$( set.mm - Version of 15-Sep-2018 $)
$( To prevent GitHub merge conflicts, please change the above date only if
there are no other pull requests in the queue.  Travis has been modified to use
"verify markup * /date_skip" to prevent a non-updated date from causing an
error.  I will maintain the date when necessary.  --NM $)

$( Important recent changes:  On 28-Jul-2017 and 18-Aug-2017, specialization
related theorems *cla4* and *a4* (no cl) were renamed *spc* and *sp*
respectively.  On 27-Apr-2017, copab2 was renamed coprab (122 places).
Starting 17-Aug-2018, redundant "A e. V" antecedents are being removed from
sbc* and csb* theorems and their consequences.  --NM

See 'help verify markup' in metamath.exe for markup conventions. $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
            Metamath source file for logic and set theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

                           ~~ PUBLIC DOMAIN ~~
This work is waived of all rights, including copyright, according to the CC0
Public Domain Dedication.  http://creativecommons.org/publicdomain/zero/1.0/

Principal curator:  Norman Megill   http://us.metamath.org/email.html

Contributor list:

DA  David Abernethy      JH  Jeff Hoffman          MM  Mykola Mostovenko
SA  Stefan Allan         SJ  Szymon Jaroszewicz    SO  Stefan O'Rear
TA  Thierry Arnoux       BJ  Benoit Jubin          JO  Jason Orendorff
JA  Juha Arpiainen       JK  Jim Kingdon           JP  Josh Purinton
JB  Jonathan Ben-Naim    WL  Wolf Lammen           SR  Steve Rodriguez
GB  Gregory Bush         GL  Gerard Lang           ATS Andrew Salmon
MC  Mario Carneiro       BL  Brendan Leahy         AS  Alan Sare
PC  Paul Chapman         RL  Raph Levien           ES  Eric Schmidt
DF  Drahflow             FL  Frederic Line         GS  Glauco Siliprandi
GD  Georgy Dunaev        RFL Roy F. Longton        SS  Saveliy Skresanov
SF  Scott Fenton         GM  Giovanni Mascellani   JU  Jarvin Udandy
JGH Jeffrey Hankins      JM  Jeff Madsen           AV  Alexander van der Vekens
AH  Anthony Hart         RM  Rodolfo Medina        DAW David A. Wheeler
DH  David Harvey         NM  Norman Megill         JY  Jonathan Yan
CH  Chen-Pang He         MO  Mel L. O'Cat          FZ  Fan Zheng


HTML code for accented names:
  GL G&eacute;rard Lang
  FL Fr&eacute;d&eacute;ric Lin&eacute;

$)

$( (See 'help verify markup' for help with the markup syntax.) $)
$( Begin $[ set-header.mm $] $)

$(

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Contents of this header
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

1. Recent label changes
2. Quick "How To"
3. Bibliography
4. Metamath syntax summary
5. Other notes
6. Acceptable shorter proofs

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          1. Recent label changes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

This is part of an ongoing project to improve naming consistency.  If you have
suggestions for better names, let me know.

To update your mathbox, you can make global substitutions into
your local version by processing the ones WITHOUT "Notes" in _reverse_ order.
The ones WITH "Notes" may have to be processed manually.

PROPOSED:
Date      Old       New         Notes
proposed  syl       imtri       (analogous to *bitr*, sstri, etc.)
proposed  sylib     imbitri     etc.
proposed  sylbid    biimtrd     etc.
proposed  sylbird   biimtrrd    etc.
proposed  syl5*     *trid       (syl5bi -> biimtrid; syl5eqel -> eqeltrid;etc.)
proposed  syl6*     *trdi
proposed  *mpt*     *mpf* or *mptf* (maps-to for functions)
proposed  *mpt2*    *mpo* or *mpto* (maps-to for operations)
(Please send any comments on these proposals to Norm Megill.)

DONE:
Date      Old       New         Notes

13-Sep-18 csbuni2   ---         deleted; use csbun
13-Sep-18 csbung    ---         deleted; use csbun
13-Sep-18 sbcopg    csbopg      moved from DF's mathbox to main set.mm
13-Sep-18 sbcuni    csbuni2     moved from DF's mathbox to main set.mm
13-Sep-18 sbcung    csbung      moved from DF's mathbox to main set.mm
28-Aug-18 laps      ---         deleted
28-Aug-18 lanfwcl   ---         deleted
28-Aug-18 laspwcl   ---         deleted
28-Aug-18 isla      ---         deleted
28-Aug-18 spweu     ---         deleted
28-Aug-18 spwpr4c   ---         deleted
28-Aug-18 spwpr4    ---         deleted
28-Aug-18 spwcl     ---         deleted
28-Aug-18 spwex     ---         deleted
28-Aug-18 spwval    ---         deleted
28-Aug-18 spwval2   ---         deleted
28-Aug-18 df-lar    ---         deleted
28-Aug-18 df-nfw    ---         deleted
28-Aug-18 df-spw    ---         deleted
28-Aug-18 cla       ---         deleted
28-Aug-18 cinf      ---         deleted
28-Aug-18 cspw      ---         deleted (use df-poset functions)
28-Aug-18 riotassuni ---        deleted
25-Aug-18 sbcf      sbcfg
25-Aug-18 sbcfn     sbcfng
25-Aug-18 sbcfun    sbcfung
25-Aug-18 sbcssVD   sbcssgVD
24-Aug-18 sbc3org   ---         deleted; use sbc3or
24-Aug-18 csbdmg    ---         deleted; use csbdm
24-Aug-18 sbc4rexg  ---         deleted; use sbc4rex
24-Aug-18 sbc2rexg  ---         deleted; use sbc2rex
24-Aug-18 2sbcrex   [same]      revised - removed redundant hypotheses
24-Aug-18 csbdmg    ---         deleted; use csbdm
24-Aug-18 sbc3org   ---         deleted; use sbc3or
23-Aug-18 sbcssg    [same]      renamed variables
23-Aug-18 sbcss     sbcssg
23-Aug-18 csbov12g  [same]      renamed variables
23-Aug-18 csbov2g   [same]      renamed variables
23-Aug-18 csbov1g   [same]      renamed variables
23-Aug-18 csbovg    ---         deleted; use csbov123
23-Aug-18 xp0r      0xp
23-Aug-18 fv01      0fv
23-Aug-18 csbiotag  ---         deleted; use csbiota
23-Aug-18 csbresg   ---         deleted; use csbres
23-Aug-18 csbxpg    ---         deleted; use csbxp
23-Aug-18 csbrng    ---         deleted; use csbrn
23-Aug-18 csbrn     csbren
23-Aug-18 csbcnvg   ---         deleted; use csbcnv
23-Aug-18 breqn0    brne0       moved from AV's mathbox to main set.mm
23-Aug-18 csbopabg  ---         deleted; use csbopab
22-Aug-18 csbunig   ---         deleted; use csbuni
22-Aug-18 sbcbr2g   [same]      renamed variables
22-Aug-18 sbcbr1g   [same]      renamed variables
22-Aug-18 sbcbr12g  [same]      renamed variables
22-Aug-18 sbcbrg     ---        deleted; use sbcbr123
22-Aug-18 sbcsng    ---         deleted; use ralsnsg
22-Aug-18 ralsns    ralsnsg
22-Aug-18 rexsns    [same]      revised - removed unnecessary antecent
22-Aug-18 csbcnvg   [same]      moved from AV's mathbox to main set.mm
20-Aug-18 csbima12gALT ---      deleted; use csbima12
20-Aug-18 csbima12g ---         deleted; use csbima12
20-Aug-18 csbfvg    ---         deleted; use csbfv
20-Aug-18 csbfv12gALT ---       deleted; use csbfv12
20-Aug-18 csbfv12g  ---         deleted; use csbfv12
19-Aug-18 csbifg    ---         deleted; use csbif
19-Aug-18 exan3     exsimpr     moved from RM's mathbox to main set.mm
19-Aug-18 iuneq12df [same]      moved from TA's mathbox to main set.mm
19-Aug-18 rexeqbid  [same]      moved from TA's mathbox to main set.mm
19-Aug-18 raleqbid  [same]      moved from TA's mathbox to main set.mm
19-Aug-18 csbabg    ---         deleted; use csbab
18-Aug-18 sbccsb2g  ---         deleted; use sbccsb2
18-Aug-18 sbccsbg   ---         deleted; use sbccsb
18-Aug-18 csbidmg   ---         deleted; use csbidm
18-Aug-18 csbing    ---         deleted; use csbin
18-Aug-18 csbcomg   ---         deleted; use csbcom
18-Aug-18 sbcel2g   ---         deleted; use sbcel2
18-Aug-18 sbcne12g  ---         deleted; use sbcne12
18-Aug-18 sbcel12g  ---         deleted; use sbcel12
18-Aug-18 sbcreug   ---         deleted; use sbcreu
18-Aug-18 sbcrexg   ---         deleted; use sbcrex
18-Aug-18 sbcrext   [same]      revised - removed unnecessary antecedent
17-Aug-18 sbcimdv   [same]      revised - removed unnecessary antecedent
17-Aug-18 sbc3ang   ---         deleted; use sbc3an
17-Aug-18 sbcel1gv  ---         deleted; use sbcel1v
17-Aug-18 eqsbc3r   [same]      renamed variables
17-Aug-18 sbcexg    ---         deleted; use sbcex
17-Aug-18 sbcalg    ---         deleted; use sbcal
17-Aug-18 csbex     [same]      revised - removed unnecessary hypothesis
17-Aug-18 csbexg    [same]      revised - removed unnecessary antecedent
17-Aug-18 sbcorg    ---         deleted; use sbcor
17-Aug-18 sbcang    ---         deleted; use sbcan
 5-Aug-18 undifv    unvdif
30-Jun-18 sbceq1dd  [same]      revised
30-Jun-18 sbceq1d   [same]      revised
 9-Jun-18 elnn0fz0  nn0fz0      moved from SF's mathbox to main set.mm
12-May-18 intn3an1d [same]      moved from FL's mathbox to main set.mm
12-May-18 intn3an2d [same]      moved from FL's mathbox to main set.mm
12-May-18 intn3an3d [same]      moved from FL's mathbox to main set.mm
12-May-18 negcmpprcal1 nrexralim moved from FL's mathbox to main set.mm
12-May-18 islp3     [same]      moved from FL's mathbox to main set.mm
12-May-18 isunscov  infssuni    moved from FL's mathbox to main set.mm
12-May-18 bwt2      bwth        moved from FL's mathbox to main set.mm
22-Apr-18 ax10lem3  ax10o2
 8-Apr-18 elfzo1    [same]      moved from TA's mathbox to main set.mm
 8-Apr-18 fzossnn   [same]      moved from TA's mathbox to main set.mm
22-Mar-18 df-spthon [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
22-Mar-18 is2wlk    [same]      moved from AV's mathbox to main set.mm
22-Mar-18 2wlklem   [same]      moved from AV's mathbox to main set.mm
22-Mar-18 fz0tp     [same]      moved from AV's mathbox to main set.mm
22-Mar-18 tpssi     [same]      moved from AV's mathbox to main set.mm
22-Mar-18 fzo12sn   [same]      moved from AV's mathbox to main set.mm
22-Mar-18 usgranloopv [same]    moved from AV's mathbox to main set.mm
22-Mar-18 fvfundmfvn0 [same]    moved from AV's mathbox to main set.mm
22-Mar-18 f1o2ndf1  [same]      moved from AV's mathbox to main set.mm
22-Mar-18 fo2ndf    [same]      moved from AV's mathbox to main set.mm
22-Mar-18 f2ndf     [same]      moved from AV's mathbox to main set.mm
22-Mar-18 dfiunv2   [same]      moved from FL's mathbox to main set.mm
 6-Mar-18 ax10lem3  aevlem1
 6-Mar-18 ax10lem4  ax10lem3
17-Feb-18 ax10lem6  ax10lem4
17-Feb-18 ax10lem5  ax10lem3
17-Feb-18 ax10lem4  ax10lem2
17-Feb-18 ax10lem3  ---         deleted; use ax10
17-Feb-18 ax10lem2  ---         deleted; use ax10
23-Jan-18 ftp       [same]      moved from SO's mathbox to main set.mm
23-Jan-18 df-conngra [same]     moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-pthon  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-trlon  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-wlkon  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-cycl   [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-crct   [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-spth   [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-pth    [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-trail  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
23-Jan-18 df-wlk    [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
21-Jan-18 df-eupa   [same]      moved (together with corresponding theorems)
                                from MC's mathbox to main set.mm
21-Jan-18 df-vdgr   [same]      revised and moved (together with corresponding
                                theorems) from MC's mathbox to main set.mm
21-Jan-18 df-uvtx   [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
21-Jan-18 df-cusgra [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
21-Jan-18 df-nbgra  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
20-Jan-18 df-usgra  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
20-Jan-18 df-uslgra [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
20-Jan-18 df-umgra  [same]      moved (together with corresponding theorems)
                                from MC's mathbox to main set.mm
20-Jan-18 df-uhgra  [same]      moved (together with corresponding theorems)
                                from AV's mathbox to main set.mm
20-Jan-18 s4dom     [same]      moved from AV's mathbox to main set.mm
20-Jan-18 s4f1o     [same]      moved from AV's mathbox to main set.mm
20-Jan-18 f1oun2prg [same]      moved from AV's mathbox to main set.mm
20-Jan-18 s2f1o     [same]      moved from AV's mathbox to main set.mm
20-Jan-18 s4prop    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 s2prop    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 brfi1ind  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 brfi1uzind [same]     moved from AV's mathbox to main set.mm
20-Jan-18 brfi1indlem [same]    moved from AV's mathbox to main set.mm
20-Jan-18 hashtpg   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hash2prb  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hash2prde [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hash2pr   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashgt12el2 [same]    moved from AV's mathbox to main set.mm
20-Jan-18 hashgt12el [same]     moved from AV's mathbox to main set.mm
20-Jan-18 hash1snb  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashdifsn [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashgt0elexb [same]   moved from AV's mathbox to main set.mm
20-Jan-18 hashgt0elex [same]    moved from AV's mathbox to main set.mm
20-Jan-18 hashle00  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashprb   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 elprchashprn2 [same]  moved from AV's mathbox to main set.mm
20-Jan-18 hashnn0n0nn [same]    moved from AV's mathbox to main set.mm
20-Jan-18 hashunx   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashinfxadd [same]    moved from AV's mathbox to main set.mm
20-Jan-18 hashrabrsn[same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashnfinnn0 [same]    moved from AV's mathbox to main set.mm
20-Jan-18 hashvnfin [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashf1rn  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hasheqf1oi [same]     moved from AV's mathbox to main set.mm
20-Jan-18 fiinfnf1o [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hasheqf1o [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashv01gt1 [same]     moved from AV's mathbox to main set.mm
20-Jan-18 hashnemnf [same]      moved from AV's mathbox to main set.mm
20-Jan-18 hashnnn0genn0 [same]  moved from AV's mathbox to main set.mm
20-Jan-18 hashnn0pnf[same]      moved from AV's mathbox to main set.mm
20-Jan-18 bcn2p1    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 bcn2m1    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 bc0k      [same]      moved from AV's mathbox to main set.mm
20-Jan-18 injresinj [same]      moved from AV's mathbox to main set.mm
20-Jan-18 injresinjlem [same]   moved from AV's mathbox to main set.mm
20-Jan-18 elfznelfzob [same]    moved from AV's mathbox to main set.mm
20-Jan-18 elfznelfzo [same]     moved from AV's mathbox to main set.mm
20-Jan-18 fzo0to42pr [same]     moved from AV's mathbox to main set.mm
20-Jan-18 fzo0to3tp [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fzo0to2pr [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fzossrbm1 [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fzon      [same]      moved from AV's mathbox to main set.mm
20-Jan-18 4fvwrd4   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 1fv       [same]      moved from AV's mathbox to main set.mm
20-Jan-18 xadd4d    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 nn0pnfge0 [same]      moved from AV's mathbox to main set.mm
20-Jan-18 nn0n0n1ge2b [same]    moved from AV's mathbox to main set.mm
20-Jan-18 nn0n0n1ge2 [same]     moved from AV's mathbox to main set.mm
20-Jan-18 nfielex   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 finresfin [same]      moved from AV's mathbox to main set.mm
20-Jan-18 isprmpt2  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 sprmpt2   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 brovmpt2ex [same]     moved from AV's mathbox to main set.mm
20-Jan-18 brovex    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 mpt2ndm0  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopoveqd [same]   moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopovel [same]    moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopoveq [same]    moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopynvov0 [same]  moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopxprcov0 [same] moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopx0ov0 [same]   moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopxnop0 [same]   moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopynvov0g [same] moved from AV's mathbox to main set.mm
20-Jan-18 mpt2xopn0yelv [same]  moved from AV's mathbox to main set.mm
20-Jan-18 bropopvvv [same]      moved from AV's mathbox to main set.mm
20-Jan-18 nssdmovg  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 brabv     [same]      moved from AV's mathbox to main set.mm
20-Jan-18 0neqopab  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 opabbrex  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 f1ocnvfvrneq [same]   moved from AV's mathbox to main set.mm
20-Jan-18 f1veqaeq  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fvtp3g    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fvtp2g    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fvtp1g    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fvpr2g    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fvpr1g    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 ftpg      [same]      moved from AV's mathbox to main set.mm
20-Jan-18 eldmrexrnb [same]     moved from AV's mathbox to main set.mm
20-Jan-18 eldmrexrn [same]      moved from AV's mathbox to main set.mm
20-Jan-18 elrnrexdmb [same]     moved from AV's mathbox to main set.mm
20-Jan-18 elrnrexdm [same]      moved from AV's mathbox to main set.mm
20-Jan-18 f1oprg    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 fntpg     [same]      moved from AV's mathbox to main set.mm
20-Jan-18 funtpg    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 prnebg    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 prneimg   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 tppreqb   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 tpprceq3  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 tppreq3   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 rabrsn    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 disjpr2   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 exsnrex   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 difrab0eq [same]      moved from AV's mathbox to main set.mm
20-Jan-18 raldifb   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 ssrabeq   [same]      moved from AV's mathbox to main set.mm
20-Jan-18 elrabi    [same]      moved from AV's mathbox to main set.mm
20-Jan-18 nnel      [same]      moved from AV's mathbox to main set.mm
20-Jan-18 3biant1d  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 3bior2fd  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 3bior1fand [same]     moved from AV's mathbox to main set.mm
20-Jan-18 3bior1fd  [same]      moved from AV's mathbox to main set.mm
20-Jan-18 jaoi2     [same]      moved from AV's mathbox to main set.mm
18-Jan-18 prsspwg   [same]      changed _V in antecedents to variables
18-Jan-18 prsspwg   [same]      moved from TA's mathbox to main set.mm
18-Jan-18 pwundif2  ---         deleted from TA's mathbox; same as pwundif
18-Jan-18 prelpwi   [same]      moved from TA's mathbox to main set.mm
18-Jan-18 hashge1   [same]      moved from TA's mathbox to main set.mm
18-Jan-18 hashgt0   [same]      moved from TA's mathbox to main set.mm
18-Jan-18 hashge0   [same]      moved from TA's mathbox to main set.mm
30-Dec-17 rabfi     [same]      moved from TA's mathbox to main set.mm
30-Dec-17 infi      [same]      moved from TA's mathbox to main set.mm
26-Dec-17 addccncf  [same]      moved from JM's mathbox to main set.mm
16-Dec-17 opabex3d  [same]      moved from AV's mathbox to main set.mm
10-Dec-17 fnpr      [same]      changed hypotheses to "e. _V" instead of "e. V"
10-Dec-17 3m1e2     [same]      swapped equality arguments
10-Dec-17 repfuntw  fnpr        moved from FL's mathbox to main set.mm
10-Dec-17 uninqs    uniinqs     moved from FL's mathbox to main set.mm
10-Dec-17 rngoridfz [same]      moved from FL's mathbox to main set.mm
10-Dec-17 zerdivemp1 [same]     moved from FL's mathbox to main set.mm
10-Dec-17 neleq12d  [same]      moved from FL's mathbox to main set.mm
10-Dec-17 feq123    [same]      moved from FL's mathbox to main set.mm
10-Dec-17 fprg      [same]      moved from FL's mathbox to main set.mm
10-Dec-17 2eq3m1    3m1e2       moved from FL's mathbox to main set.mm
10-Dec-17 trcrm     truan       moved from FL's mathbox to main set.mm
 8-Dec-17 ---       ---         changed math symbol from "cprod_" to "prod_"
 8-Dec-17 ---       ---         changed math symbol from "prod_" to "gprod_"
 1-Dec-17 diftpsneq diftpsn3    moved from AV's mathbox to main set.mm
 1-Dec-17 difprsng  ---         (in AV's mathbox) deleted; use difprsn1
 1-Dec-17 difprsneq difprsn2    moved from AV's mathbox to main set.mm
 1-Dec-17 difprsn2  difprsn1    moved from TA's mathbox to main set.mm
 1-Dec-17 difprsn   difprsnss
 1-Dec-17 difsneq   difsnb
 7-Oct-17 fv4       df-fv
 7-Oct-17 df-fv     dffv4
 6-Oct-17 cnveq3    cnveq0      moved from FL's mathbox to main set.mm
22-Sep-17 wunexALT  wunex3
22-Sep-17 pwuninelALT pwuninel2
20-Sep-17 dveeq1ALT dveeq1-o16
20-Sep-17 dveeq2ALT dveeq2-o16
20-Sep-17 dvelimfALT2 ---       deleted; use dvelimh
20-Sep-17 dvelimfALT2 dvelimhw
17-Sep-17 hbaes     ---         deleted; use hbae + syl (ae = all equals)
17-Sep-17 alequcom  aecom
17-Sep-17 alequcoms aecoms
17-Sep-17 nalequcoms naecoms
17-Sep-17 alequcom-o aecom-o
17-Sep-17 alequcoms-o aecoms-o
17-Sep-17 nalequcoms-o naecoms-o
26-Aug-17 cmpfun    funmpt2     moved from FL's mathbox to main set.mm
26-Aug-17 xrre3     [--same--]  moved from FL's mathbox to main set.mm
21-Aug-17 nd5       ---         deleted; use dveeq2
19-Aug-17 ax4       sp
16-Aug-17 ax10lem8  ax10lem5
16-Aug-17 ax10lem7  ax10lem4
16-Aug-17 ax10lem4  ax10lem6
16-Aug-17 ax10lem6  ---         deleted; use dveeq2
16-Aug-17 ax10lem5  dvelimv
16-Aug-17 dvelimv   dvelimnf
 5-Aug-17 ax12dgen4w ax12dgen4
 5-Aug-17 ax12dgen3w ax12dgen3
 5-Aug-17 ax12dgen2w ax12dgen2
 5-Aug-17 ax12dgen1w ax12dgen1
 5-Aug-17 ax11dgenw ax11dgen
 5-Aug-17 ax7dgenw  ax7dgen
 5-Aug-17 ax9dgenw  ax9dgen
 5-Aug-17 ax11demow ax11wdemo
 5-Aug-17 ax11wlemw ax11wlem
 3-Aug-17 hbalwK    hbalw
 3-Aug-17 hbe1wK    hbe1w
 3-Aug-17 hba1wK    hba1w
 3-Aug-17 ax11wdemoK ax11demow
 3-Aug-17 ax11dgenK ax11dgenw
 3-Aug-17 ax11wK    ax11w
 3-Aug-17 ax11wlemK ax11wlemw
 3-Aug-17 ax12dgen4K ax12dgen4w
 3-Aug-17 ax12dgen3K ax12dgen3w
 3-Aug-17 ax12dgen2K ax12dgen2w
 3-Aug-17 ax12dgen1K ax12dgen1w
 3-Aug-17 ax12wK    ax12w
 3-Aug-17 ax7dgenK  ax7dgenw
 3-Aug-17 ax7wK     ax7w
 3-Aug-17 ax6wK     ax6w
 3-Aug-17 ax6wfK    ax6fw
 3-Aug-17 ax9dgenK  ax9dgenw
 3-Aug-17 cbvexvK   cbvexvw
 3-Aug-17 cbvalvK   cbvalvw
 3-Aug-17 cbvalK    cbvalw
 3-Aug-17 spfalK    spfalw
 3-Aug-17 sptruK    sptruw
 3-Aug-17 spvK      spvw
 3-Aug-17 spwK      spw
 3-Aug-17 19.8wK    19.8w
 3-Aug-17 spnwfK    spnfw
 3-Aug-17 spwfK     spfw
 3-Aug-17 cbvalivK  cbvalivw
 3-Aug-17 cbvaliK   cbvaliw
 3-Aug-17 spimvK    spimvw
 3-Aug-17 spimK     spimw
 3-Aug-17 spimfK    spimfw
 3-Aug-17 speimfK   speimfw
 2-Aug-17 ax-9v     ax9v        now a theorem instead of an axiom
 1-Aug-17 dvelimfALT2 [--same--] revised hypotheses
 1-Aug-17 equcomi-o ---         deleted; use equcomi instead
 1-Aug-17 cbv3ALT   cbv3h
 1-Aug-17 19.2      19.2g
 1-Aug-17 equidxx   equid
 1-Aug-17 equid     equid1
 1-Aug-17 equid1    equidxx
28-Jul-17 a4i       spi
28-Jul-17 a4s       sps
28-Jul-17 a4sd      spsd
28-Jul-17 a4imt     spimt
28-Jul-17 a4im      spim
28-Jul-17 a4ime     spime
28-Jul-17 a4imed    spimed
28-Jul-17 a4imv     spimv
28-Jul-17 a4sbe     spsbe
28-Jul-17 a4sbim    spsbim
28-Jul-17 a4sbbi    spsbbi
28-Jul-17 a4v       spv
28-Jul-17 a4imev    spimev
28-Jul-17 a4eiv     speiv
28-Jul-17 ra4       rsp
28-Jul-17 ra4e      rspe
28-Jul-17 ra42      rsp2
28-Jul-17 ra42e     rsp2e
28-Jul-17 cla4imgft spcimgft
28-Jul-17 cla4gft   spcgft
28-Jul-17 cla4imgf  spcimgf
28-Jul-17 cla4imegf spcimegf
28-Jul-17 cla4gf    spcgf
28-Jul-17 cla4egf   spcegf
28-Jul-17 cla4imdv  spcimdv
28-Jul-17 cla4dv    spcdv
28-Jul-17 cla4imedv spcimedv
28-Jul-17 cla4gv    spcgv
28-Jul-17 cla4egv   spcegv
28-Jul-17 cla42egv  spc2egv
28-Jul-17 cla42gv   spc2gv
28-Jul-17 cla43egv  spc3egv
28-Jul-17 cla43gv   spc3gv
28-Jul-17 cla4v     spcv
28-Jul-17 cla4ev    spcev
28-Jul-17 cla42ev   spc2ev
28-Jul-17 rcla4t    rspct
28-Jul-17 rcla4     rspc
28-Jul-17 rcla4e    rspce
28-Jul-17 rcla4v    rspcv
28-Jul-17 rcla4cv   rspccv
28-Jul-17 rcla4va   rspcva
28-Jul-17 rcla4cva  rspccva
28-Jul-17 rcla4ev   rspcev
28-Jul-17 rcla4imdv rspcimdv
28-Jul-17 rcla4imedv rspcimedv
28-Jul-17 rcla4dv   rspcdv
28-Jul-17 rcla4edv  rspcedv
28-Jul-17 rcla42    rspc2
28-Jul-17 rcla42v   rspc2v
28-Jul-17 rcla42va  rspc2va
28-Jul-17 rcla42ev  rspc2ev
28-Jul-17 rcla43v   rspc3v
28-Jul-17 rcla43ev  rspc3ev
28-Jul-17 a4sbc     spsbc
28-Jul-17 a4sbcd    spsbcd
28-Jul-17 ra4sbc    rspsbc
28-Jul-17 ra4sbca   rspsbca
28-Jul-17 ra4esbca  rspesbca
28-Jul-17 a4esbc    spesbc
28-Jul-17 a4esbcd   spesbcd
28-Jul-17 ra4csbela rspcsbela
28-Jul-17 rcla4eov  rspceov
28-Jul-17 rcla42edv rspc2edv
28-Jul-17 isibg1a4a isibg1spa
28-Jul-17 a4sbce-2  spsbce-2
28-Jul-17 rcla4egf  rspcegf
28-Jul-17 ra4sbc2   rspsbc2
28-Jul-17 ra4sbc2VD rspsbc2VD
23-Jul-17 df-n      df-nn
23-Jul-17 sbcss     [--same--]  moved from AS's mathbox to main set.mm
22-Jul-17 dfprime2  dfprm2
22-Jul-17 df-divides df-dvds
22-Jul-17 divides2  dvdsval2
22-Jul-17 divides3  dvdsval3
22-Jul-17 nndivdivides nndivdvds
22-Jul-17 df-prime  df-prm
19-Jul-17 df-ring   df-rng
19-Jul-17 df-plus   df-add
29-Jun-17 2m1e1     [--same--]  moved from DAW's mathbox to main set.mm
24-Jun-17 imrmo     rmoim
24-Jun-17 immoi     moimi
24-Jun-17 immo      moim
24-Jun-17 moimv     morimv
17-Jun-17 2ndcdisj2 [--same--]  revised to use df-rmo
17-Jun-17 2ndcdisj  [--same--]  revised to use df-rmo
17-Jun-17 mgmidmo   [--same--]  revised to use df-rmo
17-Jun-17 lspextmo  [--same--]  revised to use df-rmo
17-Jun-17 ply1divmo [--same--]  revised to use df-rmo
17-Jun-17 sqrmo     [--same--]  revised to use df-rmo
17-Jun-17 cvmliftmo [--same--]  revised to use df-rmo
17-Jun-17 hilbert1.2 [--same--] revised to use df-rmo
17-Jun-17 idomsubgmo [--same--] revised to use df-rmo
16-Jun-17 spwmo     [--same--]  revised to use df-rmo
16-Jun-17 poslubmo  [--same--]  revised to use df-rmo
16-Jun-17 brdom7disj [--same--] revised to use df-rmo
16-Jun-17 brdom4    [--same--]  revised to use df-rmo
16-Jun-17 iunmapdisj [--same--] revised to use df-rmo
16-Jun-17 moriotass [--same--]  revised to use df-rmo
16-Jun-17 supmo     [--same--]  revised to use df-rmo
16-Jun-17 dffun9    [--same--]  revised to use df-rmo
16-Jun-17 reuxfr2   [--same--]  revised to use df-rmo
16-Jun-17 reuxfr2d  [--same--]  revised to use df-rmo
16-Jun-17 somo      [--same--]  revised to use df-rmo
16-Jun-17 df-disj   [--same--]  revised to use df-rmo
16-Jun-17 rmoi      [--same--]  revised to use df-rmo
16-Jun-17 rmob      [--same--]  revised to use df-rmo
16-Jun-17 rmo3      [--same--]  revised to use df-rmo
16-Jun-17 2reuswap  [--same--]  revised to use df-rmo
16-Jun-17 rmo4      [--same--]  revised to use df-rmo
16-Jun-17 reu5      [--same--]  revised to use df-rmo
18-May-17 fsnunfv   [--same--]  revised
28-Apr-17 copab2    coprab
 7-Jan-17 df-sbc    [--same--]  df-sbc and 521 uses modified (statement and/or
                                  proof) to use separate notation from df-sb.
31-Dec-16 elabsbc   ---         deleted; use df-sbc instead
31-Dec-16 elabsg    ---         deleted; use df-sbc instead
31-Dec-16 elabs2    ---         deleted; use df-sbc instead
26-Dec-16 faclt2exp 2expltfac
24-Dec-16 reuunineg riotaneg    revised
24-Dec-16 supsn     [--same--]  revised
24-Dec-16 suppr     [--same--]  revised
24-Dec-16 supeut    ---         deleted; see supeu
24-Dec-16 supmax    [--same--]  revised
24-Dec-16 supnubi   ---         deleted; see supnub
24-Dec-16 suplubi   ---         deleted; see suplub
24-Dec-16 supubi    ---         deleted; see supub
24-Dec-16 supcli    ---         deleted; see supcl
24-Dec-16 supeui    ---         deleted; see supeu
24-Dec-16 supnub    [--same--]  revised
24-Dec-16 suplub2   [--same--]  revised
24-Dec-16 suplub    [--same--]  revised
24-Dec-16 supub     [--same--]  revised
24-Dec-16 supcl     [--same--]  revised
24-Dec-16 eqsup     [--same--]  revised
24-Dec-16 supeu     [--same--]  revised
24-Dec-16 supmo     [--same--]  revised
24-Dec-16 reiotass2 riotass2    revised
24-Dec-16 reiota2   riota2      revised
24-Dec-16 reiota2f  riota2f     revised
24-Dec-16 reiota2df riota2df    revised
24-Dec-16 reiota1   riota1      revised
24-Dec-16 reiotasbc riotasbc    revised
24-Dec-16 reiotacl  riotacl     revised
24-Dec-16 iota2df   [--same--]  revised
24-Dec-16 reiotacl2 riotacl2    revised
24-Dec-16 f1ocnvfv3 [--same--]  revised
24-Dec-16 reuunixfr riotaxfrd   revised
24-Dec-16 eusvobj1  [--same--]  revised
24-Dec-16 reuunisn  snriota     revised
24-Dec-16 reusni    rabsneu     revised
24-Dec-16 reuuniss2 riotass2    revised
24-Dec-16 mouniss   moriotass   revised
24-Dec-16 reuuniss  riotass     revised
24-Dec-16 reuuni3   ---         deleted; see riotauni, riotasbc, sbcie2g
24-Dec-16 reuunisbc riotasbc    revised
24-Dec-16 reucl     riotacl     revised
24-Dec-16 reucl2    riotacl2    revised
24-Dec-16 euuni2    iota2       revised
24-Dec-16 reuuni2   riota2      revised
24-Dec-16 reuuni2f  riota2f     revised
24-Dec-16 reuuni1   riota1a     revised
24-Dec-16 euuni     iotauni     revised
24-Dec-16 iotaequ   iotauni
24-Dec-16 iota2     iotaequ
20-Dec-16 ---       ---         Renames below prevent ax-XXX vs. axXXX conflict
20-Dec-16 axreg     axreg2
20-Dec-16 axac      axac3
20-Dec-16 axhilex   axhilex-zf
20-Dec-16 axhfvadd  axhfvadd-zf
20-Dec-16 axhvcom   axhvcom-zf
20-Dec-16 axhvass   axhvass-zf
20-Dec-16 axhv0cl   axhv0cl-zf
20-Dec-16 axhvaddid axhvaddid-zf
20-Dec-16 axhfvmul  axhfvmul-zf
20-Dec-16 axhvmulid axhvmulid-zf
20-Dec-16 axhvmulass axhvmulass-zf
20-Dec-16 axhvdistr1 axhvdistr1-zf
20-Dec-16 axhvdistr2 axhvdistr2-zf
20-Dec-16 axhvmul0  axhvmul0-zf
20-Dec-16 axhfi     axhfi-zf
20-Dec-16 axhis1    axhis1-zf
20-Dec-16 axhis2    axhis2-zf
20-Dec-16 axhis3    axhis3-zf
20-Dec-16 axhis4    axhis4-zf
20-Dec-16 axhcompl  axhcompl-zf
20-Dec-16 axlll     axlll2      (in FL's mathbox)
 4-Dec-16 hbmpt2    [same]      removed unnecessary $d restriction
17-Sep-16 ssdifeq0  [same]      moved from SR's mathbox to main set.mm
 4-Sep-16 bnj232    anim12ci    moved from JB's mathbox to main set.mm
 4-Sep-16 bnj186    anbi12ci    moved from JB's mathbox to main set.mm
 4-Sep-16 bnj1540   neneqd      moved from JB's mathbox to main set.mm
 4-Sep-16 bnj169    3anan32     moved from JB's mathbox to main set.mm
 4-Sep-16 bnj176    3anan12     moved from JB's mathbox to main set.mm
 4-Sep-16 bnj1295   ssind       moved from JB's mathbox to main set.mm
 4-Sep-16 bnj184    anbi2ci     moved from JB's mathbox to main set.mm
 4-Sep-16 bnj2      con3and     moved from JB's mathbox to main set.mm
 4-Sep-16 c-bnj16   ---         deleted
 4-Sep-16 bnj536    ---         deleted; also deleted 744 other unused bnj*
28-May-16 recld     recld2
28-May-16 expmwordi leexp1a
28-May-16 expword2i leexp2r
28-May-16 expord2   ltexp2r
28-May-16 expwordi  leexp2a
28-May-16 expword   leexp2
28-May-16 expord    ltexp2
28-May-16 expordi   ltexp2a
22-May-16 anim12    ---         deleted (use prth instead)
 6-Apr-16 AneBC     nelpri      moved from DAW's mathbox to main set.mm
 6-Apr-16 ixpfn     [same]      moved from FL's mathbox to main set.mm
 6-Apr-16 oveq123i  [same]      moved from FL's mathbox to main set.mm
 6-Apr-16 2on0      [same]      moved from SF's mathbox to main set.mm
 6-Apr-16 sqsubswap [same]      moved from SF's mathbox to main set.mm
 6-Apr-16 anass1rs  [same]      moved from JM's mathbox to main set.mm
 6-Apr-16 eltids    opelresi    moved from FL's mathbox to main set.mm; revised
 6-Apr-16 ref4w     issref      moved from FL's mathbox to main set.mm; revised
 5-Apr-16 relexpex  ---         (in DF's mathbox) obsolete; deleted - use ovex
 5-Apr-16 mplvscafval ---       obsolete; deleted - use mplvsca2
 5-Apr-16 ply1rcl   ---         obsolete; deleted - use elbasfv
 5-Apr-16 psr1rcl   ---         obsolete; deleted - use elbasfv
 5-Apr-16 lbicc2a   lbicc2      moved from FL's mathbox to main set.mm
 5-Apr-16 ubicc2a   ubicc2      moved from FL's mathbox to main set.mm
 5-Apr-16 anymptr   a1tru       moved from FL's mathbox to main set.mm
 5-Apr-16 fampany   falim       moved from FL's mathbox to main set.mm
 5-Apr-16 predbrg   [same]      revised - eliminated antecedent
 5-Apr-16 predbr    ---         obsolete; deleted - use elpredim
 5-Apr-16 mueq0     ---         obsolete; deleted - use isnsqf
 5-Apr-16 resiundi  ---         obsolete; deleted - use resiun2
 5-Apr-16 trsuc2    ---         obsolete; deleted - use suctr
 5-Apr-16 tru2      ---         obsolete; deleted - use tru
29-Jan-16 .le       c.le
29-Jan-16 .lt       c.lt
29-Jan-16 .pl       c.pl
29-Jan-16 .an       c.an
29-Jan-16 .or       c.or
21-Dec-15 ax12conj  ax12        revised
21-Dec-15 ax12      ---         obsolete; deleted
21-Dec-15 ax12-2    ---         obsolete; deleted
21-Dec-15 ax12-3    ---         obsolete; deleted
21-Dec-15 ax12o     [same]      revised
21-Dec-15 ax-12     [same]      revised
 2-Dec-15 ax9seplem ax9vsep
 2-Dec-15 ax9sep    ---         obsolete (moved to NM's mathbox; to be deleted)
 2-Dec-15 ax9ALT    ax9
 2-Dec-15 ax9       ax9OLD      obsolete (moved to NM's mathbox; to be deleted)
 2-Dec-15 ax9vax9   ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 dvelimfALT2 ---       obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12stdy1  ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12stdy2  ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12stdy3  ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12stdy4  ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12lem1   ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12lem2   ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12study  ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12studyALT ---       obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12study2 ---         obsolete (moved to NM's mathbox; to be deleted)
30-Nov-15 a12study3 ---         obsolete (moved to NM's mathbox; to be deleted)
29-Nov-15 ax-12     ax-12o
10-Nov-15 a9wa9     ax9vax9
10-Nov-15 ax10      [--same--]  proved from new ax-9v instead of ax-9
 2-Nov-15 hlhil     hlathil     (in NM's mathbox)
 2-Nov-15 df-ocomp  [--same--]  moved from NM's mathbox to main set.mm
 2-Nov-15 ishil     ishil2      moved from NM's mathbox to main set.mm
 2-Nov-15 iscsubsp  iscss       moved from NM's mathbox to main set.mm; revised
 2-Nov-15 csubspset cssval      moved from NM's mathbox to main set.mm; revised
 2-Nov-15 ocvval    [--same--]  moved from NM's mathbox to main set.mm; revised
 2-Nov-15 ocvfval   [--same--]  moved from NM's mathbox to main set.mm; revised
 2-Nov-15 df-hil    [--same--]  moved from NM's mathbox to main set.mm; revised
 2-Nov-15 df-csubsp df-css      moved from NM's mathbox to main set.mm; revised
 2-Nov-15 df-ocv    [--same--]  moved from NM's mathbox to main set.mm
 2-Nov-15 isphild   isphld      moved from NM's mathbox to main set.mm
 2-Nov-15 isphil    isphl       moved from NM's mathbox to main set.mm; revised
 2-Nov-15 df-prehil df-phl      moved from NM's mathbox to main set.mm; revised
 2-Nov-15 phlfn     phlstr      moved from NM's mathbox to main set.mm
 2-Nov-15 phllem    ---         (in NM's mathbox) deleted; see phlfn
 2-Nov-15 ipid      [--same--]  moved from NM's mathbox to main set.mm
 2-Nov-15 df-inprod df-ip       moved from NM's mathbox to main set.mm
 2-Nov-15 issrngd   [--same--]  moved from NM's mathbox to main set.mm
 2-Nov-15 issrng    [--same--]  moved from NM's mathbox to main set.mm; revised
 2-Nov-15 df-starrng df-srng    moved from NM's mathbox to main set.mm; revised
 2-Nov-15 srngfn    [--same--]  moved from NM's mathbox to main set.mm; revised
 2-Nov-15 srnglem   ---         (in NM's mathbox) deleted; see srngfn
 2-Nov-15 starvid   [--same--]  moved from NM's mathbox to main set.mm
 2-Nov-15 df-starv  [--same--]  moved from NM's mathbox to main set.mm
 2-Nov-15 ldualsmul [--same--]  (in NM's mathbox) hypothesis eliminated
 2-Nov-15 lsatset   [--same--]  (in NM's mathbox) revised
 2-Nov-15 df-lsatoms [--same--] (in NM's mathbox) revised
 2-Nov-15 df-mulvval [--same--] (in ATS's mathbox) revised
 2-Nov-15 df-subrval [--same--] (in ATS's mathbox) revised
 2-Nov-15 df-addrval [--same--] (in ATS's mathbox) revised
 2-Nov-15 df-mulv   [--same--]  (in ATS's mathbox) revised
 2-Nov-15 df-subr   [--same--]  (in ATS's mathbox) revised
 2-Nov-15 df-addr   [--same--]  (in ATS's mathbox) revised
 2-Nov-15 fveqsb    [--same--]  (in ATS's mathbox) hypothesis eliminated
 2-Nov-15 fvsb      [--same--]  (in ATS's mathbox) hypothesis eliminated
 2-Nov-15 hausgraph [--same--]  (in SO's mathbox) hypothesis eliminated
 2-Nov-15 prdminvgd2 prdsinvgd2 (in SO's mathbox) revised
 2-Nov-15 dfac21i   dfac21      (in SO's mathbox) revised
 2-Nov-15 nndivdivides [--same--] moved from SO's mathbox to main set.mm
 2-Nov-15 df-dioph  [--same--]  (in SO's mathbox) revised
 2-Nov-15 mzpcl34   [--same--]  (in SO's mathbox) hypothesis eliminated
 2-Nov-15 mzpcl2    [--same--]  (in SO's mathbox) hypothesis eliminated
 2-Nov-15 mzpcl1    [--same--]  (in SO's mathbox) hypothesis eliminated
 2-Nov-15 elmzpcl   [--same--]  (in SO's mathbox) hypothesis eliminated
 2-Nov-15 mzpclval  [--same--]  (in SO's mathbox) revised
 2-Nov-15 df-mzpcl  [--same--]  (in SO's mathbox) revised
 2-Nov-15 fcompt    [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 ---       ---         isipodrs ~ lidlacs moved from SO's mathbox to
                                main set.mm
 2-Nov-15 iscldtop  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 cldmreon  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 toponmre  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 mretopd   [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 istopon   [--same--]  moved from SO's mathbox to main set.mm; revised
 2-Nov-15 df-topon  [--same--]  moved from SO's mathbox to main set.mm; revised
 2-Nov-15 ptcldmpt  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 ptcld     [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 ptunimpt  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 cldopn2   cldopn      moved from SO's mathbox to main set.mm; revised
 2-Nov-15 cldss3    cldss       moved from SO's mathbox to main set.mm; revised
 2-Nov-15 cldrcl    [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 ptopn2    [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 riinint   [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 boxcutc   [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 boxriin   [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 baspartn  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 fncld     [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 reslmhm2b [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 reslmhm2  [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 islmhmd   [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 lmodvsinv [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 fissuni   [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 fmptsn    [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 intsng    [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 rexss     [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 ralss     [--same--]  moved from SO's mathbox to main set.mm
 2-Nov-15 elfpw     [--same--]  moved from SO's mathbox to main set.mm; revised
 2-Nov-15 prter3    [--same--]  (in RM's mathbox) revised
 2-Nov-15 prter2    [--same--]  (in RM's mathbox) revised
 2-Nov-15 prtex     [--same--]  (in RM's mathbox) revised
 2-Nov-15 prter1    [--same--]  (in RM's mathbox) revised
 2-Nov-15 erex2     erexb       moved from RM's mathbox to main set.mm; revised
 2-Nov-15 erex      [--same--]  moved from RM's mathbox to main set.mm; revised
 2-Nov-15 erreft2   ---         (in RM's mathbox) deleted; see erref,erdm
 2-Nov-15 erreft    ---         (in RM's mathbox) deleted; see erref,erdm,errn
 2-Nov-15 ersymb2   ---         (in RM's mathbox) deleted; see ersymb
 2-Nov-15 ertr2     ---         (in RM's mathbox) deleted; see ertr
 2-Nov-15 ersym2    ---         (in RM's mathbox) deleted; see ersym
 2-Nov-15 df-maxidl [--same--]  (in JM's mathbox) revised
 2-Nov-15 df-pridl  [--same--]  (in JM's mathbox) revised
 2-Nov-15 df-idl    [--same--]  (in JM's mathbox) revised
 2-Nov-15 rngoisoval [--same--] (in JM's mathbox) revised
 2-Nov-15 df-rngoiso [--same--] (in JM's mathbox) revised
 2-Nov-15 rngohomval [--same--] (in JM's mathbox) revised
 2-Nov-15 df-rngohom [--same--] (in JM's mathbox) revised
 2-Nov-15 reheibor  [--same--]  (in JM's mathbox) revised
 2-Nov-15 ismrer1   [--same--]  (in JM's mathbox) revised
 2-Nov-15 rrnheibor [--same--]  (in JM's mathbox) revised
 2-Nov-15 rrntotbnd [--same--]  (in JM's mathbox) revised
 2-Nov-15 rrncms    [--same--]  (in JM's mathbox) revised
 2-Nov-15 rrndstprj2 [--same--] (in JM's mathbox) revised
 2-Nov-15 rrndstprj1 [--same--] (in JM's mathbox) revised
 2-Nov-15 rrnmet    [--same--]  (in JM's mathbox) revised
 2-Nov-15 rrndm     ---         (in JM's mathbox) deleted; see rrnmet
 2-Nov-15 rrnmval   [--same--]  (in JM's mathbox) revised
 2-Nov-15 rrnval    [--same--]  (in JM's mathbox) revised
 2-Nov-15 df-rrn    [--same--]  (in JM's mathbox) revised
 2-Nov-15 recms     recmet      moved from JM's mathbox to main set.mm
 2-Nov-15 ismtyhmeo [--same--]  (in JM's mathbox) revised
 2-Nov-15 df-ismty  [--same--]  (in JM's mathbox) revised
 2-Nov-15 isbnd3    isbnd2      (in JM's mathbox)
 2-Nov-15 isbnd2    ---         (in JM's mathbox) deleted; see isbnd
 2-Nov-15 isbnd     [--same--]  (in JM's mathbox) revised
 2-Nov-15 df-bnd    [--same--]  (in JM's mathbox) revised
 2-Nov-15 totbndss  [--same--]  (in JM's mathbox) hypothesis eliminated
 2-Nov-15 istotbnd  [--same--]  (in JM's mathbox) revised
 2-Nov-15 df-totbnd [--same--]  (in JM's mathbox) revised
 2-Nov-15 hmeocld   [--same--]  moved from JM's mathbox to main set.mm; revised
 2-Nov-15 hmeoopn   [--same--]  moved from JM's mathbox to main set.mm; revised
 2-Nov-15 cncfres   [--same--]  (in JM's mathbox) revised
 2-Nov-15 sub2cncf  [--same--]  (in JM's mathbox) revised
 2-Nov-15 sub1cncf  [--same--]  (in JM's mathbox) revised
 2-Nov-15 idcncf    [--same--]  (in JM's mathbox) revised
 2-Nov-15 addccncf  [--same--]  (in JM's mathbox) revised
 2-Nov-15 constcncf [--same--]  (in JM's mathbox) revised
 2-Nov-15 metf1o    [--same--]  (in JM's mathbox) revised
 2-Nov-15 absrdbnd  [--same--]  moved from JM's mathbox to main set.mm
 2-Nov-15 rddif     [--same--]  moved from JM's mathbox to main set.mm
 2-Nov-15 upixp     [--same--]  (in JM's mathbox) revised
 2-Nov-15 fvopabf4g [--same--]  (in JM's mathbox) revised
 2-Nov-15 supfil    [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 opnfbas   [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 metnrm    [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 nrmsep2   [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 nrmsep    [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 nrmtop    [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 isnrm2    isnrm3      moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 isnrm     isnrm3      moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 regsep    regsep2     moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 regtop    [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 isreg     isreg2      moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 t1t0      [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 t1sep     [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 t1sncld   [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 t1top     [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 ist1-3    [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 ist1-2    [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 t0dist    [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 t0top     [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 ist0-2    ist0-3      moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 ist0      [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 df-nrm    [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 df-reg    [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 df-t0ALT  df-t0       moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 fnejoin2  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 fnejoin1  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 fnemeet2  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 fnemeet1  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 topjoin   [--same--]  (in JGH's mathbox) revised
 2-Nov-15 topmeet   [--same--]  (in JGH's mathbox) revised
 2-Nov-15 topmtcl   [--same--]  (in JGH's mathbox) revised
 2-Nov-15 neibastop3 [--same--] (in JGH's mathbox) revised
 2-Nov-15 neibastop2 [--same--] (in JGH's mathbox) revised
 2-Nov-15 neibastop1 [--same--] (in JGH's mathbox) revised
 2-Nov-15 locfincf  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 locfindsc locfindis   (in JGH's mathbox) revised
 2-Nov-15 locfincomp locfincmp  (in JGH's mathbox) revised
 2-Nov-15 islocfin  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 refssfne  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 fnessref  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 topfneec  [--same--]  (in JGH's mathbox) revised
 2-Nov-15 topfne    [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 topbasfne isfne4b     (in JGH's mathbox) revised
 2-Nov-15 fneerdm   ---         (in JGH's mathbox) deleted; see fneer
 2-Nov-15 reftr     [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 fneer     [--same--]  (in JGH's mathbox) revised
 2-Nov-15 fnetr     [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 refssex   [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 refbas    [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 fneint    [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 fneuni    [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 fnessex   [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 fnebas    [--same--]  (in JGH's mathbox) hypothesis eliminated
 2-Nov-15 df-locfin [--same--]  (in JGH's mathbox) revised
 2-Nov-15 cnntr     [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 cncls     [--same--]  moved from JGH's mathbox to main set.mm;revised
 2-Nov-15 clscmp    clsdif      moved from JGH's mathbox to main set.mm
 2-Nov-15 ntrcmp    ntrdif      moved from JGH's mathbox to main set.mm
 2-Nov-15 ssdifin0  [--same--]  moved from JGH's mathbox to main set.mm
 2-Nov-15 plibgax4b [--same--]  (in FL's mathbox) revised
 2-Nov-15 plibgax4a [--same--]  (in FL's mathbox) revised
 2-Nov-15 plibgax3  [--same--]  (in FL's mathbox) revised
 2-Nov-15 plibgax2  [--same--]  (in FL's mathbox) revised
 2-Nov-15 plibgax1  [--same--]  (in FL's mathbox) revised
 2-Nov-15 isplibg   [--same--]  (in FL's mathbox) revised
 2-Nov-15 isplibg4b [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-plibg4b [--same--] (in FL's mathbox) revised
 2-Nov-15 isplibg4a [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-plibg4a [--same--] (in FL's mathbox) revised
 2-Nov-15 isplibg3  [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-plibg3 [--same--]  (in FL's mathbox) revised
 2-Nov-15 isplibg2  [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-plibg2 [--same--]  (in FL's mathbox) revised
 2-Nov-15 isplibg1  [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-plibg1 [--same--]  (in FL's mathbox) revised
 2-Nov-15 isseg1    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-seg    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-line   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-trcls  [--same--]  (in FL's mathbox) revised
 2-Nov-15 vtarsu    [--same--]  (in FL's mathbox) revised
 2-Nov-15 valtar    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-tar    [--same--]  (in FL's mathbox) revised
 2-Nov-15 issubcat  [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-subcat   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-isof   [--same--]  (in FL's mathbox) revised
 2-Nov-15 isfunb    [--same--]  (in FL's mathbox) hypothesis eliminated
 2-Nov-15 isfuna    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-funcOLD   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-cinv   [--same--]  (in FL's mathbox) revised
 2-Nov-15 isepib    [--same--]  (in FL's mathbox) hypothesis eliminated
 2-Nov-15 isepia    [--same--]  (in FL's mathbox) revised
 2-Nov-15 ismonb    [--same--]  (in FL's mathbox) hypothesis eliminated
 2-Nov-15 ismona    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-isoc   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-epiOLD    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-monOLD    [--same--]  (in FL's mathbox) revised
 2-Nov-15 ishomb    [--same--]  (in FL's mathbox) revised
 2-Nov-15 ishoma    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-homOLD    [--same--]  (in FL's mathbox) revised
 2-Nov-15 dualcat2  [--same--]  (in FL's mathbox) revised
 2-Nov-15 dualded   [--same--]  (in FL's mathbox) revised
 2-Nov-15 dualalg   [--same--]  (in FL's mathbox) revised
 2-Nov-15 mamb      xnegeq      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 mreal     rexneg      moved from FL's mathbox to main set.mm
 2-Nov-15 miminf    xnegmnf     moved from FL's mathbox to main set.mm
 2-Nov-15 mpinf     xnegpnf     moved from FL's mathbox to main set.mm
 2-Nov-15 df-adde   df-xadd     moved from FL's mathbox to main set.mm; revised
 2-Nov-15 df-nege   df-xneg     moved from FL's mathbox to main set.mm
 2-Nov-15 lteqttos  letsr       moved from FL's mathbox to main set.mm
 2-Nov-15 fldleqt   lefld       moved from FL's mathbox to main set.mm; revised
 2-Nov-15 ranleqt   lern        moved from FL's mathbox to main set.mm; revised
 2-Nov-15 domleqt   ledm        moved from FL's mathbox to main set.mm; revised
 2-Nov-15 df-topvs  df-tvc      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 df-toprngo df-trg     moved from FL's mathbox to main set.mm; revised
 2-Nov-15 df-opfn   [--same--]  (in FL's mathbox) revised
 2-Nov-15 topgrpsubcn tgpsubcn  moved from FL's mathbox to main set.mm
 2-Nov-15 istpsbas  tpsuni      moved from FL's mathbox to main set.mm
 2-Nov-15 istpstp   tpstop      moved from FL's mathbox to main set.mm
 2-Nov-15 topgrpinv tgpinv      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 topgrpcn  tgpcn       moved from FL's mathbox to main set.mm; revised
 2-Nov-15 topgrptop tgptps      moved from FL's mathbox to main set.mm
 2-Nov-15 topgrpgrp tgpgrp      moved from FL's mathbox to main set.mm
 2-Nov-15 istopgrp  istgp       moved from FL's mathbox to main set.mm; revised
 2-Nov-15 df-topgrp df-tgp      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 intopcon  indiscon    moved from FL's mathbox to main set.mm
 2-Nov-15 t2t1      haust1      moved from FL's mathbox to main set.mm
 2-Nov-15 df-unif   [--same--]  moved from FL's mathbox to main set.mm
 2-Nov-15 islimrs   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-flimfrs [--same--] (in FL's mathbox) revised
 2-Nov-15 iscnp3    iscnp4      (in FL's mathbox) revised
 2-Nov-15 homindlem3 hmphindis  moved from FL's mathbox to main set.mm; revised
 2-Nov-15 homindlem2 hmph0      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 top2usne  ---         (in FL's mathbox) deleted; see en2top
 2-Nov-15 top2ind   en2top      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 top1      en1top      moved from FL's mathbox to main set.mm
 2-Nov-15 eqindhome indishmph   moved from FL's mathbox to main set.mm; revised
 2-Nov-15 homcardus hmphen2     moved from FL's mathbox to main set.mm; revised
 2-Nov-15 homcard   hmphen      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 hmphsymv  ---         (in FL's mathbox) deleted; see hmphsymb
 2-Nov-15 hmpher    [--same--]  moved from FL's mathbox to main set.mm; revised
 2-Nov-15 rnhmpha   hmphtop2    moved from FL's mathbox to main set.mm; revised
 2-Nov-15 dmhmpha   hmphtop1    moved from FL's mathbox to main set.mm; revised
 2-Nov-15 hmphtr    [--same--]  moved from FL's mathbox to main set.mm; revised
 2-Nov-15 hmphre    hmphref     moved from FL's mathbox to main set.mm
 2-Nov-15 hmphsyma  hmphsym     moved from FL's mathbox to main set.mm; revised
 2-Nov-15 hmphsym   hmphsymb    moved from FL's mathbox to main set.mm; revised
 2-Nov-15 cnvhmph   hmeocnvb    moved from FL's mathbox to main set.mm; revised
 2-Nov-15 idhme     idhmeo      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 cmphmp    hmeoco      moved from FL's mathbox to main set.mm; revised
 2-Nov-15 df-mmat   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-smat   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-amat   [--same--]  (in FL's mathbox) revised
 2-Nov-15 svs3      [--same--]  (in FL's mathbox) revised
 2-Nov-15 svs2      [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-svs    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-gsmhom [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-subsmg [--same--]  (in FL's mathbox) revised
 2-Nov-15 fnopabco2b [--same--] (in FL's mathbox) revised
 2-Nov-15 expus     [--same--]  (in FL's mathbox) revised
 2-Nov-15 expm      [--same--]  (in FL's mathbox) revised
 2-Nov-15 expmiz    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-expsg  [--same--]  (in FL's mathbox) revised
 2-Nov-15 tostos    tsrss       moved from FL's mathbox to main set.mm
 2-Nov-15 rngsubpos psssdm2     moved from FL's mathbox to main set.mm
 2-Nov-15 pospos    psss        moved from FL's mathbox to main set.mm
 2-Nov-15 istoset2  istsr2      moved from FL's mathbox to main set.mm
 2-Nov-15 dutos2    ---         (in FL's mathbox) revised; see cnvtsr
 2-Nov-15 dutos1    cnvtsr      moved from FL's mathbox to main set.mm
 2-Nov-15 df-lb     [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-ub     [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-ler    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-ge     [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-mnl    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-mxl    [--same--]  (in FL's mathbox) revised
 2-Nov-15 dupos2    cnvpsb      moved from FL's mathbox to main set.mm
 2-Nov-15 dupos1    cnvps       moved from FL's mathbox to main set.mm
 2-Nov-15 valcurfn2 [--same--]  (in FL's mathbox) revised
 2-Nov-15 cur1vald  [--same--]  (in FL's mathbox) revised
 2-Nov-15 cur1val   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-cur2   [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-cur1   [--same--]  (in FL's mathbox) revised
 2-Nov-15 iscst3    [--same--]  (in FL's mathbox) hypothesis removed
 2-Nov-15 iscst2    [--same--]  (in FL's mathbox) revised
 2-Nov-15 iscst1    [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-cst    [--same--]  (in FL's mathbox) revised
 2-Nov-15 fopab2g   [--same--]  (in FL's mathbox) revised
 2-Nov-15 elovdm2   elmpt2cl2   moved from FL's mathbox to main set.mm; revised
 2-Nov-15 elovdm    elmpt2cl1   moved from FL's mathbox to main set.mm; revised
 2-Nov-15 ov4gc     [--same--]  (in FL's mathbox) revised
 2-Nov-15 ov2gc     [--same--]  (in FL's mathbox) revised
 2-Nov-15 en2eqpr   set2elt     moved from FL's mathbox to main set.mm
 2-Nov-15 df-rtrcl  [--same--]  (in FL's mathbox) revised
 2-Nov-15 df-trcl   [--same--]  (in FL's mathbox) revised
 2-Nov-15 tricptr   trinxp      moved from FL's mathbox to main set.mm
 2-Nov-15 inttr     trin2       moved from FL's mathbox to main set.mm
 2-Nov-15 sqpeq     xpider      moved from FL's mathbox to main set.mm
 2-Nov-15 cpref     xpidtr      moved from FL's mathbox to main set.mm
 2-Nov-15 fldsqcp2  unixpid     moved from FL's mathbox to main set.mm
 2-Nov-15 dfoprab4spop dfoprab4pop (in FL's mathbox) revised
 2-Nov-15 frsucmptn [--same--]  moved from SF's mathbox to main set.mm; revised
 2-Nov-15 frsucopabn ---        (in SF's mathbox) deleted; see frsucmptn
 2-Nov-15 fvmptgf   fvmptf      moved from SF's mathbox to main set.mm
 2-Nov-15 pjf       pjhf
 2-Nov-15 pjfo      pjhfo
 2-Nov-15 pjpjthi   pjpjhthi
 2-Nov-15 pjpjth    pjpjhth
 2-Nov-15 pjtheu2   pjhtheu2
 2-Nov-15 pjfval    pjhfval
 2-Nov-15 df-pj     df-pjh
 2-Nov-15 pjtheu    pjhtheu
 2-Nov-15 pjth      pjhth
 2-Nov-15 pjthmo    pjhthmo
 2-Nov-15 hhssmetba ---         deleted; see hhssmet
 2-Nov-15 hilmetba  ---         deleted; see hilmet
 2-Nov-15 hhmetba   ---         deleted; see hhmet
 2-Nov-15 h2hmetba  ---         deleted; see hhmet
 2-Nov-15 cpj       cpjh
 2-Nov-15 ---       ---         math token "proj" changed to "projh"
 2-Nov-15 cnhl      cnchl
 2-Nov-15 hlcms     hlcmet
 2-Nov-15 hlbn      hlobn
 2-Nov-15 ishl      ishlo
 2-Nov-15 df-hl     df-hlo
 2-Nov-15 chl       chlo
 2-Nov-15 ---       ---         math token "CHil" changed to "CHilOLD"
 2-Nov-15 minvec    minveco
 2-Nov-15 bncms     cbncms
 2-Nov-15 isbn      iscbn
 2-Nov-15 df-bn     df-cbn
 2-Nov-15 cbn       ccbn
 2-Nov-15 ajval     [--same--]  hypothesis removed
 2-Nov-15 ipsubdi   dipsubdi
 2-Nov-15 ipsubdir  dipsubdir
 2-Nov-15 ipassr2   dipassr2
 2-Nov-15 ipassr    dipassr
 2-Nov-15 ipass     dipass
 2-Nov-15 ipdi      dipdi
 2-Nov-15 ipdir     dipdir
 2-Nov-15 cnph      cncph
 2-Nov-15 cphl      ccphlo
 2-Nov-15 ---       ---         math token "CPreHil" changed to "CPreHilOLD"
 2-Nov-15 nmo0      nmoo0
 2-Nov-15 nmolb     nmoolb
 2-Nov-15 nmoge0    nmooge0
 2-Nov-15 nmoval    nmooval
 2-Nov-15 nmofval   nmoofval
 2-Nov-15 df-nmo    df-nmoo
 2-Nov-15 cnmo      cnmoo
 2-Nov-15 ---       ---         math token "normOp" changed to "normOpOLD"
 2-Nov-15 ipcn      dipcn
 2-Nov-15 ip0l      dip0l
 2-Nov-15 ip0r      dip0r
 2-Nov-15 iporthcom diporthcom
 2-Nov-15 ipcj      dipcj
 2-Nov-15 ipcl      dipcl
 2-Nov-15 ipfval    dipfval
 2-Nov-15 df-ip     df-dip
 2-Nov-15 cip       cdip
 2-Nov-15 nmcn      nmcvcn
 2-Nov-15 imsbai    ---         deleted; see imsmet
 2-Nov-15 imsba     ---         deleted; see imsmet
 2-Nov-15 nmfval    nmcvfval
 2-Nov-15 df-nm     df-nmcv
 2-Nov-15 cnm       cnmcv
 2-Nov-15 ---       ---         math token "norm" changed to "normCV"
 2-Nov-15 ---       ---         math token "CVec" changed to "CVecOLD"
 2-Nov-15 df-giso   [--same--]  (in PC's mathbox) revised
 2-Nov-15 df-ghom   [--same--]  (in PC's mathbox) revised
 2-Nov-15 mdegpropd [--same--]  hypothesis removed
 2-Nov-15 deg1fval  [--same--]  hypothesis removed
 2-Nov-15 mdegcl    [--same--]  hypothesis removed
 2-Nov-15 mdegxrf   [--same--]  hypothesis removed
 2-Nov-15 mdegxrcl  [--same--]  hypothesis removed
 2-Nov-15 mdeglt    [--same--]  hypothesis removed
 2-Nov-15 mdegleb   [--same--]  hypothesis removed
 2-Nov-15 mdegval   [--same--]  hypothesis removed
 2-Nov-15 mdegfval  [--same--]  hypothesis removed
 2-Nov-15 cncms     cncmet
 2-Nov-15 cmsss     cmetss
 2-Nov-15 iscms3i   iscmet3i
 2-Nov-15 iscms3    iscmet3
 2-Nov-15 cmsmeti   cmetmeti
 2-Nov-15 cmsmet    cmetmet
 2-Nov-15 cmscvg2   ---         deleted; see cmetcau
 2-Nov-15 iscms2    ---         deleted; see iscmet2
 2-Nov-15 cmscvg    cmetcau
 2-Nov-15 iscms     iscmet2
 2-Nov-15 df-cmet   [--same--]  revised
 2-Nov-15 om1opn    [--same--]  revised
 2-Nov-15 om1plusg  [--same--]  revised
 2-Nov-15 topgrpfun topgrpstr   revised
 2-Nov-15 om1val    [--same--]  hypothesis removed
 2-Nov-15 pcophtb   [--same--]  hypothesis removed
 2-Nov-15 pcorev2   [--same--]  hypothesis removed
 2-Nov-15 pcorev    [--same--]  hypothesis removed
 2-Nov-15 pcorevcl  [--same--]  hypothesis removed
 2-Nov-15 pcoass    [--same--]  hypothesis removed
 2-Nov-15 pcopt2    [--same--]  hypothesis removed
 2-Nov-15 pcopt     [--same--]  hypothesis removed
 2-Nov-15 pcoptcl   [--same--]  revised
 2-Nov-15 pcohtpy   [--same--]  hypothesis removed
 2-Nov-15 copco     [--same--]  hypothesis removed
 2-Nov-15 pcocn     [--same--]  hypothesis removed
 2-Nov-15 pcoval2   [--same--]  hypothesis removed
 2-Nov-15 pco1      [--same--]  hypothesis removed
 2-Nov-15 pco0      [--same--]  hypothesis removed
 2-Nov-15 pcoval1   [--same--]  hypothesis removed
 2-Nov-15 pcovalg   [--same--]  hypothesis removed
 2-Nov-15 pcoval    [--same--]  hypothesis removed
 2-Nov-15 pcofval   [--same--]  hypothesis removed
 2-Nov-15 phtpcco2  [--same--]  hypothesis removed
 2-Nov-15 reparpht  [--same--]  hypothesis removed
 2-Nov-15 reparphti [--same--]  hypothesis removed
 2-Nov-15 phtpc01   [--same--]  hypothesis removed
 2-Nov-15 phtpcer   [--same--]  hypothesis removed
 2-Nov-15 isphtpc   [--same--]  hypothesis removed
 2-Nov-15 phtpycc   [--same--]  hypothesis removed
 2-Nov-15 phtpyco2  [--same--]  hypothesis removed
 2-Nov-15 phtpyid   [--same--]  hypothesis removed
 2-Nov-15 phtpy01   [--same--]  hypothesis removed
 2-Nov-15 phtpyi    [--same--]  hypothesis removed
 2-Nov-15 phtpycn   [--same--]  hypothesis removed
 2-Nov-15 phtpyhtpy [--same--]  hypothesis removed
 2-Nov-15 isphtpy   [--same--]  hypothesis removed
 2-Nov-15 htpycc    [--same--]  revised
 2-Nov-15 htpyco2   [--same--]  hypothesis removed
 2-Nov-15 htpyco1   [--same--]  revised
 2-Nov-15 htpyid    [--same--]  revised
 2-Nov-15 htpycom   [--same--]  revised
 2-Nov-15 ishtpyd   [--same--]  revised
 2-Nov-15 htpyi     [--same--]  revised
 2-Nov-15 htpycn    [--same--]  revised
 2-Nov-15 ishtpy    [--same--]  revised
 2-Nov-15 cnmpt2pc  [--same--]  revised
 2-Nov-15 metdscn   [--same--]  revised
 2-Nov-15 metdseq0  [--same--]  revised
 2-Nov-15 metds0    [--same--]  revised
 2-Nov-15 metdsf    [--same--]  revised
 2-Nov-15 metdsval  [--same--]  revised
 2-Nov-15 blcvx     [--same--]  revised
 2-Nov-15 ioo2blex  [--same--]  hypothesis removed
 2-Nov-15 ioo2bl    [--same--]  hypothesis removed
 2-Nov-15 bl2ioo    [--same--]  revised
 2-Nov-15 remetba   ---         deleted; see remet
 2-Nov-15 txcc      ---         deleted; see cnfldtps, xpstopn
 2-Nov-15 cn2met    ---         deleted; see cnfldms, xpsms
 2-Nov-15 cnmetba   ---         deleted; see cnmet
 2-Nov-15 txmet     ---         deleted; see xpstopn, xpsms, xpsdsval
 2-Nov-15 metidcn   ---         deleted; see idcn, cnrest, metrest
 2-Nov-15 metcnss2  ---         deleted; see cnrest, metrest
 2-Nov-15 metcnss   ---         deleted; see cnrest2r, metrest
 2-Nov-15 metcnco   ---         deleted; see cnco
 2-Nov-15 metcni2   ---         deleted; see metcnpi3
 2-Nov-15 metcni    ---         deleted; see metcnpi
 2-Nov-15 metcnpi4  ---         deleted; see metcnpi3
 2-Nov-15 metcnconst ---        deleted; see cnconst
 2-Nov-15 metcnf    ---         deleted; see cnf
 2-Nov-15 metcnpf   ---         deleted; see cnpf
 2-Nov-15 methausi  ---         deleted; see methaus
 2-Nov-15 opn0      mopn0
 2-Nov-15 opnin     mopnin
 2-Nov-15 opnuni    unimopn
 2-Nov-15 opni3     mopni3
 2-Nov-15 opni2     mopni2
 2-Nov-15 opni      mopni
 2-Nov-15 msdmdm    ---         deleted; see msmet
 2-Nov-15 ismsg     isms2       revised
 2-Nov-15 opnss     mopnss
 2-Nov-15 isopn4    elmopn2
 2-Nov-15 opnm      mopnm
 2-Nov-15 opnfss    mopnfss
 2-Nov-15 isopn     elmopn
 2-Nov-15 uniopn2   mopnuni
 2-Nov-15 opntop    mopntop
 2-Nov-15 opnval    mopnval
 2-Nov-15 metxp     ---         deleted; see xpsmet
 2-Nov-15 metss     ---         deleted; see dmss
 2-Nov-15 metssba2  ---         deleted; see metres2
 2-Nov-15 metssba   ---         deleted; see metres
 2-Nov-15 ismet     [--same--]  revised
 2-Nov-15 df-met    [--same--]  changed "D e. Met" to "D e. (Met`X)",
                                affecting all df-met theorems
 2-Nov-15 df-tsms   [--same--]  revised
 2-Nov-15 cnflf2    [--same--]  revised
 2-Nov-15 cnflf     [--same--]  revised
 2-Nov-15 cnpflf    [--same--]  revised
 2-Nov-15 cnpflf2   [--same--]  revised
 2-Nov-15 cnpflfi   [--same--]  revised
 2-Nov-15 flfelbas  [--same--]  revised
 2-Nov-15 isflf     [--same--]  revised
 2-Nov-15 flfnei    [--same--]  revised
 2-Nov-15 flfval    [--same--]  revised
 2-Nov-15 flffval   [--same--]  revised
 2-Nov-15 flimcls   [--same--]  revised
 2-Nov-15 flimcf    [--same--]  revised
 2-Nov-15 fbflim2   [--same--]  revised
 2-Nov-15 fbflim    [--same--]  revised
 2-Nov-15 flimopn   [--same--]  revised
 2-Nov-15 neiflim   [--same--]  revised
 2-Nov-15 flimss2   [--same--]  revised
 2-Nov-15 elflim    [--same--]  revised
 2-Nov-15 trnei     [--same--]  revised
 2-Nov-15 trfil3    [--same--]  revised
 2-Nov-15 trfil2    [--same--]  revised
 2-Nov-15 trfil1    [--same--]  revised
 2-Nov-15 neifil    [--same--]  revised
 2-Nov-15 qtophmeo  [--same--]  revised
 2-Nov-15 xkohmeo   [--same--]  revised
 2-Nov-15 xkocnv    [--same--]  revised
 2-Nov-15 pt1hmeo   [--same--]  revised
 2-Nov-15 txswaphmeo [--same--] revised
 2-Nov-15 contoppr  conhmph     revised
 2-Nov-15 cmptoppr  cmphmph     revised
 2-Nov-15 hmph      [--same--]  hypothesis removed
 2-Nov-15 hmeores   [--same--]  hypothesis removed
 2-Nov-15 hmeocnv   [--same--]  hypothesis removed
 2-Nov-15 hmeobc    ishmeo      hypothesis removed
 2-Nov-15 hmeoima   [--same--]  revised
 2-Nov-15 hmeocnb   ---         deleted; see hmeoima
 2-Nov-15 hmeocna   ---         deleted; see hmeocn, cnima
 2-Nov-15 hmeof1o   [--same--]  hypothesis removed
 2-Nov-15 ishmeo    [--same--]  revised
 2-Nov-15 hmeofval  [--same--]  revised
 2-Nov-15 df-hmph   [--same--]  revised
 2-Nov-15 df-hmeo   [--same--]  revised
 2-Nov-15 qtopcmap  [--same--]  revised
 2-Nov-15 qtopomap  [--same--]  revised
 2-Nov-15 qtoprest  [--same--]  revised
 2-Nov-15 qtopeu    [--same--]  revised
 2-Nov-15 qtopss    [--same--]  revised
 2-Nov-15 qtopcn    [--same--]  revised
 2-Nov-15 qtopcld   [--same--]  revised
 2-Nov-15 qtopid    [--same--]  revised
 2-Nov-15 ---       ---         cnmptid ~ cnmpt2k revised
 2-Nov-15 xkoco2cn  [--same--]  hypothesis removed
 2-Nov-15 xkoco1cn  [--same--]  hypothesis removed
 2-Nov-15 lmcn2     [--same--]  revised
 2-Nov-15 txlm      [--same--]  revised
 2-Nov-15 hauseqlcld [--same--] hypothesis removed
 2-Nov-15 txrest    [--same--]  revised
 2-Nov-15 ptcn      [--same--]  revised
 2-Nov-15 txcnmpt   [--same--]  hypothesis removed
 2-Nov-15 txcn      [--same--]  hypothesis removed
 2-Nov-15 uptx      [--same--]  revised
 2-Nov-15 ptcnp     [--same--]  revised
 2-Nov-15 txcnp     [--same--]  revised
 2-Nov-15 xkoccn    [--same--]  revised
 2-Nov-15 tx2cn     [--same--]  revised
 2-Nov-15 tx1cn     [--same--]  revised
 2-Nov-15 txbasval  [--same--]  revised
 2-Nov-15 txcld     [--same--]  hypothesis removed
 2-Nov-15 txopn     [--same--]  hypothesis removed
 2-Nov-15 eltpt2    eltx        revised
 2-Nov-15 eltpt     ---         deleted; see eltg3
 2-Nov-15 txbas2    txbas       revised
 2-Nov-15 txval     [--same--]  revised
 2-Nov-15 df-tx     [--same--]  revised
 2-Nov-15 kgen2cn   [--same--]  hypothesis removed
 2-Nov-15 kgencn2   [--same--]  revised
 2-Nov-15 kgencn    [--same--]  revised
 2-Nov-15 kgen2ss   [--same--]  revised
 2-Nov-15 elkgen    [--same--]  revised
 2-Nov-15 kgenval   [--same--]  revised
 2-Nov-15 2ndcomap  [--same--]  hypothesis removed
 2-Nov-15 concompcld [--same--] revised
 2-Nov-15 concompid [--same--]  revised
 2-Nov-15 clscon    [--same--]  revised
 2-Nov-15 uncon     [--same--]  revised
 2-Nov-15 iuncon    [--same--]  revised
 2-Nov-15 concn     [--same--]  hypothesis removed
 2-Nov-15 conima    [--same--]  hypothesis removed
 2-Nov-15 consubclo [--same--]  hypothesis removed
 2-Nov-15 nconsubb  [--same--]  revised
 2-Nov-15 cnconn    [--same--]  hypothesis removed
 2-Nov-15 connsub   [--same--]  revised
 2-Nov-15 consuba   [--same--]  revised
 2-Nov-15 dfcon2    [--same--]  revised
 2-Nov-15 alexsub   alexsubALT
 2-Nov-15 cmpfii    [--same--]  revised
 2-Nov-15 sscmp     [--same--]  revised
 2-Nov-15 imacmp    [--same--]  hypothesis removed
 2-Nov-15 rncmp     [--same--]  hypothesis removed
 2-Nov-15 cncmp     [--same--]  hypothesis removed
 2-Nov-15 sshaus    [--same--]  revised
 2-Nov-15 dnsconst  [--same--]  revised
 2-Nov-15 ishausi   ---         deleted; see ishaus
 2-Nov-15 hausnei2  [--same--]  revised
 2-Nov-15 lmcn      [--same--]  hypothesis removed
 2-Nov-15 lmcnp     [--same--]  hypothesis removed
 2-Nov-15 lmff      [--same--]  revised
 2-Nov-15 lmres     [--same--]  revised
 2-Nov-15 lmcl      [--same--]  revised
 2-Nov-15 lmfss     [--same--]  revised
 2-Nov-15 lmfpm     [--same--]  revised
 2-Nov-15 paste     [--same--]  revised
 2-Nov-15 cnindis   [--same--]  revised
 2-Nov-15 cndis     [--same--]  revised
 2-Nov-15 cnprest2  [--same--]  hypothesis removed
 2-Nov-15 cnprest   [--same--]  hypothesis removed
 2-Nov-15 cnpresti  [--same--]  hypothesis removed
 2-Nov-15 cnrest2r  [--same--]  hypothesis removed
 2-Nov-15 cnrest2   [--same--]  hypothesis removed
 2-Nov-15 cnrest    [--same--]  revised
 2-Nov-15 cnconst   [--same--]  revised
 2-Nov-15 cnconst2  [--same--]  revised
 2-Nov-15 cncnp2    [--same--]  revised
 2-Nov-15 cncnp     [--same--]  revised
 2-Nov-15 cncnpi    [--same--]  hypothesis removed
 2-Nov-15 cnsscnp   [--same--]  hypothesis removed
 2-Nov-15 cnss2     [--same--]  revised
 2-Nov-15 cnss1     [--same--]  revised
 2-Nov-15 cnclima   [--same--]  hypothesis removed
 2-Nov-15 iscncl    [--same--]  revised
 2-Nov-15 cnpco     [--same--]  hypothesis removed
 2-Nov-15 cnco      [--same--]  hypothesis removed
 2-Nov-15 cnima     [--same--]  hypothesis removed
 2-Nov-15 ---       ---         lmbr ~ lmcvg revised
 2-Nov-15 idcn      [--same--]  revised
 2-Nov-15 cnpimaex  [--same--]  hypothesis removed
 2-Nov-15 ssidcn    [--same--]  revised
 2-Nov-15 subbascn  [--same--]  revised
 2-Nov-15 tgcn      [--same--]  revised
 2-Nov-15 tgcnp     [--same--]  revised
 2-Nov-15 cnpcl     [--same--]  hypothesis removed
 2-Nov-15 cnpf      [--same--]  hypothesis removed
 2-Nov-15 cnf       [--same--]  hypothesis removed
 2-Nov-15 iscnp2    [--same--]  revised
 2-Nov-15 iscnp     [--same--]  revised
 2-Nov-15 cnpval    [--same--]  revised
 2-Nov-15 iscn      [--same--]  revised
 2-Nov-15 cnpfval   [--same--]  revised
 2-Nov-15 cnfval    [--same--]  revised
 2-Nov-15 lmfval    [--same--]  revised
 2-Nov-15 restsubbas ---        deleted; see firest, tgrest
 2-Nov-15 tgrest    [--same--]  revised
 2-Nov-15 restcldr  [--same--]  revised
 2-Nov-15 restcldi  [--same--]  revised
 2-Nov-15 restsn2   [--same--]  revised
 2-Nov-15 opncldf3  [--same--]  hypothesis removed
 2-Nov-15 opncldf1  [--same--]  revised
 2-Nov-15 elcls3    [--same--]  revised
 2-Nov-15 clsss2    [--same--]  hypothesis removed
 2-Nov-15 incld     [--same--]  hypothesis removed
 2-Nov-15 cldcls    [--same--]  hypothesis removed
 2-Nov-15 uncld     [--same--]  hypothesis removed
 2-Nov-15 intcld    [--same--]  hypothesis removed
 2-Nov-15 iincld    [--same--]  hypothesis removed
 2-Nov-15 difopn    [--same--]  hypothesis removed
 2-Nov-15 cldopn    [--same--]  hypothesis removed
 2-Nov-15 cldss2    [--same--]  hypothesis removed
 2-Nov-15 cldss     [--same--]  hypothesis removed
 2-Nov-15 cctop     [--same--]  revised
 2-Nov-15 fctop2    [--same--]  revised
 2-Nov-15 fctop     [--same--]  revised
 2-Nov-15 subtop    resttop     revised
 2-Nov-15 subtopbas restbas     revised
 2-Nov-15 bastop2   [--same--]  revised; see also tgclb
 2-Nov-15 bastop1   [--same--]  revised; see also tgclb
 2-Nov-15 2basgen   [--same--]  hypothesis removed
 2-Nov-15 basgen2   [--same--]  revised; see also tgclb
 2-Nov-15 tgss3     [--same--]  revised; see also eltg, dfss3
 2-Nov-15 tgss2     [--same--]  hypothesis removed
 2-Nov-15 tgidm     [--same--]  hypothesis removed
 2-Nov-15 tpsstr    ---         deleted; see tpspropd
 2-Nov-15 tpsprop   tpspropd    revised
 2-Nov-15 eltopsp   ---         deleted; see toptopon, eltpsg
 2-Nov-15 eltopspg  ---         deleted; see toptopon, eltpsg
 2-Nov-15 eltpsg    [--same--]  revised
 2-Nov-15 eltps     ---         deleted; see eltpsg
 2-Nov-15 top2tps   ---         deleted; see tpstop
 2-Nov-15 istps5    ---         deleted; see istps
 2-Nov-15 istps4    ---         deleted; see istps
 2-Nov-15 istps3    ---         deleted; see istps
 2-Nov-15 istps2    ---         deleted; see istps
 2-Nov-15 istps     [--same--]  revised
 2-Nov-15 topsn     [--same--]  revised
 2-Nov-15 topgele   [--same--]  revised
 2-Nov-15 df-topsp  [--same--]  revised
 2-Nov-15 znz2rfo   znzrhfo
 2-Nov-15 znz2rval  znzrhval
 2-Nov-15 znz2r2    znzrh2
 2-Nov-15 znz2r     znzrh
 2-Nov-15 z2rpropd  zrhpropd
 2-Nov-15 z2rrhm    zrhrhm
 2-Nov-15 z2rrhmb   zrhrhmb
 2-Nov-15 z2rmulg   zrhmulg
 2-Nov-15 z2rval2   zrhval2
 2-Nov-15 z2rval    zrhval
 2-Nov-15 df-z2r    df-zrh
 2-Nov-15 cz2r      czrh
 2-Nov-15 ---       ---         math token "Z2Ring" changed to "ZRHom"
 2-Nov-15 df-cnfld  [--same--]  revised
 2-Nov-15 ply1ascl  [--same--]  hypothesis removed
 2-Nov-15 ply1mpl1  [--same--]  hypothesis removed
 2-Nov-15 ply1mpl0  [--same--]  hypothesis removed
 2-Nov-15 mplbaspropd [--same--] hypothesis removed
 2-Nov-15 psrplusgpropd [--same--] hypothesis removed
 2-Nov-15 psrbaspropd [--same--] hypothesis removed
 2-Nov-15 ply1mulr  [--same--]  hypothesis removed
 2-Nov-15 ply1vsca  [--same--]  hypothesis removed
 2-Nov-15 ply1plusg [--same--]  hypothesis removed
 2-Nov-15 psr1mulr  [--same--]  hypothesis removed
 2-Nov-15 psr1vsca  [--same--]  hypothesis removed
 2-Nov-15 psr1plusg [--same--]  hypothesis removed
 2-Nov-15 mplmulr   [--same--]  hypothesis removed
 2-Nov-15 mplvscafval [--same--] hypothesis removed
 2-Nov-15 mplplusg  [--same--]  hypothesis removed
 2-Nov-15 opsr1     [--same--]  hypothesis removed
 2-Nov-15 opsr0     [--same--]  hypothesis removed
 2-Nov-15 ply1bas   [--same--]  hypothesis removed
 2-Nov-15 ply1val   [--same--]  hypothesis removed
 2-Nov-15 psr1bas   [--same--]  hypothesis removed
 2-Nov-15 psr1bas2  [--same--]  hypothesis removed
 2-Nov-15 psr1val   [--same--]  hypothesis removed
 2-Nov-15 opsrvsca  [--same--]  hypothesis removed
 2-Nov-15 opsrmulr  [--same--]  hypothesis removed
 2-Nov-15 opsrplusg [--same--]  hypothesis removed
 2-Nov-15 opsrbas   [--same--]  hypothesis removed
 2-Nov-15 opsrle    [--same--]  hypothesis removed
 2-Nov-15 mplvscaval [--same--] hypothesis removed
 2-Nov-15 mplvsca   [--same--]  hypothesis removed
 2-Nov-15 mplvsca2  [--same--]  hypothesis removed
 2-Nov-15 mplmul    [--same--]  hypothesis removed
 2-Nov-15 mpladd    [--same--]  hypothesis removed
 2-Nov-15 mplelf    [--same--]  hypothesis removed
 2-Nov-15 mplbasss  [--same--]  hypothesis removed
 2-Nov-15 mplval2   [--same--]  hypothesis removed
 2-Nov-15 mplelbas  [--same--]  hypothesis removed
 2-Nov-15 mplbas    [--same--]  revised
 2-Nov-15 mplval    [--same--]  hypothesis removed
 2-Nov-15 resspsrbas [--same--] hypothesis removed
 2-Nov-15 psrvscacl [--same--]  hypothesis removed
 2-Nov-15 psrvscaval [--same--] hypothesis removed
 2-Nov-15 psrvsca   [--same--]  hypothesis removed
 2-Nov-15 psrvscafval [--same--] hypothesis removed
 2-Nov-15 psrmulcl  [--same--]  hypothesis removed
 2-Nov-15 psrmulval [--same--]  hypothesis removed
 2-Nov-15 psrmulfval [--same--] hypothesis removed
 2-Nov-15 psrmulr   [--same--]  hypothesis removed
 2-Nov-15 psraddcl  [--same--]  hypothesis removed
 2-Nov-15 psradd    [--same--]  hypothesis removed
 2-Nov-15 psrplusg  [--same--]  hypothesis removed
 2-Nov-15 psrelbas  [--same--]  hypothesis removed
 2-Nov-15 psrbas    [--same--]  hypothesis removed
 2-Nov-15 psrvalfun psrvalstr   revised
 2-Nov-15 psrval    [--same--]  revised
 2-Nov-15 rlm0      [--same--]  hypothesis removed
 2-Nov-15 sralmod0  [--same--]  hypothesis removed
 2-Nov-15 sraval    [--same--]  revised
 2-Nov-15 df-sra    [--same--]  revised
 2-Nov-15 islvec2   islvec
 2-Nov-15 islmhm3   ---         deleted; see islmhm
 2-Nov-15 df-lmic   [--same--]  revised
 2-Nov-15 prdmlmodd prdslmodd
 2-Nov-15 prdmvscacl prdsvscacl
 2-Nov-15 lmodvsubid lmodsubid
 2-Nov-15 lmodvsubeq0 lmodsubeq0
 2-Nov-15 lmodvsubdi2 lmodsubdir
 2-Nov-15 lmodvsubdi1 lmodsubdi
 2-Nov-15 lmodvsass [--same--]  revised
 2-Nov-15 lmodvsdi2 lmodvsdir   revised
 2-Nov-15 lmodvsdi1 lmodvsdi    revised
 2-Nov-15 invrpropd [--same--]  hypothesis removed
 2-Nov-15 rngidpropd [--same--] hypothesis removed
 2-Nov-15 rngdvcan3 dvrcan3
 2-Nov-15 rngdvcan1 dvrcan1
 2-Nov-15 rngdvass  dvrass
 2-Nov-15 rngdv1    dvr1
 2-Nov-15 rngdvid   dvrid
 2-Nov-15 rngdvcl   dvrcl
 2-Nov-15 rngdvval  dvrval
 2-Nov-15 rngdvfval dvrfval
 2-Nov-15 df-rngdv  df-dvr
 2-Nov-15 opprmul   [--same--]  hypothesis removed
 2-Nov-15 opprmulfval [--same--] revised
 2-Nov-15 opprval   [--same--]  revised
 2-Nov-15 df-oppr   [--same--]  revised
 2-Nov-15 prdm1     prds1
 2-Nov-15 prdmcrngd prdscrngd
 2-Nov-15 prdmrngd  prdsrngd
 2-Nov-15 prdmmulrcl prdsmulrcl
 2-Nov-15 prdmmgp2  prdsmgp     revised
 2-Nov-15 prdmmgp1  prdsmgp     revised
 2-Nov-15 dfur2     [--same--]  hypothesis removed
 2-Nov-15 rngidval  [--same--]  hypothesis removed
 2-Nov-15 mgpval    [--same--]  hypothesis removed
 2-Nov-15 prdmgsum  prdsgsum
 2-Nov-15 prdmabld  prdsabld
 2-Nov-15 prdmcmnd  prdscmnd
 2-Nov-15 dfod2     [--same--]  revised
 2-Nov-15 odf1      [--same--]  revised
 2-Nov-15 oddvds    [--same--]  hypothesis removed
 2-Nov-15 odid      [--same--]  revised
 2-Nov-15 odxrcl    ---         deleted; see odcl
 2-Nov-15 odcl      [--same--]  revised
 2-Nov-15 odval     [--same--]  revised
 2-Nov-15 odfval    [--same--]  revised
 2-Nov-15 df-od     [--same--]  revised
 2-Nov-15 symgval   [--same--]  revised
 2-Nov-15 df-symg   [--same--]  revised
 2-Nov-15 df-gic    [--same--]  revised
 2-Nov-15 divsgrp   [--same--]  revised
 2-Nov-15 prdminvgd prdsinvgd
 2-Nov-15 prdmgrpd  prdsgrpd
 2-Nov-15 mulgfval  [--same--]  hypothesis removed
 2-Nov-15 grpinvval [--same--]  hypothesis removed
 2-Nov-15 grpinvfval [--same--] hypothesis removed
 2-Nov-15 grpstr    grppropstr
 2-Nov-15 prdmpjmhm prdspjmhm
 2-Nov-15 prdm0g    prds0g
 2-Nov-15 prdmmndd  prdspmndd
 2-Nov-15 prdmplusgcl prdsplusgcl
 2-Nov-15 grpidpropd [--same--] hypothesis removed
 2-Nov-15 grpidval  [--same--]  revised
 2-Nov-15 df-0g     [--same--]  revised
 2-Nov-15 istoset3  istsr2      revised
 2-Nov-15 istoset   istsr       revised
 2-Nov-15 posreltr  pstr2
 2-Nov-15 posanref  psref2
 2-Nov-15 df-la     df-lar      revised
 2-Nov-15 df-nfw    [--same--]  revised
 2-Nov-15 df-ts     df-tsr      revised
 2-Nov-15 ipoval    [--same--]  revised
 2-Nov-15 df-ipo    [--same--]  revised
 2-Nov-15 erlecpbl  [--same--]  revised
 2-Nov-15 ercpbl    [--same--]  revised
 2-Nov-15 imasvscaf [--same--]  revised
 2-Nov-15 imasopn   imastset    revised
 2-Nov-15 imasvsca  [--same--]  revised
 2-Nov-15 imassca   [--same--]  revised
 2-Nov-15 imasdist  imasds      revised
 2-Nov-15 imasval   [--same--]  revised
 2-Nov-15 prdmbasmpt2 prdsbasmpt2
 2-Nov-15 prdmvscafval prdsvscafval
 2-Nov-15 prdmvscaval prdsvscaval
 2-Nov-15 prdmmulrfval prdsmulrfval
 2-Nov-15 prdmmulrval prdsmulrval
 2-Nov-15 prdmplusgfval prdsplusgfval
 2-Nov-15 prdmplusgval prdsplusgval
 2-Nov-15 prdmvsca  prdsvsca
 2-Nov-15 prdmbasprj prdsbasprj
 2-Nov-15 prdmbasfn prdsbasfn
 2-Nov-15 prdmbasmpt prdsbasmpt
 2-Nov-15 prdmbas2  prdsbas2
 2-Nov-15 prdmvsca  prdsvsca
 2-Nov-15 prdmmulr  prdsmulr
 2-Nov-15 prdmplusg prdsplusg
 2-Nov-15 prdmsca   prdssca
 2-Nov-15 prdmbas   prdsbas
 2-Nov-15 prdmval   prdsval
 2-Nov-15 prdmvalfun prdsvalstr
 2-Nov-15 reldmprdm reldmprds
 2-Nov-15 prdmbasex prdsbasex
 2-Nov-15 df-prdm   df-prds
 2-Nov-15 ---       ---         math token "Xm_" changed to "Xs_"
 2-Nov-15 cprdm     cprds
 2-Nov-15 posle     ---         deleted; see 2strop
 2-Nov-15 posbase   ---         deleted; see 2strbas
 2-Nov-15 posfn     ---         deleted; see 2strstr
 2-Nov-15 tpstopset ---         deleted; see 2strop
 2-Nov-15 tpsbase   ---         deleted; see 2strbas
 2-Nov-15 tpsfn     ---         deleted; see 2strstr
 2-Nov-15 algfn     algstr      revised
 2-Nov-15 lmodfn    lmodstr     revised
 2-Nov-15 rngfn     rngstr      revised
 2-Nov-15 rnglem    ---         deleted; see rngstr
 2-Nov-15 grpfn     grpstr      revised
 2-Nov-15 grplem    ---         deleted; see grpstr
 2-Nov-15 ---       ---         math token "ip" changed to ".i"
 2-Nov-15 ---       ---         math token ".i" changed to ".iOLD"
 2-Nov-15 ---       ---         math token "vsca" changed to ".s"
 2-Nov-15 ---       ---         math token ".s" changed to ".sOLD"
 2-Nov-15 ---       ---         df-base ~ basendx, resslem, df-plusg ~ df-ds
                                revised
 2-Nov-15 leisorel  [--same--]  revised
 2-Nov-15 nnesqi    nnesq       revised
 2-Nov-15 nnlesqi   nnlesq      revised
 2-Nov-15 nnsqcli   nnsqcl      revised
 2-Nov-15 icoshftf1oii ---      deleted; see icoshftf1o
 2-Nov-15 ubicc2    [--same--]  revised
 2-Nov-15 lbicc2    [--same--]  revised
 2-Nov-15 ltneii    gtneii      revised
 2-Nov-15 ltne      [--same--]  revised
 2-Nov-15 iundom    [--same--]  revised
 2-Nov-15 unidomg   unidom      revised
 2-Nov-15 unidom    [--same--]  revised
 2-Nov-15 trcl      [--same--]  revised
 2-Nov-15 fipwuni   [--same--]  hypothesis removed
 2-Nov-15 fi0       fieq0
 2-Nov-15 unifi     [--same--]  revised
 2-Nov-15 dmen      ---         deleted; see ener
 2-Nov-15 f1oen2g   f1oen3g     variables renamed
 2-Nov-15 fvopabf4  fvmptmap    revised
 2-Nov-15 ereldmb   ereldm
 2-Nov-15 ereldm    [--same--]  revised
 2-Nov-15 iser2d    iserd       revised
 2-Nov-15 iser      iserd       revised
 2-Nov-15 erdmrn    ---         deleted; see erdm, errn
 2-Nov-15 errtr     ---         deleted; see ertr
 2-Nov-15 errsym    ---         deleted; see ersym
 2-Nov-15 df-er     [--same--]  revised
 2-Nov-15 wer       [--same--]  changed "Er R" to "R Er A", affecting all df-er
                                theorems
 2-Nov-15 frsucopab frsucmpt    revised
 2-Nov-15 rdgsucopabn rdgsucmptnf revised
 2-Nov-15 rdgsucopab rdgsucmptf revised
 2-Nov-15 fv4       [--same--]  hypothesis removed
 2-Nov-15 fsplit    [--same--]  revised
 2-Nov-15 fpar      [--same--]  revised
 2-Nov-15 curry2    [--same--]  revised
 2-Nov-15 curry1    [--same--]  revised
 2-Nov-15 iunfoprab dfmpt2      revised
 2-Nov-15 oprab2co  [--same--]  revised
 2-Nov-15 oprabco   [--same--]  revised
 2-Nov-15 elrnoprab elrnmpt2    revised
 2-Nov-15 elrnoprabg elrnmpt2g  revised
 2-Nov-15 dmoprab2  dmmpt2      revised
 2-Nov-15 fnoprab2  fnmpt2i     revised
 2-Nov-15 fnoprab2g ---         deleted; see fmpt2, dffn2
 2-Nov-15 foprab    ---         deleted; see fmpt2
 2-Nov-15 foprab2   fmpt2       revised
 2-Nov-15 elopaba   [--same--]  variables renamed
 2-Nov-15 copsex2gb [--same--]  variables renamed
 2-Nov-15 copsex2ga [--same--]  variables renamed
 2-Nov-15 oprabopab dfoprab4    revised
 2-Nov-15 oprabopabf dfoprab4f  revised
 2-Nov-15 dfopab5sf ---         deleted; see mpt2mpt
 2-Nov-15 dfopab5s  ---         deleted; see mpt2mpt
 2-Nov-15 dfopab4s  dfopab4     revised
 2-Nov-15 dfopab3s  dfopab3     revised
 2-Nov-15 dfopab3   dfopab3s
 2-Nov-15 dfopab2   [--same--]  revised
 2-Nov-15 csbopeq1a [--same--]  revised
 2-Nov-15 sbcopeq1a [--same--]  revised
 2-Nov-15 caofdir   [--same--]  variables renamed
 2-Nov-15 caofdi    [--same--]  variables renamed
 2-Nov-15 caovdird  [--same--]  variables renamed
 2-Nov-15 caovdirg  [--same--]  variables renamed
 2-Nov-15 caovdid   [--same--]  variables renamed
 2-Nov-15 caovdig   [--same--]  variables renamed
 2-Nov-15 ov5       ovmpt2      revised
 2-Nov-15 ov2       ovmpt2      revised
 2-Nov-15 ov2g      ovmpt2g     revised
 2-Nov-15 ov2ag     ovmpt2ga    revised
 2-Nov-15 ov4g      ovmpt4g     revised
 2-Nov-15 ov2gf     [--same--]  revised
 2-Nov-15 oprabex2  mpt2ex      revised
 2-Nov-15 oprabex2g mpt2exg     revised
 2-Nov-15 fov       ---         deleted; see fnov, ffnov
 2-Nov-15 fnov2     fnov
 2-Nov-15 brwitnlem [--same--]  revised
 2-Nov-15 fopabap   fmptap      revised
 2-Nov-15 fopabsn   fmptsn      revised
 2-Nov-15 fopabcos  fmptcos     revised
 2-Nov-15 fopabco   fmptco      revised
 2-Nov-15 fopabfv   ---         deleted; see dffn5, ffnfv
 2-Nov-15 fopab     fmpti       revised
 2-Nov-15 fopab3    ---         deleted; see df-f, fnmpti
 2-Nov-15 rnssopab  ---         deleted; see fmpt, frn
 2-Nov-15 fopabssxp ---         deleted; see fmpt, fssxp
 2-Nov-15 fopab2    ---         deleted; see fmpt
 2-Nov-15 fopabex2  ---         deleted; see mptex
 2-Nov-15 opabex2g  ---         deleted; see mptexg
 2-Nov-15 opabex2   ---         deleted; see mptex
 2-Nov-15 fnasrn    [--same--]  revised
 2-Nov-15 elrnopab  ---         deleted; see elrnmpti
 2-Nov-15 elrnopabg ---         deleted; see elrnmptg
 2-Nov-15 eqfnfv2   eqfnfv
 2-Nov-15 eqfnfv    eqfnfv2
 2-Nov-15 fvopab5   [--same--]  revised
 2-Nov-15 fvopabs   ---         deleted; see fvmpts
 2-Nov-15 fvopab2   ---         deleted; see fvmpt2
 2-Nov-15 fvopab    ---         deleted; see fvmpt
 2-Nov-15 fvopabf   ---         deleted; see fvmptf
 2-Nov-15 fvopabnf  ---         deleted; see fvmptnf
 2-Nov-15 fvopabgf  ---         deleted; see fvmptf
 2-Nov-15 fvopabn   ---         deleted; see fvmptn
 2-Nov-15 fvopabg   ---         deleted; see fvmptg
 2-Nov-15 fvopab4sf ---         deleted; see fvmpts
 2-Nov-15 fvopab4f  fvmpts      revised
 2-Nov-15 fvopab4gf fvmptf      revised
 2-Nov-15 fvopab4   fvmpt       revised
 2-Nov-15 fvopab4g  fvmptg      revised
 2-Nov-15 fvopab4t  fvmptt      revised
 2-Nov-15 dffn5     [--same--]  revised
 2-Nov-15 tz6.12c   [--same--]  hypothesis removed
 2-Nov-15 tz6.12f   [--same--]  variables renamed
 2-Nov-15 tz6.12    [--same--]  hypothesis removed
 2-Nov-15 tz6.12-1  [--same--]  hypothesis removed
 2-Nov-15 fv3       [--same--]  hypothesis removed
 2-Nov-15 elfv      [--same--]  hypothesis removed
 2-Nov-15 fv2       [--same--]  hypothesis removed
 2-Nov-15 dmopab2   ---         deleted; see dmmpti
 2-Nov-15 fnopab2   ---         deleted; see fnmpti
 2-Nov-15 fnopab2g  ---         deleted; see mptfng
 2-Nov-15 iunfopab  dfmpt       revised
 2-Nov-15 funeu2    [--same--]  variables renamed
 2-Nov-15 funeu     [--same--]  variables renamed
 2-Nov-15 funmo     [--same--]  variables renamed
 2-Nov-15 dffun6    [--same--]  variables renamed
 2-Nov-15 opswap    [--same--]  hypothesis removed
 2-Nov-15 rnopab2   ---         deleted; see rnmpt
 2-Nov-15 fconstopab ---        deleted; see fconstmpt
 2-Nov-15 elomg     ---         deleted; see elom
 2-Nov-15 elom      [--same--]  revised
 2-Nov-15 df-om     [--same--]  revised
 2-Nov-15 rexxfr2d  [--same--]  revised
 2-Nov-15 ralxfr2d  [--same--]  revised
 2-Nov-15 hbcsb1    hbcsb1f
 2-Nov-15 csbeq2i   [--same--]  hypothesis removed
 2-Nov-15 csbeq2dv  [--same--]  hypothesis removed
 2-Nov-15 hbsbc1v   hbsbc1      hypothesis removed
 2-Nov-15 hbsbc1    hbsbc1f
 2-Nov-15 rexrab    [--same--]  variables renamed
 2-Nov-15 rexab     [--same--]  variables renamed
 2-Nov-15 ceqsralv  [--same--]  hypothesis removed
16-Aug-15 dif1en    [--same--]  hypothesis removed
11-Aug-15 df-sgm    [--same--]  revised
11-Aug-15 pi1xfrf1o pi1xfrgim   revised
11-Aug-15 pi1xfr    [--same--]  revised
11-Aug-15 pi1id     [--same--]  revised
11-Aug-15 pi1gp     pi1grp
11-Aug-15 pi1pval   pi1addval   revised
11-Aug-15 pi1f      pi1addf     revised
11-Aug-15 pi1fval   ---         deleted; see pi1addval
11-Aug-15 pi1bvalqs pi1bas      revised
11-Aug-15 elpi1i    [--same--]  revised
11-Aug-15 elpi1     [--same--]  revised
11-Aug-15 pi1bval   ---         deleted; see pi1bas
11-Aug-15 pi1val    [--same--]  revised
11-Aug-15 pcohtpy   [--same--]  hypothesis removed
11-Aug-15 pcoloopf  om1addcl    revised
11-Aug-15 df-pi1    [--same--]  revised
11-Aug-15 phtpc01   [--same--]  hypothesis removed
11-Aug-15 phtpcdm   ---         deleted; see phtpcer
11-Aug-15 isphtpc   [--same--]  hypothesis removed
11-Aug-15 conntoppr contoppr
11-Aug-15 cnvhmpha  hmeocnv
11-Aug-15 hmeomap   hmeof1o
11-Aug-15 ishomeo   ishmeo
11-Aug-15 homeofval hmeofval
11-Aug-15 df-homeo  df-hmeo
11-Aug-15 chomeo    chmph
11-Aug-15 chomeosm  chmeo
11-Aug-15 ---       ---         df-imas, df-divs theorems: hypothesis revised
11-Aug-15 pcadd2    [--same--]  hypothesis removed
11-Aug-15 pcadd     [--same--]  hypothesis removed
11-Aug-15 pcz       [--same--]  hypothesis removed
11-Aug-15 pc11      [--same--]  revised
11-Aug-15 pc2dvds   [--same--]  revised
11-Aug-15 pcabs     [--same--]  hypothesis removed
11-Aug-15 pcneg     [--same--]  hypothesis removed
11-Aug-15 pcdvdsb   [--same--]  revised
11-Aug-15 df-pc     [--same--]  revised
11-Aug-15 dmenr     ---         deleted; see enrer
11-Aug-15 dmenq     ---         deleted; see enqer
11-Aug-15 ---       ---         otoscl ~ otosen deleted; see df-oi
11-Aug-15 r0weon    [--same--]  revised
11-Aug-15 hta       [--same--]  revised
11-Aug-15 onssr1    [--same--]  revised
11-Aug-15 uniwf     [--same--]  revised
11-Aug-15 unwf      [--same--]  revised
11-Aug-15 pwwf      [--same--]  revised
11-Aug-15 rankr1ag  [--same--]  revised
11-Aug-15 r1val1    [--same--]  revised
11-Aug-15 oieu      [--same--]  revised
11-Aug-15 oicl      [--same--]  revised
11-Aug-15 ordtype   [--same--]  revised
11-Aug-15 oiex      oiexg       revised
11-Aug-15 df-oi     [--same--]  revised
11-Aug-15 domssex2  [--same--]  hypothesis added
11-Aug-15 domss2    [--same--]  hypothesis added
11-Aug-15 en3       [--same--]  hypothesis added
11-Aug-15 en2       [--same--]  hypothesis added
11-Aug-15 en3d      [--same--]  hypothesis added
11-Aug-15 en2d      [--same--]  hypothesis added
11-Aug-15 ixpssmapg [--same--]  variables renamed
11-Aug-15 qsss      [--same--]  revised
11-Aug-15 uniqs2    [--same--]  revised
11-Aug-15 ereldmb   [--same--]  revised
11-Aug-15 ereldm    [--same--]  revised
11-Aug-15 erth2     [--same--]  revised
11-Aug-15 erth      [--same--]  revised
11-Aug-15 ecss      [--same--]  revised
11-Aug-15 erref     [--same--]  revised
11-Aug-15 tz7.44-3  [--same--]  revised
11-Aug-15 tz7.44-2  [--same--]  revised
11-Aug-15 tz7.44-1  [--same--]  revised
11-Aug-15 smoge     [--same--]  deleted; use smogt
11-Aug-15 fnwe      [--same--]  revised
11-Aug-15 weniso    [--same--]  revised
11-Aug-15 epne3     [--same--]  revised
11-Aug-15 fr3nr     [--same--]  revised
11-Aug-15 wereucl   ---         deleted; use wereu and reucl
11-Aug-15 efrn2lp   [--same--]  revised
11-Aug-15 fr2nr     [--same--]  revised
11-Aug-15 frirr     [--same--]  revised
11-Aug-15 frc       [--same--]  revised
11-Aug-15 dffr2     [--same--]  revised
 9-Aug-15 ---       ---         df-fbas, df-fg, df-fil, and df-fm revised.
                                Individual changes not noted; version with *OLD
                                is set.mm@5db2041
29-Jul-15 ax10      ax10from10o
29-Jul-15 ax9       ax9from9o
19-Jun-15 uvcf1     [--same--]  (in SO's mathbox) revised
19-Jun-15 pwssnf1o  [--same--]  moved from SO's mathbox to main set.mm
19-Jun-15 mapsnf1o  [--same--]  moved from SO's mathbox to main set.mm
19-Jun-15 ixpsnf1o  [--same--]  moved from SO's mathbox to main set.mm
19-Jun-15 elixpsn   [--same--]  moved from SO's mathbox to main set.mm
19-Jun-15 ---       ---         df-gim ~ lmicsym moved from SO's mathbox
                                to main set.mm
19-Jun-15 isfld     isfldOLD
19-Jun-15 df-zn     [--same--]  moved from MC's mathbox to main set.mm; revised
19-Jun-15 df-q2r    df-z2r      moved from MC's mathbox to main set.mm; revised
19-Jun-15 ---       ---         df-lgs ~ lgssq2 moved from MC's mathbox
                                to main set.mm
19-Jun-15 evlval    [--same--]  hypothesis removed
19-Jun-15 vr1val    [--same--]  hypothesis removed
19-Jun-15 df-evl1   [--same--]  revised
19-Jun-15 abvn0b    [--same--]  revised
19-Jun-15 isdomn2   [--same--]  revised
19-Jun-15 isdomn    [--same--]  revised
19-Jun-15 df-idom   [--same--]  revised
19-Jun-15 df-domn   [--same--]  revised
19-Jun-15 lsppropd  [--same--]  revised
19-Jun-15 lsspropd  [--same--]  revised
19-Jun-15 isrhmd    [--same--]  hypothesis reordered
19-Jun-15 unitdvcl  [--same--]  hypothesis removed
19-Jun-15 rngel1ne0 rngelznr    revised
19-Jun-15 eqgval    [--same--]  hypothesis removed
19-Jun-15 eqgval    [--same--]  hypothesis removed
19-Jun-15 mhmpropd  [--same--]  revised
19-Jun-15 fznn      [--same--]  revised
13-Jun-15 ---       ---         rlmfn ~ ply1pid moved from SO's mathbox
                                to main set.mm
13-Jun-15 ---       ---         strfvi ~ grpsubpropd moved from SO's mathbox
                                to main set.mm
13-Jun-15 ---       ---         pwsdiagel ~ pwsdiagrhm moved from SO's mathbox
                                to main set.mm
13-Jun-15 pwselbasb [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 ---       ---         sraval ~ issubrngd2 moved from SO's mathbox
                                to main set.mm
13-Jun-15 ---       ---         df-odu ~ mreclatdemo moved from SO's mathbox
                                to main set.mm
13-Jun-15 ---       ---         subsubrg2 ~ dvdsr02 moved from SO's mathbox
                                to main set.mm
13-Jun-15 gsumpt    [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 rngel1ne0 [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 suppfif1  [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 ---       ---         nnfi ~ suppssof1 moved from SO's mathbox
                                to main set.mm
13-Jun-15 ---       ---         fco2 ~ fvco4i moved from SO's mathbox
                                to main set.mm
13-Jun-15 fnfvof    [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 ---       ---         fneqeql ~ fncoeqres moved from SO's mathbox
                                to main set.mm
13-Jun-15 fnimaeq0  [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 supxrss   [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 rabun2    [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 elin3     [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 elin2     [--same--]  moved from SO's mathbox to main set.mm
13-Jun-15 ---       ---         rint0 ~ elrint2 moved from SO's mathbox
                                to main set.mm
13-Jun-15 wilth     [--same--]  moved from MC's mathbox to main set.mm
13-Jun-15 ---       ---         df-od ~ sylow3 moved from MC's mathbox
                                to main set.mm
13-Jun-15 grpinvpropd [--same--] revised
13-Jun-15 grpsubfval [--same--] revised
13-Jun-15 cardval2  [--same--]  revised
13-Jun-15 cardsdomel [--same--] revised
13-Jun-15 cardsdomel2 cardsdomel revised
13-Jun-15 coires1   [--same--]  revised
 4-Jun-15 tpaaa     tpidm       moved from DAW's mathbox to main set.mm
 4-Jun-15 tpabb     tpidm23     moved from DAW's mathbox to main set.mm
 4-Jun-15 tpaba     tpidm13     moved from DAW's mathbox to main set.mm
 4-Jun-15 tpaab     tpidm12     moved from DAW's mathbox to main set.mm
 4-Jun-15 ifnefalse [--same--]  moved from DAW's mathbox to main set.mm
 4-Jun-15 ptolemy   [--same--]  moved from DAW's mathbox to main set.mm
 4-Jun-15 cosmul    [--same--]  moved from DAW's mathbox to main set.mm
 4-Jun-15 sinmul    [--same--]  moved from DAW's mathbox to main set.mm
 4-Jun-15 dfac1     dfac3       moved from SO's mathbox to main set.mm
 4-Jun-15 dfac3     dfac9       moved from SO's mathbox to main set.mm
 4-Jun-15 dfaccard  dfac10      moved from SO's mathbox to main set.mm
 4-Jun-15 dfac10b   [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 axac      [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 dfac10    dfac10c     moved from SO's mathbox to main set.mm
 4-Jun-15 df-ac     [--same--]  moved from SO's mathbox to main set.mm; revised
 4-Jun-15 df-recs   [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 marypha2  [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 marypha1  [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 ---       ---         df-har ~ hsmex3 moved from SO's mathbox
                                to main set.mm
 4-Jun-15 domunfican [--same--] moved from SO's mathbox to main set.mm
 4-Jun-15 domunsncan [--same--] moved from SO's mathbox to main set.mm
 4-Jun-15 domdifsn  [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 wemoiso2  [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 wemoiso   [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 weniso    [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 fodomfi2  [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 fipreimaNEW fipreima  moved from SO's mathbox to main set.mm
 4-Jun-15 imafi     [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 f1ssr     [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 imainrect [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 f1eqcocnv [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 foeqcnvco [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 fococnv2  [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 fnunirn   [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 fvmpt3    [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 mpt20     [--same--]  moved from SO's mathbox to main set.mm; revised
 4-Jun-15 iunopab   [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 pwidg     [--same--]  moved from SO's mathbox to main set.mm
 4-Jun-15 uffixfr   [--same--]  moved from JGH's mathbox to main set.mm;revised
 4-Jun-15 ---       ---         df-ufil ~ ufildr moved from JH's mathbox
                                to main set.mm
 4-Jun-15 filfinnfr [--same--]  moved from JH's mathbox to main set.mm
 4-Jun-15 csdfil    [--same--]  moved from FL's mathbox to main set.mm
 4-Jun-15 rcfpfil   cfinfil     moved from FL's mathbox to main set.mm
 4-Jun-15 excxor    [--same--]  moved from FL's mathbox to main set.mm
 4-Jun-15 assxor    [--same--]  moved from FL's mathbox to main set.mm
 4-Jun-15 df-xor    [--same--]  moved from FL's mathbox to main set.mm
 4-Jun-15 ---       ---         lukshef-ax1 ~ re2luk3 moved from AH's mathbox
                                to main set.mm
 4-Jun-15 FFSid     falnanfal   moved from AH's mathbox to main set.mm
 4-Jun-15 FTSid     falnantru   moved from AH's mathbox to main set.mm
 4-Jun-15 TFSid     trunanfal   moved from AH's mathbox to main set.mm
 4-Jun-15 TTSid     trunantru   moved from AH's mathbox to main set.mm
 4-Jun-15 FFBid     falbifal    moved from AH's mathbox to main set.mm
 4-Jun-15 FTBid     falbitru    moved from AH's mathbox to main set.mm
 4-Jun-15 TFBid     trubifal    moved from AH's mathbox to main set.mm
 4-Jun-15 TTBid     trubitru    moved from AH's mathbox to main set.mm
 4-Jun-15 FNid      notfal      moved from AH's mathbox to main set.mm
 4-Jun-15 TNid      nottru      moved from AH's mathbox to main set.mm
 4-Jun-15 FFIid     falimfal    moved from AH's mathbox to main set.mm
 4-Jun-15 FTIid     falimtru    moved from AH's mathbox to main set.mm
 4-Jun-15 TFIid     truimfal    moved from AH's mathbox to main set.mm
 4-Jun-15 TTIid     truimtru    moved from AH's mathbox to main set.mm
 4-Jun-15 FFOid     falorfal    moved from AH's mathbox to main set.mm
 4-Jun-15 FTOid     falortru    moved from AH's mathbox to main set.mm
 4-Jun-15 TFOid     truorfal    moved from AH's mathbox to main set.mm
 4-Jun-15 TTOid     truortru    moved from AH's mathbox to main set.mm
 4-Jun-15 FFAid     falanfal    moved from AH's mathbox to main set.mm
 4-Jun-15 FTAid     falantru    moved from AH's mathbox to main set.mm
 4-Jun-15 TFAid     truanfal    moved from AH's mathbox to main set.mm
 4-Jun-15 TTAid     truantru    moved from AH's mathbox to main set.mm
 4-Jun-15 AiT       a1tru       moved from AH's mathbox to main set.mm
 4-Jun-15 FiA       falim       moved from AH's mathbox to main set.mm
 4-Jun-15 falvar    nbfal       moved from AH's mathbox to main set.mm
 4-Jun-15 truvar    tbtru       moved from AH's mathbox to main set.mm
 4-Jun-15 ordsucuniel [--same--] moved from SF's mathbox to main set.mm
 4-Jun-15 mpt2fun   [--same--]  moved from SF's mathbox to main set.mm
 4-Jun-15 ccnf      ccnfn
 4-Jun-15 ltbval    [--same--]  revised
 4-Jun-15 df-ltbag  [--same--]  revised
 4-Jun-15 pwcfsdom  [--same--]  revised
 4-Jun-15 zornn0    [--same--]  revised
 4-Jun-15 zorn      [--same--]  revised
 4-Jun-15 aceqkm    dfackm      revised
 4-Jun-15 aceq8     dfac8       revised
 4-Jun-15 aceq7     dfac7       revised
 4-Jun-15 aceq6     dfac2       revised
 4-Jun-15 aceq6a    dfac2a      revised
 4-Jun-15 aceq5     dfac5       revised
 4-Jun-15 aceq4     dfac4       revised
 4-Jun-15 aceq3     dfac3       revised
 4-Jun-15 alephfp   [--same--]  revised
 4-Jun-15 aceq8c    dfac8c
 4-Jun-15 aceq8b    dfac8b
 4-Jun-15 aceq8a    dfac8a
 4-Jun-15 ondomcard harcard     revised
 4-Jun-15 df-aleph  [--same--]  revised
 4-Jun-15 finsschain [--same--] revised
 4-Jun-15 fipreima  [--same--]  hypothesis removed
 4-Jun-15 oeworde   [--same--]  revised
 4-Jun-15 oeword    [--same--]  revised
 4-Jun-15 oecan     [--same--]  revised
 4-Jun-15 oeord     [--same--]  revised
 4-Jun-15 oeordi    [--same--]  revised
 4-Jun-15 omeu      [--same--]  revised
 4-Jun-15 oarec     [--same--]  revised
 4-Jun-15 rdgval    [--same--]  revised
 4-Jun-15 df-rdg    [--same--]  revised
 4-Jun-15 tfr3      [--same--]  revised
 4-Jun-15 tfr2      [--same--]  revised
 4-Jun-15 tfr1      [--same--]  revised
 4-Jun-15 notfal    fal
 4-Jun-15 nic-justbi nanbi
 4-Jun-15 nic-justneg nannot
 4-Jun-15 nic-justim nanim
 4-Jun-15 nic-justlem nannan
 4-Jun-15 df-nand   df-nan
 4-Jun-15 wnand     wnan
23-May-15 grpinvnzcl [--same--] moved from SO's mathbox to main set.mm
23-May-15 grpinvnz  [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 dihopellsm [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 xihopellsmN [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 dihopcl   [--same--]  (in NM's mathbox) hypothesis removed
 7-May-15 dihopelvalbN [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 diblsmopel [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 dibopelval3 [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 dibopelval2 [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 dibopelvalN [--same--] (in NM's mathbox) hypothesis removed
 7-May-15 df-ocomp  [--same--]  (in NM's mathbox) revised
 7-May-15 phlfun    [--same--]  (in NM's mathbox) revised
 7-May-15 phlfn     [--same--]  (in NM's mathbox) revised
 7-May-15 srngfn    [--same--]  (in NM's mathbox) revised
 7-May-15 bnj96     [--same--]  (in JB's mathbox) hypothesis added
 7-May-15 bnj536    [--same--]  (in JB's mathbox) hypothesis removed
 7-May-15 bnj142    [--same--]  (in JB's mathbox) hypothesis removed
 7-May-15 bnj136    [--same--]  (in JB's mathbox) hypothesis removed
 7-May-15 addcomgi  [--same--]  (in AS's mathbox) hypothesis removed
 7-May-15 lmiclbs   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmimlbs   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmmmlem   ---         (in SO's mathbox) deleted; use lmhmlmod2
 7-May-15 lnmlmic   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lnmepi    [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmhmfgima [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 kercvrlsm [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmicsym   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmimcnv   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmimf1o   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 islmim    [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 gicsubgen [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 gicen     [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 gimcnv    [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 lmhmf1o   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 subggim   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 gimf1o    [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 isgim     [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 gimlem2   ---         (in SO's mathbox) deleted
 7-May-15 elovmpt2  [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 infpssALT [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 infpssen1 [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 infpssr   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 fidomtri2 [--same--]  moved from SO's mathbox to main set.mm; revised
 7-May-15 pw2f1oval2 [--same--] (in SO's mathbox) hypothesis removed
 7-May-15 pw2f1oval [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 mapfzcons2 [--same--] (in SO's mathbox) hypothesis removed
 7-May-15 mapfzcons1cl [--same--] (in SO's mathbox) hypothesis removed
 7-May-15 mapfzcons1 [--same--] (in SO's mathbox) hypothesis removed
 7-May-15 elmapssres [--same--] (in SO's mathbox) hypothesis removed
 7-May-15 mapco2    [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 mapco2g   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 elmapex2  ---         (in SO's mathbox) deleted
 7-May-15 constmap  [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 xpwdomg   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 unwdomg   [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 brwdom3i  [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 wdomndom  ---         (in SO's mathbox) deleted; use brrelex12
 7-May-15 brwdomn0  [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 numth3    [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 isnum2    [--same--]  moved from SO's mathbox to main set.mm; hyp rem
 7-May-15 isghmd    [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 difsnen   [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fsnunres  [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fsnunfv   [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fsnunf2   [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fsnunf    [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fnsnsplit [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 ralxpmap  [--same--]  (in SO's mathbox) hypothesis removed
 7-May-15 reldmmap  [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fconst6g  [--same--]  moved from SO's mathbox to main set.mm
 7-May-15 fconst6   [--same--]  moved from JM's mathbox to main set.mm
 7-May-15 xrletr2   [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 mlteqer   [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 csdfil    [--same--]  (in FL's mathbox) revised
 7-May-15 curgrpact [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 rngapm    [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 gapm2     [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 nfwpr4c   [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 prltub    [--same--]  (in FL's mathbox) hypothesis removed
 7-May-15 domtri2   domtri3     (in FL's mathbox)
 7-May-15 brtxp2    [--same--]  (in SF's mathbox) hypothesis removed
 7-May-15 predfz    [--same--]  (in SF's mathbox) hypothesis removed
 7-May-15 brtp      [--same--]  (in SF's mathbox) hypothesis removed
 7-May-15 epelg     [--same--]  moved from SF's mathbox to main set.mm
 7-May-15 epelcNEW  epelc       moved from SF's mathbox to main set.mm
 7-May-15 eupath    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupath2   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupap1    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupares   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupaseg   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupapf    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupafi    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupaf1o   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupacl    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 eupai     [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 iseupa    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgraun   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgrares  [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgraex   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgrafi   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgrale   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgran0   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgrass   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgraf    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 umgraf2   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmfo     [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmlift   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmliftmo [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmliftmoi [--same--] (in MC's mathbox) hypothesis removed
 7-May-15 cvmsiota  [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmseu    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmscld   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmsf1o   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmcov    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 cvmtop2   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 iscvm     [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 sylow2    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 slwhash   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 slwpgp    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 slwpss    [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 slwispgp  [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 slwsubg   [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 isslw     [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 ispgp     [--same--]  (in MC's mathbox) hypothesis removed
 7-May-15 hlimunii  hlimuni     hypothesis removed
 7-May-15 hlimadd   [--same--]  hypothesis removed
 7-May-15 hvsubopr  hbsubf
 7-May-15 bpos1     [--same--]  revised
 7-May-15 logcnss   logdmss
 7-May-15 itgulm    [--same--]  hypothesis removed
 7-May-15 mbfulm    [--same--]  hypothesis removed
 7-May-15 ulmdv     [--same--]  hypothesis removed
 7-May-15 ulmcn     [--same--]  hypothesis removed
 7-May-15 ulmbdd    [--same--]  hypothesis removed
 7-May-15 ulmss     [--same--]  hypothesis removed
 7-May-15 ulmshft   [--same--]  hypothesis removed
 7-May-15 ulmres    [--same--]  hypothesis removed
 7-May-15 ulmclm    [--same--]  hypothesis removed
 7-May-15 ulmi      [--same--]  hypothesis removed
 7-May-15 ulmcl     [--same--]  hypothesis removed
 7-May-15 ulmval    [--same--]  revised
 7-May-15 dvlm      [--same--]  hypothesis removed
 7-May-15 dvcl      [--same--]  hypothesis removed
 7-May-15 eldv      [--same--]  hypothesis removed
 7-May-15 mbflim    [--same--]  hypothesis removed
 7-May-15 cncfco    [--same--]  hypothesis removed
 7-May-15 climcncf  [--same--]  hypothesis removed
 7-May-15 cncffvrn  [--same--]  revised
 7-May-15 rescncf   [--same--]  hypothesis removed
 7-May-15 cncfi     [--same--]  hypothesis removed
 7-May-15 cncff     [--same--]  hypothesis removed
 7-May-15 cncfrss2  [--same--]  hypothesis removed
 7-May-15 nvlmcl    [--same--]  hypothesis removed
 7-May-15 nvvcop    [--same--]  revised
 7-May-15 nvss      [--same--]  revised
 7-May-15 caublcls  [--same--]  hypothesis removed
 7-May-15 metelcls  [--same--]  hypothesis removed
 7-May-15 lmclimf   [--same--]  hypothesis removed
 7-May-15 lmclim    [--same--]  hypothesis removed
 7-May-15 lmle      [--same--]  hypothesis removed
 7-May-15 lmmbrf    [--same--]  hypothesis removed
 7-May-15 lmmcvg    [--same--]  hypothesis removed
 7-May-15 lmmbr3    [--same--]  hypothesis removed
 7-May-15 lmmbr2    [--same--]  hypothesis removed
 7-May-15 lmmbr     [--same--]  hypothesis removed
 7-May-15 lincmb01icc icccvx
 7-May-15 resubtop  rerest
 7-May-15 subtopmet metrest
 7-May-15 qtopsubsp qtoprest
 7-May-15 lmcn2     [--same--]  hypothesis removed
 7-May-15 txlm      [--same--]  hypothesis removed
 7-May-15 txsubsp   txrest
 7-May-15 hauspwdom [--same--]  revised
 7-May-15 1stcelcls [--same--]  hypothesis removed
 7-May-15 lly1stc   [--same--]  revised
 7-May-15 nllyidm   [--same--]  revised
 7-May-15 llyidm    [--same--]  revised
 7-May-15 nllysubsp nllyrest
 7-May-15 llysubsp  llyrest
 7-May-15 subsplly  restlly
 7-May-15 subspnlly restnlly
 7-May-15 2ndcsubsp 2ndcrest
 7-May-15 1stcsubsp 1stcrest
 7-May-15 lmmo      [--same--]  hypothesis removed
 7-May-15 subsphaus resthaus
 7-May-15 lmcn      [--same--]  hypothesis removed
 7-May-15 lmcld     [--same--]  hypothesis removed
 7-May-15 lmcls     [--same--]  hypothesis removed
 7-May-15 lmres     [--same--]  hypothesis removed
 7-May-15 lmcl      [--same--]  hypothesis removed
 7-May-15 lmfss     [--same--]  hypothesis removed
 7-May-15 lmfpm     [--same--]  hypothesis removed
 7-May-15 cnpsubsp2 cnprest2
 7-May-15 cnpsubsp  cnprest
 7-May-15 cnpsubspi cnpresti
 7-May-15 cnsubsp2r cnrest2r
 7-May-15 cnsubsp2  cnrest2
 7-May-15 cnsubsp   cnrest
 7-May-15 lmbrf     [--same--]  hypothesis removed
 7-May-15 lmbr2     [--same--]  hypothesis removed
 7-May-15 lmbr      [--same--]  hypothesis removed
 7-May-15 subntr    restntr
 7-May-15 subcls    restcls
 7-May-15 subspdis  restdis
 7-May-15 subspsubbas restsubbas
 7-May-15 tgsubsp   tgrest
 7-May-15 subspopn2 restopn2
 7-May-15 sssubsp   ssrest      hypothesis removed
 7-May-15 subspopnb restopnb
 7-May-15 subspcld2 restcldr
 7-May-15 subspcld  restcldi
 7-May-15 subcld    restcld
 7-May-15 subspsn2  restsn2
 7-May-15 subspsn   restsn
 7-May-15 subsp0    rest0
 7-May-15 subspuni2 restuni2
 7-May-15 subspint  restin      hypothesis generalized
 7-May-15 subsubtop restabs     hypothesis generalized
 7-May-15 subspco   restco      revised
 7-May-15 stoig     [--same--]  revised
 7-May-15 subspuni  restuni     revised
 7-May-15 subsptop  resttop
 7-May-15 subsprcl  restrcl     revised
 7-May-15 subspid   restid      hypothesis generalized
 7-May-15 elsubspr  elrestr     hypothesis generalized
 7-May-15 elsubsp   elrest      hypothesis generalized
 7-May-15 subspval  restval     hypothesis generalized
 7-May-15 df-subsp  df-rest     arguments were swapped; revisions due to the
                                new form factor are not noted
 7-May-15 csubsp    crest
 7-May-15 reslmhm   [--same--]  hypothesis removed
 7-May-15 lmhmkerlss [--same--] hypothesis removed
 7-May-15 lmhmrnlss [--same--]  hypothesis removed
 7-May-15 lmhmlsp   [--same--]  hypothesis removed
 7-May-15 lmhmima   [--same--]  hypothesis removed
 7-May-15 lmhmlin   [--same--]  hypothesis removed
 7-May-15 lmhmf     [--same--]  hypothesis removed
 7-May-15 lmhmlmod2 [--same--]  hypothesis removed
 7-May-15 lmhmsca   [--same--]  hypothesis removed
 7-May-15 islmhm2   [--same--]  hypothesis removed
 7-May-15 islmhm    [--same--]  hypothesis removed
 7-May-15 dvdsrneg  [--same--]  revised
 7-May-15 dvdsrmul1 [--same--]  revised
 7-May-15 dvdsrid   [--same--]  revised
 7-May-15 dvdsr2    [--same--]  hypothesis removed
 7-May-15 dvdsr     [--same--]  hypothesis removed
 7-May-15 dvdsrval  [--same--]  hypothesis removed
 7-May-15 gsumhomo  ---         deleted; use gsummhm
 7-May-15 lactghmga [--same--]  hypothesis removed
 7-May-15 galactghm [--same--]  hypothesis removed
 7-May-15 orbsta2   [--same--]  hypothesis removed
 7-May-15 orbsta    [--same--]  hypothesis removed
 7-May-15 orbstaval [--same--]  hypothesis removed
 7-May-15 orbstaeu  [--same--]  hypothesis removed
 7-May-15 gastacos  [--same--]  hypothesis removed
 7-May-15 gastacl   [--same--]  hypothesis removed
 7-May-15 gaorber   [--same--]  hypothesis removed
 7-May-15 gaorb     [--same--]  hypothesis removed
 7-May-15 gapm      [--same--]  hypothesis removed
 7-May-15 gacan     [--same--]  hypothesis removed
 7-May-15 galcan    [--same--]  hypothesis removed
 7-May-15 gasubg    [--same--]  hypothesis removed
 7-May-15 gass      [--same--]  hypothesis removed
 7-May-15 gaass     [--same--]  hypothesis removed
 7-May-15 gafo      [--same--]  hypothesis removed
 7-May-15 gaf       [--same--]  hypothesis removed
 7-May-15 gagrpid   [--same--]  hypothesis removed
 7-May-15 isga      [--same--]  hypothesis removed
 7-May-15 ghmf1o    [--same--]  hypothesis removed
 7-May-15 ghmf1     [--same--]  hypothesis removed
 7-May-15 ghmeqker  [--same--]  hypothesis removed
 7-May-15 ghmker    [--same--]  hypothesis removed
 7-May-15 ghmsub    [--same--]  hypothesis removed
 7-May-15 ghmima    [--same--]  hypothesis removed
 7-May-15 resghm    [--same--]  hypothesis removed
 7-May-15 ghmrn     [--same--]  hypothesis removed
 7-May-15 ghminv    [--same--]  hypothesis removed
 7-May-15 ghmid     [--same--]  hypothesis removed
 7-May-15 ghmlin    [--same--]  hypothesis removed
 7-May-15 ghmgrp2   [--same--]  hypothesis removed
 7-May-15 ghmf      [--same--]  hypothesis removed
 7-May-15 isghm2    ---         deleted; use isghm
 7-May-15 isghm     [--same--]  hypothesis removed
 7-May-15 spwpr4c   [--same--]  hypothesis removed
 7-May-15 spwpr4    [--same--]  hypothesis removed
 7-May-15 prdmvalfun [--same--] revised
 7-May-15 posfn     [--same--]  revised
 7-May-15 tpsfn     [--same--]  revised
 7-May-15 ressvsca  [--same--]  hypothesis added
 7-May-15 resssca   [--same--]  hypothesis added
 7-May-15 algfun    [--same--]  revised
 7-May-15 algfn     [--same--]  revised
 7-May-15 lmodfun   [--same--]  revised
 7-May-15 lmodfn    [--same--]  revised
 7-May-15 ressmulr  [--same--]  hypothesis added
 7-May-15 rngfn     [--same--]  revised
 7-May-15 ressplusg [--same--]  hypothesis added
 7-May-15 grpfn     [--same--]  revised
 7-May-15 strlemor3 [--same--]  revised
 7-May-15 strlemor2 [--same--]  revised
 7-May-15 strlemor1 [--same--]  revised
 7-May-15 strlemor0 [--same--]  revised
 7-May-15 df-ds     [--same--]  revised
 7-May-15 resslem2  ---         deleted
 7-May-15 resslem   [--same--]  revised
 7-May-15 strfvd    [--same--]  hypothesis removed
 7-May-15 strfv     [--same--]  hypothesis removed
 7-May-15 setscom   [--same--]  hypothesis added
 7-May-15 setsabs   [--same--]  hypothesis added
 7-May-15 setsval   [--same--]  hypothesis added
 7-May-15 --        ---         11prm ~ 4001prm revised for base 10
 7-May-15 gcdi      [--same--]  revised
 7-May-15 modsubi   [--same--]  revised
 7-May-15 mod2xnegi [--same--]  revised
 7-May-15 modxp1i   [--same--]  revised
 7-May-15 mod2xi    [--same--]  revised
 7-May-15 modxai    [--same--]  revised
 7-May-15 --        ---         dec2dvds1 ~ dec2nprm revised for base 10
 7-May-15 iserodd   [--same--]  revised
 7-May-15 maxprmfct [--same--]  revised
 7-May-15 nprmi     [--same--]  revised
 7-May-15 1nprm     [--same--]  revised
 7-May-15 algrflem  [--same--]  hypothesis added
 7-May-15 ndvdsi    [--same--]  revised
 7-May-15 climfsum  [--same--]  hypothesis removed
 7-May-15 cvgcmpub  [--same--]  hypothesis removed
 7-May-15 iserabs   [--same--]  hypothesis removed
 7-May-15 isumclim  [--same--]  hypothesis removed
 7-May-15 climim    [--same--]  hypothesis removed
 7-May-15 climre    [--same--]  hypothesis removed
 7-May-15 climcj    [--same--]  hypothesis removed
 7-May-15 climabs   [--same--]  hypothesis removed
 7-May-15 isercoll2 [--same--]  hypothesis removed
 7-May-15 isercoll  [--same--]  hypothesis removed
 7-May-15 isershft  [--same--]  hypothesis removed
 7-May-15 iserle    [--same--]  hypothesis removed
 7-May-15 isermulc2 [--same--]  hypothesis removed
 7-May-15 iserex    [--same--]  hypothesis removed
 7-May-15 clim2ser2 [--same--]  hypothesis removed
 7-May-15 clim2ser  [--same--]  hypothesis removed
 7-May-15 rlimdiv   [--same--]  hypothesis removed
 7-May-15 rlimmul   [--same--]  hypothesis removed
 7-May-15 rlimsub   [--same--]  hypothesis removed
 7-May-15 rlimadd   [--same--]  hypothesis removed
 7-May-15 climsqz2  [--same--]  hypothesis removed
 7-May-15 climsqz   [--same--]  hypothesis removed
 7-May-15 climle    [--same--]  hypothesis removed
 7-May-15 climsubc2 [--same--]  hypothesis removed
 7-May-15 climsubc1 [--same--]  hypothesis removed
 7-May-15 climmulc2 [--same--]  hypothesis removed
 7-May-15 climaddc2 [--same--]  hypothesis removed
 7-May-15 climaddc1 [--same--]  hypothesis removed
 7-May-15 climsub   [--same--]  hypothesis removed
 7-May-15 climmul   [--same--]  hypothesis removed
 7-May-15 climadd   [--same--]  hypothesis removed
 7-May-15 climrecl  [--same--]  hypothesis removed
 7-May-15 climshft2 [--same--]  hypothesis removed
 7-May-15 climshft  [--same--]  hypothesis removed
 7-May-15 climres   [--same--]  hypothesis removed
 7-May-15 climmpt2  [--same--]  hypothesis removed
 7-May-15 2clim     [--same--]  hypothesis removed
 7-May-15 climmpt   [--same--]  hypothesis removed
 7-May-15 rlimeq    [--same--]  hypothesis removed
 7-May-15 climeq    [--same--]  hypothesis removed
 7-May-15 rlimuni   [--same--]  hypothesis removed
 7-May-15 rlimresb  [--same--]  hypothesis removed
 7-May-15 rlimres2  [--same--]  hypothesis removed
 7-May-15 rlimres   [--same--]  hypothesis removed
 7-May-15 climreu   [--same--]  hypothesis removed
 7-May-15 climeu    [--same--]  hypothesis removed
 7-May-15 climuni   [--same--]  hypothesis removed
 7-May-15 rlimi     [--same--]  hypothesis removed
 7-May-15 climi2    [--same--]  hypothesis removed
 7-May-15 climi     [--same--]  hypothesis removed
 7-May-15 clim2     [--same--]  hypothesis removed
 7-May-15 rlimcl    [--same--]  hypothesis removed
 7-May-15 climcl    [--same--]  hypothesis removed
 7-May-15 rlim      [--same--]  hypothesis removed
 7-May-15 clim      [--same--]  hypothesis removed
 7-May-15 seqcoll2  [--same--]  hypothesis removed
 7-May-15 hashfacen [--same--]  hypothesis removed
 7-May-15 hashdom   [--same--]  hypothesis generalized
 7-May-15 hasheni   [--same--]  hypothesis removed
 7-May-15 hashinf   [--same--]  revised
 7-May-15 permnn    [--same--]  hypothesis removed
 7-May-15 bccl2     [--same--]  hypothesis removed
 7-May-15 bcp1nk    [--same--]  hypothesis removed
 7-May-15 bcp1n     [--same--]  hypothesis removed
 7-May-15 bcm1k     [--same--]  hypothesis removed
 7-May-15 bcrpcl    [--same--]  hypothesis removed
 7-May-15 bcval2    [--same--]  hypothesis removed
 7-May-15 fseqsupubi [--same--] hypothesis removed
 7-May-15 fsequb2   [--same--]  hypothesis removed
 7-May-15 fsequb    [--same--]  hypothesis removed
 7-May-15 fznuz     [--same--]  hypothesis removed
 7-May-15 fz2ex     ---         deleted
 7-May-15 fzrev3i   [--same--]  hypothesis removed
 7-May-15 fzrev3    [--same--]  hypothesis removed
 7-May-15 fzrev2i   [--same--]  hypothesis removed
 7-May-15 fzp1disj  [--same--]  hypothesis removed
 7-May-15 fzelp1i   ---         deleted; use fzelp1
 7-May-15 fzp1elp1  [--same--]  hypothesis removed
 7-May-15 fzelp1    [--same--]  hypothesis removed
 7-May-15 fzp1ss    [--same--]  hypothesis removed
 7-May-15 fzssp1    [--same--]  hypothesis removed
 7-May-15 fzss1     [--same--]  hypothesis removed
 7-May-15 fzopth    [--same--]  hypothesis removed
 7-May-15 fznn0sub2 [--same--]  hypothesis removed
 7-May-15 fznn0sub  [--same--]  hypothesis removed
 7-May-15 elfz3nn0  [--same--]  hypothesis removed
 7-May-15 elfz2nn0  [--same--]  hypothesis removed
 7-May-15 fzdisj    [--same--]  hypothesis removed
 7-May-15 fzsplit   [--same--]  hypothesis removed
 7-May-15 fzn0      [--same--]  revised
 7-May-15 peano2fzr [--same--]  hypothesis removed
 7-May-15 elfzuz2   [--same--]  hypothesis removed
 7-May-15 elfzle3   [--same--]  hypothesis removed
 7-May-15 elfzel2g  ---         deleted; use elfzel2
 7-May-15 elfzel2i  elfzel2     hypothesis removed
 7-May-15 elfzuz3   [--same--]  hypothesis removed
 7-May-15 elfzuzb   [--same--]  hypothesis removed
 7-May-15 elfz2     [--same--]  hypothesis removed
 7-May-15 iccss2    [--same--]  hypothesis removed
 7-May-15 iccssioo  [--same--]  hypothesis removed
 7-May-15 iccss     [--same--]  hypothesis removed
 7-May-15 elioo4g   [--same--]  hypothesis removed
 7-May-15 iooss2    [--same--]  hypothesis removed
 7-May-15 iooss1    [--same--]  hypothesis removed
 7-May-15 elioo3g   [--same--]  hypothesis removed
 7-May-15 ixxss12   [--same--]  hypothesis removed
 7-May-15 ixxss2    [--same--]  hypothesis removed
 7-May-15 ixxss1    [--same--]  hypothesis removed
 7-May-15 ixxssixx  [--same--]  revised
 7-May-15 elixx3g   [--same--]  hypothesis removed
 7-May-15 uzsupss   [--same--]  revised
 7-May-15 0p1e1     1e0p1
 7-May-15 ---       ---         deccl ~ decbin3 revised for base 10
 7-May-15 znn0sub2  ---         deleted; use znn0sub or uznn0sub
 7-May-15 lt01      0lt1
 7-May-15 subopr    subf
 7-May-15 ax-ltxr   [--same--]  revised
 7-May-15 ax-mulopr ax-mulf
 7-May-15 ax-addopr ax-addf
 7-May-15 axmulopr  axmulf
 7-May-15 axaddopr  axaddf
 7-May-15 ---       ---         addcompi ~ ltresr: hypothesis removed
 7-May-15 fodomnumg ---         deleted; use fodomnum
 7-May-15 tskwe2    [--same--]  revised
 7-May-15 unictb    [--same--]  hypothesis removed
 7-May-15 iunctb    [--same--]  hypothesis removed
 7-May-15 infpss    [--same--]  hypothesis removed
 7-May-15 infmap1   [--same--]  deleted; use mappwen
 7-May-15 infxpidm  [--same--]  hypothesis removed
 7-May-15 carddomi  ---         deleted; use carddomi2 or carddom
 7-May-15 cardid    [--same--]  hypothesis added
 7-May-15 cardval   [--same--]  hypothesis added
 7-May-15 brdom4    [--same--]  hypothesis removed
 7-May-15 brdom5    [--same--]  hypothesis removed
 7-May-15 brdom3    [--same--]  hypothesis removed
 7-May-15 fodomb    [--same--]  hypothesis removed
 7-May-15 numth2    [--same--]  hypothesis added
 7-May-15 infmap2   infmap      hypothesis removed
 7-May-15 infxp     [--same--]  revised
 7-May-15 csdfillem infunsdom1  revised
 7-May-15 infxpabs  [--same--]  revised
 7-May-15 infxpdom  [--same--]  revised
 7-May-15 infdif2   [--same--]  revised
 7-May-15 infdif    [--same--]  revised
 7-May-15 infcda    [--same--]  revised
 7-May-15 infunabs  [--same--]  revised
 7-May-15 infcdaabs [--same--]  revised
 7-May-15 cardacda  [--same--]  revised
 7-May-15 cdainf    [--same--]  hypothesis removed
 7-May-15 cdadom3   [--same--]  revised: sethood antecedent
 7-May-15 cdadom2   [--same--]  hypothesis removed
 7-May-15 cdadom1   [--same--]  hypothesis removed
 7-May-15 mapcdaen  [--same--]  revised: sethood antecedent
 7-May-15 xpcdaen   [--same--]  revised: sethood antecedent
 7-May-15 cdaassen  [--same--]  revised: sethood antecedent
 7-May-15 cdacomen  [--same--]  hypothesis removed
 7-May-15 xp2cda    [--same--]  revised: sethood antecedent
 7-May-15 xp1en     [--same--]  revised: sethood antecedent
 7-May-15 cda0en    [--same--]  revised: sethood antecedent
 7-May-15 cdaeng    ---         deleted; use cdaen
 7-May-15 cdaen     [--same--]  hypothesis removed
 7-May-15 cdaung    cdaun
 7-May-15 cdaung    cdaun
 7-May-15 cda2en    [--same--]  revised: sethood antecedent
 7-May-15 cdaun     [--same--]  revised: sethood antecedent
 7-May-15 uncdadom  [--same--]  revised: sethood antecedent
 7-May-15 cdavali   [--same--]  deleted; use cdaval
 7-May-15 fodomnum  [--same--]  revised
 7-May-15 onssnum   [--same--]  revised
 7-May-15 ondomen   [--same--]  revised
 7-May-15 ween      [--same--]  revised
 7-May-15 aceq8b    [--same--]  revised
 7-May-15 aceq8a    [--same--]  revised
 7-May-15 mappwen   [--same--]  revised
 7-May-15 infxpidm2 [--same--]  revised
 7-May-15 fidomtri  [--same--]  hypothesis added
 7-May-15 ficardsdom cardsdom2  revised
 7-May-15 ficarddom carddom2    revised
 7-May-15 ficarden  carden2     revised
 7-May-15 carddom2  [--same--]  revised
 7-May-15 carddomi2 [--same--]  revised
 7-May-15 carden2b  [--same--]  hypothesis removed
 7-May-15 cardnueq0 [--same--]  revised
 7-May-15 cardid2   [--same--]  revised
 7-May-15 cardval3b ---         deleted; use ndmfv
 7-May-15 cardval3a ---         deleted; use cardval3
 7-May-15 cardval3  [--same--]  revised
 7-May-15 isfinite3 isfinite
 7-May-15 card2inf  [--same--]  hypothesis added
 7-May-15 fisup2g   fisupcl
 7-May-15 unbnn2    [--same--]  revised
 7-May-15 unbnn     [--same--]  revised
 7-May-15 f1finf1o  [--same--]  revised
 7-May-15 isfinite1 isfiniteg   revised
 7-May-15 omsdomnn  nnsdomg     revised
 7-May-15 unxpdom2  [--same--]  hypothesis removed
 7-May-15 0sdom1dom [--same--]  hypothesis removed
 7-May-15 sucdom    [--same--]  hypothesis removed
 7-May-15 sucdom2   [--same--]  hypothesis removed
 7-May-15 ssenen    [--same--]  hypothesis removed
 7-May-15 mapunen   [--same--]  revised: sethood antecedent
 7-May-15 mapxpen   [--same--]  revised: sethood antecedent
 7-May-15 mapdom2   [--same--]  hypothesis removed
 7-May-15 mapdom1   [--same--]  hypothesis removed
 7-May-15 mapen     [--same--]  hypothesis removed
 7-May-15 xpnum     [--same--]  revised
 7-May-15 xpeng     [--same--]  deleted; use xpen
 7-May-15 xpen      [--same--]  hypothesis removed
 7-May-15 tskwe     [--same--]  revised
 7-May-15 domssex   [--same--]  hypothesis removed
 7-May-15 fodomr    [--same--]  hypothesis removed
 7-May-15 onenon    [--same--]  revised
 7-May-15 sdomen2   [--same--]  hypothesis removed
 7-May-15 sdomen1   [--same--]  hypothesis removed
 7-May-15 domen2    [--same--]  hypothesis removed
 7-May-15 domen1    [--same--]  hypothesis removed
 7-May-15 enen2     [--same--]  hypothesis removed
 7-May-15 enen1     [--same--]  hypothesis removed
 7-May-15 sdomex    ---         deleted; use brrelex12
 7-May-15 sdomentr  [--same--]  hypothesis removed
 7-May-15 sdomdomtr [--same--]  hypothesis removed
 7-May-15 0dom      [--same--]  hypothesis added
 7-May-15 sbthbg    sbthb       hypothesis removed
 7-May-15 xpdom3    [--same--]  hypothesis added
 7-May-15 xpdom1    [--same--]  hypothesis removed
 7-May-15 xpdom1g   [--same--]  hypothesis removed
 7-May-15 xpdom2    [--same--]  hypothesis removed
 7-May-15 undom     [--same--]  hypothesis removed
 7-May-15 finnum    [--same--]  revised
 7-May-15 map1      [--same--]  revised: sethood antecedent
 7-May-15 mapsnen   [--same--]  hypothesis added
 7-May-15 2dom      [--same--]  hypothesis removed
 7-May-15 entr4i    [--same--]  hypothesis removed
 7-May-15 entr3i    [--same--]  hypothesis removed
 7-May-15 entr2i    [--same--]  hypothesis removed
 7-May-15 ensymi    [--same--]  hypothesis removed
 7-May-15 ensym     [--same--]  hypothesis removed
 7-May-15 ensymg    ---         deleted; use ensym
 7-May-15 ssdom2g   ssdomg
 7-May-15 ssdomg    [--same--]  revised
 7-May-15 dom3      dom2
 7-May-15 dom2      [--same--]  revised
 7-May-15 dom3d     dom2d
 7-May-15 dom2d     [--same--]  revised
 7-May-15 f1dom     [--same--]  revised
 7-May-15 f1dom2g   f1domg
 7-May-15 f1domg    [--same--]  revised
 7-May-15 bren      [--same--]  hypothesis removed
 7-May-15 breng     ---         deleted; use bren
 7-May-15 ixpssmap  [--same--]  hypothesis removed
 7-May-15 ixpssmapg [--same--]  hypothesis removed
 7-May-15 mapss     [--same--]  revised: sethood antecedent
 7-May-15 map0b     [--same--]  hypothesis removed
 7-May-15 map0e     [--same--]  revised: sethood antecedent
 7-May-15 mapsspw   [--same--]  hypothesis removed
 7-May-15 pmresg    [--same--]  hypothesis removed
 7-May-15 elmapi    [--same--]  hypothesis removed
 7-May-15 elmapex1  elmapex     revised
 7-May-15 eceqoveq  [--same--]  hypothesis removed
 7-May-15 ecopovtrn [--same--]  hypothesis removed
 7-May-15 ecopovsym [--same--]  hypothesis removed
 7-May-15 brecop2   [--same--]  hypothesis removed
 7-May-15 errsym    [--same--]  hypothesis removed
 7-May-15 curry2val [--same--]  hypothesis removed
 7-May-15 curry1val [--same--]  hypothesis removed
 7-May-15 eqop      [--same--]  hypothesis removed
 7-May-15 ot2ndg    [--same--]  hypothesis added
 7-May-15 ot1stg    [--same--]  hypothesis added
 7-May-15 op1stg    [--same--]  hypothesis added
 7-May-15 op1st     [--same--]  hypothesis added
 7-May-15 caovmo    [--same--]  hypothesis removed
 7-May-15 ndmovordi [--same--]  hypothesis removed
 7-May-15 ndmovord  [--same--]  hypothesis removed
 7-May-15 ndmovdistr [--same--] hypothesis removed
 7-May-15 ndmovass  [--same--]  hypothesis removed
 7-May-15 ndmovcom  [--same--]  hypothesis removed
 7-May-15 ndmovrcl  [--same--]  hypothesis removed
 7-May-15 ndmov     [--same--]  hypothesis removed
 7-May-15 ndmovcl   [--same--]  revised
 7-May-15 ndmovg    [--same--]  hypothesis removed
 7-May-15 fnopovb   fnotovb     revised; hypothesis removed
 7-May-15 ovprc2if  ---         deleted
 7-May-15 ovprc2    [--same--]  revised
 7-May-15 fvopab3   fvopab3g    revised: sethood antecedent
 7-May-15 fniniseg  [--same--]  hypothesis removed
 7-May-15 funbrfv2bg funbrfv2b  hypothesis removed
 7-May-15 funbrfvbg ---         deleted; use funbrfvb
 7-May-15 funopfvb  [--same--]  hypothesis removed
 7-May-15 funbrfvb  [--same--]  hypothesis removed
 7-May-15 fnbrfvb   [--same--]  hypothesis removed
 7-May-15 fnbrfvbg  ---         deleted; use fnbrfvb
 7-May-15 funopfvg  ---         deleted; use funopfv
 7-May-15 funopfv   [--same--]  hypothesis removed
 7-May-15 funbrfv   [--same--]  hypothesis removed
 7-May-15 opelf     [--same--]  hypothesis added
 7-May-15 fnunsn    [--same--]  hypothesis added; deduction form
 7-May-15 fntp      [--same--]  hypothesis added
 7-May-15 fnprg     [--same--]  hypothesis added
 7-May-15 fnsn      [--same--]  hypothesis added
 7-May-15 funtp     [--same--]  hypothesis added
 7-May-15 funpr     [--same--]  hypothesis added
 7-May-15 funprg    [--same--]  hypothesis added
 7-May-15 funsng    [--same--]  hypothesis added
 7-May-15 funsn     [--same--]  hypothesis added
 7-May-15 funopg    [--same--]  hypothesis added
 7-May-15 rnsnop    [--same--]  hypothesis removed
 7-May-15 cnvsn     [--same--]  hypothesis added
 7-May-15 op1sta    [--same--]  hypothesis added
 7-May-15 dmtpop    [--same--]  hypothesis added
 7-May-15 dmprop    [--same--]  hypothesis added
 7-May-15 dmsnop    [--same--]  hypothesis added
 7-May-15 irrexi    ---         deleted; use brrelex12
 7-May-15 relelrng  [--same--]  hypothesis removed
 7-May-15 breldmg   [--same--]  hypothesis added
 7-May-15 breldm    [--same--]  hypothesis added
 7-May-15 opeldm    [--same--]  hypothesis added
 7-May-15 issetid   [--same--]  revised
 7-May-15 opelxpex2 ---         deleted; use opelxp2
 7-May-15 opeliunxp2 [--same--] hypothesis removed
 7-May-15 relsnop   [--same--]  hypothesis added
 7-May-15 brinxp2   [--same--]  hypothesis removed
 7-May-15 opeliunxpg opeliunxp  hypothesis removed
 7-May-15 brel      [--same--]  hypothesis removed
 7-May-15 brelg     ---         deleted; use brel
 7-May-15 opprc4b   ---         deleted
 7-May-15 opelvv    [--same--]  hypothesis added
 7-May-15 opelxpv   ---         deleted
 7-May-15 brxp      [--same--]  hypothesis removed
 7-May-15 opelxpg   ---         deleted; use opelxp
 7-May-15 opelxp    [--same--]  hypothesis removed
 7-May-15 vtoclribr ---         deleted; use vtoclr
 7-May-15 vtoclrbr  ---         deleted; use vtoclr
 7-May-15 vtoclr    [--same--]  hypothesis removed
 7-May-15 op1stb    [--same--]  hypothesis added
 7-May-15 wereucl   [--same--]  revised: sethood antecedent
 7-May-15 wereu     [--same--]  revised: sethood antecedent
 7-May-15 epelc     [--same--]  hypothesis removed
 7-May-15 uniopel   [--same--]  hypothesis added
 7-May-15 uniop     [--same--]  hypothesis added
 7-May-15 euop2     [--same--]  hypothesis added
 7-May-15 opeqpr    [--same--]  hypothesis added
 7-May-15 moop2     [--same--]  hypothesis added
 7-May-15 opcom     [--same--]  hypothesis added
 7-May-15 opth2     ---         deleted; use opth or opth2
 7-May-15 oteqex    [--same--]  revised
 7-May-15 opeqex    [--same--]  revised
 7-May-15 opprc3    ---         deleted
 7-May-15 opprc1b   0nelop      revised
 7-May-15 opnz      [--same--]  hypothesis added; revised (use opnz or opnzi)
 7-May-15 otthg     otth        hypothesis removed
 7-May-15 otthg2    otth2       hypothesis removed
 7-May-15 opthgg    opthg       hypothesis removed
 7-May-15 opthg2    ---         deleted; use opth2
 7-May-15 opthg     ---         deleted; use opth
 7-May-15 opth      [--same--]  hypothesis removed
 7-May-15 opth1     [--same--]  hypothesis added
 7-May-15 opi2      [--same--]  hypothesis added
 7-May-15 opi1      [--same--]  hypothesis added
 7-May-15 elop      [--same--]  hypothesis added
 7-May-15 brprc     ---         deleted
 7-May-15 opprc2if  ---         deleted
 7-May-15 opprc2    [--same--]  revised
 7-May-15 opprc1    [--same--]  revised
 7-May-15 opid      [--same--]  hypothesis added
 7-May-15 ralsng    ralsns
 7-May-15 ralsn     [--same--]  revised
 7-May-15 raltp     [--same--]  revised
 7-May-15 rexpr     [--same--]  revised
 7-May-15 ralpr     [--same--]  revised
 7-May-15 rexprg    [--same--]  revised
 7-May-15 ralprg    [--same--]  revised
 7-May-15 df-op     [--same--]  revised; see dfop or dfopg
14-Apr-15 mptiniseg [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 mptcnvima mptpreima   moved from SO's mathbox to main set.mm
14-Apr-15 resmpt3   [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 fidomtri  [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 ficardsdom [--same--] moved from SO's mathbox to main set.mm
14-Apr-15 euen1     [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 reuen1    [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 dvdsadd2b [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 riincld   [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 cmpfii    [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 tgdom     [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 eltg4i    [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 fopwdom   [--same--]  moved from SO's mathbox to main set.mm
14-Apr-15 fclsfcn   cnfcf       (in JGH's mathbox)
14-Apr-15 fclsfcnp  cnpfcf      (in JGH's mathbox)
14-Apr-15 fclsfneii fcfneii     (in JGH's mathbox)
14-Apr-15 fclsfelbas fcfelbas   (in JGH's mathbox)
14-Apr-15 fclusfnei fcfnei      (in JGH's mathbox)
14-Apr-15 isfclusf  isfcf       (in JGH's mathbox)
14-Apr-15 sfclusf   fcfval      (in JGH's mathbox) revised
14-Apr-15 fclusff   ---         (in JGH's mathbox) deleted; use fcfval
14-Apr-15 ufcomp    ufilcmp     (in JGH's mathbox) revised
14-Apr-15 fcluscomp fclscmp     (in JGH's mathbox) revised
14-Apr-15 fcluscn   fclscn      (in JGH's mathbox) revised
14-Apr-15 fcluscnp  fclscnp     (in JGH's mathbox) revised
14-Apr-15 uffclsflim [--same--] (in JGH's mathbox) revised
14-Apr-15 flimfnfcls [--same--] (in JGH's mathbox) revised
14-Apr-15 fclsfnflim [--same--] (in JGH's mathbox) revised
14-Apr-15 flimfcls  [--same--]  (in JGH's mathbox) revised
14-Apr-15 fcluscf   fclscf      (in JGH's mathbox)
14-Apr-15 fclusss   fclsss2     (in JGH's mathbox) revised
14-Apr-15 fclusbas  fclsopn     (in JGH's mathbox) revised
14-Apr-15 fclusneii fclsneii    (in JGH's mathbox) revised
14-Apr-15 fclselbas [--same--]  (in JGH's mathbox) revised
14-Apr-15 fclusnei  fclsnei     (in JGH's mathbox)
14-Apr-15 isfclus   isfcls      (in JGH's mathbox) revised
14-Apr-15 filclus   fclsval     (in JGH's mathbox) revised
14-Apr-15 sfcls     ---         (in JGH's mathbox) deleted; use fclsval
14-Apr-15 flimfcn   cnflf       moved from JGH's mathbox to main set.mm;revised
14-Apr-15 flimfcnp  cnpflf      moved from JGH's mathbox to main set.mm;revised
14-Apr-15 flimfbas  [--same--]  (in JGH's mathbox) revised
14-Apr-15 fmfnfm    [--same--]  (in JGH's mathbox) revised
14-Apr-15 rnelfmlem [--same--]  (in JGH's mathbox) revised
14-Apr-15 imaelfm   [--same--]  moved from JGH's mathbox to main set.mm
14-Apr-15 cnfillim  cnflf       moved from JGH's mathbox to main set.mm;revised
14-Apr-15 cnpfillim cnpflf      moved from JGH's mathbox to main set.mm;revised
14-Apr-15 flimcls   [--same--]  moved from JGH's mathbox to main set.mm;revised
14-Apr-15 limfilcf  flimcf      moved from JGH's mathbox to main set.mm;revised
14-Apr-15 neiplim   neiflim     moved from JGH's mathbox to main set.mm;revised
14-Apr-15 df-fclusf df-fcf      (in JGH's mathbox)
14-Apr-15 df-fclus  df-fcls     (in JGH's mathbox)
14-Apr-15 cfclusf   cfcf        (in JGH's mathbox)
14-Apr-15 cfclus    cfcls       (in JGH's mathbox)
14-Apr-15 ---       ---         df-1stc ~ 2ndcctbss moved from JGH's mathbox to
                                main set.mm
14-Apr-15 fictb     [--same--]  moved from JGH's mathbox to main set.mm
14-Apr-15 uncon     [--same--]  moved from FL's mathbox to main set.mm
14-Apr-15 iuncon    [--same--]  moved from FL's mathbox to main set.mm
14-Apr-15 flimfneicn flfneicn   (in FL's mathbox)
14-Apr-15 flimfneic flfneic     (in FL's mathbox)
14-Apr-15 flimfnein flfnein     (in FL's mathbox)
14-Apr-15 clindistop indiscld   moved from FL's mathbox to main set.mm
14-Apr-15 clsingemp sn0cld      moved from FL's mathbox to main set.mm
14-Apr-15 dtt2      dishaus     moved from FL's mathbox to main set.mm; revised
14-Apr-15 dtopcl    discld      moved from FL's mathbox to main set.mm; revised
14-Apr-15 flimfnei2 flfnei2     (in FL's mathbox)
14-Apr-15 cnpfillim4 cnpflf4    (in FL's mathbox) revised
14-Apr-15 conttnf   cnpflf2     moved from FL's mathbox to main set.mm; revised
14-Apr-15 flimfneih flfneih     (in FL's mathbox)
14-Apr-15 trnei     [--same--]  moved from FL's mathbox to main set.mm; revised
14-Apr-15 trfil     ---         moved from FL's mathbox to main set.mm; revised
                                (split into trfil1, trfil2)
14-Apr-15 fbfgss2   fil2ss      (in FL's mathbox)
14-Apr-15 fbaslim2  fbflim2     moved from FL's mathbox to main set.mm; revised
14-Apr-15 elfilnemp fileln0     moved from FL's mathbox to main set.mm
14-Apr-15 distopg   distop      moved from FL's mathbox to main set.mm
14-Apr-15 neindisj2 [--same--]  moved from FL's mathbox to main set.mm
14-Apr-15 surjsec   fcofo       moved from FL's mathbox to main set.mm
14-Apr-15 injrec    fcof1       moved from FL's mathbox to main set.mm
14-Apr-15 pw2eng    [--same--]  moved from FL's mathbox to main set.mm
14-Apr-15 surrc2    cocan2      moved from FL's mathbox to main set.mm
14-Apr-15 njtlc     cocan1      moved from FL's mathbox to main set.mm; revised
14-Apr-15 tanord    [--same--]  revised
14-Apr-15 dvmptco   [--same--]  revised
14-Apr-15 dvmptim   [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptre   [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptcj   [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptsub  [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptneg  [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptcmul [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptres  [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptres2 [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptmul  [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptadd  [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmptcl   [--same--]  revised: eliminated hypothesis
14-Apr-15 dvcof     [--same--]  revised
14-Apr-15 dvco      [--same--]  revised
14-Apr-15 dvcobr    [--same--]  revised
14-Apr-15 dvcmulf   [--same--]  revised: eliminated hypothesis
14-Apr-15 dvmulf    [--same--]  revised: eliminated hypothesis
14-Apr-15 dvaddf    [--same--]  revised: eliminated hypothesis
14-Apr-15 ovolmgt0  ovolmge0    revised
14-Apr-15 ---       ---         df-ovol ~ ovolgelb revised
14-Apr-15 isphtpc   [--same--]  revised
14-Apr-15 df-phtpc  [--same--]  revised
14-Apr-15 phtpyco   phtpycc     revised
14-Apr-15 isphtpy   [--same--]  revised
14-Apr-15 df-phtpy  [--same--]  revised
14-Apr-15 holimf2   hausflf2
14-Apr-15 holimf    hausflf
14-Apr-15 hausflim2 hausflimi
14-Apr-15 flimfelbas flfelbas
14-Apr-15 isflimf   isflf
14-Apr-15 flimfneii flfneii
14-Apr-15 flimfnei  flfnei
14-Apr-15 fbfgfmeq  fmfg
14-Apr-15 fmbas     fmuni       swapped equality arguments
14-Apr-15 fmval     [--same--]  revised
14-Apr-15 fmfval    [--same--]  revised
14-Apr-15 df-fm     [--same--]  revised
14-Apr-15 fbaslim   fbflim      revised
14-Apr-15 limfilss  flimss2     revised
14-Apr-15 df-flim   [--same--]  revised ( ( fLim`J )`F ) -> ( J fLim F )
                                (affects all flim* theorems)
14-Apr-15 filrn     [--same--]  revised
14-Apr-15 fgid      fgfil
14-Apr-15 fgfil     fgcl
14-Apr-15 fbfgss    fgss2
14-Apr-15 fgbas     fguni
14-Apr-15 fbssfg    ssfg
14-Apr-15 fgf       fgval
14-Apr-15 emnfil    filn0
14-Apr-15 fipfil2   filintn0
14-Apr-15 fipfil    filinn0
14-Apr-15 filusb    filtop
14-Apr-15 filint    filin
14-Apr-15 fillsb    filss       rearranged hypotheses
14-Apr-15 filesn    0nelfil
14-Apr-15 nconsubb  [--same--]  revised
14-Apr-15 nconsuba  ---         deleted; use nconsubb
14-Apr-15 consuba   ---         deleted; use connsub or nconsubb
14-Apr-15 usinuniop ---         deleted; use dfcon2 or conndisj
14-Apr-15 iscon     [--same--]  revised
14-Apr-15 stoig2    subspuni
14-Apr-15 stoig3    subsptop
14-Apr-15 neiuni    unnei       swapped equality arguments
14-Apr-15 distop    [--same--]  revised
14-Apr-15 prdmbasex [--same--]  revised
14-Apr-15 rlimi     [--same--]  revised
14-Apr-15 rlim0lt   [--same--]  revised
14-Apr-15 rlim0     [--same--]  revised
14-Apr-15 rlim3     [--same--]  revised
14-Apr-15 rlim2lt   [--same--]  revised
14-Apr-15 rlim2     [--same--]  revised
14-Apr-15 recvalzi  recval      revised
14-Apr-15 fzsdom2   [--same--]  revised
14-Apr-15 hashfz    [--same--]  revised
14-Apr-15 hashfn    [--same--]  revised: eliminated hypothesis
14-Apr-15 iccss     [--same--]  revised
14-Apr-15 iooss2    [--same--]  revised
14-Apr-15 iooss1    [--same--]  revised
14-Apr-15 ixxss2    [--same--]  revised
14-Apr-15 ixxss1    [--same--]  revised
14-Apr-15 pwen      [--same--]  revised: eliminated hypothesis
14-Apr-15 mpt2eq123 [--same--]  revised
12-Apr-15 sneqbg    [--same--]  moved from SF's mathbox to main set.mm
12-Apr-15 sneqrg    [--same--]  moved from SF's mathbox to main set.mm
 9-Apr-15 lspsnvsel lspsneli
 9-Apr-15 lmodvsinv lmodvsneg   moved from SO's mathbox to main set.mm; revised
 7-Apr-15 grpsubinv grpinvsub
22-Mar-15 lspsneli  [--same--]  obsolete; use lspsnvsel
21-Mar-15 lspsnmul  lspsnvsel
21-Mar-15 lvecmulcan2 lvecvscan2
21-Mar-15 lvecmulcan lvecvscan
21-Mar-15 lvecmuln0 lvecvsn0
21-Mar-15 lvecmul0or lvecvs0or
12-Mar-15 0vid      lmod0vid
12-Mar-15 0vrid     lmod0vrid
12-Mar-15 0vlid     lmod0vlid
12-Mar-15 0vcl      lmod0vcl
28-Feb-15 cnvcan    funcocnv2   moved from JM's mathbox to main set.mm
17-Feb-15 hauseqlcld [--same--] moved from SO's mathbox to main set.mm
17-Feb-15 hausdiag  [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 eltpt2    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 xpssres   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 c1lip3    [--same--]  (in SO's mathbox) revised
17-Feb-15 c1lip2    [--same--]  (in SO's mathbox) revised
17-Feb-15 c1lip     [--same--]  (in SO's mathbox) revised
17-Feb-15 plycpn    [--same--]  (in SO's mathbox) revised
17-Feb-15 dvnply    [--same--]  (in SO's mathbox) revised
17-Feb-15 cpnord    [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 elcpn     [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 fncpn     [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvnbss    [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvnf      [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvnp1     [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvn0      [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvf2      dvf         moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvply2    [--same--]  (in SO's mathbox) revised
17-Feb-15 dvply1    [--same--]  (in SO's mathbox) revised
17-Feb-15 dvexp2    [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 dvmptfsum [--same--]  moved from SO's mathbox to main set.mm; revised
17-Feb-15 wemapso   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 wemappo   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 soltmin   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 somin2    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 somincom  [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 somin1    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 poltletr  [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 poleloe   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 fresaunres2 [--same--] moved from SO's mathbox to main set.mm
17-Feb-15 fresaun   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 resasplit [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 elmapi    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 elmapex1  [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 fndmin    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 fndmdifeq0 [--same--] moved from SO's mathbox to main set.mm
17-Feb-15 fndmdifcom [--same--] moved from SO's mathbox to main set.mm
17-Feb-15 fndmdif   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 ralima    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 rexima    [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 fvssunirn [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 fvelrn0   fvrn0       moved from SO's mathbox to main set.mm
17-Feb-15 fvbr0     [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 difopab   [--same--]  moved from SO's mathbox to main set.mm
17-Feb-15 df-maxidl [--same--]  moved from JM's mathbox to main set.mm
17-Feb-15 df-pridl  [--same--]  moved from JM's mathbox to main set.mm
17-Feb-15 df-idl    [--same--]  moved from JM's mathbox to main set.mm
17-Feb-15 conntoppr [--same--]  moved from JGH's mathbox to main set.mm
17-Feb-15 cnconn    [--same--]  moved from JGH's mathbox to main set.mm
17-Feb-15 alexsub   [--same--]  moved from JGH's mathbox to main set.mm
17-Feb-15 finsschain [--same--] moved from JGH's mathbox to main set.mm
17-Feb-15 nconsubb  [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 nconsuba  [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 consuba   [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 istos     [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 df-toset  [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 unprj     undifixp    moved from FL's mathbox to main set.mm
17-Feb-15 eltpg     [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 inpreima2 intpreima   moved from FL's mathbox to main set.mm
17-Feb-15 inpreima5 iinpreima   moved from FL's mathbox to main set.mm
17-Feb-15 fveq12i   [--same--]  moved from FL's mathbox to main set.mm
17-Feb-15 fvrn0     [--same--]  moved from SF's mathbox to main set.mm
17-Feb-15 ---       ---         dvaddbr ~ itgsubst revised
17-Feb-15 dvaddbr   [--same--]  revised
19-Jan-15 ---       ---         df-dv ~ dvcn revised
17-Feb-15 df-dv     [--same--]  revised
17-Feb-15 pi1set    ---         deleted; use pi1bval
17-Feb-15 pi1gp     [--same--]  revised
17-Feb-15 pi1val    pi1pval     revised
17-Feb-15 pi1f      [--same--]  revised
17-Feb-15 pi1fval   [--same--]  revised
17-Feb-15 pi1bvalqs [--same--]  revised
17-Feb-15 elpi1i    [--same--]  revised
17-Feb-15 elpi1     [--same--]  revised
17-Feb-15 pi1bval   [--same--]  revised
17-Feb-15 df-pi1    [--same--]  revised
17-Feb-15 df-pi1b   ---         deleted; use df-pi1
17-Feb-15 iscmp     [--same--]  revised
17-Feb-15 symgcl    [--same--]  revised
17-Feb-15 symgov    [--same--]  revised
17-Feb-15 symgplusg [--same--]  revised
17-Feb-15 symgbas   [--same--]  revised
17-Feb-15 proplem2  [--same--]  revised
17-Feb-15 df-pt     [--same--]  revised
17-Feb-15 ---       ---         math token "tP" changed to "Xt_"
17-Feb-15 mapixp    ---         deleted; use ixpconst
 8-Feb-15 posprs    posprsr     (in FL's mathbox)
 8-Feb-15 isprs     isprsr      (in FL's mathbox)
 8-Feb-15 cpreset   [--same--]  moved from FL's mathbox to main set.mm
 8-Feb-15 df-preset [--same--]  moved from FL's mathbox to main set.mm
28-Jan-15 strssd    [--same--]  moved from NM's mathbox to main set.mm
28-Jan-15 strfvd    [--same--]  moved from NM's mathbox to main set.mm
28-Jan-15 strfvnd   [--same--]  moved from NM's mathbox to main set.mm
28-Jan-15 r1omNEW   r1om        moved from SO's mathbox to main set.mm
28-Jan-15 ackbij2   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 ackbij1b  [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 ackbij1   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 onpsssuc  [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 f1opw     [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 djudisj   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 djussxp   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 xpsnen2g  [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 nnunifi   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 fzsdom2   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 hashfz    [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 isinffi   [--same--]  moved from SO's mathbox to main set.mm
28-Jan-15 isprj2    [--same--]  (in FL's mathbox) revised
28-Jan-15 prdmbasex [--same--]  revised
28-Jan-15 ixpexg    [--same--]  revised
19-Jan-15 ---       ---         strlemor0 ~ prdmlmodd moved from SO's mathbox
                                to main set.mm
19-Jan-15 lspf      [--same--]  moved from SO's mathbox to main set.mm
19-Jan-15 lsslsp    [--same--]  moved from SO's mathbox to main set.mm
19-Jan-15 lsslss    [--same--]  moved from SO's mathbox to main set.mm
19-Jan-15 ---       ---         cghm ~ reslmhm moved from SO's mathbox to main
                                set.mm
19-Jan-15 elfz1end  [--same--]  moved from SO's mathbox to main set.mm
19-Jan-15 curgrpact [--same--]  (in FL's mathbox) revised
19-Jan-15 rngapm    [--same--]  (in FL's mathbox) revised
19-Jan-15 gapm2     [--same--]  (in FL's mathbox) revised
19-Jan-15 gaplc     galcan      moved from FL's mathbox to main set.mm; revised
19-Jan-15 symgfo    [--same--]  (in FL's mathbox) revised
19-Jan-15 ltlga     gaid2       moved from FL's mathbox to main set.mm; revised
19-Jan-15 cayleyth  [--same--]  moved from PC's mathbox to main set.mm; revised
19-Jan-15 cayleyi   cayley      moved from PC's mathbox to main set.mm; revised
19-Jan-15 symggrp   [--same--]  moved from PC's mathbox to main set.mm; revised
19-Jan-15 tgss      [--same--]  revised
19-Jan-15 unitg     [--same--]  revised
19-Jan-15 bastg     [--same--]  revised
19-Jan-15 tg2       [--same--]  revised
19-Jan-15 tg1       [--same--]  revised
19-Jan-15 eltg2b    [--same--]  revised
19-Jan-15 eltg2     [--same--]  revised
19-Jan-15 eltg      [--same--]  revised
19-Jan-15 tgval2    [--same--]  revised
19-Jan-15 tgval     [--same--]  revised
19-Jan-15 df-topgen [--same--]  revised
19-Jan-15 symgidi   symgid      revised
19-Jan-15 symggrpi  symggrp     revised
19-Jan-15 symgov    [--same--]  revised
19-Jan-15 symgval   symgplusg   revised
19-Jan-15 elsymgrn  elsymgbas   revised
19-Jan-15 df-symg   [--same--]  revised
19-Jan-15 gapm      [--same--]  revised
19-Jan-15 gacan     [--same--]  revised
19-Jan-15 gaass     [--same--]  revised
19-Jan-15 gagrpid   [--same--]  revised
19-Jan-15 gaf       [--same--]  revised
19-Jan-15 gagrp     [--same--]  revised
19-Jan-15 ssga      subgga      revised
19-Jan-15 gaid      [--same--]  revised
19-Jan-15 ga0       [--same--]  revised
19-Jan-15 isga2     ---         deleted; use isga
19-Jan-15 gafo      [--same--]  revised
19-Jan-15 isga      [--same--]  revised
19-Jan-15 df-ga     [--same--]  revised
19-Jan-15 grplactf1o [--same--] revised
19-Jan-15 grplactval [--same--] revised
19-Jan-15 grplactfval [--same--] revised
19-Jan-15 islbs2    islbs3      revised
19-Jan-15 lbspss    [--same--]  revised
19-Jan-15 lbsind    lbsind2     revised
19-Jan-15 lbssp     [--same--]  revised
19-Jan-15 lbsel     [--same--]  revised
19-Jan-15 lbsss     [--same--]  revised
19-Jan-15 islbs     [--same--]  revised; see also islbs2
19-Jan-15 lbsval    ---         deleted; use islbs
19-Jan-15 df-lbs    [--same--]  revised
19-Jan-15 lssne0    [--same--]  revised
19-Jan-15 lsscl     [--same--]  revised
19-Jan-15 lssn0     [--same--]  revised
19-Jan-15 lssel     [--same--]  revised
19-Jan-15 lssss     [--same--]  revised
19-Jan-15 islssd    [--same--]  revised
19-Jan-15 islss     [--same--]  revised
19-Jan-15 lagsubglem2 lagsubg2  revised
19-Jan-15 lagsubglem1 eqger     revised
19-Jan-15 issubg2   [--same--]  revised
19-Jan-15 odphi     odzphi
19-Jan-15 oddvds    odzdvds
19-Jan-15 odid      odzid
19-Jan-15 odcl      odzcl
19-Jan-15 odcllem   odzcllem
19-Jan-15 odval     odzval
19-Jan-15 df-od     df-odz
19-Jan-15 cod       codz
19-Jan-15 ---       ---         math token "od" changed to "odZ"
10-Jan-15 lsmss1xxx lsmss2
10-Jan-15 lsmss1    lsmss2
10-Jan-15 lsmss2    lsmss1xxx
 9-Jan-15 mpbiran   [--same--]  changed hypothesis order
 9-Jan-15 mpbiran2  [--same--]  changed hypothesis order
 9-Jan-15 mpbir2an  [--same--]  changed hypothesis order
 9-Jan-15 mpbi2and  [--same--]  changed hypothesis order
 9-Jan-15 mpbir2and [--same--]  changed hypothesis order
 9-Jan-15 mpbir3an  [--same--]  changed hypothesis order
 9-Jan-15 mpbir3and [--same--]  changed hypothesis order
 8-Jan-15 lsmmod    [--same--]  swapped equality arguments
 8-Jan-15 ficarddom [--same--]  swapped biconditional arguments
 7-Jan-15 algvsca   [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 algsca    [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 algmulr   [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 algaddg   [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 algbase   [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 algfun    [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 algfn     [--same--]  moved from SO's mathbox to main set.mm
 7-Jan-15 crngcom   crngocom
 7-Jan-15 ---       ---         math token "CRing" changed to "CRingOps"
 7-Jan-15 df-mnd2   df-mnd      moved from FL's mathbox to main set.mm
 7-Jan-15 mndass2   mndoass2
 7-Jan-15 mndass    mndoass
 7-Jan-15 mndio     mndoio
 7-Jan-15 mndid     mndoid
 7-Jan-15 mndisass  mndoisass
 7-Jan-15 df-tsms   rngomndo
 7-Jan-15 rngomnd   rngomndo
 7-Jan-15 grpomnd   grpomndo
 7-Jan-15 ismnd2    ismndo2
 7-Jan-15 ismnd1    ismndo1
 7-Jan-15 ismnd     ismndo
 7-Jan-15 mndmgmid  mndomgmid
 7-Jan-15 mndismgm  mndoismgm
 7-Jan-15 mndisexid mndoisexid
 7-Jan-15 mndissmgrp mndoissmgrp
 7-Jan-15 df-mnd    df-mndo
 7-Jan-15 cmnd      cmndo
 7-Jan-15 ---       ---         math token "Mnd" changed to "MndOp"
 7-Jan-15 grp2grpo  ---         deleted (commented out)
 7-Jan-15 unitpropd [--same--]  revised: eliminated hypothesis
 7-Jan-15 dvdsrpropd [--same--] revised: eliminated hypothesis
 7-Jan-15 dvdsrmul2 dvdsrmul1   revised
 7-Jan-15 dvdsrmul  [--same--]  revised
 7-Jan-15 dvdsr2    [--same--]  revised
 7-Jan-15 dvdsr     [--same--]  revised
 7-Jan-15 dvdsrval  [--same--]  revised
 7-Jan-15 df-dvdsr  [--same--]  revised (changed from left-divisible to right)
 7-Jan-15 ringi     [--same--]  revised
 7-Jan-15 isring    [--same--]  revised
 7-Jan-15 df-ring   [--same--]  revised
 7-Jan-15 gsum2d    [--same--]  revised
 7-Jan-15 ---       ---         all gsum* theorems revised for CMnd
 7-Jan-15 mulgnndi  mulgnn0di   revised
 7-Jan-15 abl4      cmn4        revised
 7-Jan-15 abl32     cmn32       revised
 7-Jan-15 isabld    [--same--]  reordered hypotheses
 7-Jan-15 isabl     isabl2
 7-Jan-15 df-abl    [--same--]  revised
 7-Jan-15 mulgnn0ass [--same--] revised
 7-Jan-15 mulgnnass [--same--]  revised
 7-Jan-15 mulgnn0dir [--same--] revised
 7-Jan-15 mulgnndir [--same--]  revised
 7-Jan-15 mulgnn0z  [--same--]  revised
 7-Jan-15 mulgnn0cl [--same--]  revised
 7-Jan-15 mulgnncl  [--same--]  revised
 7-Jan-15 mulgnn0p1 [--same--]  revised
 7-Jan-15 grpinv    ---         deleted; use grplinv, grprinv
 7-Jan-15 isgrpid   ---         deleted; use ismgmid
 7-Jan-15 grpidinv2 ---         deleted; use grplid, grprid, grpinvex
 7-Jan-15 isgrpi    [--same--]  revised: eliminated hypothesis
 7-Jan-15 isgrpiOLD ---         deleted
 7-Jan-15 isgrpdOLD ---         deleted
 7-Jan-15 isgrprd   ---         deleted
 7-Jan-15 isgrpd    [--same--]  revised: eliminated hypothesis
 7-Jan-15 grppropOLD ---        deleted; use grpprop
 7-Jan-15 elgrp     ---         deleted; use isgrp
 7-Jan-15 grpideu2  ---         deleted; use grpideu or grpridd
 7-Jan-15 grpidinv  ---         deleted; use grpinvex
 7-Jan-15 ---       ---         grpidinvlem1 - grpidinvlem4 deleted
 7-Jan-15 grplidinv             deleted; use grpinvex
 7-Jan-15 grplem1   ---         deleted
 7-Jan-15 isgrp2    ---         deleted; use isgrp
 7-Jan-15 isgrp     [--same--]  revised
 7-Jan-15 df-grp    [--same--]  revised
 7-Jan-15 df-mpq    [--same--]  revised
 7-Jan-15 df-plpq   [--same--]  revised
 7-Jan-15 fineqv    [--same--]  revised
 7-Jan-15 erovlem   [--same--]  revised
 7-Jan-15 eroveu    [--same--]  revised
 7-Jan-15 ovmpt2    [--same--]  changed distinct vars
 7-Jan-15 ovmpt2g   [--same--]  changed distinct vars
 7-Jan-15 grplidd   grpridd     revised
 7-Jan-15 grplinvd  grprinvd    revised
 7-Jan-15 grplinvlem2 ---       deleted
 7-Jan-15 grplinvlem1 grprinvlem revised
 7-Jan-15 caovcld   caovclg
 7-Jan-15 posn      [--same--]  revised
 7-Jan-15 sbcbidv   sbcbidgv
 7-Jan-15 sbcbid    sbcbidg
28-Dec-14 grpnegprop ---        (in SO's mathbox) deleted; use grpinvpropd
28-Dec-14 grpidprop ---         (in SO's mathbox) deleted; use grpidpropd
28-Dec-14 fvco4     fvco2       moved from SO's mathbox to main set.mm
28-Dec-14 injrec    [--same--]  (in FL's mathbox) revised
28-Dec-14 subrgugrp [--same--]  revised
28-Dec-14 drngid    [--same--]  revised
28-Dec-14 drngmgrp  [--same--]  revised
28-Dec-14 isdrng2   [--same--]  revised
28-Dec-14 invrfval  [--same--]  revised
28-Dec-14 df-invr   [--same--]  revised
28-Dec-14 unitgrpid [--same--]  revised
28-Dec-14 unitgrp   [--same--]  revised
28-Dec-14 rngidval  [--same--]  revised
28-Dec-14 df-ur     [--same--]  revised
28-Dec-14 df-gsum   [--same--]  revised
28-Dec-14 grpsubval [--same--]  revised: eliminated hypothesis
28-Dec-14 grpidval  [--same--]  revised
28-Dec-14 grpproplem proplem
28-Dec-14 grpproplem2 proplem2
28-Dec-14 grpideu   grpideu2
28-Dec-14 df-0g     [--same--]  revised
28-Dec-14 algrflem  [--same--]  revised: eliminated hypothesis
28-Dec-14 fvco3     [--same--]  revised: eliminated hypothesis
28-Dec-14 fvco2     [--same--]  revised: eliminated hypothesis
28-Dec-14 fvco      [--same--]  revised: eliminated hypothesis
28-Dec-14 hbcsb1    [--same--]  revised: eliminated hypothesis
28-Dec-14 hbsbc1    hbsbc1g2
27-Dec-14 a1i12     a1ii
27-Dec-14 fmpt2d    [--same--]  revised: weakened hypothesis
 5-Dec-14 df-cnfld  [--same--]  moved from SO's mathbox to main set.mm
 5-Dec-14 grppropd  [--same--]  moved from SO's mathbox to main set.mm
 5-Dec-14 df-ress   [--same--]  moved from SO's mathbox to main set.mm
 5-Dec-14 ghsubg    ghsubgo
 5-Dec-14 zaddsubg  zaddsubgo
 5-Dec-14 readdsubg readdsubgo
 5-Dec-14 subgablo  subgoablo
 5-Dec-14 issubgi   issubgoi
 5-Dec-14 subginv   subgoinv
 5-Dec-14 subgid    subgoid
 5-Dec-14 subgrnss  subgornss
 5-Dec-14 subgov    subgoov
 5-Dec-14 subgres   subgores
 5-Dec-14 issubg    issubgo
 5-Dec-14 df-subg   df-subgo
 5-Dec-14 csubg     csubgo
 5-Dec-14 isabvd    [--same--]  revised
 5-Dec-14 rngdvcan1 [--same--]  revised
 5-Dec-14 rngdvcl   [--same--]  revised
 5-Dec-14 rngdvval  [--same--]  revised
 5-Dec-14 rngdvfval [--same--]  revised
 5-Dec-14 rngnegrmul rngmneg2   revised
 5-Dec-14 rngneglmul rngmneg1   revised
 5-Dec-14 isrngd    [--same--]  revised
 5-Dec-14 isrng     [--same--]  revised
 5-Dec-14 df-ring   [--same--]  revised
 5-Dec-14 lagsubg   [--same--]  revised
 5-Dec-14 grpn0     grpbn0
 5-Dec-14 setsval   [--same--]  revised
 5-Dec-14 df-sets   [--same--]  revised
10-Nov-14 dford3    dford5reg   (in SF's mathbox)
10-Nov-14 fvun2     [--same--]  moved from SF's mathbox to main set.mm
10-Nov-14 fvun1     [--same--]  moved from SF's mathbox to main set.mm
10-Nov-14 twsvbdop  oprab4      moved from FL's mathbox to main set.mm
10-Nov-14 ra42e     [--same--]  moved from FL's mathbox to main set.mm
10-Nov-14 dmmptss   [--same--]  moved from SF's mathbox to main set.mm
10-Nov-14 rabxm     [--same--]  moved from JM's mathbox to main set.mm
10-Nov-14 rabnc     [--same--]  moved from JM's mathbox to main set.mm
10-Nov-14 absz      [--same--]  moved from JM's mathbox to main set.mm
10-Nov-14 absmod0   [--same--]  moved from JM's mathbox to main set.mm
10-Nov-14 negmod0   [--same--]  moved from JM's mathbox to main set.mm
13-Oct-14 qredeu    [--same--]  moved from JGH's mathbox to main set.mm
13-Oct-14 qredeq    [--same--]  moved from JGH's mathbox to main set.mm
25-Sep-14 otthg     otthg2      otthg now uses ordered triple definition
23-Sep-14 logcl     logrncl
23-Sep-14 divcnlem  reccn2      revised
23-Sep-14 climsqueeze2 climsqz2
23-Sep-14 climsqueeze climsqz
21-Sep-14 elqs2     ---         (in RM's mathbox) deleted; same as elqsg
21-Sep-14 cnss      ---         (in JM's mathbox) deleted; same as cnsubsp2r
21-Sep-14 elnnr     ---         (in JM's mathbox) deleted; same as elrege0
21-Sep-14 zmodfzcl  ---         (in JM's mathbox) deleted; same as zmodfz
21-Sep-14 subtareqbe [--same--] (in FL's mathbox) revised
21-Sep-14 subtsm    [--same--]  (in FL's mathbox) revised
21-Sep-14 pwtsm     [--same--]  (in FL's mathbox) revised
21-Sep-14 tmpts     tskmcl      moved from FL's mathbox to main set.mm; revised
21-Sep-14 intrtael  tskint      moved from FL's mathbox to main set.mm; revised
21-Sep-14 intartar  inttsk      moved from FL's mathbox to main set.mm
21-Sep-14 inttar1   ---         (in FL's mathbox) deleted; see 0tsk
21-Sep-14 elttar    tskmid      moved from FL's mathbox to main set.mm
21-Sep-14 btmp      eltskm      moved from FL's mathbox to main set.mm; revised
21-Sep-14 bpmp      sstskm      moved from FL's mathbox to main set.mm; revised
21-Sep-14 tarval2g  tskmval     moved from FL's mathbox to main set.mm; revised
21-Sep-14 tarval2   ---         (in FL's mathbox) deleted; see tskmval
21-Sep-14 df-tskmp  df-tskm     moved from FL's mathbox to main set.mm; revised
21-Sep-14 ctarskim  ctskm
21-Sep-14 tarsuc3   ---         (in FL's mathbox) deleted; see tsktrss
21-Sep-14 tarsuc2   tsksuc      moved from FL's mathbox to main set.mm; revised
21-Sep-14 tarsuc1   ---         (in FL's mathbox) deleted; see tsksuc, tsktrss
21-Sep-14 sexptrt   tskmap      moved from FL's mathbox to main set.mm; revised
21-Sep-14 cptarc    tskxp       moved from FL's mathbox to main set.mm; revised
21-Sep-14 tclinf    ---         (in FL's mathbox) deleted; same as tskinf
21-Sep-14 tartord   ---         (in FL's mathbox) deleted; see tsktrss
21-Sep-14 tartrel   tsktrss     moved from FL's mathbox to main set.mm
21-Sep-14 elcartr   ---         (in FL's mathbox) deleted; see trss
21-Sep-14 tarax3d4  ---         (in FL's mathbox) deleted; see tsksdom
21-Sep-14 tarax3d3  ---         (in FL's mathbox) deleted; see tsksdom
21-Sep-14 tarax3c   ---         (in FL's mathbox) deleted; see tsken
21-Sep-14 tarax3b   ---         (in FL's mathbox) deleted; see tsken
21-Sep-14 tarax3a   ---         (in FL's mathbox) deleted; same as tsken
21-Sep-14 inacint   tskin       moved from FL's mathbox to main set.mm; revised
21-Sep-14 elincin   ---         (in FL's mathbox) deleted; same as tskss
21-Sep-14 letri31   ---         (in FL's mathbox) deleted; same as xrletri3
21-Sep-14 elioooord ---         (in FL's mathbox) deleted; same as eliooord
21-Sep-14 elioc3    ---         (in FL's mathbox) deleted; same as elioc2
21-Sep-14 elico3    ---         (in FL's mathbox) deleted; same as elico2
21-Sep-14 omslim2   ---         (in FL's mathbox) deleted; same as dfom5
21-Sep-14 omslim    ---         (in FL's mathbox) deleted; see dfom5
21-Sep-14 ltwefz    [--same--]  moved from SF's mathbox to main set.mm
21-Sep-14 ltwenn    [--same--]  moved from SF's mathbox to main set.mm
21-Sep-14 ltweuz    [--same--]  moved from SF's mathbox to main set.mm
21-Sep-14 sqrrpcl   ---         deleted; same as rpsqrcl
21-Sep-14 ltfrn     ltweuz
21-Sep-14 zmodcl2   zmodfz
21-Sep-14 tskssel2  ---         deleted; see tskssel
21-Sep-14 eltsk2    ---         deleted; see eltsk2g
21-Sep-14 eltsk     ---         deleted; see eltskg
21-Sep-14 dftsk2    ---         deleted; see eltsk2g
21-Sep-14 omsubinit alephinit
21-Sep-14 infenomsub infenaleph
21-Sep-14 omsubindss ---        deleted; same as alephle
21-Sep-14 omsublim  ---         deleted; see alephislim
21-Sep-14 omsubdmss alephdom2
21-Sep-14 elomsubsd alephsdom
21-Sep-14 omsubss   ---         deleted; same as alephord3
21-Sep-14 omsubel   ---         deleted; same as alephord2
21-Sep-14 omsubdom  alephdom
21-Sep-14 omsubsdom ---         deleted; same as alephordi
21-Sep-14 omsubsdomlem2 ---     deleted; see alephordi
21-Sep-14 omsubsdomlem1 ---     deleted; same as alephordilem1
21-Sep-14 omsubsuc2 ---         deleted; same as alephsuc2
21-Sep-14 omsubsuc  ---         deleted; same as alephsuc
19-Sep-14 clfsebs2  ---         (in FL's mathbox) deleted; same as clfsebsr
15-Sep-14 ostth     [--same--]  revised
15-Sep-14 wlogle    [--same--]  revised
11-Sep-14 infmrgelbOLD ---      (in JM's mathbox) deleted; see infmrgelb
11-Sep-14 lbleinfOLD ---        (in JGH's mathbox) deleted; see infmrgelb
11-Sep-14 suplub2   supwlub     (in FL's mathbox)
11-Sep-14 nmfnleub  [--same--]  revised
11-Sep-14 nmopub    [--same--]  revised
11-Sep-14 itg2leub  [--same--]  revised
11-Sep-14 mbfmono   mbfsup      revised
11-Sep-14 ovolshftlem2 [--same--] revised
11-Sep-14 nmoubi    [--same--]  revised
11-Sep-14 pcid      pcidlem
11-Sep-14 caurcvg   [--same--]  revised
11-Sep-14 caurcvglem [--same--] revised
11-Sep-14 limsupcl  [--same--]  revised
11-Sep-14 limsupval [--same--]  revised
11-Sep-14 expcl2lem [--same--]  revised
11-Sep-14 infmxrgelb [--same--] revised
11-Sep-14 infmrgelb [--same--]  revised
11-Sep-14 suprleubii [--same--] revised
11-Sep-14 suprnubii [--same--]  revised
11-Sep-14 suprlubii [--same--]  revised
11-Sep-14 suprleub  [--same--]  revised
11-Sep-14 suprnub   [--same--]  revised
11-Sep-14 suprlub   [--same--]  revised
 2-Sep-14 grpohlem5 grpohmlem5  (in FL's mathbox)
 2-Sep-14 grpohlem3 grpohmlem3  (in FL's mathbox)
 2-Sep-14 ditgsplit [--same--]  revised
 2-Sep-14 ditgswap  [--same--]  revised
 2-Sep-14 ditgcl    [--same--]  revised
 2-Sep-14 ditgneg   [--same--]  revised
 2-Sep-14 ditgpos   [--same--]  revised
 2-Sep-14 mbfeq     mbfeqa      revised
 2-Sep-14 ivthicc   [--same--]  revised
 2-Sep-14 ivthle2   [--same--]  revised
 2-Sep-14 ivthle    [--same--]  revised
 2-Sep-14 ivth2     [--same--]  revised
 2-Sep-14 ivth      [--same--]  revised
 2-Sep-14 negfcncf  [--same--]  revised
 2-Sep-14 cncfco    [--same--]  revised
 2-Sep-14 cncffvrn  [--same--]  revised
 2-Sep-14 rescncf   [--same--]  revised
 2-Sep-14 cncffvelrn ---        deleted; see cncff
 2-Sep-14 cncfi     [--same--]  revised
 2-Sep-14 cncffvelrnOLD ---     deleted; see cncff
 2-Sep-14 cncff     [--same--]  revised
 2-Sep-14 ---       ---         changed math symbol from "Itgbl" to "L^1"
18-Aug-14 reheibor  [--same--]  (in JM's mathbox) revised
18-Aug-14 itgcnval  [--same--]  revised
18-Aug-14 iblre     iblrelem
18-Aug-14 itg0      itgz
18-Aug-14 mbfneg    [--same--]  revised
18-Aug-14 mbfmulc2  mbfmulc2re  revised
18-Aug-14 iccst     ---         deleted; see resubmet
18-Aug-14 stioo     ---         deleted; see resubmet
14-Aug-14 rexxfr    [--same--]  revised to be more general
14-Aug-14 ralxfr    [--same--]  revised to be more general
14-Aug-14 rexxfrd   [--same--]  revised to be more general
14-Aug-14 ralxfrd   [--same--]  revised to be more general
10-Aug-14 subntr    [--same--]  moved from JGH's mathbox to main set.mm
10-Aug-14 subcls    [--same--]  moved from JGH's mathbox to main set.mm
10-Aug-14 subsubtop [--same--]  moved from JGH's mathbox to main set.mm
10-Aug-14 ntrin     [--same--]  moved from JGH's mathbox to main set.mm
10-Aug-14 epr       [--same--]  moved from JGH's mathbox to main set.mm
10-Aug-14 epos      [--same--]  moved from JGH's mathbox to main set.mm
10-Aug-14 imrescl   resima2     moved from FL's mathbox to main set.mm
10-Aug-14 dmdcan    [--same--]  moved from SF's mathbox to main set.mm
10-Aug-14 bposlem6  [--same--]  revised
10-Aug-14 bposlem5  [--same--]  revised
10-Aug-14 hashpwlem ---         deleted
30-Jul-14 hasheq0   [--same--]  revised
30-Jul-14 ifswap    ifnot
30-Jul-14 ifor      ifeqor
23-Jul-14 reptertr4 ---         (in FL's mathbox) deleted; see fmptco
23-Jul-14 reptertr3 ---         (in FL's mathbox) deleted; see fmptco
23-Jul-14 reptertr2 ---         (in FL's mathbox) deleted; see fmptco
23-Jul-14 eflti     ---         deleted; see eflt
23-Jul-14 fsumcllem [--same--]  revised
23-Jul-14 fsumcl2lem [--same--] revised
16-Jul-14 cbvrex2v  [--same--]  moved from FL's mathbox to main set.mm
16-Jul-14 df-subg   [--same--]  revised
16-Jul-14 imcj      imval2
16-Jul-14 recj      reval
16-Jul-14 hashf     [--same--]  revised
16-Jul-14 df-hash   [--same--]  revised
16-Jul-14 crmuli    ---         deleted (contents moved to remullem)
14-Jul-14 riota4    riotasbc
14-Jul-14 reiota4   reiotasbc
14-Jul-14 reuuni4   reuunisbc
14-Jul-14 elabs     elabsbc
12-Jul-14 lssdisj   lssdisj1
11-Jul-14 0nelqs2   elqsn0      moved from RM's mathbox to main set.mm; revised
11-Jul-14 erdisj3   qsdisj      moved from RM's mathbox to main set.mm; revised
11-Jul-14 df-subg   [--same--]  revised
11-Jul-14 subgov    [--same--]  revised
11-Jul-14 df-subg   [--same--]  revised
11-Jul-14 hash0     hasheq0
11-Jul-14 dmmulnq   mulnqf      revised
11-Jul-14 dmaddnq   addnqf      revised
11-Jul-14 df-rq     [--same--]  revised
11-Jul-14 ecelqsdm  [--same--]  revised
11-Jul-14 0nelqs    elqsn0      revised
11-Jul-14 uniqs     [--same--]  revised
11-Jul-14 qsexg     [--same--]  revised
11-Jul-14 ecelqsg   [--same--]  changed variable names
11-Jul-14 ecdmn0    [--same--]  revised
11-Jul-14 erdisj2   erdisj      revised
11-Jul-14 erdisj    [--same--]  revised
11-Jul-14 ereldm    ereldmb     revised
11-Jul-14 erthdmr   erth2       revised
11-Jul-14 erthdmg   erth        revised
11-Jul-14 erthdm    erth        revised
11-Jul-14 erth      [--same--]  revised
11-Jul-14 erthi     [--same--]  revised
11-Jul-14 ecdmn0    [--same--]  revised
11-Jul-14 eceq2     eceq1       (these labels should be
11-Jul-14 eceq1     eceq2        exchanged at the same time)
11-Jul-14 erdmrn    [--same--]  revised
11-Jul-14 erref     [--same--]  revised
11-Jul-14 errtr     [--same--]  revised
11-Jul-14 erref2    erref       revised
11-Jul-14 ertr      [--same--]  revised
11-Jul-14 errsym    [--same--]  revised
11-Jul-14 ersymb    [--same--]  revised
11-Jul-14 ersym     [--same--]  revised
11-Jul-14 ster      iser
11-Jul-14 dfec2     [--same--]  revised
11-Jul-14 so        isso2i      revised
11-Jul-14 itlso     issoi
 7-Jul-14 difxpOLD  ---         deleted; see difxp
 7-Jul-14 clsrebb   iccssxr     moved from FL's mathbox to main set.mm; revised
 7-Jul-14 iooirrsa  ioossre     moved from FL's mathbox to main set.mm; revised
 7-Jul-14 elicore2  icossre     moved from FL's mathbox to main set.mm
 7-Jul-14 elicore   icossxr     moved from FL's mathbox to main set.mm; revised
 7-Jul-14 eliocreb2 iocssre     moved from FL's mathbox to main set.mm
 7-Jul-14 eliocreb  iocssxr     moved from FL's mathbox to main set.mm; revised
 7-Jul-14 eliccre2b iccssre     moved from FL's mathbox to main set.mm
 7-Jul-14 eliccreb  iccssxr     moved from FL's mathbox to main set.mm; revised
 7-Jul-14 islvecd   ---         deleted; see islmodd and islvec2
 7-Jul-14 islmodd   [--same--]  revised
 7-Jul-14 islmod    [--same--]  revised
 7-Jul-14 df-lmod   [--same--]  revised (change g e. Abel to g e. Grp)
 7-Jul-14 fsump1i   [--same--]  revised
 7-Jul-14 difxp     [--same--]  revised
 2-Jul-14 difeq12   [--same--]  moved from FL's mathbox to main set.mm
 2-Jul-14 rngneg1   rngnegl     revised
 1-Jul-14 abl4pnp   ablo4pnp    (in JM's mathbox)
 1-Jul-14 ablinvop  abloinvop   (in JM's mathbox)
 1-Jul-14 ablcomgrp ablocomgrp  (in JM's mathbox)
 1-Jul-14 hhssabl   hhssablo
 1-Jul-14 hhssabli  hhssabloi
 1-Jul-14 hilabl    hilablo
 1-Jul-14 nvabl     nvablo
 1-Jul-14 vcabl     vcablo
 1-Jul-14 ablmul    ablomul
 1-Jul-14 ablsn     ablosn
 1-Jul-14 subgabl   subgablo
 1-Jul-14 isablda   isabloda
 1-Jul-14 ablnnncan1 ablonnncan1
 1-Jul-14 ablnncan  ablonncan
 1-Jul-14 ablnnncan ablonnncan
 1-Jul-14 abldivdiv4 ablodivdiv4
 1-Jul-14 abldivdiv ablodivdiv
 1-Jul-14 ablmuldiv ablomuldiv
 1-Jul-14 cabl      cablo
24-Jun-14 df-lmod   [--same--]  revised, and all affected definitions and
                                theorems were revised accordingly (156
                                statements in main set.mm, 4 in FL's mathbox,
                                257 in NM's mathbox, 417 total)
23-Jun-14 ---       ---         moved from JM's mathbox to main set.mm:
                                cphtpy cphtpc phtpy phtpyfval phtpyval isphtpy
                                phtpycom phtpyid phtpyco phtpc phtpcval
                                phtpcrel isphtpc phtpcdm phtpcer reparphti
                                reparpht cpi1b cpco cpi1 pco pi1b pi1 pcofval
                                pcoval pcovalg pcoval1 pco0 pco1 pcoval2 pcocn
                                pcoloopf pcohtpylem pcohtpy pcopt pcoass
                                pcorevlem pcorev pi1bval elpi1 elpi1i pi1bvalqs
                                pi1fval pi1flem pi1f pi1val pi1gplem pi1gp
                                pi1set
23-Jun-14 isablod   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 isablda   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 isgrpod   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 isgrpda   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 cnmpt2pc  [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 paste     [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 ---       ---         moved from JM's mathbox to main set.mm:
                                iccsplit iccshftr iccshftri iccshftl iccshftli
                                iccdil iccdili icccntr icccntri cii ii iitop
                                iiuni dfii2 dfii3 iicmp cnmptre iirev iirevcn
                                iihalf1 iihalf1cn iihalf2 iihalf2cn elii1 elii2
                                iimulcl iimulcn iccst icoopnst iocopnst
                                lincmb01cmp lincmb01icc oprpiece1res1
                                oprpiece1res2
23-Jun-14 subspcld2 [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 subspcld  [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 eroprf2   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 erov2     [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 eroprf    [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 erov      [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 eroveu    [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 erovlem   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 ecelqsg   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 erthdmg   [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 oprabrexex2 [--same--] moved from JM's mathbox to main set.mm
23-Jun-14 oprabvalg ovg         moved from JM's mathbox to main set.mm

23-Jun-14 ---       ---         moved from SF's mathbox to main set.mm:
                                gcdmultiple rprimemulgcd rprimelpwr rprimepwr
                                gcd12 gcddiv gcdmultiplez dvdssqim sqgcd
                                dvdssqlem dvdssq divgcdodd gcdadd pythagtrip
                                trirecip
23-Jun-14 dvdsgcdid ---         (in SF's mathbox) deleted; see gcdeq
23-Jun-14 dvdsprime [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 ---       ---         moved from SF's mathbox to main set.mm:
                                gcdabs1 gcdabs2 dvdsgcdb gcdass mulgcdr
                                coprimeprodsq coprimeprodsq2 odd2np1lem odd2np1
                                opoe omoe opeo omeo
23-Jun-14 abssq     [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 zsqcl     [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 sqrlt     [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 nnsqcl    [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 1elunit   [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 0elunit   [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 binom2subi [--same--] moved from SF's mathbox to main set.mm
23-Jun-14 binom2sub [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 elicc2i   [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 preq12bg  [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 bfplem    bfplem2     (in JM's mathbox)
23-Jun-14 stioo     [--same--]  moved from JM's mathbox to main set.mm
23-Jun-14 elrege0   [--same--]  moved from SF's mathbox to main set.mm
23-Jun-14 clint3OLD icccld
23-Jun-14 eltop2    [--same--]  revised
23-Jun-14 ivthlem   ivthlem3
23-Jun-14 difreicc  [--same--]  revised
23-Jun-14 imaiun    imauni
16-Jun-14 icccmp    icccmpALT   (in JM's mathbox)
16-Jun-14 compfipin0 cmpfi      moved from JGH's mathbox to main set.mm
16-Jun-14 compfipin0lem cmpfilem moved from JGH's mathbox to main set.mm
16-Jun-14 hscptsscld hauscmp    moved from JGH's mathbox to main set.mm
16-Jun-14 hscptsscldlem hauscmplem moved from JGH's mathbox to main set.mm
16-Jun-14 uncomp    uncmp       moved from JGH's mathbox to main set.mm
16-Jun-14 cptclsscpt cmpcld     moved from JGH's mathbox to main set.mm
16-Jun-14 compsub   cmpsub      moved from JGH's mathbox to main set.mm
16-Jun-14 compsublem cmpsublem  moved from JGH's mathbox to main set.mm
16-Jun-14 compcov   cmpcov      moved from JGH's mathbox to main set.mm
16-Jun-14 comptop   cmptop      moved from JGH's mathbox to main set.mm
16-Jun-14 opncldf3  [--same--]  moved from JGH's mathbox to main set.mm
16-Jun-14 opncldf2  [--same--]  moved from JGH's mathbox to main set.mm
16-Jun-14 opncldf1  [--same--]  moved from JGH's mathbox to main set.mm
16-Jun-14 icc0      [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 ioc0      [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 ico0      [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 lbico1    [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 ubioc1    [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 cmptop    [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 sinempcomp 0cmp       moved from FL's mathbox to main set.mm
16-Jun-14 sbincgt   tgfiss      moved from FL's mathbox to main set.mm
16-Jun-14 neffopo   fiinopn     moved from FL's mathbox to main set.mm
16-Jun-14 rnxpid    [--same--]  moved from FL's mathbox to main set.mm
16-Jun-14 mayete3OLDi mayete3iOLD
16-Jun-14 df-toset  df-ts
16-Jun-14 ccha      ctsr
16-Jun-14 fintopcomp fincmp
16-Jun-14 comptoppr cmptoppr
16-Jun-14 cncomp    cncmp
16-Jun-14 iscomp    iscmp
16-Jun-14 df-comp   df-cmp
16-Jun-14 ccomp     ccmp
16-Jun-14 subbas2   ---         deleted; see fiuni
16-Jun-14 subbas    ---         deleted; see fibas
16-Jun-14 invrrOLD  ---         deleted; see drnginvrr
16-Jun-14 invrlOLD  ---         deleted; see drnginvrl
16-Jun-14 invrclOLD invrcllem
16-Jun-14 isumcmpss isumless
16-Jun-14 isumcmp   isumle
16-Jun-14 fsumtscop [--same--]  revised
16-Jun-14 fsumcmp   fsumle
16-Jun-14 fsumcmpss fsumless
16-Jun-14 isercmp   iserle
16-Jun-14 climcmpc2 climlec2
16-Jun-14 climcmp   climle
16-Jun-14 sercmp    serle
16-Jun-14 serdistr  seqdistr
16-Jun-14 serf1o    seqf1o
16-Jun-14 serf1olem2 seqf1olem2
16-Jun-14 serf1olem1 seqf1olem1
16-Jun-14 sercaopr  seqcaopr
16-Jun-14 sercaopr2 seqcaopr2
16-Jun-14 ioojoin   [--same--]  revised
16-Jun-14 snunioo   [--same--]  revised
16-Jun-14 snunioolem ---        deleted
16-Jun-14 icoun     [--same--]  revised
16-Jun-14 icounlem  ---         deleted
16-Jun-14 elico2    [--same--]  revised
16-Jun-14 elioc2    [--same--]  revised
16-Jun-14 elixx2    ---         deleted; see elioo2, elico2, elioc2, elicc2
16-Jun-14 ixxssicc  ixxssixx    revised
16-Jun-14 uzwo3lem2 ---         deleted
16-Jun-14 uzwo3lem1 ---         deleted
16-Jun-14 uzwo5OLD  ---         deleted
16-Jun-14 uzwo4OLD  ---         deleted
16-Jun-14 fmptd     [--same--]  revised
15-Jun-14 pwtr      [--same--]  moved from AS's mathbox to main set.mm; revised
15-Jun-14 pwtrr     pwtr        moved from AS's mathbox to main set.mm; revised
12-Jun-14 eroprv2   erov2       (in JM's mathbox)
12-Jun-14 eroprv    erov        (in JM's mathbox)
12-Jun-14 eropreu   eroveu      (in JM's mathbox)
12-Jun-14 eroprlem  erovlem     (in JM's mathbox)
12-Jun-14 eloprvdm2 elovdm2     (in JM's mathbox)
12-Jun-14 eloprvdm  elovdm      (in JM's mathbox)
12-Jun-14 oprabval4gc ov4gc     (in FL's mathbox)
12-Jun-14 oprabval2gc ov2gc     (in FL's mathbox)
12-Jun-14 opreq123i oveq123i    (in FL's mathbox)
12-Jun-14 fnoprvrn2 fnovrn2     (in FL's mathbox)
12-Jun-14 fnoprvpop fnovpop     (in FL's mathbox)
12-Jun-14 oprssoprvg oprssopvg  (in FL's mathbox)
12-Jun-14 symgoprv  symgov
12-Jun-14 subgopr   subgov
12-Jun-14 ecoprdi   ecovdi
12-Jun-14 ecoprass  ecovass
12-Jun-14 ecoprcom  ecovcom
12-Jun-14 oprec     ovec
12-Jun-14 eceqopreq eceqoveq
12-Jun-14 ecopoprer ecopover
12-Jun-14 ecopoprtrn ecopovtrn
12-Jun-14 ecopoprsym ecopovsym
12-Jun-14 ecopoprdm ecopovdm
12-Jun-14 ecopopreq ecopoveq
12-Jun-14 onopriun  onoviun
12-Jun-14 onopruni  onovuni
12-Jun-14 fnopr2v   fnov2
12-Jun-14 caoprmo   caovmo
12-Jun-14 caoprlem2 caovlem2
12-Jun-14 caoprdilem caovdilem
12-Jun-14 caoprdistrr caovdistrr
12-Jun-14 caopr42   caov42
12-Jun-14 caopr411  caov411
12-Jun-14 caopr4    caov4
12-Jun-14 caopr13   caov13
12-Jun-14 caopr31   caov31
12-Jun-14 caopr12   caov12
12-Jun-14 caopr32   caov32
12-Jun-14 caoprdistr caovdistr
12-Jun-14 caoprdistrg caovdistrg
12-Jun-14 caoprord3 caovord3
12-Jun-14 caoprord2 caovord2
12-Jun-14 caoprord  caovord
12-Jun-14 caoprcan  caovcan
12-Jun-14 caoprass  caovass
12-Jun-14 caoprassg caovassg
12-Jun-14 caoprcom  caovcom
12-Jun-14 caoprcomg caovcomg
12-Jun-14 caoprcl   caovcl
12-Jun-14 caoprcld  caovcld
12-Jun-14 ndmordi   ndmovordi
12-Jun-14 ndmord    ndmovord
12-Jun-14 ndmoprdistr ndmovdistr
12-Jun-14 ndmoprass ndmovass
12-Jun-14 ndmoprcom ndmovcom
12-Jun-14 ndmoprrcl ndmovrcl
12-Jun-14 ndmopr    ndmov
12-Jun-14 ndmoprcl  ndmovcl
12-Jun-14 ndmoprg   ndmovg
12-Jun-14 oprvconst2 ovconst2
12-Jun-14 oprelimab ovelimab
12-Jun-14 funimass4b funimassov
12-Jun-14 oprvelrn  ovelrn
12-Jun-14 fnoprvrn  fnovrn
12-Jun-14 fooprv    foov
12-Jun-14 fnrnoprv  fnrnov
12-Jun-14 foprrn    fovrn
12-Jun-14 oprssoprv oprssov
12-Jun-14 oprvres   ovres
12-Jun-14 oprabval6g ov6g
12-Jun-14 oprabval4gALT ov4gALT
12-Jun-14 oprabval4g ov4g
12-Jun-14 oprabval3 ov3
12-Jun-14 oprabval5 ov5
12-Jun-14 oprabval2 ov2
12-Jun-14 oprabval2g ov2g
12-Jun-14 oprabval2ag ov2ag
12-Jun-14 oprabval2gf ov2gf
12-Jun-14 oprabvalig ovig
12-Jun-14 oprabvaligg ovigg
12-Jun-14 oprabval  ov
12-Jun-14 foprv     fov
12-Jun-14 fnoprv    fnov
12-Jun-14 eqfnoprv2 eqfnov2
12-Jun-14 eqfnoprv  eqfnov
12-Jun-14 foprcl    fovcl
12-Jun-14 ffnoprv   ffnov
12-Jun-14 elimdeloprv elimdelov
12-Jun-14 fnotoprb  fnopovb
12-Jun-14 rcla4eopr rcla4eov
12-Jun-14 csbopr2g  csbov2g
12-Jun-14 csbopr1g  csbov1g
12-Jun-14 csbopr12g csbov12g
12-Jun-14 csboprg   csbovg
12-Jun-14 oprprc2   ovprc2
12-Jun-14 oprprc1   ovprc1
12-Jun-14 oprex     ovex
12-Jun-14 hboprd    hbovd
12-Jun-14 hbopr     hbov
12-Jun-14 opreq123d oveq123d
12-Jun-14 opreqan12rd oveqan12rd
12-Jun-14 opreqan12d oveqan12d
12-Jun-14 opreq12d  oveq12d
12-Jun-14 opreqd    oveqd
12-Jun-14 opreq2d   oveq2d
12-Jun-14 opreq1d   oveq1d
12-Jun-14 opreqi    oveqi
12-Jun-14 opreq12i  oveq12i
12-Jun-14 opreq2i   oveq2i
12-Jun-14 opreq1i   oveq1i
12-Jun-14 opreq12   oveq12
12-Jun-14 opreq2    oveq2
12-Jun-14 opreq1    oveq1
12-Jun-14 opreq     oveq
12-Jun-14 df-opr    df-ov
11-Jun-14 pi1val    [--same--]  (in JM's mathbox) revised
11-Jun-14 pi1f      [--same--]  (in JM's mathbox) revised
11-Jun-14 pi1fval   [--same--]  (in JM's mathbox) revised
11-Jun-14 pi1bvalqs [--same--]  (in JM's mathbox) revised
11-Jun-14 pcorev    [--same--]  (in JM's mathbox) revised
11-Jun-14 pcorevlem [--same--]  (in JM's mathbox) revised
11-Jun-14 pcoass    [--same--]  (in JM's mathbox) revised
11-Jun-14 pcohtpy   [--same--]  (in JM's mathbox) revised
11-Jun-14 ---       ---         pcohtpylem1 - pcohtpylem3 deleted
11-Jun-14 pco1      [--same--]  (in JM's mathbox) revised
11-Jun-14 pco0      [--same--]  (in JM's mathbox) revised
11-Jun-14 pcocn     [--same--]  (in JM's mathbox) revised
11-Jun-14 pcoval2   [--same--]  (in JM's mathbox) revised
11-Jun-14 pcoval1   [--same--]  (in JM's mathbox) revised
11-Jun-14 pcoval    [--same--]  (in JM's mathbox) revised
11-Jun-14 pcofval   [--same--]  (in JM's mathbox) revised
11-Jun-14 df-pco    [--same--]  (in JM's mathbox) revised
11-Jun-14 reparpht  [--same--]  (in JM's mathbox) revised
11-Jun-14 ---       ---         reparphtlem1 - reparphtlem2 deleted
11-Jun-14 isphtpc2  ---         (in JM's mathbox) deleted; see isphtpc
11-Jun-14 isphtpc   [--same--]  (in JM's mathbox) revised
11-Jun-14 df-phtpc  [--same--]  (in JM's mathbox) revised
11-Jun-14 phtpyco   [--same--]  (in JM's mathbox) revised
11-Jun-14 ---       ---         phtpycolem1 - phtpycolem5 deleted
11-Jun-14 phtpycom  [--same--]  (in JM's mathbox) revised
11-Jun-14 phtpyid   [--same--]  (in JM's mathbox) revised
11-Jun-14 isphtpy   [--same--]  (in JM's mathbox) revised
11-Jun-14 phtpyval  [--same--]  (in JM's mathbox) revised
11-Jun-14 phtpyfval [--same--]  (in JM's mathbox) revised
11-Jun-14 df-phtpy  [--same--]  (in JM's mathbox) revised
11-Jun-14 ismrer1   [--same--]  (in JM's mathbox) revised
11-Jun-14 rrnval    [--same--]  (in JM's mathbox) revised
11-Jun-14 df-rrn    [--same--]  (in JM's mathbox) revised
11-Jun-14 bfp       [--same--]  (in JM's mathbox) revised
11-Jun-14 ---       ---         bfplem1 - bfplem11 deleted
11-Jun-14 heiborlem8 [--same--] (in JM's mathbox) revised
11-Jun-14 heibor1lem [--same--] (in JM's mathbox) revised
11-Jun-14 mulcntx   mulcn       moved from JM's mathbox to main set.mm
11-Jun-14 subcntx   subcn       moved from JM's mathbox to main set.mm
11-Jun-14 addcntx   addcn       moved from JM's mathbox to main set.mm
11-Jun-14 txcc      [--same--]  moved from JM's mathbox to main set.mm; revised
11-Jun-14 txmet     [--same--]  moved from JM's mathbox to main set.mm; revised
11-Jun-14 cnoprab2c ---         (in JM's mathbox) deleted; see cnmpt2nd,cnmpt21
11-Jun-14 cnoprab1c ---         (in JM's mathbox) deleted; see cnmpt1st,cnmpt21
11-Jun-14 cnoprab2  ---         (in JM's mathbox) deleted; see cnmpt2nd,cnmpt21
11-Jun-14 cnoprab1  ---         (in JM's mathbox) deleted; see cnmpt1st,cnmpt21
11-Jun-14 cnoproprabcoc ---     (in JM's mathbox) deleted; see cnmpt22f
11-Jun-14 cnoproprabco ---      (in JM's mathbox) deleted; see cnmpt22f
11-Jun-14 cnopropabcoc ---      (in JM's mathbox) deleted; see cnmpt12f
11-Jun-14 cnopropabco ---       (in JM's mathbox) deleted; see cnmpt12f
11-Jun-14 cnresoprab2 ---       (in JM's mathbox) deleted; see cnmpt2res
11-Jun-14 cnresoprab ---        (in JM's mathbox) deleted; see cnmpt2res
11-Jun-14 txsubsp   [--same--]  moved from JM's mathbox to main set.mm
11-Jun-14 txcnoprab ---         (in JM's mathbox) deleted; see cnmpt2t
11-Jun-14 lmtlm     ---         (in JM's mathbox) deleted
11-Jun-14 tlmconst  ---         (in JM's mathbox) deleted; see lmconst
11-Jun-14 haustlmu  ---         (in JM's mathbox) deleted; see lmmo
11-Jun-14 tlmbrf    ---         (in JM's mathbox) deleted; see lmbrf
11-Jun-14 tlmbr     ---         (in JM's mathbox) deleted; see lmbr
11-Jun-14 tlmval    ---         (in JM's mathbox) deleted; see lmfval
11-Jun-14 df-tlm    ---         (in JM's mathbox) deleted; see df-lm
11-Jun-14 ctlm      ---         (in JM's mathbox) deleted
11-Jun-14 hmeocnv   ---         (in JM's mathbox) deleted; see cnvhmpha
11-Jun-14 hmeocn    ---         (in JM's mathbox) deleted; see hmeobc
11-Jun-14 ishomeo2  ishomeo     moved from JM's mathbox to main set.mm
11-Jun-14 piececn   cnmpt2pc    (in JM's mathbox) revised
11-Jun-14 cnres     ---         (in JM's mathbox) deleted; see cnsubsp
11-Jun-14 cnimass   ---         (in JM's mathbox) deleted; see cnsubsp2
11-Jun-14 cncfco    [--same--]  moved from JM's mathbox to main set.mm; revised
11-Jun-14 metdcn    [--same--]  moved from JM's mathbox to main set.mm; revised
11-Jun-14 caures    [--same--]  moved from JM's mathbox to main set.mm; revised
11-Jun-14 caushft   [--same--]  (in JM's mathbox) revised
11-Jun-14 lmclim2   [--same--]  (in JM's mathbox) revised
11-Jun-14 geomcau   [--same--]  (in JM's mathbox) revised
11-Jun-14 mettrifi2 ---         (in JM's mathbox) deleted; see mettrifi
11-Jun-14 mettrifi  [--same--]  (in JM's mathbox) revised
11-Jun-14 csbrni    [--same--]  (in JM's mathbox) revised
11-Jun-14 trirni    ---         (in JM's mathbox) deleted; see isumshft
11-Jun-14 csbrni    csbrn       (in JM's mathbox) revised
11-Jun-14 fsumlt1   fsumge1     moved from JM's mathbox to main set.mm; revised
11-Jun-14 isumshft2 ---         (in JM's mathbox) deleted; see isumshft
11-Jun-14 iserzshft2 ---        (in JM's mathbox) deleted; see isershft
11-Jun-14 isumclf   ---         (in JM's mathbox) deleted; see isumcl
11-Jun-14 fsumleisum ---        (in JM's mathbox) deleted; see isumless
11-Jun-14 fsumleisumi ---       (in JM's mathbox) deleted; see isumless
11-Jun-14 fsumleisumii ---      (in JM's mathbox) deleted; see isumless
11-Jun-14 fsumltisum isumltss   moved from JM's mathbox to main set.mm; revised
11-Jun-14 fsumltisumi ---       (in JM's mathbox) deleted; see isumltss
11-Jun-14 fsumltisumii ---      (in JM's mathbox) deleted; see isumltss
11-Jun-14 fsumlt    [--same--]  moved from JM's mathbox to main set.mm; revised
11-Jun-14 fsum00OLD ---         (in JM's mathbox) deleted
11-Jun-14 seq1eq2   ---         (in JM's mathbox) deleted; see seqfveq
11-Jun-14 sdc       [--same--]  (in JM's mathbox) revised
11-Jun-14 sdclem2   [--same--]  (in JM's mathbox) revised
11-Jun-14 sdclem1   [--same--]  (in JM's mathbox) revised
11-Jun-14 seq1seqzgOLD ---      (in JM's mathbox) deleted
11-Jun-14 seqzp1gOLD ---        (in JM's mathbox) deleted
11-Jun-14 seqz1gOLD ---         (in JM's mathbox) deleted
11-Jun-14 seq1p1gOLD ---        (in JM's mathbox) deleted
11-Jun-14 seq11gOLD ---         (in JM's mathbox) deleted
11-Jun-14 divexp    expdiv      moved from JM's mathbox to main set.mm; revised
11-Jun-14 acdc5g    ---         (in JM's mathbox) deleted; see axdc4uz
11-Jun-14 acdc3g    ---         (in JM's mathbox) deleted; see axdc3
11-Jun-14 acdcg     ---         (in JM's mathbox) deleted; see axdc2
11-Jun-14 hbixp1    [--same--]  moved from JM's mathbox to main set.mm
11-Jun-14 cbvixpv   [--same--]  moved from JM's mathbox to main set.mm
11-Jun-14 cbvixp    [--same--]  moved from JM's mathbox to main set.mm
11-Jun-14 cnsubsp2  [--same--]  moved from JGH's mathbox to main set.mm
11-Jun-14 cnsubsp   [--same--]  moved from JGH's mathbox to main set.mm
11-Jun-14 avgle2    [--same--]  moved from JGH's mathbox to main set.mm
11-Jun-14 cntrsetlem ---        (in FL's mathbox) deleted
11-Jun-14 topgrpsubcnlem ---    (in FL's mathbox) deleted
11-Jun-14 exopcopn  [--same--]  (in FL's mathbox) revised
11-Jun-14 ttcn2     ---         (in FL's mathbox) deleted; see cnmpt1t
11-Jun-14 ttcn      ---         (in FL's mathbox) deleted; see cnmpt1t
11-Jun-14 eltpt     [--same--]  moved from FL's mathbox to main set.mm
11-Jun-14 eqindhome [--same--]  (in FL's mathbox) revised
11-Jun-14 hmeogrp   [--same--]  (in FL's mathbox) revised
11-Jun-14 rnhmpha   [--same--]  (in FL's mathbox) revised
11-Jun-14 dmhmpha   [--same--]  (in FL's mathbox) revised
11-Jun-14 cnvhmphb  ---         (in FL's mathbox) deleted; see cnvhmph
11-Jun-14 df-mmat   [--same--]  (in FL's mathbox) revised
11-Jun-14 df-expsg  [--same--]  (in FL's mathbox) revised
11-Jun-14 seqzp2    [--same--]  (in FL's mathbox) revised
11-Jun-14 isppm     [--same--]  (in FL's mathbox) revised
11-Jun-14 fprod1ib  fprod2      (in FL's mathbox) revised
11-Jun-14 fprod1i2  ---         (in FL's mathbox) deleted; see fprod1i
11-Jun-14 relsumprd fsumprd     (in FL's mathbox) revised
11-Jun-14 fprodp1s1 ---         (in FL's mathbox) deleted; see fprodp1s
11-Jun-14 fprodp1s1 ---         (in FL's mathbox) deleted; see fprodp1s
11-Jun-14 fprodp1s  [--same--]  (in FL's mathbox) revised
11-Jun-14 fprodp1slem ---       (in FL's mathbox) deleted
11-Jun-14 fprodp1fi [--same--]  (in FL's mathbox) revised
11-Jun-14 fprod1s1  ---         (in FL's mathbox) deleted; see fprod1s
11-Jun-14 fprod1s2  fprod1s     (in FL's mathbox) revised
11-Jun-14 fprod1slem ---        (in FL's mathbox) deleted
11-Jun-14 fprod1fi  [--same--]  (in FL's mathbox) revised
11-Jun-14 fprodp1i  [--same--]  (in FL's mathbox) revised
11-Jun-14 fprod1i   [--same--]  (in FL's mathbox) revised
11-Jun-14 fprodserzfi fprodserf (in FL's mathbox) revised
11-Jun-14 fprodserz fprodser    (in FL's mathbox) revised
11-Jun-14 dffprod   [--same--]  (in FL's mathbox) revised
11-Jun-14 prodeqfv  [--same--]  (in FL's mathbox) revised
11-Jun-14 prodeq3d  [--same--]  (in FL's mathbox) revised
11-Jun-14 prodeq123d [--same--] (in FL's mathbox) revised
11-Jun-14 prodeq123i [--same--] (in FL's mathbox) revised
11-Jun-14 prodeq3   prodeq2     (in FL's mathbox) (these labels should be
11-Jun-14 prodeq2   prodeq3     (in FL's mathbox)  exchanged at the same time)
11-Jun-14 valproemset prod0     (in FL's mathbox)
11-Jun-14 df-prod2  ---         (in FL's mathbox) deleted; see df-prod
11-Jun-14 df-prod   [--same--]  (in FL's mathbox) revised
11-Jun-14 cprd2     ---         (in FL's mathbox) deleted
11-Jun-14 cprd      [--same--]  (in FL's mathbox) revised
11-Jun-14 seq0p1g   ---         (in FL's mathbox) deleted; see seqp1
11-Jun-14 seq00g    ---         (in FL's mathbox) deleted; see seq1
11-Jun-14 iserzmulc1b ---       (in FL's mathbox) deleted; see isermulc2
11-Jun-14 prjnpl    resixp      moved from FL's mathbox to main set.mm
11-Jun-14 cbicp     [--same--]  (in FL's mathbox) revised
11-Jun-14 cbicplem  ---         (in FL's mathbox) deleted
11-Jun-14 isprj2    [--same--]  (in FL's mathbox) revised
11-Jun-14 isprj1    [--same--]  (in FL's mathbox) revised
11-Jun-14 hbcp      ---         (in FL's mathbox) deleted; see hbixp1
11-Jun-14 valpr     [--same--]  (in FL's mathbox) changed variable names
11-Jun-14 prmapcp3  ---         (in FL's mathbox) deleted; see prmapcp2
11-Jun-14 prmapcp2  [--same--]  (in FL's mathbox) changed variable names
11-Jun-14 ispr1     [--same--]  (in FL's mathbox) revised
11-Jun-14 df-prj    [--same--]  (in FL's mathbox) revised
11-Jun-14 df-pro    [--same--]  (in FL's mathbox) revised
11-Jun-14 dffn5b    ---         (in FL's mathbox) deleted; see dffn5v
11-Jun-14 fopabco3  fmptco      moved from FL's mathbox to main set.mm
11-Jun-14 riemtn    ---         (in FL's mathbox) deleted; see mptresid
11-Jun-14 riecb     ---         (in FL's mathbox) deleted; see opabresid
11-Jun-14 cmpran    ---         (in FL's mathbox) deleted; see rnmpt
11-Jun-14 fopab2a   ---         (in FL's mathbox) deleted; see fmpt
11-Jun-14 fopab2ga  ---         (in FL's mathbox) deleted; see fnmpt
11-Jun-14 cmpbvb    ---         (in FL's mathbox) deleted; see cbvmptv
11-Jun-14 fmptb     ---         (in FL's mathbox) deleted; see fmpt2
11-Jun-14 seq0clg   ---         (in FL's mathbox) deleted; see seqcl
11-Jun-14 bpolydiflem2 ---      (in SF's mathbox) deleted
11-Jun-14 bpolydiflem1 ---      (in SF's mathbox) deleted
11-Jun-14 bernpolycl bpolycl    (in SF's mathbox)
11-Jun-14 bernpoly1 bpoly1      (in SF's mathbox)
11-Jun-14 bernpolynn ---        (in SF's mathbox) deleted; see bpolyval
11-Jun-14 bernpoly0 bpoly0      (in SF's mathbox)
11-Jun-14 bernpolyval bpolyval  (in SF's mathbox) revised
11-Jun-14 df-bernpoly df-bpoly  (in SF's mathbox) revised
11-Jun-14 cbernpoly cbp         (in SF's mathbox)
11-Jun-14 fsumsq    ---         (in SF's mathbox) deleted; see fsumge0
11-Jun-14 trirecip  [--same--]  (in SF's mathbox) revised
11-Jun-14 trireciplem [--same--] (in SF's mathbox) revised
11-Jun-14 arisum4   ---         (in SF's mathbox) deleted; see arisum
11-Jun-14 arisum3   ---         (in SF's mathbox) deleted; see arisum
11-Jun-14 arisum2   ---         (in SF's mathbox) deleted; see arisum
11-Jun-14 arisum    [--same--]  moved from SF's mathbox to main set.mm; revised
11-Jun-14 binomp1m1 [--same--]  moved from SF's mathbox to main set.mm
11-Jun-14 binom21   [--same--]  moved from SF's mathbox to main set.mm
11-Jun-14 binom1dif [--same--]  moved from SF's mathbox to main set.mm
11-Jun-14 binom1    ---         (in SF's mathbox) deleted; see binom1p
11-Jun-14 binom     [--same--]  moved from SF's mathbox to main set.mm
11-Jun-14 bcsum     ---         (in SF's mathbox) deleted; see binom11
11-Jun-14 fsumtelescope2 fsumtscop moved from SF's mathbox to main set.mm
11-Jun-14 fsumtelescope ---     (in SF's mathbox) deleted; see fsumtscop
11-Jun-14 fsumsplitlast ---     (in SF's mathbox) deleted; see fsump1
11-Jun-14 fseq1cl   ---         (in PC's mathbox) deleted; see seqcl
11-Jun-14 seq1resval2 ---       (in PC's mathbox) deleted; see seqfveq
11-Jun-14 seq1resval ---        (in PC's mathbox) deleted; see seqfveq
11-Jun-14 seqzresval2 ---       (in PC's mathbox) deleted; see seqfveq
11-Jun-14 ---       ---         circumlem1 - circumlem3 deleted
11-Jun-14 sindivcvg sinccvg     (in PC's mathbox)
11-Jun-14 ---       ---         sindivcvglem1 - sindivcvglem8 deleted
11-Jun-14 efexple   [--same--]  (in MC's mathbox) revised
11-Jun-14 bclbnd2   bclbnd      (in MC's mathbox)
11-Jun-14 bclbnd    ---         (in MC's mathbox) deleted
11-Jun-14 elpjrnch  elpjch
11-Jun-14 elpjch    [--same--]  revised
11-Jun-14 pjhmopidm [--same--]  revised
11-Jun-14 hmopidmpj [--same--]  revised
11-Jun-14 hmopidmch [--same--]  revised
11-Jun-14 hmopidmpji [--same--] revised
11-Jun-14 hmopidmchi [--same--] revised
11-Jun-14 hmopidmchlem ---      deleted
11-Jun-14 opsqrlem6 [--same--]  revised
11-Jun-14 opsqrlem5 [--same--]  revised
11-Jun-14 opsqrlem4 [--same--]  revised
11-Jun-14 opsqrlem3 [--same--]  revised
11-Jun-14 opsqrlem2 [--same--]  revised
11-Jun-14 chso      pjth
11-Jun-14 ---       ---         osumlem1 - osumlem8 deleted
11-Jun-14 pjtheu2i  pjtheu2     revised
11-Jun-14 pjeq2     ---         deleted; see pjeq
11-Jun-14 pjtheui   ---         deleted; see pjtheu
11-Jun-14 pjth      [--same--]  revised
11-Jun-14 pjthi     ---         deleted; see pjth
11-Jun-14 ---       ---         pjthlem3 - pjthlem14 deleted
11-Jun-14 pjthlem2  [--same--]  revised
11-Jun-14 pjthlem1  [--same--]  revised
11-Jun-14 projlemHIL ---        deleted
11-Jun-14 projlem   ---         deleted
11-Jun-14 ---       ---         projlem1 - projlem31 deleted
11-Jun-14 occli     ---         deleted; see occl
11-Jun-14 ---       ---         occllem1 - occllem8 deleted
11-Jun-14 hlimeui   [--same--]  revised
11-Jun-14 hlimreui  [--same--]  revised
11-Jun-14 hlimuniii ---         deleted; see hlimunii
11-Jun-14 hlimcauii ---         deleted; see hlimcaui
11-Jun-14 hilcmpl   [--same--]  revised
11-Jun-14 hhcmpl    [--same--]  revised
11-Jun-14 hhlm      [--same--]  revised
11-Jun-14 hilcau    ---         deleted; see hhcau
11-Jun-14 hillim    ---         deleted; see hhlm
11-Jun-14 hlim2     [--same--]  revised
11-Jun-14 hlimconvi [--same--]  revised
11-Jun-14 hlimi     [--same--]  revised
11-Jun-14 hcau2     ---         deleted; see hcau
11-Jun-14 seq1hcau  [--same--]  revised
11-Jun-14 hcaucvg   [--same--]  revised
11-Jun-14 hcau      [--same--]  revised
11-Jun-14 h2hlm     [--same--]  revised
11-Jun-14 df-hcau   [--same--]  revised
11-Jun-14 df-hlim   [--same--]  revised
11-Jun-14 hmph      [--same--]  revised
11-Jun-14 hmeobc    [--same--]  revised
11-Jun-14 ishomeo   [--same--]  revised
11-Jun-14 df-hmph   [--same--]  revised
11-Jun-14 relogexp  [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 reexplog  [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 explog    [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 pilog     logm1       revised
11-Jun-14 resslogrn relogrn     revised
11-Jun-14 logrn     [--same--]  revised
11-Jun-14 df-log    [--same--]  revised
11-Jun-14 eff1o     [--same--]  revised
11-Jun-14 eff1oi    eff1olem    revised
11-Jun-14 effoi     ---         deleted; see eff1o
11-Jun-14 eff1i     ---         deleted; see eff1o
11-Jun-14 eff1lem   ---         deleted
11-Jun-14 shftefif1o ---        deleted; see efif1o
11-Jun-14 shftefif1olem ---     deleted
11-Jun-14 circgrp   [--same--]  revised
11-Jun-14 efielcirc ---         deleted
11-Jun-14 efif1o    [--same--]  revised
11-Jun-14 efif1     ---         deleted; see efif1o
11-Jun-14 ---       ---         efif1lem1 - efif1lem7 deleted
11-Jun-14 efifo     ---         deleted; see efif1o
11-Jun-14 ---       ---         efifolem1 - efifolem7 deleted
11-Jun-14 efif      ---         deleted; see efif1o
11-Jun-14 efghgrpi  efghgrp     revised
11-Jun-14 efghgrpilem ---       deleted
11-Jun-14 efgh      [--same--]  revised
11-Jun-14 cosh111   cos11       revised
11-Jun-14 ---       ---         cosh111lem1 - cosh111lem3 deleted
11-Jun-14 sineq0re  ---         deleted; see sineq0
11-Jun-14 sineq0OLD ---         deleted; see sineq0
11-Jun-14 sineq0    [--same--]  revised
11-Jun-14 sinq12gt0t sinq12gt0
11-Jun-14 sinperlem2 ---        deleted
11-Jun-14 sinperlem1 ---        deleted
11-Jun-14 pilem4    ---         deleted; see pilem3
11-Jun-14 pilem3    [--same--]  revised
11-Jun-14 pilem2    [--same--]  revised
11-Jun-14 pilem1    [--same--]  revised
11-Jun-14 cosco     ---         deleted
11-Jun-14 sinco     ---         deleted
11-Jun-14 sincnlem  ---         deleted
11-Jun-14 sincolem  ---         deleted
11-Jun-14 hlcompl   [--same--]  revised
11-Jun-14 minvecex2 ---         deleted; see minvec
11-Jun-14 minveclem39 ---       deleted
11-Jun-14 minvecle  ---         deleted; see minvec
11-Jun-14 minvecdist ---        deleted; see minvec
11-Jun-14 minveccl  ---         deleted; see minvec
11-Jun-14 minveceu   minvec     revised
11-Jun-14 ---       ---         minveclem35 - minveclem38 deleted
11-Jun-14 minvecex  ---         deleted; see minvec
11-Jun-14 ---       ---         minveclem10 - minveclem33 deleted
11-Jun-14 minvec34   ---        deleted
11-Jun-14 minveclem7 [--same--] revised
11-Jun-14 minveclem6 [--same--] revised
11-Jun-14 minveclem5 [--same--] revised
11-Jun-14 minveclem4 [--same--] revised
11-Jun-14 minveclem3 [--same--] revised
11-Jun-14 minveclem2 [--same--] revised
11-Jun-14 minveclem1 [--same--] revised
11-Jun-14 ipasslem7 [--same--]  revised
11-Jun-14 ipasslem6 ---         deleted
11-Jun-14 ip1cni    ---         deleted; see ipcn
11-Jun-14 ---       ---         ip1cnilem1 - ip1cnilem6 deleted
11-Jun-14 ipval2lem1 ---        deleted
11-Jun-14 sm1cni    ---         deleted; see smcn
11-Jun-14 sm1cnilem ---         deleted
11-Jun-14 va1cn     ---         deleted; see vacn and cnmpt12
11-Jun-14 va1cnlem  ---         deleted
11-Jun-14 vacn      [--same--]  revised
11-Jun-14 ---       ---         vacnlem1 - vacnlem6 deleted
11-Jun-14 nvlmle    [--same--]  revised
11-Jun-14 nvlmcl    [--same--]  revised
11-Jun-14 ghsubgi   ghsubg      revised
11-Jun-14 ghgrpi    ghgrp       revised
11-Jun-14 ---       ---         ghgrpilem1 - ghgrpilem4 deleted
11-Jun-14 bcthlem3  [--same--]  revised
11-Jun-14 cmsss     [--same--]  revised
11-Jun-14 lmcau     [--same--]  revised
11-Jun-14 iscms2i   iscms3i     revised
11-Jun-14 iscms2    iscms3      revised
11-Jun-14 ---       ---         iscms2lem3 - iscms2lem5 deleted
11-Jun-14 fsumcn    [--same--]  revised
11-Jun-14 fsumcnlem ---         deleted
11-Jun-14 mulcn     [--same--]  revised
11-Jun-14 subcn     [--same--]  revised
11-Jun-14 addcn     [--same--]  revised
11-Jun-14 bopcn     ---         deleted; see metcn4
11-Jun-14 ---       ---         bopcnlem1 - bopcnlem4 deleted
11-Jun-14 opr1scn   ---         deleted; see cnmpt12f and cnmptid, cnmptc
11-Jun-14 opr2cn    ---         deleted; see cnmpt12f and cnmptc
11-Jun-14 opr1cn    ---         deleted; see cnmpt12f and cnmptc
11-Jun-14 oprcn     ---         deleted; see cnmpt12f
11-Jun-14 xpcn      ---         deleted; see cnmpt1t
11-Jun-14 xplm      ---         deleted; see txlm
11-Jun-14 xplmi2    ---         deleted; see txlm
11-Jun-14 xplmi     ---         deleted; see txlm
11-Jun-14 metcnp4   [--same--]  revised
11-Jun-14 metcnp4lem2 ---       deleted
11-Jun-14 metcnp4lem1 ---       deleted
11-Jun-14 caublcls  [--same--]  revised
11-Jun-14 metcld    [--same--]  revised
11-Jun-14 metcls    ---         deleted; see metelcls
11-Jun-14 metelcls  [--same--]  revised
11-Jun-14 metcls2   ---         deleted; see lmcls
11-Jun-14 lmclimnn  lmclimf     revised
11-Jun-14 lmclim    [--same--]  revised
11-Jun-14 lmle      [--same--]  revised
11-Jun-14 lmfex     ---         deleted
11-Jun-14 lmfexlem3 ---         deleted
11-Jun-14 lmfexlem2 ---         deleted
11-Jun-14 lmfexlem1 ---         deleted
11-Jun-14 caussi    [--same--]  revised
11-Jun-14 lmss      [--same--]  revised
11-Jun-14 lmsslem   ---         deleted
11-Jun-14 lmuni     lmmo        revised
11-Jun-14 caufss    caufpm      revised
11-Jun-14 lmcl      [--same--]  revised
11-Jun-14 lmfss     [--same--]  revised
11-Jun-14 cmscvg    [--same--]  revised
11-Jun-14 iscms     [--same--]  revised
11-Jun-14 iscaunns  ---         deleted; see iscauf
11-Jun-14 lmcvgnns  ---         deleted; see lmmcvg
11-Jun-14 lmbrnns   ---         deleted; see iscauf
11-Jun-14 iscau5    ---         deleted; see iscauf
11-Jun-14 iscau4    [--same--]  revised
11-Jun-14 iscauf    [--same--]  revised
11-Jun-14 iscau3    [--same--]  revised
11-Jun-14 iscau2    [--same--]  revised
11-Jun-14 iscau     [--same--]  revised
11-Jun-14 lmnn      [--same--]  revised
11-Jun-14 lmconst   [--same--]  revised
11-Jun-14 lmcvg2    ---         deleted; see lmcvg
11-Jun-14 lmcvg     [--same--]  revised
11-Jun-14 lmbrf2    ---         deleted; see lmbrf
11-Jun-14 lmbrf     [--same--]  revised
11-Jun-14 lmbr2     [--same--]  revised
11-Jun-14 lmbr      [--same--]  revised
11-Jun-14 lmrel     [--same--]  revised
11-Jun-14 caufval   [--same--]  revised
11-Jun-14 lmfval    [--same--]  revised
11-Jun-14 df-cmet   [--same--]  revised
11-Jun-14 df-cau    [--same--]  revised
11-Jun-14 df-lm     [--same--]  revised
11-Jun-14 clm       [--same--]  revised
11-Jun-14 dscmet    [--same--]  revised
11-Jun-14 cn2met    [--same--]  revised
11-Jun-14 metdnsconst ---       deleted; see dnsconst
11-Jun-14 metxp     [--same--]  revised
11-Jun-14 metxplem4 [--same--]  revised
11-Jun-14 metxpcl   [--same--]  revised
11-Jun-14 metxpfval [--same--]  revised
11-Jun-14 metxptval [--same--]  revised
11-Jun-14 metxpdval [--same--]  revised
11-Jun-14 2txcn     ---         deleted; see cnmpt2t
11-Jun-14 txcnopab  txcnmpt     revised
11-Jun-14 txcn      [--same--]  revised
11-Jun-14 tx2cn     [--same--]  revised
11-Jun-14 tx1cn     [--same--]  revised
11-Jun-14 txcld     [--same--]  revised
11-Jun-14 txopn     [--same--]  revised
11-Jun-14 txuni     [--same--]  revised
11-Jun-14 txtop     [--same--]  revised
11-Jun-14 subspuni    [--same--]  revised
11-Jun-14 1arith2   [--same--]  revised
11-Jun-14 1arith    [--same--]  revised
11-Jun-14 ---       ---         1arithlem4 - 1arithlem31 deleted
11-Jun-14 1arithlem4 [--same--] revised
11-Jun-14 1arithlem3 [--same--] revised
11-Jun-14 1arithlem2 [--same--] revised
11-Jun-14 1arithlem1 [--same--] revised
11-Jun-14 ---       ---         mulgcdlem1 - mulgcdlem7 deleted
11-Jun-14 eucalg    [--same--]  revised
11-Jun-14 eucalgcvga [--same--] revised
11-Jun-14 eucalglt  [--same--]  revised
11-Jun-14 eucalginv [--same--]  revised
11-Jun-14 eucalgf   [--same--]  revised
11-Jun-14 eucalgval2 [--same--] revised
11-Jun-14 eucalgval [--same--]  revised
11-Jun-14 algfx     [--same--]  revised
11-Jun-14 algcvga   [--same--]  revised
11-Jun-14 algcvg    [--same--]  revised
11-Jun-14 alginv    [--same--]  revised
11-Jun-14 algrp1    [--same--]  revised
11-Jun-14 algrp1lem ---         deleted
11-Jun-14 algr0     [--same--]  revised
11-Jun-14 algrf     [--same--]  revised
11-Jun-14 ruclem39  ruclem13
11-Jun-14 ---       ---         ruclem13 - ruclem38 deleted
11-Jun-14 ruclem12  [--same--]  revised
11-Jun-14 ruclem11  [--same--]  revised
11-Jun-14 ruclem10  [--same--]  revised
11-Jun-14 ruclem9   [--same--]  revised
11-Jun-14 ruclem8   [--same--]  revised
11-Jun-14 ruclem7   [--same--]  revised
11-Jun-14 ruclem6   [--same--]  revised
11-Jun-14 ruclem5   [--same--]  revised
11-Jun-14 ruclem4   [--same--]  revised
11-Jun-14 ruclem3   [--same--]  revised
11-Jun-14 ruclem2   [--same--]  revised
11-Jun-14 ruclem1   [--same--]  revised
11-Jun-14 rpnnen2lem11 [--same--] revised
11-Jun-14 rpnnen2lem10 [--same--] revised
11-Jun-14 rpnnen2lem9 [--same--] revised
11-Jun-14 rpnnen2lem8 [--same--] revised
11-Jun-14 rpnnen2lem7 [--same--] revised
11-Jun-14 rpnnen2lem6 [--same--] revised
11-Jun-14 rpnnen2lem5 [--same--] revised
11-Jun-14 rpnnen2lem4 [--same--] revised
11-Jun-14 rpnnen2lem3 [--same--] revised
11-Jun-14 rpnnen2lem2 [--same--] revised
11-Jun-14 rpnnen2lem1 [--same--] revised
11-Jun-14 acdcALT   ---         deleted; see axdc2
11-Jun-14 acdc      ---         deleted; see axdc2
11-Jun-14 acdclem   ---         deleted
11-Jun-14 acdc5     ---         deleted; see axdc4
11-Jun-14 acdc5lem2 ---         deleted
11-Jun-14 acdc5lem1 ---         deleted
11-Jun-14 acdc2     ---         deleted; see axdc4
11-Jun-14 acdc2lem2 ---         deleted
11-Jun-14 acdc2lem1 ---         deleted
11-Jun-14 acdc4lem1 ---         deleted
11-Jun-14 acdc3     ---         deleted; see axdc3
11-Jun-14 acdc3lem  ---         deleted
11-Jun-14 demoivre  ---         generalized antecedent to N e. ZZ
11-Jun-14 ---       ---         cos01bndlem2 - cos01bndlem3 deleted
11-Jun-14 ---       ---         sin01bndlem1 - sin01bndlem3 deleted
11-Jun-14 cos2OLD   ---         deleted; see cos2t
11-Jun-14 subcos    [--same--]  revised
11-Jun-14 cosaddi   ---         deleted; see cosadd
11-Jun-14 sinaddi   ---         deleted; see sinadd
11-Jun-14 sin0ALT   ---         deleted; see sin0
11-Jun-14 efi4p     [--same--]  revised
11-Jun-14 reeff1olem2 ---       deleted
11-Jun-14 reeff1olem1 ---       deleted
11-Jun-14 ---       ---         efcnlem1 - efcnlem1 deleted
11-Jun-14 efm1legeo ---         deleted
11-Jun-14 efm1legeoi ---        deleted
11-Jun-14 eflegeo   [--same--]  revised
11-Jun-14 eflegeoi  ---         deleted
11-Jun-14 eflegeolem2 ---       deleted
11-Jun-14 eflegeolem1 ---       deleted
11-Jun-14 absefm1lei ---        deleted
11-Jun-14 efm1limi  ---         deleted
11-Jun-14 efltbi    ---         deleted; see eflt
11-Jun-14 eflti     [--same--]  revised
11-Jun-14 efgt0i    ---         deleted; see efgt0
11-Jun-14 efgt0i    ---         deleted; see efgt0
11-Jun-14 efgt1pi   efgt1p      revised
11-Jun-14 efgt1i    efgt1       revised
11-Jun-14 efge1pi   ---         deleted; see efgt1p
11-Jun-14 efge1i    ---         deleted; see efgt1
11-Jun-14 ef4p      [--same--]  revised
11-Jun-14 ef4pi     ---         deleted; see ef4p
11-Jun-14 eft0vali  eft0val     revised
11-Jun-14 effsumlei effsumlt    revised
11-Jun-14 efsepi    efsep       revised
11-Jun-14 abspef01tlubi ---     deleted; see eftlub
11-Jun-14 elt3OLD   ---         deleted; see egt2lt3
11-Jun-14 egt2OLD   ---         deleted; see egt2lt3
11-Jun-14 ---       ---         eirrlem1 - eirrlem5 deleted
11-Jun-14 absef01tlubi eftlub   revised
11-Jun-14 absef01tllem ---      deleted
11-Jun-14 ef01tlubi ---         deleted; see eftlub
11-Jun-14 ef01tllem2OLD ---     deleted
11-Jun-14 ef01tllem2 ---        deleted
11-Jun-14 ef01tllem1 ---        deleted
11-Jun-14 ef1tlubi  ---         deleted; see eftlub
11-Jun-14 ef1tllem  ---         deleted
11-Jun-14 reeftlcl  [--same--]  revised
11-Jun-14 eftlcl    [--same--]  revised
11-Jun-14 eftlex    eftlcvg     revised
11-Jun-14 eftlexiOLD ---        deleted
11-Jun-14 eftlubcl  ---         deleted
11-Jun-14 eftabsi   eftabs      revised
11-Jun-14 efnn0val  efzval      generalized antecedent to N e. ZZ
11-Jun-14 efexp     [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 efaddi    ---         deleted; see efadd
11-Jun-14 ---       ---         efaddlem1 - efaddlem28 deleted
11-Jun-14 efcji     ---         deleted; see efcj
11-Jun-14 ege2le3   [--same--]  revised; see egt2lt3
11-Jun-14 ele3      ---         deleted; see egt2lt3
11-Jun-14 ege2      ---         deleted; see egt2lt3
11-Jun-14 ereALT    ---         deleted; see ere
11-Jun-14 ege2le3lem2 ---       deleted
11-Jun-14 ege2lem2  ---         deleted
11-Jun-14 ege2le3lem1 ---       deleted
11-Jun-14 ele3lem   ---         deleted
11-Jun-14 ---       ---         erelem1 - erelem7 deleted
11-Jun-14 reefcli   ---         deleted; see reefcl
11-Jun-14 eftval    [--same--]  revised
11-Jun-14 efcvgfsum [--same--]  revised
11-Jun-14 efcvg     [--same--]  revised
11-Jun-14 efseq0ex  ---         deleted; see efcllem
11-Jun-14 ef0lem    [--same--]  revised
11-Jun-14 dfef2i    ---         deleted
11-Jun-14 efseq1ex  ---         deleted; see efcllem
11-Jun-14 efcltlem2 ---         deleted; see ef0lem
11-Jun-14 efcltlem1 ---         deleted; see efcllem
11-Jun-14 df-pi     [--same--]  revised
11-Jun-14 df-tan    [--same--]  revised
11-Jun-14 dsupivthi ivth2       revised
11-Jun-14 dsupivthlem ---       deleted
11-Jun-14 isupivthi ivth        revised
11-Jun-14 ---       ---         ivthlem1 - ivthlem9 deleted
11-Jun-14 divccncf  [--same--]  revised
11-Jun-14 mulc1cncf [--same--]  revised
11-Jun-14 abscncflem ---        deleted
11-Jun-14 negfcncfi negfcncf    revised
11-Jun-14 fsum0diag4 ---        deleted; see fsum0diag
11-Jun-14 fsum0diag3 ---        deleted; see fsum0diag
11-Jun-14 fsum0diag2 ---        deleted; see fsum0diag
11-Jun-14 fsum0diag [--same--]  revised
11-Jun-14 fsum0diaglem2 ---     deleted
11-Jun-14 fsum0diaglem1 ---     deleted
11-Jun-14 cvgrati   cvgrat      revised
11-Jun-14 ---       ---         cvgratlem1 - cvgratlem5 deleted
11-Jun-14 ---       ---         cvgratlem1ALT - cvgratlem3ALT deleted
11-Jun-14 geosum2i  ---         deleted; see geoser
11-Jun-14 geosumi   ---         deleted; see geoser
11-Jun-14 georeclim [--same--]  revised
11-Jun-14 geolim1   ---         deleted; see geolim2
11-Jun-14 geolim1i  ---         deleted; see geolim2
11-Jun-14 geolim    [--same--]  revised
11-Jun-14 geolimi   ---         deleted; see geolim
11-Jun-14 geolimilem ---        deleted
11-Jun-14 geoseri   geoser      revised
11-Jun-14 explecnv  [--same--]  revised
11-Jun-14 expcnv    [--same--]  revised
11-Jun-14 ---       ---         expcnvlem1 - expcnvlem6 deleted
11-Jun-14 arisumi   arisum      revised
11-Jun-14 arisumilem ---        deleted
11-Jun-14 supcvg    [--same--]  revised
11-Jun-14 supcvglem ---         deleted
11-Jun-14 reccnv    divcnv      revised
11-Jun-14 binom11i  binom11
11-Jun-14 binom1pi  binom1p     revised
11-Jun-14 binomi    binom       revised
11-Jun-14 ---       ---         binomlem1 - binomlem6 deleted
11-Jun-14 ser0cji   ---         deleted; see sercj
11-Jun-14 serzcji   sercj       revised
11-Jun-14 serzimi   serim       revised
11-Jun-14 serzrei   serre       revised
11-Jun-14 serzrelem ---         deleted
11-Jun-14 ser1mulci ---         deleted; see seqdistr
11-Jun-14 ser0mulci ---         deleted; see seqdistr
11-Jun-14 serzmulci ---         deleted; see seqdistr
11-Jun-14 serzmulc1 ---         deleted; see seqdistr
11-Jun-14 serzsplit ---         deleted; see seqsplit
11-Jun-14 serzcmp0  serge0      revised
11-Jun-14 serzcmp   sercmp      revised
11-Jun-14 serz0     ser0        revised
11-Jun-14 serz1p    seq1p       revised
11-Jun-14 serzrefi  serfre      revised
11-Jun-14 serzrecl  ---         deleted; see serfre
11-Jun-14 serzcl2   ---         deleted; see serf
11-Jun-14 ser1ser0i ---         deleted; see seq1p
11-Jun-14 ser1cl    ---         deleted; see seqcl
11-Jun-14 ser0cl    ---         deleted; see seqcl
11-Jun-14 serzcl    ---         deleted; see seqcl
11-Jun-14 fsumabs2mul ---       deleted; see fsum2mul and fsumabs
11-Jun-14 fsumabs   [--same--]  revised
11-Jun-14 fsum00    [--same--]  revised
11-Jun-14 fsumcmpndx2 fsumcmpss revised
11-Jun-14 fsumcmp0  fsumge0     revised
11-Jun-14 fsumcmp   [--same--]  revised
11-Jun-14 fsum0     ---         deleted; see sumz
11-Jun-14 fsumconst [--same--]  revised
11-Jun-14 fsum2mul  [--same--]  revised
11-Jun-14 fsumsub   [--same--]  revised
11-Jun-14 fsumneg   [--same--]  revised
11-Jun-14 fsumdivcALT ---       deleted
11-Jun-14 fsumdivc  [--same--]  revised
11-Jun-14 fsummulc2 fsummulc1   revised
11-Jun-14 fsummulc1 fsummulc2   revised
11-Jun-14 fsumshftm [--same--]  revised
11-Jun-14 fsumshft  [--same--]  revised
11-Jun-14 fsumrev2  [--same--]  revised
11-Jun-14 fsumrev   [--same--]  revised
11-Jun-14 fsumcom   [--same--]  revised
11-Jun-14 csbfsum   [--same--]  deleted; see sumeq2sdv
11-Jun-14 csbfsumlem [--same--] deleted
11-Jun-14 fsum4     [--same--]  deleted; see fsump1i
11-Jun-14 fsum3     [--same--]  deleted; see fsump1i
11-Jun-14 fsum2     [--same--]  deleted; see fsump1i
11-Jun-14 fsumadd   [--same--]  revised
11-Jun-14 fsumid2   ---         deleted; see fsumss
11-Jun-14 fsum0split ---        deleted; see fsumsplit
11-Jun-14 fsumsplit [--same--]  revised
11-Jun-14 fsum1p    [--same--]  revised
11-Jun-14 fsum1ps   ---         deleted; see fsum1p
11-Jun-14 fsumrecl  [--same--]  revised
11-Jun-14 fsum0cl   ---         deleted; see fsumcl
11-Jun-14 fsumcl    [--same--]  revised
11-Jun-14 fsumcllem [--same--]  revised; see this or fsumcl2lem
11-Jun-14 fsump1s   ---         deleted; see fsump1
11-Jun-14 fsump1slem ---        deleted
11-Jun-14 fsump1fi  ---         deleted; see fsump1
11-Jun-14 fsum1s2   ---         deleted; see sumsns
11-Jun-14 fsum1s    ---         deleted; see sumsns
11-Jun-14 fsum1slem ---         deleted
11-Jun-14 fsum1fi   ---         deleted; see fsum1
11-Jun-14 fsump1i   fsump1      revised
11-Jun-14 fsum1i    fsum1       revised
11-Jun-14 serzfsum  ---         deleted; see fsumser
11-Jun-14 fsumserz2 ---         deleted; see fsumser
11-Jun-14 fsumser1fi ---        deleted; see fsumser
11-Jun-14 fsumser0fi ---        deleted; see fsumser
11-Jun-14 fsumserzfi ---        deleted; see fsumser
11-Jun-14 fsumserz  fsumser     revised
11-Jun-14 dffsum    ---         deleted; see fsumser
11-Jun-14 sumeqfv   sumfc       revised
11-Jun-14 df-sum    [--same--]  revised
11-Jun-14 cvgcmp3ce cvgcmpce    revised
11-Jun-14 cvgcmp3cetlem2 ---    deleted
11-Jun-14 cvgcmp3cetlem1 ---    deleted
11-Jun-14 cvgcmp3cei ---        deleted; see cvgcmpce
11-Jun-14 cvgcmp3ci ---         deleted; see cvgcmpce
11-Jun-14 cvgcmpubi cvgcmpub    revised
11-Jun-14 cvgcmpi   cvgcmp      revised
11-Jun-14 cvgcmp2ci ---         deleted; see cvgcmp
11-Jun-14 cvgcmp2clemOLD ---    deleted
11-Jun-14 cvgcmp2clem ---       deleted
11-Jun-14 cvgcmp2i  ---         deleted; see cvgcmp
11-Jun-14 cvgcmp2lem ---        deleted
11-Jun-14 iserzabsi iserabs     revised
11-Jun-14 iserzabslem ---       deleted
11-Jun-14 ser1cmp2i ---         deleted
11-Jun-14 ser1cmp2lem ---       deleted
11-Jun-14 ser1cmp0i ---         deleted; see serge0
11-Jun-14 ser1cmpi  ---         deleted; see serle
11-Jun-14 ser1clim0 ---         deleted; see serclim0
11-Jun-14 ser10     ---         deleted; see ser0
11-Jun-14 ser1consti ser1const  revised
11-Jun-14 ser1f0i   ---         deleted; see serf0
11-Jun-14 serzf0i   serf0       revised
11-Jun-14 caucvg3   caucvg      revised
11-Jun-14 caucvg3i  ---         deleted; see caucvg
11-Jun-14 caucvg3lem ---        deleted
11-Jun-14 caucvg2i  caurcvg2    revised
11-Jun-14 caucvg3ai ---         deleted; see caucvg
11-Jun-14 caucvgi   caurcvg     revised
11-Jun-14 ---       ---         caucvglem1 - caucvglem6 deleted
11-Jun-14 climcaui  climcau     revised
11-Jun-14 climsupi  climsup     revised
11-Jun-14 climubi   ---         deleted; see monoord
11-Jun-14 climubii  ---         deleted; see monoord
11-Jun-14 climimi   climim      revised
11-Jun-14 climrei   climre      revised
11-Jun-14 climcji   climcj      revised
11-Jun-14 climabsi  climabs     revised
11-Jun-14 climabslem climcn1lem revised
11-Jun-14 climserzlei climserle revised
11-Jun-14 iserzexi  ---         deleted; see iserex
11-Jun-14 clim2serzi ---        deleted; see clim2ser
11-Jun-14 iserzshfti isershft   revised
11-Jun-14 iserzcmp0 iserge0     revised
11-Jun-14 iserzcmp  isercmp     revised
11-Jun-14 climsqueeze2 [--same--] revised
11-Jun-14 climsqueeze [--same--] revised
11-Jun-14 climcmpc1 climcmpc2   revised
11-Jun-14 climcmp   [--same--]  revised
11-Jun-14 climcmplem ---        deleted
11-Jun-14 iserzmulc1 isermulc2  revised
11-Jun-14 iserzex   iserex      revised
11-Jun-14 clim2serz clim2ser    revised
11-Jun-14 climmulci ---         deleted; see climmulc2
11-Jun-14 climaddci ---         deleted; see climaddc2
11-Jun-14 climsubc2 [--same--]  revised
11-Jun-14 climsub   [--same--]  revised
11-Jun-14 climmulc2 [--same--]  revised
11-Jun-14 climmul   [--same--]  revised
11-Jun-14 ---       ---         climmullem1 - climmullem8 deleted
11-Jun-14 climaddc2 [--same--]  revised
11-Jun-14 climaddc1 [--same--]  revised
11-Jun-14 climadd   [--same--]  revised
11-Jun-14 ---       ---         climaddlem1 - climaddlem3 deleted
11-Jun-14 climabs0i climabs0    revised
11-Jun-14 climge0   [--same--]  revised
11-Jun-14 climfnrcli ---        deleted; see climrecl
11-Jun-14 climrecl  [--same--]  revised
11-Jun-14 serzclim0 serclim0    revised
11-Jun-14 climuz0i  ---         deleted; see climconst2
11-Jun-14 iserzshft2i ---       deleted; see isershft
11-Jun-14 climshft2 [--same--]  revised
11-Jun-14 sershft   isershft
11-Jun-14 climshft  [--same--]  revised
11-Jun-14 climres   [--same--]  revised
11-Jun-14 2climnn0  ---         deleted; see 2clim
11-Jun-14 2climnn   ---         deleted; see 2clim
11-Jun-14 climeq    [--same--]  revised
11-Jun-14 climunii  ---         deleted; see climuni
11-Jun-14 clim0     climz
11-Jun-14 climconst3 ---        deleted; see climconst2
11-Jun-14 climconst2 [--same--] revised
11-Jun-14 climconsti climconst  revised
11-Jun-14 clmfnn    ---         deleted; see clim2c
11-Jun-14 climfnn   ---         deleted; see clim2c
11-Jun-14 clmi2a    ---         deleted; see climi2
11-Jun-14 clm4a     ---         deleted; see clim2c
11-Jun-14 clm0ii    ---         deleted; see climi0
11-Jun-14 clmi2rpi  ---         deleted; see climi2
11-Jun-14 clmi2i    ---         deleted; see climi2
11-Jun-14 clmi1i    ---         deleted; see climi
11-Jun-14 clm0nnsi  ---         deleted; see clim0c
11-Jun-14 clmnnsi   ---         deleted; see clim2c
11-Jun-14 clm0i     ---         deleted; see clim0c
11-Jun-14 clm4fi    ---         deleted; see clim2c
11-Jun-14 clm4lei   ---         deleted; see clim2c
11-Jun-14 clm3i     ---         deleted; see clim2c
11-Jun-14 clm2i     ---         deleted; see clim2
11-Jun-14 clm1i     ---         deleted; see clim2
11-Jun-14 climcl    [--same--]  changed variable names
11-Jun-14 clim      [--same--]  revised
11-Jun-14 ser1absdifi ---       deleted; see fsumabs or seqabs
11-Jun-14 ser1absdiflem ---     deleted
11-Jun-14 cauimi    ---         deleted
11-Jun-14 caurei    ---         deleted
11-Jun-14 caubndi   caubnd      revised
11-Jun-14 cvganuzi  rexanuz2    revised
11-Jun-14 cvganz    rexanuz     revised
11-Jun-14 cvg3i     ---         deleted; see rexuz3
11-Jun-14 cvg2i     ---         deleted
11-Jun-14 cvg1      ---         deleted
11-Jun-14 cvg1i     ---         deleted
11-Jun-14 cau5i     ---         deleted; see rexuz3
11-Jun-14 cau4ii    ---         deleted; see rexuz3
11-Jun-14 cau5ii    ---         deleted; see rexuz3
11-Jun-14 cau3i     cau3        revised
11-Jun-14 cau3iri   ---         deleted; see cau3
11-Jun-14 cau3ii    ---         deleted
11-Jun-14 cau2i     ---         deleted
11-Jun-14 seq1ubi   ---         deleted; see fimaxre3 and suprub
11-Jun-14 seq1ublem ---         deleted
11-Jun-14 seq1bndi  ---         deleted; see fimaxre3
11-Jun-14 sqsqr     resqrth
11-Jun-14 discrlem  discr       revised
11-Jun-14 ---       ---         discrlem1 - discrlem3 deleted
11-Jun-14 expnlbnd2 [--same--]  revised
11-Jun-14 leexp2r [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 ltexp2r   [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 leexp2a  [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 ltexp2    [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 expcan    [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 ltexp2a   [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 expm1     [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 expsubOLD ---         deleted; see expsub
11-Jun-14 expsub    [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 exprecOLD ---         deleted; see exprec
11-Jun-14 exprec    [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 expgt0    [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 expne0i   [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 1exp      [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 rpexpcl   [--same--]  generalized antecedent to N e. ZZ
11-Jun-14 expval    [--same--]  revised
11-Jun-14 df-exp    [--same--]  revised
11-Jun-14 ser0p1i   ---         deleted; see seqp1i
11-Jun-14 ser00i    ---         deleted; see seq1i
11-Jun-14 ser0fi    ---         deleted; see serf
11-Jun-14 ser0cl1i  ---         deleted; see serf
11-Jun-14 serzcl1i  ---         deleted; see serf
11-Jun-14 seq1resval2g ---      deleted; see seqfveq
11-Jun-14 seqzresval2g ---      deleted; see seqfveq
11-Jun-14 seq1alcl  ---         deleted; see seqcl
11-Jun-14 seqzalcl  ---         deleted; see seqcl
11-Jun-14 seq0cl    ---         deleted; see seqf
11-Jun-14 seqzres2  ---         deleted; see seqres
11-Jun-14 seqzres   ---         deleted; see seqres
11-Jun-14 seqzresval ---        deleted; see seqfveq
11-Jun-14 seqzcl    ---         deleted; see seqf
11-Jun-14 seqzrn    ---         deleted; see seqf
11-Jun-14 seqzrn2   ---         deleted; see seqf2
11-Jun-14 seqzfveqg ---         deleted; see seqfveq
11-Jun-14 seqzeq    ---         deleted; see seqfeq
11-Jun-14 seqzfveq  ---         deleted; see seqfveq
11-Jun-14 seq1seqzg ---         deleted
11-Jun-14 seqzp1g   ---         deleted; see seqp1
11-Jun-14 seqz1g    ---         deleted; see seq1
11-Jun-14 seq01     ---         deleted; see seqp1i
11-Jun-14 seqzm1    ---         deleted; see seqm1
11-Jun-14 seq1shftid ---        deleted; see seqfeq
11-Jun-14 ser1addi  ---         deleted; see seradd
11-Jun-14 ser1add2i ---         deleted; see seradd
11-Jun-14 ser1monoi ---         deleted; see sermono
11-Jun-14 ser1p1i   ---         deleted; see seqp1i
11-Jun-14 ser11i    ---         deleted; see seq1i
11-Jun-14 ser1f2i   ---         deleted; see serf
11-Jun-14 ser1cl2i  ---         deleted; see serf
11-Jun-14 ser1refi  ---         deleted; see serfre
11-Jun-14 ser1recli ---         deleted; see serfre
11-Jun-14 ser1cl1i  ---         deleted; see serf
11-Jun-14 ser1fi    ---         deleted; see serf
11-Jun-14 ser1f     ---         deleted; see serf
11-Jun-14 seq1p1g   ---         deleted; see seqp1
11-Jun-14 seq11g    ---         deleted; see seq1
11-Jun-14 seq1res   ---         deleted; see seqres
11-Jun-14 seq1cl2   ---         deleted; see seqcl2
11-Jun-14 seq1cl    ---         deleted; see seqcl
11-Jun-14 seq1f2    ---         deleted; see seqf2
11-Jun-14 seq1f     ---         deleted; see seqf
11-Jun-14 seq1rn    ---         deleted; see seqf
11-Jun-14 seq1rn2   ---         deleted; see seqf2
11-Jun-14 seq1m1    ---         deleted; see seqm1
11-Jun-14 seq1lem2  ---         deleted
11-Jun-14 seq0p1    ---         deleted; see seqp1
11-Jun-14 seq00     ---         deleted; see seq1
11-Jun-14 seqzp1    ---         deleted; see seqp1
11-Jun-14 seqz1     ---         deleted; see seq1
11-Jun-14 seq0fn    ---         deleted; see seqfn
11-Jun-14 seq0seqz  ---         deleted
11-Jun-14 seq1seqz  ---         deleted
11-Jun-14 seqzfn    ---         deleted; see seqfn
11-Jun-14 seqzfval  ---         deleted
11-Jun-14 seq0fval  ---         deleted
11-Jun-14 seq1fn    ---         deleted; see seqfn
11-Jun-14 seq1p1    ---         deleted; see seqp1
11-Jun-14 seq11     ---         deleted; see seq1
11-Jun-14 seq1fval  ---         deleted
11-Jun-14 df-seqz   ---         deleted; see df-seq
11-Jun-14 df-seq0   ---         deleted; see df-seq
11-Jun-14 df-seq1   ---         deleted; see df-seq
11-Jun-14 cseqz     ---         deleted                - use seq theorems
11-Jun-14 cseq0     ---         deleted                  in place of seq1, etc.
11-Jun-14 cseq1     ---         deleted
11-Jun-14 sercmp    [--same--]  revised
11-Jun-14 ser0      [--same--]  revised
11-Jun-14 serdistr  [--same--]  revised
11-Jun-14 seqhomo   [--same--]  revised
11-Jun-14 seqid2    [--same--]  revised
11-Jun-14 seqid     [--same--]  revised
11-Jun-14 sersub    [--same--]  revised
11-Jun-14 seradd    [--same--]  revised
11-Jun-14 serf1o    [--same--]  revised
11-Jun-14 serf1olem2 [--same--] revised
11-Jun-14 serf1olem1 [--same--] revised
11-Jun-14 sercaopr  [--same--]  revised
11-Jun-14 seq1p     [--same--]  revised
11-Jun-14 seqsplit  [--same--]  revised
11-Jun-14 sermono   [--same--]  revised
11-Jun-14 monoord   [--same--]  revised
11-Jun-14 serfre    [--same--]  revised
11-Jun-14 serf      [--same--]  revised
11-Jun-14 seqres    [--same--]  revised
11-Jun-14 seqshft2  [--same--]  revised
11-Jun-14 seqfeq    [--same--]  revised
11-Jun-14 seqfveq   [--same--]  revised
11-Jun-14 seqfeq2   [--same--]  revised
11-Jun-14 seqfveq2  [--same--]  revised
11-Jun-14 seqf      [--same--]  revised
11-Jun-14 seqcl     [--same--]  revised
11-Jun-14 seqf2     [--same--]  revised
11-Jun-14 seqcl2    [--same--]  revised
11-Jun-14 caoprassg [--same--]  revised
11-Jun-14 caoprcomg [--same--]  revised
11-Jun-14 fvunsn    [--same--]  eliminate unnecessary hypothesis
29-May-14 iccss2    [--same--]  moved from JM's mathbox to main set.mm
29-May-14 iccss     [--same--]  moved from JM's mathbox to main set.mm
29-May-14 iccconn   [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 retopcon  [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 reconn    [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 reconnlem5 [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 reconnlem4 [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 reconnlem3 [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 reconnlem2 [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 reconnlem1 [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 connsub   [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 dfcon2    [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 ioodisj   [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 iccid      [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 imp511    [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 imp55     [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 imp5g     [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 mtord     [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 eqeu      [--same--]  moved from JGH's mathbox to main set.mm
29-May-14 uznnssnn  [--same--]  moved from SF's mathbox to main set.mm
22-May-14 dmnrng    dmnrngo     (in FL's mathbox)
22-May-14 smprngpr  smprngopr   (in FL's mathbox)
22-May-14 prrngrng  prrngorngo  (in FL's mathbox)
22-May-14 isprrng   isprrngo    (in FL's mathbox)
22-May-14 df-prrng  df-prrngo   (in FL's mathbox)
22-May-14 0ring     0rngo       (in FL's mathbox)
22-May-14 rngidl    rngoidl     (in FL's mathbox)
22-May-14 crnghomfo crngohomfo  (in FL's mathbox)
22-May-14 crngrng   crngorngo   (in FL's mathbox)
22-May-14 iscring2  iscrngo2    (in FL's mathbox)
22-May-14 iscring   iscrngo     (in FL's mathbox)
22-May-14 df-cring  df-crngo    (in FL's mathbox)
22-May-14 rngisoco  rngoisoco   (in FL's mathbox)
22-May-14 rngisocnv rngoisocnv  (in FL's mathbox)
22-May-14 rngisohom rngoisohom  (in FL's mathbox)
22-May-14 rngiso1o  rngoiso1o   (in FL's mathbox)
22-May-14 isrngiso  isrngoiso   (in FL's mathbox)
22-May-14 rngisoval rngoisoval  (in FL's mathbox)
22-May-14 df-rngiso df-rngoiso  (in FL's mathbox)
22-May-14 rngkerinj rngokerinj  (in FL's mathbox)
22-May-14 rnghomco  rngohomco   (in FL's mathbox)
22-May-14 rnghomsub rngohomsub  (in FL's mathbox)
22-May-14 rnghom0   rngohom0    (in FL's mathbox)
22-May-14 rnggrphom rngogrphom  (in FL's mathbox)
22-May-14 rnghommul rngohommul  (in FL's mathbox)
22-May-14 rnghomadd rngohomadd  (in FL's mathbox)
22-May-14 rnghom1   rngohom1    (in FL's mathbox)
22-May-14 rnghomcl  rngohomcl   (in FL's mathbox)
22-May-14 rnghomf   rngohomf    (in FL's mathbox)
22-May-14 isrnghom  isrngohom   (in FL's mathbox)
22-May-14 rnghomval rngohomval  (in FL's mathbox)
22-May-14 df-rnghom df-rngohom  (in FL's mathbox)
22-May-14 isdivrng3 isdrngo3    (in FL's mathbox)
22-May-14 isdivrng2 isdrngo2    (in FL's mathbox)
22-May-14 isdivrng1 isdrngo1    (in FL's mathbox)
22-May-14 ringsubdir rngosubdir (in FL's mathbox)
22-May-14 ringsubdi rngosubdi   (in FL's mathbox)
22-May-14 ringnegrmul rngonegrmul (in FL's mathbox)
22-May-14 ringneglmul rngoneglmul (in FL's mathbox)
22-May-14 ringnegmn1r rngonegmn1r (in FL's mathbox)
22-May-14 ringnegmn1l rngonegmn1l (in FL's mathbox)
22-May-14 ringsub   rngosub     (in FL's mathbox)
22-May-14 ringaddneg2 rngoaddneg2 (in FL's mathbox)
22-May-14 ringaddneg1 rngoaddneg1 (in FL's mathbox)
22-May-14 ringnegcl rngonegcl   (in FL's mathbox)
22-May-14 df-toprng df-toprngo  (in FL's mathbox)
22-May-14 glmring   glmrngo     (in FL's mathbox)
22-May-14 rngridfz  rngoridfz   (in FL's mathbox)
22-May-14 rngunval2 rngounval2  (in FL's mathbox)
22-May-14 rnginvcl  rngoinvcl   (in FL's mathbox)
22-May-14 rnplrnml3 rngodmeqrn  (in FL's mathbox)
22-May-14 rngdmdmrn rngodmdmrn  (in FL's mathbox)
22-May-14 uznzr     rngoueqz
22-May-14 ring1cl   rngo1cl
22-May-14 on1el6    rngosn6
22-May-14 on1el4    rngosn4
22-May-14 on1el3    rngosn3
22-May-14 ringoridm rngoridm
22-May-14 ringolidm rngolidm
22-May-14 ringoidmlem rngoidmlem
22-May-14 fora      rngoablo2
22-May-14 fora2     rngoablo2lem2
22-May-14 fora1     rngoablo2lem1
22-May-14 unmnd     rngomnd
22-May-14 rnplrnml  rngorn1eq
22-May-14 rnplrnml2 rngorn1
22-May-14 rnplrnml0 rngodm1dm2
22-May-14 rngn0     rngon0
22-May-14 drngi     drngoi
22-May-14 ringsn    rngosn
22-May-14 cnring    cnrngo
22-May-14 ringorz   rngorz
22-May-14 ringolz   rngolz
22-May-14 ring0lid  rngo0lid
22-May-14 ring0rid  rngo0rid
22-May-14 ring0cl   rngo0cl
22-May-14 ringlcan  rngolcan
22-May-14 ringrcan  rngorcan
22-May-14 ringa4    rngoa4
22-May-14 ringa32   rngoa32
22-May-14 ringaass  rngoaass
22-May-14 ringcom   rngocom
22-May-14 ringgcl   rngogcl
22-May-14 ringogrpo rngogrpo
22-May-14 ringoablo rngoablo
22-May-14 ring2     rngo2
22-May-14 ringoass  rngoass
22-May-14 ringodir  rngodir
22-May-14 ringodi   rngodi
22-May-14 ringoideu rngoideu
22-May-14 ringid    rngoid
22-May-14 ringocl   rngocl
22-May-14 ringsm    rngosm
22-May-14 ringoi    rngoi
22-May-14 isringod  isrngod
22-May-14 isringo   isrngo
22-May-14 relrng    relrngo
22-May-14 df-ringo  df-rngo
22-May-14 cring     crngo
21-May-14 infmrgelb [--same--]  moved from JM's mathbox to main set.mm; revised
21-May-14 infmrlb   [--same--]  moved from JM's mathbox to main set.mm; revised
21-May-14 fienf1f1o ---         deleted; use f1finf1o
21-May-14 lbleinf   infmrgelb   moved from JGH's mathbox to main set.mm
21-May-14 divcan7   [--same--]  moved from JGH's mathbox to main set.mm
21-May-14 blhalf    [--same--]  moved from JM's mathbox to main set.mm
21-May-14 lt0nnn0   [--same--]  revised
17-May-14 oprabval2ga ---       deleted; use ovmpt2g
17-May-14 mpt2fng   ---         deleted; use fnmpt2
17-May-14 rngop     rnmpt2
17-May-14 fnoprab2ga fnmpt2
17-May-14 fnoprab2a fnmpt2i
17-May-14 dmoprab2a dmmpt2
17-May-14 foprab2a  fmpt2
17-May-14 oprabex2ga mpt2exg
17-May-14 mpt2exg   mpt2exga
17-May-14 dmmpt2    dmmpt
17-May-14 dmmpt     dmmptg
17-May-14 visset    vex
17-May-14 elisseti  elexi
17-May-14 elissetxx elisset
17-May-14 elisset   elex
17-May-14 elex      elissetxx
17-May-14 syl111anc syl3anc
17-May-14 syl11anc  syl2anc
11-Mar-14 syl2anc   syl2anr
 7-May-14 peano5uztiOLD ---     deleted
 7-May-14 peano5uziOLD ---      deleted
 7-May-14 dfnn2     dfnn3
 7-May-14 dfnn3     ---         deleted from JH's mathbox; see df-n
19-Apr-14 mod0      [--same--]  moved from JM's mathbox to main set.mm
19-Apr-14 invrcl    ---         deleted; use drnginvrcl and drnginvn0
16-Apr-14 grpkerinj grpokerinj  (in JM's mathbox)
16-Apr-14 grpeqdivid grpoeqdivid (in JM's mathbox)
16-Apr-14 grphm     grpohm      (in FL's mathbox)
16-Apr-14 grphlem5  grpohlem5   (in FL's mathbox)
16-Apr-14 grphmlem4 grpohmlem4  (in FL's mathbox)
16-Apr-14 grphlem3  grpohlem3   (in FL's mathbox)
16-Apr-14 grphmlem2 grpohmlem2  (in FL's mathbox)
16-Apr-14 grphmlem1 grpohmlem1  (in FL's mathbox)
16-Apr-14 grpdivzer grpodivzer  (in FL's mathbox)
16-Apr-14 grpdlcan  grpodlcan   (in FL's mathbox)
16-Apr-14 grpdrcan  grpodrcan   (in FL's mathbox)
16-Apr-14 grpdivfo  grpodivfo   (in FL's mathbox)
16-Apr-14 grpdivone grpodivone  (in FL's mathbox)
16-Apr-14 grpmnd    grpomnd     (in FL's mathbox)
16-Apr-14 grplactf1o grpolactf1o
16-Apr-14 grpnpncan grponpncan
16-Apr-14 grpnnncan2 grponnncan2
16-Apr-14 grppnpcan2 grpopnpcan2
16-Apr-14 grpnpcan  grponpcan
16-Apr-14 grppncan  grpopncan
16-Apr-14 grpdivid  grpodivid
16-Apr-14 grpmuldivass grpomuldivass
16-Apr-14 grpdivdiv grpodivdiv
16-Apr-14 grpdivcl  grpodivcl
16-Apr-14 grpdivf   grpodivf
16-Apr-14 grpdivval grpodivval
16-Apr-14 grpdivfval grpodivfval
16-Apr-14 grpinvdiv grpoinvdiv
16-Apr-14 grpdivinv grpodivinv
16-Apr-14 grpinvop  grpoinvop
16-Apr-14 grpinvf   grpoinvf
16-Apr-14 grp2inv   grpo2inv
16-Apr-14 grpasscan2 grpoasscan2
16-Apr-14 grpasscan1 grpoasscan1
16-Apr-14 grpsn     grposn
16-Apr-14 grprn     grporn
16-Apr-14 grprndm   grporndm
16-Apr-14 grpfo     grpofo
16-Apr-14 grp2grp   grpo2grp
 2-Apr-14 ---       ---         math token "Cgr" changed to "=="
 2-Apr-14 ---       ---         math token "(++)" changed to "(+)"
 2-Apr-14 ---       ---         math token "(+)" changed to "\/_"
31-Mar-14 grpinvcl  [--same--]  removed redundant hypothesis
31-Mar-14 ---       ---         math token "-g" changed to "invg"
23-Mar-14 hbequid2  ---         deleted; use hbequid
22-Mar-14 firnfi4   ---         deleted from JM's mathbox; see abrexfi
22-Mar-14 firnfi3   ---         deleted from JM's mathbox; see abrexfi
22-Mar-14 firnfi2   ---         deleted from JM's mathbox; see abrexfi
22-Mar-14 firnfi    ---         deleted from JM's mathbox; see abrexfi
22-Mar-14 cvol      clvol
22-Mar-14 fimaxre2  [--same--]  moved from JM's mathbox to main set.mm; revised
22-Mar-14 fimaxre   [--same--]  moved from JM's mathbox to main set.mm
15-Mar-14 reef11i   ---         deleted; see reef11
15-Mar-14 fsumsub   [--same--]  moved from SF's mathbox to main set.mm
15-Mar-14 fsumneg   [--same--]  moved from SF's mathbox to main set.mm
15-Mar-14 bccmpl    [--same--]  revised
15-Mar-14 ---       ---         fseq1p1m1lem1 - fseq1p1m1lem3 deleted
15-Mar-14 fz1eqblem ---         deleted
15-Mar-14 fzsuc     [--same--]  revised; see also fzsuc2
15-Mar-14 uz2m1nn   [--same--]  moved from PC's mathbox to main set.mm
15-Mar-14 elnn00nn  ---         deleted; see elnn0
15-Mar-14 npncan3   [--same--]  moved from SF's mathbox to main set.mm
15-Mar-14 npncan2   [--same--]  moved from SF's mathbox to main set.mm
12-Mar-14 copsexgb  coprsexg
 9-Mar-14 grpid     [--same--]  revised
 2-Mar-14 bnj1150   unssd       moved from JB's mathbox to main set.mm
28-Feb-14 f1oeq23   [--same--]  moved from FL's mathbox to main set.mm
28-Feb-14 fzp1elp1  [--same--]  moved from JM's mathbox to main set.mm
28-Feb-14 divides2  [--same--]  moved from JGH's mathbox to main set.mm
28-Feb-14 fzfi2     ---         deleted from JM's mathbox; see fzfi
28-Feb-14 fzfi      [--same--]  moved from JM's mathbox; revised
28-Feb-14 fz1fi     ---         deleted; see fzfi
25-Feb-14 biadan2   [--same--]  moved from JM's mathbox to main set.mm
23-Feb-14 op1steq   [--same--]  generalized antecedent from _V X. _V to V X. W
23-Feb-14 eqop      [--same--]  generalized antecedent from _V X. _V to V X. W
23-Feb-14 eqopi     [--same--]  generalized antecedent from _V X. _V to V X. W
20-Feb-14 eqreldv2  [--same--]  moved from RM's mathbox to main set.mm; revised
20-Feb-14 eqreldv   [--same--]  moved from RM's mathbox to main set.mm
17-Feb-14 qnnenOLD  ---         deleted; see qnnen
17-Feb-14 divvali   divval      revised
17-Feb-14 receui    receu       revised
17-Feb-14 recexi    ---         deleted; see recex
17-Feb-14 ax-cnex   ---         deleted; see cnex
17-Feb-14 axcnex    ---         deleted; see cnex
17-Feb-14 srex      ---         deleted
 4-Feb-14 abl23     ablo32
 4-Feb-14 abl4      ablo4
 4-Feb-14 abldiv23  ablodiv32
 4-Feb-14 nvadd23   nvadd32
 4-Feb-14 vca23     vca32
 4-Feb-14 ringa23   ringa32
 4-Feb-14 divdiv23i divdiv32i
 4-Feb-14 divdiv23  divdiv32
 4-Feb-14 sub23     sub32
 4-Feb-14 dif23     dif32
 4-Feb-14 or23      or32
30-Jan-14 heibor    [--same--]  revised
30-Jan-14 ---       ---         heiborlem11 - heiborlem42 deleted
30-Jan-14 heiborlem10 [--same--] revised
30-Jan-14 heiborlem9 [--same--] revised
30-Jan-14 heiborlem8 [--same--] revised
30-Jan-14 heiborlem7 [--same--] revised
30-Jan-14 heiborlem6 [--same--] revised
30-Jan-14 heiborlem5 [--same--] revised
30-Jan-14 heiborlem4 [--same--] revised
30-Jan-14 heiborlem3 [--same--] revised
30-Jan-14 heiborlem2 [--same--] revised
30-Jan-14 heiborlem1 [--same--] revised
30-Jan-14 ismtyhmeolem [--same--] revised
30-Jan-14 hmopbdopiHIL ---      deleted; see hmopbdoptHIL
30-Jan-14 htthi     htth        revised
30-Jan-14 ---       ---         htthlem1 - htthlem12 deleted
30-Jan-14 ubthi     ubth        revised
30-Jan-14 ubthii    ---         deleted; see ubth
30-Jan-14 ---       ---         ubthlem4 - ubthlem14 deleted
30-Jan-14 ubthlem3  [--same--]  revised
30-Jan-14 ubthlem2  [--same--]  revised
30-Jan-14 ubthlem1  [--same--]  revised
30-Jan-14 bcth      [--same--]  revised
30-Jan-14 ---       ---         bcthlem6 - bcthlem33 deleted
30-Jan-14 bcthlem5  [--same--]  revised
30-Jan-14 bcthlem4  [--same--]  revised
30-Jan-14 bcthlem3  [--same--]  revised
30-Jan-14 bcthlem2  [--same--]  revised
30-Jan-14 bcthlem1  [--same--]  revised
30-Jan-14 fimax     ---         deleted; see fimaxg
30-Jan-14 ac6sfilem3 ---        deleted
30-Jan-14 ac6sfilem2 ---        deleted
30-Jan-14 ac6sfilem1 ---        deleted
30-Jan-14 metdcn    [--same--]  revised
30-Jan-14 ---       ---         metnrmlem4 - metnrmlem6 deleted
30-Jan-14 metnrmlem3 [--same--] revised
30-Jan-14 metnrmlem2 [--same--] revised
30-Jan-14 metnrmlem1 [--same--] revised
30-Jan-14 altretoplem2 ---      deleted
30-Jan-14 altretoplem1 ---      deleted
30-Jan-14 bsi3      bsi
30-Jan-14 bsi2      ---         deleted; see bsi
30-Jan-14 bsi       [--same--]  revised
30-Jan-14 subtopmetlem ---      deleted
30-Jan-14 basmetres ---         deleted; see metssba2
30-Jan-14 nvcnpi4   ---         deleted; see metcnpi4
30-Jan-14 nvcnpi3   ---         deleted; see metcnpi3
30-Jan-14 nmcn3     ---         deleted; see nmcn
30-Jan-14 nmcn2     ---         deleted; see nmcn
30-Jan-14 nmcni     ---         deleted; see nmcn
30-Jan-14 nmcnilem  ---         deleted
30-Jan-14 sqcn2     ---         deleted; see sqcn
30-Jan-14 sqcn      [--same--]  revised
30-Jan-14 nvcni3    ---         deleted; see metcni
30-Jan-14 nvcni2    ---         deleted; see metcni
30-Jan-14 nvcni     ---         deleted; see metcni
30-Jan-14 nvcnpf    ---         deleted; see metcnpf
30-Jan-14 nvcnf     ---         deleted; see metcnf
30-Jan-14 nvelbl2   [--same--]  revised
30-Jan-14 nvelbl    [--same--]  revised
30-Jan-14 metcnp4OLD ---        deleted
30-Jan-14 metcnp4lem2 [--same--] revised
30-Jan-14 metelclsOLD ---       deleted
30-Jan-14 tgioolem  ---         deleted
30-Jan-14 bl2ioo    [--same--]  revised
30-Jan-14 metcnp3   [--same--]  revised
30-Jan-14 metcni2   [--same--]  revised
30-Jan-14 metcni    [--same--]  revised
30-Jan-14 metcnpi4  [--same--]  revised
30-Jan-14 metcnpi3  [--same--]  revised
30-Jan-14 metcnpi2  [--same--]  revised
30-Jan-14 metcnpi   [--same--]  revised
30-Jan-14 metcn     [--same--]  revised
30-Jan-14 metcnp2   [--same--]  revised
30-Jan-14 metcnp    [--same--]  revised
30-Jan-14 metcnplem [--same--]  revised
30-Jan-14 metequiv  [--same--]  revised
30-Jan-14 lpbl      [--same--]  revised
30-Jan-14 blnei     [--same--]  revised
30-Jan-14 metnei    [--same--]  revised
30-Jan-14 neibl     [--same--]  revised
30-Jan-14 blopn     [--same--]  revised
30-Jan-14 tgbl      ---         deleted; see opnval
30-Jan-14 opni3     [--same--]  revised
30-Jan-14 opni2     [--same--]  revised
30-Jan-14 isopn4    [--same--]  revised
30-Jan-14 uniopn2   [--same--]  revised
30-Jan-14 opnfval   ---         deleted
30-Jan-14 ssblex    [--same--]  revised
30-Jan-14 ssbl      [--same--]  revised
30-Jan-14 blssex    [--same--]  revised
30-Jan-14 blss      [--same--]  revised
30-Jan-14 blin      [--same--]  revised
30-Jan-14 rnblssm   ---         deleted; see blssm
30-Jan-14 blssm     [--same--]  revised
30-Jan-14 blex      ---         deleted; see unirnbl
30-Jan-14 blelrn    [--same--]  revised
30-Jan-14 blrn3     ---         deleted; see blrn
30-Jan-14 bln0      [--same--]  revised
30-Jan-14 blcntr    [--same--]  revised
30-Jan-14 blf       [--same--]  revised
30-Jan-14 bl2in     [--same--]  revised
30-Jan-14 blrn2     ---         deleted; see blrn
30-Jan-14 blrn      [--same--]  revised
30-Jan-14 elbl3     [--same--]  revised
30-Jan-14 elbl2     [--same--]  revised
30-Jan-14 elbl      [--same--]  revised
30-Jan-14 blval     [--same--]  revised
30-Jan-14 metdmdm   ---         deleted; see a1i
30-Jan-14 df-opn    [--same--]  revised
30-Jan-14 uniretop  [--same--]  revised
30-Jan-14 unirnioo  [--same--]  revised
30-Jan-14 qjust     ---         deleted
30-Jan-14 df-q      [--same--]  revised
30-Jan-14 unifo     iunfo       revised
30-Jan-14 oprelimab [--same--]  revised
30-Jan-14 oprvelrn  [--same--]  revised
16-Jan-14 resex     [--same--]  moved from JM's mathbox to main set.mm
16-Jan-14 ifeq2da   [--same--]  moved from JM's mathbox to main set.mm
16-Jan-14 ifeq1da   [--same--]  moved from JM's mathbox to main set.mm
16-Jan-14 fvif      [--same--]  moved from JM's mathbox to main set.mm
15-Jan-14 ifclda    [--same--]  moved from JM's mathbox to main set.mm
14-Jan-14 wl-adnestantdALT embantd moved from WL's mathbox to main set.mm
14-Jan-14 rabbirdv  rabbi2dva   revised hypothesis
13-Jan-14 19.23aexi exlimexi    (in AS's mathbox)
13-Jan-14 r19.23aib rexlimib    (in FL's mathbox)
13-Jan-14 r19.23advv rexlimdvv
13-Jan-14 r19.23aivv rexlimivv
13-Jan-14 r19.23adva rexlimdva
13-Jan-14 r19.23adv rexlimdv
13-Jan-14 r19.23ad2 rexlimd2
13-Jan-14 r19.23ad  rexlimd
13-Jan-14 r19.23aivw rexlimivw
13-Jan-14 r19.23aiva rexlimiva
13-Jan-14 r19.23aiv rexlimiv
13-Jan-14 r19.23ai  rexlimi
13-Jan-14 19.23advv exlimdvv
13-Jan-14 19.23aivv exlimivv
13-Jan-14 19.23aiv  exlimiv
13-Jan-14 19.23adv  exlimdv
13-Jan-14 19.23ad   exlimd
13-Jan-14 19.23ai   exlimi
13-Jan-14 19.21a3con13v alrim3con13v (In AS's mathbox)
13-Jan-14 r19.21advva ralrimdvva
13-Jan-14 r19.21advv ralrimdvv
13-Jan-14 r19.21aivva ralrimivva
13-Jan-14 r19.21aivv ralrimivv
13-Jan-14 r19.21adva ralrimdva
13-Jan-14 r19.21adv ralrimdv
13-Jan-14 r19.21ad  ralrimd
13-Jan-14 r19.21aiva ralrimiva
13-Jan-14 r19.21aiv ralrimiv
13-Jan-14 r19.21ai  ralrimi
13-Jan-14 19.21adv  alrimdv
13-Jan-14 19.21aivv alrimivv
13-Jan-14 19.21aiv  alrimiv
13-Jan-14 19.21ad   alrimd
13-Jan-14 19.21ai   alrimi
 9-Jan-14 dvrngprop drngprop
 9-Jan-14 dvrngid2  drngid2
 9-Jan-14 divrngunz drngunz
 9-Jan-14 divrngid  drngid
 9-Jan-14 divrngidlem drngidlem
 9-Jan-14 divrngmcl drngmcl
 9-Jan-14 divrngmgrp drngmgrp
 9-Jan-14 isdivrngrd isdrngrd
 9-Jan-14 isdivrngd isdrngd
 9-Jan-14 divrnggrp drnggrp
 9-Jan-14 divrngring drngrng
 9-Jan-14 isdivrng  isdrng
 9-Jan-14 cdivring  cdr
 9-Jan-14 ringrz    rngrz
 9-Jan-14 ringlz    rnglz
 9-Jan-14 isringd   isrngd
 9-Jan-14 isringid  isrngid
 9-Jan-14 ringridm  rngridm
 9-Jan-14 ringlidm  rnglidm
 9-Jan-14 ringidmlem rngidmlem
 9-Jan-14 ringgrp   rnggrp
 9-Jan-14 ringabl   rngabl
 9-Jan-14 ringidcl  rngidcl
 9-Jan-14 ringdir   rngdir
 9-Jan-14 ringdi    rngdi
 9-Jan-14 ringideu  rngideu
 9-Jan-14 ringass   rngass
 9-Jan-14 ringcl    rngcl
 9-Jan-14 ringi     rngi
 9-Jan-14 isring    isrng
 9-Jan-14 ringidval rngidval
23-Dec-13 cvimarndm cnvimarndm
23-Dec-13 cnvresima [--same--]  moved from JGH's mathbox to main set.mm
23-Dec-13 hstel     ishst
23-Dec-13 stel      isst        revised
23-Dec-13 df-hst    [--same--]  revised
23-Dec-13 df-st     [--same--]  revised
23-Dec-13 shsumval3i shsval3i
23-Dec-13 shsumval2i shsval2i
23-Dec-13 dfchj3    sshjval3    revised
23-Dec-13 dfchj2    sshjval2    revised
23-Dec-13 dfchsup2  ---         deleted; see hsupval2
23-Dec-13 shsumval  shsval      revised
23-Dec-13 df-chsup  [--same--]  revised
23-Dec-13 df-chj    [--same--]  revised
23-Dec-13 df-span   [--same--]  revised
23-Dec-13 df-shsum  df-shs      revised
23-Dec-13 dfch2     [--same--]  revised
23-Dec-13 ch2       isch3
23-Dec-13 chcmhi    ---         deleted; see isch3
23-Dec-13 chsscmi   ---         deleted; see isch3
23-Dec-13 closedsub isch2
23-Dec-13 df-ch     [--same--]  revised
23-Dec-13 sh2       issh3
23-Dec-13 sh        issh2
23-Dec-13 df-sh     [--same--]  revised
23-Dec-13 pjmval    pjfval      revised
23-Dec-13 df-pj     [--same--]  revised
23-Dec-13 df-oc     [--same--]  revised
23-Dec-13 dfhnorm2  [--same--]  revised
23-Dec-13 df-hvsub  [--same--]  revised
23-Dec-13 df-hnorm  [--same--]  revised
23-Dec-13 nvmfval   [--same--]  revised
23-Dec-13 iscringd  [--same--]  (in JM's mathbox) revised
23-Dec-13 flddivrng [--same--]  moved from JM's mathbox to main set.mm; revised
23-Dec-13 isringod  [--same--]  moved from JM's mathbox to main set.mm; revised
23-Dec-13 exidreslem [--same--] (in JM's mathbox) revised
23-Dec-13 extopgrp  [--same--]  (in FL's mathbox) revised
23-Dec-13 invtrgrp  ginvsn      moved from FL's mathbox to main set.mm; revised
23-Dec-13 idtrgrp   gidsn       moved from FL's mathbox to main set.mm; revised
23-Dec-13 zrfld     [--same--]  (in FL's mathbox) revised
23-Dec-13 fldi      [--same--]  (in FL's mathbox) revised
23-Dec-13 rngunval2 [--same--]  (in FL's mathbox) revised
23-Dec-13 ununr     [--same--]  (in FL's mathbox) revised
23-Dec-13 mndid     [--same--]  (in FL's mathbox) (in FL's mathbox) revised
23-Dec-13 zrdivrng  [--same--]  revised
23-Dec-13 rngmgmbs4 [--same--]  revised
23-Dec-13 ismnd2    [--same--]  revised
23-Dec-13 ismnd1    [--same--]  revised
23-Dec-13 ismnd     [--same--]  revised
23-Dec-13 isexid2   [--same--]  revised
23-Dec-13 isexid    [--same--]  revised
23-Dec-13 df-exid   [--same--]  revised
23-Dec-13 0vfval    [--same--]  revised
23-Dec-13 ringoideu [--same--]  revised
23-Dec-13 ringid    [--same--]  revised
23-Dec-13 ringoi    [--same--]  revised
23-Dec-13 isringo   [--same--]  revised
23-Dec-13 df-ringo  [--same--]  revised
23-Dec-13 gxnval    [--same--]  revised
23-Dec-13 gxpval    [--same--]  revised
23-Dec-13 gxval     [--same--]  revised
23-Dec-13 gxoprval  gxfval      revised
23-Dec-13 grpdivfval [--same--] revised
23-Dec-13 grpoinvval [--same--] revised
23-Dec-13 grpoinvfval [--same--] revised
23-Dec-13 grpoidval [--same--]  revised
23-Dec-13 grpidvallem ---       deleted
23-Dec-13 fungid    fngid       revised
23-Dec-13 gid0      ---         deleted
23-Dec-13 grprlidrid ---        deleted
23-Dec-13 df-gx     [--same--]  revised
23-Dec-13 df-gdiv   [--same--]  revised
23-Dec-13 df-ginv   [--same--]  revised
23-Dec-13 df-gid    [--same--]  revised
22-Dec-13 df-igen   [--same--]  (in JM's mathbox) revised
22-Dec-13 pcoval    [--same--]  (in JM's mathbox) revised
22-Dec-13 pcofval   [--same--]  (in JM's mathbox) revised
22-Dec-13 df-pi1    [--same--]  (in JM's mathbox) revised
22-Dec-13 df-pi1b   [--same--]  (in JM's mathbox) revised
22-Dec-13 df-pco    [--same--]  (in JM's mathbox) revised
22-Dec-13 txsubsp   [--same--]  (in JM's mathbox) revised
22-Dec-13 subspabs  ---         (in JM's mathbox) deleted; use subspco
22-Dec-13 subspopn  [--same--]  (in JM's mathbox) revised
22-Dec-13 fzm1      [--same--]  moved from JM's mathbox to main set.mm
22-Dec-13 elfzp12   [--same--]  moved from JM's mathbox to main set.mm
22-Dec-13 zornn0    [--same--]  moved from JM's mathbox to main set.mm
22-Dec-13 inficl    [--same--]  moved from JM's mathbox to main set.mm; revised
22-Dec-13 resoprab2 [--same--]  moved from JM's mathbox to main set.mm
22-Dec-13 oprabval2a ovmpt2x    moved from JM's mathbox to main set.mm; revised
22-Dec-13 eqfnoprv2 [--same--]  moved from JM's mathbox to main set.mm
22-Dec-13 filnetlem5 [--same--] (in JGH's mathbox) revised
22-Dec-13 filnetlem4 [--same--] (in JGH's mathbox) revised
22-Dec-13 filnetlem3 [--same--] (in JGH's mathbox) revised
22-Dec-13 filnetlem2 [--same--] (in JGH's mathbox) revised
22-Dec-13 filnetlem1 [--same--] (in JGH's mathbox) revised
22-Dec-13 tailmap   tailf       (in JGH's mathbox)
22-Dec-13 istail    tailval     (in JGH's mathbox) revised
22-Dec-13 tailf     tailfval    (in JGH's mathbox) revised
22-Dec-13 fmfnfm    [--same--]  (in JGH's mathbox) revised
22-Dec-13 fmfnfmlem4 [--same--] (in JGH's mathbox) revised
22-Dec-13 fmfnfmlem3 [--same--] (in JGH's mathbox) revised
22-Dec-13 fmfnfmlem2 [--same--] (in JGH's mathbox) revised
22-Dec-13 fmfnfmlem1 [--same--] (in JGH's mathbox) revised
22-Dec-13 ufcondr   ufildr      (in JGH's mathbox) revised
22-Dec-13 uffinfix  [--same--]  (in JGH's mathbox) revised
22-Dec-13 fixufil   [--same--]  (in JGH's mathbox) changed variable names
22-Dec-13 uffixfr   [--same--]  (in JGH's mathbox) revised
22-Dec-13 ufileulem ---         (in JGH's mathbox) deleted
22-Dec-13 filssufillem ---      (in JGH's mathbox) deleted
22-Dec-13 supfil    [--same--]  (in JGH's mathbox) revised
22-Dec-13 fbasfip   [--same--]  moved from JGH's mathbox to main set.mm;revised
22-Dec-13 subsubtop ---         (in JGH's mathbox) to be deleted; use subspco
22-Dec-13 ssntr     [--same--]  moved from JGH's mathbox to main set.mm;revised
22-Dec-13 elfiun    [--same--]  moved from JGH's mathbox to main set.mm;revised
22-Dec-13 isrocatset [--same--] (in FL's mathbox) revised
22-Dec-13 df-rocatset [--same--] (in FL's mathbox) revised
22-Dec-13 singcon   ---         (in FL's mathbox) deleted
22-Dec-13 topsinind topsn       moved from FL's mathbox to main set.mm; revised
22-Dec-13 empcon    ---         (in FL's mathbox) deleted
22-Dec-13 intopcon  [--same--]  (in FL's mathbox) revised
22-Dec-13 clindistop [--same--] (in FL's mathbox) revised
22-Dec-13 stfincomp [--same--]  (in FL's mathbox) revised
22-Dec-13 cmptop    [--same--]  (in FL's mathbox) revised
22-Dec-13 subsincomp ---        (in FL's mathbox) deleted
22-Dec-13 subempcomp ---        (in FL's mathbox) deleted
22-Dec-13 limfillem2 ---        (in FL's mathbox) deleted
22-Dec-13 limfillem1 ---        (in FL's mathbox) deleted
22-Dec-13 trnei2    trnei       (in FL's mathbox) revised
22-Dec-13 trfil     [--same--]  (in FL's mathbox) revised
22-Dec-13 rcfpfil   [--same--]  (in FL's mathbox) revised
22-Dec-13 rcfpfillem6 ---       (in FL's mathbox) deleted
22-Dec-13 rcfpfillem5 ---       (in FL's mathbox) deleted
22-Dec-13 rcfpfillem4 ---       (in FL's mathbox) deleted
22-Dec-13 rcfpfillem3 ---       (in FL's mathbox) deleted
22-Dec-13 rcfpfillem2 ---       (in FL's mathbox) deleted
22-Dec-13 rcfpfillem1 ---       (in FL's mathbox) deleted
22-Dec-13 efilcp2   efilcp      (in FL's mathbox) revised
22-Dec-13 efilcp    [--same--]  (in FL's mathbox) revised
22-Dec-13 fgsb      ---         (in FL's mathbox) deleted; use fsubbas,fgfil
22-Dec-13 ptincpw   ---         (in FL's mathbox) deleted; use topgele
22-Dec-13 topge     ---         (in FL's mathbox) deleted; use pwuni
22-Dec-13 topgele   [--same--]  moved from FL's mathbox to main set.mm; revised
22-Dec-13 subtopsin2 subspsn2   moved from FL's mathbox to main set.mm; revised
22-Dec-13 stoig2b   ---         (in FL's mathbox) deleted; use subspuni
22-Dec-13 sbtpsines subspsn     moved from FL's mathbox to main set.mm; revised
22-Dec-13 subspemp2 subsp0      moved from FL's mathbox to main set.mm; revised
22-Dec-13 subspemp  ---         (in FL's mathbox) deleted; use subsp0
22-Dec-13 intopcoaconlem3 [--same--] (in FL's mathbox) revised
22-Dec-13 bintop3   ---         (in FL's mathbox) deleted; use fibas
22-Dec-13 bintop    ---         (in FL's mathbox) deleted; use fibas
22-Dec-13 topindis  ---         (in FL's mathbox) deleted; use topgele
22-Dec-13 rngop     [--same--]  moved from FL's mathbox to main set.mm
22-Dec-13 relcnvfld [--same--]  moved from FL's mathbox to main set.mm
22-Dec-13 ficli     ---         (in FL's mathbox) deleted; use fiin
22-Dec-13 fiiu      ---         (in FL's mathbox) deleted; use fipwuni
22-Dec-13 infi1     ---         (in FL's mathbox) deleted; use fiin
22-Dec-13 mpteq2dvg mpteq2dvgOLD (in FL's mathbox)
22-Dec-13 uzf       [--same--]  moved from SF's mathbox to main set.mm; revised
22-Dec-13 fzf       [--same--]  moved from SF's mathbox to main set.mm; revised
22-Dec-13 elfzm1b   [--same--]  moved from PC's mathbox to main set.mm
22-Dec-13 hashgaddOLD ---       (in PC's mathbox) deleted
22-Dec-13 ---       ---         nmcopexlem1 - nmcopexlem6 deleted
22-Dec-13 eigval1   eigvalval
22-Dec-13 kbvalval  kbval
22-Dec-13 kbval     kbfval      revised
22-Dec-13 bravalval braval
22-Dec-13 braval    brafval     revised
22-Dec-13 cnfnc     [--same--]  revised
22-Dec-13 elnlfn    [--same--]  revised
22-Dec-13 cnopc     [--same--]  revised
22-Dec-13 eigvalval eigvalfval  revised
22-Dec-13 eigvecval [--same--]  revised
22-Dec-13 elcnfn    [--same--]  revised
22-Dec-13 nlfnval   [--same--]  revised
22-Dec-13 dfbdop2   df-bdop
22-Dec-13 elcnop    [--same--]  revised
22-Dec-13 df-spec   [--same--]  revised
22-Dec-13 df-eigval [--same--]  revised
22-Dec-13 df-eigvec [--same--]  revised
22-Dec-13 df-kb     [--same--]  revised
22-Dec-13 df-bra    [--same--]  revised
22-Dec-13 df-lnfn   [--same--]  revised
22-Dec-13 df-cnfn   [--same--]  revised
22-Dec-13 df-nlfn   [--same--]  revised
22-Dec-13 df-nmfn   [--same--]  revised
22-Dec-13 df-hmop   [--same--]  revised
22-Dec-13 df-bdop   [--same--]  revised
22-Dec-13 df-lnop   [--same--]  revised
22-Dec-13 df-cnop   [--same--]  revised
22-Dec-13 df-nmop   [--same--]  revised
22-Dec-13 hfsval    [--same--]  revised
22-Dec-13 hfmmval   [--same--]  revised
22-Dec-13 hfsmval   [--same--]  revised
22-Dec-13 hodmval   [--same--]  revised
22-Dec-13 hommval   [--same--]  revised
22-Dec-13 hosmval   [--same--]  revised
22-Dec-13 df-hfmul  [--same--]  revised
22-Dec-13 df-hsum   [--same--]  revised
22-Dec-13 df-hodif  [--same--]  revised
22-Dec-13 df-homul  [--same--]  revised
22-Dec-13 df-hosum  [--same--]  revised
22-Dec-13 tosdir    [--same--]  revised
22-Dec-13 dirge     [--same--]  changed variable names
22-Dec-13 dirtr     [--same--]  changed variable names
22-Dec-13 dirref    [--same--]  changed variable names
22-Dec-13 dirdm     [--same--]  changed variable names
22-Dec-13 reldir    [--same--]  changed variable names
22-Dec-13 isdir     [--same--]  revised
22-Dec-13 df-tail   [--same--]  revised
22-Dec-13 df-dir    [--same--]  revised
22-Dec-13 contop    [--same--]  revised
22-Dec-13 hausfillim2 hausflim2
22-Dec-13 sflimf    flfval
22-Dec-13 flimff    flffval     revised
22-Dec-13 elfilmap3 elfm3
22-Dec-13 elfilmap2 elfm2
22-Dec-13 elfilmap  elfm
22-Dec-13 fmf       fmfil
22-Dec-13 filmapss  fmss        changed variable names
22-Dec-13 isfilmap  fmval       changed variable names
22-Dec-13 filmapf   fmfval      revised
22-Dec-13 df-flimf  df-flf      revised
22-Dec-13 df-filmap df-fm       revised
22-Dec-13 cflimf    cflf
22-Dec-13 cfilmap   cfm
22-Dec-13 hausfillim hausflim
22-Dec-13 isfillim  elflim
22-Dec-13 limfil    flimval
22-Dec-13 sfvlim    flimfval    revised
22-Dec-13 df-flim1  df-flim     revised
22-Dec-13 cflim1    cflim       revised
22-Dec-13 fbunfip   [--same--]  revised
22-Dec-13 fsubbas   [--same--]  revised
22-Dec-13 infi      fiin        revised
22-Dec-13 0nelfb    [--same--]  revised
22-Dec-13 oefil2    snfil
22-Dec-13 filintf   infil       revised
22-Dec-13 emnfil    [--same--]  revised
22-Dec-13 isfil     isfil2      revised
22-Dec-13 df-fil    [--same--]  revised
22-Dec-13 df-fg     [--same--]  revised
22-Dec-13 subsptop  [--same--]  revised
22-Dec-13 stoigOLD  ---         deleted
22-Dec-13 stoiglem  ---         deleted
22-Dec-13 stoiglemOLD ---       deleted
22-Dec-13 elsubsp   elsubspr    revised
22-Dec-13 issubspt  elsubsp     revised
22-Dec-13 issubsplem1 ---       deleted
22-Dec-13 issubsp   ---         deleted
22-Dec-13 subsp     subspval    revised
22-Dec-13 subspi    [--same--]  revised
22-Dec-13 df-subsp  [--same--]  revised
22-Dec-13 df-homeo  [--same--]  revised
22-Dec-13 fibas     [--same--]  revised
22-Dec-13 fiiu2     fipwuni     revised
22-Dec-13 sppfi     elfi        revised
22-Dec-13 spfi      ---         deleted
22-Dec-13 abfi2     ssfii
22-Dec-13 abfi      ---         deleted
22-Dec-13 inficlALT inficl
22-Dec-13 fine2     fi0         revised
22-Dec-13 fine      ---         deleted
22-Dec-13 fiv       fival       revised
22-Dec-13 df-fi     [--same--]  revised
22-Dec-13 istoset   istoset3    revised
22-Dec-13 df-toset  [--same--]  revised
22-Dec-13 symgval   [--same--]  revised
22-Dec-13 symgoprab ---         deleted
22-Dec-13 df-symgrp df-symg     revised
22-Dec-13 csymgrp   csymg
22-Dec-13 pilem3    [--same--]  revised
22-Dec-13 spwpr4OLD ---         deleted
22-Dec-13 spwex     [--same--]  changed variable names
22-Dec-13 spwcl     [--same--]  changed variable names
22-Dec-13 spwnex    ---         deleted
22-Dec-13 spwval3   ---         deleted
22-Dec-13 spwval    [--same--]  revised
22-Dec-13 spwval2   [--same--]  revised
22-Dec-13 df-spw    [--same--]  revised
22-Dec-13 ipblnfi   [--same--]  revised
22-Dec-13 nmofval   [--same--]  revised
22-Dec-13 lnolin    [--same--]  revised
22-Dec-13 islno     [--same--]  revised
22-Dec-13 lnoval    [--same--]  revised
22-Dec-13 df-hmo    [--same--]  revised
22-Dec-13 df-aj     [--same--]  revised
22-Dec-13 df-0o     [--same--]  revised
22-Dec-13 df-blo    [--same--]  revised
22-Dec-13 df-nmo    [--same--]  revised
22-Dec-13 df-lno    [--same--]  revised
22-Dec-13 df-ssp    [--same--]  revised
22-Dec-13 ipfval    [--same--]  revised
22-Dec-13 df-ip     [--same--]  revised
22-Dec-13 df-ims    [--same--]  revised
22-Dec-13 df-ba     [--same--]  revised
22-Dec-13 opnfval   [--same--]  revised
22-Dec-13 ismsg     ---         deleted
22-Dec-13 mscl      ---         deleted
22-Dec-13 msf       ---         deleted
22-Dec-13 msflem    ---         deleted
22-Dec-13 msrel     ---         deleted
22-Dec-13 df-opn    [--same--]  revised
22-Dec-13 df-ball   [--same--]  revised
22-Dec-13 df-met    [--same--]  revised
22-Dec-13 cnpfval   [--same--]  revised
22-Dec-13 df-cnp    [--same--]  revised
22-Dec-13 df-cn     [--same--]  revised
22-Dec-13 lpfval    [--same--]  revised
22-Dec-13 df-lp     [--same--]  revised
22-Dec-13 neival    [--same--]  revised
22-Dec-13 neifval   [--same--]  revised
22-Dec-13 df-nei    [--same--]  revised
22-Dec-13 ntrval    [--same--]  revised
22-Dec-13 clsfval   [--same--]  revised
22-Dec-13 ntrfval   [--same--]  revised
22-Dec-13 cldval    [--same--]  revised
22-Dec-13 df-cls    [--same--]  revised
22-Dec-13 df-ntr    [--same--]  revised
22-Dec-13 df-cld    [--same--]  revised
22-Dec-13 df-tx     [--same--]  revised
22-Dec-13 df-topgen [--same--]  revised
22-Dec-13 df-top    [--same--]  revised
22-Dec-13 unbenlem  [--same--]  revised
22-Dec-13 df-gcd    [--same--]  revised
22-Dec-13 reeff1o2  reeff1o
22-Dec-13 reeff1o   [--same--]  revised
22-Dec-13 reeff1    [--same--]  revised
22-Dec-13 df-pi     [--same--]  revised
22-Dec-13 df-cos    [--same--]  revised
22-Dec-13 df-sin    [--same--]  revised
22-Dec-13 df-ef     [--same--]  revised
22-Dec-13 cncfval   [--same--]  revised
22-Dec-13 df-cncf   [--same--]  revised
22-Dec-13 climshft2i climshft2  revised
22-Dec-13 climresi  ---         deleted
22-Dec-13 climshfti ---         deleted
22-Dec-13 clim      [--same--]  revised
22-Dec-13 df-clim   [--same--]  revised
22-Dec-13 hashgadd  [--same--]  revised
22-Dec-13 hashenOLDOLD ---      deleted
22-Dec-13 hashenOLD ---         deleted
22-Dec-13 hashfz1OLD ---        deleted
22-Dec-13 hashginvOLD ---       deleted
22-Dec-13 hashgvalOLD ---       deleted
22-Dec-13 hashginv  [--same--]  revised
22-Dec-13 hashgval  [--same--]  revised
22-Dec-13 fz1fiOLD  ---         deleted
22-Dec-13 hashgf1o  [--same--]  revised
22-Dec-13 df-hash   [--same--]  revised
22-Dec-13 bccl2     [--same--]  revised
22-Dec-13 bcpasci   ---         deleted
22-Dec-13 bcpasc2   ---         deleted
22-Dec-13 bcpasc2i  ---         deleted
22-Dec-13 bcnp11    bcn1        revised
22-Dec-13 bccmpl    [--same--]  revised
22-Dec-13 bcval3    [--same--]  revised
22-Dec-13 bcval2    [--same--]  revised
22-Dec-13 bcval     [--same--]  revised
22-Dec-13 df-bc     [--same--]  revised
22-Dec-13 df-abs    [--same--]  revised
22-Dec-13 cjval     remim
22-Dec-13 imval     [--same--]  revised
22-Dec-13 reval     [--same--]  revised
22-Dec-13 df-im     [--same--]  revised
22-Dec-13 df-re     [--same--]  revised
22-Dec-13 df-cj     [--same--]  revised
22-Dec-13 df-limsup [--same--]  revised
22-Dec-13 shftf     [--same--]  revised
22-Dec-13 shftval   [--same--]  revised
22-Dec-13 shftresval ---        deleted
22-Dec-13 shftres   ---         deleted
22-Dec-13 shftfn    [--same--]  revised
22-Dec-13 shftfval  [--same--]  revised
22-Dec-13 df-shft   [--same--]  revised
22-Dec-13 cardfz    [--same--]  revised
22-Dec-13 fzennn    [--same--]  revised
22-Dec-13 uzrdgsuci [--same--]  revised
22-Dec-13 uzrdg0i   [--same--]  revised
22-Dec-13 uzrdgfni  [--same--]  revised
22-Dec-13 uzrdglem  [--same--]  revised
22-Dec-13 om2uzrdg  [--same--]  revised
22-Dec-13 om2uzisoi [--same--]  revised
22-Dec-13 om2uzf1oi [--same--]  revised
22-Dec-13 om2uzrani [--same--]  revised
22-Dec-13 om2uzlt2i [--same--]  revised
22-Dec-13 om2uzlti  [--same--]  revised
22-Dec-13 om2uzuzi  [--same--]  revised
22-Dec-13 om2uzsuci [--same--]  revised
22-Dec-13 om2uz0i   [--same--]  revised
22-Dec-13 df-fz     [--same--]  revised
22-Dec-13 df-uz     [--same--]  revised
22-Dec-13 df-icc    [--same--]  revised
22-Dec-13 df-ico    [--same--]  revised
22-Dec-13 df-ioc    [--same--]  revised
22-Dec-13 df-ioo    [--same--]  revised
22-Dec-13 df-mod    [--same--]  revised
22-Dec-13 df-fl     [--same--]  revised
22-Dec-13 df-div    [--same--]  revised
22-Dec-13 df-sub    [--same--]  revised
22-Dec-13 cflim     cflm
22-Dec-13 cffnon    cff         revised
22-Dec-13 df-cda    [--same--]  revised
22-Dec-13 alephlim  [--same--]  changed variable names
22-Dec-13 df-cf     [--same--]  revised
22-Dec-13 df-aleph  [--same--]  revised
22-Dec-13 df-card   [--same--]  revised
22-Dec-13 df-rank   [--same--]  revised
22-Dec-13 df-r1     [--same--]  revised
22-Dec-13 abfii5    ---         deleted; use dffi2
22-Dec-13 abfii4    ---         deleted; use dffi2
22-Dec-13 abfii3    ---         deleted; use dffi2
22-Dec-13 abfii2    ---         deleted; use dffi2
22-Dec-13 abfii1    ---         deleted; use dffi2
22-Dec-13 df-pm     [--same--]  revised
22-Dec-13 df-map    [--same--]  revised
22-Dec-13 oev2      [--same--]  revised
22-Dec-13 df-oexp   [--same--]  revised
22-Dec-13 df-omul   [--same--]  revised
22-Dec-13 df-oadd   [--same--]  revised
22-Dec-13 frsucmpt2 ---         deleted
22-Dec-13 frsucopab ---         deleted
22-Dec-13 rdglimi   ---         deleted
22-Dec-13 rdgsuci   ---         deleted
22-Dec-13 rdgval    [--same--]  revised
22-Dec-13 rdglem2   ---         deleted
22-Dec-13 dfrdg2    ---         deleted
22-Dec-13 df-rdg    [--same--]  revised
22-Dec-13 tz7.44-3  [--same--]  revised
22-Dec-13 tz7.44-2  [--same--]  revised
22-Dec-13 tz7.44-1  [--same--]  revised
22-Dec-13 foprab2a  [--same--]  revised
22-Dec-13 df-2nd    [--same--]  revised
22-Dec-13 df-1st    [--same--]  revised
22-Dec-13 resmpt2   resmpt
22-Dec-13 mpteq2dvaf mpteq2da
22-Dec-13 mpteqi    mpteq12i
22-Dec-13 oprabval2gfOLD ---    deleted
22-Dec-13 oprabval2gf ---       deleted
22-Dec-13 oprabval2gfNEW oprabval2gf revised
22-Dec-13 oprabvali ---         deleted
22-Dec-13 oprabvaligg [--same--] revised
22-Dec-13 oprabvalig [--same--] revised
25-Nov-13 eq2ab     ---         obsolete; use abbi instead
14-Nov-13 sb19.21   sbrim
11-Nov-13 alrot3    [--same--]  moved from ATS's mathbox to main set.mm
11-Nov-13 pm11.53   [--same--]  moved from ATS's mathbox to main set.mm
 4-Nov-13 ispos     [--same--]  removed nonempty base set requirement
 4-Nov-13 df-poset  [--same--]  removed nonempty base set requirement
17-Oct-13 mpt2eqdv  mpt2eqdva
17-Oct-13 mpt2eqdvg mpt2eqdvaf  moved from FL's mathbox to main set.mm
 6-Oct-13 ipid      ipidsq
 5-Oct-13 plusgval  ---         obsolete; use grpplusg
 5-Oct-13 divrngmgrp [--same--] eliminated hard-coded structure indices
 5-Oct-13 divrngid  [--same--]  eliminated hard-coded structure indices
 5-Oct-13 divrngidlem [--same--] eliminated hard-coded structure indices
 5-Oct-13 invrfval  [--same--]  eliminated hard-coded structure indices
 5-Oct-13 divrngid  [--same--]  eliminated hard-coded structure indices
 5-Oct-13 divrngidlem [--same--] eliminated hard-coded structure indices
 5-Oct-13 divrngmgrp [--same--] eliminated hard-coded structure indices
 5-Oct-13 isdivrng  [--same--]  eliminated hard-coded structure indices
 5-Oct-13 df-drng   [--same--]  eliminated hard-coded structure indices
 5-Oct-13 ndxargi   ndxarg
 5-Oct-13 strcval   strfvn
 3-Oct-13 ringmulr  rngmulr     eliminated unnecessary hypotheses
 3-Oct-13 ringplusg rngplusg    eliminated unnecessary hypotheses
 3-Oct-13 ringbase  rngbase     eliminated unnecessary hypotheses
 3-Oct-13 grpplusgg ---         obsolete; use grpplusg
 3-Oct-13 grpbaseg  ---         obsolete; use grpbase
 3-Oct-13 grpplusg  [--same--]  eliminated unnecessary antecedent
 3-Oct-13 grpbase   [--same--]  eliminated unnecessary antecedent
 3-Oct-13 str3v3    ---         obsolete; use strfv
 3-Oct-13 str3v2    ---         obsolete; use strfv
 3-Oct-13 str3v1    ---         obsolete; use strfv
 3-Oct-13 str2v2    ---         obsolete; use strfv
 3-Oct-13 str2v1    ---         obsolete; use strfv
 3-Oct-13 str3v3x   ---         obsolete; use strfv
 3-Oct-13 str3v2x   ---         obsolete; use strfv
 3-Oct-13 str3v1x   ---         obsolete; use strfv
 3-Oct-13 str2v2x   ---         obsolete; use strfv
 3-Oct-13 str2v1x   ---         obsolete; use strfv
 3-Oct-12 tpshyp    ---         obsolete; use tpslem
 3-Oct-13 ringhyp   ---         obsolete; use rnglem
 3-Oct-13 grphyp    ---         obsolete; use grplem
 3-Oct-13 poshyp    ---         obsolete; use poslem
 3-Oct-13 poslem    posi
 2-Oct-13 isfinite  ---         obsolete; use isfinite3
 1-Oct-13 ressnop0  [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fvtp3     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fvtp2     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fvtp1     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fvpr2     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fvpr1     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fntp      [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 fnprg     [--same--]  eliminated unnecessary antecedents
 1-Oct-13 fnsn      [--same--]  eliminated unnecessary hypothesis
 1-Oct-13 funtp     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 funpr     [--same--]  eliminated unnecessary hypotheses
 1-Oct-13 funprg    [--same--]  eliminated unnecessary antecedents
 1-Oct-13 funsng    [--same--]  eliminated unnecessary antecedent
 1-Oct-13 funsn     [--same--]  eliminated unnecessary hypothesis
30-Sep-13 ltneii    [--same--]  swapped conclusion vars for ltnei compatibility
25-Sep-13 2nalexn   [--same--]  moved from ATS's mathbox to main set.mm
25-Sep-13 2exnexn   [--same--]  moved from ATS's mathbox to main set.mm
24-Sep-13 supeq2    [--same--]  moved from JM's mathbox to main set.mm
24-Sep-13 ixpfi     [--same--]  moved from JM's mathbox to main set.mm
24-Sep-13 mapfi     [--same--]  moved from JM's mathbox to main set.mm
24-Sep-13 enf1f1o   fienf1f1o   moved from JM's mathbox to main set.mm
24-Sep-13 nnaun2    ficardun2
24-Sep-13 nnaun     ficardun
24-Sep-13 relsn     relsnop
24-Sep-13 difdisj   disjdif
20-Sep-13 imdistanda [--same--] moved from JM's mathbox to main set.mm
20-Sep-13 rnoprab2  [--same--]  moved from SF's mathbox to main set.mm
20-Sep-13 eqfunfv   [--same--]  moved from SF's mathbox to main set.mm
20-Sep-13 pm5.21ndd [--same--]  moved from PC's mathbox to main set.mm
20-Sep-13 div2neg   [--same--]  moved from PC's mathbox to main set.mm
16-Sep-13 oprabexd  [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 fsum00    [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 fzdisj    [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 fzsplit   [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 fzn0      [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 fz10      [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 addsubeq4 [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 add20     [--same--]  moved from JM's mathbox to main set.mm
16-Sep-13 f1elima   [--same--]  moved from JM's mathbox to main set.mm
15-Sep-13 hashpw    [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 hashpwlem [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 hashxp    [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 hashxplem [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 hashunsng [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 hashun    [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 hashgadd  [--same--]  moved from PC's mathbox to main set.mm
15-Sep-13 2ne3      ---         obsolete (use 2lt3 + ltneii instead)
15-Sep-13 1ne9      ---         obsolete (use 1lt9 + ltneii instead)
15-Sep-13 1ne3      ---         obsolete (use 1lt3 + ltneii instead)
10-Sep-13 exp5c     [--same--]  moved from JGH's mathbox to main set.mm
10-Sep-13 snelpwr   snelpwi     moved from AS's mathbox to main set.mm
 8-Sep-13 df-exp    [--same--]  revised definition
 8-Sep-13 df-fac    [--same--]  revised definition
 8-Sep-13 df-seq0   [--same--]  revised definition
 8-Sep-13 df-seq1   [--same--]  revised definition
 8-Sep-13 df-seqz   [--same--]  revised definition
 8-Sep-13 df-sqr    [--same--]  revised definition
 8-Sep-13 expval    [--same--]  revised theorem statement
 8-Sep-13 facnn     [--same--]  revised theorem statement
 8-Sep-13 fzp1ss    [--same--]  revised theorem statement
 8-Sep-13 fzss1     [--same--]  revised theorem statement
 8-Sep-13 fzss2     [--same--]  revised theorem statement
 8-Sep-13 fzssp1    [--same--]  revised theorem statement
 8-Sep-13 om2uzf1oi [--same--]  revised theorem statement
 8-Sep-13 om2uzisoi [--same--]  revised theorem statement
 8-Sep-13 om2uzrani [--same--]  revised theorem statement
 8-Sep-13 om2uzuzi  [--same--]  revised theorem statement
 8-Sep-13 seq0fval  [--same--]  revised theorem statement
 8-Sep-13 seqzfval  [--same--]  revised theorem statement
 8-Sep-13 sqrlem1   [--same--]  revised theorem statement
 8-Sep-13 sqrlem2   [--same--]  revised theorem statement
 8-Sep-13 sqrlem3   [--same--]  revised theorem statement
 8-Sep-13 sqrlem4   [--same--]  revised theorem statement
 8-Sep-13 sqrlem5   [--same--]  revised theorem statement
 8-Sep-13 sqrlem6   [--same--]  revised theorem statement
 8-Sep-13 sqrlem7   [--same--]  revised theorem statement
 8-Sep-13 sqrval    [--same--]  revised theorem statement
 8-Sep-13 uzrdgsuci [--same--]  revised theorem statement
 8-Sep-13 sqrcl     resqrcl     (new sqrcl is complex version)
 8-Sep-13 dfseq0    ---         obsolete
 8-Sep-13 expnnval  ---         obsolete
 8-Sep-13 seq0valt  ---         obsolete
 8-Sep-13 seq11lem  ---         obsolete
 8-Sep-13 seq1fnlem ---         obsolete
 8-Sep-13 seq1lem1  ---         obsolete
 8-Sep-13 seq1rval  ---         obsolete
 8-Sep-13 seq1seq0  ---         obsolete
 8-Sep-13 seq1seq01 ---         obsolete
 8-Sep-13 seq1seq02 ---         obsolete
 8-Sep-13 seq1suclem ---        obsolete
 8-Sep-13 seq1val   ---         obsolete
 8-Sep-13 seq1val2  ---         obsolete
 8-Sep-13 seqzfval2 ---         obsolete
 8-Sep-13 seqzval   ---         obsolete
 8-Sep-13 seqzval2  ---         obsolete
 8-Sep-13 ---       ---         sqrlem10 - sqrlem24 and sqrlem26 obsolete
 8-Sep-13 sqrlem8   ---         obsolete
 8-Sep-13 sqrlem9   ---         obsolete
 8-Sep-13 uzrdgfnuzi ---        obsolete
 8-Sep-13 uzrdginii ---         obsolete
 8-Sep-13 uzrdginip1i ---       obsolete
 8-Sep-13 uzrdgvali ---         obsolete
 8-Sep-13 ---       ---         math token "seq" changed to "seqz"
 2-Sep-13 ltfrn     [--same--]  revised theorem statement
 2-Sep-13 ltfrn     [--same--]  moved from ATS's mathbox to main set.mm
 2-Sep-13 eluzsub   [--same--]  moved from JM's mathbox to main set.mm
 2-Sep-13 eluzadd   [--same--]  moved from JM's mathbox to main set.mm
 2-Sep-13 rdgeq12   [--same--]  moved from SF's mathbox to main set.mm
 1-Sep-13 raffsp    craffsp     (in FL's mathbox)
 1-Sep-13 ptdfc     cptdfc      (in ATS's mathbox)
 1-Sep-13 rr3c      crr3c       (in ATS's mathbox)
 1-Sep-13 psc       cpscN        (in NM's mathbox)
 1-Sep-13 wgcdOLD   cgcdOLD     (in JH's mathbox)
 1-Sep-13 plusrc    cplusr      (in ATS's mathbox)
 1-Sep-13 minusrc   cminusr     (in ATS's mathbox)
 1-Sep-13 timesrc   ctimesr     (in ATS's mathbox)
 1-Sep-13 csmo      wsmo
 1-Sep-13 syn-bnj17 w-bnj17     (in JB's mathbox)
 1-Sep-13 syn-bnj16 c-bnj16     (in JB's mathbox)
 1-Sep-13 syn-bnj14 c-bnj14     (in JB's mathbox)
 1-Sep-13 syn-bnj13 w-bnj13     (in JB's mathbox)
 1-Sep-13 syn-bnj15 w-bnj15     (in JB's mathbox)
 1-Sep-13 syn-bnj18 c-bnj18     (in JB's mathbox)
 1-Sep-13 syn-bnj19 w-bnj19     (in JB's mathbox)
 1-Sep-13 vd1       wvd1        (in AS's mathbox)
 1-Sep-13 vd2       wvd2        (in AS's mathbox)
 1-Sep-13 vd3       wvd3        (in AS's mathbox)
31-Aug-13 trcl-df   df-trcl     (in FL's mathbox)
31-Aug-13 rtrcl-df  df-rtrcl    (in FL's mathbox)
31-Aug-13 orHom-df  df-orHom    (in FL's mathbox)
31-Aug-13 orIso-df  df-orIso    (in FL's mathbox)
31-Aug-13 decfun-df df-decfun   (in FL's mathbox)
31-Aug-13 expsg-df  df-expsg    (in FL's mathbox)
29-Aug-13 clsbldneg notab       moved from FL's mathbox to main set.mm
18-Aug-13 oprabval2gf [--same--] added bound var hypotheses
10-Aug-13 vtocl2gf  [--same--]  added bound var hypotheses
 7-Aug-13 ringidval [--same--]  changed iota to iota_
 7-Aug-13 df-1r     [--same--]  changed iota to iota_
 7-Aug-13 grpidcl   [--same--]  changed variable names
 7-Aug-13 grpid     [--same--]  changed variable names
 7-Aug-13 grpinveu  [--same--]  changed variable names
 7-Aug-13 grpinvid  [--same--]  changed variable names
 7-Aug-13 grpinvid2 [--same--]  changed variable names
 7-Aug-13 grpinvid1 [--same--]  changed variable names
 7-Aug-13 grprinv   [--same--]  changed variable names
 7-Aug-13 grplinv   [--same--]  changed variable names
 7-Aug-13 grpinv    [--same--]  changed variable names
 7-Aug-13 grpinvval [--same--]  changed iota to iota_
 7-Aug-13 grpinvfval [--same--] changed iota to iota_
 7-Aug-13 df-minusg [--same--]  changed iota to iota_
 7-Aug-13 grprid    [--same--]  changed variable names
 7-Aug-13 grplid    [--same--]  changed variable names
 7-Aug-13 grpidinv2 [--same--]  changed variable names
 7-Aug-13 grpidval  [--same--]  changed iota to iota_
 7-Aug-13 df-0g     [--same--]  changed iota to iota_
 6-Aug-13 isabld    isablod     (in JM's mathbox)
 2-Aug-13 isringd   isringod    (in JM's mathbox)
30-Jul-13 riemtn    mptresid    moved from FL's mathbox to main set.mm
30-Jul-13 riecb     opabresid   moved from FL's mathbox to main set.mm
25-Jul-13 sbcne12g  [--same--]  moved from ATS's mathbox to main set.mm
25-Jul-13 sbcnel12g [--same--]  moved from ATS's mathbox to main set.mm
17-Jul-13 fvopab4s  [--same--]  eliminated redundant hypothesis
30-Jun-13 bnj1263   syl5sseqr   moved from JB's mathbox to main set.mm
30-Jun-13 bnj1264   syl5sseq    moved from JB's mathbox to main set.mm
30-Jun-13 bnj1141   syl6ss      moved from JB's mathbox to main set.mm
24-Jun-13 onsubcum  onssr1      moved from FL's mathbox to main set.mm
21-Jun-13 19.40-2   [--same--]  moved from ATS's mathbox to main set.mm
21-Jun-13 hbxfr     hbxfreq
21-Jun-13 ssopab2   ssopab2b
18-Jun-13 boe       enpr1g      moved from FL's mathbox to main set.mm
18-Jun-13 unpde2eg2 pr2nelem    moved from FL's mathbox to main set.mm
18-Jun-13 unpde2eg22 pr2ne      moved from FL's mathbox to main set.mm
18-Jun-13 unpam2    prdom2      moved from FL's mathbox to main set.mm
18-Jun-13 uncum     r1tr2       moved from FL's mathbox to main set.mm
18-Jun-13 ctarski   ctsk        moved from FL's mathbox to main set.mm
18-Jun-13 cgruni    cgru        moved from FL's mathbox to main set.mm
18-Jun-13 df-tsk    [--same--]  moved from FL's mathbox to main set.mm
18-Jun-13 taralt    dftsk2      moved from FL's mathbox to main set.mm
18-Jun-13 tarval    eltsk       moved from FL's mathbox to main set.mm
18-Jun-13 tarvalg   eltskg      moved from FL's mathbox to main set.mm
18-Jun-13 tarval1   eltsk2      moved from FL's mathbox to main set.mm
18-Jun-13 tarval1g  eltsk2g     moved from FL's mathbox to main set.mm
18-Jun-13 tarax1    tskpwss     moved from FL's mathbox to main set.mm
18-Jun-13 tarax2    tskpw       moved from FL's mathbox to main set.mm
18-Jun-13 tarax3    tsken       moved from FL's mathbox to main set.mm
18-Jun-13 empistar  0tsk        moved from FL's mathbox to main set.mm
18-Jun-13 tarax3d2  tsksdom     moved from FL's mathbox to main set.mm
18-Jun-13 tarax3e   tskssel2    moved from FL's mathbox to main set.mm
18-Jun-13 tarax3f   tskssel     moved from FL's mathbox to main set.mm
18-Jun-13 tarsin    tsksn       moved from FL's mathbox to main set.mm
18-Jun-13 emptar    tsk0        moved from FL's mathbox to main set.mm
18-Jun-13 tarone    tsk1        moved from FL's mathbox to main set.mm
18-Jun-13 tartwo    tsk2        moved from FL's mathbox to main set.mm
18-Jun-13 tarmrtwo  2domtsk     moved from FL's mathbox to main set.mm
18-Jun-13 tarunpa   tskpr       moved from FL's mathbox to main set.mm
18-Jun-13 tarorpa   tskop       moved from FL's mathbox to main set.mm
18-Jun-13 tarcrpr   tskxpss     moved from FL's mathbox to main set.mm
18-Jun-13 ixpssmapg [--same--]  moved from JM's mathbox to main set.mm
18-Jun-13 bnj572    hbxfrbi     moved from JB's mathbox to main set.mm
 5-Jun-13 isgrpd    isgrpod     (in JM's mathbox)
24-May-13 pm2.01bd  pm2.18d     moved from FL's mathbox to main set.mm
23-May-13 r19.3zvb  r19.3z      moved from FL's mathbox to main set.mm
22-May-13 son2lpi   [--same--]  eliminated redundant hypotheses
22-May-13 sotri     [--same--]  eliminated redundant hypotheses
22-May-13 soirri    [--same--]  eliminated redundant hypothesis
22-May-13 suprnubii [--same--]  eliminated redundant hypothesis
22-May-13 suprleubii [--same--]  eliminated redundant hypothesis
20-May-13 suprnub   [--same--]  eliminated redundant antecedent
20-May-13 suprleub  [--same--]  eliminated redundant antecedent
20-May-13 noinfep   [--same--]  eliminated redundant antecedent
18-May-13 pre-axlttri axpre-lttri
18-May-13 pre-axlttrn axpre-lttrn
18-May-13 pre-axltadd axpre-ltadd
18-May-13 pre-axmulgt0 axpre-mulgt0
18-May-13 pre-axsup  axpre-sup
16-May-13 3ne0      [--same--]  moved from FL's mathbox to main set.mm
16-May-13 3cn       [--same--]  moved from FL's mathbox to main set.mm
16-May-13 ltaddpos2tb ltaddrp   moved from FL's mathbox to main set.mm
16-May-13 ltsubpostb ltsubrp    moved from FL's mathbox to main set.mm
16-May-13 r19.26t   r19.26-3    moved from FL's mathbox to main set.mm
16-May-13 uzp1      [--same--]  moved from JM's mathbox to main set.mm
16-May-13 uzm1      [--same--]  moved from JM's mathbox to main set.mm
16-May-13 r1subsuc  r1sssuc     moved from FL's mathbox to main set.mm
15-May-13 impbidd   [--same--]  moved from RM's mathbox to main set.mm
26-Apr-13 domint    dmiin       moved from FL's mathbox to main set.mm
26-Apr-13 inpartelt iinss2      moved from FL's mathbox to main set.mm
25-Apr-13 ssiing    ssiinf      moved from FL's mathbox to main set.mm
24-Apr-13 cnvintcnv cnviin      moved from FL's mathbox to main set.mm
23-Apr-13 eqrelrivg eqrelriv    moved from FL's mathbox to main set.mm
23-Apr-13 eqrelriv  eqrelriiv
22-Apr-13 coeq12d   [--same--]  moved from FL's mathbox to main set.mm
21-Apr-13 coeq12i   [--same--]  moved from FL's mathbox to main set.mm
20-Apr-13 cexint2   iinexg      moved from FL's mathbox to main set.mm
19-Apr-13 fnimapr   [--same--]  moved from JM's mathbox to main set.mm
18-Apr-13 foco2     [--same--]  moved from JM's mathbox to main set.mm
17-Apr-13 pm11.07   [--same--]  moved from ATS's mathbox to main set.mm
16-Apr-13 rcla4t    [--same--]  moved from ATS's mathbox to main set.mm
15-Apr-13 cla4gft   [--same--]  moved from ATS's mathbox to main set.mm
14-Apr-13 isseta    issetf      moved from ATS's mathbox to main set.mm
12-Apr-13 orkurss   opid        moved from FL's mathbox to main set.mm
11-Apr-13 cmpinj    f1cocnv1    moved from FL's mathbox to main set.mm
11-Apr-13 cmpinj2   f1cocnv2    moved from FL's mathbox to main set.mm
10-Apr-13 cnvinj    f1cnv       moved from FL's mathbox to main set.mm
10-Apr-13 f1cnv     f1cnvcnv
 9-Apr-13 reltrncnv relcnvtr    moved from FL's mathbox to main set.mm
 9-Apr-13 fmptd     [--same--]  added "F =" hypothesis
 9-Apr-13 fnmpt     funmpt
 8-Apr-13 cnveq2    cnveqb      moved from FL's mathbox to main set.mm
 7-Apr-13 prnzg     [--same--]  moved from FL's mathbox to main set.mm
 6-Apr-13 resrelfld relresfld   moved from FL's mathbox to main set.mm
 5-Apr-13 cmprelid2 relcoi1     moved from FL's mathbox to main set.mm
 5-Apr-13 cmprelid1 relcoi2     moved from FL's mathbox to main set.mm
 5-Apr-13 inclrel   coss1       moved from FL's mathbox to main set.mm
 5-Apr-13 cmpdia    coires1     moved from FL's mathbox to main set.mm
 4-Apr-13 findcard2s [--same--]  moved from PC's mathbox to main set.mm
 3-Apr-13 prmexpb   [--same--]  moved from PC's mathbox to main set.mm
 3-Apr-13 prmdvdsexpb [--same--]  moved from PC's mathbox to main set.mm
 2-Apr-13 imimorb   [--same--]  moved from PC's mathbox to main set.mm
 1-Apr-13 ac6sg     [--same--]  antecedent now has V instead of _V
 1-Apr-13 clint3    ---         obsolete; use icccld instead
 1-Apr-13 clicls    icccld
 1-Apr-13 lemul2aALT ---        obsolete; use lemul2a instead
 1-Apr-13 cdrci     difreicc
 1-Apr-13 rabeq0    [--same--]  moved from JM's mathbox to main set.mm
31-Mar-13 difin2    [--same--]  moved from JM's mathbox to main set.mm
30-Mar-13 respreima [--same--]  moved from JM's mathbox to main set.mm
29-Mar-13 unpreima  [--same--]  moved from JM's mathbox to main set.mm
28-Mar-13 inpreima  [--same--]  moved from JM's mathbox to main set.mm
27-Mar-13 elpri     [--same--]  moved from SF's mathbox to main set.mm
26-Mar-13 indifdi   indifdir    moved from SF's mathbox to main set.mm
25-Mar-13 r19.30    [--same--]  moved from SF's mathbox to main set.mm
24-Mar-13 r19.21    [--same--]  moved from SF's mathbox to main set.mm
23-Mar-13 19.41vvvv [--same--]  moved from FL's mathbox to main set.mm
23-Mar-13 disjr     [--same--]  moved from JM's mathbox to main set.mm
22-Mar-13 smores2   smores3
22-Mar-13 soxp      [--same--]  changed hypotheses to antecedents
22-Mar-13 poxp      [--same--]  changed hypotheses to antecedents
22-Mar-13 frxp      [--same--]  changed hypotheses to antecedents
22-Mar-13 wexp      [--same--]  changed hypotheses to antecedents
22-Mar-13 soxp      [--same--]  moved from SF's mathbox to main set.mm
22-Mar-13 poxp      [--same--]  moved from SF's mathbox to main set.mm
22-Mar-13 frxp      [--same--]  moved from SF's mathbox to main set.mm
22-Mar-13 wexp      [--same--]  moved from SF's mathbox to main set.mm
22-Mar-13 mapdom1   [--same--]  removed redundant hypothesis
22-Mar-13 mapen     [--same--]  removed redundant hypotheses
22-Mar-13 mapsnen   [--same--]  removed redundant hypothesis
22-Mar-13 xpen      [--same--]  removed redundant hypotheses
22-Mar-13 xpeng     [--same--]  removed redundant antecedents
21-Mar-13 3reeanv   [--same--]  moved from JM's mathbox to main set.mm
20-Mar-13 rexrab    [--same--]  moved from JM's mathbox to main set.mm
19-Mar-13 ee01      mpsyl       moved from AS's mathbox to main set.mm
19-Mar-13 morex     [--same--]  moved from JM's mathbox to main set.mm
18-Mar-13 cbviota   [--same--]  moved from ATS's mathbox to main set.mm
18-Mar-13 cbviotaf  [--same--]  moved from ATS's mathbox to main set.mm
17-Mar-13 raleqfn   [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 xporderlem [--same--]  moved from SF's mathbox to main set.mm
16-Mar-13 3an6      [--same--]  moved from SF's mathbox to main set.mm
16-Mar-13 3or6      [--same--]  moved from SF's mathbox to main set.mm
16-Mar-13 elres     [--same--]  moved from SF's mathbox to main set.mm
16-Mar-13 elsnres   [--same--]  moved from SF's mathbox to main set.mm
16-Mar-13 issmo     [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smoeq     [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smodm     [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smores    [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smores3   [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 iordsmo   [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smo0      [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smofvon   [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smoel     [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smoiun    [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smoiso    [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 smoge     [--same--]  moved from ATS's mathbox to main set.mm
16-Mar-13 supeut    [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 fisup2g   [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 fimax2g   [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 wofi      [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 frfi      [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 pofun     [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 frminex   [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 xpeng     [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 fimax     [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 fimaxg    [--same--]  moved from JM's mathbox to main set.mm
16-Mar-13 fisupg    [--same--]  moved from JM's mathbox to main set.mm
15-Mar-13 trint0    [--same--]  moved from ATS's mathbox to main set.mm
15-Mar-13 ordintdif [--same--]  moved from ATS's mathbox to main set.mm
14-Mar-13 ne0f      n0f
 1-Mar-13 eupickbi  [--same--]  moved from ATS's mathbox to main set.mm
 1-Mar-13 dvelimfALT2 [--same--] moved from ATS's mathbox to main set.mm
 1-Mar-13 ax12      a12study2   moved from ATS's mathbox to main set.mm
24-Feb-13 sbceq2dig sbceq2g
24-Feb-13 sbceq1dig sbceq1g
24-Feb-13 sbceqdig  sbceqg
24-Feb-13 sbcbidig  sbcbig
21-Feb-13 ---       ---         See http://us.metamath.org/mpeuni/mmnotes.txt
21-Feb-13 ---       ---         entry of 21-Feb-13 for instructions for
21-Feb-13 ---       ---         the changes below.
21-Feb-13 sylan     [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanb    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanbr   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylan2    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylan2b   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylan2br  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl2an    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl2anb   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl2anbr  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syland    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylan2d   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl2and   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanl1   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanl2   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanr1   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanr2   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylani    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylan2i   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl2ani   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylancl   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylancr   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylanbrc  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylancb   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 sylancbr  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an1   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an2   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an3   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an1b  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an2b  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an3b  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an1br [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an2br [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an3br [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3an    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anb   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anbr  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syld3an3  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syld3an1  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syld3an2  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anl1  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anl2  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anl3  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anl   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anr1  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anr2  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl3anr3  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5com   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5      [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5d     [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5ib    syl5bi      reordered hypotheses for better logical flow
21-Feb-13 syl5ibr   syl5bir     reordered hypotheses for better logical flow
21-Feb-13 syl5bi    syl5ib      reordered hypotheses for better logical flow
21-Feb-13 syl5cbi   syl5ibcom   reordered hypotheses for better logical flow
21-Feb-13 syl5bir   syl5ibr     reordered hypotheses for better logical flow
21-Feb-13 syl5cbir  syl5ibrcom  reordered hypotheses for better logical flow
21-Feb-13 syl5bb    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5rbb   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5bbr   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5rbbr  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eq    [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5req   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eqr   [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5reqr  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eqel  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eqelr [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eleq  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eleqr [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eqner [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5ss    syl5eqss    reordered hypotheses for better logical flow
21-Feb-13 syl5ssr   syl5eqssr   reordered hypotheses for better logical flow
21-Feb-13 syl5eqbr  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5eqbrr [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5breq  [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl5breqr [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl7      [--same--]  reordered hypotheses for better logical flow
21-Feb-13 syl7ib    syl7bi      reordered hypotheses for better logical flow
21-Feb-13 syl6ss    syl6sseq
21-Feb-13 syl6ssr   syl6sseqr
19-Feb-13 fv4       fv4         moved from ATS's mathbox to main set.mm
11-Feb-13 fvopab2b  fvmpt2      moved from FL's mathbox to main set.mm
11-Feb-13 isfinite3 [--same--]  moved from FL's mathbox to main set.mm
 4-Feb-13 remcon    difabs      moved from FL's mathbox to main set.mm
 4-Feb-13 foelrn    [--same--]  moved from JM's mathbox to main set.mm
 4-Feb-13 xpeq2d    [--same--]  moved from JM's mathbox to main set.mm
 4-Feb-13 xpeq1d    [--same--]  moved from JM's mathbox to main set.mm
31-Jan-13 opabex3   [--same--]  moved from JM's mathbox to main set.mm
31-Jan-13 ressn0    ressnop0    moved from SF's mathbox to main set.mm
31-Jan-13 valfunun  fvun        moved from FL's mathbox to main set.mm
20-Jan-13 sucdomi   ---         obsolete; use sucdom instead
20-Jan-13 omsucdom  ---         obsolete; use sucdom instead
20-Jan-13 fisucdom  ---         obsolete; use sucdom instead
20-Jan-13 cardennn  [--same--]  eliminated redundant antecedent
20-Jan-13 oncardon  ---         obsolete; use cardon instead
20-Jan-13 weth      [--same--]  made hypothesis into antecedent
20-Jan-13 tz7.49    [--same--]  changed hypotheses
20-Jan-13 tz7.49c   [--same--]  changed hypotheses
20-Jan-13 r19.23aivr r19.23aivw  moved from FL's mathbox to main set.mm
 4-Jan-13 mul23     mul32
 4-Jan-13 mul23i    mul32i
 4-Jan-13 add23     add32
 4-Jan-13 add23i    add32i
 4-Jan-13 cbvralcsf [--same--]  moved from ATS's mathbox to main set.mm
 4-Jan-13 cbvrexcsf [--same--]  moved from ATS's mathbox to main set.mm
 4-Jan-13 cbvreucsf [--same--]  moved from ATS's mathbox to main set.mm
 4-Jan-13 cbvrabcsf [--same--]  moved from ATS's mathbox to main set.mm
 3-Jan-13 ax0id     addid1
 3-Jan-13 ax1id     mulid1
10-Dec-12 elimant   ---         obsolete (renamed elimantOLD, to be deleted)
 1-Dec-12 fixp      xpfi
 1-Dec-12 xpfi      xpfir
 1-Dec-12 finsucdom fisucdom
 1-Dec-12 setwoe    en1eqsn
 1-Dec-12 sfseqeq   fisseneq
 1-Dec-12 islfin    difinf
 1-Dec-12 unfin     unfir
 1-Dec-12 finfin    diffi
 1-Dec-12 twpar2    uneqdifeq
 1-Dec-12 findcard2 [--same--]  moved from JM's mathbox to main set.mm
27-Nov-12 an1s      an12s
27-Nov-12 an1rs     an32s
27-Nov-12 ancom13s  an13s
27-Nov-12 ancom31s  an31s
19-Nov-12 ee11      ---         obsolete; same as sylc
17-Nov-12 seq11g    [--same--]  moved from JM's mathbox to main set.mm
17-Nov-12 seq1p1g   [--same--]  moved from JM's mathbox to main set.mm
17-Nov-12 seqz1g    [--same--]  moved from JM's mathbox to main set.mm
17-Nov-12 seqzp1g   [--same--]  moved from JM's mathbox to main set.mm
17-Nov-12 seq1seqzg [--same--]  moved from JM's mathbox to main set.mm
16-Nov-12 ordelordaxr ordelordALT
12-Nov-12 funimadisj fnimadisj
 4-Nov-12 ---       ---         math token "0vNEW" changed to "0v"
 4-Nov-12 ---       ---         math token "0v" changed to "0vec"
 4-Nov-12 ---       ---         math token "1rNEW" changed to "1r"
 4-Nov-12 ---       ---         math token "TopSet" changed to "TopOpen"
 4-Nov-12 ---       ---         math token "Toset" changed to "TosetRel"
 4-Nov-12 ---       ---         math token "Dir" changed to "DirRel"
 4-Nov-12 ---       ---         math token "LatNEW" changed to "Lat"
 4-Nov-12 ---       ---         math token "Lat" changed to "LatRel"
 4-Nov-12 ---       ---         math token "PosetNEW" changed to "Poset"
 4-Nov-12 ---       ---         math token "Poset" changed to "PosetRel"
 4-Nov-12 ---       ---         math token "DivRingNEW" changed to "DivRing"
 4-Nov-12 ---       ---         math token "DivRing" changed to "DivRingOps"
 4-Nov-12 ---       ---         math token "RingNEW" changed to "Ring"
 4-Nov-12 ---       ---         math token "Ring" changed to "RingOps"
 4-Nov-12 ---       ---         math token "SubGrp" changed to "SubGrpOp"
 4-Nov-12 ---       ---         math token "AbelNEW" changed to "Abel"
 4-Nov-12 ---       ---         math token "Abel" changed to "AbelOp"
 4-Nov-12 ---       ---         math token "GrpNEW" changed to "Grp"
 4-Nov-12 ---       ---         math token "Grp" changed to "GrpOp"
 4-Nov-12 ---       ---         math token "Open" changed to "MetOpen"
 4-Nov-12 grpNEW2grp grp2grpo
 4-Nov-12 grpNEWstr grpstr
 4-Nov-12 grpNEWprop grpprop
 4-Nov-12 grp2grpNEW grp2grp
 4-Nov-12 postrNEW  postr
 4-Nov-12 isdivrngNEW isdivrng
 4-Nov-12 df-drngNEW df-drng
 4-Nov-12 cdivringNEW cdivring
 4-Nov-12 ringrzNEW ringrz
 4-Nov-12 ringlzNEW ringlz
 4-Nov-12 ringridmNEW ringridm
 4-Nov-12 ringlidmNEW ringlidm
 4-Nov-12 ringidmlemNEW ringidmlem
 4-Nov-12 ringgrpNEW ringgrp
 4-Nov-12 ringablNEW ringabl
 4-Nov-12 ringdirNEW ringdir
 4-Nov-12 ringdiNEW ringdi
 4-Nov-12 ringideuNEW ringideu
 4-Nov-12 ringassNEW ringass
 4-Nov-12 ringclNEW ringcl
 4-Nov-12 ringiNEW  ringi
 4-Nov-12 isringNEW isring
 4-Nov-12 cnaddablNEW cnaddabl
 4-Nov-12 ablcomNEW ablcom
 4-Nov-12 ablgrpNEW ablgrp
 4-Nov-12 isabliNEW isabli
 4-Nov-12 isablNEW  isabl
 4-Nov-12 grplcanNEW grplcan
 4-Nov-12 grpinvidNEW grpinvid
 4-Nov-12 grpinvid2NEW grpinvid2
 4-Nov-12 grpinvid1NEW grpinvid1
 4-Nov-12 grprinvNEW grprinv
 4-Nov-12 grplinvNEW grplinv
 4-Nov-12 grpinvNEW grpinv
 4-Nov-12 grpinvclNEW grpinvcl
 4-Nov-12 grpinvvalNEW grpinvval
 4-Nov-12 grpinvfvalNEW grpinvfval
 4-Nov-12 grpidNEW  grpid
 4-Nov-12 grpinveuNEW grpinveu
 4-Nov-12 grprcanNEW grprcan
 4-Nov-12 grpridNEW grprid
 4-Nov-12 grplidNEW grplid
 4-Nov-12 grpidinv2NEW grpidinv2
 4-Nov-12 grpidclNEW grpidcl
 4-Nov-12 grpidvalNEW grpidval
 4-Nov-12 isgrpiNEW isgrpi
 4-Nov-12 grpn0NEW  grpn0
 4-Nov-12 grpideuNEW grpideu
 4-Nov-12 grpidinvNEW grpidinv
 4-Nov-12 grpidinvlem4NEW grpidinvlem4
 4-Nov-12 grpidinvlem3NEW grpidinvlem3
 4-Nov-12 grpidinvlem2NEW grpidinvlem2
 4-Nov-12 grpidinvlem1NEW grpidinvlem1
 4-Nov-12 grplidinvNEW grplidinv
 4-Nov-12 grpassNEW grpass
 4-Nov-12 grpclNEW  grpcl
 4-Nov-12 elgrpNEW  elgrp
 4-Nov-12 isgrp2NEW isgrp2
 4-Nov-12 isgrpNEW  isgrp
 4-Nov-12 df-ringNEW df-ring
 4-Nov-12 df-ablNEW df-abl
 4-Nov-12 df-grpNEW df-grp
 4-Nov-12 crgNEW    crg
 4-Nov-12 cabelNEW  cabel
 4-Nov-12 cgrpNEW   cgrp
 4-Nov-12 postr     posreltr
 4-Nov-12 isdivrng  isdivrngo
 4-Nov-12 df-drng   df-drngo
 4-Nov-12 ringrz    ringorz
 4-Nov-12 ringlz    ringolz
 4-Nov-12 ringridm  ringoridm
 4-Nov-12 ringlidm  ringolidm
 4-Nov-12 ringidmlem ringoidmlem
 4-Nov-12 ringgrp   ringogrpo
 4-Nov-12 ringabl   ringoablo
 4-Nov-12 ringdir   ringodir
 4-Nov-12 ringdi    ringodi
 4-Nov-12 ringideu  ringoideu
 4-Nov-12 ringass   ringoass
 4-Nov-12 ringcl    ringocl
 4-Nov-12 ringi     ringoi
 4-Nov-12 isring    isringo
 4-Nov-12 cnaddabl  cnaddablo
 4-Nov-12 ablcom    ablocom
 4-Nov-12 ablgrp    ablogrpo
 4-Nov-12 isabli    isabloi
 4-Nov-12 isabl     isablo
 4-Nov-12 grplcan   grpolcan
 4-Nov-12 grpinvid  grpoinvid
 4-Nov-12 grpinvid2 grpoinvid2
 4-Nov-12 grpinvid1 grpoinvid1
 4-Nov-12 grprinv   grporinv
 4-Nov-12 grplinv   grpolinv
 4-Nov-12 grpinv    grpoinv
 4-Nov-12 grpinvcl  grpoinvcl
 4-Nov-12 grpinvval grpoinvval
 4-Nov-12 grpinvfval grpoinvfval
 4-Nov-12 grpid     grpoid
 4-Nov-12 grpinveu  grpoinveu
 4-Nov-12 grprcan   grporcan
 4-Nov-12 grprid    grporid
 4-Nov-12 grplid    grpolid
 4-Nov-12 grpidinv2 grpoidinv2
 4-Nov-12 grpidcl   grpoidcl
 4-Nov-12 grpidval  grpoidval
 4-Nov-12 isgrpi    isgrpoi
 4-Nov-12 grpn0     grpon0
 4-Nov-12 grpideu   grpoideu
 4-Nov-12 grpidinv  grpoidinv
 4-Nov-12 grpidinvlem4 grpoidinvlem4
 4-Nov-12 grpidinvlem3 grpoidinvlem3
 4-Nov-12 grpidinvlem2 grpoidinvlem2
 4-Nov-12 grpidinvlem1 grpoidinvlem1
 4-Nov-12 grplidinv grpolidinv
 4-Nov-12 grpass    grpoass
 4-Nov-12 grpcl     grpocl
 4-Nov-12 isgrp2    isgrpo2
 4-Nov-12 isgrp     isgrpo
 4-Nov-12 df-ring   df-ringo
 4-Nov-12 df-abl    df-ablo
 4-Nov-12 df-grp    df-grpo
 4-Nov-12 1r        1sr
29-Oct-12 ralimdvaa ralimdva
28-Oct-12 mptfn     mptfng
26-Oct-12 raleqi    [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 fneq12d   [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 feq23i    [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 reseq2i   [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 reseq2d   [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 ifbieq2d  [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 supeq1d   [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 supeq1i   [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 emfin     0fin        moved from PC's mathbox to main set.mm
26-Oct-12 fz1n      [--same--]  moved from PC's mathbox to main set.mm
26-Oct-12 nn0lt10b  [--same--]  moved from PC's mathbox to main set.mm
25-Oct-12 fnoprab2ga [--same--]  moved from FL's mathbox to main set.mm
25-Oct-12 fnoprab2a [--same--]  moved from FL's mathbox to main set.mm
25-Oct-12 dmoprab2a [--same--]  moved from FL's mathbox to main set.mm
25-Oct-12 foprab2a  [--same--]  moved from FL's mathbox to main set.mm
25-Oct-12 oprabval2ga [--same--]  moved from FL's mathbox to main set.mm
25-Oct-12 oprabex2ga [--same--]  moved from FL's mathbox to main set.mm
22-Oct-12 ---       ---         math token "Bases" was changed to "TopBases"
21-Oct-12 stoi      [--same--]  converted to new structure scheme
21-Oct-12 topgele   [--same--]  converted to new structure scheme
21-Oct-12 subtopsin2 [--same--] converted to new structure scheme
21-Oct-12 topindis  [--same--]  converted to new structure scheme
21-Oct-12 subsptop    [--same--]  converted to new structure scheme
21-Oct-12 subspuni    [--same--]  converted to new structure scheme
21-Oct-12 stoig     [--same--]  converted to new structure scheme
21-Oct-12 stoiglem  [--same--]  converted to new structure scheme
20-Oct-12 retps     [--same--]  converted to new structure scheme
20-Oct-12 distps    [--same--]  converted to new structure scheme
20-Oct-12 indistps  [--same--]  converted to new structure scheme
20-Oct-12 istps5    [--same--]  converted to new structure scheme
20-Oct-12 istps4    [--same--]  converted to new structure scheme
20-Oct-12 istps3    [--same--]  converted to new structure scheme
20-Oct-12 istps2    [--same--]  converted to new structure scheme
20-Oct-12 istps     [--same--]  converted to new structure scheme
20-Oct-12 tpsex     ---         obsolete
20-Oct-12 istps     [--same--]  converted to new structure scheme
20-Oct-12 df-topsp  [--same--]  converted to new structure scheme
20-Oct-12 subsp2    subsp       moved from FL's mathbox to main set.mm
20-Oct-12 subsp     subspi
19-Oct-12 mpteqi    [--same--]  moved from SF's mathbox to main set.mm
19-Oct-12 mpteq2dva  [--same--]  moved from FL's mathbox to main set.mm
19-Oct-12 empntop   0ntop       moved from FL's mathbox to main set.mm
19-Oct-12 mp4an     [--same--]  moved from JM's mathbox to main set.mm
18-Oct-12 df-struct ---         obsolete; affected theorems reproved
18-Oct-12 df-strbldr ---        obsolete; affected theorems reproved
15-Oct-12 cbviin    [--same--]  moved from JGH's mathbox to main set.mm
15-Oct-12 cbviinv   [--same--]  moved from JGH's mathbox to main set.mm
15-Oct-12 txtopi    [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 txunii    [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 euuni2    [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 difxp     [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 unopn     [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 incld     [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 txopn     [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 txcld     [--same--]  moved from JM's mathbox to main set.mm
15-Oct-12 opnnei    [--same--]  moved from JGH's mathbox to main set.mm
 7-Oct-12 3ioran    [--same--]  moved from SF's mathbox to main set.mm
27-Aug-12 in23      in32
21-Jul-12 simplim   [--same--]  unnecessary negation removed
20-Jul-12 ---       ---         math token "base" was changed to "Base"
25-Jun-12 nelne     nelne1
24-Jun-12 an23      an32
22-Mar-12 simplld   simpld
21-May-12 fiss      [--same--]  moved from JGH's mathbox to main set.mm
21-May-12 inficlALT [--same--]  moved from JGH's mathbox to main set.mm
21-May-12 fitop     [--same--]  moved from JGH's mathbox to main set.mm
21-May-12 abrexex2g [--same--]  moved from JM's mathbox to main set.mm
16-Apr-12 rexcom4a  [--same--]  moved from JM's mathbox to main set.mm
16-Apr-12 rexcom4b  [--same--]  moved from JM's mathbox to main set.mm
16-Apr-12 eqfnfv3   [--same--]  moved from JM's mathbox to main set.mm
16-Apr-12 fibas     [--same--]  moved from JGH's mathbox to main set.mm
16-Apr-12 indexfi   [--same--]  moved from JM's mathbox to main set.mm
16-Apr-12 fipreima  [--same--]  moved from JM's mathbox to main set.mm
14-Apr-12 int2rel   brin
12-Apr-12 dif2rel   brdif       moved from SF's mathbox to main set.mm
25-Mar-12 syl3an2c  syl13anc    old hypothesis 1 is now hypothesis 5
25-Mar-12 syl3anc   syl111anc   old hypothesis 1 is now hypothesis 4
22-Mar-12 sylc      [--same--]  old hypothesis 1 is now hypothesis 4
22-Mar-12 sylanc    syl11anc    old hypothesis 1 is now hypothesis 4
22-Mar-12 syl2anr   syl22anc    old hypothesis 1 is now hypothesis 5
22-Mar-12 sylan31c  syl21anc    order of variables is different
22-Mar-12 sylan32c  syl12anc    order of variables is different
22-Mar-12 pm3.26im  simplim
22-Mar-12 pm3.27im  simprim
22-Mar-12 pm3.26    simpl
22-Mar-12 pm3.26i   simpli
22-Mar-12 pm3.26d   simpld
22-Mar-12 pm3.26bi  simplbi
22-Mar-12 pm3.27    simpr
22-Mar-12 pm3.27i   simpri
22-Mar-12 pm3.27d   simprd
22-Mar-12 pm3.27bi  simprbi
22-Mar-12 pm3.26bda simprbda
22-Mar-12 pm3.27bda simplbda
22-Mar-12 pm3.26bi2 simplbi2
22-Mar-12 pm3.26bi2VD simplbi2VD
22-Mar-12 3simp1    simp1
22-Mar-12 3simp2    simp2
22-Mar-12 3simp3    simp3
22-Mar-12 3simpl1   simpl1
22-Mar-12 3simpl2   simpl2
22-Mar-12 3simpl3   simpl3
22-Mar-12 3simpr1   simpr1
22-Mar-12 3simpr2   simpr2
22-Mar-12 3simpr3   simpr3
22-Mar-12 3simp1i   simp1i
22-Mar-12 3simp2i   simp2i
22-Mar-12 3simp3i   simp3i
22-Mar-12 3simp1d   simp1d
22-Mar-12 3simp2d   simp2d
22-Mar-12 3simp3d   simp3d
22-Mar-12 3simp1bi  simp1bi
22-Mar-12 3simp2bi  simp2bi
22-Mar-12 3simp3bi  simp3bi
22-Mar-12 3simp1l   simp1l
22-Mar-12 3simp1r   simp1r
22-Mar-12 3simp2l   simp2l
22-Mar-12 3simp2r   simp2r
22-Mar-12 3simp3l   simp3l
22-Mar-12 3simp3r   simp3r
22-Mar-12 3simp11   simp11
22-Mar-12 3simp12   simp12
22-Mar-12 3simp13   simp13
22-Mar-12 3simp21   simp21
22-Mar-12 3simp22   simp22
22-Mar-12 3simp23   simp23
22-Mar-12 3simp31   simp31
22-Mar-12 3simp32   simp32
22-Mar-12 3simp33   simp33
20-Mar-12 truni     [--same--]  moved from SF's mathbox to main set.mm
20-Mar-12 trsuc2    [--same--]  moved from SF's mathbox to main set.mm
20-Mar-12 trint     [--same--]  moved from SF's mathbox to main set.mm
20-Mar-12 trintss   [--same--]  moved from SF's mathbox to main set.mm
 4-Mar-12 ralunb    [--same--]  moved from SF's mathbox to main set.mm
20-Feb-12 3orcomb   [--same--]  moved from SF's mathbox to main set.mm
29-Jan-12 sbmo      [--same--]  moved from JM's mathbox to main set.mm
29-Jan-12 2ralor    [--same--]  moved from JM's mathbox to main set.mm
29-Jan-12 rexun     [--same--]  moved from JM's mathbox to main set.mm
29-Jan-12 ralun     [--same--]  moved from JM's mathbox to main set.mm
29-Jan-12 rexsn     [--same--]  moved from JM's mathbox to main set.mm
16-Jan-12 reuuninegi reuunineg
16-Jan-12 riotaund  riotaundb
 3-Jan-12 ee111     syl3c       moved from AS's mathbox to main set.mm
 3-Jan-12 ee12      sylsyld     moved from AS's mathbox to main set.mm
 3-Jan-12 ee20      syl6mpi     moved from AS's mathbox to main set.mm
22-Nov-11 eqfnfv3   [--same--]  moved from JM's mathbox to main set.mm
 6-Nov-11 cm        cmap
 4-Nov-11 hashgf1o  [--same--]  moved from PC's mathbox to main set.mm
 4-Nov-11 hashgval  [--same--]  moved from PC's mathbox to main set.mm
 4-Nov-11 hashginv  [--same--]  moved from PC's mathbox to main set.mm
 4-Nov-11 hashfz1   [--same--]  moved from PC's mathbox to main set.mm
 4-Nov-11 hashen    [--same--]  moved from PC's mathbox to main set.mm
 4-Nov-11 fz1fi     [--same--]  moved from PC's mathbox to main set.mm
20-Oct-11 ralab     [--same--]  moved from JM's mathbox to main set.mm
20-Oct-11 ralrab    [--same--]  moved from JM's mathbox to main set.mm
20-Sep-11 ifbieq2i  [--same--]  moved from PC's mathbox to main set.mm
20-Sep-11 dfiin2g   [--same--]  moved from JGH's mathbox to main set.mm
20-Sep-11 oprvex    ab2rexex    generalized oper. value to be arbitrary class
16-Sep-11 riotass2  reiotass2
16-Sep-11 riota2    reiota2
16-Sep-11 riota2f   reiota2f
16-Sep-11 riota1    reiota1
16-Sep-11 riotasbc    reiotasbc
16-Sep-11 riotacl   reiotacl
16-Sep-11 riotacl2  reiotacl2
15-Sep-11 19.22-2   2exim
15-Sep-11 19.20-2   2alim
15-Sep-11 19.20ii2  2al2imi
15-Sep-11 19.20ian2 2alanimi
15-Sep-11 sbc19.20dv sbcimdv
15-Sep-11 r19.22dva reximdva
15-Sep-11 r19.22sdv reximdv
15-Sep-11 r19.22dv  reximdvai
15-Sep-11 r19.22dv2 reximdv2
15-Sep-11 r19.22d   reximdai
15-Sep-11 r19.22si  reximi
15-Sep-11 r19.22i2  reximi2
15-Sep-11 r19.22i   reximia
15-Sep-11 r19.22OLD reximOLD
15-Sep-11 r19.22    rexim
15-Sep-11 r19.20dv2 ralimdv2
15-Sep-11 r19.20sdv ralimdv
15-Sep-11 r19.20dva ralimdva
15-Sep-11 r19.20da  ralimdaa
15-Sep-11 r19.20sii ral2imi
15-Sep-11 r19.20si  ralimi
15-Sep-11 r19.20ia  ralimiaa
15-Sep-11 r19.20i   ralimia
15-Sep-11 r19.20i2  ralimi2
15-Sep-11 r19.20    ralim
15-Sep-11 19.22dvv  2eximdv
15-Sep-11 19.20dvv  2alimdv
15-Sep-11 19.22dv   eximdv
15-Sep-11 19.20dv   alimdv
15-Sep-11 19.22d    eximd
15-Sep-11 19.22i2   2eximi
15-Sep-11 19.22i    eximi
15-Sep-11 19.22     exim
15-Sep-11 19.20d    alimd
15-Sep-11 19.20ian  alanimi
15-Sep-11 19.20ii   al2imi
15-Sep-11 19.20     alim
15-Sep-11 19.20i2   2alimi
15-Sep-11 19.20i    alimi
15-Sep-11 rexeqd    rexeqbi1dv
15-Sep-11 rexeq1d   rexeqdv
15-Sep-11 rexeq1    rexeq
15-Sep-11 rexeq1f   rexeqf
15-Sep-11 raleq1i   raleqi
15-Sep-11 raleqd    raleqbi1dv
15-Sep-11 raleq1d   raleqdv
15-Sep-11 raleq1    raleq
15-Sep-11 raleq1f   raleqf
15-Sep-11 rabeq12d  rabeqbidv   moved from JM's mathbox to main set.mm
15-Sep-11 19.18-2   2exbi
15-Sep-11 19.15-2   2albi
15-Sep-11 r19.15    ralbi
15-Sep-11 19.18     exbi
15-Sep-11 19.15     albi
15-Sep-11 2albi     2albiim
15-Sep-11 albi      albiim
14-Sep-11 ciota     cio
14-Sep-11 rabbii    rabbiia
14-Sep-11 rabbisdv  rabbidv
14-Sep-11 rabbidv   rabbidva
14-Sep-11 tpi3      tpid3
14-Sep-11 tpi2      tpid2
14-Sep-11 tpi1      tpid1
13-Sep-11 dmfnwdm2  fnprg       moved from FL's mathbox to main set.mm
13-Sep-11 s2pf      funprg      moved from FL's mathbox to main set.mm
12-Sep-11 mptexg    [--same--]  swapped variables "B" and "C"
 9-Sep-11 hbcmpt    hbmpt1      moved from FL's mathbox to main set.mm
 9-Sep-11 bnj1344   simp3bi     moved from JB's mathbox to main set.mm
 9-Sep-11 bnj1301   simp2bi     moved from JB's mathbox to main set.mm
 9-Sep-11 bnj1206   simp1bi     moved from JB's mathbox to main set.mm
 8-Sep-11 syl3an2c  [--same--]  moved from JM's mathbox to main set.mm
 8-Sep-11 eqfnfvALT eqfnfv2
 8-Sep-11 uridm2    ringoridm
 8-Sep-11 uridm1    ringolidm
 8-Sep-11 uridm     ringoidmlem
 8-Sep-11 zerab2    ringorz
 8-Sep-11 zerab     ringolz
 7-Sep-11 euunian   iota4an     moved from ATS's mathbox to main set.mm
 7-Sep-11 iota3     iota4       (because it's analogous to reuunisbc / riota4)
 6-Sep-11 pm13.181  [--same--]  moved from ATS's mathbox to main set.mm
 6-Sep-11 pm13.18   [--same--]  moved from ATS's mathbox to main set.mm
 6-Sep-11 trutru    tru         moved from AH's mathbox to main set.mm
 6-Sep-11 nofaltru  notfal      moved from AH's mathbox to main set.mm
 4-Sep-11 feq1i     [--same--]  moved from PC's mathbox to main set.mm
 4-Sep-11 fneq1i    [--same--]  moved from PC's mathbox to main set.mm
 4-Sep-11 fneq2d    [--same--]  moved from PC's mathbox to main set.mm
 4-Sep-11 fneq1d    [--same--]  moved from PC's mathbox to main set.mm
 3-Sep-11 prf       fpr         moved from JM's mathbox to main set.mm
 3-Sep-11 prfv2     fvpr2       moved from JM's mathbox to main set.mm
 3-Sep-11 prfv1     fvpr1       moved from JM's mathbox to main set.mm
 3-Sep-11 prfun     funpr       moved from JM's mathbox to main set.mm
30-Aug-11 eqfnfvf2  eqfnfv2f
30-Aug-11 xp11a     xpcan2      xp11a (obsolete) was a special case of xpcan2
30-Aug-11 xp11b     xpcan       xp11b (obsolete) was a special case of xpcan
26-Aug-11 dmsdtriord domtriord  moved from JGH's mathbox to main set.mm
26-Aug-11 impbid3   impcon4bid  moved from JGH's mathbox to main set.mm
26-Aug-11 cbvcsb    [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 cbvcsb    [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 ordiso    [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem1 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem2 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem3 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem4 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem5 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem6 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtypelem7 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 ordtype   [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 hartoglem [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 hartog    [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 onsdom    [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubsuc  [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubsuc2 [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubsdomlem1 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 omsubsdomlem2 [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 omsubsdom [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubdom  [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubel   [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubss   [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 elomsubsd [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubdmss [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsublim  [--same--]  moved from JGH's mathbox to main set.mm
26-Aug-11 omsubindss [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 infenomsub [--same--] moved from JGH's mathbox to main set.mm
26-Aug-11 omsubinit [--same--]  moved from JGH's mathbox to main set.mm
20-Aug-11 iotaval   [--same--]  swapped order of equality in consequent
20-Aug-11 iotaequ   [--same--]  swapped order of equality in consequent
20-Aug-11 iotanul   [--same--]  swapped order of equality
18-Aug-11 mpset     mptexg      moved from FL's mathbox to main set.mm
18-Aug-11 hbiota    hbiota1     moved from ATS's mathbox to main set.mm
18-Aug-11 iotacl    [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 iota3     [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 iotaex    [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 iotanul   [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 iotaequ   [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 iotaval   [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 sbeqalb   [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 sbceqal   [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 eqsbc3    [--same--]  moved from ATS's mathbox to main set.mm
18-Aug-11 19.20ian  [--same--]  moved from ATS's mathbox to main set.mm
17-Aug-11 mpt2g     ovmpt2g
17-Aug-11 mptg      fvmptg
17-Aug-11 bnj1226   imorri      moved from JB's mathbox to main set.mm
17-Aug-11 jad       [--same--]  moved from SF's mathbox to main set.mm
13-Aug-11 ceqsex3v  ---         (RM's mathbox) - obsolete; use ceqsexgv
13-Aug-11 ceqsex3   ---         (RM's mathbox) - obsolete; use ceqsexg
13-Aug-11 ceqsex2v  [--same--]  reformatted to use triple conjunction
13-Aug-11 ceqsex2   [--same--]  reformatted to use triple conjunction
 9-Aug-11 feq2d     [--same--]  moved from PC's mathbox to main set.mm
 9-Aug-11 bnj1456   snssd       moved from JB's mathbox to main set.mm
 9-Aug-11 snssd     [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 fbaslim   [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 fbfgss    [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 fgid      [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 cnpnei    [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 limfilss  [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 fbfgfmeq  [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 fgss      [--same--]  moved from JGH's mathbox to main set.mm
 9-Aug-11 filmapss  [--same--]  moved from JGH's mathbox to main set.mm
18-Jul-11 ompfl3    3anibar
18-Jul-11 rexeq12d  rexeqbidv
18-Jul-11 raleq12d  raleqbidv
18-Jul-11 ralbieq1dv ---        obsolete; use raleqbidv
18-Jul-11 exan2     exsimpl
 8-Jul-11 brab1     [--same--]  changed set var "y" to class var "A"
29-Jun-11 exan2     [--same--]  moved from RM's mathbox to main set.mm
29-Jun-11 wfal      [--same--]  moved from AH's mathbox to main set.mm
29-Jun-11 df-fal    [--same--]  moved from AH's mathbox to main set.mm
29-Jun-11 wtru      [--same--]  moved from AH's mathbox to main set.mm
29-Jun-11 df-tru    [--same--]  moved from AH's mathbox to main set.mm
29-Jun-11 mptfn     [--same--]  moved from SF's mathbox to main set.mm
29-Jun-11 rnmpt     [--same--]  moved from SF's mathbox to main set.mm
29-Jun-11 dford2    [--same--]  moved from SF's mathbox to main set.mm
29-Jun-11 funsngxx  funsng      changed "e. _V" to "e. C", "e. D" in antec.
29-Jun-11 bnj94     funsngxx    moved from JB's mathbox to main set.mm
29-Jun-11 bnj928    fnsn        moved from JB's mathbox to main set.mm
29-Jun-11 bnj1257   eleq2s      moved from JB's mathbox to main set.mm
29-Jun-11 bnj1495   funeqi      moved from JB's mathbox to main set.mm
29-Jun-11 erdisj2   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 cass      [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-ass    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 isass     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 isexid    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 ismgm     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 opidon    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 rngopid   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 opidon2   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 isexid2   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 exidu1    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 idrval    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 iorlid    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 cmpidelt  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 csem      [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-sgr    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 smgrpismgm [--same--] moved from FL's mathbox to main set.mm
29-Jun-11 issmgrp   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 smgrpmgm  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 smgrpass  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 cmnd      [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-mnd    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 mndissmgrp [--same--] moved from FL's mathbox to main set.mm
29-Jun-11 mndisexid [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 mndismgm  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 mndmgmid  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 ismnd     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 ismnd1    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 relrng    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 rngn0     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 rngmgmbs4 [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 rnplrnml0 [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 rnplrnml2 [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 rnplrnml  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 unmnd     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 fora1     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 fora2     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 fora      [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 uridm     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 uridm1    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 zerab     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 zerab2    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 on1el3    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 on1el4    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 on1el6    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 ring1cl   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 uznzr     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 isdivrngo  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 zrdivrng  [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 dvrunz    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 clmgm     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 uridm2    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 grpmnd    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 iscom2    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 ismnd2    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 difeq12   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 setwoe    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 sfseqeq   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 opreq123d [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 oprabvaligg [--same--] moved from FL's mathbox to main set.mm
29-Jun-11 cexid     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-exid   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 cmagm     [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-mgm    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 ccm2      [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-com2   [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 cfld      [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 df-fld    [--same--]  moved from FL's mathbox to main set.mm
29-Jun-11 imp5a     [--same--]  moved from JGH's mathbox to main set.mm
29-Jun-11 iccleub   [--same--]  moved from JGH's mathbox to main set.mm
29-Jun-11 expl      [--same--]  moved from JGH's mathbox to main set.mm
29-Jun-11 ghomid    [--same--]  moved from PC's mathbox to main set.mm
29-Jun-11 ghomlin   [--same--]  moved from PC's mathbox to main set.mm
28-Jun-11 infmssuzle [--same--] removed redundant antecedent S =/= (/)
22-Jun-11 xpeq12    [--same--]  moved from FL's mathbox to main set.mm
22-Jun-11 xpeq12i   [--same--]  moved from FL's mathbox to main set.mm
21-Jun-11 axnul2    axnulALT
25-Mar-11 ntunte    inuni
 8-Mar-11 ssxp      xpss12
 8-Mar-11 bepart    elelpwi
 8-Mar-11 intprd    intprg      changed "e. _V" to "e. C", "e. D" in antec.
 2-Mar-11 equnamo   n0moeu
21-Feb-11 muln0b    mulne0b
21-Feb-11 muln0i    mulne0i
16-Jan-11 grothinf  grothomex
13-Jan-11 hbequid   hbequid2
10-Dec-10 nexnoti   nexr
31-Oct-10 reu3xxx   reu6
31-Oct-10 reu6      reu3
31-Oct-10 reu3      reu3xxx
30-Oct-10 eusn      euabsn
26-Oct-10 raaan     raaanv
18-Oct-10 ---       ---         changed math symbol from "C=" to "C_"
 3-Oct-10 ---       ---         added variables E, e, I, i, V
 3-Oct-10 ---       ---         changed math symbol from "P~" to "~P"
 3-Oct-10 ---       ---         changed math symbol from "H~" to "~H"
 3-Oct-10 ---       ---         changed math symbol from "(_" to "C="
 3-Oct-10 ---       ---         changed math symbol from "(." to "C."
 3-Oct-10 ---       ---         changed math symbol from "C." to "_C"
 3-Oct-10 ---       ---         changed math symbol from "E" to "_E"
 3-Oct-10 ---       ---         changed math symbol from "e" to "_e"
 3-Oct-10 ---       ---         changed math symbol from "I" to "_I"
 3-Oct-10 ---       ---         changed math symbol from "i" to "_i"
 3-Oct-10 ---       ---         changed math symbol from "V" to "_V"
24-Jul-09 sandbox   mathbox
12-Jun-09 mulge0    [--same--]  rearranged antecedent
12-Jun-09 mulgt0    [--same--]  rearranged antecedent
12-May-09 ---       ---         changed math symbol from "ZZ_>" to "ZZ>="
 2-May-09 snsspr    snsspr1
 2-May-09 axpow     zfpow
 2-May-09 axac      zfac
 2-May-09 axun      zfun
27-Apr-09 pm4.22    bitr
24-Apr-09 axinf     zfinf
24-Apr-09 zfinf     zfinf2
 2-Apr-09 infmssuzle [--same--] changed -. S = (/) to S =/= (/)
23-Mar-09 eqfnfvf   ---         obsolete; use eqfnfvf2 instead
23-Mar-09 ffnoprval ffnoprv
23-Mar-09 eqfnoprval eqfnoprv
23-Mar-09 fnoprval  fnoprv
23-Mar-09 foprval   foprv
23-Mar-09 oprvalres oprvres
23-Mar-09 oprssoprval oprssoprv
23-Mar-09 fnrnoprval fnrnoprv
23-Mar-09 fooprval  fooprv
23-Mar-09 fnoprvalrn fnoprvrn
23-Mar-09 oprvalelrn oprvelrn
23-Mar-09 oprvalconst2 oprvconst2
23-Mar-09 oprvalex  oprvex
23-Mar-09 symgoprval symgoprv
23-Mar-09 fnoprvalrn2 fnoprvrn2
22-Mar-09 icoshf    icoshft
 8-Mar-09 nnont     nnon
 7-Mar-09 eluzsubii eluzsubi
 7-Mar-09 eluzaddii eluzaddi
 7-Mar-09 divexp    expdiv
 7-Mar-09 recexp    exprec
 7-Mar-09 ---       ---         changed math symbol from "ZZ>" to "ZZ_>"
27-Feb-09 lediv23   [--same--]  rearranged antecedent
27-Feb-09 ltdiv23   [--same--]  rearranged antecedent
 3-Jan-09 muln0     mulne0
 3-Jan-09 vne0      vn0
 3-Jan-09 n0        neq0
 3-Jan-09 ne0       n0
 3-Jan-09 ssne0     ssn0
 3-Jan-09 onne0     onn0
 3-Jan-09 dmsnne0   dmsnn0
 3-Jan-09 rnsnne0   rnsnn0
 3-Jan-09 1ne0      1n0
 3-Jan-09 metne0    metn0
 3-Jan-09 blne0     bln0
 2-Jan-08 flrecl    reflcl
30-Dec-08 letrdi    letrd
30-Dec-08 lelttrdi  lelttrd
30-Dec-08 ltletrdi  ltletrd
30-Dec-08 lttrdi    lttrd
29-Dec-08 hbnegi    hbneg
29-Dec-08 hbnegdi   hbnegd
29-Dec-08 hbsumi    hbsum
29-Dec-08 hbsum1i   hbsum1
28-Dec-08 negnei    negne0i
28-Dec-08 negne0i   negne0bi
28-Dec-08 lemul2    [--same--]  rearranged antecedent
28-Dec-08 lemul1    [--same--]  rearranged antecedent
28-Dec-08 ltmul2    [--same--]  rearranged antecedent
28-Dec-08 ltmul1    [--same--]  rearranged antecedent
28-Dec-08 ecdmn0    [--same--]  changed -. ... = to =/=
27-Dec-08 divdiv24  [--same--]  rearranged antecedent
27-Dec-08 divdiv13  [--same--]  rearranged antecedent
27-Dec-08 divadddiv [--same--]  rearranged antecedent
27-Dec-08 divdivdiv [--same--]  rearranged antecedent
27-Dec-08 recndi    recnd
27-Dec-08 divdivmul divdiv1
27-Dec-08 divdiv23  [--same--]  rearranged antecedent
27-Dec-08 dmsnsn0   ---         obsolete; use the more general dmsn0el
25-Dec-08 div12     [--same--]  rearranged antecedent
25-Dec-08 div13     [--same--]  rearranged antecedent
25-Dec-08 div23     [--same--]  rearranged antecedent
25-Dec-08 expm1     expm1t
25-Dec-08 divmuldiv [--same--]  rearranged antecedent
25-Dec-08 recexp    [--same--]  rearranged antecedent
25-Dec-08 expne0i   [--same--]  rearranged antecedent
25-Dec-08 expsub    [--same--]  rearranged antecedent
25-Dec-08 divexp    [--same--]  rearranged antecedent
21-Dec-08 imaun2    imaundir
21-Dec-08 imaun     imaundi
19-Dec-08 sbhyp     ---         obsolete; use sbhypf
19-Dec-08 opelcog   opelco2g
18-Dec-08 fsumspl   fsumsplit
18-Dec-08 fsum0spl  fsum0split
18-Dec-08 fsumshf   fsumshft
18-Dec-08 fsumcons  fsumconst
18-Dec-08 dmco2     dmco
17-Dec-08 ---       ---         the math token "Base" was changed to "BaseSet"
17-Dec-08 ssxpr     ---         obsolete; use ssxpb
17-Dec-08 nicodraw  ---         obsolete; use nic-ax
17-Dec-08 nicodmpraw ---        obsolete; use nic-mp
17-Dec-08 3exbi     3exbii
17-Dec-08 relssdr   relssdmrn
16-Dec-08 dfoprab4  dfoprab5s
16-Dec-08 dfoprab5  dfoprab4s
16-Dec-08 dffxxx    dff2
16-Dec-08 dff4      dff3
16-Dec-08 dff3      dff4
16-Dec-08 dff4      dffxxx
16-Dec-08 dffunmo   dffun6
16-Dec-08 dffun6    dffun7
16-Dec-08 dffun7    dffun8
16-Dec-08 dffun8    dffun9
16-Dec-08 dffunmof  dffun6f
16-Dec-08 fnopabfv  dffn5
16-Dec-08 fnforn    dffn4
16-Dec-08 fnfrn     dffn3
16-Dec-08 fnf       dffn2
16-Dec-08 f1fvf     dff13f
16-Dec-08 f1fv      dff13
16-Dec-08 f11       dff12
16-Dec-08 f1ofv     dff1o6
16-Dec-08 f1o5      dff1o5
16-Dec-08 f1o4      dff1o4
16-Dec-08 f1o3      dff1o3
16-Dec-08 f1o2      dff1o2
15-Dec-08 pm4.2d    biidd
15-Dec-08 pm4.2     biid
15-Dec-08 pm4.1     con34b
15-Dec-08 bi2.15    con1b
15-Dec-08 bi2.03    con2b
15-Dec-08 a3d       con4d
15-Dec-08 a3i       con4i
13-Dec-08 2climnni  2climnn
13-Dec-08 2climnn0i 2climnn0
12-Dec-08 reeftlclti reeftlcl
12-Dec-08 eftlclti  eftlcl
12-Dec-08 eftlexti  eftlex
12-Dec-08 fnsmnti   arisumi
12-Dec-08 nn0le2msqti nn0le2msqi
12-Dec-08 reccnvi   reccnv
12-Dec-08 expcnvi   expcnv
11-Dec-08 isummulc1i isummulc1
11-Dec-08 iserzgt0i iserzgt0
11-Dec-08 isumreclti isumrecl
11-Dec-08 isumclti  isumcl
11-Dec-08 isumnn0nni isumnn0nn
11-Dec-08 isum1pi   isum1p
11-Dec-08 isumnuli  isumnul
11-Dec-08 isumclim5ti isumclim5
11-Dec-08 isumclim4ti isumclim4
11-Dec-08 isumclim3ti isumclim3
11-Dec-08 isumclim2ti isumclim2
11-Dec-08 isumclim2tfi isumclim2f
11-Dec-08 isum1climi isum1clim
11-Dec-08 isumclimti isumclim
11-Dec-08 isumval2ti isumval2
11-Dec-08 isumvalti isumval
11-Dec-08 cvgcmp3ceti cvgcmp3ce
11-Dec-08 iserzcmp0i iserzcmp0
11-Dec-08 iserzcmpi iserzcmp
11-Dec-08 climsqueeze2i climsqueeze2
11-Dec-08 climsqueezei climsqueeze
11-Dec-08 climcmpc1i climcmpc1
11-Dec-08 climcmpi  climcmp
11-Dec-08 iserzmulc1i iserzmulc1
11-Dec-08 iserzexti iserzex
11-Dec-08 clim2serzti clim2serz
11-Dec-08 climsubc2i climsubc2
11-Dec-08 climsubi  climsub
11-Dec-08 climmulc2i climmulc2
11-Dec-08 climmuli  climmul
11-Dec-08 climaddc2i climaddc2
11-Dec-08 climaddc1i climaddc1
11-Dec-08 climaddi  climadd
11-Dec-08 climge0i  climge0
11-Dec-08 climrecli climrecl
11-Dec-08 climreui  climreu
11-Dec-08 climeui   climeu
11-Dec-08 climuniii climunii
11-Dec-08 climunii  climuni
11-Dec-08 clm4ati   clm4a
11-Dec-08 serzmulc1i serzmulc1
11-Dec-08 serzspliti serzsplit
11-Dec-08 serzcmp0i serzcmp0
11-Dec-08 serzcmpi  serzcmp
11-Dec-08 serz1pi   serz1p
11-Dec-08 serzreclti serzrecl
11-Dec-08 serzcl2ti serzcl2
11-Dec-08 ser1clti  ser1cl
11-Dec-08 ser0clti  ser0cl
11-Dec-08 serzclti  serzcl
11-Dec-08 fsum4i    fsum4
11-Dec-08 fsum3i    fsum3
11-Dec-08 fsum2i    fsum2
11-Dec-08 fsum0spli fsum0spl
11-Dec-08 fsumspli  fsumspl
11-Dec-08 serzfsumi serzfsum
11-Dec-08 fsumserz2i fsumserz2
11-Dec-08 fsumserzi fsumserz
11-Dec-08 cvg1ii    cvg1i
11-Dec-08 cvg1i     cvg1
11-Dec-08 seqzres2i seqzres2
11-Dec-08 seqzresi  seqzres
11-Dec-08 seqzresvali seqzresval
11-Dec-08 seqzcli   seqzcl
11-Dec-08 seqzrni   seqzrn
11-Dec-08 seqzrn2i  seqzrn2
11-Dec-08 seqzeqi   seqzeq
11-Dec-08 seqzfveqi seqzfveq
11-Dec-08 seqzval2ti seqzval2
11-Dec-08 seq01i    seq01
11-Dec-08 seq0p1i   seq0p1
11-Dec-08 seq00i    seq00
11-Dec-08 seqzm1i   seqzm1
11-Dec-08 seqzp1i   seqzp1
11-Dec-08 seqz1i    seqz1
11-Dec-08 seq0fni   seq0fn
11-Dec-08 seq1seq0i seq1seq0
11-Dec-08 seq1seq0ti seq1seq01
11-Dec-08 seq1seq02ti seq1seq02
11-Dec-08 seq0seqzi seq0seqz
11-Dec-08 seq1seqzi seq1seqz
11-Dec-08 seqzvalti seqzval
11-Dec-08 seqzfni   seqzfn
11-Dec-08 seqzfval2i seqzfval2
11-Dec-08 seqzfvali seqzfval
11-Dec-08 seq0valti seq0valt
11-Dec-08 seq0fvali seq0fval
11-Dec-08 seq1shftidi seq1shftid
11-Dec-08 shftidti  shftidt
11-Dec-08 shftcan1ti shftcan1
11-Dec-08 shftcan2ti shftcan2
11-Dec-08 shftfi    shftf
11-Dec-08 shftval5ti shftval5
11-Dec-08 shftval4ti shftval4
11-Dec-08 shftval3ti shftval3
11-Dec-08 shftval2ti shftval2
11-Dec-08 shftvalti shftval
11-Dec-08 shftresvalti shftresval
11-Dec-08 shftresi  shftres
11-Dec-08 shftfni   shftfn
11-Dec-08 shftfvali shftfval
11-Dec-08 seq1resi  seq1res
11-Dec-08 seq1cl2i  seq1cl2
11-Dec-08 seq1cli   seq1cl
11-Dec-08 seq1f2i   seq1f2
11-Dec-08 seq1fi    seq1f
11-Dec-08 seq1rni   seq1rn
11-Dec-08 seq1rn2i  seq1rn2
11-Dec-08 seq1fni   seq1fn
11-Dec-08 seq1m1i   seq1m1
11-Dec-08 seq1p1i   seq1p1
11-Dec-08 seq11i    seq11
11-Dec-08 seq1val2i seq1val2
11-Dec-08 seq1vali  seq1val
11-Dec-08 seq1rvali seq1rval
11-Dec-08 uznegi    uzneg
 9-Dec-08 nvelv     vprc
 9-Dec-08 inelv     iprc
 9-Dec-08 fipr      fiprc
 9-Dec-08 ecqs      [--same--]  eliminated redundant hypothesis A e. _V
18-Nov-08 ---       ---         See mmnotes.txt entry of 18-Nov-2008
18-Nov-08 cdavalt   cdaval
18-Nov-08 cdaval    cdavali
18-Nov-08 unbnnt    unbnn3
18-Nov-08 frsuct    frsuc
18-Nov-08 fr0t      fr0g
18-Nov-08 rdg0t     rdg0g
18-Nov-08 ssonunit  ssonuni
18-Nov-08 ssonuni   ssonunii
18-Nov-08 eqtr3t    eqtr3
18-Nov-08 eqtr2t    eqtr2
18-Nov-08 eqtrt     eqtr
18-Nov-08 3eqtr4r   3eqtr4ri
18-Nov-08 3eqtr3r   3eqtr3ri
18-Nov-08 3eqtr2r   3eqtr2ri
18-Nov-08 3eqtr4r   3eqtr4ri
18-Nov-08 3eqtr3r   3eqtr3ri
18-Nov-08 3bitr3r   3bitr3ri
18-Nov-08 3bitr4r   3bitr4ri
18-Nov-08 3bitr2r   3bitr2ri
18-Nov-08 biimpr    biimpri
18-Nov-08 biimp     biimpi
18-Nov-08 impbi     impbii
18-Nov-08 ---       ---         See mmnotes.txt entry of 17-Nov-2008
17-Nov-08 ---       ---         Remember that substitutions are
17-Nov-08 ---       ---         made in _reverse_ order.
17-Nov-08 efi4pt    efi4p
17-Nov-08 resin4pt  resin4p
17-Nov-08 recos4pt  recos4p
17-Nov-08 ef4pt     ef4p
17-Nov-08 addclt    addcl
17-Nov-08 readdclt  readdcl
17-Nov-08 mulclt    mulcl
17-Nov-08 remulclt  remulcl
17-Nov-08 addcomt   addcom
17-Nov-08 mulcomt   mulcom
17-Nov-08 addasst   addass
17-Nov-08 mulasst   mulass
17-Nov-08 adddit    adddi
17-Nov-08 addid1t   addid1
17-Nov-08 mulid1t   mulid1
17-Nov-08 recnt     recn
17-Nov-08 adddirt   adddir
17-Nov-08 addid2t   addid2
17-Nov-08 add12t    add12
17-Nov-08 add23t    add23
17-Nov-08 add4t     add4
17-Nov-08 add42t    add42
17-Nov-08 cnegext   cnegex
17-Nov-08 cnegextlem1 cnegexlem1
17-Nov-08 cnegextlem2 cnegexlem2
17-Nov-08 cnegextlem3 cnegexlem3
17-Nov-08 addcant   addcan
17-Nov-08 addcan2t  addcan2
17-Nov-08 subvalt   subval
17-Nov-08 subclt    subcl
17-Nov-08 negclt    negcl
17-Nov-08 subaddt   subadd
17-Nov-08 subsub23t subsub23
17-Nov-08 pncan3t   pncan3
17-Nov-08 negidt    negid
17-Nov-08 negsubt   negsub
17-Nov-08 addsubasst addsubass
17-Nov-08 addsubt   addsub
17-Nov-08 subadd23t subadd23
17-Nov-08 addsub12t addsub12
17-Nov-08 2addsubt  2addsub
17-Nov-08 negnegt   negneg
17-Nov-08 subnegt   subneg
17-Nov-08 subidt    subid
17-Nov-08 subid1t   subid1
17-Nov-08 pncant    pncan
17-Nov-08 pncan2t   pncan2
17-Nov-08 npcant    npcan
17-Nov-08 npncant   npncan
17-Nov-08 nppcant   nppcan
17-Nov-08 subcan2t  subcan2
17-Nov-08 subeq0t   subeq0
17-Nov-08 neg11t    neg11
17-Nov-08 negcon1t  negcon1
17-Nov-08 negcon2t  negcon2
17-Nov-08 subcant   subcan
17-Nov-08 mulid2t   mulid2
17-Nov-08 mul12t    mul12
17-Nov-08 mul23t    mul23
17-Nov-08 mul4t     mul4
17-Nov-08 muladdt   muladd
17-Nov-08 muladd11t muladd11
17-Nov-08 subdit    subdi
17-Nov-08 subdirt   subdir
17-Nov-08 renegclt  renegcl
17-Nov-08 resubclt  resubcl
17-Nov-08 mul01t    mul01
17-Nov-08 mul02t    mul02
17-Nov-08 mulneg1t  mulneg1
17-Nov-08 mulneg2t  mulneg2
17-Nov-08 mulneg12t mulneg12
17-Nov-08 mul2negt  mul2neg
17-Nov-08 negdit    negdi
17-Nov-08 negdi2t   negdi2
17-Nov-08 negsubdit negsubdi
17-Nov-08 negsubdi2t negsubdi2
17-Nov-08 neg2subt  neg2sub
17-Nov-08 submul2t  submul2
17-Nov-08 subsub2t  subsub2
17-Nov-08 subsubt   subsub
17-Nov-08 subsub3t  subsub3
17-Nov-08 subsub4t  subsub4
17-Nov-08 sub23t    sub23
17-Nov-08 nnncant   nnncan
17-Nov-08 nnncan1t  nnncan1
17-Nov-08 nnncan2t  nnncan2
17-Nov-08 nncant    nncan
17-Nov-08 nppcan2t  nppcan2
17-Nov-08 mulm1t    mulm1
17-Nov-08 addsub4t  addsub4
17-Nov-08 subadd4t  subadd4
17-Nov-08 sub4t     sub4
17-Nov-08 mulsubt   mulsub
17-Nov-08 pnpcant   pnpcan
17-Nov-08 pnpcan2t  pnpcan2
17-Nov-08 pnncant   pnncan
17-Nov-08 ppncant   ppncan
17-Nov-08 ltxrt     ltxr
17-Nov-08 rexrt     rexr
17-Nov-08 ltxrltt   ltxrlt
17-Nov-08 xrlenltt  xrlenlt
17-Nov-08 xrltnlet  xrltnle
17-Nov-08 lttrt     lttr
17-Nov-08 mulgt0t   mulgt0
17-Nov-08 lenltt    lenlt
17-Nov-08 ltnlet    ltnle
17-Nov-08 lttri2t   lttri2
17-Nov-08 lttri3t   lttri3
17-Nov-08 lttri4t   lttri4
17-Nov-08 ltnet     ltne
17-Nov-08 letri3t   letri3
17-Nov-08 leloet    leloe
17-Nov-08 eqleltt   eqlelt
17-Nov-08 ltlet     ltle
17-Nov-08 leltnet   leltne
17-Nov-08 ltlent    ltlen
17-Nov-08 lelttrt   lelttr
17-Nov-08 ltletrt   ltletr
17-Nov-08 letrt     letr
17-Nov-08 ltnrt     ltnr
17-Nov-08 leidt     leid
17-Nov-08 ltnsymt   ltnsym
17-Nov-08 ltnsym2t  ltnsym2
17-Nov-08 renepnft  renepnf
17-Nov-08 renemnft  renemnf
17-Nov-08 xrltnrt   xrltnr
17-Nov-08 ltpnft    ltpnf
17-Nov-08 mnfltt    mnflt
17-Nov-08 mnfltxrt  mnfltxr
17-Nov-08 pnfnltt   pnfnlt
17-Nov-08 nltmnft   nltmnf
17-Nov-08 pnfget    pnfge
17-Nov-08 mnflet    mnfle
17-Nov-08 xrltnsymt xrltnsym
17-Nov-08 xrltnsym2t xrltnsym2
17-Nov-08 xrlttrit  xrlttri
17-Nov-08 xrlttrt   xrlttr
17-Nov-08 xrlttri2t xrlttri2
17-Nov-08 xrlttri3t xrlttri3
17-Nov-08 xrleloet  xrleloe
17-Nov-08 xrleltnet xrleltne
17-Nov-08 xrltlet   xrltle
17-Nov-08 xrleidt   xrleid
17-Nov-08 xrletrit  xrletri
17-Nov-08 xrlelttrt xrlelttr
17-Nov-08 xrltletrt xrltletr
17-Nov-08 xrletrt   xrletr
17-Nov-08 xrltnet   xrltne
17-Nov-08 nltpnftt  nltpnft
17-Nov-08 ngtmnftt  ngtmnft
17-Nov-08 xrrebndt  xrrebnd
17-Nov-08 xrret     xrre
17-Nov-08 xrre2t    xrre2
17-Nov-08 eqlet     eqle
17-Nov-08 msqgt0t   msqgt0
17-Nov-08 msqge0t   msqge0
17-Nov-08 gt0ne0t   gt0ne0
17-Nov-08 ne0gt0t   ne0gt0
17-Nov-08 letrit    letric
17-Nov-08 lelttrit  lelttric
17-Nov-08 ltadd1t   ltadd1
17-Nov-08 ltadd2t   ltadd2
17-Nov-08 leadd1t   leadd1
17-Nov-08 leadd2t   leadd2
17-Nov-08 ltsubaddt ltsubadd
17-Nov-08 ltsubadd2t ltsubadd2
17-Nov-08 lesubaddt lesubadd
17-Nov-08 lesubadd2t lesubadd2
17-Nov-08 ltaddsubt ltaddsub
17-Nov-08 ltaddsub2t ltaddsub2
17-Nov-08 leaddsubt leaddsub
17-Nov-08 leaddsub2t leaddsub2
17-Nov-08 sublet    suble
17-Nov-08 lesubt    lesub
17-Nov-08 ltsub23t  ltsub23
17-Nov-08 ltsub13t  ltsub13
17-Nov-08 lt2addt   lt2add
17-Nov-08 le2addt   le2add
17-Nov-08 ltleaddt  ltleadd
17-Nov-08 leltaddt  leltadd
17-Nov-08 addgt0t   addgt0
17-Nov-08 addgegt0t addgegt0
17-Nov-08 addgtge0t addgtge0
17-Nov-08 addge0t   addge0
17-Nov-08 ltaddpost ltaddpos
17-Nov-08 ltaddpos2t ltaddpos2
17-Nov-08 ltsubpost ltsubpos
17-Nov-08 posdift   posdif
17-Nov-08 ltnegt    ltneg
17-Nov-08 ltnegcon1t ltnegcon1
17-Nov-08 lenegt    leneg
17-Nov-08 lenegcon1t lenegcon1
17-Nov-08 lenegcon2t lenegcon2
17-Nov-08 lesub1t   lesub1
17-Nov-08 lesub2t   lesub2
17-Nov-08 ltsub1t   ltsub1
17-Nov-08 ltsub2t   ltsub2
17-Nov-08 lt0neg1t  lt0neg1
17-Nov-08 lt0neg2t  lt0neg2
17-Nov-08 le0neg1t  le0neg1
17-Nov-08 le0neg2t  le0neg2
17-Nov-08 addge01t  addge01
17-Nov-08 addge02t  addge02
17-Nov-08 subge0t   subge0
17-Nov-08 suble0t   suble0
17-Nov-08 subge02t  subge02
17-Nov-08 lesub0t   lesub0
17-Nov-08 mulge0t   mulge0
17-Nov-08 recext    recex
17-Nov-08 mulcant   mulcan
17-Nov-08 mulcan2t  mulcan2
17-Nov-08 mul0ort   mul0or
17-Nov-08 muln0bt   mulne0b
17-Nov-08 muln0t    muln0
17-Nov-08 muleqaddt muleqadd
17-Nov-08 divmult   divmul
17-Nov-08 divmul2t  divmul2
17-Nov-08 divmul3t  divmul3
17-Nov-08 divclt    divcl
17-Nov-08 recclt    reccl
17-Nov-08 divcan1t  divcan1
17-Nov-08 divcan2t  divcan2
17-Nov-08 divne0bt  divne0b
17-Nov-08 divne0t   divne0
17-Nov-08 recne0t   recne0
17-Nov-08 recidt    recid
17-Nov-08 recid2t   recid2
17-Nov-08 divrect   divrec
17-Nov-08 divrec2t  divrec2
17-Nov-08 divasst   divass
17-Nov-08 div23t    div23
17-Nov-08 div13t    div13
17-Nov-08 div12t    div12
17-Nov-08 divdirt   divdir
17-Nov-08 divcan3t  divcan3
17-Nov-08 divcan4t  divcan4
17-Nov-08 div11t    div11
17-Nov-08 dividt    divid
17-Nov-08 div0t     div0
17-Nov-08 diveq0t   diveq0
17-Nov-08 div1t     div1
17-Nov-08 divnegt   divneg
17-Nov-08 divsubdirt divsubdir
17-Nov-08 recrect   recrec
17-Nov-08 rec11rt   rec11r
17-Nov-08 divmuldivt divmuldiv
17-Nov-08 divcan5t  divcan5
17-Nov-08 divmul13t divmul13
17-Nov-08 divmul24t divmul24
17-Nov-08 divadddivt divadddiv
17-Nov-08 divdivdivt divdivdiv
17-Nov-08 recdivt   recdiv
17-Nov-08 divcan6t  divcan6
17-Nov-08 divdiv23t divdiv23
17-Nov-08 divdivmult divdivmul
17-Nov-08 recdiv2t  recdiv2
17-Nov-08 conjmult  conjmul
17-Nov-08 redivclt  redivcl
17-Nov-08 rerecclt  rereccl
17-Nov-08 eqnegt    eqneg
17-Nov-08 negeq0t   negeq0
17-Nov-08 ltp1t     ltp1
17-Nov-08 lep1t     lep1
17-Nov-08 ltm1t     ltm1
17-Nov-08 letrp1t   letrp1
17-Nov-08 p1let     p1le
17-Nov-08 prodgt0t  prodgt0
17-Nov-08 prodgt02t prodgt02
17-Nov-08 prodge0t  prodge0
17-Nov-08 prodge02t prodge02
17-Nov-08 ltmul1t   ltmul1
17-Nov-08 ltmul2t   ltmul2
17-Nov-08 lemul1t   lemul1
17-Nov-08 lemul2t   lemul2
17-Nov-08 lemul1it  lemul1a
17-Nov-08 lemul2it  lemul2a
17-Nov-08 ltmul12it ltmul12a
17-Nov-08 lemul12ait lemul12b
17-Nov-08 lemul12it lemul12a
17-Nov-08 mulgt1t   mulgt1
17-Nov-08 ltmulgt11t ltmulgt11
17-Nov-08 ltmulgt12t ltmulgt12
17-Nov-08 lemulge11t lemulge11
17-Nov-08 ltdiv1t   ltdiv1
17-Nov-08 lediv1t   lediv1
17-Nov-08 gt0divt   gt0div
17-Nov-08 ge0divt   ge0div
17-Nov-08 divgt0t   divgt0
17-Nov-08 divge0t   divge0
17-Nov-08 recgt0t   recgt0
17-Nov-08 ltmuldivt ltmuldiv
17-Nov-08 ltmuldiv2t ltmuldiv2
17-Nov-08 ltdivmult ltdivmul
17-Nov-08 ledivmult ledivmul
17-Nov-08 ltdivmul2t ltdivmul2
17-Nov-08 lt2mul2divt lt2mul2div
17-Nov-08 ledivmul2t ledivmul2
17-Nov-08 lemuldivt lemuldiv
17-Nov-08 lemuldiv2t lemuldiv2
17-Nov-08 ltrect    ltrec
17-Nov-08 lerect    lerec
17-Nov-08 lt2msqt   lt2msq
17-Nov-08 ltdiv2OLDt   ltdiv2OLD
17-Nov-08 ltrec1t   ltrec1
17-Nov-08 lerec2t   lerec2
17-Nov-08 ledivdivt ledivdiv
17-Nov-08 lediv2t   lediv2
17-Nov-08 ltdiv23t  ltdiv23
17-Nov-08 lediv23t  lediv23
17-Nov-08 lediv12it lediv12a
17-Nov-08 lediv2it  lediv2a
17-Nov-08 reclt1t   reclt1
17-Nov-08 recgt1t   recgt1
17-Nov-08 recgt1it  recgt1i
17-Nov-08 recrecltt recreclt
17-Nov-08 le2msqt   le2msq
17-Nov-08 ledivp1t  ledivp1
17-Nov-08 xrmaxltt  xrmaxlt
17-Nov-08 xrltmint  xrltmin
17-Nov-08 maxlet    maxle
17-Nov-08 lemint    lemin
17-Nov-08 maxltt    maxlt
17-Nov-08 ltmint    ltmin
17-Nov-08 nnret     nnre
17-Nov-08 nncnt     nncn
17-Nov-08 nnaddclt  nnaddcl
17-Nov-08 nnmulclt  nnmulcl
17-Nov-08 nn2get    nn2ge
17-Nov-08 nnge1t    nnge1
17-Nov-08 nngt1ne1t nngt1ne1
17-Nov-08 nnle1eq1t nnle1eq1
17-Nov-08 nngt0t    nngt0
17-Nov-08 nnne0t    nnne0
17-Nov-08 nnrecret  nnrecre
17-Nov-08 nnrecgt0t nnrecgt0
17-Nov-08 nnleltp1t nnleltp1
17-Nov-08 nnltp1let nnltp1le
17-Nov-08 nnsubt    nnsub
17-Nov-08 nnaddm1clt nnaddm1cl
17-Nov-08 nndivt    nndiv
17-Nov-08 nndivtrt  nndivtr
17-Nov-08 2timest   2times
17-Nov-08 times2t   times2
17-Nov-08 halfclt   halfcl
17-Nov-08 rehalfclt rehalfcl
17-Nov-08 half0t    half0
17-Nov-08 halfpost  halfpos
17-Nov-08 halfpos2t halfpos2
17-Nov-08 halfnneg2t halfnneg2
17-Nov-08 2halvest  2halves
17-Nov-08 halfaddsubt halfaddsub
17-Nov-08 lt2halvest lt2halves
17-Nov-08 avglet    avgle
17-Nov-08 rpret     rpre
17-Nov-08 rpcnt     rpcn
17-Nov-08 rpgt0t    rpgt0
17-Nov-08 rpge0t    rpge0
17-Nov-08 rpregt0t  rpregt0
17-Nov-08 rpne0t    rpne0
17-Nov-08 rprene0t  rprene0
17-Nov-08 rpcnne0t  rpcnne0
17-Nov-08 rpaddclt  rpaddcl
17-Nov-08 rpmulclt  rpmulcl
17-Nov-08 rpdivclt  rpdivcl
17-Nov-08 rerpdivclt rerpdivcl
17-Nov-08 rpnegt    rpneg
17-Nov-08 nnreclt   nnrecl
17-Nov-08 nnnn0t    nnnn0
17-Nov-08 nn0ret    nn0re
17-Nov-08 nn0cnt    nn0cn
17-Nov-08 nn0ge0t   nn0ge0
17-Nov-08 nn0le0eq0t nn0le0eq0
17-Nov-08 nn0addclt nn0addcl
17-Nov-08 nn0mulclt nn0mulcl
17-Nov-08 nnnn0addclt nnnn0addcl
17-Nov-08 nn0nnaddclt nn0nnaddcl
17-Nov-08 nn0ltp1let nn0ltp1le
17-Nov-08 nn0leltp1t nn0leltp1
17-Nov-08 nn0ltlem1t nn0ltlem1
17-Nov-08 nn0addge1t nn0addge1
17-Nov-08 nn0addge2t nn0addge2
17-Nov-08 zret      zre
17-Nov-08 zcnt      zcn
17-Nov-08 nnzt      nnz
17-Nov-08 nn0zt     nn0z
17-Nov-08 znnnlt1t  znnnlt1
17-Nov-08 nn0subt   nn0sub
17-Nov-08 nn0sub2t  nn0sub2
17-Nov-08 znegclt   znegcl
17-Nov-08 zaddclt   zaddcl
17-Nov-08 zsubclt   zsubcl
17-Nov-08 zrevaddclt zrevaddcl
17-Nov-08 nn0p1nnt  nn0p1nn
17-Nov-08 nnm1nn0t  nnm1nn0
17-Nov-08 znnsubt   znnsub
17-Nov-08 znn0subt  znn0sub
17-Nov-08 znn0sub2t znn0sub2
17-Nov-08 zmulclt   zmulcl
17-Nov-08 zltp1let  zltp1le
17-Nov-08 zleltp1t  zleltp1
17-Nov-08 zlem1ltt  zlem1lt
17-Nov-08 zltlem1t  zltlem1
17-Nov-08 nn0lem1ltt nn0lem1lt
17-Nov-08 nnlem1ltt nnlem1lt
17-Nov-08 nnltlem1t nnltlem1
17-Nov-08 zdivt     zdiv
17-Nov-08 zdivaddt  zdivadd
17-Nov-08 zdivmult  zdivmul
17-Nov-08 z2get     z2ge
17-Nov-08 zextlet   zextle
17-Nov-08 zextltt   zextlt
17-Nov-08 recnzt    recnz
17-Nov-08 btwnnzt   btwnnz
17-Nov-08 gtndivt   gtndiv
17-Nov-08 primet    prime
17-Nov-08 nneot     nneo
17-Nov-08 zeot      zeo
17-Nov-08 qret      qre
17-Nov-08 zqt       zq
17-Nov-08 nnqt      nnq
17-Nov-08 qcnt      qcn
17-Nov-08 qaddclt   qaddcl
17-Nov-08 qnegclt   qnegcl
17-Nov-08 qmulclt   qmulcl
17-Nov-08 qsubclt   qsubcl
17-Nov-08 qrecclt   qreccl
17-Nov-08 qdivclt   qdivcl
17-Nov-08 qrevaddclt qrevaddcl
17-Nov-08 nnrecqt   nnrecq
17-Nov-08 irraddt   irradd
17-Nov-08 irrmult   irrmul
17-Nov-08 flvalt    flval
17-Nov-08 flclt     flcl
17-Nov-08 flreclt   flrecl
17-Nov-08 flleltt   fllelt
17-Nov-08 fllet     flle
17-Nov-08 flltp1t   flltp1
17-Nov-08 fraclt1t  fraclt1
17-Nov-08 fracge0t  fracge0
17-Nov-08 flget     flge
17-Nov-08 flltt     fllt
17-Nov-08 flidt     flid
17-Nov-08 flidmt    flidm
17-Nov-08 flidzt    flidz
17-Nov-08 flwordit  flwordi
17-Nov-08 flval2t   flval2
17-Nov-08 flval3t   flval3
17-Nov-08 flbit     flbi
17-Nov-08 flbi2t    flbi2
17-Nov-08 flge0nn0t flge0nn0
17-Nov-08 flge1nnt  flge1nn
17-Nov-08 fladdzt   fladdz
17-Nov-08 btwnzge0t btwnzge0
17-Nov-08 flhalft   flhalf
17-Nov-08 ceiclt    ceicl
17-Nov-08 ceiget    ceige
17-Nov-08 ceim1lt   ceim1l
17-Nov-08 ceilet    ceile
17-Nov-08 fldivt    fldiv
17-Nov-08 fldiv2t   fldiv2
17-Nov-08 modvalt   modval
17-Nov-08 modclt    modcl
17-Nov-08 modge0t   modge0
17-Nov-08 modltt    modlt
17-Nov-08 modfract  modfrac
17-Nov-08 flmodt    flmod
17-Nov-08 modcyct   modcyc
17-Nov-08 modcyc2t  modcyc2
17-Nov-08 modadd1t  modadd1
17-Nov-08 modmul1t  modmul1
17-Nov-08 moddit    moddi
17-Nov-08 modirrt   modirr
17-Nov-08 ioovalt   iooval
17-Nov-08 iooval2t  iooval2
17-Nov-08 ioo0t     ioo0
17-Nov-08 ioon0t    ioon0
17-Nov-08 iooint    iooin
17-Nov-08 iocvalt   iocval
17-Nov-08 icovalt   icoval
17-Nov-08 iccvalt   iccval
17-Nov-08 elioo1t   elioo1
17-Nov-08 elioo2t   elioo2
17-Nov-08 elioc1t   elioc1
17-Nov-08 elico1t   elico1
17-Nov-08 elicc1t   elicc1
17-Nov-08 elioo5t   elioo5
17-Nov-08 eliooret  elioore
17-Nov-08 eliooxrt  eliooxr
17-Nov-08 eliooordt eliooord
17-Nov-08 elioc2t   elioc2
17-Nov-08 elico2t   elico2
17-Nov-08 elicc2t   elicc2
17-Nov-08 iooshft   iooshf
17-Nov-08 iccssret  iccssre
17-Nov-08 lbicc2t   lbicc2
17-Nov-08 ubicc2t   ubicc2
17-Nov-08 ioonegt   iooneg
17-Nov-08 iccnegt   iccneg
17-Nov-08 icoshft   icoshf
17-Nov-08 ioojoint  ioojoin
17-Nov-08 uzvalt    uzval
17-Nov-08 eluz1t    eluz1
17-Nov-08 eluz2t    eluz2
17-Nov-08 eluzt     eluz
17-Nov-08 uzidt     uzid
17-Nov-08 uznegit   uznegi
17-Nov-08 uz11t     uz11
17-Nov-08 eluzp1m1t eluzp1m1
17-Nov-08 eluzp1lt  eluzp1l
17-Nov-08 eluzp1p1t eluzp1p1
17-Nov-08 uzaddclt  uzaddcl
17-Nov-08 fzvalt    fzval
17-Nov-08 elfz1t    elfz1
17-Nov-08 elfzt     elfz
17-Nov-08 elfz2t    elfz2
17-Nov-08 elfz5t    elfz5
17-Nov-08 elfz4t    elfz4
17-Nov-08 eluzfzt   eluzfz
17-Nov-08 elfzuz3t  elfzuz3
17-Nov-08 elfzuz2t  elfzuz2
17-Nov-08 eluzfz1t  eluzfz1
17-Nov-08 elfzuzt   elfzuz
17-Nov-08 eluzfz2t  eluzfz2
17-Nov-08 elfz3t    elfz3
17-Nov-08 elfz1eqt  elfz1eq
17-Nov-08 fznt      fzn
17-Nov-08 elfznnt   elfznn
17-Nov-08 elfz2nn0t elfz2nn0
17-Nov-08 elfznn0t  elfznn0
17-Nov-08 elfz3nn0t elfz3nn0
17-Nov-08 fznn0subt fznn0sub
17-Nov-08 fznn0sub2t fznn0sub2
17-Nov-08 fzaddelt  fzaddel
17-Nov-08 fzsubelt  fzsubel
17-Nov-08 fzoptht   fzopth
17-Nov-08 fzss1t    fzss1
17-Nov-08 fzss2t    fzss2
17-Nov-08 fzssuzt   fzssuz
17-Nov-08 fzssp1t   fzssp1
17-Nov-08 fzp1sst   fzp1ss
17-Nov-08 fzelp1t   fzelp1
17-Nov-08 fzrevt    fzrev
17-Nov-08 fzrev2t   fzrev2
17-Nov-08 fzrev2it  fzrev2i
17-Nov-08 fzrev3t   fzrev3
17-Nov-08 fzrev3it  fzrev3i
17-Nov-08 fznn0t    fznn0
17-Nov-08 fz1sbct   fz1sbc
17-Nov-08 fzneuzt   fzneuz
17-Nov-08 fzrevralt fzrevral
17-Nov-08 fzrevral2t fzrevral2
17-Nov-08 fzrevral3t fzrevral3
17-Nov-08 fzshftralt fzshftral
17-Nov-08 ser1ft    ser1f
17-Nov-08 limsupvalt limsupval
17-Nov-08 limsupclt limsupcl
17-Nov-08 expvalt   expval
17-Nov-08 exp0t     exp0
17-Nov-08 expnnvalt expnnval
17-Nov-08 exp1t     exp1
17-Nov-08 expp1t    expp1
17-Nov-08 nnexpclt  nnexpcl
17-Nov-08 nn0expclt nn0expcl
17-Nov-08 zexpclt   zexpcl
17-Nov-08 qexpclt   qexpcl
17-Nov-08 reexpclt  reexpcl
17-Nov-08 expclt    expcl
17-Nov-08 rpexpclt  rpexpcl
17-Nov-08 expm1t    expm1
17-Nov-08 1expt     1exp
17-Nov-08 expeq0t   expeq0
17-Nov-08 expne0t   expne0
17-Nov-08 expne0it  expne0i
17-Nov-08 expgt0t   expgt0
17-Nov-08 0expt     0exp
17-Nov-08 expge0t   expge0
17-Nov-08 expgt1t   expgt1
17-Nov-08 expge1t   expge1
17-Nov-08 mulexpt   mulexp
17-Nov-08 recexpt   recexp
17-Nov-08 expaddt   expadd
17-Nov-08 expmult   expmul
17-Nov-08 expsubt   expsub
17-Nov-08 divexpt   divexp
17-Nov-08 ltexp2at  ltexp2a
17-Nov-08 expcant   expcan
17-Nov-08 expordt   ltexp2
17-Nov-08 expwordit leexp2a
17-Nov-08 expord2t  ltexp2r
17-Nov-08 expword2it leexp2r
17-Nov-08 expmwordit leexp1a
17-Nov-08 exple1t   exple1
17-Nov-08 expubndt  expubnd
17-Nov-08 sqvalt    sqval
17-Nov-08 sqnegt    sqneg
17-Nov-08 sqclt     sqcl
17-Nov-08 sqmult    sqmul
17-Nov-08 sqeq0t    sqeq0
17-Nov-08 sqne0t    sqne0
17-Nov-08 resqclt   resqcl
17-Nov-08 sqgt0t    sqgt0
17-Nov-08 sq11t     sq11
17-Nov-08 lt2sqt    lt2sq
17-Nov-08 le2sqt    le2sq
17-Nov-08 le2sqit   le2sq2
17-Nov-08 sqge0t    sqge0
17-Nov-08 sqlecant  sqlecan
17-Nov-08 subsqt    subsq
17-Nov-08 subsq2t   subsq2
17-Nov-08 sqeqort   sqeqor
17-Nov-08 binom2t   binom2
17-Nov-08 sq01t     sq01
17-Nov-08 expnbndt  expnbnd
17-Nov-08 expnlbndt expnlbnd
17-Nov-08 expnlbnd2t expnlbnd2
17-Nov-08 nn0opth2t nn0opth2
17-Nov-08 sqrclt    sqrcl
17-Nov-08 sqrgt0t   sqrgt0
17-Nov-08 sqrge0t   sqrge0
17-Nov-08 sqrlet    sqrle
17-Nov-08 sqr00t    sqr00
17-Nov-08 rpsqrclt  rpsqrcl
17-Nov-08 sqrsqt    sqrsq
17-Nov-08 sqsqrt    sqsqr
17-Nov-08 crut      cru
17-Nov-08 revalt    reval
17-Nov-08 imvalt    imval
17-Nov-08 reclt     recl
17-Nov-08 imclt     imcl
17-Nov-08 replimt   replim
17-Nov-08 absvalt   absval
17-Nov-08 cjvalt    cjval
17-Nov-08 cjclt     cjcl
17-Nov-08 crret     crre
17-Nov-08 crimt     crim
17-Nov-08 imret     imre
17-Nov-08 reim0t    reim0
17-Nov-08 reim0bt   reim0b
17-Nov-08 rerebt    rereb
17-Nov-08 mulret    mulre
17-Nov-08 reret     rere
17-Nov-08 cjrebt    cjreb
17-Nov-08 cjmulrclt cjmulrcl
17-Nov-08 cjmulvalt cjmulval
17-Nov-08 cjmulge0t cjmulge0
17-Nov-08 renegt    reneg
17-Nov-08 readdt    readd
17-Nov-08 resubt    resub
17-Nov-08 imnegt    imneg
17-Nov-08 imaddt    imadd
17-Nov-08 imsubt    imsub
17-Nov-08 cjret     cjre
17-Nov-08 cjcjt     cjcj
17-Nov-08 cjaddt    cjadd
17-Nov-08 cjmult    cjmul
17-Nov-08 cjnegt    cjneg
17-Nov-08 addcjt    addcj
17-Nov-08 cjsubt    cjsub
17-Nov-08 cjexpt    cjexp
17-Nov-08 recjt     recj
17-Nov-08 imcjt     imcj
17-Nov-08 cjreimt   cjreim
17-Nov-08 cjreim2t  cjreim2
17-Nov-08 cj11t     cj11
17-Nov-08 cjne0t    cjne0
17-Nov-08 absnegt   absneg
17-Nov-08 absclt    abscl
17-Nov-08 abscjt    abscj
17-Nov-08 absvalsqt absvalsq
17-Nov-08 absvalsq2t absvalsq2
17-Nov-08 sqabsaddt sqabsadd
17-Nov-08 sqabssubt sqabssub
17-Nov-08 absval2t  absval2
17-Nov-08 abs00t    abs00
17-Nov-08 absge0t   absge0
17-Nov-08 absrpclt  absrpcl
17-Nov-08 absreimsqt absreimsq
17-Nov-08 absreimt  absreim
17-Nov-08 absmult   absmul
17-Nov-08 absdivt   absdiv
17-Nov-08 absidt    absid
17-Nov-08 absnidt   absnid
17-Nov-08 leabst    leabs
17-Nov-08 absort    absor
17-Nov-08 absret    absre
17-Nov-08 absresqt  absresq
17-Nov-08 absexpt   absexp
17-Nov-08 absrelet  absrele
17-Nov-08 absimlet  absimle
17-Nov-08 nn0absclt nn0abscl
17-Nov-08 absltt    abslt
17-Nov-08 abslet    absle
17-Nov-08 abssubne0t abssubne0
17-Nov-08 absdifltt absdiflt
17-Nov-08 absdiflet absdifle
17-Nov-08 lenegsqt  lenegsq
17-Nov-08 releabst  releabs
17-Nov-08 cjdivt    cjdiv
17-Nov-08 absidmt   absidm
17-Nov-08 absgt0t   absgt0
17-Nov-08 abssubt   abssub
17-Nov-08 abssubge0t abssubge0
17-Nov-08 abssuble0t abssuble0
17-Nov-08 absmaxt   absmax
17-Nov-08 abstrit   abstri
17-Nov-08 abs3dift  abs3dif
17-Nov-08 abs2dift  abs2dif
17-Nov-08 abs2difabst abs2difabs
17-Nov-08 recant    recan
17-Nov-08 abs3lemt  abs3lem
17-Nov-08 facnnt    facnn
17-Nov-08 facp1t    facp1
17-Nov-08 facnn2t   facnn2
17-Nov-08 facclt    faccl
17-Nov-08 facne0t   facne0
17-Nov-08 facdivt   facdiv
17-Nov-08 facndivt  facndiv
17-Nov-08 facwordit facwordi
17-Nov-08 facavgt   facavg
17-Nov-08 bcvalt    bcval
17-Nov-08 bcval2t   bcval2
17-Nov-08 bcval3t   bcval3
17-Nov-08 bcval4t   bcval4
17-Nov-08 bccmplt   bccmpl
17-Nov-08 bcn0t     bcn0
17-Nov-08 bcnnt     bcnn
17-Nov-08 bcnp11t   bcnp11
17-Nov-08 bcnp1nt   bcnp1n
17-Nov-08 bcpasc2t  bcpasc2
17-Nov-08 bcpasct   bcpasc
17-Nov-08 bccl2t    bccl2
17-Nov-08 bcclt     bccl
17-Nov-08 permnnt   permnn
17-Nov-08 fsumclt   fsumcl
17-Nov-08 fsum0clt  fsum0cl
17-Nov-08 fsumreclt fsumrecl
17-Nov-08 fsumsplit fsumspli
17-Nov-08 fsum0split fsum0spli
17-Nov-08 fsumshft  fsumshf
17-Nov-08 fsumconst fsumcons
17-Nov-08 clmi2at   clmi2a
17-Nov-08 caucvg3t  caucvg3
17-Nov-08 eftclt    eftcl
17-Nov-08 efvalt    efval
17-Nov-08 efclt     efcl
17-Nov-08 reefclt   reefcl
17-Nov-08 efcjt     efcj
17-Nov-08 efaddt    efadd
17-Nov-08 efcant    efcan
17-Nov-08 efne0t    efne0
17-Nov-08 efsubt    efsub
17-Nov-08 efexpt    efexp
17-Nov-08 efnn0valt efnn0val
17-Nov-08 reeftclt  reeftcl
17-Nov-08 eftlubclt eftlubcl
17-Nov-08 efgt0t    efgt0
17-Nov-08 reef11t   reef11
17-Nov-08 eflegeot  eflegeo
17-Nov-08 efm1legeot efm1legeo
17-Nov-08 sinvalt   sinval
17-Nov-08 cosvalt   cosval
17-Nov-08 sinclt    sincl
17-Nov-08 cosclt    coscl
17-Nov-08 resinvalt resinval
17-Nov-08 recosvalt recosval
17-Nov-08 resinclt  resincl
17-Nov-08 recosclt  recoscl
17-Nov-08 sinnegt   sinneg
17-Nov-08 cosnegt   cosneg
17-Nov-08 efivalt   efival
17-Nov-08 efmivalt  efmival
17-Nov-08 efeult    efeul
17-Nov-08 sinaddt   sinadd
17-Nov-08 cosaddt   cosadd
17-Nov-08 sinsubt   sinsub
17-Nov-08 cossubt   cossub
17-Nov-08 addsint   addsin
17-Nov-08 subsint   subsin
17-Nov-08 addcost   addcos
17-Nov-08 subcost   subcos
17-Nov-08 sincossqt sincossq
17-Nov-08 sin2tt    sin2t
17-Nov-08 cos2tt    cos2t
17-Nov-08 cos2tsint cos2tsin
17-Nov-08 sinbndt   sinbnd
17-Nov-08 cosbndt   cosbnd
17-Nov-08 absefit   absefi
17-Nov-08 abseft    absef
17-Nov-08 absefibt  absefib
17-Nov-08 cosh111t  cosh111
17-Nov-08 logclt    logcl
17-Nov-08 relogclt  relogcl
17-Nov-08 eflogt    eflog
17-Nov-08 reeflogt  reeflog
17-Nov-08 logeft    logef
17-Nov-08 relogeft  relogef
17-Nov-08 relogmult relogmul
17-Nov-08 relogdivt relogdiv
17-Nov-08 explogt   explog
17-Nov-08 reexplogt reexplog
17-Nov-08 relogexpt relogexp
17-Nov-08 logltbt   logltb
17-Nov-08 1p1times  1p1timesi
17-Nov-08 2climnn   2climnni
17-Nov-08 2climnn0  2climnn0i
17-Nov-08 2shft     2shfti
17-Nov-08 2times    2timesi
17-Nov-08 abs00     abs00i
17-Nov-08 abs1m     abs1mi
17-Nov-08 abs3dif   abs3difi
17-Nov-08 abscj     abscji
17-Nov-08 abscl     abscli
17-Nov-08 absdivz   absdivzi
17-Nov-08 absef01tlub absef01tlubi
17-Nov-08 absefm1le absefm1lei
17-Nov-08 absge0    absge0i
17-Nov-08 absgt0    absgt0i
17-Nov-08 absid     absidi
17-Nov-08 absle     abslei
17-Nov-08 abslt     abslti
17-Nov-08 absmul    absmuli
17-Nov-08 absneg    absnegi
17-Nov-08 absnid    absnidi
17-Nov-08 absor     absori
17-Nov-08 abspef01tlub abspef01tlubi
17-Nov-08 absre     absrei
17-Nov-08 abssub    abssubi
17-Nov-08 abstri    abstrii
17-Nov-08 absval2   absval2i
17-Nov-08 absvalsq  absvalsqi
17-Nov-08 absvalsq2 absvalsq2i
17-Nov-08 add12     add12i
17-Nov-08 add20     add20i
17-Nov-08 add23     add23i
17-Nov-08 add4      add4i
17-Nov-08 add42     add42i
17-Nov-08 addass    addassi
17-Nov-08 addcan    addcani
17-Nov-08 addcan2   addcan2i
17-Nov-08 addcj     addcji
17-Nov-08 addcl     addcli
17-Nov-08 addcom    addcomi
17-Nov-08 adddi     adddii
17-Nov-08 adddir    adddiri
17-Nov-08 addge0    addge0i
17-Nov-08 addgegt0  addgegt0i
17-Nov-08 addgt0    addgt0i
17-Nov-08 addgt0i   addgt0ii
17-Nov-08 addid1    addid1i
17-Nov-08 addid2    addid2i
17-Nov-08 addsub    addsubi
17-Nov-08 addsub4   addsub4i
17-Nov-08 addsubass addsubassi
17-Nov-08 bcpasc    bcpasci
17-Nov-08 bcpasc2   bcpasc2i
17-Nov-08 binom     binomi
17-Nov-08 binom1p   binom1pi
17-Nov-08 binom2    binom2i
17-Nov-08 binom2a   binom2ai
17-Nov-08 cau2      cau2i
17-Nov-08 cau3      cau3i
17-Nov-08 cau3i     cau3ii
17-Nov-08 cau3ir    cau3iri
17-Nov-08 cau4i     cau4ii
17-Nov-08 cau5      cau5i
17-Nov-08 cau5i     cau5ii
17-Nov-08 caubnd    caubndi
17-Nov-08 caucvg    caucvgi
17-Nov-08 caucvg2   caucvg2i
17-Nov-08 caucvg3   caucvg3i
17-Nov-08 caucvg3a  caucvg3ai
17-Nov-08 cauim     cauimi
17-Nov-08 caure     caurei
17-Nov-08 cbvsum    cbvsumi
17-Nov-08 cjadd     cjaddi
17-Nov-08 cjcj      cjcji
17-Nov-08 cjcl      cjcli
17-Nov-08 cjdiv     cjdivi
17-Nov-08 cjmul     cjmuli
17-Nov-08 cjmulge0  cjmulge0i
17-Nov-08 cjmulrcl  cjmulrcli
17-Nov-08 cjmulval  cjmulvali
17-Nov-08 cjneg     cjnegi
17-Nov-08 cjreb     cjrebi
17-Nov-08 clim2serz clim2serzi
17-Nov-08 clim2serzt clim2serzti
17-Nov-08 climabs   climabsi
17-Nov-08 climabs0  climabs0i
17-Nov-08 climadd   climaddi
17-Nov-08 climaddc  climaddci
17-Nov-08 climaddc1 climaddc1i
17-Nov-08 climaddc2 climaddc2i
17-Nov-08 climcau   climcaui
17-Nov-08 climcj    climcji
17-Nov-08 climcmp   climcmpi
17-Nov-08 climcmpc1 climcmpc1i
17-Nov-08 climconst climconsti
17-Nov-08 climeu    climeui
17-Nov-08 climfnrcl climfnrcli
17-Nov-08 climge0   climge0i
17-Nov-08 climim    climimi
17-Nov-08 climmul   climmuli
17-Nov-08 climmulc  climmulci
17-Nov-08 climmulc2 climmulc2i
17-Nov-08 climre    climrei
17-Nov-08 climrecl  climrecli
17-Nov-08 climres   climresi
17-Nov-08 climreu   climreui
17-Nov-08 climserzle climserzlei
17-Nov-08 climshft  climshfti
17-Nov-08 climshft2 climshft2i
17-Nov-08 climsqueeze climsqueezei
17-Nov-08 climsqueeze2 climsqueeze2i
17-Nov-08 climsub   climsubi
17-Nov-08 climsubc2 climsubc2i
17-Nov-08 climsup   climsupi
17-Nov-08 climub    climubi
17-Nov-08 climubi   climubii
17-Nov-08 climuni   climunii
17-Nov-08 climunii  climuniii
17-Nov-08 climuz0   climuz0i
17-Nov-08 clm0      clm0i
17-Nov-08 clm0i     clm0ii
17-Nov-08 clm0nns   clm0nnsi
17-Nov-08 clm1      clm1i
17-Nov-08 clm2      clm2i
17-Nov-08 clm3      clm3i
17-Nov-08 clm4      clm4i
17-Nov-08 clm4at    clm4ati
17-Nov-08 clm4f     clm4fi
17-Nov-08 clm4le    clm4lei
17-Nov-08 clmi1     clmi1i
17-Nov-08 clmi2     clmi2i
17-Nov-08 clmi2rp   clmi2rpi
17-Nov-08 clmnns    clmnnsi
17-Nov-08 cnegex    cnegexi
17-Nov-08 cosadd    cosaddi
17-Nov-08 crim      crimi
17-Nov-08 crmul     crmuli
17-Nov-08 crne0     crne0i
17-Nov-08 crre      crrei
17-Nov-08 crrecz    crreczi
17-Nov-08 cru       crui
17-Nov-08 cvg1      cvg1i
17-Nov-08 cvg1i     cvg1ii
17-Nov-08 cvg2      cvg2i
17-Nov-08 cvg3      cvg3i
17-Nov-08 cvganuz   cvganuzi
17-Nov-08 cvgcmp    cvgcmpi
17-Nov-08 cvgcmp2   cvgcmp2i
17-Nov-08 cvgcmp2c  cvgcmp2ci
17-Nov-08 cvgcmp3c  cvgcmp3ci
17-Nov-08 cvgcmp3ce cvgcmp3cei
17-Nov-08 cvgcmp3cet cvgcmp3ceti
17-Nov-08 cvgcmpub  cvgcmpubi
17-Nov-08 cvgrat    cvgrati
17-Nov-08 dfef2     dfef2i
17-Nov-08 dfuz      dfuzi
17-Nov-08 div0      div0i
17-Nov-08 div1      div1i
17-Nov-08 div11     div11i
17-Nov-08 div23     div23i
17-Nov-08 divadddiv divadddivi
17-Nov-08 divass    divassi
17-Nov-08 divassz   divasszi
17-Nov-08 divcan1   divcan1i
17-Nov-08 divcan1z  divcan1zi
17-Nov-08 divcan2   divcan2i
17-Nov-08 divcan2z  divcan2zi
17-Nov-08 divcan3   divcan3i
17-Nov-08 divcan3z  divcan3zi
17-Nov-08 divcan4   divcan4i
17-Nov-08 divcan4z  divcan4zi
17-Nov-08 divcl     divcli
17-Nov-08 divclz    divclzi
17-Nov-08 divdir    divdiri
17-Nov-08 divdirz   divdirzi
17-Nov-08 divdiv23  divdiv23i
17-Nov-08 divdiv23z divdiv23zi
17-Nov-08 divdivdiv divdivdivi
17-Nov-08 divge0    divge0i
17-Nov-08 divgt0    divgt0i
17-Nov-08 divgt0i   divgt0ii
17-Nov-08 divgt0i2  divgt0i2i
17-Nov-08 divid     dividi
17-Nov-08 divmul    divmuli
17-Nov-08 divmul13  divmul13i
17-Nov-08 divmuldiv divmuldivi
17-Nov-08 divmulz   divmulzi
17-Nov-08 divne0    divne0i
17-Nov-08 divrec    divreci
17-Nov-08 divrecz   divreczi
17-Nov-08 divval    divvali
17-Nov-08 dsupivth  dsupivthi
17-Nov-08 ef01tlub  ef01tlubi
17-Nov-08 ef1tlub   ef1tlubi
17-Nov-08 ef4p      ef4pi
17-Nov-08 efadd     efaddi
17-Nov-08 efcj      efcji
17-Nov-08 effsumle  effsumlei
17-Nov-08 efge1     efge1i
17-Nov-08 efge1p    efge1pi
17-Nov-08 efgt0     efgt0i
17-Nov-08 efgt1     efgt1i
17-Nov-08 eflegeo   eflegeoi
17-Nov-08 eflt      eflti
17-Nov-08 efltb     efltbi
17-Nov-08 efm1legeo efm1legeoi
17-Nov-08 efm1lim   efm1limi
17-Nov-08 efsep     efsepi
17-Nov-08 eft0val   eft0vali
17-Nov-08 eftabs    eftabsi
17-Nov-08 eftlclt   eftlclti
17-Nov-08 eftlext   eftlexti
17-Nov-08 elcncf1d  elcncf1di
17-Nov-08 elcncf1i  elcncf1ii
17-Nov-08 elfzel2   elfzel2i
17-Nov-08 elrpi     elrpii
17-Nov-08 eluz1     eluz1i
17-Nov-08 eluzaddi  eluzaddii
17-Nov-08 eluzsubi  eluzsubii
17-Nov-08 eqle      eqlei
17-Nov-08 eqneg     eqnegi
17-Nov-08 expcnv    expcnvi
17-Nov-08 fnsmnt    fnsmnti
17-Nov-08 fseqsupub fseqsupubi
17-Nov-08 fsum1     fsum1i
17-Nov-08 fsum1f    fsum1fi
17-Nov-08 fsum2     fsum2i
17-Nov-08 fsum3     fsum3i
17-Nov-08 fsum4     fsum4i
17-Nov-08 fsump1    fsump1i
17-Nov-08 fsump1f   fsump1fi
17-Nov-08 fsumser0f fsumser0fi
17-Nov-08 fsumser1f fsumser1fi
17-Nov-08 fsumserz  fsumserzi
17-Nov-08 fsumserz2 fsumserz2i
17-Nov-08 fsumserzf fsumserzfi
17-Nov-08 fzelp1    fzelp1i
17-Nov-08 geoser    geoseri
17-Nov-08 geosum    geosumi
17-Nov-08 gt0ne0    gt0ne0i
17-Nov-08 gt0ne0i   gt0ne0ii
17-Nov-08 halfpos   halfposi
17-Nov-08 hbneg     hbnegi
17-Nov-08 hbnegd    hbnegdi
17-Nov-08 hbsum     hbsumi
17-Nov-08 hbsum1    hbsum1i
17-Nov-08 icoshftf1oi icoshftf1oii
17-Nov-08 imadd     imaddi
17-Nov-08 imcj      imcji
17-Nov-08 imcl      imcli
17-Nov-08 immul     immuli
17-Nov-08 imneg     imnegi
17-Nov-08 infcvg    infcvgi
17-Nov-08 infcvgaux1 infcvgaux1i
17-Nov-08 infcvgaux2 infcvgaux2i
17-Nov-08 ipcn      ipcni
17-Nov-08 iserzabs  iserzabsi
17-Nov-08 iserzcmp  iserzcmpi
17-Nov-08 iserzcmp0 iserzcmp0i
17-Nov-08 iserzex   iserzexi
17-Nov-08 iserzext  iserzexti
17-Nov-08 iserzgt0  iserzgt0i
17-Nov-08 iserzmulc1 iserzmulc1i
17-Nov-08 iserzshft iserzshfti
17-Nov-08 iserzshft2 iserzshft2i
17-Nov-08 isum0split isum0spliti
17-Nov-08 isum1clim isum1climi
17-Nov-08 isum1p    isum1pi
17-Nov-08 isumclim2t isumclim2ti
17-Nov-08 isumclim2tf isumclim2tfi
17-Nov-08 isumclim3t isumclim3ti
17-Nov-08 isumclim4t isumclim4ti
17-Nov-08 isumclim5t isumclim5ti
17-Nov-08 isumclimt isumclimti
17-Nov-08 isumclimtf isumclimtfi
17-Nov-08 isumclt   isumclti
17-Nov-08 isumcmpi  isumcmpii
17-Nov-08 isummulc1 isummulc1i
17-Nov-08 isummulc1ALT isummulc1iALT
17-Nov-08 isummulc1a isummulc1ai
17-Nov-08 isumnn0nn isumnn0nni
17-Nov-08 isumnn0nna isumnn0nnai
17-Nov-08 isumnul   isumnuli
17-Nov-08 isumreclt isumreclti
17-Nov-08 isumshft  isumshfti
17-Nov-08 isumshft2 isumshft2i
17-Nov-08 isumsplit isumspliti
17-Nov-08 isumval2t isumval2ti
17-Nov-08 isumvalt  isumvalti
17-Nov-08 isumvaltf isumvaltfi
17-Nov-08 isupivth  isupivthi
17-Nov-08 le2add    le2addi
17-Nov-08 le2msq    le2msqi
17-Nov-08 le2sq     le2sqi
17-Nov-08 le2tri3   le2tri3i
17-Nov-08 leabs     leabsi
17-Nov-08 leadd1    leadd1i
17-Nov-08 leadd2    leadd2i
17-Nov-08 lecase    lecasei
17-Nov-08 ledivp1   ledivp1i
17-Nov-08 leid      leidi
17-Nov-08 leloe     leloei
17-Nov-08 lelttr    lelttri
17-Nov-08 lelttrd   lelttrdi
17-Nov-08 lemul1    lemul1i
17-Nov-08 lemul2    lemul2i
17-Nov-08 leneg     lenegi
17-Nov-08 lenegcon1 lenegcon1i
17-Nov-08 lenlt     lenlti
17-Nov-08 lerec     lereci
17-Nov-08 lesub0    lesub0i
17-Nov-08 lesubadd  lesubaddi
17-Nov-08 lesubadd2 lesubadd2i
17-Nov-08 letr      letri
17-Nov-08 letrd     letrdi
17-Nov-08 letri     letrii
17-Nov-08 letri3    letri3i
17-Nov-08 lt2add    lt2addi
17-Nov-08 lt2msq    lt2msqi
17-Nov-08 lt2sq     lt2sqi
17-Nov-08 ltadd1    ltadd1i
17-Nov-08 ltadd2    ltadd2i
17-Nov-08 ltaddpos  ltaddposi
17-Nov-08 ltaddsub  ltaddsubi
17-Nov-08 ltdiv1    ltdiv1i
17-Nov-08 ltdiv1i   ltdiv1ii
17-Nov-08 ltdiv23   ltdiv23i
17-Nov-08 ltdiv23i  ltdiv23ii
17-Nov-08 ltdivp1   ltdivp1i
17-Nov-08 ltle      ltlei
17-Nov-08 ltlei     ltleii
17-Nov-08 ltlen     ltleni
17-Nov-08 ltletr    ltletri
17-Nov-08 ltletrd   ltletrdi
17-Nov-08 ltmul1    ltmul1i
17-Nov-08 ltmul1i   ltmul1ii
17-Nov-08 ltmul2    ltmul2i
17-Nov-08 ltmuldiv  ltmuldivi
17-Nov-08 ltne      ltnei
17-Nov-08 ltneg     ltnegi
17-Nov-08 ltnegcon1 ltnegcon1i
17-Nov-08 ltnegcon2 ltnegcon2i
17-Nov-08 ltnle     ltnlei
17-Nov-08 ltnr      ltnri
17-Nov-08 ltnsym    ltnsymi
17-Nov-08 ltp1      ltp1i
17-Nov-08 ltrec     ltreci
17-Nov-08 ltreci    ltrecii
17-Nov-08 ltsubadd  ltsubaddi
17-Nov-08 ltsubadd2 ltsubadd2i
17-Nov-08 lttr      lttri
17-Nov-08 lttrd     lttrdi
17-Nov-08 lttri2    lttri2i
17-Nov-08 lttri3    lttri3i
17-Nov-08 msq0      msq0i
17-Nov-08 msq11     msq11i
17-Nov-08 msqge0    msqge0i
17-Nov-08 msqgt0    msqgt0i
17-Nov-08 mul01     mul01i
17-Nov-08 mul02     mul02i
17-Nov-08 mul0or    mul0ori
17-Nov-08 mul12     mul12i
17-Nov-08 mul23     mul23i
17-Nov-08 mul2neg   mul2negi
17-Nov-08 mul4      mul4i
17-Nov-08 muladd    muladdi
17-Nov-08 mulass    mulassi
17-Nov-08 mulcan    mulcani
17-Nov-08 mulcant2  mulcant2i
17-Nov-08 mulcl     mulcli
17-Nov-08 mulcom    mulcomi
17-Nov-08 mulge0    mulge0i
17-Nov-08 mulgt0    mulgt0i
17-Nov-08 mulgt0i   mulgt0ii
17-Nov-08 mulid1    mulid1i
17-Nov-08 mulid2    mulid2i
17-Nov-08 mulm1     mulm1i
17-Nov-08 muln0     mulne0i
17-Nov-08 mulneg1   mulneg1i
17-Nov-08 mulneg2   mulneg2i
17-Nov-08 neg11     neg11i
17-Nov-08 negcl     negcli
17-Nov-08 negcon1   negcon1i
17-Nov-08 negcon2   negcon2i
17-Nov-08 negdi     negdii
17-Nov-08 negeu     negeui
17-Nov-08 negfcncf  negfcncfi
17-Nov-08 negid     negidi
17-Nov-08 negn0     negn0i
17-Nov-08 negne0    negne0i
17-Nov-08 negneg    negnegi
17-Nov-08 negreb    negrebi
17-Nov-08 negsub    negsubi
17-Nov-08 negsubdi  negsubdii
17-Nov-08 negsubdi2 negsubdi2i
17-Nov-08 nn0addcl  nn0addcli
17-Nov-08 nn0addge1 nn0addge1i
17-Nov-08 nn0addge2 nn0addge2i
17-Nov-08 nn0cn     nn0cni
17-Nov-08 nn0ge0    nn0ge0i
17-Nov-08 nn0le2msqt nn0le2msqti
17-Nov-08 nn0le2x   nn0le2xi
17-Nov-08 nn0lele2x nn0lele2xi
17-Nov-08 nn0mulcl  nn0mulcli
17-Nov-08 nn0opth   nn0opthi
17-Nov-08 nn0opth2  nn0opth2i
17-Nov-08 nn0re     nn0rei
17-Nov-08 nncn      nncni
17-Nov-08 nneo      nneoi
17-Nov-08 nnesq     nnesqi
17-Nov-08 nngt0     nngt0i
17-Nov-08 nnlesq    nnlesqi
17-Nov-08 nnne0     nnne0i
17-Nov-08 nnnn0     nnnn0i
17-Nov-08 nnre      nnrei
17-Nov-08 nnsqcl    nnsqcli
17-Nov-08 nnsub     nnsubi
17-Nov-08 om2uz0    om2uz0i
17-Nov-08 om2uzf1o  om2uzf1oi
17-Nov-08 om2uziso  om2uzisoi
17-Nov-08 om2uzlt   om2uzlti
17-Nov-08 om2uzlt2  om2uzlt2i
17-Nov-08 om2uzran  om2uzrani
17-Nov-08 om2uzsuc  om2uzsuci
17-Nov-08 om2uzuz   om2uzuzi
17-Nov-08 peano2zd  peano2zd
17-Nov-08 peano5nn  peano5nni
17-Nov-08 peano5uz  peano5uzi
17-Nov-08 peano5uzt peano5uzti
17-Nov-08 pm2.61ltle ltlecasei
17-Nov-08 pncan3    pncan3i
17-Nov-08 pnncan    pnncani
17-Nov-08 posdif    posdifi
17-Nov-08 posex     posexi
17-Nov-08 prodge0   prodge0i
17-Nov-08 prodgt0   prodgt0i
17-Nov-08 readd     readdi
17-Nov-08 readdcl   readdcli
17-Nov-08 rec11     rec11i
17-Nov-08 rec11i    rec11ii
17-Nov-08 reccl     reccli
17-Nov-08 recclz    recclzi
17-Nov-08 reccnv    reccnvi
17-Nov-08 receu     receui
17-Nov-08 recex     recexi
17-Nov-08 recgt0    recgt0i
17-Nov-08 recgt0i   recgt0ii
17-Nov-08 recid     recidi
17-Nov-08 recidz    recidzi
17-Nov-08 recj      recji
17-Nov-08 recl      recli
17-Nov-08 recn      recni
17-Nov-08 recnd     recndi
17-Nov-08 recne0z   recne0zi
17-Nov-08 recrec    recreci
17-Nov-08 recvalz   recvalzi
17-Nov-08 redivcl   redivcli
17-Nov-08 redivclz  redivclzi
17-Nov-08 reef11    reef11i
17-Nov-08 reefcl    reefcli
17-Nov-08 reeftlclt reeftlclti
17-Nov-08 reim0b    reim0bi
17-Nov-08 releabs   releabsi
17-Nov-08 remul     remuli
17-Nov-08 remulcl   remulcli
17-Nov-08 reneg     renegi
17-Nov-08 renegcl   renegcli
17-Nov-08 replim    replimi
17-Nov-08 rereb     rerebi
17-Nov-08 rereccl   rereccli
17-Nov-08 rerecclz  rerecclzi
17-Nov-08 resqcl    resqcli
17-Nov-08 resubcl   resubcli
17-Nov-08 reuunineg reuunineg
17-Nov-08 seq00     seq00i
17-Nov-08 seq01     seq01i
17-Nov-08 seq0fn    seq0fni
17-Nov-08 seq0fval  seq0fvali
17-Nov-08 seq0p1    seq0p1i
17-Nov-08 seq0seqz  seq0seqzi
17-Nov-08 seq0valt  seq0valti
17-Nov-08 seq11     seq11i
17-Nov-08 seq1bnd   seq1bndi
17-Nov-08 seq1cl    seq1cli
17-Nov-08 seq1cl2   seq1cl2i
17-Nov-08 seq1f     seq1fi
17-Nov-08 seq1f2    seq1f2i
17-Nov-08 seq1fn    seq1fni
17-Nov-08 seq1m1    seq1m1i
17-Nov-08 seq1p1    seq1p1i
17-Nov-08 seq1res   seq1resi
17-Nov-08 seq1rn    seq1rni
17-Nov-08 seq1rn2   seq1rn2i
17-Nov-08 seq1rval  seq1rvali
17-Nov-08 seq1seq0  seq1seq0i
17-Nov-08 seq1seq02t seq1seq02ti
17-Nov-08 seq1seq0t seq1seq0ti
17-Nov-08 seq1seqz  seq1seqzi
17-Nov-08 seq1shftid seq1shftidi
17-Nov-08 seq1ub    seq1ubi
17-Nov-08 seq1val   seq1vali
17-Nov-08 seq1val2  seq1val2i
17-Nov-08 seqz1     seqz1i
17-Nov-08 seqzcl    seqzcli
17-Nov-08 seqzeq    seqzeqi
17-Nov-08 seqzfn    seqzfni
17-Nov-08 seqzfval  seqzfvali
17-Nov-08 seqzfval2 seqzfval2i
17-Nov-08 seqzfveq  seqzfveqi
17-Nov-08 seqzm1    seqzm1i
17-Nov-08 seqzp1    seqzp1i
17-Nov-08 seqzres   seqzresi
17-Nov-08 seqzres2  seqzres2i
17-Nov-08 seqzresval seqzresvali
17-Nov-08 seqzrn    seqzrni
17-Nov-08 seqzrn2   seqzrn2i
17-Nov-08 seqzval2t seqzval2ti
17-Nov-08 seqzvalt  seqzvalti
17-Nov-08 ser00     ser00i
17-Nov-08 ser0cj    ser0cji
17-Nov-08 ser0cl1   ser0cl1i
17-Nov-08 ser0clt   ser0clti
17-Nov-08 ser0f     ser0fi
17-Nov-08 ser0mulc  ser0mulci
17-Nov-08 ser0p1    ser0p1i
17-Nov-08 ser11     ser11i
17-Nov-08 ser1absdif ser1absdifi
17-Nov-08 ser1add   ser1addi
17-Nov-08 ser1add2  ser1add2i
17-Nov-08 ser1cl1   ser1cl1i
17-Nov-08 ser1cl2   ser1cl2i
17-Nov-08 ser1clt   ser1clti
17-Nov-08 ser1cmp   ser1cmpi
17-Nov-08 ser1cmp0  ser1cmp0i
17-Nov-08 ser1cmp2  ser1cmp2i
17-Nov-08 ser1const ser1consti
17-Nov-08 ser1f     ser1fi
17-Nov-08 ser1f0    ser1f0i
17-Nov-08 ser1f2    ser1f2i
17-Nov-08 ser1mono  ser1monoi
17-Nov-08 ser1mulc  ser1mulci
17-Nov-08 ser1p1    ser1p1i
17-Nov-08 ser1recl  ser1recli
17-Nov-08 ser1ref   ser1refi
17-Nov-08 ser1ser0  ser1ser0i
17-Nov-08 serz1p    serz1pi
17-Nov-08 serzcj    serzcji
17-Nov-08 serzcl1   serzcl1i
17-Nov-08 serzcl2t  serzcl2ti
17-Nov-08 serzclt   serzclti
17-Nov-08 serzcmp   serzcmpi
17-Nov-08 serzcmp0  serzcmp0i
17-Nov-08 serzf0    serzf0i
17-Nov-08 serzfsum  serzfsumi
17-Nov-08 serzim    serzimi
17-Nov-08 serzmulc  serzmulci
17-Nov-08 serzmulc1 serzmulc1i
17-Nov-08 serzre    serzrei
17-Nov-08 serzreclt serzreclti
17-Nov-08 serzref   serzrefi
17-Nov-08 serzsplit serzspliti
17-Nov-08 shftcan1t shftcan1ti
17-Nov-08 shftcan2t shftcan2ti
17-Nov-08 shftf     shftfi
17-Nov-08 shftfn    shftfni
17-Nov-08 shftfval  shftfvali
17-Nov-08 shftidt   shftidti
17-Nov-08 shftres   shftresi
17-Nov-08 shftresvalt shftresvalti
17-Nov-08 shftval2t shftval2ti
17-Nov-08 shftval3t shftval3ti
17-Nov-08 shftval4t shftval4ti
17-Nov-08 shftval5t shftval5ti
17-Nov-08 shftvalt  shftvalti
17-Nov-08 sinadd    sinaddi
17-Nov-08 sq11      sq11i
17-Nov-08 sqabsadd  sqabsaddi
17-Nov-08 sqabssub  sqabssubi
17-Nov-08 sqcl      sqcli
17-Nov-08 sqdiv     sqdivi
17-Nov-08 sqeq0     sqeq0i
17-Nov-08 sqeqor    sqeqori
17-Nov-08 sqge0     sqge0i
17-Nov-08 sqgt0     sqgt0i
17-Nov-08 sqmul     sqmuli
17-Nov-08 sqr11     sqr11i
17-Nov-08 sqrcl     sqrcli
17-Nov-08 sqreci    sqrecii
17-Nov-08 sqrge0    sqrge0i
17-Nov-08 sqrgt0    sqrgt0i
17-Nov-08 sqrgt0i   sqrgt0ii
17-Nov-08 sqrle     sqrlei
17-Nov-08 sqrlt     sqrlti
17-Nov-08 sqrmsq    sqrmsqi
17-Nov-08 sqrmsq2   sqrmsq2i
17-Nov-08 sqrmul    sqrmuli
17-Nov-08 sqrmuli   sqrmulii
17-Nov-08 sqrsq     sqrsqi
17-Nov-08 sqrth     sqrthi
17-Nov-08 sqsqr     sqsqri
17-Nov-08 sqval     sqvali
17-Nov-08 subadd    subaddi
17-Nov-08 subadd2   subadd2i
17-Nov-08 subaddri  subaddrii
17-Nov-08 subcan    subcani
17-Nov-08 subcan2   subcan2i
17-Nov-08 subcl     subcli
17-Nov-08 subdi     subdii
17-Nov-08 subdir    subdiri
17-Nov-08 subeq0    subeq0i
17-Nov-08 subge0    subge0i
17-Nov-08 subid     subidi
17-Nov-08 subid1    subid1i
17-Nov-08 subneg    subnegi
17-Nov-08 subsq     subsqi
17-Nov-08 subsq0    subsq0i
17-Nov-08 subsub23  subsub23i
17-Nov-08 sumsqne0  sumsqne0i
17-Nov-08 sup3i     sup3ii
17-Nov-08 suprcli   suprclii
17-Nov-08 suprleubi suprleubii
17-Nov-08 suprlubi  suprlubii
17-Nov-08 suprnubi  suprnubii
17-Nov-08 suprubi   suprubii
17-Nov-08 times2    times2i
17-Nov-08 uzinfm    uzinfmi
17-Nov-08 uzrdgfnuz uzrdgfnuzi
17-Nov-08 uzrdgini  uzrdginii
17-Nov-08 uzrdginip1 uzrdginip1i
17-Nov-08 uzrdgsuc  uzrdgsuci
17-Nov-08 uzrdgval  uzrdgvali
17-Nov-08 zre       zrei
17-Nov-08 abs3lem   abs3lemi
17-Nov-08 abs2difabs abs2difabsi
17-Nov-08 abs2dif   abs2difi
17-Nov-08 2basgent  2basgen
17-Nov-08 basgent   basgen
17-Nov-08 basgen2t  basgen2
17-Nov-08 tgss3t    tgss3
17-Nov-08 tgss2t    tgss2
17-Nov-08 tgsst     tgss
17-Nov-08 tgtop11t  tgtop11
17-Nov-08 bastopt   bastop
17-Nov-08 bastop    bastop1
17-Nov-08 tgidmt    tgidm
17-Nov-08 eltop3t   eltop3
17-Nov-08 eltop2t   eltop2
17-Nov-08 eltopt    eltop
17-Nov-08 tgtopt    tgtop
17-Nov-08 topbast   topbas
17-Nov-08 eltg3t    eltg3
17-Nov-08 tgval3t   tgval3
17-Nov-08 tgclt     tgcl
17-Nov-08 unitgt    unitg
17-Nov-08 bastgt    bastg
17-Nov-08 tg2t      tg2
17-Nov-08 tg1t      tg1
17-Nov-08 eltg2t    eltg2
17-Nov-08 eltgt     eltg
17-Nov-08 tgval2t   tgval2
17-Nov-08 tgvalt    tgval
17-Nov-08 basis2t   basis2
17-Nov-08 basis1t   basis1
17-Nov-08 0opnt     0opn
17-Nov-08 inopnt    inopn
17-Nov-08 iunopnt   iunopn
17-Nov-08 uniopnt   uniopn
17-Nov-08 uniopn    uniopn2
17-Nov-08 entrt     entr
17-Nov-08 entr4     entr4i
17-Nov-08 entr3     entr3i
17-Nov-08 entr2     entr2i
17-Nov-08 entr      entri
17-Nov-08 entri     entric
17-Nov-08 rdglimt   rdglim
17-Nov-08 onelpsst  onelpss
17-Nov-08 rdgsuct   rdgsuc
17-Nov-08 on0eqelt  on0eqel
17-Nov-08 onelsst   onelss
17-Nov-08 onsst     onss
17-Nov-08 rdglim    rdglimi
17-Nov-08 rdgsuc    rdgsuci
17-Nov-08 nnon      nnoni
17-Nov-08 onsucss   onsucssi
17-Nov-08 onun      onun2i
17-Nov-08 onssel    onsseli
17-Nov-08 onuninsuc onuninsuci
17-Nov-08 onuniorsuc onuniorsuci
17-Nov-08 onunisuc  onunisuci
17-Nov-08 onsuc     onsuci
17-Nov-08 onelun    oneluni
17-Nov-08 onelin    onelini
17-Nov-08 onssneli2 onssnel2i
17-Nov-08 onelss    onelssi
17-Nov-08 onss      onssi
17-Nov-08 onel      oneli
17-Nov-08 onirr     onirri
17-Nov-08 ontrc     ontrci
17-Nov-08 onord     onordi
17-Nov-08 ---       ---         The *tr inferences were changed to *tri,
17-Nov-08 ---       ---         for consistency with *tr*d
17-Nov-08 bitr      bitri
17-Nov-08 bitr2     bitr2i
17-Nov-08 bitr3     bitr3i
17-Nov-08 bitr4     bitr4i
17-Nov-08 3bitr     3bitri
17-Nov-08 3bitrr    3bitrri
17-Nov-08 3bitr2    3bitr2i
17-Nov-08 3bitr3    3bitr3i
17-Nov-08 3bitr4    3bitr4i
17-Nov-08 3imtr3    3imtr3i
17-Nov-08 3imtr4    3imtr4i
17-Nov-08 eqtr      eqtri
17-Nov-08 eqtr2     eqtr2i
17-Nov-08 eqtr3     eqtr3i
17-Nov-08 eqtr4     eqtr4i
17-Nov-08 3eqtr     3eqtri
17-Nov-08 3eqtrr    3eqtrri
17-Nov-08 3eqtr2    3eqtr2i
17-Nov-08 3eqtr3    3eqtr3i
17-Nov-08 3eqtr4    3eqtr4i
17-Nov-08 eq2tr     eq2tri
17-Nov-08 eqeltr    eqeltri
17-Nov-08 eqeltrr   eqeltrri
17-Nov-08 eleqtr    eleqtri
17-Nov-08 eleqtrr   eleqtrri
17-Nov-08 eqsstr    eqsstri
17-Nov-08 eqsstr3   eqsstr3i
17-Nov-08 sseqtr    sseqtri
17-Nov-08 sseqtr4   sseqtr4i
17-Nov-08 3sstr3    3sstr3i
17-Nov-08 3sstr4    3sstr4i
17-Nov-08 eqbrtr    eqbrtri
17-Nov-08 eqbrtrr   eqbrtrri
17-Nov-08 breqtr    breqtri
17-Nov-08 breqtrr   breqtrri
17-Nov-08 3brtr3    3brtr3i
17-Nov-08 3brtr4    3brtr4i
16-Nov-08 opabsb    opelopabsb
14-Nov-08 zfext2    axext3
14-Nov-08 axext     axext2
14-Nov-08 nega      notnot2
14-Nov-08 negai     notnotri
14-Nov-08 negb      notnot1
14-Nov-08 negbi     notnoti
14-Nov-08 negbii    notbii
14-Nov-08 negbid    notbid
14-Nov-08 pm4.13    notnot
14-Nov-08 pm4.11    notbi
11-Nov-08 divmul3t  [--same--]  rearranged antecedent; renamed variables
11-Nov-08 divmul2t  [--same--]  rearranged antecedent; renamed variables
11-Nov-08 divmult   [--same--]  rearranged antecedent; renamed variables
11-Nov-08 elqsi     [--same--]  changed E. x ( x e. A /\ ...  to E. x e. A ...
11-Nov-08 elqs      [--same--]  changed E. x ( x e. A /\ ...  to E. x e. A ...
 8-Nov-08 indistop  [--same--]  eliminated hypothesis A e. _V
 8-Nov-08 pri2      prid2
 8-Nov-08 pri1      prid1
 7-Nov-08 qdivclt   [--same--]  antecedent changed to use triple conjunction
 6-Nov-08 rcfpfil   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem6 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem5 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem4 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem3 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem2 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 rcfpfillem1 [--same--] changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fisub     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 filint2   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 efilcp    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fgsb      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fipfil2   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 sppfi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fiv       [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 df-fi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 0fin     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 ficli     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fiiu      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 abfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fine      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 infi1     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 spfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fctop     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 subbas2   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 subbas    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 istps5    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 istps4    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 istop2g   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 isfinite  [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 pwfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 pwfilem   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 iunfi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fofi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fodomfib  [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 fodomfi   [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 abfii5    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Nov-08 abfii4    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 isfinite1 [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 domfi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 unifi     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 abfii1    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 abfii2    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
31-Sep-08 abfii3    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
10-Sep-08 isfinite2 [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 9-Sep-08 fisucdom  [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 7-Sep-08 ominf     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Sep-08 onfin     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Sep-08 pssinf    {--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 6-Sep-08 divsubdirt [--same--] changed hyp. order
 3-Sep-08 php3      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 2-Sep-08 fiint     [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
 1-Sep-08 prfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
30-Aug-08 unfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
29-Aug-08 snfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
29-Aug-08 ssnnfi    [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
29-Aug-08 ssfi      [--same--]  changed "E. ... e. om ... ~~ ..." to "e. Fin"
24-Aug-08 mulcant   [--same--]  changed antecendent order; swapped var. names
24-Aug-08 mulcan2t  [--same--]  changed antecendent order; swapped var. names
24-Aug-08 mulcant2  [--same--]  changed hyp. order; swapped var. names
24-Aug-08 mulcan    [--same--]  changed hyp. order; swapped var. names
23-Aug-08 divcan4t  [--same--]  changed antecendent order; swapped var. names
23-Aug-08 divcan4z  [--same--]  changed hyp. order; swapped var. names
23-Aug-08 divcan3t  [--same--]  changed antecendent order; swapped var. names
23-Aug-08 divcan3z  [--same--]  changed hyp. order; swapped var. names
22-Aug-08 ssnn      ssnnfi
22-Aug-08 divcan4   [--same--]  changed hyp. order; swapped var. names
22-Aug-08 divcan3   [--same--]  changed hyp. order; swapped var. names
21-Aug-08 pm4.2i    biidd
21-Aug-08 divcan2t  [--same--]  changed antecendent order; swapped var. names
21-Aug-08 divcan2z  [--same--]  changed hyp. order; swapped var. names
20-Aug-08 divdirt   [--same--]  changed hyp. order
18-Aug-08 divcan2   [--same--]  changed hyp. order; swapped var. names
18-Aug-08 divcan1t  [--same--]  changed antecendent order; swapped var. names
18-Aug-08 divcan1z  [--same--]  changed hyp. order; swapped var. names
18-Aug-08 divcan1   [--same--]  changed hyp. order; swapped var. names
17-Aug-08 ltmuldiv2t [--same--] changed antecedent grouping
17-Aug-08 ltdivmult [--same--]  changed antecedent grouping
17-Aug-08 ledivmult [--same--]  changed antecedent grouping
17-Aug-08 ltdivmul2t [--same--] changed antecedent grouping
17-Aug-08 ledivmul2t [--same--] changed antecedent grouping
17-Aug-08 lemuldivt [--same--]  changed antecedent grouping
17-Aug-08 lemuldiv2t [--same--] changed antecedent grouping
16-Aug-08 ltmuldivt [--same--]  changed antecedent grouping
15-Aug-08 bii       dfbi1
15-Aug-08 biigb     dfbi1gb
15-Aug-08 bi        dfbi2
15-Aug-08 dfbi      dfbi3
14-Aug-08 lediv1t   [--same--]  changed antecedent grouping
14-Aug-08 ltdiv1t   [--same--]  changed antecedent grouping
10-Jul-08 expne0t   [--same--]  swapped biconditional
10-Jul-08 sq0t      sqeq0t
10-Jul-08 sq00      sqeq0
 7-Jul-08 syl3dan3  syld3an3
 7-Jul-08 syl3dan2  syld3an2
31-May-08 isnvi     [--same--]  eliminated hypotheses G e. V, S e. _V
31-May-08 isnvg     ---         obsolete; use isnv
31-May-08 isvcg     ---         obsolete; use isvc
31-May-08 ideq      [--same--]  eliminated hypothesis A e. _V
31-May-08 ideqg     [--same--]  eliminated first antecedent A e. C
28-May-08 opelxpex  ---         obsolete; use opelxp1
22-May-08 ax9a      ax9
22-May-08 ax9       ax9o
21-May-08 ax6-2     ax6
21-May-08 ax6-3     ax6o
21-May-08 ax-6      ax-6o
21-May-08 ax-5      ax-5o
17-May-08 ax-10     ax-10o
16-May-08 er2       dfer2
16-May-08 er2       dfer2
16-May-08 sb7       dfsb7
13-May-08 cla4e2v   cla42ev
13-May-08 cla4e2gv  cla42egv
12-May-08 a4w1      a4eiv
12-May-08 a4w       a4imev
12-May-08 a4c1      a4imed
12-May-08 a4c       a4ime
12-May-08 a4b1      a4v
12-May-08 a4b       a4imv
12-May-08 a4at      a4imt
12-May-08 a4a       a4im
11-May-08 sbea4     a4sbe
11-May-08 sbia4     a4sbim
11-May-08 sbba4     a4sbbi
 6-May-08 inf4      axinf2
 6-May-08 minfnre   mnfnre
27-Apr-08 sb6y      sb6f
27-Apr-08 sb5y      sb5f
17-Apr-08 sbn2      ---         obsolete; use sbn
17-Apr-08 sbn1      ---         obsolete; use sbn
 9-Apr-08 isvci     [--same--]  weakened hyp from G : ... to dom G = ...
 9-Apr-08 isabli    [--same--]  weakened hyp from G : ... to dom G = ...
 2-Apr-08 19.2      [--same--]  generalized to use 2 set variables
30-Mar-08 grprn     [--same--]  weakened hyp from G : ... to dom G = ...
11-Mar-08 absefimt  absefit
11-Mar-08 axcnre    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cnegexlem2 [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cnegext   [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 recextlem1 [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 recextlem2 [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 recext    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crulem    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cru       [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crut      [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crne0     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crmul     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crrecz    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 creur     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 creui     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 rimul     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 df-re     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 df-im     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 revalt    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 imvalt    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 replimt   [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 df-cj     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 cjvalt    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 replim    [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crret     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crimt     [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crre      [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 crim      [--same--]  changed 'x. i' to 'i x.'
11-Mar-08 efit4pt   efi4pt      changed 'x. i' to 'i x.'
10-Mar-08 fabex     [--same--]  added 3rd hypothesis
 6-Mar-08 pm2.36    [--same--]  corrected to match Principia Mathematica
 6-Mar-08 pm2.37    [--same--]  corrected to match Principia Mathematica
 6-Mar-08 pm2.38    [--same--]  corrected to match Principia Mathematica
 2-Mar-08 csbiet    csbiegft
 2-Mar-08 csbie2g   csbie2t
 2-Mar-08 vsbcint   sbhyp
 2-Mar-08 cbvsbcv   cbvralsv
 1-Mar-08 sbcrex    sbcrexg
 1-Mar-08 sbcral    sbcralg
 1-Mar-08 19.23g    19.23t
 1-Mar-08 19.21g    19.21t
 1-Mar-08 minusex   negex
 1-Mar-08 negext    cnegext
 1-Mar-08 negex     cnegex
29-Feb-08 hbneq     hbne
29-Feb-08 hbne      hbn
29-Feb-08 csbiet    csbiegft
29-Feb-08 sbciet    sbciegft
29-Feb-08 elabt     elabgt
29-Feb-08 vtoclefg  vtoclegft
23-Feb-08 sqdif0    subsq0
23-Feb-08 binom2a   ---         obsolete; use subsq
12-Feb-08 cnhl      [--same--]  added hypothesis to assign vector space to var
 9-Feb-08 oneirr    onirr
 9-Feb-08 ordeirr   ordirr
 9-Feb-08 eirr      elirr
 9-Feb-08 eirrv     elirrv
29-Jan-08 oibabs    [--same--]  swapped sides of biconditional
24-Jan-08 cos2t     ---         obsolete; use cos2tt
20-Jan-08 ffvrni    ffvelrni
20-Jan-08 ffvrn     ffvelrn
20-Jan-08 fnfvrn    fnfvelrn
20-Jan-08 fvrn      fvelrn
20-Jan-08 fvelrn    fvelrnb
18-Jan-08 arch      [--same--]  changed x to n, changing $f hypothesis order
18-Jan-08 cos1lem4  8th4div3
18-Jan-08 eftlex    ---         obsolete; use eftlext
18-Jan-08 sin2t     ---         obsolete; use sin2tt
15-Jan-08 explt1t   expord2t
15-Jan-08 eft0vallem eft0val
15-Jan-08 effsumlelem ---       obsolete; use reeftclt
15-Jan-08 eftvallem eftval
15-Jan-08 efpartex  eftlex
15-Jan-08 efcltlem4 efseq0ex
15-Jan-08 efcltlem2a ef0lem
15-Jan-08 dfef2lem  dfef2
15-Jan-08 efcltlem3 efseq1ex
15-Jan-08 eftcltlem eftclt
15-Jan-08 eftabslem eftabs
12-Jan-08 rgen2xxx  rgen2a
12-Jan-08 rgen2a    rgen2
12-Jan-08 rgen2     rgen2xxx
12-Jan-08 cnbn      [--same--]  added hypothesis to assign vector space to var
12-Jan-08 cnph      [--same--]  added hypothesis to assign vector space to var
12-Jan-08 cnims     [--same--]  reorganized hypotheses and conclusion
14-Jan-08 rgen3     [--same--]  generalized for 3 different class variables
12-Jan-08 cnnv      [--same--]  added hypothesis to assign vector space to var
10-Jan-08 zneo      [--same--]  changed -. ... = to =/=
 3-Jan-08 ax7-467   ax467to7
 3-Jan-08 ax6-467   ax467to6
 3-Jan-08 ax4-467   ax467to4
 3-Jan-08 ax6-67    ax67to6
 3-Jan-08 ax7-67    ax67to7
 3-Jan-08 ax4-46    ax46to4
 3-Jan-08 ax5-46    ax46to5
29-Dec-07 eftvallem [--same--]  added hypothesis
22-Dec-07 zfnuleu   [--same--]  added $e hypothesis to remove ax-nul dependency
 8-Dec-07 supxrre2  [--same--]  changed -. ... = to =/=
23-Nov-07 sub4      addsub4
23-Nov-07 sub4t     addsub4t
17-Nov-07 climres   [--same--]  generalized antecedent from A e. CC to A e. B
12-Nov-07 climle    climcmp
11-Nov-07 eqneqi    necon3bii
11-Nov-07 eqneqd    necon3bid
10-Nov-07 ser0cj    [--same--]  weakened hypotheses
 9-Nov-07 ser1cj    ---         obsolete; derive from serzcj (as in ser0cj)
 9-Nov-07 ser0re    ---         obsolete; derive from serzre (as in ser0cj)
 9-Nov-07 ser1re    ---         obsolete; derive from serzre (as in ser0cj)
 8-Nov-07 mp3dan    mp3dan23
23-Oct-07 pm3.27bd  simprbi
23-Oct-07 pm3.26bd  simplbi
16-Oct-07 expbndt   expubndt
16-Oct-07 expge1t   [--same--]  strengthened from N e. NN to N e. NN0
12-Oct-07 kmlem15   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem14   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem13   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem10   [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem9    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem7    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem5    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem4    [--same--]  changed -. ... = to =/=
12-Oct-07 kmlem3    [--same--]  changed -. ... = to =/=
 5-Oct-07 1open     topopn
 5-Oct-07 1clsd     topcld
 3-Oct-07 intss3    ntrss3
 2-Oct-07 isopen3   isopn3
 2-Oct-07 isopen2   isopn2
 2-Oct-07 cmclsopen cmclsopn
 2-Oct-07 snclsd    sncld
 2-Oct-07 clsdlp    cldlp
 2-Oct-07 isclsd3   iscld3
 2-Oct-07 cmntrclsd cmntrcld
 2-Oct-07 clsclsd   clscld
 2-Oct-07 clsdcls   cldcls
 2-Oct-07 unclsd    uncld
 2-Oct-07 intclsd   intcld
 2-Oct-07 iinclsd   iincld
 2-Oct-07 0clsd     0cld
 2-Oct-07 openclsd  opncld
 2-Oct-07 clsdopen  cldopn
 2-Oct-07 clsdss    cldss
 2-Oct-07 isclsd2   iscld2
 2-Oct-07 isclsd    iscld
 2-Oct-07 clsdval   cldval
 2-Oct-07 df-clsd   df-cld
 2-Oct-07 isopn2    isopn4
28-Sep-07 ---       ---         changed math symbol from "floor" to "|_"
26-Sep-07 ser0cl    ser0cl1
26-Sep-07 ser1cl    ser1cl1
25-Sep-07 ser1re2   ser1re
25-Sep-07 ser1re    ser1ref
23-Sep-07 df-fac    [--same--]  swapped arguments of union
23-Sep-07 seqzrnx   seqzrn
23-Sep-07 seqzrn    seqzrn2
23-Sep-07 seqzrn2   seqzrnx
23-Sep-07 seq1rnx   seq1rn
23-Sep-07 seq1rn    seq1rn2
23-Sep-07 seq1rn2   seq1rnx
17-Sep-07 pm2.21nd  pm2.24d
17-Sep-07 pm2.21ni  pm2.24i
16-Sep-07 dvelimf2  dvelimfALT
 8-Sep-07 lemul2it  [--same--]  rearranged antecedent
 8-Sep-07 lemul1it  [--same--]  rearranged antecedent
 7-Sep-07 0vval     0vfval
 4-Sep-07 ---       ---         Many changes after df-ms, described in the
                                  4-Sep-2007 entry of
                                  us.metamath.org/mpeuni/mmnotes.txt
 4-Sep-07 elssab    ---         obsolete; use elssabg
 4-Sep-07 nvc       nvvc
 4-Sep-07 ---       ---         changed math symbol from "Met" to "MetSp"
 4-Sep-07 ---       ---         changed math symbol from "CMet" to "CMetSp"
25-Aug-07 fopabco   fopabcos
21-Aug-07 xrltnet   [--same--]  changed -. A = B to B =/= A; triple conjunction
21-Aug-07 lttri2    [--same--]  changed -. A = B to A =/= B
21-Aug-07 lttri2t   [--same--]  changed -. A = B to A =/= B
15-Aug-07 sbccsbg   sbccsb2g
11-Aug-07 recdivt   [--same--]  rearranged antecedent
 9-Aug-07 funopabex2g opabex2g
 9-Aug-07 funopabex2 opabex2
 9-Aug-07 funopabex opabex
 9-Aug-07 cnco      [--same--]  swapped 2nd & 3rd args in 1st triple conj
 6-Aug-07 ---       ---         changed "ncv" to "nv" in the labels of:
                                  cncv df-ncv ncvss ncvrel ncvop ncvvop
                                  isncvg isncvi ncvi ncvv ncvgcl
                                  ncvscl ncvf ncvcl ncvcli ncvdm ncvs
                                  ncvm1 ncvdif ncvpi ncvz0 ncvz ncvtri
                                  ncvabs ncvge0 cnncv cnncv0 elimncvu
                                  ncvnd phncv bnncv hlncv hilncv
 4-Aug-07 subval    ---         obsolete; use subvalt
31-Jul-07 divge0t   [--same--]  rearranged antecedent
31-Jul-07 divgt0t   [--same--]  rearranged antecedent
31-Jul-07 ltne      [--same--]  changed -. A = B to B =/= A
31-Jul-07 ltnet     [--same--]  changed -. A = B to B =/= A; triple conjunction
31-Jul-07 ltlen     [--same--]  changed -. A = B to B =/= A
31-Jul-07 ltlent    [--same--]  changed -. A = B to B =/= A
22-Jul-07 xrleltnet [--same--]  changed -. A = B to B =/= A
20-Jul-07 nngt1ne1t [--same--]  changed -. A = 1 to A =/= 1
18-Jul-07 leltnet   [--same--]  changed -. A = B to B =/= A
15-Ju1-07 zornx     zorn
15-Ju1-07 zorn      zorn2
15-Ju1-07 zorn2     zornx
18-Jun-07 caucvglem2 [--same--]  changed -. S = (/) to S =/= (/)
17-Jun-07 seq1ublem [--same--]  changed -. ... = (/) to =/= (/)
17-Jun-07 suppr     supexpr
17-Jun-07 ruclem33  [--same--]  changed -. ... = (/) to =/= (/)
16-Jun-07 ltrec1t   [--same--]  rearranged antecedent
15-Jun-07 lerec2t   [--same--]  rearranged antecedent
 3-Jun-07 nordeq    [--same--]  changed -. A = B to A =/= B
 3-Jun-07 xpsndisj  [--same--]  changed -. A = B to A =/= B
 2-Jun-07 peano3    [--same--]  changed -. A = (/) to A =/= (/)
 2-Jun-07 disjsn2   [--same--]  changed -. A = B to A =/= B
 2-Jun-07 fun2ssres [--same--]  antecedent changed to use triple conjunction
 2-Jun-07 onelpsst  [--same--]  changed -. A = B to A =/= B
 1-Jun-07 ordelssne [--same--]  changed -. A = B to A =/= B
 1-Jun-07 suprleubi [--same--]  changed -. A = (/) to A =/= (/)
31-May-07 suprnubi  [--same--]  changed -. A = (/) to A =/= (/)
30-Mar-07 onssmin   [--same--]  changed -. A = (/) to A =/= (/)
29-May-07 suprlub   [--same--]  changed -. A = (/) to A =/= (/)
29-May-07 funssfv   [--same--]  antecedent changed to use triple conjunction
29-May-07 limuni3   [--same--]  changed -. A = (/) to A =/= (/)
29-May-07 ordge1n0  [--same--]  changed -. A = (/) to A =/= (/)
28-May-07 onmindif2 [--same--]  changed -. A = (/) to A =/= (/)
28-May-07 suprleub  [--same--]  changed -. A = (/) to A =/= (/)
28-May-07 tz7.7     [--same--]  changed -. B = A to B =/= A
27-May-07 nnullss   [--same--]  changed -. ... = (/) to =/= (/)
27-May-07 supxrre2  [--same--]  changed -. A = (/) to A =/= (/)
27-May-07 fodomfib  [--same--]  changed -. A = (/) to A =/= (/)
26-May-07 supxrre1  [--same--]  changed -. A = (/) to A =/= (/)
24-May-07 supxrgtmnf [--same--]  changed -. A = (/) to A =/= (/)
23-May-07 ltmsqt    ---         obsolete; use msqgt0t
23-May-07 msqgt0    [--same--]  changed -. A = (/) to A =/= (/)
22-May-07 supxrbnd  [--same--]  changed -. A = (/) to A =/= (/)
21-May-07 suprnub   [--same--]  changed -. A = (/) to A =/= (/)
21-May-07 19.3r     ---         obsolete; use 19.3
21-May-07 19.9rv    ---         obsolete; use 19.9v
20-May-07 19.9r     ---         obsolete; use 19.9
17-May-07 iunn0     [--same--]  changed -. ... = (/) to =/= (/)
17-May-07 iinon     [--same--]  changed -. A = (/) to A =/= (/)
17-May-07 map0      [--same--]  changed -. B = (/) to B =/= (/)
16-May-07 infmrcl   [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprub    [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprcli   [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprubi   [--same--]  changed -. A = (/) to A =/= (/)
16-May-07 suprlubi  [--same--]  changed -. A = (/) to A =/= (/)
14-May-07 sup3i     [--same--]  changed -. A = (/) to A =/= (/)
13-May-07 kmlemxx   kmlem8      changed -. ... = (/) to =/= (/)
13-May-07 kmlem8    kmlem9
13-May-07 kmlem9    kmlem10
13-May-07 kmlem10   kmlem11
13-May-07 kmlem11   kmlem12     changed -. ... = to =/=
13-May-07 kmlem12   kmlem13     changed -. ... = to =/=
13-May-07 kmlem13   kmlemxx
13-May-07 supxrre   [--same--]  changed -. A = (/) to A =/= (/)
13-May-07 infmsup   [--same--]  changed -. A = (/) to A =/= (/)
13-May-07 suprcl    [--same--]  changed -. A = (/) to A =/= (/)
12-May-07 kmlem1    [--same--]  changed -. ... = to =/=
12-May-07 kmlem3    [--same--]  changed -. ... = to =/=
12-May-07 kmlem6    [--same--]  changed -. ... = to =/=
12-May-07 kmlem7    [--same--]  changed -. ... = to =/=
11-May-07 infm3     [--same--]  changed -. A = (/) to A =/= (/)
11-May-07 sup3      [--same--]  changed -. A = (/) to A =/= (/)
10-May-07 oneqmin   [--same--]  changed -. B = (/) to B =/= (/)
10-May-07 infmssuzcl [--same--]  changed -. S = (/) to S =/= (/)
 5-May-07 xpexr2    [--same--]  changed -. ... = (/) to =/= (/)
 5-May-07 tz7.49c   [--same--]  changed -. ... = to =/=
 4-May-07 tz7.49    [--same--]  changed -. ... = to =/=
 4-May-07 funimass2 [--same--]  conjoined antecedents in hypothesis
 3-May-07 ac4c      [--same--]  changed -. x = (/) to x =/= (/)
30-Apr-07 aceq6b    [--same--]  changed -. z = (/) to z =/= (/)
30-Apr-07 disjpss   [--same--]  changed -. B = (/) to B =/= (/)
30-Apr-07 infxpidmlem10 [--same--]  changed -. g = (/) to g =/= (/)
30-Apr-07 1ne0      [--same--]  changed -. 1o = (/) to 1o =/= (/)
30-Apr-07 ac5b      [--same--]  changed -. x = (/) to x =/= (/)
30-Apr-07 aceq6a    [--same--]  changed -. z = (/) to z =/= (/)
30-Apr-07 on0eln0   [--same--]  changed -. A = (/) to A =/= (/)
28-Apr-07 tz7.2     [--same--]  changed -. B = A to B =/= A; triple conjunction
25-Apr-07 ac5       [--same--]  changed -. x = (/) to x =/= (/)
23-Apr-07 ac4       [--same--]  changed -. z = (/) to z =/= (/)
22-Apr-07 ac8       [--same--]  changed -. ... = to =/=
22-Apr-07 uzwo2     [--same--]  changed -. S = (/) to S =/= (/)
21-Apr-07 aceq5     [--same--]  changed -. ... = to =/=
21-Apr-07 epfrc     [--same--]  -. B = (/) to B =/= (/); triple conjunction
20-Apr-07 dfepfr    [--same--]  changed -. x = (/) to x =/= (/)
19-Apr-07 xpnz      [--same--]  changed -. ... = (/) to =/= (/)
18-Apr-07 ltexprlem1 [--same--]  changed -. C = (/) to C =/= (/)
17-Apr-07 uzwo      [--same--]  changed -. S = (/) to S =/= (/)
17-Apr-07 aceq4     [--same--]  changed -. z = (/) to z =/= (/)
17-Apr-07 prn0      [--same--]  changed -. A = (/) to A =/= (/)
15-Apr-07 elni      [--same--]  changed -. A = (/) to A =/= (/)
14-Apr-07 aceq3lem  [--same--]  changed -. z = (/) to z =/= (/)
14-Apr-07 aceq3     [--same--]  changed -. z = (/) to z =/= (/)
13-Apr-07 tpnz      [--same--]  changed -. ... = (/) to =/= (/)
13-Apr-07 0nep0     [--same--]  changed -. (/) = { (/) } to (/) =/= { (/) }
12-Apr-07 1cn       ax1cn
12-Apr-07 ax1re     1re
11-Apr-07 zfreg     [--same--]  changed -. A = (/) to A =/= (/)
11-Apr-07 zfreg2    [--same--]  changed -. A = (/) to A =/= (/)
11-Apr-07 inf1      [--same--]  changed -. x = (/) to x =/= (/)
11-Apr-07 inf2      [--same--]  changed -. x = (/) to x =/= (/)
11-Apr-07 zorn2lem6  [--same--]  changed -. H = (/) to H =/= (/)
11-Apr-07 zorn2lem5  [--same--]  changed -. H = (/) to H =/= (/)
11-Apr-07 zorn2lem3  [--same--]  changed -. D = (/) to D =/= (/)
11-Apr-07 zorn2lem2  [--same--]  changed -. D = (/) to D =/= (/)
11-Apr-07 zorn2lem1  [--same--]  changed -. D = (/) to D =/= (/)
11-Apr-07 inf3lem2  [--same--]  changed -. ... = to =/=
11-Apr-07 inf3lem3  [--same--]  changed -. ... = to =/=
11-Apr-07 inf3lem4  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3lem5  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3lem6  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3lem7  [--same--]  changed -. -. x = (/) to x =/= (/)
11-Apr-07 inf3      [--same--]  changed -. -. x = (/) to x =/= (/)
10-Apr-07 htalem    [--same--]  changed -. A = (/) to A =/= (/)
 9-Apr-07 ac3       [--same--]  changed -. z = (/) to z =/= (/)
 9-Apr-07 rnxp      [--same--]  changed -. A = (/) to A =/= (/)
 7-Apr-07 aceq2     [--same--]  changed -. z = (/) to z =/= (/)
 6-Apr-07 tz6.12i   [--same--]  changed -. B = (/) to B =/= (/)
 6-Apr-07 scott0s   [--same--]  changed -. .. = (/) to =/= { (/) }
 6-Apr-07 dmxp      [--same--]  changed -. A = (/) to A =/= (/)
 6-Apr-07 nnsuc     [--same--]  changed -. A = (/) to A =/= (/)
 5-Apr-07 onne0     [--same--]  changed -. On = (/) to On =/= (/)
 5-Apr-07 ord0eln0  [--same--]  changed -. A = (/) to A =/= (/)
 5-Apr-07 wereu     [--same--]  -. B = (/) to B =/= (/); triple conjunction
 3-Apr-07 aceq5lem5 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 aceq5lem4 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 aceq5lem3 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 aceq5lem2 [--same--]  changed -. u = (/) to u =/= (/)
 3-Apr-07 pssdifn0  [--same--]  changed -. ... = to =/=
 3-Apr-07 fri       [--same--]  changed -. ... = (/) to ... =/= (/)
 2-Apr-07 cplem1    [--same--]  changed -. ... = (/) to =/= (/)
 2-Apr-07 cplem2    [--same--]  changed -. ... = (/) to =/= (/)
 2-Apr-07 0pss      [--same--]  changed -. A = (/) to A =/= (/)
 2-Apr-07 inelcm    [--same--]  changed -. ... = (/) to =/= (/)
 2-Apr-07 snnz      [--same--]  changed -. A = (/) to A =/= (/)
 2-Apr-07 inf0      [--same--]  changed conclusion to match ax-inf exactly
 2-Apr-07 n0f       ---         obsolete; use n0f
26-Mar-07 df-lim    [--same--]  changed -. A = (/) to A =/= (/)
26-Mar-07 pwen      [--same--]  eliminated redundant hypotheses
26-Mar-07 ssundif   undif
23-Mar-07 fo2       dffo2
23-Mar-07 fofv      dffo3
22-Mar-07 fnbr      [--same--]  eliminated redundant hypotheses
22-Mar-07 fnop      [--same--]  eliminated redundant hypotheses
21-Mar-07 kardex    [--same--]  eliminated redundant hypothesis
21-Mar-07 qsid      [--same--]  eliminated redundant hypothesis
21-Mar-07 0nelqs    [--same--]  eliminated redundant hypothesis
21-Mar-07 brecop2   [--same--]  eliminated redundant hypothesis
21-Mar-07 ecelqsdm  [--same--]  eliminated redundant hypothesis
18-Mar-07 map0b     [--same--]  changed -. A = (/) to A =/= (/)
17-Mar-07 oninton   [--same--]  changed -. A = (/) to A =/= (/)
17-Mar-07 wefrc     [--same--]  -. B = (/) to B =/= (/); triple conjunction
17-Mar-07 onint     [--same--]  changed -. A = (/) to A =/= (/)
17-Mar-07 tz7.5     [--same--]  -. B = (/) to B =/= (/); triple conjunction
17-Mar-07 fiint     [--same--]  changed -. x = (/) to x =/= (/)
16-Mar-07 ishlg     [--same--]  changed hypothesis from X = dom N to X = ran G
16-Mar-07 unitopt   ---         obsolete; use topopn
16-Mar-07 peano3nn0 nn0p1nnt
15-Mar-07 intex     [--same--]  changed -. A = (/) to A =/= (/)
 4-Mar-07 opthreg   [--same--]  added converse:  ->  to  <->
15-Feb-07 qbtwnre   [--same--]  antecedent changed to use triple conjunction
13-Feb-07 rcla42ev  [--same--]  antecedent changed to use triple conjunction
10-Feb-07 fodomb    [--same--]  changed -. A = (/) to A =/= (/)
 7-Feb-07 rabbidv   [--same--]  conjoined antecedents in hypothesis
 5-Feb-07 equidALT  equid
 5-Feb-07 ax-11     ax-11o
 2-Feb-07 ax11a     ax11v
 1-Feb-07 frc       [--same--]  -. = (/) to =/= (/); conjoined antecedents
31-Jan-07 itimesi   ixi
31-Jan-07 isqm1     i2
30-Jan-07 dffr2     [--same--]  changed -. ... = (/) to ... =/= (/)
30-Jan-07 df-fr     [--same--]  changed -. ... = (/) to ... =/= (/)
30-Jan-07 f1oeng    [--same--]  conjoined antecedents
29-Jan-07 2sumeq2d  ---         obsolete; use 2sumeq2dv
29-Jan-07 sumeq12d  ---         obsolete; use sumeq12dv
29-Jan-07 sumeq12rd ---         obsolete; use sumeq12rdv
29-Jan-07 eval      [--same--]  ( 1 ^ k ) changed to 1
22-Jan-07 ax11el    [--same--]  generalized with less restrictive variables
18-Jan-07 climcvgc1 ---         obsolete; use clmi1
18-Jan-07 climcvg1  ---         obsolete; use clmi2
18-Jan-07 clim1     ---         obsolete; use clm2
18-Jan-07 clim1a    ---         obsolete; use clm3
18-Jan-07 clim2a    ---         obsolete; use clm2
18-Jan-07 clim2     ---         obsolete; use clm4
18-Jan-07 climcvg2  ---         obsolete; use clmi2
18-Jan-07 climcvg2z ---         obsolete; use clmi2
18-Jan-07 climcvgc2z ---        obsolete; use clmi1
18-Jan-07 climcvg2zb ---        obsolete; use clmi2
18-Jan-07 clim2az   ---         obsolete; use clm3
18-Jan-07 clim3az   ---         obsolete; use clm3
18-Jan-07 clim3a    ---         obsolete; use clm3
18-Jan-07 clim3     ---         obsolete; use clm4
18-Jan-07 clim3b    ---         obsolete; use clm2
18-Jan-07 climcvg3  ---         obsolete; use clmi2
18-Jan-07 climcvg3z ---         obsolete; use clmi2
18-Jan-07 clim4a    ---         obsolete; use clm3
18-Jan-07 clim4     ---         obsolete; use clm4
18-Jan-07 climcvg4  ---         obsolete; use clmi2
18-Jan-07 climcvgc4z ---        obsolete; use clmi1
18-Jan-07 climcvg4z ---         obsolete; use clmi2
18-Jan-07 clim0cvg4z ---        obsolete; use clm0i
18-Jan-07 climcvgc5z ---        obsolete; use clmi1
18-Jan-07 climcvg5z ---         obsolete; use clmi2
18-Jan-07 clim0cvg5z ---        obsolete; use clm0i
18-Jan-07 climnn0   ---         obsolete; use clm4
18-Jan-07 climnn    ---         obsolete; use clm4
18-Jan-07 clim0nn   ---         obsolete; use clm0
18-Jan-07 climcvgnn ---         obsolete; use clmi2
18-Jan-07 climcvgnn0 ---        obsolete; use clmi2
18-Jan-07 clim0cvgnn0 ---       obsolete; use clm0i
18-Jan-07 climcvg2nn0 ---       obsolete; use clmi2
18-Jan-07 clim0cvg2nn0 ---      obsolete; use clm0i
18-Jan-07 climnn0le ---         obsolete; use clm4le
18-Jan-07 clim0nn0le ---        obsolete; use clm4le and clm0
16-Jan-07 abn0      [--same--]  changed -. ... = (/) to ... =/= (/)
16-Jan-07 rabn0     [--same--]  changed -. ... = (/) to ... =/= (/)
16-Jan-07 nsuceq0   [--same--]  changed -. ... = (/) to ... =/= (/)
16-Jan-07 iin0      [--same--]  changed -. A = (/) to A =/= (/)
16-Jan-07 fint      [--same--]  changed -. B = (/) to B =/= (/)
14-Jan-07 clim3z    clm4at
12-Jan-07 climconst [--same--]  made M e. ZZ a hypothesis instead of antecedent
11-Jan-07 climres2  ---         obsolete; use climres
 4-Jan-07 iunconst  [--same--]  changed -. A = (/) to A =/= (/)
21-Dec-06 intssuni2 [--same--]  changed -. A = (/) to A =/= (/)
21-Dec-06 intssuni  [--same--]  changed -. A = (/) to A =/= (/)
21-Dec-06 prer2     preqr2
20-Dec-06 ccms      cnms
20-Dec-06 ccims     cnims
20-Dec-06 ccmsval   cnimsval
18-Dec-06 cvgannn   ---         obsolete; use cvganuz
18-Dec-06 cvgannn0  ---         obsolete; use cvganuz
14-Dec-06 cleqreli  eqrelriv
14-Dec-06 cleqrel   eqrel
12-Dec-06 rnco      rncoss
12-Dec-06 dmco      dmcoss
 5-Dec-06 r19.2z    [--same--]  -. A = (/) to A =/= (/); conjoined antecendents
24-Nov-06 infn0     [--same--]  changed -. A = (/) to A =/= (/)
24-Nov-06 0sdom     [--same--]  changed -. A = (/) to A =/= (/)
24-Nov-06 0sdomg    [--same--]  changed -. A = (/) to A =/= (/)
24-Nov-06 infxpabs  [--same--]  -. B = (/) to B =/= (/); use w3a for antec.
24-Nov-06 xpdom3    [--same--]  changed antecedent from -. B = (/) to B =/= (/)
14-Nov-06 zfnul     axnul
14-Nov-06 zfaus     axsep
28-Oct-06 inv       inv1
25-Oct-06 orcana    ---         obsolete; use pm5.6
10-Oct-06 oprec     [--same--]  changed order of $f hypotheses
10-Oct-06 ecoprdi   [--same--]  changed order of $f hypotheses
10-Oct-06 ecoprass  [--same--]  changed order of $f hypotheses
 9-Oct-06 unisseq   ---         obsolete; use unimax
 8-Oct-06 notzfaus  [--same--]  more meaningful first hypothesis
 8-Oct-06 intmin    [--same--]  swapped arguments of = sign
 8-Oct-06 intmin2   [--same--]  swapped arguments of = sign
 5-Oct-06 expcant   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 expsubt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 divexpt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 expwordit [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 explt1t   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 recexpt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 expordt   [--same--]  generalized antecedent from e. NN to e. NN0
 5-Oct-06 iineq2dv  [--same--]  conjoined antecedents in hypothesis
 5-Oct-06 iuneq2dv  [--same--]  conjoined antecedents in hypothesis
 5-Oct-06 r19.9rzv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.45zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.27zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.36zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 iindif2   [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.28zv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 5-Oct-06 r19.3rzv  [--same--]  changed antecedent from -. A = (/) to A =/= (/)
 2-Oct-06 phplem5   phplem4
 2-Oct-06 phplem4   phplem3
 2-Oct-06 phplem3   phplem2
 2-Oct-06 phplem2   phplem1
 2-Oct-06 phplem1   ---         obsolete; use difsnid
29-Sep-06 uniord    orduni
29-Sep-06 onunit    ssonuni
29-Sep-06 onuni     ssonunii
29-Sep-06 ac6s2     ac6s3
29-Sep-06 ac6c      ---         obsolete; use ac6s5
21-Sep-06 rankuni   rankuni2
20-Sep-06 npnz      [--same--]  strengthened by adding converse
20-Sep-06 onsucuni2 [--same--]  swapped arguments of = sign
19-Sep-06 nlimsuc   ---         obsolete; use nlimsucg
19-Sep-06 limuni2   limuni3
15-Sep-06 ranklon   rankval4
13-Sep-06 cbvop     rexxp
11-Sep-06 zfaus     zfauscl
10-Sep-06 fex       [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 f1dmex    [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 fnex      [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 ssexg     [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 funimaexg [--same--]  antecedent changed to use conjunction & swapped
10-Sep-06 resfunexg [--same--]  antecedent changed to use conjunction & swapped
 9-Sep-06 funex     [--same--]  antecedent changed to use conjunction & swapped
 8-Sep-06 cls       clsp
29-Aug-06 elab3g    elab3
26-Aug-06 unop      uniop
26-Aug-06 unpr      unipr
26-Aug-06 unictb    [--same--]  removed irrelevant hypothesis
16-Aug-06 ssrab     ssrab2
16-Aug-06 rabss     rabss2
16-Aug-06 ssab      ssab2
13-Aug-06 fvco3     [--same--]  antecedent changed to use triple conjunction
13-Aug-06 fvco2     [--same--]  antecedent changed to use triple conjunction
 6-Jun-06 sq0       sq00
 1-Jun-06 infpn     infpn2
27-May-06 ---       ---         exp was changed to ex to prevent matching
27-May-06 ---       ---           math token 'exp'.
27-May-06 exp       ex
26-May-06 f1ocnvfvb [--same--]  antecedent changed to use triple conjunction
22-Apr-06 fvco      [--same--]  antecedent changed to use triple conjunction
10-Apr-06 plus1let  p1let
10-Apr-06 leplus1t  lep1t
10-Apr-06 ltplus1   ltp1
10-Apr-06 ltplus1t  ltp1t
29-Mar-06 xpdom2    [--same--]  eliminated the A e. _V hypothesis
29-Mar-06 xpdom1    [--same--]  eliminated the A e. _V hypothesis
28-Mar-06 sspr      [--same--]  eliminated both $e hypotheses
26-Mar-06 fnfvop    fnopfvb
26-Mar-06 fnfvbr    fnbrfvb
26-Mar-06 eqri      eqriv
26-Mar-06 eqrd      eqrdv
26-Mar-06 nn0z      nn0zrab
26-Mar-06 nnz       nnzrab
24-Mar-06 fodomb    [--same--]  eliminated the B e. _V hypothesis
24-Mar-06 eldmg     eldm2g
22-Mar-06 prprc     prprc1
22-Mar-06 sqrsqet   sqrsqt
22-Mar-06 sqrsqe    sqrsq
22-Mar-06 sqrsq     sqrmsq2
21-Mar-06 nn0le2sqet nn0le2msqt
21-Mar-06 le2sqet   le2sqt
21-Mar-06 le2sqt    le2msqt
21-Mar-06 lt2sqet   lt2sqt
21-Mar-06 lt2sqt    lt2msqt
21-Mar-06 le2sqe    le2sq
21-Mar-06 le2sq     le2msq
21-Mar-06 lt2sqe    lt2sq
21-Mar-06 lt2sq     lt2msq
21-Mar-06 ltsqt     ltmsqt
13-Mar-06 sq11t     [--same--]  rearranged antecedent
11-Mar-06 sqrecl    resqcl
11-Mar-06 sqreclt   resqclt
11-Mar-06 ---       ---         'sq' is normal square (A ^ 2)
11-Mar-06 sqe0      sqeq0
11-Mar-06 sqe11     sq11
11-Mar-06 sqegt0    sqgt0
11-Mar-06 sqege0    sqge0
11-Mar-06 sqe11t    sq11t
11-Mar-06 sqege0t   sqge0t
11-Mar-06 ---       ---         'msq' is square represented by mult. (A x. A)
11-Mar-06 sqeq0      msq0
11-Mar-06 sqgt0     msqgt0
11-Mar-06 sqge0     msqge0
11-Mar-06 sq11      msq11
11-Mar-06 sqznn     msqznn
11-Mar-06 sqrsqid   sqrmsq
11-Mar-06 sqeq0      msq0
24-Feb-06 lerect    [--same--]  rearranged antecedent
24-Feb-06 ltrect    [--same--]  rearranged antecedent
24-Feb-06 lt2sqet   [--same--]  rearranged antecedent
24-Feb-06 le2sqet   [--same--]  rearranged antecedent
24-Feb-06 lt2sqt    [--same--]  rearranged antecedent
24-Feb-06 le2sqt    [--same--]  rearranged antecedent
20-Feb-06 funfvopi  funopfv
20-Feb-06 funopfv   funfvop
20-Feb-06 funfvop   funopfvb
 9-Feb-06 divneq0bt divne0bt
 9-Feb-06 divneq0   divne0
 9-Feb-06 recneq0z  recne0z
 9-Feb-06 pm2.61an2 pm2.61dan
 9-Feb-06 pm2.61an1 pm2.61ian
28-Jan-06 cleqfvf   eqfnfvf
26-Jan-06 fri       [--same--]  changed to closed theorem instead of inference
17-Jan-06 relin     relin1
17-Jan-06 ssrelqqq  relss
17-Jan-06 relss     ssrel
17-Jan-06 ssrel     ssrelqqq
16-Jan-06 elrnqqq   elrn2
16-Jan-06 elrn2     elrn
16-Jan-06 elrn      elrnqqq
12-Jan-06 df-ef     [--same--]  revised to use new df-sum
 9-Jan-06 rabeqbi2i rabeq2i
 9-Jan-06 abeqbi2   abeq2
 9-Jan-06 abeqbi1   abeq1
 9-Jan-06 abeqbi2i  abeq2i
 9-Jan-06 abeqbi1i  abeq1i
 9-Jan-06 abeqbi2d  abeq2d
 9-Jan-06 abbieq2i  abbi2i
 9-Jan-06 abbieqi   abbii
 9-Jan-06 abbieqd   abbid
 9-Jan-06 abbieqdv  abbidv
 9-Jan-06 abbieq2dv abbi2dv
 9-Jan-06 abbieq1dv abbi1dv
 9-Jan-06 rabbieqi  rabbii
 9-Jan-06 rabbieqdv rabbidv
 9-Jan-06 rabbieqsdv rabbisdv
 9-Jan-06 rabbieqrdv rabbirdv
 9-Jan-06 opabbieqd opabbid
 9-Jan-06 opabbieqdv opabbidv
 9-Jan-06 oprabbieqd oprabbid
 9-Jan-06 oprabbieqdv oprabbidv
 9-Jan-06 oprabbieqi oprabbii
 9-Jan-06 abeqbi2   abeq2
 9-Jan-06 abeqbi2i  abeq2i
 9-Jan-06 abeqbi1   abeq1
 9-Jan-06 abeqbi2d  abeq2d
 9-Jan-06 abeqbi1i  abeq1i
 9-Jan-06 rabeqbi2i rabeq2i
 9-Jan-06 oprabbieqi oprabbii
 7-Jan-06 divgt0lem divgt0i2
 5-Jan-06 lep1t  letrp1t
 4-Jan-06 nnegdift  ---         obsolete; use subge0t (swapped biconditional)
 2-Jan-06 opabbii.2 opabbii
 1-Jan-06 negdi2    negsubdi
 1-Jan-06 negdi2t   negsubdit
 1-Jan-06 negdi3    negsubdi2t
 1-Jan-06 negdi3t   negsubdi2t
17-Dec-05 msca      ---         obsolete; now embedded inside equs4 proof
16-Dec-05 1expt     [--same--]  antecedent extended from NN to NN0
16-Dec-05 nnexpclt  [--same--]  antecedent extended from NN to NN0
16-Dec-05 nn0expclt [--same--]  antecedent extended from NN to NN0
16-Dec-05 zexpclt   [--same--]  antecedent extended from NN to NN0
16-Dec-05 qexpclt   [--same--]  antecedent extended from NN to NN0
16-Dec-05 reexpclt  [--same--]  antecedent extended from NN to NN0
16-Dec-05 expclt    [--same--]  antecedent extended from NN to NN0
16-Dec-05 expcllem  [--same--]  antecedent extended from NN to NN0; + 3rd hyp.
16-Dec-05 expp1t    [--same--]  antecedent extended from NN to NN0
16-Dec-05 expvalt   expnnvalt
13-Dec-05 sbcco     sbccog
 1-Dec-05 subneg2t  subnegt
 1-Dec-05 subnegt   ---         obsolete; use negsubt (swapped equality)
 1-Dec-05 subneg    ---         obsolete; use negsub (swapped equality)
 1-Dec-05 reueq     reueq1
 1-Dec-05 rexeq     rexeq1
 1-Dec-05 raleq     raleq1
 1-Dec-05 reueqf    reueq1f
 1-Dec-05 rexeqf    rexeq1f
 1-Dec-05 raleqf    raleq1f
 1-Dec-05 ad2antxx  ad2antrr
 1-Dec-05 ad2antrr  ad2antll
 1-Dec-05 ad2antll  ad2antxx
29-Nov-05 sbcel2    sbcel2gv
29-Nov-05 sbcel1    sbcel1gv
28-Nov-05 sbcn      sbcng
28-Nov-05 sbcim     sbcimg
28-Nov-05 sbcbi     sbcbig
28-Nov-05 sbcor     sbcorg
28-Nov-05 sbcan     sbcang
28-Nov-05 sbcal     sbcalg
28-Nov-05 sbcex     sbcexg
28-Nov-05 sbceq1    sbceq1a
21-Nov-05 2o        2on
21-Nov-05 1o        1on
19-Nov-05 zfrep3    axrep5
19-Nov-05 zfrep2    axrep4
19-Nov-05 axrep     axrep2
18-Nov-05 hbsbcg    hbsbc1g
18-Nov-05 hbsbc     hbsbc1
18-Nov-05 hbsbcv    hbsbc1v
18-Nov-05 ---       ---         More changes to the bixx series below -
18-Nov-05 ---       ---         changed to xxbix to be analogous to the xxeqx
18-Nov-05 ---       ---         series e.g. uneq12d.  Also, the bi(r)abxx were
18-Nov-05 ---       ---         changed to (r)abbieqxx: "bi" in hyp. and
18-Nov-05 ---       ---         "eq" in conclusion.
18-Nov-05 bial      albii
18-Nov-05 bi2al     2albii
18-Nov-05 biex      exbii
18-Nov-05 bi2ex     2exbii
18-Nov-05 bi3ex     3exbi
18-Nov-05 biald     albid
18-Nov-05 biexd     exbid
18-Nov-05 bisb      sbbii
18-Nov-05 bisbd     sbbid
18-Nov-05 bialdv    albidv
18-Nov-05 biexdv    exbidv
18-Nov-05 bi2aldv   2albidv
18-Nov-05 bi2exdv   2exbidv
18-Nov-05 bi3exdv   3exbidv
18-Nov-05 bi4exdv   4exbidv
18-Nov-05 bieud     eubid
18-Nov-05 bieudv    eubidv
18-Nov-05 bieu      eubii
18-Nov-05 bimod     mobid
18-Nov-05 bimo      mobii
18-Nov-05 biralda   ralbida
18-Nov-05 birexda   rexbida
18-Nov-05 biraldva  ralbidva
18-Nov-05 birexdva  rexbidva
18-Nov-05 birald    ralbid
18-Nov-05 birexd    rexbid
18-Nov-05 biraldv   ralbidv
18-Nov-05 birexdv   rexbidv
18-Nov-05 biraldv2  ralbidv2
18-Nov-05 birexdv2  rexbidv2
18-Nov-05 biral     ralbii
18-Nov-05 birex     rexbii
18-Nov-05 bi2ral    2ralbii
18-Nov-05 bi2rex    2rexbii
18-Nov-05 biral2    ralbii2
18-Nov-05 birex2    rexbii2
18-Nov-05 birala    ralbiia
18-Nov-05 birexa    rexbiia
18-Nov-05 bi2rexa   2rexbiia
18-Nov-05 bi2ralda  2ralbida
18-Nov-05 bi2raldva 2ralbidva
18-Nov-05 bi2rexdva 2rexbidva
18-Nov-05 bireudva  reubidva
18-Nov-05 bireudv   reubidv
18-Nov-05 bireua    reubiia
18-Nov-05 bireu     reubii
18-Nov-05 bisbcdv   sbcbidv
18-Nov-05 bisbc     sbcbii
18-Nov-05 eqrabi    rabeqbi2i
18-Nov-05 eqab      abeqbi2
18-Nov-05 eqabr     abeqbi1
18-Nov-05 eqabi     abeqbi2i
18-Nov-05 eqabri    abeqbi1i
18-Nov-05 eqabd     abeqbi2d
18-Nov-05 biabri    abbieq2i
18-Nov-05 biabi     abbieqi
18-Nov-05 biabd     abbieqd
18-Nov-05 biabdv    abbieqdv
18-Nov-05 biabrdv   abbieq2dv
18-Nov-05 biabldv   abbieq1dv
18-Nov-05 birabi    rabbieqi
18-Nov-05 birabdv   rabbieqdv
18-Nov-05 birabsdv  rabbieqsdv
18-Nov-05 birabrdv  rabbieqrdv
18-Nov-05 biopabd   opabbieqd
18-Nov-05 biopabdv  opabbieqdv
18-Nov-05 bioprabd  oprabbieqd
18-Nov-05 bioprabdv oprabbieqdv
18-Nov-05 bioprabi  oprabbieqi
18-Nov-05 bicon1i   con1bii
18-Nov-05 bicon2i   con2bii
18-Nov-05 bicon4i   con4bii
18-Nov-05 bicon4d   con4bid
18-Nov-05 bicon2    con2bi
18-Nov-05 bicon2d   con2bid
18-Nov-05 bicon1d   con1bid
18-Nov-05 bisyl7    syl7ib
18-Nov-05 bisyl8    syl8ib
11-Nov-05 sbcbidv   [--same--]  swapped antecedents
21-Oct-05 ciin      [--same--]  "|^|" changed to "|^|_"
21-Oct-05 cuin      [--same--]  "U." changed to "U_"
21-Oct-05 ---SYMBOL CHANGE----  Changed "|^|" to "|^|_" in thm's using ciin
21-Oct-05 ---SYMBOL CHANGE----  Changed "U." to "U_" in thm's using ciun
20-Oct-05 rax5      ra5
20-Oct-05 rax4      ---         obsolete; use ra4sbc
20-Oct-05 reuuni2f  [--same--]  weakened its hypotheses
19-Oct-05 reuss     [--same--]  antecedent changed to use triple conjunction
10-Oct-05 uzwo      [--same--]  changed to use ZZ>= notation
10-Oct-05 uzwo2     [--same--]  changed to use ZZ>= notation
 1-Oct-05 nnncant   nnncan1t
13-Sep-05 leltnet   [--same--]  antecedent changed to use triple conjunction
10-Sep-05 ifel      ifcl
 6-Sep-05 dmopab2   dmopab3
 5-Sep-05 peano2uz  peano2uz2
 1-Sep-05 cleqfv    eqfnfv
 1-Sep-05 df-seq    df-seq1
 1-Sep-05 cseqz     cseq1
 1-Sep-05 serft     ser1ft
 1-Sep-05 serf      ser1f
 1-Sep-05 sercl     ser1cl
 1-Sep-05 serrecl   ser1recl
 1-Sep-05 serre     ser1re
 1-Sep-05 sercl2    ser1cl2
 1-Sep-05 serf2     ser1f2
 1-Sep-05 ser12     ser11
 1-Sep-05 sersuc2   ser1p1
 1-Sep-05 sermono   ser1mono
 1-Sep-05 seradd2   ser1add2
 1-Sep-05 seradd    ser1add
 1-Sep-05 serdir    ser1dir
 1-Sep-05 serabsdiflem ser1absdiflem
 1-Sep-05 serabsdif ser1absdif
 1-Sep-05 serre2    ser1re2
 1-Sep-05 sercj     ser1cj
 1-Sep-05 serconst  ser1const
 1-Sep-05 sertrunclem ser1trunclem
 1-Sep-05 sercmp    ser1cmp
 1-Sep-05 sercmp0   ser1cmp0
 1-Sep-05 sercmp2lem ser1cmp2lem
 1-Sep-05 sercmp2   ser1cmp2
 1-Sep-05 seqlem1   seq1lem1
 1-Sep-05 seqlem2   seq1lem2
 1-Sep-05 seqrval   seq1rval
 1-Sep-05 seqval    seq1val
 1-Sep-05 seqfnlem  seq1fnlem
 1-Sep-05 seqval2   seq1val2
 1-Sep-05 seq1lem   seq11lem
 1-Sep-05 seqsuclem seq1suclem
 1-Sep-05 seqp1     seq1p1
 1-Sep-05 seqm1     seq1m1
 1-Sep-05 seqfn     seq1fn
 1-Sep-05 seqrn     seq1rn2
 1-Sep-05 seqrn2    seq1rn
 1-Sep-05 seqcl     seq1cl
 1-Sep-05 seqres    seq1res
 1-Sep-05 seqbnd    seq1bnd
 1-Sep-05 sequblem  seq1ublem
 1-Sep-05 sequb     seq1ub
 1-Sep-05 seqhcau   seq1hcau
 1-Sep-05 ---SYMBOL CHANGE----  Changed math symbol 'seq' to 'seq1'
 1-Sep-05 seq1      seq11       Warning: do _before_ the symbol change above
17-Aug-05 df-clim   [--same--]  The old df-clim, df-shft, and df-seq0, and
17-Aug-05 df-shft   [--same--]      all derived theorems, have been scrapped
17-Aug-05 df-seq0   [--same--]      or rederived from the new definitions.
30-Jul-05 ---       ---         syl* changes below were sugg'ed by Scott Fenton
30-Jul-05 syl34d    imim12d
30-Jul-05 syl4d     imim1d
30-Jul-05 syl3d     imim2d
30-Jul-05 syl34     imim112i
30-Jul-05 syl4      imim1i
30-Jul-05 syl3      imim2i
30-Jul-05 syl2      imim1
30-Jul-05 syl1      imim2
27-Jul-05 uzind     [--same--]  weaker basis hyp.; different mand. hyp. order
13-Jul-05 mp3an11   mp3anl1
13-Jul-05 mp3an12   mp3anl2
13-Jul-05 mp3an13   mp3anl3
13-Jul-05 syl3an11  syl3anl1
13-Jul-05 syl3an12  syl3anl2
13-Jul-05 syl3an13  syl3anl3
13-Jul-05 mpan11    mpanl1
13-Jul-05 mpan12    mpanl2
13-Jul-05 mpan21    mpanr1
13-Jul-05 mpan22    mpanr2
13-Jul-05 sylan11   sylanl1
13-Jul-05 sylan12   sylanl2
13-Jul-05 sylan21   sylanr1
13-Jul-05 sylan22   sylanr2
13-Jul-05 mpan121   mpanlr1
13-Jul-05 ecased    ---         obsolete; use ecase23d (diff. hyp. order)
11-Jul-05 lelt      lenlt
11-Jul-05 leltt     lenltt
11-Jul-05 lenltt    eqleltt
10-Jul-05 bcpasc    bcpasc2
10-Jul-05 bcvalt    bcval2t
 9-Jul-05 sermconst ---         obsolete; use ser1mulc
 9-Jul-05 seqsuc    seq1p1
 3-Jul-05 peano5c   ---         obsolete; use peano5nn (restr. qntfr.)
 3-Jul-05 df-n      [--same--]  shortened with restricted quantifier
 2-Jul-05 mulge0t   [--same--]  conjoined antecedents
 2-Jul-05 prodgt02t [--same--]  swapped A e. RR and B e. RR
27-Jun-05 syl3an    [--same--]  changed order of hypotheses
25-Jun-05 ecoprcom  [--same--]  changed order of $f hypotheses
21-Jun-05 nn0ltlem1 nn0ltlem1t
21-Jun-05 subsub    subsub23
17-Jun-05 ecoprdist ---         obsolete; use ecoprdi
16-Jun-05 binom     binom2
12-Jun-05 oel       orabs
30-May-05 ltdiv23t  [--same--]  conjoined antecedents
30-May-05 ledivt    lediv1t
23-May-05 rcla42v   [--same--]  swapped antecedents
23-May-05 rcla4v    [--same--]  swapped antecedents
23-May-05 rcla4     [--same--]  swapped antecedents
10-May-05 mpbiranr  mpbiran2
 8-May-05 funfv2    [--same--]  changed to A F y instead of <. A , y >. e. F
 8-May-05 imasn     ---         obsolete; use relimasn (A R y instead of o.p.)
 3-May-05 nndiv     nndivt
 2-May-05 subaddeq  pncan3
 2-May-05 subaddeqt pncan3t
 1-May-05 divne0bt  [--same--]  changed antecedent to triple conjunction
 1-May-05 divcan2t  [--same--]  changed antecedent to triple conjunction
 1-May-05 divcan1t  [--same--]  changed antecedent to triple conjunction
30-Apr-05 divnegt   [--same--]  changed antecedent to triple conjunction
30-Apr-05 divrect   [--same--]  changed antecedent to triple conjunction
30-Apr-05 divcan3t  [--same--]  changed antecedent to triple conjunction
30-Apr-05 divcan4t  [--same--]  changed antecedent to triple conjunction
29-Apr-05 crut      [--same--]  generalized -> to <->
29-Apr-05 cru       [--same--]  generalized -> to <->
29-Apr-05 isqm1     itimesi
29-Apr-05 crmult    crmul       changed hypotheses from real to complex
29-Apr-05 redivclt  [--same--]  changed antecedent to triple conjunction
29-Apr-05 divclt    [--same--]  changed antecedent to triple conjunction
28-Apr-05 ine0      [--same--]  changed -. and = to =/=
27-Apr-05 ltdivt    ltdiv1t
27-Apr-05 ltdiv     ltdiv1
27-Apr-05 ltdivi    ltdiv1i
24-Apr-05 prodgt0   [--same--]  strengthened 0 < A to 0 <_ A
24-Apr-05 prodgt0i  prodgt0lem
 7-Apr-05 equs2     ---         obsolete; use equs5
 7-Apr-05 equs1     ---         obsolete; use equs4
 6-Apr-05 absltt    [--same--]  swapped & contraposed conjunct with -u
 6-Apr-05 absle     [--same--]  swapped & contraposed conjunct with -u
 6-Apr-05 abslt     [--same--]  swapped & contraposed conjunct with -u
26-Mar-05 abscj     [--same--]  swapped arguments of = sign
18-Mar-05 reim0     reim0b
18-Mar-05 rere      rereb
18-Mar-05 cjre      cjreb
18-Mar-05 negre     negreb
11-Mar-05 frsuc     frsuc
10-Mar-05 nn0addge2 [--same--]  Generalized 1st hyp from NN0 to RR
10-Mar-05 nn0addge1 [--same--]  Generalized 1st hyp from NN0 to RR
 5-Mar-05 chv       chvarv
 5-Mar-05 chv2      chvar
 4-Mar-05 divdistr  divdir
 4-Mar-05 divdistrz divdirz
 4-Mar-05 divge0t   [--same--]  conjoined the two left-most antecedents
 4-Mar-05 divgt0t   [--same--]  conjoined the two left-most antecedents
 4-Mar-05 absgt0t   [--same--]  changed  -. A = 0  to  A =/= 0
 4-Mar-05 absgt0    [--same--]  changed  -. A = 0  to  A =/= 0
24-Feb-05 absidt    [--same--]  conjoined the two left-most antecedents
27-Feb-05 del34     ---         obsolete; use dral1 instead
27-Feb-05 del35     ---         obsolete; use dral1 instead
27-Feb-05 del34b    dral1
27-Feb-05 del36     ---         obsolete; use dral2 instead
27-Feb-05 del40     ---         obsolete; use drex1 instead
27-Feb-05 del41     ---         obsolete; use drex1 instead
27-Feb-05 del42     ---         obsolete; use drex2 instead
27-Feb-05 del43     ---         obsolete; use drsb1 instead
27-Feb-05 del43b    drsb1
27-Feb-05 del44     ---         obsolete; use drsb2 instead
27-Feb-05 del45     ---         obsolete; use drsb2 instead
27-Feb-05 ddelimf2  dvelimf2
27-Feb-05 ddelimf   dvelimf
27-Feb-05 ddelimdf  dvelimdf
27-Feb-05 ddelim    dvelim
27-Feb-05 ddeeq1    dveeq1
27-Feb-05 ddeeq2    dveeq2
27-Feb-05 ddeel1    dveel1
27-Feb-05 ddeel2    dveel2
24-Feb-05 bi3ord    3orbi123d
24-Feb-05 im3ord    3orim123d
24-Feb-05 bi3or     3orbi123i
24-Feb-05 bi3an     3anbi123i
24-Feb-05 bi3and    3anbi123d
24-Feb-05 im3an     3anim123i
24-Feb-05 divdistrt divdirt
24-Feb-05 ltdiv1t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 lediv1t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltmuldivt [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltdivmult [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltmuldiv2t [--same--]  conjoined the two left-most antecedents
24-Feb-05 gt0ne0t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 ltrect    [--same--]  conjoined the two left-most antecedents
24-Feb-05 recgt0t   [--same--]  conjoined the two left-most antecedents
24-Feb-05 lerect    [--same--]  conjoined the two left-most antecedents
21-Feb-05 nn0ge0i   nn0ge0
21-Feb-05 rdgzer    rdg0
21-Feb-05 rdgzert   rdg0g
21-Feb-05 frzer     fr0g
21-Feb-05 mulzer1   mul01
21-Feb-05 mulzer2   mul02
21-Feb-05 mulzer1t  mul01t
21-Feb-05 mulzer2t  mul02t
21-Feb-05 divzer    div0
19-Feb-05 ax0re     0re
13-Feb-05 cardcard  cardidm
13-Feb-05 exp2t     sqvalt
13-Feb-05 uzind2    ---         Obsolete; use uzind3
 5-Feb-05 ---       ---         We will adopt "equ" (vs. old "eq") for
 5-Feb-05 ---       ---         set variable equality and "eq" (vs. old
 5-Feb-05 ---       ---         "cleq") for class equality.  (Remember it
 5-Feb-05 ---       ---         is important to do these in REVERSE order
 5-Feb-05 ---       ---         below!)
 5-Feb-05 cleqri    eqri
 5-Feb-05 cleqrd    eqrd
 5-Feb-05 cleqid    eqid
 5-Feb-05 cleqcom   eqcom
 5-Feb-05 cleqcomi  eqcomi
 5-Feb-05 cleqcomd  eqcomd
 5-Feb-05 cleq1     eqeq1
 5-Feb-05 cleq2     eqeq2
 5-Feb-05 cleq1i    eqeq1i
 5-Feb-05 cleq2i    eqeq2i
 5-Feb-05 cleq1d    eqeq1d
 5-Feb-05 cleq2d    eqeq2d
 5-Feb-05 cleq12    eqeq12
 5-Feb-05 cleq12i   eqeq12i
 5-Feb-05 cleq12d   eqeq12d
 5-Feb-05 cleqan12d eqeqan12d
 5-Feb-05 cleqan12rd eqeqan12rd
 5-Feb-05 cleqtr    eqtr
 5-Feb-05 cleq2tr   eq2tri
 5-Feb-05 cleqab    abeqbi2
 5-Feb-05 cleqabi   abeqbi2i
 5-Feb-05 cleqabr   abeqbi1
 5-Feb-05 cleqabd   abeqbi2d
 5-Feb-05 cleqabri  abeqbi1i
 5-Feb-05 cleq2ab   eq2ab
 5-Feb-05 cleqrabi  rabeqbi2i
 5-Feb-05 clneq     nelneq
 5-Feb-05 clneq2    nelneq2
 5-Feb-05 sbeq2     equsb2
 5-Feb-05 sbeq1     equsb1
 5-Feb-05 eqvin.l2  ---           obsolete; use equvin instead
 5-Feb-05 eqvin     equvin
 5-Feb-05 eqvin.l1  equvini
 5-Feb-05 eqsal     equsal
 5-Feb-05 eqsex     equsex
 5-Feb-05 eqs5      equs5
 5-Feb-05 eqs4      equs4
 5-Feb-05 eqs3      equs3
 5-Feb-05 eqs2      equs2
 5-Feb-05 eqs1      equs1
 5-Feb-05 eq6s      hbnaes
 5-Feb-05 eq6       hbnae
 5-Feb-05 eq5s      hbaes
 5-Feb-05 eq5       hbae
 5-Feb-05 eq4ds     nalequcoms
 5-Feb-05 eq4s      alequcoms
 5-Feb-05 eq4       ax-10
 5-Feb-05 a14b      elequ2
 5-Feb-05 a13b      elequ1
 5-Feb-05 eqt2b     equequ2
 5-Feb-05 a8b       equequ1
 5-Feb-05 eqt       equtr
 5-Feb-05 eqt2      equtrr
 5-Feb-05 eqan      equtr2
 5-Feb-05 eqcom     equcomi
 5-Feb-05 eqcomb    equcom
 5-Feb-05 eqcoms    equcoms
 5-Feb-05 eqid      equid
 3-Feb-05 sb5f1     sb6rf
21-Jan-05 mulcanxx  mulcant2
21-Jan-05 mulcant2  mulcant
21-Jan-05 mulcant   mulcanxx
10-Jan-05 add41r3   add42
10-Jan-05 caopr41r3 caopr42
10-Jan-05 an41r3s   an42s
10-Jan-05 an41r3    an42
 8-Jan-05 ---       ---         The imxx series was changed analogously
 8-Jan-05 ---       ---         to the bixx series change.
 8-Jan-05 im2an     anim12i
 8-Jan-05 imran     anim1i
 8-Jan-05 imlan     anim2i
 8-Jan-05 im2or     orim12i
 8-Jan-05 imror     orim1i
 8-Jan-05 imlor     orim2i
 8-Jan-05 im2and    anim12d
 8-Jan-05 imrand    anim1d
 8-Jan-05 imland    anim2d
 8-Jan-05 im2ord    orim12d
 8-Jan-05 imrord    orim1d
 8-Jan-05 imlord    orim2d
 8-Jan-05 ---       ---         The bixx series was changed to be analogous
 8-Jan-05 ---       ---         to the xxeqx series e.g. uneq12d.
 8-Jan-05 ---       ---         (Suggested by Raph Levien.)
 8-Jan-05 bi2and    anbi12d
 8-Jan-05 birand    anbi1d
 8-Jan-05 biland    anbi2d
 8-Jan-05 bi2imd    imbi12d
 8-Jan-05 birimd    imbi1d
 8-Jan-05 bilimd    imbi2d
 8-Jan-05 bi2ord    orbi12d
 8-Jan-05 birord    orbi1d
 8-Jan-05 bilord    orbi2d
 8-Jan-05 bi2bid    bibi12d
 8-Jan-05 birbid    bibi1d
 8-Jan-05 bilbid    bibi2d
 8-Jan-05 binegd    negbid
 8-Jan-05 bi2an     anbi12i
 8-Jan-05 biran     anbi1i
 8-Jan-05 bilan     anbi2i
 8-Jan-05 bi2im     imbi12i
 8-Jan-05 birim     imbi1i
 8-Jan-05 bilim     imbi2i
 8-Jan-05 bi2or     orbi12i
 8-Jan-05 biror     orbi1i
 8-Jan-05 bilor     orbi2i
 8-Jan-05 bi2bi     bibi12i
 8-Jan-05 birbi     bibi1i
 8-Jan-05 bilbi     bibi2i
 8-Jan-05 bineg     negbii
 3-Jan-05 pm5.41    imdi
 1-Jan-05 iundif    iundif2
 1-Jan-05 iindif    iindif2
 1-Jan-05 iunin     iunin2
 1-Jan-05 iinin     iinin2
 1-Jan-05 sylan13br sylancbr
 1-Jan-05 sylan13b  sylancb
 1-Jan-05 sylan13   sylanc
 1-Jan-05 syl13     sylc
26-Dec-04 0ne1o     ---         obsolete; use 1ne0
19-Dec-04 sbequ6    [--same--]  swapped biconditional order
19-Dec-04 sbequ5    [--same--]  swapped biconditional order
15-Dec-04 syl2and   syl2ani
15-Dec-04 sylan2d   sylan2i
15-Dec-04 syland    sylani
12-Dec-04 nnordex   nnaordex
12-Dec-04 nnwordex  nnawordex
12-Dec-04 mpand     mpdan
12-Dec-04 ontr      ontr1
 6-Dec-04 on0eqel   on0eqelt
30-Nov-04 exp2      sqvalt
30-Nov-04 1exp      1expt
30-Nov-04 0exp      0expt
30-Nov-04 exp1      exp1t
30-Nov-04 expp1     expp1t
18-Nov-04 divrclz   redivclz
18-Nov-04 divrclt   redivclt
18-Nov-04 subrclt   resubclt
18-Nov-04 negrclt   renegclt
18-Nov-04 mulrclt   remulclt
18-Nov-04 divrcl    redivcl
18-Nov-04 subrcl    resubcl
18-Nov-04 negrcl    renegcl
18-Nov-04 mulrcl    remulcl
18-Nov-04 addrcl    readdcl
18-Nov-04 ltdivmul  ---         obsolete; use ltmuldiv instead
18-Nov-04 ltdivmult ---         obsolete; use ltmuldivt instead (note: there
                                is a new ltdivmult that is unrelated)
18-Nov-04 distr2t   adddirt
18-Nov-04 distr2    adddir
18-Nov-04 distr     adddi
18-Nov-04 subdistr  subdir
17-Nov-04 nnrect    nnrecgt0t
17-Nov-04 posdif    [--same--]  swapped biconditional and variable order
15-Nov-04 negdistt3 negdi3t
15-Nov-04 negdistt2 negdi2t
15-Nov-04 negdistt  negdit
15-Nov-04 negdist3  negdi3
15-Nov-04 negdist2  negdi2
11-Nov-04 reuunis   reuuni2
11-Nov-04 reuuni    reuuni1
 9-Nov-04 zlelt1    zleltp1t
 9-Nov-04 zltle1    zltp1let
 7-Sep-04 arch      [--same--]  removed quantifier, changed set var. to class
 2-Nov-04 dfom2     dfom3
 2-Nov-04 dfom3     dfom4
29-Oct-04 df-ded    df-if
29-Oct-04 dedeq1    ifeq1
29-Oct-04 dedeq2    ifeq2
29-Oct-04 dedeq12   ifeq12
29-Oct-04 dedbi     ifbi
29-Oct-04 dedlem1   iftrue
29-Oct-04 dedlem2   iffalse
29-Oct-04 dedex     ifex
29-Oct-04 cded      cif
29-Oct-04 ---SYMBOL CHANGE----  Changed math symbol 'ded' to 'if'
28-Oct-04 cmulc     cmul
20-Oct-04 oprabex   oprabex2
14-Oct-04 nn0lelt1  nn0leltp1t
14-Oct-04 nn0ltle1  nn0ltp1let
14-Oct-04 nnlelt1   nnleltp1t
14-Oct-04 nnltle1   nnltp1let
14-Oct-04 rnoel3    rabn0
14-Oct-04 noel3     abn0
14-Oct-04 noel2     n0i
14-Oct-04 peano2c   peano2nn
12-Oct-04 supeu     supeui
12-Oct-04 supcl     supcli
12-Oct-04 supub     supubi
12-Oct-04 suplub    suplubi
12-Oct-04 supnub    supnubi
12-Oct-04 suprcl    suprcli
12-Oct-04 suprub    suprubi
12-Oct-04 pm4.12    con2bi
12-Oct-04 bicon4    con4bii
12-Oct-04 con2bi    con2bii
12-Oct-04 bicon1    con1bii
12-Oct-04 pm2.11    exmid
11-Oct-04 sbf1      ---         obsolete; use sbf instead
11-Oct-04 ceqsexg   ceqex
 9-Oct-04 fvco2     fvco3
 8-Oct-04 indif0    disjdif
 8-Oct-04 biopab    opabbii.2
 8-Oct-04 bioprab   oprabbieqi
 7-Oct-04 ssii      sselii
 6-Oct-04 op2nd     op2ndb
 6-Oct-04 op1st     op1stb
 3-Oct-04 ind       nnind
 3-Oct-04 sylan5    sylan2
 3-Oct-04 sylan5b   sylan2b
 3-Oct-04 sylan5br  sylan2br
 3-Oct-04 sylan5d   sylan2i
 3-Oct-04 zind      ---         obsolete; use uzind
30-Sep-04 fvop      funfvop
30-Sep-04 funfvop   funopfv
30-Sep-04 pm4.21    bicom
30-Sep-04 bicom     bicomi
30-Sep-04 entr      entri
30-Sep-04 sstr2qqq  sstr
30-Sep-04 sstr      sstr2
30-Sep-04 sstr2     sstr2qqq
29-Sep-04 xp0qqq    xp0r
29-Sep-04 xp0r      xp0
29-Sep-04 xp0       xp0qqq
28-Sep-04 xpdom     xpdom2      changed variable names
28-Sep-04 xpdom2    xpdom3
26-Sep-04 xpindi    inxp
26-Sep-04 xpun1     xpundi
26-Sep-04 xpun2     xpundir
25-Sep-04 entr      entrt
23-Sep-04 ssfnres   ---         obsolete; use fnssres instead
23-Sep-04 resun     resundi
21-Sep-04 f11       [--same--]  changed o.p. membership to binary relation
21-Sep-04 unisuc    [--same--]  swapped arguments of = sign
21-Sep-04 onunisuc  [--same--]  swapped arguments of = sign
21-Sep-04 undif3    ---         obsolete; use undif
21-Sep-04 ssequn2   [--same--]  swapped arguments of = sign
21-Sep-04 sseqin2   [--same--]  swapped arguments of = sign
21-Sep-04 onelun    [--same--]  swapped arguments of = sign
21-Sep-04 dfss4     [--same--]  swapped arguments of = sign
21-Sep-04 ordunisuc ordunisssuc
21-Sep-04 ssfun     funss
15-Sep-04 19.6      alex
15-Sep-04 alex      alexeq
15-Sep-04 19.11     excom
15-Sep-04 19.11a    excomim
15-Sep-04 19.5      alcom
15-Sep-04 19.7      alnex
15-Sep-04 19.14     exnal
15-Sep-04 alnex     alinexa
15-Sep-04 exnal     exanali
15-Sep-04 dmsn      dmsnop
15-Sep-04 rnsn      rnsnop
13-Sep-04 ppnull    pwpw0
13-Sep-04 pwnull    pw0
13-Sep-04 zfnull2   zfnul
13-Sep-04 nullpss   0pss
13-Sep-04 nullss    0ss
13-Sep-04 nulleq    eq0
13-Sep-04 nnull     n0
13-Sep-04 nnullf    n0f
13-Sep-04 xpdisj    xpsndisj
13-Sep-04 subdist   subdi
13-Sep-04 negdist   negdi
13-Sep-04 nndist    nndi
13-Sep-04 xpindist  inxp
11-Sep-04 ssd       sseld
11-Sep-04 ssi       sseli
11-Sep-04 vtoclab   elab2
11-Sep-04 vtoclabg  elab2g
11-Sep-04 elab2g    elab3g
 6-Sep-04 comm      com12
 4-Sep-04 opabval   fvopab3
 4-Sep-04 opabvalig fvopab3ig
 4-Sep-04 opabval2g fvopab4g
 4-Sep-04 opabval2  fvopab4
 3-Sep-04 undif2    difun2
 1-Sep-04 dedlem2   [--same--]  swapped arguments of = sign
 1-Sep-04 dedlem1   [--same--]  swapped arguments of = sign
31-Aug-04 pm2.16d   con3d
31-Aug-04 pm2.03d   con2d
31-Aug-04 pm2.15d   con1d
31-Aug-04 pm2.16    con3
31-Aug-04 pm2.03    con2
31-Aug-04 pm2.15    con1
31-Aug-04 con3      con3i
31-Aug-04 con2      con2i
31-Aug-04 con1      con1i
29-Aug-04 oprabelrn elrnoprab
27-Aug-04 ssequn1   [--same--]  swapped arguments of = sign
27-Aug-04 df-ss     dfss
27-Aug-04 imdistanb ---         obsolete; use imdistan
27-Aug-04 imdistan  [--same--]  now includes converse
17-Aug-04 difun2    [--same--]  swapped arguments of = sign
17-Aug-04 undif1    [--same--]  swapped arguments of = sign and union
17-Aug-04 difin     [--same--]  swapped arguments of = sign
17-Aug-04 unindistr undir
17-Aug-04 unindist  undi
17-Aug-04 inundistr indir
17-Aug-04 inundist  indi
17-Aug-04 indist    inindi
16-Aug-04 ss2un     unss12      order of variables changed
15-Aug-04 funmo,dffunmof,dffunmo
                    [--same--]  ordered pair membership -> binary relation
15-Aug-04 dfrel2    [--same--]  swapped arguments of = sign
12-Aug-04 unxp      xpundir
11-Aug-04 elima2    elima3
11-Aug-04 reluni    [--same--]  restricted quantifier and added converse
 9-Aug-04 imun      imaun
 3-Aug-04 1id       om1
 3-Aug-04 oalim     [--same--]  conjoined antecedents; now uses indexed union
 3-Aug-04 divdiv23  divdiv23z
 3-Aug-04 divdiv23i divdiv23
 2-Aug-04 divrec,divrecz [--same--] swapped A and B
 2-Aug-04 zq        zqt
 2-Aug-04 qre       qret
 1-Aug-04 mulcant  [--same--]  swapped conjunct in antecedent
 1-Aug-04 axrecex,axrrecex,divclt,divcan1t,divcan2t,recidt,divdistrt,divrclt
                    [--same--]  conjoined the two left-most antecedents
 1-Aug-04 peano1c   1nn
 1-Aug-04 1nn       1onn
28-Jul-04 sbco0     sbid2
28-Jul-04 sbid2     sbid2v
26-Jul-04 cardonval oncardval
15-Jun-04 ssin      [--same--]  swapped biconditional order
15-Jun-04 unss      [--same--]  swapped biconditional order
11-Jun-04 dfun2     df-un
11-Jun-04 df-un     dfun2
11-Jun-04 dfin2     df-in
11-Jun-04 df-in     dfin2
 3-Jun-04 ssintss   intss
 3-Jun-04 intss     intss1
30-May-04 r1clos    r1pwcl      now uses antecedent instead of hypothesis
30-May-04 r1powt    r1pw
28-May-04 sqvalt    ---         obsolete; use exp2
28-May-04 expntwo   exp2
28-May-04 expnone   ---         obsolete; use expp1t
28-May-04 expnsuc   ---         obsolete; use expp1t
28-May-04 expnzer   ---         obsolete; use exp0t
26-May-04 ontrt     ---         obsolete; use onelon instead
26-May-04 ddelim*   [--same--]  (*=wildcard) changed order of hypotheses
21-May-04 fvcnvb    f1ocnvfvb
21-May-04 fvcnv     f1ocnvfv
21-May-04 sbcb      sbcbig    now uses antecedent instead of hypothesis
21-May-04 sbci      sbcimg
21-May-04 sbb       sbbi
21-May-04 sbo       sbor
21-May-04 sbi       sbim
21-May-04 sbim      sbimi
21-May-04 sba       sban
21-May-04 fvelrn    [--same--]  changed to restricted quantifier
 8-Feb-04 zfpowb    pwexb
 8-Feb-04 zfpowcl   pwex
 8-Feb-04 zfnull    0ex
 8-Feb-04 limelon   [--same--]  changed first -> to /\ in antecedent


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                           2. Quick "How To"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

How to use this file under Windows 95/98/NT/2K/XP/Vista:

1. Download the program metamath.exe per the instructions on the
   Metamath home page (http://us.metamath.org) and put it in the same
   directory as this file (set.mm).
2. In Windows Explorer, double-click on metamath.exe.
3. Type "read set.mm" and press Enter.
4. Type "help" for a list of help topics, and "help demo" for some
   command examples.


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             3. Bibliography
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Bibliographical references are made by bracketing an identifier in a theorem's
comment, such as [RussellWhitehead].  These refer to HTML tags on the following
web pages:

  Logic and set theory - see http://us.metamath.org/mpeuni/mmset.html#bib
  Hilbert space - see http://us.metamath.org/mpeuni/mmhil.html#ref


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      4. Metamath syntax summary
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

The HELP LANGUAGE command in the Metamath program will give you a quick
overview of Metamath.  The official spec is found on pp. 92-95 of the
Metamath book.  The following syntax summary is provided for convenience
but may omit some details.

          $c ... $. - Constant declaration
          $v ... $. - Variable declaration
          $d ... $. - Disjoint (distinct) variable restriction
  <label> $f ... $. - "Floating" hypothesis (i.e. variable type declaration)
  <label> $e ... $. - "Essential" hypothesis (i.e. a logical assumption for a
                      theorem or axiom)
  <label> $a ... $. - Axiom or definition or syntax construction
  <label> $p ... $= ... $. - Theorem and its proof
          ${ ... $} - Block for defining the scope of the above statements
                      (except $a, $p which are forever active)
$)        $( ... $)
$(                  - Comments (may not be nested); see HELP LANGUAGE
                      for markup features.
          $[ ... $] - Include a file

The above two-character sequences beginning with "$" are the only primitives
built into the Metamath language.  The only "logic" Metamath uses in its proof
verification algorithm is the substitution of expressions for variables while
checking for distinct variable violations.  Everything else, including the
axioms for logic, is defined in this database file.

Here is some more detail about the syntax.  There are two kinds of user-defined
syntax elements, called math symbols (or just symbols) and labels.  A symbol
may contain any non-whitespace printable character except "$".  A label may
contain only alphanumeric characters and the characters "."  (period), "-"
(hyphen), and "_" (underscore).  Tokens and labels are case-sensitive.  All
labels (except in proofs) must be distinct.  A label may not have the same name
as a token (to simplify the coding of certain parsers and translators).

  $c <symbollist> $.
      <symbollist> is a (whitespace-separated) list of distinct symbols that
      haven't been used before.
  $v <symbollist> $.
      <symbollist> is a list of distinct symbols that haven't been used yet
      in the current scope (see ${ ... $} below).
  $d <symbollist> $.
      <symbollist> is a (whitespace-separated) list of distinct symbols
      previously declared with $v in current scope.  It means that
      substitutions into these symbols may not have variables in common.
  <label> $f <symbollist> $.
      <symbollist> is a list of 2 symbols, the first of which must be
      previously declared with $c in the current scope.
  <label> $e <symbollist> $.
      <symbollist> is a list of 2 or more symbols, the first of which must be
      previously declared with $c in the current scope.
  <label> $a <symbollist> $.
      <symbollist> is a list of 2 or more symbols, the first of which must be
      previously declared with $c in the current scope.
  <label> $p <symbollist> $= <proof> $.
      <symbollist> is a list of 2 or more symbols, the first of which must be
      previously declared with $c in the current scope.  <proof> is either a
      whitespace-delimited sequence of previous labels (created by
      SAVE PROOF <label> /NORMAL) or a compressed proof (created by
      SAVE PROOF <label> /COMPRESSED).  After using SAVE PROOF, use
      WRITE SOURCE to save the database file to disk.
  ${ ... $}
      Block for scoping the above statements (except $a, $p which are forever
      active).  Currently, $c may not occur inside of a block.
$)
  $( <any text> $)
$(    Comment.  Note: <any text> may not contain adjacent "$" and ")"
      characters.  The comment opening and closing delimiters must be
      surrounded by whitespace (space, tab, CR, LF, or FF).
  $[ <filename> $]
      Insert contents of <filename> at this point.  If <filename> is current
      file or has been already been inserted, it will not be inserted again.

Inside of comments, it is recommended that labels be preceded with a tilde (~)
and math symbol tokens be enclosed in grave accents (` `).  This way the LaTeX
and HTML rendition of comments will be accurate, and (future) tools to globally
change labels and math symbols will also change them in comments.  Note that
inside of grave accents a pair of grave accents is interpreted as a single
grave accent.  A special comment containing $ t defines LaTeX and HTML symbols.
See HELP LANGUAGE and HELP HTML for other markup features in comments.

The proofs in this file are in "compressed" format for storage efficiency.  The
Metamath program reads the compressed format directly.  This format is
described in an Appendix of the Metamath book.  It is not intended to be read
by humans.  For viewing proofs you should use the various SHOW PROOF commands
described in the Metamath book (or the on-line HELP).

The Metamath program does not normally affect any content of this file (set.mm)
other than proofs, i.e. tokens between "$=" and "$.".  All other content is
user-created.  Proofs are created or modified with the PROVE command.


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          5. Other notes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

1. It is recommended that you be familiar with chapters 2 and 4 of the
'Metamath' book to understand the Metamath language.  Chapters 2, 3 and 5
explain how to use the program.  Chapter 3 gives you an informal overview of
what this source file is all about.  Appendix A shows you the standard
mathematical symbols corresponding to some of the ASCII tokens in this file.

The ASCII tokens may seem cryptic at first, even if you are familiar with set
theory, but a review of the definition summary in Chapter 3 should quickly
enable you to see the correspondence to standard mathematical notation.  To
easily find the definition of a token, search for the first occurrences of the
token surrounded by spaces.  Some odd-looking ones include "-." for "not", and
"C_" for "is a subset of."  (HELP TEX tells you how to obtain a LaTeX output to
see the real mathematical symbols.)  Let me know if you have better suggestions
for naming ASCII tokens.


=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           6. Acceptable shorter proofs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Shorter proofs are welcome, and any shorter proof I accept will be acknowledged
in the theorem's description.  However, in some cases a proof may be "shorter"
or not depending on how it is formatted.  This section provides general
guidelines.

Usually I will automatically accept shorter proofs that (1) shorten the set.mm
file (with compressed proofs), (2) reduce the size of the HTML file generated
with SHOW STATEMENT xx / HTML, (3) use only existing, unmodified theorems in
the database (the order of theorems may be changed, though), and (4) use no
additional axioms.

Usually I will also automatically accept a _new_ theorem that is used to
shorten multiple proofs, if the total size of set.mm (including the comment of
the new theorem, not including the acknowledgment) decreases as a result.

In borderline cases, I typically place more importance on the number of
compressed proof steps and less on the length of the label section (since the
names are in principal arbitrary).  If two proofs have the same number of
compressed proof steps, I will typically give preference to the one with the
smaller number of different labels, or if these numbers are the same, the proof
with the fewest number of characters that the proofs happen to have by chance
when label lengths are included.

A few theorems have a longer proof than necessary in order to avoid the use of
certain axioms, for pedagogical purposes, and for other reasons.  These
theorems will (or should) have a "(Proof modification is discouraged.)" tag in
their description.  For example, id1 shows a proof directly from axioms.
Shorter proofs for such cases won't be accepted, of course, unless the criteria
described continues to be satisfied.

$)

$( End $[ set-header.mm $] $)

$( Begin $[ set-main.mm $] $)
$( Begin $[ set-pred.mm $] $)

$(
###############################################################################
            CLASSICAL FIRST ORDER LOGIC WITH EQUALITY
###############################################################################

  Logic can be defined as the "study of the principles of correct reasoning"
  (Merrilee H. Salmon's 1991 "Informal Reasoning and Informal Logic" in
  _Informal Reasoning and Education_ ) or as "a formal system using symbolic
  techniques and mathematical methods to establish truth-values" (the Oxford
  English Dictionary).

  This section formally defines the logic system we will use.  In particular,
  it defines symbols for declaring truthful statements, along with rules for
  deriving truthful statements from other truthful statements.  The system
  defined here is classical first order logic with equality (the most common
  logic system used by mathematicians).

  We begin with a few housekeeping items in pre-logic, and then introduce
  propositional calculus (both its axioms and important theorems that can be
  derived from them).  Propositional calculus deals with general truths about
  well-formed formulas (wffs) regardless of how they are constructed.  This is
  followed by proofs that other axiomatizations of classical propositional
  calculus can be derived from the axioms we have chosen to use.

  We then define predicate calculus, which adds additional symbols and rules
  useful for discussing objects (beyond simply true or false).  In particular,
  it introduces the symbols ` = ` ("equals"), ` e. ` ("is a member of"), and `
  A. ` ("for all").  The first two are called "predicates."  A predicate
  specifies a true or false relationship between its two arguments.

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Pre-logic
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  This section includes a few "housekeeping" mechanisms before we begin
  defining the basics of logic.

$)

  $( Declare the primitive constant symbols for propositional calculus. $)
  $c ( $.  $( Left parenthesis $)
  $c ) $.  $( Right parenthesis $)
  $c -> $. $( Right arrow (read:  "implies") $)
  $c -. $. $( Right handle (read:  "not") $)
  $c wff $. $( Well-formed formula symbol (read:  "the following symbol
               sequence is a wff") $)
  $c |- $. $( Turnstile (read:  "the following symbol sequence is provable" or
              'a proof exists for") $)

  $( Define the syntax and logical typecodes, and declare that our grammar is
     unambiguous (verifiable using the KLR parser, with compositing depth 5).
     (This $ j comment need not be read by verifiers, but is useful for parsers
     like mmj2.) $)
  $( $j
    syntax 'wff';
    syntax '|-' as 'wff';
    unambiguous 'klr 5';
  $)

  $( wff variable sequence:  ph ps ch th ta et ze si rh mu la ka $)
  $( Introduce some variable names we will use to represent well-formed
     formulas (wff's). $)
  $v ph $.  $( Greek phi $)
  $v ps $.  $( Greek psi $)
  $v ch $.  $( Greek chi $)
  $v th $.  $( Greek theta $)
  $v ta $.  $( Greek tau $)
  $v et $.  $( Greek eta $)
  $v ze $.  $( Greek zeta $)
  $v si $.  $( Greek sigma $)
  $v rh $.  $( Greek rho $)
  $v mu $.  $( Greek mu $)
  $v la $.  $( Greek lambda $)
  $v ka $.  $( Greek kappa $)

  $( Specify some variables that we will use to represent wff's.
     The fact that a variable represents a wff is relevant only to a theorem
     referring to that variable, so we may use $f hypotheses.  The symbol
     ` wff ` specifies that the variable that follows it represents a wff. $)
  $( Let variable ` ph ` be a wff. $)
  wph $f wff ph $.
  $( Let variable ` ps ` be a wff. $)
  wps $f wff ps $.
  $( Let variable ` ch ` be a wff. $)
  wch $f wff ch $.
  $( Let variable ` th ` be a wff. $)
  wth $f wff th $.
  $( Let variable ` ta ` be a wff. $)
  wta $f wff ta $.
  $( Let variable ` et ` be a wff. $)
  wet $f wff et $.
  $( Let variable ` ze ` be a wff. $)
  wze $f wff ze $.
  $( Let variable ` si ` be a wff. $)
  wsi $f wff si $.
  $( Let variable ` rh ` be a wff. $)
  wrh $f wff rh $.
  $( Let variable ` mu ` be a wff. $)
  wmu $f wff mu $.
  $( Let variable ` la ` be a wff. $)
  wla $f wff la $.
  $( Let variable ` ka ` be a wff. $)
  wka $f wff ka $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Inferences for assisting proof development
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    dummylink.1 $e |- ph $.
    dummylink.2 $e |- ps $.
    $( (_Note_:  This inference rule and the next one, ~ idi , will normally
       never appear in a completed proof.  It can be ignored if you are using
       this database to assist learning logic - please start with the statement
       ~ wn instead.)

       This is a technical inference to assist proof development.  It provides
       a temporary way to add an independent subproof to a proof under
       development, for later assignment to a normal proof step.

       The metamath program's Proof Assistant requires proofs to be developed
       backwards from the conclusion with no gaps, and it has no mechanism that
       lets the user to work on isolated subproofs.  This inference provides a
       workaround for this limitation.  It can be inserted at any point in a
       proof to allow an independent subproof to be developed on the side, for
       later use as part of the final proof.

       _Instructions_:  (1) Assign this inference to any unknown step in the
       proof.  Typically, the last unknown step is the most convenient, since
       'assign last' can be used.  This step will be replicated in hypothesis
       dummylink.1, from where the development of the main proof can continue.
       (2) Develop the independent subproof backwards from hypothesis
       dummylink.2.  If desired, use a 'let' command to pre-assign the
       conclusion of the independent subproof to dummylink.2.  (3) After the
       independent subproof is complete, use 'improve all' to assign it
       automatically to an unknown step in the main proof that matches it.  (4)
       After the entire proof is complete, use 'minimize *' to clean up
       (discard) all dummylink references automatically.

       This inference was originally designed to assist importing partially
       completed Proof Worksheets from the mmj2 Proof Assistant GUI, but it can
       also be useful on its own.  Interestingly, no axioms are required for
       its proof.  (Contributed by NM, 7-Feb-2006.) $)
    dummylink $p |- ph $=
      (  ) C $.
  $}

  ${
    idi.1 $e |- ph $.
    $( Inference form of ~ id .  This inference rule, which requires no axioms
       for its proof, is useful as a copy-paste mechanism during proof
       development in mmj2.  It is normally not referenced in the final version
       of a proof, since it is always redundant and can be removed using the
       'minimize *' command in the metamath program's Proof Assistant.
       (Contributed by Alan Sare, 31-Dec-2011.) $)
    idi $p |- ph $=
      (  ) B $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Propositional calculus
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  Propositional calculus deals with general truths about well-formed formulas
  (wffs) regardless of how they are constructed.  The simplest propositional
  truth is ` ( ph -> ph ) ` , which can be read "if something is true, then it
  is true" - rather trivial and obvious, but nonetheless it must be proved from
  the axioms (see theorem ~ id ).

  Our system of propositional calculus consists of three basic axioms and
  another axiom that defines the modus-ponens inference rule.  It is attributed
  to Jan Lukasiewicz (pronounced woo-kah-SHAY-vitch) and was popularized by
  Alonzo Church, who called it system P2.  (Thanks to Ted Ulrich for this
  information.)  These axioms are ~ ax-1 , ~ ax-2 , ~ ax-3 , and (for modus
  ponens) ~ ax-mp . Some closely followed texts include [Margaris] for the
  axioms and [WhiteheadRussell] for the theorems.

  The propositional calculus used here is the classical system widely used by
  mathematicians.  In particular, this logic system accepts the "law of the
  excluded middle" as proven in ~ exmid , which says that a logical statement
  is either true or not true.  This is an essential distinction of classical
  logic and is not a theorem of intuitionistic logic.

  All 194 axioms, definitions, and theorems for propositional calculus in
  _Principia Mathematica_ (specifically *1.2 through *5.75) are axioms or
  formally proven.  See the Bibliographic Cross-References at
  ~ http://us.metamath.org/mpeuni/mmbiblio.html for a complete
  cross-reference from sources used to its formalization in the Metamath
  Proof Explorer.

$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Recursively define primitive wffs for propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( If ` ph ` is a wff, so is ` -. ph ` or "not ` ph ` ."  Part of the
     recursive definition of a wff (well-formed formula).  In classical logic
     (which is our logic), a wff is interpreted as either true or false.  So if
     ` ph ` is true, then ` -. ph ` is false; if ` ph ` is false, then
     ` -. ph ` is true.  Traditionally, Greek letters are used to represent
     wffs, and we follow this convention.  In propositional calculus, we define
     only wffs built up from other wffs, i.e. there is no starting or "atomic"
     wff.  Later, in predicate calculus, we will extend the basic wff
     definition by including atomic wffs ( ~ weq and ~ wel ). $)
  wn $a wff -. ph $.

  $( If ` ph ` and ` ps ` are wff's, so is ` ( ph -> ps ) ` or " ` ph ` implies
     ` ps ` ."  Part of the recursive definition of a wff.  The resulting wff
     is (interpreted as) false when ` ph ` is true and ` ps ` is false; it is
     true otherwise.  Think of the truth table for an OR gate with input ` ph `
     connected through an inverter.  After we define the axioms of
     propositional calculus ( ~ ax-1 , ~ ax-2 , ~ ax-3 , and ~ ax-mp ), the
     biconditional ( ~ df-bi ), the constant true ` T. ` ( ~ df-tru ), and the
     constant false ` F. ` ( ~ df-fal ), we will be able to prove these truth
     table values: ` ( ( T. -> T. ) <-> T. ) ` ( ~ truimtru ),
     ` ( ( T. -> F. ) <-> F. ) ` ( ~ truimfal ), ` ( ( F. -> T. ) <-> T. ) `
     ( ~ falimtru ), and ` ( ( F. -> F. ) <-> T. ) ` ( ~ falimfal ).  These
     have straightforward meanings, for example, ` ( ( T. -> T. ) <-> T. ) `
     just means "the value of ` T. -> T. ` is ` T. ` ".

     The left-hand wff is called the antecedent, and the right-hand wff is
     called the consequent.  In the case of ` ( ph -> ( ps -> ch ) ) ` , the
     middle ` ps ` may be informally called either an antecedent or part of the
     consequent depending on context.  Contrast with ` <-> ` ( ~ df-bi ),
     ` /\ ` ( ~ df-an ), and ` \/ ` ( ~ df-or ).

     This is called "material implication" and the arrow is usually read as
     "implies."  However, material implication is not identical to the meaning
     of "implies" in natural language.  For example, the word "implies" may
     suggest a causal relationship in natural language.  Material implication
     does not require any causal relationship.  Also, note that in material
     implication, if the consequent is true then the wff is always true (even
     if the antecedent is false).  Thus, if "implies" means material
     implication, it is true that "if the moon is made of green cheese that
     implies that 5=5" (because 5=5).  Similarly, if the antecedent is false,
     the wff is always true.  Thus, it is true that, "if the moon made of green
     cheese that implies that 5=7" (because the moon is not actually made of
     green cheese).  A contradiction implies anything ( ~ pm2.21i ).  In short,
     material implication has a very specific technical definition, and
     misunderstandings of it are sometimes called "paradoxes of logical
     implication." $)
  wi $a wff ( ph -> ps ) $.

  $( Register '-.' and '->' as primitive expressions (lacking definitions). $)
  $( $j primitive 'wn' 'wi'; $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The axioms of propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Propositional calculus (axioms ~ ax-1 through ~ ax-3 and rule ~ ax-mp ) can
  be thought of as asserting formulas that are universally "true" when their
  variables are replaced by any combination of "true" and "false."
  Propositional calculus was first formalized by Frege in 1879, using as his
  axioms (in addition to rule ~ ax-mp ) the wffs ~ ax-1 , ~ ax-2 , ~ pm2.04 ,
  ~ con3 , ~ notnot2 , and ~ notnot1 . Around 1930, Lukasiewicz simplified the
  system by eliminating the third (which follows from the first two, as you can
  see by looking at the proof of ~ pm2.04 ) and replacing the last three with
  our ~ ax-3 . (Thanks to Ted Ulrich for this information.)

  The theorems of propositional calculus are also called _tautologies_.
  Tautologies can be proved very simply using truth tables, based on the
  true/false interpretation of propositional calculus.  To do this, we assign
  all possible combinations of true and false to the wff variables and verify
  that the result (using the rules described in ~ wi and ~ wn ) always
  evaluates to true.  This is called the _semantic_ approach.  Our approach is
  called the _syntactic_ approach, in which everything is derived from axioms.
  A metatheorem called the Completeness Theorem for Propositional Calculus
  shows that the two approaches are equivalent and even provides an algorithm
  for automatically generating syntactic proofs from a truth table.  Those
  proofs, however, tend to be long, since truth tables grow exponentially with
  the number of variables, and the much shorter proofs that we show here were
  found manually.

$)

  ${
    $( Minor premise for modus ponens. $)
    min $e |- ph $.
    $( Major premise for modus ponens. $)
    maj $e |- ( ph -> ps ) $.
    $( Rule of Modus Ponens.  The postulated inference rule of propositional
       calculus.  See e.g.  Rule 1 of [Hamilton] p. 73.  The rule says, "if
       ` ph ` is true, and ` ph ` implies ` ps ` , then ` ps ` must also be
       true."  This rule is sometimes called "detachment," since it detaches
       the minor premise from the major premise.  "Modus ponens" is short for
       "modus ponendo ponens," a Latin phrase that means "the mood that by
       affirming affirms" - remark in [Sanford] p. 39.  This rule is similar to
       the rule of modus tollens ~ mto .

       Note:  In some web page displays such as the Statement List, the symbols
       "&" and "=>" informally indicate the relationship between the hypotheses
       and the assertion (conclusion), abbreviating the English words "and" and
       "implies."  They are not part of the formal language.  (Contributed by
       NM, 5-Aug-1993.) $)
    ax-mp $a |- ps $.
  $}

  $( Axiom _Simp_.  Axiom A1 of [Margaris] p. 49.  One of the 3 axioms of
     propositional calculus.  The 3 axioms are also given as Definition 2.1 of
     [Hamilton] p. 28.  This axiom is called _Simp_ or "the principle of
     simplification" in _Principia Mathematica_ (Theorem *2.02 of
     [WhiteheadRussell] p. 100) because "it enables us to pass from the joint
     assertion of ` ph ` and ` ps ` to the assertion of ` ph ` simply."
     (Contributed by NM, 5-Aug-1993.) $)
  ax-1 $a |- ( ph -> ( ps -> ph ) ) $.

  $( Axiom _Frege_.  Axiom A2 of [Margaris] p. 49.  One of the 3 axioms of
     propositional calculus.  It "distributes" an antecedent over two
     consequents.  This axiom was part of Frege's original system and is known
     as _Frege_ in the literature.  It is also proved as Theorem *2.77 of
     [WhiteheadRussell] p. 108.  The other direction of this axiom also turns
     out to be true, as demonstrated by ~ pm5.41 .  (Contributed by NM,
     5-Aug-1993.) $)
  ax-2 $a |- ( ( ph -> ( ps -> ch ) ) -> ( ( ph -> ps ) -> ( ph -> ch ) ) ) $.

  $( Axiom _Transp_.  Axiom A3 of [Margaris] p. 49.  One of the 3 axioms of
     propositional calculus.  It swaps or "transposes" the order of the
     consequents when negation is removed.  An informal example is that the
     statement "if there are no clouds in the sky, it is not raining" implies
     the statement "if it is raining, there are clouds in the sky."  This axiom
     is called _Transp_ or "the principle of transposition" in _Principia
     Mathematica_ (Theorem *2.17 of [WhiteheadRussell] p. 103).  We will also
     use the term "contraposition" for this principle, although the reader is
     advised that in the field of philosophical logic, "contraposition" has a
     different technical meaning.  (Contributed by NM, 5-Aug-1993.) $)
  ax-3 $a |- ( ( -. ph -> -. ps ) -> ( ps -> ph ) ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical implication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  The results in this section are based on implication only, and avoid
  ax-3, so are intuitionistic.  In an implication, the wff before the
  arrow is called the "antecedent" and the wff after the arrow is called
  the "consequent."

  We will use the following descriptive terms very loosely:  A "closed form" or
  "tautology" has no $e hypotheses.  An "inference" has one or more $e
  hypotheses.  A "deduction" is an inference in which the hypotheses and the
  conclusion share the same antecedent.

$)

  ${
    mp2.1 $e |- ph $.
    mp2.2 $e |- ps $.
    mp2.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A double modus ponens inference.  See ~ mp2ALT for a shorter proof using
       two more axioms.  (Contributed by NM, 5-Apr-1994.)
       (Proof modification is discouraged.) $)
    mp2 $p |- ch $=
      ( wi ax-mp ) BCEABCGDFHH $.
  $}

  ${
    mp2b.1 $e |- ph $.
    mp2b.2 $e |- ( ph -> ps ) $.
    mp2b.3 $e |- ( ps -> ch ) $.
    $( A double modus ponens inference.  (Contributed by Mario Carneiro,
       24-Jan-2013.) $)
    mp2b $p |- ch $=
      ( ax-mp ) BCABDEGFG $.
  $}

  ${
    $( Premise for ~ a1i . $)
    a1i.1 $e |- ph $.
    $( Inference derived from axiom ~ ax-1 .  See ~ a1d for an explanation of
       our informal use of the terms "inference" and "deduction."  See also the
       comment in ~ syld .  (Contributed by NM, 5-Aug-1993.) $)
    a1i $p |- ( ps -> ph ) $=
      ( wi ax-1 ax-mp ) ABADCABEF $.
  $}

  ${
    mp1i.a $e |- ph $.
    mp1i.b $e |- ( ph -> ps ) $.
    $( Drop and replace an antecedent.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    mp1i $p |- ( ch -> ps ) $=
      ( ax-mp a1i ) BCABDEFG $.
  $}

  ${
    $( Premise for ~ a2i . $)
    a2i.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference derived from axiom ~ ax-2 .  (Contributed by NM,
       5-Aug-1993.) $)
    a2i $p |- ( ( ph -> ps ) -> ( ph -> ch ) ) $=
      ( wi ax-2 ax-mp ) ABCEEABEACEEDABCFG $.
  $}

  ${
    imim2i.1 $e |- ( ph -> ps ) $.
    $( Inference adding common antecedents in an implication.  (Contributed by
       NM, 5-Aug-1993.) $)
    imim2i $p |- ( ( ch -> ph ) -> ( ch -> ps ) ) $=
      ( wi a1i a2i ) CABABECDFG $.
  $}

  ${
    mpd.1 $e |- ( ph -> ps ) $.
    mpd.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A modus ponens deduction.  A translation of natural deduction rule
       ` -> ` E ( ` -> ` elimination), see ~ natded .  (Contributed by NM,
       5-Aug-1993.) $)
    mpd $p |- ( ph -> ch ) $=
      ( wi a2i ax-mp ) ABFACFDABCEGH $.
  $}

  ${
    $( First of 2 premises for ~ syl . $)
    syl.1 $e |- ( ph -> ps ) $.
    $( Second of 2 premises for ~ syl . $)
    syl.2 $e |- ( ps -> ch ) $.
    $( An inference version of the transitive laws for implication ~ imim2 and
       ~ imim1 , which Russell and Whitehead call "the principle of the
       syllogism...because...the syllogism in Barbara is derived from them"
       (quote after Theorem *2.06 of [WhiteheadRussell] p. 101).  Some authors
       call this law a "hypothetical syllogism."

       (A bit of trivia: this is the most commonly referenced assertion in our
       database.  In second place is ~ eqid , followed by ~ syl2anc ,
       ~ adantr , ~ syl3anc , and ~ ax-mp .  The Metamath program command 'show
       usage' shows the number of references.)  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by O'Cat, 20-Oct-2011.)  (Proof shortened
       by Wolf Lammen, 26-Jul-2012.) $)
    syl $p |- ( ph -> ch ) $=
      ( wi a1i mpd ) ABCDBCFAEGH $.
  $}

  ${
    mpi.1 $e |- ps $.
    mpi.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A nested modus ponens inference.  (Contributed by NM, 5-Aug-1993.)
       (Proof shortened by Stefan Allan, 20-Mar-2006.) $)
    mpi $p |- ( ph -> ch ) $=
      ( a1i mpd ) ABCBADFEG $.
  $}

  ${
    mp2ALT.1 $e |- ph $.
    mp2ALT.2 $e |- ps $.
    mp2ALT.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Alternate proof of ~ mp2 (shorter but uses two more axioms).
       (Contributed by Wolf Lammen, 23-Jul-2013.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    mp2ALT $p |- ch $=
      ( mpi ax-mp ) ACDABCEFGH $.
  $}

  ${
    3syl.1 $e |- ( ph -> ps ) $.
    3syl.2 $e |- ( ps -> ch ) $.
    3syl.3 $e |- ( ch -> th ) $.
    $( Inference chaining two syllogisms.  (Contributed by NM, 5-Aug-1993.) $)
    3syl $p |- ( ph -> th ) $=
      ( syl ) ACDABCEFHGH $.
  $}

  ${
    4syl.1 $e |- ( ph -> ps ) $.
    4syl.2 $e |- ( ps -> ch ) $.
    4syl.3 $e |- ( ch -> th ) $.
    4syl.4 $e |- ( th -> ta ) $.
    $( Inference chaining three syllogisms.  The use of this theorem is marked
       "discouraged" because it causes the "minimize" command to have very long
       run times.  However, feel free to override it to use directly or in
       small "minimize" runs.  (Contributed by BJ, 14-Jul-2018.)
       (New usage is discouraged.) $)
    4syl $p |- ( ph -> ta ) $=
      ( 3syl syl ) ADEABCDFGHJIK $.
  $}

  $( Principle of identity.  Theorem *2.08 of [WhiteheadRussell] p. 101.  For
     another version of the proof directly from axioms, see ~ id1 .
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Stefan Allan,
     20-Mar-2006.) $)
  id $p |- ( ph -> ph ) $=
    ( wi ax-1 mpd ) AAABZAAACAECD $.

  $( Principle of identity.  Theorem *2.08 of [WhiteheadRussell] p. 101.  This
     version is proved directly from the axioms for demonstration purposes.
     This proof is a popular example in the literature and is identical, step
     for step, to the proofs of Theorem 1 of [Margaris] p. 51, Example 2.7(a)
     of [Hamilton] p. 31, Lemma 10.3 of [BellMachover] p. 36, and Lemma 1.8 of
     [Mendelson] p. 36.  It is also "Our first proof" in Hirst and Hirst's _A
     Primer for Logic and Proof_ p. 17 (PDF p. 23) at
     ~ http://www.mathsci.appstate.edu/~~hirstjl/primer/hirst.pdf .  For a
     shorter version of the proof that takes advantage of previously proved
     theorems, see ~ id .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  id1 $p |- ( ph -> ph ) $=
    ( wi ax-1 ax-2 ax-mp ) AAABZBZFAACAFABBGFBAFCAFADEE $.

  $( Principle of identity with antecedent.  (Contributed by NM,
     26-Nov-1995.) $)
  idd $p |- ( ph -> ( ps -> ps ) ) $=
    ( wi id a1i ) BBCABDE $.

  ${
    a1d.1 $e |- ( ph -> ps ) $.
    $( Deduction introducing an embedded antecedent.

       _Naming convention_:  We often call a theorem a "deduction" and suffix
       its label with "d" whenever the hypotheses and conclusion are each
       prefixed with the same antecedent.  This allows us to use the theorem in
       places where (in traditional textbook formalizations) the standard
       Deduction Theorem would be used; here ` ph ` would be replaced with a
       conjunction ( ~ df-an ) of the hypotheses of the would-be deduction.  By
       contrast, we tend to call the simpler version with no common antecedent
       an "inference" and suffix its label with "i"; compare theorem ~ a1i .
       Finally, a "theorem" would be the form with no hypotheses; in this case
       the "theorem" form would be the original axiom ~ ax-1 .  We usually show
       the theorem form without a suffix on its label (e.g. ~ pm2.43 vs.
       ~ pm2.43i vs. ~ pm2.43d ).  When an inference is converted to a theorem
       by eliminating an "is a set" hypothesis, we sometimes suffix the theorem
       form with "g" (for "more general") as in ~ uniex vs. ~ uniexg .
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Stefan Allan,
       20-Mar-2006.) $)
    a1d $p |- ( ph -> ( ch -> ps ) ) $=
      ( wi ax-1 syl ) ABCBEDBCFG $.
  $}

  ${
    a2d.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Deduction distributing an embedded antecedent.  (Contributed by NM,
       23-Jun-1994.) $)
    a2d $p |- ( ph -> ( ( ps -> ch ) -> ( ps -> th ) ) ) $=
      ( wi ax-2 syl ) ABCDFFBCFBDFFEBCDGH $.
  $}

  ${
    a1ii.1 $e |- ch $.
    $( Add two antecedents to a wff.  See ~ a1iiALT for a shorter proof using
       one more axiom.  (Contributed by Jeff Hankins, 4-Aug-2009.)
       (Proof modification is discouraged.) $)
    a1ii $p |- ( ph -> ( ps -> ch ) ) $=
      ( wi a1i ) BCEACBDFF $.
  $}

  ${
    a1iiALT.1 $e |- ch $.
    $( Alternate proof of ~ a1ii (shorter but uses one more axiom).
       (Contributed by Wolf Lammen, 23-Jul-2013.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    a1iiALT $p |- ( ph -> ( ps -> ch ) ) $=
      ( a1i a1d ) ACBCADEF $.
  $}

  ${
    sylcom.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylcom.2 $e |- ( ps -> ( ch -> th ) ) $.
    $( Syllogism inference with commutation of antecedents.  (Contributed by
       NM, 29-Aug-2004.)  (Proof shortened by O'Cat, 2-Feb-2006.)  (Proof
       shortened by Stefan Allan, 23-Feb-2006.) $)
    sylcom $p |- ( ph -> ( ps -> th ) ) $=
      ( wi a2i syl ) ABCGBDGEBCDFHI $.
  $}

  ${
    syl5com.1 $e |- ( ph -> ps ) $.
    syl5com.2 $e |- ( ch -> ( ps -> th ) ) $.
    $( Syllogism inference with commuted antecedents.  (Contributed by NM,
       24-May-2005.) $)
    syl5com $p |- ( ph -> ( ch -> th ) ) $=
      ( a1d sylcom ) ACBDABCEGFH $.
  $}

  ${
    $( Premise for ~ com12 .  See ~ pm2.04 for the theorem form. $)
    com12.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference that swaps (commutes) antecedents in an implication.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       4-Aug-2012.) $)
    com12 $p |- ( ps -> ( ph -> ch ) ) $=
      ( id syl5com ) BBACBEDF $.
  $}

  ${
    syl5.1 $e |- ( ph -> ps ) $.
    syl5.2 $e |- ( ch -> ( ps -> th ) ) $.
    $( A syllogism rule of inference.  The first premise is used to replace the
       second antecedent of the second premise.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 25-May-2013.) $)
    syl5 $p |- ( ch -> ( ph -> th ) ) $=
      ( syl5com com12 ) ACDABCDEFGH $.
  $}

  ${
    syl6.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6.2 $e |- ( ch -> th ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the consequent of the first premise.  (Contributed by NM, 5-Aug-1993.)
       (Proof shortened by Wolf Lammen, 30-Jul-2012.) $)
    syl6 $p |- ( ph -> ( ps -> th ) ) $=
      ( wi a1i sylcom ) ABCDECDGBFHI $.
  $}

  ${
    syl56.1 $e |- ( ph -> ps ) $.
    syl56.2 $e |- ( ch -> ( ps -> th ) ) $.
    syl56.3 $e |- ( th -> ta ) $.
    $( Combine ~ syl5 and ~ syl6 .  (Contributed by NM, 14-Nov-2013.) $)
    syl56 $p |- ( ch -> ( ph -> ta ) ) $=
      ( syl6 syl5 ) ABCEFCBDEGHIJ $.
  $}

  ${
    syl6com.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6com.2 $e |- ( ch -> th ) $.
    $( Syllogism inference with commuted antecedents.  (Contributed by NM,
       25-May-2005.) $)
    syl6com $p |- ( ps -> ( ph -> th ) ) $=
      ( syl6 com12 ) ABDABCDEFGH $.
  $}

  ${
    mpcom.1 $e |- ( ps -> ph ) $.
    mpcom.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Modus ponens inference with commutation of antecedents.  (Contributed by
       NM, 17-Mar-1996.) $)
    mpcom $p |- ( ps -> ch ) $=
      ( com12 mpd ) BACDABCEFG $.
  $}

  ${
    syli.1 $e |- ( ps -> ( ph -> ch ) ) $.
    syli.2 $e |- ( ch -> ( ph -> th ) ) $.
    $( Syllogism inference with common nested antecedent.  (Contributed by NM,
       4-Nov-2004.) $)
    syli $p |- ( ps -> ( ph -> th ) ) $=
      ( com12 sylcom ) BACDECADFGH $.
  $}

  ${
    syl2im.1 $e |- ( ph -> ps ) $.
    syl2im.2 $e |- ( ch -> th ) $.
    syl2im.3 $e |- ( ps -> ( th -> ta ) ) $.
    $( Replace two antecedents.  Implication-only version of ~ syl2an .
       (Contributed by Wolf Lammen, 14-May-2013.) $)
    syl2im $p |- ( ph -> ( ch -> ta ) ) $=
      ( wi syl5 syl ) ABCEIFCDBEGHJK $.
  $}

  $( This theorem, called "Assertion," can be thought of as closed form of
     modus ponens ~ ax-mp .  Theorem *2.27 of [WhiteheadRussell] p. 104.
     (Contributed by NM, 5-Aug-1993.) $)
  pm2.27 $p |- ( ph -> ( ( ph -> ps ) -> ps ) ) $=
    ( wi id com12 ) ABCZABFDE $.

  ${
    mpdd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    mpdd.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A nested modus ponens deduction.  (Contributed by NM, 12-Dec-2004.) $)
    mpdd $p |- ( ph -> ( ps -> th ) ) $=
      ( wi a2d mpd ) ABCGBDGEABCDFHI $.
  $}

  ${
    mpid.1 $e |- ( ph -> ch ) $.
    mpid.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A nested modus ponens deduction.  (Contributed by NM, 14-Dec-2004.) $)
    mpid $p |- ( ph -> ( ps -> th ) ) $=
      ( a1d mpdd ) ABCDACBEGFH $.
  $}

  ${
    mpdi.1 $e |- ( ps -> ch ) $.
    mpdi.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A nested modus ponens deduction.  (Contributed by NM, 16-Apr-2005.)
       (Proof shortened by O'Cat, 15-Jan-2008.) $)
    mpdi $p |- ( ph -> ( ps -> th ) ) $=
      ( wi a1i mpdd ) ABCDBCGAEHFI $.
  $}

  ${
    mpii.1 $e |- ch $.
    mpii.2 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A doubly nested modus ponens inference.  (Contributed by NM,
       31-Dec-1993.)  (Proof shortened by Wolf Lammen, 31-Jul-2012.) $)
    mpii $p |- ( ph -> ( ps -> th ) ) $=
      ( a1i mpdi ) ABCDCBEGFH $.
  $}

  ${
    syld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syld.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( Syllogism deduction.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened
       by O'Cat, 19-Feb-2008.)  (Proof shortened by Wolf Lammen, 3-Aug-2012.)

       Notice that ~ syld has the same form as ~ syl with ` ph ` added in front
       of each hypothesis and conclusion.  When all theorems referenced in a
       proof are converted in this way, we can replace ` ph ` with a hypothesis
       of the proof, allowing the hypothesis to be eliminated with ~ id and
       become an antecedent.  The Deduction Theorem for propositional calculus,
       e.g.  Theorem 3 in [Margaris] p. 56, tells us that this procedure is
       always possible. $)
    syld $p |- ( ph -> ( ps -> th ) ) $=
      ( wi a1d mpdd ) ABCDEACDGBFHI $.
  $}

  ${
    mp2d.1 $e |- ( ph -> ps ) $.
    mp2d.2 $e |- ( ph -> ch ) $.
    mp2d.3 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A double modus ponens deduction.  (Contributed by NM, 23-May-2013.)
       (Proof shortened by Wolf Lammen, 23-Jul-2013.) $)
    mp2d $p |- ( ph -> th ) $=
      ( mpid mpd ) ABDEABCDFGHI $.
  $}

  ${
    a1dd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction introducing a nested embedded antecedent.  (Contributed by NM,
       17-Dec-2004.)  (Proof shortened by O'Cat, 15-Jan-2008.) $)
    a1dd $p |- ( ph -> ( ps -> ( th -> ch ) ) ) $=
      ( wi ax-1 syl6 ) ABCDCFECDGH $.
  $}

  ${
    pm2.43i.1 $e |- ( ph -> ( ph -> ps ) ) $.
    $( Inference absorbing redundant antecedent.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by O'Cat, 28-Nov-2008.) $)
    pm2.43i $p |- ( ph -> ps ) $=
      ( id mpd ) AABADCE $.
  $}

  ${
    pm2.43d.1 $e |- ( ph -> ( ps -> ( ps -> ch ) ) ) $.
    $( Deduction absorbing redundant antecedent.  (Contributed by NM,
       18-Aug-1993.)  (Proof shortened by O'Cat, 28-Nov-2008.) $)
    pm2.43d $p |- ( ph -> ( ps -> ch ) ) $=
      ( id mpdi ) ABBCBEDF $.
  $}

  ${
    pm2.43a.1 $e |- ( ps -> ( ph -> ( ps -> ch ) ) ) $.
    $( Inference absorbing redundant antecedent.  (Contributed by NM,
       7-Nov-1995.)  (Proof shortened by O'Cat, 28-Nov-2008.) $)
    pm2.43a $p |- ( ps -> ( ph -> ch ) ) $=
      ( id mpid ) BABCBEDF $.
  $}

  ${
    pm2.43b.1 $e |- ( ps -> ( ph -> ( ps -> ch ) ) ) $.
    $( Inference absorbing redundant antecedent.  (Contributed by NM,
       31-Oct-1995.) $)
    pm2.43b $p |- ( ph -> ( ps -> ch ) ) $=
      ( pm2.43a com12 ) BACABCDEF $.
  $}

  $( Absorption of redundant antecedent.  Also called the "Contraction" or
     "Hilbert" axiom.  Theorem *2.43 of [WhiteheadRussell] p. 106.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by O'Cat,
     15-Aug-2004.) $)
  pm2.43 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    ( wi pm2.27 a2i ) AABCBABDE $.

  ${
    imim2d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding nested antecedents.  (Contributed by NM,
       5-Aug-1993.) $)
    imim2d $p |- ( ph -> ( ( th -> ps ) -> ( th -> ch ) ) ) $=
      ( wi a1d a2d ) ADBCABCFDEGH $.
  $}

  $( A closed form of syllogism (see ~ syl ).  Theorem *2.05 of
     [WhiteheadRussell] p. 100.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 6-Sep-2012.) $)
  imim2 $p |- ( ( ph -> ps ) -> ( ( ch -> ph ) -> ( ch -> ps ) ) ) $=
    ( wi id imim2d ) ABDZABCGEF $.

  ${
    embantd.1 $e |- ( ph -> ps ) $.
    embantd.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( Deduction embedding an antecedent.  (Contributed by Wolf Lammen,
       4-Oct-2013.) $)
    embantd $p |- ( ph -> ( ( ps -> ch ) -> th ) ) $=
      ( wi imim2d mpid ) ABCGBDEACDBFHI $.
  $}

  ${
    3syld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3syld.2 $e |- ( ph -> ( ch -> th ) ) $.
    3syld.3 $e |- ( ph -> ( th -> ta ) ) $.
    $( Triple syllogism deduction.  (Contributed by Jeff Hankins,
       4-Aug-2009.) $)
    3syld $p |- ( ph -> ( ps -> ta ) ) $=
      ( syld ) ABDEABCDFGIHI $.
  $}

  ${
    sylsyld.1 $e |- ( ph -> ps ) $.
    sylsyld.2 $e |- ( ph -> ( ch -> th ) ) $.
    sylsyld.3 $e |- ( ps -> ( th -> ta ) ) $.
    $( Virtual deduction rule ~ e12 without virtual deduction symbols.
       (Contributed by Alan Sare, 20-Apr-2011.) $)
    sylsyld $p |- ( ph -> ( ch -> ta ) ) $=
      ( wi syl syld ) ACDEGABDEIFHJK $.
  $}

  ${
    imim12i.1 $e |- ( ph -> ps ) $.
    imim12i.2 $e |- ( ch -> th ) $.
    $( Inference joining two implications.  (Contributed by NM, 5-Aug-1993.)
       (Proof shortened by O'Cat, 29-Oct-2011.) $)
    imim12i $p |- ( ( ps -> ch ) -> ( ph -> th ) ) $=
      ( wi imim2i syl5 ) ABBCGDECDBFHI $.
  $}

  ${
    imim1i.1 $e |- ( ph -> ps ) $.
    $( Inference adding common consequents in an implication, thereby
       interchanging the original antecedent and consequent.  (Contributed by
       NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 4-Aug-2012.) $)
    imim1i $p |- ( ( ps -> ch ) -> ( ph -> ch ) ) $=
      ( id imim12i ) ABCCDCEF $.
  $}

  ${
    imim3i.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference adding three nested antecedents.  (Contributed by NM,
       19-Dec-2006.) $)
    imim3i $p |- ( ( th -> ph ) -> ( ( th -> ps ) -> ( th -> ch ) ) ) $=
      ( wi imim2i a2d ) DAFDBCABCFDEGH $.
  $}

  ${
    sylc.1 $e |- ( ph -> ps ) $.
    sylc.2 $e |- ( ph -> ch ) $.
    sylc.3 $e |- ( ps -> ( ch -> th ) ) $.
    $( A syllogism inference combined with contraction.  (Contributed by NM,
       4-May-1994.)  (Revised by NM, 13-Jul-2013.) $)
    sylc $p |- ( ph -> th ) $=
      ( syl2im pm2.43i ) ADABACDEFGHI $.
  $}

  ${
    syl3c.1 $e |- ( ph -> ps ) $.
    syl3c.2 $e |- ( ph -> ch ) $.
    syl3c.3 $e |- ( ph -> th ) $.
    syl3c.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( A syllogism inference combined with contraction. ~ e111 without virtual
       deductions.  (Contributed by Alan Sare, 7-Jul-2011.) $)
    syl3c $p |- ( ph -> ta ) $=
      ( wi sylc mpd ) ADEHABCDEJFGIKL $.
  $}

  ${
    syl6mpi.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6mpi.2 $e |- th $.
    syl6mpi.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( ~ e20 without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof shortened by Wolf Lammen, 13-Sep-2012.) $)
    syl6mpi $p |- ( ph -> ( ps -> ta ) ) $=
      ( mpi syl6 ) ABCEFCDEGHIJ $.
  $}

  ${
    mpsyl.1 $e |- ph $.
    mpsyl.2 $e |- ( ps -> ch ) $.
    mpsyl.3 $e |- ( ph -> ( ch -> th ) ) $.
    $( Modus ponens combined with a syllogism inference.  (Contributed by Alan
       Sare, 20-Apr-2011.) $)
    mpsyl $p |- ( ps -> th ) $=
      ( a1i sylc ) BACDABEHFGI $.
  $}

  ${
    syl6c.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6c.2 $e |- ( ph -> ( ps -> th ) ) $.
    syl6c.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( Inference combining ~ syl6 with contraction.  (Contributed by Alan Sare,
       2-May-2011.) $)
    syl6c $p |- ( ph -> ( ps -> ta ) ) $=
      ( wi syl6 mpdd ) ABDEGABCDEIFHJK $.
  $}

  ${
    syldd.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syldd.2 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    $( Nested syllogism deduction.  (Contributed by NM, 12-Dec-2004.)  (Proof
       shortened by Wolf Lammen, 11-May-2013.) $)
    syldd $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      ( wi imim2 syl6c ) ABDEHCDHCEHGFDECIJ $.
  $}

  ${
    syl5d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl5d.2 $e |- ( ph -> ( th -> ( ch -> ta ) ) ) $.
    $( A nested syllogism deduction.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Josh Purinton, 29-Dec-2000.)  (Proof shortened by O'Cat,
       2-Feb-2006.) $)
    syl5d $p |- ( ph -> ( th -> ( ps -> ta ) ) ) $=
      ( wi a1d syldd ) ADBCEABCHDFIGJ $.
  $}

  ${
    syl7.1 $e |- ( ph -> ps ) $.
    syl7.2 $e |- ( ch -> ( th -> ( ps -> ta ) ) ) $.
    $( A syllogism rule of inference.  The first premise is used to replace the
       third antecedent of the second premise.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 3-Aug-2012.) $)
    syl7 $p |- ( ch -> ( th -> ( ph -> ta ) ) ) $=
      ( wi a1i syl5d ) CABDEABHCFIGJ $.
  $}

  ${
    syl6d.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl6d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( A nested syllogism deduction.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Josh Purinton, 29-Dec-2000.)  (Proof shortened by O'Cat,
       2-Feb-2006.) $)
    syl6d $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      ( wi a1d syldd ) ABCDEFADEHBGIJ $.
  $}

  ${
    syl8.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl8.2 $e |- ( th -> ta ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the consequent of the first premise.  (Contributed by NM, 1-Aug-1994.)
       (Proof shortened by Wolf Lammen, 3-Aug-2012.) $)
    syl8 $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      ( wi a1i syl6d ) ABCDEFDEHAGIJ $.
  $}

  ${
    syl9.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl9.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( A nested syllogism inference with different antecedents.  (Contributed
       by NM, 5-Aug-1993.)  (Proof shortened by Josh Purinton, 29-Dec-2000.) $)
    syl9 $p |- ( ph -> ( th -> ( ps -> ta ) ) ) $=
      ( wi a1i syl5d ) ABCDEFDCEHHAGIJ $.
  $}

  ${
    syl9r.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl9r.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( A nested syllogism inference with different antecedents.  (Contributed
       by NM, 5-Aug-1993.) $)
    syl9r $p |- ( th -> ( ph -> ( ps -> ta ) ) ) $=
      ( wi syl9 com12 ) ADBEHABCDEFGIJ $.
  $}

  ${
    imim12d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    imim12d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( Deduction combining antecedents and consequents.  (Contributed by NM,
       7-Aug-1994.)  (Proof shortened by O'Cat, 30-Oct-2011.) $)
    imim12d $p |- ( ph -> ( ( ch -> th ) -> ( ps -> ta ) ) ) $=
      ( wi imim2d syl5d ) ABCCDHEFADECGIJ $.
  $}

  ${
    imim1d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding nested consequents.  (Contributed by NM, 3-Apr-1994.)
       (Proof shortened by Wolf Lammen, 12-Sep-2012.) $)
    imim1d $p |- ( ph -> ( ( ch -> th ) -> ( ps -> th ) ) ) $=
      ( idd imim12d ) ABCDDEADFG $.
  $}

  $( A closed form of syllogism (see ~ syl ).  Theorem *2.06 of
     [WhiteheadRussell] p. 100.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 25-May-2013.) $)
  imim1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( wi id imim1d ) ABDZABCGEF $.

  $( Theorem *2.83 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.83 $p |- ( ( ph -> ( ps -> ch ) )
      -> ( ( ph -> ( ch -> th ) ) -> ( ph -> ( ps -> th ) ) ) ) $=
    ( wi imim1 imim3i ) BCECDEBDEABCDFG $.

  ${
    com3.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Commutation of antecedents.  Swap 2nd and 3rd.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 4-Aug-2012.) $)
    com23 $p |- ( ph -> ( ch -> ( ps -> th ) ) ) $=
      ( wi pm2.27 syl9 ) ABCDFCDECDGH $.

    $( Commutation of antecedents.  Rotate right.  (Contributed by NM,
       25-Apr-1994.) $)
    com3r $p |- ( ch -> ( ph -> ( ps -> th ) ) ) $=
      ( wi com23 com12 ) ACBDFABCDEGH $.

    $( Commutation of antecedents.  Swap 1st and 3rd.  (Contributed by NM,
       25-Apr-1994.)  (Proof shortened by Wolf Lammen, 28-Jul-2012.) $)
    com13 $p |- ( ch -> ( ps -> ( ph -> th ) ) ) $=
      ( com3r com23 ) CABDABCDEFG $.

    $( Commutation of antecedents.  Rotate left.  (Contributed by NM,
       25-Apr-1994.)  (Proof shortened by Wolf Lammen, 28-Jul-2012.) $)
    com3l $p |- ( ps -> ( ch -> ( ph -> th ) ) ) $=
      ( com3r ) CABDABCDEFF $.
  $}

  $( Swap antecedents.  Theorem *2.04 of [WhiteheadRussell] p. 100.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
     12-Sep-2012.) $)
  pm2.04 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ps -> ( ph -> ch ) ) ) $=
    ( wi id com23 ) ABCDDZABCGEF $.

  ${
    com4.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $.
    $( Commutation of antecedents.  Swap 3rd and 4th.  (Contributed by NM,
       25-Apr-1994.) $)
    com34 $p |- ( ph -> ( ps -> ( th -> ( ch -> ta ) ) ) ) $=
      ( wi pm2.04 syl6 ) ABCDEGGDCEGGFCDEHI $.

    $( Commutation of antecedents.  Rotate left.  (Contributed by NM,
       25-Apr-1994.)  (Proof shortened by O'Cat, 15-Aug-2004.) $)
    com4l $p |- ( ps -> ( ch -> ( th -> ( ph -> ta ) ) ) ) $=
      ( wi com3l com34 ) BCADEABCDEGFHI $.

    $( Commutation of antecedents.  Rotate twice.  (Contributed by NM,
       25-Apr-1994.) $)
    com4t $p |- ( ch -> ( th -> ( ph -> ( ps -> ta ) ) ) ) $=
      ( com4l ) BCDAEABCDEFGG $.

    $( Commutation of antecedents.  Rotate right.  (Contributed by NM,
       25-Apr-1994.) $)
    com4r $p |- ( th -> ( ph -> ( ps -> ( ch -> ta ) ) ) ) $=
      ( com4t com4l ) CDABEABCDEFGH $.

    $( Commutation of antecedents.  Swap 2nd and 4th.  (Contributed by NM,
       25-Apr-1994.)  (Proof shortened by Wolf Lammen, 28-Jul-2012.) $)
    com24 $p |- ( ph -> ( th -> ( ch -> ( ps -> ta ) ) ) ) $=
      ( wi com4t com13 ) CDABEGABCDEFHI $.

    $( Commutation of antecedents.  Swap 1st and 4th.  (Contributed by NM,
       25-Apr-1994.)  (Proof shortened by Wolf Lammen, 28-Jul-2012.) $)
    com14 $p |- ( th -> ( ps -> ( ch -> ( ph -> ta ) ) ) ) $=
      ( wi com4l com3r ) BCDAEGABCDEFHI $.
  $}

  ${
    com5.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( Commutation of antecedents.  Swap 4th and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com45 $p |- ( ph -> ( ps -> ( ch -> ( ta -> ( th -> et ) ) ) ) ) $=
      ( wi pm2.04 syl8 ) ABCDEFHHEDFHHGDEFIJ $.

    $( Commutation of antecedents.  Swap 3rd and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com35 $p |- ( ph -> ( ps -> ( ta -> ( th -> ( ch -> et ) ) ) ) ) $=
      ( wi com34 com45 ) ABDECFHABDCEFABCDEFHGIJI $.

    $( Commutation of antecedents.  Swap 2nd and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com25 $p |- ( ph -> ( ta -> ( ch -> ( th -> ( ps -> et ) ) ) ) ) $=
      ( wi com24 com45 ) ADCEBFHADCBEFABCDEFHGIJI $.

    $( Commutation of antecedents.  Rotate left.  (Contributed by Jeff Hankins,
       28-Jun-2009.)  (Proof shortened by Wolf Lammen, 29-Jul-2012.) $)
    com5l $p |- ( ps -> ( ch -> ( th -> ( ta -> ( ph -> et ) ) ) ) ) $=
      ( wi com4l com45 ) BCDAEFABCDEFHGIJ $.

    $( Commutation of antecedents.  Swap 1st and 5th.  (Contributed by Jeff
       Hankins, 28-Jun-2009.)  (Proof shortened by Wolf Lammen,
       29-Jul-2012.) $)
    com15 $p |- ( ta -> ( ps -> ( ch -> ( th -> ( ph -> et ) ) ) ) ) $=
      ( wi com5l com4r ) BCDEAFHABCDEFGIJ $.

    $( Commutation of antecedents.  Rotate left twice.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com52l $p |- ( ch -> ( th -> ( ta -> ( ph -> ( ps -> et ) ) ) ) ) $=
      ( com5l ) BCDEAFABCDEFGHH $.

    $( Commutation of antecedents.  Rotate right twice.  (Contributed by Jeff
       Hankins, 28-Jun-2009.) $)
    com52r $p |- ( th -> ( ta -> ( ph -> ( ps -> ( ch -> et ) ) ) ) ) $=
      ( com52l com5l ) CDEABFABCDEFGHI $.

    $( Commutation of antecedents.  Rotate right.  (Contributed by Wolf Lammen,
       29-Jul-2012.) $)
    com5r $p |- ( ta -> ( ph -> ( ps -> ( ch -> ( th -> et ) ) ) ) ) $=
      ( com52l ) CDEABFABCDEFGHH $.
  $}

  $( Elimination of a nested antecedent as a kind of reversal of inference
     ~ ja .  (Contributed by Wolf Lammen, 9-May-2013.) $)
  jarr $p |- ( ( ( ph -> ps ) -> ch ) -> ( ps -> ch ) ) $=
    ( wi ax-1 imim1i ) BABDCBAEF $.

  ${
    pm2.86i.1 $e |- ( ( ph -> ps ) -> ( ph -> ch ) ) $.
    $( Inference based on ~ pm2.86 .  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 3-Apr-2013.) $)
    pm2.86i $p |- ( ph -> ( ps -> ch ) ) $=
      ( wi ax-1 syl com12 ) BACBABEACEBAFDGH $.
  $}

  ${
    pm2.86d.1 $e |- ( ph -> ( ( ps -> ch ) -> ( ps -> th ) ) ) $.
    $( Deduction based on ~ pm2.86 .  (Contributed by NM, 29-Jun-1995.)  (Proof
       shortened by Wolf Lammen, 3-Apr-2013.) $)
    pm2.86d $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( wi ax-1 syl5 com23 ) ACBDCBCFABDFCBGEHI $.
  $}

  $( Converse of axiom ~ ax-2 .  Theorem *2.86 of [WhiteheadRussell] p. 108.
     (Contributed by NM, 25-Apr-1994.)  (Proof shortened by Wolf Lammen,
     3-Apr-2013.) $)
  pm2.86 $p |- ( ( ( ph -> ps )
       -> ( ph -> ch ) ) -> ( ph -> ( ps -> ch ) ) ) $=
    ( wi id pm2.86d ) ABDACDDZABCGEF $.

  $( The Linearity Axiom of the infinite-valued sentential logic (L-infinity)
     of Lukasiewicz.  (Contributed by O'Cat, 12-Aug-2004.)
     (Proof modification is discouraged.) $)
  loolin $p |- ( ( ( ph -> ps ) -> ( ps -> ph ) ) -> ( ps -> ph ) ) $=
    ( wi jarr pm2.43d ) ABCBACZCBAABFDE $.

  $( An alternate for the Linearity Axiom of the infinite-valued sentential
     logic (L-infinity) of Lukasiewicz, due to Barbara Wozniakowska, _Reports
     on Mathematical Logic_ 10, 129-137 (1978).  (Contributed by O'Cat,
     8-Aug-2004.) $)
  loowoz $p |- ( ( ( ph -> ps ) -> ( ph -> ch ) )
      -> ( ( ps -> ph ) -> ( ps -> ch ) ) ) $=
    ( wi jarr a2d ) ABDACDZDBACABGEF $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical negation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  This section makes our first use of the third axiom of propositional
  calculus, ~ ax-3 .

$)

  ${
    con4d.1 $e |- ( ph -> ( -. ps -> -. ch ) ) $.
    $( Deduction derived from axiom ~ ax-3 .  (Contributed by NM,
       26-Mar-1995.) $)
    con4d $p |- ( ph -> ( ch -> ps ) ) $=
      ( wn wi ax-3 syl ) ABECEFCBFDBCGH $.
  $}

  ${
    pm2.21d.1 $e |- ( ph -> -. ps ) $.
    $( A contradiction implies anything.  Deduction from ~ pm2.21 .
       (Contributed by NM, 10-Feb-1996.) $)
    pm2.21d $p |- ( ph -> ( ps -> ch ) ) $=
      ( wn a1d con4d ) ACBABECEDFG $.
  $}

  ${
    pm2.21dd.1 $e |- ( ph -> ps ) $.
    pm2.21dd.2 $e |- ( ph -> -. ps ) $.
    $( A contradiction implies anything.  Deduction from ~ pm2.21 .
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    pm2.21dd $p |- ( ph -> ch ) $=
      ( pm2.21d mpd ) ABCDABCEFG $.
  $}

  $( From a wff and its negation, anything is true.  Theorem *2.21 of
     [WhiteheadRussell] p. 104.  Also called the Duns Scotus law.  (Contributed
     by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 14-Sep-2012.) $)
  pm2.21 $p |- ( -. ph -> ( ph -> ps ) ) $=
    ( wn id pm2.21d ) ACZABFDE $.

  $( Theorem *2.24 of [WhiteheadRussell] p. 104.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.24 $p |- ( ph -> ( -. ph -> ps ) ) $=
    ( wn pm2.21 com12 ) ACABABDE $.

  $( Proof by contradiction.  Theorem *2.18 of [WhiteheadRussell] p. 103.  Also
     called the Law of Clavius.  (Contributed by NM, 5-Aug-1993.) $)
  pm2.18 $p |- ( ( -. ph -> ph ) -> ph ) $=
    ( wn wi pm2.21 a2i con4d pm2.43i ) ABZACZAIAIHAIBZAJDEFG $.

  ${
    pm2.18d.1 $e |- ( ph -> ( -. ps -> ps ) ) $.
    $( Deduction based on reductio ad absurdum.  (Contributed by FL,
       12-Jul-2009.)  (Proof shortened by Andrew Salmon, 7-May-2011.) $)
    pm2.18d $p |- ( ph -> ps ) $=
      ( wn wi pm2.18 syl ) ABDBEBCBFG $.
  $}

  $( Converse of double negation.  Theorem *2.14 of [WhiteheadRussell] p. 102.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by David Harvey,
     5-Sep-1999.)  (Proof shortened by Josh Purinton, 29-Dec-2000.) $)
  notnot2 $p |- ( -. -. ph -> ph ) $=
    ( wn pm2.21 pm2.18d ) ABZBAEACD $.

  ${
    notnotrd.1 $e |- ( ph -> -. -. ps ) $.
    $( Deduction converting double-negation into the original wff, aka the
       double negation rule.  A translation of natural deduction rule ` -. -. `
       -C, ` _G |- -. -. ps ` => ` _G |- ps ` ; see ~ natded .  This is
       definition NNC in [Pfenning] p. 17.  This rule is valid in classical
       logic (which MPE uses), but not intuitionistic logic.  (Contributed by
       DAW, 8-Feb-2017.) $)
    notnotrd $p |- ( ph -> ps ) $=
      ( wn notnot2 syl ) ABDDBCBEF $.
  $}

  ${
    notnotri.1 $e |- -. -. ph $.
    $( Inference from double negation.  (Contributed by NM, 27-Feb-2008.) $)
    notnotri $p |- ph $=
      ( wn notnot2 ax-mp ) ACCABADE $.
  $}

  ${
    con2d.1 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( A contraposition deduction.  (Contributed by NM, 19-Aug-1993.) $)
    con2d $p |- ( ph -> ( ch -> -. ps ) ) $=
      ( wn notnot2 syl5 con4d ) ABEZCIEBACEBFDGH $.
  $}

  $( Contraposition.  Theorem *2.03 of [WhiteheadRussell] p. 100.  (Contributed
     by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 12-Feb-2013.) $)
  con2 $p |- ( ( ph -> -. ps ) -> ( ps -> -. ph ) ) $=
    ( wn wi id con2d ) ABCDZABGEF $.

  ${
    mt2d.1 $e |- ( ph -> ch ) $.
    mt2d.2 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( Modus tollens deduction.  (Contributed by NM, 4-Jul-1994.) $)
    mt2d $p |- ( ph -> -. ps ) $=
      ( wn con2d mpd ) ACBFDABCEGH $.
  $}

  ${
    mt2i.1 $e |- ch $.
    mt2i.2 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( Modus tollens inference.  (Contributed by NM, 26-Mar-1995.)  (Proof
       shortened by Wolf Lammen, 15-Sep-2012.) $)
    mt2i $p |- ( ph -> -. ps ) $=
      ( a1i mt2d ) ABCCADFEG $.
  $}

  ${
    nsyl3.1 $e |- ( ph -> -. ps ) $.
    nsyl3.2 $e |- ( ch -> ps ) $.
    $( A negated syllogism inference.  (Contributed by NM, 1-Dec-1995.) $)
    nsyl3 $p |- ( ch -> -. ph ) $=
      ( wn wi a1i mt2d ) CABEABFGCDHI $.
  $}

  ${
    con2i.a $e |- ( ph -> -. ps ) $.
    $( A contraposition inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by O'Cat, 28-Nov-2008.)  (Proof shortened by Wolf Lammen,
       13-Jun-2013.) $)
    con2i $p |- ( ps -> -. ph ) $=
      ( id nsyl3 ) ABBCBDE $.
  $}

  ${
    nsyl.1 $e |- ( ph -> -. ps ) $.
    nsyl.2 $e |- ( ch -> ps ) $.
    $( A negated syllogism inference.  (Contributed by NM, 31-Dec-1993.)
       (Proof shortened by Wolf Lammen, 2-Mar-2013.) $)
    nsyl $p |- ( ph -> -. ch ) $=
      ( nsyl3 con2i ) CAABCDEFG $.
  $}

  $( Converse of double negation.  Theorem *2.12 of [WhiteheadRussell] p. 101.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
     2-Mar-2013.) $)
  notnot1 $p |- ( ph -> -. -. ph ) $=
    ( wn id con2i ) ABZAECD $.

  ${
    negbi.1 $e |- ph $.
    $( Infer double negation.  (Contributed by NM, 27-Feb-2008.) $)
    notnoti $p |- -. -. ph $=
      ( wn notnot1 ax-mp ) AACCBADE $.
  $}

  ${
    con1d.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( A contraposition deduction.  (Contributed by NM, 5-Aug-1993.) $)
    con1d $p |- ( ph -> ( -. ch -> ps ) ) $=
      ( wn notnot1 syl6 con4d ) ABCEZABECIEDCFGH $.
  $}

  ${
    mt3d.1 $e |- ( ph -> -. ch ) $.
    mt3d.2 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Modus tollens deduction.  (Contributed by NM, 26-Mar-1995.) $)
    mt3d $p |- ( ph -> ps ) $=
      ( wn con1d mpd ) ACFBDABCEGH $.
  $}

  ${
    mt3i.1 $e |- -. ch $.
    mt3i.2 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Modus tollens inference.  (Contributed by NM, 26-Mar-1995.)  (Proof
       shortened by Wolf Lammen, 15-Sep-2012.) $)
    mt3i $p |- ( ph -> ps ) $=
      ( wn a1i mt3d ) ABCCFADGEH $.
  $}

  ${
    nsyl2.1 $e |- ( ph -> -. ps ) $.
    nsyl2.2 $e |- ( -. ch -> ps ) $.
    $( A negated syllogism inference.  (Contributed by NM, 26-Jun-1994.) $)
    nsyl2 $p |- ( ph -> ch ) $=
      ( wn wi a1i mt3d ) ACBDCFBGAEHI $.
  $}

  $( Contraposition.  Theorem *2.15 of [WhiteheadRussell] p. 102.  (Contributed
     by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 12-Feb-2013.) $)
  con1 $p |- ( ( -. ph -> ps ) -> ( -. ps -> ph ) ) $=
    ( wn wi id con1d ) ACBDZABGEF $.

  ${
    con1i.a $e |- ( -. ph -> ps ) $.
    $( A contraposition inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by O'Cat, 28-Nov-2008.)  (Proof shortened by Wolf Lammen,
       19-Jun-2013.) $)
    con1i $p |- ( -. ps -> ph ) $=
      ( wn id nsyl2 ) BDZBAGECF $.
  $}

  ${
    con4i.1 $e |- ( -. ph -> -. ps ) $.
    $( Inference rule derived from axiom ~ ax-3 .  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 21-Jun-2013.) $)
    con4i $p |- ( ps -> ph ) $=
      ( wn notnot1 nsyl2 ) BBDABECF $.
  $}

  ${
    pm2.21i.1 $e |- -. ph $.
    $( A contradiction implies anything.  Inference from ~ pm2.21 .
       (Contributed by NM, 16-Sep-1993.) $)
    pm2.21i $p |- ( ph -> ps ) $=
      ( wn a1i con4i ) BAADBDCEF $.
  $}

  ${
    pm2.24ii.1 $e |- ph $.
    pm2.24ii.2 $e |- -. ph $.
    $( A contradiction implies anything.  Inference from ~ pm2.24 .
       (Contributed by NM, 27-Feb-2008.) $)
    pm2.24ii $p |- ps $=
      ( pm2.21i ax-mp ) ABCABDEF $.
  $}

  ${
    con3d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( A contraposition deduction.  (Contributed by NM, 5-Aug-1993.) $)
    con3d $p |- ( ph -> ( -. ch -> -. ps ) ) $=
      ( wn notnot2 syl5 con1d ) ABEZCIEBACBFDGH $.
  $}

  $( Contraposition.  Theorem *2.16 of [WhiteheadRussell] p. 103.  (Contributed
     by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 13-Feb-2013.) $)
  con3 $p |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) $=
    ( wi id con3d ) ABCZABFDE $.

  ${
    con3i.a $e |- ( ph -> ps ) $.
    $( A contraposition inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 20-Jun-2013.) $)
    con3i $p |- ( -. ps -> -. ph ) $=
      ( wn id nsyl ) BDZBAGECF $.
  $}

  ${
    con3rr3.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Rotate through consequent right.  (Contributed by Wolf Lammen,
       3-Nov-2013.) $)
    con3rr3 $p |- ( -. ch -> ( ph -> -. ps ) ) $=
      ( wn con3d com12 ) ACEBEABCDFG $.
  $}

  ${
    mt4.1 $e |- ph $.
    mt4.2 $e |- ( -. ps -> -. ph ) $.
    $( The rule of modus tollens.  (Contributed by Wolf Lammen,
       12-May-2013.) $)
    mt4 $p |- ps $=
      ( con4i ax-mp ) ABCBADEF $.
  $}

  ${
    mt4d.1 $e |- ( ph -> ps ) $.
    mt4d.2 $e |- ( ph -> ( -. ch -> -. ps ) ) $.
    $( Modus tollens deduction.  (Contributed by NM, 9-Jun-2006.) $)
    mt4d $p |- ( ph -> ch ) $=
      ( con4d mpd ) ABCDACBEFG $.
  $}

  ${
    mt4i.1 $e |- ch $.
    mt4i.2 $e |- ( ph -> ( -. ps -> -. ch ) ) $.
    $( Modus tollens inference.  (Contributed by Wolf Lammen, 12-May-2013.) $)
    mt4i $p |- ( ph -> ps ) $=
      ( a1i mt4d ) ACBCADFEG $.
  $}

  ${
    nsyld.1 $e |- ( ph -> ( ps -> -. ch ) ) $.
    nsyld.2 $e |- ( ph -> ( ta -> ch ) ) $.
    $( A negated syllogism deduction.  (Contributed by NM, 9-Apr-2005.) $)
    nsyld $p |- ( ph -> ( ps -> -. ta ) ) $=
      ( wn con3d syld ) ABCGDGEADCFHI $.
  $}

  ${
    nsyli.1 $e |- ( ph -> ( ps -> ch ) ) $.
    nsyli.2 $e |- ( th -> -. ch ) $.
    $( A negated syllogism inference.  (Contributed by NM, 3-May-1994.) $)
    nsyli $p |- ( ph -> ( th -> -. ps ) ) $=
      ( wn con3d syl5 ) DCGABGFABCEHI $.
  $}

  ${
    nsyl4.1 $e |- ( ph -> ps ) $.
    nsyl4.2 $e |- ( -. ph -> ch ) $.
    $( A negated syllogism inference.  (Contributed by NM, 15-Feb-1996.) $)
    nsyl4 $p |- ( -. ch -> ps ) $=
      ( wn con1i syl ) CFABACEGDH $.
  $}

  ${
    pm2.24d.1 $e |- ( ph -> ps ) $.
    $( Deduction version of ~ pm2.24 .  (Contributed by NM, 30-Jan-2006.) $)
    pm2.24d $p |- ( ph -> ( -. ps -> ch ) ) $=
      ( wn a1d con1d ) ACBABCEDFG $.
  $}

  ${
    pm2.24i.1 $e |- ph $.
    $( Inference version of ~ pm2.24 .  (Contributed by NM, 20-Aug-2001.) $)
    pm2.24i $p |- ( -. ph -> ps ) $=
      ( wn a1i con1i ) BAABDCEF $.
  $}

  $( Theorem *3.2 of [WhiteheadRussell] p. 111, expressed with primitive
     connectives.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Josh
     Purinton, 29-Dec-2000.) $)
  pm3.2im $p |- ( ph -> ( ps -> -. ( ph -> -. ps ) ) ) $=
    ( wn wi pm2.27 con2d ) AABCZDBAGEF $.

  $( Theorem 8 of [Margaris] p. 60.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Josh Purinton, 29-Dec-2000.) $)
  mth8 $p |- ( ph -> ( -. ps -> -. ( ph -> ps ) ) ) $=
    ( wi pm2.27 con3d ) AABCBABDE $.

  ${
    jc.1 $e |- ( ph -> ps ) $.
    jc.2 $e |- ( ph -> ch ) $.
    $( Inference joining the consequents of two premises.  (Contributed by NM,
       5-Aug-1993.) $)
    jc $p |- ( ph -> -. ( ps -> -. ch ) ) $=
      ( wn wi pm3.2im sylc ) ABCBCFGFDEBCHI $.
  $}

  ${
    impi.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( An importation inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 20-Jul-2013.) $)
    impi $p |- ( -. ( ph -> -. ps ) -> ch ) $=
      ( wn wi con3rr3 con1i ) CABEFABCDGH $.
  $}

  ${
    expi.1 $e |- ( -. ( ph -> -. ps ) -> ch ) $.
    $( An exportation inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by O'Cat, 28-Nov-2008.) $)
    expi $p |- ( ph -> ( ps -> ch ) ) $=
      ( wn wi pm3.2im syl6 ) ABABEFECABGDH $.
  $}

  $( Simplification.  Similar to Theorem *3.27 (Simp) of [WhiteheadRussell]
     p. 112.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 13-Nov-2012.) $)
  simprim $p |- ( -. ( ph -> -. ps ) -> ps ) $=
    ( idd impi ) ABBABCD $.

  $( Simplification.  Similar to Theorem *3.26 (Simp) of [WhiteheadRussell]
     p. 112.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 21-Jul-2012.) $)
  simplim $p |- ( -. ( ph -> ps ) -> ph ) $=
    ( wi pm2.21 con1i ) AABCABDE $.

  $( Theorem *2.5 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 9-Oct-2012.) $)
  pm2.5 $p |- ( -. ( ph -> ps ) -> ( -. ph -> ps ) ) $=
    ( wi wn simplim pm2.24d ) ABCDABABEF $.

  $( Theorem *2.51 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.51 $p |- ( -. ( ph -> ps ) -> ( ph -> -. ps ) ) $=
    ( wi wn ax-1 con3i a1d ) ABCZDBDABHBAEFG $.

  $( Theorem *2.521 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 8-Oct-2012.) $)
  pm2.521 $p |- ( -. ( ph -> ps ) -> ( ps -> ph ) ) $=
    ( wi wn simplim a1d ) ABCDABABEF $.

  $( Theorem *2.52 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 8-Oct-2012.) $)
  pm2.52 $p |- ( -. ( ph -> ps ) -> ( -. ph -> -. ps ) ) $=
    ( wi wn pm2.521 con3d ) ABCDBAABEF $.

  $( Exportation theorem expressed with primitive connectives.  (Contributed by
     NM, 5-Aug-1993.) $)
  expt $p |- ( ( -. ( ph -> -. ps ) -> ch ) -> ( ph -> ( ps -> ch ) ) ) $=
    ( wn wi pm3.2im imim1d com12 ) AABDEDZCEBCEABICABFGH $.

  $( Importation theorem expressed with primitive connectives.  (Contributed by
     NM, 25-Apr-1994.)  (Proof shortened by Wolf Lammen, 20-Jul-2013.) $)
  impt $p |- ( ( ph -> ( ps -> ch ) ) -> ( -. ( ph -> -. ps ) -> ch ) ) $=
    ( wi wn simprim simplim imim1i mpdi ) ABCDZDABEZDEZBCABFLAJAKGHI $.

  ${
    pm2.61d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.61d.2 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Deduction eliminating an antecedent.  (Contributed by NM, 27-Apr-1994.)
       (Proof shortened by Wolf Lammen, 12-Sep-2013.) $)
    pm2.61d $p |- ( ph -> ch ) $=
      ( wn con1d syld pm2.18d ) ACACFBCABCEGDHI $.
  $}

  ${
    pm2.61d1.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.61d1.2 $e |- ( -. ps -> ch ) $.
    $( Inference eliminating an antecedent.  (Contributed by NM,
       15-Jul-2005.) $)
    pm2.61d1 $p |- ( ph -> ch ) $=
      ( wn wi a1i pm2.61d ) ABCDBFCGAEHI $.
  $}

  ${
    pm2.61d2.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    pm2.61d2.2 $e |- ( ps -> ch ) $.
    $( Inference eliminating an antecedent.  (Contributed by NM,
       18-Aug-1993.) $)
    pm2.61d2 $p |- ( ph -> ch ) $=
      ( wi a1i pm2.61d ) ABCBCFAEGDH $.
  $}

  ${
    ja.1 $e |- ( -. ph -> ch ) $.
    ja.2 $e |- ( ps -> ch ) $.
    $( Inference joining the antecedents of two premises.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by O'Cat, 19-Feb-2008.) $)
    ja $p |- ( ( ph -> ps ) -> ch ) $=
      ( wi imim2i pm2.61d1 ) ABFACBCAEGDH $.
  $}

  ${
    jad.1 $e |- ( ph -> ( -. ps -> th ) ) $.
    jad.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( Deduction form of ~ ja .  (Contributed by Scott Fenton, 13-Dec-2010.)
       (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    jad $p |- ( ph -> ( ( ps -> ch ) -> th ) ) $=
      ( wi wn com12 ja ) BCGADBCADGABHDEIACDFIJI $.
  $}

  $( Elimination of a nested antecedent as a kind of reversal of inference
     ~ ja .  (Contributed by Wolf Lammen, 10-May-2013.) $)
  jarl $p |- ( ( ( ph -> ps ) -> ch ) -> ( -. ph -> ch ) ) $=
    ( wn wi pm2.21 imim1i ) ADABECABFG $.

  ${
    pm2.61i.1 $e |- ( ph -> ps ) $.
    pm2.61i.2 $e |- ( -. ph -> ps ) $.
    $( Inference eliminating an antecedent.  (Contributed by NM, 5-Apr-1994.)
       (Proof shortened by Wolf Lammen, 12-Sep-2013.) $)
    pm2.61i $p |- ps $=
      ( wi id ja ax-mp ) AAEBAFAABDCGH $.
  $}

  ${
    pm2.61ii.1 $e |- ( -. ph -> ( -. ps -> ch ) ) $.
    pm2.61ii.2 $e |- ( ph -> ch ) $.
    pm2.61ii.3 $e |- ( ps -> ch ) $.
    $( Inference eliminating two antecedents.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Josh Purinton, 29-Dec-2000.) $)
    pm2.61ii $p |- ch $=
      ( wn pm2.61d2 pm2.61i ) ACEAGBCDFHI $.
  $}

  ${
    pm2.61nii.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.61nii.2 $e |- ( -. ph -> ch ) $.
    pm2.61nii.3 $e |- ( -. ps -> ch ) $.
    $( Inference eliminating two antecedents.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 25-May-2011.)  (Proof
       shortened by Wolf Lammen, 13-Nov-2012.) $)
    pm2.61nii $p |- ch $=
      ( pm2.61d1 pm2.61i ) ACABCDFGEH $.
  $}

  ${
    pm2.61iii.1 $e |- ( -. ph -> ( -. ps -> ( -. ch -> th ) ) ) $.
    pm2.61iii.2 $e |- ( ph -> th ) $.
    pm2.61iii.3 $e |- ( ps -> th ) $.
    pm2.61iii.4 $e |- ( ch -> th ) $.
    $( Inference eliminating three antecedents.  (Contributed by NM,
       2-Jan-2002.)  (Proof shortened by Wolf Lammen, 22-Sep-2013.) $)
    pm2.61iii $p |- th $=
      ( wn wi a1d pm2.61ii pm2.61i ) CDHABCIZDJEADNFKBDNGKLM $.
  $}

  $( Reductio ad absurdum.  Theorem *2.01 of [WhiteheadRussell] p. 100.
     (Contributed by NM, 18-Aug-1993.)  (Proof shortened by O'Cat,
     21-Nov-2008.)  (Proof shortened by Wolf Lammen, 31-Oct-2012.) $)
  pm2.01 $p |- ( ( ph -> -. ph ) -> -. ph ) $=
    ( wn id ja ) AABZEECZFD $.

  ${
    pm2.01d.1 $e |- ( ph -> ( ps -> -. ps ) ) $.
    $( Deduction based on reductio ad absurdum.  (Contributed by NM,
       18-Aug-1993.)  (Proof shortened by Wolf Lammen, 5-Mar-2013.) $)
    pm2.01d $p |- ( ph -> -. ps ) $=
      ( wn id pm2.61d1 ) ABBDZCGEF $.
  $}

  $( Theorem *2.6 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.6 $p |- ( ( -. ph -> ps ) -> ( ( ph -> ps ) -> ps ) ) $=
    ( wn wi id idd jad ) ACBDZABBHEHBFG $.

  $( Theorem *2.61 of [WhiteheadRussell] p. 107.  Useful for eliminating an
     antecedent.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 22-Sep-2013.) $)
  pm2.61 $p |- ( ( ph -> ps ) -> ( ( -. ph -> ps ) -> ps ) ) $=
    ( wn wi pm2.6 com12 ) ACBDABDBABEF $.

  $( Theorem *2.65 of [WhiteheadRussell] p. 107.  Proof by contradiction.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
     8-Mar-2013.) $)
  pm2.65 $p |- ( ( ph -> ps ) -> ( ( ph -> -. ps ) -> -. ph ) ) $=
    ( wi wn idd con3 jad ) ABCZABDADZHIEABFG $.

  ${
    pm2.65i.1 $e |- ( ph -> ps ) $.
    pm2.65i.2 $e |- ( ph -> -. ps ) $.
    $( Inference rule for proof by contradiction.  (Contributed by NM,
       18-May-1994.)  (Proof shortened by Wolf Lammen, 11-Sep-2013.) $)
    pm2.65i $p |- -. ph $=
      ( wn con2i con3i pm2.61i ) BAEABDFABCGH $.
  $}

  ${
    pm2.65d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    pm2.65d.2 $e |- ( ph -> ( ps -> -. ch ) ) $.
    $( Deduction rule for proof by contradiction.  (Contributed by NM,
       26-Jun-1994.)  (Proof shortened by Wolf Lammen, 26-May-2013.) $)
    pm2.65d $p |- ( ph -> -. ps ) $=
      ( nsyld pm2.01d ) ABABCBEDFG $.
  $}

  ${
    mto.1 $e |- -. ps $.
    mto.2 $e |- ( ph -> ps ) $.
    $( The rule of modus tollens.  The rule says, "if ` ps ` is not true, and
       ` ph ` implies ` ps ` , then ` ps ` must also be not true."  Modus
       tollens is short for "modus tollendo tollens," a Latin phrase that means
       "the mood that by denying affirms" - remark in [Sanford] p. 39.  It is
       also called denying the consequent.  Modus tollens is closely related to
       modus ponens ~ ax-mp .  (Contributed by NM, 19-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 11-Sep-2013.) $)
    mto $p |- -. ph $=
      ( wn a1i pm2.65i ) ABDBEACFG $.
  $}

  ${
    mtod.1 $e |- ( ph -> -. ch ) $.
    mtod.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Modus tollens deduction.  (Contributed by NM, 3-Apr-1994.)  (Proof
       shortened by Wolf Lammen, 11-Sep-2013.) $)
    mtod $p |- ( ph -> -. ps ) $=
      ( wn a1d pm2.65d ) ABCEACFBDGH $.
  $}

  ${
    mtoi.1 $e |- -. ch $.
    mtoi.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Modus tollens inference.  (Contributed by NM, 5-Jul-1994.)  (Proof
       shortened by Wolf Lammen, 15-Sep-2012.) $)
    mtoi $p |- ( ph -> -. ps ) $=
      ( wn a1i mtod ) ABCCFADGEH $.
  $}

  ${
    mt2.1 $e |- ps $.
    mt2.2 $e |- ( ph -> -. ps ) $.
    $( A rule similar to modus tollens.  (Contributed by NM, 19-Aug-1993.)
       (Proof shortened by Wolf Lammen, 10-Sep-2013.) $)
    mt2 $p |- -. ph $=
      ( a1i pm2.65i ) ABBACEDF $.
  $}

  ${
    mt3.1 $e |- -. ps $.
    mt3.2 $e |- ( -. ph -> ps ) $.
    $( A rule similar to modus tollens.  (Contributed by NM, 18-May-1994.)
       (Proof shortened by Wolf Lammen, 11-Sep-2013.) $)
    mt3 $p |- ph $=
      ( wn mto notnotri ) AAEBCDFG $.
  $}

  $( Peirce's axiom.  This odd-looking theorem is the "difference" between an
     intuitionistic system of propositional calculus and a classical system and
     is not accepted by intuitionists.  When Peirce's axiom is added to an
     intuitionistic system, the system becomes equivalent to our classical
     system ~ ax-1 through ~ ax-3 .  A curious fact about this theorem is that
     it requires ~ ax-3 for its proof even though the result has no negation
     connectives in it.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by
     Wolf Lammen, 9-Oct-2012.) $)
  peirce $p |- ( ( ( ph -> ps ) -> ph ) -> ph ) $=
    ( wi simplim id ja ) ABCAAABDAEF $.

  $( The Inversion Axiom of the infinite-valued sentential logic (L-infinity)
     of Lukasiewicz.  Using ~ dfor2 , we can see that this essentially
     expresses "disjunction commutes."  Theorem *2.69 of [WhiteheadRussell]
     p. 108.  (Contributed by NM, 12-Aug-2004.) $)
  looinv $p |- ( ( ( ph -> ps ) -> ps ) -> ( ( ps -> ph ) -> ph ) ) $=
    ( wi imim1 peirce syl6 ) ABCZBCBACGACAGBADABEF $.

  $( Theorem used to justify definition of biconditional ~ df-bi .
     (Contributed by NM, 11-May-1999.)  (Proof shortened by Josh Purinton,
     29-Dec-2000.) $)
  bijust $p |- -. ( ( -. ( ( ph -> ps ) -> -. ( ps -> ph ) )
                      -> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) )
               -> -. ( -. ( ( ph -> ps ) -> -. ( ps -> ph ) )
                      -> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ) ) $=
    ( wi wn id pm2.01 mt2 ) ABCBACDCDZHCZIDCIHEIFG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical equivalence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  The definition ~ df-bi in this section is our first definition, which
  introduces and defines the biconditional connective ` <-> ` . We define a wff
  of the form ` ( ph <-> ps ) ` as an abbreviation for
  ` -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ` .

  Unlike most traditional developments, we have chosen not to have a separate
  symbol such as "Df." to mean "is defined as."  Instead, we will later use the
  biconditional connective for this purpose ( ~ df-or is its first use), as it
  allows us to use logic to manipulate definitions directly.  This greatly
  simplifies many proofs since it eliminates the need for a separate mechanism
  for introducing and eliminating definitions.
$)

  $( Declare the biconditional connective. $)
  $c <-> $. $( Double arrow (read:  'if and only if' or
               'is logically equivalent to') $)

  $( Extend our wff definition to include the biconditional connective. $)
  wb $a wff ( ph <-> ps ) $.

  $( Define the biconditional (logical 'iff').

     The definition ~ df-bi in this section is our first definition, which
     introduces and defines the biconditional connective ` <-> ` .  We define a
     wff of the form ` ( ph <-> ps ) ` as an abbreviation for
     ` -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ` .

     Unlike most traditional developments, we have chosen not to have a
     separate symbol such as "Df." to mean "is defined as."  Instead, we will
     later use the biconditional connective for this purpose ( ~ df-or is its
     first use), as it allows us to use logic to manipulate definitions
     directly.  This greatly simplifies many proofs since it eliminates the
     need for a separate mechanism for introducing and eliminating
     definitions.  Of course, we cannot use this mechanism to define the
     biconditional itself, since it hasn't been introduced yet.  Instead, we
     use a more general form of definition, described as follows.

     In its most general form, a definition is simply an assertion that
     introduces a new symbol (or a new combination of existing symbols, as in
     ~ df-3an ) that is eliminable and does not strengthen the existing
     language.  The latter requirement means that the set of provable
     statements not containing the new symbol (or new combination) should
     remain exactly the same after the definition is introduced.  Our
     definition of the biconditional may look unusual compared to most
     definitions, but it strictly satisfies these requirements.

     The justification for our definition is that if we mechanically replace
     ` ( ph <-> ps ) ` (the definiendum i.e. the thing being defined) with
     ` -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ` (the definiens i.e. the
     defining expression) in the definition, the definition becomes the
     previously proved theorem ~ bijust .  It is impossible to use ~ df-bi to
     prove any statement expressed in the original language that can't be
     proved from the original axioms, because if we simply replace each
     instance of ~ df-bi in the proof with the corresponding ~ bijust instance,
     we will end up with a proof from the original axioms.

     Note that from Metamath's point of view, a definition is just another
     axiom - i.e. an assertion we claim to be true - but from our high level
     point of view, we are not strengthening the language.  To indicate this
     fact, we prefix definition labels with "df-" instead of "ax-".  (This
     prefixing is an informal convention that means nothing to the Metamath
     proof verifier; it is just a naming convention for human readability.)

     After we define the constant true ` T. ` ( ~ df-tru ) and the constant
     false ` F. ` ( ~ df-fal ), we will be able to prove these truth table
     values: ` ( ( T. <-> T. ) <-> T. ) ` ( ~ trubitru ),
     ` ( ( T. <-> F. ) <-> F. ) ` ( ~ trubifal ), ` ( ( F. <-> T. ) <-> F. ) `
     ( ~ falbitru ), and ` ( ( F. <-> F. ) <-> T. ) ` ( ~ falbifal ).

     See ~ dfbi1 , ~ dfbi2 , and ~ dfbi3 for theorems suggesting typical
     textbook definitions of ` <-> ` , showing that our definition has the
     properties we expect.  Theorem ~ dfbi1 is particularly useful if we want
     to eliminate ` <-> ` from an expression to convert it to primitives.
     Theorem ~ dfbi shows this definition rewritten in an abbreviated form
     after conjunction is introduced, for easier understanding.

     Contrast with ` \/ ` ( ~ df-or ), ` -> ` ( ~ wi ), ` -/\ ` ( ~ df-nan ),
     and ` \/_ ` ( ~ df-xor ) .  In some sense ` <-> ` returns true if two
     truth values are equal; ` = ` ( ~ df-cleq ) returns true if two classes
     are equal.  (Contributed by NM, 5-Aug-1993.) $)
  df-bi $a |- -. ( ( ( ph <-> ps ) -> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) )
        -> -. ( -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) -> ( ph <-> ps ) ) ) $.

  $( $j justification 'bijust' for 'df-bi'; $)

  $( Property of the biconditional connective.  (Contributed by NM,
     11-May-1999.) $)
  bi1 $p |- ( ( ph <-> ps ) -> ( ph -> ps ) ) $=
    ( wb wi wn df-bi simplim ax-mp syl ) ABCZABDZBADEZDEZKJMDZMJDEZDENABFNOGHKL
    GI $.

  $( Property of the biconditional connective.  (Contributed by NM,
     11-May-1999.) $)
  bi3 $p |- ( ( ph -> ps ) -> ( ( ps -> ph ) -> ( ph <-> ps ) ) ) $=
    ( wi wb wn df-bi simprim ax-mp expi ) ABCZBACZABDZLJKECEZCZMLCZECEOABFNOGHI
    $.

  ${
    impbii.1 $e |- ( ph -> ps ) $.
    impbii.2 $e |- ( ps -> ph ) $.
    $( Infer an equivalence from an implication and its converse.  (Contributed
       by NM, 5-Aug-1993.) $)
    impbii $p |- ( ph <-> ps ) $=
      ( wi wb bi3 mp2 ) ABEBAEABFCDABGH $.
  $}

  ${
    impbidd.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    impbidd.2 $e |- ( ph -> ( ps -> ( th -> ch ) ) ) $.
    $( Deduce an equivalence from two implications.  (Contributed by Rodolfo
       Medina, 12-Oct-2010.) $)
    impbidd $p |- ( ph -> ( ps -> ( ch <-> th ) ) ) $=
      ( wi wb bi3 syl6c ) ABCDGDCGCDHEFCDIJ $.
  $}

  ${
    impbid21d.1 $e |- ( ps -> ( ch -> th ) ) $.
    impbid21d.2 $e |- ( ph -> ( th -> ch ) ) $.
    $( Deduce an equivalence from two implications.  (Contributed by Wolf
       Lammen, 12-May-2013.) $)
    impbid21d $p |- ( ph -> ( ps -> ( ch <-> th ) ) ) $=
      ( wi a1i a1d impbidd ) ABCDBCDGGAEHADCGBFIJ $.
  $}

  ${
    impbid.1 $e |- ( ph -> ( ps -> ch ) ) $.
    impbid.2 $e |- ( ph -> ( ch -> ps ) ) $.
    $( Deduce an equivalence from two implications.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Wolf Lammen, 3-Nov-2012.) $)
    impbid $p |- ( ph -> ( ps <-> ch ) ) $=
      ( wb impbid21d pm2.43i ) ABCFAABCDEGH $.
  $}

  $( Relate the biconditional connective to primitive connectives.  See
     ~ dfbi1gb for an unusual version proved directly from axioms.
     (Contributed by NM, 5-Aug-1993.) $)
  dfbi1 $p |- ( ( ph <-> ps ) <-> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ) $=
    ( wb wi wn df-bi simplim ax-mp bi3 impi impbii ) ABCZABDZBADZEDEZLODZOLDEZD
    EPABFPQGHMNLABIJK $.

  $( This proof of ~ dfbi1 , discovered by Gregory Bush on 8-Mar-2004, has
     several curious properties.  First, it has only 17 steps directly from the
     axioms and ~ df-bi , compared to over 800 steps were the proof of ~ dfbi1
     expanded into axioms.  Second, step 2 demands only the property of "true";
     any axiom (or theorem) could be used.  It might be thought, therefore,
     that it is in some sense redundant, but in fact no proof is shorter than
     this (measured by number of steps).  Third, it illustrates how
     intermediate steps can "blow up" in size even in short proofs.  Fourth,
     the compressed proof is only 182 bytes (or 17 bytes in D-proof notation),
     but the generated web page is over 200kB with intermediate steps that are
     essentially incomprehensible to humans (other than Gregory Bush).  If
     there were an obfuscated code contest for proofs, this would be a
     contender.  This "blowing up" and incomprehensibility of the intermediate
     steps vividly demonstrate the advantages of using many layered
     intermediate theorems, since each theorem is easier to understand.
     (Contributed by Gregory Bush, 10-Mar-2004.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  dfbi1gb $p |- ( ( ph <-> ps ) <-> -. ( ( ph -> ps ) -> -. ( ps -> ph ) ) ) $=
    ( wch wth wb wi wn df-bi ax-1 ax-mp ax-3 ax-2 ) ABEZABFBAFGFGZFNMFGFGZMNEZA
    BHCDCFFZOPFZCDIRGZQGZFZQRFSPOFZSFZFZUASUBISUCTFZFZUDUAFUEUFTGZUCGZFZUEUHUIM
    NHUHUGIJTUCKJUESIJSUCTLJJRQKJJJ $.

  ${
    biimpi.1 $e |- ( ph <-> ps ) $.
    $( Infer an implication from a logical equivalence.  (Contributed by NM,
       5-Aug-1993.) $)
    biimpi $p |- ( ph -> ps ) $=
      ( wb wi bi1 ax-mp ) ABDABECABFG $.
  $}

  ${
    sylbi.1 $e |- ( ph <-> ps ) $.
    sylbi.2 $e |- ( ps -> ch ) $.
    $( A mixed syllogism inference from a biconditional and an implication.
       Useful for substituting an antecedent with a definition.  (Contributed
       by NM, 5-Aug-1993.) $)
    sylbi $p |- ( ph -> ch ) $=
      ( biimpi syl ) ABCABDFEG $.
  $}

  ${
    sylib.1 $e |- ( ph -> ps ) $.
    sylib.2 $e |- ( ps <-> ch ) $.
    $( A mixed syllogism inference from an implication and a biconditional.
       (Contributed by NM, 5-Aug-1993.) $)
    sylib $p |- ( ph -> ch ) $=
      ( biimpi syl ) ABCDBCEFG $.
  $}

  $( Property of the biconditional connective.  (Contributed by NM,
     11-May-1999.)  (Proof shortened by Wolf Lammen, 11-Nov-2012.) $)
  bi2 $p |- ( ( ph <-> ps ) -> ( ps -> ph ) ) $=
    ( wb wi wn dfbi1 simprim sylbi ) ABCABDZBADZEDEJABFIJGH $.

  $( Commutative law for equivalence.  (Contributed by Wolf Lammen,
     10-Nov-2012.) $)
  bicom1 $p |- ( ( ph <-> ps ) -> ( ps <-> ph ) ) $=
    ( wb bi2 bi1 impbid ) ABCBAABDABEF $.

  $( Commutative law for equivalence.  Theorem *4.21 of [WhiteheadRussell]
     p. 117.  (Contributed by NM, 5-Aug-1993.) $)
  bicom $p |- ( ( ph <-> ps ) <-> ( ps <-> ph ) ) $=
    ( wb bicom1 impbii ) ABCBACABDBADE $.

  ${
    bicomd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Commute two sides of a biconditional in a deduction.  (Contributed by
       NM, 5-Aug-1993.) $)
    bicomd $p |- ( ph -> ( ch <-> ps ) ) $=
      ( wb bicom sylib ) ABCECBEDBCFG $.
  $}

  ${
    bicomi.1 $e |- ( ph <-> ps ) $.
    $( Inference from commutative law for logical equivalence.  (Contributed by
       NM, 5-Aug-1993.) $)
    bicomi $p |- ( ps <-> ph ) $=
      ( wb bicom1 ax-mp ) ABDBADCABEF $.
  $}

  ${
    impbid1.1 $e |- ( ph -> ( ps -> ch ) ) $.
    impbid1.2 $e |- ( ch -> ps ) $.
    $( Infer an equivalence from two implications.  (Contributed by NM,
       6-Mar-2007.) $)
    impbid1 $p |- ( ph -> ( ps <-> ch ) ) $=
      ( wi a1i impbid ) ABCDCBFAEGH $.
  $}

  ${
    impbid2.1 $e |- ( ps -> ch ) $.
    impbid2.2 $e |- ( ph -> ( ch -> ps ) ) $.
    $( Infer an equivalence from two implications.  (Contributed by NM,
       6-Mar-2007.)  (Proof shortened by Wolf Lammen, 27-Sep-2013.) $)
    impbid2 $p |- ( ph -> ( ps <-> ch ) ) $=
      ( impbid1 bicomd ) ACBACBEDFG $.
  $}

  ${
    impcon4bid.1 $e |- ( ph -> ( ps -> ch ) ) $.
    impcon4bid.2 $e |- ( ph -> ( -. ps -> -. ch ) ) $.
    $( A variation on ~ impbid with contraposition.  (Contributed by Jeff
       Hankins, 3-Jul-2009.) $)
    impcon4bid $p |- ( ph -> ( ps <-> ch ) ) $=
      ( con4d impbid ) ABCDABCEFG $.
  $}

  ${
    biimpri.1 $e |- ( ph <-> ps ) $.
    $( Infer a converse implication from a logical equivalence.  (Contributed
       by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 16-Sep-2013.) $)
    biimpri $p |- ( ps -> ph ) $=
      ( bicomi biimpi ) BAABCDE $.
  $}

  ${
    biimpd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduce an implication from a logical equivalence.  (Contributed by NM,
       5-Aug-1993.) $)
    biimpd $p |- ( ph -> ( ps -> ch ) ) $=
      ( wb wi bi1 syl ) ABCEBCFDBCGH $.
  $}

  ${
    mpbi.min $e |- ph $.
    mpbi.maj $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus ponens.
       (Contributed by NM, 5-Aug-1993.) $)
    mpbi $p |- ps $=
      ( biimpi ax-mp ) ABCABDEF $.
  $}

  ${
    mpbir.min $e |- ps $.
    mpbir.maj $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus ponens.
       (Contributed by NM, 5-Aug-1993.) $)
    mpbir $p |- ph $=
      ( biimpri ax-mp ) BACABDEF $.
  $}

  ${
    mpbid.min $e |- ( ph -> ps ) $.
    mpbid.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, related to modus ponens.  (Contributed
       by NM, 5-Aug-1993.) $)
    mpbid $p |- ( ph -> ch ) $=
      ( biimpd mpd ) ABCDABCEFG $.
  $}

  ${
    mpbii.min $e |- ps $.
    mpbii.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a nested biconditional, related to modus ponens.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       25-Oct-2012.) $)
    mpbii $p |- ( ph -> ch ) $=
      ( a1i mpbid ) ABCBADFEG $.
  $}

  ${
    sylibr.1 $e |- ( ph -> ps ) $.
    sylibr.2 $e |- ( ch <-> ps ) $.
    $( A mixed syllogism inference from an implication and a biconditional.
       Useful for substituting a consequent with a definition.  (Contributed by
       NM, 5-Aug-1993.) $)
    sylibr $p |- ( ph -> ch ) $=
      ( biimpri syl ) ABCDCBEFG $.
  $}

  ${
    sylbir.1 $e |- ( ps <-> ph ) $.
    sylbir.2 $e |- ( ps -> ch ) $.
    $( A mixed syllogism inference from a biconditional and an implication.
       (Contributed by NM, 5-Aug-1993.) $)
    sylbir $p |- ( ph -> ch ) $=
      ( biimpri syl ) ABCBADFEG $.
  $}

  ${
    sylibd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylibd.2 $e |- ( ph -> ( ch <-> th ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 3-Aug-1994.) $)
    sylibd $p |- ( ph -> ( ps -> th ) ) $=
      ( biimpd syld ) ABCDEACDFGH $.
  $}

  ${
    sylbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    sylbid.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 3-Aug-1994.) $)
    sylbid $p |- ( ph -> ( ps -> th ) ) $=
      ( biimpd syld ) ABCDABCEGFH $.
  $}

  ${
    mpbidi.min $e |- ( th -> ( ph -> ps ) ) $.
    mpbidi.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, related to modus ponens.  (Contributed
       by NM, 9-Aug-1994.) $)
    mpbidi $p |- ( th -> ( ph -> ch ) ) $=
      ( biimpd sylcom ) DABCEABCFGH $.
  $}

  ${
    syl5bi.1 $e |- ( ph <-> ps ) $.
    syl5bi.2 $e |- ( ch -> ( ps -> th ) ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional.  Useful for substituting an embedded antecedent with a
       definition.  (Contributed by NM, 5-Aug-1993.) $)
    syl5bi $p |- ( ch -> ( ph -> th ) ) $=
      ( biimpi syl5 ) ABCDABEGFH $.
  $}

  ${
    syl5bir.1 $e |- ( ps <-> ph ) $.
    syl5bir.2 $e |- ( ch -> ( ps -> th ) ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional.  (Contributed by NM, 5-Aug-1993.) $)
    syl5bir $p |- ( ch -> ( ph -> th ) ) $=
      ( biimpri syl5 ) ABCDBAEGFH $.
  $}

  ${
    syl5ib.1 $e |- ( ph -> ps ) $.
    syl5ib.2 $e |- ( ch -> ( ps <-> th ) ) $.
    $( A mixed syllogism inference.  (Contributed by NM, 5-Aug-1993.) $)
    syl5ib $p |- ( ch -> ( ph -> th ) ) $=
      ( biimpd syl5 ) ABCDECBDFGH $.

    $( A mixed syllogism inference.  (Contributed by NM, 19-Jun-2007.) $)
    syl5ibcom $p |- ( ph -> ( ch -> th ) ) $=
      ( syl5ib com12 ) CADABCDEFGH $.
  $}

  ${
    syl5ibr.1 $e |- ( ph -> th ) $.
    syl5ibr.2 $e |- ( ch -> ( ps <-> th ) ) $.
    $( A mixed syllogism inference.  (Contributed by NM, 3-Apr-1994.) $)
    syl5ibr $p |- ( ch -> ( ph -> ps ) ) $=
      ( bicomd syl5ib ) ADCBECBDFGH $.

    $( A mixed syllogism inference.  (Contributed by NM, 20-Jun-2007.) $)
    syl5ibrcom $p |- ( ph -> ( ch -> ps ) ) $=
      ( syl5ibr com12 ) CABABCDEFGH $.
  $}

  ${
    biimprd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduce a converse implication from a logical equivalence.  (Contributed
       by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 22-Sep-2013.) $)
    biimprd $p |- ( ph -> ( ch -> ps ) ) $=
      ( id syl5ibr ) CBACCEDF $.
  $}

  ${
    biimpcd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduce a commuted implication from a logical equivalence.  (Contributed
       by NM, 3-May-1994.)  (Proof shortened by Wolf Lammen, 22-Sep-2013.) $)
    biimpcd $p |- ( ps -> ( ph -> ch ) ) $=
      ( id syl5ibcom ) BBACBEDF $.

    $( Deduce a converse commuted implication from a logical equivalence.
       (Contributed by NM, 3-May-1994.)  (Proof shortened by Wolf Lammen,
       20-Dec-2013.) $)
    biimprcd $p |- ( ch -> ( ph -> ps ) ) $=
      ( id syl5ibrcom ) CBACCEDF $.
  $}

  ${
    syl6ib.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6ib.2 $e |- ( ch <-> th ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional.  (Contributed by NM, 5-Aug-1993.) $)
    syl6ib $p |- ( ph -> ( ps -> th ) ) $=
      ( biimpi syl6 ) ABCDECDFGH $.
  $}

  ${
    syl6ibr.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl6ibr.2 $e |- ( th <-> ch ) $.
    $( A mixed syllogism inference from a nested implication and a
       biconditional.  Useful for substituting an embedded consequent with a
       definition.  (Contributed by NM, 5-Aug-1993.) $)
    syl6ibr $p |- ( ph -> ( ps -> th ) ) $=
      ( biimpri syl6 ) ABCDEDCFGH $.
  $}


  ${
    syl6bi.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6bi.2 $e |- ( ch -> th ) $.
    $( A mixed syllogism inference.  (Contributed by NM, 2-Jan-1994.) $)
    syl6bi $p |- ( ph -> ( ps -> th ) ) $=
      ( biimpd syl6 ) ABCDABCEGFH $.
  $}

  ${
    syl6bir.1 $e |- ( ph -> ( ch <-> ps ) ) $.
    syl6bir.2 $e |- ( ch -> th ) $.
    $( A mixed syllogism inference.  (Contributed by NM, 18-May-1994.) $)
    syl6bir $p |- ( ph -> ( ps -> th ) ) $=
      ( biimprd syl6 ) ABCDACBEGFH $.
  $}

  ${
    syl7bi.1 $e |- ( ph <-> ps ) $.
    syl7bi.2 $e |- ( ch -> ( th -> ( ps -> ta ) ) ) $.
    $( A mixed syllogism inference from a doubly nested implication and a
       biconditional.  (Contributed by NM, 5-Aug-1993.) $)
    syl7bi $p |- ( ch -> ( th -> ( ph -> ta ) ) ) $=
      ( biimpi syl7 ) ABCDEABFHGI $.
  $}

  ${
    syl8ib.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    syl8ib.2 $e |- ( th <-> ta ) $.
    $( A syllogism rule of inference.  The second premise is used to replace
       the consequent of the first premise.  (Contributed by NM,
       1-Aug-1994.) $)
    syl8ib $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      ( biimpi syl8 ) ABCDEFDEGHI $.
  $}

  ${
    mpbird.min $e |- ( ph -> ch ) $.
    mpbird.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, related to modus ponens.  (Contributed
       by NM, 5-Aug-1993.) $)
    mpbird $p |- ( ph -> ps ) $=
      ( biimprd mpd ) ACBDABCEFG $.
  $}

  ${
    mpbiri.min $e |- ch $.
    mpbiri.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a nested biconditional, related to modus ponens.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       25-Oct-2012.) $)
    mpbiri $p |- ( ph -> ps ) $=
      ( a1i mpbird ) ABCCADFEG $.
  $}

  ${
    sylibrd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylibrd.2 $e |- ( ph -> ( th <-> ch ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 3-Aug-1994.) $)
    sylibrd $p |- ( ph -> ( ps -> th ) ) $=
      ( biimprd syld ) ABCDEADCFGH $.
  $}

  ${
    sylbird.1 $e |- ( ph -> ( ch <-> ps ) ) $.
    sylbird.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 3-Aug-1994.) $)
    sylbird $p |- ( ph -> ( ps -> th ) ) $=
      ( biimprd syld ) ABCDACBEGFH $.
  $}

  $( Principle of identity for logical equivalence.  Theorem *4.2 of
     [WhiteheadRussell] p. 117.  (Contributed by NM, 5-Aug-1993.) $)
  biid $p |- ( ph <-> ph ) $=
    ( id impbii ) AAABZDC $.

  $( Principle of identity with antecedent.  (Contributed by NM,
     25-Nov-1995.) $)
  biidd $p |- ( ph -> ( ps <-> ps ) ) $=
    ( wb biid a1i ) BBCABDE $.

  $( Two propositions are equivalent if they are both true.  Closed form of
     ~ 2th .  Equivalent to a ~ bi1 -like version of the xor-connective.  This
     theorem stays true, no matter how you permute its operands.  This is
     evident from its sharper version
     ` ( ph <-> ( ps <-> ( ph <-> ps ) ) ) ` .  (Contributed by Wolf Lammen,
     12-May-2013.) $)
  pm5.1im $p |- ( ph -> ( ps -> ( ph <-> ps ) ) ) $=
    ( ax-1 impbid21d ) ABABBACABCD $.

  ${
    2th.1 $e |- ph $.
    2th.2 $e |- ps $.
    $( Two truths are equivalent.  (Contributed by NM, 18-Aug-1993.) $)
    2th $p |- ( ph <-> ps ) $=
      ( a1i impbii ) ABBADEABCEF $.
  $}

  ${
    2thd.1 $e |- ( ph -> ps ) $.
    2thd.2 $e |- ( ph -> ch ) $.
    $( Two truths are equivalent (deduction rule).  (Contributed by NM,
       3-Jun-2012.) $)
    2thd $p |- ( ph -> ( ps <-> ch ) ) $=
      ( wb pm5.1im sylc ) ABCBCFDEBCGH $.
  $}

  ${
    ibi.1 $e |- ( ph -> ( ph <-> ps ) ) $.
    $( Inference that converts a biconditional implied by one of its arguments,
       into an implication.  (Contributed by NM, 17-Oct-2003.) $)
    ibi $p |- ( ph -> ps ) $=
      ( biimpd pm2.43i ) ABAABCDE $.
  $}

  ${
    ibir.1 $e |- ( ph -> ( ps <-> ph ) ) $.
    $( Inference that converts a biconditional implied by one of its arguments,
       into an implication.  (Contributed by NM, 22-Jul-2004.) $)
    ibir $p |- ( ph -> ps ) $=
      ( bicomd ibi ) ABABACDE $.
  $}

  ${
    ibd.1 $e |- ( ph -> ( ps -> ( ps <-> ch ) ) ) $.
    $( Deduction that converts a biconditional implied by one of its arguments,
       into an implication.  (Contributed by NM, 26-Jun-2004.) $)
    ibd $p |- ( ph -> ( ps -> ch ) ) $=
      ( wb bi1 syli ) BABCECDBCFG $.
  $}

  $( Distribution of implication over biconditional.  Theorem *5.74 of
     [WhiteheadRussell] p. 126.  (Contributed by NM, 1-Aug-1994.)  (Proof
     shortened by Wolf Lammen, 11-Apr-2013.) $)
  pm5.74 $p |- ( ( ph -> ( ps <-> ch ) ) <->
               ( ( ph -> ps ) <-> ( ph -> ch ) ) ) $=
    ( wb wi bi1 imim3i bi2 impbid pm2.86d impbidd impbii ) ABCDZEZABEZACEZDZNOP
    MBCABCFGMCBABCHGIQABCQABCOPFJQACBOPHJKL $.

  ${
    pm5.74i.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Distribution of implication over biconditional (inference rule).
       (Contributed by NM, 1-Aug-1994.) $)
    pm5.74i $p |- ( ( ph -> ps ) <-> ( ph -> ch ) ) $=
      ( wb wi pm5.74 mpbi ) ABCEFABFACFEDABCGH $.
  $}

  ${
    pm5.74ri.1 $e |- ( ( ph -> ps ) <-> ( ph -> ch ) ) $.
    $( Distribution of implication over biconditional (reverse inference
       rule).  (Contributed by NM, 1-Aug-1994.) $)
    pm5.74ri $p |- ( ph -> ( ps <-> ch ) ) $=
      ( wb wi pm5.74 mpbir ) ABCEFABFACFEDABCGH $.
  $}

  ${
    pm5.74d.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Distribution of implication over biconditional (deduction rule).
       (Contributed by NM, 21-Mar-1996.) $)
    pm5.74d $p |- ( ph -> ( ( ps -> ch ) <-> ( ps -> th ) ) ) $=
      ( wb wi pm5.74 sylib ) ABCDFGBCGBDGFEBCDHI $.
  $}

  ${
    pm5.74rd.1 $e |- ( ph -> ( ( ps -> ch ) <-> ( ps -> th ) ) ) $.
    $( Distribution of implication over biconditional (deduction rule).
       (Contributed by NM, 19-Mar-1997.) $)
    pm5.74rd $p |- ( ph -> ( ps -> ( ch <-> th ) ) ) $=
      ( wi wb pm5.74 sylibr ) ABCFBDFGBCDGFEBCDHI $.
  $}

  ${
    bitri.1 $e |- ( ph <-> ps ) $.
    bitri.2 $e |- ( ps <-> ch ) $.
    $( An inference from transitive law for logical equivalence.  (Contributed
       by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 13-Oct-2012.) $)
    bitri $p |- ( ph <-> ch ) $=
      ( biimpi sylib biimpri sylibr impbii ) ACABCABDFEGCBABCEHDIJ $.
  $}

  ${
    bitr2i.1 $e |- ( ph <-> ps ) $.
    bitr2i.2 $e |- ( ps <-> ch ) $.
    $( An inference from transitive law for logical equivalence.  (Contributed
       by NM, 5-Aug-1993.) $)
    bitr2i $p |- ( ch <-> ph ) $=
      ( bitri bicomi ) ACABCDEFG $.
  $}

  ${
    bitr3i.1 $e |- ( ps <-> ph ) $.
    bitr3i.2 $e |- ( ps <-> ch ) $.
    $( An inference from transitive law for logical equivalence.  (Contributed
       by NM, 5-Aug-1993.) $)
    bitr3i $p |- ( ph <-> ch ) $=
      ( bicomi bitri ) ABCBADFEG $.
  $}

  ${
    bitr4i.1 $e |- ( ph <-> ps ) $.
    bitr4i.2 $e |- ( ch <-> ps ) $.
    $( An inference from transitive law for logical equivalence.  (Contributed
       by NM, 5-Aug-1993.) $)
    bitr4i $p |- ( ph <-> ch ) $=
      ( bicomi bitri ) ABCDCBEFG $.
  $}

  $( Register '<->' as an equality for its type (wff). $)
  $( $j
    equality 'wb' from 'biid' 'bicomi' 'bitri';
    definition 'dfbi1' for 'wb';
  $)

  ${
    bitrd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitrd.2 $e |- ( ph -> ( ch <-> th ) ) $.
    $( Deduction form of ~ bitri .  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 14-Apr-2013.) $)
    bitrd $p |- ( ph -> ( ps <-> th ) ) $=
      ( wi pm5.74i bitri pm5.74ri ) ABDABGACGADGABCEHACDFHIJ $.
  $}

  ${
    bitr2d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitr2d.2 $e |- ( ph -> ( ch <-> th ) ) $.
    $( Deduction form of ~ bitr2i .  (Contributed by NM, 9-Jun-2004.) $)
    bitr2d $p |- ( ph -> ( th <-> ps ) ) $=
      ( bitrd bicomd ) ABDABCDEFGH $.
  $}

  ${
    bitr3d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitr3d.2 $e |- ( ph -> ( ps <-> th ) ) $.
    $( Deduction form of ~ bitr3i .  (Contributed by NM, 5-Aug-1993.) $)
    bitr3d $p |- ( ph -> ( ch <-> th ) ) $=
      ( bicomd bitrd ) ACBDABCEGFH $.
  $}

  ${
    bitr4d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bitr4d.2 $e |- ( ph -> ( th <-> ch ) ) $.
    $( Deduction form of ~ bitr4i .  (Contributed by NM, 5-Aug-1993.) $)
    bitr4d $p |- ( ph -> ( ps <-> th ) ) $=
      ( bicomd bitrd ) ABCDEADCFGH $.
  $}

  ${
    syl5bb.1 $e |- ( ph <-> ps ) $.
    syl5bb.2 $e |- ( ch -> ( ps <-> th ) ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       5-Aug-1993.) $)
    syl5bb $p |- ( ch -> ( ph <-> th ) ) $=
      ( wb a1i bitrd ) CABDABGCEHFI $.
  $}

  ${
    syl5rbb.1 $e |- ( ph <-> ps ) $.
    syl5rbb.2 $e |- ( ch -> ( ps <-> th ) ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       5-Aug-1993.) $)
    syl5rbb $p |- ( ch -> ( th <-> ph ) ) $=
      ( syl5bb bicomd ) CADABCDEFGH $.
  $}

  ${
    syl5bbr.1 $e |- ( ps <-> ph ) $.
    syl5bbr.2 $e |- ( ch -> ( ps <-> th ) ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       5-Aug-1993.) $)
    syl5bbr $p |- ( ch -> ( ph <-> th ) ) $=
      ( bicomi syl5bb ) ABCDBAEGFH $.
  $}

  ${
    syl5rbbr.1 $e |- ( ps <-> ph ) $.
    syl5rbbr.2 $e |- ( ch -> ( ps <-> th ) ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       25-Nov-1994.) $)
    syl5rbbr $p |- ( ch -> ( th <-> ph ) ) $=
      ( bicomi syl5rbb ) ABCDBAEGFH $.
  $}

  ${
    syl6bb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6bb.2 $e |- ( ch <-> th ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       5-Aug-1993.) $)
    syl6bb $p |- ( ph -> ( ps <-> th ) ) $=
      ( wb a1i bitrd ) ABCDECDGAFHI $.
  $}

  ${
    syl6rbb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6rbb.2 $e |- ( ch <-> th ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       5-Aug-1993.) $)
    syl6rbb $p |- ( ph -> ( th <-> ps ) ) $=
      ( syl6bb bicomd ) ABDABCDEFGH $.
  $}

  ${
    syl6bbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6bbr.2 $e |- ( th <-> ch ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       5-Aug-1993.) $)
    syl6bbr $p |- ( ph -> ( ps <-> th ) ) $=
      ( bicomi syl6bb ) ABCDEDCFGH $.
  $}

  ${
    syl6rbbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl6rbbr.2 $e |- ( th <-> ch ) $.
    $( A syllogism inference from two biconditionals.  (Contributed by NM,
       25-Nov-1994.) $)
    syl6rbbr $p |- ( ph -> ( th <-> ps ) ) $=
      ( bicomi syl6rbb ) ABCDEDCFGH $.
  $}

  ${
    3imtr3.1 $e |- ( ph -> ps ) $.
    3imtr3.2 $e |- ( ph <-> ch ) $.
    3imtr3.3 $e |- ( ps <-> th ) $.
    $( A mixed syllogism inference, useful for removing a definition from both
       sides of an implication.  (Contributed by NM, 10-Aug-1994.) $)
    3imtr3i $p |- ( ch -> th ) $=
      ( sylbir sylib ) CBDCABFEHGI $.
  $}

  ${
    3imtr4.1 $e |- ( ph -> ps ) $.
    3imtr4.2 $e |- ( ch <-> ph ) $.
    3imtr4.3 $e |- ( th <-> ps ) $.
    $( A mixed syllogism inference, useful for applying a definition to both
       sides of an implication.  (Contributed by NM, 5-Aug-1993.) $)
    3imtr4i $p |- ( ch -> th ) $=
      ( sylbi sylibr ) CBDCABFEHGI $.
  $}

  ${
    3imtr3d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr3d.2 $e |- ( ph -> ( ps <-> th ) ) $.
    3imtr3d.3 $e |- ( ph -> ( ch <-> ta ) ) $.
    $( More general version of ~ 3imtr3i .  Useful for converting conditional
       definitions in a formula.  (Contributed by NM, 8-Apr-1996.) $)
    3imtr3d $p |- ( ph -> ( th -> ta ) ) $=
      ( sylibd sylbird ) ADBEGABCEFHIJ $.
  $}

  ${
    3imtr4d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr4d.2 $e |- ( ph -> ( th <-> ps ) ) $.
    3imtr4d.3 $e |- ( ph -> ( ta <-> ch ) ) $.
    $( More general version of ~ 3imtr4i .  Useful for converting conditional
       definitions in a formula.  (Contributed by NM, 26-Oct-1995.) $)
    3imtr4d $p |- ( ph -> ( th -> ta ) ) $=
      ( sylibrd sylbid ) ADBEGABCEFHIJ $.
  $}

  ${
    3imtr3g.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr3g.2 $e |- ( ps <-> th ) $.
    3imtr3g.3 $e |- ( ch <-> ta ) $.
    $( More general version of ~ 3imtr3i .  Useful for converting definitions
       in a formula.  (Contributed by NM, 20-May-1996.)  (Proof shortened by
       Wolf Lammen, 20-Dec-2013.) $)
    3imtr3g $p |- ( ph -> ( th -> ta ) ) $=
      ( syl5bir syl6ib ) ADCEDBACGFIHJ $.
  $}

  ${
    3imtr4g.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3imtr4g.2 $e |- ( th <-> ps ) $.
    3imtr4g.3 $e |- ( ta <-> ch ) $.
    $( More general version of ~ 3imtr4i .  Useful for converting definitions
       in a formula.  (Contributed by NM, 20-May-1996.)  (Proof shortened by
       Wolf Lammen, 20-Dec-2013.) $)
    3imtr4g $p |- ( ph -> ( th -> ta ) ) $=
      ( syl5bi syl6ibr ) ADCEDBACGFIHJ $.
  $}

  ${
    3bitri.1 $e |- ( ph <-> ps ) $.
    3bitri.2 $e |- ( ps <-> ch ) $.
    3bitri.3 $e |- ( ch <-> th ) $.
    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 5-Aug-1993.) $)
    3bitri $p |- ( ph <-> th ) $=
      ( bitri ) ABDEBCDFGHH $.

    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 4-Aug-2006.) $)
    3bitrri $p |- ( th <-> ph ) $=
      ( bitr2i bitr3i ) DCAGABCEFHI $.
  $}

  ${
    3bitr2i.1 $e |- ( ph <-> ps ) $.
    3bitr2i.2 $e |- ( ch <-> ps ) $.
    3bitr2i.3 $e |- ( ch <-> th ) $.
    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 4-Aug-2006.) $)
    3bitr2i $p |- ( ph <-> th ) $=
      ( bitr4i bitri ) ACDABCEFHGI $.

    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 4-Aug-2006.) $)
    3bitr2ri $p |- ( th <-> ph ) $=
      ( bitr4i bitr2i ) ACDABCEFHGI $.
  $}

  ${
    3bitr3i.1 $e |- ( ph <-> ps ) $.
    3bitr3i.2 $e |- ( ph <-> ch ) $.
    3bitr3i.3 $e |- ( ps <-> th ) $.
    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 19-Aug-1993.) $)
    3bitr3i $p |- ( ch <-> th ) $=
      ( bitr3i bitri ) CBDCABFEHGI $.

    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 5-Aug-1993.) $)
    3bitr3ri $p |- ( th <-> ch ) $=
      ( bitr3i ) DBCGBACEFHH $.
  $}

  ${
    3bitr4i.1 $e |- ( ph <-> ps ) $.
    3bitr4i.2 $e |- ( ch <-> ph ) $.
    3bitr4i.3 $e |- ( th <-> ps ) $.
    $( A chained inference from transitive law for logical equivalence.  This
       inference is frequently used to apply a definition to both sides of a
       logical equivalence.  (Contributed by NM, 5-Aug-1993.) $)
    3bitr4i $p |- ( ch <-> th ) $=
      ( bitr4i bitri ) CADFABDEGHI $.

    $( A chained inference from transitive law for logical equivalence.
       (Contributed by NM, 2-Sep-1995.) $)
    3bitr4ri $p |- ( th <-> ch ) $=
      ( bitr4i bitr2i ) CADFABDEGHI $.
  $}

  ${
    3bitrd.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitrd.2 $e |- ( ph -> ( ch <-> th ) ) $.
    3bitrd.3 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction from transitivity of biconditional.  (Contributed by NM,
       13-Aug-1999.) $)
    3bitrd $p |- ( ph -> ( ps <-> ta ) ) $=
      ( bitrd ) ABDEABCDFGIHI $.

    $( Deduction from transitivity of biconditional.  (Contributed by NM,
       4-Aug-2006.) $)
    3bitrrd $p |- ( ph -> ( ta <-> ps ) ) $=
      ( bitr2d bitr3d ) ADEBHABCDFGIJ $.
  $}

  ${
    3bitr2d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr2d.2 $e |- ( ph -> ( th <-> ch ) ) $.
    3bitr2d.3 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction from transitivity of biconditional.  (Contributed by NM,
       4-Aug-2006.) $)
    3bitr2d $p |- ( ph -> ( ps <-> ta ) ) $=
      ( bitr4d bitrd ) ABDEABCDFGIHJ $.

    $( Deduction from transitivity of biconditional.  (Contributed by NM,
       4-Aug-2006.) $)
    3bitr2rd $p |- ( ph -> ( ta <-> ps ) ) $=
      ( bitr4d bitr2d ) ABDEABCDFGIHJ $.
  $}

  ${
    3bitr3d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr3d.2 $e |- ( ph -> ( ps <-> th ) ) $.
    3bitr3d.3 $e |- ( ph -> ( ch <-> ta ) ) $.
    $( Deduction from transitivity of biconditional.  Useful for converting
       conditional definitions in a formula.  (Contributed by NM,
       24-Apr-1996.) $)
    3bitr3d $p |- ( ph -> ( th <-> ta ) ) $=
      ( bitr3d bitrd ) ADCEABDCGFIHJ $.

    $( Deduction from transitivity of biconditional.  (Contributed by NM,
       4-Aug-2006.) $)
    3bitr3rd $p |- ( ph -> ( ta <-> th ) ) $=
      ( bitr3d ) ACEDHABCDFGII $.
  $}

  ${
    3bitr4d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr4d.2 $e |- ( ph -> ( th <-> ps ) ) $.
    3bitr4d.3 $e |- ( ph -> ( ta <-> ch ) ) $.
    $( Deduction from transitivity of biconditional.  Useful for converting
       conditional definitions in a formula.  (Contributed by NM,
       18-Oct-1995.) $)
    3bitr4d $p |- ( ph -> ( th <-> ta ) ) $=
      ( bitr4d bitrd ) ADBEGABCEFHIJ $.

    $( Deduction from transitivity of biconditional.  (Contributed by NM,
       4-Aug-2006.) $)
    3bitr4rd $p |- ( ph -> ( ta <-> th ) ) $=
      ( bitr4d ) AEBDAECBHFIGI $.
  $}

  ${
    3bitr3g.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr3g.2 $e |- ( ps <-> th ) $.
    3bitr3g.3 $e |- ( ch <-> ta ) $.
    $( More general version of ~ 3bitr3i .  Useful for converting definitions
       in a formula.  (Contributed by NM, 4-Jun-1995.) $)
    3bitr3g $p |- ( ph -> ( th <-> ta ) ) $=
      ( syl5bbr syl6bb ) ADCEDBACGFIHJ $.
  $}

  ${
    3bitr4g.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3bitr4g.2 $e |- ( th <-> ps ) $.
    3bitr4g.3 $e |- ( ta <-> ch ) $.
    $( More general version of ~ 3bitr4i .  Useful for converting definitions
       in a formula.  (Contributed by NM, 5-Aug-1993.) $)
    3bitr4g $p |- ( ph -> ( th <-> ta ) ) $=
      ( syl5bb syl6bbr ) ADCEDBACGFIHJ $.
  $}

  ${
    bi3ant.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Construct a bi-conditional in antecedent position.  (Contributed by Wolf
       Lammen, 14-May-2013.) $)
    bi3ant $p |- ( ( ( th -> ta ) -> ph )
        -> ( ( ( ta -> th ) -> ps ) -> ( ( th <-> ta ) -> ch ) ) ) $=
      ( wi wb bi1 imim1i bi2 imim3i syl2im ) DEGZAGDEHZAGEDGZBGOBGOCGONADEIJOPB
      DEKJABCOFLM $.
  $}

  $( Express symmetries of theorems in terms of biconditionals.  (Contributed
     by Wolf Lammen, 14-May-2013.) $)
  bisym $p |- ( ( ( ph -> ps ) -> ( ch -> th ) ) -> ( ( ( ps -> ph )
      -> ( th -> ch ) ) -> ( ( ph <-> ps ) -> ( ch <-> th ) ) ) ) $=
    ( wi wb bi3 bi3ant ) CDEDCECDFABCDGH $.

  $( Double negation.  Theorem *4.13 of [WhiteheadRussell] p. 117.
     (Contributed by NM, 5-Aug-1993.) $)
  notnot $p |- ( ph <-> -. -. ph ) $=
    ( wn notnot1 notnot2 impbii ) AABBACADE $.

  $( Contraposition.  Theorem *4.1 of [WhiteheadRussell] p. 116.  (Contributed
     by NM, 5-Aug-1993.) $)
  con34b $p |- ( ( ph -> ps ) <-> ( -. ps -> -. ph ) ) $=
    ( wi wn con3 ax-3 impbii ) ABCBDADCABEBAFG $.

  ${
    con4bid.1 $e |- ( ph -> ( -. ps <-> -. ch ) ) $.
    $( A contraposition deduction.  (Contributed by NM, 21-May-1994.) $)
    con4bid $p |- ( ph -> ( ps <-> ch ) ) $=
      ( wn biimprd con4d biimpd impcon4bid ) ABCACBABEZCEZDFGAJKDHI $.
  $}

  ${
    notbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction negating both sides of a logical equivalence.  (Contributed by
       NM, 21-May-1994.) $)
    notbid $p |- ( ph -> ( -. ps <-> -. ch ) ) $=
      ( wn notnot 3bitr3g con4bid ) ABEZCEZABCIEJEDBFCFGH $.
  $}

  $( Contraposition.  Theorem *4.11 of [WhiteheadRussell] p. 117.  (Contributed
     by NM, 21-May-1994.)  (Proof shortened by Wolf Lammen, 12-Jun-2013.) $)
  notbi $p |- ( ( ph <-> ps ) <-> ( -. ph <-> -. ps ) ) $=
    ( wb wn id notbid con4bid impbii ) ABCZADBDCZIABIEFJABJEGH $.

  ${
    notbii.1 $e |- ( ph <-> ps ) $.
    $( Negate both sides of a logical equivalence.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 19-May-2013.) $)
    notbii $p |- ( -. ph <-> -. ps ) $=
      ( wb wn notbi mpbi ) ABDAEBEDCABFG $.

    $( Theorem notbii is the congruence law for negation. $)
    $( $j congruence 'notbii'; $)
  $}

  ${
    con4bii.1 $e |- ( -. ph <-> -. ps ) $.
    $( A contraposition inference.  (Contributed by NM, 21-May-1994.) $)
    con4bii $p |- ( ph <-> ps ) $=
      ( wb wn notbi mpbir ) ABDAEBEDCABFG $.
  $}

  ${
    mtbi.1 $e |- -. ph $.
    mtbi.2 $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus tollens.
       (Contributed by NM, 15-Nov-1994.)  (Proof shortened by Wolf Lammen,
       25-Oct-2012.) $)
    mtbi $p |- -. ps $=
      ( biimpri mto ) BACABDEF $.
  $}

  ${
    mtbir.1 $e |- -. ps $.
    mtbir.2 $e |- ( ph <-> ps ) $.
    $( An inference from a biconditional, related to modus tollens.
       (Contributed by NM, 15-Nov-1994.)  (Proof shortened by Wolf Lammen,
       14-Oct-2012.) $)
    mtbir $p |- -. ph $=
      ( bicomi mtbi ) BACABDEF $.
  $}

  ${
    mtbid.min $e |- ( ph -> -. ps ) $.
    mtbid.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, similar to modus tollens.
       (Contributed by NM, 26-Nov-1995.) $)
    mtbid $p |- ( ph -> -. ch ) $=
      ( biimprd mtod ) ACBDABCEFG $.
  $}

  ${
    mtbird.min $e |- ( ph -> -. ch ) $.
    mtbird.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( A deduction from a biconditional, similar to modus tollens.
       (Contributed by NM, 10-May-1994.) $)
    mtbird $p |- ( ph -> -. ps ) $=
      ( biimpd mtod ) ABCDABCEFG $.
  $}

  ${
    mtbii.min $e |- -. ps $.
    mtbii.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a biconditional, similar to modus tollens.
       (Contributed by NM, 27-Nov-1995.) $)
    mtbii $p |- ( ph -> -. ch ) $=
      ( biimprd mtoi ) ACBDABCEFG $.
  $}

  ${
    mtbiri.min $e |- -. ch $.
    mtbiri.maj $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An inference from a biconditional, similar to modus tollens.
       (Contributed by NM, 24-Aug-1995.) $)
    mtbiri $p |- ( ph -> -. ps ) $=
      ( biimpd mtoi ) ABCDABCEFG $.
  $}

  ${
    sylnib.1 $e |- ( ph -> -. ps ) $.
    sylnib.2 $e |- ( ps <-> ch ) $.
    $( A mixed syllogism inference from an implication and a biconditional.
       (Contributed by Wolf Lammen, 16-Dec-2013.) $)
    sylnib $p |- ( ph -> -. ch ) $=
      ( wb a1i mtbid ) ABCDBCFAEGH $.
  $}

  ${
    sylnibr.1 $e |- ( ph -> -. ps ) $.
    sylnibr.2 $e |- ( ch <-> ps ) $.
    $( A mixed syllogism inference from an implication and a biconditional.
       Useful for substituting a consequent with a definition.  (Contributed by
       Wolf Lammen, 16-Dec-2013.) $)
    sylnibr $p |- ( ph -> -. ch ) $=
      ( bicomi sylnib ) ABCDCBEFG $.
  $}

  ${
    sylnbi.1 $e |- ( ph <-> ps ) $.
    sylnbi.2 $e |- ( -. ps -> ch ) $.
    $( A mixed syllogism inference from a biconditional and an implication.
       Useful for substituting an antecedent with a definition.  (Contributed
       by Wolf Lammen, 16-Dec-2013.) $)
    sylnbi $p |- ( -. ph -> ch ) $=
      ( wn notbii sylbi ) AFBFCABDGEH $.
  $}

  ${
    sylnbir.1 $e |- ( ps <-> ph ) $.
    sylnbir.2 $e |- ( -. ps -> ch ) $.
    $( A mixed syllogism inference from a biconditional and an implication.
       (Contributed by Wolf Lammen, 16-Dec-2013.) $)
    sylnbir $p |- ( -. ph -> ch ) $=
      ( bicomi sylnbi ) ABCBADFEG $.
  $}

  ${
    xchnxbi.1 $e |- ( -. ph <-> ps ) $.
    xchnxbi.2 $e |- ( ph <-> ch ) $.
    $( Replacement of a subexpression by an equivalent one.  (Contributed by
       Wolf Lammen, 27-Sep-2014.) $)
    xchnxbi $p |- ( -. ch <-> ps ) $=
      ( wn notbii bitr3i ) CFAFBACEGDH $.
  $}

  ${
    xchnxbir.1 $e |- ( -. ph <-> ps ) $.
    xchnxbir.2 $e |- ( ch <-> ph ) $.
    $( Replacement of a subexpression by an equivalent one.  (Contributed by
       Wolf Lammen, 27-Sep-2014.) $)
    xchnxbir $p |- ( -. ch <-> ps ) $=
      ( bicomi xchnxbi ) ABCDCAEFG $.
  $}

  ${
    xchbinx.1 $e |- ( ph <-> -. ps ) $.
    xchbinx.2 $e |- ( ps <-> ch ) $.
    $( Replacement of a subexpression by an equivalent one.  (Contributed by
       Wolf Lammen, 27-Sep-2014.) $)
    xchbinx $p |- ( ph <-> -. ch ) $=
      ( wn notbii bitri ) ABFCFDBCEGH $.
  $}

  ${
    xchbinxr.1 $e |- ( ph <-> -. ps ) $.
    xchbinxr.2 $e |- ( ch <-> ps ) $.
    $( Replacement of a subexpression by an equivalent one.  (Contributed by
       Wolf Lammen, 27-Sep-2014.) $)
    xchbinxr $p |- ( ph <-> -. ch ) $=
      ( bicomi xchbinx ) ABCDCBEFG $.
  $}

  $( The next three rules are useful for building up wff's around a
     definition, in order to make use of the definition. $)

  ${
    bi.a $e |- ( ph <-> ps ) $.
    $( Introduce an antecedent to both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       6-Feb-2013.) $)
    imbi2i $p |- ( ( ch -> ph ) <-> ( ch -> ps ) ) $=
      ( wb a1i pm5.74i ) CABABECDFG $.
  $}

  ${
    bibi.a $e |- ( ph <-> ps ) $.
    $( Inference adding a biconditional to the left in an equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       7-May-2011.)  (Proof shortened by Wolf Lammen, 16-May-2013.) $)
    bibi2i $p |- ( ( ch <-> ph ) <-> ( ch <-> ps ) ) $=
      ( wb id syl6bb syl6bbr impbii ) CAEZCBEZJCABJFDGKCBAKFDHI $.

    $( Inference adding a biconditional to the right in an equivalence.
       (Contributed by NM, 5-Aug-1993.) $)
    bibi1i $p |- ( ( ph <-> ch ) <-> ( ps <-> ch ) ) $=
      ( wb bicom bibi2i 3bitri ) ACECAECBEBCEACFABCDGCBFH $.

    ${
      bibi12.2 $e |- ( ch <-> th ) $.
      $( The equivalence of two equivalences.  (Contributed by NM,
         5-Aug-1993.) $)
      bibi12i $p |- ( ( ph <-> ch ) <-> ( ps <-> th ) ) $=
        ( wb bibi2i bibi1i bitri ) ACGADGBDGCDAFHABDEIJ $.
    $}
  $}

  ${
    imbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction adding an antecedent to both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.) $)
    imbi2d $p |- ( ph -> ( ( th -> ps ) <-> ( th -> ch ) ) ) $=
      ( wb a1d pm5.74d ) ADBCABCFDEGH $.

    $( Deduction adding a consequent to both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       17-Sep-2013.) $)
    imbi1d $p |- ( ph -> ( ( ps -> th ) <-> ( ch -> th ) ) ) $=
      ( wi biimprd imim1d biimpd impbid ) ABDFCDFACBDABCEGHABCDABCEIHJ $.

    $( Deduction adding a biconditional to the left in an equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       19-May-2013.) $)
    bibi2d $p |- ( ph -> ( ( th <-> ps ) <-> ( th <-> ch ) ) ) $=
      ( wb wi pm5.74i bibi2i pm5.74 3bitr4i pm5.74ri ) ADBFZDCFZADGZABGZFOACGZF
      AMGANGPQOABCEHIADBJADCJKL $.

    $( Deduction adding a biconditional to the right in an equivalence.
       (Contributed by NM, 5-Aug-1993.) $)
    bibi1d $p |- ( ph -> ( ( ps <-> th ) <-> ( ch <-> th ) ) ) $=
      ( wb bibi2d bicom 3bitr4g ) ADBFDCFBDFCDFABCDEGBDHCDHI $.
  $}

  ${
    imbi12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    imbi12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction joining two equivalences to form equivalence of implications.
       (Contributed by NM, 5-Aug-1993.) $)
    imbi12d $p |- ( ph -> ( ( ps -> th ) <-> ( ch -> ta ) ) ) $=
      ( wi imbi1d imbi2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.

    $( Deduction joining two equivalences to form equivalence of
       biconditionals.  (Contributed by NM, 5-Aug-1993.) $)
    bibi12d $p |- ( ph -> ( ( ps <-> th ) <-> ( ch <-> ta ) ) ) $=
      ( wb bibi1d bibi2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  $( Theorem *4.84 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.) $)
  imbi1 $p |- ( ( ph <-> ps ) -> ( ( ph -> ch ) <-> ( ps -> ch ) ) ) $=
    ( wb id imbi1d ) ABDZABCGEF $.

  $( Theorem *4.85 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 19-May-2013.) $)
  imbi2 $p |- ( ( ph <-> ps ) -> ( ( ch -> ph ) <-> ( ch -> ps ) ) ) $=
    ( wb id imbi2d ) ABDZABCGEF $.

  ${
    imbi1i.1 $e |- ( ph <-> ps ) $.
    $( Introduce a consequent to both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       17-Sep-2013.) $)
    imbi1i $p |- ( ( ph -> ch ) <-> ( ps -> ch ) ) $=
      ( wb wi imbi1 ax-mp ) ABEACFBCFEDABCGH $.
  $}

  ${
    imbi12i.1 $e |- ( ph <-> ps ) $.
    imbi12i.2 $e |- ( ch <-> th ) $.
    $( Join two logical equivalences to form equivalence of implications.
       (Contributed by NM, 5-Aug-1993.) $)
    imbi12i $p |- ( ( ph -> ch ) <-> ( ps -> th ) ) $=
      ( wi imbi2i imbi1i bitri ) ACGADGBDGCDAFHABDEIJ $.

    $( Theorem imbi12i is the congruence law for implication. $)
    $( $j congruence 'imbi12i'; $)
  $}

  $( Theorem *4.86 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.) $)
  bibi1 $p |- ( ( ph <-> ps ) -> ( ( ph <-> ch ) <-> ( ps <-> ch ) ) ) $=
    ( wb id bibi1d ) ABDZABCGEF $.

  $( Contraposition.  Theorem *4.12 of [WhiteheadRussell] p. 117.  (Contributed
     by NM, 15-Apr-1995.)  (Proof shortened by Wolf Lammen, 3-Jan-2013.) $)
  con2bi $p |- ( ( ph <-> -. ps ) <-> ( ps <-> -. ph ) ) $=
    ( wn wb notbi notnot bibi2i bicom 3bitr2i ) ABCZDACZJCZDKBDBKDAJEBLKBFGKBHI
    $.

  ${
    con2bid.1 $e |- ( ph -> ( ps <-> -. ch ) ) $.
    $( A contraposition deduction.  (Contributed by NM, 15-Apr-1995.) $)
    con2bid $p |- ( ph -> ( ch <-> -. ps ) ) $=
      ( wn wb con2bi sylibr ) ABCEFCBEFDCBGH $.
  $}

  ${
    con1bid.1 $e |- ( ph -> ( -. ps <-> ch ) ) $.
    $( A contraposition deduction.  (Contributed by NM, 9-Oct-1999.) $)
    con1bid $p |- ( ph -> ( -. ch <-> ps ) ) $=
      ( wn bicomd con2bid ) ABCEACBABECDFGF $.
  $}

  ${
    con1bii.1 $e |- ( -. ph <-> ps ) $.
    $( A contraposition inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 13-Oct-2012.) $)
    con1bii $p |- ( -. ps <-> ph ) $=
      ( wn notnot xchbinx bicomi ) ABDAADBAECFG $.
  $}

  ${
    con2bii.1 $e |- ( ph <-> -. ps ) $.
    $( A contraposition inference.  (Contributed by NM, 5-Aug-1993.) $)
    con2bii $p |- ( ps <-> -. ph ) $=
      ( wn bicomi con1bii ) ADBBAABDCEFE $.
  $}

  $( Contraposition.  Bidirectional version of ~ con1 .  (Contributed by NM,
     5-Aug-1993.) $)
  con1b $p |- ( ( -. ph -> ps ) <-> ( -. ps -> ph ) ) $=
    ( wn wi con1 impbii ) ACBDBCADABEBAEF $.

  $( Contraposition.  Bidirectional version of ~ con2 .  (Contributed by NM,
     5-Aug-1993.) $)
  con2b $p |- ( ( ph -> -. ps ) <-> ( ps -> -. ph ) ) $=
    ( wn wi con2 impbii ) ABCDBACDABEBAEF $.

  $( A wff is equivalent to itself with true antecedent.  (Contributed by NM,
     28-Jan-1996.) $)
  biimt $p |- ( ph -> ( ps <-> ( ph -> ps ) ) ) $=
    ( wi ax-1 pm2.27 impbid2 ) ABABCBADABEF $.

  $( Theorem *5.5 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.5 $p |- ( ph -> ( ( ph -> ps ) <-> ps ) ) $=
    ( wi biimt bicomd ) ABABCABDE $.

  ${
    a1bi.1 $e |- ph $.
    $( Inference rule introducing a theorem as an antecedent.  (Contributed by
       NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 11-Nov-2012.) $)
    a1bi $p |- ( ps <-> ( ph -> ps ) ) $=
      ( wi wb biimt ax-mp ) ABABDECABFG $.
  $}

  ${
    mt2bi.1 $e |- ph $.
    $( A false consequent falsifies an antecedent.  (Contributed by NM,
       19-Aug-1993.)  (Proof shortened by Wolf Lammen, 12-Nov-2012.) $)
    mt2bi $p |- ( -. ps <-> ( ps -> -. ph ) ) $=
      ( wn wi a1bi con2b bitri ) BDZAIEBADEAICFABGH $.
  $}

  $( Modus-tollens-like theorem.  (Contributed by NM, 7-Apr-2001.)  (Proof
     shortened by Wolf Lammen, 12-Nov-2012.) $)
  mtt $p |- ( -. ph -> ( -. ps <-> ( ps -> ph ) ) ) $=
    ( wn wi biimt con34b syl6bbr ) ACZBCZHIDBADHIEBAFG $.

  $( Theorem *5.501 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.501 $p |- ( ph -> ( ps <-> ( ph <-> ps ) ) ) $=
    ( wb pm5.1im bi1 com12 impbid ) ABABCZABDHABABEFG $.

  $( Implication in terms of implication and biconditional.  (Contributed by
     NM, 31-Mar-1994.)  (Proof shortened by Wolf Lammen, 24-Jan-2013.) $)
  ibib $p |- ( ( ph -> ps ) <-> ( ph -> ( ph <-> ps ) ) ) $=
    ( wb pm5.501 pm5.74i ) ABABCABDE $.

  $( Implication in terms of implication and biconditional.  (Contributed by
     NM, 29-Apr-2005.)  (Proof shortened by Wolf Lammen, 21-Dec-2013.) $)
  ibibr $p |- ( ( ph -> ps ) <-> ( ph -> ( ps <-> ph ) ) ) $=
    ( wb pm5.501 bicom syl6bb pm5.74i ) ABBACZABABCHABDABEFG $.

  ${
    tbt.1 $e |- ph $.
    $( A wff is equivalent to its equivalence with truth.  (Contributed by NM,
       18-Aug-1993.)  (Proof shortened by Andrew Salmon, 13-May-2011.) $)
    tbt $p |- ( ps <-> ( ps <-> ph ) ) $=
      ( wb ibibr pm5.74ri ax-mp ) ABBADZDCABHABEFG $.
  $}

  $( The negation of a wff is equivalent to the wff's equivalence to
     falsehood.  (Contributed by Juha Arpiainen, 19-Jan-2006.)  (Proof
     shortened by Wolf Lammen, 28-Jan-2013.) $)
  nbn2 $p |- ( -. ph -> ( -. ps <-> ( ph <-> ps ) ) ) $=
    ( wn wb pm5.501 notbi syl6bbr ) ACZBCZHIDABDHIEABFG $.

  $( Transfer negation via an equivalence.  (Contributed by NM, 3-Oct-2007.)
     (Proof shortened by Wolf Lammen, 28-Jan-2013.) $)
  bibif $p |- ( -. ps -> ( ( ph <-> ps ) <-> -. ph ) ) $=
    ( wn wb nbn2 bicom syl6rbb ) BCACBADABDBAEBAFG $.

  ${
    nbn.1 $e |- -. ph $.
    $( The negation of a wff is equivalent to the wff's equivalence to
       falsehood.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
       Lammen, 3-Oct-2013.) $)
    nbn $p |- ( -. ps <-> ( ps <-> ph ) ) $=
      ( wb wn bibif ax-mp bicomi ) BADZBEZAEIJDCBAFGH $.
  $}

  ${
    nbn3.1 $e |- ph $.
    $( Transfer falsehood via equivalence.  (Contributed by NM,
       11-Sep-2006.) $)
    nbn3 $p |- ( -. ps <-> ( ps <-> -. ph ) ) $=
      ( wn notnoti nbn ) ADBACEF $.
  $}

  $( Two propositions are equivalent if they are both false.  Closed form of
     ~ 2false .  Equivalent to a ~ bi2 -like version of the xor-connective.
     (Contributed by Wolf Lammen, 13-May-2013.) $)
  pm5.21im $p |- ( -. ph -> ( -. ps -> ( ph <-> ps ) ) ) $=
    ( wn wb nbn2 biimpd ) ACBCABDABEF $.

  ${
    2false.1 $e |- -. ph $.
    2false.2 $e |- -. ps $.
    $( Two falsehoods are equivalent.  (Contributed by NM, 4-Apr-2005.)  (Proof
       shortened by Wolf Lammen, 19-May-2013.) $)
    2false $p |- ( ph <-> ps ) $=
      ( wn 2th con4bii ) ABAEBECDFG $.
  $}

  ${
    2falsed.1 $e |- ( ph -> -. ps ) $.
    2falsed.2 $e |- ( ph -> -. ch ) $.
    $( Two falsehoods are equivalent (deduction rule).  (Contributed by NM,
       11-Oct-2013.) $)
    2falsed $p |- ( ph -> ( ps <-> ch ) ) $=
      ( pm2.21d impbid ) ABCABCDFACBEFG $.
  $}

  ${
    pm5.21ni.1 $e |- ( ph -> ps ) $.
    pm5.21ni.2 $e |- ( ch -> ps ) $.
    $( Two propositions implying a false one are equivalent.  (Contributed by
       NM, 16-Feb-1996.)  (Proof shortened by Wolf Lammen, 19-May-2013.) $)
    pm5.21ni $p |- ( -. ps -> ( ph <-> ch ) ) $=
      ( wn con3i 2falsed ) BFACABDGCBEGH $.

    ${
      pm5.21nii.3 $e |- ( ps -> ( ph <-> ch ) ) $.
      $( Eliminate an antecedent implied by each side of a biconditional.
         (Contributed by NM, 21-May-1999.) $)
      pm5.21nii $p |- ( ph <-> ch ) $=
        ( wb pm5.21ni pm2.61i ) BACGFABCDEHI $.
    $}
  $}

  ${
    pm5.21ndd.1 $e |- ( ph -> ( ch -> ps ) ) $.
    pm5.21ndd.2 $e |- ( ph -> ( th -> ps ) ) $.
    pm5.21ndd.3 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Eliminate an antecedent implied by each side of a biconditional,
       deduction version.  (Contributed by Paul Chapman, 21-Nov-2012.)  (Proof
       shortened by Wolf Lammen, 6-Oct-2013.) $)
    pm5.21ndd $p |- ( ph -> ( ch <-> th ) ) $=
      ( wb wn con3d pm5.21im syl6c pm2.61d ) ABCDHZGABICIDINACBEJADBFJCDKLM $.
  $}

  ${
    bija.1 $e |- ( ph -> ( ps -> ch ) ) $.
    bija.2 $e |- ( -. ph -> ( -. ps -> ch ) ) $.
    $( Combine antecedents into a single bi-conditional.  This inference,
       reminiscent of ~ ja , is reversible:  The hypotheses can be deduced from
       the conclusion alone (see ~ pm5.1im and ~ pm5.21im ).  (Contributed by
       Wolf Lammen, 13-May-2013.) $)
    bija $p |- ( ( ph <-> ps ) -> ch ) $=
      ( wb bi2 syli wn bi1 con3d pm2.61d ) ABFZBCBMACABGDHBIMAICMABABJKEHL $.
  $}

  $( Theorem *5.18 of [WhiteheadRussell] p. 124.  This theorem says that
     logical equivalence is the same as negated "exclusive-or."  (Contributed
     by NM, 28-Jun-2002.)  (Proof shortened by Andrew Salmon, 20-Jun-2011.)
     (Proof shortened by Wolf Lammen, 15-Oct-2013.) $)
  pm5.18 $p |- ( ( ph <-> ps ) <-> -. ( ph <-> -. ps ) ) $=
    ( wb wn pm5.501 con1bid bitr2d nbn2 pm2.61i ) AABCZABDZCZDZCAMBJABLAKEFABEG
    ADZMKJNKLAKHFABHGI $.

  $( Two ways to express "exclusive or."  (Contributed by NM, 1-Jan-2006.) $)
  xor3 $p |- ( -. ( ph <-> ps ) <-> ( ph <-> -. ps ) ) $=
    ( wn wb pm5.18 con2bii bicomi ) ABCDZABDZCIHABEFG $.

  $( Move negation outside of biconditional.  Compare Theorem *5.18 of
     [WhiteheadRussell] p. 124.  (Contributed by NM, 27-Jun-2002.)  (Proof
     shortened by Wolf Lammen, 20-Sep-2013.) $)
  nbbn $p |- ( ( -. ph <-> ps ) <-> -. ( ph <-> ps ) ) $=
    ( wb wn xor3 con2bi bicom 3bitrri ) ABCDABDCBADZCIBCABEABFBIGH $.

  $( Associative law for the biconditional.  An axiom of system DS in Vladimir
     Lifschitz, "On calculational proofs", Annals of Pure and Applied Logic,
     113:207-224, 2002,
     ~ http://www.cs.utexas.edu/users/ai-lab/pub-view.php?PubID=26805 .
     Interestingly, this law was not included in _Principia Mathematica_ but
     was apparently first noted by Jan Lukasiewicz circa 1923.  (Contributed by
     NM, 8-Jan-2005.)  (Proof shortened by Juha Arpiainen, 19-Jan-2006.)
     (Proof shortened by Wolf Lammen, 21-Sep-2013.) $)
  biass $p |- ( ( ( ph <-> ps ) <-> ch ) <-> ( ph <-> ( ps <-> ch ) ) ) $=
    ( wb pm5.501 bibi1d bitr3d wn nbbn nbn2 syl5bbr pm2.61i ) AABDZCDZABCDZDZDA
    ONPABMCABEFAOEGAHZOHZNPRBHZCDQNBCIQSMCABJFKAOJGL $.

  $( Theorem *5.19 of [WhiteheadRussell] p. 124.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.19 $p |- -. ( ph <-> -. ph ) $=
    ( wb wn biid pm5.18 mpbi ) AABAACBCADAAEF $.

  $( Logical equivalence of commuted antecedents.  Part of Theorem *4.87 of
     [WhiteheadRussell] p. 122.  (Contributed by NM, 5-Aug-1993.) $)
  bi2.04 $p |- ( ( ph -> ( ps -> ch ) ) <-> ( ps -> ( ph -> ch ) ) ) $=
    ( wi pm2.04 impbii ) ABCDDBACDDABCEBACEF $.

  $( Antecedent absorption implication.  Theorem *5.4 of [WhiteheadRussell]
     p. 125.  (Contributed by NM, 5-Aug-1993.) $)
  pm5.4 $p |- ( ( ph -> ( ph -> ps ) ) <-> ( ph -> ps ) ) $=
    ( wi pm2.43 ax-1 impbii ) AABCZCGABDGAEF $.

  $( Distributive law for implication.  Compare Theorem *5.41 of
     [WhiteheadRussell] p. 125.  (Contributed by NM, 5-Aug-1993.) $)
  imdi $p |- ( ( ph -> ( ps -> ch ) ) <->
               ( ( ph -> ps ) -> ( ph -> ch ) ) ) $=
    ( wi ax-2 pm2.86 impbii ) ABCDDABDACDDABCEABCFG $.

  $( Theorem *5.41 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 12-Oct-2012.) $)
  pm5.41 $p |- ( ( ( ph -> ps ) -> ( ph -> ch ) ) <->
                ( ph -> ( ps -> ch ) ) ) $=
    ( wi imdi bicomi ) ABCDDABDACDDABCEF $.

  $( Theorem *4.8 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.8 $p |- ( ( ph -> -. ph ) <-> -. ph ) $=
    ( wn wi pm2.01 ax-1 impbii ) AABZCGADGAEF $.

  $( Theorem *4.81 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.81 $p |- ( ( -. ph -> ph ) <-> ph ) $=
    ( wn wi pm2.18 pm2.24 impbii ) ABACAADAAEF $.

  $( Simplify an implication between two implications when the antecedent of
     the first is a consequence of the antecedent of the second.  The reverse
     form is useful in producing the successor step in induction proofs.
     (Contributed by Paul Chapman, 22-Jun-2011.)  (Proof shortened by Wolf
     Lammen, 14-Sep-2013.) $)
  imim21b $p |- ( ( ps -> ph ) -> ( ( ( ph -> ch ) -> ( ps -> th ) ) <->
                                    ( ps -> ( ch -> th ) ) ) ) $=
    ( wi bi2.04 wb pm5.5 imbi1d imim2i pm5.74d syl5bb ) ACEZBDEEBMDEZEBAEZBCDEZ
    EMBDFOBNPANPGBAMCDACHIJKL $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical disjunction and conjunction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Here we define disjunction (logical 'or') ` \/ ` ( ~ df-or ) and conjunction
  (logical 'and') ` /\ ` ( ~ df-an ). We also define various rules for
  simplifying and applying them, e.g., ~ olc , ~ orc , and ~ orcom .

$)

  $( Declare connectives for disjunction ('or') and conjunction ('and'). $)
  $c \/ $. $( Vee (read:  'or') $)
  $c /\ $. $( Wedge (read:  'and') $)

  $( Extend wff definition to include disjunction ('or'). $)
  wo $a wff ( ph \/ ps ) $.
  $( Extend wff definition to include conjunction ('and'). $)
  wa $a wff ( ph /\ ps ) $.

  $( Define disjunction (logical 'or').  Definition of [Margaris] p. 49.  When
     the left operand, right operand, or both are true, the result is true;
     when both sides are false, the result is false.  For example, it is true
     that ` ( 2 = 3 \/ 4 = 4 ) ` ( ~ ex-or ).  After we define the constant
     true ` T. ` ( ~ df-tru ) and the constant false ` F. ` ( ~ df-fal ), we
     will be able to prove these truth table values:
     ` ( ( T. \/ T. ) <-> T. ) ` ( ~ truortru ), ` ( ( T. \/ F. ) <-> T. ) `
     ( ~ truorfal ), ` ( ( F. \/ T. ) <-> T. ) ` ( ~ falortru ), and
     ` ( ( F. \/ F. ) <-> F. ) ` ( ~ falorfal ).

     This is our first use of the biconditional connective in a definition; we
     use the biconditional connective in place of the traditional "<=def=>",
     which means the same thing, except that we can manipulate the
     biconditional connective directly in proofs rather than having to rely on
     an informal definition substitution rule.  Note that if we mechanically
     substitute ` ( -. ph -> ps ) ` for ` ( ph \/ ps ) ` , we end up with an
     instance of previously proved theorem ~ biid .  This is the justification
     for the definition, along with the fact that it introduces a new symbol
     ` \/ ` .  Contrast with ` /\ ` ( ~ df-an ), ` -> ` ( ~ wi ), ` -/\ `
     ( ~ df-nan ), and ` \/_ ` ( ~ df-xor ) .  (Contributed by NM,
     5-Aug-1993.) $)
  df-or $a |- ( ( ph \/ ps ) <-> ( -. ph -> ps ) ) $.

  $( Define conjunction (logical 'and').  Definition of [Margaris] p. 49.  When
     both the left and right operand are true, the result is true; when either
     is false, the result is false.  For example, it is true that
     ` ( 2 = 2 /\ 3 = 3 ) ` .  After we define the constant true ` T. `
     ( ~ df-tru ) and the constant false ` F. ` ( ~ df-fal ), we will be able
     to prove these truth table values: ` ( ( T. /\ T. ) <-> T. ) `
     ( ~ truantru ), ` ( ( T. /\ F. ) <-> F. ) ` ( ~ truanfal ),
     ` ( ( F. /\ T. ) <-> F. ) ` ( ~ falantru ), and
     ` ( ( F. /\ F. ) <-> F. ) ` ( ~ falanfal ).

     Contrast with ` \/ ` ( ~ df-or ), ` -> ` ( ~ wi ), ` -/\ ` ( ~ df-nan ),
     and ` \/_ ` ( ~ df-xor ) .  (Contributed by NM, 5-Aug-1993.) $)
  df-an $a |- ( ( ph /\ ps ) <-> -. ( ph -> -. ps ) ) $.

  $( Theorem *4.64 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.64 $p |- ( ( -. ph -> ps ) <-> ( ph \/ ps ) ) $=
    ( wo wn wi df-or bicomi ) ABCADBEABFG $.

  $( Theorem *2.53 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.53 $p |- ( ( ph \/ ps ) -> ( -. ph -> ps ) ) $=
    ( wo wn wi df-or biimpi ) ABCADBEABFG $.

  $( Theorem *2.54 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.54 $p |- ( ( -. ph -> ps ) -> ( ph \/ ps ) ) $=
    ( wo wn wi df-or biimpri ) ABCADBEABFG $.

  ${
    ori.1 $e |- ( ph \/ ps ) $.
    $( Infer implication from disjunction.  (Contributed by NM,
       11-Jun-1994.) $)
    ori $p |- ( -. ph -> ps ) $=
      ( wo wn wi df-or mpbi ) ABDAEBFCABGH $.
  $}

  ${
    orri.1 $e |- ( -. ph -> ps ) $.
    $( Infer implication from disjunction.  (Contributed by NM,
       11-Jun-1994.) $)
    orri $p |- ( ph \/ ps ) $=
      ( wo wn wi df-or mpbir ) ABDAEBFCABGH $.
  $}

  ${
    ord.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    $( Deduce implication from disjunction.  (Contributed by NM,
       18-May-1994.) $)
    ord $p |- ( ph -> ( -. ps -> ch ) ) $=
      ( wo wn wi df-or sylib ) ABCEBFCGDBCHI $.
  $}

  ${
    orrd.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    $( Deduce implication from disjunction.  (Contributed by NM,
       27-Nov-1995.) $)
    orrd $p |- ( ph -> ( ps \/ ch ) ) $=
      ( wn wi wo pm2.54 syl ) ABECFBCGDBCHI $.
  $}

  ${
    jaoi.1 $e |- ( ph -> ps ) $.
    jaoi.2 $e |- ( ch -> ps ) $.
    $( Inference disjoining the antecedents of two implications.  (Contributed
       by NM, 5-Apr-1994.) $)
    jaoi $p |- ( ( ph \/ ch ) -> ps ) $=
      ( wo wn pm2.53 syl6 pm2.61d2 ) ACFZABKAGCBACHEIDJ $.
  $}

  ${
    jaod.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jaod.2 $e |- ( ph -> ( th -> ch ) ) $.
    $( Deduction disjoining the antecedents of two implications.  (Contributed
       by NM, 18-Aug-1994.) $)
    jaod $p |- ( ph -> ( ( ps \/ th ) -> ch ) ) $=
      ( wo wi com12 jaoi ) BDGACBACHDABCEIADCFIJI $.

    jaod.3 $e |- ( ph -> ( ps \/ th ) ) $.
    $( Eliminate a disjunction in a deduction.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    mpjaod $p |- ( ph -> ch ) $=
      ( wo jaod mpd ) ABDHCGABCDEFIJ $.
  $}

  $( Elimination of disjunction by denial of a disjunct.  Theorem *2.55 of
     [WhiteheadRussell] p. 107.  (Contributed by NM, 12-Aug-1994.)  (Proof
     shortened by Wolf Lammen, 21-Jul-2012.) $)
  orel1 $p |- ( -. ph -> ( ( ph \/ ps ) -> ps ) ) $=
    ( wo wn pm2.53 com12 ) ABCADBABEF $.

  $( Elimination of disjunction by denial of a disjunct.  Theorem *2.56 of
     [WhiteheadRussell] p. 107.  (Contributed by NM, 12-Aug-1994.)  (Proof
     shortened by Wolf Lammen, 5-Apr-2013.) $)
  orel2 $p |- ( -. ph -> ( ( ps \/ ph ) -> ps ) ) $=
    ( wn idd pm2.21 jaod ) ACZBBAGBDABEF $.

  $( Introduction of a disjunct.  Axiom *1.3 of [WhiteheadRussell] p. 96.
     (Contributed by NM, 30-Aug-1993.) $)
  olc $p |- ( ph -> ( ps \/ ph ) ) $=
    ( wn ax-1 orrd ) ABAABCDE $.

  $( Introduction of a disjunct.  Theorem *2.2 of [WhiteheadRussell] p. 104.
     (Contributed by NM, 30-Aug-1993.) $)
  orc $p |- ( ph -> ( ph \/ ps ) ) $=
    ( pm2.24 orrd ) AABABCD $.

  $( Axiom *1.4 of [WhiteheadRussell] p. 96.  (Contributed by NM,
     3-Jan-2005.) $)
  pm1.4 $p |- ( ( ph \/ ps ) -> ( ps \/ ph ) ) $=
    ( wo olc orc jaoi ) ABACBABDBAEF $.

  $( Commutative law for disjunction.  Theorem *4.31 of [WhiteheadRussell]
     p. 118.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 15-Nov-2012.) $)
  orcom $p |- ( ( ph \/ ps ) <-> ( ps \/ ph ) ) $=
    ( wo pm1.4 impbii ) ABCBACABDBADE $.

  ${
    orcomd.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    $( Commutation of disjuncts in consequent.  (Contributed by NM,
       2-Dec-2010.) $)
    orcomd $p |- ( ph -> ( ch \/ ps ) ) $=
      ( wo orcom sylib ) ABCECBEDBCFG $.
  $}

  ${
    orcoms.1 $e |- ( ( ph \/ ps ) -> ch ) $.
    $( Commutation of disjuncts in antecedent.  (Contributed by NM,
       2-Dec-2012.) $)
    orcoms $p |- ( ( ps \/ ph ) -> ch ) $=
      ( wo pm1.4 syl ) BAEABECBAFDG $.
  $}

  ${
    orci.1 $e |- ph $.
    $( Deduction introducing a disjunct.  (Contributed by NM, 19-Jan-2008.)
       (Proof shortened by Wolf Lammen, 14-Nov-2012.) $)
    orci $p |- ( ph \/ ps ) $=
      ( pm2.24i orri ) ABABCDE $.

    $( Deduction introducing a disjunct.  (Contributed by NM, 19-Jan-2008.)
       (Proof shortened by Wolf Lammen, 14-Nov-2012.) $)
    olci $p |- ( ps \/ ph ) $=
      ( wn a1i orri ) BAABDCEF $.
  $}

  ${
    orcd.1 $e |- ( ph -> ps ) $.
    $( Deduction introducing a disjunct.  A translation of natural deduction
       rule ` \/ ` IR ( ` \/ ` insertion right), see ~ natded .  (Contributed
       by NM, 20-Sep-2007.) $)
    orcd $p |- ( ph -> ( ps \/ ch ) ) $=
      ( wo orc syl ) ABBCEDBCFG $.

    $( Deduction introducing a disjunct.  A translation of natural deduction
       rule ` \/ ` IL ( ` \/ ` insertion left), see ~ natded .  (Contributed by
       NM, 11-Apr-2008.)  (Proof shortened by Wolf Lammen, 3-Oct-2013.) $)
    olcd $p |- ( ph -> ( ch \/ ps ) ) $=
      ( orcd orcomd ) ABCABCDEF $.
  $}

  ${
    orcs.1 $e |- ( ( ph \/ ps ) -> ch ) $.
    $( Deduction eliminating disjunct. _Notational convention_:  We sometimes
       suffix with "s" the label of an inference that manipulates an
       antecedent, leaving the consequent unchanged.  The "s" means that the
       inference eliminates the need for a syllogism ( ~ syl ) -type inference
       in a proof.  (Contributed by NM, 21-Jun-1994.) $)
    orcs $p |- ( ph -> ch ) $=
      ( wo orc syl ) AABECABFDG $.
  $}

  ${
    olcs.1 $e |- ( ( ph \/ ps ) -> ch ) $.
    $( Deduction eliminating disjunct.  (Contributed by NM, 21-Jun-1994.)
       (Proof shortened by Wolf Lammen, 3-Oct-2013.) $)
    olcs $p |- ( ps -> ch ) $=
      ( orcoms orcs ) BACABCDEF $.
  $}

  $( Theorem *2.07 of [WhiteheadRussell] p. 101.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.07 $p |- ( ph -> ( ph \/ ph ) ) $=
    ( olc ) AAB $.

  $( Theorem *2.45 of [WhiteheadRussell] p. 106.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.45 $p |- ( -. ( ph \/ ps ) -> -. ph ) $=
    ( wo orc con3i ) AABCABDE $.

  $( Theorem *2.46 of [WhiteheadRussell] p. 106.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.46 $p |- ( -. ( ph \/ ps ) -> -. ps ) $=
    ( wo olc con3i ) BABCBADE $.

  $( Theorem *2.47 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.47 $p |- ( -. ( ph \/ ps ) -> ( -. ph \/ ps ) ) $=
    ( wo wn pm2.45 orcd ) ABCDADBABEF $.

  $( Theorem *2.48 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.48 $p |- ( -. ( ph \/ ps ) -> ( ph \/ -. ps ) ) $=
    ( wo wn pm2.46 olcd ) ABCDBDAABEF $.

  $( Theorem *2.49 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.49 $p |- ( -. ( ph \/ ps ) -> ( -. ph \/ -. ps ) ) $=
    ( wo wn pm2.46 olcd ) ABCDBDADABEF $.

  $( Slight generalization of Theorem *2.67 of [WhiteheadRussell] p. 107.
     (Contributed by NM, 3-Jan-2005.) $)
  pm2.67-2 $p |- ( ( ( ph \/ ch ) -> ps ) -> ( ph -> ps ) ) $=
    ( wo orc imim1i ) AACDBACEF $.

  $( Theorem *2.67 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.67 $p |- ( ( ( ph \/ ps ) -> ps ) -> ( ph -> ps ) ) $=
    ( pm2.67-2 ) ABBC $.

  $( Theorem *2.25 of [WhiteheadRussell] p. 104.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.25 $p |- ( ph \/ ( ( ph \/ ps ) -> ps ) ) $=
    ( wo wi orel1 orri ) AABCBDABEF $.

  $( A wff is equivalent to its disjunction with falsehood.  Theorem *4.74 of
     [WhiteheadRussell] p. 121.  (Contributed by NM, 23-Mar-1995.)  (Proof
     shortened by Wolf Lammen, 18-Nov-2012.) $)
  biorf $p |- ( -. ph -> ( ps <-> ( ph \/ ps ) ) ) $=
    ( wn wo olc orel1 impbid2 ) ACBABDBAEABFG $.

  $( A wff is equivalent to its negated disjunction with falsehood.
     (Contributed by NM, 9-Jul-2012.) $)
  biortn $p |- ( ph -> ( ps <-> ( -. ph \/ ps ) ) ) $=
    ( wn wo wb notnot1 biorf syl ) AACZCBIBDEAFIBGH $.

  ${
    biorfi.1 $e |- -. ph $.
    $( A wff is equivalent to its disjunction with falsehood.  (Contributed by
       NM, 23-Mar-1995.) $)
    biorfi $p |- ( ps <-> ( ps \/ ph ) ) $=
      ( wn wo wb orc orel2 impbid2 ax-mp ) ADZBBAEZFCKBLBAGABHIJ $.
  $}

  $( Theorem *2.621 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.621 $p |- ( ( ph -> ps ) -> ( ( ph \/ ps ) -> ps ) ) $=
    ( wi id idd jaod ) ABCZABBGDGBEF $.

  $( Theorem *2.62 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 13-Dec-2013.) $)
  pm2.62 $p |- ( ( ph \/ ps ) -> ( ( ph -> ps ) -> ps ) ) $=
    ( wi wo pm2.621 com12 ) ABCABDBABEF $.

  $( Theorem *2.68 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.68 $p |- ( ( ( ph -> ps ) -> ps ) -> ( ph \/ ps ) ) $=
    ( wi jarl orrd ) ABCBCABABBDE $.

  $( Logical 'or' expressed in terms of implication only.  Theorem *5.25 of
     [WhiteheadRussell] p. 124.  (Contributed by NM, 12-Aug-2004.)  (Proof
     shortened by Wolf Lammen, 20-Oct-2012.) $)
  dfor2 $p |- ( ( ph \/ ps ) <-> ( ( ph -> ps ) -> ps ) ) $=
    ( wo wi pm2.62 pm2.68 impbii ) ABCABDBDABEABFG $.

  $( Implication in terms of disjunction.  Theorem *4.6 of [WhiteheadRussell]
     p. 120.  (Contributed by NM, 5-Aug-1993.) $)
  imor $p |- ( ( ph -> ps ) <-> ( -. ph \/ ps ) ) $=
    ( wi wn wo notnot imbi1i df-or bitr4i ) ABCADZDZBCJBEAKBAFGJBHI $.

  ${
    imori.1 $e |- ( ph -> ps ) $.
    $( Infer disjunction from implication.  (Contributed by NM,
       12-Mar-2012.) $)
    imori $p |- ( -. ph \/ ps ) $=
      ( wi wn wo imor mpbi ) ABDAEBFCABGH $.
  $}

  ${
    imorri.1 $e |- ( -. ph \/ ps ) $.
    $( Infer implication from disjunction.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.) $)
    imorri $p |- ( ph -> ps ) $=
      ( wi wn wo imor mpbir ) ABDAEBFCABGH $.
  $}

  $( Law of excluded middle, also called the principle of _tertium non datur_.
     Theorem *2.11 of [WhiteheadRussell] p. 101.  It says that something is
     either true or not true; there are no in-between values of truth.  This is
     an essential distinction of our classical logic and is not a theorem of
     intuitionistic logic.  (Contributed by NM, 5-Aug-1993.) $)
  exmid $p |- ( ph \/ -. ph ) $=
    ( wn id orri ) AABZECD $.

  $( Law of excluded middle in a context.  (Contributed by Mario Carneiro,
     9-Feb-2017.) $)
  exmidd $p |- ( ph -> ( ps \/ -. ps ) ) $=
    ( wn wo exmid a1i ) BBCDABEF $.

  $( Theorem *2.1 of [WhiteheadRussell] p. 101.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 23-Nov-2012.) $)
  pm2.1 $p |- ( -. ph \/ ph ) $=
    ( id imori ) AAABC $.

  $( Theorem *2.13 of [WhiteheadRussell] p. 101.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.13 $p |- ( ph \/ -. -. -. ph ) $=
    ( wn notnot1 orri ) AABZBBECD $.

  $( Theorem *4.62 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.62 $p |- ( ( ph -> -. ps ) <-> ( -. ph \/ -. ps ) ) $=
    ( wn imor ) ABCD $.

  $( Theorem *4.66 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.66 $p |- ( ( -. ph -> -. ps ) <-> ( ph \/ -. ps ) ) $=
    ( wn pm4.64 ) ABCD $.

  $( Theorem *4.63 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.63 $p |- ( -. ( ph -> -. ps ) <-> ( ph /\ ps ) ) $=
    ( wa wn wi df-an bicomi ) ABCABDEDABFG $.

  $( Express implication in terms of conjunction.  (Contributed by NM,
     9-Apr-1994.) $)
  imnan $p |- ( ( ph -> -. ps ) <-> -. ( ph /\ ps ) ) $=
    ( wa wn wi df-an con2bii ) ABCABDEABFG $.

  ${
    imnani.1 $e |- -. ( ph /\ ps ) $.
    $( Express implication in terms of conjunction.  (Contributed by Mario
       Carneiro, 28-Sep-2015.) $)
    imnani $p |- ( ph -> -. ps ) $=
      ( wn wi wa imnan mpbir ) ABDEABFDCABGH $.
  $}

  $( Express implication in terms of conjunction.  Theorem 3.4(27) of [Stoll]
     p. 176.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 30-Oct-2012.) $)
  iman $p |- ( ( ph -> ps ) <-> -. ( ph /\ -. ps ) ) $=
    ( wi wn wa notnot imbi2i imnan bitri ) ABCABDZDZCAJEDBKABFGAJHI $.

  $( Express conjunction in terms of implication.  (Contributed by NM,
     2-Aug-1994.) $)
  annim $p |- ( ( ph /\ -. ps ) <-> -. ( ph -> ps ) ) $=
    ( wi wn wa iman con2bii ) ABCABDEABFG $.

  $( Theorem *4.61 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.61 $p |- ( -. ( ph -> ps ) <-> ( ph /\ -. ps ) ) $=
    ( wn wa wi annim bicomi ) ABCDABECABFG $.

  $( Theorem *4.65 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.65 $p |- ( -. ( -. ph -> ps ) <-> ( -. ph /\ -. ps ) ) $=
    ( wn pm4.61 ) ACBD $.

  $( Theorem *4.67 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.67 $p |- ( -. ( -. ph -> -. ps ) <-> ( -. ph /\ ps ) ) $=
    ( wn pm4.63 ) ACBD $.

  ${
    imp.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Importation inference.  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Eric Schmidt, 22-Dec-2006.) $)
    imp $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wn wi df-an impi sylbi ) ABEABFGFCABHABCDIJ $.

    $( Importation inference with commuted antecedents.  (Contributed by NM,
       25-May-2005.) $)
    impcom $p |- ( ( ps /\ ph ) -> ch ) $=
      ( com12 imp ) BACABCDEF $.
  $}

  ${
    imp3.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Importation deduction.  (Contributed by NM, 31-Mar-1994.) $)
    imp3a $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      ( wa wi com3l imp com12 ) BCFADBCADGABCDEHIJ $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp31 $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      ( wa wi imp ) ABFCDABCDGEHH $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp32 $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      ( wa imp3a imp ) ABCFDABCDEGH $.
  $}

  ${
    exp.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Exportation inference.  (This theorem used to be labeled "exp" but was
       changed to "ex" so as not to conflict with the math token "exp", per the
       June 2006 Metamath spec change.)  A translation of natural deduction
       rule ` -> ` I ( ` -> ` introduction), see ~ natded .  (Contributed by
       NM, 5-Aug-1993.)  (Proof shortened by Eric Schmidt, 22-Dec-2006.) $)
    ex $p |- ( ph -> ( ps -> ch ) ) $=
      ( wn wi wa df-an sylbir expi ) ABCABEFEABGCABHDIJ $.

    $( Exportation inference with commuted antecedents.  (Contributed by NM,
       25-May-2005.) $)
    expcom $p |- ( ps -> ( ph -> ch ) ) $=
      ( ex com12 ) ABCABCDEF $.
  $}

  ${
    exp3a.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Exportation deduction.  (Contributed by NM, 20-Aug-1993.) $)
    exp3a $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( wi wa com12 ex com3r ) BCADBCADFABCGDEHIJ $.

    $( A deduction version of exportation, followed by importation.
       (Contributed by NM, 6-Sep-2008.) $)
    expdimp $p |- ( ( ph /\ ps ) -> ( ch -> th ) ) $=
      ( wi exp3a imp ) ABCDFABCDEGH $.
  $}

  ${
    impancom.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Mixed importation/commutation inference.  (Contributed by NM,
       22-Jun-2013.) $)
    impancom $p |- ( ( ph /\ ch ) -> ( ps -> th ) ) $=
      ( wi ex com23 imp ) ACBDFABCDABCDFEGHI $.
  $}

  ${
    con3and.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Variant of ~ con3d with importation.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.) $)
    con3and $p |- ( ( ph /\ -. ch ) -> -. ps ) $=
      ( wn con3d imp ) ACEBEABCDFG $.
  $}

  ${
    pm2.01da.1 $e |- ( ( ph /\ ps ) -> -. ps ) $.
    $( Deduction based on reductio ad absurdum.  (Contributed by Mario
       Carneiro, 9-Feb-2017.) $)
    pm2.01da $p |- ( ph -> -. ps ) $=
      ( wn ex pm2.01d ) ABABBDCEF $.
  $}

  ${
    pm2.18da.1 $e |- ( ( ph /\ -. ps ) -> ps ) $.
    $( Deduction based on reductio ad absurdum.  (Contributed by Mario
       Carneiro, 9-Feb-2017.) $)
    pm2.18da $p |- ( ph -> ps ) $=
      ( wn ex pm2.18d ) ABABDBCEF $.
  $}

  $( Theorem *3.3 (Exp) of [WhiteheadRussell] p. 112.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 24-Mar-2013.) $)
  pm3.3 $p |- ( ( ( ph /\ ps ) -> ch ) -> ( ph -> ( ps -> ch ) ) ) $=
    ( wa wi id exp3a ) ABDCEZABCHFG $.

  $( Theorem *3.31 (Imp) of [WhiteheadRussell] p. 112.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 24-Mar-2013.) $)
  pm3.31 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( ph /\ ps ) -> ch ) ) $=
    ( wi id imp3a ) ABCDDZABCGEF $.

  $( Import-export theorem.  Part of Theorem *4.87 of [WhiteheadRussell]
     p. 122.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 24-Mar-2013.) $)
  impexp $p |- ( ( ( ph /\ ps ) -> ch ) <-> ( ph -> ( ps -> ch ) ) ) $=
    ( wa wi pm3.3 pm3.31 impbii ) ABDCEABCEEABCFABCGH $.

  $( Join antecedents with conjunction.  Theorem *3.2 of [WhiteheadRussell]
     p. 111.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 12-Nov-2012.) $)
  pm3.2 $p |- ( ph -> ( ps -> ( ph /\ ps ) ) ) $=
    ( wa id ex ) ABABCZFDE $.

  $( Join antecedents with conjunction.  Theorem *3.21 of [WhiteheadRussell]
     p. 111.  (Contributed by NM, 5-Aug-1993.) $)
  pm3.21 $p |- ( ph -> ( ps -> ( ps /\ ph ) ) ) $=
    ( wa pm3.2 com12 ) BABACBADE $.

  $( Theorem *3.22 of [WhiteheadRussell] p. 111.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 13-Nov-2012.) $)
  pm3.22 $p |- ( ( ph /\ ps ) -> ( ps /\ ph ) ) $=
    ( wa pm3.21 imp ) ABBACABDE $.

  $( Commutative law for conjunction.  Theorem *4.3 of [WhiteheadRussell]
     p. 118.  (Contributed by NM, 25-Jun-1998.)  (Proof shortened by Wolf
     Lammen, 4-Nov-2012.) $)
  ancom $p |- ( ( ph /\ ps ) <-> ( ps /\ ph ) ) $=
    ( wa pm3.22 impbii ) ABCBACABDBADE $.

  ${
    ancomd.1 $e |- ( ph -> ( ps /\ ch ) ) $.
    $( Commutation of conjuncts in consequent.  (Contributed by Jeff Hankins,
       14-Aug-2009.) $)
    ancomd $p |- ( ph -> ( ch /\ ps ) ) $=
      ( wa ancom sylib ) ABCECBEDBCFG $.
  $}

  ${
    ancoms.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Inference commuting conjunction in antecedent.  (Contributed by NM,
       21-Apr-1994.) $)
    ancoms $p |- ( ( ps /\ ph ) -> ch ) $=
      ( expcom imp ) BACABCDEF $.
  $}

  ${
    ancomsd.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Deduction commuting conjunction in antecedent.  (Contributed by NM,
       12-Dec-2004.) $)
    ancomsd $p |- ( ph -> ( ( ch /\ ps ) -> th ) ) $=
      ( wa ancom syl5bi ) CBFBCFADCBGEH $.
  $}

  ${
    pm3.2i.1 $e |- ph $.
    pm3.2i.2 $e |- ps $.
    $( Infer conjunction of premises.  (Contributed by NM, 5-Aug-1993.) $)
    pm3.2i $p |- ( ph /\ ps ) $=
      ( wa pm3.2 mp2 ) ABABECDABFG $.
  $}

  $( Nested conjunction of antecedents.  (Contributed by NM, 5-Aug-1993.) $)
  pm3.43i $p |- ( ( ph -> ps )
      -> ( ( ph -> ch ) -> ( ph -> ( ps /\ ch ) ) ) ) $=
    ( wa pm3.2 imim3i ) BCBCDABCEF $.

  $( Elimination of a conjunct.  Theorem *3.26 (Simp) of [WhiteheadRussell]
     p. 112.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 13-Nov-2012.) $)
  simpl $p |- ( ( ph /\ ps ) -> ph ) $=
    ( ax-1 imp ) ABAABCD $.

  ${
    simpli.1 $e |- ( ph /\ ps ) $.
    $( Inference eliminating a conjunct.  (Contributed by NM, 15-Jun-1994.) $)
    simpli $p |- ph $=
      ( wa simpl ax-mp ) ABDACABEF $.
  $}

  ${
    simpld.1 $e |- ( ph -> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct.  A translation of natural deduction
       rule ` /\ ` EL ( ` /\ ` elimination left), see ~ natded .  (Contributed
       by NM, 5-Aug-1993.) $)
    simpld $p |- ( ph -> ps ) $=
      ( wa simpl syl ) ABCEBDBCFG $.
  $}

  ${
    simplbi.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct.  (Contributed by NM, 27-May-1998.) $)
    simplbi $p |- ( ph -> ps ) $=
      ( wa biimpi simpld ) ABCABCEDFG $.
  $}

  $( Elimination of a conjunct.  Theorem *3.27 (Simp) of [WhiteheadRussell]
     p. 112.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 13-Nov-2012.) $)
  simpr $p |- ( ( ph /\ ps ) -> ps ) $=
    ( idd imp ) ABBABCD $.

  ${
    simpri.1 $e |- ( ph /\ ps ) $.
    $( Inference eliminating a conjunct.  (Contributed by NM, 15-Jun-1994.) $)
    simpri $p |- ps $=
      ( wa simpr ax-mp ) ABDBCABEF $.
  $}

  ${
    simprd.1 $e |- ( ph -> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct.  (Contributed by NM, 5-Aug-1993.)  A
       translation of natural deduction rule ` /\ ` ER ( ` /\ ` elimination
       right), see ~ natded .  (Proof shortened by Wolf Lammen, 3-Oct-2013.) $)
    simprd $p |- ( ph -> ch ) $=
      ( ancomd simpld ) ACBABCDEF $.
  $}

  ${
    simprbi.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct.  (Contributed by NM, 27-May-1998.) $)
    simprbi $p |- ( ph -> ch ) $=
      ( wa biimpi simprd ) ABCABCEDFG $.
  $}

  ${
    adantr.1 $e |- ( ph -> ps ) $.
    $( Inference adding a conjunct to the right of an antecedent.  (Contributed
       by NM, 30-Aug-1993.) $)
    adantr $p |- ( ( ph /\ ch ) -> ps ) $=
      ( a1d imp ) ACBABCDEF $.
  $}

  ${
    adantl.1 $e |- ( ph -> ps ) $.
    $( Inference adding a conjunct to the left of an antecedent.  (Contributed
       by NM, 30-Aug-1993.)  (Proof shortened by Wolf Lammen, 23-Nov-2012.) $)
    adantl $p |- ( ( ch /\ ph ) -> ps ) $=
      ( adantr ancoms ) ACBABCDEF $.
  $}

  ${
    adantld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding a conjunct to the left of an antecedent.  (Contributed
       by NM, 4-May-1994.)  (Proof shortened by Wolf Lammen, 20-Dec-2012.) $)
    adantld $p |- ( ph -> ( ( th /\ ps ) -> ch ) ) $=
      ( wa simpr syl5 ) DBFBACDBGEH $.
  $}

  ${
    adantrd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction adding a conjunct to the right of an antecedent.  (Contributed
       by NM, 4-May-1994.) $)
    adantrd $p |- ( ph -> ( ( ps /\ th ) -> ch ) ) $=
      ( wa simpl syl5 ) BDFBACBDGEH $.
  $}

  ${
    mpan9.1 $e |- ( ph -> ps ) $.
    mpan9.2 $e |- ( ch -> ( ps -> th ) ) $.
    $( Modus ponens conjoining dissimilar antecedents.  (Contributed by NM,
       1-Feb-2008.)  (Proof shortened by Andrew Salmon, 7-May-2011.) $)
    mpan9 $p |- ( ( ph /\ ch ) -> th ) $=
      ( syl5 impcom ) CADABCDEFGH $.
  $}

  ${
    syldan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    syldan.2 $e |- ( ( ph /\ ch ) -> th ) $.
    $( A syllogism deduction with conjoined antecedents.  (Contributed by NM,
       24-Feb-2005.)  (Proof shortened by Wolf Lammen, 6-Apr-2013.) $)
    syldan $p |- ( ( ph /\ ps ) -> th ) $=
      ( wa expcom adantrd mpcom ) CABGDECADBACDFHIJ $.
  $}

  ${
    sylan.1 $e |- ( ph -> ps ) $.
    sylan.2 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference.  (Contributed by NM, 21-Apr-1994.)  (Proof
       shortened by Wolf Lammen, 22-Nov-2012.) $)
    sylan $p |- ( ( ph /\ ch ) -> th ) $=
      ( expcom mpan9 ) ABCDEBCDFGH $.
  $}

  ${
    sylanb.1 $e |- ( ph <-> ps ) $.
    sylanb.2 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference.  (Contributed by NM, 18-May-1994.) $)
    sylanb $p |- ( ( ph /\ ch ) -> th ) $=
      ( biimpi sylan ) ABCDABEGFH $.
  $}

  ${
    sylanbr.1 $e |- ( ps <-> ph ) $.
    sylanbr.2 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference.  (Contributed by NM, 18-May-1994.) $)
    sylanbr $p |- ( ( ph /\ ch ) -> th ) $=
      ( biimpri sylan ) ABCDBAEGFH $.
  $}

  ${
    sylan2.1 $e |- ( ph -> ch ) $.
    sylan2.2 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference.  (Contributed by NM, 21-Apr-1994.)  (Proof
       shortened by Wolf Lammen, 22-Nov-2012.) $)
    sylan2 $p |- ( ( ps /\ ph ) -> th ) $=
      ( adantl syldan ) BACDACBEGFH $.
  $}

  ${
    sylan2b.1 $e |- ( ph <-> ch ) $.
    sylan2b.2 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference.  (Contributed by NM, 21-Apr-1994.) $)
    sylan2b $p |- ( ( ps /\ ph ) -> th ) $=
      ( biimpi sylan2 ) ABCDACEGFH $.
  $}

  ${
    sylan2br.1 $e |- ( ch <-> ph ) $.
    sylan2br.2 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference.  (Contributed by NM, 21-Apr-1994.) $)
    sylan2br $p |- ( ( ps /\ ph ) -> th ) $=
      ( biimpri sylan2 ) ABCDCAEGFH $.
  $}

  ${
    syl2an.1 $e |- ( ph -> ps ) $.
    syl2an.2 $e |- ( ta -> ch ) $.
    syl2an.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A double syllogism inference.  (Contributed by NM, 31-Jan-1997.) $)
    syl2an $p |- ( ( ph /\ ta ) -> th ) $=
      ( sylan sylan2 ) EACDGABCDFHIJ $.

    $( A double syllogism inference.  (Contributed by NM, 17-Sep-2013.) $)
    syl2anr $p |- ( ( ta /\ ph ) -> th ) $=
      ( syl2an ancoms ) AEDABCDEFGHIJ $.
  $}

  ${
    syl2anb.1 $e |- ( ph <-> ps ) $.
    syl2anb.2 $e |- ( ta <-> ch ) $.
    syl2anb.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A double syllogism inference.  (Contributed by NM, 29-Jul-1999.) $)
    syl2anb $p |- ( ( ph /\ ta ) -> th ) $=
      ( sylanb sylan2b ) EACDGABCDFHIJ $.
  $}

  ${
    syl2anbr.1 $e |- ( ps <-> ph ) $.
    syl2anbr.2 $e |- ( ch <-> ta ) $.
    syl2anbr.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A double syllogism inference.  (Contributed by NM, 29-Jul-1999.) $)
    syl2anbr $p |- ( ( ph /\ ta ) -> th ) $=
      ( sylanbr sylan2br ) EACDGABCDFHIJ $.
  $}

  ${
    syland.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syland.2 $e |- ( ph -> ( ( ch /\ th ) -> ta ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 15-Dec-2004.) $)
    syland $p |- ( ph -> ( ( ps /\ th ) -> ta ) ) $=
      ( wi exp3a syld imp3a ) ABDEABCDEHFACDEGIJK $.
  $}

  ${
    sylan2d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylan2d.2 $e |- ( ph -> ( ( th /\ ch ) -> ta ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 15-Dec-2004.) $)
    sylan2d $p |- ( ph -> ( ( th /\ ps ) -> ta ) ) $=
      ( ancomsd syland ) ABDEABCDEFADCEGHIH $.
  $}

  ${
    syl2and.1 $e |- ( ph -> ( ps -> ch ) ) $.
    syl2and.2 $e |- ( ph -> ( th -> ta ) ) $.
    syl2and.3 $e |- ( ph -> ( ( ch /\ ta ) -> et ) ) $.
    $( A syllogism deduction.  (Contributed by NM, 15-Dec-2004.) $)
    syl2and $p |- ( ph -> ( ( ps /\ th ) -> et ) ) $=
      ( sylan2d syland ) ABCDFGADECFHIJK $.
  $}

  ${
    biimpa.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Inference from a logical equivalence.  (Contributed by NM,
       3-May-1994.) $)
    biimpa $p |- ( ( ph /\ ps ) -> ch ) $=
      ( biimpd imp ) ABCABCDEF $.

    $( Inference from a logical equivalence.  (Contributed by NM,
       3-May-1994.) $)
    biimpar $p |- ( ( ph /\ ch ) -> ps ) $=
      ( biimprd imp ) ACBABCDEF $.

    $( Inference from a logical equivalence.  (Contributed by NM,
       3-May-1994.) $)
    biimpac $p |- ( ( ps /\ ph ) -> ch ) $=
      ( biimpcd imp ) BACABCDEF $.

    $( Inference from a logical equivalence.  (Contributed by NM,
       3-May-1994.) $)
    biimparc $p |- ( ( ch /\ ph ) -> ps ) $=
      ( biimprcd imp ) CABABCDEF $.
  $}

  $( Negated conjunction in terms of disjunction (De Morgan's law).  Theorem
     *4.51 of [WhiteheadRussell] p. 120.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Andrew Salmon, 13-May-2011.) $)
  ianor $p |- ( -. ( ph /\ ps ) <-> ( -. ph \/ -. ps ) ) $=
    ( wa wn wi wo imnan pm4.62 bitr3i ) ABCDABDZEADJFABGABHI $.

  $( Conjunction in terms of disjunction (De Morgan's law).  Theorem *4.5 of
     [WhiteheadRussell] p. 120.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 3-Nov-2012.) $)
  anor $p |- ( ( ph /\ ps ) <-> -. ( -. ph \/ -. ps ) ) $=
    ( wn wo wa ianor bicomi con2bii ) ACBCDZABEZJCIABFGH $.

  $( Negated disjunction in terms of conjunction (De Morgan's law).  Compare
     Theorem *4.56 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     5-Aug-1993.)  (Proof shortened by Andrew Salmon, 7-May-2011.) $)
  ioran $p |- ( -. ( ph \/ ps ) <-> ( -. ph /\ -. ps ) ) $=
    ( wn wi wa wo pm4.65 pm4.64 xchnxbi ) ACZBDJBCEABFABGABHI $.

  $( Theorem *4.52 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 5-Nov-2012.) $)
  pm4.52 $p |- ( ( ph /\ -. ps ) <-> -. ( -. ph \/ ps ) ) $=
    ( wn wa wi wo annim imor xchbinx ) ABCDABEACBFABGABHI $.

  $( Theorem *4.53 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.53 $p |- ( -. ( ph /\ -. ps ) <-> ( -. ph \/ ps ) ) $=
    ( wn wo wa pm4.52 con2bii bicomi ) ACBDZABCEZCJIABFGH $.

  $( Theorem *4.54 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 5-Nov-2012.) $)
  pm4.54 $p |- ( ( -. ph /\ ps ) <-> -. ( ph \/ -. ps ) ) $=
    ( wn wa wi wo df-an pm4.66 xchbinx ) ACZBDJBCZEAKFJBGABHI $.

  $( Theorem *4.55 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.55 $p |- ( -. ( -. ph /\ ps ) <-> ( ph \/ -. ps ) ) $=
    ( wn wo wa pm4.54 con2bii bicomi ) ABCDZACBEZCJIABFGH $.

  $( Theorem *4.56 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.56 $p |- ( ( -. ph /\ -. ps ) <-> -. ( ph \/ ps ) ) $=
    ( wo wn wa ioran bicomi ) ABCDADBDEABFG $.

  $( Disjunction in terms of conjunction (De Morgan's law).  Compare Theorem
     *4.57 of [WhiteheadRussell] p. 120.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Andrew Salmon, 7-May-2011.) $)
  oran $p |- ( ( ph \/ ps ) <-> -. ( -. ph /\ -. ps ) ) $=
    ( wn wa wo pm4.56 con2bii ) ACBCDABEABFG $.

  $( Theorem *4.57 of [WhiteheadRussell] p. 120.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.57 $p |- ( -. ( -. ph /\ -. ps ) <-> ( ph \/ ps ) ) $=
    ( wo wn wa oran bicomi ) ABCADBDEDABFG $.

  $( Theorem *3.1 of [WhiteheadRussell] p. 111.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.1 $p |- ( ( ph /\ ps ) -> -. ( -. ph \/ -. ps ) ) $=
    ( wa wn wo anor biimpi ) ABCADBDEDABFG $.

  $( Theorem *3.11 of [WhiteheadRussell] p. 111.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.11 $p |- ( -. ( -. ph \/ -. ps ) -> ( ph /\ ps ) ) $=
    ( wa wn wo anor biimpri ) ABCADBDEDABFG $.

  $( Theorem *3.12 of [WhiteheadRussell] p. 111.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.12 $p |- ( ( -. ph \/ -. ps ) \/ ( ph /\ ps ) ) $=
    ( wn wo wa pm3.11 orri ) ACBCDABEABFG $.

  $( Theorem *3.13 of [WhiteheadRussell] p. 111.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.13 $p |- ( -. ( ph /\ ps ) -> ( -. ph \/ -. ps ) ) $=
    ( wn wo wa pm3.11 con1i ) ACBCDABEABFG $.

  $( Theorem *3.14 of [WhiteheadRussell] p. 111.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.14 $p |- ( ( -. ph \/ -. ps ) -> -. ( ph /\ ps ) ) $=
    ( wa wn wo pm3.1 con2i ) ABCADBDEABFG $.

  $( Introduction of antecedent as conjunct.  Theorem *4.73 of
     [WhiteheadRussell] p. 121.  (Contributed by NM, 30-Mar-1994.) $)
  iba $p |- ( ph -> ( ps <-> ( ps /\ ph ) ) ) $=
    ( wa pm3.21 simpl impbid1 ) ABBACABDBAEF $.

  $( Introduction of antecedent as conjunct.  (Contributed by NM,
     5-Dec-1995.) $)
  ibar $p |- ( ph -> ( ps <-> ( ph /\ ps ) ) ) $=
    ( wa pm3.2 simpr impbid1 ) ABABCABDABEF $.

  ${
    biantru.1 $e |- ph $.
    $( A wff is equivalent to its conjunction with truth.  (Contributed by NM,
       5-Aug-1993.) $)
    biantru $p |- ( ps <-> ( ps /\ ph ) ) $=
      ( wa wb iba ax-mp ) ABBADECABFG $.
  $}

  ${
    biantrur.1 $e |- ph $.
    $( A wff is equivalent to its conjunction with truth.  (Contributed by NM,
       3-Aug-1994.) $)
    biantrur $p |- ( ps <-> ( ph /\ ps ) ) $=
      ( wa wb ibar ax-mp ) ABABDECABFG $.
  $}

  ${
    biantrud.1 $e |- ( ph -> ps ) $.
    $( A wff is equivalent to its conjunction with truth.  (Contributed by NM,
       2-Aug-1994.)  (Proof shortened by Wolf Lammen, 23-Oct-2013.) $)
    biantrud $p |- ( ph -> ( ch <-> ( ch /\ ps ) ) ) $=
      ( wa wb iba syl ) ABCCBEFDBCGH $.

    $( A wff is equivalent to its conjunction with truth.  (Contributed by NM,
       1-May-1995.)  (Proof shortened by Andrew Salmon, 7-May-2011.) $)
    biantrurd $p |- ( ph -> ( ch <-> ( ps /\ ch ) ) ) $=
      ( wa wb ibar syl ) ABCBCEFDBCGH $.
  $}

  ${
    jaao.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jaao.2 $e |- ( th -> ( ta -> ch ) ) $.
    $( Inference conjoining and disjoining the antecedents of two
       implications.  (Contributed by NM, 30-Sep-1999.) $)
    jaao $p |- ( ( ph /\ th ) -> ( ( ps \/ ta ) -> ch ) ) $=
      ( wa wi adantr adantl jaod ) ADHBCEABCIDFJDECIAGKL $.

    $( Inference disjoining and conjoining the antecedents of two
       implications.  (Contributed by Stefan Allan, 1-Nov-2008.) $)
    jaoa $p |- ( ( ph \/ th ) -> ( ( ps /\ ta ) -> ch ) ) $=
      ( wa wi adantrd adantld jaoi ) ABEHCIDABCEFJDECBGKL $.
  $}

  $( Theorem *3.44 of [WhiteheadRussell] p. 113.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 3-Oct-2013.) $)
  pm3.44 $p |- ( ( ( ps -> ph ) /\ ( ch -> ph ) )
      -> ( ( ps \/ ch ) -> ph ) ) $=
    ( wi id jaao ) BADZBACADZCGEHEF $.

  $( Disjunction of antecedents.  Compare Theorem *3.44 of [WhiteheadRussell]
     p. 113.  (Contributed by NM, 5-Apr-1994.)  (Proof shortened by Wolf
     Lammen, 4-Apr-2013.) $)
  jao $p |- ( ( ph -> ps ) -> ( ( ch -> ps ) -> ( ( ph \/ ch ) -> ps ) ) ) $=
    ( wi wo pm3.44 ex ) ABDCBDACEBDBACFG $.

  $( Axiom *1.2 of [WhiteheadRussell] p. 96, which they call "Taut".
     (Contributed by NM, 3-Jan-2005.) $)
  pm1.2 $p |- ( ( ph \/ ph ) -> ph ) $=
    ( id jaoi ) AAAABZDC $.

  $( Idempotent law for disjunction.  Theorem *4.25 of [WhiteheadRussell]
     p. 117.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
     Salmon, 16-Apr-2011.)  (Proof shortened by Wolf Lammen, 10-Mar-2013.) $)
  oridm $p |- ( ( ph \/ ph ) <-> ph ) $=
    ( wo pm1.2 pm2.07 impbii ) AABAACADE $.

  $( Theorem *4.25 of [WhiteheadRussell] p. 117.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.25 $p |- ( ph <-> ( ph \/ ph ) ) $=
    ( wo oridm bicomi ) AABAACD $.

  ${
    orim12i.1 $e |- ( ph -> ps ) $.
    orim12i.2 $e |- ( ch -> th ) $.
    $( Disjoin antecedents and consequents of two premises.  (Contributed by
       NM, 6-Jun-1994.)  (Proof shortened by Wolf Lammen, 25-Jul-2012.) $)
    orim12i $p |- ( ( ph \/ ch ) -> ( ps \/ th ) ) $=
      ( wo orcd olcd jaoi ) ABDGCABDEHCDBFIJ $.
  $}

  ${
    orim1i.1 $e |- ( ph -> ps ) $.
    $( Introduce disjunct to both sides of an implication.  (Contributed by NM,
       6-Jun-1994.) $)
    orim1i $p |- ( ( ph \/ ch ) -> ( ps \/ ch ) ) $=
      ( id orim12i ) ABCCDCEF $.

    $( Introduce disjunct to both sides of an implication.  (Contributed by NM,
       6-Jun-1994.) $)
    orim2i $p |- ( ( ch \/ ph ) -> ( ch \/ ps ) ) $=
      ( id orim12i ) CCABCEDF $.
  $}

  ${
    orbi2i.1 $e |- ( ph <-> ps ) $.
    $( Inference adding a left disjunct to both sides of a logical
       equivalence.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
       Lammen, 12-Dec-2012.) $)
    orbi2i $p |- ( ( ch \/ ph ) <-> ( ch \/ ps ) ) $=
      ( wo biimpi orim2i biimpri impbii ) CAECBEABCABDFGBACABDHGI $.

    $( Inference adding a right disjunct to both sides of a logical
       equivalence.  (Contributed by NM, 5-Aug-1993.) $)
    orbi1i $p |- ( ( ph \/ ch ) <-> ( ps \/ ch ) ) $=
      ( wo orcom orbi2i 3bitri ) ACECAECBEBCEACFABCDGCBFH $.
  $}

  ${
    orbi12i.1 $e |- ( ph <-> ps ) $.
    orbi12i.2 $e |- ( ch <-> th ) $.
    $( Infer the disjunction of two equivalences.  (Contributed by NM,
       5-Aug-1993.) $)
    orbi12i $p |- ( ( ph \/ ch ) <-> ( ps \/ th ) ) $=
      ( wo orbi2i orbi1i bitri ) ACGADGBDGCDAFHABDEIJ $.
  $}

  $( Axiom *1.5 (Assoc) of [WhiteheadRussell] p. 96.  (Contributed by NM,
     3-Jan-2005.) $)
  pm1.5 $p |- ( ( ph \/ ( ps \/ ch ) ) -> ( ps \/ ( ph \/ ch ) ) ) $=
    ( wo orc olcd olc orim2i jaoi ) ABACDZDBCDAJBACEFCJBCAGHI $.

  $( Swap two disjuncts.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by
     Wolf Lammen, 14-Nov-2012.) $)
  or12 $p |- ( ( ph \/ ( ps \/ ch ) ) <-> ( ps \/ ( ph \/ ch ) ) ) $=
    ( wo pm1.5 impbii ) ABCDDBACDDABCEBACEF $.

  $( Associative law for disjunction.  Theorem *4.33 of [WhiteheadRussell]
     p. 118.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
     Salmon, 26-Jun-2011.) $)
  orass $p |- ( ( ( ph \/ ps ) \/ ch ) <-> ( ph \/ ( ps \/ ch ) ) ) $=
    ( wo orcom or12 orbi2i 3bitri ) ABDZCDCIDACBDZDABCDZDICECABFJKACBEGH $.

  $( Theorem *2.31 of [WhiteheadRussell] p. 104.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.31 $p |- ( ( ph \/ ( ps \/ ch ) ) -> ( ( ph \/ ps ) \/ ch ) ) $=
    ( wo orass biimpri ) ABDCDABCDDABCEF $.

  $( Theorem *2.32 of [WhiteheadRussell] p. 105.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.32 $p |- ( ( ( ph \/ ps ) \/ ch ) -> ( ph \/ ( ps \/ ch ) ) ) $=
    ( wo orass biimpi ) ABDCDABCDDABCEF $.

  $( A rearrangement of disjuncts.  (Contributed by NM, 18-Oct-1995.)  (Proof
     shortened by Andrew Salmon, 26-Jun-2011.) $)
  or32 $p |- ( ( ( ph \/ ps ) \/ ch ) <-> ( ( ph \/ ch ) \/ ps ) ) $=
    ( wo orass or12 orcom 3bitri ) ABDCDABCDDBACDZDIBDABCEABCFBIGH $.

  $( Rearrangement of 4 disjuncts.  (Contributed by NM, 12-Aug-1994.) $)
  or4 $p |- ( ( ( ph \/ ps ) \/ ( ch \/ th ) ) <->
                ( ( ph \/ ch ) \/ ( ps \/ th ) ) ) $=
    ( wo or12 orbi2i orass 3bitr4i ) ABCDEZEZEACBDEZEZEABEJEACELEKMABCDFGABJHAC
    LHI $.

  $( Rearrangement of 4 disjuncts.  (Contributed by NM, 10-Jan-2005.) $)
  or42 $p |- ( ( ( ph \/ ps ) \/ ( ch \/ th ) ) <->
                 ( ( ph \/ ch ) \/ ( th \/ ps ) ) ) $=
    ( wo or4 orcom orbi2i bitri ) ABECDEEACEZBDEZEJDBEZEABCDFKLJBDGHI $.

  $( Distribution of disjunction over disjunction.  (Contributed by NM,
     25-Feb-1995.) $)
  orordi $p |- ( ( ph \/ ( ps \/ ch ) ) <->
               ( ( ph \/ ps ) \/ ( ph \/ ch ) ) ) $=
    ( wo oridm orbi1i or4 bitr3i ) ABCDZDAADZIDABDACDDJAIAEFAABCGH $.

  $( Distribution of disjunction over disjunction.  (Contributed by NM,
     25-Feb-1995.) $)
  orordir $p |- ( ( ( ph \/ ps ) \/ ch ) <->
               ( ( ph \/ ch ) \/ ( ps \/ ch ) ) ) $=
    ( wo oridm orbi2i or4 bitr3i ) ABDZCDICCDZDACDBCDDJCICEFABCCGH $.

  ${
    jca.1 $e |- ( ph -> ps ) $.
    jca.2 $e |- ( ph -> ch ) $.
    $( Deduce conjunction of the consequents of two implications ("join
       consequents with 'and'").  Equivalent to the natural deduction rule
       ` /\ ` I ( ` /\ ` introduction), see ~ natded .  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 25-Oct-2012.) $)
    jca $p |- ( ph -> ( ps /\ ch ) ) $=
      ( wa pm3.2 sylc ) ABCBCFDEBCGH $.
  $}

  ${
    jcad.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jcad.2 $e |- ( ph -> ( ps -> th ) ) $.
    $( Deduction conjoining the consequents of two implications.  (Contributed
       by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 23-Jul-2013.) $)
    jcad $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      ( wa pm3.2 syl6c ) ABCDCDGEFCDHI $.
  $}

  ${
    jca31.1 $e |- ( ph -> ps ) $.
    jca31.2 $e |- ( ph -> ch ) $.
    jca31.3 $e |- ( ph -> th ) $.
    $( Join three consequents.  (Contributed by Jeff Hankins, 1-Aug-2009.) $)
    jca31 $p |- ( ph -> ( ( ps /\ ch ) /\ th ) ) $=
      ( wa jca ) ABCHDABCEFIGI $.

    $( Join three consequents.  (Contributed by FL, 1-Aug-2009.) $)
    jca32 $p |- ( ph -> ( ps /\ ( ch /\ th ) ) ) $=
      ( wa jca ) ABCDHEACDFGII $.
  $}

  ${
    jcai.1 $e |- ( ph -> ps ) $.
    jcai.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction replacing implication with conjunction.  (Contributed by NM,
       5-Aug-1993.) $)
    jcai $p |- ( ph -> ( ps /\ ch ) ) $=
      ( mpd jca ) ABCDABCDEFG $.
  $}

  ${
    jctil.1 $e |- ( ph -> ps ) $.
    jctil.2 $e |- ch $.
    $( Inference conjoining a theorem to left of consequent in an implication.
       (Contributed by NM, 31-Dec-1993.) $)
    jctil $p |- ( ph -> ( ch /\ ps ) ) $=
      ( a1i jca ) ACBCAEFDG $.

    $( Inference conjoining a theorem to right of consequent in an
       implication.  (Contributed by NM, 31-Dec-1993.) $)
    jctir $p |- ( ph -> ( ps /\ ch ) ) $=
      ( a1i jca ) ABCDCAEFG $.
  $}

  ${
    jctl.1 $e |- ps $.
    $( Inference conjoining a theorem to the left of a consequent.
       (Contributed by NM, 31-Dec-1993.)  (Proof shortened by Wolf Lammen,
       24-Oct-2012.) $)
    jctl $p |- ( ph -> ( ps /\ ph ) ) $=
      ( id jctil ) AABADCE $.

    $( Inference conjoining a theorem to the right of a consequent.
       (Contributed by NM, 18-Aug-1993.)  (Proof shortened by Wolf Lammen,
       24-Oct-2012.) $)
    jctr $p |- ( ph -> ( ph /\ ps ) ) $=
      ( id jctir ) AABADCE $.
  $}

  ${
    jctild.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jctild.2 $e |- ( ph -> th ) $.
    $( Deduction conjoining a theorem to left of consequent in an implication.
       (Contributed by NM, 21-Apr-2005.) $)
    jctild $p |- ( ph -> ( ps -> ( th /\ ch ) ) ) $=
      ( a1d jcad ) ABDCADBFGEH $.
  $}

  ${
    jctird.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jctird.2 $e |- ( ph -> th ) $.
    $( Deduction conjoining a theorem to right of consequent in an
       implication.  (Contributed by NM, 21-Apr-2005.) $)
    jctird $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      ( a1d jcad ) ABCDEADBFGH $.
  $}

  $( Conjoin antecedent to left of consequent.  (Contributed by NM,
     15-Aug-1994.) $)
  ancl $p |- ( ( ph -> ps ) -> ( ph -> ( ph /\ ps ) ) ) $=
    ( wa pm3.2 a2i ) ABABCABDE $.

  $( Conjoin antecedent to left of consequent.  Theorem *4.7 of
     [WhiteheadRussell] p. 120.  (Contributed by NM, 25-Jul-1999.)  (Proof
     shortened by Wolf Lammen, 24-Mar-2013.) $)
  anclb $p |- ( ( ph -> ps ) <-> ( ph -> ( ph /\ ps ) ) ) $=
    ( wa ibar pm5.74i ) ABABCABDE $.

  $( Theorem *5.42 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.42 $p |- ( ( ph -> ( ps -> ch ) ) <->
                ( ph -> ( ps -> ( ph /\ ch ) ) ) ) $=
    ( wi wa ibar imbi2d pm5.74i ) ABCDBACEZDACIBACFGH $.

  $( Conjoin antecedent to right of consequent.  (Contributed by NM,
     15-Aug-1994.) $)
  ancr $p |- ( ( ph -> ps ) -> ( ph -> ( ps /\ ph ) ) ) $=
    ( wa pm3.21 a2i ) ABBACABDE $.

  $( Conjoin antecedent to right of consequent.  (Contributed by NM,
     25-Jul-1999.)  (Proof shortened by Wolf Lammen, 24-Mar-2013.) $)
  ancrb $p |- ( ( ph -> ps ) <-> ( ph -> ( ps /\ ph ) ) ) $=
    ( wa iba pm5.74i ) ABBACABDE $.

  ${
    ancli.1 $e |- ( ph -> ps ) $.
    $( Deduction conjoining antecedent to left of consequent.  (Contributed by
       NM, 12-Aug-1993.) $)
    ancli $p |- ( ph -> ( ph /\ ps ) ) $=
      ( id jca ) AABADCE $.
  $}

  ${
    ancri.1 $e |- ( ph -> ps ) $.
    $( Deduction conjoining antecedent to right of consequent.  (Contributed by
       NM, 15-Aug-1994.) $)
    ancri $p |- ( ph -> ( ps /\ ph ) ) $=
      ( id jca ) ABACADE $.
  $}

  ${
    ancld.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to left of consequent in nested
       implication.  (Contributed by NM, 15-Aug-1994.)  (Proof shortened by
       Wolf Lammen, 1-Nov-2012.) $)
    ancld $p |- ( ph -> ( ps -> ( ps /\ ch ) ) ) $=
      ( idd jcad ) ABBCABEDF $.
  $}

  ${
    ancrd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to right of consequent in nested
       implication.  (Contributed by NM, 15-Aug-1994.)  (Proof shortened by
       Wolf Lammen, 1-Nov-2012.) $)
    ancrd $p |- ( ph -> ( ps -> ( ch /\ ps ) ) ) $=
      ( idd jcad ) ABCBDABEF $.
  $}

  $( Conjoin antecedent to left of consequent in nested implication.
     (Contributed by NM, 10-Aug-1994.)  (Proof shortened by Wolf Lammen,
     14-Jul-2013.) $)
  anc2l $p |- ( ( ph -> ( ps -> ch ) ) -> ( ph -> ( ps -> ( ph /\ ch ) ) ) ) $=
    ( wi wa pm5.42 biimpi ) ABCDDABACEDDABCFG $.

  $( Conjoin antecedent to right of consequent in nested implication.
     (Contributed by NM, 15-Aug-1994.) $)
  anc2r $p |- ( ( ph -> ( ps -> ch ) ) -> ( ph -> ( ps -> ( ch /\ ph ) ) ) ) $=
    ( wi wa pm3.21 imim2d a2i ) ABCDBCAEZDACIBACFGH $.

  ${
    anc2li.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to left of consequent in nested
       implication.  (Contributed by NM, 10-Aug-1994.)  (Proof shortened by
       Wolf Lammen, 7-Dec-2012.) $)
    anc2li $p |- ( ph -> ( ps -> ( ph /\ ch ) ) ) $=
      ( id jctild ) ABCADAEF $.
  $}

  ${
    anc2ri.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction conjoining antecedent to right of consequent in nested
       implication.  (Contributed by NM, 15-Aug-1994.)  (Proof shortened by
       Wolf Lammen, 7-Dec-2012.) $)
    anc2ri $p |- ( ph -> ( ps -> ( ch /\ ph ) ) ) $=
      ( id jctird ) ABCADAEF $.
  $}

  $( Theorem *3.41 of [WhiteheadRussell] p. 113.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.41 $p |- ( ( ph -> ch ) -> ( ( ph /\ ps ) -> ch ) ) $=
    ( wa simpl imim1i ) ABDACABEF $.

  $( Theorem *3.42 of [WhiteheadRussell] p. 113.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.42 $p |- ( ( ps -> ch ) -> ( ( ph /\ ps ) -> ch ) ) $=
    ( wa simpr imim1i ) ABDBCABEF $.

  $( Conjunction implies implication.  Theorem *3.4 of [WhiteheadRussell]
     p. 113.  (Contributed by NM, 31-Jul-1995.) $)
  pm3.4 $p |- ( ( ph /\ ps ) -> ( ph -> ps ) ) $=
    ( wa simpr a1d ) ABCBAABDE $.

  $( Conjunction with implication.  Compare Theorem *4.45 of [WhiteheadRussell]
     p. 119.  (Contributed by NM, 17-May-1998.) $)
  pm4.45im $p |- ( ph <-> ( ph /\ ( ps -> ph ) ) ) $=
    ( wi wa ax-1 ancli simpl impbii ) AABACZDAIABEFAIGH $.

  ${
    anim12d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    anim12d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( Conjoin antecedents and consequents in a deduction.  (Contributed by NM,
       3-Apr-1994.)  (Proof shortened by Wolf Lammen, 18-Dec-2013.) $)
    anim12d $p |- ( ph -> ( ( ps /\ th ) -> ( ch /\ ta ) ) ) $=
      ( wa idd syl2and ) ABCDECEHZFGAKIJ $.
  $}

  ${
    anim1d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Add a conjunct to right of antecedent and consequent in a deduction.
       (Contributed by NM, 3-Apr-1994.) $)
    anim1d $p |- ( ph -> ( ( ps /\ th ) -> ( ch /\ th ) ) ) $=
      ( idd anim12d ) ABCDDEADFG $.

    $( Add a conjunct to left of antecedent and consequent in a deduction.
       (Contributed by NM, 5-Aug-1993.) $)
    anim2d $p |- ( ph -> ( ( th /\ ps ) -> ( th /\ ch ) ) ) $=
      ( idd anim12d ) ADDBCADFEG $.
  $}

  ${
    anim12i.1 $e |- ( ph -> ps ) $.
    anim12i.2 $e |- ( ch -> th ) $.
    $( Conjoin antecedents and consequents of two premises.  (Contributed by
       NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 14-Dec-2013.) $)
    anim12i $p |- ( ( ph /\ ch ) -> ( ps /\ th ) ) $=
      ( wa id syl2an ) ABDBDGZCEFJHI $.

    $( Variant of ~ anim12i with commutation.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    anim12ci $p |- ( ( ph /\ ch ) -> ( th /\ ps ) ) $=
      ( wa anim12i ancoms ) CADBGCDABFEHI $.
  $}

  ${
    anim1i.1 $e |- ( ph -> ps ) $.
    $( Introduce conjunct to both sides of an implication.  (Contributed by NM,
       5-Aug-1993.) $)
    anim1i $p |- ( ( ph /\ ch ) -> ( ps /\ ch ) ) $=
      ( id anim12i ) ABCCDCEF $.

    $( Introduce conjunct to both sides of an implication.  (Contributed by NM,
       5-Aug-1993.) $)
    anim2i $p |- ( ( ch /\ ph ) -> ( ch /\ ps ) ) $=
      ( id anim12i ) CCABCEDF $.
  $}

  ${
    anim12ii.1 $e |- ( ph -> ( ps -> ch ) ) $.
    anim12ii.2 $e |- ( th -> ( ps -> ta ) ) $.
    $( Conjoin antecedents and consequents in a deduction.  (Contributed by NM,
       11-Nov-2007.)  (Proof shortened by Wolf Lammen, 19-Jul-2013.) $)
    anim12ii $p |- ( ( ph /\ th ) -> ( ps -> ( ch /\ ta ) ) ) $=
      ( wa wi adantr adantl jcad ) ADHBCEABCIDFJDBEIAGKL $.
  $}

  $( Conjoin antecedents and consequents of two premises.  This is the closed
     theorem form of ~ anim12d .  Theorem *3.47 of [WhiteheadRussell] p. 113.
     It was proved by Leibniz, and it evidently pleased him enough to call it
     _praeclarum theorema_ (splendid theorem).  (Contributed by NM,
     12-Aug-1993.)  (Proof shortened by Wolf Lammen, 7-Apr-2013.) $)
  prth $p |- ( ( ( ph -> ps ) /\ ( ch -> th ) )
       -> ( ( ph /\ ch ) -> ( ps /\ th ) ) ) $=
    ( wi wa simpl simpr anim12d ) ABEZCDEZFABCDJKGJKHI $.

  $( Theorem *2.3 of [WhiteheadRussell] p. 104.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.3 $p |- ( ( ph \/ ( ps \/ ch ) ) -> ( ph \/ ( ch \/ ps ) ) ) $=
    ( wo pm1.4 orim2i ) BCDCBDABCEF $.

  $( Theorem *2.41 of [WhiteheadRussell] p. 106.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.41 $p |- ( ( ps \/ ( ph \/ ps ) ) -> ( ph \/ ps ) ) $=
    ( wo olc id jaoi ) BABCZGBADGEF $.

  $( Theorem *2.42 of [WhiteheadRussell] p. 106.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.42 $p |- ( ( -. ph \/ ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    ( wn wi pm2.21 id jaoi ) ACABDZHABEHFG $.

  $( Theorem *2.4 of [WhiteheadRussell] p. 106.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.4 $p |- ( ( ph \/ ( ph \/ ps ) ) -> ( ph \/ ps ) ) $=
    ( wo orc id jaoi ) AABCZGABDGEF $.

  ${
    pm2.65da.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    pm2.65da.2 $e |- ( ( ph /\ ps ) -> -. ch ) $.
    $( Deduction rule for proof by contradiction.  (Contributed by NM,
       12-Jun-2014.) $)
    pm2.65da $p |- ( ph -> -. ps ) $=
      ( ex wn pm2.65d ) ABCABCDFABCGEFH $.
  $}

  $( Theorem *4.44 of [WhiteheadRussell] p. 119.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.44 $p |- ( ph <-> ( ph \/ ( ph /\ ps ) ) ) $=
    ( wa wo orc id simpl jaoi impbii ) AAABCZDAJEAAJAFABGHI $.

  $( Theorem *4.14 of [WhiteheadRussell] p. 117.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 23-Oct-2012.) $)
  pm4.14 $p |- ( ( ( ph /\ ps ) -> ch ) <-> ( ( ph /\ -. ch ) -> -. ps ) ) $=
    ( wi wn wa con34b imbi2i impexp 3bitr4i ) ABCDZDACEZBEZDZDABFCDALFMDKNABCGH
    ABCIALMIJ $.

  $( Theorem *3.37 (Transp) of [WhiteheadRussell] p. 112.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 23-Oct-2012.) $)
  pm3.37 $p |- ( ( ( ph /\ ps ) -> ch ) -> ( ( ph /\ -. ch ) -> -. ps ) ) $=
    ( wa wi wn pm4.14 biimpi ) ABDCEACFDBFEABCGH $.

  $( Theorem to move a conjunct in and out of a negation.  (Contributed by NM,
     9-Nov-2003.) $)
  nan $p |- ( ( ph -> -. ( ps /\ ch ) ) <-> ( ( ph /\ ps ) -> -. ch ) ) $=
    ( wa wn wi impexp imnan imbi2i bitr2i ) ABDCEZFABKFZFABCDEZFABKGLMABCHIJ $.

  $( Theorem *4.15 of [WhiteheadRussell] p. 117.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 18-Nov-2012.) $)
  pm4.15 $p |- ( ( ( ph /\ ps ) -> -. ch ) <-> ( ( ps /\ ch ) -> -. ph ) ) $=
    ( wa wn wi con2b nan bitr2i ) BCDZAEFAJEFABDCEFJAGABCHI $.

  $( Implication distributes over disjunction.  Theorem *4.78 of
     [WhiteheadRussell] p. 121.  (Contributed by NM, 3-Jan-2005.)  (Proof
     shortened by Wolf Lammen, 19-Nov-2012.) $)
  pm4.78 $p |- ( ( ( ph -> ps ) \/ ( ph -> ch ) ) <->
                ( ph -> ( ps \/ ch ) ) ) $=
    ( wn wo wi orordi imor orbi12i 3bitr4ri ) ADZBCEZEKBEZKCEZEALFABFZACFZEKBCG
    ALHOMPNABHACHIJ $.

  $( Theorem *4.79 of [WhiteheadRussell] p. 121.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 27-Jun-2013.) $)
  pm4.79 $p |- ( ( ( ps -> ph ) \/ ( ch -> ph ) ) <->
                ( ( ps /\ ch ) -> ph ) ) $=
    ( wi wo wa id jaoa wn simplim pm3.3 syl5 orrd impbii ) BADZCADZEBCFADZOBAPC
    OGPGHQOPOIBQPBAJBCAKLMN $.

  $( Theorem *4.87 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Eric Schmidt, 26-Oct-2006.) $)
  pm4.87 $p |- ( ( ( ( ( ph /\ ps ) -> ch ) <-> ( ph -> ( ps -> ch ) ) ) /\
                ( ( ph -> ( ps -> ch ) ) <-> ( ps -> ( ph -> ch ) ) ) ) /\
                ( ( ps -> ( ph -> ch ) ) <-> ( ( ps /\ ph ) -> ch ) ) ) $=
    ( wa wi wb impexp bi2.04 pm3.2i bicomi ) ABDCEABCEEZFZKBACEEZFZDMBADCEZFLNA
    BCGABCHIOMBACGJI $.

  $( Theorem *3.33 (Syll) of [WhiteheadRussell] p. 112.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.33 $p |- ( ( ( ph -> ps ) /\ ( ps -> ch ) ) -> ( ph -> ch ) ) $=
    ( wi imim1 imp ) ABDBCDACDABCEF $.

  $( Theorem *3.34 (Syll) of [WhiteheadRussell] p. 112.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.34 $p |- ( ( ( ps -> ch ) /\ ( ph -> ps ) ) -> ( ph -> ch ) ) $=
    ( wi imim2 imp ) BCDABDACDBCAEF $.

  $( Conjunctive detachment.  Theorem *3.35 of [WhiteheadRussell] p. 112.
     (Contributed by NM, 14-Dec-2002.) $)
  pm3.35 $p |- ( ( ph /\ ( ph -> ps ) ) -> ps ) $=
    ( wi pm2.27 imp ) AABCBABDE $.

  $( Theorem *5.31 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.31 $p |- ( ( ch /\ ( ph -> ps ) ) -> ( ph -> ( ps /\ ch ) ) ) $=
    ( wi wa pm3.21 imim2d imp ) CABDABCEZDCBIACBFGH $.

  ${
    imp4.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $.
    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp4a $p |- ( ph -> ( ps -> ( ( ch /\ th ) -> ta ) ) ) $=
      ( wi wa impexp syl6ibr ) ABCDEGGCDHEGFCDEIJ $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp4b $p |- ( ( ph /\ ps ) -> ( ( ch /\ th ) -> ta ) ) $=
      ( wa wi imp4a imp ) ABCDGEHABCDEFIJ $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp4c $p |- ( ph -> ( ( ( ps /\ ch ) /\ th ) -> ta ) ) $=
      ( wa wi imp3a ) ABCGDEABCDEHFII $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp4d $p |- ( ph -> ( ( ps /\ ( ch /\ th ) ) -> ta ) ) $=
      ( wa imp4a imp3a ) ABCDGEABCDEFHI $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp41 $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( wa wi imp imp31 ) ABGCDEABCDEHHFIJ $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp42 $p |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ta ) $=
      ( wa wi imp32 imp ) ABCGGDEABCDEHFIJ $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp43 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $=
      ( wa imp4b imp ) ABGCDGEABCDEFHI $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp44 $p |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ta ) $=
      ( wa imp4c imp ) ABCGDGEABCDEFHI $.

    $( An importation inference.  (Contributed by NM, 26-Apr-1994.) $)
    imp45 $p |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> ta ) $=
      ( wa imp4d imp ) ABCDGGEABCDEFHI $.

  $}

  ${
    imp5.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( An importation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    imp5a $p |- ( ph -> ( ps -> ( ch -> ( ( th /\ ta ) -> et ) ) ) ) $=
      ( wi wa pm3.31 syl8 ) ABCDEFHHDEIFHGDEFJK $.

    $( An importation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    imp5d $p |- ( ( ( ph /\ ps ) /\ ch ) -> ( ( th /\ ta ) -> et ) ) $=
      ( wa wi imp31 imp3a ) ABHCHDEFABCDEFIIGJK $.

    $( An importation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    imp5g $p |- ( ( ph /\ ps ) -> ( ( ( ch /\ th ) /\ ta ) -> et ) ) $=
      ( wa wi imp imp4c ) ABHCDEFABCDEFIIIGJK $.

    $( An importation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    imp55 $p |- ( ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) /\ ta ) -> et ) $=
      ( wa wi imp4a imp42 ) ABCDHEFABCDEFIGJK $.

    $( An importation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    imp511 $p |- ( ( ph /\ ( ( ps /\ ( ch /\ th ) ) /\ ta ) ) -> et ) $=
      ( wa wi imp4a imp44 ) ABCDHEFABCDEFIGJK $.
  $}

  ${
    expimpd.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Exportation followed by a deduction version of importation.
       (Contributed by NM, 6-Sep-2008.) $)
    expimpd $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      ( wi ex imp3a ) ABCDABCDFEGH $.
  $}

  ${
    exp31.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp31 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( wi wa ex ) ABCDFABGCDEHH $.
  $}

  ${
    exp32.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp32 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( wa ex exp3a ) ABCDABCFDEGH $.
  $}

  ${
    exp4a.1 $e |- ( ph -> ( ps -> ( ( ch /\ th ) -> ta ) ) ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp4a $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wa wi impexp syl6ib ) ABCDGEHCDEHHFCDEIJ $.
  $}

  ${
    exp4b.1 $e |- ( ( ph /\ ps ) -> ( ( ch /\ th ) -> ta ) ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.)  (Proof
       shortened by Wolf Lammen, 23-Nov-2012.) $)
    exp4b $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wa wi ex exp4a ) ABCDEABCDGEHFIJ $.
  $}

  ${
    exp4c.1 $e |- ( ph -> ( ( ( ps /\ ch ) /\ th ) -> ta ) ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp4c $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi wa exp3a ) ABCDEGABCHDEFII $.
  $}

  ${
    exp4d.1 $e |- ( ph -> ( ( ps /\ ( ch /\ th ) ) -> ta ) ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp4d $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wa exp3a exp4a ) ABCDEABCDGEFHI $.
  $}

  ${
    exp41.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp41 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi wa ex exp31 ) ABCDEGABHCHDEFIJ $.
  $}

  ${
    exp42.1 $e |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ta ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp42 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi wa exp31 exp3a ) ABCDEGABCHDEFIJ $.
  $}

  ${
    exp43.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp43 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wa ex exp4b ) ABCDEABGCDGEFHI $.
  $}

  ${
    exp44.1 $e |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ta ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp44 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi wa exp32 exp3a ) ABCDEGABCHDEFIJ $.
  $}

  ${
    exp45.1 $e |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> ta ) $.
    $( An exportation inference.  (Contributed by NM, 26-Apr-1994.) $)
    exp45 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wa exp32 exp4a ) ABCDEABCDGEFHI $.
  $}

  ${
    expr.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Export a wff from a right conjunct.  (Contributed by Jeff Hankins,
       30-Aug-2009.) $)
    expr $p |- ( ( ph /\ ps ) -> ( ch -> th ) ) $=
      ( wi exp32 imp ) ABCDFABCDEGH $.
  $}

  ${
    exp5c.1 $e |- ( ph -> ( ( ps /\ ch ) -> ( ( th /\ ta ) -> et ) ) ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp5c $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi wa exp4a exp3a ) ABCDEFHHABCIDEFGJK $.
  $}

  ${
    exp53.1 $e |- ( ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) /\ ta ) -> et ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins,
       30-Aug-2009.) $)
    exp53 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi wa ex exp43 ) ABCDEFHABICDIIEFGJK $.
  $}

  ${
    expl.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Export a wff from a left conjunct.  (Contributed by Jeff Hankins,
       28-Aug-2009.) $)
    expl $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      ( exp31 imp3a ) ABCDABCDEFG $.
  $}

  ${
    impr.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Import a wff into a right conjunct.  (Contributed by Jeff Hankins,
       30-Aug-2009.) $)
    impr $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      ( wi ex imp32 ) ABCDABCDFEGH $.
  $}

  ${
    impl.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Export a wff from a left conjunct.  (Contributed by Mario Carneiro,
       9-Jul-2014.) $)
    impl $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      ( exp3a imp31 ) ABCDABCDEFG $.
  $}

  ${
    impac.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Importation with conjunction in consequent.  (Contributed by NM,
       9-Aug-1994.) $)
    impac $p |- ( ( ph /\ ps ) -> ( ch /\ ps ) ) $=
      ( wa ancrd imp ) ABCBEABCDFG $.
  $}

  ${
    exbiri.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Inference form of ~ exbir .  This proof is ~ exbiriVD automatically
       translated and minimized.  (Contributed by Alan Sare, 31-Dec-2011.)
       (Proof shortened by Wolf Lammen, 27-Jan-2013.) $)
    exbiri $p |- ( ph -> ( ps -> ( th -> ch ) ) ) $=
      ( wa biimpar exp31 ) ABDCABFCDEGH $.
  $}

  ${
    pm3.26bda.1 $e |- ( ph -> ( ps <-> ( ch /\ th ) ) ) $.
    $( Deduction eliminating a conjunct.  (Contributed by NM, 22-Oct-2007.) $)
    simprbda $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa biimpa simpld ) ABFCDABCDFEGH $.

    $( Deduction eliminating a conjunct.  (Contributed by NM, 22-Oct-2007.) $)
    simplbda $p |- ( ( ph /\ ps ) -> th ) $=
      ( wa biimpa simprd ) ABFCDABCDFEGH $.
  $}

  ${
    pm3.26bi2.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Deduction eliminating a conjunct.  Automatically derived from
       ~ simplbi2VD .  (Contributed by Alan Sare, 31-Dec-2011.) $)
    simplbi2 $p |- ( ps -> ( ch -> ph ) ) $=
      ( wa biimpri ex ) BCAABCEDFG $.
  $}

  $( A theorem similar to the standard definition of the biconditional.
     Definition of [Margaris] p. 49.  (Contributed by NM, 5-Aug-1993.) $)
  dfbi2 $p |- ( ( ph <-> ps ) <-> ( ( ph -> ps ) /\ ( ps -> ph ) ) ) $=
    ( wb wi wn wa dfbi1 df-an bitr4i ) ABCABDZBADZEDEJKFABGJKHI $.

  $( Definition ~ df-bi rewritten in an abbreviated form to help intuitive
     understanding of that definition.  Note that it is a conjunction of two
     implications; one which asserts properties that follow from the
     biconditional and one which asserts properties that imply the
     biconditional.  (Contributed by NM, 15-Aug-2008.) $)
  dfbi $p |- ( ( ( ph <-> ps ) -> ( ( ph -> ps ) /\ ( ps -> ph ) ) )
        /\ ( ( ( ph -> ps ) /\ ( ps -> ph ) ) -> ( ph <-> ps ) ) ) $=
    ( wb wi wa dfbi2 biimpi biimpri pm3.2i ) ABCZABDBADEZDKJDJKABFZGJKLHI $.

  $( Implication in terms of biconditional and conjunction.  Theorem *4.71 of
     [WhiteheadRussell] p. 120.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 2-Dec-2012.) $)
  pm4.71 $p |- ( ( ph -> ps ) <-> ( ph <-> ( ph /\ ps ) ) ) $=
    ( wa wi wb simpl biantru anclb dfbi2 3bitr4i ) AABCZDZLKADZCABDAKEMLABFGABH
    AKIJ $.

  $( Implication in terms of biconditional and conjunction.  Theorem *4.71 of
     [WhiteheadRussell] p. 120 (with conjunct reversed).  (Contributed by NM,
     25-Jul-1999.) $)
  pm4.71r $p |- ( ( ph -> ps ) <-> ( ph <-> ( ps /\ ph ) ) ) $=
    ( wi wa wb pm4.71 ancom bibi2i bitri ) ABCAABDZEABADZEABFJKAABGHI $.

  ${
    pm4.71i.1 $e |- ( ph -> ps ) $.
    $( Inference converting an implication to a biconditional with
       conjunction.  Inference from Theorem *4.71 of [WhiteheadRussell]
       p. 120.  (Contributed by NM, 4-Jan-2004.) $)
    pm4.71i $p |- ( ph <-> ( ph /\ ps ) ) $=
      ( wi wa wb pm4.71 mpbi ) ABDAABEFCABGH $.
  $}

  ${
    pm4.71ri.1 $e |- ( ph -> ps ) $.
    $( Inference converting an implication to a biconditional with
       conjunction.  Inference from Theorem *4.71 of [WhiteheadRussell] p. 120
       (with conjunct reversed).  (Contributed by NM, 1-Dec-2003.) $)
    pm4.71ri $p |- ( ph <-> ( ps /\ ph ) ) $=
      ( wi wa wb pm4.71r mpbi ) ABDABAEFCABGH $.
  $}

  ${
    pm4.71rd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction converting an implication to a biconditional with
       conjunction.  Deduction from Theorem *4.71 of [WhiteheadRussell]
       p. 120.  (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    pm4.71d $p |- ( ph -> ( ps <-> ( ps /\ ch ) ) ) $=
      ( wi wa wb pm4.71 sylib ) ABCEBBCFGDBCHI $.

    $( Deduction converting an implication to a biconditional with
       conjunction.  Deduction from Theorem *4.71 of [WhiteheadRussell]
       p. 120.  (Contributed by NM, 10-Feb-2005.) $)
    pm4.71rd $p |- ( ph -> ( ps <-> ( ch /\ ps ) ) ) $=
      ( wi wa wb pm4.71r sylib ) ABCEBCBFGDBCHI $.
  $}

  $( Distribution of implication over biconditional.  Theorem *5.32 of
     [WhiteheadRussell] p. 125.  (Contributed by NM, 1-Aug-1994.) $)
  pm5.32 $p |- ( ( ph -> ( ps <-> ch ) ) <->
               ( ( ph /\ ps ) <-> ( ph /\ ch ) ) ) $=
    ( wb wi wn wa notbi imbi2i pm5.74 3bitri df-an bibi12i bitr4i ) ABCDZEZABFZ
    EZFZACFZEZFZDZABGZACGZDPAQTDZERUADUCOUFABCHIAQTJRUAHKUDSUEUBABLACLMN $.

  ${
    pm5.32i.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Distribution of implication over biconditional (inference rule).
       (Contributed by NM, 1-Aug-1994.) $)
    pm5.32i $p |- ( ( ph /\ ps ) <-> ( ph /\ ch ) ) $=
      ( wb wi wa pm5.32 mpbi ) ABCEFABGACGEDABCHI $.

    $( Distribution of implication over biconditional (inference rule).
       (Contributed by NM, 12-Mar-1995.) $)
    pm5.32ri $p |- ( ( ps /\ ph ) <-> ( ch /\ ph ) ) $=
      ( wa pm5.32i ancom 3bitr4i ) ABEACEBAECAEABCDFBAGCAGH $.
  $}

  ${
    pm5.32d.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Distribution of implication over biconditional (deduction rule).
       (Contributed by NM, 29-Oct-1996.) $)
    pm5.32d $p |- ( ph -> ( ( ps /\ ch ) <-> ( ps /\ th ) ) ) $=
      ( wb wi wa pm5.32 sylib ) ABCDFGBCHBDHFEBCDIJ $.

    $( Distribution of implication over biconditional (deduction rule).
       (Contributed by NM, 25-Dec-2004.) $)
    pm5.32rd $p |- ( ph -> ( ( ch /\ ps ) <-> ( th /\ ps ) ) ) $=
      ( wa pm5.32d ancom 3bitr4g ) ABCFBDFCBFDBFABCDEGCBHDBHI $.
  $}

  ${
    pm5.32da.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Distribution of implication over biconditional (deduction rule).
       (Contributed by NM, 9-Dec-2006.) $)
    pm5.32da $p |- ( ph -> ( ( ps /\ ch ) <-> ( ps /\ th ) ) ) $=
      ( wb ex pm5.32d ) ABCDABCDFEGH $.
  $}

  ${
    biadan2.1 $e |- ( ph -> ps ) $.
    biadan2.2 $e |- ( ps -> ( ph <-> ch ) ) $.
    $( Add a conjunction to an equivalence.  (Contributed by Jeff Madsen,
       20-Jun-2011.) $)
    biadan2 $p |- ( ph <-> ( ps /\ ch ) ) $=
      ( wa pm4.71ri pm5.32i bitri ) ABAFBCFABDGBACEHI $.
  $}

  $( Theorem *4.24 of [WhiteheadRussell] p. 117.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.24 $p |- ( ph <-> ( ph /\ ph ) ) $=
    ( id pm4.71i ) AAABC $.

  $( Idempotent law for conjunction.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 14-Mar-2014.) $)
  anidm $p |- ( ( ph /\ ph ) <-> ph ) $=
    ( wa pm4.24 bicomi ) AAABACD $.

  ${
    anidms.1 $e |- ( ( ph /\ ph ) -> ps ) $.
    $( Inference from idempotent law for conjunction.  (Contributed by NM,
       15-Jun-1994.) $)
    anidms $p |- ( ph -> ps ) $=
      ( ex pm2.43i ) ABAABCDE $.
  $}

  $( Conjunction idempotence with antecedent.  (Contributed by Roy F. Longton,
     8-Aug-2005.) $)
  anidmdbi $p |- ( ( ph -> ( ps /\ ps ) ) <-> ( ph -> ps ) ) $=
    ( wa anidm imbi2i ) BBCBABDE $.

  ${
    anasss.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Associative law for conjunction applied to antecedent (eliminates
       syllogism).  (Contributed by NM, 15-Nov-2002.) $)
    anasss $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      ( exp31 imp32 ) ABCDABCDEFG $.
  $}

  ${
    anassrs.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Associative law for conjunction applied to antecedent (eliminates
       syllogism).  (Contributed by NM, 15-Nov-2002.) $)
    anassrs $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      ( exp32 imp31 ) ABCDABCDEFG $.
  $}

  $( Associative law for conjunction.  Theorem *4.32 of [WhiteheadRussell]
     p. 118.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 24-Nov-2012.) $)
  anass $p |- ( ( ( ph /\ ps ) /\ ch ) <-> ( ph /\ ( ps /\ ch ) ) ) $=
    ( wa id anassrs anasss impbii ) ABDCDZABCDDZABCJJEFABCIIEGH $.

  ${
    sylanl1.1 $e |- ( ph -> ps ) $.
    sylanl1.2 $e |- ( ( ( ps /\ ch ) /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 10-Mar-2005.) $)
    sylanl1 $p |- ( ( ( ph /\ ch ) /\ th ) -> ta ) $=
      ( wa anim1i sylan ) ACHBCHDEABCFIGJ $.
  $}

  ${
    sylanl2.1 $e |- ( ph -> ch ) $.
    sylanl2.2 $e |- ( ( ( ps /\ ch ) /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 1-Jan-2005.) $)
    sylanl2 $p |- ( ( ( ps /\ ph ) /\ th ) -> ta ) $=
      ( wa anim2i sylan ) BAHBCHDEACBFIGJ $.
  $}

  ${
    sylanr1.1 $e |- ( ph -> ch ) $.
    sylanr1.2 $e |- ( ( ps /\ ( ch /\ th ) ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 9-Apr-2005.) $)
    sylanr1 $p |- ( ( ps /\ ( ph /\ th ) ) -> ta ) $=
      ( wa anim1i sylan2 ) ADHBCDHEACDFIGJ $.
  $}

  ${
    sylanr2.1 $e |- ( ph -> th ) $.
    sylanr2.2 $e |- ( ( ps /\ ( ch /\ th ) ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 9-Apr-2005.) $)
    sylanr2 $p |- ( ( ps /\ ( ch /\ ph ) ) -> ta ) $=
      ( wa anim2i sylan2 ) CAHBCDHEADCFIGJ $.
  $}

  ${
    sylani.1 $e |- ( ph -> ch ) $.
    sylani.2 $e |- ( ps -> ( ( ch /\ th ) -> ta ) ) $.
    $( A syllogism inference.  (Contributed by NM, 2-May-1996.) $)
    sylani $p |- ( ps -> ( ( ph /\ th ) -> ta ) ) $=
      ( wi a1i syland ) BACDEACHBFIGJ $.
  $}

  ${
    sylan2i.1 $e |- ( ph -> th ) $.
    sylan2i.2 $e |- ( ps -> ( ( ch /\ th ) -> ta ) ) $.
    $( A syllogism inference.  (Contributed by NM, 1-Aug-1994.) $)
    sylan2i $p |- ( ps -> ( ( ch /\ ph ) -> ta ) ) $=
      ( wi a1i sylan2d ) BADCEADHBFIGJ $.
  $}

  ${
    syl2ani.1 $e |- ( ph -> ch ) $.
    syl2ani.2 $e |- ( et -> th ) $.
    syl2ani.3 $e |- ( ps -> ( ( ch /\ th ) -> ta ) ) $.
    $( A syllogism inference.  (Contributed by NM, 3-Aug-1999.) $)
    syl2ani $p |- ( ps -> ( ( ph /\ et ) -> ta ) ) $=
      ( sylan2i sylani ) ABCFEGFBCDEHIJK $.
  $}

  ${
    sylan9.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylan9.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       7-May-2011.) $)
    sylan9 $p |- ( ( ph /\ th ) -> ( ps -> ta ) ) $=
      ( wi syl9 imp ) ADBEHABCDEFGIJ $.
  $}

  ${
    sylan9r.1 $e |- ( ph -> ( ps -> ch ) ) $.
    sylan9r.2 $e |- ( th -> ( ch -> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents.
       (Contributed by NM, 5-Aug-1993.) $)
    sylan9r $p |- ( ( th /\ ph ) -> ( ps -> ta ) ) $=
      ( wi syl9r imp ) DABEHABCDEFGIJ $.
  $}

  ${
    mtand.1 $e |- ( ph -> -. ch ) $.
    mtand.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( A modus tollens deduction.  (Contributed by Jeff Hankins,
       19-Aug-2009.) $)
    mtand $p |- ( ph -> -. ps ) $=
      ( ex mtod ) ABCDABCEFG $.
  $}

  ${
    mtord.1 $e |- ( ph -> -. ch ) $.
    mtord.2 $e |- ( ph -> -. th ) $.
    mtord.3 $e |- ( ph -> ( ps -> ( ch \/ th ) ) ) $.
    $( A modus tollens deduction involving disjunction.  (Contributed by Jeff
       Hankins, 15-Jul-2009.) $)
    mtord $p |- ( ph -> -. ps ) $=
      ( wn wo wi df-or syl6ib mpid mtod ) ABDFABCHZDEABCDIODJGCDKLMN $.
  $}

  ${
    syl2anc.1 $e |- ( ph -> ps ) $.
    syl2anc.2 $e |- ( ph -> ch ) $.
    syl2anc.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( Syllogism inference combined with contraction.  (Contributed by NM,
       16-Mar-2012.) $)
    syl2anc $p |- ( ph -> th ) $=
      ( ex sylc ) ABCDEFBCDGHI $.
  $}

  ${
    sylancl.1 $e |- ( ph -> ps ) $.
    sylancl.2 $e |- ch $.
    sylancl.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( Syllogism inference combined with modus ponens.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    sylancl $p |- ( ph -> th ) $=
      ( a1i syl2anc ) ABCDECAFHGI $.
  $}

  ${
    sylancr.1 $e |- ps $.
    sylancr.2 $e |- ( ph -> ch ) $.
    sylancr.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( Syllogism inference combined with modus ponens.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    sylancr $p |- ( ph -> th ) $=
      ( a1i syl2anc ) ABCDBAEHFGI $.
  $}

  ${
    sylanbrc.1 $e |- ( ph -> ps ) $.
    sylanbrc.2 $e |- ( ph -> ch ) $.
    sylanbrc.3 $e |- ( th <-> ( ps /\ ch ) ) $.
    $( Syllogism inference.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    sylanbrc $p |- ( ph -> th ) $=
      ( wa jca sylibr ) ABCHDABCEFIGJ $.
  $}

  ${
    sylancb.1 $e |- ( ph <-> ps ) $.
    sylancb.2 $e |- ( ph <-> ch ) $.
    sylancb.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference combined with contraction.  (Contributed by NM,
       3-Sep-2004.) $)
    sylancb $p |- ( ph -> th ) $=
      ( syl2anb anidms ) ADABCDAEFGHI $.
  $}

  ${
    sylancbr.1 $e |- ( ps <-> ph ) $.
    sylancbr.2 $e |- ( ch <-> ph ) $.
    sylancbr.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( A syllogism inference combined with contraction.  (Contributed by NM,
       3-Sep-2004.) $)
    sylancbr $p |- ( ph -> th ) $=
      ( syl2anbr anidms ) ADABCDAEFGHI $.
  $}

  ${
    sylancom.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    sylancom.2 $e |- ( ( ch /\ ps ) -> th ) $.
    $( Syllogism inference with commutation of antecedents.  (Contributed by
       NM, 2-Jul-2008.) $)
    sylancom $p |- ( ( ph /\ ps ) -> th ) $=
      ( wa simpr syl2anc ) ABGCBDEABHFI $.
  $}

  ${
    mpdan.1 $e |- ( ph -> ps ) $.
    mpdan.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 23-May-1999.)
       (Proof shortened by Wolf Lammen, 22-Nov-2012.) $)
    mpdan $p |- ( ph -> ch ) $=
      ( id syl2anc ) AABCAFDEG $.
  $}

  ${
    mpancom.1 $e |- ( ps -> ph ) $.
    mpancom.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens with commutation of antecedents.
       (Contributed by NM, 28-Oct-2003.)  (Proof shortened by Wolf Lammen,
       7-Apr-2013.) $)
    mpancom $p |- ( ps -> ch ) $=
      ( id syl2anc ) BABCDBFEG $.
  $}

  ${
    mpan.1 $e |- ph $.
    mpan.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 30-Aug-1993.)
       (Proof shortened by Wolf Lammen, 7-Apr-2013.) $)
    mpan $p |- ( ps -> ch ) $=
      ( a1i mpancom ) ABCABDFEG $.
  $}

  ${
    mpan2.1 $e |- ps $.
    mpan2.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 16-Sep-1993.)
       (Proof shortened by Wolf Lammen, 19-Nov-2012.) $)
    mpan2 $p |- ( ph -> ch ) $=
      ( a1i mpdan ) ABCBADFEG $.
  $}

  ${
    mp2an.1 $e |- ph $.
    mp2an.2 $e |- ps $.
    mp2an.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       13-Apr-1995.) $)
    mp2an $p |- ch $=
      ( mpan ax-mp ) BCEABCDFGH $.
  $}

  ${
    mp4an.1 $e |- ph $.
    mp4an.2 $e |- ps $.
    mp4an.3 $e |- ch $.
    mp4an.4 $e |- th $.
    mp4an.5 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by Jeff Madsen,
       15-Jun-2010.) $)
    mp4an $p |- ta $=
      ( wa pm3.2i mp2an ) ABKCDKEABFGLCDHILJM $.
  $}

  ${
    mpan2d.1 $e |- ( ph -> ch ) $.
    mpan2d.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( A deduction based on modus ponens.  (Contributed by NM, 12-Dec-2004.) $)
    mpan2d $p |- ( ph -> ( ps -> th ) ) $=
      ( exp3a mpid ) ABCDEABCDFGH $.
  $}

  ${
    mpand.1 $e |- ( ph -> ps ) $.
    mpand.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( A deduction based on modus ponens.  (Contributed by NM, 12-Dec-2004.)
       (Proof shortened by Wolf Lammen, 7-Apr-2013.) $)
    mpand $p |- ( ph -> ( ch -> th ) ) $=
      ( ancomsd mpan2d ) ACBDEABCDFGH $.
  $}

  ${
    mpani.1 $e |- ps $.
    mpani.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 10-Apr-1994.)
       (Proof shortened by Wolf Lammen, 19-Nov-2012.) $)
    mpani $p |- ( ph -> ( ch -> th ) ) $=
      ( a1i mpand ) ABCDBAEGFH $.
  $}

  ${
    mpan2i.1 $e |- ch $.
    mpan2i.2 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 10-Apr-1994.)
       (Proof shortened by Wolf Lammen, 19-Nov-2012.) $)
    mpan2i $p |- ( ph -> ( ps -> th ) ) $=
      ( a1i mpan2d ) ABCDCAEGFH $.
  $}

  ${
    mp2ani.1 $e |- ps $.
    mp2ani.2 $e |- ch $.
    mp2ani.3 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       12-Dec-2004.) $)
    mp2ani $p |- ( ph -> th ) $=
      ( mpani mpi ) ACDFABCDEGHI $.
  $}

  ${
    mp2and.1 $e |- ( ph -> ps ) $.
    mp2and.2 $e |- ( ph -> ch ) $.
    mp2and.3 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( A deduction based on modus ponens.  (Contributed by NM, 12-Dec-2004.) $)
    mp2and $p |- ( ph -> th ) $=
      ( mpand mpd ) ACDFABCDEGHI $.
  $}

  ${
    mpanl1.1 $e |- ph $.
    mpanl1.2 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 16-Aug-1994.)
       (Proof shortened by Wolf Lammen, 7-Apr-2013.) $)
    mpanl1 $p |- ( ( ps /\ ch ) -> th ) $=
      ( wa jctl sylan ) BABGCDBAEHFI $.
  $}

  ${
    mpanl2.1 $e |- ps $.
    mpanl2.2 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 16-Aug-1994.)
       (Proof shortened by Andrew Salmon, 7-May-2011.) $)
    mpanl2 $p |- ( ( ph /\ ch ) -> th ) $=
      ( wa jctr sylan ) AABGCDABEHFI $.
  $}

  ${
    mpanl12.1 $e |- ph $.
    mpanl12.2 $e |- ps $.
    mpanl12.3 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       13-Jul-2005.) $)
    mpanl12 $p |- ( ch -> th ) $=
      ( mpanl1 mpan ) BCDFABCDEGHI $.
  $}

  ${
    mpanr1.1 $e |- ps $.
    mpanr1.2 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 3-May-1994.)
       (Proof shortened by Andrew Salmon, 7-May-2011.) $)
    mpanr1 $p |- ( ( ph /\ ch ) -> th ) $=
      ( anassrs mpanl2 ) ABCDEABCDFGH $.
  $}

  ${
    mpanr2.1 $e |- ch $.
    mpanr2.2 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 3-May-1994.)
       (Proof shortened by Andrew Salmon, 7-May-2011.)  (Proof shortened by
       Wolf Lammen, 7-Apr-2013.) $)
    mpanr2 $p |- ( ( ph /\ ps ) -> th ) $=
      ( wa jctr sylan2 ) BABCGDBCEHFI $.
  $}

  ${
    mpanr12.1 $e |- ps $.
    mpanr12.2 $e |- ch $.
    mpanr12.3 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       24-Jul-2009.) $)
    mpanr12 $p |- ( ph -> th ) $=
      ( mpanr1 mpan2 ) ACDFABCDEGHI $.
  $}

  ${
    mpanlr1.1 $e |- ps $.
    mpanlr1.2 $e |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 30-Dec-2004.)
       (Proof shortened by Wolf Lammen, 7-Apr-2013.) $)
    mpanlr1 $p |- ( ( ( ph /\ ch ) /\ th ) -> ta ) $=
      ( wa jctl sylanl2 ) CABCHDECBFIGJ $.
  $}

  ${
    pm5.74da.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Distribution of implication over biconditional (deduction rule).
       (Contributed by NM, 4-May-2007.) $)
    pm5.74da $p |- ( ph -> ( ( ps -> ch ) <-> ( ps -> th ) ) ) $=
      ( wb ex pm5.74d ) ABCDABCDFEGH $.
  $}

  $( Theorem *4.45 of [WhiteheadRussell] p. 119.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.45 $p |- ( ph <-> ( ph /\ ( ph \/ ps ) ) ) $=
    ( wo orc pm4.71i ) AABCABDE $.

  $( Distribution of implication with conjunction.  (Contributed by NM,
     31-May-1999.)  (Proof shortened by Wolf Lammen, 6-Dec-2012.) $)
  imdistan $p |- ( ( ph -> ( ps -> ch ) ) <->
                ( ( ph /\ ps ) -> ( ph /\ ch ) ) ) $=
    ( wi wa pm5.42 impexp bitr4i ) ABCDDABACEZDDABEIDABCFABIGH $.

  ${
    imdistani.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Distribution of implication with conjunction.  (Contributed by NM,
       1-Aug-1994.) $)
    imdistani $p |- ( ( ph /\ ps ) -> ( ph /\ ch ) ) $=
      ( wa anc2li imp ) ABACEABCDFG $.
  $}

  ${
    imdistanri.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Distribution of implication with conjunction.  (Contributed by NM,
       8-Jan-2002.) $)
    imdistanri $p |- ( ( ps /\ ph ) -> ( ch /\ ph ) ) $=
      ( com12 impac ) BACABCDEF $.
  $}

  ${
    imdistand.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Distribution of implication with conjunction (deduction rule).
       (Contributed by NM, 27-Aug-2004.) $)
    imdistand $p |- ( ph -> ( ( ps /\ ch ) -> ( ps /\ th ) ) ) $=
      ( wi wa imdistan sylib ) ABCDFFBCGBDGFEBCDHI $.
  $}

  ${
    imdistanda.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Distribution of implication with conjunction (deduction version with
       conjoined antecedent).  (Contributed by Jeff Madsen, 19-Jun-2011.) $)
    imdistanda $p |- ( ph -> ( ( ps /\ ch ) -> ( ps /\ th ) ) ) $=
      ( wi ex imdistand ) ABCDABCDFEGH $.
  $}

  ${
    bi.aa $e |- ( ph <-> ps ) $.
    $( Introduce a left conjunct to both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       16-Nov-2013.) $)
    anbi2i $p |- ( ( ch /\ ph ) <-> ( ch /\ ps ) ) $=
      ( wb a1i pm5.32i ) CABABECDFG $.

    $( Introduce a right conjunct to both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       16-Nov-2013.) $)
    anbi1i $p |- ( ( ph /\ ch ) <-> ( ps /\ ch ) ) $=
      ( wb a1i pm5.32ri ) CABABECDFG $.

    $( Variant of ~ anbi2i with commutation.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.)  (Proof shortened by Andrew Salmon,
       14-Jun-2011.) $)
    anbi2ci $p |- ( ( ph /\ ch ) <-> ( ch /\ ps ) ) $=
      ( wa anbi1i ancom bitri ) ACEBCECBEABCDFBCGH $.
  $}

  ${
    anbi12.1 $e |- ( ph <-> ps ) $.
    anbi12.2 $e |- ( ch <-> th ) $.
    $( Conjoin both sides of two equivalences.  (Contributed by NM,
       5-Aug-1993.) $)
    anbi12i $p |- ( ( ph /\ ch ) <-> ( ps /\ th ) ) $=
      ( wa anbi1i anbi2i bitri ) ACGBCGBDGABCEHCDBFIJ $.

    $( Variant of ~ anbi12i with commutation.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    anbi12ci $p |- ( ( ph /\ ch ) <-> ( th /\ ps ) ) $=
      ( wa anbi12i ancom bitri ) ACGBDGDBGABCDEFHBDIJ $.
  $}

  ${
    sylan9bb.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    sylan9bb.2 $e |- ( th -> ( ch <-> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents.
       (Contributed by NM, 4-Mar-1995.) $)
    sylan9bb $p |- ( ( ph /\ th ) -> ( ps <-> ta ) ) $=
      ( wa wb adantr adantl bitrd ) ADHBCEABCIDFJDCEIAGKL $.
  $}

  ${
    sylan9bbr.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    sylan9bbr.2 $e |- ( th -> ( ch <-> ta ) ) $.
    $( Nested syllogism inference conjoining dissimilar antecedents.
       (Contributed by NM, 4-Mar-1995.) $)
    sylan9bbr $p |- ( ( th /\ ph ) -> ( ps <-> ta ) ) $=
      ( wb sylan9bb ancoms ) ADBEHABCDEFGIJ $.
  $}

  ${
    bid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction adding a left disjunct to both sides of a logical
       equivalence.  (Contributed by NM, 5-Aug-1993.) $)
    orbi2d $p |- ( ph -> ( ( th \/ ps ) <-> ( th \/ ch ) ) ) $=
      ( wn wi wo imbi2d df-or 3bitr4g ) ADFZBGLCGDBHDCHABCLEIDBJDCJK $.

    $( Deduction adding a right disjunct to both sides of a logical
       equivalence.  (Contributed by NM, 5-Aug-1993.) $)
    orbi1d $p |- ( ph -> ( ( ps \/ th ) <-> ( ch \/ th ) ) ) $=
      ( wo orbi2d orcom 3bitr4g ) ADBFDCFBDFCDFABCDEGBDHCDHI $.

    $( Deduction adding a left conjunct to both sides of a logical
       equivalence.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
       Lammen, 16-Nov-2013.) $)
    anbi2d $p |- ( ph -> ( ( th /\ ps ) <-> ( th /\ ch ) ) ) $=
      ( wb a1d pm5.32d ) ADBCABCFDEGH $.

    $( Deduction adding a right conjunct to both sides of a logical
       equivalence.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
       Lammen, 16-Nov-2013.) $)
    anbi1d $p |- ( ph -> ( ( ps /\ th ) <-> ( ch /\ th ) ) ) $=
      ( wb a1d pm5.32rd ) ADBCABCFDEGH $.
  $}

  $( Theorem *4.37 of [WhiteheadRussell] p. 118.  (Contributed by NM,
     3-Jan-2005.) $)
  orbi1 $p |- ( ( ph <-> ps ) -> ( ( ph \/ ch ) <-> ( ps \/ ch ) ) ) $=
    ( wb id orbi1d ) ABDZABCGEF $.

  $( Introduce a right conjunct to both sides of a logical equivalence.
     Theorem *4.36 of [WhiteheadRussell] p. 118.  (Contributed by NM,
     3-Jan-2005.) $)
  anbi1 $p |- ( ( ph <-> ps ) -> ( ( ph /\ ch ) <-> ( ps /\ ch ) ) ) $=
    ( wb id anbi1d ) ABDZABCGEF $.

  $( Introduce a left conjunct to both sides of a logical equivalence.
     (Contributed by NM, 16-Nov-2013.) $)
  anbi2 $p |- ( ( ph <-> ps ) -> ( ( ch /\ ph ) <-> ( ch /\ ps ) ) ) $=
    ( wb id anbi2d ) ABDZABCGEF $.

  $( Theorem *4.22 of [WhiteheadRussell] p. 117.  (Contributed by NM,
     3-Jan-2005.) $)
  bitr $p |- ( ( ( ph <-> ps ) /\ ( ps <-> ch ) ) -> ( ph <-> ch ) ) $=
    ( wb bibi1 biimpar ) ABDACDBCDABCEF $.

  ${
    bi12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bi12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction joining two equivalences to form equivalence of disjunctions.
       (Contributed by NM, 5-Aug-1993.) $)
    orbi12d $p |- ( ph -> ( ( ps \/ th ) <-> ( ch \/ ta ) ) ) $=
      ( wo orbi1d orbi2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.

    $( Deduction joining two equivalences to form equivalence of conjunctions.
       (Contributed by NM, 5-Aug-1993.) $)
    anbi12d $p |- ( ph -> ( ( ps /\ th ) <-> ( ch /\ ta ) ) ) $=
      ( wa anbi1d anbi2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  $( Theorem *5.3 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Andrew Salmon, 7-May-2011.) $)
  pm5.3 $p |- ( ( ( ph /\ ps ) -> ch ) <->
               ( ( ph /\ ps ) -> ( ph /\ ch ) ) ) $=
    ( wa wi impexp imdistan bitri ) ABDZCEABCEEIACDEABCFABCGH $.

  $( Theorem *5.61 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 30-Jun-2013.) $)
  pm5.61 $p |- ( ( ( ph \/ ps ) /\ -. ps ) <-> ( ph /\ -. ps ) ) $=
    ( wn wo biorf orcom syl6rbb pm5.32ri ) BCZABDZAIABADJBAEBAFGH $.

  ${
    adant2.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       4-May-1994.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    adantll $p |- ( ( ( th /\ ph ) /\ ps ) -> ch ) $=
      ( wa simpr sylan ) DAFABCDAGEH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       4-May-1994.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    adantlr $p |- ( ( ( ph /\ th ) /\ ps ) -> ch ) $=
      ( wa simpl sylan ) ADFABCADGEH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       4-May-1994.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    adantrl $p |- ( ( ph /\ ( th /\ ps ) ) -> ch ) $=
      ( wa simpr sylan2 ) DBFABCDBGEH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       4-May-1994.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    adantrr $p |- ( ( ph /\ ( ps /\ th ) ) -> ch ) $=
      ( wa simpl sylan2 ) BDFABCBDGEH $.
  $}

  ${
    adantl2.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 2-Dec-2012.) $)
    adantlll $p |- ( ( ( ( ta /\ ph ) /\ ps ) /\ ch ) -> th ) $=
      ( wa simpr sylanl1 ) EAGABCDEAHFI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantllr $p |- ( ( ( ( ph /\ ta ) /\ ps ) /\ ch ) -> th ) $=
      ( wa simpl sylanl1 ) AEGABCDAEHFI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantlrl $p |- ( ( ( ph /\ ( ta /\ ps ) ) /\ ch ) -> th ) $=
      ( wa simpr sylanl2 ) EBGABCDEBHFI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantlrr $p |- ( ( ( ph /\ ( ps /\ ta ) ) /\ ch ) -> th ) $=
      ( wa simpl sylanl2 ) BEGABCDBEHFI $.
  $}

  ${
    adantr2.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantrll $p |- ( ( ph /\ ( ( ta /\ ps ) /\ ch ) ) -> th ) $=
      ( wa simpr sylanr1 ) EBGABCDEBHFI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantrlr $p |- ( ( ph /\ ( ( ps /\ ta ) /\ ch ) ) -> th ) $=
      ( wa simpl sylanr1 ) BEGABCDBEHFI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantrrl $p |- ( ( ph /\ ( ps /\ ( ta /\ ch ) ) ) -> th ) $=
      ( wa simpr sylanr2 ) ECGABCDECHFI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       26-Dec-2004.)  (Proof shortened by Wolf Lammen, 4-Dec-2012.) $)
    adantrrr $p |- ( ( ph /\ ( ps /\ ( ch /\ ta ) ) ) -> th ) $=
      ( wa simpl sylanr2 ) CEGABCDCEHFI $.
  $}

  ${
    ad2ant.1 $e |- ( ph -> ps ) $.
    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       19-Oct-1999.)  (Proof shortened by Wolf Lammen, 20-Nov-2012.) $)
    ad2antrr $p |- ( ( ( ph /\ ch ) /\ th ) -> ps ) $=
      ( adantr adantlr ) ADBCABDEFG $.

    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       19-Oct-1999.)  (Proof shortened by Wolf Lammen, 20-Nov-2012.) $)
    ad2antlr $p |- ( ( ( ch /\ ph ) /\ th ) -> ps ) $=
      ( adantr adantll ) ADBCABDEFG $.

    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       19-Oct-1999.) $)
    ad2antrl $p |- ( ( ch /\ ( ph /\ th ) ) -> ps ) $=
      ( wa adantr adantl ) ADFBCABDEGH $.

    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       19-Oct-1999.) $)
    ad2antll $p |- ( ( ch /\ ( th /\ ph ) ) -> ps ) $=
      ( wa adantl ) DAFBCABDEGG $.

    $( Deduction adding three conjuncts to antecedent.  (Contributed by NM,
       28-Jul-2012.) $)
    ad3antrrr $p |- ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) -> ps ) $=
      ( wa adantr ad2antrr ) ACGBDEABCFHI $.

    $( Deduction adding three conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad3antlr $p |- ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) -> ps ) $=
      ( wa ad2antlr adantr ) CAGDGBEABCDFHI $.

    $( Deduction adding 4 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad4antr $p |- ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et ) -> ps ) $=
      ( wa ad3antrrr adantr ) ACHDHEHBFABCDEGIJ $.

    $( Deduction adding 4 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad4antlr $p |- ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et ) -> ps ) $=
      ( wa ad3antlr adantr ) CAHDHEHBFABCDEGIJ $.

    $( Deduction adding 5 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad5antr $p |- ( ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et )
      /\ ze ) -> ps ) $=
      ( wa ad4antr adantr ) ACIDIEIFIBGABCDEFHJK $.

    $( Deduction adding 5 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad5antlr $p |- ( ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et )
      /\ ze ) -> ps ) $=
      ( wa ad4antlr adantr ) CAIDIEIFIBGABCDEFHJK $.

    $( Deduction adding 6 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad6antr $p |- ( ( ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) -> ps ) $=
      ( wa ad5antr adantr ) ACJDJEJFJGJBHABCDEFGIKL $.

    $( Deduction adding 6 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad6antlr $p |- ( ( ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) -> ps ) $=
      ( wa ad5antlr adantr ) CAJDJEJFJGJBHABCDEFGIKL $.

    $( Deduction adding 7 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad7antr $p |- ( ( ( ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) -> ps ) $=
      ( wa ad6antr adantr ) ACKDKEKFKGKHKBIABCDEFGHJLM $.

    $( Deduction adding 7 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad7antlr $p |- ( ( ( ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) -> ps ) $=
      ( wa ad6antlr adantr ) CAKDKEKFKGKHKBIABCDEFGHJLM $.

    $( Deduction adding 8 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad8antr $p |- ( ( ( ( ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) /\ mu ) -> ps ) $=
      ( wa ad7antr adantr ) ACLDLELFLGLHLILBJABCDEFGHIKMN $.

    $( Deduction adding 8 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad8antlr $p |- ( ( ( ( ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) /\ mu ) -> ps ) $=
      ( wa ad7antlr adantr ) CALDLELFLGLHLILBJABCDEFGHIKMN $.

    $( Deduction adding 9 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad9antr $p |- ( ( ( ( ( ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) -> ps ) $=
      ( wa ad8antr adantr ) ACMDMEMFMGMHMIMJMBKABCDEFGHIJLNO $.

    $( Deduction adding 9 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad9antlr $p |- ( ( ( ( ( ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) -> ps ) $=
      ( wa ad8antlr adantr ) CAMDMEMFMGMHMIMJMBKABCDEFGHIJLNO $.

    $( Deduction adding 10 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    ad10antr $p |- ( ( ( ( ( ( ( ( ( ( ( ph /\ ch ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) /\ ka ) -> ps ) $=
      ( wa ad9antr adantr ) ACNDNENFNGNHNINJNKNBLABCDEFGHIJKMOP $.

    $( Deduction adding 10 conjuncts to antecedent.  (Contributed by Mario
       Carneiro, 5-Jan-2017.) $)
    ad10antlr $p |- ( ( ( ( ( ( ( ( ( ( ( ch /\ ph ) /\ th ) /\ ta ) /\ et )
      /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) /\ ka ) -> ps ) $=
      ( wa ad9antlr adantr ) CANDNENFNGNHNINJNKNBLABCDEFGHIJKMOP $.
  $}

  ${
    ad2ant2.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    ad2ant2l $p |- ( ( ( th /\ ph ) /\ ( ta /\ ps ) ) -> ch ) $=
      ( wa adantrl adantll ) AEBGCDABCEFHI $.

    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    ad2ant2r $p |- ( ( ( ph /\ th ) /\ ( ps /\ ta ) ) -> ch ) $=
      ( wa adantrr adantlr ) ABEGCDABCEFHI $.

    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       23-Nov-2007.) $)
    ad2ant2lr $p |- ( ( ( th /\ ph ) /\ ( ps /\ ta ) ) -> ch ) $=
      ( wa adantrr adantll ) ABEGCDABCEFHI $.

    $( Deduction adding two conjuncts to antecedent.  (Contributed by NM,
       24-Nov-2007.) $)
    ad2ant2rl $p |- ( ( ( ph /\ th ) /\ ( ta /\ ps ) ) -> ch ) $=
      ( wa adantrl adantlr ) AEBGCDABCEFHI $.
  $}

  $( Simplification of a conjunction.  (Contributed by NM, 18-Mar-2007.) $)
  simpll $p |- ( ( ( ph /\ ps ) /\ ch ) -> ph ) $=
    ( id ad2antrr ) AABCADE $.

  $( Simplification of a conjunction.  (Contributed by NM, 20-Mar-2007.) $)
  simplr $p |- ( ( ( ph /\ ps ) /\ ch ) -> ps ) $=
    ( id ad2antlr ) BBACBDE $.

  $( Simplification of a conjunction.  (Contributed by NM, 21-Mar-2007.) $)
  simprl $p |- ( ( ph /\ ( ps /\ ch ) ) -> ps ) $=
    ( id ad2antrl ) BBACBDE $.

  $( Simplification of a conjunction.  (Contributed by NM, 21-Mar-2007.) $)
  simprr $p |- ( ( ph /\ ( ps /\ ch ) ) -> ch ) $=
    ( id ad2antll ) CCABCDE $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simplll $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ph ) $=
    ( wa simpl ad2antrr ) ABEACDABFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simpllr $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ps ) $=
    ( wa simpr ad2antrr ) ABEBCDABFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simplrl $p |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ps ) $=
    ( wa simpl ad2antlr ) BCEBADBCFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simplrr $p |- ( ( ( ph /\ ( ps /\ ch ) ) /\ th ) -> ch ) $=
    ( wa simpr ad2antlr ) BCECADBCFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprll $p |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ps ) $=
    ( wa simpl ad2antrl ) BCEBADBCFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprlr $p |- ( ( ph /\ ( ( ps /\ ch ) /\ th ) ) -> ch ) $=
    ( wa simpr ad2antrl ) BCECADBCFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprrl $p |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> ch ) $=
    ( wa simpl ad2antll ) CDECABCDFG $.

  $( Simplification of a conjunction.  (Contributed by Jeff Hankins,
     28-Jul-2009.) $)
  simprrr $p |- ( ( ph /\ ( ps /\ ( ch /\ th ) ) ) -> th ) $=
    ( wa simpr ad2antll ) CDEDABCDFG $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-4l $p |- ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta ) -> ph ) $=
    ( wa simplll adantr ) ABFCFDFAEABCDGH $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-4r $p |- ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta ) -> ps ) $=
    ( wa simpllr adantr ) ABFCFDFBEABCDGH $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-5l $p |- ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) -> ph ) $=
    ( wa simp-4l adantr ) ABGCGDGEGAFABCDEHI $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-5r $p |- ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) -> ps ) $=
    ( wa simp-4r adantr ) ABGCGDGEGBFABCDEHI $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-6l $p |- ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) -> ph ) $=
    ( wa simp-5l adantr ) ABHCHDHEHFHAGABCDEFIJ $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-6r $p |- ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) -> ps ) $=
    ( wa simp-5r adantr ) ABHCHDHEHFHBGABCDEFIJ $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-7l $p |- ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) -> ph ) $=
    ( wa simp-6l adantr ) ABICIDIEIFIGIAHABCDEFGJK $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-7r $p |- ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) -> ps ) $=
    ( wa simp-6r adantr ) ABICIDIEIFIGIBHABCDEFGJK $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-8l $p |- ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) -> ph ) $=
    ( wa simp-7l adantr ) ABJCJDJEJFJGJHJAIABCDEFGHKL $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-8r $p |- ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) -> ps ) $=
    ( wa simp-7r adantr ) ABJCJDJEJFJGJHJBIABCDEFGHKL $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-9l $p |- ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) -> ph ) $=
    ( wa simp-8l adantr ) ABKCKDKEKFKGKHKIKAJABCDEFGHILM $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-9r $p |- ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) -> ps ) $=
    ( wa simp-8r adantr ) ABKCKDKEKFKGKHKIKBJABCDEFGHILM $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-10l $p |- ( ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) -> ph ) $=
    ( wa simp-9l adantr ) ABLCLDLELFLGLHLILJLAKABCDEFGHIJMN $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-10r $p |- ( ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) -> ps ) $=
    ( wa simp-9r adantr ) ABLCLDLELFLGLHLILJLBKABCDEFGHIJMN $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-11l $p |- ( ( ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) /\ ka ) -> ph ) $=
    ( wa simp-10l adantr ) ABMCMDMEMFMGMHMIMJMKMALABCDEFGHIJKNO $.

  $( Simplification of a conjunction.  (Contributed by Mario Carneiro,
     4-Jan-2017.) $)
  simp-11r $p |- ( ( ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta )
    /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) /\ ka ) -> ps ) $=
    ( wa simp-10r adantr ) ABMCMDMEMFMGMHMIMJMKMBLABCDEFGHIJKNO $.

  $( Disjunction of antecedents.  Compare Theorem *4.77 of [WhiteheadRussell]
     p. 121.  (Contributed by NM, 30-May-1994.)  (Proof shortened by Wolf
     Lammen, 9-Dec-2012.) $)
  jaob $p |- ( ( ( ph \/ ch ) -> ps ) <-> ( ( ph -> ps ) /\ ( ch -> ps ) ) ) $=
    ( wo wi wa pm2.67-2 olc imim1i jca pm3.44 impbii ) ACDZBEZABEZCBEZFNOPABCGC
    MBCAHIJBACKL $.

  ${
    jaoian.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    jaoian.2 $e |- ( ( th /\ ps ) -> ch ) $.
    $( Inference disjoining the antecedents of two implications.  (Contributed
       by NM, 23-Oct-2005.) $)
    jaoian $p |- ( ( ( ph \/ th ) /\ ps ) -> ch ) $=
      ( wo wi ex jaoi imp ) ADGBCABCHDABCEIDBCFIJK $.
  $}

  ${
    jaodan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    jaodan.2 $e |- ( ( ph /\ th ) -> ch ) $.
    $( Deduction disjoining the antecedents of two implications.  (Contributed
       by NM, 14-Oct-2005.) $)
    jaodan $p |- ( ( ph /\ ( ps \/ th ) ) -> ch ) $=
      ( wo ex jaod imp ) ABDGCABCDABCEHADCFHIJ $.

    jaodan.3 $e |- ( ph -> ( ps \/ th ) ) $.
    $( Eliminate a disjunction in a deduction.  A translation of natural
       deduction rule ` \/ ` E ( ` \/ ` elimination), see ~ natded .
       (Contributed by Mario Carneiro, 29-May-2016.) $)
    mpjaodan $p |- ( ph -> ch ) $=
      ( wo jaodan mpdan ) ABDHCGABCDEFIJ $.
  $}

  $( Theorem *4.77 of [WhiteheadRussell] p. 121.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.77 $p |- ( ( ( ps -> ph ) /\ ( ch -> ph ) ) <->
                ( ( ps \/ ch ) -> ph ) ) $=
    ( wo wi wa jaob bicomi ) BCDAEBAECAEFBACGH $.

  $( Theorem *2.63 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.63 $p |- ( ( ph \/ ps ) -> ( ( -. ph \/ ps ) -> ps ) ) $=
    ( wo wn pm2.53 idd jaod ) ABCZADBBABEHBFG $.

  $( Theorem *2.64 of [WhiteheadRussell] p. 107.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.64 $p |- ( ( ph \/ ps ) -> ( ( ph \/ -. ps ) -> ph ) ) $=
    ( wn wo wi ax-1 orel2 jaoi com12 ) ABCZDABDZAAKAEJAKFBAGHI $.

  ${
    pm2.61ian.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    pm2.61ian.2 $e |- ( ( -. ph /\ ps ) -> ch ) $.
    $( Elimination of an antecedent.  (Contributed by NM, 1-Jan-2005.) $)
    pm2.61ian $p |- ( ps -> ch ) $=
      ( wi ex wn pm2.61i ) ABCFABCDGAHBCEGI $.
  $}

  ${
    pm2.61dan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    pm2.61dan.2 $e |- ( ( ph /\ -. ps ) -> ch ) $.
    $( Elimination of an antecedent.  (Contributed by NM, 1-Jan-2005.) $)
    pm2.61dan $p |- ( ph -> ch ) $=
      ( ex wn pm2.61d ) ABCABCDFABGCEFH $.
  $}

  ${
    pm2.61ddan.1 $e |- ( ( ph /\ ps ) -> th ) $.
    pm2.61ddan.2 $e |- ( ( ph /\ ch ) -> th ) $.
    pm2.61ddan.3 $e |- ( ( ph /\ ( -. ps /\ -. ch ) ) -> th ) $.
    $( Elimination of two antecedents.  (Contributed by NM, 9-Jul-2013.) $)
    pm2.61ddan $p |- ( ph -> th ) $=
      ( wn wa adantlr anassrs pm2.61dan ) ABDEABHZICDACDMFJAMCHDGKLL $.
  $}

  ${
    pm2.61dda.1 $e |- ( ( ph /\ -. ps ) -> th ) $.
    pm2.61dda.2 $e |- ( ( ph /\ -. ch ) -> th ) $.
    pm2.61dda.3 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Elimination of two antecedents.  (Contributed by NM, 9-Jul-2013.) $)
    pm2.61dda $p |- ( ph -> th ) $=
      ( wa anassrs wn adantlr pm2.61dan ) ABDABHCDABCDGIACJDBFKLEL $.
  $}

  ${
    condan.1 $e |- ( ( ph /\ -. ps ) -> ch ) $.
    condan.2 $e |- ( ( ph /\ -. ps ) -> -. ch ) $.
    $( Proof by contradiction.  (Contributed by NM, 9-Feb-2006.)  (Proof
       shortened by Wolf Lammen, 19-Jun-2014.) $)
    condan $p |- ( ph -> ps ) $=
      ( wn pm2.65da notnotrd ) ABABFCDEGH $.
  $}

  $( Introduce one conjunct as an antecedent to the other.  "abai" stands for
     "and, biconditional, and, implication".  (Contributed by NM,
     12-Aug-1993.)  (Proof shortened by Wolf Lammen, 7-Dec-2012.) $)
  abai $p |- ( ( ph /\ ps ) <-> ( ph /\ ( ph -> ps ) ) ) $=
    ( wi biimt pm5.32i ) ABABCABDE $.

  $( Theorem *5.53 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.53 $p |- ( ( ( ( ph \/ ps ) \/ ch ) -> th ) <->
                ( ( ( ph -> th ) /\ ( ps -> th ) ) /\ ( ch -> th ) ) ) $=
    ( wo wi wa jaob anbi1i bitri ) ABEZCEDFKDFZCDFZGADFBDFGZMGKDCHLNMADBHIJ $.

  $( Swap two conjuncts.  Note that the first digit (1) in the label refers to
     the outer conjunct position, and the next digit (2) to the inner conjunct
     position.  (Contributed by NM, 12-Mar-1995.) $)
  an12 $p |- ( ( ph /\ ( ps /\ ch ) ) <-> ( ps /\ ( ph /\ ch ) ) ) $=
    ( wa ancom anbi1i anass 3bitr3i ) ABDZCDBADZCDABCDDBACDDIJCABEFABCGBACGH $.

  $( A rearrangement of conjuncts.  (Contributed by NM, 12-Mar-1995.)  (Proof
     shortened by Wolf Lammen, 25-Dec-2012.) $)
  an32 $p |- ( ( ( ph /\ ps ) /\ ch ) <-> ( ( ph /\ ch ) /\ ps ) ) $=
    ( wa anass an12 ancom 3bitri ) ABDCDABCDDBACDZDIBDABCEABCFBIGH $.

  $( A rearrangement of conjuncts.  (Contributed by NM, 24-Jun-2012.)  (Proof
     shortened by Wolf Lammen, 31-Dec-2012.) $)
  an13 $p |- ( ( ph /\ ( ps /\ ch ) ) <-> ( ch /\ ( ps /\ ph ) ) ) $=
    ( wa an12 anass ancom 3bitr2i ) ABCDDBACDDBADZCDCIDABCEBACFICGH $.

  $( A rearrangement of conjuncts.  (Contributed by NM, 24-Jun-2012.)  (Proof
     shortened by Wolf Lammen, 31-Dec-2012.) $)
  an31 $p |- ( ( ( ph /\ ps ) /\ ch ) <-> ( ( ch /\ ps ) /\ ph ) ) $=
    ( wa an13 anass 3bitr4i ) ABCDDCBADDABDCDCBDADABCEABCFCBAFG $.

  ${
    an12s.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Swap two conjuncts in antecedent.  The label suffix "s" means that
       ~ an12 is combined with ~ syl (or a variant).  (Contributed by NM,
       13-Mar-1996.) $)
    an12s $p |- ( ( ps /\ ( ph /\ ch ) ) -> th ) $=
      ( wa an12 sylbi ) BACFFABCFFDBACGEH $.

    $( Inference commuting a nested conjunction in antecedent.  (Contributed by
       NM, 24-May-2006.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    ancom2s $p |- ( ( ph /\ ( ch /\ ps ) ) -> th ) $=
      ( wa pm3.22 sylan2 ) CBFABCFDCBGEH $.

    $( Swap two conjuncts in antecedent.  (Contributed by NM, 31-May-2006.) $)
    an13s $p |- ( ( ch /\ ( ps /\ ph ) ) -> th ) $=
      ( exp32 com13 imp32 ) CBADABCDABCDEFGH $.
  $}

  ${
    an32s.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Swap two conjuncts in antecedent.  (Contributed by NM, 13-Mar-1996.) $)
    an32s $p |- ( ( ( ph /\ ch ) /\ ps ) -> th ) $=
      ( wa an32 sylbi ) ACFBFABFCFDACBGEH $.

    $( Inference commuting a nested conjunction in antecedent.  (Contributed by
       NM, 24-May-2006.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    ancom1s $p |- ( ( ( ps /\ ph ) /\ ch ) -> th ) $=
      ( wa pm3.22 sylan ) BAFABFCDBAGEH $.

    $( Swap two conjuncts in antecedent.  (Contributed by NM, 31-May-2006.) $)
    an31s $p |- ( ( ( ch /\ ps ) /\ ph ) -> th ) $=
      ( exp31 com13 imp31 ) CBADABCDABCDEFGH $.
  $}

  ${
    anass1rs.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Commutative-associative law for conjunction in an antecedent.
       (Contributed by Jeff Madsen, 19-Jun-2011.) $)
    anass1rs $p |- ( ( ( ph /\ ch ) /\ ps ) -> th ) $=
      ( anassrs an32s ) ABCDABCDEFG $.
  $}

  $( Absorption into embedded conjunct.  (Contributed by NM, 4-Sep-1995.)
     (Proof shortened by Wolf Lammen, 16-Nov-2013.) $)
  anabs1 $p |- ( ( ( ph /\ ps ) /\ ph ) <-> ( ph /\ ps ) ) $=
    ( wa simpl pm4.71i bicomi ) ABCZGACGAABDEF $.

  $( Absorption into embedded conjunct.  (Contributed by NM, 20-Jul-1996.)
     (Proof shortened by Wolf Lammen, 9-Dec-2012.) $)
  anabs5 $p |- ( ( ph /\ ( ph /\ ps ) ) <-> ( ph /\ ps ) ) $=
    ( wa ibar bicomd pm5.32i ) AABCZBABGABDEF $.

  $( Absorption into embedded conjunct.  (Contributed by NM, 20-Jul-1996.)
     (Proof shortened by Wolf Lammen, 17-Nov-2013.) $)
  anabs7 $p |- ( ( ps /\ ( ph /\ ps ) ) <-> ( ph /\ ps ) ) $=
    ( wa simpr pm4.71ri bicomi ) ABCZBGCGBABDEF $.

  ${
    anabsan.1 $e |- ( ( ( ph /\ ph ) /\ ps ) -> ch ) $.
    $( Absorption of antecedent with conjunction.  (Contributed by NM,
       24-Mar-1996.) $)
    anabsan $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa pm4.24 sylanb ) AAAEBCAFDG $.
  $}

  ${
    anabss1.1 $e |- ( ( ( ph /\ ps ) /\ ph ) -> ch ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       20-Jul-1996.)  (Proof shortened by Wolf Lammen, 31-Dec-2012.) $)
    anabss1 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( an32s anabsan ) ABCABACDEF $.
  $}

  ${
    anabss4.1 $e |- ( ( ( ps /\ ph ) /\ ps ) -> ch ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       20-Jul-1996.) $)
    anabss4 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( anabss1 ancoms ) BACBACDEF $.
  $}

  ${
    anabss5.1 $e |- ( ( ph /\ ( ph /\ ps ) ) -> ch ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       10-May-1994.)  (Proof shortened by Wolf Lammen, 1-Jan-2013.) $)
    anabss5 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( anassrs anabsan ) ABCAABCDEF $.
  $}

  ${
    anabsi5.1 $e |- ( ph -> ( ( ph /\ ps ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       11-Jun-1995.)  (Proof shortened by Wolf Lammen, 18-Nov-2013.) $)
    anabsi5 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa imp anabss5 ) ABCAABECDFG $.
  $}

  ${
    anabsi6.1 $e |- ( ph -> ( ( ps /\ ph ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       14-Aug-2000.) $)
    anabsi6 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( ancomsd anabsi5 ) ABCABACDEF $.
  $}

  ${
    anabsi7.1 $e |- ( ps -> ( ( ph /\ ps ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       20-Jul-1996.)  (Proof shortened by Wolf Lammen, 18-Nov-2013.) $)
    anabsi7 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( anabsi6 ancoms ) BACBACDEF $.
  $}

  ${
    anabsi8.1 $e |- ( ps -> ( ( ps /\ ph ) -> ch ) ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       26-Sep-1999.) $)
    anabsi8 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( anabsi5 ancoms ) BACBACDEF $.
  $}

  ${
    anabss7.1 $e |- ( ( ps /\ ( ph /\ ps ) ) -> ch ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       20-Jul-1996.)  (Proof shortened by Wolf Lammen, 19-Nov-2013.) $)
    anabss7 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( anassrs anabss4 ) ABCBABCDEF $.
  $}

  ${
    anabsan2.1 $e |- ( ( ph /\ ( ps /\ ps ) ) -> ch ) $.
    $( Absorption of antecedent with conjunction.  (Contributed by NM,
       10-May-2004.) $)
    anabsan2 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( an12s anabss7 ) ABCABBCDEF $.
  $}

  ${
    anabss3.1 $e |- ( ( ( ph /\ ps ) /\ ps ) -> ch ) $.
    $( Absorption of antecedent into conjunction.  (Contributed by NM,
       20-Jul-1996.)  (Proof shortened by Wolf Lammen, 1-Jan-2013.) $)
    anabss3 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( anasss anabsan2 ) ABCABBCDEF $.
  $}

  $( Rearrangement of 4 conjuncts.  (Contributed by NM, 10-Jul-1994.) $)
  an4 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
              ( ( ph /\ ch ) /\ ( ps /\ th ) ) ) $=
    ( wa an12 anbi2i anass 3bitr4i ) ABCDEZEZEACBDEZEZEABEJEACELEKMABCDFGABJHAC
    LHI $.

  $( Rearrangement of 4 conjuncts.  (Contributed by NM, 7-Feb-1996.) $)
  an42 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
                 ( ( ph /\ ch ) /\ ( th /\ ps ) ) ) $=
    ( wa an4 ancom anbi2i bitri ) ABECDEEACEZBDEZEJDBEZEABCDFKLJBDGHI $.

  ${
    an4s.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( Inference rearranging 4 conjuncts in antecedent.  (Contributed by NM,
       10-Aug-1995.) $)
    an4s $p |- ( ( ( ph /\ ch ) /\ ( ps /\ th ) ) -> ta ) $=
      ( wa an4 sylbi ) ACGBDGGABGCDGGEACBDHFI $.
  $}

  ${
    an41r3s.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $.
    $( Inference rearranging 4 conjuncts in antecedent.  (Contributed by NM,
       10-Aug-1995.) $)
    an42s $p |- ( ( ( ph /\ ch ) /\ ( th /\ ps ) ) -> ta ) $=
      ( wa an4s ancom2s ) ACGBDEABCDEFHI $.
  $}

  $( Distribution of conjunction over conjunction.  (Contributed by NM,
     14-Aug-1995.) $)
  anandi $p |- ( ( ph /\ ( ps /\ ch ) ) <->
               ( ( ph /\ ps ) /\ ( ph /\ ch ) ) ) $=
    ( wa anidm anbi1i an4 bitr3i ) ABCDZDAADZIDABDACDDJAIAEFAABCGH $.

  $( Distribution of conjunction over conjunction.  (Contributed by NM,
     24-Aug-1995.) $)
  anandir $p |- ( ( ( ph /\ ps ) /\ ch ) <->
               ( ( ph /\ ch ) /\ ( ps /\ ch ) ) ) $=
    ( wa anidm anbi2i an4 bitr3i ) ABDZCDICCDZDACDBCDDJCICEFABCCGH $.

  ${
    anandis.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) ) -> ta ) $.
    $( Inference that undistributes conjunction in the antecedent.
       (Contributed by NM, 7-Jun-2004.) $)
    anandis $p |- ( ( ph /\ ( ps /\ ch ) ) -> ta ) $=
      ( wa an4s anabsan ) ABCFDABACDEGH $.
  $}

  ${
    anandirs.1 $e |- ( ( ( ph /\ ch ) /\ ( ps /\ ch ) ) -> ta ) $.
    $( Inference that undistributes conjunction in the antecedent.
       (Contributed by NM, 7-Jun-2004.) $)
    anandirs $p |- ( ( ( ph /\ ps ) /\ ch ) -> ta ) $=
      ( wa an4s anabsan2 ) ABFCDACBCDEGH $.
  $}

  ${
    impbida.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    impbida.2 $e |- ( ( ph /\ ch ) -> ps ) $.
    $( Deduce an equivalence from two implications.  (Contributed by NM,
       17-Feb-2007.) $)
    impbida $p |- ( ph -> ( ps <-> ch ) ) $=
      ( ex impbid ) ABCABCDFACBEFG $.
  $}

  $( Theorem *3.48 of [WhiteheadRussell] p. 114.  (Contributed by NM,
     28-Jan-1997.) $)
  pm3.48 $p |- ( ( ( ph -> ps ) /\ ( ch -> th ) )
      -> ( ( ph \/ ch ) -> ( ps \/ th ) ) ) $=
    ( wi wo orc imim2i olc jaao ) ABEABDFZCDECBKABDGHDKCDBIHJ $.

  $( Theorem *3.45 (Fact) of [WhiteheadRussell] p. 113.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.45 $p |- ( ( ph -> ps ) -> ( ( ph /\ ch ) -> ( ps /\ ch ) ) ) $=
    ( wi id anim1d ) ABDZABCGEF $.

  ${
    im2an9.1 $e |- ( ph -> ( ps -> ch ) ) $.
    im2an9.2 $e |- ( th -> ( ta -> et ) ) $.
    $( Deduction joining nested implications to form implication of
       conjunctions.  (Contributed by NM, 29-Feb-1996.) $)
    im2anan9 $p |- ( ( ph /\ th ) -> ( ( ps /\ ta ) -> ( ch /\ et ) ) ) $=
      ( wa wi adantr adantl anim12d ) ADIBCEFABCJDGKDEFJAHLM $.

    $( Deduction joining nested implications to form implication of
       conjunctions.  (Contributed by NM, 29-Feb-1996.) $)
    im2anan9r $p |- ( ( th /\ ph ) -> ( ( ps /\ ta ) -> ( ch /\ et ) ) ) $=
      ( wa wi im2anan9 ancoms ) ADBEICFIJABCDEFGHKL $.
  $}

  ${
    anim12dan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    anim12dan.2 $e |- ( ( ph /\ th ) -> ta ) $.
    $( Conjoin antecedents and consequents in a deduction.  (Contributed by
       Mario Carneiro, 12-May-2014.) $)
    anim12dan $p |- ( ( ph /\ ( ps /\ th ) ) -> ( ch /\ ta ) ) $=
      ( wa ex anim12d imp ) ABDHCEHABCDEABCFIADEGIJK $.
  $}

  ${
    orim12d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    orim12d.2 $e |- ( ph -> ( th -> ta ) ) $.
    $( Disjoin antecedents and consequents in a deduction.  (Contributed by NM,
       10-May-1994.) $)
    orim12d $p |- ( ph -> ( ( ps \/ th ) -> ( ch \/ ta ) ) ) $=
      ( wi wo pm3.48 syl2anc ) ABCHDEHBDICEIHFGBCDEJK $.
  $}

  ${
    orim1d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Disjoin antecedents and consequents in a deduction.  (Contributed by NM,
       23-Apr-1995.) $)
    orim1d $p |- ( ph -> ( ( ps \/ th ) -> ( ch \/ th ) ) ) $=
      ( idd orim12d ) ABCDDEADFG $.

    $( Disjoin antecedents and consequents in a deduction.  (Contributed by NM,
       23-Apr-1995.) $)
    orim2d $p |- ( ph -> ( ( th \/ ps ) -> ( th \/ ch ) ) ) $=
      ( idd orim12d ) ADDBCADFEG $.
  $}

  $( Axiom *1.6 (Sum) of [WhiteheadRussell] p. 97.  (Contributed by NM,
     3-Jan-2005.) $)
  orim2 $p |- ( ( ps -> ch ) -> ( ( ph \/ ps ) -> ( ph \/ ch ) ) ) $=
    ( wi id orim2d ) BCDZBCAGEF $.

  $( Theorem *2.38 of [WhiteheadRussell] p. 105.  (Contributed by NM,
     6-Mar-2008.) $)
  pm2.38 $p |- ( ( ps -> ch ) -> ( ( ps \/ ph ) -> ( ch \/ ph ) ) ) $=
    ( wi id orim1d ) BCDZBCAGEF $.

  $( Theorem *2.36 of [WhiteheadRussell] p. 105.  (Contributed by NM,
     6-Mar-2008.) $)
  pm2.36 $p |- ( ( ps -> ch ) -> ( ( ph \/ ps ) -> ( ch \/ ph ) ) ) $=
    ( wo wi pm1.4 pm2.38 syl5 ) ABDBADBCECADABFABCGH $.

  $( Theorem *2.37 of [WhiteheadRussell] p. 105.  (Contributed by NM,
     6-Mar-2008.) $)
  pm2.37 $p |- ( ( ps -> ch ) -> ( ( ps \/ ph ) -> ( ph \/ ch ) ) ) $=
    ( wi wo pm2.38 pm1.4 syl6 ) BCDBAECAEACEABCFCAGH $.

  $( Theorem *2.73 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.73 $p |- ( ( ph -> ps )
       -> ( ( ( ph \/ ps ) \/ ch ) -> ( ps \/ ch ) ) ) $=
    ( wi wo pm2.621 orim1d ) ABDABEBCABFG $.

  $( Theorem *2.74 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Andrew Salmon, 7-May-2011.) $)
  pm2.74 $p |- ( ( ps -> ph )
      -> ( ( ( ph \/ ps ) \/ ch ) -> ( ph \/ ch ) ) ) $=
    ( wi wo orel2 ax-1 ja orim1d ) BADABEZACBAJADBAFAJGHI $.

  $( Disjunction distributes over implication.  (Contributed by Wolf Lammen,
     5-Jan-2013.) $)
  orimdi $p |- ( ( ph \/ ( ps -> ch ) )
        <-> ( ( ph \/ ps ) -> ( ph \/ ch ) ) ) $=
    ( wn wi wo imdi df-or imbi12i 3bitr4i ) ADZBCEZEKBEZKCEZEALFABFZACFZEKBCGAL
    HOMPNABHACHIJ $.

  $( Theorem *2.76 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.76 $p |- ( ( ph \/ ( ps -> ch ) )
      -> ( ( ph \/ ps ) -> ( ph \/ ch ) ) ) $=
    ( wi wo orimdi biimpi ) ABCDEABEACEDABCFG $.

  $( Theorem *2.75 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 4-Jan-2013.) $)
  pm2.75 $p |- ( ( ph \/ ps )
       -> ( ( ph \/ ( ps -> ch ) ) -> ( ph \/ ch ) ) ) $=
    ( wi wo pm2.76 com12 ) ABCDEABEACEABCFG $.

  $( Theorem *2.8 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 5-Jan-2013.) $)
  pm2.8 $p |- ( ( ph \/ ps ) -> ( ( -. ps \/ ch ) -> ( ph \/ ch ) ) ) $=
    ( wo wn pm2.53 con1d orim1d ) ABDZBEACIABABFGH $.

  $( Theorem *2.81 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.81 $p |- ( ( ps -> ( ch -> th ) )
      -> ( ( ph \/ ps ) -> ( ( ph \/ ch ) -> ( ph \/ th ) ) ) ) $=
    ( wi wo orim2 pm2.76 syl6 ) BCDEZEABFAJFACFADFEABJGACDHI $.

  $( Theorem *2.82 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.) $)
  pm2.82 $p |- ( ( ( ph \/ ps ) \/ ch ) -> ( ( ( ph \/ -. ch ) \/ th )
      -> ( ( ph \/ ps ) \/ th ) ) ) $=
    ( wo wn wi ax-1 pm2.24 orim2d jaoi orim1d ) ABEZCEACFZEZMDMOMGCMOHCNBACBIJK
    L $.

  $( Theorem *2.85 of [WhiteheadRussell] p. 108.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 5-Jan-2013.) $)
  pm2.85 $p |- ( ( ( ph \/ ps ) -> ( ph \/ ch ) )
      -> ( ph \/ ( ps -> ch ) ) ) $=
    ( wi wo orimdi biimpri ) ABCDEABEACEDABCFG $.

  ${
    pm3.2ni.1 $e |- -. ph $.
    pm3.2ni.2 $e |- -. ps $.
    $( Infer negated disjunction of negated premises.  (Contributed by NM,
       4-Apr-1995.) $)
    pm3.2ni $p |- -. ( ph \/ ps ) $=
      ( wo id pm2.21i jaoi mto ) ABEACAABAFBADGHI $.
  $}

  $( Absorption of redundant internal disjunct.  Compare Theorem *4.45 of
     [WhiteheadRussell] p. 119.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 28-Feb-2014.) $)
  orabs $p |- ( ph <-> ( ( ph \/ ps ) /\ ph ) ) $=
    ( wo orc pm4.71ri ) AABCABDE $.

  $( Absorb a disjunct into a conjunct.  (Contributed by Roy F. Longton,
     23-Jun-2005.)  (Proof shortened by Wolf Lammen, 10-Nov-2013.) $)
  oranabs $p |- ( ( ( ph \/ -. ps ) /\ ps ) <-> ( ph /\ ps ) ) $=
    ( wn wo biortn orcom syl6rbb pm5.32ri ) BABCZDZABAIADJBAEIAFGH $.

  $( Two propositions are equivalent if they are both true.  Theorem *5.1 of
     [WhiteheadRussell] p. 123.  (Contributed by NM, 21-May-1994.) $)
  pm5.1 $p |- ( ( ph /\ ps ) -> ( ph <-> ps ) ) $=
    ( wb pm5.501 biimpa ) ABABCABDE $.

  $( Two propositions are equivalent if they are both false.  Theorem *5.21 of
     [WhiteheadRussell] p. 124.  (Contributed by NM, 21-May-1994.) $)
  pm5.21 $p |- ( ( -. ph /\ -. ps ) -> ( ph <-> ps ) ) $=
    ( wn wb pm5.21im imp ) ACBCABDABEF $.

  $( Theorem *3.43 (Comp) of [WhiteheadRussell] p. 113.  (Contributed by NM,
     3-Jan-2005.) $)
  pm3.43 $p |- ( ( ( ph -> ps ) /\ ( ph -> ch ) )
      -> ( ph -> ( ps /\ ch ) ) ) $=
    ( wi wa pm3.43i imp ) ABDACDABCEDABCFG $.

  $( Distributive law for implication over conjunction.  Compare Theorem *4.76
     of [WhiteheadRussell] p. 121.  (Contributed by NM, 3-Apr-1994.)  (Proof
     shortened by Wolf Lammen, 27-Nov-2013.) $)
  jcab $p |- ( ( ph -> ( ps /\ ch ) )
      <-> ( ( ph -> ps ) /\ ( ph -> ch ) ) ) $=
    ( wa wi simpl imim2i simpr jca pm3.43 impbii ) ABCDZEZABEZACEZDMNOLBABCFGLC
    ABCHGIABCJK $.

  $( Distributive law for disjunction.  Theorem *4.41 of [WhiteheadRussell]
     p. 119.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
     Salmon, 7-May-2011.)  (Proof shortened by Wolf Lammen, 28-Nov-2013.) $)
  ordi $p |- ( ( ph \/ ( ps /\ ch ) ) <-> ( ( ph \/ ps ) /\ ( ph \/ ch ) ) ) $=
    ( wn wa wi wo jcab df-or anbi12i 3bitr4i ) ADZBCEZFLBFZLCFZEAMGABGZACGZELBC
    HAMIPNQOABIACIJK $.

  $( Distributive law for disjunction.  (Contributed by NM, 12-Aug-1994.) $)
  ordir $p |- ( ( ( ph /\ ps ) \/ ch ) <->
              ( ( ph \/ ch ) /\ ( ps \/ ch ) ) ) $=
    ( wa wo ordi orcom anbi12i 3bitr4i ) CABDZECAEZCBEZDJCEACEZBCEZDCABFJCGMKNL
    ACGBCGHI $.

  $( Theorem *4.76 of [WhiteheadRussell] p. 121.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.76 $p |- ( ( ( ph -> ps ) /\ ( ph -> ch ) ) <->
                ( ph -> ( ps /\ ch ) ) ) $=
    ( wa wi jcab bicomi ) ABCDEABEACEDABCFG $.

  $( Distributive law for conjunction.  Theorem *4.4 of [WhiteheadRussell]
     p. 118.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf
     Lammen, 5-Jan-2013.) $)
  andi $p |- ( ( ph /\ ( ps \/ ch ) ) <-> ( ( ph /\ ps ) \/ ( ph /\ ch ) ) ) $=
    ( wo wa orc olc jaodan anim2i jaoi impbii ) ABCDZEZABEZACEZDZABPCNOFONGHNMO
    BLABCFICLACBGIJK $.

  $( Distributive law for conjunction.  (Contributed by NM, 12-Aug-1994.) $)
  andir $p |- ( ( ( ph \/ ps ) /\ ch ) <->
              ( ( ph /\ ch ) \/ ( ps /\ ch ) ) ) $=
    ( wo wa andi ancom orbi12i 3bitr4i ) CABDZECAEZCBEZDJCEACEZBCEZDCABFJCGMKNL
    ACGBCGHI $.

  $( Double distributive law for disjunction.  (Contributed by NM,
     12-Aug-1994.) $)
  orddi $p |- ( ( ( ph /\ ps ) \/ ( ch /\ th ) ) <->
              ( ( ( ph \/ ch ) /\ ( ph \/ th ) ) /\
              ( ( ps \/ ch ) /\ ( ps \/ th ) ) ) ) $=
    ( wa wo ordir ordi anbi12i bitri ) ABECDEZFAKFZBKFZEACFADFEZBCFBDFEZEABKGLN
    MOACDHBCDHIJ $.

  $( Double distributive law for conjunction.  (Contributed by NM,
     12-Aug-1994.) $)
  anddi $p |- ( ( ( ph \/ ps ) /\ ( ch \/ th ) ) <->
              ( ( ( ph /\ ch ) \/ ( ph /\ th ) ) \/
              ( ( ps /\ ch ) \/ ( ps /\ th ) ) ) ) $=
    ( wo wa andir andi orbi12i bitri ) ABECDEZFAKFZBKFZEACFADFEZBCFBDFEZEABKGLN
    MOACDHBCDHIJ $.

  $( Prove formula-building rules for the biconditional connective. $)

  $( Theorem *4.39 of [WhiteheadRussell] p. 118.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.39 $p |- ( ( ( ph <-> ch ) /\ ( ps <-> th ) ) ->
                ( ( ph \/ ps ) <-> ( ch \/ th ) ) ) $=
    ( wb wa simpl simpr orbi12d ) ACEZBDEZFACBDJKGJKHI $.

  $( Theorem *4.38 of [WhiteheadRussell] p. 118.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.38 $p |- ( ( ( ph <-> ch ) /\ ( ps <-> th ) ) ->
                ( ( ph /\ ps ) <-> ( ch /\ th ) ) ) $=
    ( wb wa simpl simpr anbi12d ) ACEZBDEZFACBDJKGJKHI $.

  ${
    bi2an9.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bi2an9.2 $e |- ( th -> ( ta <-> et ) ) $.
    $( Deduction joining two equivalences to form equivalence of conjunctions.
       (Contributed by NM, 31-Jul-1995.) $)
    bi2anan9 $p |- ( ( ph /\ th ) -> ( ( ps /\ ta ) <-> ( ch /\ et ) ) ) $=
      ( wa anbi1d anbi2d sylan9bb ) ABEICEIDCFIABCEGJDEFCHKL $.

    $( Deduction joining two equivalences to form equivalence of conjunctions.
       (Contributed by NM, 19-Feb-1996.) $)
    bi2anan9r $p |- ( ( th /\ ph ) -> ( ( ps /\ ta ) <-> ( ch /\ et ) ) ) $=
      ( wa wb bi2anan9 ancoms ) ADBEICFIJABCDEFGHKL $.

    $( Deduction joining two biconditionals with different antecedents.
       (Contributed by NM, 12-May-2004.) $)
    bi2bian9 $p |- ( ( ph /\ th ) -> ( ( ps <-> ta ) <-> ( ch <-> et ) ) ) $=
      ( wa wb adantr adantl bibi12d ) ADIBCEFABCJDGKDEFJAHLM $.
  $}

  $( Implication in terms of biconditional and disjunction.  Theorem *4.72 of
     [WhiteheadRussell] p. 121.  (Contributed by NM, 30-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 30-Jan-2013.) $)
  pm4.72 $p |- ( ( ph -> ps ) <-> ( ps <-> ( ph \/ ps ) ) ) $=
    ( wi wo wb olc pm2.621 impbid2 orc bi2 syl5 impbii ) ABCZBABDZEZMBNBAFABGHA
    NOBABIBNJKL $.

  $( Simplify an implication between implications.  (Contributed by Paul
     Chapman, 17-Nov-2012.)  (Proof shortened by Wolf Lammen, 3-Apr-2013.) $)
  imimorb $p |- ( ( ( ps -> ch ) -> ( ph -> ch ) ) <->
                  ( ph -> ( ps \/ ch ) ) ) $=
    ( wi wo bi2.04 dfor2 imbi2i bitr4i ) BCDZACDDAJCDZDABCEZDJACFLKABCGHI $.

  $( Theorem *5.33 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.33 $p |- ( ( ph /\ ( ps -> ch ) ) <->
                ( ph /\ ( ( ph /\ ps ) -> ch ) ) ) $=
    ( wi wa ibar imbi1d pm5.32i ) ABCDABEZCDABICABFGH $.

  $( Theorem *5.36 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.36 $p |- ( ( ph /\ ( ph <-> ps ) ) <-> ( ps /\ ( ph <-> ps ) ) ) $=
    ( wb id pm5.32ri ) ABCZABFDE $.

  ${
    bianabs.1 $e |- ( ph -> ( ps <-> ( ph /\ ch ) ) ) $.
    $( Absorb a hypothesis into the second member of a biconditional.
       (Contributed by FL, 15-Feb-2007.) $)
    bianabs $p |- ( ph -> ( ps <-> ch ) ) $=
      ( wa ibar bitr4d ) ABACECDACFG $.
  $}

  $( Absorption of disjunction into equivalence.  (Contributed by NM,
     6-Aug-1995.)  (Proof shortened by Wolf Lammen, 3-Nov-2013.) $)
  oibabs $p |- ( ( ( ph \/ ps ) -> ( ph <-> ps ) ) <-> ( ph <-> ps ) ) $=
    ( wo wb wi wn wa ioran pm5.21 sylbi id ja ax-1 impbii ) ABCZABDZEPOPPOFAFBF
    GPABHABIJPKLPOMN $.

  $( Law of noncontradiction.  Theorem *3.24 of [WhiteheadRussell] p. 111 (who
     call it the "law of contradiction").  (Contributed by NM, 16-Sep-1993.)
     (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
  pm3.24 $p |- -. ( ph /\ -. ph ) $=
    ( wi wn wa id iman mpbi ) AABAACDCAEAAFG $.

  $( Theorem *2.26 of [WhiteheadRussell] p. 104.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 23-Nov-2012.) $)
  pm2.26 $p |- ( -. ph \/ ( ( ph -> ps ) -> ps ) ) $=
    ( wi pm2.27 imori ) AABCBCABDE $.

  $( Theorem *5.11 of [WhiteheadRussell] p. 123.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.11 $p |- ( ( ph -> ps ) \/ ( -. ph -> ps ) ) $=
    ( wi wn pm2.5 orri ) ABCADBCABEF $.

  $( Theorem *5.12 of [WhiteheadRussell] p. 123.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.12 $p |- ( ( ph -> ps ) \/ ( ph -> -. ps ) ) $=
    ( wi wn pm2.51 orri ) ABCABDCABEF $.

  $( Theorem *5.14 of [WhiteheadRussell] p. 123.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.14 $p |- ( ( ph -> ps ) \/ ( ps -> ch ) ) $=
    ( wi wn ax-1 con3i pm2.21d orri ) ABDZBCDJEBCBJBAFGHI $.

  $( Theorem *5.13 of [WhiteheadRussell] p. 123.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 14-Nov-2012.) $)
  pm5.13 $p |- ( ( ph -> ps ) \/ ( ps -> ph ) ) $=
    ( pm5.14 ) ABAC $.

  $( Theorem *5.17 of [WhiteheadRussell] p. 124.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 3-Jan-2013.) $)
  pm5.17 $p |- ( ( ( ph \/ ps ) /\ -. ( ph /\ ps ) ) <-> ( ph <-> -. ps ) ) $=
    ( wn wb wi wa wo bicom dfbi2 orcom df-or bitr2i imnan anbi12i 3bitrri ) ABC
    ZDPADPAEZAPEZFABGZABFCZFAPHPAIQSRTSBAGQABJBAKLABMNO $.

  $( Theorem *5.15 of [WhiteheadRussell] p. 124.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 15-Oct-2013.) $)
  pm5.15 $p |- ( ( ph <-> ps ) \/ ( ph <-> -. ps ) ) $=
    ( wb wn xor3 biimpi orri ) ABCZABDCZHDIABEFG $.

  $( Theorem *5.16 of [WhiteheadRussell] p. 124.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 17-Oct-2013.) $)
  pm5.16 $p |- -. ( ( ph <-> ps ) /\ ( ph <-> -. ps ) ) $=
    ( wb wn wi wa pm5.18 biimpi imnan mpbi ) ABCZABDCZDZEKLFDKMABGHKLIJ $.

  $( Two ways to express "exclusive or."  Theorem *5.22 of [WhiteheadRussell]
     p. 124.  (Contributed by NM, 3-Jan-2005.)  (Proof shortened by Wolf
     Lammen, 22-Jan-2013.) $)
  xor $p |- ( -. ( ph <-> ps ) <->
                ( ( ph /\ -. ps ) \/ ( ps /\ -. ph ) ) ) $=
    ( wn wa wo wb wi iman anbi12i dfbi2 ioran 3bitr4ri con1bii ) ABCDZBACDZEZAB
    FZABGZBAGZDNCZOCZDQPCRTSUAABHBAHIABJNOKLM $.

  $( Two ways to express "exclusive or."  (Contributed by NM, 3-Jan-2005.)
     (Proof shortened by Wolf Lammen, 24-Jan-2013.) $)
  nbi2 $p |- ( -. ( ph <-> ps ) <-> ( ( ph \/ ps ) /\ -. ( ph /\ ps ) ) ) $=
    ( wb wn wo wa xor3 pm5.17 bitr4i ) ABCDABDCABEABFDFABGABHI $.

  $( An alternate definition of the biconditional.  Theorem *5.23 of
     [WhiteheadRussell] p. 124.  (Contributed by NM, 27-Jun-2002.)  (Proof
     shortened by Wolf Lammen, 3-Nov-2013.) $)
  dfbi3 $p |- ( ( ph <-> ps ) <-> ( ( ph /\ ps ) \/ ( -. ph /\ -. ps ) ) ) $=
    ( wn wb wa wo xor pm5.18 notnot anbi2i ancom orbi12i 3bitr4i ) ABCZDCANCZEZ
    NACZEZFABDABEZQNEZFANGABHSPTRBOABIJQNKLM $.

  $( Theorem *5.24 of [WhiteheadRussell] p. 124.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.24 $p |- ( -. ( ( ph /\ ps ) \/ ( -. ph /\ -. ps ) ) <->
                ( ( ph /\ -. ps ) \/ ( ps /\ -. ph ) ) ) $=
    ( wb wn wa wo xor dfbi3 xchnxbi ) ABCABDZEBADZEFABEKJEFABGABHI $.

  $( Conjunction distributes over exclusive-or, using ` -. ( ph <-> ps ) ` to
     express exclusive-or.  This is one way to interpret the distributive law
     of multiplication over addition in modulo 2 arithmetic.  (Contributed by
     NM, 3-Oct-2008.) $)
  xordi $p |- ( ( ph /\ -. ( ps <-> ch ) ) <->
                -. ( ( ph /\ ps ) <-> ( ph /\ ch ) ) ) $=
    ( wb wn wa wi annim pm5.32 xchbinx ) ABCDZEFAKGABFACFDAKHABCIJ $.

  $( A wff disjoined with truth is true.  (Contributed by NM, 23-May-1999.) $)
  biort $p |- ( ph -> ( ph <-> ( ph \/ ps ) ) ) $=
    ( wo orc ax-1 impbid2 ) AAABCZABDAGEF $.

  $( Theorem *5.55 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 20-Jan-2013.) $)
  pm5.55 $p |- ( ( ( ph \/ ps ) <-> ph ) \/ ( ( ph \/ ps ) <-> ps ) ) $=
    ( wo wb biort bicomd wn biorf nsyl4 con1i orri ) ABCZADZLBDZNMAMNAALABEFAGB
    LABHFIJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Miscellaneous theorems of propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    pm5.21nd.1 $e |- ( ( ph /\ ps ) -> th ) $.
    pm5.21nd.2 $e |- ( ( ph /\ ch ) -> th ) $.
    pm5.21nd.3 $e |- ( th -> ( ps <-> ch ) ) $.
    $( Eliminate an antecedent implied by each side of a biconditional.
       (Contributed by NM, 20-Nov-2005.)  (Proof shortened by Wolf Lammen,
       4-Nov-2013.) $)
    pm5.21nd $p |- ( ph -> ( ps <-> ch ) ) $=
      ( ex wb wi a1i pm5.21ndd ) ADBCABDEHACDFHDBCIJAGKL $.
  $}

  $( Theorem *5.35 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.35 $p |- ( ( ( ph -> ps ) /\ ( ph -> ch ) ) ->
                ( ph -> ( ps <-> ch ) ) ) $=
    ( wi wa pm5.1 pm5.74rd ) ABDZACDZEABCHIFG $.

  $( Theorem *5.54 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 7-Nov-2013.) $)
  pm5.54 $p |- ( ( ( ph /\ ps ) <-> ph ) \/ ( ( ph /\ ps ) <-> ps ) ) $=
    ( wa wb iba bicomd adantl pm5.21ni orri ) ABCZADZJBDJKBBKABAJBAEFZGLHI $.

  ${
    baib.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Move conjunction outside of biconditional.  (Contributed by NM,
       13-May-1999.) $)
    baib $p |- ( ps -> ( ph <-> ch ) ) $=
      ( wa ibar syl6rbbr ) BCBCEABCFDG $.

    $( Move conjunction outside of biconditional.  (Contributed by NM,
       11-Jul-1994.) $)
    baibr $p |- ( ps -> ( ch <-> ph ) ) $=
      ( baib bicomd ) BACABCDEF $.

    $( Move conjunction outside of biconditional.  (Contributed by Mario
       Carneiro, 11-Sep-2015.) $)
    rbaib $p |- ( ch -> ( ph <-> ps ) ) $=
      ( wa ancom bitri baib ) ACBABCECBEDBCFGH $.

    $( Move conjunction outside of biconditional.  (Contributed by Mario
       Carneiro, 11-Sep-2015.) $)
    rbaibr $p |- ( ch -> ( ps <-> ph ) ) $=
      ( wa ancom bitri baibr ) ACBABCECBEDBCFGH $.
  $}

  ${
    baibd.1 $e |- ( ph -> ( ps <-> ( ch /\ th ) ) ) $.
    $( Move conjunction outside of biconditional.  (Contributed by Mario
       Carneiro, 11-Sep-2015.) $)
    baibd $p |- ( ( ph /\ ch ) -> ( ps <-> th ) ) $=
      ( wa ibar bicomd sylan9bb ) ABCDFZCDECDJCDGHI $.

    $( Move conjunction outside of biconditional.  (Contributed by Mario
       Carneiro, 11-Sep-2015.) $)
    rbaibd $p |- ( ( ph /\ th ) -> ( ps <-> ch ) ) $=
      ( wa iba bicomd sylan9bb ) ABCDFZDCEDCJDCGHI $.
  $}

  $( Theorem *5.44 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.) $)
  pm5.44 $p |- ( ( ph -> ps ) -> ( ( ph -> ch ) <->
                ( ph -> ( ps /\ ch ) ) ) ) $=
    ( wa wi jcab baibr ) ABCDEABEACEABCFG $.

  $( Conjunction in antecedent versus disjunction in consequent.  Theorem *5.6
     of [WhiteheadRussell] p. 125.  (Contributed by NM, 8-Jun-1994.) $)
  pm5.6 $p |- ( ( ( ph /\ -. ps ) -> ch ) <-> ( ph -> ( ps \/ ch ) ) ) $=
    ( wn wa wi wo impexp df-or imbi2i bitr4i ) ABDZECFALCFZFABCGZFALCHNMABCIJK
    $.

  ${
    orcanai.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    $( Change disjunction in consequent to conjunction in antecedent.
       (Contributed by NM, 8-Jun-1994.) $)
    orcanai $p |- ( ( ph /\ -. ps ) -> ch ) $=
      ( wn ord imp ) ABECABCDFG $.
  $}


  ${
    intnan.1 $e |- -. ph $.
    $( Introduction of conjunct inside of a contradiction.  (Contributed by NM,
       16-Sep-1993.) $)
    intnan $p |- -. ( ps /\ ph ) $=
      ( wa simpr mto ) BADACBAEF $.

    $( Introduction of conjunct inside of a contradiction.  (Contributed by NM,
       3-Apr-1995.) $)
    intnanr $p |- -. ( ph /\ ps ) $=
      ( wa simpl mto ) ABDACABEF $.
  $}

  ${
    intnand.1 $e |- ( ph -> -. ps ) $.
    $( Introduction of conjunct inside of a contradiction.  (Contributed by NM,
       10-Jul-2005.) $)
    intnand $p |- ( ph -> -. ( ch /\ ps ) ) $=
      ( wa simpr nsyl ) ABCBEDCBFG $.

    $( Introduction of conjunct inside of a contradiction.  (Contributed by NM,
       10-Jul-2005.) $)
    intnanrd $p |- ( ph -> -. ( ps /\ ch ) ) $=
      ( wa simpl nsyl ) ABBCEDBCFG $.
  $}

  ${
    mpbiran.1 $e |- ps $.
    mpbiran.2 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Detach truth from conjunction in biconditional.  (Contributed by NM,
       27-Feb-1996.) $)
    mpbiran $p |- ( ph <-> ch ) $=
      ( wa biantrur bitr4i ) ABCFCEBCDGH $.
  $}

  ${
    mpbiran2.1 $e |- ch $.
    mpbiran2.2 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Detach truth from conjunction in biconditional.  (Contributed by NM,
       22-Feb-1996.) $)
    mpbiran2 $p |- ( ph <-> ps ) $=
      ( wa biantru bitr4i ) ABCFBECBDGH $.
  $}

  ${
    mpbir2an.1 $e |- ps $.
    mpbir2an.2 $e |- ch $.
    mpbiran2an.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Detach a conjunction of truths in a biconditional.  (Contributed by NM,
       10-May-2005.) $)
    mpbir2an $p |- ph $=
      ( mpbiran mpbir ) ACEABCDFGH $.
  $}

  ${
    mpbi2and.1 $e |- ( ph -> ps ) $.
    mpbi2and.2 $e |- ( ph -> ch ) $.
    mpbi2and.3 $e |- ( ph -> ( ( ps /\ ch ) <-> th ) ) $.
    $( Detach a conjunction of truths in a biconditional.  (Contributed by NM,
       6-Nov-2011.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    mpbi2and $p |- ( ph -> th ) $=
      ( wa jca mpbid ) ABCHDABCEFIGJ $.
  $}

  ${
    mpbir2and.1 $e |- ( ph -> ch ) $.
    mpbir2and.2 $e |- ( ph -> th ) $.
    mpbir2and.3 $e |- ( ph -> ( ps <-> ( ch /\ th ) ) ) $.
    $( Detach a conjunction of truths in a biconditional.  (Contributed by NM,
       6-Nov-2011.)  (Proof shortened by Wolf Lammen, 24-Nov-2012.) $)
    mpbir2and $p |- ( ph -> ps ) $=
      ( wa jca mpbird ) ABCDHACDEFIGJ $.
  $}

  $( Theorem *5.62 of [WhiteheadRussell] p. 125.  (Contributed by Roy F.
     Longton, 21-Jun-2005.) $)
  pm5.62 $p |- ( ( ( ph /\ ps ) \/ -. ps ) <-> ( ph \/ -. ps ) ) $=
    ( wa wn wo exmid ordir mpbiran2 ) ABCBDZEAIEBIEBFABIGH $.

  $( Theorem *5.63 of [WhiteheadRussell] p. 125.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 25-Dec-2012.) $)
  pm5.63 $p |- ( ( ph \/ ps ) <-> ( ph \/ ( -. ph /\ ps ) ) ) $=
    ( wn wa wo exmid ordi mpbiran bicomi ) AACZBDEZABEZKAJELAFAJBGHI $.

  ${
    bianfi.1 $e |- -. ph $.
    $( A wff conjoined with falsehood is false.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Wolf Lammen, 26-Nov-2012.) $)
    bianfi $p |- ( ph <-> ( ps /\ ph ) ) $=
      ( wa intnan 2false ) ABADCABCEF $.
  $}

  ${
    bianfd.1 $e |- ( ph -> -. ps ) $.
    $( A wff conjoined with falsehood is false.  (Contributed by NM,
       27-Mar-1995.)  (Proof shortened by Wolf Lammen, 5-Nov-2013.) $)
    bianfd $p |- ( ph -> ( ps <-> ( ps /\ ch ) ) ) $=
      ( wa intnanrd 2falsed ) ABBCEDABCDFG $.
  $}

  $( Theorem *4.43 of [WhiteheadRussell] p. 119.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Wolf Lammen, 26-Nov-2012.) $)
  pm4.43 $p |- ( ph <-> ( ( ph \/ ps ) /\ ( ph \/ -. ps ) ) ) $=
    ( wn wa wo pm3.24 biorfi ordi bitri ) AABBCZDZEABEAJEDKABFGABJHI $.

  $( Theorem *4.82 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.82 $p |- ( ( ( ph -> ps ) /\ ( ph -> -. ps ) ) <-> -. ph ) $=
    ( wi wn wa pm2.65 imp pm2.21 jca impbii ) ABCZABDZCZEADZKMNABFGNKMABHALHIJ
    $.

  $( Theorem *4.83 of [WhiteheadRussell] p. 122.  (Contributed by NM,
     3-Jan-2005.) $)
  pm4.83 $p |- ( ( ( ph -> ps ) /\ ( -. ph -> ps ) ) <-> ps ) $=
    ( wn wo wi wa exmid a1bi jaob bitr2i ) BAACZDZBEABEKBEFLBAGHABKIJ $.

  $( Negation inferred from embedded conjunct.  (Contributed by NM,
     20-Aug-1993.)  (Proof shortened by Wolf Lammen, 25-Nov-2012.) $)
  pclem6 $p |- ( ( ph <-> ( ps /\ -. ph ) ) -> -. ps ) $=
    ( wn wa wb ibar nbbn sylib con2i ) BABACZDZEZBJKELCBJFAKGHI $.

  $( A transitive law of equivalence.  Compare Theorem *4.22 of
     [WhiteheadRussell] p. 117.  (Contributed by NM, 18-Aug-1993.) $)
  biantr $p |- ( ( ( ph <-> ps ) /\ ( ch <-> ps ) ) -> ( ph <-> ch ) ) $=
    ( wb id bibi2d biimparc ) CBDZACDABDHCBAHEFG $.

  $( Disjunction distributes over the biconditional.  An axiom of system DS in
     Vladimir Lifschitz, "On calculational proofs" (1998),
     ~ http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.25.3384 .
     (Contributed by NM, 8-Jan-2005.)  (Proof shortened by Wolf Lammen,
     4-Feb-2013.) $)
  orbidi $p |- ( ( ph \/ ( ps <-> ch ) ) <->
                ( ( ph \/ ps ) <-> ( ph \/ ch ) ) ) $=
    ( wn wb wi wo pm5.74 df-or bibi12i 3bitr4i ) ADZBCEZFLBFZLCFZEAMGABGZACGZEL
    BCHAMIPNQOABIACIJK $.

  $( Lukasiewicz's shortest axiom for equivalential calculus.  Storrs McCall,
     ed., _Polish Logic 1920-1939_ (Oxford, 1967), p. 96.  (Contributed by NM,
     10-Jan-2005.) $)
  biluk $p |- ( ( ph <-> ps ) <-> ( ( ch <-> ps ) <-> ( ph <-> ch ) ) ) $=
    ( wb bicom bibi1i biass bitri mpbi bitr4i ) ABDZCBACDZDZDZCBDLDKCDZMDKNDOBA
    DZCDMKPCABEFBACGHKCMGICBLGJ $.

  $( Disjunction distributes over the biconditional.  Theorem *5.7 of
     [WhiteheadRussell] p. 125.  This theorem is similar to ~ orbidi .
     (Contributed by Roy F. Longton, 21-Jun-2005.) $)
  pm5.7 $p |- ( ( ( ph \/ ch ) <-> ( ps \/ ch ) ) <->
               ( ch \/ ( ph <-> ps ) ) ) $=
    ( wb wo orbidi orcom bibi12i bitr2i ) CABDECAEZCBEZDACEZBCEZDCABFJLKMCAGCBG
    HI $.

  $( Dijkstra-Scholten's Golden Rule for calculational proofs.  (Contributed by
     NM, 10-Jan-2005.) $)
  bigolden $p |- ( ( ( ph /\ ps ) <-> ph ) <-> ( ps <-> ( ph \/ ps ) ) ) $=
    ( wi wa wb wo pm4.71 pm4.72 bicom 3bitr3ri ) ABCAABDZEBABFEKAEABGABHAKIJ $.

  $( Theorem *5.71 of [WhiteheadRussell] p. 125.  (Contributed by Roy F.
     Longton, 23-Jun-2005.) $)
  pm5.71 $p |- ( ( ps -> -. ch ) -> ( ( ( ph \/ ps ) /\ ch ) <->
                ( ph /\ ch ) ) ) $=
    ( wn wo wa wb orel2 orc impbid1 anbi1d pm2.21 pm5.32rd ja ) BCDZABEZCFACFGB
    DZPACQPABAHABIJKOCPACPAGLMN $.

  $( Theorem *5.75 of [WhiteheadRussell] p. 126.  (Contributed by NM,
     3-Jan-2005.)  (Proof shortened by Andrew Salmon, 7-May-2011.)  (Proof
     shortened by Wolf Lammen, 23-Dec-2012.) $)
  pm5.75 $p |- ( ( ( ch -> -. ps ) /\ ( ph <-> ( ps \/ ch ) ) ) ->
                ( ( ph /\ -. ps ) <-> ch ) ) $=
    ( wo wb wn wa wi anbi1 anbi1i pm5.61 syl6bb pm4.71 biimpi bicomd sylan9bbr
    orcom bitri ) ABCDZEZABFZGZCUAGZCUAHZCTUBSUAGZUCASUAIUECBDZUAGUCSUFUABCQJCB
    KRLUDCUCUDCUCECUAMNOP $.

  $( Removal of conjunct from one side of an equivalence.  (Contributed by NM,
     5-Aug-1993.) $)
  bimsc1 $p |- ( ( ( ph -> ps ) /\ ( ch <-> ( ps /\ ph ) ) )
               -> ( ch <-> ph ) ) $=
    ( wi wa wb simpr ancr impbid2 bibi2d biimpa ) ABDZCBAEZFCAFLMACLMABAGABHIJK
    $.

  $( The disjunction of the four possible combinations of two wffs and their
     negations is always true.  (Contributed by David Abernethy,
     28-Jan-2014.) $)
  4exmid $p |- ( ( ( ph /\ ps ) \/ ( -. ph /\ -. ps ) )
              \/ ( ( ph /\ -. ps ) \/ ( ps /\ -. ph ) ) ) $=
    ( wb wn wo wa exmid dfbi3 xor orbi12i mpbi ) ABCZLDZEABFADZBDZFEZAOFBNFEZEL
    GLPMQABHABIJK $.

  ${
    ecase2d.1 $e |- ( ph -> ps ) $.
    ecase2d.2 $e |- ( ph -> -. ( ps /\ ch ) ) $.
    ecase2d.3 $e |- ( ph -> -. ( ps /\ th ) ) $.
    ecase2d.4 $e |- ( ph -> ( ta \/ ( ch \/ th ) ) ) $.
    $( Deduction for elimination by cases.  (Contributed by NM, 21-Apr-1994.)
       (Proof shortened by Wolf Lammen, 22-Dec-2012.) $)
    ecase2d $p |- ( ph -> ta ) $=
      ( wo idd wa pm2.21d mpand jaod mpjaod ) AEECDJAEKACEDABCEFABCLEGMNABDEFAB
      DLEHMNOIP $.
  $}

  ${
    ecase3.1 $e |- ( ph -> ch ) $.
    ecase3.2 $e |- ( ps -> ch ) $.
    ecase3.3 $e |- ( -. ( ph \/ ps ) -> ch ) $.
    $( Inference for elimination by cases.  (Contributed by NM, 23-Mar-1995.)
       (Proof shortened by Wolf Lammen, 26-Nov-2012.) $)
    ecase3 $p |- ch $=
      ( wo jaoi pm2.61i ) ABGCACBDEHFI $.
  $}

  ${
    ecase.1 $e |- ( -. ph -> ch ) $.
    ecase.2 $e |- ( -. ps -> ch ) $.
    ecase.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Inference for elimination by cases.  (Contributed by NM,
       13-Jul-2005.) $)
    ecase $p |- ch $=
      ( ex pm2.61nii ) ABCABCFGDEH $.
  $}

  ${
    ecase3d.1 $e |- ( ph -> ( ps -> th ) ) $.
    ecase3d.2 $e |- ( ph -> ( ch -> th ) ) $.
    ecase3d.3 $e |- ( ph -> ( -. ( ps \/ ch ) -> th ) ) $.
    $( Deduction for elimination by cases.  (Contributed by NM, 2-May-1996.)
       (Proof shortened by Andrew Salmon, 7-May-2011.) $)
    ecase3d $p |- ( ph -> th ) $=
      ( wo jaod pm2.61d ) ABCHDABDCEFIGJ $.
  $}

  ${
    ecased.1 $e |- ( ph -> ( -. ps -> th ) ) $.
    ecased.2 $e |- ( ph -> ( -. ch -> th ) ) $.
    ecased.3 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Deduction for elimination by cases.  (Contributed by NM, 8-Oct-2012.) $)
    ecased $p |- ( ph -> th ) $=
      ( wn wo wa pm3.11 syl5 ecase3d ) ABHZCHZDEFNOIHBCJADBCKGLM $.
  $}

  ${
    ecase3ad.1 $e |- ( ph -> ( ps -> th ) ) $.
    ecase3ad.2 $e |- ( ph -> ( ch -> th ) ) $.
    ecase3ad.3 $e |- ( ph -> ( ( -. ps /\ -. ch ) -> th ) ) $.
    $( Deduction for elimination by cases.  (Contributed by NM,
       24-May-2013.) $)
    ecase3ad $p |- ( ph -> th ) $=
      ( wn notnot2 syl5 ecased ) ABHZCHZDLHBADBIEJMHCADCIFJGK $.
  $}

  ${
    ccase.1 $e |- ( ( ph /\ ps ) -> ta ) $.
    ccase.2 $e |- ( ( ch /\ ps ) -> ta ) $.
    ccase.3 $e |- ( ( ph /\ th ) -> ta ) $.
    ccase.4 $e |- ( ( ch /\ th ) -> ta ) $.
    $( Inference for combining cases.  (Contributed by NM, 29-Jul-1999.)
       (Proof shortened by Wolf Lammen, 6-Jan-2013.) $)
    ccase $p |- ( ( ( ph \/ ch ) /\ ( ps \/ th ) ) -> ta ) $=
      ( wo jaoian jaodan ) ACJBEDABECFGKADECHIKL $.
  $}

  ${
    ccased.1 $e |- ( ph -> ( ( ps /\ ch ) -> et ) ) $.
    ccased.2 $e |- ( ph -> ( ( th /\ ch ) -> et ) ) $.
    ccased.3 $e |- ( ph -> ( ( ps /\ ta ) -> et ) ) $.
    ccased.4 $e |- ( ph -> ( ( th /\ ta ) -> et ) ) $.
    $( Deduction for combining cases.  (Contributed by NM, 9-May-2004.) $)
    ccased $p |- ( ph -> ( ( ( ps \/ th ) /\ ( ch \/ ta ) ) -> et ) ) $=
      ( wo wa wi com12 ccase ) BDKCEKLAFBCDEAFMABCLFGNADCLFHNABELFINADELFJNON
      $.
  $}

  ${
    ccase2.1 $e |- ( ( ph /\ ps ) -> ta ) $.
    ccase2.2 $e |- ( ch -> ta ) $.
    ccase2.3 $e |- ( th -> ta ) $.
    $( Inference for combining cases.  (Contributed by NM, 29-Jul-1999.) $)
    ccase2 $p |- ( ( ( ph \/ ch ) /\ ( ps \/ th ) ) -> ta ) $=
      ( adantr adantl ccase ) ABCDEFCEBGIDEAHJDECHJK $.
  $}

  ${
    4cases.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    4cases.2 $e |- ( ( ph /\ -. ps ) -> ch ) $.
    4cases.3 $e |- ( ( -. ph /\ ps ) -> ch ) $.
    4cases.4 $e |- ( ( -. ph /\ -. ps ) -> ch ) $.
    $( Inference eliminating two antecedents from the four possible cases that
       result from their true/false combinations.  (Contributed by NM,
       25-Oct-2003.) $)
    4cases $p |- ch $=
      ( pm2.61ian wn pm2.61i ) BCABCDFHABICEGHJ $.
  $}

  ${
    4casesdan.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    4casesdan.2 $e |- ( ( ph /\ ( ps /\ -. ch ) ) -> th ) $.
    4casesdan.3 $e |- ( ( ph /\ ( -. ps /\ ch ) ) -> th ) $.
    4casesdan.4 $e |- ( ( ph /\ ( -. ps /\ -. ch ) ) -> th ) $.
    $( Deduction eliminating two antecedents from the four possible cases that
       result from their true/false combinations.  (Contributed by NM,
       19-Mar-2013.) $)
    4casesdan $p |- ( ph -> th ) $=
      ( wi wa expcom wn 4cases ) BCADIABCJDEKABCLZJDFKABLZCJDGKAONJDHKM $.
  $}

  ${
    niabn.1 $e |- ph $.
    $( Miscellaneous inference relating falsehoods.  (Contributed by NM,
       31-Mar-1994.) $)
    niabn $p |- ( -. ps -> ( ( ch /\ ps ) <-> -. ph ) ) $=
      ( wa wn simpr pm2.24i pm5.21ni ) CBEBAFCBGABDHI $.
  $}

  $( Lemma for an alternate version of weak deduction theorem.  (Contributed by
     NM, 2-Apr-1994.)  (Proof shortened by Andrew Salmon, 7-May-2011.)  (Proof
     shortened by Wolf Lammen, 4-Dec-2012.) $)
  dedlem0a $p |- ( ph -> ( ps <-> ( ( ch -> ph ) -> ( ps /\ ph ) ) ) ) $=
    ( wa wi iba wb ax-1 biimt syl bitrd ) ABBADZCAEZLEZABFAMLNGACHMLIJK $.

  $( Lemma for an alternate version of weak deduction theorem.  (Contributed by
     NM, 2-Apr-1994.) $)
  dedlem0b $p |- ( -. ph -> ( ps <-> ( ( ps -> ph ) -> ( ch /\ ph ) ) ) ) $=
    ( wn wi wa pm2.21 imim2d com23 simpr imim12i con1d com12 impbid ) ADZBBAEZC
    AFZEZOPBQOAQBAQGHIROBRBABDPQABAGCAJKLMN $.

  $( Lemma for weak deduction theorem.  (Contributed by NM, 26-Jun-2002.)
     (Proof shortened by Andrew Salmon, 7-May-2011.) $)
  dedlema $p |- ( ph -> ( ps <-> ( ( ps /\ ph ) \/ ( ch /\ -. ph ) ) ) ) $=
    ( wa wn wo orc expcom wi simpl a1i pm2.24 adantld jaod impbid ) ABBADZCAEZD
    ZFZBASPRGHAPBRPBIABAJKAQBCABLMNO $.

  $( Lemma for weak deduction theorem.  (Contributed by NM, 15-May-1999.)
     (Proof shortened by Andrew Salmon, 7-May-2011.) $)
  dedlemb $p |- ( -. ph -> ( ch <-> ( ( ps /\ ph ) \/ ( ch /\ -. ph ) ) ) ) $=
    ( wn wa wo olc expcom pm2.21 adantld wi simpl a1i jaod impbid ) ADZCBAEZCPE
    ZFZCPSRQGHPQCRPACBACIJRCKPCPLMNO $.

  ${
    elimh.1 $e |- ( ( ph <-> ( ( ph /\ ch ) \/ ( ps /\ -. ch ) ) )
                     -> ( ch <-> ta ) ) $.
    elimh.2 $e |- ( ( ps <-> ( ( ph /\ ch ) \/ ( ps /\ -. ch ) ) )
                     -> ( th <-> ta ) ) $.
    elimh.3 $e |- th $.
    $( Hypothesis builder for weak deduction theorem.  For more information,
       see the Deduction Theorem link on the Metamath Proof Explorer home
       page.  (Contributed by NM, 26-Jun-2002.) $)
    elimh $p |- ta $=
      ( wa wn wo wb dedlema syl ibi dedlemb mpbii pm2.61i ) CECECAACIBCJZIKZLCE
      LCABMFNOSDEHSBTLDELCABPGNQR $.
  $}

  ${
    dedt.1 $e |- ( ( ph <-> ( ( ph /\ ch ) \/ ( ps /\ -. ch ) ) )
                     -> ( th <-> ta ) ) $.
    dedt.2 $e |- ta $.
    $( The weak deduction theorem.  For more information, see the Deduction
       Theorem link on the Metamath Proof Explorer home page.  (Contributed by
       NM, 26-Jun-2002.) $)
    dedt $p |- ( ch -> th ) $=
      ( wa wn wo wb dedlema mpbiri syl ) CAACHBCIHJKZDCABLODEGFMN $.
  $}

  $( Contraposition.  Theorem *2.16 of [WhiteheadRussell] p. 103.  This version
     of ~ con3 demonstrates the use of the weak deduction theorem ~ dedt to
     derive it from ~ con3i .  (Contributed by NM, 27-Jun-2002.)
     (Proof modification is discouraged.) $)
  con3th $p |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) $=
    ( wi wn wa wo wb id notbid imbi1d imbi2d elimh con3i dedt ) BAABCZBDZADZCBO
    EAODEFZDZQCBRGZPSQTBRTHZIJARBAOAACARCTBRAUAKARGZARAUBHKAHLMN $.

  $( The consensus theorem.  This theorem and its dual (with ` \/ ` and ` /\ `
     interchanged) are commonly used in computer logic design to eliminate
     redundant terms from Boolean expressions.  Specifically, we prove that the
     term ` ( ps /\ ch ) ` on the left-hand side is redundant.  (Contributed by
     NM, 16-May-2003.)  (Proof shortened by Andrew Salmon, 13-May-2011.)
     (Proof shortened by Wolf Lammen, 20-Jan-2013.) $)
  consensus $p |- ( ( ( ( ph /\ ps ) \/ ( -. ph /\ ch ) ) \/ ( ps /\ ch ) ) <->
                      ( ( ph /\ ps ) \/ ( -. ph /\ ch ) ) ) $=
    ( wa wn wo id orc adantrr olc adantrl pm2.61ian jaoi impbii ) ABDZAEZCDZFZB
    CDZFRRRSRGASRABRCOQHIPCRBQOJKLMRSHN $.

  $( Theorem *4.42 of [WhiteheadRussell] p. 119.  (Contributed by Roy F.
     Longton, 21-Jun-2005.) $)
  pm4.42 $p |- ( ph <-> ( ( ph /\ ps ) \/ ( ph /\ -. ps ) ) ) $=
    ( wa wn wo wb dedlema dedlemb pm2.61i ) BAABCABDCEFBAAGBAAHI $.

  ${
    ninba.1 $e |- ph $.
    $( Miscellaneous inference relating falsehoods.  (Contributed by NM,
       31-Mar-1994.) $)
    ninba $p |- ( -. ps -> ( -. ph <-> ( ch /\ ps ) ) ) $=
      ( wn wa niabn bicomd ) BECBFAEABCDGH $.
  $}

  ${
    prlem1.1 $e |- ( ph -> ( et <-> ch ) ) $.
    prlem1.2 $e |- ( ps -> -. th ) $.
    $( A specialized lemma for set theory (to derive the Axiom of Pairing).
       (Contributed by NM, 18-Oct-1995.)  (Proof shortened by Andrew Salmon,
       13-May-2011.)  (Proof shortened by Wolf Lammen, 5-Jan-2013.) $)
    prlem1 $p |- ( ph -> ( ps ->
                  ( ( ( ps /\ ch ) \/ ( th /\ ta ) ) -> et ) ) ) $=
      ( wa wo wi biimprd adantld pm2.21d adantrd jaao ex ) ABBCIZDEIZJFKARFBSAC
      FBAFCGLMBDFEBDFHNOPQ $.
  $}

  $( A specialized lemma for set theory (to derive the Axiom of Pairing).
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
     13-May-2011.)  (Proof shortened by Wolf Lammen, 9-Dec-2012.) $)
  prlem2 $p |- ( ( ( ph /\ ps ) \/ ( ch /\ th ) ) <->
              ( ( ph \/ ch ) /\ ( ( ph /\ ps ) \/ ( ch /\ th ) ) ) ) $=
    ( wa wo simpl orim12i pm4.71ri ) ABEZCDEZFACFJAKCABGCDGHI $.

  ${
    oplem1.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    oplem1.2 $e |- ( ph -> ( th \/ ta ) ) $.
    oplem1.3 $e |- ( ps <-> th ) $.
    oplem1.4 $e |- ( ch -> ( th <-> ta ) ) $.
    $( A specialized lemma for set theory (ordered pair theorem).  (Contributed
       by NM, 18-Oct-1995.)  (Proof shortened by Wolf Lammen, 8-Dec-2012.) $)
    oplem1 $p |- ( ph -> ps ) $=
      ( wn wa notbii ord syl5bir jcad biimpar syl6 pm2.18d sylibr ) ADBADADJZCE
      KDATCETBJACBDHLABCFMNADEGMOCDEIPQRHS $.
  $}

  $( Lemma used in construction of real numbers.  (Contributed by NM,
     4-Sep-1995.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  rnlem $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
  ( ( ( ph /\ ch ) /\ ( ps /\ th ) ) /\ ( ( ph /\ th ) /\ ( ps /\ ch ) ) ) ) $=
    ( wa an4 biimpi an42 biimpri jca adantl impbii ) ABECDEEZACEBDEEZADEBCEEZEM
    NOMNABCDFGOMADBCHZIJOMNOMPGKL $.

  $( A single axiom for Boolean algebra known as DN_1.  See
     ~ http://www-unix.mcs.anl.gov/~~mccune/papers/basax/v12.pdf .
     (Contributed by Jeffrey Hankins, 3-Jul-2009.)  (Proof shortened by Andrew
     Salmon, 13-May-2011.)  (Proof shortened by Wolf Lammen, 6-Jan-2013.) $)
  dn1 $p |- ( -. ( -. ( -. ( ph \/ ps ) \/ ch ) \/
            -. ( ph \/ -. ( -. ch \/ -. ( ch \/ th ) ) ) ) <-> ch ) $=
    ( wo wn wa wi pm2.45 imnan mpbi biorfi orcom ordir bitri pm4.45 anor orbi2i
    anbi2i 3bitrri ) CABEFZCEZACEZGZUBACFCDEZFEFZEZGUBFUGFEFCCUAAGZEZUDUHCUAAFH
    UHFABIUAAJKLUIUHCEUDCUHMUAACNOOUCUGUBCUFACCUEGUFCDPCUEQORSUBUGQT $.

  ${
    jaoi2.1 $e |- ( ( ph \/ ( -. ph /\ ch ) ) -> ps ) $.
    $( Inference removing a negated conjunct in a disjunction of an antecedent
       if this conjunct is part of the disjunction.  (Contributed by Alexander
       van der Vekens, 3-Nov-2017.) $)
    jaoi2 $p |- ( ( ph \/ ch ) -> ps ) $=
      ( wo wa wn wb exmid iba ancom andir bitri syl6bb ax-mp orbi2i orass sylbi
      bicomi pm4.44 orbi1i ) ACEAACFZAGZCFZEZEZBCUEAAUCEZCUEHAIUGCCUGFZUEUGCJUH
      UGCFUECUGKAUCCLMNOPUFAUDEZBUFAUBEZUDEZUIUKUFAUBUDQSUJAUDAUJACTSUAMDRR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Abbreviated conjunction and disjunction of three wff's
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend wff definition to include 3-way disjunction ('or'). $)
  w3o $a wff ( ph \/ ps \/ ch ) $.
  $( Extend wff definition to include 3-way conjunction ('and'). $)
  w3a $a wff ( ph /\ ps /\ ch ) $.

  $( These abbreviations help eliminate parentheses to aid readability. $)

  $( Define disjunction ('or') of three wff's.  Definition *2.33 of
     [WhiteheadRussell] p. 105.  This abbreviation reduces the number of
     parentheses and emphasizes that the order of bracketing is not important
     by virtue of the associative law ~ orass .  (Contributed by NM,
     8-Apr-1994.) $)
  df-3or $a |- ( ( ph \/ ps \/ ch ) <-> ( ( ph \/ ps ) \/ ch ) ) $.

  $( Define conjunction ('and') of three wff's.  Definition *4.34 of
     [WhiteheadRussell] p. 118.  This abbreviation reduces the number of
     parentheses and emphasizes that the order of bracketing is not important
     by virtue of the associative law ~ anass .  (Contributed by NM,
     8-Apr-1994.) $)
  df-3an $a |- ( ( ph /\ ps /\ ch ) <-> ( ( ph /\ ps ) /\ ch ) ) $.

  $( Associative law for triple disjunction.  (Contributed by NM,
     8-Apr-1994.) $)
  3orass $p |- ( ( ph \/ ps \/ ch ) <-> ( ph \/ ( ps \/ ch ) ) ) $=
    ( w3o wo df-3or orass bitri ) ABCDABECEABCEEABCFABCGH $.

  $( Associative law for triple conjunction.  (Contributed by NM,
     8-Apr-1994.) $)
  3anass $p |- ( ( ph /\ ps /\ ch ) <-> ( ph /\ ( ps /\ ch ) ) ) $=
    ( w3a wa df-3an anass bitri ) ABCDABECEABCEEABCFABCGH $.

  $( Rotation law for triple conjunction.  (Contributed by NM, 8-Apr-1994.) $)
  3anrot $p |- ( ( ph /\ ps /\ ch ) <-> ( ps /\ ch /\ ph ) ) $=
    ( wa w3a ancom 3anass df-3an 3bitr4i ) ABCDZDJADABCEBCAEAJFABCGBCAHI $.

  $( Rotation law for triple disjunction.  (Contributed by NM, 4-Apr-1995.) $)
  3orrot $p |- ( ( ph \/ ps \/ ch ) <-> ( ps \/ ch \/ ph ) ) $=
    ( wo w3o orcom 3orass df-3or 3bitr4i ) ABCDZDJADABCEBCAEAJFABCGBCAHI $.

  $( Commutation law for triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  3ancoma $p |- ( ( ph /\ ps /\ ch ) <-> ( ps /\ ph /\ ch ) ) $=
    ( wa w3a ancom anbi1i df-3an 3bitr4i ) ABDZCDBADZCDABCEBACEJKCABFGABCHBACHI
    $.

  $( Commutation law for triple disjunction.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  3orcoma $p |- ( ( ph \/ ps \/ ch ) <-> ( ps \/ ph \/ ch ) ) $=
    ( wo w3o or12 3orass 3bitr4i ) ABCDDBACDDABCEBACEABCFABCGBACGH $.

  $( Commutation law for triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  3ancomb $p |- ( ( ph /\ ps /\ ch ) <-> ( ph /\ ch /\ ps ) ) $=
    ( w3a 3ancoma 3anrot bitri ) ABCDBACDACBDABCEBACFG $.

  $( Commutation law for triple disjunction.  (Contributed by Scott Fenton,
     20-Apr-2011.) $)
  3orcomb $p |- ( ( ph \/ ps \/ ch ) <-> ( ph \/ ch \/ ps ) ) $=
    ( wo w3o orcom orbi2i 3orass 3bitr4i ) ABCDZDACBDZDABCEACBEJKABCFGABCHACBHI
    $.

  $( Reversal law for triple conjunction.  (Contributed by NM, 21-Apr-1994.) $)
  3anrev $p |- ( ( ph /\ ps /\ ch ) <-> ( ch /\ ps /\ ph ) ) $=
    ( w3a 3ancoma 3anrot bitr4i ) ABCDBACDCBADABCECBAFG $.

  $( Convert triple conjunction to conjunction, then commute.  (Contributed by
     Jonathan Ben-Naim, 3-Jun-2011.) $)
  3anan32 $p |- ( ( ph /\ ps /\ ch ) <-> ( ( ph /\ ch ) /\ ps ) ) $=
    ( w3a wa df-3an an32 bitri ) ABCDABECEACEBEABCFABCGH $.

  $( Convert triple conjunction to conjunction, then commute.  (Contributed by
     Jonathan Ben-Naim, 3-Jun-2011.)  (Proof shortened by Andrew Salmon,
     14-Jun-2011.) $)
  3anan12 $p |- ( ( ph /\ ps /\ ch ) <-> ( ps /\ ( ph /\ ch ) ) ) $=
    ( w3a wa 3ancoma 3anass bitri ) ABCDBACDBACEEABCFBACGH $.

  $( Triple conjunction expressed in terms of triple disjunction.  (Contributed
     by Jeff Hankins, 15-Aug-2009.) $)
  3anor $p |- ( ( ph /\ ps /\ ch ) <-> -. ( -. ph \/ -. ps \/ -. ch ) ) $=
    ( w3a wa wn w3o df-3an wo anor ianor orbi1i xchbinx df-3or xchbinxr bitri )
    ABCDABEZCEZAFZBFZCFZGZFABCHRSTIZUAIZUBRQFZUAIUDQCJUEUCUAABKLMSTUANOP $.

  $( Negated triple conjunction expressed in terms of triple disjunction.
     (Contributed by Jeff Hankins, 15-Aug-2009.)  (Proof shortened by Andrew
     Salmon, 13-May-2011.) $)
  3ianor $p |- ( -. ( ph /\ ps /\ ch ) <-> ( -. ph \/ -. ps \/ -. ch ) ) $=
    ( wn w3o w3a 3anor con2bii bicomi ) ADBDCDEZABCFZDKJABCGHI $.

  $( Negated triple disjunction as triple conjunction.  (Contributed by Scott
     Fenton, 19-Apr-2011.) $)
  3ioran $p |- ( -. ( ph \/ ps \/ ch ) <-> ( -. ph /\ -. ps /\ -. ch ) ) $=
    ( wo wn wa w3o w3a ioran anbi1i df-3or xchnxbir df-3an 3bitr4i ) ABDZEZCEZF
    ZAEZBEZFZQFABCGZESTQHPUAQABIJOCDRUBOCIABCKLSTQMN $.

  $( Triple disjunction in terms of triple conjunction.  (Contributed by NM,
     8-Oct-2012.) $)
  3oran $p |- ( ( ph \/ ps \/ ch ) <-> -. ( -. ph /\ -. ps /\ -. ch ) ) $=
    ( wn w3a w3o 3ioran con1bii bicomi ) ADBDCDEZDABCFZKJABCGHI $.

  $( Simplification of triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  3simpa $p |- ( ( ph /\ ps /\ ch ) -> ( ph /\ ps ) ) $=
    ( w3a wa df-3an simplbi ) ABCDABECABCFG $.

  $( Simplification of triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  3simpb $p |- ( ( ph /\ ps /\ ch ) -> ( ph /\ ch ) ) $=
    ( w3a wa 3ancomb 3simpa sylbi ) ABCDACBDACEABCFACBGH $.

  $( Simplification of triple conjunction.  (Contributed by NM, 21-Apr-1994.)
     (Proof shortened by Andrew Salmon, 13-May-2011.) $)
  3simpc $p |- ( ( ph /\ ps /\ ch ) -> ( ps /\ ch ) ) $=
    ( w3a wa 3anrot 3simpa sylbi ) ABCDBCADBCEABCFBCAGH $.

  $( Simplification of triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  simp1 $p |- ( ( ph /\ ps /\ ch ) -> ph ) $=
    ( w3a 3simpa simpld ) ABCDABABCEF $.

  $( Simplification of triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  simp2 $p |- ( ( ph /\ ps /\ ch ) -> ps ) $=
    ( w3a 3simpa simprd ) ABCDABABCEF $.

  $( Simplification of triple conjunction.  (Contributed by NM,
     21-Apr-1994.) $)
  simp3 $p |- ( ( ph /\ ps /\ ch ) -> ch ) $=
    ( w3a 3simpc simprd ) ABCDBCABCEF $.

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  simpl1 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ph ) $=
    ( w3a simp1 adantr ) ABCEADABCFG $.

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  simpl2 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ps ) $=
    ( w3a simp2 adantr ) ABCEBDABCFG $.

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  simpl3 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ch ) $=
    ( w3a simp3 adantr ) ABCECDABCFG $.

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  simpr1 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ps ) $=
    ( w3a simp1 adantl ) BCDEBABCDFG $.

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  simpr2 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ch ) $=
    ( w3a simp2 adantl ) BCDECABCDFG $.

  $( Simplification rule.  (Contributed by Jeff Hankins, 17-Nov-2009.) $)
  simpr3 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> th ) $=
    ( w3a simp3 adantl ) BCDEDABCDFG $.

  ${
    3simp1i.1 $e |- ( ph /\ ps /\ ch ) $.
    $( Infer a conjunct from a triple conjunction.  (Contributed by NM,
       19-Apr-2005.) $)
    simp1i $p |- ph $=
      ( w3a simp1 ax-mp ) ABCEADABCFG $.

    $( Infer a conjunct from a triple conjunction.  (Contributed by NM,
       19-Apr-2005.) $)
    simp2i $p |- ps $=
      ( w3a simp2 ax-mp ) ABCEBDABCFG $.

    $( Infer a conjunct from a triple conjunction.  (Contributed by NM,
       19-Apr-2005.) $)
    simp3i $p |- ch $=
      ( w3a simp3 ax-mp ) ABCECDABCFG $.
  $}

  ${
    3simp1d.1 $e |- ( ph -> ( ps /\ ch /\ th ) ) $.
    $( Deduce a conjunct from a triple conjunction.  (Contributed by NM,
       4-Sep-2005.) $)
    simp1d $p |- ( ph -> ps ) $=
      ( w3a simp1 syl ) ABCDFBEBCDGH $.

    $( Deduce a conjunct from a triple conjunction.  (Contributed by NM,
       4-Sep-2005.) $)
    simp2d $p |- ( ph -> ch ) $=
      ( w3a simp2 syl ) ABCDFCEBCDGH $.

    $( Deduce a conjunct from a triple conjunction.  (Contributed by NM,
       4-Sep-2005.) $)
    simp3d $p |- ( ph -> th ) $=
      ( w3a simp3 syl ) ABCDFDEBCDGH $.
  $}

  ${
    3simp1bi.1 $e |- ( ph <-> ( ps /\ ch /\ th ) ) $.
    $( Deduce a conjunct from a triple conjunction.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    simp1bi $p |- ( ph -> ps ) $=
      ( w3a biimpi simp1d ) ABCDABCDFEGH $.

    $( Deduce a conjunct from a triple conjunction.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    simp2bi $p |- ( ph -> ch ) $=
      ( w3a biimpi simp2d ) ABCDABCDFEGH $.

    $( Deduce a conjunct from a triple conjunction.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    simp3bi $p |- ( ph -> th ) $=
      ( w3a biimpi simp3d ) ABCDABCDFEGH $.
  $}

  ${
    3adant.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       16-Jul-1995.) $)
    3adant1 $p |- ( ( th /\ ph /\ ps ) -> ch ) $=
      ( w3a wa 3simpc syl ) DABFABGCDABHEI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       16-Jul-1995.) $)
    3adant2 $p |- ( ( ph /\ th /\ ps ) -> ch ) $=
      ( w3a wa 3simpb syl ) ADBFABGCADBHEI $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       16-Jul-1995.) $)
    3adant3 $p |- ( ( ph /\ ps /\ th ) -> ch ) $=
      ( w3a wa 3simpa syl ) ABDFABGCABDHEI $.
  $}

  ${
    3ad2ant.1 $e |- ( ph -> ch ) $.
    $( Deduction adding conjuncts to an antecedent.  (Contributed by NM,
       21-Apr-2005.) $)
    3ad2ant1 $p |- ( ( ph /\ ps /\ th ) -> ch ) $=
      ( adantr 3adant2 ) ADCBACDEFG $.

    $( Deduction adding conjuncts to an antecedent.  (Contributed by NM,
       21-Apr-2005.) $)
    3ad2ant2 $p |- ( ( ps /\ ph /\ th ) -> ch ) $=
      ( adantr 3adant1 ) ADCBACDEFG $.

    $( Deduction adding conjuncts to an antecedent.  (Contributed by NM,
       21-Apr-2005.) $)
    3ad2ant3 $p |- ( ( ps /\ th /\ ph ) -> ch ) $=
      ( adantl 3adant1 ) DACBACDEFG $.
  $}

  $( Simplification of triple conjunction.  (Contributed by NM, 9-Nov-2011.) $)
  simp1l $p |- ( ( ( ph /\ ps ) /\ ch /\ th ) -> ph ) $=
    ( wa simpl 3ad2ant1 ) ABECADABFG $.

  $( Simplification of triple conjunction.  (Contributed by NM, 9-Nov-2011.) $)
  simp1r $p |- ( ( ( ph /\ ps ) /\ ch /\ th ) -> ps ) $=
    ( wa simpr 3ad2ant1 ) ABECBDABFG $.

  $( Simplification of triple conjunction.  (Contributed by NM, 9-Nov-2011.) $)
  simp2l $p |- ( ( ph /\ ( ps /\ ch ) /\ th ) -> ps ) $=
    ( wa simpl 3ad2ant2 ) BCEABDBCFG $.

  $( Simplification of triple conjunction.  (Contributed by NM, 9-Nov-2011.) $)
  simp2r $p |- ( ( ph /\ ( ps /\ ch ) /\ th ) -> ch ) $=
    ( wa simpr 3ad2ant2 ) BCEACDBCFG $.

  $( Simplification of triple conjunction.  (Contributed by NM, 9-Nov-2011.) $)
  simp3l $p |- ( ( ph /\ ps /\ ( ch /\ th ) ) -> ch ) $=
    ( wa simpl 3ad2ant3 ) CDEACBCDFG $.

  $( Simplification of triple conjunction.  (Contributed by NM, 9-Nov-2011.) $)
  simp3r $p |- ( ( ph /\ ps /\ ( ch /\ th ) ) -> th ) $=
    ( wa simpr 3ad2ant3 ) CDEADBCDFG $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp11 $p |- ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) -> ph ) $=
    ( w3a simp1 3ad2ant1 ) ABCFDAEABCGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp12 $p |- ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) -> ps ) $=
    ( w3a simp2 3ad2ant1 ) ABCFDBEABCGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp13 $p |- ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) -> ch ) $=
    ( w3a simp3 3ad2ant1 ) ABCFDCEABCGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp21 $p |- ( ( ph /\ ( ps /\ ch /\ th ) /\ ta ) -> ps ) $=
    ( w3a simp1 3ad2ant2 ) BCDFABEBCDGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp22 $p |- ( ( ph /\ ( ps /\ ch /\ th ) /\ ta ) -> ch ) $=
    ( w3a simp2 3ad2ant2 ) BCDFACEBCDGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp23 $p |- ( ( ph /\ ( ps /\ ch /\ th ) /\ ta ) -> th ) $=
    ( w3a simp3 3ad2ant2 ) BCDFADEBCDGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp31 $p |- ( ( ph /\ ps /\ ( ch /\ th /\ ta ) ) -> ch ) $=
    ( w3a simp1 3ad2ant3 ) CDEFACBCDEGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp32 $p |- ( ( ph /\ ps /\ ( ch /\ th /\ ta ) ) -> th ) $=
    ( w3a simp2 3ad2ant3 ) CDEFADBCDEGH $.

  $( Simplification of doubly triple conjunction.  (Contributed by NM,
     17-Nov-2011.) $)
  simp33 $p |- ( ( ph /\ ps /\ ( ch /\ th /\ ta ) ) -> ta ) $=
    ( w3a simp3 3ad2ant3 ) CDEFAEBCDEGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpll1 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th ) /\ ta ) -> ph ) $=
    ( w3a wa simpl1 adantr ) ABCFDGAEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpll2 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th ) /\ ta ) -> ps ) $=
    ( w3a wa simpl2 adantr ) ABCFDGBEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpll3 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th ) /\ ta ) -> ch ) $=
    ( w3a wa simpl3 adantr ) ABCFDGCEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simplr1 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) ) /\ ta ) -> ph ) $=
    ( w3a wa simpr1 adantr ) DABCFGAEDABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simplr2 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) ) /\ ta ) -> ps ) $=
    ( w3a wa simpr2 adantr ) DABCFGBEDABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simplr3 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) ) /\ ta ) -> ch ) $=
    ( w3a wa simpr3 adantr ) DABCFGCEDABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simprl1 $p |- ( ( ta /\ ( ( ph /\ ps /\ ch ) /\ th ) ) -> ph ) $=
    ( w3a wa simpl1 adantl ) ABCFDGAEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simprl2 $p |- ( ( ta /\ ( ( ph /\ ps /\ ch ) /\ th ) ) -> ps ) $=
    ( w3a wa simpl2 adantl ) ABCFDGBEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simprl3 $p |- ( ( ta /\ ( ( ph /\ ps /\ ch ) /\ th ) ) -> ch ) $=
    ( w3a wa simpl3 adantl ) ABCFDGCEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simprr1 $p |- ( ( ta /\ ( th /\ ( ph /\ ps /\ ch ) ) ) -> ph ) $=
    ( w3a wa simpr1 adantl ) DABCFGAEDABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simprr2 $p |- ( ( ta /\ ( th /\ ( ph /\ ps /\ ch ) ) ) -> ps ) $=
    ( w3a wa simpr2 adantl ) DABCFGBEDABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simprr3 $p |- ( ( ta /\ ( th /\ ( ph /\ ps /\ ch ) ) ) -> ch ) $=
    ( w3a wa simpr3 adantl ) DABCFGCEDABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl1l $p |- ( ( ( ( ph /\ ps ) /\ ch /\ th ) /\ ta ) -> ph ) $=
    ( wa w3a simp1l adantr ) ABFCDGAEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl1r $p |- ( ( ( ( ph /\ ps ) /\ ch /\ th ) /\ ta ) -> ps ) $=
    ( wa w3a simp1r adantr ) ABFCDGBEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl2l $p |- ( ( ( ch /\ ( ph /\ ps ) /\ th ) /\ ta ) -> ph ) $=
    ( wa w3a simp2l adantr ) CABFDGAECABDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl2r $p |- ( ( ( ch /\ ( ph /\ ps ) /\ th ) /\ ta ) -> ps ) $=
    ( wa w3a simp2r adantr ) CABFDGBECABDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl3l $p |- ( ( ( ch /\ th /\ ( ph /\ ps ) ) /\ ta ) -> ph ) $=
    ( wa w3a simp3l adantr ) CDABFGAECDABHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl3r $p |- ( ( ( ch /\ th /\ ( ph /\ ps ) ) /\ ta ) -> ps ) $=
    ( wa w3a simp3r adantr ) CDABFGBECDABHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr1l $p |- ( ( ta /\ ( ( ph /\ ps ) /\ ch /\ th ) ) -> ph ) $=
    ( wa w3a simp1l adantl ) ABFCDGAEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr1r $p |- ( ( ta /\ ( ( ph /\ ps ) /\ ch /\ th ) ) -> ps ) $=
    ( wa w3a simp1r adantl ) ABFCDGBEABCDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr2l $p |- ( ( ta /\ ( ch /\ ( ph /\ ps ) /\ th ) ) -> ph ) $=
    ( wa w3a simp2l adantl ) CABFDGAECABDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr2r $p |- ( ( ta /\ ( ch /\ ( ph /\ ps ) /\ th ) ) -> ps ) $=
    ( wa w3a simp2r adantl ) CABFDGBECABDHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr3l $p |- ( ( ta /\ ( ch /\ th /\ ( ph /\ ps ) ) ) -> ph ) $=
    ( wa w3a simp3l adantl ) CDABFGAECDABHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr3r $p |- ( ( ta /\ ( ch /\ th /\ ( ph /\ ps ) ) ) -> ps ) $=
    ( wa w3a simp3r adantl ) CDABFGBECDABHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1ll $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th /\ ta ) -> ph ) $=
    ( wa simpll 3ad2ant1 ) ABFCFDAEABCGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1lr $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th /\ ta ) -> ps ) $=
    ( wa simplr 3ad2ant1 ) ABFCFDBEABCGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1rl $p |- ( ( ( ch /\ ( ph /\ ps ) ) /\ th /\ ta ) -> ph ) $=
    ( wa simprl 3ad2ant1 ) CABFFDAECABGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1rr $p |- ( ( ( ch /\ ( ph /\ ps ) ) /\ th /\ ta ) -> ps ) $=
    ( wa simprr 3ad2ant1 ) CABFFDBECABGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2ll $p |- ( ( th /\ ( ( ph /\ ps ) /\ ch ) /\ ta ) -> ph ) $=
    ( wa simpll 3ad2ant2 ) ABFCFDAEABCGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2lr $p |- ( ( th /\ ( ( ph /\ ps ) /\ ch ) /\ ta ) -> ps ) $=
    ( wa simplr 3ad2ant2 ) ABFCFDBEABCGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2rl $p |- ( ( th /\ ( ch /\ ( ph /\ ps ) ) /\ ta ) -> ph ) $=
    ( wa simprl 3ad2ant2 ) CABFFDAECABGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2rr $p |- ( ( th /\ ( ch /\ ( ph /\ ps ) ) /\ ta ) -> ps ) $=
    ( wa simprr 3ad2ant2 ) CABFFDBECABGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3ll $p |- ( ( th /\ ta /\ ( ( ph /\ ps ) /\ ch ) ) -> ph ) $=
    ( wa simpll 3ad2ant3 ) ABFCFDAEABCGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3lr $p |- ( ( th /\ ta /\ ( ( ph /\ ps ) /\ ch ) ) -> ps ) $=
    ( wa simplr 3ad2ant3 ) ABFCFDBEABCGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3rl $p |- ( ( th /\ ta /\ ( ch /\ ( ph /\ ps ) ) ) -> ph ) $=
    ( wa simprl 3ad2ant3 ) CABFFDAECABGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3rr $p |- ( ( th /\ ta /\ ( ch /\ ( ph /\ ps ) ) ) -> ps ) $=
    ( wa simprr 3ad2ant3 ) CABFFDBECABGH $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl11 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ et ) -> ph ) $=
    ( w3a simp11 adantr ) ABCGDEGAFABCDEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl12 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ et ) -> ps ) $=
    ( w3a simp12 adantr ) ABCGDEGBFABCDEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl13 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ et ) -> ch ) $=
    ( w3a simp13 adantr ) ABCGDEGCFABCDEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl21 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ et ) -> ph ) $=
    ( w3a simp21 adantr ) DABCGEGAFDABCEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl22 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ et ) -> ps ) $=
    ( w3a simp22 adantr ) DABCGEGBFDABCEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl23 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ et ) -> ch ) $=
    ( w3a simp23 adantr ) DABCGEGCFDABCEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl31 $p |- ( ( ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ et ) -> ph ) $=
    ( w3a simp31 adantr ) DEABCGGAFDEABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl32 $p |- ( ( ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ et ) -> ps ) $=
    ( w3a simp32 adantr ) DEABCGGBFDEABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpl33 $p |- ( ( ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ et ) -> ch ) $=
    ( w3a simp33 adantr ) DEABCGGCFDEABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr11 $p |- ( ( et /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) ) -> ph ) $=
    ( w3a simp11 adantl ) ABCGDEGAFABCDEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr12 $p |- ( ( et /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) ) -> ps ) $=
    ( w3a simp12 adantl ) ABCGDEGBFABCDEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr13 $p |- ( ( et /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) ) -> ch ) $=
    ( w3a simp13 adantl ) ABCGDEGCFABCDEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr21 $p |- ( ( et /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) ) -> ph ) $=
    ( w3a simp21 adantl ) DABCGEGAFDABCEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr22 $p |- ( ( et /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) ) -> ps ) $=
    ( w3a simp22 adantl ) DABCGEGBFDABCEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr23 $p |- ( ( et /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) ) -> ch ) $=
    ( w3a simp23 adantl ) DABCGEGCFDABCEHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr31 $p |- ( ( et /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) ) -> ph ) $=
    ( w3a simp31 adantl ) DEABCGGAFDEABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr32 $p |- ( ( et /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) ) -> ps ) $=
    ( w3a simp32 adantl ) DEABCGGBFDEABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simpr33 $p |- ( ( et /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) ) -> ch ) $=
    ( w3a simp33 adantl ) DEABCGGCFDEABCHI $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1l1 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th ) /\ ta /\ et ) -> ph ) $=
    ( w3a wa simpl1 3ad2ant1 ) ABCGDHEAFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1l2 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th ) /\ ta /\ et ) -> ps ) $=
    ( w3a wa simpl2 3ad2ant1 ) ABCGDHEBFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1l3 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th ) /\ ta /\ et ) -> ch ) $=
    ( w3a wa simpl3 3ad2ant1 ) ABCGDHECFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1r1 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) ) /\ ta /\ et ) -> ph ) $=
    ( w3a wa simpr1 3ad2ant1 ) DABCGHEAFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1r2 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) ) /\ ta /\ et ) -> ps ) $=
    ( w3a wa simpr2 3ad2ant1 ) DABCGHEBFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp1r3 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) ) /\ ta /\ et ) -> ch ) $=
    ( w3a wa simpr3 3ad2ant1 ) DABCGHECFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2l1 $p |- ( ( ta /\ ( ( ph /\ ps /\ ch ) /\ th ) /\ et ) -> ph ) $=
    ( w3a wa simpl1 3ad2ant2 ) ABCGDHEAFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2l2 $p |- ( ( ta /\ ( ( ph /\ ps /\ ch ) /\ th ) /\ et ) -> ps ) $=
    ( w3a wa simpl2 3ad2ant2 ) ABCGDHEBFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2l3 $p |- ( ( ta /\ ( ( ph /\ ps /\ ch ) /\ th ) /\ et ) -> ch ) $=
    ( w3a wa simpl3 3ad2ant2 ) ABCGDHECFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2r1 $p |- ( ( ta /\ ( th /\ ( ph /\ ps /\ ch ) ) /\ et ) -> ph ) $=
    ( w3a wa simpr1 3ad2ant2 ) DABCGHEAFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2r2 $p |- ( ( ta /\ ( th /\ ( ph /\ ps /\ ch ) ) /\ et ) -> ps ) $=
    ( w3a wa simpr2 3ad2ant2 ) DABCGHEBFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp2r3 $p |- ( ( ta /\ ( th /\ ( ph /\ ps /\ ch ) ) /\ et ) -> ch ) $=
    ( w3a wa simpr3 3ad2ant2 ) DABCGHECFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3l1 $p |- ( ( ta /\ et /\ ( ( ph /\ ps /\ ch ) /\ th ) ) -> ph ) $=
    ( w3a wa simpl1 3ad2ant3 ) ABCGDHEAFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3l2 $p |- ( ( ta /\ et /\ ( ( ph /\ ps /\ ch ) /\ th ) ) -> ps ) $=
    ( w3a wa simpl2 3ad2ant3 ) ABCGDHEBFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3l3 $p |- ( ( ta /\ et /\ ( ( ph /\ ps /\ ch ) /\ th ) ) -> ch ) $=
    ( w3a wa simpl3 3ad2ant3 ) ABCGDHECFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3r1 $p |- ( ( ta /\ et /\ ( th /\ ( ph /\ ps /\ ch ) ) ) -> ph ) $=
    ( w3a wa simpr1 3ad2ant3 ) DABCGHEAFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3r2 $p |- ( ( ta /\ et /\ ( th /\ ( ph /\ ps /\ ch ) ) ) -> ps ) $=
    ( w3a wa simpr2 3ad2ant3 ) DABCGHEBFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp3r3 $p |- ( ( ta /\ et /\ ( th /\ ( ph /\ ps /\ ch ) ) ) -> ch ) $=
    ( w3a wa simpr3 3ad2ant3 ) DABCGHECFDABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp11l $p |- ( ( ( ( ph /\ ps ) /\ ch /\ th ) /\ ta /\ et ) -> ph ) $=
    ( wa w3a simp1l 3ad2ant1 ) ABGCDHEAFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp11r $p |- ( ( ( ( ph /\ ps ) /\ ch /\ th ) /\ ta /\ et ) -> ps ) $=
    ( wa w3a simp1r 3ad2ant1 ) ABGCDHEBFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp12l $p |- ( ( ( ch /\ ( ph /\ ps ) /\ th ) /\ ta /\ et ) -> ph ) $=
    ( wa w3a simp2l 3ad2ant1 ) CABGDHEAFCABDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp12r $p |- ( ( ( ch /\ ( ph /\ ps ) /\ th ) /\ ta /\ et ) -> ps ) $=
    ( wa w3a simp2r 3ad2ant1 ) CABGDHEBFCABDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp13l $p |- ( ( ( ch /\ th /\ ( ph /\ ps ) ) /\ ta /\ et ) -> ph ) $=
    ( wa w3a simp3l 3ad2ant1 ) CDABGHEAFCDABIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp13r $p |- ( ( ( ch /\ th /\ ( ph /\ ps ) ) /\ ta /\ et ) -> ps ) $=
    ( wa w3a simp3r 3ad2ant1 ) CDABGHEBFCDABIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp21l $p |- ( ( ta /\ ( ( ph /\ ps ) /\ ch /\ th ) /\ et ) -> ph ) $=
    ( wa w3a simp1l 3ad2ant2 ) ABGCDHEAFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp21r $p |- ( ( ta /\ ( ( ph /\ ps ) /\ ch /\ th ) /\ et ) -> ps ) $=
    ( wa w3a simp1r 3ad2ant2 ) ABGCDHEBFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp22l $p |- ( ( ta /\ ( ch /\ ( ph /\ ps ) /\ th ) /\ et ) -> ph ) $=
    ( wa w3a simp2l 3ad2ant2 ) CABGDHEAFCABDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp22r $p |- ( ( ta /\ ( ch /\ ( ph /\ ps ) /\ th ) /\ et ) -> ps ) $=
    ( wa w3a simp2r 3ad2ant2 ) CABGDHEBFCABDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp23l $p |- ( ( ta /\ ( ch /\ th /\ ( ph /\ ps ) ) /\ et ) -> ph ) $=
    ( wa w3a simp3l 3ad2ant2 ) CDABGHEAFCDABIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp23r $p |- ( ( ta /\ ( ch /\ th /\ ( ph /\ ps ) ) /\ et ) -> ps ) $=
    ( wa w3a simp3r 3ad2ant2 ) CDABGHEBFCDABIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp31l $p |- ( ( ta /\ et /\ ( ( ph /\ ps ) /\ ch /\ th ) ) -> ph ) $=
    ( wa w3a simp1l 3ad2ant3 ) ABGCDHEAFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp31r $p |- ( ( ta /\ et /\ ( ( ph /\ ps ) /\ ch /\ th ) ) -> ps ) $=
    ( wa w3a simp1r 3ad2ant3 ) ABGCDHEBFABCDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp32l $p |- ( ( ta /\ et /\ ( ch /\ ( ph /\ ps ) /\ th ) ) -> ph ) $=
    ( wa w3a simp2l 3ad2ant3 ) CABGDHEAFCABDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp32r $p |- ( ( ta /\ et /\ ( ch /\ ( ph /\ ps ) /\ th ) ) -> ps ) $=
    ( wa w3a simp2r 3ad2ant3 ) CABGDHEBFCABDIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp33l $p |- ( ( ta /\ et /\ ( ch /\ th /\ ( ph /\ ps ) ) ) -> ph ) $=
    ( wa w3a simp3l 3ad2ant3 ) CDABGHEAFCDABIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp33r $p |- ( ( ta /\ et /\ ( ch /\ th /\ ( ph /\ ps ) ) ) -> ps ) $=
    ( wa w3a simp3r 3ad2ant3 ) CDABGHEBFCDABIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp111 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ et /\ ze ) -> ph ) $=
    ( w3a simp11 3ad2ant1 ) ABCHDEHFAGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp112 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ et /\ ze ) -> ps ) $=
    ( w3a simp12 3ad2ant1 ) ABCHDEHFBGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp113 $p |- ( ( ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ et /\ ze ) -> ch ) $=
    ( w3a simp13 3ad2ant1 ) ABCHDEHFCGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp121 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ et /\ ze ) -> ph ) $=
    ( w3a simp21 3ad2ant1 ) DABCHEHFAGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp122 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ et /\ ze ) -> ps ) $=
    ( w3a simp22 3ad2ant1 ) DABCHEHFBGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp123 $p |- ( ( ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ et /\ ze ) -> ch ) $=
    ( w3a simp23 3ad2ant1 ) DABCHEHFCGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp131 $p |- ( ( ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ et /\ ze ) -> ph ) $=
    ( w3a simp31 3ad2ant1 ) DEABCHHFAGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp132 $p |- ( ( ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ et /\ ze ) -> ps ) $=
    ( w3a simp32 3ad2ant1 ) DEABCHHFBGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp133 $p |- ( ( ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ et /\ ze ) -> ch ) $=
    ( w3a simp33 3ad2ant1 ) DEABCHHFCGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp211 $p |- ( ( et /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ ze ) -> ph ) $=
    ( w3a simp11 3ad2ant2 ) ABCHDEHFAGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp212 $p |- ( ( et /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ ze ) -> ps ) $=
    ( w3a simp12 3ad2ant2 ) ABCHDEHFBGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp213 $p |- ( ( et /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) /\ ze ) -> ch ) $=
    ( w3a simp13 3ad2ant2 ) ABCHDEHFCGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp221 $p |- ( ( et /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ ze ) -> ph ) $=
    ( w3a simp21 3ad2ant2 ) DABCHEHFAGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp222 $p |- ( ( et /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ ze ) -> ps ) $=
    ( w3a simp22 3ad2ant2 ) DABCHEHFBGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp223 $p |- ( ( et /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) /\ ze ) -> ch ) $=
    ( w3a simp23 3ad2ant2 ) DABCHEHFCGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp231 $p |- ( ( et /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ ze ) -> ph ) $=
    ( w3a simp31 3ad2ant2 ) DEABCHHFAGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp232 $p |- ( ( et /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ ze ) -> ps ) $=
    ( w3a simp32 3ad2ant2 ) DEABCHHFBGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp233 $p |- ( ( et /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) /\ ze ) -> ch ) $=
    ( w3a simp33 3ad2ant2 ) DEABCHHFCGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp311 $p |- ( ( et /\ ze /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) ) -> ph ) $=
    ( w3a simp11 3ad2ant3 ) ABCHDEHFAGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp312 $p |- ( ( et /\ ze /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) ) -> ps ) $=
    ( w3a simp12 3ad2ant3 ) ABCHDEHFBGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp313 $p |- ( ( et /\ ze /\ ( ( ph /\ ps /\ ch ) /\ th /\ ta ) ) -> ch ) $=
    ( w3a simp13 3ad2ant3 ) ABCHDEHFCGABCDEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp321 $p |- ( ( et /\ ze /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) ) -> ph ) $=
    ( w3a simp21 3ad2ant3 ) DABCHEHFAGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp322 $p |- ( ( et /\ ze /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) ) -> ps ) $=
    ( w3a simp22 3ad2ant3 ) DABCHEHFBGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp323 $p |- ( ( et /\ ze /\ ( th /\ ( ph /\ ps /\ ch ) /\ ta ) ) -> ch ) $=
    ( w3a simp23 3ad2ant3 ) DABCHEHFCGDABCEIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp331 $p |- ( ( et /\ ze /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) ) -> ph ) $=
    ( w3a simp31 3ad2ant3 ) DEABCHHFAGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp332 $p |- ( ( et /\ ze /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) ) -> ps ) $=
    ( w3a simp32 3ad2ant3 ) DEABCHHFBGDEABCIJ $.

  $( Simplification of conjunction.  (Contributed by NM, 9-Mar-2012.) $)
  simp333 $p |- ( ( et /\ ze /\ ( th /\ ta /\ ( ph /\ ps /\ ch ) ) ) -> ch ) $=
    ( w3a simp33 3ad2ant3 ) DEABCHHFCGDEABCIJ $.

  ${
    3adantl.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       24-Feb-2005.) $)
    3adantl1 $p |- ( ( ( ta /\ ph /\ ps ) /\ ch ) -> th ) $=
      ( w3a wa 3simpc sylan ) EABGABHCDEABIFJ $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       24-Feb-2005.) $)
    3adantl2 $p |- ( ( ( ph /\ ta /\ ps ) /\ ch ) -> th ) $=
      ( w3a wa 3simpb sylan ) AEBGABHCDAEBIFJ $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       24-Feb-2005.) $)
    3adantl3 $p |- ( ( ( ph /\ ps /\ ta ) /\ ch ) -> th ) $=
      ( w3a wa 3simpa sylan ) ABEGABHCDABEIFJ $.
  $}

  ${
    3adantr.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       27-Apr-2005.) $)
    3adantr1 $p |- ( ( ph /\ ( ta /\ ps /\ ch ) ) -> th ) $=
      ( w3a wa 3simpc sylan2 ) EBCGABCHDEBCIFJ $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       27-Apr-2005.) $)
    3adantr2 $p |- ( ( ph /\ ( ps /\ ta /\ ch ) ) -> th ) $=
      ( w3a wa 3simpb sylan2 ) BECGABCHDBECIFJ $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       27-Apr-2005.) $)
    3adantr3 $p |- ( ( ph /\ ( ps /\ ch /\ ta ) ) -> th ) $=
      ( w3a wa 3simpa sylan2 ) BCEGABCHDBCEIFJ $.
  $}

  ${
    3ad2antl.1 $e |- ( ( ph /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       4-Aug-2007.) $)
    3ad2antl1 $p |- ( ( ( ph /\ ps /\ ta ) /\ ch ) -> th ) $=
      ( adantlr 3adantl2 ) AECDBACDEFGH $.

    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       4-Aug-2007.) $)
    3ad2antl2 $p |- ( ( ( ps /\ ph /\ ta ) /\ ch ) -> th ) $=
      ( adantlr 3adantl1 ) AECDBACDEFGH $.

    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       4-Aug-2007.) $)
    3ad2antl3 $p |- ( ( ( ps /\ ta /\ ph ) /\ ch ) -> th ) $=
      ( adantll 3adantl1 ) EACDBACDEFGH $.

    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       25-Dec-2007.) $)
    3ad2antr1 $p |- ( ( ph /\ ( ch /\ ps /\ ta ) ) -> th ) $=
      ( adantrr 3adantr3 ) ACBDEACDBFGH $.

    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       27-Dec-2007.) $)
    3ad2antr2 $p |- ( ( ph /\ ( ps /\ ch /\ ta ) ) -> th ) $=
      ( adantrl 3adantr3 ) ABCDEACDBFGH $.

    $( Deduction adding conjuncts to antecedent.  (Contributed by NM,
       30-Dec-2007.) $)
    3ad2antr3 $p |- ( ( ph /\ ( ps /\ ta /\ ch ) ) -> th ) $=
      ( adantrl 3adantr1 ) AECDBACDEFGH $.
  $}

  ${
    3anibar.1 $e |- ( ( ph /\ ps /\ ch ) -> ( th <-> ( ch /\ ta ) ) ) $.
    $( Remove a hypothesis from the second member of a biimplication.
       (Contributed by FL, 22-Jul-2008.) $)
    3anibar $p |- ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) $=
      ( w3a wa simp3 biantrurd bitr4d ) ABCGZDCEHEFLCEABCIJK $.
  $}

  $( Introduction in triple disjunction.  (Contributed by NM, 4-Apr-1995.) $)
  3mix1 $p |- ( ph -> ( ph \/ ps \/ ch ) ) $=
    ( wo w3o orc 3orass sylibr ) AABCDZDABCEAIFABCGH $.

  $( Introduction in triple disjunction.  (Contributed by NM, 4-Apr-1995.) $)
  3mix2 $p |- ( ph -> ( ps \/ ph \/ ch ) ) $=
    ( w3o 3mix1 3orrot sylibr ) AACBDBACDACBEBACFG $.

  $( Introduction in triple disjunction.  (Contributed by NM, 4-Apr-1995.) $)
  3mix3 $p |- ( ph -> ( ps \/ ch \/ ph ) ) $=
    ( w3o 3mix1 3orrot sylib ) AABCDBCADABCEABCFG $.

  ${
    3mixi.1 $e |- ph $.
    $( Introduction in triple disjunction.  (Contributed by Mario Carneiro,
       6-Oct-2014.) $)
    3mix1i $p |- ( ph \/ ps \/ ch ) $=
      ( w3o 3mix1 ax-mp ) AABCEDABCFG $.

    $( Introduction in triple disjunction.  (Contributed by Mario Carneiro,
       6-Oct-2014.) $)
    3mix2i $p |- ( ps \/ ph \/ ch ) $=
      ( w3o 3mix2 ax-mp ) ABACEDABCFG $.

    $( Introduction in triple disjunction.  (Contributed by Mario Carneiro,
       6-Oct-2014.) $)
    3mix3i $p |- ( ps \/ ch \/ ph ) $=
      ( w3o 3mix3 ax-mp ) ABCAEDABCFG $.
  $}

  ${
    3pm3.2i.1 $e |- ph $.
    3pm3.2i.2 $e |- ps $.
    3pm3.2i.3 $e |- ch $.
    $( Infer conjunction of premises.  (Contributed by NM, 10-Feb-1995.) $)
    3pm3.2i $p |- ( ph /\ ps /\ ch ) $=
      ( w3a wa pm3.2i df-3an mpbir2an ) ABCGABHCABDEIFABCJK $.
  $}

  ${
    $( ~ pm3.2 for a triple conjunction.  (Contributed by Alan Sare,
       24-Oct-2011.) $)
    pm3.2an3 $p |- ( ph -> ( ps -> ( ch -> ( ph /\ ps /\ ch ) ) ) ) $=
      ( wa w3a wi pm3.2 ex df-3an bicomi syl8ib ) ABCABDZCDZABCEZABCMFLCGHNMABC
      IJK $.
  $}

  ${
    3jca.1 $e |- ( ph -> ps ) $.
    3jca.2 $e |- ( ph -> ch ) $.
    3jca.3 $e |- ( ph -> th ) $.
    $( Join consequents with conjunction.  (Contributed by NM, 9-Apr-1994.) $)
    3jca $p |- ( ph -> ( ps /\ ch /\ th ) ) $=
      ( wa w3a jca31 df-3an sylibr ) ABCHDHBCDIABCDEFGJBCDKL $.
  $}

  ${
    3jcad.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3jcad.2 $e |- ( ph -> ( ps -> th ) ) $.
    3jcad.3 $e |- ( ph -> ( ps -> ta ) ) $.
    $( Deduction conjoining the consequents of three implications.
       (Contributed by NM, 25-Sep-2005.) $)
    3jcad $p |- ( ph -> ( ps -> ( ch /\ th /\ ta ) ) ) $=
      ( w3a wa imp 3jca ex ) ABCDEIABJCDEABCFKABDGKABEHKLM $.
  $}

  ${
    mpbir3an.1 $e |- ps $.
    mpbir3an.2 $e |- ch $.
    mpbir3an.3 $e |- th $.
    mpbir3an.4 $e |- ( ph <-> ( ps /\ ch /\ th ) ) $.
    $( Detach a conjunction of truths in a biconditional.  (Contributed by NM,
       16-Sep-2011.) $)
    mpbir3an $p |- ph $=
      ( w3a 3pm3.2i mpbir ) ABCDIBCDEFGJHK $.
  $}

  ${
    mpbir3and.1 $e |- ( ph -> ch ) $.
    mpbir3and.2 $e |- ( ph -> th ) $.
    mpbir3and.3 $e |- ( ph -> ta ) $.
    mpbir3and.4 $e |- ( ph -> ( ps <-> ( ch /\ th /\ ta ) ) ) $.
    $( Detach a conjunction of truths in a biconditional.  (Contributed by
       Mario Carneiro, 11-May-2014.)  (Revised by Mario Carneiro,
       9-Jan-2015.) $)
    mpbir3and $p |- ( ph -> ps ) $=
      ( w3a 3jca mpbird ) ABCDEJACDEFGHKIL $.
  $}

  ${
    syl3anbrc.1 $e |- ( ph -> ps ) $.
    syl3anbrc.2 $e |- ( ph -> ch ) $.
    syl3anbrc.3 $e |- ( ph -> th ) $.
    syl3anbrc.4 $e |- ( ta <-> ( ps /\ ch /\ th ) ) $.
    $( Syllogism inference.  (Contributed by Mario Carneiro, 11-May-2014.) $)
    syl3anbrc $p |- ( ph -> ta ) $=
      ( w3a 3jca sylibr ) ABCDJEABCDFGHKIL $.
  $}

  ${
    3anim123i.1 $e |- ( ph -> ps ) $.
    3anim123i.2 $e |- ( ch -> th ) $.
    3anim123i.3 $e |- ( ta -> et ) $.
    $( Join antecedents and consequents with conjunction.  (Contributed by NM,
       8-Apr-1994.) $)
    3anim123i $p |- ( ( ph /\ ch /\ ta ) -> ( ps /\ th /\ et ) ) $=
      ( w3a 3ad2ant1 3ad2ant2 3ad2ant3 3jca ) ACEJBDFACBEGKCADEHLEAFCIMN $.
  $}

  ${
    3animi.1 $e |- ( ph -> ps ) $.
    $( Add two conjuncts to antecedent and consequent.  (Contributed by Jeff
       Hankins, 16-Aug-2009.) $)
    3anim1i $p |- ( ( ph /\ ch /\ th ) -> ( ps /\ ch /\ th ) ) $=
      ( id 3anim123i ) ABCCDDECFDFG $.

    $( Add two conjuncts to antecedent and consequent.  (Contributed by Jeff
       Hankins, 19-Aug-2009.) $)
    3anim3i $p |- ( ( ch /\ th /\ ph ) -> ( ch /\ th /\ ps ) ) $=
      ( id 3anim123i ) CCDDABCFDFEG $.
  $}

  ${
    bi3.1 $e |- ( ph <-> ps ) $.
    bi3.2 $e |- ( ch <-> th ) $.
    bi3.3 $e |- ( ta <-> et ) $.
    $( Join 3 biconditionals with conjunction.  (Contributed by NM,
       21-Apr-1994.) $)
    3anbi123i $p |- ( ( ph /\ ch /\ ta ) <-> ( ps /\ th /\ et ) ) $=
      ( wa w3a anbi12i df-3an 3bitr4i ) ACJZEJBDJZFJACEKBDFKOPEFABCDGHLILACEMBD
      FMN $.

    $( Join 3 biconditionals with disjunction.  (Contributed by NM,
       17-May-1994.) $)
    3orbi123i $p |- ( ( ph \/ ch \/ ta ) <-> ( ps \/ th \/ et ) ) $=
      ( wo w3o orbi12i df-3or 3bitr4i ) ACJZEJBDJZFJACEKBDFKOPEFABCDGHLILACEMBD
      FMN $.
  $}

  ${
    3anbi1i.1 $e |- ( ph <-> ps ) $.
    $( Inference adding two conjuncts to each side of a biconditional.
       (Contributed by NM, 8-Sep-2006.) $)
    3anbi1i $p |- ( ( ph /\ ch /\ th ) <-> ( ps /\ ch /\ th ) ) $=
      ( biid 3anbi123i ) ABCCDDECFDFG $.

    $( Inference adding two conjuncts to each side of a biconditional.
       (Contributed by NM, 8-Sep-2006.) $)
    3anbi2i $p |- ( ( ch /\ ph /\ th ) <-> ( ch /\ ps /\ th ) ) $=
      ( biid 3anbi123i ) CCABDDCFEDFG $.

    $( Inference adding two conjuncts to each side of a biconditional.
       (Contributed by NM, 8-Sep-2006.) $)
    3anbi3i $p |- ( ( ch /\ th /\ ph ) <-> ( ch /\ th /\ ps ) ) $=
      ( biid 3anbi123i ) CCDDABCFDFEG $.
  $}

  ${
    3imp.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Importation inference.  (Contributed by NM, 8-Apr-1994.) $)
    3imp $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( w3a wa df-3an imp31 sylbi ) ABCFABGCGDABCHABCDEIJ $.
  $}

  ${
    3impa.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $.
    $( Importation from double to triple conjunction.  (Contributed by NM,
       20-Aug-1995.) $)
    3impa $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( exp31 3imp ) ABCDABCDEFG $.
  $}

  ${
    3impb.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( Importation from double to triple conjunction.  (Contributed by NM,
       20-Aug-1995.) $)
    3impb $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( exp32 3imp ) ABCDABCDEFG $.
  $}

  ${
    3impia.1 $e |- ( ( ph /\ ps ) -> ( ch -> th ) ) $.
    $( Importation to triple conjunction.  (Contributed by NM, 13-Jun-2006.) $)
    3impia $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wi ex 3imp ) ABCDABCDFEGH $.
  $}

  ${
    3impib.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Importation to triple conjunction.  (Contributed by NM, 13-Jun-2006.) $)
    3impib $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( exp3a 3imp ) ABCDABCDEFG $.
  $}

  ${
    3exp.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Exportation inference.  (Contributed by NM, 30-May-1994.) $)
    3exp $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( w3a pm3.2an3 syl8 ) ABCABCFDABCGEH $.

    $( Exportation from triple to double conjunction.  (Contributed by NM,
       20-Aug-1995.) $)
    3expa $p |- ( ( ( ph /\ ps ) /\ ch ) -> th ) $=
      ( 3exp imp31 ) ABCDABCDEFG $.

    $( Exportation from triple to double conjunction.  (Contributed by NM,
       20-Aug-1995.) $)
    3expb $p |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $=
      ( 3exp imp32 ) ABCDABCDEFG $.

    $( Exportation from triple conjunction.  (Contributed by NM,
       19-May-2007.) $)
    3expia $p |- ( ( ph /\ ps ) -> ( ch -> th ) ) $=
      ( wi 3exp imp ) ABCDFABCDEGH $.

    $( Exportation from triple conjunction.  (Contributed by NM,
       19-May-2007.) $)
    3expib $p |- ( ph -> ( ( ps /\ ch ) -> th ) ) $=
      ( 3exp imp3a ) ABCDABCDEFG $.

    $( Commutation in antecedent.  Swap 1st and 3rd.  (Contributed by NM,
       28-Jan-1996.)  (Proof shortened by Andrew Salmon, 13-May-2011.) $)
    3com12 $p |- ( ( ps /\ ph /\ ch ) -> th ) $=
      ( w3a 3ancoma sylbi ) BACFABCFDBACGEH $.

    $( Commutation in antecedent.  Swap 1st and 3rd.  (Contributed by NM,
       28-Jan-1996.) $)
    3com13 $p |- ( ( ch /\ ps /\ ph ) -> th ) $=
      ( w3a 3anrev sylbi ) CBAFABCFDCBAGEH $.

    $( Commutation in antecedent.  Swap 2nd and 3rd.  (Contributed by NM,
       28-Jan-1996.) $)
    3com23 $p |- ( ( ph /\ ch /\ ps ) -> th ) $=
      ( 3exp com23 3imp ) ACBDABCDABCDEFGH $.

    $( Commutation in antecedent.  Rotate left.  (Contributed by NM,
       28-Jan-1996.) $)
    3coml $p |- ( ( ps /\ ch /\ ph ) -> th ) $=
      ( 3com23 3com13 ) ACBDABCDEFG $.

    $( Commutation in antecedent.  Rotate right.  (Contributed by NM,
       28-Jan-1996.) $)
    3comr $p |- ( ( ch /\ ph /\ ps ) -> th ) $=
      ( 3coml ) BCADABCDEFF $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       16-Feb-2008.) $)
    3adant3r1 $p |- ( ( ph /\ ( ta /\ ps /\ ch ) ) -> th ) $=
      ( 3expb 3adantr1 ) ABCDEABCDFGH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       17-Feb-2008.) $)
    3adant3r2 $p |- ( ( ph /\ ( ps /\ ta /\ ch ) ) -> th ) $=
      ( 3expb 3adantr2 ) ABCDEABCDFGH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       18-Feb-2008.) $)
    3adant3r3 $p |- ( ( ph /\ ( ps /\ ch /\ ta ) ) -> th ) $=
      ( 3expb 3adantr3 ) ABCDEABCDFGH $.
  $}

  ${
    3an1rs.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( Swap conjuncts.  (Contributed by NM, 16-Dec-2007.) $)
    3an1rs $p |- ( ( ( ph /\ ps /\ th ) /\ ch ) -> ta ) $=
      ( w3a wi ex 3exp com34 3imp imp ) ABDGCEABDCEHABCDEABCDEHABCGDEFIJKLM $.
  $}

  ${
    3imp1.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $.
    $( Importation to left triple conjunction.  (Contributed by NM,
       24-Feb-2005.) $)
    3imp1 $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $=
      ( w3a wi 3imp imp ) ABCGDEABCDEHFIJ $.

    $( Importation deduction for triple conjunction.  (Contributed by NM,
       26-Oct-2006.) $)
    3impd $p |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $=
      ( w3a wi com4l 3imp com12 ) BCDGAEBCDAEHABCDEFIJK $.

    $( Importation to right triple conjunction.  (Contributed by NM,
       26-Oct-2006.) $)
    3imp2 $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $=
      ( w3a 3impd imp ) ABCDGEABCDEFHI $.
  $}

  ${
    3exp1.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( Exportation from left triple conjunction.  (Contributed by NM,
       24-Feb-2005.) $)
    3exp1 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi w3a ex 3exp ) ABCDEGABCHDEFIJ $.
  $}

  ${
    3expd.1 $e |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $.
    $( Exportation deduction for triple conjunction.  (Contributed by NM,
       26-Oct-2006.) $)
    3expd $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi w3a com12 3exp com4r ) BCDAEBCDAEGABCDHEFIJK $.
  $}

  ${
    3exp2.1 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( Exportation from right triple conjunction.  (Contributed by NM,
       26-Oct-2006.) $)
    3exp2 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( w3a ex 3expd ) ABCDEABCDGEFHI $.
  $}

  ${
    exp5o.1 $e |- ( ( ph /\ ps /\ ch ) -> ( ( th /\ ta ) -> et ) ) $.
    $( A triple exportation inference.  (Contributed by Jeff Hankins,
       8-Jul-2009.) $)
    exp5o $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi w3a exp3a 3exp ) ABCDEFHHABCIDEFGJK $.
  $}

  ${
    exp516.1 $e |- ( ( ( ph /\ ( ps /\ ch /\ th ) ) /\ ta ) -> et ) $.
    $( A triple exportation inference.  (Contributed by Jeff Hankins,
       8-Jul-2009.) $)
    exp516 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi w3a exp31 3expd ) ABCDEFHABCDIEFGJK $.
  $}

  ${
    exp520.1 $e |- ( ( ( ph /\ ps /\ ch ) /\ ( th /\ ta ) ) -> et ) $.
    $( A triple exportation inference.  (Contributed by Jeff Hankins,
       8-Jul-2009.) $)
    exp520 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( w3a wa ex exp5o ) ABCDEFABCHDEIFGJK $.
  $}

  ${
    3anassrs.1 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( Associative law for conjunction applied to antecedent (eliminates
       syllogism).  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    3anassrs $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( 3exp2 imp41 ) ABCDEABCDEFGH $.
  $}

  ${
    3adant1l.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    3adant1l $p |- ( ( ( ta /\ ph ) /\ ps /\ ch ) -> th ) $=
      ( wa 3expb adantll 3impb ) EAGBCDABCGDEABCDFHIJ $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    3adant1r $p |- ( ( ( ph /\ ta ) /\ ps /\ ch ) -> th ) $=
      ( wa 3expb adantlr 3impb ) AEGBCDABCGDEABCDFHIJ $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    3adant2l $p |- ( ( ph /\ ( ta /\ ps ) /\ ch ) -> th ) $=
      ( wa 3com12 3adant1l ) EBGACDBACDEABCDFHIH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    3adant2r $p |- ( ( ph /\ ( ps /\ ta ) /\ ch ) -> th ) $=
      ( wa 3com12 3adant1r ) BEGACDBACDEABCDFHIH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    3adant3l $p |- ( ( ph /\ ps /\ ( ta /\ ch ) ) -> th ) $=
      ( wa 3com13 3adant1l ) ECGBADCBADEABCDFHIH $.

    $( Deduction adding a conjunct to antecedent.  (Contributed by NM,
       8-Jan-2006.) $)
    3adant3r $p |- ( ( ph /\ ps /\ ( ch /\ ta ) ) -> th ) $=
      ( wa 3com13 3adant1r ) CEGBADCBADEABCDFHIH $.
  $}

  ${
    sylXanc.1 $e |- ( ph -> ps ) $.
    sylXanc.2 $e |- ( ph -> ch ) $.
    sylXanc.3 $e |- ( ph -> th ) $.
    ${
      syl12anc.4 $e |- ( ( ps /\ ( ch /\ th ) ) -> ta ) $.
      $( Syllogism combined with contraction.  (Contributed by Jeff Hankins,
         1-Aug-2009.) $)
      syl12anc $p |- ( ph -> ta ) $=
        ( wa jca32 syl ) ABCDJJEABCDFGHKIL $.
    $}

    ${
      syl21anc.4 $e |- ( ( ( ps /\ ch ) /\ th ) -> ta ) $.
      $( Syllogism combined with contraction.  (Contributed by Jeff Hankins,
         1-Aug-2009.) $)
      syl21anc $p |- ( ph -> ta ) $=
        ( wa jca31 syl ) ABCJDJEABCDFGHKIL $.
    $}

    ${
      syl111anc.4 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl3anc $p |- ( ph -> ta ) $=
        ( w3a 3jca syl ) ABCDJEABCDFGHKIL $.
    $}

    sylXanc.4 $e |- ( ph -> ta ) $.
    ${
      syl22anc.5 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta ) ) -> et ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl22anc $p |- ( ph -> et ) $=
        ( wa jca syl12anc ) ABCLDEFABCGHMIJKN $.
    $}

    ${
      syl13anc.5 $e |- ( ( ps /\ ( ch /\ th /\ ta ) ) -> et ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl13anc $p |- ( ph -> et ) $=
        ( w3a 3jca syl2anc ) ABCDELFGACDEHIJMKN $.
    $}

    ${
      syl31anc.5 $e |- ( ( ( ps /\ ch /\ th ) /\ ta ) -> et ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl31anc $p |- ( ph -> et ) $=
        ( w3a 3jca syl2anc ) ABCDLEFABCDGHIMJKN $.
    $}

    ${
      syl112anc.5 $e |- ( ( ps /\ ch /\ ( th /\ ta ) ) -> et ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl112anc $p |- ( ph -> et ) $=
        ( wa jca syl3anc ) ABCDELFGHADEIJMKN $.
    $}

    ${
      syl121anc.5 $e |- ( ( ps /\ ( ch /\ th ) /\ ta ) -> et ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl121anc $p |- ( ph -> et ) $=
        ( wa jca syl3anc ) ABCDLEFGACDHIMJKN $.
    $}

    ${
      syl211anc.5 $e |- ( ( ( ps /\ ch ) /\ th /\ ta ) -> et ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl211anc $p |- ( ph -> et ) $=
        ( wa jca syl3anc ) ABCLDEFABCGHMIJKN $.
    $}

    sylXanc.5 $e |- ( ph -> et ) $.
    ${
      syl23anc.6 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta /\ et ) ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl23anc $p |- ( ph -> ze ) $=
        ( wa jca syl13anc ) ABCNDEFGABCHIOJKLMP $.
    $}

    ${
      syl32anc.6 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et ) ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl32anc $p |- ( ph -> ze ) $=
        ( wa jca syl31anc ) ABCDEFNGHIJAEFKLOMP $.
    $}

    ${
      syl122anc.6 $e |- ( ( ps /\ ( ch /\ th ) /\ ( ta /\ et ) ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl122anc $p |- ( ph -> ze ) $=
        ( wa jca syl121anc ) ABCDEFNGHIJAEFKLOMP $.
    $}

    ${
      syl212anc.6 $e |- ( ( ( ps /\ ch ) /\ th /\ ( ta /\ et ) ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl212anc $p |- ( ph -> ze ) $=
        ( wa jca syl211anc ) ABCDEFNGHIJAEFKLOMP $.
    $}

    ${
      syl221anc.6 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta ) /\ et ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl221anc $p |- ( ph -> ze ) $=
        ( wa jca syl211anc ) ABCDENFGHIADEJKOLMP $.
    $}

    ${
      syl113anc.6 $e |- ( ( ps /\ ch /\ ( th /\ ta /\ et ) ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl113anc $p |- ( ph -> ze ) $=
        ( w3a 3jca syl3anc ) ABCDEFNGHIADEFJKLOMP $.
    $}

    ${
      syl131anc.6 $e |- ( ( ps /\ ( ch /\ th /\ ta ) /\ et ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl131anc $p |- ( ph -> ze ) $=
        ( w3a 3jca syl3anc ) ABCDENFGHACDEIJKOLMP $.
    $}

    ${
      syl311anc.6 $e |- ( ( ( ps /\ ch /\ th ) /\ ta /\ et ) -> ze ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl311anc $p |- ( ph -> ze ) $=
        ( w3a 3jca syl3anc ) ABCDNEFGABCDHIJOKLMP $.
    $}

    sylXanc.6 $e |- ( ph -> ze ) $.
    ${
      syl33anc.7 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et /\ ze ) )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl33anc $p |- ( ph -> si ) $=
        ( w3a 3jca syl13anc ) ABCDPEFGHABCDIJKQLMNOR $.
    $}

    ${
      syl222anc.7 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta ) /\ ( et /\ ze ) )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl222anc $p |- ( ph -> si ) $=
        ( wa jca syl221anc ) ABCDEFGPHIJKLAFGMNQOR $.
    $}

    ${
      syl123anc.7 $e |- ( ( ps /\ ( ch /\ th ) /\ ( ta /\ et /\ ze ) )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl123anc $p |- ( ph -> si ) $=
        ( wa jca syl113anc ) ABCDPEFGHIACDJKQLMNOR $.
    $}

    ${
      syl132anc.7 $e |- ( ( ps /\ ( ch /\ th /\ ta ) /\ ( et /\ ze ) )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Jul-2012.) $)
      syl132anc $p |- ( ph -> si ) $=
        ( wa jca syl131anc ) ABCDEFGPHIJKLAFGMNQOR $.
    $}

    ${
      syl213anc.7 $e |- ( ( ( ps /\ ch ) /\ th /\ ( ta /\ et /\ ze ) )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl213anc $p |- ( ph -> si ) $=
        ( wa jca syl113anc ) ABCPDEFGHABCIJQKLMNOR $.
    $}

    ${
      syl231anc.7 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta /\ et ) /\ ze )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl231anc $p |- ( ph -> si ) $=
        ( wa jca syl131anc ) ABCPDEFGHABCIJQKLMNOR $.
    $}

    ${
      syl312anc.7 $e |- ( ( ( ps /\ ch /\ th ) /\ ta /\ ( et /\ ze ) )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Jul-2012.) $)
      syl312anc $p |- ( ph -> si ) $=
        ( wa jca syl311anc ) ABCDEFGPHIJKLAFGMNQOR $.
    $}

    ${
      syl321anc.7 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et ) /\ ze )
           -> si ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Jul-2012.) $)
      syl321anc $p |- ( ph -> si ) $=
        ( wa jca syl311anc ) ABCDEFPGHIJKAEFLMQNOR $.
    $}

    sylXanc.7 $e |- ( ph -> si ) $.
    ${
      syl133anc.8 $e |- ( ( ps /\ ( ch /\ th /\ ta ) /\ ( et /\ ze /\ si ) )
           -> rh ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl133anc $p |- ( ph -> rh ) $=
        ( w3a 3jca syl131anc ) ABCDEFGHRIJKLMAFGHNOPSQT $.
    $}

    ${
      syl313anc.8 $e |- ( ( ( ps /\ ch /\ th ) /\ ta /\ ( et /\ ze /\ si ) )
           -> rh ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl313anc $p |- ( ph -> rh ) $=
        ( w3a 3jca syl311anc ) ABCDEFGHRIJKLMAFGHNOPSQT $.
    $}

    ${
      syl331anc.8 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et /\ ze ) /\ si )
           -> rh ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl331anc $p |- ( ph -> rh ) $=
        ( w3a 3jca syl311anc ) ABCDEFGRHIJKLAEFGMNOSPQT $.
    $}

    ${
      syl223anc.8 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta ) /\ ( et /\ ze /\ si )
          ) -> rh ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl223anc $p |- ( ph -> rh ) $=
        ( wa jca syl213anc ) ABCDERFGHIJKADELMSNOPQT $.
    $}

    ${
      syl232anc.8 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta /\ et ) /\ ( ze /\ si )
          ) -> rh ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl232anc $p |- ( ph -> rh ) $=
        ( wa jca syl231anc ) ABCDEFGHRIJKLMNAGHOPSQT $.
    $}

    ${
      syl322anc.8 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et ) /\ ( ze /\ si )
          ) -> rh ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl322anc $p |- ( ph -> rh ) $=
        ( wa jca syl321anc ) ABCDEFGHRIJKLMNAGHOPSQT $.
    $}

    sylXanc.8 $e |- ( ph -> rh ) $.
    ${
      syl233anc.9 $e |- ( ( ( ps /\ ch ) /\ ( th /\ ta /\ et ) /\ ( ze /\ si /\
          rh ) ) -> mu ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl233anc $p |- ( ph -> mu ) $=
        ( wa jca syl133anc ) ABCTDEFGHIJABCKLUAMNOPQRSUB $.
    $}

    ${
      syl323anc.9 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et ) /\ ( ze /\ si /\
          rh ) ) -> mu ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl323anc $p |- ( ph -> mu ) $=
        ( wa jca syl313anc ) ABCDEFTGHIJKLMAEFNOUAPQRSUB $.
    $}

    ${
      syl332anc.9 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et /\ ze ) /\ ( si /\
          rh ) ) -> mu ) $.
      $( Syllogism combined with contraction.  (Contributed by NM,
         11-Mar-2012.) $)
      syl332anc $p |- ( ph -> mu ) $=
        ( wa jca syl331anc ) ABCDEFGHITJKLMNOPAHIQRUASUB $.
    $}

    sylXanc.9 $e |- ( ph -> mu ) $.
    ${
      syl333anc.10 $e |- ( ( ( ps /\ ch /\ th ) /\ ( ta /\ et /\ ze )
          /\ ( si /\ rh /\ mu ) ) -> la ) $.
      $( A syllogism inference combined with contraction.  (Contributed by NM,
         10-Mar-2012.) $)
      syl333anc $p |- ( ph -> la ) $=
        ( w3a 3jca syl331anc ) ABCDEFGHIJUBKLMNOPQAHIJRSTUCUAUD $.
    $}
  $}

  ${
    syl3an1.1 $e |- ( ph -> ps ) $.
    syl3an1.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an1 $p |- ( ( ph /\ ch /\ th ) -> ta ) $=
      ( w3a 3anim1i syl ) ACDHBCDHEABCDFIGJ $.
  $}

  ${
    syl3an2.1 $e |- ( ph -> ch ) $.
    syl3an2.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an2 $p |- ( ( ps /\ ph /\ th ) -> ta ) $=
      ( wi 3exp syl5 3imp ) BADEACBDEHFBCDEGIJK $.
  $}

  ${
    syl3an3.1 $e |- ( ph -> th ) $.
    syl3an3.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an3 $p |- ( ( ps /\ ch /\ ph ) -> ta ) $=
      ( 3exp syl7 3imp ) BCAEADBCEFBCDEGHIJ $.
  $}

  ${
    syl3an1b.1 $e |- ( ph <-> ps ) $.
    syl3an1b.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an1b $p |- ( ( ph /\ ch /\ th ) -> ta ) $=
      ( biimpi syl3an1 ) ABCDEABFHGI $.
  $}

  ${
    syl3an2b.1 $e |- ( ph <-> ch ) $.
    syl3an2b.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an2b $p |- ( ( ps /\ ph /\ th ) -> ta ) $=
      ( biimpi syl3an2 ) ABCDEACFHGI $.
  $}

  ${
    syl3an3b.1 $e |- ( ph <-> th ) $.
    syl3an3b.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an3b $p |- ( ( ps /\ ch /\ ph ) -> ta ) $=
      ( biimpi syl3an3 ) ABCDEADFHGI $.
  $}

  ${
    syl3an1br.1 $e |- ( ps <-> ph ) $.
    syl3an1br.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an1br $p |- ( ( ph /\ ch /\ th ) -> ta ) $=
      ( biimpri syl3an1 ) ABCDEBAFHGI $.
  $}

  ${
    syl3an2br.1 $e |- ( ch <-> ph ) $.
    syl3an2br.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an2br $p |- ( ( ps /\ ph /\ th ) -> ta ) $=
      ( biimpri syl3an2 ) ABCDECAFHGI $.
  $}

  ${
    syl3an3br.1 $e |- ( th <-> ph ) $.
    syl3an3br.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 22-Aug-1995.) $)
    syl3an3br $p |- ( ( ps /\ ch /\ ph ) -> ta ) $=
      ( biimpri syl3an3 ) ABCDEDAFHGI $.
  $}

  ${
    syl3an.1 $e |- ( ph -> ps ) $.
    syl3an.2 $e |- ( ch -> th ) $.
    syl3an.3 $e |- ( ta -> et ) $.
    syl3an.4 $e |- ( ( ps /\ th /\ et ) -> ze ) $.
    $( A triple syllogism inference.  (Contributed by NM, 13-May-2004.) $)
    syl3an $p |- ( ( ph /\ ch /\ ta ) -> ze ) $=
      ( w3a 3anim123i syl ) ACELBDFLGABCDEFHIJMKN $.
  $}

  ${
    syl3anb.1 $e |- ( ph <-> ps ) $.
    syl3anb.2 $e |- ( ch <-> th ) $.
    syl3anb.3 $e |- ( ta <-> et ) $.
    syl3anb.4 $e |- ( ( ps /\ th /\ et ) -> ze ) $.
    $( A triple syllogism inference.  (Contributed by NM, 15-Oct-2005.) $)
    syl3anb $p |- ( ( ph /\ ch /\ ta ) -> ze ) $=
      ( w3a 3anbi123i sylbi ) ACELBDFLGABCDEFHIJMKN $.
  $}

  ${
    syl3anbr.1 $e |- ( ps <-> ph ) $.
    syl3anbr.2 $e |- ( th <-> ch ) $.
    syl3anbr.3 $e |- ( et <-> ta ) $.
    syl3anbr.4 $e |- ( ( ps /\ th /\ et ) -> ze ) $.
    $( A triple syllogism inference.  (Contributed by NM, 29-Dec-2011.) $)
    syl3anbr $p |- ( ( ph /\ ch /\ ta ) -> ze ) $=
      ( bicomi syl3anb ) ABCDEFGBAHLDCILFEJLKM $.
  $}

  ${
    syld3an3.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    syld3an3.2 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 20-May-2007.) $)
    syld3an3 $p |- ( ( ph /\ ps /\ ch ) -> ta ) $=
      ( w3a simp1 simp2 syl3anc ) ABCHABDEABCIABCJFGK $.
  $}

  ${
    syld3an1.1 $e |- ( ( ch /\ ps /\ th ) -> ph ) $.
    syld3an1.2 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 7-Jul-2008.) $)
    syld3an1 $p |- ( ( ch /\ ps /\ th ) -> ta ) $=
      ( 3com13 syld3an3 ) DBCEDBCAECBDAFHABDEGHIH $.
  $}

  ${
    syld3an2.1 $e |- ( ( ph /\ ch /\ th ) -> ps ) $.
    syld3an2.2 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( A syllogism inference.  (Contributed by NM, 20-May-2007.) $)
    syld3an2 $p |- ( ( ph /\ ch /\ th ) -> ta ) $=
      ( 3com23 syld3an3 ) ADCEADCBEACDBFHABDEGHIH $.
  $}

  ${
    syl3anl1.1 $e |- ( ph -> ps ) $.
    syl3anl1.2 $e |- ( ( ( ps /\ ch /\ th ) /\ ta ) -> et ) $.
    $( A syllogism inference.  (Contributed by NM, 24-Feb-2005.) $)
    syl3anl1 $p |- ( ( ( ph /\ ch /\ th ) /\ ta ) -> et ) $=
      ( w3a 3anim1i sylan ) ACDIBCDIEFABCDGJHK $.
  $}

  ${
    syl3anl2.1 $e |- ( ph -> ch ) $.
    syl3anl2.2 $e |- ( ( ( ps /\ ch /\ th ) /\ ta ) -> et ) $.
    $( A syllogism inference.  (Contributed by NM, 24-Feb-2005.) $)
    syl3anl2 $p |- ( ( ( ps /\ ph /\ th ) /\ ta ) -> et ) $=
      ( w3a wi ex syl3an2 imp ) BADIEFABCDEFJGBCDIEFHKLM $.
  $}

  ${
    syl3anl3.1 $e |- ( ph -> th ) $.
    syl3anl3.2 $e |- ( ( ( ps /\ ch /\ th ) /\ ta ) -> et ) $.
    $( A syllogism inference.  (Contributed by NM, 24-Feb-2005.) $)
    syl3anl3 $p |- ( ( ( ps /\ ch /\ ph ) /\ ta ) -> et ) $=
      ( w3a 3anim3i sylan ) BCAIBCDIEFADBCGJHK $.
  $}

  ${
    syl3anl.1 $e |- ( ph -> ps ) $.
    syl3anl.2 $e |- ( ch -> th ) $.
    syl3anl.3 $e |- ( ta -> et ) $.
    syl3anl.4 $e |- ( ( ( ps /\ th /\ et ) /\ ze ) -> si ) $.
    $( A triple syllogism inference.  (Contributed by NM, 24-Dec-2006.) $)
    syl3anl $p |- ( ( ( ph /\ ch /\ ta ) /\ ze ) -> si ) $=
      ( w3a 3anim123i sylan ) ACEMBDFMGHABCDEFIJKNLO $.
  $}

  ${
    syl3anr1.1 $e |- ( ph -> ps ) $.
    syl3anr1.2 $e |- ( ( ch /\ ( ps /\ th /\ ta ) ) -> et ) $.
    $( A syllogism inference.  (Contributed by NM, 31-Jul-2007.) $)
    syl3anr1 $p |- ( ( ch /\ ( ph /\ th /\ ta ) ) -> et ) $=
      ( w3a 3anim1i sylan2 ) ADEICBDEIFABDEGJHK $.
  $}

  ${
    syl3anr2.1 $e |- ( ph -> th ) $.
    syl3anr2.2 $e |- ( ( ch /\ ( ps /\ th /\ ta ) ) -> et ) $.
    $( A syllogism inference.  (Contributed by NM, 1-Aug-2007.) $)
    syl3anr2 $p |- ( ( ch /\ ( ps /\ ph /\ ta ) ) -> et ) $=
      ( w3a ancoms syl3anl2 ) BAEICFABDECFGCBDEIFHJKJ $.
  $}

  ${
    syl3anr3.1 $e |- ( ph -> ta ) $.
    syl3anr3.2 $e |- ( ( ch /\ ( ps /\ th /\ ta ) ) -> et ) $.
    $( A syllogism inference.  (Contributed by NM, 23-Aug-2007.) $)
    syl3anr3 $p |- ( ( ch /\ ( ps /\ th /\ ph ) ) -> et ) $=
      ( w3a 3anim3i sylan2 ) BDAICBDEIFAEBDGJHK $.
  $}

  ${
    3impdi.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) ) -> th ) $.
    $( Importation inference (undistribute conjunction).  (Contributed by NM,
       14-Aug-1995.) $)
    3impdi $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( anandis 3impb ) ABCDABCDEFG $.
  $}

  ${
    3impdir.1 $e |- ( ( ( ph /\ ps ) /\ ( ch /\ ps ) ) -> th ) $.
    $( Importation inference (undistribute conjunction).  (Contributed by NM,
       20-Aug-1995.) $)
    3impdir $p |- ( ( ph /\ ch /\ ps ) -> th ) $=
      ( anandirs 3impa ) ACBDACBDEFG $.
  $}

  ${
    3anidm12.1 $e |- ( ( ph /\ ph /\ ps ) -> ch ) $.
    $( Inference from idempotent law for conjunction.  (Contributed by NM,
       7-Mar-2008.) $)
    3anidm12 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( 3expib anabsi5 ) ABCAABCDEF $.
  $}

  ${
    3anidm13.1 $e |- ( ( ph /\ ps /\ ph ) -> ch ) $.
    $( Inference from idempotent law for conjunction.  (Contributed by NM,
       7-Mar-2008.) $)
    3anidm13 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( 3com23 3anidm12 ) ABCABACDEF $.
  $}

  ${
    3anidm23.1 $e |- ( ( ph /\ ps /\ ps ) -> ch ) $.
    $( Inference from idempotent law for conjunction.  (Contributed by NM,
       1-Feb-2007.) $)
    3anidm23 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( 3expa anabss3 ) ABCABBCDEF $.
  $}

  ${
    3ori.1 $e |- ( ph \/ ps \/ ch ) $.
    $( Infer implication from triple disjunction.  (Contributed by NM,
       26-Sep-2006.) $)
    3ori $p |- ( ( -. ph /\ -. ps ) -> ch ) $=
      ( wn wa wo ioran w3o df-3or mpbi ori sylbir ) AEBEFABGZECABHNCABCINCGDABC
      JKLM $.
  $}

  $( Disjunction of 3 antecedents.  (Contributed by NM, 8-Apr-1994.) $)
  3jao $p |- ( ( ( ph -> ps ) /\ ( ch -> ps ) /\ ( th -> ps ) ) ->
              ( ( ph \/ ch \/ th ) -> ps ) ) $=
    ( w3o wo wi w3a df-3or jao syl6 3imp syl5bi ) ACDEACFZDFZABGZCBGZDBGZHBACDI
    PQROBGZPQNBGRSGABCJNBDJKLM $.

  $( Disjunction of 3 antecedents.  (Contributed by NM, 13-Sep-2011.) $)
  3jaob $p |- ( ( ( ph \/ ch \/ th ) -> ps ) <->
              ( ( ph -> ps ) /\ ( ch -> ps ) /\ ( th -> ps ) ) ) $=
    ( w3o wi w3a 3mix1 imim1i 3mix2 3mix3 3jca 3jao impbii ) ACDEZBFZABFZCBFZDB
    FZGPQRSAOBACDHICOBCADJIDOBDACKILABCDMN $.

  ${
    3jaoi.1 $e |- ( ph -> ps ) $.
    3jaoi.2 $e |- ( ch -> ps ) $.
    3jaoi.3 $e |- ( th -> ps ) $.
    $( Disjunction of 3 antecedents (inference).  (Contributed by NM,
       12-Sep-1995.) $)
    3jaoi $p |- ( ( ph \/ ch \/ th ) -> ps ) $=
      ( wi w3a w3o 3pm3.2i 3jao ax-mp ) ABHZCBHZDBHZIACDJBHNOPEFGKABCDLM $.
  $}

  ${
    3jaod.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3jaod.2 $e |- ( ph -> ( th -> ch ) ) $.
    3jaod.3 $e |- ( ph -> ( ta -> ch ) ) $.
    $( Disjunction of 3 antecedents (deduction).  (Contributed by NM,
       14-Oct-2005.) $)
    3jaod $p |- ( ph -> ( ( ps \/ th \/ ta ) -> ch ) ) $=
      ( wi w3o 3jao syl3anc ) ABCIDCIECIBDEJCIFGHBCDEKL $.
  $}

  ${
    3jaoian.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    3jaoian.2 $e |- ( ( th /\ ps ) -> ch ) $.
    3jaoian.3 $e |- ( ( ta /\ ps ) -> ch ) $.
    $( Disjunction of 3 antecedents (inference).  (Contributed by NM,
       14-Oct-2005.) $)
    3jaoian $p |- ( ( ( ph \/ th \/ ta ) /\ ps ) -> ch ) $=
      ( w3o wi ex 3jaoi imp ) ADEIBCABCJDEABCFKDBCGKEBCHKLM $.
  $}

  ${
    3jaodan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    3jaodan.2 $e |- ( ( ph /\ th ) -> ch ) $.
    3jaodan.3 $e |- ( ( ph /\ ta ) -> ch ) $.
    $( Disjunction of 3 antecedents (deduction).  (Contributed by NM,
       14-Oct-2005.) $)
    3jaodan $p |- ( ( ph /\ ( ps \/ th \/ ta ) ) -> ch ) $=
      ( w3o ex 3jaod imp ) ABDEICABCDEABCFJADCGJAECHJKL $.
  $}

  ${
    3jaao.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3jaao.2 $e |- ( th -> ( ta -> ch ) ) $.
    3jaao.3 $e |- ( et -> ( ze -> ch ) ) $.
    $( Inference conjoining and disjoining the antecedents of three
       implications.  (Contributed by Jeff Hankins, 15-Aug-2009.)  (Proof
       shortened by Andrew Salmon, 13-May-2011.) $)
    3jaao $p |- ( ( ph /\ th /\ et ) -> ( ( ps \/ ta \/ ze ) -> ch ) ) $=
      ( w3a wi 3ad2ant1 3ad2ant2 3ad2ant3 3jaod ) ADFKBCEGADBCLFHMDAECLFINFAGCL
      DJOP $.
  $}

  ${
    syl3an9b.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    syl3an9b.2 $e |- ( th -> ( ch <-> ta ) ) $.
    syl3an9b.3 $e |- ( et -> ( ta <-> ze ) ) $.
    $( Nested syllogism inference conjoining 3 dissimilar antecedents.
       (Contributed by NM, 1-May-1995.) $)
    syl3an9b $p |- ( ( ph /\ th /\ et ) -> ( ps <-> ze ) ) $=
      ( wb wa sylan9bb 3impa ) ADFBGKADLBEFGABCDEHIMJMN $.
  $}

  ${
    bi3d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    bi3d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    bi3d.3 $e |- ( ph -> ( et <-> ze ) ) $.
    $( Deduction joining 3 equivalences to form equivalence of disjunctions.
       (Contributed by NM, 20-Apr-1994.) $)
    3orbi123d $p |- ( ph -> ( ( ps \/ th \/ et ) <-> ( ch \/ ta \/ ze ) ) ) $=
      ( wo w3o orbi12d df-3or 3bitr4g ) ABDKZFKCEKZGKBDFLCEGLAPQFGABCDEHIMJMBDF
      NCEGNO $.

    $( Deduction joining 3 equivalences to form equivalence of conjunctions.
       (Contributed by NM, 22-Apr-1994.) $)
    3anbi123d $p |- ( ph -> ( ( ps /\ th /\ et ) <-> ( ch /\ ta /\ ze ) ) ) $=
      ( wa w3a anbi12d df-3an 3bitr4g ) ABDKZFKCEKZGKBDFLCEGLAPQFGABCDEHIMJMBDF
      NCEGNO $.
  $}

  ${
    3anbi12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    3anbi12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Deduction conjoining and adding a conjunct to equivalences.
       (Contributed by NM, 8-Sep-2006.) $)
    3anbi12d $p |- ( ph -> ( ( ps /\ th /\ et ) <-> ( ch /\ ta /\ et ) ) ) $=
      ( biidd 3anbi123d ) ABCDEFFGHAFIJ $.

    $( Deduction conjoining and adding a conjunct to equivalences.
       (Contributed by NM, 8-Sep-2006.) $)
    3anbi13d $p |- ( ph -> ( ( ps /\ et /\ th ) <-> ( ch /\ et /\ ta ) ) ) $=
      ( biidd 3anbi123d ) ABCFFDEGAFIHJ $.

    $( Deduction conjoining and adding a conjunct to equivalences.
       (Contributed by NM, 8-Sep-2006.) $)
    3anbi23d $p |- ( ph -> ( ( et /\ ps /\ th ) <-> ( et /\ ch /\ ta ) ) ) $=
      ( biidd 3anbi123d ) AFFBCDEAFIGHJ $.
  $}

  ${
    3anbi1d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction adding conjuncts to an equivalence.  (Contributed by NM,
       8-Sep-2006.) $)
    3anbi1d $p |- ( ph -> ( ( ps /\ th /\ ta ) <-> ( ch /\ th /\ ta ) ) ) $=
      ( biidd 3anbi12d ) ABCDDEFADGH $.

    $( Deduction adding conjuncts to an equivalence.  (Contributed by NM,
       8-Sep-2006.) $)
    3anbi2d $p |- ( ph -> ( ( th /\ ps /\ ta ) <-> ( th /\ ch /\ ta ) ) ) $=
      ( biidd 3anbi12d ) ADDBCEADGFH $.

    $( Deduction adding conjuncts to an equivalence.  (Contributed by NM,
       8-Sep-2006.) $)
    3anbi3d $p |- ( ph -> ( ( th /\ ta /\ ps ) <-> ( th /\ ta /\ ch ) ) ) $=
      ( biidd 3anbi13d ) ADDBCEADGFH $.
  $}

  ${
    3anim123d.1 $e |- ( ph -> ( ps -> ch ) ) $.
    3anim123d.2 $e |- ( ph -> ( th -> ta ) ) $.
    3anim123d.3 $e |- ( ph -> ( et -> ze ) ) $.
    $( Deduction joining 3 implications to form implication of conjunctions.
       (Contributed by NM, 24-Feb-2005.) $)
    3anim123d $p |- ( ph -> ( ( ps /\ th /\ et ) -> ( ch /\ ta /\ ze ) ) ) $=
      ( wa w3a anim12d df-3an 3imtr4g ) ABDKZFKCEKZGKBDFLCEGLAPQFGABCDEHIMJMBDF
      NCEGNO $.

    $( Deduction joining 3 implications to form implication of disjunctions.
       (Contributed by NM, 4-Apr-1997.) $)
    3orim123d $p |- ( ph -> ( ( ps \/ th \/ et ) -> ( ch \/ ta \/ ze ) ) ) $=
      ( wo w3o orim12d df-3or 3imtr4g ) ABDKZFKCEKZGKBDFLCEGLAPQFGABCDEHIMJMBDF
      NCEGNO $.
  $}

  $( Rearrangement of 6 conjuncts.  (Contributed by NM, 13-Mar-1995.) $)
  an6 $p |- ( ( ( ph /\ ps /\ ch ) /\ ( th /\ ta /\ et ) ) <->
              ( ( ph /\ th ) /\ ( ps /\ ta ) /\ ( ch /\ et ) ) ) $=
    ( wa w3a an4 anbi1i bitri df-3an anbi12i 3bitr4i ) ABGZCGZDEGZFGZGZADGZBEGZ
    GZCFGZGZABCHZDEFHZGTUAUCHSOQGZUCGUDOCQFIUGUBUCABDEIJKUEPUFRABCLDEFLMTUAUCLN
    $.

  $( Analog of ~ an4 for triple conjunction.  (Contributed by Scott Fenton,
     16-Mar-2011.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
  3an6 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) /\ ( ta /\ et ) ) <->
                ( ( ph /\ ch /\ ta ) /\ ( ps /\ th /\ et ) ) ) $=
    ( w3a wa an6 bicomi ) ACEGBDFGHABHCDHEFHGACEBDFIJ $.

  $( Analog of ~ or4 for triple conjunction.  (Contributed by Scott Fenton,
     16-Mar-2011.) $)
  3or6 $p |- ( ( ( ph \/ ps ) \/ ( ch \/ th ) \/ ( ta \/ et ) ) <->
                ( ( ph \/ ch \/ ta ) \/ ( ps \/ th \/ et ) ) ) $=
    ( wo w3o or4 orbi1i bitr2i df-3or orbi12i 3bitr4i ) ABGZCDGZGZEFGZGZACGZEGZ
    BDGZFGZGZOPRHACEHZBDFHZGUDTUBGZRGSTEUBFIUGQRACBDIJKOPRLUEUAUFUCACELBDFLMN
    $.

  ${
    mp3an1.1 $e |- ph $.
    mp3an1.2 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       21-Nov-1994.) $)
    mp3an1 $p |- ( ( ps /\ ch ) -> th ) $=
      ( wa 3expb mpan ) ABCGDEABCDFHI $.
  $}

  ${
    mp3an2.1 $e |- ps $.
    mp3an2.2 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       21-Nov-1994.) $)
    mp3an2 $p |- ( ( ph /\ ch ) -> th ) $=
      ( 3expa mpanl2 ) ABCDEABCDFGH $.
  $}

  ${
    mp3an3.1 $e |- ch $.
    mp3an3.2 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       21-Nov-1994.) $)
    mp3an3 $p |- ( ( ph /\ ps ) -> th ) $=
      ( wa 3expia mpi ) ABGCDEABCDFHI $.
  $}

  ${
    mp3an12.1 $e |- ph $.
    mp3an12.2 $e |- ps $.
    mp3an12.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       13-Jul-2005.) $)
    mp3an12 $p |- ( ch -> th ) $=
      ( mp3an1 mpan ) BCDFABCDEGHI $.
  $}

  ${
    mp3an13.1 $e |- ph $.
    mp3an13.2 $e |- ch $.
    mp3an13.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       14-Jul-2005.) $)
    mp3an13 $p |- ( ps -> th ) $=
      ( mp3an3 mpan ) ABDEABCDFGHI $.
  $}

  ${
    mp3an23.1 $e |- ps $.
    mp3an23.2 $e |- ch $.
    mp3an23.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       14-Jul-2005.) $)
    mp3an23 $p |- ( ph -> th ) $=
      ( mp3an3 mpan2 ) ABDEABCDFGHI $.
  $}

  ${
    mp3an1i.1 $e |- ps $.
    mp3an1i.2 $e |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 5-Jul-2005.) $)
    mp3an1i $p |- ( ph -> ( ( ch /\ th ) -> ta ) ) $=
      ( wa wi w3a com12 mp3an1 ) CDHAEBCDAEIFABCDJEGKLK $.
  $}

  ${
    mp3anl1.1 $e |- ph $.
    mp3anl1.2 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       24-Feb-2005.) $)
    mp3anl1 $p |- ( ( ( ps /\ ch ) /\ th ) -> ta ) $=
      ( wa wi w3a ex mp3an1 imp ) BCHDEABCDEIFABCJDEGKLM $.
  $}

  ${
    mp3anl2.1 $e |- ps $.
    mp3anl2.2 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       24-Feb-2005.) $)
    mp3anl2 $p |- ( ( ( ph /\ ch ) /\ th ) -> ta ) $=
      ( wa wi w3a ex mp3an2 imp ) ACHDEABCDEIFABCJDEGKLM $.
  $}

  ${
    mp3anl3.1 $e |- ch $.
    mp3anl3.2 $e |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       24-Feb-2005.) $)
    mp3anl3 $p |- ( ( ( ph /\ ps ) /\ th ) -> ta ) $=
      ( wa wi w3a ex mp3an3 imp ) ABHDEABCDEIFABCJDEGKLM $.
  $}

  ${
    mp3anr1.1 $e |- ps $.
    mp3anr1.2 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 4-Nov-2006.) $)
    mp3anr1 $p |- ( ( ph /\ ( ch /\ th ) ) -> ta ) $=
      ( wa w3a ancoms mp3anl1 ) CDHAEBCDAEFABCDIEGJKJ $.
  $}

  ${
    mp3anr2.1 $e |- ch $.
    mp3anr2.2 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       24-Nov-2006.) $)
    mp3anr2 $p |- ( ( ph /\ ( ps /\ th ) ) -> ta ) $=
      ( wa w3a ancoms mp3anl2 ) BDHAEBCDAEFABCDIEGJKJ $.
  $}

  ${
    mp3anr3.1 $e |- th $.
    mp3anr3.2 $e |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       19-Oct-2007.) $)
    mp3anr3 $p |- ( ( ph /\ ( ps /\ ch ) ) -> ta ) $=
      ( wa w3a ancoms mp3anl3 ) BCHAEBCDAEFABCDIEGJKJ $.
  $}

  ${
    mp3an.1 $e |- ph $.
    mp3an.2 $e |- ps $.
    mp3an.3 $e |- ch $.
    mp3an.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM,
       14-May-1999.) $)
    mp3an $p |- th $=
      ( mp3an1 mp2an ) BCDFGABCDEHIJ $.
  $}

  ${
    mpd3an3.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    mpd3an3.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 8-Nov-2007.) $)
    mpd3an3 $p |- ( ( ph /\ ps ) -> th ) $=
      ( wa 3expa mpdan ) ABGCDEABCDFHI $.
  $}

  ${
    mpd3an23.1 $e |- ( ph -> ps ) $.
    mpd3an23.2 $e |- ( ph -> ch ) $.
    mpd3an23.3 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An inference based on modus ponens.  (Contributed by NM, 4-Dec-2006.) $)
    mpd3an23 $p |- ( ph -> th ) $=
      ( id syl3anc ) AABCDAHEFGI $.
  $}

  ${
    mp3and.1 $e |- ( ph -> ps ) $.
    mp3and.2 $e |- ( ph -> ch ) $.
    mp3and.3 $e |- ( ph -> th ) $.
    mp3and.4 $e |- ( ph -> ( ( ps /\ ch /\ th ) -> ta ) ) $.
    $( A deduction based on modus ponens.  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    mp3and $p |- ( ph -> ta ) $=
      ( w3a 3jca mpd ) ABCDJEABCDFGHKIL $.
  $}

  ${
    biimp3a.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Infer implication from a logical equivalence.  Similar to ~ biimpa .
       (Contributed by NM, 4-Sep-2005.) $)
    biimp3a $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa biimpa 3impa ) ABCDABFCDEGH $.

    $( Infer implication from a logical equivalence.  Similar to ~ biimpar .
       (Contributed by NM, 2-Jan-2009.) $)
    biimp3ar $p |- ( ( ph /\ ps /\ th ) -> ch ) $=
      ( exbiri 3imp ) ABDCABCDEFG $.
  $}

  ${
    3anandis.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) /\ ( ph /\ th ) )
                      -> ta ) $.
    $( Inference that undistributes a triple conjunction in the antecedent.
       (Contributed by NM, 18-Apr-2007.) $)
    3anandis $p |- ( ( ph /\ ( ps /\ ch /\ th ) ) -> ta ) $=
      ( w3a wa simpl simpr1 simpr2 simpr3 syl222anc ) ABCDGZHABACADEANIZABCDJOA
      BCDKOABCDLFM $.
  $}

  ${
    3anandirs.1 $e |- ( ( ( ph /\ th ) /\ ( ps /\ th ) /\ ( ch /\ th ) )
                      -> ta ) $.
    $( Inference that undistributes a triple conjunction in the antecedent.
       (Contributed by NM, 25-Jul-2006.) $)
    3anandirs $p |- ( ( ( ph /\ ps /\ ch ) /\ th ) -> ta ) $=
      ( w3a wa simpl1 simpr simpl2 simpl3 syl222anc ) ABCGZDHADBDCDEABCDINDJZAB
      CDKOABCDLOFM $.
  $}

  ${
    ecase23d.1 $e |- ( ph -> -. ch ) $.
    ecase23d.2 $e |- ( ph -> -. th ) $.
    ecase23d.3 $e |- ( ph -> ( ps \/ ch \/ th ) ) $.
    $( Deduction for elimination by cases.  (Contributed by NM,
       22-Apr-1994.) $)
    ecase23d $p |- ( ph -> ps ) $=
      ( wo wn ioran sylanbrc w3o 3orass sylib ord mt3d ) ABCDHZACIDIQIEFCDJKABQ
      ABCDLBQHGBCDMNOP $.
  $}

  ${
    3ecase.1 $e |- ( -. ph -> th ) $.
    3ecase.2 $e |- ( -. ps -> th ) $.
    3ecase.3 $e |- ( -. ch -> th ) $.
    3ecase.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Inference for elimination by cases.  (Contributed by NM,
       13-Jul-2005.) $)
    3ecase $p |- th $=
      ( wi 3exp wn a1d pm2.61i pm2.61nii ) BCDABCDIZIABCDHJAKZOBPDCELLMFGN $.
  $}

  ${
    3biorfd.1 $e |- ( ph -> -. th ) $.
    $( A disjunction is equivalent to a threefold disjunction with single
       falsehood, analogous to ~ biorf .  (Contributed by Alexander van der
       Vekens, 8-Sep-2017.) $)
    3bior1fd $p |- ( ph -> ( ( ch \/ ps ) <-> ( th \/ ch \/ ps ) ) ) $=
      ( wo w3o wn wb biorf syl 3orass syl6bbr ) ACBFZDNFZDCBGADHNOIEDNJKDCBLM
      $.

    $( A disjunction is equivalent to a threefold disjunction with single
       falsehood of a conjunction.  (Contributed by Alexander van der Vekens,
       8-Sep-2017.) $)
    3bior1fand $p |- ( ph -> ( ( ch \/ ps )
                       <-> ( ( th /\ ta ) \/ ch \/ ps ) ) ) $=
      ( wa intnanrd 3bior1fd ) ABCDEGADEFHI $.

    3biorfd.2 $e |- ( ph -> -. ch ) $.
    $( A wff is equivalent to its threefold disjunction with double falsehood,
       analogous to ~ biorf .  (Contributed by Alexander van der Vekens,
       8-Sep-2017.) $)
    3bior2fd $p |- ( ph -> ( ps <-> ( th \/ ch \/ ps ) ) ) $=
      ( wo w3o wn wb biorf syl 3bior1fd bitrd ) ABCBGZDCBHACIBOJFCBKLABCDEMN $.
  $}

  ${
    3biantd.1 $e |- ( ph -> th ) $.
    $( A conjunction is equivalent to a threefold conjunction with single
       truth, analogous to ~ biantrud .  (Contributed by Alexander van der
       Vekens, 26-Sep-2017.) $)
    3biant1d $p |- ( ph -> ( ( ch /\ ps ) <-> ( th /\ ch /\ ps ) ) ) $=
      ( wa w3a biantrurd 3anass syl6bbr ) ACBFZDKFDCBGADKEHDCBIJ $.
  $}

  ${
    intn3and.1 $e |- ( ph -> -. ps ) $.
    $( Introduction of a triple conjunct inside a contradiction.  (Contributed
       by FL, 27-Dec-2007.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    intn3an1d $p |- ( ph -> -. ( ps /\ ch /\ th ) ) $=
      ( w3a simp1 nsyl ) ABBCDFEBCDGH $.

    $( Introduction of a triple conjunct inside a contradiction.  (Contributed
       by FL, 27-Dec-2007.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    intn3an2d $p |- ( ph -> -. ( ch /\ ps /\ th ) ) $=
      ( w3a simp2 nsyl ) ABCBDFECBDGH $.

    $( Introduction of a triple conjunct inside a contradiction.  (Contributed
       by FL, 27-Dec-2007.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    intn3an3d $p |- ( ph -> -. ( ch /\ th /\ ps ) ) $=
      ( w3a simp3 nsyl ) ABCDBFECDBGH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical 'nand' (Sheffer stroke)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare connective for alternative denial ('nand'). $)
  $c -/\ $. $( Overlined 'wedge' (read:  'nand') $)

  $( Extend wff definition to include alternative denial ('nand'). $)
  wnan $a wff ( ph -/\ ps ) $.

  $( Define incompatibility, or alternative denial ('not-and' or 'nand').  This
     is also called the Sheffer stroke, represented by a vertical bar, but we
     use a different symbol to avoid ambiguity with other uses of the vertical
     bar.  In the second edition of Principia Mathematica (1927), Russell and
     Whitehead used the Sheffer stroke and suggested it as a replacement for
     the "or" and "not" operations of the first edition.  However, in practice,
     "or" and "not" are more widely used.  After we define the constant true
     ` T. ` ( ~ df-tru ) and the constant false ` F. ` ( ~ df-fal ), we will be
     able to prove these truth table values: ` ( ( T. -/\ T. ) <-> F. ) `
     ( ~ trunantru ), ` ( ( T. -/\ F. ) <-> T. ) ` ( ~ trunanfal ),
     ` ( ( F. -/\ T. ) <-> T. ) ` ( ~ falnantru ), and
     ` ( ( F. -/\ F. ) <-> T. ) ` ( ~ falnanfal ).  Contrast with ` /\ `
     ( ~ df-an ), ` \/ ` ( ~ df-or ), ` -> ` ( ~ wi ), and ` \/_ `
     ( ~ df-xor ) .  (Contributed by Jeff Hoffman, 19-Nov-2007.) $)
  df-nan $a |- ( ( ph -/\ ps ) <-> -. ( ph /\ ps ) ) $.

  $( Write 'and' in terms of 'nand'.  (Contributed by Mario Carneiro,
     9-May-2015.) $)
  nanan $p |- ( ( ph /\ ps ) <-> -. ( ph -/\ ps ) ) $=
    ( wnan wa df-nan con2bii ) ABCABDABEF $.

  $( The 'nand' operator commutes.  (Contributed by Mario Carneiro,
     9-May-2015.) $)
  nancom $p |- ( ( ph -/\ ps ) <-> ( ps -/\ ph ) ) $=
    ( wa wn wnan ancom notbii df-nan 3bitr4i ) ABCZDBACZDABEBAEJKABFGABHBAHI $.

  $( Lemma for handling nested 'nand's.  (Contributed by Jeff Hoffman,
     19-Nov-2007.) $)
  nannan $p |- ( ( ph -/\ ( ch -/\ ps ) ) <-> ( ph -> ( ch /\ ps ) ) ) $=
    ( wnan wa wn wi df-nan anbi2i xchbinx iman bitr4i ) ACBDZDZACBEZFZEZFAOGNAM
    EQAMHMPACBHIJAOKL $.

  $( Show equivalence between implication and the Nicod version.  To derive
     ~ nic-dfim , apply ~ nanbi .  (Contributed by Jeff Hoffman,
     19-Nov-2007.) $)
  nanim $p |- ( ( ph -> ps ) <-> ( ph -/\ ( ps -/\ ps ) ) ) $=
    ( wnan wa wi nannan anidmdbi bitr2i ) ABBCCABBDEABEABBFABGH $.

  $( Show equivalence between negation and the Nicod version.  To derive
     ~ nic-dfneg , apply ~ nanbi .  (Contributed by Jeff Hoffman,
     19-Nov-2007.) $)
  nannot $p |- ( -. ps <-> ( ps -/\ ps ) ) $=
    ( wnan wn wa df-nan anidm xchbinx bicomi ) AABZACIAADAAAEAFGH $.

  $( Show equivalence between the bidirectional and the Nicod version.
     (Contributed by Jeff Hoffman, 19-Nov-2007.) $)
  nanbi $p |- ( ( ph <-> ps ) <->
          ( ( ph -/\ ps ) -/\ ( ( ph -/\ ph ) -/\ ( ps -/\ ps ) ) ) ) $=
    ( wa wn wo wb pm4.57 df-nan nannot anbi12i xchbinxr xchbinx dfbi3 3bitr4ri
    wnan ) ABCZDZADZBDZCZDZCZDPTEABOZAAOZBBOZOZOZABFPTGUGUCUFCUBUCUFHUCQUFUAABH
    UFUDUECTUDUEHRUDSUEAIBIJKJLABMN $.

  ${
    $( Introduce a right anti-conjunct to both sides of a logical equivalence.
       (Contributed by SF, 2-Jan-2018.) $)
    nanbi1 $p |- ( ( ph <-> ps ) -> ( ( ph -/\ ch ) <-> ( ps -/\ ch ) ) ) $=
      ( wb wa wn wnan anbi1 notbid df-nan 3bitr4g ) ABDZACEZFBCEZFACGBCGLMNABCH
      IACJBCJK $.

    $( Introduce a left anti-conjunct to both sides of a logical equivalence.
       (Contributed by SF, 2-Jan-2018.) $)
    nanbi2 $p |- ( ( ph <-> ps ) -> ( ( ch -/\ ph ) <-> ( ch -/\ ps ) ) ) $=
      ( wb wnan nanbi1 nancom 3bitr4g ) ABDACEBCECAECBEABCFCAGCBGH $.

    $( Join two logical equivalences with anti-conjunction.  (Contributed by
       SF, 2-Jan-2018.) $)
    nanbi12 $p |- ( ( ( ph <-> ps ) /\ ( ch <-> th ) ) ->
       ( ( ph -/\ ch ) <-> ( ps -/\ th ) ) ) $=
      ( wb wnan nanbi1 nanbi2 sylan9bb ) ABEACFBCFCDEBDFABCGCDBHI $.

  $}

  ${
    nanbii.1 $e |- ( ph <-> ps ) $.
    $( Introduce a right anti-conjunct to both sides of a logical equivalence.
       (Contributed by SF, 2-Jan-2018.) $)
    nanbi1i $p |- ( ( ph -/\ ch ) <-> ( ps -/\ ch ) ) $=
      ( wb wnan nanbi1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Introduce a left anti-conjunct to both sides of a logical equivalence.
       (Contributed by SF, 2-Jan-2018.) $)
    nanbi2i $p |- ( ( ch -/\ ph ) <-> ( ch -/\ ps ) ) $=
      ( wb wnan nanbi2 ax-mp ) ABECAFCBFEDABCGH $.

    nanbi12i.2 $e |- ( ch <-> th ) $.
    $( Join two logical equivalences with anti-conjunction.  (Contributed by
       SF, 2-Jan-2018.) $)
    nanbi12i $p |- ( ( ph -/\ ch ) <-> ( ps -/\ th ) ) $=
      ( wb wnan nanbi12 mp2an ) ABGCDGACHBDHGEFABCDIJ $.

  $}

  ${
    nanbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Introduce a right anti-conjunct to both sides of a logical equivalence.
       (Contributed by SF, 2-Jan-2018.) $)
    nanbi1d $p |- ( ph -> ( ( ps -/\ th ) <-> ( ch -/\ th ) ) ) $=
      ( wb wnan nanbi1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Introduce a left anti-conjunct to both sides of a logical equivalence.
       (Contributed by SF, 2-Jan-2018.) $)
    nanbi2d $p |- ( ph -> ( ( th -/\ ps ) <-> ( th -/\ ch ) ) ) $=
      ( wb wnan nanbi2 syl ) ABCFDBGDCGFEBCDHI $.

    nanbi12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Join two logical equivalences with anti-conjunction.  (Contributed by
       Scott Fenton, 2-Jan-2018.) $)
    nanbi12d $p |- ( ph -> ( ( ps -/\ th ) <-> ( ch -/\ ta ) ) ) $=
      ( wb wnan nanbi12 syl2anc ) ABCHDEHBDICEIHFGBCDEJK $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logical 'xor'
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare connective for exclusive disjunction ('xor'). $)
  $c \/_ $. $( Underlined 'vee' (read:  'xor') $)

  $( Extend wff definition to include exclusive disjunction ('xor'). $)
  wxo $a wff ( ph \/_ ps ) $.

  $( Define exclusive disjunction (logical 'xor').  Return true if either the
     left or right, but not both, are true.  After we define the constant true
     ` T. ` ( ~ df-tru ) and the constant false ` F. ` ( ~ df-fal ), we will be
     able to prove these truth table values: ` ( ( T. \/_ T. ) <-> F. ) `
     ( ~ truxortru ), ` ( ( T. \/_ F. ) <-> T. ) ` ( ~ truxorfal ),
     ` ( ( F. \/_ T. ) <-> T. ) ` ( ~ falxortru ), and
     ` ( ( F. \/_ F. ) <-> F. ) ` ( ~ falxorfal ).  Contrast with ` /\ `
     ( ~ df-an ), ` \/ ` ( ~ df-or ), ` -> ` ( ~ wi ), and ` -/\ `
     ( ~ df-nan ) .  (Contributed by FL, 22-Nov-2010.) $)
  df-xor $a |- ( ( ph \/_ ps ) <-> -. ( ph <-> ps ) ) $.

  $( Two ways to write XNOR. (Contributed by Mario Carneiro, 4-Sep-2016.) $)
  xnor $p |- ( ( ph <-> ps ) <-> -. ( ph \/_ ps ) ) $=
    ( wxo wb df-xor con2bii ) ABCABDABEF $.

  $( ` \/_ ` is commutative.  (Contributed by Mario Carneiro, 4-Sep-2016.) $)
  xorcom $p |- ( ( ph \/_ ps ) <-> ( ps \/_ ph ) ) $=
    ( wb wn wxo bicom notbii df-xor 3bitr4i ) ABCZDBACZDABEBAEJKABFGABHBAHI $.

  $( ` \/_ ` is associative.  (Contributed by FL, 22-Nov-2010.)  (Proof
     shortened by Andrew Salmon, 8-Jun-2011.) $)
  xorass $p |- ( ( ( ph \/_ ps ) \/_ ch ) <-> ( ph \/_ ( ps \/_ ch ) ) ) $=
    ( wxo wb wn biass notbii nbbn pm5.18 con2bii 3bitr4i df-xor bibi1i bibi2i )
    ABDZCEZFABCDZEZFPCDARDQSABEZFZCEZABCEZFZEZQSTCEZFAUCEZFUBUEUFUGABCGHTCIUGUE
    AUCJKLPUACABMNRUDABCMOLHPCMARML $.

  $( This tautology shows that xor is really exclusive.  (Contributed by FL,
     22-Nov-2010.) $)
  excxor $p |- ( ( ph \/_ ps ) <->
       ( ( ph /\ -. ps ) \/ ( -. ph /\ ps ) ) ) $=
    ( wxo wb wn wa wo df-xor xor ancom orbi2i 3bitri ) ABCABDEABEFZBAEZFZGMNBFZ
    GABHABIOPMBNJKL $.

  $( Two ways to express "exclusive or."  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  xor2 $p |- ( ( ph \/_ ps ) <->
       ( ( ph \/ ps ) /\ -. ( ph /\ ps ) ) ) $=
    ( wxo wb wn wo wa df-xor nbi2 bitri ) ABCABDEABFABGEGABHABIJ $.

  $( ` \/_ ` is negated under negation of one argument.  (Contributed by Mario
     Carneiro, 4-Sep-2016.) $)
  xorneg1 $p |- ( ( -. ph \/_ ps ) <-> -. ( ph \/_ ps ) ) $=
    ( wn wxo wb df-xor nbbn con2bii xnor 3bitr2i ) ACZBDKBEZCABEZABDCKBFLMABGHA
    BIJ $.

  $( ` \/_ ` is negated under negation of one argument.  (Contributed by Mario
     Carneiro, 4-Sep-2016.) $)
  xorneg2 $p |- ( ( ph \/_ -. ps ) <-> -. ( ph \/_ ps ) ) $=
    ( wn wxo xorneg1 xorcom notbii 3bitr4i ) BCZADBADZCAIDABDZCBAEAIFKJABFGH $.

  $( ` \/_ ` is unchanged under negation of both arguments.  (Contributed by
     Mario Carneiro, 4-Sep-2016.) $)
  xorneg $p |- ( ( -. ph \/_ -. ps ) <-> ( ph \/_ ps ) ) $=
    ( wn wxo xorneg1 xorneg2 con2bii bitr4i ) ACBCZDAIDZCABDZAIEJKABFGH $.

  ${
    xorbi12.1 $e |- ( ph <-> ps ) $.
    xorbi12.2 $e |- ( ch <-> th ) $.
    $( Equality property for XOR. (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    xorbi12i $p |- ( ( ph \/_ ch ) <-> ( ps \/_ th ) ) $=
      ( wb wn wxo bibi12i notbii df-xor 3bitr4i ) ACGZHBDGZHACIBDINOABCDEFJKACL
      BDLM $.
  $}

  ${
    xor12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    xor12d.2 $e |- ( ph -> ( th <-> ta ) ) $.
    $( Equality property for XOR. (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    xorbi12d $p |- ( ph -> ( ( ps \/_ th ) <-> ( ch \/_ ta ) ) ) $=
      ( wb wn wxo bibi12d notbid df-xor 3bitr4g ) ABDHZICEHZIBDJCEJAOPABCDEFGKL
      BDMCEMN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                True and false constants
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c T. $.
  $c F. $.

  $( ` T. ` is a wff. $)
  wtru $a wff T. $.

  $( ` F. ` is a wff. $)
  wfal $a wff F. $.

  $( Soundness justification theorem for ~ df-tru .  (Contributed by Mario
     Carneiro, 17-Nov-2013.) $)
  trujust $p |- ( ( ph <-> ph ) <-> ( ps <-> ps ) ) $=
    ( wb biid 2th ) AACBBCADBDE $.

  $( Definition of ` T. ` , a tautology. ` T. ` is a constant true.  In this
     definition ~ biid is used as an antecedent, however, any true wff, such as
     an axiom, can be used in its place.  (Contributed by Anthony Hart,
     13-Oct-2010.) $)
  df-tru $a |- ( T. <-> ( ph <-> ph ) ) $.

  $( Definition of ` F. ` , a contradiction. ` F. ` is a constant false.
     (Contributed by Anthony Hart, 22-Oct-2010.) $)
  df-fal $a |- ( F. <-> -. T. ) $.

  $( ` T. ` is provable.  (Contributed by Anthony Hart, 13-Oct-2010.) $)
  tru $p |- T. $=
    ( wph wtru wb biid df-tru mpbir ) BAACADAEF $.

  $( ` F. ` is refutable.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Mel L. O'Cat, 11-Mar-2012.) $)
  fal $p |- -. F. $=
    ( wfal wtru wn tru notnoti df-fal mtbir ) ABCBDEFG $.

  ${
    trud.1 $e |- ( T. -> ph ) $.
    $( Eliminate ` T. ` as an antecedent.  (Contributed by Mario Carneiro,
       13-Mar-2014.) $)
    trud $p |- ph $=
      ( wtru tru ax-mp ) CADBE $.
  $}

  $( If something is true, it outputs ` T. ` .  (Contributed by Anthony Hart,
     14-Aug-2011.) $)
  tbtru $p |- ( ph <-> ( ph <-> T. ) ) $=
    ( wtru tru tbt ) BACD $.

  $( If something is not true, it outputs ` F. ` .  (Contributed by Anthony
     Hart, 14-Aug-2011.) $)
  nbfal $p |- ( -. ph <-> ( ph <-> F. ) ) $=
    ( wfal fal nbn ) BACD $.

  ${
    bitru.1 $e |- ph $.
    $( A theorem is equivalent to truth.  (Contributed by Mario Carneiro,
       9-May-2015.) $)
    bitru $p |- ( ph <-> T. ) $=
      ( wtru tru 2th ) ACBDE $.
  $}

  ${
    bifal.1 $e |- -. ph $.
    $( A contradiction is equivalent to falsehood.  (Contributed by Mario
       Carneiro, 9-May-2015.) $)
    bifal $p |- ( ph <-> F. ) $=
      ( wfal fal 2false ) ACBDE $.
  $}

  $( ` F. ` implies anything.  (Contributed by FL, 20-Mar-2011.)  (Proof
     shortened by Anthony Hart, 1-Aug-2011.) $)
  falim $p |- ( F. -> ph ) $=
    ( wfal fal pm2.21i ) BACD $.

  $( ` F. ` implies anything.  (Contributed by Mario Carneiro, 9-Feb-2017.) $)
  falimd $p |- ( ( ph /\ F. ) -> ps ) $=
    ( wfal falim adantl ) CBABDE $.

  $( Anything implies ` T. ` .  (Contributed by FL, 20-Mar-2011.)  (Proof
     shortened by Anthony Hart, 1-Aug-2011.) $)
  a1tru $p |- ( ph -> T. ) $=
    ( wtru tru a1i ) BACD $.

  $( True can be removed from a conjunction.  (Contributed by FL,
     20-Mar-2011.) $)
  truan $p |- ( ( T. /\ ph ) <-> ph ) $=
    ( wtru wa simpr a1tru ancri impbii ) BACABADABAEFG $.

  $( Given falsum, we can define the negation of a wff ` ph ` as the statement
     that a contradiction follows from assuming ` ph ` .  (Contributed by Mario
     Carneiro, 9-Feb-2017.) $)
  dfnot $p |- ( -. ph <-> ( ph -> F. ) ) $=
    ( wn wfal wi pm2.21 id falim ja impbii ) ABZACDACEACJJFJGHI $.

  ${
    inegd.1 $e |- ( ( ph /\ ps ) -> F. ) $.
    $( Negation introduction rule from natural deduction.  (Contributed by
       Mario Carneiro, 9-Feb-2017.) $)
    inegd $p |- ( ph -> -. ps ) $=
      ( wfal wi wn ex dfnot sylibr ) ABDEBFABDCGBHI $.
  $}

  ${
    efald.1 $e |- ( ( ph /\ -. ps ) -> F. ) $.
    $( Deduction based on reductio ad absurdum.  (Contributed by Mario
       Carneiro, 9-Feb-2017.) $)
    efald $p |- ( ph -> ps ) $=
      ( wn inegd notnotrd ) ABABDCEF $.
  $}

  ${
    pm2.21fal.1 $e |- ( ph -> ps ) $.
    pm2.21fal.2 $e |- ( ph -> -. ps ) $.
    $( If a wff and its negation are provable, then falsum is provable.
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    pm2.21fal $p |- ( ph -> F. ) $=
      ( wfal pm2.21dd ) ABECDF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Truth tables
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Some sources define operations on true/false values using truth tables.
  These tables show the results of their operations for all possible
  combinations of true ( ` T. ` ) and false ( ` F. ` ).
  Here we show that our definitions and axioms produce equivalent results for
  ` /\ ` (conjunction aka logical 'and') ~ df-an ,
  ` \/ ` (disjunction aka logical inclusive 'or') ~ df-or ,
  ` -> ` (implies) ~ wi ,
  ` -. ` (not) ~ wn ,
  ` <-> ` (logical equivalence) ~ df-bi ,
  ` -/\ ` (nand aka Sheffer stroke) ~ df-nan , and
  ` \/_ ` (exclusive or) ~ df-xor .
$)

  $( A ` /\ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  truantru $p |- ( ( T. /\ T. ) <-> T. ) $=
    ( wtru anidm ) AB $.

  $( A ` /\ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  truanfal $p |- ( ( T. /\ F. ) <-> F. ) $=
    ( wfal truan ) AB $.

  $( A ` /\ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  falantru $p |- ( ( F. /\ T. ) <-> F. ) $=
    ( wfal wtru wa fal intnanr bifal ) ABCABDEF $.

  $( A ` /\ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  falanfal $p |- ( ( F. /\ F. ) <-> F. ) $=
    ( wfal anidm ) AB $.

  $( A ` \/ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  truortru $p |- ( ( T. \/ T. ) <-> T. ) $=
    ( wtru oridm ) AB $.

  $( A ` \/ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  truorfal $p |- ( ( T. \/ F. ) <-> T. ) $=
    ( wtru wfal wo tru orci bitru ) ABCABDEF $.

  $( A ` \/ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  falortru $p |- ( ( F. \/ T. ) <-> T. ) $=
    ( wfal wtru wo tru olci bitru ) ABCBADEF $.

  $( A ` \/ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  falorfal $p |- ( ( F. \/ F. ) <-> F. ) $=
    ( wfal oridm ) AB $.

  $( A ` -> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  truimtru $p |- ( ( T. -> T. ) <-> T. ) $=
    ( wtru wi id bitru ) AABACD $.

  $( A ` -> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  truimfal $p |- ( ( T. -> F. ) <-> F. ) $=
    ( wfal wtru wi tru a1bi bicomi ) ABACBADEF $.

  $( A ` -> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  falimtru $p |- ( ( F. -> T. ) <-> T. ) $=
    ( wfal wtru wi falim bitru ) ABCBDE $.

  $( A ` -> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  falimfal $p |- ( ( F. -> F. ) <-> T. ) $=
    ( wfal wi id bitru ) AABACD $.

  $( A ` -. ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.) $)
  nottru $p |- ( -. T. <-> F. ) $=
    ( wfal wtru wn df-fal bicomi ) ABCDE $.

  $( A ` -. ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  notfal $p |- ( -. F. <-> T. ) $=
    ( wfal wn fal bitru ) ABCD $.

  $( A ` <-> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  trubitru $p |- ( ( T. <-> T. ) <-> T. ) $=
    ( wtru wb biid bitru ) AABACD $.

  $( A ` <-> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  trubifal $p |- ( ( T. <-> F. ) <-> F. ) $=
    ( wtru wfal wb wn nottru nbbn mpbi bifal ) ABCZADBCIDEABFGH $.

  $( A ` <-> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  falbitru $p |- ( ( F. <-> T. ) <-> F. ) $=
    ( wfal wtru wb bicom trubifal bitri ) ABCBACAABDEF $.

  $( A ` <-> ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  falbifal $p |- ( ( F. <-> F. ) <-> T. ) $=
    ( wfal wb biid bitru ) AABACD $.

  $( A ` -/\ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  trunantru $p |- ( ( T. -/\ T. ) <-> F. ) $=
    ( wtru wnan wn wfal nannot nottru bitr3i ) AABACDAEFG $.

  $( A ` -/\ ` identity.  (Contributed by Anthony Hart, 23-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  trunanfal $p |- ( ( T. -/\ F. ) <-> T. ) $=
    ( wtru wfal wnan wa wn df-nan truanfal notbii notfal 3bitri ) ABCABDZEBEAAB
    FKBGHIJ $.

  $( A ` -/\ ` identity.  (Contributed by Anthony Hart, 23-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  falnantru $p |- ( ( F. -/\ T. ) <-> T. ) $=
    ( wfal wtru wnan nancom trunanfal bitri ) ABCBACBABDEF $.

  $( A ` -/\ ` identity.  (Contributed by Anthony Hart, 22-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 13-May-2011.) $)
  falnanfal $p |- ( ( F. -/\ F. ) <-> T. ) $=
    ( wfal wnan wn wtru nannot notfal bitr3i ) AABACDAEFG $.

  $( A ` \/_ ` identity.  (Contributed by David A. Wheeler, 8-May-2015.) $)
  truxortru $p |- ( ( T. \/_ T. ) <-> F. ) $=
    ( wtru wxo wn wfal wb df-xor trubitru xchbinx nottru bitri ) AABZACDKAAEAAA
    FGHIJ $.

  $( A ` \/_ ` identity.  (Contributed by David A. Wheeler, 8-May-2015.) $)
  truxorfal $p |- ( ( T. \/_ F. ) <-> T. ) $=
    ( wtru wfal wxo wn wb df-xor trubifal xchbinx notfal bitri ) ABCZBDAKABEBAB
    FGHIJ $.

  $( A ` \/_ ` identity.  (Contributed by David A. Wheeler, 9-May-2015.) $)
  falxortru $p |- ( ( F. \/_ T. ) <-> T. ) $=
    ( wfal wtru wxo wb wn df-xor falbitru notbii notfal 3bitri ) ABCABDZEAEBABF
    KAGHIJ $.

  $( A ` \/_ ` identity.  (Contributed by David A. Wheeler, 9-May-2015.) $)
  falxorfal $p |- ( ( F. \/_ F. ) <-> F. ) $=
    ( wfal wxo wtru wn wb df-xor falbifal xchbinx nottru bitri ) AABZCDAKAAECAA
    FGHIJ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Auxiliary theorems for Alan Sare's virtual deduction tool, part 1
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    ee22.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee22.2 $e |- ( ph -> ( ps -> th ) ) $.
    ee22.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( Virtual deduction rule ~ e22 without virtual deduction connectives.
       Special theorem needed for Alan Sare's virtual deduction translation
       tool.  (Contributed by Alan Sare, 2-May-2011.)
       (New usage is discouraged.)  TODO: decide if this is worth keeping. $)
    ee22 $p |- ( ph -> ( ps -> ta ) ) $=
      ( syl6c ) ABCDEFGHI $.
  $}

  ${
    ee12an.1 $e |- ( ph -> ps ) $.
    ee12an.2 $e |- ( ph -> ( ch -> th ) ) $.
    ee12an.3 $e |- ( ( ps /\ th ) -> ta ) $.
    $( ~ e12an without virtual deduction connectives.  Special theorem needed
       for Alan Sare's virtual deduction translation tool.  (Contributed by
       Alan Sare, 28-Oct-2011.)  TODO: this is frequently used; come up with
       better label. $)
    ee12an $p |- ( ph -> ( ch -> ta ) ) $=
      ( wa jctild syl6 ) ACBDIEACDBGFJHK $.
  $}

  ${
    ee23.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee23.2 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    ee23.3 $e |- ( ch -> ( ta -> et ) ) $.
    $( ~ e23 without virtual deductions.  (Contributed by Alan Sare,
       17-Jul-2011.)  (New usage is discouraged.)  TODO: decide if this is
       worth keeping. $)
    ee23 $p |- ( ph -> ( ps -> ( th -> et ) ) ) $=
      ( wi syl6 syldd ) ABDEFHABCEFJGIKL $.
  $}

  $( Exportation implication also converting head from biconditional to
     conditional.  This proof is ~ exbirVD automatically translated and
     minimized.  (Contributed by Alan Sare, 31-Dec-2011.)
     (New usage is discouraged.)  TODO: decide if this is worth keeping. $)
  exbir $p |- ( ( ( ph /\ ps ) -> ( ch <-> th ) ) ->
              ( ph -> ( ps -> ( th -> ch ) ) ) ) $=
    ( wa wb wi bi2 imim2i exp3a ) ABEZCDFZGABDCGZLMKCDHIJ $.

  $( ~ impexp with a 3-conjunct antecedent.  (Contributed by Alan Sare,
     31-Dec-2011.) $)
  3impexp $p |- ( ( ( ph /\ ps /\ ch ) -> th ) <->
                ( ph -> ( ps -> ( ch -> th ) ) ) ) $=
    ( w3a wi id 3expd 3impd impbii ) ABCEDFZABCDFFFZKABCDKGHLABCDLGIJ $.

  $( ~ 3impexp with biconditional consequent of antecedent that is commuted in
     consequent.  Derived automatically from ~ 3impexpVD .  (Contributed by
     Alan Sare, 31-Dec-2011.)  (New usage is discouraged.)  TODO: decide if
     this is worth keeping. $)
  3impexpbicom $p |- ( ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) <->
                     ( ph -> ( ps -> ( ch -> ( ta <-> th ) ) ) ) ) $=
    ( w3a wb wi bicom imbi2 biimpcd mpi 3expd 3impexp biimpri syl6ibr impbii )
    ABCFZDEGZHZABCEDGZHHHZTABCUATSUAGZRUAHZDEIZUCTUDSUARJKLMUBRUASUDUBABCUANOUE
    PQ $.

  ${
    3impexpbicomi.1 $e |- ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) $.
    $( Deduction form of ~ 3impexpbicom .  Derived automatically from
       ~ 3impexpbicomiVD .  (Contributed by Alan Sare, 31-Dec-2011.)
       (New usage is discouraged.)  TODO: decide if this is worth keeping. $)
    3impexpbicomi $p |- ( ph -> ( ps -> ( ch -> ( ta <-> th ) ) ) ) $=
      ( wb w3a bicomd 3exp ) ABCEDGABCHDEFIJ $.
  $}

  $( Closed form of ~ ancoms .  Derived automatically from ~ ancomsimpVD .
     (Contributed by Alan Sare, 31-Dec-2011.) $)
  ancomsimp $p |- ( ( ( ph /\ ps ) -> ch ) <-> ( ( ps /\ ph ) -> ch ) ) $=
    ( wa ancom imbi1i ) ABDBADCABEF $.

  ${
    exp3acom3r.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( Export and commute antecedents.  (Contributed by Alan Sare,
       18-Mar-2012.) $)
    exp3acom3r $p |- ( ps -> ( ch -> ( ph -> th ) ) ) $=
      ( exp3a com3l ) ABCDABCDEFG $.
  $}

  $( Implication form of ~ exp3acom23 .  (Contributed by Alan Sare,
     22-Jul-2012.)  (New usage is discouraged.)  TODO: decide if this is worth
     keeping. $)
  exp3acom23g $p |- ( ( ph -> ( ( ps /\ ch ) -> th ) ) <->
                        ( ph -> ( ch -> ( ps -> th ) ) ) ) $=
    ( wa wi ancomsimp impexp bitri imbi2i ) BCEDFZCBDFFZAKCBEDFLBCDGCBDHIJ $.

  ${
    exp3acom23.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    $( The exportation deduction ~ exp3a with commutation of the conjoined
       wwfs.  (Contributed by Alan Sare, 22-Jul-2012.) $)
    exp3acom23 $p |- ( ph -> ( ch -> ( ps -> th ) ) ) $=
      ( exp3a com23 ) ABCDABCDEFG $.
  $}

  $( Implication form of ~ simplbi2com .  (Contributed by Alan Sare,
     22-Jul-2012.)  (New usage is discouraged.)  TODO: decide if this is worth
     keeping. $)
  simplbi2comg $p |- ( ( ph <-> ( ps /\ ch ) ) -> ( ch -> ( ps -> ph ) ) ) $=
    ( wa wb bi2 exp3acom23 ) ABCDZEBCAAHFG $.

  ${
    simplbi2com.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( A deduction eliminating a conjunct, similar to ~ simplbi2 .
       (Contributed by Alan Sare, 22-Jul-2012.)  (Proof shortened by Wolf
       Lammen, 10-Nov-2012.) $)
    simplbi2com $p |- ( ch -> ( ps -> ph ) ) $=
      ( simplbi2 com12 ) BCAABCDEF $.
  $}

  ${
    ee21.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee21.2 $e |- ( ph -> th ) $.
    ee21.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( ~ e21 without virtual deductions.  (Contributed by Alan Sare,
       18-Mar-2012.)  (New usage is discouraged.)  TODO: decide if this is
       worth keeping. $)
    ee21 $p |- ( ph -> ( ps -> ta ) ) $=
      ( a1d ee22 ) ABCDEFADBGIHJ $.
  $}

  ${
    ee10.1 $e |- ( ph -> ps ) $.
    ee10.2 $e |- ch $.
    ee10.3 $e |- ( ps -> ( ch -> th ) ) $.
    $( ~ e10 without virtual deductions.  (Contributed by Alan Sare,
       25-Jul-2011.)  TODO: this is frequently used; come up with better
       label. $)
    ee10 $p |- ( ph -> th ) $=
      ( mpi syl ) ABDEBCDFGHI $.
  $}

  ${
    ee02.1 $e |- ph $.
    ee02.2 $e |- ( ps -> ( ch -> th ) ) $.
    ee02.3 $e |- ( ph -> ( th -> ta ) ) $.
    $( ~ e02 without virtual deductions.  (Contributed by Alan Sare,
       22-Jul-2012.)  (New usage is discouraged.)  TODO: decide if this is
       worth keeping. $)
    ee02 $p |- ( ps -> ( ch -> ta ) ) $=
      ( a1i sylsyld ) BACDEABFIGHJ $.
  $}

$( End of auxiliary theorems for Alan Sare's virtual deduction tool, part 1 $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Half-adders and full adders in propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Propositional calculus deals with truth values, which can be interpreted as
  bits. Using this, we can define the half-adder in pure propositional
  calculus, and show its basic properties.

$)

  $c hadd cadd $.
  $c , $.  $( Comma (also used for unordered pair notation later) $)

  $( Define the half adder (triple XOR).  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  whad $a wff hadd ( ph , ps , ch ) $.

  $( Define the half adder carry.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  wcad $a wff cadd ( ph , ps , ch ) $.

  $( Define the half adder (triple XOR).  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  df-had $a |- ( hadd ( ph , ps , ch ) <-> ( ( ph \/_ ps ) \/_ ch ) ) $.

  $( Define the half adder carry, which is true when at least two arguments are
     true.  (Contributed by Mario Carneiro, 4-Sep-2016.) $)
  df-cad $a |- ( cadd ( ph , ps , ch ) <->
    ( ( ph /\ ps ) \/ ( ch /\ ( ph \/_ ps ) ) ) ) $.

  ${
    hadbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    hadbid.2 $e |- ( ph -> ( th <-> ta ) ) $.
    hadbid.3 $e |- ( ph -> ( et <-> ze ) ) $.
    $( Equality theorem for half adder.  (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    hadbi123d $p |- ( ph ->
      ( hadd ( ps , th , et ) <-> hadd ( ch , ta , ze ) ) ) $=
      ( wxo whad xorbi12d df-had 3bitr4g ) ABDKZFKCEKZGKBDFLCEGLAPQFGABCDEHIMJM
      BDFNCEGNO $.

    $( Equality theorem for adder carry.  (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    cadbi123d $p |- ( ph ->
      ( cadd ( ps , th , et ) <-> cadd ( ch , ta , ze ) ) ) $=
      ( wa wxo wo wcad anbi12d xorbi12d orbi12d df-cad 3bitr4g ) ABDKZFBDLZKZMC
      EKZGCELZKZMBDFNCEGNATUCUBUEABCDEHIOAFGUAUDJABCDEHIPOQBDFRCEGRS $.
  $}

  ${
    hadbii.1 $e |- ( ph <-> ps ) $.
    hadbii.2 $e |- ( ch <-> th ) $.
    hadbii.3 $e |- ( ta <-> et ) $.
    $( Equality theorem for half adder.  (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    hadbi123i $p |- ( hadd ( ph , ch , ta ) <-> hadd ( ps , th , et ) ) $=
      ( whad wb wtru a1i hadbi123d trud ) ACEJBDFJKLABCDEFABKLGMCDKLHMEFKLIMNO
      $.

    $( Equality theorem for adder carry.  (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    cadbi123i $p |- ( cadd ( ph , ch , ta ) <-> cadd ( ps , th , et ) ) $=
      ( wcad wb wtru a1i cadbi123d trud ) ACEJBDFJKLABCDEFABKLGMCDKLHMEFKLIMNO
      $.
  $}

  $( Associative law for triple XOR. (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  hadass $p |- ( hadd ( ph , ps , ch ) <-> ( ph \/_ ( ps \/_ ch ) ) ) $=
    ( whad wxo df-had xorass bitri ) ABCDABECEABCEEABCFABCGH $.

  $( The half adder is the same as the triple biconditional.  (Contributed by
     Mario Carneiro, 4-Sep-2016.) $)
  hadbi $p |- ( hadd ( ph , ps , ch ) <-> ( ( ph <-> ps ) <-> ch ) ) $=
    ( wxo wb wn whad df-xor df-had xnor bibi1i nbbn bitri 3bitr4i ) ABDZCDOCEFZ
    ABCGABEZCEZOCHABCIROFZCEPQSCABJKOCLMN $.

  $( Commutative law for triple XOR. (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  hadcoma $p |- ( hadd ( ph , ps , ch ) <-> hadd ( ps , ph , ch ) ) $=
    ( wxo whad xorcom biid xorbi12i df-had 3bitr4i ) ABDZCDBADZCDABCEBACEKLCCAB
    FCGHABCIBACIJ $.

  $( Commutative law for triple XOR. (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  hadcomb $p |- ( hadd ( ph , ps , ch ) <-> hadd ( ph , ch , ps ) ) $=
    ( wxo whad biid xorcom xorbi12i hadass 3bitr4i ) ABCDZDACBDZDABCEACBEAAKLAF
    BCGHABCIACBIJ $.

  $( Rotation law for triple XOR. (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  hadrot $p |- ( hadd ( ph , ps , ch ) <-> hadd ( ps , ch , ph ) ) $=
    ( whad hadcoma hadcomb bitri ) ABCDBACDBCADABCEBACFG $.

  $( Write the adder carry in disjunctive normal form.  (Contributed by Mario
     Carneiro, 4-Sep-2016.) $)
  cador $p |- ( cadd ( ph , ps , ch ) <->
    ( ( ph /\ ps ) \/ ( ph /\ ch ) \/ ( ps /\ ch ) ) ) $=
    ( wcad wa wxo wo df-cad wn wi xor2 rbaib anbi1d ancom andir 3bitr3g pm5.74i
    w3o df-or bitri 3orass 3bitr4i ) ABCDABEZCABFZEZGZUCACEZBCEZRZABCHUCIZUEJUJ
    UGUHGZJZUFUIUJUEUKUJUDCEABGZCEUEUKUJUDUMCUDUMUJABKLMUDCNABCOPQUCUESUIUCUKGU
    LUCUGUHUAUCUKSTUBT $.

  $( Write the adder carry in conjunctive normal form.  (Contributed by Mario
     Carneiro, 4-Sep-2016.) $)
  cadan $p |- ( cadd ( ph , ps , ch ) <->
    ( ( ph \/ ps ) /\ ( ph \/ ch ) /\ ( ps \/ ch ) ) ) $=
    ( wa w3o wo wcad w3a ordir wn wi wb simpr con3i biorf pm5.74i df-or 3bitr4i
    syl orcom anbi2i 3bitr3i syl6bb bitr3i anbi12i bitri df-3or anandir df-3an
    ordi cador ) ABDZACDZBCDZEZABFZACFZDBCFZDZABCGUPUQURHULUMFZUNFZUPURDZUQURDZ
    DZUOUSVAUTBFZUTCFZDVDUTBCUJVEVBVFVCUMBFZUPCBFZDVEVBACBIBUMFZBUTFZVGVEBJZUMK
    VKUTKVIVJVKUMUTVKULJUMUTLULBABMNULUMOSPBUMQBUTQRUMBTUTBTRVHURUPCBTUAUBVFULC
    FZVCCULFZCUTFZVLVFCJZULKVOUTKVMVNVOULUTVOUMJZULUTLUMCACMNVPULUMULFUTUMULOUM
    ULTUCSPCULQCUTQRULCTUTCTRABCIUDUEUFULUMUNUGUPUQURUHRABCUKUPUQURUIR $.

  $( The half adder distributes over negation.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  hadnot $p |- ( -. hadd ( ph , ps , ch ) <->
    hadd ( -. ph , -. ps , -. ch ) ) $=
    ( wxo wn whad xorneg biid xorbi12i xorneg2 bitr2i df-had notbii 3bitr4i ) A
    BDZCDZEZAEZBEZDZCEZDZABCFZERSUAFUBOUADQTOUAUAABGUAHIOCJKUCPABCLMRSUALN $.

  $( The adder carry distributes over negation.  (Contributed by Mario
     Carneiro, 4-Sep-2016.) $)
  cadnot $p |- ( -. cadd ( ph , ps , ch ) <->
    cadd ( -. ph , -. ps , -. ch ) ) $=
    ( wa w3o wn wo wcad 3ioran ianor 3anbi123i bitri cador notbii cadan 3bitr4i
    w3a ) ABDZACDZBCDZEZFZAFZBFZGZUCCFZGZUDUFGZQZABCHZFUCUDUFHUBRFZSFZTFZQUIRST
    IUKUEULUGUMUHABJACJBCJKLUJUAABCMNUCUDUFOP $.

  $( Commutative law for adder carry.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  cadcoma $p |- ( cadd ( ph , ps , ch ) <-> cadd ( ps , ph , ch ) ) $=
    ( wa wxo wo wcad ancom xorcom anbi2i orbi12i df-cad 3bitr4i ) ABDZCABEZDZFB
    ADZCBAEZDZFABCGBACGNQPSABHORCABIJKABCLBACLM $.

  $( Commutative law for adder carry.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  cadcomb $p |- ( cadd ( ph , ps , ch ) <-> cadd ( ph , ch , ps ) ) $=
    ( wa w3o wcad 3orcoma biid ancom 3orbi123i bitri cador 3bitr4i ) ABDZACDZBC
    DZEZONCBDZEZABCFACBFQONPESNOPGOONNPROHNHBCIJKABCLACBLM $.

  $( Rotation law for adder carry.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  cadrot $p |- ( cadd ( ph , ps , ch ) <-> cadd ( ps , ch , ph ) ) $=
    ( wcad cadcoma cadcomb bitri ) ABCDBACDBCADABCEBACFG $.

  $( If one parameter is true, the adder carry is true exactly when at least
     one of the other parameters is true.  (Contributed by Mario Carneiro,
     8-Sep-2016.) $)
  cad1 $p |- ( ch -> ( cadd ( ph , ps , ch ) <-> ( ph \/ ps ) ) ) $=
    ( wa wxo wo wcad ibar bicomd orbi2d df-cad wn pm5.63 olc orc adantr id jaoi
    impbii xor2 ancom bitri orbi2i 3bitr4i 3bitr4g ) CABDZCABEZDZFUFUGFZABCGABF
    ZCUHUGUFCUGUHCUGHIJABCKUFUJFZUFUFLZUJDZFUJUIUFUJMUJUKUJUFNUFUJUJAUJBABOPUJQ
    RSUGUMUFUGUJULDUMABTUJULUAUBUCUDUE $.

  $( If two parameters are true, the adder carry is true.  (Contributed by
     Mario Carneiro, 4-Sep-2016.) $)
  cad11 $p |- ( ( ph /\ ps ) -> cadd ( ph , ps , ch ) ) $=
    ( wa wxo wo wcad orc df-cad sylibr ) ABDZKCABEDZFABCGKLHABCIJ $.

  $( If one parameter is false, the adder carry is true exactly when both of
     the other two parameters are true.  (Contributed by Mario Carneiro,
     8-Sep-2016.) $)
  cad0 $p |- ( -. ch -> ( cadd ( ph , ps , ch ) <-> ( ph /\ ps ) ) ) $=
    ( wcad wa wxo wo wn df-cad idd pm2.21 adantrd jaod orc impbid1 syl5bb ) ABC
    DABEZCABFZEZGZCHZQABCIUATQUAQQSUAQJUACQRCQKLMQSNOP $.

  $( Rotation law for adder carry.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  cadtru $p |- cadd ( T. , T. , ph ) $=
    ( wtru wcad tru cad11 mp2an ) BBBBACDDBBAEF $.

  $( If the first parameter is true, the half adder is equivalent to the
     equality of the other two inputs.  (Contributed by Mario Carneiro,
     4-Sep-2016.) $)
  had1 $p |- ( ph -> ( hadd ( ph , ps , ch ) <-> ( ps <-> ch ) ) ) $=
    ( whad wb hadbi biass bitri id biidd 2thd sylibr syl5bb ) ABCDZABCEZEZAONAB
    ECEPABCFABCGHAAOOEZEPOEAAQAIAOJKAOOGLM $.

  $( If the first parameter is false, the half adder is equivalent to the XOR
     of the other two inputs.  (Contributed by Mario Carneiro, 4-Sep-2016.) $)
  had0 $p |- ( -. ph -> ( hadd ( ph , ps , ch ) <-> ( ps \/_ ch ) ) ) $=
    ( wn whad wxo wb had1 hadnot df-xor xorneg bitr3i con1bii 3bitr4g con4bid )
    ADZABCEZBCFZPPBDZCDZESTGZQDRDPSTHABCIUARUADSTFRSTJBCKLMNO $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
      Other axiomatizations of classical propositional calculus
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Derive the Lukasiewicz axioms from Meredith's sole axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Carew Meredith's sole axiom for propositional calculus.  This amazing
     formula is thought to be the shortest possible single axiom for
     propositional calculus with inference rule ~ ax-mp , where negation and
     implication are primitive.  Here we prove Meredith's axiom from ~ ax-1 ,
     ~ ax-2 , and ~ ax-3 .  Then from it we derive the Lukasiewicz axioms
     ~ luk-1 , ~ luk-2 , and ~ luk-3 .  Using these we finally re-derive our
     axioms as ~ ax1 , ~ ax2 , and ~ ax3 , thus proving the equivalence of all
     three systems.  C. A. Meredith, "Single Axioms for the Systems (C,N),
     (C,O) and (A,N) of the Two-Valued Propositional Calculus," _The Journal of
     Computing Systems_ vol. 1 (1953), pp. 155-164.  Meredith claimed to be
     close to a proof that this axiom is the shortest possible, but the proof
     was apparently never completed.

     An obscure Irish lecturer, Meredith (1904-1976) became enamored with logic
     somewhat late in life after attending talks by Lukasiewicz and produced
     many remarkable results such as this axiom.  From his obituary:  "He did
     logic whenever time and opportunity presented themselves, and he did it on
     whatever materials came to hand: in a pub, his favored pint of porter
     within reach, he would use the inside of cigarette packs to write proofs
     for logical colleagues."  (Contributed by NM, 14-Dec-2002.)  (Proof
     shortened by Andrew Salmon, 25-Jul-2011.)  (Proof shortened by Wolf
     Lammen, 28-May-2013.) $)
  meredith $p |- ( ( ( ( ( ph -> ps ) -> ( -. ch -> -. th ) ) -> ch ) ->
       ta ) -> ( ( ta -> ph ) -> ( th -> ph ) ) ) $=
    ( wi wn pm2.21 ax-3 imim12i com13 con1d com12 a1d ax-1 imim1d ja ) ABFZCGDG
    FZFZCFZEEAFZDAFZFUAGZUCUBDUDADAUATAGZDCUERSDCFABHCDIJKLMNEDEAEDOPQ $.

  $( Alias for ~ meredith which "verify markup *" will match to
     ~ ax-meredith .  (Contributed by NM, 21-Aug-2017.)
     (New usage is discouraged.) $)
  axmeredith $p |- ( ( ( ( ( ph -> ps ) -> ( -. ch -> -. th ) ) -> ch ) ->
       ta ) -> ( ( ta -> ph ) -> ( th -> ph ) ) ) $=
    ( meredith ) ABCDEF $.

  $( Theorem ~ meredith restated as an axiom.  This will allow us to ensure
     that the rederivation of ~ ax1 , ~ ax2 , and ~ ax3 below depend only on
     Meredith's sole axiom and not accidentally on a previous theorem above.
     Outside of this section, we will not make use of this axiom.  (Contributed
     by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax-meredith $a |- ( ( ( ( ( ph -> ps ) -> ( -. ch -> -. th ) ) -> ch ) ->
       ta ) -> ( ( ta -> ph ) -> ( th -> ph ) ) ) $.

  $( Step 3 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (The step numbers refer to Meredith's original paper.)  (Contributed by
     NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem1 $p |- ( ( ( ch -> ( -. ph -> ps ) ) -> ta ) -> ( ph -> ta ) ) $=
    ( wn wi ax-meredith ax-mp ) DAEZFIBFZEZIFFZJFCJFZFZMDFADFFJDECEFZEKEFZFOFDF
    LFNIBOKDGJPDCLGHDIJAMGH $.

  $( Step 4 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem2 $p |- ( ( ( ph -> ph ) -> ch ) -> ( th -> ch ) ) $=
    ( wi wn merlem1 ax-meredith ax-mp ) BBDZAECEZDDADAADZDKBDCBDDAJIAFBBACKGH
    $.

  $( Step 7 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem3 $p |- ( ( ( ps -> ch ) -> ph ) -> ( ch -> ph ) ) $=
    ( wi wn merlem2 ax-mp ax-meredith ) AADZCEZJDZDZCDBCDZDZMADCADZDOBEZPDDBDZL
    DZNKKDLDRJKIFKLQFGCABBLHGAACCMHG $.

  $( Step 8 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem4 $p |- ( ta -> ( ( ta -> ph ) -> ( th -> ph ) ) ) $=
    ( wi wn ax-meredith merlem3 ax-mp ) AADBEZIDDBDZCDCADBADDZDCKDAABBCFKJCGH
    $.

  $( Step 11 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem5 $p |- ( ( ph -> ps ) -> ( -. -. ph -> ps ) ) $=
    ( wi wn ax-meredith merlem1 merlem4 ax-mp ) BBCZBDZJCCBCBCIICCZABCZADZDZBCC
    ZBBBBBEIJNDCCBCZACZOCZKOCZBBBNAEOKDZCMTCCZACQCZRSCUAUBMBLTFAPUAGHOTAKQEHHH
    $.

  $( Step 12 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem6 $p |- ( ch -> ( ( ( ps -> ch ) -> ph ) -> ( th -> ph ) ) ) $=
    ( wi merlem4 merlem3 ax-mp ) BCEZIAEDAEEZECJEADIFJBCGH $.

  $( Between steps 14 and 15 of Meredith's proof of Lukasiewicz axioms from his
     sole axiom.  (Contributed by NM, 22-Dec-2002.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merlem7 $p |- ( ph -> ( ( ( ps -> ch ) -> th ) -> ( ( ( ch -> ta ) ->
                  ( -. th -> -. ps ) ) -> th ) ) ) $=
    ( wi wn merlem4 merlem6 ax-meredith ax-mp ) BCFZLDFZCEFDGBGFFZDFZFZFZAPFZDN
    LHPAGZFCGZSFFZCFLFZQRFOUAFUBSMOTICEDBUAJKPSCALJKK $.

  $( Step 15 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem8 $p |- ( ( ( ps -> ch ) -> th ) -> ( ( ( ch -> ta ) ->
                  ( -. th -> -. ps ) ) -> th ) ) $=
    ( wph wi wn ax-meredith merlem7 ax-mp ) EEFZEGZLFFEFEFKKFFZABFCFBDFCGAGFFCF
    FEEEEEHMABCDIJ $.

  $( Step 18 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem9 $p |- ( ( ( ph -> ps ) -> ( ch -> ( th -> ( ps -> ta ) ) ) ) ->
                    ( et -> ( ch -> ( th -> ( ps -> ta ) ) ) ) ) $=
    ( wi wn merlem6 merlem8 ax-mp ax-meredith ) CDBEGZGZGZFHZGBHZPGGZBGABGZGZSO
    GFOGGMRHDHGZHAHGZGUAGRGZTNRGUCPCNQIDMRUBJKBEUAARLKOPBFSLK $.

  $( Step 19 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem10 $p |- ( ( ph -> ( ph -> ps ) ) -> ( th -> ( ph -> ps ) ) ) $=
    ( wi wn ax-meredith merlem9 ax-mp ) AADZAEZJDDADADIIDDZAABDZDZCLDDZAAAAAFLA
    DJCEDDADZADNDKNDLAACAFOAMCBKGHH $.

  $( Step 20 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem11 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    ( wi wn ax-meredith merlem10 ax-mp ) AACZADZICCACACHHCCZAABCZCZKCZAAAAAELMC
    JMCABLFLKJFGG $.

  $( Step 28 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem12 $p |- ( ( ( th -> ( -. -. ch -> ch ) ) -> ph ) -> ph ) $=
    ( wn wi merlem5 merlem2 ax-mp merlem4 merlem11 ) CBDDBEZEZAEZMAEZEZNLOBBEKE
    LBBFBKCGHAMLIHMAJH $.

  $( Step 35 of Meredith's proof of Lukasiewicz axioms from his sole axiom.
     (Contributed by NM, 14-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merlem13 $p |- ( ( ph -> ps ) ->
              ( ( ( th -> ( -. -. ch -> ch ) ) -> -. -. ph ) -> ps ) ) $=
    ( wi wn merlem12 merlem5 ax-mp merlem6 ax-meredith merlem11 ) BBEZAFZDCFFCE
    EZNFZEZFZEZEAEZAEZABEQBEETUAEZUASUBOREZREZSRCDGRBEZRFPEZEREUCEZUDSEUFUGQPEU
    FPCDGQPHIRUEUFOJIRBRNUCKIIAMSTJITALIBBAQAKI $.

  $( 1 of 3 axioms for propositional calculus due to Lukasiewicz, derived from
     Meredith's sole axiom.  (Contributed by NM, 14-Dec-2002.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  luk-1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( wi wn ax-meredith merlem13 ax-mp ) CCDZAEZEZEJDDKDBDZBCDACDDZDZABDZMDZCCK
    ABFMADZOEZEZERDDSDLDZNPDOLDTABJIGOLRQGHMASOLFHH $.

  $( 2 of 3 axioms for propositional calculus due to Lukasiewicz, derived from
     Meredith's sole axiom.  (Contributed by NM, 14-Dec-2002.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  luk-2 $p |- ( ( -. ph -> ph ) -> ph ) $=
    ( wn wi merlem5 merlem4 ax-mp merlem11 ax-meredith ) ABZACZJACZCZKAJBZCIBMC
    CZICZICZLOPCZPNQAMDIONEFOIGFAMIJIHFJAGF $.

  $( 3 of 3 axioms for propositional calculus due to Lukasiewicz, derived from
     Meredith's sole axiom.  (Contributed by NM, 14-Dec-2002.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  luk-3 $p |- ( ph -> ( -. ph -> ps ) ) $=
    ( wn wi merlem11 merlem1 ax-mp ) ACZHBDZDIDAIDHBEABHIFG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Derive the standard axioms from the Lukasiewicz axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    luklem1.1 $e |- ( ph -> ps ) $.
    luklem1.2 $e |- ( ps -> ch ) $.
    $( Used to rederive standard propositional axioms from Lukasiewicz'.
       (Contributed by NM, 23-Dec-2002.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    luklem1 $p |- ( ph -> ch ) $=
      ( wi luk-1 ax-mp ) BCFZACFZEABFIJFDABCGHH $.
  $}

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem2 $p |- ( ( ph -> -. ps ) ->
                ( ( ( ph -> ch ) -> th ) -> ( ps -> th ) ) ) $=
    ( wn wi luk-1 luk-3 ax-mp luklem1 ) ABEZFZBACFZFZMDFBDFFLKCFZMFZNAKCGBOFPNF
    BCHBOMGIJBMDGJ $.

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem3 $p |- ( ph -> ( ( ( -. ph -> ps ) -> ch ) -> ( th -> ch ) ) ) $=
    ( wn wi luk-3 luklem2 luklem1 ) AAEZDEZFJBFCFDCFFAKGJDBCHI $.

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem4 $p |- ( ( ( ( -. ph -> ph ) -> ph ) -> ps ) -> ps ) $=
    ( wn wi luk-2 luklem3 ax-mp luk-1 luklem1 ) ACADADZBDZBCZBDZBLJDZKMDJCJDJDZ
    NJEJONDAEJJJLFGGLJBHGBEI $.

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem5 $p |- ( ph -> ( ps -> ph ) ) $=
    ( wn wi luklem3 luklem4 luklem1 ) AACADADBADZDHAAABEAHFG $.

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem6 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    ( wi luk-1 wn luklem5 luklem2 luklem4 luklem1 ax-mp ) AABCZCKBCZKCZKAKBDKEZ
    KCZKCMKCZCZPMOCZQNLCRNBEZNCZLNSFTSBCBCLCLSKBBGBLHIINLKDJMOKDJKPHJI $.

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem7 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ps -> ( ph -> ch ) ) ) $=
    ( wi luk-1 luklem5 luklem1 luklem6 ax-mp ) ABCDZDJCDZACDZDZBLDZAJCEBKDMNDBJ
    KDZKBJBDOBJFJBCEGJCHGBKLEIG $.

  $( Used to rederive standard propositional axioms from Lukasiewicz'.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  luklem8 $p |- ( ( ph -> ps ) -> ( ( ch -> ph ) -> ( ch -> ps ) ) ) $=
    ( wi luk-1 luklem7 ax-mp ) CADZABDZCBDZDDIHJDDCABEHIJFG $.

  $( Standard propositional axiom derived from Lukasiewicz axioms.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax1 $p |- ( ph -> ( ps -> ph ) ) $=
    ( luklem5 ) ABC $.

  $( Standard propositional axiom derived from Lukasiewicz axioms.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax2 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( ph -> ps ) -> ( ph -> ch ) ) ) $=
    ( wi luklem7 luklem8 luklem6 ax-mp luklem1 ) ABCDDBACDZDZABDZJDZABCEKLAJDZD
    ZMBJAFNJDOMDACGNJLFHII $.

  $( Standard propositional axiom derived from Lukasiewicz axioms.
     (Contributed by NM, 22-Dec-2002.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax3 $p |- ( ( -. ph -> -. ps ) -> ( ps -> ph ) ) $=
    ( wn wi luklem2 luklem4 luklem1 ) ACZBCDHADADBADZDIHBAAEAIFG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Derive Nicod's axiom from the standard axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Prove Nicod's axiom and implication and negation definitions.

$)

  $( Define implication in terms of 'nand'.  Analogous to
     ` ( ( ph -/\ ( ps -/\ ps ) ) <-> ( ph -> ps ) ) ` .  In a pure
     (standalone) treatment of Nicod's axiom, this theorem would be changed to
     a definition ($a statement).  (Contributed by NM, 11-Dec-2008.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-dfim $p |- ( ( ( ph -/\ ( ps -/\ ps ) ) -/\ ( ph -> ps ) ) -/\
                   ( ( ( ph -/\ ( ps -/\ ps ) ) -/\ ( ph -/\ ( ps -/\ ps ) ) )
                          -/\
                     ( ( ph -> ps ) -/\ ( ph -> ps ) ) ) ) $=
    ( wnan wi wb nanim bicomi nanbi mpbi ) ABBCCZABDZEJKCJJCKKCCCKJABFGJKHI $.

  $( Define negation in terms of 'nand'.  Analogous to
     ` ( ( ph -/\ ph ) <-> -. ph ) ` .  In a pure (standalone) treatment of
     Nicod's axiom, this theorem would be changed to a definition ($a
     statement).  (Contributed by NM, 11-Dec-2008.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-dfneg $p |- ( ( ( ph -/\ ph ) -/\ -. ph ) -/\
                    ( ( ( ph -/\ ph ) -/\ ( ph -/\ ph ) ) -/\
                      ( -. ph -/\ -. ph ) ) ) $=
    ( wnan wn wb nannot bicomi nanbi mpbi ) AABZACZDIJBIIBJJBBBJIAEFIJGH $.

  ${
    $( Minor premise. $)
    nic-jmin $e |- ph $.
    $( Major premise. $)
    nic-jmaj $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    $( Derive Nicod's rule of modus ponens using 'nand', from the standard
       one.  Although the major and minor premise together also imply ` ch ` ,
       this form is necessary for useful derivations from ~ nic-ax .  In a pure
       (standalone) treatment of Nicod's axiom, this theorem would be changed
       to an axiom ($a statement).  (Contributed by Jeff Hoffman,
       19-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-mp $p |- ps $=
      ( wnan wa wi nannan mpbi simprd ax-mp ) ABDACBACBFFACBGHEABCIJKL $.

    $( A direct proof of ~ nic-mp .  (Contributed by NM, 30-Dec-2008.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    nic-mpALT $p |- ps $=
      ( wa wi wn wnan df-nan anbi2i xchbinx mpbi iman mpbir simprd ax-mp ) ABDA
      CBACBFZGARHZFZHZACBIZIZUAEUCAUBFTAUBJUBSACBJKLMARNOPQ $.
  $}

  $( Nicod's axiom derived from the standard ones.  See _Intro. to Math.
     Phil._ by B. Russell, p. 152.  Like ~ meredith , the usual axioms can be
     derived from this and vice versa.  Unlike ~ meredith , Nicod uses a
     different connective ('nand'), so another form of modus ponens must be
     used in proofs, e.g. ` { ` ~ nic-ax , ~ nic-mp ` } ` is equivalent to
     ` { ` ~ luk-1 , ~ luk-2 , ~ luk-3 , ~ ax-mp ` } ` .  In a pure
     (standalone) treatment of Nicod's axiom, this theorem would be changed to
     an axiom ($a statement).  (Contributed by Jeff Hoffman, 19-Nov-2007.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-ax $p |- ( ( ph -/\ ( ch -/\ ps ) ) -/\
                   ( ( ta -/\ ( ta -/\ ta ) ) -/\
                     ( ( th -/\ ch ) -/\
                       ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    ( wnan wa wi nannan biimpi simpl imim2i wn imnan df-nan bitr4i imim2d con2b
    con3 mpbir 3bitr4ri syl6ibr syl5bir nanim sylib 3syl pm4.24 jctil ) ACBFFZE
    EEFFZDCFZADFZULFFZFFUIUJUMGHUIUMUJUIACBGZHZACHZUMUIUOABCIJUNCACBKLUPUKULHUM
    UKDCMZHZUPULURDCGMUKDCNDCOPUPURDAMZHZULUPUQUSDACSQADMHADGMUTULADNDARADOUAUB
    UCUKULUDUEUFUJEEEGZHEVAEUGJEEEITUHUIUMUJIT $.

  $( A direct proof of ~ nic-ax .  (Contributed by NM, 11-Dec-2008.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-axALT $p |- ( ( ph -/\ ( ch -/\ ps ) ) -/\ ( ( ta -/\ ( ta -/\ ta ) )
          -/\ ( ( th -/\ ch ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    ( wnan wa wn anidm df-nan anbi2i notbii iman 3bitr4i bitr4i xchbinx anbi12i
    wi imnan mpbir simpl imim2i con3 imim2d biimpri jctil con2b bitr3i 3bitri
    syl ) ACBFZFZEEEFZFZDCFZADFZUPFZFZFZFULUSGZHZVAACBGZRZEEEGZRZDCHZRZDAHZRZRZ
    GZRZVCVJVEVCACRZVJVBCACBUAUBVMVFVHDACUCUDUJVDEEIUEUFVAVCVKHZGZHVLUTVOULVCUS
    VNAUKGZHAVBHZGZHULVCVPVRUKVQACBJKLAUKJAVBMNUSUNURGVKUNURJUNVEURVJEUMGZHEVDH
    ZGZHUNVEVSWAUMVTEEEJKLEUMJEVDMNUOUQGZHVGVIHZGZHURVJWBWDUOVGUQWCUODCGHVGDCJD
    CSOUQUPUPGZVIUPUPJWEUPADGHZVIUPIADJWFADHRVIADSADUGUHUIPQLUOUQJVGVIMNQPQLVCV
    KMOTULUSJT $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Derive the Lukasiewicz axioms from Nicod's axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Minor premise. $)
    nic-imp.1 $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    $( Inference for ~ nic-mp using ~ nic-ax as major premise.  (Contributed by
       Jeff Hoffman, 17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-imp $p |- ( ( th -/\ ch ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) $=
      ( wta wnan nic-ax nic-mp ) ACBGGDCGADGZJGGFFFGGEABCDFHI $.
  $}

  $( Lemma for ~ nic-id .  (Contributed by Jeff Hoffman, 17-Nov-2007.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-idlem1 $p |- ( ( th -/\ ( ta -/\ ( ta -/\ ta ) ) ) -/\
                 ( ( ( ph -/\ ( ch -/\ ps ) ) -/\ th ) -/\
                   ( ( ph -/\ ( ch -/\ ps ) ) -/\ th ) ) ) $=
    ( wnan nic-ax nic-imp ) ACBFFACFAAFZIFFEEEFFDABCAEGH $.

  ${
    nic-idlem2.1 $e |- ( et -/\ ( ( ph -/\ ( ch -/\ ps ) ) -/\ th ) ) $.
    $( Lemma for ~ nic-id .  Inference used by ~ nic-id .  (Contributed by Jeff
       Hoffman, 17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-idlem2 $p |- ( ( th -/\ ( ta -/\ ( ta -/\ ta ) ) ) -/\ et ) $=
      ( wnan nic-ax nic-imp nic-mp ) FACBHHZDHZHDEEEHHZHZFHZPGOMMFLACHAAHZQHHND
      ABCAEIJJK $.
  $}

  $( Theorem ~ id expressed with ` -/\ ` .  (Contributed by Jeff Hoffman,
     17-Nov-2007.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  nic-id $p |- ( ta -/\ ( ta -/\ ta ) ) $=
    ( wph wps wch wth wnan nic-ax nic-idlem2 nic-idlem1 nic-mp ) BCFZCBFZLFFZDD
    DFZFZFZCCCFFZFAAAFFZOEEEMDQCCCBEGHMNDPCORFKLLOAIHJ $.

  $( ` -/\ ` is symmetric.  (Contributed by Jeff Hoffman, 17-Nov-2007.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-swap $p |- ( ( th -/\ ph ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) $=
    ( wta wnan nic-id nic-ax nic-mp ) AAADDBADABDZHDDCCCDDAEAAABCFG $.

  ${
    nic-isw1.1 $e |- ( th -/\ ph ) $.
    $( Inference version of ~ nic-swap .  (Contributed by Jeff Hoffman,
       17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-isw1 $p |- ( ph -/\ th ) $=
      ( wnan nic-swap nic-mp ) BADABDZGCABEF $.
  $}

  ${
    nic-isw2.1 $e |- ( ps -/\ ( th -/\ ph ) ) $.
    $( Inference for swapping nested terms.  (Contributed by Jeff Hoffman,
       17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-isw2 $p |- ( ps -/\ ( ph -/\ th ) ) $=
      ( wnan nic-swap nic-imp nic-mp nic-isw1 ) BACEZBCAEZEJBEZLDJKKBCAFGHI $.
  $}

  ${
    nic-iimp1.1 $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    nic-iimp1.2 $e |- ( th -/\ ch ) $.
    $( Inference version of ~ nic-imp using right-handed term.  (Contributed by
       Jeff Hoffman, 17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-iimp1 $p |- ( th -/\ ph ) $=
      ( wnan nic-imp nic-mp nic-isw1 ) DADCGADGZKFABCDEHIJ $.
  $}

  ${
    nic-iimp2.1 $e |- ( ( ph -/\ ps ) -/\ ( ch -/\ ch ) ) $.
    nic-iimp2.2 $e |- ( th -/\ ph ) $.
    $( Inference version of ~ nic-imp using left-handed term.  (Contributed by
       Jeff Hoffman, 17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-iimp2 $p |- ( th -/\ ( ch -/\ ch ) ) $=
      ( wnan nic-isw1 nic-iimp1 ) CCGZBADJABGEHFI $.
  $}

  ${
    nic-idel.1 $e |- ( ph -/\ ( ch -/\ ps ) ) $.
    $( Inference to remove the trailing term.  (Contributed by Jeff Hoffman,
       17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-idel $p |- ( ph -/\ ( ch -/\ ch ) ) $=
      ( wnan nic-id nic-isw1 nic-imp nic-mp ) CCEZCEAJEZKJCCFGABCJDHI $.
  $}

  ${
    nic-ich.1 $e |- ( ph -/\ ( ps -/\ ps ) ) $.
    nic-ich.2 $e |- ( ps -/\ ( ch -/\ ch ) ) $.
    $( Chained inference.  (Contributed by Jeff Hoffman, 17-Nov-2007.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    nic-ich $p |- ( ph -/\ ( ch -/\ ch ) ) $=
      ( wnan nic-isw1 nic-imp nic-mp ) CCFZBFAJFZKJBEGABBJDHI $.
  $}

  ${
    nic-idbl.1 $e |- ( ph -/\ ( ps -/\ ps ) ) $.
    $( Double the terms.  Since doubling is the same as negation, this can be
       viewed as a contraposition inference.  (Contributed by Jeff Hoffman,
       17-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-idbl $p |- ( ( ps -/\ ps ) -/\ ( ( ph -/\ ph ) -/\ ( ph -/\ ph ) ) ) $=
      ( wnan nic-imp nic-ich ) BBDABDAADABBBCEABBACEF $.
  $}

$( (not in Table of Contents)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Biconditional justification from Nicod's axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( For nic-* definitions, the biconditional connective is not used.  Instead,
     definitions are made based on this form. ~ nic-bi1 and ~ nic-bi2 are used
     to convert the definitions into usable theorems about one side of the
     implication.  (Contributed by Jeff Hoffman, 18-Nov-2007.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-bijust $p |- ( ( ta -/\ ta ) -/\ ( ( ta -/\ ta ) -/\ ( ta -/\ ta ) ) ) $=
    ( nic-swap ) AAB $.

  ${
    $( 'Biconditional' premise. $)
    nic-bi1.1 $e |- ( ( ph -/\ ps ) -/\ ( ( ph -/\ ph )
         -/\ ( ps -/\ ps ) ) ) $.
    $( Inference to extract one side of an implication from a definition.
       (Contributed by Jeff Hoffman, 18-Nov-2007.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    nic-bi1 $p |- ( ph -/\ ( ps -/\ ps ) ) $=
      ( wnan nic-id nic-iimp1 nic-isw2 nic-idel ) AABBAAABDBBDAADACAEFGH $.
  $}

  ${
    $( 'Biconditional' premise.  $)
    nic-bi2.1 $e |- ( ( ph -/\ ps ) -/\ ( ( ph -/\ ph )
         -/\ ( ps -/\ ps ) ) ) $.
    $( Inference to extract the other side of an implication from a
       'biconditional' definition.  (Contributed by Jeff Hoffman,
       18-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-bi2 $p |- ( ps -/\ ( ph -/\ ph ) ) $=
      ( wnan nic-isw2 nic-id nic-iimp1 nic-idel ) BBAABDZAADZBBDZBKIJCEBFGH $.
  $}

$( (not in Table of Contents)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Prove the Lukasiewicz axioms from Nicod's axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Minor premise. $)
    nic-smin $e |- ph $.
    $( Major premise. $)
    nic-smaj $e |- ( ph -> ps ) $.
    $( Derive the standard modus ponens from ~ nic-mp .  (Contributed by Jeff
       Hoffman, 18-Nov-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    nic-stdmp $p |- ps $=
      ( wi wnan nic-dfim nic-bi2 nic-mp ) ABBCABEZABBFFZKDKJABGHII $.
  $}

  $( Proof of ~ luk-1 from ~ nic-ax and ~ nic-mp (and definitions ~ nic-dfim
     and ~ nic-dfneg ).  Note that the standard axioms ~ ax-1 , ~ ax-2 , and
     ~ ax-3 are proved from the Lukasiewicz axioms by theorems ~ ax1 , ~ ax2 ,
     and ~ ax3 .  (Contributed by Jeff Hoffman, 18-Nov-2007.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nic-luk1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( wta wi nic-dfim nic-bi2 nic-ax nic-isw2 nic-idel nic-bi1 nic-idbl nic-imp
    wnan nic-swap nic-ich nic-mp ) ABEZBCEZACEZEZUANNZRUAEZUCRABBNNZUAUDRABFGUD
    STTNZNZUAUDCCNZBNZAUGNZUINZNZUFUDDDDNNZUKUKUDULABBUGDHIJUKUEUHNUFUEUJUJUHUI
    TUITACFKLMSUHUHUESBUGNZUHUMSBCFGUGBOPMPPUFUASTFKPPUBUCRUAFKQ $.

  $( Proof of ~ luk-2 from ~ nic-ax and ~ nic-mp .  (Contributed by Jeff
     Hoffman, 18-Nov-2007.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  nic-luk2 $p |- ( ( -. ph -> ph ) -> ph ) $=
    ( wn wi wnan nic-dfim nic-bi2 nic-dfneg nic-iimp1 nic-isw2 nic-isw1 nic-bi1
    nic-id nic-mp ) ABZACZAADZDZOACZROPONPDZSPSONAEFNPPPNDNNDPPDPAGPLHIHJQROAEK
    M $.

  $( Proof of ~ luk-3 from ~ nic-ax and ~ nic-mp .  (Contributed by Jeff
     Hoffman, 18-Nov-2007.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  nic-luk3 $p |- ( ph -> ( -. ph -> ps ) ) $=
    ( wnan nic-dfim nic-bi1 nic-dfneg nic-bi2 nic-id nic-iimp1 nic-iimp2 nic-mp
    wn wi ) AALZBMZOCCZAOMZQNBBCZOANRCONBDENAACZSASNAFGAHIJPQAODEK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Derive Nicod's Axiom from Lukasiewicz's First Sheffer Stroke Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( This alternative axiom for propositional calculus using the Sheffer Stroke
     was offered by Lukasiewicz in his Selected Works.  It improves on Nicod's
     axiom by reducing its number of variables by one.

     This axiom also uses ~ nic-mp for its constructions.

     Here, the axiom is proved as a substitution instance of ~ nic-ax .
     (Contributed by Anthony Hart, 31-Jul-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  lukshef-ax1 $p |- ( ( ph -/\ ( ch -/\ ps ) ) -/\ ( ( th -/\ ( th -/\ th ) )
          -/\ ( ( th -/\ ch ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    ( nic-ax ) ABCDDE $.

  $( Lemma for ~ renicax .  (Contributed by NM, 31-Jul-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  lukshefth1 $p |- ( ( ( ( ta -/\ ps ) -/\ ( ( ph -/\ ta ) -/\ ( ph
          -/\ ta ) ) ) -/\ ( th -/\ ( th -/\ th ) ) ) -/\ ( ph -/\ ( ps
          -/\ ch ) ) ) $=
    ( wnan lukshef-ax1 nic-mp ) ABCFFZEEEFFZEBFAEFZKFFZFZFZLDDDFFZFZIFZQACBEGPM
    MFFZNQQFFIIIFFJODEFEDFZSFFZFFRLLLFFEEEDGJTOLGHPMMIGHH $.

  $( Lemma for ~ renicax .  (Contributed by NM, 31-Jul-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  lukshefth2 $p |- ( ( ta -/\ th ) -/\ ( ( th -/\ ta ) -/\ ( th
          -/\ ta ) ) ) $=
    ( wps wch wph wnan lukshef-ax1 nic-mp lukshefth1 ) AAAFFZBAFABFZKFFBBBFFAJF
    ZCDEFFZAFZNFFZJBEFEBFZPFFZMJADFCAFZRFFZFFOJCEDAGMSJAGHQJFZEEEFFZFZOTFZUCEEE
    ABIOUAENFLEFZUDFFZFFUBUCUCFFTTTFFLNNEGOUEUATGHHHAAABGH $.

  $( A rederivation of ~ nic-ax from ~ lukshef-ax1 , proving that ~ lukshef-ax1
     with ~ nic-mp can be used as a complete axiomatization of propositional
     calculus.  (Contributed by Anthony Hart, 31-Jul-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  renicax $p |- ( ( ph -/\ ( ch -/\ ps ) ) -/\ ( ( ta -/\ ( ta -/\ ta ) )
          -/\ ( ( th -/\ ch ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    ( wnan lukshefth1 lukshefth2 nic-mp lukshef-ax1 ) EEEFFZDCFADFZLFFZFZACBFFZ
    FZONFZQOMKFZFZPPROFSSACBEDGORHINRRFFSPPFFOOOFFMKHNRROJIIONHI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Derive the Lukasiewicz Axioms from the Tarski-Bernays-Wajsberg Axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Justification for ~ tbw-negdf .  (Contributed by Anthony Hart,
     15-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  tbw-bijust $p |- ( ( ph <-> ps ) <-> ( ( ( ph -> ps )
    -> ( ( ps -> ph ) -> F. ) ) -> F. ) ) $=
    ( wb wi wn wfal dfbi1 pm2.21 imim2i falim impbii notbii ax-1 pm2.43i 3bitri
    id ja ) ABCABDZBADZEZDZERSFDZDZEZUCFDZABGUAUCUAUCTUBRSFHIUBTRSFTTPTJQIKLUDU
    EUCFHUEUDUCFUEUDDZUDUEMUFJQNKO $.

  $( The definition of negation, in terms of ` -> ` and ` F. ` .  (Contributed
     by Anthony Hart, 15-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  tbw-negdf $p |- ( ( ( -. ph -> ( ph -> F. ) )
    -> ( ( ( ph -> F. ) -> -. ph ) -> F. ) ) -> F. ) $=
    ( wn wfal wi wb pm2.21 ax-1 falim ja pm2.43i impbii tbw-bijust mpbi ) ABZAC
    DZENODONDZCDDCDNOACFONACPNOGPHIJKNOLM $.

  $( The first of four axioms in the Tarski-Bernays-Wajsberg system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbw-ax1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( imim1 ) ABCD $.

  $( The second of four axioms in the Tarski-Bernays-Wajsberg system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbw-ax2 $p |- ( ph -> ( ps -> ph ) ) $=
    ( ax-1 ) ABC $.

  $( The third of four axioms in the Tarski-Bernays-Wajsberg system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbw-ax3 $p |- ( ( ( ph -> ps ) -> ph ) -> ph ) $=
    ( peirce ) ABC $.

  $( The fourth of four axioms in the Tarski-Bernays-Wajsberg system.

     This axiom was added to the Tarski-Bernays axiom system ( see ~ tb-ax1 ,
     ~ tb-ax2 , and ~ tb-ax3 ) by Wajsberg for completeness.  (Contributed by
     Anthony Hart, 13-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  tbw-ax4 $p |- ( F. -> ph ) $=
    ( falim ) AB $.

  ${
    tbwsyl.1 $e |- ( ph -> ps ) $.
    tbwsyl.2 $e |- ( ps -> ch ) $.
    $( Used to rederive the Lukasiewicz axioms from Tarski-Bernays-Wajsberg'.
       (Contributed by Anthony Hart, 16-Aug-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    tbwsyl $p |- ( ph -> ch ) $=
      ( wi tbw-ax1 ax-mp ) BCFZACFZEABFIJFDABCGHH $.
  $}

  $( Used to rederive the Lukasiewicz axioms from Tarski-Bernays-Wajsberg'.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbwlem1 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ps -> ( ph -> ch ) ) ) $=
    ( wi tbw-ax2 tbw-ax1 tbwsyl tbw-ax3 mpsyl ) BBCDZCDZDAJDKACDZDBLDBJKDZKBJBD
    MBJEJBCFGMKCDKDKJKCFKCHGGAJCFBKLFI $.

  $( Used to rederive the Lukasiewicz axioms from Tarski-Bernays-Wajsberg'.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbwlem2 $p |- ( ( ph -> ( ps -> F. ) ) -> ( ( ( ph -> ch ) -> th )
    -> ( ps -> th ) ) ) $=
    ( wfal wi tbw-ax4 tbw-ax1 tbwlem1 ax-mp mpsyl tbwsyl ) ABEFZFZBACFZFZODFBDF
    FBMCFZFZNQOFPMBCFZFZRECFZTCGMUASFFUATFBECHMUASIJJMBCIJAMCHBQOHKBODHL $.

  $( Used to rederive the Lukasiewicz axioms from Tarski-Bernays-Wajsberg'.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbwlem3 $p |- ( ( ( ( ( ph -> F. ) -> ph ) -> ph ) -> ps ) -> ps ) $=
    ( wfal wi tbw-ax3 tbw-ax2 tbw-ax1 tbwsyl ax-mp ) ACDADADZBDZKBDZDZLJMACEJKJ
    DMJKFKJBGHIMLBDLDLKLBGLBEHI $.

  $( Used to rederive the Lukasiewicz axioms from Tarski-Bernays-Wajsberg'.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbwlem4 $p |- ( ( ( ph -> F. ) -> ps ) -> ( ( ps -> F. ) -> ph ) ) $=
    ( wfal wi tbw-ax4 tbw-ax1 tbwlem1 ax-mp tbwlem2 tbwlem3 tbwsyl ) ACDZBDZLBC
    DZCDZDZNADZBODZMPDZNNDZRCCDZTCENUANDDUATDBCCFNUANGHHNBCGHMRPDDRSDLBOFMRPGHH
    PLADADQDQLNAAIAQJKK $.

  $( Used to rederive the Lukasiewicz axioms from Tarski-Bernays-Wajsberg'.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tbwlem5 $p |- ( ( ( ph -> ( ps -> F. ) ) -> F. ) -> ph ) $=
    ( wfal wi tbw-ax2 tbw-ax1 tbwsyl tbwlem1 ax-mp tbwlem4 ) ACDZABCDZDZDZMCDAD
    AKLDZDNABADOABEBACFGAKLHIAMJI $.

  $( ~ luk-1 derived from the Tarski-Bernays-Wajsberg axioms.  (Contributed by
     Anthony Hart, 16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1luk1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( tbw-ax1 ) ABCD $.

  $( ~ luk-2 derived from the Tarski-Bernays-Wajsberg axioms.  (Contributed by
     Anthony Hart, 16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1luk2 $p |- ( ( -. ph -> ph ) -> ph ) $=
    ( wn wi wfal tbw-negdf tbw-ax2 tbwlem4 ax-mp tbw-ax1 tbw-ax3 tbwsyl ) ABZAC
    ZADCZACZANLCZMOCLNCZPDCZCZDCZPAERSCTPCRQFPSGHHNLAIHADJK $.

  $( ~ luk-3 derived from the Tarski-Bernays-Wajsberg axioms.

     This theorem, along with ~ re1luk1 and ~ re1luk2 proves that ~ tbw-ax1 ,
     ~ tbw-ax2 , ~ tbw-ax3 , and ~ tbw-ax4 , with ~ ax-mp can be used as a
     complete axiom system for all of propositional calculus.  (Contributed by
     Anthony Hart, 16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1luk3 $p |- ( ph -> ( -. ph -> ps ) ) $=
    ( wn wfal wi tbw-negdf tbwlem5 ax-mp tbw-ax4 tbw-ax1 tbwlem1 mpsyl ) ACZADE
    ZEZANBEZMBEONMEZDEEDEOAFOQGHNABEZEZAPEDBEZSBINTREETSEADBJNTRKHHNABKHMNBJL
    $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Derive the Tarski-Bernays-Wajsberg axioms from Meredith's First CO Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A single axiom for propositional calculus offered by Meredith.

     This axiom is worthy of note, due to it having only 19 symbols, not
     counting parentheses.  The more well-known ~ meredith has 21 symbols, sans
     parentheses.

     See ~ merco2 for another axiom of equal length.  (Contributed by Anthony
     Hart, 13-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  merco1 $p |- ( ( ( ( ( ph -> ps ) -> ( ch -> F. ) ) -> th ) -> ta )
         -> ( ( ta -> ph ) -> ( ch -> ph ) ) ) $=
    ( wi wfal wn ax-1 falim ja imim2i imim1i meredith syl ) ABFZCGFZFZDFZEFPDHZ
    CHZFZFZDFZEFEAFCAFFUDSERUCDQUBPCGUBUATIUBJKLMMABDCENO $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem1 $p |- ( ph -> ( F. -> ch ) ) $=
    ( wfal wi merco1 ax-mp ) AACADZDZDZACBDZDZHGDZHDZIGCDACDZDZGDHDZMGNDZNDZGDO
    DPCAANGEGNAGOEFGCAGHEFHCDZNDZGDLDZMIDQSDHDTDUACAASHEGNHHTEFHCAGLEFFHJDZKDZI
    KDZJCDNDZGDHDZUCRJDUEDUFCAANJEGNAJUEEFJCAGHEFKCDICDZDZJDUBDZUCUDDJUGDSDKDUH
    DUICBISKEJUGHKUHEFKCIJUBEFFF $.

  $( ~ tbw-ax4 rederived from ~ merco1 .  (Contributed by Anthony Hart,
     17-Sep-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  retbwax4 $p |- ( F. -> ph ) $=
    ( wfal wi merco1lem1 ax-mp ) ABACZCZFAADGADE $.

  $( ~ tbw-ax2 rederived from ~ merco1 .  (Contributed by Anthony Hart,
     17-Sep-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  retbwax2 $p |- ( ph -> ( ps -> ph ) ) $=
    ( wi wfal merco1lem1 merco1 ax-mp ) AAAACZCZCZABACZCZDACZHCZICZJHACADCZCACZ
    MCOQAEHAAAMFGIPCPCDCNCOJCAHAPDFIPADNFGGMKCZLCZJLCZKACPCACZMCSUAAEKAAAMFGLBD
    CZCJDCZCDCRCSTCAKBUCDFLUBJDRFGGG $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem2 $p |- ( ( ( ph -> ps ) -> ch ) -> ( ( ( ps -> ta ) -> ( ph ->
    F. ) ) -> ch ) ) $=
    ( wi wfal retbwax2 merco1 ax-mp ) CAEZBDEAFEEZFEZEZBEABEZEZNCEKCEELMEOLJGBD
    AFMHICAKBNHI $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem3 $p |- ( ( ( ph -> ps ) -> ( ch -> F. ) ) -> ( ch -> ph ) ) $=
    ( wi wfal merco1lem2 retbwax2 ax-mp ) AAADZAEDDZIDZDZABDCEDDZCADZDZIEDJEDDZ
    LAAEAFKLDPLDKAGJILEFHHNEDMEDDZLODZCAEBFORDQRDOLGMNREFHHH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem4 $p |- ( ( ( ph -> ps ) -> ch ) -> ( ps -> ch ) ) $=
    ( wi wfal merco1lem3 merco1 ax-mp ) CADZBEDZDZBDABDZDZLCDBCDDJAEDZDIEDZDKDM
    JNIFBEAOKGHCABBLGH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem5 $p |- ( ( ( ( ph -> F. ) -> ch ) -> ta ) -> ( ph -> ta ) ) $=
    ( wi wfal merco1lem4 merco1 ax-mp ) CADZAEDZDBDJBDZDKCDACDDIJBFCAABKGH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem6 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ch -> ( ph -> ps ) ) ) $=
    ( wi wfal merco1lem5 merco1lem3 ax-mp merco1 ) ABDZEDCEDZDZEDZADZAJDCJDDJME
    DZDZNLODZPOEDMDQLEEFOELGHJKOFHABMGHJECEAIH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem7 $p |- ( ph -> ( ( ( ps -> ch ) -> ps ) -> ps ) ) $=
    ( wi wfal merco1lem5 merco1 ax-mp merco1lem6 ) BCDZBDZKBDZDZALDBEDKEDZDCDJD
    MBNCFBEKCJGHKBAIH $.

  $( ~ tbw-ax3 rederived from ~ merco1 .  (Contributed by Anthony Hart,
     17-Sep-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  retbwax3 $p |- ( ( ( ph -> ps ) -> ph ) -> ph ) $=
    ( wi retbwax2 merco1lem7 ax-mp ) AAACCZABCACACAADGABEF $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 17-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem8 $p |- ( ph -> ( ( ps -> ( ps -> ch ) ) -> ( ps -> ch ) ) ) $=
    ( wi merco1lem6 ax-mp ) BBCDZDZHGDZDAIDBCHEHGAEF $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem9 $p |- ( ( ph -> ( ph -> ps ) ) -> ( ph -> ps ) ) $=
    ( wfal wi merco1lem8 ax-mp ) CADZAABDZDHDZDZIGABEJABEF $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem10 $p |- ( ( ( ( ( ph -> ps ) -> ch ) -> ( ta -> ch ) ) -> ph ) ->
    ( th -> ph ) ) $=
    ( wi wfal merco1 merco1lem2 ax-mp ) ABFZDGFZFCAFEGFFAFZGFZFKCFECFFZFZOAFDAF
    FMKFOFPCAEAKHMKOLIJABDNOHJ $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem11 $p |- ( ( ph -> ps ) -> ( ( ( ch -> ( ph -> ta ) ) -> F. ) -> ps
    ) ) $=
    ( wi wfal merco1lem5 merco1lem3 ax-mp merco1lem4 merco1 merco1lem2 ) ADEZBA
    EZCMEZFEZFEZEZFEZFEZEZABEPBEEZOTEZUAQTEZUCRTEZUDTFESEUERFFGTFRHINQTJIOFTGIC
    MTJISAEUBEUAUBEBAPFAKSAUBDLII $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem12 $p |- ( ( ph -> ps ) -> ( ( ( ch -> ( ph -> ta ) ) -> ph ) -> ps
    ) ) $=
    ( wi wfal merco1lem3 merco1 ax-mp merco1lem9 merco1lem11 ) BAEZCADEZEZAEZFE
    ZEFEAEZABEOBEEOAEZQOREZRMPECFEZENESMPCGADOTNHIOAJIOALFKIBAOFAHI $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem13 $p |- ( ( ( ( ph -> ps ) -> ( ch -> ps ) ) -> ta ) -> ( ph ->
    ta ) ) $=
    ( wi wfal merco1 merco1lem4 ax-mp merco1lem12 ) DAEZAFEEAEABECBEEZEZLDEADEE
    ALEZMBAECFEEAEZAELENBACAAGOALHIALKFJIDAAALGI $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem14 $p |- ( ( ( ( ph -> ps ) -> ps ) -> ch ) -> ( ph -> ch ) ) $=
    ( wi wfal merco1lem13 merco1lem8 merco1 ax-mp merco1lem9 merco1lem12 ) CADZ
    AEDDADABDZBDZDZNCDACDDANDZOMNDNDZPDZPABMNFRRPDZDZSPADREDDADZQDTUAMBGPARAQHI
    RPJIIANLEKICAAANHI $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem15 $p |- ( ( ph -> ps ) -> ( ph -> ( ch -> ps ) ) ) $=
    ( wi merco1lem14 merco1lem13 ax-mp ) ABDZBDCBDZDAIDZDHJDABIEHBCJFG $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem16 $p |- ( ( ( ph -> ( ps -> ch ) ) -> ta ) -> ( ( ph -> ch ) -> ta
    ) ) $=
    ( wi wfal merco1lem15 merco1lem11 ax-mp merco1 ) DAEZACEZFEEFEABCEEZEZMDELD
    EELMENACBGLMKFHIDALFMJI $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem17 $p |- ( ( ( ( ( ph -> ps ) -> ph ) -> ch ) -> ta ) -> ( ( ph ->
    ch ) -> ta ) ) $=
    ( wfal merco1lem11 merco1lem7 ax-mp merco1lem9 merco1lem4 merco1lem16 mpsyl
    wi merco1 ) DAMZACMZEMZMCMZABMAMZCMZMTDMPDMMQPMZTMZRQCMTPTMZUBCAMZSEMMEMAMZ
    UCSAMZUEMZUESAUDEFUGUGUEMZMZUHUEAMUGEMMAMZUFMUIUJABGUEAUGAUFNHUGUEIHHCASEAN
    HTAMZUAEMMEMPMZUCUBMUAPMZULMZULUAPUKEFUNUNULMZMZUOULAMUNEMMAMZUMMUPUQPEGULA
    UNAUMNHUNULIHHTAUAEPNHHOQCJQACTKLDAPCTNH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco1 .
     (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco1lem18 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( ps -> ph ) -> ( ps ->
    ch ) ) ) $=
    ( wfal merco1 merco1lem17 ax-mp merco1lem5 merco1lem3 merco1lem4 merco1lem2
    wi merco1lem9 ) BALZABCLZLZNOLZLZLZROBLZALRLZSTNDLZLTLALRLUAOBNTAETUBARFGBC
    ARFGSSRLZLZUCQRDLSDLZLZDLZDLZLZUDRUHLZUIUFUHLZUJUHDLUGLUKUFDDHUHDUFIGRUEUHH
    GPQUHJGUGNLUDLUIUDLRDSDNEUGNUDOKGGSRMGG $.

  $( ~ tbw-ax1 rederived from ~ merco1 .

     This theorem, along with ~ retbwax2 , ~ retbwax3 , and ~ retbwax4 , shows
     that ~ merco1 with ~ ax-mp can be used as a complete axiomatization of
     propositional calculus.  (Contributed by Anthony Hart, 18-Sep-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  retbwax1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( wi merco1lem18 merco1lem16 ax-mp merco1lem15 merco1lem14 wfal merco1lem10
    merco1 merco1lem9 merco1lem13 ) BCDZABDZACDZDZDZPOQDZDZBQDRDSBACEBACRFGOSUA
    DZDZUBSRDUBDZUCRUBDZUDRUADUEPQOHRUASHGRSUAEGORUBIGUCUBDZJDZUADZUFUGTDZUHUFQ
    DZTDZUIOUBQITADZUGJDZDZQDUJDZUKUIDQADZUGDZUMDUNDZUOUMJDULJDDUGDUQDURUGJJUPU
    LKUMJULUGUQLGQAUFUMUNLGTAUGQUJLGGUGTPHGUHUBDUFDZUFDZUHUFDUSUTDUTUFJUAUSSKUS
    UFMGUHUBUCUFNGGGG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Derive the Tarski-Bernays-Wajsberg axioms from Meredith's Second CO Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A single axiom for propositional calculus offered by Meredith.

     This axiom has 19 symbols, sans auxiliaries.  See notes in ~ merco1 .
     (Contributed by Anthony Hart, 7-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  merco2 $p |- ( ( ( ph -> ps ) -> ( ( F. -> ch ) -> th ) ) -> ( ( th
         -> ph ) -> ( ta -> ( et -> ph ) ) ) ) $=
    ( wi wfal falim pm2.04 mpi jarl idd jad looinv 3syl a1dd a1i com4l ) FABGZH
    CGZDGGZDAGZEAUBUCEAGGGFUBUCAEUBTDGZADGDGUCAGUBUAUDCITUADJKUDADDABDLUDDMNADO
    PQRS $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem1 $p |- ( ( ( ph -> ps ) -> ch ) -> ( ps -> ( th -> ch ) ) ) $=
    ( wi wfal merco2 ax-mp ) AAEZFAEZAEEIAIEEEZABEZCEZBDCEZEZEZAAAAAAGZKKPEZQCA
    EZJLEZEZPEZKREZCAALBDGPTEJUAEEZUBUCETOEJPEEZUDOJFEZEFBETEEUEBNAFJAGOUFBTJMG
    HTOAPJSGHPTAUAKKGHHHH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem2 $p |- ( ( ( ph -> ps ) -> ph ) -> ( ch -> ( th -> ph ) ) ) $=
    ( wi wfal merco2 ax-mp ) AAEZFAEZAEEIAIEEEZABEZAEZCDAEEZEZAAAAAAGZKKOEZPIJL
    EZEZOEZKQEZAAALCDGOREJSEEZTUAERNEJOEEZUBNLEJREEZUCLJFEZEJNEEUDABAFCDGLUEANJ
    JGHNLARJMGHRNAOJIGHORASKKGHHHH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem3 $p |- ( ( ps -> ch ) -> ( ps -> ( ph -> ch ) ) ) $=
    ( wi wfal merco2 mercolem2 ax-mp ) AADZEADZADDIAIDDDZBCDZBACDZDZDZAAAAAAFZK
    KODZPCADZJBDZDZODZKQDZCAABBAFOSDJTDDZUAUBDSNDJODDZUCNBDJSDDUDBMJJGNBASJLFHS
    NAOJRFHOSATKKFHHHH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem4 $p |- ( ( th -> ( et -> ph ) ) -> ( ( ( th -> ch )
  -> ph ) -> ( ta -> ( et -> ph ) ) ) ) $=
    ( wi wfal merco2 mercolem1 ax-mp mercolem3 ) AAFZGAFZAFFLALFFFZCEAFZFZCBFZA
    FZDOFFZFZAAAAAAHZNNTFZUAOAFZMCFFZTFZNUBFZOAACRDHTCFZMUDFFZUEUFFUGUDFZUHQMTF
    FZUIMQFZTFZUJLUKFSFULAAAQDEHLUKSPIJMQTMIJCBATUCMHJMUGUDKJTCAUDNNHJJJJ $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem5 $p |- ( th -> ( ( th -> ph ) -> ( ta -> ( ch -> ph ) ) ) ) $=
    ( wi wfal merco2 mercolem1 ax-mp mercolem2 ) AAEZFAEZAEEKAKEEEZCCAEDBAEEEZE
    ZAAAAAAGZMMOEZPLCEZOEZMQEZKRENESAAACDBGKRNCHIOCELREESTECNLLJOCARMMGIIII $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem6 $p |- ( ( ph -> ( ps -> ( ph -> ch ) ) )
  -> ( ps -> ( ph -> ch ) ) ) $=
    ( wi wfal merco2 mercolem1 ax-mp mercolem5 mercolem4 ) AADZEADADDKAKDDDZABA
    CDZDZDZNDZAAAAAAFZLLPDZQLLRDZQORDZLSDZLTQMRDZLTDZAODZMDPDUBAOMBGUDMPLGHATDU
    BUCDNOALIRCALOJHHHLTUADZQPUADZLUEDZALDZPDSDUFALPLGUHPSLGHOUEDUFUGDRLOLIUANO
    LTJHHHHHHH $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem7 $p |- ( ( ph -> ps ) -> ( ( ( ph -> ch )
  -> ( th -> ps ) ) -> ( th -> ps ) ) ) $=
    ( wi wfal merco2 mercolem3 mercolem6 ax-mp mercolem5 mercolem4 ) AAEZFAEAEE
    MAMEEEZABEZACEZDBEZEZQEZEZAAAAAAGPSEZNTEZRUAEUARPQHRPQIJATEUAUBEBDARKSCANOL
    JJJ $.

  $( Used to rederive the Tarski-Bernays-Wajsberg axioms from ~ merco2 .
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mercolem8 $p |- ( ( ph -> ps ) -> ( ( ps -> ( ph -> ch ) )
  -> ( ta -> ( th -> ( ph -> ch ) ) ) ) ) $=
    ( wi wfal merco2 mercolem3 ax-mp mercolem7 ) AAFZGAFZAFFLALFFFZABFZBACFZFED
    PFFFZFZAAAAAAHZNNRFZSPMBFZFUAFZRFZNTFZUBQFUCPUAABEDHOUBQIJRMUBFZFUEFZUCUDFO
    UBFUFABCMKOUBQMKJRUEAUBNNHJJJJ $.

  $( ~ tbw-ax1 rederived from ~ merco2 .  (Contributed by Anthony Hart,
     16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1tbw1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( wi mercolem8 mercolem3 mercolem6 mpsyl ax-mp ) BCDZABDZJACDZDZDZDNKBLDZND
    DJONABCJKEABCFKOMGHJKLGI $.

  $( ~ tbw-ax2 rederived from ~ merco2 .  (Contributed by Anthony Hart,
     16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1tbw2 $p |- ( ph -> ( ps -> ph ) ) $=
    ( wi mercolem1 ax-mp mercolem6 ) BABACZCZCZHAICZIAACZACHCJAAABDKAHBDEABGFEB
    AAFE $.

  $( ~ tbw-ax3 rederived from ~ merco2 .  (Contributed by Anthony Hart,
     16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1tbw3 $p |- ( ( ( ph -> ps ) -> ph ) -> ph ) $=
    ( wi mercolem2 mercolem6 ax-mp ) AACZACAGCCZABCACZACZAAAADIHJCZCKABHIDIHAEF
    F $.

  $( ~ tbw-ax4 rederived from ~ merco2 .

     This theorem, along with ~ re1tbw1 , ~ re1tbw2 , and ~ re1tbw3 , shows
     that ~ merco2 , along with ~ ax-mp , can be used as a complete
     axiomatization of propositional calculus.  (Contributed by Anthony Hart,
     16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re1tbw4 $p |- ( F. -> ph ) $=
    ( wi wfal re1tbw3 re1tbw2 re1tbw1 ax-mp mercolem3 merco2 ) AABZCABZJABZABZJ
    AADALBMJBAJEALAFGGZJJKBZNKKBZJOBZKABZKBZKBZPKADKSBTPBKREKSKFGGRPBPQBCKAHKAA
    KJJIGGGG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Derive the Lukasiewicz axioms from the The Russell-Bernays Axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Justification for ~ rb-imdf .  (Contributed by Anthony Hart,
     17-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  rb-bijust $p |- ( ( ph <-> ps ) <-> -. ( -. ( -. ph \/ ps )
    \/ -. ( -. ps \/ ph ) ) ) $=
    ( wb wi wn wo dfbi1 imor notbii imbi12i pm4.62 3bitri ) ABCABDZBADZEZDZEAEB
    FZBEAFZEZDZEQESFZEABGPTMQOSABHNRBAHIJITUAQRKIL $.

  $( The definition of implication, in terms of ` \/ ` and ` -. ` .
     (Contributed by Anthony Hart, 17-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rb-imdf $p |- -. ( -. ( -. ( ph -> ps ) \/ ( -. ph \/ ps ) )
    \/ -. ( -. ( -. ph \/ ps ) \/ ( ph -> ps ) ) ) $=
    ( wi wn wo wb imor rb-bijust mpbi ) ABCZADBEZFJDKEDKDJEDEDABGJKHI $.

  ${
    anmp.min $e |- ph $.
    anmp.maj $e |- ( -. ph \/ ps ) $.
    $( Modus ponens for ` \/ ` ` -. ` axiom systems.  (Contributed by Anthony
       Hart, 12-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    anmp $p |- ps $=
      ( imorri ax-mp ) ABCABDEF $.
  $}

  $( The first of four axioms in the Russell-Bernays axiom system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rb-ax1 $p |- ( -. ( -. ps \/ ch ) \/ ( -. ( ph \/ ps ) \/ ( ph \/ ch ) ) ) $=
    ( wn wo wi orim2 imor 3imtr3i imori ) BDCEZABEZDACEZEZBCFLMFKNABCGBCHLMHIJ
    $.

  $( The second of four axioms in the Russell-Bernays axiom system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rb-ax2 $p |- ( -. ( ph \/ ps ) \/ ( ps \/ ph ) ) $=
    ( wo wn pm1.4 con3i con1i orri ) ABCZDZBACZKJIKABEFGH $.

  $( The third of four axioms in the Russell-Bernays axiom system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rb-ax3 $p |- ( -. ph \/ ( ps \/ ph ) ) $=
    ( wn wo pm2.46 con1i orri ) ACZBADZIHBAEFG $.

  $( The fourth of four axioms in the Russell-Bernays axiom system.
     (Contributed by Anthony Hart, 13-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rb-ax4 $p |- ( -. ( ph \/ ph ) \/ ph ) $=
    ( wo wn pm1.2 con3i con1i orri ) AABZCZAAIHAADEFG $.

  ${
    rbsyl.1 $e |- ( -. ps \/ ch ) $.
    rbsyl.2 $e |- ( ph \/ ps ) $.
    $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
       (Contributed by Anthony Hart, 18-Aug-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    rbsyl $p |- ( ph \/ ch ) $=
      ( wo wn rb-ax1 anmp ) ABFZACFZEBGCFJGKFDABCHII $.
  $}

  ${
    rblem1.1 $e |- ( -. ph \/ ps ) $.
    rblem1.2 $e |- ( -. ch \/ th ) $.
    $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
       (Contributed by Anthony Hart, 18-Aug-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    rblem1 $p |- ( -. ( ph \/ ch ) \/ ( ps \/ th ) ) $=
      ( wo wn rb-ax1 anmp rb-ax2 rbsyl ) ACGHZBCGZBDGZCHDGNHOGFBCDIJMCBGZNCBKMC
      AGZPAHBGQHPGECABIJACKLLL $.
  $}

  $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
     (Contributed by Anthony Hart, 18-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rblem2 $p |- ( -. ( ch \/ ph ) \/ ( ch \/ ( ph \/ ps ) ) ) $=
    ( wn wo rb-ax2 rb-ax3 rbsyl rb-ax1 anmp ) ADZABEZECAEDCLEEKBAELBAFABGHCALIJ
    $.

  $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
     (Contributed by Anthony Hart, 18-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rblem3 $p |- ( -. ( ch \/ ph ) \/ ( ( ch \/ ps ) \/ ph ) ) $=
    ( wo wn rb-ax2 rblem2 rbsyl ) CADEZACBDZDZJADAJFIACDKCBAGCAFHH $.

  ${
    rblem4.1 $e |- ( -. ph \/ th ) $.
    rblem4.2 $e |- ( -. ps \/ ta ) $.
    rblem4.3 $e |- ( -. ch \/ et ) $.
    $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
       (Contributed by Anthony Hart, 18-Aug-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    rblem4 $p |- ( -. ( ( ph \/ ps ) \/ ch ) \/ ( ( et \/ ta ) \/ th ) ) $=
      ( wo wn rblem1 rb-ax2 rb-ax1 anmp rbsyl rb-ax4 rblem2 rb-ax3 ) ABJZCJKZCB
      JZAJZFEJZDJUBUDADCFBEIHLGLUABCJZAJZUCUFKZAUBJZUCAUBMUGAUEJZUHUEKUBJUIKUHJ
      BCMAUEUBNOUEAMPPUAUFUFJUFUFQTUFCUFTKUIUFAUEMBCARPCKZUEJUJUFJCBSUEAUJROLPP
      P $.
  $}

  $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
     (Contributed by Anthony Hart, 19-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  rblem5 $p |- ( -. ( -. -. ph \/ ps ) \/ ( -. -. ps \/ ph ) ) $=
    ( wn wo rb-ax2 rb-ax4 rb-ax3 rbsyl anmp rblem1 ) ACZCZBDCABCZCZDNADANELABNK
    ADLCZADKAADAAFAAGHZKOAAOLDLODOLLDLLFLLGHOLEIPJINMDMNDNMMDMMFMMGHNMEIJH $.

  ${
    rblem6.1 $e |- -. ( -. ( -. ph \/ ps ) \/ -. ( -. ps \/ ph ) ) $.
    $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
       (Contributed by Anthony Hart, 19-Aug-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    rblem6 $p |- ( -. ph \/ ps ) $=
      ( wn wo rb-ax4 rb-ax3 rbsyl rb-ax2 anmp rblem3 rblem5 ) ADBEZDZBDAEDZEZDZ
      MCNDZPEZQDMEPREZSNREZTRNEUARNNENNFNNGHRNIJRONKJPRIJMPLJJ $.
  $}

  ${
    rblem7.1 $e |- -. ( -. ( -. ph \/ ps ) \/ -. ( -. ps \/ ph ) ) $.
    $( Used to rederive the Lukasiewicz axioms from Russell-Bernays'.
       (Contributed by Anthony Hart, 19-Aug-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    rblem7 $p |- ( -. ps \/ ph ) $=
      ( wn wo rb-ax3 rblem5 anmp ) ADBEDZBDAEZDZEZDZJCKDLEMDJEKIFJLGHH $.
  $}

  ${
    re1axmp.min $e |- ph $.
    re1axmp.maj $e |- ( ph -> ps ) $.
    $( ~ ax-mp derived from Russell-Bernays'.  (Contributed by Anthony Hart,
       19-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    re1axmp $p |- ps $=
      ( wi wn wo rb-imdf rblem6 anmp ) ABCABEZAFBGZDKLABHIJJ $.
  $}

  $( ~ luk-1 derived from Russell-Bernays'.  (Contributed by Anthony Hart,
     19-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re2luk1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( wi wn rb-imdf rblem7 rblem6 rb-ax2 rb-ax4 rb-ax3 rbsyl anmp rblem1 rb-ax1
    wo rblem4 ) ABDZEZBCDZACDZDZPZRUBDZSTEZUAPZUBUBUFTUAFGSAEZBPZUFUHEZBECPZEZU
    GCPZPZUFUKUEULUAUEUJPZUKEZUEPZTUJBCFHUNEUEUOPUPUEUOIUEUEUJUOUEEUEUEPUEUEJUE
    UEKLUOUKPUKUOPUOUKUKPUKUKJUKUKKLZUOUKIMNLMUAULACFGNUKUIULPZPZUIUMPZUGBCOUSE
    ZUMUIPZUTUMUIIVAURUKPVBUIULUKUIULUKUIEUIUIPUIUIJUIUIKLULEULULPULULJULULKLUQ
    QUKURILLMLRUHABFHLLUDUCRUBFGM $.

  $( ~ luk-2 derived from Russell-Bernays'.  (Contributed by Anthony Hart,
     19-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re2luk2 $p |- ( ( -. ph -> ph ) -> ph ) $=
    ( wn wi wo rb-ax4 rb-ax3 rbsyl rb-ax2 anmp rblem1 rb-imdf rblem6 rblem7 ) A
    BZACZBZADZOACZPNBZADZATBAADZAAEZSAAANADSBZADNUAAUBAAFGZNUCAAUCSDSUCDUCSSDSS
    ESSFGUCSHIUDJIUDJGOTNAKLGRQOAKMI $.

  $( ~ luk-3 derived from Russell-Bernays'.

     This theorem, along with ~ re1axmp , ~ re2luk1 , and ~ re2luk2 shows that
     ~ rb-ax1 , ~ rb-ax2 , ~ rb-ax3 , and ~ rb-ax4 , along with ~ anmp , can be
     used as a complete axiomatization of propositional calculus.  (Contributed
     by Anthony Hart, 19-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  re2luk3 $p |- ( ph -> ( -. ph -> ps ) ) $=
    ( wn wi wo rb-imdf rblem7 rb-ax4 rb-ax3 rbsyl rb-ax2 anmp rblem2 ) ACZNBDZE
    ZAODZNNCZBEZOOSNBFGNREZNSERNETRNNENNHNNIJRNKLRBNMLJQPAOFGL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Stoic logic indemonstrables (Chrysippus of Soli)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  The Greek Stoics developed a system of logic.
  The Stoic Chrysippus, in particular, was often considered one of the greatest
  logicians of antiquity.
  Stoic logic is different from Aristotle's system, since it focuses
  on propositional logic,
  though later thinkers did combine the systems of the Stoics with Aristotle.
  Jan Lukasiewicz reports,
  "For anybody familiar with mathematical logic it is self-evident
  that the Stoic dialectic is the ancient form of modern propositional logic"
  ( _On the history of the logic of proposition_ by Jan Lukasiewicz (1934),
  translated in: _Selected Works_ - Edited by Ludwik Borkowski -
  Amsterdam, North-Holland, 1970 pp. 197-217,
  referenced in "History of Logic"
  ~ https://www.historyoflogic.com/logic-stoics.htm ).
  For more about Aristotle's system, see ~ barbara and related theorems.

  A key part of the Stoic logic system is a set of five "indemonstrables"
  assigned to Chrysippus of Soli by Diogenes Laertius, though in
  general it is difficult to assign specific
  ideas to specific thinkers.
  The indemonstrables are described in, for example,
  [Lopez-Astorga] p. 11 , [Sanford] p. 39, and [Hitchcock] p. 5.
  These indemonstrables are
  modus ponendo ponens (modus ponens) ~ ax-mp ,
  modus tollendo tollens (modus tollens) ~ mto ,
  modus ponendo tollens I ~ mpto1 ,
  modus ponendo tollens II ~ mpto2 , and
  modus tollendo ponens (exclusive-or version) ~ mtp-xor .
  The first is an axiom, the second is already proved; in this section
  we prove the other three.
  Since we assume or prove all of indemonstrables, the system of logic we use
  here is as at least as strong as the set of Stoic indemonstrables.
  Note that modus tollendo ponens ~ mtp-xor originally used exclusive-or,
  but over time the name modus tollendo ponens has increasingly referred
  to an inclusive-or variation, which is proved in ~ mtp-or .
  This set of indemonstrables is not the entire system of Stoic logic.

$)

  ${
    $( Minor premise for modus ponendo tollens 1. $)
    mpto1.1 $e |- ph $.
    $( Major premise for modus ponendo tollens 1. $)
    mpto1.2 $e |- -. ( ph /\ ps ) $.
    $( Modus ponendo tollens 1, one of the "indemonstrables" in Stoic logic.
       See rule 1 on [Lopez-Astorga] p. 12 , rule 1 on [Sanford] p. 40, and
       rule A3 in [Hitchcock] p. 5.  Sanford describes this rule second (after
       ~ mpto2 ) as a "safer, and these days much more common" version of modus
       ponendo tollens because it avoids confusion between inclusive-or and
       exclusive-or.  (Contributed by David A. Wheeler, 3-Jul-2016.) $)
    mpto1 $p |- -. ps $=
      ( wn imnani ax-mp ) ABECABDFG $.
  $}

  ${
    $( Minor premise for modus ponendo tollens 2. $)
    mpto2.1 $e |- ph $.
    $( Major premise for modus ponendo tollens 2. $)
    mpto2.2 $e |- ( ph \/_ ps ) $.
    $( Modus ponendo tollens 2, one of the "indemonstrables" in Stoic logic.
       Note that this uses exclusive-or ` \/_ ` .  See rule 2 on
       [Lopez-Astorga] p. 12 , rule 4 on [Sanford] p. 39 and rule A4 in
       [Hitchcock] p. 5 .  (Contributed by David A. Wheeler, 3-Jul-2016.)
       (Proof shortened by Wolf Lammen, 12-Nov-2017.) $)
    mpto2 $p |- -. ps $=
      ( wn wb wxo df-xor mpbi xor3 ) ABEZCABFEZAKFABGLDABHIABJII $.
  $}

  ${
    $( Minor premise for modus ponendo tollens 2. $)
    mpto2OLD.1 $e |- ph $.
    $( Major premise for modus ponendo tollens 2. $)
    mpto2OLD.2 $e |- ( ph \/_ ps ) $.
    $( Obsolete version of ~ mpto2 as of 12-Nov-2017.  (Contributed by David A.
       Wheeler, 3-Jul-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    mpto2OLD $p |- -. ps $=
      ( wn wb wxo df-xor mpbi nbbn mpbir con1bii ) BEACABAEBFABFEZABGMDABHIABJK
      LK $.
  $}


  ${
    $( Minor premise for modus tollendo ponens (original exclusive-or version).
    $)
    mtp-xor.1 $e |- -. ph $.
    $( Major premise for modus tollendo ponens (original exclusive-or version).
    $)
    mtp-xor.2 $e |- ( ph \/_ ps ) $.
    $( Modus tollendo ponens (original exclusive-or version), aka disjunctive
       syllogism, one of the five "indemonstrables" in Stoic logic.  The rule
       says, "if ` ph ` is not true, and either ` ph ` or ` ps ` (exclusively)
       are true, then ` ps ` must be true."  Today the name "modus tollendo
       ponens" often refers to a variant, the inclusive-or version as defined
       in ~ mtp-or .  See rule 3 on [Lopez-Astorga] p. 12 (note that the "or"
       is the same as ~ mpto2 , that is, it is exclusive-or ~ df-xor ), rule 3
       of [Sanford] p. 39 (where it is not as clearly stated which kind of "or"
       is used but it appears to be in the same sense as ~ mpto2 ), and rule A5
       in [Hitchcock] p. 5 (exclusive-or is expressly used).  (Contributed by
       David A. Wheeler, 4-Jul-2016.)  (Proof shortened by Wolf Lammen,
       11-Nov-2017.) $)
    mtp-xor $p |- ps $=
      ( wn wxo xorneg mpbir mpto2 notnotri ) BAEZBEZCKLFABFDABGHIJ $.

    $( Obsolete version of ~ mtp-xor as of 11-Nov-2017.  (Contributed by David
       A. Wheeler, 4-Jul-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    mtp-xorOLD $p |- ps $=
      ( wn wb wxo df-xor mpbi bicom mtbi xor3 mpbir ) BAEZCBAFZEBNFABFZOABGPEDA
      BHIABJKBALIM $.
  $}

  ${
    $( Minor premise for modus tollendo ponens (inclusive-or version). $)
    mtp-or.1 $e |- -. ph $.
    $( Major premise for modus tollendo ponens (inclusive-or version). $)
    mtp-or.2 $e |- ( ph \/ ps ) $.
    $( Modus tollendo ponens (inclusive-or version), aka disjunctive
       syllogism.  This is similar to ~ mtp-xor , one of the five original
       "indemonstrables" in Stoic logic.  However, in Stoic logic this rule
       used exclusive-or, while the name modus tollendo ponens often refers to
       a variant of the rule that uses inclusive-or instead.  The rule says,
       "if ` ph ` is not true, and ` ph ` or ` ps ` (or both) are true, then
       ` ps ` must be true."  An alternative phrasing is, "Once you eliminate
       the impossible, whatever remains, no matter how improbable, must be the
       truth." -- Sherlock Holmes (Sir Arthur Conan Doyle, 1890:  The Sign of
       the Four, ch. 6).  (Contributed by David A. Wheeler, 3-Jul-2016.)
       (Proof shortened by Wolf Lammen, 11-Nov-2017.) $)
    mtp-or $p |- ps $=
      ( wn ori ax-mp ) AEBCABDFG $.

    $( Obsolete version of ~ mtp-or as of 11-Nov-2017.  (Contributed by David
       A. Wheeler, 3-Jul-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    mtp-orOLD $p |- ps $=
      ( wn wo wi pm2.53 ax-mp ) AEZBCABFJBGDABHII $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
    Predicate calculus with equality:  Tarski's system S2 (1 rule, 6 schemes)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  Here we extend the language of wffs with predicate calculus, which allows us
  to talk about individual objects in a domain of discussion (which for us will
  be the universe of all sets, so we call them "set variables") and make
  true/false statements about predicates, which are relationships between
  objects, such as whether or not two objects are equal.  In addition, we
  introduce universal quantification ("for all") in order to make statements
  about whether a wff holds for every object in the domain of discussion.
  Later we introduce existential quantification ("there exists", ~ df-ex )
  which is defined in terms of universal quantification.

  Our axioms are really axiom _schemes_, and our wff and set variables are
  metavariables ranging over expressions in an underlying "object language."
  This is explained here:  ~ http://us.metamath.org/mpeuni/mmset.html#axiomnote

  Our axiom system starts with the predicate calculus axiom schemes system S2
  of Tarski defined in his 1965 paper, "A Simplified Formalization of Predicate
  Logic with Identity" [Tarski].  System S2 is defined in the last paragraph on
  p. 77, and repeated on p. 81 of [KalishMontague].  We do not include scheme
  B5 (our ~ sp ) since [KalishMontague] shows it to be logically redundant
  (Lemma 9, p. 87, which we prove as theorem ~ spw below).

  Theorem ~ spw can be used to prove any instance of ~ sp having no wff
  metavariables and mutually distinct set variables.  However, it seems that
  ~ sp in its general form cannot be derived from only Tarski's schemes.  We
  do not include B5 i.e.  ~ sp as part of what we call "Tarski's system"
  because we want it to be the smallest set of axioms that is logically
  complete with no redundancies.  We later prove ~ sp as theorem ~ ax4
  using the auxiliary axioms that make our system metalogically complete.

  Our version of Tarski's system S2 consists of propositional calculus plus
  ~ ax-gen , ~ ax-5 , ~ ax-17 , ~ ax-9 , ~ ax-8 , ~ ax-13 , and ~ ax-14 . The
  last 3 are equality axioms that represent 3 sub-schemes of Tarski's scheme
  B8.  Due to its side-condition ("where ` ph ` is an atomic formula and ` ps `
  is obtained by replacing an occurrence of the variable ` x ` by the variable
  ` y ` "), we cannot represent his B8 directly without greatly complicating
  our scheme language, but the simpler schemes ~ ax-8 , ~ ax-13 , and ~ ax-14
  are sufficient for set theory.

  Tarski's system is exactly equivalent to the traditional axiom system in most
  logic textbooks but has the advantage of being easy to manipulate with a
  computer program, and its simpler metalogic (with no built-in notions of free
  variable and proper substitution) is arguably easier for a non-logician human
  to follow step by step in a proof.

  However, in our system that derives schemes (rather than object language
  theorems) from other schemes, Tarski's S2 is not complete.  For example, we
  cannot derive scheme ~ sp , even though (using ~ spw ) we can derive all
  instances of it that don't involve wff metavariables or bundled set
  metavariables.  (Two set metavariables are "bundled" if they can be
  substituted with the same set metavariable i.e. do not have a $d distinct
  variable proviso.)  Later we will introduce auxiliary axiom schemes ~ ax-6 ,
  ~ ax-7 , ~ ax-12 , and ~ ax-11 that are metatheorems of Tarski's system (i.e.
  are logically redundant) but which give our system the property of
  "metalogical completeness," allowing us to prove directly (instead of, say,
  by induction on formula length) all possible schemes that can be expressed in
  our language.

$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Universal quantifier; define "exists" and "not free"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols needed for predicate calculus. $)
  $c A. $. $( "inverted A" universal quantifier (read:  "for all") $)
  $c set $. $( Individual variable type (read:  "the following is an
             individual (set) variable" $)

  $( Add 'set' as a typecode. $)
  $( $j syntax 'set'; $)

  $( Declare some names for individual variables. $)
  $v x $.
  $v y $.
  $v z $.
  $v w $.
  $v v $.
  $v u $.
  $v t $.
  $( Let ` x ` be an individual variable. $)
  vx $f set x $.
  $( Let ` y ` be an individual variable. $)
  vy $f set y $.
  $( Let ` z ` be an individual variable. $)
  vz $f set z $.
  $( Let ` w ` be an individual variable. $)
  vw $f set w $.
  $( Let ` v ` be an individual variable. $)
  vv $f set v $.
  $( Let ` u ` be an individual variable. $)
  vu $f set u $.
  $( Let ` t ` be an individual variable. $)
  vt $f set t $.

  $( Extend wff definition to include the universal quantifier ('for all').
     ` A. x ph ` is read " ` ph ` (phi) is true for all ` x ` ."  Typically, in
     its final application ` ph ` would be replaced with a wff containing a
     (free) occurrence of the variable ` x ` , for example ` x = y ` .  In a
     universe with a finite number of objects, "for all" is equivalent to a big
     conjunction (AND) with one wff for each possible case of ` x ` .  When the
     universe is infinite (as with set theory), such a propositional-calculus
     equivalent is not possible because an infinitely long formula has no
     meaning, but conceptually the idea is the same. $)
  wal $a wff A. x ph $.

  $( Register 'A.' as a primitive expression (lacking a definition). $)
  $( $j primitive 'wal'; $)

  $( Declare the existential quantifier symbol. $)
  $c E. $.   $( Backwards E (read:  "there exists") $)

  $( Extend wff definition to include the existential quantifier ("there
     exists"). $)
  wex $a wff E. x ph $.

  $( Define existential quantification. ` E. x ph ` means "there exists at
     least one set ` x ` such that ` ph ` is true."  Definition of [Margaris]
     p. 49.  (Contributed by NM, 5-Aug-1993.) $)
  df-ex $a |- ( E. x ph <-> -. A. x -. ph ) $.

  $( Theorem 19.7 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.) $)
  alnex $p |- ( A. x -. ph <-> -. E. x ph ) $=
    ( wex wn wal df-ex con2bii ) ABCADBEABFG $.

  $c F/ $.  $( The not-free symbol. $)

  $( Extend wff definition to include the not-free predicate. $)
  wnf $a wff F/ x ph $.

  $( Define the not-free predicate for wffs.  This is read " ` x ` is not free
     in ` ph ` ".  Not-free means that the value of ` x ` cannot affect the
     value of ` ph ` , e.g., any occurrence of ` x ` in ` ph ` is effectively
     bound by a "for all" or something that expands to one (such as "there
     exists").  In particular, substitution for a variable not free in a wff
     does not affect its value ( ~ sbf ).  An example of where this is used is
     ~ stdpc5 .  See ~ nf2 for an alternative definition which does not involve
     nested quantifiers on the same variable.

     Not-free is a commonly used constraint, so it is useful to have a notation
     for it.  Surprisingly, there is no common formal notation for it, so here
     we devise one.  Our definition lets us work with the not-free notion
     within the logic itself rather than as a metalogical side condition.

     To be precise, our definition really means "effectively not free," because
     it is slightly less restrictive than the usual textbook definition for
     not-free (which only considers syntactic freedom).  For example, ` x ` is
     effectively not free in the bare expression ` x = x ` (see ~ nfequid ),
     even though ` x ` would be considered free in the usual textbook
     definition, because the value of ` x ` in the expression ` x = x ` cannot
     affect the truth of the expression (and thus substitution will not change
     the result).

     This predicate only applies to wffs.  See ~ df-nfc for a not-free
     predicate for class variables.  (Contributed by Mario Carneiro,
     11-Aug-2016.) $)
  df-nf $a |- ( F/ x ph <-> A. x ( ph -> A. x ph ) ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Rule scheme ax-gen (Generalization)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    ax-g.1 $e |- ph $.
    $( Rule of Generalization.  The postulated inference rule of predicate
       calculus.  See e.g.  Rule 2 of [Hamilton] p. 74.  This rule says that if
       something is unconditionally true, then it is true for all values of a
       variable.  For example, if we have proved ` x = x ` , we can conclude
       ` A. x x = x ` or even ` A. y x = x ` .  Theorem ~ allt shows the
       special case ` A. x T. ` .  Theorem ~ spi shows we can go the other way
       also: in other words we can add or remove universal quantifiers from the
       beginning of any theorem as required.  (Contributed by NM,
       5-Aug-1993.) $)
    ax-gen $a |- A. x ph $.
  $}

  ${
    gen2.1 $e |- ph $.
    $( Generalization applied twice.  (Contributed by NM, 30-Apr-1998.) $)
    gen2 $p |- A. x A. y ph $=
      ( wal ax-gen ) ACEBACDFF $.
  $}

  ${
    mpg.1 $e |- ( A. x ph -> ps ) $.
    mpg.2 $e |- ph $.
    $( Modus ponens combined with generalization.  (Contributed by NM,
       24-May-1994.) $)
    mpg $p |- ps $=
      ( wal ax-gen ax-mp ) ACFBACEGDH $.
  $}

  ${
    mpgbi.1 $e |- ( A. x ph <-> ps ) $.
    mpgbi.2 $e |- ph $.
    $( Modus ponens on biconditional combined with generalization.
       (Contributed by NM, 24-May-1994.)  (Proof shortened by Stefan Allan,
       28-Oct-2008.) $)
    mpgbi $p |- ps $=
      ( wal ax-gen mpbi ) ACFBACEGDH $.
  $}

  ${
    mpgbir.1 $e |- ( ph <-> A. x ps ) $.
    mpgbir.2 $e |- ps $.
    $( Modus ponens on biconditional combined with generalization.
       (Contributed by NM, 24-May-1994.)  (Proof shortened by Stefan Allan,
       28-Oct-2008.) $)
    mpgbir $p |- ph $=
      ( wal ax-gen mpbir ) ABCFBCEGDH $.
  $}

  ${
    nfi.1 $e |- ( ph -> A. x ph ) $.
    $( Deduce that ` x ` is not free in ` ph ` from the definition.
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfi $p |- F/ x ph $=
      ( wnf wal wi df-nf mpgbir ) ABDAABEFBABGCH $.
  $}

  ${
    hbth.1 $e |- ph $.
    $( No variable is (effectively) free in a theorem.

       This and later "hypothesis-building" lemmas, with labels starting
       "hb...", allow us to construct proofs of formulas of the form
       ` |- ( ph -> A. x ph ) ` from smaller formulas of this form.  These are
       useful for constructing hypotheses that state " ` x ` is (effectively)
       not free in ` ph ` ."  (Contributed by NM, 5-Aug-1993.) $)
    hbth $p |- ( ph -> A. x ph ) $=
      ( wal ax-gen a1i ) ABDAABCEF $.

    $( No variable is (effectively) free in a theorem.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    nfth $p |- F/ x ph $=
      ( hbth nfi ) ABABCDE $.
  $}

  $( The true constant has no free variables.  (This can also be proven in one
     step with ~ nfv , but this proof does not use ~ ax-17 .)  (Contributed by
     Mario Carneiro, 6-Oct-2016.) $)
  nftru $p |- F/ x T. $=
    ( wtru tru nfth ) BACD $.

  ${
    nex.1 $e |- -. ph $.
    $( Generalization rule for negated wff.  (Contributed by NM,
       18-May-1994.) $)
    nex $p |- -. E. x ph $=
      ( wn wex alnex mpgbi ) ADABEDBABFCG $.
  $}

  ${
    nfnth.1 $e |- -. ph $.
    $( No variable is (effectively) free in a non-theorem.  (Contributed by
       Mario Carneiro, 6-Dec-2016.) $)
    nfnth $p |- F/ x ph $=
      ( wal pm2.21i nfi ) ABAABDCEF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Axiom scheme ax-5 (Quantified Implication)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Quantified Implication.  Axiom C4 of [Monk2] p. 105.
     (Contributed by NM, 5-Aug-1993.) $)
  ax-5 $a |- ( A. x ( ph -> ps ) -> ( A. x ph -> A. x ps ) ) $.

  $( Theorem 19.20 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by O'Cat, 30-Mar-2008.) $)
  alim $p |- ( A. x ( ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    ( ax-5 ) ABCD $.

  ${
    alimi.1 $e |- ( ph -> ps ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 5-Aug-1993.) $)
    alimi $p |- ( A. x ph -> A. x ps ) $=
      ( wi wal ax-5 mpg ) ABEACFBCFECABCGDH $.

    $( Inference doubly quantifying both antecedent and consequent.
       (Contributed by NM, 3-Feb-2005.) $)
    2alimi $p |- ( A. x A. y ph -> A. x A. y ps ) $=
      ( wal alimi ) ADFBDFCABDEGG $.
  $}

  ${
    al2imi.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference quantifying antecedent, nested antecedent, and consequent.
       (Contributed by NM, 5-Aug-1993.) $)
    al2imi $p |- ( A. x ph -> ( A. x ps -> A. x ch ) ) $=
      ( wal wi alimi alim syl ) ADFBCGZDFBDFCDFGAKDEHBCDIJ $.
  $}

  ${
    alanimi.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Variant of ~ al2imi with conjunctive antecedent.  (Contributed by Andrew
       Salmon, 8-Jun-2011.) $)
    alanimi $p |- ( ( A. x ph /\ A. x ps ) -> A. x ch ) $=
      ( wal ex al2imi imp ) ADFBDFCDFABCDABCEGHI $.
  $}

  ${
    alimdh.1 $e |- ( ph -> A. x ph ) $.
    alimdh.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.20 of [Margaris] p. 90.  (Contributed by NM,
       4-Jan-2002.) $)
    alimdh $p |- ( ph -> ( A. x ps -> A. x ch ) ) $=
      ( wal wi al2imi syl ) AADGBDGCDGHEABCDFIJ $.
  $}

  $( Theorem 19.15 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  albi $p |- ( A. x ( ph <-> ps ) -> ( A. x ph <-> A. x ps ) ) $=
    ( wb wal bi1 al2imi bi2 impbid ) ABDZCEACEBCEJABCABFGJBACABHGI $.

  ${
    alrimih.1 $e |- ( ph -> A. x ph ) $.
    alrimih.2 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    alrimih $p |- ( ph -> A. x ps ) $=
      ( wal alimi syl ) AACFBCFDABCEGH $.
  $}

  ${
    albii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding universal quantifier to both sides of an equivalence.
       (Contributed by NM, 7-Aug-1994.) $)
    albii $p |- ( A. x ph <-> A. x ps ) $=
      ( wb wal albi mpg ) ABEACFBCFECABCGDH $.

    $( Theorem albii is the congruence law for universal quantification. $)
    $( $j congruence 'albii'; $)

    $( Inference adding two universal quantifiers to both sides of an
       equivalence.  (Contributed by NM, 9-Mar-1997.) $)
    2albii $p |- ( A. x A. y ph <-> A. x A. y ps ) $=
      ( wal albii ) ADFBDFCABDEGG $.
  $}

  ${
    hbxfrbi.1 $e |- ( ph <-> ps ) $.
    hbxfrbi.2 $e |- ( ps -> A. x ps ) $.
    $( A utility lemma to transfer a bound-variable hypothesis builder into a
       definition.  See ~ hbxfreq for equality version.  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.) $)
    hbxfrbi $p |- ( ph -> A. x ph ) $=
      ( wal albii 3imtr4i ) BBCFAACFEDABCDGH $.
  $}

  ${
    nfbii.1 $e |- ( ph <-> ps ) $.
    $( Equality theorem for not-free.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfbii $p |- ( F/ x ph <-> F/ x ps ) $=
      ( wal wi wnf albii imbi12i df-nf 3bitr4i ) AACEZFZCEBBCEZFZCEACGBCGMOCABL
      NDABCDHIHACJBCJK $.

    ${
      nfxfr.2 $e |- F/ x ps $.
      $( A utility lemma to transfer a bound-variable hypothesis builder into a
         definition.  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
      nfxfr $p |- F/ x ph $=
        ( wnf nfbii mpbir ) ACFBCFEABCDGH $.
    $}

    ${
      nfxfrd.2 $e |- ( ch -> F/ x ps ) $.
      $( A utility lemma to transfer a bound-variable hypothesis builder into a
         definition.  (Contributed by Mario Carneiro, 24-Sep-2016.) $)
      nfxfrd $p |- ( ch -> F/ x ph ) $=
        ( wnf nfbii sylibr ) CBDGADGFABDEHI $.
    $}
  $}

  $( Theorem 19.6 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.) $)
  alex $p |- ( A. x ph <-> -. E. x -. ph ) $=
    ( wal wn wex notnot albii alnex bitri ) ABCADZDZBCJBEDAKBAFGJBHI $.

  $( Part of theorem *11.5 in [WhiteheadRussell] p. 164.  (Contributed by
     Andrew Salmon, 24-May-2011.) $)
  2nalexn $p |- ( -. A. x A. y ph <-> E. x E. y -. ph ) $=
    ( wn wex wal df-ex alex albii xchbinxr bicomi ) ADCEZBEZACFZBFZDMLDZBFOLBGN
    PBACHIJK $.

  $( Theorem 19.14 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  exnal $p |- ( E. x -. ph <-> -. A. x ph ) $=
    ( wal wn wex alex con2bii ) ABCADBEABFG $.

  $( Theorem 19.22 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Wolf Lammen, 4-Jul-2014.) $)
  exim $p |- ( A. x ( ph -> ps ) -> ( E. x ph -> E. x ps ) ) $=
    ( wi wal wex wn con3 al2imi alnex 3imtr3g con4d ) ABDZCEZBCFZACFZNBGZCEAGZC
    EOGPGMQRCABHIBCJACJKL $.

  ${
    eximi.1 $e |- ( ph -> ps ) $.
    $( Inference adding existential quantifier to antecedent and consequent.
       (Contributed by NM, 5-Aug-1993.) $)
    eximi $p |- ( E. x ph -> E. x ps ) $=
      ( wi wex exim mpg ) ABEACFBCFECABCGDH $.

    $( Inference adding two existential quantifiers to antecedent and
       consequent.  (Contributed by NM, 3-Feb-2005.) $)
    2eximi $p |- ( E. x E. y ph -> E. x E. y ps ) $=
      ( wex eximi ) ADFBDFCABDEGG $.
  $}

  ${
    eximii.1 $e |- E. x ph $.
    eximii.2 $e |- ( ph -> ps ) $.
    $( Inference associated with ~ eximi .  (Contributed by BJ, 3-Feb-2018.) $)
    eximii $p |- E. x ps $=
      ( wex eximi ax-mp ) ACFBCFDABCEGH $.
  $}

  $( A transformation of quantifiers and logical connectives.  (Contributed by
     NM, 19-Aug-1993.) $)
  alinexa $p |- ( A. x ( ph -> -. ps ) <-> -. E. x ( ph /\ ps ) ) $=
    ( wn wi wal wa wex imnan albii alnex bitri ) ABDEZCFABGZDZCFNCHDMOCABIJNCKL
    $.

  $( A relationship between two quantifiers and negation.  (Contributed by NM,
     18-Aug-1993.) $)
  alexn $p |- ( A. x E. y -. ph <-> -. E. x A. y ph ) $=
    ( wn wex wal exnal albii alnex bitri ) ADCEZBFACFZDZBFLBEDKMBACGHLBIJ $.

  $( Theorem *11.51 in [WhiteheadRussell] p. 164.  (Contributed by Andrew
     Salmon, 24-May-2011.)  (Proof shortened by Wolf Lammen, 25-Sep-2014.) $)
  2exnexn $p |- ( E. x A. y ph <-> -. A. x E. y -. ph ) $=
    ( wn wex wal alexn con2bii ) ADCEBFACFBEABCGH $.

  $( Theorem 19.18 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  exbi $p |- ( A. x ( ph <-> ps ) -> ( E. x ph <-> E. x ps ) ) $=
    ( wb wal wex wi bi1 alimi exim syl bi2 impbid ) ABDZCEZACFZBCFZOABGZCEPQGNR
    CABHIABCJKOBAGZCEQPGNSCABLIBACJKM $.

  ${
    exbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding existential quantifier to both sides of an
       equivalence.  (Contributed by NM, 24-May-1994.) $)
    exbii $p |- ( E. x ph <-> E. x ps ) $=
      ( wb wex exbi mpg ) ABEACFBCFECABCGDH $.
  $}

  ${
    2exbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding two existential quantifiers to both sides of an
       equivalence.  (Contributed by NM, 16-Mar-1995.) $)
    2exbii $p |- ( E. x E. y ph <-> E. x E. y ps ) $=
      ( wex exbii ) ADFBDFCABDEGG $.
  $}

  ${
    3exbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding 3 existential quantifiers to both sides of an
       equivalence.  (Contributed by NM, 2-May-1995.) $)
    3exbii $p |- ( E. x E. y E. z ph <-> E. x E. y E. z ps ) $=
      ( wex exbii 2exbii ) AEGBEGCDABEFHI $.
  $}

  $( A transformation of quantifiers and logical connectives.  (Contributed by
     NM, 25-Mar-1996.)  (Proof shortened by Wolf Lammen, 4-Sep-2014.) $)
  exanali $p |- ( E. x ( ph /\ -. ps ) <-> -. A. x ( ph -> ps ) ) $=
    ( wn wa wex wi wal annim exbii exnal bitri ) ABDEZCFABGZDZCFNCHDMOCABIJNCKL
    $.

  $( Commutation of conjunction inside an existential quantifier.  (Contributed
     by NM, 18-Aug-1993.) $)
  exancom $p |- ( E. x ( ph /\ ps ) <-> E. x ( ps /\ ph ) ) $=
    ( wa ancom exbii ) ABDBADCABEF $.

  ${
    alrimdh.1 $e |- ( ph -> A. x ph ) $.
    alrimdh.2 $e |- ( ps -> A. x ps ) $.
    alrimdh.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
       10-Feb-1997.)  (Proof shortened by Andrew Salmon, 13-May-2011.) $)
    alrimdh $p |- ( ph -> ( ps -> A. x ch ) ) $=
      ( wal alimdh syl5 ) BBDHACDHFABCDEGIJ $.
  $}

  ${
    eximdh.1 $e |- ( ph -> A. x ph ) $.
    eximdh.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Contributed by NM,
       20-May-1996.) $)
    eximdh $p |- ( ph -> ( E. x ps -> E. x ch ) ) $=
      ( wi wal wex alrimih exim syl ) ABCGZDHBDICDIGAMDEFJBCDKL $.
  $}

  ${
    nexdh.1 $e |- ( ph -> A. x ph ) $.
    nexdh.2 $e |- ( ph -> -. ps ) $.
    $( Deduction for generalization rule for negated wff.  (Contributed by NM,
       2-Jan-2002.) $)
    nexdh $p |- ( ph -> -. E. x ps ) $=
      ( wn wal wex alrimih alnex sylib ) ABFZCGBCHFALCDEIBCJK $.
  $}

  ${
    albidh.1 $e |- ( ph -> A. x ph ) $.
    albidh.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for universal quantifier (deduction rule).
       (Contributed by NM, 5-Aug-1993.) $)
    albidh $p |- ( ph -> ( A. x ps <-> A. x ch ) ) $=
      ( wb wal alrimih albi syl ) ABCGZDHBDHCDHGALDEFIBCDJK $.
  $}

  ${
    exbidh.1 $e |- ( ph -> A. x ph ) $.
    exbidh.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for existential quantifier (deduction rule).
       (Contributed by NM, 5-Aug-1993.) $)
    exbidh $p |- ( ph -> ( E. x ps <-> E. x ch ) ) $=
      ( wb wal wex alrimih exbi syl ) ABCGZDHBDICDIGAMDEFJBCDKL $.
  $}

  $( Simplification of an existentially quantified conjunction.  (Contributed
     by Rodolfo Medina, 25-Sep-2010.)  (Proof shortened by Andrew Salmon,
     29-Jun-2011.) $)
  exsimpl $p |- ( E. x ( ph /\ ps ) -> E. x ph ) $=
    ( wa simpl eximi ) ABDACABEF $.

  $( Simplification of an existentially quantified conjunction.  (Contributed
     by Rodolfo Medina, 25-Sep-2010.)  (Proof shortened by Andrew Salmon,
     29-Jun-2011.) $)
  exsimpr $p |- ( E. x ( ph /\ ps ) -> E. x ps ) $=
    ( wa simpr eximi ) ABDBCABEF $.

  $( Theorem 19.26 of [Margaris] p. 90.  Also Theorem *10.22 of
     [WhiteheadRussell] p. 147.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 4-Jul-2014.) $)
  19.26 $p |- ( A. x ( ph /\ ps ) <-> ( A. x ph /\ A. x ps ) ) $=
    ( wa wal simpl alimi simpr jca id alanimi impbii ) ABDZCEZACEZBCEZDNOPMACAB
    FGMBCABHGIABMCMJKL $.

  $( Theorem 19.26 of [Margaris] p. 90 with two quantifiers.  (Contributed by
     NM, 3-Feb-2005.) $)
  19.26-2 $p |- ( A. x A. y ( ph /\ ps ) <->
                ( A. x A. y ph /\ A. x A. y ps ) ) $=
    ( wa wal 19.26 albii bitri ) ABEDFZCFADFZBDFZEZCFKCFLCFEJMCABDGHKLCGI $.

  $( Theorem 19.26 of [Margaris] p. 90 with triple conjunction.  (Contributed
     by NM, 13-Sep-2011.) $)
  19.26-3an $p |- ( A. x ( ph /\ ps /\ ch )
                   <-> ( A. x ph /\ A. x ps /\ A. x ch ) ) $=
    ( wa wal w3a 19.26 anbi1i bitri df-3an albii 3bitr4i ) ABEZCEZDFZADFZBDFZEZ
    CDFZEZABCGZDFQRTGPNDFZTEUANCDHUCSTABDHIJUBODABCKLQRTKM $.

  $( Theorem 19.29 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Andrew Salmon, 13-May-2011.) $)
  19.29 $p |- ( ( A. x ph /\ E. x ps ) -> E. x ( ph /\ ps ) ) $=
    ( wal wex wa wi pm3.2 alimi exim syl imp ) ACDZBCEZABFZCEZMBOGZCDNPGAQCABHI
    BOCJKL $.

  $( Variation of Theorem 19.29 of [Margaris] p. 90.  (Contributed by NM,
     18-Aug-1993.) $)
  19.29r $p |- ( ( E. x ph /\ A. x ps ) -> E. x ( ph /\ ps ) ) $=
    ( wex wal wa 19.29 ancoms exancom sylibr ) ACDZBCEZFBAFCDZABFCDLKMBACGHABCI
    J $.

  $( Variation of Theorem 19.29 of [Margaris] p. 90 with double
     quantification.  (Contributed by NM, 3-Feb-2005.) $)
  19.29r2 $p |- ( ( E. x E. y ph /\ A. x A. y ps ) ->
             E. x E. y ( ph /\ ps ) ) $=
    ( wex wal wa 19.29r eximi syl ) ADEZCEBDFZCFGKLGZCEABGDEZCEKLCHMNCABDHIJ $.

  $( Variation of Theorem 19.29 of [Margaris] p. 90 with mixed quantification.
     (Contributed by NM, 11-Feb-2005.) $)
  19.29x $p |- ( ( E. x A. y ph /\ A. x E. y ps ) ->
             E. x E. y ( ph /\ ps ) ) $=
    ( wal wex wa 19.29r 19.29 eximi syl ) ADEZCFBDFZCEGLMGZCFABGDFZCFLMCHNOCABD
    IJK $.

  $( Theorem 19.35 of [Margaris] p. 90.  This theorem is useful for moving an
     implication (in the form of the right-hand side) into the scope of a
     single existential quantifier.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 27-Jun-2014.) $)
  19.35 $p |- ( E. x ( ph -> ps ) <-> ( A. x ph -> E. x ps ) ) $=
    ( wi wex wal wn wa 19.26 annim albii alnex anbi2i 3bitr3i con4bii ) ABDZCEZ
    ACFZBCEZDZPGZCFZRSGZHZQGTGABGZHZCFRUECFZHUBUDAUECIUFUACABJKUGUCRBCLMNPCLRSJ
    NO $.

  ${
    19.35i.1 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.35 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.35i $p |- ( A. x ph -> E. x ps ) $=
      ( wi wex wal 19.35 mpbi ) ABECFACGBCFEDABCHI $.
  $}

  ${
    19.35ri.1 $e |- ( A. x ph -> E. x ps ) $.
    $( Inference from Theorem 19.35 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.35ri $p |- E. x ( ph -> ps ) $=
      ( wi wex wal 19.35 mpbir ) ABECFACGBCFEDABCHI $.
  $}

  $( Theorem 19.25 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  19.25 $p |- ( A. y E. x ( ph -> ps ) ->
              ( E. y A. x ph -> E. y E. x ps ) ) $=
    ( wi wex wal 19.35 biimpi alimi exim syl ) ABECFZDGACGZBCFZEZDGNDFODFEMPDMP
    ABCHIJNODKL $.

  $( Theorem 19.30 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Andrew Salmon, 25-May-2011.) $)
  19.30 $p |- ( A. x ( ph \/ ps ) -> ( A. x ph \/ E. x ps ) ) $=
    ( wn wi wal wex wo exnal exim syl5bir df-or albii 3imtr4i ) ADZBEZCFZACFZDZ
    BCGZEABHZCFRTHSOCGQTACIOBCJKUAPCABLMRTLN $.

  $( Theorem 19.43 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Wolf Lammen, 27-Jun-2014.) $)
  19.43 $p |- ( E. x ( ph \/ ps ) <-> ( E. x ph \/ E. x ps ) ) $=
    ( wo wex wn wi wal df-or exbii 19.35 alnex imbi1i 3bitri bitr4i ) ABDZCEZAC
    EZFZBCEZGZRTDQAFZBGZCEUBCHZTGUAPUCCABIJUBBCKUDSTACLMNRTIO $.

  $( Obsolete proof of ~ 19.43 as of 3-May-2017.  Leave this in for the example
     on the mmrecent.html page.  (Contributed by NM, 5-Aug-1993.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  19.43OLD $p |- ( E. x ( ph \/ ps ) <-> ( E. x ph \/ E. x ps ) ) $=
    ( wo wn wal wex wa ioran albii 19.26 alnex anbi12i 3bitri notbii df-ex oran
    3bitr4i ) ABDZEZCFZEACGZEZBCGZEZHZESCGUBUDDUAUFUAAEZBEZHZCFUGCFZUHCFZHUFTUI
    CABIJUGUHCKUJUCUKUEACLBCLMNOSCPUBUDQR $.

  $( Theorem 19.33 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  19.33 $p |- ( ( A. x ph \/ A. x ps ) -> A. x ( ph \/ ps ) ) $=
    ( wal wo orc alimi olc jaoi ) ACDABEZCDBCDAJCABFGBJCBAHGI $.

  $( The antecedent provides a condition implying the converse of ~ 19.33 .
     Compare Theorem 19.33 of [Margaris] p. 90.  (Contributed by NM,
     27-Mar-2004.)  (Proof shortened by Andrew Salmon, 25-May-2011.)  (Proof
     shortened by Wolf Lammen, 5-Jul-2014.) $)
  19.33b $p |- ( -. ( E. x ph /\ E. x ps ) ->
               ( A. x ( ph \/ ps ) <-> ( A. x ph \/ A. x ps ) ) ) $=
    ( wex wa wn wo wal ianor alnex pm2.53 al2imi syl5bir olc syl6com orcomd ord
    wi 19.30 orc jaoi sylbi 19.33 impbid1 ) ACDZBCDZEFZABGZCHZACHZBCHZGZUGUEFZU
    FFZGUIULRZUEUFIUMUOUNUIUMUKULUMAFZCHUIUKACJUHUPBCABKLMUKUJNOUIUNUJULUIUFUJU
    IUJUFABCSPQUJUKTOUAUBABCUCUD $.

  $( Theorem 19.40 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  19.40 $p |- ( E. x ( ph /\ ps ) -> ( E. x ph /\ E. x ps ) ) $=
    ( wa wex exsimpl exsimpr jca ) ABDCEACEBCEABCFABCGH $.

  $( Theorem *11.42 in [WhiteheadRussell] p. 163.  Theorem 19.40 of [Margaris]
     p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon, 24-May-2011.) $)
  19.40-2 $p |- ( E. x E. y ( ph /\ ps ) ->
        ( E. x E. y ph /\ E. x E. y ps ) ) $=
    ( wa wex 19.40 eximi syl ) ABEDFZCFADFZBDFZEZCFKCFLCFEJMCABDGHKLCGI $.

  $( Split a biconditional and distribute quantifier.  (Contributed by NM,
     18-Aug-1993.) $)
  albiim $p |- ( A. x ( ph <-> ps ) <->
             ( A. x ( ph -> ps ) /\ A. x ( ps -> ph ) ) ) $=
    ( wb wal wi wa dfbi2 albii 19.26 bitri ) ABDZCEABFZBAFZGZCEMCENCEGLOCABHIMN
    CJK $.

  $( Split a biconditional and distribute 2 quantifiers.  (Contributed by NM,
     3-Feb-2005.) $)
  2albiim $p |- ( A. x A. y ( ph <-> ps ) <->
             ( A. x A. y ( ph -> ps ) /\ A. x A. y ( ps -> ph ) ) ) $=
    ( wb wal wi wa albiim albii 19.26 bitri ) ABEDFZCFABGDFZBAGDFZHZCFNCFOCFHMP
    CABDIJNOCKL $.

  $( Add/remove a conjunct in the scope of an existential quantifier.
     (Contributed by Raph Levien, 3-Jul-2006.) $)
  exintrbi $p |- ( A. x ( ph -> ps ) -> ( E. x ph <-> E. x ( ph /\ ps ) ) ) $=
    ( wi wal wa wb wex pm4.71 albii exbi sylbi ) ABDZCEAABFZGZCEACHNCHGMOCABIJA
    NCKL $.

  $( Introduce a conjunct in the scope of an existential quantifier.
     (Contributed by NM, 11-Aug-1993.) $)
  exintr $p |- ( A. x ( ph -> ps ) -> ( E. x ph -> E. x ( ph /\ ps ) ) ) $=
    ( wi wal wex wa exintrbi biimpd ) ABDCEACFABGCFABCHI $.

  $( Theorem *10.3 in [WhiteheadRussell] p. 150.  (Contributed by Andrew
     Salmon, 8-Jun-2011.) $)
  alsyl $p |- ( ( A. x ( ph -> ps ) /\ A. x ( ps -> ch ) ) ->
        A. x ( ph -> ch ) ) $=
    ( wi pm3.33 alanimi ) ABEBCEACEDABCFG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Axiom scheme ax-17 (Distinctness) - first use of $d
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x ph $.
    $( Axiom of Distinctness.  This axiom quantifies a variable over a formula
       in which it does not occur.  Axiom C5 in [Megill] p. 444 (p. 11 of the
       preprint).  Also appears as Axiom B6 (p. 75) of system S2 of [Tarski]
       p. 77 and Axiom C5-1 of [Monk2] p. 113.

       (See comments in ~ ax17o about the logical redundancy of ~ ax-17 in the
       presence of our obsolete axioms.)

       This axiom essentially says that if ` x ` does not occur in ` ph ` ,
       i.e. ` ph ` does not depend on ` x ` in any way, then we can add the
       quantifier ` A. x ` to ` ph ` with no further assumptions.  By ~ sp , we
       can also remove the quantifier (unconditionally).  (Contributed by NM,
       5-Aug-1993.) $)
    ax-17 $a |- ( ph -> A. x ph ) $.
  $}

  ${
    $d x ps $.
    $( ~ ax-17 with antecedent.  Useful in proofs of deduction versions of
       bound-variable hypothesis builders.  (Contributed by NM, 1-Mar-2013.) $)
    a17d $p |- ( ph -> ( ps -> A. x ps ) ) $=
      ( wal wi ax-17 a1i ) BBCDEABCFG $.
  $}

  ${
    $d x ph $.
    $( A rephrasing of ~ ax-17 using the existential quantifier.  (Contributed
       by Wolf Lammen, 4-Dec-2017.) $)
    ax17e $p |- ( E. x ph -> ph ) $=
      ( wex wn wal df-ex ax-17 con1i sylbi ) ABCADZBEZDAABFAKJBGHI $.
  $}

  ${
    $d x ph $.
    $( If ` x ` is not present in ` ph ` , then ` x ` is not free in ` ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfv $p |- F/ x ph $=
      ( ax-17 nfi ) ABABCD $.
  $}

  ${
    $d x ps $.
    $( ~ nfv with antecedent.  Useful in proofs of deduction versions of
       bound-variable hypothesis builders such as ~ nfimd .  (Contributed by
       Mario Carneiro, 6-Oct-2016.) $)
    nfvd $p |- ( ph -> F/ x ps ) $=
      ( wnf nfv a1i ) BCDABCEF $.
  $}

  ${
    $d x ph $.
    alimdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.20 of [Margaris] p. 90.  (Contributed by NM,
       3-Apr-1994.) $)
    alimdv $p |- ( ph -> ( A. x ps -> A. x ch ) ) $=
      ( ax-17 alimdh ) ABCDADFEG $.

    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Contributed by NM,
       27-Apr-1994.) $)
    eximdv $p |- ( ph -> ( E. x ps -> E. x ch ) ) $=
      ( ax-17 eximdh ) ABCDADFEG $.
  $}

  ${
    $d x ph $.  $d y ph $.
    2alimdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Contributed by NM,
       27-Apr-2004.) $)
    2alimdv $p |- ( ph -> ( A. x A. y ps -> A. x A. y ch ) ) $=
      ( wal alimdv ) ABEGCEGDABCEFHH $.

    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Contributed by NM,
       3-Aug-1995.) $)
    2eximdv $p |- ( ph -> ( E. x E. y ps -> E. x E. y ch ) ) $=
      ( wex eximdv ) ABEGCEGDABCEFHH $.
  $}

  ${
    $d x ph $.
    albidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for universal quantifier (deduction rule).
       (Contributed by NM, 5-Aug-1993.) $)
    albidv $p |- ( ph -> ( A. x ps <-> A. x ch ) ) $=
      ( ax-17 albidh ) ABCDADFEG $.

    $( Formula-building rule for existential quantifier (deduction rule).
       (Contributed by NM, 5-Aug-1993.) $)
    exbidv $p |- ( ph -> ( E. x ps <-> E. x ch ) ) $=
      ( ax-17 exbidh ) ABCDADFEG $.
  $}

  ${
    $d x ph $.  $d y ph $.
    2albidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for 2 universal quantifiers (deduction rule).
       (Contributed by NM, 4-Mar-1997.) $)
    2albidv $p |- ( ph -> ( A. x A. y ps <-> A. x A. y ch ) ) $=
      ( wal albidv ) ABEGCEGDABCEFHH $.

    $( Formula-building rule for 2 existential quantifiers (deduction rule).
       (Contributed by NM, 1-May-1995.) $)
    2exbidv $p |- ( ph -> ( E. x E. y ps <-> E. x E. y ch ) ) $=
      ( wex exbidv ) ABEGCEGDABCEFHH $.
  $}

  ${
    $d x ph $.  $d y ph $.  $d z ph $.
    3exbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for 3 existential quantifiers (deduction rule).
       (Contributed by NM, 1-May-1995.) $)
    3exbidv $p |- ( ph -> ( E. x E. y E. z ps <-> E. x E. y E. z ch ) ) $=
      ( wex exbidv 2exbidv ) ABFHCFHDEABCFGIJ $.
  $}

  ${
    $d x ph $.  $d y ph $.  $d z ph $.  $d w ph $.
    4exbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for 4 existential quantifiers (deduction rule).
       (Contributed by NM, 3-Aug-1995.) $)
    4exbidv $p |- ( ph ->
                     ( E. x E. y E. z E. w ps <-> E. x E. y E. z E. w ch ) ) $=
      ( wex 2exbidv ) ABGIFICGIFIDEABCFGHJJ $.
  $}

  ${
    $d x ph $.
    alrimiv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    alrimiv $p |- ( ph -> A. x ps ) $=
      ( ax-17 alrimih ) ABCACEDF $.
  $}

  ${
    $d x ph $.  $d y ph $.
    alrimivv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
       31-Jul-1995.) $)
    alrimivv $p |- ( ph -> A. x A. y ps ) $=
      ( wal alrimiv ) ABDFCABDEGG $.
  $}

  ${
    $d x ph $.  $d x ps $.
    alrimdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
       10-Feb-1997.) $)
    alrimdv $p |- ( ph -> ( ps -> A. x ch ) ) $=
      ( ax-17 alrimdh ) ABCDADFBDFEG $.
  $}

  ${
    $d x ps $.
    exlimiv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.

       This inference, along with our many variants such as ~ rexlimdv , is
       used to implement a metatheorem called "Rule C" that is given in many
       logic textbooks.  See, for example, Rule C in [Mendelson] p. 81, Rule C
       in [Margaris] p. 40, or Rule C in Hirst and Hirst's _A Primer for Logic
       and Proof_ p. 59 (PDF p. 65) at
       ~ http://www.mathsci.appstate.edu/~~hirstjl/primer/hirst.pdf .

       In informal proofs, the statement "Let ` C ` be an element such that..."
       almost always means an implicit application of Rule C.

       In essence, Rule C states that if we can prove that some element ` x `
       exists satisfying a wff, i.e. ` E. x ph ( x ) ` where ` ph ( x ) ` has
       ` x ` free, then we can use ` ph ( C ) ` as a hypothesis for the proof
       where ` C ` is a new (ficticious) constant not appearing previously in
       the proof, nor in any axioms used, nor in the theorem to be proved.  The
       purpose of Rule C is to get rid of the existential quantifier.

       We cannot do this in Metamath directly.  Instead, we use the original
       ` ph ` (containing ` x ` ) as an antecedent for the main part of the
       proof.  We eventually arrive at ` ( ph -> ps ) ` where ` ps ` is the
       theorem to be proved and does not contain ` x ` .  Then we apply
       ~ exlimiv to arrive at ` ( E. x ph -> ps ) ` .  Finally, we separately
       prove ` E. x ph ` and detach it with modus ponens ~ ax-mp to arrive at
       the final theorem ` ps ` .  (Contributed by NM, 5-Aug-1993.)  (Revised
       by Wolf Lammen to remove dependency on ax-9 and ax-8, 4-Dec-2017.) $)
    exlimiv $p |- ( E. x ph -> ps ) $=
      ( wex eximi ax17e syl ) ACEBCEBABCDFBCGH $.
  $}

  ${
    $d x ps $.  $d y ps $.
    exlimivv.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM,
       1-Aug-1995.) $)
    exlimivv $p |- ( E. x E. y ph -> ps ) $=
      ( wex exlimiv ) ADFBCABDEGG $.
  $}

  ${
    $d x ch $.  $d x ph $.
    exlimdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90.  Revised to remove
       dependency on ~ ax-9 and ~ ax-8 .  (Contributed by NM, 27-Apr-1994.)
       (Revised by Wolf Lammen, 4-Dec-2017.) $)
    exlimdv $p |- ( ph -> ( E. x ps -> ch ) ) $=
      ( wex eximdv ax17e syl6 ) ABDFCDFCABCDEGCDHI $.
  $}

  ${
    $d x ch $.  $d x ph $.  $d y ch $.  $d y ph $.
    exlimdvv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM,
       31-Jul-1995.) $)
    exlimdvv $p |- ( ph -> ( E. x E. y ps -> ch ) ) $=
      ( wex exlimdv ) ABEGCDABCEFHH $.
  $}

  ${
    $d x ch $.  $d x ph $.
    exlimddv.1 $e |- ( ph -> E. x ps ) $.
    exlimddv.2 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Existential elimination rule of natural deduction.  (Contributed by
       Mario Carneiro, 15-Jun-2016.) $)
    exlimddv $p |- ( ph -> ch ) $=
      ( wex ex exlimdv mpd ) ABDGCEABCDABCFHIJ $.
  $}

  ${
    $d x ph $.
    nfdv.1 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Apply the definition of not-free in a context.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    nfdv $p |- ( ph -> F/ x ps ) $=
      ( wal wi wnf alrimiv df-nf sylibr ) ABBCEFZCEBCGAKCDHBCIJ $.
  $}

  ${
    $d x ph $.  $d y ph $.
    $( Quantification of two variables over a formula in which they do not
       occur.  (Contributed by Alan Sare, 12-Apr-2011.) $)
    2ax17 $p |- ( ph -> A. x A. y ph ) $=
      ( id alrimivv ) AABCADE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Equality predicate; define substitution
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( --- Start of patch to prevent connective overloading $)
  $c class $.

  $( Add 'class' as a typecode. $)
  $( $j syntax 'class'; $)

  $( This syntax construction states that a variable ` x ` , which has been
     declared to be a set variable by $f statement vx, is also a class
     expression.  This can be justified informally as follows.  We know that
     the class builder ` { y | y e. x } ` is a class by ~ cab .  Since (when
     ` y ` is distinct from ` x ` ) we have ` x = { y | y e. x } ` by
     ~ cvjust , we can argue that the syntax " ` class x ` " can be viewed as
     an abbreviation for " ` class { y | y e. x } ` ".  See the discussion
     under the definition of class in [Jech] p. 4 showing that "Every set can
     be considered to be a class."

     While it is tempting and perhaps occasionally useful to view ~ cv as a
     "type conversion" from a set variable to a class variable, keep in mind
     that ~ cv is intrinsically no different from any other class-building
     syntax such as ~ cab , ~ cun , or ~ c0 .

     For a general discussion of the theory of classes and the role of ~ cv ,
     see ~ http://us.metamath.org/mpeuni/mmset.html#class .

     (The description above applies to set theory, not predicate calculus.  The
     purpose of introducing ` class x ` here, and not in set theory where it
     belongs, is to allow us to express i.e.  "prove" the ~ weq of predicate
     calculus from the ~ wceq of set theory, so that we don't "overload" the
     ` = ` connective with two syntax definitions.  This is done to prevent
     ambiguity that would complicate some Metamath parsers.) $)
  cv $a class x $.
  $( --- End of patch to prevent connective overloading $)

  $( --- Start of old code before overloading prevention patch. $)
  $(          (None - the above patch had no old code.) $)
  $( --- End of old code before overloading prevention patch. $)

  $( Declare the equality predicate symbol. $)
  $c = $.  $( Equal sign (read:  'is equal to') $)

  $( --- Start of patch to prevent connective overloading $)
  ${
    $v A $.
    $v B $.
    wceq.cA $f class A $.
    wceq.cB $f class B $.
    $( Extend wff definition to include class equality.

       For a general discussion of the theory of classes, see
       ~ http://us.metamath.org/mpeuni/mmset.html#class .

       (The purpose of introducing ` wff A = B ` here, and not in set theory
       where it belongs, is to allow us to express i.e.  "prove" the ~ weq of
       predicate calculus in terms of the ~ wceq of set theory, so that we
       don't "overload" the ` = ` connective with two syntax definitions.  This
       is done to prevent ambiguity that would complicate some Metamath
       parsers.  For example, some parsers - although not the Metamath program
       - stumble on the fact that the ` = ` in ` x = y ` could be the ` = ` of
       either ~ weq or ~ wceq , although mathematically it makes no
       difference.  The class variables ` A ` and ` B ` are introduced
       temporarily for the purpose of this definition but otherwise not used in
       predicate calculus.  See ~ df-cleq for more information on the set
       theory usage of ~ wceq .) $)
    wceq $a wff A = B $.
  $}

  $( Extend wff definition to include atomic formulas using the equality
     predicate.

     (Instead of introducing ~ weq as an axiomatic statement, as was done in an
     older version of this database, we introduce it by "proving" a special
     case of set theory's more general ~ wceq .  This lets us avoid overloading
     the ` = ` connective, thus preventing ambiguity that would complicate
     certain Metamath parsers.  However, logically ~ weq is considered to be a
     primitive syntax, even though here it is artificially "derived" from
     ~ wceq .  Note:  To see the proof steps of this syntax proof, type "show
     proof weq /all" in the Metamath program.)  (Contributed by NM,
     24-Jan-2006.) $)
  weq $p wff x = y $=
    ( cv wceq ) ACBCD $.
  $( --- End of patch to prevent connective overloading $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include atomic formulas using the equality
     predicate.

     After we introduce ~ cv and ~ wceq in set theory, this syntax construction
     becomes redundant, since it can be derived with the proof
     "vx cv vy cv wceq". @)
  weq @a wff x = y @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Lemma used in proofs of substitution properties.  (Contributed by NM,
     5-Aug-1993.) $)
  equs3 $p |- ( E. x ( x = y /\ ph ) <-> -. A. x ( x = y -> -. ph ) ) $=
    ( weq wn wi wal wa wex alinexa con2bii ) BCDZAEFBGLAHBILABJK $.

  ${
    speimfw.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization, with additional weakening to allow bundling of ` x ` and
       ` y ` .  Uses only Tarski's FOL axiom schemes.  (Contributed by NM,
       23-Apr-2017.)  (Proof shortened by Wolf Lammen, 5-Aug-2017.) $)
    speimfw $p |- ( -. A. x -. x = y -> ( A. x ph -> E. x ps ) ) $=
      ( weq wex wi wn wal eximi df-ex 19.35 3imtr3i ) CDFZCGABHZCGOICJIACJBCGHO
      PCEKOCLABCMN $.
  $}

  ${
    spimfw.1 $e |- ( -. ps -> A. x -. ps ) $.
    spimfw.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization, with additional weakening to allow bundling of ` x ` and
       ` y ` .  Uses only Tarski's FOL axiom schemes.  (Contributed by NM,
       23-Apr-1017.)  (Proof shortened by Wolf Lammen, 7-Aug-2017.) $)
    spimfw $p |- ( -. A. x -. x = y -> ( A. x ph -> ps ) ) $=
      ( weq wn wal wex speimfw df-ex con1i sylbi syl6 ) CDGHCIHACIBCJZBABCDFKPB
      HCIZHBBCLBQEMNO $.
  $}

  ${
    ax11i.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    ax11i.2 $e |- ( ps -> A. x ps ) $.
    $( Inference that has ~ ax-11 (without ` A. y ` ) as its conclusion.  Uses
       only Tarski's FOL axiom schemes.  The hypotheses may be eliminable
       without one or more of these axioms in special cases.  Proof similar to
       Lemma 16 of [Tarski] p. 70.  (Contributed by NM, 20-May-2008.) $)
    ax11i $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      ( weq wi wal biimprcd alrimih syl6bi ) CDGZABMAHZCIEBNCFMABEJKL $.
  $}

  $c [ $. $( Left bracket $)
  $c / $. $( Slash. $)
  $c ] $.  $( Right bracket $)

  $( Extend wff definition to include proper substitution (read "the wff that
     results when ` y ` is properly substituted for ` x ` in wff ` ph ` ").
     (Contributed by NM, 24-Jan-2006.) $)
  wsb $a wff [ y / x ] ph $.

  $( Define proper substitution.  Remark 9.1 in [Megill] p. 447 (p. 15 of the
     preprint).  For our notation, we use ` [ y / x ] ph ` to mean "the wff
     that results from the proper substitution of ` y ` for ` x ` in the wff
     ` ph ` ."  We can also use ` [ y / x ] ph ` in place of the "free for"
     side condition used in traditional predicate calculus; see, for example,
     ~ stdpc4 .

     Our notation was introduced in Haskell B. Curry's _Foundations of
     Mathematical Logic_ (1977), p. 316 and is frequently used in textbooks of
     lambda calculus and combinatory logic.  This notation improves the common
     but ambiguous notation, " ` ph ( y ) ` is the wff that results when ` y `
     is properly substituted for ` x ` in ` ph ( x ) ` ."  For example, if the
     original ` ph ( x ) ` is ` x = y ` , then ` ph ( y ) ` is ` y = y ` , from
     which we obtain that ` ph ( x ) ` is ` x = x ` .  So what exactly does
     ` ph ( x ) ` mean?  Curry's notation solves this problem.

     In most books, proper substitution has a somewhat complicated recursive
     definition with multiple cases based on the occurrences of free and bound
     variables in the wff.  Instead, we use a single formula that is exactly
     equivalent and gives us a direct definition.  We later prove that our
     definition has the properties we expect of proper substitution (see
     theorems ~ sbequ , ~ sbcom2 and ~ sbid2v ).

     Note that our definition is valid even when ` x ` and ` y ` are replaced
     with the same variable, as ~ sbid shows.  We achieve this by having ` x `
     free in the first conjunct and bound in the second.  We can also achieve
     this by using a dummy variable, as the alternate definition ~ dfsb7 shows
     (which some logicians may prefer because it doesn't mix free and bound
     variables).  Another version that mixes free and bound variables is
     ~ dfsb3 .  When ` x ` and ` y ` are distinct, we can express proper
     substitution with the simpler expressions of ~ sb5 and ~ sb6 .

     There are no restrictions on any of the variables, including what
     variables may occur in wff ` ph ` .  (Contributed by NM, 5-Aug-1993.) $)
  df-sb $a |- ( [ y / x ] ph <->
              ( ( x = y -> ph ) /\ E. x ( x = y /\ ph ) ) ) $.

  $( An equality theorem for substitution.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Wolf Lammen, 25-Feb-2018.) $)
  sbequ2 $p |- ( x = y -> ( [ y / x ] ph -> ph ) ) $=
    ( wsb weq wi wa wex df-sb simplbi com12 ) ABCDZBCEZALMAFMAGBHABCIJK $.

  $( Obsolete proof of ~ sbequ2 as of 25-Feb-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  sbequ2OLD $p |- ( x = y -> ( [ y / x ] ph -> ph ) ) $=
    ( wsb weq wi wa wex df-sb simpl com12 syl5bi ) ABCDBCEZAFZMAGBHZGZMAABCIPMA
    NOJKL $.

  $( One direction of a simplified definition of substitution.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb1 $p |- ( [ y / x ] ph -> E. x ( x = y /\ ph ) ) $=
    ( wsb weq wi wa wex df-sb simprbi ) ABCDBCEZAFKAGBHABCIJ $.

  $( A specialization theorem.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 3-May-2018.) $)
  spsbe $p |- ( [ y / x ] ph -> E. x ph ) $=
    ( wsb weq wa wex sb1 exsimpr syl ) ABCDBCEZAFBGABGABCHKABIJ $.

  $( Elimination of equality from antecedent after substitution.  Revised to
     minimize dependencies.  (Contributed by NM, 5-Aug-1993.)  (Revised by Wolf
     Lammen, 28-Jul-2018.) $)
  sbequ8 $p |- ( [ y / x ] ph <-> [ y / x ] ( x = y -> ph ) ) $=
    ( weq wi wa wex wsb pm5.4 bicomi abai exbii anbi12i df-sb 3bitr4i ) BCDZAEZ
    PAFZBGZFPQEZPQFZBGZFABCHQBCHQTSUBTQPAIJRUABPAKLMABCNQBCNO $.

  ${
    sbimi.1 $e |- ( ph -> ps ) $.
    $( Infer substitution into antecedent and consequent of an implication.
       (Contributed by NM, 25-Jun-1998.) $)
    sbimi $p |- ( [ y / x ] ph -> [ y / x ] ps ) $=
      ( weq wi wa wex wsb imim2i anim2i eximi anim12i df-sb 3imtr4i ) CDFZAGZQA
      HZCIZHQBGZQBHZCIZHACDJBCDJRUATUCABQEKSUBCABQELMNACDOBCDOP $.
  $}

  ${
    sbbii.1 $e |- ( ph <-> ps ) $.
    $( Infer substitution into both sides of a logical equivalence.
       (Contributed by NM, 5-Aug-1993.) $)
    sbbii $p |- ( [ y / x ] ph <-> [ y / x ] ps ) $=
      ( wsb biimpi sbimi biimpri impbii ) ACDFBCDFABCDABEGHBACDABEIHJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Axiom scheme ax-9 (Existence)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Existence.  One of the equality and substitution axioms of
     predicate calculus with equality.  This axiom tells us is that at least
     one thing exists.  In this form (not requiring that ` x ` and ` y ` be
     distinct) it was used in an axiom system of Tarski (see Axiom B7' in
     footnote 1 of [KalishMontague] p. 81.)  It is equivalent to axiom scheme
     C10' in [Megill] p. 448 (p. 16 of the preprint); the equivalence is
     established by ~ ax9o and ~ ax9from9o .  A more convenient form of this
     axiom is ~ a9e , which has additional remarks.

     Raph Levien proved the independence of this axiom from the other logical
     axioms on 12-Apr-2005.  See item 16 at
     ~ http://us.metamath.org/award2003.html .

     ~ ax-9 can be proved from the weaker version ~ ax9v requiring that the
     variables be distinct; see theorem ~ ax9 .

     ~ ax-9 can also be proved from the Axiom of Separation (in the form that
     we use that axiom, where free variables are not universally quantified).
     See theorem ~ ax9vsep .

     Except by ~ ax9v , this axiom should not be referenced directly.  Instead,
     use theorem ~ ax9 .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-9 $a |- -. A. x -. x = y $.

  ${
    $d x y $.
    $( Axiom B7 of [Tarski] p. 75, which requires that ` x ` and ` y ` be
       distinct.  This trivial proof is intended merely to weaken axiom ~ ax-9
       by adding a distinct variable restriction.  From here on, ~ ax-9 should
       not be referenced directly by any other proof, so that theorem ~ ax9
       will show that we can recover ~ ax-9 from this weaker version if it were
       an axiom (as it is in the case of Tarski).

       Note:  Introducing ` x , y ` as a distinct variable group "out of the
       blue" with no apparent justification has puzzled some people, but it is
       perfectly sound.  All we are doing is adding an additional redundant
       requirement, no different from adding a redundant logical hypothesis,
       that results in a weakening of the theorem.  This means that any
       _future_ theorem that references ~ ax9v must have a $d specified for the
       two variables that get substituted for ` x ` and ` y ` .  The $d does
       not propagate "backwards" i.e. it does not impose a requirement on
       ~ ax-9 .

       When possible, use of this theorem rather than ~ ax9 is preferred since
       its derivation from axioms is much shorter.  (Contributed by NM,
       7-Aug-2015.) $)
    ax9v $p |- -. A. x -. x = y $=
      ( ax-9 ) ABC $.
  $}

  ${
    $d x y $.
    $( At least one individual exists.  Weaker version of ~ a9e .  When
       possible, use of this theorem rather than ~ a9e is preferred since its
       derivation from axioms is much shorter.  (Contributed by NM,
       3-Aug-2017.) $)
    a9ev $p |- E. x x = y $=
      ( weq wex wn wal ax9v df-ex mpbir ) ABCZADJEAFEABGJAHI $.
  $}

  ${
    $d x y $.
    exiftru.1 $e |- ph $.
    $( A companion rule to ax-gen, valid only if an individual exists.  Unlike
       ~ ax-9 , it does not require equality on its interface.  Some
       fundamental theorems of predicate logic can be proven from ~ ax-gen ,
       ~ ax-5 and this theorem alone, not requiring ~ ax-8 or excessive
       distinct variable conditions.  (Contributed by Wolf Lammen,
       12-Nov-2017.)  (Proof shortened by Wolf Lammen, 9-Dec-2017.) $)
    exiftru $p |- E. x ph $=
      ( vy weq a9ev a1i eximii ) BDEZABBDFAICGH $.
  $}

  ${
    $d x y $.
    exiftruOLD.1 $e |- ph $.
    $( Obsolete proof of ~ exiftru as of 9-Dec-2017.  (Contributed by Wolf
       Lammen, 12-Nov-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    exiftruOLD $p |- E. x ph $=
      ( vy wex weq wi wal a9ev a1i 19.35ri id 2th exbii mpbir ) ABEBDFZPGZBEPPB
      PBEPBHBDIJKAQBAQCPLMNO $.
  $}

  $( Theorem 19.2 of [Margaris] p. 89.  Note:  This proof is very different
     from Margaris' because we only have Tarski's FOL axiom schemes available
     at this point.  See the later ~ 19.2g for a more conventional proof.
     Revised to remove dependency on ~ ax-8 .  (Contributed by NM,
     2-Aug-2017.)  (Revised by Wolf Lammen, 4-Dec-2017.) $)
  19.2 $p |- ( A. x ph -> E. x ph ) $=
    ( wi id exiftru 19.35i ) AABAACBADEF $.

  ${
    19.8w.1 $e |- ( ph -> A. x ph ) $.
    $( Weak version of ~ 19.8a .  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 1-Aug-2017.)  (Proof shortened by Wolf Lammen,
       4-Dec-2017.) $)
    19.8w $p |- ( ph -> E. x ph ) $=
      ( wal wex 19.2 syl ) AABDABECABFG $.
  $}

  $( Theorem 19.39 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  19.39 $p |- ( ( E. x ph -> E. x ps ) -> E. x ( ph -> ps ) ) $=
    ( wex wi wal 19.2 imim1i 19.35 sylibr ) ACDZBCDZEACFZLEABECDMKLACGHABCIJ $.

  $( Theorem 19.24 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  19.24 $p |- ( ( A. x ph -> A. x ps ) -> E. x ( ph -> ps ) ) $=
    ( wal wi wex 19.2 imim2i 19.35 sylibr ) ACDZBCDZEKBCFZEABECFLMKBCGHABCIJ $.

  $( Theorem 19.34 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
  19.34 $p |- ( ( A. x ph \/ E. x ps ) -> E. x ( ph \/ ps ) ) $=
    ( wal wex wo 19.2 orim1i 19.43 sylibr ) ACDZBCEZFACEZLFABFCEKMLACGHABCIJ $.

  ${
    $d x ph $.
    $( Special case of Theorem 19.9 of [Margaris] p. 89.  Revised to remove
       dependency on ~ ax-8 .  (Contributed by NM, 28-May-1995.)  (Revised by
       NM, 1-Aug-2017.)  (Revised by Wolf Lammen, 4-Dec-2017.) $)
    19.9v $p |- ( E. x ph <-> ph ) $=
      ( wex ax17e ax-17 19.8w impbii ) ABCAABDABABEFG $.

    $( Special case of Theorem 19.3 of [Margaris] p. 89.  Revised to remove
       dependency on ~ ax-8 .  (Contributed by NM, 1-Aug-2017.)  (Revised by
       Wolf Lammen, 4-Dec-2017.) $)
    19.3v $p |- ( A. x ph <-> ph ) $=
      ( wal wn wex alex 19.9v con2bii bitr4i ) ABCADZBEZDAABFKAJBGHI $.

    $( Version of ~ sp when ` x ` does not occur in ` ph ` .  This provides the
       other direction of ~ ax-17 .  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 10-Apr-2017.)  (Proof shortened by Wolf Lammen,
       4-Dec-2017.) $)
    spvw $p |- ( A. x ph -> ph ) $=
      ( wal 19.3v biimpi ) ABCAABDE $.
  $}

  ${
    $d x z $.
    spimeh.1 $e |- ( ph -> A. x ph ) $.
    spimeh.2 $e |- ( x = z -> ( ph -> ps ) ) $.
    $( Existential introduction, using implicit substitution.  Compare Lemma 14
       of [Tarski] p. 70.  (Contributed by NM, 7-Aug-1994.)  (Proof shortened
       by Wolf Lammen, 10-Dec-2017.) $)
    spimeh $p |- ( ph -> E. x ps ) $=
      ( wal wex weq wi a9ev eximii 19.35i syl ) AACGBCHEABCCDIABJCCDKFLMN $.
  $}

  ${
    $d x y $.
    spimw.1 $e |- ( -. ps -> A. x -. ps ) $.
    spimw.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization.  Lemma 8 of [KalishMontague] p. 87.  Uses only Tarski's
       FOL axiom schemes.  (Contributed by NM, 19-Apr-2017.)  (Proof shortened
       by Wolf Lammen, 7-Aug-2017.) $)
    spimw $p |- ( A. x ph -> ps ) $=
      ( weq wn wal wi ax9v spimfw ax-mp ) CDGHCIHACIBJCDKABCDEFLM $.
  $}

  ${
    $d x y $.  $d x ps $.
    spimvw.1 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization.  Lemma 8 of [KalishMontague] p. 87.  Uses only Tarski's
       FOL axiom schemes.  (Contributed by NM, 9-Apr-2017.) $)
    spimvw $p |- ( A. x ph -> ps ) $=
      ( wn ax-17 spimw ) ABCDBFCGEH $.
  $}

  ${
    $d x y $.  $d y ph $.
    spnfw.1 $e |- ( -. ph -> A. x -. ph ) $.
    $( Weak version of ~ sp .  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 1-Aug-2017.)  (Proof shortened by Wolf Lammen,
       13-Aug-2017.) $)
    spnfw $p |- ( A. x ph -> ph ) $=
      ( vy weq idd spimw ) AABDCBDEAFG $.
  $}

  ${
    sptruw.1 $e |- ph $.
    $( Version of ~ sp when ` ph ` is true.  Uses only Tarski's FOL axiom
       schemes.  (Contributed by NM, 23-Apr-1017.) $)
    sptruw $p |- ( A. x ph -> ph ) $=
      ( wal a1i ) AABDCE $.
  $}

  ${
    spfalw.1 $e |- -. ph $.
    $( Version of ~ sp when ` ph ` is false.  Uses only Tarski's FOL axiom
       schemes.  (Contributed by NM, 23-Apr-1017.)  (Proof shortened by Wolf
       Lammen, 25-Dec-2017.) $)
    spfalw $p |- ( A. x ph -> ph ) $=
      ( wn hbth spnfw ) ABADBCEF $.
  $}

  ${
    $d x y $.
    cbvaliw.1 $e |- ( A. x ph -> A. y A. x ph ) $.
    cbvaliw.2 $e |- ( -. ps -> A. x -. ps ) $.
    cbvaliw.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Change bound variable.  Uses only Tarski's FOL axiom schemes.  Part of
       Lemma 7 of [KalishMontague] p. 86.  (Contributed by NM, 19-Apr-2017.) $)
    cbvaliw $p |- ( A. x ph -> A. y ps ) $=
      ( wal spimw alrimih ) ACHBDEABCDFGIJ $.
  $}

  ${
    $d x y $.  $d x ps $.  $d y ph $.
    cbvalivw.1 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Change bound variable.  Uses only Tarski's FOL axiom schemes.  Part of
       Lemma 7 of [KalishMontague] p. 86.  (Contributed by NM, 9-Apr-2017.) $)
    cbvalivw $p |- ( A. x ph -> A. y ps ) $=
      ( wal spimvw alrimiv ) ACFBDABCDEGH $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Axiom scheme ax-8 (Equality)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Equality.  One of the equality and substitution axioms of
     predicate calculus with equality.  This is similar to, but not quite, a
     transitive law for equality (proved later as ~ equtr ).  This axiom scheme
     is a sub-scheme of Axiom Scheme B8 of system S2 of [Tarski], p. 75, whose
     general form cannot be represented with our notation.  Also appears as
     Axiom C7 of [Monk2] p. 105 and Axiom Scheme C8' in [Megill] p. 448 (p. 16
     of the preprint).

     The equality symbol was invented in 1527 by Robert Recorde.  He chose a
     pair of parallel lines of the same length because "noe .2. thynges, can be
     moare equalle."

     Note that this axiom is still valid even when any two or all three of
     ` x ` , ` y ` , and ` z ` are replaced with the same variable since they
     do not have any distinct variable (Metamath's $d) restrictions.  Because
     of this, we say that these three variables are "bundled" (a term coined by
     Raph Levien).  (Contributed by NM, 5-Aug-1993.) $)
  ax-8 $a |- ( x = y -> ( x = z -> y = z ) ) $.

  ${
    $d x y $.
    $( Identity law for equality.  Lemma 2 of [KalishMontague] p. 85.  See also
       Lemma 6 of [Tarski] p. 68.  (Contributed by NM, 1-Apr-2005.)  (Revised
       by NM, 9-Apr-2017.)  (Proof shortened by Wolf Lammen, 5-Feb-2018.) $)
    equid $p |- x = x $=
      ( vy weq wex a9ev ax-8 pm2.43i eximii ax17e ax-mp ) AACZBDKBACZKBBAELKBAA
      FGHKBIJ $.
  $}

  ${
    $d x y $.
    $( Obsolete proof of ~ equid as of 9-Dec-2017.  (Contributed by NM,
       1-Apr-2005.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    equidOLD $p |- x = x $=
      ( vy weq wn wal ax9v ax-8 pm2.43i con3i alimi mto ax-17 mt3 ) AACZNDZBEZP
      BACZDZBEBAFORBQNQNBAAGHIJKOBLM $.
  $}

  $( Bound-variable hypothesis builder for ` x = x ` .  This theorem tells us
     that any variable, including ` x ` , is effectively not free in
     ` x = x ` , even though ` x ` is technically free according to the
     traditional definition of free variable.  (Contributed by NM,
     13-Jan-2011.)  (Revised by NM, 21-Aug-2017.) $)
  nfequid $p |- F/ y x = x $=
    ( weq equid nfth ) AACBADE $.

  ${
    $d x w $.
    $( Commutative law for equality.  Lemma 3 of [KalishMontague] p. 85.  See
       also Lemma 7 of [Tarski] p. 69.  (Contributed by NM, 5-Aug-1993.)
       (Revised by NM, 9-Apr-2017.) $)
    equcomi $p |- ( x = y -> y = x ) $=
      ( weq equid ax-8 mpi ) ABCAACBACADABAEF $.
  $}

  $( Commutative law for equality.  (Contributed by NM, 20-Aug-1993.) $)
  equcom $p |- ( x = y <-> y = x ) $=
    ( weq equcomi impbii ) ABCBACABDBADE $.

  ${
    equcoms.1 $e |- ( x = y -> ph ) $.
    $( An inference commuting equality in antecedent.  Used to eliminate the
       need for a syllogism.  (Contributed by NM, 5-Aug-1993.) $)
    equcoms $p |- ( y = x -> ph ) $=
      ( weq equcomi syl ) CBEBCEACBFDG $.
  $}

  $( A transitive law for equality.  (Contributed by NM, 23-Aug-1993.) $)
  equtr $p |- ( x = y -> ( y = z -> x = z ) ) $=
    ( weq wi ax-8 equcoms ) BCDACDEBABACFG $.

  $( A transitive law for equality.  Lemma L17 in [Megill] p. 446 (p. 14 of the
     preprint).  (Contributed by NM, 23-Aug-1993.) $)
  equtrr $p |- ( x = y -> ( z = x -> z = y ) ) $=
    ( weq equtr com12 ) CADABDCBDCABEF $.

  $( An equivalence law for equality.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 10-Dec-2017.) $)
  equequ1 $p |- ( x = y -> ( x = z <-> y = z ) ) $=
    ( weq ax-8 equtr impbid ) ABDACDBCDABCEABCFG $.

  $( Obsolete version of ~ equequ1 as of 12-Nov-2017.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  equequ1OLD $p |- ( x = y -> ( x = z <-> y = z ) ) $=
    ( weq ax-8 wi equcomi syl impbid ) ABDZACDZBCDZABCEJBADLKFABGBACEHI $.

  $( An equivalence law for equality.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 4-Aug-2017.) $)
  equequ2 $p |- ( x = y -> ( z = x <-> z = y ) ) $=
    ( weq equequ1 equcom 3bitr3g ) ABDACDBCDCADCBDABCEACFBCFG $.

  $( One of the two equality axioms of standard predicate calculus, called
     reflexivity of equality.  (The other one is ~ stdpc7 .)  Axiom 6 of
     [Mendelson] p. 95.  Mendelson doesn't say why he prepended the redundant
     quantifier, but it was probably to be compatible with free logic (which is
     valid in the empty domain).  (Contributed by NM, 16-Feb-2005.) $)
  stdpc6 $p |- A. x x = x $=
    ( weq equid ax-gen ) AABAACD $.

  $( A transitive law for equality.  (Contributed by NM, 12-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 25-May-2011.) $)
  equtr2 $p |- ( ( x = z /\ y = z ) -> x = y ) $=
    ( weq wi equtrr equcoms impcom ) BCDACDZABDZIJECBCBAFGH $.

  $( Two equivalent ways of expressing ~ ax-12 .  See the comment for
     ~ ax-12 .  (Contributed by NM, 2-May-2017.)  (Proof shortened by Wolf
     Lammen, 26-Feb-2018.) $)
  ax12b $p |- ( ( -. x = y -> ( y = z -> A. x y = z ) )
     <-> ( -. x = y -> ( -. x = z -> ( y = z -> A. x y = z ) ) ) ) $=
    ( weq wn wal ax-1 equtrr equcoms con3rr3 imim1d pm2.43 syl6 impbid2 pm5.74i
    wi ) ABDZEZBCDZSAFZPZACDZEZUAPZRUAUDUAUCGRUDSUAPUARSUCUASUBQUBQPCBCBAHIJKST
    LMNO $.

  $( Obsolete version of ~ ax12b as of 12-Aug-2017.  (Contributed by NM,
     2-May-2017.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  ax12bOLD $p |- ( ( -. x = y -> ( y = z -> A. x y = z ) )
     <-> ( -. x = y -> ( -. x = z -> ( y = z -> A. x y = z ) ) ) ) $=
    ( weq wn wal wi wa bi2.04 equtrr equcoms con3d pm4.71d imbi1d pm5.74i bitri
    impexp ) ABDZEZBCDZTAFZGZGZSACDZEZHZUBGZSUEUBGGUCTUFUAGZGZUGUCTSUAGZGUISTUA
    ITUJUHTSUFUATSUETUDRUDRGCBCBAJKLMNOPTUFUAIPSUEUBQP $.

  ${
    $d x y $.
    spfw.1 $e |- ( -. ps -> A. x -. ps ) $.
    spfw.2 $e |- ( A. x ph -> A. y A. x ph ) $.
    spfw.3 $e |- ( -. ph -> A. y -. ph ) $.
    spfw.4 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ sp .  Uses only Tarski's FOL axiom schemes.  Lemma 9
       of [KalishMontague] p. 87.  This may be the best we can do with minimal
       distinct variable conditions.  TO DO:  Do we need this theorem?  If not,
       maybe it should be deleted.  (Contributed by NM, 19-Apr-2017.) $)
    spfw $p |- ( A. x ph -> ph ) $=
      ( wal wi ax-5 weq biimprd equcoms spimw syl56 biimpd mpg ) ACIZBJZSAJDSSD
      ITDIBDIAFSBDKBADCGBAJCDCDLZABHMNOPABCDEUAABHQOR $.
  $}

  ${
    $d x y $.  $d y ph $.
    spnfw.3 $e |- ( -. ph -> A. x -. ph ) $.
    $( Weak version of ~ sp .  Uses only Tarski's FOL axiom schemes.  Obsolete
       version of ~ spnfw as of 13-Aug-2017.  (Contributed by NM, 1-Aug-2017.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    spnfwOLD $p |- ( A. x ph -> ph ) $=
      ( vy wal ax-17 wn weq biidd spfw ) AABDCABEDFAGDFBDHAIJ $.
  $}

  ${
    19.8wOLD.1 $e |- ( ph -> A. x ph ) $.
    $( Obsolete version of ~ 19.8w as of 4-Dec-2017.  (Contributed by NM,
       1-Aug-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    19.8wOLD $p |- ( ph -> E. x ph ) $=
      ( wn wal wex notnot albii 3imtr3i spnfw con2i df-ex sylibr ) AADZBEZDABFO
      ANBAABENDZPBECAGZAPBQHIJKABLM $.
  $}

  ${
    $d x y $.  $d x ps $.  $d y ph $.
    spw.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of specialization scheme ~ sp .  Lemma 9 of
       [KalishMontague] p. 87.  While it appears that ~ sp in its general form
       does not follow from Tarski's FOL axiom schemes, from this theorem we
       can prove any instance of ~ sp having no wff metavariables and mutually
       distinct set variables (see ~ ax11wdemo for an example of the procedure
       to eliminate the hypothesis).  Other approximations of ~ sp are ~ spfw
       (minimal distinct variable requirements), ~ spnfw (when ` x ` is not
       free in ` -. ph ` ), ~ spvw (when ` x ` does not appear in ` ph ` ),
       ~ sptruw (when ` ph ` is true), and ~ spfalw (when ` ph ` is false).
       (Contributed by NM, 9-Apr-2017.)  (Proof shortened by Wolf Lammen,
       27-Feb-2018.) $)
    spw $p |- ( A. x ph -> ph ) $=
      ( wn ax-17 wal spfw ) ABCDBFCGACHDGAFDGEI $.
    $( Obsolete proof of ~ spw as of 27-Feb-2018.  (Contributed by NM,
       9-Apr-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    spwOLD $p |- ( A. x ph -> ph ) $=
      ( wal wi ax-17 ax-5 weq biimprd equcoms spimvw syl56 biimpd mpg ) ACFZBGZ
      QAGDQQDFRDFBDFAQDHQBDIBADCBAGCDCDJZABEKLMNABCDSABEOMP $.
  $}

  ${
    $d x y ph $.
    $( Obsolete version of ~ spvw as of 4-Dec-2017.  (Contributed by NM,
       10-Apr-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    spvwOLD $p |- ( A. x ph -> ph ) $=
      ( vy weq biidd spw ) AABCBCDAEF $.

    $( Obsolete version of ~ 19.3v as of 4-Dec-2017.  (Contributed by NM,
       1-Aug-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    19.3vOLD $p |- ( A. x ph <-> ph ) $=
      ( wal spvw ax-17 impbii ) ABCAABDABEF $.

    $( Obsolete version of ~ 19.9v as of 4-Dec-2017.  (Contributed by NM,
       28-May-1995.)  (Revised by NM, 1-Aug-2017.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    19.9vOLD $p |- ( E. x ph <-> ph ) $=
      ( wex wn wal df-ex 19.3v con2bii bitr4i ) ABCADZBEZDAABFKAJBGHI $.
  $}

  ${
    $d x ps $.
    exlimivOLD.1 $e |- ( ph -> ps ) $.
    $( Obsolete version of ~ exlimiv as of 4-Dec-2017.  (Contributed by NM,
       5-Aug-1993.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    exlimivOLD $p |- ( E. x ph -> ps ) $=
      ( wex eximi 19.9v sylib ) ACEBCEBABCDFBCGH $.
  $}

  ${
    $d x y $.  $d y ph $.
    spfalwOLD.1 $e |- -. ph $.
    $( Obsolete proof of ~ spfalw as of 25-Dec-2017.  (Contributed by NM,
       23-Apr-1017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    spfalwOLD $p |- ( A. x ph -> ph ) $=
      ( vy wfal wb weq bifal a1i spw ) AEBDAEFBDGACHIJ $.
  $}

  $( Obsolete version of ~ 19.2 as of 4-Dec-2017.  (Contributed by NM,
     2-Aug-2017.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  19.2OLD $p |- ( A. x ph -> E. x ph ) $=
    ( weq wn wal wex wi equid notnoti spfalw mt2 idd speimfw ax-mp ) BBCZDZBEZD
    ABEABFGQOBHZPBORIJKAABBOALMN $.

  ${
    $d x y $.
    cbvalw.1 $e |- ( A. x ph -> A. y A. x ph ) $.
    cbvalw.2 $e |- ( -. ps -> A. x -. ps ) $.
    cbvalw.3 $e |- ( A. y ps -> A. x A. y ps ) $.
    cbvalw.4 $e |- ( -. ph -> A. y -. ph ) $.
    cbvalw.5 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variable.  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 9-Apr-2017.) $)
    cbvalw $p |- ( A. x ph <-> A. y ps ) $=
      ( wal weq biimpd cbvaliw wi biimprd equcoms impbii ) ACJBDJABCDEFCDKZABIL
      MBADCGHBANCDRABIOPMQ $.
  $}

  ${
    $d x y $.  $d x ps $.  $d y ph $.
    cbvalvw.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variable.  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 9-Apr-2017.)  (Proof shortened by Wolf Lammen,
       28-Feb-2018.) $)
    cbvalvw $p |- ( A. x ph <-> A. y ps ) $=
      ( wal ax-17 wn cbvalw ) ABCDACFDGBHCGBDFCGAHDGEI $.

    $( Change bound variable.  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 9-Apr-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    cbvalvwOLD $p |- ( A. x ph <-> A. y ps ) $=
      ( wal weq biimpd cbvalivw wi biimprd equcoms impbii ) ACFBDFABCDCDGZABEHI
      BADCBAJCDNABEKLIM $.

    $( Change bound variable.  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 19-Apr-2017.) $)
    cbvexvw $p |- ( E. x ph <-> E. y ps ) $=
      ( wn wal wex weq notbid cbvalvw notbii df-ex 3bitr4i ) AFZCGZFBFZDGZFACHB
      DHPROQCDCDIABEJKLACMBDMN $.
  $}

  ${
    $d y z $.  $d x y $.  $d z ph $.  $d y ps $.
    alcomiw.1 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Weak version of ~ alcom .  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 10-Apr-2017.) $)
    alcomiw $p |- ( A. x A. y ph -> A. y A. x ph ) $=
      ( wal weq biimpd cbvalivw alimi ax-17 wi biimprd equcoms spimvw 3syl ) AD
      GZCGBEGZCGZTDGACGZDGRSCABDEDEHZABFIJKTDLTUADSACBAEDBAMDEUBABFNOPKKQ $.
  $}

  ${
    $d x y $.
    hbn1fw.1 $e |- ( A. x ph -> A. y A. x ph ) $.
    hbn1fw.2 $e |- ( -. ps -> A. x -. ps ) $.
    hbn1fw.3 $e |- ( A. y ps -> A. x A. y ps ) $.
    hbn1fw.4 $e |- ( -. ph -> A. y -. ph ) $.
    hbn1fw.5 $e |- ( -. A. y ps -> A. x -. A. y ps ) $.
    hbn1fw.6 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ ax-6 from which we can prove any ~ ax-6 instance not
       involving wff variables or bundling.  Uses only Tarski's FOL axiom
       schemes.  (Contributed by NM, 19-Apr-2017.)  (Proof shortened by Wolf
       Lammen, 28-Feb-2018.) $)
    hbn1fw $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
      ( wal wn cbvalw notbii biimpi biimpri alimi 3syl ) ACKZLZBDKZLZUBCKTCKTUB
      SUAABCDEFGHJMNZOIUBTCTUBUCPQR $.

    $( Obsolete proof of ~ hbn1fw as of 28-Feb-2018.  (Contributed by NM,
       19-Apr-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hbn1fwOLD $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
      ( wal wn cbvalw biimpri con3i biimpi alimi 3syl ) ACKZLZBDKZLZUBCKTCKUASS
      UAABCDEFGHJMZNOIUBTCSUASUAUCPOQR $.
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y $.
    hbn1w.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ hbn1 .  Uses only Tarski's FOL axiom schemes.
       (Contributed by NM, 9-Apr-2017.) $)
    hbn1w $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
      ( wal ax-17 wn hbn1fw ) ABCDACFDGBHCGBDFZCGAHDGJHCGEI $.

    $( Weak version of ~ hba1 .  See comments for ~ ax6w .  Uses only Tarski's
       FOL axiom schemes.  (Contributed by NM, 9-Apr-2017.) $)
    hba1w $p |- ( A. x ph -> A. x A. x ph ) $=
      ( wal wn weq wb cbvalvw a1i notbid spw con2i hbn1w con1i alimi 3syl ) ACF
      ZSGZCFZGZUBCFSCFUASTBDFZGZCDCDHZSUCSUCIUEABCDEJKLZMNTUDCDUFOUBSCSUAABCDEO
      PQR $.

    $( Weak version of ~ hbe1 .  See comments for ~ ax6w .  Uses only Tarski's
       FOL axiom schemes.  (Contributed by NM, 19-Apr-2017.) $)
    hbe1w $p |- ( E. x ph -> A. x E. x ph ) $=
      ( wex wn wal df-ex weq notbid hbn1w hbxfrbi ) ACFAGZCHGCACINBGCDCDJABEKLM
      $.
  $}

  ${
    $d x z $.  $d x y $.  $d z ph $.  $d x ps $.
    hbalw.1 $e |- ( x = z -> ( ph <-> ps ) ) $.
    hbalw.2 $e |- ( ph -> A. x ph ) $.
    $( Weak version of ~ hbal .  Uses only Tarski's FOL axiom schemes.  Unlike
       ~ hbal , this theorem requires that ` x ` and ` y ` be distinct i.e. are
       not bundled.  (Contributed by NM, 19-Apr-2017.) $)
    hbalw $p |- ( A. y ph -> A. x A. y ph ) $=
      ( wal alimi alcomiw syl ) ADHZACHZDHLCHAMDGIABDCEFJK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Membership predicate
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the membership predicate symbol. $)
  $c e. $. $( Stylized epsilon $)

  $( --- Start of patch to prevent connective overloading $)
  ${
    $v A $.
    $v B $.
    wcel.cA $f class A $.
    wcel.cB $f class B $.
    $( Extend wff definition to include the membership connective between
       classes.

       For a general discussion of the theory of classes, see
       ~ http://us.metamath.org/mpeuni/mmset.html#class .

       (The purpose of introducing ` wff A e. B ` here is to allow us to
       express i.e.  "prove" the ~ wel of predicate calculus in terms of the
       ~ wceq of set theory, so that we don't "overload" the ` e. ` connective
       with two syntax definitions.  This is done to prevent ambiguity that
       would complicate some Metamath parsers.  The class variables ` A ` and
       ` B ` are introduced temporarily for the purpose of this definition but
       otherwise not used in predicate calculus.  See ~ df-clab for more
       information on the set theory usage of ~ wcel .) $)
    wcel $a wff A e. B $.
  $}

  $( Extend wff definition to include atomic formulas with the epsilon
     (membership) predicate.  This is read " ` x ` is an element of
     ` y ` ," " ` x ` is a member of ` y ` ," " ` x ` belongs to ` y ` ,"
     or " ` y ` contains ` x ` ."  Note:  The phrase " ` y ` includes
     ` x ` " means " ` x ` is a subset of ` y ` ;" to use it also for
     ` x e. y ` , as some authors occasionally do, is poor form and causes
     confusion, according to George Boolos (1992 lecture at MIT).

     This syntactical construction introduces a binary non-logical predicate
     symbol ` e. ` (epsilon) into our predicate calculus.  We will eventually
     use it for the membership predicate of set theory, but that is irrelevant
     at this point: the predicate calculus axioms for ` e. ` apply to any
     arbitrary binary predicate symbol.  "Non-logical" means that the predicate
     is presumed to have additional properties beyond the realm of predicate
     calculus, although these additional properties are not specified by
     predicate calculus itself but rather by the axioms of a theory (in our
     case set theory) added to predicate calculus.  "Binary" means that the
     predicate has two arguments.

     (Instead of introducing ~ wel as an axiomatic statement, as was done in an
     older version of this database, we introduce it by "proving" a special
     case of set theory's more general ~ wcel .  This lets us avoid overloading
     the ` e. ` connective, thus preventing ambiguity that would complicate
     certain Metamath parsers.  However, logically ~ wel is considered to be a
     primitive syntax, even though here it is artificially "derived" from
     ~ wcel .  Note:  To see the proof steps of this syntax proof, type "show
     proof wel /all" in the Metamath program.)  (Contributed by NM,
     24-Jan-2006.) $)
  wel $p wff x e. y $=
    ( cv wcel ) ACBCD $.
  $( --- End of patch to prevent connective overloading $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include atomic formulas with the epsilon
     (membership) predicate.  This is read " ` x ` is an element of ` y ` ,"
     " ` x ` is a member of ` y ` ," " ` x ` belongs to ` y ` ," or " ` y `
     contains ` x ` ."  Note:  The phrase " ` y ` includes ` x ` " means
     " ` x ` is a subset of ` y ` "; to use it also for ` x e. y ` (as some
     authors occasionally do) is poor form and causes confusion.

     After we introduce ~ cv and ~ wcel in set theory, this syntax construction
     becomes redundant, since it can be derived with the proof
     "vx cv vy cv wcel". @)
  wel @a wff x e. y @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Register class-to-set promotion and class equality and membership as
     primitive expressions. Although these are actually definitions, the above
     ambiguity prevention necessitates our taking class equality as the
     primitive, instead of set equality. $)
  $( $j primitive 'weq' 'wel'; $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Axiom scheme ax-13 (Left Equality for Binary Predicate)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Left Equality for Binary Predicate.  One of the equality and
     substitution axioms for a non-logical predicate in our predicate calculus
     with equality.  It substitutes equal variables into the left-hand side of
     an arbitrary binary predicate ` e. ` , which we will use for the set
     membership relation when set theory is introduced.  This axiom scheme is a
     sub-scheme of Axiom Scheme B8 of system S2 of [Tarski], p. 75, whose
     general form cannot be represented with our notation.  Also appears as
     Axiom scheme C12' in [Megill] p. 448 (p. 16 of the preprint).
     "Non-logical" means that the predicate is not a primitive of predicate
     calculus proper but instead is an extension to it.  "Binary" means that
     the predicate has two arguments.  In a system of predicate calculus with
     equality, like ours, equality is not usually considered to be a
     non-logical predicate.  In systems of predicate calculus without equality,
     it typically would be.  (Contributed by NM, 5-Aug-1993.) $)
  ax-13 $a |- ( x = y -> ( x e. z -> y e. z ) ) $.

  $( An identity law for the non-logical predicate.  (Contributed by NM,
     5-Aug-1993.) $)
  elequ1 $p |- ( x = y -> ( x e. z <-> y e. z ) ) $=
    ( weq wel ax-13 wi equcoms impbid ) ABDACEZBCEZABCFKJGBABACFHI $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Axiom scheme ax-14 (Right Equality for Binary Predicate)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Right Equality for Binary Predicate.  One of the equality and
     substitution axioms for a non-logical predicate in our predicate calculus
     with equality.  It substitutes equal variables into the right-hand side of
     an arbitrary binary predicate ` e. ` , which we will use for the set
     membership relation when set theory is introduced.  This axiom scheme is a
     sub-scheme of Axiom Scheme B8 of system S2 of [Tarski], p. 75, whose
     general form cannot be represented with our notation.  Also appears as
     Axiom scheme C13' in [Megill] p. 448 (p. 16 of the preprint).
     (Contributed by NM, 5-Aug-1993.) $)
  ax-14 $a |- ( x = y -> ( z e. x -> z e. y ) ) $.

  $( An identity law for the non-logical predicate.  (Contributed by NM,
     5-Aug-1993.) $)
  elequ2 $p |- ( x = y -> ( z e. x <-> z e. y ) ) $=
    ( weq wel ax-14 wi equcoms impbid ) ABDCAEZCBEZABCFKJGBABACFHI $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Logical redundancy of ax-6 , ax-7 , ax-11 , ax-12
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  The orginal axiom schemes of Tarski's predicate calculus are ~ ax-5 ,
  ~ ax-17 , ~ ax9v , ~ ax-8 , ~ ax-13 , and ~ ax-14 , together with rule
  ~ ax-gen .  See ~ http://us.metamath.org/mpeuni/mmset.html#compare .  They
  are given as axiom schemes B4 through B8 in [KalishMontague] p. 81.  These
  are shown to be logically complete by Theorem 1 of [KalishMontague] p. 85.

  The axiom system of set.mm includes the auxiliary axiom schemes ~ ax-6 ,
  ~ ax-7 , ~ ax-12 , and ~ ax-11 , which are not part of Tarski's axiom
  schemes.  Each object language instance of them is provable from Tarski's
  axioms, so they are logically redundant.  However, they are conjectured not
  to be provable directly _as schemes_ from Tarski's axiom schemes using only
  Metamath's direct substitution rule.  They are used to make our system
  "metalogically complete" i.e. able to prove directly all possible schemes
  with wff and set metavariables, bundled or not, whose object-language
  instances are valid.  ( ~ ax-11 has been proved to be required; see
  ~ http://us.metamath.org/award2003.html#9a .  Metalogical independence of the
  other three are open problems.)

  (There are additional predicate calculus axiom schemes included in set.mm
  such as ~ ax-4 , but they can all be proved as theorems from the above.)

  Terminology:  Two set (individual) metavariables are "bundled" in an axiom or
  theorem scheme when there is no distinct variable constraint ($d) imposed on
  them.  (The term "bundled" is due to Raph Levien.)  For example, the ` x `
  and ` y ` in ~ ax-9 are bundled, but they are not in ~ ax9v . We also say
  that a scheme is bundled when it has at least one pair of bundled set
  metavariables.  If distinct variable conditions are added to all set
  metavariable pairs in a bundled scheme, we call that the "principal" instance
  of the bundled scheme.  For example, ~ ax9v is the principal instance of
  ~ ax-9 . Whenever a common variable is substituted for two or more bundled
  variables in an axiom or theorem scheme, we call the substitution instance
  "degenerate".  For example, the instance ` -. A. x -. x = x ` of ~ ax-9 is
  degenerate.  An advantage of bundling is ease of use since there are fewer
  distinct variable restrictions ($d) to be concerned with.  There is also a
  small economy in being able to state principal and degenerate instances
  simultaneously.  A disadvantage is that bundling may present difficulties in
  translations to other proof languages, which typically lack the concept (in
  part because their variables often represent the variables of the object
  language rather than metavariables ranging over them).

  Because Tarski's axiom schemes are logically complete, they can be used to
  prove any object-language instance of ~ ax-6 , ~ ax-7 , ~ ax-11 , and ~ ax-12
  . "Translating" this to Metamath, it means that Tarski's axioms can prove any
  substitution instance of ~ ax-6 , ~ ax-7 , ~ ax-11 , or ~ ax-12 in which (1)
  there are no wff metavariables and (2) all set metavariables are mutually
  distinct i.e. are not bundled.  In effect this is mimicking the object
  language by pretending that each set metavariable is an object-language
  variable.  (There may also be specific instances with wff metavariables
  and/or bundling that are directly provable from Tarski's axiom schemes, but
  it isn't guaranteed.  Whether all of them are possible is part of the still
  open metalogical independence problem for our additional axiom schemes.)

  It can be useful to see how this can be done, both to show that our
  additional schemes are valid metatheorems of Tarski's system and to be able
  to translate object language instances of our proofs into proofs that would
  work with a system using only Tarski's original schemes.  In addition, it may
  (or may not) provide insight into the conjectured metalogical independence of
  our additional schemes.

  The theorem schemes ~ ax6w , ~ ax7w , ~ ax11w , and ~ ax12w are derived using
  only Tarski's axiom schemes, showing that Tarski's schemes can be used to
  derive all substitution instances of ~ ax-6 , ~ ax-7 , ~ ax-11 , and ~ ax-12
  meeting conditions (1) and (2).  (The "w" suffix stands for "weak version".)
  Each hypothesis of ~ ax6w , ~ ax7w , and ~ ax11w is of the form
  ` ( x = y -> ( ph <-> ps ) ) ` where ` ps ` is an auxiliary or "dummy" wff
  metavariable in which ` x ` doesn't occur.  We can show by induction on
  formula length that the hypotheses can be eliminated in all cases meeting
  conditions (1) and (2).  The example ~ ax11wdemo illustrates the techniques
  (equality theorems and bound variable renaming) used to achieve this.

  We also show the degenerate instances for axioms with bundled variables in
  ~ ax7dgen , ~ ax11dgen , ~ ax12dgen1 , ~ ax12dgen2 , ~ ax12dgen3 , and
  ~ ax12dgen4 . (Their proofs are trivial, but we include them to be thorough.)
  Combining the principal and degenerate cases _outside_ of Metamath, we show
  that the bundled schemes ~ ax-6 , ~ ax-7 , ~ ax-11 , and ~ ax-12 are schemes
  of Tarski's system, meaning that all object language instances they generate
  are theorems of Tarski's system.

  It is interesting that Tarski used the bundled scheme ~ ax-9 in an older
  system, so it seems the main purpose of his later ~ ax9v was just to show
  that the weaker unbundled form is sufficient rather than an aesthetic
  objection to bundled free and bound variables.  Since we adopt the
  bundled ~ ax-9 as our official axiom, we  show that the degenerate
  instance holds in ~ ax9dgen .

  The case of ~ sp is curious:  originally an axiom of Tarski's system, it was
  proved logically redundant by Lemma 9 of [KalishMontague] p. 86.  However,
  the proof is by induction on formula length, and the scheme form
  ` A. x ph -> ph ` apparently cannot be proved directly from Tarski's other
  axiom schemes.  The best we can do seems to be ~ spw , again requiring
  substitution instances of ` ph ` that meet conditions (1) and (2) above.
  Note that our direct proof ~ sp requires ~ ax-11 , which is not part of
  Tarski's system.

$)

  ${
    $( Tarski's system uses the weaker ~ ax9v instead of the bundled ~ ax-9 ,
       so here we show that the degenerate case of ~ ax-9 can be derived.
       (Contributed by NM, 23-Apr-2017.) $)
    ax9dgen $p |- -. A. x -. x = x $=
      ( weq wn wal equid notnoti spfalw mt2 ) AABZCZADIAEZJAIKFGH $.
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y $.
    ax6w.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ ax-6 from which we can prove any ~ ax-6 instance not
       involving wff variables or bundling.  Uses only Tarski's FOL axiom
       schemes.  (Contributed by NM, 9-Apr-2017.) $)
    ax6w $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
      ( hbn1w ) ABCDEF $.
  $}

  ${
    $d y z $.  $d x y $.  $d z ph $.  $d y ps $.
    ax7w.1 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Weak version of ~ ax-7 from which we can prove any ~ ax-7 instance not
       involving wff variables or bundling.  Uses only Tarski's FOL axiom
       schemes.  Unlike ~ ax-7 , this theorem requires that ` x ` and ` y ` be
       distinct i.e. are not bundled.  (Contributed by NM, 10-Apr-2017.) $)
    ax7w $p |- ( A. x A. y ph -> A. y A. x ph ) $=
      ( alcomiw ) ABCDEFG $.
  $}

  $( Degenerate instance of ~ ax-7 where bundled variables ` x ` and ` y ` have
     a common substitution.  Uses only Tarski's FOL axiom schemes.
     (Contributed by NM, 13-Apr-2017.) $)
  ax7dgen $p |- ( A. x A. x ph -> A. x A. x ph ) $=
    ( wal id ) ABCBCD $.

  ${
    $d x ps $.
    ax11wlemw.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Lemma for weak version of ~ ax-11 .  Uses only Tarski's FOL axiom
       schemes.  In some cases, this lemma may lead to shorter proofs than
       ~ ax11w .  (Contributed by NM, 10-Apr-2017.) $)
    ax11wlem $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      ( ax-17 ax11i ) ABCDEBCFG $.
  $}

  ${
    $d y z $.  $d x ps $.  $d z ph $.  $d y ch $.
    ax11w.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    ax11w.2 $e |- ( y = z -> ( ph <-> ch ) ) $.
    $( Weak version of ~ ax-11 from which we can prove any ~ ax-11 instance not
       involving wff variables or bundling.  Uses only Tarski's FOL axiom
       schemes.  An instance of the first hypothesis will normally require that
       ` x ` and ` y ` be distinct (unless ` x ` does not occur in ` ph ` ).
       For an example of how the hypotheses can be eliminated when we
       substitute an expression without wff variables for ` ph ` , see
       ~ ax11wdemo .  (Contributed by NM, 10-Apr-2017.) $)
    ax11w $p |- ( x = y -> ( A. y ph -> A. x ( x = y -> ph ) ) ) $=
      ( wal weq wi spw ax11wlem syl5 ) AEIADEJZOAKDIACEFHLABDEGMN $.
  $}

  $( Degenerate instance of ~ ax-11 where bundled variables ` x ` and ` y `
     have a common substitution.  Uses only Tarski's FOL axiom schemes.
     (Contributed by NM, 13-Apr-2017.) $)
  ax11dgen $p |- ( x = x -> ( A. x ph -> A. x ( x = x -> ph ) ) ) $=
    ( wal weq wi ax-1 alimi a1i ) ABCBBDZAEZBCEIAJBAIFGH $.

  ${
    $d x y z w v $.
    $( Example of an application of ~ ax11w that results in an instance of
       ~ ax-11 for a contrived formula with mixed free and bound variables,
       ` ( x e. y /\ A. x z e. x /\ A. y A. z y e. x ) ` , in place of
       ` ph ` .  The proof illustrates bound variable renaming with ~ cbvalvw
       to obtain fresh variables to avoid distinct variable clashes.  Uses only
       Tarski's FOL axiom schemes.  (Contributed by NM, 14-Apr-2017.) $)
    ax11wdemo $p |- ( x = y
              -> ( A. y ( x e. y /\ A. x z e. x /\ A. y A. z y e. x )
     -> A. x ( x = y -> ( x e. y /\ A. x z e. x /\ A. y A. z y e. x ) ) ) ) $=
      ( vw vv wel wal w3a weq elequ1 elequ2 cbvalvw a1i albidv syl5bb 3anbi123d
      wb 3anbi13d ax11w ) ABFZCAFZAGZBAFZCGZBGZHBBFZCDFZDGZEBFZCGZEGZHAEFZUBEAF
      ZCGZEGZHABEABIZTUFUBUHUEUKABBJUBUHQUPUAUGADADCKLMUEUOUPUKUDUNBEBEIZUCUMCB
      EAJNLZUPUNUJEUPUMUICABEKNNOPUQTULUEUOUBBEAKUEUOQUQURMRS $.
  $}

  ${
    $d x y $.  $d x z $.
    $( Weak version (principal instance) of ~ ax-12 .  (Because ` y ` and ` z `
       don't need to be distinct, this actually bundles the principal instance
       and the degenerate instance
       ` ( -. x = y -> ( y = y -> A. x y = y ) ) ` .)  Uses only Tarski's FOL
       axiom schemes.  The proof is trivial but is included to complete the set
       ~ ax6w , ~ ax7w , and ~ ax11w .  (Contributed by NM, 10-Apr-2017.) $)
    ax12w $p |- ( -. x = y -> ( y = z -> A. x y = z ) ) $=
      ( weq wn a17d ) ABDEBCDAF $.
  $}

  $( Degenerate instance of ~ ax-12 where bundled variables ` x ` and ` y `
     have a common substitution.  Uses only Tarski's FOL axiom schemes.
     (Contributed by NM, 13-Apr-2017.) $)
  ax12dgen1 $p |- ( -. x = x -> ( x = z -> A. x x = z ) ) $=
    ( weq wal wi equid pm2.24i ) AACABCZHADEAFG $.

  $( Degenerate instance of ~ ax-12 where bundled variables ` x ` and ` z `
     have a common substitution.  Uses only Tarski's FOL axiom schemes.
     (Contributed by NM, 13-Apr-2017.) $)
  ax12dgen2 $p |- ( -. x = y -> ( y = x -> A. x y = x ) ) $=
    ( weq wn wal equcomi pm2.21 syl5 ) BACZABCZJDIAEZBAFJKGH $.

  $( Degenerate instance of ~ ax-12 where bundled variables ` y ` and ` z `
     have a common substitution.  Uses only Tarski's FOL axiom schemes.
     (Contributed by NM, 13-Apr-2017.) $)
  ax12dgen3 $p |- ( -. x = y -> ( y = y -> A. x y = y ) ) $=
    ( weq wn wal equid ax-gen a1ii ) ABCDBBCZIAEIABFGH $.

  $( Degenerate instance of ~ ax-12 where bundled variables ` x ` , ` y ` , and
     ` z ` have a common substitution.  Uses only Tarski's FOL axiom schemes .
     (Contributed by NM, 13-Apr-2017.) $)
  ax12dgen4 $p |- ( -. x = x -> ( x = x -> A. x x = x ) ) $=
    ( ax12dgen1 ) AAB $.


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
   Predicate calculus with equality:  Auxiliary axiom schemes (4 schemes)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  In this section we introduce four additional schemes ~ ax-6 , ~ ax-7 ,
  ~ ax-11 , and ~ ax-12 that are not part of Tarski's system but can be proved
  (outside of Metamath) as theorem schemes of Tarski's system.  These are
  needed to give our system the property of "metalogical completeness," which
  means that we can prove (with Metamath) all possible schemes expressible in
  our language of wff metavariables ranging over object-language wffs and set
  metavariables ranging over object-language individual variables.

  To show that these schemes are valid metatheorems of Tarski's system S2,
  above we proved from Tarski's system theorems ~ ax6w , ~ ax7w , ~ ax12w ,
  and ~ ax11w , which show that any object-language instance of these schemes
  (emulated by having no wff metavariables and requiring all set
  metavariables to be mutually distinct) can be proved using only the schemes
  in Tarski's system S2.

  An open problem is to show that these four additional schemes are mutually
  _metalogically_ independent and metalogically independent from Tarski's.  So
  far, independence of ~ ax-11 from all others has been shown, and
  independence of Tarski's ~ ax-9 from all others has been shown; see
  items 9a and 11 on ~ http://us.metamath.org/award2003.html .

$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Axiom scheme ax-6 (Quantified Negation)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Quantified Negation.  Axiom C5-2 of [Monk2] p. 113.  This axiom
     scheme is logically redundant (see ~ ax6w ) but is used as an auxiliary
     axiom to achieve metalogical completeness.  (Contributed by NM,
     5-Aug-1993.) $)
  ax-6 $a |- ( -. A. x ph -> A. x -. A. x ph ) $.

  $( ` x ` is not free in ` -. A. x ph ` .  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Wolf Lammen, 18-Aug-2014.) $)
  hbn1 $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
    ( ax-6 ) ABC $.

  $( ` x ` is not free in ` E. x ph ` .  (Contributed by NM, 5-Aug-1993.) $)
  hbe1 $p |- ( E. x ph -> A. x E. x ph ) $=
    ( wex wn wal df-ex hbn1 hbxfrbi ) ABCADZBEDBABFIBGH $.

  $( ` x ` is not free in ` E. x ph ` .  (Contributed by Mario Carneiro,
     11-Aug-2016.) $)
  nfe1 $p |- F/ x E. x ph $=
    ( wex hbe1 nfi ) ABCBABDE $.

  $( The analog in our predicate calculus of axiom 5 of modal logic S5.
     (Contributed by NM, 5-Oct-2005.) $)
  modal-5 $p |- ( -. A. x -. ph -> A. x -. A. x -. ph ) $=
    ( wn hbn1 ) ACBD $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Axiom scheme ax-7 (Quantifier Commutation)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Quantifier Commutation.  This axiom says universal quantifiers
     can be swapped.  Axiom scheme C6' in [Megill] p. 448 (p. 16 of the
     preprint).  Also appears as Lemma 12 of [Monk2] p. 109 and Axiom C5-3 of
     [Monk2] p. 113.  This axiom scheme is logically redundant (see ~ ax7w )
     but is used as an auxiliary axiom to achieve metalogical completeness.
     (Contributed by NM, 5-Aug-1993.) $)
  ax-7 $a |- ( A. x A. y ph -> A. y A. x ph ) $.

  ${
    a7s.1 $e |- ( A. x A. y ph -> ps ) $.
    $( Swap quantifiers in an antecedent.  (Contributed by NM, 5-Aug-1993.) $)
    a7s $p |- ( A. y A. x ph -> ps ) $=
      ( wal ax-7 syl ) ACFDFADFCFBADCGEH $.
  $}

  ${
    hbal.1 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` .
       (Contributed by NM, 5-Aug-1993.) $)
    hbal $p |- ( A. y ph -> A. x A. y ph ) $=
      ( wal alimi ax-7 syl ) ACEZABEZCEIBEAJCDFACBGH $.
  $}

  $( Theorem 19.5 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.) $)
  alcom $p |- ( A. x A. y ph <-> A. y A. x ph ) $=
    ( wal ax-7 impbii ) ACDBDABDCDABCEACBEF $.

  $( Theorem *11.21 in [WhiteheadRussell] p. 160.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  alrot3 $p |- ( A. x A. y A. z ph <-> A. y A. z A. x ph ) $=
    ( wal alcom albii bitri ) ADEZCEBEIBEZCEABEDEZCEIBCFJKCABDFGH $.

  $( Rotate 4 universal quantifiers twice.  (Contributed by NM, 2-Feb-2005.)
     (Proof shortened by Fan Zheng, 6-Jun-2016.) $)
  alrot4 $p |- ( A. x A. y A. z A. w ph <-> A. z A. w A. x A. y ph ) $=
    ( wal alrot3 albii bitri ) AEFDFCFZBFACFZEFDFZBFKBFEFDFJLBACDEGHKBDEGI $.

  ${
    hbald.1 $e |- ( ph -> A. y ph ) $.
    hbald.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbal .
       (Contributed by NM, 2-Jan-2002.) $)
    hbald $p |- ( ph -> ( A. y ps -> A. x A. y ps ) ) $=
      ( wal alimdh ax-7 syl6 ) ABDGZBCGZDGKCGABLDEFHBDCIJ $.
  $}

  $( Theorem 19.11 of [Margaris] p. 89.  Revised to remove dependency on
     ~ ax-11 , ~ ax-6 , ~ ax-9 , ~ ax-8 and ~ ax-17 .  (Contributed by NM,
     5-Aug-1993.)  (Revised by Wolf Lammen, 8-Jan-2018.) $)
  excom $p |- ( E. x E. y ph <-> E. y E. x ph ) $=
    ( wn wal wex alcom notbii exnal 3bitr4i df-ex exbii ) ADZCEZDZBFZMBEZDZCFZA
    CFZBFABFZCFNBEZDQCEZDPSUBUCMBCGHNBIQCIJTOBACKLUARCABKLJ $.

  $( One direction of Theorem 19.11 of [Margaris] p. 89.  Revised to remove
     dependency on ~ ax-11 , ~ ax-6 , ~ ax-9 , ~ ax-8 and ~ ax-17 .
     (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
     24-Sep-2016.)  (Revised by Wolf Lammen, 8-Jan-2018.) $)
  excomim $p |- ( E. x E. y ph -> E. y E. x ph ) $=
    ( wex excom biimpi ) ACDBDABDCDABCEF $.

  $( Swap 1st and 3rd existential quantifiers.  (Contributed by NM,
     9-Mar-1995.) $)
  excom13 $p |- ( E. x E. y E. z ph <-> E. z E. y E. x ph ) $=
    ( wex excom exbii 3bitri ) ADEZCEBEIBEZCEABEZDEZCEKCEDEIBCFJLCABDFGKCDFH $.

  $( Rotate existential quantifiers.  (Contributed by NM, 17-Mar-1995.) $)
  exrot3 $p |- ( E. x E. y E. z ph <-> E. y E. z E. x ph ) $=
    ( wex excom13 excom bitri ) ADECEBEABEZCEDEIDECEABCDFIDCGH $.

  $( Rotate existential quantifiers twice.  (Contributed by NM, 9-Mar-1995.) $)
  exrot4 $p |- ( E. x E. y E. z E. w ph <-> E. z E. w E. x E. y ph ) $=
    ( wex excom13 exbii bitri ) AEFDFCFZBFACFZDFEFZBFKBFEFDFJLBACDEGHKBEDGI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Axiom scheme ax-11 (Substitution)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Substitution.  One of the 5 equality axioms of predicate
     calculus.  The final consequent ` A. x ( x = y -> ph ) ` is a way of
     expressing " ` y ` substituted for ` x ` in wff ` ph ` " (cf. ~ sb6 ).  It
     is based on Lemma 16 of [Tarski] p. 70 and Axiom C8 of [Monk2] p. 105,
     from which it can be proved by cases.

     The original version of this axiom was ~ ax-11o ("o" for "old") and was
     replaced with this shorter ~ ax-11 in Jan. 2007.  The old axiom is proved
     from this one as theorem ~ ax11o .  Conversely, this axiom is proved from
     ~ ax-11o as theorem ~ ax11 .

     Juha Arpiainen proved the metalogical independence of this axiom (in the
     form of the older axiom ~ ax-11o ) from the others on 19-Jan-2006.  See
     item 9a at ~ http://us.metamath.org/award2003.html .

     See ~ ax11v and ~ ax11v2 for other equivalents of this axiom that (unlike
     this axiom) have distinct variable restrictions.

     This axiom scheme is logically redundant (see ~ ax11w ) but is used as an
     auxiliary axiom to achieve metalogical completeness.  (Contributed by NM,
     22-Jan-2007.) $)
  ax-11 $a |- ( x = y -> ( A. y ph -> A. x ( x = y -> ph ) ) ) $.

  ${
    $d x w $.  $d w ph $.
    $( If a wff is true, it is true for at least one instance.  Special case of
       Theorem 19.8 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Wolf Lammen, 13-Jan-2018.) $)
    19.8a $p |- ( ph -> E. x ph ) $=
      ( vw weq wex wi a9ev wal ax-17 ax-11 exim mpi syl56 equcoms exlimiv ax-mp
      ) CBDZCEAABEZFZCBGQSCSBCAACHBCDZTAFBHZRACIABCJUATBERBCGTABKLMNOP $.
  $}

  ${
    $( Specialization.  A universally quantified wff implies the wff without a
       quantifier Axiom scheme B5 of [Tarski] p. 67 (under his system S2,
       defined in the last paragraph on p. 77).  Also appears as Axiom scheme
       C5' in [Megill] p. 448 (p. 16 of the preprint).

       For the axiom of specialization presented in many logic textbooks, see
       theorem ~ stdpc4 .

       This theorem shows that our obsolete axiom ~ ax-4 can be derived from
       the others.  The proof uses ideas from the proof of Lemma 21 of [Monk2]
       p. 114.

       It appears that this scheme cannot be derived directly from Tarski's
       axioms without auxilliary axiom scheme ~ ax-11 .  It is thought the best
       we can do using only Tarski's axioms is ~ spw .  (Contributed by NM,
       21-May-2008.)  (Proof shortened by Scott Fenton, 24-Jan-2011.)  (Proof
       shortened by Wolf Lammen, 13-Jan-2018.) $)
    sp $p |- ( A. x ph -> ph ) $=
      ( wal wn wex alex 19.8a con1i sylbi ) ABCADZBEZDAABFAKJBGHI $.
  $}

  ${
    $d x w $.  $d w ph $.
    $( Obsolete proof of ~ sp as of 23-Dec-2017.  (Contributed by NM,
       21-May-2008.)  (Proof shortened by Scott Fenton, 24-Jan-2011.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    spOLD $p |- ( A. x ph -> ph ) $=
      ( vw wal wi weq wn ax9v equcomi ax-17 ax-11 syl2im con2 al2imi mtoi con4d
      syl6 con3i alrimiv mt3 ) ABDZAEZCBFZGZCDCBHUBGUDCUCUBUCAUAUCAGZBCFZUEEZBD
      ZUAGUCUFUEUECDUHCBIUECJUEBCKLUHUAUFGZBDBCHUGAUIBUFAMNOQPRST $.
  $}

  $( Show that the original axiom ~ ax-5o can be derived from ~ ax-5 and
     others.  See ~ ax5 for the rederivation of ~ ax-5 from ~ ax-5o .

     Part of the proof is based on the proof of Lemma 22 of [Monk2] p. 114.
     (Contributed by NM, 21-May-2008.)  (Proof modification is discouraged.) $)
  ax5o $p |- ( A. x ( A. x ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    ( wal wi wn sp con2i hbn1 con1i alimi 3syl ax-5 syl5 ) ACDZOCDZOBECDBCDOOFZ
    CDZFZSCDPROQCGHQCISOCORACIJKLOBCMN $.

  $( Show that the original axiom ~ ax-6o can be derived from ~ ax-6 and
     others.  See ~ ax6 for the rederivation of ~ ax-6 from ~ ax-6o .

     Normally, ~ ax6o should be used rather than ~ ax-6o , except by theorems
     specifically studying the latter's properties.  (Contributed by NM,
     21-May-2008.) $)
  ax6o $p |- ( -. A. x -. A. x ph -> ph ) $=
    ( wal wn sp ax-6 nsyl4 ) ABCZAHDBCABEABFG $.

  $( Abbreviated version of ~ ax6o .  (Contributed by NM, 5-Aug-1993.) $)
  a6e $p |- ( E. x A. x ph -> ph ) $=
    ( wal wex wn df-ex ax6o sylbi ) ABCZBDIEBCEAIBFABGH $.

  $( The analog in our predicate calculus of the Brouwer axiom (B) of modal
     logic S5.  (Contributed by NM, 5-Oct-2005.) $)
  modal-b $p |- ( ph -> A. x -. A. x -. ph ) $=
    ( wn wal ax6o con4i ) ACZBDCBDAGBEF $.

  ${
    spi.1 $e |- A. x ph $.
    $( Inference rule reversing generalization.  (Contributed by NM,
       5-Aug-1993.) $)
    spi $p |- ph $=
      ( wal sp ax-mp ) ABDACABEF $.
  $}

  ${
    sps.1 $e |- ( ph -> ps ) $.
    $( Generalization of antecedent.  (Contributed by NM, 5-Aug-1993.) $)
    sps $p |- ( A. x ph -> ps ) $=
      ( wal sp syl ) ACEABACFDG $.
  $}

  ${
    spsd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction generalizing antecedent.  (Contributed by NM, 17-Aug-1994.) $)
    spsd $p |- ( ph -> ( A. x ps -> ch ) ) $=
      ( wal sp syl5 ) BDFBACBDGEH $.
  $}

  $( If a wff is true, it is true for at least one instance.  Special case of
     Theorem 19.8 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  19.8aOLD $p |- ( ph -> E. x ph ) $=
    ( wn wal wex sp con2i df-ex sylibr ) AACZBDZCABEKAJBFGABHI $.

  $( Theorem 19.2 of [Margaris] p. 89, generalized to use two set variables.
     (Contributed by O'Cat, 31-Mar-2008.) $)
  19.2g $p |- ( A. x ph -> E. y ph ) $=
    ( wex 19.8a sps ) AACDBACEF $.

  ${
    19.21bi.1 $e |- ( ph -> A. x ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.21bi $p |- ( ph -> ps ) $=
      ( wal sp syl ) ABCEBDBCFG $.
  $}

  ${
    19.23bi.1 $e |- ( E. x ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.23bi $p |- ( ph -> ps ) $=
      ( wex 19.8a syl ) AACEBACFDG $.
  $}

  ${
    nexr.1 $e |- -. E. x ph $.
    $( Inference from ~ 19.8a .  (Contributed by Jeff Hankins, 26-Jul-2009.) $)
    nexr $p |- -. ph $=
      ( wex 19.8a mto ) AABDCABEF $.
  $}

  $( Consequence of the definition of not-free.  (Contributed by Mario
     Carneiro, 26-Sep-2016.) $)
  nfr $p |- ( F/ x ph -> ( ph -> A. x ph ) ) $=
    ( wnf wal wi df-nf sp sylbi ) ABCAABDEZBDIABFIBGH $.

  ${
    nfri.1 $e |- F/ x ph $.
    $( Consequence of the definition of not-free.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    nfri $p |- ( ph -> A. x ph ) $=
      ( wnf wal wi nfr ax-mp ) ABDAABEFCABGH $.
  $}

  ${
    nfrd.1 $e |- ( ph -> F/ x ps ) $.
    $( Consequence of the definition of not-free in a context.  (Contributed by
       Mario Carneiro, 11-Aug-2016.) $)
    nfrd $p |- ( ph -> ( ps -> A. x ps ) ) $=
      ( wnf wal wi nfr syl ) ABCEBBCFGDBCHI $.
  $}

  ${
    alimd.1 $e |- F/ x ph $.
    alimd.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.20 of [Margaris] p. 90.  (Contributed by Mario
       Carneiro, 24-Sep-2016.) $)
    alimd $p |- ( ph -> ( A. x ps -> A. x ch ) ) $=
      ( nfri alimdh ) ABCDADEGFH $.
  $}

  ${
    alrimi.1 $e |- F/ x ph $.
    alrimi.2 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Contributed by Mario
       Carneiro, 24-Sep-2016.) $)
    alrimi $p |- ( ph -> A. x ps ) $=
      ( nfri alrimih ) ABCACDFEG $.
  $}

  ${
    nfd.1 $e |- F/ x ph $.
    nfd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduce that ` x ` is not free in ` ps ` in a context.  (Contributed by
       Mario Carneiro, 24-Sep-2016.) $)
    nfd $p |- ( ph -> F/ x ps ) $=
      ( wal wi wnf alrimi df-nf sylibr ) ABBCFGZCFBCHALCDEIBCJK $.
  $}

  ${
    nfdh.1 $e |- ( ph -> A. x ph ) $.
    nfdh.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduce that ` x ` is not free in ` ps ` in a context.  (Contributed by
       Mario Carneiro, 24-Sep-2016.) $)
    nfdh $p |- ( ph -> F/ x ps ) $=
      ( nfi nfd ) ABCACDFEG $.
  $}

  ${
    alrimdd.1 $e |- F/ x ph $.
    alrimdd.2 $e |- ( ph -> F/ x ps ) $.
    alrimdd.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.21 of [Margaris] p. 90.  (Contributed by Mario
       Carneiro, 24-Sep-2016.) $)
    alrimdd $p |- ( ph -> ( ps -> A. x ch ) ) $=
      ( wal nfrd alimd syld ) ABBDHCDHABDFIABCDEGJK $.
  $}

  ${
    alrimd.1 $e |- F/ x ph $.
    alrimd.2 $e |- F/ x ps $.
    alrimd.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.21 of [Margaris] p. 90.  (Contributed by Mario
       Carneiro, 24-Sep-2016.) $)
    alrimd $p |- ( ph -> ( ps -> A. x ch ) ) $=
      ( wnf a1i alrimdd ) ABCDEBDHAFIGJ $.
  $}

  ${
    eximd.1 $e |- F/ x ph $.
    eximd.2 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Contributed by Mario
       Carneiro, 24-Sep-2016.) $)
    eximd $p |- ( ph -> ( E. x ps -> E. x ch ) ) $=
      ( nfri eximdh ) ABCDADEGFH $.
  $}

  ${
    nexd.1 $e |- F/ x ph $.
    nexd.2 $e |- ( ph -> -. ps ) $.
    $( Deduction for generalization rule for negated wff.  (Contributed by
       Mario Carneiro, 24-Sep-2016.) $)
    nexd $p |- ( ph -> -. E. x ps ) $=
      ( nfri nexdh ) ABCACDFEG $.
  $}

  ${
    albid.1 $e |- F/ x ph $.
    albid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for universal quantifier (deduction rule).
       (Contributed by Mario Carneiro, 24-Sep-2016.) $)
    albid $p |- ( ph -> ( A. x ps <-> A. x ch ) ) $=
      ( nfri albidh ) ABCDADEGFH $.
  $}

  ${
    exbid.1 $e |- F/ x ph $.
    exbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for existential quantifier (deduction rule).
       (Contributed by Mario Carneiro, 24-Sep-2016.) $)
    exbid $p |- ( ph -> ( E. x ps <-> E. x ch ) ) $=
      ( nfri exbidh ) ABCDADEGFH $.
  $}

  ${
    nfbidf.1 $e |- F/ x ph $.
    nfbidf.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( An equality theorem for effectively not free.  (Contributed by Mario
       Carneiro, 4-Oct-2016.) $)
    nfbidf $p |- ( ph -> ( F/ x ps <-> F/ x ch ) ) $=
      ( wal wi wnf albid imbi12d df-nf 3bitr4g ) ABBDGZHZDGCCDGZHZDGBDICDIAOQDE
      ABCNPFABCDEFJKJBDLCDLM $.
  $}

  ${
    19.3.1 $e |- F/ x ph $.
    $( A wff may be quantified with a variable not free in it.  Theorem 19.3 of
       [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.)  (Revised by Mario
       Carneiro, 24-Sep-2016.) $)
    19.3 $p |- ( A. x ph <-> ph ) $=
      ( wal sp nfri impbii ) ABDAABEABCFG $.
  $}

  $( A closed version of ~ 19.9 .  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 3-Mar-2018.) $)
  19.9ht $p |- ( A. x ( ph -> A. x ph ) -> ( E. x ph -> ph ) ) $=
    ( wal wi wex exim a6e syl6 ) AABCZDBCABEIBEAAIBFABGH $.

  $( A closed version of ~ 19.9 .  (Contributed by NM, 5-Aug-1993.)  (Revised
     by Mario Carneiro, 24-Sep-2016.)  (Proof shortended by Wolf Lammen,
     30-Dec-2017.) $)
  19.9t $p |- ( F/ x ph -> ( E. x ph <-> ph ) ) $=
    ( wnf wex wal wi df-nf 19.9ht sylbi 19.8a impbid1 ) ABCZABDZALAABEFBEMAFABG
    ABHIABJK $.

  ${
    19.9h.1 $e |- ( ph -> A. x ph ) $.
    $( A wff may be existentially quantified with a variable not free in it.
       Theorem 19.9 of [Margaris] p. 89.  (Contributed by FL, 24-Mar-2007.)
       (Proof shortened by Wolf Lammen, 5-Jan-2018.) $)
    19.9h $p |- ( E. x ph <-> ph ) $=
      ( wnf wex wb nfi 19.9t ax-mp ) ABDABEAFABCGABHI $.

    $( Obsolete proof of ~ 19.9h as of 5-Jan-2018.  (Contributed by FL,
       24-Mar-2007.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    19.9hOLD $p |- ( E. x ph <-> ph ) $=
      ( wex wal wi 19.9ht mpg 19.8a impbii ) ABDZAAABEFKAFBABGCHABIJ $.
  $}

  ${
    19.9d.1 $e |- ( ps -> F/ x ph ) $.
    $( A deduction version of one direction of ~ 19.9 .  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 24-Sep-2016.) $)
    19.9d $p |- ( ps -> ( E. x ph -> ph ) ) $=
      ( wex wnf wb 19.9t syl biimpd ) BACEZABACFKAGDACHIJ $.
  $}

  ${
    19.9.1 $e |- F/ x ph $.
    $( A wff may be existentially quantified with a variable not free in it.
       Theorem 19.9 of [Margaris] p. 89.  (Contributed by FL, 24-Mar-2007.)
       (Revised by Mario Carneiro, 24-Sep-2016.)  (Proof shortened by Wolf
       Lammen, 30-Dec-2017.) $)
    19.9 $p |- ( E. x ph <-> ph ) $=
      ( nfri 19.9h ) ABABCDE $.

    $( Obsolete proof of ~ 19.9 as of 30-Dec-2017.  (Contributed by FL,
       24-Mar-2007.)  (Revised by Mario Carneiro, 24-Sep-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    19.9OLD $p |- ( E. x ph <-> ph ) $=
      ( wnf wex wb 19.9t ax-mp ) ABDABEAFCABGH $.
  $}

  $( Closed theorem version of bound-variable hypothesis builder ~ hbn .
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
     3-Mar-2018.) $)
  hbnt $p |- ( A. x ( ph -> A. x ph ) -> ( -. ph -> A. x -. ph ) ) $=
    ( wal wi wn wex df-ex 19.9ht syl5bir con1d ) AABCDBCZAEBCZALEABFKAABGABHIJ
    $.

  $( Obsolete proof of ~ hbnt as of 3-Mar-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  hbntOLD $p |- ( A. x ( ph -> A. x ph ) -> ( -. ph -> A. x -. ph ) ) $=
    ( wn wal wi ax6o con1i con3 al2imi syl5 ) ACZABDZCZBDZALEZBDKBDNAABFGOMKBAL
    HIJ $.

  ${
    hbn.1 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` -. ph ` .
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       17-Dec-2017.) $)
    hbn $p |- ( -. ph -> A. x -. ph ) $=
      ( wal wi wn hbnt mpg ) AABDEAFZIBDEBABGCH $.

    $( Obsolete proof of ~ hbn as of 16-Dec-2017.  (Contributed by NM,
       5-Aug-1993.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hbnOLD $p |- ( -. ph -> A. x -. ph ) $=
      ( wn wal sp con3i hbn1 alrimih syl ) ADZABEZDZKBELAABFGMKBABHALCGIJ $.
  $}

  $( Obsolete proof of ~ 19.9ht as of 3-Mar-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  19.9htOLD $p |- ( A. x ( ph -> A. x ph ) -> ( E. x ph -> ph ) ) $=
    ( wex wn wal wi df-ex hbnt con1d syl5bi ) ABCADBEZDAABEFBEZAABGLAKABHIJ $.

  $( ` x ` is not free in ` A. x ph ` .  Example in Appendix in [Megill] p. 450
     (p. 19 of the preprint).  Also Lemma 22 of [Monk2] p. 114.  (Contributed
     by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 15-Dec-2017.) $)
  hba1 $p |- ( A. x ph -> A. x A. x ph ) $=
    ( wal wn wex alex hbe1 hbn hbxfrbi ) ABCADZBEZDBABFKBJBGHI $.

  $( Obsolete proof of ~ hba1 as of 15-Dec-2017 (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  hba1OLD $p |- ( A. x ph -> A. x A. x ph ) $=
    ( wal wn sp con2i hbn1 con1i alimi 3syl ) ABCZKDZBCZDZNBCKBCMKLBEFLBGNKBKMA
    BGHIJ $.

  $( ` x ` is not free in ` A. x ph ` .  (Contributed by Mario Carneiro,
     11-Aug-2016.) $)
  nfa1 $p |- F/ x A. x ph $=
    ( wal hba1 nfi ) ABCBABDE $.

  ${
    a5i.1 $e |- ( A. x ph -> ps ) $.
    $( Inference version of ~ ax5o .  (Contributed by NM, 5-Aug-1993.) $)
    a5i $p |- ( A. x ph -> A. x ps ) $=
      ( wal nfa1 alrimi ) ACEBCACFDG $.
  $}

  $( ` x ` is not free in ` F/ x ph ` .  (Contributed by Mario Carneiro,
     11-Aug-2016.) $)
  nfnf1 $p |- F/ x F/ x ph $=
    ( wnf wal wi df-nf nfa1 nfxfr ) ABCAABDEZBDBABFIBGH $.

  ${
    nfnd.1 $e |- ( ph -> F/ x ps ) $.
    $( If in a context ` x ` is not free in ` ps ` , it is not free in
       ` -. ps ` .  (Contributed by Mario Carneiro, 24-Sep-2016.)  (Proof
       shortened by Wolf Lammen, 28-Dec-2017.) $)
    nfnd $p |- ( ph -> F/ x -. ps ) $=
      ( wnf wn nfnf1 wal wi df-nf hbnt sylbi nfd syl ) ABCEZBFZCEDOPCBCGOBBCHIC
      HPPCHIBCJBCKLMN $.

    $( Obsolete proof of ~ nfnd as of 28-Dec-2017.  (Contributed by Mario
       Carneiro, 24-Sep-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfndOLD $p |- ( ph -> F/ x -. ps ) $=
      ( wnf wn nfnf1 wal ax6o con1i wi df-nf con3 al2imi sylbi syl5 nfd syl ) A
      BCEZBFZCEDSTCBCGTBCHZFZCHZSTCHZUCBBCIJSBUAKZCHUCUDKBCLUEUBTCBUAMNOPQR $.

  $}

  ${
    nfn.1 $e |- F/ x ph $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` -. ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfn $p |- F/ x -. ph $=
      ( wn wnf wtru a1i nfnd trud ) ADBEFABABEFCGHI $.
  $}

  $( A convenience theorem particularly designed to remove dependencies on
     ~ ax-7 in conjunction with disjunctors.  (Contributed by Wolf Lammen,
     2-Sep-2018.) $)
  nfna1 $p |- F/ x -. A. x ph $=
    ( wal nfa1 nfn ) ABCBABDE $.

  $( Theorem 19.38 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
     (Revised by Wolf Lammen, 2-Jan-2018.) $)
  19.38 $p |- ( ( E. x ph -> A. x ps ) -> A. x ( ph -> ps ) ) $=
    ( wex wal wi wn alnex pm2.21 alimi sylbir ax-1 ja ) ACDZBCEABFZCEZNGAGZCEPA
    CHQOCABIJKBOCBALJM $.

  $( Closed form of Theorem 19.21 of [Margaris] p. 90.  (Contributed by NM,
     27-May-1997.)  (Revised by Mario Carneiro, 24-Sep-2016.)  (Proof shortened
     by Wolf Lammen, 3-Jan-2018.) $)
  19.21t $p |- ( F/ x ph -> ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) ) $=
    ( wnf wi wal nfr ax-5 syl9 wex 19.9t imbi1d 19.38 syl6bir impbid ) ACDZABEC
    FZABCFZEZPAACFQRACGABCHIPSACJZREQPTARACKLABCMNO $.

  ${
    19.21.1 $e |- F/ x ph $.
    $( Theorem 19.21 of [Margaris] p. 90.  The hypothesis can be thought of
       as " ` x ` is not free in ` ph ` ."  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 24-Sep-2016.) $)
    19.21 $p |- ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) $=
      ( wnf wi wal wb 19.21t ax-mp ) ACEABFCGABCGFHDABCIJ $.
  $}

  ${
    19.21h.1 $e |- ( ph -> A. x ph ) $.
    $( Theorem 19.21 of [Margaris] p. 90.  The hypothesis can be thought of
       as " ` x ` is not free in ` ph ` ."  (Contributed by NM, 1-Aug-2017.)
       (Proof shortened by Wolf Lammen, 1-Jan-2018.) $)
    19.21h $p |- ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) $=
      ( nfi 19.21 ) ABCACDEF $.
  $}

  ${
    stdpc5.1 $e |- F/ x ph $.
    $( An axiom scheme of standard predicate calculus that emulates Axiom 5 of
       [Mendelson] p. 69.  The hypothesis ` F/ x ph ` can be thought of as
       emulating " ` x ` is not free in ` ph ` ."  With this definition, the
       meaning of "not free" is less restrictive than the usual textbook
       definition; for example ` x ` would not (for us) be free in ` x = x ` by
       ~ nfequid .  This theorem scheme can be proved as a metatheorem of
       Mendelson's axiom system, even though it is slightly stronger than his
       Axiom 5.  (Contributed by NM, 22-Sep-1993.)  (Revised by Mario Carneiro,
       12-Oct-2016.)  (Proof shortened by Wolf Lammen, 1-Jan-2018.) $)
    stdpc5 $p |- ( A. x ( ph -> ps ) -> ( ph -> A. x ps ) ) $=
      ( wi wal 19.21 biimpi ) ABECFABCFEABCDGH $.

    $( Obsolete proof of ~ stdpc5 as of 1-Jan-2018.  (Contributed by NM,
       22-Sep-1993.)  (Revised by Mario Carneiro, 12-Oct-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    stdpc5OLD $p |- ( A. x ( ph -> ps ) -> ( ph -> A. x ps ) ) $=
      ( wal wi nfri alim syl5 ) AACEABFCEBCEACDGABCHI $.
  $}

  $( Closed form of Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM,
     7-Nov-2005.)  (Proof shortened by Wolf Lammen, 2-Jan-2018.) $)
  19.23t $p |- ( F/ x ps -> ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) ) $=
    ( wnf wi wal wex exim 19.9t biimpd syl9r nfr imim2d 19.38 syl6 impbid ) BCD
    ZABECFZACGZBEZRSBCGZQBABCHQUABBCIJKQTSBCFZERQBUBSBCLMABCNOP $.

  ${
    19.23.1 $e |- F/ x ps $.
    $( Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 24-Sep-2016.) $)
    19.23 $p |- ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) $=
      ( wnf wi wal wex wb 19.23t ax-mp ) BCEABFCGACHBFIDABCJK $.
  $}

  ${
    19.23h.1 $e |- ( ps -> A. x ps ) $.
    $( Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 24-Sep-2016.)  (Proof shortened by Wolf
       Lammen, 1-Jan-2018.) $)
    19.23h $p |- ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) $=
      ( nfi 19.23 ) ABCBCDEF $.
  $}

  ${
    exlimi.1 $e |- F/ x ps $.
    exlimi.2 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Contributed by Mario
       Carneiro, 24-Sep-2016.) $)
    exlimi $p |- ( E. x ph -> ps ) $=
      ( wi wex 19.23 mpgbi ) ABFACGBFCABCDHEI $.
  $}

  ${
    exlimih.1 $e |- ( ps -> A. x ps ) $.
    exlimih.2 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 13-May-2011.)  (Proof
       shortened by Wolf Lammen, 1-Jan-2018.) $)
    exlimih $p |- ( E. x ph -> ps ) $=
      ( nfi exlimi ) ABCBCDFEG $.

    $( Obsolete proof of ~ exlimih as of 1-Jan-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 13-May-2011.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    exlimihOLD $p |- ( E. x ph -> ps ) $=
      ( wi wex 19.23h mpgbi ) ABFACGBFCABCDHEI $.
  $}

  ${
    exlimd.1 $e |- F/ x ph $.
    exlimd.2 $e |- F/ x ch $.
    exlimd.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.9 of [Margaris] p. 89.  (Contributed by Mario
       Carneiro, 24-Sep-2016.)  (Proof shortened by Wolf Lammen,
       12-Jan-2018.) $)
    exlimd $p |- ( ph -> ( E. x ps -> ch ) ) $=
      ( wex eximd 19.9 syl6ib ) ABDHCDHCABCDEGICDFJK $.
    $( Obsolete proof of ~ exlimd as of 12-Jan-2018.  (Contributed by Mario
       Carneiro, 24-Sep-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    exlimdOLD $p |- ( ph -> ( E. x ps -> ch ) ) $=
      ( wi wal wex alrimi 19.23 sylib ) ABCHZDIBDJCHANDEGKBCDFLM $.
  $}

  ${
    exlimdh.1 $e |- ( ph -> A. x ph ) $.
    exlimdh.2 $e |- ( ch -> A. x ch ) $.
    exlimdh.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.9 of [Margaris] p. 89.  (Contributed by NM,
       28-Jan-1997.) $)
    exlimdh $p |- ( ph -> ( E. x ps -> ch ) ) $=
      ( nfi exlimd ) ABCDADEHCDFHGI $.
  $}

  ${
    nfimd.1 $e |- ( ph -> F/ x ps ) $.
    nfimd.2 $e |- ( ph -> F/ x ch ) $.
    $( If in a context ` x ` is not free in ` ps ` and ` ch ` , it is not free
       in ` ( ps -> ch ) ` .  (Contributed by Mario Carneiro, 24-Sep-2016.)
       (Proof shortened by Wolf Lammen, 30-Dec-2017.) $)
    nfimd $p |- ( ph -> F/ x ( ps -> ch ) ) $=
      ( wnf wal nfnf1 nfr imim2d 19.21t biimprd syl9r alrimd df-nf syl6ibr sylc
      wi ) ABDGZCDGZBCSZDGZEFTUAUBUBDHZSZDHUCTUAUEDBDICDIUAUBBCDHZSZTUDUACUFBCD
      JKTUDUGBCDLMNOUBDPQR $.

    $( Obsolete proof of ~ nfimd as of 29-Dec-2017.  (Contributed by Mario
       Carneiro, 24-Sep-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfimdOLD $p |- ( ph -> F/ x ( ps -> ch ) ) $=
      ( wnf wi wal wa nfa1 wn hbnt pm2.21 alimi imim2i adantr ax-1 adantl df-nf
      jad ex syl alimd imp anbi12i 3imtr4i syl2anc ) ABDGZCDGZBCHZDGZEFBBDIHZDI
      ZCCDIZHZDIZJUKUKDIZHZDIZUIUJJULUNUQUTUNUPUSDUMDKUNBLZVADIZHZUPUSHBDMVCUPU
      SVCUPJBCURVCVAURHUPVBURVAVAUKDBCNOPQUPCURHVCUOURCCUKDCBROPSUAUBUCUDUEUIUN
      UJUQBDTCDTUFUKDTUGUH $.
  $}

  ${
    hbim1.1 $e |- ( ph -> A. x ph ) $.
    hbim1.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( A closed form of ~ hbim .  (Contributed by NM, 5-Aug-1993.) $)
    hbim1 $p |- ( ( ph -> ps ) -> A. x ( ph -> ps ) ) $=
      ( wi wal a2i 19.21h sylibr ) ABFZABCGZFKCGABLEHABCDIJ $.
  $}

  ${
    nfim1.1 $e |- F/ x ph $.
    nfim1.2 $e |- ( ph -> F/ x ps ) $.
    $( A closed form of ~ nfim .  (Contributed by NM, 5-Aug-1993.)  (Revised by
       Mario Carneiro, 24-Sep-2016.)  (Proof shortened by Wolf Lammen,
       2-Jan-2018.) $)
    nfim1 $p |- F/ x ( ph -> ps ) $=
      ( wi nfri nfrd hbim1 nfi ) ABFCABCACDGABCEHIJ $.

    $( A closed form of ~ nfim .  (Contributed by NM, 5-Aug-1993.)  (Revised by
       Mario Carneiro, 24-Sep-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfim1OLD $p |- F/ x ( ph -> ps ) $=
      ( wi wal nfrd a2i 19.21 sylibr nfi ) ABFZCMABCGZFMCGABNABCEHIABCDJKL $.
  $}

  ${
    nfim.1 $e |- F/ x ph $.
    nfim.2 $e |- F/ x ps $.
    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph -> ps ) ` .  (Contributed by Mario Carneiro, 11-Aug-2016.)
       (Proof shortened by Wolf Lammen, 2-Jan-2018.) $)
    nfim $p |- F/ x ( ph -> ps ) $=
      ( wnf a1i nfim1 ) ABCDBCFAEGH $.

    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph -> ps ) ` .  (Contributed by Mario Carneiro, 11-Aug-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    nfimOLD $p |- F/ x ( ph -> ps ) $=
      ( wi wnf wtru a1i nfimd trud ) ABFCGHABCACGHDIBCGHEIJK $.
  $}

  ${
    hbimd.1 $e |- ( ph -> A. x ph ) $.
    hbimd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    hbimd.3 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbim .
       (Contributed by NM, 1-Jan-2002.)  (Proof shortened by Wolf Lammen,
       3-Jan-2018.) $)
    hbimd $p |- ( ph -> ( ( ps -> ch ) -> A. x ( ps -> ch ) ) ) $=
      ( wi nfdh nfimd nfrd ) ABCHDABCDABDEFIACDEGIJK $.

    $( Obsolete proof of ~ hbimd as of 16-Dec-2017.  (Contributed by NM,
       1-Jan-2002.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hbimdOLD $p |- ( ph -> ( ( ps -> ch ) -> A. x ( ps -> ch ) ) ) $=
      ( wi wal wn alrimih sp hbn1 nsyl4 con1i con3 al2imi syl2im alimi syl6 jad
      pm2.21 ax-1 ) ABCBCHZDIZABJZUFDIZUEABBDIZHZDIUFUHJZDIZUGAUIDEFKUKBUHBUKBD
      LBDMNOUIUJUFDBUHPQRUFUDDBCUBSTACCDIUEGCUDDCBUCSTUA $.
  $}

  ${
    hbim.1 $e |- ( ph -> A. x ph ) $.
    hbim.2 $e |- ( ps -> A. x ps ) $.
    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph -> ps ) ` .  (Contributed by NM, 5-Aug-1993.)  (Proof shortened
       by O'Cat, 3-Mar-2008.)  (Proof shortened by Wolf Lammen, 1-Jan-2018.) $)
    hbim $p |- ( ( ph -> ps ) -> A. x ( ph -> ps ) ) $=
      ( wal wi a1i hbim1 ) ABCDBBCFGAEHI $.

    $( Obsolete proof of ~ hbim as of 1-Jan-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by O'Cat, 3-Mar-2008.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    hbimOLD $p |- ( ( ph -> ps ) -> A. x ( ph -> ps ) ) $=
      ( wi wal wn hbn pm2.21 alrimih ax-1 ja ) ABABFZCGAHNCACDIABJKBNCEBALKM $.
  $}

  $( Obsolete proof of ~ 19.23t as of 1-Jan-2018.  (Contributed by NM,
     7-Nov-2005.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  19.23tOLD $p |- ( F/ x ps -> ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) ) $=
    ( wnf wi wal wex exim 19.9t imbi2d syl5ib nfnf1 nfe1 a1i nfimd 19.8a imim1d
    id alrimdd impbid ) BCDZABEZCFZACGZBEZUCUDBCGZEUAUEABCHUAUFBUDBCIJKUAUEUBCB
    CLUAUDBCUDCDUAACMNUAROUAAUDBAUDEUAACPNQST $.

  ${
    19.23hOLD.1 $e |- ( ps -> A. x ps ) $.
    $( Obsolete proof of ~ 19.23h as of 1-Jan-2018.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 24-Sep-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    19.23hOLD $p |- ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) $=
      ( wi wal wex exim 19.9h syl6ib hbe1 hbim 19.8a imim1i alrimih impbii ) AB
      EZCFZACGZBEZRSBCGBABCHBCDIJTQCSBCACKDLASBACMNOP $.
  $}


  ${
    $d x z $.  $d w ph $.
    spimehOLD.1 $e |- ( ph -> A. x ph ) $.
    spimehOLD.2 $e |- ( x = z -> ( ph -> ps ) ) $.
    $( Obsolete proof of ~ spimeh as of 10-Dec-2017.  (Contributed by NM,
       7-Aug-1994.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    spimehOLD $p |- ( ph -> E. x ps ) $=
      ( wn wal wex wi weq ax9v id hbth hba1 a1i hbn hbimd ax-mp sp nsyli sylibr
      con3i alrimih mt3 con2i df-ex ) ABGZCHZGBCIUIAUIAGZJZCDKZGZCHCDLUKGUMCUKC
      AAJZUKUKCHJAMZUNUIUJCUNCUONUIUICHJUNUHCOPUJUJCHJUNACEQPRSQULUKULABUIFUHCT
      UAUCUDUEUFBCUGUB $.
  $}

  ${
    19.27.1 $e |- F/ x ps $.
    $( Theorem 19.27 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.27 $p |- ( A. x ( ph /\ ps ) <-> ( A. x ph /\ ps ) ) $=
      ( wa wal 19.26 19.3 anbi2i bitri ) ABECFACFZBCFZEKBEABCGLBKBCDHIJ $.
  $}

  ${
    19.28.1 $e |- F/ x ph $.
    $( Theorem 19.28 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.28 $p |- ( A. x ( ph /\ ps ) <-> ( ph /\ A. x ps ) ) $=
      ( wa wal 19.26 19.3 anbi1i bitri ) ABECFACFZBCFZEALEABCGKALACDHIJ $.
  $}

  ${
    nfand.1 $e |- ( ph -> F/ x ps ) $.
    nfand.2 $e |- ( ph -> F/ x ch ) $.
    $( If in a context ` x ` is not free in ` ps ` and ` ch ` , it is not free
       in ` ( ps /\ ch ) ` .  (Contributed by Mario Carneiro, 7-Oct-2016.) $)
    nfand $p |- ( ph -> F/ x ( ps /\ ch ) ) $=
      ( wa wn wi df-an nfnd nfimd nfxfrd ) BCGBCHZIZHADBCJAODABNDEACDFKLKM $.

    nfand.3 $e |- ( ph -> F/ x th ) $.
    $( Deduction form of bound-variable hypothesis builder ~ nf3an .
       (Contributed by NM, 17-Feb-2013.)  (Revised by Mario Carneiro,
       16-Oct-2016.) $)
    nf3and $p |- ( ph -> F/ x ( ps /\ ch /\ th ) ) $=
      ( w3a wa df-3an nfand nfxfrd ) BCDIBCJZDJAEBCDKANDEABCEFGLHLM $.
  $}


  ${
    nfan1.1 $e |- F/ x ph $.
    nfan1.2 $e |- ( ph -> F/ x ps ) $.
    $( A closed form of ~ nfan .  (Contributed by Mario Carneiro,
       3-Oct-2016.) $)
    nfan1 $p |- F/ x ( ph /\ ps ) $=
      ( wa wal nfrd imdistani 19.28 sylibr nfi ) ABFZCMABCGZFMCGABNABCEHIABCDJK
      L $.
  $}

  ${
    nfan.1 $e |- F/ x ph $.
    nfan.2 $e |- F/ x ps $.
    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph /\ ps ) ` .  (Contributed by Mario Carneiro, 11-Aug-2016.)
       (Proof shortened by Wolf Lammen, 13-Jan-2018.) $)
    nfan $p |- F/ x ( ph /\ ps ) $=
      ( wnf a1i nfan1 ) ABCDBCFAEGH $.

    $( If ` x ` is not free in ` ph ` and ` ps ` , then it is not free in
       ` ( ph -/\ ps ) ` .  (Contributed by Scott Fenton, 2-Jan-2018.) $)
    nfnan $p |- F/ x ( ph -/\ ps ) $=
      ( wnan wa wn df-nan nfan nfn nfxfr ) ABFABGZHCABIMCABCDEJKL $.

    $( Obsolete proof of ~ nfan as of 2-Jan-2018.  (Contributed by Mario
       Carneiro, 11-Aug-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfanOLD $p |- F/ x ( ph /\ ps ) $=
      ( wa wn wi df-an nfn nfim nfxfr ) ABFABGZHZGCABINCAMCDBCEJKJL $.

    nfan.3 $e |- F/ x ch $.
    $( If ` x ` is not free in ` ph ` , ` ps ` , and ` ch ` , it is not free in
       ` ( ph /\ ps /\ ch ) ` .  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nf3an $p |- F/ x ( ph /\ ps /\ ch ) $=
      ( w3a wa df-3an nfan nfxfr ) ABCHABIZCIDABCJMCDABDEFKGKL $.
  $}

  ${
    hb.1 $e |- ( ph -> A. x ph ) $.
    hb.2 $e |- ( ps -> A. x ps ) $.
    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph /\ ps ) ` .  (Contributed by NM, 5-Aug-1993.)  (Proof shortened
       by Wolf Lammen, 2-Jan-2018.) $)
    hban $p |- ( ( ph /\ ps ) -> A. x ( ph /\ ps ) ) $=
      ( wa nfi nfan nfri ) ABFCABCACDGBCEGHI $.
    $( Obsolete proof of ~ hban as of 2-Jan-2018.  (Contributed by NM,
       5-Aug-1993.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hbanOLD $p |- ( ( ph /\ ps ) -> A. x ( ph /\ ps ) ) $=
      ( wa wn wi df-an hbn hbim hbxfrbi ) ABFABGZHZGCABINCAMCDBCEJKJL $.

    hb.3 $e |- ( ch -> A. x ch ) $.
    $( If ` x ` is not free in ` ph ` , ` ps ` , and ` ch ` , it is not free in
       ` ( ph /\ ps /\ ch ) ` .  (Contributed by NM, 14-Sep-2003.)  (Proof
       shortened by Wolf Lammen, 2-Jan-2018.) $)
    hb3an $p |- ( ( ph /\ ps /\ ch ) -> A. x ( ph /\ ps /\ ch ) ) $=
      ( w3a nfi nf3an nfri ) ABCHDABCDADEIBDFICDGIJK $.

    $( Obsolete proof of ~ hb3an as of 2-Jan-2018.  (Contributed by NM,
       14-Sep-2003.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hb3anOLD $p |- ( ( ph /\ ps /\ ch ) -> A. x ( ph /\ ps /\ ch ) ) $=
      ( w3a wa df-3an hban hbxfrbi ) ABCHABIZCIDABCJMCDABDEFKGKL $.
  $}

  ${
    nfbid.1 $e |- ( ph -> F/ x ps ) $.
    nfbid.2 $e |- ( ph -> F/ x ch ) $.
    $( If in a context ` x ` is not free in ` ps ` and ` ch ` , it is not free
       in ` ( ps <-> ch ) ` .  (Contributed by Mario Carneiro, 24-Sep-2016.)
       (Proof shortened by Wolf Lammen, 29-Dec-2017.) $)
    nfbid $p |- ( ph -> F/ x ( ps <-> ch ) ) $=
      ( wb wi wa dfbi2 nfimd nfand nfxfrd ) BCGBCHZCBHZIADBCJANODABCDEFKACBDFEK
      LM $.

    $( Obsolete proof of ~ nfbid as of 29-Dec-2017.  (Contributed by Mario
       Carneiro, 24-Sep-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfbidOLD $p |- ( ph -> F/ x ( ps <-> ch ) ) $=
      ( wb wi wn dfbi1 nfimd nfnd nfxfrd ) BCGBCHZCBHZIZHZIADBCJAQDANPDABCDEFKA
      ODACBDFEKLKLM $.
  $}

  ${
    nf.1 $e |- F/ x ph $.
    nf.2 $e |- F/ x ps $.
    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph <-> ps ) ` .  (Contributed by Mario Carneiro, 11-Aug-2016.)
       (Proof shortened by Wolf Lammen, 2-Jan-2018.) $)
    nfbi $p |- F/ x ( ph <-> ps ) $=
      ( wb wnf wtru a1i nfbid trud ) ABFCGHABCACGHDIBCGHEIJK $.

    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph <-> ps ) ` .  (Contributed by Mario Carneiro, 11-Aug-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    nfbiOLD $p |- F/ x ( ph <-> ps ) $=
      ( wb wi wa dfbi2 nfim nfan nfxfr ) ABFABGZBAGZHCABIMNCABCDEJBACEDJKL $.

    $( If ` x ` is not free in ` ph ` and ` ps ` , it is not free in
       ` ( ph \/ ps ) ` .  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfor $p |- F/ x ( ph \/ ps ) $=
      ( wo wn wi df-or nfn nfim nfxfr ) ABFAGZBHCABIMBCACDJEKL $.

    nf.3 $e |- F/ x ch $.
    $( If ` x ` is not free in ` ph ` , ` ps ` , and ` ch ` , it is not free in
       ` ( ph \/ ps \/ ch ) ` .  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nf3or $p |- F/ x ( ph \/ ps \/ ch ) $=
      ( w3o wo df-3or nfor nfxfr ) ABCHABIZCIDABCJMCDABDEFKGKL $.
  $}

  ${
    $d x y $.
    equsalhw.1 $e |- ( ps -> A. x ps ) $.
    equsalhw.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weaker version of ~ equsalh (requiring distinct variables) without using
       ~ ax-12 .  (Contributed by NM, 29-Nov-2015.)  (Proof shortened by Wolf
       Lammen, 28-Dec-2017.) $)
    equsalhw $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( weq wi wal wex 19.23h pm5.74i albii a9ev a1bi 3bitr4i ) CDGZBHZCIQCJZBH
      QAHZCIBQBCEKTRCQABFLMSBCDNOP $.
  $}

  ${
    $d x y $.
    equsalhwOLD.1 $e |- ( ps -> A. x ps ) $.
    equsalhwOLD.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Obsolete proof of ~ equsalhw as of 28-Dec-2017.  (Contributed by NM,
       29-Nov-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    equsalhwOLD $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( weq wi wal sp impbii syl6bbr pm5.74i albii a1d alrimih ax9v con3 al2imi
      wn mtoi ax6o syl bitr4i ) CDGZAHZCIUEBCIZHZCIZBUFUHCUEAUGUEABUGFUGBBCJEKL
      MNBUIBUHCEBUGUEEOPUIUGTZCIZTBUIUKUETZCICDQUHUJULCUEUGRSUABCUBUCKUD $.
  $}

  ${
    19.21hOLD.1 $e |- ( ph -> A. x ph ) $.
    $( Obsolete proof of ~ 19.21h as of 1-Jan-2018.  (Contributed by NM,
       1-Aug-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    19.21hOLD $p |- ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) $=
      ( wi wal alim syl5 hba1 hbim sp imim2i alrimih impbii ) ABEZCFZABCFZEZAAC
      FPQDABCGHROCAQCDBCIJQBABCKLMN $.
  $}

  ${
    hbex.1 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` .
       (Contributed by NM, 5-Aug-1993.) $)
    hbex $p |- ( E. y ph -> A. x E. y ph ) $=
      ( wex wn wal df-ex hbn hbal hbxfrbi ) ACEAFZCGZFBACHMBLBCABDIJIK $.
  $}

  ${
    nfal.1 $e |- F/ x ph $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfal $p |- F/ x A. y ph $=
      ( wal nfri hbal nfi ) ACEBABCABDFGH $.

    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.)  (Proof shortened by Wolf
       Lammen, 30-Dec-2017.) $)
    nfex $p |- F/ x E. y ph $=
      ( wex nfri hbex nfi ) ACEBABCABDFGH $.

    $( Obsolete proof of ~ nfex as of 30-Dec-2017.  (Contributed by Mario
       Carneiro, 11-Aug-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfexOLD $p |- F/ x E. y ph $=
      ( wex wn wal df-ex nfn nfal nfxfr ) ACEAFZCGZFBACHMBLBCABDIJIK $.

    $( If ` x ` is not free in ` ph ` , it is not free in ` F/ y ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.)  (Proof shortened by Wolf
       Lammen, 30-Dec-2017.) $)
    nfnf $p |- F/ x F/ y ph $=
      ( wnf wal wi df-nf nfal nfim nfxfr ) ACEAACFZGZCFBACHMBCALBDABCDIJIK $.

    $( Obsolete proof of ~ nfnf as of 30-Dec-2017.  (Contributed by Mario
       Carneiro, 11-Aug-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfnfOLD $p |- F/ x F/ y ph $=
      ( wnf wal wi df-nf wtru a1i nfal nfimd trud nfxfr ) ACEAACFZGZCFBACHPBCPB
      EIAOBABEIDJOBEIABCDKJLMKN $.
  $}

  $( Theorem 19.12 of [Margaris] p. 89.  Assuming the converse is a mistake
     sometimes made by beginners!  But sometimes the converse does hold, as in
     ~ 19.12vv and ~ r19.12sn .  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Wolf Lammen, 3-Jan-2018.) $)
  19.12 $p |- ( E. x A. y ph -> A. y E. x ph ) $=
    ( wal wex nfa1 nfex sp eximi alrimi ) ACDZBEABECKCBACFGKABACHIJ $.

  $( Obsolete proof of ~ 19.12 as of 3-Jan-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  19.12OLD $p |- ( E. x A. y ph -> A. y E. x ph ) $=
    ( wal wex hba1 hbex sp eximi alrimih ) ACDZBEABECKCBACFGKABACHIJ $.

  ${
    nfald.1 $e |- F/ y ph $.
    nfald.2 $e |- ( ph -> F/ x ps ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` .
       (Contributed by Mario Carneiro, 24-Sep-2016.)  (Proof shortened by Wolf
       Lammen, 6-Jan-2018.) $)
    nfald $p |- ( ph -> F/ x A. y ps ) $=
      ( wnf wal alrimi nfnf1 nfal hba1 sp nfrd hbald nfd syl ) ABCGZDHZBDHZCGAR
      DEFISTCRCDBCJKSBCDRDLSBCRDMNOPQ $.

    $( Obsolete proof of ~ nfald as of 6-Jan-2018.  (Contributed by Mario
       Carneiro, 24-Sep-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nfaldOLD $p |- ( ph -> F/ x A. y ps ) $=
      ( wnf wal alrimi nfnf1 nfal nfr al2imi ax-7 syl6 nfd syl ) ABCGZDHZBDHZCG
      ARDEFISTCRCDBCJKSTBCHZDHTCHRBUADBCLMBDCNOPQ $.

    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` .
       (Contributed by Mario Carneiro, 24-Sep-2016.) $)
    nfexd $p |- ( ph -> F/ x E. y ps ) $=
      ( wex wn wal df-ex nfnd nfald nfxfrd ) BDGBHZDIZHACBDJAOCANCDEABCFKLKM $.
  $}

  $( Lemma 24 of [Monk2] p. 114.  (Contributed by Mario Carneiro,
     24-Sep-2016.) $)
  nfa2 $p |- F/ x A. y A. x ph $=
    ( wal nfa1 nfal ) ABDBCABEF $.

  $( Lemma 23 of [Monk2] p. 114.  (Contributed by Mario Carneiro,
     24-Sep-2016.) $)
  nfia1 $p |- F/ x ( A. x ph -> A. x ps ) $=
    ( wal nfa1 nfim ) ACDBCDCACEBCEF $.

  ${
    $d x z $.  $d y z $.
    dvelimhw.1 $e |- ( ph -> A. x ph ) $.
    dvelimhw.2 $e |- ( ps -> A. z ps ) $.
    dvelimhw.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $(  dvelimhw.4 $e |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $. $)
    dvelimhw.4 $e |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $.
    $( Proof of ~ dvelimh without using ~ ax-12 but with additional distinct
       variable conditions.  (Contributed by Andrew Salmon, 21-Jul-2011.)
       (Revised by NM, 1-Aug-2017.)  (Proof shortened by Wolf Lammen,
       3-Mar-2018.) $)
    dvelimhw $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi wnf nfv equcom nfa1 nfn nfd nfxfrd nfi a1i nfimd equsalhw
      nfald nfbii sylib nfrd ) CDJZCKZLZBCUKEDJZAMZEKZCNBCNUKUMCEUKEOUKULACULDE
      JZUKCEDPUKUOCUJCUICQRISTACNUKACFUAUBUCUEUNBCABEDGHUDUFUGUH $.

    $( Proof of ~ dvelimh without using ~ ax-12 but with additional distinct
       variable conditions.  (Contributed by Andrew Salmon, 21-Jul-2011.)
       (Revised by NM, 1-Aug-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dvelimhwOLD $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi ax-17 hbn1 equcomi alimi syl56 a1i hbimd equsalhw 3imtr3g
      hbald albii ) CDJZCKLZEDJZAMZEKZUICKBBCKUFUHCEUFENUFUGACUECOUGDEJZUFUJCKU
      GCKEDPIUJUGCDEPQRAACKMUFFSTUCABEDGHUAZUIBCUKUDUB $.
  $}

  ${
    $d x y $.
    cbv3hv.1 $e |- ( ph -> A. y ph ) $.
    cbv3hv.2 $e |- ( ps -> A. x ps ) $.
    cbv3hv.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Lemma for ~ ax10 .  Similar to ~ cbv3h .  Requires distinct variables
       but avoids ~ ax-12 .  (Contributed by NM, 25-Jul-2015.)  (Proof
       shortened by Wolf Lammen, 29-Dec-2017.) $)
    cbv3hv $p |- ( A. x ph -> A. y ps ) $=
      ( wal alimi wex weq wi a9ev eximii 19.35i 19.9h sylib a7s syl ) ACHZADHZC
      HBDHZAUACEIAUBDCTBDTBCJBABCCDKABLCCDMGNOBCFPQIRS $.

    $( Obsolete proof of ~ cbv3hv as of 29-Dec-2017.  (Contributed by NM,
       25-Jul-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    cbv3hvOLD $p |- ( A. x ph -> A. y ps ) $=
      ( wal alimi wi weq wn ax9v hba1 hbim hbn sp syl5 con3i alrimih mt3 a7s
      syl ) ACHZADHZCHBDHZAUECEIAUFDCUDBDUDBJZCDKZLZCHCDMUGLUICUGCUDBCACNFOPUHU
      GUDAUHBACQGRSTUAIUBUC $.
  $}

  $( Obsolete proof of ~ 19.9t as of 30-Dec-2017.  (Contributed by NM,
     5-Aug-1993.)  (Revised by Mario Carneiro, 24-Sep-2016.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  19.9tOLD $p |- ( F/ x ph -> ( E. x ph <-> ph ) ) $=
    ( wnf wex wn wal df-ex id nfnd nfrd con1d syl5bi 19.8a impbid1 ) ABCZABDZAP
    AEZBFZEOAABGOAROQBOABOHIJKLABMN $.

  $( Obsolete proof of ~ excomim as of 8-Jan-2018.  (Contributed by NM,
     5-Aug-1993.)  (Revised by Mario Carneiro, 24-Sep-2016.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  excomimOLD $p |- ( E. x E. y ph -> E. y E. x ph ) $=
    ( wex 19.8a 2eximi nfe1 nfex 19.9 sylib ) ACDBDABDZCDZBDLAKBCABEFLBKBCABGHI
    J $.

  $( Obsolete proof of ~ excom as of 8-Jan-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  excomOLD $p |- ( E. x E. y ph <-> E. y E. x ph ) $=
    ( wex excomim impbii ) ACDBDABDCDABCEACBEF $.

  ${
    19.16.1 $e |- F/ x ph $.
    $( Theorem 19.16 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.16 $p |- ( A. x ( ph <-> ps ) -> ( ph <-> A. x ps ) ) $=
      ( wal wb 19.3 albi syl5bbr ) AACEABFCEBCEACDGABCHI $.
  $}

  ${
    19.17.1 $e |- F/ x ps $.
    $( Theorem 19.17 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.17 $p |- ( A. x ( ph <-> ps ) -> ( A. x ph <-> ps ) ) $=
      ( wb wal albi 19.3 syl6bb ) ABECFACFBCFBABCGBCDHI $.
  $}

  ${
    19.19.1 $e |- F/ x ph $.
    $( Theorem 19.19 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.19 $p |- ( A. x ( ph <-> ps ) -> ( ph <-> E. x ps ) ) $=
      ( wex wb wal 19.9 exbi syl5bbr ) AACEABFCGBCEACDHABCIJ $.
  $}

  $( Obsolete proof of ~ 19.21t as of 30-Dec-2017.  (Contributed by NM,
     27-May-1997.)  (Revised by Mario Carneiro, 24-Sep-2016.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  19.21tOLD $p |- ( F/ x ph -> ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) ) $=
    ( wnf wi wal id nfrd alim syl9 nfa1 a1i nfimd sp imim2i alimi syl6 impbid )
    ACDZABEZCFZABCFZEZSAACFUAUBSACSGZHABCIJSUCUCCFUASUCCSAUBCUDUBCDSBCKLMHUCTCU
    BBABCNOPQR $.

  ${
    19.21-2.1 $e |- F/ x ph $.
    19.21-2.2 $e |- F/ y ph $.
    $( Theorem 19.21 of [Margaris] p. 90 but with 2 quantifiers.  (Contributed
       by NM, 4-Feb-2005.) $)
    19.21-2 $p |- ( A. x A. y ( ph -> ps ) <-> ( ph -> A. x A. y ps ) ) $=
      ( wi wal 19.21 albii bitri ) ABGDHZCHABDHZGZCHAMCHGLNCABDFIJAMCEIK $.
  $}

  ${
    19.21bbi.1 $e |- ( ph -> A. x A. y ps ) $.
    $( Inference removing double quantifier.  (Contributed by NM,
       20-Apr-1994.) $)
    19.21bbi $p |- ( ph -> ps ) $=
      ( wal 19.21bi ) ABDABDFCEGG $.
  $}

  $( An alternative definition of ~ df-nf , which does not involve nested
     quantifiers on the same variable.  (Contributed by Mario Carneiro,
     24-Sep-2016.) $)
  nf2 $p |- ( F/ x ph <-> ( E. x ph -> A. x ph ) ) $=
    ( wnf wal wi wex df-nf nfa1 19.23 bitri ) ABCAABDZEBDABFKEABGAKBABHIJ $.

  $( An alternative definition of ~ df-nf .  (Contributed by Mario Carneiro,
     24-Sep-2016.) $)
  nf3 $p |- ( F/ x ph <-> A. x ( E. x ph -> ph ) ) $=
    ( wnf wex wal wi nf2 nfe1 19.21 bitr4i ) ABCABDZABEFKAFBEABGKABABHIJ $.

  $( Variable ` x ` is effectively not free in ` ph ` iff ` ph ` is always true
     or always false.  (Contributed by Mario Carneiro, 24-Sep-2016.) $)
  nf4 $p |- ( F/ x ph <-> ( A. x ph \/ A. x -. ph ) ) $=
    ( wnf wex wal wi wn wo nf2 imor orcom alnex orbi2i bitr4i 3bitri ) ABCABDZA
    BEZFPGZQHZQAGBEZHZABIPQJSQRHUARQKTRQABLMNO $.

  ${
    nfdi.1 $e |- ( ph -> F/ x ph ) $.
    $( Since the converse holds by ~ a1i , this inference shows that we can
       represent a not-free hypothesis with either ` F/ x ph ` (inference form)
       or ` ( ph -> F/ x ph ) ` (deduction form).  (Contributed by NM,
       17-Aug-2018.) $)
    nfdi $p |- F/ x ph $=
      ( wex wal 19.8a wnf wi nf2 sylib mpd nfi ) ABAABDZABEZABFAABGMNHCABIJKL
      $.
  $}

  ${
    19.36.1 $e |- F/ x ps $.
    $( Theorem 19.36 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.36 $p |- ( E. x ( ph -> ps ) <-> ( A. x ph -> ps ) ) $=
      ( wi wex wal 19.35 19.9 imbi2i bitri ) ABECFACGZBCFZELBEABCHMBLBCDIJK $.

    19.36i.2 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.36 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.36i $p |- ( A. x ph -> ps ) $=
      ( wi wex wal 19.36 mpbi ) ABFCGACHBFEABCDIJ $.
  $}

  ${
    19.37.1 $e |- F/ x ph $.
    $( Theorem 19.37 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.37 $p |- ( E. x ( ph -> ps ) <-> ( ph -> E. x ps ) ) $=
      ( wi wex wal 19.35 19.3 imbi1i bitri ) ABECFACGZBCFZEAMEABCHLAMACDIJK $.
  $}

  $( Obsolete proof of ~ 19.38 as of 2-Jan-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  19.38OLD $p |- ( ( E. x ph -> A. x ps ) -> A. x ( ph -> ps ) ) $=
    ( wex wal wi nfe1 nfa1 nfim 19.8a sp imim12i alrimi ) ACDZBCEZFABFCNOCACGBC
    HIANOBACJBCKLM $.

  ${
    19.32.1 $e |- F/ x ph $.
    $( Theorem 19.32 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 24-Sep-2016.) $)
    19.32 $p |- ( A. x ( ph \/ ps ) <-> ( ph \/ A. x ps ) ) $=
      ( wn wi wal wo nfn 19.21 df-or albii 3bitr4i ) AEZBFZCGNBCGZFABHZCGAPHNBC
      ACDIJQOCABKLAPKM $.
  $}

  ${
    19.31.1 $e |- F/ x ps $.
    $( Theorem 19.31 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.31 $p |- ( A. x ( ph \/ ps ) <-> ( A. x ph \/ ps ) ) $=
      ( wo wal 19.32 orcom albii 3bitr4i ) BAEZCFBACFZEABEZCFLBEBACDGMKCABHILBH
      J $.
  $}

  ${
    19.44.1 $e |- F/ x ps $.
    $( Theorem 19.44 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.44 $p |- ( E. x ( ph \/ ps ) <-> ( E. x ph \/ ps ) ) $=
      ( wo wex 19.43 19.9 orbi2i bitri ) ABECFACFZBCFZEKBEABCGLBKBCDHIJ $.
  $}

  ${
    19.45.1 $e |- F/ x ph $.
    $( Theorem 19.45 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.) $)
    19.45 $p |- ( E. x ( ph \/ ps ) <-> ( ph \/ E. x ps ) ) $=
      ( wo wex 19.43 19.9 orbi1i bitri ) ABECFACFZBCFZEALEABCGKALACDHIJ $.
  $}

  ${
    19.41.1 $e |- F/ x ps $.
    $( Theorem 19.41 of [Margaris] p. 90.  (Contributed by NM, 5-Aug-1993.)
       (Proof shortened by Andrew Salmon, 25-May-2011.)  (Proof shortened by
       Wolf Lammen, 12-Jan-2018.) $)
    19.41 $p |- ( E. x ( ph /\ ps ) <-> ( E. x ph /\ ps ) ) $=
      ( wa wex 19.40 19.9 anbi2i sylib pm3.21 eximd impcom impbii ) ABEZCFZACFZ
      BEZPQBCFZERABCGSBQBCDHIJBQPBAOCDBAKLMN $.

    $( Obsolete proof of ~ 19.41 as of 12-Jan-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 25-May-2011.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    19.41OLD $p |- ( E. x ( ph /\ ps ) <-> ( E. x ph /\ ps ) ) $=
      ( wa wex 19.40 id exlimi anim2i syl pm3.21 eximd impcom impbii ) ABEZCFZA
      CFZBEZQRBCFZESABCGTBRBBCDBHIJKBRQBAPCDBALMNO $.
  $}

  ${
    19.42.1 $e |- F/ x ph $.
    $( Theorem 19.42 of [Margaris] p. 90.  (Contributed by NM, 18-Aug-1993.) $)
    19.42 $p |- ( E. x ( ph /\ ps ) <-> ( ph /\ E. x ps ) ) $=
      ( wa wex 19.41 exancom ancom 3bitr4i ) BAECFBCFZAEABECFAKEBACDGABCHAKIJ
      $.
  $}

  ${
    exan.1 $e |- ( E. x ph /\ ps ) $.
    $( Place a conjunct in the scope of an existential quantifier.
       (Contributed by NM, 18-Aug-1993.)  (Proof shortened by Andrew Salmon,
       25-May-2011.)  (Proof shortened by Wolf Lammen, 13-Jan-2018.) $)
    exan $p |- E. x ( ph /\ ps ) $=
      ( wa wex simpri nfth 19.41 mpbir ) ABECFACFZBEDABCBCKBDGHIJ $.

    $( Obsolete proof of ~ exan as of 13-Jan-2018.  (Contributed by NM,
       18-Aug-1993.)  (Proof shortened by Andrew Salmon, 25-May-2011.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    exanOLD $p |- E. x ( ph /\ ps ) $=
      ( wex wal wa nfe1 19.28 mpgbi 19.29r ax-mp ) ACEZBCFGZABGCEMBGNCMBCACHIDJ
      ABCKL $.
  $}

  ${
    hbnd.1 $e |- ( ph -> A. x ph ) $.
    hbnd.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbn .
       (Contributed by NM, 3-Jan-2002.) $)
    hbnd $p |- ( ph -> ( -. ps -> A. x -. ps ) ) $=
      ( wal wi wn alrimih hbnt syl ) ABBCFGZCFBHZMCFGALCDEIBCJK $.
  $}

  ${
    aaan.1 $e |- F/ y ph $.
    aaan.2 $e |- F/ x ps $.
    $( Rearrange universal quantifiers.  (Contributed by NM, 12-Aug-1993.) $)
    aaan $p |- ( A. x A. y ( ph /\ ps ) <-> ( A. x ph /\ A. y ps ) ) $=
      ( wa wal 19.28 albii nfal 19.27 bitri ) ABGDHZCHABDHZGZCHACHOGNPCABDEIJAO
      CBCDFKLM $.
  $}

  ${
    eeor.1 $e |- F/ y ph $.
    eeor.2 $e |- F/ x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 8-Aug-1994.) $)
    eeor $p |- ( E. x E. y ( ph \/ ps ) <-> ( E. x ph \/ E. y ps ) ) $=
      ( wo wex 19.45 exbii nfex 19.44 bitri ) ABGDHZCHABDHZGZCHACHOGNPCABDEIJAO
      CBCDFKLM $.
  $}

  $( Quantified "excluded middle."  Exercise 9.2a of Boolos, p. 111,
     _Computability and Logic_.  (Contributed by NM, 10-Dec-2000.) $)
  qexmid $p |- E. x ( ph -> A. x ph ) $=
    ( wal 19.8a 19.35ri ) AABCZBFBDE $.

  $( A property related to substitution that unlike ~ equs5 doesn't require a
     distinctor antecedent.  (Contributed by NM, 2-Feb-2007.) $)
  equs5a $p |- ( E. x ( x = y /\ A. y ph ) -> A. x ( x = y -> ph ) ) $=
    ( weq wal wa wi nfa1 ax-11 imp exlimi ) BCDZACEZFLAGZBEZBNBHLMOABCIJK $.

  $( A property related to substitution that unlike ~ equs5 doesn't require a
     distinctor antecedent.  (Contributed by NM, 2-Feb-2007.)  (Proof shortened
     by Wolf Lammen, 15-Jan-2018.) $)
  equs5e $p |- ( E. x ( x = y /\ ph ) -> A. x ( x = y -> E. y ph ) ) $=
    ( weq wa wex wi wal nfa1 hbe1 19.23bi ax-11 syl5 imp exlimi ) BCDZAEPACFZGZ
    BHZBRBIPASAQCHZPSATCACJKQBCLMNO $.

  $( Obsolete proof of ~ equs5e as of 15-Jan-2018.  (Contributed by NM,
     2-Feb-2007.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  equs5eOLD $p |- ( E. x ( x = y /\ ph ) -> A. x ( x = y -> E. y ph ) ) $=
    ( weq wa wex wi nfe1 wn wal equs3 ax-11 con3rr3 df-ex syl6ibr sylbi alrimi
    ) BCDZAEZBFZRACFZGZBSBHTRAIZGBJZIZUBABCKUERUCCJZIUARUFUDUCBCLMACNOPQ $.

  ${
    exlimdd.1 $e |- F/ x ph $.
    exlimdd.2 $e |- F/ x ch $.
    exlimdd.3 $e |- ( ph -> E. x ps ) $.
    exlimdd.4 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Existential elimination rule of natural deduction.  (Contributed by
       Mario Carneiro, 9-Feb-2017.) $)
    exlimdd $p |- ( ph -> ch ) $=
      ( wex ex exlimd mpd ) ABDICGABCDEFABCHJKL $.
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.21 of [Margaris] p. 90. _Notational
       convention_:  We sometimes suffix with "v" the label of a theorem
       eliminating a hypothesis such as ` F/ x ph ` in ~ 19.21 via the use of
       distinct variable conditions combined with ~ nfv .  Conversely, we
       sometimes suffix with "f" the label of a theorem introducing such a
       hypothesis to eliminate the need for the distinct variable condition;
       e.g. ~ euf derived from ~ df-eu .  The "f" stands for "not free in"
       which is less restrictive than "does not occur in."  (Contributed by NM,
       5-Aug-1993.) $)
    19.21v $p |- ( A. x ( ph -> ps ) <-> ( ph -> A. x ps ) ) $=
      ( nfv 19.21 ) ABCACDE $.
  $}

  ${
    $d x ps $.
    $( Special case of Theorem 19.23 of [Margaris] p. 90.  (Contributed by NM,
       28-Jun-1998.) $)
    19.23v $p |- ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) $=
      ( nfv 19.23 ) ABCBCDE $.
  $}

  ${
    $d x ps $.  $d y ps $.
    $( Theorem 19.23 of [Margaris] p. 90 extended to two variables.
       (Contributed by NM, 10-Aug-2004.) $)
    19.23vv $p |- ( A. x A. y ( ph -> ps ) <-> ( E. x E. y ph -> ps ) ) $=
      ( wi wal wex 19.23v albii bitri ) ABEDFZCFADGZBEZCFLCGBEKMCABDHILBCHJ $.
  $}

  ${
    $d ph y $.  $d ps x $.
    $( Theorem *11.53 in [WhiteheadRussell] p. 164.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm11.53 $p |- ( A. x A. y ( ph -> ps ) <-> ( E. x ph -> A. y ps ) ) $=
      ( wi wal wex 19.21v albii nfv nfal 19.23 bitri ) ABEDFZCFABDFZEZCFACGOENP
      CABDHIAOCBCDBCJKLM $.
  $}

  ${
    $d x ps $.
    $( Theorem 19.27 of [Margaris] p. 90.  (Contributed by NM, 3-Jun-2004.) $)
    19.27v $p |- ( A. x ( ph /\ ps ) <-> ( A. x ph /\ ps ) ) $=
      ( nfv 19.27 ) ABCBCDE $.
  $}

  ${
    $d x ph $.
    $( Theorem 19.28 of [Margaris] p. 90.  (Contributed by NM, 25-Mar-2004.) $)
    19.28v $p |- ( A. x ( ph /\ ps ) <-> ( ph /\ A. x ps ) ) $=
      ( nfv 19.28 ) ABCACDE $.
  $}

  ${
    $d x ps $.
    $( Special case of Theorem 19.36 of [Margaris] p. 90.  (Contributed by NM,
       18-Aug-1993.) $)
    19.36v $p |- ( E. x ( ph -> ps ) <-> ( A. x ph -> ps ) ) $=
      ( nfv 19.36 ) ABCBCDE $.
  $}

  ${
    $d x ps $.
    19.36aiv.1 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.36 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.36aiv $p |- ( A. x ph -> ps ) $=
      ( nfv 19.36i ) ABCBCEDF $.
  $}

  ${
    $d x ps $.  $d y ph $.
    $( Special case of ~ 19.12 where its converse holds.  (Contributed by NM,
       18-Jul-2001.)  (Revised by Andrew Salmon, 11-Jul-2011.) $)
    19.12vv $p |- ( E. x A. y ( ph -> ps ) <-> A. y E. x ( ph -> ps ) ) $=
      ( wi wal wex 19.21v exbii nfv nfal 19.36 19.36v albii 19.21 bitr2i 3bitri
      ) ABEZDFZCGABDFZEZCGACFZTEZRCGZDFZSUACABDHIATCBCDBCJKLUEUBBEZDFUCUDUFDABC
      MNUBBDADCADJKOPQ $.
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.37 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.37v $p |- ( E. x ( ph -> ps ) <-> ( ph -> E. x ps ) ) $=
      ( nfv 19.37 ) ABCACDE $.
  $}

  ${
    $d x ph $.
    19.37aiv.1 $e |- E. x ( ph -> ps ) $.
    $( Inference from Theorem 19.37 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.37aiv $p |- ( ph -> E. x ps ) $=
      ( wi wex 19.37v mpbi ) ABECFABCFEDABCGH $.
  $}

  ${
    $d x ps $.
    $( Special case of Theorem 19.41 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.41v $p |- ( E. x ( ph /\ ps ) <-> ( E. x ph /\ ps ) ) $=
      ( nfv 19.41 ) ABCBCDE $.
  $}

  ${
    $d x ps $.  $d y ps $.
    $( Theorem 19.41 of [Margaris] p. 90 with 2 quantifiers.  (Contributed by
       NM, 30-Apr-1995.) $)
    19.41vv $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x E. y ph /\ ps ) ) $=
      ( wa wex 19.41v exbii bitri ) ABEDFZCFADFZBEZCFKCFBEJLCABDGHKBCGI $.
  $}

  ${
    $d x ps $.  $d y ps $.  $d z ps $.
    $( Theorem 19.41 of [Margaris] p. 90 with 3 quantifiers.  (Contributed by
       NM, 30-Apr-1995.) $)
    19.41vvv $p |- ( E. x E. y E. z ( ph /\ ps ) <->
                     ( E. x E. y E. z ph /\ ps ) ) $=
      ( wa wex 19.41vv exbii 19.41v bitri ) ABFEGDGZCGAEGDGZBFZCGMCGBFLNCABDEHI
      MBCJK $.
  $}

  ${
    $d w ps $.  $d x ps $.  $d y ps $.  $d z ps $.
    $( Theorem 19.41 of [Margaris] p. 90 with 4 quantifiers.  (Contributed by
       FL, 14-Jul-2007.) $)
    19.41vvvv $p |- ( E. w E. x E. y E. z ( ph /\ ps ) <->
                     ( E. w E. x E. y E. z ph /\ ps ) ) $=
      ( wa wex 19.41vvv exbii 19.41v bitri ) ABGEHDHCHZFHAEHDHCHZBGZFHNFHBGMOFA
      BCDEIJNBFKL $.
  $}

  ${
    $d x ph $.
    $( Special case of Theorem 19.42 of [Margaris] p. 90.  (Contributed by NM,
       5-Aug-1993.) $)
    19.42v $p |- ( E. x ( ph /\ ps ) <-> ( ph /\ E. x ps ) ) $=
      ( nfv 19.42 ) ABCACDE $.
  $}

  ${
    $d y ph $.
    $( Distribution of existential quantifiers.  (Contributed by NM,
       9-Mar-1995.) $)
    exdistr $p |- ( E. x E. y ( ph /\ ps ) <-> E. x ( ph /\ E. y ps ) ) $=
      ( wa wex 19.42v exbii ) ABEDFABDFECABDGH $.
  $}

  ${
    $d x ph $.  $d y ph $.
    $( Theorem 19.42 of [Margaris] p. 90 with 2 quantifiers.  (Contributed by
       NM, 16-Mar-1995.) $)
    19.42vv $p |- ( E. x E. y ( ph /\ ps ) <-> ( ph /\ E. x E. y ps ) ) $=
      ( wa wex exdistr 19.42v bitri ) ABEDFCFABDFZECFAJCFEABCDGAJCHI $.
  $}

  ${
    $d x ph $.  $d y ph $.  $d z ph $.
    $( Theorem 19.42 of [Margaris] p. 90 with 3 quantifiers.  (Contributed by
       NM, 21-Sep-2011.) $)
    19.42vvv $p |- ( E. x E. y E. z ( ph /\ ps )
                       <-> ( ph /\ E. x E. y E. z ps ) ) $=
      ( wa wex 19.42vv exbii 19.42v bitri ) ABFEGDGZCGABEGDGZFZCGAMCGFLNCABDEHI
      AMCJK $.
  $}

  ${
    $d y ph $.  $d z ph $.
    $( Distribution of existential quantifiers.  (Contributed by NM,
       17-Mar-1995.) $)
    exdistr2 $p |- ( E. x E. y E. z ( ph /\ ps ) <->
                   E. x ( ph /\ E. y E. z ps ) ) $=
      ( wa wex 19.42vv exbii ) ABFEGDGABEGDGFCABDEHI $.
  $}

  ${
    $d y ph $.  $d z ph $.  $d z ps $.
    $( Distribution of existential quantifiers.  (Contributed by NM,
       9-Mar-1995.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3exdistr $p |- ( E. x E. y E. z ( ph /\ ps /\ ch ) <->
                E. x ( ph /\ E. y ( ps /\ E. z ch ) ) ) $=
      ( w3a wex wa 3anass 2exbii 19.42vv exdistr anbi2i 3bitri exbii ) ABCGZFHE
      HZABCFHIEHZIZDRABCIZIZFHEHAUAFHEHZITQUBEFABCJKAUAEFLUCSABCEFMNOP $.
  $}

  ${
    $d y ph $.  $d z ph $.  $d w ph $.  $d z ps $.  $d w ps $.  $d w ch $.
    $( Distribution of existential quantifiers.  (Contributed by NM,
       9-Mar-1995.)  (Proof shortened by Wolf Lammen, 20-Jan-2018.) $)
    4exdistr $p |- ( E. x E. y E. z E. w ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
                E. x ( ph /\ E. y ( ps /\ E. z ( ch /\ E. w th ) ) ) ) $=
      ( wa wex w3a 19.42v anbi2i df-3an 3bitr4i 3exbii 3exdistr bitri ) ABIZCDI
      ZIHJZGJFJEJABCDHJIZKZGJFJEJABUBGJIFJIEJUAUCEFGSTHJZISUBIUAUCUDUBSCDHLMSTH
      LABUBNOPABUBEFGQR $.
  $}

  ${
    $d y ph $.  $d z ph $.  $d w ph $.  $d z ps $.  $d w ps $.  $d w ch $.
    $( Obsolete proof of ~ 4exdistr as of 20-Jan-2018.  (Contributed by NM,
       9-Mar-1995.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    4exdistrOLD $p |- ( E. x E. y E. z E. w ( ( ph /\ ps ) /\ ( ch /\ th ) )
                <-> E. x ( ph /\ E. y ( ps /\ E. z ( ch /\ E. w th ) ) ) ) $=
      ( wa wex anass exbii 19.42v anbi2i 3bitri bitri ) ABICDIZIZHJZGJZFJZABCDH
      JIZGJIZFJIZEUAAUCIZFJUDTUEFTABUBIZIZGJAUFGJZIUESUGGSABQIZIZHJZUGRUJHABQKL
      UKAUIHJZIABQHJZIZIUGAUIHMULUNABQHMNUNUFAUMUBBCDHMNNOPLAUFGMUHUCABUBGMNOLA
      UCFMPL $.
  $}

  ${
    eean.1 $e |- F/ y ph $.
    eean.2 $e |- F/ x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 27-Oct-2010.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    eean $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x ph /\ E. y ps ) ) $=
      ( wa wex 19.42 exbii nfex 19.41 bitri ) ABGDHZCHABDHZGZCHACHOGNPCABDEIJAO
      CBCDFKLM $.
  $}

  ${
    $d y ph $.  $d x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 26-Jul-1995.) $)
    eeanv $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x ph /\ E. y ps ) ) $=
      ( nfv eean ) ABCDADEBCEF $.
  $}

  ${
    $d y ph $.  $d z ph $.  $d x ps $.  $d z ps $.  $d x ch $.  $d y ch $.
    $( Rearrange existential quantifiers.  Revised to loosen distinct variable
       restrictions.  (Contributed by NM, 26-Jul-1995.)  (Proof shortened by
       Andrew Salmon, 25-May-2011.)  (Revised by Wolf Lammen, 20-Jan-2018.) $)
    eeeanv $p |- ( E. x E. y E. z ( ph /\ ps /\ ch ) <->
                 ( E. x ph /\ E. y ps /\ E. z ch ) ) $=
      ( wa wex w3a eeanv anbi1i df-3an exbii 19.42v bitri 2exbii nfv nfex 19.41
      3bitri 3bitr4i ) ABGZEHZDHZCFHZGZADHZBEHZGZUEGABCIZFHZEHDHZUGUHUEIUDUIUEA
      BDEJKULUBUEGZEHZDHUCUEGZDHUFUKUMDEUKUBCGZFHUMUJUPFABCLMUBCFNOPUNUODUBUEEC
      EFCEQRSMUCUEDCDFCDQRSTUGUHUELUA $.
  $}

  ${
    $d y ph $.  $d z ph $.  $d x z ps $.  $d x y ch $.
    $( Obsolete proof of ~ eeeanv as of 20-Jan-2018.  (Contributed by NM,
       26-Jul-1995.)  (Proof shortened by Andrew Salmon, 25-May-2011.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    eeeanvOLD $p |- ( E. x E. y E. z ( ph /\ ps /\ ch ) <->
                 ( E. x ph /\ E. y ps /\ E. z ch ) ) $=
      ( w3a wex wa df-3an 3exbii eeanv exbii anbi1i 19.41v 3bitr4i 3bitri ) ABC
      GZFHEHDHABIZCIZFHEHZDHSEHZCFHZIZDHZADHZBEHZUCGZRTDEFABCJKUAUDDSCEFLMUBDHZ
      UCIUFUGIZUCIUEUHUIUJUCABDELNUBUCDOUFUGUCJPQ $.
  $}

  ${
    $d z ph $.  $d w ph $.  $d x ps $.  $d y ps $.  $d y z $.  $d w x $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 31-Jul-1995.) $)
    ee4anv $p |- ( E. x E. y E. z E. w ( ph /\ ps ) <->
                  ( E. x E. y ph /\ E. z E. w ps ) ) $=
      ( wa wex excom exbii eeanv 2exbii 3bitri ) ABGFHZEHDHZCHNDHZEHZCHADHZBFHZ
      GZEHCHRCHSEHGOQCNDEIJPTCEABDFKLRSCEKM $.
  $}

  ${
    $d x ph $.
    nexdv.1 $e |- ( ph -> -. ps ) $.
    $( Deduction for generalization rule for negated wff.  (Contributed by NM,
       5-Aug-1993.) $)
    nexdv $p |- ( ph -> -. E. x ps ) $=
      ( nfv nexd ) ABCACEDF $.
  $}

  $( One of the two equality axioms of standard predicate calculus, called
     substitutivity of equality.  (The other one is ~ stdpc6 .)  Translated to
     traditional notation, it can be
     read:  " ` x = y -> ( ph ( x , x ) -> ph ( x , y ) ) ` , provided that
     ` y ` is free for ` x ` in ` ph ( x , x ) ` ."  Axiom 7 of [Mendelson]
     p. 95.  (Contributed by NM, 15-Feb-2005.) $)
  stdpc7 $p |- ( x = y -> ( [ x / y ] ph -> ph ) ) $=
    ( wsb wi sbequ2 equcoms ) ACBDAECBACBFG $.

  $( An equality theorem for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbequ1 $p |- ( x = y -> ( ph -> [ y / x ] ph ) ) $=
    ( weq wsb wa wi wex pm3.4 19.8a df-sb sylanbrc ex ) BCDZAABCEZNAFZNAGPBHONA
    IPBJABCKLM $.

  $( An equality theorem for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbequ12 $p |- ( x = y -> ( ph <-> [ y / x ] ph ) ) $=
    ( weq wsb sbequ1 sbequ2 impbid ) BCDAABCEABCFABCGH $.

  $( An equality theorem for substitution.  (Contributed by NM, 6-Oct-2004.)
     (Proof shortened by Andrew Salmon, 21-Jun-2011.) $)
  sbequ12r $p |- ( x = y -> ( [ x / y ] ph <-> ph ) ) $=
    ( wsb wb weq sbequ12 bicomd equcoms ) ACBDZAECBCBFAJACBGHI $.

  $( An equality theorem for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbequ12a $p |- ( x = y -> ( [ y / x ] ph <-> [ x / y ] ph ) ) $=
    ( weq wsb sbequ12 wb equcoms bitr3d ) BCDAABCEACBEZABCFAJGCBACBFHI $.

  $( An identity theorem for substitution.  Remark 9.1 in [Megill] p. 447 (p.
     15 of the preprint).  (Contributed by NM, 5-Aug-1993.) $)
  sbid $p |- ( [ x / x ] ph <-> ph ) $=
    ( wsb weq wb equid sbequ12 ax-mp bicomi ) AABBCZBBDAJEBFABBGHI $.

  $( A version of ~ sb4 that doesn't require a distinctor antecedent.
     (Contributed by NM, 2-Feb-2007.) $)
  sb4a $p |- ( [ y / x ] A. y ph -> A. x ( x = y -> ph ) ) $=
    ( wal wsb weq wa wex wi sb1 equs5a syl ) ACDZBCEBCFZMGBHNAIBDMBCJABCKL $.

  $( One direction of a simplified definition of substitution that unlike ~ sb4
     doesn't require a distinctor antecedent.  (Contributed by NM,
     2-Feb-2007.) $)
  sb4e $p |- ( [ y / x ] ph -> A. x ( x = y -> E. y ph ) ) $=
    ( wsb weq wa wex wi wal sb1 equs5e syl ) ABCDBCEZAFBGMACGHBIABCJABCKL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Axiom scheme ax-12 (Quantified Equality)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axiom of Quantified Equality.  One of the equality and substitution axioms
     of predicate calculus with equality.

     An equivalent way to express this axiom that may be easier to understand
     is ` ( -. x = y -> ( -. x = z -> ( y = z -> A. x y = z ) ) ) ` (see
     ~ ax12b ).  Recall that in the intended interpretation, our variables are
     metavariables ranging over the variables of predicate calculus (the object
     language).  In order for the first antecedent ` -. x = y ` to hold, ` x `
     and ` y ` must have different values and thus cannot be the same
     object-language variable.  Similarly, ` x ` and ` z ` cannot be the same
     object-language variable.  Therefore, ` x ` will not occur in the wff
     ` y = z ` when the first two antecedents hold, so analogous to ~ ax-17 ,
     the conclusion ` ( y = z -> A. x y = z ) ` follows.

     The original version of this axiom was ~ ax-12o and was replaced with this
     shorter ~ ax-12 in December 2015.  The old axiom is proved from this one
     as theorem ~ ax12o .  Conversely, this axiom is proved from ~ ax-12o as
     theorem ~ ax12 .

     The primary purpose of this axiom is to provide a way to introduce the
     quantifier ` A. x ` on ` y = z ` even when ` x ` and ` y ` are substituted
     with the same variable.  In this case, the first antecedent becomes
     ` -. x = x ` and the axiom still holds.

     Although this version is shorter, the original version ~ ax12o may be more
     practical to work with because of the "distinctor" form of its
     antecedents.  A typical application of ~ ax12o is in ~ dvelimh which
     converts a distinct variable pair to the distinctor antecendent
     ` -. A. x x = y ` .

     This axiom can be weakened if desired by adding distinct variable
     restrictions on pairs ` x , z ` and ` y , z ` .  To show that, we add
     these restrictions to theorem ~ ax12v and use only ~ ax12v for further
     derivations.  Thus, ~ ax12v should be the only theorem referencing this
     axiom.  Other theorems can reference either ~ ax12v or ~ ax12o .

     This axiom scheme is logically redundant (see ~ ax12w ) but is used as an
     auxiliary axiom to achieve metalogical completeness.  (Contributed by NM,
     21-Dec-2015.)  (New usage is discouraged.) $)
  ax-12 $a |- ( -. x = y -> ( y = z -> A. x y = z ) ) $.

  ${
    $d x z $.  $d y z $.
    $( A weaker version of ~ ax-12 with distinct variable restrictions on pairs
       ` x , z ` and ` y , z ` .  In order to show that this weakening is
       adequate, this should be the only theorem referencing ~ ax-12 directly.
       (Contributed by NM, 30-Jun-2016.) $)
    ax12v $p |- ( -. x = y -> ( y = z -> A. x y = z ) ) $=
      ( ax-12 ) ABCD $.
  $}

  ${
    $d y w $.  $d z w $.
    $( A specialized version of ~ equvini with a distinct variable
       restriction.  (Contributed by Wolf Lammen, 8-Sep-2018.)
       (New usage is discouraged.) $)
    ax12lem1 $p |- ( y = z -> E. w ( y = w /\ z = w ) ) $=
      ( weq wex wa a9ev equcomi equtr ancrd syl5 eximdv mpi ) ABDZCBDZCEACDZBCD
      ZFZCECBGNORCOQNRCBHNQPABCIJKLM $.
  $}

  ${
    $d x z w $.  $d y w $.
    $( A version of ~ ax12v with one distinct variable restriction dropped.
       For convenience, ` y ` is kept on the right side of equations.  The
       proof of ~ ax12 bases on ideas from NM, 24-Dec-2015.  (Contributed by
       Wolf Lammen, 8-Sep-2018.)  (New usage is discuraged.) $)
    ax12lem2 $p |- ( -. x = y -> ( z = y -> A. x z = y ) ) $=
      ( vw weq wa wex wn wal ax12lem1 ax12v equequ2 biimprcd syl9 imp3a exlimdv
      alimdv syl5 ) CBEZCDEZBDEZFZDGABEHZSAIZCBDJUCUBUDDUCTUAUDUCUAUAAITUDABDKT
      UASAUASTBDCLMQNOPR $.
  $}

  ${
    $d y w $.  $d x w $.
    $( At least one individual exists.  This is not a theorem of free logic,
       which is sound in empty domains.  For such a logic, we would add this
       theorem as an axiom of set theory (Axiom 0 of [Kunen] p. 10).  In the
       system consisting of ~ ax-5 through ~ ax-14 and ~ ax-17 , all axioms
       other than ~ ax-9 are believed to be theorems of free logic, although
       the system without ~ ax-9 is probably not complete in free logic.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Wolf Lammen,
       8-Sep-2018.) $)
    a9e $p |- E. x x = y $=
      ( vw weq wex 19.8a wn wi wal ax12lem2 equtr eximii 19.35i syl6com exlimiv
      a9ev ax-mp pm2.61i ) ABDZSAEZSAFCBDZCESGZTHZCBPUAUCCUBUAUAAITABCJUASAACDU
      ASHAACPACBKLMNOQR $.
  $}

  $( Theorem showing that ~ ax-9 follows from the weaker version ~ ax9v .
     (Even though this theorem depends on ~ ax-9 , all references of ~ ax-9 are
     made via ~ ax9v .  An earlier version stated ~ ax9v as a separate axiom,
     but having two axioms caused some confusion.)

     This theorem should be referenced in place of ~ ax-9 so that all proofs
     can be traced back to ~ ax9v .  (Contributed by NM, 12-Nov-2013.)
     (Revised by NM, 25-Jul-2015.)  (Proof shortened by Wolf Lammen,
     4-Feb-2018.) $)
  ax9 $p |- -. A. x -. x = y $=
    ( weq wex wn wal a9e df-ex mpbi ) ABCZADJEAFEABGJAHI $.

  $( Show that the original axiom ~ ax-9o can be derived from ~ ax9 and
     others.  See ~ ax9from9o for the rederivation of ~ ax9 from ~ ax-9o .

     Normally, ~ ax9o should be used rather than ~ ax-9o , except by theorems
     specifically studying the latter's properties.  (Contributed by NM,
     5-Aug-1993.)  (Proof modification is discouraged.) $)
  ax9o $p |- ( A. x ( x = y -> A. x ph ) -> ph ) $=
    ( weq wal wi wn ax9 con3 al2imi mtoi ax6o syl ) BCDZABEZFZBEZOGZBEZGAQSNGZB
    EBCHPRTBNOIJKABLM $.

  $( Closed theorem form of ~ spim .  (Contributed by NM, 15-Jan-2008.)
     (Revised by Mario Carneiro, 17-Oct-2016.)  (Proof shortened by Wolf
     Lammen, 24-Feb-2018.) $)
  spimt $p |- ( ( F/ x ps /\ A. x ( x = y -> ( ph -> ps ) ) ) ->
              ( A. x ph -> ps ) ) $=
    ( weq wi wal wex wnf a9e exim mpi 19.35 sylib 19.9t biimpd sylan9r ) CDEZAB
    FZFCGZACGZBCHZBCIZBTSCHZUAUBFTRCHUDCDJRSCKLABCMNUCUBBBCOPQ $.

  $( Obsolete proof of ~ spimt as of 17-Feb-2018.  (Contributed by NM,
     15-Jan-2008.)  (Revised by Mario Carneiro, 17-Oct-2016.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  spimtOLD $p |- ( ( F/ x ps /\ A. x ( x = y -> ( ph -> ps ) ) ) ->
              ( A. x ph -> ps ) ) $=
    ( wnf weq wi wal wa nfnf1 nfa1 sp adantl nfr adantr embantd imim2d impancom
    nfan alimd ax9o syl6 ) BCEZCDFZABGZGZCHZIACHZUDBCHZGZCHZBUCUHUGUKUCUHIZUFUJ
    CUCUHCBCJACKSULUEUIUDULABUIUHAUCACLMUCBUIGUHBCNOPQTRBCDUAUB $.

  ${
    spim.1 $e |- F/ x ps $.
    spim.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization, using implicit substitution.  Compare Lemma 14 of
       [Tarski] p. 70.  The ~ spim series of theorems requires that only one
       direction of the substitution hypothesis hold.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)  (Proof shortened
       by Wolf Lammen, 18-Feb-2018.) $)
    spim $p |- ( A. x ph -> ps ) $=
      ( weq wi a9e eximii 19.36i ) ABCECDGABHCCDIFJK $.
    $( Obsolete proof of ~ spim as of 18-Feb-2018.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)
       (New usage is discouraged.)  (Proof modofication is discouraged.) $)
    spimOLD $p |- ( A. x ph -> ps ) $=
      ( wnf weq wi wal ax-gen spimt mp2an ) BCGCDHABIIZCJACJBIENCFKABCDLM $.
  $}

  ${
    spimeOLD.1 $e |- F/ x ph $.
    spimeOLD.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Obsolete proof of ~ spime as of 17-Feb-2018.  (Contributed by NM,
       7-Aug-1994.)  (Revised by Mario Carneiro, 3-Oct-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    spimeOLD $p |- ( ph -> E. x ps ) $=
      ( wn wal wex nfn weq con3d spim con2i df-ex sylibr ) ABGZCHZGBCIRAQAGCDAC
      EJCDKABFLMNBCOP $.
  $}

  ${
    spimed.1 $e |- ( ch -> F/ x ph ) $.
    spimed.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Deduction version of ~ spime .  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 3-Oct-2016.)  (Proof shortened by Wolf
       Lammen, 19-Feb-2018.) $)
    spimed $p |- ( ch -> ( ph -> E. x ps ) ) $=
      ( wal wex nfrd weq wi a9e eximii 19.35i syl6 ) CAADHBDICADFJABDDEKABLDDEM
      GNOP $.

    $( Obsolete proof of ~ spimed as of 19-Feb-2018.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    spimedOLD $p |- ( ch -> ( ph -> E. x ps ) ) $=
      ( wnf wex wi wa nfnf1 id nfan1 weq adantld spimeOLD ex syl ) CADHZABDIZJF
      TAUATAKBDETADADLTMNDEOABTGPQRS $.
  $}

  ${
    spime.1 $e |- F/ x ph $.
    spime.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Existential introduction, using implicit substitution.  Compare Lemma 14
       of [Tarski] p. 70.  (Contributed by NM, 7-Aug-1994.)  (Revised by Mario
       Carneiro, 3-Oct-2016.)  (Proof shortened by Wolf Lammen, 6-Mar-2018.) $)
    spime $p |- ( ph -> E. x ps ) $=
      ( wex wi wtru wnf a1i spimed trud ) ABCGHABICDACJIEKFLM $.
  $}

  ${
    $d x ps $.
    spimv.1 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( A version of ~ spim with a distinct variable requirement instead of a
       bound variable hypothesis.  (Contributed by NM, 5-Aug-1993.) $)
    spimv $p |- ( A. x ph -> ps ) $=
      ( nfv spim ) ABCDBCFEG $.
  $}

  ${
    $d x ph $.
    spimev.1 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Distinct-variable version of ~ spime .  (Contributed by NM,
       5-Aug-1993.) $)
    spimev $p |- ( ph -> E. x ps ) $=
      ( nfv spime ) ABCDACFEG $.
  $}

  ${
    $d x ps $.
    spv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Specialization, using implicit substitution.  (Contributed by NM,
       30-Aug-1993.) $)
    spv $p |- ( A. x ph -> ps ) $=
      ( weq biimpd spimv ) ABCDCDFABEGH $.
  $}

  ${
    spei.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    spei.2 $e |- ps $.
    $( Inference from existential specialization, using implicit substitution.
       Revised to remove a distinct variable constraint.  (Contributed by NM,
       19-Aug-1993.)  (Proof shortened by Wolf Lammen, 12-May-2018.) $)
    spei $p |- E. x ph $=
      ( weq a9e mpbiri eximii ) CDGZACCDHKABFEIJ $.
  $}

  ${
    $d x ps $.
    speivOLD.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    speivOLD.2 $e |- ps $.
    $( Obsolete proof of ~ spei as of 23-Feb-2018.  (Contributed by NM,
       19-Aug-1993.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    speivOLD $p |- E. x ph $=
      ( wex weq biimprd spimev ax-mp ) BACGFBACDCDHABEIJK $.
  $}

  ${
    chvar.1 $e |- F/ x ps $.
    chvar.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    chvar.3 $e |- ph $.
    $( Implicit substitution of ` y ` for ` x ` into a theorem.  (Contributed
       by Raph Levien, 9-Jul-2003.)  (Revised by Mario Carneiro,
       3-Oct-2016.) $)
    chvar $p |- ps $=
      ( weq biimpd spim mpg ) ABCABCDECDHABFIJGK $.
  $}

  ${
    $d x ps $.
    chv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    chv.2 $e |- ph $.
    $( Implicit substitution of ` y ` for ` x ` into a theorem.  (Contributed
       by NM, 20-Apr-1994.)  (Proof shortened by Wolf Lammen, 22-Apr-2018.) $)
    chvarv $p |- ps $=
      ( nfv chvar ) ABCDBCGEFH $.
    $( Obsolete proof of ~ chvarv as of 22-Apr-2018.  (Contributed by NM,
       20-Apr-1994.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    chvarvOLD $p |- ps $=
      ( spv mpg ) ABCABCDEGFH $.
  $}

  ${
    cbv3.1 $e |- F/ y ph $.
    cbv3.2 $e |- F/ x ps $.
    cbv3.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution, that
       does not use ~ ax-12o .  (Contributed by NM, 5-Aug-1993.)  (Proof
       shortened by Wolf Lammen, 12-May-2018.) $)
    cbv3 $p |- ( A. x ph -> A. y ps ) $=
      ( wal nfal spim alrimi ) ACHBDADCEIABCDFGJK $.
  $}

  ${
    cbv3h.1 $e |- ( ph -> A. y ph ) $.
    cbv3h.2 $e |- ( ps -> A. x ps ) $.
    cbv3h.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       25-May-2011.)  (Proof shortened by Wolf Lammen, 12-May-2018.) $)
    cbv3h $p |- ( A. x ph -> A. y ps ) $=
      ( nfi cbv3 ) ABCDADEHBCFHGI $.
  $}

  ${
    cbv1.1 $e |- F/ x ph $.
    cbv1.2 $e |- F/ y ph $.
    cbv1.3 $e |- ( ph -> F/ y ps ) $.
    cbv1.4 $e |- ( ph -> F/ x ch ) $.
    cbv1.5 $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       Revised to format hypotheses to common style.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)  (Revised by Wolf
       Lammen, 13-May-2018.) $)
    cbv1 $p |- ( ph -> ( A. x ps -> A. y ch ) ) $=
      ( wal wi nfim1 weq com12 a2d cbv3 19.21 3imtr3i pm2.86i ) ABDKZCEKZABLZDK
      ACLZEKAUALAUBLUCUDDEABEGHMACDFIMDENZABCAUEBCLJOPQABDFRACEGRST $.
  $}

  ${
    cbv1h.1 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv1h.2 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv1h.3 $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
       13-May-2018.) $)
    cbv1h $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( wal nfa1 nfa2 wi sp sps syl nfd weq cbv1 ) AEIZDIZBCDESDJZAEDKZTBEUBTAB
      BEILSADAEMNZFOPTCDUATACCDILUCGOPTADEQBCLLUCHOR $.

    $( Obsolete proof of ~ cbv1h as of 13-May-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    cbv1hOLD $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( wal wi sps al2imi ax-7 syl6 weq com23 syl6d ax9o a7s syld ) AEIZDIZBDIZ
      UCEIZCEIZUBUCBEIZDIUDUABUFDABUFJEFKLBDEMNAUDUEJEDADIZUCCEUGUCDEOZCDIZJZDI
      CABUJDABUHCUIAUHBCHPGQLCDERNLST $.
  $}

  ${
    cbv1OLD.1 $e |- ( ph -> F/ y ps ) $.
    cbv1OLD.2 $e |- ( ph -> F/ x ch ) $.
    cbv1OLD.3 $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Obsolete version of ~ cbv1 as of 13-May-2018.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cbv1OLD $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( nfrd cbv1hOLD ) ABCDEABEFIACDGIHJ $.
  $}

  ${
    cbv3hOLD.1 $e |- ( ph -> A. y ph ) $.
    cbv3hOLD.2 $e |- ( ps -> A. x ps ) $.
    cbv3hOLD.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Obsolete proof of ~ cbv3h as of 12-May-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 25-May-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cbv3hOLD $p |- ( A. x ph -> A. y ps ) $=
      ( weq wal wi a1i cbv1h stdpc6 mpg ) DDHZDIACIBDIJCOABCDAADIJOEKBBCIJOFKCD
      HABJJOGKLDMN $.
  $}

  ${
    cbv3OLD.1 $e |- F/ y ph $.
    cbv3OLD.2 $e |- F/ x ps $.
    cbv3OLD.3 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Obsolete proof of ~ cbv3 as of 22-Apr-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    cbv3OLD $p |- ( A. x ph -> A. y ps ) $=
      ( wtru wal wi wnf a1i weq cbv1OLD tru ax-gen mpg ) HDIACIBDIJCHABCDADKHEL
      BCKHFLCDMABJJHGLNHDOPQ $.
  $}

  ${
    cbv2h.1 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv2h.2 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv2h.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbv2h $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal weq wb wi bi1 syl6 cbv1h equcomi bi2 syl56 a7s impbid ) AEIDIBDIZCE
      IZABCDEFGADEJZBCKZBCLHBCMNOAUBUALEDACBEDGFEDJUCAUDCBLEDPHBCQROST $.
  $}

  ${
    cbv2.1 $e |- F/ x ph $.
    cbv2.2 $e |- F/ y ph $.
    cbv2.3 $e |- ( ph -> F/ y ps ) $.
    cbv2.4 $e |- ( ph -> F/ x ch ) $.
    cbv2.5 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       Revised to align format of hypotheses to common style.  (Contributed by
       NM, 5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)  (Revised by
       Wolf Lammen, 13-May-2018.) $)
    cbv2 $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal wb nfri nfal syl nfrd cbv2h ) AAEKZDKZBDKCEKLARSAEGMRDADEFNMOABCDEA
      BEHPACDIPJQO $.
  $}

  ${
    cbv2OLD.1 $e |- ( ph -> F/ y ps ) $.
    cbv2OLD.2 $e |- ( ph -> F/ x ch ) $.
    cbv2OLD.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Obsolete version of ~ cbv2 as of 13-May-2018.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cbv2OLD $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      ( nfrd cbv2h ) ABCDEABEFIACDGIHJ $.
  $}

  ${
    cbval.1 $e |- F/ y ph $.
    cbval.2 $e |- F/ x ps $.
    cbval.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       3-Oct-2016.) $)
    cbval $p |- ( A. x ph <-> A. y ps ) $=
      ( wal weq biimpd cbv3 wi biimprd equcoms impbii ) ACHBDHABCDEFCDIZABGJKBA
      DCFEBALCDPABGMNKO $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbvex $p |- ( E. x ph <-> E. y ps ) $=
      ( wn wal wex nfn weq notbid cbval notbii df-ex 3bitr4i ) AHZCIZHBHZDIZHAC
      JBDJSUARTCDADEKBCFKCDLABGMNOACPBDPQ $.
  $}

  ${
    $d y ph $.  $d x ps $.
    cbvalv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbvalv $p |- ( A. x ph <-> A. y ps ) $=
      ( nfv cbval ) ABCDADFBCFEG $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbvexv $p |- ( E. x ph <-> E. y ps ) $=
      ( nfv cbvex ) ABCDADFBCFEG $.
  $}

  ${
    $d x ph $.  $d x ch $.
    cbvald.1 $e |- F/ y ph $.
    cbvald.2 $e |- ( ph -> F/ y ps ) $.
    cbvald.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Deduction used to change bound variables, using implicit substitution,
       particularly useful in conjunction with ~ dvelim .  (Contributed by NM,
       2-Jan-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.)  (Revised by Wolf
       Lammen, 13-May-2018.) $)
    cbvald $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( nfv wnf a1i cbv2 ) ABCDEADIFGCDJACDIKHL $.

    $( Obsolete proof of ~ cbvald as of 13-May-2018.  (Contributed by NM,
       2-Jan-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cbvaldOLD $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal wb nfri alrimiv nfvd cbv2OLD syl ) AAEIZDIBDICEIJAPDAEFKLABCDEGACDM
      HNO $.

    $( Deduction used to change bound variables, using implicit substitution,
       particularly useful in conjunction with ~ dvelim .  (Contributed by NM,
       2-Jan-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    cbvexd $p |- ( ph -> ( E. x ps <-> E. y ch ) ) $=
      ( wn wal wex nfnd weq wb notbi syl6ib cbvald notbid df-ex 3bitr4g ) ABIZD
      JZICIZEJZIBDKCEKAUBUDAUAUCDEFABEGLADEMBCNUAUCNHBCOPQRBDSCEST $.
  $}

  ${
    $d y x $.  $d y z $.  $d w x $.  $d w z $.
    cbval2.1 $e |- F/ z ph $.
    cbval2.2 $e |- F/ w ph $.
    cbval2.3 $e |- F/ x ps $.
    cbval2.4 $e |- F/ y ps $.
    cbval2.5 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 22-Dec-2003.)  (Revised by Mario Carneiro,
       6-Oct-2016.)  (Proof shortened by Wolf Lammen, 22-Apr-2018.) $)
    cbval2 $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      ( wal nfal weq wi nfv nfim wb cbval 19.21v pm5.74d 3bitr3i pm5.74ri
      expcom ) ADLZBFLZCEAEDGMBCFIMCENZUEUFUGAOZDLUGBOZFLUGUEOUGUFOUHUIDFUGAFUG
      FPHQUGBDUGDPJQDFNZUGABUGUJABRKUDUASUGADTUGBFTUBUCS $.
    $( Obsolete proof of ~ cbval2 as of 22-Apr-2018.  (Contributed by NM,
       22-Dec-2003.)  (Revised by Mario Carneiro, 6-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cbval2OLD $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      ( wal nfal weq wb wa nfv nfan cbval 19.28v wi expcom pm5.32d pm5.32 mpbir
      3bitr3i ) ADLZBFLZCEAEDGMBCFIMCENZUGUHOUAUIUGPZUIUHPZOUIAPZDLUIBPZFLUJUKU
      LUMDFUIAFUIFQHRUIBDUIDQJRDFNZUIABUIUNABOKUBUCSUIADTUIBFTUFUIUGUHUDUES $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 14-Sep-2003.)  (Revised by Mario Carneiro,
       6-Oct-2016.) $)
    cbvex2 $p |- ( E. x E. y ph <-> E. z E. w ps ) $=
      ( wex nfex weq wb wa nfv nfan cbvex 19.42v wi expcom pm5.32d pm5.32 mpbir
      3bitr3i ) ADLZBFLZCEAEDGMBCFIMCENZUGUHOUAUIUGPZUIUHPZOUIAPZDLUIBPZFLUJUKU
      LUMDFUIAFUIFQHRUIBDUIDQJRDFNZUIABUIUNABOKUBUCSUIADTUIBFTUFUIUGUHUDUES $.
  $}

  ${
    $d z w ph $.  $d x y ps $.  $d x w $.  $d z y $.
    cbval2v.1 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 4-Feb-2005.) $)
    cbval2v $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      ( nfv cbval2 ) ABCDEFAEHAFHBCHBDHGI $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 26-Jul-1995.) $)
    cbvex2v $p |- ( E. x E. y ph <-> E. z E. w ps ) $=
      ( nfv cbvex2 ) ABCDEFAEHAFHBCHBDHGI $.
  $}

  ${
    $d ps y $.  $d ch x $.  $d ph x $.  $d ph y $.
    cbvaldva.1 $e |- ( ( ph /\ x = y ) -> ( ps <-> ch ) ) $.
    $( Rule used to change the bound variable in a universal quantifier with
       implicit substitution.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    cbvaldva $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( nfv nfvd weq wb ex cbvald ) ABCDEAEGABEHADEIBCJFKL $.

    $( Rule used to change the bound variable in an existential quantifier with
       implicit substitution.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    cbvexdva $p |- ( ph -> ( E. x ps <-> E. y ch ) ) $=
      ( nfv nfvd weq wb ex cbvexd ) ABCDEAEGABEHADEIBCJFKL $.
  $}

  ${
    $v f $.
    $v g $.
    $( Define temporary individual variables. $)
    cbvex4v.vf $f set f $.
    cbvex4v.vg $f set g $.
    $d w z ch $.  $d u v ph $.  $d x y ps $.  $d f g ps $.  $d f w $.
    $d g z $.  $d u v w x y z $.
    cbvex4v.1 $e |- ( ( x = v /\ y = u ) -> ( ph <-> ps ) ) $.
    cbvex4v.2 $e |- ( ( z = f /\ w = g ) -> ( ps <-> ch ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 26-Jul-1995.) $)
    cbvex4v $p |- ( E. x E. y E. z E. w ph <-> E. v E. u E. f E. g ch ) $=
      ( wex weq wa 2exbidv cbvex2v 2exbii bitri ) AGNFNZENDNBGNFNZINHNCKNJNZINH
      NUAUBDEHIDHOEIOPABFGLQRUBUCHIBCFGJKMRST $.
  $}

  $( Lemma used in proofs of substitution properties.  (Contributed by NM,
     5-Aug-1993.)  (Proof shortened by Mario Carneiro, 20-May-2014.)  (Proof
     shortened by Wolf Lammen, 5-Feb-2018.) $)
  equs4 $p |- ( A. x ( x = y -> ph ) -> E. x ( x = y /\ ph ) ) $=
    ( weq wi wal wex wa a9e exintr mpi ) BCDZAEBFLBGLAHBGBCILABJK $.

  $( Obsolete proof of ~ equs4 as of 5-Feb-2018.  (Contributed by NM,
     5-Aug-1993.)  (Proof shortened by Mario Carneiro, 20-May-2014.)
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  equs4OLD $p |- ( A. x ( x = y -> ph ) -> E. x ( x = y /\ ph ) ) $=
    ( weq wi wal wa wex a9e 19.29 mpan2 ancl imp eximi syl ) BCDZAEZBFZQPGZBHZP
    AGZBHRPBHTBCIQPBJKSUABQPUAPALMNO $.

  ${
    equsal.1 $e |- F/ x ps $.
    equsal.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 12-Aug-2011.)  (Revised
       by Mario Carneiro, 3-Oct-2016.)  (Proof shortened by Wolf Lammen,
       5-Feb-2018.) $)
    equsal $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( weq wi wal wex 19.23 pm5.74i albii a9e a1bi 3bitr4i ) CDGZBHZCIQCJZBHQA
      HZCIBQBCEKTRCQABFLMSBCDNOP $.
    $( Obsolete proof of ~ equsal as of 5-Feb-2018.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 12-Aug-2011.)  (Revised
       by Mario Carneiro, 3-Oct-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    equsalOLD $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( weq wal 19.3 syl6bbr pm5.74i albii nfri a1d alrimi ax9o impbii bitr4i
      wi ) CDGZASZCHTBCHZSZCHZBUAUCCTAUBTABUBFBCEIJKLBUDBUCCEBUBTBCEMNOBCDPQR
      $.
  $}

  ${
    equsalh.1 $e |- ( ps -> A. x ps ) $.
    equsalh.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.) $)
    equsalh $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( nfi equsal ) ABCDBCEGFH $.
  $}

  ${
    equsex.1 $e |- F/ x ps $.
    equsex.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)  (Proof shortened
       by Wolf Lammen, 6-Feb-2018.) $)
    equsex $p |- ( E. x ( x = y /\ ph ) <-> ps ) $=
      ( weq wa wex biimpa exlimi wi wal equsal equs4 sylbir impbii ) CDGZAHZCIZ
      BSBCERABFJKBRALCMTABCDEFNACDOPQ $.
    $( Obsolete proof of ~ equsex as of 6-Feb-2018.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    equsexOLD $p |- ( E. x ( x = y /\ ph ) <-> ps ) $=
      ( weq wn wi wex wal exnal df-an exbii nfn notbid equsal con2bii 3bitr4i
      wa ) CDGZAHZIZHZCJUCCKZHUAATZCJBUCCLUFUDCUAAMNUEBUBBHCDBCEOUAABFPQRS $.
  $}

  ${
    equsexh.1 $e |- ( ps -> A. x ps ) $.
    equsexh.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.) $)
    equsexh $p |- ( E. x ( x = y /\ ph ) <-> ps ) $=
      ( nfi equsex ) ABCDBCEGFH $.
  $}

  ${
    $d w x z $.  $d w y $.
    $( Lemma for ~ dveeq2 .  This lemma is equivalent to ~ ax12v with one
       distinct variable constraint removed.  (Contributed by Wolf Lammen,
       8-Sep-2018.)  (New usage is discouraged.) $)
    ax12lem3 $p |- ( -. x = y -> ( E. x z = y -> z = y ) ) $=
      ( vw weq wn wex wi wal ax12lem2 equequ2 biimprcd eximi sylib syl9 alrimdv
      19.36v nfv equsal syl6ib ) ABEFZCBEZAGZDBEZCDEZHZDIUBUAUCUFDUAUDUDAIZUCUE
      ABDJUCUFAGUGUEHUBUFAUDUEUBDBCKZLMUDUEAQNOPUEUBDBUBDRUHST $.
  $}

  ${
    $d x z $.
    $( Quantifier introduction when one pair of variables is distinct.  Revised
       to remove dependency on ~ ax-7 .  (Contributed by NM, 2-Jan-2002.)
       (Revised by NM, 20-Jul-2015.)  (Revised by Wolf Lammen, 8-Sep-2018.) $)
    dveeq2 $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      ( weq wal wn wex wnf exnal nfnf1 ax12lem3 ax12lem2 syld nf2 sylibr exlimi
      wi sylbir nfrd ) ABDZAEFZCBDZAUATFZAGUBAHZTAIUCUDAUBAJUCUBAGZUBAEZQUDUCUE
      UBUFABCKABCLMUBANOPRS $.
  $}

  ${
    $d x z $.
    $( Quantifier introduction when one pair of variables is distinct.  Revised
       to be independent of ~ ax-7 .  (Contributed by NM, 2-Jan-2002.)
       (Revised by Wolf Lammen, 8-Sep-2018.) $)
    dveeq1 $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      ( weq wal wn dveeq2 equcom albii 3imtr3g ) ABDAEFCBDZKAEBCDZLAEABCGCBHZKL
      AMIJ $.
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A variable is effectively not free in an equality if it is not either of
       the involved variables. ` F/ ` version of ~ ax-12o .  Revised to remove
       dependency on ~ ax-7 .  (Contributed by Mario Carneiro, 6-Oct-2016.)
       (Revised by Wolf Lammen, 6-Sep-2018.) $)
    nfeqf $p |- ( ( -. A. z z = x /\ -. A. z z = y ) -> F/ z x = y ) $=
      ( vw weq wal wn wa nfna1 nfan wex ax12lem1 dveeq1 imp equtr2 alanimi an4s
      syl2an ex exlimdv syl5 nfd ) CAEZCFGZCBEZCFGZHZABEZCUDUFCUCCIUECIJUHADEZB
      DEZHZDKUGUHCFZABDLUGUKULDUGUKULUDUIUFUJULUDUIHUICFZUJCFZULUFUJHUDUIUMCADM
      NUFUJUNCBDMNUIUJUHCABDOPRQSTUAUB $.
  $}

  $( Derive set.mm's original ~ ax-12o from the shorter ~ ax-12 .  (Contributed
     by NM, 29-Nov-2015.)  (Revised by NM, 24-Dec-2015.)  (Proof shortened by
     Wolf Lammen, 29-Apr-2018.) $)
  ax12o $p |- ( -. A. z z = x -> ( -. A. z z = y
              -> ( x = y -> A. z x = y ) ) ) $=
    ( weq wal wn wi wa nfeqf nfrd ex ) CADCEFZCBDCEFZABDZNCEGLMHNCABCIJK $.

  ${
    $d w y $.  $d w z $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
       Similar to ~ equvin but with a negated equality.  (Contributed by NM,
       24-Dec-2015.)  (Proof shortened by Wolf Lammen, 20-Jan-2018.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax12olem1OLD $p |- ( E. w ( y = w /\ -. z = w ) <-> -. y = z ) $=
      ( weq wn wa wex ax-8 equcomi syl6 con3and exlimiv ax-17 syl5 con3d jctild
      spimeh impbii ) ACDZBCDZEZFZCGABDZEZUBUDCSUCTSUCCBDZTACBHCBIJKLUDUBCAUDCM
      CADZUDUASUFTUCTUEUFUCBCICABHNOCAIPQR $.
  $}

  ${
    $d w x z $.  $d w y $.
    ax12olem2OLD.1 $e |- ( -. x = y -> ( y = w -> A. x y = w ) ) $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
       Negate the equalities in ~ ax-12 , shown as the hypothesis.
       (Contributed by NM, 24-Dec-2015.)  (Proof shortened by Wolf Lammen,
       23-Jan-2018.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    ax12olem2OLD $p |- ( -. x = y -> ( -. y = z -> A. x -. y = z ) ) $=
      ( weq wn wa wex wal anim1d 19.27v syl6ibr eximdv 19.12 ax12olem1OLD albii
      syl6 3imtr3g ) ABFGZBDFZCDFGZHZDIZUDAJZBCFGZUFAJTUDUCAJZDIUETUCUGDTUCUAAJ
      ZUBHUGTUAUHUBEKUAUBALMNUCDAORBCDPZUDUFAUIQS $.
  $}

  $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
     Show the equivalence of an intermediate equivalent to ~ ax12o with the
     conjunction of ~ ax-12 and a variant with negated equalities.
     (Contributed by NM, 24-Dec-2015.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  ax12olem3OLD $p |- ( ( -. x = y -> ( -. A. x -. y = z -> A. x y = z ) )
         <-> ( ( -. x = y -> ( y = z -> A. x y = z ) )
            /\ ( -. x = y -> ( -. y = z -> A. x -. y = z ) ) ) ) $=
    ( weq wn wal wi wa sp con2i imim1i imim2i con1d jca imim1d com12 imim3i imp
    con1 impbii ) ABDEZBCDZEZAFZEZUBAFZGZGZUAUBUFGZGZUAUCUDGZGZHUHUJULUGUIUAUBU
    EUFUDUBUCAIJKLUGUKUAUGUDUBUFUBUEUBAILMLNUJULUHUIUKUGUAUKUIUGUKUEUBUFUBUDSOP
    QRT $.

  ${
    $d w x z $.  $d w y z $.
    ax12olem4OLD.1 $e |- ( -. x = y -> ( y = z -> A. x y = z ) ) $.
    ax12olem4OLD.2 $e |- ( -. x = y -> ( y = w -> A. x y = w ) ) $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
       Construct an intermediate equivalent to ~ ax-12 from two instances of
       ~ ax-12 .  (Contributed by NM, 24-Dec-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax12olem4OLD $p |- ( -. x = y -> ( -. A. x -. y = z -> A. x y = z ) ) $=
      ( weq wn wal wi ax12olem2OLD ax12olem3OLD mpbir2an ) ABGHZBCGZHZAIZHOAIZJ
      JNORJJNPQJJEABCDFKABCLM $.
  $}

  ${
    ax12olem5OLD.1 $e |- ( -. x = y -> ( -. A. x -. y = z -> A. x y = z ) ) $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
       See ~ ax12olem6OLD for derivation of ~ ax12oOLD from the conclusion.
       (Contributed by NM, 24-Dec-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    ax12olem5OLD $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      ( weq wal wn wex wi exnal 19.8a hbe1 hba1 hbim syl5bi exlimih syl5 sylbir
      df-ex ) ABEZAFGTGZAHZBCEZUCAFZITAJUCUCAHZUBUDUCAKUAUEUDIAUEUDAUCALUCAMNUE
      UCGAFGUAUDUCASDOPQR $.
  $}

  ${
    $d w x $.  $d w y $.  $d w z $.
    ax12olem6OLD.1 $e |- ( -. A. x x = z -> ( z = w -> A. x z = w ) ) $.
    ax12olem6OLD.2 $e |- ( -. A. x x = y -> ( y = w -> A. x y = w ) ) $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
       Derivation of ~ ax12oOLD from the hypotheses, without using
       ~ ax12oOLD .  (Contributed by Andrew Salmon, 21-Jul-2011.)  (Revised by
       NM, 24-Dec-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    ax12olem6OLD $p |- ( -. A. x x = y
      -> ( -. A. x x = z -> ( y = z -> A. x y = z ) ) ) $=
      ( weq wn wi hbn1 hbim1 ax-17 equcom equequ1 syl5bb imbi2d dvelimhw 19.21h
      wal syl6ib pm2.86d ) ABGASHZACGZASHZBCGZUEASZUBUDUEIZUGASUDUFIUDCDGZIUGAB
      DUDUHAUCAJZEKUGDLDBGZUHUEUDUHDCGUJUECDMDBCNOPFQUDUEAUIRTUA $.
  $}

  ${
    $d w x $.  $d w y $.  $d w z $.
    ax12olem7OLD.1 $e |- ( -. x = z -> ( -. A. x -. z = w -> A. x z = w ) ) $.
    ax12olem7OLD.2 $e |- ( -. x = y -> ( -. A. x -. y = w -> A. x y = w ) ) $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  Lemma for ~ ax12oOLD .
       Derivation of ~ ax12oOLD from the hypotheses, without using
       ~ ax12oOLD .  (Contributed by NM, 24-Dec-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax12olem7OLD $p |- ( -. A. x x = y
              -> ( -. A. x x = z -> ( y = z -> A. x y = z ) ) ) $=
      ( ax12olem5OLD ax12olem6OLD ) ABCDACDEGABDFGH $.
  $}

  ${
    $d x w v $.  $d y w v $.  $d z w v $.
    $( Obsolete proof of ~ ax12oOLD as of 30-Jan-2018.  (Contributed by NM,
       29-Nov-2015.)  (Revised by NM, 24-Dec-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax12oOLD $p |- ( -. A. z z = x -> ( -. A. z z = y
              -> ( x = y -> A. z x = y ) ) ) $=
      ( vw vv ax12v ax12olem4OLD ax12olem7OLD ) CABDCBDECBDFCBEFGCADECADFCAEFGH
      $.
  $}

  $( Derive ~ ax-12 from ~ ax12v via ~ ax12o .  This shows that the weakening
     in ~ ax12v is still sufficient for a complete system.  (Contributed by NM,
     21-Dec-2015.)  (Proof shortened by Wolf Lammen, 31-Jan-2018.) $)
  ax12 $p |- ( -. x = y -> ( y = z -> A. x y = z ) ) $=
    ( weq wn wal wi sp con3i ax12o syl2im ax12b mpbir ) ABDZEZBCDZPAFGZGOACDZEZ
    QGGONAFZESRAFZEQTNNAHIUARRAHIBCAJKABCLM $.

  $( Obsolete proof of ~ ax12 as of 31-Jan-2018.  (Contributed by NM,
     21-Dec-2015.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  ax12OLD $p |- ( -. x = y -> ( y = z -> A. x y = z ) ) $=
    ( weq wn wal wi wa sp con3i adantr equtrr equcoms con3rr3 imp nsyl ax12o ex
    sylc pm2.43d ) ABDZEZBCDZUCAFZUBUCUCUDGZUBUCHZUAAFZEZACDZAFZEUEUBUHUCUGUAUA
    AIJKUFUIUJUBUCUIEUCUIUAUIUAGCBCBALMNOUIAIPBCAQSRT $.

  ${
    $d x v w $.  $d y v w $.
    $( Lemma for ~ ax10 .  Change bound variable.  (Contributed by NM,
       22-Jul-2015.) $)
    ax10lem1 $p |- ( A. x x = w -> A. y y = w ) $=
      ( vv weq wal ax-8 cbvalivw syl ) ACEZAFDCEZDFBCEZBFJKADADCGHKLDBDBCGHI $.
  $}

  ${
    $d w z x $.  $d w z y $.
    $( Lemma for ~ ax10 .  Change bound variable.  (Contributed by NM,
       8-Jul-2016.)  (Proof shortened by Wolf Lammen, 17-Feb-2018.) $)
    ax10lem2 $p |- ( A. x x = w -> A. y y = x ) $=
      ( weq wal ax10lem1 equequ2 biimprd al2imi syl5com dveeq1 spsd com12 con1d
      wn pm2.61d ) ACDZAEZQBEZBADZBEZRBCDZBESUAABCFQUBTBQTUBACBGHIJRUASUAOZRSUC
      QSABACKLMNP $.
  $}

  $( Same as ~ ax10o but with reversed antecedent.  (Contributed by NM,
     25-Jul-2015.) $)
  ax10o2 $p |- ( A. y y = x -> ( A. x ph -> A. y ph ) ) $=
    ( weq wal wi ax-11 sps pm2.27 al2imi syld ) CBDZCEABEZLAFZCEZACELMOFCACBGHL
    NACLAIJK $.

  ${
    $d x z $.  $d y z $.
    $( Derive set.mm's original ~ ax-10 from others.  (Contributed by NM,
       25-Jul-2015.)  (Revised by NM, 7-Nov-2015.)  (Proof shortened by Wolf
       Lammen, 6-Mar-2018.) $)
    ax10 $p |- ( A. x x = y -> A. y y = x ) $=
      ( vz weq wal wex wn a9ev equcomi dveeq1 syl5com ax10o2 ax10lem2 syl6 syl9
      wi exlimiv ax-mp pm2.18d ) ABDAEZBADBEZCADZCFTUAGZUAPPZCAHUBUDCUBUCACDZBE
      ZTUAUBUEUCUFCAIBACJKTUFUEAEUAUEBALABCMNOQRS $.
  $}

  ${
    $d x y $.  $d x z $.
    $( Obsolete proof of a lemma for ~ ax10 as of 17-Feb-2018.  Change free
       variable.  (Contributed by NM, 25-Jul-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax10lem2OLD $p |- ( A. x x = y -> A. x x = z ) $=
      ( weq wal wn hbe1 equequ2 biimprd con3rr3 19.8a syl6 ax-17 equequ1 notbid
      wex spimeh pm2.61d1 exlimih exnal 3imtr3i con4i ) ACDZAEZABDZAEZUCFZAPUEF
      ZAPZUDFUFFUGUIAUHAGUGCBDZUIUGUJUHUIUJUEUCUJUCUECBAHIJUHAKLUJFZUHACUKAMUCU
      HUKUCUEUJACBNOIQRSUCATUEATUAUB $.
  $}

  ${
    $d w x y $.  $d w x z $.
    $( Obsolete proof of a lemma for ~ ax10 as of 17-Feb-2018.  Similar to
       ~ ax-10 but with distinct variables.  (Contributed by NM, 25-Jul-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax10lem3OLD $p |- ( A. x x = y -> A. y y = x ) $=
      ( vz vw weq wal ax10lem2OLD ax10lem1 syl ) ABEAFACEAFZBAEBFZABCGJDAEDFZKJ
      DCEDFLADCHDCAGIDBAHII $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ps $.  $d x ph $.
    dvelimvOLD.1 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Obsolete proof of ~ dvelimv as of 17-Feb-2018.  (Contributed by NM,
       25-Jul-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dvelimvOLD $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi ax-17 alrimih a2i alimi syl ax10lem3OLD con3i hbn1 hban
      sp wa a1d syl5ibr ax12o imp a17d hbimd hbald biimpd ax9v con3 al2imi mtoi
      nsyl2 syl56 expcom ax-11 syl2im pm2.27 syld pm2.61d2 ) CDGZCHIZCEGZCHZBBC
      HZJZVEIZVCVGBEDGZAJZEHZVHVCUAZVKCHVFBVIBEHZJZEHVKBVNEBEKZBVMVIVOUBLVNVJEV
      IVMAVMAVIBBETFUCMNOVLVJCEVHVCEVHECGZEHZIZVHEHVQVEECPQVRVHEVPERVEVQCEPQLOV
      CEKSVLVIACVHVCCVDCRVBCRSVHVCVIVICHJEDCUDUEVLACUFUGUHVKBCVKBIZEHZBVKVIBJZE
      HZVTIVJWAEVIABVIABFUIMNWBVTVIIZEHEDUJWAVSWCEVIBUKULUMOVSEKUNNUOUPVEBVDBJZ
      CHZVFVEVDBVMWEVDCTVOBCEUQURVDWDBCVDBUSULUTVA $.
  $}

  ${
    $d w x z $.  $d w y $.
    $( Obsolete proof of ~ dveeq2 as of 25-Feb-2018.  (Contributed by NM,
       2-Jan-2002.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dveeq2OLD $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      ( vw weq equequ2 dvelimvOLD ) CDECBEABDDBCFG $.
  $}

  ${
    $d w z x $.  $d w z y $.
    $( Obsolete proof of ~ ax10lem2 as of 17-Feb-2018.  (Contributed by NM,
       8-Jul-2016.)  (New usage is discouraged.)  (Proof modification is
       discouraged. ) $)
    ax10lem4OLD $p |- ( A. x x = w -> A. y y = x ) $=
      ( vz weq wal wn wi ax10lem1 equequ1 dvelimvOLD hba1 wb equequ2 sps albidh
      biimprd syl6 syl7 spsd pm2.43d com12 pm2.18d ) ACEZAFZBAEZBFZUGGZUEUGUHUE
      UGUHUDUEUGHAUEBCEZBFZUHUDUGABCIUHUDUDBFZUJUGHDCEUDBADDACJKUKUGUJUKUFUIBUD
      BLUDUFUIMBACBNOPQRSTUAUBUC $.
  $}

  ${
    $d w z $.  $d u v w $.  $d v x $.  $d v y $.
    $( Obsolete proof of ~ ax10o2 as of 17-Feb-2018.  (Contributed by NM,
       22-Jul-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    ax10lem5OLD $p |- ( A. z z = w -> A. y y = x ) $=
      ( vv vu weq wal ax10lem1 ax10lem4OLD syl ) CDGCHZAEGAHZBAGBHLFEGFHZMLEDGE
      HNCEDIEFDJKFAEIKABEJK $.
  $}

  ${
    $d x z $.  $d y z $.
    $( Obsolete proof of ~ ax10 as of 17-Feb-2018.  (Contributed by NM,
       25-Jul-2015.)  (Revised by NM, 7-Nov-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    ax10OLD $p |- ( A. x x = y -> A. y y = x ) $=
      ( vz weq wal wn ax9v wex df-ex wi dveeq2OLD imp ax10o2 equcomi alimi syl6
      wa ax10lem5OLD syl56 exp3acom23 pm2.18 exlimdv syl5bir mpi ) ABDAEZCADZFC
      EFZBADBEZCAGUGUFCHUEUHUFCIUEUFUHCUEUFUHFZUHJUHUEUIUFUHUIUFQUFBEZUEACDZAEZ
      UHUIUFUJBACKLUEUJUFAEULUFBAMUFUKACANOPABACRSTUHUAPUBUCUD $.
  $}

  ${
    $d x v z $.  $d y v z $.
    $( Obsolete proof of ~ ax9 as of 4-Feb-2018.  (Contributed by NM,
       12-Nov-2013.)  (Revised by NM, 25-Jul-2015.)
       (New usage is discouraged.)  (Proof modfication is discouraged.) $)
    ax9OLD $p |- -. A. x -. x = y $=
      ( vv weq wal wn sp nsyl3 wi ax9v dveeq2OLD hba1 equequ2 sps notbid albidh
      wb mtbii syl6com con3i alrimiv mt3 pm2.61i ) ABDZAEZUDFZAEZFZUGUDUEUFAGUD
      AGHUEFZUHIZCBDZFZCECBJUJFULCUKUJUIUKUKAEZUHABCKUMACDZFZAEUGACJUMUOUFAUKAL
      UMUNUDUKUNUDQACBAMNOPRSTUAUBUC $.
  $}

  $( Obsolete proof of ~ a9e as of 4-Feb-2018.  (Contributed by NM,
     5-Aug-1993.)  (New usage is discouraged.)  (Proof modfication is
     discouraged.) $)
  a9eOLD $p |- E. x x = y $=
    ( weq wex wn wal ax9 df-ex mpbir ) ABCZADJEAFEABGJAHI $.

  $( Commutation law for identical variable specifiers.  The antecedent and
     consequent are true when ` x ` and ` y ` are substituted with the same
     variable.  Lemma L12 in [Megill] p. 445 (p. 12 of the preprint).
     (Contributed by NM, 5-Aug-1993.) $)
  aecom $p |- ( A. x x = y -> A. y y = x ) $=
    ( ax10 ) ABC $.

  ${
    aecoms.1 $e |- ( A. x x = y -> ph ) $.
    $( A commutation rule for identical variable specifiers.  (Contributed by
       NM, 5-Aug-1993.) $)
    aecoms $p |- ( A. y y = x -> ph ) $=
      ( weq wal ax10 syl ) CBECFBCEBFACBGDH $.
  $}

  ${
    naecoms.1 $e |- ( -. A. x x = y -> ph ) $.
    $( A commutation rule for distinct variable specifiers.  (Contributed by
       NM, 2-Jan-2002.) $)
    naecoms $p |- ( -. A. y y = x -> ph ) $=
      ( weq wal ax10 nsyl4 con1i ) ACBECFZBCEBFJABCGDHI $.
  $}

  $( Show that ~ ax-10o can be derived from ~ ax-10 in the form of ~ ax10 .
     Normally, ~ ax10o should be used rather than ~ ax-10o , except by theorems
     specifically studying the latter's properties.  (Contributed by NM,
     16-May-2008.)  (Proof shortened by Wolf Lammen, 21-Apr-2018.) $)
  ax10o $p |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $=
    ( wal wi ax10o2 aecoms ) ABDACDECBABCFG $.

  $( Obsolete proof of ~ ax10o as of 21-Apr-2018.  (Contributed by NM,
     16-May-2008.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax10oOLD $p |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $=
    ( weq wal wi ax10 ax-11 equcoms sps pm2.27 al2imi sylsyld ) BCDZBECBDZCEABE
    ZOAFZCEZACEBCGNPRFZBSCBACBHIJOQACOAKLM $.

  $( All variables are effectively bound in an identical variable specifier.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen,
     21-Apr-2018.) $)
  hbae $p |- ( A. x x = y -> A. z A. x x = y ) $=
    ( weq wal wi wn ax12o syl7 ax10o2 ax10o pm2.43i syl5 pm2.61ii a5i ax-7 syl
    sp ) ABDZAEZSCEZAETCESUAACADCEZCBDCEZTUAFTSUBGUCGUASARABCHISACJTSBEZUCUATUD
    SABKLSBCJMNOSACPQ $.

  $( Obsolete proof of ~ hbae as of 21-Apr-2018.  (Contributed by NM,
     5-Aug-1993.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  hbaeOLD $p |- ( A. x x = y -> A. z A. x x = y ) $=
    ( weq wal wi wn ax12o syl7 ax10o aecoms pm2.43i syl5 pm2.61ii a5i ax-7 syl
    sp ) ABDZAEZSCEZAETCESUAACADCEZCBDCEZTUAFZTSUBGUCGUASARABCHIUDACSACJKUDBCTS
    BEZBCDBEUATUESABJLSBCJMKNOSACPQ $.

  $( All variables are effectively bound in an identical variable specifier.
     (Contributed by Mario Carneiro, 11-Aug-2016.) $)
  nfae $p |- F/ z A. x x = y $=
    ( weq wal hbae nfi ) ABDAECABCFG $.

  $( All variables are effectively bound in a distinct variable specifier.
     Lemma L19 in [Megill] p. 446 (p. 14 of the preprint).  (Contributed by NM,
     5-Aug-1993.) $)
  hbnae $p |- ( -. A. x x = y -> A. z -. A. x x = y ) $=
    ( weq wal hbae hbn ) ABDAECABCFG $.

  $( All variables are effectively bound in a distinct variable specifier.
     (Contributed by Mario Carneiro, 11-Aug-2016.) $)
  nfnae $p |- F/ z -. A. x x = y $=
    ( weq wal nfae nfn ) ABDAECABCFG $.

  ${
    hbnalequs.1 $e |- ( A. z -. A. x x = y -> ph ) $.
    $( Rule that applies ~ hbnae to antecedent.  (Contributed by NM,
       5-Aug-1993.) $)
    hbnaes $p |- ( -. A. x x = y -> ph ) $=
      ( weq wal wn hbnae syl ) BCFBGHZKDGABCDIEJ $.
  $}

  ${
    $d w z $.  $d u v w $.  $d v x $.  $d v y $.
    $( Lemma for ~ aev and ~ a16g .  Change free and bound variables.
       (Contributed by NM, 22-Jul-2015.)  (Proof shortened by Wolf Lammen,
       17-Feb-2018.) $)
    aevlem1 $p |- ( A. z z = w -> A. y y = x ) $=
      ( vv vu weq wal ax10lem1 ax10lem2 4syl ) CDGCHEDGEHFEGFHAEGAHBAGBHCEDIEFD
      JFAEIABEJK $.
  $}

  ${
    $d x y $.  $d w ph $.
    $( Generalization of ~ ax16 .  (Contributed by NM, 25-Jul-2015.)  (Proof
       shortened by Wolf Lammen, 18-Feb-2018.) $)
    a16g $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      ( vw weq wal aevlem1 ax-17 ax10o syl2im ) BCFBGEDFEGAAEGADGDEBCHAEIAEDJK
      $.
  $}

  ${
    $d u v $.  $d u x y $.  $d u w $.
    $( A "distinctor elimination" lemma with no restrictions on variables in
       the consequent.  Revised to remove a dependency on ~ ax-7 .
       (Contributed by NM, 8-Nov-2006.)  (Revised by Wolf Lammen,
       7-Sep-2018.) $)
    aev $p |- ( A. x x = y -> A. z w = v ) $=
      ( vu weq wal aevlem1 ax-8 spimv syl a16g mpd ) ABGAHZDEGZPCHOFEGZFHPEFABI
      QPFDFDEJKLPABCMN $.
    $( A "distinctor elimination" lemma with no restrictions on variables in
       the consequent.  (Contributed by NM, 8-Nov-2006.)
       (New usage is discouraged.) $)
    aevALT $p |- ( A. x x = y -> A. z w = v ) $=
      ( vu weq wal hbae aevlem1 ax-8 spimv syl alrimih ) ABGAHZDEGZCABCIOFEGZFH
      PEFABJQPFDFDEKLMN $.
  $}

  ${
    $d x y $.  $d w ph $.  $d w z $.
    $( Obsolete proof of ~ a16g as of 18-Feb-2018.  (Contributed by NM,
       25-Jul-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    a16gOLD $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      ( vw weq wex wi a9ev aevlem1 wn hbn1 pm2.21 alrimih ax-17 ax-1 ja equcomi
      wal ax-11 syl2im ax-5 syl6 com23 syl5 exlimih mpsyl ) EDFZEGBCFBSUHESZAAD
      SZHZEDIDEBCJUHUIUKHZEUIUKULESUIKULEUHELUIUKMNUKULEUKEOUKUIPNQUIDEFZDSZUHU
      KEDEDJUHAUNUJUHAUMAHDSZUNUJHUHUMAAESUOEDRAEOADETUAUMADUBUCUDUEUFUG $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Proof of older axiom ~ ax-16 .  (Contributed by NM, 8-Nov-2006.)
       (Revised by NM, 22-Sep-2017.) $)
    ax16 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( a16g ) ABCBD $.
  $}

  ${
    $d x y z $.  $d z ph $.
    ax16i.1 $e |- ( x = z -> ( ph <-> ps ) ) $.
    ax16i.2 $e |- ( ps -> A. x ps ) $.
    $( Inference with ~ ax16 as its conclusion.  (Contributed by NM,
       20-May-2008.)  (Proof modification is discouraged.) $)
    ax16i $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( weq wal wi nfv ax-8 cbv3 spimv equcomi syl syl5com alimdv mpcom alimi
      biimpcd nfi biimprd syl6com 3syl ) CDHZCIEDHZEIZCEHZEIZAACIZJUFUGCEUFEKUG
      CKCEDLMUHECHZEIZUJUFUHUMUGUFECECDLNUFUGULEUFDCHZUGULCDOUGDEHUNULJEDODECLP
      QRSULUIEECOZTPAUJBEIUKAUIBEUIABFUARBAECBCGUBAEKULUIBAJUOUIABFUCPMUDUE $.
  $}

  ${
    $d x y $.  $d z w $.
    $( If ~ dtru is false, then there is only one element in the universe, so
       everything satisfies ` F/ ` .  Revised to remove dependency on ~ ax-7 .
       (Contributed by Mario Carneiro, 7-Oct-2016.)  (Revised by Wolf Lammen,
       9-Sep-2018.) $)
    a16nf $p |- ( A. x x = y -> F/ z ph ) $=
      ( vw weq wal wnf aev nfa1 a16g nfd syl ) BCFBGDEFZDGZADHBCDDEIOADNDJADEDK
      LM $.
  $}

  ${
    $d x y $.
    $( A generalization of axiom ~ ax-16 .  (Contributed by NM, 5-Aug-1993.) $)
    a16gb $p |- ( A. x x = y -> ( ph <-> A. z ph ) ) $=
      ( weq wal a16g sp impbid1 ) BCEBFAADFABCDGADHI $.

    $( If ~ dtru is false, then there is only one element in the universe, so
       everything satisfies ` F/ ` .  (Contributed by Mario Carneiro,
       7-Oct-2016.)  (New usage is discouraged.) $)
    a16nfALT $p |- ( A. x x = y -> F/ z ph ) $=
      ( weq wal nfae a16g nfd ) BCEBFADBCDGABCDHI $.
  $}

  $( Obsolete proof of ~ nfeqf as of 29-Apr-2018.  (Contributed by Mario
     Carneiro, 6-Oct-2016.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  nfeqfOLD $p |- ( ( -. A. z z = x /\ -. A. z z = y ) -> F/ z x = y ) $=
    ( weq wal wn wa nfnae nfan wi ax12o imp nfd ) CADCEFZCBDCEFZGABDZCNOCCACHCB
    CHINOPPCEJABCKLM $.

  ${
    dral1.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 27-Feb-2005.)  (Revised by Wolf Lammen,
       4-Mar-2018.) $)
    dral2 $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
      ( weq wal nfae albid ) CDGCHABECDEIFJ $.

    $( Obsolete proof of ~ dral2 as of 4-Mar-2018.  (Contributed by NM,
       27-Feb-2005.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dral2OLD $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
      ( weq wal hbae albidh ) CDGCHABECDEIFJ $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  Revised to
       remove dependency on ~ ax-7 .  (Contributed by NM, 24-Nov-1994.)  (Proof
       revised by Wolf Lammen, 6-Sep-2018.) $)
    dral1 $p |- ( A. x x = y -> ( A. x ph <-> A. y ps ) ) $=
      ( weq wal nfa1 albid ax10o ax10o2 impbid bitrd ) CDFZCGZACGBCGZBDGZOABCNC
      HEIOPQBCDJBDCKLM $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 24-Nov-1994.)  (Proof shortened by Wolf Lammen,
       22-Apr-2018.)  (New usage is discouraged.) $)
    dral1ALT $p |- ( A. x x = y -> ( A. x ph <-> A. y ps ) ) $=
      ( weq wal dral2 ax10o ax10o2 impbid bitrd ) CDFCGZACGBCGZBDGZABCDCEHMNOBC
      DIBDCJKL $.

    $( Obsolete proof of ~ dral1 as of 4-Mar-2018.  (Contributed by NM,
       24-Nov-1994.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dral1OLD $p |- ( A. x x = y -> ( A. x ph <-> A. y ps ) ) $=
      ( weq wal hbae biimpd alimdh ax10o syld biimprd wi aecoms impbid ) CDFCGZ
      ACGZBDGZQRBCGSQABCCDCHQABEIJBCDKLQSADGZRQBADCDDHQABEMJTRNDCADCKOLP $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 27-Feb-2005.) $)
    drex1 $p |- ( A. x x = y -> ( E. x ph <-> E. y ps ) ) $=
      ( weq wal wn wex notbid dral1 df-ex 3bitr4g ) CDFCGZAHZCGZHBHZDGZHACIBDIN
      PROQCDNABEJKJACLBDLM $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 27-Feb-2005.) $)
    drex2 $p |- ( A. x x = y -> ( E. z ph <-> E. z ps ) ) $=
      ( weq wal hbae exbidh ) CDGCHABECDEIFJ $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       (Contributed by Mario Carneiro, 4-Oct-2016.) $)
    drnf1 $p |- ( A. x x = y -> ( F/ x ph <-> F/ y ps ) ) $=
      ( weq wal wi wnf dral1 imbi12d df-nf 3bitr4g ) CDFCGZAACGZHZCGBBDGZHZDGAC
      IBDIPRCDNABOQEABCDEJKJACLBDLM $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       (Contributed by Mario Carneiro, 4-Oct-2016.)  (Proof shortened by Wolf
       Lammen, 5-May-2018.) $)
    drnf2 $p |- ( A. x x = y -> ( F/ z ph <-> F/ z ps ) ) $=
      ( weq wal nfae nfbidf ) CDGCHABECDEIFJ $.

    $( Obsolete proof of ~ drnf2 as of 5-May-2018.  (Contributed by Mario
       Carneiro, 4-Oct-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    drnf2OLD $p |- ( A. x x = y -> ( F/ z ph <-> F/ z ps ) ) $=
      ( weq wal wi wnf dral2 imbi12d df-nf 3bitr4g ) CDGCHZAAEHZIZEHBBEHZIZEHAE
      JBEJQSCDEOABPRFABCDEFKLKAEMBEMN $.
  $}

  ${
    nfald2.1 $e |- F/ y ph $.
    nfald2.2 $e |- ( ( ph /\ -. A. x x = y ) -> F/ x ps ) $.
    $( Variation on ~ nfald which adds the hypothesis that ` x ` and ` y ` are
       distinct in the inner subproof.  (Contributed by Mario Carneiro,
       8-Oct-2016.) $)
    nfald2 $p |- ( ph -> F/ x A. y ps ) $=
      ( weq wal wnf wn wa nfnae nfan nfald ex nfa1 biidd drnf1 mpbiri pm2.61d2
      ) ACDGCHZBDHZCIZAUAJZUCAUDKBCDAUDDECDDLMFNOUAUCUBDIBDPUBUBCDUAUBQRST $.

    $( Variation on ~ nfexd which adds the hypothesis that ` x ` and ` y ` are
       distinct in the inner subproof.  (Contributed by Mario Carneiro,
       8-Oct-2016.) $)
    nfexd2 $p |- ( ph -> F/ x E. y ps ) $=
      ( wex wn wal df-ex weq wa nfnd nfald2 nfxfrd ) BDGBHZDIZHACBDJAQCAPCDEACD
      KCIHLBCFMNMO $.
  $}

  ${
    exdistrf.1 $e |- ( -. A. x x = y -> F/ y ph ) $.
    $( Distribution of existential quantifiers, with a bound-variable
       hypothesis saying that ` y ` is not free in ` ph ` , but ` x ` can be
       free in ` ph ` (and there is no distinct variable condition on ` x ` and
       ` y ` ).  (Contributed by Mario Carneiro, 20-Mar-2013.)  (Proof
       shortened by Wolf Lammen, 14-May-2018.) $)
    exdistrf $p |- ( E. x E. y ( ph /\ ps ) -> E. x ( ph /\ E. y ps ) ) $=
      ( wa wex weq wal wi 19.8a anim2i eximi biidd drex1 syl5ibr wn 19.40 19.9d
      nfe1 anim1d syl56 pm2.61i exlimi ) ABFZDGZABDGZFZCGZCUHCTCDHCIZUFUIJUFUIU
      JUHDGUEUHDBUGABDKLMUHUHCDUJUHNOPUFADGZUGFUJQZUHUIABDRULUKAUGAULDESUAUHCKU
      BUCUD $.
    $( Obsolete proof of ~ exdistrf as of 14-May-2018.  (Contributed by Mario
       Carneiro, 20-Mar-2013.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    exdistrfOLD $p |- ( E. x E. y ( ph /\ ps ) -> E. x ( ph /\ E. y ps ) ) $=
      ( weq wal wa wex wi biidd drex1 drex2 nfe1 19.9 19.8a eximi sylbi syl6bir
      anim2i wn nfnae 19.40 19.9d anim1d syl5 eximd pm2.61i ) CDFCGZABHZDIZCIZA
      BDIZHZCIZJUIULUJCIZCIZUOUPUKCDCUJUJCDUIUJKLMUQUPUOUPCUJCNOUJUNCBUMABDPTQR
      SUIUAZUKUNCCDCUBUKADIZUMHURUNABDUCURUSAUMAURDEUDUEUFUGUH $.
  $}

  ${
    dvelimf.1 $e |- F/ x ph $.
    dvelimf.2 $e |- F/ z ps $.
    dvelimf.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelimv without any variable restrictions.  (Contributed by
       NM, 1-Oct-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.)  (Proof
       shortened by Wolf Lammen, 11-May-2018.) $)
    dvelimf $p |- ( -. A. x x = y -> F/ x ps ) $=
      ( weq wi wal wn equsal bicomi nfnae wa wnf nfeqf ancoms a1i nfald2 nfxfrd
      nfimd ) BEDIZAJZEKZCDICKLZCUFBABEDGHMNUGUECECDEOUGCEICKLZPZUDACUHUGUDCQED
      CRSACQUIFTUCUAUB $.

    $( Obsolete proof of ~ dvelimf as of 21-Apr-2018.  (Contributed by NM,
       1-Oct-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dvelimfOLD $p |- ( -. A. x x = y -> F/ x ps ) $=
      ( weq wi wal wn equsal bicomi nfnae wa nfan ax12o impcom nfd nfimd nfald2
      wnf a1i nfxfrd ) BEDIZAJZEKZCDICKLZCUHBABEDGHMNUIUGCECDEOUICEICKLZPZUFACU
      KUFCUIUJCCDCOCECOQUJUIUFUFCKJEDCRSTACUCUKFUDUAUBUE $.
  $}

  ${
    dvelimdf.1 $e |- F/ x ph $.
    dvelimdf.2 $e |- F/ z ph $.
    dvelimdf.3 $e |- ( ph -> F/ x ps ) $.
    dvelimdf.4 $e |- ( ph -> F/ z ch ) $.
    dvelimdf.5 $e |- ( ph -> ( z = y -> ( ps <-> ch ) ) ) $.
    $( Deduction form of ~ dvelimf .  This version may be useful if we want to
       avoid ~ ax-17 and use ~ ax-16 instead.  (Contributed by NM,
       7-Apr-2004.)  (Revised by Mario Carneiro, 6-Oct-2016.)  (Proof shortened
       by Wolf Lammen, 11-May-2018.) $)
    dvelimdf $p |- ( ph -> ( -. A. x x = y -> F/ x ch ) ) $=
      ( weq wal wn wi wnf nfim1 wb com12 pm5.74d dvelimf pm5.5 nfbidf syl5ib )
      DELDMNACOZDPACDPABOUEDEFABDGIQACFHJQFELZABCAUFBCRKSTUAAUECDGACUBUCUD $.
  $}

  ${
    dvelimh.1 $e |- ( ph -> A. x ph ) $.
    dvelimh.2 $e |- ( ps -> A. z ps ) $.
    dvelimh.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelim without any variable restrictions.  (Contributed by
       NM, 1-Oct-2002.)  (Proof shortened by Wolf Lammen, 11-May-2018.) $)
    dvelimh $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn nfi dvelimf nfrd ) CDICJKBCABCDEACFLBEGLHMN $.


    $( Obsolete proof of ~ dvelimh as of 4-Mar-2018.  (Contributed by NM,
       1-Oct-2002.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dvelimhOLD $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi hba1 ax10o aecoms syl5 a1d wa hbnae hban ax12o imp a1i ex
      hbimd hbald pm2.61i equsalh albii 3imtr3g ) CDICJKZEDIZALZEJZUNCJZBBCJCEI
      CJZUKUNUOLZLUPUQUKUNUNEJZUPUOUMEMURUOLECUNECNOPQUPKZUKUQUSUKRZUMCEUSUKECE
      ESCDESTUTULACUSUKCCECSCDCSTUSUKULULCJLEDCUAUBAACJLUTFUCUEUFUDUGABEDGHUHZU
      NBCVAUIUJ $.
  $}

  ${
    $d z ps $.
    dvelim.1 $e |- ( ph -> A. x ph ) $.
    dvelim.2 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( This theorem can be used to eliminate a distinct variable restriction on
       ` x ` and ` z ` and replace it with the "distinctor" ` -. A. x x = y `
       as an antecedent. ` ph ` normally has ` z ` free and can be read
       ` ph ( z ) ` , and ` ps ` substitutes ` y ` for ` z ` and can be read
       ` ph ( y ) ` .  We don't require that ` x ` and ` y ` be distinct: if
       they aren't, the distinctor will become false (in multiple-element
       domains of discourse) and "protect" the consequent.

       To obtain a closed-theorem form of this inference, prefix the hypotheses
       with ` A. x A. z ` , conjoin them, and apply ~ dvelimdf .

       Other variants of this theorem are ~ dvelimh (with no distinct variable
       restrictions), ~ dvelimhw (that avoids ~ ax-12 ), and ~ dvelimALT (that
       avoids ~ ax-10 ).  (Contributed by NM, 23-Nov-1994.) $)
    dvelim $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( ax-17 dvelimh ) ABCDEFBEHGI $.
  $}

  ${
    $d x ph $.  $d z ps $.
    dvelimv.1 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Similar to ~ dvelim with first hypothesis replaced by distinct variable
       condition.  (Contributed by NM, 25-Jul-2015.)  (Proof shortened by Wolf
       Lammen, 30-Apr-2018.) $)
    dvelimv $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( ax-17 dvelim ) ABCDEACGFH $.
  $}

  ${
    $d z ps $.
    dvelimnf.1 $e |- F/ x ph $.
    dvelimnf.2 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelim using "not free" notation.  (Contributed by Mario
       Carneiro, 9-Oct-2016.) $)
    dvelimnf $p |- ( -. A. x x = y -> F/ x ps ) $=
      ( nfv dvelimf ) ABCDEFBEHGI $.
  $}

  ${
    $d w x z $.  $d w y $.
    $( Obsolete proof of ~ dveeq1 as of 25-Feb-2018.  (Contributed by NM,
       2-Jan-2002.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    dveeq1OLD $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      ( vw weq equequ1 dvelimv ) DCEBCEABDDBCFG $.

    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.)  (Revised by NM, 20-Jul-2015.)
       (New usage is discouraged.) $)
    dveeq2ALT $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      ( vw weq equequ2 dvelimv ) CDECBEABDDBCFG $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11v2.1 $e |- ( x = z -> ( ph -> A. x ( x = z -> ph ) ) ) $.
    $( Recovery of ~ ax-11o from ~ ax11v .  This proof uses ~ ax-10 and
       ~ ax-11 .  TODO: figure out if this is useful, or if it should be
       simplified or eliminated.  (Contributed by NM, 2-Feb-2007.)  (Proof
       shortened by Wolf Lammen, 21-Apr-2018.) $)
    ax11v2 $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( weq wal wn wex wi a9ev dveeq2 wb equequ2 sps nfa1 imbi1d imbi2d imbi12d
      albid mpbii syl6 exlimdv mpi ) BCFZBGHZDCFZDIUEAUEAJZBGZJZJZDCKUFUGUKDUFU
      GUGBGZUKBCDLULBDFZAUMAJZBGZJZJUKEULUMUEUPUJUGUMUEMBDCBNOZULUOUIAULUNUHBUG
      BPULUMUEAUQQTRSUAUBUCUD $.

    $( Obsolete proof of ~ ax11v2 as of 21-Apr-2018.  (Contributed by NM,
       2-Feb-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11v2OLD $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( weq wal wn wex wi a9ev wa wb equequ2 adantl dveeq2 imp nfa1 imbi1d sps
      albid syl imbi2d imbi12d mpbii ex exlimdv mpi ) BCFZBGHZDCFZDIUIAUIAJZBGZ
      JZJZDCKUJUKUODUJUKUOUJUKLZBDFZAUQAJZBGZJZJUOEUPUQUIUTUNUKUQUIMUJDCBNZOUPU
      SUMAUPUKBGZUSUMMUJUKVBBCDPQVBURULBUKBRUKURULMBUKUQUIAVASTUAUBUCUDUEUFUGUH
      $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11a2.1 $e |- ( x = z -> ( A. z ph -> A. x ( x = z -> ph ) ) ) $.
    $( Derive ~ ax-11o from a hypothesis in the form of ~ ax-11 . ~ ax-10 and
       ~ ax-11 are used by the proof, but not ~ ax-10o or ~ ax-11o .  TODO:
       figure out if this is useful, or if it should be simplified or
       eliminated.  (Contributed by NM, 2-Feb-2007.) $)
    ax11a2 $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( wal weq wi ax-17 syl5 ax11v2 ) ABCDAADFBDGZLAHBFADIEJK $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( Derivation of set.mm's original ~ ax-11o from ~ ax-10 and the shorter
       ~ ax-11 that has replaced it.

       Theorem ~ ax11 shows the reverse derivation of ~ ax-11 from ~ ax-11o .

       Normally, ~ ax11o should be used rather than ~ ax-11o , except by
       theorems specifically studying the latter's properties.  (Contributed by
       NM, 3-Feb-2007.) $)
    ax11o $p |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( vz ax-11 ax11a2 ) ABCDABDEF $.
  $}

  $( A bidirectional version of ~ ax11o .  (Contributed by NM, 30-Jun-2006.) $)
  ax11b $p |- ( ( -. A. x x = y /\ x = y ) ->
              ( ph <-> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wa wi ax11o imp sp com12 adantl impbid ) BCDZBEFZOGAOAHZBEZPOA
    RHABCIJORAHPROAQBKLMN $.

  $( A variable introduction law for equality.  Lemma 15 of [Monk2] p. 109,
     however we do not require ` z ` to be distinct from ` x ` and ` y `
     (making the proof longer).  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 25-May-2011.)  (Proof shortened by Wolf
     Lammen, 15-Sep-2018.) $)
  equvini $p |- ( x = y -> E. z ( x = z /\ z = y ) ) $=
    ( weq wa wex wi equtr equequ2 biimprd anc2ri syli 19.8a syl6 wn ax12 eximii
    wal a9e 19.35i pm2.61i ) CADZABDZACDZCBDZEZCFZGUBUCUFUGUCUBUEUFCABHUEUCUDUE
    UDUCCBAIJKZLUFCMNUBOUCUCCRUGCABPUCUFCUEUCUFGCCBSUHQTNUA $.

  $( Obsolete proof of ~ equvini as of 7-Apr-2018.  (Contributed by NM,
     5-Aug-1993.)  (Proof shortened by Andrew Salmon, 25-May-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  equviniOLD $p |- ( x = y -> E. z ( x = z /\ z = y ) ) $=
    ( weq wal wa wex wi equcomi alimi a9e jctir 19.29 syl6 eximii anc2ri 19.29r
    a1d a1ii wn wo ioran nfeqf ax-8 anc2li equcoms spimed sylbi ecase3 ) CADZCE
    ZCBDZCEZABDZACDZULFZCGZHZUKUNUOCEZULCGZFZUQUKVAUNUKUSUTUJUOCCAIZJCBKLRUOULC
    MNUMUNUOCGZUMFUQUMUNVCUMUNVCUJUOCCAKVBOSPUOULCQNUKUMUATUKTUMTFZURUKUMUBUNUP
    VDCAABCUCUNUPHACUOUNULACBUDUEUFUGUHUI $.

  $( A variable elimination law for equality with no distinct variable
     requirements.  (Compare ~ equvini .)  (Contributed by NM, 1-Mar-2013.)
     (Proof shortened by Mario Carneiro, 17-Oct-2016.)  (Proof shortened by
     Wolf Lammen, 11-Sep-2018.) $)
  equveli $p |- ( A. z ( z = x <-> z = y ) -> x = y ) $=
    ( weq wb wal wi wex wn a9e bi2 ax-8 com12 eximii 19.35i wnf nfeqf ex al2imi
    syli nf2 syl6ib syl7 bi1 syld pm2.61ii 19.21bi ) CADZCBDZEZCFZABDZCUHCFZUIC
    FZUKULCFZGUKULCHZUMIZUNIZUOUJULCUIUJULGCCBJUJUIULUIUJUHULUHUIKCABLZTMZNOUQU
    RULCPZUPUOGUQURVAABCQRULCUAUBUCUHUJULCUHUJUIULUJUHUIUHUIUDMUSUESUIUJULCUTSU
    FUG $.

  $( Obsolete proof of ~ equveli as of 15-Apr-2018.  (Contributed by NM,
     1-Mar-2013.)  (Proof shortened by Mario Carneiro, 17-Oct-2016.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  equveliOLD $p |- ( A. z ( z = x <-> z = y ) -> x = y ) $=
    ( weq wb wal wi wa albiim equequ1 imbi12d sps dral1 equid sp equcomi syl6bi
    mpi wn pm2.61i syl adantld dral2 a1bi biimpri a1d wnf nfeqf equtr ax-8 mpii
    imim12d ax-gen spimt sylancl ex adantrd sylbi ) CADZCBDZECFUSUTGZCFZUTUSGZC
    FZHZABDZUSUTCIUTCFZVEVFGVGVDVFVBVGVDBBDZBADZGZBFZVFVCVJCBUTVCVJECUTUTVHUSVI
    CBBJCBAJKLMVKVIVFVKVHVIBNVJBORBAPUAQUBVGSZVBVFVDUSCFZVLVBVFGZGVMVNVLVMVBAAD
    ZVFGZCFVFVAVPCACUSVAVPECUSUSVOUTVFCAAJCABJKLUCVPVFCVFVPVOVFANZUDUELQUFVMSZV
    LVNVRVLHVFCUGUSVAVFGGZCFVNABCUHVSCUSVAVOVFVQUSVOUSUTVFCAAUICABUJULUKUMVAVFC
    AUNUOUPTUQTUR $.

  ${
    $d x z $.  $d y z $.
    $( A variable introduction law for equality.  Lemma 15 of [Monk2] p. 109.
       (Contributed by NM, 5-Aug-1993.) $)
    equvin $p |- ( x = y <-> E. z ( x = z /\ z = y ) ) $=
      ( weq wa wex equvini equtr imp exlimiv impbii ) ABDZACDZCBDZEZCFABCGOLCMN
      LACBHIJK $.
  $}

  ${
    equs45f.1 $e |- F/ y ph $.
    $( Two ways of expressing substitution when ` y ` is not free in ` ph ` .
       (Contributed by NM, 25-Apr-2008.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    equs45f $p |- ( E. x ( x = y /\ ph ) <-> A. x ( x = y -> ph ) ) $=
      ( weq wa wex wi wal nfri anim2i eximi equs5a syl equs4 impbii ) BCEZAFZBG
      ZQAHBIZSQACIZFZBGTRUBBAUAQACDJKLABCMNABCOP $.
  $}

  $( Lemma used in proofs of substitution properties.  (Contributed by NM,
     5-Aug-1993.) $)
  equs5 $p |- ( -. A. x x = y ->
             ( E. x ( x = y /\ ph ) -> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wa wi nfna1 nfa1 ax11o imp3a exlimd ) BCDZBEFZNAGNAHZBEZBNBIPB
    JONAQABCKLM $.

  $( One direction of a simplified definition of substitution.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb2 $p |- ( A. x ( x = y -> ph ) -> [ y / x ] ph ) $=
    ( weq wi wal wa wex wsb sp equs4 df-sb sylanbrc ) BCDZAEZBFONAGBHABCIOBJABC
    KABCLM $.

  $( The specialization axiom of standard predicate calculus.  It states that
     if a statement ` ph ` holds for all ` x ` , then it also holds for the
     specific case of ` y ` (properly) substituted for ` x ` .  Translated to
     traditional notation, it can be read:  " ` A. x ph ( x ) -> ph ( y ) ` ,
     provided that ` y ` is free for ` x ` in ` ph ( x ) ` ."  Axiom 4 of
     [Mendelson] p. 69.  See also ~ spsbc and ~ rspsbc .  (Contributed by NM,
     5-Aug-1993.) $)
  stdpc4 $p |- ( A. x ph -> [ y / x ] ph ) $=
    ( wal weq wi wsb ax-1 alimi sb2 syl ) ABDBCEZAFZBDABCGAMBALHIABCJK $.

  ${
    sbt.1 $e |- ph $.
    $( A substitution into a theorem remains true.  (See ~ chvar and ~ chvarv
       for versions using implicit substitution.)  (Contributed by NM,
       21-Jan-2004.)  (Proof shortened by Andrew Salmon, 25-May-2011.)  (Proof
       shortened by Wolf Lammen, 20-Jul-2018.) $)
    sbt $p |- [ y / x ] ph $=
      ( wsb stdpc4 mpg ) AABCEBABCFDG $.
  $}

  $( One direction of a simplified definition of substitution when variables
     are distinct.  (Contributed by NM, 5-Aug-1993.) $)
  sb3 $p |- ( -. A. x x = y -> ( E. x ( x = y /\ ph ) -> [ y / x ] ph ) ) $=
    ( weq wal wn wa wex wi wsb equs5 sb2 syl6 ) BCDZBEFNAGBHNAIBEABCJABCKABCLM
    $.

  $( One direction of a simplified definition of substitution when variables
     are distinct.  (Contributed by NM, 5-Aug-1993.) $)
  sb4 $p |- ( -. A. x x = y -> ( [ y / x ] ph -> A. x ( x = y -> ph ) ) ) $=
    ( wsb weq wa wex wal wn wi sb1 equs5 syl5 ) ABCDBCEZAFBGNBHINAJBHABCKABCLM
    $.

  $( Simplified definition of substitution when variables are distinct.
     (Contributed by NM, 27-May-1997.) $)
  sb4b $p |- ( -. A. x x = y -> ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wsb wi sb4 sb2 impbid1 ) BCDZBEFABCGLAHBEABCIABCJK $.

  $( Bound-variable hypothesis builder for substitution.  (Contributed by NM,
     5-Aug-1993.) $)
  hbsb2 $p |- ( -. A. x x = y -> ( [ y / x ] ph -> A. x [ y / x ] ph ) ) $=
    ( weq wal wn wsb wi sb4 sb2 a5i syl6 ) BCDZBEFABCGZMAHZBENBEABCIONBABCJKL
    $.

  $( Bound-variable hypothesis builder for substitution.  (Contributed by Mario
     Carneiro, 4-Oct-2016.) $)
  nfsb2 $p |- ( -. A. x x = y -> F/ x [ y / x ] ph ) $=
    ( weq wal wn wsb nfna1 hbsb2 nfd ) BCDZBEFABCGBKBHABCIJ $.

  $( Special case of a bound-variable hypothesis builder for substitution.
     (Contributed by NM, 2-Feb-2007.) $)
  hbsb2a $p |- ( [ y / x ] A. y ph -> A. x [ y / x ] ph ) $=
    ( wal wsb weq wi sb4a sb2 a5i syl ) ACDBCEBCFAGZBDABCEZBDABCHLMBABCIJK $.

  $( Special case of a bound-variable hypothesis builder for substitution.
     (Contributed by NM, 2-Feb-2007.) $)
  hbsb2e $p |- ( [ y / x ] ph -> A. x [ y / x ] E. y ph ) $=
    ( wsb weq wex wi wal sb4e sb2 a5i syl ) ABCDBCEACFZGZBHMBCDZBHABCINOBMBCJKL
    $.

  ${
    hbsb3.1 $e |- ( ph -> A. y ph ) $.
    $( If ` y ` is not free in ` ph ` , ` x ` is not free in
       ` [ y / x ] ph ` .  (Contributed by NM, 5-Aug-1993.) $)
    hbsb3 $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      ( wsb wal sbimi hbsb2a syl ) ABCEZACFZBCEJBFAKBCDGABCHI $.
  $}

  ${
    nfs1.1 $e |- F/ y ph $.
    $( If ` y ` is not free in ` ph ` , ` x ` is not free in
       ` [ y / x ] ph ` .  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfs1 $p |- F/ x [ y / x ] ph $=
      ( wsb nfri hbsb3 nfi ) ABCEBABCACDFGH $.
  $}

  $( Substitution applied to an atomic wff.  (Contributed by NM,
     5-Aug-1993.) $)
  equsb1 $p |- [ y / x ] x = y $=
    ( weq wi wsb sb2 id mpg ) ABCZIDIABEAIABFIGH $.

  $( Substitution applied to an atomic wff.  (Contributed by NM,
     5-Aug-1993.) $)
  equsb2 $p |- [ y / x ] y = x $=
    ( weq wi wsb sb2 equcomi mpg ) ABCBACZDIABEAIABFABGH $.

  ${
    $d x z $.  $d y z $.
    $( When the class variables in definition ~ df-clel are replaced with set
       variables, this theorem of predicate calculus is the result.  This
       theorem provides part of the justification for the consistency of that
       definition, which "overloads" the set variables in ~ wel with the class
       variables in ~ wcel .  Note:  This proof is referenced on the Metamath
       Proof Explorer Home Page and shouldn't be changed.  (Contributed by NM,
       28-Jan-2004.)  (Proof modification is discouraged.) $)
    cleljust $p |- ( x e. y <-> E. z ( z = x /\ z e. y ) ) $=
      ( weq wel wa wex ax-17 elequ1 equsexh bicomi ) CADCBEZFCGABEZLMCAMCHCABIJ
      K $.
  $}

  ${
    $d x z $.  $d y z $.
    $( When the class variables in definition ~ df-clel are replaced with set
       variables, this theorem of predicate calculus is the result.  This
       theorem provides part of the justification for the consistency of that
       definition, which "overloads" the set variables in ~ wel with the class
       variables in ~ wcel .  (Contributed by NM, 28-Jan-2004.)  (Revised by
       Mario Carneiro, 21-Dec-2016.)  (Proof modification is discouraged.) $)
    cleljustALT $p |- ( x e. y <-> E. z ( z = x /\ z e. y ) ) $=
      ( weq wel wa wex nfv elequ1 equsex bicomi ) CADCBEZFCGABEZLMCAMCHCABIJK
      $.
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.) $)
    dveel1 $p |- ( -. A. x x = y -> ( y e. z -> A. x y e. z ) ) $=
      ( vw wel elequ1 dvelimv ) DCEBCEABDDBCFG $.

    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.) $)
    dveel2 $p |- ( -. A. x x = y -> ( z e. y -> A. x z e. y ) ) $=
      ( vw wel elequ2 dvelimv ) CDECBEABDDBCFG $.
  $}

  ${
    $d w y $.  $d w z $.  $d w x $.  $( ` w ` is dummy. $)
    $( Axiom ~ ax-15 is redundant if we assume ~ ax-17 .  Remark 9.6 in
       [Megill] p. 448 (p. 16 of the preprint), regarding axiom scheme C14'.

       Note that ` w ` is a dummy variable introduced in the proof.  On the web
       page, it is implicitly assumed to be distinct from all other variables.
       (This is made explicit in the database file set.mm).  Its purpose is to
       satisfy the distinct variable requirements of ~ dveel2 and ~ ax-17 .  By
       the end of the proof it has vanished, and the final theorem has no
       distinct variable requirements.  (Contributed by NM, 29-Jun-1995.)
       (Proof modification is discouraged.) $)
    ax15 $p |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x e. y -> A. z x e. y ) ) ) $=
      ( vw weq wal wn wel hbn1 dveel2 hbim1 elequ1 imbi2d dvelim nfa1 nfn 19.21
      wi syl6ib pm2.86d ) CAECFGZCBEZCFZGZABHZUECFZUAUDUERZUGCFUDUFRUDDBHZRUGCA
      DUDUHCUBCICBDJKDAEUHUEUDDABLMNUDUECUCCUBCOPQST $.
  $}

  $( An alternate definition of proper substitution that, like ~ df-sb , mixes
     free and bound variables to avoid distinct variable requirements.
     (Contributed by NM, 17-Feb-2005.) $)
  dfsb2 $p |- ( [ y / x ] ph <->
              ( ( x = y /\ ph ) \/ A. x ( x = y -> ph ) ) ) $=
    ( wsb weq wa wi wal wo sp sbequ2 sps orc ee12an sb4 olc syl6 pm2.61i sbequ1
    wn imp sb2 jaoi impbii ) ABCDZBCEZAFZUFAGBHZIZUFBHZUEUIGUJUFUEAUIUFBJUFUEAG
    BABCKLUGUHMNUJTUEUHUIABCOUHUGPQRUGUEUHUFAUEABCSUAABCUBUCUD $.

  $( An alternate definition of proper substitution ~ df-sb that uses only
     primitive connectives (no defined terms) on the right-hand side.
     (Contributed by NM, 6-Mar-2007.) $)
  dfsb3 $p |- ( [ y / x ] ph <->
              ( ( x = y -> -. ph ) -> A. x ( x = y -> ph ) ) ) $=
    ( weq wa wi wal wo wn wsb df-or dfsb2 imnan imbi1i 3bitr4i ) BCDZAEZPAFBGZH
    QIZRFABCJPAIFZRFQRKABCLTSRPAMNO $.

  $( An equality theorem for substitution.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Wolf Lammen, 15-Sep-2018.) $)
  sbequi $p |- ( x = y -> ( [ x / z ] ph -> [ y / z ] ph ) ) $=
    ( weq wsb wi equtr sbequ2 sbequ1 syl9 syld wn wal ax12 sp con3i sb4 equequ2
    syl biimprd imim1d al2imi sb2 syl6 pm2.61i ) DBEZBCEZADBFZADCFZGZGUGUHDCEZU
    KDBCHUGUIAULUJADBIADCJKLUGMZUHUHDNZUKDBCOUMUIUGAGZDNZUNUJUMUGDNZMUIUPGUQUGU
    GDPQADBRTUNUPULAGZDNUJUHUOURDUHULUGAUHUGULBCDSUAUBUCADCUDUEKLUF $.

  $( An equality theorem for substitution.  Used in proof of Theorem 9.7 in
     [Megill] p. 449 (p. 16 of the preprint).  (Contributed by NM,
     5-Aug-1993.) $)
  sbequ $p |- ( x = y -> ( [ x / z ] ph <-> [ y / z ] ph ) ) $=
    ( weq wsb sbequi wi equcoms impbid ) BCEADBFZADCFZABCDGLKHCBACBDGIJ $.

  $( Formula-building lemma for use with the Distinctor Reduction Theorem.
     Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  (Contributed
     by NM, 5-Aug-1993.) $)
  drsb1 $p |- ( A. x x = y -> ( [ z / x ] ph <-> [ z / y ] ph ) ) $=
    ( weq wal wi wa wex wsb wb equequ1 sps imbi1d anbi1d drex1 anbi12d 3bitr4g
    df-sb ) BCEZBFZBDEZAGZUBAHZBIZHCDEZAGZUFAHZCIZHABDJACDJUAUCUGUEUIUAUBUFATUB
    UFKBBCDLMZNUDUHBCUAUBUFAUJOPQABDSACDSR $.

  $( Formula-building lemma for use with the Distinctor Reduction Theorem.
     Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  (Contributed
     by NM, 27-Feb-2005.) $)
  drsb2 $p |- ( A. x x = y -> ( [ x / z ] ph <-> [ y / z ] ph ) ) $=
    ( weq wsb wb sbequ sps ) BCEADBFADCFGBABCDHI $.

  $( Obsolete proof of ~ sbequi as of 2-May-2018.  (Contributed by NM,
     5-Aug-1993.)  (Proof modification is discoraged.)
     (New usage is discouraged.) $)
  sbequiOLD $p |- ( x = y -> ( [ x / z ] ph -> [ y / z ] ph ) ) $=
    ( weq wal wsb wi wn wa wex hbsb2 stdpc7 sbequ1 sylan9 sps adantr drsb1 syld
    ex equvini eximi 19.35 sylib nfsb2 19.9d syl9 sbequ2 biimprd sylan9r biimpd
    syl com23 pm2.61ii ) DBEZDFZDCEZDFZBCEZADBGZADCGZHZHUPIZUSURIZVBVCUSVDVBHVC
    USJUTVADKZVDVAVCUTUTDFZUSVEADBLUSVBDKZVFVEHUSBDEZUQJZDKVGBCDUAVIVBDVHUTAUQV
    AABDMADCNZOUBULUTVADUCUDOVAVDDADCUEUFUGTUMUPUSVBUPUSJUTAVAUPUTAHZUSUOVKDADB
    UHPQUSAABCGZUPVAABCNUPVAVLADBCRUIUJSTURUSVBURUSJUTAVAURUTACBGZUSAURUTVMADCB
    RUKABCMOURAVAHZUSUQVNDVJPQSTUN $.

  $( Substitution has no effect on a non-free variable.  (Contributed by NM,
     30-May-2009.)  (Revised by Mario Carneiro, 12-Oct-2016.)  (Proof shortened
     by Wolf Lammen, 3-May-2018.) $)
  sbft $p |- ( F/ x ph -> ( [ y / x ] ph <-> ph ) ) $=
    ( wnf wsb wex spsbe 19.9t syl5ib wal nfr stdpc4 syl6 impbid ) ABDZABCEZAPAB
    FOAABCGABHIOAABJPABKABCLMN $.

  $( Obsolete proof of ~ sbft as of 22-Apr-2018.  (Contributed by NM,
     30-May-2009.)  (Revised by Mario Carneiro, 12-Oct-2016.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  sbftOLD $p |- ( F/ x ph -> ( [ y / x ] ph <-> ph ) ) $=
    ( wnf wsb weq wa wex sb1 wal simpr ax-gen 19.23t mpbii syl5 nfr stdpc4 syl6
    wi impbid ) ABDZABCEZAUBBCFZAGZBHZUAAABCIUAUDASZBJUEASUFBUCAKLUDABMNOUAAABJ
    UBABPABCQRT $.

  ${
    sbf.1 $e |- F/ x ph $.
    $( Substitution for a variable not free in a wff does not affect it.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sbf $p |- ( [ y / x ] ph <-> ph ) $=
      ( wnf wsb wb sbft ax-mp ) ABEABCFAGDABCHI $.
  $}

  ${
    sbh.1 $e |- ( ph -> A. x ph ) $.
    $( Substitution for a variable not free in a wff does not affect it.
       (Contributed by NM, 5-Aug-1993.) $)
    sbh $p |- ( [ y / x ] ph <-> ph ) $=
      ( nfi sbf ) ABCABDEF $.
  $}

  $( Substitution has no effect on a bound variable.  (Contributed by NM,
     1-Jul-2005.) $)
  sbf2 $p |- ( [ y / x ] A. x ph <-> A. x ph ) $=
    ( wal nfa1 sbf ) ABDBCABEF $.

  ${
    nfs1f.1 $e |- F/ x ph $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfs1f $p |- F/ x [ y / x ] ph $=
      ( wsb sbf nfxfr ) ABCEABABCDFDG $.
  $}

  ${
    sb6x.1 $e |- F/ x ph $.
    $( Equivalence involving substitution for a variable not free.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sb6x $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      ( wsb weq wi wal sbf biidd equsal bitr4i ) ABCEABCFZAGBHABCDIAABCDMAJKL
      $.
  $}

  ${
    sb6f.1 $e |- F/ y ph $.
    $( Equivalence for substitution when ` y ` is not free in ` ph ` .
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sb6f $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      ( wsb weq wi wal nfri sbimi sb4a syl sb2 impbii ) ABCEZBCFAGBHZOACHZBCEPA
      QBCACDIJABCKLABCMN $.

    $( Equivalence for substitution when ` y ` is not free in ` ph ` .
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sb5f $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      ( wsb weq wi wal wa wex sb6f equs45f bitr4i ) ABCEBCFZAGBHNAIBJABCDKABCDL
      M $.
  $}

  $( Substitution does not change an identical variable specifier.
     (Contributed by NM, 5-Aug-1993.) $)
  sbequ5 $p |- ( [ w / z ] A. x x = y <-> A. x x = y ) $=
    ( weq wal nfae sbf ) ABEAFCDABCGH $.

  $( Substitution does not change a distinctor.  (Contributed by NM,
     5-Aug-1993.) $)
  sbequ6 $p |- ( [ w / z ] -. A. x x = y <-> -. A. x x = y ) $=
    ( weq wal wn nfnae sbf ) ABEAFGCDABCHI $.

  ${
    sbtOLD.1 $e |- ph $.
    $( Obsolete proof of ~ sbt as of 20-Jul-2018.)  (Contributed by NM,
       21-Jan-2004.)  (Proof shortened by Andrew Salmon, 25-May-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sbtOLD $p |- [ y / x ] ph $=
      ( wsb nfth sbf mpbir ) ABCEADABCABDFGH $.
  $}

  $( A variable not free remains so after substitution with a distinct variable
     (closed form of ~ nfsb4 ).  (Contributed by NM, 7-Apr-2004.)  (Revised by
     Mario Carneiro, 4-Oct-2016.)  (Proof shortened by Wolf Lammen,
     11-May-2018.) $)
  nfsb4t $p |- ( A. x F/ z ph ->
                 ( -. A. z z = y -> F/ z [ y / x ] ph ) ) $=
    ( wnf wal weq wn wsb wi wa sbequ12 sps drnf2 biimpd spsd impcom nfnae nfan
    wb a1d nfnf1 nfal nfa1 sp adantr nfsb2 adantl a1i dvelimdf pm2.61dan ) ADEZ
    BFZBCGZBFZDCGDFHZABCIZDEZJUMUOKURUPUOUMURUOULURBUOULURAUQBCDUNAUQTZBABCLZMN
    OPQUAUMUOHZKZAUQDCBUMVADULDBADUBUCBCDRSUMVABULBUDBCBRSUMULVAULBUEUFVAUQBEUM
    ABCUGUHUNUSJVBUTUIUJUK $.

  $( Obsolete proof of ~ nfsb4t as of 6-May-2018.  (Contributed by NM,
     7-Apr-2004.)  (Revised by Mario Carneiro, 4-Oct-2016.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nfsb4tOLD $p |- ( A. x F/ z ph ->
                 ( -. A. z z = y -> F/ z [ y / x ] ph ) ) $=
    ( wnf wal weq wn wsb wi wa sbequ12 sps drnf2 biimpcd a1dd nfa1 nfnae nfan
    wb nfeqf adantl sp adantr nfimd nfald sb4b nfbidf imbi2d syl5ibrcom pm2.61d
    ex exp3a nfsb2 drsb1 syl5ib pm2.61d2 ) ADEZBFZDBGDFZDCGDFHZABCIZDEZJUSUTHZV
    AVCUSBCGZBFZVDVAKZVCJZUSVFVCVGURVFVCJBVFURVCAVBBCDVEAVBTBABCLMNOMPUSVHVFHZV
    GVEAJZBFZDEZJUSVGVLUSVGKZVJDBUSVGBURBQVDVABDBBRDCBRSSVMVEADVGVEDEUSBCDUAUBU
    SURVGURBUCUDUEUFULVIVCVLVGVIVBVKDBCDRABCUGUHUIUJUKUMVAADCIZDEUTVCADCUNVNVBD
    BDADBCUONUPUQ $.

  ${
    nfsb4.1 $e |- F/ z ph $.
    $( A variable not free remains so after substitution with a distinct
       variable.  (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    nfsb4 $p |- ( -. A. z z = y -> F/ z [ y / x ] ph ) $=
      ( wnf weq wal wn wsb wi nfsb4t mpg ) ADFDCGDHIABCJDFKBABCDLEM $.
  $}

  $( Negation inside and outside of substitution are equivalent.  (Contributed
     by NM, 5-Aug-1993.)  (Proof shortened by Wolf Lammen, 30-Apr-2018.) $)
  sbn $p |- ( [ y / x ] -. ph <-> -. [ y / x ] ph ) $=
    ( wn wsb weq wi wal wa wex df-sb exanali anbi2i annim 3bitri dfsb3 xchbinxr
    ) ADZBCEZBCFZRGZTAGBHZGZABCESUATRIBJZIUAUBDZIUCDRBCKUDUEUATABLMUAUBNOABCPQ
    $.

  $( Obsolete proof of ~ sbn as of 30-Apr-2018.  (Contributed by NM,
     5-Aug-1993.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  sbnOLD $p |- ( [ y / x ] -. ph <-> -. [ y / x ] ph ) $=
    ( wn wsb weq wal wi sbequ2 nsyld sps sb4 wa wex sb1 equs3 sylib syl6 sylibr
    con2i pm2.61i sbequ1 con3rr3 sb2 notnot sbbii con3i df-sb sylanbrc impbii )
    ADZBCEZABCEZDZBCFZBGZULUNHZUOUQBUOULAUMUKBCIABCIJKUPDULUOUKHZBGZUNUKBCLUMUS
    UMUOAMBNUSDABCOABCPQTRUAUNURUOUKMBNZULUOAUMABCUBUCUNUOUKDZHBGZDUTVBUMVBVABC
    EUMVABCUDAVABCAUEUFSUGUKBCPSUKBCUHUIUJ $.

  $( Removal of implication from substitution.  (Contributed by NM,
     5-Aug-1993.) $)
  sbi1 $p |- ( [ y / x ] ( ph -> ps ) -> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    ( weq wal wi wsb sbequ2 syl5d sbequ1 syl6d sps sb4 ax-2 al2imi syl6 pm2.61i
    wn sb2 ) CDEZCFZABGZCDHZACDHZBCDHZGGZUAUGCUAUDUEBUFUAUEAUDBACDIUCCDIJBCDKLM
    UBSZUEUAAGZCFZUDUFACDNUHUDUAUCGZCFZUJUFGUCCDNULUJUABGZCFUFUKUIUMCUAABOPBCDT
    QQJR $.

  $( Introduction of implication into substitution.  (Contributed by NM,
     5-Aug-1993.) $)
  sbi2 $p |- ( ( [ y / x ] ph -> [ y / x ] ps ) -> [ y / x ] ( ph -> ps ) ) $=
    ( wsb wi wn sbn pm2.21 sbimi sylbir ax-1 ja ) ACDEZBCDEABFZCDEZNGAGZCDEPACD
    HQOCDABIJKBOCDBALJM $.

  $( Specialization of implication.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 25-May-2011.) $)
  spsbim $p |- ( A. x ( ph -> ps ) -> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    ( wi wal wsb stdpc4 sbi1 syl ) ABEZCFKCDGACDGBCDGEKCDHABCDIJ $.

  $( Implication inside and outside of substitution are equivalent.
     (Contributed by NM, 5-Aug-1993.) $)
  sbim $p |- ( [ y / x ] ( ph -> ps ) <-> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    ( wi wsb sbi1 sbi2 impbii ) ABECDFACDFBCDFEABCDGABCDHI $.

  ${
    sbrim.1 $e |- F/ x ph $.
    $( Substitution with a variable not free in antecedent affects only the
       consequent.  (Contributed by NM, 5-Aug-1993.)  (Revised by Mario
       Carneiro, 4-Oct-2016.) $)
    sbrim $p |- ( [ y / x ] ( ph -> ps ) <-> ( ph -> [ y / x ] ps ) ) $=
      ( wi wsb sbim sbf imbi1i bitri ) ABFCDGACDGZBCDGZFAMFABCDHLAMACDEIJK $.
  $}

  ${
    sblim.1 $e |- F/ x ps $.
    $( Substitution with a variable not free in consequent affects only the
       antecedent.  (Contributed by NM, 14-Nov-2013.)  (Revised by Mario
       Carneiro, 4-Oct-2016.) $)
    sblim $p |- ( [ y / x ] ( ph -> ps ) <-> ( [ y / x ] ph -> ps ) ) $=
      ( wi wsb sbim sbf imbi2i bitri ) ABFCDGACDGZBCDGZFLBFABCDHMBLBCDEIJK $.
  $}

  $( Logical OR inside and outside of substitution are equivalent.
     (Contributed by NM, 29-Sep-2002.) $)
  sbor $p |- ( [ y / x ] ( ph \/ ps ) <-> ( [ y / x ] ph \/ [ y / x ] ps ) ) $=
    ( wn wi wsb wo sbim sbn imbi1i bitri df-or sbbii 3bitr4i ) AEZBFZCDGZACDGZE
    ZBCDGZFZABHZCDGSUAHRPCDGZUAFUBPBCDIUDTUAACDJKLUCQCDABMNSUAMO $.

  $( Conjunction inside and outside of a substitution are equivalent.
     (Contributed by NM, 5-Aug-1993.) $)
  sban $p |- ( [ y / x ] ( ph /\ ps ) <-> ( [ y / x ] ph /\ [ y / x ] ps ) ) $=
    ( wn wi wsb wa sbn sbim imbi2i bitri xchbinx df-an sbbii 3bitr4i ) ABEZFZEZ
    CDGZACDGZBCDGZEZFZEABHZCDGUAUBHTRCDGZUDRCDIUFUAQCDGZFUDAQCDJUGUCUABCDIKLMUE
    SCDABNOUAUBNP $.

  $( Conjunction inside and outside of a substitution are equivalent.
     (Contributed by NM, 14-Dec-2006.) $)
  sb3an $p |- ( [ y / x ] ( ph /\ ps /\ ch ) <->
              ( [ y / x ] ph /\ [ y / x ] ps /\ [ y / x ] ch ) ) $=
    ( w3a wsb wa df-3an sbbii sban anbi1i bitr4i 3bitri ) ABCFZDEGABHZCHZDEGPDE
    GZCDEGZHZADEGZBDEGZSFZOQDEABCIJPCDEKTUAUBHZSHUCRUDSABDEKLUAUBSIMN $.

  $( Equivalence inside and outside of a substitution are equivalent.
     (Contributed by NM, 5-Aug-1993.) $)
  sbbi $p |- ( [ y / x ] ( ph <-> ps )
     <-> ( [ y / x ] ph <-> [ y / x ] ps ) ) $=
    ( wb wsb wi wa dfbi2 sbbii sbim anbi12i sban 3bitr4i bitri ) ABEZCDFABGZBAG
    ZHZCDFZACDFZBCDFZEZPSCDABIJQCDFZRCDFZHUAUBGZUBUAGZHTUCUDUFUEUGABCDKBACDKLQR
    CDMUAUBINO $.

  $( Specialization of biconditional.  (Contributed by NM, 5-Aug-1993.) $)
  spsbbi $p |- ( A. x ( ph <-> ps ) -> ( [ y / x ] ph <-> [ y / x ] ps ) ) $=
    ( wb wal wsb stdpc4 sbbi sylib ) ABEZCFKCDGACDGBCDGEKCDHABCDIJ $.

  ${
    sbbid.1 $e |- F/ x ph $.
    sbbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction substituting both sides of a biconditional.  (Contributed by
       NM, 5-Aug-1993.) $)
    sbbid $p |- ( ph -> ( [ y / x ] ps <-> [ y / x ] ch ) ) $=
      ( wb wal wsb alrimi spsbbi syl ) ABCHZDIBDEJCDEJHANDFGKBCDELM $.
  $}

  ${
    sblbis.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce left biconditional inside of a substitution.  (Contributed by
       NM, 19-Aug-1993.) $)
    sblbis $p |- ( [ y / x ] ( ch <-> ph ) <-> ( [ y / x ] ch <-> ps ) ) $=
      ( wb wsb sbbi bibi2i bitri ) CAGDEHCDEHZADEHZGLBGCADEIMBLFJK $.
  $}

  ${
    sbrbis.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce right biconditional inside of a substitution.  (Contributed by
       NM, 18-Aug-1993.) $)
    sbrbis $p |- ( [ y / x ] ( ph <-> ch ) <-> ( ps <-> [ y / x ] ch ) ) $=
      ( wb wsb sbbi bibi1i bitri ) ACGDEHADEHZCDEHZGBMGACDEILBMFJK $.
  $}

  ${
    sbrbif.1 $e |- F/ x ch $.
    sbrbif.2 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce right biconditional inside of a substitution.  (Contributed by
       NM, 18-Aug-1993.)  (Revised by Mario Carneiro, 4-Oct-2016.) $)
    sbrbif $p |- ( [ y / x ] ( ph <-> ch ) <-> ( ps <-> ch ) ) $=
      ( wb wsb sbrbis sbf bibi2i bitri ) ACHDEIBCDEIZHBCHABCDEGJNCBCDEFKLM $.
  $}

  $( Obsolete proof of ~ spsbe as of 3-May-2018.  (Contributed by NM,
     5-Aug-1993.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  spsbeOLD $p |- ( [ y / x ] ph -> E. x ph ) $=
    ( wsb wn wal wex stdpc4 sbn sylib con2i df-ex sylibr ) ABCDZAEZBFZEABGPNPOB
    CDNEOBCHABCIJKABLM $.

  $( Elimination of equality from antecedent after substitution.  (Contributed
     by NM, 5-Aug-1993.)  (New usage is discouraged.) $)
  sbequ8ALT $p |- ( [ y / x ] ph <-> [ y / x ] ( x = y -> ph ) ) $=
    ( wsb weq wi equsb1 a1bi sbim bitr4i ) ABCDZBCEZBCDZKFLAFBCDMKBCGHLABCIJ $.

  ${
    sbie.1 $e |- F/ x ps $.
    sbie.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit substitution.
       (Contributed by NM, 30-Jun-1994.)  (Revised by Mario Carneiro,
       4-Oct-2016.)  (Revised by Wolf Lammen, 14-Jul-2018.) $)
    sbie $p |- ( [ y / x ] ph <-> ps ) $=
      ( wsb wb weq wi sbt sbequ8 mpbir sbbi mpbi sbf bitri ) ACDGZBCDGZBABHZCDG
      ZRSHUACDITJZCDGUBCDFKTCDLMABCDNOBCDEPQ $.
  $}

  ${
    sbied.1 $e |- F/ x ph $.
    sbied.2 $e |- ( ph -> F/ x ch ) $.
    sbied.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Conversion of implicit substitution to explicit substitution (deduction
       version of ~ sbie ).  (Contributed by NM, 30-Jun-1994.)  (Revised by
       Mario Carneiro, 4-Oct-2016.)  (Proof shortened by Wolf Lammen,
       24-Jun-2018.) $)
    sbied $p |- ( ph -> ( [ y / x ] ps <-> ch ) ) $=
      ( wsb wi sbrim nfim1 weq wb com12 pm5.74d sbie bitr3i pm5.74ri ) ABDEIZCA
      TJABJZDEIACJZABDEFKUAUBDEACDFGLDEMZABCAUCBCNHOPQRS $.

    $( Obsolete proof of ~ sbied as of 30-Apr-2018.  (Contributed by NM,
       30-Jun-1994.)  (Revised by Mario Carneiro, 4-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sbiedOLD $p |- ( ph -> ( [ y / x ] ps <-> ch ) ) $=
      ( wsb wex weq wa sb1 wb wi bi1 syl6 imp3a syld wal eximd syl5 19.9d com23
      nfrd bi2 alimd sb2 impbid ) ABDEIZCAUJCDJZCUJDEKZBLZDJAUKBDEMAUMCDFAULBCA
      ULBCNZBCOHBCPQRUAUBCADGUCSACCDTZUJACDGUEAUOULBOZDTUJACUPDFAULCBAULUNCBOHB
      CUFQUDUGBDEUHQSUI $.
  $}

  ${
    sbieOLD.1 $e |- F/ x ps $.
    sbieOLD.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Obsolete proof of ~ sbie as of 30-Apr-2018.  (Contributed by NM,
       30-Jun-1994.)  (Revised by Mario Carneiro, 4-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sbieOLD $p |- ( [ y / x ] ph <-> ps ) $=
      ( wsb wb wtru nftru wnf a1i weq wi sbied trud ) ACDGBHIABCDCJBCKIELCDMABH
      NIFLOP $.
  $}

  ${
    $d x ph $.  $d x ch $.
    sbiedv.1 $e |- ( ( ph /\ x = y ) -> ( ps <-> ch ) ) $.
    $( Conversion of implicit substitution to explicit substitution (deduction
       version of ~ sbie ).  (Contributed by NM, 7-Jan-2017.) $)
    sbiedv $p |- ( ph -> ( [ y / x ] ps <-> ch ) ) $=
      ( nfv nfvd weq wb ex sbied ) ABCDEADGACDHADEIBCJFKL $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Alternate proof of ~ ax16 .  (Contributed by NM, 17-May-2008.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax16ALT $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( vz wsb sbequ12 ax-17 hbsb3 ax16i ) AABDEBCDABDFABDADGHI $.
  $}

  ${
    $d x y $.  $d z ph $.
    $( Alternate proof of ~ ax16 .  (Contributed by NM, 8-Nov-2006.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax16ALT2 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( weq wal aev wsb sbequ12 biimpcd alimdv nfv nfs1 stdpc7 cbv3 syl6com syl
      vz wi ) BCDBEBQDZQEZAABEZRBCQBQFATABQGZQEUAASUBQSAUBABQHIJUBAQBABQAQKZLUC
      AQBMNOP $.
  $}

  ${
    $d x y $.
    $( A generalization of axiom ~ ax-16 .  Alternate proof of ~ a16g that uses
       ~ df-sb .  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
       Salmon, 25-May-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    a16gALT $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      ( weq wal aev ax16ALT2 biidd dral1 biimprd sylsyld ) BCEBFDBEDFZAABFZADFZ
      BCDDBGABCHMONAADBMAIJKL $.
  $}

  ${
    dvelimdfOLD.1 $e |- F/ x ph $.
    dvelimdfOLD.2 $e |- F/ z ph $.
    dvelimdfOLD.3 $e |- ( ph -> F/ x ps ) $.
    dvelimdfOLD.4 $e |- ( ph -> F/ z ch ) $.
    dvelimdfOLD.5 $e |- ( ph -> ( z = y -> ( ps <-> ch ) ) ) $.
    $( Obsolete proof of ~ dvelimdf as of 6-May-2018.  (Contributed by NM,
       7-Apr-2004.)  (Revised by Mario Carneiro, 6-Oct-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dvelimdfOLD $p |- ( ph -> ( -. A. x x = y -> F/ x ch ) ) $=
      ( weq wal wn wnf wa wsb wi alrimi nfsb4t syl imp nfnae nfan adantr nfbidf
      wb sbied mpbid ex ) ADELDMNZCDOZAUKPZBFEQZDOZULAUKUOABDOZFMUKUORAUPFHISBF
      EDTUAUBUMUNCDAUKDGDEDUCUDAUNCUGUKABCFEHJKUHUEUFUIUJ $.
  $}

  $( A composition law for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbco $p |- ( [ y / x ] [ x / y ] ph <-> [ y / x ] ph ) $=
    ( wsb wb weq equsb2 sbequ12 bicomd sbimi ax-mp sbbi mpbi ) ACBDZAEZBCDZNBCD
    ABCDECBFZBCDPBCGQOBCQANACBHIJKNABCLM $.

  ${
    sbid2.1 $e |- F/ x ph $.
    $( An identity law for substitution.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sbid2 $p |- ( [ y / x ] [ x / y ] ph <-> ph ) $=
      ( wsb sbco sbf bitri ) ACBEBCEABCEAABCFABCDGH $.
  $}

  $( An idempotent law for substitution.  (Contributed by NM, 30-Jun-1994.)
     (Proof shortened by Andrew Salmon, 25-May-2011.) $)
  sbidm $p |- ( [ y / x ] [ y / x ] ph <-> [ y / x ] ph ) $=
    ( wsb wb weq equsb2 sbequ12r sbimi ax-mp sbbi mpbi ) ABCDZAEZBCDZMBCDMECBFZ
    BCDOBCGPNBCACBHIJMABCKL $.

  ${
    sbco2.1 $e |- F/ z ph $.
    $( A composition law for substitution.  (Contributed by NM, 30-Jun-1994.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sbco2 $p |- ( [ y / z ] [ z / x ] ph <-> [ y / x ] ph ) $=
      ( weq wal wsb wb sbid2 sbequ syl5bbr sbequ12 bitr3d sps wn nfnae nfsb4 wi
      nfs1 a1i sbied bicomd pm2.61i ) BCFZBGZABDHZDCHZABCHZIZUEUJBUEAUHUIAUGDBH
      UEUHADBEJUGBCDKLZABCMNOUFPZUIUHULAUHBCBCBQUGDCBABDETRUEAUHISULUKUAUBUCUD
      $.
  $}

  ${
    sbco2d.1 $e |- F/ x ph $.
    sbco2d.2 $e |- F/ z ph $.
    sbco2d.3 $e |- ( ph -> F/ z ps ) $.
    $( A composition law for substitution.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sbco2d $p |- ( ph -> ( [ y / z ] [ z / x ] ps <-> [ y / x ] ps ) ) $=
      ( wsb wi nfim1 sbco2 sbrim sbbii bitri 3bitr3i pm5.74ri ) ABCEIZEDIZBCDIZ
      ABJZCEIZEDIZUACDIASJZATJUACDEABEGHKLUCARJZEDIUDUBUEEDABCEFMNAREDGMOABCDFM
      PQ $.
  $}

  $( A composition law for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbco3 $p |- ( [ z / y ] [ y / x ] ph <-> [ z / x ] [ x / y ] ph ) $=
    ( weq wal wsb wb drsb1 sbequ12a alimi spsbbi syl bitr3d wn sbco sbbii nfnae
    nfsb2 sbco2d syl5rbbr pm2.61i ) BCEZBFZABCGZCDGZACBGZBDGZHUDUEBDGZUFUHUEBCD
    IUDUEUGHZBFUIUHHUCUJBABCJKUEUGBDLMNUHUECBGZBDGUDOZUFUKUGBDACBPQULUECDBBCCRB
    CBRABCSTUAUB $.

  $( A commutativity law for substitution.  (Contributed by NM, 27-May-1997.)
     (Proof shortened by Wolf Lammen, 24-Jun-2018.) $)
  sbcom $p |- ( [ y / z ] [ y / x ] ph <-> [ y / x ] [ y / z ] ph ) $=
    ( weq wal wsb wb wn wa drsb1 nfae sbbid bitr3d nfnae nfan sb4b sbequ12 sps
    wi adantr alcom bi2.04 2albii bitri nfeqf 19.21t adantl imbi2d bitr4d albid
    wnf syl syl5bb adantrr ax10 con3i sylan adantrl ad2antll ad2antrl pm2.61ian
    3bitr4d ex pm2.61ii ) BCEZBFZDCEZDFZABCGZDCGZADCGZBCGZHZVGIZVIIZVNBDEBFZVOV
    PJZVNVQVNVRVQVJBCGVKVMVJBDCKVQVJVLBCBDBLABDCKMNUAVQIZVRJZVHVJTZDFZVFVLTZBFZ
    VKVMVTVFVHATZTZDFZBFZWBWDVSVOWHWBHVPWHVHVFATZTZBFZDFZVSVOJZWBWHWFBFDFWLWFBD
    UBWFWJDBVFVHAUCUDUEWMWKWADVSVODBDDOBCDOPWMWKVHWIBFZTZWAWMVHBULWKWOHDCBUFVHW
    IBUGUMWMVJWNVHVOVJWNHVSABCQUHUIUJUKUNUOVSVPWHWDHVOVSVPJZWGWCBVSVPBBDBODCBOP
    WPWGVFWEDFZTZWCWPVFDULZWGWRHVSDBEDFZIVPWSWTVQDBUPUQBCDUFURVFWEDUGUMVPWCWRHV
    SVPVLWQVFADCQUIUHUJUKUSNVPVKWBHVSVOVJDCQUTVOVMWDHVSVPVLBCQVAVCVBVDVGVLVKVMV
    GAVJDCBCDLVFAVJHBABCRSMVFVLVMHBVLBCRSNVIVJVKVMVHVJVKHDVJDCRSVIAVLBCDCBLVHAV
    LHDADCRSMNVE $.

  $( Obsolete proof of ~ sbcom as of 24-Jun-2018.  (Contributed by NM,
     27-May-1997.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  sbcomOLD $p |- ( [ y / z ] [ y / x ] ph <-> [ y / x ] [ y / z ] ph ) $=
    ( weq wal wsb wb wn wa drsb1 nfae sbbid bitr3d nfnae albid sb4b sbequ12 sps
    wi adantr wnf nfeqf 19.21t syl adantrr alcom bi2.04 albii aecom con3i sylan
    nfan syl5bb adantrl imbi2d sylan9bbr sylan9bb 3bitr4d pm2.61ian ex pm2.61ii
    adantl ) BCEZBFZDCEZDFZABCGZDCGZADCGZBCGZHZVEIZVGIZVLBDEBFZVMVNJZVLVOVLVPVO
    VHBCGVIVKVHBDCKVOVHVJBCBDBLABDCKMNUAVOIZVPJZVFVDATZBFZTZDFZVDVFATZDFZTZBFZV
    IVKVRVFVSTZBFZDFZWBWFVQVMWIWBHVNVQVMJZWHWADVQVMDBDDOBCDOZUMWJVFBUBWHWAHDCBU
    CVFVSBUDUEPUFVQVNWIWFHVMWIWGDFZBFVQVNJZWFWGDBUGWMWLWEBVQVNBBDBODCBOZUMWLVDW
    CTZDFZWMWEWGWODVFVDAUHUIWMVDDUBZWPWEHVQDBEDFZIVNWQWRVODBUJUKBCDUCULVDWCDUDU
    EUNPUNUONVPVIWBHVQVNVIVFVHTZDFVMWBVHDCQVMWSWADWKVMVHVTVFABCQUPPUQVCVPVKWFHV
    QVMVKVDVJTZBFVNWFVJBCQVNWTWEBWNVNVJWDVDADCQUPPURVCUSUTVAVEVJVIVKVEAVHDCBCDL
    VDAVHHBABCRSMVDVJVKHBVJBCRSNVGVHVIVKVFVHVIHDVHDCRSVGAVJBCDCBLVFAVJHDADCRSMN
    VB $.

  ${
    sb5rf.1 $e |- F/ y ph $.
    $( Reversed substitution.  (Contributed by NM, 3-Feb-2005.)  (Revised by
       Mario Carneiro, 6-Oct-2016.) $)
    sb5rf $p |- ( ph <-> E. y ( y = x /\ [ y / x ] ph ) ) $=
      ( weq wsb wa wex sbid2 sb1 sylbir stdpc7 imp exlimi impbii ) ACBEZABCFZGZ
      CHZAQCBFSACBDIQCBJKRACDPQAACBLMNO $.

    $( Reversed substitution.  (Contributed by NM, 5-Aug-1993.)  (Revised by
       Mario Carneiro, 6-Oct-2016.) $)
    sb6rf $p |- ( ph <-> A. y ( y = x -> [ y / x ] ph ) ) $=
      ( weq wsb wi wal sbequ1 equcoms com12 alrimi sb2 sbid2 sylib impbii ) ACB
      EZABCFZGZCHZASCDQARARGBCABCIJKLTRCBFARCBMACBDNOP $.

    $( Substitution of variable in universal quantifier.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 6-Oct-2016.)  (Proof shortened
       by Jim Kingdon, 15-Jan-2018.) $)
    sb8 $p |- ( A. x ph <-> A. y [ y / x ] ph ) $=
      ( wsb nfs1 sbequ12 cbval ) AABCEBCDABCDFABCGH $.

    $( Substitution of variable in existential quantifier.  (Contributed by NM,
       12-Aug-1993.)  (Revised by Mario Carneiro, 6-Oct-2016.)  (Proof
       shortened by Jim Kingdon, 15-Jan-2018.) $)
    sb8e $p |- ( E. x ph <-> E. y [ y / x ] ph ) $=
      ( wsb nfs1 sbequ12 cbvex ) AABCEBCDABCDFABCGH $.
  $}

  $( Commutation of quantification and substitution variables.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb9i $p |- ( A. x [ x / y ] ph -> A. y [ y / x ] ph ) $=
    ( weq wal wsb wi drsb1 drsb2 bitr3d dral1 biimprd wn nfnae hbsb2 alimd sbco
    stdpc4 sylib alimi a7s syl6 pm2.61i ) CBDCEZACBFZBEZABCFZCEZGUDUHUFUGUECBUD
    ACCFUGUEACBCHACBCIJKLUDMZUFUECEZBEUHUIUEUJBCBBNACBOPUEUHCBUFUGCUFUEBCFUGUEB
    CRABCQSTUAUBUC $.

  $( Commutation of quantification and substitution variables.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb9 $p |- ( A. x [ x / y ] ph <-> A. y [ y / x ] ph ) $=
    ( wsb wal sb9i impbii ) ACBDBEABCDCEABCFACBFG $.

  ${
    $d x y $.  $d x z $.  $d y z $.  $d ph z $.
    $( This is a version of ~ ax-11o when the variables are distinct.  Axiom
       (C8) of [Monk2] p. 105.  See theorem ~ ax11v2 for the rederivation of
       ~ ax-11o from this theorem.  (Contributed by NM, 5-Aug-1993.) $)
    ax11v $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      ( weq wal wi ax-1 ax16 syl5 a1d ax11o pm2.61i ) BCDZBEZMAMAFZBEZFZFNQMAON
      PAMGOBCHIJABCKL $.

    $( Alternate proof of ~ ax11v that avoids theorem ~ ax16 and is proved
       directly from ~ ax-11 rather than via ~ ax11o .  (Contributed by Jim
       Kingdon, 15-Dec-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    ax11vALT $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      ( vz cv wceq wex wi wal a9e ax-17 ax-11 syl5 equequ2 imbi1d albidv imbi2d
      imbi12d mpbii exlimiv ax-mp ) DEZCEZFZDGBEZUCFZAUFAHZBIZHZHZDCJUDUJDUDUEU
      BFZAUKAHZBIZHZHUJAADIUKUMADKABDLMUDUKUFUNUIDCBNZUDUMUHAUDULUGBUDUKUFAUOOP
      QRSTUA $.

    $( Two equivalent ways of expressing the proper substitution of ` y ` for
       ` x ` in ` ph ` , when ` x ` and ` y ` are distinct.  Theorem 6.2 of
       [Quine] p. 40.  The proof does not involve ~ df-sb .  (Contributed by
       NM, 14-Apr-2008.) $)
    sb56 $p |- ( E. x ( x = y /\ ph ) <-> A. x ( x = y -> ph ) ) $=
      ( weq wi wal nfa1 ax11v sp com12 impbid equsex ) ABCDZAEZBFZBCNBGMAOABCHO
      MANBIJKL $.

    $( Equivalence for substitution.  Compare Theorem 6.2 of [Quine] p. 40.
       Also proved as Lemmas 16 and 17 of [Tarski] p. 70.  (Contributed by NM,
       18-Aug-1993.) $)
    sb6 $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      ( weq wi wa wex wal wsb sb56 anbi2i df-sb sp pm4.71ri 3bitr4i ) BCDZAEZPA
      FBGZFQQBHZFABCISRSQABCJKABCLSQQBMNO $.

    $( Equivalence for substitution.  Similar to Theorem 6.1 of [Quine] p. 40.
       (Contributed by NM, 18-Aug-1993.) $)
    sb5 $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      ( wsb weq wi wal wa wex sb6 sb56 bitr4i ) ABCDBCEZAFBGMAHBIABCJABCKL $.
  $}

  ${
    $d y z $.  $d x y $.
    $( Lemma for ~ equsb3 .  (Contributed by Raph Levien and FL, 4-Dec-2005.)
       (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
    equsb3lem $p |- ( [ x / y ] y = z <-> x = z ) $=
      ( weq nfv equequ1 sbie ) BCDACDZBAHBEBACFG $.
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic wff.  (Contributed by Raph Levien and
       FL, 4-Dec-2005.) $)
    equsb3 $p |- ( [ x / y ] y = z <-> x = z ) $=
      ( vw weq wsb equsb3lem sbbii nfv sbco2 3bitr3i ) BCEZBDFZDAFDCEZDAFLBAFAC
      EMNDADBCGHLBADLDIJADCGK $.
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic membership wff.  (Contributed by NM,
       7-Nov-2006.)  (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
    elsb3 $p |- ( [ x / y ] y e. z <-> x e. z ) $=
      ( vw wel wsb nfv sbco2 elequ1 sbie sbbii 3bitr3i ) DCEZDBFZBAFMDAFBCEZBAF
      ACEZMDABMBGHNOBAMODBODGDBCIJKMPDAPDGDACIJL $.
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic membership wff.  (Contributed by
       Rodolfo Medina, 3-Apr-2010.)  (Proof shortened by Andrew Salmon,
       14-Jun-2011.) $)
    elsb4 $p |- ( [ x / y ] z e. y <-> z e. x ) $=
      ( vw wel wsb nfv sbco2 elequ2 sbie sbbii 3bitr3i ) CDEZDBFZBAFMDAFCBEZBAF
      CAEZMDABMBGHNOBAMODBODGDBCIJKMPDAPDGDACIJL $.
  $}

  ${
    $d x y $.
    $( ` x ` is not free in ` [ y / x ] ph ` when ` x ` and ` y ` are
       distinct.  (Contributed by NM, 5-Aug-1993.) $)
    hbs1 $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      ( weq wal wsb wi ax16 hbsb2 pm2.61i ) BCDBEABCFZKBEGKBCHABCIJ $.

    $( ` x ` is not free in ` [ y / x ] ph ` when ` x ` and ` y ` are
       distinct.  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfs1v $p |- F/ x [ y / x ] ph $=
      ( wsb hbs1 nfi ) ABCDBABCEF $.
  $}

  ${
    $d y ph $.
    $( Two ways of expressing " ` x ` is (effectively) not free in ` ph ` ."
       (Contributed by NM, 29-May-2009.) $)
    sbhb $p |- ( ( ph -> A. x ph ) <-> A. y ( ph -> [ y / x ] ph ) ) $=
      ( wal wi wsb nfv sb8 imbi2i 19.21v bitr4i ) AABDZEAABCFZCDZEAMECDLNAABCAC
      GHIAMCJK $.
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( Two ways of expressing " ` x ` is (effectively) not free in ` ph ` ."
       (Contributed by G&eacute;rard Lang, 14-Nov-2013.)  (Revised by Mario
       Carneiro, 6-Oct-2016.) $)
    sbnf2 $p |- ( F/ x ph
       <-> A. y A. z ( [ y / x ] ph <-> [ z / x ] ph ) ) $=
      ( wsb wb wal wi wnf 2albiim sbhb albii alcom 3bitri nfv nfs1v sblim bitri
      wa sb8 df-nf anbi12i anidm 3bitr2ri ) ABCEZABDEZFDGCGUEUFHZDGCGZUFUEHZDGZ
      CGZSABIZULSULUEUFCDJULUHULUKULAUFHZBGZDGZUGCGZDGUHULAABGHZBGZUMDGZBGUOABU
      AZUQUSBABDKLUMBDMNUNUPDUNUMBCEZCGUPUMBCUMCOTVAUGCAUFBCABDPQLRLUGDCMNULAUE
      HZBGZCGZUKULURVBCGZBGVDUTUQVEBABCKLVBBCMNVCUJCVCVBBDEZDGUJVBBDVBDOTVFUIDA
      UEBDABCPQLRLRUBULUCUD $.
  $}

  ${
    $d y z $.
    nfsb.1 $e |- F/ z ph $.
    $( If ` z ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` when
       ` y ` and ` z ` are distinct.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfsb $p |- F/ z [ y / x ] ph $=
      ( weq wal wsb wnf a16nf nfsb4 pm2.61i ) DCFDGABCHZDIMDCDJABCDEKL $.
  $}

  ${
    $d y z $.
    hbsb.1 $e |- ( ph -> A. z ph ) $.
    $( If ` z ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` when
       ` y ` and ` z ` are distinct.  (Contributed by NM, 12-Aug-1993.) $)
    hbsb $p |- ( [ y / x ] ph -> A. z [ y / x ] ph ) $=
      ( wsb nfi nfsb nfri ) ABCFDABCDADEGHI $.
  $}

  ${
    $d y z $.
    nfsbd.1 $e |- F/ x ph $.
    nfsbd.2 $e |- ( ph -> F/ z ps ) $.
    $( Deduction version of ~ nfsb .  (Contributed by NM, 15-Feb-2013.) $)
    nfsbd $p |- ( ph -> F/ z [ y / x ] ps ) $=
      ( weq wal wsb wnf wn wi alrimi nfsb4t syl a16nf pm2.61d2 ) AEDHEIZBCDJZEK
      ZABEKZCISLUAMAUBCFGNBCDEOPTEDEQR $.
  $}

  ${
    $d x y z $.  $d w y $.
    $( Equivalence for double substitution.  (Contributed by NM,
       3-Feb-2005.) $)
    2sb5 $p |- ( [ z / x ] [ w / y ] ph <->
               E. x E. y ( ( x = z /\ y = w ) /\ ph ) ) $=
      ( wsb weq wa wex sb5 19.42v anass exbii anbi2i 3bitr4ri bitri ) ACEFZBDFB
      DGZQHZBIRCEGZHAHZCIZBIQBDJSUBBRTAHZHZCIRUCCIZHUBSRUCCKUAUDCRTALMQUERACEJN
      OMP $.

    $( Equivalence for double substitution.  (Contributed by NM,
       3-Feb-2005.) $)
    2sb6 $p |- ( [ z / x ] [ w / y ] ph <->
               A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      ( wsb weq wi wal wa sb6 19.21v impexp albii imbi2i 3bitr4ri bitri ) ACEFZ
      BDFBDGZRHZBISCEGZJAHZCIZBIRBDKTUCBSUAAHZHZCISUDCIZHUCTSUDCLUBUECSUAAMNRUF
      SACEKOPNQ $.
  $}

  ${
    $d x z $.  $d x w $.  $d y z $.
    $( Commutativity law for substitution.  Used in proof of Theorem 9.7 of
       [Megill] p. 449 (p. 16 of the preprint).  (Contributed by NM,
       27-May-1997.) $)
    sbcom2 $p |- ( [ w / z ] [ y / x ] ph <-> [ y / x ] [ w / z ] ph ) $=
      ( weq wal wsb wb wn wi albii 19.21v sb4b imbi2d albidv nfae sbequ12 sbbid
      sps wa alcom bi2.04 bitri 3bitr3i a1i sylan9bbr sylan9bb 3bitr4d pm2.61ii
      ex bitr3d ) BCFZBGZDEFZDGZABCHZDEHZADEHZBCHZIZUNJZUPJZVAVBVCUAZUOUMAKZBGZ
      KZDGZUMUOAKZDGZKZBGZURUTVHVLIVDUMVIKZBGZDGVMDGZBGVHVLVMDBUBVNVGDVNUOVEKZB
      GVGVMVPBUMUOAUCLUOVEBMUDLVOVKBUMVIDMLUEUFVCURUOUQKZDGVBVHUQDENVBVQVGDVBUQ
      VFUOABCNOPUGVBUTUMUSKZBGVCVLUSBCNVCVRVKBVCUSVJUMADENOPUHUIUKUNUSURUTUNAUQ
      DEBCDQUMAUQIBABCRTSUMUSUTIBUSBCRTULUPUQURUTUOUQURIDUQDERTUPAUSBCDEBQUOAUS
      IDADERTSULUJ $.
  $}

  ${
    $d ph x y z $.  $d w x z $.
    $( (Probably not) Axiom *11.07 in [WhiteheadRussell] p. 159.  The original
       confusingly reads: *11.07 "Whatever possible argument ` x ` may be,
       ` ph ( x , y ) ` is true whatever possible argument ` y ` may be"
       implies the corresponding statement with ` x ` and ` y ` interchanged
       except in " ` ph ( x , y ) ` ".  This theorem will be deleted after
       22-Feb-2018 if no one is able to determine the correct interpretation.
       See
       ~ https://groups.google.com/d/msg/metamath/iS0fOvSemC8/YzrRyX70AgAJ .
       (Contributed by Andrew Salmon, 17-Jun-2011.)  (Proof shortened by Jim
       Kingdon, 22-Jan-2018.)  (New usage is discouraged.) $)
    pm11.07 $p |- ( [ w / x ] [ y / z ] ph <-> [ y / x ] [ w / z ] ph ) $=
      ( wsb nfv sbf sbbii bitri bitr4i ) ADCFZBEFZAADEFZBCFZMABEFALABEADCADGZHI
      ABEABGZHJOABCFANABCADEPHIABCQHJK $.
  $}

  ${
    $d ph x y z $.  $d w x z $.
    $( Obsolete proof of ~ pm11.07 as of 22-Jan-2018.  (Contributed by Andrew
       Salmon, 17-Jun-2011.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    pm11.07OLD $p |- ( [ w / x ] [ y / z ] ph <-> [ y / x ] [ w / z ] ph ) $=
      ( weq wa wex wsb a9ev pm3.2i 2th eeanv 3bitr4i anbi1i 19.41vv 2sb5 ) BEFZ
      DCFZGZAGDHBHZBCFZDEFZGZAGDHBHZADCIBEIADEIBCITDHBHZAGUDDHBHZAGUAUEUFUGARBH
      ZSDHZGZUBBHZUCDHZGZUFUGUJUMUHUIBEJDCJKUKULBCJDEJKLRSBDMUBUCBDMNOTABDPUDAB
      DPNABDECQABDCEQN $.
  $}

  ${
    $d x y $.
    $( Equivalence for substitution.  (Contributed by NM, 5-Aug-1993.) $)
    sb6a $p |- ( [ y / x ] ph <-> A. x ( x = y -> [ x / y ] ph ) ) $=
      ( wsb weq wi wal sb6 wb sbequ12 equcoms pm5.74i albii bitri ) ABCDBCEZAFZ
      BGOACBDZFZBGABCHPRBOAQAQICBACBJKLMN $.
  $}

  ${
    $d x y $.  $d x w $.  $d y z $.  $d z w $.
    2sb5rf.1 $e |- F/ z ph $.
    2sb5rf.2 $e |- F/ w ph $.
    $( Reversed double substitution.  (Contributed by NM, 3-Feb-2005.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    2sb5rf $p |- ( ph <->
                E. z E. w ( ( z = x /\ w = y ) /\ [ z / x ] [ w / y ] ph ) ) $=
      ( weq wsb wex sb5rf 19.42v sbcom2 anbi2i anass bitri exbii nfsb 3bitr4ri
      wa ) ADBHZABDIZTZDJUAECHZTZACEIBDIZTZEJZDJABDFKUCUHDUAUDUBCEIZTZTZEJUAUJE
      JZTUHUCUAUJELUGUKEUGUEUITUKUFUIUEACEBDMNUAUDUIOPQUBULUAUBCEABDEGRKNSQP $.

    $( Reversed double substitution.  (Contributed by NM, 3-Feb-2005.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    2sb6rf $p |- ( ph <->
                A. z A. w ( ( z = x /\ w = y ) -> [ z / x ] [ w / y ] ph ) ) $=
      ( weq wsb wi wal wa sb6rf 19.21v sbcom2 imbi2i impexp bitri albii nfsb
      3bitr4ri ) ADBHZABDIZJZDKUBECHZLZACEIBDIZJZEKZDKABDFMUDUIDUBUEUCCEIZJZJZE
      KUBUKEKZJUIUDUBUKENUHULEUHUFUJJULUGUJUFACEBDOPUBUEUJQRSUCUMUBUCCEABDEGTMP
      UASR $.
  $}

  ${
    $d y z $.
    sb7f.1 $e |- F/ z ph $.
    $( This version of ~ dfsb7 does not require that ` ph ` and ` z ` be
       distinct.  This permits it to be used as a definition for substitution
       in a formalization that omits the logically redundant axiom ~ ax-17 i.e.
       that doesn't have the concept of a variable not occurring in a wff.
       ( ~ df-sb is also suitable, but its mixing of free and bound variables
       is distasteful to some logicians.)  (Contributed by NM, 26-Jul-2006.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sb7f $p |- ( [ y / x ] ph <->
               E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      ( wsb cv wceq wa wex sb5f sbbii sbco2 sb5 3bitr3i ) ABDFZDCFBGDGZHAIBJZDC
      FABCFQCGHRIDJPRDCABDEKLABCDEMRDCNO $.
  $}

  ${
    $d y z $.
    sb7h.1 $e |- ( ph -> A. z ph ) $.
    $( This version of ~ dfsb7 does not require that ` ph ` and ` z ` be
       distinct.  This permits it to be used as a definition for substitution
       in a formalization that omits the logically redundant axiom ~ ax-17 i.e.
       that doesn't have the concept of a variable not occurring in a wff.
       ( ~ df-sb is also suitable, but its mixing of free and bound variables
       is distasteful to some logicians.)  (Contributed by NM, 26-Jul-2006.)
       (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    sb7h $p |- ( [ y / x ] ph <->
               E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      ( nfi sb7f ) ABCDADEFG $.
  $}

  ${
    $d y z $.  $d z ph $.
    $( An alternate definition of proper substitution ~ df-sb .  By introducing
       a dummy variable ` z ` in the definiens, we are able to eliminate any
       distinct variable restrictions among the variables ` x ` , ` y ` , and
       ` ph ` of the definiendum.  No distinct variable conflicts arise because
       ` z ` effectively insulates ` x ` from ` y ` .  To achieve this, we use
       a chain of two substitutions in the form of ~ sb5 , first ` z ` for
       ` x ` then ` y ` for ` z ` .  Compare Definition 2.1'' of [Quine] p. 17,
       which is obtained from this theorem by applying ~ df-clab .  Theorem
       ~ sb7h provides a version where ` ph ` and ` z ` don't have to be
       distinct.  (Contributed by NM, 28-Jan-2004.) $)
    dfsb7 $p |- ( [ y / x ] ph <-> E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      ( nfv sb7f ) ABCDADEF $.
  $}

  ${
    $d x y $.
    sb10f.1 $e |- F/ x ph $.
    $( Hao Wang's identity axiom P6 in Irving Copi, _Symbolic Logic_ (5th ed.,
       1979), p. 328.  In traditional predicate calculus, this is a sole axiom
       for identity from which the usual ones can be derived.  (Contributed by
       NM, 9-May-2005.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sb10f $p |- ( [ y / z ] ph <-> E. x ( x = y /\ [ x / z ] ph ) ) $=
      ( weq wsb wa wex nfsb sbequ equsex bicomi ) BCFADBGZHBIADCGZNOBCADCBEJABC
      DKLM $.
  $}

  ${
    $d x ph $.
    $( An identity law for substitution.  Used in proof of Theorem 9.7 of
       [Megill] p. 449 (p. 16 of the preprint).  (Contributed by NM,
       5-Aug-1993.) $)
    sbid2v $p |- ( [ y / x ] [ x / y ] ph <-> ph ) $=
      ( nfv sbid2 ) ABCABDE $.
  $}

  ${
    $d x y $.  $d x ph $.
    $( Elimination of substitution.  (Contributed by NM, 5-Aug-1993.) $)
    sbelx $p |- ( ph <-> E. x ( x = y /\ [ x / y ] ph ) ) $=
      ( wsb weq wa wex sbid2v sb5 bitr3i ) AACBDZBCDBCEKFBGABCHKBCIJ $.
  $}

  ${
    $( Note:  A more general case could also be proved with
       "$d x z $.  $d y w $.  $d x ph $.  $d y ph $.", but with more
       difficulty. $)
    $d x y z $.  $d w y $.  $d x y ph $.
    $( Elimination of double substitution.  (Contributed by NM, 5-Aug-1993.) $)
    sbel2x $p |- ( ph <-> E. x E. y ( ( x = z /\ y = w ) /\
                     [ y / w ] [ x / z ] ph ) ) $=
      ( weq wsb wa wex sbelx anbi2i exbii exdistr 3bitr4i anass 2exbii bitr4i )
      ABDFZCEFZADBGZECGZHZHZCIBIZRSHUAHZCIBIRTHZBIRUBCIZHZBIAUDUFUHBTUGRTCEJKLA
      BDJRUBBCMNUEUCBCRSUAOPQ $.
  $}

  ${
    $d x y $.
    $( A theorem used in elimination of disjoint variable restriction on ` x `
       and ` y ` by replacing it with a distinctor ` -. A. x x = z ` .
       (Contributed by NM, 5-Aug-1993.) $)
    sbal1 $p |- ( -. A. x x = z ->
             ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) ) $=
      ( weq wal wn wsb wb wi sbequ12 sps dral2 bitr3d a1d wa nfa1 al2imi hbnaes
      syl6 nfsb4 nfrd sp sbimi alimi adantl ax-7 dveeq2 alim syl9 sylan9 impbid
      sb4 sb2 ex pm2.61i ) CDEZCFZBDEBFGZABFZCDHZACDHZBFZIZJURVDUSURUTVAVCUQUTV
      AICUTCDKLAVBCDBUQAVBICACDKLMNOURGZUSVDVEUSPVAVCUSVAVCJVEUSVAVABFVCUSVABUT
      CDBABQUAUBVAVBBUTACDABUCUDUETUFVEVCUQAJZBFZCFZUSVAVEVCVFCFZBFZVHVCVJJCDBV
      EVBVIBACDUMRSVFBCUGTVHVAJBDCUSCFVHUQUTJZCFVAUSVGVKCUSUQUQBFVGUTBDCUHUQABU
      IUJRUTCDUNTSUKULUOUP $.
  $}

  ${
    $d x y $.  $d x z $.
    $( Move universal quantifier in and out of substitution.  (Contributed by
       NM, 5-Aug-1993.) $)
    sbal $p |- ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) $=
      ( weq wal wsb wb a16gb sbimi sbequ5 sbbi 3imtr3i bitr3d sbal1 pm2.61i ) B
      DEBFZABFZCDGZACDGZBFZHQTSUAQCDGARHZCDGQTSHQUBCDABDBIJBDCDKARCDLMTBDBINABC
      DOP $.
  $}

  ${
    $d x y $.  $d x z $.
    $( Move existential quantifier in and out of substitution.  (Contributed by
       NM, 27-Sep-2003.) $)
    sbex $p |- ( [ z / y ] E. x ph <-> E. x [ z / y ] ph ) $=
      ( wn wal wsb wex sbn sbal albii bitri xchbinx df-ex sbbii 3bitr4i ) AEZBF
      ZEZCDGZACDGZEZBFZEABHZCDGUABHTRCDGZUCRCDIUEQCDGZBFUCQBCDJUFUBBACDIKLMUDSC
      DABNOUABNP $.
  $}

  ${
    $d x z $.  $d y z $.
    sbalv.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Quantify with new variable inside substitution.  (Contributed by NM,
       18-Aug-1993.) $)
    sbalv $p |- ( [ y / x ] A. z ph <-> A. z ps ) $=
      ( wal wsb sbal albii bitri ) AEGCDHACDHZEGBEGAECDILBEFJK $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( An equivalent expression for existence.  (Contributed by NM,
       2-Feb-2005.) $)
    exsb $p |- ( E. x ph <-> E. y A. x ( x = y -> ph ) ) $=
      ( weq wi wal nfv nfa1 ax11v sp com12 impbid cbvex ) ABCDZAEZBFZBCACGOBHNA
      PABCIPNAOBJKLM $.

    $( An equivalent expression for existence.  Obsolete as of 19-Jun-2017.
       (Contributed by NM, 2-Feb-2005.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    exsbOLD $p |- ( E. x ph <-> E. y A. x ( x = y -> ph ) ) $=
      ( wex wsb cv wceq wi wal nfv sb8e sb6 exbii bitri ) ABDABCEZCDBFCFGAHBIZC
      DABCACJKOPCABCLMN $.
  $}

  ${
    $d x y z $.  $d y w $.  $d z w ph $.
    $( An equivalent expression for double existence.  (Contributed by NM,
       2-Feb-2005.) $)
    2exsb $p |- ( E. x E. y ph <->
                  E. z E. w A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      ( wex weq wi wal wa exsb exbii excom bitri impexp albii 19.21v bitr2i ) A
      CFZBFZCEGZAHZCIZBFZEFZBDGZUAJAHZCIZBIZEFDFZTUCEFZBFUESUKBACEKLUCBEMNUEUID
      FZEFUJUDULEUDUFUCHZBIZDFULUCBDKUNUIDUMUHBUHUFUBHZCIUMUGUOCUFUAAOPUFUBCQRP
      LNLUIEDMNN $.
  $}

  ${
    $d z ps $.  $d x z $.  $d y z $.
    dvelimALT.1 $e |- ( ph -> A. x ph ) $.
    dvelimALT.2 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelim that doesn't use ~ ax-10 .  (See ~ dvelimh for a
       version that doesn't use ~ ax-11 .)  (Contributed by NM, 17-May-2008.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    dvelimALT $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi ax-17 ax16ALT a1d wa hbn1 hban ax12o imp a1i hbimd hbald
      ex pm2.61i equsalh albii 3imtr3g ) CDHZCIJZEDHZAKZEIZULCIBBCIUIUKCEUIELCE
      HZCIZUIUKUKCIKZKUNUOUIUKCEMNUNJZUIUOUPUIOZUJACUPUICUMCPUHCPQUPUIUJUJCIKED
      CRSAACIKUQFTUAUCUDUBABEDBELGUEZULBCURUFUG $.
  $}

  ${
    $d z y $.  $d z x $.
    $( Move quantifier in and out of substitution.  (Contributed by NM,
       2-Jan-2002.) $)
    sbal2 $p |- ( -. A. x x = y ->
             ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) ) $=
      ( weq wal wn wi wsb alcom nfnae wnf wb dveeq1 nfd 19.21t syl syl5rbbr sb6
      albid albii 3bitr4g ) BCEBFGZCDEZABFZHZCFZUDAHZCFZBFZUECDIACDIZBFUJUHBFZC
      FUCUGUHCBJUCULUFCBCCKUCUDBLULUFMUCUDBBCBKBCDNOUDABPQTRUECDSUKUIBACDSUAUB
      $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
  Predicate calculus with equality:  Older axiomatization (1 rule, 14 schemes)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  The "metalogical completeness theorem", Theorem 9.7 of [Megill] p. 448, uses
  a different but (logically and metalogically) equivalent set of axiom schemes
  for its proof.  In order to show that our axiomatization is also
  metalogically complete, we derive the axiom schemes of that paper in this
  section (or mention where they are derived, if they have already been derived
  as therorems above).  Additionally, we re-derive our axiomatization from the
  one in the paper, showing that the two systems are equivalent.

  The 14 predicate calculus axioms used by the paper are ~ ax-5o , ~ ax-4 ,
  ~ ax-7 , ~ ax-6o , ~ ax-8 , ~ ax-12o , ~ ax-9o , ~ ax-10o , ~ ax-13 ,
  ~ ax-14 , ~ ax-15 , ~ ax-11o , ~ ax-16 , and ~ ax-17 .  Like ours, it
  includes the rule of generalization ( ~ ax-gen ).

  The ones we need to prove from our axioms are ~ ax-5o , ~ ax-4 ,
  ~ ax-6o , ~ ax-12o , ~ ax-9o , ~ ax-10o , ~ ax-15 , ~ ax-11o ,
  and ~ ax-16 . The theorems showing the derivations of those axioms,
  which have all been proved earlier, are ~ ax5o , ~ ax4 (also called
  ~ sp ), ~ ax6o , ~ ax12o , ~ ax9o , ~ ax10o , ~ ax15 , ~ ax11o ,
  ~ ax16 , and ~ ax10 . In addition, ~ ax-10 was an intermediate axiom we
  adopted at one time, and we show its proof in this section as
  ~ ax10from10o .

  This section also includes a few miscellaneous legacy theorems such as
  ~ hbequid use the older axioms.

  Note:  The axioms and theorems in this section should not be used outside of
  this section.  Inside this section, we may use the external axioms ~ ax-gen ,
  ~ ax-17 , ~ ax-8 , ~ ax-9 , ~ ax-13 , and ~ ax-14 since they are common to
  both our current and the older axiomatizations.  (These are the ones that
  were never revised.)

  The following newer axioms may NOT be used in this section until we
  have proved them from the older axioms:  ~ ax-5 , ~ ax-6 , ~ ax-9 ,
  ~ ax-11 , and ~ ax-12 .  However, once we have rederived an axiom
  (e.g. theorem ~ ax5 for axiom ~ ax-5 ), we may make use of theorems
  outside of this section that make use of the rederived axiom (e.g. we
  may use theorem ~ alimi , which uses ~ ax-5 , after proving ~ ax5 ).

$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 Obsolete schemes ax-5o ax-4 ax-6o ax-9o ax-10o ax-10 ax-11o ax-12o ax-15 ax-16
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  These older axiom schemes are obsolete and should not be used outside of this
  section.  They are proved above as theorems ax5o , ~ sp , ~ ax6o , ~ ax9o ,
  ~ ax10o , ~ ax10 , ~ ax11o , ~ ax12o , ~ ax15 , and ~ ax16 .

$)

  $( Axiom of Specialization.  A quantified wff implies the wff without a
     quantifier (i.e. an instance, or special case, of the generalized wff).
     In other words if something is true for all ` x ` , it is true for any
     specific ` x ` (that would typically occur as a free variable in the wff
     substituted for ` ph ` ).  (A free variable is one that does not occur in
     the scope of a quantifier: ` x ` and ` y ` are both free in ` x = y ` ,
     but only ` x ` is free in ` A. y x = y ` .)  Axiom scheme C5' in [Megill]
     p. 448 (p. 16 of the preprint).  Also appears as Axiom B5 of [Tarski]
     p. 67 (under his system S2, defined in the last paragraph on p. 77).

     Note that the converse of this axiom does not hold in general, but a
     weaker inference form of the converse holds and is expressed as rule
     ~ ax-gen .  Conditional forms of the converse are given by ~ ax-12 ,
     ~ ax-15 , ~ ax-16 , and ~ ax-17 .

     Unlike the more general textbook Axiom of Specialization, we cannot choose
     a variable different from ` x ` for the special case.  For use, that
     requires the assistance of equality axioms, and we deal with it later
     after we introduce the definition of proper substitution - see ~ stdpc4 .

     An interesting alternate axiomatization uses ~ ax467 and ~ ax-5o in place
     of ~ ax-4 , ~ ax-5 , ~ ax-6 , and ~ ax-7 .

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ sp .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-4 $a |- ( A. x ph -> ph ) $.

  $( Axiom of Quantified Implication.  This axiom moves a quantifier from
     outside to inside an implication, quantifying ` ps ` .  Notice that ` x `
     must not be a free variable in the antecedent of the quantified
     implication, and we express this by binding ` ph ` to "protect" the axiom
     from a ` ph ` containing a free ` x ` .  Axiom scheme C4' in [Megill]
     p. 448 (p. 16 of the preprint).  It is a special case of Lemma 5 of
     [Monk2] p. 108 and Axiom 5 of [Mendelson] p. 69.

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax5o .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-5o $a |- ( A. x ( A. x ph -> ps ) -> ( A. x ph -> A. x ps ) ) $.

  $( Axiom of Quantified Negation.  This axiom is used to manipulate negated
     quantifiers.  Equivalent to axiom scheme C7' in [Megill] p. 448 (p. 16 of
     the preprint).  An alternate axiomatization could use ~ ax467 in place of
     ~ ax-4 , ~ ax-6o , and ~ ax-7 .

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax6o .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-6o $a |- ( -. A. x -. A. x ph -> ph ) $.

  $( A variant of ~ ax9 .  Axiom scheme C10' in [Megill] p. 448 (p. 16 of the
     preprint).

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax9o .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-9o $a |- ( A. x ( x = y -> A. x ph ) -> ph ) $.

  $( Axiom ~ ax-10o ("o" for "old") was the original version of ~ ax-10 ,
     before it was discovered (in May 2008) that the shorter ~ ax-10 could
     replace it.  It appears as Axiom scheme C11' in [Megill] p. 448 (p. 16 of
     the preprint).

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax10o .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-10o $a |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $.

  $( Axiom of Quantifier Substitution.  One of the equality and substitution
     axioms of predicate calculus with equality.  Appears as Lemma L12 in
     [Megill] p. 445 (p. 12 of the preprint).

     The original version of this axiom was ~ ax-10o ("o" for "old") and was
     replaced with this shorter ~ ax-10 in May 2008.  The old axiom is proved
     from this one as theorem ~ ax10o .  Conversely, this axiom is proved from
     ~ ax-10o as theorem ~ ax10from10o .

     This axiom was proved redundant in July 2015.  See theorem ~ ax10 .

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax10 .  (Contributed by NM, 16-May-2008.)
     (New usage is discouraged.) $)
  ax-10 $a |- ( A. x x = y -> A. y y = x ) $.

  $( Axiom ~ ax-11o ("o" for "old") was the original version of ~ ax-11 ,
     before it was discovered (in Jan. 2007) that the shorter ~ ax-11 could
     replace it.  It appears as Axiom scheme C15' in [Megill] p. 448 (p. 16 of
     the preprint).  It is based on Lemma 16 of [Tarski] p. 70 and Axiom C8 of
     [Monk2] p. 105, from which it can be proved by cases.  To understand this
     theorem more easily, think of " ` -. A. x x = y -> ` ..." as informally
     meaning "if ` x ` and ` y ` are distinct variables then..."  The
     antecedent becomes false if the same variable is substituted for ` x ` and
     ` y ` , ensuring the theorem is sound whenever this is the case.  In some
     later theorems, we call an antecedent of the form ` -. A. x x = y ` a
     "distinctor."

     Interestingly, if the wff expression substituted for ` ph ` contains no
     wff variables, the resulting statement _can_ be proved without invoking
     this axiom.  This means that even though this axiom is _metalogically_
     independent from the others, it is not _logically_ independent.
     Specifically, we can prove any wff-variable-free instance of axiom
     ~ ax-11o (from which the ~ ax-11 instance follows by theorem ~ ax11 .)
     The proof is by induction on formula length, using ~ ax11eq and ~ ax11el
     for the basis steps and ~ ax11indn , ~ ax11indi , and ~ ax11inda for the
     induction steps.  (This paragraph is true provided we use ~ ax-10o in
     place of ~ ax-10 .)

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax11o .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-11o $a |- ( -. A. x x = y ->
             ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.

  $( Axiom of Quantifier Introduction.  One of the equality and substitution
     axioms of predicate calculus with equality.  Informally, it says that
     whenever ` z ` is distinct from ` x ` and ` y ` , and ` x = y ` is true,
     then ` x = y ` quantified with ` z ` is also true.  In other words, ` z `
     is irrelevant to the truth of ` x = y ` .  Axiom scheme C9' in [Megill]
     p. 448 (p. 16 of the preprint).  It apparently does not otherwise appear
     in the literature but is easily proved from textbook predicate calculus by
     cases.

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax12o .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-12o $a |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x = y -> A. z x = y ) ) ) $.

  $( Axiom of Quantifier Introduction.  One of the equality and substitution
     axioms for a non-logical predicate in our predicate calculus with
     equality.  Axiom scheme C14' in [Megill] p. 448 (p. 16 of the preprint).
     It is redundant if we include ~ ax-17 ; see theorem ~ ax15 .  Alternately,
     ~ ax-17 becomes unnecessary in principle with this axiom, but we lose the
     more powerful metalogic afforded by ~ ax-17 .  We retain ~ ax-15 here to
     provide completeness for systems with the simpler metalogic that results
     from omitting ~ ax-17 , which might be easier to study for some
     theoretical purposes.

     This axiom is obsolete and should no longer be used.  It is proved above
     as theorem ~ ax15 .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  ax-15 $a |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x e. y -> A. z x e. y ) ) ) $.

  ${
    $d x y $.
    $( Axiom of Distinct Variables.  The only axiom of predicate calculus
       requiring that variables be distinct (if we consider ~ ax-17 to be a
       metatheorem and not an axiom).  Axiom scheme C16' in [Megill] p. 448 (p.
       16 of the preprint).  It apparently does not otherwise appear in the
       literature but is easily proved from textbook predicate calculus by
       cases.  It is a somewhat bizarre axiom since the antecedent is always
       false in set theory (see ~ dtru ), but nonetheless it is technically
       necessary as you can see from its uses.

       This axiom is redundant if we include ~ ax-17 ; see theorem ~ ax16 .
       Alternately, ~ ax-17 becomes logically redundant in the presence of this
       axiom, but without ~ ax-17 we lose the more powerful metalogic that
       results from being able to express the concept of a set variable not
       occurring in a wff (as opposed to just two set variables being
       distinct).  We retain ~ ax-16 here to provide logical completeness for
       systems with the simpler metalogic that results from omitting ~ ax-17 ,
       which might be easier to study for some theoretical purposes.

       This axiom is obsolete and should no longer be used.  It is proved above
       as theorem ~ ax16 .  (Contributed by NM, 5-Aug-1993.)
       (New usage is discouraged.) $)
    ax-16 $a |- ( A. x x = y -> ( ph -> A. x ph ) ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Rederive new axioms from old:  ax5 , ax6 , ax9from9o , ax11 , ax12from12o
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Theorems ~ ax11 and ~ ax12from12o require some intermediate theorems that are
  included in this section.

$)

  $( This theorem repeats ~ sp under the name ~ ax4 , so that the metamath
     program's "verify markup" command will check that it matches axiom scheme
     ~ ax-4 .  It is preferred that references to this theorem use the name
     ~ sp .  (Contributed by NM, 18-Aug-2017.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  ax4 $p |- ( A. x ph -> ph ) $=
    ( sp ) ABC $.

  $( Rederivation of axiom ~ ax-5 from ~ ax-5o and other older axioms.  See
     ~ ax5o for the derivation of ~ ax-5o from ~ ax-5 .  (Contributed by NM,
     23-May-2008.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax5 $p |- ( A. x ( ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    ( wi wal ax-5o ax-4 syl5 mpg syl ) ABDZCEZACEZBDZCEZMBCEDLNDLODCKNCFMALBACG
    KCGHIABCFJ $.

  $( Rederivation of axiom ~ ax-6 from ~ ax-6o and other older axioms.  See
     ~ ax6o for the derivation of ~ ax-6o from ~ ax-6 .  (Contributed by NM,
     23-May-2008.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax6 $p |- ( -. A. x ph -> A. x -. A. x ph ) $=
    ( wal wn wi ax-5o ax-4 id mpg nsyl ax-6o nsyl4 ) ABCZBCZDZBCZMDZBCZMPQEPREB
    OQBFPNMOBGMMEMNEBAMBFMHIJIMBKL $.

  $( Rederivation of axiom ~ ax-9 from ~ ax-9o and other older axioms.  See
     ~ ax9o for the derivation of ~ ax-9o from ~ ax-9 .  Lemma L18 in [Megill]
     p. 446 (p. 14 of the preprint).  (Contributed by NM, 5-Aug-1993.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax9from9o $p |- -. A. x -. x = y $=
    ( weq wn wal wi ax-9o ax-6o con4i mpg ) ABCZKDZAEDZAEZFMAMABGNKLAHIJ $.

  $( ` x ` is not free in ` A. x ph ` .  Example in Appendix in [Megill] p. 450
     (p. 19 of the preprint).  Also Lemma 22 of [Monk2] p. 114.  (Contributed
     by NM, 5-Aug-1993.)  (New usage is discouraged.) $)
  hba1-o $p |- ( A. x ph -> A. x A. x ph ) $=
    ( wal wn ax-4 con2i ax6 con1i alimi 3syl ) ABCZKDZBCZDZNBCKBCMKLBEFLBGNKBKM
    ABGHIJ $.

  ${
    a5i-o.1 $e |- ( A. x ph -> ps ) $.
    $( Inference version of ~ ax-5o .  (Contributed by NM, 5-Aug-1993.)
       (New usage is discouraged.) $)
    a5i-o $p |- ( A. x ph -> A. x ps ) $=
      ( wal hba1-o alrimih ) ACEBCACFDG $.
  $}

  $( Commutation law for identical variable specifiers.  The antecedent and
     consequent are true when ` x ` and ` y ` are substituted with the same
     variable.  Lemma L12 in [Megill] p. 445 (p. 12 of the preprint).  Version
     of ~ aecom using ~ ax-10o .  Unlike ~ ax10from10o , this version does not
     require ~ ax-17 .  (Contributed by NM, 5-Aug-1993.)
     (New usage is discouraged.) $)
  aecom-o $p |- ( A. x x = y -> A. y y = x ) $=
    ( weq wal ax-10o pm2.43i equcomi alimi syl ) ABCZADZJBDZBACZBDKLJABEFJMBABG
    HI $.

  ${
    alequcoms-o.1 $e |- ( A. x x = y -> ph ) $.
    $( A commutation rule for identical variable specifiers.  Version of
       ~ aecoms using ax-10o .  (Contributed by NM, 5-Aug-1993.)
       (New usage is discouraged.) $)
    aecoms-o $p |- ( A. y y = x -> ph ) $=
      ( weq wal aecom-o syl ) CBECFBCEBFACBGDH $.
  $}

  $( All variables are effectively bound in an identical variable specifier.
     Version of ~ hbae using ~ ax-10o .  (Contributed by NM, 5-Aug-1993.)
     (Proof modification is disccouraged.)  (New usage is discouraged.) $)
  hbae-o $p |- ( A. x x = y -> A. z A. x x = y ) $=
    ( weq wal wi wn ax-4 ax-12o syl7 ax-10o aecoms-o pm2.43i syl5 pm2.61ii ax-7
    a5i-o syl ) ABDZAEZSCEZAETCESUAACADCEZCBDCEZTUAFZTSUBGUCGUASAHABCIJUDACSACK
    LUDBCTSBEZBCDBEUATUESABKMSBCKNLOQSACPR $.

  ${
    dral1-o.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  Version of
       ~ dral1 using ~ ax-10o .  (Contributed by NM, 24-Nov-1994.)
       (New usage is discouraged.) $)
    dral1-o $p |- ( A. x x = y -> ( A. x ph <-> A. y ps ) ) $=
      ( weq wal hbae-o biimpd alimdh ax-10o syld biimprd wi aecoms-o impbid ) C
      DFCGZACGZBDGZQRBCGSQABCCDCHQABEIJBCDKLQSADGZRQBADCDDHQABEMJTRNDCADCKOLP
      $.
  $}

  $( Rederivation of axiom ~ ax-11 from ~ ax-11o , ~ ax-10o , and other older
     axioms.  The proof does not require ~ ax-16 or ~ ax-17 .  See theorem
     ~ ax11o for the derivation of ~ ax-11o from ~ ax-11 .

     An open problem is whether we can prove this using ~ ax-10 instead of
     ~ ax-10o .

     This proof uses newer axioms ~ ax-5 and ~ ax-9 , but since these are
     proved from the older axioms above, this is acceptable and lets us avoid
     having to reprove several earlier theorems to use ~ ax-5o and ~ ax-9o .
     (Contributed by NM, 22-Jan-2007.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax11 $p |- ( x = y -> ( A. y ph -> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wi biidd dral1-o ax-1 alimi syl6bir a1d ax-4 ax-11o syl7 pm2.61i
    wn ) BCDZBEZRACEZRAFZBEZFZFSUCRSTABEUBAABCSAGHAUABARIJKLTASQRUBACMABCNOP $.

  $( Derive ~ ax-12 from ~ ax-12o and other older axioms.

     This proof uses newer axioms ~ ax-5 and ~ ax-9 , but since these are
     proved from the older axioms above, this is acceptable and lets us avoid
     having to reprove several earlier theorems to use ~ ax-5o and ~ ax-9o .
     (Contributed by NM, 21-Dec-2015.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax12from12o $p |- ( -. x = y -> ( y = z -> A. x y = z ) ) $=
    ( weq wn wal wi wa ax-4 con3i adantr equtrr equcoms con3rr3 imp nsyl ax-12o
    sylc ex pm2.43d ) ABDZEZBCDZUCAFZUBUCUCUDGZUBUCHZUAAFZEZACDZAFZEUEUBUHUCUGU
    AUAAIJKUFUIUJUBUCUIEUCUIUAUIUAGCBCBALMNOUIAIPBCAQRST $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Legacy theorems using obsolete axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  These theorems were mostly intended to study properties of the older axiom
  schemes and are not useful outside of this section.  They should not be
  used outside of this section.  They may be deleted when they are deemed to no
  longer be of interest.

$)


  ${
    $d x ph $.
    $( Axiom to quantify a variable over a formula in which it does not occur.
       Axiom C5 in [Megill] p. 444 (p. 11 of the preprint).  Also appears as
       Axiom B6 (p. 75) of system S2 of [Tarski] p. 77 and Axiom C5-1 of
       [Monk2] p. 113.

       (This theorem simply repeats ~ ax-17 so that we can include the
       following note, which applies only to the obsolete axiomatization.)

       This axiom is _logically_ redundant in the (logically complete)
       predicate calculus axiom system consisting of ~ ax-gen , ~ ax-5o ,
       ~ ax-4 , ~ ax-7 , ~ ax-6o , ~ ax-8 , ~ ax-12o , ~ ax-9o , ~ ax-10o ,
       ~ ax-13 , ~ ax-14 , ~ ax-15 , ~ ax-11o , and ~ ax-16 : in that system,
       we can derive any instance of ~ ax-17 not containing wff variables by
       induction on formula length, using ~ ax17eq and ~ ax17el for the basis
       together ~ hbn , ~ hbal , and ~ hbim .  However, if we omit this axiom,
       our development would be quite inconvenient since we could work only
       with specific instances of wffs containing no wff variables - this axiom
       introduces the concept of a set variable not occurring in a wff (as
       opposed to just two set variables being distinct).  (Contributed by NM,
       19-Aug-2017.)  (New usage is discouraged.)  (Proof modification
       discouraged.) $)
    ax17o $p |- ( ph -> A. x ph ) $=
      ( ax-17 ) ABC $.
  $}

  $( Identity law for equality (reflexivity).  Lemma 6 of [Tarski] p. 68.  This
     is often an axiom of equality in textbook systems, but we don't need it as
     an axiom since it can be proved from our other axioms (although the proof,
     as you can see below, is not as obvious as you might think).  This proof
     uses only axioms without distinct variable conditions and thus requires no
     dummy variables.  A simpler proof, similar to Tarki's, is possible if we
     make use of ~ ax-17 ; see the proof of ~ equid .  See ~ equid1ALT for an
     alternate proof.  (Contributed by NM, 5-Aug-1993.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  equid1 $p |- x = x $=
    ( weq wal wn wi ax-5o ax-4 ax-12o sylc mpg ax-9o syl ax-6o pm2.61i ) AABZAC
    ZDZACZOROPEZACZORSERTEAQSAFRQQSQAGZUAAAAHIJOAAKLOAMN $.

  ${
    sps-o.1 $e |- ( ph -> ps ) $.
    $( Generalization of antecedent.  (Contributed by NM, 5-Aug-1993.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sps-o $p |- ( A. x ph -> ps ) $=
      ( wal ax-4 syl ) ACEABACFDG $.
  $}

  $( Bound-variable hypothesis builder for ` x = x ` .  This theorem tells us
     that any variable, including ` x ` , is effectively not free in
     ` x = x ` , even though ` x ` is technically free according to the
     traditional definition of free variable.  (The proof does not use
     ~ ax-9o .)  (Contributed by NM, 13-Jan-2011.)  (Proof shortened by Wolf
     Lammen, 23-Mar-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  hbequid $p |- ( x = x -> A. y x = x ) $=
    ( weq wal wi ax-12o ax-8 pm2.43i alimi a1d pm2.61ii ) BACZBDZMAACZNBDZEAABF
    MONLNBLNBAAGHIJZPK $.

  $( Bound-variable hypothesis builder for ` x = x ` .  This theorem tells us
     that any variable, including ` x ` , is effectively not free in
     ` x = x ` , even though ` x ` is technically free according to the
     traditional definition of free variable.  (The proof uses only ~ ax-5 ,
     ~ ax-8 , ~ ax-12o , and ~ ax-gen .  This shows that this can be proved
     without ~ ax9 , even though the theorem ~ equid cannot be.  A shorter
     proof using ~ ax9 is obtainable from ~ equid and ~ hbth .)  Remark added
     2-Dec-2015 NM:  This proof does implicitly use ~ ax9v , which is used for
     the derivation of ~ ax12o , unless we consider ~ ax-12o the starting axiom
     rather than ~ ax-12 .  (Contributed by NM, 13-Jan-2011.)  (Revised by
     Mario Carneiro, 12-Oct-2016.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  nfequid-o $p |- F/ y x = x $=
    ( weq hbequid nfi ) AACBABDE $.

  $( Proof of a single axiom that can replace ~ ax-4 and ~ ax-6o .  See
     ~ ax46to4 and ~ ax46to6 for the re-derivation of those axioms.
     (Contributed by Scott Fenton, 12-Sep-2005.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax46 $p |- ( ( A. x -. A. x ph -> A. x ph ) -> ph ) $=
    ( wal wn ax-6o ax-4 ja ) ABCZDBCHAABEABFG $.

  $( Re-derivation of ~ ax-4 from ~ ax46 .  Only propositional calculus is used
     for the re-derivation.  (Contributed by Scott Fenton, 12-Sep-2005.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax46to4 $p |- ( A. x ph -> ph ) $=
    ( wal wn wi ax-1 ax46 syl ) ABCZIDBCZIEAIJFABGH $.

  $( Re-derivation of ~ ax-6o from ~ ax46 .  Only propositional calculus is
     used for the re-derivation.  (Contributed by Scott Fenton, 12-Sep-2005.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax46to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    ( wal wn wi pm2.21 ax46 syl ) ABCZDBCZDJIEAJIFABGH $.

  $( Proof of a single axiom that can replace both ~ ax-6o and ~ ax-7 .  See
     ~ ax67to6 and ~ ax67to7 for the re-derivation of those axioms.
     (Contributed by NM, 18-Nov-2006.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax67 $p |- ( -. A. x -. A. y A. x ph -> A. y ph ) $=
    ( wal wn ax-7 con3i alimi ax-6o syl ) ABDCDZEZBDZEACDZBDZEZBDZENQMPLBKOACBF
    GHGNBIJ $.

  $( ` x ` is not free in ` A. x ph ` .  (Contributed by Mario Carneiro,
     11-Aug-2016.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  nfa1-o $p |- F/ x A. x ph $=
    ( wal hba1-o nfi ) ABCBABDE $.

  $( Re-derivation of ~ ax-6o from ~ ax67 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation.  (Contributed by NM, 18-Nov-2006.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax67to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    ( wal wn hba1-o con3i alimi ax67 ax-4 3syl ) ABCZDZBCZDKBCZDZBCZDKAPMOLBKNA
    BEFGFABBHABIJ $.

  $( Re-derivation of ~ ax-7 from ~ ax67 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation.  (Contributed by NM, 18-Nov-2006.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax67to7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
    ( wal wn ax67to6 con4i ax67 alimi syl ) ACDBDZKEZCDEZCDZABDZCDNKLCFGMOCACBH
    IJ $.

  $( Proof of a single axiom that can replace ~ ax-4 , ~ ax-6o , and ~ ax-7 in
     a subsystem that includes these axioms plus ~ ax-5o and ~ ax-gen (and
     propositional calculus).  See ~ ax467to4 , ~ ax467to6 , and ~ ax467to7 for
     the re-derivation of those axioms.  This theorem extends the idea in Scott
     Fenton's ~ ax46 .  (Contributed by NM, 18-Nov-2006.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax467 $p |- ( ( A. x A. y -. A. x A. y ph -> A. x ph ) -> ph ) $=
    ( wal wn ax-4 ax6 ax-6o con1i alimi ax-7 3syl nsyl4 ja ) ACDZBDEZCDBDZABDAO
    AQACFOEZRCDPBDZCDQACGRSCSOOBHIJPCBKLMABFN $.

  $( Re-derivation of ~ ax-4 from ~ ax467 .  Only propositional calculus is
     used by the re-derivation.  (Contributed by NM, 19-Nov-2006.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax467to4 $p |- ( A. x ph -> ph ) $=
    ( wal wn wi ax-1 ax467 syl ) ABCZIBCDBCBCZIEAIJFABBGH $.

  $( Re-derivation of ~ ax-6o from ~ ax467 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation.  The use of ~ alimi (which uses ~ ax-4 ) is
     allowed since we have already proved ~ ax467to4 .  (Contributed by NM,
     19-Nov-2006.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax467to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    ( wal wn wi hba1-o con3i alimi sps-o pm2.21 ax467 3syl ) ABCZDZBCZDMBCZDZBC
    ZBCZDSMEASOROBQNBMPABFGHIGSMJABBKL $.

  $( Re-derivation of ~ ax-7 from ~ ax467 .  Note that ~ ax-6o and ~ ax-7 are
     not used by the re-derivation.  The use of ~ alimi (which uses ~ ax-4 ) is
     allowed since we have already proved ~ ax467to4 .  (Contributed by NM,
     19-Nov-2006.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax467to7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
    ( wal wn ax467to6 con4i wi pm2.21 ax467 syl alimi nsyl4 ) ACDBDZNEZCDZEZCDZ
    ABDZCDRNOCFGQSCPBDZEZBDSPUAABUATSHATSIABCJKLPBFMLK $.

  $( ~ equid with existential quantifier without using ~ ax-4 or ~ ax-17 .
     (Contributed by NM, 13-Jan-2011.)  (Proof shortened by Wolf Lammen,
     27-Feb-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  equidqe $p |- -. A. y -. x = x $=
    ( weq wn wal ax9from9o ax-8 pm2.43i con3i alimi mto ) AACZDZBEBACZDZBEBAFMO
    BNLNLBAAGHIJK $.

  $( A special case of ~ ax-4 without using ~ ax-4 or ~ ax-17 .  (Contributed
     by NM, 13-Jan-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax4sp1 $p |- ( A. y -. x = x -> -. x = x ) $=
    ( weq wn wal equidqe pm2.21i ) AACDZBEHABFG $.

  $( ~ equid with universal quantifier without using ~ ax-4 or ~ ax-17 .
     (Contributed by NM, 13-Jan-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  equidq $p |- A. y x = x $=
    ( weq wal wn equidqe ax6 hbequid con3i alrimih mt3 ) AACZBDZLEZBDABFMENBLBG
    LMABHIJK $.

  $( Identity law for equality (reflexivity).  Lemma 6 of [Tarski] p. 68.
     Alternate proof of ~ equid1 from older axioms ~ ax-6o and ~ ax-9o .
     (Contributed by NM, 5-Aug-1993.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  equid1ALT $p |- x = x $=
    ( weq wal wn wi ax-12o pm2.43i alimi ax-9o syl ax-6o pm2.61i ) AABZACZDZACZ
    MPMNEZACMOQAOQAAAFGHMAAIJMAKL $.

  $( Rederivation of ~ ax-10 from original version ~ ax-10o .  See theorem
     ~ ax10o for the derivation of ~ ax-10o from ~ ax-10 .

     This theorem should not be referenced in any proof.  Instead, use ~ ax-10
     above so that uses of ~ ax-10 can be more easily identified, or use
     ~ aecom-o when this form is needed for studies involving ~ ax-10o and
     omitting ~ ax-17 .  (Contributed by NM, 16-May-2008.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ax10from10o $p |- ( A. x x = y -> A. y y = x ) $=
    ( weq wal ax-10o pm2.43i equcomi alimi syl ) ABCZADZJBDZBACZBDKLJABEFJMBABG
    HI $.

  ${
    nalequcoms-o.1 $e |- ( -. A. x x = y -> ph ) $.
    $( A commutation rule for distinct variable specifiers.  Version of
       ~ naecoms using ~ ax-10o .  (Contributed by NM, 2-Jan-2002.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    naecoms-o $p |- ( -. A. y y = x -> ph ) $=
      ( weq wal aecom-o nsyl4 con1i ) ACBECFZBCEBFJABCGDHI $.
  $}

  $( All variables are effectively bound in a distinct variable specifier.
     Lemma L19 in [Megill] p. 446 (p. 14 of the preprint).  Version of ~ hbnae
     using ~ ax-10o .  (Contributed by NM, 5-Aug-1993.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  hbnae-o $p |- ( -. A. x x = y -> A. z -. A. x x = y ) $=
    ( weq wal hbae-o hbn ) ABDAECABCFG $.

  ${
    dvelimf-o.1 $e |- ( ph -> A. x ph ) $.
    dvelimf-o.2 $e |- ( ps -> A. z ps ) $.
    dvelimf-o.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Proof of ~ dvelimh that uses ~ ax-10o but not ~ ax-11o , ~ ax-10 , or
       ~ ax-11 .  Version of ~ dvelimh using ~ ax-10o instead of ~ ax10o .
       (Contributed by NM, 12-Nov-2002.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dvelimf-o $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi hba1-o ax-10o aecoms-o syl5 a1d wa hbnae-o hban imp hbimd
      ax-12o a1i hbald ex pm2.61i equsalh albii 3imtr3g ) CDICJKZEDIZALZEJZUNCJ
      ZBBCJCEICJZUKUNUOLZLUPUQUKUNUNEJZUPUOUMEMURUOLECUNECNOPQUPKZUKUQUSUKRZUMC
      EUSUKECEESCDESTUTULACUSUKCCECSCDCSTUSUKULULCJLEDCUCUAAACJLUTFUDUBUEUFUGAB
      EDGHUHZUNBCVAUIUJ $.
  $}

  ${
    dral2-o.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  Version of
       ~ dral2 using ~ ax-10o .  (Contributed by NM, 27-Feb-2005.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dral2-o $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
      ( weq wal hbae-o albidh ) CDGCHABECDEIFJ $.
  $}

  ${
    $d t u v $.  $d t u x y $.  $d u w $.
    $( A "distinctor elimination" lemma with no restrictions on variables in
       the consequent, proved without using ~ ax-16 .  Version of ~ aev using
       ~ ax-10o .  (Contributed by NM, 8-Nov-2006.)  (Proof shortened by Andrew
       Salmon, 21-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    aev-o $p |- ( A. x x = y -> A. z w = v ) $=
      ( vt vu weq hbae-o ax-8 spimv alrimih equcomi syl6 aecoms-o a5i-o aecom-o
      wal 3syl ) ABHZARZDEHZCABCIUAFBHZFRZGEHZGRZUBUAUCFABFITUCAFAFBJKLUDFGHZFR
      ZEGHZERUFUCUGFUGBFBFHZUGBGBGHUJGFHUGBGFJGFMNKOPUHUIEFGEIUGUIFEFEGJKLEGQSU
      EUBGDGDEJKSL $.
  $}

  ${
    $d x z $.  $d y z $.
    $( Theorem to add distinct quantifier to atomic formula.  (This theorem
       demonstrates the induction basis for ~ ax-17 considered as a
       metatheorem.  Do not use it for later proofs - use ~ ax-17 instead, to
       avoid reference to the redundant axiom ~ ax-16 .)  (Contributed by NM,
       5-Aug-1993.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax17eq $p |- ( x = y -> A. z x = y ) $=
      ( weq wal wi ax-12o ax-16 pm2.61ii ) CADCECBDCEABDZJCEFABCGJCAHJCBHI $.
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct.  Version
       of ~ dveeq2 using ~ ax-11o .  (Contributed by NM, 2-Jan-2002.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dveeq2-o $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      ( vw weq ax-17 equequ2 dvelimf-o ) CDEZCBEZABDIAFJDFDBCGH $.

    $( Version of ~ dveeq2 using ~ ax-16 instead of ~ ax-17 .  TO DO:  Recover
       proof from older set.mm to remove use of ~ ax-17 .  (Contributed by NM,
       29-Apr-2008.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dveeq2-o16 $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      ( vw weq ax17eq equequ2 dvelimALT ) CDECBEABDCDAFDBCGH $.
  $}

  ${
    $d x y $.
    $( A generalization of axiom ~ ax-16 .  Version of ~ a16g using ~ ax-10o .
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       25-May-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    a16g-o $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      ( weq wal aev-o ax-16 biidd dral1-o biimprd sylsyld ) BCEBFDBEDFZAABFZADF
      ZBCDDBGABCHMONAADBMAIJKL $.
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct.  Version
       of ~ dveeq1 using ax-10o .  (Contributed by NM, 2-Jan-2002.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dveeq1-o $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      ( vw weq ax-17 equequ1 dvelimf-o ) DCEZBCEZABDIAFJDFDBCGH $.

    $( Version of ~ dveeq1 using ~ ax-16 instead of ~ ax-17 .  (Contributed by
       NM, 29-Apr-2008.)  TO DO:  Recover proof from older set.mm to remove use
       of ~ ax-17 .  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dveeq1-o16 $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      ( vw weq ax17eq equequ1 dvelimh ) DCEBCEABDDCAFBCDFDBCGH $.
  $}

  ${
    $d x z $.  $d y z $.
    $( Theorem to add distinct quantifier to atomic formula.  This theorem
       demonstrates the induction basis for ~ ax-17 considered as a
       metatheorem.)  (Contributed by NM, 5-Aug-1993.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax17el $p |- ( x e. y -> A. z x e. y ) $=
      ( weq wal wel wi ax-15 ax-16 pm2.61ii ) CADCECBDCEABFZKCEGABCHKCAIKCBIJ
      $.
  $}

  ${
    $d x z w $.
    $( This theorem shows that, given ~ ax-16 , we can derive a version of
       ~ ax-10 .  However, it is weaker than ~ ax-10 because it has a distinct
       variable requirement.  (Contributed by Andrew Salmon, 27-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax10-16 $p |- ( A. x x = z -> A. z z = x ) $=
      ( vw weq wal ax-16 alrimiv a5i-o equequ1 cbvalv a1i imbi12d albidv biimpi
      wi wb wex nfa1-o 19.23 a7s albii pm2.27 ax-mp alimi equequ2 spv sps-o syl
      a9ev sylbi 3syl ) ABDZAEZACDZUNAEZOZCEZAEZBCDZUSBEZOZCEZBEZBADZBEULUQAUMU
      PCUNABFGHURVCUQVBABULUPVACULUNUSUOUTABCIZUOUTPULUNUSABVEJKLMJNVBVDBVAVDCB
      VABEZCEUSBQZUTOZCEZVDVFVHCUSUTBUSBRSUAVIUTCEVDVHUTCVGVHUTOBCUIVGUTUBUCUDU
      SVDBCUSCEVDBUSVDCACABUEUFUGTUHUJTHUK $.
  $}

  ${
    $d w z x $.  $d w y $.
    $( Version of ~ dveel2 using ~ ax-16 instead of ~ ax-17 .  (Contributed by
       NM, 10-May-2008.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dveel2ALT $p |- ( -. A. x x = y -> ( z e. y -> A. x z e. y ) ) $=
      ( vw wel ax17el elequ2 dvelimh ) CDECBEABDCDAFCBDFDBCGH $.
  $}

  ${
    ax11f.1 $e |- ( ph -> A. x ph ) $.
    $( Basis step for constructing a substitution instance of ~ ax-11o without
       using ~ ax-11o .  We can start with any formula ` ph ` in which ` x ` is
       not free.  (Contributed by NM, 21-Jan-2007.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax11f $p |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( weq wal wn wi ax-1 alrimih a1ii ) BCEZBFGLALAHZBFHAMBDALIJK $.
  $}

  ${
    $d x u v $.  $d y u v $.  $d z u v $.  $d w u v $.
    $( Basis step for constructing a substitution instance of ~ ax-11o without
       using ~ ax-11o .  Atomic formula for equality predicate.  (Contributed
       by NM, 22-Jan-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11eq $p |- ( -. A. x x = y ->
               ( x = y -> ( z = w -> A. x ( x = y -> z = w ) ) ) ) $=
      ( vu vv weq wal wn wi wa 19.26 a1i wb equequ1 equequ2 sps-o imbi12d exp32
      imbi2d equid ax-gen sylan9bb nfa1-o adantr sylbir ad2antll impcom adantrr
      albid mpbii ax12o equtrr alimi syl6 sylbid adantll dral2-o ad2antrr mpbid
      imp biimprcd adantlr ad2antlr wex alrimiv adantl dveeq2-o im2anan9 sylibr
      a9ev ax-1 syl exlimdv mpi a1d 4cases ) ACGZAHZADGZAHZABGZAHIZWBCDGZWBWDJZ
      AHZJZJZJZVSWAKVRVTKZAHZWIVRVTALWKWCWBWGWKWCWBKZKAAGZWBWMJZAHZJZWGWOWMWNAW
      MWBAUAMUBMWKWPWGNWLWKWMWDWOWFWJWMWDNAVRWMCAGZVTWDACAOADCPZUCQZWKWNWEAWJAU
      DWKWMWDWBWSTUJRUEUKSUFVSWAIZKZWCWBWGXAWLKVTWBVTJZAHZJZWGWTWLXDVSWTWLKZVTB
      DGZXCWBVTXFNWTWCABDOUGXEXFXFAHZXCWTWCXFXGJZWBWCWTXHBDAULUHUIXFXBABDAUMUNU
      OUPUQVSXDWGNWTWLVSVTWDXCWFVRVTWDNAACDOQZXBWEACAVSVTWDWBXITURRUSUTSVSIZWAK
      ZWCWBWGXKWLKWQWBWQJZAHZJZWGXJWLXNWAXJWLKZWQCBGZXMWBWQXPNXJWCABCPZUGXOXPXP
      AHZXMXJWCXPXRJZWBXJWCXSCBAULVAUIXPXLAWBWQXPXQVBUNUOUPVCWAXNWGNXJWLWAWQWDX
      MWFVTWQWDNAWRQZXLWEADAWAWQWDWBXTTURRVDUTSXJWTKZWHWCYAWGWBYAEDGZEVEWGEDVKY
      AYBWGEYAFCGZFVEYBWGJZFCVKYAYCYDFYAYCYBWGYAYCYBKZKZFEGZWBYGJZAHZJWGYGYHAYG
      WBVLVFYFYGWDYIWFYEYGWDNZYAYCYGCEGYBWDFCEOEDCPUCZVGYFYEAHZYIWFNYFYCAHZYBAH
      ZKZYLYAYEYOXJYCYMWTYBYNACFVHADEVHVIVAYCYBALVJYLYHWEAYEAUDYLYGWDWBYEYJAYKQ
      TUJVMRUKSVNVOVNVOVPVPVQ $.
  $}

  ${
    $d x u v $.  $d y u v $.  $d z u v $.  $d w u v $.
    $( Basis step for constructing a substitution instance of ~ ax-11o without
       using ~ ax-11o .  Atomic formula for membership predicate.  (Contributed
       by NM, 22-Jan-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11el $p |- ( -. A. x x = y ->
               ( x = y -> ( z e. w -> A. x ( x = y -> z e. w ) ) ) ) $=
      ( vv vu weq wal wn wel wi wa wb elequ1 elequ2 adantl sps-o imbi2d imbi12d
      exp32 19.26 bitrd ax-17 biimprcd alimi syl6 adantr sylbid sylan9bb nfa1-o
      albid mpbid sylbir ad2antll ax-15 impcom adantrr adantll dral2-o ad2antrr
      dvelimf-o imp adantlr ad2antlr a9ev ax-1 alrimiv dveeq2-o im2anan9 sylibr
      wex syl mpbii exlimdv mpi a1d 4cases ) ACGZAHZADGZAHZABGZAHIZWBCDJZWBWDKZ
      AHZKZKZKZVSWALVRVTLZAHZWIVRVTAUAWKWCWBWGWKWCWBLZLAAJZWBWMKZAHZKZWGWLWPWKW
      LWMBBJZWOWBWMWQMWCWBWMBAJWQABANABBOUBZPWCWQWOKWBWCWQWQAHWOEEJZWQABEWSAUCW
      QEUCEBGWSBEJWQEBENEBBOUBVAWQWNAWBWMWQWRUDUEUFUGUHPWKWPWGMWLWKWMWDWOWFWJWM
      WDMAVRWMCAJZVTWDACANADCOZUIQZWKWNWEAWJAUJWKWMWDWBXBRUKSUGULTUMVSWAIZLZWCW
      BWGXDWLLADJZWBXEKZAHZKZWGXCWLXHVSXCWLLZXEBDJZXGWBXEXJMXCWCABDNZUNXIXJXJAH
      ZXGXCWCXJXLKZWBWCXCXMBDAUOUPUQXJXFAWBXEXJXKUDUEUFUHURVSXHWGMXCWLVSXEWDXGW
      FVRXEWDMAACDNQZXFWEACAVSXEWDWBXNRUSSUTULTVSIZWALZWCWBWGXPWLLWTWBWTKZAHZKZ
      WGXOWLXSWAXOWLLZWTCBJZXRWBWTYAMXOWCABCOZUNXTYAYAAHZXRXOWCYAYCKZWBXOWCYDCB
      AUOVBUQYAXQAWBWTYAYBUDUEUFUHVCWAXSWGMXOWLWAWTWDXRWFVTWTWDMAXAQZXQWEADAWAW
      TWDWBYERUSSVDULTXOXCLZWHWCYFWGWBYFFDGZFVKWGFDVEYFYGWGFYFECGZEVKYGWGKZECVE
      YFYHYIEYFYHYGWGYFYHYGLZLZEFJZWBYLKZAHZKWGYLYMAYLWBVFVGYKYLWDYNWFYJYLWDMZY
      FYHYLCFJYGWDECFNFDCOUIZPYKYJAHZYNWFMYKYHAHZYGAHZLZYQYFYJYTXOYHYRXCYGYSACE
      VHADFVHVIVBYHYGAUAVJYQYMWEAYJAUJYQYLWDWBYJYOAYPQRUKVLSVMTVNVOVNVOVPVPVQ
      $.
  $}

  ${
    ax11indn.1 $e |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.
    $( Induction step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Negation case.  (Contributed by NM,
       21-Jan-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11indn $p |- ( -. A. x x = y ->
               ( x = y -> ( -. ph -> A. x ( x = y -> -. ph ) ) ) ) $=
      ( weq wal wn wi wa 19.8a exanali hbn1 con3 syl6 com23 alrimdh syl5bi syl5
      wex exp3a ) BCEZBFGZUAAGZUAUCHZBFZUAUCIZUFBSZUBUEUFBJUGUAAHZBFZGZUBUEUAAB
      KUBUJUDBUABLUHBLUBUAUJUCUBUAAUIHUJUCHDAUIMNOPQRT $.

    ${
      ax11indi.2 $e |- ( -. A. x x = y ->
                 ( x = y -> ( ps -> A. x ( x = y -> ps ) ) ) ) $.
      $( Induction step for constructing a substitution instance of ~ ax-11o
         without using ~ ax-11o .  Implication case.  (Contributed by NM,
         21-Jan-2007.)  (Proof modification is discouraged.)
         (New usage is discouraged.) $)
      ax11indi $p |- ( -. A. x x = y ->
           ( x = y -> ( ( ph -> ps ) -> A. x ( x = y -> ( ph -> ps ) ) ) ) ) $=
        ( weq wal wn wi wa ax11indn imp pm2.21 imim2i alimi syl6 ax-1 jad ex )
        CDGZCHIZUAABJZUAUCJZCHZJUBUAKZABUEUFAIZUAUGJZCHZUEUBUAUGUIJACDELMUHUDCU
        GUCUAABNOPQUFBUABJZCHZUEUBUABUKJFMUJUDCBUCUABAROPQST $.
    $}
  $}

  ${
    ax11indalem.1 $e |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.
    $( Lemma for ~ ax11inda2 and ~ ax11inda .  (Contributed by NM,
       24-Jan-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11indalem $p |- ( -. A. y y = z -> ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) ) $=
      ( weq wal wn wi ax-1 a5i-o a1i biidd a1d aecom-o con3i imp hbnae-o hban
      wa dral1-o imbi2d dral2-o 3imtr4d adantr simplr ax12o syl2an adantlr ax-4
      aecoms-o hba1-o sylan2 alimdh syl2anc ax-7 wb nfdh 19.21t albidh ad2antrr
      wnf syl syl5ib syld exp31 pm2.61ian ) BDFBGZCDFCGZHZBCFZBGHZVKADGZVKVMIZB
      GZIZIZIZVHVRVJVHVQVLVHVPVKVPDBDBFDGZABGZVKVTIZBGZVMVOVTWBIVSAWABVTVKJKLAA
      DBVSAMUAZVNWADBBVSVMVTVKWCUBUCUDUKNNUEVHHZVJTZVLVKVPWEVLTVKTZVMVKAIZBGZDG
      ZVOWFVLVKDGZVMWIIWEVLVKUFWEVKWJVLWEVKWJWDVSHZDCFDGZHZVKWJIZVJVSVHDBOPWLVI
      DCOPWKWMWNBCDUGQUHZQUIVLWJTAWHDVLWJDBCDRVKDULSWJVLVKAWHIZVKDUJVLVKWPEQUMU
      NUOWEWIVOIVLVKWIWGDGZBGWEVOWGDBUPWEWQVNBWDVJBBDBRCDBRSWEVKDVBWQVNUQWEVKDW
      DVJDBDDRCDDRSWOURVKADUSVCUTVDVAVEVFVG $.
  $}

  ${
    $d z y $.
    ax11inda2.1 $e |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $.
    $( A proof of ~ ax11inda2 that is slightly more direct.  (Contributed by
       NM, 4-May-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11inda2ALT $p |- ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) $=
      ( weq wal wn wi a5i-o a1i biidd dral1-o imbi2d dral2-o a1d wa imp hbnae-o
      ax-1 3imtr4d aecoms-o simplr dveeq1-o naecoms-o hba1-o hban sylan2 alimdh
      adantlr ax-4 syl2anc ax-7 wnf nfdh 19.21t syl albidh syl5ib ad2antrr syld
      wb exp31 pm2.61i ) BDFBGZBCFZBGHZVFADGZVFVHIZBGZIZIZIVEVLVGVEVKVFVKDBDBFD
      GZABGZVFVNIZBGZVHVJVNVPIVMAVOBVNVFTJKAADBVMALMZVIVODBBVMVHVNVFVQNOUAUBPPV
      EHZVGVFVKVRVGQVFQZVHVFAIZBGZDGZVJVSVGVFDGZVHWBIVRVGVFUCVRVFWCVGVRVFWCVFWC
      IDBDBCUDUEZRUJVGWCQAWADVGWCDBCDSVFDUFUGWCVGVFAWAIZVFDUKVGVFWEERUHUIULVRWB
      VJIVGVFWBVTDGZBGVRVJVTDBUMVRWFVIBBDBSVRVFDUNWFVIVBVRVFDBDDSWDUOVFADUPUQUR
      USUTVAVCVD $.

    $( Induction step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Quantification case.  When ` z ` and ` y ` are
       distinct, this theorem avoids the dummy variables needed by the more
       general ~ ax11inda .  (Contributed by NM, 24-Jan-2007.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax11inda2 $p |- ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) $=
      ( weq wal wn wi ax-1 a16g-o syl5 a1d ax11indalem pm2.61i ) CDFCGZBCFZBGHZ
      QADGZQSIZBGZIZIZIPUCRPUBQSTPUASQJTCDBKLMMABCDENO $.
  $}

  ${
    $d w ph $.  $d w x $.  $d w y $.  $d w z $.
    ax11inda.1 $e |- ( -. A. x x = w ->
               ( x = w -> ( ph -> A. x ( x = w -> ph ) ) ) ) $.
    $( Induction step for constructing a substitution instance of ~ ax-11o
       without using ~ ax-11o .  Quantification case.  (When ` z ` and ` y `
       are distinct, ~ ax11inda2 may be used instead to avoid the dummy
       variable ` w ` in the proof.)  (Contributed by NM, 24-Jan-2007.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax11inda $p |- ( -. A. x x = y ->
               ( x = y -> ( A. z ph -> A. x ( x = y -> A. z ph ) ) ) ) $=
      ( weq wal wn wi wex a9ev wa ax11inda2 wb dveeq2-o imp albidh syl imbi12d
      hba1-o equequ2 sps-o notbid adantl imbi1d imbi2d mpbii ex exlimdv pm2.43i
      mpi ) BCGZBHZIZUMADHZUMUPJZBHZJZJZUOECGZEKUOUTJZECLUOVAVBEUOVAVBUOVAMZBEG
      ZBHZIZVDUPVDUPJZBHZJZJZJVBABEDFNVCVFUOVJUTVCVABHZVFUOOUOVAVKBCEPQZVKVEUNV
      KVDUMBVABUAZVAVDUMOZBECBUBZUCZRUDSVCVDUMVIUSVAVNUOVOUEVCVHURUPVCVKVHUROVL
      VKVGUQBVMVKVDUMUPVPUFRSUGTTUHUIUJULUK $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11v2-o.1 $e |- ( x = z -> ( ph -> A. x ( x = z -> ph ) ) ) $.
    $( Recovery of ~ ax-11o from ~ ax11v without using ~ ax-11o .  The
       hypothesis is even weaker than ~ ax11v , with ` z ` both distinct from
       ` x ` _and_ not occurring in ` ph ` .  Thus, the hypothesis provides an
       alternate axiom that can be used in place of ~ ax-11o .  (Contributed by
       NM, 2-Feb-2007.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax11v2-o $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( weq wal wn wex wi wa wb equequ2 adantl dveeq2-o imp nfa1-o imbi1d sps-o
      a9ev albid syl imbi2d imbi12d mpbii ex exlimdv mpi ) BCFZBGHZDCFZDIUIAUIA
      JZBGZJZJZDCTUJUKUODUJUKUOUJUKKZBDFZAUQAJZBGZJZJUOEUPUQUIUTUNUKUQUILUJDCBM
      ZNUPUSUMAUPUKBGZUSUMLUJUKVBBCDOPVBURULBUKBQUKURULLBUKUQUIAVARSUAUBUCUDUEU
      FUGUH $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11a2-o.1 $e |- ( x = z -> ( A. z ph -> A. x ( x = z -> ph ) ) ) $.
    $( Derive ~ ax-11o from a hypothesis in the form of ~ ax-11 , without using
       ~ ax-11 or ~ ax-11o .  The hypothesis is even weaker than ~ ax-11 , with
       ` z ` both distinct from ` x ` and not occurring in ` ph ` .  Thus, the
       hypothesis provides an alternate axiom that can be used in place of
       ~ ax-11 , if we also hvae ~ ax-10o which this proof uses .  As theorem
       ~ ax11 shows, the distinct variable conditions are optional.  An open
       problem is whether we can derive this with ~ ax-10 instead of
       ~ ax-10o .  (Contributed by NM, 2-Feb-2007.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax11a2-o $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( wal weq wi ax-17 syl5 ax11v2-o ) ABCDAADFBDGZLAHBFADIEJK $.
  $}

  $( Show that ~ ax-10o can be derived from ~ ax-10 .  An open problem is
     whether this theorem can be derived from ~ ax-10 and the others when
     ~ ax-11 is replaced with ~ ax-11o .  See theorem ~ ax10from10o for the
     rederivation of ~ ax-10 from ~ ax10o .

     Normally, ~ ax10o should be used rather than ~ ax-10o or ~ ax10o-o ,
     except by theorems specifically studying the latter's properties.
     (Contributed by NM, 16-May-2008.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ax10o-o $p |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $=
    ( weq wal wi ax-10 ax11 equcoms sps-o pm2.27 al2imi sylsyld ) BCDZBECBDZCEA
    BEZOAFZCEZACEBCGNPRFZBSCBACBHIJOQACOAKLM $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Existential uniqueness
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $( Declare new symbols needed for uniqueness notation. $)
  $c E! $.  $( Backwards E exclamation point. $)
  $c E* $.  $( Backwards E superscript *. $)

  $( Extend wff definition to include existential uniqueness ("there exists a
     unique ` x ` such that ` ph ` "). $)
  weu $a wff E! x ph $.

  $( Extend wff definition to include uniqueness ("there exists at most one
     ` x ` such that ` ph ` "). $)
  wmo $a wff E* x ph $.

  ${
    $d w x y $.  $d x z $.  $d y ph $.  $d w z ph $.
    $( A soundness justification theorem for ~ df-eu , showing that the
       definition is equivalent to itself with its dummy variable renamed.
       Note that ` y ` and ` z ` needn't be distinct variables.  See
       ~ eujustALT for a proof that provides an example of how it can be
       achieved through the use of ~ dvelim .  (Contributed by NM,
       11-Mar-2010.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
    eujust $p |- ( E. y A. x ( ph <-> x = y )
        <-> E. z A. x ( ph <-> x = z ) ) $=
      ( vw weq wb wal wex equequ2 bibi2d albidv cbvexv bitri ) ABCFZGZBHZCIABEF
      ZGZBHZEIABDFZGZBHZDIQTCECEFZPSBUDORACEBJKLMTUCEDEDFZSUBBUERUAAEDBJKLMN $.

    $( A soundness justification theorem for ~ df-eu , showing that the
       definition is equivalent to itself with its dummy variable renamed.
       Note that ` y ` and ` z ` needn't be distinct variables.  While this
       isn't strictly necessary for soundness, the proof provides an example of
       how it can be achieved through the use of ~ dvelim .  (Contributed by
       NM, 11-Mar-2010.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eujustALT $p |- ( E. y A. x ( ph <-> x = y )
        <-> E. z A. x ( ph <-> x = z ) ) $=
      ( vw weq wal wb wex equequ2 bibi2d albidv wn hbnae wi ax-17 notbid dvelim
      sps df-ex drex1 alrimih naecoms a1i cbv2h syl 3bitr4g pm2.61i ) CDFZCGZAB
      CFZHZBGZCIZABDFZHZBGZDIZHUMUQCDUIUMUQHCUIULUPBUIUKUOACDBJKLZSUAUJMZUMMZCG
      ZMUQMZDGZMUNURUTVBVDUTUTDGZCGVBVDHUTVECCDCNCDDNUBUTVAVCCDVAVADGODCABEFZHZ
      BGZMZVADCEVIDPECFZVHUMVJVGULBVJVFUKAECBJKLQRUCVIVCCDEVICPEDFZVHUQVKVGUPBV
      KVFUOAEDBJKLQRUIVAVCHOUTUIUMUQUSQUDUEUFQUMCTUQDTUGUH $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( Define existential uniqueness, i.e.  "there exists exactly one ` x `
       such that ` ph ` ."  Definition 10.1 of [BellMachover] p. 97; also
       Definition *14.02 of [WhiteheadRussell] p. 175.  Other possible
       definitions are given by ~ eu1 , ~ eu2 , ~ eu3 , and ~ eu5 (which in
       some cases we show with a hypothesis ` ph -> A. y ph ` in place of a
       distinct variable condition on ` y ` and ` ph ` ).  Double uniqueness is
       tricky: ` E! x E! y ph ` does not mean "exactly one ` x ` and one
       ` y ` " (see ~ 2eu4 ).  (Contributed by NM, 12-Aug-1993.) $)
    df-eu $a |- ( E! x ph <-> E. y A. x ( ph <-> x = y ) ) $.
  $}

  $( Define "there exists at most one ` x ` such that ` ph ` ."  Here we define
     it in terms of existential uniqueness.  Notation of [BellMachover] p. 460,
     whose definition we show as ~ mo3 .  For other possible definitions see
     ~ mo2 and ~ mo4 .  (Contributed by NM, 8-Mar-1995.) $)
  df-mo $a |- ( E* x ph <-> ( E. x ph -> E! x ph ) ) $.

  ${
    $d x y z $.  $d ph z $.
    euf.1 $e |- F/ y ph $.
    $( A version of the existential uniqueness definition with a hypothesis
       instead of a distinct variable condition.  (Contributed by NM,
       12-Aug-1993.) $)
    euf $p |- ( E! x ph <-> E. y A. x ( ph <-> x = y ) ) $=
      ( vz weu weq wb wal wex df-eu nfbi nfal equequ2 bibi2d albidv cbvex bitri
      nfv ) ABFABEGZHZBIZEJABCGZHZBIZCJABEKUBUEECUACBATCDTCSLMUDEBAUCEAESUCESLM
      ECGZUAUDBUFTUCAECBNOPQR $.
  $}

  ${
    $d x y $.  $d y ph $.  $d y ps $.  $d y ch $.
    eubid.1 $e |- F/ x ph $.
    eubid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for uniqueness quantifier (deduction rule).
       (Contributed by NM, 9-Jul-1994.) $)
    eubid $p |- ( ph -> ( E! x ps <-> E! x ch ) ) $=
      ( vy weq wb wal wex weu bibi1d albid exbidv df-eu 3bitr4g ) ABDGHZIZDJZGK
      CRIZDJZGKBDLCDLATUBGASUADEABCRFMNOBDGPCDGPQ $.
  $}

  ${
    $d x ph $.
    eubidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for uniqueness quantifier (deduction rule).
       (Contributed by NM, 9-Jul-1994.) $)
    eubidv $p |- ( ph -> ( E! x ps <-> E! x ch ) ) $=
      ( nfv eubid ) ABCDADFEG $.
  $}

  ${
    eubii.1 $e |- ( ph <-> ps ) $.
    $( Introduce uniqueness quantifier to both sides of an equivalence.
       (Contributed by NM, 9-Jul-1994.)  (Revised by Mario Carneiro,
       6-Oct-2016.) $)
    eubii $p |- ( E! x ph <-> E! x ps ) $=
      ( weu wb wtru a1i eubidv trud ) ACEBCEFGABCABFGDHIJ $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( Bound-variable hypothesis builder for uniqueness.  (Contributed by NM,
       9-Jul-1994.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
    nfeu1 $p |- F/ x E! x ph $=
      ( vy weu weq wb wal wex df-eu nfa1 nfex nfxfr ) ABDABCEFZBGZCHBABCINBCMBJ
      KL $.
  $}

  $( Bound-variable hypothesis builder for "at most one."  (Contributed by NM,
     8-Mar-1995.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
  nfmo1 $p |- F/ x E* x ph $=
    ( wmo wex weu wi df-mo nfe1 nfeu1 nfim nfxfr ) ABCABDZABEZFBABGLMBABHABIJK
    $.

  ${
    $d y z $.  $d z ph $.  $d z ps $.
    nfeud2.1 $e |- F/ y ph $.
    nfeud2.2 $e |- ( ( ph /\ -. A. x x = y ) -> F/ x ps ) $.
    $( Bound-variable hypothesis builder for uniqueness.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    nfeud2 $p |- ( ph -> F/ x E! y ps ) $=
      ( vz weu weq wb wal wex df-eu nfv wn wa nfnae nfan wnf adantlr adantll
      nfeqf ancoms nfbid nfald2 nfexd2 nfxfrd ) BDHBDGIZJZDKZGLACBDGMAUJCGAGNAC
      GICKOZPZUICDAUKDECGDQRULCDICKOZPBUHCAUMBCSUKFTUKUMUHCSZAUMUKUNDGCUBUCUAUD
      UEUFUG $.

    $( Bound-variable hypothesis builder for "at most one."  (Contributed by
       Mario Carneiro, 14-Nov-2016.) $)
    nfmod2 $p |- ( ph -> F/ x E* y ps ) $=
      ( wmo wex weu wi df-mo nfexd2 nfeud2 nfimd nfxfrd ) BDGBDHZBDIZJACBDKAPQC
      ABCDEFLABCDEFMNO $.
  $}

  ${
    nfeud.1 $e |- F/ y ph $.
    nfeud.2 $e |- ( ph -> F/ x ps ) $.
    $( Deduction version of ~ nfeu .  (Contributed by NM, 15-Feb-2013.)
       (Revised by Mario Carneiro, 7-Oct-2016.) $)
    nfeud $p |- ( ph -> F/ x E! y ps ) $=
      ( wnf weq wal wn adantr nfeud2 ) ABCDEABCGCDHCIJFKL $.

    $( Bound-variable hypothesis builder for "at most one."  (Contributed by
       Mario Carneiro, 14-Nov-2016.) $)
    nfmod $p |- ( ph -> F/ x E* y ps ) $=
      ( wnf weq wal wn adantr nfmod2 ) ABCDEABCGCDHCIJFKL $.
  $}

  ${
    $d y z $.  $d x z $.  $d z ph $.
    nfeu.1 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for uniqueness.  Note that ` x ` and
       ` y ` needn't be distinct (this makes the proof more difficult).
       (Contributed by NM, 8-Mar-1995.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    nfeu $p |- F/ x E! y ph $=
      ( weu wnf wtru nftru a1i nfeud trud ) ACEBFGABCCHABFGDIJK $.

    $( Bound-variable hypothesis builder for "at most one."  (Contributed by
       NM, 9-Mar-1995.) $)
    nfmo $p |- F/ x E* y ph $=
      ( wmo wnf wtru nftru a1i nfmod trud ) ACEBFGABCCHABFGDIJK $.
  $}

  ${
    $d w y z $.  $d ph z w $.  $d w x z $.
    sb8eu.1 $e |- F/ y ph $.
    $( Variable substitution in uniqueness quantifier.  (Contributed by NM,
       7-Aug-1994.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
    sb8eu $p |- ( E! x ph <-> E! y [ y / x ] ph ) $=
      ( vz vw weq wb wal wex wsb weu nfv sb8 sbbi nfsb equsb3 nfxfr nfbi df-eu
      sbequ cbval sblbis albii 3bitri exbii 3bitr4i ) ABEGZHZBIZEJABCKZCEGZHZCI
      ZEJABLUKCLUJUNEUJUIBFKZFIUIBCKZCIUNUIBFUIFMNUOUPFCUOABFKZUHBFKZHCAUHBFOUQ
      URCABFCDPURFEGZCFBEQUSCMRSRUPFMUIFCBUAUBUPUMCUHULABCCBEQUCUDUEUFABETUKCET
      UG $.

    $( Variable substitution for "at most one."  (Contributed by Alexander van
       der Vekens, 17-Jun-2017.) $)
    sb8mo $p |- ( E* x ph <-> E* y [ y / x ] ph ) $=
      ( wex weu wi wsb wmo sb8e sb8eu imbi12i df-mo 3bitr4i ) ABEZABFZGABCHZCEZ
      QCFZGABIQCIORPSABCDJABCDKLABMQCMN $.
  $}

  ${
    cbveu.1 $e |- F/ y ph $.
    cbveu.2 $e |- F/ x ps $.
    cbveu.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 25-Nov-1994.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    cbveu $p |- ( E! x ph <-> E! y ps ) $=
      ( weu wsb sb8eu sbie eubii bitri ) ACHACDIZDHBDHACDEJNBDABCDFGKLM $.
  $}

  ${
    $d x y $.
    eu1.1 $e |- F/ y ph $.
    $( An alternate way to express uniqueness used by some authors.  Exercise
       2(b) of [Margaris] p. 110.  (Contributed by NM, 20-Aug-1993.)  (Revised
       by Mario Carneiro, 7-Oct-2016.) $)
    eu1 $p |- ( E! x ph <->
                E. x ( ph /\ A. y ( [ y / x ] ph -> x = y ) ) ) $=
      ( wsb weu weq wb wal wex wi wa nfs1v euf sb8eu equcom albii sb6rf 3bitr4i
      imbi2i anbi12i ancom albiim exbii ) ABCEZCFUECBGZHCIZBJABFAUEBCGZKZCIZLZB
      JUECBABCMNABCDOUKUGBUJALUEUFKZCIZUFUEKCIZLUKUGUJUMAUNUIULCUHUFUEBCPTQABCD
      RUAAUJUBUEUFCUCSUDS $.
  $}

  ${
    $d x y z $.  $d ph z $.
    mo.1 $e |- F/ y ph $.
    $( Equivalent definitions of "there exists at most one."  (Contributed by
       NM, 7-Aug-1994.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
    mo $p |- ( E. y A. x ( ph -> x = y ) <->
               A. x A. y ( ( ph /\ [ y / x ] ph ) -> x = y ) ) $=
      ( vz weq wi wal wex wsb wa nfv nfim nfal equequ2 imbi2d cbv3 sylbir nfn
      wn albidv cbvex nfs1v sbequ2 ax-8 imim12d ancli aaan sylibr equtr2 2alimi
      prth syl6 syl exlimiv nfa2 sp exp3a com3r alimd com12 eximd alnex equcoms
      sbequ1 con3d pm2.21 alimi 19.8a 3syl pm2.61d1 impbii ) ABCFZGZBHZCIZAABCJ
      ZKZVMGZCHZBHZVPABEFZGZBHZEIWAWDVOECWCCBAWBCDWBCLMZNVOELECFZWCVNBWFWBVMAEC
      BOPUAUBWDWAEWDWCVQCEFZGZKZCHBHZWAWDWDWHCHZKWJWDWKWCWHBCWEVQWGBABCUCZWGBLM
      ZVMVQAWBWGABCUDBCEUEUFQUGWCWHBCWEWMUHUIWIVSBCWIVRWBWGKVMAWBVQWGULBCEUJUMU
      KUNUORWAVQCIZVPWAVQVOCVSCBUPVQWAVOVQVTVNBWLVTAVQVMVTAVQVMVSCUQURUSUTVAVBW
      NTVQTZCHZVPVQCVCWPATZBHVOVPWOWQCBVQBWLSACDSCBFAVQAVQGBCABCVEVDVFQWQVNBAVM
      VGVHVOCVIVJRVKVL $.
  $}

  ${
    $d x y $.  $d ph y $.
    $( Existential uniqueness implies existence.  (Contributed by NM,
       15-Sep-1993.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
    euex $p |- ( E! x ph -> E. x ph ) $=
      ( vy weu wsb weq wi wal wa wex nfv eu1 exsimpl sylbi ) ABDAABCEBCFGCHZIBJ
      ABJABCACKLAOBMN $.
  $}

  ${
    $d x y $.
    eumo0.1 $e |- F/ y ph $.
    $( Existential uniqueness implies "at most one."  (Contributed by NM,
       8-Jul-1994.) $)
    eumo0 $p |- ( E! x ph -> E. y A. x ( ph -> x = y ) ) $=
      ( weu weq wb wal wex wi euf bi1 alimi eximi sylbi ) ABEABCFZGZBHZCIAPJZBH
      ZCIABCDKRTCQSBAPLMNO $.
  $}

  ${
    $d x y $.
    eu2.1 $e |- F/ y ph $.
    $( An alternate way of defining existential uniqueness.  Definition 6.10 of
       [TakeutiZaring] p. 26.  (Contributed by NM, 8-Jul-1994.) $)
    eu2 $p |- ( E! x ph <->
    ( E. x ph /\ A. x A. y ( ( ph /\ [ y / x ] ph ) -> x = y ) ) ) $=
      ( weu wex wsb wa weq wi wal euex eumo0 mo sylib 19.29r impexp albii 19.21
      jca bitri anbi2i abai bitr4i exbii eu1 sylibr impbii ) ABEZABFZAABCGZHBCI
      ZJZCKZBKZHZUIUJUOABLUIAULJBKCFUOABCDMABCDNOTUPAUKULJZCKZHZBFZUIUPAUNHZBFU
      TAUNBPVAUSBVAAAURJZHUSUNVBAUNAUQJZCKVBUMVCCAUKULQRAUQCDSUAUBAURUCUDUEOABC
      DUFUGUH $.
  $}

  ${
    $d x y $.
    eu3.1 $e |- F/ y ph $.
    $( An alternate way to express existential uniqueness.  (Contributed by NM,
       8-Jul-1994.) $)
    eu3 $p |- ( E! x ph <->
                ( E. x ph /\ E. y A. x ( ph -> x = y ) ) ) $=
      ( weu wex wsb wa weq wi wal eu2 mo anbi2i bitr4i ) ABEABFZAABCGHBCIZJCKBK
      ZHPAQJBKCFZHABCDLSRPABCDMNO $.
  $}

  ${
    euor.1 $e |- F/ x ph $.
    $( Introduce a disjunct into a uniqueness quantifier.  (Contributed by NM,
       21-Oct-2005.) $)
    euor $p |- ( ( -. ph /\ E! x ps ) -> E! x ( ph \/ ps ) ) $=
      ( wn weu wo nfn biorf eubid biimpa ) AEZBCFABGZCFLBMCACDHABIJK $.
  $}

  ${
    $d x ph $.
    $( Introduce a disjunct into a uniqueness quantifier.  (Contributed by NM,
       23-Mar-1995.) $)
    euorv $p |- ( ( -. ph /\ E! x ps ) -> E! x ( ph \/ ps ) ) $=
      ( nfv euor ) ABCACDE $.
  $}

  ${
    $d x y $.
    mo2.1 $e |- F/ y ph $.
    $( Alternate definition of "at most one."  (Contributed by NM,
       8-Mar-1995.) $)
    mo2 $p |- ( E* x ph <-> E. y A. x ( ph -> x = y ) ) $=
      ( wmo wex weu wi weq wal df-mo alnex pm2.21 alimi 19.8a syl sylbir eumo0
      wn ja eu3 simplbi2com impbii bitri ) ABEABFZABGZHZABCIZHZBJZCFZABKUGUKUEU
      FUKUESASZBJZUKABLUMUJUKULUIBAUHMNUJCOPQABCDRTUFUEUKABCDUAUBUCUD $.
  $}

  ${
    $d w x z $.  $d w y z $.  $d w ph $.
    $( Substitution into "at most one".  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    sbmo $p |- ( [ y / x ] E* z ph <-> E* z [ y / x ] ph ) $=
      ( vw weq wi wal wex wsb wmo nfv sblim sbalv exbii bitri mo2 sbbii 3bitr4i
      sbex ) ADEFZGZDHZEIZBCJZABCJZUAGZDHZEIZADKZBCJUFDKUEUCBCJZEIUIUCEBCTUKUHE
      UBUGBCDAUABCUABLMNOPUJUDBCADEAELQRUFDEUFELQS $.
  $}

  ${
    $d x y $.
    mo3.1 $e |- F/ y ph $.
    $( Alternate definition of "at most one."  Definition of [BellMachover]
       p. 460, except that definition has the side condition that ` y ` not
       occur in ` ph ` in place of our hypothesis.  (Contributed by NM,
       8-Mar-1995.) $)
    mo3 $p |- ( E* x ph <->
               A. x A. y ( ( ph /\ [ y / x ] ph ) -> x = y ) ) $=
      ( wmo weq wi wal wex wsb wa mo2 mo bitri ) ABEABCFZGBHCIAABCJKOGCHBHABCDL
      ABCDMN $.
  $}

  ${
    $d x y $.  $d y ph $.
    mo4f.1 $e |- F/ x ps $.
    mo4f.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( "At most one" expressed using implicit substitution.  (Contributed by
       NM, 10-Apr-2004.) $)
    mo4f $p |- ( E* x ph <-> A. x A. y ( ( ph /\ ps ) -> x = y ) ) $=
      ( wmo wsb wa weq wi wal nfv mo3 sbie anbi2i imbi1i 2albii bitri ) ACGAACD
      HZIZCDJZKZDLCLABIZUBKZDLCLACDADMNUCUECDUAUDUBTBAABCDEFOPQRS $.
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    mo4.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( "At most one" expressed using implicit substitution.  (Contributed by
       NM, 26-Jul-1995.) $)
    mo4 $p |- ( E* x ph <-> A. x A. y ( ( ph /\ ps ) -> x = y ) ) $=
      ( nfv mo4f ) ABCDBCFEG $.
  $}

  ${
    mobid.1 $e |- F/ x ph $.
    mobid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for "at most one" quantifier (deduction rule).
       (Contributed by NM, 8-Mar-1995.) $)
    mobid $p |- ( ph -> ( E* x ps <-> E* x ch ) ) $=
      ( wex weu wi wmo exbid eubid imbi12d df-mo 3bitr4g ) ABDGZBDHZICDGZCDHZIB
      DJCDJAPRQSABCDEFKABCDEFLMBDNCDNO $.
  $}

  ${
    $d x ph $.
    mobidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for "at most one" quantifier (deduction rule).
       (Contributed by Mario Carneiro, 7-Oct-2016.) $)
    mobidv $p |- ( ph -> ( E* x ps <-> E* x ch ) ) $=
      ( nfv mobid ) ABCDADFEG $.
  $}

  ${
    mobii.1 $e |- ( ps <-> ch ) $.
    $( Formula-building rule for "at most one" quantifier (inference rule).
       (Contributed by NM, 9-Mar-1995.)  (Revised by Mario Carneiro,
       17-Oct-2016.) $)
    mobii $p |- ( E* x ps <-> E* x ch ) $=
      ( wmo wb wtru a1i mobidv trud ) ACEBCEFGABCABFGDHIJ $.
  $}

  ${
    cbvmo.1 $e |- F/ y ph $.
    cbvmo.2 $e |- F/ x ps $.
    cbvmo.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 9-Mar-1995.)  (Revised by Andrew Salmon,
       8-Jun-2011.) $)
    cbvmo $p |- ( E* x ph <-> E* y ps ) $=
      ( wex weu wi wmo cbvex cbveu imbi12i df-mo 3bitr4i ) ACHZACIZJBDHZBDIZJAC
      KBDKQSRTABCDEFGLABCDEFGMNACOBDOP $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( Uniqueness in terms of "at most one."  (Contributed by NM,
       23-Mar-1995.) $)
    eu5 $p |- ( E! x ph <-> ( E. x ph /\ E* x ph ) ) $=
      ( vy weu wex weq wi wal wa wmo nfv eu3 mo2 anbi2i bitr4i ) ABDABEZABCFGBH
      CEZIPABJZIABCACKZLRQPABCSMNO $.
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    eu4.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Uniqueness using implicit substitution.  (Contributed by NM,
       26-Jul-1995.) $)
    eu4 $p |- ( E! x ph <-> ( E. x ph /\
             A. x A. y ( ( ph /\ ps ) -> x = y ) ) ) $=
      ( weu wex wmo wa weq wi wal eu5 mo4 anbi2i bitri ) ACFACGZACHZIQABICDJKDL
      CLZIACMRSQABCDENOP $.
  $}

  $( Existential uniqueness implies "at most one."  (Contributed by NM,
     23-Mar-1995.) $)
  eumo $p |- ( E! x ph -> E* x ph ) $=
    ( weu wex wmo eu5 simprbi ) ABCABDABEABFG $.

  ${
    eumoi.1 $e |- E! x ph $.
    $( "At most one" inferred from existential uniqueness.  (Contributed by NM,
       5-Apr-1995.) $)
    eumoi $p |- E* x ph $=
      ( weu wmo eumo ax-mp ) ABDABECABFG $.
  $}

  $( Existence in terms of "at most one" and uniqueness.  (Contributed by NM,
     5-Apr-2004.) $)
  exmoeu $p |- ( E. x ph <-> ( E* x ph -> E! x ph ) ) $=
    ( wex wmo weu wi df-mo biimpi com12 biimpri euex imim12i peirce syl impbii
    ) ABCZABDZABEZFZQPRQPRFZABGZHISTPFPTQRPQTUAJABKLPRMNO $.

  $( Existence implies "at most one" is equivalent to uniqueness.  (Contributed
     by NM, 5-Apr-2004.) $)
  exmoeu2 $p |- ( E. x ph -> ( E* x ph <-> E! x ph ) ) $=
    ( weu wex wmo eu5 baibr ) ABCABDABEABFG $.

  $( Absorption of existence condition by "at most one."  (Contributed by NM,
     4-Nov-2002.) $)
  moabs $p |- ( E* x ph <-> ( E. x ph -> E* x ph ) ) $=
    ( wex weu wi wmo pm5.4 df-mo imbi2i 3bitr4ri ) ABCZKABDZEZEMKABFZENKLGNMKAB
    HZIOJ $.

  $( Something exists or at most one exists.  (Contributed by NM,
     8-Mar-1995.) $)
  exmo $p |- ( E. x ph \/ E* x ph ) $=
    ( wex wmo wn weu wi pm2.21 df-mo sylibr orri ) ABCZABDZLELABFZGMLNHABIJK $.

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    $( "At most one" is preserved through implication (notice wff reversal).
       (Contributed by NM, 22-Apr-1995.) $)
    moim $p |- ( A. x ( ph -> ps ) -> ( E* x ps -> E* x ph ) ) $=
      ( vy wi wal weq wex wmo imim1 al2imi eximdv nfv mo2 3imtr4g ) ABEZCFZBCDG
      ZEZCFZDHAREZCFZDHBCIACIQTUBDPSUACABRJKLBCDBDMNACDADMNO $.
  $}

  ${
    immoi.1 $e |- ( ph -> ps ) $.
    $( "At most one" is preserved through implication (notice wff reversal).
       (Contributed by NM, 15-Feb-2006.) $)
    moimi $p |- ( E* x ps -> E* x ph ) $=
      ( wi wmo moim mpg ) ABEBCFACFECABCGDH $.
  $}

  ${
    $d x y $.  $d x y ph $.  $d y ps $.
    $( Move antecedent outside of "at most one."  (Contributed by NM,
       28-Jul-1995.) $)
    morimv $p |- ( E* x ( ph -> ps ) -> ( ph -> E* x ps ) ) $=
      ( vy wmo weq wal wex ax-1 a1i imim1d alimdv eximdv nfv mo2 3imtr4g com12
      wi ) AABRZCEZBCEZASCDFZRZCGZDHBUBRZCGZDHTUAAUDUFDAUCUECABSUBBSRABAIJKLMSC
      DSDNOBCDBDNOPQ $.
  $}

  $( Uniqueness implies "at most one" through implication.  (Contributed by NM,
     22-Apr-1995.) $)
  euimmo $p |- ( A. x ( ph -> ps ) -> ( E! x ps -> E* x ph ) ) $=
    ( weu wmo wi wal eumo moim syl5 ) BCDBCEABFCGACEBCHABCIJ $.

  $( Add existential uniqueness quantifiers to an implication.  Note the
     reversed implication in the antecedent.  (Contributed by NM,
     19-Oct-2005.)  (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
  euim $p |- ( ( E. x ph /\ A. x ( ph -> ps ) ) -> ( E! x ps -> E! x ph ) ) $=
    ( wex wi wal wa weu wmo ax-1 euimmo anim12ii eu5 syl6ibr ) ACDZABECFZGBCHZO
    ACIZGACHOQOPROQJABCKLACMN $.

  $( "At most one" is still the case when a conjunct is added.  (Contributed by
     NM, 22-Apr-1995.) $)
  moan $p |- ( E* x ph -> E* x ( ps /\ ph ) ) $=
    ( wa simpr moimi ) BADACBAEF $.

  ${
    moani.1 $e |- E* x ph $.
    $( "At most one" is still true when a conjunct is added.  (Contributed by
       NM, 9-Mar-1995.) $)
    moani $p |- E* x ( ps /\ ph ) $=
      ( wmo wa moan ax-mp ) ACEBAFCEDABCGH $.
  $}

  $( "At most one" is still the case when a disjunct is removed.  (Contributed
     by NM, 5-Apr-2004.) $)
  moor $p |- ( E* x ( ph \/ ps ) -> E* x ph ) $=
    ( wo orc moimi ) AABDCABEF $.

  $( "At most one" imports disjunction to conjunction.  (Contributed by NM,
     5-Apr-2004.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
  mooran1 $p |- ( ( E* x ph \/ E* x ps ) -> E* x ( ph /\ ps ) ) $=
    ( wmo wa simpl moimi moan jaoi ) ACDABEZCDBCDJACABFGBACHI $.

  $( "At most one" exports disjunction to conjunction.  (Contributed by NM,
     5-Apr-2004.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
  mooran2 $p |- ( E* x ( ph \/ ps ) -> ( E* x ph /\ E* x ps ) ) $=
    ( wo wmo moor olc moimi jca ) ABDZCEACEBCEABCFBJCBAGHI $.

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    moanim.1 $e |- F/ x ph $.
    $( Introduction of a conjunct into "at most one" quantifier.  (Contributed
       by NM, 3-Dec-2001.) $)
    moanim $p |- ( E* x ( ph /\ ps ) <-> ( ph -> E* x ps ) ) $=
      ( vy wa weq wi wal wex wmo impexp albii 19.21 bitri nfv mo2 imbi2i 19.37v
      exbii bitr4i 3bitr4i ) ABFZCEGZHZCIZEJABUDHZCIZHZEJZUCCKABCKZHZUFUIEUFAUG
      HZCIUIUEUMCABUDLMAUGCDNOTUCCEUCEPQULAUHEJZHUJUKUNABCEBEPQRAUHESUAUB $.

    $( Introduction of a conjunct into uniqueness quantifier.  (Contributed by
       NM, 19-Feb-2005.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
    euan $p |- ( E! x ( ph /\ ps ) <-> ( ph /\ E! x ps ) ) $=
      ( wa weu wex wmo simpl exlimi adantr exsimpr nfe1 simpr a1d ancrd impbid2
      mobid biimpa eu5 jca32 anbi2i 3imtr4i ibar eubid impbii ) ABEZCFZABCFZEZU
      GCGZUGCHZEZABCGZBCHZEZEUHUJUMAUNUOUKAULUGACDABIJZKUKUNULABCLKUKULUOUKUGBC
      UGCMUKUGBABNUKBAUKABUQOPQRSUAUGCTUIUPABCTUBUCAUIUHABUGCDABUDUESUF $.
  $}

  ${
    $d x y ph $.  $d y ps $.
    $( Introduction of a conjunct into "at most one" quantifier.  (Contributed
       by NM, 23-Mar-1995.) $)
    moanimv $p |- ( E* x ( ph /\ ps ) <-> ( ph -> E* x ps ) ) $=
      ( nfv moanim ) ABCACDE $.
  $}

  $( Nested "at most one" and uniqueness quantifiers.  (Contributed by NM,
     25-Jan-2006.) $)
  moaneu $p |- E* x ( ph /\ E! x ph ) $=
    ( weu wa wmo wi eumo nfeu1 moanim mpbir ancom mobii ) AABCZDZBEMADZBEZPMABE
    FABGMABABHIJNOBAMKLJ $.

  $( Nested "at most one" quantifiers.  (Contributed by NM, 25-Jan-2006.) $)
  moanmo $p |- E* x ( ph /\ E* x ph ) $=
    ( wmo wa wi id nfmo1 moanim mpbir ancom mobii ) AABCZDZBCLADZBCZOLLELFLABAB
    GHIMNBALJKI $.

  ${
    $d x ph $.
    $( Introduction of a conjunct into uniqueness quantifier.  (Contributed by
       NM, 23-Mar-1995.) $)
    euanv $p |- ( E! x ( ph /\ ps ) <-> ( ph /\ E! x ps ) ) $=
      ( nfv euan ) ABCACDE $.
  $}

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    $( "At most one" picks a variable value, eliminating an existential
       quantifier.  (Contributed by NM, 27-Jan-1997.) $)
    mopick $p |- ( ( E* x ph /\ E. x ( ph /\ ps ) ) -> ( ph -> ps ) ) $=
      ( vy wa wex wmo wi wsb nfv nfs1v nfan weq sbequ12 anbi12d cbvex wal sylbi
      mo3 sp sps sbequ2 imim2i exp3a com4t imp syl5 exlimiv impcom ) ABEZCFZACG
      ZABHZUKACDIZBCDIZEZDFULUMHZUJUPCDUJDJUNUOCACDKBCDKLCDMZAUNBUOACDNBCDNOPUP
      UQDULAUNEZURHZUPUMULUTDQZCQUTACDADJSVAUTCUTDTUARUNUOUTUMHUTAUNUOBUTAUNUOB
      HZURVBUSBCDUBUCUDUEUFUGUHRUI $.
  $}

  $( Existential uniqueness "picks" a variable value for which another wff is
     true.  If there is only one thing ` x ` such that ` ph ` is true, and
     there is also an ` x ` (actually the same one) such that ` ph ` and ` ps `
     are both true, then ` ph ` implies ` ps ` regardless of ` x ` .  This
     theorem can be useful for eliminating existential quantifiers in a
     hypothesis.  Compare Theorem *14.26 in [WhiteheadRussell] p. 192.
     (Contributed by NM, 10-Jul-1994.) $)
  eupick $p |- ( ( E! x ph /\ E. x ( ph /\ ps ) ) -> ( ph -> ps ) ) $=
    ( weu wmo wa wex wi eumo mopick sylan ) ACDACEABFCGABHACIABCJK $.

  $( Version of ~ eupick with closed formulas.  (Contributed by NM,
     6-Sep-2008.) $)
  eupicka $p |- ( ( E! x ph /\ E. x ( ph /\ ps ) ) -> A. x ( ph -> ps ) ) $=
    ( weu wa wex wi nfeu1 nfe1 nfan eupick alrimi ) ACDZABEZCFZEABGCMOCACHNCIJA
    BCKL $.

  $( Existential uniqueness "pick" showing wff equivalence.  (Contributed by
     NM, 25-Nov-1994.) $)
  eupickb $p |- ( ( E! x ph /\ E! x ps /\ E. x ( ph /\ ps ) ) ->
               ( ph <-> ps ) ) $=
    ( weu wa wex w3a wi eupick 3adant2 3simpc pm3.22 eximi anim2i 3syl impbid )
    ACDZBCDZABEZCFZGZABQTABHRABCIJUARTERBAEZCFZEBAHQRTKTUCRSUBCABLMNBACIOP $.

  $( Theorem *14.26 in [WhiteheadRussell] p. 192.  (Contributed by Andrew
     Salmon, 11-Jul-2011.) $)
  eupickbi $p |- ( E! x ph -> ( E. x ( ph /\ ps ) <-> A. x ( ph -> ps ) ) ) $=
    ( weu wa wex wi wal eupicka ex nfa1 wb ancl simpl impbid1 eubid euex syl6bi
    sps com12 impbid ) ACDZABEZCFZABGZCHZUBUDUFABCIJUFUBUDUFUBUCCDUDUFAUCCUECKU
    EAUCLCUEAUCABMABNOSPUCCQRTUA $.

  $( "At most one" can show the existence of a common value.  In this case we
     can infer existence of conjunction from a conjunction of existence, and it
     is one way to achieve the converse of ~ 19.40 .  (Contributed by NM,
     5-Apr-2004.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
  mopick2 $p |- ( ( E* x ph /\ E. x ( ph /\ ps ) /\ E. x ( ph /\ ch ) ) ->
                E. x ( ph /\ ps /\ ch ) ) $=
    ( wmo wa wex w3a nfmo1 nfe1 mopick ancld anim1d df-3an syl6ibr eximd 3impia
    nfan ) ADEZABFZDGZACFZDGABCHZDGSUAFZUBUCDSUADADITDJRUDUBTCFUCUDATCUDABABDKL
    MABCNOPQ $.

  $( Introduce or eliminate a disjunct in a uniqueness quantifier.
     (Contributed by NM, 21-Oct-2005.)  (Proof shortened by Andrew Salmon,
     9-Jul-2011.) $)
  euor2 $p |- ( -. E. x ph -> ( E! x ( ph \/ ps ) <-> E! x ps ) ) $=
    ( wex wn wo nfe1 nfn wb 19.8a con3i orel1 olc impbid1 syl eubid ) ACDZEZABF
    ZBCQCACGHRAEZSBIAQACJKTSBABLBAMNOP $.

  ${
    moexex.1 $e |- F/ y ph $.
    $( "At most one" double quantification.  (Contributed by NM,
       3-Dec-2001.) $)
    moexex $p |- ( ( E* x ph /\ A. x E* y ps ) -> E* y E. x ( ph /\ ps ) ) $=
      ( wmo wal wa wex wi nfmo1 nfa1 nfe1 nfmo nfim mopick ex exlimi wn a1d ori
      com3r alrimd moim spsd syl6 nfex exsimpl con3i exmo syl pm2.61i imp ) ACF
      ZBDFZCGZABHZCIZDFZACIZUNUPUSJZJZAVBCUNVACACKUPUSCUOCLURCDUQCMNOOAUNURBJZD
      GZVAAUNVCDEADCENUNURABUNURABJABCPQUBUCVDUOUSCURBDUDUEUFRUTSZVAUNVEUSUPVEU
      RDIZSUSVFUTURUTDADCEUGABCUHRUIVFUSURDUJUAUKTTULUM $.
  $}

  ${
    $d y ph $.
    $( "At most one" double quantification.  (Contributed by NM,
       26-Jan-1997.) $)
    moexexv $p |- ( ( E* x ph /\ A. x E* y ps ) -> E* y E. x ( ph /\ ps ) ) $=
      ( nfv moexex ) ABCDADEF $.
  $}

  $( Double quantification with "at most one."  (Contributed by NM,
     3-Dec-2001.) $)
  2moex $p |- ( E* x E. y ph -> A. y E* x ph ) $=
    ( wex wmo nfe1 nfmo 19.8a moimi alrimi ) ACDZBEABECKCBACFGAKBACHIJ $.

  $( Double quantification with existential uniqueness.  (Contributed by NM,
     3-Dec-2001.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
  2euex $p |- ( E! x E. y ph -> E. y E! x ph ) $=
    ( wex weu wmo wa eu5 excom nfe1 19.8a moimi df-mo sylib eximd syl5bi impcom
    nfmo wi sylbi ) ACDZBEUABDZUABFZGABEZCDZUABHUCUBUEUBABDZCDUCUEABCIUCUFUDCUA
    CBACJRUCABFUFUDSAUABACKLABMNOPQT $.

  $( Double quantification with existential uniqueness and "at most one."
     (Contributed by NM, 3-Dec-2001.) $)
  2eumo $p |- ( E! x E* y ph -> E* x E! y ph ) $=
    ( weu wmo wi euimmo eumo mpg ) ACDZACEZFKBDJBEFBJKBGACHI $.

  $( Double existential uniqueness.  (Contributed by NM, 3-Dec-2001.) $)
  2eu2ex $p |- ( E! x E! y ph -> E. x E. y ph ) $=
    ( weu wex euex eximi syl ) ACDZBDIBEACEZBEIBFIJBACFGH $.

  $( A condition allowing swap of "at most one" and existential quantifiers.
     (Contributed by NM, 10-Apr-2004.) $)
  2moswap $p |- ( A. x E* y ph -> ( E* x E. y ph -> E* y E. x ph ) ) $=
    ( wmo wal wex wa nfe1 moexex expcom 19.8a pm4.71ri exbii mobii syl6ibr ) AC
    DBEZACFZBDZQAGZBFZCDZABFZCDRPUAQABCACHIJUBTCASBAQACKLMNO $.

  $( A condition allowing swap of uniqueness and existential quantifiers.
     (Contributed by NM, 10-Apr-2004.) $)
  2euswap $p |- ( A. x E* y ph -> ( E! x E. y ph -> E! y E. x ph ) ) $=
    ( wmo wal wex wa weu wi excomim a1i 2moswap anim12d eu5 3imtr4g ) ACDBEZACF
    ZBFZQBDZGABFZCFZTCDZGQBHTCHPRUASUBRUAIPABCJKABCLMQBNTCNO $.

  $( Double existential uniqueness implies double uniqueness quantification.
     (Contributed by NM, 3-Dec-2001.)  (Proof shortened by Mario Carneiro,
     22-Dec-2016.) $)
  2exeu $p |- ( ( E! x E. y ph /\ E! y E. x ph ) -> E! x E! y ph ) $=
    ( wex weu wa wmo eumo euex moimi syl 2euex anim12ci eu5 sylibr ) ACDZBEZABD
    CEZFACEZBDZSBGZFSBEQUARTQPBGUAPBHSPBACIJKACBLMSBNO $.

  ${
    $d x y z w v u $.  $d z w v u ph $.
    $( Two equivalent expressions for double "at most one."  (Contributed by
       NM, 2-Feb-2005.)  (Revised by Mario Carneiro, 17-Oct-2016.) $)
    2mo $p |- ( E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) <->
              A. x A. y A. z A. w ( ( ph /\ [ z / x ] [ w / y ] ph ) ->
                   ( x = z /\ y = w ) ) ) $=
      ( vv vu weq wa wi wal wex wsb nfv albii bitri 2alimi syl sylbir wn imbi2d
      equequ2 2albidv cbvex2v nfs1v nfim nfsb sbequ12 sylan9bbr equequ1 imbi12d
      bi2anan9 cbval2 biimpi ancli alcom aaan nfal sylibr prth equtr2 an4s syl6
      anim12i exlimivv alrot4 pm3.21 imim1d alimd com12 alimi exim sylbi notbid
      alnex nfn pm2.21 19.8a 19.23bi pm2.61d1 impbii ) ABDHZCEHZIZJZCKZBKZELZDL
      ZAACEMZBDMZIZWDJZEKDKZCKBKZWIABFHZCGHZIZJZCKZBKZGLFLWOXAWGFGDEFDHZGEHZIZW
      SWEBCXDWRWDAXBWPWBXCWQWCFDBUBGECUBULUAUCUDXAWOFGXAWSWKDFHZEGHZIZJZIZEKZDK
      ZCKZBKZWOXAXAXHEKZDKZIZXMXAXOXAXOWSXHBCDEWSDNWSENZWKXGBWJBDUEZXGBNUFZWKXG
      CWJBDCACEUEUGZXGCNUFZWDAWKWRXGWCAWJWBWKACEUHWJBDUHUIZWBWPXEWCWQXFBDFUJCEG
      UJULUKUMUNUOXMWTXNIZDKZBKXPXLYDBXLXJCKZDKYDXJCDUPYEYCDWSXHCEXQYAUQOPOWTXN
      BDWTDNXHBEXSURUQPUSXKWNBCXIWMDEXIWLWRXGIWDAWRWKXGUTWPXEWQXFWDWPXEIWBWQXFI
      WCBDFVACEGVAVDVBVCQQRVESWOWKELZDLZWIWOYFWHJZDKZYGWIJWOWMCKZBKZEKZDKYIWMBC
      DEVFYLYHDYLWKWGJZEKYHYKYMEWKYKWGWKYJWFBXRWKWMWECXTWKAWLWDWKAVGVHVIVIVJVKW
      KWGEVLRVKVMYFWHDVLRYGTZWKTZEKZDKZWIYQYFTZDKYNYPYRDWKEVOOYFDVOPYQWGWIYQATZ
      CKBKWGYSYOBCDEYSDNYSENWKBXRVPWKCXTVPWDAWKYBVNUMYSWEBCAWDVQQSWGWIEWHDVRVSR
      SVTWA $.
  $}

  ${
    $d z w ph $.  $d x y ps $.  $d x y z w $.
    2mos.1 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Double "exists at most one", using implicit substitution.  (Contributed
       by NM, 10-Feb-2005.) $)
    2mos $p |- ( E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) <->
             A. x A. y A. z A. w ( ( ph /\ ps ) -> ( x = z /\ y = w ) ) ) $=
      ( weq wa wi wal wex wsb 2mo nfv sbiedv sbie anbi2i imbi1i 2albii bitri )
      ACEHZDFHIZJDKCKFLELAADFMZCEMZIZUCJZFKEKZDKCKABIZUCJZFKEKZDKCKACDEFNUHUKCD
      UGUJEFUFUIUCUEBAUDBCEBCOUBABDFGPQRSTTUA $.
  $}

  $( Double existential uniqueness.  This theorem shows a condition under which
     a "naive" definition matches the correct one.  (Contributed by NM,
     3-Dec-2001.) $)
  2eu1 $p |- ( A. x E* y ph ->
        ( E! x E! y ph <-> ( E! x E. y ph /\ E! y E. x ph ) ) ) $=
    ( wmo wal weu wex wa wi eu5 exbii mobii anbi12i bitri simprbi anim2i ancoms
    sp sylib com12 moimi nfa1 moanim ancrd 2moswap imdistani syl6 syl excom jca
    2eu2ex jctild an4 syl6ibr 2exeu impbid1 ) ACDZBEZACFZBFZACGZBFZABGZCFZHZUTU
    RVEUTURVABGZVCCGZHZVABDZVCCDZHZHZVEUTURVKVHUTVAUQHZBDZURVKIUTVMBGZVNUTUSBGZ
    USBDZHVOVNHUSBJVPVOVQVNUSVMBACJZKUSVMBVRLMNOVNURVIURHVKVNURVIVNURVAHZBDURVI
    IVSVMBVAURVMURUQVAUQBRPQUAURVABUQBUBUCSUDVIURVJURVIVJABCUETUFUGUHUTVFVGABCU
    KZUTVFVGVTABCUISUJULVEVFVIHZVGVJHZHVLVBWAVDWBVABJVCCJMVFVIVGVJUMNUNTABCUOUP
    $.

  $( Double existential uniqueness.  (Contributed by NM, 3-Dec-2001.) $)
  2eu2 $p |- ( E! y E. x ph -> ( E! x E! y ph <-> E! x E. y ph ) ) $=
    ( wex weu wmo wal wi eumo 2moex 2eu1 simpl syl6bi 3syl 2exeu expcom impbid
    wa ) ABDZCEZACEBEZACDBEZTSCFACFBGZUAUBHSCIACBJUCUAUBTRUBABCKUBTLMNUBTUAABCO
    PQ $.


  $( Double existential uniqueness.  (Contributed by NM, 3-Dec-2001.) $)
  2eu3 $p |- ( A. x A. y ( E* x ph \/ E* y ph ) ->
 ( ( E! x E! y ph /\ E! y E! x ph ) <-> ( E! x E. y ph /\ E! y E. x ph ) ) ) $=
    ( wmo wo wal weu wa wex wb nfmo1 19.31 albii nfal 19.32 bitri wi 2eu1 2exeu
    biimpd ancom syl6ib adantld adantrd jaoi ancoms jca impbid1 sylbi ) ABDZACD
    ZECFZBFZUJCFZUKBFZEZACGBGZABGCGZHZACIBGZABICGZHZJUMUNUKEZBFUPULVCBUJUKCACKL
    MUNUKBUJBCABKNOPUPUSVBUNUSVBQUOUNURVBUQUNURVAUTHZVBUNURVDACBRTVAUTUAUBUCUOU
    QVBURUOUQVBABCRTUDUEVBUQURABCSVAUTURACBSUFUGUHUI $.

  ${
    $d x y z w $.  $d z w ph $.
    $( This theorem provides us with a definition of double existential
       uniqueness ("exactly one ` x ` and exactly one ` y ` ").  Naively one
       might think (incorrectly) that it could be defined by
       ` E! x E! y ph ` .  See ~ 2eu1 for a condition under which the naive
       definition holds and ~ 2exeu for a one-way implication.  See ~ 2eu5 and
       ~ 2eu8 for alternate definitions.  (Contributed by NM, 3-Dec-2001.) $)
    2eu4 $p |- ( ( E! x E. y ph /\ E! y E. x ph ) <->
      ( E. x E. y ph /\ E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) ) ) $=
      ( wex weu wa weq wal nfv eu3 anbi12i anbi2i bitri 19.26 nfa1 19.3 albii
      wi an4 excom anidm jcab bitr4i bitr2i 19.23v 2albii nfe1 nfim aaan 3bitri
      alcom 2exbii eeanv ) ACFZBGZABFZCGZHUPBFZUPBDIZTZBJZDFZHZURCFZURCEIZTZCJZ
      EFZHZHUTVFHZVDVJHZHUTAVAVGHTZCJZBJZEFDFZHUQVEUSVKUPBDUPDKLURCEUREKLMUTVDV
      FVJUAVLUTVMVQVLUTUTHUTVFUTUTACBUBNUTUCOVQVCVIHZEFDFVMVPVRDEVPAVATZCJZAVGT
      ZBJZHZCJZBJZVBVHHZCJBJVRVPVTWACJZBJZHZBJZWEWJVTBJZWHBJZHZVPVTWHBPWMWKWHHZ
      VPWLWHWKWHBWGBQRNVPVTWGHZBJWNVOWOBVOVSWAHZCJWOVNWPCAVAVGUDSVSWACPOSVTWGBP
      OUEUFWDWIBWDVTCJZWBCJZHWIVTWBCPWQVTWRWHVTCVSCQRWACBUMMOSUEWCWFBCVTVBWBVHA
      VACUGAVGBUGMUHVBVHBCUPVACACUIVACKUJURVGBABUIVGBKUJUKULUNVCVIDEUOUFMUL $.

    $( An alternate definition of double existential uniqueness (see ~ 2eu4 ).
       A mistake sometimes made in the literature is to use ` E! x E! y ` to
       mean "exactly one ` x ` and exactly one ` y ` ."  (For example, see
       Proposition 7.53 of [TakeutiZaring] p. 53.)  It turns out that this is
       actually a weaker assertion, as can be seen by expanding out the formal
       definitions.  This theorem shows that the erroneous definition can be
       repaired by conjoining ` A. x E* y ph ` as an additional condition.  The
       correct definition apparently has never been published.  ( ` E* ` means
       "exists at most one.") (Contributed by NM, 26-Oct-2003.) $)
    2eu5 $p |- ( ( E! x E! y ph /\ A. x E* y ph ) <->
      ( E. x E. y ph /\ E. z E. w A. x A. y ( ph -> ( x = z /\ y = w ) ) ) ) $=
      ( weu wmo wal wa wex weq 2eu1 pm5.32ri eumo adantl 2moex syl pm4.71i 2eu4
      wi 3bitr2i ) ACFBFZACGBHZIACJZBFZABJZCFZIZUCIUHUDBJABDKCEKITCHBHEJDJIUCUB
      UHABCLMUHUCUHUFCGZUCUGUIUEUFCNOACBPQRABCDESUA $.
  $}

  ${
    $d x y z w v u $.  $d z w v u ph $.
    $( Two equivalent expressions for double existential uniqueness.
       (Contributed by NM, 2-Feb-2005.)  (Revised by Mario Carneiro,
       17-Oct-2016.) $)
    2eu6 $p |- ( ( E! x E. y ph /\ E! y E. x ph ) <->
               E. z E. w A. x A. y ( ph <-> ( x = z /\ y = w ) ) ) $=
      ( vu vv wex wa weq wal wsb nfv nfsb sbequ12 equequ2 bi2anan9 nfim bitri
      wi weu 2eu4 nfs1v sylan9bbr cbvex2 imbi2d 2albidv cbvex2v equequ1 imbi12d
      cbval2 2exbii 2mo 19.29r2 syl2anb 2albiim ancom sbco2 sbbii sbcom2 bitr3i
      nfan syl6bb anbi2d equcom anbi12i imbi2i impexp 2albii anbi2i abai bitr4i
      wb 19.21-2 2sb6 anbi1i sylibr bi2 2alimi 2eximi 2exsb bi1 jca impbii ) AC
      HZBUAABHCUAIWEBHZABDJZCEJZIZTZCKBKZEHDHZIZAWIVMZCKBKZEHDHZABCDEUBWMWPWMAC
      ELZBDLZWRWREFLZDGLZIZDGJZEFJZIZTZFKGKZIZEHDHZWPWFWREHDHXFEKDKZXHWLAWRBCDE
      ADMAEMZWQBDUCZWQBDCACEUCNZWHAWQWGWRACEOWQBDOUDZUEWLABGJZCFJZIZTZCKBKZFHGH
      ZXIWKXRDEGFXDWJXQBCXDWIXPAXBWGXNXCWHXODGBPEFCPQUFUGUHXSWRXDTZEKDKZFHGHXIX
      RYAGFXQXTBCDEXQDMXQEMWRXDBXKXDBMZRWRXDCXLXDCMZRWIAWRXPXDXMWGXNXBWHXOXCBDG
      UICEFUIQUJUKULWRDEGFUMSSWRXFDEUNUOWPWIATZCKBKZWKIZEHDHXHWOYFDEWOWKYEIYFAW
      IBCUPWKYEUQSULXGYFDEXGWRWKIZYFXGWRWRWKTZIYGXFYHWRXFWRWJTZCKBKZYHXFWRAIZDB
      JZECJZIZTZCKBKYJYOXEBCGFYOGMYOFMXAXDBWRWTBXKWSDGBWREFBXKNNVBYBRXAXDCWRWTC
      XLWSDGCWREFCXLNNVBYCRXPYKXAYNXDXPAWTWRXPAACFLZBGLZWTXOAYPXNYQACFOYPBGOUDY
      QWQEFLZBGLZWTYRYPBGACFEXJURUSYSYRBDLZDGLWTYRBGDYRDMURYTWSDGWQEFBDUTUSVAVA
      VCVDXNYLXBXOYMXCBGDPCFEPQUJUKYOYIBCYOYKWITYIYNWIYKYLWGYMWHDBVEECVEVFVGWRA
      WIVHSVIVAWRWJBCXKXLVNSVJWRWKVKVLWRYEWKABCDEVOVPSULVLVQWPWFWLWPYEEHDHWFWOY
      EDEWNYDBCAWIVRVSVTABCDEWAVQWOWKDEWNWJBCAWIWBVSVTWCWDS $.
  $}

  $( Two equivalent expressions for double existential uniqueness.
     (Contributed by NM, 19-Feb-2005.) $)
  2eu7 $p |- ( ( E! x E. y ph /\ E! y E. x ph ) <->
             E! x E! y ( E. x ph /\ E. y ph ) ) $=
    ( wex weu wa nfe1 nfeu euan ancom eubii 3bitri 3bitr4ri ) ABDZCEZACDZFZBEOP
    BEZFNPFZCEZBEROFOPBNBCABGHITQBTPNFZCEPOFQSUACNPJKPNCACGIPOJLKROJM $.

  $( Two equivalent expressions for double existential uniqueness.  Curiously,
     we can put ` E! ` on either of the internal conjuncts but not both.  We
     can also commute ` E! x E! y ` using ~ 2eu7 .  (Contributed by NM,
     20-Feb-2005.) $)
  2eu8 $p |- ( E! x E! y ( E. x ph /\ E. y ph ) <->
                E! x E! y ( E! x ph /\ E. y ph ) ) $=
    ( wex wa 2eu2 pm5.32i nfeu1 nfeu euan ancom eubii nfe1 3bitri 3bitr4ri 2eu7
    weu 3bitr3ri ) ACDZBQZABQZCQZEZTABDZCQZEUASEZCQZBQZUDSECQBQTUBUEACBFGUBSEZB
    QUBTEUHUCUBSBUABCABHIJUGUIBUGSUAEZCQSUBEUIUFUJCUASKLSUACACMJSUBKNLTUBKOABCP
    R $.

  ${
    $d x y z $.
    $( Equality has existential uniqueness.  Special case of ~ eueq1 proved
       using only predicate calculus.  (Contributed by Stefan Allan,
       4-Dec-2008.) $)
    euequ1 $p |- E! x x = y $=
      ( vz weq weu wex wa wi wal a9ev equtr2 gen2 equequ1 eu4 mpbir2an ) ABDZAE
      PAFPCBDZGACDHZCIAIABJRACACBKLPQACACBMNO $.
  $}

  ${
    $d x y $.
    $( Two ways to express "only one thing exists."  The left-hand side
       requires only one variable to express this.  Both sides are false in set
       theory; see theorem ~ dtru .  (Contributed by NM, 5-Apr-2004.) $)
    exists1 $p |- ( E! x x = x <-> A. x x = y ) $=
      ( weq weu wb wal wex df-eu equid tbt bicom bitri albii exbii nfae 3bitr2i
      19.9 ) AACZADRABCZEZAFZBGSAFZBGUBRABHUBUABSTASSRETRSAIJSRKLMNUBBABBOQP $.

    $( A condition implying that at least two things exist.  (Contributed by
       NM, 10-Apr-2004.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
    exists2 $p |- ( ( E. x ph /\ E. x -. ph ) -> -. E! x x = x ) $=
      ( vy wex wn weq weu wal nfeu1 nfa1 exists1 ax16 sylbi exlimd com12 syl6ib
      wi alex con2d imp ) ABDZAEBDZBBFZBGZEUAUDUBUAUDABHZUBEUDUAUEUDAUEBUCBIABJ
      UDBCFBHAUEQBCKABCLMNOABRPST $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             Other axiomatizations related to classical predicate calculus
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Predicate calculus with all distinct variables
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Distinct variable version of ~ ax-7 .  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    ax-7d $a |- ( A. x A. y ph -> A. y A. x ph ) $.

    $( Distinct variable version of ~ ax-8 .  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    ax-8d $a |- ( x = y -> ( x = z -> y = z ) ) $.

    $( Distinct variable version of ~ ax-9 , equal variables case.
       (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    ax-9d1 $a |- -. A. x -. x = x $.

    $( Distinct variable version of ~ ax-9 , distinct variables case.
       (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    ax-9d2 $a |- -. A. x -. x = y $.

    $( Distinct variable version of ~ ax10 .  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    ax-10d $a |- ( A. x x = y -> A. y y = x ) $.

    $( Distinct variable version of ~ ax-11 .  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    ax-11d $a |- ( x = y -> ( A. y ph -> A. x ( x = y -> ph ) ) ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Aristotelian logic: Assertic syllogisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Model the Aristotelian assertic syllogisms using modern notation.
  This section shows that the Aristotelian assertic syllogisms can be proven
  with our axioms of logic, and also provides generally useful theorems.

  In antiquity Aristotelian logic and Stoic logic
  (see ~ mpto1 ) were the leading logical systems.
  Aristotelian logic became the leading system in medieval Europe;
  this section models this system (including later refinements to it).
  Aristotle defined syllogisms very generally
  ("a discourse in which certain (specific) things having been supposed,
  something different from the things supposed results of necessity
  because these things are so")
  Aristotle, _Prior Analytics_ 24b18-20.
  However, in _Prior Analytics_ he limits himself to
  categorical syllogisms that consist of three categorical propositions
  with specific structures.  The syllogisms are the valid subset of
  the possible combinations of these structures.
  The medieval schools used vowels to identify the types of terms
  (a=all, e=none, i=some, and o=some are not), and named the different
  syllogisms with Latin words that had the vowels in the intended order.

  "There is a surprising amount of scholarly debate
  about how best to formalize Aristotle's syllogisms..." according to
  _Aristotle's Modal Proofs: Prior Analytics A8-22 in Predicate Logic_,
  Adriane Rini, Springer, 2011, ISBN 978-94-007-0049-9, page 28.
  For example, Lukasiewicz believes it is important to note that
  "Aristotle does not introduce singular terms or premisses into his system".
  Lukasiewicz also believes that Aristotelian syllogisms are
  predicates (having a true/false value), not inference rules:
  "The characteristic sign of an inference is the word 'therefore'...
  no syllogism is formulated by Aristotle primarily as an inference,
  but they are all implications."
  Jan Lukasiewicz, _Aristotle's Syllogistic from the Standpoint of
  Modern Formal Logic_, Second edition, Oxford, 1957, page 1-2.
  Lukasiewicz devised a specialized prefix notation for representing
  Aristotelian syllogisms instead of using standard predicate logic notation.

  We instead translate each Aristotelian syllogism into an inference rule,
  and each rule is defined using standard predicate logic notation and
  predicates.  The predicates are represented by wff variables
  that may depend on the quantified variable ` x ` .
  Our translation is essentially identical to the one
  use in Rini page 18, Table 2 "Non-Modal Syllogisms in
  Lower Predicate Calculus (LPC)", which uses
  standard predicate logic with predicates.  Rini states,
  "the crucial point is that we capture the meaning Aristotle intends,
  and the method by which we represent that meaning is less important."
  There are two differences: we make the existence criteria explicit, and
  we use ` ph ` , ` ps ` , and ` ch ` in the order they appear
  (a common Metamath convention).
  Patzig also uses standard predicate logic notation and predicates
  (though he interprets them as conditional propositions, not as
  inference rules); see
  Gunther Patzig, _Aristotle's Theory of the Syllogism_ second edition, 1963,
  English translation by Jonathan Barnes, 1968, page 38.
  Terms such as "all" and "some" are translated into predicate logic
  using the aproach devised by Frege and Russell.
  "Frege (and Russell) devised an ingenious procedure for regimenting
  binary quantifiers like "every" and "some" in terms of unary quantifiers
  like "everything" and "something": they formalized sentences of the form
  "Some A is B" and "Every A is B" as
  exists x (Ax and Bx) and all x (Ax implies Bx), respectively."
  "Quantifiers and Quantification", _Stanford Encyclopedia of Philosophy_,
  ~ http://plato.stanford.edu/entries/quantification/ .
  See _Principia Mathematica_ page 22 and *10 for more information
  (especially *10.3 and *10.26).

  Expressions of the form "no ` ph ` is ` ps ` " are consistently translated as
  ` A. x ( ph -> -. ps ) ` .  These can also be expressed as
  ` -. E. x ( ph /\ ps ) ` , per ~ alinexa .
  We translate "all ` ph ` is ` ps ` " to ` A. x ( ph -> ps ) ` ,
  "some ` ph ` is ` ps ` " to ` E. x ( ph /\ ps ) ` , and
  "some ` ph ` is not ` ps ` " to ` E. x ( ph /\ -. ps ) ` .
  It is traditional to use the singular verb "is", not the plural
  verb "are", in the generic expressions.
  By convention the major premise is listed first.

  In traditional Aristotelian syllogisms the predicates
  have a restricted form ("x is a ..."); those predicates
  could be modeled in modern notation by constructs such as
  ` x = A ` , ` x e. A ` , or ` x C_ A ` .
  Here we use wff variables instead of specialized restricted forms.
  This generalization makes the syllogisms more useful
  in more circumstances.  In addition, these expressions make
  it clearer that the syllogisms of Aristolean logic are the
  forerunners of predicate calculus.  If we used restricted forms
  like ` x e. A ` instead, we would not only unnecessarily limit
  their use, but we would also need to use set and class axioms,
  making their relationship to predicate calculus less clear.

  There are some widespread misconceptions about the existential
  assumptions made by Aristotle (aka "existential import").
  Aristotle was not trying to develop something exactly corresponding
  to modern logic.  Aristotle devised "a companion-logic for science.
  He relegates fictions like fairy godmothers and mermaids and unicorns to
  the realms of poetry and literature. In his mind, they exist outside the
  ambit of science. This is why he leaves no room for such non-existent
  entities in his logic.  This is a thoughtful choice, not an inadvertent
  omission. Technically, Aristotelian science is a search for definitions,
  where a definition is "a phrase signifying a thing's essence."
  (Topics, I.5.102a37, Pickard-Cambridge.)...
  Because non-existent entities cannot be anything, they do not, in
  Aristotle's mind, possess an essence...  This is why he leaves
  no place for fictional entities like goat-stags (or unicorns)."
  Source: Louis F. Groarke, "Aristotle: Logic",
  section 7. (Existential Assumptions),
  _Internet Encyclopedia of Philosophy_ (A Peer-Reviewed Academic Resource),
  ~ http://www.iep.utm.edu/aris-log/ .
  Thus, some syllogisms have "extra" existence
  hypotheses that do not directly appear in Aristotle's original materials
  (since they were always assumed); they are added where they are needed.
  This affects ~ barbari , ~ celaront , ~ cesaro , ~ camestros , ~ felapton ,
  ~ darapti , ~ calemos , ~ fesapo , and ~ bamalip .

  These are only the _assertic_ syllogisms.
  Aristotle also defined modal syllogisms that deal with modal
  qualifiers such as "necessarily" and "possibly".
  Historically Aristotelian modal syllogisms were not as widely used.
  For more about modal syllogisms in a modern context, see Rini as well as
  _Aristotle's Modal Syllogistic_ by Marko Malink, Harvard
  University Press, November 2013.  We do not treat them further here.

  Aristotelean logic is essentially the forerunner of predicate calculus
  (as well as set theory since it discusses membership in groups),
  while Stoic logic is essentially the forerunner of propositional calculus.
$)

  $( Figure 1.  Aristotelian syllogisms are grouped by "figures",
     which doesn't matter for our purposes but is a reasonable way
     to order them. $)

  ${
    $( Major premise for the Aristotelian syllogism "Barbara", e.g.,
       "All men are mortal". By convention, the major premise is first. $)
    barbara.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for Barbara, e.g., "Socrates is a man". $)
    barbara.min $e |- A. x ( ch -> ph ) $.
    $( "Barbara", one of the fundamental syllogisms of Aristotelian logic.  All
       ` ph ` is ` ps ` , and all ` ch ` is ` ph ` , therefore all ` ch ` is
       ` ps ` .  (In Aristotelian notation, AAA-1:  MaP and SaM therefore SaP.)
       For example, given "All men are mortal" and "Socrates is a man", we can
       prove "Socrates is mortal".  If H is the set of men, M is the set of
       mortal beings, and S is Socrates, these word phrases can be represented
       as ` A. x ( x e. H -> x e. M ) ` (all men are mortal) and
       ` A. x ( x = S -> x e. H ) ` (Socrates is a man) therefore
       ` A. x ( x = S -> x e. M ) ` (Socrates is mortal).  Russell and
       Whitehead note that the "syllogism in Barbara is derived..." from
       ~ syl .  (quote after Theorem *2.06 of [WhiteheadRussell] p. 101).  Most
       of the proof is in ~ alsyl .  There are a legion of sources for Barbara,
       including ~ http://www.friesian.com/aristotl.htm ,
       ~ http://plato.stanford.edu/entries/aristotle-logic/ , and
       ~ https://en.wikipedia.org/wiki/Syllogism .  (Contributed by David A.
       Wheeler, 24-Aug-2016.) $)
    barbara $p |- A. x ( ch -> ps ) $=
      ( wi wal alsyl mp2an ) CAGDHABGDHCBGDHFECABDIJ $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Celarent", e.g.,
       "No reptiles have fur". $)
    celarent.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for Celarent, e.g., "All snakes are reptiles". $)
    celarent.min $e |- A. x ( ch -> ph ) $.
    $( "Celarent", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , and all ` ch ` is ` ph ` , therefore no ` ch ` is ` ps ` .  (In
       Aristotelian notation, EAE-1:  MeP and SaM therefore SeP.) For example,
       given the "No reptiles have fur" and "All snakes are reptiles",
       therefore "No snakes have fur".  Example from
       ~ https://en.wikipedia.org/wiki/Syllogism .  (Contributed by David A.
       Wheeler, 24-Aug-2016.)  (Revised by David A. Wheeler, 2-Sep-2016.) $)
    celarent $p |- A. x ( ch -> -. ps ) $=
      ( wn barbara ) ABGCDEFH $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Darii", e.g.,
       "All rabbits have fur". $)
    darii.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for Darii, e.g., "Some pets are rabbits." $)
    darii.min $e |- E. x ( ch /\ ph ) $.
    $( "Darii", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , and some ` ch ` is ` ph ` , therefore some ` ch ` is ` ps ` .
       (In Aristotelian notation, AII-1:  MaP and SiM therefore SiP.) For
       example, given "All rabbits have fur" and "Some pets are rabbits",
       therefore "Some pets have fur".  Example from
       ~ https://en.wikipedia.org/wiki/Syllogism .  (Contributed by David A.
       Wheeler, 24-Aug-2016.) $)
    darii $p |- E. x ( ch /\ ps ) $=
      ( wa wi spi anim2i eximii ) CAGCBGDFABCABHDEIJK $.
  $}


  ${
    $( Major premise for the Aristotelian syllogism "Ferio" ("Ferioque"),
       e.g., "No homework is fun". $)
    ferio.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for Ferio, e.g., "Some reading is homework." $)
    ferio.min $e |- E. x ( ch /\ ph ) $.
    $( "Ferio" ("Ferioque"), one of the syllogisms of Aristotelian logic.  No
       ` ph ` is ` ps ` , and some ` ch ` is ` ph ` , therefore some ` ch ` is
       not ` ps ` .  (In Aristotelian notation, EIO-1:  MeP and SiM therefore
       SoP.) For example, given "No homework is fun" and "Some reading is
       homework", therefore "Some reading is not fun".  This is essentially a
       logical axiom in Aristotelian logic.  Example from
       ~ https://en.wikipedia.org/wiki/Syllogism .  (Contributed by David A.
       Wheeler, 24-Aug-2016.)  (Revised by David A. Wheeler, 2-Sep-2016.) $)
    ferio $p |- E. x ( ch /\ -. ps ) $=
      ( wn darii ) ABGCDEFH $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Barbari", e.g.,
       e.g., "All men are mortal". $)
    barbari.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for Barbari, e.g., "All Greeks are men." $)
    barbari.min $e |- A. x ( ch -> ph ) $.
    $( Existence premise for Barbari, e.g., "Greeks exist." $)
    barbari.e $e |- E. x ch $.
    $( "Barbari", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , all ` ch ` is ` ph ` , and some ` ch ` exist, therefore some
       ` ch ` is ` ps ` .  (In Aristotelian notation, AAI-1:  MaP and SaM
       therefore SiP.) For example, given "All men are mortal", "All Greeks are
       men", and "Greeks exist", therefore "Some Greeks are mortal".  Note the
       existence hypothesis (to prove the "some" in the conclusion).  Example
       from ~ https://en.wikipedia.org/wiki/Syllogism .  (Contributed by David
       A. Wheeler, 27-Aug-2016.)  (Revised by David A. Wheeler,
       30-Aug-2016.) $)
    barbari $p |- E. x ( ch /\ ps ) $=
      ( wa wi barbara spi ancli eximii ) CCBHDGCBCBIDABCDEFJKLM $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Celaront", e.g.,
       e.g., "No reptiles have fur". $)
    celaront.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for Celaront, e.g., "All Snakes are reptiles." $)
    celaront.min $e |- A. x ( ch -> ph ) $.
    $( Existence premise for Celaront, e.g., "Snakes exist." $)
    celaront.e $e |- E. x ch $.
    $( "Celaront", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , all ` ch ` is ` ph ` , and some ` ch ` exist, therefore some
       ` ch ` is not ` ps ` .  (In Aristotelian notation, EAO-1:  MeP and SaM
       therefore SoP.) For example, given "No reptiles have fur", "All snakes
       are reptiles.", and "Snakes exist.", prove "Some snakes have no fur".
       Note the existence hypothesis.  Example from
       ~ https://en.wikipedia.org/wiki/Syllogism .  (Contributed by David A.
       Wheeler, 27-Aug-2016.)  (Revised by David A. Wheeler, 2-Sep-2016.) $)
    celaront $p |- E. x ( ch /\ -. ps ) $=
      ( wn barbari ) ABHCDEFGI $.
  $}

  $( Figure 2 $)

  ${
    $( Major premise for the Aristotelian syllogism "Cesare" $)
    cesare.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for Cesare $)
    cesare.min $e |- A. x ( ch -> ps ) $.
    $( "Cesare", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , and all ` ch ` is ` ps ` , therefore no ` ch ` is ` ph ` .  (In
       Aristotelian notation, EAE-2:  PeM and SaM therefore SeP.) Related to
       ~ celarent .  (Contributed by David A. Wheeler, 27-Aug-2016.)  (Revised
       by David A. Wheeler, 13-Nov-2016.) $)
    cesare $p |- A. x ( ch -> -. ph ) $=
      ( wn wi spi nsyl3 ax-gen ) CAGHDABCABGHDEICBHDFIJK $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Camestres" $)
    camestres.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for Camestres $)
    camestres.min $e |- A. x ( ch -> -. ps ) $.
    $( "Camestres", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , and no ` ch ` is ` ps ` , therefore no ` ch ` is ` ph ` .  (In
       Aristotelian notation, AEE-2:  PaM and SeM therefore SeP.) (Contributed
       by David A. Wheeler, 28-Aug-2016.)  (Revised by David A. Wheeler,
       2-Sep-2016.) $)
    camestres $p |- A. x ( ch -> -. ph ) $=
      ( wn wi spi nsyl ax-gen ) CAGHDCBACBGHDFIABHDEIJK $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Festino" $)
    festino.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for Festino $)
    festino.min $e |- E. x ( ch /\ ps ) $.
    $( "Festino", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , and some ` ch ` is ` ps ` , therefore some ` ch ` is not
       ` ph ` .  (In Aristotelian notation, EIO-2:  PeM and SiM therefore SoP.)
       (Contributed by David A. Wheeler, 25-Nov-2016.) $)
    festino $p |- E. x ( ch /\ -. ph ) $=
      ( wa wn wi spi con2i anim2i eximii ) CBGCAHZGDFBNCABABHIDEJKLM $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Baroco" $)
    baroco.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for Baroco $)
    baroco.min $e |- E. x ( ch /\ -. ps ) $.
    $( "Baroco", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , and some ` ch ` is not ` ps ` , therefore some ` ch ` is not
       ` ph ` .  (In Aristotelian notation, AOO-2:  PaM and SoM therefore SoP.)
       For example, "All informative things are useful", "Some websites are not
       useful", therefore "Some websites are not informative."  (Contributed by
       David A. Wheeler, 28-Aug-2016.) $)
    baroco $p |- E. x ( ch /\ -. ph ) $=
      ( wn wa wi spi con3i anim2i eximii ) CBGZHCAGZHDFNOCABABIDEJKLM $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Cesaro" $)
    cesaro.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for Cesaro $)
    cesaro.min $e |- A. x ( ch -> ps ) $.
    $( Existence premise for Cesaro $)
    cesaro.e $e |- E. x ch $.
    $( "Cesaro", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , all ` ch ` is ` ps ` , and ` ch ` exist, therefore some ` ch `
       is not ` ph ` .  (In Aristotelian notation, EAO-2:  PeM and SaM
       therefore SoP.) (Contributed by David A. Wheeler, 28-Aug-2016.)
       (Revised by David A. Wheeler, 2-Sep-2016.) $)
    cesaro $p |- E. x ( ch /\ -. ph ) $=
      ( wn wa wi spi nsyl3 ancli eximii ) CCAHZIDGCOABCABHJDEKCBJDFKLMN $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Camestros" $)
    camestros.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for  $)
    camestros.min $e |- A. x ( ch -> -. ps ) $.
    $( Existence premise for Camestros $)
    camestros.e $e |- E. x ch $.
    $( "Camestros", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , no ` ch ` is ` ps ` , and ` ch ` exist, therefore some ` ch `
       is not ` ph ` .  (In Aristotelian notation, AEO-2:  PaM and SeM
       therefore SoP.) For example, "All horses have hooves", "No humans have
       hooves", and humans exist, therefore "Some humans are not horses".
       (Contributed by David A. Wheeler, 28-Aug-2016.)  (Revised by David A.
       Wheeler, 2-Sep-2016.) $)
    camestros $p |- E. x ( ch /\ -. ph ) $=
      ( wn wa wi spi nsyl ancli eximii ) CCAHZIDGCOCBACBHJDFKABJDEKLMN $.
  $}

  $( Figure 3 $)

  ${
    $( Major premise for the Aristotelian syllogism "Datisi" $)
    datisi.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for  $)
    datisi.min $e |- E. x ( ph /\ ch ) $.
    $( "Datisi", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , and some ` ph ` is ` ch ` , therefore some ` ch ` is ` ps ` .
       (In Aristotelian notation, AII-3:  MaP and MiS therefore SiP.)
       (Contributed by David A. Wheeler, 28-Aug-2016.) $)
    datisi $p |- E. x ( ch /\ ps ) $=
      ( wa simpr wi spi adantr jca eximii ) ACGZCBGDFNCBACHABCABIDEJKLM $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Disamis" $)
    disamis.maj $e |- E. x ( ph /\ ps ) $.
    $( Minor premise for  $)
    disamis.min $e |- A. x ( ph -> ch ) $.
    $( "Disamis", one of the syllogisms of Aristotelian logic.  Some ` ph ` is
       ` ps ` , and all ` ph ` is ` ch ` , therefore some ` ch ` is ` ps ` .
       (In Aristotelian notation, IAI-3:  MiP and MaS therefore SiP.)
       (Contributed by David A. Wheeler, 28-Aug-2016.) $)
    disamis $p |- E. x ( ch /\ ps ) $=
      ( wa wi spi anim1i eximii ) ABGCBGDEACBACHDFIJK $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Ferison" $)
    ferison.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for  $)
    ferison.min $e |- E. x ( ph /\ ch ) $.
    $( "Ferison", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , and some ` ph ` is ` ch ` , therefore some ` ch ` is not
       ` ps ` .  (In Aristotelian notation, EIO-3:  MeP and MiS therefore SoP.)
       (Contributed by David A. Wheeler, 28-Aug-2016.)  (Revised by David A.
       Wheeler, 2-Sep-2016.) $)
    ferison $p |- E. x ( ch /\ -. ps ) $=
      ( wn datisi ) ABGCDEFH $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Bocardo" $)
    bocardo.maj $e |- E. x ( ph /\ -. ps ) $.
    $( Minor premise for  $)
    bocardo.min $e |- A. x ( ph -> ch ) $.
    $( "Bocardo", one of the syllogisms of Aristotelian logic.  Some ` ph ` is
       not ` ps ` , and all ` ph ` is ` ch ` , therefore some ` ch ` is not
       ` ps ` .  (In Aristotelian notation, OAO-3:  MoP and MaS therefore SoP.)
       For example, "Some cats have no tails", "All cats are mammals",
       therefore "Some mammals have no tails".  A reorder of ~ disamis ; prefer
       using that instead.  (Contributed by David A. Wheeler, 28-Aug-2016.)
       (New usage is discouraged.) $)
    bocardo $p |- E. x ( ch /\ -. ps ) $=
      ( wn disamis ) ABGCDEFH $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Felapton" $)
    felapton.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for  $)
    felapton.min $e |- A. x ( ph -> ch ) $.
    $( Existence premise for Felapton $)
    felapton.e $e |- E. x ph $.
    $( "Felapton", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , all ` ph ` is ` ch ` , and some ` ph ` exist, therefore some
       ` ch ` is not ` ps ` .  (In Aristotelian notation, EAO-3:  MeP and MaS
       therefore SoP.) For example, "No flowers are animals" and "All flowers
       are plants", therefore "Some plants are not animals".  (Contributed by
       David A. Wheeler, 28-Aug-2016.)  (Revised by David A. Wheeler,
       2-Sep-2016.) $)
    felapton $p |- E. x ( ch /\ -. ps ) $=
      ( wn wa wi spi jca eximii ) ACBHZIDGACNACJDFKANJDEKLM $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Darapti" $)
    darapti.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for  $)
    darapti.min $e |- A. x ( ph -> ch ) $.
    $( Existence premise for Darapti $)
    darapti.e $e |- E. x ph $.
    $( "Darapti", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , all ` ph ` is ` ch ` , and some ` ph ` exist, therefore some
       ` ch ` is ` ps ` .  (In Aristotelian notation, AAI-3:  MaP and MaS
       therefore SiP.) For example, "All squares are rectangles" and "All
       squares are rhombuses", therefore "Some rhombuses are rectangles".
       (Contributed by David A. Wheeler, 28-Aug-2016.) $)
    darapti $p |- E. x ( ch /\ ps ) $=
      ( wa wi spi jca eximii ) ACBHDGACBACIDFJABIDEJKL $.
  $}

  $( Figure 4 $)

  ${
    $( Major premise for the Aristotelian syllogism "Calemes" $)
    calemes.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for  $)
    calemes.min $e |- A. x ( ps -> -. ch ) $.
    $( "Calemes", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , and no ` ps ` is ` ch ` , therefore no ` ch ` is ` ph ` .  (In
       Aristotelian notation, AEE-4:  PaM and MeS therefore SeP.) (Contributed
       by David A. Wheeler, 28-Aug-2016.)  (Revised by David A. Wheeler,
       2-Sep-2016.) $)
    calemes $p |- A. x ( ch -> -. ph ) $=
      ( wn wi spi con2i nsyl ax-gen ) CAGHDCBABCBCGHDFIJABHDEIKL $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Dimatis" $)
    dimatis.maj $e |- E. x ( ph /\ ps ) $.
    $( Minor premise for  $)
    dimatis.min $e |- A. x ( ps -> ch ) $.
    $( "Dimatis", one of the syllogisms of Aristotelian logic.  Some ` ph ` is
       ` ps ` , and all ` ps ` is ` ch ` , therefore some ` ch ` is ` ph ` .
       (In Aristotelian notation, IAI-4:  PiM and MaS therefore SiP.) For
       example, "Some pets are rabbits.", "All rabbits have fur", therefore
       "Some fur bearing animals are pets".  Like ~ darii with positions
       interchanged.  (Contributed by David A. Wheeler, 28-Aug-2016.) $)
    dimatis $p |- E. x ( ch /\ ph ) $=
      ( wa wi spi adantl simpl jca eximii ) ABGZCAGDENCABCABCHDFIJABKLM $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Fresison" $)
    fresison.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for  $)
    fresison.min $e |- E. x ( ps /\ ch ) $.
    $( "Fresison", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` (PeM), and some ` ps ` is ` ch ` (MiS), therefore some ` ch ` is
       not ` ph ` (SoP).  (In Aristotelian notation, EIO-4:  PeM and MiS
       therefore SoP.) (Contributed by David A. Wheeler, 28-Aug-2016.)
       (Revised by David A. Wheeler, 2-Sep-2016.) $)
    fresison $p |- E. x ( ch /\ -. ph ) $=
      ( wa wn simpr wi spi con2i adantr jca eximii ) BCGZCAHZGDFPCQBCIBQCABABHJ
      DEKLMNO $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Calemos" $)
    calemos.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for  $)
    calemos.min $e |- A. x ( ps -> -. ch ) $.
    $( Existence premise for Calemos $)
    calemos.e $e |- E. x ch $.
    $( "Calemos", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` (PaM), no ` ps ` is ` ch ` (MeS), and ` ch ` exist, therefore
       some ` ch ` is not ` ph ` (SoP).  (In Aristotelian notation, AEO-4:  PaM
       and MeS therefore SoP.) (Contributed by David A. Wheeler, 28-Aug-2016.)
       (Revised by David A. Wheeler, 2-Sep-2016.) $)
    calemos $p |- E. x ( ch /\ -. ph ) $=
      ( wn wa wi spi con2i nsyl ancli eximii ) CCAHZIDGCPCBABCBCHJDFKLABJDEKMNO
      $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Fesapo" $)
    fesapo.maj $e |- A. x ( ph -> -. ps ) $.
    $( Minor premise for  $)
    fesapo.min $e |- A. x ( ps -> ch ) $.
    $( Existence premise for Fesapo $)
    fesapo.e $e |- E. x ps $.
    $( "Fesapo", one of the syllogisms of Aristotelian logic.  No ` ph ` is
       ` ps ` , all ` ps ` is ` ch ` , and ` ps ` exist, therefore some ` ch `
       is not ` ph ` .  (In Aristotelian notation, EAO-4:  PeM and MaS
       therefore SoP.) (Contributed by David A. Wheeler, 28-Aug-2016.)
       (Revised by David A. Wheeler, 2-Sep-2016.) $)
    fesapo $p |- E. x ( ch /\ -. ph ) $=
      ( wn wa wi spi con2i jca eximii ) BCAHZIDGBCOBCJDFKABABHJDEKLMN $.
  $}

  ${
    $( Major premise for the Aristotelian syllogism "Bamalip" $)
    bamalip.maj $e |- A. x ( ph -> ps ) $.
    $( Minor premise for  $)
    bamalip.min $e |- A. x ( ps -> ch ) $.
    $( Existence premise for Bamalip $)
    bamalip.e $e |- E. x ph $.
    $( "Bamalip", one of the syllogisms of Aristotelian logic.  All ` ph ` is
       ` ps ` , all ` ps ` is ` ch ` , and ` ph ` exist, therefore some ` ch `
       is ` ph ` .  (In Aristotelian notation, AAI-4:  PaM and MaS therefore
       SiP.) Like ~ barbari .  (Contributed by David A. Wheeler,
       28-Aug-2016.) $)
    bamalip $p |- E. x ( ch /\ ph ) $=
      ( wa wi spi syl ancri eximii ) ACAHDGACABCABIDEJBCIDFJKLM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Intuitionistic logic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

Intuitionistic (constructive) logic is similar to classical logic
with the notable omission of ~ ax-3 and theorems such as ~ exmid or
~ peirce . We mostly treat intuitionistic logic in a separate file, iset.mm,
which is known as the Intuitionistic Logic Explorer on the web site. However,
iset.mm has a number of additional axioms (mainly to replace definitions like
~ df-or and ~ df-ex which are not valid in intitionistic logic) and we want
to prove those axioms here to demonstrate that adding those axioms in iset.mm
does not make iset.mm any less consistent than set.mm.

The following axioms are unchanged between set.mm and iset.mm: ~ ax-1 ,
~ ax-2 , ~ ax-mp , ~ ax-5 , ~ ax-7 , ~ ax-gen , ~ ax-8 , ~ ax-11 ,
~ ax-13 , ~ ax-14 , and ~ ax-17 .

$)

  $( Left 'and' elimination (intuitionistic logic axiom ax-ia1).  (Contributed
     by Jim Kingdon, 21-May-2018.) $)
  axia1 $p |- ( ( ph /\ ps ) -> ph ) $=
    ( simpl ) ABC $.

  $( Right 'and' elimination (intuitionistic logic axiom ax-ia2).  (Contributed
     by Jim Kingdon, 21-May-2018.) $)
  axia2 $p |- ( ( ph /\ ps ) -> ps ) $=
    ( simpr ) ABC $.

  $( 'And' introduction (intuitionistic logic axiom ax-ia3).  (Contributed by
     Jim Kingdon, 21-May-2018.) $)
  axia3 $p |- ( ph -> ( ps -> ( ph /\ ps ) ) ) $=
    ( pm3.2 ) ABC $.

  $( 'Not' introduction (intuitionistic logic axiom ax-in1).  (Contributed by
     Jim Kingdon, 21-May-2018.) $)
  axin1 $p |- ( ( ph -> -. ph ) -> -. ph ) $=
    ( pm2.01 ) AB $.

  $( 'Not' elimination (intuitionistic logic axiom ax-in2).  (Contributed by
     Jim Kingdon, 21-May-2018.) $)
  axin2 $p |- ( -. ph -> ( ph -> ps ) ) $=
    ( pm2.21 ) ABC $.

  $( Definition of 'or' (intuitionistic logic axiom ax-io).  (Contributed by
     Jim Kingdon, 21-May-2018.) $)
  axio $p |- ( ( ( ph \/ ch ) -> ps ) <->
      ( ( ph -> ps ) /\ ( ch -> ps ) ) ) $=
    ( jaob ) ABCD $.

  $( Specialization (intuitionistic logic axiom ax-4).  This is just ~ sp by
     another name.  (Contributed by Jim Kingdon, 31-Dec-2017.) $)
  axi4 $p |- ( A. x ph -> ph ) $=
    ( sp ) ABC $.

  $( Converse of ax-5o (intuitionistic logic axiom ax-i5r).  (Contributed by
     Jim Kingdon, 31-Dec-2017.) $)
  axi5r $p |- ( ( A. x ph -> A. x ps ) -> A. x ( A. x ph -> ps ) ) $=
    ( wal wi hba1 hbim sp imim2i alrimih ) ACDZBCDZEKBECKLCACFBCFGLBKBCHIJ $.

  $( ` x ` is not free in ` A. x ph ` (intuitionistic logic axiom ax-ial).
     (Contributed by Jim Kingdon, 31-Dec-2017.) $)
  axial $p |- ( A. x ph -> A. x A. x ph ) $=
    ( hba1 ) ABC $.

  $( ` x ` is bound in ` E. x ph ` (intuitionistic logic axiom ax-ie1).
     (Contributed by Jim Kingdon, 31-Dec-2017.) $)
  axie1 $p |- ( E. x ph -> A. x E. x ph ) $=
    ( hbe1 ) ABC $.

  $( A key property of existential quantification (intuitionistic logic axiom
     ax-ie2).  (Contributed by Jim Kingdon, 31-Dec-2017.) $)
  axie2 $p |- ( A. x ( ps -> A. x ps ) ->
              ( A. x ( ph -> ps ) <-> ( E. x ph -> ps ) ) ) $=
    ( wal wi wnf wex wb df-nf 19.23t sylbir ) BBCDECDBCFABECDACGBEHBCIABCJK $.

  $( Axiom of existence (intuitionistic logic axiom ax-i9).  In classical
     logic, this is equivalent to ~ ax-9 but in intuitionistic logic it needs
     to be stated using the existential quantifier.  (Contributed by Jim
     Kingdon, 31-Dec-2017.) $)
  axi9 $p |- E. x x = y $=
    ( a9e ) ABC $.

  $( Axiom of Quantifier Substitution (intuitionistic logic axiom ax-10).  This
     is just ~ ax10 by another name.  (Contributed by Jim Kingdon,
     31-Dec-2017.) $)
  axi10 $p |- ( A. x x = y -> A. y y = x ) $=
    ( ax10 ) ABC $.

  $( Axiom of Quantifier Introduction (intuitionistic logic axiom ax-i12).

     In classical logic, this is mostly a restatement of ~ ax12o (with one
     additional quantifier).  But in intuitionistic logic, changing the
     negations and implications to disjunctions makes it stronger.

     (Contributed by Jim Kingdon, 31-Dec-2017.) $)
  axi12 $p |- ( A. z z = x \/ ( A. z z = y \/
                A. z ( x = y -> A. z x = y ) ) ) $=
    ( weq wal wo wi nfae nfor 19.32 wn ax12o orrd orri orass mpbir mpgbi mpbi )
    CADCEZCBDCEZFZABDZUBCEGZCEZFZSTUDFFUAUCFZUECUAUCCSTCCACHCBCHIJUFSTUCFZFSUGS
    KTUCABCLMNSTUCOPQSTUDOR $.

  $( Axiom of Bundling (intuitionistic logic axiom ax-bnd).

     In classical logic, this and ~ axi12 are fairly straightforward
     consequences of ~ ax12o .  But in intuitionistic logic, it is not easy to
     add the extra ` A. x ` to ~ axi12 and so we treat the two as separate
     axioms.

     (Contributed by Jim Kingdon, 22-Mar-2018.) $)
  axbnd $p |- ( A. z z = x \/ ( A. z z = y \/
                 A. x A. z ( x = y -> A. z x = y ) ) ) $=
    ( weq wal wi wo wn wa nfnae nfan ax12o imp alrimi ex orrd orri ) CADCEZCBDC
    EZABDZTCEFZCEZAEZGRHZSUCUDSHZUCUDUEIZUBAUDUEACAAJCBAJKUFUACUDUECCACJCBCJKUD
    UEUAABCLMNNOPQ $.

$( End $[ set-pred.mm $] $)

$( Begin $[ set-class.mm $] $)

$(
###############################################################################
                ZF (ZERMELO-FRAENKEL) SET THEORY
###############################################################################

  Set theory uses the formalism of propositional and predicate calculus to
  assert properties of arbitrary mathematical objects called "sets."  A set can
  be contained in another set, and this relationship is indicated by the ` e. `
  symbol.  Starting with the simplest mathematical object, called the empty
  set, set theory builds up more and more complex structures whose existence
  follows from the axioms, eventually resulting in extremely complicated sets
  that we identify with the real numbers and other familiar mathematical
  objects.

  A simplistic concept of sets, sometimes called "naive set theory", is
  vulnerable to a paradox called "Russell's paradox" ( ~ ru ), a discovery that
  revolutionized the foundations of mathematics and logic.  Russell's Paradox
  spawned the development of set theories that countered the paradox, including
  the ZF set theory that is most widely used and is defined here.

  Except for Extensionality, the axioms basically say, "given an arbitrary set
  x (and, in the cases of Replacement and Regularity, provided that an
  antecedent is satisfied), there exists another set y based on or constructed
  from it, with the stated properties."  (The axiom of Extensionality can also
  be restated this way as shown by ~ axext2 .) The individual axiom links
  provide more detailed descriptions.  We derive the redundant ZF axioms of
  Separation, Null Set, and Pairing from the others as theorems.

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                    Zermelo-Fraenkel Set Theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - start with the Axiom of Extensionality
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Introduce the Axiom of Extensionality
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d x y z $.
    $( Axiom of Extensionality.  An axiom of Zermelo-Fraenkel set theory.  It
       states that two sets are identical if they contain the same elements.
       Axiom Ext of [BellMachover] p. 461.

       Set theory can also be formulated with a _single_ primitive predicate
       ` e. ` on top of traditional predicate calculus _without_ equality.  In
       that case the Axiom of Extensionality becomes
       ` ( A. w ( w e. x <-> w e. y ) -> ( x e. z -> y e. z ) ) ` , and
       equality ` x = y ` is _defined_ as ` A. w ( w e. x <-> w e. y ) ` .  All
       of the usual axioms of equality then become theorems of set theory.
       See, for example, Axiom 1 of [TakeutiZaring] p. 8.

       To use the above "equality-free" version of Extensionality with
       Metamath's logical axioms, we would rewrite ~ ax-8 through ~ ax-16 with
       equality expanded according to the above definition.  Some of those
       axioms could be proved from set theory and would be redundant.  Not all
       of them are redundant, since our axioms of predicate calculus make
       essential use of equality for the proper substitution that is a
       primitive notion in traditional predicate calculus.  A study of such an
       axiomatization would be an interesting project for someone exploring the
       foundations of logic.

       _General remarks_:  Our set theory axioms are presented using defined
       connectives ( ` <-> ` , ` E. ` , etc.) for convenience.  However, it is
       implicitly understood that the actual axioms use only the primitive
       connectives ` -> ` , ` -. ` , ` A. ` , ` = ` , and ` e. ` .  It is
       straightforward to establish the equivalence between the actual axioms
       and the ones we display, and we will not do so.

       It is important to understand that strictly speaking, all of our set
       theory axioms are really schemes that represent an infinite number of
       actual axioms.  This is inherent in the design of Metamath
       ("metavariable math"), which manipulates only metavariables.  For
       example, the metavariable ` x ` in ~ ax-ext can represent any actual
       variable _v1_, _v2_, _v3_,... .  Distinct variable restrictions ($d)
       prevent us from substituting say _v1_ for both ` x ` and ` z ` .  This
       is in contrast to typical textbook presentations that present actual
       axioms (except for Replacement ~ ax-rep , which involves a wff
       metavariable).  In practice, though, the theorems and proofs are
       essentially the same.  The $d restrictions make each of the infinite
       axioms generated by the ~ ax-ext scheme exactly logically equivalent to
       each other and in particular to the actual axiom of the textbook
       version.  (Contributed by NM, 5-Aug-1993.) $)
    ax-ext $a |- ( A. z ( z e. x <-> z e. y ) -> x = y ) $.

    $( The Axiom of Extensionality ( ~ ax-ext ) restated so that it postulates
       the existence of a set ` z ` given two arbitrary sets ` x ` and ` y ` .
       This way to express it follows the general idea of the other ZFC axioms,
       which is to postulate the existence of sets given other sets.
       (Contributed by NM, 28-Sep-2003.) $)
    axext2 $p |- E. z ( ( z e. x <-> z e. y ) -> x = y ) $=
      ( wel wb weq wi wex wal ax-ext 19.36v mpbir ) CADCBDEZABFZGCHMCINGABCJMNC
      KL $.
  $}

  ${
    $d z x w $.  $d z y w $.
    $( A generalization of the Axiom of Extensionality in which ` x ` and ` y `
       need not be distinct.  (Contributed by NM, 15-Sep-1993.)  (Proof
       shortened by Andrew Salmon, 12-Aug-2011.) $)
    axext3 $p |- ( A. z ( z e. x <-> z e. y ) -> x = y ) $=
      ( vw wel wb wal weq wi elequ2 bibi1d albidv equequ1 imbi12d ax-ext chvarv
      ) CDEZCBEZFZCGZDBHZICAEZRFZCGZABHZIDADAHZTUDUAUEUFSUCCUFQUBRDACJKLDABMNDB
      COP $.

    $( A bidirectional version of Extensionality.  Although this theorem
       "looks" like it is just a definition of equality, it requires the Axiom
       of Extensionality for its proof under our axiomatization.  See the
       comments for ~ ax-ext and ~ df-cleq .  (Contributed by NM,
       14-Nov-2008.) $)
    axext4 $p |- ( x = y <-> A. z ( z e. x <-> z e. y ) ) $=
      ( weq wel wb wal elequ2 alrimiv axext3 impbii ) ABDZCAECBEFZCGLMCABCHIABC
      JK $.
  $}

  ${
    $d x y z $.  $d ph z $.
    bm1.1.1 $e |- F/ x ph $.
    $( Any set defined by a property is the only set defined by that property.
       Theorem 1.1 of [BellMachover] p. 462.  (Contributed by NM,
       30-Jun-1994.) $)
    bm1.1 $p |- ( E. x A. y ( y e. x <-> ph ) ->
                  E! x A. y ( y e. x <-> ph ) ) $=
      ( vz wel wb wal wex wsb wa weq wi weu nfv nfbi nfal elequ2 bibi1d albidv
      sbie 19.26 biantr alimi ax-ext syl sylbir sylan2b gen2 jctr eu2 sylibr )
      CBFZAGZCHZBIZUPUOUOBEJZKBELZMZEHBHZKUOBNUPUTUSBEUQUOCEFZAGZCHZURUOVCBEVBB
      CVAABVABODPQURUNVBCURUMVAABECRSTUAUOVCKUNVBKZCHZURUNVBCUBVEUMVAGZCHURVDVF
      CUMAVAUCUDBECUEUFUGUHUIUJUOBEUOEOUKUL $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Class abstractions (a.k.a. class builders)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constants use in class definition. $)
  $c { $. $( Left brace $)
  $c | $.  $( Vertical bar $)
  $c } $. $( Right brace $)
  $( --- Start of old code before overloading prevention patch. $)
  $(
  @c class @. @( Class variable type @)
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Declare symbols as variables $)
  $v ./\ $.
  $v .\/ $.
  $v .<_ $.
  $v .< $.
  $v .+ $.
  $v .- $.
  $v .X. $.
  $v ./ $.
  $v .^ $.
  $v .0. $.
  $v .1. $.
  $v .|| $.
  $v .~ $.
  $v ._|_ $.
  $v .+^ $.
  $v .+b $.
  $v .(+) $.
  $v .* $.
  $v .x. $.
  $v .xb $.
  $v ., $.
  $v .(x) $.
  $v .0b $.

  $( Declare variable symbols that will be used to represent classes.  Note
     that later on ` R ` , ` S ` , ` F ` and ` G ` denote relations and
     functions, but these letters serve as mnemonics only and in fact behave
     no differently from the variables ` A ` through ` D ` . $)
  $v A $.
  $v B $.
  $v C $.
  $v D $.
  $v P $.
  $v Q $.
  $v R $.
  $v S $.
  $v T $.
  $v U $.

  $( Introduce the class builder or class abstraction notation ("the class of
     sets ` x ` such that ` ph ` is true").  Our class variables ` A ` ,
     ` B ` , etc. range over class builders (implicitly in the case of defined
     class terms such as ~ df-nul ).  Note that a set variable can be expressed
     as a class builder per theorem ~ cvjust , justifying the assignment of set
     variables to class variables via the use of ~ cv . $)
  cab $a class { x | ph } $.

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( A set variable is a class expression.  The syntax " ` class x ` " can be
     viewed as an abbreviation for " ` class { y | y e. x } ` " (a special case
     of ~ cab ), where ` y ` is distinct from ` x ` .  See the discussion under
     the definition of class in [Jech] p. 4.  Note that ` { y | y e. x } = x `
     by ~ cvjust . @)
  cv @a class x @.
  $)
  $( --- End of old code before overloading prevention patch. $)
  $( $j primitive 'cv' 'wceq' 'wcel' 'cab'; $)

  $( Let ` A ` be a class variable. $)
  cA $f class A $.
  $( Let ` B ` be a class variable. $)
  cB $f class B $.
  $( Let ` C ` be a class variable. $)
  cC $f class C $.

  $( Define a connective symbol for use as a class variable. $)
  c.pa $f class .|| $.

  $( Let ` D ` be a class variable. $)
  cD $f class D $.

  $( Define a connective symbol for use as a class variable. $)
  c.dv $f class ./ $.

  $( Let ` P ` be a class variable. $)
  cP $f class P $.

  $( Define a connective symbol for use as a class variable. $)
  c.pl $f class .+ $.

  $( Define a connective symbol for use as a class variable. $)
  c.pd $f class .+^ $.

  $( Define a connective symbol for use as a class variable. $)
  c.pb $f class .+b $.

  $( Define a connective symbol for use as a class variable. $)
  c.po $f class .(+) $.

  $( Let ` Q ` be a class variable. $)
  cQ $f class Q $.

  $( Define a connective symbol for use as a class variable. $)
  c.sm $f class .~ $.

  $( Let ` R ` be a class variable. $)
  cR $f class R $.
  $( Let ` S ` be a class variable. $)
  cS $f class S $.

  $( Define a connective symbol for use as a class variable. $)
  c.lt $f class .< $.

  $( Define a connective symbol for use as a class variable. $)
  c.xb $f class .xb $.

  $( Let ` T ` be a class variable. $)
  cT $f class T $.

  $( Define a connective symbol for use as a class variable. $)
  c.x $f class .x. $.

  $( Define a connective symbol for use as a class variable. $)
  c.xp $f class .X. $.

  $( Define a connective symbol for use as a class variable. $)
  c.xo $f class .(x) $.

  $( Let ` U ` be a class variable. $)
  cU $f class U $.

  $( Define a connective symbol for use as a class variable. $)
  c.1 $f class .1. $.

  $v e $.
  $v f $.
  $v g $.
  $v h $.
  $v i $.
  $v j $.
  $v k $.
  $v m $.
  $v n $.
  $v o $.
  $v E $.
  $v F $.
  $v G $.
  $v H $.
  $v I $.
  $v J $.
  $v K $.
  $v L $.
  $v M $.
  $v N $.
  $v V $.
  $v W $.
  $v X $.
  $v Y $.
  $v Z $.
  $v O $.
  $v s $.
  $v r $.
  $v q $.
  $v p $.
  $v a $.
  $v b $.
  $v c $.
  $v d $.
  $v l $.


  $( Let ` e ` be an individual variable. $)
  ve $f set e $.
  $( Let ` f ` be an individual variable. $)
  vf $f set f $.
  $( Let ` g ` be an individual variable. $)
  vg $f set g $.
  $( Let ` h ` be an individual variable. $)
  vh $f set h $.
  $( Let ` i ` be an individual variable. $)
  vi $f set i $.
  $( Let ` j ` be an individual variable. $)
  vj $f set j $.
  $( Let ` k ` be an individual variable. $)
  vk $f set k $.
  $( Let ` m ` be an individual variable. $)
  vm $f set m $.
  $( Let ` n ` be an individual variable. $)
  vn $f set n $.
  $( Let ` o ` be an individual variable. $)
  vo $f set o $.
  $( Let ` E ` be a class variable. $)
  cE $f class E $.

  $( Define a connective symbol for use as a class variable. $)
  c.ex $f class .^ $.

  $( Let ` F ` be a class variable. $)
  cF $f class F $.
  $( Let ` G ` be a class variable. $)
  cG $f class G $.
  $( Let ` H ` be a class variable. $)
  cH $f class H $.

  $( Define a connective symbol for use as a class variable. $)
  c.xi $f class ., $.

  $( Let ` I ` be a class variable. $)
  cI $f class I $.

  $( Define a connective symbol for use as a class variable. $)
  c.as $f class .* $.

  $( Let ` J ` be a class variable. $)
  cJ $f class J $.

  $( Define a connective symbol for use as a class variable. $)
  c.or $f class .\/ $.

  $( Let ` K ` be a class variable. $)
  cK $f class K $.
  $( Let ` L ` be a class variable. $)
  cL $f class L $.

  $( Define a connective symbol for use as a class variable. $)
  c.le $f class .<_ $.

  $( Let ` M ` be a class variable. $)
  cM $f class M $.

  $( Define a connective symbol for use as a class variable. $)
  c.an $f class ./\ $.

  $( Define a connective symbol for use as a class variable. $)
  c.mi $f class .- $.

  $( Let ` N ` be a class variable. $)
  cN $f class N $.

  $( Define a connective symbol for use as a class variable. $)
  c.pe $f class ._|_ $.

  $( Let ` O ` be a class variable. $)
  cO $f class O $.
  $( Let ` V ` be a class variable. $)
  cV $f class V $.
  $( Let ` W ` be a class variable. $)
  cW $f class W $.
  $( Let ` X ` be a class variable. $)
  cX $f class X $.
  $( Let ` Y ` be a class variable. $)
  cY $f class Y $.

  $( Define a connective symbol for use as a class variable. $)
  c.0 $f class .0. $.

  $( Define a connective symbol for use as a class variable. $)
  c.0b $f class .0b $.

  $( Let ` Z ` be a class variable. $)
  cZ $f class Z $.
  $( Let ` s ` be an individual variable. $)
  vs $f set s $.
  $( Let ` r ` be an individual variable. $)
  vr $f set r $.
  $( Let ` q ` be an individual variable. $)
  vq $f set q $.
  $( Let ` p ` be an individual variable. $)
  vp $f set p $.
  $( Let ` a ` be an individual variable. $)
  va $f set a $.
  $( Let ` b ` be an individual variable. $)
  vb $f set b $.
  $( Let ` c ` be an individual variable. $)
  vc $f set c $.
  $( Let ` d ` be an individual variable. $)
  vd $f set d $.
  $( Let ` l ` be an individual variable. $)
  vl $f set l $.

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include class equality. @)
  wceq @a wff A = B @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff definition to include the membership connective between
     classes. @)
  wcel @a wff A e. B @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( Define class abstraction notation (so-called by Quine), also called a
     "class builder" in the literature. ` x ` and ` y ` need not be distinct.
     Definition 2.1 of [Quine] p. 16.  Typically, ` ph ` will have ` y ` as a
     free variable, and " ` { y | ph } ` " is read "the class of all sets ` y `
     such that ` ph ( y ) ` is true."  We do not define ` { y | ph } ` in
     isolation but only as part of an expression that extends or "overloads"
     the ` e. ` relationship.

     This is our first use of the ` e. ` symbol to connect classes instead of
     sets.  The syntax definition ~ wcel , which extends or "overloads" the
     ~ wel definition connecting set variables, requires that both sides of
     ` e. ` be a class.  In ~ df-cleq and ~ df-clel , we introduce a new kind
     of variable (class variable) that can substituted with expressions such as
     ` { y | ph } ` .  In the present definition, the ` x ` on the left-hand
     side is a set variable.  Syntax definition ~ cv allows us to substitute a
     set variable ` x ` for a class variable: all sets are classes by ~ cvjust
     (but not necessarily vice-versa).  For a full description of how classes
     are introduced and how to recover the primitive language, see the
     discussion in Quine (and under ~ abeq2 for a quick overview).

     Because class variables can be substituted with compound expressions and
     set variables cannot, it is often useful to convert a theorem containing a
     free set variable to a more general version with a class variable.  This
     is done with theorems such as ~ vtoclg which is used, for example, to
     convert ~ elirrv to ~ elirr .

     This is called the "axiom of class comprehension" by [Levy] p. 338, who
     treats the theory of classes as an extralogical extension to our logic and
     set theory axioms.  He calls the construction ` { y | ph } ` a "class
     term".

     For a general discussion of the theory of classes, see
     ~ http://us.metamath.org/mpeuni/mmset.html#class .  (Contributed by NM,
     5-Aug-1993.) $)
  df-clab $a |- ( x e. { y | ph } <-> [ x / y ] ph ) $.

  $( Simplification of class abstraction notation when the free and bound
     variables are identical.  (Contributed by NM, 5-Aug-1993.) $)
  abid $p |- ( x e. { x | ph } <-> ph ) $=
    ( cv cab wcel wsb df-clab sbid bitri ) BCABDEABBFAABBGABHI $.

  ${
    $d x y $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by NM, 5-Aug-1993.) $)
    hbab1 $p |- ( y e. { x | ph } -> A. x y e. { x | ph } ) $=
      ( cv cab wcel wsb df-clab hbs1 hbxfrbi ) CDABEFABCGBACBHABCIJ $.

    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 11-Aug-2016.) $)
    nfsab1 $p |- F/ x y e. { x | ph } $=
      ( cv cab wcel hbab1 nfi ) CDABEFBABCGH $.
  $}

  ${
    $d x z $.
    hbab.1 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by NM, 1-Mar-1995.) $)
    hbab $p |- ( z e. { y | ph } -> A. x z e. { y | ph } ) $=
      ( cv cab wcel wsb df-clab hbsb hbxfrbi ) DFACGHACDIBADCJACDBEKL $.
  $}

  ${
    $d x z $.
    nfsab.1 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 11-Aug-2016.) $)
    nfsab $p |- F/ x z e. { y | ph } $=
      ( cv cab wcel nfri hbab nfi ) DFACGHBABCDABEIJK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x y z $.
    df-cleq.1 $e |- ( A. x ( x e. y <-> x e. z ) -> y = z ) $.
    $( Define the equality connective between classes.  Definition 2.7 of
       [Quine] p. 18.  Also Definition 4.5 of [TakeutiZaring] p. 13; Chapter 4
       provides its justification and methods for eliminating it.  Note that
       its elimination will not necessarily result in a single wff in the
       original language but possibly a "scheme" of wffs.

       This is an example of a somewhat "risky" definition, meaning that it has
       a more complex than usual soundness justification (outside of Metamath),
       because it "overloads" or reuses the existing equality symbol rather
       than introducing a new symbol.  This allows us to make statements that
       may not hold for the original symbol.  For example, it permits us to
       deduce ` y = z <-> A. x ( x e. y <-> x e. z ) ` , which is not a theorem
       of logic but rather presupposes the Axiom of Extensionality (see theorem
       ~ axext4 ).  We therefore include this axiom as a hypothesis, so that
       the use of Extensionality is properly indicated.

       We could avoid this complication by introducing a new symbol, say =_2,
       in place of ` = ` .  This would also have the advantage of making
       elimination of the definition straightforward, so that we could
       eliminate Extensionality as a hypothesis.  We would then also have the
       advantage of being able to identify in various proofs exactly where
       Extensionality truly comes into play rather than just being an artifact
       of a definition.  One of our theorems would then be ` x ` =_2
       ` y <-> x = y ` by invoking Extensionality.

       However, to conform to literature usage, we retain this overloaded
       definition.  This also makes some proofs shorter and probably easier to
       read, without the constant switching between two kinds of equality.

       See also comments under ~ df-clab , ~ df-clel , and ~ abeq2 .

       In the form of ~ dfcleq , this is called the "axiom of extensionality"
       by [Levy] p. 338, who treats the theory of classes as an extralogical
       extension to our logic and set theory axioms.

       For a general discussion of the theory of classes, see
       ~ http://us.metamath.org/mpeuni/mmset.html#class .  (Contributed by NM,
       15-Sep-1993.) $)
    df-cleq $a |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $.
  $}

  ${
    $d x A $.  $d x B $.  $d x y z $.
    $( The same as ~ df-cleq with the hypothesis removed using the Axiom of
       Extensionality ~ ax-ext .  (Contributed by NM, 15-Sep-1993.) $)
    dfcleq $p |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $=
      ( vy vz ax-ext df-cleq ) ADEBCDEAFG $.
  $}

  ${
    $d x y z $.
    $( Every set is a class.  Proposition 4.9 of [TakeutiZaring] p. 13.  This
       theorem shows that a set variable can be expressed as a class
       abstraction.  This provides a motivation for the class syntax
       construction ~ cv , which allows us to substitute a set variable for a
       class variable.  See also ~ cab and ~ df-clab .  Note that this is not a
       rigorous justification, because ~ cv is used as part of the proof of
       this theorem, but a careful argument can be made outside of the
       formalism of Metamath, for example as is done in Chapter 4 of Takeuti
       and Zaring.  See also the discussion under the definition of class in
       [Jech] p. 4 showing that "Every set can be considered to be a class."
       (Contributed by NM, 7-Nov-2006.) $)
    cvjust $p |- x = { y | y e. x } $=
      ( vz cv wcel cab wceq wb dfcleq wsb df-clab elsb3 bitr2i mpgbir ) ADZBDOE
      ZBFZGCDZOEZRQEZHCCOQITPBCJSPCBKCBALMN $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Define the membership connective between classes.  Theorem 6.3 of
       [Quine] p. 41, or Proposition 4.6 of [TakeutiZaring] p. 13, which we
       adopt as a definition.  See these references for its metalogical
       justification.  Note that like ~ df-cleq it extends or "overloads" the
       use of the existing membership symbol, but unlike ~ df-cleq it does not
       strengthen the set of valid wffs of logic when the class variables are
       replaced with set variables (see ~ cleljust ), so we don't include any
       set theory axiom as a hypothesis.  See also comments about the syntax
       under ~ df-clab .  Alternate definitions of ` A e. B ` (but that require
       either ` A ` or ` B ` to be a set) are shown by ~ clel2 , ~ clel3 , and
       ~ clel4 .

       This is called the "axiom of membership" by [Levy] p. 338, who treats
       the theory of classes as an extralogical extension to our logic and set
       theory axioms.

       For a general discussion of the theory of classes, see
       ~ http://us.metamath.org/mpeuni/mmset.html#class .  (Contributed by NM,
       5-Aug-1993.) $)
    df-clel $a |- ( A e. B <-> E. x ( x = A /\ x e. B ) ) $.
  $}

  ${
    $d x A $.  $d x B $.
    eqriv.1 $e |- ( x e. A <-> x e. B ) $.
    $( Infer equality of classes from equivalence of membership.  (Contributed
       by NM, 5-Aug-1993.) $)
    eqriv $p |- A = B $=
      ( wceq cv wcel wb dfcleq mpgbir ) BCEAFZBGKCGHAABCIDJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    eqrdv.1 $e |- ( ph -> ( x e. A <-> x e. B ) ) $.
    $( Deduce equality of classes from equivalence of membership.  (Contributed
       by NM, 17-Mar-1996.) $)
    eqrdv $p |- ( ph -> A = B ) $=
      ( cv wcel wb wal wceq alrimiv dfcleq sylibr ) ABFZCGNDGHZBICDJAOBEKBCDLM
      $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    eqrdav.1 $e |- ( ( ph /\ x e. A ) -> x e. C ) $.
    eqrdav.2 $e |- ( ( ph /\ x e. B ) -> x e. C ) $.
    eqrdav.3 $e |- ( ( ph /\ x e. C ) -> ( x e. A <-> x e. B ) ) $.
    $( Deduce equality of classes from an equivalence of membership that
       depends on the membership variable.  (Contributed by NM, 7-Nov-2008.) $)
    eqrdav $p |- ( ph -> A = B ) $=
      ( cv wcel wa biimpd impancom mpd wi exbiri com23 imp impbida eqrdv ) ABCD
      ABIZCJZUADJZAUBKUAEJZUCFAUDUBUCAUDKUBUCHLMNAUCKUDUBGAUCUDUBOAUDUCUBAUDUBU
      CHPQRNST $.
  $}

  ${
    $d x A $.
    $( Law of identity (reflexivity of class equality).  Theorem 6.4 of [Quine]
       p. 41.

       This law is thought to have originated with Aristotle (_Metaphysics_,
       Zeta, 17, 1041 a, 10-20).  (Thanks to Stefan Allan.)  (Contributed by
       NM, 5-Aug-1993.)  (Revised by BJ, 14-Oct-2017.) $)
    eqid $p |- A = A $=
      ( vx cv wcel biid eqriv ) BAABCADEF $.
  $}

  $( Class identity law with antecedent.  (Contributed by NM, 21-Aug-2008.) $)
  eqidd $p |- ( ph -> A = A ) $=
    ( wceq eqid a1i ) BBCABDE $.

  ${
    $d x A $.  $d x B $.
    $( Commutative law for class equality.  Theorem 6.5 of [Quine] p. 41.
       (Contributed by NM, 5-Aug-1993.) $)
    eqcom $p |- ( A = B <-> B = A ) $=
      ( vx cv wcel wb wal wceq bicom albii dfcleq 3bitr4i ) CDZAEZMBEZFZCGONFZC
      GABHBAHPQCNOIJCABKCBAKL $.
  $}

  ${
    eqcoms.1 $e |- ( A = B -> ph ) $.
    $( Inference applying commutative law for class equality to an antecedent.
       (Contributed by NM, 5-Aug-1993.) $)
    eqcoms $p |- ( B = A -> ph ) $=
      ( wceq eqcom sylbi ) CBEBCEACBFDG $.
  $}

  ${
    eqcomi.1 $e |- A = B $.
    $( Inference from commutative law for class equality.  (Contributed by NM,
       5-Aug-1993.) $)
    eqcomi $p |- B = A $=
      ( wceq eqcom mpbi ) ABDBADCABEF $.
  $}

  ${
    eqcomd.1 $e |- ( ph -> A = B ) $.
    $( Deduction from commutative law for class equality.  (Contributed by NM,
       15-Aug-1994.) $)
    eqcomd $p |- ( ph -> B = A ) $=
      ( wceq eqcom sylib ) ABCECBEDBCFG $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality implies equivalence of equalities.  (Contributed by NM,
       5-Aug-1993.) $)
    eqeq1 $p |- ( A = B -> ( A = C <-> B = C ) ) $=
      ( vx wceq cv wcel wb wal dfcleq biimpi 19.21bi bibi1d albidv 3bitr4g ) AB
      EZDFZAGZQCGZHZDIQBGZSHZDIACEBCEPTUBDPRUASPRUAHZDPUCDIDABJKLMNDACJDBCJO $.
  $}

  ${
    eqeq1i.1 $e |- A = B $.
    $( Inference from equality to equivalence of equalities.  (Contributed by
       NM, 5-Aug-1993.) $)
    eqeq1i $p |- ( A = C <-> B = C ) $=
      ( wceq wb eqeq1 ax-mp ) ABEACEBCEFDABCGH $.
  $}

  ${
    eqeq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction from equality to equivalence of equalities.  (Contributed by
       NM, 27-Dec-1993.) $)
    eqeq1d $p |- ( ph -> ( A = C <-> B = C ) ) $=
      ( wceq wb eqeq1 syl ) ABCFBDFCDFGEBCDHI $.
  $}

  $( Equality implies equivalence of equalities.  (Contributed by NM,
     5-Aug-1993.) $)
  eqeq2 $p |- ( A = B -> ( C = A <-> C = B ) ) $=
    ( wceq eqeq1 eqcom 3bitr4g ) ABDACDBCDCADCBDABCECAFCBFG $.

  ${
    eqeq2i.1 $e |- A = B $.
    $( Inference from equality to equivalence of equalities.  (Contributed by
       NM, 5-Aug-1993.) $)
    eqeq2i $p |- ( C = A <-> C = B ) $=
      ( wceq wb eqeq2 ax-mp ) ABECAECBEFDABCGH $.
  $}

  ${
    eqeq2d.1 $e |- ( ph -> A = B ) $.
    $( Deduction from equality to equivalence of equalities.  (Contributed by
       NM, 27-Dec-1993.) $)
    eqeq2d $p |- ( ph -> ( C = A <-> C = B ) ) $=
      ( wceq wb eqeq2 syl ) ABCFDBFDCFGEBCDHI $.
  $}

  $( Equality relationship among 4 classes.  (Contributed by NM,
     3-Aug-1994.) $)
  eqeq12 $p |- ( ( A = B /\ C = D ) -> ( A = C <-> B = D ) ) $=
    ( wceq eqeq1 eqeq2 sylan9bb ) ABEACEBCECDEBDEABCFCDBGH $.

  ${
    eqeq12i.1 $e |- A = B $.
    eqeq12i.2 $e |- C = D $.
    $( A useful inference for substituting definitions into an equality.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       25-May-2011.) $)
    eqeq12i $p |- ( A = C <-> B = D ) $=
      ( wceq wb eqeq12 mp2an ) ABGCDGACGBDGHEFABCDIJ $.

    $( Theorem eqeq12i is the congruence law for equality. $)
    $( $j congruence 'eqeq12i'; $)
  $}

  ${
    eqeq12d.1 $e |- ( ph -> A = B ) $.
    eqeq12d.2 $e |- ( ph -> C = D ) $.
    $( A useful inference for substituting definitions into an equality.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       25-May-2011.) $)
    eqeq12d $p |- ( ph -> ( A = C <-> B = D ) ) $=
      ( wceq wb eqeq12 syl2anc ) ABCHDEHBDHCEHIFGBCDEJK $.
  $}

  ${
    eqeqan12d.1 $e |- ( ph -> A = B ) $.
    eqeqan12d.2 $e |- ( ps -> C = D ) $.
    $( A useful inference for substituting definitions into an equality.
       (Contributed by NM, 9-Aug-1994.)  (Proof shortened by Andrew Salmon,
       25-May-2011.) $)
    eqeqan12d $p |- ( ( ph /\ ps ) -> ( A = C <-> B = D ) ) $=
      ( wceq wb eqeq12 syl2an ) ACDIEFICEIDFIJBGHCDEFKL $.
  $}

  ${
    eqeqan12rd.1 $e |- ( ph -> A = B ) $.
    eqeqan12rd.2 $e |- ( ps -> C = D ) $.
    $( A useful inference for substituting definitions into an equality.
       (Contributed by NM, 9-Aug-1994.) $)
    eqeqan12rd $p |- ( ( ps /\ ph ) -> ( A = C <-> B = D ) ) $=
      ( wceq wb eqeqan12d ancoms ) ABCEIDFIJABCDEFGHKL $.
  $}

  $( Transitive law for class equality.  Proposition 4.7(3) of [TakeutiZaring]
     p. 13.  (Contributed by NM, 25-Jan-2004.) $)
  eqtr $p |- ( ( A = B /\ B = C ) -> A = C ) $=
    ( wceq eqeq1 biimpar ) ABDACDBCDABCEF $.

  $( A transitive law for class equality.  (Contributed by NM, 20-May-2005.)
     (Proof shortened by Andrew Salmon, 25-May-2011.) $)
  eqtr2 $p |- ( ( A = B /\ A = C ) -> B = C ) $=
    ( wceq eqcom eqtr sylanb ) ABDBADACDBCDABEBACFG $.

  $( A transitive law for class equality.  (Contributed by NM, 20-May-2005.) $)
  eqtr3 $p |- ( ( A = C /\ B = C ) -> A = B ) $=
    ( wceq eqcom eqtr sylan2b ) BCDACDCBDABDBCEACBFG $.

  ${
    eqtri.1 $e |- A = B $.
    eqtri.2 $e |- B = C $.
    $( An equality transitivity inference.  (Contributed by NM, 5-Aug-1993.) $)
    eqtri $p |- A = C $=
      ( wceq eqeq2i mpbi ) ABFACFDBCAEGH $.
  $}

  ${
    eqtr2i.1 $e |- A = B $.
    eqtr2i.2 $e |- B = C $.
    $( An equality transitivity inference.  (Contributed by NM,
       21-Feb-1995.) $)
    eqtr2i $p |- C = A $=
      ( eqtri eqcomi ) ACABCDEFG $.
  $}

  ${
    eqtr3i.1 $e |- A = B $.
    eqtr3i.2 $e |- A = C $.
    $( An equality transitivity inference.  (Contributed by NM, 6-May-1994.) $)
    eqtr3i $p |- B = C $=
      ( eqcomi eqtri ) BACABDFEG $.
  $}

  ${
    eqtr4i.1 $e |- A = B $.
    eqtr4i.2 $e |- C = B $.
    $( An equality transitivity inference.  (Contributed by NM, 5-Aug-1993.) $)
    eqtr4i $p |- A = C $=
      ( eqcomi eqtri ) ABCDCBEFG $.
  $}

  $( Register '=' as an equality for its type (class). $)
  $( $j equality 'wceq' from 'eqid' 'eqcomi' 'eqtri'; $)

  ${
    3eqtri.1 $e |- A = B $.
    3eqtri.2 $e |- B = C $.
    3eqtri.3 $e |- C = D $.
    $( An inference from three chained equalities.  (Contributed by NM,
       29-Aug-1993.) $)
    3eqtri $p |- A = D $=
      ( eqtri ) ABDEBCDFGHH $.

    $( An inference from three chained equalities.  (Contributed by NM,
       3-Aug-2006.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtrri $p |- D = A $=
      ( eqtri eqtr2i ) ACDABCEFHGI $.
  $}

  ${
    3eqtr2i.1 $e |- A = B $.
    3eqtr2i.2 $e |- C = B $.
    3eqtr2i.3 $e |- C = D $.
    $( An inference from three chained equalities.  (Contributed by NM,
       3-Aug-2006.) $)
    3eqtr2i $p |- A = D $=
      ( eqtr4i eqtri ) ACDABCEFHGI $.

    $( An inference from three chained equalities.  (Contributed by NM,
       3-Aug-2006.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtr2ri $p |- D = A $=
      ( eqtr4i eqtr2i ) ACDABCEFHGI $.
  $}

  ${
    3eqtr3i.1 $e |- A = B $.
    3eqtr3i.2 $e |- A = C $.
    3eqtr3i.3 $e |- B = D $.
    $( An inference from three chained equalities.  (Contributed by NM,
       6-May-1994.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtr3i $p |- C = D $=
      ( eqtr3i ) BCDABCEFHGH $.

    $( An inference from three chained equalities.  (Contributed by NM,
       15-Aug-2004.) $)
    3eqtr3ri $p |- D = C $=
      ( eqtr3i ) BDCGABCEFHH $.
  $}

  ${
    3eqtr4i.1 $e |- A = B $.
    3eqtr4i.2 $e |- C = A $.
    3eqtr4i.3 $e |- D = B $.
    $( An inference from three chained equalities.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtr4i $p |- C = D $=
      ( eqtr4i ) CADFDBAGEHH $.

    $( An inference from three chained equalities.  (Contributed by NM,
       2-Sep-1995.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtr4ri $p |- D = C $=
      ( eqtr4i ) DACDBAGEHFH $.
  $}

  ${
    eqtrd.1 $e |- ( ph -> A = B ) $.
    eqtrd.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM, 5-Aug-1993.) $)
    eqtrd $p |- ( ph -> A = C ) $=
      ( wceq eqeq2d mpbid ) ABCGBDGEACDBFHI $.
  $}

  ${
    eqtr2d.1 $e |- ( ph -> A = B ) $.
    eqtr2d.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM,
       18-Oct-1999.) $)
    eqtr2d $p |- ( ph -> C = A ) $=
      ( eqtrd eqcomd ) ABDABCDEFGH $.
  $}

  ${
    eqtr3d.1 $e |- ( ph -> A = B ) $.
    eqtr3d.2 $e |- ( ph -> A = C ) $.
    $( An equality transitivity equality deduction.  (Contributed by NM,
       18-Jul-1995.) $)
    eqtr3d $p |- ( ph -> B = C ) $=
      ( eqcomd eqtrd ) ACBDABCEGFH $.
  $}

  ${
    eqtr4d.1 $e |- ( ph -> A = B ) $.
    eqtr4d.2 $e |- ( ph -> C = B ) $.
    $( An equality transitivity equality deduction.  (Contributed by NM,
       18-Jul-1995.) $)
    eqtr4d $p |- ( ph -> A = C ) $=
      ( eqcomd eqtrd ) ABCDEADCFGH $.
  $}

  ${
    3eqtrd.1 $e |- ( ph -> A = B ) $.
    3eqtrd.2 $e |- ( ph -> B = C ) $.
    3eqtrd.3 $e |- ( ph -> C = D ) $.
    $( A deduction from three chained equalities.  (Contributed by NM,
       29-Oct-1995.) $)
    3eqtrd $p |- ( ph -> A = D ) $=
      ( eqtrd ) ABCEFACDEGHII $.

    $( A deduction from three chained equalities.  (Contributed by NM,
       4-Aug-2006.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtrrd $p |- ( ph -> D = A ) $=
      ( eqtrd eqtr2d ) ABDEABCDFGIHJ $.
  $}

  ${
    3eqtr2d.1 $e |- ( ph -> A = B ) $.
    3eqtr2d.2 $e |- ( ph -> C = B ) $.
    3eqtr2d.3 $e |- ( ph -> C = D ) $.
    $( A deduction from three chained equalities.  (Contributed by NM,
       4-Aug-2006.) $)
    3eqtr2d $p |- ( ph -> A = D ) $=
      ( eqtr4d eqtrd ) ABDEABCDFGIHJ $.

    $( A deduction from three chained equalities.  (Contributed by NM,
       4-Aug-2006.) $)
    3eqtr2rd $p |- ( ph -> D = A ) $=
      ( eqtr4d eqtr2d ) ABDEABCDFGIHJ $.
  $}

  ${
    3eqtr3d.1 $e |- ( ph -> A = B ) $.
    3eqtr3d.2 $e |- ( ph -> A = C ) $.
    3eqtr3d.3 $e |- ( ph -> B = D ) $.
    $( A deduction from three chained equalities.  (Contributed by NM,
       4-Aug-1995.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtr3d $p |- ( ph -> C = D ) $=
      ( eqtr3d ) ACDEABCDFGIHI $.

    $( A deduction from three chained equalities.  (Contributed by NM,
       14-Jan-2006.) $)
    3eqtr3rd $p |- ( ph -> D = C ) $=
      ( eqtr3d ) ACEDHABCDFGII $.
  $}

  ${
    3eqtr4d.1 $e |- ( ph -> A = B ) $.
    3eqtr4d.2 $e |- ( ph -> C = A ) $.
    3eqtr4d.3 $e |- ( ph -> D = B ) $.
    $( A deduction from three chained equalities.  (Contributed by NM,
       4-Aug-1995.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    3eqtr4d $p |- ( ph -> C = D ) $=
      ( eqtr4d ) ADBEGAECBHFII $.

    $( A deduction from three chained equalities.  (Contributed by NM,
       21-Sep-1995.) $)
    3eqtr4rd $p |- ( ph -> D = C ) $=
      ( eqtr4d ) AEBDAECBHFIGI $.
  $}

  ${
    syl5eq.1 $e |- A = B $.
    syl5eq.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM, 5-Aug-1993.) $)
    syl5eq $p |- ( ph -> A = C ) $=
      ( wceq a1i eqtrd ) ABCDBCGAEHFI $.
  $}

  ${
    syl5req.1 $e |- A = B $.
    syl5req.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM,
       29-Mar-1998.) $)
    syl5req $p |- ( ph -> C = A ) $=
      ( syl5eq eqcomd ) ABDABCDEFGH $.
  $}

  ${
    syl5eqr.1 $e |- B = A $.
    syl5eqr.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM, 5-Aug-1993.) $)
    syl5eqr $p |- ( ph -> A = C ) $=
      ( eqcomi syl5eq ) ABCDCBEGFH $.
  $}

  ${
    syl5reqr.1 $e |- B = A $.
    syl5reqr.2 $e |- ( ph -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM,
       29-Mar-1998.) $)
    syl5reqr $p |- ( ph -> C = A ) $=
      ( eqcomi syl5req ) ABCDCBEGFH $.
  $}

  ${
    syl6eq.1 $e |- ( ph -> A = B ) $.
    syl6eq.2 $e |- B = C $.
    $( An equality transitivity deduction.  (Contributed by NM, 5-Aug-1993.) $)
    syl6eq $p |- ( ph -> A = C ) $=
      ( wceq a1i eqtrd ) ABCDECDGAFHI $.
  $}

  ${
    syl6req.1 $e |- ( ph -> A = B ) $.
    syl6req.2 $e |- B = C $.
    $( An equality transitivity deduction.  (Contributed by NM,
       29-Mar-1998.) $)
    syl6req $p |- ( ph -> C = A ) $=
      ( syl6eq eqcomd ) ABDABCDEFGH $.
  $}

  ${
    syl6eqr.1 $e |- ( ph -> A = B ) $.
    syl6eqr.2 $e |- C = B $.
    $( An equality transitivity deduction.  (Contributed by NM, 5-Aug-1993.) $)
    syl6eqr $p |- ( ph -> A = C ) $=
      ( eqcomi syl6eq ) ABCDEDCFGH $.
  $}

  ${
    syl6reqr.1 $e |- ( ph -> A = B ) $.
    syl6reqr.2 $e |- C = B $.
    $( An equality transitivity deduction.  (Contributed by NM,
       29-Mar-1998.) $)
    syl6reqr $p |- ( ph -> C = A ) $=
      ( eqcomi syl6req ) ABCDEDCFGH $.
  $}

  ${
    sylan9eq.1 $e |- ( ph -> A = B ) $.
    sylan9eq.2 $e |- ( ps -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM, 8-May-1994.)
       (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    sylan9eq $p |- ( ( ph /\ ps ) -> A = C ) $=
      ( wceq eqtr syl2an ) ACDHDEHCEHBFGCDEIJ $.
  $}

  ${
    sylan9req.1 $e |- ( ph -> B = A ) $.
    sylan9req.2 $e |- ( ps -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM,
       23-Jun-2007.) $)
    sylan9req $p |- ( ( ph /\ ps ) -> A = C ) $=
      ( eqcomd sylan9eq ) ABCDEADCFHGI $.
  $}

  ${
    sylan9eqr.1 $e |- ( ph -> A = B ) $.
    sylan9eqr.2 $e |- ( ps -> B = C ) $.
    $( An equality transitivity deduction.  (Contributed by NM, 8-May-1994.) $)
    sylan9eqr $p |- ( ( ps /\ ph ) -> A = C ) $=
      ( wceq sylan9eq ancoms ) ABCEHABCDEFGIJ $.
  $}

  ${
    3eqtr3g.1 $e |- ( ph -> A = B ) $.
    3eqtr3g.2 $e |- A = C $.
    3eqtr3g.3 $e |- B = D $.
    $( A chained equality inference, useful for converting from definitions.
       (Contributed by NM, 15-Nov-1994.) $)
    3eqtr3g $p |- ( ph -> C = D ) $=
      ( syl5eqr syl6eq ) ADCEADBCGFIHJ $.
  $}

  ${
    3eqtr3a.1 $e |- A = B $.
    3eqtr3a.2 $e |- ( ph -> A = C ) $.
    3eqtr3a.3 $e |- ( ph -> B = D ) $.
    $( A chained equality inference, useful for converting from definitions.
       (Contributed by Mario Carneiro, 6-Nov-2015.) $)
    3eqtr3a $p |- ( ph -> C = D ) $=
      ( syl5eq eqtr3d ) ABDEGABCEFHIJ $.
  $}

  ${
    3eqtr4g.1 $e |- ( ph -> A = B ) $.
    3eqtr4g.2 $e |- C = A $.
    3eqtr4g.3 $e |- D = B $.
    $( A chained equality inference, useful for converting to definitions.
       (Contributed by NM, 5-Aug-1993.) $)
    3eqtr4g $p |- ( ph -> C = D ) $=
      ( syl5eq syl6eqr ) ADCEADBCGFIHJ $.
  $}

  ${
    3eqtr4a.1 $e |- A = B $.
    3eqtr4a.2 $e |- ( ph -> C = A ) $.
    3eqtr4a.3 $e |- ( ph -> D = B ) $.
    $( A chained equality inference, useful for converting to definitions.
       (Contributed by NM, 2-Feb-2007.)  (Proof shortened by Andrew Salmon,
       25-May-2011.) $)
    3eqtr4a $p |- ( ph -> C = D ) $=
      ( syl6eq eqtr4d ) ADCEADBCGFIHJ $.
  $}

  ${
    eq2tr.1 $e |- ( A = C -> D = F ) $.
    eq2tr.2 $e |- ( B = D -> C = G ) $.
    $( A compound transitive inference for class equality.  (Contributed by NM,
       22-Jan-2004.) $)
    eq2tri $p |- ( ( A = C /\ B = F ) <-> ( B = D /\ A = G ) ) $=
      ( wceq wa ancom eqeq2d pm5.32i 3bitr3i ) ACIZBDIZJPOJOBEIZJPAFIZJOPKOPQOD
      EBGLMPORPCFAHLMN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality implies equivalence of membership.  (Contributed by NM,
       5-Aug-1993.) $)
    eleq1 $p |- ( A = B -> ( A e. C <-> B e. C ) ) $=
      ( vx wceq cv wcel wa wex eqeq2 anbi1d exbidv df-clel 3bitr4g ) ABEZDFZAEZ
      PCGZHZDIPBEZRHZDIACGBCGOSUADOQTRABPJKLDACMDBCMN $.

    $( Equality implies equivalence of membership.  (Contributed by NM,
       5-Aug-1993.) $)
    eleq2 $p |- ( A = B -> ( C e. A <-> C e. B ) ) $=
      ( vx wceq cv wcel wa wex wal dfcleq biimpi 19.21bi anbi2d df-clel 3bitr4g
      wb exbidv ) ABEZDFZCEZTAGZHZDIUATBGZHZDICAGCBGSUCUEDSUBUDUASUBUDQZDSUFDJD
      ABKLMNRDCAODCBOP $.
  $}

  $( Equality implies equivalence of membership.  (Contributed by NM,
     31-May-1999.) $)
  eleq12 $p |- ( ( A = B /\ C = D ) -> ( A e. C <-> B e. D ) ) $=
    ( wceq wcel eleq1 eleq2 sylan9bb ) ABEACFBCFCDEBDFABCGCDBHI $.

  ${
    eleq1i.1 $e |- A = B $.
    $( Inference from equality to equivalence of membership.  (Contributed by
       NM, 5-Aug-1993.) $)
    eleq1i $p |- ( A e. C <-> B e. C ) $=
      ( wceq wcel wb eleq1 ax-mp ) ABEACFBCFGDABCHI $.

    $( Inference from equality to equivalence of membership.  (Contributed by
       NM, 5-Aug-1993.) $)
    eleq2i $p |- ( C e. A <-> C e. B ) $=
      ( wceq wcel wb eleq2 ax-mp ) ABECAFCBFGDABCHI $.

    ${
      eleq12i.2 $e |- C = D $.
      $( Inference from equality to equivalence of membership.  (Contributed by
         NM, 31-May-1994.) $)
      eleq12i $p |- ( A e. C <-> B e. D ) $=
        ( wcel eleq2i eleq1i bitri ) ACGADGBDGCDAFHABDEIJ $.

      $( Theorem eleq12i is the congruence law for elementhood. $)
      $( $j congruence 'eleq12i'; $)
    $}
  $}

  ${
    eleq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction from equality to equivalence of membership.  (Contributed by
       NM, 5-Aug-1993.) $)
    eleq1d $p |- ( ph -> ( A e. C <-> B e. C ) ) $=
      ( wceq wcel wb eleq1 syl ) ABCFBDGCDGHEBCDIJ $.

    $( Deduction from equality to equivalence of membership.  (Contributed by
       NM, 27-Dec-1993.) $)
    eleq2d $p |- ( ph -> ( C e. A <-> C e. B ) ) $=
      ( wceq wcel wb eleq2 syl ) ABCFDBGDCGHEBCDIJ $.

    ${
      eleq12d.2 $e |- ( ph -> C = D ) $.
      $( Deduction from equality to equivalence of membership.  (Contributed by
         NM, 31-May-1994.) $)
      eleq12d $p |- ( ph -> ( A e. C <-> B e. D ) ) $=
        ( wcel eleq2d eleq1d bitrd ) ABDHBEHCEHADEBGIABCEFJK $.
    $}
  $}

  $( A transitive-type law relating membership and equality.  (Contributed by
     NM, 9-Apr-1994.) $)
  eleq1a $p |- ( A e. B -> ( C = A -> C e. B ) ) $=
    ( wceq wcel eleq1 biimprcd ) CADCBEABECABFG $.

  ${
    eqeltr.1 $e |- A = B $.
    eqeltr.2 $e |- B e. C $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    eqeltri $p |- A e. C $=
      ( wcel eleq1i mpbir ) ACFBCFEABCDGH $.
  $}

  ${
    eqeltrr.1 $e |- A = B $.
    eqeltrr.2 $e |- A e. C $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    eqeltrri $p |- B e. C $=
      ( eqcomi eqeltri ) BACABDFEG $.
  $}

  ${
    eleqtr.1 $e |- A e. B $.
    eleqtr.2 $e |- B = C $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    eleqtri $p |- A e. C $=
      ( wcel eleq2i mpbi ) ABFACFDBCAEGH $.
  $}

  ${
    eleqtrr.1 $e |- A e. B $.
    eleqtrr.2 $e |- C = B $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    eleqtrri $p |- A e. C $=
      ( eqcomi eleqtri ) ABCDCBEFG $.
  $}

  ${
    eqeltrd.1 $e |- ( ph -> A = B ) $.
    eqeltrd.2 $e |- ( ph -> B e. C ) $.
    $( Substitution of equal classes into membership relation, deduction form.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    eqeltrd $p |- ( ph -> A e. C ) $=
      ( wcel eleq1d mpbird ) ABDGCDGFABCDEHI $.
  $}

  ${
    eqeltrrd.1 $e |- ( ph -> A = B ) $.
    eqeltrrd.2 $e |- ( ph -> A e. C ) $.
    $( Deduction that substitutes equal classes into membership.  (Contributed
       by NM, 14-Dec-2004.) $)
    eqeltrrd $p |- ( ph -> B e. C ) $=
      ( eqcomd eqeltrd ) ACBDABCEGFH $.
  $}

  ${
    eleqtrd.1 $e |- ( ph -> A e. B ) $.
    eleqtrd.2 $e |- ( ph -> B = C ) $.
    $( Deduction that substitutes equal classes into membership.  (Contributed
       by NM, 14-Dec-2004.) $)
    eleqtrd $p |- ( ph -> A e. C ) $=
      ( wcel eleq2d mpbid ) ABCGBDGEACDBFHI $.
  $}

  ${
    eleqtrrd.1 $e |- ( ph -> A e. B ) $.
    eleqtrrd.2 $e |- ( ph -> C = B ) $.
    $( Deduction that substitutes equal classes into membership.  (Contributed
       by NM, 14-Dec-2004.) $)
    eleqtrrd $p |- ( ph -> A e. C ) $=
      ( eqcomd eleqtrd ) ABCDEADCFGH $.
  $}

  ${
    3eltr3.1 $e |- A e. B $.
    3eltr3.2 $e |- A = C $.
    3eltr3.3 $e |- B = D $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    3eltr3i $p |- C e. D $=
      ( eleqtri eqeltrri ) ACDFABDEGHI $.
  $}

  ${
    3eltr4.1 $e |- A e. B $.
    3eltr4.2 $e |- C = A $.
    3eltr4.3 $e |- D = B $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    3eltr4i $p |- C e. D $=
      ( eleqtrri eqeltri ) CADFABDEGHI $.
  $}

  ${
    3eltr3d.1 $e |- ( ph -> A e. B ) $.
    3eltr3d.2 $e |- ( ph -> A = C ) $.
    3eltr3d.3 $e |- ( ph -> B = D ) $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    3eltr3d $p |- ( ph -> C e. D ) $=
      ( eleqtrd eqeltrrd ) ABDEGABCEFHIJ $.
  $}

  ${
    3eltr4d.1 $e |- ( ph -> A e. B ) $.
    3eltr4d.2 $e |- ( ph -> C = A ) $.
    3eltr4d.3 $e |- ( ph -> D = B ) $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    3eltr4d $p |- ( ph -> C e. D ) $=
      ( eleqtrrd eqeltrd ) ADBEGABCEFHIJ $.
  $}

  ${
    3eltr3g.1 $e |- ( ph -> A e. B ) $.
    3eltr3g.2 $e |- A = C $.
    3eltr3g.3 $e |- B = D $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    3eltr3g $p |- ( ph -> C e. D ) $=
      ( wcel eleq12i sylib ) ABCIDEIFBDCEGHJK $.
  $}

  ${
    3eltr4g.1 $e |- ( ph -> A e. B ) $.
    3eltr4g.2 $e |- C = A $.
    3eltr4g.3 $e |- D = B $.
    $( Substitution of equal classes into membership relation.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    3eltr4g $p |- ( ph -> C e. D ) $=
      ( wcel eleq12i sylibr ) ABCIDEIFDBECGHJK $.
  $}

  ${
    syl5eqel.1 $e |- A = B $.
    syl5eqel.2 $e |- ( ph -> B e. C ) $.
    $( B membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl5eqel $p |- ( ph -> A e. C ) $=
      ( wceq a1i eqeltrd ) ABCDBCGAEHFI $.
  $}

  ${
    syl5eqelr.1 $e |- B = A $.
    syl5eqelr.2 $e |- ( ph -> B e. C ) $.
    $( B membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl5eqelr $p |- ( ph -> A e. C ) $=
      ( eqcomi syl5eqel ) ABCDCBEGFH $.
  $}

  ${
    syl5eleq.1 $e |- A e. B $.
    syl5eleq.2 $e |- ( ph -> B = C ) $.
    $( B membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl5eleq $p |- ( ph -> A e. C ) $=
      ( wcel a1i eleqtrd ) ABCDBCGAEHFI $.
  $}

  ${
    syl5eleqr.1 $e |- A e. B $.
    syl5eleqr.2 $e |- ( ph -> C = B ) $.
    $( B membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl5eleqr $p |- ( ph -> A e. C ) $=
      ( eqcomd syl5eleq ) ABCDEADCFGH $.
  $}

  ${
    syl6eqel.1 $e |- ( ph -> A = B ) $.
    syl6eqel.2 $e |- B e. C $.
    $( A membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl6eqel $p |- ( ph -> A e. C ) $=
      ( wcel a1i eqeltrd ) ABCDECDGAFHI $.
  $}

  ${
    syl6eqelr.1 $e |- ( ph -> B = A ) $.
    syl6eqelr.2 $e |- B e. C $.
    $( A membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl6eqelr $p |- ( ph -> A e. C ) $=
      ( eqcomd syl6eqel ) ABCDACBEGFH $.
  $}

  ${
    syl6eleq.1 $e |- ( ph -> A e. B ) $.
    syl6eleq.2 $e |- B = C $.
    $( A membership and equality inference.  (Contributed by NM,
       4-Jan-2006.) $)
    syl6eleq $p |- ( ph -> A e. C ) $=
      ( wceq a1i eleqtrd ) ABCDECDGAFHI $.
  $}

  ${
    syl6eleqr.1 $e |- ( ph -> A e. B ) $.
    syl6eleqr.2 $e |- C = B $.
    $( A membership and equality inference.  (Contributed by NM,
       24-Apr-2005.) $)
    syl6eleqr $p |- ( ph -> A e. C ) $=
      ( eqcomi syl6eleq ) ABCDEDCFGH $.
  $}

  ${
    eleq2s.1 $e |- ( A e. B -> ph ) $.
    eleq2s.2 $e |- C = B $.
    $( Substitution of equal classes into a membership antecedent.
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.) $)
    eleq2s $p |- ( A e. C -> ph ) $=
      ( wcel eleq2i sylbi ) BDGBCGADCBFHEI $.
  $}

  ${
    eqneltrd.1 $e |- ( ph -> A = B ) $.
    eqneltrd.2 $e |- ( ph -> -. B e. C ) $.
    $( If a class is not an element of another class, an equal class is also
       not an element.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    eqneltrd $p |- ( ph -> -. A e. C ) $=
      ( wcel eleq1d mtbird ) ABDGCDGFABCDEHI $.
  $}

  ${
    eqneltrrd.1 $e |- ( ph -> A = B ) $.
    eqneltrrd.2 $e |- ( ph -> -. A e. C ) $.
    $( If a class is not an element of another class, an equal class is also
       not an element.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    eqneltrrd $p |- ( ph -> -. B e. C ) $=
      ( wcel eleq1d mtbid ) ABDGCDGFABCDEHI $.
  $}

  ${
    neleqtrd.1 $e |- ( ph -> -. C e. A ) $.
    neleqtrd.2 $e |- ( ph -> A = B ) $.
    $( If a class is not an element of another class, it is also not an element
       of an equal class.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    neleqtrd $p |- ( ph -> -. C e. B ) $=
      ( wcel eleq2d mtbid ) ADBGDCGEABCDFHI $.
  $}

  ${
    neleqtrrd.1 $e |- ( ph -> -. C e. B ) $.
    neleqtrrd.2 $e |- ( ph -> A = B ) $.
    $( If a class is not an element of another class, it is also not an element
       of an equal class.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    neleqtrrd $p |- ( ph -> -. C e. A ) $=
      ( wcel eleq2d mtbird ) ADBGDCGEABCDFHI $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    cleqh.1 $e |- ( y e. A -> A. x y e. A ) $.
    cleqh.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( Establish equality between classes, using bound-variable hypotheses
       instead of distinct variable conditions.  (Contributed by NM,
       5-Aug-1993.) $)
    cleqh $p |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $=
      ( wceq cv wcel wb wal dfcleq ax-17 wi wa dfbi2 hbim weq eleq1 cbv3h hban
      hbxfrbi bibi12d biimpd equcoms biimprd impbii bitr4i ) CDGBHZCIZUIDIZJZBK
      ZAHZCIZUNDIZJZAKZBCDLURUMUQULABUQBMZULUJUKNZUKUJNZOAUJUKPUTVAAUJUKAEFQUKU
      JAFEQUAUBZABRZUQULVCUOUJUPUKUNUICSUNUIDSUCZUDTULUQBAVBUSBARUQULUQULJABVDU
      EUFTUGUH $.
  $}

  $( A way of showing two classes are not equal.  (Contributed by NM,
     1-Apr-1997.) $)
  nelneq $p |- ( ( A e. C /\ -. B e. C ) -> -. A = B ) $=
    ( wcel wceq eleq1 biimpcd con3and ) ACDZABEZBCDZJIKABCFGH $.

  $( A way of showing two classes are not equal.  (Contributed by NM,
     12-Jan-2002.) $)
  nelneq2 $p |- ( ( A e. B /\ -. A e. C ) -> -. B = C ) $=
    ( wcel wceq eleq2 biimpcd con3and ) ABDZBCEZACDZJIKBCAFGH $.

  ${
    $d x y $.  $d y A $.
    $( Lemma for ~ eqsb3 .  (Contributed by Rodolfo Medina, 28-Apr-2010.)
       (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
    eqsb3lem $p |- ( [ x / y ] y = A <-> x = A ) $=
      ( cv wceq nfv eqeq1 sbie ) BDZCEADZCEZBAKBFIJCGH $.
  $}

  ${
    $d y A $.  $d w y $.  $d w A $.  $d x w $.
    $( Substitution applied to an atomic wff (class version of ~ equsb3 ).
       (Contributed by Rodolfo Medina, 28-Apr-2010.) $)
    eqsb3 $p |- ( [ x / y ] y = A <-> x = A ) $=
      ( vw cv wceq wsb eqsb3lem sbbii nfv sbco2 3bitr3i ) BECFZBDGZDAGDECFZDAGM
      BAGAECFNODADBCHIMBADMDJKADCHL $.
  $}

  ${
    $d y A $.  $d w y $.  $d w A $.  $d w x $.
    $( Substitution applied to an atomic wff (class version of ~ elsb3 ).
       (Contributed by Rodolfo Medina, 28-Apr-2010.)  (Proof shortened by
       Andrew Salmon, 14-Jun-2011.) $)
    clelsb3 $p |- ( [ x / y ] y e. A <-> x e. A ) $=
      ( vw cv wcel wsb nfv sbco2 eleq1 sbie sbbii 3bitr3i ) DEZCFZDBGZBAGODAGBE
      ZCFZBAGAEZCFZODABOBHIPRBAORDBRDHNQCJKLOTDATDHNSCJKM $.
  $}

  ${
    hbxfr.1 $e |- A = B $.
    hbxfr.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( A utility lemma to transfer a bound-variable hypothesis builder into a
       definition.  See ~ hbxfrbi for equivalence version.  (Contributed by NM,
       21-Aug-2007.) $)
    hbxfreq $p |- ( y e. A -> A. x y e. A ) $=
      ( cv wcel eleq2i hbxfrbi ) BGZCHKDHACDKEIFJ $.
  $}

  ${
    $d w y A $.  $d w x z $.
    hblem.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( Change the free variable of a hypothesis builder.  Lemma for ~ nfcrii .
       (Contributed by NM, 5-Aug-1993.)  (Revised by Andrew Salmon,
       11-Jul-2011.) $)
    hblem $p |- ( z e. A -> A. x z e. A ) $=
      ( cv wcel wsb wal hbsb clelsb3 albii 3imtr3i ) BFDGZBCHZOAICFDGZPAINBCAEJ
      CBDKZOPAQLM $.
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Equality of a class variable and a class abstraction (also called a
       class builder).  Theorem 5.1 of [Quine] p. 34.  This theorem shows the
       relationship between expressions with class abstractions and expressions
       with class variables.  Note that ~ abbi and its relatives are among
       those useful for converting theorems with class variables to equivalent
       theorems with wff variables, by first substituting a class abstraction
       for each class variable.

       Class variables can always be eliminated from a theorem to result in an
       equivalent theorem with wff variables, and vice-versa.  The idea is
       roughly as follows.  To convert a theorem with a wff variable ` ph `
       (that has a free variable ` x ` ) to a theorem with a class variable
       ` A ` , we substitute ` x e. A ` for ` ph ` throughout and simplify,
       where ` A ` is a new class variable not already in the wff.  An example
       is the conversion of ~ zfauscl to ~ inex1 (look at the instance of
       ~ zfauscl that occurs in the proof of ~ inex1 ).  Conversely, to convert
       a theorem with a class variable ` A ` to one with ` ph ` , we substitute
       ` { x | ph } ` for ` A ` throughout and simplify, where ` x ` and ` ph `
       are new set and wff variables not already in the wff.  An example is
       ~ cp , which derives a formula containing wff variables from
       substitution instances of the class variables in its equivalent
       formulation ~ cplem2 .  For more information on class variables, see
       Quine pp. 15-21 and/or Takeuti and Zaring pp. 10-13.  (Contributed by
       NM, 5-Aug-1993.) $)
    abeq2 $p |- ( A = { x | ph } <-> A. x ( x e. A <-> ph ) ) $=
      ( vy cab wceq cv wcel wb wal ax-17 hbab1 cleqh abid bibi2i albii bitri )
      CABEZFBGZCHZSRHZIZBJTAIZBJBDCRDGCHBKABDLMUBUCBUAATABNOPQ $.
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Equality of a class variable and a class abstraction.  (Contributed by
       NM, 20-Aug-1993.) $)
    abeq1 $p |- ( { x | ph } = A <-> A. x ( ph <-> x e. A ) ) $=
      ( cab wceq cv wcel wb wal abeq2 eqcom bicom albii 3bitr4i ) CABDZEBFCGZAH
      ZBIOCEAPHZBIABCJOCKRQBAPLMN $.
  $}

  ${
    abeqi.1 $e |- A = { x | ph } $.
    $( Equality of a class variable and a class abstraction (inference rule).
       (Contributed by NM, 3-Apr-1996.) $)
    abeq2i $p |- ( x e. A <-> ph ) $=
      ( cv wcel cab eleq2i abid bitri ) BEZCFKABGZFACLKDHABIJ $.
  $}

  ${
    abeqri.1 $e |- { x | ph } = A $.
    $( Equality of a class variable and a class abstraction (inference rule).
       (Contributed by NM, 31-Jul-1994.) $)
    abeq1i $p |- ( ph <-> x e. A ) $=
      ( cv cab wcel abid eleq2i bitr3i ) ABEZABFZGKCGABHLCKDIJ $.
  $}

  ${
    abeqd.1 $e |- ( ph -> A = { x | ps } ) $.
    $( Equality of a class variable and a class abstraction (deduction).
       (Contributed by NM, 16-Nov-1995.) $)
    abeq2d $p |- ( ph -> ( x e. A <-> ps ) ) $=
      ( cv wcel cab eleq2d abid syl6bb ) ACFZDGLBCHZGBADMLEIBCJK $.
  $}

  ${
    $d ph y $.  $d ps y $.  $d x y $.
    $( Equivalent wff's correspond to equal class abstractions.  (Contributed
       by NM, 25-Nov-2013.)  (Revised by Mario Carneiro, 11-Aug-2016.) $)
    abbi $p |- ( A. x ( ph <-> ps ) <-> { x | ph } = { x | ps } ) $=
      ( vy cab wceq wcel wal dfcleq nfsab1 nfbi nfv wsb df-clab sbequ12r syl5bb
      cv wb bibi12d cbval bitr2i ) ACEZBCEZFDQZUBGZUDUCGZRZDHABRZCHDUBUCIUGUHDC
      UEUFCACDJBCDJKUHDLUDCQFZUEAUFBUEACDMUIAADCNADCOPUFBCDMUIBBDCNBDCOPSTUA $.
  $}

  ${
    $d x A $.
    abbiri.1 $e |- ( x e. A <-> ph ) $.
    $( Equality of a class variable and a class abstraction (inference rule).
       (Contributed by NM, 5-Aug-1993.) $)
    abbi2i $p |- A = { x | ph } $=
      ( cab wceq cv wcel wb abeq2 mpgbir ) CABEFBGCHAIBABCJDK $.
  $}

  ${
    abbii.1 $e |- ( ph <-> ps ) $.
    $( Equivalent wff's yield equal class abstractions (inference rule).
       (Contributed by NM, 5-Aug-1993.) $)
    abbii $p |- { x | ph } = { x | ps } $=
      ( wb cab wceq abbi mpgbi ) ABEACFBCFGCABCHDI $.

    $( Theorem abbii is the congruence law for class abstraction. $)
    $( $j congruence 'abbii'; $)
  $}

  ${
    $d x y $.  $d ph y $.  $d ps y $.  $d ch y $.  $( ` y ` is a dummy var. $)
    abbid.1 $e |- F/ x ph $.
    abbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal class abstractions (deduction rule).
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    abbid $p |- ( ph -> { x | ps } = { x | ch } ) $=
      ( wb wal cab wceq alrimi abbi sylib ) ABCGZDHBDICDIJANDEFKBCDLM $.
  $}

  ${
    $d x ph $.
    abbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal class abstractions (deduction rule).
       (Contributed by NM, 10-Aug-1993.) $)
    abbidv $p |- ( ph -> { x | ps } = { x | ch } ) $=
      ( nfv abbid ) ABCDADFEG $.
  $}

  ${
    $d x y A $.  $d ph x y $.  $d ps y $.  $( ` y ` is a dummy var. $)
    abbirdv.1 $e |- ( ph -> ( x e. A <-> ps ) ) $.
    $( Deduction from a wff to a class abstraction.  (Contributed by NM,
       9-Jul-1994.) $)
    abbi2dv $p |- ( ph -> A = { x | ps } ) $=
      ( cv wcel wb wal cab wceq alrimiv abeq2 sylibr ) ACFDGBHZCIDBCJKAOCELBCDM
      N $.
  $}

  ${
    $d x y A $.  $d ph x y $.  $d ps y $.  $( ` y ` is a dummy var. $)
    abbildv.1 $e |- ( ph -> ( ps <-> x e. A ) ) $.
    $( Deduction from a wff to a class abstraction.  (Contributed by NM,
       9-Jul-1994.) $)
    abbi1dv $p |- ( ph -> { x | ps } = A ) $=
      ( cv wcel wb wal cab wceq alrimiv abeq1 sylibr ) ABCFDGHZCIBCJDKAOCELBCDM
      N $.
  $}

  ${
    $d x A $.
    $( A simplification of class abstraction.  Theorem 5.2 of [Quine] p. 35.
       (Contributed by NM, 26-Dec-1993.) $)
    abid2 $p |- { x | x e. A } = A $=
      ( cv wcel cab biid abbi2i eqcomi ) BACBDZAEIABIFGH $.
  $}

  ${
    $d x z $.  $d y z $.  $d ph z $.  $d ps z $.
    cbvab.1 $e |- F/ y ph $.
    cbvab.2 $e |- F/ x ps $.
    cbvab.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by Andrew Salmon, 11-Jul-2011.) $)
    cbvab $p |- { x | ph } = { y | ps } $=
      ( vz cab wsb cv wcel nfsb weq wb equcoms bicomd sbie sbequ df-clab eqriv
      syl5bbr 3bitr4i ) HACIZBDIZACHJBDHJZHKZUDLUGUELAUFCHBDHCFMABDCJCHNUFBADCE
      DCNABABOCDGPQRBCHDSUBRAHCTBHDTUCUA $.
  $}

  ${
    $d y ph $.  $d x ps $.
    cbvabv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 26-May-1999.) $)
    cbvabv $p |- { x | ph } = { y | ps } $=
      ( nfv cbvab ) ABCDADFBCFEG $.
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Membership of a class variable in a class abstraction.  (Contributed by
       NM, 23-Dec-1993.) $)
    clelab $p |- ( A e. { x | ph } <-> E. x ( x = A /\ ph ) ) $=
      ( vy cv wceq cab wcel wex wsb df-clab anbi2i exbii df-clel nfv nfs1v nfan
      wa eqeq1 sbequ12 anbi12d cbvex 3bitr4i ) DEZCFZUDABGZHZRZDIUEABDJZRZDICUF
      HBEZCFZARZBIUHUJDUGUIUEADBKLMDCUFNUMUJBDUMDOUEUIBUEBOABDPQUKUDFULUEAUIUKU
      DCSABDTUAUBUC $.
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( Membership of a class abstraction in another class.  (Contributed by NM,
       17-Jan-2006.) $)
    clabel $p |- ( { x | ph } e. A <->
                 E. y ( y e. A /\ A. x ( x e. y <-> ph ) ) ) $=
      ( cab wcel cv wceq wa wex wb wal df-clel abeq2 anbi2ci exbii bitri ) ABEZ
      DFCGZRHZSDFZIZCJUABGSFAKBLZIZCJCRDMUBUDCTUCUAABSNOPQ $.
  $}

  ${
    $d z A $.  $d z x $.  $d z y $.
    $( The right-hand side of the second equality is a way of representing
       proper substitution of ` y ` for ` x ` into a class variable.
       (Contributed by NM, 14-Sep-2003.) $)
    sbab $p |- ( x = y -> A = { z | [ y / x ] z e. A } ) $=
      ( weq cv wcel wsb sbequ12 abbi2dv ) ABECFDGZABHCDKABIJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Class form not-free predicate
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c F/_ $.  $( Underlined not-free symbol. $)

  $( Extend wff definition to include the not-free predicate for classes. $)
  wnfc $a wff F/_ x A $.

  ${
    $d x y z $.  $d y z A $.
    $( Justification theorem for ~ df-nfc .  (Contributed by Mario Carneiro,
       13-Oct-2016.) $)
    nfcjust $p |- ( A. y F/ x y e. A <-> A. z F/ x z e. A ) $=
      ( cv wcel wnf weq nfv eleq1 nfbidf cbvalv ) BEZDFZAGCEZDFZAGBCBCHZNPAQAIM
      ODJKL $.
  $}

  ${
    $d x y $.  $d y A $.
    $( Define the not-free predicate for classes.  This is read " ` x ` is not
       free in ` A ` ".  Not-free means that the value of ` x ` cannot affect
       the value of ` A ` , e.g., any occurrence of ` x ` in ` A ` is
       effectively bound by a "for all" or something that expands to one (such
       as "there exists").  It is defined in terms of the not-free predicate
       ~ df-nf for wffs; see that definition for more information.
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    df-nfc $a |- ( F/_ x A <-> A. y F/ x y e. A ) $.

    ${
      nfci.1 $e |- F/ x y e. A $.
      $( Deduce that a class ` A ` does not have ` x ` free in it.
         (Contributed by Mario Carneiro, 11-Aug-2016.) $)
      nfci $p |- F/_ x A $=
        ( wnfc cv wcel wnf df-nfc mpgbir ) ACEBFCGAHBABCIDJ $.
    $}

    ${
      nfcii.1 $e |- ( y e. A -> A. x y e. A ) $.
      $( Deduce that a class ` A ` does not have ` x ` free in it.
         (Contributed by Mario Carneiro, 11-Aug-2016.) $)
      nfcii $p |- F/_ x A $=
        ( cv wcel nfi nfci ) ABCBECFADGH $.
    $}

    $( Consequence of the not-free predicate.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfcr $p |- ( F/_ x A -> F/ x y e. A ) $=
      ( wnfc cv wcel wnf wal df-nfc sp sylbi ) ACDBECFAGZBHLABCILBJK $.
  $}

  ${
    $d x y z $.  $d z A $.
    nfcri.1 $e |- F/_ x A $.
    $( Consequence of the not-free predicate.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfcrii $p |- ( y e. A -> A. x y e. A ) $=
      ( vz cv wcel wnfc wnf nfcr ax-mp nfri hblem ) AEBCEFCGZAACHNAIDAECJKLM $.

    $( Consequence of the not-free predicate.  (Note that unlike ~ nfcr , this
       does not require ` y ` and ` A ` to be disjoint.)  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    nfcri $p |- F/ x y e. A $=
      ( cv wcel nfcrii nfi ) BECFAABCDGH $.
  $}

  ${
    $d x y $.  $d y A $.
    nfcd.1 $e |- F/ y ph $.
    nfcd.2 $e |- ( ph -> F/ x y e. A ) $.
    $( Deduce that a class ` A ` does not have ` x ` free in it.  (Contributed
       by Mario Carneiro, 11-Aug-2016.) $)
    nfcd $p |- ( ph -> F/_ x A ) $=
      ( cv wcel wnf wal wnfc alrimi df-nfc sylibr ) ACGDHBIZCJBDKAOCEFLBCDMN $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    nfceqi.1 $e |- A = B $.
    $( Equality theorem for class not-free.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfceqi $p |- ( F/_ x A <-> F/_ x B ) $=
      ( vy cv wcel wnf wal wnfc eleq2i nfbii albii df-nfc 3bitr4i ) EFZBGZAHZEI
      PCGZAHZEIABJACJRTEQSABCPDKLMAEBNAECNO $.

    ${
      nfcxfr.2 $e |- F/_ x B $.
      $( A utility lemma to transfer a bound-variable hypothesis builder into a
         definition.  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
      nfcxfr $p |- F/_ x A $=
        ( wnfc nfceqi mpbir ) ABFACFEABCDGH $.
    $}

    ${
      nfcxfrd.2 $e |- ( ph -> F/_ x B ) $.
      $( A utility lemma to transfer a bound-variable hypothesis builder into a
         definition.  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
      nfcxfrd $p |- ( ph -> F/_ x A ) $=
        ( wnfc nfceqi sylibr ) ABDGBCGFBCDEHI $.
    $}
  $}

  ${
    $d x y $.  $d A y $.  $d B y $.  $d ph y $.
    nfceqdf.1 $e |- F/ x ph $.
    nfceqdf.2 $e |- ( ph -> A = B ) $.
    $( An equality theorem for effectively not free.  (Contributed by Mario
       Carneiro, 14-Oct-2016.) $)
    nfceqdf $p |- ( ph -> ( F/_ x A <-> F/_ x B ) ) $=
      ( vy cv wcel wnf wal wnfc eleq2d nfbidf albidv df-nfc 3bitr4g ) AGHZCIZBJ
      ZGKRDIZBJZGKBCLBDLATUBGASUABEACDRFMNOBGCPBGDPQ $.
  $}

  ${
    $d x y A $.
    $( If ` x ` is disjoint from ` A ` , then ` x ` is not free in ` A ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfcv $p |- F/_ x A $=
      ( vy cv wcel nfv nfci ) ACBCDBEAFG $.

    $( If ` x ` is disjoint from ` A ` , then ` x ` is not free in ` A ` .
       (Contributed by Mario Carneiro, 7-Oct-2016.) $)
    nfcvd $p |- ( ph -> F/_ x A ) $=
      ( wnfc nfcv a1i ) BCDABCEF $.
  $}

  ${
    $d x y $.  $d y A $.  $d y ph $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 11-Aug-2016.) $)
    nfab1 $p |- F/_ x { x | ph } $=
      ( vy cab nfsab1 nfci ) BCABDABCEF $.

    $( ` x ` is bound in ` F/_ x A ` .  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfnfc1 $p |- F/ x F/_ x A $=
      ( vy wnfc cv wcel wnf wal df-nfc nfnf1 nfal nfxfr ) ABDCEBFZAGZCHAACBINAC
      MAJKL $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    nfab.1 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 11-Aug-2016.) $)
    nfab $p |- F/_ x { y | ph } $=
      ( vz cab nfsab nfci ) BEACFABCEDGH $.
  $}

  ${
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 14-Oct-2016.) $)
    nfaba1 $p |- F/_ x { y | A. x ph } $=
      ( wal nfa1 nfab ) ABDBCABEF $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z B $.
    nfnfc.1 $e |- F/_ x A $.
    $( Hypothesis builder for ` F/_ y A ` .  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfnfc $p |- F/ x F/_ y A $=
      ( vz wnfc cv wcel wnf wal df-nfc nfcri nfnf nfal nfxfr ) BCFEGCHZBIZEJABE
      CKQAEPABAECDLMNO $.

    nfeq.2 $e |- F/_ x B $.
    $( Hypothesis builder for equality.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfeq $p |- F/ x A = B $=
      ( vz wceq cv wcel wb wal dfcleq nfcri nfbi nfal nfxfr ) BCGFHZBIZQCIZJZFK
      AFBCLTAFRSAAFBDMAFCEMNOP $.

    $( Hypothesis builder for elementhood.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfel $p |- F/ x A e. B $=
      ( vz wcel cv wceq wa wex df-clel nfcv nfeq nfcri nfan nfex nfxfr ) BCGFHZ
      BIZSCGZJZFKAFBCLUBAFTUAAASBASMDNAFCEOPQR $.
  $}

  ${
    $d x B $.
    nfeq1.1 $e |- F/_ x A $.
    $( Hypothesis builder for equality, special case.  (Contributed by Mario
       Carneiro, 10-Oct-2016.) $)
    nfeq1 $p |- F/ x A = B $=
      ( nfcv nfeq ) ABCDACEF $.

    $( Hypothesis builder for elementhood, special case.  (Contributed by Mario
       Carneiro, 10-Oct-2016.) $)
    nfel1 $p |- F/ x A e. B $=
      ( nfcv nfel ) ABCDACEF $.
  $}

  ${
    $d x A $.
    nfeq2.1 $e |- F/_ x B $.
    $( Hypothesis builder for equality, special case.  (Contributed by Mario
       Carneiro, 10-Oct-2016.) $)
    nfeq2 $p |- F/ x A = B $=
      ( nfcv nfeq ) ABCABEDF $.

    $( Hypothesis builder for elementhood, special case.  (Contributed by Mario
       Carneiro, 10-Oct-2016.) $)
    nfel2 $p |- F/ x A e. B $=
      ( nfcv nfel ) ABCABEDF $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    nfeqd.1 $e |- ( ph -> F/_ x A ) $.
    $( Consequence of the not-free predicate.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfcrd $p |- ( ph -> F/ x y e. A ) $=
      ( wnfc cv wcel wnf nfcr syl ) ABDFCGDHBIEBCDJK $.

    $d y ph $.
    nfeqd.2 $e |- ( ph -> F/_ x B ) $.
    $( Hypothesis builder for equality.  (Contributed by Mario Carneiro,
       7-Oct-2016.) $)
    nfeqd $p |- ( ph -> F/ x A = B ) $=
      ( vy wceq cv wcel wb wal dfcleq nfv nfcrd nfbid nfald nfxfrd ) CDHGIZCJZS
      DJZKZGLABGCDMAUBBGAGNATUABABGCEOABGDFOPQR $.

    $( Hypothesis builder for elementhood.  (Contributed by Mario Carneiro,
       7-Oct-2016.) $)
    nfeld $p |- ( ph -> F/ x A e. B ) $=
      ( vy wcel cv wceq wa wex df-clel nfv nfcvd nfeqd nfcrd nfand nfexd nfxfrd
      ) CDHGIZCJZUADHZKZGLABGCDMAUDBGAGNAUBUCBABUACABUAOEPABGDFQRST $.
  $}

  ${
    $d w x $.  $d w y $.  $d w z $.  $d w A $.  $d w B $.
    drnfc1.1 $e |- ( A. x x = y -> A = B ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       (Contributed by Mario Carneiro, 8-Oct-2016.) $)
    drnfc1 $p |- ( A. x x = y -> ( F/_ x A <-> F/_ y B ) ) $=
      ( vw weq wal cv wcel wnf wnfc eleq2d drnf1 dral2 df-nfc 3bitr4g ) ABGAHZF
      IZCJZAKZFHSDJZBKZFHACLBDLUAUCABFTUBABRCDSEMNOAFCPBFDPQ $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       (Contributed by Mario Carneiro, 8-Oct-2016.) $)
    drnfc2 $p |- ( A. x x = y -> ( F/_ z A <-> F/_ z B ) ) $=
      ( vw weq wal cv wcel wnf wnfc eleq2d drnf2 dral2 df-nfc 3bitr4g ) ABHAIZG
      JZDKZCLZGITEKZCLZGICDMCEMUBUDABGUAUCABCSDETFNOPCGDQCGEQR $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.  $d z ps $.
    nfabd2.1 $e |- F/ y ph $.
    nfabd2.2 $e |- ( ( ph /\ -. A. x x = y ) -> F/ x ps ) $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 8-Oct-2016.) $)
    nfabd2 $p |- ( ph -> F/_ x { y | ps } ) $=
      ( vz weq wal cab wnfc wn wa nfv cv wcel wsb df-clab nfnae nfan nfsbd nfcd
      nfxfrd ex nfab1 eqidd drnfc1 mpbiri pm2.61d2 ) ACDHCIZCBDJZKZAUJLZULAUMMZ
      CGUKUNGNGOUKPBDGQUNCBGDRUNBDGCAUMDECDDSTFUAUCUBUDUJULDUKKBDUECDUKUKUJUKUF
      UGUHUI $.
  $}

  ${
    nfabd.1 $e |- F/ y ph $.
    nfabd.2 $e |- ( ph -> F/ x ps ) $.
    $( Bound-variable hypothesis builder for a class abstraction.  (Contributed
       by Mario Carneiro, 8-Oct-2016.) $)
    nfabd $p |- ( ph -> F/_ x { y | ps } ) $=
      ( wnf weq wal wn adantr nfabd2 ) ABCDEABCGCDHCIJFKL $.
  $}

  ${
    $d w x $.  $d w y $.  $d w z $.  $d w A $.  $d w B $.  $d w ph $.
    dvelimdc.1 $e |- F/ x ph $.
    dvelimdc.2 $e |- F/ z ph $.
    dvelimdc.3 $e |- ( ph -> F/_ x A ) $.
    dvelimdc.4 $e |- ( ph -> F/_ z B ) $.
    dvelimdc.5 $e |- ( ph -> ( z = y -> A = B ) ) $.
    $( Deduction form of ~ dvelimc .  (Contributed by Mario Carneiro,
       8-Oct-2016.) $)
    dvelimdc $p |- ( ph -> ( -. A. x x = y -> F/_ x B ) ) $=
      ( vw weq wal wn wnfc wa nfv wcel nfcrd cv wnf wceq wb eleq2 syl6 dvelimdf
      imp nfcd ex ) ABCMBNOZBFPAUKQZBLFULLRAUKLUAZFSZBUBAUMESZUNBCDGHABLEITADLF
      JTADCMEFUCUOUNUDKEFUMUEUFUGUHUIUJ $.
  $}

  ${
    dvelimc.1 $e |- F/_ x A $.
    dvelimc.2 $e |- F/_ z B $.
    dvelimc.3 $e |- ( z = y -> A = B ) $.
    $( Version of ~ dvelim for classes.  (Contributed by Mario Carneiro,
       8-Oct-2016.) $)
    dvelimc $p |- ( -. A. x x = y -> F/_ x B ) $=
      ( weq wal wn wnfc wi wtru nftru a1i wceq dvelimdc trud ) ABIAJKAELMNABCDE
      AOCOADLNFPCELNGPCBIDEQMNHPRS $.
  $}

  ${
    $d x z $.  $d y z $.
    $( If ` x ` and ` y ` are distinct, then ` x ` is not free in ` y ` .
       (Contributed by Mario Carneiro, 8-Oct-2016.) $)
    nfcvf $p |- ( -. A. x x = y -> F/_ x y ) $=
      ( vz cv nfcv weq id dvelimc ) ABCCDZBDZAIECJECBFGH $.

    $( If ` x ` and ` y ` are distinct, then ` y ` is not free in ` x ` .
       (Contributed by Mario Carneiro, 5-Dec-2016.) $)
    nfcvf2 $p |- ( -. A. x x = y -> F/_ y x ) $=
      ( cv wnfc nfcvf naecoms ) BACDBABAEF $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    cleqf.1 $e |- F/_ x A $.
    cleqf.2 $e |- F/_ x B $.
    $( Establish equality between classes, using bound-variable hypotheses
       instead of distinct variable conditions.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
    cleqf $p |- ( A = B <-> A. x ( x e. A <-> x e. B ) ) $=
      ( vy wceq cv wcel wb wal dfcleq nfv nfcri nfbi eleq1 bibi12d cbval bitr4i
      ) BCGFHZBIZTCIZJZFKAHZBIZUDCIZJZAKFBCLUGUCAFUGFMUAUBAAFBDNAFCENOUDTGUEUAU
      FUBUDTBPUDTCPQRS $.
  $}

  ${
    $d y A $.  $d x y $.
    abid2f.1 $e |- F/_ x A $.
    $( A simplification of class abstraction.  Theorem 5.2 of [Quine] p. 35.
       (Contributed by NM, 5-Sep-2011.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    abid2f $p |- { x | x e. A } = A $=
      ( cv wcel cab wceq wb wal nfab1 cleqf abid bibi2i albii bitri biid mpgbir
      eqcomi ) BADZBEZAFZBUAGZTTHZAUBTSUAEZHZAIUCAIABUACTAJKUEUCAUDTTTALMNOTPQR
      $.
  $}

  ${
    $d v A w $.  $d x z v u $.  $d y z v u $.  $d v ph $.
    sbabel.1 $e |- F/_ x A $.
    $( Theorem to move a substitution in and out of a class abstraction.
       (Contributed by NM, 27-Sep-2003.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    sbabel $p |- ( [ y / x ] { z | ph } e. A <-> { z | [ y / x ] ph } e. A ) $=
      ( vv cv cab wceq wcel wa wex wsb wb wal sbf abeq2 sbbii 3bitr4i sbex sban
      nfv sbrbis sbalv nfcri anbi12i bitri exbii df-clel ) GHZADIZJZUKEKZLZGMZB
      CNZUKABCNZDIZJZUNLZGMZULEKZBCNUSEKUQUOBCNZGMVBUOGBCUAVDVAGVDUMBCNZUNBCNZL
      VAUMUNBCUBVEUTVFUNDHUKKZAOZDPZBCNVGUROZDPVEUTVHVJBCDVGVGABCVGBCVGBUCQUDUE
      UMVIBCADUKRSURDUKRTUNBCBGEFUFQUGUHUIUHVCUPBCGULEUJSGUSEUJT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Negated equality and membership
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new connectives. $)
  $c =/= $. $( Not equal to (equal sign with slash through it). $)
  $c e/ $. $( Not an element of (epsilon with slash through it). $)

  $( Extend wff notation to include inequality. $)
  wne $a wff A =/= B $.

  $( Extend wff notation to include negated membership. $)
  wnel $a wff A e/ B $.

  $( Define inequality.  (Contributed by NM, 5-Aug-1993.) $)
  df-ne $a |- ( A =/= B <-> -. A = B ) $.

  $( Define negated membership.  (Contributed by NM, 7-Aug-1994.) $)
  df-nel $a |- ( A e/ B <-> -. A e. B ) $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Negated equality
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    neii.1 $e |- A =/= B $.
    $( Inference associated with ~ df-ne .  (Contributed by BJ, 7-Jul-2018.) $)
    neii $p |- -. A = B $=
      ( wne wceq wn df-ne mpbi ) ABDABEFCABGH $.
  $}

  ${
    neir.1 $e |- -. A = B $.
    $( Inference associated with ~ df-ne .  (Contributed by BJ, 7-Jul-2018.) $)
    neir $p |- A =/= B $=
      ( wne wceq wn df-ne mpbir ) ABDABEFCABGH $.
  $}

  $( Negation of inequality.  (Contributed by NM, 9-Jun-2006.) $)
  nne $p |- ( -. A =/= B <-> A = B ) $=
    ( wceq wne wn df-ne con2bii bicomi ) ABCZABDZEJIABFGH $.

  $( No class is unequal to itself.  Inequality is irreflexive.  (Contributed
     by Stefan O'Rear, 1-Jan-2015.) $)
  neirr $p |- -. A =/= A $=
    ( wne wn wceq eqid nne mpbir ) AABCAADAEAAFG $.

  $( Excluded middle with equality and inequality.  (Contributed by NM,
     3-Feb-2012.) $)
  exmidne $p |- ( A = B \/ A =/= B ) $=
    ( wceq wne wo wn exmid df-ne orbi2i mpbir ) ABCZABDZEKKFZEKGLMKABHIJ $.

  $( Law of noncontradiction with equality and inequality.  (Contributed by NM,
     3-Feb-2012.) $)
  nonconne $p |- -. ( A = B /\ A =/= B ) $=
    ( wceq wne wa wn pm3.24 df-ne anbi2i mtbir ) ABCZABDZEKKFZEKGLMKABHIJ $.

  $( Equality theorem for inequality.  (Contributed by NM, 19-Nov-1994.) $)
  neeq1 $p |- ( A = B -> ( A =/= C <-> B =/= C ) ) $=
    ( wceq wn wne eqeq1 notbid df-ne 3bitr4g ) ABDZACDZEBCDZEACFBCFKLMABCGHACIB
    CIJ $.

  $( Equality theorem for inequality.  (Contributed by NM, 19-Nov-1994.) $)
  neeq2 $p |- ( A = B -> ( C =/= A <-> C =/= B ) ) $=
    ( wceq wn wne eqeq2 notbid df-ne 3bitr4g ) ABDZCADZECBDZECAFCBFKLMABCGHCAIC
    BIJ $.

  ${
    neeq1i.1 $e |- A = B $.
    $( Inference for inequality.  (Contributed by NM, 29-Apr-2005.) $)
    neeq1i $p |- ( A =/= C <-> B =/= C ) $=
      ( wceq wne wb neeq1 ax-mp ) ABEACFBCFGDABCHI $.

    $( Inference for inequality.  (Contributed by NM, 29-Apr-2005.) $)
    neeq2i $p |- ( C =/= A <-> C =/= B ) $=
      ( wceq wne wb neeq2 ax-mp ) ABECAFCBFGDABCHI $.

    neeq12i.2 $e |- C = D $.
    $( Inference for inequality.  (Contributed by NM, 24-Jul-2012.) $)
    neeq12i $p |- ( A =/= C <-> B =/= D ) $=
      ( wne neeq2i neeq1i bitri ) ACGADGBDGCDAFHABDEIJ $.
  $}

  ${
    neeq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction for inequality.  (Contributed by NM, 25-Oct-1999.) $)
    neeq1d $p |- ( ph -> ( A =/= C <-> B =/= C ) ) $=
      ( wceq wne wb neeq1 syl ) ABCFBDGCDGHEBCDIJ $.

    $( Deduction for inequality.  (Contributed by NM, 25-Oct-1999.) $)
    neeq2d $p |- ( ph -> ( C =/= A <-> C =/= B ) ) $=
      ( wceq wne wb neeq2 syl ) ABCFDBGDCGHEBCDIJ $.

    neeq12d.2 $e |- ( ph -> C = D ) $.
    $( Deduction for inequality.  (Contributed by NM, 24-Jul-2012.) $)
    neeq12d $p |- ( ph -> ( A =/= C <-> B =/= D ) ) $=
      ( wne neeq1d neeq2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  ${
    neneqd.1 $e |- ( ph -> A =/= B ) $.
    $( Deduction eliminating inequality definition.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    neneqd $p |- ( ph -> -. A = B ) $=
      ( wne wceq wn df-ne sylib ) ABCEBCFGDBCHI $.
  $}

  ${
    eqnetr.1 $e |- A = B $.
    eqnetr.2 $e |- B =/= C $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    eqnetri $p |- A =/= C $=
      ( wne neeq1i mpbir ) ACFBCFEABCDGH $.
  $}

  ${
    eqnetrd.1 $e |- ( ph -> A = B ) $.
    eqnetrd.2 $e |- ( ph -> B =/= C ) $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    eqnetrd $p |- ( ph -> A =/= C ) $=
      ( wne neeq1d mpbird ) ABDGCDGFABCDEHI $.
  $}

  ${
    eqnetrr.1 $e |- A = B $.
    eqnetrr.2 $e |- A =/= C $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    eqnetrri $p |- B =/= C $=
      ( eqcomi eqnetri ) BACABDFEG $.
  $}

  ${
    eqnetrrd.1 $e |- ( ph -> A = B ) $.
    eqnetrrd.2 $e |- ( ph -> A =/= C ) $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    eqnetrrd $p |- ( ph -> B =/= C ) $=
      ( eqcomd eqnetrd ) ACBDABCEGFH $.
  $}

  ${
    neeqtr.1 $e |- A =/= B $.
    neeqtr.2 $e |- B = C $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    neeqtri $p |- A =/= C $=
      ( wne neeq2i mpbi ) ABFACFDBCAEGH $.
  $}

  ${
    neeqtrd.1 $e |- ( ph -> A =/= B ) $.
    neeqtrd.2 $e |- ( ph -> B = C ) $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    neeqtrd $p |- ( ph -> A =/= C ) $=
      ( wne neeq2d mpbid ) ABCGBDGEACDBFHI $.
  $}

  ${
    neeqtrr.1 $e |- A =/= B $.
    neeqtrr.2 $e |- C = B $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    neeqtrri $p |- A =/= C $=
      ( eqcomi neeqtri ) ABCDCBEFG $.
  $}

  ${
    neeqtrrd.1 $e |- ( ph -> A =/= B ) $.
    neeqtrrd.2 $e |- ( ph -> C = B ) $.
    $( Substitution of equal classes into an inequality.  (Contributed by NM,
       4-Jul-2012.) $)
    neeqtrrd $p |- ( ph -> A =/= C ) $=
      ( eqcomd neeqtrd ) ABCDEADCFGH $.
  $}

  ${
    syl5eqner.1 $e |- B = A $.
    syl5eqner.2 $e |- ( ph -> B =/= C ) $.
    $( B chained equality inference for inequality.  (Contributed by NM,
       6-Jun-2012.) $)
    syl5eqner $p |- ( ph -> A =/= C ) $=
      ( wne neeq1i sylib ) ACDGBDGFCBDEHI $.
  $}

  ${
    3netr3d.1 $e |- ( ph -> A =/= B ) $.
    3netr3d.2 $e |- ( ph -> A = C ) $.
    3netr3d.3 $e |- ( ph -> B = D ) $.
    $( Substitution of equality into both sides of an inequality.  (Contributed
       by NM, 24-Jul-2012.) $)
    3netr3d $p |- ( ph -> C =/= D ) $=
      ( wne neeq12d mpbid ) ABCIDEIFABDCEGHJK $.
  $}

  ${
    3netr4d.1 $e |- ( ph -> A =/= B ) $.
    3netr4d.2 $e |- ( ph -> C = A ) $.
    3netr4d.3 $e |- ( ph -> D = B ) $.
    $( Substitution of equality into both sides of an inequality.  (Contributed
       by NM, 24-Jul-2012.) $)
    3netr4d $p |- ( ph -> C =/= D ) $=
      ( wne neeq12d mpbird ) ADEIBCIFADBECGHJK $.
  $}

  ${
    3netr3g.1 $e |- ( ph -> A =/= B ) $.
    3netr3g.2 $e |- A = C $.
    3netr3g.3 $e |- B = D $.
    $( Substitution of equality into both sides of an inequality.  (Contributed
       by NM, 24-Jul-2012.) $)
    3netr3g $p |- ( ph -> C =/= D ) $=
      ( wne neeq12i sylib ) ABCIDEIFBDCEGHJK $.
  $}

  ${
    3netr4g.1 $e |- ( ph -> A =/= B ) $.
    3netr4g.2 $e |- C = A $.
    3netr4g.3 $e |- D = B $.
    $( Substitution of equality into both sides of an inequality.  (Contributed
       by NM, 14-Jun-2012.) $)
    3netr4g $p |- ( ph -> C =/= D ) $=
      ( wne neeq12i sylibr ) ABCIDEIFDBECGHJK $.
  $}

  ${
    necon3abii.1 $e |- ( A = B <-> ph ) $.
    $( Deduction from equality to inequality.  (Contributed by NM,
       9-Nov-2007.) $)
    necon3abii $p |- ( A =/= B <-> -. ph ) $=
      ( wne wceq df-ne xchbinx ) BCEBCFABCGDH $.
  $}

  ${
    necon3bbii.1 $e |- ( ph <-> A = B ) $.
    $( Deduction from equality to inequality.  (Contributed by NM,
       13-Apr-2007.) $)
    necon3bbii $p |- ( -. ph <-> A =/= B ) $=
      ( wne wn wceq bicomi necon3abii ) BCEAFABCABCGDHIH $.
  $}

  ${
    necon3bii.1 $e |- ( A = B <-> C = D ) $.
    $( Inference from equality to inequality.  (Contributed by NM,
       23-Feb-2005.) $)
    necon3bii $p |- ( A =/= B <-> C =/= D ) $=
      ( wne wceq wn necon3abii df-ne bitr4i ) ABFCDGZHCDFLABEICDJK $.
  $}

  ${
    necon3abid.1 $e |- ( ph -> ( A = B <-> ps ) ) $.
    $( Deduction from equality to inequality.  (Contributed by NM,
       21-Mar-2007.) $)
    necon3abid $p |- ( ph -> ( A =/= B <-> -. ps ) ) $=
      ( wne wceq wn df-ne notbid syl5bb ) CDFCDGZHABHCDIALBEJK $.
  $}

  ${
    necon3bbid.1 $e |- ( ph -> ( ps <-> A = B ) ) $.
    $( Deduction from equality to inequality.  (Contributed by NM,
       2-Jun-2007.) $)
    necon3bbid $p |- ( ph -> ( -. ps <-> A =/= B ) ) $=
      ( wne wn wceq bicomd necon3abid ) ACDFBGABCDABCDHEIJI $.
  $}

  ${
    necon3bid.1 $e |- ( ph -> ( A = B <-> C = D ) ) $.
    $( Deduction from equality to inequality.  (Contributed by NM,
       23-Feb-2005.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon3bid $p |- ( ph -> ( A =/= B <-> C =/= D ) ) $=
      ( wne wceq wn df-ne necon3bbid syl5bb ) BCGBCHZIADEGBCJAMDEFKL $.
  $}

  ${
    necon3ad.1 $e |- ( ph -> ( ps -> A = B ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       2-Apr-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon3ad $p |- ( ph -> ( A =/= B -> -. ps ) ) $=
      ( wne wceq wn nne syl6ibr con2d ) ABCDFZABCDGLHECDIJK $.
  $}

  ${
    necon3bd.1 $e |- ( ph -> ( A = B -> ps ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       2-Apr-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon3bd $p |- ( ph -> ( -. ps -> A =/= B ) ) $=
      ( wne wn wceq nne syl5bi con1d ) ACDFZBLGCDHABCDIEJK $.
  $}

  ${
    necon3d.1 $e |- ( ph -> ( A = B -> C = D ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       10-Jun-2006.) $)
    necon3d $p |- ( ph -> ( C =/= D -> A =/= B ) ) $=
      ( wne wceq wn necon3ad df-ne syl6ibr ) ADEGBCHZIBCGAMDEFJBCKL $.
  $}

  $( Characterization of inequality in terms of reversed equality (see
     ~ bicom ).  (Contributed by BJ, 7-Jul-2018.) $)
  nesym $p |- ( A =/= B <-> -. B = A ) $=
    ( wceq eqcom necon3abii ) BACABABDE $.

  ${
    nesymi.1 $e |- A =/= B $.
    $( Inference associated with ~ nesym .  (Contributed by BJ, 7-Jul-2018.) $)
    nesymi $p |- -. B = A $=
      ( wne wceq wn nesym mpbi ) ABDBAEFCABGH $.
  $}

  ${
    nesymir.1 $e |- -. A = B $.
    $( Inference associated with ~ nesym .  (Contributed by BJ, 7-Jul-2018.) $)
    nesymir $p |- B =/= A $=
      ( wne wceq wn nesym mpbir ) BADABEFCBAGH $.
  $}

  ${
    necon3i.1 $e |- ( A = B -> C = D ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       9-Aug-2006.) $)
    necon3i $p |- ( C =/= D -> A =/= B ) $=
      ( wceq wi wne id necon3d ax-mp ) ABFCDFGZCDHABHGELABCDLIJK $.
  $}

  ${
    necon3ai.1 $e |- ( ph -> A = B ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       23-May-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon3ai $p |- ( A =/= B -> -. ph ) $=
      ( wne wceq wn nne sylibr con2i ) ABCEZABCFKGDBCHIJ $.
  $}

  ${
    necon3bi.1 $e |- ( A = B -> ph ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       1-Jun-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon3bi $p |- ( -. ph -> A =/= B ) $=
      ( wne wn wceq nne sylbi con1i ) BCEZAKFBCGABCHDIJ $.
  $}

  ${
    necon1ai.1 $e |- ( -. ph -> A = B ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       12-Feb-2007.) $)
    necon1ai $p |- ( A =/= B -> ph ) $=
      ( wne wceq wn df-ne con1i sylbi ) BCEBCFZGABCHAKDIJ $.
  $}

  ${
    necon1bi.1 $e |- ( A =/= B -> ph ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       18-Mar-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon1bi $p |- ( -. ph -> A = B ) $=
      ( wn wne wceq con3i nne sylib ) AEBCFZEBCGKADHBCIJ $.
  $}

  ${
    necon1i.1 $e |- ( A =/= B -> C = D ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       18-Mar-2007.) $)
    necon1i $p |- ( C =/= D -> A = B ) $=
      ( wceq wn wne df-ne sylbir necon1ai ) ABFZCDLGABHCDFABIEJK $.
  $}

  ${
    necon2ai.1 $e |- ( A = B -> -. ph ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       16-Jan-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon2ai $p |- ( ph -> A =/= B ) $=
      ( wne wn wceq nne sylbi con4i ) BCEZAKFBCGAFBCHDIJ $.
  $}

  ${
    necon2bi.1 $e |- ( ph -> A =/= B ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       1-Apr-2007.) $)
    necon2bi $p |- ( A = B -> -. ph ) $=
      ( wceq neneqd con2i ) ABCEABCDFG $.
  $}

  ${
    necon2i.1 $e |- ( A = B -> C =/= D ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       18-Mar-2007.) $)
    necon2i $p |- ( C = D -> A =/= B ) $=
      ( wceq neneqd necon2ai ) CDFABABFCDEGH $.
  $}

  ${
    necon2ad.1 $e |- ( ph -> ( A = B -> -. ps ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       19-Apr-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon2ad $p |- ( ph -> ( ps -> A =/= B ) ) $=
      ( wne wn wceq nne syl5bi con4d ) ACDFZBLGCDHABGCDIEJK $.
  $}

  ${
    necon2bd.1 $e |- ( ph -> ( ps -> A =/= B ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       13-Apr-2007.) $)
    necon2bd $p |- ( ph -> ( A = B -> -. ps ) ) $=
      ( wceq wne wn df-ne syl6ib con2d ) ABCDFZABCDGLHECDIJK $.
  $}

  ${
    necon2d.1 $e |- ( ph -> ( A = B -> C =/= D ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       28-Dec-2008.) $)
    necon2d $p |- ( ph -> ( C = D -> A =/= B ) ) $=
      ( wceq wne wn df-ne syl6ib necon2ad ) ADEGZBCABCGDEHMIFDEJKL $.
  $}

  ${
    necon1abii.1 $e |- ( -. ph <-> A = B ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       17-Mar-2007.) $)
    necon1abii $p |- ( A =/= B <-> ph ) $=
      ( wne wceq wn df-ne con1bii bitri ) BCEBCFZGABCHAKDIJ $.
  $}

  ${
    necon1bbii.1 $e |- ( A =/= B <-> ph ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       17-Mar-2007.) $)
    necon1bbii $p |- ( -. ph <-> A = B ) $=
      ( wceq wn wne df-ne bitr3i con1bii ) BCEZAKFBCGABCHDIJ $.
  $}

  ${
    necon1abid.1 $e |- ( ph -> ( -. ps <-> A = B ) ) $.
    $( Contrapositive deduction for inequality.  (Contributed by NM,
       21-Aug-2007.) $)
    necon1abid $p |- ( ph -> ( A =/= B <-> ps ) ) $=
      ( wne wceq wn df-ne con1bid syl5bb ) CDFCDGZHABCDIABLEJK $.
  $}

  ${
    necon1bbid.1 $e |- ( ph -> ( A =/= B <-> ps ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       31-Jan-2008.) $)
    necon1bbid $p |- ( ph -> ( -. ps <-> A = B ) ) $=
      ( wceq wn wne df-ne syl5bbr con1bid ) ACDFZBLGCDHABCDIEJK $.
  $}

  ${
    necon2abii.1 $e |- ( A = B <-> -. ph ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       2-Mar-2007.) $)
    necon2abii $p |- ( ph <-> A =/= B ) $=
      ( wne wceq wn bicomi necon1abii ) BCEAABCBCFAGDHIH $.
  $}

  ${
    necon2bbii.1 $e |- ( ph <-> A =/= B ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       13-Apr-2007.) $)
    necon2bbii $p |- ( A = B <-> -. ph ) $=
      ( wn wceq wne bicomi necon1bbii ) AEBCFABCABCGDHIH $.
  $}

  ${
    necon2abid.1 $e |- ( ph -> ( A = B <-> -. ps ) ) $.
    $( Contrapositive deduction for inequality.  (Contributed by NM,
       18-Jul-2007.) $)
    necon2abid $p |- ( ph -> ( ps <-> A =/= B ) ) $=
      ( wceq wn wne con2bid df-ne syl6bbr ) ABCDFZGCDHALBEICDJK $.
  $}

  ${
    necon2bbid.1 $e |- ( ph -> ( ps <-> A =/= B ) ) $.
    $( Contrapositive deduction for inequality.  (Contributed by NM,
       13-Apr-2007.) $)
    necon2bbid $p |- ( ph -> ( A = B <-> -. ps ) ) $=
      ( wceq wne wn df-ne syl6bb con2bid ) ABCDFZABCDGLHECDIJK $.
  $}

  ${
    necon4ai.1 $e |- ( A =/= B -> -. ph ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       16-Jan-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon4ai $p |- ( ph -> A = B ) $=
      ( wne wn wceq con2i nne sylib ) ABCEZFBCGKADHBCIJ $.
  $}

  ${
    necon4i.1 $e |- ( A =/= B -> C =/= D ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       17-Mar-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon4i $p |- ( C = D -> A = B ) $=
      ( wceq wne wn necon2bi nne sylib ) CDFABGZHABFLCDEIABJK $.
  $}

  ${
    necon4ad.1 $e |- ( ph -> ( A =/= B -> -. ps ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       2-Apr-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon4ad $p |- ( ph -> ( ps -> A = B ) ) $=
      ( wne wn wceq con2d nne syl6ib ) ABCDFZGCDHALBEICDJK $.
  $}

  ${
    necon4bd.1 $e |- ( ph -> ( -. ps -> A =/= B ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       1-Jun-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon4bd $p |- ( ph -> ( A = B -> ps ) ) $=
      ( wceq wne wn nne con1d syl5bir ) CDFCDGZHABCDIABLEJK $.
  $}

  ${
    necon4d.1 $e |- ( ph -> ( A =/= B -> C =/= D ) ) $.
    $( Contrapositive inference for inequality.  (Contributed by NM,
       2-Apr-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon4d $p |- ( ph -> ( C = D -> A = B ) ) $=
      ( wceq wne wn necon2bd nne syl6ib ) ADEGBCHZIBCGAMDEFJBCKL $.
  $}

  ${
    necon4abid.1 $e |- ( ph -> ( A =/= B <-> -. ps ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       11-Jan-2008.) $)
    necon4abid $p |- ( ph -> ( A = B <-> ps ) ) $=
      ( wceq wn wne df-ne syl5bbr con4bid ) ACDFZBLGCDHABGCDIEJK $.
  $}

  ${
    necon4bbid.1 $e |- ( ph -> ( -. ps <-> A =/= B ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       9-May-2012.) $)
    necon4bbid $p |- ( ph -> ( ps <-> A = B ) ) $=
      ( wceq wn wne bicomd necon4abid ) ACDFBABCDABGCDHEIJI $.
  $}

  ${
    necon4bid.1 $e |- ( ph -> ( A =/= B <-> C =/= D ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       29-Jun-2007.) $)
    necon4bid $p |- ( ph -> ( A = B <-> C = D ) ) $=
      ( wceq wne wn necon2bbid nne syl6rbb ) ADEGBCHZIBCGAMDEFJBCKL $.
  $}

  ${
    necon1ad.1 $e |- ( ph -> ( -. ps -> A = B ) ) $.
    $( Contrapositive deduction for inequality.  (Contributed by NM,
       2-Apr-2007.) $)
    necon1ad $p |- ( ph -> ( A =/= B -> ps ) ) $=
      ( wne wceq wn df-ne con1d syl5bi ) CDFCDGZHABCDIABLEJK $.
  $}

  ${
    necon1bd.1 $e |- ( ph -> ( A =/= B -> ps ) ) $.
    $( Contrapositive deduction for inequality.  (Contributed by NM,
       21-Mar-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon1bd $p |- ( ph -> ( -. ps -> A = B ) ) $=
      ( wn wne wceq con3d nne syl6ib ) ABFCDGZFCDHALBEICDJK $.
  $}

  ${
    necon1d.1 $e |- ( ph -> ( A =/= B -> C = D ) ) $.
    $( Contrapositive law deduction for inequality.  (Contributed by NM,
       28-Dec-2008.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    necon1d $p |- ( ph -> ( C =/= D -> A = B ) ) $=
      ( wne wceq wn nne syl6ibr necon4ad ) ADEGZBCABCGDEHMIFDEJKL $.
  $}

  ${
    neneqad.1 $e |- ( ph -> -. A = B ) $.
    $( If it is not the case that two classes are equal, they are unequal.
       Converse of ~ neneqd .  One-way deduction form of ~ df-ne .
       (Contributed by David Moews, 28-Feb-2017.) $)
    neneqad $p |- ( ph -> A =/= B ) $=
      ( wceq con2i necon2ai ) ABCABCEDFG $.
  $}

  $( Contraposition law for inequality.  (Contributed by NM, 28-Dec-2008.) $)
  nebi $p |- ( ( A = B <-> C = D ) <-> ( A =/= B <-> C =/= D ) ) $=
    ( wceq wb wne id necon3bid necon4bid impbii ) ABECDEFZABGCDGFZLABCDLHIMABCD
    MHJK $.

  $( Theorem *13.18 in [WhiteheadRussell] p. 178.  (Contributed by Andrew
     Salmon, 3-Jun-2011.) $)
  pm13.18 $p |- ( ( A = B /\ A =/= C ) -> B =/= C ) $=
    ( wceq wne eqeq1 biimprd necon3d imp ) ABDZACEBCEJBCACJACDBCDABCFGHI $.

  $( Theorem *13.181 in [WhiteheadRussell] p. 178.  (Contributed by Andrew
     Salmon, 3-Jun-2011.) $)
  pm13.181 $p |- ( ( A = B /\ B =/= C ) -> A =/= C ) $=
    ( wceq wne eqcom pm13.18 sylanb ) ABDBADBCEACEABFBACGH $.

  ${
    pm2.21ddne.1 $e |- ( ph -> A = B ) $.
    pm2.21ddne.2 $e |- ( ph -> A =/= B ) $.
    $( A contradiction implies anything.  Equality/inequality deduction form.
       (Contributed by David Moews, 28-Feb-2017.) $)
    pm2.21ddne $p |- ( ph -> ps ) $=
      ( wceq neneqd pm2.21dd ) ACDGBEACDFHI $.
  $}

  ${
    pm2.61ne.1 $e |- ( A = B -> ( ps <-> ch ) ) $.
    pm2.61ne.2 $e |- ( ( ph /\ A =/= B ) -> ps ) $.
    pm2.61ne.3 $e |- ( ph -> ch ) $.
    $( Deduction eliminating an inequality in an antecedent.  (Contributed by
       NM, 24-May-2006.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    pm2.61ne $p |- ( ph -> ps ) $=
      ( wne wi expcom wn wceq nne syl5ibr sylbi pm2.61i ) DEIZABJZARBGKRLDEMZSD
      ENABTCHFOPQ $.
  $}

  ${
    pm2.61ine.1 $e |- ( A = B -> ph ) $.
    pm2.61ine.2 $e |- ( A =/= B -> ph ) $.
    $( Inference eliminating an inequality in an antecedent.  (Contributed by
       NM, 16-Jan-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    pm2.61ine $p |- ph $=
      ( wne wn wceq nne sylbi pm2.61i ) BCFZAELGBCHABCIDJK $.
  $}

  ${
    pm2.61dne.1 $e |- ( ph -> ( A = B -> ps ) ) $.
    pm2.61dne.2 $e |- ( ph -> ( A =/= B -> ps ) ) $.
    $( Deduction eliminating an inequality in an antecedent.  (Contributed by
       NM, 1-Jun-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    pm2.61dne $p |- ( ph -> ps ) $=
      ( wne wn wceq nne syl5bi pm2.61d ) ACDGZBFMHCDIABCDJEKL $.
  $}

  ${
    pm2.61dane.1 $e |- ( ( ph /\ A = B ) -> ps ) $.
    pm2.61dane.2 $e |- ( ( ph /\ A =/= B ) -> ps ) $.
    $( Deduction eliminating an inequality in an antecedent.  (Contributed by
       NM, 30-Nov-2011.) $)
    pm2.61dane $p |- ( ph -> ps ) $=
      ( wceq ex wne pm2.61dne ) ABCDACDGBEHACDIBFHJ $.
  $}

  ${
    pm2.61da2ne.1 $e |- ( ( ph /\ A = B ) -> ps ) $.
    pm2.61da2ne.2 $e |- ( ( ph /\ C = D ) -> ps ) $.
    pm2.61da2ne.3 $e |- ( ( ph /\ ( A =/= B /\ C =/= D ) ) -> ps ) $.
    $( Deduction eliminating two inequalities in an antecedent.  (Contributed
       by NM, 29-May-2013.) $)
    pm2.61da2ne $p |- ( ph -> ps ) $=
      ( wne wa wceq adantlr anassrs pm2.61dane ) ABCDGACDJZKBEFAEFLBPHMAPEFJBIN
      OO $.
  $}

  ${
    pm2.61da3ne.1 $e |- ( ( ph /\ A = B ) -> ps ) $.
    pm2.61da3ne.2 $e |- ( ( ph /\ C = D ) -> ps ) $.
    pm2.61da3ne.3 $e |- ( ( ph /\ E = F ) -> ps ) $.
    pm2.61da3ne.4 $e |- ( ( ph /\ ( A =/= B /\ C =/= D /\ E =/= F ) )
          -> ps ) $.
    $( Deduction eliminating three inequalities in an antecedent.  (Contributed
       by NM, 15-Jun-2013.) $)
    pm2.61da3ne $p |- ( ph -> ps ) $=
      ( wne wa wceq adantlr simpll simplrl simplrr simpr pm2.61dane pm2.61da2ne
      syl13anc ) ABCDEFIJACDMZEFMZNZNZBGHAGHOBUFKPUGGHMZNAUDUEUHBAUFUHQAUDUEUHR
      AUDUEUHSUGUHTLUCUAUB $.
  $}

  $( Commutation of inequality.  (Contributed by NM, 14-May-1999.) $)
  necom $p |- ( A =/= B <-> B =/= A ) $=
    ( eqcom necon3bii ) ABBAABCD $.

  ${
    necomi.1 $e |- A =/= B $.
    $( Inference from commutative law for inequality.  (Contributed by NM,
       17-Oct-2012.) $)
    necomi $p |- B =/= A $=
      ( wne necom mpbi ) ABDBADCABEF $.
  $}

  ${
    necomd.1 $e |- ( ph -> A =/= B ) $.
    $( Deduction from commutative law for inequality.  (Contributed by NM,
       12-Feb-2008.) $)
    necomd $p |- ( ph -> B =/= A ) $=
      ( wne necom sylib ) ABCECBEDBCFG $.
  $}

  $( Logical OR with an equality.  (Contributed by NM, 29-Apr-2007.) $)
  neor $p |- ( ( A = B \/ ps ) <-> ( A =/= B -> ps ) ) $=
    ( wceq wo wn wi wne df-or df-ne imbi1i bitr4i ) BCDZAEMFZAGBCHZAGMAIONABCJK
    L $.

  $( A De Morgan's law for inequality.  (Contributed by NM, 18-May-2007.) $)
  neanior $p |- ( ( A =/= B /\ C =/= D ) <-> -. ( A = B \/ C = D ) ) $=
    ( wne wa wceq wn wo df-ne anbi12i pm4.56 bitri ) ABEZCDEZFABGZHZCDGZHZFPRIH
    NQOSABJCDJKPRLM $.

  $( A De Morgan's law for inequality.  (Contributed by NM, 30-Sep-2013.) $)
  ne3anior $p |- ( ( A =/= B /\ C =/= D /\ E =/= F )
        <-> -. ( A = B \/ C = D \/ E = F ) ) $=
    ( wne w3a wn w3o wceq 3anor nne 3orbi123i xchbinx ) ABGZCDGZEFGZHPIZQIZRIZJ
    ABKZCDKZEFKZJPQRLSUBTUCUAUDABMCDMEFMNO $.

  $( A De Morgan's law for inequality.  (Contributed by NM, 18-May-2007.) $)
  neorian $p |- ( ( A =/= B \/ C =/= D ) <-> -. ( A = B /\ C = D ) ) $=
    ( wne wo wceq wn wa df-ne orbi12i ianor bitr4i ) ABEZCDEZFABGZHZCDGZHZFPRIH
    NQOSABJCDJKPRLM $.

  ${
    nemtbir.1 $e |- A =/= B $.
    nemtbir.2 $e |- ( ph <-> A = B ) $.
    $( An inference from an inequality, related to modus tollens.  (Contributed
       by NM, 13-Apr-2007.) $)
    nemtbir $p |- -. ph $=
      ( wceq neii mtbir ) ABCFBCDGEH $.
  $}

  $( Two classes are different if they don't contain the same element.
     (Contributed by NM, 3-Feb-2012.) $)
  nelne1 $p |- ( ( A e. B /\ -. A e. C ) -> B =/= C ) $=
    ( wcel wn wne wceq eleq2 biimpcd necon3bd imp ) ABDZACDZEBCFLMBCBCGLMBCAHIJ
    K $.

  $( Two classes are different if they don't belong to the same class.
     (Contributed by NM, 25-Jun-2012.) $)
  nelne2 $p |- ( ( A e. C /\ -. B e. C ) -> A =/= B ) $=
    ( wcel wn wne wceq eleq1 biimpcd necon3bd imp ) ACDZBCDZEABFLMABABGLMABCHIJ
    K $.

  ${
    $d y A $.  $d y B $.
    nfne.1 $e |- F/_ x A $.
    nfne.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for inequality.  (Contributed by NM,
       10-Nov-2007.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
    nfne $p |- F/ x A =/= B $=
      ( wne wceq wn df-ne nfeq nfn nfxfr ) BCFBCGZHABCIMAABCDEJKL $.
  $}

  ${
    $d y A $.  $d y B $.
    nfned.1 $e |- ( ph -> F/_ x A ) $.
    nfned.2 $e |- ( ph -> F/_ x B ) $.
    $( Bound-variable hypothesis builder for inequality.  (Contributed by NM,
       10-Nov-2007.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
    nfned $p |- ( ph -> F/ x A =/= B ) $=
      ( wne wceq wn df-ne nfeqd nfnd nfxfrd ) CDGCDHZIABCDJANBABCDEFKLM $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Negated membership
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    neli.1 $e |- A e/ B $.
    $( Inference associated with ~ df-nel .  (Contributed by BJ,
       7-Jul-2018.) $)
    neli $p |- -. A e. B $=
      ( wnel wcel wn df-nel mpbi ) ABDABEFCABGH $.
  $}

  ${
    nelir.1 $e |- -. A e. B $.
    $( Inference associated with ~ df-nel .  (Contributed by BJ,
       7-Jul-2018.) $)
    nelir $p |- A e/ B $=
      ( wnel wcel wn df-nel mpbir ) ABDABEFCABGH $.
  $}

  $( Equality theorem for negated membership.  (Contributed by NM,
     20-Nov-1994.) $)
  neleq1 $p |- ( A = B -> ( A e/ C <-> B e/ C ) ) $=
    ( wceq wcel wn wnel eleq1 notbid df-nel 3bitr4g ) ABDZACEZFBCEZFACGBCGLMNAB
    CHIACJBCJK $.

  $( Equality theorem for negated membership.  (Contributed by NM,
     20-Nov-1994.) $)
  neleq2 $p |- ( A = B -> ( C e/ A <-> C e/ B ) ) $=
    ( wceq wcel wn wnel eleq2 notbid df-nel 3bitr4g ) ABDZCAEZFCBEZFCAGCBGLMNAB
    CHICAJCBJK $.

  ${
    neleq12d.1 $e |- ( ph -> A = B ) $.
    neleq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality theorem for negated membership.  (Contributed by FL,
       10-Aug-2016.) $)
    neleq12d $p |- ( ph -> ( A e/ C <-> B e/ D ) ) $=
      ( wnel wceq wb neleq1 syl neleq2 bitrd ) ABDHZCDHZCEHZABCIOPJFBCDKLADEIPQ
      JGDECMLN $.
  $}

  ${
    $d y A $.  $d z B $.
    nfnel.1 $e |- F/_ x A $.
    nfnel.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for negated membership.  (Contributed
       by David Abernethy, 26-Jun-2011.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    nfnel $p |- F/ x A e/ B $=
      ( wnel wcel wn df-nel nfel nfn nfxfr ) BCFBCGZHABCIMAABCDEJKL $.
  $}

  ${
    $d y A $.  $d z B $.
    nfneld.1 $e |- ( ph -> F/_ x A ) $.
    nfneld.2 $e |- ( ph -> F/_ x B ) $.
    $( Bound-variable hypothesis builder for negated membership.  (Contributed
       by David Abernethy, 26-Jun-2011.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    nfneld $p |- ( ph -> F/ x A e/ B ) $=
      ( wnel wcel wn df-nel nfeld nfnd nfxfrd ) CDGCDHZIABCDJANBABCDEFKLM $.
  $}

  $( Negation of negated membership, analogous to ~ nne .  (Contributed by
     Alexander van der Vekens, 18-Jan-2018.) $)
  nnel $p |- ( -. A e/ B <-> A e. B ) $=
    ( wcel wn wnel notnot bicomi df-nel xchnxbir ) ABCZDZJABEJKDJFGABHI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Restricted quantification
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend wff notation to include restricted universal quantification. $)
  wral $a wff A. x e. A ph $.

  $( Extend wff notation to include restricted existential quantification. $)
  wrex $a wff E. x e. A ph $.

  $( Extend wff notation to include restricted existential uniqueness. $)
  wreu $a wff E! x e. A ph $.

  $( Extend wff notation to include restricted "at most one." $)
  wrmo $a wff E* x e. A ph $.

  $( Extend class notation to include the restricted class abstraction (class
     builder). $)
  crab $a class { x e. A | ph } $.

  $( Define restricted universal quantification.  Special case of Definition
     4.15(3) of [TakeutiZaring] p. 22.  (Contributed by NM, 19-Aug-1993.) $)
  df-ral $a |- ( A. x e. A ph <-> A. x ( x e. A -> ph ) ) $.

  $( Define restricted existential quantification.  Special case of Definition
     4.15(4) of [TakeutiZaring] p. 22.  (Contributed by NM, 30-Aug-1993.) $)
  df-rex $a |- ( E. x e. A ph <-> E. x ( x e. A /\ ph ) ) $.

  $( Define restricted existential uniqueness.  (Contributed by NM,
     22-Nov-1994.) $)
  df-reu $a |- ( E! x e. A ph <-> E! x ( x e. A /\ ph ) ) $.

  $( Define restricted "at most one".  (Contributed by NM, 16-Jun-2017.) $)
  df-rmo $a |- ( E* x e. A ph <-> E* x ( x e. A /\ ph ) ) $.

  $( Define a restricted class abstraction (class builder), which is the class
     of all ` x ` in ` A ` such that ` ph ` is true.  Definition of
     [TakeutiZaring] p. 20.  (Contributed by NM, 22-Nov-1994.) $)
  df-rab $a |- { x e. A | ph } = { x | ( x e. A /\ ph ) } $.

  $( Relationship between restricted universal and existential quantifiers.
     (Contributed by NM, 21-Jan-1997.) $)
  ralnex $p |- ( A. x e. A -. ph <-> -. E. x e. A ph ) $=
    ( wn wral cv wcel wi wal wrex df-ral wa wex alinexa df-rex xchbinxr bitri )
    ADZBCEBFCGZRHBIZABCJZDRBCKTSALBMUASABNABCOPQ $.

  $( Relationship between restricted universal and existential quantifiers.
     (Contributed by NM, 21-Jan-1997.) $)
  rexnal $p |- ( E. x e. A -. ph <-> -. A. x e. A ph ) $=
    ( wn wrex cv wcel wa wex wral df-rex wi wal exanali df-ral xchbinxr bitri )
    ADZBCEBFCGZRHBIZABCJZDRBCKTSALBMUASABNABCOPQ $.

  $( Relationship between restricted universal and existential quantifiers.
     (Contributed by NM, 21-Jan-1997.) $)
  dfral2 $p |- ( A. x e. A ph <-> -. E. x e. A -. ph ) $=
    ( wn wrex wral rexnal con2bii ) ADBCEABCFABCGH $.

  $( Relationship between restricted universal and existential quantifiers.
     (Contributed by NM, 21-Jan-1997.) $)
  dfrex2 $p |- ( E. x e. A ph <-> -. A. x e. A -. ph ) $=
    ( wn wral wrex ralnex con2bii ) ADBCEABCFABCGH $.

  ${
    ralbida.1 $e |- F/ x ph $.
    ralbida.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule).  (Contributed by NM, 6-Oct-2003.) $)
    ralbida $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      ( cv wcel wi wal wral pm5.74da albid df-ral 3bitr4g ) ADHEIZBJZDKQCJZDKBD
      ELCDELARSDFAQBCGMNBDEOCDEOP $.

    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 6-Oct-2003.) $)
    rexbida $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      ( cv wcel wa wex wrex pm5.32da exbid df-rex 3bitr4g ) ADHEIZBJZDKQCJZDKBD
      ELCDELARSDFAQBCGMNBDEOCDEOP $.
  $}

  ${
    $d x ph $.
    ralbidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule).  (Contributed by NM, 4-Mar-1997.) $)
    ralbidva $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      ( nfv ralbida ) ABCDEADGFH $.

    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 9-Mar-1997.) $)
    rexbidva $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      ( nfv rexbida ) ABCDEADGFH $.
  $}

  ${
    ralbid.1 $e |- F/ x ph $.
    ralbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule).  (Contributed by NM, 27-Jun-1998.) $)
    ralbid $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      ( wb cv wcel adantr ralbida ) ABCDEFABCHDIEJGKL $.

    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 27-Jun-1998.) $)
    rexbid $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      ( wb cv wcel adantr rexbida ) ABCDEFABCHDIEJGKL $.
  $}

  ${
    $d x ph $.
    ralbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule).  (Contributed by NM, 20-Nov-1994.) $)
    ralbidv $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      ( nfv ralbid ) ABCDEADGFH $.

    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 20-Nov-1994.) $)
    rexbidv $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      ( nfv rexbid ) ABCDEADGFH $.
  $}

  ${
    $d x ph $.
    ralbidv2.1 $e |- ( ph -> ( ( x e. A -> ps ) <-> ( x e. B -> ch ) ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule).  (Contributed by NM, 6-Apr-1997.) $)
    ralbidv2 $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ch ) ) $=
      ( cv wcel wi wal wral albidv df-ral 3bitr4g ) ADHZEIBJZDKPFICJZDKBDELCDFL
      AQRDGMBDENCDFNO $.
  $}

  ${
    $d x ph $.
    rexbidv2.1 $e |- ( ph -> ( ( x e. A /\ ps ) <-> ( x e. B /\ ch ) ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 22-May-1999.) $)
    rexbidv2 $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ch ) ) $=
      ( cv wcel wa wex wrex exbidv df-rex 3bitr4g ) ADHZEIBJZDKPFICJZDKBDELCDFL
      AQRDGMBDENCDFNO $.
  $}

  ${
    ralbii.1 $e |- ( ph <-> ps ) $.
    $( Inference adding restricted universal quantifier to both sides of an
       equivalence.  (Contributed by NM, 23-Nov-1994.)  (Revised by Mario
       Carneiro, 17-Oct-2016.) $)
    ralbii $p |- ( A. x e. A ph <-> A. x e. A ps ) $=
      ( wral wb wtru a1i ralbidv trud ) ACDFBCDFGHABCDABGHEIJK $.

    $( Inference adding restricted existential quantifier to both sides of an
       equivalence.  (Contributed by NM, 23-Nov-1994.)  (Revised by Mario
       Carneiro, 17-Oct-2016.) $)
    rexbii $p |- ( E. x e. A ph <-> E. x e. A ps ) $=
      ( wrex wb wtru a1i rexbidv trud ) ACDFBCDFGHABCDABGHEIJK $.

    $( Inference adding two restricted universal quantifiers to both sides of
       an equivalence.  (Contributed by NM, 1-Aug-2004.) $)
    2ralbii $p |- ( A. x e. A A. y e. B ph <-> A. x e. A A. y e. B ps ) $=
      ( wral ralbii ) ADFHBDFHCEABDFGII $.

    $( Inference adding two restricted existential quantifiers to both sides of
       an equivalence.  (Contributed by NM, 11-Nov-1995.) $)
    2rexbii $p |- ( E. x e. A E. y e. B ph <-> E. x e. A E. y e. B ps ) $=
      ( wrex rexbii ) ADFHBDFHCEABDFGII $.
  $}

  ${
    ralbii2.1 $e |- ( ( x e. A -> ph ) <-> ( x e. B -> ps ) ) $.
    $( Inference adding different restricted universal quantifiers to each side
       of an equivalence.  (Contributed by NM, 15-Aug-2005.) $)
    ralbii2 $p |- ( A. x e. A ph <-> A. x e. B ps ) $=
      ( cv wcel wi wal wral albii df-ral 3bitr4i ) CGZDHAIZCJOEHBIZCJACDKBCEKPQ
      CFLACDMBCEMN $.
  $}

  ${
    rexbii2.1 $e |- ( ( x e. A /\ ph ) <-> ( x e. B /\ ps ) ) $.
    $( Inference adding different restricted existential quantifiers to each
       side of an equivalence.  (Contributed by NM, 4-Feb-2004.) $)
    rexbii2 $p |- ( E. x e. A ph <-> E. x e. B ps ) $=
      ( cv wcel wa wex wrex exbii df-rex 3bitr4i ) CGZDHAIZCJOEHBIZCJACDKBCEKPQ
      CFLACDMBCEMN $.
  $}

  ${
    raleqbii.1 $e |- A = B $.
    raleqbii.2 $e |- ( ps <-> ch ) $.
    $( Equality deduction for restricted universal quantifier, changing both
       formula and quantifier domain.  Inference form.  (Contributed by David
       Moews, 1-May-2017.) $)
    raleqbii $p |- ( A. x e. A ps <-> A. x e. B ch ) $=
      ( cv wcel eleq2i imbi12i ralbii2 ) ABCDECHZDIMEIABDEMFJGKL $.

    $( Equality deduction for restricted existential quantifier, changing both
       formula and quantifier domain.  Inference form.  (Contributed by David
       Moews, 1-May-2017.) $)
    rexeqbii $p |- ( E. x e. A ps <-> E. x e. B ch ) $=
      ( cv wcel eleq2i anbi12i rexbii2 ) ABCDECHZDIMEIABDEMFJGKL $.
  $}

  ${
    ralbiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Inference adding restricted universal quantifier to both sides of an
       equivalence.  (Contributed by NM, 26-Nov-2000.) $)
    ralbiia $p |- ( A. x e. A ph <-> A. x e. A ps ) $=
      ( cv wcel pm5.74i ralbii2 ) ABCDDCFDGABEHI $.

    $( Inference adding restricted existential quantifier to both sides of an
       equivalence.  (Contributed by NM, 26-Oct-1999.) $)
    rexbiia $p |- ( E. x e. A ph <-> E. x e. A ps ) $=
      ( cv wcel pm5.32i rexbii2 ) ABCDDCFDGABEHI $.
  $}

  ${
    $d x y $.  $d y A $.
    2rexbiia.1 $e |- ( ( x e. A /\ y e. B ) -> ( ph <-> ps ) ) $.
    $( Inference adding two restricted existential quantifiers to both sides of
       an equivalence.  (Contributed by NM, 1-Aug-2004.) $)
    2rexbiia $p |- ( E. x e. A E. y e. B ph <-> E. x e. A E. y e. B ps ) $=
      ( wrex cv wcel rexbidva rexbiia ) ADFHBDFHCECIEJABDFGKL $.
  $}

  ${
    $d x y $.
    r2alf.1 $e |- F/_ y A $.
    $( Double restricted universal quantification.  (Contributed by Mario
       Carneiro, 14-Oct-2016.) $)
    r2alf $p |- ( A. x e. A A. y e. B ph <->
               A. x A. y ( ( x e. A /\ y e. B ) -> ph ) ) $=
      ( wral cv wi wal wa df-ral nfcri 19.21 impexp albii imbi2i 3bitr4i bitr4i
      wcel ) ACEGZBDGBHDTZUAIZBJUBCHETZKAIZCJZBJUABDLUFUCBUBUDAIZIZCJUBUGCJZIUF
      UCUBUGCCBDFMNUEUHCUBUDAOPUAUIUBACELQRPS $.

    $( Double restricted existential quantification.  (Contributed by Mario
       Carneiro, 14-Oct-2016.) $)
    r2exf $p |- ( E. x e. A E. y e. B ph <->
               E. x E. y ( ( x e. A /\ y e. B ) /\ ph ) ) $=
      ( wrex cv wcel wex df-rex nfcri 19.42 anass exbii anbi2i 3bitr4i bitr4i
      wa ) ACEGZBDGBHDIZTSZBJUACHEIZSASZCJZBJTBDKUEUBBUAUCASZSZCJUAUFCJZSUEUBUA
      UFCCBDFLMUDUGCUAUCANOTUHUAACEKPQOR $.
  $}

  ${
    $d x y $.  $d y A $.
    $( Double restricted universal quantification.  (Contributed by NM,
       19-Nov-1995.) $)
    r2al $p |- ( A. x e. A A. y e. B ph <->
               A. x A. y ( ( x e. A /\ y e. B ) -> ph ) ) $=
      ( nfcv r2alf ) ABCDECDFG $.

    $( Double restricted existential quantification.  (Contributed by NM,
       11-Nov-1995.) $)
    r2ex $p |- ( E. x e. A E. y e. B ph <->
               E. x E. y ( ( x e. A /\ y e. B ) /\ ph ) ) $=
      ( nfcv r2exf ) ABCDECDFG $.
  $}

  ${
    $d x y $.  $d y A $.
    2ralbida.1 $e |- F/ x ph $.
    2ralbida.2 $e |- F/ y ph $.
    2ralbida.3 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifier (deduction
       rule).  (Contributed by NM, 24-Feb-2004.) $)
    2ralbida $p |- ( ph ->
                     ( A. x e. A A. y e. B ps <-> A. x e. A A. y e. B ch ) ) $=
      ( wral cv wcel wa nfv nfan wb anassrs ralbida ) ABEGKCEGKDFHADLFMZNBCEGAT
      EITEOPATELGMBCQJRSS $.
  $}

  ${
    $d x y ph $.  $d y A $.
    2ralbidva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifiers (deduction
       rule).  (Contributed by NM, 4-Mar-1997.) $)
    2ralbidva $p |- ( ph ->
                     ( A. x e. A A. y e. B ps <-> A. x e. A A. y e. B ch ) ) $=
      ( nfv 2ralbida ) ABCDEFGADIAEIHJ $.

    $( Formula-building rule for restricted existential quantifiers (deduction
       rule).  (Contributed by NM, 15-Dec-2004.) $)
    2rexbidva $p |- ( ph ->
                    ( E. x e. A E. y e. B ps <-> E. x e. A E. y e. B ch ) ) $=
      ( wrex cv wcel wa wb anassrs rexbidva ) ABEGICEGIDFADJFKZLBCEGAPEJGKBCMHN
      OO $.
  $}

  ${
    $d x ph $.  $d y ph $.
    2ralbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted universal quantifiers (deduction
       rule).  (Contributed by NM, 28-Jan-2006.)  (Revised by Szymon
       Jaroszewicz, 16-Mar-2007.) $)
    2ralbidv $p |- ( ph ->
                     ( A. x e. A A. y e. B ps <-> A. x e. A A. y e. B ch ) ) $=
      ( wral ralbidv ) ABEGICEGIDFABCEGHJJ $.

    $( Formula-building rule for restricted existential quantifiers (deduction
       rule).  (Contributed by NM, 28-Jan-2006.) $)
    2rexbidv $p |- ( ph ->
                    ( E. x e. A E. y e. B ps <-> E. x e. A E. y e. B ch ) ) $=
      ( wrex rexbidv ) ABEGICEGIDFABCEGHJJ $.

    $( Formula-building rule for restricted quantifiers (deduction rule).
       (Contributed by NM, 28-Jan-2006.) $)
    rexralbidv $p |- ( ph ->
                    ( E. x e. A A. y e. B ps <-> E. x e. A A. y e. B ch ) ) $=
      ( wral ralbidv rexbidv ) ABEGICEGIDFABCEGHJK $.
  $}

  $( A transformation of restricted quantifiers and logical connectives.
     (Contributed by NM, 4-Sep-2005.) $)
  ralinexa $p |- ( A. x e. A ( ph -> -. ps ) <-> -. E. x e. A ( ph /\ ps ) ) $=
    ( wn wi wral wa wrex imnan ralbii ralnex bitri ) ABEFZCDGABHZEZCDGOCDIENPCD
    ABJKOCDLM $.

  $( A transformation of restricted quantifiers and logical connectives.
     (Contributed by NM, 4-Sep-2005.) $)
  rexanali $p |- ( E. x e. A ( ph /\ -. ps ) <-> -. A. x e. A ( ph -> ps ) ) $=
    ( wn wa wrex wi wral annim rexbii rexnal bitri ) ABEFZCDGABHZEZCDGOCDIENPCD
    ABJKOCDLM $.

  $( Negation of a complex predicate calculus formula.  (Contributed by FL,
     31-Jul-2009.) $)
  nrexralim $p |- ( -. E. x e. A A. y e. B ( ph -> ps )
     <-> A. x e. A E. y e. B ( ph /\ -. ps ) ) $=
    ( wn wa wrex wral wi rexanali ralbii ralnex bitr2i ) ABGHDFIZCEJABKDFJZGZCE
    JQCEIGPRCEABDFLMQCENO $.

  ${
    $d x A $.  $d x B $.
    $( Two ways to say " ` A ` belongs to ` B ` ."  (Contributed by NM,
       22-Nov-1994.) $)
    risset $p |- ( A e. B <-> E. x e. B x = A ) $=
      ( cv wcel wceq wa wex wrex exancom df-rex df-clel 3bitr4ri ) ADZCEZNBFZGA
      HPOGAHPACIBCEOPAJPACKABCLM $.
  $}

  ${
    hbral.1 $e |- ( y e. A -> A. x y e. A ) $.
    hbral.2 $e |- ( ph -> A. x ph ) $.
    $( Bound-variable hypothesis builder for restricted quantification.
       (Contributed by NM, 1-Sep-1999.)  (Revised by David Abernethy,
       13-Dec-2009.) $)
    hbral $p |- ( A. y e. A ph -> A. x A. y e. A ph ) $=
      ( wral cv wcel wi wal df-ral hbim hbal hbxfrbi ) ACDGCHDIZAJZCKBACDLQBCPA
      BEFMNO $.
  $}

  $( ` x ` is not free in ` A. x e. A ph ` .  (Contributed by NM,
     18-Oct-1996.) $)
  hbra1 $p |- ( A. x e. A ph -> A. x A. x e. A ph ) $=
    ( wral cv wcel wi wal df-ral hba1 hbxfrbi ) ABCDBECFAGZBHBABCILBJK $.

  $( ` x ` is not free in ` A. x e. A ph ` .  (Contributed by NM,
     18-Oct-1996.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
  nfra1 $p |- F/ x A. x e. A ph $=
    ( wral cv wcel wi wal df-ral nfa1 nfxfr ) ABCDBECFAGZBHBABCILBJK $.

  ${
    nfrald.2 $e |- F/ y ph $.
    nfrald.3 $e |- ( ph -> F/_ x A ) $.
    nfrald.4 $e |- ( ph -> F/ x ps ) $.
    $( Deduction version of ~ nfral .  (Contributed by NM, 15-Feb-2013.)
       (Revised by Mario Carneiro, 7-Oct-2016.) $)
    nfrald $p |- ( ph -> F/ x A. y e. A ps ) $=
      ( wral cv wcel wi wal df-ral weq wn wa wnfc nfcvf adantr adantl nfeld wnf
      nfimd nfald2 nfxfrd ) BDEIDJZEKZBLZDMACBDENAUICDFACDOCMPZQZUHBCUKCUGEUJCU
      GRACDSUAACERUJGTUBABCUCUJHTUDUEUF $.

    $( Deduction version of ~ nfrex .  (Contributed by Mario Carneiro,
       14-Oct-2016.) $)
    nfrexd $p |- ( ph -> F/ x E. y e. A ps ) $=
      ( wrex wn wral dfrex2 nfnd nfrald nfxfrd ) BDEIBJZDEKZJACBDELAQCAPCDEFGAB
      CHMNMO $.
  $}

  ${
    nfral.1 $e |- F/_ x A $.
    nfral.2 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for restricted quantification.
       (Contributed by NM, 1-Sep-1999.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    nfral $p |- F/ x A. y e. A ph $=
      ( wral wnf wtru nftru wnfc a1i nfrald trud ) ACDGBHIABCDCJBDKIELABHIFLMN
      $.
  $}

  ${
    $d A y $.
    $( Similar to Lemma 24 of [Monk2] p. 114, except the quantification of the
       antecedent is restricted.  Derived automatically from ~ hbra2VD .
       Contributed by Alan Sare 31-Dec-2011.  (Contributed by NM,
       31-Dec-2011.) $)
    nfra2 $p |- F/ y A. x e. A A. y e. B ph $=
      ( wral nfcv nfra1 nfral ) ACEFCBDCDGACEHI $.
  $}

  ${
    nfrex.1 $e |- F/_ x A $.
    nfrex.2 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for restricted quantification.
       (Contributed by NM, 1-Sep-1999.)  (Revised by Mario Carneiro,
       7-Oct-2016.) $)
    nfrex $p |- F/ x E. y e. A ph $=
      ( wrex wn wral dfrex2 nfn nfral nfxfr ) ACDGAHZCDIZHBACDJOBNBCDEABFKLKM
      $.
  $}

  $( ` x ` is not free in ` E. x e. A ph ` .  (Contributed by NM,
     19-Mar-1997.)  (Revised by Mario Carneiro, 7-Oct-2016.) $)
  nfre1 $p |- F/ x E. x e. A ph $=
    ( wrex cv wcel wa wex df-rex nfe1 nfxfr ) ABCDBECFAGZBHBABCILBJK $.

  ${
    $d x y z $.  $d y z A $.  $d z B $.
    $( Triple restricted universal quantification.  (Contributed by NM,
       19-Nov-1995.) $)
    r3al $p |- ( A. x e. A A. y e. B A. z e. C ph <->
               A. x A. y A. z ( ( x e. A /\ y e. B /\ z e. C ) -> ph ) ) $=
      ( cv wcel wa wi wal wral w3a df-ral r2al ralbii bitri albii 19.21v 3anass
      imbi1i impexp 3bitr4i ) CHFIZDHGIZJZAKZDLZCLZBEMBHEIZUJKZBLADGMCFMZBEMUKU
      EUFNZAKZDLZCLZBLUJBEOUMUJBEACDFGPQUQULBUQUKUIKZCLULUPURCUPUKUHKZDLURUOUSD
      UOUKUGJZAKUSUNUTAUKUEUFUAUBUKUGAUCRSUKUHDTRSUKUICTRSUD $.
  $}

  $( Universal quantification implies restricted quantification.  (Contributed
     by NM, 20-Oct-2006.) $)
  alral $p |- ( A. x ph -> A. x e. A ph ) $=
    ( wal cv wcel wi wral ax-1 alimi df-ral sylibr ) ABDBECFZAGZBDABCHANBAMIJAB
    CKL $.

  $( Restricted existence implies existence.  (Contributed by NM,
     11-Nov-1995.) $)
  rexex $p |- ( E. x e. A ph -> E. x ph ) $=
    ( wrex cv wcel wa wex df-rex exsimpr sylbi ) ABCDBECFZAGBHABHABCILABJK $.

  $( Restricted specialization.  (Contributed by NM, 17-Oct-1996.) $)
  rsp $p |- ( A. x e. A ph -> ( x e. A -> ph ) ) $=
    ( wral cv wcel wi wal df-ral sp sylbi ) ABCDBECFAGZBHLABCILBJK $.

  $( Restricted specialization.  (Contributed by NM, 12-Oct-1999.) $)
  rspe $p |- ( ( x e. A /\ ph ) -> E. x e. A ph ) $=
    ( cv wcel wa wex wrex 19.8a df-rex sylibr ) BDCEAFZLBGABCHLBIABCJK $.

  $( Restricted specialization.  (Contributed by NM, 11-Feb-1997.) $)
  rsp2 $p |- ( A. x e. A A. y e. B ph -> ( ( x e. A /\ y e. B ) -> ph ) ) $=
    ( wral cv wcel wi rsp syl6 imp3a ) ACEFZBDFZBGDHZCGEHZANOMPAIMBDJACEJKL $.

  $( Restricted specialization.  (Contributed by FL, 4-Jun-2012.) $)
  rsp2e $p |- ( ( x e. A /\ y e. B /\ ph ) -> E. x e. A E. y e. B ph ) $=
    ( cv wcel w3a wrex wa wex simp1 rspe 3adant1 19.8a syl2anc df-rex sylibr )
    BFDGZCFEGZAHZSACEIZJZBKZUBBDIUASUBUDSTALTAUBSACEMNUCBOPUBBDQR $.

  ${
    rspec.1 $e |- A. x e. A ph $.
    $( Specialization rule for restricted quantification.  (Contributed by NM,
       19-Nov-1994.) $)
    rspec $p |- ( x e. A -> ph ) $=
      ( wral cv wcel wi rsp ax-mp ) ABCEBFCGAHDABCIJ $.
  $}

  ${
    rgen.1 $e |- ( x e. A -> ph ) $.
    $( Generalization rule for restricted quantification.  (Contributed by NM,
       19-Nov-1994.) $)
    rgen $p |- A. x e. A ph $=
      ( wral cv wcel wi df-ral mpgbir ) ABCEBFCGAHBABCIDJ $.
  $}

  ${
    $d y z A $.  $d x z $.
    rgen2a.1 $e |- ( ( x e. A /\ y e. A ) -> ph ) $.
    $( Generalization rule for restricted quantification.  Note that ` x ` and
       ` y ` needn't be distinct (and illustrates the use of ~ dvelim ).
       (Contributed by NM, 23-Nov-1994.)  (Proof shortened by Andrew Salmon,
       25-May-2011.)  (Proof modification is discouraged. $)
    rgen2a $p |- A. x e. A A. y e. A ph $=
      ( vz wral cv wcel wi wal weq eleq1 ex syl6bi pm2.43d alimi a1d wn dvelimv
      syl6 pm2.61i df-ral sylibr rgen ) ACDGZBDBHZDIZCHZDIZAJZCKZUFCBLZCKZUHULJ
      UNULUHUMUKCUMUJAUMUJUHUKUIUGDMUHUJAENZOPQRUNSUHUHCKULFHZDIUHCBFUPUGDMTUHU
      KCUOQUAUBACDUCUDUE $.
  $}

  ${
    rgenw.1 $e |- ph $.
    $( Generalization rule for restricted quantification.  (Contributed by NM,
       18-Jun-2014.) $)
    rgenw $p |- A. x e. A ph $=
      ( cv wcel a1i rgen ) ABCABECFDGH $.

    $( Generalization rule for restricted quantification.  Note that ` x ` and
       ` y ` needn't be distinct.  (Contributed by NM, 18-Jun-2014.) $)
    rgen2w $p |- A. x e. A A. y e. B ph $=
      ( wral rgenw ) ACEGBDACEFHH $.
  $}

  ${
    mprg.1 $e |- ( A. x e. A ph -> ps ) $.
    mprg.2 $e |- ( x e. A -> ph ) $.
    $( Modus ponens combined with restricted generalization.  (Contributed by
       NM, 10-Aug-2004.) $)
    mprg $p |- ps $=
      ( wral rgen ax-mp ) ACDGBACDFHEI $.
  $}

  ${
    mprgbir.1 $e |- ( ph <-> A. x e. A ps ) $.
    mprgbir.2 $e |- ( x e. A -> ps ) $.
    $( Modus ponens on biconditional combined with restricted generalization.
       (Contributed by NM, 21-Mar-2004.) $)
    mprgbir $p |- ph $=
      ( wral rgen mpbir ) ABCDGBCDFHEI $.
  $}

  $( Distribution of restricted quantification over implication.  (Contributed
     by NM, 9-Feb-1997.) $)
  ralim $p |- ( A. x e. A ( ph -> ps ) ->
               ( A. x e. A ph -> A. x e. A ps ) ) $=
    ( wi wral cv wcel wal df-ral ax-2 al2imi sylbi 3imtr4g ) ABEZCDFZCGDHZAEZCI
    ZQBEZCIZACDFBCDFPQOEZCISUAEOCDJUBRTCQABKLMACDJBCDJN $.

  ${
    ralimi2.1 $e |- ( ( x e. A -> ph ) -> ( x e. B -> ps ) ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 22-Feb-2004.) $)
    ralimi2 $p |- ( A. x e. A ph -> A. x e. B ps ) $=
      ( cv wcel wi wal wral alimi df-ral 3imtr4i ) CGZDHAIZCJOEHBIZCJACDKBCEKPQ
      CFLACDMBCEMN $.
  $}

  ${
    ralimia.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 19-Jul-1996.) $)
    ralimia $p |- ( A. x e. A ph -> A. x e. A ps ) $=
      ( cv wcel a2i ralimi2 ) ABCDDCFDGABEHI $.
  $}

  ${
    ralimiaa.1 $e |- ( ( x e. A /\ ph ) -> ps ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 4-Aug-2007.) $)
    ralimiaa $p |- ( A. x e. A ph -> A. x e. A ps ) $=
      ( cv wcel ex ralimia ) ABCDCFDGABEHI $.
  $}

  ${
    ralimi.1 $e |- ( ph -> ps ) $.
    $( Inference quantifying both antecedent and consequent, with strong
       hypothesis.  (Contributed by NM, 4-Mar-1997.) $)
    ralimi $p |- ( A. x e. A ph -> A. x e. A ps ) $=
      ( wi cv wcel a1i ralimia ) ABCDABFCGDHEIJ $.
  $}

  ${
    ral2imi.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference quantifying antecedent, nested antecedent, and consequent,
       with a strong hypothesis.  (Contributed by NM, 19-Dec-2006.) $)
    ral2imi $p |- ( A. x e. A ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      ( wral wi ralimi ralim syl ) ADEGBCHZDEGBDEGCDEGHALDEFIBCDEJK $.
  $}

  ${
    ralimdaa.1 $e |- F/ x ph $.
    ralimdaa.2 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.20 of [Margaris] p. 90.  (Contributed by NM, 22-Sep-2003.) $)
    ralimdaa $p |- ( ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      ( cv wcel wi wal wral ex a2d alimd df-ral 3imtr4g ) ADHEIZBJZDKRCJZDKBDEL
      CDELASTDFARBCARBCJGMNOBDEPCDEPQ $.
  $}

  ${
    $d x ph $.
    ralimdva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.20 of [Margaris] p. 90.  (Contributed by NM, 22-May-1999.) $)
    ralimdva $p |- ( ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      ( nfv ralimdaa ) ABCDEADGFH $.
  $}

  ${
    $d x ph $.
    ralimdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.20 of [Margaris] p. 90.  (Contributed by NM, 8-Oct-2003.) $)
    ralimdv $p |- ( ph -> ( A. x e. A ps -> A. x e. A ch ) ) $=
      ( wi cv wcel adantr ralimdva ) ABCDEABCGDHEIFJK $.
  $}

  ${
    $d x ph $.
    ralimdv2.1 $e |- ( ph -> ( ( x e. A -> ps ) -> ( x e. B -> ch ) ) ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 1-Feb-2005.) $)
    ralimdv2 $p |- ( ph -> ( A. x e. A ps -> A. x e. B ch ) ) $=
      ( cv wcel wi wal wral alimdv df-ral 3imtr4g ) ADHZEIBJZDKPFICJZDKBDELCDFL
      AQRDGMBDENCDFNO $.
  $}

  ${
    ralrimi.1 $e |- F/ x ph $.
    ralrimi.2 $e |- ( ph -> ( x e. A -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 10-Oct-1999.) $)
    ralrimi $p |- ( ph -> A. x e. A ps ) $=
      ( cv wcel wi wal wral alrimi df-ral sylibr ) ACGDHBIZCJBCDKAOCEFLBCDMN $.
  $}

  ${
    $d x ph $.
    ralrimiv.1 $e |- ( ph -> ( x e. A -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 22-Nov-1994.) $)
    ralrimiv $p |- ( ph -> A. x e. A ps ) $=
      ( nfv ralrimi ) ABCDACFEG $.
  $}

  ${
    $d x ph $.
    ralrimiva.1 $e |- ( ( ph /\ x e. A ) -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 2-Jan-2006.) $)
    ralrimiva $p |- ( ph -> A. x e. A ps ) $=
      ( cv wcel ex ralrimiv ) ABCDACFDGBEHI $.
  $}

  ${
    $d x ph $.
    ralrimivw.1 $e |- ( ph -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 18-Jun-2014.) $)
    ralrimivw $p |- ( ph -> A. x e. A ps ) $=
      ( cv wcel a1d ralrimiv ) ABCDABCFDGEHI $.
  $}

  ${
    $( Theorem 19.21 of [Margaris] p. 90 with restricted quantifiers (closed
       theorem version).  (Contributed by NM, 1-Mar-2008.) $)
    r19.21t $p |- ( F/ x ph ->
             ( A. x e. A ( ph -> ps ) <-> ( ph -> A. x e. A ps ) ) ) $=
      ( wnf cv wcel wal wral bi2.04 albii 19.21t syl5bb df-ral imbi2i 3bitr4g
      wi ) ACEZCFDGZABQZQZCHZASBQZCHZQZTCDIABCDIZQUBAUCQZCHRUEUAUGCSABJKAUCCLMT
      CDNUFUDABCDNOP $.
  $}

  ${
    r19.21.1 $e |- F/ x ph $.
    $( Theorem 19.21 of [Margaris] p. 90 with restricted quantifiers.
       (Contributed by Scott Fenton, 30-Mar-2011.) $)
    r19.21 $p |- ( A. x e. A ( ph -> ps ) <-> ( ph -> A. x e. A ps ) ) $=
      ( wnf wi wral wb r19.21t ax-mp ) ACFABGCDHABCDHGIEABCDJK $.
  $}

  ${
    $d x ph $.
    $( Theorem 19.21 of [Margaris] p. 90 with restricted quantifiers.
       (Contributed by NM, 15-Oct-2003.)  (Proof shortened by Andrew Salmon,
       30-May-2011.) $)
    r19.21v $p |- ( A. x e. A ( ph -> ps ) <-> ( ph -> A. x e. A ps ) ) $=
      ( nfv r19.21 ) ABCDACEF $.
  $}

  ${
    ralrimd.1 $e |- F/ x ph $.
    ralrimd.2 $e |- F/ x ps $.
    ralrimd.3 $e |- ( ph -> ( ps -> ( x e. A -> ch ) ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 16-Feb-2004.) $)
    ralrimd $p |- ( ph -> ( ps -> A. x e. A ch ) ) $=
      ( cv wcel wi wal wral alrimd df-ral syl6ibr ) ABDIEJCKZDLCDEMABQDFGHNCDEO
      P $.
  $}

  ${
    $d x ph $.  $d x ps $.
    ralrimdv.1 $e |- ( ph -> ( ps -> ( x e. A -> ch ) ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 27-May-1998.) $)
    ralrimdv $p |- ( ph -> ( ps -> A. x e. A ch ) ) $=
      ( nfv ralrimd ) ABCDEADGBDGFH $.
  $}

  ${
    $d x ph $.  $d x ps $.
    ralrimdva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 2-Feb-2008.) $)
    ralrimdva $p |- ( ph -> ( ps -> A. x e. A ch ) ) $=
      ( cv wcel wi ex com23 ralrimdv ) ABCDEADGEHZBCAMBCIFJKL $.
  $}

  ${
    $d x y ph $.  $d y A $.
    ralrimivv.1 $e |- ( ph -> ( ( x e. A /\ y e. B ) -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.)  (Contributed by NM,
       24-Jul-2004.) $)
    ralrimivv $p |- ( ph -> A. x e. A A. y e. B ps ) $=
      ( wral cv wcel exp3a ralrimdv ralrimiv ) ABDFHCEACIEJZBDFANDIFJBGKLM $.
  $}

  ${
    $d ph x y $.  $d A y $.
    ralrimivva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.)  (Contributed by Jeff
       Madsen, 19-Jun-2011.) $)
    ralrimivva $p |- ( ph -> A. x e. A A. y e. B ps ) $=
      ( cv wcel wa ex ralrimivv ) ABCDEFACHEIDHFIJBGKL $.
  $}

  ${
    $d ph x y z $.  $d A y z $.  $d B z $.
    ralrimivvva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B /\ z e. C ) ) -> ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with triple quantification.)  (Contributed by Mario
       Carneiro, 9-Jul-2014.) $)
    ralrimivvva $p |- ( ph -> A. x e. A A. y e. B A. z e. C ps ) $=
      ( wral cv wcel wa 3anassrs ralrimiva ) ABEHJZDGJCFACKFLZMZPDGRDKGLZMBEHAQ
      SEKHLBINOOO $.
  $}

  ${
    $d x y ph $.  $d x y ps $.  $d y A $.
    ralrimdvv.1 $e |- ( ph -> ( ps -> ( ( x e. A /\ y e. B ) -> ch ) ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.)  (Contributed by NM,
       1-Jun-2005.) $)
    ralrimdvv $p |- ( ph -> ( ps -> A. x e. A A. y e. B ch ) ) $=
      ( wral wa cv wcel wi imp ralrimivv ex ) ABCEGIDFIABJCDEFGABDKFLEKGLJCMHNO
      P $.
  $}

  ${
    $d x y ph $.  $d x y ps $.  $d y A $.
    ralrimdvva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version with double quantification.)  (Contributed by NM,
       2-Feb-2008.) $)
    ralrimdvva $p |- ( ph -> ( ps -> A. x e. A A. y e. B ch ) ) $=
      ( cv wcel wa wi ex com23 ralrimdvv ) ABCDEFGADIFJEIGJKZBCAPBCLHMNO $.
  $}

  ${
    $d x y $.  $d y A $.
    rgen2.1 $e |- ( ( x e. A /\ y e. B ) -> ph ) $.
    $( Generalization rule for restricted quantification.  (Contributed by NM,
       30-May-1999.) $)
    rgen2 $p |- A. x e. A A. y e. B ph $=
      ( wral cv wcel ralrimiva rgen ) ACEGBDBHDIACEFJK $.
  $}

  ${
    $d y z A $.  $d z B $.  $d x y z $.
    rgen3.1 $e |- ( ( x e. A /\ y e. B /\ z e. C ) -> ph ) $.
    $( Generalization rule for restricted quantification.  (Contributed by NM,
       12-Jan-2008.) $)
    rgen3 $p |- A. x e. A A. y e. B A. z e. C ph $=
      ( wral cv wcel wa 3expa ralrimiva rgen2 ) ADGIBCEFBJEKZCJFKZLADGPQDJGKAHM
      NO $.
  $}

  ${
    r19.21bi.1 $e |- ( ph -> A. x e. A ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 20-Nov-1994.) $)
    r19.21bi $p |- ( ( ph /\ x e. A ) -> ps ) $=
      ( cv wcel wi wral wal df-ral sylib 19.21bi imp ) ACFDGZBAOBHZCABCDIPCJEBC
      DKLMN $.
  $}

  ${
    rspec2.1 $e |- A. x e. A A. y e. B ph $.
    $( Specialization rule for restricted quantification.  (Contributed by NM,
       20-Nov-1994.) $)
    rspec2 $p |- ( ( x e. A /\ y e. B ) -> ph ) $=
      ( cv wcel wral rspec r19.21bi ) BGDHACEACEIBDFJK $.
  $}

  ${
    rspec3.1 $e |- A. x e. A A. y e. B A. z e. C ph $.
    $( Specialization rule for restricted quantification.  (Contributed by NM,
       20-Nov-1994.) $)
    rspec3 $p |- ( ( x e. A /\ y e. B /\ z e. C ) -> ph ) $=
      ( cv wcel wa wral rspec2 r19.21bi 3impa ) BIEJZCIFJZDIGJAPQKADGADGLBCEFHM
      NO $.
  $}

  ${
    r19.21be.1 $e |- ( ph -> A. x e. A ps ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 21-Nov-1994.) $)
    r19.21be $p |- A. x e. A ( ph -> ps ) $=
      ( wi cv wcel r19.21bi expcom rgen ) ABFCDACGDHBABCDEIJK $.
  $}

  ${
    nrex.1 $e |- ( x e. A -> -. ps ) $.
    $( Inference adding restricted existential quantifier to negated wff.
       (Contributed by NM, 16-Oct-2003.) $)
    nrex $p |- -. E. x e. A ps $=
      ( wn wral wrex rgen ralnex mpbi ) AEZBCFABCGEKBCDHABCIJ $.
  $}

  ${
    $d x ph $.
    nrexdv.1 $e |- ( ( ph /\ x e. A ) -> -. ps ) $.
    $( Deduction adding restricted existential quantifier to negated wff.
       (Contributed by NM, 16-Oct-2003.) $)
    nrexdv $p |- ( ph -> -. E. x e. A ps ) $=
      ( wn wral wrex ralrimiva ralnex sylib ) ABFZCDGBCDHFALCDEIBCDJK $.
  $}

  $( Theorem 19.22 of [Margaris] p. 90.  (Restricted quantifier version.)
     (Contributed by NM, 22-Nov-1994.)  (Proof shortened by Andrew Salmon,
     30-May-2011.) $)
  rexim $p |- ( A. x e. A ( ph -> ps ) ->
               ( E. x e. A ph -> E. x e. A ps ) ) $=
    ( wi wral wn wrex con3 ral2imi con3d dfrex2 3imtr4g ) ABEZCDFZAGZCDFZGBGZCD
    FZGACDHBCDHOSQNRPCDABIJKACDLBCDLM $.

  ${
    reximia.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 10-Feb-1997.) $)
    reximia $p |- ( E. x e. A ph -> E. x e. A ps ) $=
      ( wi wrex rexim mprg ) ABFACDGBCDGFCDABCDHEI $.
  $}

  ${
    reximi2.1 $e |- ( ( x e. A /\ ph ) -> ( x e. B /\ ps ) ) $.
    $( Inference quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90.  (Contributed by NM, 8-Nov-2004.) $)
    reximi2 $p |- ( E. x e. A ph -> E. x e. B ps ) $=
      ( cv wcel wa wex wrex eximi df-rex 3imtr4i ) CGZDHAIZCJOEHBIZCJACDKBCEKPQ
      CFLACDMBCEMN $.
  $}

  ${
    reximi.1 $e |- ( ph -> ps ) $.
    $( Inference quantifying both antecedent and consequent.  (Contributed by
       NM, 18-Oct-1996.) $)
    reximi $p |- ( E. x e. A ph -> E. x e. A ps ) $=
      ( wi cv wcel a1i reximia ) ABCDABFCGDHEIJ $.
  $}

  ${
    reximdai.1 $e |- F/ x ph $.
    reximdai.2 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 31-Aug-1999.) $)
    reximdai $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      ( wi wral wrex ralrimi rexim syl ) ABCHZDEIBDEJCDEJHANDEFGKBCDELM $.
  $}

  ${
    $d x ph $.
    reximdv2.1 $e |- ( ph -> ( ( x e. A /\ ps ) -> ( x e. B /\ ch ) ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90.  (Contributed by NM, 17-Sep-2003.) $)
    reximdv2 $p |- ( ph -> ( E. x e. A ps -> E. x e. B ch ) ) $=
      ( cv wcel wa wex wrex eximdv df-rex 3imtr4g ) ADHZEIBJZDKPFICJZDKBDELCDFL
      AQRDGMBDENCDFNO $.
  $}

  ${
    $d x ph $.
    reximdvai.1 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90.  (Contributed by NM, 14-Nov-2002.) $)
    reximdvai $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      ( nfv reximdai ) ABCDEADGFH $.
  $}

  ${
    $d x ph $.
    reximdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Restricted
       quantifier version with strong hypothesis.)  (Contributed by NM,
       24-Jun-1998.) $)
    reximdv $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      ( wi cv wcel a1d reximdvai ) ABCDEABCGDHEIFJK $.
  $}

  ${
    $d x ph $.
    reximdva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction quantifying both antecedent and consequent, based on Theorem
       19.22 of [Margaris] p. 90.  (Contributed by NM, 22-May-1999.) $)
    reximdva $p |- ( ph -> ( E. x e. A ps -> E. x e. A ch ) ) $=
      ( cv wcel wi ex reximdvai ) ABCDEADGEHBCIFJK $.
  $}

  ${
    $d x y $.  $d y A $.  $d x B $.
    $( Theorem 19.12 of [Margaris] p. 89 with restricted quantifiers.
       (Contributed by NM, 15-Oct-2003.)  (Proof shortened by Andrew Salmon,
       30-May-2011.) $)
    r19.12 $p |- ( E. x e. A A. y e. B ph -> A. y e. B E. x e. A ph ) $=
      ( wral wrex nfcv nfra1 nfrex cv wcel ax-1 ralrimi rsp reximdv ralimia syl
      com12 ) ACEFZBDGZUACEFABDGZCEFUAUACETCBDCDHACEIJUACKELZMNUAUBCEUCTABDTUCA
      ACEOSPQR $.
  $}

  $( Closed theorem form of ~ r19.23 .  (Contributed by NM, 4-Mar-2013.)
     (Revised by Mario Carneiro, 8-Oct-2016.) $)
  r19.23t $p |- ( F/ x ps ->
    ( A. x e. A ( ph -> ps ) <-> ( E. x e. A ph -> ps ) ) ) $=
    ( wnf cv wcel wa wal wex wral wrex 19.23t df-ral impexp albii bitr4i df-rex
    wi imbi1i 3bitr4g ) BCECFDGZAHZBSZCIZUCCJZBSABSZCDKZACDLZBSUCBCMUHUBUGSZCIU
    EUGCDNUDUJCUBABOPQUIUFBACDRTUA $.

  ${
    r19.23.1 $e |- F/ x ps $.
    $( Theorem 19.23 of [Margaris] p. 90 with restricted quantifiers.
       (Contributed by NM, 22-Oct-2010.)  (Proof shortened by Mario Carneiro,
       8-Oct-2016.) $)
    r19.23 $p |- ( A. x e. A ( ph -> ps ) <-> ( E. x e. A ph -> ps ) ) $=
      ( wnf wi wral wrex wb r19.23t ax-mp ) BCFABGCDHACDIBGJEABCDKL $.
  $}

  ${
    $d x ps $.
    $( Theorem 19.23 of [Margaris] p. 90 with restricted quantifiers.
       (Contributed by NM, 31-Aug-1999.) $)
    r19.23v $p |- ( A. x e. A ( ph -> ps ) <-> ( E. x e. A ph -> ps ) ) $=
      ( nfv r19.23 ) ABCDBCEF $.
  $}

  ${
    rexlimi.1 $e |- F/ x ps $.
    rexlimi.2 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference from Theorem 19.21 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 30-Nov-2003.)  (Proof
       shortened by Andrew Salmon, 30-May-2011.) $)
    rexlimi $p |- ( E. x e. A ph -> ps ) $=
      ( wi wral wrex rgen r19.23 mpbi ) ABGZCDHACDIBGMCDFJABCDEKL $.
  $}

  ${
    $d x ps $.
    rexlimiv.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 20-Nov-1994.) $)
    rexlimiv $p |- ( E. x e. A ph -> ps ) $=
      ( nfv rexlimi ) ABCDBCFEG $.
  $}

  ${
    $d x ps $.
    rexlimiva.1 $e |- ( ( x e. A /\ ph ) -> ps ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 18-Dec-2006.) $)
    rexlimiva $p |- ( E. x e. A ph -> ps ) $=
      ( cv wcel ex rexlimiv ) ABCDCFDGABEHI $.
  $}

  ${
    $d ps x $.
    rexlimivw.1 $e |- ( ph -> ps ) $.
    $( Weaker version of ~ rexlimiv .  (Contributed by FL, 19-Sep-2011.) $)
    rexlimivw $p |- ( E. x e. A ph -> ps ) $=
      ( wi cv wcel a1i rexlimiv ) ABCDABFCGDHEIJ $.
  $}

  ${
    rexlimd.1 $e |- F/ x ph $.
    rexlimd.2 $e |- F/ x ch $.
    rexlimd.3 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Deduction from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 27-May-1998.)  (Proof shortened by Andrew
       Salmon, 30-May-2011.) $)
    rexlimd $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( wi wral wrex ralrimi r19.23 sylib ) ABCIZDEJBDEKCIAODEFHLBCDEGMN $.
  $}

  ${
    rexlimd2.1 $e |- F/ x ph $.
    rexlimd2.2 $e |- ( ph -> F/ x ch ) $.
    rexlimd2.3 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Version of ~ rexlimd with deduction version of second hypothesis.
       (Contributed by NM, 21-Jul-2013.)  (Revised by Mario Carneiro,
       8-Oct-2016.) $)
    rexlimd2 $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( wi wral wrex ralrimi wnf wb r19.23t syl mpbid ) ABCIZDEJZBDEKCIZARDEFHL
      ACDMSTNGBCDEOPQ $.
  $}

  ${
    $d x ph $.  $d x ch $.
    rexlimdv.1 $e |- ( ph -> ( x e. A -> ( ps -> ch ) ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 14-Nov-2002.)  (Proof shortened by Eric
       Schmidt, 22-Dec-2006.) $)
    rexlimdv $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( nfv rexlimd ) ABCDEADGCDGFH $.
  $}

  ${
    $d x ph $.  $d x ch $.
    rexlimdva.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 20-Jan-2007.) $)
    rexlimdva $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( cv wcel wi ex rexlimdv ) ABCDEADGEHBCIFJK $.
  $}

  ${
    $d x ph $.  $d x ch $.
    rexlimdvaa.1 $e |- ( ( ph /\ ( x e. A /\ ps ) ) -> ch ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by Mario Carneiro, 15-Jun-2016.) $)
    rexlimdvaa $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( cv wcel expr rexlimdva ) ABCDEADGEHBCFIJ $.
  $}

  ${
    $d x ph $.  $d x ch $.
    rexlimdv3a.1 $e |- ( ( ph /\ x e. A /\ ps ) -> ch ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  Frequently-used variant of ~ rexlimdv .  (Contributed by NM,
       7-Jun-2015.) $)
    rexlimdv3a $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( cv wcel 3exp rexlimdv ) ABCDEADGEHBCFIJ $.
  $}

  ${
    $d x ph $.  $d x ch $.
    rexlimdvw.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 18-Jun-2014.) $)
    rexlimdvw $p |- ( ph -> ( E. x e. A ps -> ch ) ) $=
      ( wi cv wcel a1d rexlimdv ) ABCDEABCGDHEIFJK $.
  $}

  ${
    $d x ph $.  $d x ch $.
    rexlimddv.1 $e |- ( ph -> E. x e. A ps ) $.
    rexlimddv.2 $e |- ( ( ph /\ ( x e. A /\ ps ) ) -> ch ) $.
    $( Restricted existential elimination rule of natural deduction.
       (Contributed by Mario Carneiro, 15-Jun-2016.) $)
    rexlimddv $p |- ( ph -> ch ) $=
      ( wrex rexlimdvaa mpd ) ABDEHCFABCDEGIJ $.
  $}

  ${
    $d x y ps $.  $d y A $.
    rexlimivv.1 $e |- ( ( x e. A /\ y e. B ) -> ( ph -> ps ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90 (restricted quantifier
       version).  (Contributed by NM, 17-Feb-2004.) $)
    rexlimivv $p |- ( E. x e. A E. y e. B ph -> ps ) $=
      ( wrex cv wcel rexlimdva rexlimiv ) ADFHBCECIEJABDFGKL $.
  $}

  ${
    $d x y ph $.  $d x y ch $.  $d y A $.
    rexlimdvv.1 $e |- ( ph -> ( ( x e. A /\ y e. B ) -> ( ps -> ch ) ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 22-Jul-2004.) $)
    rexlimdvv $p |- ( ph -> ( E. x e. A E. y e. B ps -> ch ) ) $=
      ( wrex cv wcel wa wi expdimp rexlimdv rexlimdva ) ABEGICDFADJFKZLBCEGAQEJ
      GKBCMHNOP $.
  $}

  ${
    $d x y ph $.  $d x y ch $.  $d y A $.
    rexlimdvva.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> ( ps -> ch ) ) $.
    $( Inference from Theorem 19.23 of [Margaris] p. 90.  (Restricted
       quantifier version.)  (Contributed by NM, 18-Jun-2014.) $)
    rexlimdvva $p |- ( ph -> ( E. x e. A E. y e. B ps -> ch ) ) $=
      ( cv wcel wa wi ex rexlimdvv ) ABCDEFGADIFJEIGJKBCLHMN $.
  $}

  $( Theorem 19.26 of [Margaris] p. 90 with restricted quantifiers.
     (Contributed by NM, 28-Jan-1997.)  (Proof shortened by Andrew Salmon,
     30-May-2011.) $)
  r19.26 $p |- ( A. x e. A ( ph /\ ps ) <->
               ( A. x e. A ph /\ A. x e. A ps ) ) $=
    ( wa wral simpl ralimi simpr jca pm3.2 ral2imi imp impbii ) ABEZCDFZACDFZBC
    DFZEPQROACDABGHOBCDABIHJQRPABOCDABKLMN $.

  $( Theorem 19.26 of [Margaris] p. 90 with 2 restricted quantifiers.
     (Contributed by NM, 10-Aug-2004.) $)
  r19.26-2 $p |- ( A. x e. A A. y e. B ( ph /\ ps ) <->
               ( A. x e. A A. y e. B ph /\ A. x e. A A. y e. B ps ) ) $=
    ( wa wral r19.26 ralbii bitri ) ABGDFHZCEHADFHZBDFHZGZCEHMCEHNCEHGLOCEABDFI
    JMNCEIK $.

  $( Theorem 19.26 of [Margaris] p. 90 with 3 restricted quantifiers.
     (Contributed by FL, 22-Nov-2010.) $)
  r19.26-3 $p |- ( A. x e. A ( ph /\ ps /\ ch ) <->
               ( A. x e. A ph /\ A. x e. A ps /\ A. x e. A ch ) ) $=
    ( w3a wral wa df-3an ralbii r19.26 anbi1i bitr4i 3bitri ) ABCFZDEGABHZCHZDE
    GPDEGZCDEGZHZADEGZBDEGZSFZOQDEABCIJPCDEKTUAUBHZSHUCRUDSABDEKLUAUBSIMN $.

  $( Theorem 19.26 of [Margaris] p. 90 with mixed quantifiers.  (Contributed by
     NM, 22-Feb-2004.) $)
  r19.26m $p |- ( A. x ( ( x e. A -> ph ) /\ ( x e. B -> ps ) ) <->
               ( A. x e. A ph /\ A. x e. B ps ) ) $=
    ( cv wcel wi wa wal wral 19.26 df-ral anbi12i bitr4i ) CFZDGAHZPEGBHZICJQCJ
    ZRCJZIACDKZBCEKZIQRCLUASUBTACDMBCEMNO $.

  $( Distribute a restricted universal quantifier over a biconditional.
     Theorem 19.15 of [Margaris] p. 90 with restricted quantification.
     (Contributed by NM, 6-Oct-2003.) $)
  ralbi $p |- ( A. x e. A ( ph <-> ps ) ->
               ( A. x e. A ph <-> A. x e. A ps ) ) $=
    ( wb wral nfra1 cv wcel rsp imp ralbida ) ABEZCDFZABCDMCDGNCHDIMMCDJKL $.

  $( Split a biconditional and distribute quantifier.  (Contributed by NM,
     3-Jun-2012.) $)
  ralbiim $p |- ( A. x e. A ( ph <-> ps ) <->
             ( A. x e. A ( ph -> ps ) /\ A. x e. A ( ps -> ph ) ) ) $=
    ( wb wral wi wa dfbi2 ralbii r19.26 bitri ) ABEZCDFABGZBAGZHZCDFNCDFOCDFHMP
    CDABIJNOCDKL $.

  ${
    $d x ps $.
    $( Restricted version of one direction of Theorem 19.27 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.)
       (Contributed by NM, 3-Jun-2004.)  (Proof shortened by Andrew Salmon,
       30-May-2011.) $)
    r19.27av $p |- ( ( A. x e. A ph /\ ps ) -> A. x e. A ( ph /\ ps ) ) $=
      ( wral wa cv wcel ax-1 ralrimiv anim2i r19.26 sylibr ) ACDEZBFNBCDEZFABFC
      DEBONBBCDBCGDHIJKABCDLM $.
  $}

  ${
    $d x ph $.
    $( Restricted version of one direction of Theorem 19.28 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.)
       (Contributed by NM, 2-Apr-2004.) $)
    r19.28av $p |- ( ( ph /\ A. x e. A ps ) -> A. x e. A ( ph /\ ps ) ) $=
      ( wral wa r19.27av ancom ralbii 3imtr4i ) BCDEZAFBAFZCDEAKFABFZCDEBACDGAK
      HMLCDABHIJ $.
  $}

  $( Theorem 19.29 of [Margaris] p. 90 with restricted quantifiers.
     (Contributed by NM, 31-Aug-1999.)  (Proof shortened by Andrew Salmon,
     30-May-2011.) $)
  r19.29 $p |- ( ( A. x e. A ph /\ E. x e. A ps ) ->
               E. x e. A ( ph /\ ps ) ) $=
    ( wral wrex wa wi pm3.2 ralimi rexim syl imp ) ACDEZBCDFZABGZCDFZNBPHZCDEOQ
    HARCDABIJBPCDKLM $.

  $( Variation of Theorem 19.29 of [Margaris] p. 90 with restricted
     quantifiers.  (Contributed by NM, 31-Aug-1999.) $)
  r19.29r $p |- ( ( E. x e. A ph /\ A. x e. A ps ) ->
                E. x e. A ( ph /\ ps ) ) $=
    ( wral wrex wa r19.29 ancom rexbii 3imtr4i ) BCDEZACDFZGBAGZCDFMLGABGZCDFBA
    CDHMLIONCDABIJK $.

  ${
    r19.29af2.p $e |- F/ x ph $.
    r19.29af2.c $e |- F/ x ch $.
    r19.29af2.1 $e |- ( ( ( ph /\ x e. A ) /\ ps ) -> ch ) $.
    r19.29af2.2 $e |- ( ph -> E. x e. A ps ) $.
    $( A commonly used pattern based on ~ r19.29 (Contributed by Thierry
       Arnoux, 17-Dec-2017.) $)
    r19.29af2 $p |- ( ph -> ch ) $=
      ( wrex wi wral wa cv wcel exp31 ralrimi jca r19.29r pm3.35 rexlimi 3syl
      a1i ) ABDEJZBCKZDELZMBUEMZDEJCAUDUFIAUEDEFADNEOZBCHPQRBUEDESUGCDEGUGCKUHB
      CTUCUAUB $.
  $}

  ${
    $d x ch $.
    r19.29af.0 $e |- F/ x ph $.
    r19.29af.1 $e |- ( ( ( ph /\ x e. A ) /\ ps ) -> ch ) $.
    r19.29af.2 $e |- ( ph -> E. x e. A ps ) $.
    $( A commonly used pattern based on ~ r19.29 (Contributed by Thierry
       Arnoux, 29-Nov-2017.) $)
    r19.29af $p |- ( ph -> ch ) $=
      ( nfv r19.29af2 ) ABCDEFCDIGHJ $.
  $}

  ${
    $d x ch $.  $d x ph $.
    r19.29a.1 $e |- ( ( ( ph /\ x e. A ) /\ ps ) -> ch ) $.
    r19.29a.2 $e |- ( ph -> E. x e. A ps ) $.
    $( A commonly used pattern based on ~ r19.29 (Contributed by Thierry
       Arnoux, 22-Nov-2017.) $)
    r19.29a $p |- ( ph -> ch ) $=
      ( nfv r19.29af ) ABCDEADHFGI $.
  $}

  ${
    r19.29d2r.1 $e |- ( ph -> A. x e. A A. y e. B ps ) $.
    r19.29d2r.2 $e |- ( ph -> E. x e. A E. y e. B ch ) $.
    $( Theorem 19.29 of [Margaris] p. 90 with two restricted quantifiers,
       deduction version (Contributed by Thierry Arnoux, 30-Jan-2017.) $)
    r19.29d2r $p |- ( ph -> E. x e. A E. y e. B ( ps /\ ch ) ) $=
      ( wral wrex wa r19.29 syl2anc reximi syl ) ABEGJZCEGKZLZDFKZBCLEGKZDFKAQD
      FJRDFKTHIQRDFMNSUADFBCEGMOP $.
  $}

  ${
    $d y A $.  $d x y ch $.  $d x y ph $.
    r19.29_2a.1 $e |- ( ( ( ( ph /\ x e. A ) /\ y e. B ) /\ ps ) -> ch ) $.
    r19.29_2a.2 $e |- ( ph -> E. x e. A E. y e. B ps ) $.
    $( A commonly used pattern based on ~ r19.29 , version with two restricted
       quantifiers (Contributed by Thierry Arnoux, 26-Nov-2017.) $)
    r19.29_2a $p |- ( ph -> ch ) $=
      ( wi wa wrex wral cv wcel ex ralrimiva r19.29d2r pm3.35 rexlimivw ancoms
      syl ) ABCJZBKZEGLZDFLCAUCBDEFGAUCEGMDFADNFOKZUCEGUFENGOKBCHPQQIRUECDFUDCE
      GBUCCBCSUATTUB $.
  $}

  $( Theorem 19.30 of [Margaris] p. 90 with restricted quantifiers.
     (Contributed by Scott Fenton, 25-Feb-2011.) $)
  r19.30 $p |- ( A. x e. A ( ph \/ ps ) ->
                 ( A. x e. A ph \/ E. x e. A ps ) ) $=
    ( wn wi wral wrex ralim orcom df-or bitri ralbii dfrex2 orbi2i imor 3bitr4i
    wo 3imtr4i ) BEZAFZCDGTCDGZACDGZFZABRZCDGUCBCDHZRZTACDIUEUACDUEBARUAABJBAKL
    MUCUBEZRUHUCRUGUDUCUHJUFUHUCBCDNOUBUCPQS $.

  ${
    $d x ph $.
    $( Theorem 19.32 of [Margaris] p. 90 with restricted quantifiers.
       (Contributed by NM, 25-Nov-2003.) $)
    r19.32v $p |- ( A. x e. A ( ph \/ ps ) <-> ( ph \/ A. x e. A ps ) ) $=
      ( wn wi wral wo r19.21v df-or ralbii 3bitr4i ) AEZBFZCDGMBCDGZFABHZCDGAOH
      MBCDIPNCDABJKAOJL $.
  $}

  $( Restricted quantifier version of Theorem 19.35 of [Margaris] p. 90.
     (Contributed by NM, 20-Sep-2003.) $)
  r19.35 $p |- ( E. x e. A ( ph -> ps ) <->
               ( A. x e. A ph -> E. x e. A ps ) ) $=
    ( wral wn wi wrex r19.26 annim ralbii df-an 3bitr3i con2bii dfrex2 3bitr4ri
    wa imbi2i ) ACDEZBFZCDEZFZGZABGZFZCDEZFSBCDHZGUDCDHUFUCATQZCDESUAQUFUCFATCD
    IUHUECDABJKSUALMNUGUBSBCDORUDCDOP $.

  ${
    $d x ps $.
    $( One direction of a restricted quantifier version of Theorem 19.36 of
       [Margaris] p. 90.  The other direction doesn't hold when ` A ` is
       empty.  (Contributed by NM, 22-Oct-2003.) $)
    r19.36av $p |- ( E. x e. A ( ph -> ps ) -> ( A. x e. A ph -> ps ) ) $=
      ( wi wrex wral r19.35 cv wcel idd rexlimiv imim2i sylbi ) ABECDFACDGZBCDF
      ZEOBEABCDHPBOBBCDCIDJBKLMN $.
  $}

  ${
    r19.37.1 $e |- F/ x ph $.
    $( Restricted version of one direction of Theorem 19.37 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.)
       (Contributed by FL, 13-May-2012.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    r19.37 $p |- ( E. x e. A ( ph -> ps ) -> ( ph -> E. x e. A ps ) ) $=
      ( wi wrex wral r19.35 cv wcel ax-1 ralrimi imim1i sylbi ) ABFCDGACDHZBCDG
      ZFAQFABCDIAPQAACDEACJDKLMNO $.
  $}

  ${
    $d x ph $.
    $( Restricted version of one direction of Theorem 19.37 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.)
       (Contributed by NM, 2-Apr-2004.) $)
    r19.37av $p |- ( E. x e. A ( ph -> ps ) -> ( ph -> E. x e. A ps ) ) $=
      ( nfv r19.37 ) ABCDACEF $.
  $}

  $( Restricted quantifier version of Theorem 19.40 of [Margaris] p. 90.
     (Contributed by NM, 2-Apr-2004.) $)
  r19.40 $p |- ( E. x e. A ( ph /\ ps ) ->
               ( E. x e. A ph /\ E. x e. A ps ) ) $=
    ( wa wrex simpl reximi simpr jca ) ABEZCDFACDFBCDFKACDABGHKBCDABIHJ $.

  ${
    r19.41.1 $e |- F/ x ps $.
    $( Restricted quantifier version of Theorem 19.41 of [Margaris] p. 90.
       (Contributed by NM, 1-Nov-2010.) $)
    r19.41 $p |- ( E. x e. A ( ph /\ ps ) <-> ( E. x e. A ph /\ ps ) ) $=
      ( cv wcel wa wex wrex anass exbii 19.41 bitr3i df-rex anbi1i 3bitr4i ) CF
      DGZABHZHZCIZRAHZCIZBHZSCDJACDJZBHUAUBBHZCIUDUFTCRABKLUBBCEMNSCDOUEUCBACDO
      PQ $.
  $}

  ${
    $d x ps $.
    $( Restricted quantifier version of Theorem 19.41 of [Margaris] p. 90.
       (Contributed by NM, 17-Dec-2003.) $)
    r19.41v $p |- ( E. x e. A ( ph /\ ps ) <-> ( E. x e. A ph /\ ps ) ) $=
      ( nfv r19.41 ) ABCDBCEF $.
  $}

  ${
    $d x ph $.
    $( Restricted version of Theorem 19.42 of [Margaris] p. 90.  (Contributed
       by NM, 27-May-1998.) $)
    r19.42v $p |- ( E. x e. A ( ph /\ ps ) <-> ( ph /\ E. x e. A ps ) ) $=
      ( wa wrex r19.41v ancom rexbii 3bitr4i ) BAEZCDFBCDFZAEABEZCDFALEBACDGMKC
      DABHIALHJ $.
  $}

  $( Restricted version of Theorem 19.43 of [Margaris] p. 90.  (Contributed by
     NM, 27-May-1998.)  (Proof shortened by Andrew Salmon, 30-May-2011.) $)
  r19.43 $p |- ( E. x e. A ( ph \/ ps ) <->
               ( E. x e. A ph \/ E. x e. A ps ) ) $=
    ( wn wi wrex wral wo r19.35 df-or rexbii ralnex imbi1i bitr4i 3bitr4i ) AEZ
    BFZCDGQCDHZBCDGZFZABIZCDGACDGZTIZQBCDJUBRCDABKLUDUCEZTFUAUCTKSUETACDMNOP $.

  ${
    $d x ps $.
    $( One direction of a restricted quantifier version of Theorem 19.44 of
       [Margaris] p. 90.  The other direction doesn't hold when ` A ` is
       empty.  (Contributed by NM, 2-Apr-2004.) $)
    r19.44av $p |- ( E. x e. A ( ph \/ ps ) -> ( E. x e. A ph \/ ps ) ) $=
      ( wo wrex r19.43 cv wcel idd rexlimiv orim2i sylbi ) ABECDFACDFZBCDFZENBE
      ABCDGOBNBBCDCHDIBJKLM $.
  $}

  ${
    $d x ph $.
    $( Restricted version of one direction of Theorem 19.45 of [Margaris]
       p. 90.  (The other direction doesn't hold when ` A ` is empty.)
       (Contributed by NM, 2-Apr-2004.) $)
    r19.45av $p |- ( E. x e. A ( ph \/ ps ) -> ( ph \/ E. x e. A ps ) ) $=
      ( wo wrex r19.43 cv wcel idd rexlimiv orim1i sylbi ) ABECDFACDFZBCDFZEAOE
      ABCDGNAOAACDCHDIAJKLM $.
  $}

  ${
    $d x y $.
    ralcomf.1 $e |- F/_ y A $.
    ralcomf.2 $e |- F/_ x B $.
    $( Commutation of restricted quantifiers.  (Contributed by Mario Carneiro,
       14-Oct-2016.) $)
    ralcomf $p |- ( A. x e. A A. y e. B ph <-> A. y e. B A. x e. A ph ) $=
      ( cv wcel wa wi wal wral ancomsimp 2albii alcom bitri r2alf 3bitr4i ) BHD
      IZCHEIZJAKZCLBLZUATJAKZBLCLZACEMBDMABDMCEMUCUDCLBLUEUBUDBCTUAANOUDBCPQABC
      DEFRACBEDGRS $.

    $( Commutation of restricted quantifiers.  (Contributed by Mario Carneiro,
       14-Oct-2016.) $)
    rexcomf $p |- ( E. x e. A E. y e. B ph <-> E. y e. B E. x e. A ph ) $=
      ( cv wcel wa wex wrex ancom anbi1i 2exbii excom bitri r2exf 3bitr4i ) BHD
      IZCHEIZJZAJZCKBKZUATJZAJZBKCKZACELBDLABDLCELUDUFCKBKUGUCUFBCUBUEATUAMNOUF
      BCPQABCDEFRACBEDGRS $.
  $}

  ${
    $d x y $.  $d x B $.  $d y A $.
    $( Commutation of restricted quantifiers.  (Contributed by NM,
       13-Oct-1999.)  (Revised by Mario Carneiro, 14-Oct-2016.) $)
    ralcom $p |- ( A. x e. A A. y e. B ph <-> A. y e. B A. x e. A ph ) $=
      ( nfcv ralcomf ) ABCDECDFBEFG $.

    $( Commutation of restricted quantifiers.  (Contributed by NM,
       19-Nov-1995.)  (Revised by Mario Carneiro, 14-Oct-2016.) $)
    rexcom $p |- ( E. x e. A E. y e. B ph <-> E. y e. B E. x e. A ph ) $=
      ( nfcv rexcomf ) ABCDECDFBEFG $.
  $}

  ${
    $d y z A $.  $d x z B $.  $d x y C $.
    $( Swap 1st and 3rd restricted existential quantifiers.  (Contributed by
       NM, 8-Apr-2015.) $)
    rexcom13 $p |- ( E. x e. A E. y e. B E. z e. C ph
         <-> E. z e. C E. y e. B E. x e. A ph ) $=
      ( wrex rexcom rexbii 3bitri ) ADGHZCFHBEHLBEHZCFHABEHZDGHZCFHNCFHDGHLBCEF
      IMOCFABDEGIJNCDFGIK $.
  $}

  ${
    $d w z A $.  $d w z B $.  $d w x y C $.  $d x y z D $.
    $( Rotate existential restricted quantifiers twice.  (Contributed by NM,
       8-Apr-2015.) $)
    rexrot4 $p |- ( E. x e. A E. y e. B E. z e. C E. w e. D ph
        <-> E. z e. C E. w e. D E. x e. A E. y e. B ph ) $=
      ( wrex rexcom13 rexbii bitri ) AEIJDHJCGJZBFJACGJZDHJEIJZBFJOBFJEIJDHJNPB
      FACDEGHIKLOBEDFIHKM $.
  $}

  ${
    $d y z A $.  $d x z A $.
    $( Commutation of restricted quantifiers.  Note that ` x ` and ` y `
       needn't be distinct (this makes the proof longer).  (Contributed by NM,
       24-Nov-1994.)  (Proof shortened by Mario Carneiro, 17-Oct-2016.) $)
    ralcom2 $p |- ( A. x e. A A. y e. A ph -> A. y e. A A. x e. A ph ) $=
      ( weq wral wi cv wcel wb eleq1 dral1 df-ral 3bitr4g wa nfnae nfan ralrimi
      wal ex sps imbi1d bicomd imbi12d biimpd wn nfra2 nfra1 nfcvf adantr nfcvd
      wnfc nfeld nfan1 rsp2 ancomsd expdimp adantll pm2.61i ) BCEZBSZACDFZBDFZA
      BDFZCDFZGVAVCVEVABHZDIZVBGZBSCHZDIZVDGZCSVCVEVHVKBCVAVGVJVBVDUTVGVJJBVFVI
      DKUAZVAVJAGZCSZVGAGZBSZVBVDVAVPVNVOVMBCVAVGVJAVLUBLUCACDMABDMNUDLVBBDMVDC
      DMNUEVAUFZVCVEVQVCOZVDCDVQVCCBCCPABCDDUGQVRVJVDVRVJOABDVRVJBVQVCBBCBPVBBD
      UHQVRBVIDVQBVIULVCBCUIUJVRBDUKUMUNVCVJVOVQVCVJVGAVCVGVJAABCDDUOUPUQURRTRT
      US $.
  $}

  ${
    $( A commutative law for restricted quantifiers that swaps the domain of
       the restriction.  (Contributed by NM, 22-Feb-2004.) $)
    ralcom3 $p |- ( A. x e. A ( x e. B -> ph ) <->
                    A. x e. B ( x e. A -> ph ) ) $=
      ( cv wcel wi wral pm2.04 ralimi2 impbii ) BEZDFZAGZBCHLCFZAGZBDHNPBCDOMAI
      JPNBDCMOAIJK $.
  $}

  ${
    $d y A $.  $d x B $.  $d x y $.
    reean.1 $e |- F/ y ph $.
    reean.2 $e |- F/ x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 27-Oct-2010.)
       (Proof shortened by Andrew Salmon, 30-May-2011.) $)
    reean $p |- ( E. x e. A E. y e. B ( ph /\ ps ) <->
                 ( E. x e. A ph /\ E. y e. B ps ) ) $=
      ( cv wcel wa wex wrex an4 2exbii nfv nfan eean bitri df-rex r2ex anbi12i
      3bitr4i ) CIEJZDIFJZKABKZKZDLCLZUDAKZCLZUEBKZDLZKZUFDFMCEMACEMZBDFMZKUHUI
      UKKZDLCLUMUGUPCDUDUEABNOUIUKCDUDADUDDPGQUEBCUECPHQRSUFCDEFUAUNUJUOULACETB
      DFTUBUC $.
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y $.  $d y A $.  $d x B $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 9-May-1999.) $)
    reeanv $p |- ( E. x e. A E. y e. B ( ph /\ ps ) <->
                 ( E. x e. A ph /\ E. y e. B ps ) ) $=
      ( nfv reean ) ABCDEFADGBCGH $.
  $}

  ${
    $d ph y z $.  $d ps x z $.  $d ch x y $.  $d A y $.  $d B x z $.
    $d C x y $.
    $( Rearrange three existential quantifiers.  (Contributed by Jeff Madsen,
       11-Jun-2010.) $)
    3reeanv $p |- ( E. x e. A E. y e. B E. z e. C ( ph /\ ps /\ ch )
                      <-> ( E. x e. A ph /\ E. y e. B ps /\ E. z e. C ch ) ) $=
      ( wa wrex w3a r19.41v reeanv anbi1i bitri df-3an 2rexbii rexbii 3bitr4i )
      ABJZEHKZCFIKZJZDGKZADGKZBEHKZJZUCJZABCLZFIKEHKZDGKUFUGUCLUEUBDGKZUCJUIUBU
      CDGMULUHUCABDEGHNOPUKUDDGUKUACJZFIKEHKUDUJUMEFHIABCQRUACEFHINPSUFUGUCQT
      $.
  $}

  ${
    $d ph y $.  $d ps x $.  $d A y $.  $d B x $.  $d x y $.
    $( Distribute quantification over "or".  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    2ralor $p |- ( A. x e. A A. y e. B ( ph \/ ps ) <->
                  ( A. x e. A ph \/ A. y e. B ps ) ) $=
      ( wo wral wn wrex wa rexnal anbi12i rexbii bitr3i reeanv 3bitr3ri 3bitr4i
      ioran con4bii ) ABGZDFHZCEHZACEHZBDFHZGZAIZCEJZBIZDFJZKZUDIZUEIZKUCIZUFIU
      HULUJUMACELBDFLMUGUIKZDFJZCEJUBIZCEJUKUNUPUQCEUPUAIZDFJUQURUODFABSNUADFLO
      NUGUICDEFPUBCELQUDUESRT $.
  $}

  $( ` x ` is not free in ` E! x e. A ph ` .  (Contributed by NM,
     19-Mar-1997.) $)
  nfreu1 $p |- F/ x E! x e. A ph $=
    ( wreu cv wcel wa weu df-reu nfeu1 nfxfr ) ABCDBECFAGZBHBABCILBJK $.

  $( ` x ` is not free in ` E* x e. A ph ` .  (Contributed by NM,
     16-Jun-2017.) $)
  nfrmo1 $p |- F/ x E* x e. A ph $=
    ( wrmo cv wcel wa wmo df-rmo nfmo1 nfxfr ) ABCDBECFAGZBHBABCILBJK $.

  ${
    $d x z $.  $d y z $.  $d A z $.  $d ph z $.
    nfreud.1 $e |- F/ y ph $.
    nfreud.2 $e |- ( ph -> F/_ x A ) $.
    nfreud.3 $e |- ( ph -> F/ x ps ) $.
    $( Deduction version of ~ nfreu .  (Contributed by NM, 15-Feb-2013.)
       (Revised by Mario Carneiro, 8-Oct-2016.) $)
    nfreud $p |- ( ph -> F/ x E! y e. A ps ) $=
      ( wreu cv wcel wa weu df-reu weq wal wn wnfc nfcvf adantr nfeld wnf nfand
      adantl nfeud2 nfxfrd ) BDEIDJZEKZBLZDMACBDENAUICDFACDOCPQZLZUHBCUKCUGEUJC
      UGRACDSUDACERUJGTUAABCUBUJHTUCUEUF $.

    $( Deduction version of ~ nfrmo .  (Contributed by NM, 17-Jun-2017.) $)
    nfrmod $p |- ( ph -> F/ x E* y e. A ps ) $=
      ( wrmo cv wcel wa wmo df-rmo weq wal wn wnfc nfcvf adantr nfeld wnf nfand
      adantl nfmod2 nfxfrd ) BDEIDJZEKZBLZDMACBDENAUICDFACDOCPQZLZUHBCUKCUGEUJC
      UGRACDSUDACERUJGTUAABCUBUJHTUCUEUF $.
  $}

  ${
    nfreu.1 $e |- F/_ x A $.
    nfreu.2 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for restricted uniqueness.
       (Contributed by NM, 30-Oct-2010.)  (Revised by Mario Carneiro,
       8-Oct-2016.) $)
    nfreu $p |- F/ x E! y e. A ph $=
      ( wreu wnf wtru nftru wnfc a1i nfreud trud ) ACDGBHIABCDCJBDKIELABHIFLMN
      $.

    $( Bound-variable hypothesis builder for restricted uniqueness.
       (Contributed by NM, 16-Jun-2017.) $)
    nfrmo $p |- F/ x E* y e. A ph $=
      ( wrmo cv wcel wa wmo df-rmo wnf wtru nftru weq wal wn nfcvf a1i adantl
      wnfc nfeld nfand nfmod2 trud nfxfr ) ACDGCHZDIZAJZCKZBACDLUKBMNUJBCCOBCPB
      QRZUJBMNULUIABULBUHDBCSBDUBULETUCABMULFTUDUAUEUFUG $.
  $}

  $( An "identity" law of concretion for restricted abstraction.  Special case
     of Definition 2.1 of [Quine] p. 16.  (Contributed by NM, 9-Oct-2003.) $)
  rabid $p |- ( x e. { x e. A | ph } <-> ( x e. A /\ ph ) ) $=
    ( cv wcel wa crab df-rab abeq2i ) BDCEAFBABCGABCHI $.

  ${
    $d x A $.
    $( An "identity" law for restricted class abstraction.  (Contributed by NM,
       9-Oct-2003.)  (Proof shortened by Andrew Salmon, 30-May-2011.) $)
    rabid2 $p |- ( A = { x e. A | ph } <-> A. x e. A ph ) $=
      ( cv wcel wa cab wceq wi wal crab abeq2 pm4.71 albii bitr4i df-rab eqeq2i
      wral wb df-ral 3bitr4i ) CBDCEZAFZBGZHZUBAIZBJZCABCKZHABCRUEUBUCSZBJUGUCB
      CLUFUIBUBAMNOUHUDCABCPQABCTUA $.
  $}

  ${
    $( Equivalent wff's correspond to equal restricted class abstractions.
       Closed theorem form of ~ rabbidva .  (Contributed by NM,
       25-Nov-2013.) $)
    rabbi $p |- ( A. x e. A ( ps <-> ch )
         <-> { x e. A | ps } = { x e. A | ch } ) $=
      ( cv wcel wa wb wal cab wceq wral crab abbi wi df-ral pm5.32 albii df-rab
      bitri eqeq12i 3bitr4i ) CEDFZAGZUCBGZHZCIZUDCJZUECJZKABHZCDLZACDMZBCDMZKU
      DUECNUKUCUJOZCIUGUJCDPUNUFCUCABQRTULUHUMUIACDSBCDSUAUB $.
  $}

  $( Swap with a membership relation in a restricted class abstraction.
     (Contributed by NM, 4-Jul-2005.) $)
  rabswap $p |- { x e. A | x e. B } = { x e. B | x e. A } $=
    ( cv wcel wa cab crab ancom abbii df-rab 3eqtr4i ) ADZBEZMCEZFZAGONFZAGOABH
    NACHPQANOIJOABKNACKL $.

  ${
    $d x y $.
    $( The abstraction variable in a restricted class abstraction isn't free.
       (Contributed by NM, 19-Mar-1997.) $)
    nfrab1 $p |- F/_ x { x e. A | ph } $=
      ( crab cv wcel wa cab df-rab nfab1 nfcxfr ) BABCDBECFAGZBHABCILBJK $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.
    nfrab.1 $e |- F/ x ph $.
    nfrab.2 $e |- F/_ x A $.
    $( A variable not free in a wff remains so in a restricted class
       abstraction.  (Contributed by NM, 13-Oct-2003.)  (Revised by Mario
       Carneiro, 9-Oct-2016.) $)
    nfrab $p |- F/_ x { y e. A | ph } $=
      ( vz crab cv wcel wa cab df-rab wnfc wtru nftru weq wal wn wnf a1i adantl
      nfcri eleq1 dvelimnf nfand nfabd2 trud nfcxfr ) BACDHCIZDJZAKZCLZACDMBUMN
      OULBCCPBCQBRSZULBTOUNUKABGIZDJUKBCGBGDFUCUOUJDUDUEABTUNEUAUFUBUGUHUI $.
  $}

  ${
    reubida.1 $e |- F/ x ph $.
    reubida.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by Mario Carneiro, 19-Nov-2016.) $)
    reubida $p |- ( ph -> ( E! x e. A ps <-> E! x e. A ch ) ) $=
      ( cv wcel wa weu wreu pm5.32da eubid df-reu 3bitr4g ) ADHEIZBJZDKQCJZDKBD
      ELCDELARSDFAQBCGMNBDEOCDEOP $.
  $}

  ${
    $d x ph $.
    reubidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 13-Nov-2004.) $)
    reubidva $p |- ( ph -> ( E! x e. A ps <-> E! x e. A ch ) ) $=
      ( nfv reubida ) ABCDEADGFH $.
  $}

  ${
    $d x ph $.
    reubidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 17-Oct-1996.) $)
    reubidv $p |- ( ph -> ( E! x e. A ps <-> E! x e. A ch ) ) $=
      ( wb cv wcel adantr reubidva ) ABCDEABCGDHEIFJK $.
  $}

  ${
    reubiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Formula-building rule for restricted existential quantifier (inference
       rule).  (Contributed by NM, 14-Nov-2004.) $)
    reubiia $p |- ( E! x e. A ph <-> E! x e. A ps ) $=
      ( cv wcel wa weu wreu pm5.32i eubii df-reu 3bitr4i ) CFDGZAHZCIOBHZCIACDJ
      BCDJPQCOABEKLACDMBCDMN $.
  $}

  ${
    reubii.1 $e |- ( ph <-> ps ) $.
    $( Formula-building rule for restricted existential quantifier (inference
       rule).  (Contributed by NM, 22-Oct-1999.) $)
    reubii $p |- ( E! x e. A ph <-> E! x e. A ps ) $=
      ( wb cv wcel a1i reubiia ) ABCDABFCGDHEIJ $.
  $}

  ${
    rmobida.1 $e |- F/ x ph $.
    rmobida.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 16-Jun-2017.) $)
    rmobida $p |- ( ph -> ( E* x e. A ps <-> E* x e. A ch ) ) $=
      ( cv wcel wa wmo wrmo pm5.32da mobid df-rmo 3bitr4g ) ADHEIZBJZDKQCJZDKBD
      ELCDELARSDFAQBCGMNBDEOCDEOP $.
  $}

  ${
    $d x ph $.
    rmobidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 16-Jun-2017.) $)
    rmobidva $p |- ( ph -> ( E* x e. A ps <-> E* x e. A ch ) ) $=
      ( nfv rmobida ) ABCDEADGFH $.
  $}

  ${
    $d x ph $.
    rmobidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by NM, 16-Jun-2017.) $)
    rmobidv $p |- ( ph -> ( E* x e. A ps <-> E* x e. A ch ) ) $=
      ( wb cv wcel adantr rmobidva ) ABCDEABCGDHEIFJK $.
  $}

  ${
    rmobiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Formula-building rule for restricted existential quantifier (inference
       rule).  (Contributed by NM, 16-Jun-2017.) $)
    rmobiia $p |- ( E* x e. A ph <-> E* x e. A ps ) $=
      ( cv wcel wa wmo wrmo pm5.32i mobii df-rmo 3bitr4i ) CFDGZAHZCIOBHZCIACDJ
      BCDJPQCOABEKLACDMBCDMN $.
  $}

  ${
    rmobii.1 $e |- ( ph <-> ps ) $.
    $( Formula-building rule for restricted existential quantifier (inference
       rule).  (Contributed by NM, 16-Jun-2017.) $)
    rmobii $p |- ( E* x e. A ph <-> E* x e. A ps ) $=
      ( wb cv wcel a1i rmobiia ) ABCDABFCGDHEIJ $.
  $}

  ${
    $d y A $.  $d y B $.
    raleq1f.1 $e |- F/_ x A $.
    raleq1f.2 $e |- F/_ x B $.
    $( Equality theorem for restricted universal quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions.
       (Contributed by NM, 7-Mar-2004.)  (Revised by Andrew Salmon,
       11-Jul-2011.) $)
    raleqf $p |- ( A = B -> ( A. x e. A ph <-> A. x e. B ph ) ) $=
      ( wceq cv wcel wi wal wral nfeq eleq2 imbi1d albid df-ral 3bitr4g ) CDGZB
      HZCIZAJZBKTDIZAJZBKABCLABDLSUBUDBBCDEFMSUAUCACDTNOPABCQABDQR $.

    $( Equality theorem for restricted existential quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions.
       (Contributed by NM, 9-Oct-2003.)  (Revised by Andrew Salmon,
       11-Jul-2011.) $)
    rexeqf $p |- ( A = B -> ( E. x e. A ph <-> E. x e. B ph ) ) $=
      ( wceq cv wcel wa wex wrex nfeq eleq2 anbi1d exbid df-rex 3bitr4g ) CDGZB
      HZCIZAJZBKTDIZAJZBKABCLABDLSUBUDBBCDEFMSUAUCACDTNOPABCQABDQR $.

    $( Equality theorem for restricted uniqueness quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions.
       (Contributed by NM, 5-Apr-2004.)  (Revised by Andrew Salmon,
       11-Jul-2011.) $)
    reueq1f $p |- ( A = B -> ( E! x e. A ph <-> E! x e. B ph ) ) $=
      ( wceq cv wcel wa weu wreu nfeq eleq2 anbi1d eubid df-reu 3bitr4g ) CDGZB
      HZCIZAJZBKTDIZAJZBKABCLABDLSUBUDBBCDEFMSUAUCACDTNOPABCQABDQR $.

    $( Equality theorem for restricted uniqueness quantifier, with
       bound-variable hypotheses instead of distinct variable restrictions.
       (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
    rmoeq1f $p |- ( A = B -> ( E* x e. A ph <-> E* x e. B ph ) ) $=
      ( wceq cv wcel wa wmo wrmo nfeq eleq2 anbi1d mobid df-rmo 3bitr4g ) CDGZB
      HZCIZAJZBKTDIZAJZBKABCLABDLSUBUDBBCDEFMSUAUCACDTNOPABCQABDQR $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for restricted universal quantifier.  (Contributed by
       NM, 16-Nov-1995.) $)
    raleq $p |- ( A = B -> ( A. x e. A ph <-> A. x e. B ph ) ) $=
      ( nfcv raleqf ) ABCDBCEBDEF $.

    $( Equality theorem for restricted existential quantifier.  (Contributed by
       NM, 29-Oct-1995.) $)
    rexeq $p |- ( A = B -> ( E. x e. A ph <-> E. x e. B ph ) ) $=
      ( nfcv rexeqf ) ABCDBCEBDEF $.

    $( Equality theorem for restricted uniqueness quantifier.  (Contributed by
       NM, 5-Apr-2004.) $)
    reueq1 $p |- ( A = B -> ( E! x e. A ph <-> E! x e. B ph ) ) $=
      ( nfcv reueq1f ) ABCDBCEBDEF $.

    $( Equality theorem for restricted uniqueness quantifier.  (Contributed by
       Alexander van der Vekens, 17-Jun-2017.) $)
    rmoeq1 $p |- ( A = B -> ( E* x e. A ph <-> E* x e. B ph ) ) $=
      ( nfcv rmoeq1f ) ABCDBCEBDEF $.
  $}

  ${
    $d A x $.  $d B x $.
    raleq1i.1 $e |- A = B $.
    $( Equality inference for restricted universal qualifier.  (Contributed by
       Paul Chapman, 22-Jun-2011.) $)
    raleqi $p |- ( A. x e. A ph <-> A. x e. B ph ) $=
      ( wceq wral wb raleq ax-mp ) CDFABCGABDGHEABCDIJ $.

    $( Equality inference for restricted existential qualifier.  (Contributed
       by Mario Carneiro, 23-Apr-2015.) $)
    rexeqi $p |- ( E. x e. A ph <-> E. x e. B ph ) $=
      ( wceq wrex wb rexeq ax-mp ) CDFABCGABDGHEABCDIJ $.
  $}

  ${
    $d x A $.  $d x B $.
    raleq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for restricted universal quantifier.  (Contributed by
       NM, 13-Nov-2005.) $)
    raleqdv $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ps ) ) $=
      ( wceq wral wb raleq syl ) ADEGBCDHBCEHIFBCDEJK $.

    $( Equality deduction for restricted existential quantifier.  (Contributed
       by NM, 14-Jan-2007.) $)
    rexeqdv $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ps ) ) $=
      ( wceq wrex wb rexeq syl ) ADEGBCDHBCEHIFBCDEJK $.
  $}

  ${
    $d x A $.  $d x B $.
    raleqd.1 $e |- ( A = B -> ( ph <-> ps ) ) $.
    $( Equality deduction for restricted universal quantifier.  (Contributed by
       NM, 16-Nov-1995.) $)
    raleqbi1dv $p |- ( A = B -> ( A. x e. A ph <-> A. x e. B ps ) ) $=
      ( wceq wral raleq ralbidv bitrd ) DEGZACDHACEHBCEHACDEILABCEFJK $.

    $( Equality deduction for restricted existential quantifier.  (Contributed
       by NM, 18-Mar-1997.) $)
    rexeqbi1dv $p |- ( A = B -> ( E. x e. A ph <-> E. x e. B ps ) ) $=
      ( wceq wrex rexeq rexbidv bitrd ) DEGZACDHACEHBCEHACDEILABCEFJK $.

    $( Equality deduction for restricted uniqueness quantifier.  (Contributed
       by NM, 5-Apr-2004.) $)
    reueqd $p |- ( A = B -> ( E! x e. A ph <-> E! x e. B ps ) ) $=
      ( wceq wreu reueq1 reubidv bitrd ) DEGZACDHACEHBCEHACDEILABCEFJK $.

    $( Equality deduction for restricted uniqueness quantifier.  (Contributed
       by Alexander van der Vekens, 17-Jun-2017.) $)
    rmoeqd $p |- ( A = B -> ( E* x e. A ph <-> E* x e. B ps ) ) $=
      ( wceq wrmo rmoeq1 rmobidv bitrd ) DEGZACDHACEHBCEHACDEILABCEFJK $.
  $}

  ${
    raleqbid.0 $e |- F/ x ph $.
    raleqbid.1 $e |- F/_ x A $.
    raleqbid.2 $e |- F/_ x B $.
    raleqbid.3 $e |- ( ph -> A = B ) $.
    raleqbid.4 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality deduction for restricted universal quantifier.  (Contributed by
       Thierry Arnoux, 8-Mar-2017.) $)
    raleqbid $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ch ) ) $=
      ( wral wceq wb raleqf syl ralbid bitrd ) ABDELZBDFLZCDFLAEFMSTNJBDEFHIOPA
      BCDFGKQR $.

    $( Equality deduction for restricted existential quantifier.  (Contributed
       by Thierry Arnoux, 8-Mar-2017.) $)
    rexeqbid $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ch ) ) $=
      ( wrex wceq wb rexeqf syl rexbid bitrd ) ABDELZBDFLZCDFLAEFMSTNJBDEFHIOPA
      BCDFGKQR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    raleqbidv.1 $e |- ( ph -> A = B ) $.
    raleqbidv.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality deduction for restricted universal quantifier.  (Contributed by
       NM, 6-Nov-2007.) $)
    raleqbidv $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ch ) ) $=
      ( wral raleqdv ralbidv bitrd ) ABDEIBDFICDFIABDEFGJABCDFHKL $.

    $( Equality deduction for restricted universal quantifier.  (Contributed by
       NM, 6-Nov-2007.) $)
    rexeqbidv $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ch ) ) $=
      ( wrex rexeqdv rexbidv bitrd ) ABDEIBDFICDFIABDEFGJABCDFHKL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    raleqbidva.1 $e |- ( ph -> A = B ) $.
    raleqbidva.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Equality deduction for restricted universal quantifier.  (Contributed by
       Mario Carneiro, 5-Jan-2017.) $)
    raleqbidva $p |- ( ph -> ( A. x e. A ps <-> A. x e. B ch ) ) $=
      ( wral ralbidva raleqdv bitrd ) ABDEICDEICDFIABCDEHJACDEFGKL $.

    $( Equality deduction for restricted universal quantifier.  (Contributed by
       Mario Carneiro, 5-Jan-2017.) $)
    rexeqbidva $p |- ( ph -> ( E. x e. A ps <-> E. x e. B ch ) ) $=
      ( wrex rexbidva rexeqdv bitrd ) ABDEICDEICDFIABCDEHJACDEFGKL $.
  $}

  $( Unrestricted "at most one" implies restricted "at most one".  (Contributed
     by NM, 16-Jun-2017.) $)
  mormo $p |- ( E* x ph -> E* x e. A ph ) $=
    ( wmo cv wcel wa wrmo moan df-rmo sylibr ) ABDBECFZAGBDABCHALBIABCJK $.

  $( Restricted uniqueness in terms of "at most one."  (Contributed by NM,
     23-May-1999.)  (Revised by NM, 16-Jun-2017.) $)
  reu5 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\ E* x e. A ph ) ) $=
    ( cv wcel wa weu wex wmo wreu wrex eu5 df-reu df-rex df-rmo anbi12i 3bitr4i
    wrmo ) BDCEAFZBGSBHZSBIZFABCJABCKZABCRZFSBLABCMUBTUCUAABCNABCOPQ $.

  $( Restricted unique existence implies restricted existence.  (Contributed by
     NM, 19-Aug-1999.) $)
  reurex $p |- ( E! x e. A ph -> E. x e. A ph ) $=
    ( wreu wrex wrmo reu5 simplbi ) ABCDABCEABCFABCGH $.

  $( Restricted existential uniqueness implies restricted "at most one."
     (Contributed by NM, 16-Jun-2017.) $)
  reurmo $p |- ( E! x e. A ph -> E* x e. A ph ) $=
    ( wreu wrex wrmo reu5 simprbi ) ABCDABCEABCFABCGH $.

  $( Restricted "at most one" in term of uniqueness.  (Contributed by NM,
     16-Jun-2017.) $)
  rmo5 $p |- ( E* x e. A ph <-> ( E. x e. A ph -> E! x e. A ph ) ) $=
    ( cv wcel wa wmo wex weu wrmo wrex wreu df-mo df-rmo df-rex imbi12i 3bitr4i
    wi df-reu ) BDCEAFZBGTBHZTBIZRABCJABCKZABCLZRTBMABCNUCUAUDUBABCOABCSPQ $.

  $( Nonexistence implies restricted "at most one".  (Contributed by NM,
     17-Jun-2017.) $)
  nrexrmo $p |- ( -. E. x e. A ph -> E* x e. A ph ) $=
    ( wrex wn wreu wi wrmo pm2.21 rmo5 sylibr ) ABCDZELABCFZGABCHLMIABCJK $.

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z ps $.  $d z ph $.
    cbvralf.1 $e |- F/_ x A $.
    cbvralf.2 $e |- F/_ y A $.
    cbvralf.3 $e |- F/ y ph $.
    cbvralf.4 $e |- F/ x ps $.
    cbvralf.5 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 7-Mar-2004.)  (Revised by Mario Carneiro,
       9-Oct-2016.) $)
    cbvralf $p |- ( A. x e. A ph <-> A. y e. A ps ) $=
      ( vz cv wcel wi wal wral wsb nfv nfcri nfim nfs1v weq eleq1 sbequ12 cbval
      imbi12d nfsb sbequ sbie syl6bb bitri df-ral 3bitr4i ) CLZEMZANZCOZDLZEMZB
      NZDOZACEPBDEPUQKLZEMZACKQZNZKOVAUPVECKUPKRVCVDCCKEFSACKUATCKUBUOVCAVDUNVB
      EUCACKUDUFUEVEUTKDVCVDDDKEGSACKDHUGTUTKRKDUBZVCUSVDBVBUREUCVFVDACDQBAKDCU
      HABCDIJUIUJUFUEUKACEULBDEULUM $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by FL, 27-Apr-2008.)  (Revised by Mario Carneiro,
       9-Oct-2016.) $)
    cbvrexf $p |- ( E. x e. A ph <-> E. y e. A ps ) $=
      ( wn wral wrex nfn weq notbid cbvralf notbii dfrex2 3bitr4i ) AKZCELZKBKZ
      DELZKACEMBDEMUBUDUAUCCDEFGADHNBCINCDOABJPQRACESBDEST $.
  $}

  ${
    $d x z A $.  $d y z A $.  $d z ph $.  $d z ps $.
    cbvral.1 $e |- F/ y ph $.
    cbvral.2 $e |- F/ x ps $.
    cbvral.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 31-Jul-2003.) $)
    cbvral $p |- ( A. x e. A ph <-> A. y e. A ps ) $=
      ( nfcv cbvralf ) ABCDECEIDEIFGHJ $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 31-Jul-2003.)  (Proof shortened by Andrew Salmon,
       8-Jun-2011.) $)
    cbvrex $p |- ( E. x e. A ph <-> E. y e. A ps ) $=
      ( nfcv cbvrexf ) ABCDECEIDEIFGHJ $.

    $( Change the bound variable of a restricted uniqueness quantifier using
       implicit substitution.  (Contributed by Mario Carneiro, 15-Oct-2016.) $)
    cbvreu $p |- ( E! x e. A ph <-> E! y e. A ps ) $=
      ( vz cv wcel wa weu wreu wsb nfv sb8eu sban eubii df-reu anbi1i nfsb nfan
      clelsb3 weq eleq1 sbequ sbie syl6bb anbi12d cbveu bitri 3bitri 3bitr4i )
      CJEKZALZCMZDJZEKZBLZDMZACENBDENUQUPCIOZIMUOCIOZACIOZLZIMZVAUPCIUPIPQVBVEI
      UOACIRSVFIJZEKZVDLZIMVAVEVIIVCVHVDICEUDUASVIUTIDVHVDDVHDPACIDFUBUCUTIPIDU
      EZVHUSVDBVGUREUFVJVDACDOBAIDCUGABCDGHUHUIUJUKULUMACETBDETUN $.

    $( Change the bound variable of restricted "at most one" using implicit
       substitution.  (Contributed by NM, 16-Jun-2017.) $)
    cbvrmo $p |- ( E* x e. A ph <-> E* y e. A ps ) $=
      ( wrex wreu wi wrmo cbvrex cbvreu imbi12i rmo5 3bitr4i ) ACEIZACEJZKBDEIZ
      BDEJZKACELBDELRTSUAABCDEFGHMABCDEFGHNOACEPBDEPQ $.
  $}

  ${
    $d z x A $.  $d y A $.  $d z y ph $.  $d z x ps $.
    cbvralv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change the bound variable of a restricted universal quantifier using
       implicit substitution.  (Contributed by NM, 28-Jan-1997.) $)
    cbvralv $p |- ( A. x e. A ph <-> A. y e. A ps ) $=
      ( nfv cbvral ) ABCDEADGBCGFH $.

    $( Change the bound variable of a restricted existential quantifier using
       implicit substitution.  (Contributed by NM, 2-Jun-1998.) $)
    cbvrexv $p |- ( E. x e. A ph <-> E. y e. A ps ) $=
      ( nfv cbvrex ) ABCDEADGBCGFH $.

    $( Change the bound variable of a restricted uniqueness quantifier using
       implicit substitution.  (Contributed by NM, 5-Apr-2004.)  (Revised by
       Mario Carneiro, 15-Oct-2016.) $)
    cbvreuv $p |- ( E! x e. A ph <-> E! y e. A ps ) $=
      ( nfv cbvreu ) ABCDEADGBCGFH $.

    $( Change the bound variable of a restricted uniqueness quantifier using
       implicit substitution.  (Contributed by Alexander van der Vekens,
       17-Jun-2017.) $)
    cbvrmov $p |- ( E* x e. A ph <-> E* y e. A ps ) $=
      ( nfv cbvrmo ) ABCDEADGBCGFH $.
  $}

  ${
    $d A y $.  $d ps y $.  $d B x $.  $d ch x $.  $d x ph y $.
    cbvraldva2.1 $e |- ( ( ph /\ x = y ) -> ( ps <-> ch ) ) $.
    cbvraldva2.2 $e |- ( ( ph /\ x = y ) -> A = B ) $.
    $( Rule used to change the bound variable in a restricted universal
       quantifier with implicit substitution which also changes the quantifier
       domain.  Deduction form.  (Contributed by David Moews, 1-May-2017.) $)
    cbvraldva2 $p |- ( ph -> ( A. x e. A ps <-> A. y e. B ch ) ) $=
      ( cv wcel wi wal wral weq wa simpr eleq12d imbi12d df-ral cbvaldva
      3bitr4g ) ADJZFKZBLZDMEJZGKZCLZEMBDFNCEGNAUEUHDEADEOZPZUDUGBCUJUCUFFGAUIQ
      IRHSUABDFTCEGTUB $.

    $( Rule used to change the bound variable in a restricted existential
       quantifier with implicit substitution which also changes the quantifier
       domain.  Deduction form.  (Contributed by David Moews, 1-May-2017.) $)
    cbvrexdva2 $p |- ( ph -> ( E. x e. A ps <-> E. y e. B ch ) ) $=
      ( cv wcel wa wex wrex weq simpr eleq12d anbi12d cbvexdva df-rex 3bitr4g )
      ADJZFKZBLZDMEJZGKZCLZEMBDFNCEGNAUDUGDEADEOZLZUCUFBCUIUBUEFGAUHPIQHRSBDFTC
      EGTUA $.
  $}

  ${
    $d ps y $.  $d ch x $.  $d A x y $.  $d x ph y $.
    cbvraldva.1 $e |- ( ( ph /\ x = y ) -> ( ps <-> ch ) ) $.
    $( Rule used to change the bound variable in a restricted universal
       quantifier with implicit substitution.  Deduction form.  (Contributed by
       David Moews, 1-May-2017.) $)
    cbvraldva $p |- ( ph -> ( A. x e. A ps <-> A. y e. A ch ) ) $=
      ( weq wa eqidd cbvraldva2 ) ABCDEFFGADEHIFJK $.

    $( Rule used to change the bound variable in a restricted existential
       quantifier with implicit substitution.  Deduction form.  (Contributed by
       David Moews, 1-May-2017.) $)
    cbvrexdva $p |- ( ph -> ( E. x e. A ps <-> E. y e. A ch ) ) $=
      ( weq wa eqidd cbvrexdva2 ) ABCDEFFGADEHIFJK $.
  $}

  ${
    $d x A $.  $d z A $.  $d x y B $.  $d z y B $.  $d w B $.  $d z ph $.
    $d y ps $.  $d x ch $.  $d w ch $.
    cbvral2v.1 $e |- ( x = z -> ( ph <-> ch ) ) $.
    cbvral2v.2 $e |- ( y = w -> ( ch <-> ps ) ) $.
    $( Change bound variables of double restricted universal quantification,
       using implicit substitution.  (Contributed by NM, 10-Aug-2004.) $)
    cbvral2v $p |- ( A. x e. A A. y e. B ph <-> A. z e. A A. w e. B ps ) $=
      ( wral weq ralbidv cbvralv ralbii bitri ) AEILZDHLCEILZFHLBGILZFHLRSDFHDF
      MACEIJNOSTFHCBEGIKOPQ $.
  $}

  ${
    $d A x $.  $d A z $.  $d B w $.  $d B x y $.  $d B z y $.  $d ch w $.
    $d ch x $.  $d ph z $.  $d ps y $.
    cbvrex2v.1 $e |- ( x = z -> ( ph <-> ch ) ) $.
    cbvrex2v.2 $e |- ( y = w -> ( ch <-> ps ) ) $.
    $( Change bound variables of double restricted universal quantification,
       using implicit substitution.  (Contributed by FL, 2-Jul-2012.) $)
    cbvrex2v $p |- ( E. x e. A E. y e. B ph <-> E. z e. A E. w e. B ps ) $=
      ( wrex weq rexbidv cbvrexv rexbii bitri ) AEILZDHLCEILZFHLBGILZFHLRSDFHDF
      MACEIJNOSTFHCBEGIKOPQ $.
  $}

  ${
    $d w ph $.  $d z ps $.  $d x ch $.  $d v ch $.  $d y u th $.  $d x A $.
    $d w A $.  $d x y B $.  $d w y B $.  $d v B $.  $d x y z C $.
    $d w y z C $.  $d v z C $.  $d z y C $.  $d z C $.  $d u C $.
    cbvral3v.1 $e |- ( x = w -> ( ph <-> ch ) ) $.
    cbvral3v.2 $e |- ( y = v -> ( ch <-> th ) ) $.
    cbvral3v.3 $e |- ( z = u -> ( th <-> ps ) ) $.
    $( Change bound variables of triple restricted universal quantification,
       using implicit substitution.  (Contributed by NM, 10-May-2005.) $)
    cbvral3v $p |- ( A. x e. A A. y e. B A. z e. C ph <->
                     A. w e. A A. v e. B A. u e. C ps ) $=
      ( wral weq 2ralbidv cbvralv cbvral2v ralbii bitri ) AGMQFLQZEKQCGMQFLQZHK
      QBJMQILQZHKQUDUEEHKEHRACFGLMNSTUEUFHKCBDFGIJLMOPUAUBUC $.
  $}

  ${
    $d z x A $.  $d y A $.  $d z y ph $.
    $( Change bound variable by using a substitution.  (Contributed by NM,
       20-Nov-2005.)  (Revised by Andrew Salmon, 11-Jul-2011.) $)
    cbvralsv $p |- ( A. x e. A ph <-> A. y e. A [ y / x ] ph ) $=
      ( vz wral wsb nfv nfs1v sbequ12 cbvral nfsb sbequ bitri ) ABDFABEGZEDFABC
      GZCDFAOBEDAEHABEIABEJKOPECDABECACHLPEHAECBMKN $.
  $}

  ${
    $d z x A $.  $d y z ph $.  $d y A $.
    $( Change bound variable by using a substitution.  (Contributed by NM,
       2-Mar-2008.)  (Revised by Andrew Salmon, 11-Jul-2011.) $)
    cbvrexsv $p |- ( E. x e. A ph <-> E. y e. A [ y / x ] ph ) $=
      ( vz wrex wsb nfv nfs1v sbequ12 cbvrex nfsb sbequ bitri ) ABDFABEGZEDFABC
      GZCDFAOBEDAEHABEIABEJKOPECDABECACHLPEHAECBMKN $.
  $}

  ${
    $d x y z $.  $d y z ph $.  $d x z ps $.
    sbralie.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Implicit to explicit substitution that swaps variables in a quantified
       expression.  (Contributed by NM, 5-Sep-2004.) $)
    sbralie $p |- ( [ x / y ] A. x e. y ph <-> A. y e. x ps ) $=
      ( vz cv wral wsb cbvralsv sbbii nfv raleq sbie bitri sbco2 ralbii ) ACDGZ
      HZDCIZACFIZFCGZHZBDUBHZTUAFRHZDCIUCSUEDCACFRJKUEUCDCUCDLUAFRUBMNOUCUAFDIZ
      DUBHUDUAFDUBJUFBDUBUFACDIBACDFAFLPABCDBCLENOQOO $.
  $}

  ${
    rabbiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (inference
       rule).  (Contributed by NM, 22-May-1999.) $)
    rabbiia $p |- { x e. A | ph } = { x e. A | ps } $=
      ( cv wcel wa cab crab pm5.32i abbii df-rab 3eqtr4i ) CFDGZAHZCIOBHZCIACDJ
      BCDJPQCOABEKLACDMBCDMN $.
  $}

  ${
    $d x ph $.
    rabbidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (deduction
       rule).  (Contributed by NM, 28-Nov-2003.) $)
    rabbidva $p |- ( ph -> { x e. A | ps } = { x e. A | ch } ) $=
      ( wb wral crab wceq ralrimiva rabbi sylib ) ABCGZDEHBDEICDEIJANDEFKBCDELM
      $.
  $}

  ${
    $d x ph $.
    rabbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (deduction
       rule).  (Contributed by NM, 10-Feb-1995.) $)
    rabbidv $p |- ( ph -> { x e. A | ps } = { x e. A | ch } ) $=
      ( wb cv wcel adantr rabbidva ) ABCDEABCGDHEIFJK $.
  $}

  ${
    $d y A $.  $d y B $.
    rabeqf.1 $e |- F/_ x A $.
    rabeqf.2 $e |- F/_ x B $.
    $( Equality theorem for restricted class abstractions, with bound-variable
       hypotheses instead of distinct variable restrictions.  (Contributed by
       NM, 7-Mar-2004.) $)
    rabeqf $p |- ( A = B -> { x e. A | ph } = { x e. B | ph } ) $=
      ( wceq cv wcel wa cab crab nfeq eleq2 anbi1d abbid df-rab 3eqtr4g ) CDGZB
      HZCIZAJZBKTDIZAJZBKABCLABDLSUBUDBBCDEFMSUAUCACDTNOPABCQABDQR $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for restricted class abstractions.  (Contributed by NM,
       15-Oct-2003.) $)
    rabeq $p |- ( A = B -> { x e. A | ph } = { x e. B | ph } ) $=
      ( nfcv rabeqf ) ABCDBCEBDEF $.
  $}

  ${
    $d A x $.  $d B x $.  $d ph x $.
    rabeqbidv.1 $e |- ( ph -> A = B ) $.
    rabeqbidv.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality of restricted class abstractions.  (Contributed by Jeff Madsen,
       1-Dec-2009.) $)
    rabeqbidv $p |- ( ph -> { x e. A | ps } = { x e. B | ch } ) $=
      ( crab wceq rabeq syl rabbidv eqtrd ) ABDEIZBDFIZCDFIAEFJOPJGBDEFKLABCDFH
      MN $.
  $}

  ${
    $d A x $.  $d B x $.  $d ph x $.
    rabeqbidva.1 $e |- ( ph -> A = B ) $.
    rabeqbidva.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Equality of restricted class abstractions.  (Contributed by Mario
       Carneiro, 26-Jan-2017.) $)
    rabeqbidva $p |- ( ph -> { x e. A | ps } = { x e. B | ch } ) $=
      ( crab rabbidva wceq rabeq syl eqtrd ) ABDEICDEIZCDFIZABCDEHJAEFKOPKGCDEF
      LMN $.
  $}

  ${
    rabeqi.1 $e |- A = { x e. B | ph } $.
    $( Inference rule from equality of a class variable and a restricted class
       abstraction.  (Contributed by NM, 16-Feb-2004.) $)
    rabeq2i $p |- ( x e. A <-> ( x e. B /\ ph ) ) $=
      ( cv wcel crab wa eleq2i rabid bitri ) BFZCGMABDHZGMDGAICNMEJABDKL $.
  $}

  ${
    $d x z $.  $d y z $.  $d A z $.  $d ph z $.  $d ps z $.
    cbvrab.1 $e |- F/_ x A $.
    cbvrab.2 $e |- F/_ y A $.
    cbvrab.3 $e |- F/ y ph $.
    cbvrab.4 $e |- F/ x ps $.
    cbvrab.5 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule to change the bound variable in a restricted class abstraction,
       using implicit substitution.  This version has bound-variable hypotheses
       in place of distinct variable conditions.  (Contributed by Andrew
       Salmon, 11-Jul-2011.)  (Revised by Mario Carneiro, 9-Oct-2016.) $)
    cbvrab $p |- { x e. A | ph } = { y e. A | ps } $=
      ( vz cv wcel wa cab crab wsb nfv nfcri nfan nfs1v weq eleq1 sbequ12 cbvab
      anbi12d nfsb sbequ sbie syl6bb eqtri df-rab 3eqtr4i ) CLZEMZANZCOZDLZEMZB
      NZDOZACEPBDEPUQKLZEMZACKQZNZKOVAUPVECKUPKRVCVDCCKEFSACKUATCKUBUOVCAVDUNVB
      EUCACKUDUFUEVEUTKDVCVDDDKEGSACKDHUGTUTKRKDUBZVCUSVDBVBUREUCVFVDACDQBAKDCU
      HABCDIJUIUJUFUEUKACEULBDEULUM $.
  $}

  ${
    $d x y z A $.  $d y ph $.  $d x ps $.
    cbvrabv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule to change the bound variable in a restricted class abstraction,
       using implicit substitution.  (Contributed by NM, 26-May-1999.) $)
    cbvrabv $p |- { x e. A | ph } = { y e. A | ps } $=
      ( nfcv nfv cbvrab ) ABCDECEGDEGADHBCHFI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The universal class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the symbol for the universal class. $)
  $c _V $. $( Letter V (for the universal class) $)

  $( Extend class notation to include the universal class symbol. $)
  cvv $a class _V $.

  ${
    $d z x $.  $d z y $.
    $( Soundness justification theorem for ~ df-v .  (Contributed by Rodolfo
       Medina, 27-Apr-2010.) $)
    vjust $p |- { x | x = x } = { y | y = y } $=
      ( vz weq cab wsb cv wcel equid sbt 2th df-clab 3bitr4i eqriv ) CAADZAEZBB
      DZBEZOACFZQBCFZCGZPHUARHSTOACAIJQBCBIJKOCALQCBLMN $.
  $}

  $( Define the universal class.  Definition 5.20 of [TakeutiZaring] p. 21.
     Also Definition 2.9 of [Quine] p. 19.  The class ` _V ` can be described
     as the "class of all sets"; ~ vprc proves that ` _V ` is not itself a set
     in ZFC. We will frequently use the expression ` A e. _V ` as a short way
     to say " ` A ` is a set", and ~ isset proves that this expression has the
     same meaning as ` E. x x = A ` .  The class ` _V ` is called the "von
     Neumann universe", however, the letter "V" is not a tribute to the name of
     von Neumann.  The letter "V" was used earlier by Peano in 1889 for the
     universe of sets, where the letter V is derived from the word "Verum".
     Peano's notation V was adopted by Whitehead and Russell in Principia
     Mathematica for the class of all sets in 1910.  For a general discussion
     of the theory of classes, see
     ~ http://us.metamath.org/mpeuni/mmset.html#class .  (Contributed by NM,
     5-Aug-1993.) $)
  df-v $a |- _V = { x | x = x } $.

  $( All set variables are sets (see ~ isset ).  Theorem 6.8 of [Quine] p. 43.
     (Contributed by NM, 5-Aug-1993.) $)
  vex $p |- x e. _V $=
    ( cv cvv wcel weq equid df-v abeq2i mpbir ) ABCDAAEZAFJACAGHI $.

  ${
    $d x A $.
    $( Two ways to say " ` A ` is a set":  A class ` A ` is a member of the
       universal class ` _V ` (see ~ df-v ) if and only if the class ` A `
       exists (i.e. there exists some set ` x ` equal to class ` A ` ).
       Theorem 6.9 of [Quine] p. 43. _Notational convention_:  We will use the
       notational device " ` A e. _V ` " to mean " ` A ` is a set" very
       frequently, for example in ~ uniex .  Note the when ` A ` is not a set,
       it is called a proper class.  In some theorems, such as ~ uniexg , in
       order to shorten certain proofs we use the more general antecedent
       ` A e. V ` instead of ` A e. _V ` to mean " ` A ` is a set."

       Note that a constant is implicitly considered distinct from all
       variables.  This is why ` _V ` is not included in the distinct variable
       list, even though ~ df-clel requires that the expression substituted for
       ` B ` not contain ` x ` .  (Also, the Metamath spec does not allow
       constants in the distinct variable list.)  (Contributed by NM,
       5-Aug-1993.) $)
    isset $p |- ( A e. _V <-> E. x x = A ) $=
      ( cvv wcel cv wceq wa wex df-clel vex biantru exbii bitr4i ) BCDAEZBFZNCD
      ZGZAHOAHABCIOQAPOAJKLM $.
  $}

  ${
    $d A y $.  $d x y $.
    issetf.1 $e |- F/_ x A $.
    $( A version of isset that does not require x and A to be distinct.
       (Contributed by Andrew Salmon, 6-Jun-2011.)  (Revised by Mario Carneiro,
       10-Oct-2016.) $)
    issetf $p |- ( A e. _V <-> E. x x = A ) $=
      ( vy cvv wcel cv wceq wex isset nfeq2 nfv eqeq1 cbvex bitri ) BEFDGZBHZDI
      AGZBHZAIDBJQSDAAPBCKSDLPRBMNO $.
  $}

  ${
    $d x A $.
    isseti.1 $e |- A e. _V $.
    $( A way to say " ` A ` is a set" (inference rule).  (Contributed by NM,
       5-Aug-1993.) $)
    isseti $p |- E. x x = A $=
      ( cvv wcel cv wceq wex isset mpbi ) BDEAFBGAHCABIJ $.
  $}

  ${
    $d x A $.
    issetri.1 $e |- E. x x = A $.
    $( A way to say " ` A ` is a set" (inference rule).  (Contributed by NM,
       5-Aug-1993.) $)
    issetri $p |- A e. _V $=
      ( cvv wcel cv wceq wex isset mpbir ) BDEAFBGAHCABIJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class is a member of another class, it is a set.  Theorem 6.12 of
       [Quine] p. 44.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by
       Andrew Salmon, 8-Jun-2011.) $)
    elex $p |- ( A e. B -> A e. _V ) $=
      ( vx cv wceq wcel wa wex cvv exsimpl df-clel isset 3imtr4i ) CDZAEZNBFZGC
      HOCHABFAIFOPCJCABKCALM $.
  $}

  ${
    elisseti.1 $e |- A e. B $.
    $( If a class is a member of another class, it is a set.  (Contributed by
       NM, 11-Jun-1994.) $)
    elexi $p |- A e. _V $=
      ( wcel cvv elex ax-mp ) ABDAEDCABFG $.
  $}

  ${
    $d x A $.
    $( An element of a class exists.  (Contributed by NM, 1-May-1995.) $)
    elisset $p |- ( A e. V -> E. x x = A ) $=
      ( wcel cvv cv wceq wex elex isset sylib ) BCDBEDAFBGAHBCIABJK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( If two classes each contain another class, then both contain some set.
       (Contributed by Alan Sare, 24-Oct-2011.) $)
    elex22 $p |- ( ( A e. B /\ A e. C ) -> E. x ( x e. B /\ x e. C ) ) $=
      ( wcel wa cv wceq wi wal eleq1a anim12ii alrimiv elisset adantr exim sylc
      wex ) BCEZBDEZFZAGZBHZUBCEZUBDEZFZIZAJUCARZUFARUAUGASUCUDTUEBCUBKBDUBKLMS
      UHTABCNOUCUFAPQ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class contains another class, then it contains some set.
       (Contributed by Alan Sare, 25-Sep-2011.) $)
    elex2 $p |- ( A e. B -> E. x x e. B ) $=
      ( wcel cv wceq wi wal wex eleq1a alrimiv elisset exim sylc ) BCDZAEZBFZPC
      DZGZAHQAIRAIOSABCPJKABCLQRAMN $.
  $}

  $( A universal quantifier restricted to the universe is unrestricted.
     (Contributed by NM, 26-Mar-2004.) $)
  ralv $p |- ( A. x e. _V ph <-> A. x ph ) $=
    ( cvv wral cv wcel wi wal df-ral vex a1bi albii bitr4i ) ABCDBECFZAGZBHABHA
    BCIAOBNABJKLM $.

  $( An existential quantifier restricted to the universe is unrestricted.
     (Contributed by NM, 26-Mar-2004.) $)
  rexv $p |- ( E. x e. _V ph <-> E. x ph ) $=
    ( cvv wrex cv wcel wa wex df-rex vex biantrur exbii bitr4i ) ABCDBECFZAGZBH
    ABHABCIAOBNABJKLM $.

  $( A uniqueness quantifier restricted to the universe is unrestricted.
     (Contributed by NM, 1-Nov-2010.) $)
  reuv $p |- ( E! x e. _V ph <-> E! x ph ) $=
    ( cvv wreu cv wcel wa weu df-reu vex biantrur eubii bitr4i ) ABCDBECFZAGZBH
    ABHABCIAOBNABJKLM $.

  $( A uniqueness quantifier restricted to the universe is unrestricted.
     (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
  rmov $p |- ( E* x e. _V ph <-> E* x ph ) $=
    ( cvv wrmo cv wcel wa wmo df-rmo vex biantrur mobii bitr4i ) ABCDBECFZAGZBH
    ABHABCIAOBNABJKLM $.

  $( A class abstraction restricted to the universe is unrestricted.
     (Contributed by NM, 27-Dec-2004.)  (Proof shortened by Andrew Salmon,
     8-Jun-2011.) $)
  rabab $p |- { x e. _V | ph } = { x | ph } $=
    ( cvv crab cv wcel wa cab df-rab vex biantrur abbii eqtr4i ) ABCDBECFZAGZBH
    ABHABCIAOBNABJKLM $.

  ${
    $d x y $.  $d y A $.
    $( Commutation of restricted and unrestricted universal quantifiers.
       (Contributed by NM, 26-Mar-2004.)  (Proof shortened by Andrew Salmon,
       8-Jun-2011.) $)
    ralcom4 $p |- ( A. x e. A A. y ph <-> A. y A. x e. A ph ) $=
      ( cvv wral wal ralcom ralv ralbii 3bitr3i ) ACEFZBDFABDFZCEFACGZBDFMCGABC
      DEHLNBDACIJMCIK $.

    $( Commutation of restricted and unrestricted existential quantifiers.
       (Contributed by NM, 12-Apr-2004.)  (Proof shortened by Andrew Salmon,
       8-Jun-2011.) $)
    rexcom4 $p |- ( E. x e. A E. y ph <-> E. y E. x e. A ph ) $=
      ( cvv wrex wex rexcom rexv rexbii 3bitr3i ) ACEFZBDFABDFZCEFACGZBDFMCGABC
      DEHLNBDACIJMCIK $.
  $}

  ${
    $d A x $.  $d x y $.  $d ph x $.
    $( Specialized existential commutation lemma.  (Contributed by Jeff Madsen,
       1-Jun-2011.) $)
    rexcom4a $p |- ( E. x E. y e. A ( ph /\ ps )
                          <-> E. y e. A ( ph /\ E. x ps ) ) $=
      ( wa wrex wex rexcom4 19.42v rexbii bitr3i ) ABFZDEGCHMCHZDEGABCHFZDEGMDC
      EINODEABCJKL $.

    $d B x $.
    rexcom4b.1 $e |- B e. _V $.
    $( Specialized existential commutation lemma.  (Contributed by Jeff Madsen,
       1-Jun-2011.) $)
    rexcom4b $p |- ( E. x E. y e. A ( ph /\ x = B ) <-> E. y e. A ph ) $=
      ( cv wceq wa wrex wex rexcom4a isseti biantru rexbii bitr4i ) ABGEHZICDJB
      KAQBKZIZCDJACDJAQBCDLASCDRABEFMNOP $.
  $}

  ${
    $d x A $.
    $( Closed theorem version of ~ ceqsalg .  (Contributed by NM,
       28-Feb-2013.)  (Revised by Mario Carneiro, 10-Oct-2016.) $)
    ceqsalt $p |- ( ( F/ x ps /\ A. x ( x = A -> ( ph <-> ps ) ) /\ A e. V )
         -> ( A. x ( x = A -> ph ) <-> ps ) ) $=
      ( wnf cv wceq wb wi wal wcel w3a wex elisset 3ad2ant3 bi1 imim3i 3ad2ant2
      3ad2ant1 al2imi 19.23t sylibd mpid imim2i com23 alimi 19.21t mpbid impbid
      bi2 ) BCFZCGDHZABIZJZCKZDELZMZUMAJZCKZBURUTUMCNZBUQULVAUPCDEOPURUTUMBJZCK
      ZVABJZUPULUTVCJUQUOUSVBCUNABUMABQRUASULUPVCVDIUQUMBCUBTUCUDURBUSJZCKZBUTJ
      ZUPULVFUQUOVECUOUMBAUNBAJUMABUKUEUFUGSULUPVFVGIUQBUSCUHTUIUJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Restricted quantifier version of ~ ceqsalt .  (Contributed by NM,
       28-Feb-2013.)  (Revised by Mario Carneiro, 10-Oct-2016.) $)
    ceqsralt $p |- ( ( F/ x ps
              /\ A. x ( x = A -> ( ph <-> ps ) ) /\ A e. B )
         -> ( A. x e. B ( x = A -> ph ) <-> ps ) ) $=
      ( wnf cv wceq wb wi wal wcel w3a wral df-ral eleq1 pm5.32ri imbi1i impexp
      wa 3bitr3i albii a1i syl5bb 19.21v syl6bb biimt 3ad2ant3 ceqsalt 3bitr2d
      ) BCFZCGZDHZABIJCKZDELZMZUMAJZCENZUOUQCKZJZUSBUPURUOUQJZCKZUTURULELZUQJZC
      KZUPVBUQCEOVEVBIUPVDVACVCUMTZAJUOUMTZAJVDVAVFVGAUMVCUOULDEPQRVCUMASUOUMAS
      UAUBUCUDUOUQCUEUFUOUKUSUTIUNUOUSUGUHABCDEUIUJ $.
  $}

  ${
    $d x A $.
    ceqsalg.1 $e |- F/ x ps $.
    ceqsalg.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis.  (Contributed by NM,
       29-Oct-2003.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    ceqsalg $p |- ( A e. V -> ( A. x ( x = A -> ph ) <-> ps ) ) $=
      ( wcel cv wceq wi wal wex elisset nfa1 biimpd a2i sps exlimd syl5com
      biimprcd alrimi impbid1 ) DEHZCIDJZAKZCLZBUDUECMUGBCDENUGUEBCUFCOFUFUEBKC
      UEABUEABGPQRSTBUFCFUEABGUAUBUC $.
  $}

  ${
    $d x A $.
    ceqsal.1 $e |- F/ x ps $.
    ceqsal.2 $e |- A e. _V $.
    ceqsal.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis.  (Contributed by NM,
       18-Aug-1993.) $)
    ceqsal $p |- ( A. x ( x = A -> ph ) <-> ps ) $=
      ( cvv wcel cv wceq wi wal wb ceqsalg ax-mp ) DHICJDKALCMBNFABCDHEGOP $.
  $}

  ${
    $d x A $.  $d x ps $.
    ceqsalv.1 $e |- A e. _V $.
    ceqsalv.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis.  (Contributed by NM,
       18-Aug-1993.) $)
    ceqsalv $p |- ( A. x ( x = A -> ph ) <-> ps ) $=
      ( nfv ceqsal ) ABCDBCGEFH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    ceqsralv.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Restricted quantifier version of ~ ceqsalv .  (Contributed by NM,
       21-Jun-2013.) $)
    ceqsralv $p |- ( A e. B -> ( A. x e. B ( x = A -> ph ) <-> ps ) ) $=
      ( wnf cv wceq wb wi wal wcel wral nfv ax-gen ceqsralt mp3an12 ) BCGCHDIZA
      BJKZCLDEMSAKCENBJBCOTCFPABCDEQR $.
  $}

  ${
    $d x ps $.
    gencl.1 $e |- ( th <-> E. x ( ch /\ A = B ) ) $.
    gencl.2 $e |- ( A = B -> ( ph <-> ps ) ) $.
    gencl.3 $e |- ( ch -> ph ) $.
    $( Implicit substitution for class with embedded variable.  (Contributed by
       NM, 17-May-1996.) $)
    gencl $p |- ( th -> ps ) $=
      ( wceq wa wex syl5ib impcom exlimiv sylbi ) DCFGKZLZEMBHSBERCBCARBJINOPQ
      $.
  $}

  ${
    $d x y $.  $d x R $.  $d x ps $.  $d y C $.  $d y S $.  $d y ch $.
    2gencl.1 $e |- ( C e. S <-> E. x e. R A = C ) $.
    2gencl.2 $e |- ( D e. S <-> E. y e. R B = D ) $.
    2gencl.3 $e |- ( A = C -> ( ph <-> ps ) ) $.
    2gencl.4 $e |- ( B = D -> ( ps <-> ch ) ) $.
    2gencl.5 $e |- ( ( x e. R /\ y e. R ) -> ph ) $.
    $( Implicit substitution for class with embedded variable.  (Contributed by
       NM, 17-May-1996.) $)
    2gencl $p |- ( ( C e. S /\ D e. S ) -> ch ) $=
      ( wcel wi cv wceq wrex wa wex df-rex bitri imbi2d ex gencl com12 impcom )
      IKQZHKQZCULBRULCRESJQZUKEGIUKGITZEJUAUMUNUBEUCMUNEJUDUEUNBCULOUFULUMBUMAR
      UMBRDSJQZULDFHULFHTZDJUAUOUPUBDUCLUPDJUDUEUPABUMNUFUOUMAPUGUHUIUHUJ $.
  $}

  ${
    $d x y z $.  $d y z D $.  $d z F $.  $d x y R $.  $d y z S $.  $d x ps $.
    $d y ch $.  $d z th $.
    3gencl.1 $e |- ( D e. S <-> E. x e. R A = D ) $.
    3gencl.2 $e |- ( F e. S <-> E. y e. R B = F ) $.
    3gencl.3 $e |- ( G e. S <-> E. z e. R C = G ) $.
    3gencl.4 $e |- ( A = D -> ( ph <-> ps ) ) $.
    3gencl.5 $e |- ( B = F -> ( ps <-> ch ) ) $.
    3gencl.6 $e |- ( C = G -> ( ch <-> th ) ) $.
    3gencl.7 $e |- ( ( x e. R /\ y e. R /\ z e. R ) -> ph ) $.
    $( Implicit substitution for class with embedded variable.  (Contributed by
       NM, 17-May-1996.) $)
    3gencl $p |- ( ( D e. S /\ F e. S /\ G e. S ) -> th ) $=
      ( wcel wa wi wceq wrex wex df-rex bitri imbi2d 3expia 2gencl com12 3impia
      cv gencl ) KMUCZNMUCZOMUCZDUTURUSUDZDVACUEVADUEGUPLUCZUTGJOUTJOUFZGLUGVBV
      CUDGUHRVCGLUIUJVCCDVAUAUKVAVBCVBAUEVBBUEVBCUEEFHIKNLMPQHKUFABVBSUKINUFBCV
      BTUKEUPLUCFUPLUCVBAUBULUMUNUQUNUO $.
  $}

  ${
    $d x A $.  $d x ps $.
    cgsexg.1 $e |- ( x = A -> ch ) $.
    cgsexg.2 $e |- ( ch -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for general classes.  (Contributed by
       NM, 26-Aug-2007.) $)
    cgsexg $p |- ( A e. V ->
                     ( E. x ( ch /\ ph ) <-> ps ) ) $=
      ( wcel wa wex biimpa exlimiv cv wceq elisset eximi syl biimprcd ancld
      eximdv syl5com impbid2 ) EFIZCAJZDKZBUEBDCABHLMUDCDKZBUFUDDNEOZDKUGDEFPUH
      CDGQRBCUEDBCACABHSTUAUBUC $.
  $}

  ${
    $d x y ps $.  $d x y A $.  $d x y B $.
    cgsex2g.1 $e |- ( ( x = A /\ y = B ) -> ch ) $.
    cgsex2g.2 $e |- ( ch -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for general classes.  (Contributed by
       NM, 26-Jul-1995.) $)
    cgsex2g $p |- ( ( A e. V /\ B e. W ) ->
                     ( E. x E. y ( ch /\ ph ) <-> ps ) ) $=
      ( wcel wa wex biimpa exlimivv cv wceq elisset anim12i eeanv sylibr 2eximi
      syl biimprcd ancld 2eximdv syl5com impbid2 ) FHLZGILZMZCAMZENDNZBUMBDECAB
      KOPULCENDNZBUNULDQFRZEQGRZMZENDNZUOULUPDNZUQENZMUSUJUTUKVADFHSEGISTUPUQDE
      UAUBURCDEJUCUDBCUMDEBCACABKUEUFUGUHUI $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x y z w ps $.
    cgsex4g.1 $e |- ( ( ( x = A /\ y = B ) /\ ( z = C /\ w = D ) ) -> ch ) $.
    cgsex4g.2 $e |- ( ch -> ( ph <-> ps ) ) $.
    $( An implicit substitution inference for 4 general classes.  (Contributed
       by NM, 5-Aug-1995.) $)
    cgsex4g $p |- ( ( ( A e. R /\ B e. S ) /\ ( C e. R /\ D e. S ) ) ->
                    ( E. x E. y E. z E. w ( ch /\ ph ) <-> ps ) ) $=
      ( wcel wa wex cv wceq biimpa exlimivv elisset anim12i eeanv sylibr ee4anv
      2eximi syl biimprcd ancld 2eximdv syl5com impbid2 ) HLPZIMPZQZJLPZKMPZQZQ
      ZCAQZGRFRZERDRZBVCBDEVBBFGCABOUAUBUBVACGRFRZERDRZBVDVADSHTZESITZQZFSJTZGS
      KTZQZQZGRFRZERDRZVFVAVIERDRZVLGRFRZQVOUQVPUTVQUQVGDRZVHERZQVPUOVRUPVSDHLU
      CEIMUCUDVGVHDEUEUFUTVJFRZVKGRZQVQURVTUSWAFJLUCGKMUCUDVJVKFGUEUFUDVIVLDEFG
      UGUFVNVEDEVMCFGNUHUHUIBVEVCDEBCVBFGBCACABOUJUKULULUMUN $.
  $}

  ${
    $d x A $.
    ceqsex.1 $e |- F/ x ps $.
    ceqsex.2 $e |- A e. _V $.
    ceqsex.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of an existential quantifier, using implicit substitution.
       (Contributed by NM, 2-Mar-1995.)  (Revised by Mario Carneiro,
       10-Oct-2016.) $)
    ceqsex $p |- ( E. x ( x = A /\ ph ) <-> ps ) $=
      ( cv wceq wa wex biimpa exlimi wi wal biimprcd alrimi isseti exintr ee10
      impbii ) CHDIZAJZCKZBUCBCEUBABGLMBUBANZCOUBCKUDBUECEUBABGPQCDFRUBACSTUA
      $.
  $}

  ${
    $d x A $.  $d x ps $.
    ceqsexv.1 $e |- A e. _V $.
    ceqsexv.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of an existential quantifier, using implicit substitution.
       (Contributed by NM, 2-Mar-1995.) $)
    ceqsexv $p |- ( E. x ( x = A /\ ph ) <-> ps ) $=
      ( nfv ceqsex ) ABCDBCGEFH $.
  $}

  ${
    $d x y A $.  $d x y B $.
    ceqsex2.1 $e |- F/ x ps $.
    ceqsex2.2 $e |- F/ y ch $.
    ceqsex2.3 $e |- A e. _V $.
    ceqsex2.4 $e |- B e. _V $.
    ceqsex2.5 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex2.6 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Elimination of two existential quantifiers, using implicit
       substitution.  (Contributed by Scott Fenton, 7-Jun-2006.) $)
    ceqsex2 $p |- ( E. x E. y ( x = A /\ y = B /\ ph ) <-> ch ) $=
      ( cv wceq w3a wex wa exbii ceqsex 3anass 19.42v nfan anbi2d exbidv 3bitri
      bitri nfv nfex ) DNFOZENGOZAPZEQZDQUJUKARZEQZRZDQUKBRZEQZCUMUPDUMUJUNRZEQ
      UPULUSEUJUKAUASUJUNEUBUGSUOURDFUQDEUKBDUKDUHHUCUIJUJUNUQEUJABUKLUDUETBCEG
      IKMTUF $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x ps $.  $d y ch $.
    ceqsex2v.1 $e |- A e. _V $.
    ceqsex2v.2 $e |- B e. _V $.
    ceqsex2v.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex2v.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Elimination of two existential quantifiers, using implicit
       substitution.  (Contributed by Scott Fenton, 7-Jun-2006.) $)
    ceqsex2v $p |- ( E. x E. y ( x = A /\ y = B /\ ph ) <-> ch ) $=
      ( nfv ceqsex2 ) ABCDEFGBDLCELHIJKM $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x ps $.  $d y ch $.
    $d z th $.
    ceqsex3v.1 $e |- A e. _V $.
    ceqsex3v.2 $e |- B e. _V $.
    ceqsex3v.3 $e |- C e. _V $.
    ceqsex3v.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex3v.5 $e |- ( y = B -> ( ps <-> ch ) ) $.
    ceqsex3v.6 $e |- ( z = C -> ( ch <-> th ) ) $.
    $( Elimination of three existential quantifiers, using implicit
       substitution.  (Contributed by NM, 16-Aug-2011.) $)
    ceqsex3v $p |- ( E. x E. y E. z ( ( x = A /\ y = B /\ z = C ) /\ ph )
                 <-> th ) $=
      ( cv wceq wa wex anass 3anass anbi1i df-3an anbi2i 3bitr4i 2exbii 19.42vv
      w3a bitri exbii 3anbi3d 2exbidv ceqsexv ceqsex2v ) EQHRZFQIRZGQJRZUIZASZG
      TFTZETUPUQURAUIZGTFTZSZETZDVAVDEVAUPVBSZGTFTVDUTVFFGUPUQURSZSZASUPVGASZSU
      TVFUPVGAUAUSVHAUPUQURUBUCVBVIUPUQURAUDUEUFUGUPVBFGUHUJUKVEUQURBUIZGTFTZDV
      CVKEHKUPVBVJFGUPABUQURNULUMUNBCDFGIJLMOPUOUJUJ $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x ps $.  $d y ch $.  $d z th $.  $d w ta $.
    ceqsex4v.1 $e |- A e. _V $.
    ceqsex4v.2 $e |- B e. _V $.
    ceqsex4v.3 $e |- C e. _V $.
    ceqsex4v.4 $e |- D e. _V $.
    ceqsex4v.7 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex4v.8 $e |- ( y = B -> ( ps <-> ch ) ) $.
    ceqsex4v.9 $e |- ( z = C -> ( ch <-> th ) ) $.
    ceqsex4v.10 $e |- ( w = D -> ( th <-> ta ) ) $.
    $( Elimination of four existential quantifiers, using implicit
       substitution.  (Contributed by NM, 23-Sep-2011.) $)
    ceqsex4v $p |- ( E. x E. y E. z E. w
          ( ( x = A /\ y = B ) /\ ( z = C /\ w = D ) /\ ph ) <-> ta ) $=
      ( wceq w3a wex 19.42vv 3anass df-3an anbi2i bitr4i 2exbii 3bitr4i 3anbi3d
      cv wa 2exbidv ceqsex2v 3bitri ) FUMJUBZGUMKUBZUNZHUMLUBZIUMMUBZUNZAUCZIUD
      HUDZGUDFUDURUSVAVBAUCZIUDHUDZUCZGUDFUDVAVBCUCZIUDHUDZEVEVHFGUTVFUNZIUDHUD
      UTVGUNVEVHUTVFHIUEVDVKHIVDUTVCAUNZUNVKUTVCAUFVFVLUTVAVBAUGUHUIUJURUSVGUGU
      KUJVGVAVBBUCZIUDHUDVJFGJKNOURVFVMHIURABVAVBRULUOUSVMVIHIUSBCVAVBSULUOUPCD
      EHILMPQTUAUPUQ $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.  $d x y z w v u E $.  $d x y z w v u F $.  $d x ps $.
    $d y ch $.  $d z th $.  $d w ta $.  $d v et $.  $d u ze $.
    ceqsex6v.1 $e |- A e. _V $.
    ceqsex6v.2 $e |- B e. _V $.
    ceqsex6v.3 $e |- C e. _V $.
    ceqsex6v.4 $e |- D e. _V $.
    ceqsex6v.5 $e |- E e. _V $.
    ceqsex6v.6 $e |- F e. _V $.
    ceqsex6v.7 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex6v.8 $e |- ( y = B -> ( ps <-> ch ) ) $.
    ceqsex6v.9 $e |- ( z = C -> ( ch <-> th ) ) $.
    ceqsex6v.10 $e |- ( w = D -> ( th <-> ta ) ) $.
    ceqsex6v.11 $e |- ( v = E -> ( ta <-> et ) ) $.
    ceqsex6v.12 $e |- ( u = F -> ( et <-> ze ) ) $.
    $( Elimination of six existential quantifiers, using implicit
       substitution.  (Contributed by NM, 21-Sep-2011.) $)
    ceqsex6v $p |- ( E. x E. y E. z E. w E. v E. u
          ( ( x = A /\ y = B /\ z = C ) /\ ( w = D /\ v = E /\ u = F ) /\ ph )
                 <-> ze ) $=
      ( cv wceq w3a wex wa 3anass 3exbii 19.42vvv bitri anbi2d 3exbidv ceqsex3v
      ) HULNUMZIULOUMZJULPUMZUNZKULQUMLULRUMMULSUMUNZAUNZMUOLUOKUOZJUOIUOHUOVGV
      HAUPZMUOLUOKUOZUPZJUOIUOHUOZGVJVMHIJVJVGVKUPZMUOLUOKUOVMVIVOKLMVGVHAUQURV
      GVKKLMUSUTURVNVHDUPZMUOLUOKUOZGVLVHBUPZMUOLUOKUOVHCUPZMUOLUOKUOVQHIJNOPTU
      AUBVDVKVRKLMVDABVHUFVAVBVEVRVSKLMVEBCVHUGVAVBVFVSVPKLMVFCDVHUHVAVBVCDEFGK
      LMQRSUCUDUEUIUJUKVCUTUT $.
  $}

  ${
    $d x y z w v u t s A $.  $d x y z w v u t s B $.  $d x y z w v u t s C $.
    $d x y z w v u t s D $.  $d x y z w v u t s E $.  $d x y z w v u t s F $.
    $d x y z w v u t s G $.  $d x y z w v u t s H $.  $d x ps $.  $d y ch $.
    $d z th $.  $d w ta $.  $d v et $.  $d u ze $.  $d t si $.  $d s rh $.
    ceqsex8v.1 $e |- A e. _V $.
    ceqsex8v.2 $e |- B e. _V $.
    ceqsex8v.3 $e |- C e. _V $.
    ceqsex8v.4 $e |- D e. _V $.
    ceqsex8v.5 $e |- E e. _V $.
    ceqsex8v.6 $e |- F e. _V $.
    ceqsex8v.7 $e |- G e. _V $.
    ceqsex8v.8 $e |- H e. _V $.
    ceqsex8v.9 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsex8v.10 $e |- ( y = B -> ( ps <-> ch ) ) $.
    ceqsex8v.11 $e |- ( z = C -> ( ch <-> th ) ) $.
    ceqsex8v.12 $e |- ( w = D -> ( th <-> ta ) ) $.
    ceqsex8v.13 $e |- ( v = E -> ( ta <-> et ) ) $.
    ceqsex8v.14 $e |- ( u = F -> ( et <-> ze ) ) $.
    ceqsex8v.15 $e |- ( t = G -> ( ze <-> si ) ) $.
    ceqsex8v.16 $e |- ( s = H -> ( si <-> rh ) ) $.
    $( Elimination of eight existential quantifiers, using implicit
       substitution.  (Contributed by NM, 23-Sep-2011.) $)
    ceqsex8v $p |- ( E. x E. y E. z E. w E. v E. u E. t E. s
              ( ( ( x = A /\ y = B ) /\ ( z = C /\ w = D ) )
         /\ ( ( v = E /\ u = F ) /\ ( t = G /\ s = H ) ) /\ ph ) <-> rh ) $=
      ( cv wceq wa w3a 19.42vv 2exbii bitri 3anass df-3an anbi2i bitr4i 3bitr4i
      wex 3anbi3d 4exbidv ceqsex4v ) JVBQVCZKVBRVCZVDZLVBSVCZMVBTVCZVDZVDZNVBUA
      VCOVBUBVCVDZPVBUCVCUEVBUDVCVDZVDZAVEZUEVNPVNZOVNNVNZMVNLVNZKVNJVNVTWCWEWF
      AVEZUEVNPVNZOVNNVNZVEZMVNLVNZKVNJVNZIWKWPJKWJWOLMWDWLVDZUEVNPVNZOVNNVNZWD
      WNVDZWJWOWTWDWMVDZOVNNVNXAWSXBNOWDWLPUEVFVGWDWMNOVFVHWIWSNOWHWRPUEWHWDWGA
      VDZVDWRWDWGAVIWLXCWDWEWFAVJVKVLVGVGVTWCWNVJVMVGVGWQWEWFEVEZUEVNPVNOVNNVNZ
      IWNWEWFBVEZUEVNPVNOVNNVNWEWFCVEZUEVNPVNOVNNVNWEWFDVEZUEVNPVNOVNNVNXEJKLMQ
      RSTUFUGUHUIVRWLXFNOPUEVRABWEWFUNVOVPVSXFXGNOPUEVSBCWEWFUOVOVPWAXGXHNOPUEW
      ACDWEWFUPVOVPWBXHXDNOPUEWBDEWEWFUQVOVPVQEFGHINOPUEUAUBUCUDUJUKULUMURUSUTV
      AVQVHVH $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x th $.  $d y ch $.  $d y A $.
    gencbvex.1 $e |- A e. _V $.
    gencbvex.2 $e |- ( A = y -> ( ph <-> ps ) ) $.
    gencbvex.3 $e |- ( A = y -> ( ch <-> th ) ) $.
    gencbvex.4 $e |- ( th <-> E. x ( ch /\ A = y ) ) $.
    $( Change of bound variable using implicit substitution.  (Contributed by
       NM, 17-May-1996.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    gencbvex $p |- ( E. x ( ch /\ ph ) <-> E. y ( th /\ ps ) ) $=
      ( cv wceq wa wex excom wb anbi12d bicomd exbii eqcoms ceqsexv simpr eqcom
      19.41v biimpi adantl eximi sylbi adantr ancri impbii bitri 3bitr3i ) FLZG
      MZDBNZNZFOZEOUREOZFOCANZEOUQFOUREFPUSVAEUQVAFGHUQVAQGUOGUOMZVAUQVBCDABJIR
      SUAUBTUTUQFUTUPEOZUQNZUQUPUQEUEVDUQVCUQUCUQVCDVCBDCVBNZEOVCKVEUPEVBUPCVBU
      PGUOUDUFUGUHUIUJUKULUMTUN $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x th $.  $d y ch $.  $d y A $.
    gencbvex2.1 $e |- A e. _V $.
    gencbvex2.2 $e |- ( A = y -> ( ph <-> ps ) ) $.
    gencbvex2.3 $e |- ( A = y -> ( ch <-> th ) ) $.
    gencbvex2.4 $e |- ( th -> E. x ( ch /\ A = y ) ) $.
    $( Restatement of ~ gencbvex with weaker hypotheses.  (Contributed by
       Jeffrey Hankins, 6-Dec-2006.) $)
    gencbvex2 $p |- ( E. x ( ch /\ ph ) <-> E. y ( th /\ ps ) ) $=
      ( cv wceq wa wex biimpac exlimiv impbii gencbvex ) ABCDEFGHIJDCGFLMZNZEOK
      UADETCDJPQRS $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x th $.  $d y ch $.  $d y A $.
    gencbval.1 $e |- A e. _V $.
    gencbval.2 $e |- ( A = y -> ( ph <-> ps ) ) $.
    gencbval.3 $e |- ( A = y -> ( ch <-> th ) ) $.
    gencbval.4 $e |- ( th <-> E. x ( ch /\ A = y ) ) $.
    $( Change of bound variable using implicit substitution.  (Contributed by
       NM, 17-May-1996.) $)
    gencbval $p |- ( A. x ( ch -> ph ) <-> A. y ( th -> ps ) ) $=
      ( wi wal wn wa wex cv wceq notbid exanali gencbvex 3bitr3i con4bii ) CALE
      MZDBLFMZCANZOEPDBNZOFPUDNUENUFUGCDEFGHGFQRABISJKUACAETDBFTUBUC $.
  $}

  ${
    $d A x $.  $d x y $.
    sbhypf.1 $e |- F/ x ps $.
    sbhypf.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Introduce an explicit substitution into an implicit substitution
       hypothesis.  See also ~ csbhypf .  (Contributed by Raph Levien,
       10-Apr-2004.) $)
    sbhypf $p |- ( y = A -> ( [ y / x ] ph <-> ps ) ) $=
      ( cv wceq wa wex wsb wb vex eqeq1 ceqsexv nfs1v nfbi sbequ12 bicomd
      sylan9bb exlimi sylbir ) DHZEIZCHZUDIZUFEIZJZCKACDLZBMZUHUECUDDNUFUDEOPUI
      UKCUJBCACDQFRUGUJAUHBUGAUJACDSTGUAUBUC $.
  $}

  ${
    $d y z A $.  $d x z $.  $d y z $.
    $( Closed theorem form of ~ vtoclgf .  (Contributed by NM, 17-Feb-2013.)
       (Revised by Mario Carneiro, 12-Oct-2016.) $)
    vtoclgft $p |- ( ( ( F/_ x A /\ F/ x ps )
                  /\ ( A. x ( x = A -> ( ph <-> ps ) )
                     /\ A. x ph ) /\ A e. V ) -> ps ) $=
      ( vz wcel wnfc wnf wa cv wceq wb wi wal cvv elex w3a wex mpbid elisset id
      3ad2ant3 nfnfc1 nfcvd nfeqd eqeq1 a1i cbvexd 3adant3 bi1 imim2i com23 imp
      ad2antrr alanimi 3ad2ant2 simp1r 19.23t syl mpd syl3an3 ) DEGCDHZBCIZJZCK
      ZDLZABMZNZCOACOJZDPGZBDEQVEVJVKRZVGCSZBVLFKZDLZFSZVMVKVEVPVJFDPUAUCVEVJVP
      VMMZVKVCVQVDVJVCVOVGFCCDUDVCCVNDVCCVNUEVCUBUFVNVFLVOVGMNVCVNVFDUGUHUIUOUJ
      TVLVGBNZCOZVMBNZVJVEVSVKVIAVRCVIAVRVIVGABVHABNVGABUKULUMUNUPUQVLVDVSVTMVC
      VDVJVKURVGBCUSUTTVAVB $.
  $}

  ${
    vtocld.1 $e |- ( ph -> A e. V ) $.
    vtocld.2 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    vtocld.3 $e |- ( ph -> ps ) $.
    ${
      vtocldf.4 $e |- F/ x ph $.
      vtocldf.5 $e |- ( ph -> F/_ x A ) $.
      vtocldf.6 $e |- ( ph -> F/ x ch ) $.
      $( Implicit substitution of a class for a set variable.  (Contributed by
         Mario Carneiro, 15-Oct-2016.) $)
      vtocldf $p |- ( ph -> ch ) $=
        ( wnfc wnf cv wceq wb wi wal alrimi wcel ex vtoclgft syl221anc ) ADEMCD
        NDOEPZBCQZRZDSBDSEFUACKLAUGDJAUEUFHUBTABDJITGBCDEFUCUD $.
    $}

    $d x A $.  $d x ph $.  $d x ch $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       Mario Carneiro, 15-Oct-2016.) $)
    vtocld $p |- ( ph -> ch ) $=
      ( nfv nfcvd nfvd vtocldf ) ABCDEFGHIADJADEKACDLM $.
  $}

  ${
    $d x A $.
    vtoclf.1 $e |- F/ x ps $.
    vtoclf.2 $e |- A e. _V $.
    vtoclf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclf.4 $e |- ph $.
    $( Implicit substitution of a class for a set variable.  This is a
       generalization of ~ chvar .  (Contributed by NM, 30-Aug-1993.) $)
    vtoclf $p |- ps $=
      ( cv wceq wi isseti biimpd eximii 19.36i mpg ) ABCABCECIDJZABKCCDFLQABGMN
      OHP $.
  $}

  ${
    $d x A $.  $d x ps $.
    vtocl.1 $e |- A e. _V $.
    vtocl.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl.3 $e |- ph $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 30-Aug-1993.) $)
    vtocl $p |- ps $=
      ( nfv vtoclf ) ABCDBCHEFGI $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    vtocl2.1 $e |- A e. _V $.
    vtocl2.2 $e |- B e. _V $.
    vtocl2.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    vtocl2.4 $e |- ph $.
    $( Implicit substitution of classes for set variables.  (Contributed by NM,
       26-Jul-1995.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    vtocl2 $p |- ps $=
      ( wal wi wex cv wceq isseti wa eeanv biimpd 2eximi sylbir 19.36v 19.36aiv
      mp2an exbii mpbi ax-gen mpg ) ADKZBCUIBCABLZDMZCMZUIBLZCMCNEOZCMZDNFOZDMZ
      ULCEGPDFHPUOUQQUNUPQZDMCMULUNUPCDRURUJCDURABISTUAUDUKUMCABDUBUEUFUCADJUGU
      H $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z ps $.
    vtocl3.1 $e |- A e. _V $.
    vtocl3.2 $e |- B e. _V $.
    vtocl3.3 $e |- C e. _V $.
    vtocl3.4 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    vtocl3.5 $e |- ph $.
    $( Implicit substitution of classes for set variables.  (Contributed by NM,
       3-Jun-1995.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    vtocl3 $p |- ps $=
      ( wal wi wex cv wceq isseti w3a eeeanv biimpd 2eximi sylbir 19.36v 2exbii
      eximi mp3an mpbi exbii 19.36aiv gen2 mpg ) AENZDNZBCUOBCUNBOZDPZCPZUOBOZC
      PABOZEPZDPCPZURCQFRZCPZDQGRZDPZEQHRZEPZVBCFISDGJSEHKSVDVFVHTVCVEVGTZEPZDP
      CPVBVCVEVGCDEUAVJVACDVIUTEVIABLUBUGUCUDUHVAUPCDABEUEUFUIUQUSCUNBDUEUJUIUK
      ADEMULUM $.
  $}

  ${
    $d x A $.  $d x ch $.  $d x th $.
    vtoclb.1 $e |- A e. _V $.
    vtoclb.2 $e |- ( x = A -> ( ph <-> ch ) ) $.
    vtoclb.3 $e |- ( x = A -> ( ps <-> th ) ) $.
    vtoclb.4 $e |- ( ph <-> ps ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 23-Dec-1993.) $)
    vtoclb $p |- ( ch <-> th ) $=
      ( wb cv wceq bibi12d vtocl ) ABKCDKEFGELFMACBDHINJO $.
  $}

  ${
    vtoclgf.1 $e |- F/_ x A $.
    vtoclgf.2 $e |- F/ x ps $.
    vtoclgf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclgf.4 $e |- ph $.
    $( Implicit substitution of a class for a set variable, with bound-variable
       hypotheses in place of distinct variable restrictions.  (Contributed by
       NM, 21-Sep-2003.)  (Proof shortened by Mario Carneiro, 10-Oct-2016.) $)
    vtoclgf $p |- ( A e. V -> ps ) $=
      ( wcel cvv elex cv wceq wex issetf mpbii exlimi sylbi syl ) DEJDKJZBDELUA
      CMDNZCOBCDFPUBBCGUBABIHQRST $.
  $}

  ${
    $d x A $.  $d x ps $.
    vtoclg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclg.2 $e |- ph $.
    $( Implicit substitution of a class expression for a set variable.
       (Contributed by NM, 17-Apr-1995.) $)
    vtoclg $p |- ( A e. V -> ps ) $=
      ( nfcv nfv vtoclgf ) ABCDECDHBCIFGJ $.
  $}

  ${
    $d x A $.  $d x ch $.  $d x th $.
    vtoclbg.1 $e |- ( x = A -> ( ph <-> ch ) ) $.
    vtoclbg.2 $e |- ( x = A -> ( ps <-> th ) ) $.
    vtoclbg.3 $e |- ( ph <-> ps ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 29-Apr-1994.) $)
    vtoclbg $p |- ( A e. V -> ( ch <-> th ) ) $=
      ( wb cv wceq bibi12d vtoclg ) ABKCDKEFGELFMACBDHINJO $.
  $}

  ${
    vtocl2gf.1 $e |- F/_ x A $.
    vtocl2gf.2 $e |- F/_ y A $.
    vtocl2gf.3 $e |- F/_ y B $.
    vtocl2gf.4 $e |- F/ x ps $.
    vtocl2gf.5 $e |- F/ y ch $.
    vtocl2gf.6 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2gf.7 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2gf.8 $e |- ph $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 25-Apr-1995.) $)
    vtocl2gf $p |- ( ( A e. V /\ B e. W ) -> ch ) $=
      ( wcel cvv wi elex nfel1 nfim cv wceq imbi2d vtoclgf mpan9 ) FHRFSRZGIRCF
      HUAUIBTUICTEGILUICEEFSKUBNUCEUDGUEBCUIPUFABDFSJMOQUGUGUH $.
  $}

  ${
    $d w A $.  $d w B $.  $d w C $.  $d w y $.  $d w z $.
    vtocl3gf.a $e |- F/_ x A $.
    vtocl3gf.b $e |- F/_ y A $.
    vtocl3gf.c $e |- F/_ z A $.
    vtocl3gf.d $e |- F/_ y B $.
    vtocl3gf.e $e |- F/_ z B $.
    vtocl3gf.f $e |- F/_ z C $.
    vtocl3gf.1 $e |- F/ x ps $.
    vtocl3gf.2 $e |- F/ y ch $.
    vtocl3gf.3 $e |- F/ z th $.
    vtocl3gf.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl3gf.5 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl3gf.6 $e |- ( z = C -> ( ch <-> th ) ) $.
    vtocl3gf.7 $e |- ph $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 10-Aug-2013.)  (Revised by Mario Carneiro, 10-Oct-2016.) $)
    vtocl3gf $p |- ( ( A e. V /\ B e. W /\ C e. X ) -> th ) $=
      ( wcel cvv wa elex wi nfel1 nfim wceq imbi2d vtoclgf vtocl2gf mpan9 3impb
      cv ) HKUGZILUGZJMUGZDVAHUHUGZVBVCUIDHKUJVDBUKVDCUKVDDUKFGIJLMQRSVDCFFHUHO
      ULUAUMVDDGGHUHPULUBUMFUTIUNBCVDUDUOGUTJUNCDVDUEUOABEHUHNTUCUFUPUQURUS $.
  $}

  ${
    $d w x A $.  $d y A $.  $d w y B $.  $d x ps $.  $d y ch $.
    vtocl2g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2g.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2g.3 $e |- ph $.
    $( Implicit substitution of 2 classes for 2 set variables.  (Contributed by
       NM, 25-Apr-1995.) $)
    vtocl2g $p |- ( ( A e. V /\ B e. W ) -> ch ) $=
      ( nfcv nfv vtocl2gf ) ABCDEFGHIDFMEFMEGMBDNCENJKLO $.
  $}

  ${
    $d y A $.  $d x B z $.
    vtoclgaf.1 $e |- F/_ x A $.
    vtoclgaf.2 $e |- F/ x ps $.
    vtoclgaf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclgaf.4 $e |- ( x e. B -> ph ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 17-Feb-2006.)  (Revised by Mario Carneiro, 10-Oct-2016.) $)
    vtoclgaf $p |- ( A e. B -> ps ) $=
      ( wcel cv wi nfel1 nfim wceq eleq1 imbi12d vtoclgf pm2.43i ) DEJZBCKZEJZA
      LTBLCDEFTBCCDEFMGNUADOUBTABUADEPHQIRS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x ps $.
    vtoclga.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclga.2 $e |- ( x e. B -> ph ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 20-Aug-1995.) $)
    vtoclga $p |- ( A e. B -> ps ) $=
      ( nfcv nfv vtoclgaf ) ABCDECDHBCIFGJ $.
  $}

  ${
    $d x y C $.  $d x y D $.
    vtocl2gaf.a $e |- F/_ x A $.
    vtocl2gaf.b $e |- F/_ y A $.
    vtocl2gaf.c $e |- F/_ y B $.
    vtocl2gaf.1 $e |- F/ x ps $.
    vtocl2gaf.2 $e |- F/ y ch $.
    vtocl2gaf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2gaf.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2gaf.5 $e |- ( ( x e. C /\ y e. D ) -> ph ) $.
    $( Implicit substitution of 2 classes for 2 set variables.  (Contributed by
       NM, 10-Aug-2013.) $)
    vtocl2gaf $p |- ( ( A e. C /\ B e. D ) -> ch ) $=
      ( wcel wa wi cv nfel1 nfan nfim wceq eleq1 anbi1d imbi12d anbi2d vtocl2gf
      nfv pm2.43i ) FHRZGIRZSZCDUAZHRZEUAZIRZSZATUMUSSZBTUOCTDEFGHIJKLVABDUMUSD
      DFHJUBUSDUKUCMUDUOCEUMUNEEFHKUBEGILUBUCNUDUPFUEZUTVAABVBUQUMUSUPFHUFUGOUH
      URGUEZVAUOBCVCUSUNUMURGIUFUIPUHQUJUL $.
  $}

  ${
    $d w x y A $.  $d w y B $.  $d w x y C $.  $d w x y D $.  $d x ps $.
    $d y ch $.
    vtocl2ga.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl2ga.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl2ga.3 $e |- ( ( x e. C /\ y e. D ) -> ph ) $.
    $( Implicit substitution of 2 classes for 2 set variables.  (Contributed by
       NM, 20-Aug-1995.) $)
    vtocl2ga $p |- ( ( A e. C /\ B e. D ) -> ch ) $=
      ( nfcv nfv vtocl2gaf ) ABCDEFGHIDFMEFMEGMBDNCENJKLO $.
  $}

  ${
    $d w A $.  $d w B $.  $d w C $.  $d w x y z R $.  $d w x y z S $.
    $d w x y z T $.
    vtocl3gaf.a $e |- F/_ x A $.
    vtocl3gaf.b $e |- F/_ y A $.
    vtocl3gaf.c $e |- F/_ z A $.
    vtocl3gaf.d $e |- F/_ y B $.
    vtocl3gaf.e $e |- F/_ z B $.
    vtocl3gaf.f $e |- F/_ z C $.
    vtocl3gaf.1 $e |- F/ x ps $.
    vtocl3gaf.2 $e |- F/ y ch $.
    vtocl3gaf.3 $e |- F/ z th $.
    vtocl3gaf.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl3gaf.5 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl3gaf.6 $e |- ( z = C -> ( ch <-> th ) ) $.
    vtocl3gaf.7 $e |- ( ( x e. R /\ y e. S /\ z e. T ) -> ph ) $.
    $( Implicit substitution of 3 classes for 3 set variables.  (Contributed by
       NM, 10-Aug-2013.)  (Revised by Mario Carneiro, 11-Oct-2016.) $)
    vtocl3gaf $p |- ( ( A e. R /\ B e. S /\ C e. T ) -> th ) $=
      ( wcel w3a cv nfel1 nf3an nfim wceq eleq1 3anbi1d imbi12d 3anbi2d 3anbi3d
      wi nfv vtocl3gf pm2.43i ) HKUGZILUGZJMUGZUHZDEUIZKUGZFUIZLUGZGUIZMUGZUHZA
      USVCVJVLUHZBUSVCVDVLUHZCUSVFDUSEFGHIJKLMNOPQRSVNBEVCVJVLEEHKNUJVJEUTVLEUT
      UKTULVOCFVCVDVLFFHKOUJFILQUJVLFUTUKUAULVFDGVCVDVEGGHKPUJGILRUJGJMSUJUKUBU
      LVGHUMZVMVNABVPVHVCVJVLVGHKUNUOUCUPVIIUMZVNVOBCVQVJVDVCVLVIILUNUQUDUPVKJU
      MZVOVFCDVRVLVEVCVDVKJMUNURUEUPUFVAVB $.
  $}

  ${
    $d w x y z A $.  $d w y z B $.  $d w z C $.  $d w x y z D $.
    $d w x y z R $.  $d w x y z S $.  $d x ps $.  $d y ch $.  $d z th $.
    vtocl3ga.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtocl3ga.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    vtocl3ga.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    vtocl3ga.4 $e |- ( ( x e. D /\ y e. R /\ z e. S ) -> ph ) $.
    $( Implicit substitution of 3 classes for 3 set variables.  (Contributed by
       NM, 20-Aug-1995.) $)
    vtocl3ga $p |- ( ( A e. D /\ B e. R /\ C e. S ) -> th ) $=
      ( nfcv nfv vtocl3gaf ) ABCDEFGHIJKLMEHRFHRGHRFIRGIRGJRBESCFSDGSNOPQT $.
  $}

  ${
    $d x A $.  $d x ph $.
    vtocleg.1 $e |- ( x = A -> ph ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 10-Jan-2004.) $)
    vtocleg $p |- ( A e. V -> ph ) $=
      ( wcel cv wceq wex elisset exlimiv syl ) CDFBGCHZBIABCDJMABEKL $.
  $}

  ${
    $d x A $.
    $( Implicit substitution of a class for a set variable.  (Closed theorem
       version of ~ vtoclef .)  (Contributed by NM, 7-Nov-2005.)  (Revised by
       Mario Carneiro, 11-Oct-2016.) $)
    vtoclegft $p |- ( ( A e. B /\ F/ x ph /\
                   A. x ( x = A -> ph ) ) -> ph ) $=
      ( wcel wnf cv wceq wi wal w3a wex elisset mpan9 3adant2 wb 19.9t 3ad2ant2
      exim mpbid ) CDEZABFZBGCHZAIBJZKABLZAUAUDUEUBUAUCBLUDUEBCDMUCABSNOUBUAUEA
      PUDABQRT $.
  $}

  ${
    $d x A $.
    vtoclef.1 $e |- F/ x ph $.
    vtoclef.2 $e |- A e. _V $.
    vtoclef.3 $e |- ( x = A -> ph ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 18-Aug-1993.) $)
    vtoclef $p |- ph $=
      ( cv wceq wex isseti exlimi ax-mp ) BGCHZBIABCEJMABDFKL $.
  $}

  ${
    $d x A $.  $d x ph $.
    vtocle.1 $e |- A e. _V $.
    vtocle.2 $e |- ( x = A -> ph ) $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 9-Sep-1993.) $)
    vtocle $p |- ph $=
      ( cvv wcel vtocleg ax-mp ) CFGADABCFEHI $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    vtoclri.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    vtoclri.2 $e |- A. x e. B ph $.
    $( Implicit substitution of a class for a set variable.  (Contributed by
       NM, 21-Nov-1994.) $)
    vtoclri $p |- ( A e. B -> ps ) $=
      ( rspec vtoclga ) ABCDEFACEGHI $.
  $}

  ${
    spcimgft.1 $e |- F/ x ps $.
    spcimgft.2 $e |- F/_ x A $.
    $( A closed version of ~ spcimgf .  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    spcimgft $p |- ( A. x ( x = A -> ( ph -> ps ) ) -> ( A e. B ->
                      ( A. x ph -> ps ) ) ) $=
      ( wcel cvv cv wceq wi wal elex wex issetf exim syl5bi 19.36 syl6ib syl5 )
      DEHDIHZCJDKZABLZLCMZACMBLZDENUEUBUDCOZUFUBUCCOUEUGCDGPUCUDCQRABCFSTUA $.

    $( A closed version of ~ spcgf .  (Contributed by Andrew Salmon,
       6-Jun-2011.)  (Revised by Mario Carneiro, 4-Jan-2017.) $)
    spcgft $p |- ( A. x ( x = A -> ( ph <-> ps ) ) -> ( A e. B ->
                      ( A. x ph -> ps ) ) ) $=
      ( cv wceq wb wi wal wcel bi1 imim2i alimi spcimgft syl ) CHDIZABJZKZCLSAB
      KZKZCLDEMACLBKKUAUCCTUBSABNOPABCDEFGQR $.
  $}

  ${
    spcimgf.1 $e |- F/_ x A $.
    spcimgf.2 $e |- F/ x ps $.
    ${
      spcimgf.3 $e |- ( x = A -> ( ph -> ps ) ) $.
      $( Rule of specialization, using implicit substitution.  Compare Theorem
         7.3 of [Quine] p. 44.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
      spcimgf $p |- ( A e. V -> ( A. x ph -> ps ) ) $=
        ( cv wceq wi wcel wal spcimgft mpg ) CIDJABKKDELACMBKKCABCDEGFNHO $.
    $}

    spcimegf.3 $e |- ( x = A -> ( ps -> ph ) ) $.
    $( Existential specialization, using implicit substitution.  (Contributed
       by Mario Carneiro, 4-Jan-2017.) $)
    spcimegf $p |- ( A e. V -> ( ps -> E. x ph ) ) $=
      ( wcel wn wal wex nfn cv wceq con3d spcimgf con2d df-ex syl6ibr ) DEIZBAJ
      ZCKZJACLUAUCBUBBJCDEFBCGMCNDOBAHPQRACST $.
  $}

  ${
    $d y A z $.  $d x z $.
    spcgf.1 $e |- F/_ x A $.
    spcgf.2 $e |- F/ x ps $.
    spcgf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Rule of specialization, using implicit substitution.  Compare Theorem
       7.3 of [Quine] p. 44.  (Contributed by NM, 2-Feb-1997.)  (Revised by
       Andrew Salmon, 12-Aug-2011.) $)
    spcgf $p |- ( A e. V -> ( A. x ph -> ps ) ) $=
      ( cv wceq wb wi wcel wal spcgft mpg ) CIDJABKLDEMACNBLLCABCDEGFOHP $.

    $( Existential specialization, using implicit substitution.  (Contributed
       by NM, 2-Feb-1997.) $)
    spcegf $p |- ( A e. V -> ( ps -> E. x ph ) ) $=
      ( wcel wn wal wex nfn cv wceq notbid spcgf con2d df-ex syl6ibr ) DEIZBAJZ
      CKZJACLUAUCBUBBJCDEFBCGMCNDOABHPQRACST $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x ch $.
    spcimdv.1 $e |- ( ph -> A e. B ) $.
    ${
      spcimdv.2 $e |- ( ( ph /\ x = A ) -> ( ps -> ch ) ) $.
      $( Restricted specialization, using implicit substitution.  (Contributed
         by Mario Carneiro, 4-Jan-2017.) $)
      spcimdv $p |- ( ph -> ( A. x ps -> ch ) ) $=
        ( cv wceq wi wal wcel ex alrimiv nfv nfcv spcimgft sylc ) ADIEJZBCKZKZD
        LEFMBDLCKAUBDATUAHNOGBCDEFCDPDEQRS $.
    $}

    ${
      spcdv.2 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
      $( Rule of specialization, using implicit substitution.  Analogous to
         ~ rspcdv .  (Contributed by David Moews, 1-May-2017.) $)
      spcdv $p |- ( ph -> ( A. x ps -> ch ) ) $=
        ( cv wceq wa biimpd spcimdv ) ABCDEFGADIEJKBCHLM $.
    $}

    spcimedv.2 $e |- ( ( ph /\ x = A ) -> ( ch -> ps ) ) $.
    $( Restricted existential specialization, using implicit substitution.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    spcimedv $p |- ( ph -> ( ch -> E. x ps ) ) $=
      ( wn wal wex cv wceq wa con3d spcimdv con2d df-ex syl6ibr ) ACBIZDJZIBDKA
      UACATCIDEFGADLEMNCBHOPQBDRS $.
  $}

  ${
    $d x ps $.  $d x y A $.
    spcgv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Rule of specialization, using implicit substitution.  Compare Theorem
       7.3 of [Quine] p. 44.  (Contributed by NM, 22-Jun-1994.) $)
    spcgv $p |- ( A e. V -> ( A. x ph -> ps ) ) $=
      ( nfcv nfv spcgf ) ABCDECDGBCHFI $.

    $( Existential specialization, using implicit substitution.  (Contributed
       by NM, 14-Aug-1994.) $)
    spcegv $p |- ( A e. V -> ( ps -> E. x ph ) ) $=
      ( nfcv nfv spcegf ) ABCDECDGBCHFI $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    spc2egv.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Existential specialization with 2 quantifiers, using implicit
       substitution.  (Contributed by NM, 3-Aug-1995.) $)
    spc2egv $p |- ( ( A e. V /\ B e. W ) -> ( ps -> E. x E. y ph ) ) $=
      ( wcel wa cv wceq wex elisset anim12i eeanv sylibr biimprcd 2eximdv
      syl5com ) EGJZFHJZKZCLEMZDLFMZKZDNCNZBADNCNUDUECNZUFDNZKUHUBUIUCUJCEGODFH
      OPUEUFCDQRBUGACDUGABISTUA $.

    $( Specialization with 2 quantifiers, using implicit substitution.
       (Contributed by NM, 27-Apr-2004.) $)
    spc2gv $p |- ( ( A e. V /\ B e. W ) -> ( A. x A. y ph -> ps ) ) $=
      ( wcel wa wal wn wex cv wceq notbid spc2egv 2nalexn syl6ibr con4d ) EGJFH
      JKZBADLCLZUBBMZAMZDNCNUCMUEUDCDEFGHCOEPDOFPKABIQRACDSTUA $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z ps $.
    spc3egv.1 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    $( Existential specialization with 3 quantifiers, using implicit
       substitution.  (Contributed by NM, 12-May-2008.) $)
    spc3egv $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
               ( ps -> E. x E. y E. z ph ) ) $=
      ( wcel w3a cv wceq wex elisset 3anim123i eeeanv biimprcd 2eximdv syl5com
      sylibr eximdv ) FIMZGJMZHKMZNZCOFPZDOGPZEOHPZNZEQZDQCQZBAEQZDQCQUIUJCQZUK
      DQZULEQZNUOUFUQUGURUHUSCFIRDGJREHKRSUJUKULCDETUDBUNUPCDBUMAEUMABLUAUEUBUC
      $.

    $( Specialization with 3 quantifiers, using implicit substitution.
       (Contributed by NM, 12-May-2008.) $)
    spc3gv $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
               ( A. x A. y A. z ph -> ps ) ) $=
      ( wcel w3a wal wn wex cv wceq exnal notbid spc3egv exbii bitr2i syl6ibr
      bitri con4d ) FIMGJMHKMNZBAEOZDOZCOZUHBPZAPZEQZDQZCQZUKPZUMULCDEFGHIJKCRF
      SDRGSERHSNABLUAUBUPUJPZCQUQUOURCUOUIPZDQURUNUSDAETUCUIDTUFUCUJCTUDUEUG $.
  $}

  ${
    $d x A $.  $d x ps $.
    spcv.1 $e |- A e. _V $.
    spcv.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Rule of specialization, using implicit substitution.  (Contributed by
       NM, 22-Jun-1994.) $)
    spcv $p |- ( A. x ph -> ps ) $=
      ( cvv wcel wal wi spcgv ax-mp ) DGHACIBJEABCDGFKL $.

    $( Existential specialization, using implicit substitution.  (Contributed
       by NM, 31-Dec-1993.)  (Proof shortened by Eric Schmidt, 22-Dec-2006.) $)
    spcev $p |- ( ps -> E. x ph ) $=
      ( cvv wcel wex wi spcegv ax-mp ) DGHBACIJEABCDGFKL $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    spc2ev.1 $e |- A e. _V $.
    spc2ev.2 $e |- B e. _V $.
    spc2ev.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Existential specialization, using implicit substitution.  (Contributed
       by NM, 3-Aug-1995.) $)
    spc2ev $p |- ( ps -> E. x E. y ph ) $=
      ( cvv wcel wex wi spc2egv mp2an ) EJKFJKBADLCLMGHABCDEFJJINO $.
  $}

  ${
    $d x A $.  $d x B $.
    rspct.1 $e |- F/ x ps $.
    $( A closed version of ~ rspc .  (Contributed by Andrew Salmon,
       6-Jun-2011.) $)
    rspct $p |- ( A. x ( x = A -> ( ph <-> ps ) ) -> ( A e. B ->
                   ( A. x e. B ph -> ps ) ) ) $=
      ( cv wceq wb wi wal wcel wral df-ral wa eleq1 adantr simpr imbi12d ex a2i
      alimi nfv nfim nfcv spcgft syl syl7bi com34 pm2.43d ) CGZDHZABIZJZCKZDELZ
      ACEMZBJUOUPUQUPBUQUKELZAJZCKZUOUPUPBJZACENUOULUSVAIZJZCKUPUTVAJJUNVCCULUM
      VBULUMVBULUMOURUPABULURUPIUMUKDEPQULUMRSTUAUBUSVACDEUPBCUPCUCFUDCDUEUFUGU
      HUIUJ $.
  $}

  ${
    $d x y A $.  $d x B $.
    rspc.1 $e |- F/ x ps $.
    rspc.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Restricted specialization, using implicit substitution.  (Contributed by
       NM, 19-Apr-2005.)  (Revised by Mario Carneiro, 11-Oct-2016.) $)
    rspc $p |- ( A e. B -> ( A. x e. B ph -> ps ) ) $=
      ( wral cv wcel wi wal df-ral nfcv nfv nfim wceq eleq1 imbi12d spcgf
      pm2.43a syl5bi ) ACEHCIZEJZAKZCLZDEJZBACEMUFUGBUEUGBKCDECDNUGBCUGCOFPUCDQ
      UDUGABUCDERGSTUAUB $.

    $( Restricted existential specialization, using implicit substitution.
       (Contributed by NM, 26-May-1998.)  (Revised by Mario Carneiro,
       11-Oct-2016.) $)
    rspce $p |- ( ( A e. B /\ ps ) -> E. x e. B ph ) $=
      ( wcel wa cv wex wrex nfcv nfv nfan wceq eleq1 anbi12d spcegf anabsi5
      df-rex sylibr ) DEHZBIZCJZEHZAIZCKZACELUCBUHUGUDCDECDMUCBCUCCNFOUEDPUFUCA
      BUEDEQGRSTACEUAUB $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    rspcv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Restricted specialization, using implicit substitution.  (Contributed by
       NM, 26-May-1998.) $)
    rspcv $p |- ( A e. B -> ( A. x e. B ph -> ps ) ) $=
      ( nfv rspc ) ABCDEBCGFH $.

    $( Restricted specialization, using implicit substitution.  (Contributed by
       NM, 2-Feb-2006.) $)
    rspccv $p |- ( A. x e. B ph -> ( A e. B -> ps ) ) $=
      ( wcel wral rspcv com12 ) DEGACEHBABCDEFIJ $.

    $( Restricted specialization, using implicit substitution.  (Contributed by
       NM, 13-Sep-2005.) $)
    rspcva $p |- ( ( A e. B /\ A. x e. B ph ) -> ps ) $=
      ( wcel wral rspcv imp ) DEGACEHBABCDEFIJ $.

    $( Restricted specialization, using implicit substitution.  (Contributed by
       NM, 26-Jul-2006.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    rspccva $p |- ( ( A. x e. B ph /\ A e. B ) -> ps ) $=
      ( wcel wral rspcv impcom ) DEGACEHBABCDEFIJ $.

    $( Restricted existential specialization, using implicit substitution.
       (Contributed by NM, 26-May-1998.) $)
    rspcev $p |- ( ( A e. B /\ ps ) -> E. x e. B ph ) $=
      ( nfv rspce ) ABCDEBCGFH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.  $d x ch $.
    rspcimdv.1 $e |- ( ph -> A e. B ) $.
    ${
      rspcimdv.2 $e |- ( ( ph /\ x = A ) -> ( ps -> ch ) ) $.
      $( Restricted specialization, using implicit substitution.  (Contributed
         by Mario Carneiro, 4-Jan-2017.) $)
      rspcimdv $p |- ( ph -> ( A. x e. B ps -> ch ) ) $=
        ( wral cv wcel wi wal df-ral wceq wa simpr eleq1d biimprd imim12d mpid
        spcimdv syl5bi ) BDFIDJZFKZBLZDMZACBDFNAUGEFKZCGAUFUHCLDEFGAUDEOZPZUHUE
        BCUJUEUHUJUDEFAUIQRSHTUBUAUC $.
    $}

    rspcimedv.2 $e |- ( ( ph /\ x = A ) -> ( ch -> ps ) ) $.
    $( Restricted existential specialization, using implicit substitution.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    rspcimedv $p |- ( ph -> ( ch -> E. x e. B ps ) ) $=
      ( wn wral wrex cv wceq wa con3d rspcimdv con2d dfrex2 syl6ibr ) ACBIZDFJZ
      IBDFKAUACATCIDEFGADLEMNCBHOPQBDFRS $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.  $d x ch $.
    rspcdv.1 $e |- ( ph -> A e. B ) $.
    rspcdv.2 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Restricted specialization, using implicit substitution.  (Contributed by
       NM, 17-Feb-2007.)  (Revised by Mario Carneiro, 4-Jan-2017.) $)
    rspcdv $p |- ( ph -> ( A. x e. B ps -> ch ) ) $=
      ( cv wceq wa biimpd rspcimdv ) ABCDEFGADIEJKBCHLM $.

    $( Restricted existential specialization, using implicit substitution.
       (Contributed by FL, 17-Apr-2007.)  (Revised by Mario Carneiro,
       4-Jan-2017.) $)
    rspcedv $p |- ( ph -> ( ch -> E. x e. B ps ) ) $=
      ( cv wceq wa biimprd rspcimedv ) ABCDEFGADIEJKBCHLM $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C $.  $d x y D $.
    rspc2.1 $e |- F/ x ch $.
    rspc2.2 $e |- F/ y ps $.
    rspc2.3 $e |- ( x = A -> ( ph <-> ch ) ) $.
    rspc2.4 $e |- ( y = B -> ( ch <-> ps ) ) $.
    $( 2-variable restricted specialization, using implicit substitution.
       (Contributed by NM, 9-Nov-2012.) $)
    rspc2 $p |- ( ( A e. C /\ B e. D ) -> ( A. x e. C A. y e. D ph ->
                  ps ) ) $=
      ( wcel wral nfcv nfral cv wceq rspc ralbidv sylan9 ) FHNAEIOZDHOCEIOZGINB
      UCUDDFHCDEIDIPJQDRFSACEILUATCBEGIKMTUB $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C $.  $d x y D $.  $d x ch $.  $d y ps $.
    rspc2v.1 $e |- ( x = A -> ( ph <-> ch ) ) $.
    rspc2v.2 $e |- ( y = B -> ( ch <-> ps ) ) $.
    $( 2-variable restricted specialization, using implicit substitution.
       (Contributed by NM, 13-Sep-1999.) $)
    rspc2v $p |- ( ( A e. C /\ B e. D ) -> ( A. x e. C A. y e. D ph ->
                  ps ) ) $=
      ( nfv rspc2 ) ABCDEFGHICDLBELJKM $.

    $( 2-variable restricted specialization, using implicit substitution.
       (Contributed by NM, 18-Jun-2014.) $)
    rspc2va $p |- ( ( ( A e. C /\ B e. D ) /\ A. x e. C A. y e. D ph ) ->
                  ps ) $=
      ( wcel wa wral rspc2v imp ) FHLGILMAEINDHNBABCDEFGHIJKOP $.

    $( 2-variable restricted existential specialization, using implicit
       substitution.  (Contributed by NM, 16-Oct-1999.) $)
    rspc2ev $p |- ( ( A e. C /\ B e. D /\ ps ) -> E. x e. C E. y e. D ph ) $=
      ( wcel w3a wrex wa rspcev anim2i 3impb cv wceq rexbidv syl ) FHLZGILZBMUC
      CEINZOZAEINZDHNUCUDBUFUDBOUEUCCBEGIKPQRUGUEDFHDSFTACEIJUAPUB $.
  $}

  ${
    $d z ps $.  $d x ch $.  $d y th $.  $d x y z A $.  $d y z B $.  $d z C $.
    $d x R $.  $d x y S $.  $d x y z T $.
    rspc3v.1 $e |- ( x = A -> ( ph <-> ch ) ) $.
    rspc3v.2 $e |- ( y = B -> ( ch <-> th ) ) $.
    rspc3v.3 $e |- ( z = C -> ( th <-> ps ) ) $.
    $( 3-variable restricted specialization, using implicit substitution.
       (Contributed by NM, 10-May-2005.) $)
    rspc3v $p |- ( ( A e. R /\ B e. S /\ C e. T ) ->
                  ( A. x e. R A. y e. S A. z e. T ph -> ps ) ) $=
      ( wcel wral cv wceq wi wa ralbidv rspc2v rspcv sylan9 3impa ) HKQZILQZJMQ
      ZAGMRZFLREKRZBUAUHUIUBULDGMRZUJBUKUMCGMREFHIKLESHTACGMNUCFSITCDGMOUCUDDBG
      JMPUEUFUG $.

    $( 3-variable restricted existentional specialization, using implicit
       substitution.  (Contributed by NM, 25-Jul-2012.) $)
    rspc3ev $p |- ( ( ( A e. R /\ B e. S /\ C e. T ) /\ ps ) ->
                  E. x e. R E. y e. S E. z e. T ph ) $=
      ( wcel wrex cv wceq w3a wa simpl1 simpl2 rspcev 3ad2antl3 rexbidv rspc2ev
      syl3anc ) HKQZILQZJMQZUABUBUJUKDGMRZAGMRZFLREKRUJUKULBUCUJUKULBUDULUJBUMU
      KDBGJMPUEUFUNUMCGMREFHIKLESHTACGMNUGFSITCDGMOUGUHUI $.
  $}

  ${
    $d x A y z $.  $d x B y z $.
    eqvinc.1 $e |- A e. _V $.
    $( A variable introduction law for class equality.  (Contributed by NM,
       14-Apr-1995.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    eqvinc $p |- ( A = B <-> E. x ( x = A /\ x = B ) ) $=
      ( wceq cv wa wex wi isseti ax-1 eqtr jca eximi pm3.43 mp2b 19.37aiv eqtr2
      ex exlimiv impbii ) BCEZAFZBEZUCCEZGZAHUBUFAUDAHUBUDIZUBUEIZGZAHUBUFIZAHA
      BDJUDUIAUDUGUHUDUBKUDUBUEUCBCLSMNUIUJAUBUDUEONPQUFUBAUCBCRTUA $.
  $}

  ${
    $d A y $.  $d B y $.  $d x y $.
    eqvincf.1 $e |- F/_ x A $.
    eqvincf.2 $e |- F/_ x B $.
    eqvincf.3 $e |- A e. _V $.
    $( A variable introduction law for class equality, using bound-variable
       hypotheses instead of distinct variable conditions.  (Contributed by NM,
       14-Sep-2003.) $)
    eqvincf $p |- ( A = B <-> E. x ( x = A /\ x = B ) ) $=
      ( vy wceq cv wa wex eqvinc nfeq2 nfan nfv eqeq1 anbi12d cbvex bitri ) BCH
      GIZBHZTCHZJZGKAIZBHZUDCHZJZAKGBCFLUCUGGAUAUBAATBDMATCEMNUGGOTUDHUAUEUBUFT
      UDBPTUDCPQRS $.
  $}

  ${
    $d x A y $.  $d ph y $.
    alexeq.1 $e |- A e. _V $.
    $( Two ways to express substitution of ` A ` for ` x ` in ` ph ` .
       (Contributed by NM, 2-Mar-1995.) $)
    alexeq $p |- ( A. x ( x = A -> ph ) <-> E. x ( x = A /\ ph ) ) $=
      ( vy cv wceq wa wex wi wal anbi1d exbidv imbi1d albidv sb56 vtoclb bicomi
      eqeq2 ) BFZCGZAHZBIZUAAJZBKZTEFZGZAHZBIUGAJZBKUCUEECDUFCGZUHUBBUJUGUAAUFC
      TSZLMUJUIUDBUJUGUAAUKNOABEPQR $.
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Equality implies equivalence with substitution.  (Contributed by NM,
       2-Mar-1995.) $)
    ceqex $p |- ( x = A -> ( ph <-> E. x ( x = A /\ ph ) ) ) $=
      ( vy cvv wcel cv wceq wa wex wb 19.8a isset sylibr wi eqeq2 anbi1d exbidv
      bibi2d imbi12d ex wal vex alexeq sp com12 syl5bir impbid vtoclg mpcom ) C
      EFZBGZCHZAUMAIZBJZKZUMUMBJUKUMBLBCMNULDGZHZAURAIZBJZKZOUMUPODCEUQCHZURUMV
      AUPUQCULPZVBUTUOAVBUSUNBVBURUMAVCQRSTURAUTURAUTUSBLUAUTURAOZBUBZURAABUQDU
      CUDVEURAVDBUEUFUGUHUIUJ $.
  $}

  ${
    $d x y A $.
    ceqsexg.1 $e |- F/ x ps $.
    ceqsexg.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A representation of explicit substitution of a class for a variable,
       inferred from an implicit substitution hypothesis.  (Contributed by NM,
       11-Oct-2004.) $)
    ceqsexg $p |- ( A e. V -> ( E. x ( x = A /\ ph ) <-> ps ) ) $=
      ( wb cv wceq wa wex nfcv nfe1 nfbi ceqex bibi12d biid vtoclgf ) AAHCIDJZA
      KZCLZBHCDECDMUBBCUACNFOTAUBABACDPGQARS $.
  $}

  ${
    $d x y A $.  $d x ps $.
    ceqsexgv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of an existential quantifier, using implicit substitution.
       (Contributed by NM, 29-Dec-1996.) $)
    ceqsexgv $p |- ( A e. V -> ( E. x ( x = A /\ ph ) <-> ps ) ) $=
      ( nfv ceqsexg ) ABCDEBCGFH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    ceqsrexv.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Elimination of a restricted existential quantifier, using implicit
       substitution.  (Contributed by NM, 30-Apr-2004.) $)
    ceqsrexv $p |- ( A e. B -> ( E. x e. B ( x = A /\ ph ) <-> ps ) ) $=
      ( cv wceq wa wrex wcel wex df-rex an12 exbii bitr4i eleq1 anbi12d bianabs
      ceqsexgv syl5bb ) CGZDHZAIZCEJZUCUBEKZAIZIZCLZDEKZBUEUFUDIZCLUIUDCEMUHUKC
      UCUFANOPUJUIBUGUJBICDEUCUFUJABUBDEQFRTSUA $.

    $( Elimination of a restricted existential quantifier, using implicit
       substitution.  (Contributed by Mario Carneiro, 14-Mar-2014.) $)
    ceqsrexbv $p |- ( E. x e. B ( x = A /\ ph ) <-> ( A e. B /\ ps ) ) $=
      ( wcel cv wceq wa wrex r19.42v eleq1 adantr pm5.32ri bicomi baib ceqsrexv
      wb rexbiia pm5.32i 3bitr3i ) DEGZCHZDIZAJZJZCEKUCUFCEKZJUHUCBJUCUFCELUGUF
      CEUGUDEGZUFUIUFJUGUFUIUCUEUIUCSAUDDEMNOPQTUCUHBABCDEFRUAUB $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.  $d x y D $.  $d x ps $.  $d y ch $.
    ceqsrex2v.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsrex2v.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Elimination of a restricted existential quantifier, using implicit
       substitution.  (Contributed by NM, 29-Oct-2005.) $)
    ceqsrex2v $p |- ( ( A e. C /\ B e. D ) ->
      ( E. x e. C E. y e. D ( ( x = A /\ y = B ) /\ ph ) <-> ch ) ) $=
      ( wcel cv wceq wa wrex anass rexbii r19.42v ceqsrexv bitri anbi2d rexbidv
      syl5bb sylan9bb ) FHLZDMFNZEMGNZOAOZEIPZDHPZUHBOZEIPZGILCUKUGUHAOZEIPZOZD
      HPUFUMUJUPDHUJUGUNOZEIPUPUIUQEIUGUHAQRUGUNEISUARUOUMDFHUGUNULEIUGABUHJUBU
      CTUDBCEGIKTUE $.
  $}

  ${
    $d x A $.  $d x B $.
    clel2.1 $e |- A e. _V $.
    $( An alternate definition of class membership when the class is a set.
       (Contributed by NM, 18-Aug-1993.) $)
    clel2 $p |- ( A e. B <-> A. x ( x = A -> x e. B ) ) $=
      ( cv wceq wcel wi wal eleq1 ceqsalv bicomi ) AEZBFMCGZHAIBCGZNOABDMBCJKL
      $.
  $}

  ${
    $d x A $.  $d x B $.
    $( An alternate definition of class membership when the class is a set.
       (Contributed by NM, 13-Aug-2005.) $)
    clel3g $p |- ( B e. V -> ( A e. B <-> E. x ( x = B /\ A e. x ) ) ) $=
      ( wcel cv wceq wa wex eleq2 ceqsexgv bicomd ) CDEAFZCGBMEZHAIBCEZNOACDMCB
      JKL $.
  $}

  ${
    $d x A $.  $d x B $.
    clel3.1 $e |- B e. _V $.
    $( An alternate definition of class membership when the class is a set.
       (Contributed by NM, 18-Aug-1993.) $)
    clel3 $p |- ( A e. B <-> E. x ( x = B /\ A e. x ) ) $=
      ( cvv wcel cv wceq wa wex wb clel3g ax-mp ) CEFBCFAGZCHBNFIAJKDABCELM $.
  $}

  ${
    $d x A $.  $d x B $.
    clel4.1 $e |- B e. _V $.
    $( An alternate definition of class membership when the class is a set.
       (Contributed by NM, 18-Aug-1993.) $)
    clel4 $p |- ( A e. B <-> A. x ( x = B -> A e. x ) ) $=
      ( cv wceq wcel wi wal eleq2 ceqsalv bicomi ) AEZCFBMGZHAIBCGZNOACDMCBJKL
      $.
  $}

  ${
    $d y A z $.  $d y B z $.
    $( Compare theorem *13.183 in [WhiteheadRussell] p. 178.  Only ` A ` is
       required to be a set.  (Contributed by Andrew Salmon, 3-Jun-2011.) $)
    pm13.183 $p |- ( A e. V -> ( A = B <-> A. z ( z = A <-> z = B ) ) ) $=
      ( vy cv wceq wal eqeq1 eqeq2 bibi1d albidv alrimiv wsb stdpc4 sbbi bibi2i
      wb eqsb3 sylbi equsb1 bi1 mpi syl impbii vtoclbg ) EFZCGZAFZUGGZUICGZRZAH
      ZBCGUIBGZUKRZAHEBDUGBCIUGBGZULUOAUPUJUNUKUGBUIJKLUHUMUHULAUGCUIJMUMULAENZ
      UHULAEOUQUJAENZUKAENZRZUHUJUKAEPUTURUHRZUHUSUHUREACSQVAURUHAEUAURUHUBUCTT
      UDUEUF $.
  $}

  ${
    $d y A $.  $d x y $.  $d y ph $.
    $( Restricted quantifier version of Theorem 19.3 of [Margaris] p. 89.  We
       don't need the non-empty class condition of ~ r19.3rzv when there is an
       outer quantifier.  (Contributed by NM, 25-Oct-2012.) $)
    rr19.3v $p |- ( A. x e. A A. y e. A ph <-> A. x e. A ph ) $=
      ( wral cv weq biidd rspcv ralimia wcel ax-1 ralrimiv ralimi impbii ) ACDE
      ZBDEABDEPABDAACBFDCBGAHIJAPBDAACDACFDKLMNO $.

    $( Restricted quantifier version of Theorem 19.28 of [Margaris] p. 90.  We
       don't need the non-empty class condition of ~ r19.28zv when there is an
       outer quantifier.  (Contributed by NM, 29-Oct-2012.) $)
    rr19.28v $p |- ( A. x e. A A. y e. A ( ph /\ ps )
                      <-> A. x e. A ( ph /\ A. y e. A ps ) ) $=
      ( wa wral cv wcel simpl ralimi weq biidd rspcv syl5 wi simpr jcad ralimia
      a1i r19.28av impbii ) ABFZDEGZCEGABDEGZFZCEGUDUFCECHZEIZUDAUEUDADEGUHAUCA
      DEABJKAADUGEDCLAMNOUDUEPUHUCBDEABQKTRSUFUDCEABDEUAKUB $.
  $}

  ${
    $d x y A $.  $d y ph $.  $d x ps $.
    $( Membership in a class abstraction, using implicit substitution.  (Closed
       theorem version of ~ elabg .)  (Contributed by NM, 7-Nov-2005.)  (Proof
       shortened by Andrew Salmon, 8-Jun-2011.) $)
    elabgt $p |- ( ( A e. B /\ A. x ( x = A -> ( ph <-> ps ) ) ) ->
                 ( A e. { x | ph } <-> ps ) ) $=
      ( cv wceq wb wal wcel cab abid eleq1 syl5bbr bibi1d biimpd a2i alimi nfcv
      wi nfab1 nfel2 nfv nfbi pm5.5 spcgf imp sylan2 ) CFZDGZABHZTZCIDEJZUJDACK
      ZJZBHZTZCIZUPULUQCUJUKUPUJUKUPUJAUOBAUIUNJUJUOACLUIDUNMNOPQRUMURUPUQUPCDE
      CDSUOBCCDUNACUAUBBCUCUDUJUPUEUFUGUH $.
  $}

  ${
    elabgf.1 $e |- F/_ x A $.
    elabgf.2 $e |- F/ x ps $.
    elabgf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitution.  Compare
       Theorem 6.13 of [Quine] p. 44.  This version has bound-variable
       hypotheses in place of distinct variable restrictions.  (Contributed by
       NM, 21-Sep-2003.)  (Revised by Mario Carneiro, 12-Oct-2016.) $)
    elabgf $p |- ( A e. B -> ( A e. { x | ph } <-> ps ) ) $=
      ( cv cab wcel wb nfab1 nfel nfbi wceq eleq1 bibi12d abid vtoclgf ) CIZACJ
      ZKZALDUBKZBLCDEFUDBCCDUBFACMNGOUADPUCUDABUADUBQHRACST $.
  $}

  ${
    $d ps y $.  $d x A y $.  $d y ph $.
    elabf.1 $e |- F/ x ps $.
    elabf.2 $e |- A e. _V $.
    elabf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitution.
       (Contributed by NM, 1-Aug-1994.)  (Revised by Mario Carneiro,
       12-Oct-2016.) $)
    elabf $p |- ( A e. { x | ph } <-> ps ) $=
      ( cvv wcel cab wb nfcv elabgf ax-mp ) DHIDACJIBKFABCDHCDLEGMN $.
  $}

  ${
    $d x ps $.  $d x A $.
    elab.1 $e |- A e. _V $.
    elab.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitution.  Compare
       Theorem 6.13 of [Quine] p. 44.  (Contributed by NM, 1-Aug-1994.) $)
    elab $p |- ( A e. { x | ph } <-> ps ) $=
      ( nfv elabf ) ABCDBCGEFH $.
  $}

  ${
    $d x ps $.  $d x y A $.
    elabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, using implicit substitution.  Compare
       Theorem 6.13 of [Quine] p. 44.  (Contributed by NM, 14-Apr-1995.) $)
    elabg $p |- ( A e. V -> ( A e. { x | ph } <-> ps ) ) $=
      ( nfcv nfv elabgf ) ABCDECDGBCHFI $.
  $}

  ${
    $d x ps $.  $d x A $.
    elab2g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elab2g.2 $e |- B = { x | ph } $.
    $( Membership in a class abstraction, using implicit substitution.
       (Contributed by NM, 13-Sep-1995.) $)
    elab2g $p |- ( A e. V -> ( A e. B <-> ps ) ) $=
      ( wcel cab eleq2i elabg syl5bb ) DEIDACJZIDFIBENDHKABCDFGLM $.
  $}

  ${
    $d x ps $.  $d x A $.
    elab2.1 $e |- A e. _V $.
    elab2.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elab2.3 $e |- B = { x | ph } $.
    $( Membership in a class abstraction, using implicit substitution.
       (Contributed by NM, 13-Sep-1995.) $)
    elab2 $p |- ( A e. B <-> ps ) $=
      ( cvv wcel wb elab2g ax-mp ) DIJDEJBKFABCDEIGHLM $.
  $}

  ${
    $d x ps $.  $d x A $.
    elab4g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elab4g.2 $e |- B = { x | ph } $.
    $( Membership in a class abstraction, using implicit substitution.
       (Contributed by NM, 17-Oct-2012.) $)
    elab4g $p |- ( A e. B <-> ( A e. _V /\ ps ) ) $=
      ( wcel cvv elex elab2g biadan2 ) DEHDIHBDEJABCDEIFGKL $.
  $}

  ${
    $d y A $.
    elab3gf.1 $e |- F/_ x A $.
    elab3gf.2 $e |- F/ x ps $.
    elab3gf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, with a weaker antecedent than
       ~ elabgf .  (Contributed by NM, 6-Sep-2011.) $)
    elab3gf $p |- ( ( ps -> A e. B ) -> ( A e. { x | ph } <-> ps ) ) $=
      ( wcel cab wb wn elabgf ibi pm2.21 impbid2 ja ) BDEIDACJZIZBKBLSBSBABCDRF
      GHMNBSOPABCDEFGHMQ $.
  $}

  ${
    $d x ps $.  $d x y A $.
    elab3g.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction, with a weaker antecedent than
       ~ elabg .  (Contributed by NM, 29-Aug-2006.) $)
    elab3g $p |- ( ( ps -> A e. B ) -> ( A e. { x | ph } <-> ps ) ) $=
      ( nfcv nfv elab3gf ) ABCDECDGBCHFI $.
  $}

  ${
    $d x ps $.  $d x A $.
    elab3.1 $e |- ( ps -> A e. _V ) $.
    elab3.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction using implicit substitution.
       (Contributed by NM, 10-Nov-2000.) $)
    elab3 $p |- ( A e. { x | ph } <-> ps ) $=
      ( cvv wcel wi cab wb elab3g ax-mp ) BDGHIDACJHBKEABCDGFLM $.
  $}

  ${
    $d A x $.  $d V x $.
    $( Implication for the membership in a restricted class abstraction.
       (Contributed by Alexander van der Vekens, 31-Dec-2017.) $)
    elrabi $p |- ( A e. { x e. V | ph } -> A e. V ) $=
      ( wcel cv wa cab crab wceq wex clelab eleq1 anbi1d simprbda exlimiv sylbi
      df-rab eleq2s ) CDEZCBFZDEZAGZBHZABDICUDEUACJZUCGZBKTUCBCLUFTBUEUCTAUEUBT
      AUACDMNOPQABDRS $.
  $}

  ${
    elrabf.1 $e |- F/_ x A $.
    elrabf.2 $e |- F/_ x B $.
    elrabf.3 $e |- F/ x ps $.
    elrabf.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a restricted class abstraction, using implicit
       substitution.  This version has bound-variable hypotheses in place of
       distinct variable restrictions.  (Contributed by NM, 21-Sep-2003.) $)
    elrabf $p |- ( A e. { x e. B | ph } <-> ( A e. B /\ ps ) ) $=
      ( crab wcel cvv wa elex adantr cv cab df-rab eleq2i nfel nfan wceq elabgf
      eleq1 anbi12d syl5bb pm5.21nii ) DACEJZKZDLKZDEKZBMZDUHNUKUJBDENOUIDCPZEK
      ZAMZCQZKUJULUHUPDACERSUOULCDLFUKBCCDEFGTHUAUMDUBUNUKABUMDEUDIUEUCUFUG $.
  $}

  ${
    $d x ps $.  $d x y A $.  $d x y B $.
    elrab.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a restricted class abstraction, using implicit
       substitution.  (Contributed by NM, 21-May-1999.) $)
    elrab $p |- ( A e. { x e. B | ph } <-> ( A e. B /\ ps ) ) $=
      ( nfcv nfv elrabf ) ABCDECDGCEGBCHFI $.

    $( Membership in a restricted class abstraction, using implicit
       substitution.  (Contributed by NM, 5-Oct-2006.) $)
    elrab3 $p |- ( A e. B -> ( A e. { x e. B | ph } <-> ps ) ) $=
      ( crab wcel elrab baib ) DACEGHDEHBABCDEFIJ $.
  $}

  ${
    $d x ps $.  $d x y A $.  $d x y B $.
    elrab2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    elrab2.2 $e |- C = { x e. B | ph } $.
    $( Membership in a class abstraction, using implicit substitution.
       (Contributed by NM, 2-Nov-2006.) $)
    elrab2 $p |- ( A e. C <-> ( A e. B /\ ps ) ) $=
      ( wcel crab wa eleq2i elrab bitri ) DFIDACEJZIDEIBKFODHLABCDEGMN $.
  $}

  ${
    $d x y $.  $d y A $.  $d y ps $.
    ralab.1 $e |- ( y = x -> ( ph <-> ps ) ) $.
    $( Universal quantification over a class abstraction.  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    ralab $p |- ( A. x e. { y | ph } ch <-> A. x ( ps -> ch ) ) $=
      ( cab wral cv wcel wi wal df-ral vex elab imbi1i albii bitri ) CDAEGZHDIZ
      SJZCKZDLBCKZDLCDSMUBUCDUABCABETDNFOPQR $.

    $( Universal quantification over a restricted class abstraction.
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    ralrab $p |- ( A. x e. { y e. A | ph } ch <-> A. x e. A ( ps -> ch ) ) $=
      ( wi crab cv wcel wa elrab imbi1i impexp bitri ralbii2 ) CBCHZDAEFIZFDJZS
      KZCHTFKZBLZCHUBRHUAUCCABETFGMNUBBCOPQ $.

    $( Existential quantification over a class abstraction.  (Contributed by
       Mario Carneiro, 23-Jan-2014.)  (Revised by Mario Carneiro,
       3-Sep-2015.) $)
    rexab $p |- ( E. x e. { y | ph } ch <-> E. x ( ps /\ ch ) ) $=
      ( cab wrex cv wcel wa wex df-rex vex elab anbi1i exbii bitri ) CDAEGZHDIZ
      SJZCKZDLBCKZDLCDSMUBUCDUABCABETDNFOPQR $.

    $( Existential quantification over a class abstraction.  (Contributed by
       Jeff Madsen, 17-Jun-2011.)  (Revised by Mario Carneiro, 3-Sep-2015.) $)
    rexrab $p |- ( E. x e. { y e. A | ph } ch <-> E. x e. A ( ps /\ ch ) ) $=
      ( wa crab cv wcel elrab anbi1i anass bitri rexbii2 ) CBCHZDAEFIZFDJZRKZCH
      SFKZBHZCHUAQHTUBCABESFGLMUABCNOP $.
  $}

  ${
    $d x y $.  $d x A $.  $d x ch $.  $d x ph $.  $d y ps $.
    ralab2.1 $e |- ( x = y -> ( ps <-> ch ) ) $.
    $( Universal quantification over a class abstraction.  (Contributed by
       Mario Carneiro, 3-Sep-2015.) $)
    ralab2 $p |- ( A. x e. { y | ph } ps <-> A. y ( ph -> ch ) ) $=
      ( cab wral cv wcel wi wal df-ral nfsab1 nfv nfim weq eleq1 abid syl6bb
      imbi12d cbval bitri ) BDAEGZHDIZUDJZBKZDLACKZELBDUDMUGUHDEUFBEAEDNBEOPUHD
      ODEQZUFABCUIUFEIZUDJAUEUJUDRAESTFUAUBUC $.

    $( Universal quantification over a restricted class abstraction.
       (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    ralrab2 $p |- ( A. x e. { y e. A | ph } ps <-> A. y e. A ( ph -> ch ) ) $=
      ( crab wral cv wcel wa cab wi wal df-rab raleqi ralab2 impexp albii
      df-ral bitr4i 3bitri ) BDAEFHZIBDEJFKZALZEMZIUFCNZEOZACNZEFIZBDUDUGAEFPQU
      FBCDEGRUIUEUJNZEOUKUHULEUEACSTUJEFUAUBUC $.

    $( Existential quantification over a class abstraction.  (Contributed by
       Mario Carneiro, 3-Sep-2015.) $)
    rexab2 $p |- ( E. x e. { y | ph } ps <-> E. y ( ph /\ ch ) ) $=
      ( cab wrex cv wcel wa wex df-rex nfsab1 nfv nfan weq eleq1 abid syl6bb
      anbi12d cbvex bitri ) BDAEGZHDIZUDJZBKZDLACKZELBDUDMUGUHDEUFBEAEDNBEOPUHD
      ODEQZUFABCUIUFEIZUDJAUEUJUDRAESTFUAUBUC $.

    $( Existential quantification over a class abstraction.  (Contributed by
       Mario Carneiro, 3-Sep-2015.) $)
    rexrab2 $p |- ( E. x e. { y e. A | ph } ps <-> E. y e. A ( ph /\ ch ) ) $=
      ( crab wrex cv wcel wa cab wex df-rab rexeqi rexab2 anass exbii df-rex
      bitr4i 3bitri ) BDAEFHZIBDEJFKZALZEMZIUECLZENZACLZEFIZBDUCUFAEFOPUEBCDEGQ
      UHUDUILZENUJUGUKEUDACRSUIEFTUAUB $.
  $}

  ${
    $d w y A $.  $d w x z $.  $d x y $.  $d A z $.
    $( Identity used to create closed-form versions of bound-variable
       hypothesis builders for class expressions.  (Contributed by NM,
       10-Nov-2005.)  (Proof shortened by Mario Carneiro, 12-Oct-2016.) $)
    abidnf $p |- ( F/_ x A -> { z | A. x z e. A } = A ) $=
      ( wnfc cv wcel wal sp nfcr nfrd impbid2 abbi1dv ) ACDZBECFZAGZBCMONNAHMNA
      ABCIJKL $.
  $}

  ${
    $d y A $.  $d x z $.  $d x y $.  $d z A $.
    dedhb.1 $e |- ( A = { z | A. x z e. A } -> ( ph <-> ps ) ) $.
    dedhb.2 $e |- ps $.
    $( A deduction theorem for converting the inference ` |- F/_ x A ` =>
       ` |- ph ` into a closed theorem.  Use ~ nfa1 and ~ nfab to eliminate the
       hypothesis of the substitution instance ` ps ` of the inference.  For
       converting the inference form into a deduction form, ~ abidnf is
       useful.  (Contributed by NM, 8-Dec-2006.) $)
    dedhb $p |- ( F/_ x A -> ph ) $=
      ( wnfc cv wcel wal cab wceq wb abidnf eqcomd syl mpbiri ) CEHZABGSEDIEJCK
      DLZMABNSTECDEOPFQR $.
  $}

  ${
    $d y ph $.  $d x y ps $.  $d x y A $.
    eqeu.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A condition which implies existential uniqueness.  (Contributed by Jeff
       Hankins, 8-Sep-2009.) $)
    eqeu $p |- ( ( A e. B /\ ps /\ A. x ( ph -> x = A ) ) -> E! x ph ) $=
      ( vy wcel cv wceq wi wal w3a wex weu spcegv imp 3adant3 eqeq2 imbi2d nfv
      albidv 3adant2 eu3 sylanbrc ) DEHZBACIZDJZKZCLZMACNZAUGGIZJZKZCLZGNZACOUF
      BUKUJUFBUKABCDEFPQRUFUJUPBUFUJUPUOUJGDEULDJZUNUICUQUMUHAULDUGSTUBPQUCACGA
      GUAUDUE $.
  $}

  ${
    $d x y A $.
    $( Equality has existential uniqueness.  (Contributed by NM,
       25-Nov-1994.) $)
    eueq $p |- ( A e. _V <-> E! x x = A ) $=
      ( vy cv wceq wex wa wi wal cvv wcel weu eqtr3 biantru isset eqeq1 3bitr4i
      gen2 eu4 ) ADZBEZAFZUBUACDZBEZGTUCEHZCIAIZGBJKUAALUFUBUEACTUCBMRNABOUAUDA
      CTUCBPSQ $.
  $}

  ${
    $d x A $.
    eueq1.1 $e |- A e. _V $.
    $( Equality has existential uniqueness.  (Contributed by NM,
       5-Apr-1995.) $)
    eueq1 $p |- E! x x = A $=
      ( cvv wcel cv wceq weu eueq mpbi ) BDEAFBGAHCABIJ $.
  $}

  ${
    $d x ph $.  $d x A $.  $d x B $.
    eueq2.1 $e |- A e. _V $.
    eueq2.2 $e |- B e. _V $.
    $( Equality has existential uniqueness (split into 2 cases).  (Contributed
       by NM, 5-Apr-1995.) $)
    eueq2 $p |- E! x ( ( ph /\ x = A ) \/ ( -. ph /\ x = B ) ) $=
      ( cv wceq wa wn weu eueq1 euanv biimpri mpan2 euorv bianfd eubidv mpbid
      wo notnot1 syl2anc orcom orbi2d syl5bb mpdan id orbi1d pm2.61i ) AABGZCHZ
      IZAJZUJDHZIZTZBKZAUMULTZBKZUQAUMJULBKZUSAUAZAUKBKZUTBCELUTAVBIAUKBMNOUMUL
      BPUBAURUPBURULUMTAUPUMULUCAUMUOULAUMUNVAQUDUERSUMAUOTZBKZUQUMUOBKZVDUMUNB
      KZVEBDFLVEUMVFIUMUNBMNOAUOBPUFUMVCUPBUMAULUOUMAUKUMUGQUHRSUI $.
  $}

  ${
    $d x ph $.  $d x ps $.  $d x A $.  $d x B $.  $d x C $.
    eueq3.1 $e |- A e. _V $.
    eueq3.2 $e |- B e. _V $.
    eueq3.3 $e |- C e. _V $.
    eueq3.4 $e |- -. ( ph /\ ps ) $.
    $( Equality has existential uniqueness (split into 3 cases).  (Contributed
       by NM, 5-Apr-1995.)  (Proof shortened by Mario Carneiro,
       28-Sep-2015.) $)
    eueq3 $p |- E! x ( ( ph /\ x = A ) \/ ( -. ( ph \/ ps ) /\ x = B )
                \/ ( ps /\ x = C ) ) $=
      ( wceq wa wo wn w3o weu eueq1 ibar wb con2i cv pm2.45 imnani jaoi orbi12d
      bianfd mtbid biorf bitrd 3orrot df-3or bitri syl6bbr eubidv adantr pm2.46
      syl mpbii simpl orim12i con3i 3orcomb ecase3 ) ABACUAZDKZLZABMZNZVDEKZLZB
      VDFKZLZOZCPZAVECPVNCDGQAVEVMCAVEVJVLMZVFMZVMAVEVFVPAVERAVONVFVPSAVHBMZVOV
      QAVHANBABUBZABABJUCZTUDTAVHVJBVLAVHVIVHAVRTUFABVKVSUFUEUGVOVFUHUQUIVMVJVL
      VFOVPVFVJVLUJVJVLVFUKULUMUNURBVKCPVNCFIQBVKVMCBVKVFVJMZVLMZVMBVKVLWABVKRB
      VTNVLWASVTBVFBNZVJAWBVEVSUOVHWBVIABUPUOUDTVTVLUHUQUIVFVJVLUKUMUNURVHVICPV
      NCEHQVHVIVMCVHVIVFVLMZVJMZVMVHVIVJWDVHVIRVHWCNVJWDSWCVGVFAVLBAVEUSBVKUSUT
      VAWCVJUHUQUIVMVFVLVJOWDVFVJVLVBVFVLVJUKULUMUNURVC $.
  $}

  ${
    $d x A $.
    $( There is at most one set equal to a class.  (Contributed by NM,
       8-Mar-1995.) $)
    moeq $p |- E* x x = A $=
      ( cv wceq wmo wex weu wi cvv wcel isset eueq bitr3i biimpi df-mo mpbir )
      ACBDZAEQAFZQAGZHRSRBIJSABKABLMNQAOP $.
  $}

  ${
    $d x y ph $.  $d x y ps $.  $d x y A $.  $d x y B $.  $d x y C $.
    moeq3.1 $e |- B e. _V $.
    moeq3.2 $e |- C e. _V $.
    moeq3.3 $e |- -. ( ph /\ ps ) $.
    $( "At most one" property of equality (split into 3 cases).  (The first 2
       hypotheses could be eliminated with longer proof.)  (Contributed by NM,
       23-Apr-1995.) $)
    moeq3 $p |- E* x ( ( ph /\ x = A ) \/ ( -. ( ph \/ ps ) /\ x = B )
                \/ ( ps /\ x = C ) ) $=
      ( vy cvv wcel cv wceq wa wo wn w3o weu biidd eqeq2 anbi2d 3orbi123d eueq3
      wmo eubidv vex vtoclg eumo syl wi eleq1 mpbii pm2.21 anim2d orim1d 3orass
      wal syl5 3imtr4g alrimiv euimmo ee10 pm2.61i ) DKLZACMZDNZOZABPQVFENOZBVF
      FNOZRZCUEZVEVKCSZVLAVFJMZNZOZVIVJRZCSZVMJDKVNDNZVQVKCVSVPVHVIVIVJVJVSVOVG
      AVNDVFUAUBVSVITVSVJTUCUFABCVNEFJUGGHIUDZUHVKCUIUJVEQZVKVQUKZCURVRVLWAWBCW
      AVHVIVJPZPVPWCPVKVQWAVHVPWCWAVGVOAVGVEWAVOVGVFKLVECUGVFDKULUMVEVOUNUSUOUP
      VHVIVJUQVPVIVJUQUTVAVTVKVQCVBVCVD $.
  $}

  ${
    $d x y A $.
    mosub.1 $e |- E* x ph $.
    $( "At most one" remains true after substitution.  (Contributed by NM,
       9-Mar-1995.) $)
    mosub $p |- E* x E. y ( y = A /\ ph ) $=
      ( cv wceq wmo wal wa wex moeq ax-gen moexexv mp2an ) CFDGZCHABHZCIPAJCKBH
      CDLQCEMPACBNO $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Theorem for inferring "at most one."  (Contributed by NM,
       17-Oct-1996.) $)
    mo2icl $p |- ( A. x ( ph -> x = A ) -> E* x ph ) $=
      ( vy cvv wcel cv wceq wi wal wmo eqeq2 imbi2d albidv imbi1d wex 19.8a nfv
      mo2 wn sylibr vtoclg vex eleq1 mpbii imim2i con3rr3 alimdv alnex exmo ori
      sylbi syl6 pm2.61i ) CEFZABGZCHZIZBJZABKZIZAUPDGZHZIZBJZUTIVADCEVBCHZVEUS
      UTVFVDURBVFVCUQAVBCUPLMNOVEVEDPUTVEDQABDADRSUAUBUOTZUSATZBJZUTVGURVHBURAU
      OUQUOAUQUPEFUOBUCUPCEUDUEUFUGUHVIABPZTUTABUIVJUTABUJUKULUMUN $.
  $}

  ${
    $d x y A $.  $d y ph $.  $d x y ps $.
    moi2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Consequence of "at most one."  (Contributed by NM, 2-Jan-2015.) $)
    mob2 $p |- ( ( A e. B /\ E* x ph /\ ph ) -> ( x = A <-> ps ) ) $=
      ( vy wcel wmo w3a cv wceq simp3 syl5ibcom wi wa wsb wal nfs1v sbequ12 nfv
      mo4f sylbi sbhypf anbi2d eqeq2 imbi12d spcgv syl5 imp exp3a 3impia impbid
      sp ) DEHZACIZAJZCKZDLZBUQAUSBUOUPAMFNUOUPABUSOUOUPPABUSUOUPABPZUSOZUPAACG
      QZPZURGKZLZOZGRZUOVAUPVGCRVGAVBCGACGSACGTUBVGCUNUCVFVAGDEVDDLZVCUTVEUSVHV
      BBAABCGDBCUAFUDUEVDDURUFUGUHUIUJUKULUM $.

    $( Consequence of "at most one."  (Contributed by NM, 29-Jun-2008.) $)
    moi2 $p |- ( ( ( A e. B /\ E* x ph ) /\ ( ph /\ ps ) ) -> x = A ) $=
      ( wcel wmo wa cv wceq wb mob2 3expa biimprd impr ) DEGZACHZIZABCJDKZSAITB
      QRATBLABCDEFMNOP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ch $.  $d y ph $.  $d x y ps $.
    moi.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    moi.2 $e |- ( x = B -> ( ph <-> ch ) ) $.
    $( Equality implied by "at most one."  (Contributed by NM, 18-Feb-2006.) $)
    mob $p |- ( ( ( A e. C /\ B e. D ) /\ E* x ph /\ ps ) ->
                ( A = B <-> ch ) ) $=
      ( wcel wa wmo wceq wb wi cvv elex w3a nfv cv nfcv nfmo1 nf3an nfim bibi1d
      3anbi3d eqeq1 imbi12d mob2 vtoclgf com12 3expib syl com3r imp 3impib ) EG
      KZFHKZLADMZBEFNZCOZURUSUTBLZVBPUSVCURVBUSFQKZVCURVBPZPFHRVDUTBVEURVDUTBSZ
      VBVDUTASZDUAZFNZCOZPVFVBPDEGDEUBVFVBDVDUTBDVDDTADUCBDTUDVBDTUEVHENZVGVFVJ
      VBVKABVDUTIUGVKVIVACVHEFUHUFUIACDFQJUJUKULUMUNUOUPUQ $.

    $( Equality implied by "at most one."  (Contributed by NM, 18-Feb-2006.) $)
    moi $p |- ( ( ( A e. C /\ B e. D ) /\ E* x ph /\ ( ps /\ ch ) ) ->
              A = B ) $=
      ( wcel wa wmo wceq wi w3a mob biimprd 3expia imp3a 3impia ) EGKFHKLZADMZB
      CLEFNZUBUCLBCUDUBUCBCUDOUBUCBPUDCABCDEFGHIJQRSTUA $.
  $}

  ${
    $d B x y $.  $d A x y $.  $d ph y $.  $d ps x y $.
    morex.1 $e |- B e. _V $.
    morex.2 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Derive membership from uniqueness.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    morex $p |- ( ( E. x e. A ph /\ E* x ph ) -> ( ps -> B e. A ) ) $=
      ( wmo wrex wcel wi cv wa wex df-rex exancom bitri wal nfmo1 nfe1 nfan syl
      mopick alrimi wceq eleq1 imbi12d spcv sylan2b ancoms ) ACHZACDIZBEDJZKZUL
      UKACLZDJZMZCNZUNULUPAMCNURACDOUPACPQUKURMZAUPKZCRUNUSUTCUKURCACSUQCTUAAUP
      CUCUDUTUNCEFUOEUEABUPUMGUOEDUFUGUHUBUIUJ $.
  $}

  ${
    $d x ph $.  $d x A $.
    euxfr2.1 $e |- A e. _V $.
    euxfr2.2 $e |- E* y x = A $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       14-Nov-2004.) $)
    euxfr2 $p |- ( E! x E. y ( x = A /\ ph ) <-> E! y ph ) $=
      ( cv wceq wa wex weu wmo wi 2euswap moani ancom mobii mpbi mpg moeq biidd
      impbii ceqsexv eubii bitri ) BGDHZAIZCJBKZUGBJZCKZACKUHUJUGCLZUHUJMBUGBCN
      AUFIZCLUKUFACFOULUGCAUFPZQRSUGBLZUJUHMCUGCBNULBLUNUFABBDTOULUGBUMQRSUBUIA
      CAABDEUFAUAUCUDUE $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x A $.
    euxfr.1 $e |- A e. _V $.
    euxfr.2 $e |- E! y x = A $.
    euxfr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       14-Nov-2004.) $)
    euxfr $p |- ( E! x ph <-> E! y ps ) $=
      ( weu cv wceq wa wex euex ax-mp biantrur 19.41v pm5.32i exbii 3bitr2i
      eubii eumoi euxfr2 bitri ) ACICJEKZBLZDMZCIBDIAUGCAUEDMZALUEALZDMUGUHAUED
      IUHGUEDNOPUEADQUIUFDUEABHRSTUABCDEFUEDGUBUCUD $.
  $}

  ${
    $d y z w ph $.  $d x z ps $.  $d y z w A $.  $d x z B $.  $d x y w $.
    euind.1 $e |- B e. _V $.
    euind.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    euind.3 $e |- ( x = y -> A = B ) $.
    $( Existential uniqueness via an indirect equality.  (Contributed by NM,
       11-Oct-2010.) $)
    euind $p |- ( ( A. x A. y ( ( ph /\ ps ) -> A = B ) /\ E. x ph )
                 -> E! z A. x ( ph -> z = A ) ) $=
      ( vw wa wceq wi wal wex cv exbii bitri imim2i weu cbvexv biantrur 3bitr2i
      isseti 19.41v excom eqeq2 bi2 an31 imbi1i impexp 3bitr3i sylib syl 2alimi
      wb 19.23v albii 19.21v eximdv syl5bi imp pm4.24 biimpi prth eqtr3 alanimi
      syl56 com12 syl5 alrimivv adantl eqeq1 imbi2d albidv eu4 sylanbrc ) ABLZF
      GMZNZDOCOZACPZLAEQZFMZNZCOZEPZWGAKQZFMZNZCOZLZWDWIMZNZKOEOZWGEUAWBWCWHWCW
      DGMZBLZDPZEPZWBWHWCBDPZWTABCDIUBXAWQEPZBLZDPWREPZDPWTBXCDXBBEGHUEUCRXDXCD
      WQBEUFRWRDEUGUDSWBWSWGEWBWRWFNZDOZCOZWSWGNZWAXECDWAVSWEWQUQZNZXEVTXIVSFGW
      DUHTXJVSWQWENZNZXEXIXKVSWEWQUITVSWQLZWENWRALZWENXLXEXMXNWEABWQUJUKVSWQWEU
      LWRAWEULUMUNUOUPXGWSWFNZCOXHXFXOCWRWFDURUSWSWFCUTSUNVAVBVCWCWPWBWCWOEKWMA
      WNNZCOZWCWNWFWKXPCAAALZWFWKLWEWJLWNAXRAVDVEAWEAWJVFWDWIFVGVIVHXQWCWNXQWCW
      NNAWNCURVEVJVKVLVMWGWLEKWNWFWKCWNWEWJAWDWIFVNVOVPVQVR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ph $.  $d x ps $.
    $( A way to express restricted uniqueness.  (Contributed by NM,
       22-Nov-1994.) $)
    reu2 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\
               A. x e. A A. y e. A ( ( ph /\ [ y / x ] ph ) -> x = y ) ) ) $=
      ( cv wcel wa weu wex wsb weq wi wal wreu wral df-ral impexp albii 3bitr4i
      nfv wrex eu2 df-reu df-rex 19.21v nfs1v nfan eleq1 sbequ12 anbi12d anbi2i
      sbie an4 bitri imbi1i 3bitri imbi2i bitr4i anbi12i ) BEZDFZAGZBHVBBIZVBVB
      BCJZGZBCKZLZCMZBMZGABDNABDUAZAABCJZGZVFLZCDOZBDOZGVBBCVBCTUBABDUCVJVCVOVI
      ABDUDVOVAVNLZBMVIVNBDPVHVPBVACEZDFZVMLZLZCMVAVSCMZLVHVPVAVSCUEVGVTCVGVAVR
      GZVLGZVFLWBVMLVTVEWCVFVEVBVRVKGZGWCVDWDVBVBWDBCVRVKBVRBTABCUFUGVFVAVRAVKU
      TVQDUHABCUIUJULUKVAAVRVKUMUNUOWBVLVFQVAVRVMQUPRVNWAVAVMCDPUQSRURUSS $.

    $( A way to express restricted uniqueness.  (Contributed by NM,
       20-Oct-2006.) $)
    reu6 $p |- ( E! x e. A ph <-> E. y e. A A. x e. A ( ph <-> x = y ) ) $=
      ( cv wcel wa weq wb wal wex wi bi1 bi2 adantr impbid imim2i imp 3bitr4i
      ex wreu weu wral wrex df-reu 19.28v eleq1 sbequ12 anbi12d equequ1 bibi12d
      wsb equid tbt simpl sylbir syl6bi spimv expdimp simpr syl6 sps jca adantl
      a5i imp3a eleq1a com23 jcai alimi impbii df-ral anbi2i exbii df-eu df-rex
      adantll bitri ) ABDUABEZDFZAGZBUBZABCHZIZBDUCZCDUDZABDUEWAWCIZBJZCKCEZDFZ
      WEGZCKWBWFWHWKCWJVTWDLZGZBJZWJWLBJZGWHWKWJWLBUFWHWNWGWMBWHWJWLWGWJBCWCWGW
      JABCULZGZCCHZIZWJWCWAWQWCWRWCVTWJAWPVSWIDUGABCUHUIBCCUJUKWSWQWJWRWQCUMUNW
      JWPUOUPUQURWGWLBWGVTWDWGVTGAWCWGVTAWCWAWCMUSWGWCALZVTWGWCWAAWAWCNVTAUTVAO
      PTVBVCVEWMWGBWMWAWCWLWAWCLWJWLVTAWCWDAWCLVTAWCMQVFVDWMWCWAWMWCGVTAWMWCVTW
      JWCVTLWLWIDVSVGORWLWCVTALZWJWLWCXAWLVTWCAWDWTVTAWCNQVHRVQVITPVJVKWEWOWJWD
      BDVLVMSVNWABCVOWECDVPSVR $.

    $( A way to express restricted uniqueness.  (Contributed by NM,
       24-Oct-2006.) $)
    reu3 $p |- ( E! x e. A ph <->
               ( E. x e. A ph /\ E. y e. A A. x e. A ( ph -> x = y ) ) ) $=
      ( wreu wrex weq wi wral wa reurex wb reu6 bi1 ralimi reximi sylbi jca wex
      wal rexex anim2i cv wcel weu nfv df-reu df-rex df-ral impexp albii bitr4i
      eu3 exbii anbi12i 3bitr4i sylibr impbii ) ABDEZABDFZABCGZHZBDIZCDFZJZUSUT
      VDABDKUSAVALZBDIZCDFVDABCDMVGVCCDVFVBBDAVANOPQRVEUTVCCSZJZUSVDVHUTVCCDUAU
      BBUCDUDZAJZBUEVKBSZVKVAHZBTZCSZJUSVIVKBCVKCUFUMABDUGUTVLVHVOABDUHVCVNCVCV
      JVBHZBTVNVBBDUIVMVPBVJAVAUJUKULUNUOUPUQUR $.

    $( A condition which implies existential uniqueness.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    reu6i $p |- ( ( B e. A /\ A. x e. A ( ph <-> x = B ) ) -> E! x e. A ph ) $=
      ( vy wcel cv wceq wb wral wa wrex wreu eqeq2 bibi2d ralbidv rspcev sylibr
      reu6 ) DCFABGZDHZIZBCJZKATEGZHZIZBCJZECLABCMUGUCEDCUDDHZUFUBBCUHUEUAAUDDT
      NOPQABECSR $.

    eqreu.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( A condition which implies existential uniqueness.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    eqreu $p |- ( ( B e. A /\ ps /\ A. x e. A ( ph -> x = B ) ) ->
      E! x e. A ph ) $=
      ( wcel cv wceq wi wral wreu wa wb ralbiim ceqsralv anbi2d syl5bb reu6i ex
      sylbird 3impib 3com23 ) EDGZACHEIZJCDKZBACDLZUDUFBUGUDUFBMZAUENCDKZUGUIUF
      UEAJCDKZMUDUHAUECDOUDUJBUFABCEDFPQRUDUIUGACDESTUAUBUC $.
  $}

  ${
    $d x y z A $.  $d y z ph $.  $d x z ps $.
    rmo4.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Restricted "at most one" using implicit substitution.  (Contributed by
       NM, 24-Oct-2006.)  (Revised by NM, 16-Jun-2017.) $)
    rmo4 $p |- ( E* x e. A ph <->
               A. x e. A A. y e. A ( ( ph /\ ps ) -> x = y ) ) $=
      ( wrmo cv wcel wa wmo weq wi wral df-rmo wal bitri impexp albii df-ral
      an4 ancom anbi1i imbi1i 3bitri r19.21v 3bitr2i eleq1 anbi12d mo4 3bitr4i
      ) ACEGCHZEIZAJZCKZABJZCDLZMZDENZCENZACEOUNDHZEIZBJZJZUQMZDPZCPUMUSMZCPUOU
      TVFVGCVFVBUMURMZMZDPVHDENVGVEVIDVEVBUMJZUPJZUQMVJURMVIVDVKUQVDUMVBJZUPJVK
      UMAVBBUAVLVJUPUMVBUBUCQUDVJUPUQRVBUMURRUESVHDETUMURDEUFUGSUNVCCDUQUMVBABU
      LVAEUHFUIUJUSCETUKQ $.

    $( Restricted uniqueness using implicit substitution.  (Contributed by NM,
       23-Nov-1994.) $)
    reu4 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\
             A. x e. A A. y e. A ( ( ph /\ ps ) -> x = y ) ) ) $=
      ( wreu wrex wrmo wa weq wi wral reu5 rmo4 anbi2i bitri ) ACEGACEHZACEIZJR
      ABJCDKLDEMCEMZJACENSTRABCDEFOPQ $.

    $( Restricted uniqueness using implicit substitution.  (Contributed by NM,
       24-Oct-2006.) $)
    reu7 $p |- ( E! x e. A ph <-> ( E. x e. A ph /\
             E. x e. A A. y e. A ( ps -> x = y ) ) ) $=
      ( vz wreu wrex weq wi wral wa equequ1 equcom syl6bb imbi12d cbvralv bitri
      reu3 rexbii imbi2d ralbidv cbvrexv anbi2i ) ACEHACEIZACGJZKZCELZGEIZMUFBC
      DJZKZDELZCEIZMACGETUJUNUFUJBGDJZKZDELZGEIUNUIUQGEUHUPCDEUKABUGUOFUKUGDGJU
      OCDGNDGOPQRUAUQUMGCEGCJZUPULDEURUOUKBGCDNUBUCUDSUES $.

    $( Restricted uniqueness using implicit substitution.  (Contributed by NM,
       24-Oct-2006.) $)
    reu8 $p |- ( E! x e. A ph <-> E. x e. A ( ph /\
                A. y e. A ( ps -> x = y ) ) ) $=
      ( wreu weq wb wral wrex wi wa cbvreuv reu6 cv wcel ralbii wal syl5bb a1i
      dfbi2 ancom equcom imbi2i biimt df-ral bi2.04 albii eleq1 imbi12d equcoms
      vex bicomd ceqsalv 3bitrri syl6bb anbi12d r19.26 syl6rbbr rexbiia 3bitri
      ) ACEGBDEGBDCHZIZDEJZCEKABCDHZLZDEJZMZCEKABCDEFNBDCEOVEVICEVEBVCLZVCBLZMZ
      DEJZCPZEQZVIVDVLDEBVCUBRVOVIVJDEJZVKDEJZMZVMVIVHAMVOVRAVHUCVOVHVPAVQVHVPI
      VOVGVJDEVFVCBCDUDUERUAVOAVOALZVQVOAUFVQDPZEQZVKLZDSVCWABLZLZDSVSVKDEUGWBW
      DDWAVCBUHUIWCVSDVNCUMWCVSICDVFVSWCVFVOWAABVNVTEUJFUKUNULUOUPUQURTVJVKDEUS
      UTTVAVB $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Equality has existential uniqueness.  (Contributed by Mario Carneiro,
       1-Sep-2015.) $)
    reueq $p |- ( B e. A <-> E! x e. A x = B ) $=
      ( wcel cv wceq wrex wreu risset wrmo wmo moeq mormo ax-mp mpbiran2 bitr4i
      reu5 ) CBDAECFZABGZRABHZACBITSRABJZRAKUAACLRABMNRABQOP $.
  $}

  $( Restricted "at most one" still holds when a conjunct is added.
     (Contributed by NM, 16-Jun-2017.) $)
  rmoan $p |- ( E* x e. A ph -> E* x e. A ( ps /\ ph ) ) $=
    ( cv wcel wa wmo wrmo moan an12 mobii sylib df-rmo 3imtr4i ) CEDFZAGZCHZPBA
    GZGZCHZACDISCDIRBQGZCHUAQBCJUBTCBPAKLMACDNSCDNO $.

  $( Restricted "at most one" is preserved through implication (note wff
     reversal).  (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
  rmoim $p |- ( A. x e. A ( ph -> ps )
        -> ( E* x e. A ps -> E* x e. A ph ) ) $=
    ( wi wral cv wcel wa wal wrmo df-ral imdistan albii wmo moim df-rmo 3imtr4g
    bitri sylbi ) ABEZCDFZCGDHZAIZUCBIZEZCJZBCDKZACDKZEUBUCUAEZCJUGUACDLUJUFCUC
    ABMNSUGUECOUDCOUHUIUDUECPBCDQACDQRT $.

  ${
    rmoimia.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Restricted "at most one" is preserved through implication (note wff
       reversal).  (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
    rmoimia $p |- ( E* x e. A ps -> E* x e. A ph ) $=
      ( wi wrmo rmoim mprg ) ABFBCDGACDGFCDABCDHEI $.
  $}

  ${
    rmoimi2.1 $e |- A. x ( ( x e. A /\ ph ) -> ( x e. B /\ ps ) ) $.
    $( Restricted "at most one" is preserved through implication (note wff
       reversal).  (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
    rmoimi2 $p |- ( E* x e. B ps -> E* x e. A ph ) $=
      ( cv wcel wa wmo wrmo wi wal moim ax-mp df-rmo 3imtr4i ) CGZEHBIZCJZRDHAI
      ZCJZBCEKACDKUASLCMTUBLFUASCNOBCEPACDPQ $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( A condition allowing swap of uniqueness and existential quantifiers.
       (Contributed by Thierry Arnoux, 7-Apr-2017.)  (Revised by NM,
       16-Jun-2017.) $)
    2reuswap $p |- ( A. x e. A E* y e. B ph ->
                   ( E! x e. A E. y e. B ph -> E! y e. B E. x e. A ph ) ) $=
      ( wral cv wcel wa wmo wrex wreu wal wex weu df-reu r19.42v df-rex bitri
      wi wrmo df-rmo ralbii df-ral moanimv albii bitr4i bitr3i an12 exbii eubii
      2euswap 3imtr4g sylbi ) ACEUAZBDFCGEHZAIZCJZBDFZACEKZBDLZABDKZCELZTZUOURB
      DACEUBUCUSBGDHZUQIZCJZBMZVDUSVEURTZBMVHURBDUDVGVIBVEUQCUEUFUGVHVFCNZBOZVF
      BNZCOZVAVCVFBCULVAVEUTIZBOVKUTBDPVNVJBVNUPVEAIZIZCNZVJVNVOCEKVQVEACEQVOCE
      RUHVPVFCUPVEAUIUJSUKSVCUPVBIZCOVMVBCEPVRVLCVRUQBDKVLUPABDQUQBDRUHUKSUMUNU
      N $.
  $}

  ${
    $d w y z A $.  $d x z B $.  $d w x y z C $.  $d w y z ph $.  $d x z ps $.
    reuind.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    reuind.2 $e |- ( x = y -> A = B ) $.
    $( Existential uniqueness via an indirect equality.  (Contributed by NM,
       16-Oct-2010.) $)
    reuind $p |- ( ( A. x A. y ( ( ( A e. C /\ ph ) /\ ( B e. C /\ ps ) )
         -> A = B ) /\ E. x ( A e. C /\ ph ) )
                 -> E! z e. C A. x ( ( A e. C /\ ph ) -> z = A ) ) $=
      ( vw wcel wa wceq wi wal wex cv wrex bitri wral wreu eleq1d anbi12d exbii
      cbvexv r19.41v rexcom4 risset anbi1i 3bitr4ri wb eqeq2 imim2i an31 imbi1i
      bi2 impexp 3bitr3i sylib 2alimi 19.23v an12 adantr pm5.32ri bitr4i 19.42v
      syl eleq1 albii 19.21v exp3a reximdvai syl5bi imp pm4.24 prth eqtr3 syl56
      biimpi alanimi com12 syl5 a1d ralrimivv adantl eqeq1 imbi2d reu4 sylanbrc
      albidv ) FHLZAMZGHLZBMZMZFGNZOZDPCPZWMCQZMWMERZFNZOZCPZEHSZXDWMKRZFNZOZCP
      ZMZXAXFNZOZKHUAEHUAZXDEHUBWSWTXEWTXAGNZBMZDQZEHSZWSXEWTWODQZXQWMWOCDCRDRN
      ZWLWNABXSFGHJUCIUDUFXOEHSZDQXNEHSZBMZDQXQXRXTYBDXNBEHUGUEXOEDHUHWOYBDWNYA
      BEGHUIUJUEUKTWSXPXDEHWSXAHLZXPXDWSXNWOMZXCOZDPZCPZYCXPMZXDOZWRYECDWRWPXBX
      NULZOZYEWQYJWPFGXAUMUNYKWPXNXBOZOZYEYJYLWPXBXNUQUNWPXNMZXBOYDWMMZXBOYMYEY
      NYOXBWMWOXNUOUPWPXNXBURYDWMXBURUSUTVHVAYGYHXCOZCPYIYFYPCYFYDDQZXCOYPYDXCD
      VBYQYHXCYQYCXOMZDQYHYDYRDYDWNXOMYRXNWNBVCXOYCWNXNYCWNULBXAGHVIVDVEVFUEYCX
      ODVGTUPTVJYHXCCVKTUTVLVMVNVOWTXMWSWTXLEKHHWTXLYCXFHLMXJWMXKOZCPZWTXKXCXHY
      SCWMWMWMMZXCXHMXBXGMXKWMUUAWMVPVTWMXBWMXGVQXAXFFVRVSWAYTWTXKYTWTXKOWMXKCV
      BVTWBWCWDWEWFXDXIEKHXKXCXHCXKXBXGWMXAXFFWGWHWKWIWJ $.
  $}

  ${
    $d y A $.  $d x B $.  $d x y $.
    $( Double restricted quantification with "at most one," analogous to
       ~ 2moex .  (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
    2rmorex $p |- ( E* x e. A E. y e. B ph -> A. y e. B E* x e. A ph ) $=
      ( wrex wrmo nfcv nfre1 nfrmo cv wcel wi wral ex ralrimivw rmoim syl com12
      rspe ralrimi ) ACEFZBDGZABDGZCEUBCBDCDHACEIJCKELZUCUDUEAUBMZBDNUCUDMUEUFB
      DUEAUBACETOPAUBBDQRSUA $.

    $( Lemma for ~ 2reu5 .  Note that ` E! x e. A E! y e. B ph ` does not mean
       "there is exactly one ` x ` in ` A ` and exactly one ` y ` in ` B ` such
       that ` ph ` holds;" see comment for ~ 2eu5 .  (Contributed by Alexander
       van der Vekens, 17-Jun-2017.) $)
    2reu5lem1 $p |- ( E! x e. A E! y e. B ph <->
                   E! x E! y ( x e. A /\ y e. B /\ ph ) ) $=
      ( wreu cv wcel wa weu w3a df-reu reubii euanv bicomi 3anass eubii bitri )
      ACEFZBDFCGEHZAIZCJZBDFZBGDHZTAKZCJZBJZSUBBDACELMUCUDUBIZBJUGUBBDLUHUFBUHU
      DUAIZCJZUFUJUHUDUACNOUIUECUEUIUDTAPOQRQRR $.

    $( Lemma for ~ 2reu5 .  (Contributed by Alexander van der Vekens,
       17-Jun-2017.) $)
    2reu5lem2 $p |- ( A. x e. A E* y e. B ph <->
                   A. x E* y ( x e. A /\ y e. B /\ ph ) ) $=
      ( wrmo wral cv wcel wa wmo w3a wal df-rmo ralbii wi df-ral moanimv bicomi
      bitri 3anass mobii albii ) ACEFZBDGCHEIZAJZCKZBDGZBHDIZUEALZCKZBMZUDUGBDA
      CENOUHUIUGPZBMULUGBDQUMUKBUMUIUFJZCKZUKUOUMUIUFCRSUNUJCUJUNUIUEAUASUBTUCT
      T $.
  $}

  ${
    $d w y z A $.  $d w x z B $.  $d x y $.  $d ph w $.  $d ph z $.
    $( Lemma for ~ 2reu5 .  This lemma is interesting in its own right, showing
       that existential restriction in the last conjunct (the "at most one"
       part) is optional; compare ~ rmo2 .  (Contributed by Alexander van der
       Vekens, 17-Jun-2017.) $)
    2reu5lem3 $p |- ( ( E! x e. A E! y e. B ph /\ A. x e. A E* y e. B ph )
                   <-> ( E. x e. A E. y e. B ph
                         /\ E. z E. w A. x e. A A. y e. B
                            ( ph -> ( x = z /\ y = w ) ) ) ) $=
      ( wreu wral wa cv wcel weu wal wex weq wi wrex exbii 3bitri w3a 2reu5lem1
      wrmo wmo 2reu5lem2 anbi12i 2eu5 3anass 19.42v df-rex bicomi anbi2i bitr4i
      3anan12 imbi1i impexp imbi2i albii df-ral r19.21v 3bitr2i ) ACGHBFHZACGUC
      BFIZJBKFLZCKGLZAUAZCMBMZVFCUDBNZJVFCOZBOZVFBDPCEPJZQZCNZBNZEOZDOZJACGRZBF
      RZAVKQZCGIZBFIZEOZDOZJVBVGVCVHABCFGUBABCFGUEUFVFBCDEUGVJVRVPWCVJVDVQJZBOV
      RVIWDBVIVDVEAJZJZCOVDWECOZJWDVFWFCVDVEAUHSVDWECUIWGVQVDVQWGACGUJUKULTSVQB
      FUJUMVOWBDVNWAEVNVDVTQZBNWAVMWHBVMVEVDVSQZQZCNWICGIWHVLWJCVLVEVDAJZJZVKQV
      EWKVKQZQWJVFWLVKVDVEAUNUOVEWKVKUPWMWIVEVDAVKUPUQTURWICGUSVDVSCGUTVAURVTBF
      USUMSSUFT $.

    $d x A $.  $d y B $.
    $( Double restricted existential uniqueness in terms of restricted
       existential quantification and restricted universal quantification,
       analogous to ~ 2eu5 and ~ reu3 .  (Contributed by Alexander van der
       Vekens, 17-Jun-2017.) $)
    2reu5 $p |- ( ( E! x e. A E! y e. B ph /\ A. x e. A E* y e. B ph )
                  <-> ( E. x e. A E. y e. B ph
                        /\ E. z e. A E. w e. B A. x e. A A. y e. B
                           ( ph -> ( x = z /\ y = w ) ) ) ) $=
      ( wrex weq wa wral wex cv wcel wreu r19.29r reximi eleq1 ex df-rex pm3.35
      wrmo bi2anan9 biimpac ancomd rexlimivv 4syl pm4.71rd anass syl6bb 2exbidv
      wi pm5.32i 2reu5lem3 r19.42v bitr3i exbii bitri anbi2i 3bitr4i ) ACGHZBFH
      ZABDIZCEIZJZULZCGKZBFKZELDLZJVBEMZGNZDMZFNZVHJZJZELZDLZJACGOBFOACGUBBFKJV
      BVHEGHZDFHZJVBVIVQVBVHVODEVBVHVKVMJZVHJVOVBVHVTVBVHVTVBVHJVAVGJZBFHAVFJZC
      GHZBFHVECGHZBFHVTVAVGBFPWAWCBFAVFCGPQWCWDBFWBVECGAVEUAQQVEVTBCFGBMZFNZCMZ
      GNZJZVEVTWIVEJVMVKVEWIVMVKJVCWFVMVDWHVKWEVLFRWGVJGRUCUDUESUFUGSUHVKVMVHUI
      UJUKUMABCDEFGUNVSVQVBVSVMVRJZDLVQVRDFTWJVPDWJVNEGHVPVMVHEGUOVNEGTUPUQURUS
      UT $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    nelrdva.1 $e |- ( ( ph /\ x e. A ) -> x =/= B ) $.
    $( Deduce negative membership from an implication.  (Contributed by Thierry
       Arnoux, 27-Nov-2017.) $)
    nelrdva $p |- ( ph -> -. B e. A ) $=
      ( wcel wceq wa eqidd wne cv wi eleq1 anbi2d imbi12d vtoclg anabsi7 neneqd
      neeq1 pm2.65da ) ADCFZDDGAUAHZDIUBDDAUADDJZABKZCFZHZUDDJZLUBUCLBDCUDDGZUF
      UBUGUCUHUEUAAUDDCMNUDDDSOEPQRT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Conditional equality (experimental)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  This is a very useless definition, which "abbreviates" ` ( x = y -> ph ) ` as
  ` CondEq ( x = y -> ph ) ` . What this display hides, though, is that the
  first expression, even though it has a shorter constant string, is actually
  much more complicated in its parse tree: it is parsed as
  (wi (wceq (cv vx) (cv vy)) wph), while the ` CondEq ` version is parsed as
  (wcdeq vx vy wph).  It also allows us to give a name to the specific 3-ary
  operation ` ( x = y -> ph ) ` .

  This is all used as part of a metatheorem: we want to say that
  ` |- ( x = y -> ( ph ( x ) <-> ph ( y ) ) ) ` and
  ` |- ( x = y -> A ( x ) = A ( y ) ) ` are provable, for any expressions
  ` ph ( x ) ` or ` A ( x ) ` in the language.  The proof is by induction, so
  the base case is each of the primitives, which is why you will see a theorem
  for each of the set.mm primitive operations.

  The metatheorem comes with a disjoint variables assumption: every variable in
  ` ph ( x ) ` is assumed disjoint from ` x ` except ` x ` itself.  For such a
  proof by induction, we must consider each of the possible forms of
  ` ph ( x ) ` .  If it is a variable other than ` x ` , then we have
  ` CondEq ( x = y -> A = A ) ` or ` CondEq ( x = y -> ( ph <-> ph ) ) ` ,
  which is provable by ~ cdeqth and reflexivity.  Since we are only working
  with class and wff expressions, it can't be ` x ` itself in set.mm, but if it
  was we'd have to also prove ` CondEq ( x = y -> x = y ) ` (where _set_
  equality is being used on the right).

  Otherwise, it is a primitive operation applied to smaller expressions.  In
  these cases, for each set variable parameter to the operation, we must
  consider if it is equal to ` x ` or not, which yields 2^n proof obligations.
  Luckily, all primitive operations in set.mm have either zero or one set
  variable, so we only need to prove one statement for the non-set constructors
  (like implication) and two for the constructors taking a set (the forall and
  the class builder).

  In each of the primitive proofs, we are allowed to assume that ` y ` is
  disjoint from ` ph ( x ) ` and vice versa, because this is maintained through
  the induction.  This is how we satisfy the DV assumptions of ~ cdeqab1 and
  ~ cdeqab .

$)

  $c CondEq $. $( conditional equality $)

  $( Extend wff notation to include conditional equality.  This is a technical
     device used in the proof that ` F/ ` is the not-free predicate, and that
     definitions are conservative as a result. $)
  wcdeq $a wff CondEq ( x = y -> ph ) $.

  $( Define conditional equality.  All the notation to the left of the ` <-> `
     is fake; the parentheses and arrows are all part of the notation, which
     could equally well be written ` CondEq x y ph ` .  On the right side is
     the actual implication arrow.  The reason for this definition is to
     "flatten" the structure on the right side (whose tree structure is
     something like (wi (wceq (cv vx) (cv vy)) wph) ) into just (wcdeq vx vy
     wph).  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
  df-cdeq $a |- ( CondEq ( x = y -> ph ) <-> ( x = y -> ph ) ) $.

  ${
    cdeqi.1 $e |- ( x = y -> ph ) $.
    $( Deduce conditional equality.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    cdeqi $p |- CondEq ( x = y -> ph ) $=
      ( wcdeq weq wi df-cdeq mpbir ) ABCEBCFAGDABCHI $.
  $}

  ${
    cdeqri.1 $e |- CondEq ( x = y -> ph ) $.
    $( Property of conditional equality.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    cdeqri $p |- ( x = y -> ph ) $=
      ( wcdeq weq wi df-cdeq mpbi ) ABCEBCFAGDABCHI $.
  $}

  ${
    cdeqth.1 $e |- ph $.
    $( Deduce conditional equality from a theorem.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    cdeqth $p |- CondEq ( x = y -> ph ) $=
      ( weq a1i cdeqi ) ABCABCEDFG $.
  $}

  ${
    cdeqnot.1 $e |- CondEq ( x = y -> ( ph <-> ps ) ) $.
    $( Distribute conditional equality over negation.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    cdeqnot $p |- CondEq ( x = y -> ( -. ph <-> -. ps ) ) $=
      ( wn wb weq cdeqri notbid cdeqi ) AFBFGCDCDHABABGCDEIJK $.

    ${
      $d x z $.  $d y z $.
      $( Distribute conditional equality over quantification.  (Contributed by
         Mario Carneiro, 11-Aug-2016.) $)
      cdeqal $p |- CondEq ( x = y -> ( A. z ph <-> A. z ps ) ) $=
        ( wal wb weq cdeqri albidv cdeqi ) AEGBEGHCDCDIABEABHCDFJKL $.

      $( Distribute conditional equality over abstraction.  (Contributed by
         Mario Carneiro, 11-Aug-2016.) $)
      cdeqab $p |- CondEq ( x = y -> { z | ph } = { z | ps } ) $=
        ( cab wceq weq wb cdeqri abbidv cdeqi ) AEGBEGHCDCDIABEABJCDFKLM $.
    $}

    ${
      $d x ps $.  $d y ph $.
      $( Distribute conditional equality over quantification.  (Contributed by
         Mario Carneiro, 11-Aug-2016.) $)
      cdeqal1 $p |- CondEq ( x = y -> ( A. x ph <-> A. y ps ) ) $=
        ( wal wb cdeqri cbvalv cdeqth ) ACFBDFGCDABCDABGCDEHIJ $.

      $( Distribute conditional equality over abstraction.  (Contributed by
         Mario Carneiro, 11-Aug-2016.) $)
      cdeqab1 $p |- CondEq ( x = y -> { x | ph } = { y | ps } ) $=
        ( cab wceq wb cdeqri cbvabv cdeqth ) ACFBDFGCDABCDABHCDEIJK $.
    $}

    cdeqim.1 $e |- CondEq ( x = y -> ( ch <-> th ) ) $.
    $( Distribute conditional equality over implication.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    cdeqim $p |- CondEq ( x = y -> ( ( ph -> ch ) <-> ( ps -> th ) ) ) $=
      ( wi wb weq cdeqri imbi12d cdeqi ) ACIBDIJEFEFKABCDABJEFGLCDJEFHLMN $.
  $}

  $( Conditional equality for set-to-class promotion.  (Contributed by Mario
     Carneiro, 11-Aug-2016.) $)
  cdeqcv $p |- CondEq ( x = y -> x = y ) $=
    ( weq id cdeqi ) ABCZABFDE $.

  ${
    cdeqeq.1 $e |- CondEq ( x = y -> A = B ) $.
    cdeqeq.2 $e |- CondEq ( x = y -> C = D ) $.
    $( Distribute conditional equality over equality.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    cdeqeq $p |- CondEq ( x = y -> ( A = C <-> B = D ) ) $=
      ( wceq wb weq cdeqri eqeq12d cdeqi ) CEIDFIJABABKCDEFCDIABGLEFIABHLMN $.

    $( Distribute conditional equality over elementhood.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) $)
    cdeqel $p |- CondEq ( x = y -> ( A e. C <-> B e. D ) ) $=
      ( wcel wb weq wceq cdeqri eleq12d cdeqi ) CEIDFIJABABKCDEFCDLABGMEFLABHMN
      O $.
  $}

  ${
    $d x ps $.  $d y ph $.
    nfcdeq.1 $e |- F/ x ph $.
    nfcdeq.2 $e |- CondEq ( x = y -> ( ph <-> ps ) ) $.
    $( If we have a conditional equality proof, where ` ph ` is ` ph ( x ) `
       and ` ps ` is ` ph ( y ) ` , and ` ph ( x ) ` in fact does not have
       ` x ` free in it according to ` F/ ` , then ` ph ( x ) <-> ph ( y ) `
       unconditionally.  This proves that ` F/ x ph ` is actually a not-free
       predicate.  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfcdeq $p |- ( ph <-> ps ) $=
      ( wsb sbf nfv wb cdeqri sbie bitr3i ) AACDGBACDEHABCDBCIABJCDFKLM $.
  $}

  ${
    $d x z B $.  $d y z A $.
    nfccdeq.1 $e |- F/_ x A $.
    nfccdeq.2 $e |- CondEq ( x = y -> A = B ) $.
    $( Variation of ~ nfcdeq for classes.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfccdeq $p |- A = B $=
      ( vz cv wcel nfcri weq equid cdeqth cdeqel nfcdeq eqriv ) GCDGHZCIQDIABAG
      CEJABQQCDGGKABGLMFNOP $.
  $}

  $( Let the computer know the theorems to look for to prove the metatheorem $)
  $( $j
    condequality 'wcdeq' from 'cdeqth';
    condcongruence 'cdeqnot' 'cdeqim' 'cdeqal1' 'cdeqal' 'cdeqcv' 'cdeqeq'
      'cdeqel' 'cdeqab1' 'cdeqab';
    notfree 'wnf' from 'nfcdeq';
    notfree 'wnfc' from 'nfccdeq';
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Russell's Paradox
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Russell's Paradox.  Proposition 4.14 of [TakeutiZaring] p. 14.

       In the late 1800s, Frege's Axiom of (unrestricted) Comprehension,
       expressed in our notation as ` A e. _V ` , asserted that any collection
       of sets ` A ` is a set i.e. belongs to the universe ` _V ` of all sets.
       In particular, by substituting ` { x | x e/ x } ` (the "Russell class")
       for ` A ` , it asserted ` { x | x e/ x } e. _V ` , meaning that the
       "collection of all sets which are not members of themselves" is a set.
       However, here we prove ` { x | x e/ x } e/ _V ` .  This contradiction
       was discovered by Russell in 1901 (published in 1903), invalidating the
       Comprehension Axiom and leading to the collapse of Frege's system.

       In 1908, Zermelo rectified this fatal flaw by replacing Comprehension
       with a weaker Subset (or Separation) Axiom ~ ssex asserting that ` A `
       is a set only when it is smaller than some other set ` B ` .  However,
       Zermelo was then faced with a "chicken and egg" problem of how to show
       ` B ` is a set, leading him to introduce the set-building axioms of Null
       Set ~ 0ex , Pairing ~ prex , Union ~ uniex , Power Set ~ pwex , and
       Infinity ~ omex to give him some starting sets to work with (all of
       which, before Russell's Paradox, were immediate consequences of Frege's
       Comprehension).  In 1922 Fraenkel strengthened the Subset Axiom with our
       present Replacement Axiom ~ funimaex (whose modern formalization is due
       to Skolem, also in 1922).  Thus, in a very real sense Russell's Paradox
       spawned the invention of ZF set theory and completely revised the
       foundations of mathematics!

       Another mainstream formalization of set theory, devised by von Neumann,
       Bernays, and Goedel, uses class variables rather than set variables as
       its primitives.  The axiom system NBG in [Mendelson] p. 225 is suitable
       for a Metamath encoding.  NBG is a conservative extension of ZF in that
       it proves exactly the same theorems as ZF that are expressible in the
       language of ZF. An advantage of NBG is that it is finitely axiomatizable
       - the Axiom of Replacement can be broken down into a finite set of
       formulas that eliminate its wff metavariable.  Finite axiomatizability
       is required by some proof languages (although not by Metamath).  There
       is a stronger version of NBG called Morse-Kelley (axiom system MK in
       [Mendelson] p. 287).

       Russell himself continued in a different direction, avoiding the paradox
       with his "theory of types."  Quine extended Russell's ideas to formulate
       his New Foundations set theory (axiom system NF of [Quine] p. 331).  In
       NF, the collection of all sets is a set, contradicting ZF and NBG set
       theories, and it has other bizarre consequences: when sets become too
       huge (beyond the size of those used in standard mathematics), the Axiom
       of Choice ~ ac4 and Cantor's Theorem ~ canth are provably false!  (See
       ~ ncanth for some intuition behind the latter.)  Recent results (as of
       2014) seem to show that NF is equiconsistent to Z (ZF in which ~ ax-sep
       replaces ~ ax-rep ) with ~ ax-sep restricted to only bounded
       quantifiers.  NF is finitely axiomatizable and can be encoded in
       Metamath using the axioms from T. Hailperin, "A set of axioms for
       logic," _J. Symb.  Logic_ 9:1-19 (1944).

       Under our ZF set theory, every set is a member of the Russell class by
       ~ elirrv (derived from the Axiom of Regularity), so for us the Russell
       class equals the universe ` _V ` (theorem ~ ruv ).  See ~ ruALT for an
       alternate proof of ~ ru derived from that fact.  (Contributed by NM,
       7-Aug-1994.) $)
    ru $p |- { x | x e/ x } e/ _V $=
      ( vy cv wnel cab cvv wcel wceq wex wel wb wal pm5.19 eleq1 df-nel eleq12d
      wn id notbid mtbir syl5bb bibi12d spv mto abeq2 nex isset nelir ) ACZUIDZ
      AEZFUKFGBCZUKHZBIUMBUMABJZUJKZALZUPBBJZUQQZKZUQMUOUSABUIULHZUNUQUJURUIULU
      LNUJAAJZQUTURUIUIOUTVAUQUTUIULUIULUTRZVBPSUAUBUCUDUJAULUETUFBUKUGTUH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Proper substitution of classes for sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c [. $.
  $c ]. $.

  $( Extend wff notation to include the proper substitution of a class for a
     set.  Read this notation as "the proper substitution of class ` A ` for
     set variable ` x ` in wff ` ph ` ." $)
  wsbc $a wff [. A / x ]. ph $.

  $( Define the proper substitution of a class for a set.

     When ` A ` is a proper class, our definition evaluates to false.  This is
     somewhat arbitrary: we could have, instead, chosen the conclusion of
     ~ sbc6 for our definition, which always evaluates to true for proper
     classes.

     Our definition also does not produce the same results as discussed in the
     proof of Theorem 6.6 of [Quine] p. 42 (although Theorem 6.6 itself does
     hold, as shown by ~ dfsbcq below).  For example, if ` A ` is a proper
     class, Quine's substitution of ` A ` for ` y ` in ` 0 e. y ` evaluates to
     ` 0 e. A ` rather than our falsehood.  (This can be seen by substituting
     ` A ` , ` y ` , and ` 0 ` for alpha, beta, and gamma in Subcase 1 of
     Quine's discussion on p. 42.)  Unfortunately, Quine's definition requires
     a recursive syntactical breakdown of ` ph ` , and it does not seem
     possible to express it with a single closed formula.

     If we did not want to commit to any specific proper class behavior, we
     could use this definition _only_ to prove theorem ~ dfsbcq , which holds
     for both our definition and Quine's, and from which we can derive a weaker
     version of ~ df-sbc in the form of ~ sbc8g .  However, the behavior of
     Quine's definition at proper classes is similarly arbitrary, and for
     practical reasons (to avoid having to prove sethood of ` A ` in every use
     of this definition) we allow direct reference to ~ df-sbc and assert that
     ` [. A / x ]. ph ` is always false when ` A ` is a proper class.

     The theorem ~ sbc2or shows the apparently "strongest" statement we can
     make regarding behavior at proper classes if we start from ~ dfsbcq .

     The related definition ~ df-csb defines proper substitution into a class
     variable (as opposed to a wff variable).  (Contributed by NM,
     14-Apr-1995.)  (Revised by NM, 25-Dec-2016.) $)
  df-sbc $a |- ( [. A / x ]. ph <-> A e. { x | ph } ) $.

  $( --- Start of old code before overloading prevention patch. $)
  $(
  @( Extend wff notation to include the proper substitution of a class for a
     set.  This definition "overloads" the previously defined variable
     substitution ~ wsb (where the first argument is a set variable rather
     than a class variable).  We take care to ensure that this new definition
     is a conservative extension.  Read this notation as "the proper
     substitution of class ` A ` for set variable ` x ` in wff ` ph ` ." @)
  wsbcSBC @a wff [ A / x ] ph @.
  $)
  $( --- End of old code before overloading prevention patch. $)

  $( This theorem, which is similar to Theorem 6.7 of [Quine] p. 42 and holds
     under both our definition and Quine's, provides us with a weak definition
     of the proper substitution of a class for a set.  Since our ~ df-sbc does
     not result in the same behavior as Quine's for proper classes, if we
     wished to avoid conflict with Quine's definition we could start with this
     theorem and ~ dfsbcq2 instead of ~ df-sbc .  ( ~ dfsbcq2 is needed because
     unlike Quine we do not overload the ~ df-sb syntax.)  As a consequence of
     these theorems, we can derive ~ sbc8g , which is a weaker version of
     ~ df-sbc that leaves substitution undefined when ` A ` is a proper class.

     However, it is often a nuisance to have to prove the sethood hypothesis of
     ~ sbc8g , so we will allow direct use of ~ df-sbc after theorem ~ sbc2or
     below.  Proper substiution with a proper class is rarely needed, and when
     it is, we can simply use the expansion of Quine's definition.
     (Contributed by NM, 14-Apr-1995.) $)
  dfsbcq $p |- ( A = B -> ( [. A / x ]. ph <-> [. B / x ]. ph ) ) $=
    ( wceq cab wcel wsbc eleq1 df-sbc 3bitr4g ) CDECABFZGDLGABCHABDHCDLIABCJABD
    JK $.

  $( This theorem, which is similar to Theorem 6.7 of [Quine] p. 42 and holds
     under both our definition and Quine's, relates logic substitution ~ df-sb
     and substitution for class variables ~ df-sbc .  Unlike Quine, we use a
     different syntax for each in order to avoid overloading it.  See remarks
     in ~ dfsbcq .  (Contributed by NM, 31-Dec-2016.) $)
  dfsbcq2 $p |- ( y = A -> ( [ y / x ] ph <-> [. A / x ]. ph ) ) $=
    ( cv wceq cab wcel wsb wsbc eleq1 df-clab df-sbc bicomi 3bitr3g ) CEZDFPABG
    ZHDQHZABCIABDJZPDQKACBLSRABDMNO $.

  $( Show that ~ df-sb and ~ df-sbc are equivalent when the class term ` A ` in
     ~ df-sbc is a set variable.  This theorem lets us reuse theorems based on
     ~ df-sb for proofs involving ~ df-sbc .  (Contributed by NM,
     31-Dec-2016.)  (Proof modification is discouraged.) $)
  sbsbc $p |- ( [ y / x ] ph <-> [. y / x ]. ph ) $=
    ( weq wsb cv wsbc wb eqid dfsbcq2 ax-mp ) CCDABCEABCFZGHLIABCLJK $.

  ${
    sbceq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for class substitution.  (Contributed by Mario
       Carneiro, 9-Feb-2017.)  (Revised by NM, 30-Jun-2018.) $)
    sbceq1d $p |- ( ph -> ( [. A / x ]. ps <-> [. B / x ]. ps ) ) $=
      ( wceq wsbc wb dfsbcq syl ) ADEGBCDHBCEHIFBCDEJK $.

    sbceq1dd.2 $e |- ( ph -> [. A / x ]. ps ) $.
    $( Equality theorem for class substitution.  (Contributed by Mario
       Carneiro, 9-Feb-2017.)  (Revised by NM, 30-Jun-2018.) $)
    sbceq1dd $p |- ( ph -> [. B / x ]. ps ) $=
      ( wsbc sbceq1d mpbid ) ABCDHBCEHGABCDEFIJ $.
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( This is the closest we can get to ~ df-sbc if we start from ~ dfsbcq
       (see its comments) and ~ dfsbcq2 .  (Contributed by NM, 18-Nov-2008.)
       (Proof shortened by Andrew Salmon, 29-Jun-2011.)
       (Proof modification is discouraged.) $)
    sbc8g $p |- ( A e. V -> ( [. A / x ]. ph <-> A e. { x | ph } ) ) $=
      ( vy cv wsbc cab wcel dfsbcq eleq1 wsb df-clab weq wb equid dfsbcq2 ax-mp
      bitr2i vtoclbg ) ABEFZGZUAABHZIZABCGCUCIECDABUACJUACUCKUDABELZUBAEBMEENUE
      UBOEPABEUAQRST $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( The disjunction of two equivalences for class substitution does not
       require a class existence hypothesis.  This theorem tells us that there
       are only 2 possibilities for ` [ A / x ] ph ` behavior at proper
       classes, matching the ~ sbc5 (false) and ~ sbc6 (true) conclusions.
       This is interesting since ~ dfsbcq and ~ dfsbcq2 (from which it is
       derived) do not appear to say anything obvious about proper class
       behavior.  Note that this theorem doesn't tell us that it is always one
       or the other at proper classes; it could "flip" between false (the first
       disjunct) and true (the second disjunct) as a function of some other
       variable ` y ` that ` ph ` or ` A ` may contain.  (Contributed by NM,
       11-Oct-2004.)  (Proof modification is discouraged.) $)
    sbc2or $p |- ( ( [. A / x ]. ph <-> E. x ( x = A /\ ph ) ) \/
                  ( [. A / x ]. ph <-> A. x ( x = A -> ph ) ) ) $=
      ( vy cvv wcel wsbc cv wceq wa wex wb wi wal wo wsb weq wn mpbii con3i sb5
      dfsbcq2 eqeq2 anbi1d exbidv vtoclbg pm5.15 vex eleq1 adantr nexdv pm2.21d
      orcd alrimiv 2thd bibi2d orbi2d pm2.61i ) CEFZABCGZBHZCIZAJZBKZLZUTVBAMZB
      NZLZOZUSVEVHABDPBDQZAJZBKUTVDDCEABDCUBDHZCIZVKVCBVMVJVBAVLCVAUCUDUEABDUAU
      FUMUSRZVEUTVDRZLZOVIUTVDUGVNVPVHVEVNVOVGUTVNVOVGVNVCBVCUSVBUSAVBVAEFUSBUH
      VACEUISZUJTUKVNVFBVNVBAVBUSVQTULUNUOUPUQSUR $.
  $}

  $( Direct use of ~ df-sbc is allowed from here on. -NM $)

  $( By our definition of proper substitution, it can only be true if the
     substituted expression is a set.  (Contributed by Mario Carneiro,
     13-Oct-2016.) $)
  sbcex $p |- ( [. A / x ]. ph -> A e. _V ) $=
    ( wsbc cab wcel cvv df-sbc elex sylbi ) ABCDCABEZFCGFABCHCKIJ $.

  $( Equality theorem for class substitution.  Class version of ~ sbequ12 .
     (Contributed by NM, 26-Sep-2003.) $)
  sbceq1a $p |- ( x = A -> ( ph <-> [. A / x ]. ph ) ) $=
    ( wsb cv wceq wsbc sbid dfsbcq2 syl5bbr ) AABBDBECFABCGABHABBCIJ $.

  $( Equality theorem for class substitution.  Class version of ~ sbequ12r .
     (Contributed by NM, 4-Jan-2017.) $)
  sbceq2a $p |- ( A = x -> ( [. A / x ]. ph <-> ph ) ) $=
    ( cv wceq wsbc wb sbceq1a eqcoms bicomd ) CBDZEAABCFZALGKCABCHIJ $.

  ${
    $d ph y $.  $d A y $.  $d x y $.
    $( Specialization: if a formula is true for all sets, it is true for any
       class which is a set.  Similar to Theorem 6.11 of [Quine] p. 44.  See
       also ~ stdpc4 and ~ rspsbc .  (Contributed by NM, 16-Jan-2004.) $)
    spsbc $p |- ( A e. V -> ( A. x ph -> [. A / x ]. ph ) ) $=
      ( vy wal wsbc wi cv wceq wsb stdpc4 sbsbc sylib dfsbcq syl5ib vtocleg ) A
      BFZABCGZHECDRABEIZGZTCJSRABEKUAABELABEMNABTCOPQ $.

    spsbcd.1 $e |- ( ph -> A e. V ) $.
    spsbcd.2 $e |- ( ph -> A. x ps ) $.
    $( Specialization: if a formula is true for all sets, it is true for any
       class which is a set.  Similar to Theorem 6.11 of [Quine] p. 44.  See
       also ~ stdpc4 and ~ rspsbc .  (Contributed by Mario Carneiro,
       9-Feb-2017.) $)
    spsbcd $p |- ( ph -> [. A / x ]. ps ) $=
      ( wcel wal wsbc spsbc sylc ) ADEHBCIBCDJFGBCDEKL $.
  $}

  ${
    sbcth.1 $e |- ph $.
    $( A substitution into a theorem remains true (when ` A ` is a set).
       (Contributed by NM, 5-Nov-2005.) $)
    sbcth $p |- ( A e. V -> [. A / x ]. ph ) $=
      ( wcel wal wsbc ax-gen spsbc mpi ) CDFABGABCHABEIABCDJK $.
  $}

  ${
    $d x ph $.
    sbcthdv.1 $e |- ( ph -> ps ) $.
    $( Deduction version of ~ sbcth .  (Contributed by NM, 30-Nov-2005.)
       (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    sbcthdv $p |- ( ( ph /\ A e. V ) -> [. A / x ]. ps ) $=
      ( wal wcel wsbc alrimiv spsbc mpan9 ) ABCGDEHBCDIABCFJBCDEKL $.
  $}

  $( An identity theorem for substitution.  See ~ sbid .  (Contributed by Mario
     Carneiro, 18-Feb-2017.) $)
  sbcid $p |- ( [. x / x ]. ph <-> ph )
    $=
    ( cv wsbc wsb sbsbc sbid bitr3i ) ABBCDABBEAABBFABGH $.

  ${
    nfsbc1d.2 $e |- ( ph -> F/_ x A ) $.
    $( Deduction version of ~ nfsbc1 .  (Contributed by NM, 23-May-2006.)
       (Revised by Mario Carneiro, 12-Oct-2016.) $)
    nfsbc1d $p |- ( ph -> F/ x [. A / x ]. ps ) $=
      ( wsbc cab wcel df-sbc wnfc nfab1 a1i nfeld nfxfrd ) BCDFDBCGZHACBCDIACDO
      ECOJABCKLMN $.
  $}

  ${
    nfsbc1.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for class substitution.  (Contributed
       by Mario Carneiro, 12-Oct-2016.) $)
    nfsbc1 $p |- F/ x [. A / x ]. ph $=
      ( wsbc wnf wtru wnfc a1i nfsbc1d trud ) ABCEBFGABCBCHGDIJK $.
  $}

  ${
    $d x A $.
    $( Bound-variable hypothesis builder for class substitution.  (Contributed
       by Mario Carneiro, 12-Oct-2016.) $)
    nfsbc1v $p |- F/ x [. A / x ]. ph $=
      ( nfcv nfsbc1 ) ABCBCDE $.
  $}

  ${
    nfsbcd.1 $e |- F/ y ph $.
    nfsbcd.2 $e |- ( ph -> F/_ x A ) $.
    nfsbcd.3 $e |- ( ph -> F/ x ps ) $.
    $( Deduction version of ~ nfsbc .  (Contributed by NM, 23-Nov-2005.)
       (Revised by Mario Carneiro, 12-Oct-2016.) $)
    nfsbcd $p |- ( ph -> F/ x [. A / y ]. ps ) $=
      ( wsbc cab wcel df-sbc nfabd nfeld nfxfrd ) BDEIEBDJZKACBDELACEPGABCDFHMN
      O $.
  $}

  ${
    nfsbc.1 $e |- F/_ x A $.
    nfsbc.2 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for class substitution.  (Contributed
       by NM, 7-Sep-2014.)  (Revised by Mario Carneiro, 12-Oct-2016.) $)
    nfsbc $p |- F/ x [. A / y ]. ph $=
      ( wsbc wnf wtru nftru wnfc a1i nfsbcd trud ) ACDGBHIABCDCJBDKIELABHIFLMN
      $.
  $}

  ${
    $d x z $.  $d z A $.  $d y z ph $.
    $( A composition law for class substitution.  (Contributed by NM,
       26-Sep-2003.)  (Revised by Mario Carneiro, 13-Oct-2016.) $)
    sbcco $p |- ( [. A / y ]. [. y / x ]. ph <-> [. A / x ]. ph ) $=
      ( vz cv wsbc cvv wcel sbcex dfsbcq wsb sbsbc sbbii sbco2 3bitr3ri vtoclbg
      nfv bitri pm5.21nii ) ABCFGZCDGZDHIABDGZUACDJABDJUACEFZGZABUDGZUBUCEDHUAC
      UDDKABUDDKUEABELZUFABCLZCELUACELUGUEUHUACEABCMNABECACROUACEMPABEMSQT $.
  $}

  ${
    $d x y $.  $d y ph $.  $d A y $.
    sbcco2.1 $e |- ( x = y -> A = B ) $.
    $( A composition law for class substitution.  Importantly, ` x ` may occur
       free in the class expression substituted for ` A ` .  (Contributed by
       NM, 5-Sep-2004.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    sbcco2 $p |- ( [. x / y ]. [. B / x ]. ph <-> [. A / x ]. ph ) $=
      ( wsbc cv wsb sbsbc nfv weq wceq wb equcoms dfsbcq bicomd syl sbie bitr3i
      ) ABEGZCBHGUACBIABDGZUACBJUAUBCBUBCKCBLDEMZUAUBNUCBCFOUCUBUAABDEPQRST $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( An equivalence for class substitution.  (Contributed by NM,
       23-Aug-1993.)  (Revised by Mario Carneiro, 12-Oct-2016.) $)
    sbc5 $p |- ( [. A / x ]. ph <-> E. x ( x = A /\ ph ) ) $=
      ( vy wsbc cvv wcel cv wceq wex sbcex exsimpl isset sylibr wsb weq dfsbcq2
      wa eqeq2 anbi1d exbidv sb5 vtoclbg pm5.21nii ) ABCEZCFGZBHZCIZARZBJZABCKU
      JUHBJUFUHABLBCMNABDOBDPZARZBJUEUJDCFABDCQDHZCIZULUIBUNUKUHAUMCUGSTUAABDUB
      UCUD $.
  $}

  ${
    $d x y A $.
    $( An equivalence for class substitution.  (Contributed by NM,
       11-Oct-2004.)  (Proof shortened by Andrew Salmon, 8-Jun-2011.) $)
    sbc6g $p |- ( A e. V -> ( [. A / x ]. ph <-> A. x ( x = A -> ph ) ) ) $=
      ( wcel cv wceq wi wal wa wex wsbc nfe1 ceqex ceqsalg sbc5 syl6rbbr ) CDEB
      FCGZAHBIRAJZBKZABCLATBCDSBMABCNOABCPQ $.
  $}

  ${
    $d x A $.
    sbc6.1 $e |- A e. _V $.
    $( An equivalence for class substitution.  (Contributed by NM,
       23-Aug-1993.)  (Proof shortened by Eric Schmidt, 17-Jan-2007.) $)
    sbc6 $p |- ( [. A / x ]. ph <-> A. x ( x = A -> ph ) ) $=
      ( cvv wcel wsbc cv wceq wi wal wb sbc6g ax-mp ) CEFABCGBHCIAJBKLDABCEMN
      $.
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( An equivalence for class substitution in the spirit of ~ df-clab .  Note
       that ` x ` and ` A ` don't have to be distinct.  (Contributed by NM,
       18-Nov-2008.)  (Revised by Mario Carneiro, 13-Oct-2016.) $)
    sbc7 $p |- ( [. A / x ]. ph <-> E. y ( y = A /\ [. y / x ]. ph ) ) $=
      ( wsbc cv wceq wa wex sbcco sbc5 bitr3i ) ABDEABCFZEZCDEMDGNHCIABCDJNCDKL
      $.
  $}

  ${
    cbvsbc.1 $e |- F/ y ph $.
    cbvsbc.2 $e |- F/ x ps $.
    cbvsbc.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variables in a wff substitution.  (Contributed by Jeff
       Hankins, 19-Sep-2009.)  (Proof shortened by Andrew Salmon,
       8-Jun-2011.) $)
    cbvsbc $p |- ( [. A / x ]. ph <-> [. A / y ]. ps ) $=
      ( cab wcel wsbc cbvab eleq2i df-sbc 3bitr4i ) EACIZJEBDIZJACEKBDEKPQEABCD
      FGHLMACENBDENO $.
  $}

  ${
    $d y ph $.  $d x ps $.
    cbvsbcv.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change the bound variable of a class substitution using implicit
       substitution.  (Contributed by NM, 30-Sep-2008.)  (Revised by Mario
       Carneiro, 13-Oct-2016.) $)
    cbvsbcv $p |- ( [. A / x ]. ph <-> [. A / y ]. ps ) $=
      ( nfv cbvsbc ) ABCDEADGBCGFH $.
  $}

  ${
    $d x y A $.  $d y ps $.
    $( Conversion of implicit substitution to explicit class substitution,
       using a bound-variable hypothesis instead of distinct variables.
       (Closed theorem version of ~ sbciegf .)  (Contributed by NM,
       10-Nov-2005.)  (Revised by Mario Carneiro, 13-Oct-2016.) $)
    sbciegft $p |- ( ( A e. V /\ F/ x ps /\
            A. x ( x = A -> ( ph <-> ps ) ) ) -> ( [. A / x ]. ph <-> ps ) ) $=
      ( wcel wnf cv wceq wb wi wal w3a wsbc imim2i alimi biimpa sylan2 3adant1
      wa wex sbc5 bi1 imp3a 19.23t syl5bi bi2 com23 19.21t sbc6g sylibrd impbid
      3ad2ant1 ) DEFZBCGZCHDIZABJZKZCLZMZACDNZBVAUPATZCUAZUTBACDUBUOUSVCBKZUNUS
      UOVBBKZCLZVDURVECURUPABUQABKUPABUCOUDPUOVFVDVBBCUEQRSUFUTBUPAKZCLZVAUOUSB
      VHKZUNUSUOBVGKZCLZVIURVJCURUPBAUQBAKUPABUGOUHPUOVKVIBVGCUIQRSUNUOVAVHJUSA
      CDEUJUMUKUL $.
  $}

  ${
    $d x A $.
    sbciegf.1 $e |- F/ x ps $.
    sbciegf.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by NM, 14-Dec-2005.)  (Revised by Mario Carneiro,
       13-Oct-2016.) $)
    sbciegf $p |- ( A e. V -> ( [. A / x ]. ph <-> ps ) ) $=
      ( wcel wnf cv wceq wb wi wal wsbc ax-gen sbciegft mp3an23 ) DEHBCICJDKABL
      MZCNACDOBLFSCGPABCDEQR $.
  $}

  ${
    $d x A $.  $d x ps $.
    sbcieg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by NM, 10-Nov-2005.) $)
    sbcieg $p |- ( A e. V -> ( [. A / x ]. ph <-> ps ) ) $=
      ( nfv sbciegf ) ABCDEBCGFH $.
  $}

  ${
    $d x y $.  $d A y $.  $d ch y $.  $d ph y $.  $d ps x $.
    sbcie2g.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    sbcie2g.2 $e |- ( y = A -> ( ps <-> ch ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       This version of ~ sbcie avoids a disjointness condition on ` x , A ` by
       substituting twice.  (Contributed by Mario Carneiro, 15-Oct-2016.) $)
    sbcie2g $p |- ( A e. V -> ( [. A / x ]. ph <-> ch ) ) $=
      ( cv wsbc dfsbcq wsb sbsbc nfv sbie bitr3i vtoclbg ) ADEJZKZBADFKCEFGADSF
      LITADEMBADENABDEBDOHPQR $.
  $}

  ${
    $d x A $.  $d x ps $.
    sbcie.1 $e |- A e. _V $.
    sbcie.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by NM, 4-Sep-2004.) $)
    sbcie $p |- ( [. A / x ]. ph <-> ps ) $=
      ( cvv wcel wsbc wb sbcieg ax-mp ) DGHACDIBJEABCDGFKL $.
  $}

  ${
    $d x A $.
    sbcied.1 $e |- ( ph -> A e. V ) $.
    sbcied.2 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    ${
      sbciedf.3 $e |- F/ x ph $.
      sbciedf.4 $e |- ( ph -> F/ x ch ) $.
      $( Conversion of implicit substitution to explicit class substitution,
         deduction form.  (Contributed by NM, 29-Dec-2014.) $)
      sbciedf $p |- ( ph -> ( [. A / x ]. ps <-> ch ) ) $=
        ( wcel wnf cv wceq wb wi wal wsbc ex alrimi sbciegft syl3anc ) AEFKCDLD
        MENZBCOZPZDQBDERCOGJAUEDIAUCUDHSTBCDEFUAUB $.
    $}

    $d x ph $.  $d x ch $.
    $( Conversion of implicit substitution to explicit class substitution,
       deduction form.  (Contributed by NM, 13-Dec-2014.) $)
    sbcied $p |- ( ph -> ( [. A / x ]. ps <-> ch ) ) $=
      ( nfv nfvd sbciedf ) ABCDEFGHADIACDJK $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x ch $.
    sbcied2.1 $e |- ( ph -> A e. V ) $.
    sbcied2.2 $e |- ( ph -> A = B ) $.
    sbcied2.3 $e |- ( ( ph /\ x = B ) -> ( ps <-> ch ) ) $.
    $( Conversion of implicit substitution to explicit class substitution,
       deduction form.  (Contributed by NM, 13-Dec-2014.) $)
    sbcied2 $p |- ( ph -> ( [. A / x ]. ps <-> ch ) ) $=
      ( cv wceq wb id sylan9eqr syldan sbcied ) ABCDEGHADKZELZRFLBCMSAREFSNIOJP
      Q $.
  $}

  ${
    $d y A $.  $d y B $.  $d y ph $.  $d x y $.
    elrabsf.1 $e |- F/_ x B $.
    $( Membership in a restricted class abstraction, expressed with explicit
       class substitution.  (The variation ~ elrabf has implicit
       substitution).  The hypothesis specifies that ` x ` must not be a free
       variable in ` B ` .  (Contributed by NM, 30-Sep-2003.)  (Proof shortened
       by Mario Carneiro, 13-Oct-2016.) $)
    elrabsf $p |- ( A e. { x e. B | ph }
          <-> ( A e. B /\ [. A / x ]. ph ) ) $=
      ( vy cv wsbc crab dfsbcq nfcv nfv nfsbc1v sbceq1a cbvrab elrab2 ) ABFGZHZ
      ABCHFCDABDIABQCJARBFDEFDKAFLABQMABQNOP $.
  $}

  ${
    $d x y B $.  $d y A $.
    $( Substitution applied to an atomic wff.  Set theory version of ~ eqsb3 .
       (Contributed by Andrew Salmon, 29-Jun-2011.) $)
    eqsbc3 $p |- ( A e. V -> ( [. A / x ]. x = B <-> A = B ) ) $=
      ( vy cv wceq wsbc dfsbcq eqeq1 wsb sbsbc eqsb3 bitr3i vtoclbg ) AFCGZAEFZ
      HZQCGZPABHBCGEBDPAQBIQBCJRPAEKSPAELEACMNO $.
  $}

  ${
    $d x y $.  $d y A $.  $d y ph $.  $d y ps $.
    $( Move negation in and out of class substitution.  (Contributed by NM,
       16-Jan-2004.) $)
    sbcng $p |- ( A e. V -> ( [. A / x ]. -. ph <-> -. [. A / x ]. ph ) ) $=
      ( vy wn wsb wsbc dfsbcq2 cv wceq notbid sbn vtoclbg ) AFZBEGABEGZFOBCHABC
      HZFECDOBECIEJCKPQABECILABEMN $.

    $( Distribution of class substitution over implication.  (Contributed by
       NM, 16-Jan-2004.) $)
    sbcimg $p |- ( A e. V ->
     ( [. A / x ]. ( ph -> ps ) <-> ( [. A / x ]. ph -> [. A / x ]. ps ) ) ) $=
      ( vy wi wsb wsbc dfsbcq2 cv wceq imbi12d sbim vtoclbg ) ABGZCFHACFHZBCFHZ
      GPCDIACDIZBCDIZGFDEPCFDJFKDLQSRTACFDJBCFDJMABCFNO $.

    $( Distribution of class substitution over conjunction.  (Contributed by
       NM, 31-Dec-2016.)  (Revised by NM, 17-Aug-2018.) $)
    sbcan $p |- ( [. A / x ]. ( ph /\ ps )
        <-> ( [. A / x ]. ph /\ [. A / x ]. ps ) ) $=
      ( vy wa wsbc cvv wcel sbcex adantl dfsbcq2 cv wceq anbi12d sban pm5.21nii
      wsb vtoclbg ) ABFZCDGZDHIZACDGZBCDGZFZTCDJUDUBUCBCDJKTCERACERZBCERZFUAUEE
      DHTCEDLEMDNUFUCUGUDACEDLBCEDLOABCEPSQ $.

    $( Distribution of class substitution over conjunction.  (Contributed by
       NM, 21-May-2004.)  Obsolete as of 17-Aug-2018.  Use ~ sbcan instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcangOLD $p |- ( A e. V ->
     ( [. A / x ]. ( ph /\ ps ) <-> ( [. A / x ]. ph /\ [. A / x ]. ps ) ) ) $=
      ( vy wa wsb wsbc dfsbcq2 cv wceq anbi12d sban vtoclbg ) ABGZCFHACFHZBCFHZ
      GPCDIACDIZBCDIZGFDEPCFDJFKDLQSRTACFDJBCFDJMABCFNO $.

    $( Distribution of class substitution over disjunction.  (Contributed by
       NM, 31-Dec-2016.)  (Revised by NM, 17-Aug-2018.) $)
    sbcor $p |- ( [. A / x ]. ( ph \/ ps )
         <-> ( [. A / x ]. ph \/ [. A / x ]. ps ) ) $=
      ( vy wo wsbc cvv wcel sbcex jaoi wsb dfsbcq2 cv wceq orbi12d sbor vtoclbg
      pm5.21nii ) ABFZCDGZDHIZACDGZBCDGZFZTCDJUCUBUDACDJBCDJKTCELACELZBCELZFUAU
      EEDHTCEDMENDOUFUCUGUDACEDMBCEDMPABCEQRS $.

    $( Distribution of class substitution over disjunction.  (Contributed by
       NM, 21-May-2004.)  Obsolete as of 17-Aug-2018.  Use ~ sbcor instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcorgOLD $p |- ( A e. V ->
     ( [. A / x ]. ( ph \/ ps ) <-> ( [. A / x ]. ph \/ [. A / x ]. ps ) ) ) $=
      ( vy wo wsb wsbc dfsbcq2 cv wceq orbi12d sbor vtoclbg ) ABGZCFHACFHZBCFHZ
      GPCDIACDIZBCDIZGFDEPCFDJFKDLQSRTACFDJBCFDJMABCFNO $.

    $( Distribution of class substitution over biconditional.  (Contributed by
       Raph Levien, 10-Apr-2004.) $)
    sbcbig $p |- ( A e. V ->
   ( [. A / x ]. ( ph <-> ps ) <-> ( [. A / x ]. ph <-> [. A / x ]. ps ) ) ) $=
      ( vy wb wsb wsbc dfsbcq2 cv wceq bibi12d sbbi vtoclbg ) ABGZCFHACFHZBCFHZ
      GPCDIACDIZBCDIZGFDEPCFDJFKDLQSRTACFDJBCFDJMABCFNO $.
  $}

  $( Move negation in and out of class substitution.  One direction of ~ sbcng
     that holds for proper classes.  (Contributed by NM, 17-Aug-2018.) $)
  sbcn1 $p |- ( [. A / x ]. -. ph -> -. [. A / x ]. ph ) $=
    ( cvv wcel wn wsbc sbcex sbcng biimpd mpcom ) CDEZAFZBCGZABCGFZMBCHLNOABCDI
    JK $.

  $( Distribution of class substitution over implication.  One direction of
     ~ sbcimg that holds for proper classes.  (Contributed by NM,
     17-Aug-2018.) $)
  sbcim1 $p |- ( [. A / x ]. ( ph -> ps )
          -> ( [. A / x ]. ph -> [. A / x ]. ps ) ) $=
    ( cvv wcel wi wsbc sbcex sbcimg biimpd mpcom ) DEFZABGZCDHZACDHBCDHGZNCDIMO
    PABCDEJKL $.

  $( Distribution of class substitution over biconditional.  One direction of
     ~ sbcbig that holds for proper classes.  (Contributed by NM,
     17-Aug-2018.) $)
  sbcbi1 $p |- ( [. A / x ]. ( ph <-> ps )
       -> ( [. A / x ]. ph <-> [. A / x ]. ps ) ) $=
    ( cvv wcel wb wsbc sbcex sbcbig biimpd mpcom ) DEFZABGZCDHZACDHBCDHGZNCDIMO
    PABCDEJKL $.

  ${
    $d x z A $.  $d x y z $.  $d z ph $.
    $( Move universal quantifier in and out of class substitution.
       (Contributed by NM, 31-Dec-2016.)  (Revised by NM, 18-Aug-2018.) $)
    sbcal $p |- ( [. A / y ]. A. x ph <-> A. x [. A / y ]. ph ) $=
      ( vz wal wsbc cvv wcel sbcex sps dfsbcq2 cv wceq albidv vtoclbg pm5.21nii
      wsb sbal ) ABFZCDGZDHIZACDGZBFZTCDJUCUBBACDJKTCERACERZBFUAUDEDHTCEDLEMDNU
      EUCBACEDLOABCESPQ $.

    $( Move universal quantifier in and out of class substitution.
       (Contributed by NM, 16-Jan-2004.)  Obsolete as of 17-Aug-2018.  Use
       ~ sbcal instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbcalgOLD $p |- ( A e. V
        -> ( [. A / y ]. A. x ph <-> A. x [. A / y ]. ph ) ) $=
      ( vz wal wsb wsbc dfsbcq2 cv wceq albidv sbal vtoclbg ) ABGZCFHACFHZBGPCD
      IACDIZBGFDEPCFDJFKDLQRBACFDJMABCFNO $.

    $( Move existential quantifier in and out of class substitution.
       (Contributed by NM, 21-May-2004.)  (Revised by NM, 18-Aug-2018.) $)
    sbcex2 $p |- ( [. A / y ]. E. x ph <-> E. x [. A / y ]. ph ) $=
      ( vz wex wsbc cvv wcel sbcex exlimiv wsb dfsbcq2 wceq exbidv sbex vtoclbg
      cv pm5.21nii ) ABFZCDGZDHIZACDGZBFZTCDJUCUBBACDJKTCELACELZBFUAUDEDHTCEDME
      RDNUEUCBACEDMOABCEPQS $.

    $( Move existential quantifier in and out of class substitution.
       (Contributed by NM, 21-May-2004.)  Obsolete as of 17-Aug-2018.  Use
       ~ sbcex instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbcexgOLD $p |- ( A e. V
         -> ( [. A / y ]. E. x ph <-> E. x [. A / y ]. ph ) ) $=
      ( vz wex wsb wsbc dfsbcq2 cv wceq exbidv sbex vtoclbg ) ABGZCFHACFHZBGPCD
      IACDIZBGFDEPCFDJFKDLQRBACFDJMABCFNO $.
  $}

  ${
    $d x B $.  $d x A $.
    $( Set theory version of ~ sbeqal1 .  (Contributed by Andrew Salmon,
       28-Jun-2011.) $)
    sbceqal $p |- ( A e. V -> ( A. x ( x = A -> x = B ) -> A = B ) ) $=
      ( wcel cv wceq wi wal wsbc spsbc sbcimg wb eqsbc3 mpbiri pm5.5 syl 3bitrd
      eqid sylibd ) BDEZAFZBGZUBCGZHZAIUEABJZBCGZUEABDKUAUFUCABJZUDABJZHZUIUGUC
      UDABDLUAUHUJUIMUAUHBBGBSABBDNOUHUIPQABCDNRT $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Theorem *14.121 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 28-Jun-2011.)  (Proof shortened by Wolf Lammen, 9-May-2013.) $)
    sbeqalb $p |- ( A e. V -> ( ( A. x ( ph <-> x = A ) /\ A. x ( ph <->
      x = B ) ) -> A = B ) ) $=
      ( cv wceq wb wal wa wi wcel bibi1 biimpa biimpd alanimi sbceqal syl5 ) AB
      FZCGZHZBIASDGZHZBIJTUBKZBICELCDGUAUCUDBUAUCJTUBUAUCTUBHATUBMNOPBCDEQR $.
  $}

  ${
    sbcbid.1 $e |- F/ x ph $.
    sbcbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building deduction rule for class substitution.  (Contributed by
       NM, 29-Dec-2014.) $)
    sbcbid $p |- ( ph -> ( [. A / x ]. ps <-> [. A / x ]. ch ) ) $=
      ( cab wcel wsbc abbid eleq2d df-sbc 3bitr4g ) AEBDHZIECDHZIBDEJCDEJAOPEAB
      CDFGKLBDEMCDEMN $.
  $}

  ${
    $d x ph $.
    sbcbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building deduction rule for class substitution.  (Contributed by
       NM, 29-Dec-2014.) $)
    sbcbidv $p |- ( ph -> ( [. A / x ]. ps <-> [. A / x ]. ch ) ) $=
      ( nfv sbcbid ) ABCDEADGFH $.
  $}

  ${
    sbcbii.1 $e |- ( ph <-> ps ) $.
    $( Formula-building inference rule for class substitution.  (Contributed by
       NM, 11-Nov-2005.) $)
    sbcbii $p |- ( [. A / x ]. ph <-> [. A / x ]. ps ) $=
      ( wsbc wb wtru a1i sbcbidv trud ) ACDFBCDFGHABCDABGHEIJK $.

    $( Formula-building inference rule for class substitution.  (Contributed by
       NM, 11-Nov-2005.)  Obsolete as of 17-Aug-2018.  Use ~ sbcbii instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcbiiOLD $p |- ( A e. V -> ( [. A / x ]. ph <-> [. A / x ]. ps ) ) $=
      ( wsbc wb wcel sbcbii a1i ) ACDGBCDGHDEIABCDFJK $.
  $}

  ${
    $d x A $.  $d x B $.
    $( ~ eqsbc3 with set variable on right side of equals sign.  This proof was
       automatically generated from the virtual deduction proof ~ eqsbc3rVD
       using a translation program.  (Contributed by Alan Sare,
       24-Oct-2011.) $)
    eqsbc3r $p |- ( A e. V -> ( [. A / x ]. B = x <-> B = A ) ) $=
      ( wcel wceq wsbc eqcom sbcbii biimpi eqsbc3 syl5ib syl6ib syl6ibr sylibrd
      cv idd impbid ) BDEZCAPZFZABGZCBFZSUBBCFZUCUBTCFZABGZSUDUBUFUAUEABCTHIZJA
      BCDKZLBCHZMSUCUFUBSUCUDUFSUCUCUDSUCQUINUHOUGNR $.
  $}

  $( Distribution of class substitution over triple conjunction.  (Contributed
     by NM, 14-Dec-2006.)  (Revised by NM, 17-Aug-2018.) $)
  sbc3an $p |- ( [. A / x ]. ( ph /\ ps /\ ch ) <->
              ( [. A / x ]. ph /\ [. A / x ]. ps /\ [. A / x ]. ch ) ) $=
    ( w3a wsbc wa df-3an sbcbii sbcan anbi1i 3bitri bitr4i ) ABCFZDEGZADEGZBDEG
    ZHZCDEGZHZQRTFPABHZCHZDEGUBDEGZTHUAOUCDEABCIJUBCDEKUDSTABDEKLMQRTIN $.

  ${
    $d y ch $.  $d y ps $.  $d y ph $.  $d y A $.  $d x y $.
    $( Distribution of class substitution over triple conjunction.
       (Contributed by NM, 14-Dec-2006.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.)  Obsolete as of 17-Aug-2018.  Use ~ sbc3an instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbc3angOLD $p |- ( A e. V -> ( [. A / x ]. ( ph /\ ps /\ ch ) <->
                ( [. A / x ]. ph /\ [. A / x ]. ps /\ [. A / x ]. ch ) ) ) $=
      ( vy w3a wsb wsbc dfsbcq2 cv wceq 3anbi123d sb3an vtoclbg ) ABCHZDGIADGIZ
      BDGIZCDGIZHQDEJADEJZBDEJZCDEJZHGEFQDGEKGLEMRUASUBTUCADGEKBDGEKCDGEKNABCDG
      OP $.
  $}

  ${
    $d y z A $.  $d x y B $.
    $( Class substitution into a membership relation.  (Contributed by NM,
       17-Aug-2018.) $)
    sbcel1v $p |- ( [. A / x ]. x e. B <-> A e. B ) $=
      ( vy wcel wsbc cvv sbcex elex wsb dfsbcq2 eleq1 clelsb3 vtoclbg pm5.21nii
      cv ) APCEZABFZBGEBCEZQABHBCIQADJDPZCERSDBGQADBKTBCLDACMNO $.
  $}

  ${
    $d y z A $.  $d x y B $.
    $( Class substitution into a membership relation.  (Contributed by NM,
       17-Nov-2006.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.)
       Obsolete as of 17-Aug-2018.  Use ~ sbcel1v instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcel1gvOLD $p |- ( A e. V -> ( [. A / x ]. x e. B <-> A e. B ) ) $=
      ( vy cv wcel wsb wsbc dfsbcq2 eleq1 clelsb3 vtoclbg ) AFCGZAEHEFZCGNABIBC
      GEBDNAEBJOBCKEACLM $.
  $}

  ${
    $d y z B $.  $d x y A $.
    $( Class substitution into a membership relation.  (Contributed by NM,
       17-Nov-2006.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    sbcel2gv $p |- ( B e. V -> ( [. B / x ]. A e. x <-> A e. B ) ) $=
      ( vy cv wcel eleq2 sbcie2g ) BAFZGBEFZGBCGAECDJKBHKCBHI $.

    $( Class substitution into a membership relation.  One direction of
       ~ sbcel2gv that holds for proper classes.  (Contributed by NM,
       17-Aug-2018.) $)
    sbcel21v $p |- ( [. B / x ]. A e. x -> A e. B ) $=
      ( cvv wcel cv wsbc sbcex sbcel2gv biimpd mpcom ) CDEZBAFEZACGZBCEZMACHLNO
      ABCDIJK $.
  $}

  ${
    $d x ph $.
    sbcimdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Substitution analog of Theorem 19.20 of [Margaris] p. 90.  (Contributed
       by NM, 11-Nov-2005.) $)
    sbcimdv $p |- ( ph -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) $=
      ( cvv wcel wsbc wi wal alrimiv spsbc sbcim1 syl56 sbcex con3i pm2.21d a1d
      wn pm2.61i ) EGHZABDEIZCDEIZJZJABCJZDKUBUFDEIUEAUFDFLUFDEGMBCDENOUBTZUEAU
      GUCUDUCUBBDEPQRSUA $.

    $( Substitution analog of Theorem 19.20 of [Margaris] p. 90.  (Contributed
       by NM, 11-Nov-2005.)  Obsolete as of 17-Aug-2018.  Use ~ sbcimdv
       instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbcimdvOLD $p |- ( ( ph /\ A e. V ) ->
          ( [. A / x ]. ps -> [. A / x ]. ch ) ) $=
      ( wcel wsbc wi wal alrimiv spsbc syl5 sbcimg sylibd impcom ) EFHZABDEICDE
      IJZRABCJZDEIZSATDKRUAATDGLTDEFMNBCDEFOPQ $.
  $}

  ${
    $d x y $.  $d y A $.  $d y ph $.
    $( Substitution for a variable not free in a wff does not affect it.
       (Contributed by Mario Carneiro, 14-Oct-2016.) $)
    sbctt $p |- ( ( A e. V /\ F/ x ph ) -> ( [. A / x ]. ph <-> ph ) ) $=
      ( vy wcel wnf wsbc wb wsb wi wceq dfsbcq2 bibi1d imbi2d sbft vtoclg imp
      cv ) CDFABGZABCHZAIZTABEJZAIZKTUBKECDESCLZUDUBTUEUCUAAABECMNOABEPQR $.
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    sbcgf.1 $e |- F/ x ph $.
    $( Substitution for a variable not free in a wff does not affect it.
       (Contributed by NM, 11-Oct-2004.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    sbcgf $p |- ( A e. V -> ( [. A / x ]. ph <-> ph ) ) $=
      ( wcel wnf wsbc wb sbctt mpan2 ) CDFABGABCHAIEABCDJK $.

    $( Substitution for a variable not free in antecedent affects only the
       consequent.  (Contributed by NM, 11-Oct-2004.) $)
    sbc19.21g $p |- ( A e. V ->
            ( [. A / x ]. ( ph -> ps ) <-> ( ph -> [. A / x ]. ps ) ) ) $=
      ( wcel wi wsbc sbcimg sbcgf imbi1d bitrd ) DEGZABHCDIACDIZBCDIZHAPHABCDEJ
      NOAPACDEFKLM $.
  $}

  ${
    $d x ph $.
    $( Substitution for a variable not occurring in a wff does not affect it.
       Distinct variable form of ~ sbcgf .  (Contributed by Alan Sare,
       10-Nov-2012.) $)
    sbcg $p |- ( A e. V -> ( [. A / x ]. ph <-> ph ) ) $=
      ( nfv sbcgf ) ABCDABEF $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x V $.  $d y W $.
    sbc2iegf.1 $e |- F/ x ps $.
    sbc2iegf.2 $e |- F/ y ps $.
    sbc2iegf.3 $e |- F/ x B e. W $.
    sbc2iegf.4 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by Mario Carneiro, 19-Dec-2013.) $)
    sbc2iegf $p |- ( ( A e. V /\ B e. W ) ->
            ( [. A / x ]. [. B / y ]. ph <-> ps ) ) $=
      ( wcel wa simpl cv wceq wb adantll nfv wsbc wnf a1i sbciedf nfan ) EGMZFH
      MZNZADFUAZBCEGUFUGOUGCPEQZUIBRUFUGUJNZABDFHUGUJOUJDPFQABRUGLSUKDTBDUBUKJU
      CUDSUFUGCUFCTKUEBCUBUHIUCUD $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ps $.
    sbc2ie.1 $e |- A e. _V $.
    sbc2ie.2 $e |- B e. _V $.
    sbc2ie.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by NM, 16-Dec-2008.)  (Revised by Mario Carneiro,
       19-Dec-2013.) $)
    sbc2ie $p |- ( [. A / x ]. [. B / y ]. ph <-> ps ) $=
      ( cvv wcel wsbc wb nfv nfth sbc2iegf mp2an ) EJKFJKZADFLCELBMGHABCDEFJJBC
      NBDNRCHOIPQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ph $.  $d x y ch $.
    sbc2iedv.1 $e |- A e. _V $.
    sbc2iedv.2 $e |- B e. _V $.
    sbc2iedv.3 $e |- ( ph -> ( ( x = A /\ y = B ) -> ( ps <-> ch ) ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by NM, 16-Dec-2008.)  (Proof shortened by Mario Carneiro,
       18-Oct-2016.) $)
    sbc2iedv $p |- ( ph -> ( [. A / x ]. [. B / y ]. ps <-> ch ) ) $=
      ( wsbc cvv wcel a1i cv wceq wa wb impl sbcied ) ABEGKCDFLFLMAHNADOFPZQZBC
      EGLGLMUBINAUAEOGPBCRJSTT $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.  $d x y z ps $.
    sbc3ie.1 $e |- A e. _V $.
    sbc3ie.2 $e |- B e. _V $.
    sbc3ie.3 $e |- C e. _V $.
    sbc3ie.4 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by Mario Carneiro, 19-Jun-2014.)  (Revised by Mario
       Carneiro, 29-Dec-2014.) $)
    sbc3ie $p |- ( [. A / x ]. [. B / y ]. [. C / z ]. ph <-> ps ) $=
      ( wsbc cv wceq wa cvv wcel a1i wb 3expa sbcied sbc2ie ) AEHMBCDFGIJCNFOZD
      NGOZPZABEHQHQRUFKSUDUEENHOABTLUAUBUC $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y V $.  $d x W $.
    $( Lemma for ~ sbccom .  (Contributed by NM, 14-Nov-2005.)  (Revised by
       Mario Carneiro, 18-Oct-2016.) $)
    sbccomlem $p |- ( [. A / x ]. [. B / y ]. ph
         <-> [. B / y ]. [. A / x ]. ph ) $=
      ( cv wceq wa wex wsbc excom exdistr an12 exbii bitri 3bitr3i sbc5 3bitr4i
      19.42v sbcbii ) CFEGZAHZCIZBDJZBFDGZAHZBIZCEJZACEJZBDJABDJZCEJUEUCHBIZUAU
      GHZCIZUDUHUEUBHZCIBIUNBIZCIUKUMUNBCKUEUBBCLUOULCUOUAUFHZBIULUNUPBUEUAAMNU
      AUFBSONPUCBDQUGCEQRUIUCBDACEQTUJUGCEABDQTR $.
  $}

  ${
    $d w y z A $.  $d w x z B $.  $d w z ph $.  $d x y $.
    $( Commutative law for double class substitution.  (Contributed by NM,
       15-Nov-2005.)  (Proof shortened by Mario Carneiro, 18-Oct-2016.) $)
    sbccom $p |- ( [. A / x ]. [. B / y ]. ph
          <-> [. B / y ]. [. A / x ]. ph ) $=
      ( vw vz cv wsbc sbccomlem sbcbii bitri 3bitr3i sbcco ) ACFHZIZFEIZBDIZABG
      HZIZGDIZCEIZACEIZBDIABDIZCEIQBSIZGDIZUACOIZFEIZRUBTCOIZFEIZGDIUIGDIZFEIUF
      UHUIGFDEJUJUEGDUJPBSIZFEIUEUIULFEACBOSJKPFBESJLKUKUGFETGCDOJKMQBGDNUACFEN
      MQUCBDACFENKUAUDCEABGDNKM $.
  $}

  ${
    $d x y z $.  $d A z $.  $d B x z $.  $d V z $.  $d ph z $.
    $( Interchange class substitution and restricted quantifier.  (Contributed
       by NM, 1-Mar-2008.)  (Revised by David Abernethy, 22-Feb-2010.) $)
    sbcralt $p |- ( ( A e. V /\ F/_ y A ) ->
           ( [. A / x ]. A. y e. B ph <-> A. y e. B [. A / x ]. ph ) ) $=
      ( vz wral wsbc cv wcel wnfc wa sbcco simpl wsb wceq sbsbc nfcv wb sbequ12
      nfs1v nfral weq ralbidv bitr3i nfnfc1 nfcvd id nfeqd nfan1 dfsbcq2 adantl
      sbie ralbid adantll syl5bb sbcied syl5bbr ) ACEHZBDIUTBGJZIZGDIDFKZCDLZMZ
      ABDIZCEHZUTBGDNVEVBVGGDFVCVDOVBABGPZCEHZVEVADQZMVGVBUTBGPVIUTBGRUTVIBGVHB
      CEBESABGUBUCBGUDAVHCEABGUAUEUNUFVDVJVIVGTVCVDVJMVHVFCEVDVJCCDUGVDCVADVDCV
      AUHVDUIUJUKVJVHVFTVDABGDULUMUOUPUQURUS $.

    $( Interchange class substitution and restricted existential quantifier.
       (Contributed by NM, 1-Mar-2008.)  (Proof shortened by Mario Carneiro,
       13-Oct-2016.)  Obsolete as of 18-Aug-2018.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbcrextOLD $p |- ( ( A e. V /\ F/_ y A ) ->
          ( [. A / x ]. E. y e. B ph <-> E. y e. B [. A / x ]. ph ) ) $=
      ( wcel cvv wnfc wrex wsbc wb elex wa wn wral sbcng adantr bitrd dfrex2 id
      sbcralt nfnfc1 nfcvd nfeld nfan1 adantl ralbid ancoms notbid sbcbii sylan
      3bitr4g ) DFGDHGZCDIZACEJZBDKZABDKZCEJZLDFMUNUONZAOZCEPZOZBDKZUROZCEPZOZU
      QUSUTVDVBBDKZOZVGUNVDVILUOVBBDHQRUTVHVFUTVHVABDKZCEPZVFVABCDEHUBUOUNVKVFL
      UOUNNVJVECEUOUNCCDUCUOCDHUOUAUOCHUDUEUFUNVJVELUOABDHQUGUHUISUJSUPVCBDACET
      UKURCETUMUL $.

    $( Interchange class substitution and restricted existential quantifier.
       (Contributed by NM, 1-Mar-2008.)  (Proof shortened by Mario Carneiro,
       13-Oct-2016.)  (Revised by NM, 18-Aug-2018.) $)
    sbcrext $p |- ( F/_ y A ->
          ( [. A / x ]. E. y e. B ph <-> E. y e. B [. A / x ]. ph ) ) $=
      ( cvv wcel wnfc wrex wsbc wb wa wn wral sbcng adantr sbcralt bitrd dfrex2
      sbcex nfnfc1 nfcvd nfeld nfan1 adantl ralbid ancoms notbid sbcbii 3bitr4g
      id con3i cv wi a1ii rexlimd2 con3rr3 imp 2falsed pm2.61ian ) DFGZCDHZACEI
      ZBDJZABDJZCEIZKVAVBLZAMZCENZMZBDJZVEMZCENZMZVDVFVGVKVIBDJZMZVNVAVKVPKVBVI
      BDFOPVGVOVMVGVOVHBDJZCENZVMVHBCDEFQVBVAVRVMKVBVALVQVLCEVBVACCDUAZVBCDFVBU
      KVBCFUBUCZUDVAVQVLKVBABDFOUEUFUGRUHRVCVJBDACESUIVECESUJVAMZVBLVDVFWAVDMVB
      VDVAVCBDTULPWAVBVFMVBVFVAVBVEVACEVSVTVBCUMEGVEVAUNABDTUOUPUQURUSUT $.
  $}

  ${
    $d y z A $.  $d x B $.  $d x y z $.  $d ph z $.  $d B z $.
    $( Interchange class substitution and restricted quantifier.  (Contributed
       by NM, 15-Nov-2005.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    sbcralg $p |- ( A e. V ->
                 ( [. A / x ]. A. y e. B ph <-> A. y e. B [. A / x ]. ph ) ) $=
      ( wcel wnfc wral wsbc wb nfcv sbcralt mpan2 ) DFGCDHACEIBDJABDJCEIKCDLABC
      DEFMN $.

    $( Interchange class substitution and restricted existential quantifier.
       (Contributed by NM, 15-Nov-2005.)  (Revised by NM, 18-Aug-2018.) $)
    sbcrex $p |- ( [. A / x ]. E. y e. B ph <-> E. y e. B [. A / x ]. ph ) $=
      ( wnfc wrex wsbc wb nfcv sbcrext ax-mp ) CDFACEGBDHABDHCEGICDJABCDEKL $.

    $( Interchange class substitution and restricted existential quantifier.
       (Contributed by NM, 15-Nov-2005.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.)  Obsolete as of 18-Aug-2018.  Use ~ sbcrex instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcrexgOLD $p |- ( A e. V ->
                 ( [. A / x ]. E. y e. B ph <-> E. y e. B [. A / x ]. ph ) ) $=
      ( vz wrex wsb wsbc dfsbcq2 wceq rexbidv nfcv nfs1v nfrex weq sbequ12 sbie
      cv vtoclbg ) ACEHZBGIABGIZCEHZUBBDJABDJZCEHGDFUBBGDKGTDLUCUECEABGDKMUBUDB
      GUCBCEBENABGOPBGQAUCCEABGRMSUA $.

    $( Interchange class substitution and restricted uniqueness quantifier.
       (Contributed by NM, 24-Feb-2013.)  (Revised by NM, 18-Aug-2018.) $)
    sbcreu $p |- ( [. A / x ]. E! y e. B ph <-> E! y e. B [. A / x ]. ph ) $=
      ( vz wreu wsbc cvv wcel sbcex reurex rexlimivw syl wsb dfsbcq2 cv reubidv
      wrex wceq nfcv nfs1v nfreu weq sbequ12 sbie vtoclbg pm5.21nii ) ACEGZBDHZ
      DIJZABDHZCEGZUIBDKUMULCESUKULCELULUKCEABDKMNUIBFOABFOZCEGZUJUMFDIUIBFDPFQ
      DTUNULCEABFDPRUIUOBFUNBCEBEUAABFUBUCBFUDAUNCEABFUERUFUGUH $.

    $( Interchange class substitution and restricted uniqueness quantifier.
       (Contributed by NM, 24-Feb-2013.)  Obsolete as of 18-Aug-2018.  Use
       ~ sbcreu instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbcreugOLD $p |- ( A e. V ->
                 ( [. A / x ]. E! y e. B ph <-> E! y e. B [. A / x ]. ph ) ) $=
      ( vz wreu wsb wsbc dfsbcq2 wceq reubidv nfcv nfs1v nfreu weq sbequ12 sbie
      cv vtoclbg ) ACEHZBGIABGIZCEHZUBBDJABDJZCEHGDFUBBGDKGTDLUCUECEABGDKMUBUDB
      GUCBCEBENABGOPBGQAUCCEABGRMSUA $.
  $}

  ${
    $d y w A $.  $d w z B $.  $d w ph $.  $d x y $.  $d w x z $.
    sbcabel.1 $e |- F/_ x B $.
    $( Interchange class substitution and class abstraction.  (Contributed by
       NM, 5-Nov-2005.) $)
    sbcabel $p |- ( A e. V -> ( [. A / x ]. { y | ph } e. B <->
                  { y | [. A / x ]. ph } e. B ) ) $=
      ( vw wcel cvv cab wsbc wb cv wceq wa wex wal syl5bb abeq2 elex sbcan sbcg
      sbcex2 sbcal sbcbig bibi1d bitrd albidv sbcbii 3bitr4g nfcri sbcgf exbidv
      anbi12d df-clel syl ) DFIDJIZACKZEIZBDLZABDLZCKZEIZMDFUAURHNZUSOZVEEIZPZH
      QZBDLZVEVCOZVGPZHQZVAVDVJVHBDLZHQURVMVHHBDUDURVNVLHVNVFBDLZVGBDLZPURVLVFV
      GBDUBURVOVKVPVGURCNVEIZAMZCRZBDLZVQVBMZCRZVOVKVTVRBDLZCRURWBVRCBDUEURWCWA
      CURWCVQBDLZVBMWAVQABDJUFURWDVQVBVQBDJUCUGUHUISVFVSBDACVETUJVBCVETUKVGBDJB
      HEGULUMUOSUNSUTVIBDHUSEUPUJHVCEUPUKUQ $.
  $}

  ${
    $d y A $.  $d x y B $.  $d y ph $.
    $( Restricted quantifier version of Axiom 4 of [Mendelson] p. 69.  This
       provides an axiom for a predicate calculus for a restricted domain.
       This theorem generalizes the unrestricted ~ stdpc4 and ~ spsbc .  See
       also ~ rspsbca and ~ rspcsbela .  (Contributed by NM, 17-Nov-2006.)
       (Proof shortened by Mario Carneiro, 13-Oct-2016.) $)
    rspsbc $p |- ( A e. B -> ( A. x e. B ph -> [. A / x ]. ph ) ) $=
      ( vy wral wsb wcel wsbc cbvralsv dfsbcq2 rspcv syl5bi ) ABDFABEGZEDFCDHAB
      CIZABEDJNOECDABECKLM $.

    $( Restricted quantifier version of Axiom 4 of [Mendelson] p. 69.
       (Contributed by NM, 14-Dec-2005.) $)
    rspsbca $p |- ( ( A e. B /\ A. x e. B ph ) -> [. A / x ]. ph ) $=
      ( wcel wral wsbc rspsbc imp ) CDEABDFABCGABCDHI $.

    $( Existence form of ~ rspsbca .  (Contributed by NM, 29-Feb-2008.)  (Proof
       shortened by Mario Carneiro, 13-Oct-2016.) $)
    rspesbca $p |- ( ( A e. B /\ [. A / x ]. ph ) -> E. x e. B ph ) $=
      ( vy wcel wsbc wa wsb wrex dfsbcq2 rspcev cbvrexsv sylibr ) CDFABCGZHABEI
      ZEDJABDJPOECDABECKLABEDMN $.

    $( Existence form of ~ spsbc .  (Contributed by Mario Carneiro,
       18-Nov-2016.) $)
    spesbc $p |- ( [. A / x ]. ph -> E. x ph ) $=
      ( wsbc cvv wrex wex wcel sbcex rspesbca mpancom rexv sylib ) ABCDZABEFZAB
      GCEHNOABCIABCEJKABLM $.

    spesbcd.1 $e |- ( ph -> [. A / x ]. ps ) $.
    $( form of ~ spsbc .  (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    spesbcd $p |- ( ph -> E. x ps ) $=
      ( wsbc wex spesbc syl ) ABCDFBCGEBCDHI $.
  $}

  ${
    $d x B $.
    sbcth2.1 $e |- ( x e. B -> ph ) $.
    $( A substitution into a theorem.  (Contributed by NM, 1-Mar-2008.)  (Proof
       shortened by Mario Carneiro, 13-Oct-2016.) $)
    sbcth2 $p |- ( A e. B -> [. A / x ]. ph ) $=
      ( wcel wral wsbc rgen rspsbc mpi ) CDFABDGABCHABDEIABCDJK $.
  $}

  ${
    ra5.1 $e |- F/ x ph $.
    $( Restricted quantifier version of Axiom 5 of [Mendelson] p. 69.  This is
       an axiom of a predicate calculus for a restricted domain.  Compare the
       unrestricted ~ stdpc5 .  (Contributed by NM, 16-Jan-2004.) $)
    ra5 $p |- ( A. x e. A ( ph -> ps ) -> ( ph -> A. x e. A ps ) ) $=
      ( wi wral cv wcel wal df-ral bi2.04 albii bitri stdpc5 sylbi syl6ibr ) AB
      FZCDGZACHDIZBFZCJZBCDGSAUAFZCJZAUBFSTRFZCJUDRCDKUEUCCTABLMNAUACEOPBCDKQ
      $.
  $}

  ${
    $d x y A $.
    rmo2.1 $e |- F/ y ph $.
    $( Alternate definition of restricted "at most one."  Note that
       ` E* x e. A ph ` is not equivalent to
       ` E. y e. A A. x e. A ( ph -> x = y ) ` (in analogy to ~ reu6 ); to see
       this, let ` A ` be the empty set.  However, one direction of this
       pattern holds; see ~ rmo2i .  (Contributed by NM, 17-Jun-2017.) $)
    rmo2 $p |- ( E* x e. A ph <-> E. y A. x e. A ( ph -> x = y ) ) $=
      ( wrmo cv wcel wa wmo weq wi wal wex wral df-rmo nfv nfan mo2 impexp
      albii df-ral bitr4i exbii 3bitri ) ABDFBGDHZAIZBJUGBCKZLZBMZCNAUHLZBDOZCN
      ABDPUGBCUFACUFCQERSUJULCUJUFUKLZBMULUIUMBUFAUHTUAUKBDUBUCUDUE $.

    $( Condition implying restricted "at most one."  (Contributed by NM,
       17-Jun-2017.) $)
    rmo2i $p |- ( E. y e. A A. x e. A ( ph -> x = y ) -> E* x e. A ph ) $=
      ( weq wi wral wrex wex wrmo rexex rmo2 sylibr ) ABCFGBDHZCDIOCJABDKOCDLAB
      CDEMN $.

    $( Restricted "at most one" using explicit substitution.  (Contributed by
       NM, 4-Nov-2012.)  (Revised by NM, 16-Jun-2017.) $)
    rmo3 $p |- ( E* x e. A ph <->
               A. x e. A A. y e. A ( ( ph /\ [ y / x ] ph ) -> x = y ) ) $=
      ( wrmo cv wcel wa wmo wsb wi wral anbi1i bitri 3bitri impexp albii df-ral
      wal weq df-rmo sban clelsb3 anbi2i an4 ancom r19.21v 3bitr2i nfv nfan mo3
      imbi1i 3bitr4i ) ABDFBGDHZAIZBJZAABCKZIZBCUAZLZCDMZBDMZABDUBUPUPBCKZIZUTL
      ZCTZBTUOVBLZBTUQVCVGVHBVGCGDHZUOVALZLZCTVJCDMVHVFVKCVFVIUOIZUSIZUTLVLVALV
      KVEVMUTVEUPVIURIZIUOVIIZUSIVMVDVNUPVDUOBCKZURIVNUOABCUCVPVIURCBDUDNOUEUOA
      VIURUFVOVLUSUOVIUGNPUMVLUSUTQVIUOVAQPRVJCDSUOVACDUHUIRUPBCUOACUOCUJEUKULV
      BBDSUNO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d y ph $.  $d x y ps $.  $d x ch $.
    rmoi.b $e |- ( x = B -> ( ph <-> ps ) ) $.
    rmoi.c $e |- ( x = C -> ( ph <-> ch ) ) $.
    $( Consequence of "at most one", using implicit substitution.  (Contributed
       by NM, 2-Jan-2015.)  (Revised by NM, 16-Jun-2017.) $)
    rmob $p |- ( ( E* x e. A ph /\ ( B e. A /\ ps ) ) ->
        ( B = C <-> ( C e. A /\ ch ) ) ) $=
      ( wrmo cv wcel wa wmo wceq wb df-rmo simprl eleq1 anbi12d syl5ibcom simpl
      wi a1i simplrl simpr simpll simplrr mob syl212anc ex pm5.21ndd sylanb ) A
      DEJDKZELZAMZDNZFELZBMZFGOZGELZCMZPZADEQUQUSMZVAUTVBVDURUTVAUQURBRFGESUAVB
      VAUCVDVACUBUDVDVAVCVDVAMURVAUQURBVCUQURBVAUEZVDVAUFUQUSVAUGVEUQURBVAUHUPU
      SVBDFGEEUNFOUOURABUNFESHTUNGOUOVAACUNGESITUIUJUKULUM $.

    $( Consequence of "at most one", using implicit substitution.  (Contributed
       by NM, 4-Nov-2012.)  (Revised by NM, 16-Jun-2017.) $)
    rmoi $p |- ( ( E* x e. A ph
          /\ ( B e. A /\ ps ) /\ ( C e. A /\ ch ) ) -> B = C ) $=
      ( wrmo wcel wa wceq rmob biimp3ar ) ADEJFEKBLFGMGEKCLABCDEFGHINO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Proper substitution of classes for sets into classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c [_ $.  $( Underlined left bracket $)
  $c ]_ $.  $( Underlined right bracket $)

  $( Extend class notation to include the proper substitution of a class for a
     set into another class. $)
  csb $a class [_ A / x ]_ B $.

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( Define the proper substitution of a class for a set into another class.
       The underlined brackets distinguish it from the substitution into a wff,
       ~ wsbc , to prevent ambiguity.  Theorem ~ sbcel1g shows an example of
       how ambiguity could arise if we didn't use distinguished brackets.
       Theorem ~ sbccsb recreates substitution into a wff from this
       definition.  (Contributed by NM, 10-Nov-2005.) $)
    df-csb $a |- [_ A / x ]_ B = { y | [. A / x ]. y e. B } $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y $.
    $( Alternate expression for the proper substitution into a class, without
       referencing substitution into a wff.  Note that ` x ` can be free in
       ` B ` but cannot occur in ` A ` .  (Contributed by NM, 2-Dec-2013.) $)
    csb2 $p |- [_ A / x ]_ B = { y | E. x ( x = A /\ y e. B ) } $=
      ( csb cv wcel wsbc cab wceq wa wex df-csb sbc5 abbii eqtri ) ACDEBFDGZACH
      ZBIAFCJQKALZBIABCDMRSBQACNOP $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Analog of ~ dfsbcq for proper substitution into a class.  (Contributed
       by NM, 10-Nov-2005.) $)
    csbeq1 $p |- ( A = B -> [_ A / x ]_ C = [_ B / x ]_ C ) $=
      ( vy wceq cv wcel wsbc cab csb dfsbcq abbidv df-csb 3eqtr4g ) BCFZEGDHZAB
      IZEJQACIZEJABDKACDKPRSEQABCLMAEBDNAECDNO $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z C $.  $d z D $.
    cbvcsb.1 $e |- F/_ y C $.
    cbvcsb.2 $e |- F/_ x D $.
    cbvcsb.3 $e |- ( x = y -> C = D ) $.
    $( Change bound variables in a class substitution.  Interestingly, this
       does not require any bound variable conditions on ` A ` .  (Contributed
       by Jeff Hankins, 13-Sep-2009.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    cbvcsb $p |- [_ A / x ]_ C = [_ A / y ]_ D $=
      ( vz cv wcel wsbc cab csb nfcri weq eleq2d cbvsbc abbii df-csb 3eqtr4i )
      IJZDKZACLZIMUBEKZBCLZIMACDNBCENUDUFIUCUEABCBIDFOAIEGOABPDEUBHQRSAICDTBICE
      TUA $.
  $}

  ${
    $d x y $.  $d z A $.  $d y z B $.  $d x z C $.
    cbvcsbv.1 $e |- ( x = y -> B = C ) $.
    $( Change the bound variable of a proper substitution into a class using
       implicit substitution.  (Contributed by NM, 30-Sep-2008.)  (Revised by
       Mario Carneiro, 13-Oct-2016.) $)
    cbvcsbv $p |- [_ A / x ]_ B = [_ A / y ]_ C $=
      ( nfcv cbvcsb ) ABCDEBDGAEGFH $.
  $}

  ${
    csbeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for proper substitution into a class.  (Contributed
       by NM, 3-Dec-2005.) $)
    csbeq1d $p |- ( ph -> [_ A / x ]_ C = [_ B / x ]_ C ) $=
      ( wceq csb csbeq1 syl ) ACDGBCEHBDEHGFBCDEIJ $.
  $}

  ${
    $d x y $.  $d y A $.
    $( Analog of ~ sbid for proper substitution into a class.  (Contributed by
       NM, 10-Nov-2005.) $)
    csbid $p |- [_ x / x ]_ A = A $=
      ( vy cv csb wcel wsbc cab df-csb sbcid abbii abid2 3eqtri ) AADZBECDBFZAN
      GZCHOCHBACNBIPOCOAJKCBLM $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Equality theorem for proper substitution into a class.  (Contributed by
       NM, 10-Nov-2005.) $)
    csbeq1a $p |- ( x = A -> B = [_ A / x ]_ B ) $=
      ( cv wceq csb csbid csbeq1 syl5eqr ) ADZBECAJCFABCFACGAJBCHI $.
  $}

  ${
    $d z A $.  $d y z B $.  $d z V $.  $d x z $.
    $( Composition law for chained substitutions into a class.  (Contributed by
       NM, 10-Nov-2005.) $)
    csbco $p |- [_ A / y ]_ [_ y / x ]_ B = [_ A / x ]_ B $=
      ( vz cv csb wcel wsbc cab df-csb abeq2i sbcbii sbcco bitri abbii 3eqtr4i
      ) EFZABFZDGZHZBCIZEJRDHZACIZEJBCTGACDGUBUDEUBUCASIZBCIUDUAUEBCUEETAESDKLM
      UCABCNOPBECTKAECDKQ $.
  $}

  ${
    $d y A $.  $d y B $.  $d y V $.  $d x y $.
    $( Substitution doesn't affect a constant ` B ` (in which ` x ` is not
       free).  (Contributed by Mario Carneiro, 14-Oct-2016.) $)
    csbtt $p |- ( ( A e. V /\ F/_ x B ) -> [_ A / x ]_ B = B ) $=
      ( vy wcel wnfc wa csb cv wsbc cab df-csb wnf wb nfcr sbctt sylan2 abbi1dv
      syl5eq ) BDFZACGZHZABCIEJCFZABKZELCAEBCMUCUEECUBUAUDANUEUDOAECPUDABDQRST
      $.
  $}

  ${
    csbconstgf.1 $e |- F/_ x B $.
    $( Substitution doesn't affect a constant ` B ` (in which ` x ` is not
       free).  (Contributed by NM, 10-Nov-2005.) $)
    csbconstgf $p |- ( A e. V -> [_ A / x ]_ B = B ) $=
      ( wcel wnfc csb wceq csbtt mpan2 ) BDFACGABCHCIEABCDJK $.
  $}

  ${
    $d A y $.  $d B x y $.  $d V y $.
    $( Substitution doesn't affect a constant ` B ` (in which ` x ` does not
       occur). ~ csbconstgf with distinct variable requirement.  (Contributed
       by Alan Sare, 22-Jul-2012.) $)
    csbconstg $p |- ( A e. V -> [_ A / x ]_ B = B ) $=
      ( nfcv csbconstgf ) ABCDACEF $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y ph $.
    nfcsb1d.1 $e |- ( ph -> F/_ x A ) $.
    $( Bound-variable hypothesis builder for substitution into a class.
       (Contributed by Mario Carneiro, 12-Oct-2016.) $)
    nfcsb1d $p |- ( ph -> F/_ x [_ A / x ]_ B ) $=
      ( vy csb cv wcel wsbc cab df-csb nfv nfsbc1d nfabd nfcxfrd ) ABBCDGFHDIZB
      CJZFKBFCDLARBFAFMAQBCENOP $.
  $}

  ${
    $d y z A $.  $d z B $.  $d x y z $.
    nfcsb1.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for substitution into a class.
       (Contributed by Mario Carneiro, 12-Oct-2016.) $)
    nfcsb1 $p |- F/_ x [_ A / x ]_ B $=
      ( csb wnfc wtru a1i nfcsb1d trud ) AABCEFGABCABFGDHIJ $.
  $}

  ${
    $d x y A $.
    $( Bound-variable hypothesis builder for substitution into a class.
       (Contributed by NM, 17-Aug-2006.)  (Revised by Mario Carneiro,
       12-Oct-2016.) $)
    nfcsb1v $p |- F/_ x [_ A / x ]_ B $=
      ( nfcv nfcsb1 ) ABCABDE $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z B $.  $d z ph $.
    nfcsbd.1 $e |- F/ y ph $.
    nfcsbd.2 $e |- ( ph -> F/_ x A ) $.
    nfcsbd.3 $e |- ( ph -> F/_ x B ) $.
    $( Deduction version of ~ nfcsb .  (Contributed by NM, 21-Nov-2005.)
       (Revised by Mario Carneiro, 12-Oct-2016.) $)
    nfcsbd $p |- ( ph -> F/_ x [_ A / y ]_ B ) $=
      ( vz csb cv wcel wsbc cab df-csb nfv nfcrd nfsbcd nfabd nfcxfrd ) ABCDEJI
      KELZCDMZINCIDEOAUBBIAIPAUABCDFGABIEHQRST $.
  $}

  ${
    nfcsb.1 $e |- F/_ x A $.
    nfcsb.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for substitution into a class.
       (Contributed by Mario Carneiro, 12-Oct-2016.) $)
    nfcsb $p |- F/_ x [_ A / y ]_ B $=
      ( csb wnfc wtru nftru a1i nfcsbd trud ) ABCDGHIABCDBJACHIEKADHIFKLM $.
  $}

  ${
    $d x y $.
    csbhypf.1 $e |- F/_ x A $.
    csbhypf.2 $e |- F/_ x C $.
    csbhypf.3 $e |- ( x = A -> B = C ) $.
    $( Introduce an explicit substitution into an implicit substitution
       hypothesis.  See ~ sbhypf for class substitution version.  (Contributed
       by NM, 19-Dec-2008.) $)
    csbhypf $p |- ( y = A -> [_ y / x ]_ B = C ) $=
      ( cv wceq wi csb nfeq2 nfcsb1v nfeq nfim eqeq1 csbeq1a eqeq1d imbi12d
      chvar ) AIZCJZDEJZKBIZCJZAUEDLZEJZKABUFUHAAUECFMAUGEAUEDNGOPUBUEJZUCUFUDU
      HUBUECQUIDUGEAUEDRSTHUA $.
  $}

  ${
    $d x A $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Closed theorem version of ~ csbiegf .)  (Contributed by NM,
       11-Nov-2005.) $)
    csbiebt $p |- ( ( A e. V /\ F/_ x C ) ->
                 ( A. x ( x = A -> B = C ) <-> [_ A / x ]_ B = C ) ) $=
      ( wcel cvv wnfc cv wceq wi wal csb wb elex wa wsbc adantl a1i nfeqd spsbc
      adantr simpl biimt csbeq1a eqeq1d bitr3d nfv nfnfc1 nfcsb1v simpr sbciedf
      nfan sylibd id nfan1 biimprcd alrimi ex impbid sylan ) BEFBGFZADHZAIBJZCD
      JZKZALZABCMZDJZNBEOVBVCPZVGVIVJVGVFABQZVIVBVGVKKVCVFABGUAUBVJVFVIABGVBVCU
      CVDVFVINVJVDVEVFVIVDVEUDVDCVHDABCUEUFZUGRVBVCAVBAUHADUIZUMVJAVHDAVHHZVJAB
      CUJZSVBVCUKTULUNVCVIVGKVBVCVIVGVCVIPVFAVCVIAVMVCAVHDVNVCVOSVCUOTUPVIVFVCV
      DVEVIVLUQRURUSRUTVA $.

    csbiedf.1 $e |- F/ x ph $.
    csbiedf.2 $e |- ( ph -> F/_ x C ) $.
    csbiedf.3 $e |- ( ph -> A e. V ) $.
    csbiedf.4 $e |- ( ( ph /\ x = A ) -> B = C ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Contributed by Mario Carneiro, 13-Oct-2016.) $)
    csbiedf $p |- ( ph -> [_ A / x ]_ B = C ) $=
      ( cv wceq wi wal csb ex alrimi wcel wnfc wb csbiebt syl2anc mpbid ) ABKCL
      ZDELZMZBNZBCDOELZAUFBGAUDUEJPQACFRBESUGUHTIHBCDEFUAUBUC $.
  $}

  ${
    $d x z A $.  $d z B $.  $d y C $.  $d x y $.
    csbieb.1 $e |- A e. _V $.
    csbieb.2 $e |- F/_ x C $.
    $( Bidirectional conversion between an implicit class substitution
       hypothesis ` x = A -> B = C ` and its explicit substitution equivalent.
       (Contributed by NM, 2-Mar-2008.) $)
    csbieb $p |- ( A. x ( x = A -> B = C ) <-> [_ A / x ]_ B = C ) $=
      ( cvv wcel wnfc cv wceq wi wal csb wb csbiebt mp2an ) BGHADIAJBKCDKLAMABC
      NDKOEFABCDGPQ $.
  $}

  ${
    $d a x A $.  $d a B $.  $d a y C $.  $d x y $.
    csbiebg.2 $e |- F/_ x C $.
    $( Bidirectional conversion between an implicit class substitution
       hypothesis ` x = A -> B = C ` and its explicit substitution equivalent.
       (Contributed by NM, 24-Mar-2013.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    csbiebg $p |- ( A e. V ->
          ( A. x ( x = A -> B = C ) <-> [_ A / x ]_ B = C ) ) $=
      ( va cv wceq wal csb eqeq2 imbi1d albidv csbeq1 eqeq1d vex csbieb vtoclbg
      wi ) AHZGHZIZCDIZTZAJAUBCKZDIUABIZUDTZAJABCKZDIGBEUBBIZUEUHAUJUCUGUDUBBUA
      LMNUJUFUIDAUBBCOPAUBCDGQFRS $.
  $}

  ${
    $d x y A $.  $d y C $.  $d x y V $.
    csbiegf.1 $e |- ( A e. V -> F/_ x C ) $.
    csbiegf.2 $e |- ( x = A -> B = C ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Contributed by NM, 11-Nov-2005.)  (Revised by Mario Carneiro,
       13-Oct-2016.) $)
    csbiegf $p |- ( A e. V -> [_ A / x ]_ B = C ) $=
      ( wcel cv wceq wi wal csb ax-gen wnfc wb csbiebt mpdan mpbii ) BEHZAIBJCD
      JKZALZABCMDJZUAAGNTADOUBUCPFABCDEQRS $.
  $}

  ${
    $d x A $.  $d y C $.  $d x y $.
    csbief.1 $e |- A e. _V $.
    csbief.2 $e |- F/_ x C $.
    csbief.3 $e |- ( x = A -> B = C ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Contributed by NM, 26-Nov-2005.)  (Revised by Mario Carneiro,
       13-Oct-2016.) $)
    csbief $p |- [_ A / x ]_ B = C $=
      ( cvv wcel csb wceq wnfc a1i csbiegf ax-mp ) BHIZABCJDKEABCDHADLPFMGNO $.
  $}

  ${
    $d x A $.  $d x y C $.  $d x y ph $.
    csbied.1 $e |- ( ph -> A e. V ) $.
    csbied.2 $e |- ( ( ph /\ x = A ) -> B = C ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Contributed by Mario Carneiro, 2-Dec-2014.)  (Revised by Mario
       Carneiro, 13-Oct-2016.) $)
    csbied $p |- ( ph -> [_ A / x ]_ B = C ) $=
      ( nfv nfcvd csbiedf ) ABCDEFABIABEJGHK $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x D $.
    csbied2.1 $e |- ( ph -> A e. V ) $.
    csbied2.2 $e |- ( ph -> A = B ) $.
    csbied2.3 $e |- ( ( ph /\ x = B ) -> C = D ) $.
    $( Conversion of implicit substitution to explicit class substitution,
       deduction form.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    csbied2 $p |- ( ph -> [_ A / x ]_ C = D ) $=
      ( cv wceq id sylan9eqr syldan csbied ) ABCEFGHABKZCLZQDLEFLRAQCDRMINJOP
      $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.  $d x y z D $.
    csbie2t.1 $e |- A e. _V $.
    csbie2t.2 $e |- B e. _V $.
    $( Conversion of implicit substitution to explicit substitution into a
       class (closed form of ~ csbie2 ).  (Contributed by NM, 3-Sep-2007.)
       (Revised by Mario Carneiro, 13-Oct-2016.) $)
    csbie2t $p |- ( A. x A. y ( ( x = A /\ y = B ) -> C = D ) ->
                  [_ A / x ]_ [_ B / y ]_ C = D ) $=
      ( cv wceq wa wi wal csb cvv nfa1 nfcvd wcel a1i csbiedf nfa2 nfv nfan sps
      sp impl ) AICJZBIDJZKEFJZLZBMZAMZACBDENFOUKAPULAFQCORULGSULUGKZBDEFOULUGB
      UJBAUAUGBUBUCUMBFQDORUMHSULUGUHUIUKUJAUJBUEUDUFTT $.

    csbie2.3 $e |- ( ( x = A /\ y = B ) -> C = D ) $.
    $( Conversion of implicit substitution to explicit substitution into a
       class.  (Contributed by NM, 27-Aug-2007.) $)
    csbie2 $p |- [_ A / x ]_ [_ B / y ]_ C = D $=
      ( cv wceq wa wi wal csb gen2 csbie2t ax-mp ) AJCKBJDKLEFKMZBNANACBDEOOFKS
      ABIPABCDEFGHQR $.
  $}

  ${
    $d x y z $.  $d A y z $.  $d B y z $.  $d C x $.  $d D y z $.  $d V z $.
    csbie2g.1 $e |- ( x = y -> B = C ) $.
    csbie2g.2 $e |- ( y = A -> C = D ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       This version of ~ sbcie avoids a disjointness condition on ` x , A ` by
       substituting twice.  (Contributed by Mario Carneiro, 11-Nov-2016.) $)
    csbie2g $p |- ( A e. V -> [_ A / x ]_ B = D ) $=
      ( vz wcel csb cv wsbc cab df-csb wceq eleq2d sbcie2g abbi1dv syl5eq ) CGK
      ZACDLJMZDKZACNZJOFAJCDPUBUEJFUDUCEKUCFKABCGAMBMZQDEUCHRUFCQEFUCIRSTUA $.
  $}

  ${
    $d x v z $.  $d y v z $.  $d A w v z $.  $d B w v z $.  $d ph v z $.
    $d ps v z $.
    cbvralcsf.1 $e |- F/_ y A $.
    cbvralcsf.2 $e |- F/_ x B $.
    cbvralcsf.3 $e |- F/ y ph $.
    cbvralcsf.4 $e |- F/ x ps $.
    cbvralcsf.5 $e |- ( x = y -> A = B ) $.
    cbvralcsf.6 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A more general version of ~ cbvralf that doesn't require ` A ` and ` B `
       to be distinct from ` x ` or ` y ` .  Changes bound variables using
       implicit substitution.  (Contributed by Andrew Salmon, 13-Jul-2011.) $)
    cbvralcsf $p |- ( A. x e. A ph <-> A. y e. B ps ) $=
      ( vz vv cv wcel wi wal wsbc nfcri wral csb nfv nfcsb1v nfsbc1v id csbeq1a
      nfim weq eleq12d sbceq1a imbi12d cbval nfcv nfcsb nfsbc csbeq1 cab df-csb
      eleq2d sbie sbsbc bitr3i abbi2i eqtr4i syl6eq dfsbcq syl6bb bitri 3bitr4i
      wsb df-ral ) COZEPZAQZCRZDOZFPZBQZDRZACEUABDFUAVPMOZCWAEUBZPZACWASZQZMRVT
      VOWECMVOMUCWCWDCCMWBCWAEUDTACWAUEUHCMUIZVNWCAWDWFVMWAEWBWFUFCWAEUGUJACWAU
      KULUMWEVSMDWCWDDDMWBDCWAEDWAUNZGUOTADCWAWGIUPUHVSMUCMDUIZWCVRWDBWHWAVQWBF
      WHUFWHWBCVQEUBZFCWAVQEUQWINOZEPZCVQSZNURFCNVQEUSWLNFWJFPZWKCDVKWLWKWMCDCN
      FHTCDUIEFWJKUTVAWKCDVBVCVDVEVFUJWHWDACVQSZBACWAVQVGWNACDVKBACDVBABCDJLVAV
      CVHULUMVIACEVLBDFVLVJ $.

    $( A more general version of ~ cbvrexf that has no distinct variable
       restrictions.  Changes bound variables using implicit substitution.
       (Contributed by Andrew Salmon, 13-Jul-2011.)  (Proof shortened by Mario
       Carneiro, 7-Dec-2014.) $)
    cbvrexcsf $p |- ( E. x e. A ph <-> E. y e. B ps ) $=
      ( wn wral wrex nfn weq notbid cbvralcsf dfrex2 notbii 3bitr4i ) AMZCENZMB
      MZDFNZMACEOBDFOUDUFUCUECDEFGHADIPBCJPKCDQABLRSUAACETBDFTUB $.

    $( A more general version of ~ cbvreuv that has no distinct variable
       rextrictions.  Changes bound variables using implicit substitution.
       (Contributed by Andrew Salmon, 13-Jul-2011.) $)
    cbvreucsf $p |- ( E! x e. A ph <-> E! y e. B ps ) $=
      ( vz vv cv wcel wa weu wsb nfcri wreu csb nfv nfcsb1v nfan weq id csbeq1a
      nfs1v eleq12d sbequ12 anbi12d cbveu nfcv nfcsb nfsb csbeq1 cab wsbc sbsbc
      abbii eleq2d sbie bicomi abbi2i df-csb 3eqtr4ri syl6eq sbequ syl6bb bitri
      df-reu 3bitr4i ) COZEPZAQZCRZDOZFPZBQZDRZACEUABDFUAVQMOZCWBEUBZPZACMSZQZM
      RWAVPWFCMVPMUCWDWECCMWCCWBEUDTACMUIUECMUFZVOWDAWEWGVNWBEWCWGUGCWBEUHUJACM
      UKULUMWFVTMDWDWEDDMWCDCWBEDWBUNGUOTACMDIUPUEVTMUCMDUFZWDVSWEBWHWBVRWCFWHU
      GWHWCCVREUBZFCWBVREUQNOZEPZCDSZNURWKCVRUSZNURFWIWLWMNWKCDUTVAWLNFWLWJFPZW
      KWNCDCNFHTCDUFEFWJKVBVCVDVECNVREVFVGVHUJWHWEACDSBAMDCVIABCDJLVCVJULUMVKAC
      EVLBDFVLVM $.

    $( A more general version of ~ cbvrab with no distinct variable
       restrictions.  (Contributed by Andrew Salmon, 13-Jul-2011.) $)
    cbvrabcsf $p |- { x e. A | ph } = { y e. B | ps } $=
      ( vz vv cv wcel wa cab wsb nfcri crab csb nfv nfcsb1v nfan weq id csbeq1a
      nfs1v eleq12d sbequ12 anbi12d cbvab nfcv nfcsb csbeq1 df-csb eleq2d sbsbc
      nfsb wsbc bitr3i abbi2i eqtr4i syl6eq sbequ syl6bb eqtri df-rab 3eqtr4i
      sbie ) COZEPZAQZCRZDOZFPZBQZDRZACEUABDFUAVOMOZCVTEUBZPZACMSZQZMRVSVNWDCMV
      NMUCWBWCCCMWACVTEUDTACMUIUECMUFZVMWBAWCWEVLVTEWAWEUGCVTEUHUJACMUKULUMWDVR
      MDWBWCDDMWADCVTEDVTUNGUOTACMDIUTUEVRMUCMDUFZWBVQWCBWFVTVPWAFWFUGWFWACVPEU
      BZFCVTVPEUPWGNOZEPZCVPVAZNRFCNVPEUQWJNFWHFPZWICDSWJWIWKCDCNFHTCDUFEFWHKUR
      VKWICDUSVBVCVDVEUJWFWCACDSBAMDCVFABCDJLVKVGULUMVHACEVIBDFVIVJ $.
  $}

  ${
    $d A y $.  $d ps y $.  $d B x $.  $d ch x $.
    cbvralv2.1 $e |- ( x = y -> ( ps <-> ch ) ) $.
    cbvralv2.2 $e |- ( x = y -> A = B ) $.
    $( Rule used to change the bound variable in a restricted universal
       quantifier with implicit substitution which also changes the quantifier
       domain.  (Contributed by David Moews, 1-May-2017.) $)
    cbvralv2 $p |- ( A. x e. A ps <-> A. y e. B ch ) $=
      ( nfcv nfv cbvralcsf ) ABCDEFDEICFIADJBCJHGK $.

    $( Rule used to change the bound variable in a restricted existential
       quantifier with implicit substitution which also changes the quantifier
       domain.  (Contributed by David Moews, 1-May-2017.) $)
    cbvrexv2 $p |- ( E. x e. A ps <-> E. y e. B ch ) $=
      ( nfcv nfv cbvrexcsf ) ABCDEFDEICFIADJBCJHGK $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Define basic set operations and relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols. $)
  $c \ $. $( Backslash (difference) $)
  $c u. $. $( Cup (union) $)
  $c i^i $. $( Cap (intersection) $)
  $c C_ $. $( Subclass or subset symbol $)
  $c C. $. $( Proper subclass or subset symbol $)

  $( Extend class notation to include class difference (read:  " ` A ` minus
     ` B ` "). $)
  cdif $a class ( A \ B ) $.

  $( Extend class notation to include union of two classes (read:  " ` A `
     union ` B ` "). $)
  cun $a class ( A u. B ) $.

  $( Extend class notation to include the intersection of two classes
     (read:  " ` A ` intersect ` B ` "). $)
  cin $a class ( A i^i B ) $.

  $( Extend wff notation to include the subclass relation.  This is
     read " ` A ` is a subclass of ` B ` " or " ` B ` includes ` A ` ."  When
     ` A ` exists as a set, it is also read " ` A ` is a subset of ` B ` ." $)
  wss $a wff A C_ B $.

  $( Extend wff notation with proper subclass relation. $)
  wpss $a wff A C. B $.

  ${
    $d x A $.  $d x B $.  $d y A $.  $d y B $.  $d z x $.  $d z y $.  $d z A $.
    $d z B $.
    $( Soundness justification theorem for ~ df-dif .  (Contributed by Rodolfo
       Medina, 27-Apr-2010.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    difjust $p |- { x | ( x e. A /\ -. x e. B ) }
                  = { y | ( y e. A /\ -. y e. B ) } $=
      ( vz cv wcel wn wa cab weq eleq1 notbid anbi12d cbvabv eqtri ) AFZCGZQDGZ
      HZIZAJEFZCGZUBDGZHZIZEJBFZCGZUGDGZHZIZBJUAUFAEAEKZRUCTUEQUBCLULSUDQUBDLMN
      OUFUKEBEBKZUCUHUEUJUBUGCLUMUDUIUBUGDLMNOP $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Define class difference, also called relative complement.  Definition
       5.12 of [TakeutiZaring] p. 20.  For example,
       ` ( { 1 , 3 } \ { 1 , 8 } ) = { 3 } ` ( ~ ex-dif ).  Contrast this
       operation with union ` ( A u. B ) ` ( ~ df-un ) and intersection
       ` ( A i^i B ) ` ( ~ df-in ).  Several notations are used in the
       literature; we chose the ` \ ` convention used in Definition 5.3 of
       [Eisenberg] p. 67 instead of the more common minus sign to reserve the
       latter for later use in, e.g., arithmetic.  We will use the
       terminology " ` A ` excludes ` B ` " to mean ` A \ B ` .  We will
       use " ` B ` is removed from ` A ` " to mean ` A \ { B } ` i.e. the
       removal of an element or equivalently the exclusion of a singleton.
       (Contributed by NM, 29-Apr-1994.) $)
    df-dif $a |- ( A \ B ) = { x | ( x e. A /\ -. x e. B ) } $.
  $}

  ${
    $d x A $.  $d x B $.  $d y A $.  $d y B $.  $d z x $.  $d z y $.  $d z A $.
    $d z B $.
    $( Soundness justification theorem for ~ df-un .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    unjust $p |- { x | ( x e. A \/ x e. B ) } = { y | ( y e. A \/ y e. B ) } $=
      ( vz cv wcel wo cab weq eleq1 orbi12d cbvabv eqtri ) AFZCGZODGZHZAIEFZCGZ
      SDGZHZEIBFZCGZUCDGZHZBIRUBAEAEJPTQUAOSCKOSDKLMUBUFEBEBJTUDUAUESUCCKSUCDKL
      MN $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Define the union of two classes.  Definition 5.6 of [TakeutiZaring]
       p. 16.  For example, ` ( { 1 , 3 } u. { 1 , 8 } ) = { 1 , 3 , 8 } `
       ( ~ ex-un ).  Contrast this operation with difference ` ( A \ B ) `
       ( ~ df-dif ) and intersection ` ( A i^i B ) ` ( ~ df-in ).  For an
       alternate definition in terms of class difference, requiring no dummy
       variables, see ~ dfun2 .  For union defined in terms of intersection,
       see ~ dfun3 .  (Contributed by NM, 23-Aug-1993.) $)
    df-un $a |- ( A u. B ) = { x | ( x e. A \/ x e. B ) } $.
  $}

  ${
    $d x A $.  $d x B $.  $d y A $.  $d y B $.  $d z x $.  $d z y $.  $d z A $.
    $d z B $.
    $( Soundness justification theorem for ~ df-in .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    injust $p |- { x | ( x e. A /\ x e. B ) }
                  = { y | ( y e. A /\ y e. B ) } $=
      ( vz cv wcel wa cab weq eleq1 anbi12d cbvabv eqtri ) AFZCGZODGZHZAIEFZCGZ
      SDGZHZEIBFZCGZUCDGZHZBIRUBAEAEJPTQUAOSCKOSDKLMUBUFEBEBJTUDUAUESUCCKSUCDKL
      MN $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Define the intersection of two classes.  Definition 5.6 of
       [TakeutiZaring] p. 16.  For example,
       ` ( { 1 , 3 } i^i { 1 , 8 } ) = { 1 } ` ( ~ ex-in ).  Contrast this
       operation with union ` ( A u. B ) ` ( ~ df-un ) and difference
       ` ( A \ B ) ` ( ~ df-dif ).  For alternate definitions in terms of class
       difference, requiring no dummy variables, see ~ dfin2 and ~ dfin4 .  For
       intersection defined in terms of union, see ~ dfin3 .  (Contributed by
       NM, 29-Apr-1994.) $)
    df-in $a |- ( A i^i B ) = { x | ( x e. A /\ x e. B ) } $.

    $( Alternate definition for the intersection of two classes.  (Contributed
       by NM, 6-Jul-2005.) $)
    dfin5 $p |- ( A i^i B ) = { x e. A | x e. B } $=
      ( cin cv wcel wa cab crab df-in df-rab eqtr4i ) BCDAEZBFMCFZGAHNABIABCJNA
      BKL $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of class difference.  (Contributed by NM,
       25-Mar-2004.) $)
    dfdif2 $p |- ( A \ B ) = { x e. A | -. x e. B } $=
      ( cdif cv wcel wn wa cab crab df-dif df-rab eqtr4i ) BCDAEZBFNCFGZHAIOABJ
      ABCKOABLM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Expansion of membership in a class difference.  (Contributed by NM,
       29-Apr-1994.) $)
    eldif $p |- ( A e. ( B \ C ) <-> ( A e. B /\ -. A e. C ) ) $=
      ( vx cdif wcel cvv wn wa elex adantr cv wceq notbid anbi12d df-dif elab2g
      eleq1 pm5.21nii ) ABCEZFAGFZABFZACFZHZIZATJUBUAUDABJKDLZBFZUFCFZHZIUEDATG
      UFAMZUGUBUIUDUFABRUJUHUCUFACRNODBCPQS $.
  $}

  ${
    eldifd.1 $e |- ( ph -> A e. B ) $.
    eldifd.2 $e |- ( ph -> -. A e. C ) $.
    $( If a class is in one class and not another, it is also in their
       difference.  One-way deduction form of ~ eldif .  (Contributed by David
       Moews, 1-May-2017.) $)
    eldifd $p |- ( ph -> A e. ( B \ C ) ) $=
      ( wcel wn cdif eldif sylanbrc ) ABCGBDGHBCDIGEFBCDJK $.
  $}

  ${
    eldifad.1 $e |- ( ph -> A e. ( B \ C ) ) $.
    $( If a class is in the difference of two classes, it is also in the
       minuend.  One-way deduction form of ~ eldif .  (Contributed by David
       Moews, 1-May-2017.) $)
    eldifad $p |- ( ph -> A e. B ) $=
      ( wcel wn cdif wa eldif sylib simpld ) ABCFZBDFGZABCDHFMNIEBCDJKL $.
  $}

  ${
    eldifbd.1 $e |- ( ph -> A e. ( B \ C ) ) $.
    $( If a class is in the difference of two classes, it is not in the
       subtrahend.  One-way deduction form of ~ eldif .  (Contributed by David
       Moews, 1-May-2017.) $)
    eldifbd $p |- ( ph -> -. A e. C ) $=
      ( wcel wn cdif wa eldif sylib simprd ) ABCFZBDFGZABCDHFMNIEBCDJKL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Subclasses and subsets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)
  $( Define the subclass relationship.  Exercise 9 of [TakeutiZaring] p. 18.
     For example, ` { 1 , 2 } C_ { 1 , 2 , 3 } ` ( ~ ex-ss ).  Note that
     ` A C_ A ` (proved in ~ ssid ).  Contrast this relationship with the
     relationship ` A C. B ` (as will be defined in ~ df-pss ).  For a more
     traditional definition, but requiring a dummy variable, see ~ dfss2 .
     Other possible definitions are given by ~ dfss3 , ~ dfss4 , ~ sspss ,
     ~ ssequn1 , ~ ssequn2 , ~ sseqin2 , and ~ ssdif0 .  (Contributed by NM,
     27-Apr-1994.) $)
  df-ss $a |- ( A C_ B <-> ( A i^i B ) = A ) $.

  $( Variant of subclass definition ~ df-ss .  (Contributed by NM,
     3-Sep-2004.) $)
  dfss $p |- ( A C_ B <-> A = ( A i^i B ) ) $=
    ( wss cin wceq df-ss eqcom bitri ) ABCABDZAEAIEABFIAGH $.

  $( Define proper subclass relationship between two classes.  Definition 5.9
     of [TakeutiZaring] p. 17.  For example, ` { 1 , 2 } C. { 1 , 2 , 3 } `
     ( ~ ex-pss ).  Note that ` -. A C. A ` (proved in ~ pssirr ).  Contrast
     this relationship with the relationship ` A C_ B ` (as defined in
     ~ df-ss ).  Other possible definitions are given by ~ dfpss2 and
     ~ dfpss3 .  (Contributed by NM, 7-Feb-1996.) $)
  df-pss $a |- ( A C. B <-> ( A C_ B /\ A =/= B ) ) $.

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of the subclass relationship between two classes.
       Definition 5.9 of [TakeutiZaring] p. 17.  (Contributed by NM,
       8-Jan-2002.) $)
    dfss2 $p |- ( A C_ B <-> A. x ( x e. A -> x e. B ) ) $=
      ( wss cv wcel wa wb wal wi cin wceq dfss df-in eqeq2i abeq2 3bitri pm4.71
      cab albii bitr4i ) BCDZAEZBFZUDUCCFZGZHZAIZUDUEJZAIUBBBCKZLBUFASZLUHBCMUJ
      UKBABCNOUFABPQUIUGAUDUERTUA $.

    $( Alternate definition of subclass relationship.  (Contributed by NM,
       14-Oct-1999.) $)
    dfss3 $p |- ( A C_ B <-> A. x e. A x e. B ) $=
      ( wss cv wcel wi wal wral dfss2 df-ral bitr4i ) BCDAEZBFMCFZGAHNABIABCJNA
      BKL $.
  $}

  ${
    $d z y A $.  $d z y B $.  $d x z $.
    dfss2f.1 $e |- F/_ x A $.
    dfss2f.2 $e |- F/_ x B $.
    $( Equivalence for subclass relation, using bound-variable hypotheses
       instead of distinct variable conditions.  (Contributed by NM,
       3-Jul-1994.)  (Revised by Andrew Salmon, 27-Aug-2011.) $)
    dfss2f $p |- ( A C_ B <-> A. x ( x e. A -> x e. B ) ) $=
      ( vz wss cv wcel wal dfss2 nfcri nfim nfv weq eleq1 imbi12d cbval bitri
      wi ) BCGFHZBIZUACIZTZFJAHZBIZUECIZTZAJFBCKUDUHFAUBUCAAFBDLAFCELMUHFNFAOUB
      UFUCUGUAUEBPUAUECPQRS $.

    $d y A $.  $d y B $.
    $( Equivalence for subclass relation, using bound-variable hypotheses
       instead of distinct variable conditions.  (Contributed by NM,
       20-Mar-2004.) $)
    dfss3f $p |- ( A C_ B <-> A. x e. A x e. B ) $=
      ( wss cv wcel wi wal wral dfss2f df-ral bitr4i ) BCFAGZBHOCHZIAJPABKABCDE
      LPABMN $.

    $( If ` x ` is not free in ` A ` and ` B ` , it is not free in
       ` A C_ B ` .  (Contributed by NM, 27-Dec-1996.) $)
    nfss $p |- F/ x A C_ B $=
      ( wss cv wcel wral dfss3f nfra1 nfxfr ) BCFAGCHZABIAABCDEJMABKL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Membership relationships follow from a subclass relationship.
       (Contributed by NM, 5-Aug-1993.) $)
    ssel $p |- ( A C_ B -> ( C e. A -> C e. B ) ) $=
      ( vx wss cv wceq wa wex wi wal dfss2 biimpi 19.21bi anim2d eximdv df-clel
      wcel 3imtr4g ) ABEZDFZCGZUAARZHZDIUBUABRZHZDICARCBRTUDUFDTUCUEUBTUCUEJZDT
      UGDKDABLMNOPDCAQDCBQS $.
  $}

  $( Membership relationships follow from a subclass relationship.
     (Contributed by NM, 7-Jun-2004.) $)
  ssel2 $p |- ( ( A C_ B /\ C e. A ) -> C e. B ) $=
    ( wss wcel ssel imp ) ABDCAECBEABCFG $.

  ${
    sseli.1 $e |- A C_ B $.
    $( Membership inference from subclass relationship.  (Contributed by NM,
       5-Aug-1993.) $)
    sseli $p |- ( C e. A -> C e. B ) $=
      ( wss wcel wi ssel ax-mp ) ABECAFCBFGDABCHI $.

    ${
      sselii.2 $e |- C e. A $.
      $( Membership inference from subclass relationship.  (Contributed by NM,
         31-May-1999.) $)
      sselii $p |- C e. B $=
        ( wcel sseli ax-mp ) CAFCBFEABCDGH $.
    $}

    ${
      sseldi.2 $e |- ( ph -> C e. A ) $.
      $( Membership inference from subclass relationship.  (Contributed by NM,
         25-Jun-2014.) $)
      sseldi $p |- ( ph -> C e. B ) $=
        ( wcel sseli syl ) ADBGDCGFBCDEHI $.
    $}
  $}

  ${
    sseld.1 $e |- ( ph -> A C_ B ) $.
    $( Membership deduction from subclass relationship.  (Contributed by NM,
       15-Nov-1995.) $)
    sseld $p |- ( ph -> ( C e. A -> C e. B ) ) $=
      ( wss wcel wi ssel syl ) ABCFDBGDCGHEBCDIJ $.

    $( Membership deduction from subclass relationship.  (Contributed by NM,
       26-Jun-2014.) $)
    sselda $p |- ( ( ph /\ C e. A ) -> C e. B ) $=
      ( wcel sseld imp ) ADBFDCFABCDEGH $.

    ${
      sseldd.2 $e |- ( ph -> C e. A ) $.
      $( Membership inference from subclass relationship.  (Contributed by NM,
         14-Dec-2004.) $)
      sseldd $p |- ( ph -> C e. B ) $=
        ( wcel sseld mpd ) ADBGDCGFABCDEHI $.
    $}
  $}

  ${
    ssneld.1 $e |- ( ph -> A C_ B ) $.
    $( If a class is not in another class, it is also not in a subclass of that
       class.  Deduction form.  (Contributed by David Moews, 1-May-2017.) $)
    ssneld $p |- ( ph -> ( -. C e. B -> -. C e. A ) ) $=
      ( wcel sseld con3d ) ADBFDCFABCDEGH $.

    ssneldd.2 $e |- ( ph -> -. C e. B ) $.
    $( If an element is not in a class, it is also not in a subclass of that
       class.  Deduction form.  (Contributed by David Moews, 1-May-2017.) $)
    ssneldd $p |- ( ph -> -. C e. A ) $=
      ( wcel wn ssneld mpd ) ADCGHDBGHFABCDEIJ $.
  $}

  ${
    $d x A $.  $d x B $.
    ssriv.1 $e |- ( x e. A -> x e. B ) $.
    $( Inference rule based on subclass definition.  (Contributed by NM,
       5-Aug-1993.) $)
    ssriv $p |- A C_ B $=
      ( wss cv wcel wi dfss2 mpgbir ) BCEAFZBGKCGHAABCIDJ $.
  $}

  ${
    ssrd.0 $e |- F/ x ph $.
    ssrd.1 $e |- F/_ x A $.
    ssrd.2 $e |- F/_ x B $.
    ssrd.3 $e |- ( ph -> ( x e. A -> x e. B ) ) $.
    $( Deduction rule based on subclass definition.  (Contributed by Thierry
       Arnoux, 8-Mar-2017.) $)
    ssrd $p |- ( ph -> A C_ B ) $=
      ( cv wcel wi wal wss alrimi dfss2f sylibr ) ABIZCJQDJKZBLCDMARBEHNBCDFGOP
      $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    ssrdv.1 $e |- ( ph -> ( x e. A -> x e. B ) ) $.
    $( Deduction rule based on subclass definition.  (Contributed by NM,
       15-Nov-1995.) $)
    ssrdv $p |- ( ph -> A C_ B ) $=
      ( cv wcel wi wal wss alrimiv dfss2 sylibr ) ABFZCGNDGHZBICDJAOBEKBCDLM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Transitivity of subclasses.  Exercise 5 of [TakeutiZaring] p. 17.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       14-Jun-2011.) $)
    sstr2 $p |- ( A C_ B -> ( B C_ C -> A C_ C ) ) $=
      ( vx wss cv wcel wi wal ssel imim1d alimdv dfss2 3imtr4g ) ABEZDFZBGZPCGZ
      HZDIPAGZRHZDIBCEACEOSUADOTQRABPJKLDBCMDACMN $.
  $}

  $( Transitivity of subclasses.  Theorem 6 of [Suppes] p. 23.  (Contributed by
     NM, 5-Sep-2003.) $)
  sstr $p |- ( ( A C_ B /\ B C_ C ) -> A C_ C ) $=
    ( wss sstr2 imp ) ABDBCDACDABCEF $.

  ${
    sstri.1 $e |- A C_ B $.
    sstri.2 $e |- B C_ C $.
    $( Subclass transitivity inference.  (Contributed by NM, 5-May-2000.) $)
    sstri $p |- A C_ C $=
      ( wss sstr2 mp2 ) ABFBCFACFDEABCGH $.
  $}

  ${
    sstrd.1 $e |- ( ph -> A C_ B ) $.
    sstrd.2 $e |- ( ph -> B C_ C ) $.
    $( Subclass transitivity deduction.  (Contributed by NM, 2-Jun-2004.) $)
    sstrd $p |- ( ph -> A C_ C ) $=
      ( wss sstr syl2anc ) ABCGCDGBDGEFBCDHI $.
  $}

  ${
    syl5ss.1 $e |- A C_ B $.
    syl5ss.2 $e |- ( ph -> B C_ C ) $.
    $( Subclass transitivity deduction.  (Contributed by NM, 6-Feb-2014.) $)
    syl5ss $p |- ( ph -> A C_ C ) $=
      ( wss a1i sstrd ) ABCDBCGAEHFI $.
  $}

  ${
    syl6ss.1 $e |- ( ph -> A C_ B ) $.
    syl6ss.2 $e |- B C_ C $.
    $( Subclass transitivity deduction.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.) $)
    syl6ss $p |- ( ph -> A C_ C ) $=
      ( wss a1i sstrd ) ABCDECDGAFHI $.
  $}

  ${
    sylan9ss.1 $e |- ( ph -> A C_ B ) $.
    sylan9ss.2 $e |- ( ps -> B C_ C ) $.
    $( A subclass transitivity deduction.  (Contributed by NM, 27-Sep-2004.)
       (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
    sylan9ss $p |- ( ( ph /\ ps ) -> A C_ C ) $=
      ( wss sstr syl2an ) ACDHDEHCEHBFGCDEIJ $.
  $}

  ${
    sylan9ssr.1 $e |- ( ph -> A C_ B ) $.
    sylan9ssr.2 $e |- ( ps -> B C_ C ) $.
    $( A subclass transitivity deduction.  (Contributed by NM, 27-Sep-2004.) $)
    sylan9ssr $p |- ( ( ps /\ ph ) -> A C_ C ) $=
      ( wss sylan9ss ancoms ) ABCEHABCDEFGIJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The subclass relationship is antisymmetric.  Compare Theorem 4 of
       [Suppes] p. 22.  (Contributed by NM, 5-Aug-1993.) $)
    eqss $p |- ( A = B <-> ( A C_ B /\ B C_ A ) ) $=
      ( vx cv wcel wb wal wi wa wceq wss albiim dfcleq dfss2 anbi12i 3bitr4i )
      CDZAEZQBEZFCGRSHCGZSRHCGZIABJABKZBAKZIRSCLCABMUBTUCUACABNCBANOP $.
  $}

  ${
    eqssi.1 $e |- A C_ B $.
    eqssi.2 $e |- B C_ A $.
    $( Infer equality from two subclass relationships.  Compare Theorem 4 of
       [Suppes] p. 22.  (Contributed by NM, 9-Sep-1993.) $)
    eqssi $p |- A = B $=
      ( wceq wss eqss mpbir2an ) ABEABFBAFCDABGH $.
  $}

  ${
    eqssd.1 $e |- ( ph -> A C_ B ) $.
    eqssd.2 $e |- ( ph -> B C_ A ) $.
    $( Equality deduction from two subclass relationships.  Compare Theorem 4
       of [Suppes] p. 22.  (Contributed by NM, 27-Jun-2004.) $)
    eqssd $p |- ( ph -> A = B ) $=
      ( wss wceq eqss sylanbrc ) ABCFCBFBCGDEBCHI $.
  $}

  ${
    eqrd.0 $e |- F/ x ph $.
    eqrd.1 $e |- F/_ x A $.
    eqrd.2 $e |- F/_ x B $.
    eqrd.3 $e |- ( ph -> ( x e. A <-> x e. B ) ) $.
    $( Deduce equality of classes from equivalence of membership.  (Contributed
       by Thierry Arnoux, 21-Mar-2017.) $)
    eqrd $p |- ( ph -> A = B ) $=
      ( cv wcel biimpd ssrd biimprd eqssd ) ACDABCDEFGABIZCJZODJZHKLABDCEGFAPQH
      MLN $.
  $}

  ${
    $d A x $.
    $( Any class is a subclass of itself.  Exercise 10 of [TakeutiZaring]
       p. 18.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
       Salmon, 14-Jun-2011.) $)
    ssid $p |- A C_ A $=
      ( vx cv wcel id ssriv ) BAABCADEF $.
  $}

  ${
    $d A x $.
    $( Any class is a subclass of the universal class.  (Contributed by NM,
       31-Oct-1995.) $)
    ssv $p |- A C_ _V $=
      ( vx cvv cv elex ssriv ) BACBDAEF $.
  $}

  $( Equality theorem for subclasses.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 21-Jun-2011.) $)
  sseq1 $p |- ( A = B -> ( A C_ C <-> B C_ C ) ) $=
    ( wceq wss wa wb eqss wi sstr2 adantl adantr impbid sylbi ) ABDABEZBAEZFZAC
    EZBCEZGABHQRSPRSIOBACJKOSRIPABCJLMN $.

  $( Equality theorem for the subclass relationship.  (Contributed by NM,
     25-Jun-1998.) $)
  sseq2 $p |- ( A = B -> ( C C_ A <-> C C_ B ) ) $=
    ( wss wa wi wceq wb sstr2 com12 anim12i eqss dfbi2 3imtr4i ) ABDZBADZECADZC
    BDZFZRQFZEABGQRHOSPTQORCABIJRPQCBAIJKABLQRMN $.

  $( Equality theorem for the subclass relationship.  (Contributed by NM,
     31-May-1999.) $)
  sseq12 $p |- ( ( A = B /\ C = D ) -> ( A C_ C <-> B C_ D ) ) $=
    ( wceq wss sseq1 sseq2 sylan9bb ) ABEACFBCFCDEBDFABCGCDBHI $.

  ${
    sseq1i.1 $e |- A = B $.
    $( An equality inference for the subclass relationship.  (Contributed by
       NM, 18-Aug-1993.) $)
    sseq1i $p |- ( A C_ C <-> B C_ C ) $=
      ( wceq wss wb sseq1 ax-mp ) ABEACFBCFGDABCHI $.

    $( An equality inference for the subclass relationship.  (Contributed by
       NM, 30-Aug-1993.) $)
    sseq2i $p |- ( C C_ A <-> C C_ B ) $=
      ( wceq wss wb sseq2 ax-mp ) ABECAFCBFGDABCHI $.

    ${
      sseq12i.2 $e |- C = D $.
      $( An equality inference for the subclass relationship.  (Contributed by
         NM, 31-May-1999.)  (Proof shortened by Eric Schmidt, 26-Jan-2007.) $)
      sseq12i $p |- ( A C_ C <-> B C_ D ) $=
        ( wceq wss wb sseq12 mp2an ) ABGCDGACHBDHIEFABCDJK $.
    $}
  $}

  ${
    sseq1d.1 $e |- ( ph -> A = B ) $.
    $( An equality deduction for the subclass relationship.  (Contributed by
       NM, 14-Aug-1994.) $)
    sseq1d $p |- ( ph -> ( A C_ C <-> B C_ C ) ) $=
      ( wceq wss wb sseq1 syl ) ABCFBDGCDGHEBCDIJ $.

    $( An equality deduction for the subclass relationship.  (Contributed by
       NM, 14-Aug-1994.) $)
    sseq2d $p |- ( ph -> ( C C_ A <-> C C_ B ) ) $=
      ( wceq wss wb sseq2 syl ) ABCFDBGDCGHEBCDIJ $.

    ${
      sseq12d.2 $e |- ( ph -> C = D ) $.
      $( An equality deduction for the subclass relationship.  (Contributed by
         NM, 31-May-1999.) $)
      sseq12d $p |- ( ph -> ( A C_ C <-> B C_ D ) ) $=
        ( wss sseq1d sseq2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.
    $}
  $}

  ${
    eqsstr.1 $e |- A = B $.
    eqsstr.2 $e |- B C_ C $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 16-Jul-1995.) $)
    eqsstri $p |- A C_ C $=
      ( wss sseq1i mpbir ) ACFBCFEABCDGH $.
  $}

  ${
    eqsstr3.1 $e |- B = A $.
    eqsstr3.2 $e |- B C_ C $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 19-Oct-1999.) $)
    eqsstr3i $p |- A C_ C $=
      ( eqcomi eqsstri ) ABCBADFEG $.
  $}

  ${
    sseqtr.1 $e |- A C_ B $.
    sseqtr.2 $e |- B = C $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 28-Jul-1995.) $)
    sseqtri $p |- A C_ C $=
      ( wss sseq2i mpbi ) ABFACFDBCAEGH $.
  $}

  ${
    sseqtr4.1 $e |- A C_ B $.
    sseqtr4.2 $e |- C = B $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 4-Apr-1995.) $)
    sseqtr4i $p |- A C_ C $=
      ( eqcomi sseqtri ) ABCDCBEFG $.
  $}

  ${
    eqsstrd.1 $e |- ( ph -> A = B ) $.
    eqsstrd.2 $e |- ( ph -> B C_ C ) $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 25-Apr-2004.) $)
    eqsstrd $p |- ( ph -> A C_ C ) $=
      ( wss sseq1d mpbird ) ABDGCDGFABCDEHI $.
  $}

  ${
    eqsstr3d.1 $e |- ( ph -> B = A ) $.
    eqsstr3d.2 $e |- ( ph -> B C_ C ) $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 25-Apr-2004.) $)
    eqsstr3d $p |- ( ph -> A C_ C ) $=
      ( eqcomd eqsstrd ) ABCDACBEGFH $.
  $}

  ${
    sseqtrd.1 $e |- ( ph -> A C_ B ) $.
    sseqtrd.2 $e |- ( ph -> B = C ) $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 25-Apr-2004.) $)
    sseqtrd $p |- ( ph -> A C_ C ) $=
      ( wss sseq2d mpbid ) ABCGBDGEACDBFHI $.
  $}

  ${
    sseqtr4d.1 $e |- ( ph -> A C_ B ) $.
    sseqtr4d.2 $e |- ( ph -> C = B ) $.
    $( Substitution of equality into a subclass relationship.  (Contributed by
       NM, 25-Apr-2004.) $)
    sseqtr4d $p |- ( ph -> A C_ C ) $=
      ( eqcomd sseqtrd ) ABCDEADCFGH $.
  $}

  ${
    3sstr3.1 $e |- A C_ B $.
    3sstr3.2 $e |- A = C $.
    3sstr3.3 $e |- B = D $.
    $( Substitution of equality in both sides of a subclass relationship.
       (Contributed by NM, 13-Jan-1996.)  (Proof shortened by Eric Schmidt,
       26-Jan-2007.) $)
    3sstr3i $p |- C C_ D $=
      ( wss sseq12i mpbi ) ABHCDHEACBDFGIJ $.
  $}

  ${
    3sstr4.1 $e |- A C_ B $.
    3sstr4.2 $e |- C = A $.
    3sstr4.3 $e |- D = B $.
    $( Substitution of equality in both sides of a subclass relationship.
       (Contributed by NM, 13-Jan-1996.)  (Proof shortened by Eric Schmidt,
       26-Jan-2007.) $)
    3sstr4i $p |- C C_ D $=
      ( wss sseq12i mpbir ) CDHABHECADBFGIJ $.
  $}

  ${
    3sstr3g.1 $e |- ( ph -> A C_ B ) $.
    3sstr3g.2 $e |- A = C $.
    3sstr3g.3 $e |- B = D $.
    $( Substitution of equality into both sides of a subclass relationship.
       (Contributed by NM, 1-Oct-2000.) $)
    3sstr3g $p |- ( ph -> C C_ D ) $=
      ( wss sseq12i sylib ) ABCIDEIFBDCEGHJK $.
  $}

  ${
    3sstr4g.1 $e |- ( ph -> A C_ B ) $.
    3sstr4g.2 $e |- C = A $.
    3sstr4g.3 $e |- D = B $.
    $( Substitution of equality into both sides of a subclass relationship.
       (Contributed by NM, 16-Aug-1994.)  (Proof shortened by Eric Schmidt,
       26-Jan-2007.) $)
    3sstr4g $p |- ( ph -> C C_ D ) $=
      ( wss sseq12i sylibr ) ABCIDEIFDBECGHJK $.
  $}

  ${
    3sstr3d.1 $e |- ( ph -> A C_ B ) $.
    3sstr3d.2 $e |- ( ph -> A = C ) $.
    3sstr3d.3 $e |- ( ph -> B = D ) $.
    $( Substitution of equality into both sides of a subclass relationship.
       (Contributed by NM, 1-Oct-2000.) $)
    3sstr3d $p |- ( ph -> C C_ D ) $=
      ( wss sseq12d mpbid ) ABCIDEIFABDCEGHJK $.
  $}

  ${
    3sstr4d.1 $e |- ( ph -> A C_ B ) $.
    3sstr4d.2 $e |- ( ph -> C = A ) $.
    3sstr4d.3 $e |- ( ph -> D = B ) $.
    $( Substitution of equality into both sides of a subclass relationship.
       (Contributed by NM, 30-Nov-1995.)  (Proof shortened by Eric Schmidt,
       26-Jan-2007.) $)
    3sstr4d $p |- ( ph -> C C_ D ) $=
      ( wss sseq12d mpbird ) ADEIBCIFADBECGHJK $.
  $}

  ${
    syl5eqss.1 $e |- A = B $.
    syl5eqss.2 $e |- ( ph -> B C_ C ) $.
    $( B chained subclass and equality deduction.  (Contributed by NM,
       25-Apr-2004.) $)
    syl5eqss $p |- ( ph -> A C_ C ) $=
      ( wss sseq1i sylibr ) ACDGBDGFBCDEHI $.
  $}

  ${
    syl5eqssr.1 $e |- B = A $.
    syl5eqssr.2 $e |- ( ph -> B C_ C ) $.
    $( B chained subclass and equality deduction.  (Contributed by NM,
       25-Apr-2004.) $)
    syl5eqssr $p |- ( ph -> A C_ C ) $=
      ( eqcomi syl5eqss ) ABCDCBEGFH $.
  $}

  ${
    syl6sseq.1 $e |- ( ph -> A C_ B ) $.
    syl6sseq.2 $e |- B = C $.
    $( A chained subclass and equality deduction.  (Contributed by NM,
       25-Apr-2004.) $)
    syl6sseq $p |- ( ph -> A C_ C ) $=
      ( wss sseq2i sylib ) ABCGBDGECDBFHI $.
  $}

  ${
    syl6ssr.1 $e |- ( ph -> A C_ B ) $.
    syl6ssr.2 $e |- C = B $.
    $( A chained subclass and equality deduction.  (Contributed by NM,
       25-Apr-2004.) $)
    syl6sseqr $p |- ( ph -> A C_ C ) $=
      ( eqcomi syl6sseq ) ABCDEDCFGH $.
  $}

  ${
    syl5sseq.1 $e |- B C_ A $.
    syl5sseq.2 $e |- ( ph -> A = C ) $.
    $( Subclass transitivity deduction.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.) $)
    syl5sseq $p |- ( ph -> B C_ C ) $=
      ( wceq wss sseq2 biimpa sylancl ) ABDGZCBHZCDHZFELMNBDCIJK $.
  $}

  ${
    syl5sseqr.1 $e |- B C_ A $.
    syl5sseqr.2 $e |- ( ph -> C = A ) $.
    $( Subclass transitivity deduction.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.) $)
    syl5sseqr $p |- ( ph -> B C_ C ) $=
      ( wss a1i sseqtr4d ) ACBDCBGAEHFI $.
  $}

  ${
    syl6eqss.1 $e |- ( ph -> A = B ) $.
    syl6eqss.2 $e |- B C_ C $.
    $( A chained subclass and equality deduction.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    syl6eqss $p |- ( ph -> A C_ C ) $=
      ( wss a1i eqsstrd ) ABCDECDGAFHI $.
  $}

  ${
    syl6eqssr.1 $e |- ( ph -> B = A ) $.
    syl6eqssr.2 $e |- B C_ C $.
    $( A chained subclass and equality deduction.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    syl6eqssr $p |- ( ph -> A C_ C ) $=
      ( eqcomd syl6eqss ) ABCDACBEGFH $.
  $}

  $( Equality implies the subclass relation.  (Contributed by NM, 5-Aug-1993.)
     (Proof shortened by Andrew Salmon, 21-Jun-2011.) $)
  eqimss $p |- ( A = B -> A C_ B ) $=
    ( wceq wss eqss simplbi ) ABCABDBADABEF $.

  $( Equality implies the subclass relation.  (Contributed by NM,
     23-Nov-2003.) $)
  eqimss2 $p |- ( B = A -> A C_ B ) $=
    ( wss eqimss eqcoms ) ABCABABDE $.

  ${
    eqimssi.1 $e |- A = B $.
    $( Infer subclass relationship from equality.  (Contributed by NM,
       6-Jan-2007.) $)
    eqimssi $p |- A C_ B $=
      ( ssid sseqtri ) AABADCE $.

    $( Infer subclass relationship from equality.  (Contributed by NM,
       7-Jan-2007.) $)
    eqimss2i $p |- B C_ A $=
      ( ssid sseqtr4i ) BBABDCE $.
  $}

  $( Two classes are different if they don't include the same class.
     (Contributed by NM, 23-Apr-2015.) $)
  nssne1 $p |- ( ( A C_ B /\ -. A C_ C ) -> B =/= C ) $=
    ( wss wn wne wceq sseq2 biimpcd necon3bd imp ) ABDZACDZEBCFLMBCBCGLMBCAHIJK
    $.

  $( Two classes are different if they are not subclasses of the same class.
     (Contributed by NM, 23-Apr-2015.) $)
  nssne2 $p |- ( ( A C_ C /\ -. B C_ C ) -> A =/= B ) $=
    ( wss wn wne wceq sseq1 biimpcd necon3bd imp ) ACDZBCDZEABFLMABABGLMABCHIJK
    $.

  ${
    $d x A $.  $d x B $.
    $( Negation of subclass relationship.  Exercise 13 of [TakeutiZaring]
       p. 18.  (Contributed by NM, 25-Feb-1996.)  (Proof shortened by Andrew
       Salmon, 21-Jun-2011.) $)
    nss $p |- ( -. A C_ B <-> E. x ( x e. A /\ -. x e. B ) ) $=
      ( cv wcel wn wa wex wss wi wal exanali dfss2 xchbinxr bicomi ) ADZBEZPCEZ
      FGAHZBCIZFSQRJAKTQRALABCMNO $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Quantification restricted to a subclass.  (Contributed by NM,
       11-Mar-2006.) $)
    ssralv $p |- ( A C_ B -> ( A. x e. B ph -> A. x e. A ph ) ) $=
      ( wss cv wcel ssel imim1d ralimdv2 ) CDEZAABDCKBFZCGLDGACDLHIJ $.

    $( Existential quantification restricted to a subclass.  (Contributed by
       NM, 11-Jan-2007.) $)
    ssrexv $p |- ( A C_ B -> ( E. x e. A ph -> E. x e. B ph ) ) $=
      ( wss cv wcel ssel anim1d reximdv2 ) CDEZAABCDKBFZCGLDGACDLHIJ $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Restricted universal quantification on a subset in terms of superset.
       (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    ralss $p |- ( A C_ B -> ( A. x e. A ph <->
          A. x e. B ( x e. A -> ph ) ) ) $=
      ( wss cv wcel wi wa ssel pm4.71rd imbi1d impexp syl6bb ralbidv2 ) CDEZABF
      ZCGZAHZBCDPSQDGZRIZAHTSHPRUAAPRTCDQJKLTRAMNO $.

    $( Restricted existential quantification on a subset in terms of superset.
       (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    rexss $p |- ( A C_ B -> ( E. x e. A ph <->
          E. x e. B ( x e. A /\ ph ) ) ) $=
      ( wss cv wcel wa ssel pm4.71rd anbi1d anass syl6bb rexbidv2 ) CDEZABFZCGZ
      AHZBCDORPDGZQHZAHSRHOQTAOQSCDPIJKSQALMN $.
  $}

  ${
    $d ph y $.  $d ps y $.  $d x y $.
    $( Class abstractions in a subclass relationship.  (Contributed by NM,
       3-Jul-1994.) $)
    ss2ab $p |- ( { x | ph } C_ { x | ps } <-> A. x ( ph -> ps ) ) $=
      ( cab wss cv wcel wi wal nfab1 dfss2f abid imbi12i albii bitri ) ACDZBCDZ
      ECFZPGZRQGZHZCIABHZCICPQACJBCJKUAUBCSATBACLBCLMNO $.
  $}

  ${
    $d x A $.
    $( Class abstraction in a subclass relationship.  (Contributed by NM,
       16-Aug-2006.) $)
    abss $p |- ( { x | ph } C_ A <-> A. x ( ph -> x e. A ) ) $=
      ( cab wss cv wcel wi wal abid2 sseq2i ss2ab bitr3i ) ABDZCENBFCGZBDZEAOHB
      IPCNBCJKAOBLM $.

    $( Subclass of a class abstraction.  (Contributed by NM, 16-Aug-2006.) $)
    ssab $p |- ( A C_ { x | ph } <-> A. x ( x e. A -> ph ) ) $=
      ( cab wss cv wcel wi wal abid2 sseq1i ss2ab bitr3i ) CABDZEBFCGZBDZNEOAHB
      IPCNBCJKOABLM $.

    $( The relation for a subclass of a class abstraction is equivalent to
       restricted quantification.  (Contributed by NM, 6-Sep-2006.) $)
    ssabral $p |- ( A C_ { x | ph } <-> A. x e. A ph ) $=
      ( cab wss cv wcel wi wal wral ssab df-ral bitr4i ) CABDEBFCGAHBIABCJABCKA
      BCLM $.
  $}

  ${
    ss2abi.1 $e |- ( ph -> ps ) $.
    $( Inference of abstraction subclass from implication.  (Contributed by NM,
       31-Mar-1995.) $)
    ss2abi $p |- { x | ph } C_ { x | ps } $=
      ( cab wss wi ss2ab mpgbir ) ACEBCEFABGCABCHDI $.
  $}

  ${
    $d x ph $.
    ss2abdv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Deduction of abstraction subclass from implication.  (Contributed by NM,
       29-Jul-2011.) $)
    ss2abdv $p |- ( ph -> { x | ps } C_ { x | ch } ) $=
      ( wi wal cab wss alrimiv ss2ab sylibr ) ABCFZDGBDHCDHIAMDEJBCDKL $.
  $}

  ${
    $d x ph $.  $d x A $.
    abssdv.1 $e |- ( ph -> ( ps -> x e. A ) ) $.
    $( Deduction of abstraction subclass from implication.  (Contributed by NM,
       20-Jan-2006.) $)
    abssdv $p |- ( ph -> { x | ps } C_ A ) $=
      ( cv wcel wi wal cab wss alrimiv abss sylibr ) ABCFDGHZCIBCJDKAOCELBCDMN
      $.
  $}

  ${
    $d x A $.
    abssi.1 $e |- ( ph -> x e. A ) $.
    $( Inference of abstraction subclass from implication.  (Contributed by NM,
       20-Jan-2006.) $)
    abssi $p |- { x | ph } C_ A $=
      ( cab cv wcel ss2abi abid2 sseqtri ) ABEBFCGZBECAKBDHBCIJ $.
  $}

  $( Restricted abstraction classes in a subclass relationship.  (Contributed
     by NM, 30-May-1999.) $)
  ss2rab $p |- ( { x e. A | ph } C_ { x e. A | ps } <->
               A. x e. A ( ph -> ps ) ) $=
    ( crab wss cv wcel wa cab wi wal df-rab sseq12i ss2ab df-ral imdistan albii
    wral bitr2i 3bitri ) ACDEZBCDEZFCGDHZAIZCJZUDBIZCJZFUEUGKZCLZABKZCDSZUBUFUC
    UHACDMBCDMNUEUGCOULUDUKKZCLUJUKCDPUMUICUDABQRTUA $.

  ${
    $d x B $.
    $( Restricted class abstraction in a subclass relationship.  (Contributed
       by NM, 16-Aug-2006.) $)
    rabss $p |- ( { x e. A | ph } C_ B <-> A. x e. A ( ph -> x e. B ) ) $=
      ( crab wss cv wcel wa cab wal wral df-rab sseq1i abss impexp albii df-ral
      wi bitr4i 3bitri ) ABCEZDFBGZCHZAIZBJZDFUEUCDHZSZBKZAUGSZBCLZUBUFDABCMNUE
      BDOUIUDUJSZBKUKUHULBUDAUGPQUJBCRTUA $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass of a restricted class abstraction.  (Contributed by NM,
       16-Aug-2006.) $)
    ssrab $p |- ( B C_ { x e. A | ph } <-> ( B C_ A /\ A. x e. B ph ) ) $=
      ( crab wss cv wcel wa cab wal wral df-rab sseq2i ssab dfss3 anbi1i r19.26
      wi df-ral 3bitr2ri 3bitri ) DABCEZFDBGZCHZAIZBJZFUDDHUFSBKZDCFZABDLZIZUCU
      GDABCMNUFBDOUKUEBDLZUJIUFBDLUHUIULUJBDCPQUEABDRUFBDTUAUB $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    ssrabdv.1 $e |- ( ph -> B C_ A ) $.
    ssrabdv.2 $e |- ( ( ph /\ x e. B ) -> ps ) $.
    $( Subclass of a restricted class abstraction (deduction rule).
       (Contributed by NM, 31-Aug-2006.) $)
    ssrabdv $p |- ( ph -> B C_ { x e. A | ps } ) $=
      ( wss wral crab ralrimiva ssrab sylanbrc ) AEDHBCEIEBCDJHFABCEGKBCDELM $.
  $}

  ${
    $d x B $.  $d x ph $.
    rabssdv.1 $e |- ( ( ph /\ x e. A /\ ps ) -> x e. B ) $.
    $( Subclass of a restricted class abstraction (deduction rule).
       (Contributed by NM, 2-Feb-2015.) $)
    rabssdv $p |- ( ph -> { x e. A | ps } C_ B ) $=
      ( cv wcel wi wral crab wss 3exp ralrimiv rabss sylibr ) ABCGZEHZIZCDJBCDK
      ELASCDAQDHBRFMNBCDEOP $.
  $}

  ${
    $d x ph $.
    ss2rabdv.1 $e |- ( ( ph /\ x e. A ) -> ( ps -> ch ) ) $.
    $( Deduction of restricted abstraction subclass from implication.
       (Contributed by NM, 30-May-2006.) $)
    ss2rabdv $p |- ( ph -> { x e. A | ps } C_ { x e. A | ch } ) $=
      ( wi wral crab wss ralrimiva ss2rab sylibr ) ABCGZDEHBDEICDEIJANDEFKBCDEL
      M $.
  $}

  ${
    ss2rabi.1 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Inference of restricted abstraction subclass from implication.
       (Contributed by NM, 14-Oct-1999.) $)
    ss2rabi $p |- { x e. A | ph } C_ { x e. A | ps } $=
      ( crab wss wi ss2rab mprgbir ) ACDFBCDFGABHCDABCDIEJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass law for restricted abstraction.  (Contributed by NM,
       18-Dec-2004.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    rabss2 $p |- ( A C_ B -> { x e. A | ph } C_ { x e. B | ph } ) $=
      ( wss cv wcel wa cab crab wi wal pm3.45 alimi dfss2 ss2ab 3imtr4i 3sstr4g
      df-rab ) CDEZBFZCGZAHZBIZUADGZAHZBIZABCJABDJUBUEKZBLUCUFKZBLTUDUGEUHUIBUB
      UEAMNBCDOUCUFBPQABCSABDSR $.

    $( Subclass relation for the restriction of a class abstraction.
       (Contributed by NM, 31-Mar-1995.) $)
    ssab2 $p |- { x | ( x e. A /\ ph ) } C_ A $=
      ( cv wcel wa simpl abssi ) BDCEZAFBCIAGH $.

    $( Subclass relation for a restricted class.  (Contributed by NM,
       19-Mar-1997.) $)
    ssrab2 $p |- { x e. A | ph } C_ A $=
      ( crab cv wcel wa cab df-rab ssab2 eqsstri ) ABCDBECFAGBHCABCIABCJK $.
  $}

  ${
    $d V x $.
    $( If the restricting class of a restricted class abstraction is a subset
       of this restricted class abstraction, it is equal to this restricted
       class abstraction.  (Contributed by Alexander van der Vekens,
       31-Dec-2017.) $)
    ssrabeq $p |- ( V C_ { x e. V | ph } <-> V = { x e. V | ph } ) $=
      ( crab wss wa wceq ssrab2 biantru eqss bitr4i ) CABCDZEZMLCEZFCLGNMABCHIC
      LJK $.
  $}

  $( A restricted class is a subclass of the corresponding unrestricted class.
     (Contributed by Mario Carneiro, 23-Dec-2016.) $)
  rabssab $p |- { x e. A | ph } C_ { x | ph } $=
    ( crab cv wcel wa cab df-rab simpr ss2abi eqsstri ) ABCDBECFZAGZBHABHABCINA
    BMAJKL $.

  ${
    $d x y $.  $d y z A $.  $d y z B $.  $d x z C $.
    $( A subset relationship useful for converting union to indexed union using
       ~ dfiun2 or ~ dfiun2g and intersection to indexed intersection using
       ~ dfiin2 .  (Contributed by NM, 5-Oct-2006.)  (Proof shortened by Mario
       Carneiro, 26-Sep-2015.) $)
    uniiunlem $p |- ( A. x e. A B e. D ->
                     ( A. x e. A B e. C <-> { y | E. x e. A y = B } C_ C ) ) $=
      ( vz cv wceq wrex cab wss wcel wi wal wral eqeq1 rexbidv cbvabv wb sseq1i
      r19.23v albii ralcom4 abss 3bitr4i bitr4i nfv eleq1 ceqsalg ralbi syl5rbb
      ralimi syl ) BHZDIZACJZBKZELZGHZDIZUTEMZNZGOZACPZDFMZACPZDEMZACPZUSVAACJZ
      GKZELZVEURVKEUQVJBGUOUTIUPVAACUOUTDQRSUAVCACPZGOVJVBNZGOVEVLVMVNGVAVBACUB
      UCVCAGCUDVJGEUEUFUGVGVDVHTZACPVEVITVFVOACVBVHGDFVHGUHUTDEUIUJUMVDVHACUKUN
      UL $.
  $}

  $( Alternate definition of proper subclass.  (Contributed by NM,
     7-Feb-1996.) $)
  dfpss2 $p |- ( A C. B <-> ( A C_ B /\ -. A = B ) ) $=
    ( wpss wss wne wa wceq wn df-pss df-ne anbi2i bitri ) ABCABDZABEZFMABGHZFAB
    INOMABJKL $.

  $( Alternate definition of proper subclass.  (Contributed by NM,
     7-Feb-1996.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  dfpss3 $p |- ( A C. B <-> ( A C_ B /\ -. B C_ A ) ) $=
    ( wpss wss wceq wn wa dfpss2 eqss baib notbid pm5.32i bitri ) ABCABDZABEZFZ
    GNBADZFZGABHNPRNOQONQABIJKLM $.

  $( Equality theorem for proper subclass.  (Contributed by NM, 7-Feb-1996.) $)
  psseq1 $p |- ( A = B -> ( A C. C <-> B C. C ) ) $=
    ( wceq wss wne wa wpss sseq1 neeq1 anbi12d df-pss 3bitr4g ) ABDZACEZACFZGBC
    EZBCFZGACHBCHNOQPRABCIABCJKACLBCLM $.

  $( Equality theorem for proper subclass.  (Contributed by NM, 7-Feb-1996.) $)
  psseq2 $p |- ( A = B -> ( C C. A <-> C C. B ) ) $=
    ( wceq wss wne wa wpss sseq2 neeq2 anbi12d df-pss 3bitr4g ) ABDZCAEZCAFZGCB
    EZCBFZGCAHCBHNOQPRABCIABCJKCALCBLM $.

  ${
    psseq1i.1 $e |- A = B $.
    $( An equality inference for the proper subclass relationship.
       (Contributed by NM, 9-Jun-2004.) $)
    psseq1i $p |- ( A C. C <-> B C. C ) $=
      ( wceq wpss wb psseq1 ax-mp ) ABEACFBCFGDABCHI $.

    $( An equality inference for the proper subclass relationship.
       (Contributed by NM, 9-Jun-2004.) $)
    psseq2i $p |- ( C C. A <-> C C. B ) $=
      ( wceq wpss wb psseq2 ax-mp ) ABECAFCBFGDABCHI $.

    ${
      psseq12i.2 $e |- C = D $.
      $( An equality inference for the proper subclass relationship.
         (Contributed by NM, 9-Jun-2004.) $)
      psseq12i $p |- ( A C. C <-> B C. D ) $=
        ( wpss psseq1i psseq2i bitri ) ACGBCGBDGABCEHCDBFIJ $.
    $}
  $}

  ${
    psseq1d.1 $e |- ( ph -> A = B ) $.
    $( An equality deduction for the proper subclass relationship.
       (Contributed by NM, 9-Jun-2004.) $)
    psseq1d $p |- ( ph -> ( A C. C <-> B C. C ) ) $=
      ( wceq wpss wb psseq1 syl ) ABCFBDGCDGHEBCDIJ $.

    $( An equality deduction for the proper subclass relationship.
       (Contributed by NM, 9-Jun-2004.) $)
    psseq2d $p |- ( ph -> ( C C. A <-> C C. B ) ) $=
      ( wceq wpss wb psseq2 syl ) ABCFDBGDCGHEBCDIJ $.

    ${
      psseq12d.2 $e |- ( ph -> C = D ) $.
      $( An equality deduction for the proper subclass relationship.
         (Contributed by NM, 9-Jun-2004.) $)
      psseq12d $p |- ( ph -> ( A C. C <-> B C. D ) ) $=
        ( wpss psseq1d psseq2d bitrd ) ABDHCDHCEHABCDFIADECGJK $.
    $}
  $}

  $( A proper subclass is a subclass.  Theorem 10 of [Suppes] p. 23.
     (Contributed by NM, 7-Feb-1996.) $)
  pssss $p |- ( A C. B -> A C_ B ) $=
    ( wpss wss wne df-pss simplbi ) ABCABDABEABFG $.

  $( Two classes in a proper subclass relationship are not equal.  (Contributed
     by NM, 16-Feb-2015.) $)
  pssne $p |- ( A C. B -> A =/= B ) $=
    ( wpss wss wne df-pss simprbi ) ABCABDABEABFG $.

  ${
    pssssd.1 $e |- ( ph -> A C. B ) $.
    $( Deduce subclass from proper subclass.  (Contributed by NM,
       29-Feb-1996.) $)
    pssssd $p |- ( ph -> A C_ B ) $=
      ( wpss wss pssss syl ) ABCEBCFDBCGH $.

    $( Proper subclasses are unequal.  Deduction form of ~ pssne .
       (Contributed by David Moews, 1-May-2017.) $)
    pssned $p |- ( ph -> A =/= B ) $=
      ( wpss wne pssne syl ) ABCEBCFDBCGH $.
  $}

  $( Subclass in terms of proper subclass.  (Contributed by NM,
     25-Feb-1996.) $)
  sspss $p |- ( A C_ B <-> ( A C. B \/ A = B ) ) $=
    ( wss wpss wceq wo wn dfpss2 simplbi2 con1d orrd pssss eqimss jaoi impbii )
    ABCZABDZABEZFPQRPRQQPRGABHIJKQPRABLABMNO $.

  $( Proper subclass is irreflexive.  Theorem 7 of [Suppes] p. 23.
     (Contributed by NM, 7-Feb-1996.) $)
  pssirr $p |- -. A C. A $=
    ( wpss wss wn wa pm3.24 dfpss3 mtbir ) AABAACZIDEIFAAGH $.

  $( Proper subclass has no 2-cycle loops.  Compare Theorem 8 of [Suppes]
     p. 23.  (Contributed by NM, 7-Feb-1996.)  (Proof shortened by Andrew
     Salmon, 26-Jun-2011.) $)
  pssn2lp $p |- -. ( A C. B /\ B C. A ) $=
    ( wpss wn wi wa wss dfpss3 simprbi pssss nsyl imnan mpbi ) ABCZBACZDENOFDNB
    AGZONABGPDABHIBAJKNOLM $.

  $( Two ways of stating trichotomy with respect to inclusion.  (Contributed by
     NM, 12-Aug-2004.) $)
  sspsstri $p |- ( ( A C_ B \/ B C_ A ) <-> ( A C. B \/ A = B \/ B C. A ) ) $=
    ( wpss wo wceq wss w3o or32 sspss eqcom orbi2i bitri orbi12i orordir bitr4i
    df-3or 3bitr4i ) ABCZBACZDABEZDZRTDZSDABFZBAFZDZRTSGRSTHUEUBSTDZDUAUCUBUDUF
    ABIUDSBAEZDUFBAIUGTSBAJKLMRSTNORTSPQ $.

  $( Partial trichotomy law for subclasses.  (Contributed by NM, 16-May-1996.)
     (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  ssnpss $p |- ( A C_ B -> -. B C. A ) $=
    ( wpss wss wn dfpss3 simprbi con2i ) BACZABDZIBADJEBAFGH $.

  $( Transitive law for proper subclass.  Theorem 9 of [Suppes] p. 23.
     (Contributed by NM, 7-Feb-1996.) $)
  psstr $p |- ( ( A C. B /\ B C. C ) -> A C. C ) $=
    ( wpss wa wss wceq pssss sylan9ss pssn2lp psseq1 anbi1d mtbiri con2i dfpss2
    wn sylanbrc ) ABDZBCDZEZACFACGZPACDRSABCABHBCHIUATUATCBDZSECBJUARUBSACBKLMN
    ACOQ $.

  $( Transitive law for subclass and proper subclass.  (Contributed by NM,
     3-Apr-1996.) $)
  sspsstr $p |- ( ( A C_ B /\ B C. C ) -> A C. C ) $=
    ( wss wpss wceq wo sspss wi psstr ex psseq1 biimprd jaoi imp sylanb ) ABDAB
    EZABFZGZBCEZACEZABHSTUAQTUAIRQTUAABCJKRUATABCLMNOP $.

  $( Transitive law for subclass and proper subclass.  (Contributed by NM,
     3-Apr-1996.) $)
  psssstr $p |- ( ( A C. B /\ B C_ C ) -> A C. C ) $=
    ( wss wpss wceq wo sspss psstr ex psseq2 biimpcd jaod imp sylan2b ) BCDABEZ
    BCEZBCFZGZACEZBCHPSTPQTRPQTABCIJRPTBCAKLMNO $.

  ${
    psstrd.1 $e |- ( ph -> A C. B ) $.
    psstrd.2 $e |- ( ph -> B C. C ) $.
    $( Proper subclass inclusion is transitive.  Deduction form of ~ psstr .
       (Contributed by David Moews, 1-May-2017.) $)
    psstrd $p |- ( ph -> A C. C ) $=
      ( wpss psstr syl2anc ) ABCGCDGBDGEFBCDHI $.
  $}

  ${
    sspsstrd.1 $e |- ( ph -> A C_ B ) $.
    sspsstrd.2 $e |- ( ph -> B C. C ) $.
    $( Transitivity involving subclass and proper subclass inclusion.
       Deduction form of ~ sspsstr .  (Contributed by David Moews,
       1-May-2017.) $)
    sspsstrd $p |- ( ph -> A C. C ) $=
      ( wss wpss sspsstr syl2anc ) ABCGCDHBDHEFBCDIJ $.
  $}

  ${
    psssstrd.1 $e |- ( ph -> A C. B ) $.
    psssstrd.2 $e |- ( ph -> B C_ C ) $.
    $( Transitivity involving subclass and proper subclass inclusion.
       Deduction form of ~ psssstr .  (Contributed by David Moews,
       1-May-2017.) $)
    psssstrd $p |- ( ph -> A C. C ) $=
      ( wpss wss psssstr syl2anc ) ABCGCDHBDGEFBCDIJ $.
  $}

  $( A class is not a proper subclass of another iff it satisfies a
     one-directional form of ~ eqss .  (Contributed by Mario Carneiro,
     15-May-2015.) $)
  npss $p |- ( -. A C. B <-> ( A C_ B -> A = B ) ) $=
    ( wss wceq wi wpss wn wa pm4.61 dfpss2 bitr4i con1bii ) ABCZABDZEZABFZOGMNG
    HPMNIABJKL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The difference, union, and intersection of two classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      The difference of two classes
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality theorem for class difference.  (Contributed by NM,
       10-Feb-1997.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    difeq1 $p |- ( A = B -> ( A \ C ) = ( B \ C ) ) $=
      ( vx wceq cv wcel wn crab cdif rabeq dfdif2 3eqtr4g ) ABEDFCGHZDAINDBIACJ
      BCJNDABKDACLDBCLM $.

    $( Equality theorem for class difference.  (Contributed by NM,
       10-Feb-1997.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    difeq2 $p |- ( A = B -> ( C \ A ) = ( C \ B ) ) $=
      ( vx wceq cv wcel wn crab cdif eleq2 notbid rabbidv dfdif2 3eqtr4g ) ABEZ
      DFZAGZHZDCIQBGZHZDCICAJCBJPSUADCPRTABQKLMDCANDCBNO $.
  $}

  $( Equality theorem for class difference.  (Contributed by FL,
     31-Aug-2009.) $)
  difeq12 $p |- ( ( A = B /\ C = D ) -> ( A \ C ) = ( B \ D ) ) $=
    ( wceq cdif difeq1 difeq2 sylan9eq ) ABECDEACFBCFBDFABCGCDBHI $.

  ${
    difeq1i.1 $e |- A = B $.
    $( Inference adding difference to the right in a class equality.
       (Contributed by NM, 15-Nov-2002.) $)
    difeq1i $p |- ( A \ C ) = ( B \ C ) $=
      ( wceq cdif difeq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Inference adding difference to the left in a class equality.
       (Contributed by NM, 15-Nov-2002.) $)
    difeq2i $p |- ( C \ A ) = ( C \ B ) $=
      ( wceq cdif difeq2 ax-mp ) ABECAFCBFEDABCGH $.

    ${
      difeq12i.2 $e |- C = D $.
      $( Equality inference for class difference.  (Contributed by NM,
         29-Aug-2004.) $)
      difeq12i $p |- ( A \ C ) = ( B \ D ) $=
        ( cdif difeq1i difeq2i eqtri ) ACGBCGBDGABCEHCDBFIJ $.
    $}
  $}

  ${
    difeq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction adding difference to the right in a class equality.
       (Contributed by NM, 15-Nov-2002.) $)
    difeq1d $p |- ( ph -> ( A \ C ) = ( B \ C ) ) $=
      ( wceq cdif difeq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Deduction adding difference to the left in a class equality.
       (Contributed by NM, 15-Nov-2002.) $)
    difeq2d $p |- ( ph -> ( C \ A ) = ( C \ B ) ) $=
      ( wceq cdif difeq2 syl ) ABCFDBGDCGFEBCDHI $.
  $}

  ${
    difeq12d.1 $e |- ( ph -> A = B ) $.
    difeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for class difference.  (Contributed by FL,
       29-May-2014.) $)
    difeq12d $p |- ( ph -> ( A \ C ) = ( B \ D ) ) $=
      ( cdif difeq1d difeq2d eqtrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    difeqri.1 $e |- ( ( x e. A /\ -. x e. B ) <-> x e. C ) $.
    $( Inference from membership to difference.  (Contributed by NM,
       17-May-1998.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    difeqri $p |- ( A \ B ) = C $=
      ( cdif cv wcel wn wa eldif bitri eqriv ) ABCFZDAGZNHOBHOCHIJODHOBCKELM $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    nfdif.1 $e |- F/_ x A $.
    nfdif.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for class difference.  (Contributed by
       NM, 3-Dec-2003.)  (Revised by Mario Carneiro, 13-Oct-2016.) $)
    nfdif $p |- F/_ x ( A \ B ) $=
      ( vy cdif cv wcel wn crab dfdif2 nfcri nfn nfrab nfcxfr ) ABCGFHCIZJZFBKF
      BCLRAFBQAAFCEMNDOP $.
  $}

  $( Implication of membership in a class difference.  (Contributed by NM,
     29-Apr-1994.) $)
  eldifi $p |- ( A e. ( B \ C ) -> A e. B ) $=
    ( cdif wcel wn eldif simplbi ) ABCDEABEACEFABCGH $.

  $( Implication of membership in a class difference.  (Contributed by NM,
     3-May-1994.) $)
  eldifn $p |- ( A e. ( B \ C ) -> -. A e. C ) $=
    ( cdif wcel wn eldif simprbi ) ABCDEABEACEFABCGH $.

  $( A set does not belong to a class excluding it.  (Contributed by NM,
     27-Jun-1994.) $)
  elndif $p |- ( A e. B -> -. A e. ( C \ B ) ) $=
    ( cdif wcel eldifn con2i ) ACBDEABEACBFG $.

  $( Implication of membership in a class difference.  (Contributed by NM,
     28-Jun-1994.) $)
  neldif $p |- ( ( A e. B /\ -. A e. ( B \ C ) ) -> A e. C ) $=
    ( wcel cdif wn eldif simplbi2 con1d imp ) ABDZABCEDZFACDZKMLLKMFABCGHIJ $.

  ${
    $d x A $.  $d x B $.
    $( Double class difference.  Exercise 11 of [TakeutiZaring] p. 22.
       (Contributed by NM, 17-May-1998.) $)
    difdif $p |- ( A \ ( B \ A ) ) = A $=
      ( vx cdif cv wcel wi wa wn pm4.45im eldif xchbinxr anbi2i bitr2i difeqri
      iman ) CABADZACEZAFZSRBFZSGZHSRQFZIZHSTJUAUCSUATSIHUBTSPRBAKLMNO $.

    $( Subclass relationship for class difference.  Exercise 14 of
       [TakeutiZaring] p. 22.  (Contributed by NM, 29-Apr-1994.) $)
    difss $p |- ( A \ B ) C_ A $=
      ( vx cdif cv eldifi ssriv ) CABDACEABFG $.
  $}

  $( A difference of two classes is contained in the minuend.  Deduction form
     of ~ difss .  (Contributed by David Moews, 1-May-2017.) $)
  difssd $p |- ( ph -> ( A \ B ) C_ A ) $=
    ( cdif wss difss a1i ) BCDBEABCFG $.

  $( If a class is contained in a difference, it is contained in the minuend.
     (Contributed by David Moews, 1-May-2017.) $)
  difss2 $p |- ( A C_ ( B \ C ) -> A C_ B ) $=
    ( cdif wss id difss syl6ss ) ABCDZEZAIBJFBCGH $.

  ${
    difss2d.1 $e |- ( ph -> A C_ ( B \ C ) ) $.
    $( If a class is contained in a difference, it is contained in the
       minuend.  Deduction form of ~ difss2 .  (Contributed by David Moews,
       1-May-2017.) $)
    difss2d $p |- ( ph -> A C_ B ) $=
      ( cdif wss difss2 syl ) ABCDFGBCGEBCDHI $.
  $}

  $( Preservation of a subclass relationship by class difference.  (Contributed
     by NM, 15-Feb-2007.) $)
  ssdifss $p |- ( A C_ B -> ( A \ C ) C_ B ) $=
    ( cdif wss difss sstr mpan ) ACDZAEABEIBEACFIABGH $.

  ${
    $d x A $.
    $( Double complement under universal class.  Exercise 4.10(s) of
       [Mendelson] p. 231.  (Contributed by NM, 8-Jan-2002.) $)
    ddif $p |- ( _V \ ( _V \ A ) ) = A $=
      ( vx cvv cdif cv wcel wn wa eldif mpbiran con2bii biantrur bitr2i difeqri
      vex ) BCCADZABEZAFZQPFZGZQCFZTHSRSUARGBOZQCAIJKUATUBLMN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Contraposition law for subsets.  (Contributed by NM, 22-Mar-1998.) $)
    ssconb $p |- ( ( A C_ C /\ B C_ C ) ->
                  ( A C_ ( C \ B ) <-> B C_ ( C \ A ) ) ) $=
      ( vx wss wa cv wcel cdif wi wal wn wb ssel pm5.1 jcab 3bitr4g eldif dfss2
      imbi2i syl2an con2b a1i anbi12d albidv ) ACEZBCEZFZDGZAHZUICBIZHZJZDKUIBH
      ZUICAIZHZJZDKAUKEBUOEUHUMUQDUHUJUICHZUNLZFZJZUNURUJLZFZJZUMUQUHUJURJZUJUS
      JZFUNURJZUNVBJZFVAVDUHVEVGVFVHUFVEVGVEVGMUGACUINBCUINVEVGOUAVFVHMUHUJUNUB
      UCUDUJURUSPUNURVBPQULUTUJUICBRTUPVCUNUICARTQUEDAUKSDBUOSQ $.

    $( Contraposition law for subsets.  Exercise 15 of [TakeutiZaring] p. 22.
       (Contributed by NM, 22-Mar-1998.) $)
    sscon $p |- ( A C_ B -> ( C \ B ) C_ ( C \ A ) ) $=
      ( vx wss cdif cv wcel wn wa ssel con3d anim2d eldif 3imtr4g ssrdv ) ABEZD
      CBFZCAFZQDGZCHZTBHZIZJUATAHZIZJTRHTSHQUCUEUAQUDUBABTKLMTCBNTCANOP $.

    $( Difference law for subsets.  (Contributed by NM, 28-May-1998.) $)
    ssdif $p |- ( A C_ B -> ( A \ C ) C_ ( B \ C ) ) $=
      ( vx wss cdif cv wcel wn wa ssel anim1d eldif 3imtr4g ssrdv ) ABEZDACFZBC
      FZPDGZAHZSCHIZJSBHZUAJSQHSRHPTUBUAABSKLSACMSBCMNO $.
  $}

  ${
    ssdifd.1 $e |- ( ph -> A C_ B ) $.
    $( If ` A ` is contained in ` B ` , then ` ( A \ C ) ` is contained in
       ` ( B \ C ) ` .  Deduction form of ~ ssdif .  (Contributed by David
       Moews, 1-May-2017.) $)
    ssdifd $p |- ( ph -> ( A \ C ) C_ ( B \ C ) ) $=
      ( wss cdif ssdif syl ) ABCFBDGCDGFEBCDHI $.

    $( If ` A ` is contained in ` B ` , then ` ( C \ B ) ` is contained in
       ` ( C \ A ) ` .  Deduction form of ~ sscon .  (Contributed by David
       Moews, 1-May-2017.) $)
    sscond $p |- ( ph -> ( C \ B ) C_ ( C \ A ) ) $=
      ( wss cdif sscon syl ) ABCFDCGDBGFEBCDHI $.

    $( If ` A ` is contained in ` B ` , then ` ( A \ C ) ` is also contained in
       ` B ` .  Deduction form of ~ ssdifss .  (Contributed by David Moews,
       1-May-2017.) $)
    ssdifssd $p |- ( ph -> ( A \ C ) C_ B ) $=
      ( wss cdif ssdifss syl ) ABCFBDGCFEBCDHI $.

    ssdif2d.2 $e |- ( ph -> C C_ D ) $.
    $( If ` A ` is contained in ` B ` and ` C ` is contained in ` D ` , then
       ` ( A \ D ) ` is contained in ` ( B \ C ) ` .  Deduction form.
       (Contributed by David Moews, 1-May-2017.) $)
    ssdif2d $p |- ( ph -> ( A \ D ) C_ ( B \ C ) ) $=
      ( cdif sscond ssdifd sstrd ) ABEHBDHCDHADEBGIABCDFJK $.
  $}

  $( Restricted universal quantification on a class difference in terms of an
     implication.  (Contributed by Alexander van der Vekens, 3-Jan-2018.) $)
  raldifb $p |- ( A. x e. A ( x e/ B -> ph ) <-> A. x e. ( A \ B ) ph ) $=
    ( cv wnel wi cdif wcel wa impexp bicomi wn df-nel anbi2i eldif bitri imbi1i
    ralbii2 ) BEZDFZAGZABCCDHZTCIZUBGZUDUAJZAGZTUCIZAGUGUEUDUAAKLUFUHAUFUDTDIMZ
    JZUHUAUIUDTDNOUHUJTCDPLQRQS $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      The union of two classes
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Expansion of membership in class union.  Theorem 12 of [Suppes] p. 25.
       (Contributed by NM, 7-Aug-1994.) $)
    elun $p |- ( A e. ( B u. C ) <-> ( A e. B \/ A e. C ) ) $=
      ( vx cun wcel cvv wo elex jaoi wceq eleq1 orbi12d df-un elab2g pm5.21nii
      cv ) ABCEZFAGFZABFZACFZHZARITSUAABIACIJDQZBFZUCCFZHUBDARGUCAKUDTUEUAUCABL
      UCACLMDBCNOP $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    uneqri.1 $e |- ( ( x e. A \/ x e. B ) <-> x e. C ) $.
    $( Inference from membership to union.  (Contributed by NM, 5-Aug-1993.) $)
    uneqri $p |- ( A u. B ) = C $=
      ( cun cv wcel wo elun bitri eqriv ) ABCFZDAGZMHNBHNCHINDHNBCJEKL $.
  $}

  ${
    $d x A $.
    $( Idempotent law for union of classes.  Theorem 23 of [Suppes] p. 27.
       (Contributed by NM, 5-Aug-1993.) $)
    unidm $p |- ( A u. A ) = A $=
      ( vx cv wcel oridm uneqri ) BAAABCADEF $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Commutative law for union of classes.  Exercise 6 of [TakeutiZaring]
       p. 17.  (Contributed by NM, 25-Jun-1998.)  (Proof shortened by Andrew
       Salmon, 26-Jun-2011.) $)
    uncom $p |- ( A u. B ) = ( B u. A ) $=
      ( vx cun cv wcel wo orcom elun bitr4i uneqri ) CABBADZCEZAFZMBFZGONGMLFNO
      HMBAIJK $.
  $}

  ${
    $( If a class equals the union of two other classes, then it equals the
       union of those two classes commuted. ~ equncom was automatically derived
       from ~ equncomVD using the tools program
       translate_without_overwriting.cmd and minimizing.  (Contributed by Alan
       Sare, 18-Feb-2012.) $)
    equncom $p |- ( A = ( B u. C ) <-> A = ( C u. B ) ) $=
      ( cun uncom eqeq2i ) BCDCBDABCEF $.
  $}

  ${
    equncomi.1 $e |- A = ( B u. C ) $.
    $( Inference form of ~ equncom . ~ equncomi was automatically derived from
       ~ equncomiVD using the tools program translate_without_overwriting.cmd
       and minimizing.  (Contributed by Alan Sare, 18-Feb-2012.) $)
    equncomi $p |- A = ( C u. B ) $=
      ( cun wceq equncom mpbi ) ABCEFACBEFDABCGH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality theorem for union of two classes.  (Contributed by NM,
       5-Aug-1993.) $)
    uneq1 $p |- ( A = B -> ( A u. C ) = ( B u. C ) ) $=
      ( vx wceq cun cv wcel wo eleq2 orbi1d elun 3bitr4g eqrdv ) ABEZDACFZBCFZO
      DGZAHZRCHZIRBHZTIRPHRQHOSUATABRJKRACLRBCLMN $.
  $}

  $( Equality theorem for the union of two classes.  (Contributed by NM,
     5-Aug-1993.) $)
  uneq2 $p |- ( A = B -> ( C u. A ) = ( C u. B ) ) $=
    ( wceq cun uneq1 uncom 3eqtr4g ) ABDACEBCECAECBEABCFCAGCBGH $.

  $( Equality theorem for union of two classes.  (Contributed by NM,
     29-Mar-1998.) $)
  uneq12 $p |- ( ( A = B /\ C = D ) -> ( A u. C ) = ( B u. D ) ) $=
    ( wceq cun uneq1 uneq2 sylan9eq ) ABECDEACFBCFBDFABCGCDBHI $.

  ${
    uneq1i.1 $e |- A = B $.
    $( Inference adding union to the right in a class equality.  (Contributed
       by NM, 30-Aug-1993.) $)
    uneq1i $p |- ( A u. C ) = ( B u. C ) $=
      ( wceq cun uneq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Inference adding union to the left in a class equality.  (Contributed by
       NM, 30-Aug-1993.) $)
    uneq2i $p |- ( C u. A ) = ( C u. B ) $=
      ( wceq cun uneq2 ax-mp ) ABECAFCBFEDABCGH $.

    ${
      uneq12i.2 $e |- C = D $.
      $( Equality inference for union of two classes.  (Contributed by NM,
         12-Aug-2004.)  (Proof shortened by Eric Schmidt, 26-Jan-2007.) $)
      uneq12i $p |- ( A u. C ) = ( B u. D ) $=
        ( wceq cun uneq12 mp2an ) ABGCDGACHBDHGEFABCDIJ $.
    $}
  $}

  ${
    uneq1d.1 $e |- ( ph -> A = B ) $.
    $( Deduction adding union to the right in a class equality.  (Contributed
       by NM, 29-Mar-1998.) $)
    uneq1d $p |- ( ph -> ( A u. C ) = ( B u. C ) ) $=
      ( wceq cun uneq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Deduction adding union to the left in a class equality.  (Contributed by
       NM, 29-Mar-1998.) $)
    uneq2d $p |- ( ph -> ( C u. A ) = ( C u. B ) ) $=
      ( wceq cun uneq2 syl ) ABCFDBGDCGFEBCDHI $.

    ${
      uneq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for union of two classes.  (Contributed by NM,
         29-Sep-2004.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
      uneq12d $p |- ( ph -> ( A u. C ) = ( B u. D ) ) $=
        ( wceq cun uneq12 syl2anc ) ABCHDEHBDICEIHFGBCDEJK $.
    $}
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    nfun.1 $e |- F/_ x A $.
    nfun.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for the union of classes.
       (Contributed by NM, 15-Sep-2003.)  (Revised by Mario Carneiro,
       14-Oct-2016.) $)
    nfun $p |- F/_ x ( A u. B ) $=
      ( vy cun cv wcel wo cab df-un nfcri nfor nfab nfcxfr ) ABCGFHZBIZQCIZJZFK
      FBCLTAFRSAAFBDMAFCEMNOP $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Associative law for union of classes.  Exercise 8 of [TakeutiZaring]
       p. 17.  (Contributed by NM, 3-May-1994.)  (Proof shortened by Andrew
       Salmon, 26-Jun-2011.) $)
    unass $p |- ( ( A u. B ) u. C ) = ( A u. ( B u. C ) ) $=
      ( vx cun cv wcel wo elun orbi2i orbi1i orass bitr2i 3bitrri uneqri ) DABE
      ZCABCEZEZDFZRGSAGZSQGZHTSBGZSCGZHZHZSPGZUCHZSAQIUAUDTSBCIJUGTUBHZUCHUEUFU
      HUCSABIKTUBUCLMNO $.
  $}

  $( A rearrangement of union.  (Contributed by NM, 12-Aug-2004.) $)
  un12 $p |- ( A u. ( B u. C ) ) = ( B u. ( A u. C ) ) $=
    ( cun uncom uneq1i unass 3eqtr3i ) ABDZCDBADZCDABCDDBACDDIJCABEFABCGBACGH
    $.

  $( A rearrangement of union.  (Contributed by NM, 12-Aug-2004.)  (Proof
     shortened by Andrew Salmon, 26-Jun-2011.) $)
  un23 $p |- ( ( A u. B ) u. C ) = ( ( A u. C ) u. B ) $=
    ( cun unass un12 uncom 3eqtri ) ABDCDABCDDBACDZDIBDABCEABCFBIGH $.

  $( A rearrangement of the union of 4 classes.  (Contributed by NM,
     12-Aug-2004.) $)
  un4 $p |- ( ( A u. B ) u. ( C u. D ) ) =
            ( ( A u. C ) u. ( B u. D ) ) $=
    ( cun un12 uneq2i unass 3eqtr4i ) ABCDEZEZEACBDEZEZEABEJEACELEKMABCDFGABJHA
    CLHI $.

  $( Union distributes over itself.  (Contributed by NM, 17-Aug-2004.) $)
  unundi $p |- ( A u. ( B u. C ) ) = ( ( A u. B ) u. ( A u. C ) ) $=
    ( cun unidm uneq1i un4 eqtr3i ) AADZBCDZDAJDABDACDDIAJAEFAABCGH $.

  $( Union distributes over itself.  (Contributed by NM, 17-Aug-2004.) $)
  unundir $p |- ( ( A u. B ) u. C ) = ( ( A u. C ) u. ( B u. C ) ) $=
    ( cun unidm uneq2i un4 eqtr3i ) ABDZCCDZDICDACDBCDDJCICEFABCCGH $.

  ${
    $d x A $.  $d x B $.
    $( Subclass relationship for union of classes.  Theorem 25 of [Suppes]
       p. 27.  (Contributed by NM, 5-Aug-1993.) $)
    ssun1 $p |- A C_ ( A u. B ) $=
      ( vx cun cv wcel wo orc elun sylibr ssriv ) CAABDZCEZAFZNMBFZGMLFNOHMABIJ
      K $.
  $}

  $( Subclass relationship for union of classes.  (Contributed by NM,
     30-Aug-1993.) $)
  ssun2 $p |- A C_ ( B u. A ) $=
    ( cun ssun1 uncom sseqtri ) AABCBACABDABEF $.

  $( Subclass law for union of classes.  (Contributed by NM, 5-Aug-1993.) $)
  ssun3 $p |- ( A C_ B -> A C_ ( B u. C ) ) $=
    ( wss cun ssun1 sstr2 mpi ) ABDBBCEZDAIDBCFABIGH $.

  $( Subclass law for union of classes.  (Contributed by NM, 14-Aug-1994.) $)
  ssun4 $p |- ( A C_ B -> A C_ ( C u. B ) ) $=
    ( wss cun ssun2 sstr2 mpi ) ABDBCBEZDAIDBCFABIGH $.

  $( Membership law for union of classes.  (Contributed by NM, 5-Aug-1993.) $)
  elun1 $p |- ( A e. B -> A e. ( B u. C ) ) $=
    ( cun ssun1 sseli ) BBCDABCEF $.

  $( Membership law for union of classes.  (Contributed by NM, 30-Aug-1993.) $)
  elun2 $p |- ( A e. B -> A e. ( C u. B ) ) $=
    ( cun ssun2 sseli ) BCBDABCEF $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Subclass law for union of classes.  (Contributed by NM, 14-Oct-1999.)
       (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    unss1 $p |- ( A C_ B -> ( A u. C ) C_ ( B u. C ) ) $=
      ( vx wss cun cv wcel wo ssel orim1d elun 3imtr4g ssrdv ) ABEZDACFZBCFZODG
      ZAHZRCHZIRBHZTIRPHRQHOSUATABRJKRACLRBCLMN $.

    $( A relationship between subclass and union.  Theorem 26 of [Suppes]
       p. 27.  (Contributed by NM, 30-Aug-1993.)  (Proof shortened by Andrew
       Salmon, 26-Jun-2011.) $)
    ssequn1 $p |- ( A C_ B <-> ( A u. B ) = B ) $=
      ( vx cv wcel wi wal cun wb wceq wo bicom pm4.72 elun bibi1i 3bitr4i albii
      wss dfss2 dfcleq ) CDZAEZUABEZFZCGUAABHZEZUCIZCGABRUEBJUDUGCUCUBUCKZIUHUC
      IUDUGUCUHLUBUCMUFUHUCUAABNOPQCABSCUEBTP $.
  $}

  $( Subclass law for union of classes.  Exercise 7 of [TakeutiZaring] p. 18.
     (Contributed by NM, 14-Oct-1999.) $)
  unss2 $p |- ( A C_ B -> ( C u. A ) C_ ( C u. B ) ) $=
    ( wss cun unss1 uncom 3sstr4g ) ABDACEBCECAECBEABCFCAGCBGH $.

  $( Subclass law for union of classes.  (Contributed by NM, 2-Jun-2004.) $)
  unss12 $p |- ( ( A C_ B /\ C C_ D ) -> ( A u. C ) C_ ( B u. D ) ) $=
    ( wss cun unss1 unss2 sylan9ss ) ABECDEACFBCFBDFABCGCDBHI $.

  $( A relationship between subclass and union.  (Contributed by NM,
     13-Jun-1994.) $)
  ssequn2 $p |- ( A C_ B <-> ( B u. A ) = B ) $=
    ( wss cun wceq ssequn1 uncom eqeq1i bitri ) ABCABDZBEBADZBEABFJKBABGHI $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( The union of two subclasses is a subclass.  Theorem 27 of [Suppes] p. 27
       and its converse.  (Contributed by NM, 11-Jun-2004.) $)
    unss $p |- ( ( A C_ C /\ B C_ C ) <-> ( A u. B ) C_ C ) $=
      ( vx cun wss cv wcel wi wal wa dfss2 19.26 elun imbi1i jaob bitri anbi12i
      wo albii 3bitr4i bitr2i ) ABEZCFDGZUCHZUDCHZIZDJZACFZBCFZKZDUCCLUDAHZUFIZ
      UDBHZUFIZKZDJUMDJZUODJZKUHUKUMUODMUGUPDUGULUNSZUFIUPUEUSUFUDABNOULUFUNPQT
      UIUQUJURDACLDBCLRUAUB $.
  $}

  ${
    unssi.1 $e |- A C_ C $.
    unssi.2 $e |- B C_ C $.
    $( An inference showing the union of two subclasses is a subclass.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    unssi $p |- ( A u. B ) C_ C $=
      ( wss wa cun pm3.2i unss mpbi ) ACFZBCFZGABHCFLMDEIABCJK $.
  $}

  ${
    unssd.1 $e |- ( ph -> A C_ C ) $.
    unssd.2 $e |- ( ph -> B C_ C ) $.
    $( A deduction showing the union of two subclasses is a subclass.
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.) $)
    unssd $p |- ( ph -> ( A u. B ) C_ C ) $=
      ( wss cun wa unss biimpi syl2anc ) ABDGZCDGZBCHDGZEFMNIOBCDJKL $.
  $}

  ${
    unssad.1 $e |- ( ph -> ( A u. B ) C_ C ) $.
    $( If ` ( A u. B ) ` is contained in ` C ` , so is ` A ` .  One-way
       deduction form of ~ unss .  Partial converse of ~ unssd .  (Contributed
       by David Moews, 1-May-2017.) $)
    unssad $p |- ( ph -> A C_ C ) $=
      ( wss cun wa unss sylibr simpld ) ABDFZCDFZABCGDFLMHEBCDIJK $.

    $( If ` ( A u. B ) ` is contained in ` C ` , so is ` B ` .  One-way
       deduction form of ~ unss .  Partial converse of ~ unssd .  (Contributed
       by David Moews, 1-May-2017.) $)
    unssbd $p |- ( ph -> B C_ C ) $=
      ( wss cun wa unss sylibr simprd ) ABDFZCDFZABCGDFLMHEBCDIJK $.
  $}

  $( A condition that implies inclusion in the union of two classes.
     (Contributed by NM, 23-Nov-2003.) $)
  ssun $p |- ( ( A C_ B \/ A C_ C ) -> A C_ ( B u. C ) ) $=
    ( wss cun ssun3 ssun4 jaoi ) ABDABCEDACDABCFACBGH $.

  $( Restricted existential quantification over union.  (Contributed by Jeff
     Madsen, 5-Jan-2011.) $)
  rexun $p |- ( E. x e. ( A u. B ) ph <->
                          ( E. x e. A ph \/ E. x e. B ph ) ) $=
    ( cun wrex cv wcel wa wo df-rex 19.43 elun anbi1i andir bitri exbii orbi12i
    wex 3bitr4i ) ABCDEZFBGZUAHZAIZBSZABCFZABDFZJZABUAKUBCHZAIZUBDHZAIZJZBSUJBS
    ZULBSZJUEUHUJULBLUDUMBUDUIUKJZAIUMUCUPAUBCDMNUIUKAOPQUFUNUGUOABCKABDKRTP $.

  $( Restricted quantification over a union.  (Contributed by Scott Fenton,
     12-Apr-2011.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
  ralunb $p |- ( A. x e. ( A u. B ) ph <->
                 ( A. x e. A ph /\ A. x e. B ph ) ) $=
    ( cv cun wcel wi wal wa wral wo elun imbi1i jaob bitri albii df-ral anbi12i
    19.26 3bitr4i ) BEZCDFZGZAHZBIZUBCGZAHZBIZUBDGZAHZBIZJZABUCKABCKZABDKZJUFUH
    UKJZBIUMUEUPBUEUGUJLZAHUPUDUQAUBCDMNUGAUJOPQUHUKBTPABUCRUNUIUOULABCRABDRSUA
    $.

  $( Restricted quantification over union.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  ralun $p |- ( ( A. x e. A ph /\ A. x e. B ph ) -> A. x e. ( A u. B ) ph ) $=
    ( cun wral wa ralunb biimpri ) ABCDEFABCFABDFGABCDHI $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      The intersection of two classes
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Expansion of membership in an intersection of two classes.  Theorem 12
       of [Suppes] p. 25.  (Contributed by NM, 29-Apr-1994.) $)
    elin $p |- ( A e. ( B i^i C ) <-> ( A e. B /\ A e. C ) ) $=
      ( vx cin wcel wa elex adantl cv wceq eleq1 anbi12d df-in elab2g pm5.21nii
      cvv ) ABCEZFAQFZABFZACFZGZARHUASTACHIDJZBFZUCCFZGUBDARQUCAKUDTUEUAUCABLUC
      ACLMDBCNOP $.
  $}

  ${
    elin2.x $e |- X = ( B i^i C ) $.
    $( Membership in a class defined as an intersection.  (Contributed by
       Stefan O'Rear, 29-Mar-2015.) $)
    elin2 $p |- ( A e. X <-> ( A e. B /\ A e. C ) ) $=
      ( wcel cin wa eleq2i elin bitri ) ADFABCGZFABFACFHDLAEIABCJK $.
  $}

  ${
    elin3.x $e |- X = ( ( B i^i C ) i^i D ) $.
    $( Membership in a class defined as a ternary intersection.  (Contributed
       by Stefan O'Rear, 29-Mar-2015.) $)
    elin3 $p |- ( A e. X <-> ( A e. B /\ A e. C /\ A e. D ) ) $=
      ( cin wcel wa w3a elin anbi1i elin2 df-3an 3bitr4i ) ABCGZHZADHZIABHZACHZ
      IZRIAEHSTRJQUARABCKLAPDEFMSTRNO $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Commutative law for intersection of classes.  Exercise 7 of
       [TakeutiZaring] p. 17.  (Contributed by NM, 5-Aug-1993.) $)
    incom $p |- ( A i^i B ) = ( B i^i A ) $=
      ( vx cin cv wcel wa ancom elin 3bitr4i eqriv ) CABDZBADZCEZAFZNBFZGPOGNLF
      NMFOPHNABINBAIJK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    ineqri.1 $e |- ( ( x e. A /\ x e. B ) <-> x e. C ) $.
    $( Inference from membership to intersection.  (Contributed by NM,
       5-Aug-1993.) $)
    ineqri $p |- ( A i^i B ) = C $=
      ( cin cv wcel wa elin bitri eqriv ) ABCFZDAGZMHNBHNCHINDHNBCJEKL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Equality theorem for intersection of two classes.  (Contributed by NM,
       14-Dec-1993.) $)
    ineq1 $p |- ( A = B -> ( A i^i C ) = ( B i^i C ) ) $=
      ( vx wceq cin cv wcel wa eleq2 anbi1d elin 3bitr4g eqrdv ) ABEZDACFZBCFZO
      DGZAHZRCHZIRBHZTIRPHRQHOSUATABRJKRACLRBCLMN $.
  $}

  $( Equality theorem for intersection of two classes.  (Contributed by NM,
     26-Dec-1993.) $)
  ineq2 $p |- ( A = B -> ( C i^i A ) = ( C i^i B ) ) $=
    ( wceq cin ineq1 incom 3eqtr4g ) ABDACEBCECAECBEABCFCAGCBGH $.

  $( Equality theorem for intersection of two classes.  (Contributed by NM,
     8-May-1994.) $)
  ineq12 $p |- ( ( A = B /\ C = D ) -> ( A i^i C ) = ( B i^i D ) ) $=
    ( wceq cin ineq1 ineq2 sylan9eq ) ABECDEACFBCFBDFABCGCDBHI $.

  ${
    ineq1i.1 $e |- A = B $.
    $( Equality inference for intersection of two classes.  (Contributed by NM,
       26-Dec-1993.) $)
    ineq1i $p |- ( A i^i C ) = ( B i^i C ) $=
      ( wceq cin ineq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality inference for intersection of two classes.  (Contributed by NM,
       26-Dec-1993.) $)
    ineq2i $p |- ( C i^i A ) = ( C i^i B ) $=
      ( wceq cin ineq2 ax-mp ) ABECAFCBFEDABCGH $.

    ${
      ineq12i.2 $e |- C = D $.
      $( Equality inference for intersection of two classes.  (Contributed by
         NM, 24-Jun-2004.)  (Proof shortened by Eric Schmidt, 26-Jan-2007.) $)
      ineq12i $p |- ( A i^i C ) = ( B i^i D ) $=
        ( wceq cin ineq12 mp2an ) ABGCDGACHBDHGEFABCDIJ $.
    $}
  $}

  ${
    ineq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for intersection of two classes.  (Contributed by NM,
       10-Apr-1994.) $)
    ineq1d $p |- ( ph -> ( A i^i C ) = ( B i^i C ) ) $=
      ( wceq cin ineq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality deduction for intersection of two classes.  (Contributed by NM,
       10-Apr-1994.) $)
    ineq2d $p |- ( ph -> ( C i^i A ) = ( C i^i B ) ) $=
      ( wceq cin ineq2 syl ) ABCFDBGDCGFEBCDHI $.

    ${
      ineq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for intersection of two classes.  (Contributed by
         NM, 24-Jun-2004.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
      ineq12d $p |- ( ph -> ( A i^i C ) = ( B i^i D ) ) $=
        ( wceq cin ineq12 syl2anc ) ABCHDEHBDICEIHFGBCDEJK $.
    $}

    ${
      ineqan12d.2 $e |- ( ps -> C = D ) $.
      $( Equality deduction for intersection of two classes.  (Contributed by
         NM, 7-Feb-2007.) $)
      ineqan12d $p |- ( ( ph /\ ps ) -> ( A i^i C ) = ( B i^i D ) ) $=
        ( wceq cin ineq12 syl2an ) ACDIEFICEJDFJIBGHCDEFKL $.
    $}
  $}

  $( A frequently-used variant of subclass definition ~ df-ss .  (Contributed
     by NM, 10-Jan-2015.) $)
  dfss1 $p |- ( A C_ B <-> ( B i^i A ) = A ) $=
    ( wss cin wceq df-ss incom eqeq1i bitri ) ABCABDZAEBADZAEABFJKAABGHI $.

  $( Another definition of subclasshood.  Similar to ~ df-ss , ~ dfss , and
     ~ dfss1 .  (Contributed by David Moews, 1-May-2017.) $)
  dfss5 $p |- ( A C_ B <-> A = ( B i^i A ) ) $=
    ( wss cin wceq dfss1 eqcom bitri ) ABCBADZAEAIEABFIAGH $.

  ${
    $d x y $.  $d y A $.  $d y B $.
    nfin.1 $e |- F/_ x A $.
    nfin.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for the intersection of classes.
       (Contributed by NM, 15-Sep-2003.)  (Revised by Mario Carneiro,
       14-Oct-2016.) $)
    nfin $p |- F/_ x ( A i^i B ) $=
      ( vy cin cv wcel crab dfin5 nfcri nfrab nfcxfr ) ABCGFHCIZFBJFBCKOAFBAFCE
      LDMN $.
  $}

  ${
    $d x ph $.  $d x A $.  $d x B $.
    rabbi2dva.1 $e |- ( ( ph /\ x e. A ) -> ( x e. B <-> ps ) ) $.
    $( Deduction from a wff to a restricted class abstraction.  (Contributed by
       NM, 14-Jan-2014.) $)
    rabbi2dva $p |- ( ph -> ( A i^i B ) = { x e. A | ps } ) $=
      ( cin cv wcel crab dfin5 rabbidva syl5eq ) ADEGCHEIZCDJBCDJCDEKANBCDFLM
      $.
  $}

  ${
    $d x A $.
    $( Idempotent law for intersection of classes.  Theorem 15 of [Suppes]
       p. 26.  (Contributed by NM, 5-Aug-1993.) $)
    inidm $p |- ( A i^i A ) = A $=
      ( vx cv wcel anidm ineqri ) BAAABCADEF $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Associative law for intersection of classes.  Exercise 9 of
       [TakeutiZaring] p. 17.  (Contributed by NM, 3-May-1994.) $)
    inass $p |- ( ( A i^i B ) i^i C ) = ( A i^i ( B i^i C ) ) $=
      ( vx cin cv wcel wa anass elin anbi2i bitr4i anbi1i 3bitr4i ineqri ) DABE
      ZCABCEZEZDFZAGZSBGZHZSCGZHZTSQGZHZSPGZUCHSRGUDTUAUCHZHUFTUAUCIUEUHTSBCJKL
      UGUBUCSABJMSAQJNO $.
  $}

  $( A rearrangement of intersection.  (Contributed by NM, 21-Apr-2001.) $)
  in12 $p |- ( A i^i ( B i^i C ) ) = ( B i^i ( A i^i C ) ) $=
    ( cin incom ineq1i inass 3eqtr3i ) ABDZCDBADZCDABCDDBACDDIJCABEFABCGBACGH
    $.

  $( A rearrangement of intersection.  (Contributed by NM, 21-Apr-2001.)
     (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  in32 $p |- ( ( A i^i B ) i^i C ) = ( ( A i^i C ) i^i B ) $=
    ( cin inass in12 incom 3eqtri ) ABDCDABCDDBACDZDIBDABCEABCFBIGH $.

  $( A rearrangement of intersection.  (Contributed by NM, 27-Aug-2012.) $)
  in13 $p |- ( A i^i ( B i^i C ) ) = ( C i^i ( B i^i A ) ) $=
    ( cin in32 incom 3eqtr4i ) BCDZADBADZCDAHDCIDBCAEAHFCIFG $.

  $( A rearrangement of intersection.  (Contributed by NM, 27-Aug-2012.) $)
  in31 $p |- ( ( A i^i B ) i^i C ) = ( ( C i^i B ) i^i A ) $=
    ( cin in12 incom 3eqtr4i ) CABDZDACBDZDHCDIADCABEHCFIAFG $.

  $( Rotate the intersection of 3 classes.  (Contributed by NM,
     27-Aug-2012.) $)
  inrot $p |- ( ( A i^i B ) i^i C ) = ( ( C i^i A ) i^i B ) $=
    ( cin in31 in32 eqtri ) ABDCDCBDADCADBDABCECBAFG $.

  $( Rearrangement of intersection of 4 classes.  (Contributed by NM,
     21-Apr-2001.) $)
  in4 $p |- ( ( A i^i B ) i^i ( C i^i D ) ) =
            ( ( A i^i C ) i^i ( B i^i D ) ) $=
    ( cin in12 ineq2i inass 3eqtr4i ) ABCDEZEZEACBDEZEZEABEJEACELEKMABCDFGABJHA
    CLHI $.

  $( Intersection distributes over itself.  (Contributed by NM, 6-May-1994.) $)
  inindi $p |- ( A i^i ( B i^i C ) ) = ( ( A i^i B ) i^i ( A i^i C ) ) $=
    ( cin inidm ineq1i in4 eqtr3i ) AADZBCDZDAJDABDACDDIAJAEFAABCGH $.

  $( Intersection distributes over itself.  (Contributed by NM,
     17-Aug-2004.) $)
  inindir $p |- ( ( A i^i B ) i^i C ) = ( ( A i^i C ) i^i ( B i^i C ) ) $=
    ( cin inidm ineq2i in4 eqtr3i ) ABDZCCDZDICDACDBCDDJCICEFABCCGH $.

  $( A relationship between subclass and intersection.  Similar to Exercise 9
     of [TakeutiZaring] p. 18.  (Contributed by NM, 17-May-1994.) $)
  sseqin2 $p |- ( A C_ B <-> ( B i^i A ) = A ) $=
    ( dfss1 ) ABC $.

  ${
    $d x A $.  $d x B $.
    $( The intersection of two classes is a subset of one of them.  Part of
       Exercise 12 of [TakeutiZaring] p. 18.  (Contributed by NM,
       27-Apr-1994.) $)
    inss1 $p |- ( A i^i B ) C_ A $=
      ( vx cin cv wcel elin simplbi ssriv ) CABDZACEZJFKAFKBFKABGHI $.
  $}

  $( The intersection of two classes is a subset of one of them.  Part of
     Exercise 12 of [TakeutiZaring] p. 18.  (Contributed by NM,
     27-Apr-1994.) $)
  inss2 $p |- ( A i^i B ) C_ B $=
    ( cin incom inss1 eqsstr3i ) ABCBACBBADBAEF $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Subclass of intersection.  Theorem 2.8(vii) of [Monk1] p. 26.
       (Contributed by NM, 15-Jun-2004.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    ssin $p |- ( ( A C_ B /\ A C_ C ) <-> A C_ ( B i^i C ) ) $=
      ( vx cv wcel wi wal wa cin wss elin imbi2i albii jcab 19.26 3bitrri dfss2
      anbi12i 3bitr4i ) DEZAFZUABFZGZDHZUBUACFZGZDHZIZUBUABCJZFZGZDHZABKZACKZIA
      UJKUMUBUCUFIZGZDHUDUGIZDHUIULUQDUKUPUBUABCLMNUQURDUBUCUFONUDUGDPQUNUEUOUH
      DABRDACRSDAUJRT $.
  $}

  ${
    ssini.1 $e |- A C_ B $.
    ssini.2 $e |- A C_ C $.
    $( An inference showing that a subclass of two classes is a subclass of
       their intersection.  (Contributed by NM, 24-Nov-2003.) $)
    ssini $p |- A C_ ( B i^i C ) $=
      ( wss wa cin pm3.2i ssin mpbi ) ABFZACFZGABCHFLMDEIABCJK $.
  $}

  ${
    ssind.1 $e |- ( ph -> A C_ B ) $.
    ssind.2 $e |- ( ph -> A C_ C ) $.
    $( A deduction showing that a subclass of two classes is a subclass of
       their intersection.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.) $)
    ssind $p |- ( ph -> A C_ ( B i^i C ) ) $=
      ( wss cin wa ssin biimpi syl2anc ) ABCGZBDGZBCDHGZEFMNIOBCDJKL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Add right intersection to subclass relation.  (Contributed by NM,
       16-Aug-1994.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    ssrin $p |- ( A C_ B -> ( A i^i C ) C_ ( B i^i C ) ) $=
      ( vx wss cin cv wcel wa ssel anim1d elin 3imtr4g ssrdv ) ABEZDACFZBCFZODG
      ZAHZRCHZIRBHZTIRPHRQHOSUATABRJKRACLRBCLMN $.

    $( Add left intersection to subclass relation.  (Contributed by NM,
       19-Oct-1999.) $)
    sslin $p |- ( A C_ B -> ( C i^i A ) C_ ( C i^i B ) ) $=
      ( wss cin ssrin incom 3sstr4g ) ABDACEBCECAECBEABCFCAGCBGH $.
  $}

  $( Intersection of subclasses.  (Contributed by NM, 5-May-2000.) $)
  ss2in $p |- ( ( A C_ B /\ C C_ D ) -> ( A i^i C ) C_ ( B i^i D ) ) $=
    ( wss cin ssrin sslin sylan9ss ) ABECDEACFBCFBDFABCGCDBHI $.

  $( Intersection preserves subclass relationship.  (Contributed by NM,
     14-Sep-1999.) $)
  ssinss1 $p |- ( A C_ C -> ( A i^i B ) C_ C ) $=
    ( cin wss wi inss1 sstr2 ax-mp ) ABDZAEACEJCEFABGJACHI $.

  $( Inclusion of an intersection of two classes.  (Contributed by NM,
     30-Oct-2014.) $)
  inss $p |- ( ( A C_ C \/ B C_ C ) -> ( A i^i B ) C_ C ) $=
    ( wss cin ssinss1 incom syl5eqss jaoi ) ACDABEZCDBCDZABCFKJBAECABGBACFHI $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Combinations of difference, union, and intersection of two classes
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Absorption law for union.  (Contributed by NM, 16-Apr-2006.) $)
  unabs $p |- ( A u. ( A i^i B ) ) = A $=
    ( cin wss cun wceq inss1 ssequn2 mpbi ) ABCZADAJEAFABGJAHI $.

  $( Absorption law for intersection.  (Contributed by NM, 16-Apr-2006.) $)
  inabs $p |- ( A i^i ( A u. B ) ) = A $=
    ( cun wss cin wceq ssun1 df-ss mpbi ) AABCZDAJEAFABGAJHI $.

  $( Negation of subclass expressed in terms of intersection and proper
     subclass.  (Contributed by NM, 30-Jun-2004.)  (Proof shortened by Andrew
     Salmon, 26-Jun-2011.) $)
  nssinpss $p |- ( -. A C_ B <-> ( A i^i B ) C. A ) $=
    ( cin wne wss wa wn wpss inss1 biantrur df-ss necon3bbii df-pss 3bitr4i ) A
    BCZADZOAEZPFABEZGOAHQPABIJROAABKLOAMN $.

  $( Negation of subclass expressed in terms of proper subclass and union.
     (Contributed by NM, 15-Sep-2004.) $)
  nsspssun $p |- ( -. A C_ B <-> B C. ( A u. B ) ) $=
    ( wss wn cun wa wpss ssun2 biantrur ssid biantru unss bitri xchnxbir dfpss3
    bitr4i ) ABCZDBABEZCZRBCZDZFZBRGTUBQSUABAHIQQBBCZFTUCQBJKABBLMNBROP $.

  ${
    $d x A $.  $d x B $.
    $( Subclass defined in terms of class difference.  See comments under
       ~ dfun2 .  (Contributed by NM, 22-Mar-1998.)  (Proof shortened by Andrew
       Salmon, 26-Jun-2011.) $)
    dfss4 $p |- ( A C_ B <-> ( B \ ( B \ A ) ) = A ) $=
      ( vx wss wceq cdif sseqin2 cv wcel wn wa eldif notbii anbi2i wi elin abai
      cin iman bitr4i 3bitri difeqri eqeq1i ) ABDBARZAEBBAFZFZAEABGUFUDACBUEUDC
      HZBIZUGUEIZJZKUHUHUGAIZJKZJZKZUGUDIZUJUMUHUIULUGBALMNUOUHUKKUHUHUKOZKUNUG
      BAPUHUKQUPUMUHUHUKSNUATUBUCT $.

    $( An alternate definition of the union of two classes in terms of class
       difference, requiring no dummy variables.  Along with ~ dfin2 and
       ~ dfss4 it shows we can express union, intersection, and subset directly
       in terms of the single "primitive" operation ` \ ` (class difference).
       (Contributed by NM, 10-Jun-2004.) $)
    dfun2 $p |- ( A u. B ) = ( _V \ ( ( _V \ A ) \ B ) ) $=
      ( vx cvv cdif cv wcel wo wn wa eldif mpbiran anbi1i ioran 3bitr4i con2bii
      vex bitr4i uneqri ) CABDDAEZBEZEZCFZAGZUCBGZHZUCUAGZIZUCUBGZUGUFUCTGZUEIZ
      JUDIZUKJUGUFIUJULUKUJUCDGZULCQZUCDAKLMUCTBKUDUENOPUIUMUHUNUCDUAKLRS $.

    $( An alternate definition of the intersection of two classes in terms of
       class difference, requiring no dummy variables.  See comments under
       ~ dfun2 .  Another version is given by ~ dfin4 .  (Contributed by NM,
       10-Jun-2004.) $)
    dfin2 $p |- ( A i^i B ) = ( A \ ( _V \ B ) ) $=
      ( vx cvv cdif cv wcel wa vex eldif mpbiran con2bii anbi2i bitr4i ineqri
      wn ) CABADBEZEZCFZAGZSBGZHTSQGZPZHSRGUAUCTUBUAUBSDGUAPCISDBJKLMSAQJNO $.

    $( Difference with intersection.  Theorem 33 of [Suppes] p. 29.
       (Contributed by NM, 31-Mar-1998.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    difin $p |- ( A \ ( A i^i B ) ) = ( A \ B ) $=
      ( vx cin cdif cv wcel wi wn pm4.61 anclb elin imbi2i iman 3bitr2i con2bii
      wa eldif 3bitr4i difeqri ) CAABDZABEZCFZAGZUCBGZHZIUDUEIQUDUCUAGZIQZUCUBG
      UDUEJUFUHUFUDUDUEQZHUDUGHUHIUDUEKUGUIUDUCABLMUDUGNOPUCABRST $.
  $}

  $( Union defined in terms of intersection (De Morgan's law).  Definition of
     union in [Mendelson] p. 231.  (Contributed by NM, 8-Jan-2002.) $)
  dfun3 $p |- ( A u. B ) = ( _V \ ( ( _V \ A ) i^i ( _V \ B ) ) ) $=
    ( cun cvv cdif cin dfun2 dfin2 ddif difeq2i eqtr2i eqtri ) ABCDDAEZBEZEDMDB
    EZFZEABGNPDPMDOEZENMOHQBMBIJKJL $.

  $( Intersection defined in terms of union (De Morgan's law).  Similar to
     Exercise 4.10(n) of [Mendelson] p. 231.  (Contributed by NM,
     8-Jan-2002.) $)
  dfin3 $p |- ( A i^i B ) = ( _V \ ( ( _V \ A ) u. ( _V \ B ) ) ) $=
    ( cvv cdif cun cin ddif dfun2 difeq1i difeq2i eqtri dfin2 3eqtr4ri ) CCACBD
    ZDZDZDOCCADZNEZDABFOGRPCRCCQDZNDZDPQNHTOCSANAGIJKJABLM $.

  $( Alternate definition of the intersection of two classes.  Exercise 4.10(q)
     of [Mendelson] p. 231.  (Contributed by NM, 25-Nov-2003.) $)
  dfin4 $p |- ( A i^i B ) = ( A \ ( A \ B ) ) $=
    ( cin cdif wss wceq inss1 dfss4 mpbi difin difeq2i eqtr3i ) AAABCZDZDZMAABD
    ZDMAEOMFABGMAHINPAABJKL $.

  $( Intersection with universal complement.  Remark in [Stoll] p. 20.
     (Contributed by NM, 17-Aug-2004.) $)
  invdif $p |- ( A i^i ( _V \ B ) ) = ( A \ B ) $=
    ( cvv cdif cin dfin2 ddif difeq2i eqtri ) ACBDZEACJDZDABDAJFKBABGHI $.

  $( Intersection with class difference.  Theorem 34 of [Suppes] p. 29.
     (Contributed by NM, 17-Aug-2004.) $)
  indif $p |- ( A i^i ( A \ B ) ) = ( A \ B ) $=
    ( cdif cin dfin4 difeq2i difin 3eqtr2i ) AABCZDAAICZCAABDZCIAIEKJAABEFABGH
    $.

  $( Bring an intersection in and out of a class difference.  (Contributed by
     Jeff Hankins, 15-Jul-2009.) $)
  indif2 $p |- ( A i^i ( B \ C ) ) = ( ( A i^i B ) \ C ) $=
    ( cin cvv cdif inass invdif ineq2i 3eqtr3ri ) ABDZECFZDABLDZDKCFABCFZDABLGK
    CHMNABCHIJ $.

  $( Bring an intersection in and out of a class difference.  (Contributed by
     Mario Carneiro, 15-May-2015.) $)
  indif1 $p |- ( ( A \ C ) i^i B ) = ( ( A i^i B ) \ C ) $=
    ( cdif cin indif2 incom difeq1i 3eqtr3i ) BACDZEBAEZCDJBEABEZCDBACFBJGKLCBA
    GHI $.

  $( Commutation law for intersection and difference.  (Contributed by Scott
     Fenton, 18-Feb-2013.) $)
  indifcom $p |- ( A i^i ( B \ C ) ) = ( B i^i ( A \ C ) ) $=
    ( cin cdif incom difeq1i indif2 3eqtr4i ) ABDZCEBADZCEABCEDBACEDJKCABFGABCH
    BACHI $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Distributive law for intersection over union.  Exercise 10 of
       [TakeutiZaring] p. 17.  (Contributed by NM, 30-Sep-2002.)  (Proof
       shortened by Andrew Salmon, 26-Jun-2011.) $)
    indi $p |- ( A i^i ( B u. C ) ) = ( ( A i^i B ) u. ( A i^i C ) ) $=
      ( vx cun cin cv wcel wo wa andi elin orbi12i bitr4i anbi2i 3bitr4i ineqri
      elun ) DABCEZABFZACFZEZDGZAHZUCBHZUCCHZIZJZUCTHZUCUAHZIZUDUCSHZJUCUBHUHUD
      UEJZUDUFJZIUKUDUEUFKUIUMUJUNUCABLUCACLMNULUGUDUCBCROUCTUARPQ $.

    $( Distributive law for union over intersection.  Exercise 11 of
       [TakeutiZaring] p. 17.  (Contributed by NM, 30-Sep-2002.)  (Proof
       shortened by Andrew Salmon, 26-Jun-2011.) $)
    undi $p |- ( A u. ( B i^i C ) ) = ( ( A u. B ) i^i ( A u. C ) ) $=
      ( vx cin cv wcel wo wa elin orbi2i ordi elun anbi12i bitr2i 3bitri uneqri
      cun ) DABCEZABRZACRZEZDFZAGZUCSGZHUDUCBGZUCCGZIZHUDUFHZUDUGHZIZUCUBGZUEUH
      UDUCBCJKUDUFUGLULUCTGZUCUAGZIUKUCTUAJUMUIUNUJUCABMUCACMNOPQ $.
  $}

  $( Distributive law for intersection over union.  Theorem 28 of [Suppes]
     p. 27.  (Contributed by NM, 30-Sep-2002.) $)
  indir $p |- ( ( A u. B ) i^i C ) = ( ( A i^i C ) u. ( B i^i C ) ) $=
    ( cun cin indi incom uneq12i 3eqtr4i ) CABDZECAEZCBEZDJCEACEZBCEZDCABFJCGMK
    NLACGBCGHI $.

  $( Distributive law for union over intersection.  Theorem 29 of [Suppes]
     p. 27.  (Contributed by NM, 30-Sep-2002.) $)
  undir $p |- ( ( A i^i B ) u. C ) = ( ( A u. C ) i^i ( B u. C ) ) $=
    ( cin cun undi uncom ineq12i 3eqtr4i ) CABDZECAEZCBEZDJCEACEZBCEZDCABFJCGMK
    NLACGBCGHI $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Infer equality from equalities of union and intersection.  Exercise 20
       of [Enderton] p. 32 and its converse.  (Contributed by NM,
       10-Aug-2004.) $)
    unineq $p |- ( ( ( A u. C ) = ( B u. C ) /\ ( A i^i C ) = ( B i^i C ) )
                 <-> A = B ) $=
      ( vx cun wceq cin wa wcel wb eleq2 elin 3bitr3g iba bibi12d syl5ibr uncom
      wo elun biorf cv wi adantld eqeq12i sylbi adantrd pm2.61i eqrdv uneq1 jca
      wn ineq1 impbii ) ACEZBCEZFZACGZBCGZFZHZABFZUTDABDUAZCIZUTVBAIZVBBIZJZUBV
      CUSVFUPUSVFVCVDVCHZVEVCHZJUSVBUQIVBURIVGVHUQURVBKVBACLVBBCLMVCVDVGVEVHVCV
      DNVCVENOPUCVCUKZUPVFUSUPVFVIVCVDRZVCVERZJUPVBCAEZIZVBCBEZIZVJVKUPVLVNFVMV
      OJUNVLUOVNACQBCQUDVLVNVBKUEVBCASVBCBSMVIVDVJVEVKVCVDTVCVETOPUFUGUHVAUPUSA
      BCUIABCULUJUM $.
  $}

  $( Equality of union and intersection implies equality of their arguments.
     (Contributed by NM, 16-Apr-2006.)  (Proof shortened by Andrew Salmon,
     26-Jun-2011.) $)
  uneqin $p |- ( ( A u. B ) = ( A i^i B ) <-> A = B ) $=
    ( cun cin wceq wss wa eqimss unss ssin sstr sylbir simpl anim12i syl sylibr
    eqss unidm inidm eqtr4i uneq2 ineq2 3eqtr3a impbii ) ABCZABDZEZABEZUGABFZBA
    FZGZUHUGUEUFFZUKUEUFHULAUFFZBUFFZGUKABUFIUMUIUNUJUMAAFUIGUIAABJAABKLUNUJBBF
    ZGUJBABJUJUOMLNLOABQPUHAACZAADZUEUFUPAUQARASTABAUAABAUBUCUD $.

  $( Distributive law for class difference.  Theorem 39 of [Suppes] p. 29.
     (Contributed by NM, 17-Aug-2004.) $)
  difundi $p |- ( A \ ( B u. C ) ) = ( ( A \ B ) i^i ( A \ C ) ) $=
    ( cun cdif cvv cin dfun3 difeq2i inindi dfin2 invdif ineq12i 3eqtr3i eqtri
    ) ABCDZEAFFBEZFCEZGZEZEZABEZACEZGZPTABCHIASGAQGZARGZGUAUDAQRJASKUEUBUFUCABL
    ACLMNO $.

  $( Distributive law for class difference.  (Contributed by NM,
     17-Aug-2004.) $)
  difundir $p |- ( ( A u. B ) \ C ) = ( ( A \ C ) u. ( B \ C ) ) $=
    ( cun cvv cdif cin indir invdif uneq12i 3eqtr3i ) ABDZECFZGAMGZBMGZDLCFACFZ
    BCFZDABMHLCINPOQACIBCIJK $.

  $( Distributive law for class difference.  Theorem 40 of [Suppes] p. 29.
     (Contributed by NM, 17-Aug-2004.) $)
  difindi $p |- ( A \ ( B i^i C ) ) = ( ( A \ B ) u. ( A \ C ) ) $=
    ( cin cdif cvv cun dfin3 difeq2i indi dfin2 invdif uneq12i 3eqtr3i eqtri )
    ABCDZEAFFBEZFCEZGZEZEZABEZACEZGZPTABCHIASDAQDZARDZGUAUDAQRJASKUEUBUFUCABLAC
    LMNO $.

  $( Distributive law for class difference.  (Contributed by NM,
     17-Aug-2004.) $)
  difindir $p |- ( ( A i^i B ) \ C ) = ( ( A \ C ) i^i ( B \ C ) ) $=
    ( cin cvv cdif inindir invdif ineq12i 3eqtr3i ) ABDZECFZDALDZBLDZDKCFACFZBC
    FZDABLGKCHMONPACHBCHIJ $.

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Distribute intersection over difference.  (Contributed by Scott Fenton,
       14-Apr-2011.) $)
    indifdir $p |- ( ( A \ B ) i^i C ) = ( ( A i^i C ) \ ( B i^i C ) ) $=
      ( vx cdif cin cv wcel wn wa pm3.24 intnan anass mtbir biorfi 3bitr4i elin
      wo eldif bitri an32 andi ianor anbi2i bitr4i anbi1i notbii anbi12i eqriv
      ) DABEZCFZACFZBCFZEZDGZAHZUOBHZIZJZUOCHZJZUPUTJZUQUTJZIZJZUOUKHZUOUNHZVAV
      BURUTIZRZJZVEVBURJZVKVBVHJZRVAVJVLVKVLUPUTVHJZJVMUPUTKLUPUTVHMNOUPURUTUAV
      BURVHUBPVDVIVBUQUTUCUDUEVFUOUJHZUTJVAUOUJCQVNUSUTUOABSUFTVGUOULHZUOUMHZIZ
      JVEUOULUMSVOVBVQVDUOACQVPVCUOBCQUGUHTPUI $.
  $}

  $( Set difference with a set difference.  (Contributed by Thierry Arnoux,
     18-Dec-2017.) $)
  difdif2 $p |- ( A \ ( B \ C ) ) = ( ( A \ B ) u. ( A i^i C ) ) $=
    ( cvv cdif cin cun difindi invdif eqcomi difeq2i dfin2 uneq2i 3eqtr4i ) ABD
    CEZFZEABEZAOEZGABCEZEQACFZGABOHSPAPSBCIJKTRQACLMN $.

  $( De Morgan's law for union.  Theorem 5.2(13) of [Stoll] p. 19.
     (Contributed by NM, 18-Aug-2004.) $)
  undm $p |- ( _V \ ( A u. B ) ) = ( ( _V \ A ) i^i ( _V \ B ) ) $=
    ( cvv difundi ) CABD $.

  $( De Morgan's law for intersection.  Theorem 5.2(13') of [Stoll] p. 19.
     (Contributed by NM, 18-Aug-2004.) $)
  indm $p |- ( _V \ ( A i^i B ) ) = ( ( _V \ A ) u. ( _V \ B ) ) $=
    ( cvv difindi ) CABD $.

  $( A relationship involving double difference and union.  (Contributed by NM,
     29-Aug-2004.) $)
  difun1 $p |- ( A \ ( B u. C ) ) = ( ( A \ B ) \ C ) $=
    ( cvv cdif cin cun inass invdif eqtr3i undm ineq2i difeq1i ) ADBEZFZCEZABCG
    ZEZABEZCEANDCEZFZFZPROTFUBPANTHOCIJADQEZFUBRUCUAABCKLAQIJJOSCABIMJ $.

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( An equality involving class union and class difference.  The first
       equality of Exercise 13 of [TakeutiZaring] p. 22.  (Contributed by Alan
       Sare, 17-Apr-2012.) $)
    undif3 $p |- ( A u. ( B \ C ) ) = ( ( A u. B ) \ ( C \ A ) ) $=
      ( vx cdif cun cv wcel wn wa elun pm4.53 eldif xchnxbir anbi12i orbi2i orc
      wo olc jca anim12i simpl adantr adantl ccase impbii 3bitri 3bitr4ri eqriv
      jaoi orcd ) DABCEZFZABFZCAEZEZDGZUNHZUQUOHZIZJUQAHZUQBHZRZUQCHZIZVARZJZUQ
      UPHUQUMHZURVCUTVFUQABKVDVAIJVFUSVDVALUQCAMNOUQUNUOMVHVAUQULHZRVAVBVEJZRZV
      GUQAULKVIVJVAUQBCMPVKVGVAVGVJVAVCVFVAVBQVAVESTVBVCVEVFVBVASVEVAQUAUJVAVEV
      BVAVKVAVEJVAVJVAVEUBUKVJVASVAVKVAVAVJQZUCVAVKVBVLUDUEUFUGUHUI $.

    $( Represent a set difference as an intersection with a larger difference.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    difin2 $p |- ( A C_ C -> ( A \ B ) = ( ( C \ B ) i^i A ) ) $=
      ( vx wss cdif cin cv wcel wn ssel pm4.71d anbi1d eldif anbi1i ancom anass
      wa elin bitr4i 3bitri 3bitr4g eqrdv ) ACEZDABFZCBFZAGZUDDHZAIZUHBIJZRUIUH
      CIZRZUJRZUHUEIUHUGIZUDUIULUJUDUIUKACUHKLMUHABNUNUHUFIZUIRUKUJRZUIRZUMUHUF
      ASUOUPUIUHCBNOUQUIUPRUMUPUIPUIUKUJQTUAUBUC $.
  $}

  $( Swap second and third argument of double difference.  (Contributed by NM,
     18-Aug-2004.) $)
  dif32 $p |- ( ( A \ B ) \ C ) = ( ( A \ C ) \ B ) $=
    ( cun cdif uncom difeq2i difun1 3eqtr3i ) ABCDZEACBDZEABECEACEBEJKABCFGABCH
    ACBHI $.

  $( Absorption-like law for class difference: you can remove a class only
     once.  (Contributed by FL, 2-Aug-2009.) $)
  difabs $p |- ( ( A \ B ) \ B ) = ( A \ B ) $=
    ( cun cdif difun1 unidm difeq2i eqtr3i ) ABBCZDABDZBDJABBEIBABFGH $.

  $( Two ways to express symmetric difference.  This theorem shows the
     equivalence of the definition of symmetric difference in [Stoll] p. 13 and
     the restated definition in Example 4.1 of [Stoll] p. 262.  (Contributed by
     NM, 17-Aug-2004.) $)
  symdif1 $p |- ( ( A \ B ) u. ( B \ A ) ) = ( ( A u. B ) \ ( A i^i B ) ) $=
    ( cun cin cdif difundir difin incom difeq2i eqtri uneq12i eqtr2i ) ABCABDZE
    AMEZBMEZCABEZBAEZCABMFNPOQABGOBBADZEQMRBABHIBAGJKL $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Class abstractions with difference, union, and intersection of two classes
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)
  ${
    $d x A $.  $d x B $.
    $( Two ways to express symmetric difference.  (Contributed by NM,
       17-Aug-2004.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    symdif2 $p |- ( ( A \ B ) u. ( B \ A ) ) =
                  { x | -. ( x e. A <-> x e. B ) } $=
      ( cv wcel wb wn cdif cun wo wa eldif orbi12i elun xor 3bitr4i abbi2i ) AD
      ZBEZRCEZFGZABCHZCBHZIZRUBEZRUCEZJSTGKZTSGKZJRUDEUAUEUGUFUHRBCLRCBLMRUBUCN
      STOPQ $.
  $}

  ${
    $d x y $.  $d ph y $.  $d ps y $.
    $( Union of two class abstractions.  (Contributed by NM, 29-Sep-2002.)
       (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    unab $p |- ( { x | ph } u. { x | ps } ) = { x | ( ph \/ ps ) } $=
      ( vy cab wo wsb cv wcel sbor df-clab orbi12i 3bitr4ri uneqri ) DACEZBCEZA
      BFZCEZQCDGACDGZBCDGZFDHZRIUAOIZUAPIZFABCDJQDCKUBSUCTADCKBDCKLMN $.

    $( Intersection of two class abstractions.  (Contributed by NM,
       29-Sep-2002.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    inab $p |- ( { x | ph } i^i { x | ps } ) = { x | ( ph /\ ps ) } $=
      ( vy cab wa wsb cv wcel sban df-clab anbi12i 3bitr4ri ineqri ) DACEZBCEZA
      BFZCEZQCDGACDGZBCDGZFDHZRIUAOIZUAPIZFABCDJQDCKUBSUCTADCKBDCKLMN $.

    $( Difference of two class abstractions.  (Contributed by NM,
       23-Oct-2004.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    difab $p |- ( { x | ph } \ { x | ps } ) = { x | ( ph /\ -. ps ) } $=
      ( vy cab wn wcel wsb df-clab sban bicomi xchbinxr anbi12i 3bitrri difeqri
      wa cv sbn ) DACEZBCEZABFZPZCEZDQZUCGUBCDHACDHZUACDHZPUDSGZUDTGZFZPUBDCIAU
      ACDJUEUGUFUIUGUEADCIKUFBCDHUHBCDRBDCILMNO $.
  $}

  $( A class builder defined by a negation.  (Contributed by FL,
     18-Sep-2010.) $)
  notab $p |- { x | -. ph } = ( _V \ { x | ph } ) $=
    ( cv cvv wcel wn wa cab cdif crab df-rab rabab eqtr3i difab abid2 difeq1i )
    BCDEZAFZGBHZRBHZDABHZIZRBDJSTRBDKRBLMQBHZUAISUBQABNUCDUABDOPMM $.

  $( Union of two restricted class abstractions.  (Contributed by NM,
     25-Mar-2004.) $)
  unrab $p |- ( { x e. A | ph } u. { x e. A | ps } ) =
              { x e. A | ( ph \/ ps ) } $=
    ( crab cun cv wcel wa cab wo df-rab uneq12i unab andi abbii eqtr4i ) ACDEZB
    CDEZFCGDHZAIZCJZTBIZCJZFZABKZCDEZRUBSUDACDLBCDLMUGTUFIZCJZUEUFCDLUEUAUCKZCJ
    UIUAUCCNUHUJCTABOPQQQ $.

  $( Intersection of two restricted class abstractions.  (Contributed by NM,
     1-Sep-2006.) $)
  inrab $p |- ( { x e. A | ph } i^i { x e. A | ps } ) =
              { x e. A | ( ph /\ ps ) } $=
    ( crab cin cv wcel wa cab df-rab ineq12i inab anandi abbii eqtr4i ) ACDEZBC
    DEZFCGDHZAIZCJZSBIZCJZFZABIZCDEZQUARUCACDKBCDKLUFSUEIZCJZUDUECDKUDTUBIZCJUH
    TUBCMUGUICSABNOPPP $.

  ${
    $d x B $.
    $( Intersection with a restricted class abstraction.  (Contributed by NM,
       19-Nov-2007.) $)
    inrab2 $p |- ( { x e. A | ph } i^i B ) = { x e. ( A i^i B ) | ph } $=
      ( crab cin cv wcel cab df-rab abid2 eqcomi ineq12i inab elin anbi1i bitri
      wa an32 eqtr4i abbii ) ABCEZDFBGZCHZARZBIZUCDHZBIZFZABCDFZEZUBUFDUHABCJUH
      DBDKLMUKUCUJHZARZBIZUIABUJJUIUEUGRZBIUNUEUGBNUMUOBUMUDUGRZARUOULUPAUCCDOP
      UDUGASQUATTT $.
  $}

  $( Difference of two restricted class abstractions.  (Contributed by NM,
     23-Oct-2004.) $)
  difrab $p |- ( { x e. A | ph } \ { x e. A | ps } ) =
              { x e. A | ( ph /\ -. ps ) } $=
    ( crab cdif cv wcel wa wn df-rab difeq12i difab anass simpr con3i anim2i wi
    cab eqtr4i pm3.2 adantr con3d imdistani impbii bitr3i abbii ) ACDEZBCDEZFCG
    DHZAIZCSZUJBIZCSZFZABJZIZCDEZUHULUIUNACDKBCDKLURUJUQIZCSZUOUQCDKUOUKUMJZIZC
    SUTUKUMCMUSVBCUSUKUPIZVBUJAUPNVCVBUPVAUKUMBUJBOPQUKVAUPUKBUMUJBUMRAUJBUAUBU
    CUDUEUFUGTTT $.

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of restricted class abstraction.  (Contributed by
       NM, 20-Sep-2003.) $)
    dfrab2 $p |- { x e. A | ph } = ( { x | ph } i^i A ) $=
      ( crab cv wcel wa cab cin df-rab inab abid2 ineq1i eqtr3i incom 3eqtri )
      ABCDBECFZAGBHZCABHZIZSCIABCJQBHZSIRTQABKUACSBCLMNCSOP $.

    $( Alternate definition of restricted class abstraction.  (Contributed by
       Mario Carneiro, 8-Sep-2013.) $)
    dfrab3 $p |- { x e. A | ph } = ( A i^i { x | ph } ) $=
      ( crab cv wcel wa cab cin df-rab inab abid2 ineq1i 3eqtr2i ) ABCDBECFZAGB
      HOBHZABHZICQIABCJOABKPCQBCLMN $.

    $( Complementation of restricted class abstractions.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    notrab $p |- ( A \ { x e. A | ph } ) = { x e. A | -. ph } $=
      ( cv wcel cab cdif wn crab difab cin difin dfrab3 difeq2i difeq1i 3eqtr4i
      wa abid2 df-rab ) BDCEZBFZABFZGZTAHZQBFCABCIZGZUDBCITABJCCUBKZGCUBGUFUCCU
      BLUEUGCABCMNUACUBBCROPUDBCSP $.

    $( Restricted class abstraction with a common superset.  (Contributed by
       Stefan O'Rear, 12-Sep-2015.)  (Proof shortened by Mario Carneiro,
       8-Nov-2015.) $)
    dfrab3ss $p |- ( A C_ B -> { x e. A | ph } = ( A i^i { x e. B | ph } ) ) $=
      ( wss cab crab wceq df-ss ineq1 eqcomd sylbi dfrab3 ineq2i eqtr4i 3eqtr4g
      cin inass ) CDEZCABFZQZCDQZTQZABCGCABDGZQZSUBCHZUAUCHCDIUFUCUAUBCTJKLABCM
      UECDTQZQUCUDUGCABDMNCDTROP $.
  $}

  $( Abstraction restricted to a union.  (Contributed by Stefan O'Rear,
     5-Feb-2015.) $)
  rabun2 $p |- { x e. ( A u. B ) | ph } =
      ( { x e. A | ph } u. { x e. B | ph } ) $=
    ( cun crab cv wcel wa cab df-rab uneq12i elun anbi1i andir bitri abbii unab
    wo eqtr4i ) ABCDEZFBGZUAHZAIZBJZABCFZABDFZEZABUAKUHUBCHZAIZBJZUBDHZAIZBJZEZ
    UEUFUKUGUNABCKABDKLUEUJUMSZBJUOUDUPBUDUIULSZAIUPUCUQAUBCDMNUIULAOPQUJUMBRTT
    T $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Restricted uniqueness with difference, union, and intersection
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x B $.
    $( Transfer uniqueness to a smaller subclass.  (Contributed by NM,
       20-Oct-2005.) $)
    reuss2 $p |- ( ( ( A C_ B /\ A. x e. A ( ph -> ps ) ) /\
                 ( E. x e. A ph /\ E! x e. B ps ) ) -> E! x e. A ph ) $=
      ( wrex wreu wa wss wi wral wcel wex weu df-rex df-reu anbi12i wal sylan2b
      cv wmo df-ral ssel prth sylan exp4b com23 a2d imp4a alimdv imp euimmo syl
      eu5 simplbi2 syl9 imp32 sylibr ) ACDFZBCEGZHDEIZABJZCDKZHZCTZDLZAHZCMZVEE
      LZBHZCNZHZACDGZUSVHUTVKACDOBCEPQVDVLHVGCNZVMVDVHVKVNVDVKVGCUAZVHVNVDVGVJJ
      ZCRZVKVOJVCVAVFVBJZCRZVQVBCDUBVAVSVQVAVRVPCVAVRVFAVJVAVFVBAVJJZVAVBVFVTVA
      VBVFAVJVAVFVIJVBVPDEVEUCVFVIABUDUEUFUGUHUIUJUKSVGVJCULUMVNVHVOVGCUNUOUPUQ
      ACDPURS $.

    $( Transfer uniqueness to a smaller subclass.  (Contributed by NM,
       21-Aug-1999.) $)
    reuss $p |- ( ( A C_ B /\ E. x e. A ph /\ E! x e. B ph ) ->
                E! x e. A ph ) $=
      ( wss wrex wreu wi wral wa cv wcel idd rgen reuss2 mpanl2 3impb ) CDEZABC
      FZABDGZABCGZRAAHZBCISTJUAUBBCBKCLAMNAABCDOPQ $.

    $( Transfer uniqueness to a smaller class.  (Contributed by NM,
       21-Oct-2005.) $)
    reuun1 $p |- ( ( E. x e. A ph /\ E! x e. ( A u. B ) ( ph \/ ps ) )
                 -> E! x e. A ph ) $=
      ( cun wss wo wi wral wrex wreu wa ssun1 orc rgenw reuss2 mpanl12 ) DDEFZG
      AABHZIZCDJACDKTCSLMACDLDENUACDABOPATCDSQR $.

    $( Transfer uniqueness to a smaller or larger class.  (Contributed by NM,
       21-Oct-2005.) $)
    reuun2 $p |- ( -. E. x e. B ph ->
             ( E! x e. ( A u. B ) ph <-> E! x e. A ph ) ) $=
      ( wrex wn cv wcel wa wo weu cun wreu wex df-rex euor2 sylnbi df-reu bitri
      wb elun anbi1i andir orcom eubii 3bitr4g ) ABDEZFBGZDHZAIZUHCHZAIZJZBKZUL
      BKZABCDLZMZABCMUGUJBNUNUOTABDOUJULBPQUQUHUPHZAIZBKUNABUPRUSUMBUSUKUIJZAIZ
      UMURUTAUHCDUAUBVAULUJJUMUKUIAUCULUJUDSSUESABCRUF $.

    $( Restricted uniqueness "picks" a member of a subclass.  (Contributed by
       NM, 21-Aug-1999.) $)
    reupick $p |- ( ( ( A C_ B /\ ( E. x e. A ph /\ E! x e. B ph ) ) /\ ph ) ->
                  ( x e. A <-> x e. B ) ) $=
      ( wss wrex wreu wa cv wcel wi ssel ad2antrr wex weu df-rex df-reu anbi12i
      ancrd anim1d an32 syl6ib eximdv eupick ex syl9 com23 imp32 exp3acom23 imp
      sylan2b impbid ) CDEZABCFZABDGZHZHZAHBIZCJZURDJZUMUSUTKUPACDURLZMUQAUTUSK
      UQUTAUSUPUMUSAHZBNZUTAHZBOZHVDUSKZUNVCUOVEABCPABDQRUMVCVEVFUMVEVCVFUMVCVD
      USHZBNZVEVFUMVBVGBUMVBUTUSHZAHVGUMUSVIAUMUSUTVASTUTUSAUAUBUCVEVHVFVDUSBUD
      UEUFUGUHUKUIUJUL $.

    $( Restricted uniqueness "picks" a member of a subclass.  (Contributed by
       Mario Carneiro, 19-Nov-2016.) $)
    reupick3 $p  |- ( ( E! x e. A ph /\ E. x e. A ( ph /\ ps ) /\ x e. A ) ->
       ( ph -> ps ) ) $=
      ( wreu wa wrex cv wcel wi weu wex df-reu df-rex anass exbii bitr4i eupick
      syl2anb exp3a 3impia ) ACDEZABFZCDGZCHDIZABJUBUDFUEABUBUEAFZCKUFBFZCLZUFB
      JUDACDMUDUEUCFZCLUHUCCDNUGUICUEABOPQUFBCRSTUA $.

    $( Restricted uniqueness "picks" a member of a subclass.  (Contributed by
       Mario Carneiro, 15-Dec-2013.)  (Proof shortened by Mario Carneiro,
       19-Nov-2016.) $)
    reupick2 $p |- ( ( ( A. x e. A ( ps -> ph ) /\ E. x e. A ps /\
                       E! x e. A ph ) /\ x e. A ) -> ( ph <-> ps ) ) $=
      ( wi wral wrex wreu w3a cv wcel ancr ralimi rexim syl reupick3 3exp com12
      wa syl6 3imp1 rsp 3ad2ant1 imp impbid ) BAEZCDFZBCDGZACDHZIZCJDKZSABUGUHU
      IUKABEZUGUHABSZCDGZUIUKULEZEUGBUMEZCDFUHUNEUFUPCDBALMBUMCDNOUIUNUOUIUNUKU
      LABCDPQRTUAUJUKUFUGUHUKUFEUIUFCDUBUCUDUE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           The empty set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the symbol for the empty or null set. $)
  $c (/) $. $( null set $)

  $( Extend class notation to include the empty set. $)
  c0 $a class (/) $.

  $( Define the empty set.  Special case of Exercise 4.10(o) of [Mendelson]
     p. 231.  For a more traditional definition, but requiring a dummy
     variable, see ~ dfnul2 .  (Contributed by NM, 5-Aug-1993.) $)
  df-nul $a |- (/) = ( _V \ _V ) $.

  $( Alternate definition of the empty set.  Definition 5.14 of [TakeutiZaring]
     p. 20.  (Contributed by NM, 26-Dec-1996.) $)
  dfnul2 $p |- (/) = { x | -. x = x } $=
    ( cv wceq wn c0 wcel cvv cdif wa df-nul eleq2i eldif eqid pm3.24 2th 3bitri
    con2bii abbi2i ) ABZSCZDZAESEFSGGHZFSGFZUCDIZUAEUBSJKSGGLTUDTUDDSMUCNOQPR
    $.

  $( Alternate definition of the empty set.  (Contributed by NM,
     25-Mar-2004.) $)
  dfnul3 $p |- (/) = { x e. A | -. x e. A } $=
    ( weq wn cab cv wcel wa crab pm3.24 equid 2th con1bii dfnul2 df-rab 3eqtr4i
    c0 abbii ) AACZDZAEAFBGZUADZHZAEQUBABITUCAUCSUCDSUAJAKLMRANUBABOP $.

  $( The empty set has no elements.  Theorem 6.14 of [Quine] p. 44.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Mario Carneiro,
     1-Sep-2015.) $)
  noel $p |- -. A e. (/) $=
    ( c0 wcel cvv cdif eldifi eldifn pm2.65i df-nul eleq2i mtbir ) ABCADDEZCZMA
    DCADDFADDGHBLAIJK $.

  $( If a set has elements, it is not empty.  (Contributed by NM,
     31-Dec-1993.) $)
  n0i $p |- ( B e. A -> -. A = (/) ) $=
    ( c0 wceq wcel noel eleq2 mtbiri con2i ) ACDZBAEZJKBCEBFACBGHI $.

  $( If a set has elements, it is not empty.  (Contributed by NM,
     31-Dec-1993.) $)
  ne0i $p |- ( B e. A -> A =/= (/) ) $=
    ( wcel c0 n0i neneqad ) BACADABEF $.

  $( The universal class is not equal to the empty set.  (Contributed by NM,
     11-Sep-2008.) $)
  vn0 $p |- _V =/= (/) $=
    ( vx cv cvv wcel c0 wne vex ne0i ax-mp ) ABZCDCEFAGCJHI $.

  ${
    $d x y $.  $d y A $.
    n0f.1 $e |- F/_ x A $.
    $( A nonempty class has at least one element.  Proposition 5.17(1) of
       [TakeutiZaring] p. 20.  This version of ~ n0 requires only that ` x `
       not be free in, rather than not occur in, ` A ` .  (Contributed by NM,
       17-Oct-2003.) $)
    n0f $p |- ( A =/= (/) <-> E. x x e. A ) $=
      ( c0 wne cv wcel wn wal wex wceq wb nfcv cleqf noel nbn bitr4i necon3abii
      albii df-ex ) BDEAFZBGZHZAIZHUBAJUDBDBDKUBUADGZLZAIUDABDCADMNUCUFAUEUBUAO
      PSQRUBATQ $.
  $}

  ${
    $d x y A $.
    $( A nonempty class has at least one element.  Proposition 5.17(1) of
       [TakeutiZaring] p. 20.  (Contributed by NM, 29-Sep-2006.) $)
    n0 $p |- ( A =/= (/) <-> E. x x e. A ) $=
      ( nfcv n0f ) ABABCD $.

    $( A nonempty class has at least one element.  Proposition 5.17(1) of
       [TakeutiZaring] p. 20.  (Contributed by NM, 5-Aug-1993.) $)
    neq0 $p |- ( -. A = (/) <-> E. x x e. A ) $=
      ( c0 wceq wn wne cv wcel wex df-ne n0 bitr3i ) BCDEBCFAGBHAIBCJABKL $.
  $}

  ${
    $d x A $.  $d x ph $.
    reximdva0.1 $e |- ( ( ph /\ x e. A ) -> ps ) $.
    $( Restricted existence deduced from non-empty class.  (Contributed by NM,
       1-Feb-2012.) $)
    reximdva0 $p |- ( ( ph /\ A =/= (/) ) -> E. x e. A ps ) $=
      ( c0 wne wa cv wcel wex wrex n0 ex ancld eximdv imp sylan2b df-rex sylibr
      ) ADFGZHCIDJZBHZCKZBCDLUAAUBCKZUDCDMAUEUDAUBUCCAUBBAUBBENOPQRBCDST $.
  $}

  ${
    $d A x $.
    $( A case of equivalence of "at most one" and "only one".  (Contributed by
       FL, 6-Dec-2010.) $)
    n0moeu $p |- ( A =/= (/) -> ( E* x x e. A <-> E! x x e. A ) ) $=
      ( c0 wne cv wcel wmo wex wa weu n0 biimpi biantrurd eu5 syl6bbr ) BCDZAEB
      FZAGZQAHZRIQAJPSRPSABKLMQANO $.
  $}

  $( Vacuous existential quantification is false.  (Contributed by NM,
     15-Oct-2003.) $)
  rex0 $p |- -. E. x e. (/) ph $=
    ( c0 cv wcel wn noel pm2.21i nrex ) ABCBDZCEAFJGHI $.

  ${
    $d x A $.
    $( The empty set has no elements.  Theorem 2 of [Suppes] p. 22.
       (Contributed by NM, 29-Aug-1993.) $)
    eq0 $p |- ( A = (/) <-> A. x -. x e. A ) $=
      ( c0 wceq cv wcel wn wal wex neq0 df-ex bitri con4bii ) BCDZAEBFZGAHZNGOA
      IPGABJOAKLM $.

    $( The universe contains every set.  (Contributed by NM, 11-Sep-2006.) $)
    eqv $p |- ( A = _V <-> A. x x e. A ) $=
      ( cvv wceq cv wcel wb wal dfcleq vex tbt albii bitr4i ) BCDAEZBFZNCFZGZAH
      OAHABCIOQAPOAJKLM $.
  $}

  ${
    $d x A $.  $d x y $.
    $( Membership of the empty set in another class.  (Contributed by NM,
       29-Jun-2004.) $)
    0el $p |- ( (/) e. A <-> E. x e. A A. y -. y e. x ) $=
      ( c0 wcel cv wceq wrex wn wal risset eq0 rexbii bitri ) DCEAFZDGZACHBFOEI
      BJZACHADCKPQACBOLMN $.
  $}

  ${
    $d x ph $.
    $( The class builder of a wff not containing the abstraction variable is
       either the universal class or the empty set.  (Contributed by Mario
       Carneiro, 29-Aug-2013.) $)
    abvor0 $p |- ( { x | ph } = _V \/ { x | ph } = (/) ) $=
      ( cab cvv wceq c0 wn cv wcel vex a1i 2thd abbi1dv con3i noel 2falsed orri
      id syl ) ABCZDEZTFEZUAGAGZUBAUAAABDAABHZDIZARUEABJKLMNUCABFUCAUDFIZUCRUFG
      UCUDOKPMSQ $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( Nonempty class abstraction.  (Contributed by NM, 26-Dec-1996.)  (Proof
       shortened by Mario Carneiro, 11-Nov-2016.) $)
    abn0 $p |- ( { x | ph } =/= (/) <-> E. x ph ) $=
      ( cab c0 wne cv wcel wex nfab1 n0f abid exbii bitri ) ABCZDEBFNGZBHABHBNA
      BIJOABABKLM $.
  $}

  $( Non-empty restricted class abstraction.  (Contributed by NM,
     29-Aug-1999.) $)
  rabn0 $p |- ( { x e. A | ph } =/= (/) <-> E. x e. A ph ) $=
    ( cv wcel wa cab c0 wne wex crab wrex abn0 df-rab neeq1i df-rex 3bitr4i ) B
    DCEAFZBGZHIRBJABCKZHIABCLRBMTSHABCNOABCPQ $.

  $( Any restricted class abstraction restricted to the empty set is empty.
     (Contributed by NM, 15-Oct-2003.)  (Proof shortened by Andrew Salmon,
     26-Jun-2011.) $)
  rab0 $p |- { x e. (/) | ph } = (/) $=
    ( cv c0 wcel wa cab weq wn crab equid noel intnanr 2th con2bii abbii df-rab
    dfnul2 3eqtr4i ) BCZDEZAFZBGBBHZIZBGABDJDUBUDBUCUBUCUBIBKUAATLMNOPABDQBRS
    $.

  $( Condition for a restricted class abstraction to be empty.  (Contributed by
     Jeff Madsen, 7-Jun-2010.) $)
  rabeq0 $p |- ( { x e. A | ph } = (/) <-> A. x e. A -. ph ) $=
    ( wn wral wrex crab c0 wceq ralnex rabn0 necon1bbii bitr2i ) ADBCEABCFZDABC
    GZHIABCJNOHABCKLM $.

  ${
    $d A x $.
    $( Law of excluded middle, in terms of restricted class abstractions.
       (Contributed by Jeff Madsen, 20-Jun-2011.) $)
    rabxm $p |- A = ( { x e. A | ph } u. { x e. A | -. ph } ) $=
      ( wn wo crab cun wceq rabid2 cv wcel exmidd mprgbir unrab eqtr4i ) CAADZE
      ZBCFZABCFPBCFGCRHQBCQBCIBJCKALMAPBCNO $.

    $( Law of noncontradiction, in terms of restricted class abstractions.
       (Contributed by Jeff Madsen, 20-Jun-2011.) $)
    rabnc $p |- ( { x e. A | ph } i^i { x e. A | -. ph } ) = (/) $=
      ( crab wn cin wa c0 inrab wceq rabeq0 cv wcel pm3.24 a1i mprgbir eqtri )
      ABCDAEZBCDFARGZBCDZHARBCITHJSEZBCSBCKUABLCMANOPQ $.
  $}

  ${
    $d x A $.
    $( The union of a class with the empty set is itself.  Theorem 24 of
       [Suppes] p. 27.  (Contributed by NM, 5-Aug-1993.) $)
    un0 $p |- ( A u. (/) ) = A $=
      ( vx c0 cv wcel wo noel biorfi bicomi uneqri ) BACABDZAEZLKCEZFMLKGHIJ $.

    $( The intersection of a class with the empty set is the empty set.
       Theorem 16 of [Suppes] p. 26.  (Contributed by NM, 5-Aug-1993.) $)
    in0 $p |- ( A i^i (/) ) = (/) $=
      ( vx c0 cv wcel wa noel bianfi bicomi ineqri ) BACCBDZCEZKAEZLFLMKGHIJ $.
  $}

  $( The intersection of a class with the universal class is itself.  Exercise
     4.10(k) of [Mendelson] p. 231.  (Contributed by NM, 17-May-1998.) $)
  inv1 $p |- ( A i^i _V ) = A $=
    ( cvv cin inss1 ssid ssv ssini eqssi ) ABCAABDAABAEAFGH $.

  $( The union of a class with the universal class is the universal class.
     Exercise 4.10(l) of [Mendelson] p. 231.  (Contributed by NM,
     17-May-1998.) $)
  unv $p |- ( A u. _V ) = _V $=
    ( cvv cun ssv ssun2 eqssi ) ABCZBGDBAEF $.

  ${
    $d A x $.
    $( The null set is a subset of any class.  Part of Exercise 1 of
       [TakeutiZaring] p. 22.  (Contributed by NM, 5-Aug-1993.) $)
    0ss $p |- (/) C_ A $=
      ( vx c0 cv wcel noel pm2.21i ssriv ) BCABDZCEIAEIFGH $.
  $}

  $( Any subset of the empty set is empty.  Theorem 5 of [Suppes] p. 23 and its
     converse.  (Contributed by NM, 17-Sep-2003.) $)
  ss0b $p |- ( A C_ (/) <-> A = (/) ) $=
    ( c0 wceq wss 0ss eqss mpbiran2 bicomi ) ABCZABDZIJBADAEABFGH $.

  $( Any subset of the empty set is empty.  Theorem 5 of [Suppes] p. 23.
     (Contributed by NM, 13-Aug-1994.) $)
  ss0 $p |- ( A C_ (/) -> A = (/) ) $=
    ( c0 wss wceq ss0b biimpi ) ABCABDAEF $.

  $( A subclass of an empty class is empty.  (Contributed by NM, 7-Mar-2007.)
     (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  sseq0 $p |- ( ( A C_ B /\ B = (/) ) -> A = (/) ) $=
    ( c0 wceq wss sseq2 ss0 syl6bi impcom ) BCDZABEZACDZJKACELBCAFAGHI $.

  $( A class with a nonempty subclass is nonempty.  (Contributed by NM,
     17-Feb-2007.) $)
  ssn0 $p |- ( ( A C_ B /\ A =/= (/) ) -> B =/= (/) ) $=
    ( wss c0 wne wceq sseq0 ex necon3d imp ) ABCZADEBDEKBDADKBDFADFABGHIJ $.

  ${
    abf.1 $e |- -. ph $.
    $( A class builder with a false argument is empty.  (Contributed by NM,
       20-Jan-2012.) $)
    abf $p |- { x | ph } = (/) $=
      ( cab c0 wss wceq cv wcel pm2.21i abssi ss0 ax-mp ) ABDZEFNEGABEABHEICJKN
      LM $.
  $}

  ${
    $d x A $.  $d x ph $.
    eq0rdv.1 $e |- ( ph -> -. x e. A ) $.
    $( Deduction rule for equality to the empty set.  (Contributed by NM,
       11-Jul-2014.) $)
    eq0rdv $p |- ( ph -> A = (/) ) $=
      ( c0 wss wceq cv wcel pm2.21d ssrdv ss0 syl ) ACEFCEGABCEABHZCINEIDJKCLM
      $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( The proper substitution of a proper class for a set into a class results
       in the empty set.  (Contributed by NM, 17-Aug-2018.) $)
    csbprc $p |- ( -. A e. _V -> [_ A / x ]_ B = (/) ) $=
      ( vy cvv wcel wn csb cv wsbc cab c0 df-csb wfal sbcex con3i pm2.21d falim
      impbid1 abbidv fal abf syl6eq syl5eq ) BEFZGZABCHDICFZABJZDKZLADBCMUFUIND
      KLUFUHNDUFUHNUFUHNUHUEUGABOPQUHRSTNDUAUBUCUD $.
  $}

  $( The proper substitution of a class into the empty set is empty.
     (Contributed by NM, 18-Aug-2018.) $)
  csb0 $p |- [_ A / x ]_ (/) = (/) $=
    ( cvv wcel c0 csb wceq csbconstg csbprc pm2.61i ) BCDABEFEGABECHABEIJ $.

  ${
    $d w x y z $.  $d w y z A $.  $d w y z B $.  $d w y z C $.
    $( Distribute proper substitution through a membership relation.
       (Contributed by NM, 10-Nov-2005.)  (Revised by NM, 18-Aug-2018.) $)
    sbcel12 $p |- ( [. A / x ]. B e. C <-> [_ A / x ]_ B e. [_ A / x ]_ C ) $=
      ( vy vz cvv wcel wsbc csb cv cab wsb dfsbcq2 abbidv eleq12d nfs1v nfab wn
      sbab wb wceq nfel sbie vtoclbg df-csb eleq12i syl6bbr sbcex con3i c0 noel
      weq csbprc eleq2d notbid mpbiri 2falsed pm2.61i ) BGHZCDHZABIZABCJZABDJZH
      ZUAUTVBEKZCHZABIZELZVFDHZABIZELZHZVEVAAFMVGAFMZELZVJAFMZELZHZVBVMFBGVAAFB
      NFKBUBZVOVIVQVLVSVNVHEVGAFBNOVSVPVKEVJAFBNOPVAVRAFAVOVQVNAEVGAFQRVPAEVJAF
      QRUCAFUMCVODVQAFECTAFEDTPUDUEVCVIVDVLAEBCUFAEBDUFUGUHUTSZVBVEVBUTVAABUIUJ
      VTVESVCUKHZSVCULVTVEWAVTVDUKVCABDUNUOUPUQURUS $.

    $( Distribute proper substitution through a membership relation.
       (Contributed by NM, 10-Nov-2005.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.)  Obsolete as of 18-Aug-2018.  Use ~ sbcel12 instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcel12gOLD $p |- ( A e. V -> ( [. A / x ]. B e. C <->
                   [_ A / x ]_ B e. [_ A / x ]_ C ) ) $=
      ( vy vz wcel wsbc cv cab csb wsb dfsbcq2 abbidv eleq12d nfs1v nfab df-csb
      sbab wceq nfel weq sbie vtoclbg eleq12i syl6bbr ) BEHCDHZABIZFJZCHZABIZFK
      ZUJDHZABIZFKZHZABCLZABDLZHUHAGMUKAGMZFKZUNAGMZFKZHZUIUQGBEUHAGBNGJBUAZVAU
      MVCUPVEUTULFUKAGBNOVEVBUOFUNAGBNOPUHVDAGAVAVCUTAFUKAGQRVBAFUNAGQRUBAGUCCV
      ADVCAGFCTAGFDTPUDUEURUMUSUPAFBCSAFBDSUFUG $.

    $( Distribute proper substitution through an equality relation.
       (Contributed by NM, 10-Nov-2005.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    sbceqg $p |- ( A e. V -> ( [. A / x ]. B = C <->
                   [_ A / x ]_ B = [_ A / x ]_ C ) ) $=
      ( vy vz wcel wceq wsbc cab csb wsb dfsbcq2 abbidv eqeq12d nfs1v nfab sbab
      cv nfeq weq sbie vtoclbg df-csb eqeq12i syl6bbr ) BEHCDIZABJZFTZCHZABJZFK
      ZUJDHZABJZFKZIZABCLZABDLZIUHAGMUKAGMZFKZUNAGMZFKZIZUIUQGBEUHAGBNGTBIZVAUM
      VCUPVEUTULFUKAGBNOVEVBUOFUNAGBNOPUHVDAGAVAVCUTAFUKAGQRVBAFUNAGQRUAAGUBCVA
      DVCAGFCSAGFDSPUCUDURUMUSUPAFBCUEAFBDUEUFUG $.
  $}

  $( Distribute proper substitution through negated membership.  (Contributed
     by Andrew Salmon, 18-Jun-2011.) $)
  sbcnel12g $p |- ( A e. V
        -> ( [. A / x ]. B e/ C <-> [_ A / x ]_ B e/ [_ A / x ]_ C ) ) $=
    ( wcel wn wsbc wnel csb sbcng df-nel sbcbii sbcel12 xchbinxr 3bitr4g ) BEFC
    DFZGZABHQABHZGCDIZABHABCJZABDJZIZQABEKTRABCDLMUCUAUBFSUAUBLABCDNOP $.

  $( Distribute proper substitution through an inequality.  (Contributed by
     Andrew Salmon, 18-Jun-2011.)  (Revised by NM, 18-Aug-2018.) $)
  sbcne12 $p |- ( [. A / x ]. B =/= C <-> [_ A / x ]_ B =/= [_ A / x ]_ C ) $=
    ( cvv wcel wne wsbc csb wb wceq nne sbcbii a1i sbcng sbceqg syl6bbr 3bitr3d
    wn csbprc con4bid sbcex con3i c0 eqtr4d sylibr 2falsed pm2.61i ) BEFZCDGZAB
    HZABCIZABDIZGZJUIUKUNUIUJSZABHZCDKZABHZUKSUNSZUPURJUIUOUQABCDLMNUJABEOUIURU
    LUMKZUSABCDEPULUMLZQRUAUISZUKUNUKUIUJABUBUCVBUTUSVBULUDUMABCTABDTUEVAUFUGUH
    $.

  $( Distribute proper substitution through an inequality.  (Contributed by
     Andrew Salmon, 18-Jun-2011.)  Obsolete as of 18-Aug-2018.  Use ~ sbcne12
     instead.  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  sbcne12gOLD $p |- ( A e. V -> ( [. A / x ]. B =/= C <-> [_ A / x ]_ B =/=
                   [_ A / x ]_ C ) ) $=
    ( wcel wne wsbc csb wn wceq wb nne sbcbii a1i sbcng syl6bbr 3bitr3d con4bid
    sbceqg ) BEFZCDGZABHZABCIZABDIZGZUAUBJZABHZCDKZABHZUCJUFJZUHUJLUAUGUIABCDMN
    OUBABEPUAUJUDUEKUKABCDETUDUEMQRS $.

  ${
    $d y A $.  $d x y C $.  $d y V $.
    $( Move proper substitution in and out of a membership relation.  Note that
       the scope of ` [. A / x ]. ` is the wff ` B e. C ` , whereas the scope
       of ` [_ A / x ]_ ` is the class ` B ` .  (Contributed by NM,
       10-Nov-2005.) $)
    sbcel1g $p |- ( A e. V -> ( [. A / x ]. B e. C <->
                    [_ A / x ]_ B e. C ) ) $=
      ( wcel wsbc csb sbcel12 csbconstg eleq2d syl5bb ) CDFABGABCHZABDHZFBEFZMD
      FABCDIONDMABDEJKL $.

    $( Move proper substitution to first argument of an equality.  (Contributed
       by NM, 30-Nov-2005.) $)
    sbceq1g $p |- ( A e. V -> ( [. A / x ]. B = C <->
                    [_ A / x ]_ B = C ) ) $=
      ( wcel wceq wsbc csb sbceqg csbconstg eqeq2d bitrd ) BEFZCDGABHABCIZABDIZ
      GODGABCDEJNPDOABDEKLM $.
  $}

  ${
    $d y A $.  $d x y B $.  $d y V $.
    $( Move proper substitution in and out of a membership relation.
       (Contributed by NM, 14-Nov-2005.)  (Revised by NM, 18-Aug-2018.) $)
    sbcel2 $p |- ( [. A / x ]. B e. C <-> B e. [_ A / x ]_ C ) $=
      ( cvv wcel wsbc wb sbcel12 csbconstg eleq1d syl5bb wn sbcex con3i c0 noel
      csb csbprc eleq2d mtbiri 2falsed pm2.61i ) BEFZCDFZABGZCABDRZFZHUFABCRZUG
      FUDUHABCDIUDUICUGABCEJKLUDMZUFUHUFUDUEABNOUJUHCPFCQUJUGPCABDSTUAUBUC $.

    $( Move proper substitution in and out of a membership relation.
       (Contributed by NM, 14-Nov-2005.)  Obsolete as of 18-Aug-2018.  Use
       ~ sbcne12 instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbcel2gOLD $p |- ( A e. V -> ( [. A / x ]. B e. C <->
                    B e. [_ A / x ]_ C ) ) $=
      ( wcel wsbc csb sbcel12gOLD csbconstg eleq1d bitrd ) BEFZCDFABGABCHZABDHZ
      FCOFABCDEIMNCOABCEJKL $.

    $( Move proper substitution to second argument of an equality.
       (Contributed by NM, 30-Nov-2005.) $)
    sbceq2g $p |- ( A e. V -> ( [. A / x ]. B = C <->
                    B = [_ A / x ]_ C ) ) $=
      ( wcel wceq wsbc csb sbceqg csbconstg eqeq1d bitrd ) BEFZCDGABHABCIZABDIZ
      GCPGABCDEJNOCPABCEKLM $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y ph $.
    csbeq2d.1 $e |- F/ x ph $.
    csbeq2d.2 $e |- ( ph -> B = C ) $.
    $( Formula-building deduction rule for class substitution.  (Contributed by
       NM, 22-Nov-2005.)  (Revised by Mario Carneiro, 1-Sep-2015.) $)
    csbeq2d $p |- ( ph -> [_ A / x ]_ B = [_ A / x ]_ C ) $=
      ( vy cv wcel wsbc cab csb eleq2d sbcbid abbidv df-csb 3eqtr4g ) AHIZDJZBC
      KZHLSEJZBCKZHLBCDMBCEMAUAUCHATUBBCFADESGNOPBHCDQBHCEQR $.
  $}

  ${
    $d x ph $.
    csbeq2dv.1 $e |- ( ph -> B = C ) $.
    $( Formula-building deduction rule for class substitution.  (Contributed by
       NM, 10-Nov-2005.)  (Revised by Mario Carneiro, 1-Sep-2015.) $)
    csbeq2dv $p |- ( ph -> [_ A / x ]_ B = [_ A / x ]_ C ) $=
      ( nfv csbeq2d ) ABCDEABGFH $.
  $}

  ${
    csbeq2i.1 $e |- B = C $.
    $( Formula-building inference rule for class substitution.  (Contributed by
       NM, 10-Nov-2005.)  (Revised by Mario Carneiro, 1-Sep-2015.) $)
    csbeq2i $p |- [_ A / x ]_ B = [_ A / x ]_ C $=
      ( csb wceq wtru a1i csbeq2dv trud ) ABCFABDFGHABCDCDGHEIJK $.
  $}

  ${
    $d y z A $.  $d x z B $.  $d z C $.  $d x y $.
    $( Commutative law for double substitution into a class.  (Contributed by
       NM, 14-Nov-2005.)  (Revised by NM, 18-Aug-2018.) $)
    csbcom $p |- [_ A / x ]_ [_ B / y ]_ C = [_ B / y ]_ [_ A / x ]_ C $=
      ( vz csb cv wcel wsbc sbccom sbcel2 sbcbii 3bitr3i eqriv ) FACBDEGZGZBDAC
      EGZGZFHZPIZACJZTRIZBDJZTQITSITEIZBDJZACJUEACJZBDJUBUDUEABCDKUFUAACBDTELMU
      GUCBDACTELMNACTPLBDTRLNO $.

    $( Commutative law for double substitution into a class.  (Contributed by
       NM, 14-Nov-2005.)  Obsolete as of 18-Aug-2018.  Use ~ csbcom instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbcomgOLD $p |- ( ( A e. V /\ B e. W ) ->
                 [_ A / x ]_ [_ B / y ]_ C = [_ B / y ]_ [_ A / x ]_ C ) $=
      ( vz wcel cvv csb wceq elex wsbc sbcel2gOLD sbcbidv adantl adantr 3bitr3d
      wb wa cv sbccom a1i eqrdv syl2an ) CFICJIZDJIZACBDEKZKZBDACEKZKZLDGICFMDG
      MUGUHUAZHUJULUMHUBZUIIZACNZUNUKIZBDNZUNUJIZUNULIZUMUNEIZBDNZACNZVAACNZBDN
      ZUPURVCVETUMVAABCDUCUDUHVCUPTUGUHVBUOACBDUNEJOPQUGVEURTUHUGVDUQBDACUNEJOP
      RSUGUPUSTUHACUNUIJORUHURUTTUGBDUNUKJOQSUEUF $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z B $.  $d z C $.  $d z ph $.
    $( Nest the composition of two substitutions.  (Contributed by Mario
       Carneiro, 11-Nov-2016.) $)
    sbcnestgf $p |- ( ( A e. V /\ A. y F/ x ph ) ->
         ( [. A / x ]. [. B / y ]. ph <-> [. [_ A / x ]_ B / y ]. ph ) ) $=
      ( vz wcel wnf wal wsbc csb wb cv wi wceq dfsbcq syl cvv a1i csbeq1 imbi2d
      bibi12d vex csbeq1a adantl nfnf1 nfal nfa1 wnfc nfcsb1v sp nfsbcd sbciedf
      vtoclg imp ) DFHABIZCJZACEKZBDKZACBDELZKZMZURUSBGNZKZACBVDELZKZMZOURVCOGD
      FVDDPZVHVCURVIVEUTVGVBUSBVDDQVIVFVAPVGVBMBVDDEUAACVFVAQRUCUBURUSVGBVDSVDS
      HURGUDTBNVDPZUSVGMZURVJEVFPVKBVDEUEACEVFQRUFUQBCABUGUHURABCVFUQCUIBVFUJUR
      BVDEUKTUQCULUMUNUOUP $.

    $( Nest the composition of two substitutions.  (Contributed by NM,
       23-Nov-2005.)  (Proof shortened by Mario Carneiro, 10-Nov-2016.) $)
    csbnestgf $p |- ( ( A e. V /\ A. y F/_ x C ) ->
         [_ A / x ]_ [_ B / y ]_ C = [_ [_ A / x ]_ B / y ]_ C ) $=
      ( vz wcel wnfc wal wa cv csb wsbc cab cvv wceq elex df-csb abeq2i wb nfcr
      sbcbii wnf alimi sbcnestgf sylan2 syl5bb abbidv sylan 3eqtr4g ) CFHZAEIZB
      JZKGLZBDEMZHZACNZGOZUOEHZBACDMZNZGOZACUPMBVAEMULCPHZUNUSVCQCFRVDUNKZURVBG
      URUTBDNZACNZVEVBUQVFACVFGUPBGDESTUCUNVDUTAUDZBJVGVBUAUMVHBAGEUBUEUTABCDPU
      FUGUHUIUJAGCUPSBGVAESUK $.

    $d x ph $.
    $( Nest the composition of two substitutions.  (Contributed by NM,
       27-Nov-2005.)  (Proof shortened by Mario Carneiro, 11-Nov-2016.) $)
    sbcnestg $p |- ( A e. V ->
          ( [. A / x ]. [. B / y ]. ph <-> [. [_ A / x ]_ B / y ]. ph ) ) $=
      ( wcel wnf wal wsbc csb wb nfv ax-gen sbcnestgf mpan2 ) DFGABHZCIACEJBDJA
      CBDEKJLQCABMNABCDEFOP $.

    $d x C $.
    $( Nest the composition of two substitutions.  (Contributed by NM,
       23-Nov-2005.)  (Proof shortened by Mario Carneiro, 10-Nov-2016.) $)
    csbnestg $p |- ( A e. V ->
          [_ A / x ]_ [_ B / y ]_ C = [_ [_ A / x ]_ B / y ]_ C ) $=
      ( wcel wnfc wal csb wceq nfcv ax-gen csbnestgf mpan2 ) CFGAEHZBIACBDEJJBA
      CDJEJKPBAELMABCDEFNO $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x C $.  $d x D $.
    sbcco3g.1 $e |- ( x = A -> B = C ) $.
    $( Composition of two substitutions.  (Contributed by NM, 27-Nov-2005.)
       (Revised by Mario Carneiro, 11-Nov-2016.) $)
    sbcco3g $p |- ( A e. V ->
         ( [. A / x ]. [. B / y ]. ph <-> [. C / y ]. ph ) ) $=
      ( wcel wsbc csb sbcnestg cvv wceq wb elex nfcvd csbiegf dfsbcq 3syl bitrd
      ) DGIZACEJBDJACBDEKZJZACFJZABCDEGLUBDMIZUCFNUDUEODGPBDEFMUFBFQHRACUCFSTUA
      $.

    $( Composition of two class substitutions.  (Contributed by NM,
       27-Nov-2005.)  (Revised by Mario Carneiro, 11-Nov-2016.) $)
    csbco3g $p |- ( A e. V ->
                 [_ A / x ]_ [_ B / y ]_ D = [_ C / y ]_ D ) $=
      ( wcel csb csbnestg cvv wceq elex nfcvd csbiegf syl csbeq1d eqtrd ) CGIZA
      CBDFJJBACDJZFJBEFJABCDFGKTBUAEFTCLIZUAEMCGNACDELUBAEOHPQRS $.
  $}

  ${
    $d x y $.  $d y C $.
    $( Nest the composition of two substitutions.  (Contributed by NM,
       23-May-2006.)  (Proof shortened by Mario Carneiro, 11-Nov-2016.) $)
    csbnest1g $p |- ( A e. V ->
         [_ A / x ]_ [_ B / x ]_ C = [_ [_ A / x ]_ B / x ]_ C ) $=
      ( vy wcel cv csb wnfc wceq nfcsb1v ax-gen csbnestgf mpan2 csbeq2i 3eqtr3g
      wal csbco ) BEGZABFCAFHZDIZIZIZFABCIZUBIZABACDIZIAUEDITAUBJZFRUDUFKUHFAUA
      DLMAFBCUBENOABUCUGAFCDSPAFUEDSQ $.
  $}

  ${
    $d x A $.
    $( Idempotent law for class substitutions.  (Contributed by NM,
       1-Mar-2008.)  (Revised by NM, 18-Aug-2018.) $)
    csbidm $p |- [_ A / x ]_ [_ A / x ]_ B = [_ A / x ]_ B $=
      ( cvv wcel csb wceq csbnest1g csbconstg csbeq1d eqtrd wn c0 csbprc eqtr4d
      pm2.61i ) BDEZABABCFZFZRGQSAABBFZCFRABBCDHQATBCABBDIJKQLSMRABRNABCNOP $.

    $( Idempotent law for class substitutions.  (Contributed by NM,
       1-Mar-2008.)  Obsolete as of 18-Aug-2018.  Use ~ csbidm instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbidmgOLD $p |- ( A e. V -> [_ A / x ]_ [_ A / x ]_ B = [_ A / x ]_ B ) $=
      ( wcel cvv csb wceq elex csbnest1g csbconstg csbeq1d eqtrd syl ) BDEBFEZA
      BABCGZGZPHBDIOQAABBGZCGPABBCFJOARBCABBFKLMN $.
  $}

  ${
    $d y z A $.  $d x y z $.
    $( The proper substitution of a class for set variable results in the class
       (if the class exists).  (Contributed by NM, 10-Nov-2005.) $)
    csbvarg $p |- ( A e. V -> [_ A / x ]_ x = A ) $=
      ( vz vy wcel cvv cv csb wceq elex wsbc cab df-csb sbcel2gv abbi1dv syl5eq
      vex ax-mp csbeq2i csbco 3eqtr3i syl ) BCFBGFZABAHZIZBJBCKUDUFDHZEHZFEBLZD
      MZBEBAUHUEIZIEBUHIUFUJEBUKUHUHGFZUKUHJERULUKUGUEFAUHLZDMUHADUHUENULUMDUHA
      UGUHGOPQSTAEBUEUAEDBUHNUBUDUIDBEUGBGOPQUC $.
  $}

  ${
    $d x y $.
    $( Substitution into a wff expressed in terms of substitution into a
       class.  (Contributed by NM, 15-Aug-2007.)  (Revised by NM,
       18-Aug-2018.) $)
    sbccsb $p |- ( [. A / x ]. ph <-> y e. [_ A / x ]_ { y | ph } ) $=
      ( wsbc cv cab wcel csb abid sbcbii sbcel2 bitr3i ) ABDECFZACGZHZBDENBDOIH
      PABDACJKBDNOLM $.

    $( Substitution into a wff expressed in terms of substitution into a
       class.  (Contributed by NM, 15-Aug-2007.)  Obsolete as of 18-Aug-2018.
       Use ~ sbccsb instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbccsbgOLD $p |- ( A e. V ->
                 ( [. A / x ]. ph <-> y e. [_ A / x ]_ { y | ph } ) ) $=
      ( wsbc cv cab wcel csb abid sbcbii sbcel2gOLD syl5bbr ) ABDFCGZACHZIZBDFD
      EIOBDPJIQABDACKLBDOPEMN $.
  $}

  $( Substitution into a wff expressed in using substitution into a class.
     (Contributed by NM, 27-Nov-2005.)  (Revised by NM, 18-Aug-2018.) $)
  sbccsb2 $p |- ( [. A / x ]. ph <-> A e. [_ A / x ]_ { x | ph } ) $=
    ( wsbc cvv wcel cab sbcex elex cv abid sbcbii sbcel12 csbvarg eleq1d syl5bb
    csb syl5bbr pm5.21nii ) ABCDZCEFZCBCABGZQZFZABCHCUCITBJZUBFZBCDZUAUDUFABCAB
    KLUGBCUEQZUCFUAUDBCUEUBMUAUHCUCBCENOPRS $.

  $( Substitution into a wff expressed in using substitution into a class.
     (Contributed by NM, 27-Nov-2005.)  Obsolete as of 18-Aug-2018.  Use
     ~ sbccsb2 instead.  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  sbccsb2gOLD $p |- ( A e. V ->
               ( [. A / x ]. ph <-> A e. [_ A / x ]_ { x | ph } ) ) $=
    ( wsbc cv cab wcel csb abid sbcbii sbcel12gOLD csbvarg eleq1d bitrd syl5bbr
    ) ABCEBFZABGZHZBCEZCDHZCBCRIZHZSABCABJKUATBCQIZUBHUCBCQRDLUAUDCUBBCDMNOP $.

  ${
    $d x B $.  $d x D $.
    $( Special case related to ~ rspsbc .  (Contributed by NM, 10-Dec-2005.)
       (Proof shortened by Eric Schmidt, 17-Jan-2007.) $)
    rspcsbela $p |- ( ( A e. B /\ A. x e. B C e. D ) -> [_ A / x ]_ C e. D ) $=
      ( wcel wral csb wsbc rspsbc sbcel1g sylibd imp ) BCFZDEFZACGZABDHEFZNPOAB
      IQOABCJABDECKLM $.
  $}

  ${
    $d w x y z $.  $d w y z A $.
    $( Two ways of expressing " ` x ` is (effectively) not free in ` A ` ."
       (Contributed by Mario Carneiro, 14-Oct-2016.) $)
    sbnfc2 $p |- ( F/_ x A <-> A. y A. z [_ y / x ]_ A = [_ z / x ]_ A ) $=
      ( vw wnfc cv csb wceq wal cvv wcel vex csbtt mpan wsbc sbsbc sbcel2 bitri
      wsb eqtr4d alrimivv nfv wnf eleq2 3bitr4g 2alimi sbnf2 sylibr nfcd impbii
      wb ) ADFZABGZDHZACGZDHZIZCJBJZUMURBCUMUODUQUNKLUMUODIBMAUNDKNOUPKLUMUQDIC
      MAUPDKNOUAUBUSAEDUSEUCUSEGZDLZABTZVAACTZULZCJBJVAAUDURVDBCURUTUOLZUTUQLZV
      BVCUOUQUTUEVBVAAUNPVEVAABQAUNUTDRSVCVAAUPPVFVAACQAUPUTDRSUFUGVAABCUHUIUJU
      K $.
  $}

  ${
    $d y z A $.  $d z ph $.  $d x y z $.  $d V z $.
    $( Move substitution into a class abstraction.  (Contributed by NM,
       13-Dec-2005.)  (Revised by NM, 19-Aug-2018.) $)
    csbab $p |- [_ A / x ]_ { y | ph } = { y | [. A / x ]. ph } $=
      ( vz cab csb wsbc cv wcel df-clab sbsbc bitri sbccom sbcbii bitr4i sbcel2
      wsb 3bitrri eqriv ) EBDACFZGZABDHZCFZEIZUDJZUCCUEHZUEUAJZBDHZUEUBJUFUCCER
      UGUCECKUCCELMUGACUEHZBDHUIACBUEDNUHUJBDUHACERUJAECKACELMOPBDUEUAQST $.
  $}

  ${
    $d y z A $.  $d z ph $.  $d x y z $.  $d V z $.
    $( Move substitution into a class abstraction.  (Contributed by NM,
       13-Dec-2005.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.)  Obsolete
       as of 19-Aug-2018.  Use ~ csbab instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbabgOLD $p |- ( A e. V ->
                 [_ A / x ]_ { y | ph } = { y | [. A / x ]. ph } ) $=
      ( vz wcel cab csb wsbc sbccom wsb df-clab sbsbc sbcbii 3bitr4i sbcel2gOLD
      cv bitri syl5rbb eqrdv ) DEGZFBDACHZIZABDJZCHZFRZUFGZUGUCGZBDJZUBUGUDGUEC
      UGJZACUGJZBDJUHUJACBUGDKUHUECFLUKUEFCMUECFNSUIULBDUIACFLULAFCMACFNSOPBDUG
      UCEQTUA $.
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d x y $.
    $( Distribution of class substitution over union of two classes, inference
       version.  (Contributed by Drahflow, 23-Sep-2015.)  (Revised by Mario
       Carneiro, 11-Dec-2016.)  (Revised by NM, 13-Sep-2018.) $)
    csbun $p |- [_ A / x ]_ ( B u. C ) = ( [_ A / x ]_ B u. [_ A / x ]_ C ) $=
      ( vy cvv wcel cun csb wceq cv csbeq1 uneq12d eqeq12d nfcsb1v nfun csbeq1a
      vex c0 csbprc weq csbief vtoclg wn un0 a1i 3eqtr4rd pm2.61i ) BFGZABCDHZI
      ZABCIZABDIZHZJZAEKZUJIZAUPCIZAUPDIZHZJUOEBFUPBJZUQUKUTUNAUPBUJLVAURULUSUM
      AUPBCLAUPBDLMNAUPUJUTERAURUSAUPCOAUPDOPAEUACURDUSAUPCQAUPDQMUBUCUIUDZSSHZ
      SUNUKVCSJVBSUEUFVBULSUMSABCTABDTMABUJTUGUH $.
  $}

  ${
    $d x y z A $.  $d y z C $.  $d y z D $.
    $( Distribution of class substitution over union of two classes.
       (Contributed by Drahflow, 23-Sep-2015.)  (Revised by Mario Carneiro,
       11-Dec-2016.)  Obsolete as of 13-Sep-2018.  Use ~ csbun instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbungOLD $p |- ( A e. _V -> [_ A / x ]_ ( C u. D ) =
              ( [_ A / x ]_ C u. [_ A / x ]_ D ) ) $=
      ( cun csb cvv wnfc wcel nfcsb1v nfun a1i cv wceq csbeq1a uneq12d csbiegf
      ) ABCDEABCFZABDFZEZGATHBGIARSABCJABDJKLAMBNCRDSABCOABDOPQ $.

    ${
      csbun.1 $e |- A e. _V $.
      $( Distribution of class substitution over union of two classes,
         inference version.  (Contributed by Drahflow, 23-Sep-2015.)  Obsolete
         as of 13-Sep-2018.  Use ~ csbun instead.  (New usage is discouraged.)
         (Proof modification is discouraged.) $)
      csbuni2OLD $p |- [_ A / x ]_ ( C u. D ) =
                 ( [_ A / x ]_ C u. [_ A / x ]_ D ) $=
        ( cvv wcel cun csb wceq csbungOLD ax-mp ) BFGABCDHIABCIABDIHJEABCDKL $.
    $}
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d x y $.
    $( Distribute proper substitution into a class through an intersection
       relation.  (Contributed by Alan Sare, 22-Jul-2012.)  (Revised by NM,
       18-Aug-2018.) $)
    csbin $p |- [_ A / x ]_ ( B i^i C )
                 = ( [_ A / x ]_ B i^i [_ A / x ]_ C ) $=
      ( vy cvv wcel cin csb wceq cv csbeq1 ineq12d eqeq12d nfcsb1v nfin csbeq1a
      vex c0 csbprc weq csbief vtoclg wn in0 syl6req eqtrd pm2.61i ) BFGZABCDHZ
      IZABCIZABDIZHZJZAEKZUJIZAUPCIZAUPDIZHZJUOEBFUPBJZUQUKUTUNAUPBUJLVAURULUSU
      MAUPBCLAUPBDLMNAUPUJUTERAURUSAUPCOAUPDOPAEUACURDUSAUPCQAUPDQMUBUCUIUDZUKS
      UNABUJTVBUNSSHSVBULSUMSABCTABDTMSUEUFUGUH $.
  $}

  ${
    $d A y $.  $d C y $.  $d D y $.  $d x y $.
    $( Distribute proper substitution through an intersection relation.
       (Contributed by Alan Sare, 22-Jul-2012.)  Obsolete as of 18-Aug-2018.
       Use ~ csbin instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbingOLD $p |- ( A e. B -> [_ A / x ]_ ( C i^i D ) =
                  ( [_ A / x ]_ C i^i [_ A / x ]_ D ) ) $=
      ( vy cv cin csb wceq csbeq1 ineq12d eqeq12d nfcsb1v csbeq1a csbief vtoclg
      vex nfin ) AFGZDEHZIZATDIZATEIZHZJABUAIZABDIZABEIZHZJFBCTBJZUBUFUEUIATBUA
      KUJUCUGUDUHATBDKATBEKLMATUAUEFRAUCUDATDNATENSAGTJDUCEUDATDOATEOLPQ $.
  $}

  $( Two classes are empty iff their union is empty.  (Contributed by NM,
     11-Aug-2004.) $)
  un00 $p |- ( ( A = (/) /\ B = (/) ) <-> ( A u. B ) = (/) ) $=
    ( c0 wceq wa cun uneq12 un0 syl6eq wss ssun1 sseq2 mpbii sylib ssun2 impbii
    ss0b jca ) ACDZBCDZEZABFZCDZUAUBCCFCACBCGCHIUCSTUCACJZSUCAUBJUDABKUBCALMAQN
    UCBCJZTUCBUBJUEBAOUBCBLMBQNRP $.

  $( Only the universal class has the universal class as a subclass.
     (Contributed by NM, 17-Sep-2003.)  (Proof shortened by Andrew Salmon,
     26-Jun-2011.) $)
  vss $p |- ( _V C_ A <-> A = _V ) $=
    ( cvv wss wa wceq ssv biantrur eqss bitr4i ) BACZABCZJDABEKJAFGABHI $.

  $( The null set is a proper subset of any non-empty set.  (Contributed by NM,
     27-Feb-1996.) $)
  0pss $p |- ( (/) C. A <-> A =/= (/) ) $=
    ( c0 wpss wne wss 0ss df-pss mpbiran necom bitri ) BACZBADZABDKBAELAFBAGHBA
    IJ $.

  $( No set is a proper subset of the empty set.  (Contributed by NM,
     17-Jun-1998.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  npss0 $p |- -. A C. (/) $=
    ( c0 wpss wss wn wa wi 0ss a1i iman mpbi dfpss3 mtbir ) ABCABDZBADZEFZNOGPE
    ONAHINOJKABLM $.

  $( Any non-universal class is a proper subclass of the universal class.
     (Contributed by NM, 17-May-1998.) $)
  pssv $p |- ( A C. _V <-> -. A = _V ) $=
    ( cvv wpss wss wceq wn ssv dfpss2 mpbiran ) ABCABDABEFAGABHI $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Two ways of saying that two classes are disjoint (have no members in
       common).  (Contributed by NM, 17-Feb-2004.) $)
    disj $p |- ( ( A i^i B ) = (/) <-> A. x e. A -. x e. B ) $=
      ( cin c0 wceq cv wcel wn wi wal wral wa cab df-in eqeq1i abeq1 imnan noel
      wb nbn bitr2i albii 3bitri df-ral bitr4i ) BCDZEFZAGZBHZUICHZIZJZAKZULABL
      UHUJUKMZANZEFUOUIEHZTZAKUNUGUPEABCOPUOAEQURUMAUMUOIURUJUKRUQUOUISUAUBUCUD
      ULABUEUF $.

    $( Two ways of saying that two classes are disjoint.  (Contributed by Jeff
       Madsen, 19-Jun-2011.) $)
    disjr $p |- ( ( A i^i B ) = (/) <-> A. x e. B -. x e. A ) $=
      ( cin c0 wceq cv wcel wn wral incom eqeq1i disj bitri ) BCDZEFCBDZEFAGBHI
      ACJOPEBCKLACBMN $.

    $( Two ways of saying that two classes are disjoint (have no members in
       common).  (Contributed by NM, 19-Aug-1993.) $)
    disj1 $p |- ( ( A i^i B ) = (/) <-> A. x ( x e. A -> -. x e. B ) ) $=
      ( cin c0 wceq cv wcel wn wral wi wal disj df-ral bitri ) BCDEFAGZCHIZABJP
      BHQKALABCMQABNO $.

    $( Two ways of saying that two classes are disjoint, using the complement
       of ` B ` relative to a universe ` C ` .  (Contributed by NM,
       15-Feb-2007.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    reldisj $p |- ( A C_ C -> ( ( A i^i B ) = (/) <-> A C_ ( C \ B ) ) ) $=
      ( vx wss cv wcel wn wi wal cdif cin c0 wceq wb dfss2 pm5.44 eldif imbi2i
      wa syl6bbr sps sylbi albidv disj1 3bitr4g ) ACEZDFZAGZUHBGHZIZDJUIUHCBKZG
      ZIZDJABLMNAULEUGUKUNDUGUIUHCGZIZDJUKUNOZDACPUPUQDUPUKUIUOUJTZIUNUIUOUJQUM
      URUIUHCBRSUAUBUCUDDABUEDAULPUF $.

    $( Two ways of saying that two classes are disjoint.  (Contributed by NM,
       19-May-1998.) $)
    disj3 $p |- ( ( A i^i B ) = (/) <-> A = ( A \ B ) ) $=
      ( vx cv wcel wn wi wal cdif wb cin c0 wa pm4.71 eldif bibi2i bitr4i albii
      wceq disj1 dfcleq 3bitr4i ) CDZAEZUCBEFZGZCHUDUCABIZEZJZCHABKLSAUGSUFUICU
      FUDUDUEMZJUIUDUENUHUJUDUCABOPQRCABTCAUGUAUB $.

    $( Members of disjoint sets are not equal.  (Contributed by NM,
       28-Mar-2007.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    disjne $p |- ( ( ( A i^i B ) = (/) /\ C e. A /\ D e. B ) -> C =/= D ) $=
      ( vx cin c0 wceq wcel wne cv wn wral wi disj eleq1 notbid rspccva eleq1a
      wa necon3bd syl5com sylanb 3impia ) ABFGHZCAIZDBIZCDJZUEEKZBIZLZEAMZUFUGU
      HNEABOULUFTCBIZLZUGUHUKUNECAUICHUJUMUICBPQRUGUMCDDBCSUAUBUCUD $.
  $}

  $( A set can't belong to both members of disjoint classes.  (Contributed by
     NM, 28-Feb-2015.) $)
  disjel $p |- ( ( ( A i^i B ) = (/) /\ C e. A ) -> -. C e. B ) $=
    ( cin c0 wceq wcel wn cdif wi disj3 eleq2 eldifn syl6bi sylbi imp ) ABDEFZC
    AGZCBGHZQAABIZFZRSJABKUARCTGSATCLCABMNOP $.

  $( Two ways of saying that two classes are disjoint.  (Contributed by NM,
     17-May-1998.) $)
  disj2 $p |- ( ( A i^i B ) = (/) <-> A C_ ( _V \ B ) ) $=
    ( cvv wss cin c0 wceq cdif wb ssv reldisj ax-mp ) ACDABEFGACBHDIAJABCKL $.

  $( Two ways of saying that two classes are disjoint.  (Contributed by NM,
     21-Mar-2004.) $)
  disj4 $p |- ( ( A i^i B ) = (/) <-> -. ( A \ B ) C. A ) $=
    ( cin c0 wceq cdif wpss disj3 eqcom wss difss dfpss2 mpbiran con2bii 3bitri
    wn ) ABCDEAABFZEQAEZQAGZPABHAQISRSQAJRPABKQALMNO $.

  $( Intersection with a subclass of a disjoint class.  (Contributed by FL,
     24-Jan-2007.) $)
  ssdisj $p |- ( ( A C_ B /\ ( B i^i C ) = (/) ) -> ( A i^i C ) = (/) ) $=
    ( wss cin c0 wceq wa ss0b wi ssrin sstr2 syl syl5bir imp ss0 ) ABDZBCEZFGZH
    ACEZFDZTFGQSUASRFDZQUARIQTRDUBUAJABCKTRFLMNOTPM $.

  $( A class is a proper subset of its union with a disjoint nonempty class.
     (Contributed by NM, 15-Sep-2004.) $)
  disjpss $p |- ( ( ( A i^i B ) = (/) /\ B =/= (/) ) -> A C. ( A u. B ) ) $=
    ( cin c0 wceq wne wa wss wn cun wpss ssid biantru bitri sseq2 syl5bb syl6bi
    ssin ss0 necon3ad imp nsspssun uncom psseq2i sylib ) ABCZDEZBDFZGBAHZIZAABJ
    ZKZUGUHUJUGUIBDUGUIBDHZBDEUIBUFHZUGUMUIUIBBHZGUNUOUIBLMBABRNUFDBOPBSQTUAUJA
    BAJZKULBAUBUPUKABAUCUDNUE $.

  $( The union of disjoint classes is disjoint.  (Contributed by NM,
     26-Sep-2004.) $)
  undisj1 $p |- ( ( ( A i^i C ) = (/) /\ ( B i^i C ) = (/) ) <->
               ( ( A u. B ) i^i C ) = (/) ) $=
    ( cin c0 wceq wa cun un00 indir eqeq1i bitr4i ) ACDZEFBCDZEFGMNHZEFABHCDZEF
    MNIPOEABCJKL $.

  $( The union of disjoint classes is disjoint.  (Contributed by NM,
     13-Sep-2004.) $)
  undisj2 $p |- ( ( ( A i^i B ) = (/) /\ ( A i^i C ) = (/) ) <->
               ( A i^i ( B u. C ) ) = (/) ) $=
    ( cin c0 wceq wa cun un00 indi eqeq1i bitr4i ) ABDZEFACDZEFGMNHZEFABCHDZEFM
    NIPOEABCJKL $.

  $( Subclass expressed in terms of intersection with difference from the
     universal class.  (Contributed by NM, 17-Sep-2003.) $)
  ssindif0 $p |- ( A C_ B <-> ( A i^i ( _V \ B ) ) = (/) ) $=
    ( cvv cdif cin c0 wceq wss disj2 ddif sseq2i bitr2i ) ACBDZEFGACMDZHABHAMIN
    BABJKL $.

  $( The intersection of classes with a common member is nonempty.
     (Contributed by NM, 7-Apr-1994.) $)
  inelcm $p |- ( ( A e. B /\ A e. C ) -> ( B i^i C ) =/= (/) ) $=
    ( wcel wa cin c0 wne elin ne0i sylbir ) ABDACDEABCFZDLGHABCILAJK $.

  $( A minimum element of a class has no elements in common with the class.
     (Contributed by NM, 22-Jun-1994.) $)
  minel $p |- ( ( A e. B /\ ( C i^i B ) = (/) ) -> -. A e. C ) $=
    ( cin c0 wceq wcel wn wa wi inelcm necon2bi imnan sylibr con2d impcom ) CBD
    ZEFZABGZACGZHRTSRTSIZHTSHJUAQEACBKLTSMNOP $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Distribute union over difference.  (Contributed by NM, 17-May-1998.)
       (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    undif4 $p |- ( ( A i^i C ) = (/) ->
                 ( A u. ( B \ C ) ) = ( ( A u. B ) \ C ) ) $=
      ( vx cv wcel wn wi wal cdif cun wb cin c0 wceq wo wa eldif elun 3bitr4g
      pm2.621 olc impbid1 anbi2d orbi2i bitri anbi1i alimi disj1 dfcleq 3imtr4i
      ordi ) DEZAFZUMCFGZHZDIUMABCJZKZFZUMABKZCJZFZLZDIACMNOURVAOUPVCDUPUNUMUQF
      ZPZUMUTFZUOQZUSVBUPUNUMBFZPZUNUOPZQZVIUOQVEVGUPVJUOVIUPVJUOUNUOUAUOUNUBUC
      UDVEUNVHUOQZPVKVDVLUNUMBCRUEUNVHUOULUFVFVIUOUMABSUGTUMAUQSUMUTCRTUHDACUID
      URVAUJUK $.

    $( Subset relation for disjoint classes.  (Contributed by NM,
       25-Oct-2005.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    disjssun $p |- ( ( A i^i B ) = (/) -> ( A C_ ( B u. C ) <-> A C_ C ) ) $=
      ( cin c0 wceq cun wss indi equncomi uneq2 un0 syl6eq syl5eq df-ss 3bitr4g
      eqeq1d ) ABDZEFZABCGZDZAFACDZAFATHACHSUAUBASUAUBRGZUBUARUBABCIJSUCUBEGUBR
      EUBKUBLMNQATOACOP $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass expressed in terms of difference.  Exercise 7 of
       [TakeutiZaring] p. 22.  (Contributed by NM, 29-Apr-1994.) $)
    ssdif0 $p |- ( A C_ B <-> ( A \ B ) = (/) ) $=
      ( vx cv wcel wi wal cdif wn wss c0 wceq wa eldif xchbinxr albii dfss2 eq0
      iman 3bitr4i ) CDZAEZUABEZFZCGUAABHZEZIZCGABJUEKLUDUGCUDUBUCIMUFUBUCSUAAB
      NOPCABQCUERT $.
  $}

  $( Universal class equality in terms of empty difference.  (Contributed by
     NM, 17-Sep-2003.) $)
  vdif0 $p |- ( A = _V <-> ( _V \ A ) = (/) ) $=
    ( cvv wceq wss cdif c0 vss ssdif0 bitr3i ) ABCBADBAEFCAGBAHI $.

  ${
    $d V x $.
    $( If the difference between the restricting class of a restricted class
       abstraction and the restricted class abstraction is empty, the
       restricting class is equal to this restricted class abstraction.
       (Contributed by Alexander van der Vekens, 31-Dec-2017.) $)
    difrab0eq $p |- ( ( V \ { x e. V | ph } ) = (/)
                      <-> V = { x e. V | ph } ) $=
      ( crab cdif c0 wceq wss ssdif0 ssrabeq bitr3i ) CABCDZEFGCLHCLGCLIABCJK
      $.
  $}

  $( A proper subclass has a nonempty difference.  (Contributed by NM,
     3-May-1994.) $)
  pssdifn0 $p |- ( ( A C_ B /\ A =/= B ) -> ( B \ A ) =/= (/) ) $=
    ( wss wne cdif c0 wceq ssdif0 eqss simplbi2 syl5bir necon3d imp ) ABCZABDBA
    EZFDNOFABOFGBACZNABGZBAHQNPABIJKLM $.

  $( A proper subclass has a nonempty difference.  (Contributed by Mario
     Carneiro, 27-Apr-2016.) $)
  pssdif $p |- ( A C. B -> ( B \ A ) =/= (/) ) $=
    ( wpss wss wne wa cdif c0 df-pss pssdifn0 sylbi ) ABCABDABEFBAGHEABIABJK $.

  $( A subclass missing a member is a proper subclass.  (Contributed by NM,
     12-Jan-2002.) $)
  ssnelpss $p |- ( A C_ B -> ( ( C e. B /\ -. C e. A ) -> A C. B ) ) $=
    ( wcel wn wa wceq wss wpss nelneq2 eqcom sylnib dfpss2 baibr syl5ib ) CBDCA
    DEFZABGZEZABHZABIZPBAGQCBAJBAKLTSRABMNO $.

  ${
    ssnelpssd.1 $e |- ( ph -> A C_ B ) $.
    ssnelpssd.2 $e |- ( ph -> C e. B ) $.
    ssnelpssd.3 $e |- ( ph -> -. C e. A ) $.
    $( Subclass inclusion with one element of the superclass missing is proper
       subclass inclusion.  Deduction form of ~ ssnelpss .  (Contributed by
       David Moews, 1-May-2017.) $)
    ssnelpssd $p |- ( ph -> A C. B ) $=
      ( wcel wn wpss wss wa wi ssnelpss syl mp2and ) ADCHZDBHIZBCJZFGABCKQRLSME
      BCDNOP $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A proper subclass has a member in one argument that's not in both.
       (Contributed by NM, 29-Feb-1996.) $)
    pssnel $p |- ( A C. B -> E. x ( x e. B /\ -. x e. A ) ) $=
      ( wpss cv cdif wcel wex wn wa c0 wne pssdif n0 sylib eldif exbii ) BCDZAE
      ZCBFZGZAHZSCGSBGIJZAHRTKLUBBCMATNOUAUCASCBPQO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Difference, intersection, and subclass relationship.  (Contributed by
       NM, 30-Apr-1994.)  (Proof shortened by Wolf Lammen, 30-Sep-2014.) $)
    difin0ss $p |- ( ( ( A \ B ) i^i C ) = (/) -> ( C C_ A -> C C_ B ) ) $=
      ( vx cdif cin c0 wceq cv wcel wn wal wss wi eq0 wa iman elin eldif dfss2
      anbi1i bitri ancom annim anbi2i 3bitr2i xchbinxr ax-2 sylbir al2imi sylbi
      3imtr4g ) ABEZCFZGHDIZUNJZKZDLZCAMZCBMZNDUNOURUOCJZUOAJZNZDLVAUOBJZNZDLUS
      UTUQVCVEDUQVAVBVDNZNZVCVENVGVAVFKZPZUPVAVFQUPVBVDKPZVAPZVAVJPVIUPUOUMJZVA
      PVKUOUMCRVLVJVAUOABSUAUBVAVJUCVJVHVAVBVDUDUEUFUGVAVBVDUHUIUJDCATDCBTULUK
      $.

    $( Intersection, subclass, and difference relationship.  (Contributed by
       NM, 27-Oct-1996.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.)
       (Proof shortened by Wolf Lammen, 30-Sep-2014.) $)
    inssdif0 $p |- ( ( A i^i B ) C_ C <-> ( A i^i ( B \ C ) ) = (/) ) $=
      ( vx cv cin wcel wi wal cdif wn wss c0 wceq elin imbi1i iman bitri eldif
      wa anbi2i anass 3bitr4ri xchbinx albii dfss2 eq0 3bitr4i ) DEZABFZGZUICGZ
      HZDIUIABCJZFZGZKZDIUJCLUOMNUMUQDUMUIAGZUIBGZTZULKZTZUPUMUTULHVBKUKUTULUIA
      BOPUTULQRURUIUNGZTURUSVATZTUPVBVCVDURUIBCSUAUIAUNOURUSVAUBUCUDUEDUJCUFDUO
      UGUH $.
  $}

  $( The difference between a class and itself is the empty set.  Proposition
     5.15 of [TakeutiZaring] p. 20.  Also Theorem 32 of [Suppes] p. 28.
     (Contributed by NM, 22-Apr-2004.) $)
  difid $p |- ( A \ A ) = (/) $=
    ( wss cdif c0 wceq ssid ssdif0 mpbi ) AABAACDEAFAAGH $.

  ${
    $d x A $.
    $( The difference between a class and itself is the empty set.  Proposition
       5.15 of [TakeutiZaring] p. 20.  Also Theorem 32 of [Suppes] p. 28.
       Alternate proof of ~ difid .  (Contributed by David Abernethy,
       17-Jun-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    difidALT $p |- ( A \ A ) = (/) $=
      ( vx cdif cv wcel wn crab c0 dfdif2 dfnul3 eqtr4i ) AACBDAEFBAGHBAAIBAJK
      $.
  $}

  $( The difference between a class and the empty set.  Part of Exercise 4.4 of
     [Stoll] p. 16.  (Contributed by NM, 17-Aug-2004.) $)
  dif0 $p |- ( A \ (/) ) = A $=
    ( cdif c0 difid difeq2i difdif eqtr3i ) AAABZBACBAHCAADEAAFG $.

  $( The difference between the empty set and a class.  Part of Exercise 4.4 of
     [Stoll] p. 16.  (Contributed by NM, 17-Aug-2004.) $)
  0dif $p |- ( (/) \ A ) = (/) $=
    ( c0 cdif wss wceq difss ss0 ax-mp ) BACZBDIBEBAFIGH $.

  $( A class and its relative complement are disjoint.  Theorem 38 of [Suppes]
     p. 29.  (Contributed by NM, 24-Mar-1998.) $)
  disjdif $p |- ( A i^i ( B \ A ) ) = (/) $=
    ( cin wss cdif c0 wceq inss1 inssdif0 mpbi ) ABCADABAECFGABHABAIJ $.

  $( The difference of a class from its intersection is empty.  Theorem 37 of
     [Suppes] p. 29.  (Contributed by NM, 17-Aug-2004.)  (Proof shortened by
     Andrew Salmon, 26-Jun-2011.) $)
  difin0 $p |- ( ( A i^i B ) \ B ) = (/) $=
    ( cin wss cdif c0 wceq inss2 ssdif0 mpbi ) ABCZBDKBEFGABHKBIJ $.

  $( The union of a class and its complement is the universe.  Theorem 5.1(5)
     of [Stoll] p. 17.  (Contributed by NM, 17-Aug-2004.) $)
  unvdif $p |- ( A u. ( _V \ A ) ) = _V $=
    ( cvv cdif cun cin c0 dfun3 disjdif difeq2i dif0 3eqtri ) ABACZDBLBLCEZCBFC
    BALGMFBLBHIBJK $.

  $( Absorption of difference by union.  This decomposes a union into two
     disjoint classes (see ~ disjdif ).  Theorem 35 of [Suppes] p. 29.
     (Contributed by NM, 19-May-1998.) $)
  undif1 $p |- ( ( A \ B ) u. B ) = ( A u. B ) $=
    ( cvv cdif cin undir invdif uneq1i uncom unvdif eqtri ineq2i inv1 3eqtr3i
    cun ) ACBDZEZBOABOZPBOZEZABDZBORAPBFQUABABGHTRCERSCRSBPOCPBIBJKLRMKN $.

  $( Absorption of difference by union.  This decomposes a union into two
     disjoint classes (see ~ disjdif ).  Part of proof of Corollary 6K of
     [Enderton] p. 144.  (Contributed by NM, 19-May-1998.) $)
  undif2 $p |- ( A u. ( B \ A ) ) = ( A u. B ) $=
    ( cdif cun uncom undif1 3eqtri ) ABACZDHADBADABDAHEBAFBAEG $.

  $( Absorption of difference by union.  (Contributed by NM, 18-Aug-2013.) $)
  undifabs $p |- ( A u. ( A \ B ) ) = A $=
    ( cdif cun undif3 unidm difeq1i difdif 3eqtri ) AABCDAADZBACZCAKCAAABEJAKAF
    GABHI $.

  ${
    $d x A $.  $d x B $.
    $( The intersection and class difference of a class with another class
       unite to give the original class.  (Contributed by Paul Chapman,
       5-Jun-2009.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    inundif $p |- ( ( A i^i B ) u. ( A \ B ) ) = A $=
      ( vx cin cdif cv wcel wo wa wn elin eldif orbi12i pm4.42 bitr4i uneqri )
      CABDZABEZACFZQGZSRGZHSAGZSBGZIZUBUCJIZHUBTUDUAUESABKSABLMUBUCNOP $.
  $}

  $( Absorption of union by difference.  Theorem 36 of [Suppes] p. 29.
     (Contributed by NM, 19-May-1998.) $)
  difun2 $p |- ( ( A u. B ) \ B ) = ( A \ B ) $=
    ( cun cdif c0 difundir difid uneq2i un0 3eqtri ) ABCBDABDZBBDZCKECKABBFLEKB
    GHKIJ $.

  $( Union of complementary parts into whole.  (Contributed by NM,
     22-Mar-1998.) $)
  undif $p |- ( A C_ B <-> ( A u. ( B \ A ) ) = B ) $=
    ( wss cun wceq cdif ssequn1 undif2 eqeq1i bitr4i ) ABCABDZBEABAFDZBEABGLKBA
    BHIJ $.

  $( A subset of a difference does not intersect the subtrahend.  (Contributed
     by Jeff Hankins, 1-Sep-2013.)  (Proof shortened by Mario Carneiro,
     24-Aug-2015.) $)
  ssdifin0 $p |- ( A C_ ( B \ C ) -> ( A i^i C ) = (/) ) $=
    ( cdif wss cin c0 wceq ssrin incom disjdif eqtri sseq0 sylancl ) ABCDZEACFZ
    OCFZEQGHPGHAOCIQCOFGOCJCBKLPQMN $.

  $( A class is a subclass of itself subtracted from another iff it is the
     empty set.  (Contributed by Steve Rodriguez, 20-Nov-2015.) $)
  ssdifeq0 $p |- ( A C_ ( B \ A ) <-> A = (/) ) $=
    ( cdif wss wceq cin inidm ssdifin0 syl5eqr 0ss difeq2 sseq12d mpbiri impbii
    c0 id ) ABACZDZAOEZRAAAFOAGABAHISROBOCZDTJSAOQTSPAOBKLMN $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( A condition equivalent to inclusion in the union of two classes.
       (Contributed by NM, 26-Mar-2007.) $)
    ssundif $p |- ( A C_ ( B u. C ) <-> ( A \ B ) C_ C ) $=
      ( vx cv wcel cun wi wal cdif wss wn wa wo pm5.6 eldif imbi1i imbi2i dfss2
      elun 3bitr4ri albii 3bitr4i ) DEZAFZUDBCGZFZHZDIUDABJZFZUDCFZHZDIAUFKUICK
      UHULDUEUDBFZLMZUKHUEUMUKNZHULUHUEUMUKOUJUNUKUDABPQUGUOUEUDBCTRUAUBDAUFSDU
      ICSUC $.
  $}

  $( Swap the arguments of a class difference.  (Contributed by NM,
     29-Mar-2007.) $)
  difcom $p |- ( ( A \ B ) C_ C <-> ( A \ C ) C_ B ) $=
    ( cun wss cdif uncom sseq2i ssundif 3bitr3i ) ABCDZEACBDZEABFCEACFBEKLABCGH
    ABCIACBIJ $.

  $( Two ways to express overlapping subsets.  (Contributed by Stefan O'Rear,
     31-Oct-2014.) $)
  pssdifcom1 $p |- ( ( A C_ C /\ B C_ C ) ->
    ( ( C \ A ) C. B <-> ( C \ B ) C. A ) ) $=
    ( wss wa cdif wn wpss wb difcom ssconb ancoms notbid anbi12d dfpss3 3bitr4g
    a1i ) ACDZBCDZEZCAFZBDZBUADZGZECBFZADZAUEDZGZEUABHUEAHTUBUFUDUHUBUFITCABJQT
    UCUGSRUCUGIBACKLMNUABOUEAOP $.

  $( Two ways to express non-covering pairs of subsets.  (Contributed by Stefan
     O'Rear, 31-Oct-2014.) $)
  pssdifcom2 $p |- ( ( A C_ C /\ B C_ C ) ->
    ( B C. ( C \ A ) <-> A C. ( C \ B ) ) ) $=
    ( wss wa cdif wn wpss wb ssconb ancoms difcom notbid anbi12d dfpss3 3bitr4g
    a1i ) ACDZBCDZEZBCAFZDZUABDZGZEACBFZDZUEADZGZEBUAHAUEHTUBUFUDUHSRUBUFIBACJK
    TUCUGUCUGITCABLQMNBUAOAUEOP $.

  $( Distributive law for class difference.  Exercise 4.8 of [Stoll] p. 16.
     (Contributed by NM, 18-Aug-2004.) $)
  difdifdir $p |- ( ( A \ B ) \ C ) = ( ( A \ C ) \ ( B \ C ) ) $=
    ( cdif cvv cun cin dif32 invdif eqtr4i un0 indi disjdif incom eqtr3i uneq2i
    c0 ddif indm difeq2i ineq2i 3eqtri ) ABDCDZACDZEBDZCFZGZUDEBCDZDZGUDUHDUCUD
    UEGZQFZUGUCUJUKUCUDBDUJABCHUDBIJUJKJUGUJUDCGZFUKUDUECLQULUJCUDGQULCAMCUDNOP
    JJUFUIUDUEEECDZDZFZUFUIUNCUECRPEBUMGZDUOUIBUMSUPUHEBCITOOUAUDUHIUB $.

  $( Two ways to say that ` A ` and ` B ` partition ` C ` (when ` A ` and ` B `
     don't overlap and ` A ` is a part of ` C ` ).  (Contributed by FL,
     17-Nov-2008.) $)
  uneqdifeq $p |- ( ( A C_ C /\ ( A i^i B ) = (/) )
     -> ( ( A u. B ) = C <-> ( C \ A ) = B ) ) $=
    ( wss cin c0 wceq wa cun cdif uncom eqcomd difeq1 difun2 incom expcom com12
    wi eqtr adantl eqeq1i disj3 bitri eqcoms sylbi syl5com syl mpan difss sseq1
    sylancl biimpi syl6bi mpi adantr imp eqimss ssundif sylibr adantlr eqssd ex
    unss impbid ) ACDZABEZFGZHZABIZCGZCAJZBGZVGVJVLRVEVJVGVLBAIZVIGZVJVGVLRZBAK
    VNVJHZCVMGZVOVPVMCVMVICSLVQVKVMAJZGZVRBAJZGZVOCVMAMBANVSWAHVKVTGZVGVLVKVRVT
    SVGBVTGZWBVLRZVGBAEZFGWCVFWEFABOUABAUBUCWDVTBWBVTBGVLVKVTBSPUDUEUFUKUGUHQTV
    HVLVJVHVLHVICVHVLVICDZVEVLWFRVGVLVEWFVLVKCDZVEWFRZCAUIVLWGBCDZWHVKBCUJVEWIW
    FVEWIHWFABCVCULPUMUNQUOUPVEVLCVIDZVGVEVLHVKBDZWJVLWKVEVKBUQTCABURUSUTVAVBVD
    $.

  ${
    $d x A $.
    $( Theorem 19.2 of [Margaris] p. 89 with restricted quantifiers (compare
       ~ 19.2 ).  The restricted version is valid only when the domain of
       quantification is not empty.  (Contributed by NM, 15-Nov-2003.) $)
    r19.2z $p |- ( ( A =/= (/) /\ A. x e. A ph ) -> E. x e. A ph ) $=
      ( wral c0 wne wrex cv wex wa wi wal df-ral exintr sylbi n0 df-rex 3imtr4g
      wcel impcom ) ABCDZCEFZABCGZUABHCSZBIZUDAJBIZUBUCUAUDAKBLUEUFKABCMUDABNOB
      CPABCQRT $.

    $( A response to the notion that the condition ` A =/= (/) ` can be removed
       in ~ r19.2z .  Interestingly enough, ` ph ` does not figure in the
       left-hand side.  (Contributed by Jeff Hankins, 24-Aug-2009.) $)
    r19.2zb $p |- ( A =/= (/) <-> ( A. x e. A ph -> E. x e. A ph ) ) $=
      ( c0 wral wrex wi r19.2z ex wceq cv wcel noel pm2.21i rgen raleq necon3bi
      wne mpbiri wex wa exsimpl df-rex n0 3imtr4i ja impbii ) CDRZABCEZABCFZGUH
      UIUJABCHIUIUJUHUICDCDJUIABDEABDBKZDLAUKMNOABCDPSQUKCLZAUABTULBTUJUHULABUB
      ABCUCBCUDUEUFUG $.
  $}

  ${
    $d x A $.
    r19.3rz.1 $e |- F/ x ph $.
    $( Restricted quantification of wff not containing quantified variable.
       (Contributed by FL, 3-Jan-2008.) $)
    r19.3rz $p |- ( A =/= (/) -> ( ph <-> A. x e. A ph ) ) $=
      ( c0 wne cv wcel wex wi wral wb n0 biimt sylbi df-ral 19.23 bitri syl6bbr
      wal ) CEFZABGCHZBIZAJZABCKZUAUCAUDLBCMUCANOUEUBAJBTUDABCPUBABDQRS $.

    $( Restricted quantifier version of Theorem 19.28 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by NM, 26-Oct-2010.) $)
    r19.28z $p |- ( A =/= (/) ->
                   ( A. x e. A ( ph /\ ps ) <-> ( ph /\ A. x e. A ps ) ) ) $=
      ( c0 wne wral wa r19.3rz anbi1d r19.26 syl6rbbr ) DFGZABCDHZIACDHZOIABICD
      HNAPOACDEJKABCDLM $.
  $}

  ${
    $d x A $.  $d x ph $.
    $( Restricted quantification of wff not containing quantified variable.
       (Contributed by NM, 10-Mar-1997.) $)
    r19.3rzv $p |- ( A =/= (/) -> ( ph <-> A. x e. A ph ) ) $=
      ( c0 wne cv wcel wex wi wb n0 biimt sylbi wal df-ral 19.23v bitri syl6bbr
      wral ) CDEZABFCGZBHZAIZABCSZTUBAUCJBCKUBALMUDUAAIBNUCABCOUAABPQR $.

    $( Restricted quantification of wff not containing quantified variable.
       (Contributed by NM, 27-May-1998.) $)
    r19.9rzv $p |- ( A =/= (/) -> ( ph <-> E. x e. A ph ) ) $=
      ( c0 wne wn wral wrex r19.3rzv bicomd con2bid dfrex2 syl6bbr ) CDEZAAFZBC
      GZFABCHNPANOPOBCIJKABCLM $.

    $( Restricted quantifier version of Theorem 19.28 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by NM, 19-Aug-2004.) $)
    r19.28zv $p |- ( A =/= (/) ->
                   ( A. x e. A ( ph /\ ps ) <-> ( ph /\ A. x e. A ps ) ) ) $=
      ( c0 wne wral wa r19.3rzv anbi1d r19.26 syl6rbbr ) DEFZABCDGZHACDGZNHABHC
      DGMAONACDIJABCDKL $.

    $( Restricted quantifier version of Theorem 19.37 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by Paul Chapman, 8-Oct-2007.) $)
    r19.37zv $p |- ( A =/= (/) ->
                   ( E. x e. A ( ph -> ps ) <-> ( ph -> E. x e. A ps ) ) ) $=
      ( c0 wne wrex wi wral r19.3rzv imbi1d r19.35 syl6rbbr ) DEFZABCDGZHACDIZO
      HABHCDGNAPOACDJKABCDLM $.

    $( Restricted version of Theorem 19.45 of [Margaris] p. 90.  (Contributed
       by NM, 27-May-1998.) $)
    r19.45zv $p |- ( A =/= (/) ->
                   ( E. x e. A ( ph \/ ps ) <-> ( ph \/ E. x e. A ps ) ) ) $=
      ( c0 wne wrex wo r19.9rzv orbi1d r19.43 syl6rbbr ) DEFZABCDGZHACDGZNHABHC
      DGMAONACDIJABCDKL $.
  $}

  ${
    $d x A $.
    r19.27z.1 $e |- F/ x ps $.
    $( Restricted quantifier version of Theorem 19.27 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by NM, 26-Oct-2010.) $)
    r19.27z $p |- ( A =/= (/) ->
                   ( A. x e. A ( ph /\ ps ) <-> ( A. x e. A ph /\ ps ) ) ) $=
      ( c0 wne wral wa r19.3rz anbi2d r19.26 syl6rbbr ) DFGZACDHZBIOBCDHZIABICD
      HNBPOBCDEJKABCDLM $.
  $}

  ${
    $d x A $.  $d x ps $.
    $( Restricted quantifier version of Theorem 19.27 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by NM, 19-Aug-2004.) $)
    r19.27zv $p |- ( A =/= (/) ->
                   ( A. x e. A ( ph /\ ps ) <-> ( A. x e. A ph /\ ps ) ) ) $=
      ( c0 wne wral wa r19.3rzv anbi2d r19.26 syl6rbbr ) DEFZACDGZBHNBCDGZHABHC
      DGMBONBCDIJABCDKL $.

    $( Restricted quantifier version of Theorem 19.36 of [Margaris] p. 90.  It
       is valid only when the domain of quantification is not empty.
       (Contributed by NM, 20-Sep-2003.) $)
    r19.36zv $p |- ( A =/= (/) ->
                   ( E. x e. A ( ph -> ps ) <-> ( A. x e. A ph -> ps ) ) ) $=
      ( c0 wne wral wi wrex r19.9rzv imbi2d r19.35 syl6rbbr ) DEFZACDGZBHOBCDIZ
      HABHCDINBPOBCDJKABCDLM $.
  $}

  ${
    $d x A $.
    $( Vacuous quantification is always true.  (Contributed by NM,
       11-Mar-1997.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
    rzal $p |- ( A = (/) -> A. x e. A ph ) $=
      ( c0 wceq cv wcel ne0i necon2bi pm2.21d ralrimiv ) CDEZABCLBFZCGZANCDCMHI
      JK $.

    $( Restricted existential quantification implies its restriction is
       nonempty.  (Contributed by Szymon Jaroszewicz, 3-Apr-2007.) $)
    rexn0 $p |- ( E. x e. A ph -> A =/= (/) ) $=
      ( c0 wne cv wcel ne0i a1d rexlimiv ) ACDEZBCBFZCGKACLHIJ $.

    $( Idempotent law for restricted quantifier.  (Contributed by NM,
       28-Mar-1997.) $)
    ralidm $p |- ( A. x e. A A. x e. A ph <-> A. x e. A ph ) $=
      ( c0 wceq wral wb rzal 2thd wn cv wcel wex neq0 wi biimt wal df-ral nfra1
      19.23 bitri syl6rbbr sylbi pm2.61i ) CDEZABCFZBCFZUFGZUEUGUFUFBCHABCHIUEJ
      BKCLZBMZUHBCNUJUFUJUFOZUGUJUFPUGUIUFOBQUKUFBCRUIUFBABCSTUAUBUCUD $.
  $}

  $( Vacuous universal quantification is always true.  (Contributed by NM,
     20-Oct-2005.) $)
  ral0 $p |- A. x e. (/) ph $=
    ( c0 cv wcel noel pm2.21i rgen ) ABCBDZCEAIFGH $.

  ${
    $d x A $.
    rgenz.1 $e |- ( ( A =/= (/) /\ x e. A ) -> ph ) $.
    $( Generalization rule that eliminates a non-zero class requirement.
       (Contributed by NM, 8-Dec-2012.) $)
    rgenz $p |- A. x e. A ph $=
      ( wral c0 rzal wne ralrimiva pm2.61ine ) ABCECFABCGCFHABCDIJ $.
  $}

  ${
    $d x A $.
    ralf0.1 $e |- -. ph $.
    $( The quantification of a falsehood is vacuous when true.  (Contributed by
       NM, 26-Nov-2005.) $)
    ralf0 $p |- ( A. x e. A ph <-> A = (/) ) $=
      ( wral c0 wceq cv wcel wi wal wn con3 mpi alimi df-ral eq0 3imtr4i impbii
      rzal ) ABCEZCFGZBHCIZAJZBKUCLZBKUAUBUDUEBUDALUEDUCAMNOABCPBCQRABCTS $.
  $}

  $( TODO - shorten r19.3zv, r19.27zv, r19.28zv, raaanv w/ non-v $)
  ${
    $d x y A $.
    raaan.1 $e |- F/ y ph $.
    raaan.2 $e |- F/ x ps $.
    $( Rearrange restricted quantifiers.  (Contributed by NM, 26-Oct-2010.) $)
    raaan $p |- ( A. x e. A A. y e. A ( ph /\ ps ) <->
                  ( A. x e. A ph /\ A. y e. A ps ) ) $=
      ( wa wral wb c0 wceq rzal pm5.1 syl12anc wne r19.28z ralbidv nfcv nfral
      r19.27z bitrd pm2.61ine ) ABHDEIZCEIZACEIZBDEIZHZJZEKEKLUEUFUGUIUDCEMACEM
      BDEMUEUHNOEKPZUEAUGHZCEIUHUJUDUKCEABDEFQRAUGCEBCDECESGTUAUBUC $.
  $}

  ${
    $d y ph $.  $d x ps $.  $d x y A $.
    $( Rearrange restricted quantifiers.  (Contributed by NM, 11-Mar-1997.) $)
    raaanv $p |- ( A. x e. A A. y e. A ( ph /\ ps ) <->
                  ( A. x e. A ph /\ A. y e. A ps ) ) $=
      ( wa wral wb wceq rzal pm5.1 syl12anc wne r19.28zv ralbidv r19.27zv bitrd
      c0 pm2.61ine ) ABFDEGZCEGZACEGZBDEGZFZHZERERIUAUBUCUETCEJACEJBDEJUAUDKLER
      MZUAAUCFZCEGUDUFTUGCEABDENOAUCCEPQS $.
  $}

  ${
    $d z y $.  $d z x A $.
    $( Set substitution into the first argument of a subset relation.
       (Contributed by Rodolfo Medina, 7-Jul-2010.)  (Proof shortened by Mario
       Carneiro, 14-Nov-2016.) $)
    sbss $p |- ( [ y / x ] x C_ A <-> y C_ A ) $=
      ( vz cv wss wsb vex sbequ sseq1 nfv sbie vtoclb ) AEZCFZADGDEZCFZOABGBEZC
      FDRBHODBAIPRCJOQADQAKNPCJLM $.
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d V y $.  $d x y $.
    $( Distribute proper substitution through a subclass relation.
       (Contributed by Alan Sare, 22-Jul-2012.)  (Proof shortened by Alexander
       van der Vekens, 23-Jul-2017.) $)
    sbcssg $p |- ( A e. V -> ( [. A / x ]. B C_ C <->
      [_ A / x ]_ B C_ [_ A / x ]_ C ) ) $=
      ( vy wcel cv wi wal wsbc csb wss sbcal sbcimg sbcel2 imbi12i syl6bb dfss2
      albidv syl5bb sbcbii 3bitr4g ) BEGZFHZCGZUEDGZIZFJZABKZUEABCLZGZUEABDLZGZ
      IZFJZCDMZABKUKUMMUJUHABKZFJUDUPUHFABNUDURUOFUDURUFABKZUGABKZIUOUFUGABEOUS
      ULUTUNABUECPABUEDPQRTUAUQUIABFCDSUBFUKUMSUC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           "Weak deduction theorem" for set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  In a Hilbert system of logic (which consists of a set of axioms, modus
  ponens, and the generalization rule), converting a deduction to a proof using
  the Deduction Theorem (taught in introductory logic books) involves an
  exponential increase of the number of steps as hypotheses are successively
  eliminated.  Here is a trick that is not as general as the Deduction Theorem
  but requires only a linear increase in the number of steps.

  The general problem:  We want to convert a deduction
    P |- Q
  into a proof of the theorem
    |- P -> Q
  i.e. we want to eliminate the hypothesis P.  Normally this is done using the
  Deduction (meta)Theorem, which looks at the microscopic steps of the
  deduction and usually doubles or triples the number of these microscopic
  steps for each hypothesis that is eliminated.  We will look at a special case
  of this problem, without appealing to the Deduction Theorem.

  We assume ZF with class notation.  A and B are arbitrary (possibly
  proper) classes.  P, Q, R, S and T are wffs.

  We define the conditional operator, if(P,A,B), as follows:
    if(P,A,B) =def= { x | (x \in A & P) v (x \in B & -. P) }
  (where x does not occur in A, B, or P).

  Lemma 1.
    A = if(P,A,B) -> (P <-> R), B = if(P,A,B) -> (S <-> R), S |- R
  Proof:  Logic and Axiom of Extensionality.

  Lemma 2.
    A = if(P,A,B) -> (Q <-> T), T |- P -> Q
  Proof:  Logic and Axiom of Extensionality.

  Here's a simple example that illustrates how it works.  Suppose we have
  a deduction
    Ord A |- Tr A
  which means, "Assume A is an ordinal class.  Then A is a transitive class."
  Note that A is a class variable that may be substituted with any class
  expression, so this is really a deduction scheme.

  We want to convert this to a proof of the theorem (scheme)
    |- Ord A -> Tr A.

  The catch is that we must be able to prove "Ord A" for at least one
  object A (and this is what makes it weaker than the ordinary Deduction
  Theorem).  However, it is easy to prove |- Ord 0 (the empty set is
  ordinal).  (For a typical textbook "theorem," i.e. deduction, there is
  usually at least one object satisfying each hypothesis, otherwise the
  theorem would not be very useful.  We can always go back to the standard
  Deduction Theorem for those hypotheses where this is not the case.)
  Continuing with the example:

  Equality axioms (and Extensionality) yield
    |- A = if(Ord A, A, 0) -> (Ord A <-> Ord if(Ord A, A, 0))  (1)
    |- 0 = if(Ord A, A, 0) -> (Ord 0 <-> Ord if(Ord A, A, 0))  (2)
  From (1), (2) and |- Ord 0, Lemma 1 yields
    |- Ord if(Ord A, A, 0)                                       (3)
  From (3) and substituting if(Ord A, A, 0) for
  A in the original deduction,
    |- Tr if(Ord A, A, 0)                                        (4)
  Equality axioms (and Extensionality) yield
    |- A = if(Ord A, A, 0) -> (Tr A <-> Tr if(Ord A, A, 0))    (5)
  From (4) and (5), Lemma 2 yields
    |- Ord A -> Tr A                                               (Q.E.D.)

$)

  $( These lemmas are used to convert hypotheses into antecedents,
     when there is at least one class making the hypothesis true. $)

  $( Declare new constant symbols. $)
  $c if $.  $( Conditional operator (was "ded" for "deduction class"). $)

  $( Extend class notation to include the conditional operator.  See ~ df-if
     for a description.  (In older databases this was denoted "ded".) $)
  cif $a class if ( ph , A , B ) $.

  ${
    $d x ph $.  $d x A $.  $d x B $.
    $( Define the conditional operator.  Read ` if ( ph , A , B ) ` as "if
       ` ph ` then ` A ` else ` B ` ."  See ~ iftrue and ~ iffalse for its
       values.  In mathematical literature, this operator is rarely defined
       formally but is implicit in informal definitions such as "let f(x)=0 if
       x=0 and 1/x otherwise."  (In older versions of this database, this
       operator was denoted "ded" and called the "deduction class.")

       An important use for us is in conjunction with the weak deduction
       theorem, which converts a hypothesis into an antecedent.  In that role,
       ` A ` is a class variable in the hypothesis and ` B ` is a class
       (usually a constant) that makes the hypothesis true when it is
       substituted for ` A ` .  See ~ dedth for the main part of the weak
       deduction theorem, ~ elimhyp to eliminate a hypothesis, and ~ keephyp to
       keep a hypothesis.  See the Deduction Theorem link on the Metamath Proof
       Explorer Home Page for a description of the weak deduction theorem.
       (Contributed by NM, 15-May-1999.) $)
    df-if $a |- if ( ph , A , B ) =
                 { x | ( ( x e. A /\ ph ) \/ ( x e. B /\ -. ph ) ) } $.
  $}

  ${
    $d x ph $.  $d x A $.  $d x B $.  $d x C $.
    $( An alternate definition of the conditional operator ~ df-if with one
       fewer connectives (but probably less intuitive to understand).
       (Contributed by NM, 30-Jan-2006.) $)
    dfif2 $p |- if ( ph , A , B ) =
                 { x | ( ( x e. B -> ph ) -> ( x e. A /\ ph ) ) } $=
      ( cif cv wcel wa wn wo cab wi df-if df-or orcom iman imbi1i 3bitr4i abbii
      eqtri ) ACDEBFZCGAHZUADGZAIHZJZBKUCALZUBLZBKABCDMUEUGBUDUBJUDIZUBLUEUGUDU
      BNUBUDOUFUHUBUCAPQRST $.

    $( An alternate definition of the conditional operator ~ df-if as a simple
       class abstraction.  (Contributed by Mario Carneiro, 8-Sep-2013.) $)
    dfif6 $p |- if ( ph , A , B ) =
                 ( { x e. A | ph } u. { x e. B | -. ph } ) $=
      ( cv wcel wa cab wn cun wo crab cif unab df-rab uneq12i df-if 3eqtr4ri )
      BEZCFAGZBHZSDFAIZGZBHZJTUCKBHABCLZUBBDLZJACDMTUCBNUEUAUFUDABCOUBBDOPABCDQ
      R $.

    $( Equality theorem for conditional operator.  (Contributed by NM,
       1-Sep-2004.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    ifeq1 $p |- ( A = B -> if ( ph , A , C ) = if ( ph , B , C ) ) $=
      ( vx wceq crab wn cun cif rabeq uneq1d dfif6 3eqtr4g ) BCFZAEBGZAHEDGZIAE
      CGZQIABDJACDJOPRQAEBCKLAEBDMAECDMN $.

    $( Equality theorem for conditional operator.  (Contributed by NM,
       1-Sep-2004.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    ifeq2 $p |- ( A = B -> if ( ph , C , A ) = if ( ph , C , B ) ) $=
      ( vx wceq crab wn cun cif rabeq uneq2d dfif6 3eqtr4g ) BCFZAEDGZAHZEBGZIP
      QECGZIADBJADCJORSPQEBCKLAEDBMAEDCMN $.

    $( Value of the conditional operator when its first argument is true.
       (Contributed by NM, 15-May-1999.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    iftrue $p |- ( ph -> if ( ph , A , B ) = A ) $=
      ( vx cv wcel wi wa cab cif dedlem0a abbi2dv dfif2 syl6reqr ) ABDEZCFZAGOB
      FZAHGZDIABCJARDBAQPKLADBCMN $.

    $( Value of the conditional operator when its first argument is false.
       (Contributed by NM, 14-Aug-1999.) $)
    iffalse $p |- ( -. ph -> if ( ph , A , B ) = B ) $=
      ( vx wn cv wcel wa wo cab cif dedlemb abbi2dv df-if syl6reqr ) AEZCDFZBGZ
      AHQCGZPHIZDJABCKPTDCARSLMADBCNO $.
  $}

  $( When values are unequal, but an "if" condition checks if they are equal,
     then the "false" branch results.  This is a simple utility to provide a
     slight shortening and simplification of proofs vs. applying ~ iffalse
     directly in this case.  It happens, e.g., in ~ oevn0 .  (Contributed by
     David A. Wheeler, 15-May-2015.) $)
  ifnefalse $p |- ( A =/= B -> if ( A = B , C , D ) = D ) $=
    ( wne wceq wn cif df-ne iffalse sylbi ) ABEABFZGLCDHDFABILCDJK $.

  ${
    $d A x y $.  $d B x y $.  $d C y $.
    ifsb.1 $e |- ( if ( ph , A , B ) = A -> C = D ) $.
    ifsb.2 $e |- ( if ( ph , A , B ) = B -> C = E ) $.
    $( Distribute a function over an if-clause.  (Contributed by Mario
       Carneiro, 14-Aug-2013.) $)
    ifsb $p |- C = if ( ph , D , E ) $=
      ( cif wceq iftrue syl eqtr4d wn iffalse pm2.61i ) ADAEFIZJADEQAABCIZBJDEJ
      ABCKGLAEFKMANZDFQSRCJDFJABCOHLAEFOMP $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y ph $.
    dfif3.1 $e |- C = { x | ph } $.
    $( Alternate definition of the conditional operator ~ df-if .  Note that
       ` ph ` is independent of ` x ` i.e. a constant true or false.
       (Contributed by NM, 25-Aug-2013.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    dfif3 $p |- if ( ph , A , B )
                  = ( ( A i^i C ) u. ( B i^i ( _V \ C ) ) ) $=
      ( vy cif crab wn cun cin cvv cdif dfif6 cab weq ineq2i dfrab3 eqtr4i
      biidd cbvabv eqtri notab difeq2i eqtr2i uneq12i ) ACDHAGCIZAJZGDIZKCELZDM
      ENZLZKAGCDOUKUHUMUJUKCAGPZLUHEUNCEABPUNFAABGBGQAUAUBUCZRAGCSTUJDUIGPZLUMU
      IGDSUPULDUPMUNNULAGUDEUNMUOUETRUFUGT $.

    $( Alternate definition of the conditional operator ~ df-if .  Note that
       ` ph ` is independent of ` x ` i.e. a constant true or false.
       (Contributed by NM, 25-Aug-2013.) $)
    dfif4 $p |- if ( ph , A , B )
        = ( ( A u. B ) i^i ( ( A u. ( _V \ C ) ) i^i ( B u. C ) ) ) $=
      ( cif cin cvv cdif cun dfif3 undir undi uncom unvdif ineq12i 3eqtri inass
      inv1 eqtri ) ACDGCEHDIEJZHZKCUCKZEUCKZHZCDKZCUBKZDEKZHHZABCDEFLCEUCMUFUGU
      HHZUIHUJUDUKUEUICDUBNUEEDKZEUBKZHUIIHUIEDUBNULUIUMIEDOEPQUITRQUGUHUISUAR
      $.

    $( Alternate definition of the conditional operator ~ df-if .  Note that
       ` ph ` is independent of ` x ` i.e. a constant true or false (see also
       ~ abvor0 ).  (Contributed by G&eacute;rard Lang, 18-Aug-2013.) $)
    dfif5 $p |- if ( ph , A , B ) = ( ( A i^i B )
          u. ( ( ( A \ B ) i^i C ) u. ( ( B \ A ) i^i ( _V \ C ) ) ) ) $=
      ( cun cdif undir unidm unass undi 3eqtr3ri undifabs ineq1i undif2 3eqtr4i
      cin inabs eqtr4i cvv cif inindi dfif4 uneq1i 3eqtri uneq12i uncom 3eqtrri
      unundi uneq2i ineq2i ineq12i ) CDGZCUAEHZGZDEGZRRUNUPRZUNUQRZRZACDUBCDRCD
      HZERZDCHZUORZGZGZUNUPUQUCABCDEFUDVFCVEGZDVEGZRUTCDVEIURVGUSVHURCVBGZCVDGZ
      GZVGURCCDUORZGZGZVKCCGZVLGVMVNURVOCVLCJUECCVLKCDUOLZMVICVJVMVICVAGZCEGZRC
      VRRCCVAELVQCVRCDNOCESUFCVCGZUPRURVJVMVSUNUPCDPOCVCUOLVPQUGTCVBVDUJTCERZDG
      ZDVBGZDVDGZGZUSVHWADGVTDDGZGWDWAVTDDKWAWBDWCWADVAGZUQRZWBDVTGDCGZUQRWAWGD
      CELVTDUHWFWHUQDCPOQDVAELTWCDVCGZDUOGZRDWJRDDVCUOLWIDWJDCNODUOSUIUGWEDVTDJ
      UKMUSUNEDGZRWAUQWKUNDEUHULCEDITDVBVDUJQUMTQ $.
  $}

  $( Equality theorem for conditional operators.  (Contributed by NM,
     1-Sep-2004.) $)
  ifeq12 $p |- ( ( A = B /\ C = D ) ->
                if ( ph , A , C ) = if ( ph , B , D ) ) $=
    ( wceq cif ifeq1 ifeq2 sylan9eq ) BCFDEFABDGACDGACEGABCDHADECIJ $.

  ${
    ifeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for conditional operator.  (Contributed by NM,
       16-Feb-2005.) $)
    ifeq1d $p |- ( ph -> if ( ps , A , C ) = if ( ps , B , C ) ) $=
      ( wceq cif ifeq1 syl ) ACDGBCEHBDEHGFBCDEIJ $.

    $( Equality deduction for conditional operator.  (Contributed by NM,
       16-Feb-2005.) $)
    ifeq2d $p |- ( ph -> if ( ps , C , A ) = if ( ps , C , B ) ) $=
      ( wceq cif ifeq2 syl ) ACDGBECHBEDHGFBCDEIJ $.

    ifeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for conditional operator.  (Contributed by NM,
       24-Mar-2015.) $)
    ifeq12d $p |- ( ph -> if ( ps , A , C ) = if ( ps , B , D ) ) $=
      ( cif ifeq1d ifeq2d eqtrd ) ABCEIBDEIBDFIABCDEGJABEFDHKL $.
  $}

  $( Equivalence theorem for conditional operators.  (Contributed by Raph
     Levien, 15-Jan-2004.) $)
  ifbi $p |- ( ( ph <-> ps ) -> if ( ph , A , B ) = if ( ps , A , B ) ) $=
    ( wb wa wn wo cif wceq dfbi3 iftrue eqcomd sylan9eq iffalse jaoi sylbi ) AB
    EABFZAGZBGZFZHACDIZBCDIZJZABKRUDUAABUBCUCACDLBUCCBCDLMNSTUBDUCACDOTUCDBCDOM
    NPQ $.

  ${
    ifbid.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalence deduction for conditional operators.  (Contributed by NM,
       18-Apr-2005.) $)
    ifbid $p |- ( ph -> if ( ps , A , B ) = if ( ch , A , B ) ) $=
      ( wb cif wceq ifbi syl ) ABCGBDEHCDEHIFBCDEJK $.
  $}

  ${
    ifbieq2i.1 $e |- ( ph <-> ps ) $.
    ifbieq2i.2 $e |- A = B $.
    $( Equivalence/equality inference for conditional operators.  (Contributed
       by Paul Chapman, 22-Jun-2011.) $)
    ifbieq2i $p |- if ( ph , C , A ) = if ( ps , C , B ) $=
      ( cif wb wceq ifbi ax-mp ifeq2 eqtri ) AECHZBECHZBEDHZABIOPJFABECKLCDJPQJ
      GBCDEMLN $.
  $}

  ${
    ifbieq2d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    ifbieq2d.2 $e |- ( ph -> A = B ) $.
    $( Equivalence/equality deduction for conditional operators.  (Contributed
       by Paul Chapman, 22-Jun-2011.) $)
    ifbieq2d $p |- ( ph -> if ( ps , C , A ) = if ( ch , C , B ) ) $=
      ( cif ifbid ifeq2d eqtrd ) ABFDICFDICFEIABCFDGJACDEFHKL $.
  $}

  ${
    ifbieq12i.1 $e |- ( ph <-> ps ) $.
    ifbieq12i.2 $e |- A = C $.
    ifbieq12i.3 $e |- B = D $.
    $( Equivalence deduction for conditional operators.  (Contributed by NM,
       18-Mar-2013.) $)
    ifbieq12i $p |- if ( ph , A , B ) = if ( ps , C , D ) $=
      ( cif wceq ifeq1 ax-mp ifbieq2i eqtri ) ACDJZAEDJZBEFJCEKPQKHACEDLMABDFEG
      INO $.
  $}

  ${
    ifbieq12d.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    ifbieq12d.2 $e |- ( ph -> A = C ) $.
    ifbieq12d.3 $e |- ( ph -> B = D ) $.
    $( Equivalence deduction for conditional operators.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    ifbieq12d $p |- ( ph -> if ( ps , A , B ) = if ( ch , C , D ) ) $=
      ( cif ifbid ifeq12d eqtrd ) ABDEKCDEKCFGKABCDEHLACDFEGIJMN $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y ph $.  $d y ps $.
    nfifd.2 $e |- ( ph -> F/ x ps ) $.
    nfifd.3 $e |- ( ph -> F/_ x A ) $.
    nfifd.4 $e |- ( ph -> F/_ x B ) $.
    $( Deduction version of ~ nfif .  (Contributed by NM, 15-Feb-2013.)
       (Revised by Mario Carneiro, 13-Oct-2016.) $)
    nfifd $p |- ( ph -> F/_ x if ( ps , A , B ) ) $=
      ( vy cif cv wcel wi wa cab dfif2 nfv nfcrd nfimd nfand nfabd nfcxfrd ) AC
      BDEJIKZELZBMZUCDLZBNZMZIOBIDEPAUHCIAIQAUEUGCAUDBCACIEHRFSAUFBCACIDGRFTSUA
      UB $.
  $}

  ${
    $d x y z $.  $d y z A $.  $d y z B $.  $d z ph $.
    nfif.1 $e |- F/ x ph $.
    nfif.2 $e |- F/_ x A $.
    nfif.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for a conditional operator.
       (Contributed by NM, 16-Feb-2005.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) $)
    nfif $p |- F/_ x if ( ph , A , B ) $=
      ( cif wnfc wtru wnf a1i nfifd trud ) BACDHIJABCDABKJELBCIJFLBDIJGLMN $.
  $}

  ${
    ifeq1da.1 $e |- ( ( ph /\ ps ) -> A = B ) $.
    $( Conditional equality.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    ifeq1da $p |- ( ph -> if ( ps , A , C ) = if ( ps , B , C ) ) $=
      ( cif wceq wa ifeq1d wn iffalse eqtr4d adantl pm2.61dan ) ABBCEGZBDEGZHZA
      BIBCDEFJBKZRASPEQBCELBDELMNO $.
  $}

  ${
    ifeq2da.1 $e |- ( ( ph /\ -. ps ) -> A = B ) $.
    $( Conditional equality.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    ifeq2da $p |- ( ph -> if ( ps , C , A ) = if ( ps , C , B ) ) $=
      ( cif wceq iftrue eqtr4d adantl wn wa ifeq2d pm2.61dan ) ABBECGZBEDGZHZBR
      ABPEQBECIBEDIJKABLMBCDEFNO $.
  $}

  ${
    ifclda.1 $e |- ( ( ph /\ ps ) -> A e. C ) $.
    ifclda.2 $e |- ( ( ph /\ -. ps ) -> B e. C ) $.
    $( Conditional closure.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    ifclda $p |- ( ph -> if ( ps , A , B ) e. C ) $=
      ( cif wcel wa wceq iftrue adantl eqeltrd wn iffalse pm2.61dan ) ABBCDHZEI
      ABJRCEBRCKABCDLMFNABOZJRDESRDKABCDPMGNQ $.
  $}

  ${
    elimif.1 $e |- ( if ( ph , A , B ) = A -> ( ps <-> ch ) ) $.
    elimif.2 $e |- ( if ( ph , A , B ) = B -> ( ps <-> th ) ) $.
    $( Elimination of a conditional operator contained in a wff ` ps ` .
       (Contributed by NM, 15-Feb-2005.) $)
    elimif $p |- ( ps <-> ( ( ph /\ ch ) \/ ( -. ph /\ th ) ) ) $=
      ( wn wo wa exmid biantrur andir cif wceq wb iftrue syl pm5.32i iffalse
      orbi12i 3bitri ) BAAIZJZBKABKZUDBKZJACKZUDDKZJUEBALMAUDBNUFUHUGUIABCAAEFO
      ZEPBCQAEFRGSTUDBDUDUJFPBDQAEFUAHSTUBUC $.
  $}

  ${
    ifboth.1 $e |- ( A = if ( ph , A , B ) -> ( ps <-> th ) ) $.
    ifboth.2 $e |- ( B = if ( ph , A , B ) -> ( ch <-> th ) ) $.
    ${
      ifbothda.3 $e |- ( ( et /\ ph ) -> ps ) $.
      ifbothda.4 $e |- ( ( et /\ -. ph ) -> ch ) $.
      $( A wff ` th ` containing a conditional operator is true when both of
         its cases are true.  (Contributed by NM, 15-Feb-2015.) $)
      ifbothda $p |- ( et -> th ) $=
        ( wa wb cif wceq iftrue eqcomd syl adantl mpbid wn iffalse pm2.61dan )
        EADEALBDJABDMZEAFAFGNZOUDAUEFAFGPQHRSTEAUAZLCDKUFCDMZEUFGUEOUGUFUEGAFGU
        BQIRSTUC $.
    $}

    $( A wff ` th ` containing a conditional operator is true when both of its
       cases are true.  (Contributed by NM, 3-Sep-2006.)  (Revised by Mario
       Carneiro, 15-Feb-2015.) $)
    ifboth $p |- ( ( ps /\ ch ) -> th ) $=
      ( wa simpll wn simplr ifbothda ) ABCDBCIEFGHBCAJBCAKLM $.
  $}

  $( Identical true and false arguments in the conditional operator.
     (Contributed by NM, 18-Apr-2005.) $)
  ifid $p |- if ( ph , A , A ) = A $=
    ( cif wceq iftrue iffalse pm2.61i ) AABBCBDABBEABBFG $.

  $( Expansion of an equality with a conditional operator.  (Contributed by NM,
     14-Feb-2005.) $)
  eqif $p |- ( A = if ( ph , B , C ) <->
             ( ( ph /\ A = B ) \/ ( -. ph /\ A = C ) ) ) $=
    ( cif wceq eqeq2 elimif ) ABACDEZFBCFBDFCDICBGIDBGH $.

  $( Membership in a conditional operator.  (Contributed by NM,
     14-Feb-2005.) $)
  elif $p |- ( A e. if ( ph , B , C ) <->
             ( ( ph /\ A e. B ) \/ ( -. ph /\ A e. C ) ) ) $=
    ( cif wcel eleq2 elimif ) ABACDEZFBCFBDFCDICBGIDBGH $.

  $( Membership of a conditional operator.  (Contributed by NM,
     10-Sep-2005.) $)
  ifel $p |- ( if ( ph , A , B ) e. C <->
             ( ( ph /\ A e. C ) \/ ( -. ph /\ B e. C ) ) ) $=
    ( cif wcel eleq1 elimif ) AABCEZDFBDFCDFBCIBDGICDGH $.

  $( Membership (closure) of a conditional operator.  (Contributed by NM,
     4-Apr-2005.) $)
  ifcl $p |- ( ( A e. C /\ B e. C ) -> if ( ph , A , B ) e. C ) $=
    ( wcel cif eleq1 ifboth ) ABDECDEABCFZDEBCBIDGCIDGH $.

  $( The possible values of a conditional operator.  (Contributed by NM,
     17-Jun-2007.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.) $)
  ifeqor $p |- ( if ( ph , A , B ) = A \/ if ( ph , A , B ) = B ) $=
    ( cif wceq wn iftrue con3i iffalse syl orri ) ABCDZBEZLCEZMFAFNAMABCGHABCIJ
    K $.

  $( Negating the first argument swaps the last two arguments of a conditional
     operator.  (Contributed by NM, 21-Jun-2007.) $)
  ifnot $p |- if ( -. ph , A , B ) = if ( ph , B , A ) $=
    ( wn cif wceq notnot1 iffalse syl iftrue eqtr4d pm2.61i ) AADZBCEZACBEZFANC
    OAMDNCFAGMBCHIACBJKMNBOMBCJACBHKL $.

  $( Rewrite a conjunction in an if statement as two nested conditionals.
     (Contributed by Mario Carneiro, 28-Jul-2014.) $)
  ifan $p |- if ( ( ph /\ ps ) , A , B ) = if ( ph , if ( ps , A , B ) , B ) $=
    ( wa cif wceq iftrue ifbid eqtr2d wn simpl con3i iffalse syl eqtr4d pm2.61i
    ibar ) AABEZCDFZABCDFZDFZGAUBUATAUADHABSCDABRIJAKZTDUBUCSKTDGSAABLMSCDNOAUA
    DNPQ $.

  $( Rewrite a disjunction in an if statement as two nested conditionals.
     (Contributed by Mario Carneiro, 28-Jul-2014.) $)
  ifor $p |- if ( ( ph \/ ps ) , A , B ) = if ( ph , A , if ( ps , A , B ) ) $=
    ( wo cif wceq iftrue orcs eqtr4d wn iffalse biorf ifbid eqtr2d pm2.61i ) AA
    BEZCDFZACBCDFZFZGARCTABRCGQCDHIACSHJAKZTSRACSLUABQCDABMNOP $.

  ${
    $d y A $.  $d y z B $.  $d y z C $.  $d y z ph $.  $d x y z $.
    $( Distribute proper substitution through the conditional operator.
       (Contributed by NM, 24-Feb-2013.)  (Revised by NM, 19-Aug-2018.) $)
    csbif $p |- [_ A / x ]_ if ( ph , B , C )
          = if ( [. A / x ]. ph , [_ A / x ]_ B , [_ A / x ]_ C ) $=
      ( vy cvv wcel cif csb wsbc cv wsb csbeq1 ifbieq12d nfcsb1v csbeq1a csbprc
      wceq c0 dfsbcq2 eqeq12d vex nfs1v nfif sbequ12 csbief vtoclg ifeq12d ifid
      weq wn syl6req eqtrd pm2.61i ) CGHZBCADEIZJZABCKZBCDJZBCEJZIZSZBFLZUQJZAB
      FMZBVDDJZBVDEJZIZSVCFCGVDCSZVEURVIVBBVDCUQNVJVFUSVGVHUTVAABFCUABVDCDNBVDC
      ENOUBBVDUQVIFUCVFBVGVHABFUDBVDDPBVDEPUEBFUKAVFDEVGVHABFUFBVDDQBVDEQOUGUHU
      PULZURTVBBCUQRVKVBUSTTITVKUSUTTVATBCDRBCERUIUSTUJUMUNUO $.

    $( Distribute proper substitution through the conditional operator.
       (Contributed by NM, 24-Feb-2013.)  (Revised by Mario Carneiro,
       14-Nov-2016.)  Obsolete as of 19-Aug-2018.  Use ~ csbif instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbifgOLD $p |- ( A e. V -> [_ A / x ]_ if ( ph , B , C )
          = if ( [. A / x ]. ph , [_ A / x ]_ B , [_ A / x ]_ C ) ) $=
      ( vy cv cif csb wsb wceq csbeq1 dfsbcq2 ifbieq12d eqeq12d nfcsb1v csbeq1a
      wsbc vex nfs1v nfif weq sbequ12 csbief vtoclg ) BGHZADEIZJZABGKZBUGDJZBUG
      EJZIZLBCUHJZABCSZBCDJZBCEJZIZLGCFUGCLZUIUNUMURBUGCUHMUSUJUOUKULUPUQABGCNB
      UGCDMBUGCEMOPBUGUHUMGTUJBUKULABGUABUGDQBUGEQUBBGUCAUJDEUKULABGUDBUGDRBUGE
      ROUEUF $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    dedth.1 $e |- ( A = if ( ph , A , B ) -> ( ps <-> ch ) ) $.
    dedth.2 $e |- ch $.
    $( Weak deduction theorem that eliminates a hypothesis ` ph ` , making it
       become an antecedent.  We assume that a proof exists for ` ph ` when the
       class variable ` A ` is replaced with a specific class ` B ` .  The
       hypothesis ` ch ` should be assigned to the inference, and the
       inference's hypothesis eliminated with ~ elimhyp .  If the inference has
       other hypotheses with class variable ` A ` , these can be kept by
       assigning ~ keephyp to them.  For more information, see the Deduction
       Theorem ~ http://us.metamath.org/mpeuni/mmdeduction.html .  (Contributed
       by NM, 15-May-1999.) $)
    dedth $p |- ( ph -> ps ) $=
      ( cif wceq wb iftrue eqcomd syl mpbiri ) ABCGADADEHZIBCJAODADEKLFMN $.
  $}

  ${
    dedth2h.1 $e |- ( A = if ( ph , A , C ) -> ( ch <-> th ) ) $.
    dedth2h.2 $e |- ( B = if ( ps , B , D ) -> ( th <-> ta ) ) $.
    dedth2h.3 $e |- ta $.
    $( Weak deduction theorem eliminating two hypotheses.  This theorem is
       simpler to use than ~ dedth2v but requires that each hypothesis has
       exactly one class variable.  See also comments in ~ dedth .
       (Contributed by NM, 15-May-1999.) $)
    dedth2h $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wi cif wceq imbi2d dedth imp ) ABCABCMBDMFHFAFHNOCDBJPBDEGIKLQQR $.
  $}

  ${
    dedth3h.1 $e |- ( A = if ( ph , A , D ) -> ( th <-> ta ) ) $.
    dedth3h.2 $e |- ( B = if ( ps , B , R ) -> ( ta <-> et ) ) $.
    dedth3h.3 $e |- ( C = if ( ch , C , S ) -> ( et <-> ze ) ) $.
    dedth3h.4 $e |- ze $.
    $( Weak deduction theorem eliminating three hypotheses.  See comments in
       ~ dedth2h .  (Contributed by NM, 15-May-1999.) $)
    dedth3h $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa wi cif wceq imbi2d dedth2h dedth 3impib ) ABCDABCRZDSUFESHKHAHKTUADE
      UFNUBBCEFGIJLMOPQUCUDUE $.
  $}

  ${
    dedth4h.1 $e |- ( A = if ( ph , A , R ) -> ( ta <-> et ) ) $.
    dedth4h.2 $e |- ( B = if ( ps , B , S ) -> ( et <-> ze ) ) $.
    dedth4h.3 $e |- ( C = if ( ch , C , F ) -> ( ze <-> si ) ) $.
    dedth4h.4 $e |- ( D = if ( th , D , G ) -> ( si <-> rh ) ) $.
    dedth4h.5 $e |- rh $.
    $( Weak deduction theorem eliminating four hypotheses.  See comments in
       ~ dedth2h .  (Contributed by NM, 16-May-1999.) $)
    dedth4h $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ta ) $=
      ( wa wi cif wceq imbi2d dedth2h imp ) ABUCCDUCZEABUJEUDUJFUDUJGUDJKNOJAJN
      UEUFEFUJRUGKBKOUEUFFGUJSUGCDGHILMPQTUAUBUHUHUI $.
  $}

  ${
    dedth2v.1 $e |- ( A = if ( ph , A , C ) -> ( ps <-> ch ) ) $.
    dedth2v.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    dedth2v.3 $e |- th $.
    $( Weak deduction theorem for eliminating a hypothesis with 2 class
       variables.  Note: if the hypothesis can be separated into two
       hypotheses, each with one class variable, then ~ dedth2h is simpler to
       use.  See also comments in ~ dedth .  (Contributed by NM, 13-Aug-1999.)
       (Proof shortened by Eric Schmidt, 28-Jul-2009.) $)
    dedth2v $p |- ( ph -> ps ) $=
      ( dedth2h anidms ) ABAABCDEFGHIJKLM $.
  $}

  ${
    dedth3v.1 $e |- ( A = if ( ph , A , D ) -> ( ps <-> ch ) ) $.
    dedth3v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    dedth3v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    dedth3v.4 $e |- ta $.
    $( Weak deduction theorem for eliminating a hypothesis with 3 class
       variables.  See comments in ~ dedth2v .  (Contributed by NM,
       13-Aug-1999.)  (Proof shortened by Eric Schmidt, 28-Jul-2009.) $)
    dedth3v $p |- ( ph -> ps ) $=
      ( dedth3h 3anidm12 anidms ) ABAABAAABCDEFGHIJKLMNOPQR $.
  $}

  ${
    dedth4v.1 $e |- ( A = if ( ph , A , R ) -> ( ps <-> ch ) ) $.
    dedth4v.2 $e |- ( B = if ( ph , B , S ) -> ( ch <-> th ) ) $.
    dedth4v.3 $e |- ( C = if ( ph , C , T ) -> ( th <-> ta ) ) $.
    dedth4v.4 $e |- ( D = if ( ph , D , U ) -> ( ta <-> et ) ) $.
    dedth4v.5 $e |- et $.
    $( Weak deduction theorem for eliminating a hypothesis with 4 class
       variables.  See comments in ~ dedth2v .  (Contributed by NM,
       21-Apr-2007.)  (Proof shortened by Eric Schmidt, 28-Jul-2009.) $)
    dedth4v $p |- ( ph -> ps ) $=
      ( anidms wa dedth4h ) ABAAUABAAAABCDEFGHIJKLMNOPQRSUBTT $.
  $}

  ${
    elimhyp.1 $e |- ( A = if ( ph , A , B ) -> ( ph <-> ps ) ) $.
    elimhyp.2 $e |- ( B = if ( ph , A , B ) -> ( ch <-> ps ) ) $.
    elimhyp.3 $e |- ch $.
    $( Eliminate a hypothesis containing class variable ` A ` when it is known
       for a specific class ` B ` .  For more information, see comments in
       ~ dedth .  (Contributed by NM, 15-May-1999.) $)
    elimhyp $p |- ps $=
      ( cif wceq wb iftrue eqcomd syl ibi wn iffalse mpbii pm2.61i ) ABABADADEI
      ZJABKATDADELMFNOAPZCBHUAETJCBKUATEADEQMGNRS $.
  $}

  ${
    elimhyp2v.1 $e |- ( A = if ( ph , A , C ) -> ( ph <-> ch ) ) $.
    elimhyp2v.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    elimhyp2v.3 $e |- ( C = if ( ph , A , C ) -> ( ta <-> et ) ) $.
    elimhyp2v.4 $e |- ( D = if ( ph , B , D ) -> ( et <-> th ) ) $.
    elimhyp2v.5 $e |- ta $.
    $( Eliminate a hypothesis containing 2 class variables.  (Contributed by
       NM, 14-Aug-1999.) $)
    elimhyp2v $p |- th $=
      ( cif wceq wb iftrue eqcomd syl bitrd ibi wn iffalse mpbii pm2.61i ) ACAC
      AABCAFAFHOZPABQAUGFAFHRSJTAGAGIOZPBCQAUHGAGIRSKTUAUBAUCZDCNUIDECUIHUGPDEQ
      UIUGHAFHUDSLTUIIUHPECQUIUHIAGIUDSMTUAUEUF $.
  $}

  ${
    elimhyp3v.1 $e |- ( A = if ( ph , A , D ) -> ( ph <-> ch ) ) $.
    elimhyp3v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    elimhyp3v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    elimhyp3v.4 $e |- ( D = if ( ph , A , D ) -> ( et <-> ze ) ) $.
    elimhyp3v.5 $e |- ( R = if ( ph , B , R ) -> ( ze <-> si ) ) $.
    elimhyp3v.6 $e |- ( S = if ( ph , C , S ) -> ( si <-> ta ) ) $.
    elimhyp3v.7 $e |- et $.
    $( Eliminate a hypothesis containing 3 class variables.  (Contributed by
       NM, 14-Aug-1999.) $)
    elimhyp3v $p |- ta $=
      ( cif wceq wb iftrue eqcomd syl 3bitrd ibi wn iffalse mpbii pm2.61i ) ADA
      DAABCDAHAHKUAZUBABUCAUMHAHKUDUENUFAIAILUAZUBBCUCAUNIAILUDUEOUFAJAJMUAZUBC
      DUCAUOJAJMUDUEPUFUGUHAUIZEDTUPEFGDUPKUMUBEFUCUPUMKAHKUJUEQUFUPLUNUBFGUCUP
      UNLAILUJUERUFUPMUOUBGDUCUPUOMAJMUJUESUFUGUKUL $.
  $}

  ${
    elimhyp4v.1 $e |- ( A = if ( ph , A , D ) -> ( ph <-> ch ) ) $.
    elimhyp4v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    elimhyp4v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    elimhyp4v.4 $e |- ( F = if ( ph , F , G ) -> ( ta <-> ps ) ) $.
    elimhyp4v.5 $e |- ( D = if ( ph , A , D ) -> ( et <-> ze ) ) $.
    elimhyp4v.6 $e |- ( R = if ( ph , B , R ) -> ( ze <-> si ) ) $.
    elimhyp4v.7 $e |- ( S = if ( ph , C , S ) -> ( si <-> rh ) ) $.
    elimhyp4v.8 $e |- ( G = if ( ph , F , G ) -> ( rh <-> ps ) ) $.
    elimhyp4v.9 $e |- et $.
    $( Eliminate a hypothesis containing 4 class variables (for use with the
       weak deduction theorem ~ dedth ).  (Contributed by NM, 16-Apr-2005.) $)
    elimhyp4v $p |- ps $=
      ( cif wceq wb iftrue eqcomd syl bitrd 3bitrd ibi wn iffalse mpbii pm2.61i
      ) ABABAADEBAACDAJAJMUGZUHACUIAUTJAJMUJUKRULAKAKNUGZUHCDUIAVAKAKNUJUKSULUM
      ALALOUGZUHDEUIAVBLALOUJUKTULAPAPQUGZUHEBUIAVCPAPQUJUKUAULUNUOAUPZFBUFVDFH
      IBVDFGHVDMUTUHFGUIVDUTMAJMUQUKUBULVDNVAUHGHUIVDVANAKNUQUKUCULUMVDOVBUHHIU
      IVDVBOALOUQUKUDULVDQVCUHIBUIVDVCQAPQUQUKUEULUNURUS $.
  $}

  ${
    elimel.1 $e |- B e. C $.
    $( Eliminate a membership hypothesis for weak deduction theorem, when
       special case ` B e. C ` is provable.  (Contributed by NM,
       15-May-1999.) $)
    elimel $p |- if ( A e. C , A , B ) e. C $=
      ( wcel cif eleq1 elimhyp ) ACEZIABFZCEBCEABAJCGBJCGDH $.
  $}

  ${
    elimdhyp.1 $e |- ( ph -> ps ) $.
    elimdhyp.2 $e |- ( A = if ( ph , A , B ) -> ( ps <-> ch ) ) $.
    elimdhyp.3 $e |- ( B = if ( ph , A , B ) -> ( th <-> ch ) ) $.
    elimdhyp.4 $e |- th $.
    $( Version of ~ elimhyp where the hypothesis is deduced from the final
       antecedent.  See ~ ghomgrplem for an example of its use.  (Contributed
       by Paul Chapman, 25-Mar-2008.) $)
    elimdhyp $p |- ch $=
      ( cif wceq wb iftrue eqcomd syl mpbid wn iffalse mpbii pm2.61i ) ACABCGAE
      AEFKZLBCMAUBEAEFNOHPQARZDCJUCFUBLDCMUCUBFAEFSOIPTUA $.
  $}

  ${
    keephyp.1 $e |- ( A = if ( ph , A , B ) -> ( ps <-> th ) ) $.
    keephyp.2 $e |- ( B = if ( ph , A , B ) -> ( ch <-> th ) ) $.
    keephyp.3 $e |- ps $.
    keephyp.4 $e |- ch $.
    $( Transform a hypothesis ` ps ` that we want to keep (but contains the
       same class variable ` A ` used in the eliminated hypothesis) for use
       with the weak deduction theorem.  (Contributed by NM, 15-May-1999.) $)
    keephyp $p |- th $=
      ( ifboth mp2an ) BCDIJABCDEFGHKL $.
  $}

  ${
    keephyp2v.1 $e |- ( A = if ( ph , A , C ) -> ( ps <-> ch ) ) $.
    keephyp2v.2 $e |- ( B = if ( ph , B , D ) -> ( ch <-> th ) ) $.
    keephyp2v.3 $e |- ( C = if ( ph , A , C ) -> ( ta <-> et ) ) $.
    keephyp2v.4 $e |- ( D = if ( ph , B , D ) -> ( et <-> th ) ) $.
    keephyp2v.5 $e |- ps $.
    keephyp2v.6 $e |- ta $.
    $( Keep a hypothesis containing 2 class variables (for use with the weak
       deduction theorem ~ dedth ).  (Contributed by NM, 16-Apr-2005.) $)
    keephyp2v $p |- th $=
      ( wceq wb eqcomd syl cif iftrue bitrd mpbii wn iffalse pm2.61i ) ADABDOAB
      CDAGAGIUAZQBCRAUHGAGIUBSKTAHAHJUAZQCDRAUIHAHJUBSLTUCUDAUEZEDPUJEFDUJIUHQE
      FRUJUHIAGIUFSMTUJJUIQFDRUJUIJAHJUFSNTUCUDUG $.
  $}

  ${
    keephyp3v.1 $e |- ( A = if ( ph , A , D ) -> ( rh <-> ch ) ) $.
    keephyp3v.2 $e |- ( B = if ( ph , B , R ) -> ( ch <-> th ) ) $.
    keephyp3v.3 $e |- ( C = if ( ph , C , S ) -> ( th <-> ta ) ) $.
    keephyp3v.4 $e |- ( D = if ( ph , A , D ) -> ( et <-> ze ) ) $.
    keephyp3v.5 $e |- ( R = if ( ph , B , R ) -> ( ze <-> si ) ) $.
    keephyp3v.6 $e |- ( S = if ( ph , C , S ) -> ( si <-> ta ) ) $.
    keephyp3v.7 $e |- rh $.
    keephyp3v.8 $e |- et $.
    $( Keep a hypothesis containing 3 class variables.  (Contributed by NM,
       27-Sep-1999.) $)
    keephyp3v $p |- ta $=
      ( cif wceq wb iftrue eqcomd syl 3bitrd mpbii wn iffalse pm2.61i ) ADAHDUA
      AHBCDAIAILUCZUDHBUEAUNIAILUFUGOUHAJAJMUCZUDBCUEAUOJAJMUFUGPUHAKAKNUCZUDCD
      UEAUPKAKNUFUGQUHUIUJAUKZEDUBUQEFGDUQLUNUDEFUEUQUNLAILULUGRUHUQMUOUDFGUEUQ
      UOMAJMULUGSUHUQNUPUDGDUEUQUPNAKNULUGTUHUIUJUM $.
  $}

  ${
    keepel.1 $e |- A e. C $.
    keepel.2 $e |- B e. C $.
    $( Keep a membership hypothesis for weak deduction theorem, when special
       case ` B e. C ` is provable.  (Contributed by NM, 14-Aug-1999.) $)
    keepel $p |- if ( ph , A , B ) e. C $=
      ( wcel cif eleq1 keephyp ) ABDGCDGABCHZDGBCBKDICKDIEFJ $.
  $}

  ${
    dedex.1 $e |- A e. _V $.
    dedex.2 $e |- B e. _V $.
    $( Conditional operator existence.  (Contributed by NM, 2-Sep-2004.) $)
    ifex $p |- if ( ph , A , B ) e. _V $=
      ( cvv keepel ) ABCFDEG $.
  $}

  ${
    $d A x y $.  $d B y $.  $d ph x y $.
    $( Conditional operator existence.  (Contributed by NM, 21-Mar-2011.) $)
    ifexg $p |- ( ( A e. V /\ B e. W ) -> if ( ph , A , B ) e. _V ) $=
      ( vx vy cv cif cvv wcel wceq ifeq1 eleq1d ifeq2 vex ifex vtocl2g ) AFHZGH
      ZIZJKABTIZJKABCIZJKFGBCDESBLUAUBJASBTMNTCLUBUCJATCBONASTFPGPQR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Power classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the symbol for power class. $)
  $c ~P $.  $( Calligraphic P $)

  $( Extend class notation to include power class.  (The tilde in the Metamath
     token is meant to suggest the calligraphic font of the P.) $)
  cpw $a class ~P A $.

  ${
    $d x A $.  $d y A $.  $d w x $.  $d w y $.  $d w A $.  $d w z $.  $d z x $.
    $d z y $.  $d z A $.
    $( Soundness justification theorem for ~ df-pw .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    pwjust $p |- { x | x C_ A } = { y | y C_ A } $=
      ( vz cv wss cab sseq1 cbvabv eqtri ) AEZCFZAGDEZCFZDGBEZCFZBGLNADKMCHINPD
      BMOCHIJ $.
  $}

  ${
    $d x A $.
    $( Define power class.  Definition 5.10 of [TakeutiZaring] p. 17, but we
       also let it apply to proper classes, i.e. those that are not members of
       ` _V ` .  When applied to a set, this produces its power set.  A power
       set of S is the set of all subsets of S, including the empty set and S
       itself.  For example, if ` A = { 3 , 5 , 7 } ` , then
       ` ~P A = { (/) , { 3 } , { 5 } , { 7 } , { 3 , 5 } , `
       ` { 3 , 7 } , { 5 , 7 } , { 3 , 5 , 7 } } ` ( ~ ex-pw ).  We will later
       introduce the Axiom of Power Sets ~ ax-pow , which can be expressed in
       class notation per ~ pwexg .  Still later we will prove, in ~ hashpw ,
       that the size of the power set of a finite set is 2 raised to the power
       of the size of the set.  (Contributed by NM, 5-Aug-1993.) $)
    df-pw $a |- ~P A = { x | x C_ A } $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Equality theorem for power class.  (Contributed by NM, 5-Aug-1993.) $)
    pweq $p |- ( A = B -> ~P A = ~P B ) $=
      ( vx wceq cv wss cab cpw sseq2 abbidv df-pw 3eqtr4g ) ABDZCEZAFZCGNBFZCGA
      HBHMOPCABNIJCAKCBKL $.
  $}

  ${
    pweqi.1 $e |- A = B $.
    $( Equality inference for power class.  (Contributed by NM,
       27-Nov-2013.) $)
    pweqi $p |- ~P A = ~P B $=
      ( wceq cpw pweq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    pweqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for power class.  (Contributed by NM,
       27-Nov-2013.) $)
    pweqd $p |- ( ph -> ~P A = ~P B ) $=
      ( wceq cpw pweq syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d A x $.  $d B x $.
    ${
      elpw.1 $e |- A e. _V $.
      $( Membership in a power class.  Theorem 86 of [Suppes] p. 47.
         (Contributed by NM, 31-Dec-1993.) $)
      elpw $p |- ( A e. ~P B <-> A C_ B ) $=
        ( vx cv wss cpw sseq1 df-pw elab2 ) DEZBFABFDABGCKABHDBIJ $.
    $}

    $( Membership in a power class.  Theorem 86 of [Suppes] p. 47.  See also
       ~ elpw2g .  (Contributed by NM, 6-Aug-2000.) $)
    elpwg $p |- ( A e. V -> ( A e. ~P B <-> A C_ B ) ) $=
      ( vx cv cpw wcel wss eleq1 sseq1 vex elpw vtoclbg ) DEZBFZGNBHAOGABHDACNA
      OINABJNBDKLM $.
  $}

  $( Subset relation implied by membership in a power class.  (Contributed by
     NM, 17-Feb-2007.) $)
  elpwi $p |- ( A e. ~P B -> A C_ B ) $=
    ( cpw wcel wss elpwg ibi ) ABCZDABEABHFG $.

  ${
    elpwid.1 $e |- ( ph -> A e. ~P B ) $.
    $( An element of a power class is a subclass.  Deduction form of ~ elpwi .
       (Contributed by David Moews, 1-May-2017.) $)
    elpwid $p |- ( ph -> A C_ B ) $=
      ( cpw wcel wss elpwi syl ) ABCEFBCGDBCHI $.
  $}

  $( If ` A ` belongs to a part of ` C ` then ` A ` belongs to ` C ` .
     (Contributed by FL, 3-Aug-2009.) $)
  elelpwi $p |- ( ( A e. B /\ B e. ~P C ) -> A e. C ) $=
    ( cpw wcel elpwi sseld impcom ) BCDEZABEACEIBCABCFGH $.

  ${
    $d y z A $.  $d x y z $.
    nfpw.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for power class.  (Contributed by NM,
       28-Oct-2003.)  (Revised by Mario Carneiro, 13-Oct-2016.) $)
    nfpw $p |- F/_ x ~P A $=
      ( vy cpw cv wss cab df-pw nfcv nfss nfab nfcxfr ) ABEDFZBGZDHDBIOADANBANJ
      CKLM $.
  $}

  $( Membership of the original in a power set.  (Contributed by Stefan O'Rear,
     1-Feb-2015.) $)
  pwidg $p |- ( A e. V -> A e. ~P A ) $=
    ( wcel cpw wss ssid elpwg mpbiri ) ABCAADCAAEAFAABGH $.

  ${
    pwid.1 $e |- A e. _V $.
    $( A set is a member of its power class.  Theorem 87 of [Suppes] p. 47.
       (Contributed by NM, 5-Aug-1993.) $)
    pwid $p |- A e. ~P A $=
      ( cvv wcel cpw pwidg ax-mp ) ACDAAEDBACFG $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass relationship for power class.  (Contributed by NM,
       21-Jun-2009.) $)
    pwss $p |- ( ~P A C_ B <-> A. x ( x C_ A -> x e. B ) ) $=
      ( cpw wss cv wcel wi wal dfss2 df-pw abeq2i imbi1i albii bitri ) BDZCEAFZ
      PGZQCGZHZAIQBEZSHZAIAPCJTUBARUASUAAPABKLMNO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Unordered and ordered pairs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbols needed. $)
  $c <. $.  $( Bracket (the period distinguishes it from 'less than') $)
  $c >. $.  $( Bracket (the period distinguishes it from 'greater than') $)

  $( Extend class notation to include singleton. $)
  csn $a class { A } $.
  $( Extend class notation to include unordered pair. $)
  cpr $a class { A , B } $.
  $( Extend class notation to include unordered triplet. $)
  ctp $a class { A , B , C } $.
  $( Extend class notation to include ordered pair. $)
  cop $a class <. A , B >. $.
  $( Extend class notation to include ordered triple. $)
  cotp $a class <. A , B , C >. $.

  ${
    $d x A $.  $d y A $.  $d z x $.  $d z y $.  $d z A $.
    $( Soundness justification theorem for ~ df-sn .  (Contributed by Rodolfo
       Medina, 28-Apr-2010.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    snjust $p |- { x | x = A } = { y | y = A } $=
      ( vz cv wceq cab eqeq1 cbvabv eqtri ) AEZCFZAGDEZCFZDGBEZCFZBGLNADKMCHINP
      DBMOCHIJ $.
  $}

  ${
    $d x A $.
    $( Define the singleton of a class.  Definition 7.1 of [Quine] p. 48.  For
       convenience, it is well-defined for proper classes, i.e., those that are
       not elements of ` _V ` , although it is not very meaningful in this
       case.  For an alternate definition see ~ dfsn2 .  (Contributed by NM,
       5-Aug-1993.) $)
    df-sn $a |- { A } = { x | x = A } $.
  $}

  $( Define unordered pair of classes.  Definition 7.1 of [Quine] p. 48.  For
     example, ` A e. { 1 , -u 1 } -> ( A ^ 2 ) = 1 ` ( ~ ex-pr ).  They are
     unordered, so ` { A , B } = { B , A } ` as proven by ~ prcom .  For a more
     traditional definition, but requiring a dummy variable, see ~ dfpr2 .
     (Contributed by NM, 5-Aug-1993.) $)
  df-pr $a |- { A , B } = ( { A } u. { B } ) $.

  $( Define unordered triple of classes.  Definition of [Enderton] p. 19.
     (Contributed by NM, 9-Apr-1994.) $)
  df-tp $a |- { A , B , C } = ( { A , B } u. { C } ) $.

  ${
    $d x A $.  $d x B $.
    $( Definition of an ordered pair, equivalent to Kuratowski's definition
       ` { { A } , { A , B } } ` when the arguments are sets.  Since the
       behavior of Kuratowski definition is not very useful for proper classes,
       we define it to be empty in this case (see ~ opprc1 , ~ opprc2 , and
       ~ 0nelop ).  For Kuratowski's actual definition when the arguments are
       sets, see ~ dfop .  For the justifying theorem (for sets) see ~ opth .
       See ~ dfopif for an equivalent formulation using the ` if ` operation.

       Definition 9.1 of [Quine] p. 58 defines an ordered pair unconditionally
       as ` <. A , B >. = { { A } , { A , B } } ` , which has different
       behavior from our ~ df-op when the arguments are proper classes.
       Ordinarily this difference is not important, since neither definition is
       meaningful in that case.  Our ~ df-op was chosen because it often makes
       proofs shorter by eliminating unnecessary sethood hypotheses.

       There are other ways to define ordered pairs.  The basic requirement is
       that two ordered pairs are equal iff their respective members are
       equal.  In 1914 Norbert Wiener gave the first successful definition
       ` <. A , B >. ` _2 ` = { { { A } , (/) } , { { B } } } ` , justified by
       ~ opthwiener .  This was simplified by Kazimierz Kuratowski in 1921 to
       our present definition.  An even simpler definition ` <. A , B >. ` _3
       ` = { A , { A , B } } ` is justified by ~ opthreg , but it requires the
       Axiom of Regularity for its justification and is not commonly used.  A
       definition that also works for proper classes is ` <. A , B >. ` _4
       ` = ( ( A X. { (/) } ) u. ( B X. { { (/) } } ) ) ` , justified by
       ~ opthprc .  If we restrict our sets to nonnegative integers, an ordered
       pair definition that involves only elementary arithmetic is provided by
       ~ nn0opthi .  Finally, an ordered pair of real numbers can be
       represented by a complex number as shown by ~ cru .  (Contributed by NM,
       28-May-1995.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    df-op $a |- <. A , B >. = { x |
      ( A e. _V /\ B e. _V /\ x e. { { A } , { A , B } } ) } $.
  $}

  $( Define ordered triple of classes.  Definition of ordered triple in [Stoll]
     p. 25.  (Contributed by NM, 3-Apr-2015.) $)
  df-ot $a |- <. A , B , C >. = <. <. A , B >. , C >. $.

  ${
    $d x A $.  $d x B $.
    $( Equality theorem for singletons.  Part of Exercise 4 of [TakeutiZaring]
       p. 15.  (Contributed by NM, 5-Aug-1993.) $)
    sneq $p |- ( A = B -> { A } = { B } ) $=
      ( vx wceq cv cab csn eqeq2 abbidv df-sn 3eqtr4g ) ABDZCEZADZCFMBDZCFAGBGL
      NOCABMHICAJCBJK $.
  $}

  ${
    sneqi.1 $e |- A = B $.
    $( Equality inference for singletons.  (Contributed by NM, 22-Jan-2004.) $)
    sneqi $p |- { A } = { B } $=
      ( wceq csn sneq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    sneqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for singletons.  (Contributed by NM, 22-Jan-2004.) $)
    sneqd $p |- ( ph -> { A } = { B } ) $=
      ( wceq csn sneq syl ) ABCEBFCFEDBCGH $.
  $}

  $( Alternate definition of singleton.  Definition 5.1 of [TakeutiZaring]
     p. 15.  (Contributed by NM, 24-Apr-1994.) $)
  dfsn2 $p |- { A } = { A , A } $=
    ( cpr csn cun df-pr unidm eqtr2i ) AABACZHDHAAEHFG $.

  ${
    $d x A $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15.  (Contributed by NM, 5-Aug-1993.) $)
    elsn $p |- ( x e. { A } <-> x = A ) $=
      ( cv wceq csn df-sn abeq2i ) ACBDABEABFG $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Alternate definition of unordered pair.  Definition 5.1 of
       [TakeutiZaring] p. 15.  (Contributed by NM, 24-Apr-1994.) $)
    dfpr2 $p |- { A , B } = { x | ( x = A \/ x = B ) } $=
      ( cpr csn cun cv wceq cab df-pr wcel elun elsn orbi12i bitri abbi2i eqtri
      wo ) BCDBEZCEZFZAGZBHZUBCHZRZAIBCJUEAUAUBUAKUBSKZUBTKZRUEUBSTLUFUCUGUDABM
      ACMNOPQ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( A member of an unordered pair of classes is one or the other of them.
       Exercise 1 of [TakeutiZaring] p. 15, generalized.  (Contributed by NM,
       13-Sep-1995.) $)
    elprg $p |- ( A e. V -> ( A e. { B , C } <-> ( A = B \/ A = C ) ) ) $=
      ( vx cv wceq wo cpr eqeq1 orbi12d dfpr2 elab2g ) EFZBGZNCGZHABGZACGZHEABC
      IDNAGOQPRNABJNACJKEBCLM $.
  $}

  ${
    elpr.1 $e |- A e. _V $.
    $( A member of an unordered pair of classes is one or the other of them.
       Exercise 1 of [TakeutiZaring] p. 15.  (Contributed by NM,
       13-Sep-1995.) $)
    elpr $p |- ( A e. { B , C } <-> ( A = B \/ A = C ) ) $=
      ( cvv wcel cpr wceq wo wb elprg ax-mp ) AEFABCGFABHACHIJDABCEKL $.
  $}

  ${
    elpr2.1 $e |- B e. _V $.
    elpr2.2 $e |- C e. _V $.
    $( A member of an unordered pair of classes is one or the other of them.
       Exercise 1 of [TakeutiZaring] p. 15.  (Contributed by NM,
       14-Oct-2005.) $)
    elpr2 $p |- ( A e. { B , C } <-> ( A = B \/ A = C ) ) $=
      ( cpr wcel wceq wo elprg ibi cvv wb eleq1 mpbiri jaoi syl ibir impbii ) A
      BCFZGZABHZACHZIZUAUDABCTJKUDUAUDALGZUAUDMUBUEUCUBUEBLGDABLNOUCUECLGEACLNO
      PABCLJQRS $.
  $}

  $( If a class is an element of a pair, then it is one of the two paired
     elements.  (Contributed by Scott Fenton, 1-Apr-2011.) $)
  elpri $p |- ( A e. { B , C } -> ( A = B \/ A = C ) ) $=
    ( cpr wcel wceq wo elprg ibi ) ABCDZEABFACFGABCJHI $.

  ${
    nelpri.1 $e |- A =/= B $.
    nelpri.2 $e |- A =/= C $.
    $( If an element doesn't match the items in an unordered pair, it is not in
       the unordered pair.  (Contributed by David A. Wheeler, 10-May-2015.) $)
    nelpri $p |- -. A e. { B , C } $=
      ( wne cpr wcel wn wa wceq wo neanior elpri con3i sylbi mp2an ) ABFZACFZAB
      CGHZIZDERSJABKACKLZIUAABACMTUBABCNOPQ $.
  $}

  ${
    $d A x $.  $d B x $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15 (generalized).  (Contributed by NM, 13-Sep-1995.)  (Proof
       shortened by Andrew Salmon, 29-Jun-2011.) $)
    elsncg $p |- ( A e. V -> ( A e. { B } <-> A = B ) ) $=
      ( vx cv wceq csn eqeq1 df-sn elab2g ) DEZBFABFDABGCKABHDBIJ $.
  $}

  ${
    elsnc.1 $e |- A e. _V $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15.  (Contributed by NM, 13-Sep-1995.) $)
    elsnc $p |- ( A e. { B } <-> A = B ) $=
      ( cvv wcel csn wceq wb elsncg ax-mp ) ADEABFEABGHCABDIJ $.
  $}

  $( There is only one element in a singleton.  (Contributed by NM,
     5-Jun-1994.) $)
  elsni $p |- ( A e. { B } -> A = B ) $=
    ( csn wcel wceq elsncg ibi ) ABCZDABEABHFG $.

  $( A set is a member of its singleton.  Part of Theorem 7.6 of [Quine]
     p. 49.  (Contributed by NM, 28-Oct-2003.) $)
  snidg $p |- ( A e. V -> A e. { A } ) $=
    ( wcel csn wceq eqid elsncg mpbiri ) ABCAADCAAEAFAABGH $.

  $( A class is a set iff it is a member of its singleton.  (Contributed by NM,
     5-Apr-2004.) $)
  snidb $p |- ( A e. _V <-> A e. { A } ) $=
    ( cvv wcel csn snidg elex impbii ) ABCAADZCABEAHFG $.

  ${
    snid.1 $e |- A e. _V $.
    $( A set is a member of its singleton.  Part of Theorem 7.6 of [Quine]
       p. 49.  (Contributed by NM, 31-Dec-1993.) $)
    snid $p |- A e. { A } $=
      ( cvv wcel csn snidb mpbi ) ACDAAEDBAFG $.
  $}

  $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
     p. 15.  This variation requires only that ` B ` , rather than ` A ` , be a
     set.  (Contributed by NM, 28-Oct-2003.) $)
  elsnc2g $p |- ( B e. V -> ( A e. { B } <-> A = B ) ) $=
    ( wcel csn wceq elsni snidg eleq1 syl5ibrcom impbid2 ) BCDZABEZDZABFZABGLNO
    BMDBCHABMIJK $.

  ${
    elsnc2.1 $e |- B e. _V $.
    $( There is only one element in a singleton.  Exercise 2 of [TakeutiZaring]
       p. 15.  This variation requires only that ` B ` , rather than ` A ` , be
       a set.  (Contributed by NM, 12-Jun-1994.) $)
    elsnc2 $p |- ( A e. { B } <-> A = B ) $=
      ( cvv wcel csn wceq wb elsnc2g ax-mp ) BDEABFEABGHCABDIJ $.
  $}

  ${
    $d A x $.  $d ps x $.
    $( Substitution expressed in terms of quantification over a singleton.
       (Contributed by Mario Carneiro, 23-Apr-2015.) $)
    ralsnsg $p |- ( A e. V -> ( A. x e. { A } ph <-> [. A / x ]. ph ) ) $=
      ( wcel wsbc cv wceq wal csn wral sbc6g df-ral imbi1i albii bitri syl6rbbr
      wi elsn ) CDEABCFBGZCHZARZBIZABCJZKZABCDLUETUDEZARZBIUCABUDMUGUBBUFUAABCS
      NOPQ $.

    $( Restricted existential quantification over a singleton.  (Contributed by
       Mario Carneiro, 23-Apr-2015.)  (Revised by NM, 22-Aug-2018.) $)
    rexsns $p |- ( E. x e. { A } ph <-> [. A / x ]. ph ) $=
      ( cv csn wcel wa wex wceq wrex wsbc elsn anbi1i exbii df-rex sbc5 3bitr4i
      ) BDZCEZFZAGZBHRCIZAGZBHABSJABCKUAUCBTUBABCLMNABSOABCPQ $.

    $( Restricted existential quantification over a singleton.  (Contributed by
       Mario Carneiro, 23-Apr-2015.)  Obsolete as of 22-Aug-2018.  Use ~ rexsns
       instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    rexsnsOLD $p |- ( A e. V -> ( E. x e. { A } ph <-> [. A / x ]. ph ) ) $=
      ( wcel wsbc cv wceq wa wex csn wrex wb sbc5 a1i df-rex anbi1i exbii bitri
      elsn syl6rbbr ) CDEZABCFZBGZCHZAIZBJZABCKZLZUCUGMUBABCNOUIUDUHEZAIZBJUGAB
      UHPUKUFBUJUEABCTQRSUA $.

    ralsng.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Substitution expressed in terms of quantification over a singleton.
       (Contributed by NM, 14-Dec-2005.)  (Revised by Mario Carneiro,
       23-Apr-2015.) $)
    ralsng $p |- ( A e. V -> ( A. x e. { A } ph <-> ps ) ) $=
      ( wcel csn wral wsbc ralsnsg sbcieg bitrd ) DEGACDHIACDJBACDEKABCDEFLM $.

    $( Restricted existential quantification over a singleton.  (Contributed by
       NM, 29-Jan-2012.) $)
    rexsng $p |- ( A e. V -> ( E. x e. { A } ph <-> ps ) ) $=
      ( wcel csn wrex wsbc rexsnsOLD sbcieg bitrd ) DEGACDHIACDJBACDEKABCDEFLM
      $.
  $}

  $( There is a set being the element of a singleton if and only if there is an
     element of the singleton.  (Contributed by Alexander van der Vekens,
     1-Jan-2018.) $)
  exsnrex $p |- ( E. x M = { x } <-> E. x e. M M = { x } ) $=
    ( cv csn wceq wex wcel wa wrex vex snid eleq2 mpbiri pm4.71ri df-rex bitr4i
    exbii ) BACZDZEZAFRBGZTHZAFTABITUBATUATUARSGRAJKBSRLMNQTABOP $.

  ${
    $d A x $.  $d ps x $.
    ralsn.1 $e |- A e. _V $.
    ralsn.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Convert a quantification over a singleton to a substitution.
       (Contributed by NM, 27-Apr-2009.) $)
    ralsn $p |- ( A. x e. { A } ph <-> ps ) $=
      ( cvv wcel csn wral wb ralsng ax-mp ) DGHACDIJBKEABCDGFLM $.

    $( Restricted existential quantification over a singleton.  (Contributed by
       Jeff Madsen, 5-Jan-2011.) $)
    rexsn $p |- ( E. x e. { A } ph <-> ps ) $=
      ( cvv wcel csn wrex wb rexsng ax-mp ) DGHACDIJBKEABCDGFLM $.
  $}

  ${
    $( Members of an unordered triple of classes.  (Contributed by FL,
       2-Feb-2014.)  (Proof shortened by Mario Carneiro, 11-Feb-2015.) $)
    eltpg $p |- ( A e. V -> ( A e. { B , C , D } <->
       ( A = B \/ A = C \/ A = D ) ) ) $=
      ( wcel cpr csn wo wceq ctp w3o elprg elsncg orbi12d cun df-tp eleq2i elun
      bitri df-3or 3bitr4g ) AEFZABCGZFZADHZFZIZABJZACJZIZADJZIABCDKZFZUIUJULLU
      CUEUKUGULABCEMADENOUNAUDUFPZFUHUMUOABCDQRAUDUFSTUIUJULUAUB $.
  $}

  ${
    $( A member of an unordered triple of classes is one of them.  (Contributed
       by Mario Carneiro, 11-Feb-2015.) $)
    eltpi $p |- ( A e. { B , C , D } -> ( A = B \/ A = C \/ A = D ) ) $=
      ( ctp wcel wceq w3o eltpg ibi ) ABCDEZFABGACGADGHABCDKIJ $.
  $}

  ${
    eltp.1 $e |- A e. _V $.
    $( A member of an unordered triple of classes is one of them.  Special case
       of Exercise 1 of [TakeutiZaring] p. 17.  (Contributed by NM,
       8-Apr-1994.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    eltp $p |- ( A e. { B , C , D } <-> ( A = B \/ A = C \/ A = D ) ) $=
      ( cvv wcel ctp wceq w3o wb eltpg ax-mp ) AFGABCDHGABIACIADIJKEABCDFLM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Alternate definition of unordered triple of classes.  Special case of
       Definition 5.3 of [TakeutiZaring] p. 16.  (Contributed by NM,
       8-Apr-1994.) $)
    dftp2 $p |- { A , B , C } = { x | ( x = A \/ x = B \/ x = C ) } $=
      ( cv wceq w3o ctp vex eltp abbi2i ) AEZBFLCFLDFGABCDHLBCDAIJK $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    nfpr.1 $e |- F/_ x A $.
    nfpr.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for unordered pairs.  (Contributed by
       NM, 14-Nov-1995.) $)
    nfpr $p |- F/_ x { A , B } $=
      ( vy cpr cv wceq wo cab dfpr2 nfeq2 nfor nfab nfcxfr ) ABCGFHZBIZQCIZJZFK
      FBCLTAFRSAAQBDMAQCEMNOP $.
  $}

  $( Membership of a conditional operator in an unordered pair.  (Contributed
     by NM, 17-Jun-2007.) $)
  ifpr $p |- ( ( A e. C /\ B e. D ) -> if ( ph , A , B ) e. { A , B } ) $=
    ( wcel cvv cif cpr elex wa ifcl wceq wo ifeqor elprg mpbiri syl syl2an ) BD
    FBGFZCGFZABCHZBCIFZCEFBDJCEJTUAKUBGFZUCABCGLUDUCUBBMUBCMNABCOUBBCGPQRS $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ps $.  $d x ch $.  $d x th $.
    ralprg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ralprg.2 $e |- ( x = B -> ( ph <-> ch ) ) $.
    $( Convert a quantification over a pair to a conjunction.  (Contributed by
       NM, 17-Sep-2011.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    ralprg $p |- ( ( A e. V /\ B e. W ) ->
      ( A. x e. { A , B } ph <-> ( ps /\ ch ) ) ) $=
      ( cpr wral csn wa wcel cun df-pr raleqi ralunb ralsng bi2anan9 syl5bb
      bitri ) ADEFKZLZADEMZLZADFMZLZNZEGOZFHOZNBCNUEADUFUHPZLUJADUDUMEFQRADUFUH
      SUCUKUGBULUICABDEGITACDFHJTUAUB $.

    $( Convert a quantification over a pair to a disjunction.  (Contributed by
       NM, 17-Sep-2011.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    rexprg $p |- ( ( A e. V /\ B e. W ) ->
      ( E. x e. { A , B } ph <-> ( ps \/ ch ) ) ) $=
      ( cpr wrex csn wo wcel wa cun df-pr rexeqi rexsng orbi1d orbi2d sylan9bb
      rexun bitri syl5bb ) ADEFKZLZADEMZLZADFMZLZNZEGOZFHOZPBCNZUHADUIUKQZLUMAD
      UGUQEFRSADUIUKUDUEUNUMBULNUOUPUNUJBULABDEGITUAUOULCBACDFHJTUBUCUF $.

    raltpg.3 $e |- ( x = C -> ( ph <-> th ) ) $.
    $( Convert a quantification over a triple to a conjunction.  (Contributed
       by NM, 17-Sep-2011.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    raltpg $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
      ( A. x e. { A , B , C } ph <-> ( ps /\ ch /\ th ) ) ) $=
      ( wcel w3a cpr wral csn wa ctp wb ralprg ralsng bi2anan9 3impa cun raleqi
      df-tp ralunb bitri df-3an 3bitr4g ) FIOZGJOZHKOZPAEFGQZRZAEHSZRZTZBCTZDTZ
      AEFGHUAZRZBCDPUNUOUPVAVCUBUNUOTURVBUPUTDABCEFGIJLMUCADEHKNUDUEUFVEAEUQUSU
      GZRVAAEVDVFFGHUIUHAEUQUSUJUKBCDULUM $.

    $( Convert a quantification over a triple to a disjunction.  (Contributed
       by Mario Carneiro, 23-Apr-2015.) $)
    rextpg $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
      ( E. x e. { A , B , C } ph <-> ( ps \/ ch \/ th ) ) ) $=
      ( wcel w3a cpr wrex csn wo ctp wb wa rexprg orbi1d rexsng orbi2d sylan9bb
      w3o 3impa cun df-tp rexeqi rexun bitri df-3or 3bitr4g ) FIOZGJOZHKOZPAEFG
      QZRZAEHSZRZTZBCTZDTZAEFGHUAZRZBCDUIURUSUTVEVGUBURUSUCZVEVFVDTUTVGVJVBVFVD
      ABCEFGIJLMUDUEUTVDDVFADEHKNUFUGUHUJVIAEVAVCUKZRVEAEVHVKFGHULUMAEVAVCUNUOB
      CDUPUQ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.  $d x ch $.
    ralpr.1 $e |- A e. _V $.
    ralpr.2 $e |- B e. _V $.
    ralpr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ralpr.4 $e |- ( x = B -> ( ph <-> ch ) ) $.
    $( Convert a quantification over a pair to a conjunction.  (Contributed by
       NM, 3-Jun-2007.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    ralpr $p |- ( A. x e. { A , B } ph <-> ( ps /\ ch ) ) $=
      ( cvv wcel cpr wral wa wb ralprg mp2an ) EKLFKLADEFMNBCOPGHABCDEFKKIJQR
      $.

    $( Convert an existential quantification over a pair to a disjunction.
       (Contributed by NM, 3-Jun-2007.)  (Revised by Mario Carneiro,
       23-Apr-2015.) $)
    rexpr $p |- ( E. x e. { A , B } ph <-> ( ps \/ ch ) ) $=
      ( cvv wcel cpr wrex wo wb rexprg mp2an ) EKLFKLADEFMNBCOPGHABCDEFKKIJQR
      $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ps $.  $d x ch $.  $d x th $.
    raltp.1 $e |- A e. _V $.
    raltp.2 $e |- B e. _V $.
    raltp.3 $e |- C e. _V $.
    raltp.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    raltp.5 $e |- ( x = B -> ( ph <-> ch ) ) $.
    raltp.6 $e |- ( x = C -> ( ph <-> th ) ) $.
    $( Convert a quantification over a triple to a conjunction.  (Contributed
       by NM, 13-Sep-2011.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    raltp $p |- ( A. x e. { A , B , C } ph <-> ( ps /\ ch /\ th ) ) $=
      ( cvv wcel ctp wral w3a wb raltpg mp3an ) FOPGOPHOPAEFGHQRBCDSTIJKABCDEFG
      HOOOLMNUAUB $.

    $( Convert a quantification over a triple to a disjunction.  (Contributed
       by Mario Carneiro, 23-Apr-2015.) $)
    rextp $p |- ( E. x e. { A , B , C } ph <-> ( ps \/ ch \/ th ) ) $=
      ( cvv wcel ctp wrex w3o wb rextpg mp3an ) FOPGOPHOPAEFGHQRBCDSTIJKABCDEFG
      HOOOLMNUAUB $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Substitution expressed in terms of quantification over a singleton.
       (Contributed by NM, 14-Dec-2005.)  (Revised by Mario Carneiro,
       23-Apr-2015.)  Obsolete as of 22-Aug-2018.  Use ~ ralsng instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcsngOLD $p |- ( A e. V -> ( [. A / x ]. ph <-> A. x e. { A } ph ) ) $=
      ( wcel csn wral wsbc ralsnsg bicomd ) CDEABCFGABCHABCDIJ $.
  $}

  ${
    nfsn.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for singletons.  (Contributed by NM,
       14-Nov-1995.) $)
    nfsn $p |- F/_ x { A } $=
      ( csn cpr dfsn2 nfpr nfcxfr ) ABDBBEBFABBCCGH $.
  $}

  ${
    $d A y $.  $d B y $.  $d V y $.  $d x y $.
    $( Distribute proper substitution through the singleton of a class.
       ~ csbsng is derived from the virtual deduction proof ~ csbsngVD .
       (Contributed by Alan Sare, 10-Nov-2012.) $)
    csbsng $p |- ( A e. V -> [_ A / x ]_ { B } = { [_ A / x ]_ B } ) $=
      ( vy wcel wceq cab csb csn wsbc csbab sbceq2g abbidv syl5eq df-sn csbeq2i
      cv 3eqtr4g ) BDFZABERZCGZEHZIZUAABCIZGZEHZABCJZIUEJTUDUBABKZEHUGUBAEBLTUI
      UFEABUACDMNOABUHUCECPQEUEPS $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Intersection with the singleton of a non-member is disjoint.
       (Contributed by NM, 22-May-1998.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.)  (Proof shortened by Wolf Lammen, 30-Sep-2014.) $)
    disjsn $p |- ( ( A i^i { B } ) = (/) <-> -. B e. A ) $=
      ( vx csn cin c0 wceq cv wcel wn wi wal wa disj1 con2b imbi1i imnan 3bitri
      elsn albii wex alnex df-clel xchbinxr ) ABDZEFGCHZAIZUFUEIZJKZCLUFBGZUGMZ
      JZCLZBAIZJCAUENUIULCUIUHUGJZKUJUOKULUGUHOUHUJUOCBSPUJUGQRTUMUKCUAUNUKCUBC
      BAUCUDR $.
  $}

  $( Intersection of distinct singletons is disjoint.  (Contributed by NM,
     25-May-1998.) $)
  disjsn2 $p |- ( A =/= B -> ( { A } i^i { B } ) = (/) ) $=
    ( wne csn wcel wn cin c0 wceq elsni eqcomd necon3ai disjsn sylibr ) ABCBADZ
    EZFOBDGHIPABPBABAJKLOBMN $.

  $( The intersection of distinct unordered pairs is disjoint.  (Contributed by
     Alexander van der Vekens, 11-Nov-2017.) $)
  disjpr2 $p |- ( ( ( A =/= C /\ B =/= C ) /\ ( A =/= D /\ B =/= D ) )
                  -> ( { A , B } i^i { C , D } ) = (/) ) $=
    ( wne wa cpr cin csn c0 wceq df-pr ineq1i indir eqtri disjsn2 adantr adantl
    cun syl5eq a1i ineq2d indi jca un00 sylib uneq12d un0 syl6eq eqtrd ) ACEZBC
    EZFZADEZBDEZFZFZABGZCDGZHURCIZDIZSZHZJUQUSVBURUSVBKUQCDLUAUBUQVCURUTHZURVAH
    ZSZJURUTVAUCUQVFJJSJUQVDJVEJUQVDAIZUTHZBIZUTHZSZJVDVGVISZUTHVKURVLUTABLZMVG
    VIUTNOUQVHJKZVJJKZFVKJKUQVNVOUMVNUPUKVNULACPQQUMVOUPULVOUKBCPRQUDVHVJUEUFTU
    QVEVGVAHZVIVAHZSZJVEVLVAHVRURVLVAVMMVGVIVANOUQVPJKZVQJKZFVRJKUQVSVTUPVSUMUN
    VSUOADPQRUPVTUMUOVTUNBDPRRUDVPVQUEUFTUGJUHUITUJ $.

  ${
    $d x A $.
    $( The singleton of a proper class (one that doesn't exist) is the empty
       set.  Theorem 7.2 of [Quine] p. 48.  (Contributed by NM, 5-Aug-1993.) $)
    snprc $p |- ( -. A e. _V <-> { A } = (/) ) $=
      ( vx csn c0 wceq cvv wcel cv wex wn elsn exbii neq0 isset 3bitr4i con1bii
      ) ACZDEZAFGZBHZQGZBITAEZBIRJSUAUBBBAKLBQMBANOP $.
  $}

  ${
    $d x y A $.  $d x B $.
    r19.12sn.1 $e |- A e. _V $.
    $( Special case of ~ r19.12 where its converse holds.  (Contributed by NM,
       19-May-2008.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    r19.12sn $p |- ( E. x e. { A } A. y e. B ph
                <-> A. y e. B E. x e. { A } ph ) $=
      ( cvv wcel wral csn wrex wb wsbc sbcralg rexsnsOLD ralbidv 3bitr4d ax-mp
      ) DGHZACEIZBDJZKZABUAKZCEIZLFSTBDMABDMZCEIUBUDABCDEGNTBDGOSUCUECEABDGOPQR
      $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Condition where a restricted class abstraction is a singleton.
       (Contributed by NM, 28-May-2006.) $)
    rabsn $p |- ( B e. A -> { x e. A | x = B } = { B } ) $=
      ( wcel cv wceq wa cab crab csn eleq1 pm5.32ri abbidv df-rab df-sn 3eqtr4g
      baib ) CBDZAEZBDZSCFZGZAHUAAHUAABICJRUBUAAUBRUAUATRSCBKLQMUAABNACOP $.
  $}

  ${
    $d x A $.  $d y ph $.
    $( A restricted class abstraction restricted to a singleton is either the
       empty set or the singleton itself.  (Contributed by Alexander van der
       Vekens, 22-Dec-2017.) $)
    rabrsn $p |- ( M = { x e. { A } | ph } -> ( M = (/) \/ M = { A } ) ) $=
      ( csn crab wceq c0 wo cvv wcel wn wral wsbc ralsnsg orbi12d mpbird wb a1i
      eqeq1 pm2.1 sbcth sbcor sylib rabeq0 eqcom rabid2 bitri snprc rab0 syl6eq
      rabeq orcd sylbi pm2.61i ) DABCEZFZGZDHGZDUPGZIUQHGZUQUPGZIZVCURCJKZVCVDV
      CALZBUPMZABUPMZIZVDVHVEBCNZABCNZIZVDVEAIZBCNVKVLBCJAUAUBVEABCUCUDVDVFVIVG
      VJVEBCJOABCJOPQVDVAVFVBVGVAVFRVDABUPUESVBVGRVDVBUPUQGVGUQUPUFABUPUGUHSPQV
      DLUPHGZVCCUIVMVAVBVMUQABHFHABUPHULABUJUKUMUNUOSURUSVAUTVBDUQHTDUQUPTPQ $.
  $}

  ${
    $d x y $.  $d y ph $.  $d y A $.
    $( Another way to express existential uniqueness of a wff: its class
       abstraction is a singleton.  (Contributed by Mario Carneiro,
       14-Nov-2016.) $)
    euabsn2 $p |- ( E! x ph <-> E. y { x | ph } = { y } ) $=
      ( weu cv wceq wb wal wex cab csn df-eu wcel abeq1 elsn bibi2i albii bitri
      exbii bitr4i ) ABDABEZCEZFZGZBHZCIABJUBKZFZCIABCLUGUECUGAUAUFMZGZBHUEABUF
      NUIUDBUHUCABUBOPQRST $.

    $( Another way to express existential uniqueness of a wff: its class
       abstraction is a singleton.  (Contributed by NM, 22-Feb-2004.) $)
    euabsn $p |- ( E! x ph <-> E. x { x | ph } = { x } ) $=
      ( vy weu cab cv csn wceq wex euabsn2 nfab1 nfeq1 sneq eqeq2d cbvex bitr4i
      nfv ) ABDABEZCFZGZHZCIRBFZGZHZBIABCJUDUABCUDCQBRTABKLUBSHUCTRUBSMNOP $.

    $( A way to express restricted existential uniqueness of a wff: its
       restricted class abstraction is a singleton.  (Contributed by NM,
       30-May-2006.)  (Proof shortened by Mario Carneiro, 14-Nov-2016.) $)
    reusn $p |- ( E! x e. A ph <-> E. y { x e. A | ph } = { y } ) $=
      ( cv wcel wa weu cab csn wceq wex wreu euabsn2 df-reu df-rab eqeq1i exbii
      crab 3bitr4i ) BEDFAGZBHUABIZCEJZKZCLABDMABDSZUCKZCLUABCNABDOUFUDCUEUBUCA
      BDPQRT $.

    $( Restricted existential uniqueness determined by a singleton.
       (Contributed by NM, 29-May-2006.) $)
    absneu $p |- ( ( A e. V /\ { x | ph } = { A } ) -> E! x ph ) $=
      ( vy wcel cab csn wceq wa wex weu sneq eqeq2d spcegv imp euabsn2 sylibr
      cv ) CDFZABGZCHZIZJUAESZHZIZEKZABLTUCUGUFUCECDUDCIUEUBUAUDCMNOPABEQR $.

    $( Restricted existential uniqueness determined by a singleton.
       (Contributed by NM, 29-May-2006.)  (Revised by Mario Carneiro,
       23-Dec-2016.) $)
    rabsneu $p |- ( ( A e. V /\ { x e. B | ph } = { A } ) -> E! x e. B ph ) $=
      ( wcel crab csn wceq wa cv weu df-rab eqeq1i absneu sylan2b df-reu sylibr
      wreu cab ) CEFZABDGZCHZIZJBKDFAJZBLZABDSUDUAUEBTZUCIUFUBUGUCABDMNUEBCEOPA
      BDQR $.
  $}

  ${
    $d x A $.
    $( Two ways to express " ` A ` is a singleton."  (Contributed by NM,
       30-Oct-2010.) $)
    eusn $p |- ( E! x x e. A <-> E. x A = { x } ) $=
      ( cv wcel weu cab csn wceq wex euabsn abid2 eqeq1i exbii bitri ) ACZBDZAE
      PAFZOGZHZAIBRHZAIPAJSTAQBRABKLMN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    rabsnt.1 $e |- B e. _V $.
    rabsnt.2 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Truth implied by equality of a restricted class abstraction and a
       singleton.  (Contributed by NM, 29-May-2006.)  (Proof shortened by Mario
       Carneiro, 23-Dec-2016.) $)
    rabsnt $p |- ( { x e. A | ph } = { B } -> ps ) $=
      ( crab csn wceq wcel snid id syl5eleqr elrab simprbi syl ) ACDHZEIZJZERKZ
      BTESREFLTMNUAEDKBABCEDGOPQ $.
  $}

  $( Commutative law for unordered pairs.  (Contributed by NM, 5-Aug-1993.) $)
  prcom $p |- { A , B } = { B , A } $=
    ( csn cun cpr uncom df-pr 3eqtr4i ) ACZBCZDJIDABEBAEIJFABGBAGH $.

  $( Equality theorem for unordered pairs.  (Contributed by NM,
     29-Mar-1998.) $)
  preq1 $p |- ( A = B -> { A , C } = { B , C } ) $=
    ( wceq csn cun cpr sneq uneq1d df-pr 3eqtr4g ) ABDZAEZCEZFBEZNFACGBCGLMONAB
    HIACJBCJK $.

  $( Equality theorem for unordered pairs.  (Contributed by NM, 5-Aug-1993.) $)
  preq2 $p |- ( A = B -> { C , A } = { C , B } ) $=
    ( wceq cpr preq1 prcom 3eqtr4g ) ABDACEBCECAECBEABCFCAGCBGH $.

  $( Equality theorem for unordered pairs.  (Contributed by NM,
     19-Oct-2012.) $)
  preq12 $p |- ( ( A = C /\ B = D ) -> { A , B } = { C , D } ) $=
    ( wceq cpr preq1 preq2 sylan9eq ) ACEBDEABFCBFCDFACBGBDCHI $.

  ${
    preq1i.1 $e |- A = B $.
    $( Equality inference for unordered pairs.  (Contributed by NM,
       19-Oct-2012.) $)
    preq1i $p |- { A , C } = { B , C } $=
      ( wceq cpr preq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality inference for unordered pairs.  (Contributed by NM,
       19-Oct-2012.) $)
    preq2i $p |- { C , A } = { C , B } $=
      ( wceq cpr preq2 ax-mp ) ABECAFCBFEDABCGH $.

    ${
      preq12i.2 $e |- C = D $.
      $( Equality inference for unordered pairs.  (Contributed by NM,
         19-Oct-2012.) $)
      preq12i $p |- { A , C } = { B , D } $=
        ( wceq cpr preq12 mp2an ) ABGCDGACHBDHGEFACBDIJ $.
    $}
  $}

  ${
    preq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for unordered pairs.  (Contributed by NM,
       19-Oct-2012.) $)
    preq1d $p |- ( ph -> { A , C } = { B , C } ) $=
      ( wceq cpr preq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality deduction for unordered pairs.  (Contributed by NM,
       19-Oct-2012.) $)
    preq2d $p |- ( ph -> { C , A } = { C , B } ) $=
      ( wceq cpr preq2 syl ) ABCFDBGDCGFEBCDHI $.

    preq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for unordered pairs.  (Contributed by NM,
       19-Oct-2012.) $)
    preq12d $p |- ( ph -> { A , C } = { B , D } ) $=
      ( wceq cpr preq12 syl2anc ) ABCHDEHBDICEIHFGBDCEJK $.
  $}

  $( Equality theorem for unordered triples.  (Contributed by NM,
     13-Sep-2011.) $)
  tpeq1 $p |- ( A = B -> { A , C , D } = { B , C , D } ) $=
    ( wceq cpr csn cun ctp preq1 uneq1d df-tp 3eqtr4g ) ABEZACFZDGZHBCFZPHACDIB
    CDINOQPABCJKACDLBCDLM $.

  $( Equality theorem for unordered triples.  (Contributed by NM,
     13-Sep-2011.) $)
  tpeq2 $p |- ( A = B -> { C , A , D } = { C , B , D } ) $=
    ( wceq cpr csn cun ctp preq2 uneq1d df-tp 3eqtr4g ) ABEZCAFZDGZHCBFZPHCADIC
    BDINOQPABCJKCADLCBDLM $.

  $( Equality theorem for unordered triples.  (Contributed by NM,
     13-Sep-2011.) $)
  tpeq3 $p |- ( A = B -> { C , D , A } = { C , D , B } ) $=
    ( wceq cpr csn cun ctp sneq uneq2d df-tp 3eqtr4g ) ABEZCDFZAGZHOBGZHCDAICDB
    INPQOABJKCDALCDBLM $.

  ${
    tpeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for unordered triples.  (Contributed by NM,
       22-Jun-2014.) $)
    tpeq1d $p |- ( ph -> { A , C , D } = { B , C , D } ) $=
      ( wceq ctp tpeq1 syl ) ABCGBDEHCDEHGFBCDEIJ $.

    $( Equality theorem for unordered triples.  (Contributed by NM,
       22-Jun-2014.) $)
    tpeq2d $p |- ( ph -> { C , A , D } = { C , B , D } ) $=
      ( wceq ctp tpeq2 syl ) ABCGDBEHDCEHGFBCDEIJ $.

    $( Equality theorem for unordered triples.  (Contributed by NM,
       22-Jun-2014.) $)
    tpeq3d $p |- ( ph -> { C , D , A } = { C , D , B } ) $=
      ( wceq ctp tpeq3 syl ) ABCGDEBHDECHGFBCDEIJ $.

    tpeq123d.2 $e |- ( ph -> C = D ) $.
    tpeq123d.3 $e |- ( ph -> E = F ) $.
    $( Equality theorem for unordered triples.  (Contributed by NM,
       22-Jun-2014.) $)
    tpeq123d $p |- ( ph -> { A , C , E } = { B , D , F } ) $=
      ( ctp tpeq1d tpeq2d tpeq3d 3eqtrd ) ABDFKCDFKCEFKCEGKABCDFHLADECFIMAFGCEJ
      NO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Rotation of the elements of an unordered triple.  (Contributed by Alan
       Sare, 24-Oct-2011.) $)
    tprot $p |- { A , B , C } = { B , C , A } $=
      ( vx cv wceq w3o cab ctp 3orrot abbii dftp2 3eqtr4i ) DEZAFZNBFZNCFZGZDHP
      QOGZDHABCIBCAIRSDOPQJKDABCLDBCALM $.
  $}

  $( Swap 1st and 2nd members of an undordered triple.  (Contributed by NM,
     22-May-2015.) $)
  tpcoma $p |- { A , B , C } = { B , A , C } $=
    ( cpr csn cun ctp prcom uneq1i df-tp 3eqtr4i ) ABDZCEZFBADZMFABCGBACGLNMABH
    IABCJBACJK $.

  $( Swap 2nd and 3rd members of an undordered triple.  (Contributed by NM,
     22-May-2015.) $)
  tpcomb $p |- { A , B , C } = { A , C , B } $=
    ( ctp tpcoma tprot 3eqtr4i ) BCADCBADABCDACBDBCAEABCFACBFG $.

  $( Split off the first element of an unordered triple.  (Contributed by Mario
     Carneiro, 5-Jan-2016.) $)
  tpass $p |- { A , B , C } = ( { A } u. { B , C } ) $=
    ( ctp cpr csn cun df-tp tprot uncom 3eqtr4i ) BCADBCEZAFZGABCDMLGBCAHABCIML
    JK $.

  $( Two ways to write an unordered quadruple.  (Contributed by Mario Carneiro,
     5-Jan-2016.) $)
  qdass $p |- ( { A , B } u. { C , D } ) = ( { A , B , C } u. { D } ) $=
    ( cpr csn cun ctp unass df-tp uneq1i df-pr uneq2i 3eqtr4ri ) ABEZCFZGZDFZGO
    PRGZGABCHZRGOCDEZGOPRITQRABCJKUASOCDLMN $.

  $( Two ways to write an unordered quadruple.  (Contributed by Mario Carneiro,
     5-Jan-2016.) $)
  qdassr $p |- ( { A , B } u. { C , D } ) = ( { A } u. { B , C , D } ) $=
    ( csn cun cpr ctp unass df-pr uneq1i tpass uneq2i 3eqtr4i ) AEZBEZFZCDGZFOP
    RFZFABGZRFOBCDHZFOPRITQRABJKUASOBCDLMN $.

  $( Unordered triple ` { A , A , B } ` is just an overlong way to write
     ` { A , B } ` .  (Contributed by David A. Wheeler, 10-May-2015.) $)
  tpidm12 $p |- { A , A , B } = { A , B } $=
    ( csn cun cpr ctp dfsn2 uneq1i df-pr df-tp 3eqtr4ri ) ACZBCZDAAEZMDABEAABFL
    NMAGHABIAABJK $.

  $( Unordered triple ` { A , B , A } ` is just an overlong way to write
     ` { A , B } ` .  (Contributed by David A. Wheeler, 10-May-2015.) $)
  tpidm13 $p |- { A , B , A } = { A , B } $=
    ( ctp cpr tprot tpidm12 eqtr3i ) AABCABACABDAABEABFG $.

  $( Unordered triple ` { A , B , B } ` is just an overlong way to write
     ` { A , B } ` .  (Contributed by David A. Wheeler, 10-May-2015.) $)
  tpidm23 $p |- { A , B , B } = { A , B } $=
    ( ctp cpr tprot tpidm12 prcom 3eqtri ) ABBCBBACBADABDABBEBAFBAGH $.

  $( Unordered triple ` { A , A , A } ` is just an overlong way to write
     ` { A } ` .  (Contributed by David A. Wheeler, 10-May-2015.) $)
  tpidm $p |- { A , A , A } = { A } $=
    ( ctp cpr csn tpidm12 dfsn2 eqtr4i ) AAABAACADAAEAFG $.

  $( An unordered triple is an unordered pair if one of its elements is
     identical with another element.  (Contributed by Alexander van der Vekens,
     6-Oct-2017.) $)
  tppreq3 $p |- ( B = C -> { A , B , C } = { A , B } ) $=
    ( wceq ctp cpr tpeq3 eqcoms tpidm23 syl6eq ) BCDABCEZABBEZABFKLDCBCBABGHABI
    J $.

  $( An unordered pair contains its first member.  Part of Theorem 7.6 of
     [Quine] p. 49.  (Contributed by Stefan Allan, 8-Nov-2008.) $)
  prid1g $p |- ( A e. V -> A e. { A , B } ) $=
    ( wcel cpr wceq wo eqid orci elprg mpbiri ) ACDAABEDAAFZABFZGLMAHIAABCJK $.

  $( An unordered pair contains its second member.  Part of Theorem 7.6 of
     [Quine] p. 49.  (Contributed by Stefan Allan, 8-Nov-2008.) $)
  prid2g $p |- ( B e. V -> B e. { A , B } ) $=
    ( wcel cpr prid1g prcom syl6eleq ) BCDBBAEABEBACFBAGH $.

  ${
    prid1.1 $e |- A e. _V $.
    $( An unordered pair contains its first member.  Part of Theorem 7.6 of
       [Quine] p. 49.  (Contributed by NM, 5-Aug-1993.) $)
    prid1 $p |- A e. { A , B } $=
      ( cvv wcel cpr prid1g ax-mp ) ADEAABFECABDGH $.
  $}

  ${
    prid2.1 $e |- B e. _V $.
    $( An unordered pair contains its second member.  Part of Theorem 7.6 of
       [Quine] p. 49.  (Contributed by NM, 5-Aug-1993.) $)
    prid2 $p |- B e. { A , B } $=
      ( cpr prid1 prcom eleqtri ) BBADABDBACEBAFG $.
  $}

  $( A proper class vanishes in an unordered pair.  (Contributed by NM,
     5-Aug-1993.) $)
  prprc1 $p |- ( -. A e. _V -> { A , B } = { B } ) $=
    ( cvv wcel wn csn c0 wceq cpr snprc cun uneq1 df-pr uncom un0 3eqtr4g sylbi
    eqtr2i ) ACDEAFZGHZABIZBFZHAJTSUBKGUBKZUAUBSGUBLABMUCUBGKUBGUBNUBORPQ $.

  $( A proper class vanishes in an unordered pair.  (Contributed by NM,
     22-Mar-2006.) $)
  prprc2 $p |- ( -. B e. _V -> { A , B } = { A } ) $=
    ( cvv wcel wn cpr csn prcom prprc1 syl5eq ) BCDEABFBAFAGABHBAIJ $.

  $( An unordered pair containing two proper classes is the empty set.
     (Contributed by NM, 22-Mar-2006.) $)
  prprc $p |- ( ( -. A e. _V /\ -. B e. _V ) -> { A , B } = (/) ) $=
    ( cvv wcel wn cpr csn c0 prprc1 wceq snprc biimpi sylan9eq ) ACDEBCDEZABFBG
    ZHABINOHJBKLM $.

  ${
    tpid1.1 $e |- A e. _V $.
    $( One of the three elements of an unordered triple.  (Contributed by NM,
       7-Apr-1994.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    tpid1 $p |- A e. { A , B , C } $=
      ( ctp wcel wceq w3o eqid 3mix1i eltp mpbir ) AABCEFAAGZABGZACGZHMNOAIJAAB
      CDKL $.
  $}

  ${
    tpid2.1 $e |- B e. _V $.
    $( One of the three elements of an unordered triple.  (Contributed by NM,
       7-Apr-1994.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    tpid2 $p |- B e. { A , B , C } $=
      ( ctp wcel wceq w3o eqid 3mix2i eltp mpbir ) BABCEFBAGZBBGZBCGZHNMOBIJBAB
      CDKL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x ps $.
    $( Closed theorem form of ~ tpid3 .  This proof was automatically generated
       from the virtual deduction proof ~ tpid3gVD using a translation
       program.  (Contributed by Alan Sare, 24-Oct-2011.) $)
    tpid3g $p |- ( A e. B -> A e. { C , D , A } ) $=
      ( vx wcel cv wceq wex ctp elisset w3o cab wi 3mix3 a1i abid syl6ibr dftp2
      eleq2i eleq1 mpbidi exlimdv mpd ) ABFZEGZAHZEIACDAJZFZEABKUEUGUIEUGUFUHFZ
      UIUEUEUGUFUFCHZUFDHZUGLZEMZFZUJUEUGUMUOUGUMNUEUGUKULOPUMEQRUHUNUFECDASTRU
      FAUHUAUBUCUD $.
  $}

  ${
    tpid3.1 $e |- C e. _V $.
    $( One of the three elements of an unordered triple.  (Contributed by NM,
       7-Apr-1994.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    tpid3 $p |- C e. { A , B , C } $=
      ( ctp wcel wceq w3o eqid 3mix3i eltp mpbir ) CABCEFCAGZCBGZCCGZHOMNCIJCAB
      CDKL $.
  $}

  $( The singleton of a set is not empty.  (Contributed by NM, 14-Dec-2008.) $)
  snnzg $p |- ( A e. V -> { A } =/= (/) ) $=
    ( wcel csn c0 wne snidg ne0i syl ) ABCAADZCJEFABGJAHI $.

  ${
    snnz.1 $e |- A e. _V $.
    $( The singleton of a set is not empty.  (Contributed by NM,
       10-Apr-1994.) $)
    snnz $p |- { A } =/= (/) $=
      ( cvv wcel csn c0 wne snnzg ax-mp ) ACDAEFGBACHI $.
  $}

  ${
    prnz.1 $e |- A e. _V $.
    $( A pair containing a set is not empty.  (Contributed by NM,
       9-Apr-1994.) $)
    prnz $p |- { A , B } =/= (/) $=
      ( cpr wcel c0 wne prid1 ne0i ax-mp ) AABDZEKFGABCHKAIJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A pair containing a set is not empty.  (Contributed by FL,
       19-Sep-2011.) $)
    prnzg $p |- ( A e. V -> { A , B } =/= (/) ) $=
      ( vx cv cpr c0 wne wceq preq1 neeq1d vex prnz vtoclg ) DEZBFZGHABFZGHDACO
      AIPQGOABJKOBDLMN $.
  $}

  ${
    tpnz.1 $e |- A e. _V $.
    $( A triplet containing a set is not empty.  (Contributed by NM,
       10-Apr-1994.) $)
    tpnz $p |- { A , B , C } =/= (/) $=
      ( ctp wcel c0 wne tpid1 ne0i ax-mp ) AABCEZFLGHABCDILAJK $.
  $}

  ${
    $d A x $.  $d B x $.
    snss.1 $e |- A e. _V $.
    $( The singleton of an element of a class is a subset of the class.
       Theorem 7.4 of [Quine] p. 49.  (Contributed by NM, 5-Aug-1993.) $)
    snss $p |- ( A e. B <-> { A } C_ B ) $=
      ( vx cv csn wcel wi wal wceq wss elsn imbi1i albii dfss2 clel2 3bitr4ri )
      DEZAFZGZRBGZHZDIRAJZUAHZDISBKABGUBUDDTUCUADALMNDSBODABCPQ $.
  $}

  $( Membership in a set with an element removed.  (Contributed by NM,
     10-Oct-2007.) $)
  eldifsn $p |- ( A e. ( B \ { C } ) <-> ( A e. B /\ A =/= C ) ) $=
    ( csn cdif wcel wn wa wne eldif elsncg necon3bbid pm5.32i bitri ) ABCDZEFAB
    FZAOFZGZHPACIZHABOJPRSPQACACBKLMN $.

  $( Membership in a set with an element removed.  (Contributed by NM,
     10-Mar-2015.) $)
  eldifsni $p |- ( A e. ( B \ { C } ) -> A =/= C ) $=
    ( csn cdif wcel wne eldifsn simprbi ) ABCDEFABFACGABCHI $.

  $( ` A ` is not in ` ( B \ { A } ) ` .  (Contributed by David Moews,
     1-May-2017.) $)
  neldifsn $p |- -. A e. ( B \ { A } ) $=
    ( csn cdif wcel wne neirr eldifsni mto ) ABACDEAAFAGABAHI $.

  $( ` A ` is not in ` ( B \ { A } ) ` .  Deduction form.  (Contributed by
     David Moews, 1-May-2017.) $)
  neldifsnd $p |- ( ph -> -. A e. ( B \ { A } ) ) $=
    ( csn cdif wcel wn neldifsn a1i ) BCBDEFGABCHI $.

  $( Restricted existential quantification over a set with an element removed.
     (Contributed by NM, 4-Feb-2015.) $)
  rexdifsn $p |- ( E. x e. ( A \ { B } ) ph
      <-> E. x e. A ( x =/= B /\ ph ) ) $=
    ( cv wne wa csn cdif wcel eldifsn anbi1i anass bitri rexbii2 ) ABEZDFZAGZBC
    DHIZCPSJZAGPCJZQGZAGUARGTUBAPCDKLUAQAMNO $.

  ${
    $d A x $.  $d B x $.
    $( The singleton of an element of a class is a subset of the class.
       Theorem 7.4 of [Quine] p. 49.  (Contributed by NM, 22-Jul-2001.) $)
    snssg $p |- ( A e. V -> ( A e. B <-> { A } C_ B ) ) $=
      ( vx cv wcel csn wss eleq1 wceq sneq sseq1d vex snss vtoclbg ) DEZBFPGZBH
      ABFAGZBHDACPABIPAJQRBPAKLPBDMNO $.

    $( An element not in a set can be removed without affecting the set.
       (Contributed by NM, 16-Mar-2006.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    difsn $p |- ( -. A e. B -> ( B \ { A } ) = B ) $=
      ( vx wcel wn csn cdif cv wne wa eldifsn simpl wceq eleq1 biimpcd necon3bd
      com12 ancld impbid2 syl5bb eqrdv ) ABDZEZCBAFGZBCHZUDDUEBDZUEAIZJZUCUFUEB
      AKUCUHUFUFUGLUCUFUGUFUCUGUFUBUEAUEAMUFUBUEABNOPQRSTUA $.

    $( Removal of a singleton from an unordered pair.  (Contributed by NM,
       16-Mar-2006.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    difprsnss $p |- ( { A , B } \ { A } ) C_ { B } $=
      ( vx cpr csn cdif cv wcel wn wa wceq wo elpr elsn notbii biimparc syl2anb
      vex biorf eldif 3imtr4i ssriv ) CABDZAEZFZBEZCGZUCHZUGUDHZIZJUGBKZUGUEHUG
      UFHUHUGAKZUKLZULIZUKUJUGABCRMUIULCANOUNUKUMULUKSPQUGUCUDTCBNUAUB $.
  $}

  $( Removal of a singleton from an unordered pair.  (Contributed by Thierry
     Arnoux, 4-Feb-2017.) $)
  difprsn1 $p |- ( A =/= B -> ( { A , B } \ { A } ) = { B } ) $=
    ( wne cpr csn cdif wceq necom cin c0 disjsn2 disj3 sylib cun df-pr equncomi
    difeq1i difun2 eqtri syl6reqr sylbir ) ABCBACZABDZAEZFZBEZGBAHUBUFUFUDFZUEU
    BUFUDIJGUFUGGBAKUFUDLMUEUFUDNZUDFUGUCUHUDUCUDUFABOPQUFUDRSTUA $.

  $( Removal of a singleton from an unordered pair.  (Contributed by Alexander
     van der Vekens, 5-Oct-2017.) $)
  difprsn2 $p |- ( A =/= B -> ( { A , B } \ { B } ) = { A } ) $=
    ( wne cpr csn cdif prcom difeq1i wceq necom difprsn1 sylbi syl5eq ) ABCZABD
    ZBEZFBADZPFZAEZOQPABGHNBACRSIABJBAKLM $.

  $( Removal of a singleton from an unordered triple.  (Contributed by
     Alexander van der Vekens, 5-Oct-2017.) $)
  diftpsn3 $p |- ( ( A =/= C /\ B =/= C )
                    -> ( { A , B , C } \ { C } ) = { A , B } ) $=
    ( wne wa ctp csn cdif cpr cun a1i c0 cin necom disjsn2 sylbi uneq12d syl6eq
    wceq 3eqtrd df-tp difeq1d df-pr ineq1d incom indi eqtri adantr adantl unidm
    difundir disj3 sylib eqcomd difid un0 ) ACDZBCDZEZABCFZCGZHABIZVAJZVAHZVBVA
    HZVAVAHZJZVBUSUTVCVAUTVCSUSABCUAKUBVDVGSUSVBVAVAUKKUSVGVBLJVBUSVEVBVFLUSVBV
    EUSVBVAMZLSVBVESUSVHAGZBGZJZVAMZVAVIMZVAVJMZJZLUSVBVKVAVBVKSUSABUCKUDVLVOSU
    SVLVAVKMVOVKVAUEVAVIVJUFUGKUSVOLLJLUSVMLVNLUQVMLSZURUQCADVPACNCAOPUHURVNLSZ
    UQURCBDVQBCNCBOPUIQLUJRTVBVAULUMUNVFLSUSVAUOKQVBUPRT $.

  $( An unordered triple is an unordered pair if one of its elemets is a proper
     class or is identical with another element.  (Contributed by Alexander van
     der Vekens, 6-Oct-2017.) $)
  tpprceq3 $p |- ( -. ( C e. _V /\ C =/= B ) -> { A , B , C } = { A , B } ) $=
    ( cvv wcel wne wa wn wo ctp cpr wceq ianor tprot csn cun df-tp prprc2 sylbi
    syl5eq uneq1d df-pr prcom eqtr3i syl6eq nne tppreq3 eqcoms jaoi ) CDEZCBFZG
    HUJHZUKHZIABCJZABKZLZUJUKMULUPUMULUNBCAJZUOABCNULUQBCKZAOZPZUOBCAQULUTBOZUS
    PZUOULURVAUSBCRUABAKVBUOBAUBBAUCUDUETTUMCBLUPCBUFUPBCABCUGUHSUIS $.

  $( An unordered triple is an unordered pair if and only if one of its
     elements is a proper class or is identical with one of the another
     elements.  (Contributed by Alexander van der Vekens, 15-Jan-2018.) $)
  tppreqb $p |- ( -. ( C e. _V /\ C =/= A /\ C =/= B )
                     <-> { A , B , C } = { A , B } ) $=
    ( cvv wcel wne w3a wn ctp cpr wceq wo w3o wa ianor tpprceq3 sylbir jaoi nne
    sylbi 3ianor df-3or bitri orass tpcoma prcom 3eqtr3g orcom bitr4i csn df-tp
    cun eqeq1i wss ssequn2 wi snssg elpri 3mix2 3mix3 syl syl6bir 3mix1 pm2.61i
    orcs a1d sylibr impbii ) CDEZCAFZCBFZGHZABCIZABJZKZVLVIHZVJHZLZVKHZLZVOVLVP
    VQVSMZVTVIVJVKUAZVPVQVSUBUCVTVPVOVTVPLVRVSVPLZLVOVRVSVPUDVRVOWCVRBACIZBAJZV
    MVNVRVIVJNHWDWEKVIVJOBACPQBACUEBAUFUGWCVIVKNHZVOWCVPVSLWFVSVPUHVIVKOUIABCPT
    RTVETVOVNCUJZULZVNKZVLVMWHVNABCUKUMWIWGVNUNZVLWGVNUOWJWAVLVIWJWAUPVIWJCVNEZ
    WACVNDUQWKCAKZCBKZLWACABURWLWAWMWLVQWACASVQVPVSUSQWMVSWACBSVSVPVQUTQRVAVBVP
    WAWJVPVQVSVCVFVDWBVGQTVH $.

  $( ` ( B \ { A } ) ` equals ` B ` if and only if ` A ` is not a member of
     ` B ` .  Generalization of ~ difsn .  (Contributed by David Moews,
     1-May-2017.) $)
  difsnb $p |- ( -. A e. B <-> ( B \ { A } ) = B ) $=
    ( wcel wn csn cdif wceq difsn neldifsnd nelne1 mpdan necomd necon2bi impbii
    wne ) ABCZDBAEFZBGABHPQBPBQPAQCDBQOPABIABQJKLMN $.

  $( ` ( B \ { A } ) ` is a proper subclass of ` B ` if and only if ` A ` is a
     member of ` B ` .  (Contributed by David Moews, 1-May-2017.) $)
  difsnpss $p |- ( A e. B <-> ( B \ { A } ) C. B ) $=
    ( wcel wn csn cdif wpss notnot wne wss wa biantrur difsnb necon3bbii df-pss
    difss 3bitr4i bitri ) ABCZSDZDZBAEZFZBGZSHUCBIZUCBJZUEKUAUDUFUEBUBPLTUCBABM
    NUCBOQR $.

  $( The singleton of an element of a class is a subset of the class.
     (Contributed by NM, 6-Jun-1994.) $)
  snssi $p |- ( A e. B -> { A } C_ B ) $=
    ( wcel csn wss snssg ibi ) ABCADBEABBFG $.

  ${
    snssd.1 $e |- ( ph -> A e. B ) $.
    $( The singleton of an element of a class is a subset of the class
       (deduction rule).  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.) $)
    snssd $p |- ( ph -> { A } C_ B ) $=
      ( wcel csn wss wb snssg syl mpbid ) ABCEZBFCGZDALLMHDBCCIJK $.
  $}

  $( If we remove a single element from a class then put it back in, we end up
     with the original class.  (Contributed by NM, 2-Oct-2006.) $)
  difsnid $p |- ( B e. A -> ( ( A \ { B } ) u. { B } ) = A ) $=
    ( wcel csn cdif cun uncom wss wceq snssi undif sylib syl5eq ) BACZABDZEZOFO
    PFZAPOGNOAHQAIBAJOAKLM $.

  $( Note that ` x ` is a dummy variable in the proof below. $)
  $( Compute the power set of the empty set.  Theorem 89 of [Suppes] p. 47.
     (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
     29-Jun-2011.) $)
  pw0 $p |- ~P (/) = { (/) } $=
    ( vx cv c0 wss cab wceq cpw csn ss0b abbii df-pw df-sn 3eqtr4i ) ABZCDZAENC
    FZAECGCHOPANIJACKACLM $.

  ${
    $d x y $.
    $( Compute the power set of the power set of the empty set.  (See ~ pw0 for
       the power set of the empty set.)  Theorem 90 of [Suppes] p. 48.
       Although this theorem is a special case of ~ pwsn , we have chosen to
       show a direct elementary proof.  (Contributed by NM, 7-Aug-1994.) $)
    pwpw0 $p |- ~P { (/) } = { (/) , { (/) } } $=
      ( vx vy cv c0 csn wss cab wceq wo cpw cpr wn wa wcel wal dfss2 elsn sylbi
      wi wex imbi2i albii bitri neq0 exintr syl5bi exancom df-clel bitr4i snssi
      syl6 anc2li eqss syl6ibr orrd sseq1 mpbiri eqimss jaoi impbii abbii df-pw
      0ss dfpr2 3eqtr4i ) ACZDEZFZAGVFDHZVFVGHZIZAGVGJDVGKVHVKAVHVKVHVIVJVHVILZ
      VHVGVFFZMVJVHVLVMVHBCZVFNZVNDHZSZBOZVLVMSVHVOVNVGNZSZBOVRBVFVGPVTVQBVSVPV
      OBDQUAUBUCVRVLVOVPMBTZVMVLVOBTVRWABVFUDVOVPBUEUFWADVFNZVMWAVPVOMBTWBVOVPB
      UGBDVFUHUIDVFUJRUKRULVFVGUMUNUOVIVHVJVIVHDVGFVGVCVFDVGUPUQVFVGURUSUTVAAVG
      VBADVGVDVE $.
  $}

  $( A singleton is a subset of an unordered pair containing its member.
     (Contributed by NM, 27-Aug-2004.) $)
  snsspr1 $p |- { A } C_ { A , B } $=
    ( csn cun cpr ssun1 df-pr sseqtr4i ) ACZIBCZDABEIJFABGH $.

  $( A singleton is a subset of an unordered pair containing its member.
     (Contributed by NM, 2-May-2009.) $)
  snsspr2 $p |- { B } C_ { A , B } $=
    ( csn cun cpr ssun2 df-pr sseqtr4i ) BCZACZIDABEIJFABGH $.

  $( A singleton is a subset of an unordered triple containing its member.
     (Contributed by NM, 9-Oct-2013.) $)
  snsstp1 $p |- { A } C_ { A , B , C } $=
    ( csn cpr cun ctp snsspr1 ssun1 sstri df-tp sseqtr4i ) ADZABEZCDZFZABCGMNPA
    BHNOIJABCKL $.

  $( A singleton is a subset of an unordered triple containing its member.
     (Contributed by NM, 9-Oct-2013.) $)
  snsstp2 $p |- { B } C_ { A , B , C } $=
    ( csn cpr cun ctp snsspr2 ssun1 sstri df-tp sseqtr4i ) BDZABEZCDZFZABCGMNPA
    BHNOIJABCKL $.

  $( A singleton is a subset of an unordered triple containing its member.
     (Contributed by NM, 9-Oct-2013.) $)
  snsstp3 $p |- { C } C_ { A , B , C } $=
    ( csn cpr cun ctp ssun2 df-tp sseqtr4i ) CDZABEZKFABCGKLHABCIJ $.

  ${
    $d A x $.  $d B x $.  $d C x $.
    prss.1 $e |- A e. _V $.
    prss.2 $e |- B e. _V $.
    $( A pair of elements of a class is a subset of the class.  Theorem 7.5 of
       [Quine] p. 49.  (Contributed by NM, 30-May-1994.)  (Proof shortened by
       Andrew Salmon, 29-Jun-2011.) $)
    prss $p |- ( ( A e. C /\ B e. C ) <-> { A , B } C_ C ) $=
      ( csn wss wa cun wcel cpr unss snss anbi12i df-pr sseq1i 3bitr4i ) AFZCGZ
      BFZCGZHRTIZCGACJZBCJZHABKZCGRTCLUCSUDUAACDMBCEMNUEUBCABOPQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.
    $( A pair of elements of a class is a subset of the class.  Theorem 7.5 of
       [Quine] p. 49.  (Contributed by NM, 22-Mar-2006.)  (Proof shortened by
       Andrew Salmon, 29-Jun-2011.) $)
    prssg $p |- ( ( A e. V /\ B e. W )
                -> ( ( A e. C /\ B e. C ) <-> { A , B } C_ C ) ) $=
      ( wcel wa csn wss cpr snssg bi2anan9 cun unss df-pr sseq1i bitr4i syl6bb
      ) ADFZBEFZGACFZBCFZGAHZCIZBHZCIZGZABJZCIZSUAUDTUBUFACDKBCEKLUGUCUEMZCIUIU
      CUECNUHUJCABOPQR $.
  $}

  $( A pair of elements of a class is a subset of the class.  (Contributed by
     NM, 16-Jan-2015.) $)
  prssi $p |- ( ( A e. C /\ B e. C ) -> { A , B } C_ C ) $=
    ( wcel wa cpr wss prssg ibi ) ACDBCDEABFCGABCCCHI $.

  $( An unordered pair belongs to the power class of a class iff each member
     belongs to the class.  (Contributed by Thierry Arnoux, 3-Oct-2016.)
     (Revised by NM, 18-Jan-2018.) $)
  prsspwg $p |- ( ( A e. V /\ B e. W ) -> ( { A , B } C_ ~P C
      <-> ( A C_ C /\ B C_ C ) ) ) $=
    ( wcel wa cpw cpr wss prssg elpwg bi2anan9 bitr3d ) ADFZBEFZGACHZFZBQFZGABI
    QJACJZBCJZGABQDEKORTPSUAACDLBCELMN $.

  $( Obsolete version of ~ prsspwg as of 18-Jan-2018.  (Contributed by Thierry
     Arnoux, 3-Oct-2016.)  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  prsspwgOLD $p |- ( ( A e. _V /\ B e. _V ) -> ( { A , B } C_ ~P C <->
    ( A C_ C /\ B C_ C ) ) ) $=
    ( cvv wcel wa cpw cpr wss prssg wb elpwg anim12i pm4.38 syl bitr3d ) ADEZBD
    EZFZACGZEZBTEZFZABHTIACIZBCIZFZABTDDJSUAUDKZUBUEKZFUCUFKQUGRUHACDLBCDLMUAUB
    UDUENOP $.

  ${
    $d x A $.  $d x B $.
    $( The subsets of a singleton.  (Contributed by NM, 24-Apr-2004.) $)
    sssn $p |- ( A C_ { B } <-> ( A = (/) \/ A = { B } ) ) $=
      ( vx csn wss c0 wceq wo wn wa wcel cv wex neq0 ssel elsni syl6 eleq1 ibd
      wb exlimdv syl5bi snssi anc2li eqss syl6ibr orrd sseq1 mpbiri eqimss jaoi
      0ss impbii ) ABDZEZAFGZAUNGZHUOUPUQUOUPIZUOUNAEZJUQUOURUSUOURBAKZUSURCLZA
      KZCMUOUTCANUOVBUTCUOVBUTUOVBVABGZVBUTTUOVBVAUNKVCAUNVAOVABPQVABARQSUAUBBA
      UCQUDAUNUEUFUGUPUOUQUPUOFUNEUNULAFUNUHUIAUNUJUKUM $.

    $( The property of being sandwiched between two sets naturally splits under
       union with a singleton.  This is the induction hypothesis for the
       determination of large powersets such as ~ pwtp .  (Contributed by Mario
       Carneiro, 2-Jul-2016.) $)
    ssunsn2 $p |- ( ( B C_ A /\ A C_ ( C u. { D } ) )
                    <-> ( ( B C_ A /\ A C_ C ) \/
                      ( ( B u. { D } ) C_ A /\ A C_ ( C u. { D } ) ) ) ) $=
      ( wcel wss csn cun wa wo wb syl wi anim12d pm4.72 sylib bitrd wceq bitr3i
      a1i snssi unss bicomi rbaibr anbi1d biimpi expcom ssun3 wn cdif c0 disjsn
      cin disj3 sseq1 sylbi uncom sseq2i ssundif syl6rbbr anbi2d simplbi biimpd
      orcom syl6bb pm2.61i ) DAEZBAFZACDGZHZFZIZVHACFZIZBVIHAFZVKIZJZKVGVLVPVQV
      GVHVOVKVGVIAFZVHVOKDAUAZVOVHVRVHVRIZVOBVIAUBZUCZUDLUEVGVNVPMVPVQKVGVHVOVM
      VKVGVRVHVOMVSVHVRVOVTVOWAUFUGLVMVKMVGACVIUHTNVNVPOPQVGUIZVLVNVQWCVKVMVHWC
      VMAVIUJZCFZVKWCAWDRZVMWEKWCAVIUMUKRWFADULAVIUNSAWDCUOUPVKAVICHZFWEWGVJAVI
      CUQURAVICUSSUTZVAWCVNVPVNJZVQWCVPVNMVNWIKWCVOVHVKVMVOVHMWCVOVHVRWBVBTWCVK
      VMWHVCNVPVNOPVPVNVDVEQVF $.

    $( Possible values for a set sandwiched between another set and it plus a
       singleton.  (Contributed by Mario Carneiro, 2-Jul-2016.) $)
    ssunsn $p |- ( ( B C_ A /\ A C_ ( B u. { C } ) )
        <-> ( A = B \/ A = ( B u. { C } ) ) ) $=
      ( wss csn cun wa wo wceq ssunsn2 ancom eqss bitr4i orbi12i bitri ) BADZAB
      CEFZDZGPABDZGZQADZRGZHABIZAQIZHABBCJTUCUBUDTSPGUCPSKABLMUBRUAGUDUARKAQLMN
      O $.

    $( Two ways to express that a nonempty set equals a singleton.
       (Contributed by NM, 15-Dec-2007.) $)
    eqsn $p |- ( A =/= (/) -> ( A = { B } <-> A. x e. A x = B ) ) $=
      ( c0 wne csn wceq wss cv wral eqimss wn df-ne wo sssn biimpi syl5bi com12
      ord impbid2 wcel dfss3 elsn ralbii bitri syl6bb ) BDEZBCFZGZBUHHZAIZCGZAB
      JZUGUIUJBUHKUJUGUIUGBDGZLUJUIBDMUJUNUIUJUNUINBCOPSQRTUJUKUHUAZABJUMABUHUB
      UOULABACUCUDUEUF $.
  $}

  ${
    $( Possible values for a set sandwiched between another set and it plus a
       singleton.  (Contributed by Mario Carneiro, 2-Jul-2016.) $)
    ssunpr $p |- ( ( B C_ A /\ A C_ ( B u. { C , D } ) )
        <-> ( ( A = B \/ A = ( B u. { C } ) ) \/
          ( A = ( B u. { D } ) \/ A = ( B u. { C , D } ) ) ) ) $=
      ( wss cpr cun wa csn wceq df-pr uneq2i unass eqtr4i sseq2i anbi2i ssunsn2
      wo ssunsn 3bitri un23 eqtr2i eqeq2i orbi2i orbi12i ) BAEZABCDFZGZEZHUFABC
      IZGZDIZGZEZHUFAUKEHZBULGZAEZUNHZRABJAUKJRZAUPJZAUHJZRZRUIUNUFUHUMAUHBUJUL
      GZGUMUGVCBCDKLBUJULMNZOPABUKDQUOUSURVBABCSURUQAUPUJGZEZHUTAVEJZRVBUNVFUQU
      MVEABUJULUAZOPAUPCSVGVAUTVEUHAUHUMVEVDVHUBUCUDTUET $.

    $( The subsets of a pair.  (Contributed by NM, 16-Mar-2006.)  (Proof
       shortened by Mario Carneiro, 2-Jul-2016.) $)
    sspr $p |- ( A C_ { B , C }
        <-> ( ( A = (/) \/ A = { B } ) \/ ( A = { C } \/ A = { B , C } ) ) ) $=
      ( cpr wss c0 cun wa wceq csn wo uncom eqtri sseq2i biantrur bitr3i eqeq2i
      un0 0ss orbi12i ssunpr orbi2i 3bitri ) ABCDZEZFAEZAFUDGZEZHZAFIZAFBJZGZIZ
      KZAFCJZGZIZAUGIZKZKUJAUKIZKZAUOIZAUDIZKZKUEUHUIUGUDAUGUDFGUDFUDLUDRMZNUFU
      HASOPAFBCUAUNVAUSVDUMUTUJULUKAULUKFGUKFUKLUKRMQUBUQVBURVCUPUOAUPUOFGUOFUO
      LUORMQUGUDAVEQTTUC $.

    $( The subsets of a triple.  (Contributed by Mario Carneiro,
       2-Jul-2016.) $)
    sstp $p |- ( A C_ { B , C , D }
        <-> ( ( ( A = (/) \/ A = { B } ) \/ ( A = { C } \/ A = { B , C } ) ) \/
          ( ( A = { D } \/ A = { B , D } ) \/
            ( A = { C , D } \/ A = { B , C , D } ) ) ) ) $=
      ( wss cpr csn cun c0 wa wceq wo sseq2i biantrur uncom df-pr eqtr4i eqeq2i
      orbi12i 3bitri ctp df-tp 0ss ssunsn2 sspr bitr3i un0 eqtri sseq1i anbi12i
      ssunpr orbi2i eqtr2i bitri ) ABCDUAZEABCFZDGZHZEZIAEZUSJZAIKABGZKLACGZKAU
      PKLLZAUQKZABDFZKZLZACDFZKZAUOKZLZLZLZUOURABCDUBZMUTUSAUCZNVAUTAUPEZJZIUQH
      ZAEZUSJZLVNAIUPDUDVRVDWAVMVRVQVDUTVQVPNABCUEUFWAUQAEZAUQUPHZEZJVEAUQVBHZK
      ZLZAUQVCHZKZAWCKZLZLVMVTWBUSWDVSUQAVSUQIHUQIUQOUQUGUHUIURWCAUPUQOZMUJAUQB
      CUKWGVHWKVLWFVGVEWEVFAWEVBUQHVFUQVBOBDPQRULWIVJWJVKWHVIAWHVCUQHVIUQVCOCDP
      QRWCUOAUOURWCVOWLUMRSSTSUNT $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.  $d D x $.
    tpss.1 $e |- A e. _V $.
    tpss.2 $e |- B e. _V $.
    tpss.3 $e |- C e. _V $.
    $( A triplet of elements of a class is a subset of the class.  (Contributed
       by NM, 9-Apr-1994.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    tpss $p |- ( ( A e. D /\ B e. D /\ C e. D ) <-> { A , B , C } C_ D ) $=
      ( cpr wss csn wa cun wcel w3a ctp unss df-3an prss snss anbi12i 3bitr4i
      bitri df-tp sseq1i ) ABHZDIZCJZDIZKZUEUGLZDIADMZBDMZCDMZNZABCOZDIUEUGDPUN
      UKULKZUMKUIUKULUMQUPUFUMUHABDEFRCDGSTUBUOUJDABCUCUDUA $.
  $}

  $( A triple of elements of a class is a subset of the class.  (Contributed by
     Alexander van der Vekens, 1-Feb-2018.) $)
  tpssi $p |- ( ( A e. D /\ B e. D /\ C e. D ) -> { A , B , C } C_ D ) $=
    ( w3a ctp cpr csn cun df-tp wss prssi 3adant3 snssi 3ad2ant3 unssd syl5eqss
    wcel ) ADRZBDRZCDRZEZABCFABGZCHZIDABCJUBUCUDDSTUCDKUAABDLMUASUDDKTCDNOPQ $.

  ${
    sneqr.1 $e |- A e. _V $.
    $( If the singletons of two sets are equal, the two sets are equal.  Part
       of Exercise 4 of [TakeutiZaring] p. 15.  (Contributed by NM,
       27-Aug-1993.) $)
    sneqr $p |- ( { A } = { B } -> A = B ) $=
      ( csn wceq wcel snid eleq2 mpbii elsnc sylib ) ADZBDZEZAMFZABENALFOACGLMA
      HIABCJK $.

    $( If a singleton is a subset of another, their members are equal.
       (Contributed by NM, 28-May-2006.) $)
    snsssn $p |- ( { A } C_ { B } -> A = B ) $=
      ( csn wss c0 wceq wo sssn snnz neii pm2.21i sneqr jaoi sylbi ) ADZBDZEPFG
      ZPQGZHABGZPBIRTSRTPFACJKLABCMNO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Closed form of ~ sneqr .  (Contributed by Scott Fenton, 1-Apr-2011.) $)
    sneqrg $p |- ( A e. V -> ( { A } = { B } -> A = B ) ) $=
      ( vx cv csn wceq wi sneq eqeq1d eqeq1 imbi12d vex sneqr vtoclg ) DEZFZBFZ
      GZPBGZHAFZRGZABGZHDACPAGZSUBTUCUDQUARPAIJPABKLPBDMNO $.

  $}

  $( Two singletons of sets are equal iff their elements are equal.
     (Contributed by Scott Fenton, 16-Apr-2012.) $)
  sneqbg $p |- ( A e. V -> ( { A } = { B } <-> A = B ) ) $=
    ( wcel csn wceq sneqrg sneq impbid1 ) ACDAEBEFABFABCGABHI $.

  ${
    $d x A $.
    $( The singleton of a class is a subset of its power class.  (Contributed
       by NM, 5-Aug-1993.) $)
    snsspw $p |- { A } C_ ~P A $=
      ( vx csn cpw cv wceq wss wcel eqimss elsn df-pw abeq2i 3imtr4i ssriv ) BA
      CZADZBEZAFQAGZQOHQPHQAIBAJRBPBAKLMN $.
  $}


  ${
    $d x A $.  $d x B $.  $d x C $.
    prsspw.1 $e |- A e. _V $.
    prsspw.2 $e |- B e. _V $.
    $( An unordered pair belongs to the power class of a class iff each member
       belongs to the class.  (Contributed by NM, 10-Dec-2003.)  (Proof
       shortened by Andrew Salmon, 26-Jun-2011.) $)
    prsspw $p |- ( { A , B } C_ ~P C <-> ( A C_ C /\ B C_ C ) ) $=
      ( cpr cpw wss wcel wa prss elpw anbi12i bitr3i ) ABFCGZHAOIZBOIZJACHZBCHZ
      JABODEKPRQSACDLBCELMN $.
  $}

  ${
    preqr1.1 $e |- A e. _V $.
    preqr1.2 $e |- B e. _V $.
    $( Reverse equality lemma for unordered pairs.  If two unordered pairs have
       the same second element, the first elements are equal.  (Contributed by
       NM, 18-Oct-1995.) $)
    preqr1 $p |- ( { A , C } = { B , C } -> A = B ) $=
      ( cpr wceq wcel wo prid1 eleq2 mpbii elpr sylib mpbiri eqcom eqeq2 oplem1
      ) ACFZBCFZGZABGZACGZBAGZBCGZUAATHZUBUCIUAASHUFACDJSTAKLABCDMNUABSHZUDUEIU
      AUGBTHBCEJSTBKOBACEMNABPACBQR $.
  $}

  ${
    preqr2.1 $e |- A e. _V $.
    preqr2.2 $e |- B e. _V $.
    $( Reverse equality lemma for unordered pairs.  If two unordered pairs have
       the same first element, the second elements are equal.  (Contributed by
       NM, 5-Aug-1993.) $)
    preqr2 $p |- ( { C , A } = { C , B } -> A = B ) $=
      ( cpr wceq prcom eqeq12i preqr1 sylbi ) CAFZCBFZGACFZBCFZGABGLNMOCAHCBHIA
      BCDEJK $.
  $}

  ${
    preq12b.1 $e |- A e. _V $.
    preq12b.2 $e |- B e. _V $.
    preq12b.3 $e |- C e. _V $.
    preq12b.4 $e |- D e. _V $.
    $( Equality relationship for two unordered pairs.  (Contributed by NM,
       17-Oct-1996.) $)
    preq12b $p |- ( { A , B } = { C , D } <->
                   ( ( A = C /\ B = D ) \/ ( A = D /\ B = C ) ) ) $=
      ( cpr wceq wa wo wcel preq1 eqeq1d preqr2 syl6bi com12 ancld prcom eqeq2i
      prid1 eleq2 mpbii elpr sylib wi sylbi orim12d preq12 syl6eq sylan9eq jaoi
      mpd impbii ) ABIZCDIZJZACJZBDJZKZADJZBCJZKZLZURUSVBLZVEURAUQMZVFURAUPMVGA
      BEUBUPUQAUCUDACDEUEUFURUSVAVBVDURUSUTUSURUTUSURCBIZUQJUTUSUPVHUQACBNOBDCF
      HPQRSURVBVCURUPDCIZJZVBVCUGUQVIUPCDTUAVBVJVCVBVJDBIZVIJVCVBUPVKVIADBNZOBC
      DFGPQRUHSUIUNVAURVDABCDUJVBVCUPBDIZUQVBUPVKVMVLDBTUKBCDNULUMUO $.

    $( Equality of two unordered pairs.  (Contributed by NM, 17-Oct-1996.) $)
    prel12 $p |- ( -. A = B -> ( { A , B } = { C , D } <->
                   ( A e. { C , D } /\ B e. { C , D } ) ) ) $=
      ( wceq wn cpr wcel wa eleq2 mpbii wo wi elpr eqeq2 notbid prid1 prid2 jca
      orel2 syl6bi com3l imp ancrd orel1 orim12d orcom bitri preq12b 3imtr4g ex
      syl5bi imp3a impbid2 ) ABIZJZABKZCDKZIZAVBLZBVBLZMVCVDVEVCAVALVDABEUAVAVB
      ANOVCBVALVEABFUBVAVBBNOUCUTVDVEVCVDACIZADIZPZUTVEVCQZACDERUTVHVIUTVHMZBDI
      ZBCIZPZVFVKMZVGVLMZPVEVCVJVKVNVLVOVJVKVFUTVHVKVFQVKUTVHVFVKUTVGJVHVFQVKUS
      VGBDASTVGVFUDUEUFUGUHVJVLVGUTVHVLVGQVLUTVHVGVLUTVFJVHVGQVLUSVFBCASTVFVGUI
      UEUFUGUHUJVEVLVKPVMBCDFRVLVKUKULABCDEFGHUMUNUOUPUQUR $.

    $( A way to represent ordered pairs using unordered pairs with distinct
       members.  (Contributed by NM, 27-Mar-2007.) $)
    opthpr $p |- ( A =/= D ->
                 ( { A , B } = { C , D } <-> ( A = C /\ B = D ) ) ) $=
      ( cpr wceq wa wo wne preq12b idd wn wi df-ne pm2.21 sylbi jaod orc syl5bb
      imp3a impbid1 ) ABICDIJACJBDJKZADJZBCJZKZLZADMZUFABCDEFGHNUKUJUFUKUFUFUIU
      KUFOUKUGUHUFUKUGPUGUHUFQZQADRUGULSTUDUAUFUIUBUEUC $.
  $}

  ${
    $d A x y z w $.  $d B x y z w $.  $d C x y z w $.  $d D x y z w $.
    $d V x y z w $.  $d W x y z w $.  $d X x y z w $.  $d Y x y z w $.
    $( Closed form of ~ preq12b .  (Contributed by Scott Fenton,
       28-Mar-2014.) $)
    preq12bg $p |- ( ( ( A e. V /\ B e. W ) /\ ( C e. X /\ D e. Y ) ) ->
       ( { A , B } = { C , D } <->
         ( ( A = C /\ B = D ) \/ ( A = D /\ B = C ) ) ) ) $=
      ( vx vy vz vw wcel wa cpr wceq wo wb wi cv weq preq1 eqeq1d eqeq1 orbi12d
      anbi1d bibi12d imbi2d preq2 anbi2d eqeq2 w3a vex preq12b vtoclbg vtocl3ga
      eqeq2d a1i 3expa impr ) AEMZBFMZNCGMZDHMZABOZCDOZPZACPZBDPZNZADPZBCPZNZQZ
      RZVAVBVCVDVOSZVDITZJTZOZKTZDOZPZIKUAZVRDPZNZVQDPZJKUAZNZQZRZSZVDAVROZWAPZ
      AVTPZWDNZVKWGNZQZRZSVDVEWAPZWNVINZVKBVTPZNZQZRZSVPIJKABCEFGVQAPZWJWRVDXEW
      BWMWIWQXEVSWLWAVQAVRUBUCXEWEWOWHWPXEWCWNWDVQAVTUDUFXEWFVKWGVQADUDUFUEUGUH
      VRBPZWRXDVDXFWMWSWQXCXFWLVEWAVRBAUIUCXFWOWTWPXBXFWDVIWNVRBDUDUJXFWGXAVKVR
      BVTUDUJUEUGUHVTCPZXDVOVDXGWSVGXCVNXGWAVFVEVTCDUBUQXGWTVJXBVMXGWNVHVIVTCAU
      KUFXGXAVLVKVTCBUKUJUEUGUHWKVQEMVRFMVTGMULVSVTLTZOZPWCJLUAZNZILUAZWGNZQWBW
      ILDHXHDPZXIWAVSXHDVTUIUQXNXKWEXMWHXNXJWDWCXHDVRUKUJXNXLWFWGXHDVQUKUFUEVQV
      RVTXHIUMJUMKUMLUMUNUOURUPUSUT $.
  $}

  $( Two pairs are not equal if at least one element of the first pair is not
     contained in the second pair.  (Contributed by Alexander van der Vekens,
     13-Aug-2017.) $)
  prneimg $p |- ( ( ( A e. U /\ B e. V ) /\ ( C e. X /\ D e. Y ) )
                  -> ( ( ( A =/= C /\ A =/= D ) \/ ( B =/= C /\ B =/= D ) )
                       -> { A , B } =/= { C , D } ) ) $=
    ( wcel wa wne wo cpr wceq wn ianor nne orbi12i bitr2i syl6ib preq12bg orddi
    simpll pm1.4 ad2antll jca sylbi syl6bi anbi12i pm4.56 necon2ad ) AEIBFIJCGI
    DHIJJZACKZADKZJZBCKZBDKZJZLZABMZCDMZULUTVANZUOOZUROZJZUSOULVBACNZADNZLZBCNZ
    BDNZLZJZVEULVBVFVJJVGVIJLZVLABCDEFGHUAVMVHVFVILZJZVJVGLZVJVILZJZJZVLVFVJVGV
    IUBVSVHVKVHVNVRUCVQVKVOVPVJVIUDUEUFUGUHVHVCVKVDVCUMOZUNOZLVHUMUNPVTVFWAVGAC
    QADQRSVDUPOZUQOZLVKUPUQPWBVIWCVJBCQBDQRSUITUOURUJTUK $.

  $( A (proper) pair is not equal to another (maybe inproper) pair if and only
     if an element of the first pair is not contained in the second pair.
     (Contributed by Alexander van der Vekens, 16-Jan-2018.) $)
  prnebg $p |- ( ( ( A e. U /\ B e. V ) /\ ( C e. X /\ D e. Y ) /\ A =/= B )
                  -> ( ( ( A =/= C /\ A =/= D ) \/ ( B =/= C /\ B =/= D ) )
                       <-> { A , B } =/= { C , D } ) ) $=
    ( wcel wa wne wo cpr wi wn wceq nne bitri syl5bi jaoi prneimg 3adant3 ioran
    w3a ianor orbi12i anbi12i anddi eqtr3 pm2.24 syl preq12 a1d syl6eq 3ad2ant3
    df-ne prcom com12 necon1ad impbid ) AEIBFIJZCGIDHIJZABKZUDZACKZADKZJZBCKZBD
    KZJZLZABMZCDMZKZVAVBVKVNNVCABCDEFGHUAUBVDVKVLVMVKOZACPZADPZLZBCPZBDPZLZJZVD
    VLVMPZVOVGOZVJOZJWBVGVJUCWDVRWEWAWDVEOZVFOZLVRVEVFUEWFVPWGVQACQADQUFRWEVHOZ
    VIOZLWAVHVIUEWHVSWIVTBCQBDQUFRUGRWBVPVSJZVPVTJZLZVQVSJZVQVTJZLZLZVDWCVPVQVS
    VTUHVCVAWPWCNVBWPVCWCWLVCWCNZWOWJWQWKWJABPZWQABCUIVCWROWRWCABUPWRWCUJSZUKWK
    WCVCABCDULUMTWMWQWNWMWCVCWMVLDCMVMABDCULDCUQUNUMWNWRWQABDUIWSUKTTURUOSSUSUT
    $.

  ${
    preqsn.1 $e |- A e. _V $.
    preqsn.2 $e |- B e. _V $.
    preqsn.3 $e |- C e. _V $.
    $( Equivalence for a pair equal to a singleton.  (Contributed by NM,
       3-Jun-2008.) $)
    preqsn $p |- ( { A , B } = { C } <-> ( A = B /\ B = C ) ) $=
      ( cpr csn wceq wa dfsn2 eqeq2i preq12b oridm eqtr3 simpr jca eqtr bitri
      wo impbii ) ABGZCHZIUBCCGZIZABIZBCIZJZUCUDUBCKLUEACIZUGJZUJTZUHABCCDEFFMU
      KUJUHUJNUJUHUJUFUGABCOUIUGPQUHUIUGABCRUFUGPQUASSS $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Rewrite ~ df-op using ` if ` .  When both arguments are sets, it reduces
       to the standard Kuratowski definition; otherwise, it is defined to be
       the empty set.  (Contributed by Mario Carneiro, 26-Apr-2015.) $)
    dfopif $p |- <. A , B >. =
      if ( ( A e. _V /\ B e. _V ) , { { A } , { A , B } } , (/) ) $=
      ( vx cop cvv wcel cv csn cpr w3a cab wa c0 df-op df-3an abbii wceq iftrue
      cif ibar abbi2dv eqtr2d wss pm2.21 adantrd abssdv ss0 syl iffalse pm2.61i
      wn eqtr4d 3eqtri ) ABDAEFZBEFZCGZAHABIIZFZJZCKUNUOLZURLZCKZUTUQMSZCABNUSV
      ACUNUOUROPUTVBVCQUTVCUQVBUTUQMRUTVACUQUTURTUAUBUTUKZVBMVCVDVBMUCVBMQVDVAC
      MVDUTUPMFZURUTVEUDUEUFVBUGUHUTUQMUIULUJUM $.
  $}

  $( Value of the ordered pair when the arguments are sets.  (Contributed by
     Mario Carneiro, 26-Apr-2015.) $)
  dfopg $p |- ( ( A e. V /\ B e. W ) ->
    <. A , B >. = { { A } , { A , B } } ) $=
    ( wcel cvv cop csn cpr wceq elex wa c0 cif dfopif iftrue syl5eq syl2an ) AC
    EAFEZBFEZABGZAHABIIZJBDEACKBDKSTLZUAUCUBMNUBABOUCUBMPQR $.

  ${
    dfop.1 $e |- A e. _V $.
    dfop.2 $e |- B e. _V $.
    $( Value of an ordered pair when the arguments are sets, with the
       conclusion corresponding to Kuratowski's original definition.
       (Contributed by NM, 25-Jun-1998.) $)
    dfop $p |- <. A , B >. = { { A } , { A , B } } $=
      ( cvv wcel cop csn cpr wceq dfopg mp2an ) AEFBEFABGAHABIIJCDABEEKL $.
  $}

  $( Equality theorem for ordered pairs.  (Contributed by NM, 25-Jun-1998.)
     (Revised by Mario Carneiro, 26-Apr-2015.) $)
  opeq1 $p |- ( A = B -> <. A , C >. = <. B , C >. ) $=
    ( wceq cvv wcel wa csn cpr c0 cif cop eleq1 anbi1d sneq preq1 preq12d eqidd
    ifbieq12d dfopif 3eqtr4g ) ABDZAEFZCEFZGZAHZACIZIZJKBEFZUDGZBHZBCIZIZJKACLB
    CLUBUEUJUHJUMJUBUCUIUDABEMNUBUFUKUGULABOABCPQUBJRSACTBCTUA $.

  $( Equality theorem for ordered pairs.  (Contributed by NM, 25-Jun-1998.)
     (Revised by Mario Carneiro, 26-Apr-2015.) $)
  opeq2 $p |- ( A = B -> <. C , A >. = <. C , B >. ) $=
    ( wceq cvv wcel wa csn cpr c0 cif eleq1 anbi2d preq2 preq2d eqidd ifbieq12d
    cop dfopif 3eqtr4g ) ABDZCEFZAEFZGZCHZCAIZIZJKUBBEFZGZUECBIZIZJKCARCBRUAUDU
    IUGJUKJUAUCUHUBABELMUAUFUJUEABCNOUAJPQCASCBST $.

  $( Equality theorem for ordered pairs.  (Contributed by NM, 28-May-1995.) $)
  opeq12 $p |- ( ( A = C /\ B = D ) -> <. A , B >. = <. C , D >. ) $=
    ( wceq cop opeq1 opeq2 sylan9eq ) ACEBDEABFCBFCDFACBGBDCHI $.

  ${
    opeq1i.1 $e |- A = B $.
    $( Equality inference for ordered pairs.  (Contributed by NM,
       16-Dec-2006.) $)
    opeq1i $p |- <. A , C >. = <. B , C >. $=
      ( wceq cop opeq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality inference for ordered pairs.  (Contributed by NM,
       16-Dec-2006.) $)
    opeq2i $p |- <. C , A >. = <. C , B >. $=
      ( wceq cop opeq2 ax-mp ) ABECAFCBFEDABCGH $.

    ${
      opeq12i.2 $e |- C = D $.
      $( Equality inference for ordered pairs.  (Contributed by NM,
         16-Dec-2006.)  (Proof shortened by Eric Schmidt, 4-Apr-2007.) $)
      opeq12i $p |- <. A , C >. = <. B , D >. $=
        ( wceq cop opeq12 mp2an ) ABGCDGACHBDHGEFACBDIJ $.
    $}
  $}

  ${
    opeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for ordered pairs.  (Contributed by NM,
       16-Dec-2006.) $)
    opeq1d $p |- ( ph -> <. A , C >. = <. B , C >. ) $=
      ( wceq cop opeq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality deduction for ordered pairs.  (Contributed by NM,
       16-Dec-2006.) $)
    opeq2d $p |- ( ph -> <. C , A >. = <. C , B >. ) $=
      ( wceq cop opeq2 syl ) ABCFDBGDCGFEBCDHI $.

    opeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for ordered pairs.  (Contributed by NM,
       16-Dec-2006.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    opeq12d $p |- ( ph -> <. A , C >. = <. B , D >. ) $=
      ( wceq cop opeq12 syl2anc ) ABCHDEHBDICEIHFGBDCEJK $.
  $}

  $( Equality theorem for ordered triples.  (Contributed by NM, 3-Apr-2015.) $)
  oteq1 $p |- ( A = B -> <. A , C , D >. = <. B , C , D >. ) $=
    ( wceq cop cotp opeq1 opeq1d df-ot 3eqtr4g ) ABEZACFZDFBCFZDFACDGBCDGLMNDAB
    CHIACDJBCDJK $.

  $( Equality theorem for ordered triples.  (Contributed by NM, 3-Apr-2015.) $)
  oteq2 $p |- ( A = B -> <. C , A , D >. = <. C , B , D >. ) $=
    ( wceq cop cotp opeq2 opeq1d df-ot 3eqtr4g ) ABEZCAFZDFCBFZDFCADGCBDGLMNDAB
    CHICADJCBDJK $.

  $( Equality theorem for ordered triples.  (Contributed by NM, 3-Apr-2015.) $)
  oteq3 $p |- ( A = B -> <. C , D , A >. = <. C , D , B >. ) $=
    ( wceq cop cotp opeq2 df-ot 3eqtr4g ) ABECDFZAFKBFCDAGCDBGABKHCDAICDBIJ $.

  ${
    oteq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for ordered triples.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    oteq1d $p |- ( ph -> <. A , C , D >. = <. B , C , D >. ) $=
      ( wceq cotp oteq1 syl ) ABCGBDEHCDEHGFBCDEIJ $.

    $( Equality deduction for ordered triples.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    oteq2d $p |- ( ph -> <. C , A , D >. = <. C , B , D >. ) $=
      ( wceq cotp oteq2 syl ) ABCGDBEHDCEHGFBCDEIJ $.

    $( Equality deduction for ordered triples.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    oteq3d $p |- ( ph -> <. C , D , A >. = <. C , D , B >. ) $=
      ( wceq cotp oteq3 syl ) ABCGDEBHDECHGFBCDEIJ $.

    oteq123d.2 $e |- ( ph -> C = D ) $.
    oteq123d.3 $e |- ( ph -> E = F ) $.
    $( Equality deduction for ordered triples.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    oteq123d $p |- ( ph -> <. A , C , E >. = <. B , D , F >. ) $=
      ( cotp oteq1d oteq2d oteq3d 3eqtrd ) ABDFKCDFKCEFKCEGKABCDFHLADECFIMAFGCE
      JNO $.
  $}

  ${
    nfop.1 $e |- F/_ x A $.
    nfop.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for ordered pairs.  (Contributed by
       NM, 14-Nov-1995.) $)
    nfop $p |- F/_ x <. A , B >. $=
      ( cop cvv wcel wa csn cpr c0 cif dfopif nfel1 nfan nfsn nfpr nfcv nfif
      nfcxfr ) ABCFBGHZCGHZIZBJZBCKZKZLMBCNUDAUGLUBUCAABGDOACGEOPAUEUFABDQABCDE
      RRALSTUA $.
  $}

  ${
    $d z B $.  $d z A $.  $d x z $.
    nfopd.2 $e |- ( ph -> F/_ x A ) $.
    nfopd.3 $e |- ( ph -> F/_ x B ) $.
    $( Deduction version of bound-variable hypothesis builder ~ nfop .  This
       shows how the deduction version of a not-free theorem such as ~ nfop can
       be created from the corresponding not-free inference theorem.
       (Contributed by NM, 4-Feb-2008.) $)
    nfopd $p |- ( ph -> F/_ x <. A , B >. ) $=
      ( vz cv wcel wal cab cop wnfc nfaba1 nfop wb wa nfnfc1 wceq abidnf adantr
      nfan adantl opeq12d nfceqdf syl2anc mpbii ) ABGHZCIZBJGKZUHDIZBJGKZLZMZBC
      DLZMZBUJULUIBGNUKBGNOABCMZBDMZUNUPPEFUQURQZBUMUOUQURBBCRBDRUBUSUJCULDUQUJ
      CSURBGCTUAURULDSUQBGDTUCUDUEUFUG $.
  $}

  ${
    $d x A $.
    $( Distribution of class substitution over ordered pairs.  (Contributed by
       Drahflow, 25-Sep-2015.)  (Revised by Mario Carneiro, 29-Oct-2015.) $)
    csbopg $p |- ( A e. _V -> [_ A / x ]_ <. C , D >. =
                           <. [_ A / x ]_ C , [_ A / x ]_ D >. ) $=
      ( cop csb cvv wnfc wcel nfcsb1v nfop a1i cv wceq csbeq1a opeq12d csbiegf
      ) ABCDEABCFZABDFZEZGATHBGIARSABCJABDJKLAMBNCRDSABCOABDOPQ $.
  $}

  ${
    opid.1 $e |- A e. _V $.
    $( The ordered pair ` <. A , A >. ` in Kuratowski's representation.
       (Contributed by FL, 28-Dec-2011.) $)
    opid $p |- <. A , A >. = { { A } } $=
      ( csn cpr cop dfsn2 eqcomi preq2i dfop 3eqtr4i ) ACZAADZDKKDAAEKCLKKKLAFG
      HAABBIKFJ $.
  $}

  ${
    $d B x $.  $d ps x $.
    ralunsn.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Restricted quantification over the union of a set and a singleton, using
       implicit substitution.  (Contributed by Paul Chapman, 17-Nov-2012.)
       (Revised by Mario Carneiro, 23-Apr-2015.) $)
    ralunsn $p |- ( B e. C -> ( A. x e. ( A u. { B } ) ph <->
                                ( A. x e. A ph /\ ps ) ) ) $=
      ( csn cun wral wa wcel ralunb ralsng anbi2d syl5bb ) ACDEHZIJACDJZACQJZKE
      FLZRBKACDQMTSBRABCEFGNOP $.
  $}

  ${
    $d A x $.  $d B x y $.  $d C x $.  $d ch x $.  $d ps y $.  $d th x $.
    2ralunsn.1 $e |- ( x = B -> ( ph <-> ch ) ) $.
    2ralunsn.2 $e |- ( y = B -> ( ph <-> ps ) ) $.
    2ralunsn.3 $e |- ( x = B -> ( ps <-> th ) ) $.
    $( Double restricted quantification over the union of a set and a
       singleton, using implicit substitution.  (Contributed by Paul Chapman,
       17-Nov-2012.) $)
    2ralunsn $p |- ( B e. C ->
                     ( A. x e. ( A u. { B } ) A. y e. ( A u. { B } ) ph <->
                       ( ( A. x e. A A. y e. A ph /\ A. x e. A ps ) /\
                         ( A. y e. A ch /\ th ) ) ) ) $=
      ( wcel csn cun wral wa ralunsn ralbidv cv wceq r19.26 anbi1i syl6bb bitrd
      anbi12d ) HIMZAFGHNOZPZEUHPAFGPZBQZEUHPZUJEGPBEGPQZCFGPZDQZQZUGUIUKEUHABF
      GHIKRSUGULUKEGPZUOQUPUKUOEGHIETHUAZUJUNBDURACFGJSLUFRUQUMUOUJBEGUBUCUDUE
      $.
  $}

  $( Expansion of an ordered pair when either member is a proper class.
     (Contributed by Mario Carneiro, 26-Apr-2015.) $)
  opprc $p |- ( -. ( A e. _V /\ B e. _V ) -> <. A , B >. = (/) ) $=
    ( cvv wcel wa wn cop csn cpr c0 cif dfopif iffalse syl5eq ) ACDBCDEZFABGOAH
    ABIIZJKJABLOPJMN $.

  $( Expansion of an ordered pair when the first member is a proper class.  See
     also ~ opprc .  (Contributed by NM, 10-Apr-2004.)  (Revised by Mario
     Carneiro, 26-Apr-2015.) $)
  opprc1 $p |- ( -. A e. _V -> <. A , B >. = (/) ) $=
    ( cvv wcel wn wa cop c0 wceq simpl con3i opprc syl ) ACDZENBCDZFZEABGHIPNNO
    JKABLM $.

  $( Expansion of an ordered pair when the second member is a proper class.
     See also ~ opprc .  (Contributed by NM, 15-Nov-1994.)  (Revised by Mario
     Carneiro, 26-Apr-2015.) $)
  opprc2 $p |- ( -. B e. _V -> <. A , B >. = (/) ) $=
    ( cvv wcel wn wa cop c0 wceq simpr con3i opprc syl ) BCDZEACDZNFZEABGHIPNON
    JKABLM $.

  $( If an ordered pair has an element, then its arguments are sets.
     (Contributed by Mario Carneiro, 26-Apr-2015.) $)
  oprcl $p |- ( C e. <. A , B >. -> ( A e. _V /\ B e. _V ) ) $=
    ( cop wcel c0 wceq cvv wa n0i opprc nsyl2 ) CABDZEMFGAHEBHEIMCJABKL $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( The power set of a singleton.  (Contributed by NM, 5-Jun-2006.) $)
    pwsn $p |- ~P { A } = { (/) , { A } } $=
      ( vx cv csn wss cab c0 wceq wo cpw cpr sssn abbii df-pw dfpr2 3eqtr4i ) B
      CZADZEZBFQGHQRHIZBFRJGRKSTBQALMBRNBGROP $.

    $d x y $.  $d y A $.
    $( The power set of a singleton (direct proof).  TO DO - should we keep
       this?  (Contributed by NM, 5-Jun-2006.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    pwsnALT $p |- ~P { A } = { (/) , { A } } $=
      ( vx vy cv csn wss cab c0 wceq wo cpw cpr wn wa wcel wal dfss2 wex sylbi
      wi elsn imbi2i albii bitri neq0 exintr syl5bi df-clel exancom bitr2i syl6
      snssi anc2li eqss syl6ibr orrd 0ss sseq1 mpbiri eqimss impbii abbii df-pw
      jaoi dfpr2 3eqtr4i ) BDZAEZFZBGVGHIZVGVHIZJZBGVHKHVHLVIVLBVIVLVIVJVKVIVJM
      ZVIVHVGFZNVKVIVMVNVICDZVGOZVOAIZTZCPZVMVNTVIVPVOVHOZTZCPVSCVGVHQWAVRCVTVQ
      VPCAUAUBUCUDVSVMVPVQNCRZVNVMVPCRVSWBCVGUEVPVQCUFUGWBAVGOZVNWCVQVPNCRWBCAV
      GUHVQVPCUIUJAVGULSUKSUMVGVHUNUOUPVJVIVKVJVIHVHFVHUQVGHVHURUSVGVHUTVDVAVBB
      VHVCBHVHVEVF $.

    $( The power set of an unordered pair.  (Contributed by NM, 1-May-2009.) $)
    pwpr $p |- ~P { A , B } = ( { (/) , { A } } u. { { B } , { A , B } } ) $=
      ( vx cpr cpw c0 csn cun cv wss wcel wo wceq sspr elpr orbi12i bitr4i elpw
      vex elun 3bitr4i eqriv ) CABDZEZFAGZDZBGZUCDZHZCIZUCJZUJUFKZUJUHKZLZUJUDK
      UJUIKUKUJFMUJUEMLZUJUGMUJUCMLZLUNUJABNULUOUMUPUJFUECSZOUJUGUCUQOPQUJUCUQR
      UJUFUHTUAUB $.

    $( The power set of an unordered triple.  (Contributed by Mario Carneiro,
       2-Jul-2016.) $)
    pwtp $p |- ~P { A , B , C } =
      ( ( { (/) , { A } } u. { { B } , { A , B } } ) u.
        ( { { C } , { A , C } } u. { { B , C } , { A , B , C } } ) ) $=
      ( vx ctp cpw c0 csn cpr cun cv wcel wss vex wceq elun elpr orbi12i bitri
      wo elpw sstp 3bitr4ri eqriv ) DABCEZFZGAHZIZBHZABIZIZJZCHZACIZIZBCIZUEIZJ
      ZJZDKZUFLUTUEMZUTUSLZUTUEDNZUAUTULLZUTURLZTUTGOUTUGOTZUTUIOUTUJOTZTZUTUMO
      UTUNOTZUTUPOUTUEOTZTZTVBVAVDVHVEVKVDUTUHLZUTUKLZTVHUTUHUKPVLVFVMVGUTGUGVC
      QUTUIUJVCQRSVEUTUOLZUTUQLZTVKUTUOUQPVNVIVOVJUTUMUNVCQUTUPUEVCQRSRUTULURPU
      TABCUBUCSUD $.
  $}

  ${
    $d x y $.
    $( Compute the power set of the power set of the power set of the empty
       set.  (See also ~ pw0 and ~ pwpw0 .)  (Contributed by NM,
       2-May-2009.) $)
    pwpwpw0 $p |- ~P { (/) , { (/) } } =
                ( { (/) , { (/) } } u. { { { (/) } } , { (/) , { (/) } } } ) $=
      ( c0 csn pwpr ) AABC $.
  $}

  ${

    $( The power class of the universe is the universe.  Exercise 4.12(d) of
       [Mendelson] p. 235.  (Contributed by NM, 14-Sep-2003.) $)
    pwv $p |- ~P _V = _V $=
      ( vx cvv cpw cv wcel wss ssv vex elpw mpbir 2th eqriv ) ABCZBADZMEZNBEONB
      FNGNBAHZIJPKL $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       The union of a class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare class union symbol. $)
  $c U. $. $( Big cup $)

  $( Extend class notation to include the union of a class (read:  'union
     ` A ` ') $)
  cuni $a class U. A $.

  ${
    $d x y A $.
    $( Define the union of a class i.e. the collection of all members of the
       members of the class.  Definition 5.5 of [TakeutiZaring] p. 16.  For
       example, ` U. { { 1 , 3 } , { 1 , 8 } } = { 1 , 3 , 8 } ` ( ~ ex-uni ).
       This is similar to the union of two classes ~ df-un .  (Contributed by
       NM, 23-Aug-1993.) $)
    df-uni $a |- U. A = { x | E. y ( x e. y /\ y e. A ) } $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of class union.  (Contributed by NM,
       28-Jun-1998.) $)
    dfuni2 $p |- U. A = { x | E. y e. A x e. y } $=
      ( cuni cv wcel wa wex cab wrex df-uni exancom df-rex bitr4i abbii eqtri )
      CDAEBEZFZQCFZGBHZAIRBCJZAIABCKTUAATSRGBHUARSBLRBCMNOP $.
  $}

  ${
    $d x A y $.  $d x B y $.
    $( Membership in class union.  (Contributed by NM, 22-May-1994.) $)
    eluni $p |- ( A e. U. B <-> E. x ( A e. x /\ x e. B ) ) $=
      ( vy cuni wcel cvv cv wa wex elex adantr exlimiv wceq eleq1 anbi1d exbidv
      df-uni elab2g pm5.21nii ) BCEZFBGFZBAHZFZUCCFZIZAJZBUAKUFUBAUDUBUEBUCKLMD
      HZUCFZUEIZAJUGDBUAGUHBNZUJUFAUKUIUDUEUHBUCOPQDACRST $.

    $( Membership in class union.  Restricted quantifier version.  (Contributed
       by NM, 31-Aug-1999.) $)
    eluni2 $p |- ( A e. U. B <-> E. x e. B A e. x ) $=
      ( cv wcel wa wex cuni wrex exancom eluni df-rex 3bitr4i ) BADZEZNCEZFAGPO
      FAGBCHEOACIOPAJABCKOACLM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Membership in class union.  (Contributed by NM, 24-Mar-1995.) $)
    elunii $p |- ( ( A e. B /\ B e. C ) -> A e. U. C ) $=
      ( vx wcel wa cv cuni wceq eleq2 eleq1 anbi12d spcegv anabsi7 eluni sylibr
      wex ) ABEZBCEZFZADGZEZUACEZFZDQZACHERSUEUDTDBCUABIUBRUCSUABAJUABCKLMNDACO
      P $.
  $}

  ${
    $d y z A $.  $d x y z $.
    nfuni.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for union.  (Contributed by NM,
       30-Dec-1996.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    nfuni $p |- F/_ x U. A $=
      ( vy vz cuni wel wrex cab dfuni2 nfv nfrex nfab nfcxfr ) ABFDEGZEBHZDIDEB
      JPADOAEBCOAKLMN $.
  $}

  ${
    $d y z A $.  $d x y z $.  $d y z ph $.
    nfunid.3 $e |- ( ph -> F/_ x A ) $.
    $( Deduction version of ~ nfuni .  (Contributed by NM, 18-Feb-2013.) $)
    nfunid $p |- ( ph -> F/_ x U. A ) $=
      ( vy vz cuni wel wrex cab dfuni2 nfv nfvd nfrexd nfabd nfcxfrd ) ABCGEFHZ
      FCIZEJEFCKARBEAELAQBFCAFLDAQBMNOP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for class union.  Exercise 15 of [TakeutiZaring]
       p. 18.  (Contributed by NM, 10-Aug-1993.)  (Proof shortened by Andrew
       Salmon, 29-Jun-2011.) $)
    unieq $p |- ( A = B -> U. A = U. B ) $=
      ( vy vx wceq wel wrex cab cuni rexeq abbidv dfuni2 3eqtr4g ) ABEZCDFZDAGZ
      CHODBGZCHAIBINPQCODABJKCDALCDBLM $.
  $}

  ${
    unieqi.1 $e |- A = B $.
    $( Inference of equality of two class unions.  (Contributed by NM,
       30-Aug-1993.) $)
    unieqi $p |- U. A = U. B $=
      ( wceq cuni unieq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    unieqd.1 $e |- ( ph -> A = B ) $.
    $( Deduction of equality of two class unions.  (Contributed by NM,
       21-Apr-1995.) $)
    unieqd $p |- ( ph -> U. A = U. B ) $=
      ( wceq cuni unieq syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d x A y $.  $d ph y $.
    $( Membership in union of a class abstraction.  (Contributed by NM,
       11-Aug-1994.)  (Revised by Mario Carneiro, 14-Nov-2016.) $)
    eluniab $p |- ( A e. U. { x | ph } <-> E. x ( A e. x /\ ph ) ) $=
      ( vy cab cuni wcel cv wa wex eluni nfv nfsab1 nfan weq eleq2 eleq1 syl6bb
      abid anbi12d cbvex bitri ) CABEZFGCDHZGZUDUCGZIZDJCBHZGZAIZBJDCUCKUGUJDBU
      EUFBUEBLABDMNUJDLDBOZUEUIUFAUDUHCPUKUFUHUCGAUDUHUCQABSRTUAUB $.

    $( Membership in union of a class abstraction.  (Contributed by NM,
       4-Oct-2006.) $)
    elunirab $p |- ( A e. U. { x e. B | ph } <->
                   E. x e. B ( A e. x /\ ph ) ) $=
      ( cv wcel cab cuni wex crab wrex eluniab df-rab unieqi eleq2i df-rex an12
      wa exbii bitri 3bitr4i ) CBEZDFZARZBGZHZFCUBFZUDRZBIZCABDJZHZFUGARZBDKZUD
      BCLUKUFCUJUEABDMNOUMUCULRZBIUIULBDPUNUHBUCUGAQSTUA $.
  $}

  ${
    $d x y A $.  $d x y B $.
    unipr.1 $e |- A e. _V $.
    unipr.2 $e |- B e. _V $.
    $( The union of a pair is the union of its members.  Proposition 5.7 of
       [TakeutiZaring] p. 16.  (Contributed by NM, 23-Aug-1993.) $)
    unipr $p |- U. { A , B } = ( A u. B ) $=
      ( vx vy cv wcel wo cab cpr wa wex cun cuni wceq 19.43 bitri clel3 exancom
      vex elpr anbi2i andi exbii orbi12i 3bitr4ri abbii df-un df-uni 3eqtr4ri )
      EGZAHZULBHZIZEJULFGZHZUPABKZHZLZFMZEJABNUROUOVAEUQUPAPZLZUQUPBPZLZIZFMVCF
      MZVEFMZIVAUOVCVEFQUTVFFUTUQVBVDIZLVFUSVIUQUPABFUAUBUCUQVBVDUDRUEUMVGUNVHU
      MVBUQLFMVGFULACSVBUQFTRUNVDUQLFMVHFULBDSVDUQFTRUFUGUHEABUIEFURUJUK $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( The union of a pair is the union of its members.  Proposition 5.7 of
       [TakeutiZaring] p. 16.  (Contributed by NM, 25-Aug-2006.) $)
    uniprg $p |- ( ( A e. V /\ B e. W ) -> U. { A , B } = ( A u. B ) ) $=
      ( vx vy cv cpr cuni cun wceq preq1 unieqd uneq1 eqeq12d preq2 uneq2 unipr
      vex vtocl2g ) EGZFGZHZIZUAUBJZKAUBHZIZAUBJZKABHZIZABJZKEFABCDUAAKZUDUGUEU
      HULUCUFUAAUBLMUAAUBNOUBBKZUGUJUHUKUMUFUIUBBAPMUBBAQOUAUBESFSRT $.
  $}

  ${
    unisn.1 $e |- A e. _V $.
    $( A set equals the union of its singleton.  Theorem 8.2 of [Quine] p. 53.
       (Contributed by NM, 30-Aug-1993.) $)
    unisn $p |- U. { A } = A $=
      ( csn cuni cpr cun dfsn2 unieqi unipr unidm 3eqtri ) ACZDAAEZDAAFALMAGHAA
      BBIAJK $.
  $}

  ${
    $d x A $.
    $( A set equals the union of its singleton.  Theorem 8.2 of [Quine] p. 53.
       (Contributed by NM, 13-Aug-2002.) $)
    unisng $p |- ( A e. V -> U. { A } = A ) $=
      ( vx cv csn cuni wceq sneq unieqd id eqeq12d vex unisn vtoclg ) CDZEZFZOG
      AEZFZAGCABOAGZQSOATPROAHITJKOCLMN $.
  $}

  ${
    $d x y $.  $d y A $.
    $( An alternative statement of the effective freeness of a class ` A ` ,
       when it is a set.  (Contributed by Mario Carneiro, 14-Oct-2016.) $)
    dfnfc2 $p |- ( A. x A e. V -> ( F/_ x A <-> A. y F/ x y = A ) ) $=
      ( wcel wal wnfc cv wceq wnf nfcvd id nfeqd alrimiv wa csn cuni simpr elsn
      df-nfc nfbii albii bitri sylibr nfunid nfa1 nfnf1 nfal nfan unisng adantr
      sps nfceqdf mpbid ex impbid2 ) CDEZAFZACGZBHZCIZAJZBFZUSVBBUSAUTCUSAUTKUS
      LMNURVCUSURVCOZACPZQZGUSVDAVEVDVCAVEGZURVCRVGUTVEEZAJZBFVCABVETVIVBBVHVAA
      BCSUAUBUCUDUEVDAVFCURVCAUQAUFVBABVAAUGUHUIURVFCIZVCUQVJACDUJULUKUMUNUOUP
      $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The class union of the union of two classes.  Theorem 8.3 of [Quine]
       p. 53.  (Contributed by NM, 20-Aug-1993.) $)
    uniun $p |- U. ( A u. B ) = ( U. A u. U. B ) $=
      ( vx vy cun cuni cv wcel wa wo 19.43 elun anbi2i andi bitri exbii orbi12i
      wex eluni 3bitr4i eqriv ) CABEZFZAFZBFZEZCGZDGZHZUHUBHZIZDRZUGUDHZUGUEHZJ
      ZUGUCHUGUFHUIUHAHZIZUIUHBHZIZJZDRUQDRZUSDRZJULUOUQUSDKUKUTDUKUIUPURJZIUTU
      JVCUIUHABLMUIUPURNOPUMVAUNVBDUGASDUGBSQTDUGUBSUGUDUELTUA $.

    $( The class union of the intersection of two classes.  Exercise 4.12(n) of
       [Mendelson] p. 235.  See ~ uniinqs for a condition where equality
       holds.  (Contributed by NM, 4-Dec-2003.)  (Proof shortened by Andrew
       Salmon, 29-Jun-2011.) $)
    uniin $p |- U. ( A i^i B ) C_ ( U. A i^i U. B ) $=
      ( vx vy cin cuni cv wcel wex 19.40 elin anbi2i anandi bitri exbii anbi12i
      wa eluni 3imtr4i ssriv ) CABEZFZAFZBFZEZCGZDGZHZUGUAHZQZDIZUFUCHZUFUDHZQZ
      UFUBHUFUEHUHUGAHZQZUHUGBHZQZQZDIUPDIZURDIZQUKUNUPURDJUJUSDUJUHUOUQQZQUSUI
      VBUHUGABKLUHUOUQMNOULUTUMVADUFARDUFBRPSDUFUARUFUCUDKST $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Subclass relationship for class union.  Theorem 61 of [Suppes] p. 39.
       (Contributed by NM, 22-Mar-1998.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    uniss $p |- ( A C_ B -> U. A C_ U. B ) $=
      ( vx vy wss cuni cv wcel wa wex ssel anim2d eximdv eluni 3imtr4g ssrdv )
      ABEZCAFZBFZQCGZDGZHZUAAHZIZDJUBUABHZIZDJTRHTSHQUDUFDQUCUEUBABUAKLMDTANDTB
      NOP $.

    $( Subclass relationship for class union.  (Contributed by NM,
       24-May-1994.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
    ssuni $p |- ( ( A C_ B /\ B e. C ) -> A C_ U. C ) $=
      ( vy vx wcel wss cuni cv wi wal eleq2 imbi1d elunii expcom vtoclga imim2d
      wceq alimdv dfss2 3imtr4g impcom ) BCFZABGZACHZGZUCDIZAFZUGBFZJZDKUHUGUEF
      ZJZDKUDUFUCUJULDUCUIUKUHUGEIZFZUKJUIUKJEBCUMBRUNUIUKUMBUGLMUNUMCFUKUGUMCN
      OPQSDABTDAUETUAUB $.
  $}

  ${
    unissi.1 $e |- A C_ B $.
    $( Subclass relationship for subclass union.  Inference form of ~ uniss .
       (Contributed by David Moews, 1-May-2017.) $)
    unissi $p |- U. A C_ U. B $=
      ( wss cuni uniss ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    unissd.1 $e |- ( ph -> A C_ B ) $.
    $( Subclass relationship for subclass union.  Deduction form of ~ uniss .
       (Contributed by David Moews, 1-May-2017.) $)
    unissd $p |- ( ph -> U. A C_ U. B ) $=
      ( wss cuni uniss syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d x y A $.
    $( The union of a set is empty iff the set is included in the singleton of
       the empty set.  (Contributed by NM, 12-Sep-2004.) $)
    uni0b $p |- ( U. A = (/) <-> A C_ { (/) } ) $=
      ( vx vy cv c0 csn wcel wral wceq wss cuni elsn ralbii dfss3 wex wrex neq0
      wn rexcom4 3bitr4ri rexbii eluni2 exbii rexnal 3bitri con4bii ) BDZEFZGZB
      AHUGEIZBAHZAUHJAKZEIZUIUJBABELMBAUHNUMUKUMRCDZULGZCOZUJRZBAPZUKRCULQUNUGG
      ZCOZBAPUSBAPZCOURUPUSBCASUQUTBACUGQUAUOVACBUNAUBUCTUJBAUDUEUFT $.

    $( The union of a set is empty iff all of its members are empty.
       (Contributed by NM, 16-Aug-2006.) $)
    uni0c $p |- ( U. A = (/) <-> A. x e. A x = (/) ) $=
      ( cuni c0 wceq csn wss cv wcel wral uni0b dfss3 elsn ralbii 3bitri ) BCDE
      BDFZGAHZPIZABJQDEZABJBKABPLRSABADMNO $.
  $}

  $( The union of the empty set is the empty set.  Theorem 8.7 of [Quine]
     p. 54.  (Reproved without relying on ~ ax-nul by Eric Schmidt.)
     (Contributed by NM, 16-Sep-1993.)  (Revised by Eric Schmidt,
     4-Apr-2007.) $)
  uni0 $p |- U. (/) = (/) $=
    ( c0 cuni wceq csn wss 0ss uni0b mpbir ) ABACAADZEIFAGH $.

  ${
    $d A y z $.  $d B y z $.  $d V y z $.  $d x y z $.
    $( Distribute proper substitution through the union of a class.
       (Contributed by Alan Sare, 10-Nov-2012.)  (Revised by NM,
       22-Aug-2018.) $)
    csbuni $p |- [_ A / x ]_ U. B = U. [_ A / x ]_ B $=
      ( vz vy cvv wcel cuni csb wceq wel cv wa wex wsbc syl5bb df-uni c0 csbprc
      cab csbab sbcex2 anbi1d sbcel2 anbi2i syl6bb exbidv abbidv syl5eq csbeq2i
      sbcan sbcg 3eqtr4g wn unieqd uni0 syl6req eqtrd pm2.61i ) BFGZABCHZIZABCI
      ZHZJUTABDEKZELZCGZMZENZDTZIZVEVFVCGZMZENZDTZVBVDUTVKVIABOZDTVOVIADBUAUTVP
      VNDVPVHABOZENUTVNVHEABUBUTVQVMEVQVEABOZVGABOZMZUTVMVEVGABUKUTVTVEVSMVMUTV
      RVEVSVEABFULUCVSVLVEABVFCUDUEUFPUGPUHUIABVAVJDECQUJDEVCQUMUTUNZVBRVDABVAS
      WAVDRHRWAVCRABCSUOUPUQURUS $.
  $}

  ${
    $d A y z $.  $d B y z $.  $d V y z $.  $d x y z $.
    $( Distribute proper substitution through the union of a class.
       (Contributed by Alan Sare, 10-Nov-2012.)  Obsolete as of 22-Aug-2018.
       Use ~ csbuni instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbunigOLD $p |- ( A e. V -> [_ A / x ]_ U. B = U. [_ A / x ]_ B ) $=
      ( vz vy wcel cv wex cab csb cuni wsbc csbabgOLD sbcexgOLD sbcangOLD bitrd
      wa sbcg df-uni sbcel2gOLD anbi12d exbidv abbidv eqtrd csbeq2i 3eqtr4g ) B
      DGZABEHFHZGZUICGZRZFIZEJZKZUJUIABCKZGZRZFIZEJZABCLZKUPLUHUOUMABMZEJUTUMAE
      BDNUHVBUSEUHVBULABMZFIUSULFABDOUHVCURFUHVCUJABMZUKABMZRURUJUKABDPUHVDUJVE
      UQUJABDSABUICDUAUBQUCQUDUEABVAUNEFCTUFEFUPTUG $.
  $}

  $( An element of a class is a subclass of its union.  Theorem 8.6 of [Quine]
     p. 54.  Also the basis for Proposition 7.20 of [TakeutiZaring] p. 40.
     (Contributed by NM, 6-Jun-1994.) $)
  elssuni $p |- ( A e. B -> A C_ U. B ) $=
    ( wss wcel cuni ssid ssuni mpan ) AACABDABECAFAABGH $.

  $( Condition turning a subclass relationship for union into an equality.
     (Contributed by NM, 18-Jul-2006.) $)
  unissel $p |- ( ( U. A C_ B /\ B e. A ) -> U. A = B ) $=
    ( cuni wss wcel wa simpl elssuni adantl eqssd ) ACZBDZBAEZFKBLMGMBKDLBAHIJ
    $.

  ${
    $d x y A $.  $d x y B $.
    $( Relationship involving membership, subset, and union.  Exercise 5 of
       [Enderton] p. 26 and its converse.  (Contributed by NM, 20-Sep-2003.) $)
    unissb $p |- ( U. A C_ B <-> A. x e. A x C_ B ) $=
      ( vy cv cuni wcel wi wal wss wa wex eluni imbi1i 19.23v albii bitri dfss2
      wral 3bitr4i bitr4i alcom 19.21v impexp bi2.04 imbi2i df-ral ) DEZBFZGZUH
      CGZHZDIZAEZBGZUNCJZHZAIZUICJUPABSUMUHUNGZUOKZUKHZAIZDIZURULVBDULUTALZUKHV
      BUJVDUKAUHBMNUTUKAOUAPVCVADIZAIURVADAUBVEUQAUOUSUKHZHZDIUOVFDIZHVEUQUOVFD
      UCVAVGDVAUSUOUKHHVGUSUOUKUDUSUOUKUEQPUPVHUODUNCRUFTPQQDUICRUPABUGT $.
  $}

  ${
    $d x A $.  $d x y B $.
    $( A subclass condition on the members of two classes that implies a
       subclass relation on their unions.  Proposition 8.6 of [TakeutiZaring]
       p. 59.  See ~ iunss2 for a generalization to indexed unions.
       (Contributed by NM, 22-Mar-2004.) $)
    uniss2 $p |- ( A. x e. A E. y e. B x C_ y -> U. A C_ U. B ) $=
      ( cv wss wrex wral cuni wcel ssuni expcom rexlimiv ralimi unissb sylibr )
      AEZBEZFZBDGZACHQDIZFZACHCIUAFTUBACSUBBDSRDJUBQRDKLMNACUAOP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( If the difference ` A \ B ` contains the largest members of ` A ` , then
       the union of the difference is the union of ` A ` .  (Contributed by NM,
       22-Mar-2004.) $)
    unidif $p |- ( A. x e. A E. y e. ( A \ B ) x C_ y ->
               U. ( A \ B ) = U. A ) $=
      ( cv wss cdif wrex wral cuni wceq uniss2 difss unissi jctil eqss sylibr
      wa ) AEBEFBCDGZHACIZSJZCJZFZUBUAFZRUAUBKTUDUCABCSLSCCDMNOUAUBPQ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Relationship implying union.  (Contributed by NM, 10-Nov-1999.) $)
    ssunieq $p |- ( ( A e. B /\ A. x e. B x C_ A ) -> A = U. B ) $=
      ( wcel cv wss wral cuni wceq elssuni unissb biimpri anim12i eqss sylibr
      wa ) BCDZAEBFACGZPBCHZFZSBFZPBSIQTRUABCJUARACBKLMBSNO $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Any member of a class is the largest of those members that it includes.
       (Contributed by NM, 13-Aug-2002.) $)
    unimax $p |- ( A e. B -> U. { x e. B | x C_ A } = A ) $=
      ( vy wcel cv wss crab wral cuni wceq ssid sseq1 elrab3 elrab simprbi rgen
      mpbiri wa ssunieq eqcomd sylancl ) BCEZBAFZBGZACHZEZDFZBGZDUFIZUFJZBKUCUG
      BBGZBLUEULABCUDBBMNRUIDUFUHUFEUHCEUIUEUIAUHCUDUHBMOPQUGUJSBUKDBUFTUAUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The intersection of a class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare class intersection symbol. $)
  $c |^| $. $( Big cap $)

  $( Extend class notation to include the intersection of a class (read:
     'intersect ` A ` '). $)
  cint $a class |^| A $.

  ${
    $d x y A $.
    $( Define the intersection of a class.  Definition 7.35 of [TakeutiZaring]
       p. 44.  For example, ` |^| { { 1 , 3 } , { 1 , 8 } } = { 1 } ` .
       Compare this with the intersection of two classes, ~ df-in .
       (Contributed by NM, 18-Aug-1993.) $)
    df-int $a |- |^| A = { x | A. y ( y e. A -> x e. y ) } $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of class intersection.  (Contributed by NM,
       28-Jun-1998.) $)
    dfint2 $p |- |^| A = { x | A. y e. A x e. y } $=
      ( cint cv wcel wi wal cab wral df-int df-ral abbii eqtr4i ) CDBEZCFAEOFZG
      BHZAIPBCJZAIABCKRQAPBCLMN $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality law for intersection.  (Contributed by NM, 13-Sep-1999.) $)
    inteq $p |- ( A = B -> |^| A = |^| B ) $=
      ( vx vy wceq wel wral cab cint raleq abbidv dfint2 3eqtr4g ) ABEZCDFZDAGZ
      CHODBGZCHAIBINPQCODABJKCDALCDBLM $.
  $}

  ${
    inteqi.1 $e |- A = B $.
    $( Equality inference for class intersection.  (Contributed by NM,
       2-Sep-2003.) $)
    inteqi $p |- |^| A = |^| B $=
      ( wceq cint inteq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    inteqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for class intersection.  (Contributed by NM,
       2-Sep-2003.) $)
    inteqd $p |- ( ph -> |^| A = |^| B ) $=
      ( wceq cint inteq syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d x A y $.  $d x B y $.
    elint.1 $e |- A e. _V $.
    $( Membership in class intersection.  (Contributed by NM, 21-May-1994.) $)
    elint $p |- ( A e. |^| B <-> A. x ( x e. B -> A e. x ) ) $=
      ( vy cv wcel wi wal cint wceq eleq1 imbi2d albidv df-int elab2 ) AFZCGZEF
      ZQGZHZAIRBQGZHZAIEBCJDSBKZUAUCAUDTUBRSBQLMNEACOP $.
  $}

  ${
    $d x A $.  $d x B $.
    elint2.1 $e |- A e. _V $.
    $( Membership in class intersection.  (Contributed by NM, 14-Oct-1999.) $)
    elint2 $p |- ( A e. |^| B <-> A. x e. B A e. x ) $=
      ( cint wcel cv wi wal wral elint df-ral bitr4i ) BCEFAGZCFBNFZHAIOACJABCD
      KOACLM $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Membership in class intersection, with the sethood requirement expressed
       as an antecedent.  (Contributed by NM, 20-Nov-2003.) $)
    elintg $p |- ( A e. V -> ( A e. |^| B <-> A. x e. B A e. x ) ) $=
      ( vy cv cint wcel wral eleq1 wceq ralbidv vex elint2 vtoclbg ) EFZCGZHPAF
      ZHZACIBQHBRHZACIEBDPBQJPBKSTACPBRJLAPCEMNO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in class intersection.  (Contributed by NM, 14-Oct-1999.)
       (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
    elinti $p |- ( A e. |^| B -> ( C e. B -> A e. C ) ) $=
      ( vx cint wcel wi cv wral elintg eleq2 rspccv syl6bi pm2.43i ) ABEZFZCBFA
      CFZGZPPADHZFZDBIRDABOJTQDCBSCAKLMN $.
  $}

  ${
    $d y z A $.  $d x y z $.
    nfint.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for intersection.  (Contributed by NM,
       2-Feb-1997.)  (Proof shortened by Andrew Salmon, 12-Aug-2011.) $)
    nfint $p |- F/_ x |^| A $=
      ( vy vz cint wel wral cab dfint2 nfv nfral nfab nfcxfr ) ABFDEGZEBHZDIDEB
      JPADOAEBCOAKLMN $.
  $}

  ${
    $d A x y $.  $d ph y $.
    inteqab.1 $e |- A e. _V $.
    $( Membership in the intersection of a class abstraction.  (Contributed by
       NM, 30-Aug-1993.) $)
    elintab $p |- ( A e. |^| { x | ph } <-> A. x ( ph -> A e. x ) ) $=
      ( vy cab cint wcel cv wi wal elint nfsab1 nfv nfim weq eleq1 syl6bb eleq2
      abid imbi12d cbval bitri ) CABFZGHEIZUDHZCUEHZJZEKACBIZHZJZBKECUDDLUHUKEB
      UFUGBABEMUGBNOUKENEBPZUFAUGUJULUFUIUDHAUEUIUDQABTRUEUICSUAUBUC $.

    $( Membership in the intersection of a class abstraction.  (Contributed by
       NM, 17-Oct-1999.) $)
    elintrab $p |- ( A e. |^| { x e. B | ph } <->
                 A. x e. B ( ph -> A e. x ) ) $=
      ( cv wcel wa cab cint wi wal crab wral elintab impexp albii df-rab inteqi
      bitri eleq2i df-ral 3bitr4i ) CBFZDGZAHZBIZJZGZUEACUDGZKZKZBLZCABDMZJZGUK
      BDNUIUFUJKZBLUMUFBCEOUPULBUEAUJPQTUOUHCUNUGABDRSUAUKBDUBUC $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y ph $.
    $( Membership in the intersection of a class abstraction.  (Contributed by
       NM, 17-Feb-2007.) $)
    elintrabg $p |- ( A e. V -> ( A e. |^| { x e. B | ph } <->
                 A. x e. B ( ph -> A e. x ) ) ) $=
      ( vy cv crab cint wcel wi wral eleq1 wceq imbi2d ralbidv elintrab vtoclbg
      vex ) FGZABDHIZJATBGZJZKZBDLCUAJACUBJZKZBDLFCETCUAMTCNZUDUFBDUGUCUEATCUBM
      OPABTDFSQR $.

    $( The intersection of the empty set is the universal class.  Exercise 2 of
       [TakeutiZaring] p. 44.  (Contributed by NM, 18-Aug-1993.) $)
    int0 $p |- |^| (/) = _V $=
      ( vy vx cv c0 wcel wi wal cab weq cint cvv pm2.21i ax-gen equid 2th abbii
      noel df-int df-v 3eqtr4i ) ACZDEZBCUAEZFZAGZBHBBIZBHDJKUEUFBUEUFUDAUBUCUA
      QLMBNOPBADRBST $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ph $.
    $( An element of a class includes the intersection of the class.  Exercise
       4 of [TakeutiZaring] p. 44 (with correction), generalized to classes.
       (Contributed by NM, 18-Nov-1995.) $)
    intss1 $p |- ( A e. B -> |^| B C_ A ) $=
      ( vx vy wcel cint cv wal vex elint wceq eleq1 eleq2 imbi12d spcgv pm2.43a
      wi syl5bi ssrdv ) ABEZCBFZACGZUAEDGZBEZUBUCEZQZDHZTUBAEZDUBBCIJUGTUHUFTUH
      QDABUCAKUDTUEUHUCABLUCAUBMNOPRS $.

    $( Subclass of a class intersection.  Theorem 5.11(viii) of [Monk1] p. 52
       and its converse.  (Contributed by NM, 14-Oct-1999.) $)
    ssint $p |- ( A C_ |^| B <-> A. x e. B A C_ x ) $=
      ( vy cint wss cv wcel wral dfss3 vex elint2 ralbii ralcom bitr4i 3bitri )
      BCEZFDGZQHZDBIRAGZHZACIZDBIZBTFZACIZDBQJSUBDBARCDKLMUCUADBIZACIUEUADABCNU
      DUFACDBTJMOP $.

    $( Subclass of the intersection of a class abstraction.  (Contributed by
       NM, 31-Jul-2006.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
    ssintab $p |- ( A C_ |^| { x | ph } <-> A. x ( ph -> A C_ x ) ) $=
      ( vy cab cint wss cv wral wi wal ssint sseq2 ralab2 bitri ) CABEZFGCDHZGZ
      DPIACBHZGZJBKDCPLARTDBQSCMNO $.

    $( Subclass of the least upper bound.  (Contributed by NM, 8-Aug-2000.) $)
    ssintub $p |- A C_ |^| { x e. B | A C_ x } $=
      ( vy cv wss crab cint ssint wcel sseq2 elrab simprbi mprgbir ) BBAEZFZACG
      ZHFBDEZFZDQDBQIRQJRCJSPSARCORBKLMN $.

    $( Subclass of the minimum value of class of supersets.  (Contributed by
       NM, 10-Aug-2006.) $)
    ssmin $p |- A C_ |^| { x | ( A C_ x /\ ph ) } $=
      ( cv wss wa cab cint wi ssintab simpl mpgbir ) CCBDEZAFZBGHENMIBNBCJMAKL
      $.

    $( Any member of a class is the smallest of those members that include it.
       (Contributed by NM, 13-Aug-2002.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    intmin $p |- ( A e. B -> |^| { x e. B | A C_ x } = A ) $=
      ( vy wcel cv wss crab cint wi wral elintrab ssid wceq sseq2 eleq2 imbi12d
      vex rspcv mpii syl5bi ssrdv ssintub a1i eqssd ) BCEZBAFZGZACHIZBUFDUIBDFZ
      UIEUHUJUGEZJZACKZUFUJBEZUHAUJCDRLUFUMBBGZUNBMULUOUNJABCUGBNUHUOUKUNUGBBOU
      GBUJPQSTUAUBBUIGUFABCUCUDUE $.

    $( Intersection of subclasses.  (Contributed by NM, 14-Oct-1999.) $)
    intss $p |- ( A C_ B -> |^| B C_ |^| A ) $=
      ( vy vx cv wcel wal cint wss imim1 al2imi vex elint 3imtr4g alrimiv dfss2
      wi 3imtr4i ) CEZAFZSBFZQZCGZDEZBHZFZUDAHZFZQZDGABIUEUGIUCUIDUCUAUDSFZQZCG
      TUJQZCGUFUHUBUKULCTUAUJJKCUDBDLZMCUDAUMMNOCABPDUEUGPR $.

    $( The intersection of a nonempty set is a subclass of its union.
       (Contributed by NM, 29-Jul-2006.) $)
    intssuni $p |- ( A =/= (/) -> |^| A C_ U. A ) $=
      ( vx vy c0 wne cint cuni cv wcel wral r19.2z ex vex elint2 eluni2 3imtr4g
      wrex ssrdv ) ADEZBAFZAGZSBHZCHIZCAJZUCCAQZUBTIUBUAISUDUEUCCAKLCUBABMNCUBA
      OPR $.
  $}

  ${
    $d x A $.
    $( Subclass of the intersection of a restricted class builder.
       (Contributed by NM, 30-Jan-2015.) $)
    ssintrab $p |- ( A C_ |^| { x e. B | ph }
           <-> A. x e. B ( ph -> A C_ x ) ) $=
      ( crab cint wss cv wcel wa cab wral df-rab inteqi sseq2i wal impexp albii
      wi ssintab df-ral 3bitr4i bitri ) CABDEZFZGCBHZDIZAJZBKZFZGZACUFGZSZBDLZU
      EUJCUDUIABDMNOUHULSZBPUGUMSZBPUKUNUOUPBUGAULQRUHBCTUMBDUAUBUC $.
  $}

  $( If the union of a class is included in its intersection, the class is
     either the empty set or a singleton ( ~ uniintsn ).  (Contributed by NM,
     30-Oct-2010.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
  unissint $p |- ( U. A C_ |^| A <-> ( A = (/) \/ U. A = |^| A ) ) $=
    ( cuni cint wss c0 wo wn wa simpl wne df-ne intssuni sylbir adantl eqssd ex
    wceq orrd cvv ssv int0 sseqtr4i inteq syl5sseqr eqimss jaoi impbii ) ABZACZ
    DZAEQZUHUIQZFUJUKULUJUKGZULUJUMHUHUIUJUMIUMUIUHDZUJUMAEJUNAEKALMNOPRUKUJULU
    KECZUHUIUHSUOUHTUAUBAEUCUDUHUIUEUFUG $.

  $( Subclass relationship for intersection and union.  (Contributed by NM,
     29-Jul-2006.) $)
  intssuni2 $p |- ( ( A C_ B /\ A =/= (/) ) -> |^| A C_ U. B ) $=
    ( c0 wne wss cint cuni intssuni uniss sylan9ssr ) ACDABEAFAGBGAHABIJ $.

  ${
    $d x A $.  $d x B $.  $d x ps $.
    intminss.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Under subset ordering, the intersection of a restricted class
       abstraction is less than or equal to any of its members.  (Contributed
       by NM, 7-Sep-2013.) $)
    intminss $p |- ( ( A e. B /\ ps ) -> |^| { x e. B | ph } C_ A ) $=
      ( wcel wa crab cint wss elrab intss1 sylbir ) DEGBHDACEIZGOJDKABCDEFLDOMN
      $.
  $}

  ${
    $d x A $.
    intmin2.1 $e |- A e. _V $.
    $( Any set is the smallest of all sets that include it.  (Contributed by
       NM, 20-Sep-2003.) $)
    intmin2 $p |- |^| { x | A C_ x } = A $=
      ( cv wss cvv crab cint cab rabab inteqi wcel wceq intmin ax-mp eqtr3i ) B
      ADEZAFGZHZQAIZHBRTQAJKBFLSBMCABFNOP $.
  $}

  ${
    $d x A $.  $d x ps $.
    intmin3.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    intmin3.3 $e |- ps $.
    $( Under subset ordering, the intersection of a class abstraction is less
       than or equal to any of its members.  (Contributed by NM,
       3-Jul-2005.) $)
    intmin3 $p |- ( A e. V -> |^| { x | ph } C_ A ) $=
      ( wcel cab cint wss elabg mpbiri intss1 syl ) DEHZDACIZHZQJDKPRBGABCDEFLM
      DQNO $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Elimination of a conjunct in a class intersection.  (Contributed by NM,
       31-Jul-2006.) $)
    intmin4 $p |- ( A C_ |^| { x | ph } ->
                  |^| { x | ( A C_ x /\ ph ) } = |^| { x | ph } ) $=
      ( vy cab cint wss cv wa wcel wi wal wb ssintab simpr impbid2 imbi1d alimi
      ancr elintab albi syl sylbi vex 3bitr4g eqrdv ) CABEFZGZDCBHZGZAIZBEFZUGU
      HUKDHZUIJZKZBLZAUNKZBLZUMULJUMUGJUHAUJKZBLZUPURMZABCNUTUOUQMZBLVAUSVBBUSU
      KAUNUSUKAUJAOAUJSPQRUOUQBUAUBUCUKBUMDUDZTABUMVCTUEUF $.
  $}

  ${
    $d x z A $.  $d x z ph $.  $d x y z $.
    intab.1 $e |- A e. _V $.
    intab.2 $e |- { x | E. y ( ph /\ x = A ) } e. _V $.
    $( The intersection of a special case of a class abstraction. ` y ` may be
       free in ` ph ` and ` A ` , which can be thought of a ` ph ( y ) ` and
       ` A ( y ) ` .  Typically, ~ abrexex2 or ~ abexssex can be used to
       satisfy the second hypothesis.  (Contributed by NM, 28-Jul-2006.)
       (Proof shortened by Mario Carneiro, 14-Nov-2016.) $)
    intab $p |- |^| { x | A. y ( ph -> A e. x ) } =
                { x | E. y ( ph /\ x = A ) } $=
      ( vz cv wcel wi wal cab cint wceq wa wex wss ex alrimiv sylibr cvv anbi2d
      eqeq1 exbidv cbvabv eqeltri nfe1 nfab nfeq2 eleq2 imbi2d albid elab 19.8a
      wsbc sbc6 df-sbc sylib mpgbir intss1 19.29r simplr pm3.35 adantlr eqeltrd
      ax-mp exlimiv syl vex elintab abssi eqssi eqtri ) ADBHZIZJZCKZBLZMZAGHZDN
      ZOZCPZGLZAVNDNZOZCPZBLZVSWDWDVRIZVSWDQWIADWDIZJZCVQWKCKBWDWDWHUAWCWGGBVTV
      NNZWBWFCWLWAWEAVTVNDUCUBUDUEZFUFVNWDNZVPWKCCVNWDWCCGWBCUGUHUIWNVOWJAVNWDD
      UJUKULUMAWCGDUOZWJAWAWCJZGKWOAWPGAWAWCWBCUNRSWCGDEUPTWCGDUQURUSWDVRUTVFWC
      GVSWCVQVTVNIZJZBKVTVSIWCWRBWCVQWQWCVQOWBVPOZCPWQWBVPCVAWSWQCWSVTDVNAWAVPV
      BAVPVOWAAVOVCVDVEVGVHRSVQBVTGVIVJTVKVLWMVM $.
  $}

  $( The intersection of a class containing the empty set is empty.
     (Contributed by NM, 24-Apr-2004.) $)
  int0el $p |- ( (/) e. A -> |^| A = (/) ) $=
    ( c0 wcel cint intss1 wss 0ss a1i eqssd ) BACZADZBBAEBKFJKGHI $.

  ${
    $d x y A $.  $d x y B $.
    $( The class intersection of the union of two classes.  Theorem 78 of
       [Suppes] p. 42.  (Contributed by NM, 22-Sep-2002.) $)
    intun $p |- |^| ( A u. B ) = ( |^| A i^i |^| B ) $=
      ( vx vy cun cint cin cv wcel wi wal wa 19.26 elun imbi1i jaob bitri elint
      wo 3bitr4i albii vex anbi12i elin eqriv ) CABEZFZAFZBFZGZDHZUFIZCHZUKIZJZ
      DKZUMUHIZUMUIIZLZUMUGIUMUJIUKAIZUNJZUKBIZUNJZLZDKVADKZVCDKZLUPUSVAVCDMUOV
      DDUOUTVBSZUNJVDULVGUNUKABNOUTUNVBPQUAUQVEURVFDUMACUBZRDUMBVHRUCTDUMUFVHRU
      MUHUIUDTUE $.
  $}

  ${
    $d x y A $.  $d x y B $.
    intpr.1 $e |- A e. _V $.
    intpr.2 $e |- B e. _V $.
    $( The intersection of a pair is the intersection of its members.  Theorem
       71 of [Suppes] p. 42.  (Contributed by NM, 14-Oct-1999.) $)
    intpr $p |- |^| { A , B } = ( A i^i B ) $=
      ( vx vy cpr cint cin cv wcel wi wal wa wceq 19.26 wo vex clel4 3bitr4i
      elpr imbi1i jaob bitri albii anbi12i elint elin eqriv ) EABGZHZABIZFJZUJK
      ZEJZUMKZLZFMZUOAKZUOBKZNZUOUKKUOULKUMAOZUPLZUMBOZUPLZNZFMVCFMZVEFMZNURVAV
      CVEFPUQVFFUQVBVDQZUPLVFUNVIUPUMABFRUAUBVBUPVDUCUDUEUSVGUTVHFUOACSFUOBDSUF
      TFUOUJERUGUOABUHTUI $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( The intersection of a pair is the intersection of its members.  Closed
       form of ~ intpr .  Theorem 71 of [Suppes] p. 42.  (Contributed by FL,
       27-Apr-2008.) $)
    intprg $p |- ( ( A e. V /\ B e. W ) -> |^| { A , B } = ( A i^i B ) ) $=
      ( vx vy cv cpr cint cin wceq preq1 inteqd ineq1 eqeq12d preq2 ineq2 intpr
      vex vtocl2g ) EGZFGZHZIZUAUBJZKAUBHZIZAUBJZKABHZIZABJZKEFABCDUAAKZUDUGUEU
      HULUCUFUAAUBLMUAAUBNOUBBKZUGUJUHUKUMUFUIUBBAPMUBBAQOUAUBESFSRT $.
  $}

  $( Intersection of a singleton.  (Contributed by Stefan O'Rear,
     22-Feb-2015.) $)
  intsng $p |- ( A e. V -> |^| { A } = A ) $=
    ( wcel csn cint cpr dfsn2 inteqi cin wceq intprg anidms inidm syl6eq syl5eq
    ) ABCZADZEAAFZEZAQRAGHPSAAIZAPSTJAABBKLAMNO $.

  ${
    intsn.1 $e |- A e. _V $.
    $( The intersection of a singleton is its member.  Theorem 70 of [Suppes]
       p. 41.  (Contributed by NM, 29-Sep-2002.) $)
    intsn $p |- |^| { A } = A $=
      ( cvv wcel csn cint wceq intsng ax-mp ) ACDAEFAGBACHI $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( Two ways to express " ` A ` is a singleton."  See also ~ en1 , ~ en1b ,
       ~ card1 , and ~ eusn .  (Contributed by NM, 2-Aug-2010.) $)
    uniintsn $p |- ( U. A = |^| A <-> E. x A = { x } ) $=
      ( vy cuni cint wceq cv wex wcel wa wal c0 inteq syl6eq adantl unieq sylib
      wne cvv wss csn wi vn0 int0 eqeq1 syl5ib imp eqtr3d ex necon3d mpi n0 cpr
      uni0 vex prss cun cin uniss simpl sseqtrd intss sstrd unipr intpr 3sstr3g
      inss1 ssun1 sstri jctir eqss uneqin bitr3i syl5bi alrimivv jca weu euabsn
      cab eleq1 abid2 eqeq1i exbii 3bitr3i unisn intsn 3eqtr4a exlimiv impbii
      eu4 ) BDZBEZFZBAGZUAZFZAHZWMWNBIZAHZWRCGZBIZJZWNWTFZUBZCKAKZJZWQWMWSXEWMB
      LRZWSWMSLRXGUCWMBLSLWMBLFZSLFWMXHJWLSLXHWLSFWMXHWLLESBLMUDNOWMXHWLLFZXHWK
      LFWMXIXHWKLDLBLPUNNWKWLLUEUFUGUHUIUJUKABULQWMXDACXBWNWTUMZBTZWMXCWNWTBAUO
      ZCUOZUPWMXKXCWMXKJZWNWTUQZWNWTURZTZXPXOTZJZXCXNXQXRXNXJDZXJEZXOXPXNXTWLYA
      XNXTWKWLXKXTWKTWMXJBUSOWMXKUTVAXKWLYATWMXJBVBOVCWNWTXLXMVDWNWTXLXMVEVFXPW
      NXOWNWTVGWNWTVHVIVJXSXOXPFXCXOXPVKWNWTVLVMQUIVNVOVPWRAVQWRAVSZWOFZAHXFWQW
      RAVRWRXAACWNWTBVTWJYCWPAYBBWOABWAWBWCWDQWPWMAWPWODWNWKWLWNXLWEBWOPWPWLWOE
      WNBWOMWNXLWFNWGWHWI $.

    $( The union and the intersection of a class abstraction are equal exactly
       when there is a unique satisfying value of ` ph ( x ) ` .  (Contributed
       by Mario Carneiro, 24-Dec-2016.) $)
    uniintab $p |- ( E! x ph <-> U. { x | ph } = |^| { x | ph } ) $=
      ( vy weu cab cv csn wceq wex cuni cint euabsn2 uniintsn bitr4i ) ABDABEZC
      FGHCIOJOKHABCLCOMN $.
  $}

  ${
    intunsn.1 $e |- B e. _V $.
    $( Theorem joining a singleton to an intersection.  (Contributed by NM,
       29-Sep-2002.) $)
    intunsn $p |- |^| ( A u. { B } ) = ( |^| A i^i B ) $=
      ( csn cun cint cin intun intsn ineq2i eqtri ) ABDZEFAFZLFZGMBGALHNBMBCIJK
      $.
  $}

  $( Relative intersection of an empty set.  (Contributed by Stefan O'Rear,
     3-Apr-2015.) $)
  rint0 $p |- ( X = (/) -> ( A i^i |^| X ) = A ) $=
    ( c0 wceq cint cin inteq ineq2d cvv int0 ineq2i inv1 eqtri syl6eq ) BCDZABE
    ZFACEZFZAOPQABCGHRAIFAQIAJKALMN $.

  ${
    $d B y $.  $d X y $.
    $( Membership in a restricted intersection.  (Contributed by Stefan O'Rear,
       3-Apr-2015.) $)
    elrint $p |- ( X e. ( A i^i |^| B ) <-> ( X e. A /\ A. y e. B X e. y ) ) $=
      ( cint cin wcel wa cv wral elin elintg pm5.32i bitri ) DBCEZFGDBGZDOGZHPD
      AIGACJZHDBOKPQRADCBLMN $.

    $( Membership in a restricted intersection.  (Contributed by Stefan O'Rear,
       3-Apr-2015.) $)
    elrint2 $p |- ( X e. A -> ( X e. ( A i^i |^| B ) <->
          A. y e. B X e. y ) ) $=
      ( cint cin wcel cv wral elrint baib ) DBCEFGDBGDAHGACIABCDJK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Indexed union and intersection
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c U_ $. $( Underlined big cup. $)
  $c |^|_ $. $( Underlined big cap. $)

  $( Extend class notation to include indexed union.  Note:  Historically
     (prior to 21-Oct-2005), set.mm used the notation ` U. x e. A B ` , with
     the same union symbol as ~ cuni .  While that syntax was unambiguous, it
     did not allow for LALR parsing of the syntax constructions in set.mm.  The
     new syntax uses as distinguished symbol ` U_ ` instead of ` U. ` and does
     allow LALR parsing.  Thanks to Peter Backes for suggesting this change. $)
  ciun $a class U_ x e. A B $.

  $( Extend class notation to include indexed intersection.  Note:
     Historically (prior to 21-Oct-2005), set.mm used the notation
     ` |^| x e. A B ` , with the same intersection symbol as ~ cint .  Although
     that syntax was unambiguous, it did not allow for LALR parsing of the
     syntax constructions in set.mm.  The new syntax uses a distinguished
     symbol ` |^|_ ` instead of ` |^| ` and does allow LALR parsing.  Thanks to
     Peter Backes for suggesting this change. $)
  ciin $a class |^|_ x e. A B $.

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Define indexed union.  Definition indexed union in [Stoll] p. 45.  In
       most applications, ` A ` is independent of ` x ` (although this is not
       required by the definition), and ` B ` depends on ` x ` i.e. can be read
       informally as ` B ( x ) ` .  We call ` x ` the index, ` A ` the index
       set, and ` B ` the indexed set.  In most books, ` x e. A ` is written as
       a subscript or underneath a union symbol ` U. ` .  We use a special
       union symbol ` U_ ` to make it easier to distinguish from plain class
       union.  In many theorems, you will see that ` x ` and ` A ` are in the
       same distinct variable group (meaning ` A ` cannot depend on ` x ` ) and
       that ` B ` and ` x ` do not share a distinct variable group (meaning
       that can be thought of as ` B ( x ) ` i.e. can be substituted with a
       class expression containing ` x ` ).  An alternate definition tying
       indexed union to ordinary union is ~ dfiun2 .  Theorem ~ uniiun provides
       a definition of ordinary union in terms of indexed union.  Theorems
       ~ fniunfv and ~ funiunfv are useful when ` B ` is a function.
       (Contributed by NM, 27-Jun-1998.) $)
    df-iun $a |- U_ x e. A B = { y | E. x e. A y e. B } $.

    $( Define indexed intersection.  Definition of [Stoll] p. 45.  See the
       remarks for its sibling operation of indexed union ~ df-iun .  An
       alternate definition tying indexed intersection to ordinary intersection
       is ~ dfiin2 .  Theorem ~ intiin provides a definition of ordinary
       intersection in terms of indexed intersection.  (Contributed by NM,
       27-Jun-1998.) $)
    df-iin $a |- |^|_ x e. A B = { y | A. x e. A y e. B } $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y C $.
    $( Membership in indexed union.  (Contributed by NM, 3-Sep-2003.) $)
    eliun $p |- ( A e. U_ x e. B C <-> E. x e. B A e. C ) $=
      ( vy ciun wcel wrex elex rexlimivw cv wceq eleq1 rexbidv df-iun pm5.21nii
      cvv elab2g ) BACDFZGBQGZBDGZACHZBSIUATACBDIJEKZDGZACHUBEBSQUCBLUDUAACUCBD
      MNAECDORP $.

    $( Membership in indexed intersection.  (Contributed by NM, 3-Sep-2003.) $)
    eliin $p |- ( A e. V -> ( A e. |^|_ x e. B C <-> A. x e. B A e. C ) ) $=
      ( vy cv wcel wral ciin wceq eleq1 ralbidv df-iin elab2g ) FGZDHZACIBDHZAC
      IFBACDJEPBKQRACPBDLMAFCDNO $.
  $}

  ${
    $d y z A $.  $d x z B $.  $d z C $.  $d x y $.
    $( Commutation of indexed unions.  (Contributed by NM, 18-Dec-2008.) $)
    iuncom $p |- U_ x e. A U_ y e. B C = U_ y e. B U_ x e. A C $=
      ( vz ciun cv wcel wrex rexcom eliun rexbii 3bitr4i eqriv ) FACBDEGZGZBDAC
      EGZGZFHZPIZACJZTRIZBDJZTQITSITEIZBDJZACJUEACJZBDJUBUDUEABCDKUAUFACBTDELMU
      CUGBDATCELMNATCPLBTDRLNO $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d x y z $.
    $( Commutation of union with indexed union.  (Contributed by Mario
       Carneiro, 18-Jan-2014.) $)
    iuncom4 $p |- U_ x e. A U. B = U. U_ x e. A B $=
      ( vy vz cuni ciun cv wcel wa wex df-rex rexbii rexcom4 bitri exbii eluni2
      wrex eliun 3bitr4i r19.41v anbi1i eqriv ) DABCFZGZABCGZFZDHZUDIZABRZUHEHZ
      IZEUFRZUHUEIUHUGIULECRZABRZUKCIZABRZULJZEKZUJUMUOUPULJZABRZEKZUSUOUTEKZAB
      RVBUNVCABULECLMUTAEBNOVAUREUPULABUAPOUIUNABEUHCQMUMUKUFIZULJZEKUSULEUFLVE
      UREVDUQULAUKBCSUBPOTAUHBUDSEUHUFQTUC $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Indexed union of a constant class, i.e. where ` B ` does not depend on
       ` x ` .  (Contributed by NM, 5-Sep-2004.)  (Proof shortened by Andrew
       Salmon, 25-Jul-2011.) $)
    iunconst $p |- ( A =/= (/) -> U_ x e. A B = B ) $=
      ( vy c0 wne ciun cv wcel wrex r19.9rzv eliun syl6rbbr eqrdv ) BEFZDABCGZC
      ODHZCIZRABJQPIRABKAQBCLMN $.

    $( Indexed intersection of a constant class, i.e. where ` B ` does not
       depend on ` x ` .  (Contributed by Mario Carneiro, 6-Feb-2015.) $)
    iinconst $p |- ( A =/= (/) -> |^|_ x e. A B = B ) $=
      ( vy c0 wne ciin cv wcel wral r19.3rzv cvv vex eliin ax-mp syl6rbbr eqrdv
      wb ) BEFZDABCGZCSDHZCIZUBABJZUATIZUBABKUALIUDUCRDMAUABCLNOPQ $.
  $}

  ${
    $d x y $.  $d y z A $.  $d x z B $.  $d z C $.
    $( Law combining indexed union with indexed intersection.  Eq. 14 in
       [KuratowskiMostowski] p. 109.  This theorem also appears as the last
       example at ~ http://en.wikipedia.org/wiki/Union%5F%28set%5Ftheory%29 .
       (Contributed by NM, 17-Aug-2004.)  (Proof shortened by Andrew Salmon,
       25-Jul-2011.) $)
    iuniin $p |- U_ x e. A |^|_ y e. B C C_ |^|_ y e. B U_ x e. A C $=
      ( vz ciin ciun cv wcel wrex wral r19.12 cvv vex eliin ax-mp eliun 3imtr4i
      wb rexbii ralbii ssriv ) FACBDEGZHZBDACEHZGZFIZUDJZACKZUHUFJZBDLZUHUEJUHU
      GJZUHEJZBDLZACKUNACKZBDLUJULUNABCDMUIUOACUHNJZUIUOTFOZBUHDENPQUAUKUPBDAUH
      CERUBSAUHCUDRUQUMULTURBUHDUFNPQSUC $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Subclass theorem for indexed union.  (Contributed by NM, 10-Dec-2004.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    iunss1 $p |- ( A C_ B -> U_ x e. A C C_ U_ x e. B C ) $=
      ( vy wss ciun cv wcel wrex ssrexv eliun 3imtr4g ssrdv ) BCFZEABDGZACDGZOE
      HZDIZABJSACJRPIRQISABCKARBDLARCDLMN $.

    $( Subclass theorem for indexed union.  (Contributed by NM,
       24-Jan-2012.) $)
    iinss1 $p |- ( A C_ B -> |^|_ x e. B C C_ |^|_ x e. A C ) $=
      ( vy wss ciin cv wcel wral ssralv cvv wb vex eliin ax-mp 3imtr4g ssrdv )
      BCFZEACDGZABDGZSEHZDIZACJZUCABJZUBTIZUBUAIZUCABCKUBLIZUFUDMENZAUBCDLOPUHU
      GUEMUIAUBBDLOPQR $.

    $( Equality theorem for indexed union.  (Contributed by NM,
       27-Jun-1998.) $)
    iuneq1 $p |- ( A = B -> U_ x e. A C = U_ x e. B C ) $=
      ( wss wa ciun wceq iunss1 anim12i eqss 3imtr4i ) BCEZCBEZFABDGZACDGZEZPOE
      ZFBCHOPHMQNRABCDIACBDIJBCKOPKL $.

    $( Equality theorem for restricted existential quantifier.  (Contributed by
       NM, 27-Jun-1998.) $)
    iineq1 $p |- ( A = B -> |^|_ x e. A C = |^|_ x e. B C ) $=
      ( vy wceq cv wcel wral cab ciin raleq abbidv df-iin 3eqtr4g ) BCFZEGDHZAB
      IZEJQACIZEJABDKACDKPRSEQABCLMAEBDNAECDNO $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Subclass theorem for indexed union.  (Contributed by NM, 26-Nov-2003.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    ss2iun $p |- ( A. x e. A B C_ C -> U_ x e. A B C_ U_ x e. A C ) $=
      ( vy wss wral ciun cv wcel wrex ssel ralimi rexim syl eliun 3imtr4g ssrdv
      wi ) CDFZABGZEABCHZABDHZUAEIZCJZABKZUDDJZABKZUDUBJUDUCJUAUEUGSZABGUFUHSTU
      IABCDUDLMUEUGABNOAUDBCPAUDBDPQR $.

    $( Equality theorem for indexed union.  (Contributed by NM,
       22-Oct-2003.) $)
    iuneq2 $p |- ( A. x e. A B = C -> U_ x e. A B = U_ x e. A C ) $=
      ( wss wral wa ciun wceq ss2iun anim12i eqss ralbii r19.26 bitri 3imtr4i )
      CDEZABFZDCEZABFZGZABCHZABDHZEZUCUBEZGCDIZABFZUBUCIRUDTUEABCDJABDCJKUGQSGZ
      ABFUAUFUHABCDLMQSABNOUBUCLP $.

    $( Equality theorem for indexed intersection.  (Contributed by NM,
       22-Oct-2003.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    iineq2 $p |- ( A. x e. A B = C -> |^|_ x e. A B = |^|_ x e. A C ) $=
      ( vy wceq wral cv wcel cab ciin wb eleq2 ralimi syl abbidv df-iin 3eqtr4g
      ralbi ) CDFZABGZEHZCIZABGZEJUBDIZABGZEJABCKABDKUAUDUFEUAUCUELZABGUDUFLTUG
      ABCDUBMNUCUEABSOPAEBCQAEBDQR $.
  $}

  ${
    iuneq2i.1 $e |- ( x e. A -> B = C ) $.
    $( Equality inference for indexed union.  (Contributed by NM,
       22-Oct-2003.) $)
    iuneq2i $p |- U_ x e. A B = U_ x e. A C $=
      ( wceq ciun iuneq2 mprg ) CDFABCGABDGFABABCDHEI $.

    $( Equality inference for indexed intersection.  (Contributed by NM,
       22-Oct-2003.) $)
    iineq2i $p |- |^|_ x e. A B = |^|_ x e. A C $=
      ( wceq ciin iineq2 mprg ) CDFABCGABDGFABABCDHEI $.
  $}

  ${
    iineq2d.1 $e |- F/ x ph $.
    iineq2d.2 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Equality deduction for indexed intersection.  (Contributed by NM,
       7-Dec-2011.) $)
    iineq2d $p |- ( ph -> |^|_ x e. A B = |^|_ x e. A C ) $=
      ( wceq wral ciin cv wcel ex ralrimi iineq2 syl ) ADEHZBCIBCDJBCEJHAQBCFAB
      KCLQGMNBCDEOP $.
  $}

  ${
    $d x ph $.
    iuneq2dv.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Equality deduction for indexed union.  (Contributed by NM,
       3-Aug-2004.) $)
    iuneq2dv $p |- ( ph -> U_ x e. A B = U_ x e. A C ) $=
      ( wceq wral ciun ralrimiva iuneq2 syl ) ADEGZBCHBCDIBCEIGAMBCFJBCDEKL $.

    $( Equality deduction for indexed intersection.  (Contributed by NM,
       3-Aug-2004.) $)
    iineq2dv $p |- ( ph -> |^|_ x e. A B = |^|_ x e. A C ) $=
      ( nfv iineq2d ) ABCDEABGFH $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y D $.  $d y ph $.
    iuneq12df.1 $e |- F/ x ph $.
    iuneq12df.2 $e |- F/_ x A $.
    iuneq12df.3 $e |- F/_ x B $.
    iuneq12df.4 $e |- ( ph -> A = B ) $.
    iuneq12df.5 $e |- ( ph -> C = D ) $.
    $( Equality deduction for indexed union, deduction version.  (Contributed
       by Thierry Arnoux, 31-Dec-2016.) $)
    iuneq12df $p |- ( ph -> U_ x e. A C = U_ x e. B D ) $=
      ( vy cv wcel wrex wb ciun wceq cab df-iun eleq2d rexeqbid alrimiv eqeq12i
      wal abbi bitr4i sylib ) ALMZENZBCOZUIFNZBDOZPZLUEZBCEQZBDFQZRZAUNLAUJULBC
      DGHIJAEFUIKUAUBUCUOUKLSZUMLSZRURUKUMLUFUPUSUQUTBLCETBLDFTUDUGUH $.
  $}

  ${
    $d x A $.  $d x B $.
    iuneq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for indexed union, deduction version.  (Contributed by
       Drahflow, 22-Oct-2015.) $)
    iuneq1d $p |- ( ph -> U_ x e. A C = U_ x e. B C ) $=
      ( wceq ciun iuneq1 syl ) ACDGBCEHBDEHGFBCDEIJ $.

    ${
      $d x ph $.
      iuneq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for indexed union, deduction version.  (Contributed
         by Drahflow, 22-Oct-2015.) $)
      iuneq12d $p |- ( ph -> U_ x e. A C = U_ x e. B D ) $=
        ( ciun iuneq1d wceq cv wcel adantr iuneq2dv eqtrd ) ABCEIBDEIBDFIABCDEG
        JABDEFAEFKBLDMHNOP $.
    $}
  $}

  ${
    $d x ph $.  $d x A $.
    iuneq2d.2 $e |- ( ph -> B = C ) $.
    $( Equality deduction for indexed union.  (Contributed by Drahflow,
       22-Oct-2015.) $)
    iuneq2d $p |- ( ph -> U_ x e. A B = U_ x e. A C ) $=
      ( wceq cv wcel adantr iuneq2dv ) ABCDEADEGBHCIFJK $.
  $}

  ${
    $d z A $.  $d z B $.  $d x z $.  $d y z $.
    nfiun.1 $e |- F/_ y A $.
    nfiun.2 $e |- F/_ y B $.
    $( Bound-variable hypothesis builder for indexed union.  (Contributed by
       Mario Carneiro, 25-Jan-2014.) $)
    nfiun $p |- F/_ y U_ x e. A B $=
      ( vz ciun cv wcel wrex cab df-iun nfcri nfrex nfab nfcxfr ) BACDHGIDJZACK
      ZGLAGCDMSBGRBACEBGDFNOPQ $.

    $( Bound-variable hypothesis builder for indexed intersection.
       (Contributed by Mario Carneiro, 25-Jan-2014.) $)
    nfiin $p |- F/_ y |^|_ x e. A B $=
      ( vz ciin cv wcel wral cab df-iin nfcri nfral nfab nfcxfr ) BACDHGIDJZACK
      ZGLAGCDMSBGRBACEBGDFNOPQ $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( Bound-variable hypothesis builder for indexed union.  (Contributed by
       NM, 12-Oct-2003.) $)
    nfiu1 $p |- F/_ x U_ x e. A B $=
      ( vy ciun cv wcel wrex cab df-iun nfre1 nfab nfcxfr ) AABCEDFCGZABHZDIADB
      CJOADNABKLM $.

    $( Bound-variable hypothesis builder for indexed intersection.
       (Contributed by NM, 15-Oct-2003.) $)
    nfii1 $p |- F/_ x |^|_ x e. A B $=
      ( vy ciin cv wcel wral cab df-iin nfra1 nfab nfcxfr ) AABCEDFCGZABHZDIADB
      CJOADNABKLM $.
  $}

  ${
    $d y z w A $.  $d y z w B $.  $d w C z $.  $d w x y z $.
    $( Alternate definition of indexed union when ` B ` is a set.  Definition
       15(a) of [Suppes] p. 44.  (Contributed by NM, 23-Mar-2006.)  (Proof
       shortened by Andrew Salmon, 25-Jul-2011.) $)
    dfiun2g $p |- ( A. x e. A B e. C ->
                  U_ x e. A B = U. { y | E. x e. A y = B } ) $=
      ( vz wcel wral ciun cv wceq wrex cab cuni wa wex nfra1 wb rsp syl6bb syl6
      clel3g rexbida rexcom4 r19.41v exbii exancom bitri eliun eluniab 3bitr4g
      imp eqrdv ) DEGZACHZFACDIZBJZDKZACLZBMNZUOFJZDGZACLZVAUQGZUSOBPZVAUPGVAUT
      GUOVCURVDOZACLZBPZVEUOVCVFBPZACLVHUOVBVIACUNACQUOAJCGZVBVIRZUOVJUNVKUNACS
      BVADEUBUAULUCVFABCUDTVHUSVDOZBPVEVGVLBURVDACUEUFUSVDBUGUHTAVACDUIUSBVAUJU
      KUM $.

    $( Alternate definition of indexed intersection when ` B ` is a set.
       (Contributed by Jeff Hankins, 27-Aug-2009.) $)
    dfiin2g $p |- ( A. x e. A B e. C
               -> |^|_ x e. A B = |^| { y | E. x e. A y = B } ) $=
      ( vw vz wcel wral cv cab wceq wrex wi wal df-ral wb eqeq1 albii bitr4i
      ciin cint eleq2 biimprcd alrimiv eqid imbi12d mpii impbid2 imim2i pm5.74d
      spcgv alimi albi syl sylbi alcom r19.23v vex rexbidv elab imbi1i 3bitr3ri
      19.21v syl6bb syl5bb abbidv df-iin df-int 3eqtr4g ) DEHZACIZFJZDHZACIZFKG
      JZBJZDLZACMZBKZHZVMVPHZNZGOZFKACDUAVTUBVLVOWDFVOAJCHZVNNZAOZVLWDVNACPVLWG
      WEVPDLZWBNZGOZNZAOZWDVLWEVKNZAOZWGWLQZVKACPWNWFWKQZAOWOWMWPAWMWEVNWJVKVNW
      JQWEVKVNWJVNWIGWHWBVNVPDVMUCZUDUEVKWJDDLZVNDUFWIWRVNNGDEWHWHWRWBVNVPDDRWQ
      UGULUHUIUJUKUMWFWKAUNUOUPWIACIZGOZWEWINZGOZAOZWDWLWTXAAOZGOXCWSXDGWIACPSX
      AAGUQTWSWCGWSWHACMZWBNWCWHWBACURWAXEWBVSXEBVPGUSVQVPLVRWHACVQVPDRUTVAVBTS
      XBWKAWEWIGVDSVCVEVFVGAFCDVHFGVTVIVJ $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    dfiun2.1 $e |- B e. _V $.
    $( Alternate definition of indexed union when ` B ` is a set.  Definition
       15(a) of [Suppes] p. 44.  (Contributed by NM, 27-Jun-1998.)  (Revised by
       David Abernethy, 19-Jun-2012.) $)
    dfiun2 $p |- U_ x e. A B = U. { y | E. x e. A y = B } $=
      ( cvv wcel ciun cv wceq wrex cab cuni dfiun2g a1i mprg ) DFGZACDHBIDJACKB
      LMJACABCDFNQAICGEOP $.

    $( Alternate definition of indexed intersection when ` B ` is a set.
       Definition 15(b) of [Suppes] p. 44.  (Contributed by NM, 28-Jun-1998.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    dfiin2 $p |- |^|_ x e. A B = |^| { y | E. x e. A y = B } $=
      ( cvv wcel ciin cv wceq wrex cab cint dfiin2g a1i mprg ) DFGZACDHBIDJACKB
      LMJACABCDFNQAICGEOP $.
  $}

  ${
    $d x z $.  $d y z w $.  $d z A $.  $d z w B $.  $d z w C $.
    $( Define double indexed union.  (Contributed by FL, 6-Nov-2013.) $)
    dfiunv2 $p |- U_ x e. A U_ y e. B C =
      { z | E. x e. A E. y e. B z e. C } $=
      ( vw ciun cv wcel wrex cab wceq df-iun a1i iuneq2i vex weq eleq1 rexbidv
      elab rexbii abbii 3eqtri ) ADBEFHZHADGIZFJZBEKZGLZHCIZUIJZADKZCLUJFJZBEKZ
      ADKZCLADUEUIUEUIMAIDJBGEFNOPACDUINULUOCUKUNADUHUNGUJCQGCRUGUMBEUFUJFSTUAU
      BUCUD $.
  $}

  ${
    $d z y A $.  $d z x A $.  $d z B $.  $d z C $.
    cbviun.1 $e |- F/_ y B $.
    cbviun.2 $e |- F/_ x C $.
    cbviun.3 $e |- ( x = y -> B = C ) $.
    $( Rule used to change the bound variables in an indexed union, with the
       substitution specified implicitly by the hypothesis.  (Contributed by
       NM, 26-Mar-2006.)  (Revised by Andrew Salmon, 25-Jul-2011.) $)
    cbviun $p |- U_ x e. A B = U_ y e. A C $=
      ( vz cv wcel wrex cab ciun nfcri weq eleq2d cbvrex abbii df-iun 3eqtr4i )
      IJZDKZACLZIMUBEKZBCLZIMACDNBCENUDUFIUCUEABCBIDFOAIEGOABPDEUBHQRSAICDTBICE
      TUA $.

    $( Change bound variables in an indexed intersection.  (Contributed by Jeff
       Hankins, 26-Aug-2009.)  (Revised by Mario Carneiro, 14-Oct-2016.) $)
    cbviin $p |- |^|_ x e. A B = |^|_ y e. A C $=
      ( vz cv wcel wral cab ciin nfcri weq eleq2d cbvral abbii df-iin 3eqtr4i )
      IJZDKZACLZIMUBEKZBCLZIMACDNBCENUDUFIUCUEABCBIDFOAIEGOABPDEUBHQRSAICDTBICE
      TUA $.
  $}

  ${
    $d x A $.  $d y A $.  $d y z B $.  $d x z C $.
    cbviunv.1 $e |- ( x = y -> B = C ) $.
    $( Rule used to change the bound variables in an indexed union, with the
       substitution specified implicitly by the hypothesis.  (Contributed by
       NM, 15-Sep-2003.) $)
    cbviunv $p |- U_ x e. A B = U_ y e. A C $=
      ( nfcv cbviun ) ABCDEBDGAEGFH $.

    $( Change bound variables in an indexed intersection.  (Contributed by Jeff
       Hankins, 26-Aug-2009.) $)
    cbviinv $p |- |^|_ x e. A B = |^|_ y e. A C $=
      ( nfcv cbviin ) ABCDEBDGAEGFH $.
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset theorem for an indexed union.  (Contributed by NM, 13-Sep-2003.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    iunss $p |- ( U_ x e. A B C_ C <-> A. x e. A B C_ C ) $=
      ( vy ciun wss cv wcel wrex cab wal wral df-iun sseq1i abss ralbii ralcom4
      wi dfss2 r19.23v albii 3bitrri 3bitri ) ABCFZDGEHZCIZABJZEKZDGUHUFDIZSZEL
      ZCDGZABMZUEUIDAEBCNOUHEDPUNUGUJSZELZABMUOABMZELULUMUPABECDTQUOAEBRUQUKEUG
      UJABUAUBUCUD $.
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset implication for an indexed union.  (Contributed by NM,
       3-Sep-2003.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    ssiun $p |- ( E. x e. A C C_ B -> C C_ U_ x e. A B ) $=
      ( vy wss wrex ciun cv wcel ssel reximi r19.37av syl eliun syl6ibr ssrdv
      wi ) DCFZABGZEDABCHZTEIZDJZUBCJZABGZUBUAJTUCUDRZABGUCUERSUFABDCUBKLUCUDAB
      MNAUBBCOPQ $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( Identity law for subset of an indexed union.  (Contributed by NM,
       12-Oct-2003.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    ssiun2 $p |- ( x e. A -> B C_ U_ x e. A B ) $=
      ( vy cv wcel ciun wrex rspe ex eliun syl6ibr ssrdv ) AEBFZDCABCGZNDEZCFZQ
      ABHZPOFNQRQABIJAPBCKLM $.
  $}

  ${
    $d x A $.  $d x C $.  $d x D $.
    ssiun2s.1 $e |- ( x = C -> B = D ) $.
    $( Subset relationship for an indexed union.  (Contributed by NM,
       26-Oct-2003.) $)
    ssiun2s $p |- ( C e. A -> D C_ U_ x e. A B ) $=
      ( ciun wss nfcv nfiu1 nfss cv wceq sseq1d ssiun2 vtoclgaf ) CABCGZHEQHADB
      ADIAEQAEIABCJKALDMCEQFNABCOP $.
  $}

  ${
    $d x y $.  $d x B $.  $d y C $.  $d x D $.
    $( A subclass condition on the members of two indexed classes ` C ( x ) `
       and ` D ( y ) ` that implies a subclass relation on their indexed
       unions.  Generalization of Proposition 8.6 of [TakeutiZaring] p. 59.
       Compare ~ uniss2 .  (Contributed by NM, 9-Dec-2004.) $)
    iunss2 $p |- ( A. x e. A E. y e. B C C_ D ->
                 U_ x e. A C C_ U_ y e. B D ) $=
      ( wss wrex wral ciun ssiun ralimi iunss sylibr ) EFGBDHZACIEBDFJZGZACIACE
      JPGOQACBDFEKLACEPMN $.
  $}

  ${
    $d y A $.  $d x y $.  $d x B $.
    $( The indexed union of a class abstraction.  (Contributed by NM,
       27-Dec-2004.) $)
    iunab $p |- U_ x e. A { y | ph } = { y | E. x e. A ph } $=
      ( cab ciun wrex wceq cv wcel wb nfcv nfab1 nfiun cleqf abid eliun 3bitr4i
      rexbii mpgbir ) BDACEZFZABDGZCEZHCIZUBJZUEUDJZKCCUBUDBCDUACDLACMNUCCMOUEU
      AJZBDGUCUFUGUHABDACPSBUEDUAQUCCPRT $.

    $( The indexed union of a restricted class abstraction.  (Contributed by
       NM, 3-Jan-2004.)  (Proof shortened by Mario Carneiro, 14-Nov-2016.) $)
    iunrab $p |- U_ x e. A { y e. B | ph } = { y e. B | E. x e. A ph } $=
      ( cv wcel cab ciun wrex crab iunab wceq df-rab a1i iuneq2i r19.42v eqtr4i
      wa abbii 3eqtr4i ) BDCFEGZASZCHZIUCBDJZCHZBDACEKZIABDJZCEKZUCBCDLBDUGUDUG
      UDMBFDGACENOPUIUBUHSZCHUFUHCENUEUJCUBABDQTRUA $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    iunxdif2.1 $e |- ( x = y -> C = D ) $.
    $( Indexed union with a class difference as its index.  (Contributed by NM,
       10-Dec-2004.) $)
    iunxdif2 $p |- ( A. x e. A E. y e. ( A \ B ) C C_ D ->
                 U_ y e. ( A \ B ) D = U_ x e. A C ) $=
      ( wss cdif wrex wral ciun wceq iunss2 difss iunss1 ax-mp cbviunv sseqtr4i
      wa jctil eqss sylibr ) EFHBCDIZJACKZBUDFLZACELZHZUGUFHZTUFUGMUEUIUHABCUDE
      FNUFBCFLZUGUDCHUFUJHCDOBUDCFPQABCEFGRSUAUFUGUBUC $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d x y z $.
    ssiinf.1 $e |- F/_ x C $.
    $( Subset theorem for an indexed intersection.  (Contributed by FL,
       15-Oct-2012.)  (Proof shortened by Mario Carneiro, 14-Oct-2016.) $)
    ssiinf $p |- ( C C_ |^|_ x e. A B <-> A. x e. A C C_ B ) $=
      ( vy cv ciin wcel wral wss cvv vex eliin ax-mp ralbii nfcv ralcomf dfss3
      wb bitri 3bitr4i ) FGZABCHZIZFDJZUCCIZFDJZABJZDUDKDCKZABJUFUGABJZFDJUIUEU
      KFDUCLIUEUKTFMAUCBCLNOPUGFADBEFBQRUAFDUDSUJUHABFDCSPUB $.
  $}

  ${
    $d x C $.
    $( Subset theorem for an indexed intersection.  (Contributed by NM,
       15-Oct-2003.) $)
    ssiin $p |- ( C C_ |^|_ x e. A B <-> A. x e. A C C_ B ) $=
      ( nfcv ssiinf ) ABCDADEF $.
  $}

  ${
    $d x y C $.  $d y A $.  $d y B $.
    $( Subset implication for an indexed intersection.  (Contributed by NM,
       15-Oct-2003.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    iinss $p |- ( E. x e. A B C_ C -> |^|_ x e. A B C_ C ) $=
      ( vy wss wrex ciin cv wcel wral cvv wb vex eliin ax-mp wi reximi r19.36av
      ssel syl syl5bi ssrdv ) CDFZABGZEABCHZDEIZUFJZUGCJZABKZUEUGDJZUGLJUHUJMEN
      AUGBCLOPUEUIUKQZABGUJUKQUDULABCDUGTRUIUKABSUAUBUC $.
  $}

  ${
    $d A y $.  $d B y $.  $d x y $.
    $( An indexed intersection is included in any of its members.  (Contributed
       by FL, 15-Oct-2012.) $)
    iinss2 $p |- ( x e. A -> |^|_ x e. A B C_ B ) $=
      ( vy cv wcel ciin wral wi cvv wb vex eliin ax-mp rsp sylbi com12 ssrdv )
      AEBFZDABCGZCDEZTFZSUACFZUBUCABHZSUCIUAJFUBUDKDLAUABCJMNUCABOPQR $.
  $}

  ${
    $d x y A $.
    $( Class union in terms of indexed union.  Definition in [Stoll] p. 43.
       (Contributed by NM, 28-Jun-1998.) $)
    uniiun $p |- U. A = U_ x e. A x $=
      ( vy cuni wel wrex cab cv ciun dfuni2 df-iun eqtr4i ) BDCAEABFCGABAHZICAB
      JACBMKL $.

    $( Class intersection in terms of indexed intersection.  Definition in
       [Stoll] p. 44.  (Contributed by NM, 28-Jun-1998.) $)
    intiin $p |- |^| A = |^|_ x e. A x $=
      ( vy cint wel wral cab cv ciin dfint2 df-iin eqtr4i ) BDCAEABFCGABAHZICAB
      JACBMKL $.

    $( An indexed union of singletons recovers the index set.  (Contributed by
       NM, 6-Sep-2005.) $)
    iunid $p |- U_ x e. A { x } = A $=
      ( vy cv csn ciun wceq cab wcel df-sn equcom abbii eqtri a1i iuneq2i iunab
      wrex risset abid2 3eqtr2i ) ABADZEZFABUACDZGZCHZFZBABUBUEUBUEGUABIUBUCUAG
      ZCHUECUAJUGUDCCAKLMNOUFUDABQZCHUCBIZCHBUDACBPUIUHCAUCBRLCBSTM $.
  $}

  ${
    $d x y $.  $d y A $.
    $( An indexed union of the empty set is empty.  (Contributed by NM,
       26-Mar-2003.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    iun0 $p |- U_ x e. A (/) = (/) $=
      ( vy c0 ciun cv wcel wrex wn noel a1i nrex eliun mtbir 2false eqriv ) CAB
      DEZDCFZQGZRDGZSTABHTABTIAFBGRJZKLARBDMNUAOP $.

    $( An empty indexed union is empty.  (Contributed by NM, 4-Dec-2004.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    0iun $p |- U_ x e. (/) A = (/) $=
      ( vy c0 ciun cv wcel wrex rex0 eliun mtbir noel 2false eqriv ) CADBEZDCFZ
      OGZPDGQPBGZADHRAIAPDBJKPLMN $.

    $( An empty indexed intersection is the universal class.  (Contributed by
       NM, 20-Oct-2005.) $)
    0iin $p |- |^|_ x e. (/) A = _V $=
      ( vy c0 ciin cv wcel wral cab cvv df-iin vex ral0 2th abbi2i eqtr4i ) ADB
      ECFZBGZADHZCIJACDBKSCJQJGSCLRAMNOP $.

    $( Indexed intersection with a universal index class.  When ` A ` doesn't
       depend on ` x ` , this evaluates to ` A ` by ~ 19.3 and ~ abid2 .  When
       ` A = x ` , this evaluates to ` (/) ` by ~ intiin and ~ intv .
       (Contributed by NM, 11-Sep-2008.) $)
    viin $p |- |^|_ x e. _V A = { y | A. x y e. A } $=
      ( cvv ciin cv wcel wral cab wal df-iin ralv abbii eqtri ) ADCEBFCGZADHZBI
      OAJZBIABDCKPQBOALMN $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( There is a non-empty class in an indexed collection ` B ( x ) ` iff the
       indexed union of them is non-empty.  (Contributed by NM, 15-Oct-2003.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    iunn0 $p |- ( E. x e. A B =/= (/) <-> U_ x e. A B =/= (/) ) $=
      ( vy cv wcel wex wrex c0 wne rexcom4 eliun exbii bitr4i n0 rexbii 3bitr4i
      ciun ) DEZCFZDGZABHZSABCRZFZDGZCIJZABHUCIJUBTABHZDGUETADBKUDUGDASBCLMNUFU
      AABDCOPDUCOQ $.
  $}

  ${
    $d y A $.  $d x y $.
    $( Indexed intersection of a class builder.  (Contributed by NM,
       6-Dec-2011.) $)
    iinab $p |- |^|_ x e. A { y | ph } = { y | A. x e. A ph } $=
      ( cab ciin wral wceq cv wcel nfcv nfab1 nfiin cleqf abid ralbii cvv eliin
      wb vex ax-mp 3bitr4i mpgbir ) BDACEZFZABDGZCEZHCIZUEJZUHUGJZSCCUEUGBCDUDC
      DKACLMUFCLNUHUDJZBDGZUFUIUJUKABDACOPUHQJUIULSCTBUHDUDQRUAUFCOUBUC $.

    $d x A $.  $d x B $.
    $( Indexed intersection of a restricted class builder.  (Contributed by NM,
       6-Dec-2011.) $)
    iinrab $p |- ( A =/= (/)
          -> |^|_ x e. A { y e. B | ph } = { y e. B | A. x e. A ph } ) $=
      ( c0 wne cv wcel wa wral cab crab ciin r19.28zv abbidv df-rab a1i iineq2i
      wceq iinab eqtri 3eqtr4g ) DFGZCHEIZAJZBDKZCLZUEABDKZJZCLBDACEMZNZUICEMUD
      UGUJCUEABDOPULBDUFCLZNUHBDUKUMUKUMTBHDIACEQRSUFBCDUAUBUICEQUC $.

    $d y B $.
    $( Indexed intersection of a restricted class builder.  (Contributed by NM,
       6-Dec-2011.) $)
    iinrab2 $p |- ( |^|_ x e. A { y e. B | ph } i^i B )
                      = { y e. B | A. x e. A ph } $=
      ( crab ciin cin wral wceq c0 cvv iineq1 0iin syl6eq incom inv1 eqtri rzal
      ineq1d rabid2 ralcom bitr2i sylib wne iinrab wss ssrab2 dfss mpbi syl6eqr
      eqtrd pm2.61ine ) BDACEFZGZEHZABDIZCEFZJDKDKJZUPEURUSUPLEHZEUSUOLEUSUOBKU
      NGLBDKUNMBUNNOTUTELHELEPEQROUSACEIZBDIZEURJZVABDSVCUQCEIVBUQCEUAACBEDUBUC
      UDULDKUEZUPUREHZURVDUOUREABCDEUFTUREUGURVEJUQCEUHUREUIUJUKUM $.
  $}

  ${
    $d y A $.  $d x y B $.  $d y C $.
    $( Indexed union of intersection.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ uniiun to recover
       Enderton's theorem.  (Contributed by NM, 26-Mar-2004.) $)
    iunin2 $p |- U_ x e. A ( B i^i C ) = ( B i^i U_ x e. A C ) $=
      ( vy cin ciun cv wcel wrex r19.42v elin rexbii eliun anbi2i 3bitr4i eqriv
      wa ) EABCDFZGZCABDGZFZEHZSIZABJZUCCIZUCUAIZRZUCTIUCUBIUFUCDIZRZABJUFUIABJ
      ZRUEUHUFUIABKUDUJABUCCDLMUGUKUFAUCBDNOPAUCBSNUCCUALPQ $.

    $( Indexed union of intersection.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ uniiun to recover
       Enderton's theorem.  (Contributed by Mario Carneiro, 30-Aug-2015.) $)
    iunin1 $p |- U_ x e. A ( C i^i B ) = ( U_ x e. A C i^i B ) $=
      ( cin ciun iunin2 wceq cv wcel incom a1i iuneq2i 3eqtr4i ) ABCDEZFCABDFZE
      ABDCEZFPCEABCDGABQOQOHAIBJDCKLMPCKN $.

    $( Indexed intersection of union.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ intiin to recover
       Enderton's theorem.  (Contributed by NM, 19-Aug-2004.) $)
    iinun2 $p |- |^|_ x e. A ( B u. C ) = ( B u. |^|_ x e. A C ) $=
      ( vy cun ciin cv wcel wral wo r19.32v elun ralbii cvv eliin ax-mp 3bitr4i
      wb vex orbi2i eqriv ) EABCDFZGZCABDGZFZEHZUCIZABJZUGCIZUGUEIZKZUGUDIZUGUF
      IUJUGDIZKZABJUJUNABJZKUIULUJUNABLUHUOABUGCDMNUKUPUJUGOIZUKUPSETZAUGBDOPQU
      ARUQUMUISURAUGBUCOPQUGCUEMRUB $.

    $( Indexed union of class difference.  Generalization of half of theorem
       "De Morgan's laws" in [Enderton] p. 31.  Use ~ intiin to recover
       Enderton's theorem.  (Contributed by NM, 19-Aug-2004.) $)
    iundif2 $p |- U_ x e. A ( B \ C ) = ( B \ |^|_ x e. A C ) $=
      ( vy cdif ciun ciin cv wcel wrex wn wa eldif rexbii r19.42v rexnal cvv wb
      wral vex eliin ax-mp xchbinxr anbi2i 3bitri eliun 3bitr4i eqriv ) EABCDFZ
      GZCABDHZFZEIZUJJZABKZUNCJZUNULJZLZMZUNUKJUNUMJUPUQUNDJZLZMZABKUQVBABKZMUT
      UOVCABUNCDNOUQVBABPVDUSUQVDVAABTZURVAABQUNRJURVESEUAAUNBDRUBUCUDUEUFAUNBU
      JUGUNCULNUHUI $.
  $}

  ${
    $d x B $.  $d y C $.  $d x D $.  $d x y $.
    $( Rearrange indexed unions over intersection.  (Contributed by NM,
       18-Dec-2008.) $)
    2iunin $p |- U_ x e. A U_ y e. B ( C i^i D )
        = ( U_ x e. A C i^i U_ y e. B D ) $=
      ( cin ciun wceq cv wcel iunin2 a1i iuneq2i iunin1 eqtri ) ACBDEFGHZHACEBD
      FHZGZHACEHRGACQSQSIAJCKBDEFLMNACREOP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Indexed intersection of class difference.  Generalization of half of
       theorem "De Morgan's laws" in [Enderton] p. 31.  Use ~ uniiun to recover
       Enderton's theorem.  (Contributed by NM, 5-Oct-2006.) $)
    iindif2 $p |- ( A =/= (/) ->
                 |^|_ x e. A ( B \ C ) = ( B \ U_ x e. A C ) ) $=
      ( vy c0 wne cdif ciin ciun cv wcel wn wa r19.28zv eldif bicomi ralbii cvv
      wral wrex ralnex eliun xchbinxr anbi2i 3bitr3g wb vex eliin ax-mp 3bitr4g
      eqrdv ) BFGZEABCDHZIZCABDJZHZUMEKZUNLZABTZURCLZURUPLZMZNZURUOLZURUQLUMVAU
      RDLZMZNZABTVAVGABTZNUTVDVAVGABOVHUSABUSVHURCDPQRVIVCVAVIVFABUAVBVFABUBAUR
      BDUCUDUEUFURSLVEUTUGEUHAURBUNSUIUJURCUPPUKUL $.

    $( Indexed intersection of intersection.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ intiin to recover
       Enderton's theorem.  (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    iinin2 $p |- ( A =/= (/) ->
      |^|_ x e. A ( B i^i C ) = ( B i^i |^|_ x e. A C ) ) $=
      ( vy c0 wne cin ciin cv wcel wral wa r19.28zv elin wb eliin ax-mp 3bitr4g
      cvv ralbii vex anbi2i eqrdv ) BFGZEABCDHZIZCABDIZHZUEEJZUFKZABLZUJCKZUJUH
      KZMZUJUGKZUJUIKUEUMUJDKZMZABLUMUQABLZMULUOUMUQABNUKURABUJCDOUAUNUSUMUJTKZ
      UNUSPEUBZAUJBDTQRUCSUTUPULPVAAUJBUFTQRUJCUHOSUD $.

    $( Indexed intersection of intersection.  Generalization of half of theorem
       "Distributive laws" in [Enderton] p. 30.  Use ~ intiin to recover
       Enderton's theorem.  (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    iinin1 $p |- ( A =/= (/) ->
      |^|_ x e. A ( C i^i B ) = ( |^|_ x e. A C i^i B ) ) $=
      ( c0 wne cin ciin iinin2 wceq cv wcel incom a1i iineq2i 3eqtr4g ) BEFABCD
      GZHCABDHZGABDCGZHRCGABCDIABSQSQJAKBLDCMNORCMP $.
  $}

  ${
    $d x A $.
    $( The indexed intersection of a complement.  (Contributed by G&eacute;rard
       Lang, 5-Aug-2018.) $)
    iinvdif $p |- |^|_ x e. A ( _V \ B ) = ( _V \ U_ x e. A B ) $=
      ( cvv cdif ciin ciun wceq c0 dif0 0iun difeq2i 0iin iineq1 iuneq1 difeq2d
      3eqtr4ri 3eqtr4a iindif2 pm2.61ine ) ABDCEZFZDABCGZEZHBIBIHZAIUAFZDAICGZE
      ZUBUDDIEDUHUFDJUGIDACKLAUAMQABIUANUEUCUGDABICOPRABDCST $.
  $}

  ${
    $d A x y $.  $d X x y $.  $d B x $.
    $( Elementhood in a relative intersection.  (Contributed by Mario Carneiro,
       30-Dec-2016.) $)
    elriin $p |- ( B e. ( A i^i |^|_ x e. X S ) <->
      ( B e. A /\ A. x e. X B e. S ) ) $=
      ( ciin cin wcel wa wral elin eliin pm5.32i bitri ) CBAEDFZGHCBHZCOHZIPCDH
      AEJZICBOKPQRACEDBLMN $.

    $( Relative intersection of an empty family.  (Contributed by Stefan
       O'Rear, 3-Apr-2015.) $)
    riin0 $p |- ( X = (/) -> ( A i^i |^|_ x e. X S ) = A ) $=
      ( c0 wceq ciin cin iineq1 ineq2d cvv 0iin ineq2i inv1 eqtri syl6eq ) DEFZ
      BADCGZHBAECGZHZBQRSBADECIJTBKHBSKBACLMBNOP $.

    $( Relative intersection of a nonempty family.  (Contributed by Stefan
       O'Rear, 3-Apr-2015.) $)
    riinn0 $p |- ( ( A. x e. X S C_ A /\ X =/= (/) ) ->
        ( A i^i |^|_ x e. X S ) = |^|_ x e. X S ) $=
      ( wss wral c0 wne wa ciin incom wceq wrex r19.2z ancoms iinss df-ss sylib
      cin syl syl5eq ) CBEZADFZDGHZIZBADCJZSUFBSZUFBUFKUEUFBEZUGUFLUEUBADMZUHUD
      UCUIUBADNOADCBPTUFBQRUA $.

    $( Relative intersection of a relative abstraction.  (Contributed by Stefan
       O'Rear, 3-Apr-2015.) $)
    riinrab $p |- ( A i^i |^|_ x e. X { y e. A | ph } ) =
        { y e. A | A. x e. X ph } $=
      ( crab ciin cin wral wceq c0 riin0 rzal ralrimivw rabid2 sylibr eqtrd wne
      wss ssrab2 rgenw riinn0 mpan iinrab pm2.61ine ) DBEACDFZGZHZABEIZCDFZJEKE
      KJZUHDUJBDUFELUKUICDIDUJJUKUICDABEMNUICDOPQEKRZUHUGUJUFDSZBEIULUHUGJUMBEA
      CDTUABDUFEUBUCABCEDUDQUE $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d y V $.
    iinxsng.1 $e |- ( x = A -> B = C ) $.
    $( A singleton index picks out an instance of an indexed intersection's
       argument.  (Contributed by NM, 15-Jan-2012.)  (Proof shortened by Mario
       Carneiro, 17-Nov-2016.) $)
    iinxsng $p |- ( A e. V -> |^|_ x e. { A } B = C ) $=
      ( vy wcel csn ciin cv wral cab df-iin wceq eleq2d ralsng abbi1dv syl5eq )
      BEHZABIZCJGKZCHZAUALZGMDAGUACNTUDGDUCUBDHABEAKBOCDUBFPQRS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x y D $.  $d x y E $.  $d y V $.
    $d y W $.
    iinxprg.1 $e |- ( x = A -> C = D ) $.
    iinxprg.2 $e |- ( x = B -> C = E ) $.
    $( Indexed intersection with an unordered pair index.  (Contributed by NM,
       25-Jan-2012.) $)
    iinxprg $p |- ( ( A e. V /\ B e. W )
        -> |^|_ x e. { A , B } C = ( D i^i E ) ) $=
      ( vy wcel wa cv cpr wral cab ciin wceq eleq2d ralprg abbidv df-in 3eqtr4g
      cin df-iin ) BGLCHLMZKNZDLZABCOZPZKQUHELZUHFLZMZKQAUJDREFUEUGUKUNKUIULUMA
      BCGHANZBSDEUHITUOCSDFUHJTUAUBAKUJDUFKEFUCUD $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d y V $.
    iunxsng.1 $e |- ( x = A -> B = C ) $.
    $( A singleton index picks out an instance of an indexed union's argument.
       (Contributed by Mario Carneiro, 25-Jun-2016.) $)
    iunxsng $p |- ( A e. V -> U_ x e. { A } B = C ) $=
      ( vy wcel csn ciun cv wrex eliun wceq eleq2d rexsng syl5bb eqrdv ) BEHZGA
      BIZCJZDGKZUAHUBCHZATLSUBDHZAUBTCMUCUDABEAKBNCDUBFOPQR $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.
    iunxsn.1 $e |- A e. _V $.
    iunxsn.2 $e |- ( x = A -> B = C ) $.
    $( A singleton index picks out an instance of an indexed union's argument.
       (Contributed by NM, 26-Mar-2004.)  (Proof shortened by Mario Carneiro,
       25-Jun-2016.) $)
    iunxsn $p |- U_ x e. { A } B = C $=
      ( cvv wcel csn ciun wceq iunxsng ax-mp ) BGHABICJDKEABCDGFLM $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Separate a union in an indexed union.  (Contributed by NM,
       27-Dec-2004.)  (Proof shortened by Mario Carneiro, 17-Nov-2016.) $)
    iunun $p |- U_ x e. A ( B u. C ) = ( U_ x e. A B u. U_ x e. A C ) $=
      ( vy cun ciun cv wcel wrex r19.43 elun rexbii eliun orbi12i 3bitr4i eqriv
      wo ) EABCDFZGZABCGZABDGZFZEHZSIZABJZUDUAIZUDUBIZRZUDTIUDUCIUDCIZUDDIZRZAB
      JUJABJZUKABJZRUFUIUJUKABKUEULABUDCDLMUGUMUHUNAUDBCNAUDBDNOPAUDBSNUDUAUBLP
      Q $.

    $( Separate a union in the index of an indexed union.  (Contributed by NM,
       26-Mar-2004.)  (Proof shortened by Mario Carneiro, 17-Nov-2016.) $)
    iunxun $p |- U_ x e. ( A u. B ) C = ( U_ x e. A C u. U_ x e. B C ) $=
      ( vy cun ciun cv wcel wrex rexun eliun orbi12i bitr4i elun 3bitr4i eqriv
      wo ) EABCFZDGZABDGZACDGZFZEHZDIZASJZUDUAIZUDUBIZRZUDTIUDUCIUFUEABJZUEACJZ
      RUIUEABCKUGUJUHUKAUDBDLAUDCDLMNAUDSDLUDUAUBOPQ $.
  $}

  ${
    $d x y z $.  $d x z A $.  $d z B $.  $d y z C $.
    $( Separate an indexed union in the index of an indexed union.
       (Contributed by Mario Carneiro, 5-Dec-2016.) $)
    iunxiun $p |- U_ x e. U_ y e. A B C = U_ y e. A U_ x e. B C $=
      ( vz ciun cv wcel wa wex eliun anbi1i r19.41v bitr4i exbii rexcom4 df-rex
      wrex 3bitr4i bitri rexbii eqriv ) FABCDGZEGZBCADEGZGZFHZEIZAUDSZUHUFIZBCS
      ZUHUEIUHUGIAHZUDIZUIJZAKZUMDIZUIJZAKZBCSZUJULUPURBCSZAKUTUOVAAUOUQBCSZUIJ
      VAUNVBUIBUMCDLMUQUIBCNOPURBACQOUIAUDRUKUSBCUKUIADSUSAUHDELUIADRUAUBTAUHUD
      ELBUHCUFLTUC $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A relationship involving union and indexed intersection.  Exercise 23 of
       [Enderton] p. 33.  (Contributed by NM, 25-Nov-2003.)  (Proof shortened
       by Mario Carneiro, 17-Nov-2016.) $)
    iinuni $p |- ( A u. |^| B ) = |^|_ x e. B ( A u. x ) $=
      ( vy cv wcel cint cab cun wral ciin r19.32v elun ralbii vex elint2 orbi2i
      wo 3bitr4ri abbii df-un df-iin 3eqtr4i ) DEZBFZUDCGZFZRZDHUDBAEZIZFZACJZD
      HBUFIACUJKUHULDUEUDUIFZRZACJUEUMACJZRULUHUEUMACLUKUNACUDBUIMNUGUOUEAUDCDO
      PQSTDBUFUAADCUJUBUC $.

    $( A relationship involving union and indexed union.  Exercise 25 of
       [Enderton] p. 33.  (Contributed by NM, 25-Nov-2003.)  (Proof shortened
       by Mario Carneiro, 17-Nov-2016.) $)
    iununi $p |- ( ( B = (/) -> A = (/) ) <->
                ( A u. U. B ) = U_ x e. B ( A u. x ) ) $=
      ( c0 wceq wi cuni cun cv ciun wn wne iunconst sylbir iun0 iuneq2d 3eqtr4a
      df-ne id syl6eq ja eqcomd uneq1d uniiun uneq2i iunun 3eqtr4g unieq uneq2d
      uni0 un0 iuneq1 0iun eqeq12d biimpcd impbii ) CDEZBDEZFZBCGZHZACBAIZHZJZE
      ZUSBACVBJZHACBJZVFHVAVDUSBVGVFUSVGBUQURVGBEZUQKCDLVHCDRACBMNURACDJDVGBACO
      URACBDURSZPVIQUAUBUCUTVFBACUDUEACBVBUFUGUQVEURUQVABVDDUQVABDHBUQUTDBUQUTD
      GDCDUHUJTUIBUKTUQVDADVCJDACDVCULAVCUMTUNUOUP $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Subclass relationship for power class and union.  (Contributed by NM,
       18-Jul-2006.) $)
    sspwuni $p |- ( A C_ ~P B <-> U. A C_ B ) $=
      ( vx cv cpw wcel wral wss cuni vex elpw ralbii dfss3 unissb 3bitr4i ) CDZ
      BEZFZCAGPBHZCAGAQHAIBHRSCAPBCJKLCAQMCABNO $.

    $( Two ways to express a collection of subclasses.  (Contributed by NM,
       19-Jul-2006.) $)
    pwssb $p |- ( A C_ ~P B <-> A. x e. A x C_ B ) $=
      ( cpw wss cuni cv wral sspwuni unissb bitri ) BCDEBFCEAGCEABHBCIABCJK $.
  $}

  $( Relationship for power class and union.  (Contributed by NM,
     18-Jul-2006.) $)
  elpwuni $p |- ( B e. A -> ( A C_ ~P B <-> U. A = B ) ) $=
    ( cpw wss cuni wcel wceq sspwuni unissel expcom eqimss impbid1 syl5bb ) ABC
    DAEZBDZBAFZNBGZABHPOQOPQABIJNBKLM $.

  ${
    $d x y A $.
    $( The power class of an intersection in terms of indexed intersection.
       Exercise 24(a) of [Enderton] p. 33.  (Contributed by NM,
       29-Nov-2003.) $)
    iinpw $p |- ~P |^| A = |^|_ x e. A ~P x $=
      ( vy cint cpw cv ciin wss wcel wral ssint vex elpw ralbii bitr4i wb eliin
      cvv ax-mp 3bitr4i eqriv ) CBDZEZABAFZEZGZCFZUBHZUGUEIZABJZUGUCIUGUFIZUHUG
      UDHZABJUJAUGBKUIULABUGUDCLZMNOUGUBUMMUGRIUKUJPUMAUGBUERQSTUA $.

    $( Inclusion of an indexed union of a power class in the power class of the
       union of its index.  Part of Exercise 24(b) of [Enderton] p. 33.
       (Contributed by NM, 25-Nov-2003.) $)
    iunpwss $p |- U_ x e. A ~P x C_ ~P U. A $=
      ( vy cpw ciun cuni wss wrex wcel ssiun eliun vex elpw rexbii bitri uniiun
      cv sseq2i 3imtr4i ssriv ) CABAQZDZEZBFZDZCQZUAGZABHZUFABUAEZGZUFUCIZUFUEI
      ZABUAUFJUKUFUBIZABHUHAUFBUBKUMUGABUFUACLZMNOULUFUDGUJUFUDUNMUDUIUFABPROST
      $.
  $}

  $( Relative intersection of a nonempty set.  (Contributed by Stefan O'Rear,
     3-Apr-2015.)  (Revised by Mario Carneiro, 5-Jun-2015.) $)
  rintn0 $p |- ( ( X C_ ~P A /\ X =/= (/) ) -> ( A i^i |^| X ) = |^| X ) $=
    ( cpw wss c0 wne wa cint incom wceq cuni intssuni2 ssid sspwuni mpbi syl6ss
    cin df-ss sylib syl5eq ) BACZDBEFGZABHZQUCAQZUCAUCIUBUCADUDUCJUBUCUAKZABUAL
    UAUADUEADUAMUAANOPUCARST $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Disjointness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Disj_ $.

  $( Extend wff notation to include the statement that a family of classes
     ` B ( x ) ` , for ` x e. A ` , is a disjoint family. $)
  wdisj $a wff Disj_ x e. A B $.

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( A collection of classes ` B ( x ) ` is disjoint when for each element
       ` y ` , it is in ` B ( x ) ` for at most one ` x ` .  (Contributed by
       Mario Carneiro, 14-Nov-2016.)  (Revised by NM, 16-Jun-2017.) $)
    df-disj $a |- ( Disj_ x e. A B <-> A. y E* x e. A y e. B ) $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Alternate definition for disjoint classes.  (Contributed by NM,
       17-Jun-2017.) $)
    dfdisj2 $p |- ( Disj_ x e. A B <-> A. y E* x ( x e. A /\ y e. B ) ) $=
      ( wdisj cv wcel wrmo wal wa wmo df-disj df-rmo albii bitri ) ACDEBFDGZACH
      ZBIAFCGPJAKZBIABCDLQRBPACMNO $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( If each element of a collection is contained in a disjoint collection,
       the original collection is also disjoint.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    disjss2 $p |- ( A. x e. A B C_ C ->
      ( Disj_ x e. A C -> Disj_ x e. A B ) ) $=
      ( vy wss wral cv wcel wrmo wal wdisj ssel ralimi rmoim syl alimdv df-disj
      wi 3imtr4g ) CDFZABGZEHZDIZABJZEKUCCIZABJZEKABDLABCLUBUEUGEUBUFUDSZABGUEU
      GSUAUHABCDUCMNUFUDABOPQAEBDRAEBCRT $.
  $}

  $( Equality theorem for disjoint collection.  (Contributed by Mario Carneiro,
     14-Nov-2016.) $)
  disjeq2 $p |- ( A. x e. A B = C ->
    ( Disj_ x e. A B <-> Disj_ x e. A C ) ) $=
    ( wceq wral wdisj wss wi eqimss2 ralimi disjss2 syl eqimss impbid ) CDEZABF
    ZABCGZABDGZQDCHZABFRSIPTABDCJKABDCLMQCDHZABFSRIPUAABCDNKABCDLMO $.

  ${
    $d x ph $.
    disjeq2dv.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Equality deduction for disjoint collection.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    disjeq2dv $p |- ( ph -> ( Disj_ x e. A B <-> Disj_ x e. A C ) ) $=
      ( wceq wral wdisj wb ralrimiva disjeq2 syl ) ADEGZBCHBCDIBCEIJANBCFKBCDEL
      M $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( A subset of a disjoint collection is disjoint.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    disjss1 $p |- ( A C_ B -> ( Disj_ x e. B C -> Disj_ x e. A C ) ) $=
      ( vy wss cv wcel wa wmo wal wdisj wi ssel anim1d alrimiv moim syl dfdisj2
      alimdv 3imtr4g ) BCFZAGZCHZEGDHZIZAJZEKUCBHZUEIZAJZEKACDLABDLUBUGUJEUBUIU
      FMZAKUGUJMUBUKAUBUHUDUEBCUCNOPUIUFAQRTAECDSAEBDSUA $.

    $( Equality theorem for disjoint collection.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    disjeq1 $p |- ( A = B -> ( Disj_ x e. A C <-> Disj_ x e. B C ) ) $=
      ( wceq wdisj wss wi eqimss2 disjss1 syl eqimss impbid ) BCEZABDFZACDFZNCB
      GOPHCBIACBDJKNBCGPOHBCLABCDJKM $.

    disjeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for disjoint collection.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    disjeq1d $p |- ( ph -> ( Disj_ x e. A C <-> Disj_ x e. B C ) ) $=
      ( wceq wdisj wb disjeq1 syl ) ACDGBCEHBDEHIFBCDEJK $.

    $d x ph $.
    disjeq12d.1 $e |- ( ph -> C = D ) $.
    $( Equality theorem for disjoint collection.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    disjeq12d $p |- ( ph -> ( Disj_ x e. A C <-> Disj_ x e. B D ) ) $=
      ( wdisj disjeq1d wceq cv wcel adantr disjeq2dv bitrd ) ABCEIBDEIBDFIABCDE
      GJABDEFAEFKBLDMHNOP $.
  $}

  ${
    $d x y z A $.  $d z B $.  $d z C $.
    cbvdisj.1 $e |- F/_ y B $.
    cbvdisj.2 $e |- F/_ x C $.
    cbvdisj.3 $e |- ( x = y -> B = C ) $.
    $( Change bound variables in a disjoint collection.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    cbvdisj $p |- ( Disj_ x e. A B <-> Disj_ y e. A C ) $=
      ( vz cv wcel wrmo wal wdisj nfcri weq eleq2d cbvrmo albii df-disj 3bitr4i
      ) IJZDKZACLZIMUBEKZBCLZIMACDNBCENUDUFIUCUEABCBIDFOAIEGOABPDEUBHQRSAICDTBI
      CETUA $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C $.
    cbvdisjv.1 $e |- ( x = y -> B = C ) $.
    $( Change bound variables in a disjoint collection.  (Contributed by Mario
       Carneiro, 11-Dec-2016.) $)
    cbvdisjv $p |- ( Disj_ x e. A B <-> Disj_ y e. A C ) $=
      ( nfcv cbvdisj ) ABCDEBDGAEGFH $.
  $}

  ${
    $d z A $.  $d z B $.  $d x z $.  $d y z $.
    nfdisj.1 $e |- F/_ y A $.
    nfdisj.2 $e |- F/_ y B $.
    $( Bound-variable hypothesis builder for disjoint collection.  (Contributed
       by Mario Carneiro, 14-Nov-2016.) $)
    nfdisj $p |- F/ y Disj_ x e. A B $=
      ( vz wdisj cv wcel wa wmo wal dfdisj2 wnf wtru nftru weq wn a1i wnfc trud
      nfcvf nfeld nfcri nfand adantl nfmod2 nfal nfxfr ) ACDHAIZCJZGIDJZKZALZGM
      BAGCDNUOBGUOBOPUNBAAQBARBMSZUNBOPUPULUMBUPBUKCBAUCBCUAUPETUDUMBOUPBGDFUET
      UFUGUHUBUIUJ $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( Bound-variable hypothesis builder for disjoint collection.  (Contributed
       by Mario Carneiro, 14-Nov-2016.) $)
    nfdisj1 $p |- F/ x Disj_ x e. A B $=
      ( vy wdisj cv wcel wrmo wal df-disj nfrmo1 nfal nfxfr ) ABCEDFCGZABHZDIAA
      DBCJOADNABKLM $.
  $}

  ${
    $d i j x A $.  $d j x B $.  $d i x C $.
    disjmo.1 $e |- ( i = j -> B = C ) $.
    $( Two ways to say that a collection ` B ( i ) ` for ` i e. A ` is
       disjoint.  (Contributed by Mario Carneiro, 26-Mar-2015.)  (Revised by
       Mario Carneiro, 14-Nov-2016.) $)
    disjor $p |- ( Disj_ i e. A B <->
      A. i e. A A. j e. A ( i = j \/ ( B i^i C ) = (/) ) ) $=
      ( vx wdisj cv wcel wrmo wal wo wral wi ralcom4 wex bitri bitr4i ralbii c0
      weq cin wceq df-disj wa orcom df-or neq0 elin imbi1i 19.23v 3bitri eleq2d
      wn exbii rmo4 albii 3bitr4i ) DABHGIZBJZDAKZGLZDEUBZBCUCZUAUDZMZEANZDANZD
      GABUEVAUTCJZUFZVDOZEANZGLZDANVMDANZGLVIVCVMDGAPVHVNDAVHVLGLZEANVNVGVPEAVG
      VFVDMVFUOZVDOZVPVDVFUGVFVDUHVRVKGQZVDOVPVQVSVDVQUTVEJZGQVSGVEUIVTVKGUTBCU
      JUPRUKVKVDGULSUMTVLEGAPRTVBVOGVAVJDEAVDBCUTFUNUQURUSS $.

    $( Two ways to say that a collection ` B ( i ) ` for ` i e. A ` is
       disjoint.  (Contributed by Mario Carneiro, 26-Mar-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    disjmoOLD $p |- ( A. x E* i ( i e. A /\ x e. B ) <->
      A. i e. A A. j e. A ( i = j \/ ( B i^i C ) = (/) ) ) $=
      ( cv wcel wa wmo wal wdisj wceq cin c0 wo wral dfdisj2 disjor bitr3i ) EH
      ZBIAHCIJEKALEBCMUBFHNCDOPNQFBREBREABCSBCDEFGTUA $.
  $}

  ${
    $d i j x A $.  $d i j B $.
    $( Two ways to say that a collection ` B ( i ) ` for ` i e. A ` is
       disjoint.  (Contributed by Mario Carneiro, 14-Nov-2016.) $)
    disjors $p |- ( Disj_ x e. A B <-> A. i e. A A. j e. A
      ( i = j \/ ( [_ i / x ]_ B i^i [_ j / x ]_ B ) = (/) ) ) $=
      ( wdisj cv csb wceq c0 wo wral nfcv nfcsb1v csbeq1a cbvdisj csbeq1 disjor
      cin bitri ) ABCFDBADGZCHZFUAEGZIUBAUCCHZSJIKEBLDBLADBCUBDCMAUACNAUACOPBUB
      UDDEAUAUCCQRT $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z C $.  $d x z D $.  $d x y z X $.
    $d x z Y $.
    disji.1 $e |- ( x = X -> B = C ) $.
    disji.2 $e |- ( x = Y -> B = D ) $.
    $( Property of a disjoint collection: if ` B ( X ) = C ` and
       ` B ( Y ) = D ` , and ` X =/= Y ` , then ` C ` and ` D ` are disjoint.
       (Contributed by Mario Carneiro, 14-Nov-2016.) $)
    disji2 $p |- ( ( Disj_ x e. A B /\ ( X e. A /\ Y e. A ) /\
      X =/= Y ) -> ( C i^i D ) = (/) ) $=
      ( vy vz wcel wa cin c0 wceq wo cv csb nfcv wdisj df-ne wral disjors eqeq1
      wn csbhypf ineq1d eqeq1d orbi12d eqeq2 ineq2d rspc2v syl5bi impcom 3impia
      wne ord ) ABCUAZFBLGBLMZFGUQZDENZOPZVAFGPZUFUSUTMZVCFGUBVEVDVCUTUSVDVCQZU
      SJRZKRZPZAVGCSZAVHCSZNZOPZQZKBUCJBUCUTVFABCJKUDVNVFFVHPZDVKNZOPZQJKFGBBVG
      FPZVIVOVMVQVGFVHUEVRVLVPOVRVJDVKAJFCDAFTADTHUGUHUIUJVHGPZVOVDVQVCVHGFUKVS
      VPVBOVSVKEDAKGCEAGTAETIUGULUIUJUMUNUOURUNUP $.

    $( Property of a disjoint collection: if ` B ( X ) = C ` and
       ` B ( Y ) = D ` have a common element ` Z ` , then ` X = Y ` .
       (Contributed by Mario Carneiro, 14-Nov-2016.) $)
    disji $p |- ( ( Disj_ x e. A B /\ ( X e. A /\ Y e. A ) /\
      ( Z e. C /\ Z e. D ) ) -> X = Y ) $=
      ( wcel wa wdisj cin c0 wne wceq inelcm disji2 3expia necon1d syl3an3
      3impia ) HDKHEKLABCMZFBKGBKLZDENZOPZFGQZHDERUDUEUGUHUDUELFGUFOUDUEFGPUFOQ
      ABCDEFGIJSTUAUCUB $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d x C $.
    $( If there is a function ` C ( y ) ` such that ` C ( y ) = x ` for all
       ` y e. B ( x ) ` , then the sets ` B ( x ) ` for distinct ` x e. A ` are
       disjoint.  (Contributed by Mario Carneiro, 10-Dec-2016.) $)
    invdisj $p |- ( A. x e. A A. y e. B C = x -> Disj_ x e. A B ) $=
      ( cv wceq wral wcel wa wmo wal wdisj nfra2 df-ral rsp eqcom syl6ib imim2i
      wi imp3a alimi sylbi mo2icl syl alrimi dfdisj2 sylibr ) EAFZGZBDHZACHZUIC
      IZBFDIZJZAKZBLACDMULUPBUJABCDNULUOUIEGZTZALZUPULUMUKTZALUSUKACOUTURAUTUMU
      NUQUKUNUQTUMUKUNUJUQUJBDPEUIQRSUAUBUCUOAEUDUEUFABCDUGUH $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z C $.  $d x y z D $.
    $( A disjoint collection yields disjoint indexed unions for disjoint index
       sets.  (Contributed by Mario Carneiro, 26-Mar-2015.)  (Revised by Mario
       Carneiro, 14-Nov-2016.) $)
    disjiun $p |- ( ( Disj_ x e. A B /\
      ( C C_ A /\ D C_ A /\ ( C i^i D ) = (/) ) ) ->
        ( U_ x e. C B i^i U_ x e. D B ) = (/) ) $=
      ( vy vz wss cin c0 wceq wa cv wcel wi wrex wral impcom syl syl5bi ciun wn
      wdisj w3a wal wrmo df-disj wne elin eliun anbi12i weq wex nfv rmo2 ssralv
      bitri an4 r19.29 id imp eleq1d biimpcd rexlimiv ex expimpd anim12d inelcm
      syl6 exlimiv exp3a sylbi necon2bd impancom 3impa alimdv eq0 sylibr ) ABCU
      CZDBHZEBHZDEIZJKZUDZLFMZADCUAZAECUAZIZNZUBZFUEZWHJKWDVSWKVSWECNZABUFZFUEW
      DWKAFBCUGWDWMWJFVTWAWCWMWJOVTWALZWMWCWJWNWMLZWIWBJWIWLADPZWLAEPZLZWOWBJUH
      ZWIWEWFNZWEWGNZLWRWEWFWGUIWTWPXAWQAWEDCUJAWEECUJUKUQWMWNWRWSOZWMWLAGULZOZ
      ABQZGUMZWNXBOWLAGBWLGUNUOXFWNWRWSWNWRLVTWPLZWAWQLZLZXFWSVTWAWPWQURXEXIWSO
      GXEXIGMZDNZXJENZLWSXEXGXKXHXLXEVTWPXKXEVTLXDADQZWPXKOVTXEXMXDADBUPRXMWPXK
      XMWPLXDWLLZADPXKXDWLADUSXNXKADXNAMZDNXKXNXOXJDXDWLXCXDUTVAZVBVCVDSVESVFXE
      WAWQXLXEWALXDAEQZWQXLOWAXEXQXDAEBUPRXQWQXLXQWQLXNAEPXLXDWLAEUSXNXLAEXNXOE
      NXLXNXOXJEXPVBVCVDSVESVFVGXJDEVHVIVJTVKVLRTVMVNVOVPTRFWHVQVR $.

    $( A disjoint collection yields disjoint indexed unions for disjoint index
       sets.  (Contributed by Mario Carneiro, 26-Mar-2015.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    disjiunOLD $p |- ( ( A. y E* x ( x e. A /\ y e. B ) /\
      ( C C_ A /\ D C_ A /\ ( C i^i D ) = (/) ) ) ->
        ( U_ x e. C B i^i U_ x e. D B ) = (/) ) $=
      ( cv wcel wa wmo wal wdisj wss cin c0 wceq w3a ciun dfdisj2 disjiun
      sylanbr ) AGCHBGDHIAJBKACDLECMFCMEFNOPQAEDRAFDRNOPABCDSACDEFTUA $.
  $}

  ${
    $d x y $.  $d y A $.
    $( Any collection of singletons is disjoint.  (Contributed by Mario
       Carneiro, 14-Nov-2016.) $)
    sndisj $p |- Disj_ x e. A { x } $=
      ( vy cv csn wdisj wcel wmo dfdisj2 weq moeq simpr elsn sylib eqcomd moimi
      wa ax-mp mpgbir ) ABADZEZFTBGZCDZUAGZQZAHZCACBUAIACJZAHUFAUCKUEUGAUEUCTUE
      UDCAJUBUDLCTMNOPRS $.
  $}

  $( Any collection of empty sets is disjoint.  (Contributed by Mario Carneiro,
     14-Nov-2016.) $)
  0disj $p |- Disj_ x e. A (/) $=
    ( c0 cv csn wss wral wdisj 0ss rgenw sndisj disjss2 mp2 ) CADEZFZABGABNHABC
    HOABNIJABKABCNLM $.

  ${
    $d x y A $.  $d y B $.
    $( A singleton collection is disjoint.  (Contributed by Mario Carneiro,
       14-Nov-2016.) $)
    disjxsn $p |- Disj_ x e. { A } B $=
      ( vy csn wdisj cv wcel wa wmo dfdisj2 wceq moeq elsni adantr moimi mpgbir
      ax-mp ) ABEZCFAGZSHZDGCHZIZAJZDADSCKTBLZAJUDABMUCUEAUAUEUBTBNOPRQ $.

    $( An empty collection is disjoint.  (Contributed by Mario Carneiro,
       14-Nov-2016.) $)
    disjx0 $p |- Disj_ x e. (/) B $=
      ( c0 csn wss wdisj 0ss disjxsn disjss1 mp2 ) CCDZEAKBFACBFKGACBHACKBIJ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d y z C $.  $d x y z D $.  $d x y z E $.
    disjprg.1 $e |- ( x = A -> C = D ) $.
    disjprg.2 $e |- ( x = B -> C = E ) $.
    $( A pair collection is disjoint iff the two sets in the family have empty
       intersection.  (Contributed by Mario Carneiro, 14-Nov-2016.) $)
    disjprg $p |- ( ( A e. V /\ B e. V /\ A =/= B ) ->
      ( Disj_ x e. { A , B } C <-> ( D i^i E ) = (/) ) ) $=
      ( vy vz wceq cin c0 wo wral wa wb nfcv wtru wcel wne w3a cv csb cpr wdisj
      eqeq1 csbhypf ineq1d eqeq1d orbi12d ralbidv ralprg 3adant3 id eqcomd orcd
      a1tru 2thd eqeq2 ineq2d simp3 neneqd biorf syl tru biantrur syl6bb bitr4d
      wn eqcom incom syl6eq biantru anbi12d bitrd disjors pm4.24 3bitr4g ) BGUA
      ZCGUAZBCUBZUCZJUDZKUDZLZAWEDUEZAWFDUEZMZNLZOZKBCUFZPZJWMPZEFMZNLZWQQZAWMD
      UGWQWDWOBWFLZEWIMZNLZOZKWMPZCWFLZFWIMZNLZOZKWMPZQZWRWAWBWOXIRWCWNXCXHJBCG
      GWEBLZWLXBKWMXJWGWSWKXAWEBWFUHXJWJWTNXJWHEWIAJBDEABSZAESZHUIUJUKULUMWECLZ
      WLXGKWMXMWGXDWKXFWECWFUHXMWJXENXMWHFWIAJCDFACSZAFSZIUIUJUKULUMUNUOWDXCWQX
      HWQWDXCTBCLZWQOZQZWQWAWBXCXRRWCXBTXQKBCGGWFBLZXBTXSWSXAXSWFBXSUPUQURXSUSU
      TWFCLZWSXPXAWQWFCBVAXTWTWPNXTWIFEAKCDFXNXOIUIVBUKULUNUOWDWQXQXRWDXPVKWQXQ
      RWDBCWAWBWCVCVDXPWQVEVFZTXQVGVHVIVJWDXHXQTQZWQWAWBXHYBRWCXGXQTKBCGGXSXDXP
      XFWQXSXDCBLXPWFBCVACBVLVIXSXEWPNXSXEFEMWPXSWIEFAKBDEXKXLHUIVBFEVMVNUKULXT
      XGTXTXDXFXTWFCXTUPUQURXTUSUTUNUOWDWQXQYBYATXQVGVOVIVJVPVQAWMDJKVRWQVSVT
      $.
  $}

  ${
    $d r s u v x y z A $.  $d r s u v x z B $.  $d r s u v y z C $.
    $( An indexed union of a disjoint collection of disjoint collections is
       disjoint if each component is disjoint, and the disjoint unions in the
       collection are also disjoint.  Note that ` B ( y ) ` and ` C ( x ) ` may
       have the displayed free variables.  (Contributed by Mario Carneiro,
       14-Nov-2016.) $)
    disjxiun $p |- ( Disj_ y e. A B -> ( Disj_ x e. U_ y e. A B C <->
      ( A. y e. A Disj_ x e. B C /\ Disj_ y e. A U_ x e. B C ) ) ) $=
      ( vu vv vr vs vz wdisj ciun wral wa nfcv cv wcel wss syl weq nfiu1 nfdisj
      wi ssiun2 disjss1 com12 ralrimi a1i csb cin c0 wceq wo wn simprll nfcsb1v
      simplr csbeq1a cbviun syl6sseqr simprlr csbeq1 sseq1d vtoclga simpl sylib
      cbvdisj disjor rsp2 imp ord impr disjiun syl13anc expr ralrimivva iuneq1d
      orrd sylibr nfiun ex jcad wrex eleq2i eliun anbi12i reeanv bitr4i simplrr
      simprl simplrl disjeq1d rspc sylc ad2antrr disjors simpld simprd eleqtrrd
      bitri adantl jca mpd wne ss2in syl2anc simprr disji2 syl121anc pm2.61dane
      simpr sseq0 rexlimdvva syl5bi ralrimivv impbid ) BCDKZABCDLZEKZADEKZBCMZB
      CADELZKZNZXQXSYAYCXSYAUCXQXSXTBCABXREBCDUABEOZUBBPCQZXSXTYFDXRRXSXTUCBCDU
      DADXREUESUFUGUHXQXSYCXQXSNZFCABFPZDUIZELZKZYCYGFGTZYJABGPZDUIZELZUJZUKULZ
      UMZGCMFCMYKYGYRFGCCYGYHCQZYMCQZNZNZYLYQYGUUAYLUNZYQYGUUAUUCNZNZXSYIXRRZYN
      XRRZYIYNUJUKULZYQXQXSUUDUQUUEYSUUFYGYSYTUUCUOYSYIFCYILZXRFCYIUDBFCDYIFDOZ
      BYHDUPZBYHDURZUSZUTZSUUEYTUUGYGYSYTUUCVAUUFUUGFYMCYLYIYNXRBYHYMDVBZVCUUNV
      DSYGUUAUUCUUHUUBYLUUHYGUUAYLUUHUMZYGUUPGCMFCMZUUAUUPUCYGFCYIKZUUQYGXQUURX
      QXSVEBFCDYIUUJUUKUULVGVFCYIYNFGUUOVHVFUUPFGCCVISVJVKVLAXREYIYNVMVNVOVRVPC
      YJYOFGYLAYIYNEUUOVQVHVSBFCYBYJFYBOABYIEUUKYEVTBFTZADYIEUULVQVGVSWAWBXQYDX
      SXQYDNZHITZAHPZEUIZAIPZEUIZUJZUKULZUMZIXRMHXRMXSUUTUVHHIXRXRUVBXRQZUVDXRQ
      ZNZUVBYIQZUVDYNQZNZGCWCFCWCZUUTUVHUVKUVLFCWCZUVMGCWCZNUVOUVIUVPUVJUVQUVIU
      VBUUIQUVPXRUUIUVBUUMWDFUVBCYIWEWTUVJUVDGCYNLZQUVQXRUVRUVDBGCDYNGDOBYMDUPB
      YMDURUSWDGUVDCYNWEWTWFUVLUVMFGCCWGWHUUTUVNUVHFGCCUUTUUANZUVNUVHUVSUVNNUVA
      UVGUVSUVNUVAUNZUVGUVSUVNUVTNZNZUVGYHYMUWBYLNZUVTUVGUVSUVNUVTYLWIUWCUVAUVG
      UWCUVHIYIMHYIMZUVLUVDYIQZNUVHUWCAYIEKZUWDUVSUWFUWAYLUVSYSYAUWFUUTYSYTWJZX
      QYAYCUUAWKXTUWFBYHCABYIEUUKYEUBUUSADYIEUULWLWMWNWOAYIEHIWPVFUWCUVLUWEUWCU
      VLUVMUVSUVNUVTYLWKZWQUWCUVDYNYIUWCUVLUVMUWHWRYLYIYNULUWBUUOXAWSXBUVHHIYIY
      IVIWNVKXCUWBYHYMXDZNZUVFYPRZYQUVGUWJUVCYJRZUVEYORZUWKUWJUVLUWLUWJUVLUVMUV
      SUVNUVTUWIWKZWQUVLUVCHYIUVCLYJHYIUVCUDAHYIEUVCHEOAUVBEUPAUVBEURUSUTSUWJUV
      MUWMUWJUVLUVMUWNWRUVMUVEIYNUVELYOIYNUVEUDAIYNEUVEIEOAUVDEUPAUVDEURUSUTSUV
      CYJUVEYOXEXFUWJJCABJPZDUIZELZKZYSYTUWIYQUWJYCUWRUVSYCUWAUWIXQYAYCUUAWIWOB
      JCYBUWQJYBOABUWPEBUWODUPYEVTBJTADUWPEBUWODURVQVGVFUVSYSUWAUWIUWGWOUVSYTUW
      AUWIUUTYSYTXGWOUWBUWIXKJCUWQYJYOYHYMJFTAUWPYIEBUWOYHDVBVQJGTAUWPYNEBUWOYM
      DVBVQXHXIUVFYPXLXFXJVOVRWAXMXNXOAXREHIWPVSWAXP $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w y z C $.  $d w x z D $.
    disjxun.1 $e |- ( x = y -> C = D ) $.
    $( The union of two disjoint collections.  (Contributed by Mario Carneiro,
       14-Nov-2016.) $)
    disjxun $p |- ( ( A i^i B ) = (/) -> ( Disj_ x e. ( A u. B ) C <->
      ( Disj_ x e. A C /\ Disj_ x e. B C /\
        A. x e. A A. y e. B ( C i^i D ) = (/) ) ) ) $=
      ( vz vw cin c0 wceq weq cv wo wral wa eqeq1d orbi12d bitri csb wdisj wcel
      cun wn wb disjel eleq1 notbid syl5ibcom con2d impr biorf bicomd 2ralbidva
      w3a syl anbi2d ralunb ralbii nfcv nfcsb1v nfin nfeq1 nfor equequ2 csbhypf
      nfral ineq2d cbvralv equequ1 csbeq1a ineq1d ralbidv syl5bbr cbvral r19.26
      nfv 3bitr3i disjor anbi1i equcom syl6bb incom syl6eq ralcom syl5bb anbi1d
      3bitr4g disjors anbi2ci anbi12d df-3an anandir ) CDJKLZHIMZAHNZEUAZAINZEU
      AZJZKLZOZICDUDZPZHCPZXEHDPZQZACEUBZEFJZKLZBDPACPZQZADEUBZXLQZQZAXDEUBZXIX
      NXLUPZWOXFXMXGXOWOABMZXKOZBCPZACPZXTBDPZACPZQZYBXLQXFXMWOYDXLYBWOXTXKABCD
      WOANZCUCZBNZDUCZQQZXKXTYJXSUEZXKXTUFWOYGYIYKWOYGQZXSYIYLYFDUCZUEXSYIUECDY
      FUGXSYMYIYFYHDUHUIUJUKULXSXKUMUQUNUOZURXTBXDPZACPYAYCQZACPXFYEYOYPACXTBCD
      USUTYOXEAHCYOHVRXCAIXDAXDVAWPXBAWPAVRAXAKAWRWTAWQEVBAWSEVBVCVDVEZVHYOAIMZ
      EWTJZKLZOZIXDPAHMZXEUUAXTIBXDIBMZYRXSYTXKIBAVFUUCYSXJKUUCWTFEAIYHEFAYHVAZ
      AFVAZGVGVIRSVJUUBUUAXCIXDUUBYRWPYTXBAHIVKUUBYSXAKUUBEWRWTAWQEVLVMRSVNVOVP
      YAYCACVQVSXIYBXLCEFABGVTWAWIWOXCICPZHDPZXCIDPZHDPZQZXLUUIQXGXOWOUUGXLUUIU
      UGYDWOXLUUGXTACPZBDPYDUUFUUKHBDUUFHAMZWREJZKLZOZACPHBMZUUKUUOXCAICUUOIVRY
      QYRUULWPUUNXBAIHVFYRUUMXAKYREWTWRAWSEVLVIRSVPUUPUUOXTACUUPUULXSUUNXKUUPUU
      LBAMXSHBAVKBAWBWCUUPUUMXJKUUPUUMFEJXJUUPWRFEAHYHEFUUDUUEGVGVMFEWDWERSVNVO
      VJXTBADCWFTYNWGWHXGUUFUUHQZHDPUUJXEUUQHDXCICDUSUTUUFUUHHDVQTXNUUIXLADEHIW
      JWKWIWLXQXEHXDPXHAXDEHIWJXEHCDUSTXRXIXNQXLQXPXIXNXLWMXIXNXLWNTWI $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Expand a disjoint collection with any number of empty sets.
       (Contributed by Mario Carneiro, 15-Nov-2016.) $)
    disjss3 $p |- ( ( A C_ B /\ A. x e. ( B \ A ) C = (/) ) ->
      ( Disj_ x e. A C <-> Disj_ x e. B C ) ) $=
      ( vy wss c0 wceq cdif wa wdisj cv wcel wmo wal wi wn syl alimdv dfdisj2
      wral df-ral w3a simp3r n0i simp3l eldif simp2 syl5bir mpand mt3d jca 3exp
      syl5bi imp moim 3imtr4g disjss1 adantr impbid ) BCFZDGHZACBIZUAZJZABDKZAC
      DKZVEALZBMZELZDMZJZANZEOVHCMZVKJZANZEOVFVGVEVMVPEVEVOVLPZAOZVMVPPVAVDVRVD
      VHVCMZVBPZAOVAVRVBAVCUBVAVTVQAVAVTVOVLVAVTVOUCZVIVKWAVIVBWAVKVBQVAVTVNVKU
      DZDVJUERWAVNVIQZVBVAVTVNVKUFVNWCJVSWAVBVHCBUGVAVTVOUHUIUJUKWBULUMSUNUOVOV
      LAUPRSAEBDTAECDTUQVAVGVFPVDABCDURUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Binary relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend wff notation to include the general binary relation predicate.
     Note that the syntax is simply three class symbols in a row.  Since binary
     relations are the only possible wff expressions consisting of three class
     expressions in a row, the syntax is unambiguous.  (For an example of how
     syntax could become ambiguous if we are not careful, see the comment in
     ~ cneg .) $)
  wbr $a wff A R B $.

  $( Define a general binary relation.  Note that the syntax is simply three
     class symbols in a row.  Definition 6.18 of [TakeutiZaring] p. 29
     generalized to arbitrary classes.  Class ` R ` often denotes a relation
     such as " ` < ` " that compares two classes ` A ` and ` B ` , which might
     be numbers such as ` 1 ` and ` 2 ` (see ~ df-ltxr for the specific
     definition of ` < ` ).  As a wff, relations are true or false.  For
     example, ` ( R = { <. 2 , 6 >. , <. 3 , 9 >. } -> 3 R 9 ) ` ( ~ ex-br ).
     Often class ` R ` meets the ` Rel ` criteria to be defined in ~ df-rel ,
     and in particular ` R ` may be a function (see ~ df-fun ).  This
     definition of relations is well-defined, although not very meaningful,
     when classes ` A ` and/or ` B ` are proper classes (i.e. are not sets).
     On the other hand, we often find uses for this definition when ` R ` is a
     proper class.  (Contributed by NM, 31-Dec-1993.) $)
  df-br $a |- ( A R B <-> <. A , B >. e. R ) $.

  $( Equality theorem for binary relations.  (Contributed by NM,
     4-Jun-1995.) $)
  breq $p |- ( R = S -> ( A R B <-> A S B ) ) $=
    ( wceq cop wcel wbr eleq2 df-br 3bitr4g ) CDEABFZCGLDGABCHABDHCDLIABCJABDJK
    $.

  $( Equality theorem for a binary relation.  (Contributed by NM,
     31-Dec-1993.) $)
  breq1 $p |- ( A = B -> ( A R C <-> B R C ) ) $=
    ( wceq cop wcel wbr opeq1 eleq1d df-br 3bitr4g ) ABEZACFZDGBCFZDGACDHBCDHMN
    ODABCIJACDKBCDKL $.

  $( Equality theorem for a binary relation.  (Contributed by NM,
     31-Dec-1993.) $)
  breq2 $p |- ( A = B -> ( C R A <-> C R B ) ) $=
    ( wceq cop wcel wbr opeq2 eleq1d df-br 3bitr4g ) ABEZCAFZDGCBFZDGCADHCBDHMN
    ODABCIJCADKCBDKL $.

  $( Equality theorem for a binary relation.  (Contributed by NM,
     8-Feb-1996.) $)
  breq12 $p |- ( ( A = B /\ C = D ) -> ( A R C <-> B R D ) ) $=
    ( wceq wbr breq1 breq2 sylan9bb ) ABFACEGBCEGCDFBDEGABCEHCDBEIJ $.

  ${
    breqi.1 $e |- R = S $.
    $( Equality inference for binary relations.  (Contributed by NM,
       19-Feb-2005.) $)
    breqi $p |- ( A R B <-> A S B ) $=
      ( wceq wbr wb breq ax-mp ) CDFABCGABDGHEABCDIJ $.
  $}

  ${
    breq1i.1 $e |- A = B $.
    $( Equality inference for a binary relation.  (Contributed by NM,
       8-Feb-1996.) $)
    breq1i $p |- ( A R C <-> B R C ) $=
      ( wceq wbr wb breq1 ax-mp ) ABFACDGBCDGHEABCDIJ $.

    $( Equality inference for a binary relation.  (Contributed by NM,
       8-Feb-1996.) $)
    breq2i $p |- ( C R A <-> C R B ) $=
      ( wceq wbr wb breq2 ax-mp ) ABFCADGCBDGHEABCDIJ $.

    ${
      breq12i.2 $e |- C = D $.
      $( Equality inference for a binary relation.  (Contributed by NM,
         8-Feb-1996.)  (Proof shortened by Eric Schmidt, 4-Apr-2007.) $)
      breq12i $p |- ( A R C <-> B R D ) $=
        ( wceq wbr wb breq12 mp2an ) ABHCDHACEIBDEIJFGABCDEKL $.
    $}
  $}

  ${
    breq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for a binary relation.  (Contributed by NM,
       8-Feb-1996.) $)
    breq1d $p |- ( ph -> ( A R C <-> B R C ) ) $=
      ( wceq wbr wb breq1 syl ) ABCGBDEHCDEHIFBCDEJK $.

    $( Equality deduction for a binary relation.  (Contributed by NM,
       29-Oct-2011.) $)
    breqd $p |- ( ph -> ( C A D <-> C B D ) ) $=
      ( wceq wbr wb breq syl ) ABCGDEBHDECHIFDEBCJK $.

    $( Equality deduction for a binary relation.  (Contributed by NM,
       8-Feb-1996.) $)
    breq2d $p |- ( ph -> ( C R A <-> C R B ) ) $=
      ( wceq wbr wb breq2 syl ) ABCGDBEHDCEHIFBCDEJK $.

    ${
      breq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for a binary relation.  (Contributed by NM,
         8-Feb-1996.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) $)
      breq12d $p |- ( ph -> ( A R C <-> B R D ) ) $=
        ( wceq wbr wb breq12 syl2anc ) ABCIDEIBDFJCEFJKGHBCDEFLM $.
    $}

    ${
      breq123d.2 $e |- ( ph -> R = S ) $.
      breq123d.3 $e |- ( ph -> C = D ) $.
      $( Equality deduction for a binary relation.  (Contributed by NM,
         29-Oct-2011.) $)
      breq123d $p |- ( ph -> ( A R C <-> B S D ) ) $=
        ( wbr breq12d breqd bitrd ) ABDFKCEFKCEGKABCDEFHJLAFGCEIMN $.
    $}

    ${
      breqan12i.2 $e |- ( ps -> C = D ) $.
      $( Equality deduction for a binary relation.  (Contributed by NM,
         8-Feb-1996.) $)
      breqan12d $p |- ( ( ph /\ ps ) -> ( A R C <-> B R D ) ) $=
        ( wceq wbr wb breq12 syl2an ) ACDJEFJCEGKDFGKLBHICDEFGMN $.

      $( Equality deduction for a binary relation.  (Contributed by NM,
         8-Feb-1996.) $)
      breqan12rd $p |- ( ( ps /\ ph ) -> ( A R C <-> B R D ) ) $=
        ( wbr wb breqan12d ancoms ) ABCEGJDFGJKABCDEFGHILM $.
    $}
  $}

  $( Two classes are different if they don't have the same relationship to a
     third class.  (Contributed by NM, 3-Jun-2012.) $)
  nbrne1 $p |- ( ( A R B /\ -. A R C ) -> B =/= C ) $=
    ( wbr wn wne wceq breq2 biimpcd necon3bd imp ) ABDEZACDEZFBCGMNBCBCHMNBCADI
    JKL $.

  $( Two classes are different if they don't have the same relationship to a
     third class.  (Contributed by NM, 3-Jun-2012.) $)
  nbrne2 $p |- ( ( A R C /\ -. B R C ) -> A =/= B ) $=
    ( wbr wn wne wceq breq1 biimpcd necon3bd imp ) ACDEZBCDEZFABGMNABABHMNABCDI
    JKL $.

  ${
    eqbrtr.1 $e |- A = B $.
    eqbrtr.2 $e |- B R C $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    eqbrtri $p |- A R C $=
      ( wbr breq1i mpbir ) ACDGBCDGFABCDEHI $.
  $}

  ${
    eqbrtrd.1 $e |- ( ph -> A = B ) $.
    eqbrtrd.2 $e |- ( ph -> B R C ) $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 8-Oct-1999.) $)
    eqbrtrd $p |- ( ph -> A R C ) $=
      ( wbr breq1d mpbird ) ABDEHCDEHGABCDEFIJ $.
  $}

  ${
    eqbrtrr.1 $e |- A = B $.
    eqbrtrr.2 $e |- A R C $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    eqbrtrri $p |- B R C $=
      ( eqcomi eqbrtri ) BACDABEGFH $.
  $}

  ${
    eqbrtrrd.1 $e |- ( ph -> A = B ) $.
    eqbrtrrd.2 $e |- ( ph -> A R C ) $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 24-Oct-1999.) $)
    eqbrtrrd $p |- ( ph -> B R C ) $=
      ( eqcomd eqbrtrd ) ACBDEABCFHGI $.
  $}

  ${
    breqtr.1 $e |- A R B $.
    breqtr.2 $e |- B = C $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    breqtri $p |- A R C $=
      ( wbr breq2i mpbi ) ABDGACDGEBCADFHI $.
  $}

  ${
    breqtrd.1 $e |- ( ph -> A R B ) $.
    breqtrd.2 $e |- ( ph -> B = C ) $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 24-Oct-1999.) $)
    breqtrd $p |- ( ph -> A R C ) $=
      ( wbr breq2d mpbid ) ABCEHBDEHFACDBEGIJ $.
  $}

  ${
    breqtrr.1 $e |- A R B $.
    breqtrr.2 $e |- C = B $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 5-Aug-1993.) $)
    breqtrri $p |- A R C $=
      ( eqcomi breqtri ) ABCDECBFGH $.
  $}

  ${
    breqtrrd.1 $e |- ( ph -> A R B ) $.
    breqtrrd.2 $e |- ( ph -> C = B ) $.
    $( Substitution of equal classes into a binary relation.  (Contributed by
       NM, 24-Oct-1999.) $)
    breqtrrd $p |- ( ph -> A R C ) $=
      ( eqcomd breqtrd ) ABCDEFADCGHI $.
  $}

  ${
    3brtr3.1 $e |- A R B $.
    3brtr3.2 $e |- A = C $.
    3brtr3.3 $e |- B = D $.
    $( Substitution of equality into both sides of a binary relation.
       (Contributed by NM, 11-Aug-1999.) $)
    3brtr3i $p |- C R D $=
      ( eqbrtrri breqtri ) CBDEACBEGFIHJ $.
  $}

  ${
    3brtr4.1 $e |- A R B $.
    3brtr4.2 $e |- C = A $.
    3brtr4.3 $e |- D = B $.
    $( Substitution of equality into both sides of a binary relation.
       (Contributed by NM, 11-Aug-1999.) $)
    3brtr4i $p |- C R D $=
      ( eqbrtri breqtrri ) CBDECABEGFIHJ $.
  $}

  ${
    3brtr3d.1 $e |- ( ph -> A R B ) $.
    3brtr3d.2 $e |- ( ph -> A = C ) $.
    3brtr3d.3 $e |- ( ph -> B = D ) $.
    $( Substitution of equality into both sides of a binary relation.
       (Contributed by NM, 18-Oct-1999.) $)
    3brtr3d $p |- ( ph -> C R D ) $=
      ( wbr breq12d mpbid ) ABCFJDEFJGABDCEFHIKL $.
  $}

  ${
    3brtr4d.1 $e |- ( ph -> A R B ) $.
    3brtr4d.2 $e |- ( ph -> C = A ) $.
    3brtr4d.3 $e |- ( ph -> D = B ) $.
    $( Substitution of equality into both sides of a binary relation.
       (Contributed by NM, 21-Feb-2005.) $)
    3brtr4d $p |- ( ph -> C R D ) $=
      ( wbr breq12d mpbird ) ADEFJBCFJGADBECFHIKL $.
  $}

  ${
    3brtr3g.1 $e |- ( ph -> A R B ) $.
    3brtr3g.2 $e |- A = C $.
    3brtr3g.3 $e |- B = D $.
    $( Substitution of equality into both sides of a binary relation.
       (Contributed by NM, 16-Jan-1997.) $)
    3brtr3g $p |- ( ph -> C R D ) $=
      ( wbr breq12i sylib ) ABCFJDEFJGBDCEFHIKL $.
  $}

  ${
    3brtr4g.1 $e |- ( ph -> A R B ) $.
    3brtr4g.2 $e |- C = A $.
    3brtr4g.3 $e |- D = B $.
    $( Substitution of equality into both sides of a binary relation.
       (Contributed by NM, 16-Jan-1997.) $)
    3brtr4g $p |- ( ph -> C R D ) $=
      ( wbr breq12i sylibr ) ABCFJDEFJGDBECFHIKL $.
  $}

  ${
    syl5eqbr.1 $e |- A = B $.
    syl5eqbr.2 $e |- ( ph -> B R C ) $.
    $( B chained equality inference for a binary relation.  (Contributed by NM,
       11-Oct-1999.) $)
    syl5eqbr $p |- ( ph -> A R C ) $=
      ( eqid 3brtr4g ) ACDBDEGFDHI $.
  $}

  ${
    syl5eqbrr.1 $e |- B = A $.
    syl5eqbrr.2 $e |- ( ph -> B R C ) $.
    $( B chained equality inference for a binary relation.  (Contributed by NM,
       17-Sep-2004.) $)
    syl5eqbrr $p |- ( ph -> A R C ) $=
      ( eqid 3brtr3g ) ACDBDEGFDHI $.
  $}

  ${
    syl5breq.1 $e |- A R B $.
    syl5breq.2 $e |- ( ph -> B = C ) $.
    $( B chained equality inference for a binary relation.  (Contributed by NM,
       11-Oct-1999.) $)
    syl5breq $p |- ( ph -> A R C ) $=
      ( wbr a1i breqtrd ) ABCDEBCEHAFIGJ $.
  $}

  ${
    syl5breqr.1 $e |- A R B $.
    syl5breqr.2 $e |- ( ph -> C = B ) $.
    $( B chained equality inference for a binary relation.  (Contributed by NM,
       24-Apr-2005.) $)
    syl5breqr $p |- ( ph -> A R C ) $=
      ( eqcomd syl5breq ) ABCDEFADCGHI $.
  $}

  ${
    syl6eqbr.1 $e |- ( ph -> A = B ) $.
    syl6eqbr.2 $e |- B R C $.
    $( A chained equality inference for a binary relation.  (Contributed by NM,
       12-Oct-1999.) $)
    syl6eqbr $p |- ( ph -> A R C ) $=
      ( wbr breq1d mpbiri ) ABDEHCDEHGABCDEFIJ $.
  $}

  ${
    syl6eqbrr.1 $e |- ( ph -> B = A ) $.
    syl6eqbrr.2 $e |- B R C $.
    $( A chained equality inference for a binary relation.  (Contributed by NM,
       4-Jan-2006.) $)
    syl6eqbrr $p |- ( ph -> A R C ) $=
      ( eqcomd syl6eqbr ) ABCDEACBFHGI $.
  $}

  ${
    syl6breq.1 $e |- ( ph -> A R B ) $.
    syl6breq.2 $e |- B = C $.
    $( A chained equality inference for a binary relation.  (Contributed by NM,
       11-Oct-1999.) $)
    syl6breq $p |- ( ph -> A R C ) $=
      ( eqid 3brtr3g ) ABCBDEFBHGI $.
  $}

  ${
    syl6breqr.1 $e |- ( ph -> A R B ) $.
    syl6breqr.2 $e |- C = B $.
    $( A chained equality inference for a binary relation.  (Contributed by NM,
       24-Apr-2005.) $)
    syl6breqr $p |- ( ph -> A R C ) $=
      ( eqcomi syl6breq ) ABCDEFDCGHI $.
  $}


  ${
    ssbrd.1 $e |- ( ph -> A C_ B ) $.
    $( Deduction from a subclass relationship of binary relations.
       (Contributed by NM, 30-Apr-2004.) $)
    ssbrd $p |- ( ph -> ( C A D -> C B D ) ) $=
      ( cop wcel wbr sseld df-br 3imtr4g ) ADEGZBHMCHDEBIDECIABCMFJDEBKDECKL $.
  $}

  ${
    ssbri.1 $e |- A C_ B $.
    $( Inference from a subclass relationship of binary relations.
       (Contributed by NM, 28-Mar-2007.)  (Revised by Mario Carneiro,
       8-Feb-2015.) $)
    ssbri $p |- ( C A D -> C B D ) $=
      ( wbr wi wtru wss a1i ssbrd trud ) CDAFCDBFGHABCDABIHEJKL $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z R $.  $d x y z $.  $d y ph $.
    nfbrd.2 $e |- ( ph -> F/_ x A ) $.
    nfbrd.3 $e |- ( ph -> F/_ x R ) $.
    nfbrd.4 $e |- ( ph -> F/_ x B ) $.
    $( Deduction version of bound-variable hypothesis builder ~ nfbr .
       (Contributed by NM, 13-Dec-2005.)  (Revised by Mario Carneiro,
       14-Oct-2016.) $)
    nfbrd $p |- ( ph -> F/ x A R B ) $=
      ( wbr cop wcel df-br nfopd nfeld nfxfrd ) CDEICDJZEKABCDELABPEABCDFHMGNO
      $.
  $}

  ${
    $d y A $.  $d y B $.  $d y R $.  $d x y $.
    nfbr.1 $e |- F/_ x A $.
    nfbr.2 $e |- F/_ x R $.
    nfbr.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for binary relation.  (Contributed by
       NM, 1-Sep-1999.)  (Revised by Mario Carneiro, 14-Oct-2016.) $)
    nfbr $p |- F/ x A R B $=
      ( wbr wnf wtru wnfc a1i nfbrd trud ) BCDHAIJABCDABKJELADKJFLACKJGLMN $.
  $}

  ${
    $d x y $.  $d y z A $.  $d y z R $.
    $( Relationship between a binary relation and a class abstraction.
       (Contributed by Andrew Salmon, 8-Jul-2011.) $)
    brab1 $p |- ( x R A <-> x e. { z | z R A } ) $=
      ( vy cv wbr wsbc cab wcel cvv wb vex breq1 sbcie2g ax-mp df-sbc bitr3i )
      AFZCDGZBFZCDGZBSHZSUBBIJSKJUCTLAMUBEFZCDGTBESKUAUDCDNUDSCDNOPUBBSQR $.
  $}

  $( The empty binary relation never holds.  (Contributed by NM,
     23-Aug-2018.) $)
  br0 $p |- -. A (/) B $=
    ( c0 wbr cop wcel noel df-br mtbir ) ABCDABEZCFJGABCHI $.

  $( If two sets are in a binary relation, the relation cannot be empty.
     (Contributed by Alexander van der Vekens, 7-Jul-2018.) $)
  brne0 $p |- ( A R B -> R =/= (/) ) $=
    ( wbr cop wcel c0 wne df-br ne0i sylbi ) ABCDABEZCFCGHABCICLJK $.

  $( The union of two binary relations.  (Contributed by NM, 21-Dec-2008.) $)
  brun $p |- ( A ( R u. S ) B <-> ( A R B \/ A S B ) ) $=
    ( cop cun wcel wo wbr elun df-br orbi12i 3bitr4i ) ABEZCDFZGNCGZNDGZHABOIAB
    CIZABDIZHNCDJABOKRPSQABCKABDKLM $.

  $( The intersection of two relations.  (Contributed by FL, 7-Oct-2008.) $)
  brin $p |- ( A ( R i^i S ) B <-> ( A R B /\ A S B ) ) $=
    ( cop cin wcel wa wbr elin df-br anbi12i 3bitr4i ) ABEZCDFZGNCGZNDGZHABOIAB
    CIZABDIZHNCDJABOKRPSQABCKABDKLM $.

  $( The difference of two binary relations.  (Contributed by Scott Fenton,
     11-Apr-2011.) $)
  brdif $p |- ( A ( R \ S ) B <-> ( A R B /\ -. A S B ) ) $=
    ( cop cdif wcel wn wa wbr eldif df-br notbii anbi12i 3bitr4i ) ABEZCDFZGPCG
    ZPDGZHZIABQJABCJZABDJZHZIPCDKABQLUARUCTABCLUBSABDLMNO $.

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y z D $.  $d y z R $.
    $d x y z $.
    $( Move substitution in and out of a binary relation.  (Contributed by NM,
       13-Dec-2005.)  (Modified by NM, 22-Aug-2018.) $)
    sbcbr123 $p |- ( [. A / x ]. B R C
           <-> [_ A / x ]_ B [_ A / x ]_ R [_ A / x ]_ C ) $=
      ( vy cvv wcel wbr wsbc csb wb wsb dfsbcq2 csbeq1 breq123d nfcsb1v csbeq1a
      cv c0 wceq nfbr weq sbie vtoclbg sbcex con3i cop df-br mtbir csbprc breqd
      wn noel mtbiri 2falsed pm2.61i ) BGHZCDEIZABJZABCKZABDKZABEKZIZLUSAFMAFSZ
      CKZAVEDKZAVEEKZIZUTVDFBGUSAFBNVEBUAVFVAVGVBVHVCAVEBCOAVEBEOAVEBDOPUSVIAFA
      VFVGVHAVECQAVEEQAVEDQUBAFUCCVFDVGEVHAVECRAVEERAVEDRPUDUEURUMZUTVDUTURUSAB
      UFUGVJVDVAVBTIZVKVAVBUHZTHVLUNVAVBTUIUJVJVCTVAVBABEUKULUOUPUQ $.

    $( Move substitution in and out of a binary relation.  (Contributed by NM,
       13-Dec-2005.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.)  Obsolete
       as of 22-Aug-2018.  Use ~ sbcbr123 instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    sbcbrgOLD $p |- ( A e. D -> ( [. A / x ]. B R C <->
           [_ A / x ]_ B [_ A / x ]_ R [_ A / x ]_ C ) ) $=
      ( vy wbr wsb cv csb wsbc dfsbcq2 wceq csbeq1 breq123d nfcsb1v weq csbeq1a
      nfbr sbie vtoclbg ) CDFHZAGIAGJZCKZAUDDKZAUDFKZHZUCABLABCKZABDKZABFKZHGBE
      UCAGBMUDBNUEUIUFUJUGUKAUDBCOAUDBFOAUDBDOPUCUHAGAUEUFUGAUDCQAUDFQAUDDQTAGR
      CUEDUFFUGAUDCSAUDFSAUDDSPUAUB $.
  $}

  ${
    $d x B $.  $d x C $.
    $( Move substitution in and out of a binary relation.  (Contributed by NM,
       23-Aug-2018.) $)
    sbcbr $p |- ( [. A / x ]. B R C <-> B [_ A / x ]_ R C ) $=
      ( wbr wsbc csb sbcbr123 cvv wcel wb csbconstg breq12d wn br0 2false breqd
      c0 a1i csbprc 3bitr4d pm2.61i bitri ) CDEFABGABCHZABDHZABEHZFZCDUGFZABCDE
      IBJKZUHUILUJUECUFDUGABCJMABDJMNUJOZUEUFSFZCDSFZUHUIULUMLUKULUMUEUFPCDPQTU
      KUGSUEUFABEUAZRUKUGSCDUNRUBUCUD $.
  $}

  ${
    $d x R $.
    $( Move substitution in and out of a binary relation.  (Contributed by NM,
       13-Dec-2005.) $)
    sbcbr12g $p |- ( A e. V ->
                 ( [. A / x ]. B R C <-> [_ A / x ]_ B R [_ A / x ]_ C ) ) $=
      ( wbr wsbc csb wcel sbcbr123 csbconstg breqd syl5bb ) CDEGABHABCIZABDIZAB
      EIZGBFJZOPEGABCDEKRQEOPABEFLMN $.
  $}

  ${
    $d x C $.  $d x R $.
    $( Move substitution in and out of a binary relation.  (Contributed by NM,
       13-Dec-2005.) $)
    sbcbr1g $p |- ( A e. V -> ( [. A / x ]. B R C <-> [_ A / x ]_ B R C ) ) $=
      ( wcel wbr wsbc csb sbcbr12g csbconstg breq2d bitrd ) BFGZCDEHABIABCJZABD
      JZEHPDEHABCDEFKOQDPEABDFLMN $.
  $}

  ${
    $d x B $.  $d x R $.
    $( Move substitution in and out of a binary relation.  (Contributed by NM,
       13-Dec-2005.) $)
    sbcbr2g $p |- ( A e. V -> ( [. A / x ]. B R C <-> B R [_ A / x ]_ C ) ) $=
      ( wcel wbr wsbc csb sbcbr12g csbconstg breq1d bitrd ) BFGZCDEHABIABCJZABD
      JZEHCQEHABCDEFKOPCQEABCFLMN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ordered-pair class abstractions (class builders)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c |-> $.  $( Maps-to symbol $)

  $( Extend class notation to include ordered-pair class abstraction (class
     builder). $)
  copab $a class { <. x , y >. | ph } $.

  $( Extend the definition of a class to include maps-to notation for defining
     a function via a rule. $)
  cmpt $a class ( x e. A |-> B ) $.

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( Define the class abstraction of a collection of ordered pairs.
       Definition 3.3 of [Monk1] p. 34.  Usually ` x ` and ` y ` are distinct,
       although the definition doesn't strictly require it (see ~ dfid2 for a
       case where they are not distinct).  The brace notation is called "class
       abstraction" by Quine; it is also (more commonly) called a "class
       builder" in the literature.  An alternate definition using no
       existential quantifiers is shown by ~ dfopab2 .  For example,
` R = { <. x , y >. | ( x e. CC /\ y e. CC /\ ( x + 1 ) = y ) } -> 3 R 4 `
       ( ~ ex-opab ).  (Contributed by NM, 4-Jul-1994.) $)
    df-opab $a |- { <. x , y >. | ph } =
                  { z | E. x E. y ( z = <. x , y >. /\ ph ) } $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    $( Define maps-to notation for defining a function via a rule.  Read as
       "the function defined by the map from ` x ` (in ` A ` ) to
       ` B ( x ) ` ."  The class expression ` B ` is the value of the function
       at ` x ` and normally contains the variable ` x ` .  An example is the
       square function for complex numbers, ` ( x e. CC |-> ( x ^ 2 ) ) ` .
       Similar to the definition of mapping in [ChoquetDD] p. 2.  (Contributed
       by NM, 17-Feb-2008.) $)
    df-mpt $a |- ( x e. A |-> B ) =
                    { <. x , y >. | ( x e. A /\ y = B ) } $.
  $}

  ${
    $d x z R $.  $d y z R $.
    $( The collection of ordered pairs in a class is a subclass of it.
       (Contributed by NM, 27-Dec-1996.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    opabss $p |- { <. x , y >. | x R y } C_ R $=
      ( vz cv wbr copab cop wceq wa wex cab df-opab df-br eleq1 biimpar sylan2b
      wcel exlimivv abssi eqsstri ) AEZBEZCFZABGDEZUBUCHZIZUDJZBKAKZDLCUDABDMUI
      DCUHUECRZABUDUGUFCRZUJUBUCCNUGUJUKUEUFCOPQSTUA $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.  $d z ps $.  $d z ch $.
    opabbid.1 $e |- F/ x ph $.
    opabbid.2 $e |- F/ y ph $.
    opabbid.3 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal ordered-pair class abstractions (deduction
       rule).  (Contributed by NM, 21-Feb-2004.)  (Proof shortened by Andrew
       Salmon, 9-Jul-2011.) $)
    opabbid $p |- ( ph -> { <. x , y >. | ps } = { <. x , y >. | ch } ) $=
      ( vz cv cop wceq wa wex cab copab anbi2d exbid abbidv df-opab 3eqtr4g ) A
      IJDJEJKLZBMZENZDNZIOUBCMZENZDNZIOBDEPCDEPAUEUHIAUDUGDFAUCUFEGABCUBHQRRSBD
      EITCDEITUA $.
  $}

  ${
    $d x ph $.  $d y z ph $.  $d z ps $.  $d z ch $.
    opabbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal ordered-pair class abstractions (deduction
       rule).  (Contributed by NM, 15-May-1995.) $)
    opabbidv $p |- ( ph -> { <. x , y >. | ps } = { <. x , y >. | ch } ) $=
      ( nfv opabbid ) ABCDEADGAEGFH $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.  $d z ps $.
    opabbii.1 $e |- ( ph <-> ps ) $.
    $( Equivalent wff's yield equal class abstractions.  (Contributed by NM,
       15-May-1995.) $)
    opabbii $p |- { <. x , y >. | ph } = { <. x , y >. | ps } $=
      ( vz cv wceq copab eqid wb a1i opabbidv ax-mp ) FGZOHZACDIBCDIHOJPABCDABK
      PELMN $.
  $}

  ${
    $d x z w $.  $d y z w $.  $d ph w $.
    nfopab.1 $e |- F/ z ph $.
    $( Bound-variable hypothesis builder for class abstraction.  (Contributed
       by NM, 1-Sep-1999.)  (Unnecessary distinct variable restrictions were
       removed by Andrew Salmon, 11-Jul-2011.) $)
    nfopab $p |- F/_ z { <. x , y >. | ph } $=
      ( vw copab cv cop wceq wa wex cab df-opab nfv nfan nfex nfab nfcxfr ) DAB
      CGFHBHCHIJZAKZCLZBLZFMABCFNUCDFUBDBUADCTADTDOEPQQRS $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( The first abstraction variable in an ordered-pair class abstraction
       (class builder) is effectively not free.  (Contributed by NM,
       16-May-1995.)  (Revised by Mario Carneiro, 14-Oct-2016.) $)
    nfopab1 $p |- F/_ x { <. x , y >. | ph } $=
      ( vz copab cv cop wceq wa wex cab df-opab nfe1 nfab nfcxfr ) BABCEDFBFCFG
      HAICJZBJZDKABCDLQBDPBMNO $.

    $( The second abstraction variable in an ordered-pair class abstraction
       (class builder) is effectively not free.  (Contributed by NM,
       16-May-1995.)  (Revised by Mario Carneiro, 14-Oct-2016.) $)
    nfopab2 $p |- F/_ y { <. x , y >. | ph } $=
      ( vz copab cv cop wceq wa wex cab df-opab nfe1 nfex nfab nfcxfr ) CABCEDF
      BFCFGHAIZCJZBJZDKABCDLSCDRCBQCMNOP $.
  $}

  ${
    $d x y z w v $.  $d v ph $.  $d v ps $.
    cbvopab.1 $e |- F/ z ph $.
    cbvopab.2 $e |- F/ w ph $.
    cbvopab.3 $e |- F/ x ps $.
    cbvopab.4 $e |- F/ y ps $.
    cbvopab.5 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables in an ordered-pair class
       abstraction, using implicit substitution.  (Contributed by NM,
       14-Sep-2003.) $)
    cbvopab $p |- { <. x , y >. | ph } = { <. z , w >. | ps } $=
      ( vv cv cop wceq wa wex cab nfv nfan opeq12 eqeq2d anbi12d cbvex2 df-opab
      copab abbii 3eqtr4i ) LMZCMZDMZNZOZAPZDQCQZLRUIEMZFMZNZOZBPZFQEQZLRACDUFB
      EFUFUOVALUNUTCDEFUMAEUMESGTUMAFUMFSHTUSBCUSCSITUSBDUSDSJTUJUPOUKUQOPZUMUS
      ABVBULURUIUJUKUPUQUAUBKUCUDUGACDLUEBEFLUEUH $.
  $}

  ${
    $d x y z w $.  $d z w v ph $.  $d x y v ps $.
    cbvopabv.1 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables in an ordered-pair class
       abstraction, using implicit substitution.  (Contributed by NM,
       15-Oct-1996.) $)
    cbvopabv $p |- { <. x , y >. | ph } = { <. z , w >. | ps } $=
      ( nfv cbvopab ) ABCDEFAEHAFHBCHBDHGI $.
  $}

  ${
    $d v w x y $.  $d v w y z $.  $d v w ph $.  $d v w ps $.
    cbvopab1.1 $e |- F/ z ph $.
    cbvopab1.2 $e |- F/ x ps $.
    cbvopab1.3 $e |- ( x = z -> ( ph <-> ps ) ) $.
    $( Change first bound variable in an ordered-pair class abstraction, using
       explicit substitution.  (Contributed by NM, 6-Oct-2004.)  (Revised by
       Mario Carneiro, 14-Oct-2016.) $)
    cbvopab1 $p |- { <. x , y >. | ph } = { <. z , y >. | ps } $=
      ( vw vv cv cop wceq wa wex cab copab wsb nfv nfan nfs1v nfex opeq1 eqeq2d
      sbequ12 anbi12d exbidv cbvex nfsb sbequ sbie syl6bb bitri df-opab 3eqtr4i
      abbii ) IKZCKZDKZLZMZANZDOZCOZIPUQEKZUSLZMZBNZDOZEOZIPACDQBEDQVDVJIVDUQJK
      ZUSLZMZACJRZNZDOZJOVJVCVPCJVCJSVOCDVMVNCVMCSACJUATUBURVKMZVBVODVQVAVMAVNV
      QUTVLUQURVKUSUCUDACJUEUFUGUHVPVIJEVOEDVMVNEVMESACJEFUITUBVIJSVKVEMZVOVHDV
      RVMVGVNBVRVLVFUQVKVEUSUCUDVRVNACERBAJECUJABCEGHUKULUFUGUHUMUPACDIUNBEDIUN
      UO $.
  $}

  ${
    $d w x y z $.  $d w ph $.  $d w ps $.
    cbvopab2.1 $e |- F/ z ph $.
    cbvopab2.2 $e |- F/ y ps $.
    cbvopab2.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Change second bound variable in an ordered-pair class abstraction, using
       explicit substitution.  (Contributed by NM, 22-Aug-2013.) $)
    cbvopab2 $p |- { <. x , y >. | ph } = { <. x , z >. | ps } $=
      ( vw cv cop wceq wa wex cab copab nfv nfan opeq2 df-opab anbi12d 3eqtr4i
      eqeq2d cbvex exbii abbii ) IJZCJZDJZKZLZAMZDNZCNZIOUGUHEJZKZLZBMZENZCNZIO
      ACDPBCEPUNUTIUMUSCULURDEUKAEUKEQFRUQBDUQDQGRUIUOLZUKUQABVAUJUPUGUIUOUHSUC
      HUAUDUEUFACDITBCEITUB $.
  $}

  ${
    $d x y z w $.  $d z w ph $.
    $( Change first bound variable in an ordered-pair class abstraction, using
       explicit substitution.  (Contributed by NM, 31-Jul-2003.) $)
    cbvopab1s $p |- { <. x , y >. | ph } = { <. z , y >. | [ z / x ] ph } $=
      ( vw cv cop wceq wa wex cab wsb copab nfv nfs1v nfan opeq1 eqeq2d df-opab
      nfex sbequ12 anbi12d exbidv cbvex abbii 3eqtr4i ) EFZBFZCFZGZHZAIZCJZBJZE
      KUGDFZUIGZHZABDLZIZCJZDJZEKABCMURDCMUNVAEUMUTBDUMDNUSBCUQURBUQBNABDOPTUHU
      OHZULUSCVBUKUQAURVBUJUPUGUHUOUIQRABDUAUBUCUDUEABCESURDCESUF $.
  $}

  ${
    $d x y $.  $d y z $.  $d z ph $.  $d x ps $.
    cbvopab1v.1 $e |- ( x = z -> ( ph <-> ps ) ) $.
    $( Rule used to change the first bound variable in an ordered pair
       abstraction, using implicit substitution.  (Contributed by NM,
       31-Jul-2003.)  (Proof shortened by Eric Schmidt, 4-Apr-2007.) $)
    cbvopab1v $p |- { <. x , y >. | ph } = { <. z , y >. | ps } $=
      ( nfv cbvopab1 ) ABCDEAEGBCGFH $.
  $}

  ${
    $d x y z w $.  $d z w ph $.  $d y w ps $.
    cbvopab2v.1 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Rule used to change the second bound variable in an ordered pair
       abstraction, using implicit substitution.  (Contributed by NM,
       2-Sep-1999.) $)
    cbvopab2v $p |- { <. x , y >. | ph } = { <. x , z >. | ps } $=
      ( vw cv cop wceq wex cab copab opeq2 eqeq2d anbi12d cbvexv exbii df-opab
      wa abbii 3eqtr4i ) GHZCHZDHZIZJZATZDKZCKZGLUCUDEHZIZJZBTZEKZCKZGLACDMBCEM
      UJUPGUIUOCUHUNDEUEUKJZUGUMABUQUFULUCUEUKUDNOFPQRUAACDGSBCEGSUB $.
  $}

  ${
    $d x z $.  $d y z $.  $d ph z $.  $d ps z $.
    $( Union of two ordered pair class abstractions.  (Contributed by NM,
       30-Sep-2002.) $)
    unopab $p |- ( { <. x , y >. | ph } u. { <. x , y >. | ps } ) =
               { <. x , y >. | ( ph \/ ps ) } $=
      ( vz cv cop wceq wa wex cab wo copab unab 19.43 andi exbii bitr2i df-opab
      cun bitr3i abbii eqtri uneq12i 3eqtr4i ) EFCFDFGHZAIZDJZCJZEKZUFBIZDJZCJZ
      EKZTZUFABLZIZDJZCJZEKZACDMZBCDMZTUPCDMUOUIUMLZEKUTUIUMENVCUSEVCUHULLZCJUS
      UHULCOVDURCURUGUKLZDJVDUQVEDUFABPQUGUKDORQUAUBUCVAUJVBUNACDESBCDESUDUPCDE
      SUE $.
  $}

  ${
    $d x y ph $.  $d y A $.  $d y B $.  $d y C $.  $d y D $.
    $( An equality theorem for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.) $)
    mpteq12f $p |- ( ( A. x A = C /\ A. x e. A B = D ) ->
                    ( x e. A |-> B ) = ( x e. C |-> D ) ) $=
      ( vy wceq wal wral wa cv wcel copab cmpt nfa1 nfra1 nfan nfv rsp df-mpt
      imp eqeq2d pm5.32da sp eleq2d anbi1d sylan9bbr opabbid 3eqtr4g ) BDGZAHZC
      EGZABIZJZAKZBLZFKZCGZJZAFMUODLZUQEGZJZAFMABCNADENUNUSVBAFUKUMAUJAOULABPQU
      NFRUMUSUPVAJUKVBUMUPURVAUMUPJCEUQUMUPULULABSUAUBUCUKUPUTVAUKBDUOUJAUDUEUF
      UGUHAFBCTAFDETUI $.

    mpteq12dv.1 $e |- ( ph -> A = C ) $.
    ${
      mpteq12dva.2 $e |- ( ( ph /\ x e. A ) -> B = D ) $.
      $( An equality inference for the maps to notation.  (Contributed by Mario
         Carneiro, 26-Jan-2017.) $)
      mpteq12dva $p |- ( ph -> ( x e. A |-> B ) = ( x e. C |-> D ) ) $=
        ( wceq wal wral cmpt alrimiv ralrimiva mpteq12f syl2anc ) ACEIZBJDFIZBC
        KBCDLBEFLIAQBGMARBCHNBCDEFOP $.
    $}

    mpteq12dv.2 $e |- ( ph -> B = D ) $.
    $( An equality inference for the maps to notation.  (Contributed by NM,
       24-Aug-2011.)  (Revised by Mario Carneiro, 16-Dec-2013.) $)
    mpteq12dv $p |- ( ph -> ( x e. A |-> B ) = ( x e. C |-> D ) ) $=
      ( wceq cv wcel adantr mpteq12dva ) ABCDEFGADFIBJCKHLM $.
  $}

  ${
    $d x A $.  $d x C $.
    $( An equality theorem for the maps to notation.  (Contributed by NM,
       16-Dec-2013.) $)
    mpteq12 $p |- ( ( A = C /\ A. x e. A B = D ) ->
                    ( x e. A |-> B ) = ( x e. C |-> D ) ) $=
      ( wceq wal wral cmpt ax-17 mpteq12f sylan ) BDFZMAGCEFABHABCIADEIFMAJABCD
      EKL $.
  $}

  ${
    $d x A $.  $d x B $.
    $( An equality theorem for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.) $)
    mpteq1 $p |- ( A = B -> ( x e. A |-> C ) = ( x e. B |-> C ) ) $=
      ( wceq wral cmpt cv wcel eqidd rgen mpteq12 mpan2 ) BCEDDEZABFABDGACDGENA
      BAHBIDJKABDCDLM $.

    mpteq1d.1 $e |- ( ph -> A = B ) $.
    $( An equality theorem for the maps to notation.  (Contributed by Mario
       Carneiro, 11-Jun-2016.) $)
    mpteq1d $p |- ( ph -> ( x e. A |-> C ) = ( x e. B |-> C ) ) $=
      ( wceq cmpt mpteq1 syl ) ACDGBCEHBDEHGFBCDEIJ $.
  $}

  ${
    mpteq2ia.1 $e |- ( x e. A -> B = C ) $.
    $( An equality inference for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.) $)
    mpteq2ia $p |- ( x e. A |-> B ) = ( x e. A |-> C ) $=
      ( wceq wal wral cmpt eqid ax-gen rgen mpteq12f mp2an ) BBFZAGCDFZABHABCIA
      BDIFOABJKPABELABCBDMN $.
  $}

  ${
    mpteq2i.1 $e |- B = C $.
    $( An equality inference for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.) $)
    mpteq2i $p |- ( x e. A |-> B ) = ( x e. A |-> C ) $=
      ( wceq cv wcel a1i mpteq2ia ) ABCDCDFAGBHEIJ $.
  $}

  ${
    mpteq12i.1 $e |- A = C $.
    mpteq12i.2 $e |- B = D $.
    $( An equality inference for the maps to notation.  (Contributed by Scott
       Fenton, 27-Oct-2010.)  (Revised by Mario Carneiro, 16-Dec-2013.) $)
    mpteq12i $p |- ( x e. A |-> B ) = ( x e. C |-> D ) $=
      ( cmpt wceq wtru a1i mpteq12dv trud ) ABCHADEHIJABCDEBDIJFKCEIJGKLM $.
  $}

  ${
    mpteq2da.1 $e |- F/ x ph $.
    mpteq2da.2 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Slightly more general equality inference for the maps to notation.
       (Contributed by FL, 14-Sep-2013.)  (Revised by Mario Carneiro,
       16-Dec-2013.) $)
    mpteq2da $p |- ( ph -> ( x e. A |-> B ) = ( x e. A |-> C ) ) $=
      ( wceq wal wral cmpt eqid ax-gen cv wcel ex ralrimi mpteq12f sylancr ) AC
      CHZBIDEHZBCJBCDKBCEKHTBCLMAUABCFABNCOUAGPQBCDCERS $.
  $}

  ${
    $d x ph $.
    mpteq2dva.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Slightly more general equality inference for the maps to notation.
       (Contributed by Scott Fenton, 25-Apr-2012.) $)
    mpteq2dva $p |- ( ph -> ( x e. A |-> B ) = ( x e. A |-> C ) ) $=
      ( nfv mpteq2da ) ABCDEABGFH $.
  $}

  ${
    $d x ph $.
    mpteq2dv.1 $e |- ( ph -> B = C ) $.
    $( An equality inference for the maps to notation.  (Contributed by Mario
       Carneiro, 23-Aug-2014.) $)
    mpteq2dv $p |- ( ph -> ( x e. A |-> B ) = ( x e. A |-> C ) ) $=
      ( wceq cv wcel adantr mpteq2dva ) ABCDEADEGBHCIFJK $.
  $}

  ${
    $d z A $.  $d z B $.  $d x y z $.
    nfmpt.1 $e |- F/_ x A $.
    nfmpt.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for the maps-to notation.
       (Contributed by NM, 20-Feb-2013.) $)
    nfmpt $p |- F/_ x ( y e. A |-> B ) $=
      ( vz cmpt cv wcel wceq wa copab df-mpt nfcri nfeq2 nfan nfopab nfcxfr ) A
      BCDHBICJZGIZDKZLZBGMBGCDNUCBGATUBAABCEOAUADFPQRS $.
  $}

  ${
    $d A z $.  $d B z $.  $d x y $.  $d x z $.
    $( Bound-variable hypothesis builder for the maps-to notation.
       (Contributed by FL, 17-Feb-2008.) $)
    nfmpt1 $p |- F/_ x ( x e. A |-> B ) $=
      ( vz cmpt cv wcel wceq wa copab df-mpt nfopab1 nfcxfr ) AABCEAFBGDFCHIZAD
      JADBCKNADLM $.
  $}

  ${
    $d w z x A $.  $d w z y A $.  $d w z B $.  $d w z C $.
    cbvmpt.1 $e |- F/_ y B $.
    cbvmpt.2 $e |- F/_ x C $.
    cbvmpt.3 $e |- ( x = y -> B = C ) $.
    $( Rule to change the bound variable in a maps-to function, using implicit
       substitution.  This version has bound-variable hypotheses in place of
       distinct variable conditions.  (Contributed by NM, 11-Sep-2011.) $)
    cbvmpt $p |- ( x e. A |-> B ) = ( y e. A |-> C ) $=
      ( vz vw cv wcel wceq wa copab cmpt wsb nfv nfan weq nfs1v sbequ12 anbi12d
      eleq1 cbvopab1 nfeq2 nfsb sbequ eqeq2d sbie syl6bb eqtri df-mpt 3eqtr4i )
      AKZCLZIKZDMZNZAIOZBKZCLZUQEMZNZBIOZACDPBCEPUTJKZCLZURAJQZNZJIOVEUSVIAIJUS
      JRVGVHAVGARURAJUASAJTUPVGURVHUOVFCUDURAJUBUCUEVIVDJIBVGVHBVGBRURAJBBUQDFU
      FUGSVDJRJBTZVGVBVHVCVFVACUDVJVHURABQVCURJBAUHURVCABAUQEGUFABTDEUQHUIUJUKU
      CUEULAICDUMBICEUMUN $.
  $}

  ${
    $d A x $.  $d A y $.  $d B y $.  $d C x $.
    cbvmptv.1 $e |- ( x = y -> B = C ) $.
    $( Rule to change the bound variable in a maps-to function, using implicit
       substitution.  (Contributed by Mario Carneiro, 19-Feb-2013.) $)
    cbvmptv $p |- ( x e. A |-> B ) = ( y e. A |-> C ) $=
      ( nfcv cbvmpt ) ABCDEBDGAEGFH $.
  $}

  ${
    $d x y $.  $d y B $.
    $( Function with universal domain in maps-to notation.  (Contributed by NM,
       16-Aug-2013.) $)
    mptv $p |- ( x e. _V |-> B ) = { <. x , y >. | y = B } $=
      ( cvv cmpt cv wcel wceq wa copab df-mpt vex biantrur opabbii eqtr4i ) ADC
      EAFDGZBFCHZIZABJQABJABDCKQRABPQALMNO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Transitive classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare a new symbol. $)
  $c Tr $. $( Transitive predicate (read:  "the following class is
              transitive") $)

  $( Extend wff notation to include transitive classes.  Notation from
     [TakeutiZaring] p. 35. $)
  wtr $a wff Tr A $.

  $( Define the transitive class predicate.  Not to be confused with a
     transitive relation (see ~ cotr ).  Definition of [Enderton] p. 71
     extended to arbitrary classes.  For alternate definitions, see ~ dftr2
     (which is suggestive of the word "transitive"), ~ dftr3 , ~ dftr4 ,
     ~ dftr5 , and (when ` A ` is a set) ~ unisuc .  The term "complete" is
     used instead of "transitive" in Definition 3 of [Suppes] p. 130.
     (Contributed by NM, 29-Aug-1993.) $)
  df-tr $a |- ( Tr A <-> U. A C_ A ) $.

  ${
    $d x y A $.
    $( An alternate way of defining a transitive class.  Exercise 7 of
       [TakeutiZaring] p. 40.  (Contributed by NM, 24-Apr-1994.) $)
    dftr2 $p |- ( Tr A <-> A. x A. y ( ( x e. y /\ y e. A ) -> x e. A ) ) $=
      ( cuni wss cv wcel wi wal wa dfss2 df-tr 19.23v eluni imbi1i bitr4i albii
      wtr wex 3bitr4i ) CDZCEAFZUAGZUBCGZHZAICRUBBFZGUFCGJZUDHBIZAIAUACKCLUHUEA
      UHUGBSZUDHUEUGUDBMUCUIUDBUBCNOPQT $.

    $( An alternate way of defining a transitive class.  (Contributed by NM,
       20-Mar-2004.) $)
    dftr5 $p |- ( Tr A <-> A. x e. A A. y e. x y e. A ) $=
      ( wtr cv wcel wa wi wal wral dftr2 alcom impexp albii df-ral bitr4i bitri
      r19.21v ) CDBEZAEZFZTCFZGSCFZHZAIBIZUCBTJZACJZBACKUEUDBIZAIZUGUDBALUIUBUF
      HZAIUGUHUJAUHUBUCHZBTJZUJUHUAUKHZBIULUDUMBUAUBUCMNUKBTOPUBUCBTRQNUFACOPQQ
      $.

    $( An alternate way of defining a transitive class.  Definition 7.1 of
       [TakeutiZaring] p. 35.  (Contributed by NM, 29-Aug-1993.) $)
    dftr3 $p |- ( Tr A <-> A. x e. A x C_ A ) $=
      ( vy wtr cv wcel wral wss dftr5 dfss3 ralbii bitr4i ) BDCEBFCAEZGZABGMBHZ
      ABGACBIONABCMBJKL $.
  $}

  $( An alternate way of defining a transitive class.  Definition of [Enderton]
     p. 71.  (Contributed by NM, 29-Aug-1993.) $)
  dftr4 $p |- ( Tr A <-> A C_ ~P A ) $=
    ( wtr cuni wss cpw df-tr sspwuni bitr4i ) ABACADAAEDAFAAGH $.

  $( Equality theorem for the transitive class predicate.  (Contributed by NM,
     17-Sep-1993.) $)
  treq $p |- ( A = B -> ( Tr A <-> Tr B ) ) $=
    ( wceq cuni wss wtr unieq sseq1d sseq2 bitrd df-tr 3bitr4g ) ABCZADZAEZBDZB
    EZAFBFMOPAEQMNPAABGHABPIJAKBKL $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( In a transitive class, the membership relation is transitive.
       (Contributed by NM, 19-Apr-1994.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    trel $p |- ( Tr A -> ( ( B e. C /\ C e. A ) -> B e. A ) ) $=
      ( vy vx wtr cv wcel wa wi wal dftr2 eleq12 wb eleq1 adantl anbi12d adantr
      wceq imbi12d spc2gv pm2.43b sylbi ) AFDGZEGZHZUEAHZIZUDAHZJZEKDKZBCHZCAHZ
      IZBAHZJZDEALUKUNUOUJUPDEBCCAUDBSZUECSZIZUHUNUIUOUSUFULUGUMUDBUECMURUGUMNU
      QUECAOPQUQUIUONURUDBAORTUAUBUC $.
  $}

  $( In a transitive class, the membership relation is transitive.
     (Contributed by NM, 19-Apr-1994.) $)
  trel3 $p |- ( Tr A -> ( ( B e. C /\ C e. D /\ D e. A ) -> B e. A ) ) $=
    ( wtr wcel w3a wa 3anass trel anim2d syl5bi syld ) AEZBCFZCDFZDAFZGZOCAFZHZ
    BAFROPQHZHNTOPQINUASOACDJKLABCJM $.

  ${
    $d x A $.  $d x B $.
    $( An element of a transitive class is a subset of the class.  (Contributed
       by NM, 7-Aug-1994.) $)
    trss $p |- ( Tr A -> ( B e. A -> B C_ A ) ) $=
      ( vx wtr wcel wss cv wceq eleq1 sseq1 imbi12d imbi2d wral dftr3 rsp sylbi
      wi vtoclg pm2.43b ) ADZBAEZBAFZTCGZAEZUCAFZQZQTUAUBQZQCBAUCBHZUFUGTUHUDUA
      UEUBUCBAIUCBAJKLTUECAMUFCANUECAOPRS $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The intersection of transitive classes is transitive.  (Contributed by
       NM, 9-May-1994.) $)
    trin $p |- ( ( Tr A /\ Tr B ) -> Tr ( A i^i B ) ) $=
      ( vx wtr cin wss wral wcel elin trss im2anan9 syl5bi ssin syl6ib ralrimiv
      wa cv dftr3 sylibr ) ADZBDZPZCQZABEZFZCUDGUDDUBUECUDUBUCUDHZUCAFZUCBFZPZU
      EUFUCAHZUCBHZPUBUIUCABITUJUGUAUKUHAUCJBUCJKLUCABMNOCUDRS $.
  $}

  $( The empty set is transitive.  (Contributed by NM, 16-Sep-1993.) $)
  tr0 $p |- Tr (/) $=
    ( c0 wtr cpw wss 0ss dftr4 mpbir ) ABAACZDHEAFG $.

  $( The universe is transitive.  (Contributed by NM, 14-Sep-2003.) $)
  trv $p |- Tr _V $=
    ( cvv wtr cuni wss ssv df-tr mpbir ) ABACZADHEAFG $.

  ${
    $d x y z A $.  $d y z B $.
    $( The indexed union of a class of transitive sets is transitive.
       (Contributed by Mario Carneiro, 16-Nov-2014.) $)
    triun $p |- ( A. x e. A Tr B -> Tr U_ x e. A B ) $=
      ( vy wtr wral cv ciun wss wcel wrex eliun r19.29 nfcv nfiu1 nfss trss imp
      wa ssiun2 sstr2 syl5com syl5 rexlimi syl sylan2b ralrimiva dftr3 sylibr )
      CEZABFZDGZABCHZIZDUMFUMEUKUNDUMULUMJUKULCJZABKZUNAULBCLUKUPSUJUOSZABKUNUJ
      UOABMUQUNABAULUMAULNABCOPUQULCIZAGBJZUNUJUOURCULQRUSCUMIURUNABCTULCUMUAUB
      UCUDUEUFUGDUMUHUI $.

    $( The union of a class of transitive sets is transitive.  Exercise 5(a) of
       [Enderton] p. 73.  (Contributed by Scott Fenton, 21-Feb-2011.)  (Proof
       shortened by Mario Carneiro, 26-Apr-2014.) $)
    truni $p |- ( A. x e. A Tr x -> Tr U. A ) $=
      ( cv wtr wral ciun cuni triun wceq wb uniiun treq ax-mp sylibr ) ACZDABEA
      BOFZDZBGZDZABOHRPISQJABKRPLMN $.

    $( The intersection of a class of transitive sets is transitive.  Exercise
       5(b) of [Enderton] p. 73.  (Contributed by Scott Fenton,
       25-Feb-2011.) $)
    trint $p |- ( A. x e. A Tr x -> Tr |^| A ) $=
      ( vy cv wtr wral wel wss wi cint dftr3 ralbii biimpi df-ral ralcom4 bitri
      wal sylib ralim alimi syl wcel vex elint2 ssint imbi12i albii sylibr ) AD
      ZEZABFZCAGZABFZCDZUIHZABFZIZCQZBJZEZUKULUOIZABFZCQZURUKUOCUIFZABFZVCUKVEU
      JVDABCUIKLMVEVACQZABFVCVDVFABUOCUINLVAACBOPRVBUQCULUOABSTUAUTUNUSHZCUSFZU
      RCUSKVHUNUSUBZVGIZCQURVGCUSNVJUQCVIUMVGUPAUNBCUCUDAUNBUEUFUGPPUH $.

    $( If ` A ` is transitive and non-null, then ` |^| A ` is a subset of
       ` A ` .  (Contributed by Scott Fenton, 3-Mar-2011.) $)
    trintss $p |- ( ( A =/= (/) /\ Tr A ) -> |^| A C_ A ) $=
      ( vy vx c0 wne wtr wa cint cv wcel wel wral elint2 wrex r19.2z exp3acom23
      vex ex trel rexlimdv sylan9 syl5bi ssrdv ) ADEZAFZGZBAHZABIZUGJBCKZCALZUF
      UHAJZCUHABQMUDUJUICANZUEUKUDUJULUICAORUEUIUKCAUEUICIZAJUKAUHUMSPTUAUBUC
      $.

    $( Any non-empty transitive class includes its intersection.  Exercise 2 in
       [TakeutiZaring] p. 44.  (Contributed by Andrew Salmon, 14-Nov-2011.) $)
    trint0 $p |- ( ( Tr A /\ A =/= (/) ) -> |^| A C_ A ) $=
      ( vx c0 wne wtr cint wss cv wcel wex wi intss1 trss com12 sylsyld exlimiv
      n0 sstr2 sylbi impcom ) ACDZAEZAFZAGZUABHZAIZBJUBUDKZBAQUFUGBUFUCUEGUBUEA
      GZUDUEALUBUFUHAUEMNUCUEAROPST $.
  $}

$( End $[ set-class.mm $] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Replacement
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Introduce the Axiom of Replacement
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.
    $( Axiom of Replacement.  An axiom scheme of Zermelo-Fraenkel set theory.
       Axiom 5 of [TakeutiZaring] p. 19.  It tells us that the image of any set
       under a function is also a set (see the variant ~ funimaex ).  Although
       ` ph ` may be any wff whatsoever, this axiom is useful (i.e. its
       antecedent is satisfied) when we are given some function and ` ph `
       encodes the predicate "the value of the function at ` w ` is ` z ` ."
       Thus, ` ph ` will ordinarily have free variables ` w ` and ` z ` - think
       of it informally as ` ph ( w , z ) ` .  We prefix ` ph ` with the
       quantifier ` A. y ` in order to "protect" the axiom from any ` ph `
       containing ` y ` , thus allowing us to eliminate any restrictions on
       ` ph ` .  This makes the axiom usable in a formalization that omits the
       logically redundant axiom ~ ax-17 .  Another common variant is derived
       as ~ axrep5 , where you can find some further remarks.  A slightly more
       compact version is shown as ~ axrep2 .  A quite different variant is
       ~ zfrep6 , which if used in place of ~ ax-rep would also require that
       the Separation Scheme ~ axsep be stated as a separate axiom.

       There is very a strong generalization of Replacement that doesn't demand
       function-like behavior of ` ph ` .  Two versions of this generalization
       are called the Collection Principle ~ cp and the Boundedness Axiom
       ~ bnd .

       Many developments of set theory distinguish the uses of Replacement from
       uses the weaker axioms of Separation ~ axsep , Null Set ~ axnul , and
       Pairing ~ axpr , all of which we derive from Replacement.  In order to
       make it easier to identify the uses of those redundant axioms, we
       restate them as axioms ~ ax-sep , ~ ax-nul , and ~ ax-pr below the
       theorems that prove them.  (Contributed by NM, 23-Dec-1993.) $)
    ax-rep $a |- ( A. w E. y A. z ( A. y ph -> z = y ) ->
                     E. y A. z ( z e. y <-> E. w ( w e. x /\ A. y ph ) ) ) $.
  $}

  ${
    $d w y ph $.  $d w x y z $.
    $( The version of the Axiom of Replacement used in the Metamath Solitaire
       applet ~ http://us.metamath.org/mmsolitaire/mms.html .  Equivalence is
       shown via the path ~ ax-rep ` -> ` ~ axrep1 ` -> ` ~ axrep2 ` -> `
       ~ axrepnd ` -> ` ~ zfcndrep = ~ ax-rep .  (Contributed by NM,
       19-Nov-2005.)  (Proof shortened by Mario Carneiro, 17-Nov-2016.) $)
    axrep1 $p |- E. x ( E. y A. z ( ph -> z = y ) ->
                 A. z ( z e. x <-> E. x ( x e. y /\ ph ) ) ) $=
      ( vw weq wi wal wex wel wa elequ2 anbi1d exbidv bibi2d albidv albii exbii
      wb nfv imbi2d ax-rep 19.3v imbi1i nfe1 nfbi nfal anbi2i a1i bibi12d cbvex
      3imtr3i chvarv 19.35ri ) ADCFZGZDHZCIZDBJZBCJZAKZBIZSZDHZBURBHZUSBEJZAKZB
      IZSZDHZBIZGVEVDBIZGECECFZVKVLVEVMVJVDBVMVIVCDVMVHVBUSVMVGVABVMVFUTAECBLMN
      OPNUAACHZUOGZDHZCIZBHDCJZVFVNKZBIZSZDHZCIVEVKAECDBUBVQURBVPUQCVOUPDVNAUOA
      CUCZUDQRQWBVJCBWABDVRVTBVRBTVSBUEUFUGVJCTCBFZWAVIDWDVRUSVTVHCBDLVTVHSWDVS
      VGBVNAVFWCUHRUIUJPUKULUMUN $.
  $}

  ${
    $d w ph $.  $d w x y z $.
    $( Axiom of Replacement expressed with the fewest number of different
       variables and without any restrictions on ` ph ` .  (Contributed by NM,
       15-Aug-2003.) $)
    axrep2 $p |- E. x ( E. y A. z ( ph -> z = y ) ->
                        A. z ( z e. x <-> E. x ( x e. y /\ A. y ph ) ) ) $=
      ( vw wal weq wi wex wel wa nfe1 nfv nfim nfex exbidv albidv imbi2d imim1i
      wb elequ2 anbi1d bibi2d axrep1 chvar sp alimi eximi nfa1 nfal cbvex sylib
      equequ2 eximii ) ACFZDEGZHZDFZEIZDBJZBCJZUOKZBIZTZDFZHZADCGZHZDFZCIZVEHBU
      SUTBEJZUOKZBIZTZDFZHZBIVFBIECVFEBUSVEEURELVEEMNOECGZVPVFBVQVOVEUSVQVNVDDV
      QVMVCUTVQVLVBBVQVKVAUOECBUAUBPUCQRPUOBEDUDUEVJUSVEVJUOVGHZDFZCIUSVIVSCVHV
      RDUOAVGACUFSUGUHVSURCEVSEMUQCDUOUPCACUIUPCMNUJCEGZVRUQDVTVGUPUOCEDUMRQUKU
      LSUN $.
  $}

  ${
    $d w x y z $.
    $( Axiom of Replacement slightly strengthened from ~ axrep2 ; ` w ` may
       occur free in ` ph ` .  (Contributed by NM, 2-Jan-1997.) $)
    axrep3 $p |- E. x ( E. y A. z ( ph -> z = y ) ->
                 A. z ( z e. x <-> E. x ( x e. w /\ A. y ph ) ) ) $=
      ( weq wi wal wex wel wa wb nfe1 nfv nfa1 nfan nfex nfbi nfal exbidv chvar
      nfim elequ2 anbi1d bibi2d albidv imbi2d axrep2 ) ADCFGDHZCIZDBJZBCJZACHZK
      ZBIZLZDHZGZBIUJUKBEJZUMKZBIZLZDHZGZBICEVDCBUJVCCUICMVBCDUKVACUKCNUTCBUSUM
      CUSCNACOPQRSUBQCEFZURVDBVEUQVCUJVEUPVBDVEUOVAUKVEUNUTBVEULUSUMCEBUCUDTUEU
      FUGTABCDUHUA $.
  $}

  ${
    $d x y z w $.
    axrep4.1 $e |- F/ z ph $.
    $( A more traditional version of the Axiom of Replacement.  (Contributed by
       NM, 14-Aug-1994.) $)
    axrep4 $p |- ( A. x E. z A. y ( ph -> y = z ) ->
                E. z A. y ( y e. z <-> E. x ( x e. w /\ ph ) ) ) $=
      ( weq wi wal wex wel wa wb axrep3 19.35i nfv nfa1 nfan nfbi nfal nfex a1i
      nfe1 elequ2 19.3 anbi2i exbii bibi12d albidv cbvex sylib ) ACDGHCIDJZBICB
      KZBEKZADIZLZBJZMZCIZBJCDKZUNALZBJZMZCIZDJULUSBABDCENOUSVDBDURDCUMUQDUMDPU
      PDBUNUODUNDPADQRUASTVCBCUTVBBUTBPVABUCSTBDGZURVCCVEUMUTUQVBBDCUDUQVBMVEUP
      VABUOAUNADFUEUFUGUBUHUIUJUK $.
  $}

  ${
    $d x y z w $.
    axrep5.1 $e |- F/ z ph $.
    $( Axiom of Replacement (similar to Axiom Rep of [BellMachover] p. 463).
       The antecedent tells us ` ph ` is analogous to a "function" from ` x `
       to ` y ` (although it is not really a function since it is a wff and not
       a class).  In the consequent we postulate the existence of a set ` z `
       that corresponds to the "image" of ` ph ` restricted to some other set
       ` w ` .  The hypothesis says ` z ` must not be free in ` ph ` .
       (Contributed by NM, 26-Nov-1995.)  (Revised by Mario Carneiro,
       14-Oct-2016.) $)
    axrep5 $p |- ( A. x ( x e. w -> E. z A. y ( ph -> y = z ) ) ->
                E. z A. y ( y e. z <-> E. x ( x e. w /\ ph ) ) ) $=
      ( wel weq wi wal wex wa wb 19.37v impexp albii 19.21v bitr2i exbii bitr3i
      nfv nfan axrep4 sylbi anabs5 bibi2i sylib ) BEGZACDHZIZCJZDKIZBJZCDGZUHUH
      ALZLZBKZMZCJZDKZUNUOBKZMZCJZDKUMUOUIIZCJZDKZBJUTULVFBULUHUKIZDKVFUHUKDNVG
      VEDVEUHUJIZCJVGVDVHCUHAUIOPUHUJCQRSTPUOBCDEUHADUHDUAFUBUCUDUSVCDURVBCUQVA
      UNUPUOBUHAUESUFPSUG $.
  $}

  ${
    $d y z A v $.  $d z ph v $.  $d A w v $.  $d x y z v $.  $d x w v $.
    zfrepclf.1 $e |- F/_ x A $.
    zfrepclf.2 $e |- A e. _V $.
    zfrepclf.3 $e |- ( x e. A -> E. z A. y ( ph -> y = z ) ) $.
    $( An inference rule based on the Axiom of Replacement.  Typically, ` ph `
       defines a function from ` x ` to ` y ` .  (Contributed by NM,
       26-Nov-1995.) $)
    zfrepclf $p |- E. z A. y ( y e. z <-> E. x ( x e. A /\ ph ) ) $=
      ( vv wel cv wcel wa wex wb wal wceq wi nfeq2 eleq2 syl6bi nfv exbid mpbid
      alrimi axrep5 syl anbi1d bibi2d albidv exbidv vtocle ) CDJZBKZELZAMZBNZOZ
      CPZDNZIEGIKZEQZUMBIJZAMZBNZOZCPZDNZUTVBVCACKDKQRCPDNZRZBPVHVBVJBBVAEFSZVB
      VCUOVIVAEUNTZHUAUEABCDIADUBUFUGVBVGUSDVBVFURCVBVEUQUMVBVDUPBVKVBVCUOAVLUH
      UCUIUJUKUDUL $.
  $}

  ${
    $d x y z A $.  $d z ph $.
    zfrep3cl.1 $e |- A e. _V $.
    zfrep3cl.2 $e |- ( x e. A -> E. z A. y ( ph -> y = z ) ) $.
    $( An inference rule based on the Axiom of Replacement.  Typically, ` ph `
       defines a function from ` x ` to ` y ` .  (Contributed by NM,
       26-Nov-1995.) $)
    zfrep3cl $p |- E. z A. y ( y e. z <-> E. x ( x e. A /\ ph ) ) $=
      ( nfcv zfrepclf ) ABCDEBEHFGI $.
  $}

  ${
    $d ph y z $.  $d ps z $.  $d x y z $.
    zfrep4.1 $e |- { x | ph } e. _V $.
    zfrep4.2 $e |- ( ph -> E. z A. y ( ps -> y = z ) ) $.
    $( A version of Replacement using class abstractions.  (Contributed by NM,
       26-Nov-1995.) $)
    zfrep4 $p |- { y | E. x ( ph /\ ps ) } e. _V $=
      ( cv cab wcel wa wex cvv abid anbi1i exbii abbii wceq wb wal nfab1 sylbi
      wi zfrepclf abeq2 mpbir issetri eqeltrri ) CHACIZJZBKZCLZDIZABKZCLZDIMULU
      ODUKUNCUJABACNZOPQEUMEHZUMRZELDHZUQJULSDTZELBCDEUIACUAFUJABUSUQRUCDTELUPG
      UBUDURUTEULDUQUEPUFUGUH $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Derive the Axiom of Separation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.  $d y z ph w $.
    $( Separation Scheme, which is an axiom scheme of Zermelo's original
       theory.  Scheme Sep of [BellMachover] p. 463.  As we show here, it is
       redundant if we assume Replacement in the form of ~ ax-rep .  Some
       textbooks present Separation as a separate axiom scheme in order to show
       that much of set theory can be derived without the stronger
       Replacement.  The Separation Scheme is a weak form of Frege's Axiom of
       Comprehension, conditioning it (with ` x e. z ` ) so that it asserts the
       existence of a collection only if it is smaller than some other
       collection ` z ` that already exists.  This prevents Russell's paradox
       ~ ru .  In some texts, this scheme is called "Aussonderung" or the
       Subset Axiom.

       The variable ` x ` can appear free in the wff ` ph ` , which in
       textbooks is often written ` ph ( x ) ` .  To specify this in the
       Metamath language, we _omit_ the distinct variable requirement ($d) that
       ` x ` not appear in ` ph ` .

       For a version using a class variable, see ~ zfauscl , which requires the
       Axiom of Extensionality as well as Separation for its derivation.

       If we omit the requirement that ` y ` not occur in ` ph ` , we can
       derive a contradiction, as ~ notzfaus shows (contradicting ~ zfauscl ).
       However, as ~ axsep2 shows, we can eliminate the restriction that ` z `
       not occur in ` ph ` .

       Note: the distinct variable restriction that ` z ` not occur in ` ph `
       is actually redundant in this particular proof, but we keep it since its
       purpose is to demonstrate the derivation of the exact ~ ax-sep from
       ~ ax-rep .

       This theorem should not be referenced by any proof.  Instead, use
       ~ ax-sep below so that the uses of the Axiom of Separation can be more
       easily identified.  (Contributed by NM, 11-Sep-2006.)
       (New usage is discouraged.) $)
    axsep $p |- E. y A. x ( x e. y <-> ( x e. z /\ ph ) ) $=
      ( vw wel weq wa wex wb wal wi nfv axrep5 equtr equcomi syl6 adantrd exbii
      alrimiv a1d spimev mpg an12 elequ1 anbi1d equsex bitr3i bibi2i albii mpbi
      ) BCFZEDFZEBGZAHZHZEIZJZBKZCIZULBDFZAHZJZBKZCIUMUOBCGZLZBKZCILUTEUOEBCDUO
      CMNUMVGCECEGZVGUMVHVFBVHUNVEAVHUNCBGVECEBOCBPQRTUAUBUCUSVDCURVCBUQVBULUQU
      NUMAHZHZEIVBVJUPEUNUMAUDSVIVBEBVBEMUNUMVAAEBDUEUFUGUHUIUJSUK $.

    $( The Axiom of Separation of ZF set theory.  See ~ axsep for more
       information.  It was derived as ~ axsep above and is therefore
       redundant, but we state it as a separate axiom here so that its uses can
       be identified more easily.  (Contributed by NM, 11-Sep-2006.) $)
    ax-sep $a |- E. y A. x ( x e. y <-> ( x e. z /\ ph ) ) $.
  $}

  ${
    $d x y z w $.  $d y ph w $.  $d z w $.
    $( A less restrictive version of the Separation Scheme ~ axsep , where
       variables ` x ` and ` z ` can both appear free in the wff ` ph ` , which
       can therefore be thought of as ` ph ( x , z ) ` .  This version was
       derived from the more restrictive ~ ax-sep with no additional set theory
       axioms.  (Contributed by NM, 10-Dec-2006.)  (Proof shortened by Mario
       Carneiro, 17-Nov-2016.) $)
    axsep2 $p |- E. y A. x ( x e. y <-> ( x e. z /\ ph ) ) $=
      ( vw wel wa wb wal wex cv eleq2 anbi1d anabs5 syl6bb bibi2d albidv exbidv
      weq ax-sep chvarv ) BCFZBEFZBDFZAGZGZHZBIZCJUBUEHZBIZCJEDEDSZUHUJCUKUGUIB
      UKUFUEUBUKUFUDUEGUEUKUCUDUEEKDKBKLMUDANOPQRUEBCETUA $.
  $}

  ${
    $d x y A z $.  $d y ph z $.
    zfauscl.1 $e |- A e. _V $.
    $( Separation Scheme (Aussonderung) using a class variable.  To derive this
       from ~ ax-sep , we invoke the Axiom of Extensionality (indirectly via
       ~ vtocl ), which is needed for the justification of class variable
       notation.

       If we omit the requirement that ` y ` not occur in ` ph ` , we can
       derive a contradiction, as ~ notzfaus shows.  (Contributed by NM,
       5-Aug-1993.) $)
    zfauscl $p |- E. y A. x ( x e. y <-> ( x e. A /\ ph ) ) $=
      ( vz cv wcel wa wb wal wex eleq2 anbi1d bibi2d albidv exbidv ax-sep vtocl
      wceq ) BGZCGHZUAFGZHZAIZJZBKZCLUBUADHZAIZJZBKZCLFDEUCDTZUGUKCULUFUJBULUEU
      IUBULUDUHAUCDUAMNOPQABCFRS $.
  $}

  ${
    $d x ph z $.  $d x y z $.
    bm1.3ii.1 $e |- E. x A. y ( ph -> y e. x ) $.
    $( Convert implication to equivalence using the Separation Scheme
       (Aussonderung) ~ ax-sep .  Similar to Theorem 1.3ii of [BellMachover]
       p. 463.  (Contributed by NM, 5-Aug-1993.) $)
    bm1.3ii $p |- E. x A. y ( y e. x <-> ph ) $=
      ( vz wel wi wal wa wex weq elequ2 imbi2d albidv cbvexv mpbi ax-sep pm3.2i
      wb exan 19.42v bimsc1 alanimi eximi sylbir exlimiv ax-mp ) ACEFZGZCHZCBFZ
      UHAISZCHZBJZIZEJUKASZCHZBJZUJUNEUJEJZUNAUKGZCHZBJUSDVAUJBEBEKZUTUICVBUKUH
      ABECLMNOPACBEQRTUOUREUOUJUMIZBJURUJUMBUAVCUQBUIULUPCAUHUKUBUCUDUEUFUG $.
  $}

  ${
    $d x y z $.
    $( Derive a weakened version of ~ ax-9 ( i.e. ~ ax9v ), where ` x ` and
       ` y ` must be distinct, from Separation ~ ax-sep and Extensionality
       ~ ax-ext .  See ~ ax9 for the derivation of ~ ax-9 from ~ ax9v .
       (Contributed by NM, 12-Nov-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ax9vsep $p |- -. A. x -. x = y $=
      ( vz cv wceq wex wn wal wcel wi wa wb ax-sep biantru bibi2i biimpri alimi
      id ax-ext syl eximi ax-mp df-ex mpbi ) ADZBDZEZAFZUGGAHGCDZUEIZUIUFIZUIUI
      EZULJZKZLZCHZAFUHUMCABMUPUGAUPUJUKLZCHUGUOUQCUQUOUKUNUJUMUKULRNOPQABCSTUA
      UBUGAUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Derive the Null Set Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    zfnuleu.1 $e |- E. x A. y -. y e. x $.
    $( Show the uniqueness of the empty set (using the Axiom of Extensionality
       via ~ bm1.1 to strengthen the hypothesis in the form of ~ axnul ).
       (Contributed by NM, 22-Dec-2007.) $)
    zfnuleu $p |- E! x A. y -. y e. x $=
      ( wel wn wal weu wfal wb wex nbfal albii exbii mpbi nfv bm1.1 ax-mp eubii
      mpbir ) BADZEZBFZAGTHIZBFZAGZUDAJZUEUBAJUFCUBUDAUAUCBTKLZMNHABHAOPQUBUDAU
      GRS $.
  $}

  ${
    $d x y z w $.
    $( Prove ~ axnul directly from ~ ax-rep using none of the equality axioms
       ~ ax-8 through ~ ax-15 provided we accept ~ sp as an axiom.  Replace
       ~ sp with the obsolete ~ ax-4 to see this in 'show trace_back'.
       (Contributed by Jeff Hoffman, 3-Feb-2008.)  (Proof shortened by Mario
       Carneiro, 17-Nov-2016.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    axnulALT $p |- E. x A. y -. y e. x $=
      ( vw vz cv wcel wn wal wex wfal wa wb wi ax-rep sp con2i df-ex sylibr mpg
      wceq fal mto pm2.21i intnan nex nbn albii exbii mpbir ) BEZAEZFZGZBHZAIUL
      CEDEFZJAHZKZCIZLZBHZAIZUPUJUKTZMZBHZAIZVACJDABCNVCVEBVDVDGZAHZGVEVGVDVFAO
      PVDAQRUPVBUPJUAJAOUBZUCSSUNUTAUMUSBURULUQCUPUOVHUDUEUFUGUHUI $.

    $( The Null Set Axiom of ZF set theory: there exists a set with no
       elements.  Axiom of Empty Set of [Enderton] p. 18.  In some textbooks,
       this is presented as a separate axiom; here we show it can be derived
       from Separation ~ ax-sep .  This version of the Null Set Axiom tells us
       that at least one empty set exists, but does not tell us that it is
       unique - we need the Axiom of Extensionality to do that (see
       ~ zfnuleu ).

       This proof, suggested by Jeff Hoffman, uses only ~ ax-5 and ~ ax-gen
       from predicate calculus, which are valid in "free logic" i.e. logic
       holding in an empty domain (see Axiom A5 and Rule R2 of [LeBlanc]
       p. 277).  Thus, our ~ ax-sep implies the existence of at least one set.
       Note that Kunen's version of ~ ax-sep (Axiom 3 of [Kunen] p. 11) does
       not imply the existence of a set because his is universally closed i.e.
       prefixed with universal quantifiers to eliminate all free variables.
       His existence is provided by a separate axiom stating ` E. x x = x `
       (Axiom 0 of [Kunen] p. 10).

       See ~ axnulALT for a proof directly from ~ ax-rep .

       This theorem should not be referenced by any proof.  Instead, use
       ~ ax-nul below so that the uses of the Null Set Axiom can be more easily
       identified.  (Contributed by Jeff Hoffman, 3-Feb-2008.)  (Revised by NM,
       4-Feb-2008.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    axnul $p |- E. x A. y -. y e. x $=
      ( vz cv wn wa wb wal wex ax-sep pm3.24 intnan id mtbiri alimi eximi ax-mp
      wcel ) BDZADRZSCDRZSSRZUBEFZFZGZBHZAITEZBHZAIUCBACJUFUHAUEUGBUETUDUCUAUBK
      LUEMNOPQ $.

    $( The Null Set Axiom of ZF set theory.  It was derived as ~ axnul above
       and is therefore redundant, but we state it as a separate axiom here so
       that its uses can be identified more easily.  (Contributed by NM,
       7-Aug-2003.) $)
    ax-nul $a |- E. x A. y -. y e. x $.

    $( The Null Set Axiom of ZF set theory: the empty set exists.  Corollary
       5.16 of [TakeutiZaring] p. 20.  For the unabbreviated version, see
       ~ ax-nul .  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
       Salmon, 9-Jul-2011.) $)
    0ex $p |- (/) e. _V $=
      ( vx vy c0 cv wceq wex wel wn wal ax-nul eq0 exbii mpbir issetri ) ACADZC
      EZAFBAGHBIZAFABJPQABOKLMN $.
  $}

  ${
    sseliALT.1 $e |- A C_ B $.
    $( Membership inference from subclass relationship.  This version of
       ~ sseli shows how we can derive it from the inference form ~ sselii
       using the weak deduction theorem.  (Contributed by NM, 24-Aug-2018.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sseliALT $p |- ( C e. A -> C e. B ) $=
      ( wcel csn cif wceq biidd eleq2 eleq1 wss sseq1 sseq2 ssid keephyp3v snid
      c0 0ex elimhyp3v sselii dedth3v ) CAEZCBEZUDCUCBRFZGZEUCCRGZUFEABCUEUERAU
      CAUEGZHUDIBUFCJCUGUFKUHUFUGUCUHBLUHUFLZUIUEUELUHUELUIABLABCUEUERAUHBMBUFU
      HNCUGHUIIUEUHUEMUEUFUHNRUGHUIIDUEOPUCCUHEZUJUGUHERUEERUHEZUKABCUEUERAUHCJ
      BUFHUJICUGUHKUEUHRJUEUFHUKIRUGUHKRSQTUAUB $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( The existence of proper substitution into a class.  (Contributed by NM,
       10-Nov-2005.)  (Revised by NM, 17-Aug-2018.) $)
    csbexg $p |- ( A. x B e. W -> [_ A / x ]_ B e. _V ) $=
      ( vy cvv wcel wal csb wa wsbc cab df-csb abid2 elex syl5eqel alimi adantr
      cv spsbc syl5 imp wb nfcv sbcabel mpbid wn csbprc 0ex syl6eqel pm2.61ian
      c0 ) BFGZCDGZAHZABCIZFGZUMUOJZUPESCGZABKELZFAEBCMURUSELZFGZABKZUTFGZUMUOV
      CUOVBAHUMVCUNVBAUNVACFECNCDOPQVBABFTUAUBUMVCVDUCUOUSAEBFFAFUDUERUFPUMUGZU
      QUOVEUPULFABCUHUIUJRUK $.
  $}

  ${
    csbex.1 $e |- B e. _V $.
    $( The existence of proper substitution into a class.  (Contributed by NM,
       7-Aug-2007.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.)  (Revised
       by NM, 17-Aug-2018.) $)
    csbex $p |- [_ A / x ]_ B e. _V $=
      ( cvv wcel csb csbexg mpg ) CEFABCGEFAABCEHDI $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( The existence of proper substitution into a class.  (Contributed by NM,
       10-Nov-2005.)  Use ~ csbexg instead of this.  Obsolete as of
       17-Aug-2018.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbexgOLD $p |- ( ( A e. V /\ A. x B e. W ) -> [_ A / x ]_ B e. _V ) $=
      ( vy wcel wal wa csb wsbc cab cvv df-csb abid2 elex syl5eqel alimi spsbc
      cv syl5 imp wb nfcv sbcabel adantr mpbid ) BDGZCEGZAHZIZABCJFTCGZABKFLZMA
      FBCNUKULFLZMGZABKZUMMGZUHUJUPUJUOAHUHUPUIUOAUIUNCMFCOCEPQRUOABDSUAUBUHUPU
      QUCUJULAFBMDAMUDUEUFUGQ $.
  $}

  ${
    csbexOLD.1 $e |- A e. _V $.
    csbexOLD.2 $e |- B e. _V $.
    $( The existence of proper substitution into a class.  (Contributed by NM,
       7-Aug-2007.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.)  Use
       ~ csbex instead of this.  Obsolete as of 17-Aug-2018.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbexOLD $p |- [_ A / x ]_ B e. _V $=
      ( cvv wcel csb wal csbexgOLD mpan mpg ) CFGZABCHFGZABFGMAINDABCFFJKEL $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Theorems requiring subset and intersection existence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( No set contains all sets.  Theorem 41 of [Suppes] p. 30.  (Contributed
       by NM, 23-Aug-1993.) $)
    nalset $p |- -. E. x A. y y e. x $=
      ( vz wel wn wex wal alexn wa wb ax-sep elequ1 elequ2 bitrd notbid anbi12d
      weq bibi12d spv pclem6 syl eximii mpgbi ) BADZEZBFUDBGAFEAUDABHCBDZCADZCC
      DZEZIZJZCGZUEBUICBAKULBBDZUDUMEZIZJZUEUKUPCBCBQZUFUMUJUOCBBLUQUGUDUIUNCBA
      LUQUHUMUQUHBCDUMCBCLCBBMNOPRSUMUDTUAUBUC $.
  $}

  ${
    $d x y $.
    $( The universal class is not a member of itself (and thus is not a set).
       Proposition 5.21 of [TakeutiZaring] p. 21; our proof, however, does not
       depend on the Axiom of Regularity.  (Contributed by NM, 23-Aug-1993.) $)
    vprc $p |- -. _V e. _V $=
      ( vx vy cvv wcel cv wceq wex wal nalset vex tbt albii dfcleq bitr4i exbii
      wb mtbi isset mtbir ) CCDAEZCFZAGZBEZTDZBHZAGUBABIUEUAAUEUDUCCDZPZBHUAUDU
      GBUFUDBJKLBTCMNOQACRS $.
  $}

  $( The universal class doesn't belong to any class.  (Contributed by FL,
     31-Dec-2006.) $)
  nvel $p |- -. _V e. A $=
    ( cvv wcel vprc elex mto ) BACBBCDBAEF $.

  $( The universal class does not exist.  (Contributed by NM, 4-Jul-2005.) $)
  vnex $p |- -. E. x x = _V $=
    ( cvv wcel cv wceq wex vprc isset mtbi ) BBCADBEAFGABHI $.

  ${
    $d A x y $.  $d B x y $.
    inex1.1 $e |- A e. _V $.
    $( Separation Scheme (Aussonderung) using class notation.  Compare Exercise
       4 of [TakeutiZaring] p. 22.  (Contributed by NM, 5-Aug-1993.) $)
    inex1 $p |- ( A i^i B ) e. _V $=
      ( vx vy cin cv wceq wex wcel wa wb zfauscl dfcleq elin bibi2i albii bitri
      wal exbii mpbir issetri ) DABFZDGZUCHZDIEGZUDJZUFAJUFBJZKZLZESZDIUHEDACMU
      EUKDUEUGUFUCJZLZESUKEUDUCNUMUJEULUIUGUFABOPQRTUAUB $.
  $}

  ${
    inex2.1 $e |- A e. _V $.
    $( Separation Scheme (Aussonderung) using class notation.  (Contributed by
       NM, 27-Apr-1994.) $)
    inex2 $p |- ( B i^i A ) e. _V $=
      ( cin cvv incom inex1 eqeltri ) BADABDEBAFABCGH $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Closed-form, generalized Separation Scheme.  (Contributed by NM,
       7-Apr-1995.) $)
    inex1g $p |- ( A e. V -> ( A i^i B ) e. _V ) $=
      ( vx cv cin cvv wcel wceq ineq1 eleq1d vex inex1 vtoclg ) DEZBFZGHABFZGHD
      ACOAIPQGOABJKOBDLMN $.
  $}

  ${
    ssex.1 $e |- B e. _V $.
    $( The subset of a set is also a set.  Exercise 3 of [TakeutiZaring]
       p. 22.  This is one way to express the Axiom of Separation ~ ax-sep
       (a.k.a.  Subset Axiom).  (Contributed by NM, 27-Apr-1994.) $)
    ssex $p |- ( A C_ B -> A e. _V ) $=
      ( wss cin wceq cvv wcel df-ss inex2 eleq1 mpbii sylbi ) ABDABEZAFZAGHZABI
      ONGHPBACJNAGKLM $.
  $}

  ${
    ssexi.1 $e |- B e. _V $.
    ssexi.2 $e |- A C_ B $.
    $( The subset of a set is also a set.  (Contributed by NM, 9-Sep-1993.) $)
    ssexi $p |- A e. _V $=
      ( wss cvv wcel ssex ax-mp ) ABEAFGDABCHI $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The subset of a set is also a set.  Exercise 3 of [TakeutiZaring] p. 22
       (generalized).  (Contributed by NM, 14-Aug-1994.) $)
    ssexg $p |- ( ( A C_ B /\ B e. C ) -> A e. _V ) $=
      ( vx wcel wss cvv cv wi wceq sseq2 imbi1d vex ssex vtoclg impcom ) BCEABF
      ZAGEZADHZFZRIQRIDBCSBJTQRSBAKLASDMNOP $.
  $}

  ${
    ssexd.1 $e |- ( ph -> B e. C ) $.
    ssexd.2 $e |- ( ph -> A C_ B ) $.
    $( A subclass of a set is a set.  Deduction form of ~ ssexg .  (Contributed
       by David Moews, 1-May-2017.) $)
    ssexd $p |- ( ph -> A e. _V ) $=
      ( wss wcel cvv ssexg syl2anc ) ABCGCDHBIHFEBCDJK $.
  $}

  $( Existence of a difference.  (Contributed by NM, 26-May-1998.) $)
  difexg $p |- ( A e. V -> ( A \ B ) e. _V ) $=
    ( cdif wss wcel cvv difss ssexg mpan ) ABDZAEACFKGFABHKACIJ $.

  ${
    $d x y A $.  $d y ph $.
    zfausab.1 $e |- A e. _V $.
    $( Separation Scheme (Aussonderung) in terms of a class abstraction.
       (Contributed by NM, 8-Jun-1994.) $)
    zfausab $p |- { x | ( x e. A /\ ph ) } e. _V $=
      ( cv wcel wa cab ssab2 ssexi ) BECFAGBHCDABCIJ $.
  $}

  ${
    $d x A $.
    $( Separation Scheme in terms of a restricted class abstraction.
       (Contributed by NM, 23-Oct-1999.) $)
    rabexg $p |- ( A e. V -> { x e. A | ph } e. _V ) $=
      ( crab wss wcel cvv ssrab2 ssexg mpan ) ABCEZCFCDGLHGABCILCDJK $.
  $}

  ${
    $d x A $.
    rabex.1 $e |- A e. _V $.
    $( Separation Scheme in terms of a restricted class abstraction.
       (Contributed by NM, 19-Jul-1996.) $)
    rabex $p |- { x e. A | ph } e. _V $=
      ( cvv wcel crab rabexg ax-mp ) CEFABCGEFDABCEHI $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    elssabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Membership in a class abstraction involving a subset.  Unlike ~ elabg ,
       ` A ` does not have to be a set.  (Contributed by NM, 29-Aug-2006.) $)
    elssabg $p |- ( B e. V ->
                  ( A e. { x | ( x C_ B /\ ph ) } <-> ( A C_ B /\ ps ) ) ) $=
      ( wcel wss wa cvv wi cv cab wb ssexg expcom adantrd wceq sseq1 elab3g syl
      anbi12d ) EFHZDEIZBJZDKHZLDCMZEIZAJZCNHUFOUDUEUGBUEUDUGDEFPQRUJUFCDKUHDSU
      IUEABUHDETGUCUAUB $.
  $}

  ${
    $d x A $.
    $( The intersection of a non-empty class exists.  Exercise 5 of
       [TakeutiZaring] p. 44 and its converse.  (Contributed by NM,
       13-Aug-2002.) $)
    intex $p |- ( A =/= (/) <-> |^| A e. _V ) $=
      ( vx c0 wne cint cvv wcel cv wex n0 wss intss1 vex ssex syl exlimiv sylbi
      wceq vprc inteq int0 syl6eq eleq1d mtbiri necon2ai impbii ) ACDZAEZFGZUGB
      HZAGZBIUIBAJUKUIBUKUHUJKUIUJALUHUJBMNOPQUIACACRZUIFFGSULUHFFULUHCEFACTUAU
      BUCUDUEUF $.
  $}

  $( If a class intersection is not a set, it must be the universe.
     (Contributed by NM, 3-Jul-2005.) $)
  intnex $p |- ( -. |^| A e. _V <-> |^| A = _V ) $=
    ( cint cvv wcel wn wceq intex necon1bbii inteq int0 syl6eq sylbi vprc eleq1
    c0 mtbiri impbii ) ABZCDZEZRCFZTAOFZUASAOAGHUBROBCAOIJKLUASCCDMRCCNPQ $.

  ${
    $d x y $.  $d ph y $.
    $( The intersection of a non-empty class abstraction exists.  (Contributed
       by NM, 21-Oct-2003.) $)
    intexab $p |- ( E. x ph <-> |^| { x | ph } e. _V ) $=
      ( wex cab c0 wne cint cvv wcel abn0 intex bitr3i ) ABCABDZEFMGHIABJMKL $.
  $}

  $( The intersection of a non-empty restricted class abstraction exists.
     (Contributed by NM, 21-Oct-2003.) $)
  intexrab $p |- ( E. x e. A ph <-> |^| { x e. A | ph } e. _V ) $=
    ( cv wcel wa wex cab cint cvv wrex crab intexab df-rex df-rab inteqi eleq1i
    3bitr4i ) BDCEAFZBGSBHZIZJEABCKABCLZIZJESBMABCNUCUAJUBTABCOPQR $.

  ${
    $d A x y $.  $d B y $.
    $( The existence of an indexed union. ` x ` is normally a free-variable
       parameter in ` B ` , which should be read ` B ( x ) ` .  (Contributed by
       FL, 19-Sep-2011.) $)
    iinexg $p |- ( ( A =/= (/) /\ A. x e. A B e. C )
    -> |^|_ x e. A B e. _V ) $=
      ( vy c0 wne wcel wral wa ciin cv wceq wrex cab cint cvv wex wi sylib abn0
      dfiin2g adantl elisset rgenw r19.2z mpan2 r19.35 imp rexcom4 sylibr intex
      eqeltrd ) BFGZCDHZABIZJZABCKZELCMZABNZEOZPZQUPURVBMUNAEBCDUBUCUQVAFGZVBQH
      UQUTERZVCUQUSERZABNZVDUNUPVFUNUOVESZABNZUPVFSUNVGABIVHVGABECDUDUEVGABUFUG
      UOVEABUHTUIUSAEBUJTUTEUAUKVAULTUM $.
  $}

  ${
    $d x y $.  $d x A $.  $d y ph $.  $d x ps $.  $d x ch $.
    intabs.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    intabs.2 $e |- ( x = |^| { y | ps } -> ( ph <-> ch ) ) $.
    intabs.3 $e |- ( |^| { y | ps } C_ A /\ ch ) $.
    $( Absorption of a redundant conjunct in the intersection of a class
       abstraction.  (Contributed by NM, 3-Jul-2005.) $)
    intabs $p |- |^| { x | ( x C_ A /\ ph ) } = |^| { x | ph } $=
      ( cv wss wa cab cint cvv wcel wceq sseq1 anbi12d intmin3 intnex ssv sseq2
      wn mpbiri sylbi pm2.61i cbvabv inteqi sseqtr4i simpr ss2abi intss ax-mp
      eqssi ) DJZFKZALZDMZNZADMZNZUTBEMZNZVBVDOPZUTVDKZURVDFKZCLDVDOUPVDQUQVGAC
      UPVDFRHSITVEUDVDOQZVFVCUAVHVFUTOKUTUBVDOUTUCUEUFUGVAVCABDEGUHUIUJUSVAKVBU
      TKURADUQAUKULUSVAUMUNUO $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( The intersection of a union ` U. A ` with a class ` B ` is equal to the
       union of the intersections of each element of ` A ` with ` B ` .
       (Contributed by FL, 24-Mar-2007.) $)
    inuni $p |- ( U. A i^i B ) = U. { x | E. y e. A x = ( y i^i B ) } $=
      ( vz cuni cin cv wceq wrex cab wcel wex eluni2 anbi1i elin r19.41v bitr4i
      wa bitri ancom exbii rexcom4 vex inex1 eleq2 ceqsexv rexbii 3bitr4i eqriv
      eluniab ) ECFZDGZAHZBHZDGZIZBCJZAKFZEHZUMLZUTUNLZURSZAMZUTUSLUTULLZUTDLZS
      UTUOLZBCJZVFSZVAVDVEVHVFBUTCNOUTULDPVDUQVBSZAMZBCJZVIVDVJBCJZAMVLVCVMAVCU
      RVBSVMVBURUAUQVBBCQRUBVJBACUCRVLVGVFSZBCJVIVKVNBCVKUTUPLZVNVBVOAUPUODBUDU
      EUNUPUTUFUGUTUODPTUHVGVFBCQTTUIURAUTUKRUJ $.
  $}

  $( Membership in a power class.  Theorem 86 of [Suppes] p. 47.  (Contributed
     by NM, 7-Aug-2000.) $)
  elpw2g $p |- ( B e. V -> ( A e. ~P B <-> A C_ B ) ) $=
    ( wcel cpw wss elpwi cvv ssexg elpwg biimparc syldan expcom impbid2 ) BCDZA
    BEDZABFZABGQOPQOAHDZPABCIRPQABHJKLMN $.

  ${
    elpw2.1 $e |- B e. _V $.
    $( Membership in a power class.  Theorem 86 of [Suppes] p. 47.
       (Contributed by NM, 11-Oct-2007.) $)
    elpw2 $p |- ( A e. ~P B <-> A C_ B ) $=
      ( cvv wcel cpw wss wb elpw2g ax-mp ) BDEABFEABGHCABDIJ $.
  $}


  ${
    $d A x y $.  $d V x y $.
    $( The power set of a set is never a subset.  (Contributed by Stefan
       O'Rear, 22-Feb-2015.) $)
    pwnss $p |- ( A e. V -> -. ~P A C_ A ) $=
      ( vx vy cpw cv wnel crab wcel wn wa wb eleq12 anidms notbid df-nel syl5bb
      wss wceq cbvrabv elrab2 pclem6 ax-mp ssel mtoi ssrab2 elpw2g mpbiri nsyl3
      ) AEZARZCFZULGZCAHZUJIZABIZUKUOUNAIZUNUNIZUQURJZKLUQJDFZUTIZJZUSDUNAUNUTU
      NSZVAURVCVAURLUTUNUTUNMNOUMVBCDAUMULULIZJULUTSZVBULULPVEVDVAVEVDVALULUTUL
      UTMNOQTUAURUQUBUCUJAUNUDUEUPUOUNARUMCAUFUNABUGUHUI $.
  $}

  $( No set equals its power set.  The sethood antecedent is necessary; compare
     ~ pwv .  (Contributed by NM, 17-Nov-2008.)  (Proof shortened by Mario
     Carneiro, 23-Dec-2016.) $)
  pwne $p |- ( A e. V -> ~P A =/= A ) $=
    ( wcel cpw wss wn wne pwnss eqimss necon3bi syl ) ABCADZAEZFLAGABHMLALAIJK
    $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Theorems requiring empty set existence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( Construct, from any class ` A ` , a set equal to it when the class
       exists and equal to the empty set when the class is proper.  This
       theorem shows that the constructed set always exists.  (Contributed by
       NM, 16-Oct-2003.) $)
    class2set $p |- { x e. A | A e. _V } e. _V $=
      ( wcel crab rabexg wn c0 wrex wceq cv simpl nrexdv rabn0 necon1bbii sylib
      cvv 0ex syl6eqel pm2.61i ) BPCZTABDZPCTABPETFZUAGPUBTABHZFUAGIUBTABUBAJBC
      KLUCUAGTABMNOQRS $.

    $( Equality theorem based on ~ class2set .  (Contributed by NM,
       13-Dec-2005.)  (Proof shortened by Raph Levien, 30-Jun-2006.) $)
    class2seteq $p |- ( A e. V -> { x e. A | A e. _V } = A ) $=
      ( wcel cvv crab wceq elex wral cv ax-1 ralrimiv rabid2 sylibr eqcomd syl
      ) BCDBEDZQABFZBGBCHQBRQQABIBRGQQABQAJBDKLQABMNOP $.
  $}

  $( Every power class contains the empty set.  (Contributed by NM,
     25-Oct-2007.) $)
  0elpw $p |- (/) e. ~P A $=
    ( c0 cpw wcel wss 0ss 0ex elpw mpbir ) BACDBAEAFBAGHI $.

  $( The empty set and its power set are not equal.  (Contributed by NM,
     23-Dec-1993.) $)
  0nep0 $p |- (/) =/= { (/) } $=
    ( c0 csn 0ex snnz necomi ) ABAACDE $.

  $( Something cannot be equal to both the null set and the power set of the
     null set.  (Contributed by NM, 30-Sep-2003.) $)
  0inp0 $p |- ( A = (/) -> -. A = { (/) } ) $=
    ( c0 wceq csn wne 0nep0 neeq1 mpbiri neneqd ) ABCZABDZJAKEBKEFABKGHI $.

  $( The removal of the empty set from a class does not affect its union.
     (Contributed by NM, 22-Mar-2004.) $)
  unidif0 $p |- U. ( A \ { (/) } ) = U. A $=
    ( c0 csn cdif cuni cun uniun undif1 uncom eqtr2i unieqi 0ex uneq2i 3eqtr4ri
    unisn un0 uneq1i 3eqtri ) ABCZDZEZBAEZFZUBBFUBUASAFZEZSEZUBFUCTSFZEUAUFFZUE
    UATSGUDUGUGASFUDASHASIJKUHUABFUAUFBUABLOZMUAPJNSAGUFBUBUIQRBUBIUBPR $.

  ${
    $d x y A $.  $d y B $.
    $( An indexed intersection of the empty set, with a non-empty index set, is
       empty.  (Contributed by NM, 20-Oct-2005.) $)
    iin0 $p |- ( A =/= (/) <-> |^|_ x e. A (/) = (/) ) $=
      ( c0 wne ciin wceq iinconst cvv wcel wn 0ex n0i ax-mp eqeq1i mtbir iineq1
      0iin eqeq1d mtbiri necon2ai impbii ) BCDABCEZCFZABCGUCBCBCFZUCACCEZCFZUFH
      CFZCHIUGJKHCLMUEHCACQNOUDUBUECABCCPRSTUA $.
  $}

  ${
    $d x A $.
    notzfaus.1 $e |- A = { (/) } $.
    notzfaus.2 $e |- ( ph <-> -. x e. y ) $.
    $( In the Separation Scheme ~ zfauscl , we require that ` y ` not occur in
       ` ph ` (which can be generalized to "not be free in").  Here we show
       special cases of ` A ` and ` ph ` that result in a contradiction by
       violating this requirement.  (Contributed by NM, 8-Feb-2006.) $)
    notzfaus $p |- -. E. y A. x ( x e. y <-> ( x e. A /\ ph ) ) $=
      ( cv wcel wa wb wal wn wex c0 wne csn 0ex snnz eqnetri mpbi n0 biimt iman
      wi anbi2i xchbinxr syl6bb xor3 sylibr eximii exnal nex ) BGZCGHZUMDHZAIZJ
      ZBKZCUQLZBMURLUOUSBDNOUOBMDNPNENQRSBDUATUOUNUPLZJUSUOUNUOUNUDZUTUOUNUBVAU
      OUNLZIUPUOUNUCAVBUOFUEUFUGUNUPUHUIUJUQBUKTUL $.
  $}

  $( The intersection of the universal class is empty.  (Contributed by NM,
     11-Sep-2008.) $)
  intv $p |- |^| _V = (/) $=
    ( c0 cvv wcel cint wceq 0ex int0el ax-mp ) ABCBDAEFBGH $.

  ${
    $d x y z A $.
    axpweq.1 $e |- A e. _V $.
    $( Two equivalent ways to express the Power Set Axiom.  Note that ~ ax-pow
       is not used by the proof.  (Contributed by NM, 22-Jun-2009.) $)
    axpweq $p |- ( ~P A e. _V
                <-> E. x A. y ( A. z ( z e. y -> z e. A ) -> y e. x ) ) $=
      ( cpw cvv wcel cv wex wel wi wal pwidg wceq pweq eleq2d spcegv wss bitri
      mpd elex exlimiv impbii vex elpw2 pwss dfss2 imbi1i albii exbii ) DFZGHZU
      LAIZFZHZAJZCBKCIDHLCMZBAKZLZBMZAJUMUQUMULULFZHZUQULGNUPVCAULGUNULOUOVBULU
      NULPQRUAUPUMAULUOUBUCUDUPVAAUPULUNSZVAULUNAUEUFVDBIZDSZUSLZBMVABDUNUGVGUT
      BVFURUSCVEDUHUIUJTTUKT $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Power Sets
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Introduce the Axiom of Power Sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w $.
    $( Axiom of Power Sets.  An axiom of Zermelo-Fraenkel set theory.  It
       states that a set ` y ` exists that includes the power set of a given
       set ` x ` i.e. contains every subset of ` x ` .  The variant ~ axpow2
       uses explicit subset notation.  A version using class notation is
       ~ pwex .  (Contributed by NM, 5-Aug-1993.) $)
    ax-pow $a |- E. y A. z ( A. w ( w e. z -> w e. x ) -> z e. y ) $.

    $( Axiom of Power Sets expressed with the fewest number of different
       variables.  (Contributed by NM, 14-Aug-2003.) $)
    zfpow $p |- E. x A. y ( A. x ( x e. y -> x e. z ) -> y e. x ) $=
      ( vw wel wal wex ax-pow weq elequ1 imbi12d cbvalv imbi1i albii exbii mpbi
      wi ) DBEZDCEZQZDFZBAEZQZBFZAGABEZACEZQZAFZUBQZBFZAGCABDHUDUJAUCUIBUAUHUBT
      UGDADAIRUESUFDABJDACJKLMNOP $.

    $( A variant of the Axiom of Power Sets ~ ax-pow using subset notation.
       Problem in {BellMachover] p. 466.  (Contributed by NM, 4-Jun-2006.) $)
    axpow2 $p |- E. y A. z ( z C_ x -> z e. y ) $=
      ( vw cv wss wel wi wal wex ax-pow dfss2 imbi1i albii exbii mpbir ) CEZAEZ
      FZCBGZHZCIZBJDCGDAGHDIZTHZCIZBJABCDKUBUEBUAUDCSUCTDQRLMNOP $.

    $( A variant of the Axiom of Power Sets ~ ax-pow .  For any set ` x ` ,
       there exists a set ` y ` whose members are exactly the subsets of ` x `
       i.e. the power set of ` x ` .  Axiom Pow of [BellMachover] p. 466.
       (Contributed by NM, 4-Jun-2006.) $)
    axpow3 $p |- E. y A. z ( z C_ x <-> z e. y ) $=
      ( cv wss wel wb wal wex axpow2 bm1.3ii bicom albii exbii mpbir ) CDADEZCB
      FZGZCHZBIQPGZCHZBIPBCABCJKSUABRTCPQLMNO $.
  $}

  ${
    $d w x y z $.
    $( Every set is an element of some other set.  See ~ elALT for a shorter
       proof using more axioms.  (Contributed by NM, 4-Jan-2002.)  (Proof
       shortened by Andrew Salmon, 25-Jul-2011.) $)
    el $p |- E. y x e. y $=
      ( vz wel wi wal zfpow weq ax-14 alrimiv ax-13 embantd spimv eximii ) BCDB
      ADEZBFZCBDZEZCFABDZBBCAGRSCACAHZPQSTOBCABIJCABKLMN $.
  $}

  ${
    $d A x y z $.
    zfpowcl.1 $e |- A e. _V $.
    $( Power set axiom expressed in class notation.  Axiom 4 of [TakeutiZaring]
       p. 17.  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew
       Salmon, 25-Jul-2011.) $)
    pwex $p |- ~P A e. _V $=
      ( vz vy vx cv cpw cvv wcel wceq pweq eleq1d wss cab df-pw wex wal bm1.3ii
      wb axpow2 abeq2 exbii mpbir issetri eqeltri vtocl ) CFZGZHIAGZHICABUGAJUH
      UIHUGAKLUHDFZUGMZDNZHDUGOEULEFZULJZEPUJUMIUKSDQZEPUKEDCEDTRUNUOEUKDUMUAUB
      UCUDUEUF $.
  $}

  ${
    $d x A $.
    $( Power set axiom expressed in class notation, with the sethood
       requirement as an antecedent.  Axiom 4 of [TakeutiZaring] p. 17.
       (Contributed by NM, 30-Oct-2003.) $)
    pwexg $p |- ( A e. V -> ~P A e. _V ) $=
      ( vx cv cpw cvv wcel wceq pweq eleq1d vex pwex vtoclg ) CDZEZFGAEZFGCABNA
      HOPFNAIJNCKLM $.

    $( Existence of a class of subsets.  (Contributed by NM, 15-Jul-2006.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    abssexg $p |- ( A e. V -> { x | ( x C_ A /\ ph ) } e. _V ) $=
      ( wcel cpw cvv cv wss wa pwexg df-pw eleq1i simpl ss2abi ssexg mpan sylbi
      cab syl ) CDECFZGEZBHCIZAJZBSZGEZCDKUBUCBSZGEZUFUAUGGBCLMUEUGIUHUFUDUCBUC
      ANOUEUGGPQRT $.
  $}

  ${
    $d x y A $.
    $( A singleton is a set.  Theorem 7.12 of [Quine] p. 51, but proved using
       only Extensionality, Power Set, and Separation.  Unlike the proof of
       ~ zfpair , Replacement is not needed.  (Contributed by NM, 7-Aug-1994.)
       (Proof shortened by Andrew Salmon, 25-Jul-2011.)  See also ~ snex .
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    snexALT $p |- { A } e. _V $=
      ( cpw cvv wcel csn wss snsspw ssexg mpan wn pwexg con3i wceq snprc biimpi
      c0 0ex syl6eqel syl pm2.61i ) ABZCDZAEZCDZUCUAFUBUDAGUCUACHIUBJACDZJZUDUE
      UBACKLUFUCPCUFUCPMANOQRST $.
  $}

  $( The power set of the empty set (the ordinal 1) is a set.  See also
     ~ p0exALT .  (Contributed by NM, 23-Dec-1993.) $)
  p0ex $p |- { (/) } e. _V $=
    ( c0 cpw csn cvv pw0 0ex pwex eqeltrri ) ABACDEAFGH $.

  $( The power set of the empty set (the ordinal 1) is a set.  Alternate proof
     which is longer and quite different from the proof of ~ p0ex if ~ snexALT
     is expanded.  (Contributed by NM, 23-Dec-1993.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  p0exALT $p |- { (/) } e. _V $=
    ( c0 snexALT ) AB $.

  $( The power set of the power set of the empty set (the ordinal 2) is a set.
     (Contributed by NM, 5-Aug-1993.) $)
  pp0ex $p |- { (/) , { (/) } } e. _V $=
    ( c0 csn cpw cpr cvv pwpw0 p0ex pwex eqeltrri ) ABZCAJDEFJGHI $.

  $( The ordinal number 3 is a set, proved without the Axiom of Union
     ~ ax-un .  (Contributed by NM, 2-May-2009.) $)
  ord3ex $p |- { (/) , { (/) } , { (/) , { (/) } } } e. _V $=
    ( c0 csn cpr ctp cun cvv df-tp cpw pwpr pp0ex pwex eqeltrri wss unss2 ax-mp
    snsspr2 ssexi eqeltri ) AABZASCZDTTBZEZFASTGUBTSBZTCZEZTHUEFASITJKLUAUDMUBU
    EMUCTPUAUDTNOQR $.

  ${
    $d w x y z $.
    $( At least two sets exist (or in terms of first-order logic, the universe
       of discourse has two or more objects).  Note that we may not substitute
       the same variable for both ` x ` and ` y ` (as indicated by the distinct
       variable requirement), for otherwise we would contradict ~ stdpc6 .

       This theorem is proved directly from set theory axioms (no set theory
       definitions) and does not use ~ ax-ext or ~ ax-sep .  See ~ dtruALT for
       a shorter proof using these axioms.

       The proof makes use of dummy variables ` z ` and ` w ` which do not
       appear in the final theorem.  They must be distinct from each other and
       from ` x ` and ` y ` .  In other words, if we were to substitute ` x `
       for ` z ` throughout the proof, the proof would fail.  (Contributed by
       NM, 7-Nov-2006.) $)
    dtru $p |- -. A. x x = y $=
      ( vw vz weq wn wex wal wel wa el ax-nul eximii eeanv mpbir2an ax-mp con3d
      sp ax-8 spimev ax-14 con3and 2eximi wi equequ2 notbid syl6bi a1d exlimivv
      com12 pm2.61i exnal mpbi ) ABEZFZAGZUNAHFCDEZFZDGCGZUPACIZADIZFZJZDGCGZUS
      VDUTCGVBDGACKVBAHVBDDALVBARMUTVBCDNOVCURCDUTUQVAUQUTVACDAUAUJUBUCPURUPCDD
      BEZURUPUDVEURCBEZFZUPVEUQVFDBCUEUFVGUOACACEUNVFACBSQTUGVEFZUPURVHUOADADEU
      NVEADBSQTUHUKUIPUNAULUM $.
  $}

  ${
    $d x y $.
    $( This theorem shows that axiom ~ ax-16 is redundant in the presence of
       theorem ~ dtru , which states simply that at least two things exist.
       This justifies the remark at
       ~ http://us.metamath.org/mpeuni/mmzfcnd.html#twoness (which links to
       this theorem).  (Proof modification is discouraged.)
       (New usage is discouraged.)  (Contributed by NM, 7-Nov-2006.) $)
    ax16b $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( weq wal wi dtru pm2.21i ) BCDBEAABEFBCGH $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( Existential uniqueness implies there is a value for which the wff
       argument is false.  (Contributed by NM, 24-Oct-2010.) $)
    eunex $p |- ( E! x ph -> E. x -. ph ) $=
      ( vy wex weq wi wal wa wn weu dtru alim mtoi exlimiv adantl nfv eu3 exnal
      3imtr4i ) ABDZABCEZFBGZCDZHABGZIZABJAIBDUCUETUBUECUBUDUABGBCKAUABLMNOABCA
      CPQABRS $.
  $}

  ${
    $d w x y z $.
    $( A set variable is not free from itself.  The proof relies on ~ dtru ,
       that is, it is not true in a one-element domain.  (Contributed by Mario
       Carneiro, 8-Oct-2016.) $)
    nfnid $p |- -. F/_ x x $=
      ( vy vz vw cv wnfc wel wal weq dtru ax-ext sps alimi mto wnf df-nfc sbnf2
      wb wsb elsb4 bibi12i 2albii bitri albii alrot3 3bitri mtbir ) AAEZFZBCGZB
      DGZRZBHZDHZCHZUOCDIZCHCDJUNUPCUMUPDCDBKLMNUIBAGZAOZBHULDHCHZBHUOABUHPURUS
      BURUQACSZUQADSZRZDHCHUSUQACDQVBULCDUTUJVAUKCABTDABTUAUBUCUDULBCDUEUFUG $.
  $}

  ${
    $d x z $.  $d y z $.
    $( The "distinctor" expression ` -. A. x x = y ` , stating that ` x ` and
       ` y ` are not the same variable, can be written in terms of ` F/ ` in
       the obvious way.  This theorem is not true in a one-element domain,
       because then ` F/_ x y ` and ` A. x x = y ` will both be true.
       (Contributed by Mario Carneiro, 8-Oct-2016.) $)
    nfcvb $p |- ( F/_ x y <-> -. A. x x = y ) $=
      ( cv wnfc weq wal wn nfnid eqidd drnfc1 mtbiri con2i nfcvf impbii ) ABCZD
      ZABEAFZGQPQPBODBHABOOQOIJKLABMN $.
  $}

  ${
    $d A x $.
    $( A class is a subclass of the power class of its union.  Exercise 6(b) of
       [Enderton] p. 38.  (Contributed by NM, 14-Oct-1996.) $)
    pwuni $p |- A C_ ~P U. A $=
      ( vx cuni cpw cv wcel wss elssuni vex elpw sylibr ssriv ) BAACZDZBEZAFOMG
      ONFOAHOMBIJKL $.
  $}

  ${
    $d x y $.
    $( A version of ~ dtru ("two things exist") with a shorter proof that uses
       more axioms but may be easier to understand.

       Assuming that ZF set theory is consistent, we cannot prove this theorem
       unless we specify that ` x ` and ` y ` be distinct.  Specifically,
       theorem ~ spcev requires that ` x ` must not occur in the subexpression
       ` -. y = { (/) } ` in step 4 nor in the subexpression ` -. y = (/) ` in
       step 9.  The proof verifier will require that ` x ` and ` y ` be in a
       distinct variable group to ensure this.  You can check this by deleting
       the $d statement in set.mm and rerunning the verifier, which will print
       a detailed explanation of the distinct variable violation.  (Contributed
       by NM, 15-Jul-1994.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dtruALT $p |- -. A. x x = y $=
      ( cv wceq wn wex wal c0 csn 0inp0 p0ex eqeq2 notbid spcev syl 0ex pm2.61i
      exnal eqcom albii xchbinx mpbi ) BCZACZDZEZAFZUDUCDZAGZEUCHDZUGUJUCHIZDZE
      ZUGUCJUFUMAUKKUDUKDUEULUDUKUCLMNOUFUJEAHPUDHDUEUJUDHUCLMNQUGUEAGUIUEARUEU
      HAUCUDSTUAUB $.
  $}

  ${
    $d x y $.
    dtrucor.1 $e |- x = y $.
    $( Corollary of ~ dtru .  This example illustrates the danger of blindly
       trusting the standard Deduction Theorem without accounting for free
       variables: the theorem form of this deduction is not valid, as shown by
       ~ dtrucor2 .  (Contributed by NM, 27-Jun-2002.) $)
    dtrucor $p |- x =/= y $=
      ( weq cv wne wal dtru pm2.21i mpg ) ABDZAEBEFZAKAGLABHICJ $.
  $}

  ${
    dtrucor2.1 $e |- ( x = y -> x =/= y ) $.
    $( The theorem form of the deduction ~ dtrucor leads to a contradiction, as
       mentioned in the "Wrong!" example at
       ~ http://us.metamath.org/mpeuni/mmdeduction.html#bad .  (Contributed by
       NM, 20-Oct-2007.) $)
    dtrucor2 $p |- ( ph /\ -. ph ) $=
      ( weq wex wn wa a9e wi cv necon2bi pm2.01 ax-mp nex pm2.24ii ) BCEZBFAAGH
      BCIQBQQGZJRQBKCKDLQMNOP $.
  $}


  ${
    $d x y $.
    $( Demonstration of a theorem (scheme) that requires (meta)variables ` x `
       and ` y ` to be distinct, but no others.  It bundles the theorem schemes
       ` E. x ( x = y -> x e. x ) ` and ` E. x ( x = y -> y e. x ) ` .  Compare
       ~ dvdemo2 .  ("Bundles" is a term introduced by Raph Levien.)
       (Contributed by NM, 1-Dec-2006.) $)
    dvdemo1 $p |- E. x ( x = y -> z e. x ) $=
      ( weq wn wel wi wex wal dtru exnal mpbir pm2.21 eximii ) ABDZEZOCAFZGAPAH
      OAIEABJOAKLOQMN $.
  $}

  ${
    $d x z $.
    $( Demonstration of a theorem (scheme) that requires (meta)variables ` x `
       and ` z ` to be distinct, but no others.  It bundles the theorem schemes
       ` E. x ( x = x -> z e. x ) ` and ` E. x ( x = y -> y e. x ) ` .  Compare
       ~ dvdemo1 .  (Contributed by NM, 1-Dec-2006.) $)
    dvdemo2 $p |- E. x ( x = y -> z e. x ) $=
      ( wel weq wi el ax-1 eximii ) CADZABEZJFACAGJKHI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Derive the Axiom of Pairing
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x z w v $.  $d y z w v $.
    $( The Axiom of Pairing of Zermelo-Fraenkel set theory.  Axiom 2 of
       [TakeutiZaring] p. 15.  In some textbooks this is stated as a separate
       axiom; here we show it is redundant since it can be derived from the
       other axioms.

       This theorem should not be referenced by any proof other than ~ axpr .
       Instead, use ~ zfpair2 below so that the uses of the Axiom of Pairing
       can be more easily identified.  (Contributed by NM, 18-Oct-1995.)
       (New usage is discouraged.) $)
    zfpair $p |- { x , y } e. _V $=
      ( vw vz vv cv cpr weq wo cab cvv dfpr2 c0 wceq wex isseti mpbiran equequ2
      wa 19.41v csn 19.43 prlem2 exbii 0ex p0ex orbi12i 3bitr3ri abbii eqeltrri
      pp0ex wi wal 0inp0 prlem1 alrimdv spimev orcom syl7bi jaoi zfrep4 eqeltri
      con2i ) AFZBFZGCAHZCBHZIZCJZKCVDVELVIDFZMNZVJMUAZNZIZVKVFSZVMVGSZIZSZDOZC
      JKVHVSCVQDOVODOZVPDOZIVSVHVOVPDUBVQVRDVKVFVMVGUCUDVTVFWAVGVTVKDOVFDMUEPVK
      VFDTQWAVMDOVGDVLUFPVMVGDTQUGUHUIVNVQDCEMVLGVNDJKDMVLLUKUJVKVQCEHZULZCUMZE
      OVMVKWDEAEAHZVKWCCWEVKVFVMVGWBEACRVJUNZUOUPUQVMWDEBEBHZVMWCCVQVPVOIWGVMWB
      VOVPURWGVMVGVKVFWBEBCRVKVMWFVCUOUSUPUQUTVAVBVB $.

    $( Unabbreviated version of the Axiom of Pairing of ZF set theory, derived
       as a theorem from the other axioms.

       This theorem should not be referenced by any proof.  Instead, use
       ~ ax-pr below so that the uses of the Axiom of Pairing can be more
       easily identified.  (Contributed by NM, 14-Nov-2006.)
       (New usage is discouraged.) $)
    axpr $p |- E. z A. w ( ( w = x \/ w = y ) -> w e. z ) $=
      ( cv cpr wceq wo wcel wi wal zfpair isseti wb dfcleq vex bibi2i bi2 sylbi
      elpr alimi eximii ) CEZAEZBEZFZGZDEZUDGUHUEGHZUHUCIZJZDKZCCUFABLMUGUJUHUF
      IZNZDKULDUCUFOUNUKDUNUJUINUKUMUIUJUHUDUEDPTQUJUIRSUASUB $.

    $( The Axiom of Pairing of ZF set theory.  It was derived as theorem ~ axpr
       above and is therefore redundant, but we state it as a separate axiom
       here so that its uses can be identified more easily.  (Contributed by
       NM, 14-Nov-2006.) $)
    ax-pr $a |- E. z A. w ( ( w = x \/ w = y ) -> w e. z ) $.

    $( Derive the abbreviated version of the Axiom of Pairing from ~ ax-pr .
       See ~ zfpair for its derivation from the other axioms.  (Contributed by
       NM, 14-Nov-2006.) $)
    zfpair2 $p |- { x , y } e. _V $=
      ( vz vw cv cpr wceq wex wcel wo wal ax-pr bm1.3ii dfcleq vex bibi2i albii
      wb elpr bitri exbii mpbir issetri ) CAEZBEZFZCEZUFGZCHDEZUGIZUIUDGUIUEGJZ
      RZDKZCHUKCDABCDLMUHUMCUHUJUIUFIZRZDKUMDUGUFNUOULDUNUKUJUIUDUEDOSPQTUAUBUC
      $.
  $}

  ${
    $d x A $.
    $( A singleton is a set.  Theorem 7.12 of [Quine] p. 51, proved using
       Extensionality, Separation, and Pairing.  See also ~ snexALT .
       (Contributed by NM, 7-Aug-1994.)  (Revised by Mario Carneiro,
       19-May-2013.)  (Proof modification is discouraged.) $)
    snex $p |- { A } e. _V $=
      ( vx cvv wcel csn cpr dfsn2 cv wceq preq12 anidms eleq1d zfpair2 syl5eqel
      vtoclg wn c0 snprc biimpi 0ex syl6eqel pm2.61i ) ACDZAEZCDUCUDAAFZCAGBHZU
      FFZCDUECDBACUFAIZUGUECUHUGUEIUFUFAAJKLBBMONUCPZUDQCUIUDQIARSTUAUB $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The Axiom of Pairing using class variables.  Theorem 7.13 of [Quine]
       p. 51.  By virtue of its definition, an unordered pair remains a set
       (even though no longer a pair) even when its components are proper
       classes (see ~ prprc ), so we can dispense with hypotheses requiring
       them to be sets.  (Contributed by NM, 5-Aug-1993.) $)
    prex $p |- { A , B } e. _V $=
      ( vx vy cvv wcel cpr wi wceq preq2 eleq1d zfpair2 vtoclg preq1 syl5ib csn
      cv wn snex syl6eqel vtocleg prprc1 prprc2 pm2.61nii ) AEFZBEFZABGZEFZUFUH
      HCAEUFCQZBGZEFZUIAIZUHUIDQZGZEFUKDBEUMBIUNUJEUMBUIJKCDLMULUJUGEUIABNKOUAU
      ERUGBPEABUBBSTUFRUGAPEABUCASTUD $.
  $}

  ${
    $d x y $.
    $( Every set is an element of some other set.  This has a shorter proof
       than ~ el but uses more axioms.  (Contributed by NM, 4-Jan-2002.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    elALT $p |- E. y x e. y $=
      ( cv csn wcel wex vex snid snex eleq2 spcev ax-mp ) ACZMDZEZMBCZEZBFMAGHQ
      OBNMIPNMJKL $.
  $}

  ${
    $d x y $.
    $( An alternative proof of ~ dtru ("two things exist") using ~ ax-pr
       instead of ~ ax-pow .  (Contributed by Mario Carneiro, 31-Aug-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dtruALT2 $p |- -. A. x x = y $=
      ( cv wceq wn wex wal c0 csn 0inp0 snex eqeq2 notbid spcev syl 0ex pm2.61i
      exnal eqcom albii xchbinx mpbi ) BCZACZDZEZAFZUDUCDZAGZEUCHDZUGUJUCHIZDZE
      ZUGUCJUFUMAUKHKUDUKDUEULUDUKUCLMNOUFUJEAHPUDHDUEUJUDHUCLMNQUGUEAGUIUEARUE
      UHAUCUDSTUAUB $.
  $}

  ${
    $( A singleton of a set belongs to the power class of a class containing
       the set.  (Contributed by Alan Sare, 25-Aug-2011.) $)
    snelpwi $p |- ( A e. B -> { A } e. ~P B ) $=
      ( wcel csn wss cpw snssi snex elpw sylibr ) ABCADZBEKBFCABGKBAHIJ $.
  $}

  ${
    snelpw.1 $e |- A e. _V $.
    $( A singleton of a set belongs to the power class of a class containing
       the set.  (Contributed by NM, 1-Apr-1998.) $)
    snelpw $p |- ( A e. B <-> { A } e. ~P B ) $=
      ( wcel csn wss cpw snss snex elpw bitr4i ) ABDAEZBFLBGDABCHLBAIJK $.
  $}

  $( A pair of two sets belongs to the power class of a class containing those
     two sets.  (Contributed by Thierry Arnoux, 10-Mar-2017.) $)
  prelpwi $p |- ( ( A e. C /\ B e. C ) -> { A , B } e. ~P C ) $=
    ( wcel wa cpr wss cpw prssi prex elpw sylibr ) ACDBCDEABFZCGMCHDABCIMCABJKL
    $.

  ${
    $d x y z $.
    $( A theorem similar to extensionality, requiring the existence of a
       singleton.  Exercise 8 of [TakeutiZaring] p. 16.  (Contributed by NM,
       10-Aug-1993.) $)
    rext $p |- ( A. z ( x e. z -> y e. z ) -> x = y ) $=
      ( cv wcel wi wal csn wceq vex snid snex eleq2 imbi12d spcv mpi elsn sylbi
      equcomi syl ) ADZCDZEZBDZUBEZFZCGZUDUAHZEZUAUDIZUGUAUHEZUIUAAJKUFUKUIFCUH
      UALUBUHIUCUKUEUIUBUHUAMUBUHUDMNOPUIUDUAIUJBUAQBASRT $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Classes are subclasses if and only if their power classes are
       subclasses.  Exercise 18 of [TakeutiZaring] p. 18.  (Contributed by NM,
       13-Oct-1996.) $)
    sspwb $p |- ( A C_ B <-> ~P A C_ ~P B ) $=
      ( vx wss cpw wcel sstr2 com12 vex elpw 3imtr4g ssrdv csn ssel snex bitr4i
      cv snss 3imtr3g impbii ) ABDZAEZBEZDZUACUBUCUACQZADZUEBDZUEUBFUEUCFUFUAUG
      UEABGHUEACIZJUEBUHJKLUDCABUDUEMZUBFZUIUCFZUEAFZUEBFZUBUCUINUJUIADULUIAUEO
      ZJUEAUHRPUKUIBDUMUIBUNJUEBUHRPSLT $.
  $}

  ${
    $d A x y $.
    $( A class equals the union of its power class.  Exercise 6(a) of
       [Enderton] p. 38.  (Contributed by NM, 14-Oct-1996.)  (Proof shortened
       by Alan Sare, 28-Dec-2008.) $)
    unipw $p |- U. ~P A = A $=
      ( vx vy cpw cuni cv wcel wex eluni elelpwi exlimiv sylbi csn snid snelpwi
      wa vex elunii sylancr impbii eqriv ) BADZEZABFZUCGZUDAGZUEUDCFZGUGUBGPZCH
      UFCUDUBIUHUFCUDUGAJKLUFUDUDMZGUIUBGUEUDBQNUDAOUDUIUBRSTUA $.
  $}

  $( Membership of a power class.  Exercise 10 of [Enderton] p. 26.
     (Contributed by NM, 13-Jan-2007.) $)
  pwel $p |- ( A e. B -> ~P A e. ~P ~P U. B ) $=
    ( wcel cpw cuni wss elssuni sspwb sylib cvv wb pwexg elpwg syl mpbird ) ABC
    ZADZBEZDZDCZQSFZPARFUAABGARHIPQJCTUAKABLQSJMNO $.

  $( A class is transitive iff its power class is transitive.  (Contributed by
     Alan Sare, 25-Aug-2011.)  (Revised by Mario Carneiro, 15-Jun-2014.) $)
  pwtr $p |- ( Tr A <-> Tr ~P A ) $=
    ( cpw cuni wss wtr unipw sseq1i df-tr dftr4 3bitr4ri ) ABZCZKDAKDKEAELAKAFG
    KHAIJ $.

  ${
    $d A x $.  $d B x $.
    $( An extensionality-like principle defining subclass in terms of subsets.
       (Contributed by NM, 30-Jun-2004.) $)
    ssextss $p |- ( A C_ B <-> A. x ( x C_ A -> x C_ B ) ) $=
      ( wss cpw cv wcel wi wal sspwb dfss2 vex elpw imbi12i albii 3bitri ) BCDB
      EZCEZDAFZQGZSRGZHZAISBDZSCDZHZAIBCJAQRKUBUEATUCUAUDSBALZMSCUFMNOP $.

    $( An extensionality-like principle that uses the subset instead of the
       membership relation: two classes are equal iff they have the same
       subsets.  (Contributed by NM, 30-Jun-2004.) $)
    ssext $p |- ( A = B <-> A. x ( x C_ A <-> x C_ B ) ) $=
      ( wss wa cv wi wal wceq wb ssextss anbi12i eqss albiim 3bitr4i ) BCDZCBDZ
      EAFZBDZRCDZGAHZTSGAHZEBCISTJAHPUAQUBABCKACBKLBCMSTANO $.

    $( Negation of subclass relationship.  Compare ~ nss .  (Contributed by NM,
       30-Jun-2004.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    nssss $p |- ( -. A C_ B <-> E. x ( x C_ A /\ -. x C_ B ) ) $=
      ( cv wss wn wa wex wi wal exanali ssextss xchbinxr bicomi ) ADZBEZOCEZFGA
      HZBCEZFRPQIAJSPQAKABCLMN $.
  $}

  $( Classes are equal if and only if their power classes are equal.  Exercise
     19 of [TakeutiZaring] p. 18.  (Contributed by NM, 13-Oct-1996.) $)
  pweqb $p |- ( A = B <-> ~P A = ~P B ) $=
    ( wss wa cpw wceq sspwb anbi12i eqss 3bitr4i ) ABCZBACZDAEZBEZCZNMCZDABFMNF
    KOLPABGBAGHABIMNIJ $.

  ${
    $d x A $.
    intid.1 $e |- A e. _V $.
    $( The intersection of all sets to which a set belongs is the singleton of
       that set.  (Contributed by NM, 5-Jun-2009.) $)
    intid $p |- |^| { x | A e. x } = { A } $=
      ( cv wcel cab cint csn cvv wss snex eleq2 intmin3 ax-mp wi elintab mpgbir
      snid id snssi eqssi ) BADZEZAFGZBHZUEIEUDUEJBKUCBUEEAUEIUBUEBLBCRMNBUDEZU
      EUDJUFUCUCOAUCABCPUCSQBUDTNUA $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( "At most one" existence implies a class abstraction exists.
       (Contributed by NM, 30-Dec-1996.) $)
    moabex $p |- ( E* x ph -> { x | ph } e. _V ) $=
      ( vy wmo weq wi wal wex cab cvv wcel nfv mo2 cv csn wss abss imbi2i albii
      elsn bitri snex ssex sylbir exlimiv sylbi ) ABDABCEZFZBGZCHABIZJKZABCACLM
      UIUKCUIUJCNZOZPZUKUNABNUMKZFZBGUIABUMQUPUHBUOUGABULTRSUAUJUMULUBUCUDUEUF
      $.
  $}

  $( Restricted "at most one" existence implies a restricted class abstraction
     exists.  (Contributed by NM, 17-Jun-2017.) $)
  rmorabex $p |- ( E* x e. A ph -> { x e. A | ph } e. _V ) $=
    ( cv wcel wa wmo cab cvv wrmo crab moabex df-rmo df-rab eleq1i 3imtr4i ) BD
    CEAFZBGQBHZIEABCJABCKZIEQBLABCMSRIABCNOP $.

  $( The abstraction of a wff with existential uniqueness exists.  (Contributed
     by NM, 25-Nov-1994.) $)
  euabex $p |- ( E! x ph -> { x | ph } e. _V ) $=
    ( weu wmo cab cvv wcel eumo moabex syl ) ABCABDABEFGABHABIJ $.

  ${
    $d x y A $.
    $( A non-empty class (even if proper) has a non-empty subset.  (Contributed
       by NM, 23-Aug-2003.) $)
    nnullss $p |- ( A =/= (/) -> E. x ( x C_ A /\ x =/= (/) ) ) $=
      ( vy c0 wne cv wcel wex wss wa n0 csn vex snss snnz snex wceq sseq1 neeq1
      sylbi anbi12d spcev mpan2 exlimiv ) BDECFZBGZCHAFZBIZUGDEZJZAHZCBKUFUKCUF
      UELZBIZUKUEBCMZNUMULDEZUKUEUNOUJUMUOJAULUEPUGULQUHUMUIUOUGULBRUGULDSUAUBU
      CTUDT $.
  $}

  ${
    $d x y z A $.  $d y z ph $.
    $( Restricted existence in a class (even if proper) implies restricted
       existence in a subset.  (Contributed by NM, 23-Aug-2003.) $)
    exss $p |- ( E. x e. A ph -> E. y ( y C_ A /\ E. x e. y ph ) ) $=
      ( vz wrex cv wcel wa cab wex wss crab c0 wne df-rab rabn0 sylbi wsb bitri
      neeq1i 3bitr3i csn vex snss ssab2 sstr2 mpi simpr wceq equsb1 sbbii mpbir
      n0 elsn jctil df-clab sban eleq2i 3imtr4i ne0i syl sylib snex sseq1 rexeq
      anbi12d spcev syl2anc exlimiv ) ABDFZEGZBGZDHZAIZBJZHZEKZCGZDLZABVSFZIZCK
      ZABDMZNOVPNOVKVRWDVPNABDPUAABDQEVPUNUBVQWCEVQVLUCZDLZABWEFZWCVQWEVPLZWFVL
      VPEUDUEWHVPDLWFABDUFWEVPDUGUHRVQABWEMZNOZWGVQVLWIHZWJVNBESZABESZIZVMWEHZB
      ESZWMIZVQWKWNWMWPWLWMUIWPVMVLUJZBESBEUKWOWRBEBVLUOULUMUPVQVOBESWNVOEBUQVN
      ABEURTWKVLWOAIZBJZHZWQWIWTVLABWEPUSXAWSBESWQWSEBUQWOABEURTTUTWIVLVAVBABWE
      QVCWBWFWGICWEVLVDVSWEUJVTWFWAWGVSWEDVEABVSWEVFVGVHVIVJR $.
  $}

  $( An ordered pair of classes is a set.  Exercise 7 of [TakeutiZaring]
     p. 16.  (Contributed by NM, 18-Aug-1993.)  (Revised by Mario Carneiro,
     26-Apr-2015.) $)
  opex $p |- <. A , B >. e. _V $=
    ( cop cvv wcel wa csn cpr c0 cif dfopif prex 0ex ifex eqeltri ) ABCADEBDEFZ
    AGZABHZHZIJDABKPSIQRLMNO $.

  $( An ordered triple of classes is a set.  (Contributed by NM,
     3-Apr-2015.) $)
  otex $p |- <. A , B , C >. e. _V $=
    ( cotp cop cvv df-ot opex eqeltri ) ABCDABEZCEFABCGJCHI $.

  ${
    elop.1 $e |- A e. _V $.
    elop.2 $e |- B e. _V $.
    elop.3 $e |- C e. _V $.
    $( An ordered pair has two elements.  Exercise 3 of [TakeutiZaring] p. 15.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    elop $p |- ( A e. <. B , C >. <-> ( A = { B } \/ A = { B , C } ) ) $=
      ( cop wcel csn cpr wceq wo dfop eleq2i elpr bitri ) ABCGZHABIZBCJZJZHARKA
      SKLQTABCEFMNARSDOP $.
  $}

  ${
    opi1.1 $e |- A e. _V $.
    opi1.2 $e |- B e. _V $.
    $( One of the two elements in an ordered pair.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    opi1 $p |- { A } e. <. A , B >. $=
      ( csn cpr cop snex prid1 dfop eleqtrri ) AEZLABFZFABGLMAHIABCDJK $.

    $( One of the two elements of an ordered pair.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    opi2 $p |- { A , B } e. <. A , B >. $=
      ( cpr csn cop prex prid2 dfop eleqtrri ) ABEZAFZLEABGMLABHIABCDJK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Ordered pair theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( An ordered pair is nonempty iff the arguments are sets.  (Contributed by
       NM, 24-Jan-2004.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    opnz $p |- ( <. A , B >. =/= (/) <-> ( A e. _V /\ B e. _V ) ) $=
      ( cop c0 wne cvv wcel wa opprc necon1ai csn cpr dfopg snex eqnetrd impbii
      prnz a1i ) ABCZDEAFGBFGHZTSDABIJTSAKZABLZLZDABFFMUCDETUAUBANQROP $.
  $}

  ${
    opth1.1 $e |- A e. _V $.
    opth1.2 $e |- B e. _V $.
    $( An ordered pair is nonempty if the arguments are sets.  (Contributed by
       Mario Carneiro, 26-Apr-2015.) $)
    opnzi $p |- <. A , B >. =/= (/) $=
      ( cop c0 wne cvv wcel opnz mpbir2an ) ABEFGAHIBHICDABJK $.

    $( Equality of the first members of equal ordered pairs.  (Contributed by
       NM, 28-May-2008.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    opth1 $p |- ( <. A , B >. = <. C , D >. -> A = C ) $=
      ( cop wceq csn cpr wi sneqr a1i wcel cvv wa opi1 id syl5eleq syl oprcl wo
      simpld prid1g eleq2 syl5ibrcom elsni eqcomd syl6 dfopg 3syl eleqtrd elpri
      mpjaod ) ABGZCDGZHZAIZCIZHZACHZURCDJZHZUTVAKUQACELMUQVCCURNZVAUQVDVCCVBNZ
      UQCONZVEUQVFDONZUQURUPNZVFVGPZUQURUOUPABEFQUQRSZCDURUAZTUCCDOUDTURVBCUEUF
      VDCACAUGUHUIUQURUSVBJZNUTVCUBUQURUPVLVJUQVHVIUPVLHVJVKCDOOUJUKULURUSVBUMT
      UN $.

    $d x B $.  $d x C $.  $d x D $.
    $( The ordered pair theorem.  If two ordered pairs are equal, their first
       elements are equal and their second elements are equal.  Exercise 6 of
       [TakeutiZaring] p. 16.  Note that ` C ` and ` D ` are not required to be
       sets due our specific ordered pair definition.  (Contributed by NM,
       28-May-1995.) $)
    opth $p |- ( <. A , B >. = <. C , D >. <-> ( A = C /\ B = D ) ) $=
      ( vx cop wceq wa cvv wcel cpr csn syl eqtr3d dfopg prex preqr2 wi opi1 id
      opth1 syl5eleq oprcl simprd opeq1d simpld sylancl cv preq2 eqeq2d imbi12d
      eqeq2 vex vtoclg sylc jca opeq12 impbii ) ABHZCDHZIZACIZBDIZJVCVDVEABCDEF
      UCZVCDKLZCBMZCDMZIZVEVCCKLZVGVCANZVBLVKVGJZVCVLVAVBABEFUAVCUBZUDCDVLUEOZU
      FVCCNZVHMZVPVIMZIVJVCVBVQVRVCCBHZVBVQVCVAVSVBVCACBVFUGVNPVCVKBKLVSVQIVCVK
      VGVOUHFCBKKQUIPVCVMVBVRIVOCDKKQOPVHVIVPCBRCDRSOVHCGUJZMZIZBVTIZTVJVETGDKV
      TDIZWBVJWCVEWDWAVIVHVTDCUKULVTDBUNUMBVTCFGUOSUPUQURABCDUSUT $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.
    $( Ordered pair theorem. ` C ` and ` D ` are not required to be sets under
       our specific ordered pair definition.  (Contributed by NM,
       14-Oct-2005.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    opthg $p |- ( ( A e. V /\ B e. W ) ->
                 ( <. A , B >. = <. C , D >. <-> ( A = C /\ B = D ) ) ) $=
      ( vx vy cv cop wceq wa wb opeq1 eqeq1d eqeq1 anbi1d bibi12d opeq2 vex
      anbi2d opth vtocl2g ) GIZHIZJZCDJZKZUDCKZUEDKZLZMAUEJZUGKZACKZUJLZMABJZUG
      KZUNBDKZLZMGHABEFUDAKZUHUMUKUOUTUFULUGUDAUENOUTUIUNUJUDACPQRUEBKZUMUQUOUS
      VAULUPUGUEBASOVAUJURUNUEBDPUARUDUECDGTHTUBUC $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x y X $.
    $( Ordered pair theorem.  (Contributed by NM, 14-Oct-2005.)  (Revised by
       Mario Carneiro, 26-Apr-2015.) $)
    opthg2 $p |- ( ( C e. V /\ D e. W ) ->
                 ( <. A , B >. = <. C , D >. <-> ( A = C /\ B = D ) ) ) $=
      ( wcel wa cop wceq opthg eqcom anbi12i 3bitr4g ) CEGDFGHCDIZABIZJCAJZDBJZ
      HPOJACJZBDJZHCDABEFKPOLSQTRACLBDLMN $.
  $}

  ${
    opth2.1 $e |- C e. _V $.
    opth2.2 $e |- D e. _V $.
    $( Ordered pair theorem.  (Contributed by NM, 21-Sep-2014.) $)
    opth2 $p |- ( <. A , B >. = <. C , D >. <-> ( A = C /\ B = D ) ) $=
      ( cvv wcel cop wceq wa wb opthg2 mp2an ) CGHDGHABICDIJACJBDJKLEFABCDGGMN
      $.
  $}

  ${
    otth.1 $e |- A e. _V $.
    otth.2 $e |- B e. _V $.
    otth.3 $e |- R e. _V $.
    $( Ordered triple theorem, with triple express with ordered pairs.
       (Contributed by NM, 1-May-1995.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    otth2 $p |- ( <. <. A , B >. , R >. = <. <. C , D >. , S >. <->
                ( A = C /\ B = D /\ R = S ) ) $=
      ( cop wceq wa w3a opth anbi1i opex df-3an 3bitr4i ) ABJZCDJZKZEFKZLACKZBD
      KZLZUBLSEJTFJKUCUDUBMUAUEUBABCDGHNOSETFABPINUCUDUBQR $.

    $( Ordered triple theorem.  (Contributed by NM, 25-Sep-2014.)  (Revised by
       Mario Carneiro, 26-Apr-2015.) $)
    otth $p |- ( <. A , B , R >. = <. C , D , S >. <->
      ( A = C /\ B = D /\ R = S ) ) $=
      ( cotp wceq cop w3a df-ot eqeq12i otth2 bitri ) ABEJZCDFJZKABLELZCDLFLZKA
      CKBDKEFKMRTSUAABENCDFNOABCDEFGHIPQ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    eqvinop.1 $e |- B e. _V $.
    eqvinop.2 $e |- C e. _V $.
    $( A variable introduction law for ordered pairs.  Analog of Lemma 15 of
       [Monk2] p. 109.  (Contributed by NM, 28-May-1995.) $)
    eqvinop $p |- ( A = <. B , C >. <-> E. x E. y ( A = <. x , y >. /\
                  <. x , y >. = <. B , C >. ) ) $=
      ( cv cop wceq wa wex opth2 anbi2i ancom anass 3bitri exbii eqeq2d ceqsexv
      19.42v opeq2 opeq1 bitr2i ) CAHZBHZIZJZUGDEIZJZKZBLZALUEDJZCUEEIZJZKZALCU
      IJZULUPAULUMUFEJZUHKZKZBLUMUSBLZKUPUKUTBUKUHUMURKZKVBUHKUTUJVBUHUEUFDEFGM
      NUHVBOUMURUHPQRUMUSBUAVAUOUMUHUOBEGURUGUNCUFEUEUBSTNQRUOUQADFUMUNUICUEDEU
      CSTUD $.
  $}

  ${
    $d x z w A $.  $d y z w A $.  $d z w ph $.
    $( Substitution of class ` A ` for ordered pair ` <. x , y >. ` .
       (Contributed by NM, 27-Dec-1996.)  (Revised by Andrew Salmon,
       11-Jul-2011.) $)
    copsexg $p |- ( A = <. x , y >. ->
                  ( ph <-> E. x E. y ( A = <. x , y >. /\ ph ) ) ) $=
      ( vz vw cv cop wceq wa wex wb wi vex 19.8a weq syl5bi syl5 weu euequ1 wal
      eqvinop 19.23bi opth anbi1i 2exbii nfe1 nfae anass a1i anim2d eximd biidd
      ex drex1 sylibd wn exbii 19.40 nfnae dveeq2 nfd 19.9d anim1d syl6 pm2.61i
      exlimi equcom eubii eupick com12 sylan9 sylbi impbid eqeq1 anbi1d 2exbidv
      mpbi mpan bibi2d imbi12d mpbiri adantr exlimivv pm2.43i ) DBGZCGZHZIZAWIA
      JZCKBKZLZWIDEGZFGZHZIZWOWHIZJZFKEKWIWLMZEFDWFWGBNCNUBWRWSEFWPWSWQWPWSWQAW
      QAJZCKZBKZLZMWQAXBWQAXBWTXBCXABOUCUNWQEBPZFCPZJZXBAMWMWNWFWGENFNUDZXBXFAJ
      ZCKZBKZXFAWTXHBCWQXFAXGUEUFXJXDXEAJZCKZJZBKZXFAXIXNBXMBUGCBPCUAZXIXNMXOXI
      XMCKXNXOXHXMCCBCUHXHXDXKJZXOXMXDXEAUIZXOXKXLXDXKXLMXOXKCOUJUKQULXMXMCBXOX
      MUMUOUPXOUQZXIXMXNXIXPCKZXRXMXHXPCXQURXSXDCKZXLJXRXMXDXKCUSXRXTXDXLXDXRCX
      RXDCCBCUTCBEVAVBVCVDRQXMBOVEVFVGXDXNXLXEAXNXDXLXDBSZXNXDXLMBEPZBSYABETYBX
      DBBEVHVIVRXDXLBVJVSVKXLXEAXECSZXLXEAMCFPZCSYCCFTYDXECCFVHVIVRXEACVJVSVKVL
      RQVMVNWPWIWQWLXCDWOWHVOZWPWKXBAWPWJWTBCWPWIWQAYEVPVQVTWAWBWCWDVMWE $.
  $}

  ${
    $d x y ps $.  $d x y A $.  $d x y B $.
    $( Closed theorem form of ~ copsex2g .  (Contributed by NM,
       17-Feb-2013.) $)
    copsex2t $p |- ( ( A. x A. y ( ( x = A /\ y = B ) -> ( ph <-> ps ) )
      /\ ( A e. V /\ B e. W ) ) ->
                  ( E. x E. y ( <. A , B >. = <. x , y >. /\ ph ) <-> ps ) ) $=
      ( wcel wa cv wceq wb wal wex cop elisset nfe1 nfv nfbi anim12i eeanv nfa1
      wi sylibr nfa2 nfex opeq12 copsexg eqcoms syl adantl sp 19.21bi bitr3d ex
      imp exlimd sylan2 ) EGIZFHIZJZCKZELZDKZFLZJZABMZUDZDNZCNZVGDOZCOZEFPZVCVE
      PZLAJZDOZCOZBMZVBVDCOZVFDOZJVMUTVTVAWACEGQDFHQUAVDVFCDUBUEVKVMVSVKVLVSCVJ
      CUCVRBCVQCRBCSTVKVGVSDVIDCUFVRBDVQDCVPDRUGBDSTVKVGVSVKVGJAVRBVGAVRMZVKVGV
      OVNLWBVCVEEFUHWBVNVOACDVNUIUJUKULVKVGVHVKVIDVJCUMUNUQUOUPURURUQUS $.
  $}

  ${
    $d x y ps $.  $d x y A $.  $d x y B $.
    copsex2g.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for ordered pairs.  (Contributed by NM,
       28-May-1995.) $)
    copsex2g $p |- ( ( A e. V /\ B e. W ) ->
                  ( E. x E. y ( <. A , B >. = <. x , y >. /\ ph ) <-> ps ) ) $=
      ( wcel cv wceq wex cop wa wb elisset nfe1 nfv nfbi eeanv nfex copsexg syl
      opeq12 eqcoms bitr3d exlimi sylbir syl2an ) EGJCKZELZCMZDKZFLZDMZEFNZUKUN
      NZLAOZDMZCMZBPZFHJCEGQDFHQUMUPOULUOOZDMZCMVBULUOCDUAVDVBCVABCUTCRBCSTVCVB
      DVABDUTDCUSDRUBBDSTVCAVABVCURUQLAVAPZUKUNEFUEVEUQURACDUQUCUFUDIUGUHUHUIUJ
      $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x y z w ps $.  $d x y z w R $.  $d x y z w S $.
    copsex4g.1 $e |- ( ( ( x = A /\ y = B ) /\ ( z = C /\ w = D ) ) ->
                     ( ph <-> ps ) ) $.
    $( An implicit substitution inference for 2 ordered pairs.  (Contributed by
       NM, 5-Aug-1995.) $)
    copsex4g $p |- ( ( ( A e. R /\ B e. S ) /\ ( C e. R /\ D e. S ) ) ->
                      ( E. x E. y E. z E. w ( ( <. A , B >. = <. x , y >. /\
                      <. C , D >. = <. z , w >. ) /\ ph ) <-> ps ) ) $=
      ( wcel wa cop cv wceq wex vex eqcom opth bitri anbi12i anbi1i a1i 4exbidv
      wb id cgsex4g bitrd ) GKNHLNOIKNJLNOOZGHPZCQZDQZPZRZIJPZEQZFQZPZRZOZAOZFS
      ESDSCSUNGRUOHROZUSIRUTJROZOZAOZFSESDSCSBULVDVHCDEFVDVHUHULVCVGAUQVEVBVFUQ
      UPUMRVEUMUPUAUNUOGHCTDTUBUCVBVAURRVFURVAUAUSUTIJETFTUBUCUDUEUFUGABVGCDEFG
      HIJKLVGUIMUJUK $.
  $}

  $( A property of ordered pairs.  (Contributed by Mario Carneiro,
     26-Apr-2015.) $)
  0nelop $p |- -. (/) e. <. A , B >. $=
    ( c0 cop wcel csn cpr wo id cvv wa oprcl dfopg syl eleqtrd elpri wne necomd
    wceq wn simpld snnzg prnzg jca neanior sylib pm2.65i ) CABDZEZCAFZSCABGZSHZ
    UICUJUKGZEULUICUHUMUIIUIAJEZBJEZKUHUMSABCLZABJJMNOCUJUKPNUICUJQZCUKQZKULTUI
    UQURUIUJCUIUNUJCQUIUNUOUPUAZAJUBNRUIUKCUIUNUKCQUSABJUCNRUDCUJCUKUEUFUG $.

  $( Equivalence of existence implied by equality of ordered pairs.
     (Contributed by NM, 28-May-2008.) $)
  opeqex $p |- ( <. A , B >. = <. C , D >. ->
    ( ( A e. _V /\ B e. _V ) <-> ( C e. _V /\ D e. _V ) ) ) $=
    ( cop wceq c0 wne cvv wcel wa neeq1 opnz 3bitr3g ) ABEZCDEZFOGHPGHAIJBIJKCI
    JDIJKOPGLABMCDMN $.

  $( Equivalence of existence implied by equality of ordered triples.
     (Contributed by NM, 26-Apr-2015.) $)
  oteqex2 $p |- ( <. <. A , B >. , C >. = <. <. R , S >. , T >. ->
    ( C e. _V <-> T e. _V ) ) $=
    ( cop wceq cvv wcel wa opeqex opex biantrur 3bitr4g ) ABGZCGDEGZFGHPIJZCIJZ
    KQIJZFIJZKSUAPCQFLRSABMNTUADEMNO $.

  $( Equivalence of existence implied by equality of ordered triples.
     (Contributed by NM, 28-May-2008.)  (Revised by Mario Carneiro,
     26-Apr-2015.) $)
  oteqex $p |- ( <. <. A , B >. , C >. = <. <. R , S >. , T >. ->
    ( ( A e. _V /\ B e. _V /\ C e. _V ) <->
      ( R e. _V /\ S e. _V /\ T e. _V ) ) ) $=
    ( cop wceq cvv wcel w3a wi simp3 a1i oteqex2 syl5ibr wb wa opex df-3an mpan
    opthg simprbda opeqex syl adantl anbi12d 3bitr4g expcom pm5.21ndd ) ABGZCGD
    EGZFGHZCIJZAIJZBIJZUNKZDIJZEIJZFIJZKZUQUNLUMUOUPUNMNVAUNUMUTURUSUTMABCDEFOZ
    PUNUMUQVAQUNUMRZUOUPRZUNRURUSRZUTRUQVAVCVDVEUNUTVCUKULHZVDVEQUNUMVFCFHZUKIJ
    UNUMVFVGRQABSUKCULFIIUBUAUCABDEUDUEUMUNUTQUNVBUFUGUOUPUNTURUSUTTUHUIUJ $.

  ${
    opcom.1 $e |- A e. _V $.
    opcom.2 $e |- B e. _V $.
    $( An ordered pair commutes iff its members are equal.  (Contributed by NM,
       28-May-2009.) $)
    opcom $p |- ( <. A , B >. = <. B , A >. <-> A = B ) $=
      ( cop wceq wa opth eqcom anbi2i anidm 3bitri ) ABEBAEFABFZBAFZGMMGMABBACD
      HNMMBAIJMKL $.
  $}

  ${
    $d x y z A $.  $d y z B $.
    moop2.1 $e |- B e. _V $.
    $( "At most one" property of an ordered pair.  (Contributed by NM,
       11-Apr-2004.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    moop2 $p |- E* x A = <. B , x >. $=
      ( vy cv cop wceq wmo csb wa wal eqtr2 vex opth simprbi syl gen2 nfcsb1v
      wi nfcv nfop nfeq2 csbeq1a id opeq12d eqeq2d mo4f mpbir ) BCAFZGZHZAIULBA
      EFZCJZUMGZHZKZUJUMHZTZELALUSAEUQUKUOHZURBUKUOMUTCUNHURCUJUNUMDANOPQRULUPA
      EABUOAUNUMAUMCSAUMUAUBUCURUKUOBURCUNUJUMAUMCUDURUEUFUGUHUI $.
  $}

  ${
    opeqsn.1 $e |- A e. _V $.
    opeqsn.2 $e |- B e. _V $.
    opeqsn.3 $e |- C e. _V $.
    $( Equivalence for an ordered pair equal to a singleton.  (Contributed by
       NM, 3-Jun-2008.) $)
    opeqsn $p |- ( <. A , B >. = { C } <-> ( A = B /\ C = { A } ) ) $=
      ( cop csn wceq cpr dfop eqeq1i snex prex preqsn eqcom anbi2i bitri 3bitri
      wa anidm anbi1i dfsn2 preq2 syl5req eqeq1d syl6bb pm5.32i ) ABGZCHZIAHZAB
      JZJZUJIUKULIZULCIZTZABIZCUKIZTZUIUMUJABDEKLUKULCAMABNFOUPUQUOTUSUNUQUOUNU
      LUKIUQBAIZTZUQUKULPABADEDOVAUQUQTUQUTUQUQBAPQUQUARSUBUQUOURUQUOUKCIURUQUL
      UKCUQUKAAJULAUCABAUDUEUFUKCPUGUHRS $.
  $}

  ${
    opeqpr.1 $e |- A e. _V $.
    opeqpr.2 $e |- B e. _V $.
    opeqpr.3 $e |- C e. _V $.
    opeqpr.4 $e |- D e. _V $.
    $( Equivalence for an ordered pair equal to an unordered pair.
       (Contributed by NM, 3-Jun-2008.) $)
    opeqpr $p |- ( <. A , B >. = { C , D }
  <-> ( ( C = { A } /\ D = { A , B } ) \/ ( C = { A , B } /\ D = { A } ) ) ) $=
      ( cop cpr wceq csn wa wo eqcom dfop eqeq2i snex prex preq12b 3bitri ) ABI
      ZCDJZKUCUBKUCALZABJZJZKCUDKDUEKMCUEKDUDKMNUBUCOUBUFUCABEFPQCDUDUEGHARABST
      UA $.
  $}

  ${
    $d x y z A $.
    $( "At most one" remains true inside ordered pair quantification.
       (Contributed by NM, 28-Aug-2007.) $)
    mosubopt $p |- ( A. y A. z E* x ph ->
                 E* x E. y E. z ( A = <. y , z >. /\ ph ) ) $=
      ( wmo wal cv cop wceq wex wa nfa1 nfe1 nfmo wi nfex sps exlimd wn copsexg
      mobidv biimpcd simpl 2eximi exlimiv con3i exmo ori syl pm2.61d1 ) ABFZDGZ
      CGZECHDHIJZDKZCKZUOALZDKZCKZBFZUNUPVACUMCMUTCBUSCNOUMUPVAPCUMUOVADULDMUTD
      BUSDCURDNQOULUOVAPDUOULVAUOAUTBACDEUAUBUCRSRSUQTUTBKZTVAVBUQUTUQBURUOCDUO
      AUDUEUFUGVBVAUTBUHUIUJUK $.
  $}

  ${
    $d x y z A $.
    mosubop.1 $e |- E* x ph $.
    $( "At most one" remains true inside ordered pair quantification.
       (Contributed by NM, 28-May-1995.) $)
    mosubop $p |- E* x E. y E. z ( A = <. y , z >. /\ ph ) $=
      ( wmo wal cv cop wceq wa wex gen2 mosubopt ax-mp ) ABGZDHCHECIDIJKALDMCMB
      GQCDFNABCDEOP $.
  $}

  ${
    $d x ph $.  $d x A $.  $d x y $.
    euop2.1 $e |- A e. _V $.
    $( Transfer existential uniqueness to second member of an ordered pair.
       (Contributed by NM, 10-Apr-2004.) $)
    euop2 $p |- ( E! x E. y ( x = <. A , y >. /\ ph ) <-> E! y ph ) $=
      ( cv cop opex moop2 euxfr2 ) ABCDCFZGDKHCBFDEIJ $.
  $}

  ${
    $d a b c x y A $.  $d a b c x y B $.  $d a b c x y C $.  $d a b c x ph $.
    $d y ps $.
    euotd.1 $e |- ( ph -> A e. _V ) $.
    euotd.2 $e |- ( ph -> B e. _V ) $.
    euotd.3 $e |- ( ph -> C e. _V ) $.
    euotd.4 $e |- ( ph -> ( ps <-> ( a = A /\ b = B /\ c = C ) ) ) $.
    $( Prove existential uniqueness for an ordered triple.  (Contributed by
       Mario Carneiro, 20-May-2015.) $)
    euotd $p |- ( ph -> E! x E. a E. b E. c ( x = <. a , b , c >. /\ ps ) ) $=
      ( vy cv wceq wa wex cvv wtru cotp wb wal weu w3a biimpa vex sylibr eqeq2d
      otth biimpd impancom expimpd exlimdvv wcel wsbc tru adantr ad2antrr simpr
      exlimdv eqcomd biimpar jca a1tru 2thd 3anassrs sbcied mpbiri spesbcd nfcv
      nfsbc1v nfex sbceq1a exbidv spcegf 2exbidv excom13 sylib eqeq1 syl5ibrcom
      sylc anbi1d 3exbidv impbid alrimiv otex eqeq2 bibi2d albidv spcev df-eu
      syl ) ACOZGOZHOZIOZUAZPZBQZIRZHRGRZWNNOZPZUBZCUCZNRZXBCUDAXBWNDEFUAZPZUBZ
      CUCZXGAXJCAXBXIAXAXIGHAWTXIIAWSBXIABWSXIABQZWSXIXLWRXHWNXLWODPZWPEPZWQFPZ
      UEZWRXHPZABXPMUFWOWPDEWQFGUGHUGIUGUJZUHUIUKULUMVAUNAXBXIXHWRPZBQZIRHRGRZA
      XTGRHRZIRZYAAFSUOZXTIFUPZGRZHRZYCLAESUOZYEHEUPZGRZYGKAYIGDAYIGDUPTUQAYITG
      DSJAXMQZYETHESAYHXMKURYKXNQXTTIFSAYDXMXNLUSAXMXNXOXTTUBAXPQZXTTYLXSBYLWRX
      HYLXPXQAXPUTXRUHVBABXPMVCVDYLVEVFVGVHVHVHVIVJYFYJHESHEVKYIHGYEHEVLVMXNYEY
      IGYEHEVNVOVPWBYBYGIFSIFVKYFIHYEIGXTIFVLVMVMXOXTYEHGXTIFVNVQVPWBXTIHGVRVSX
      IWTXTGHIXIWSXSBWNXHWRVTWCWDWAWEWFXFXKNXHDEFWGXCXHPZXEXJCYMXDXIXBXCXHWNWHW
      IWJWKWMXBCNWLUH $.
  $}

  ${
    opthw.1 $e |- A e. _V $.
    opthw.2 $e |- B e. _V $.
    $( Justification theorem for the ordered pair definition in Norbert Wiener,
       "A simplification of the logic of relations," _Proc. of the Cambridge
       Philos.  Soc_., 1914, vol. 17, pp.387-390.  It is also shown as a
       definition in [Enderton] p. 36 and as Exercise 4.8(b) of [Mendelson]
       p. 230.  It is meaningful only for classes that exist as sets (i.e. are
       not proper classes).  See ~ df-op for other ordered pair definitions.
       (Contributed by NM, 28-Sep-2003.) $)
    opthwiener $p |- ( { { { A } , (/) } , { { B } } } =
                    { { { C } , (/) } , { { D } } } <-> ( A = C /\ B = D ) ) $=
      ( csn c0 cpr wceq wcel snex prid2 wn 0ex eqcom preq2d syl sneqr sneq elpr
      wa id wo eleq2 mpbii sylib wb snnz elsnc bitri nemtbir nelneq2 mp2an mtbi
      biorf ax-mp sylibr eqtr4d prex preqr1 jca preq1d sylan9eq impbii ) AGZHIZ
      BGZGZIZCGZHIZDGZGZIZJZACJZBDJZUBVPVQVRVPVFVKJZVQVPVGVLJZVSVPVJVLVIIZJVTVP
      VJVOWAVPUCVPVIVNVLVPVIVLJZVIVNJZUDZWCVPVIVOKZWDVPVIVJKWEVGVIVHLZMVJVOVIUE
      UFVIVLVNWFUAUGWBNWCWDUHVLVIJZWBHVLKHVIKZNWGNVKHOMWHVHHBFUIWHHVHJVHHJHVHOU
      JHVHPUKULHVLVIUMUNVLVIPUOWBWCUPUQURZQUSVGVLVIVFHUTVKHUTVARVFVKHALCLVARACE
      SRVPVHVMJZVRVPWCWJWIVHVMBLSRBDFSRVBVQVRVJWAVOVQVGVLVIVQVFVKHACTVCVCVRVIVN
      VLVRWJWCBDTVHVMTRQVDVE $.

    $( The union of an ordered pair.  Theorem 65 of [Suppes] p. 39.
       (Contributed by NM, 17-Aug-2004.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    uniop $p |- U. <. A , B >. = { A , B } $=
      ( cop cuni csn cpr cun dfop snex prex unipr wss wceq snsspr1 ssequn1 mpbi
      unieqi 3eqtri ) ABEZFAGZABHZHZFUBUCIZUCUAUDABCDJSUBUCAKABLMUBUCNUEUCOABPU
      BUCQRT $.

    $( Ordered pair membership is inherited by class union.  (Contributed by
       NM, 13-May-2008.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    uniopel $p |- ( <. A , B >. e. C -> U. <. A , B >. e. U. C ) $=
      ( cop wcel cuni cpr uniop opi2 eqeltri elssuni sseld mpi ) ABFZCGZPHZPGRC
      HZGRABIPABDEJABDEKLQPSRPCMNO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ordered-pair class abstractions (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x z w v $.  $d y z w v $.  $d ph z w v $.
    $( The law of concretion.  Special case of Theorem 9.5 of [Quine] p. 61.
       (Contributed by NM, 14-Apr-1995.)  (Proof shortened by Andrew Salmon,
       25-Jul-2011.) $)
    opabid $p |- ( <. x , y >. e. { <. x , y >. | ph } <-> ph ) $=
      ( vz cv cop wceq wa wex copab opex copsexg bicomd df-opab elab2 ) DEZBEZC
      EZFZGZAHCIBIZADSABCJQRKTAUAABCPLMABCDNO $.
  $}

  ${
    $d x z A $.  $d y z A $.  $d z ph $.
    $( Membership in a class abstraction of pairs.  (Contributed by NM,
       24-Mar-1998.) $)
    elopab $p |- ( A e. { <. x , y >. | ph } <->
                 E. x E. y ( A = <. x , y >. /\ ph ) ) $=
      ( vz copab wcel cvv cv cop wceq wa elex opex eleq1 mpbiri adantr exlimivv
      wex eqeq1 anbi1d 2exbidv df-opab elab2g pm5.21nii ) DABCFZGDHGZDBIZCIZJZK
      ZALZCSBSZDUFMULUGBCUKUGAUKUGUJHGUHUINDUJHOPQREIZUJKZALZCSBSUMEDUFHUNDKZUP
      ULBCUQUOUKAUNDUJTUAUBABCEUCUDUE $.
  $}

  ${
    $d x y z v $.  $d x y w v $.  $d v ph $.
    $( The law of concretion in terms of substitutions.  (Contributed by NM,
       30-Sep-2002.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    opelopabsbOLD $p |- ( <. z , w >. e. { <. x , y >. | ph }
                 <-> [ w / y ] [ z / x ] ph ) $=
      ( cv cop wceq wa wex copab wcel wsb excom vex opth equcom anbi12ci anbi1i
      bitri 2exbii elopab 2sb5 3bitr4i ) DFZEFZGZBFZCFZGHZAIZCJBJZUIUFHZUHUEHZI
      ZAIZBJCJZUGABCKLABDMCEMULUKBJCJUQUKBCNUKUPCBUJUOAUJUEUHHZUFUIHZIUOUEUFUHU
      IDOEOPURUNUSUMDBQECQRTSUATABCUGUBACBEDUCUD $.

    brabsbOLD.1 $e |- R = { <. x , y >. | ph } $.
    $( The law of concretion in terms of substitutions.  (Contributed by NM,
       17-Mar-2008.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    brabsbOLD $p |- ( z R w <-> [ w / y ] [ z / x ] ph ) $=
      ( cv wbr copab cop wcel wsb breqi df-br opelopabsbOLD 3bitri ) DHZEHZFIRS
      ABCJZIRSKTLABDMCEMRSFTGNRSTOABCDEPQ $.
  $}

  ${
    $d x y z w $.  $d w z A $.  $d w x B $.  $d w z ph $.
    $( The law of concretion in terms of substitutions.  (Contributed by NM,
       30-Sep-2002.)  (Revised by Mario Carneiro, 18-Nov-2016.) $)
    opelopabsb $p |- ( <. A , B >. e. { <. x , y >. | ph }
                 <-> [. A / x ]. [. B / y ]. ph ) $=
      ( vz vw cop wcel cvv wa wsbc c0 wne wceq cv wex wb eleq1d bibi12d vex nex
      copab wn opnzi simpl eqcomd necon3ai ax-mp elopab mtbir eleq1 mtbiri opnz
      necon2ai sylib sbcex spesbc exlimiv syl jca opeq1 dfsbcq2 sbcbidv nfopab1
      wsb opeq2 nfel2 nfs1v nfbi sbequ12 nfopab2 opabid chvar vtocl2g pm5.21nii
      weq ) DEHZABCUCZIZDJIZEJIZKZACELZBDLZVTVRMNWCVTVRMVRMOVTMVSIZWFMBPZCPZHZO
      ZAKZCQZBQWLBWKCWIMNWKUDWGWHBUACUAUEWKWIMWKMWIWJAUFUGUHUIUBUBABCMUJUKVRMVS
      ULUMUODEUNUPWEWAWBWDBDUQWEWDBQWBWDBDURWDWBBACEUQUSUTVAFPZGPZHZVSIZACGVFZB
      FVFZRZDWNHZVSIZWQBDLZRVTWERFGDEJJWMDOZWPXAWRXBXCWOWTVSWMDWNVBSWQBFDVCTWNE
      OZXAVTXBWEXDWTVRVSWNEDVGSXDWQWDBDACGEVCVDTWGWNHZVSIZWQRZWSBFWPWRBBWOVSABC
      VEVHWQBFVIVJBFVQZXFWPWQWRXHXEWOVSWGWMWNVBSWQBFVKTWIVSIZARXGCGXFWQCCXEVSAB
      CVLVHACGVIVJCGVQZXIXFAWQXJWIXEVSWHWNWGVGSACGVKTABCVMVNVNVOVP $.

    brabsb.1 $e |- R = { <. x , y >. | ph } $.
    $( The law of concretion in terms of substitutions.  (Contributed by NM,
       17-Mar-2008.) $)
    brabsb $p |- ( A R B <-> [. A / x ]. [. B / y ]. ph ) $=
      ( wbr cop wcel copab wsbc df-br eleq2i opelopabsb 3bitri ) DEFHDEIZFJQABC
      KZJACELBDLDEFMFRQGNABCDEOP $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y ch $.  $d z ph $.
    $( Closed theorem form of ~ opelopab .  (Contributed by NM,
       19-Feb-2013.) $)
    opelopabt $p |- ( ( A. x A. y ( x = A -> ( ph <-> ps ) )
                     /\ A. x A. y ( y = B -> ( ps <-> ch ) )
                     /\ ( A e. V /\ B e. W ) ) ->
                    ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) ) $=
      ( cop copab wcel cv wceq wa wex wb wi wal w3a elopab prth 2alimi copsex2t
      19.26-2 bitr syl6 sylbir sylan 3impa syl5bb ) FGJZADEKLULDMZEMZJNAOEPDPZU
      MFNZABQZRZESDSZUNGNZBCQZRZESDSZFHLGILOZTCADEULUAUSVCVDUOCQZUSVCOZUPUTOZAC
      QZRZESDSZVDVEVFURVBOZESDSVJURVBDEUEVKVIDEVKVGUQVAOVHUPUQUTVAUBABCUFUGUCUH
      ACDEFGHIUDUIUJUK $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    opelopabga.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  (Contributed by
       Mario Carneiro, 19-Dec-2013.) $)
    opelopabga $p |- ( ( A e. V /\ B e. W ) ->
                    ( <. A , B >. e. { <. x , y >. | ph } <-> ps ) ) $=
      ( cop copab wcel cv wceq wa wex elopab copsex2g syl5bb ) EFJZACDKLTCMDMJN
      AODPCPEGLFHLOBACDTQABCDEFGHIRS $.

    ${
      brabga.2 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion for a binary relation.  (Contributed by Mario
         Carneiro, 19-Dec-2013.) $)
      brabga $p |- ( ( A e. V /\ B e. W ) -> ( A R B <-> ps ) ) $=
        ( wbr cop copab wcel wa df-br eleq2i bitri opelopabga syl5bb ) EFGLZEFM
        ZACDNZOZEHOFIOPBUBUCGOUEEFGQGUDUCKRSABCDEFHIJTUA $.
    $}

    $d x y C $.  $d x y D $.
    $( Ordered pair membership in an ordered pair class abstraction.
       (Contributed by Mario Carneiro, 19-Dec-2013.) $)
    opelopab2a $p |- ( ( A e. C /\ B e. D ) -> ( <. A , B >. e.
                 { <. x , y >. | ( ( x e. C /\ y e. D ) /\ ph ) } <-> ps ) ) $=
      ( wcel wa cop cv copab wceq eleq1 bi2anan9 anbi12d opelopabga bianabs ) E
      GJZFHJZKZEFLCMZGJZDMZHJZKZAKZCDNJBUIUCBKCDEFGHUDEOZUFFOZKUHUCABUJUEUAUKUG
      UBUDEGPUFFHPQIRST $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ps $.
    opelopaba.1 $e |- A e. _V $.
    opelopaba.2 $e |- B e. _V $.
    opelopaba.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  (Contributed by
       Mario Carneiro, 19-Dec-2013.) $)
    opelopaba $p |- ( <. A , B >. e. { <. x , y >. | ph } <-> ps ) $=
      ( cvv wcel cop copab wb opelopabga mp2an ) EJKFJKEFLACDMKBNGHABCDEFJJIOP
      $.

    ${
      braba.4 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion for a binary relation.  (Contributed by NM,
         19-Dec-2013.) $)
      braba $p |- ( A R B <-> ps ) $=
        ( cvv wcel wbr wb brabga mp2an ) ELMFLMEFGNBOHIABCDEFGLLJKPQ $.
    $}
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ch $.
    opelopabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopabg.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  (Contributed by
       NM, 28-May-1995.)  (Revised by Mario Carneiro, 19-Dec-2013.) $)
    opelopabg $p |- ( ( A e. V /\ B e. W ) ->
                    ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) ) $=
      ( cv wceq sylan9bb opelopabga ) ACDEFGHIDLFMABELGMCJKNO $.

    ${
      brabg.5 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion for a binary relation.  (Contributed by NM,
         16-Aug-1999.)  (Revised by Mario Carneiro, 19-Dec-2013.) $)
      brabg $p |- ( ( A e. C /\ B e. D ) -> ( A R B <-> ch ) ) $=
        ( cv wceq sylan9bb brabga ) ACDEFGJHIDNFOABENGOCKLPMQ $.
    $}
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y ch $.
    opelopab2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopab2.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( Ordered pair membership in an ordered pair class abstraction.
       (Contributed by NM, 14-Oct-2007.)  (Revised by Mario Carneiro,
       19-Dec-2013.) $)
    opelopab2 $p |- ( ( A e. C /\ B e. D ) -> ( <. A , B >. e.
                 { <. x , y >. | ( ( x e. C /\ y e. D ) /\ ph ) } <-> ch ) ) $=
      ( cv wceq sylan9bb opelopab2a ) ACDEFGHIDLFMABELGMCJKNO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ch $.
    opelopab.1 $e |- A e. _V $.
    opelopab.2 $e |- B e. _V $.
    opelopab.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopab.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  (Contributed by
       NM, 16-May-1995.) $)
    opelopab $p |- ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) $=
      ( cvv wcel cop copab wb opelopabg mp2an ) FLMGLMFGNADEOMCPHIABCDEFGLLJKQR
      $.

    ${
      brab.5 $e |- R = { <. x , y >. | ph } $.
      $( The law of concretion for a binary relation.  (Contributed by NM,
         16-Aug-1999.) $)
      brab $p |- ( A R B <-> ch ) $=
        ( cvv wcel wbr wb brabg mp2an ) FNOGNOFGHPCQIJABCDEFGNNHKLMRS $.
    $}
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w z ph $.  $d w z ps $.
    opelopabaf.x $e |- F/ x ps $.
    opelopabaf.y $e |- F/ y ps $.
    opelopabaf.1 $e |- A e. _V $.
    opelopabaf.2 $e |- B e. _V $.
    opelopabaf.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  This version of
       ~ opelopab uses bound-variable hypotheses in place of distinct variable
       conditions."  (Contributed by Mario Carneiro, 19-Dec-2013.)  (Proof
       shortened by Mario Carneiro, 18-Nov-2016.) $)
    opelopabaf $p |- ( <. A , B >. e. { <. x , y >. | ph } <-> ps ) $=
      ( cop copab wcel wsbc opelopabsb cvv wb nfv sbc2iegf mp2an bitri ) EFLACD
      MNADFOCEOZBACDEFPEQNFQNZUCBRIJABCDEFQQGHUDCSKTUAUB $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w z ch $.  $d w z ph $.
    opelopabf.x $e |- F/ x ps $.
    opelopabf.y $e |- F/ y ch $.
    opelopabf.1 $e |- A e. _V $.
    opelopabf.2 $e |- B e. _V $.
    opelopabf.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopabf.4 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  This version of
       ~ opelopab uses bound-variable hypotheses in place of distinct variable
       conditions."  (Contributed by NM, 19-Dec-2008.) $)
    opelopabf $p |- ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) $=
      ( cop wcel wsbc cvv wb sbciegf ax-mp copab opelopabsb nfcv cv wceq 3bitri
      nfsbc sbcbidv ) FGNADEUAOAEGPZDFPZBEGPZCADEFGUBFQOUJUKRJUIUKDFQBDEGDGUCHU
      GDUDFUEABEGLUHSTGQOUKCRKBCEGQIMSTUF $.
  $}

  ${
    $d ph z $.  $d ps z $.  $d x z $.  $d y z $.
    $( Equivalence of ordered pair abstraction subclass and implication.
       (Contributed by NM, 27-Dec-1996.)  (Revised by Mario Carneiro,
       19-May-2013.) $)
    ssopab2 $p |- ( A. x A. y ( ph -> ps ) ->
        { <. x , y >. | ph } C_ { <. x , y >. | ps } ) $=
      ( vz wi wal cv cop wceq wa wex cab copab nfa1 sp anim2d eximd sps df-opab
      ss2abdv 3sstr4g ) ABFZDGZCGZEHCHDHIJZAKZDLZCLZEMUFBKZDLZCLZEMACDNBCDNUEUI
      ULEUEUHUKCUDCOUDUHUKFCUDUGUJDUCDOUDABUFUCDPQRSRUAACDETBCDETUB $.
  $}

  ${
    $d ph z $.  $d ps z $.  $d x z $.  $d y z $.
    $( Equivalence of ordered pair abstraction subclass and implication.
       (Contributed by NM, 27-Dec-1996.)  (Proof shortened by Mario Carneiro,
       18-Nov-2016.) $)
    ssopab2b $p |- ( { <. x , y >. | ph } C_ { <. x , y >. | ps } <->
               A. x A. y ( ph -> ps ) ) $=
      ( copab wss wi wal nfopab1 nfss nfopab2 cv cop wcel opabid 3imtr3g alrimi
      ssel ssopab2 impbii ) ACDEZBCDEZFZABGZDHZCHUCUECCUAUBACDIBCDIJUCUDDDUAUBA
      CDKBCDKJUCCLDLMZUANUFUBNABUAUBUFRACDOBCDOPQQABCDST $.
  $}

  ${
    ssopab2i.1 $e |- ( ph -> ps ) $.
    $( Inference of ordered pair abstraction subclass from implication.
       (Contributed by NM, 5-Apr-1995.) $)
    ssopab2i $p |- { <. x , y >. | ph } C_ { <. x , y >. | ps } $=
      ( wi wal copab wss ssopab2 ax-gen mpg ) ABFZDGACDHBCDHICABCDJMDEKL $.
  $}

  ${
    $d x ph $.  $d y ph $.
    ssopab2dv.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Inference of ordered pair abstraction subclass from implication.
       (Contributed by NM, 19-Jan-2014.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    ssopab2dv $p |- ( ph -> { <. x , y >. | ps } C_ { <. x , y >. | ch } ) $=
      ( wi wal copab wss alrimivv ssopab2 syl ) ABCGZEHDHBDEICDEIJANDEFKBCDELM
      $.
  $}

  ${
    $d ph z $.  $d ps z $.  $d x z $.  $d y z $.
    $( Equivalence of ordered pair abstraction equality and biconditional.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    eqopab2b $p |- ( { <. x , y >. | ph } = { <. x , y >. | ps }
                <-> A. x A. y ( ph <-> ps ) ) $=
      ( copab wss wa wi wal wceq wb ssopab2b anbi12i eqss 2albiim 3bitr4i ) ACD
      EZBCDEZFZRQFZGABHDICIZBAHDICIZGQRJABKDICISUATUBABCDLBACDLMQRNABCDOP $.
  $}

  ${
    $d z ph $.  $d z x $.  $d z y $.
    $( Non-empty ordered pair class abstraction.  (Contributed by NM,
       10-Oct-2007.) $)
    opabn0 $p |- ( { <. x , y >. | ph } =/= (/) <-> E. x E. y ph ) $=
      ( vz copab c0 wne cv wcel wex n0 cop wceq elopab exbii exrot3 opex isseti
      wa bitri 19.41v mpbiran 2exbii ) ABCEZFGDHZUDIZDJZACJBJZDUDKUGUEBHZCHZLZM
      ZASZCJBJZDJZUHUFUNDABCUENOUOUMDJZCJBJUHUMDBCPUPABCUPULDJADUKUIUJQRULADUAU
      BUCTTT $.
  $}

  ${
    $d w y z A $.  $d w ph $.  $d w x y z $.
    $( Move substitution into a class abstraction.  (Contributed by NM,
       6-Aug-2007.)  (Revised by NM, 23-Aug-2018.) $)
    csbopab $p |- [_ A / x ]_ { <. y , z >. | ph }
              = { <. y , z >. | [. A / x ]. ph } $=
      ( vw cvv wcel copab csb wsbc wceq cv wsb csbeq1 opabbidv wn c0 wex nexdv
      dfsbcq2 eqeq12d vex nfs1v nfopab sbequ12 csbief vtoclg csbprc sbcex con3i
      weq opabn0 necon1bbii sylib eqtr4d pm2.61i ) EGHZBEACDIZJZABEKZCDIZLZBFMZ
      USJZABFNZCDIZLVCFEGVDELZVEUTVGVBBVDEUSOVHVFVACDABFEUAPUBBVDUSVGFUCVFCDBAB
      FUDUEBFULAVFCDABFUFPUGUHURQZUTRVBBEUSUIVIVADSZCSZQVBRLVIVJCVIVADVAURABEUJ
      UKTTVKVBRVACDUMUNUOUPUQ $.
  $}

  ${
    $d w y z A $.  $d w ph $.  $d w x y z $.
    $( Move substitution into a class abstraction.  (Contributed by NM,
       6-Aug-2007.)  (Proof shortened by Mario Carneiro, 17-Nov-2016.)
       Obsolete as of 22-Aug-2018.  Use ~ csbopab instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbopabgOLD $p |- ( A e. V -> [_ A / x ]_ { <. y , z >. | ph }
              = { <. y , z >. | [. A / x ]. ph } ) $=
      ( vw cv copab csb wsb wceq wsbc csbeq1 dfsbcq2 opabbidv eqeq12d vex nfs1v
      nfopab sbequ12 csbief vtoclg ) BGHZACDIZJZABGKZCDIZLBEUEJZABEMZCDIZLGEFUD
      ELZUFUIUHUKBUDEUENULUGUJCDABGEOPQBUDUEUHGRUGCDBABGSTBHUDLAUGCDABGUAPUBUC
      $.
  $}

  ${
    $d ph w $.  $d A w x $.  $d A y $.  $d w y z $.  $d x z $.
    $( Move indexed union inside an ordered-pair abstraction.  (Contributed by
       Stefan O'Rear, 20-Feb-2015.) $)
    iunopab $p |- U_ z e. A { <. x , y >. | ph } =
        { <. x , y >. | E. z e. A ph } $=
      ( vw cv copab wcel wrex cab cop wceq wex ciun elopab rexcom4 exbii bitri
      wa rexbii r19.42v abbii df-iun df-opab 3eqtr4i ) FGZABCHZIZDEJZFKUGBGCGLM
      ZADEJZTZCNZBNZFKDEUHOULBCHUJUOFUJUKATZCNZBNZDEJZUOUIURDEABCUGPUAUSUQDEJZB
      NUOUQDBEQUTUNBUTUPDEJZCNUNUPDCEQVAUMCUKADEUBRSRSSUCDFEUHUDULBCFUEUF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Power class of union and intersection
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.  $d B x y $.
    $( The power class of the intersection of two classes is the intersection
       of their power classes.  Exercise 4.12(j) of [Mendelson] p. 235.
       (Contributed by NM, 23-Nov-2003.) $)
    pwin $p |- ~P ( A i^i B ) = ( ~P A i^i ~P B ) $=
      ( vx cpw cin cv wss wa wcel ssin vex elpw anbi12i 3bitr4i ineqri eqcomi )
      ADZBDZEABEZDZCQRTCFZAGZUABGZHUASGUAQIZUARIZHUATIUAABJUDUBUEUCUAACKZLUABUF
      LMUASUFLNOP $.

    $( The power class of the union of two classes includes the union of their
       power classes.  Exercise 4.12(k) of [Mendelson] p. 235.  (Contributed by
       NM, 23-Nov-2003.) $)
    pwunss $p |- ( ~P A u. ~P B ) C_ ~P ( A u. B ) $=
      ( vx cpw cun cv wss wcel ssun elun vex elpw orbi12i bitri 3imtr4i ssriv
      wo ) CADZBDZEZABEZDZCFZAGZUCBGZQZUCUAGUCTHZUCUBHUCABIUGUCRHZUCSHZQUFUCRSJ
      UHUDUIUEUCACKZLUCBUJLMNUCUAUJLOP $.

    $( The power class of the union of two classes is a subset of the union of
       their power classes, iff one class is a subclass of the other.  Exercise
       4.12(l) of [Mendelson] p. 235.  (Contributed by NM, 23-Nov-2003.) $)
    pwssun $p |- ( ( A C_ B \/ B C_ A ) <->
               ~P ( A u. B ) C_ ( ~P A u. ~P B ) ) $=
      ( vy vx wss wo cun cpw wceq pweq eqimss syl sylbi orim12i wn wa wcel elpw
      cv wi ssequn2 ssequn1 orcoms ssun cpr csn vex snss unss12 syl2anb zfpair2
      df-pr sseq1i bitr2i sylib ssel syl5 exp3acom23 imp31 elun simprbi simplbi
      prss bitr4i ord impancom ssrdv exp31 con1b syl6ib com23 imp orrd impbii
      ex ) ABEZBAEZFZABGZHZAHZBHZGZEZVRVTWAEZVTWBEZFZWDVQVPWGVQWEVPWFVQVSAIZWEB
      AUAWHVTWAIWEVSAJVTWAKLMVPVSBIZWFABUBWIVTWBIWFVSBJVTWBKLMNUCVTWAWBUDLWDVPV
      QWDVPOZVQWDWJPCBAWDWJCSZBQZWKAQZTWDWLWJWMWDWLWMOZVPTWJWMTWDWLWNVPWDWLPZWN
      PDABWODSZAQZWNWPBQZWOWQPZWMWRWSWPWKUEZWAQZWTWBQZFZWMWRFWSWTWCQZXCWDWLWQXD
      WDWQWLXDWQWLPZWTVTQZWDXDXEWPUFZWKUFZGZVSEZXFWQXGAEXHBEXJWLWPADUGZUHWKBCUG
      ZUHXGAXHBUIUJXFWTVSEXJWTVSDCUKZRWTXIVSWPWKULUMUNUOVTWCWTUPUQURUSWTWAWBUTU
      OXAWMXBWRXAWQWMXAWTAEWQWMPWTAXMRWPWKAXKXLVCVDVAXBWRWLXBWTBEWRWLPWTBXMRWPW
      KBXKXLVCVDVBNLVEVFVGVHWMVPVIVJVKVLVGVOVMVN $.
  $}

  $( Break up the power class of a union into a union of smaller classes.
     (Contributed by NM, 25-Mar-2007.)  (Proof shortened by Thierry Arnoux,
     20-Dec-2016.) $)
  pwundif $p |- ~P ( A u. B ) =
                ( ( ~P ( A u. B ) \ ~P A ) u. ~P A ) $=
    ( cun cpw cdif undif1 wss wceq pwunss unss mpbir simpli ssequn2 mpbi eqtr2i
    wa ) ABCDZADZERCQRCZQQRFRQGZSQHTBDZQGZTUBPRUACQGABIRUAQJKLRQMNO $.

  $( The power class of the union of two classes equals the union of their
     power classes, iff one class is a subclass of the other.  Part of Exercise
     7(b) of [Enderton] p. 28.  (Contributed by NM, 23-Nov-2003.) $)
  pwun $p |- ( ( A C_ B \/ B C_ A ) <->
             ~P ( A u. B ) = ( ~P A u. ~P B ) ) $=
    ( cun cpw wss wa wo wceq pwunss biantru pwssun eqss 3bitr4i ) ABCDZADBDCZEZ
    PONEZFABEBAEGNOHQPABIJABKNOLM $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Epsilon and identity relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols. $)
  $c _E $. $( Letter E (for epsilon relation) $)
  $c _I $.  $( Letter I (for identity relation) $)

  $( Extend class notation to include the epsilon relation. $)
  cep $a class _E $.

  $( Extend the definition of a class to include identity relation. $)
  cid $a class _I $.

  ${
    $d x y $.
    $( Define the epsilon relation.  Similar to Definition 6.22 of
       [TakeutiZaring] p. 30.  The epsilon relation and set membership are the
       same, that is, ` ( A _E B <-> A e. B ) ` when ` B ` is a set by
       ~ epelg .  Thus, ` 5 _E { 1 , 5 } ` ( ~ ex-eprel ).  (Contributed by NM,
       13-Aug-1995.) $)
    df-eprel $a |- _E = { <. x , y >. | x e. y } $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( The epsilon relation and membership are the same.  General version of
       ~ epel .  (Contributed by Scott Fenton, 27-Mar-2011.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    epelg $p |- ( B e. V -> ( A _E B <-> A e. B ) ) $=
      ( vx vy wcel cvv cep wbr wi cop df-br cv copab wceq wa wex vex sylbi a1i
      elopab pm3.2i opeqex mpbiri simpld adantr exlimivv df-eprel eleq2s eleq12
      elex wb brabga expcom pm5.21ndd ) BCFZAGFZABHIZABFZURUQJUPURABKZHFUQABHLU
      QUTDMZEMZFZDENZHUTVDFUTVAVBKOZVCPZEQDQUQVCDEUTUAVFUQDEVEUQVCVEUQBGFZVEUQV
      GPVAGFZVBGFZPVHVIDRERUBABVAVBUCUDUEUFUGSDEUHZUISTUSUQJUPABUKTUQUPURUSULVC
      USDEABHGCVAAVBBUJVJUMUNUO $.
  $}

  ${
    epelc.1 $e |- B e. _V $.
    $( The epsilon relationship and the membership relation are the same.
       (Contributed by Scott Fenton, 11-Apr-2012.) $)
    epelc $p |- ( A _E B <-> A e. B ) $=
      ( cvv wcel cep wbr wb epelg ax-mp ) BDEABFGABEHCABDIJ $.
  $}

  $( The epsilon relation and the membership relation are the same.
     (Contributed by NM, 13-Aug-1995.) $)
  epel $p |- ( x _E y <-> x e. y ) $=
    ( cv vex epelc ) ACBCBDE $.

  ${
    $d x y $.
    $( Define the identity relation.  Definition 9.15 of [Quine] p. 64.  For
       example, ` 5 _I 5 ` and ` -. 4 _I 5 ` ( ~ ex-id ).  (Contributed by NM,
       13-Aug-1995.) $)
    df-id $a |- _I = { <. x , y >. | x = y } $.
  $}

  ${
    $d w z x $.  $d w z y $.
    $( A stronger version of ~ df-id that doesn't require ` x ` and ` y ` to be
       distinct.  Ordinarily, we wouldn't use this as a definition, since
       non-distinct dummy variables would make soundness verification more
       difficult (as the proof here shows).  The proof can be instructive in
       showing how distinct variable requirements may be eliminated, a task
       that is not necessarily obvious.  (Contributed by NM, 5-Feb-2008.)
       (Revised by Mario Carneiro, 18-Nov-2016.) $)
    dfid3 $p |- _I = { <. x , y >. | x = y } $=
      ( vz vw weq copab cv cop wa wex cab wb exbii opeq2 eqeq2d equequ2 anbi12d
      wceq nfnae nfcvd cid df-id wal ancom equcom anbi1i bitri vex equid 3bitri
      ceqsexv biantru nfe1 19.9 bitr4i drex1 drex2 syl5bb wn nfcvf2 nfopd nfeqd
      sps nfand wi a1i cbvexd exbid pm2.61i abbii df-opab 3eqtr4i eqtri ) UAACE
      ZACFZABEZABFZACUBDGZAGZCGZHZRZVNIZCJZAJZDKVRVSBGZHZRZVPIZBJZAJZDKVOVQWEWK
      DVPAUCZWEWKLWEVRVSVSHZRZAAEZIZAJZAJZWLWKWEWQWRWDWPAWDCAEZWBIZCJWNWPWCWTCW
      CVNWBIWTWBVNUDVNWSWBACUEUFUGMWBWNCVSAUHWSWAWMVRVTVSVSNOUKWOWNAUIULUJMWQAW
      PAUMUNUOWQWJABAWPWIABVPWPWILAVPWNWHWOVPVPWMWGVRVSWFVSNOABAPQVCUPUQURWLUSZ
      WDWJAABASXAWCWICBABBSXAWBVNBXABVRWAXABVRTXABVSVTABUTZXABVTTZVAVBXABVSVTXB
      XCVBVDCBEZWCWILVEXAXDWBWHVNVPXDWAWGVRVTWFVSNOCBAPQVFVGVHVIVJVNACDVKVPABDV
      KVLVM $.
  $}

  $( Alternate definition of the identity relation.  (Contributed by NM,
     15-Mar-2007.) $)
  dfid2 $p |- _I = { <. x , x >. | x = x } $=
    ( dfid3 ) AAB $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Partial and complete ordering
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
We have not yet defined relations ( ~ df-rel ), but here we introduce a
few related notions we will use to develop ordinals.  The class variable
` R ` is no different from other class variables, but it reminds us that
normally it represents what we will later call a "relation."
$)

  $( Declare new constant symbols. $)
  $c Po $.  $( Partial ordering predicate symbol (read: 'partial ordering'). $)
  $c Or $.  $( Strict complete ordering predicate symbol (read: 'orders'). $)

  $( Extend wff notation to include the strict partial ordering predicate.
     Read:  ' ` R ` is a partial order on ` A ` .' $)
  wpo $a wff R Po A $.

  $( Extend wff notation to include the strict complete ordering predicate.
     Read:  ' ` R ` orders ` A ` .' $)
  wor $a wff R Or A $.

  ${
    $d x y z R $.  $d x y z A $.
    $( Define the strict partial order predicate.  Definition of [Enderton]
       p. 168.  The expression ` R Po A ` means ` R ` is a partial order on
       ` A ` .  For example, ` < Po RR ` is true, while ` <_ Po RR ` is false
       ( ~ ex-po ).  (Contributed by NM, 16-Mar-1997.) $)
    df-po $a |- ( R Po A <-> A. x e. A A. y e. A A. z e. A
                ( -. x R x /\ ( ( x R y /\ y R z ) -> x R z ) ) ) $.

    $( Define the strict complete (linear) order predicate.  The expression
       ` R Or A ` is true if relationship ` R ` orders ` A ` .  For example,
       ` < Or RR ` is true ( ~ ltso ).  Equivalent to Definition 6.19(1) of
       [TakeutiZaring] p. 29.  (Contributed by NM, 21-Jan-1996.) $)
    df-so $a |- ( R Or A <-> ( R Po A /\ A. x e. A A. y e. A
                ( x R y \/ x = y \/ y R x ) ) ) $.
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    $( Subset theorem for the partial ordering predicate.  (Contributed by NM,
       27-Mar-1997.)  (Proof shortened by Mario Carneiro, 18-Nov-2016.) $)
    poss $p |- ( A C_ B -> ( R Po B -> R Po A ) ) $=
      ( vx vy vz wss cv wbr wn wa wi wral wpo ssralv ralimdv syld df-po 3imtr4g
      ) ABGZDHZUACIJUAEHZCIUBFHZCIKUAUCCILKZFBMZEBMZDBMZUDFAMZEAMZDAMZBCNACNTUG
      UFDAMUJUFDABOTUFUIDATUFUEEAMUIUEEABOTUEUHEAUDFABOPQPQDEFBCRDEFACRS $.
  $}

  ${
    $d x y z R $.  $d x y z S $.  $d x y z A $.
    $( Equality theorem for partial ordering predicate.  (Contributed by NM,
       27-Mar-1997.) $)
    poeq1 $p |- ( R = S -> ( R Po A <-> S Po A ) ) $=
      ( vx vy vz wceq cv wbr wn wa wral wpo breq notbid anbi12d imbi12d ralbidv
      wi df-po 2ralbidv 3bitr4g ) BCGZDHZUDBIZJZUDEHZBIZUGFHZBIZKZUDUIBIZSZKZFA
      LZEALDALUDUDCIZJZUDUGCIZUGUICIZKZUDUICIZSZKZFALZEALDALABMACMUCUOVDDEAAUCU
      NVCFAUCUFUQUMVBUCUEUPUDUDBCNOUCUKUTULVAUCUHURUJUSUDUGBCNUGUIBCNPUDUIBCNQP
      RUADEFABTDEFACTUB $.
  $}

  $( Equality theorem for partial ordering predicate.  (Contributed by NM,
     27-Mar-1997.) $)
  poeq2 $p |- ( A = B -> ( R Po A <-> R Po B ) ) $=
    ( wceq wpo wss wi eqimss2 poss syl eqimss impbid ) ABDZACEZBCEZMBAFNOGBAHBA
    CIJMABFONGABKABCIJL $.

  ${
    $d R a b c $.  $d A a b c $.  $d x a b c $.
    nfpo.r $e |- F/_ x R $.
    nfpo.a $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for partial orders.  (Contributed by
       Stefan O'Rear, 20-Jan-2015.) $)
    nfpo $p |- F/ x R Po A $=
      ( va vb vc wpo cv wbr wn wa wi wral df-po nfcv nfbr nfan nfral nfim nfxfr
      nfn ) BCIFJZUDCKZLZUDGJZCKZUGHJZCKZMZUDUICKZNZMZHBOZGBOZFBOAFGHBCPUPAFBEU
      OAGBEUNAHBEUFUMAUEAAUDUDCAUDQZDUQRUCUKULAUHUJAAUDUGCUQDAUGQZRAUGUICURDAUI
      QZRSAUDUICUQDUSRUASTTTUB $.

    $( Bound-variable hypothesis builder for total orders.  (Contributed by
       Stefan O'Rear, 20-Jan-2015.) $)
    nfso $p |- F/ x R Or A $=
      ( va vb wor wpo cv wbr weq w3o wral wa df-so nfpo nfcv nfbr nfral nf3or
      nfv nfan nfxfr ) BCHBCIZFJZGJZCKZFGLZUGUFCKZMZGBNZFBNZOAFGBCPUEUMAABCDEQU
      LAFBEUKAGBEUHUIUJAAUFUGCAUFRZDAUGRZSUIAUBAUGUFCUODUNSUATTUCUD $.
  $}

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    $( Properties of partial order relation in class notation.  (Contributed by
       NM, 27-Mar-1997.) $)
    pocl $p |- ( R Po A -> ( ( B e. A /\ C e. A /\ D e. A ) ->
               ( -. B R B /\ ( ( B R C /\ C R D ) -> B R D ) ) ) ) $=
      ( vx vy vz wcel wbr wa wi cv wceq breq1 imbi2d breq2 anbi2d wal wral r3al
      w3a wn id breq12d notbid anbi1d imbi12d anbi12d imbi1d df-po bitri biimpi
      wpo 19.21bbi 19.21bi com12 vtocl3ga ) BAICAIDAIUBAEUNZBBEJZUCZBCEJZCDEJZK
      ZBDEJZLZKZUSFMZVHEJZUCZVHGMZEJZVKHMZEJZKZVHVMEJZLZKZLUSVABVKEJZVNKZBVMEJZ
      LZKZLUSVAVBCVMEJZKZWALZKZLUSVGLFGHBCDAAAVHBNZVRWCUSWHVJVAVQWBWHVIUTWHVHBV
      HBEWHUDZWIUEUFWHVOVTVPWAWHVLVSVNVHBVKEOUGVHBVMEOUHUIPVKCNZWCWGUSWJWBWFVAW
      JVTWEWAWJVSVBVNWDVKCBEQVKCVMEOUIUJRPVMDNZWGVGUSWKWFVFVAWKWEVDWAVEWKWDVCVB
      VMDCEQRVMDBEQUHRPUSVHAIVKAIVMAIUBZVRUSWLVRLZHUSWMHSZFGUSWNGSFSZUSVRHATGAT
      FATWOFGHAEUKVRFGHAAAUAULUMUOUPUQURUQ $.
  $}

  ${
    $d x y z A $.  $d x y z R $.  $d x y z ph $.
    ispod.1 $e |- ( ( ph /\ x e. A ) -> -. x R x ) $.
    ispod.2 $e |- ( ( ph /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
                    ( ( x R y /\ y R z ) -> x R z ) ) $.
    $( Sufficient conditions for a partial order.  (Contributed by NM,
       9-Jul-2014.) $)
    ispod $p |- ( ph -> R Po A ) $=
      ( cv wbr wn wa wi wral wpo wcel w3a 3ad2antr1 jca ralrimivvva sylibr
      df-po ) ABIZUCFJKZUCCIZFJUEDIZFJLUCUFFJMZLZDENCENBENEFOAUHBCDEEEAUCEPZUEE
      PZUFEPZQLUDUGAUJUIUDUKGRHSTBCDEFUBUA $.
  $}

  ${
    $d x y z A $.  $d x y z ph $.  $d x y z R $.  $d x y z X $.  $d y z Y $.
    $d z Z $.
    swopolem.1 $e |- ( ( ph /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
                    ( x R y -> ( x R z \/ z R y ) ) ) $.
    $( Perform the substitutions into the strict weak ordering law.
       (Contributed by Mario Carneiro, 31-Dec-2014.) $)
    swopolem $p |- ( ( ph /\ ( X e. A /\ Y e. A /\ Z e. A ) ) ->
                    ( X R Y -> ( X R Z \/ Z R Y ) ) ) $=
      ( cv wbr wo wi wral wcel wceq breq1 imbi12d breq2 w3a ralrimivvva orbi12d
      orbi1d orbi2d imbi2d rspc3v mpan9 ) ABKZCKZFLZUIDKZFLZULUJFLZMZNZDEOCEOBE
      OGEPHEPIEPUAGHFLZGIFLZIHFLZMZNZAUPBCDEEEJUBUPVAGUJFLZGULFLZUNMZNUQVCULHFL
      ZMZNBCDGHIEEEUIGQZUKVBUOVDUIGUJFRVGUMVCUNUIGULFRUDSUJHQZVBUQVDVFUJHGFTVHU
      NVEVCUJHULFTUESULIQZVFUTUQVIVCURVEUSULIGFTULIHFRUCUFUGUH $.
  $}

  ${
    $d x y z A $.  $d x y z R $.  $d x y z ph $.
    swopo.1 $e |- ( ( ph /\ ( y e. A /\ z e. A ) ) ->
                    ( y R z -> -. z R y ) ) $.
    swopo.2 $e |- ( ( ph /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
                    ( x R y -> ( x R z \/ z R y ) ) ) $.
    $( A strict weak order is a partial order.  (Contributed by Mario Carneiro,
       9-Jul-2014.) $)
    swopo $p |- ( ph -> R Po A ) $=
      ( cv wcel wa wbr wn wi wral weq breq1 breq2 notbid imbi12d ralrimivva w3a
      id ancli rspc2va syl2anr pm2.01d 3adantr1 wo imp orcomd ord expimpd ispod
      sylan2d ) ABCDEFABIZEJZKUPUPFLZUQUQUQKCIZDIZFLZUTUSFLZMZNZDEOCEOURURMZNZA
      UQUQUQUCUDAVDCDEEGUAVDVFUPUTFLZUTUPFLZMZNCDUPUPEECBPZVAVGVCVIUSUPUTFQVJVB
      VHUSUPUTFRSTDBPZVGURVIVEUTUPUPFRVKVHURUTUPUPFQSTUEUFUGAUQUSEJZUTEJZUBKZVA
      VCUPUSFLZVGAVLVMVDUQGUHVNVOVCVGVNVOKZVBVGVPVGVBVNVOVGVBUIHUJUKULUMUOUN $.
  $}

  $( A partial order relation is irreflexive.  (Contributed by NM,
     27-Mar-1997.) $)
  poirr $p |- ( ( R Po A /\ B e. A ) -> -. B R B ) $=
    ( wcel wpo w3a wbr wn wa df-3an anabs1 anidm 3bitrri wi pocl simpld sylan2b
    imp ) BADZACEZSSSFZBBCGZHZUASSIZSIUDSSSSJSSKSLMTUAIUCUBUBIUBNZTUAUCUEIABBBC
    ORPQ $.

  $( A partial order relation is a transitive relation.  (Contributed by NM,
     27-Mar-1997.) $)
  potr $p |- ( ( R Po A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             ( ( B R C /\ C R D ) -> B R D ) ) $=
    ( wpo wcel w3a wa wbr wn wi pocl imp simprd ) AEFZBAGCAGDAGHZIBBEJKZBCEJCDE
    JIBDEJLZPQRSIABCDEMNO $.

  $( A partial order relation has no 2-cycle loops.  (Contributed by NM,
     27-Mar-1997.) $)
  po2nr $p |- ( ( R Po A /\ ( B e. A /\ C e. A ) ) ->
              -. ( B R C /\ C R B ) ) $=
    ( wpo wcel wa wbr wn poirr adantrr wi potr 3exp2 com34 pm2.43d imp32 mtod )
    ADEZBAFZCAFZGGBCDHCBDHGZBBDHZSTUCIUAABDJKSTUAUBUCLZSTUAUDLSTUATUDSTUATUDABC
    BDMNOPQR $.

  $( A partial order relation has no 3-cycle loops.  (Contributed by NM,
     27-Mar-1997.) $)
  po3nr $p |- ( ( R Po A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             -. ( B R C /\ C R D /\ D R B ) ) $=
    ( wpo wcel w3a wa wbr wn po2nr 3adantr2 df-3an potr anim1d syl5bi mtod ) AE
    FZBAGZCAGZDAGZHIZBCEJZCDEJZDBEJZHZBDEJZUFIZSTUBUIKUAABDELMUGUDUEIZUFIUCUIUD
    UEUFNUCUJUHUFABCDEOPQR $.

  ${
    $d x y z R $.
    $( Any relation is a partial ordering of the empty set.  (Contributed by
       NM, 28-Mar-1997.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    po0 $p |- R Po (/) $=
      ( vx vy vz c0 wpo cv wbr wn wa wi wral ral0 df-po mpbir ) EAFBGZPAHIPCGZA
      HQDGZAHJPRAHKJDELCELZBELSBMBCDEANO $.
  $}

  ${
    $d R v w x y z $.  $d S v w z $.  $d X v w y z $.  $d Y x z $.
    $d A v w x z $.  $d B v w x z $.
    pofun.1 $e |- S = { <. x , y >. | X R Y } $.
    pofun.2 $e |- ( x = y -> X = Y ) $.
    $( A function preserves a partial order relation.  (Contributed by Jeff
       Madsen, 18-Jun-2011.) $)
    pofun $p |- ( ( R Po B /\ A. x e. A X e. B ) -> S Po A ) $=
      ( vv vw vz wcel wa cv wbr csb weq cop wpo wn nfcsb1v nfel1 csbeq1a eleq1d
      wral rspc impcom poirr copab df-br eleq2i nfcv nfbr nfv vex breq1d csbief
      csbeq1 syl5eqr breq2d opelopabf 3bitri sylnibr sylan2 w3a com12 3anim123d
      anassrs wi imp adantll potr anbi12i 3imtr4g adantlr syldan ispod ) DEUAZG
      DNZACUGZOZKLMCFVTWBKPZCNZWDWDFQZUBZWBWEOVTAWDGRZDNZWGWEWBWIWAWIAWDCAWHDAW
      DGUCZUDAKSZGWHDAWDGUEZUFUHZUIVTWIOWHWHEQZWFDWHEUJWFWDWDTZFNWOGHEQZABUKZNW
      NWDWDFULFWQWOIUMWPWHHEQZWNABWDWDAWHHEWJAEUNZAHUNZUOZWNBUPKUQZXBWKGWHHEWLU
      RZBKSZHWHWHEXDHABPZGRZWHAXEGHBUQWTJUSZAXEWDGUTVAVBVCVDVEVFVJWCWELPZCNZMPZ
      CNZVGZWIAXHGRZDNZAXJGRZDNZVGZWDXHFQZXHXJFQZOZWDXJFQZVKZWBXLXQVTWBXLXQWBWE
      WIXIXNXKXPWEWBWIWMVHXIWBXNWAXNAXHCAXMDAXHGUCZUDALSZGXMDAXHGUEZUFUHVHXKWBX
      PWAXPAXJCAXODAXJGUCUDAMSGXODAXJGUEUFUHVHVIVLVMVTXQYBWBVTXQOWHXMEQZXMXOEQZ
      OWHXOEQZXTYADWHXMXOEVNXRYFXSYGXRWDXHTZFNYIWQNYFWDXHFULFWQYIIUMWPWRYFABWDX
      HXAYFBUPXBLUQZXCBLSZHXMWHEYKHXFXMXGAXEXHGUTVAVBVCVDXSXHXJTZFNYLWQNYGXHXJF
      ULFWQYLIUMWPXMHEQYGABXHXJAXMHEYCWSWTUOYGBUPYJMUQZYDGXMHEYEURBMSZHXOXMEYNH
      XFXOXGAXEXJGUTVAZVBVCVDVOYAWDXJTZFNYPWQNYHWDXJFULFWQYPIUMWPWRYHABWDXJXAYH
      BUPXBYMXCYNHXOWHEYOVBVCVDVPVQVRVS $.
  $}

  ${
    $d x y R $.  $d x y A $.
    $( A strict linear order is a strict partial order.  (Contributed by NM,
       28-Mar-1997.) $)
    sopo $p |- ( R Or A -> R Po A ) $=
      ( vx vy wor wpo cv wbr weq w3o wral df-so simplbi ) ABEABFCGZDGZBHCDIONBH
      JDAKCAKCDABLM $.
  $}

  ${
    $d x y R $.  $d x y A $.  $d x y B $.
    $( Subset theorem for the strict ordering predicate.  (Contributed by NM,
       16-Mar-1997.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    soss $p |- ( A C_ B -> ( R Or B -> R Or A ) ) $=
      ( vx vy wss wpo cv wbr wral wa wor wcel wi wal ssel anim12d 3imtr4g df-so
      r2al weq w3o poss imim1d 2alimdv ) ABFZBCGZDHZEHZCIDEUAUIUHCIUBZEBJDBJZKA
      CGZUJEAJDAJZKBCLACLUFUGULUKUMABCUCUFUHBMZUIBMZKZUJNZEODOUHAMZUIAMZKZUJNZE
      ODOUKUMUFUQVADEUFUTUPUJUFURUNUSUOABUHPABUIPQUDUEUJDEBBTUJDEAATRQDEBCSDEAC
      SR $.
  $}

  ${
    $d x y R $.  $d x y S $.  $d x y A $.
    $( Equality theorem for the strict ordering predicate.  (Contributed by NM,
       16-Mar-1997.) $)
    soeq1 $p |- ( R = S -> ( R Or A <-> S Or A ) ) $=
      ( vx vy wceq wpo cv wbr w3o wral wa wor poeq1 breq biidd 2ralbidv anbi12d
      3orbi123d df-so 3bitr4g ) BCFZABGZDHZEHZBIZUDUEFZUEUDBIZJZEAKDAKZLACGZUDU
      ECIZUGUEUDCIZJZEAKDAKZLABMACMUBUCUKUJUOABCNUBUIUNDEAAUBUFULUGUGUHUMUDUEBC
      OUBUGPUEUDBCOSQRDEABTDEACTUA $.
  $}

  $( Equality theorem for the strict ordering predicate.  (Contributed by NM,
     16-Mar-1997.) $)
  soeq2 $p |- ( A = B -> ( R Or A <-> R Or B ) ) $=
    ( wceq wor wss wa wi wb soss anim12i eqss dfbi2 3imtr4i bicomd ) ABDZBCEZAC
    EZABFZBAFZGQRHZRQHZGPQRISUATUBABCJBACJKABLQRMNO $.

  $( A strict order relation is irreflexive.  (Contributed by NM,
     24-Nov-1995.) $)
  sonr $p |- ( ( R Or A /\ B e. A ) -> -. B R B ) $=
    ( wor wpo wcel wbr wn sopo poirr sylan ) ACDACEBAFBBCGHACIABCJK $.

  $( A strict order relation is a transitive relation.  (Contributed by NM,
     21-Jan-1996.) $)
  sotr $p |- ( ( R Or A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             ( ( B R C /\ C R D ) -> B R D ) ) $=
    ( wor wpo wcel w3a wbr wa wi sopo potr sylan ) AEFAEGBAHCAHDAHIBCEJCDEJKBDE
    JLAEMABCDENO $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y R $.
    $( A strict order relation is linear (satisfies trichotomy).  (Contributed
       by NM, 21-Jan-1996.) $)
    solin $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B R C \/ B = C \/ C R B ) ) $=
      ( vx vy wcel wa wor wbr wceq w3o cv wi breq1 eqeq1 breq2 3orbi123d imbi2d
      wral eqeq2 wpo df-so rsp2 adantl sylbi com12 vtocl2ga impcom ) BAGCAGHADI
      ZBCDJZBCKZCBDJZLZUJEMZFMZDJZUOUPKZUPUODJZLZNUJBUPDJZBUPKZUPBDJZLZNUJUNNEF
      BCAAUOBKZUTVDUJVEUQVAURVBUSVCUOBUPDOUOBUPPUOBUPDQRSUPCKZVDUNUJVFVAUKVBULV
      CUMUPCBDQUPCBUAUPCBDORSUJUOAGUPAGHZUTUJADUBZUTFATEATZHVGUTNZEFADUCVIVJVHU
      TEFAAUDUEUFUGUHUI $.
  $}

  $( A strict order relation has no 2-cycle loops.  (Contributed by NM,
     21-Jan-1996.) $)
  so2nr $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              -. ( B R C /\ C R B ) ) $=
    ( wor wpo wcel wa wbr wn sopo po2nr sylan ) ADEADFBAGCAGHBCDICBDIHJADKABCDL
    M $.

  $( A strict order relation has no 3-cycle loops.  (Contributed by NM,
     21-Jan-1996.) $)
  so3nr $p |- ( ( R Or A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
             -. ( B R C /\ C R D /\ D R B ) ) $=
    ( wor wpo wcel w3a wbr wn sopo po3nr sylan ) AEFAEGBAHCAHDAHIBCEJCDEJDBEJIK
    AELABCDEMN $.

  $( A strict order relation satisfies strict trichotomy.  (Contributed by NM,
     19-Feb-1996.) $)
  sotric $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B R C <-> -. ( B = C \/ C R B ) ) ) $=
    ( wor wcel wa wceq wo wn wi sonr breq2 notbid syl5ibcom adantrr so2nr imnan
    wbr sylibr con2d jaod w3o solin 3orass df-or bitri sylib impbid con2bid ) A
    DEZBAFZCAFZGGZBCHZCBDSZIZBCDSZUNUQURJZUNUOUSUPUKULUOUSKUMUKULGBBDSZJUOUSABD
    LUOUTURBCBDMNOPUNURUPUNURUPGJURUPJKABCDQURUPRTUAUBUNURUOUPUCZUSUQKZABCDUDVA
    URUQIVBURUOUPUEURUQUFUGUHUIUJ $.

  $( Trichotomy law for strict order relation.  (Contributed by NM,
     9-Apr-1996.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
  sotrieq $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B = C <-> -. ( B R C \/ C R B ) ) ) $=
    ( wor wcel wa wo wceq wn sonr adantrr pm1.2 nsyl breq2 breq1 orbi12d notbid
    wbr syl5ibcom con2d w3o solin 3orass or12 df-or 3bitri sylib impbid con2bid
    wi ) ADEZBAFZCAFZGGZBCDSZCBDSZHZBCIZUOURUSJZUOUSURUOBBDSZVAHZJUSURJUOVAVBUL
    UMVAJUNABDKLVAMNUSVBURUSVAUPVAUQBCBDOBCBDPQRTUAUOUPUSUQUBZUTURUKZABCDUCVCUP
    USUQHHUSURHVDUPUSUQUDUPUSUQUEUSURUFUGUHUIUJ $.

  $( Trichotomy law for strict order relation.  (Contributed by NM,
     5-May-1999.) $)
  sotrieq2 $p |- ( ( R Or A /\ ( B e. A /\ C e. A ) ) ->
              ( B = C <-> ( -. B R C /\ -. C R B ) ) ) $=
    ( wor wcel wa wceq wbr wo wn sotrieq ioran syl6bb ) ADEBAFCAFGGBCHBCDIZCBDI
    ZJKOKPKGABCDLOPMN $.

  $( A transitivity relation.  (Read ` B <_ C ` and ` C < D ` implies
     ` B < D ` .)  (Contributed by Mario Carneiro, 10-May-2013.) $)
  sotr2 $p |- ( ( R Or A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
                ( ( -. C R B /\ C R D ) -> B R D ) ) $=
    ( wor wcel w3a wa wbr wn wceq wo wi sotric ancom2s 3adantr3 con2bid breq1
    wb biimpd a1i sotr exp3a jaod sylbird imp3a ) AEFZBAGZCAGZDAGZHIZCBEJZKZCDE
    JZBDEJZULUNCBLZBCEJZMZUOUPNZULUMUSUHUIUJUMUSKTZUKUHUJUIVAACBEOPQRULUQUTURUQ
    UTNULUQUOUPCBDESUAUBULURUOUPABCDEUCUDUEUFUG $.

  ${
    $d x y R $.  $d x y A $.  $d x y ph $.
    issod.1 $e |- ( ph -> R Po A ) $.
    issod.2 $e |- ( ( ph /\ ( x e. A /\ y e. A ) ) ->
                    ( x R y \/ x = y \/ y R x ) ) $.
    $( An irreflexive, transitive, linear relation is a strict ordering.
       (Contributed by NM, 21-Jan-1996.)  (Revised by Mario Carneiro,
       9-Jul-2014.) $)
    issod $p |- ( ph -> R Or A ) $=
      ( wpo cv wbr weq w3o wral wor ralrimivva df-so sylanbrc ) ADEHBIZCIZEJBCK
      SREJLZCDMBDMDENFATBCDDGOBCDEPQ $.
  $}

  ${
    $d x y z R $.  $d x y z A $.
    issoi.1 $e |- ( x e. A -> -. x R x ) $.
    issoi.2 $e |- ( ( x e. A /\ y e. A /\ z e. A ) ->
                  ( ( x R y /\ y R z ) -> x R z ) ) $.
    issoi.3 $e |- ( ( x e. A /\ y e. A ) -> ( x R y \/ x = y \/ y R x ) ) $.
    $( An irreflexive, transitive, linear relation is a strict ordering.
       (Contributed by NM, 21-Jan-1996.)  (Revised by Mario Carneiro,
       9-Jul-2014.) $)
    issoi $p |- R Or A $=
      ( wor wtru cv wcel wbr wn adantl w3a wa wi ispod weq w3o issod trud ) DEI
      JABDEJABCDEAKZDLZUDUDEMNJFOUEBKZDLZCKZDLPUDUFEMZUFUHEMQUDUHEMRJGOSUEUGQUI
      ABTUFUDEMUAJHOUBUC $.
  $}

  ${
    $d x y z R $.  $d x y z A $.
    isso2i.1 $e |- ( ( x e. A /\ y e. A ) ->
                     ( x R y <-> -. ( x = y \/ y R x ) ) ) $.
    isso2i.2 $e |- ( ( x e. A /\ y e. A /\ z e. A ) ->
                     ( ( x R y /\ y R z ) -> x R z ) ) $.
    $( Deduce strict ordering from its properties.  (Contributed by NM,
       29-Jan-1996.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    isso2i $p |- R Or A $=
      ( cv wcel wbr wn wa weq wo equid orci wb wi eleq1 anbi2d breq1 notbid w3o
      equequ2 orbi12d breq2 bibi12d imbi12d con2bid chvarv mpbii anidms biimprd
      3orass df-or bitri sylibr issoi ) ABCDEAHZDIZUSUSEJZKZUTUTLZAAMZVANZVBVDV
      AAOPUTBHZDIZLZABMZVFUSEJZNZUSVFEJZKZQZRVCVEVBQZRBABAMZVHVCVNVOVPVGUTUTVFU
      SDSTVPVKVEVMVBVPVIVDVJVABAAUDVFUSUSEUAUEVPVLVAVFUSUSEUFUBUGUHVHVLVKFUIZUJ
      UKULGVHVMVKRZVLVIVJUCZVHVKVMVQUMVSVLVKNVRVLVIVJUNVLVKUOUPUQUR $.
  $}

  ${
    $d x y R $.
    $( Any relation is a strict ordering of the empty set.  (Contributed by NM,
       16-Mar-1997.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
    so0 $p |- R Or (/) $=
      ( vx vy c0 wor wpo cv wbr weq w3o wral po0 ral0 df-so mpbir2an ) DAEDAFBG
      ZCGZAHBCIQPAHJCDKZBDKALRBMBCDANO $.
  $}

  ${
    $d x y z A $.  $d x y z R $.
    $( A totally ordered set has at most one minimal element.  (Contributed by
       Mario Carneiro, 24-Jun-2015.)  (Revised by NM, 16-Jun-2017.) $)
    somo $p |- ( R Or A -> E* x e. A A. y e. A -. y R x ) $=
      ( vz wor cv wbr wn wral wa weq wi wrmo wcel breq1 notbid rspcv im2anan9
      wo ancomsd imp ioran w3o solin df-3or or32 bitri sylib syl5bir syl5 exp4b
      ord pm2.43d ralrimivv breq2 ralbidv rmo4 sylibr ) CDFZBGZAGZDHZIZBCJZVAEG
      ZDHZIZBCJZKZAELZMZECJACJVEACNUTVLAECCUTVBCOZVFCOZKZVLUTVOVOVJVKVOVJKVBVFD
      HZIZVFVBDHZIZKZUTVOKZVKVOVJVTVOVIVEVTVMVIVQVNVEVSVHVQBVBCBALVGVPVAVBVFDPQ
      RVDVSBVFCBELVCVRVAVFVBDPQRSUAUBVTVPVRTZIWAVKVPVRUCWAWBVKWAVPVKVRUDZWBVKTZ
      CVBVFDUEWCVPVKTVRTWDVPVKVRUFVPVKVRUGUHUIUMUJUKULUNUOVEVIAECVKVDVHBCVKVCVG
      VBVFVADUPQUQURUS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Founded and well-ordering relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols. $)
  $c Fr $. $( Well-founded predicate symbol (read: 'well-founded'). $)
  $c Se $. $( Set-like predicate symbol (read: 'set-like'). $)
  $c We $. $( Well-ordering predicate symbol (read: 'well-orders') $)

  $( Extend wff notation to include the well-founded predicate.  Read:  ' ` R `
     is a well-founded relation on ` A ` .' $)
  wfr $a wff R Fr A $.

  $( Extend wff notation to include the set-like predicate.  Read:  ' ` R ` is
     set-like on ` A ` .' $)
  wse $a wff R Se A $.

  $( Extend wff notation to include the well-ordering predicate.
     Read:  ' ` R ` well-orders ` A ` .' $)
  wwe $a wff R We A $.

  ${
    $d x y z R $.  $d x y z A $.
    $( Define the well-founded relation predicate.  Definition 6.24(1) of
       [TakeutiZaring] p. 30.  For alternate definitions, see ~ dffr2 and
       ~ dffr3 .  (Contributed by NM, 3-Apr-1994.) $)
    df-fr $a |- ( R Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                E. y e. x A. z e. x -. z R y ) ) $.

    $( Define the set-like predicate.  (Contributed by Mario Carneiro,
       19-Nov-2014.) $)
    df-se $a |- ( R Se A <-> A. x e. A { y e. A | y R x } e. _V ) $.
  $}

  $( Define the well-ordering predicate.  For an alternate definition, see
     ~ dfwe2 .  (Contributed by NM, 3-Apr-1994.) $)
  df-we $a |- ( R We A <-> ( R Fr A /\ R Or A ) ) $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z R $.  $d x y V $.
    $( Property of well-founded relation (one direction of definition).
       (Contributed by NM, 18-Mar-1997.) $)
    fri $p |- ( ( ( B e. C /\ R Fr A ) /\ ( B C_ A /\ B =/= (/) ) ) ->
                E. x e. B A. y e. B -. y R x ) $=
      ( vz wcel wfr wss c0 wne wa cv wbr wn wral wrex wi wal df-fr wceq anbi12d
      sseq1 neeq1 raleq rexeqbi1dv imbi12d spcgv syl5bi imp31 ) DEHZCFIZDCJZDKL
      ZMZBNANFOPZBDQZADRZUMGNZCJZUTKLZMZUQBUTQZAUTRZSZGTULUPUSSZGABCFUAVFVGGDEU
      TDUBZVCUPVEUSVHVAUNVBUOUTDCUDUTDKUEUCVDURAUTDUQBUTDUFUGUHUIUJUK $.

    $( The ` R ` -preimage of an element of the base set in a set-like relation
       is a set.  (Contributed by Mario Carneiro, 19-Nov-2014.) $)
    seex $p |- ( ( R Se A /\ B e. A ) -> { x e. A | x R B } e. _V ) $=
      ( vy wse cv wbr crab cvv wcel wral df-se wceq breq2 rabbidv eleq1d sylanb
      rspccva ) BDFAGZEGZDHZABIZJKZEBLCBKTCDHZABIZJKZEABDMUDUGECBUACNZUCUFJUHUB
      UEABUACTDOPQSR $.

    $( Any relation on a set is set-like on it.  (Contributed by Mario
       Carneiro, 22-Jun-2015.) $)
    exse $p |- ( A e. V -> R Se A ) $=
      ( vy vx wcel cv wbr crab cvv wral wse rabexg ralrimivw df-se sylibr ) ACF
      ZDGEGBHZDAIJFZEAKABLQSEARDACMNEDABOP $.
  $}

  ${
    $d x y z A $.  $d x y z R $.
    $( Alternate definition of well-founded relation.  Similar to Definition
       6.21 of [TakeutiZaring] p. 30.  (Contributed by NM, 17-Feb-2004.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.)  (Proof shortened by
       Mario Carneiro, 23-Jun-2015.) $)
    dffr2 $p |- ( R Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                E. y e. x { z e. x | z R y } = (/) ) ) $=
      ( wfr cv wss c0 wne wa wbr wn wral wrex wi wal crab wceq df-fr rabeq0
      rexbii imbi2i albii bitr4i ) DEFAGZDHUFIJKZCGBGELZMCUFNZBUFOZPZAQUGUHCUFR
      ISZBUFOZPZAQABCDETUNUKAUMUJUGULUIBUFUHCUFUAUBUCUDUE $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    frc.1 $e |- B e. _V $.
    $( Property of well-founded relation (one direction of definition using
       class variables).  (Contributed by NM, 17-Feb-2004.)  (Revised by Mario
       Carneiro, 19-Nov-2014.) $)
    frc $p |- ( ( R Fr A /\ B C_ A /\ B =/= (/) ) ->
                E. x e. B { y e. B | y R x } = (/) ) $=
      ( wfr wss c0 wne w3a cv wbr wn wral wrex crab wceq cvv wcel wa fri mpanl1
      3impb rabeq0 rexbii sylibr ) CEGZDCHZDIJZKBLALEMZNBDOZADPZUKBDQIRZADPUHUI
      UJUMDSTUHUIUJUAUMFABCDSEUBUCUDUNULADUKBDUEUFUG $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z R $.  $d x y S $.
    $( Subset theorem for the well-founded predicate.  Exercise 1 of
       [TakeutiZaring] p. 31.  (Contributed by NM, 3-Apr-1994.)  (Proof
       shortened by Andrew Salmon, 25-Jul-2011.) $)
    frss $p |- ( A C_ B -> ( R Fr B -> R Fr A ) ) $=
      ( vx vz vy wss cv c0 wne wa wbr wn wral wrex wi wal wfr sstr2 df-fr com12
      anim1d imim1d alimdv 3imtr4g ) ABGZDHZBGZUGIJZKZEHFHCLMEUGNFUGOZPZDQUGAGZ
      UIKZUKPZDQBCRACRUFULUODUFUNUJUKUFUMUHUIUMUFUHUGABSUAUBUCUDDFEBCTDFEACTUE
      $.

    $( Subset theorem for the set-like predicate.  (Contributed by Mario
       Carneiro, 24-Jun-2015.) $)
    sess1 $p |- ( R C_ S -> ( S Se A -> R Se A ) ) $=
      ( vy vx wss cv wbr crab cvv wcel wral wi simpl ssbrd ss2rabdv ssexg df-se
      wse wa ex syl ralimdv 3imtr4g ) BCFZDGZEGZCHZDAIZJKZEALUFUGBHZDAIZJKZEALA
      CSABSUEUJUMEAUEULUIFZUJUMMUEUKUHDAUEUFAKZTBCUFUGUEUONOPUNUJUMULUIJQUAUBUC
      EDACREDABRUD $.

    $( Subset theorem for the set-like predicate.  (Contributed by Mario
       Carneiro, 24-Jun-2015.) $)
    sess2 $p |- ( A C_ B -> ( R Se B -> R Se A ) ) $=
      ( vy vx wss cv wbr crab cvv wcel wral wse ssralv wi rabss2 ssexg ex df-se
      syl ralimdv syld 3imtr4g ) ABFZDGEGCHZDBIZJKZEBLZUEDAIZJKZEALZBCMACMUDUHU
      GEALUKUGEABNUDUGUJEAUDUIUFFZUGUJOUEDABPULUGUJUIUFJQRTUAUBEDBCSEDACSUC $.
  $}

  ${
    $d x y z R $.  $d x y z S $.  $d x y z A $.
    $( Equality theorem for the well-founded predicate.  (Contributed by NM,
       9-Mar-1997.) $)
    freq1 $p |- ( R = S -> ( R Fr A <-> S Fr A ) ) $=
      ( vx vz vy wceq cv wss c0 wne wa wbr wn wral wrex wi wal wfr df-fr notbid
      breq rexralbidv imbi2d albidv 3bitr4g ) BCGZDHZAIUHJKLZEHZFHZBMZNZEUHOFUH
      PZQZDRUIUJUKCMZNZEUHOFUHPZQZDRABSACSUGUOUSDUGUNURUIUGUMUQFEUHUHUGULUPUJUK
      BCUBUAUCUDUEDFEABTDFEACTUF $.
  $}

  $( Equality theorem for the well-founded predicate.  (Contributed by NM,
     3-Apr-1994.) $)
  freq2 $p |- ( A = B -> ( R Fr A <-> R Fr B ) ) $=
    ( wceq wfr wss wi eqimss2 frss syl eqimss impbid ) ABDZACEZBCEZMBAFNOGBAHBA
    CIJMABFONGABKABCIJL $.

  $( Equality theorem for the set-like predicate.  (Contributed by Mario
     Carneiro, 24-Jun-2015.) $)
  seeq1 $p |- ( R = S -> ( R Se A <-> S Se A ) ) $=
    ( wceq wse wss wi eqimss2 sess1 syl eqimss impbid ) BCDZABEZACEZMCBFNOGCBHA
    CBIJMBCFONGBCKABCIJL $.

  $( Equality theorem for the set-like predicate.  (Contributed by Mario
     Carneiro, 24-Jun-2015.) $)
  seeq2 $p |- ( A = B -> ( R Se A <-> R Se B ) ) $=
    ( wceq wse wss wi eqimss2 sess2 syl eqimss impbid ) ABDZACEZBCEZMBAFNOGBAHB
    ACIJMABFONGABKABCIJL $.

  ${
    $d y R a b c $.  $d y A a b c $.  $d x y a b c $.
    nffr.r $e |- F/_ x R $.
    nffr.a $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for well-founded relations.
       (Contributed by Stefan O'Rear, 20-Jan-2015.)  (Revised by Mario
       Carneiro, 14-Oct-2016.) $)
    nffr $p |- F/ x R Fr A $=
      ( va vc vb wfr cv wss c0 wne wa wbr wn wral wrex wi nfcv wal nfss nfv nfn
      df-fr nfan nfbr nfral nfrex nfim nfal nfxfr ) BCIFJZBKZUMLMZNZGJZHJZCOZPZ
      GUMQZHUMRZSZFUAAFHGBCUEVCAFUPVBAUNUOAAUMBAUMTZEUBUOAUCUFVAAHUMVDUTAGUMVDU
      SAAUQURCAUQTDAURTUGUDUHUIUJUKUL $.

    $( Bound-variable hypothesis builder for set-like relations.  (Contributed
       by Mario Carneiro, 24-Jun-2015.)  (Revised by Mario Carneiro,
       14-Oct-2016.) $)
    nfse $p |- F/ x R Se A $=
      ( va vb wse cv wbr crab cvv wcel wral df-se nfcv nfbr nfrab nfel1 nfral
      nfxfr ) BCHFIZGIZCJZFBKZLMZGBNAGFBCOUFAGBEAUELUDAFBAUBUCCAUBPDAUCPQERSTUA
      $.

    $( Bound-variable hypothesis builder for well-orderings.  (Contributed by
       Stefan O'Rear, 20-Jan-2015.)  (Revised by Mario Carneiro,
       14-Oct-2016.) $)
    nfwe $p |- F/ x R We A $=
      ( wwe wfr wor wa df-we nffr nfso nfan nfxfr ) BCFBCGZBCHZIABCJOPAABCDEKAB
      CDELMN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( A well-founded relation is irreflexive.  Special case of Proposition
       6.23 of [TakeutiZaring] p. 30.  (Contributed by NM, 2-Jan-1994.)
       (Revised by Mario Carneiro, 22-Jun-2015.) $)
    frirr $p |- ( ( R Fr A /\ B e. A ) -> -. B R B ) $=
      ( vx vy wfr wcel wa cv wbr csn crab c0 wceq wrex wss adantl wral notbid
      wn wne simpl simpr snssd snnzg frc syl3anc wb rabeq0 breq2 ralbidv syl5bb
      snex rexsng breq1 ralsng bitrd mpbid ) ACFZBAGZHZDIZEIZCJZDBKZLMNZEVEOZBB
      CJZTZVAUSVEAPVEMUAZVGUSUTUBVABAUSUTUCUDUTVJUSBAUEQEDAVECBUMUFUGUTVGVIUHUS
      UTVGVBBCJZTZDVERZVIVFVMEBAVFVDTZDVERVCBNZVMVDDVEUIVOVNVLDVEVOVDVKVCBVBCUJ
      SUKULUNVLVIDBAVBBNVKVHVBBBCUOSUPUQQUR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y R $.
    $( A well-founded relation has no 2-cycle loops.  Special case of
       Proposition 6.23 of [TakeutiZaring] p. 30.  (Contributed by NM,
       30-May-1994.)  (Revised by Mario Carneiro, 22-Jun-2015.) $)
    fr2nr $p |- ( ( R Fr A /\ ( B e. A /\ C e. A ) ) ->
                -. ( B R C /\ C R B ) ) $=
      ( vx vy wcel wa wbr wn wo cv wral cvv adantl ad2antrl wceq notbid ralbidv
      breq2 wfr cpr wrex wss wne prex a1i simpl prssi prnzg fri syl22anc rexprg
      c0 wb mpbid wi prid2g ad2antll breq1 syl prid1g orim12d mpd orcomd sylibr
      rspcv ianor ) ADUAZBAGZCAGZHZHZBCDIZJZCBDIZJZKVNVPHJVMVQVOVMELZBDIZJZEBCU
      BZMZVRCDIZJZEWAMZKZVQVOKVMVRFLZDIZJZEWAMZFWAUCZWFVMWANGZVIWAAUDZWAUNUEZWK
      WLVMBCUFUGVIVLUHVLWMVIBCAUIOVJWNVIVKBCAUJPFEAWANDUKULVLWKWFUOVIWJWBWEFBCA
      AWGBQZWIVTEWAWOWHVSWGBVRDTRSWGCQZWIWDEWAWPWHWCWGCVRDTRSUMOUPVMWBVQWEVOVMC
      WAGZWBVQUQVKWQVIVJBCAURUSVTVQECWAVRCQVSVPVRCBDUTRVGVAVMBWAGZWEVOUQVJWRVIV
      KBCAVBPWDVOEBWAVRBQWCVNVRBCDUTRVGVAVCVDVEVNVPVHVF $.
  $}

  ${
    $d x y z R $.
    $( Any relation is well-founded on the empty set.  (Contributed by NM,
       17-Sep-1993.) $)
    fr0 $p |- R Fr (/) $=
      ( vx vz vy c0 wfr cv wss wne wa wbr crab wceq wrex dffr2 ss0 a1d necon1ad
      wi wn imp mpgbir ) EAFBGZEHZUCEIZJCGDGAKCUCLEMDUCNZSBBDCEAOUDUEUFUDUFUCEU
      DUCEMUFTUCPQRUAUB $.
  $}

  ${
    $d A x y z $.  $d R x y z $.  $d ph y z $.  $d ps x z $.
    frminex.1 $e |- A e. _V $.
    frminex.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( If an element of a well-founded set satisfies a property ` ph ` , then
       there is a minimal element that satisfies ` ph ` .  (Contributed by Jeff
       Madsen, 18-Jun-2010.)  (Proof shortened by Mario Carneiro,
       18-Nov-2016.) $)
    frminex $p |- ( R Fr A -> ( E. x e. A ph ->
                      E. x e. A ( ph /\ A. y e. A ( ps -> -. y R x ) ) ) ) $=
      ( vz wrex crab c0 wne cv wbr wn wi wral wa cvv wfr rabn0 wss rabex ssrab2
      wcel fri ralrab rexbii weq breq2 notbid imbi2d ralbidv rexrab2 bitri an4s
      sylib mpanl12 ex syl5bir ) ACEJACEKZLMZEFUAZABDNZCNZFOZPZQZDERZSCEJZACEUB
      VDVCVKVBTUFZVBEUCZVDVCSVKACEGUDACEUEVLVDVMVCVKVLVDSVMVCSSVEINZFOZPZDVBRZI
      VBJZVKIDEVBTFUGVRBVPQZDERZIVBJVKVQVTIVBABVPDCEHUHUIAVTVJICEICUJZVSVIDEWAV
      PVHBWAVOVGVNVFVEFUKULUMUNUOUPURUQUSUTVA $.
  $}

  ${
    $d x A $.
    $( Irreflexivity of the epsilon relation: a class founded by epsilon is not
       a member of itself.  (Contributed by NM, 18-Apr-1994.)  (Revised by
       Mario Carneiro, 22-Jun-2015.) $)
    efrirr $p |- ( _E Fr A -> -. A e. A ) $=
      ( cep wfr wcel wa wbr frirr wb epelg adantl mtbid pm2.01da ) ABCZAADZMNEA
      ABFZNAABGNONHMAAAIJKL $.
  $}

  $( A set founded by epsilon contains no 2-cycle loops.  (Contributed by NM,
     19-Apr-1994.) $)
  efrn2lp $p |- ( ( _E Fr A /\ ( B e. A /\ C e. A ) ) ->
                -. ( B e. C /\ C e. B ) ) $=
    ( cep wfr wcel wa wbr fr2nr wb epelg bi2anan9r adantl mtbid ) ADEZBAFZCAFZG
    ZGBCDHZCBDHZGZBCFZCBFZGZABCDIRUAUDJOQSUBPTUCBCAKCBAKLMN $.

  ${
    $d x y A $.
    $( The epsilon relation is set-like on any class.  (This is the origin of
       the term "set-like": a set-like relation "acts like" the epsilon
       relation of sets and their elements.)  (Contributed by Mario Carneiro,
       22-Jun-2015.) $)
    epse $p |- _E Se A $=
      ( vy vx cep wse cv wbr crab cvv wcel wral cab epel bicomi abbi2i eqeltrri
      vex rabssab ssexi rgenw df-se mpbir ) ADEBFZCFZDGZBAHZIJZCAKUGCAUFUEBLZUD
      UHIUEBUDUEUCUDJBCMNOCQPUEBARSTCBADUAUB $.
  $}

  $( Similar to Theorem 7.2 of [TakeutiZaring] p. 35, of except that the Axiom
     of Regularity is not required due to antecedent ` _E Fr A ` .
     (Contributed by NM, 4-May-1994.) $)
  tz7.2 $p |- ( ( Tr A /\ _E Fr A /\ B e. A ) -> ( B C_ A /\ B =/= A ) ) $=
    ( wtr cep wfr wcel wss wne wa trss wn wceq efrirr eleq1 syl5ibrcom necon2ad
    notbid anim12ii 3impia ) ACZADEZBAFZBAGZBAHZITUBUCUAUDABJUAUBBAUAUBKBALZAAF
    ZKAMUEUBUFBAANQOPRS $.

  ${
    $d x y z A $.
    $( An alternate way of saying that the epsilon relation is well-founded.
       (Contributed by NM, 17-Feb-2004.)  (Revised by Mario Carneiro,
       23-Jun-2015.) $)
    dfepfr $p |- ( _E Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                  E. y e. x ( x i^i y ) = (/) ) ) $=
      ( vz cep wfr cv wss c0 wne wa wbr crab wceq wrex wi wal cin dffr2 wel a1i
      wb epel rabbiia dfin5 eqtr4i eqeq1i rexbii imbi2i albii bitri ) CEFAGZCHU
      LIJKZDGBGZELZDULMZINZBULOZPZAQUMULUNRZINZBULOZPZAQABDCESUSVCAURVBUMUQVABU
      LUPUTIUPDBTZDULMUTUOVDDULUOVDUBDATDBUCUAUDDULUNUEUFUGUHUIUJUK $.
  $}

  ${
    $d x y A $.  $d x y B $.
    epfrc.1 $e |- B e. _V $.
    $( A subset of an epsilon-founded class has a minimal element.
       (Contributed by NM, 17-Feb-2004.)  (Revised by David Abernethy,
       22-Feb-2011.) $)
    epfrc $p |- ( ( _E Fr A /\ B C_ A /\ B =/= (/) ) ->
                  E. x e. B ( B i^i x ) = (/) ) $=
      ( vy cep wfr wss c0 wne w3a cv wbr crab wceq wrex cin frc wcel dfin5 epel
      wb a1i rabbiia eqtr4i eqeq1i rexbii sylibr ) BFGCBHCIJKELZALZFMZECNZIOZAC
      PCUJQZIOZACPAEBCFDRUOUMACUNULIUNUIUJSZECNULECUJTUKUPECUKUPUBUICSEAUAUCUDU
      EUFUGUH $.
  $}

  $( Subset theorem for the well-ordering predicate.  Exercise 4 of
     [TakeutiZaring] p. 31.  (Contributed by NM, 19-Apr-1994.) $)
  wess $p |- ( A C_ B -> ( R We B -> R We A ) ) $=
    ( wss wfr wor wa wwe frss soss anim12d df-we 3imtr4g ) ABDZBCEZBCFZGACEZACF
    ZGBCHACHNOQPRABCIABCJKBCLACLM $.

  $( Equality theorem for the well-ordering predicate.  (Contributed by NM,
     9-Mar-1997.) $)
  weeq1 $p |- ( R = S -> ( R We A <-> S We A ) ) $=
    ( wceq wfr wor wa wwe freq1 soeq1 anbi12d df-we 3bitr4g ) BCDZABEZABFZGACEZ
    ACFZGABHACHNOQPRABCIABCJKABLACLM $.

  $( Equality theorem for the well-ordering predicate.  (Contributed by NM,
     3-Apr-1994.) $)
  weeq2 $p |- ( A = B -> ( R We A <-> R We B ) ) $=
    ( wceq wfr wor wa wwe freq2 soeq2 anbi12d df-we 3bitr4g ) ABDZACEZACFZGBCEZ
    BCFZGACHBCHNOQPRABCIABCJKACLBCLM $.

  $( A well-ordering is well-founded.  (Contributed by NM, 22-Apr-1994.) $)
  wefr $p |- ( R We A -> R Fr A ) $=
    ( wwe wfr wor df-we simplbi ) ABCABDABEABFG $.

  $( A well-ordering is a strict ordering.  (Contributed by NM,
     16-Mar-1997.) $)
  weso $p |- ( R We A -> R Or A ) $=
    ( wwe wfr wor df-we simprbi ) ABCABDABEABFG $.

  $( The elements of an epsilon well-ordering are comparable.  (Contributed by
     NM, 17-May-1994.) $)
  wecmpep $p |- ( ( _E We A /\ ( x e. A /\ y e. A ) ) ->
                 ( x e. y \/ x = y \/ y e. x ) ) $=
    ( cep wwe wor cv wcel wa weq w3o weso solin epel biid 3orbi123i sylib sylan
    wbr ) CDECDFZAGZCHBGZCHIZUAUBHZABJZUBUAHZKZCDLTUCIUAUBDSZUEUBUADSZKUGCUAUBD
    MUHUDUEUEUIUFABNUEOBANPQR $.

  $( An epsilon well-ordering is a transitive relation.  (Contributed by NM,
     22-Apr-1994.) $)
  wetrep $p |- ( ( _E We A /\ ( x e. A /\ y e. A /\ z e. A ) ) ->
             ( ( x e. y /\ y e. z ) -> x e. z ) ) $=
    ( cep wwe cv wcel w3a wa wbr wel wor weso sotr sylan epel anbi12i 3imtr3g
    wi ) DEFZAGZDHBGZDHCGZDHIZJUBUCEKZUCUDEKZJZUBUDEKZABLZBCLZJACLUADEMUEUHUITD
    ENDUBUCUDEOPUFUJUGUKABQBCQRACQS $.

  ${
    $d x y z R $.  $d y z A $.  $d x y z B $.
    $( A non-empty (possibly proper) subclass of a class well-ordered by ` _E `
       has a minimal element.  Special case of Proposition 6.26 of
       [TakeutiZaring] p. 31.  (Contributed by NM, 17-Feb-2004.) $)
    wefrc $p |- ( ( _E We A /\ B C_ A /\ B =/= (/) ) ->
               E. x e. B ( B i^i x ) = (/) ) $=
      ( vy vz cep wwe wss c0 wne cv cin wceq wrex wi wcel wa eqeq1d ex wel wess
      wex n0 ineq2 rspcev adantl inss1 wfr wefr vex inex2 syl3an1 3exp mpi elin
      epfrc anbi1i anass rexbii2 syl6ib adantr wral df-3an 3anrot bitr3i wetrep
      bitri w3a exp3a sylan2b exp44 imp com34 imp3a syl5bi imp4a com23 ralrimdv
      dfss3 syl6ibr dfss in32 eqeq2i biimpi biimprd syl6 reximdvai syld exlimdv
      pm2.61dne syl6com 3imp ) BFGZCBHZCIJZCAKZLZIMZACNZWNWMCFGZWOWSOCBFUAWODKZ
      CPZDUBWTWSDCUCWTXBWSDWTXBWSWTXBQZWSCXALZIXBXDIMZWSOWTXBXEWSWRXEAXACWPXAMW
      QXDIWPXACUDRUESUFXCXDIJZADTZXDWPLZIMZQZACNZWSWTXFXKOXBWTXFXIAXDNZXKWTXDCH
      ZXFXLOCXAUGWTXMXFXLWTCFUHXMXFXLCFUIACXDXACDUJUKUPULUMUNXIXJAXDCWPXDPZXIQW
      PCPZXGQZXIQXOXJQXNXPXIWPCXAUOUQXOXGXIURVGUSUTVAXCXJWRACXCXOXGXIWRXCXOXGXI
      WROZXCXPWQXAHZXQXCXPEDTZEWQVBXRXCXPXSEWQXCEKZWQPZXPXSXCYAXOXGXSYAXTCPZEAT
      ZQXCXOXGXSOZOZXTCWPUOXCYBYCYEXCYBXOYCYDWTXBYBXOYCYDOZOOWTXBYBXOYFXBYBQXOQ
      ZWTYBXOXBVHZYFYGXBYBXOVHYHXBYBXOVCXBYBXOVDVEWTYHQYCXGXSEADCVFVIVJVKVLVMVN
      VOVPVQVREWQXAVSVTXRWRXIXRWQXHIXRWQXHMZXRWQWQXALZMYIWQXAWAYJXHWQCWPXAWBWCV
      GWDRWEWFVIVPWGWHWJSWIVOWKWL $.
  $}

  $( Any relation is a well-ordering of the empty set.  (Contributed by NM,
     16-Mar-1997.) $)
  we0 $p |- R We (/) $=
    ( c0 wwe wfr wor fr0 so0 df-we mpbir2an ) BACBADBAEAFAGBAHI $.

  ${
    $d x y z A $.  $d w x y z B $.  $d w x y z R $.
    $( A subset of a well-ordered set has a unique minimal element.
       (Contributed by NM, 18-Mar-1997.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    wereu $p |- ( ( R We A /\ ( B e. V /\ B C_ A /\ B =/= (/) ) ) ->
                E! x e. B A. y e. B -. y R x ) $=
      ( wwe wcel wss c0 wne w3a wa cv wbr wn wral wrex wi wor wrmo wreu wfr fri
      wefr exp32 expcom 3imp2 sylan simpr2 weso adantr soss sylc somo syl reu5
      sylanbrc ) CEGZDFHZDCIZDJKZLZMZBNANEOPBDQZADRZVEADUAZVEADUBUSCEUCZVCVFCEU
      EVHUTVAVBVFUTVHVAVBVFSSUTVHMVAVBVFABCDFEUDUFUGUHUIVDDETZVGVDVACETZVIUSUTV
      AVBUJUSVJVCCEUKULDCEUMUNABDEUOUPVEADUQUR $.

    $( All nonempty (possibly proper) subclasses of ` A ` , which has a
       well-founded relation ` R ` , have ` R `-minimal elements.  Proposition
       6.26 of [TakeutiZaring] p. 31.  (Contributed by Scott Fenton,
       29-Jan-2011.)  (Revised by Mario Carneiro, 24-Jun-2015.) $)
    wereu2 $p |- ( ( ( R We A /\ R Se A ) /\ ( B C_ A /\ B =/= (/) ) ) ->
                E! x e. B A. y e. B -. y R x ) $=
      ( vz vw wa c0 cv wbr wn wral wrex wcel wi breq1 syl5bi sylc ad2antrr wrmo
      wwe wse wss wne wreu wex n0 crab wceq rabeq0 notbid cbvralv breq2 ralbidv
      weq syl5bb rspcev ex ad2antll cvv simprl simplr sess2 simprr seex syl2anc
      wfr wefr ssrab2 syl5ss fri expr syl21anc rexrab ralrab wor weso soss sotr
      simpr syl13anc ancomsd expdimp an32s con3d idd jad ralimdva reximdva syld
      expimpd pm2.61dne exlimdv impr somo syl reu5 sylanbrc ) CEUBZCEUCZHZDCUDZ
      DIUEZHZHZBJZAJZEKZLZBDMZADNZXKADUAZXKADUFXBXCXDXLXDFJZDOZFUGXBXCHZXLFDUHX
      PXOXLFXBXCXOXLXBXCXOHZHZXLGJZXNEKZGDUIZIYAIUJXTLZGDMZXRXLXTGDUKXOYCXLPXBX
      CXOYCXLXKYCAXNDXKXSXHEKZLZGDMAFUPZYCXJYEBGDBGUPXIYDXGXSXHEQULUMYFYEYBGDYF
      YDXTXHXNXSEUNULUOUQURUSUTRXRYAIUEZXJBYAMZAYANZXLXRYAVAOZCEVHZYACUDZYGYIPX
      RDEUCZXOYJXRXCXAYMXBXCXOVBZWTXAXQVCDCEVDSXBXCXOVEZGDXNEVFVGWTYKXAXQCEVITX
      RYADCXTGDVJYNVKYJYKHYLYGYIABCYAVAEVLVMVNYIXHXNEKZYHHZADNXRXLXTYPYHAGDXSXH
      XNEQVOXRYQXKADXRXHDOZHZYPYHXKYHXGXNEKZXJPZBDMYSYPHZXKXTYTXJBGDXSXGXNEQVPU
      UBUUAXJBDUUBXGDOZHZYTXJXJUUDXIYTYSUUCYPXIYTPYSUUCHZYPXIYTUUEXIYPYTUUEDEVQ
      ZUUCYRXOXIYPHYTPXRUUFYRUUCXRXCCEVQZUUFYNWTUUGXAXQCEVRZTDCEVSZSTYSUUCWAXRY
      RUUCVCXRXOYRUUCYOTDXGXHXNEVTWBWCWDWEWFUUDXJWGWHWIRWLWJRWKWMVMWNRWOXFUUFXM
      XFXCUUGUUFXBXCXDVBWTUUGXAXEUUHTUUISABDEWPWQXKADWRWS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordinals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c Ord $. $( Ordinal predicate $)
  $c On $. $( The class of ordinal numbers $)
  $c Lim $. $( Limit ordinal predicate $)
  $c suc $. $( Successor function (read:  'successor of') $)

  $( Extend the definition of a wff to include the ordinal predicate. $)
  word $a wff Ord A $.

  $( Extend the definition of a class to include the class of all ordinal
     numbers.  (The 0 in the name prevents creating a file called con.html,
     which causes problems in Windows.) $)
  con0 $a class On $.

  $( Extend the definition of a wff to include the limit ordinal predicate. $)
  wlim $a wff Lim A $.

  $( Extend class notation to include the successor function. $)
  csuc $a class suc A $.

  $( Define the ordinal predicate, which is true for a class that is transitive
     and is well-ordered by the epsilon relation.  Variant of definition of
     [BellMachover] p. 468.  (Contributed by NM, 17-Sep-1993.) $)
  df-ord $a |- ( Ord A <-> ( Tr A /\ _E We A ) ) $.

  $( Define the class of all ordinal numbers.  Definition 7.11 of
     [TakeutiZaring] p. 38.  (Contributed by NM, 5-Jun-1994.) $)
  df-on $a |- On = { x | Ord x } $.

  $( Define the limit ordinal predicate, which is true for a non-empty ordinal
     that is not a successor (i.e. that is the union of itself).  Our
     definition combines the definition of Lim of [BellMachover] p. 471 and
     Exercise 1 of [TakeutiZaring] p. 42.  See ~ dflim2 , ~ dflim3 , and dflim4
     for alternate definitions.  (Contributed by NM, 22-Apr-1994.) $)
  df-lim $a |- ( Lim A <-> ( Ord A /\ A =/= (/) /\ A = U. A ) ) $.

  $( Define the successor of a class.  When applied to an ordinal number, the
     successor means the same thing as "plus 1" (see ~ oa1suc ).  Definition
     7.22 of [TakeutiZaring] p. 41, who use "+ 1" to denote this function.  Our
     definition is a generalization to classes.  Although it is not
     conventional to use it with proper classes, it has no effect on a proper
     class ( ~ sucprc ), so that the successor of any ordinal class is still an
     ordinal class ( ~ ordsuc ), simplifying certain proofs.  Some authors
     denote the successor operation with a prime (apostrophe-like) symbol, such
     as Definition 6 of [Suppes] p. 134 and the definition of successor in
     [Mendelson] p. 246 (who uses the symbol "Suc" as a predicate to mean "is a
     successor ordinal").  The definition of successor of [Enderton] p. 68
     denotes the operation with a plus-sign superscript.  (Contributed by NM,
     30-Aug-1993.) $)
  df-suc $a |- suc A = ( A u. { A } ) $.

  $( Equality theorem for the ordinal predicate.  (Contributed by NM,
     17-Sep-1993.) $)
  ordeq $p |- ( A = B -> ( Ord A <-> Ord B ) ) $=
    ( wceq wtr cep wwe wa word treq weeq2 anbi12d df-ord 3bitr4g ) ABCZADZAEFZG
    BDZBEFZGAHBHNOQPRABIABEJKALBLM $.

  ${
    $d x A $.
    $( An ordinal number is an ordinal set.  (Contributed by NM,
       5-Jun-1994.) $)
    elong $p |- ( A e. V -> ( A e. On <-> Ord A ) ) $=
      ( vx cv word con0 ordeq df-on elab2g ) CDZEAECAFBJAGCHI $.
  $}

  ${
    elon.1 $e |- A e. _V $.
    $( An ordinal number is an ordinal set.  (Contributed by NM,
       5-Jun-1994.) $)
    elon $p |- ( A e. On <-> Ord A ) $=
      ( cvv wcel con0 word wb elong ax-mp ) ACDAEDAFGBACHI $.
  $}

  $( An ordinal number has the ordinal property.  (Contributed by NM,
     5-Jun-1994.) $)
  eloni $p |- ( A e. On -> Ord A ) $=
    ( con0 wcel word elong ibi ) ABCADABEF $.

  $( An ordinal number is an ordinal set.  (Contributed by NM, 8-Feb-2004.) $)
  elon2 $p |- ( A e. On <-> ( Ord A /\ A e. _V ) ) $=
    ( con0 wcel word cvv wa eloni elex jca elong biimparc impbii ) ABCZADZAECZF
    MNOAGABHIOMNAEJKL $.

  $( Equality theorem for the limit predicate.  (Contributed by NM,
     22-Apr-1994.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
  limeq $p |- ( A = B -> ( Lim A <-> Lim B ) ) $=
    ( wceq word c0 wne cuni w3a wlim ordeq neeq1 unieq eqeq12d 3anbi123d df-lim
    id 3bitr4g ) ABCZADZAEFZAAGZCZHBDZBEFZBBGZCZHAIBIRSUCTUDUBUFABJABEKRABUAUER
    PABLMNAOBOQ $.

  $( Epsilon well-orders every ordinal.  Proposition 7.4 of [TakeutiZaring]
     p. 36.  (Contributed by NM, 3-Apr-1994.) $)
  ordwe $p |- ( Ord A -> _E We A ) $=
    ( word wtr cep wwe df-ord simprbi ) ABACADEAFG $.

  $( An ordinal class is transitive.  (Contributed by NM, 3-Apr-1994.) $)
  ordtr $p |- ( Ord A -> Tr A ) $=
    ( word wtr cep wwe df-ord simplbi ) ABACADEAFG $.

  $( Epsilon is well-founded on an ordinal class.  (Contributed by NM,
     22-Apr-1994.) $)
  ordfr $p |- ( Ord A -> _E Fr A ) $=
    ( word cep wwe wfr ordwe wefr syl ) ABACDACEAFACGH $.

  $( An element of an ordinal class is a subset of it.  (Contributed by NM,
     30-May-1994.) $)
  ordelss $p |- ( ( Ord A /\ B e. A ) -> B C_ A ) $=
    ( word wtr wcel wss ordtr trss imp sylan ) ACADZBAEZBAFZAGKLMABHIJ $.

  $( A transitive subclass of an ordinal class is ordinal.  (Contributed by NM,
     29-May-1994.) $)
  trssord $p |- ( ( Tr A /\ A C_ B /\ Ord B ) -> Ord A ) $=
    ( wtr wss word w3a cep wwe ordwe wess imp sylan2 anim2i 3impb df-ord sylibr
    wa ) ACZABDZBEZFRAGHZQZAERSTUBSTQUARTSBGHZUABISUCUAABGJKLMNAOP $.

  $( Epsilon irreflexivity of ordinals: no ordinal class is a member of
     itself.  Theorem 2.2(i) of [BellMachover] p. 469, generalized to classes.
     We prove this without invoking the Axiom of Regularity.  (Contributed by
     NM, 2-Jan-1994.) $)
  ordirr $p |- ( Ord A -> -. A e. A ) $=
    ( word cep wfr wcel wn ordfr efrirr syl ) ABACDAAEFAGAHI $.

  $( A member of an ordinal class is not equal to it.  (Contributed by NM,
     25-May-1998.) $)
  nordeq $p |- ( ( Ord A /\ B e. A ) -> A =/= B ) $=
    ( word wcel wne wn wceq ordirr eleq1 notbid syl5ibcom necon2ad imp ) ACZBAD
    ZABENOABNAADZFABGZOFAHQPOABAIJKLM $.

  $( An ordinal class cannot an element of one of its members.  Variant of
     first part of Theorem 2.2(vii) of [BellMachover] p. 469.  (Contributed by
     NM, 3-Apr-1994.) $)
  ordn2lp $p |- ( Ord A -> -. ( A e. B /\ B e. A ) ) $=
    ( word wcel wa ordirr wtr wi ordtr trel syl mtod ) ACZABDBADEZAADZAFMAGNOHA
    IAABJKL $.

  ${
    $d x B $.
    $( A subclass (possibly proper) of an ordinal class has a minimal element.
       Proposition 7.5 of [TakeutiZaring] p. 36.  (Contributed by NM,
       18-Feb-2004.)  (Revised by David Abernethy, 16-Mar-2011.) $)
    tz7.5 $p |- ( ( Ord A /\ B C_ A /\ B =/= (/) ) ->
               E. x e. B ( B i^i x ) = (/) ) $=
      ( word cep wwe wss c0 wne cv cin wceq wrex ordwe wefrc syl3an1 ) BDBEFCBG
      CHICAJKHLACMBNABCOP $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( An element of an ordinal class is ordinal.  Proposition 7.6 of
       [TakeutiZaring] p. 36.  (Contributed by NM, 23-Apr-1994.) $)
    ordelord $p |- ( ( Ord A /\ B e. A ) -> Ord B ) $=
      ( vx vz vy word wcel cv wa wceq eleq1 anbi2d wtr cep wwe wel wal w3a syl
      wi ordeq imbi12d simpll 3anrot 3anass ordtr trel3 syl5bir impl exp3acom23
      bitr3i trel imp31 adantrl simplr ordwe sylan syl13anc ex pm2.43d alrimivv
      wetrep dftr2 sylibr wss trss wess syl5com syld imp df-ord sylanbrc vtoclg
      anabsi7 ) AFZBAGZBFZVOCHZAGZIZVRFZTVOVPIZVQTCBAVRBJZVTWBWAVQWCVSVPVOVRBAK
      LVRBUAUBVTVRMZVRNOZWAVTDEPZECPZIZDCPZTZEQDQWDVTWJDEVTWHWIVTWHWJVTWHIVODHZ
      AGZEHZAGZVSWJVOVSWHUCVOVSWHWLVSWHIZWFWGVSRZVOWLWPVSWFWGRWOVSWFWGUDVSWFWGU
      EUKVOAMZWPWLTAUFZAWKWMVRUGSUHUIVTWGWNWFVOVSWGWNVOWGVSWNVOWQWGVSIWNTWRAWMV
      RULSUJUMUNVOVSWHUOVOANOZWLWNVSRWJAUPZDECAVBUQURUSUTVADEVRVCVDVOVSWEVOVSVR
      AVEZWEVOWQVSXATWRAVRVFSVOWSXAWEWTVRANVGVHVIVJVRVKVLVMVN $.
  $}

  ${
    $d x y $.
    $( The class of all ordinal numbers is transitive.  (Contributed by NM,
       4-May-2009.) $)
    tron $p |- Tr On $=
      ( vx vy con0 wtr cv wss dftr3 wcel word vex elon ordelord sylanb ex ssrdv
      syl6ibr mprgbir ) CDAEZCFACACGRCHZBRCSBEZRHZTIZTCHSUAUBSRIUAUBRAJKRTLMNTB
      JKPOQ $.
  $}

  $( An element of an ordinal class is an ordinal number.  (Contributed by NM,
     26-Oct-2003.) $)
  ordelon $p |- ( ( Ord A /\ B e. A ) -> B e. On ) $=
    ( word wcel wa con0 ordelord wb elong adantl mpbird ) ACZBADZEBFDZBCZABGMNO
    HLBAIJK $.

  $( An element of an ordinal number is an ordinal number.  Theorem 2.2(iii) of
     [BellMachover] p. 469.  (Contributed by NM, 26-Oct-2003.) $)
  onelon $p |- ( ( A e. On /\ B e. A ) -> B e. On ) $=
    ( con0 wcel word eloni ordelon sylan ) ACDAEBADBCDAFABGH $.

  ${
    $d x y A $.  $d x y B $.
    $( Proposition 7.7 of [TakeutiZaring] p. 37.  (Contributed by NM,
       5-May-1994.) $)
    tz7.7 $p |- ( ( Ord A /\ Tr B ) ->
                ( B e. A <-> ( B C_ A /\ B =/= A ) ) ) $=
      ( vx vy word wtr wa wcel wss wne wi cep c0 cv wceq imp32 wn nsyli adantll
      imp wfr ordtr ordfr tz7.2 3exp sylc adantr cdif pssdifn0 wrex difss tz7.5
      cin mp3an2 eldifi trss difin0ss com12 syl56 ad2antrr eleq1 biimpcd eldifn
      syl adantl trel exp3acom23 ex adantld w3o wwe ordwe ssel2 anim12i wecmpep
      syl2an adantlr ecase23d exp44 com34 imp31 ssrdv adantrr ad2antrl eqeltrrd
      eqssd rexlimdvaa syl5 exp4b com23 adantrd pm2.43i syl7 exp4a imp3a impbid
      pm2.43d ) AEZBFZGZBAHZBAIZBAJZGZWRXAXDKZWSWRAFZALUAZXEAUBZAUCXFXGXAXDABUD
      UEUFUGWTXBXCXAWTXBXCXAKWTXBXBXCXAXDABUHZMJZWTXBXABAUIWTXBXJXAKZKZWTWRXLWS
      WTXBWRXKWTXBWRXJXAWRXJGXICNZUMMOZCXIUJZWTXBGZXAWRXIAIXJXOABUKCAXIULUNXPXN
      XACXIXPXMXIHZXNGGZXMBAXRXMBXPXQXNXMBIZWRXQXNXSKZKZWSXBWRXFYAXHXQXMAHZXFXM
      AIZXTXMABUOZAXMUPXNYCXSABXMUQURUSVDUTPXPXQBXMIXNXPXQGDBXMWTXBXQDNZBHZYEXM
      HZKWTXBYFXQYGWTXBYFXQYGWTXBYFGZXQGZGYGYEXMOZXMYEHZYIYJQZWTYFXQYLXBYFXQYLY
      FYJXMBHZXQYJYFYMYEXMBVAVBXMABVCZRTSVEWSYIYKQZWRWSYHXQYOWSYFXQYOKZXBWSYFYP
      WSYFGYKYMXQWSYFYKYMKWSYKYFYMBXMYEVFVGTYNRVHVIPSWRYIYGYJYKVJZWSWRALVKYEAHZ
      YBGYQYIAVLYHYRXQYBBAYEVMYDVNDCAVOVPVQVRVSVTWAWBWCWFXQYBXPXNYDWDWEWGWHWIWJ
      WKWLWMWNWQWOWP $.
  $}

  $( Corollary 7.8 of [TakeutiZaring] p. 37.  (Contributed by NM,
     25-Nov-1995.) $)
  ordelssne $p |- ( ( Ord A /\ Ord B ) ->
              ( A e. B <-> ( A C_ B /\ A =/= B ) ) ) $=
    ( word wcel wss wne wa wb wtr ordtr tz7.7 sylan2 ancoms ) BCZACZABDABEABFGH
    ZONAIPAJBAKLM $.

  $( Corollary 7.8 of [TakeutiZaring] p. 37.  (Contributed by NM,
     17-Jun-1998.) $)
  ordelpss $p |- ( ( Ord A /\ Ord B ) -> ( A e. B <-> A C. B ) ) $=
    ( word wa wcel wss wne wpss ordelssne df-pss syl6bbr ) ACBCDABEABFABGDABHAB
    IABJK $.

  $( For ordinal classes, subclass is equivalent to membership or equality.
     (Contributed by NM, 25-Nov-1995.)  (Proof shortened by Andrew Salmon,
     25-Jul-2011.) $)
  ordsseleq $p |- ( ( Ord A /\ Ord B ) ->
                  ( A C_ B <-> ( A e. B \/ A = B ) ) ) $=
    ( word wa wcel wceq wo wpss wss ordelpss orbi1d sspss syl6rbbr ) ACBCDZABEZ
    ABFZGABHZPGABINOQPABJKABLM $.

  $( The intersection of two ordinal classes is ordinal.  Proposition 7.9 of
     [TakeutiZaring] p. 37.  (Contributed by NM, 9-May-1994.) $)
  ordin $p |- ( ( Ord A /\ Ord B ) -> Ord ( A i^i B ) ) $=
    ( word cin wtr ordtr trin syl2an wss inss2 trssord mp3an2 sylancom ) ACZBCZ
    ABDZEZPCZNAEBEQOAFBFABGHQPBIORABJPBKLM $.

  ${
    $d x y A $.  $d x y B $.
    $( The intersection of two ordinal numbers is an ordinal number.
       (Contributed by NM, 7-Apr-1995.) $)
    onin $p |- ( ( A e. On /\ B e. On ) -> ( A i^i B ) e. On ) $=
      ( con0 wcel wa cin word eloni ordin syl2an cvv wb simpl inex1g elong 3syl
      mpbird ) ACDZBCDZEZABFZCDZUAGZRAGBGUCSAHBHABIJTRUAKDUBUCLRSMABCNUAKOPQ $.
  $}

  $( A trichotomy law for ordinals.  Proposition 7.10 of [TakeutiZaring]
     p. 38.  (Contributed by NM, 10-May-1994.)  (Proof shortened by Andrew
     Salmon, 25-Jul-2011.) $)
  ordtri3or $p |- ( ( Ord A /\ Ord B ) -> ( A e. B \/ A = B \/ B e. A ) ) $=
    ( word wa wcel wceq w3o wpss wss wo ordin sylib inss1 ordsseleq mpbii sylan
    cin wn ord df-ss ordirr syl ianor elin incom eleq1i anbi2i xchnxbir anabss1
    bitri syl6ibr anabss4 orim12d mpd sspsstri ordelpss ancoms 3orbi123d mpbird
    biidd wb ) ACZBCZDZABEZABFZBAEZGABHZVFBAHZGZVDABIZBAIZJZVJVDABQZAEZRZBAQZBE
    ZRZJZVMVDVNVNEZRZVTVDVNCZWBABKZVNUAUBVOVRDZVTWAVOVRUCWAVOVNBEZDWEVNABUDWFVR
    VOVNVQBABUEUFUGUJUHLVDVPVKVSVLVDVPVNAFZVKVDVOWGVBVCVOWGJZVDWCVBWHWDWCVBDVNA
    IWHABMVNANOPUISABTUKVDVSVQBFZVLVDVRWIVBVCVRWIJZVCVBDVQCZVCWJBAKWKVCDVQBIWJB
    AMVQBNOPULSBATUKUMUNABUOLVDVEVHVFVFVGVIABUPVDVFUTVCVBVGVIVABAUPUQURUS $.

  $( A trichotomy law for ordinals.  (Contributed by NM, 25-Mar-1995.)  (Proof
     shortened by Andrew Salmon, 25-Jul-2011.) $)
  ordtri1 $p |- ( ( Ord A /\ Ord B ) -> ( A C_ B <-> -. B e. A ) ) $=
    ( word wa wss wcel wceq wo wn ordsseleq wi imnan sylibr ordirr eleq2 notbid
    ordn2lp syl5ibrcom jaao w3o ordtri3or df-3or sylib orcomd ord impbid bitrd
    ) ACZBCZDZABEABFZABGZHZBAFZIZABJUJUMUOUHUKUOUIULUHUKUNDIUKUOKABQUKUNLMUIUOU
    LBBFZIBNULUNUPABBOPRSUJUNUMUJUMUNUJUKULUNTUMUNHABUAUKULUNUBUCUDUEUFUG $.

  $( A trichotomy law for ordinal numbers.  (Contributed by NM, 6-Nov-2003.) $)
  ontri1 $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B <-> -. B e. A ) ) $=
    ( con0 wcel word wss wn wb eloni ordtri1 syl2an ) ACDAEBEABFBADGHBCDAIBIABJ
    K $.

  $( A trichotomy law for ordinals.  (Contributed by NM, 25-Nov-1995.) $)
  ordtri2 $p |- ( ( Ord A /\ Ord B ) ->
               ( A e. B <-> -. ( A = B \/ B e. A ) ) ) $=
    ( word wa wceq wcel wo wn wb wss ordsseleq eqcom orbi2i orcom bitri ordtri1
    syl6bb bitr3d ancoms con2bid ) ACZBCZDABEZBAFZGZABFZUBUAUEUFHZIUBUADZBAJZUE
    UGUHUIUDBAEZGZUEBAKUKUDUCGUEUJUCUDBALMUDUCNOQBAPRST $.

  $( A trichotomy law for ordinals.  (Contributed by NM, 18-Oct-1995.)  (Proof
     shortened by Andrew Salmon, 25-Jul-2011.) $)
  ordtri3 $p |- ( ( Ord A /\ Ord B ) ->
               ( A = B <-> -. ( A e. B \/ B e. A ) ) ) $=
    ( word wa wceq wcel wo wn ordirr eleq2 notbid syl5ib syl5ibr anim12d pm4.56
    com12 syl6ib w3o ordtri3or sylib df-3or or32 ord impbid ) ACZBCZDZABEZABFZB
    AFZGZHZUGUHUIHZUJHZDZULUHUGUOUHUEUMUFUNUEAAFZHUHUMAIUHUPUIABAJKLUFUNUHBBFZH
    BIUHUJUQABBJKMNPUIUJOQUGUKUHUGUIUHGUJGZUKUHGUGUIUHUJRURABSUIUHUJUATUIUHUJUB
    TUCUD $.

  $( A trichotomy law for ordinals.  (Contributed by NM, 1-Nov-2003.)  (Proof
     shortened by Andrew Salmon, 25-Jul-2011.) $)
  ordtri4 $p |- ( ( Ord A /\ Ord B ) ->
               ( A = B <-> ( A C_ B /\ -. A e. B ) ) ) $=
    ( wceq wss wa word wcel wn eqss wb ordtri1 ancoms anbi2d syl5bb ) ABCABDZBA
    DZEAFZBFZEZOABGHZEABISPTORQPTJBAKLMN $.

  $( An ordinal class and its singleton are disjoint.  (Contributed by NM,
     19-May-1998.) $)
  orddisj $p |- ( Ord A -> ( A i^i { A } ) = (/) ) $=
    ( word wcel wn csn cin c0 wceq ordirr disjsn sylibr ) ABAACDAAEFGHAIAAJK $.

  ${
    $d x y z $.
    $( The ordinal class is well-founded.  This lemma is needed for ~ ordon in
       order to eliminate the need for the Axiom of Regularity.  (Contributed
       by NM, 17-May-1994.) $)
    onfr $p |- _E Fr On $=
      ( vx vz vy con0 cep wfr cv wss c0 wne wa cin wceq wrex dfepfr wcel eqeq1d
      wi syl adantr wex ineq2 rspcev adantll inss1 word ssel2 eloni ordfr inss2
      n0 vex inex1 epfrc mp3an2 sylan wb inass simpr sseldi ordelss dfss1 sylib
      syl2anc ineq2d syl5eq rexbidva mpbid ssrexv pm2.61dane exlimdv syl5bi imp
      mpsyl ex mpgbir ) DEFAGZDHZVQIJZKVQBGZLZIMZBVQNZRAABDOVRVSWCVSCGZVQPZCUAV
      RWCCVQUKVRWEWCCVRWEWCVRWEKZWCVQWDLZIWEWGIMZWCVRWBWHBWDVQVTWDMWAWGIVTWDVQU
      BQUCUDWGVQHWFWGIJZKZWBBWGNZWCVQWDUEWJWGVTLZIMZBWGNZWKWFWDEFZWIWNWFWDUFZWO
      WFWDDPWPVQDWDUGWDUHSZWDUISWOWGWDHWIWNVQWDUJZBWDWGVQWDAULUMUNUOUPWFWNWKUQW
      IWFWMWBBWGWFVTWGPZKZWLWAIWTWLVQWDVTLZLWAVQWDVTURWTXAVTVQWTVTWDHZXAVTMWTWP
      VTWDPXBWFWPWSWQTWTWGWDVTWRWFWSUSUTWDVTVAVDVTWDVBVCVEVFQVGTVHWBBWGVQVIVNVJ
      VOVKVLVMVP $.
  $}

  $( Relationship between membership and proper subset of an ordinal number.
     (Contributed by NM, 15-Sep-1995.) $)
  onelpss $p |- ( ( A e. On /\ B e. On ) ->
               ( A e. B <-> ( A C_ B /\ A =/= B ) ) ) $=
    ( con0 wcel word wss wne wa wb eloni ordelssne syl2an ) ACDAEBEABDABFABGHIB
    CDAJBJABKL $.

  $( Relationship between subset and membership of an ordinal number.
     (Contributed by NM, 15-Sep-1995.) $)
  onsseleq $p |- ( ( A e. On /\ B e. On ) ->
                 ( A C_ B <-> ( A e. B \/ A = B ) ) ) $=
    ( con0 wcel word wss wceq wo wb eloni ordsseleq syl2an ) ACDAEBEABFABDABGHI
    BCDAJBJABKL $.

  $( An element of an ordinal number is a subset of the number.  (Contributed
     by NM, 5-Jun-1994.)  (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
  onelss $p |- ( A e. On -> ( B e. A -> B C_ A ) ) $=
    ( con0 wcel word wss wi eloni ordelss ex syl ) ACDAEZBADZBAFZGAHLMNABIJK $.

  $( Transitive law for ordinal classes.  (Contributed by NM, 12-Dec-2004.) $)
  ordtr1 $p |- ( Ord C -> ( ( A e. B /\ B e. C ) -> A e. C ) ) $=
    ( word wtr wcel wa wi ordtr trel syl ) CDCEABFBCFGACFHCICABJK $.

  $( Transitive law for ordinal classes.  (Contributed by NM, 12-Dec-2004.)
     (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
  ordtr2 $p |- ( ( Ord A /\ Ord C ) -> ( ( A C_ B /\ B e. C ) -> A e. C ) ) $=
    ( word wa wss wcel wpss wi ordelord ex ancld anc2li ordelpss ancoms sspsstr
    wb expcom syl6bi com23 imp32 com12 syl9 imp3a adantl sylibrd ) ADZCDZEABFZB
    CGZEZACHZACGUHUKULIUGUHUIUJULUHUJUHUJBDZEZEZUIULUHUJUNUHUJUMUHUJUMCBJKLMUOU
    IULUHUJUMUIULIZUHUMUJUPUHUMUJUPIUHUMEUJBCHZUPUMUHUJUQQBCNOUIUQULABCPRSKTUAU
    BUCUDUEACNUF $.

  $( Transitive law for ordinal classes.  (Contributed by Mario Carneiro,
     30-Dec-2014.) $)
  ordtr3 $p |- ( ( Ord B /\ Ord C ) -> ( A e. B -> ( A e. C \/ C e. B ) ) ) $=
    ( word wa wcel wo wss simplr ordelord adantlr ordtri1 syl2anc ordtr2 ancoms
    wn wb wi ancomsd expdimp sylbird orrd ex ) BDZCDZEZABFZACFZCBFZGUFUGEZUHUIU
    JUHPZCAHZUIUJUEADZULUKQUDUEUGIUDUGUMUEBAJKCALMUFUGULUIUFULUGUIUEUDULUGEUIRC
    ABNOSTUAUBUC $.

  $( Transitive law for ordinal numbers.  Theorem 7M(b) of [Enderton] p. 192.
     (Contributed by NM, 11-Aug-1994.) $)
  ontr1 $p |- ( C e. On -> ( ( A e. B /\ B e. C ) -> A e. C ) ) $=
    ( con0 wcel word wa wi eloni ordtr1 syl ) CDECFABEBCEGACEHCIABCJK $.

  $( Transitive law for ordinal numbers.  Exercise 3 of [TakeutiZaring] p. 40.
     (Contributed by NM, 6-Nov-2003.) $)
  ontr2 $p |- ( ( A e. On /\ C e. On ) ->
              ( ( A C_ B /\ B e. C ) -> A e. C ) ) $=
    ( con0 wcel word wss wa wi eloni ordtr2 syl2an ) ADEAFCFABGBCEHACEICDEAJCJA
    BCKL $.

  ${
    $d x y A $.  $d x y B $.
    $( The union of an ordinal stays the same if a subset equal to one of its
       elements is removed.  (Contributed by NM, 10-Dec-2004.) $)
    ordunidif $p |- ( ( Ord A /\ B e. A ) -> U. ( A \ B ) = U. A ) $=
      ( vx vy word wcel wa cv wss cdif wrex wi syl wn eldif adantl sseq2 rspcev
      cuni syl6 wral wceq con0 ordelon onelss eloni ordirr simplbi2 syl5 jctild
      mpd adantr biimpri ssid jctir ex pm2.61d ralrimiva unidif ) AEZBAFZGZCHZD
      HZIZDABJZKZCAUAVFSASUBVBVGCAVBVCAFZGZVCBFZVGVIVJBVFFZVCBIZGZVGVBVJVMLVHVB
      VJVLVKVBBUCFZVJVLLABUDZBVCUEMVBVNVKVOVAVNVKLUTVNBBFNZVAVKVNBEVPBUFBUGMVKV
      AVPBABOUHUIPUKUJULVEVLDBVFVDBVCQRTVHVJNZVGLVBVHVQVCVFFZVCVCIZGZVGVHVQVTVH
      VQGZVRVSVRWAVCABOUMVCUNUOUPVEVSDVCVFVDVCVCQRTPUQURCDABUSM $.

    $( If ` B ` is smaller than ` A ` , then it equals the intersection of the
       difference.  Exercise 11 in [TakeutiZaring] p. 44.  (Contributed by
       Andrew Salmon, 14-Nov-2011.) $)
    ordintdif $p |- ( ( Ord A /\ Ord B /\ ( A \ B ) =/= (/) )
      -> B = |^| ( A \ B ) ) $=
      ( vx cdif c0 wne word wss wn cint wceq ssdif0 necon3bbii w3a cv wcel crab
      dfdif2 wa ordtri1 inteqi con2bid wb ordelord ancoms sylan bicomd rabbidva
      an32s inteqd intmin sylan9eq ex sylbird 3impia syl5req syl3an3br ) ABDZEF
      AGZBGZABHZIZBURJZKVAUREABLMUSUTVBNVCCOZBPIZCAQZJZBURVFCABRUAUSUTVBVGBKZUS
      UTSZVBBAPZVHVIVAVJABTUBVIVJVHVIVJVGBVDHZCAQZJBVIVFVLVIVEVKCAVIVDAPZSVKVEU
      SVMUTVKVEUCZUSVMSVDGZUTVNAVDUDUTVOVNBVDTUEUFUIUGUHUJCBAUKULUMUNUOUPUQ $.
  $}

  ${
    $d x ps $.  $d x A $.
    onintss.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( If a property is true for an ordinal number, then the minimum ordinal
       number for which it is true is smaller or equal.  Theorem Schema 61 of
       [Suppes] p. 228.  (Contributed by NM, 3-Oct-2003.) $)
    onintss $p |- ( A e. On -> ( ps -> |^| { x e. On | ph } C_ A ) ) $=
      ( con0 wcel crab cint wss intminss ex ) DFGBACFHIDJABCDFEKL $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A way to show that an ordinal number equals the minimum of a collection
       of ordinal numbers: it must be in the collection, and it must not be
       larger than any member of the collection.  (Contributed by NM,
       14-Nov-2003.) $)
    oneqmini $p |- ( B C_ On -> ( ( A e. B /\ A. x e. A -. x e. B )
                    -> A = |^| B ) ) $=
      ( con0 wss wcel cv wn wral wa cint wceq ssint wi ssel anim12d ontri1 syl6
      wb expdimp pm5.74d con2b syl6bb syl5bb biimprd expimpd intss1 a1i adantrd
      ralbidv2 jcad eqss syl6ibr ) CDEZBCFZAGZCFZHZABIZJZBCKZEZVABEZJBVALUNUTVB
      VCUNUOUSVBUNUOJZVBUSVBBUPEZACIVDUSABCMVDVEURACBVDUQVENUQUPBFZHZNVFURNVDUQ
      VEVGUNUOUQVEVGSZUNUOUQJBDFZUPDFZJVHUNUOVIUQVJCDBOCDUPOPBUPQRTUAUQVFUBUCUJ
      UDUEUFUNUOVCUSUOVCNUNBCUGUHUIUKBVAULUM $.
  $}

  $( The empty set is an ordinal class.  (Contributed by NM, 11-May-1994.) $)
  ord0 $p |- Ord (/) $=
    ( c0 word wtr cep wwe tr0 we0 df-ord mpbir2an ) ABACADEFDGAHI $.

  $( The empty set is an ordinal number.  Corollary 7N(b) of [Enderton]
     p. 193.  (Contributed by NM, 17-Sep-1993.) $)
  0elon $p |- (/) e. On $=
    ( c0 con0 wcel word ord0 0ex elon mpbir ) ABCADEAFGH $.

  $( A non-empty ordinal contains the empty set.  (Contributed by NM,
     25-Nov-1995.) $)
  ord0eln0 $p |- ( Ord A -> ( (/) e. A <-> A =/= (/) ) ) $=
    ( word c0 wcel wne ne0i wceq wn df-ne wo ord0 wa noel ordtri2 con2bid mpan2
    mpbiri ord syl5bi impbid2 ) ABZCADZACEZACFUCACGZHUAUBACIUAUDUBUACBZUDUBJZKU
    AUELZUFACDZHAMUGUHUFACNOQPRST $.

  $( An ordinal number contains zero iff it is nonzero.  (Contributed by NM,
     6-Dec-2004.) $)
  on0eln0 $p |- ( A e. On -> ( (/) e. A <-> A =/= (/) ) ) $=
    ( con0 wcel word c0 wne wb eloni ord0eln0 syl ) ABCADEACAEFGAHAIJ $.

  $( An alternate definition of a limit ordinal.  (Contributed by NM,
     4-Nov-2004.) $)
  dflim2 $p |- ( Lim A <-> ( Ord A /\ (/) e. A /\ A = U. A ) ) $=
    ( wlim word c0 wne cuni wceq w3a wcel df-lim ord0eln0 anbi1d pm5.32i 3anass
    wa 3bitr4i bitr4i ) ABACZADEZAAFGZHZRDAIZTHZAJRUBTOZORSTOZOUCUARUDUERUBSTAK
    LMRUBTNRSTNPQ $.

  $( The intersection of the class of ordinal numbers is the empty set.
     (Contributed by NM, 20-Oct-2003.) $)
  inton $p |- |^| On = (/) $=
    ( c0 con0 wcel cint wceq 0elon int0el ax-mp ) ABCBDAEFBGH $.

  $( The empty set is not a limit ordinal.  (Contributed by NM, 24-Mar-1995.)
     (Proof shortened by Andrew Salmon, 25-Jul-2011.) $)
  nlim0 $p |- -. Lim (/) $=
    ( c0 wlim word wcel cuni wceq w3a noel simp2 mto dflim2 mtbir ) ABACZAADZAA
    EFZGZPNAHMNOIJAKL $.

  $( A limit ordinal is ordinal.  (Contributed by NM, 4-May-1995.) $)
  limord $p |- ( Lim A -> Ord A ) $=
    ( wlim word c0 wne cuni wceq df-lim simp1bi ) ABACADEAAFGAHI $.

  $( A limit ordinal is its own supremum (union).  (Contributed by NM,
     4-May-1995.) $)
  limuni $p |- ( Lim A -> A = U. A ) $=
    ( wlim word c0 wne cuni wceq df-lim simp3bi ) ABACADEAAFGAHI $.

  $( The union of a limit ordinal is a limit ordinal.  (Contributed by NM,
     19-Sep-2006.) $)
  limuni2 $p |- ( Lim A -> Lim U. A ) $=
    ( wlim cuni wceq wb limuni limeq syl ibi ) ABZACZBZJAKDJLEAFAKGHI $.

  $( A limit ordinal contains the empty set.  (Contributed by NM,
     15-May-1994.) $)
  0ellim $p |- ( Lim A -> (/) e. A ) $=
    ( wlim c0 wcel wne wceq nlim0 limeq mtbiri necon2ai word wb limord ord0eln0
    syl mpbird ) ABZCADZACEZQACACFQCBGACHIJQAKRSLAMANOP $.

  $( A limit ordinal class that is also a set is an ordinal number.
     (Contributed by NM, 26-Apr-2004.) $)
  limelon $p |- ( ( A e. B /\ Lim A ) -> A e. On ) $=
    ( wcel wlim con0 word limord elong syl5ibr imp ) ABCZADZAECZLMKAFAGABHIJ $.

  $( The class of all ordinal numbers in not empty.  (Contributed by NM,
     17-Sep-1995.) $)
  onn0 $p |- On =/= (/) $=
    ( c0 con0 wcel wne 0elon ne0i ax-mp ) ABCBADEBAFG $.

  $( Equality of successors.  (Contributed by NM, 30-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 25-Jul-2011.) $)
  suceq $p |- ( A = B -> suc A = suc B ) $=
    ( wceq csn cun csuc id sneq uneq12d df-suc 3eqtr4g ) ABCZAADZEBBDZEAFBFLABM
    NLGABHIAJBJK $.

  $( Membership in a successor.  This one-way implication does not require that
     either ` A ` or ` B ` be sets.  (Contributed by NM, 6-Jun-1994.) $)
  elsuci $p |- ( A e. suc B -> ( A e. B \/ A = B ) ) $=
    ( csuc wcel csn wo wceq cun df-suc eleq2i elun bitri elsni orim2i sylbi ) A
    BCZDZABDZABEZDZFZRABGZFQABSHZDUAPUCABIJABSKLTUBRABMNO $.

  $( Membership in a successor.  Exercise 5 of [TakeutiZaring] p. 17.
     (Contributed by NM, 15-Sep-1995.) $)
  elsucg $p |- ( A e. V -> ( A e. suc B <-> ( A e. B \/ A = B ) ) ) $=
    ( csuc wcel csn wo wceq cun df-suc eleq2i elun bitri elsncg orbi2d syl5bb )
    ABDZEZABEZABFZEZGZACEZSABHZGRABTIZEUBQUEABJKABTLMUCUAUDSABCNOP $.

  $( Variant of membership in a successor, requiring that ` B ` rather than
     ` A ` be a set.  (Contributed by NM, 28-Oct-2003.) $)
  elsuc2g $p |- ( B e. V -> ( A e. suc B <-> ( A e. B \/ A = B ) ) ) $=
    ( csuc wcel csn cun wceq wo df-suc eleq2i elun elsnc2g orbi2d syl5bb ) ABDZ
    EABBFZGZEZBCEZABEZABHZIZPRABJKSUAAQEZITUCABQLTUDUBUAABCMNOO $.

  ${
    elsuc.1 $e |- A e. _V $.
    $( Membership in a successor.  Exercise 5 of [TakeutiZaring] p. 17.
       (Contributed by NM, 15-Sep-2003.) $)
    elsuc $p |- ( A e. suc B <-> ( A e. B \/ A = B ) ) $=
      ( cvv wcel csuc wceq wo wb elsucg ax-mp ) ADEABFEABEABGHICABDJK $.

    $( Membership in a successor.  (Contributed by NM, 15-Sep-2003.) $)
    elsuc2 $p |- ( B e. suc A <-> ( B e. A \/ B = A ) ) $=
      ( cvv wcel csuc wceq wo wb elsuc2g ax-mp ) ADEBAFEBAEBAGHICBADJK $.
  $}

  ${
    $d y A $.  $d x y $.
    nfsuc.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for successor.  (Contributed by NM,
       15-Sep-2003.) $)
    nfsuc $p |- F/_ x suc A $=
      ( csuc csn cun df-suc nfsn nfun nfcxfr ) ABDBBEZFBGABKCABCHIJ $.
  $}

  $( Membership in a successor.  (Contributed by NM, 20-Jun-1998.) $)
  elelsuc $p |- ( A e. B -> A e. suc B ) $=
    ( wcel csuc wceq wo orc elsucg mpbird ) ABCZABDCJABEZFJKGABBHI $.

  ${
    $d x y A $.  $d x B $.
    $( Membership of a successor in another class.  (Contributed by NM,
       29-Jun-2004.) $)
    sucel $p |- ( suc A e. B <->
                E. x e. B A. y ( y e. x <-> ( y e. A \/ y = A ) ) ) $=
      ( csuc wcel cv wceq wrex wo wb wal risset dfcleq elsuc bibi2i albii bitri
      vex rexbii ) CEZDFAGZUAHZADIBGZUBFZUDCFUDCHJZKZBLZADIAUADMUCUHADUCUEUDUAF
      ZKZBLUHBUBUANUJUGBUIUFUEUDCBSOPQRTR $.
  $}

  $( The successor of the empty set.  (Contributed by NM, 1-Feb-2005.) $)
  suc0 $p |- suc (/) = { (/) } $=
    ( c0 csuc csn cun df-suc uncom un0 3eqtri ) ABAACZDIADIAEAIFIGH $.

  $( A proper class is its own successor.  (Contributed by NM, 3-Apr-1995.) $)
  sucprc $p |- ( -. A e. _V -> suc A = A ) $=
    ( cvv wcel wn csuc cun csn df-suc wceq snprc uneq2 sylbi syl5eq un0 syl6eq
    c0 ) ABCDZAEZAPFZAQRAAGZFZSAHQTPIUASIAJTPAKLMANO $.

  ${
    unisuc.1 $e |- A e. _V $.
    $( A transitive class is equal to the union of its successor.  Combines
       Theorem 4E of [Enderton] p. 72 and Exercise 6 of [Enderton] p. 73.
       (Contributed by NM, 30-Aug-1993.) $)
    unisuc $p |- ( Tr A <-> U. suc A = A ) $=
      ( cuni wss cun wceq wtr csuc ssequn1 df-tr csn df-suc unieqi uniun uneq2i
      unisn 3eqtri eqeq1i 3bitr4i ) ACZADTAEZAFAGAHZCZAFTAIAJUCUAAUCAAKZEZCTUDC
      ZEUAUBUEALMAUDNUFATABPOQRS $.
  $}

  $( A class is included in its own successor.  Part of Proposition 7.23 of
     [TakeutiZaring] p. 41 (generalized to arbitrary classes).  (Contributed by
     NM, 31-May-1994.) $)
  sssucid $p |- A C_ suc A $=
    ( csn cun csuc ssun1 df-suc sseqtr4i ) AAABZCADAHEAFG $.

  $( Part of Proposition 7.23 of [TakeutiZaring] p. 41 (generalized).
     (Contributed by NM, 25-Mar-1995.)  (Proof shortened by Scott Fenton,
     20-Feb-2012.) $)
  sucidg $p |- ( A e. V -> A e. suc A ) $=
    ( wcel csuc wceq wo eqid olci elsucg mpbiri ) ABCAADCAACZAAEZFLKAGHAABIJ $.

  ${
    sucid.1 $e |- A e. _V $.
    $( A set belongs to its successor.  (Contributed by NM, 22-Jun-1994.)
       (Proof shortened by Alan Sare, 18-Feb-2012.)  (Proof shortened by Scott
       Fenton, 20-Feb-2012.) $)
    sucid $p |- A e. suc A $=
      ( cvv wcel csuc sucidg ax-mp ) ACDAAEDBACFG $.
  $}

  $( No successor is empty.  (Contributed by NM, 3-Apr-1995.) $)
  nsuceq0 $p |- suc A =/= (/) $=
    ( csuc c0 wcel wceq wn noel sucidg eleq2 syl5ibcom mtoi sucprc eqeq1d eleq1
    cvv 0ex mpbiri syl6bi con3d pm2.43i pm2.61i neir ) ABZCAODZUCCEZFZUDUEACDZA
    GUDAUCDUEUGAOHUCCAIJKUDFZUFUHUEUDUHUEACEZUDUHUCACALMUIUDCODPACONQRSTUAUB $.

  ${
    eqelsuc.1 $e |- A e. _V $.
    $( A set belongs to the successor of an equal set.  (Contributed by NM,
       18-Aug-1994.) $)
    eqelsuc $p |- ( A = B -> A e. suc B ) $=
      ( wceq csuc sucid suceq syl5eleq ) ABDAAEBEACFABGH $.
  $}

  ${
    $d A x y $.  $d B y $.  $d C x y $.
    iunsuc.1 $e |- A e. _V $.
    iunsuc.2 $e |- ( x = A -> B = C ) $.
    $( Inductive definition for the indexed union at a successor.  (Contributed
       by Mario Carneiro, 4-Feb-2013.)  (Proof shortened by Mario Carneiro,
       18-Nov-2016.) $)
    iunsuc $p |- U_ x e. suc A B = ( U_ x e. A B u. C ) $=
      ( csuc ciun csn cun wceq df-suc iuneq1 ax-mp iunxun iunxsn uneq2i 3eqtri
      ) ABGZCHZABBIZJZCHZABCHZAUACHZJUDDJSUBKTUCKBLASUBCMNABUACOUEDUDABCDEFPQR
      $.
  $}

  ${
    $d z y A $.
    $( The successor of a transtive class is transitive.  (Contributed by Alan
       Sare, 11-Apr-2009.) $)
    suctrALT $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr cv wcel csuc wa wi wal wceq simpr vex elsuc sylib simpl eleq2
      wo syl6 mpdi syl5ibcom elelsuc trel exp3a adantrd syl8 jao alrimivv dftr2
      sylibr ) ADZBEZCEZFZUMAGZFZHZULUOFZIZCJBJUODUKUSBCUKUQUMAFZUMAKZRZURUQUPV
      BUNUPLUMACMNOUKUQVAURIZVBURIZUQVAULAFZURUQUNVAVEUNUPPUMAULQUAULAUBZSUKUQU
      TURIVCVDIUKUQUTVEURUKUNUTVEIUPUKUNUTVEAULUMUCUDUEVFUFUTURVAUGSTTUHBCUOUIU
      J $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( The sucessor of a transitive class is transitive.  The proof of
       ~ http://www.virtualdeduction.com/suctrvd.html is a Virtual Deduction
       proof verified by automatically transforming it into the Metamath proof
       of ~ suctr using completeusersproof, which is verified by the Metamath
       program.  The proof of ~ http://www.virtualdeduction.com/suctrro.html is
       a form of the completed proof which preserves the Virtual Deduction
       proof's step numbers and their ordering.  (Contributed by Alan Sare,
       11-Apr-2009.)  See ~ suctrALT for the original proof before this
       revision.  (Revised by Alan Sare, 12-Jun-2018.)
       (Proof modification is discouraged.) $)
    suctr $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr cv wcel csuc wa wi wal wceq w3a sssucid id simpld trel sseldi
      adantl ex syl 3impib syl3an 3expia adantr eleqtrd wo simprd elsuci mpjaod
      idi alrimivv dftr2 biimpri ) ADZBEZCEZFZUPAGZFZHZUOURFZIZCJBJZURDZUNVBBCU
      NUTVAUNUTHUPAFZVAUPAKZUNUTVEVAUNUTVELAURUOAMZUNUNUTUQVEVEUOAFZUNNUTUQUSUT
      NZOZVENUNUQVELVHIUNUQVEVHAUOUPPUAUJUBQUCUTVFVAIUNUTVFVAUTVFHZAURUOVGVKUOU
      PAUTUQVFVJUDVFVFUTVFNRUEQSRUTVEVFUFZUNUTUSVLUTUQUSVIUGUPAUHTRUISUKVDVCBCU
      RULUMT $.
  $}

  $( A set whose successor belongs to a transitive class also belongs.
     (Contributed by NM, 5-Sep-2003.)  (Proof shortened by Andrew Salmon,
     12-Aug-2011.) $)
  trsuc $p |- ( ( Tr A /\ suc B e. A ) -> B e. A ) $=
    ( wtr csuc wcel cvv wss sssucid ssexg mpan sucidg syl ancri trel syl5 imp
    wa ) ACZBDZAEZBAEZTBSEZTQRUATUBTBFEZUBBSGTUCBHBSAIJBFKLMABSNOP $.

  $( A member of the successor of a transitive class is a subclass of it.
     (Contributed by NM, 4-Oct-2003.) $)
  trsucss $p |- ( Tr A -> ( B e. suc A -> B C_ A ) ) $=
    ( csuc wcel wceq wo wtr wss elsuci trss wi eqimss a1i jaod syl5 ) BACDBADZB
    AEZFAGZBAHZBAIRPSQABJQSKRBALMNO $.

  $( A subset of an ordinal belongs to its successor.  (Contributed by NM,
     28-Nov-2003.) $)
  ordsssuc $p |- ( ( A e. On /\ Ord B ) -> ( A C_ B <-> A e. suc B ) ) $=
    ( con0 wcel word wa wss wceq wo csuc wb eloni ordsseleq sylan elsucg adantr
    bitr4d ) ACDZBEZFABGZABDABHIZABJDZRAESTUAKALABMNRUBUAKSABCOPQ $.

  $( A subset of an ordinal number belongs to its successor.  (Contributed by
     NM, 15-Sep-1995.) $)
  onsssuc $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B <-> A e. suc B ) ) $=
    ( con0 wcel word wss csuc wb eloni ordsssuc sylan2 ) BCDACDBEABFABGDHBIABJK
    $.

  $( An ordinal subset of an ordinal number belongs to its successor.
     (Contributed by NM, 1-Feb-2005.)  (Proof shortened by Andrew Salmon,
     12-Aug-2011.) $)
  ordsssuc2 $p |- ( ( Ord A /\ B e. On ) -> ( A C_ B <-> A e. suc B ) ) $=
    ( cvv wcel word con0 wa wss csuc wb wi elong biimprd anim1d onsssuc syl6 wn
    annim ssexg ex elex a1d pm5.21ni sylbi expcom adantld pm2.61i ) ACDZAEZBFDZ
    GZABHZABIZDZJZKUHUKAFDZUJGUOUHUIUPUJUHUPUIACLMNABOPUHQZUJUOUIUJUQUOUJUQGUJU
    HKZQUOUJUHRULURUNULUJUHABFSTUNUHUJAUMUAUBUCUDUEUFUG $.

  ${
    $d x A $.  $d x B $.
    $( When its successor is subtracted from a class of ordinal numbers, an
       ordinal number is less than the minimum of the resulting subclass.
       (Contributed by NM, 1-Dec-2003.) $)
    onmindif $p |- ( ( A C_ On /\ B e. On ) -> B e. |^| ( A \ suc B ) ) $=
      ( vx con0 wss wcel wa csuc cdif cint cv wral wn eldif wi wb ssel2 onsssuc
      ontri1 bitr3d con1bid sylan biimpd exp31 com23 imp4b syl5bi elintg adantl
      ralrimiv mpbird ) ADEZBDFZGZBABHZIZJFZBCKZFZCUPLZUNUSCUPURUPFURAFZURUOFZM
      ZGUNUSURAUONULUMVAVCUSULVAUMVCUSOZULVAUMVDULVAGZUMGVCUSVEURDFZUMVCUSPADUR
      QVFUMGZUSVBVGURBEUSMVBURBSURBRTUAUBUCUDUEUFUGUJUMUQUTPULCBUPDUHUIUK $.
  $}

  $( There is no set between an ordinal class and its successor.  Generalized
     Proposition 7.25 of [TakeutiZaring] p. 41.  (Contributed by NM,
     21-Jun-1998.) $)
  ordnbtwn $p |- ( Ord A -> -. ( A e. B /\ B e. suc A ) ) $=
    ( word wcel wa wo csuc wn ordn2lp ordirr ioran sylanbrc elsuci anim2i sylib
    wceq andi eleq2 biimpac orim2i syl nsyl ) ACZABDZBADZEZAADZFZUDBAGDZEZUCUFH
    UGHUHHABIAJUFUGKLUJUFUDBAPZEZFZUHUJUDUEUKFZEUMUIUNUDBAMNUDUEUKQOULUGUFUKUDU
    GBAARSTUAUB $.

  $( There is no set between an ordinal number and its successor.  Proposition
     7.25 of [TakeutiZaring] p. 41.  (Contributed by NM, 9-Jun-1994.) $)
  onnbtwn $p |- ( A e. On -> -. ( A e. B /\ B e. suc A ) ) $=
    ( con0 wcel word csuc wa wn eloni ordnbtwn syl ) ACDAEABDBAFDGHAIABJK $.

  $( A set whose successor is a subset of another class is a member of that
     class.  (Contributed by NM, 16-Sep-1995.) $)
  sucssel $p |- ( A e. V -> ( suc A C_ B -> A e. B ) ) $=
    ( wcel csuc wss sucidg ssel syl5com ) ACDAAEZDJBFABDACGJBAHI $.

  $( Ordinal derived from its successor.  (Contributed by NM, 20-May-1998.) $)
  orddif $p |- ( Ord A -> A = ( suc A \ { A } ) ) $=
    ( word csn cin wceq csuc cdif orddisj disj3 cun df-suc difeq1i difun2 eqtri
    c0 eqeq2i bitr4i sylib ) ABAACZDOEZAAFZSGZEZAHTAASGZEUCASIUBUDAUBASJZSGUDUA
    UESAKLASMNPQR $.

  $( An ordinal class includes its union.  (Contributed by NM, 13-Sep-2003.) $)
  orduniss $p |- ( Ord A -> U. A C_ A ) $=
    ( word wtr cuni wss ordtr df-tr sylib ) ABACADAEAFAGH $.

  $( A trichotomy law for ordinal classes.  (Contributed by NM, 13-Sep-2003.)
     (Proof shortened by Andrew Salmon, 12-Aug-2011.) $)
  ordtri2or $p |- ( ( Ord A /\ Ord B ) -> ( A e. B \/ B C_ A ) ) $=
    ( word wa wcel wss wn wb ordtri1 ancoms biimprd orrd ) ACZBCZDZABEZBAFZOQPG
    ZNMQRHBAIJKL $.

  $( A trichotomy law for ordinal classes.  (Contributed by NM, 2-Nov-2003.) $)
  ordtri2or2 $p |- ( ( Ord A /\ Ord B ) -> ( A C_ B \/ B C_ A ) ) $=
    ( word wa wcel wss wo ordtri2or wi ordelss ex orim1d adantl mpd ) ACZBCZDAB
    EZBAFZGZABFZRGZABHPSUAIOPQTRPQTBAJKLMN $.

  $( A consequence of total ordering for ordinal classes.  Similar to
     ~ ordtri2or2 .  (Contributed by David Moews, 1-May-2017.) $)
  ordtri2or3 $p |- ( ( Ord A /\ Ord B ) ->
                     ( A = ( A i^i B ) \/ B = ( A i^i B ) ) ) $=
    ( word wa wss wo cin wceq ordtri2or2 dfss dfss5 orbi12i sylib ) ACBCDABEZBA
    EZFAABGZHZBPHZFABINQORABJBAKLM $.

  $( The intersection of two ordinal classes is an element of a third if and
     only if either one of them is.  (Contributed by David Moews,
     1-May-2017.) $)
  ordelinel $p |- ( ( Ord A /\ Ord B /\ Ord C ) ->
                    ( ( A i^i B ) e. C <-> ( A e. C \/ B e. C ) ) ) $=
    ( word w3a cin wcel wo wceq wi ordtri2or3 3adant3 eleq1 orc syl6bir syl wss
    wa ordtr2 mpani olc jaoi inss1 ordin anim1i 3impa inss2 jaod impbid ) ADZBD
    ZCDZEZABFZCGZACGZBCGZHZUMAUNIZBUNIZHZUOURJZUJUKVAULABKLUSVBUTUSUOUPURAUNCMU
    PUQNOUTUOUQURBUNCMUQUPUAOUBPUMUPUOUQUMUNAQZUPUOABUCUMUNDZULRZVCUPRUOJUJUKUL
    VEUJUKRVDULABUDUEUFZUNACSPTUMUNBQZUQUOABUGUMVEVGUQRUOJVFUNBCSPTUHUI $.

  $( Property of a subclass of the maximum (i.e. union) of two ordinals.
     (Contributed by NM, 28-Nov-2003.) $)
  ordssun $p |- ( ( Ord B /\ Ord C ) ->
               ( A C_ ( B u. C ) <-> ( A C_ B \/ A C_ C ) ) ) $=
    ( word wa cun wss wo wi ordtri2or2 wceq wb ssequn1 sseq2 olc syl6bi ssequn2
    sylbi orc jaoi syl ssun impbid1 ) BDCDEZABCFZGZABGZACGZHZUDBCGZCBGZHUFUIIZB
    CJUJULUKUJUFUHUIUJUECKUFUHLBCMUECANRUHUGOPUKUFUGUIUKUEBKUFUGLCBQUEBANRUGUHS
    PTUAABCUBUC $.

  $( The maximum (i.e. union) of two ordinals is either one or the other.
     Similar to Exercise 14 of [TakeutiZaring] p. 40.  (Contributed by NM,
     28-Nov-2003.) $)
  ordequn $p |- ( ( Ord B /\ Ord C ) ->
               ( A = ( B u. C ) -> ( A = B \/ A = C ) ) ) $=
    ( word wa wss wo cun wceq wi ordtri2or2 wb ssequn1 eqeq2 olc syl6bi ssequn2
    sylbi orc jaoi syl ) BDCDEBCFZCBFZGABCHZIZABIZACIZGZJZBCKUBUIUCUBUEUGUHUBUD
    CIUEUGLBCMUDCANRUGUFOPUCUEUFUHUCUDBIUEUFLCBQUDBANRUFUGSPTUA $.

  $( The maximum (i.e. union) of two ordinals is ordinal.  Exercise 12 of
     [TakeutiZaring] p. 40.  (Contributed by NM, 28-Nov-2003.) $)
  ordun $p |- ( ( Ord A /\ Ord B ) -> Ord ( A u. B ) ) $=
    ( word wa cun wceq wo eqid ordequn mpi ordeq biimprcd jaao mpd ) ACZBCZDZAB
    EZAFZRBFZGZRCZQRRFUARHRABIJOSUBPTSUBORAKLTUBPRBKLMN $.

  ${
    $d x A $.  $d x B $.
    $( A subclass relationship for union and successor of ordinal classes.
       (Contributed by NM, 28-Nov-2003.) $)
    ordunisssuc $p |- ( ( A C_ On /\ Ord B ) ->
                      ( U. A C_ B <-> A C_ suc B ) ) $=
      ( vx con0 word wa cv wral csuc wcel cuni wb ssel2 ordsssuc sylan ralbidva
      wss an32s unissb dfss3 3bitr4g ) ADQZBEZFZCGZBQZCAHUEBIZJZCAHAKBQAUGQUDUF
      UHCAUBUEAJZUCUFUHLZUBUIFUEDJUCUJADUEMUEBNORPCABSCAUGTUA $.
  $}

  $( The successor operation behaves like a one-to-one function.  Compare
     Exercise 16 of [Enderton] p. 194.  (Contributed by NM, 3-Sep-2003.) $)
  suc11 $p |- ( ( A e. On /\ B e. On ) -> ( suc A = suc B <-> A = B ) ) $=
    ( con0 wcel wa csuc wceq wn wo wi word eloni ordn2lp wss sucssel elsuci ord
    syl5 com12 syl9 ianor sylib syl adantr eqimss eqimss2 eqcom syl6ib jaao mpd
    suceq impbid1 ) ACDZBCDZEZAFZBFZGZABGZUOABDZHZBADZHZIZURUSJZUMVDUNUMAKZVDAL
    VFUTVBEHVDABMUTVBUAUBUCUDUMVAVEUNVCUMURAUQDZVAUSURUPUQNUMVGUPUQUEAUQCORVGVA
    USVGUTUSABPQSTUNURBUPDZVCUSURUQUPNUNVHUQUPUFBUPCORVCVHBAGZUSVHVCVIVHVBVIBAP
    QSBAUGUHTUIUJABUKUL $.

  ${
    on.1 $e |- A e. On $.
    $( An ordinal number is an ordinal class.  (Contributed by NM,
       11-Jun-1994.) $)
    onordi $p |- Ord A $=
      ( con0 wcel word eloni ax-mp ) ACDAEBAFG $.

    $( An ordinal number is a transitive class.  (Contributed by NM,
       11-Jun-1994.) $)
    ontrci $p |- Tr A $=
      ( word wtr onordi ordtr ax-mp ) ACADABEAFG $.

    $( An ordinal number is not a member of itself.  Theorem 7M(c) of
       [Enderton] p. 192.  (Contributed by NM, 11-Jun-1994.) $)
    onirri $p |- -. A e. A $=
      ( word wcel wn onordi ordirr ax-mp ) ACAADEABFAGH $.

    $( A member of an ordinal number is an ordinal number.  Theorem 7M(a) of
       [Enderton] p. 192.  (Contributed by NM, 11-Jun-1994.) $)
    oneli $p |- ( B e. A -> B e. On ) $=
      ( con0 wcel onelon mpan ) ADEBAEBDECABFG $.

    $( A member of an ordinal number is a subset of it.  (Contributed by NM,
       11-Aug-1994.) $)
    onelssi $p |- ( B e. A -> B C_ A ) $=
      ( con0 wcel wss wi onelss ax-mp ) ADEBAEBAFGCABHI $.

    $( An ordering law for ordinal numbers.  (Contributed by NM,
       13-Jun-1994.) $)
    onssneli $p |- ( A C_ B -> -. B e. A ) $=
      ( wcel wss con0 word wn oneli eloni ordirr 3syl ssel com12 mtod con2i ) B
      ADZABEZQRBBDZQBFDBGSHABCIBJBKLRQSABBMNOP $.

    $( An ordering law for ordinal numbers.  (Contributed by NM,
       13-Jun-1994.) $)
    onssnel2i $p |- ( B C_ A -> -. A e. B ) $=
      ( wss wcel onirri ssel mtoi ) BADABEAAEACFBAAGH $.

    $( An element of an ordinal number equals the intersection with it.
       (Contributed by NM, 11-Jun-1994.) $)
    onelini $p |- ( B e. A -> B = ( B i^i A ) ) $=
      ( wcel wss cin wceq onelssi dfss sylib ) BADBAEBBAFGABCHBAIJ $.

    $( An ordinal number equals its union with any element.  (Contributed by
       NM, 13-Jun-1994.) $)
    oneluni $p |- ( B e. A -> ( A u. B ) = A ) $=
      ( wcel wss cun wceq onelssi ssequn2 sylib ) BADBAEABFAGABCHBAIJ $.

    $( An ordinal number is equal to the union of its successor.  (Contributed
       by NM, 12-Jun-1994.) $)
    onunisuci $p |- U. suc A = A $=
      ( wtr csuc cuni wceq ontrci con0 elexi unisuc mpbi ) ACADEAFABGAAHBIJK $.

    ${
      on.2 $e |- B e. On $.
      $( Subset is equivalent to membership or equality for ordinal numbers.
         (Contributed by NM, 15-Sep-1995.) $)
      onsseli $p |- ( A C_ B <-> ( A e. B \/ A = B ) ) $=
        ( con0 wcel wss wceq wo wb onsseleq mp2an ) AEFBEFABGABFABHIJCDABKL $.

      $( The union of two ordinal numbers is an ordinal number.  (Contributed
         by NM, 13-Jun-1994.) $)
      onun2i $p |- ( A u. B ) e. On $=
        ( wcel wss wo con0 word onordi ordtri2or mp2an oneluni syl6eqel ssequn1
        cun wceq eleq1 mpbiri sylbi jaoi ax-mp ) BAEZABFZGZABPZHEZBIAIUEBDJACJB
        AKLUCUGUDUCUFAHABCMCNUDUFBQZUGABOUHUGBHEDUFBHRSTUAUB $.
    $}
  $}

  $( An ordinal equal to its own union is either zero or a limit ordinal.
     (Contributed by NM, 1-Oct-2003.) $)
  unizlim $p |- ( Ord A -> ( A = U. A <-> ( A = (/) \/ Lim A ) ) ) $=
    ( word cuni wceq c0 wlim wo wa wn wne df-ne w3a df-lim biimpri 3exp syl5bir
    wi com23 imp orrd ex uni0 eqcomi id unieq 3eqtr4a limuni jaoi impbid1 ) ABZ
    AACZDZAEDZAFZGZUJULUOUJULHUMUNUJULUMIZUNQUJUPULUNUPAEJZUJULUNQAEKUJUQULUNUN
    UJUQULLAMNOPRSTUAUMULUNUMEECZAUKUREUBUCUMUDAEUEUFAUGUHUI $.

  $( An ordinal number either equals zero or contains zero.  (Contributed by
     NM, 1-Jun-2004.) $)
  on0eqel $p |- ( A e. On -> ( A = (/) \/ (/) e. A ) ) $=
    ( con0 wcel c0 wceq wo wss 0ss 0elon onsseleq mpan mpbii eqcom orbi2i orcom
    wb bitri sylib ) ABCZDACZDAEZFZADEZTFZSDAGZUBAHDBCSUEUBPIDAJKLUBTUCFUDUAUCT
    DAMNTUCOQR $.

  $( The singleton of the singleton of the empty set is not an ordinal (nor a
     natural number by ~ omsson ).  It can be used to represent an "undefined"
     value for a partial operation on natural or ordinal numbers.  See also
     ~ onxpdisj .  (Contributed by NM, 21-May-2004.)  (Proof shortened by
     Andrew Salmon, 12-Aug-2011.) $)
  snsn0non $p |- -. { { (/) } } e. On $=
    ( c0 csn con0 wcel wceq wo wn p0ex snid n0i ax-mp eqcom mtbir elsnc pm3.2ni
    0ex on0eqel mto ) ABZBZCDTAEZATDZFUAUBSTDUAGSHITSJKUBASEZUCSAEZASDUDGAPISAJ
    KASLMASPNMOTQR $.


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Union
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Introduce the Axiom of Union
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z $.
    $( Axiom of Union.  An axiom of Zermelo-Fraenkel set theory.  It states
       that a set ` y ` exists that includes the union of a given set ` x `
       i.e. the collection of all members of the members of ` x ` .  The
       variant ~ axun2 states that the union itself exists.  A version with the
       standard abbreviation for union is ~ uniex2 .  A version using class
       notation is ~ uniex .

       The union of a class ~ df-uni should not be confused with the union of
       two classes ~ df-un .  Their relationship is shown in ~ unipr .
       (Contributed by NM, 23-Dec-1993.) $)
    ax-un $a |- E. y A. z ( E. w ( z e. w /\ w e. x ) -> z e. y ) $.

    $( Axiom of Union expressed with the fewest number of different variables.
       (Contributed by NM, 14-Aug-2003.) $)
    zfun $p |- E. x A. y ( E. x ( y e. x /\ x e. z ) -> y e. x ) $=
      ( vw wel wa wex wi wal ax-un weq elequ2 elequ1 anbi12d cbvexv albii exbii
      imbi1i mpbi ) BDEZDCEZFZDGZBAEZHZBIZAGUDACEZFZAGZUDHZBIZAGCABDJUFUKAUEUJB
      UCUIUDUBUHDADAKTUDUAUGDABLDACMNORPQS $.

    $( A variant of the Axiom of Union ~ ax-un .  For any set ` x ` , there
       exists a set ` y ` whose members are exactly the members of the members
       of ` x ` i.e. the union of ` x ` .  Axiom Union of [BellMachover]
       p. 466.  (Contributed by NM, 4-Jun-2006.) $)
    axun2 $p |- E. y A. z ( z e. y <-> E. w ( z e. w /\ w e. x ) ) $=
      ( wel wa wex ax-un bm1.3ii ) CDEDAEFDGBCABCDHI $.

    $( The Axiom of Union using the standard abbreviation for union.  Given any
       set ` x ` , its union ` y ` exists.  (Contributed by NM, 4-Jun-2006.) $)
    uniex2 $p |- E. y y = U. x $=
      ( vz cv cuni wceq wex wcel wb wi wa zfun eluni imbi1i albii exbii bm1.3ii
      wal mpbir dfcleq ) BDZADZEZFZBGCDZUAHZUEUCHZICRZBGUGBCUGUFJZCRZBGUFUAUBHK
      BGZUFJZCRZBGBCALUJUMBUIULCUGUKUFBUEUBMNOPSQUDUHBCUAUCTPS $.
  $}

  ${
    $d x y A $.
    uniex.1 $e |- A e. _V $.
    $( The Axiom of Union in class notation.  This says that if ` A ` is a set
       i.e. ` A e. _V ` (see ~ isset ), then the union of ` A ` is also a set.
       Same as Axiom 3 of [TakeutiZaring] p. 16.  (Contributed by NM,
       11-Aug-1993.) $)
    uniex $p |- U. A e. _V $=
      ( vx vy cv cuni cvv wcel wceq unieq eleq1d uniex2 issetri vtocl ) CEZFZGH
      AFZGHCABOAIPQGOAJKDPCDLMN $.
  $}

  ${
    $d x A $.
    $( The ZF Axiom of Union in class notation, in the form of a theorem
       instead of an inference.  We use the antecedent ` A e. V ` instead of
       ` A e. _V ` to make the theorem more general and thus shorten some
       proofs; obviously the universal class constant ` _V ` is one possible
       substitution for class variable ` V ` .  (Contributed by NM,
       25-Nov-1994.) $)
    uniexg $p |- ( A e. V -> U. A e. _V ) $=
      ( vx cv cuni cvv wcel wceq unieq eleq1d vex uniex vtoclg ) CDZEZFGAEZFGCA
      BNAHOPFNAIJNCKLM $.
  $}

  ${
    unex.1 $e |- A e. _V $.
    unex.2 $e |- B e. _V $.
    $( The union of two sets is a set.  Corollary 5.8 of [TakeutiZaring]
       p. 16.  (Contributed by NM, 1-Jul-1994.) $)
    unex $p |- ( A u. B ) e. _V $=
      ( cpr cuni cun cvv unipr prex uniex eqeltrri ) ABEZFABGHABCDIMABJKL $.
  $}

  $( A triple of classes exists.  (Contributed by NM, 10-Apr-1994.) $)
  tpex $p |- { A , B , C } e. _V $=
    ( ctp cpr csn cun cvv df-tp prex snex unex eqeltri ) ABCDABEZCFZGHABCINOABJ
    CKLM $.

  ${
    $d x y A $.  $d x y B $.
    $( Existence of union is equivalent to existence of its components.
       (Contributed by NM, 11-Jun-1998.) $)
    unexb $p |- ( ( A e. _V /\ B e. _V ) <-> ( A u. B ) e. _V ) $=
      ( vx vy cvv wcel wa cun cv wceq uneq1 eleq1d uneq2 vex unex vtocl2g ssun1
      wss ssexg mpan ssun2 jca impbii ) AEFZBEFZGABHZEFZCIZDIZHZEFAUIHZEFUGCDAB
      EEUHAJUJUKEUHAUIKLUIBJUKUFEUIBAMLUHUICNDNOPUGUDUEAUFRUGUDABQAUFESTBUFRUGU
      EBAUABUFESTUBUC $.
  $}

  $( A union of two sets is a set.  Corollary 5.8 of [TakeutiZaring] p. 16.
     (Contributed by NM, 18-Sep-2006.) $)
  unexg $p |- ( ( A e. V /\ B e. W ) -> ( A u. B ) e. _V ) $=
    ( wcel cvv cun elex wa unexb biimpi syl2an ) ACEAFEZBFEZABGFEZBDEACHBDHMNIO
    ABJKL $.

  ${
    $( A version of ~ unisn without the ` A e. _V ` hypothesis.  (Contributed
       by Stefan Allan, 14-Mar-2006.) $)
    unisn2 $p |- U. { A } e. { (/) , A } $=
      ( cvv wcel csn cuni c0 cpr unisng prid2g eqeltrd wceq snprc biimpi unieqd
      wn uni0 0ex prid1 eqeltri syl6eqel pm2.61i ) ABCZADZEZFAGZCUBUDAUEABHFABI
      JUBOZUDFEZUEUFUCFUFUCFKALMNUGFUEPFAQRSTUA $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Union of a singleton in the form of a restricted class abstraction.
       (Contributed by NM, 3-Jul-2008.) $)
    unisn3 $p |- ( A e. B -> U. { x e. B | x = A } = A ) $=
      ( wcel cv wceq crab cuni csn rabsn unieqd unisng eqtrd ) BCDZAEBFACGZHBIZ
      HBNOPACBJKBCLM $.
  $}

  ${
    $d x y z $.
    $( The class of all singletons is a proper class.  (Contributed by NM,
       10-Oct-2008.)  (Proof shortened by Eric Schmidt, 7-Dec-2008.) $)
    snnex $p |- { x | E. y x = { y } } e/ _V $=
      ( vz cv csn wceq wex cab cvv wcel cuni vprc wa vex snid a9ev sneq equcoms
      eximii snex eleq2 eqeq1 exbidv anbi12d spcev mp2an mpbir 2th eqriv eleq1i
      eluniab mtbir uniexg mto nelir ) ADZBDZEZFZBGZAHZIVAIJVAKZIJZVCIIJLVBIICV
      BICDZVBJZVDIJVEVDUPJZUTMZAGZVDVDEZJZVIURFZBGZVHVDCNZOUQVDFVKBBCPVKCBVDUQQ
      RSVGVJVLMAVIVDTUPVIFZVFVJUTVLUPVIVDUAVNUSVKBUPVIURUBUCUDUEUFUTAVDUKUGVMUH
      UIUJULVAIUMUNUO $.
  $}

  $( If the subtrahend of a class difference exists, then the minuend exists
     iff the difference exists.  (Contributed by NM, 12-Nov-2003.)  (Proof
     shortened by Andrew Salmon, 12-Aug-2011.) $)
  difex2 $p |- ( B e. C -> ( A e. _V <-> ( A \ B ) e. _V ) ) $=
    ( wcel cvv cdif difexg wa cun ssun2 uncom undif2 eqtr2i sseqtri unexg ssexg
    wss sylancr expcom impbid2 ) BCDZAEDZABFZEDZABEGUDUAUBUDUAHAUCBIZQUEEDUBABA
    IZUEABJUEBUCIUFUCBKBALMNUCBECOAUEEPRST $.

  ${
    opeluu.1 $e |- A e. _V $.
    opeluu.2 $e |- B e. _V $.
    $( Each member of an ordered pair belongs to the union of the union of a
       class to which the ordered pair belongs.  Lemma 3D of [Enderton] p. 41.
       (Contributed by NM, 31-Mar-1995.)  (Revised by Mario Carneiro,
       27-Feb-2016.) $)
    opeluu $p |- ( <. A , B >. e. C ->
                 ( A e. U. U. C /\ B e. U. U. C ) ) $=
      ( cop wcel cuni cpr prid1 opi2 elunii mpan sylancr prid2 jca ) ABFZCGZACH
      ZHZGZBTGZRAABIZGUCSGZUAABDJUCQGRUDABDEKUCQCLMZAUCSLNRBUCGUDUBABEOUEBUCSLN
      P $.
  $}

  ${
    $d A x y v z $.  $d A x y u z $.
    $( Expression for double union that moves union into a class builder.
       (Contributed by FL, 28-May-2007.) $)
    uniuni $p |- U. U. A = U. { x | E. y ( x = U. y /\ y e. A ) } $=
      ( vz vu vv wel cv cuni wcel wex cab wceq eluni anbi2i exbii 19.42v bicomi
      wa 3bitri excom anass ancom bitr3i 2exbii exdistr vex uniex eleq2 ceqsexv
      exancom bitri 3bitr2i eqeq1 anbi1d exbidv elab abbii df-uni 3eqtr4i ) DEG
      ZEHZCIZJZSZEKZDLDFGZFHZAHZBHZIZMZVJCJZSZBKZALZJZSZFKZDLVCIVPIVFVSDVFVAEBG
      ZVMSZBKZSZEKZVMDHZVKJZSZBKZVSVEWCEVDWBVABVBCNOPWDVAWASZBKZEKZVMVAVTSZEKZS
      ZBKZWHWCWJEWJWCVAWABQRPWKWIEKBKVMWLSZEKBKWOWIEBUAWIWPBEWIWLVMSWPVAVTVMUBW
      LVMUCUDUEVMWLBEUFTWNWGBWMWFVMWFWMEWEVJNROPTWHVGVHVKMZVMSZSZFKZBKWSBKFKZVS
      WGWTBWGVMVGWQSZFKZSVMXBSZFKWTWFXCVMWFWQVGSFKXCVGWFFVKVJBUGUHVHVKWEUIUJWQV
      GFUKUDOVMXBFQXDWSFXDXBVMSWSVMXBUCVGWQVMUBULPUMPWSBFUAXAVGWRBKZSZFKVSVGWRF
      BUFXFVRFXEVQVGVQXEVOXEAVHFUGVIVHMZVNWRBXGVLWQVMVIVHVKUNUOUPUQROPULTTURDEV
      CUSDFVPUSUT $.
  $}

  ${
    $d x y z $.  $d A y z $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` .  (Contributed by NM, 14-Oct-2010.) $)
    eusv1 $p |- ( E! y A. x y = A <-> E. y A. x y = A ) $=
      ( vz cv wceq wal weu wex wa wi sp eqtr3 syl2an gen2 eqeq1 albidv mpbiran2
      eu4 ) BEZCFZAGZBHUBBIUBDEZCFZAGZJTUCFZKZDGBGUGBDUBUAUDUFUEUAALUDALTUCCMNO
      UBUEBDUFUAUDATUCCPQSR $.
  $}

  ${
    $d x y z w $.  $d A y z w $.
    $( Even if ` x ` is free in ` A ` , it is effectively bound when
       ` A ( x ) ` is single-valued.  (Contributed by NM, 14-Oct-2010.)
       (Revised by Mario Carneiro, 14-Oct-2016.) $)
    eusvnf $p |- ( E! y A. x y = A -> F/_ x A ) $=
      ( vz vw cv wceq wal csb cvv wcel wi vex nfcv nfcsb1v nfeq2 csbeq1a eqeq2d
      spcgf ax-mp weu wex wnfc euex eqtr3d alrimivv sbnfc2 sylibr exlimiv syl )
      BFZCGZAHZBUAUMBUBACUCZUMBUDUMUNBUMADFZCIZAEFZCIZGZEHDHUNUMUSDEUMUKUPURUOJ
      KUMUKUPGZLDMULUTAUOJAUONAUKUPAUOCOPAFZUOGCUPUKAUOCQRSTUQJKUMUKURGZLEMULVB
      AUQJAUQNAUKURAUQCOPVAUQGCURUKAUQCQRSTUEUFADECUGUHUIUJ $.

    $( Two ways to say that ` A ( x ) ` is a set expression that does not
       depend on ` x ` .  (Contributed by Mario Carneiro, 18-Nov-2016.) $)
    eusvnfb $p |- ( E! y A. x y = A <-> ( F/_ x A /\ A e. _V ) ) $=
      ( cv wceq wal weu wnfc cvv wcel eusvnf wex euex vex syl6eqelr sps exlimiv
      wa id syl jca isset nfcvd nfeqd nfrd eximdv syl5bi eusv1 sylibr impbii
      imp ) BDZCEZAFZBGZACHZCIJZRZUOUPUQABCKUOUNBLZUQUNBMUNUQBUMUQAUMCULIUMSBNO
      PQTUAURUSUOUPUQUSUQUMBLUPUSBCUBUPUMUNBUPUMAUPAULCUPAULUCUPSUDUEUFUGUKABCU
      HUIUJ $.
  $}

  ${
    $d x y $.  $d A y $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` .  (Contributed by NM, 14-Oct-2010.)  (Revised by Mario
       Carneiro, 18-Nov-2016.) $)
    eusv2i $p |- ( E! y A. x y = A -> E! y E. x y = A ) $=
      ( cv wceq wal weu wex nfeu1 wnf nfcvd eusvnf nfeqd nf2 sylib 19.2 impbid1
      wi eubid ibir ) BDZCEZAFZBGZUBAHZBGUDUEUCBUCBIUDUEUCUDUBAJUEUCRUDAUACUDAU
      AKABCLMUBANOUBAPQST $.
  $}

  ${
    $d x y z v w $.  $d A y z w v $.
    eusv2.1 $e |- A e. _V $.
    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` .  (Contributed by Mario Carneiro, 18-Nov-2016.) $)
    eusv2nf $p |- ( E! y E. x y = A <-> F/_ x A ) $=
      ( cv wceq wex weu wnfc wnf wal nfeu1 wi nfe1 nfeu wa isseti alrimi sylibr
      cvv 19.8a ancri eximii eupick mpan2 nf3 wcel wb dfnfc2 mpg eusvnfb eusv2i
      mpbiran2 sylbir impbii ) BECFZAGZBHZACIZURUPAJZBKZUSURUTBUQBLURUQUPMZAKUT
      URVBAUQABUPANOURUQUPPZBGVBUPVCBBCDQUPUQUPAUAUBUCUQUPBUDUERUPAUFSRCTUGZUSV
      AUHAABCTUIDUJSUSUPAKBHZURVEUSVDDABCUKUMABCULUNUO $.

    $( Two ways to express single-valuedness of a class expression
       ` A ( x ) ` .  (Contributed by NM, 15-Oct-2010.)  (Proof shortened by
       Mario Carneiro, 18-Nov-2016.) $)
    eusv2 $p |- ( E! y E. x y = A <-> E! y A. x y = A ) $=
      ( cv wceq wex weu wnfc wal eusv2nf cvv wcel eusvnfb mpbiran2 bitr4i ) BEC
      FZAGBHACIZQAJBHZABCDKSRCLMDABCNOP $.
  $}

  ${
    $d x z A $.  $d w x z B $.  $d x z C $.  $d w x z ph $.  $d w x y z $.
    $( Two ways to express single-valuedness of a class expression
       ` C ( y ) ` .  (Contributed by NM, 16-Dec-2012.)  (Proof shortened by
       Mario Carneiro, 18-Nov-2016.) $)
    reusv1 $p |- ( E. y e. B ph -> ( E! x e. A A. y e. B ( ph -> x = C )
                   <-> E. x e. A A. y e. B ( ph -> x = C ) ) ) $=
      ( wrex cv wceq wi wral wmo wrmo wreu wb nfra1 nfmo wcel wa wal imp3a moeq
      rsp com12 alrimiv moim ee10 ex rexlimi mormo reu5 rbaib 3syl ) ACEGABHFIZ
      JZCEKZBLZUPBDMZUPBDNZUPBDGZOAUQCEUPCBUOCEPQCHERZAUQVAASZUPUNJZBTUNBLUQVBV
      CBUPVBUNUPVAAUNUOCEUCUAUDUEBFUBUPUNBUFUGUHUIUPBDUJUSUTURUPBDUKULUM $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d x z ph $.
    $( Lemma for ~ reusv2 .  (Contributed by NM, 22-Oct-2010.)  (Proof
       shortened by Mario Carneiro, 19-Nov-2016.) $)
    reusv2lem1 $p |- ( A =/= (/) -> ( E! x A. y e. A x = B
                     <-> E. x A. y e. A x = B ) ) $=
      ( c0 wne cv wceq wral wmo weu wex wb wcel n0 nfra1 nfmo wi wal rsp exlimi
      com12 alrimiv moeq moim ee10 sylbi eu5 rbaib syl ) CEFZAGDHZBCIZAJZUMAKZU
      MALZMUKBGCNZBLUNBCOUQUNBUMBAULBCPQUQUMULRZASULAJUNUQURAUMUQULULBCTUBUCADU
      DUMULAUEUFUAUGUOUPUNUMAUHUIUJ $.

    $( Lemma for ~ reusv2 .  (Contributed by NM, 27-Oct-2010.)  (Proof
       shortened by Mario Carneiro, 19-Nov-2016.) $)
    reusv2lem2 $p |- ( E! x A. y e. A x = B -> E! x E. y e. A x = B ) $=
      ( vz cv wceq wral weu wrex wi c0 wal wn wex sylib wa nfra1 imp ex alrimiv
      eunex exnal rzal nsyl3 pm2.21d wne simpr wb euex eqeq1 ralbidv cbvexv nfv
      nfan wcel simprr rsp ad2ant2lr eqtr4d simplr syl5ibrcom mpd exp32 rexlimd
      r19.2z adantr impbid eubidv exlimdv syl5 mpbird pm2.61ine ) AFZDGZBCHZAIZ
      VOBCJZAIZKCLCLGZVQVSVQVPAMZVTVQVPNAOWANVPAUBVPAUCPVTVPAVOBCUDUAUEUFCLUGZV
      QVSWBVQQVSVQWBVQUHWBVQVSVQUIZVQEFZDGZBCHZEOZWBWCVQVPAOWGVPAUJVPWFAEVNWDGZ
      VOWEBCVNWDDUKULZUMPWBWFWCEWBWFWCWBWFQZVRVPAWJVRVPWJVOVPBCWBWFBWBBUNWEBCRU
      OVOBCRWJBFCUPZVOVPWJWKVOQZQZWHVPWMVNDWDWJWKVOUQWFWKWEWBVOWFWKWEWEBCURSUSU
      TWMVPWHWFWBWFWLVAWIVBVCVDVEWBVPVRKWFWBVPVRVOBCVFTVGVHVITVJVKSVLTVM $.

    $( Lemma for ~ reusv2 .  (Contributed by NM, 14-Dec-2012.)  (Proof
       shortened by Mario Carneiro, 19-Nov-2016.) $)
    reusv2lem3 $p |- ( A. y e. A B e. _V ->
          ( E! x E. y e. A x = B <-> E! x A. y e. A x = B ) ) $=
      ( cvv wcel wral cv wceq wrex weu wa simpr nfv nfeu1 nfan wi wex syl ex c0
      wne euex rexn0 exlimiv adantl r19.2z nfra1 nfre1 nfeu simplr adantr isset
      rsp imp sylib rspe ancrd eximdv eupick syl2anc com23 ralrimd impbid eubid
      sylc mpbird reusv2lem2 impbid1 ) DEFZBCGZAHDIZBCJZAKZVLBCGZAKZVKVNVPVKVNL
      ZVPVNVKVNMVQVOVMAVKVNAVKANVMAOPVQVOVMVQCUAUBZVOVMQVNVRVKVNVMARVRVMAUCVMVR
      AVLBCUDUESUFVRVOVMVLBCUGTSVQVMVLBCVKVNBVJBCUHVMBAVLBCUIZUJPVSVQBHCFZVMVLV
      QVTVMVLQZVQVTLZVNVMVLLZARZWAVKVNVTUKWBVTVLARZWDVQVTMWBVJWEVQVTVJVKVTVJQVN
      VJBCUNULUOADUMUPVTVLWCAVTVLVMVTVLVMVLBCUQTURUSVFVMVLAUTVATVBVCVDVEVGTABCD
      VHVI $.

    $( Lemma for ~ reusv2 .  (Contributed by NM, 13-Dec-2012.) $)
    reusv2lem4 $p |- ( E! x e. A E. y e. B ( ph /\ x = C )
            <-> E! x A. y e. B ( ( C e. A /\ ph ) -> x = C ) ) $=
      ( vz cv wceq wa wrex wcel weu wi wral anass eleq1 nfv cvv wal wreu df-reu
      crab anbi1i anbi1d pm5.32ri bitr3i anbi2i 3bitr4ri rexbii2 r19.42v nfrab1
      csb rabid nfcv nfcsb1v nfeq2 csbeq1a eqeq2d cbvrexf 3bitr3i eubii wb elex
      ad2antrl sylbi rgen nfel1 eleq1d cbvralf mpbi reusv2lem3 ax-mp nfcri nfim
      df-ral imbi12d cbval imbi1i impexp bitri albii bitr4i 3bitr2i 3bitri ) AB
      HZFIZJZCEKZBDUAWFDLZWIJZBMWFCGHZFUMZIZGFDLZAJZCEUCZKZBMZWPWGNZCEOZBMZWIBD
      UBWKWRBWJWHJZCEKWGCWQKWKWRXCWGCEWQCHZELZWPJZWGJXEWPWGJZJXDWQLZWGJXEXCJXEW
      PWGPXHXFWGWPCEUNZUDXCXGXEXCWJAJZWGJXGWJAWGPWGXJWPWGWJWOAWFFDQUEUFUGUHUIUJ
      WJWHCEUKWGWNCGWQWPCEULZGWQUOZWGGRCWFWMCWLFUPZUQZXDWLIZFWMWFCWLFURZUSZUTVA
      VBWSWNGWQOZBMZXBWMSLZGWQOZWSXSVCFSLZCWQOYAYBCWQXHXFYBXIWOYBXEAFDVDVEVFVGY
      BXTCGWQXKXLYBGRCWMSXMVHXOFWMSXPVIVJVKBGWQWMVLVMXRXABXRWLWQLZWNNZGTXHWGNZC
      TZXAWNGWQVPYEYDCGYEGRYCWNCCGWQXKVNXNVOXOXHYCWGWNXDWLWQQXQVQVRYFXEWTNZCTXA
      YEYGCYEXFWGNYGXHXFWGXIVSXEWPWGVTWAWBWTCEVPWCWDVBWAWE $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.
    $( Lemma for ~ reusv2 .  (Contributed by NM, 4-Jan-2013.)  (Proof shortened
       by Mario Carneiro, 19-Nov-2016.) $)
    reusv2lem5 $p |- ( ( A. y e. B C e. A /\ B =/= (/) )
          -> ( E! x e. A E. y e. B x = C <-> E! x e. A A. y e. B x = C ) ) $=
      ( wcel wral c0 wne wa wtru cv wceq wi weu wrex wreu wb tru eubidv syl6bbr
      biimt mpan2 ibar bitr3d eleq1 pm5.32ri ralimi ralbi syl r19.28zv sylan9bb
      biantrur rexbii reubii reusv2lem4 bitri df-reu 3bitr4g ) ECFZBDGZDHIZJUTK
      JZALZEMZNZBDGZAOZVDCFZVEBDGZJZAOZVEBDPZACQZVJACQVAVHVIVEJZBDGZAOVBVLVAVGV
      PAVAVFVORZBDGVGVPRUTVQBDUTVFUTVEJZVOUTVEVFVRUTKVEVFRSVCVEUBUCUTVEUDUEVEVI
      UTVDECUFUGUAUHVFVOBDUIUJTVBVPVKAVIVEBDUKTULVNKVEJZBDPZACQVHVMVTACVEVSBDKV
      ESUMUNUOKABCDEUPUQVJACURUS $.
  $}

  ${
    $d w x y z A $.  $d w x z B $.  $d w x z C $.  $d w x z ph $.
    $( Two ways to express single-valuedness of a class expression ` C ( y ) `
       that is constant for those ` y e. B ` such that ` ph ` .  The first
       antecedent ensures that the constant value belongs to the existential
       uniqueness domain ` A ` , and the second ensures that ` C ( y ) ` is
       evaluated for at least one ` y ` .  (Contributed by NM, 4-Jan-2013.)
       (Proof shortened by Mario Carneiro, 19-Nov-2016.) $)
    reusv2 $p |- ( ( A. y e. B ( ph -> C e. A ) /\ E. y e. B ph )
          -> ( E! x e. A E. y e. B ( ph /\ x = C )
                   <-> E! x e. A A. y e. B ( ph -> x = C ) ) ) $=
      ( vz wcel wi wral cv wceq wa wrex wreu nfv cbvralf imbi1i bitri bitr3i c0
      csb crab wb nfrab1 nfcv nfcsb1v nfel1 csbeq1a eleq1d rabid impexp ralbii2
      rabn0 reusv2lem5 nfeq2 eqeq2d cbvrexf anbi1i anass rexbii2 reubii 3bitr3g
      wne syl2anbr ) AFDHZIZCEJZCGKZFUBZDHZGACEUCZJZVLUAVDZABKZFLZMZCENZBDOZAVP
      IZCEJZBDOZUDACENVMVFCVLJVHVFVKCGVLACEUEZGVLUFZVFGPCVJDCVIFUGZUHCKZVILZFVJ
      DCVIFUIZUJQVFVGCVLEWFVLHZVFIWFEHZAMZVFIWJVGIWIWKVFACEUKZRWJAVFULSUMTACEUN
      VMVNMVOVJLZGVLNZBDOWMGVLJZBDOVSWBBGDVLVJUOWNVRBDWNVPCVLNVRVPWMCGVLWCWDVPG
      PZCVOVJWEUPZWGFVJVOWHUQZURVPVQCVLEWIVPMWKVPMWJVQMWIWKVPWLUSWJAVPUTSVATVBW
      OWABDWOVPCVLJWAVPWMCGVLWCWDWPWQWRQVPVTCVLEWIVPIWKVPIWJVTIWIWKVPWLRWJAVPUL
      SUMTVBVCVE $.
  $}

  ${
    $d x y z B $.  $d x z C $.  $d x y D $.  $d x z ph $.  $d x y ps $.
    reusv3.1 $e |- ( y = z -> ( ph <-> ps ) ) $.
    reusv3.2 $e |- ( y = z -> C = D ) $.
    $( Two ways of expressing existential uniqueness via an indirect equality.
       (Contributed by NM, 23-Dec-2012.) $)
    reusv3i $p |- ( E. x e. A A. y e. B ( ph -> x = C )
            -> A. y e. B A. z e. B ( ( ph /\ ps ) -> C = D ) ) $=
      ( cv wceq wi wral wa eqeq2d imbi12d cbvralv ralimi biimpi prth eqtr2 syl6
      raaanv sylbir mpdan rexlimivw ) ACLZHMZNZDGOZABPZHIMZNZEGOZDGOZCFULBUIIMZ
      NZEGOZUQULUTUKUSDEGDLELMZABUJURJVAHIUIKQRSUAULUTPUKUSPZEGOZDGOUQUKUSDEGUE
      VCUPDGVBUOEGVBUMUJURPUNAUJBURUBUIHIUCUDTTUFUGUH $.

    $d x y z A $.
    $( Two ways to express single-valuedness of a class expression
       ` C ( y ) ` .  See ~ reusv1 for the connection to uniqueness.
       (Contributed by NM, 27-Dec-2012.) $)
    reusv3 $p |- ( E. y e. B ( ph /\ C e. A )
          -> ( A. y e. B A. z e. B ( ( ph /\ ps ) -> C = D )
                   <-> E. x e. A A. y e. B ( ph -> x = C ) ) ) $=
      ( wcel wa wrex wceq wi wral cv bitri ralbii eleq1d anbi12d nfra2 nfv nfim
      cbvrexv risset ralcom impexp bi2.04 r19.21v sylbi com3l imp31 eqeq1 eqcom
      rsp syl6bb imbi2d ralbidv syl5ibrcom reximdv com23 syl5bi expimpd rexlimi
      ex reusv3i impbid1 ) AHFLZMZDGNZABMHIOZPZEGQDGQZACRZHOZPZDGQZCFNZVLBIFLZM
      ZEGNVOVTPZVKWBDEGDRERZOZABVJWAJWEHIFKUAUBUFWBWCEGVOVTEVNDEGGUCVTEUDUEWDGL
      ZBWAWCWAVPIOZCFNZWFBMZWCCIFUGWIVOWHVTWIVOWHVTPWIVOMZWGVSCFWJVSWGAVMPZDGQZ
      WFBVOWLVOWFBWLVOBWLPZEGQZWFWMPVOVNDGQZEGQWNVNDEGGUHWOWMEGWOBWKPZDGQWMVNWP
      DGVNABVMPPWPABVMUIABVMUJSTBWKDGUKSTSWMEGUQULUMUNWGVRWKDGWGVQVMAWGVQIHOVMV
      PIHUOIHUPURUSUTVAVBVGVCVDVEVFULABCDEFGHIJKVHVI $.
  $}

  ${
    $d x y z A $.  $d x z B $.
    eusv4.1 $e |- B e. _V $.
    $( Two ways to express single-valuedness of a class expression
       ` B ( x ) ` .  (Contributed by NM, 27-Oct-2010.) $)
    eusv4 $p |- ( E! x E. y e. A x = B <-> E! x A. y e. A x = B ) $=
      ( cvv wcel cv wceq wrex weu wral wb reusv2lem3 a1i mprg ) DFGZAHDIZBCJAKR
      BCLAKMBCABCDNQBHCGEOP $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x C $.  $d x y $.
    $( Two ways to express single-valuedness of a class expression
       ` C ( y ) ` .  (Contributed by NM, 16-Dec-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    reusv5OLD $p |- ( B =/= (/) -> ( E! x e. A A. y e. B x = C
                     <-> E. x e. A A. y e. B x = C ) ) $=
      ( c0 wne cv wceq wrex wral wreu wb wcel wex wa equid biantru exbii n0 wi
      df-rex 3bitr4i reusv1 a1bi ralbii reubii rexbii 3bitr4g sylbi ) DFGZBHZUL
      IZBDJZAHEIZBDKZACLZUPACJZMULDNZBOUSUMPZBOUKUNUSUTBUMUSBQZRSBDTUMBDUBUCUNU
      MUOUAZBDKZACLVCACJUQURUMABCDEUDUPVCACUOVBBDUMUOVAUEUFZUGUPVCACVDUHUIUJ $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.  $d v w x z C $.
    $( Two ways to express single-valuedness of a class expression
       ` C ( y ) ` .  The converse does not hold.  Note that ` U. A = |^| A `
       means ` A ` is a singleton ( ~ uniintsn ).  (Contributed by NM,
       30-Oct-2010.)  (Proof shortened by Mario Carneiro, 24-Dec-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    reusv6OLD $p |- ( ( U. A =/= |^| A \/ B =/= (/) )
          -> ( E! x e. A A. y e. B x = C -> E! x e. A E. y e. B x = C ) ) $=
      ( vz wne cv wceq wral wreu wi c0 wcel wa weu csn wex nfv ex cuni wn raleq
      cint wrex reubidv df-reu uniintsn eusn ral0 biantru 3bitr2i bitr4i syl6bb
      eubii necon3bbid pm2.21 syl6bir crab wss nfrab1 nfeq1 nfan w3a nfra1 nfcv
      nfrab nf3an vex snid simp2 syl5eleqr eqeq1 ralbidv elrab simprbi r19.21bi
      syl eqeq2d biimprd elsn syl6ibr rexlimd 3expia ralrimi rabss sylibr simpr
      sseqtr4d r19.2z adantr ss2rabdv eqssd eqtrd eximdv reusn 3imtr4g a1d jaoi
      pm2.61ine ) CUAZCUDZGZAHZEIZBDJZACKZXEBDUEZACKZLZDMGZXCXJLDMDMIZXCXGUBXJX
      LXGXAXBXLXGXEBMJZACKZXAXBIZXLXFXMACXEBDMUCUFXNXDCNZXMOZAPZXOXMACUGXOCXDQI
      ARXPAPXRACUHACUIXPXQAXMXPXEBUJUKUOULUMUNUPXGXIUQURXKXJXCXKXFACUSZFHZQZIZF
      RXHACUSZYAIZFRXGXIXKYBYDFXKYBYDXKYBOZYCXSYAYEYCXSYEYCYAXSYEXHXDYANZLZACJY
      CYAUTYEYGACXKYBAXKASAXSYAXFACVAVBVCXKYBXPYGXKYBXPVDZXEYFBDXKYBXPBXKBSBXSY
      AXFBACXEBDVEBCVFVGVBXPBSVHYFBSYHBHDNZXEYFLYHYIOZXEXDXTIZYFYJYKXEYJXTEXDYH
      XTEIZBDYHXTXSNZYLBDJZYHXTYAXSXTFVIVJXKYBXPVKVLYMXTCNYNXFYNAXTCYKXEYLBDXDX
      TEVMVNVOVPVRVQVSVTAXTWAWBTWCWDWEXHACYAWFWGXKYBWHZWIXKXSYCUTYBXKXFXHACXKXF
      XHLXPXKXFXHXEBDWJTWKWLWKWMYOWNTWOXFAFCWPXHAFCWPWQZWRWTYPWS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.
    reusv7.1 $e |- ( y e. B -> C e. A ) $.
    $( Two ways to express single-valuedness of a class expression
       ` C ( y ) ` .  Note that ` U. A = |^| A ` means ` A ` is a singleton
       ( ~ uniintsn ).  (Contributed by NM, 14-Dec-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    reusv7OLD $p |- ( ( U. A =/= |^| A \/ B =/= (/) )
          -> ( E! x e. A E. y e. B x = C <-> E! x e. A A. y e. B x = C ) ) $=
      ( wne cv wceq wrex wreu wral wb c0 wi wn wa wcel weu df-reu raleq reubidv
      cuni cint csn uniintsn eusn ral0 biantru 3bitr2i bitr4i syl6bb necon3bbid
      eubii biimprd reurex rexn0 rexlimivw necon2bi jctild pm5.21 syl6 r19.28zv
      wex syl eubidv reusv2lem4 equid biantrur rexbii reubii biantrurd pm5.32ri
      eleq1 syl6rbbr biimt bitrd imbi1i ralbiia 3bitr4i 3bitr4g pm2.61ine jaoi
      a1d ) CUCZCUDZGZAHZEIZBDJZACKZWIBDLZACKZMZDNGZWGWNODNDNIZWGWKPZWMPZQWNWPW
      GWRWQWPWRWGWPWMWEWFWPWMWIBNLZACKZWEWFIZWPWLWSACWIBDNUAUBWTWHCRZWSQZASZXAW
      SACTXACWHUEIAVDXBASXDACUFACUGXBXCAWSXBWIBUHUIUNUJUKULUMUOWKDNWKWJACJWOWJA
      CUPWJWOACWIBDUQURVEUSUTWKWMVAVBWOWNWGWOXBWIQZBDLZASZXBWLQZASWKWMWOXFXHAXB
      WIBDVCVFBHZXIIZWIQZBDJZACKECRZXJQZWIOZBDLZASWKXGXJABCDEVGWJXLACWIXKBDXJWI
      BVHZVIVJVKXFXPAXEXOBDXIDRZXEXMWIOZXOXRXEWIXSXRWIXMWIQXEXRXMWIFVLWIXBXMWHE
      CVNVMVOXRXMWIXSMFXMWIVPVEVQXMXNWIXJXMXQUIVRULVSUNVTWLACTWAZWDWBXTWC $.
  $}

  ${
    $d x A $.  $d y ph $.  $d x ps $.  $d x y $.
    alxfr.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       18-Feb-2007.) $)
    alxfr $p |- ( ( A. y A e. B /\ A. x E. y x = A ) ->
                ( A. x ph <-> A. y ps ) ) $=
      ( wcel wal cv wceq wex wa wi spcgv com12 alimdv adantr nfa1 nfv sp exlimd
      syl5ibrcom adantl impbid ) EFHZDIZCJEKZDLZCIZMACIZBDIZUGUKULNUJUKUGULUKUF
      BDUFUKBABCEFGOPQPRUJULUKNUGULUJUKULUIACULUHADBDSADTULAUHBBDUAGUCUBQPUDUE
      $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x C $.  $d x ch $.  $d x y ph $.  $d y ps $.
    ralxfrd.1 $e |- ( ( ph /\ y e. C ) -> A e. B ) $.
    ralxfrd.2 $e |- ( ( ph /\ x e. B ) -> E. y e. C x = A ) $.
    ralxfrd.3 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       15-Aug-2014.)  (Proof shortened by Mario Carneiro, 19-Nov-2016.) $)
    ralxfrd $p |- ( ph -> ( A. x e. B ps <-> A. y e. C ch ) ) $=
      ( wral cv wcel wa wceq wb adantlr ralrimdva wrex rspcdv r19.29 wi biimprd
      expimpd ancomsd ad2antrr rexlimdva syl5 mpan2d impbid ) ABDGLZCEHLZAULCEH
      AEMHNZOBCDFGIADMZFPZBCQUNKRUASAUMBDGAUOGNZOZUMUPEHTZBJUMUSOCUPOZEHTURBCUP
      EHUBURUTBEHAUTBUCUQUNAUPCBAUPCBAUPOBCKUDUEUFUGUHUIUJSUK $.

    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by FL,
       10-Apr-2007.)  (Revised by Mario Carneiro, 15-Aug-2014.) $)
    rexxfrd $p |- ( ph -> ( E. x e. B ps <-> E. y e. C ch ) ) $=
      ( wn wral wrex cv wceq wa notbid ralxfrd dfrex2 3bitr4g ) ABLZDGMZLCLZEHM
      ZLBDGNCEHNAUCUEAUBUDDEFGHIJADOFPQBCKRSRBDGTCEHTUA $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x C $.  $d x ch $.  $d x y ph $.  $d y ps $.
    ralxfr2d.1 $e |- ( ( ph /\ y e. C ) -> A e. V ) $.
    ralxfr2d.2 $e |- ( ph -> ( x e. B <-> E. y e. C x = A ) ) $.
    ralxfr2d.3 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by Mario
       Carneiro, 20-Aug-2014.) $)
    ralxfr2d $p |- ( ph -> ( A. x e. B ps <-> A. y e. C ch ) ) $=
      ( cv wcel wa wceq wex elisset syl wi wrex biimprd r19.23v sylibr r19.21bi
      wral eleq1 mpbidi exlimdv mpd biimpa ralxfrd ) ABCDEFGHAEMHNOZDMZFPZDQZFG
      NZUMFINUPJDFIRSUMUOUQDUOUNGNZUQUMAUOURTZEHAUOEHUAZURTUSEHUFAURUTKUBUOUREH
      UCUDUEUNFGUGUHUIUJAURUTKUKLUL $.

    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by Mario
       Carneiro, 20-Aug-2014.)  (Proof shortened by Mario Carneiro,
       19-Nov-2016.) $)
    rexxfr2d $p |- ( ph -> ( E. x e. B ps <-> E. y e. C ch ) ) $=
      ( wn wral wrex cv wceq wa notbid dfrex2 ralxfr2d 3bitr4g ) ABMZDGNZMCMZEH
      NZMBDGOCEHOAUDUFAUCUEDEFGHIJKADPFQRBCLSUASBDGTCEHTUB $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x A $.  $d x y B $.  $d x C $.
    ralxfr.1 $e |- ( y e. C -> A e. B ) $.
    ralxfr.2 $e |- ( x e. B -> E. y e. C x = A ) $.
    ralxfr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       10-Jun-2005.)  (Revised by Mario Carneiro, 15-Aug-2014.) $)
    ralxfr $p |- ( A. x e. B ph <-> A. y e. C ps ) $=
      ( wral wb wtru cv wcel adantl wceq wrex ralxfrd trud ) ACFKBDGKLMABCDEFGD
      NGOEFOMHPCNZFOUAEQZDGRMIPUBABLMJPST $.

    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  This proof does not use
       ~ ralxfrd .  (Contributed by NM, 10-Jun-2005.)  (Revised by Mario
       Carneiro, 15-Aug-2014.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ralxfrALT $p |- ( A. x e. B ph <-> A. y e. C ps ) $=
      ( wral cv wcel wi rspcv syl com12 ralrimiv wceq wrex nfv biimprcd rexlimd
      nfra1 rsp syl6 syl5 impbii ) ACFKZBDGKZUIBDGDLGMZUIBUKEFMUIBNHABCEFJOPQRU
      JACFCLZFMULESZDGTUJAIUJUMADGBDGUDADUAUJUKBUMANBDGUEUMABJUBUFUCUGRUH $.

    $( Transfer existence from a variable ` x ` to another variable ` y `
       contained in expression ` A ` .  (Contributed by NM, 10-Jun-2005.)
       (Revised by Mario Carneiro, 15-Aug-2014.) $)
    rexxfr $p |- ( E. x e. B ph <-> E. y e. C ps ) $=
      ( wrex wn wral dfrex2 cv wceq notbid ralxfr xchbinxr bitr4i ) ACFKALZCFMZ
      LBDGKZACFNUCBLZDGMUBBDGNUAUDCDEFGHICOEPABJQRST $.
  $}

  ${
    $d x A $.  $d x y D $.  $d y ph $.  $d y ps $.  $d x ch $.
    rabxfrd.1 $e |- F/_ y B $.
    rabxfrd.2 $e |- F/_ y C $.
    rabxfrd.3 $e |- ( ( ph /\ y e. D ) -> A e. D ) $.
    rabxfrd.4 $e |- ( x = A -> ( ps <-> ch ) ) $.
    rabxfrd.5 $e |- ( y = B -> A = C ) $.
    $( Class builder membership after substituting an expression ` A `
       (containing ` y ` ) for ` x ` in the class expression ` ch ` .
       (Contributed by NM, 16-Jan-2012.) $)
    rabxfrd $p |- ( ( ph /\ B e. D ) ->
                 ( C e. { x e. D | ps } <-> B e. { y e. D | ch } ) ) $=
      ( wcel crab wb wa wi imp cv ibibr sylib anbi1d elrab rabid 3bitr4g eleq2d
      ex rabbidva nfcv nfel1 wceq eleq1d elrabf nfrab1 nfel eleq1 pm5.32 sylibr
      3bitr3g ) AGIOZHBDIPZOZGCEIPZOZQZAVBVDRZVBVFRZQVBVGSAGFVCOZEIPZOGEUAZVEOZ
      EIPZOVHVIAVKVNGAVJVMEIAVLIOZRZFIOZCRVOCRVJVMVPVQVOCAVOVQVOQZAVOVQSVOVRSAV
      OVQLUIVOVQUBUCTUDBCDFIMUECEIUFUGUJUHVJVDEGIJEIUKZEHVCKULVLGUMFHVCNUNUOVMV
      FEGIJVSEGVEJCEIUPUQVLGVEURUOVAVBVDVFUSUTT $.
  $}

  ${
    $d x A $.  $d z B $.  $d z C $.  $d x y z D $.  $d y z ph $.  $d x z ps $.
    rabxfr.1 $e |- F/_ y B $.
    rabxfr.2 $e |- F/_ y C $.
    rabxfr.3 $e |- ( y e. D -> A e. D ) $.
    rabxfr.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    rabxfr.5 $e |- ( y = B -> A = C ) $.
    $( Class builder membership after substituting an expression ` A `
       (containing ` y ` ) for ` x ` in the class expression ` ph ` .
       (Contributed by NM, 10-Jun-2005.) $)
    rabxfr $p |- ( B e. D ->
                 ( C e. { x e. D | ph } <-> B e. { y e. D | ps } ) ) $=
      ( wtru wcel crab wb tru cv adantl rabxfrd mpan ) NFHOGACHPOFBDHPOQRNABCDE
      FGHIJDSHOEHONKTLMUAUB $.
  $}

  ${
    $d x y ph $.  $d x ps $.  $d x A $.  $d x y B $.
    reuxfr2d.1 $e |- ( ( ph /\ y e. B ) -> A e. B ) $.
    reuxfr2d.2 $e |- ( ( ph /\ x e. B ) -> E* y e. B x = A ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       16-Jan-2012.)  (Revised by NM, 16-Jun-2017.) $)
    reuxfr2d $p |- ( ph
        -> ( E! x e. B E. y e. B ( x = A /\ ps ) <-> E! y e. B ps ) ) $=
      ( cv wa wrex wreu wrmo wral wi wcel syl ancom 2reuswap wmo wceq ralrimiva
      rmoan rmobii sylib df-rmo ralbii moeq moani an12 bitri mobii mpbi impbid1
      sylbir a1i mprg wb biidd ceqsrexv reubidva bitrd ) ACIZEUAZBJZDFKCFLZVECF
      KZDFLZBDFLAVFVHAVEDFMZCFNVFVHOAVICFAVCFPZJZBVDJZDFMZVIVKVDDFMVMHVDBDFUCQV
      LVEDFBVDRUDUEUBVECDFFSQVJVEJZCTZVHVFOZDFVODFNVECFMZDFNVPVQVODFVECFUFUGVED
      CFFSUOVODIFPZVJBJZVDJZCTVOVDVSCCEUHUIVTVNCVTVDVSJVNVSVDRVDVJBUJUKULUMUPUQ
      UNAVGBDFAVRJEFPVGBURGBBCEFVDBUSUTQVAVB $.
  $}

  ${
    $d x ph $.  $d x A $.  $d x y B $.
    reuxfr2.1 $e |- ( y e. B -> A e. B ) $.
    reuxfr2.2 $e |- ( x e. B -> E* y e. B x = A ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  (Contributed by NM,
       14-Nov-2004.)  (Revised by NM, 16-Jun-2017.) $)
    reuxfr2 $p |- ( E! x e. B E. y e. B ( x = A /\ ph ) <-> E! y e. B ph ) $=
      ( cv wceq wa wrex wreu wb wtru wcel adantl wrmo reuxfr2d trud ) BHZDIZAJC
      EKBELACELMNABCDECHEODEONFPTEOUACEQNGPRS $.
  $}

  ${
    $d x y ph $.  $d y ps $.  $d x ch $.  $d x A $.  $d x y B $.
    reuxfrd.1 $e |- ( ( ph /\ y e. B ) -> A e. B ) $.
    reuxfrd.2 $e |- ( ( ph /\ x e. B ) -> E! y e. B x = A ) $.
    reuxfrd.3 $e |- ( x = A -> ( ps <-> ch ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Use ~ reuhypd to
       eliminate the second hypothesis.  (Contributed by NM, 16-Jan-2012.) $)
    reuxfrd $p |- ( ph -> ( E! x e. B ps <-> E! y e. B ch ) ) $=
      ( wreu cv wceq wa wrex wcel reurex syl biantrurd r19.41v pm5.32i reubidva
      rexbii bitr3i syl6bb wrmo reurmo reuxfr2d bitrd ) ABDGKDLZFMZCNZEGOZDGKCE
      GKABUMDGAUJGPNZBUKEGOZBNZUMUNUOBUNUKEGKZUOIUKEGQRSUPUKBNZEGOUMUKBEGTURULE
      GUKBCJUAUCUDUEUBACDEFGHUNUQUKEGUFIUKEGUGRUHUI $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x A $.  $d x y B $.
    reuxfr.1 $e |- ( y e. B -> A e. B ) $.
    reuxfr.2 $e |- ( x e. B -> E! y e. B x = A ) $.
    reuxfr.3 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Use ~ reuhyp to
       eliminate the second hypothesis.  (Contributed by NM, 14-Nov-2004.) $)
    reuxfr $p |- ( E! x e. B ph <-> E! y e. B ps ) $=
      ( wreu wb wtru cv wcel adantl wceq reuxfrd trud ) ACFJBDFJKLABCDEFDMFNEFN
      LGOCMZFNSEPDFJLHOIQR $.
  $}

  ${
    $d y ph $.  $d y B $.  $d y C $.  $d x y $.
    reuhypd.1 $e |- ( ( ph /\ x e. C ) -> B e. C ) $.
    reuhypd.2 $e |- ( ( ph /\ x e. C /\ y e. C ) -> ( x = A <-> y = B ) ) $.
    $( A theorem useful for eliminating the restricted existential uniqueness
       hypotheses in ~ riotaxfrd .  (Contributed by NM, 16-Jan-2012.) $)
    reuhypd $p |- ( ( ph /\ x e. C ) -> E! y e. C x = A ) $=
      ( cv wcel wa wceq weu wreu cvv elex syl eueq sylib eleq1 syl5ibrcom 3expa
      pm4.71rd wb pm5.32da bitr4d eubidv mpbid df-reu sylibr ) ABIZFJZKZCIZFJZU
      KDLZKZCMZUPCFNUMUNELZCMZURUMEOJZUTUMEFJZVAGEFPQCERSUMUSUQCUMUSUOUSKUQUMUS
      UOUMUOUSVBGUNEFTUAUCUMUOUPUSAULUOUPUSUDHUBUEUFUGUHUPCFUIUJ $.
  $}

  ${
    $d y B $.  $d y C $.  $d x y $.
    reuhyp.1 $e |- ( x e. C -> B e. C ) $.
    reuhyp.2 $e |- ( ( x e. C /\ y e. C ) -> ( x = A <-> y = B ) ) $.
    $( A theorem useful for eliminating the restricted existential uniqueness
       hypotheses in ~ reuxfr .  (Contributed by NM, 15-Nov-2004.) $)
    reuhyp $p |- ( x e. C -> E! y e. C x = A ) $=
      ( wtru cv wcel wceq wreu tru adantl wb 3adant1 reuhypd mpan ) HAIZEJZSCKZ
      BELMHABCDETDEJHFNTBIZEJUAUBDKOHGPQR $.
  $}

  $( The Axiom of Union and its converse.  A class is a set iff its union is a
     set.  (Contributed by NM, 11-Nov-2003.) $)
  uniexb $p |- ( A e. _V <-> U. A e. _V ) $=
    ( cvv wcel cuni uniexg cpw wss pwuni pwexg ssexg sylancr impbii ) ABCZADZBC
    ZABEOANFZGPBCMAHNBIAPBJKL $.

  $( The Axiom of Power Sets and its converse.  A class is a set iff its power
     class is a set.  (Contributed by NM, 11-Nov-2003.) $)
  pwexb $p |- ( A e. _V <-> ~P A e. _V ) $=
    ( cpw cvv wcel cuni uniexb unipw eleq1i bitr2i ) ABZCDJEZCDACDJFKACAGHI $.

  $( The union of the universe is the universe.  Exercise 4.12(c) of
     [Mendelson] p. 235.  (Contributed by NM, 14-Sep-2003.) $)
  univ $p |- U. _V = _V $=
    ( cvv cpw cuni pwv unieqi unipw eqtr3i ) ABZCACAHADEAFG $.

  ${
    eldifpw.1 $e |- C e. _V $.
    $( Membership in a power class difference.  (Contributed by NM,
       25-Mar-2007.) $)
    eldifpw $p |- ( ( A e. ~P B /\ -. C C_ B ) ->
                   ( A u. C ) e. ( ~P ( B u. C ) \ ~P B ) ) $=
      ( cpw wcel wss wn wa cun elpwi unss1 cvv wb unexg mpan2 elpwg syl syl5ibr
      cdif mpd unssbd con3i anim12i eldif sylibr ) ABEZFZCBGZHZIACJZBCJZEZFZUKU
      GFZHZIUKUMUGTFUHUNUJUPUHABGZUNABKUQUNUHUKULGZABCLUHUKMFZUNURNUHCMFUSDACUG
      MOPUKULMQRSUAUOUIUOACBUKBKUBUCUDUKUMUGUEUF $.

    $( Membership in the power class of a union.  (Contributed by NM,
       26-Mar-2007.) $)
    elpwun $p |- ( A e. ~P ( B u. C ) <-> ( A \ C ) e. ~P B ) $=
      ( cun cpw wcel cvv cdif wb difex2 ax-mp sylibr wss elpwg difexg syl uncom
      elex sseq2i ssundif bitri syl6rbbr bitrd pm5.21nii ) ABCEZFZGZAHGZACIZBFZ
      GZAUGSULUJHGZUIUJUKSCHGUIUMJDACHKLMUIUHAUFNZULAUFHOUIULUJBNZUNUIUMULUOJAC
      HPUJBHOQUNACBEZNUOUFUPABCRTACBUAUBUCUDUE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Membership in an extension of a power class.  (Contributed by NM,
       26-Mar-2007.) $)
    elpwunsn $p |- ( A e. ( ~P ( B u. { C } ) \ ~P B ) -> C e. A ) $=
      ( vx csn cun cpw cdif wcel wn wa eldif cv wrex wral wss elpwg dfss3 sylbi
      wi syl6bb notbid biimpa rexnal sylibr wceq elpwi ssel wo elsni orim2i ord
      elun imim2i imp3a 3syl eleq1 biimpd syl6 exp3a com4r pm2.43b rexlimdv imp
      syldan ) ABCEZFZGZBGZHIAVHIZAVIIZJZKZCAIZAVHVILVJVLDMZBIZJZDANZVNVMVPDAOZ
      JZVRVJVLVTVJVKVSVJVKABPVSABVHQDABRUAUBUCVPDAUDUEVJVRVNVJVQVNDAVJVOAIZVQVN
      TVJWAVQWAVNVJWAVQWAVNTZVJWAVQKZVOCUFZWBVJAVGPWAVOVGIZTZWCWDTAVGUGAVGVOUHW
      FWAVQWDWEVQWDTZWAWEVPVOVFIZUIZWGVOBVFUMWIVPWDWHWDVPVOCUJUKULSUNUOUPWDWAVN
      VOCAUQURUSUTVAVBVCVDVES $.
  $}

  ${
    op1stb.1 $e |- A e. _V $.
    op1stb.2 $e |- B e. _V $.
    $( Extract the first member of an ordered pair.  Theorem 73 of [Suppes]
       p. 42.  (See ~ op2ndb to extract the second member, ~ op1sta for an
       alternate version, and ~ op1st for the preferred version.)  (Contributed
       by NM, 25-Nov-2003.) $)
    op1stb $p |- |^| |^| <. A , B >. = A $=
      ( cop cint csn cpr dfop inteqi cin snex prex intpr wss wceq snsspr1 df-ss
      mpbi eqtri intsn ) ABEZFZFAGZFAUCUDUCUDABHZHZFZUDUBUFABCDIJUGUDUEKZUDUDUE
      ALABMNUDUEOUHUDPABQUDUERSTTJACUAT $.
  $}

  ${
    $d x y A $.
    iunpw.1 $e |- A e. _V $.
    $( An indexed union of a power class in terms of the power class of the
       union of its index.  Part of Exercise 24(b) of [Enderton] p. 33.
       (Contributed by NM, 29-Nov-2003.) $)
    iunpw $p |- ( E. x e. A x = U. A <-> ~P U. A = U_ x e. A ~P x ) $=
      ( vy cuni wceq wrex cpw ciun wcel sseq2 biimprcd reximdv com12 ssiun elpw
      cv wss eliun wa uniiun syl6sseqr impbid1 df-pw abeq2i bitri 3bitr4g eqrdv
      vex rexbii ssid uniex eleq2 syl5bbr mpbii sylib elssuni elpwi eqss sylibr
      anim12i ex reximia syl impbii ) AQZBEZFZABGZVGHZABVFHZIZFZVIDVJVLVIDQZVGR
      ZVNVFRZABGZVNVJJVNVLJZVIVOVQVOVIVQVOVHVPABVHVPVOVFVGVNKLMNVQVNABVFIVGABVF
      VNOABUAUBUCVNVGDUIPVRVNVKJZABGVQAVNBVKSVSVPABVPDVKDVFUDUEUJUFUGUHVMVGVKJZ
      ABGZVIVMVGVLJZWAVMVGVGRZWBVGUKWCVGVJJVMWBVGVGBCULPVJVLVGUMUNUOAVGBVKSUPVT
      VHABVFBJZVTVHWDVTTVFVGRZVGVFRZTVHWDWEVTWFVFBUQVGVFURVAVFVGUSUTVBVCVDVE $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y R $.
    $( A well-founded relation has no 3-cycle loops.  Special case of
       Proposition 6.23 of [TakeutiZaring] p. 30.  (Contributed by NM,
       10-Apr-1994.)  (Revised by Mario Carneiro, 22-Jun-2015.) $)
    fr3nr $p |- ( ( R Fr A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
                -. ( B R C /\ C R D /\ D R B ) ) $=
      ( vy vx wcel w3a wbr wn wral wss csn wb snssg syl mpbiri wceq notbid wrex
      wfr wa w3o cv ctp cvv c0 wne tpex a1i simpl cpr df-tp simpr1 simpr2 prssi
      cun syl2anc simpr3 snssd unssd syl5eqss snsstp1 ne0i fri syl22anc ralbidv
      breq2 rextpg adantl mpbid wi snsstp3 breq1 rspcv snsstp2 3orim123d 3ianor
      mpd sylibr 3anrot sylnib ) AEUBZBAHZCAHZDAHZIZUCZDBEJZBCEJZCDEJZIZWKWLWJI
      WIWJKZWKKZWLKZUDZWMKWIFUEZBEJZKZFBCDUFZLZWRCEJZKZFXALZWRDEJZKZFXALZUDZWQW
      IWRGUEZEJZKZFXALZGXAUAZXIWIXAUGHZWDXAAMXAUHUIZXNXOWIBCDUJUKWDWHULWIXABCUM
      ZDNZURABCDUNWIXQXRAWIWEWFXQAMWDWEWFWGUOZWDWEWFWGUPZBCAUQUSWIDAWDWEWFWGUTZ
      VAVBVCWIBXAHZXPWIYBBNXAMZBCDVDWIWEYBYCOXSBXAAPQRZXABVEQGFAXAUGEVFVGWHXNXI
      OWDXMXBXEXHGBCDAAAXJBSZXLWTFXAYEXKWSXJBWREVITVHXJCSZXLXDFXAYFXKXCXJCWREVI
      TVHXJDSZXLXGFXAYGXKXFXJDWREVITVHVJVKVLWIXBWNXEWOXHWPWIDXAHZXBWNVMWIYHXRXA
      MZBCDVNWIWGYHYIOYADXAAPQRWTWNFDXAWRDSWSWJWRDBEVOTVPQWIYBXEWOVMYDXDWOFBXAW
      RBSXCWKWRBCEVOTVPQWICXAHZXHWPVMWIYJCNXAMZBCDVQWIWFYJYKOXTCXAAPQRXGWPFCXAW
      RCSXFWLWRCDEVOTVPQVRVTWJWKWLVSWAWJWKWLWBWC $.
  $}

  $( A set well-founded by epsilon contains no 3-cycle loops.  (Contributed by
     NM, 19-Apr-1994.)  (Revised by Mario Carneiro, 22-Jun-2015.) $)
  epne3 $p |- ( ( _E Fr A /\ ( B e. A /\ C e. A /\ D e. A ) ) ->
                -. ( B e. C /\ C e. D /\ D e. B ) ) $=
    ( cep wfr wcel w3a wa wbr fr3nr wb epelg 3ad2ant2 3ad2ant3 3anbi123d adantl
    3ad2ant1 mtbid ) AEFZBAGZCAGZDAGZHZIBCEJZCDEJZDBEJZHZBCGZCDGZDBGZHZABCDEKUD
    UHULLTUDUEUIUFUJUGUKUBUAUEUILUCBCAMNUCUAUFUJLUBCDAMOUAUBUGUKLUCDBAMRPQS $.

  ${
    $d x y z R $.  $d x y z A $.
    $( Alternate definition of well-ordering.  Definition 6.24(2) of
       [TakeutiZaring] p. 30.  (Contributed by NM, 16-Mar-1997.)  (Proof
       shortened by Andrew Salmon, 12-Aug-2011.) $)
    dfwe2 $p |- ( R We A <-> ( R Fr A /\ A. x e. A A. y e. A
                ( x R y \/ x = y \/ y R x ) ) ) $=
      ( vz wa cv wbr weq w3o wral wn wi wcel w3a wal breq2 r3al 3imtr4g ralbii
      wwe wfr wor df-we df-so simpr ax-1 fr2nr 3adantr3 anbi2d notbid syl5ibcom
      wpo a1i pm2.21 syl6 fr3nr df-3an biimpri ancoms pm2.21d exp3a 3jaod frirr
      nsyl 3ad2antr1 jctild a2d alimdv 2alimdv ralidm equequ2 3orbi123d cbvralv
      ex breq1 bitr3i df-po ancrd impbid2 syl5bb pm5.32i bitri ) CDUACDUBZCDUCZ
      FWDAGZBGZDHZABIZWGWFDHZJZBCKZACKZFCDUDWDWEWMWECDUMZWMFZWDWMABCDUEWDWOWMWN
      WMUFWDWMWNWDWFEGZDHZAEIZWPWFDHZJZECKZBCKZACKZWFWFDHLZWHWGWPDHZFZWQMZFZECK
      BCKACKZWMWNWDWFCNZWGCNZWPCNZOZWTMZEPZBPAPXMXHMZEPZBPAPXCXIWDXOXQABWDXNXPE
      WDXMWTXHWDXMWTXHMWDXMFZWTXGXDXRWQXGWRWSWQXGMXRWQXFUGUNXRWRXFLZXGXRWHWJFZL
      ZWRXSWDXJXKYAXLCWFWGDUHUIWRXTXFWRWJXEWHWFWPWGDQUJUKULXFWQUOUPXRWSXFWQXRWS
      XFFZWQXRWHXEWSOZYBCWFWGWPDUQXFWSYCYCXFWSFWHXEWSURUSUTVEVAVBVCWDXKXJXDXLCW
      FDVDVFVGVOVHVIVJWTABECCCRXHABECCCRSWLXBACWLWLBCKXBWKBCVKWLXABCWKWTBECBEIW
      HWQWIWRWJWSWGWPWFDQBEAVLWGWPWFDVPVMVNTVQTABECDVRSVSVTWAWBWC $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordinals (continued)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The class of all ordinal numbers is ordinal.  Proposition 7.12 of
       [TakeutiZaring] p. 38, but without using the Axiom of Regularity.
       (Contributed by NM, 17-May-1994.) $)
    ordon $p |- Ord On $=
      ( vx vy con0 word wtr cep wwe tron wfr cv wbr weq wral onfr wcel eloni wa
      w3o epel mpbir2an ordtri3or 3orbi123i sylibr syl2an rgen2a dfwe2 df-ord
      biid ) CDCECFGZHUICFIAJZBJZFKZABLZUKUJFKZRZBCMACMNUOABCUJCOUJDZUKDZUOUKCO
      UJPUKPUPUQQUJUKOZUMUKUJOZRUOUJUKUAULURUMUMUNUSABSUMUHBASUBUCUDUEABCFUFTCU
      GT $.
  $}

  $( The epsilon relation well-orders the class of ordinal numbers.
     Proposition 4.8(g) of [Mendelson] p. 244.  (Contributed by NM,
     1-Nov-2003.) $)
  epweon $p |- _E We On $=
    ( con0 word cep wwe ordon ordwe ax-mp ) ABACDEAFG $.

  $( No set contains all ordinal numbers.  Proposition 7.13 of [TakeutiZaring]
     p. 38, but without using the Axiom of Regularity.  This is also known as
     the Burali-Forti paradox (remark in [Enderton] p. 194).  In 1897, Cesare
     Burali-Forti noticed that since the "set" of all ordinal numbers is an
     ordinal class ( ~ ordon ), it must be both an element of the set of all
     ordinal numbers yet greater than every such element.  ZF set theory
     resolves this paradox by not allowing the class of all ordinal numbers to
     be a set (so instead it is a proper class).  Here we prove the denial of
     its existence.  (Contributed by NM, 18-May-1994.) $)
  onprc $p |- -. On e. _V $=
    ( con0 cvv wcel word wn ordon ordirr ax-mp elong mpbiri mto ) ABCZAACZADZME
    FAGHLMNFABIJK $.

  ${
    $d x y A $.
    $( The union of a class of ordinal numbers is ordinal.  Proposition 7.19 of
       [TakeutiZaring] p. 40.  (Contributed by NM, 30-May-1994.)  (Proof
       shortened by Andrew Salmon, 12-Aug-2011.) $)
    ssorduni $p |- ( A C_ On -> Ord U. A ) $=
      ( vx vy con0 wss cuni wtr word cv wral wcel wrex eluni2 wa wi ssel onelss
      syl6 rexlimdv syl5bi anc2r syl ssuni syl8 ralrimiv dftr3 sylibr onelon ex
      ssrdv ordon trssord 3exp mpii sylc ) ADEZAFZGZUQDEZUQHZUPBIZUQEZBUQJURUPV
      BBUQVAUQKZVACIZKZCALZUPVBCVAAMZUPVEVBCAUPVDAKZVEVAVDEZVHNZVBUPVHVEVIOZOVH
      VEVJOOUPVHVDDKZVKADVDPZVDVAQRVHVEVIUAUBVAVDAUCUDSTUEBUQUFUGUPBUQDVCVFUPVA
      DKZVGUPVEVNCAUPVHVLVEVNOVMVLVEVNVDVAUHUIRSTUJURUSDHZUTUKURUSVOUTUQDULUMUN
      UO $.
  $}

  $( The union of a set of ordinal numbers is an ordinal number.  Theorem 9 of
     [Suppes] p. 132.  (Contributed by NM, 1-Nov-2003.) $)
  ssonuni $p |- ( A e. V -> ( A C_ On -> U. A e. On ) ) $=
    ( con0 wss cuni wcel word ssorduni cvv wb uniexg elong syl syl5ibr ) ACDAEZ
    CFZABFZOGZAHQOIFPRJABKOILMN $.

  ${
    ssonuni.1 $e |- A e. _V $.
    $( The union of a set of ordinal numbers is an ordinal number.  Corollary
       7N(d) of [Enderton] p. 193.  (Contributed by NM, 20-Sep-2003.) $)
    ssonunii $p |- ( A C_ On -> U. A e. On ) $=
      ( cvv wcel con0 wss cuni wi ssonuni ax-mp ) ACDAEFAGEDHBACIJ $.
  $}

  $( A way to express the ordinal property of a class in terms of the class of
     ordinal numbers.  Corollary 7.14 of [TakeutiZaring] p. 38 and its
     converse.  (Contributed by NM, 1-Jun-2003.) $)
  ordeleqon $p |- ( Ord A <-> ( A e. On \/ A = On ) ) $=
    ( word con0 wcel wceq wo cvv onprc elex mto w3o ordon ordtri3or mpan2 sylib
    df-3or ord mt3i eloni ordeq mpbiri jaoi impbii ) ABZACDZACEZFZUDUGCADZUHCGD
    HCAIJUDUGUHUDUEUFUHKZUGUHFUDCBZUILACMNUEUFUHPOQRUEUDUFASUFUDUJLACTUAUBUC $.

  $( Any ordinal class is a subclass of the class of ordinal numbers.
     Corollary 7.15 of [TakeutiZaring] p. 38.  (Contributed by NM,
     18-May-1994.)  (Proof shortened by Andrew Salmon, 12-Aug-2011.) $)
  ordsson $p |- ( Ord A -> A C_ On ) $=
    ( word con0 wss ordon wa wcel wceq ordeleqon biimpi adantr ordsseleq mpbird
    wo mpan2 ) ABZCBZACDZEPQFRACGACHNZPSQPSAIJKACLMO $.

  $( An ordinal number is a subset of the class of ordinal numbers.
     (Contributed by NM, 5-Jun-1994.) $)
  onss $p |- ( A e. On -> A C_ On ) $=
    ( con0 wcel word wss eloni ordsson syl ) ABCADABEAFAGH $.

  $( Two ways of saying a class of ordinals is unbounded.  (Contributed by
     Mario Carneiro, 8-Jun-2013.) $)
  ssonprc $p |- ( A C_ On -> ( A e/ _V <-> U. A = On ) ) $=
    ( cvv wnel wcel wn con0 wss cuni wceq df-nel word ssorduni ordeleqon orcomd
    wo sylib ord elex uniexb sylibr syl6 con1d onprc uniexg syl5ib mtoi impbid1
    eleq1 syl5bb ) ABCABDZEZAFGZAHZFIZABJULUKUNULUNUJULUNEUMFDZUJULUNUOULUOUNUL
    UMKUOUNOALUMMPNQUOUMBDZUJUMFRASTUAUBUNUJFBDZUCUJUPUNUQABUDUMFBUHUEUFUGUI $.

  $( The union of an ordinal number is an ordinal number.  (Contributed by NM,
     29-Sep-2006.) $)
  onuni $p |- ( A e. On -> U. A e. On ) $=
    ( con0 wcel wss cuni onss ssonuni mpd ) ABCABDAEBCAFABGH $.

  $( The union of an ordinal class is ordinal.  (Contributed by NM,
     12-Sep-2003.) $)
  orduni $p |- ( Ord A -> Ord U. A ) $=
    ( word con0 wss cuni ordsson ssorduni syl ) ABACDAEBAFAGH $.

  ${
    $d x y z A $.
    $( The intersection (infimum) of a non-empty class of ordinal numbers
       belongs to the class.  Compare Exercise 4 of [TakeutiZaring] p. 45.
       (Contributed by NM, 31-Jan-1997.) $)
    onint $p |- ( ( A C_ On /\ A =/= (/) ) -> |^| A e. A ) $=
      ( vx vy vz con0 wss c0 wne cint wcel wa cv cin wceq wrex wi wel ssel wral
      exp32 word ordon tz7.5 mp3an1 imdistani wn ontri1 syl6bir ex sylan9 com4r
      imp31 ralimdva disj vex elint2 3imtr4g sylan2 com4l imp32 intss1 ad2antrl
      ssrdv eqssd eleq1d biimpd com34 pm2.43d rexlimdv syl5 anabsi5 ) AEFZAGHZA
      IZAJZVLVMKABLZMGNZBAOZVLVOEUAVLVMVRUBBEAUCUDVLVQVOBAVLVPAJZVQVOPVLVSVQVSV
      OVLVSVQVSVOPVLVSVQKKZVSVOVTVPVNAVTVPVNVTCVPVNVLVSVQCBQZCLZVNJZPWAVLVSVQWC
      WAVLVSVQWCPZVLVSKWAVLVPEJZKZWDVLVSWEAEVPRUEWAWFKZDBQUFZDASCDQZDASVQWCWGWH
      WIDAWAWFDLZAJZWHWIPWFWKWHWAWIVLWKWJEJZWEWHWAWIPZPZAEWJRWEWLWNWEWLKWHVPWJF
      WMVPWJUGVPWJWBRUHUIUJUKULUMDAVPUNDWBACUOUPUQURTUSUTVCVSVNVPFVLVQVPAVAVBVD
      VEVFTVGVHVIVJVK $.
  $}

  $( The intersection of a class of ordinal numbers is zero iff the class
     contains zero.  (Contributed by NM, 24-Apr-2004.) $)
  onint0 $p |- ( A C_ On -> ( |^| A = (/) <-> (/) e. A ) ) $=
    ( con0 wss cint c0 wceq wcel wa wne cvv 0ex eleq1 mpbiri intex sylibr onint
    sylan2 wb adantl mpbid ex int0el impbid1 ) ABCZADZEFZEAGZUDUFUGUDUFHUEAGZUG
    UFUDAEIZUHUFUEJGZUIUFUJEJGKUEEJLMANOAPQUFUHUGRUDUEEALSTUAAUBUC $.

  ${
    $d x y A $.
    $( A non-empty class of ordinal numbers has the smallest member.  Exercise
       9 of [TakeutiZaring] p. 40.  (Contributed by NM, 3-Oct-2003.) $)
    onssmin $p |- ( ( A C_ On /\ A =/= (/) ) -> E. x e. A A. y e. A x C_ y ) $=
      ( con0 wss c0 wne wa cint wcel cv wral wrex onint rgen wceq sseq1 ralbidv
      intss1 rspcev sylancl ) CDECFGHCIZCJUBBKZEZBCLZAKZUCEZBCLZACMCNUDBCUCCSOU
      HUEAUBCUFUBPUGUDBCUFUBUCQRTUA $.
  $}

  ${
    $d x y $.
    $( If a property is true for some ordinal number, it is true for a minimal
       ordinal number.  This version uses explicit substitution.  Theorem
       Schema 62 of [Suppes] p. 228.  (Contributed by NM, 29-Sep-2003.) $)
    onminesb $p |- ( E. x e. On ph -> [. |^| { x e. On | ph } / x ]. ph ) $=
      ( con0 wrex crab cint wcel wsbc c0 wne rabn0 wss ssrab2 onint mpan sylbir
      nfcv elrabsf simprbi syl ) ABCDZABCEZFZUBGZABUCHZUAUBIJZUDABCKUBCLUFUDABC
      MUBNOPUDUCCGUEABUCCBCQRST $.

    $d y ph $.
    onminsb.1 $e |- F/ x ps $.
    onminsb.2 $e |- ( x = |^| { x e. On | ph } -> ( ph <-> ps ) ) $.
    $( If a property is true for some ordinal number, it is true for a minimal
       ordinal number.  This version uses implicit substitution.  Theorem
       Schema 62 of [Suppes] p. 228.  (Contributed by NM, 3-Oct-2003.) $)
    onminsb $p |- ( E. x e. On ph -> ps ) $=
      ( con0 wrex crab cint wcel wne rabn0 wss ssrab2 onint sylbir nfrab1 nfint
      c0 mpan nfcv elrabf simprbi syl ) ACFGZACFHZIZUFJZBUEUFSKZUHACFLUFFMUIUHA
      CFNUFOTPUHUGFJBABCUGFCUFACFQRCFUADEUBUCUD $.
  $}

  $( The intersection of a non-empty collection of ordinal numbers is an
     ordinal number.  Compare Exercise 6 of [TakeutiZaring] p. 44.
     (Contributed by NM, 29-Jan-1997.) $)
  oninton $p |- ( ( A C_ On /\ A =/= (/) ) -> |^| A e. On ) $=
    ( con0 wss c0 wne cint wcel onint ex ssel syld imp ) ABCZADEZAFZBGZMNOAGZPM
    NQAHIABOJKL $.

  $( The intersection of a class of ordinal numbers exists iff it is an ordinal
     number.  (Contributed by NM, 6-Nov-2003.) $)
  onintrab $p |- ( |^| { x e. On | ph } e. _V <->
                 |^| { x e. On | ph } e. On ) $=
    ( con0 crab cint cvv wcel c0 wne wss ssrab2 oninton mpan sylbir elex impbii
    intex ) ABCDZEZFGZSCGZTRHIZUARQRCJUBUAABCKRLMNSCOP $.

  $( An existence condition equivalent to an intersection's being an ordinal
     number.  (Contributed by NM, 6-Nov-2003.) $)
  onintrab2 $p |- ( E. x e. On ph <-> |^| { x e. On | ph } e. On ) $=
    ( con0 wrex crab cint cvv wcel intexrab onintrab bitri ) ABCDABCEFZGHLCHABC
    IABJK $.

  $( No member of a set of ordinal numbers belongs to its minimum.
     (Contributed by NM, 2-Feb-1997.) $)
  onnmin $p |- ( ( A C_ On /\ B e. A ) -> -. B e. |^| A ) $=
    ( con0 wss wcel wa cint wn intss1 adantl wb c0 wne ne0i sylan2 ssel2 ontri1
    oninton syl2anc mpbid ) ACDZBAEZFZAGZBDZBUDEHZUBUEUABAIJUCUDCEZBCEUEUFKUBUA
    ALMUGABNAROACBPUDBQST $.

  ${
    $d x A $.  $d x ps $.
    onnminsb.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( An ordinal number smaller than the minimum of a set of ordinal numbers
       does not have the property determining that set. ` ps ` is the wff
       resulting from the substitution of ` A ` for ` x ` in wff ` ph ` .
       (Contributed by NM, 9-Nov-2003.) $)
    onnminsb $p |- ( A e. On -> ( A e. |^| { x e. On | ph } -> -. ps ) ) $=
      ( con0 wcel crab cint wn wa elrab wss ssrab2 onnmin mpan sylbir ex con2d
      ) DFGZBDACFHZIGZTBUBJZTBKDUAGZUCABCDFELUAFMUDUCACFNUADOPQRS $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A way to show that an ordinal number equals the minimum of a non-empty
       collection of ordinal numbers: it must be in the collection, and it must
       not be larger than any member of the collection.  (Contributed by NM,
       14-Nov-2003.) $)
    oneqmin $p |- ( ( B C_ On /\ B =/= (/) ) -> ( A = |^| B <->
                  ( A e. B /\ A. x e. A -. x e. B ) ) ) $=
      ( con0 wss c0 wne wa cint wceq wcel cv wn onint eleq1 syl5ibrcom wi eleq2
      wral adantr biimpd onnmin ex con2d syl9r ralrimdv jcad oneqmini impbid )
      CDEZCFGZHZBCIZJZBCKZALZCKZMZABSZHZULUNUOUSULUOUNUMCKCNBUMCOPUJUNUSQUKUJUN
      URABUNUPBKZUPUMKZUJURUNVAVBBUMUPRUAUJUQVBUJUQVBMCUPUBUCUDUEUFTUGUJUTUNQUK
      ABCUHTUI $.
  $}

  ${
    $d x y A $.
    bm2.5ii.1 $e |- A e. _V $.
    $( Problem 2.5(ii) of [BellMachover] p. 471.  (Contributed by NM,
       20-Sep-2003.) $)
    bm2.5ii $p |- ( A C_ On -> U. A = |^| { x e. On | A. y e. A y C_ x } ) $=
      ( con0 wss cuni wcel cv wral crab cint wceq ssonunii wb unissb a1i inteqi
      rabbiia intmin syl5reqr syl ) CEFCGZEHZUCBIAIZFBCJZAEKZLZMCDNUDUHUCUEFZAE
      KZLUCUJUGUIUFAEUIUFOUEEHBCUEPQSRAUCETUAUB $.
  $}

  ${
    $d x y z $.  $d y z ph $.  $d x z ps $.
    onminex.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( If a wff is true for an ordinal number, there is the smallest ordinal
       number for which it is true.  (Contributed by NM, 2-Feb-1997.)  (Proof
       shortened by Mario Carneiro, 20-Nov-2016.) $)
    onminex $p |- ( E. x e. On ph -> E. x e. On ( ph /\ A. y e. x -. ps ) ) $=
      ( vz con0 wrex wsb wn cv wral wa crab cint wcel wss raleq anbi12d nfv wne
      wsbc c0 ssrab2 rabn0 biimpri oninton sylancr onminesb onss sseld onnminsb
      syl syli ralrimiv wceq dfsbcq2 rspcev syl12anc nfan sbequ12 cbvrex sylibr
      nfs1v weq ) ACGHZACFIZBJZDFKZLZMZFGHZAVHDCKZLZMZCGHVFACGNZOZGPZACVQUBZVHD
      VQLZVLVFVPGQVPUCUAZVRACGUDWAVFACGUEUFVPUGUHZACUIVFVHDVQDKZVQPVFWCGPVHVFVQ
      GWCVFVRVQGQWBVQUJUMUKABCWCEULUNUOVKVSVTMFVQGVIVQUPVGVSVJVTACFVQUQVHDVIVQR
      SURUSVOVKCFGVOFTVGVJCACFVDVJCTUTCFVEAVGVNVJACFVAVHDVMVIRSVBVC $.
  $}

  $( The class of all ordinal numbers is its own successor.  (Contributed by
     NM, 12-Sep-2003.) $)
  sucon $p |- suc On = On $=
    ( con0 cvv wcel wn csuc wceq onprc sucprc ax-mp ) ABCDAEAFGAHI $.

  $( A successor exists iff its class argument exists.  (Contributed by NM,
     22-Jun-1998.) $)
  sucexb $p |- ( A e. _V <-> suc A e. _V ) $=
    ( cvv wcel csn wa cun csuc unexb snex biantru df-suc eleq1i 3bitr4i ) ABCZA
    DZBCZEAOFZBCNAGZBCAOHPNAIJRQBAKLM $.

  $( The successor of a set is a set (generalization).  (Contributed by NM,
     5-Jun-1994.) $)
  sucexg $p |- ( A e. V -> suc A e. _V ) $=
    ( wcel cvv csuc elex sucexb sylib ) ABCADCAEDCABFAGH $.

  ${
    sucex.1 $e |- A e. _V $.
    $( The successor of a set is a set.  (Contributed by NM, 30-Aug-1993.) $)
    sucex $p |- suc A e. _V $=
      ( cvv wcel csuc sucexg ax-mp ) ACDAECDBACFG $.
  $}

  ${
    $d x A $.
    $( The minimum of a class of ordinal numbers is less than the minimum of
       that class with its minimum removed.  (Contributed by NM,
       20-Nov-2003.) $)
    onmindif2 $p |- ( ( A C_ On /\ A =/= (/) ) ->
                   |^| A e. |^| ( A \ { |^| A } ) ) $=
      ( vx con0 wss c0 wne wa cint cdif wcel cv wral eldifsn wn wceq wo adantlr
      csn wb cvv onnmin oninton adantr ssel2 ontri1 onsseleq bitr3d syl2anc ord
      mpbid eqcom syl6ib necon1ad expimpd syl5bi ralrimiv elintg adantl mpbird
      intex sylbi ) ACDZAEFZGZAHZAVERIZHJZVEBKZJZBVFLZVDVIBVFVHVFJVHAJZVHVEFZGV
      DVIVHAVEMVDVKVLVIVDVKGZVIVHVEVMVINVEVHOZVHVEOVMVIVNVMVHVEJNZVIVNPZVBVKVOV
      CAVHUAQVMVECJZVHCJZVOVPSVDVQVKAUBUCVBVKVRVCACVHUDQVQVRGVEVHDVOVPVEVHUEVEV
      HUFUGUHUJUIVEVHUKULUMUNUOUPVCVGVJSZVBVCVETJVSAUTBVEVFTUQVAURUS $.
  $}

  ${
    $d x A $.
    $( The successor of an ordinal number is an ordinal number.  Proposition
       7.24 of [TakeutiZaring] p. 41.  (Contributed by NM, 6-Jun-1994.) $)
    suceloni $p |- ( A e. On -> suc A e. On ) $=
      ( vx con0 wcel csuc word wtr wss cv wral csn wo onelss wi wceq elsn sylbi
      eqimss a1i cvv orim12d cun df-suc eleq2i elun oridm 3imtr3g sssucid sstr2
      bitr2i syl6mpi ralrimiv dftr3 sylibr onss snssi unssd syl5eqss ordon 3exp
      trssord mpii sylc wb sucexg elong syl mpbird ) ACDZAEZCDZVJFZVIVJGZVJCHZV
      LVIBIZVJHZBVJJVMVIVPBVJVIVOVJDZVOAHZAVJHVPVIVOADZVOAKZDZLZVRVRLVQVRVIVSVR
      WAVRAVOMWAVRNVIWAVOAOVRBAPVOARQSUAVQVOAVTUBZDWBVJWCVOAUCZUDVOAVTUEUJVRUFU
      GAUHVOAVJUIUKULBVJUMUNVIVJWCCWDVIAVTCAUOACUPUQURVMVNCFZVLUSVMVNWEVLVJCVAU
      TVBVCVIVJTDVKVLVDACVEVJTVFVGVH $.
  $}

  $( The successor of an ordinal class is ordinal.  (Contributed by NM,
     3-Apr-1995.) $)
  ordsuc $p |- ( Ord A <-> Ord suc A ) $=
    ( cvv wcel word csuc wb elong suceloni eloni syl syl6bir sucidg ordelord ex
    con0 syl5com impbid wn wceq sucprc eqcomd ordeq pm2.61i ) ABCZADZAEZDZFZUDU
    EUGUDUEAOCZUGABGUIUFOCUGAHUFIJKUDAUFCZUGUEABLUGUJUEUFAMNPQUDRZAUFSUHUKUFAAT
    UAAUFUBJUC $.

  ${
    $d x A $.
    $( The collection of ordinals in the power class of an ordinal is its
       successor.  (Contributed by NM, 30-Jan-2005.) $)
    ordpwsuc $p |- ( Ord A -> ( ~P A i^i On ) = suc A ) $=
      ( vx word cpw con0 cin csuc cv wcel wss wa elin vex elpw anbi2ci bitri wb
      ordsssuc expcom pm5.32d simpr wi ordsuc ordelon sylbi ancrd impbid2 bitrd
      ex syl5bb eqrdv ) ACZBADZEFZAGZBHZUNIZUPEIZUPAJZKZULUPUOIZUQUPUMIZURKUTUP
      UMELVBUSURUPABMNOPULUTURVAKZVAULURUSVAURULUSVAQUPARSTULVCVAURVAUAULVAURUL
      UOCZVAURUBAUCVDVAURUOUPUDUIUEUFUGUHUJUK $.

    $( The collection of ordinal numbers in the power set of an ordinal number
       is its successor.  (Contributed by NM, 19-Oct-2004.) $)
    onpwsuc $p |- ( A e. On -> ( ~P A i^i On ) = suc A ) $=
      ( con0 wcel word cpw cin csuc wceq eloni ordpwsuc syl ) ABCADAEBFAGHAIAJK
      $.
  $}

  $( The successor of an ordinal number is an ordinal number.  (Contributed by
     NM, 9-Sep-2003.) $)
  sucelon $p |- ( A e. On <-> suc A e. On ) $=
    ( word cvv wcel wa csuc con0 ordsuc sucexb anbi12i elon2 3bitr4i ) ABZACDZE
    AFZBZOCDZEAGDOGDMPNQAHAIJAKOKL $.

  $( The successor of an element of an ordinal class is a subset of it.
     (Contributed by NM, 21-Jun-1998.) $)
  ordsucss $p |- ( Ord B -> ( A e. B -> suc A C_ B ) ) $=
    ( word wcel csuc wss wi wa ordelord wn ordnbtwn imnan sylibr adantr ordtri1
    wb ordsuc sylanb sylibrd pm2.43b sylan exp31 ) BCZABDZAEZBFZUDUCUDUFGZUCUDU
    CUGUCUDHACZUCUGBAIUHUCHUDBUEDZJZUFUHUDUJGZUCUHUDUIHJUKABKUDUILMNUHUECUCUFUJ
    PAQUEBORSUAUBTT $.

  $( An ordinal number is a proper subset of its successor.  (Contributed by
     Stefan O'Rear, 18-Nov-2014.) $)
  onpsssuc $p |- ( A e. On -> A C. suc A ) $=
    ( con0 wcel csuc wpss sucidg word eloni ordsuc sylib ordelpss syl2anc mpbid
    wb ) ABCZAADZCZAPEZABFOAGZPGZQRNAHZOSTUAAIJAPKLM $.

  $( A set belongs to an ordinal iff its successor is a subset of the ordinal.
     Exercise 8 of [TakeutiZaring] p. 42 and its converse.  (Contributed by NM,
     29-Nov-2003.) $)
  ordelsuc $p |- ( ( A e. C /\ Ord B ) -> ( A e. B <-> suc A C_ B ) ) $=
    ( wcel word wa csuc wss wi ordsucss adantl sucssel adantr impbid ) ACDZBEZF
    ABDZAGBHZPQRIOABJKORQIPABCLMN $.

  ${
    $d x A $.
    $( The successor of an ordinal number is the smallest larger ordinal
       number.  (Contributed by NM, 28-Nov-2003.) $)
    onsucmin $p |- ( A e. On -> suc A = |^| { x e. On | A e. x } ) $=
      ( con0 wcel cv crab cint csuc wss word wb ordelsuc sylan2 rabbidva inteqd
      eloni wceq sucelon intmin sylbi eqtr2d ) BCDZBAEZDZACFZGBHZUCIZACFZGZUFUB
      UEUHUBUDUGACUCCDUBUCJUDUGKUCPBUCCLMNOUBUFCDUIUFQBRAUFCSTUA $.
  $}

  $( Membership is inherited by successors.  Generalization of Exercise 9 of
     [TakeutiZaring] p. 42.  (Contributed by NM, 22-Jun-1998.)  (Proof
     shortened by Andrew Salmon, 12-Aug-2011.) $)
  ordsucelsuc $p |- ( Ord B -> ( A e. B <-> suc A e. suc B ) ) $=
    ( word wcel csuc wa simpl ordelord jca ordsuc sylibr sylanb cvv wb wss wceq
    wi wo adantr elex ancoms adantl ordsucss sucssel impbid sucexb elsucg sylbi
    ordsseleq ad2antrl 3bitr4d ex wn pm5.21ni a1d pm2.61i pm5.21nd ) BCZABDZAEZ
    BEZDZURACZFZURUSFURVCURUSGBAHIURVBFURVCURVBGURVACZVBVCBJVEVBFUTCZVCVAUTHAJZ
    KLIAMDZVDUSVBNZQVHVDVIVHVDFZUTBOZUTBDUTBPRZUSVBVDVKVLNZVHVCURVMVCVFURVMVGUT
    BUILUAUBVJUSVKURUSVKQVHVCABUCUJVHVKUSQVDABMUDSUEVHVBVLNZVDVHUTMDZVNAUFZUTBM
    UGUHSUKULVHUMVIVDUSVHVBABTVBVOVHUTVATVPKUNUOUPUQ $.

  $( The subclass relationship between two ordinal classes is inherited by
     their successors.  (Contributed by NM, 4-Oct-2003.) $)
  ordsucsssuc $p |- ( ( Ord A /\ Ord B ) -> ( A C_ B <-> suc A C_ suc B ) ) $=
    ( word wa wcel wn csuc wss ordsucelsuc notbid adantr ordtri1 ordsuc syl2anb
    wb 3bitr4d ) ACZBCZDBAEZFZBGZAGZEZFZABHUBUAHZQTUDORQSUCBAIJKABLQUBCUACUEUDO
    RAMBMUBUALNP $.

  $( Given an element ` A ` of the union of an ordinal ` B ` , ` suc A ` is an
     element of ` B ` itself.  (Contributed by Scott Fenton, 28-Mar-2012.)
     (Proof shortened by Mario Carneiro, 29-May-2015.) $)
  ordsucuniel $p |- ( Ord B -> ( A e. U. B <-> suc A e. B ) ) $=
    ( word cuni wcel csuc wi orduni ordelord ex syl wa ordsuc sylibr wb wn con0
    wss sylan ordtri1 ordsson ordunisssuc sylan2b 3bitr3d con4bid pm5.21ndd ) B
    CZACZABDZEZAFZBEZUGUICZUJUHGBHZUMUJUHUIAIJKUGULUHUGULLUKCZUHBUKIAMZNJUGUHUJ
    ULOUGUHLZUJULUQUIARZBUKRZUJPZULPZUGBQRUHURUSOBUABAUBSUGUMUHURUTOUNUIATSUHUG
    UOUSVAOUPBUKTUCUDUEJUF $.

  ${
    $d x A $.  $d x B $.
    $( The successor of the maximum (i.e. union) of two ordinals is the maximum
       of their successors.  (Contributed by NM, 28-Nov-2003.) $)
    ordsucun $p |- ( ( Ord A /\ Ord B ) ->
               suc ( A u. B ) = ( suc A u. suc B ) ) $=
      ( vx word wa cun csuc cv con0 wcel wi ordun ordsuc ordelon ex wb ordsssuc
      syl wo wss syl2anb ordssun adantl adantrr adantrl orbi12d 3bitr3d syl6bbr
      sylbi sylan2 elun expcom pm5.21ndd eqrdv ) ADZBDZEZCABFZGZAGZBGZFZUQCHZIJ
      ZVCUSJZVCVBJZUQURDZVEVDKZABLZVGUSDZVHURMVJVEVDUSVCNOUIRUOUTDZVADZVFVDKZUP
      AMBMVKVLEVBDZVMUTVALVNVFVDVBVCNORUAVDUQVEVFPVDUQEZVEVCUTJZVCVAJZSZVFVOVCU
      RTZVCATZVCBTZSZVEVRUQVSWBPVDVCABUBUCUQVDVGVSVEPVIVCURQUJVOVTVPWAVQVDUOVTV
      PPUPVCAQUDVDUPWAVQPUOVCBQUEUFUGVCUTVAUKUHULUMUN $.
  $}

  $( The maximum of two ordinals is equal to one of them.  (Contributed by
     Mario Carneiro, 25-Jun-2015.) $)
  ordunpr $p |- ( ( B e. On /\ C e. On ) -> ( B u. C ) e. { B , C } ) $=
    ( con0 wcel wa cun cpr wceq wss word eloni ordtri2or2 syl2an orcomd ssequn2
    wo ssequn1 orbi12i sylib cvv wb unexg elprg syl mpbird ) ACDZBCDZEZABFZABGD
    ZUIAHZUIBHZPZUHBAIZABIZPUMUHUOUNUFAJBJUOUNPUGAKBKABLMNUNUKUOULBAOABQRSUHUIT
    DUJUMUAABCCUBUIABTUCUDUE $.

  $( The maximum of two ordinals belongs to a third if each of them do.
     (Contributed by NM, 18-Sep-2006.)  (Revised by Mario Carneiro,
     25-Jun-2015.) $)
  ordunel $p |- ( ( Ord A /\ B e. A /\ C e. A ) -> ( B u. C ) e. A ) $=
    ( word wcel w3a cpr cun wss 3adant1 ordelon 3adant3 3adant2 ordunpr syl2anc
    prssi con0 sseldd ) ADZBAEZCAEZFZBCGZABCHZTUAUCAISBCAPJUBBQEZCQEZUDUCESTUEU
    AABKLSUAUFTACKMBCNOR $.

  $( A class of ordinal numbers is a subclass of the successor of its union.
     Similar to Proposition 7.26 of [TakeutiZaring] p. 41.  (Contributed by NM,
     19-Sep-2003.) $)
  onsucuni $p |- ( A C_ On -> A C_ suc U. A ) $=
    ( con0 wss cuni word csuc ssorduni wa ssid ordunisssuc mpbii mpdan ) ABCZAD
    ZEZANFCZAGMOHNNCPNIANJKL $.

  $( An ordinal class is a subclass of the successor of its union.
     (Contributed by NM, 12-Sep-2003.) $)
  ordsucuni $p |- ( Ord A -> A C_ suc U. A ) $=
    ( word con0 wss cuni csuc ordsson onsucuni syl ) ABACDAAEFDAGAHI $.

  $( An ordinal class is either its union or the successor of its union.  If we
     adopt the view that zero is a limit ordinal, this means every ordinal
     class is either a limit or a successor.  (Contributed by NM,
     13-Sep-2003.) $)
  orduniorsuc $p |- ( Ord A -> ( A = U. A \/ A = suc U. A ) ) $=
    ( word cuni wceq csuc wne wss wa wn wcel orduniss wb orduni mpancom biimprd
    ordelssne mpand ordsucss syld ordsucuni jctild df-ne necom bitr3i eqss orrd
    3imtr4g ) ABZAACZDZAUIEZDZUHUIAFZAUKGZUKAGZHUJIZULUHUMUOUNUHUMUIAJZUOUHUIAG
    ZUMUQAKUHUQURUMHZUIBUHUQUSLAMUIAPNOQUIARSATUAUPAUIFUMAUIUBAUIUCUDAUKUEUGUF
    $.

  ${
    $d x y A $.
    $( The class of all ordinal numbers is its own union.  Exercise 11 of
       [TakeutiZaring] p. 40.  (Contributed by NM, 12-Nov-2003.) $)
    unon $p |- U. On = On $=
      ( vx vy con0 cuni cv wcel wrex eluni2 onelon rexlimiva sylbi vex suceloni
      csuc sucid elunii sylancr impbii eqriv ) ACDZCAEZTFZUACFZUBUABEZFZBCGUCBU
      ACHUEUCBCUDUAIJKUCUAUANZFUFCFUBUAALOUAMUAUFCPQRS $.

    $( An ordinal class is equal to the union of its successor.  (Contributed
       by NM, 10-Dec-2004.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    ordunisuc $p |- ( Ord A -> U. suc A = A ) $=
      ( vx word con0 wcel wceq wo csuc ordeleqon cv suceq unieqd id eqeq12d wtr
      cuni eloni ordtr syl vex unisuc sylib vtoclga sucon unon eqtri jaoi sylbi
      unieqi 3eqtr4a ) ACADEZADFZGAHZPZAFZAIUKUOULBJZHZPZUPFZUOBADUPAFZURUNUPAU
      TUQUMUPAKLUTMNUPDEZUPOZUSVAUPCVBUPQUPRSUPBTUAUBUCULDHZPZDUNAVDDPDVCDUDUIU
      EUFULUMVCADKLULMUJUGUH $.

    $( The union of the ordinal subsets of an ordinal number is that number.
       (Contributed by NM, 30-Jan-2005.) $)
    orduniss2 $p |- ( Ord A -> U. { x e. On | x C_ A } = A ) $=
      ( word cv wss con0 crab cuni csuc cpw cin wcel wa df-rab incom inab df-pw
      cab eqcomi abid2 ineq12i 3eqtr3i eqtri ordpwsuc syl5eq unieqd ordunisuc
      eqtrd ) BCZADZBEZAFGZHBIZHBUIULUMUIULBJZFKZUMULUJFLZUKMARZUOUKAFNUPARZUKA
      RZKUSURKUQUOURUSOUPUKAPUSUNURFUNUSABQSAFTUAUBUCBUDUEUFBUGUH $.
  $}

  $( A successor ordinal is the successor of its union.  (Contributed by NM,
     10-Dec-2004.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  onsucuni2 $p |- ( ( A e. On /\ A = suc B ) -> suc U. A = A ) $=
    ( con0 wcel csuc wceq cuni word eleq1 biimpac eloni ordsuc ordunisuc sylbir
    wa suceq syl eqtr4d 3syl unieq unieqd eqeq12d syl5ibr anabsi7 adantr eqtrd
    ) ACDZABEZFZOZAGZEZAEZGZAUGUIULUNFZUJUOUIUHGZEZUHEZGZFZUJUHCDZUHHZUTUIUGVAA
    UHCIJUHKVBUQUHUSVBUPBFZUQUHFVBBHVCBLBMNUPBPQUHMRSUIULUQUNUSUIUKUPFULUQFAUHT
    UKUPPQUIUMURAUHPUAUBUCUDUGUNAFZUIUGAHVDAKAMQUEUF $.

  $( The successor of an ordinal class contains the empty set.  (Contributed by
     NM, 4-Apr-1995.) $)
  0elsuc $p |- ( Ord A -> (/) e. suc A ) $=
    ( word csuc c0 wcel ordsuc wne nsuceq0 ord0eln0 mpbiri sylbi ) ABACZBZDLEZA
    FMNLDGAHLIJK $.

  $( The class of ordinal numbers is a limit ordinal.  (Contributed by NM,
     24-Mar-1995.) $)
  limon $p |- Lim On $=
    ( con0 wlim word c0 wne cuni wceq ordon onn0 unon eqcomi df-lim mpbir3an )
    ABACADEAAFZGHINAJKALM $.

  ${
    onssi.1 $e |- A e. On $.
    $( An ordinal number is a subset of ` On ` .  (Contributed by NM,
       11-Aug-1994.) $)
    onssi $p |- A C_ On $=
      ( con0 wcel wss onss ax-mp ) ACDACEBAFG $.

    $( The successor of an ordinal number is an ordinal number.  Corollary
       7N(c) of [Enderton] p. 193.  (Contributed by NM, 12-Jun-1994.) $)
    onsuci $p |- suc A e. On $=
      ( con0 wcel csuc suceloni ax-mp ) ACDAECDBAFG $.

    $( An ordinal number is either its own union (if zero or a limit ordinal)
       or the successor of its union.  (Contributed by NM, 13-Jun-1994.) $)
    onuniorsuci $p |- ( A = U. A \/ A = suc U. A ) $=
      ( word cuni wceq csuc wo onordi orduniorsuc ax-mp ) ACAADZEAKFEGABHAIJ $.

    ${
      $d x A $.
      $( A limit ordinal is not a successor ordinal.  (Contributed by NM,
         18-Feb-2004.) $)
      onuninsuci $p |- ( A = U. A <-> -. E. x e. On A = suc x ) $=
        ( cv csuc wceq con0 wrex cuni wn wa wcel onirri cun csn wtr sylancr syl
        id sylib df-suc eqeq2i unieq sylbi uniun unisn uneq2i eqtri syl6eq tron
        vex wss eleq1 mpbii trsuc eloni ordtr df-tr eqtrd sylan9eqr sucid eleq2
        word ssequn1 mpbiri adantr mto imnani rexlimivw onuni ax-mp onuniorsuci
        eqeltrd ori suceq eqeq2d rspcev impbii con2bii ) BADZEZFZAGHZBBIZFZWCWE
        JZWBWFAGWBWEWBWEKZBBLBCMWGBVTBWEWBBWDVTWESWBWDVTIZVTNZVTWBWDVTVTOZNZIZW
        IWBBWKFWDWLFWAWKBVTUAUBBWKUCUDWLWHWJIZNWIVTWJUEWMVTWHVTAUKZUFUGUHUIWBWH
        VTULZWIVTFWBVTGLZWOWBGPWAGLZWPUJWBBGLZWQCBWAGUMUNGVTUOQWPVTPZWOWPVTVCWS
        VTUPVTUQRVTURTRWHVTVDTUSUTWBVTBLZWEWBWTVTWALVTWNVABWAVTVBVEVFVMVGVHVIWF
        WDGLZBWDEZFZWCWRXACBVJVKWEXCBCVLVNWBXCAWDGVTWDFWAXBBVTWDVOVPVQQVRVS $.
    $}

    ${
      onsucssi.2 $e |- B e. On $.
      $( A set belongs to an ordinal number iff its successor is a subset of
         the ordinal number.  Exercise 8 of [TakeutiZaring] p. 42 and its
         converse.  (Contributed by NM, 16-Sep-1995.) $)
      onsucssi $p |- ( A e. B <-> suc A C_ B ) $=
        ( con0 wcel word csuc wss wb onordi ordelsuc mp2an ) AEFBGABFAHBIJCBDKA
        BELM $.
    $}
  $}

  $( A successor is not a limit ordinal.  (Contributed by NM, 25-Mar-1995.)
     (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  nlimsucg $p |- ( A e. V -> -. Lim suc A ) $=
    ( csuc wlim wcel word cuni wceq limord ordsuc sylibr limuni ordunisuc eleq2
    wn eqeq2d ordirr notbid syl5ibrcom sucidg con3i syl6 sylbid sylc con2i ) AC
    ZDZABEZUGAFZUFUFGZHZUHOZUGUFFUIUFIAJKUFLUIUKUFAHZULUIUJAUFAMPUIUMAUFEZOZULU
    IUOUMAAEZOAQUMUNUPUFAANRSUHUNABTUAUBUCUDUE $.

  ${
    $d x A $.
    $( An ordinal equal to its union is not a successor.  (Contributed by NM,
       18-Feb-2004.) $)
    orduninsuc $p |- ( Ord A -> ( A = U. A <-> -. E. x e. On A = suc x ) ) $=
      ( word con0 wcel wceq cuni wn wb c0 id unieq eqeq12d eqeq1 rexbidv notbid
      wrex bibi12d cvv mpbiri wo cv ordeleqon cif 0elon elimel onuninsuci dedth
      csuc unon eqcomi onprc vex sucex eleq1 mto a1i nrex 2th jaoi sylbi ) BCBD
      EZBDFZUABBGZFZBAUBZUIZFZADQZHZIZBUCVBVKVCVBVKVBBJUDZVLGZFZVLVGFZADQZHZIBJ
      BVLFZVEVNVJVQVRBVLVDVMVRKBVLLMVRVIVPVRVHVOADBVLVGNOPRAVLBJDUEUFUGUHVCVKDD
      GZFZDVGFZADQZHZIVTWCVSDUJUKWAADWAHVFDEWADSEZULWAWDVGSEVFAUMUNDVGSUOTUPUQU
      RUSVCVEVTVJWCVCBDVDVSVCKBDLMVCVIWBVCVHWAADBDVGNOPRTUTVA $.

    $( An ordinal equal to its union contains the successor of each of its
       members.  (Contributed by NM, 1-Feb-2005.) $)
    ordunisuc2 $p |- ( Ord A -> ( A = U. A <-> A. x e. A suc x e. A ) ) $=
      ( word cuni wceq cv csuc con0 wn wcel wral wi wa wo eloni adantr simpr ex
      syl5bbr bitrd wrex orduninsuc ralnex suceloni syl ordtri3 con2bid onnbtwn
      wb sylan2 imnan sylibr con2d pm2.21 syl6 adantl ax-1 jaod ordtri2or sylan
      a1i wss ancoms orcomd ordsssuc2 biimpd orim12d mpd impbid bitr3d pm5.74da
      impexp ordelon ancrd impbid2 imbi1d ralbidv2 ) BCZBBDEBAFZGZEZAHUAIZVTBJZ
      ABKZABUBWBWAIZAHKVRWDWAAHUCVRWEWCAHBVRVSHJZWELWFVSBJZWCLZLZWHVRWFWEWHVRWF
      MZBVTJZWCNZWEWHWJWAWLWFVRVTCZWAWLIUIWFVTHJWMVSUDVTOUEBVTUFUJUGWJWLWHWJWKW
      HWCWFWKWHLVRWFWKWGIWHWFWGWKWFWGWKMIWGWKILVSBUHWGWKUKULUMWGWCUNUOUPWCWHLWJ
      WCWGUQVAURWJWHWLWJWHMZBVSVBZWGNZWLWJWPWHWJWGWOWFVRWGWONZWFVSCVRWQVSOVSBUS
      UTVCVDPWNWOWKWGWCWJWOWKLWHWJWOWKBVSVEVFPWJWHQVGVHRVIVJVKWIWFWGMZWCLVRWHWF
      WGWCVLVRWRWGWCVRWRWGWFWGQVRWGWFVRWGWFBVSVMRVNVOVPSTVQST $.

    $( An ordinal is zero, a successor ordinal, or a limit ordinal.
       (Contributed by NM, 1-Oct-2003.) $)
    ordzsl $p |- ( Ord A <->
                  ( A = (/) \/ E. x e. On A = suc x \/ Lim A ) ) $=
      ( word c0 wceq cv csuc con0 wrex wlim w3o cuni orduninsuc biimprd unizlim
      wo wn sylibd orrd wcel 3orass or12 bitri sylibr ord0 ordeq suceloni eleq1
      mpbiri syl5ibr eloni syl6com rexlimiv limord 3jaoi impbii ) BCZBDEZBAFZGZ
      EZAHIZBJZKZUQVBURVCPZPZVDUQVBVEUQVBQZBBLEZVEUQVHVGABMNBORSVDURVBVCPPVFURV
      BVCUAURVBVCUBUCUDURUQVBVCURUQDCUEBDUFUIVAUQAHVAUSHTZBHTZUQVIVJVAUTHTUSUGB
      UTHUHUJBUKULUMBUNUOUP $.

    $( An ordinal number is zero, a successor ordinal, or a limit ordinal
       number.  (Contributed by NM, 1-Oct-2003.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    onzsl $p |- ( A e. On <->
               ( A = (/) \/ E. x e. On A = suc x \/ ( A e. _V /\ Lim A ) ) ) $=
      ( con0 wcel c0 wceq cv csuc wrex cvv wlim wa word elex eloni ordzsl 3mix1
      w3o adantl eleq1 3mix2 3jaodan sylan2b syl2anc mpbiri suceloni syl5ibrcom
      3mix3 0elon rexlimiv limelon 3jaoi impbii ) BCDZBEFZBAGZHZFZACIZBJDZBKZLZ
      RZUNUTBMZVCBCNBOVDUTUOUSVARVCABPUTUOVCUSVAUOVCUTUOUSVBQSUSVCUTUSUOVBUASVB
      UOUSUHUBUCUDUOUNUSVBUOUNECDUIBECTUEURUNACUPCDUNURUQCDUPUFBUQCTUGUJBJUKULU
      M $.

    $( An alternate definition of a limit ordinal, which is any ordinal that is
       neither zero nor a successor.  (Contributed by NM, 1-Nov-2004.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    dflim3 $p |- ( Lim A <->
                 ( Ord A /\ -. ( A = (/) \/ E. x e. On A = suc x ) ) ) $=
      ( wlim word c0 wne cuni wceq w3a wa cv csuc con0 wrex wo wn df-lim 3anass
      wb df-ne a1i orduninsuc anbi12d ioran syl6bbr pm5.32i 3bitri ) BCBDZBEFZB
      BGHZIUHUIUJJZJUHBEHZBAKLHAMNZOPZJBQUHUIUJRUHUKUNUHUKULPZUMPZJUNUHUIUOUJUP
      UIUOSUHBETUAABUBUCULUMUDUEUFUG $.

    $( An alternate definition of a limit ordinal.  (Contributed by NM,
       1-Feb-2005.) $)
    dflim4 $p |- ( Lim A <->
                 ( Ord A /\ (/) e. A /\ A. x e. A suc x e. A ) ) $=
      ( wlim word wcel cuni wceq w3a csuc wral dflim2 ordunisuc2 anbi2d pm5.32i
      c0 cv wa 3anass 3bitr4i bitri ) BCBDZOBEZBBFGZHZUAUBAPIBEABJZHZBKUAUBUCQZ
      QUAUBUEQZQUDUFUAUGUHUAUCUEUBABLMNUAUBUCRUAUBUERST $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The successor of a member of a limit ordinal is also a member.
       (Contributed by NM, 3-Sep-2003.) $)
    limsuc $p |- ( Lim A -> ( B e. A <-> suc B e. A ) ) $=
      ( vx wlim wcel csuc word c0 cv wral w3a dflim4 wceq suceq eleq1d 3ad2ant3
      wi rspccv sylbi wtr limord ordtr trsuc ex 3syl impbid ) ADZBAEZBFZAEZUGAG
      ZHAEZCIZFZAEZCAJZKUHUJQZCALUPUKUQULUOUJCBAUMBMUNUIAUMBNORPSUGUKATZUJUHQAU
      AAUBURUJUHABUCUDUEUF $.

    $( A class includes a limit ordinal iff the successor of the class includes
       it.  (Contributed by NM, 30-Oct-2003.) $)
    limsssuc $p |- ( Lim A -> ( A C_ B <-> A C_ suc B ) ) $=
      ( vx wlim wss csuc sssucid sstr2 wa cv wcel wceq wn wi eleq1 biimpcd word
      mpi sylib ex limsuc biimpa wb limord adantr ordelord sylan ordsuc ordtri1
      syl2anc con2bid mpbid sylan9r con2d com23 imp31 ssel2 vex elsuc ord con1d
      wo adantll mpd ssrdv impbid2 ) ADZABEZABFZEZVHBVIEVJBGABVIHRVGVJVHVGVJIZC
      ABVKCJZAKZVLBKZVKVMIVLBLZMZVNVGVJVMVPVGVMVJVPVGVMVJVPNVGVMIVOVJVMVOBAKZVG
      VJMZVOVMVQVLBAOPVGVQVRVGVQIZVIAKZVRVGVQVTABUAUBVSVJVTVSAQZVIQZVJVTMUCVGWA
      VQAUDZUEVSBQZWBVGWAVQWDWCABUFUGBUHSAVIUIUJUKULTUMUNTUOUPVJVMVPVNNVGVJVMIZ
      VNVOWEVNVOWEVLVIKVNVOVBAVIVLUQVLBCURUSSUTVAVCVDTVETVF $.
  $}

  ${
    $d x y $.
    $( Two ways to express the class of non-limit ordinal numbers.  Part of
       Definition 7.27 of [TakeutiZaring] p. 42, who use the symbol K_I for
       this class.  (Contributed by NM, 1-Nov-2004.) $)
    nlimon $p |- { x e. On | ( x = (/) \/ E. y e. On x = suc y ) } =
                   { x e. On | -. Lim x } $=
      ( cv c0 wceq csuc con0 wrex wo wlim wn wcel word wb eloni dflim3 baib syl
      con2bid rabbiia ) ACZDEUABCFEBGHIZUAJZKZAGUAGLUAMZUBUDNUAOUEUCUBUCUEUBKBU
      APQSRT $.
  $}

  ${
    $d x y z A $.
    $( The union of a nonempty class of limit ordinals is a limit ordinal.
       (Contributed by NM, 1-Feb-2005.) $)
    limuni3 $p |- ( ( A =/= (/) /\ A. x e. A Lim x ) -> Lim U. A ) $=
      ( vy vz c0 wne cv wlim wral wa cuni word wcel csuc con0 wss cvv adantl wi
      elunii limeq rspcv vex limelon mpan syl6com ssrdv ssorduni syl wex 0ellim
      n0 expcom syl5 syld exlimiv sylbi wrex eluni2 rspccv limsuc anbi1d syl6bi
      imp exp3a com3r sylcom rexlimdv syl5bi ralrimiv dflim4 syl3anbrc ) BEFZAG
      ZHZABIZJBKZLZEVQMZCGZNZVQMZCVQIZVQHVPVRVMVPBOPVRVPDBODGZBMZVPWDHZWDOMZVOW
      FAWDBVNWDUAZUBZWDQMWFWGDUCWDQUDUEUFUGBUHUIRVMVPVSVMWEDUJVPVSSZDBULWEWJDWE
      VPWFVSWIWFEWDMZWEVSWDUKWKWEVSEWDBTUMUNUOUPUQVDVPWCVMVPWBCVQVTVQMVTWDMZDBU
      RVPWBDVTBUSVPWLWBDBVPWEWFWLWBSVOWFAWDBWHUTWFWLWEWBWFWLWEWBWFWLWEJWAWDMZWE
      JWBWFWLWMWEWDVTVAVBWAWDBTVCVEVFVGVHVIVJRCVQVKVL $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Transfinite induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( The Principle of Transfinite Induction.  Theorem 7.17 of [TakeutiZaring]
       p. 39.  This principle states that if ` A ` is a class of ordinal
       numbers with the property that every ordinal number included in ` A `
       also belongs to ` A ` , then every ordinal number is in ` A ` .

       See theorem ~ tfindes or ~ tfinds for the version involving basis and
       induction hypotheses.  (Contributed by NM, 18-Feb-2004.) $)
    tfi $p |- ( ( A C_ On /\ A. x e. On ( x C_ A -> x e. A ) ) -> A = On ) $=
      ( con0 wss cv wcel wi wral wa wceq cdif cin c0 wrex wn eldifn adantl onss
      eldifi difin0ss syl5com imim1d a2i syl5 imp mtod ralimi2 ralnex sylib wne
      ssdif0 necon3bbii word ordon difss tz7.5 mp3an12 sylbi anim2i eqss sylibr
      ex nsyl2 ) BCDZAEZBDZVEBFZGZACHZIVDCBDZIBCJVIVJVDVICBKZVELMJZAVKNZVJVIVLO
      ZAVKHVMOVHVNACVKVECFZVHGZVEVKFZVNVPVQIVLVGVQVGOVPVECBPQVPVQVLVGGZVQVOVPVR
      VECBSVOVHVRVOVLVFVGVOVECDVLVFVERCBVETUAUBUCUDUEUFVBUGVLAVKUHUIVJOVKMUJZVM
      VJVKMCBUKULCUMVKCDVSVMUNCBUOACVKUPUQURVCUSBCUTVA $.
  $}

  ${
    $d w y z ph $.  $d w x y z $.
    tfis.1 $e |- ( x e. On -> ( A. y e. x [ y / x ] ph -> ph ) ) $.
    $( Transfinite Induction Schema.  If all ordinal numbers less than a given
       number ` x ` have a property (induction hypothesis), then all ordinal
       numbers have the property (conclusion).  Exercise 25 of [Enderton]
       p. 200.  (Contributed by NM, 1-Aug-1994.)  (Revised by Mario Carneiro,
       20-Nov-2016.) $)
    tfis $p |- ( x e. On -> ph ) $=
      ( vz vw cv con0 wcel crab wss wi wral wceq ssrab2 wa nfcv syl5bbr simprbi
      wsb nfrab1 nfss nfcri dfss3 sseq1 rabid eleq1 imbi12d sbequ nfs1v sbequ12
      nfim nfv cbvrab elrab2 ralimi syl5 anc2li vtoclgaf rgen tfi mp2an rabeq2i
      eqcomi ) BGZHIZVFAABHHABHJZHVGHKEGZVGKZVHVGIZLZEHMVGHNABHOVKEHCGZVGIZCVEM
      ZVFAPZLVKBVHHBVHQZVIVJBBVHVGVPABHUAZUBBEVGVQUCULVEVHNZVNVIVOVJVNVEVGKVRVI
      CVEVGUDVEVHVGUERVOVEVGIVRVJABHUFVEVHVGUGRUHVFVNAVNABCTZCVEMVFAVMVSCVEVMVL
      HIVSABFTZVSFVLHVGAFCBUIAVTBFHBHQFHQAFUMABFUJABFUKUNUOSUPDUQURUSUTEVGVAVBV
      DVCS $.
  $}

  ${
    $d y ph $.  $d x y $.
    tfis2f.1 $e |- F/ x ps $.
    tfis2f.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    tfis2f.3 $e |- ( x e. On -> ( A. y e. x ps -> ph ) ) $.
    $( Transfinite Induction Schema, using implicit substitution.  (Contributed
       by NM, 18-Aug-1994.) $)
    tfis2f $p |- ( x e. On -> ph ) $=
      ( wsb cv wral con0 wcel sbie ralbii syl5bi tfis ) ACDACDHZDCIZJBDRJRKLAQB
      DRABCDEFMNGOP $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x y $.
    tfis2.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    tfis2.2 $e |- ( x e. On -> ( A. y e. x ps -> ph ) ) $.
    $( Transfinite Induction Schema, using implicit substitution.  (Contributed
       by NM, 18-Aug-1994.) $)
    tfis2 $p |- ( x e. On -> ph ) $=
      ( nfv tfis2f ) ABCDBCGEFH $.
  $}

  ${
    $d x ps $.  $d y ph $.  $d x ch $.  $d x A $.  $d x y $.
    tfis3.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    tfis3.2 $e |- ( x = A -> ( ph <-> ch ) ) $.
    tfis3.3 $e |- ( x e. On -> ( A. y e. x ps -> ph ) ) $.
    $( Transfinite Induction Schema, using implicit substitution.  (Contributed
       by NM, 4-Nov-2003.) $)
    tfis3 $p |- ( A e. On -> ch ) $=
      ( con0 tfis2 vtoclga ) ACDFJHABDEGIKL $.
  $}

  ${
    $d x v w y z T $.  $d v w y z R $.  $d x v w z S $.  $d x v w z ch $.
    $d x v w y z ph $.  $d w y z ps $.  $d x A $.  $d x th $.
    tfisi.a $e |- ( ph -> A e. V ) $.
    tfisi.b $e |- ( ph -> T e. On ) $.
    tfisi.c $e |- ( ( ph /\ ( R e. On /\ R C_ T ) /\
          A. y ( S e. R -> ch ) ) -> ps ) $.
    tfisi.d $e |- ( x = y -> ( ps <-> ch ) ) $.
    tfisi.e $e |- ( x = A -> ( ps <-> th ) ) $.
    tfisi.f $e |- ( x = y -> R = S ) $.
    tfisi.g $e |- ( x = A -> R = T ) $.
    $( A transfinite induction scheme in "implicit" form where the induction is
       done on an object derived from the object of interest.  (Contributed by
       Stefan O'Rear, 24-Aug-2015.) $)
    tfisi $p |- ( ph -> th ) $=
      ( vv wi vz vw wss ssid wceq wa eqid wcel wal con0 weq eqeq2 anbi2d imbi1d
      cv sseq1 imbi12d albidv eqeq1d imbi2d cbvalv syl6bb wral w3a simp3l simp2
      simp1l eqeltrd simp3r eqsstrd csb wsb simpl3l simpl1l simpr simpl2 onelss
      eleqtrd simpl3r sstrd simpl1r rspcva syl2anc eqidd csbhypf eqcomd equcoms
      sylc nfcv wb nfv sbhypf bicomd spv mp2and ex alrimiv sylib syl121anc 3exp
      eleq1d tfis3 syl spcgv mpi exp3a pm2.43i ) AJJUCZDJUDAXHDTAAXHDAJJUEZAXHU
      FZDTZJUGAGKUHHJUEZXJBTZTZEUIZXIXKTZLAJUJUHXOMHUAUOZUEZAXQJUCZUFZBTZTZEUIZ
      IUBUOZUEZAYDJUCZUFZCTZTZFUIZXOUAUBJUAUBUKZYCHYDUEZYGBTZTZEUIYJYKYBYNEYKXR
      YLYAYMXQYDHULYKXTYGBYKXSYFAXQYDJUPUMUNUQURYNYIEFEFUKZYLYEYMYHYOHIYDQUSYOB
      CYGOUTUQVAVBXQJUEZYBXNEYPXRXLYAXMXQJHULYPXTXJBYPXSXHAXQJJUPUMUNUQURXQUJUH
      ZYJUBXQVCZYCYQYRUFZYBEYSXRXTBYSXRXTVDZAHUJUHHJUCIHUHZCTZFUIZBYSXRAXSVEYTH
      XQUJYSXRXTVFZYQYRXRXTVGVHYTHXQJUUDYSXRAXSVIVJYTESUOHVKZHUHZBESVLZTZSUIUUC
      YTUUHSYTUUFUUGYTUUFUFZAUUEJUCZUUGAXSYSXRUUFVMUUIUUEXQJUUIYQUUEXQUHZUUEXQU
      CYQYRXRXTUUFVNUUIUUEHXQYTUUFVOYSXRXTUUFVPVRZXQUUEVQWHAXSYSXRUUFVSVTUUIIUU
      EUEZAUUJUFZCTZTZFUIZUUEUUEUEZUUNUUGTZUUIUUKYRUUQUULYQYRXRXTUUFWAYJUUQUBUU
      EXQYDUUEUEZYIUUPFUUTYEUUMYHUUOYDUUEIULUUTYGUUNCUUTYFUUJAYDUUEJUPUMUNUQURW
      BWCUUIUUEWDUUPUURUUSTFSFSUKZUUMUURUUOUUSUVAIUUEUUEUUMSFSFUKZUUEIESFUOZHIE
      UVCWIEIWIQWEZWFWGUSUVACUUGUUNCUUGWJSFUVBUUGCBCESUVCCEWKOWLZWMWGUTUQWNWHWO
      WPWQUUHUUBSFUVBUUFUUAUUGCUVBUUEIHUVDXAUVEUQVAWRNWSWTWQWPXBXCXNXPEGKEUOGUE
      ZXLXIXMXKUVFHJJRUSUVFBDXJPUTUQXDWHXEXFXGXE $.
  $}

  ${
    $d x y z $.  $d x A $.  $d x z ch $.  $d x ta $.  $d y z ph $.
    $( Substitutions. $)
    tfinds.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    tfinds.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfinds.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfinds.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfinds.5 $e |- ps $.
    $( Induction hypothesis for successors. $)
    tfinds.6 $e |- ( y e. On -> ( ch -> th ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfinds.7 $e |- ( Lim x -> ( A. y e. x ch -> ph ) ) $.
    $( Principle of Transfinite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the substitutions we
       need.  The last three are the basis, the induction hypothesis for
       successors, and the induction hypothesis for limit ordinals.  Theorem
       Schema 4 of [Suppes] p. 197.  (Contributed by NM, 16-Apr-1995.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    tfinds $p |- ( A e. On -> ta ) $=
      ( vz cv con0 wral wi wcel wlim wn word c0 wceq csuc wrex wo dflim3 notbii
      wa iman eloni pm2.27 syl mpbiri a1d nfra1 nfv nfim sucid rspcv ax-mp syl5
      vex raleq sbie syl5bbr cbvralv cbvralsv 3bitr4g imbi1d syl5ibrcom biimprd
      wsb sbequ a1i syldd rexlimi jaoi syl6 syl5bir syl5bi pm2.61d2 tfis3 ) ACE
      FGHJLFQZRUAZWGUBZCGWGSZATZWIUCWGUDZWGUEUFZWGGQZUGZUFZGRUHZUIZUCULZUCZWHWK
      WIWSGWGUJUKWTWLWRTZWHWKWLWRUMWHXAWRWKWHWLXAWRTWGUNWLWRUOUPWMWKWQWMAWJWMAB
      MIUQURWPWKGRWJAGCGWGUSAGUTVAWNRUAZWPWJDAXBWJDTWPAFWOSZDTXCCXBDWNWOUAXCCTW
      NGVFVBACFWNWOJVCVDNVEWPWJXCDWPAFPVPZPWGSXDPWOSWJXCXDPWGWOVGCXDGPWGCAFGVPW
      NPQUFXDACFGCFUTJVHAGPFVQVIVJAFPWOVKVLVMVNWPDATTXBWPADKVOVRVSVTWAWBWCWDOWE
      WF $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x ch $.  $d x th $.  $d x ta $.  $d y ph $.
    $( Substitutions. $)
    tfindsg.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    tfindsg.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfindsg.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfindsg.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfindsg.5 $e |- ( B e. On -> ps ) $.
    $( Induction hypothesis for successor ordinals. $)
    tfindsg.6 $e |- ( ( ( y e. On /\ B e. On ) /\ B C_ y ) -> ( ch -> th ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfindsg.7 $e |- ( ( ( Lim x /\ B e. On ) /\ B C_ x ) ->
                   ( A. y e. x ( B C_ y -> ch ) -> ph ) ) $.
    $( Transfinite Induction (inference schema), using implicit substitutions.
       The first four hypotheses establish the substitutions we need.  The last
       three are the basis, the induction hypothesis for successors, and the
       induction hypothesis for limit ordinals.  The basis of this version is
       an arbitrary ordinal ` B ` instead of zero.  Remark in [TakeutiZaring]
       p. 57.  (Contributed by NM, 5-Mar-2004.) $)
    tfindsg $p |- ( ( ( A e. On /\ B e. On ) /\ B C_ A ) -> ta ) $=
      ( wcel wi wceq wa con0 wss cv c0 csuc wb sseq2 adantl syl6bir imp imbi12d
      eqeq2 imbi1d ss0 con3i pm2.21d pm5.74d sylan9bbr pm2.61ian imbi2d a1d wex
      vex sucex eqvinc syl5ibr biimpd sylan9r exlimiv sylbi eqcoms imim2i com4r
      wne df-ne anbi2i annim bitri onsssuc suceloni onelpss sylan2 bitrd ancoms
      wn ax-1 syl8 a2d com23 sylbird syl5bir pm2.61d wlim wral ralimdv ad2antlr
      ex pm2.27 syld exp31 com3l com4t tfinds imp31 ) HUAQIUAQZIHUBZEXEIFUCZUBZ
      ARZRXEIUDUBZBRZRXEIGUCZUBZCRZRZXEIXLUEZUBZDRZRXEXFERZRFGHXGUDSZXIXKXEIUDS
      ZXTXIXKUFYAXTTXHXJABXTXHXJUFYAXGUDIUGZUHYAXTABUFZYAXTXGISZYCIUDXGULJUIUJU
      KXTXIXJARYAWEZXKXTXHXJAYBUMYEXJABYEXJYCXJYAIUNUOUPUQURUSUTXGXLSZXIXNXEYFX
      HXMACXGXLIUGKUKUTXGXPSZXIXRXEYGXHXQADXGXPIUGLUKUTXGHSZXIXSXEYHXHXFAEXGHIU
      GMUKUTXEBXJNVAXLUAQZXEXNXRYIXEXNXRRZYIXETZXQIXPSZRZYJXEYMYJRYIYMXNXQXEDYM
      XQXEDRZRXNYLYNXQYNXPIXPISYGYDTZFVBYNFXPIXLGVCVDVEYOYNFYDXEAYGDXEAYDBNJVFY
      GADLVGVHVIVJVKVLVAVMUHYMWEZXQIXPVNZTZYKYJYRXQYLWEZTYPYQYSXQIXPVOVPXQYLVQV
      RYKYRXMYJXEYIXMYRUFXEYITXMIXPQZYRIXLVSYIXEXPUAQYTYRUFXLVTIXPWAWBWCWDYKXNX
      MXRYKXMCXRYKXMCDXRYKXMCDROWQDXQWFWGWHWIWJWKWLWQWHXEXHXGWMZXOGXGWNZAUUAXEX
      HUUBARZUUAXEXHUUCUUAXETXHTUUBXNGXGWNZAXEUUBUUDRUUAXHXEXOXNGXGXEXNWRWOWPPW
      SWTXAXBXCXD $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x ch $.  $d x th $.  $d x ta $.  $d y ph $.
    $( Substitutions. $)
    tfindsg2.1 $e |- ( x = suc B -> ( ph <-> ps ) ) $.
    tfindsg2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfindsg2.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfindsg2.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfindsg2.5 $e |- ( B e. On -> ps ) $.
    $( Induction hypothesis for successor ordinals. $)
    tfindsg2.6 $e |- ( ( y e. On /\ B e. y ) -> ( ch -> th ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfindsg2.7 $e |- ( ( Lim x /\ B e. x ) ->
                   ( A. y e. x ( B e. y -> ch ) -> ph ) ) $.
    $( Transfinite Induction (inference schema), using implicit substitutions.
       The first four hypotheses establish the substitutions we need.  The last
       three are the basis, the induction hypothesis for successors, and the
       induction hypothesis for limit ordinals.  The basis of this version is
       an arbitrary ordinal ` suc B ` instead of zero.  (Unnecessary distinct
       variable restrictions were removed by David Abernethy, 19-Jun-2012.)
       (Contributed by NM, 5-Jan-2005.) $)
    tfindsg2 $p |- ( ( A e. On /\ B e. A ) -> ta ) $=
      ( con0 wcel wa wi csuc wss onelon sucelon sylib eloni ordsucss syl sylbir
      word imp cv wb ordelsuc sylan2 ancoms ex adantr sylbird sylan2br wlim cvv
      wral vex limelon mpan anassrs imbi1d ralbidva imbi12d tfindsg expl mp2and
      mpbid ) HQRZIHRZSZIUAZQRZVRHUBZEVQIQRZVSHIUCIUDZUEVOVPVTVOHUJVPVTTHUFIHUG
      UHUKVOVSVTSETVPVOVSVTEABCDEFGHVRJKLMVSWABWBNUIGULZQRZVSSVRWCUBZCDTZVSWDWA
      WEWFTWBWDWASWEIWCRZWFWAWDWGWEUMZWDWAWCUJZWHWCUFZIWCQUNZUOUPWDWGWFTWAWDWGW
      FOUQURUSUTUKFULZVAZVSSVRWLUBZWECTZGWLVCZATZVSWMWAWNWQTZWBWMWASIWLRZWGCTZG
      WLVCZATZTZWRWMXCWAWMWSXBPUQURWAWMXCWRUMZWMWAWLQRZXDWLVBRWMXEFVDWLVBVEVFWA
      XESZWSWNXBWQXEWAWLUJWSWNUMWLUFIWLQUNUOXFXAWPAXFWTWOGWLXFWCWLRZSWGWECWAXEX
      GWHXEXGSZWAWIWHXHWDWIWLWCUCWJUHWKUOVGVHVIVHVJUOUPVNUTUKVKVLURVM $.
  $}

  ${
    $d x y z $.  $d y z ph $.
    tfindes.1 $e |- [. (/) / x ]. ph $.
    tfindes.2 $e |- ( x e. On -> ( ph -> [. suc x / x ]. ph ) ) $.
    tfindes.3 $e |- ( Lim y -> ( A. x e. y ph -> [. y / x ]. ph ) ) $.
    $( Transfinite Induction with explicit substitution.  The first hypothesis
       is the basis, the second is the induction hypothesis for successors, and
       the third is the induction hypothesis for limit ordinals.  Theorem
       Schema 4 of [Suppes] p. 197.  (Contributed by NM, 5-Mar-2004.) $)
    tfindes $p |- ( x e. On -> ph ) $=
      ( vz cv wsbc c0 csuc dfsbcq sbceq2a con0 wcel nfsbc1v nfim imbi12d wral
      wi nfv weq eleq1 sbceq1a wceq wb suceq syl chvar wlim wsb cbvralsv ralbii
      sbsbc bitri syl5bir tfinds ) ABCHZIZABJIABGHZIZABUTKZIZACGBHZABURJLABURUT
      LABURVBLABURMDVDNOZAABVDKZIZTZTUTNOZVAVCTZTBGVIVJBVIBUAVAVCBABUTPABVBPQQB
      GUBZVEVIVHVJVDUTNUCVKAVAVGVCABUTUDVKVFVBUEVGVCUFVDUTUGABVFVBLUHRREUIVAGUR
      SZABURSZURUJUSVMABGUKZGURSVLABGURULVNVAGURABGUNUMUOFUPUQ $.
  $}

  ${
    $d x y ta $.  $d x ps $.  $d x ch $.  $d x th $.  $d y ph $.
    $( Substitutions. $)
    tfinds2.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    tfinds2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfinds2.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    $( Basis. $)
    tfinds2.4 $e |- ( ta -> ps ) $.
    $( Induction hypothesis for successors. $)
    tfinds2.5 $e |- ( y e. On -> ( ta -> ( ch -> th ) ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfinds2.6 $e |- ( Lim x -> ( ta -> ( A. y e. x ch -> ph ) ) ) $.
    $( Transfinite Induction (inference schema), using implicit substitutions.
       The first three hypotheses establish the substitutions we need.  The
       last three are the basis and the induction hypotheses (for successor and
       limit ordinals respectively).  Theorem Schema 4 of [Suppes] p. 197.  The
       wff ` ta ` is an auxiliary antecedent to help shorten proofs using this
       theorem.  (Contributed by NM, 4-Sep-2004.) $)
    tfinds2 $p |- ( x e. On -> ( ta -> ph ) ) $=
      ( wi wsbc sbcie wcel cvv ax-mp wb c0 0ex cv wceq imbi2d con0 csuc vex a2d
      mpbir sbcth sbcimg mpbi sbcel1v 3imtr3i bicomd equcoms sucex sbcbii suceq
      weq sbcco2 bitr3i 3imtr3g wral sbsbc sbralie r19.21v syl5bi limeq syl5bir
      wlim wsb tfindes ) EANZFGVOFUAOEBNZKVOVPFUAUBFUCZUAUDABEHUEPUJVQUFQZECNZG
      VQOZEDNZGVQOZVOVOFVQUGZOZGUCZUFQZGVQOZVSWANZGVQOZVRVTWBNZWFWHNZGVQOZWGWIN
      ZVQRQZWLFUHZWKGVQRWFECDLUIUKSWNWLWMTWOWFWHGVQRULSUMGVQUFUNWNWIWJTWOVSWAGV
      QRULSUOVSVOGVQWOGFVACAECATFGFGVAACIUPUQUEZPWBVOFWEUGZOZGVQOWDWRWAGVQVOWAF
      WQWEGUHZURVQWQUDADEJUEPUSVOFGWCWQVQWEUTVBVCVDVOFWEVEZVSGVQVEZFWEOZWEVLZVO
      FWEOZXBXAFGVMWTXAFGVFVSVOGFWPVGVCVQVLZFWEOZXAVONZFWEOZXCXBXDNZXEXGNZFWEOZ
      XFXHNZWERQZXKWSXJFWERXAECGVQVEZNXEVOECGVQVHXEEXNAMUIVIUKSXMXKXLTWSXEXGFWE
      RULSUMXEXCFWEWSVQWEVJPXMXHXITWSXAVOFWERULSUOVKVN $.
  $}

  ${
    $d x A $.  $d y ph $.  $d x ch $.  $d x ta $.  $d x y et $.
    $( Substitutions. $)
    tfinds3.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    tfinds3.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    tfinds3.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    tfinds3.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    tfinds3.5 $e |- ( et -> ps ) $.
    $( Induction hypothesis for successors. $)
    tfinds3.6 $e |- ( y e. On -> ( et -> ( ch -> th ) ) ) $.
    $( Induction hypothesis for limit ordinals. $)
    tfinds3.7 $e |- ( Lim x -> ( et -> ( A. y e. x ch -> ph ) ) ) $.
    $( Principle of Transfinite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the substitutions we
       need.  The last three are the basis, the induction hypothesis for
       successors, and the induction hypothesis for limit ordinals.
       (Contributed by NM, 6-Jan-2005.)  (Revised by David Abernethy,
       21-Jun-2011.) $)
    tfinds3 $p |- ( A e. On -> ( et -> ta ) ) $=
      ( wi cv wceq imbi2d c0 csuc con0 wcel a2d wral wlim r19.21v syl5bi tfinds
      ) FAQZFBQFCQZFDQFEQGHIGRZUASABFJTUMHRZSACFKTUMUNUBSADFLTUMISAEFMTNUNUCUDF
      CDOUEULHUMUFFCHUMUFZQUMUGZUKFCHUMUHUPFUOAPUEUIUJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The natural numbers (i.e. finite ordinals)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new symbol. $)
  $c om $. $( Greek letter omega $)

  $( Extend class notation to include the class of natural numbers. $)
  com $a class om $.

  ${
    $d x y $.
    $( Define the class of natural numbers, which are all ordinal numbers that
       are less than every limit ordinal, i.e. all finite ordinals.  Our
       definition is a variant of the Definition of N of [BellMachover]
       p. 471.  See ~ dfom2 for an alternate definition.  Later, when we assume
       the Axiom of Infinity, we show ` om ` is a set in ~ omex , and ` om `
       can then be defined per ~ dfom3 (the smallest inductive set) and
       ~ dfom4 .

       _Note_: the natural numbers ` om ` are a subset of the ordinal numbers
       ~ df-on .  They are completely different from the natural numbers ` NN `
       ( ~ df-nn ) that are a subset of the complex numbers defined much later
       in our development, although the two sets have analogous properties and
       operations defined on them.  (Contributed by NM, 15-May-1994.) $)
    df-om $a |- om = { x e. On | A. y ( Lim y -> x e. y ) } $.
  $}

  ${
    $d x z $.  $d y z $.
    $( An alternate definition of the set of natural numbers ` om ` .
       Definition 7.28 of [TakeutiZaring] p. 42, who use the symbol K_I for the
       inner class builder of non-limit ordinal numbers (see ~ nlimon ).
       (Contributed by NM, 1-Nov-2004.) $)
    dfom2 $p |- om = { x e. On | suc x C_ { y e. On | -. Lim y } } $=
      ( vz com cv wlim wcel wi wal con0 crab csuc wn df-om wa wb onsssuc impexp
      wss cvv ontri1 bitr3d ancoms weq limeq elrab a1i imbi12d pm5.74da limelon
      notbid vex mpan pm4.71ri imbi1i con34b ibar imbi2d syl5bb 3bitri syl6rbbr
      pm5.74i simpr suceloni onelon ex ancrd impbid2 imbi1d syl5bbr bitrd dfss2
      syl albidv syl6bbr rabbiia eqtri ) DCEZFZAEZVRGZHZCIZAJKVTLZBEZFZMZBJKZSZ
      AJKACNWCWIAJVTJGZWCVRWDGZVRWHGZHZCIWIWJWBWMCWJWBVRJGZWMHZWMWJWOWNWAMZWNVS
      MZOZHZHZWBWJWNWMWSWJWNOZWKWPWLWRWNWJWKWPPWNWJOVRVTSWKWPVRVTQVRVTUAUBUCWLW
      RPXAWGWQBVRJBCUDWFVSWEVRUEUKUFUGUHUIWBWNVSOZWAHWNWBHWTVSXBWAVSWNVRTGVSWNC
      ULVRTUJUMUNUOWNVSWARWNWBWSWBWPWQHWNWSVSWAUPWNWQWRWPWNWQUQURUSVBUTVAWOWNWK
      OZWLHWJWMWNWKWLRWJXCWKWLWJXCWKWNWKVCWJWKWNWJWDJGZWKWNHVTVDXDWKWNWDVRVEVFV
      MVGVHVIVJVKVNCWDWHVLVOVPVQ $.
  $}

  ${
    $d A x y $.
    $( Membership in omega.  The left conjunct can be eliminated if we assume
       the Axiom of Infinity; see ~ elom3 .  (Contributed by NM,
       15-May-1994.) $)
    elom $p |- ( A e. om <-> ( A e. On /\ A. x ( Lim x -> A e. x ) ) ) $=
      ( vy cv wlim wcel wi wal con0 com wceq eleq1 imbi2d albidv df-om elrab2 )
      ADZEZCDZQFZGZAHRBQFZGZAHCBIJSBKZUAUCAUDTUBRSBQLMNCAOP $.
  $}

  ${
    $d x y $.
    $( Omega is a subset of ` On ` .  (Contributed by NM, 13-Jun-1994.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    omsson $p |- om C_ On $=
      ( vx vy com cv csuc wlim wn con0 crab wss dfom2 ssrab2 eqsstri ) CADEBDFG
      BHIJZAHIHABKNAHLM $.
  $}

  ${
    $d x y A $.
    $( The class of natural numbers is a subclass of any (infinite) limit
       ordinal.  Exercise 1 of [TakeutiZaring] p. 44.  Remarkably, our proof
       does not require the Axiom of Infinity.  (Contributed by NM,
       30-Oct-2003.) $)
    limomss $p |- ( Lim A -> om C_ A ) $=
      ( vx vy word wlim com wss limord con0 wcel wceq wo wi ordeleqon wa cv wal
      elom simprbi limeq eleq2 imbi12d spcgv syl5 com23 imp ssrdv omsson mpbiri
      ex sseq2 a1d jaoi sylbi mpcom ) ADZAEZFAGZAHUPAIJZAIKZLUQURMZANUSVAUTUSUQ
      URUSUQOBFAUSUQBPZFJZVBAJZMUSVCUQVDVCCPZEZVBVEJZMZCQZUSUQVDMZVCVBIJVICVBRS
      VHVJCAIVEAKVFUQVGVDVEATVEAVBUAUBUCUDUEUFUGUJUTURUQUTURFIGUHAIFUKUIULUMUNU
      O $.
  $}

  $( A natural number is an ordinal number.  (Contributed by NM,
     27-Jun-1994.) $)
  nnon $p |- ( A e. om -> A e. On ) $=
    ( com con0 omsson sseli ) BCADE $.

  ${
    nnoni.1 $e |- A e. om $.
    $( A natural number is an ordinal number.  (Contributed by NM,
       27-Jun-1994.) $)
    nnoni $p |- A e. On $=
      ( com wcel con0 nnon ax-mp ) ACDAEDBAFG $.
  $}

  $( A natural number is ordinal.  (Contributed by NM, 17-Oct-1995.) $)
  nnord $p |- ( A e. om -> Ord A ) $=
    ( com wcel con0 word nnon eloni syl ) ABCADCAEAFAGH $.

  ${
    $d x y z $.
    $( Omega is ordinal.  Theorem 7.32 of [TakeutiZaring] p. 43.  (Contributed
       by NM, 18-Oct-1995.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    ordom $p |- Ord om $=
      ( vy vx vz com wtr con0 wss word wel cv wcel wa wi wal wlim onelon expcom
      dftr2 limord elom ordtr trel 3syl exp3a a2d alimdv anim12d 3imtr4g ax-gen
      com12 imp mpgbir omsson ordon trssord mp3an ) DEZDFGFHDHUQABIZBJZDKZLAJZD
      KZMZBNAABDRVCBURUTVBURUSFKZCJZOZBCIZMZCNZLVAFKZVFACIZMZCNZLUTVBURVDVJVIVM
      VDURVJUSVAPQURVHVLCURVFVGVKVFURVGVKMVFURVGVKVFVEHVEEURVGLVKMVESVEUAVEVAUS
      UBUCUDUJUEUFUGCUSTCVATUHUKUIULUMUNDFUOUP $.
  $}

  $( A member of a natural number is a natural number.  (Contributed by NM,
     21-Jun-1998.) $)
  elnn $p |- ( ( A e. B /\ B e. om ) -> A e. om ) $=
    ( com word wtr wcel wa wi ordom ordtr trel mp2b ) CDCEABFBCFGACFHICJCABKL
    $.

  $( The class of natural numbers ` om ` is either an ordinal number (if we
     accept the Axiom of Infinity) or the proper class of all ordinal numbers
     (if we deny the Axiom of Infinity).  Remark in [TakeutiZaring] p. 43.
     (Contributed by NM, 10-May-1998.) $)
  omon $p |- ( om e. On \/ om = On ) $=
    ( com word con0 wcel wceq wo ordom ordeleqon mpbi ) ABACDACEFGAHI $.

  ${
    $( Omega is an ordinal number.  (Contributed by Mario Carneiro,
       30-Jan-2013.) $)
    omelon2 $p |- ( om e. _V -> om e. On ) $=
      ( com con0 wcel cvv wn wceq omon ori onprc eleq1 mtbiri syl con4i ) ABCZA
      DCZNEABFZOENPGHPOBDCIABDJKLM $.
  $}

  ${
    $d x y A $.
    $( A natural number is not a limit ordinal.  (Contributed by NM,
       18-Oct-1995.) $)
    nnlim $p |- ( A e. om -> -. Lim A ) $=
      ( vx com wcel wlim word wn nnord ordirr syl cv wal con0 elom simprbi wceq
      wi limeq eleq2 imbi12d spcgv mpd mtod ) ACDZAEZAADZUDAFUFGAHAIJUDBKZEZAUG
      DZQZBLZUEUFQZUDAMDUKBANOUJULBACUGAPUHUEUIUFUGARUGAASTUAUBUC $.

    $( The class of natural numbers is a subclass of the class of non-limit
       ordinal numbers.  Exercise 4 of [TakeutiZaring] p. 42.  (Contributed by
       NM, 2-Nov-2004.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    omssnlim $p |- om C_ { x e. On | -. Lim x } $=
      ( com cv wlim wn con0 crab wss wral omsson nnlim rgen ssrab mpbir2an ) BA
      CZDEZAFGHBFHPABIJPABOKLPAFBMN $.
  $}

  $( Omega is a limit ordinal.  Theorem 2.8 of [BellMachover] p. 473.  Our
     proof, however, does not require the Axiom of Infinity.  (Contributed by
     NM, 26-Mar-1995.)  (Proof shortened by Mario Carneiro, 2-Sep-2015.) $)
  limom $p |- Lim om $=
    ( vx com word wlim ordom con0 wcel wceq wo ordeleqon cv wi wal ordirr ax-mp
    wn elom baib mtbii limeq limomss wb limord ordsseleq sylancr mpbid biimprcd
    wss ord syld con1d com12 alrimiv nsyl2 limon mpbiri jaoi sylbi ) BCZBDZEUSB
    FGZBFHZIUTBJVAUTVBVAAKZDZBVCGZLZAMZUTVABBGZVGUSVHPEBNOVHVAVGABQRSUTPZVFAVDV
    IVEVDVEUTVDVEPBVCHZUTVDVEVJVDBVCUHZVEVJIZVCUAVDUSVCCVKVLUBEVCUCBVCUDUEUFUIV
    JUTVDBVCTUGUJUKULUMUNVBUTFDUOBFTUPUQURO $.

  $( A class belongs to omega iff its successor does.  (Contributed by NM,
     3-Dec-1995.) $)
  peano2b $p |- ( A e. om <-> suc A e. om ) $=
    ( com wlim wcel csuc wb limom limsuc ax-mp ) BCABDAEBDFGBAHI $.

  ${
    $d x y A $.
    $( A nonzero natural number is a successor.  (Contributed by NM,
       18-Feb-2004.) $)
    nnsuc $p |- ( ( A e. om /\ A =/= (/) ) -> E. x e. om A = suc x ) $=
      ( com wcel c0 wne wa cv csuc wceq con0 wrex wlim wn nnlim adantr wi nnord
      word cuni orduninsuc w3a df-lim biimpri 3expia sylbird sylan mt3d biimpcd
      wb eleq1 peano2b syl6ibr ancrd adantld reximdv2 mpd ) BCDZBEFZGZBAHZIZJZA
      KLZVCACLZUTVDBMZURVFNUSBOPURBSZUSVDNZVFQBRVGUSGVHBBTJZVFVGVIVHUJUSABUAPVG
      USVIVFVFVGUSVIUBBUCUDUEUFUGUHURVDVEQUSURVCVCAKCURVCVACDZVCGVAKDURVCVJURVC
      VBCDZVJVCURVKBVBCUKUIVAULUMUNUOUPPUQ $.
  $}

  ${
    $d x A $.
    $( An ordinal subclass of non-limit ordinals is a class of natural
       numbers.  Exercise 7 of [TakeutiZaring] p. 42.  (Contributed by NM,
       2-Nov-2004.) $)
    ssnlim $p |- ( ( Ord A /\ A C_ { x e. On | -. Lim x } ) -> A C_ om ) $=
      ( word cv wlim wn con0 crab wss wa com wcel limom ssel limeq notbid elrab
      wceq simprbi syl6 mt2i adantl wb ordom ordtri1 mpan2 adantr mpbird ) BCZB
      ADZEZFZAGHZIZJBKIZKBLZFZUNUQUIUNUPKEZMUNUPKUMLZURFZBUMKNUSKGLUTULUTAKGUJK
      RUKURUJKOPQSTUAUBUIUOUQUCZUNUIKCVAUDBKUEUFUGUH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Peano's postulates
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Zero is a natural number.  One of Peano's 5 postulates for arithmetic.
     Proposition 7.30(1) of [TakeutiZaring] p. 42.  Note:  Unlike most
     textbooks, our proofs of ~ peano1 through ~ peano5 do not use the Axiom of
     Infinity.  Unlike Takeuti and Zaring, they also do not use the Axiom of
     Regularity.  (Contributed by NM, 15-May-1994.) $)
  peano1 $p |- (/) e. om $=
    ( com wlim c0 wcel limom 0ellim ax-mp ) ABCADEAFG $.

  $( The successor of any natural number is a natural number.  One of Peano's 5
     postulates for arithmetic.  Proposition 7.30(2) of [TakeutiZaring] p. 42.
     (Contributed by NM, 3-Sep-2003.) $)
  peano2 $p |- ( A e. om -> suc A e. om ) $=
    ( com wcel csuc peano2b biimpi ) ABCADBCAEF $.

  $( The successor of any natural number is not zero.  One of Peano's 5
     postulates for arithmetic.  Proposition 7.30(3) of [TakeutiZaring] p. 42.
     (Contributed by NM, 3-Sep-2003.) $)
  peano3 $p |- ( A e. om -> suc A =/= (/) ) $=
    ( csuc c0 wne com wcel nsuceq0 a1i ) ABCDAEFAGH $.

  $( Two natural numbers are equal iff their successors are equal, i.e. the
     successor function is one-to-one.  One of Peano's 5 postulates for
     arithmetic.  Proposition 7.30(4) of [TakeutiZaring] p. 43.  (Contributed
     by NM, 3-Sep-2003.) $)
  peano4 $p |- ( ( A e. om /\ B e. om ) -> ( suc A = suc B <-> A = B ) ) $=
    ( com wcel con0 csuc wceq wb nnon suc11 syl2an ) ACDAEDBEDAFBFGABGHBCDAIBIA
    BJK $.

  ${
    $d x y A $.
    $( The induction postulate: any class containing zero and closed under the
       successor operation contains all natural numbers.  One of Peano's 5
       postulates for arithmetic.  Proposition 7.30(5) of [TakeutiZaring]
       p. 43, except our proof does not require the Axiom of Infinity.  The
       more traditional statement of mathematical induction as a theorem
       schema, with a basis and an induction hypothesis, is derived from this
       theorem as theorem ~ findes .  (Contributed by NM, 18-Feb-2004.) $)
    peano5 $p |- ( ( (/) e. A /\
                 A. x e. om ( x e. A -> suc x e. A ) ) -> om C_ A ) $=
      ( vy c0 wcel cv csuc wi com wral wa wceq wss wrex wn adantl wne eleq1 nfv
      exp32 cdif cin eldifn eldifi biimpcd necon3bd mpan9 nnsuc syl2anc adantlr
      elndif adantr nfra1 nfan rsp vex sucid eleq2 mpbiri peano2b syl6bbr minel
      neldif sylan2 syl6bi mpid imp3a eleq1a com12 imim12d com13 sylan9 rexlimd
      syl5 a1i imp41 mpd mtand nrexdv ordom difss tz7.5 mp3an12 necon1bi ssdif0
      word syl sylibr ) DBEZAFZBEZWJGZBEZHZAIJZKZIBUAZDLZIBMWPWQCFZUBDLZCWQNZOW
      RWPWTCWQWPWSWQEZKZWTWSBEZXBXDOWPWSIBUCPXCWTKWSWLLZAINZXDXCXFWTWIXBXFWOWIX
      BKWSIEZWSDQZXFXBXGWIWSIBUDZPWIDWQEZOXBXHDBIUKXBXJWSDWSDLXBXJWSDWQRUEUFUGA
      WSUHUIUJULWIWOXBWTXFXDHZWOXBWTXKHHHWIWOXBWTXKWOXBWTKZKXEXDAIWOXLAWNAIUMXL
      ASUNXDASWOWJIEZWNXLXEXDHWNAIUOXEWNXLXDXEXLWKWMXDXEXBWTWKXBXGXEWTWKHZXIXEX
      GWJWSEZXNXEXOWJWLEWJAUPUQWSWLWJURUSXEXGXMXOXNHXEXGWLIEXMWSWLIRWJUTVAXMXOW
      TWKXOWTKXMWJWQEOWKWJWSWQVBWJIBVCVDTVEVFVNVGWMXEXDWLBWSVHVIVJVKVLVMTVOVPVQ
      VRVSXAWQDIWFWQIMWQDQXAVTIBWACIWQWBWCWDWGIBWEWH $.
  $}

  ${
    $d x A $.
    $( A natural number is either 0 or a successor.  (Contributed by NM,
       27-May-1998.) $)
    nn0suc $p |- ( A e. om -> ( A = (/) \/ E. x e. om A = suc x ) ) $=
      ( com wcel c0 wceq cv csuc wrex wn wne df-ne nnsuc sylan2br ex orrd ) BCD
      ZBEFZBAGHFACIZQRJZSTQBEKSBELABMNOP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite induction (for finite ordinals)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    find.1 $e |- ( A C_ om /\ (/) e. A /\ A. x e. A suc x e. A ) $.
    $( The Principle of Finite Induction (mathematical induction).  Corollary
       7.31 of [TakeutiZaring] p. 43.  The simpler hypothesis shown here was
       suggested in an email from "Colin" on 1-Oct-2001.  The hypothesis states
       that ` A ` is a set of natural numbers, zero belongs to ` A ` , and
       given any member of ` A ` the member's successor also belongs to
       ` A ` .  The conclusion is that every natural number is in ` A ` .
       (Contributed by NM, 22-Feb-2004.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    find $p |- A = om $=
      ( com wss c0 wcel cv csuc wral simp1i wi wa w3a 3simpc ax-mp df-ral alral
      wal sylbi anim2i peano5 eqssi ) BDBDEZFBGZAHZIBGZABJZCKUEUFBGUGLZADJZMZDB
      EUEUHMZUKUDUEUHNULCUDUEUHOPUHUJUEUHUIASUJUGABQUIADRTUAPABUBPUC $.
  $}

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    finds.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    finds.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    finds.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    finds.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    finds.5 $e |- ps $.
    $( Induction hypothesis. $)
    finds.6 $e |- ( y e. om -> ( ch -> th ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the substitutions we
       need.  The last two are the basis and the induction hypothesis.  Theorem
       Schema 22 of [Suppes] p. 136.  (Contributed by NM, 14-Apr-1995.) $)
    finds $p |- ( A e. om -> ta ) $=
      ( com wcel cab c0 cv elab csuc wi wral wss 0ex mpbir sucex 3imtr4g peano5
      vex rgen mp2an sseli elabg mpbid ) HOPHAFQZPEOUPHRUPPZGSZUPPZURUAZUPPZUBZ
      GOUCOUPUDUQBMABFRUEITUFVBGOUROPCDUSVANACFURGUJZJTADFUTURVCUGKTUHUKGUPUIUL
      UMAEFHOLUNUO $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    findsg.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    findsg.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    findsg.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    findsg.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    findsg.5 $e |- ( B e. om -> ps ) $.
    $( Induction hypothesis. $)
    findsg.6 $e |- ( ( ( y e. om /\ B e. om ) /\ B C_ y ) -> ( ch -> th ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first four hypotheses establish the substitutions we
       need.  The last two are the basis and the induction hypothesis.  The
       basis of this version is an arbitrary natural number ` B ` instead of
       zero.  (Contributed by NM, 16-Sep-1995.) $)
    findsg $p |- ( ( ( A e. om /\ B e. om ) /\ B C_ A ) -> ta ) $=
      ( wcel wss wi wceq wa com cv c0 wb sseq2 adantl eqeq2 syl6bir imp imbi12d
      csuc wn imbi1d ss0 pm2.21d pm5.74d sylan9bbr pm2.61ian imbi2d a1d wex vex
      con3i sucex eqvinc syl5ibr biimpd sylan9r exlimiv sylbi eqcoms imim2i wne
      com4r df-ne anbi2i annim bitri con0 onsssuc suceloni onelpss sylan2 bitrd
      nnon syl2anr ex ax-1 syl8 a2d com23 sylbird syl5bir pm2.61d finds imp31 )
      HUAPIUAPZIHQZEWQIFUBZQZARZRWQIUCQZBRZRWQIGUBZQZCRZRWQIXDUKZQZDRZRWQWRERZR
      FGHWSUCSZXAXCWQIUCSZXKXAXCUDXLXKTWTXBABXKWTXBUDXLWSUCIUEZUFXLXKABUDZXLXKW
      SISZXNIUCWSUGJUHUIUJXKXAXBARXLULZXCXKWTXBAXMUMXPXBABXPXBXNXBXLIUNVCUOUPUQ
      URUSWSXDSZXAXFWQXQWTXEACWSXDIUEKUJUSWSXGSZXAXIWQXRWTXHADWSXGIUELUJUSWSHSZ
      XAXJWQXSWTWRAEWSHIUEMUJUSWQBXBNUTXDUAPZWQXFXIXTWQXFXIRZXTWQTZXHIXGSZRZYAW
      QYDYARXTYDXFXHWQDYDXHWQDRZRXFYCYEXHYEXGIXGISXRXOTZFVAYEFXGIXDGVBVDVEYFYEF
      XOWQAXRDWQAXOBNJVFXRADLVGVHVIVJVKVLUTVNUFYDULZXHIXGVMZTZYBYAYIXHYCULZTYGY
      HYJXHIXGVOVPXHYCVQVRYBYIXEYAWQIVSPZXDVSPZXEYIUDXTIWEXDWEYKYLTXEIXGPZYIIXD
      VTYLYKXGVSPYMYIUDXDWAIXGWBWCWDWFYBXFXEXIYBXECXIYBXECDXIYBXECDROWGDXHWHWIW
      JWKWLWMWNWGWJWOWP $.
  $}

  ${
    $d x y ta $.  $d x ps $.  $d x ch $.  $d x th $.  $d y ph $.
    $( Substitutions. $)
    finds2.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    finds2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    finds2.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    $( Basis. $)
    finds2.4 $e |- ( ta -> ps ) $.
    $( Induction hypothesis. $)
    finds2.5 $e |- ( y e. om -> ( ta -> ( ch -> th ) ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first three hypotheses establish the substitutions
       we need.  The last two are the basis and the induction hypothesis.
       Theorem Schema 22 of [Suppes] p. 136.  (Contributed by NM,
       29-Nov-2002.) $)
    finds2 $p |- ( x e. om -> ( ta -> ph ) ) $=
      ( cv com wcel wi c0 wceq imbi2d elab cab csuc wss 0ex mpbir a2d vex sucex
      wral 3imtr4g rgen peano5 mp2an sseli abid sylib ) FMZNOUQEAPZFUAZOURNUSUQ
      QUSOZGMZUSOZVAUBZUSOZPZGNUINUSUCUTEBPZKURVFFQUDUQQRABEHSTUEVEGNVANOZECPZE
      DPZVBVDVGECDLUFURVHFVAGUGZUQVARACEISTURVIFVCVAVJUHUQVCRADEJSTUJUKGUSULUMU
      NURFUOUP $.
  $}

  ${
    $d x y $.  $d x ps $.  $d x ch $.  $d x th $.  $d y ph $.
    $( Substitutions. $)
    finds1.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    finds1.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    finds1.3 $e |- ( x = suc y -> ( ph <-> th ) ) $.
    $( Basis. $)
    finds1.4 $e |- ps $.
    $( Induction hypothesis. $)
    finds1.5 $e |- ( y e. om -> ( ch -> th ) ) $.
    $( Principle of Finite Induction (inference schema), using implicit
       substitutions.  The first three hypotheses establish the substitutions
       we need.  The last two are the basis and the induction hypothesis.
       Theorem Schema 22 of [Suppes] p. 136.  (Contributed by NM,
       22-Mar-2006.) $)
    finds1 $p |- ( x e. om -> ph ) $=
      ( cv com wcel c0 wceq eqid a1i wi a1d finds2 mpi ) ELMNOOPZAOQABCDUCEFGHI
      BUCJRFLMNCDSUCKTUAUB $.
  $}

  ${
    $d x y z $.  $d y z ph $.
    findes.1 $e |- [. (/) / x ]. ph $.
    findes.2 $e |- ( x e. om -> ( ph -> [. suc x / x ]. ph ) ) $.
    $( Finite induction with explicit substitution.  The first hypothesis is
       the basis and the second is the induction hypothesis.  Theorem Schema 22
       of [Suppes] p. 136.  See ~ tfindes for the transfinite version.
       (Contributed by Raph Levien, 9-Jul-2003.) $)
    findes $p |- ( x e. om -> ph ) $=
      ( vz vy wsb c0 wsbc csuc dfsbcq2 sbequ sbequ12r com wcel nfv nfim imbi12d
      cv wi nfs1v nfsbc1v weq eleq1 sbequ12 wceq suceq dfsbcq syl chvar finds
      wb ) ABEGABHIABFGZABFSZJZIZAEFBSZABEHKAEFBLABEUOKAEBMCUQNOZAABUQJZIZTZTUN
      NOZUMUPTZTBFVBVCBVBBPUMUPBABFUAABUOUBQQBFUCZURVBVAVCUQUNNUDVDAUMUTUPABFUE
      VDUSUOUFUTUPULUQUNUGABUSUOUHUIRRDUJUK $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                              Relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c X. $. $( Times symbol (cross product symbol) (read: 'cross') $)
  $c `' $. $( Small elevated smiley (converse operation) $)
  $c dom $. $( Domain $)
  $c ran $. $( Range $)
  $c |` $. $( Right hook (restriction symbol) $)
  $c " $. $( Left quote (image symbol) $)
  $c o. $. $( Small circle (composition symbol) $)
  $c Rel $. $( Relation predicate $)

  $( Extend the definition of a class to include the cross product. $)
  cxp $a class ( A X. B ) $.

  $( Extend the definition of a class to include the converse of a class. $)
  ccnv $a class `' A $.

  $( Extend the definition of a class to include the domain of a class. $)
  cdm $a class dom A $.

  $( Extend the definition of a class to include the range of a class. $)
  crn $a class ran A $.

  $( Extend the definition of a class to include the restriction of a class.
     (Read:  The restriction of ` A ` to ` B ` .) $)
  cres $a class ( A |` B ) $.

  $( Extend the definition of a class to include the image of a class.  (Read:
     The image of ` B ` under ` A ` .) $)
  cima $a class ( A " B ) $.

  $( Extend the definition of a class to include the composition of two
     classes.  (Read:  The composition of ` A ` and ` B ` .) $)
  ccom $a class ( A o. B ) $.

  $( Extend the definition of a wff to include the relation predicate.  (Read:
     ` A ` is a relation.) $)
  wrel $a wff Rel A $.

  ${
    $d x y z A $.  $d x y z B $.
    $( Define the cross product of two classes.  Definition 9.11 of [Quine]
       p. 64.  For example, ` ( { 1 , 5 } X. { 2 , 7 } ) = `
       ` ( { <. 1 , 2 >. , <. 1 , 7 >. } u. { <. 5 , 2 >. , <. 5 , 7 >. } ) `
       ( ~ ex-xp ).  Another example is that the set of rational numbers are
       defined in ~ df-q using the cross-product ` ( ZZ X. NN ) ` ; the left-
       and right-hand sides of the cross-product represent the top (integer)
       and bottom (natural) numbers of a fraction.  (Contributed by NM,
       4-Jul-1994.) $)
    df-xp $a |- ( A X. B ) = { <. x , y >. | ( x e. A /\ y e. B ) } $.

    $( Define the relation predicate.  Definition 6.4(1) of [TakeutiZaring]
       p. 23.  For alternate definitions, see ~ dfrel2 and ~ dfrel3 .
       (Contributed by NM, 1-Aug-1994.) $)
    df-rel $a |- ( Rel A <-> A C_ ( _V X. _V ) ) $.

    $( Define the converse of a class.  Definition 9.12 of [Quine] p. 64.  The
       converse of a binary relation swaps its arguments, i.e., if ` A e. _V `
       and ` B e. _V ` then ` ( A ``' R B <-> B R A ) ` , as proven in ~ brcnv
       (see ~ df-br and ~ df-rel for more on relations).  For example,
       ` ``' { <. 2 , 6 >. , <. 3 , 9 >. } = { <. 6 , 2 >. , <. 9 , 3 >. } `
       ( ~ ex-cnv ).  We use Quine's breve accent (smile) notation.  Like
       Quine, we use it as a prefix, which eliminates the need for
       parentheses.  Many authors use the postfix superscript "to the minus
       one."  "Converse" is Quine's terminology; some authors call it
       "inverse," especially when the argument is a function.  (Contributed by
       NM, 4-Jul-1994.) $)
    df-cnv $a |- `' A = { <. x , y >. | y A x } $.

    $( Define the composition of two classes.  Definition 6.6(3) of
       [TakeutiZaring] p. 24.  For example, ` ( ( exp o. cos ) `` 0 ) = _e `
       ( ~ ex-co ) because ` ( cos `` 0 ) = 1 ` (see ~ cos0 ) and
       ` ( exp `` 1 ) = _e ` (see ~ df-e ).  Note that Definition 7 of [Suppes]
       p. 63 reverses ` A ` and ` B ` , uses ` /. ` instead of ` o. ` , and
       calls the operation "relative product."  (Contributed by NM,
       4-Jul-1994.) $)
    df-co $a |- ( A o. B ) = { <. x , y >. | E. z ( x B z /\ z A y ) } $.

    $( Define the domain of a class.  Definition 3 of [Suppes] p. 59.  For
       example, ` F = { <. 2 , 6 >. , <. 3 , 9 >. } -> dom F = { 2 , 3 } `
       ( ~ ex-dm ).  Another example is the domain of the complex arctangent,
       ` ( A e. dom arctan <-> ( A e. CC /\ A =/= -u _i /\ A =/= _i ) ) ` (for
       proof see ~ atandm ).  Contrast with range (defined in ~ df-rn ).  For
       alternate definitions see ~ dfdm2 , ~ dfdm3 , and ~ dfdm4 .  The
       notation " ` dom ` " is used by Enderton; other authors sometimes use
       script D. (Contributed by NM, 1-Aug-1994.) $)
    df-dm $a |- dom A = { x | E. y x A y } $.

    $( Define the range of a class.  For example,
       ` F = { <. 2 , 6 >. , <. 3 , 9 >. } -> ran F = { 6 , 9 } ` ( ~ ex-rn ).
       Contrast with domain (defined in ~ df-dm ).  For alternate definitions,
       see ~ dfrn2 , ~ dfrn3 , and ~ dfrn4 .  The notation " ` ran ` " is used
       by Enderton; other authors sometimes use script R or script W.
       (Contributed by NM, 1-Aug-1994.) $)
    df-rn $a |- ran A = dom `' A $.

    $( Define the restriction of a class.  Definition 6.6(1) of [TakeutiZaring]
       p. 24.  For example, the expression ` ( exp |`` RR ) ` (used in
       ~ reeff1 ) means "the exponential function e to the x, but the exponent
       x must be in the reals" ( ~ df-ef defines the exponential function,
       which normally allows the exponent to be a complex number).  Another
       example is that ` ( F = { <. 2 , 6 >. , <. 3 , 9 >. } `
       ` /\ B = { 1 , 2 } ) -> ( F |`` B ) = { <. 2 , 6 >. } ` ( ~ ex-res ).
       (Contributed by NM, 2-Aug-1994.) $)
    df-res $a |- ( A |` B ) = ( A i^i ( B X. _V ) ) $.

    $( Define the image of a class (as restricted by another class).
       Definition 6.6(2) of [TakeutiZaring] p. 24.  For example,
` ( F = { <. 2 , 6 >. , <. 3 , 9 >. } /\ B = { 1 , 2 } ) -> ( F " B ) = { 6 } `
       ( ~ ex-ima ).  Contrast with restriction ( ~ df-res ) and range
       ( ~ df-rn ).  For an alternate definition, see ~ dfima2 .  (Contributed
       by NM, 2-Aug-1994.) $)
    df-ima $a |- ( A " B ) = ran ( A |` B ) $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Equality theorem for cross product.  (Contributed by NM, 4-Jul-1994.) $)
    xpeq1 $p |- ( A = B -> ( A X. C ) = ( B X. C ) ) $=
      ( vx vy wceq cv wcel wa copab cxp eleq2 anbi1d opabbidv df-xp 3eqtr4g ) A
      BFZDGZAHZEGCHZIZDEJRBHZTIZDEJACKBCKQUAUCDEQSUBTABRLMNDEACODEBCOP $.

    $( Equality theorem for cross product.  (Contributed by NM, 5-Jul-1994.) $)
    xpeq2 $p |- ( A = B -> ( C X. A ) = ( C X. B ) ) $=
      ( vx vy wceq cv wcel wa copab cxp eleq2 anbi2d opabbidv df-xp 3eqtr4g ) A
      BFZDGCHZEGZAHZIZDEJRSBHZIZDEJCAKCBKQUAUCDEQTUBRABSLMNDECAODECBOP $.

    $( Membership in a cross product.  Uses fewer axioms than ~ elxp .
       (Contributed by NM, 4-Jul-1994.) $)
    elxpi $p |- ( A e. ( B X. C ) -> E. x E. y ( A = <. x , y >. /\
               ( x e. B /\ y e. C ) ) ) $=
      ( vz cv cop wceq wcel wa wex cab cxp eqeq1 anbi1d 2exbidv elabg ibi copab
      df-xp df-opab eqtri eleq2s ) CAGZBGZHZIZUEDJUFEJKZKZBLALZCFGZUGIZUIKZBLAL
      ZFMZDENZCUPJUKUOUKFCUPULCIZUNUJABURUMUHUIULCUGOPQRSUQUIABTUPABDEUAUIABFUB
      UCUD $.

    $( Membership in a cross product.  (Contributed by NM, 4-Jul-1994.) $)
    elxp $p |- ( A e. ( B X. C ) <-> E. x E. y ( A = <. x , y >. /\
               ( x e. B /\ y e. C ) ) ) $=
      ( cxp wcel cv wa copab cop wceq wex df-xp eleq2i elopab bitri ) CDEFZGCAH
      ZDGBHZEGIZABJZGCSTKLUAIBMAMRUBCABDENOUAABCPQ $.

    $( Membership in a cross product.  (Contributed by NM, 23-Feb-2004.) $)
    elxp2 $p |- ( A e. ( B X. C ) <-> E. x e. B E. y e. C A = <. x , y >. ) $=
      ( cv wcel cop wceq wrex wa wex cxp df-rex r19.42v an13 exbii 3bitr3i elxp
      3bitr4ri ) AFZDGZCUABFZHIZBEJZKZALUDUBUCEGZKKZBLZALUEADJCDEMGUFUIAUBUDKZB
      EJUGUJKZBLUFUIUJBENUBUDBEOUKUHBUGUBUDPQRQUEADNABCDEST $.
  $}

  $( Equality theorem for cross product.  (Contributed by FL, 31-Aug-2009.) $)
  xpeq12 $p |- ( ( A = B /\ C = D ) -> ( A X. C ) = ( B X. D ) ) $=
    ( wceq cxp xpeq1 xpeq2 sylan9eq ) ABECDEACFBCFBDFABCGCDBHI $.

  ${
    xpeq1i.1 $e |- A = B $.
    $( Equality inference for cross product.  (Contributed by NM,
       21-Dec-2008.) $)
    xpeq1i $p |- ( A X. C ) = ( B X. C ) $=
      ( wceq cxp xpeq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality inference for cross product.  (Contributed by NM,
       21-Dec-2008.) $)
    xpeq2i $p |- ( C X. A ) = ( C X. B ) $=
      ( wceq cxp xpeq2 ax-mp ) ABECAFCBFEDABCGH $.
  $}

  ${
    xpeq12i.1 $e |- A = B $.
    xpeq12i.2 $e |- C = D $.
    $( Equality inference for cross product.  (Contributed by FL,
       31-Aug-2009.) $)
    xpeq12i $p |- ( A X. C ) = ( B X. D ) $=
      ( wceq cxp xpeq12 mp2an ) ABGCDGACHBDHGEFABCDIJ $.
  $}

  ${
    xpeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for cross product.  (Contributed by Jeff Madsen,
       17-Jun-2010.) $)
    xpeq1d $p |- ( ph -> ( A X. C ) = ( B X. C ) ) $=
      ( wceq cxp xpeq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality deduction for cross product.  (Contributed by Jeff Madsen,
       17-Jun-2010.) $)
    xpeq2d $p |- ( ph -> ( C X. A ) = ( C X. B ) ) $=
      ( wceq cxp xpeq2 syl ) ABCFDBGDCGFEBCDHI $.

    xpeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for cross product.  (Contributed by NM,
       8-Dec-2013.) $)
    xpeq12d $p |- ( ph -> ( A X. C ) = ( B X. D ) ) $=
      ( wceq cxp xpeq12 syl2anc ) ABCHDEHBDICEIHFGBCDEJK $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d x y z $.
    nfxp.1 $e |- F/_ x A $.
    nfxp.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for cross product.  (Contributed by
       NM, 15-Sep-2003.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfxp $p |- F/_ x ( A X. B ) $=
      ( vy vz cxp cv wcel wa copab df-xp nfcri nfan nfopab nfcxfr ) ABCHFIBJZGI
      CJZKZFGLFGBCMTFGARSAAFBDNAGCENOPQ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( The empty set is not a member of a cross product.  (Contributed by NM,
       2-May-1996.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    0nelxp $p |- -. (/) e. ( A X. B ) $=
      ( vx vy c0 cxp wcel cv cop wceq wa wex wne wn opnzi simpl eqcomd necon3ai
      vex nex ax-mp elxp mtbir ) EABFGECHZDHZIZJZUDAGUEBGKZKZDLZCLUJCUIDUFEMUIN
      UDUECSDSOUIUFEUIEUFUGUHPQRUATTCDEABUBUC $.

    $( A member of a cross product (ordered pair) doesn't contain the empty
       set.  (Contributed by NM, 15-Dec-2008.) $)
    0nelelxp $p |- ( C e. ( A X. B ) -> -. (/) e. C ) $=
      ( vx vy cxp wcel cv cop wceq wa wex c0 wn elxp 0nelop simpl eleq2d mtbiri
      exlimivv sylbi ) CABFGCDHZEHZIZJZUBAGUCBGKZKZELDLMCGZNZDECABOUGUIDEUGUHMU
      DGUBUCPUGCUDMUEUFQRSTUA $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    $( Ordered pair membership in a cross product.  (Contributed by NM,
       15-Nov-1994.)  (Proof shortened by Andrew Salmon, 12-Aug-2011.)
       (Revised by Mario Carneiro, 26-Apr-2015.) $)
    opelxp $p |- ( <. A , B >. e. ( C X. D ) <-> ( A e. C /\ B e. D ) ) $=
      ( vx vy cop cxp wcel cv wceq wrex wa elxp2 wb opth2 eleq1 bi2anan9 eqeq2d
      vex sylbi biimprcd rexlimivv eqid opeq1 opeq2 rspc2ev mp3an3 impbii bitri
      ) ABGZCDHIUKEJZFJZGZKZFDLECLZACIZBDIZMZEFUKCDNUPUSUOUSEFCDUOUSULCIZUMDIZM
      ZUOAULKZBUMKZMUSVBOABULUMETFTPVCUQUTVDURVAAULCQBUMDQRUAUBUCUQURUKUKKZUPUK
      UDUOVEUKAUMGZKEFABCDULAKUNVFUKULAUMUESUMBKVFUKUKUMBAUFSUGUHUIUJ $.

    $( Binary relation on a cross product.  (Contributed by NM,
       22-Apr-2004.) $)
    brxp $p |- ( A ( C X. D ) B <-> ( A e. C /\ B e. D ) ) $=
      ( cxp wbr cop wcel wa df-br opelxp bitri ) ABCDEZFABGMHACHBDHIABMJABCDKL
      $.
  $}

  $( Ordered pair membership in a cross product (implication).  (Contributed by
     NM, 28-May-1995.) $)
  opelxpi $p |- ( ( A e. C /\ B e. D ) -> <. A , B >. e. ( C X. D ) ) $=
    ( cop cxp wcel wa opelxp biimpri ) ABECDFGACGBDGHABCDIJ $.

  $( The first member of an ordered pair of classes in a cross product belongs
     to first cross product argument.  (Contributed by NM, 28-May-2008.)
     (Revised by Mario Carneiro, 26-Apr-2015.) $)
  opelxp1 $p |- ( <. A , B >. e. ( C X. D ) -> A e. C ) $=
    ( cop cxp wcel opelxp simplbi ) ABECDFGACGBDGABCDHI $.

  $( The second member of an ordered pair of classes in a cross product belongs
     to second cross product argument.  (Contributed by Mario Carneiro,
     26-Apr-2015.) $)
  opelxp2 $p |- ( <. A , B >. e. ( C X. D ) -> B e. D ) $=
    ( cop cxp wcel opelxp simprbi ) ABECDFGACGBDGABCDHI $.

  $( The first member of an ordered triple of classes in a cross product
     belongs to first cross product argument.  (Contributed by NM,
     28-May-2008.) $)
  otelxp1 $p |- ( <. <. A , B >. , C >. e. ( ( R X. S ) X. T )
          -> A e. R ) $=
    ( cop cxp wcel opelxp1 syl ) ABGZCGDEHZFHILMIADILCMFJABDEJK $.

  ${
    $d x y z A $.  $d x y z B $.  $d y z ph $.  $d x ps $.
    rabxp.1 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Membership in a class builder restricted to a cross product.
       (Contributed by NM, 20-Feb-2014.) $)
    rabxp $p |- { x e. ( A X. B ) | ph }
             = { <. y , z >. | ( y e. A /\ z e. B /\ ps ) } $=
      ( cv cxp wcel wa cab cop wceq w3a wex crab copab elxp anbi1i anass anbi2d
      19.41vv df-3an syl6bbr pm5.32i bitri 2exbii 3bitr2i abbii df-opab 3eqtr4i
      df-rab ) CIZFGJZKZALZCMUODIZEIZNOZUSFKZUTGKZBPZLZEQDQZCMACUPRVDDESURVFCUR
      VAVBVCLZLZEQDQZALVHALZEQDQVFUQVIADEUOFGTUAVHADEUDVJVEDEVJVAVGALZLVEVAVGAU
      BVAVKVDVAVKVGBLVDVAABVGHUCVBVCBUEUFUGUHUIUJUKACUPUNVDDECULUM $.
  $}

  $( A true binary relation on a relation implies the arguments are sets.
     (This is a property of our ordered pair definition.)  (Contributed by
     Mario Carneiro, 26-Apr-2015.) $)
  brrelex12 $p |- ( ( Rel R /\ A R B ) -> ( A e. _V /\ B e. _V ) ) $=
    ( wrel wbr wa cvv cxp wcel wss df-rel biimpi ssbrd imp brxp sylib ) CDZABCE
    ZFABGGHZEZAGIBGIFQRTQCSABQCSJCKLMNABGGOP $.

  $( A true binary relation on a relation implies the first argument is a set.
     (This is a property of our ordered pair definition.)  (Contributed by NM,
     18-May-2004.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
  brrelex $p |- ( ( Rel R /\ A R B ) -> A e. _V ) $=
    ( wrel wbr wa cvv wcel brrelex12 simpld ) CDABCEFAGHBGHABCIJ $.

  $( A true binary relation on a relation implies the second argument is a
     set.  (This is a property of our ordered pair definition.)  (Contributed
     by Mario Carneiro, 26-Apr-2015.) $)
  brrelex2 $p |- ( ( Rel R /\ A R B ) -> B e. _V ) $=
    ( wrel wbr wa cvv wcel brrelex12 simprd ) CDABCEFAGHBGHABCIJ $.

  ${
    brrelexi.1 $e |- Rel R $.
    $( The first argument of a binary relation exists.  (An artifact of our
       ordered pair definition.)  (Contributed by NM, 4-Jun-1998.) $)
    brrelexi $p |- ( A R B -> A e. _V ) $=
      ( wrel wbr cvv wcel brrelex mpan ) CEABCFAGHDABCIJ $.

    $( The second argument of a binary relation exists.  (An artifact of our
       ordered pair definition.)  (Contributed by Mario Carneiro,
       26-Apr-2015.) $)
    brrelex2i $p |- ( A R B -> B e. _V ) $=
      ( wrel wbr cvv wcel brrelex2 mpan ) CEABCFBGHDABCIJ $.
  $}

  ${
    nprrel.1 $e |- Rel R $.
    nprrel.2 $e |- -. A e. _V $.
    $( No proper class is related to anything via any relation.  (Contributed
       by Roy F. Longton, 30-Jul-2005.) $)
    nprrel $p |- -. A R B $=
      ( wbr cvv wcel brrelexi mto ) ABCFAGHEABCDIJ $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Representation of a constant function using the mapping operation.
       (Note that ` x ` cannot appear free in ` B ` .)  (Contributed by NM,
       12-Oct-1999.)  (Revised by Mario Carneiro, 16-Nov-2013.) $)
    fconstmpt $p |- ( A X. { B } ) = ( x e. A |-> B ) $=
      ( vy cv wcel csn wa copab wceq cxp cmpt elsn anbi2i opabbii df-xp 3eqtr4i
      df-mpt ) AEBFZDEZCGZFZHZADISTCJZHZADIBUAKABCLUCUEADUBUDSDCMNOADBUAPADBCRQ
      $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y z C $.  $d x y z R $.
    vtoclr.1 $e |- Rel R $.
    vtoclr.2 $e |- ( ( x R y /\ y R z ) -> x R z ) $.
    $( Variable to class conversion of transitive relation.  (Contributed by
       NM, 9-Jun-1998.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    vtoclr $p |- ( ( A R B /\ B R C ) -> A R C ) $=
      ( wbr wa wi cvv wcel brrelex2i cv wceq breq1 imbi12d breq2 anbi1d anbi12d
      brrelexi jca imbi2d imbi1d anbi2d vtoclg vtocl2g syl2im imp pm2.43i ) DEG
      JZEFGJZKZDFGJZUMUNUOUPLZUMDMNZEMNZKUNFMNZUQUMURUSDEGHUCDEGHOUDEFGHOUTAPZB
      PZGJZVBFGJZKZVAFGJZLZLUTDVBGJZVDKZUPLZLUTUQLABDEMMVADQZVGVJUTVKVEVIVFUPVK
      VCVHVDVADVBGRUAVADFGRSUEVBEQZVJUQUTVLVIUOUPVLVHUMVDUNVBEDGTVBEFGRUBUFUEVC
      VBCPZGJZKZVAVMGJZLVGCFMVMFQZVOVEVPVFVQVNVDVCVMFVBGTUGVMFVAGTSIUHUIUJUKUL
      $.
  $}

  $( Ordered pair membership in the universal class of ordered pairs.
     (Contributed by Mario Carneiro, 3-May-2015.) $)
  opelvvg $p |- ( ( A e. V /\ B e. W ) -> <. A , B >. e. ( _V X. _V ) ) $=
    ( wcel cvv cop cxp elex opelxpi syl2an ) ACEAFEBFEABGFFHEBDEACIBDIABFFJK $.

  ${
    opelvv.1 $e |- A e. _V $.
    opelvv.2 $e |- B e. _V $.
    $( Ordered pair membership in the universal class of ordered pairs.
       (Contributed by NM, 22-Aug-2013.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    opelvv $p |- <. A , B >. e. ( _V X. _V ) $=
      ( cvv wcel cop cxp opelxpi mp2an ) AEFBEFABGEEHFCDABEEIJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    $( Justification theorem for an ordered pair definition that works for any
       classes, including proper classes.  This is a possible definition
       implied by the footnote in [Jech] p. 78, which says, "The sophisticated
       reader will not object to our use of a pair of classes."  (Contributed
       by NM, 28-Sep-2003.) $)
    opthprc $p |- ( ( ( A X. { (/) } ) u. ( B X. { { (/) } } ) ) =
                    ( ( C X. { (/) } ) u. ( D X. { { (/) } } ) )
                  <-> ( A = C /\ B = D ) ) $=
      ( vx c0 csn cxp cun wceq wa wcel wo opelxp mpbiran2 bianfi bitr4i orbi12i
      elun 3bitr4ri cop eleq2 0ex snid 0nep0 elsnc nemtbir biorfi 3bitr4g eqrdv
      cv p0ex eqcom bitri wn wb biorf ax-mp jca xpeq1 uneq12 syl2an impbii ) AF
      GZHZBVDGZHZIZCVDHZDVFHZIZJZACJZBDJZKVLVMVNVLEACVLEUKZFUAZVHLZVPVKLZVOALZV
      OCLZVHVKVPUBVPVELZVPVGLZMVSFVFLZMVQVSWAVSWBWCWAVSFVDLZFUCUDZVOFAVDNOWBVOB
      LZWCKWCVOFBVFNWCWFWCFVDUEFVDUCUFUGZPQRVPVEVGSWCVSWGUHTVPVILZVPVJLZMVTWCMV
      RVTWHVTWIWCWHVTWDWEVOFCVDNOWIVODLZWCKWCVOFDVFNWCWJWGPQRVPVIVJSWCVTWGUHTUI
      UJVLEBDVLVOVDUAZVHLZWKVKLZWFWJVHVKWKUBWKVELZWKVGLZMVDVDLZWFMZWLWFWNWPWOWF
      WNVSWPKWPVOVDAVDNWPVSWPFVDUEWPVDFJFVDJVDFULUFVDFUMUNUGZPQWOWFVDVFLZVDULUD
      ZVOVDBVFNORWKVEVGSWPUOZWFWQUPWRWPWFUQURTWKVILZWKVJLZMWPWJMZWMWJXBWPXCWJXB
      VTWPKWPVOVDCVDNWPVTWRPQXCWJWSWTVOVDDVFNORWKVIVJSXAWJXDUPWRWPWJUQURTUIUJUS
      VMVEVIJVGVJJVLVNACVDUTBDVFUTVEVIVGVJVAVBVC $.
  $}

  ${
    brel.1 $e |- R C_ ( C X. D ) $.
    $( Two things in a binary relation belong to the relation's domain.
       (Contributed by NM, 17-May-1996.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    brel $p |- ( A R B -> ( A e. C /\ B e. D ) ) $=
      ( wbr cxp wcel wa ssbri brxp sylib ) ABEGABCDHZGACIBDIJENABFKABCDLM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y ps $.
    brab2a.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    brab2a.2 $e |- R = { <. x , y >. | ( ( x e. C /\ y e. D ) /\ ph ) } $.
    $( Ordered pair membership in an ordered pair class abstraction.
       (Contributed by Mario Carneiro, 9-Nov-2015.) $)
    brab2a $p |- ( A R B <-> ( ( A e. C /\ B e. D ) /\ ps ) ) $=
      ( wbr wcel wa cv copab cxp simpl ssopab2i df-xp 3sstr4i brel df-br eleq2i
      cop bitri opelopab2a syl5bb biadan2 ) EFILZEGMFHMNZBEFGHICOGMDOHMNZANZCDP
      ZULCDPIGHQUMULCDULARSKCDGHTUAUBUJEFUEZUNMZUKBUJUOIMUPEFIUCIUNUOKUDUFABCDE
      FGHJUGUHUI $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in a cross product.  (Contributed by NM, 5-Mar-1995.) $)
    elxp3 $p |- ( A e. ( B X. C ) <->
            E. x E. y ( <. x , y >. = A /\ <. x , y >. e. ( B X. C ) ) ) $=
      ( cxp wcel cv cop wceq wa wex elxp eqcom opelxp anbi12i 2exbii bitr4i ) C
      DEFZGCAHZBHZIZJZTDGUAEGKZKZBLALUBCJZUBSGZKZBLALABCDEMUHUEABUFUCUGUDUBCNTU
      ADEOPQR $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d x y z $.
    $( Membership in a union of cross products.  (Contributed by Mario
       Carneiro, 29-Dec-2014.)  (Revised by Mario Carneiro, 1-Jan-2017.) $)
    opeliunxp $p |- ( <. x , C >. e. U_ x e. A ( { x } X. B ) <->
                     ( x e. A /\ C e. B ) ) $=
      ( vy vz cv cop csn cxp ciun wcel wrex wa wceq eleq2d anbi12d bitri 3bitri
      wex cab wsb csb df-iun eleq2i opex nfv nfs1v nfcv nfcsb1v nfxp nfcri nfan
      df-rex sbequ12 sneq csbeq1a xpeq12d cbvex eleq1 anbi2d exbidv syl5bb elab
      opelxp anbi2i an12 elsn equcom anbi1i vex sbequ12r equcoms eqcomd ceqsexv
      exbii ) AGZDHZABVQIZCJZKZLVREGZVTLZABMZEUAZLVQBLZAFUBZVRFGZIZAWHCUCZJZLZN
      ZFTZWFDCLZNZWAWEVRAEBVTUDUEWDWNEVRVQDUFWDWGWBWKLZNZFTZWBVROZWNWDWFWCNZATW
      SWCABUNXAWRAFXAFUGWGWQAWFAFUHAEWKAWIWJAWIUIAWHCUJUKULUMVQWHOZWFWGWCWQWFAF
      UOXBVTWKWBXBVSWICWJVQWHUPAWHCUQZURPQUSRWTWRWMFWTWQWLWGWBVRWKUTVAVBVCVDWNW
      HVQOZWGDWJLZNZNZFTWPWMXGFWMWGVQWILZXENZNXHXFNXGWLXIWGVQDWIWJVEVFWGXHXEVGX
      HXDXFXHXBXDAWHVHAFVIRVJSVPXFWPFVQAVKXDWGWFXEWOWFFAVLXDWJCDXDCWJCWJOAFXCVM
      VNPQVORS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Distributive law for cross product over union.  Theorem 103 of [Suppes]
       p. 52.  (Contributed by NM, 12-Aug-2004.) $)
    xpundi $p |- ( A X. ( B u. C ) ) = ( ( A X. B ) u. ( A X. C ) ) $=
      ( vx vy cun cxp cv wcel wa copab df-xp uneq12i wo elun andi bitri opabbii
      anbi2i eqtr4i unopab ) ABCFZGDHAIZEHZUBIZJZDEKZABGZACGZFZDEAUBLUJUCUDBIZJ
      ZDEKZUCUDCIZJZDEKZFZUGUHUMUIUPDEABLDEACLMUGULUONZDEKUQUFURDEUFUCUKUNNZJUR
      UEUSUCUDBCOSUCUKUNPQRULUODEUATTT $.

    $( Distributive law for cross product over union.  Similar to Theorem 103
       of [Suppes] p. 52.  (Contributed by NM, 30-Sep-2002.) $)
    xpundir $p |- ( ( A u. B ) X. C ) = ( ( A X. C ) u. ( B X. C ) ) $=
      ( vx vy cun cxp cv wcel wa copab df-xp uneq12i wo elun anbi1i andir bitri
      opabbii eqtr4i unopab ) ABFZCGDHZUBIZEHCIZJZDEKZACGZBCGZFZDEUBCLUJUCAIZUE
      JZDEKZUCBIZUEJZDEKZFZUGUHUMUIUPDEACLDEBCLMUGULUONZDEKUQUFURDEUFUKUNNZUEJU
      RUDUSUEUCABOPUKUNUEQRSULUODEUATTT $.
  $}

  ${
    $d w y z A $.  $d w y z B $.  $d w x y z C $.  $d x F $.
    $( Distributive law for cross product over indexed union.  (Contributed by
       Mario Carneiro, 27-Apr-2014.) $)
    xpiundi $p |- ( C X. U_ x e. A B ) = U_ x e. A ( C X. B ) $=
      ( vz vw vy ciun cxp cv wrex wcel wa wex eliun exbii df-rex rexbii 3bitr4i
      elxp2 cop wceq rexcom anbi1i rexcom4 r19.41v 3bitri eqriv ) EDABCHZIZABDC
      IZHZEJZFJGJZUAUBZGUIKZFDKZUMUKLZABKZUMUJLUMULLUOGCKZABKZFDKUTFDKZABKUQUSU
      TFADBUCUPVAFDUNUILZUOMZGNUNCLZABKZUOMZGNZUPVAVDVGGVCVFUOAUNBCOUDPUOGUIQVA
      VEUOMZGNZABKVIABKZGNVHUTVJABUOGCQRVIAGBUEVKVGGVEUOABUFPUGSRURVBABFGUMDCTR
      SFGUMDUITAUMBUKOSUH $.

    $( Distributive law for cross product over indexed union.  (Contributed by
       Mario Carneiro, 27-Apr-2014.) $)
    xpiundir $p |- ( U_ x e. A B X. C ) = U_ x e. A ( B X. C ) $=
      ( vz vy vw ciun cxp cv cop wrex wcel wa df-rex rexbii eliun elxp2 3bitr4i
      wex wceq rexcom4 anbi1i r19.41v bitr4i exbii 3bitr4ri eqriv ) EABCHZDIZAB
      CDIZHZEJZFJZGJKUAGDLZFUILZUMUKMZABLZUMUJMUMULMUNUIMZUONZFTZUOFCLZABLZUPUR
      UNCMZUONZFTZABLVEABLZFTVCVAVEAFBUBVBVFABUOFCOPUTVGFUTVDABLZUONVGUSVHUOAUN
      BCQUCVDUOABUDUEUFUGUOFUIOUQVBABFGUMCDRPSFGUMUIDRAUMBUKQSUH $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Membership in a union of cross products when the second factor is
       constant.  (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    iunxpconst $p |- U_ x e. A ( { x } X. B ) = ( A X. B ) $=
      ( cv csn ciun cxp xpiundir iunid xpeq1i eqtr3i ) ABADEZFZCGABLCGFBCGABLCH
      MBCABIJK $.
  $}

  $( The cross product of two unions.  (Contributed by NM, 12-Aug-2004.) $)
  xpun $p |- ( ( A u. B ) X. ( C u. D ) ) =
            ( ( ( A X. C ) u. ( A X. D ) ) u. ( ( B X. C ) u. ( B X. D ) ) ) $=
    ( cun cxp xpundi xpundir uneq12i un4 3eqtri ) ABEZCDEFLCFZLDFZEACFZBCFZEZAD
    FZBDFZEZEOREPSEELCDGMQNTABCHABDHIOPRSJK $.

  ${
    $d w x y z A $.
    $( Membership in universal class of ordered pairs.  (Contributed by NM,
       4-Jul-1994.) $)
    elvv $p |- ( A e. ( _V X. _V ) <-> E. x E. y A = <. x , y >. ) $=
      ( cvv cxp wcel cv cop wceq wa wex elxp vex pm3.2i biantru 2exbii bitr4i )
      CDDEFCAGZBGZHIZRDFZSDFZJZJZBKAKTBKAKABCDDLTUDABUCTUAUBAMBMNOPQ $.

    $( Membership in universal class of ordered triples.  (Contributed by NM,
       17-Dec-2008.) $)
    elvvv $p |- ( A e. ( ( _V X. _V ) X. _V )
                 <-> E. x E. y E. z A = <. <. x , y >. , z >. ) $=
      ( vw cvv cxp wcel cv cop wceq wa wex elxp anass ancom 2exbii bitr3i bitri
      19.42vv vex biantru elvv anbi2i 3bitr4ri exrot4 excom opex eqeq2d ceqsexv
      opeq1 exbii ) DFFGZFGHDEIZCIZJZKZUNUMHZUOFHZLLZCMEMZDAIZBIZJZUOJZKZCMZBMA
      MZECDUMFNVAUNVDKZUQLZBMAMZCMEMZVHUTVKECUTUQURLZUSLZVKUQURUSOUQVILZBMAMUQV
      IBMAMZLZVKVNUQVIABTVJVOABVIUQPQVNVMVQUSVMCUAUBURVPUQABUNUCUDRUERQVLVJCMEM
      ZBMAMVHVJABECUFVRVGABVRVJEMZCMVGVJECUGVSVFCUQVFEVDVBVCUHVIUPVEDUNVDUOUKUI
      UJULSQRSS $.

    $( An ordered pair contains its union.  (Contributed by NM,
       16-Sep-2006.) $)
    elvvuni $p |- ( A e. ( _V X. _V ) -> U. A e. A ) $=
      ( vx vy cvv cxp wcel cv cop wceq wex cuni elvv cpr vex uniop opi2 eqeltri
      unieq id eleq12d mpbiri exlimivv sylbi ) ADDEFABGZCGZHZIZCJBJAKZAFZBCALUG
      UIBCUGUIUFKZUFFUJUDUEMUFUDUEBNZCNZOUDUEUKULPQUGUHUJAUFAUFRUGSTUAUBUC $.
  $}

  $( Intersection of binary relation with cross product.  (Contributed by NM,
     3-Mar-2007.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
  brinxp2 $p |- ( A ( R i^i ( C X. D ) ) B <->
                ( A e. C /\ B e. D /\ A R B ) ) $=
    ( cxp cin wbr wa wcel w3a brin ancom brxp anbi1i df-3an bitr4i 3bitri ) ABE
    CDFZGHABEHZABSHZIUATIZACJZBDJZTKZABESLTUAMUBUCUDIZTIUEUAUFTABCDNOUCUDTPQR
    $.

  $( Intersection of binary relation with cross product.  (Contributed by NM,
     9-Mar-1997.) $)
  brinxp $p |- ( ( A e. C /\ B e. D ) ->
               ( A R B <-> A ( R i^i ( C X. D ) ) B ) ) $=
    ( cxp cin wbr wcel wa w3a brinxp2 df-3an bitri baibr ) ABECDFGHZACIZBDIZJZA
    BEHZPQRTKSTJABCDELQRTMNO $.

  ${
    $d x y z A $.  $d x y z R $.
    $( Intersection of partial order with cross product of its field.
       (Contributed by Mario Carneiro, 10-Jul-2014.) $)
    poinxp $p |- ( R Po A <-> ( R i^i ( A X. A ) ) Po A ) $=
      ( vx vy vz cv wbr wn wa wi wral cxp cin wpo wcel wb brinxp ralbidva df-po
      anbi12d simpll syl2anc notbid adantll adantlr imbi12d ralbiia 3bitr4i
      adantr ) CFZUJBGZHZUJDFZBGZUMEFZBGZIZUJUOBGZJZIZEAKZDAKZCAKUJUJBAALMZGZHZ
      UJUMVCGZUMUOVCGZIZUJUOVCGZJZIZEAKZDAKZCAKABNAVCNVBVMCAUJAOZVAVLDAVNUMAOZI
      ZUTVKEAVPUOAOZIZULVEUSVJVRUKVDVRVNVNUKVDPVNVOVQUAZVSUJUJAABQUBUCVRUQVHURV
      IVRUNVFUPVGVPUNVFPVQUJUMAABQUIVOVQUPVGPVNUMUOAABQUDTVNVQURVIPVOUJUOAABQUE
      UFTRRUGCDEABSCDEAVCSUH $.

    $( Intersection of total order with cross product of its field.
       (Contributed by Mario Carneiro, 10-Jul-2014.) $)
    soinxp $p |- ( R Or A <-> ( R i^i ( A X. A ) ) Or A ) $=
      ( vx vy wpo cv wbr weq w3o wral wa cxp cin poinxp wcel brinxp biidd df-so
      wor wb ancoms 3orbi123d ralbidva ralbiia anbi12i 3bitr4i ) ABEZCFZDFZBGZC
      DHZUIUHBGZIZDAJZCAJZKABAALMZEZUHUIUPGZUKUIUHUPGZIZDAJZCAJZKABSAUPSUGUQUOV
      BABNUNVACAUHAOZUMUTDAVCUIAOZKZUJURUKUKULUSUHUIAABPVEUKQVDVCULUSTUIUHAABPU
      AUBUCUDUECDABRCDAUPRUF $.

    $( Intersection of well-founded relation with cross product of its field.
       (Contributed by Mario Carneiro, 10-Jul-2014.) $)
    frinxp $p |- ( R Fr A <-> ( R i^i ( A X. A ) ) Fr A ) $=
      ( vz vy vx cv wss c0 wa wbr wn wral wrex wi wal wfr wb wcel ssel df-fr
      wne cxp cin anim12d brinxp ancoms notbid ralbidva rexbidva adantr pm5.74i
      syl6 impl albii 3bitr4i ) CFZAGZUPHUAZIZDFZEFZBJZKZDUPLZEUPMZNZCOUSUTVABA
      AUBUCZJZKZDUPLZEUPMZNZCOABPAVGPVFVLCUSVEVKUQVEVKQURUQVDVJEUPUQVAUPRZIZVCV
      IDUPVNUTUPRZIVBVHUQVMVOVBVHQZUQVMVOIVAARZUTARZIVPUQVMVQVOVRUPAVASUPAUTSUD
      VRVQVPUTVAAABUEUFULUMUGUHUIUJUKUNCEDABTCEDAVGTUO $.

    $( Intersection of set-like relation with cross product of its field.
       (Contributed by Mario Carneiro, 22-Jun-2015.) $)
    seinxp $p |- ( R Se A <-> ( R i^i ( A X. A ) ) Se A ) $=
      ( vy vx cv wbr crab cvv wcel cxp cin wse wb brinxp ancoms rabbidva eleq1d
      wral ralbiia df-se 3bitr4i ) CEZDEZBFZCAGZHIZDARUBUCBAAJKZFZCAGZHIZDARABL
      AUGLUFUJDAUCAIZUEUIHUKUDUHCAUBAIUKUDUHMUBUCAABNOPQSDCABTDCAUGTUA $.

    $( Intersection of well-ordering with cross product of its field.
       (Contributed by NM, 9-Mar-1997.)  (Revised by Mario Carneiro,
       10-Jul-2014.) $)
    weinxp $p |- ( R We A <-> ( R i^i ( A X. A ) ) We A ) $=
      ( wfr wor wa cxp cin wwe frinxp soinxp anbi12i df-we 3bitr4i ) ABCZABDZEA
      BAAFGZCZAPDZEABHAPHNQORABIABJKABLAPLM $.
  $}

  ${
    $d x y z A $.  $d x y z R $.
    $( Partial ordering of a singleton.  (Contributed by NM, 27-Apr-2009.)
       (Revised by Mario Carneiro, 23-Apr-2015.) $)
    posn $p |- ( Rel R -> ( R Po { A } <-> -. A R A ) ) $=
      ( vx vy vz cvv wpo wbr wn wb cv wa wi wral breq2 anbi2d ralsng ralbidv c0
      wceq wrel wcel csn df-po simpl syl5ib biantrud bicomd bitrd breq12 anidms
      imbi12d notbid adantl syl5bb po0 snprc poeq2 sylbi mpbiri brrelex con3and
      ex 2thd pm2.61dan ) BUAZAFUBZAUCZBGZAABHZIZJVICKZVLBHZIZVLDKZBHZVOEKZBHZL
      ZVLVQBHZMZLZEVHNZDVHNZCVHNZVFVGLVKCDEVHBUDVGWEVKJVFVGWEVNCVHNVKVGWDVNCVHV
      GWDVNVPVOABHZLZVLABHZMZLZDVHNVNVGWCWJDVHWBWJEAFVQATZWAWIVNWKVSWGVTWHWKVRW
      FVPVQAVOBOPVQAVLBOULPQRWJVNDAFVOATZVNWJWLWIVNWGVPWLWHVPWFUEVOAVLBOUFUGUHQ
      UIRVNVKCAFVLATZVMVJWMVMVJJVLAVLABUJUKUMQUIUNUOVFVGIZLVIVKWNVIVFWNVISBGZBU
      PWNVHSTVIWOJAUQVHSBURUSUTUNVFVJVGVFVJVGAABVAVCVBVDVE $.

    $( Strict ordering on a singleton.  (Contributed by Mario Carneiro,
       28-Dec-2014.) $)
    sosn $p |- ( Rel R -> ( R Or { A } <-> -. A R A ) ) $=
      ( vx vy csn wor wpo wrel wbr wn cv weq wral wcel wa elsni eqcomd sylan9eq
      w3o 3mix2 syl rgen2a df-so mpbiran2 posn syl5bb ) AEZBFZUGBGZBHAABIJUHUIC
      KZDKZBIZCDLZUKUJBIZSZDUGMCUGMUOCDUGUJUGNZUKUGNZOUMUOUPUQUJAUKUJAPUQUKAUKA
      PQRUMULUNTUAUBCDUGBUCUDABUEUF $.

    $( Founded relation on a singleton.  (Contributed by Mario Carneiro,
       28-Dec-2014.)  (Revised by Mario Carneiro, 23-Apr-2015.) $)
    frsn $p |- ( Rel R -> ( R Fr { A } <-> -. A R A ) ) $=
      ( vz vy vx cvv wfr wbr wn wb wa cv wral wrex c0 wne wi wal wceq adantl wo
      wrel wcel csn wss df-fr df-ne simpr sssn sylib ord syl5bi eqimss ad2antlr
      impr snnzg eqnetrd jca impbida imbi1d albidv snex raleq rexeqbi1dv syl6bb
      ceqsalv syl5bb breq2 notbid ralbidv rexsng breq1 ralsng bitrd snprc freq2
      fr0 mpbiri sylbi brrelex ex con3and 2thd pm2.61dan ) BUBZAFUCZAUDZBGZAABH
      ZIZJWEWFKZWHCLZDLZBHZIZCWGMZDWGNZWJWHELZWGUEZWROPZKZWOCWRMZDWRNZQZERZWKWQ
      EDCWGBUFWKXEWRWGSZXCQZERWQWKXDXGEWKXAXFXCWKXAXFWKWSWTXFWTWROSZIWKWSKZXFWR
      OUGXIXHXFXIWSXHXFUAWKWSUHWRAUIUJUKULUOWKXFKZWSWTXFWSWKWRWGUMTXJWRWGOWKXFU
      HWFWGOPWEXFAFUPUNUQURUSUTVAXCWQEWGAVBXBWPDWRWGWOCWRWGVCVDVFVEVGWFWQWJJWEW
      FWQWLABHZIZCWGMZWJWPXMDAFWMASZWOXLCWGXNWNXKWMAWLBVHVIVJVKXLWJCAFWLASXKWIW
      LAABVLVIVMVNTVNWEWFIZKWHWJXOWHWEXOWGOSZWHAVOXPWHOBGBVQWGOBVPVRVSTWEWIWFWE
      WIWFAABVTWAWBWCWD $.

    $( Well-ordering of a singleton.  (Contributed by Mario Carneiro,
       28-Dec-2014.) $)
    wesn $p |- ( Rel R -> ( R We { A } <-> -. A R A ) ) $=
      ( wrel csn wfr wor wa wbr wn wwe frsn sosn anbi12d df-we pm4.24 3bitr4g )
      BCZADZBEZRBFZGAABHIZUAGRBJUAQSUATUAABKABLMRBNUAOP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( An abstraction relation is a subset of a related cross product.
       (Contributed by NM, 16-Jul-1995.) $)
    opabssxp $p |- { <. x , y >. | ( ( x e. A /\ y e. B ) /\ ph ) }
                   C_ ( A X. B ) $=
      ( cv wcel wa copab cxp simpl ssopab2i df-xp sseqtr4i ) BFDGCFEGHZAHZBCIOB
      CIDEJPOBCOAKLBCDEMN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y ps $.
    brab2ga.1 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    brab2ga.2 $e |- R = { <. x , y >. | ( ( x e. C /\ y e. D ) /\ ph ) } $.
    $( The law of concretion for a binary relation.  See ~ brab2a for alternate
       proof.  TODO: should one of them be deleted?  (Contributed by Mario
       Carneiro, 28-Apr-2015.)  (Proof modification is discouraged.) $)
    brab2ga $p |- ( A R B <-> ( ( A e. C /\ B e. D ) /\ ps ) ) $=
      ( wbr wcel wa cv copab cxp opabssxp eqsstri brel eleq2i opelopab2a syl5bb
      cop df-br bitri biadan2 ) EFILZEGMFHMNZBEFGHIICOGMDOHMNANCDPZGHQKACDGHRST
      UHEFUDZUJMZUIBUHUKIMULEFIUEIUJUKKUAUFABCDEFGHJUBUCUG $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y ps $.
    optocl.1 $e |- D = ( B X. C ) $.
    optocl.2 $e |- ( <. x , y >. = A -> ( ph <-> ps ) ) $.
    optocl.3 $e |- ( ( x e. B /\ y e. C ) -> ph ) $.
    $( Implicit substitution of class for ordered pair.  (Contributed by NM,
       5-Mar-1995.) $)
    optocl $p |- ( A e. D -> ps ) $=
      ( cxp wcel cv cop wceq wa wex elxp3 sylbi opelxp syl5ib exlimivv eleq2s
      imp ) BEFGLZHEUFMCNZDNZOZEPZUIUFMZQZDRCRBCDEFGSULBCDUJUKBUKAUJBUKUGFMUHGM
      QAUGUHFGUAKTJUBUEUCTIUD $.
  $}

  ${
    $d x y z w A $.  $d z w B $.  $d x y z w C $.  $d x y z w D $.
    $d x y ps $.  $d z w ch $.  $d z w R $.
    2optocl.1 $e |- R = ( C X. D ) $.
    2optocl.2 $e |- ( <. x , y >. = A -> ( ph <-> ps ) ) $.
    2optocl.3 $e |- ( <. z , w >. = B -> ( ps <-> ch ) ) $.
    2optocl.4 $e |- ( ( ( x e. C /\ y e. D ) /\ ( z e. C /\ w e. D ) ) ->
                   ph ) $.
    $( Implicit substitution of classes for ordered pairs.  (Contributed by NM,
       12-Mar-1995.) $)
    2optocl $p |- ( ( A e. R /\ B e. R ) -> ch ) $=
      ( wcel wi cv cop wceq imbi2d wa ex optocl com12 impcom ) ILQHLQZCUHBRUHCR
      FGIJKLMFSZGSZTIUABCUHOUBUHUIJQUJKQUCZBUKARUKBRDEHJKLMDSZESZTHUAABUKNUBULJ
      QUMKQUCUKAPUDUEUFUEUG $.
  $}

  ${
    $d x y z w v u A $.  $d z w v u B $.  $d v u C $.  $d x y z w v u D $.
    $d x y z w v u F $.  $d z w v u R $.  $d x y ps $.  $d z w ch $.
    $d v u th $.
    3optocl.1 $e |- R = ( D X. F ) $.
    3optocl.2 $e |- ( <. x , y >. = A -> ( ph <-> ps ) ) $.
    3optocl.3 $e |- ( <. z , w >. = B -> ( ps <-> ch ) ) $.
    3optocl.4 $e |- ( <. v , u >. = C -> ( ch <-> th ) ) $.
    3optocl.5 $e |- ( ( ( x e. D /\ y e. F ) /\ ( z e. D /\ w e. F )
                    /\ ( v e. D /\ u e. F ) ) -> ph ) $.
    $( Implicit substitution of classes for ordered pairs.  (Contributed by NM,
       12-Mar-1995.) $)
    3optocl $p |- ( ( A e. R /\ B e. R /\ C e. R ) -> th ) $=
      ( wcel wa wi cv cop wceq imbi2d 3expia 2optocl com12 optocl impcom 3impa
      ) KOUBZLOUBZMOUBZDUQUOUPUCZDURCUDURDUDIJMNPOQIUEZJUEZUFMUGCDURTUHURUSNUBU
      TPUBUCZCVAAUDVABUDVACUDEFGHKLNPOQEUEZFUEZUFKUGABVARUHGUEZHUEZUFLUGBCVASUH
      VBNUBVCPUBUCVDNUBVEPUBUCVAAUAUIUJUKULUMUN $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.  $d x y z w v u S $.  $d x y ph $.  $d z w v u ps $.
    opbrop.1 $e |- ( ( ( z = A /\ w = B ) /\ ( v = C /\ u = D ) ) ->
                     ( ph <-> ps ) ) $.
    opbrop.2 $e |- R = { <. x , y >. | ( ( x e. ( S X. S ) /\
                      y e. ( S X. S ) ) /\
                      E. z E. w E. v E. u ( ( x = <. z , w >. /\
                      y = <. v , u >. ) /\ ph ) ) } $.
    $( Ordered pair membership in a relation.  Special case.  (Contributed by
       NM, 5-Aug-1995.) $)
    opbrop $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) ) ->
                   ( <. A , B >. R <. C , D >. <-> ps ) ) $=
      ( wcel wa cv wex cop wbr cxp wceq opex eleq1 anbi1d eqeq1 4exbidv anbi12d
      anbi2d brab copsex4g syl5bb opelxpi anim12i biantrurd bitr4d ) INQJNQRZKN
      QLNQRZRZIJUAZKLUAZMUBZVBNNUCZQZVCVEQZRZBRZBVDVHVBESFSUAZUDZVCGSHSUAZUDZRZ
      ARZHTGTFTETZRZVAVICSZVEQZDSZVEQZRZVRVJUDZVTVLUDZRZARZHTGTFTETZRVFWARZVKWD
      RZARZHTGTFTETZRVQCDVBVCMIJUEKLUEVRVBUDZWBWHWGWKWLVSVFWAVRVBVEUFUGWLWFWJEF
      GHWLWEWIAWLWCVKWDVRVBVJUHUGUGUIUJVTVCUDZWHVHWKVPWMWAVGVFVTVCVEUFUKWMWJVOE
      FGHWMWIVNAWMWDVMVKVTVCVLUHUKUGUIUJPULVAVPBVHABEFGHIJKLNNOUMUKUNVAVHBUSVFU
      TVGIJNNUOKLNNUOUPUQUR $.
  $}

  ${
    $d x y z A $.
    $( The cross product with the empty set is empty.  Part of Theorem 3.13(ii)
       of [Monk1] p. 37.  (Contributed by NM, 4-Jul-1994.) $)
    0xp $p |- ( (/) X. A ) = (/) $=
      ( vz vx vy c0 cxp cv wcel cop wceq wa wex elxp noel simprl mto nex 2false
      bitri eqriv ) BEAFZEBGZUAHUBCGZDGZIJZUCEHZUDAHZKKZDLZCLZUBEHZCDUBEAMUJUKU
      ICUHDUHUFUCNUEUFUGOPQQUBNRST $.
  $}

  ${
    $d A w y z $.  $d B w y z $.  $d C w y z $.  $d D w y z $.  $d w x y z $.
    $( Distribute proper substitution through the cross product of two
       classes.  (Contributed by Alan Sare, 10-Nov-2012.)  (Revised by NM,
       23-Aug-2018.) $)
    csbxp $p |- [_ A / x ]_ ( B X. C ) = ( [_ A / x ]_ B X. [_ A / x ]_ C ) $=
      ( vz vw vy cv wcel wex cab csb cxp wsbc sbcex2 sbcan bitri intnand eqtri
      wa cop wceq csbab cvv wb sbcg sbcel2 anbi12i a1i anbi12d sbcex con3i noel
      wn c0 neleqtrrd 2falsed pm2.61i exbii abbii copab df-opab csbeq2i 3eqtr4i
      csbprc df-xp ) ABEHFHZGHZUAUBZVGCIZVHDIZTZTZGJZFJZEKZLZVIVGABCLZIZVHABDLZ
      IZTZTZGJZFJZEKZABCDMZLVRVTMZVQVOABNZEKWFVOAEBUCWIWEEWIVNABNZFJWEVNFABOWJW
      DFWJVMABNZGJWDVMGABOWKWCGWKVIABNZVLABNZTZWCVIVLABPBUDIZWNWCUEWOWLVIWMWBVI
      ABUDUFWMWBUEWOWMVJABNZVKABNZTWBVJVKABPWPVSWQWAABVGCUGABVHDUGUHQUIUJWOUNZW
      NWCWRWMWLWMWOVLABUKULRWRWBVIWRWAVSWRVTUOVHVHUOIUNWRVHUMUIABDVEUPRRUQURQUS
      QUSQUTSABWGVPWGVLFGVAVPFGCDVFVLFGEVBSVCWHWBFGVAWFFGVRVTVFWBFGEVBSVD $.

    $( Distribute proper substitution through the cross product of two
       classes.  (Contributed by Alan Sare, 10-Nov-2012.)  Obsolete as of
       23-Aug-2018.  Use ~ csbrn instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbxpgOLD $p |- ( A e. D -> [_ A / x ]_ ( B X. C ) =
                ( [_ A / x ]_ B X. [_ A / x ]_ C ) ) $=
      ( vz vw vy wcel cv wa wex cab csb cxp wsbc sbcexgOLD sbcangOLD sbcel2gOLD
      bitrd wceq csbabgOLD sbcg anbi12d exbidv abbidv eqtrd copab df-xp df-opab
      cop eqtri csbeq2i 3eqtr4g ) BEIZABFJGJZHJZUKUAZUPCIZUQDIZKZKZHLZGLZFMZNZU
      RUPABCNZIZUQABDNZIZKZKZHLZGLZFMZABCDOZNVGVIOZUOVFVDABPZFMVOVDAFBEUBUOVRVN
      FUOVRVCABPZGLVNVCGABEQUOVSVMGUOVSVBABPZHLVMVBHABEQUOVTVLHUOVTURABPZVAABPZ
      KVLURVAABERUOWAURWBVKURABEUCUOWBUSABPZUTABPZKVKUSUTABERUOWCVHWDVJABUPCESA
      BUQDESUDTUDTUETUETUFUGABVPVEVPVAGHUHVEGHCDUIVAGHFUJULUMVQVKGHUHVOGHVGVIUI
      VKGHFUJULUN $.
  $}

  ${
    $d x y z $.
    $( Ordinal numbers and ordered pairs are disjoint collections.  This
       theorem can be used if we want to extend a set of ordinal numbers or
       ordered pairs with disjoint elements.  See also ~ snsn0non .
       (Contributed by NM, 1-Jun-2004.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    onxpdisj $p |- ( On i^i ( _V X. _V ) ) = (/) $=
      ( vx con0 cvv cxp cin c0 wceq cv wcel wn disj on0eqel 0nelxp eleq1 mtbiri
      wo 0nelelxp con2i jaoi syl mprgbir ) BCCDZEFGAHZUBIZJZABABUBKUCBIUCFGZFUC
      IZPUEUCLUFUEUGUFUDFUBICCMUCFUBNOUDUGCCUCQRSTUA $.
  $}

  $( The class of ordinal numbers is not equal to the universe.  (Contributed
     by NM, 16-Jun-2007.)  (Proof shortened by Mario Carneiro, 10-Jan-2013.) $)
  onnev $p |- On =/= _V $=
    ( c0 csn con0 wcel wn cvv wne snsn0non wceq snex syl5eleqr necon3bi ax-mp
    id ) ABZBZCDZECFGHQCFCFIZPFCOJRNKLM $.

  $( Equality theorem for the relation predicate.  (Contributed by NM,
     1-Aug-1994.) $)
  releq $p |- ( A = B -> ( Rel A <-> Rel B ) ) $=
    ( wceq cvv cxp wss wrel sseq1 df-rel 3bitr4g ) ABCADDEZFBKFAGBGABKHAIBIJ $.

  ${
    releqi.1 $e |- A = B $.
    $( Equality inference for the relation predicate.  (Contributed by NM,
       8-Dec-2006.) $)
    releqi $p |- ( Rel A <-> Rel B ) $=
      ( wceq wrel wb releq ax-mp ) ABDAEBEFCABGH $.
  $}

  ${
    releqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for the relation predicate.  (Contributed by NM,
       8-Mar-2014.) $)
    releqd $p |- ( ph -> ( Rel A <-> Rel B ) ) $=
      ( wceq wrel wb releq syl ) ABCEBFCFGDBCHI $.
  $}

  ${
    $d y A $.  $d x y $.
    nfrel.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for a relation.  (Contributed by NM,
       31-Jan-2004.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfrel $p |- F/ x Rel A $=
      ( wrel cvv cxp wss df-rel nfcv nfss nfxfr ) BDBEEFZGABHABLCALIJK $.
  $}

  $( Subclass theorem for relation predicate.  Theorem 2 of [Suppes] p. 58.
     (Contributed by NM, 15-Aug-1994.) $)
  relss $p |- ( A C_ B -> ( Rel B -> Rel A ) ) $=
    ( wss cvv cxp wrel sstr2 df-rel 3imtr4g ) ABCBDDEZCAJCBFAFABJGBHAHI $.

  ${
    $d x y z A $.  $d x y z B $.
    $( A subclass relationship depends only on a relation's ordered pairs.
       Theorem 3.2(i) of [Monk1] p. 33.  (Contributed by NM, 2-Aug-1994.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    ssrel $p |- ( Rel A -> ( A C_ B <->
                A. x A. y ( <. x , y >. e. A -> <. x , y >. e. B ) ) ) $=
      ( vz wrel wss cv cop wcel wi wal ssel alrimivv wceq wex eleq1 imbi12d cvv
      dfss2 biimprcd 2alimi 19.23vv sylib com23 alimdv df-rel elvv imbi2i albii
      a2d cxp 3bitri 3imtr4g com12 impbid2 ) CFZCDGZAHBHIZCJZUSDJZKZBLALZURVBAB
      CDUSMNVCUQURVCEHZCJZVDUSOZBPAPZKZELZVEVDDJZKZELUQURVCVHVKEVCVEVGVJVCVGVEV
      JVCVFVKKZBLALVGVKKVBVLABVFVKVBVFVEUTVJVAVDUSCQVDUSDQRUAUBVFVKABUCUDUEUKUF
      UQCSSULZGVEVDVMJZKZELVICUGECVMTVOVHEVNVGVEABVDUHUIUJUMECDTUNUOUP $.

    $( Extensionality principle for relations.  Theorem 3.2(ii) of [Monk1]
       p. 33.  (Contributed by NM, 2-Aug-1994.) $)
    eqrel $p |- ( ( Rel A /\ Rel B ) -> ( A = B <->
                A. x A. y ( <. x , y >. e. A <-> <. x , y >. e. B ) ) ) $=
      ( wrel wa wss cv cop wcel wi wal wceq ssrel bi2anan9 eqss 2albiim 3bitr4g
      wb ) CEZDEZFCDGZDCGZFAHBHIZCJZUDDJZKBLALZUFUEKBLALZFCDMUEUFSBLALTUBUGUAUC
      UHABCDNABDCNOCDPUEUFABQR $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z R $.  $d x y z S $.
    $( A subclass relationship depends only on a relation's ordered pairs.
       This version of ~ ssrel is restricted to the relation's domain.
       (Contributed by Thierry Arnoux, 25-Jan-2018.) $)
    ssrel2 $p |- ( R C_ ( A X. B ) -> ( R C_ S <-> A. x e. A A. y e. B
      ( <. x , y >. e. R -> <. x , y >. e. S ) ) ) $=
      ( vz cxp wss cv wcel wi wral wrex wal eleq1 ralimi r19.23v bitri dfss2 wa
      cop ssel a1d ralrimivv wceq imbi12d biimprcd ralbii sylib com23 a2d elxp2
      alimdv imbi2i albii 3imtr4g com12 impbid2 ) ECDHZIZEFIZAJZBJZUBZEKZVEFKZL
      ZBDMZACMZVBVHABCDVBVHVCCKVDDKUAEFVEUCUDUEVJVAVBVJGJZEKZVKVEUFZBDNZACNZLZG
      OZVLVKFKZLZGOVAVBVJVPVSGVJVLVOVRVJVOVLVRVJVMVSLZBDMZACMZVOVSLZVIWAACVHVTB
      DVMVSVHVMVLVFVRVGVKVEEPVKVEFPUGUHQQWBVNVSLZACMWCWAWDACVMVSBDRUIVNVSACRSUJ
      UKULUNVAVLVKUTKZLZGOVQGEUTTWFVPGWEVOVLABVKCDUMUOUPSGEFTUQURUS $.
  $}

  ${
    $d x y A $.  $d x y B $.
    relssi.1 $e |- Rel A $.
    relssi.2 $e |- ( <. x , y >. e. A -> <. x , y >. e. B ) $.
    $( Inference from subclass principle for relations.  (Contributed by NM,
       31-Mar-1998.) $)
    relssi $p |- A C_ B $=
      ( wss cv cop wcel wi wal wrel wb ssrel ax-mp ax-gen mpgbir ) CDGZAHBHIZCJ
      TDJKZBLZACMSUBALNEABCDOPUABFQR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ph $.
    relssdv.1 $e |- ( ph -> Rel A ) $.
    relssdv.2 $e |- ( ph -> ( <. x , y >. e. A -> <. x , y >. e. B ) ) $.
    $( Deduction from subclass principle for relations.  (Contributed by NM,
       11-Sep-2004.) $)
    relssdv $p |- ( ph -> A C_ B ) $=
      ( wss cv cop wcel wi wal alrimivv wrel wb ssrel syl mpbird ) ADEHZBICIJZD
      KUAEKLZCMBMZAUBBCGNADOTUCPFBCDEQRS $.
  $}

  ${
    $d x y A $.  $d x y B $.
    eqrelriv.1 $e |- ( <. x , y >. e. A <-> <. x , y >. e. B ) $.
    $( Inference from extensionality principle for relations.  (Contributed by
       FL, 15-Oct-2012.) $)
    eqrelriv $p |- ( ( Rel A /\ Rel B ) -> A = B ) $=
      ( wrel wa wceq cv cop wcel wb wal gen2 eqrel mpbiri ) CFDFGCDHAIBIJZCKQDK
      LZBMAMRABENABCDOP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    eqreliiv.1 $e |- Rel A $.
    eqreliiv.2 $e |- Rel B $.
    eqreliiv.3 $e |- ( <. x , y >. e. A <-> <. x , y >. e. B ) $.
    $( Inference from extensionality principle for relations.  (Contributed by
       NM, 17-Mar-1995.) $)
    eqrelriiv $p |- A = B $=
      ( wrel wceq eqrelriv mp2an ) CHDHCDIEFABCDGJK $.
  $}

  ${
    $d x y A $.  $d x y B $.
    eqbrriv.1 $e |- Rel A $.
    eqbrriv.2 $e |- Rel B $.
    eqbrriv.3 $e |- ( x A y <-> x B y ) $.
    $( Inference from extensionality principle for relations.  (Contributed by
       NM, 12-Dec-2006.) $)
    eqbrriv $p |- A = B $=
      ( cv wbr cop wcel df-br 3bitr3i eqrelriiv ) ABCDEFAHZBHZCIOPDIOPJZCKQDKGO
      PCLOPDLMN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqrelrdv.1 $e |- Rel A $.
    eqrelrdv.2 $e |- Rel B $.
    eqrelrdv.3 $e |- ( ph -> ( <. x , y >. e. A <-> <. x , y >. e. B ) ) $.
    $( Deduce equality of relations from equivalence of membership.
       (Contributed by Rodolfo Medina, 10-Oct-2010.) $)
    eqrelrdv $p |- ( ph -> A = B ) $=
      ( cv cop wcel wb wal wceq alrimivv wrel eqrel mp2an sylibr ) ABICIJZDKTEK
      LZCMBMZDENZAUABCHODPEPUCUBLFGBCDEQRS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqbrrdv.1 $e |- ( ph -> Rel A ) $.
    eqbrrdv.2 $e |- ( ph -> Rel B ) $.
    eqbrrdv.3 $e |- ( ph -> ( x A y <-> x B y ) ) $.
    $( Deduction from extensionality principle for relations.  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    eqbrrdv $p |- ( ph -> A = B ) $=
      ( wceq cv cop wcel wb wal wbr df-br 3bitr3g alrimivv wrel eqrel syl2anc
      mpbird ) ADEIZBJZCJZKZDLZUFELZMZCNBNZAUIBCAUDUEDOUDUEEOUGUHHUDUEDPUDUEEPQ
      RADSESUCUJMFGBCDETUAUB $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqbrrdiv.1 $e |- Rel A $.
    eqbrrdiv.2 $e |- Rel B $.
    eqbrrdiv.3 $e |- ( ph -> ( x A y <-> x B y ) ) $.
    $( Deduction from extensionality principle for relations.  (Contributed by
       Rodolfo Medina, 10-Oct-2010.) $)
    eqbrrdiv $p |- ( ph -> A = B ) $=
      ( cv wbr cop wcel df-br 3bitr3g eqrelrdv ) ABCDEFGABIZCIZDJPQEJPQKZDLRELH
      PQDMPQEMNO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqrelrdv2.1 $e |- ( ph
       -> ( <. x , y >. e. A <-> <. x , y >. e. B ) ) $.
    $( A version of ~ eqrelrdv .  (Contributed by Rodolfo Medina,
       10-Oct-2010.) $)
    eqrelrdv2 $p |- ( ( ( Rel A /\ Rel B ) /\ ph ) -> A = B ) $=
      ( wrel wa wceq cv cop wcel wb wal alrimivv adantl eqrel adantr mpbird ) D
      GEGHZAHDEIZBJCJKZDLUBELMZCNBNZAUDTAUCBCFOPTUAUDMABCDEQRS $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.
    $( A subclass relationship determined by ordered triples.  Use ~ relrelss
       to express the antecedent in terms of the relation predicate.
       (Contributed by NM, 17-Dec-2008.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    ssrelrel $p |- ( A C_ ( ( _V X. _V ) X. _V ) -> ( A C_ B <->
                   A. x A. y A. z ( <. <. x , y >. , z >. e. A
                       -> <. <. x , y >. , z >. e. B ) ) ) $=
      ( vw cvv cxp wss cv cop wcel wi wal ssel alrimiv wex eleq1 sylib dfss2
      alrimivv wceq elvvv imbi12d biimprcd alimi 19.23v 2alimi syl5bi com23 a2d
      19.23vv alimdv 3imtr4g com12 impbid2 ) DGGHGHZIZDEIZAJBJKCJKZDLZUTELZMZCN
      ZBNANZUSVDABUSVCCDEUTOPUAVEURUSVEFJZDLZVFUQLZMZFNVGVFELZMZFNURUSVEVIVKFVE
      VGVHVJVEVHVGVJVHVFUTUBZCQZBQAQZVEVKABCVFUCVEVMVKMZBNANVNVKMVDVOABVDVLVKMZ
      CNVOVCVPCVLVKVCVLVGVAVJVBVFUTDRVFUTERUDUEUFVLVKCUGSUHVMVKABULSUIUJUKUMFDU
      QTFDETUNUOUP $.

    $( Extensionality principle for ordered triples (used by 2-place operations
       ~ df-oprab ), analogous to ~ eqrel .  Use ~ relrelss to express the
       antecedent in terms of the relation predicate.  (Contributed by NM,
       17-Dec-2008.) $)
    eqrelrel $p |- ( ( A u. B ) C_ ( ( _V X. _V ) X. _V ) -> ( A = B <->
                   A. x A. y A. z ( <. <. x , y >. , z >. e. A
                       <-> <. <. x , y >. , z >. e. B ) ) ) $=
      ( cun cvv cxp wss wa wceq cv cop wcel wb wal unss wi ssrelrel bi2anan9
      eqss 2albiim albii 19.26 bitri 3bitr4g sylbir ) DEFGGHGHZIDUHIZEUHIZJZDEK
      ZALBLMCLMZDNZUMENZOCPBPZAPZODEUHQUKDEIZEDIZJUNUORCPBPZAPZUOUNRCPBPZAPZJZU
      LUQUIURVAUJUSVCABCDESABCEDSTDEUAUQUTVBJZAPVDUPVEAUNUOBCUBUCUTVBAUDUEUFUG
      $.
  $}

  ${
    $d x y A $.
    $( A member of a relation is an ordered pair.  (Contributed by NM,
       17-Sep-2006.) $)
    elrel $p |- ( ( Rel R /\ A e. R ) -> E. x E. y A = <. x , y >. ) $=
      ( wrel wcel wa cvv cxp cop wceq wex wss df-rel biimpi sselda elvv sylib
      cv ) DEZCDFGCHHIZFCASBSJKBLALTDUACTDUAMDNOPABCQR $.
  $}

  ${
    relsn.1 $e |- A e. _V $.
    $( A singleton is a relation iff it is an ordered pair.  (Contributed by
       NM, 24-Sep-2013.) $)
    relsn $p |- ( Rel { A } <-> A e. ( _V X. _V ) ) $=
      ( csn wrel cvv cxp wss wcel df-rel snss bitr4i ) ACZDLEEFZGAMHLIAMBJK $.

    relsnop.2 $e |- B e. _V $.
    $( A singleton of an ordered pair is a relation.  (Contributed by NM,
       17-May-1998.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    relsnop $p |- Rel { <. A , B >. } $=
      ( cop csn wrel cvv cxp wcel opelvv opex relsn mpbir ) ABEZFGOHHIJABCDKOAB
      LMN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    $( Subset theorem for cross product.  Generalization of Theorem 101 of
       [Suppes] p. 52.  (Contributed by NM, 26-Aug-1995.)  (Proof shortened by
       Andrew Salmon, 27-Aug-2011.) $)
    xpss12 $p |- ( ( A C_ B /\ C C_ D ) -> ( A X. C ) C_ ( B X. D ) ) $=
      ( vx vy wss wa cv wcel copab cxp ssel im2anan9 ssopab2dv df-xp 3sstr4g )
      ABGZCDGZHZEIZAJZFIZCJZHZEFKUABJZUCDJZHZEFKACLBDLTUEUHEFRUBUFSUDUGABUAMCDU
      CMNOEFACPEFBDPQ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( A cross product is included in the ordered pair universe.  Exercise 3 of
       [TakeutiZaring] p. 25.  (Contributed by NM, 2-Aug-1994.) $)
    xpss $p |- ( A X. B ) C_ ( _V X. _V ) $=
      ( cvv wss cxp ssv xpss12 mp2an ) ACDBCDABECCEDAFBFACBCGH $.
  $}

  $( A cross product is a relation.  Theorem 3.13(i) of [Monk1] p. 37.
     (Contributed by NM, 2-Aug-1994.) $)
  relxp $p |- Rel ( A X. B ) $=
    ( cxp wrel cvv wss xpss df-rel mpbir ) ABCZDJEECFABGJHI $.

  $( Subset relation for cross product.  (Contributed by Jeff Hankins,
     30-Aug-2009.) $)
  xpss1 $p |- ( A C_ B -> ( A X. C ) C_ ( B X. C ) ) $=
    ( wss cxp ssid xpss12 mpan2 ) ABDCCDACEBCEDCFABCCGH $.

  $( Subset relation for cross product.  (Contributed by Jeff Hankins,
     30-Aug-2009.) $)
  xpss2 $p |- ( A C_ B -> ( C X. A ) C_ ( C X. B ) ) $=
    ( wss cxp ssid xpss12 mpan ) CCDABDCAECBEDCFCCABGH $.

  ${
    $d A x y z $.  $d B x y z $.
    $( A cross product is included in the power of the power of the union of
       its arguments.  (Contributed by NM, 13-Sep-2006.) $)
    xpsspw $p |- ( A X. B ) C_ ~P ~P ( A u. B ) $=
      ( vz vx vy cun cpw cv wcel wss wceq wa wex csn cpr snssi sseq1 syl5ibrcom
      vex syl cxp cop elxpi dfop wo ssun3 adantr df-pr ssun4 anim12i unss sylib
      syl5eqss jaod elpr 3imtr4g ssrdv biimpar sylan2 exlimivv sylibr ssriv
      elpw ) CABUAZABFZGZGZCHZVDIZVHVFJZVHVGIVIVHDHZEHZUBZKZVKAIZVLBIZLZLZEMDMV
      JDEVHABUCVRVJDEVQVNVMVFJZVJVQVMVKNZVKVLOZOZVFVKVLDSESUDVQCWBVFVQVHVTKZVHW
      AKZUEVHVEJZVHWBIVHVFIVQWCWEWDVQWEWCVTVEJZVOWFVPVOVTAJWFVKAPVTABUFTZUGVHVT
      VEQRVQWEWDWAVEJVQWAVTVLNZFZVEVKVLUHVQWFWHVEJZLWIVEJVOWFVPWJWGVPWHBJWJVLBP
      WHBAUITUJVTWHVEUKULUMVHWAVEQRUNVHVTWACSZUOVHVEWKVCUPUQUMVNVJVSVHVMVFQURUS
      UTTVHVFWKVCVAVB $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A cross product is included in the power of the power of the union of
       its arguments.  (Contributed by NM, 13-Sep-2006.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    xpsspwOLD $p |- ( A X. B ) C_ ~P ~P ( A u. B ) $=
      ( vx vy cxp cun cpw relxp cv wcel csn cpr wss snssi syl elpw sylibr sylib
      wa vex opelxp ssun3 snex adantr df-pr ssun4 anim12i unss syl5eqss zfpair2
      cop jca prex dfop eleq1i prss 3bitr4ri sylbi relssi ) CDABEZABFZGZGZABHCI
      ZDIZUKZUTJVDAJZVEBJZSZVFVCJZVDVEABUAVIVDKZVBJZVDVELZVBJZSZVJVIVLVNVGVLVHV
      GVKVAMZVLVGVKAMVPVDANVKABUBOZVKVAVDUCZPQUDVIVMVAMVNVIVMVKVEKZFZVAVDVEUEVI
      VPVSVAMZSVTVAMVGVPVHWAVQVHVSBMWAVEBNVSBAUFOUGVKVSVAUHRUIVMVACDUJZPQULVKVM
      LZVCJWCVBMVJVOWCVBVKVMUMPVFWCVCVDVECTDTUNUOVKVMVBVRWBUPUQRURUS $.
  $}

  $( The double class union of a cross product is included in the union of its
     arguments.  (Contributed by NM, 16-Sep-2006.) $)
  unixpss $p |- U. U. ( A X. B ) C_ ( A u. B ) $=
    ( cxp cuni cun cpw xpsspw unissi unipw sseqtri ) ABCZDZDABEZFZDMLNLNFZDNKOA
    BGHNIJHMIJ $.

  $( The cross product of two sets is a set.  Proposition 6.2 of
     [TakeutiZaring] p. 23.  See also ~ xpexgALT .  (Contributed by NM,
     14-Aug-1994.) $)
  xpexg $p |- ( ( A e. V /\ B e. W ) -> ( A X. B ) e. _V ) $=
    ( wcel wa cxp cun cpw wss cvv xpsspw unexg pwexg 3syl ssexg sylancr ) ACEBD
    EFZABGZABHZIZIZJUBKEZSKEABLRTKEUAKEUCABCDMTKNUAKNOSUBKPQ $.

  ${
    xpex.1 $e |- A e. _V $.
    xpex.2 $e |- B e. _V $.
    $( The cross product of two sets is a set.  Proposition 6.2 of
       [TakeutiZaring] p. 23.  (Contributed by NM, 14-Aug-1994.) $)
    xpex $p |- ( A X. B ) e. _V $=
      ( cvv wcel cxp xpexg mp2an ) AEFBEFABGEFCDABEEHI $.
  $}

  $( The union of two relations is a relation.  Compare Exercise 5 of
     [TakeutiZaring] p. 25.  (Contributed by NM, 12-Aug-1994.) $)
  relun $p |- ( Rel ( A u. B ) <-> ( Rel A /\ Rel B ) ) $=
    ( cvv cxp wss wa cun wrel unss df-rel anbi12i 3bitr4ri ) ACCDZEZBMEZFABGZME
    AHZBHZFPHABMIQNROAJBJKPJL $.

  $( The intersection with a relation is a relation.  (Contributed by NM,
     16-Aug-1994.) $)
  relin1 $p |- ( Rel A -> Rel ( A i^i B ) ) $=
    ( cin wss wrel wi inss1 relss ax-mp ) ABCZADAEJEFABGJAHI $.

  $( The intersection with a relation is a relation.  (Contributed by NM,
     17-Jan-2006.) $)
  relin2 $p |- ( Rel B -> Rel ( A i^i B ) ) $=
    ( cin wss wrel wi inss2 relss ax-mp ) ABCZBDBEJEFABGJBHI $.

  $( A difference cutting down a relation is a relation.  (Contributed by NM,
     31-Mar-1998.) $)
  reldif $p |- ( Rel A -> Rel ( A \ B ) ) $=
    ( cdif wss wrel wi difss relss ax-mp ) ABCZADAEJEFABGJAHI $.

  ${
    $d y A $.  $d y B $.  $d x y $.
    $( An indexed union is a relation iff each member of its indexed family is
       a relation.  (Contributed by NM, 19-Dec-2008.) $)
    reliun $p |- ( Rel U_ x e. A B <-> A. x e. A Rel B ) $=
      ( vy ciun wrel cv wcel wrex cab cvv cxp wss wral df-iun releqi df-rel wal
      wi 3bitri abss dfss2 bitri ralbii ralcom4 r19.23v albii bitr4i ) ABCEZFDG
      ZCHZABIZDJZFUMKKLZMZCFZABNZUIUMADBCOPUMQUOULUJUNHZSZDRZUQULDUNUAUQUKURSZD
      RZABNVAABNZDRUTUPVBABUPCUNMVBCQDCUNUBUCUDVAADBUEVCUSDUKURABUFUGTUHT $.
  $}

  $( An indexed intersection is a relation if at least one of the member of the
     indexed family is a relation.  (Contributed by NM, 8-Mar-2014.) $)
  reliin $p |- ( E. x e. A Rel B -> Rel |^|_ x e. A B ) $=
    ( cvv cxp wss wrex ciin wrel iinss df-rel rexbii 3imtr4i ) CDDEZFZABGABCHZN
    FCIZABGPIABCNJQOABCKLPKM $.

  ${
    $d x A $.
    $( The union of a class is a relation iff any member is a relation.
       Exercise 6 of [TakeutiZaring] p. 25 and its converse.  (Contributed by
       NM, 13-Aug-2004.) $)
    reluni $p |- ( Rel U. A <-> A. x e. A Rel x ) $=
      ( cuni wrel cv ciun wral uniiun releqi reliun bitri ) BCZDABAEZFZDMDABGLN
      ABHIABMJK $.

    $( The intersection of a class is a relation if at least one member is a
       relation.  (Contributed by NM, 8-Mar-2014.) $)
    relint $p |- ( E. x e. A Rel x -> Rel |^| A ) $=
      ( cv wrel wrex ciin cint reliin intiin releqi sylibr ) ACZDABEABLFZDBGZDA
      BLHNMABIJK $.
  $}

  $( The empty set is a relation.  (Contributed by NM, 26-Apr-1998.) $)
  rel0 $p |- Rel (/) $=
    ( c0 wrel cvv cxp wss 0ss df-rel mpbir ) ABACCDZEIFAGH $.

  ${
    $d ph z $.  $d u v x z $.  $d u v y z $.
    relopabi.1 $e |- A = { <. x , y >. | ph } $.
    $( A class of ordered pairs is a relation.  (Contributed by Mario Carneiro,
       21-Dec-2013.) $)
    relopabi $p |- Rel A $=
      ( vz wrel cvv cxp wss cv cop wceq wa wex cab copab df-opab wcel vex eqtri
      opelvv eleq1 mpbiri adantr exlimivv abssi eqsstri df-rel mpbir ) DGDHHIZJ
      DFKZBKZCKZLZMZANZCOBOZFPZUKDABCQUSEABCFRUAURFUKUQULUKSZBCUPUTAUPUTUOUKSUM
      UNBTCTUBULUOUKUCUDUEUFUGUHDUIUJ $.
  $}

  $( A class of ordered pairs is a relation.  (Contributed by NM, 8-Mar-1995.)
     (Unnecessary distinct variable restrictions were removed by Alan Sare,
     9-Jul-2013.)  (Proof shortened by Mario Carneiro, 21-Dec-2013.) $)
  relopab $p |- Rel { <. x , y >. | ph } $=
    ( copab eqid relopabi ) ABCABCDZGEF $.

  ${
    $d w x y z A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d ph z w $.
    $d ps z w $.
    $( The identity relation is a relation.  Part of Exercise 4.12(p) of
       [Mendelson] p. 235.  (Contributed by NM, 26-Apr-1998.)  (Revised by
       Mario Carneiro, 21-Dec-2013.) $)
    reli $p |- Rel _I $=
      ( vx vy weq cid dfid3 relopabi ) ABCABDABEF $.

    $( The membership relation is a relation.  (Contributed by NM,
       26-Apr-1998.)  (Revised by Mario Carneiro, 21-Dec-2013.) $)
    rele $p |- Rel _E $=
      ( vx vy wel cep df-eprel relopabi ) ABCABDABEF $.

    $( A relation expressed as an ordered pair abstraction.  (Contributed by
       NM, 11-Dec-2006.) $)
    opabid2 $p |- ( Rel A -> { <. x , y >. | <. x , y >. e. A } = A ) $=
      ( vz vw wrel cv cop wcel copab wceq wb wal vex opeq1 eleq1d opelopab gen2
      opeq2 relopab eqrel mpan mpbiri ) CFZAGZBGZHZCIZABJZCKZDGZEGZHZUIIUMCIZLZ
      EMDMZUODEUHUKUFHZCIUNABUKULDNENUEUKKUGUQCUEUKUFOPUFULKUQUMCUFULUKSPQRUIFU
      DUJUPLUHABTDEUICUAUBUC $.

    $( Intersection of two ordered pair class abstractions.  (Contributed by
       NM, 30-Sep-2002.) $)
    inopab $p |- ( { <. x , y >. | ph } i^i { <. x , y >. | ps } ) =
               { <. x , y >. | ( ph /\ ps ) } $=
      ( vz vw copab cin wa wrel relopab relin1 ax-mp cv cop wcel wsb sban sbbii
      opelopabsbOLD anbi12i 3bitr4ri elin 3bitr4i eqrelriiv ) EFACDGZBCDGZHZABI
      ZCDGZUFJUHJACDKUFUGLMUICDKENFNOZUFPZUKUGPZIZUICEQZDFQZUKUHPUKUJPACEQZBCEQ
      ZIZDFQUQDFQZURDFQZIUPUNUQURDFRUOUSDFABCERSULUTUMVAACDEFTBCDEFTUAUBUKUFUGU
      CUICDEFTUDUE $.

    $( The difference of two ordered-pair abstractions.  (Contributed by Stefan
       O'Rear, 17-Jan-2015.) $)
    difopab $p |- ( { <. x , y >. | ph } \ { <. x , y >. | ps } ) =
        { <. x , y >. | ( ph /\ -. ps ) } $=
      ( vz vw copab wn wa wrel relopab ax-mp cv wcel wsbc sbcbii opelopabsb cvv
      sbcan wb cdif reldif cop vex sbcng notbii anbi12i eldif 3bitr4i eqrelriiv
      3bitr4ri ) EFACDGZBCDGZUAZABHZIZCDGZULJUNJACDKULUMUBLUPCDKEMZFMZUCZULNZUT
      UMNZHZIZUPDUSOZCUROZUTUNNUTUQNADUSOZUODUSOZIZCUROVGCUROZVHCUROZIVFVDVGVHC
      URSVEVICURAUODUSSPVAVJVCVKACDURUSQBDUSOZHZCUROZVLCUROZHZVKVCURRNVNVPTEUDV
      LCURRUELVHVMCURUSRNVHVMTFUDBDUSRUELPVBVOBCDURUSQUFUKUGUKUTULUMUHUPCDURUSQ
      UIUJ $.

    $( The intersection of two cross products.  Exercise 9 of [TakeutiZaring]
       p. 25.  (Contributed by NM, 3-Aug-1994.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    inxp $p |- ( ( A X. B ) i^i ( C X. D ) ) =
                   ( ( A i^i C ) X. ( B i^i D ) ) $=
      ( vx vy cv wcel wa copab cin cxp inopab elin anbi12i bitr4i opabbii eqtri
      an4 df-xp ineq12i 3eqtr4i ) EGZAHZFGZBHZIZEFJZUCCHZUEDHZIZEFJZKZUCACKZHZU
      EBDKZHZIZEFJZABLZCDLZKUNUPLUMUGUKIZEFJUSUGUKEFMVBUREFVBUDUIIZUFUJIZIURUDU
      FUIUJSUOVCUQVDUCACNUEBDNOPQRUTUHVAULEFABTEFCDTUAEFUNUPTUB $.

    $( Distributive law for cross product over intersection.  Theorem 102 of
       [Suppes] p. 52.  (Contributed by NM, 26-Sep-2004.) $)
    xpindi $p |- ( A X. ( B i^i C ) ) = ( ( A X. B ) i^i ( A X. C ) ) $=
      ( cxp cin inxp inidm xpeq1i eqtr2i ) ABDACDEAAEZBCEZDAKDABACFJAKAGHI $.

    $( Distributive law for cross product over intersection.  Similar to
       Theorem 102 of [Suppes] p. 52.  (Contributed by NM, 26-Sep-2004.) $)
    xpindir $p |- ( ( A i^i B ) X. C ) = ( ( A X. C ) i^i ( B X. C ) ) $=
      ( cxp cin inxp inidm xpeq2i eqtr2i ) ACDBCDEABEZCCEZDJCDACBCFKCJCGHI $.
  $}

  ${
    $d x y z A $.  $d x y z C $.  $d y z B $.
    $( Distributive law for cross product over indexed intersection.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    xpiindi $p |- ( A =/= (/) ->
      ( C X. |^|_ x e. A B ) = |^|_ x e. A ( C X. B ) ) $=
      ( vy vz ciin cxp wrel wa wral relxp cv wcel wb eliin ax-mp opelxp 3bitr4g
      cvv wne wceq wrex rgenw r19.2z mpan2 reliin syl jctil cop r19.28zv bicomd
      c0 vex anbi2i ralbii opex eqrelrdv2 mpancom ) DABCGZHZIZABDCHZGZIZJBUMUAZ
      VAVDUBVFVEVBVFVCIZABUCZVEVFVGABKVHVGABDCLUDVGABUEUFABVCUGUHDUTLUIVFEFVAVD
      VFEMZDNZFMZUTNZJZVIVKUJZVCNZABKZVNVANVNVDNZVFVJVKCNZABKZJZVJVRJZABKZVMVPV
      FWBVTVJVRABUKULVLVSVJVKTNVLVSOFUNAVKBCTPQUOVOWAABVIVKDCRUPSVIVKDUTRVNTNVQ
      VPOVIVKUQAVNBVCTPQSURUS $.

    $( Distributive law for cross product over relativized indexed
       intersection.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    xpriindi $p |- ( C X. ( D i^i |^|_ x e. A B ) ) =
      ( ( C X. D ) i^i |^|_ x e. A ( C X. B ) ) $=
      ( ciin cin cxp wceq c0 cvv iineq1 0iin syl6eq ineq2d xpeq2d eqtr4d xpindi
      inv1 wne xpiindi syl5eq pm2.61ine ) DEABCFZGZHZDEHZABDCHZFZGZIBJBJIZUFUGU
      JUKUEEDUKUEEKGEUKUDKEUKUDAJCFKABJCLACMNOESNPUKUJUGKGUGUKUIKUGUKUIAJUHFKAB
      JUHLAUHMNOUGSNQBJTZUFUGDUDHZGUJDEUDRULUMUIUGABCDUAOUBUC $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x E $.  $d x V $.
    $( Membership in a union of cross products.  Analogue of ~ elxp for
       nonconstant ` B ( x ) ` .  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    eliunxp $p |- ( C e. U_ x e. A ( { x } X. B ) <->
      E. x E. y ( C = <. x , y >. /\ ( x e. A /\ y e. B ) ) ) $=
      ( cv csn cxp ciun wcel cop wceq wex wa wrel wral relxp rgenw reliun exbii
      mpbir elrel mpan pm4.71ri nfiu1 nfel2 19.41 19.41v eleq1 opeliunxp syl6bb
      pm5.32i bitr3i 3bitr2i ) EACAFZGZDHZIZJZEUOBFZKZLZBMZAMZUSNVCUSNZAMVBUOCJ
      UTDJNZNZBMZAMUSVDUROZUSVDVIUQOZACPVJACUPDQRACUQSUAABEURUBUCUDVCUSAAEURACU
      QUEUFUGVEVHAVEVBUSNZBMVHVBUSBUHVKVGBVBUSVFVBUSVAURJVFEVAURUIACDUTUJUKULTU
      MTUN $.

    $d x A $.
    opeliunxp2.1 $e |- ( x = C -> B = E ) $.
    $( Membership in a union of cross products.  (Contributed by Mario
       Carneiro, 14-Feb-2015.) $)
    opeliunxp2 $p |- ( <. C , D >. e. U_ x e. A ( { x } X. B ) <->
      ( C e. A /\ D e. E ) ) $=
      ( cop cv csn cxp ciun wcel cvv wa wbr df-br wrel wral wb relxp rgenw elex
      reliun mpbir brrelexi sylbir adantr nfcv nfiu1 nfel2 nfv nfbi wceq eleq1d
      opeq1 eleq1 eleq2d anbi12d bibi12d opeliunxp vtoclgf pm5.21nii ) DEHZABAI
      ZJZCKZLZMZDNMZDBMZEFMZOZVIDEVHPVJDEVHQDEVHVHRVGRZABSVNABVFCUAUBABVGUDUEUF
      UGVKVJVLDBUCUHVEEHZVHMZVEBMZECMZOZTVIVMTADNADUIVIVMAAVDVHABVGUJUKVMAULUMV
      EDUNZVPVIVSVMVTVOVDVHVEDEUPUOVTVQVKVRVLVEDBUQVTCFEGURUSUTABCEVAVBVC $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d y z ph $.  $d x ps $.
    ralxp.1 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Write a double restricted quantification as one universal quantifier.
       In this version of ~ ralxp , ` B ( y ) ` is not assumed to be constant.
       (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    raliunxp $p |- ( A. x e. U_ y e. A ( { y } X. B ) ph <->
      A. y e. A A. z e. B ps ) $=
      ( cv csn cxp ciun wcel wi wal wa wral wex albii bitri wceq eliunxp imbi1i
      cop 19.23vv bitr4i alrot3 impexp opex imbi2d ceqsalv 2albii r2al 3bitr4i
      df-ral ) CIZDFDIZJGKLZMZANZCOZUQFMEIZGMPZBNZEODOZACURQBEGQDFQVAUPUQVBUDZU
      AZVCPZANZEODOZCOZVEUTVJCUTVHERDRZANVJUSVLADEFGUPUBUCVHADEUEUFSVKVICOZEODO
      VEVICDEUGVMVDDEVMVGVCANZNZCOVDVIVOCVGVCAUHSVNVDCVFUQVBUIVGABVCHUJUKTULTTA
      CURUOBDEFGUMUN $.

    $( Write a double restricted quantification as one universal quantifier.
       In this version of ~ rexxp , ` B ( y ) ` is not assumed to be constant.
       (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    rexiunxp $p |- ( E. x e. U_ y e. A ( { y } X. B ) ph <->
      E. y e. A E. z e. B ps ) $=
      ( wn cv csn cxp ciun wral wrex cop wceq notbid raliunxp dfrex2 3bitr4i
      ralnex ralbii bitri notbii ) AIZCDFDJZKGLMZNZIBEGOZIZDFNZIACUHOUJDFOUIULU
      IBIZEGNZDFNULUFUMCDEFGCJUGEJPQABHRSUNUKDFBEGUBUCUDUEACUHTUJDFTUA $.

    $d y B $.
    $( Universal quantification restricted to a cross product is equivalent to
       a double restricted quantification.  The hypothesis specifies an
       implicit substitution.  (Contributed by NM, 7-Feb-2004.)  (Revised by
       Mario Carneiro, 29-Dec-2014.) $)
    ralxp $p |- ( A. x e. ( A X. B ) ph <-> A. y e. A A. z e. B ps ) $=
      ( cxp wral cv csn ciun iunxpconst raleqi raliunxp bitr3i ) ACFGIZJACDFDKL
      GIMZJBEGJDFJACSRDFGNOABCDEFGHPQ $.

    $( Existential quantification restricted to a cross product is equivalent
       to a double restricted quantification.  (Contributed by NM,
       11-Nov-1995.)  (Revised by Mario Carneiro, 14-Feb-2015.) $)
    rexxp $p |- ( E. x e. ( A X. B ) ph <-> E. y e. A E. z e. B ps ) $=
      ( cxp wrex cv csn ciun iunxpconst rexeqi rexiunxp bitr3i ) ACFGIZJACDFDKL
      GIMZJBEGJDFJACSRDFGNOABCDEFGHPQ $.
  $}

  ${
    $d x A $.
    $( Disjoint union is a subset of a cross product.  (Contributed by Stefan
       O'Rear, 21-Nov-2014.) $)
    djussxp $p |- U_ x e. A ( { x } X. B ) C_ ( A X. _V ) $=
      ( cv csn cxp ciun cvv wss iunss wcel snssi ssv xpss12 sylancl mprgbir ) A
      BADZEZCFZGBHFZISTIZABABSTJQBKRBICHIUAQBLCMRBCHNOP $.
  $}

  ${
    $d u v w x y A $.  $d u v w x y z B $.  $d u v w ph $.  $d u v w ps $.
    ralxpf.1 $e |- F/ y ph $.
    ralxpf.2 $e |- F/ z ph $.
    ralxpf.3 $e |- F/ x ps $.
    ralxpf.4 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Version of ~ ralxp with bound-variable hypotheses.  (Contributed by NM,
       18-Aug-2006.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    ralxpf $p |- ( A. x e. ( A X. B ) ph <-> A. y e. A A. z e. B ps ) $=
      ( vw vu vv wral wsb cv wceq vex nfsb cxp cbvralsv ralbii nfcv nfs1v nfral
      nfv sbequ12 ralbidv cbvral cop wa wex wb eqvinop nfbi opth sylan9bb sylbi
      sbhypf exlimi ralxp 3bitr4ri bitri ) ACFGUAZOACLPZLVEOZBEGOZDFOZACLVEUBBD
      MPZEGOZMFOVJENPZNGOZMFOVIVGVKVMMFVJENGUBUCVHVKDMFVHMUGVJDEGDGUDBDMUEZUFDQ
      ZMQZRZBVJEGBDMUHZUIUJVFVLLMNFGLQZVPNQZUKZRVSVOEQZUKZRZWCWARZULZEUMZDUMVFV
      LUNZDEVSVPVTMSNSUOWGWHDVFVLDACLDHTVJENDVNTUPWFWHEVFVLEACLEITVJENUEUPWDVFB
      WEVLABCLWCJKUTWEVQWBVTRZULBVLUNVOWBVPVTDSESUQVQBVJWIVLVRVJENUHURUSURVAVAU
      SVBVCVD $.

    $( Version of ~ rexxp with bound-variable hypotheses.  (Contributed by NM,
       19-Dec-2008.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    rexxpf $p |- ( E. x e. ( A X. B ) ph <-> E. y e. A E. z e. B ps ) $=
      ( wn cxp wral wrex nfn cv cop wceq dfrex2 notbid ralxpf ralnex 3bitr4i
      ralbii bitri notbii ) ALZCFGMZNZLBEGOZLZDFNZLACUIOUKDFOUJUMUJBLZEGNZDFNUM
      UHUNCDEFGADHPAEIPBCJPCQDQEQRSABKUAUBUOULDFBEGUCUEUFUGACUITUKDFTUD $.
  $}

  ${
    $d w x y A $.  $d w x y z B $.  $d w C $.  $d w D $.
    iunxpf.1 $e |- F/_ y C $.
    iunxpf.2 $e |- F/_ z C $.
    iunxpf.3 $e |- F/_ x D $.
    iunxpf.4 $e |- ( x = <. y , z >. -> C = D ) $.
    $( Indexed union on a cross product is equals a double indexed union.  The
       hypothesis specifies an implicit substitution.  (Contributed by NM,
       19-Dec-2008.) $)
    iunxpf $p |- U_ x e. ( A X. B ) C = U_ y e. A U_ z e. B D $=
      ( vw cxp ciun cv wcel wrex nfcri cop eliun wceq eleq2d rexxpf bitri eqriv
      rexbii 3bitr4i ) LADEMZFNZBDCEGNZNZLOZFPZAUHQULGPZCEQZBDQZULUIPULUKPZUMUN
      ABCDEBLFHRCLFIRALGJRAOBOCOSUAFGULKUBUCAULUHFTUQULUJPZBDQUPBULDUJTURUOBDCU
      LEGTUFUDUGUE $.
  $}

  ${
    $d x y A $.  $d x y ph $.
    opabbi2dv.1 $e |- Rel A $.
    opabbi2dv.3 $e |- ( ph -> ( <. x , y >. e. A <-> ps ) ) $.
    $( Deduce equality of a relation and an ordered-pair class builder.
       Compare ~ abbi2dv .  (Contributed by NM, 24-Feb-2014.) $)
    opabbi2dv $p |- ( ph -> A = { <. x , y >. | ps } ) $=
      ( cv cop wcel copab wrel wceq opabid2 ax-mp opabbidv syl5eqr ) AECHDHIEJZ
      CDKZBCDKELSEMFCDENOARBCDGPQ $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.
    relop.1 $e |- A e. _V $.
    relop.2 $e |- B e. _V $.
    $( A necessary and sufficient condition for a Kuratowski ordered pair to be
       a relation.  (Contributed by NM, 3-Jun-2008.) $)
    relop $p |- ( Rel <. A , B >.
             <-> E. x E. y ( A = { x } /\ B = { x , y } ) ) $=
      ( vz vw vv cop cv wceq cpr wa wex wi wal vex bitri eqeq2d cvv cxp wss csn
      wrel df-rel wcel dfss2 wo elop elvv imbi12i jaob albii 19.26 eqeq1 opeqsn
      snex eqcom syl6bb 2exbidv imbi12d spcv sneq cbvexv a9ev equcom exbii mpbi
      19.41v mpbiran eqid a1bi 3bitr2ri sylib prex mpi opeqpr idd eqtr2 simplbi
      preqsn dfsn2 preq2 syl5req syl5eq anbi12d biimpd exp3a com12 adantr imp3a
      syl mpd expcom syl5bi 2eximdv exlimiv imp syl2an sylbi simpr equid sylibr
      jaod jctl eqtr4d opeq12 spc2ev adantlr preq12 biimpa dfop syl6eqr 3imtr4g
      jaodan ex ssrdv exlimivv impbii ) CDJZUEYAUAUAUBZUCZCAKZUDZLZDYDBKZMZLZNZ
      BOAOZYAUFYCYKYCGKZCUDZLZYLYDYGJZLZBOAOZPZGQZYLCDMZLZYQPZGQZNZYKYCYLYAUGZY
      LYBUGZPZGQZUUDGYAYBUHUUHYRUUBNZGQUUDUUGUUIGUUGYNUUAUIZYQPUUIUUEUUJUUFYQYL
      CDGREFUJZABYLUKULYNYQUUAUMSUNYRUUBGUOSSYSCHKZUDZLZHOZYTYOLZBOAOZYKUUCYSYM
      YMLZYDYGLZYFNZBOZAOZPZUUOYRUVCGYMCURYNYNUURYQUVBYLYMYMUPYNYPUUTABYNYPYMYO
      LZUUTYLYMYOUPUVDYOYMLUUTYMYOUSYDYGCARZBRZEUQSUTVAVBVCUUOYFAOUVBUVCUUNYFHA
      UULYDLZUUMYECUULYDVDTVEUVAYFAUVAUUSBOZYFYGYDLZBOUVHBAVFUVIUUSBBAVGVHVIUUS
      YFBVJVKVHUURUVBYMVLVMVNVOUUCYTYTLZUUQYTVLUUBUVJUUQPGYTCDVPUUAUUAUVJYQUUQY
      LYTYTUPUUAYPUUPABYLYTYOUPVAVBVCVQUUOUUQYKUUNUUQYKPHUUNUUPYJABUUPYJCYHLZDY
      ELZNZUIZUUNYJUUPYOYTLUVNYTYOUSYDYGCDUVEUVFEFVRSUUNYJYJUVMUUNYJVSUUNUVKUVL
      YJUVKUUNUVLYJPZUVKUUNNZUUSUVOUVPYHUUMLZUUSCYHUUMVTUVQUUSYGUULLYDYGUULUVEU
      VFHRWBWAWMUVKUUSUVOPUUNUUSUVKUVOUUSUVKUVLYJUUSUVMYJUUSUVKYFUVLYIUUSYHYECU
      USYEYDYDMZYHYDWCZYDYGYDWDZWETUUSYEYHDUUSYEUVRYHUVSUVTWFTWGWHWIWJWKWNWOWLX
      EWPWQWRWSWTXAYJYCABYJGYAYBYJUUJYLUULIKZJZLZIOHOZUUEUUFYJUUJUWDYJYNUWDUUAY
      FYNUWDYIYFYNNZYLYDYDJZLZUWDUWEYLYMUWFYFYNXBYFUWFYMLZYNYFYDYDLZYFNUWHYFUWI
      AXCXFYDYDCUVEUVEEUQXDWKXGUWCUWGHIYDYDUVEUVEUVGUWAYDLNUWBUWFYLUULUWAYDYDXH
      TXIWMXJYJUUANZYPUWDUWJYLYEYHMZYOYJUUAYLUWKLYJYTUWKYLCDYEYHXKTXLYDYGUVEUVF
      XMXNUWCYPHIYDYGUVEUVFUVGUWAYGLNUWBYOYLUULUWAYDYGXHTXIWMXPXQUUKHIYLUKXOXRX
      SXTS $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( For sets, the identity relation is the same as equality.  (Contributed
       by NM, 30-Apr-2004.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    ideqg $p |- ( B e. V -> ( A _I B <-> A = B ) ) $=
      ( vx vy wcel cid wbr wceq cvv wa brrelexi adantl simpl jca eleq1 biimparc
      reli elex cv syl eqeq1 eqeq2 df-id brabg pm5.21nd ) BCFZABGHZABIZAJFZUGKU
      GUHKUJUGUHUJUGABGRLMUGUHNOUGUIKZUJUGUKACFZUJUIULUGABCPQACSUAUGUINODTZETZI
      AUNIUIDEABJCGUMAUNUBUNBAUCDEUDUEUF $.
  $}

  ${
    ideq.1 $e |- B e. _V $.
    $( For sets, the identity relation is the same as equality.  (Contributed
       by NM, 13-Aug-1995.) $)
    ideq $p |- ( A _I B <-> A = B ) $=
      ( cvv wcel cid wbr wceq wb ideqg ax-mp ) BDEABFGABHICABDJK $.
  $}

  ${
    $d x A $.
    $( A set is identical to itself.  (Contributed by NM, 28-May-2008.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    ididg $p |- ( A e. V -> A _I A ) $=
      ( wcel cid wbr wceq eqid ideqg mpbiri ) ABCAADEAAFAGAABHI $.
  $}

  $( Two ways of expressing set existence.  (Contributed by NM, 16-Feb-2008.)
     (Proof shortened by Andrew Salmon, 27-Aug-2011.)  (Revised by Mario
     Carneiro, 26-Apr-2015.) $)
  issetid $p |- ( A e. _V <-> A _I A ) $=
    ( cvv wcel cid wbr ididg reli brrelexi impbii ) ABCAADEABFAADGHI $.

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( Subclass theorem for composition.  (Contributed by FL, 30-Dec-2010.) $)
    coss1 $p |- ( A C_ B -> ( A o. C ) C_ ( B o. C ) ) $=
      ( vx vy vz wss cv wbr wa wex copab id ssbrd anim2d eximdv ssopab2dv df-co
      ccom 3sstr4g ) ABGZDHEHZCIZUBFHZAIZJZEKZDFLUCUBUDBIZJZEKZDFLACSBCSUAUGUJD
      FUAUFUIEUAUEUHUCUAABUBUDUAMNOPQDFEACRDFEBCRT $.

    $( Subclass theorem for composition.  (Contributed by NM, 5-Apr-2013.) $)
    coss2 $p |- ( A C_ B -> ( C o. A ) C_ ( C o. B ) ) $=
      ( vx vy vz wss cv wbr wa wex copab id ssbrd anim1d eximdv ssopab2dv df-co
      ccom 3sstr4g ) ABGZDHZEHZAIZUCFHCIZJZEKZDFLUBUCBIZUEJZEKZDFLCASCBSUAUGUJD
      FUAUFUIEUAUDUHUEUAABUBUCUAMNOPQDFECARDFECBRT $.
  $}

  $( Equality theorem for composition of two classes.  (Contributed by NM,
     3-Jan-1997.) $)
  coeq1 $p |- ( A = B -> ( A o. C ) = ( B o. C ) ) $=
    ( wss wa ccom wceq coss1 anim12i eqss 3imtr4i ) ABDZBADZEACFZBCFZDZONDZEABG
    NOGLPMQABCHBACHIABJNOJK $.

  $( Equality theorem for composition of two classes.  (Contributed by NM,
     3-Jan-1997.) $)
  coeq2 $p |- ( A = B -> ( C o. A ) = ( C o. B ) ) $=
    ( wss wa ccom wceq coss2 anim12i eqss 3imtr4i ) ABDZBADZECAFZCBFZDZONDZEABG
    NOGLPMQABCHBACHIABJNOJK $.

  ${
    coeq1i.1 $e |- A = B $.
    $( Equality inference for composition of two classes.  (Contributed by NM,
       16-Nov-2000.) $)
    coeq1i $p |- ( A o. C ) = ( B o. C ) $=
      ( wceq ccom coeq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality inference for composition of two classes.  (Contributed by NM,
       16-Nov-2000.) $)
    coeq2i $p |- ( C o. A ) = ( C o. B ) $=
      ( wceq ccom coeq2 ax-mp ) ABECAFCBFEDABCGH $.
  $}

  ${
    coeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for composition of two classes.  (Contributed by NM,
       16-Nov-2000.) $)
    coeq1d $p |- ( ph -> ( A o. C ) = ( B o. C ) ) $=
      ( wceq ccom coeq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality deduction for composition of two classes.  (Contributed by NM,
       16-Nov-2000.) $)
    coeq2d $p |- ( ph -> ( C o. A ) = ( C o. B ) ) $=
      ( wceq ccom coeq2 syl ) ABCFDBGDCGFEBCDHI $.
  $}

  ${
    coeq12i.1 $e |- A = B $.
    coeq12i.2 $e |- C = D $.
    $( Equality inference for composition of two classes.  (Contributed by FL,
       7-Jun-2012.) $)
    coeq12i $p |- ( A o. C ) = ( B o. D ) $=
      ( ccom coeq1i coeq2i eqtri ) ACGBCGBDGABCEHCDBFIJ $.
  $}

  ${
    coeq12d.1 $e |- ( ph -> A = B ) $.
    coeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for composition of two classes.  (Contributed by FL,
       7-Jun-2012.) $)
    coeq12d $p |- ( ph -> ( A o. C ) = ( B o. D ) ) $=
      ( ccom coeq1d coeq2d eqtrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  ${
    $d w x y z $.  $d y z w A $.  $d y z w B $.
    nfco.1 $e |- F/_ x A $.
    nfco.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for function value.  (Contributed by
       NM, 1-Sep-1999.) $)
    nfco $p |- F/_ x ( A o. B ) $=
      ( vy vw vz ccom cv wbr wa wex copab df-co nfcv nfbr nfan nfex nfopab
      nfcxfr ) ABCIFJZGJZCKZUCHJZBKZLZGMZFHNFHGBCOUHFHAUGAGUDUFAAUBUCCAUBPEAUCP
      ZQAUCUEBUIDAUEPQRSTUA $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    $( Ordered pair membership in a composition.  (Contributed by NM,
       24-Feb-2015.) $)
    brcog $p |- ( ( A e. V /\ B e. W ) -> ( A ( C o. D ) B <->
                   E. x ( A D x /\ x C B ) ) ) $=
      ( vy vz cv wbr wa wex ccom wceq breq1 breq2 bi2anan9 exbidv df-co brabga
      ) HJZAJZEKZUCIJZDKZLZAMBUCEKZUCCDKZLZAMHIBCDENFGUBBOZUECOZLUGUJAUKUDUHULU
      FUIUBBUCEPUECUCDQRSHIADETUA $.

    $( Ordered pair membership in a composition.  (Contributed by NM,
       27-Jan-1997.)  (Revised by Mario Carneiro, 24-Feb-2015.) $)
    opelco2g $p |- ( ( A e. V /\ B e. W ) -> ( <. A , B >. e. ( C o. D ) <->
                   E. x ( <. A , x >. e. D /\ <. x , B >. e. C ) ) ) $=
      ( wcel wa ccom wbr cv wex cop brcog df-br anbi12i exbii 3bitr3g ) BFHCGHI
      BCDEJZKBALZEKZUACDKZIZAMBCNTHBUANEHZUACNDHZIZAMABCDEFGOBCTPUDUGAUBUEUCUFB
      UAEPUACDPQRS $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x X $.
    $( Ordered pair membership in a composition.  (Contributed by Thierry
       Arnoux, 14-Jan-2018.) $)
    brcogw $p |- ( ( ( A e. V /\ B e. W /\ X e. Z ) /\ ( A D X /\ X C B ) )
      -> A ( C o. D ) B ) $=
      ( vx wcel w3a wbr wa cv wex ccom simpl1 simpl2 wceq breq2 breq1 3ad2antl3
      anbi12d spcegv imp brcog biimpar syl21anc ) AEJZBFJZGHJZKAGDLZGBCLZMZMUIU
      JAINZDLZUOBCLZMZIOZABCDPLZUIUJUKUNQUIUJUKUNRUKUIUNUSUJUKUNUSURUNIGHUOGSUP
      ULUQUMUOGADTUOGBCUAUCUDUEUBUIUJMUTUSIABCDEFUFUGUH $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqbrrdva.1 $e |- ( ph -> A C_ ( C X. D ) ) $.
    eqbrrdva.2 $e |- ( ph -> B C_ ( C X. D ) ) $.
    eqbrrdva.3 $e |- ( ( ph /\ x e. C /\ y e. D ) -> ( x A y <-> x B y ) ) $.
    $( Deduction from extensionality principle for relations, given an
       equivalence only on the relation's domain and range.  (Contributed by
       Thierry Arnoux, 28-Nov-2017.) $)
    eqbrrdva $p |- ( ph -> A = B ) $=
      ( cvv cxp wss wrel syl6ss df-rel sylibr cv wcel wbr xpss wa ssbrd brxp wb
      syl6ib 3expib pm5.21ndd eqbrrdv ) ABCDEADKKLZMDNADFGLZUJHFGUAZODPQAEUJMEN
      AEUKUJIULOEPQABRZFSZCRZGSZUBZUMUODTZUMUOETZAURUMUOUKTZUQADUKUMUOHUCUMUOFG
      UDZUFAUSUTUQAEUKUMUOIUCVAUFAUNUPURUSUEJUGUHUI $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.
    opelco.1 $e |- A e. _V $.
    opelco.2 $e |- B e. _V $.
    $( Binary relation on a composition.  (Contributed by NM, 21-Sep-2004.)
       (Revised by Mario Carneiro, 24-Feb-2015.) $)
    brco $p |- ( A ( C o. D ) B <-> E. x ( A D x /\ x C B ) ) $=
      ( cvv wcel ccom wbr cv wa wex wb brcog mp2an ) BHICHIBCDEJKBALZEKRCDKMANO
      FGABCDEHHPQ $.

    $( Ordered pair membership in a composition.  (Contributed by NM,
       27-Dec-1996.)  (Revised by Mario Carneiro, 24-Feb-2015.) $)
    opelco $p |- ( <. A , B >. e. ( C o. D ) <-> E. x ( A D x /\ x C B ) ) $=
      ( cop ccom wcel wbr cv wa wex df-br brco bitr3i ) BCHDEIZJBCRKBALZEKSCDKM
      ANBCROABCDEFGPQ $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Subset theorem for converse.  (Contributed by NM, 22-Mar-1998.) $)
    cnvss $p |- ( A C_ B -> `' A C_ `' B ) $=
      ( vy vx wss wbr copab ccnv cop wcel ssel 3imtr4g ssopab2dv df-cnv 3sstr4g
      cv df-br ) ABEZCPZDPZAFZDCGSTBFZDCGAHBHRUAUBDCRSTIZAJUCBJUAUBABUCKSTAQSTB
      QLMDCANDCBNO $.
  $}

  $( Equality theorem for converse.  (Contributed by NM, 13-Aug-1995.) $)
  cnveq $p |- ( A = B -> `' A = `' B ) $=
    ( wss wa ccnv wceq cnvss anim12i eqss 3imtr4i ) ABCZBACZDAEZBEZCZNMCZDABFMN
    FKOLPABGBAGHABIMNIJ $.

  ${
    cnveqi.1 $e |- A = B $.
    $( Equality inference for converse.  (Contributed by NM, 23-Dec-2008.) $)
    cnveqi $p |- `' A = `' B $=
      ( wceq ccnv cnveq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    cnveqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for converse.  (Contributed by NM, 6-Dec-2013.) $)
    cnveqd $p |- ( ph -> `' A = `' B ) $=
      ( wceq ccnv cnveq syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d x y A $.  $d x y R $.
    $( Membership in a converse.  Equation 5 of [Suppes] p. 62.  (Contributed
       by NM, 24-Mar-1998.) $)
    elcnv $p |- ( A e. `' R <-> E. x E. y ( A = <. x , y >. /\ y R x ) ) $=
      ( ccnv wcel cv wbr copab cop wceq wa wex df-cnv eleq2i elopab bitri ) CDE
      ZFCBGZAGZDHZABIZFCTSJKUALBMAMRUBCABDNOUAABCPQ $.

    $( Membership in a converse.  Equation 5 of [Suppes] p. 62.  (Contributed
       by NM, 11-Aug-2004.) $)
    elcnv2 $p |- ( A e. `' R <->
                 E. x E. y ( A = <. x , y >. /\ <. y , x >. e. R ) ) $=
      ( ccnv wcel cv cop wceq wbr wa wex elcnv df-br anbi2i 2exbii bitri ) CDEF
      CAGZBGZHIZSRDJZKZBLALTSRHDFZKZBLALABCDMUBUDABUAUCTSRDNOPQ $.
  $}

  ${
    $d y z A $.  $d x y z $.
    nfcnv.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for converse.  (Contributed by NM,
       31-Jan-2004.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfcnv $p |- F/_ x `' A $=
      ( vz vy ccnv cv wbr copab df-cnv nfcv nfbr nfopab nfcxfr ) ABFDGZEGZBHZED
      IEDBJQEDAAOPBAOKCAPKLMN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( Ordered-pair membership in converse.  (Contributed by NM, 13-May-1999.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    opelcnvg $p |- ( ( A e. C /\ B e. D ) ->
                     ( <. A , B >. e. `' R <-> <. B , A >. e. R ) ) $=
      ( vy vx wcel wa ccnv wbr cop cv breq2 breq1 df-cnv brabg df-br 3bitr3g )
      ACHBDHIABEJZKBAEKZABLTHBALEHFMZGMZEKUBAEKUAGFABCDTUCAUBENUBBAEOGFEPQABTRB
      AERS $.
  $}

  $( The converse of a binary relation swaps arguments.  Theorem 11 of [Suppes]
     p. 61.  (Contributed by NM, 10-Oct-2005.) $)
  brcnvg $p |- ( ( A e. C /\ B e. D ) -> ( A `' R B <-> B R A ) ) $=
    ( wcel wa cop ccnv wbr opelcnvg df-br 3bitr4g ) ACFBDFGABHEIZFBAHEFABNJBAEJ
    ABCDEKABNLBAELM $.

  ${
    opelcnv.1 $e |- A e. _V $.
    opelcnv.2 $e |- B e. _V $.
    $( Ordered-pair membership in converse.  (Contributed by NM,
       13-Aug-1995.) $)
    opelcnv $p |- ( <. A , B >. e. `' R <-> <. B , A >. e. R ) $=
      ( cvv wcel cop ccnv wb opelcnvg mp2an ) AFGBFGABHCIGBAHCGJDEABFFCKL $.

    $( The converse of a binary relation swaps arguments.  Theorem 11 of
       [Suppes] p. 61.  (Contributed by NM, 13-Aug-1995.) $)
    brcnv $p |- ( A `' R B <-> B R A ) $=
      ( cvv wcel ccnv wbr wb brcnvg mp2an ) AFGBFGABCHIBACIJDEABFFCKL $.
  $}

  ${
    $d y z A $.  $d y z F $.  $d y z V $.  $d x y z $.
    $( Move class substitution in and out of the converse of a function.
       (Contributed by Thierry Arnoux, 8-Feb-2017.)  (Revised by NM,
       23-Aug-2018.) $)
    csbcnv $p |- `' [_ A / x ]_ F = [_ A / x ]_ `' F $=
      ( vz vy csb ccnv cv wbr copab wsbc sbcbr opabbii csbopab 3eqtr4ri csbeq2i
      df-cnv eqtr4i ) ABCFZGZABDHZEHZCIZEDJZFZABCGZFUCABKZEDJUAUBSIZEDJUETUGUHE
      DABUAUBCLMUCAEDBNEDSQOABUFUDEDCQPR $.

    $( Move class substitution in and out of the converse of a function.
       (Contributed by Thierry Arnoux, 8-Feb-2017.)  Obsolete as of
       23-Aug-2018.  Use ~ csbcnv instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbcnvgOLD $p |- ( A e. V -> `' [_ A / x ]_ F = [_ A / x ]_ `' F ) $=
      ( vz vy wcel csb ccnv cv wbr copab wsbc sbcbr123 csbconstg breq12d syl5bb
      opabbidv csbopabgOLD df-cnv wceq a1i 3eqtr4rd csbeq2i syl6eqr ) BDGZABCHZ
      IZABEJZFJZCKZFELZHZABCIZHUFUKABMZFELUIUJUGKZFELZUMUHUFUOUPFEUOABUIHZABUJH
      ZUGKUFUPABUIUJCNUFURUIUSUJUGABUIDOABUJDOPQRUKAFEBDSUHUQUAUFFEUGTUBUCABUNU
      LFECTUDUE $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( Distributive law of converse over class composition.  Theorem 26 of
       [Suppes] p. 64.  (Contributed by NM, 19-Mar-1998.)  (Proof shortened by
       Andrew Salmon, 27-Aug-2011.) $)
    cnvco $p |- `' ( A o. B ) = ( `' B o. `' A ) $=
      ( vx vy vz cv ccom wbr copab ccnv wa wex exancom brco brcnv anbi12i exbii
      vex 3bitr4i opabbii df-cnv df-co 3eqtr4i ) CFZDFZABGZHZDCIUEEFZAJZHZUHUDB
      JZHZKZELZDCIUFJUKUIGUGUNDCUDUHBHZUHUEAHZKELUPUOKZELUGUNUOUPEMEUDUEABCRZDR
      ZNUMUQEUJUPULUOUEUHAUSERZOUHUDBUTUROPQSTDCUFUADCEUKUIUBUC $.
  $}

  ${
    $d x y z w A $.
    $( The converse of a class union is the (indexed) union of the converses of
       its members.  (Contributed by NM, 11-Aug-2004.) $)
    cnvuni $p |- `' U. A = U_ x e. A `' x $=
      ( vy vz vw cuni ccnv cv ciun wcel wrex cop wa elcnv2 eluni2 anbi2i bitr4i
      wceq wex rexcom4 r19.42v 2exbii rexbii exbii 3bitrri 3bitri eliun eqriv )
      CBFZGZABAHZGZIZCHZUJJZUNULJZABKZUNUMJUOUNDHZEHZLRZUSURLZUIJZMZESDSUTVAUKJ
      ZMZABKZESZDSZUQDEUNUINVCVFDEVCUTVDABKZMVFVBVIUTAVABOPUTVDABUAQUBUQVEESZDS
      ZABKVJABKZDSVHUPVKABDEUNUKNUCVJADBTVLVGDVEAEBTUDUEUFAUNBULUGQUH $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of domain.  Definition 6.5(1) of [TakeutiZaring]
       p. 24.  (Contributed by NM, 28-Dec-1996.) $)
    dfdm3 $p |- dom A = { x | E. y <. x , y >. e. A } $=
      ( cdm cv wbr wex cab cop wcel df-dm df-br exbii abbii eqtri ) CDAEZBEZCFZ
      BGZAHPQICJZBGZAHABCKSUAARTBPQCLMNO $.

    $( Alternate definition of range.  Definition 4 of [Suppes] p. 60.
       (Contributed by NM, 27-Dec-1996.) $)
    dfrn2 $p |- ran A = { y | E. x x A y } $=
      ( crn ccnv cdm cv wbr wex cab df-rn df-dm vex brcnv exbii abbii 3eqtri )
      CDCEZFBGZAGZRHZAIZBJTSCHZAIZBJCKBARLUBUDBUAUCASTCBMAMNOPQ $.

    $( Alternate definition of range.  Definition 6.5(2) of [TakeutiZaring]
       p. 24.  (Contributed by NM, 28-Dec-1996.) $)
    dfrn3 $p |- ran A = { y | E. x <. x , y >. e. A } $=
      ( crn cv wbr wex cab cop wcel dfrn2 df-br exbii abbii eqtri ) CDAEZBEZCFZ
      AGZBHPQICJZAGZBHABCKSUABRTAPQCLMNO $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( Membership in a range.  (Contributed by Scott Fenton, 2-Feb-2011.) $)
    elrn2g $p |- ( A e. V -> ( A e. ran B <-> E. x <. x , A >. e. B ) ) $=
      ( vy cv cop wcel wex crn wceq opeq2 eleq1d exbidv dfrn3 elab2g ) AFZEFZGZ
      CHZAIQBGZCHZAIEBCJDRBKZTUBAUCSUACRBQLMNAECOP $.

    $( Membership in a range.  (Contributed by Scott Fenton, 2-Feb-2011.) $)
    elrng $p |- ( A e. V -> ( A e. ran B <-> E. x x B A ) ) $=
      ( wcel crn cv cop wex wbr elrn2g df-br exbii syl6bbr ) BDEBCFEAGZBHCEZAIO
      BCJZAIABCDKQPAOBCLMN $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of domain.  (Contributed by NM, 28-Dec-1996.) $)
    dfdm4 $p |- dom A = ran `' A $=
      ( vy vx cv wbr wex cab crn cdm vex brcnv exbii abbii dfrn2 df-dm 3eqtr4ri
      ccnv ) BDZCDZAQZEZBFZCGSRAEZBFZCGTHAIUBUDCUAUCBRSABJCJKLMBCTNCBAOP $.
  $}

  ${
    $d x y w v $.  $d w v A $.
    dfdmf.1 $e |- F/_ x A $.
    dfdmf.2 $e |- F/_ y A $.
    $( Definition of domain, using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by NM, 8-Mar-1995.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    dfdmf $p |- dom A = { x | E. y x A y } $=
      ( vw vv cdm cv wbr wex cab df-dm nfcv nfbr nfv breq2 cbvex abbii nfex weq
      breq1 exbidv cbvab 3eqtri ) CHFIZGIZCJZGKZFLUFBIZCJZBKZFLAIZUJCJZBKZALFGC
      MUIULFUHUKGBBUFUGCBUFNEBUGNOUKGPUGUJUFCQRSULUOFAUKABAUFUJCAUFNDAUJNOTUOFP
      FAUAUKUNBUFUMUJCUBUCUDUE $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Domain membership.  Theorem 4 of [Suppes] p. 59.  (Contributed by Mario
       Carneiro, 9-Jul-2014.) $)
    eldmg $p |- ( A e. V -> ( A e. dom B <-> E. y A B y ) ) $=
      ( vx cv wbr wex cdm wceq breq1 exbidv df-dm elab2g ) EFZAFZCGZAHBPCGZAHEB
      CIDOBJQRAOBPCKLEACMN $.

    $( Domain membership.  Theorem 4 of [Suppes] p. 59.  (Contributed by NM,
       27-Jan-1997.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    eldm2g $p |- ( A e. V -> ( A e. dom B <-> E. y <. A , y >. e. B ) ) $=
      ( wcel cdm cv wbr wex cop eldmg df-br exbii syl6bb ) BDEBCFEBAGZCHZAIBOJC
      EZAIABCDKPQABOCLMN $.
  $}

  ${
    $d x y A $.  $d x y B $.
    eldm.1 $e |- A e. _V $.
    $( Membership in a domain.  Theorem 4 of [Suppes] p. 59.  (Contributed by
       NM, 2-Apr-2004.) $)
    eldm $p |- ( A e. dom B <-> E. y A B y ) $=
      ( cvv wcel cdm cv wbr wex wb eldmg ax-mp ) BEFBCGFBAHCIAJKDABCELM $.

    $( Membership in a domain.  Theorem 4 of [Suppes] p. 59.  (Contributed by
       NM, 1-Aug-1994.) $)
    eldm2 $p |- ( A e. dom B <-> E. y <. A , y >. e. B ) $=
      ( cvv wcel cdm cv cop wex wb eldm2g ax-mp ) BEFBCGFBAHICFAJKDABCELM $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Subset theorem for domain.  (Contributed by NM, 11-Aug-1994.) $)
    dmss $p |- ( A C_ B -> dom A C_ dom B ) $=
      ( vx vy wss cdm cv cop wcel wex ssel eximdv vex eldm2 3imtr4g ssrdv ) ABE
      ZCAFZBFZQCGZDGHZAIZDJUABIZDJTRITSIQUBUCDABUAKLDTACMZNDTBUDNOP $.
  $}

  $( Equality theorem for domain.  (Contributed by NM, 11-Aug-1994.) $)
  dmeq $p |- ( A = B -> dom A = dom B ) $=
    ( wss wa cdm wceq dmss anim12i eqss 3imtr4i ) ABCZBACZDAEZBEZCZNMCZDABFMNFK
    OLPABGBAGHABIMNIJ $.

  ${
    dmeqi.1 $e |- A = B $.
    $( Equality inference for domain.  (Contributed by NM, 4-Mar-2004.) $)
    dmeqi $p |- dom A = dom B $=
      ( wceq cdm dmeq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    dmeqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for domain.  (Contributed by NM, 4-Mar-2004.) $)
    dmeqd $p |- ( ph -> dom A = dom B ) $=
      ( wceq cdm dmeq syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.
    opeldm.1 $e |- A e. _V $.
    opeldm.2 $e |- B e. _V $.
    $( Membership of first of an ordered pair in a domain.  (Contributed by NM,
       30-Jul-1995.) $)
    opeldm $p |- ( <. A , B >. e. C -> A e. dom C ) $=
      ( vy cop wcel cv wex cdm wceq opeq2 eleq1d spcev eldm2 sylibr ) ABGZCHZAF
      IZGZCHZFJACKHUBSFBETBLUARCTBAMNOFACDPQ $.

    $( Membership of first of a binary relation in a domain.  (Contributed by
       NM, 30-Jul-1995.) $)
    breldm $p |- ( A R B -> A e. dom R ) $=
      ( wbr cop wcel cdm df-br opeldm sylbi ) ABCFABGCHACIHABCJABCDEKL $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x R $.
    $( Membership of first of a binary relation in a domain.  (Contributed by
       NM, 21-Mar-2007.) $)
    breldmg $p |- ( ( A e. C /\ B e. D /\ A R B ) -> A e. dom R ) $=
      ( vx wbr w3a cdm cv wex breq2 spcegv imp 3adant1 wb eldmg 3ad2ant1 mpbird
      wcel ) ACTZBDTZABEGZHAEITZAFJZEGZFKZUBUCUGUAUBUCUGUFUCFBDUEBAELMNOUAUBUDU
      GPUCFAECQRS $.

    $( The domain of a union is the union of domains.  Exercise 56(a) of
       [Enderton] p. 65.  (Contributed by NM, 12-Aug-1994.)  (Proof shortened
       by Andrew Salmon, 27-Aug-2011.) $)
    dmun $p |- dom ( A u. B ) = ( dom A u. dom B ) $=
      ( vy vx cv wbr wex cab cun cdm wo unab brun exbii 19.43 abbii eqtri df-dm
      bitr2i uneq12i 3eqtr4ri ) CEZDEZAFZDGZCHZUBUCBFZDGZCHZIZUBUCABIZFZDGZCHZA
      JZBJZIUKJUJUEUHKZCHUNUEUHCLUQUMCUMUDUGKZDGUQULURDUBUCABMNUDUGDOSPQUOUFUPU
      ICDARCDBRTCDUKRUA $.

    $( The domain of an intersection belong to the intersection of domains.
       Theorem 6 of [Suppes] p. 60.  (Contributed by NM, 15-Sep-2004.) $)
    dmin $p |- dom ( A i^i B ) C_ ( dom A i^i dom B ) $=
      ( vx vy cin cdm cv cop wcel wa wex 19.40 eldm2 elin exbii anbi12i 3imtr4i
      vex bitri ssriv ) CABEZFZAFZBFZEZCGZDGHZAIZUGBIZJZDKZUHDKZUIDKZJZUFUBIZUF
      UEIZUHUIDLUOUGUAIZDKUKDUFUACRZMUQUJDUGABNOSUPUFUCIZUFUDIZJUNUFUCUDNUSULUT
      UMDUFAURMDUFBURMPSQT $.

  $}

  ${
    $d x y z $.  $d y z A $.  $d y z B $.
    $( The domain of an indexed union.  (Contributed by Mario Carneiro,
       26-Apr-2016.) $)
    dmiun $p |- dom U_ x e. A B = U_ x e. A dom B $=
      ( vy vz ciun cdm cv cop wcel wex wrex rexcom4 eldm2 rexbii eliun 3bitr4ri
      vex exbii 3bitr4i eqriv ) DABCFZGZABCGZFZDHZEHIZUBJZEKZUFUDJZABLZUFUCJUFU
      EJUGCJZEKZABLULABLZEKUKUIULAEBMUJUMABEUFCDRZNOUHUNEAUGBCPSQEUFUBUONAUFBUD
      PTUA $.

    $d x A $.
    $( The domain of a union.  Part of Exercise 8 of [Enderton] p. 41.
       (Contributed by NM, 3-Feb-2004.) $)
    dmuni $p |- dom U. A = U_ x e. A dom x $=
      ( vy vz cuni cdm cv ciun cop wcel wex wrex excom ancom 19.41v vex 3bitr4i
      wa eldm2 exbii anbi2i bitri eluni df-rex eliun eqriv ) CBEZFZABAGZFZHZCGZ
      DGIZUGJZDKZULUJJZABLZULUHJULUKJUMUIJZUIBJZRZAKZDKZUSUPRZAKZUOUQVBUTDKZAKV
      DUTDAMVEVCAURDKZUSRUSVFRVEVCVFUSNURUSDOUPVFUSDULUICPZSUAQTUBUNVADAUMBUCTU
      PABUDQDULUGVGSAULBUJUEQUF $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( The domain of a class of ordered pairs.  (Contributed by NM,
       16-May-1995.)  (Revised by Mario Carneiro, 4-Dec-2016.) $)
    dmopab $p |- dom { <. x , y >. | ph } = { x | E. y ph } $=
      ( copab cdm wbr wex cab nfopab1 nfopab2 dfdmf cop wcel df-br opabid bitri
      cv exbii abbii eqtri ) ABCDZEBQZCQZUAFZCGZBHACGZBHBCUAABCIABCJKUEUFBUDACU
      DUBUCLUAMAUBUCUANABCOPRST $.
  $}

  ${
    $d x y A $.
    $( Upper bound for the domain of a restricted class of ordered pairs.
       (Contributed by NM, 31-Jan-2004.) $)
    dmopabss $p |- dom { <. x , y >. | ( x e. A /\ ph ) } C_ A $=
      ( cv wcel wa copab cdm wex cab dmopab 19.42v abbii ssab2 eqsstri ) BEDFZA
      GZBCHIRCJZBKZDRBCLTQACJZGZBKDSUBBQACMNUABDOPP $.
  $}

  ${
    $d x y A $.
    $( The domain of a restricted class of ordered pairs.  (Contributed by NM,
       31-Jan-2004.) $)
    dmopab3 $p |- ( A. x e. A E. y ph <->
               dom { <. x , y >. | ( x e. A /\ ph ) } = A ) $=
      ( wex wral cv wcel wi wal wa wb copab cdm wceq df-ral pm4.71 albii dmopab
      cab 19.42v abbii eqtri eqeq1i eqcom abeq2 3bitr2ri 3bitri ) ACEZBDFBGDHZU
      IIZBJUJUJUIKZLZBJZUJAKZBCMNZDOZUIBDPUKUMBUJUIQRUQULBTZDODUROUNUPURDUPUOCE
      ZBTURUOBCSUSULBUJACUAUBUCUDDURUEULBDUFUGUH $.
  $}

  ${
    $d x y $.
    $( The domain of the empty set is empty.  Part of Theorem 3.8(v) of [Monk1]
       p. 36.  (Contributed by NM, 4-Jul-1994.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    dm0 $p |- dom (/) = (/) $=
      ( vx vy c0 cdm wceq cv wcel eq0 cop wex noel nex vex eldm2 mtbir mpgbir
      wn ) CDZCEAFZRGZQAARHTSBFIZCGZBJUBBUAKLBSCAMNOP $.

    $( The domain of the identity relation is the universe.  (Contributed by
       NM, 30-Apr-1998.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    dmi $p |- dom _I = _V $=
      ( vx vy cid cdm cvv wceq cv wcel eqv wbr wex a9ev ideq equcom bitri exbii
      vex mpbir eldm mpgbir ) CDZEFAGZUAHZAAUAIUCUBBGZCJZBKZUFUDUBFZBKBALUEUGBU
      EUBUDFUGUBUDBQMABNOPRBUBCAQSRT $.

    $( The domain of the universe is the universe.  (Contributed by NM,
       8-Aug-2003.) $)
    dmv $p |- dom _V = _V $=
      ( cvv cdm ssv cid dmi wss dmss ax-mp eqsstr3i eqssi ) ABZAKCADBZKEDAFLKFD
      CDAGHIJ $.
  $}

  ${
    $d x y A $.
    $( An empty domain implies an empty range.  (Contributed by NM,
       21-May-1998.) $)
    dm0rn0 $p |- ( dom A = (/) <-> ran A = (/) ) $=
      ( vx vy cv wbr wex cab c0 wceq wcel wb wal alnex noel albii abeq1 3bitr4i
      wn nbn eqeq1i cdm crn excom xchbinx bitr4i 3bitr3i df-dm dfrn2 ) BDZCDZAE
      ZCFZBGZHIZUKBFZCGZHIZAUAZHIAUBZHIULUIHJZKZBLZUOUJHJZKZCLZUNUQULRZBLZUORZC
      LZVBVEVGUOCFZRVIVGULBFVJULBMUKBCUCUDUOCMUEVFVABUTULUINSOVHVDCVCUOUJNSOUFU
      LBHPUOCHPQURUMHBCAUGTUSUPHBCAUHTQ $.

    $( A relation is empty iff its domain is empty.  (Contributed by NM,
       15-Sep-2004.) $)
    reldm0 $p |- ( Rel A -> ( A = (/) <-> dom A = (/) ) ) $=
      ( vx vy wrel c0 wceq cv cop wcel wb wal cdm rel0 eqrel mpan2 wn eq0 alnex
      wex albii vex eldm2 xchbinxr noel nbn bitr3i bitr2i syl6bb ) ADZAEFZBGZCG
      HZAIZULEIZJZCKZBKZALZEFZUIEDUJUQJMBCAENOUSUKURIZPZBKUQBURQVAUPBVAUMPZCKZU
      PVCUMCSUTUMCRCUKABUAUBUCVBUOCUNUMULUDUETUFTUGUH $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The domain of a cross product.  Part of Theorem 3.13(x) of [Monk1]
       p. 37.  (Contributed by NM, 28-Jul-1995.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    dmxp $p |- ( B =/= (/) -> dom ( A X. B ) = A ) $=
      ( vy vx c0 wne cxp cdm cv wcel wa copab df-xp dmeqi wex wral n0 ralrimivw
      wceq biimpi dmopab3 sylib syl5eq ) BEFZABGZHCIAJDIBJZKCDLZHZAUEUGCDABMNUD
      UFDOZCAPUHASUDUICAUDUIDBQTRUFCDAUAUBUC $.
  $}

  $( The domain of a square cross product.  (Contributed by NM,
     28-Jul-1995.) $)
  dmxpid $p |- dom ( A X. A ) = A $=
    ( cxp cdm wceq c0 dm0 xpeq1 0xp syl6eq dmeqd id 3eqtr4a dmxp pm2.61ine ) AA
    BZCZADAEAEDZECEPAFQOEQOEABEAEAGAHIJQKLAAMN $.

  $( The domain of the intersection of two square cross products.  Unlike
     ~ dmin , equality holds.  (Contributed by NM, 29-Jan-2008.) $)
  dmxpin $p |- dom ( ( A X. A ) i^i ( B X. B ) ) = ( A i^i B ) $=
    ( cxp cin cdm inxp dmeqi dmxpid eqtri ) AACBBCDZEABDZKCZEKJLAABBFGKHI $.

  $( The cross product of a class with itself is one-to-one.  (Contributed by
     NM, 5-Nov-2006.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  xpid11 $p |- ( ( A X. A ) = ( B X. B ) <-> A = B ) $=
    ( cxp wceq cdm dmeq dmxpid 3eqtr3g xpeq12 anidms impbii ) AACZBBCZDZABDZNLE
    MEABLMFAGBGHONABABIJK $.

  $( The domain of the double converse of a class (which doesn't have to be a
     relation as in ~ dfrel2 ).  (Contributed by NM, 8-Apr-2007.) $)
  dmcnvcnv $p |- dom `' `' A = dom A $=
    ( cdm ccnv crn dfdm4 df-rn eqtr2i ) ABACZDHCBAEHFG $.

  $( The range of the double converse of a class.  (Contributed by NM,
     8-Apr-2007.) $)
  rncnvcnv $p |- ran `' `' A = ran A $=
    ( crn ccnv cdm df-rn dfdm4 eqtr2i ) ABACZDHCBAEHFG $.

  ${
    $d x y A $.  $d x y B $.
    $( The first member of an ordered pair in a relation belongs to the domain
       of the relation.  (Contributed by NM, 28-Jul-2004.) $)
    elreldm $p |- ( ( Rel A /\ B e. A ) -> |^| |^| B e. dom A ) $=
      ( vx vy wrel wcel cint cdm cv cop wceq wex cvv cxp wss wi df-rel ssel vex
      sylbi elvv syl6ib eleq1 opeldm syl6bi inteqd op1stb syl6eq eleq1d sylibrd
      inteq exlimivv syli imp ) AEZBAFZBGZGZAHZFZUPUOBCIZDIZJZKZDLCLZUTUOUPBMMN
      ZFZVEUOAVFOUPVGPAQAVFBRTCDBUAUBVDUPUTPCDVDUPVAUSFZUTVDUPVCAFVHBVCAUCVAVBA
      CSZDSZUDUEVDURVAUSVDURVCGZGVAVDUQVKBVCUKUFVAVBVIVJUGUHUIUJULUMUN $.
  $}

  $( Equality theorem for range.  (Contributed by NM, 29-Dec-1996.) $)
  rneq $p |- ( A = B -> ran A = ran B ) $=
    ( wceq ccnv cdm crn cnveq dmeqd df-rn 3eqtr4g ) ABCZADZEBDZEAFBFKLMABGHAIBI
    J $.

  ${
    rneqi.1 $e |- A = B $.
    $( Equality inference for range.  (Contributed by NM, 4-Mar-2004.) $)
    rneqi $p |- ran A = ran B $=
      ( wceq crn rneq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    rneqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for range.  (Contributed by NM, 4-Mar-2004.) $)
    rneqd $p |- ( ph -> ran A = ran B ) $=
      ( wceq crn rneq syl ) ABCEBFCFEDBCGH $.
  $}

  $( Subset theorem for range.  (Contributed by NM, 22-Mar-1998.) $)
  rnss $p |- ( A C_ B -> ran A C_ ran B ) $=
    ( wss ccnv cdm crn cnvss dmss syl df-rn 3sstr4g ) ABCZADZEZBDZEZAFBFLMOCNPC
    ABGMOHIAJBJK $.

  $( The second argument of a binary relation belongs to its range.
     (Contributed by NM, 29-Jun-2008.) $)
  brelrng $p |- ( ( A e. F /\ B e. G /\ A C B ) -> B e. ran C ) $=
    ( wcel wbr w3a ccnv cdm crn wb brcnvg ancoms biimp3ar 3com12 syld3an3 df-rn
    breldmg syl6eleqr ) ADFZBEFZABCGZHBCIZJZCKUAUBUCBAUDGZBUEFZUAUBUFUCUBUAUFUC
    LBAEDCMNOUBUAUFUGBAEDUDSPQCRT $.

  ${
    brelrn.1 $e |- A e. _V $.
    brelrn.2 $e |- B e. _V $.
    $( The second argument of a binary relation belongs to its range.
       (Contributed by NM, 13-Aug-2004.) $)
    brelrn $p |- ( A C B -> B e. ran C ) $=
      ( cvv wcel wbr crn brelrng mp3an12 ) AFGBFGABCHBCIGDEABCFFJK $.

    $( Membership of second member of an ordered pair in a range.  (Contributed
       by NM, 23-Feb-1997.) $)
    opelrn $p |- ( <. A , B >. e. C -> B e. ran C ) $=
      ( cop wcel wbr crn df-br brelrn sylbir ) ABFCGABCHBCIGABCJABCDEKL $.
  $}

  $( The first argument of a binary relation belongs to its domain.
     (Contributed by NM, 2-Jul-2008.) $)
  releldm $p |- ( ( Rel R /\ A R B ) -> A e. dom R ) $=
    ( wrel wbr wa cvv wcel cdm brrelex brrelex2 simpr breldmg syl3anc ) CDZABCE
    ZFAGHBGHPACIHABCJABCKOPLABGGCMN $.

  $( The second argument of a binary relation belongs to its range.
     (Contributed by NM, 2-Jul-2008.) $)
  relelrn $p |- ( ( Rel R /\ A R B ) -> B e. ran R ) $=
    ( wrel wbr wa cvv wcel crn brrelex brrelex2 simpr brelrng syl3anc ) CDZABCE
    ZFAGHBGHPBCIHABCJABCKOPLABCGGMN $.

  ${
    $d x A $.  $d x R $.
    $( Membership in a domain.  (Contributed by Mario Carneiro, 5-Nov-2015.) $)
    releldmb $p |- ( Rel R -> ( A e. dom R <-> E. x A R x ) ) $=
      ( wrel cdm wcel cv wbr wex eldmg ibi releldm ex exlimdv impbid2 ) CDZBCEZ
      FZBAGZCHZAIZRUAABCQJKPTRAPTRBSCLMNO $.

    $( Membership in a range.  (Contributed by Mario Carneiro, 5-Nov-2015.) $)
    relelrnb $p |- ( Rel R -> ( A e. ran R <-> E. x x R A ) ) $=
      ( wrel crn wcel cv wbr wex elrng ibi relelrn ex exlimdv impbid2 ) CDZBCEZ
      FZAGZBCHZAIZRUAABCQJKPTRAPTRSBCLMNO $.
  $}

  ${
    releldm.1 $e |- Rel R $.
    $( The first argument of a binary relation belongs to its domain.
       (Contributed by NM, 28-Apr-2015.) $)
    releldmi $p |- ( A R B -> A e. dom R ) $=
      ( wrel wbr cdm wcel releldm mpan ) CEABCFACGHDABCIJ $.

    $( The second argument of a binary relation belongs to its range.
       (Contributed by NM, 28-Apr-2015.) $)
    relelrni $p |- ( A R B -> B e. ran R ) $=
      ( wrel wbr crn wcel relelrn mpan ) CEABCFBCGHDABCIJ $.
  $}

  ${
    $d x y w v $.  $d w v A $.
    dfrnf.1 $e |- F/_ x A $.
    dfrnf.2 $e |- F/_ y A $.
    $( Definition of range, using bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by NM, 14-Aug-1995.)  (Revised by
       Mario Carneiro, 15-Oct-2016.) $)
    dfrnf $p |- ran A = { y | E. x x A y } $=
      ( vv vw crn cv wbr wex cab dfrn2 nfcv nfbr nfv breq1 cbvex abbii nfex weq
      breq2 exbidv cbvab 3eqtri ) CHFIZGIZCJZFKZGLAIZUGCJZAKZGLUJBIZCJZAKZBLFGC
      MUIULGUHUKFAAUFUGCAUFNDAUGNOUKFPUFUJUGCQRSULUOGBUKBABUJUGCBUJNEBUGNOTUOGP
      GBUAUKUNAUGUMUJCUBUCUDUE $.
  $}

  ${
    $d x y A $.  $d x y B $.
    elrn.1 $e |- A e. _V $.
    $( Membership in a range.  (Contributed by NM, 10-Jul-1994.) $)
    elrn2 $p |- ( A e. ran B <-> E. x <. x , A >. e. B ) $=
      ( vy cv cop wcel wex crn wceq opeq2 eleq1d exbidv dfrn3 elab2 ) AFZEFZGZC
      HZAIQBGZCHZAIEBCJDRBKZTUBAUCSUACRBQLMNAECOP $.

    $( Membership in a range.  (Contributed by NM, 2-Apr-2004.) $)
    elrn $p |- ( A e. ran B <-> E. x x B A ) $=
      ( crn wcel cv cop wex wbr elrn2 df-br exbii bitr4i ) BCEFAGZBHCFZAIOBCJZA
      IABCDKQPAOBCLMN $.
  $}

  ${
    $d x y z $.  $d y z A $.
    nfrn.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for domain.  (Contributed by NM,
       30-Jan-2004.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfdm $p |- F/_ x dom A $=
      ( vy vz cdm cv wbr wex cab df-dm nfcv nfbr nfex nfab nfcxfr ) ABFDGZEGZBH
      ZEIZDJDEBKTADSAEAQRBAQLCARLMNOP $.

    $( Bound-variable hypothesis builder for range.  (Contributed by NM,
       1-Sep-1999.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfrn $p |- F/_ x ran A $=
      ( crn ccnv cdm df-rn nfcnv nfdm nfcxfr ) ABDBEZFBGAKABCHIJ $.
  $}

  ${
    $d A z $.  $d B z $.  $d x z $.
    $( Domain of an intersection.  (Contributed by FL, 15-Oct-2012.) $)
    dmiin $p |- dom |^|_ x e. A B C_ |^|_ x e. A dom B $=
      ( ciin cdm wss nfii1 nfdm ssiinf cv wcel iinss2 dmss syl mprgbir ) ABCDZE
      ZABCEZDFQRFZABABRQAPABCGHIAJBKPCFSABCLPCMNO $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( The range of a class of ordered pairs.  (Contributed by NM,
       14-Aug-1995.)  (Revised by Mario Carneiro, 4-Dec-2016.) $)
    rnopab $p |- ran { <. x , y >. | ph } = { y | E. x ph } $=
      ( copab crn wbr wex cab nfopab1 nfopab2 dfrnf cop wcel df-br opabid bitri
      cv exbii abbii eqtri ) ABCDZEBQZCQZUAFZBGZCHABGZCHBCUAABCIABCJKUEUFCUDABU
      DUBUCLUAMAUBUCUANABCOPRST $.
  $}

  ${
    $d w y z A $.  $d w y z B $.  $d w x y z C $.
    rnmpt.1 $e |- F = ( x e. A |-> B ) $.
    $( The range of a function in maps-to notation.  (Contributed by Scott
       Fenton, 21-Mar-2011.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    rnmpt $p |- ran F = { y | E. x e. A y = B } $=
      ( cv wcel wceq wa copab crn wex cab wrex rnopab cmpt df-mpt eqtri rneqi
      df-rex abbii 3eqtr4i ) AGCHBGDIZJZABKZLUEAMZBNELUDACOZBNUEABPEUFEACDQUFFA
      BCDRSTUHUGBUDACUAUBUC $.

    $( The range of a function in maps-to notation.  (Contributed by Mario
       Carneiro, 20-Feb-2015.) $)
    elrnmpt $p |- ( C e. V -> ( C e. ran F <-> E. x e. A C = B ) ) $=
      ( vy cv wceq wrex crn eqeq1 rexbidv rnmpt elab2g ) HIZCJZABKDCJZABKHDELFQ
      DJRSABQDCMNAHBCEGOP $.

    ${
      $d x A $.  $d x D $.
      elrnmpt1s.1 $e |- ( x = D -> B = C ) $.
      $( Elementhood in an image set.  (Contributed by Mario Carneiro,
         12-Sep-2015.) $)
      elrnmpt1s $p |- ( ( D e. A /\ C e. V ) -> C e. ran F ) $=
        ( wcel wceq wrex crn eqid cv eqeq2d rspcev mpan2 elrnmpt biimparc sylan
        ) EBJZDCKZABLZDGJZDFMJZUBDDKZUDDNUCUGAEBAOEKCDDIPQRUEUFUDABCDFGHSTUA $.
    $}

    $( Elementhood in an image set.  (Contributed by Mario Carneiro,
       31-Aug-2015.) $)
    elrnmpt1 $p |- ( ( x e. A /\ B e. V ) -> B e. ran F ) $=
      ( vz vy wcel cv crn csb wceq wa wex vex wb id csbeq1a nfcsb1v bitr2d wrex
      eleq12d biantrud equcoms spcev df-rex nfv nfcri nfeq2 nfan eqeq2d anbi12d
      cbvex bitri eqeq1 anbi2d exbidv syl5bb rnmpt elab2g syl5ibr impcom ) CEIZ
      AJZBIZCDKZIZVFVHVDGJZAVIBLZIZCAVICLZMZNZGOZVNVFGVEAPVNVFQAGVEVIMZVFVKVNVP
      VEVIBVJVPRAVIBSUCZVPVMVKAVICSZUDUAUEUFHJZCMZABUBZVOHCVGEWAVKVSVLMZNZGOZVT
      VOWAVFVTNZAOWDVTABUGWEWCAGWEGUHVKWBAAGVJAVIBTUIAVSVLAVICTUJUKVPVFVKVTWBVQ
      VPCVLVSVRULUMUNUOVTWCVNGVTWBVMVKVSCVLUPUQURUSAHBCDFUTVAVBVC $.

    $( Membership in the range of a function.  (Contributed by NM,
       27-Aug-2007.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    elrnmptg $p |- ( A. x e. A B e. V ->
      ( C e. ran F <-> E. x e. A C = B ) ) $=
      ( vy crn wcel cv wceq wrex cab wral rnmpt eleq2i cvv wa syl wi eleq1 elex
      wb r19.29 biimparc rexlimivw ex eqeq1 rexbidv elab3g syl5bb ) DEIZJDHKZCL
      ZABMZHNZJZCFJZABOZDCLZABMZUMUQDAHBCEGPQUTVBDRJZUAURVBUDUTVBVCUTVBSUSVASZA
      BMVCUSVAABUEVDVCABVDDFJZVCVAVEUSDCFUBUFDFUCTUGTUHUPVBHDRUNDLUOVAABUNDCUIU
      JUKTUL $.

    elrnmpti.2 $e |- B e. _V $.
    $( Membership in the range of a function.  (Contributed by NM,
       30-Aug-2004.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    elrnmpti $p |- ( C e. ran F <-> E. x e. A C = B ) $=
      ( cvv wcel wral crn wceq wrex wb rgenw elrnmptg ax-mp ) CHIZABJDEKIDCLABM
      NRABGOABCDEHFPQ $.
  $}

  $( The range of the empty set is empty.  Part of Theorem 3.8(v) of [Monk1]
     p. 36.  (Contributed by NM, 4-Jul-1994.) $)
  rn0 $p |- ran (/) = (/) $=
    ( c0 cdm wceq crn dm0 dm0rn0 mpbi ) ABACADACEAFG $.

  ${
    $d y z w A $.  $d y z w B $.  $d w C z $.  $d w x y z $.
    $( Alternate definition of indexed union when ` B ` is a set.  (Contributed
       by Mario Carneiro, 31-Aug-2015.) $)
    dfiun3g $p |- ( A. x e. A B e. C ->
                  U_ x e. A B = U. ran ( x e. A |-> B ) ) $=
      ( vy wcel wral ciun wceq wrex cab cuni cmpt crn dfiun2g eqid rnmpt unieqi
      cv syl6eqr ) CDFABGABCHESCIABJEKZLABCMZNZLAEBCDOUCUAAEBCUBUBPQRT $.

    $( Alternate definition of indexed intersection when ` B ` is a set.
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    dfiin3g $p |- ( A. x e. A B e. C
               -> |^|_ x e. A B = |^| ran ( x e. A |-> B ) ) $=
      ( vy wcel wral ciin wceq wrex cab cint cmpt crn dfiin2g eqid rnmpt inteqi
      cv syl6eqr ) CDFABGABCHESCIABJEKZLABCMZNZLAEBCDOUCUAAEBCUBUBPQRT $.
  $}

  ${
    dfiun3.1 $e |- B e. _V $.
    $( Alternate definition of indexed union when ` B ` is a set.  (Contributed
       by Mario Carneiro, 31-Aug-2015.) $)
    dfiun3 $p |- U_ x e. A B = U. ran ( x e. A |-> B ) $=
      ( cvv wcel ciun cmpt crn cuni wceq dfiun3g cv a1i mprg ) CEFZABCGABCHIJKA
      BABCELPAMBFDNO $.

    $( Alternate definition of indexed intersection when ` B ` is a set.
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    dfiin3 $p |- |^|_ x e. A B = |^| ran ( x e. A |-> B ) $=
      ( cvv wcel ciin cmpt crn cint wceq dfiin3g cv a1i mprg ) CEFZABCGABCHIJKA
      BABCELPAMBFDNO $.
  $}

  ${
    $d I x $.  $d S x $.  $d V k $.  $d X k $.  $d k x $.
    $( Express a relative indexed intersection as an intersection.
       (Contributed by Stefan O'Rear, 22-Feb-2015.) $)
    riinint $p |- ( ( X e. V /\ A. k e. I S C_ X ) ->
        ( X i^i |^|_ k e. I S ) = |^| ( { X } u. ran ( k e. I |-> S ) ) ) $=
      ( wcel wss wral wa ciin cin cmpt crn cint csn cun cvv wceq ssexg expcom
      ralimdv imp dfiin3g syl ineq2d intun intsng adantr ineq1d syl5eq eqtr4d )
      EDFZAEGZBCHZIZEBCAJZKEBCALMZNZKZEOZUQPNZUOUPUREUOAQFZBCHZUPURRULUNVCULUMV
      BBCUMULVBAEDSTUAUBBCAQUCUDUEUOVAUTNZURKUSUTUQUFUOVDEURULVDERUNEDUGUHUIUJU
      K $.
  $}

  ${
    $d x y A $.
    $( A relation is empty iff its range is empty.  (Contributed by NM,
       15-Sep-2004.) $)
    relrn0 $p |- ( Rel A -> ( A = (/) <-> ran A = (/) ) ) $=
      ( wrel c0 wceq cdm crn reldm0 dm0rn0 syl6bb ) ABACDAECDAFCDAGAHI $.

    $( The domain and range of a class are included in its double union.
       (Contributed by NM, 13-May-2008.) $)
    dmrnssfld $p |- ( dom A u. ran A ) C_ U. U. A $=
      ( vx vy cdm crn cuni cv cop wex vex eldm2 cpr prid1 wss sseld mpi exlimiv
      wcel sylbi ssriv uniop uniopel syl5eqelr elssuni syl elrn2 prid2 unssi )
      ADZAEZAFZFZBUIULBGZUIRUMCGZHZARZCIUMULRZCUMABJZKUPUQCUPUMUMUNLZRUQUMUNURM
      UPUSULUMUPUSUKRUSULNUPUSUOFUKUMUNURCJZUAUMUNAURUTUBUCUSUKUDUEZOPQSTCUJULU
      NUJRUPBIUNULRZBUNAUTUFUPVBBUPUNUSRVBUMUNUTUGUPUSULUNVAOPQSTUH $.
  $}

  $( The domain of a set is a set.  Corollary 6.8(2) of [TakeutiZaring] p. 26.
     (Contributed by NM, 7-Apr-1995.) $)
  dmexg $p |- ( A e. V -> dom A e. _V ) $=
    ( wcel cuni cvv cdm uniexg wss crn ssun1 dmrnssfld sstri ssexg mpan 3syl
    cun ) ABCADZECQDZECZAFZECZABGQEGTRHSUATTAIZPRTUBJAKLTREMNO $.

  $( The range of a set is a set.  Corollary 6.8(3) of [TakeutiZaring] p. 26.
     Similar to Lemma 3D of [Enderton] p. 41.  (Contributed by NM,
     31-Mar-1995.) $)
  rnexg $p |- ( A e. V -> ran A e. _V ) $=
    ( wcel cuni cvv crn uniexg wss cdm ssun2 dmrnssfld sstri ssexg mpan 3syl
    cun ) ABCADZECQDZECZAFZECZABGQEGTRHSUATAIZTPRTUBJAKLTREMNO $.

  ${
    dmex.1 $e |- A e. _V $.
    $( The domain of a set is a set.  Corollary 6.8(2) of [TakeutiZaring]
       p. 26.  (Contributed by NM, 7-Jul-2008.) $)
    dmex $p |- dom A e. _V $=
      ( cvv wcel cdm dmexg ax-mp ) ACDAECDBACFG $.

    $( The range of a set is a set.  Corollary 6.8(3) of [TakeutiZaring]
       p. 26.  Similar to Lemma 3D of [Enderton] p. 41.  (Contributed by NM,
       7-Jul-2008.) $)
    rnex $p |- ran A e. _V $=
      ( cvv wcel crn rnexg ax-mp ) ACDAECDBACFG $.
  $}

  $( The identity function is a proper class.  This means, for example, that we
     cannot use it as a member of the class of continuous functions unless it
     is restricted to a set, as in ~ idcn .  (Contributed by NM,
     1-Jan-2007.) $)
  iprc $p |- -. _I e. _V $=
    ( cid cvv wcel cdm vprc dmi eleq1i mtbir dmexg mto ) ABCADZBCZLBBCEKBBFGHAB
    IJ $.

  ${
    $d x y z A $.  $d x y z B $.
    $( Domain of a composition.  Theorem 21 of [Suppes] p. 63.  (Contributed by
       NM, 19-Mar-1998.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    dmcoss $p |- dom ( A o. B ) C_ dom B $=
      ( vx vy vz ccom cdm cv cop wcel wex wbr nfe1 wa exsimpl vex opelco cbvexv
      breq2 3imtr4i exlimi eldm2 eldm ssriv ) CABFZGZBGZCHZDHZIUEJZDKUHUIBLZDKZ
      UHUFJUHUGJUJULDUKDMUHEHZBLZUMUIALZNEKUNEKUJULUNUOEOEUHUIABCPZDPQUKUNDEUIU
      MUHBSRTUADUHUEUPUBDUHBUPUCTUD $.
  $}

  $( Range of a composition.  (Contributed by NM, 19-Mar-1998.) $)
  rncoss $p |- ran ( A o. B ) C_ ran A $=
    ( ccnv ccom cdm crn dmcoss df-rn cnvco dmeqi eqtri 3sstr4i ) BCZACZDZEZNEAB
    DZFZAFMNGRQCZEPQHSOABIJKAHL $.

  ${
    $d x y z A $.  $d x y z B $.
    $( Domain of a composition.  (Contributed by NM, 28-May-1998.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    dmcosseq $p |- ( ran B C_ dom A -> dom ( A o. B ) = dom B ) $=
      ( vx vy vz crn cdm wss ccom dmcoss a1i cv wbr wex wcel wi vex eldm eximdv
      syl6ibr wa ssel elrn imbi12i 19.8a imim1i pm3.2 sylcom sylbi excom opelco
      cop syl exbii eldm2 3imtr4g ssrdv eqssd ) BFZAGZHZABIZGZBGZVCVDHVAABJKVAC
      VDVCVACLZDLZBMZDNZVEELZULVBOZENZVEVDOVEVCOVAVHVGVFVIAMZUAZDNZENZVKVAVHVME
      NZDNVOVAVGVPDVAVFUSOZVFUTOZPZVGVPPZUSUTVFUBVSVGCNZVLENZPZVTVQWAVRWBCVFBDQ
      ZUCEVFAWDRUDWCVGWBVPVGWAWBVGCUEUFVGVLVMEVGVLUGSUHUIUMSVMEDUJTVJVNEDVEVIAB
      CQZEQUKUNTDVEBWEREVEVBWEUOUPUQUR $.

    $( Domain of a composition.  (Contributed by NM, 19-Mar-1998.) $)
    dmcoeq $p |- ( dom A = ran B -> dom ( A o. B ) = dom B ) $=
      ( cdm crn wceq wss ccom eqimss2 dmcosseq syl ) ACZBDZELKFABGCBCELKHABIJ
      $.
  $}

  $( Range of a composition.  (Contributed by NM, 19-Mar-1998.) $)
  rncoeq $p |- ( dom A = ran B -> ran ( A o. B ) = ran A ) $=
    ( ccnv cdm crn wceq ccom dmcoeq eqcom df-rn dfdm4 eqeq12i bitri cnvco dmeqi
    eqtri 3imtr4i ) BCZDZACZEZFZRTGZDZTDZFADZBEZFZABGZEZAEZFRTHUHUGUFFUBUFUGIUG
    SUFUABJAKLMUJUDUKUEUJUICZDUDUIJULUCABNOPAJLQ $.

  $( Equality theorem for restrictions.  (Contributed by NM, 7-Aug-1994.) $)
  reseq1 $p |- ( A = B -> ( A |` C ) = ( B |` C ) ) $=
    ( wceq cvv cxp cin cres ineq1 df-res 3eqtr4g ) ABDACEFZGBLGACHBCHABLIACJBCJ
    K $.

  $( Equality theorem for restrictions.  (Contributed by NM, 8-Aug-1994.) $)
  reseq2 $p |- ( A = B -> ( C |` A ) = ( C |` B ) ) $=
    ( wceq cvv cxp cin cres xpeq1 ineq2d df-res 3eqtr4g ) ABDZCAEFZGCBEFZGCAHCB
    HMNOCABEIJCAKCBKL $.

  ${
    reseqi.1 $e |- A = B $.
    $( Equality inference for restrictions.  (Contributed by NM,
       21-Oct-2014.) $)
    reseq1i $p |- ( A |` C ) = ( B |` C ) $=
      ( wceq cres reseq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality inference for restrictions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    reseq2i $p |- ( C |` A ) = ( C |` B ) $=
      ( wceq cres reseq2 ax-mp ) ABECAFCBFEDABCGH $.

    reseqi.2 $e |- C = D $.
    $( Equality inference for restrictions.  (Contributed by NM,
       21-Oct-2014.) $)
    reseq12i $p |- ( A |` C ) = ( B |` D ) $=
      ( cres reseq1i reseq2i eqtri ) ACGBCGBDGABCEHCDBFIJ $.
  $}

  ${
    reseqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for restrictions.  (Contributed by NM,
       21-Oct-2014.) $)
    reseq1d $p |- ( ph -> ( A |` C ) = ( B |` C ) ) $=
      ( wceq cres reseq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality deduction for restrictions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    reseq2d $p |- ( ph -> ( C |` A ) = ( C |` B ) ) $=
      ( wceq cres reseq2 syl ) ABCFDBGDCGFEBCDHI $.

    reseqd.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for restrictions.  (Contributed by NM,
       21-Oct-2014.) $)
    reseq12d $p |- ( ph -> ( A |` C ) = ( B |` D ) ) $=
      ( cres reseq1d reseq2d eqtrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  ${
    $d y B $.  $d x y $.
    nfres.1 $e |- F/_ x A $.
    nfres.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for restriction.  (Contributed by NM,
       15-Sep-2003.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    nfres $p |- F/_ x ( A |` B ) $=
      ( cres cvv cxp cin df-res nfcv nfxp nfin nfcxfr ) ABCFBCGHZIBCJABODACGEAG
      KLMN $.
  $}

  $( Distribute proper substitution through the restriction of a class.
     (Contributed by Alan Sare, 10-Nov-2012.)  (Revised by NM, 23-Aug-2018.) $)
  csbres $p |- [_ A / x ]_ ( B |` C ) = ( [_ A / x ]_ B |` [_ A / x ]_ C ) $=
    ( cres csb cvv cxp cin df-res csbeq2i wcel csbxp csbconstg xpeq2d syl5eq wn
    wceq c0 csbprc 0xp a1i xpeq1d 3eqtr4rd pm2.61i ineq2i csbin 3eqtr4i eqtri )
    ABCDEZFABCDGHZIZFZABCFZABDFZEZABUJULCDJKUNABUKFZIUNUOGHZIUMUPUQURUNBGLZUQUR
    RUSUQUOABGFZHURABDGMUSUTGUOABGGNOPUSQZSGHZSURUQVBSRVAGUAUBVAUOSGABDTUCABUKT
    UDUEUFABCUKUGUNUOJUHUI $.

  $( Distribute proper substitution through the restriction of a class.
     ~ csbresgOLD is derived from the virtual deduction proof ~ csbresgVD .
     (Contributed by Alan Sare, 10-Nov-2012.)  Obsolete as of 23-Aug-2018.  Use
     ~ csbres instead.  (New usage is discouraged.)
     (Proof modification is discouraged.) $)
  csbresgOLD $p |- ( A e. V -> [_ A / x ]_ ( B |` C ) =
                 ( [_ A / x ]_ B |` [_ A / x ]_ C ) ) $=
    ( wcel cvv cxp cin csbingOLD csbxpgOLD csbconstg xpeq2d eqtrd ineq2d df-res
    csb cres csbeq2i 3eqtr4g ) BEFZABCDGHZIZQZABCQZABDQZGHZIZABCDRZQUEUFRUAUDUE
    ABUBQZIUHABECUBJUAUJUGUEUAUJUFABGQZHUGABDGEKUAUKGUFABGELMNONABUIUCCDPSUEUFP
    T $.

  $( A restriction to the empty set is empty.  (Contributed by NM,
     12-Nov-1994.) $)
  res0 $p |- ( A |` (/) ) = (/) $=
    ( c0 cres cvv cxp cin df-res 0xp ineq2i in0 3eqtri ) ABCABDEZFABFBABGLBADHI
    AJK $.

  ${
    opelres.1 $e |- B e. _V $.
    $( Ordered pair membership in a restriction.  Exercise 13 of
       [TakeutiZaring] p. 25.  (Contributed by NM, 13-Nov-1995.) $)
    opelres $p |- ( <. A , B >. e. ( C |` D ) <->
                    ( <. A , B >. e. C /\ A e. D ) ) $=
      ( cop cres wcel cvv cxp cin wa df-res eleq2i elin opelxp mpbiran2 anbi2i
      3bitri ) ABFZCDGZHTCDIJZKZHTCHZTUBHZLUDADHZLUAUCTCDMNTCUBOUEUFUDUEUFBIHEA
      BDIPQRS $.

    $( Binary relation on a restriction.  (Contributed by NM, 12-Dec-2006.) $)
    brres $p |- ( A ( C |` D ) B <-> ( A C B /\ A e. D ) ) $=
      ( cop cres wcel wa wbr opelres df-br anbi1i 3bitr4i ) ABFZCDGZHOCHZADHZIA
      BPJABCJZRIABCDEKABPLSQRABCLMN $.
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d y D $.
    $( Ordered pair membership in a restriction.  Exercise 13 of
       [TakeutiZaring] p. 25.  (Contributed by NM, 14-Oct-2005.) $)
    opelresg $p |- ( B e. V -> ( <. A , B >. e. ( C |` D ) <->
                    ( <. A , B >. e. C /\ A e. D ) ) ) $=
      ( vy cv cop cres wcel wa wceq opeq2 eleq1d anbi1d vex opelres vtoclbg ) A
      FGZHZCDIZJTCJZADJZKABHZUAJUDCJZUCKFBESBLZTUDUASBAMZNUFUBUEUCUFTUDCUGNOASC
      DFPQR $.

    $( Binary relation on a restriction.  (Contributed by Mario Carneiro,
       4-Nov-2015.) $)
    brresg $p |- ( B e. V -> ( A ( C |` D ) B <-> ( A C B /\ A e. D ) ) ) $=
      ( wcel cop cres wa wbr opelresg df-br anbi1i 3bitr4g ) BEFABGZCDHZFOCFZAD
      FZIABPJABCJZRIABCDEKABPLSQRABCLMN $.
  $}

  ${
    opres.1 $e |- B e. _V $.
    $( Ordered pair membership in a restriction when the first member belongs
       to the restricting class.  (Contributed by NM, 30-Apr-2004.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    opres $p |- ( A e. D ->
                    ( <. A , B >. e. ( C |` D ) <-> <. A , B >. e. C ) ) $=
      ( cop cres wcel opelres rbaib ) ABFZCDGHKCHADHABCDEIJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( A restricted identity relation is equivalent to equality in its domain.
       (Contributed by NM, 30-Apr-2004.) $)
    resieq $p |- ( ( B e. A /\ C e. A ) -> ( B ( _I |` A ) C <-> B = C ) ) $=
      ( vx wcel cid cres wbr wceq wb cv wi breq2 eqeq2 bibi12d imbi2d cop opres
      vex df-br ideq bitr3i 3bitr4g vtoclg impcom ) CAEBAEZBCFAGZHZBCIZJZUFBDKZ
      UGHZBUKIZJZLUFUJLDCAUKCIZUNUJUFUOULUHUMUIUKCBUGMUKCBNOPUFBUKQZUGEUPFEZULU
      MBUKFADSZRBUKUGTUMBUKFHUQBUKURUABUKFTUBUCUDUE $.
  $}

  $( ` <. A , A >. ` belongs to a restriction of the identity class iff ` A `
     belongs to the restricting class.  (Contributed by FL, 27-Oct-2008.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  opelresiOLD $p |- ( A e. V -> ( A e. B <-> <. A , A >. e. ( _I |` B ) ) ) $=
    ( wcel cop cid wa cres wbr ididg df-br sylib biantrurd opelresg bitr4d ) AC
    DZABDZAAEZFDZQGRFBHDPSQPAAFISACJAAFKLMAAFBCNO $.

  $( ` <. A , A >. ` belongs to a restriction of the identity class iff ` A `
     belongs to the restricting class.  (Contributed by FL, 27-Oct-2008.)
     (Revised by NM, 30-Mar-2016.) $)
  opelresi $p |- ( A e. V -> ( <. A , A >. e. ( _I |` B ) <-> A e. B ) ) $=
    ( wcel cop cid cres wa opelresg wbr ididg df-br sylib biantrurd bitr4d ) AC
    DZAAEZFBGDQFDZABDZHSAAFBCIPRSPAAFJRACKAAFLMNO $.

  $( The restriction of a restriction.  (Contributed by NM, 27-Mar-2008.) $)
  resres $p |- ( ( A |` B ) |` C ) = ( A |` ( B i^i C ) ) $=
    ( cres cvv cxp cin df-res ineq1i xpindir ineq2i inass 3eqtr4ri 3eqtri ) ABD
    ZCDOCEFZGABEFZGZPGZABCGZDZOCHORPABHIATEFZGAQPGZGUASUBUCABCEJKATHAQPLMN $.

  $( Distributive law for restriction over union.  Theorem 31 of [Suppes]
     p. 65.  (Contributed by NM, 30-Sep-2002.) $)
  resundi $p |- ( A |` ( B u. C ) ) = ( ( A |` B ) u. ( A |` C ) ) $=
    ( cun cvv cxp cin cres xpundir ineq2i indi eqtri df-res uneq12i 3eqtr4i ) A
    BCDZEFZGZABEFZGZACEFZGZDZAPHABHZACHZDRASUADZGUCQUFABCEIJASUAKLAPMUDTUEUBABM
    ACMNO $.

  $( Distributive law for restriction over union.  (Contributed by NM,
     23-Sep-2004.) $)
  resundir $p |- ( ( A u. B ) |` C ) = ( ( A |` C ) u. ( B |` C ) ) $=
    ( cun cvv cxp cin cres indir df-res uneq12i 3eqtr4i ) ABDZCEFZGANGZBNGZDMCH
    ACHZBCHZDABNIMCJQORPACJBCJKL $.

  $( Class restriction distributes over intersection.  (Contributed by FL,
     6-Oct-2008.) $)
  resindi $p |- ( A |` ( B i^i C ) ) = ( ( A |` B ) i^i ( A |` C ) ) $=
    ( cin cvv cxp cres xpindir ineq2i inindi eqtri df-res ineq12i 3eqtr4i ) ABC
    DZEFZDZABEFZDZACEFZDZDZAOGABGZACGZDQARTDZDUBPUEABCEHIARTJKAOLUCSUDUAABLACLM
    N $.

  $( Class restriction distributes over intersection.  (Contributed by NM,
     18-Dec-2008.) $)
  resindir $p |- ( ( A i^i B ) |` C ) = ( ( A |` C ) i^i ( B |` C ) ) $=
    ( cin cvv cxp cres inindir df-res ineq12i 3eqtr4i ) ABDZCEFZDAMDZBMDZDLCGAC
    GZBCGZDABMHLCIPNQOACIBCIJK $.

  $( Move intersection into class restriction.  (Contributed by NM,
     18-Dec-2008.) $)
  inres $p |- ( A i^i ( B |` C ) ) = ( ( A i^i B ) |` C ) $=
    ( cin cvv cxp cres inass df-res ineq2i 3eqtr4ri ) ABDZCEFZDABMDZDLCGABCGZDA
    BMHLCIONABCIJK $.

  ${
    $d x C $.
    $( Distribution of restriction over indexed union.  (Contributed by Mario
       Carneiro, 29-May-2015.) $)
    resiun1 $p |- ( U_ x e. A B |` C ) = U_ x e. A ( B |` C ) $=
      ( cvv cxp cin ciun cres iunin2 wceq cv wcel df-res incom iuneq2i 3eqtr4ri
      eqtri a1i ) ABDEFZCGZHTABCHZGZABCDIZHUBDIZABTCJABUDUAUDUAKALBMUDCTGUACDNC
      TORSPUEUBTGUCUBDNUBTORQ $.

    $( Distribution of restriction over indexed union.  (Contributed by Mario
       Carneiro, 29-May-2015.) $)
    resiun2 $p |- ( C |` U_ x e. A B ) = U_ x e. A ( C |` B ) $=
      ( ciun cres cvv cxp cin df-res wceq cv a1i iuneq2i xpiundir ineq2i iunin2
      wcel eqtr4i ) DABCEZFDTGHZIZABDCFZEZDTJUDABDCGHZIZEZUBABUCUFUCUFKALBRDCJM
      NUBDABUEEZIUGUAUHDABCGOPABDUEQSSS $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The domain of a restriction.  Exercise 14 of [TakeutiZaring] p. 25.
       (Contributed by NM, 1-Aug-1994.) $)
    dmres $p |- dom ( A |` B ) = ( B i^i dom A ) $=
      ( vx vy cdm cin cres cv wcel cop wex wa eldm2 19.41v opelres exbii anbi1i
      vex 3bitr4i bitr2i ineqri incom eqtr3i ) AEZBFABGZEZBUDFCUDBUFCHZUFIUGDHZ
      JZUEIZDKZUGUDIZUGBIZLZDUGUECRZMUIAIZUMLZDKUPDKZUMLUKUNUPUMDNUJUQDUGUHABDR
      OPULURUMDUGAUOMQSTUAUDBUBUC $.
  $}

  $( A domain restricted to a subclass equals the subclass.  (Contributed by
     NM, 2-Mar-1997.) $)
  ssdmres $p |- ( A C_ dom B <-> dom ( B |` A ) = A ) $=
    ( cdm wss cin wceq cres df-ss dmres eqeq1i bitr4i ) ABCZDALEZAFBAGCZAFALHNM
    ABAIJK $.

  $( The domain of a restriction to a set exists.  (Contributed by NM,
     7-Apr-1995.) $)
  dmresexg $p |- ( B e. V -> dom ( A |` B ) e. _V ) $=
    ( wcel cres cdm cin cvv dmres inex1g syl5eqel ) BCDABEFBAFZGHABIBLCJK $.

  $( A class includes its restriction.  Exercise 15 of [TakeutiZaring] p. 25.
     (Contributed by NM, 2-Aug-1994.) $)
  resss $p |- ( A |` B ) C_ A $=
    ( cres cvv cxp cin df-res inss1 eqsstri ) ABCABDEZFAABGAJHI $.

  $( Commutative law for restriction.  (Contributed by NM, 27-Mar-1998.) $)
  rescom $p |- ( ( A |` B ) |` C ) = ( ( A |` C ) |` B ) $=
    ( cin cres incom reseq2i resres 3eqtr4i ) ABCDZEACBDZEABECEACEBEJKABCFGABCH
    ACBHI $.

  $( Subclass theorem for restriction.  (Contributed by NM, 16-Aug-1994.) $)
  ssres $p |- ( A C_ B -> ( A |` C ) C_ ( B |` C ) ) $=
    ( wss cvv cxp cin cres ssrin df-res 3sstr4g ) ABDACEFZGBLGACHBCHABLIACJBCJK
    $.

  $( Subclass theorem for restriction.  (Contributed by NM, 22-Mar-1998.)
     (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  ssres2 $p |- ( A C_ B -> ( C |` A ) C_ ( C |` B ) ) $=
    ( wss cvv cxp cin cres xpss1 sslin syl df-res 3sstr4g ) ABDZCAEFZGZCBEFZGZC
    AHCBHNOQDPRDABEIOQCJKCALCBLM $.

  $( A restriction is a relation.  Exercise 12 of [TakeutiZaring] p. 25.
     (Contributed by NM, 2-Aug-1994.)  (Proof shortened by Andrew Salmon,
     27-Aug-2011.) $)
  relres $p |- Rel ( A |` B ) $=
    ( cres cvv cxp wss wrel cin df-res inss2 eqsstri relxp relss mp2 ) ABCZBDEZ
    FPGOGOAPHPABIAPJKBDLOPMN $.

  $( Absorption law for restriction.  Exercise 17 of [TakeutiZaring] p. 25.
     (Contributed by NM, 9-Aug-1994.) $)
  resabs1 $p |- ( B C_ C -> ( ( A |` C ) |` B ) = ( A |` B ) ) $=
    ( wss cres cin resres wceq sseqin2 reseq2 sylbi syl5eq ) BCDZACEBEACBFZEZAB
    EZACBGMNBHOPHBCINBAJKL $.

  $( Absorption law for restriction.  (Contributed by NM, 27-Mar-1998.) $)
  resabs2 $p |- ( B C_ C -> ( ( A |` B ) |` C ) = ( A |` B ) ) $=
    ( wss cres rescom resabs1 syl5eq ) BCDABEZCEACEBEIABCFABCGH $.

  $( Idempotent law for restriction.  (Contributed by NM, 27-Mar-1998.) $)
  residm $p |- ( ( A |` B ) |` B ) = ( A |` B ) $=
    ( wss cres wceq ssid resabs2 ax-mp ) BBCABDZBDIEBFABBGH $.

  $( A restriction to an image.  (Contributed by NM, 29-Sep-2004.) $)
  resima $p |- ( ( A |` B ) " B ) = ( A " B ) $=
    ( cres crn cima residm rneqi df-ima 3eqtr4i ) ABCZBCZDJDJBEABEKJABFGJBHABHI
    $.

  $( Image under a restricted class.  (Contributed by FL, 31-Aug-2009.) $)
  resima2 $p |- ( B C_ C -> ( ( A |` C ) " B ) = ( A " B ) ) $=
    ( wss cres cima crn df-ima cin resres rneqi wceq df-ss incom reseq2d reseq2
    a1i rneqd syl6eqr syl5eq eqtrd sylbi ) BCDZACEZBFUDBEZGZABFZUDBHUCUFACBIZEZ
    GZUGUEUIACBJKUCBCIZBLZUJUGLBCMULUJAUKEZGZUGULUIUMULUHUKAUHUKLULCBNQORULUNAB
    EZGUGULUMUOUKBAPRABHSUAUBTT $.

  $( Restriction of a constant function (or other cross product).  (Contributed
     by Stefan O'Rear, 24-Jan-2015.) $)
  xpssres $p |- ( C C_ A -> ( ( A X. B ) |` C ) = ( C X. B ) ) $=
    ( wss cxp cres cin df-res inxp incom inv1 xpeq12i 3eqtri wceq biimpi xpeq1d
    cvv df-ss syl5eq ) CADZABEZCFZCAGZBEZCBEUBUACQEGACGZBQGZEUDUACHABCQIUEUCUFB
    ACJBKLMTUCCBTUCCNCAROPS $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in a restriction.  (Contributed by Scott Fenton,
       17-Mar-2011.) $)
    elres $p |- ( A e. ( B |` C )
          <-> E. x e. C E. y ( A = <. x , y >. /\ <. x , y >. e. B ) ) $=
      ( cres wcel cv cop wceq wex wrex wrel relres elrel mpan eleq1 biimpd vex
      wa opelres biimpi ancomd syl6com ancld an12 syl6ib 2eximdv rexcom4 df-rex
      exbii excom 3bitri sylibr simplbi2com biimprd syl9 imp3a exlimdv rexlimiv
      mpd impbii ) CDEFZGZCAHZBHZIZJZVGDGZTZBKZAELZVDVEEGZVJTZBKAKZVLVDVHBKAKZV
      OVCMVDVPDENABCVCOPVDVHVNABVDVHVHVMVITZTVNVDVHVQVHVDVGVCGZVQVHVDVRCVGVCQZR
      VRVIVMVRVIVMTVEVFDEBSUAZUBUCUDUEVHVMVIUFUGUHVAVLVJAELZBKVNAKZBKVOVJABEUIW
      AWBBVJAEUJUKVNBAULUMUNVKVDAEVMVJVDBVMVHVIVDVMVIVRVHVDVRVIVMVTUOVHVDVRVSUP
      UQURUSUTVB $.

    ${
      elsnres.1 $e |- C e. _V $.
      $( Memebership in restriction to a singleton.  (Contributed by Scott
         Fenton, 17-Mar-2011.) $)
      elsnres $p |- ( A e. ( B |` { C } )
            <-> E. y ( A = <. C , y >. /\ <. C , y >. e. B ) ) $=
        ( vx csn cres wcel cv cop wceq wa wex elres rexcom4 opeq1 eqeq2d eleq1d
        wrex anbi12d rexsn exbii 3bitri ) BCDGZHIBFJZAJZKZLZUHCIZMZANFUETUKFUET
        ZANBDUGKZLZUMCIZMZANFABCUEOUKFAUEPULUPAUKUPFDEUFDLZUIUNUJUOUQUHUMBUFDUG
        QZRUQUHUMCURSUAUBUCUD $.
    $}

    $( Simplification law for restriction.  (Contributed by NM,
       16-Aug-1994.) $)
    relssres $p |- ( ( Rel A /\ dom A C_ B ) -> ( A |` B ) = A ) $=
      ( vx vy wrel cdm wss wa cres wceq simpl cv cop wcel vex opeldm ssel ancld
      wi syl5 opelres syl6ibr adantl relssdv resss jctil eqss sylibr ) AEZAFZBG
      ZHZABIZAGZAUMGZHUMAJULUOUNULCDAUMUIUKKUKCLZDLZMZANZURUMNZSUIUKUSUSUPBNZHU
      TUKUSVAUSUPUJNUKVAUPUQACODOZPUJBUPQTRUPUQABVBUAUBUCUDABUEUFUMAUGUH $.
  $}

  $( A relation restricted to its domain equals itself.  (Contributed by NM,
     12-Dec-2006.) $)
  resdm $p |- ( Rel A -> ( A |` dom A ) = A ) $=
    ( wrel cdm wss cres wceq ssid relssres mpan2 ) ABACZJDAJEAFJGAJHI $.

  $( The restriction of a set is a set.  (Contributed by NM, 28-Mar-1998.)
     (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  resexg $p |- ( A e. V -> ( A |` B ) e. _V ) $=
    ( cres wss wcel cvv resss ssexg mpan ) ABDZAEACFKGFABHKACIJ $.

  ${
    resex.1 $e |- A e. _V $.
    $( The restriction of a set is a set.  (Contributed by Jeff Madsen,
       19-Jun-2011.) $)
    resex $p |- ( A |` B ) e. _V $=
      ( cvv wcel cres resexg ax-mp ) ADEABFDECABDGH $.
  $}

  ${
    $d x y A $.
    $( Restriction of a class abstraction of ordered pairs.  (Contributed by
       NM, 5-Nov-2002.) $)
    resopab $p |- ( { <. x , y >. | ph } |` A ) =
                  { <. x , y >. | ( x e. A /\ ph ) } $=
      ( copab cres cvv cxp cin cv wa df-res df-xp biantru opabbii eqtr4i ineq2i
      wcel vex eqtri incom inopab ) ABCEZDFUCDGHZIZBJDRZAKBCEZUCDLUEUFBCEZUCIZU
      GUEUCUHIUIUDUHUCUDUFCJGRZKZBCEUHBCDGMUFUKBCUJUFCSNOPQUCUHUATUFABCUBTT $.

    $( The existence of a restricted identity function, proved without using
       the Axiom of Replacement (unlike ~ resfunexg ).  (Contributed by NM,
       13-Jan-2007.) $)
    resiexg $p |- ( A e. V -> ( _I |` A ) e. _V ) $=
      ( vx vy wcel cid cres cxp wss cvv relres weq cv wa cop simpr eleq1 biimpa
      jca vex opelres wbr df-br bitr3i anbi1i bitri opelxp 3imtr4i relssi xpexg
      ideq anidms ssexg sylancr ) ABEZFAGZAAHZIUQJEZUPJECDUPUQFAKCDLZCMZAEZNZVA
      DMZAEZNUTVCOZUPEZVEUQEVBVAVDUSVAPUSVAVDUTVCAQRSVFVEFEZVANVBUTVCFADTZUAVGU
      SVAVGUTVCFUBUSUTVCFUCUTVCVHUKUDUEUFUTVCAAUGUHUIUOURAABBUJULUPUQJUMUN $.

    $( A subclass of the identity function is the identity function restricted
       to its domain.  (Contributed by NM, 13-Dec-2003.)  (Proof shortened by
       Andrew Salmon, 27-Aug-2011.) $)
    iss $p |- ( A C_ _I <-> A = ( _I |` dom A ) ) $=
      ( vx vy cid wss cdm cres wceq cv cop wcel wb wal wa ssel wi opeldm syl5bi
      vex wrel a1i jcad wbr df-br bitr3i wex eldm2 opeq2 eleq1d biimprcd sylcom
      ideq exlimdv imbi2d syl5ibcom imp3a impbid opelres syl6bbr alrimivv relss
      reli mpi relres eqrel sylancl mpbird resss sseq1 mpbiri impbii ) ADEZADAF
      ZGZHZVLVOBIZCIZJZAKZVRVNKZLZCMBMZVLWABCVLVSVRDKZVPVMKZNZVTVLVSWEVLVSWCWDA
      DVROZVSWDPVLVPVQABSZCSZQUAUBVLWCWDVSWCVPVQHZVLWDVSPZWCVPVQDUCWIVPVQDUDVPV
      QWHULUEZVLWDVPVPJZAKZPWIWJWDVSCUFVLWMCVPAWGUGVLVSWMCVLVSWCWMWFWCWIVSWMWKW
      IWMVSWIWLVRAVPVQVPUHUIZUJRUKUMRWIWMVSWDWNUNUORUPUQVPVQDVMWHURUSUTVLATZVNT
      VOWBLVLDTWOVBADVAVCDVMVDBCAVNVEVFVGVOVLVNDEDVMVHAVNDVIVJVK $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Restriction of a class abstraction of ordered pairs.  (Contributed by
       NM, 24-Aug-2007.) $)
    resopab2 $p |- ( A C_ B -> ( { <. x , y >. | ( x e. B /\ ph ) } |` A ) =
                  { <. x , y >. | ( x e. A /\ ph ) } ) $=
      ( wss cv wcel wa copab cres resopab pm4.71d anbi1d anass syl6rbb opabbidv
      ssel syl5eq ) DEFZBGZEHZAIZBCJDKUADHZUCIZBCJUDAIZBCJUCBCDLTUEUFBCTUFUDUBI
      ZAIUETUDUGATUDUBDEUARMNUDUBAOPQS $.

    $( Restriction of the mapping operation.  (Contributed by Mario Carneiro,
       15-Jul-2013.) $)
    resmpt $p |- ( B C_ A -> ( ( x e. A |-> C ) |` B ) = ( x e. B |-> C ) ) $=
      ( vy wss cv wcel wceq wa copab cres cmpt resopab2 df-mpt reseq1i 3eqtr4g
      ) CBFAGZBHEGDIZJAEKZCLRCHSJAEKABDMZCLACDMSAECBNUATCAEBDOPAECDOQ $.

    $( Unconditional restriction of the mapping operation.  (Contributed by
       Stefan O'Rear, 24-Jan-2015.)  (Proof shortened by Mario Carneiro,
       22-Mar-2015.) $)
    resmpt3 $p |- ( ( x e. A |-> C ) |` B ) = ( x e. ( A i^i B ) |-> C ) $=
      ( cmpt cres cin resres wss wceq ssid resmpt ax-mp reseq1i inss1 3eqtr3i )
      ABDEZBFZCFQBCGZFZQCFASDEZQBCHRQCBBIRQJBKABBDLMNSBITUAJBCOABSDLMP $.
  $}

  ${
    $d w x y z A $.  $d w x y z R $.
    $( Alternate definition of the restriction operation.  (Contributed by
       Mario Carneiro, 5-Nov-2013.) $)
    dfres2 $p |- ( R |` A ) = { <. x , y >. | ( x e. A /\ x R y ) } $=
      ( vz vw cres cv wbr wa copab relres relopab cop vex brres df-br ancom weq
      wcel 3bitr3i eleq1 breq1 anbi12d breq2 anbi2d opelopab bitr4i eqrelriiv )
      EFDCGZAHZCTZUKBHZDIZJZABKZDCLUOABMEHZFHZNZUJTZUQCTZUQURDIZJZUSUPTUQURUJIV
      BVAJUTVCUQURDCFOZPUQURUJQVBVARUAUOVAUQUMDIZJVCABUQUREOVDAESULVAUNVEUKUQCU
      BUKUQUMDUCUDBFSVEVBVAUMURUQDUEUFUGUHUI $.
  $}

  ${
    $d A x y $.
    $( The restricted identity expressed with the class builder.  (Contributed
       by FL, 25-Apr-2012.) $)
    opabresid $p |- { <. x , y >. | ( x e. A /\ y = x ) } = ( _I |` A ) $=
      ( weq copab cres cv wcel cid resopab equcom opabbii eqtr4i reseq1i eqtr3i
      wa dfid3 ) BADZABEZCFAGCHRPABEICFRABCJSICSABDZABEIRTABBAKLABQMNO $.
  $}

  ${
    $d A x y $.
    $( The restricted identity expressed with the "maps to" notation.
       (Contributed by FL, 25-Apr-2012.) $)
    mptresid $p |- ( x e. A |-> x ) = ( _I |` A ) $=
      ( vy cv cmpt wcel weq wa copab cid cres df-mpt opabresid eqtri ) ABADZEOB
      FCAGHACIJBKACBOLACBMN $.
  $}

  $( The domain of a restricted identity function.  (Contributed by NM,
     27-Aug-2004.) $)
  dmresi $p |- dom ( _I |` A ) = A $=
    ( cid cdm wss cres wceq cvv ssv dmi sseqtr4i ssdmres mpbi ) ABCZDBAECAFAGMA
    HIJABKL $.

  $( TODO - delete this and replace w/ dfres3 (in FL's mathbox) $)
  $( Any relation restricted to the universe is itself.  (Contributed by NM,
     16-Mar-2004.) $)
  resid $p |- ( Rel A -> ( A |` _V ) = A ) $=
    ( wrel cdm cvv wss cres wceq ssv relssres mpan2 ) ABACZDEADFAGKHADIJ $.

  $( Equality theorem for image.  (Contributed by NM, 14-Aug-1994.) $)
  imaeq1 $p |- ( A = B -> ( A " C ) = ( B " C ) ) $=
    ( wceq cres crn cima reseq1 rneqd df-ima 3eqtr4g ) ABDZACEZFBCEZFACGBCGLMNA
    BCHIACJBCJK $.

  $( Equality theorem for image.  (Contributed by NM, 14-Aug-1994.) $)
  imaeq2 $p |- ( A = B -> ( C " A ) = ( C " B ) ) $=
    ( wceq cres crn cima reseq2 rneqd df-ima 3eqtr4g ) ABDZCAEZFCBEZFCAGCBGLMNA
    BCHICAJCBJK $.

  ${
    imaeq1i.1 $e |- A = B $.
    $( Equality theorem for image.  (Contributed by NM, 21-Dec-2008.) $)
    imaeq1i $p |- ( A " C ) = ( B " C ) $=
      ( wceq cima imaeq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality theorem for image.  (Contributed by NM, 21-Dec-2008.) $)
    imaeq2i $p |- ( C " A ) = ( C " B ) $=
      ( wceq cima imaeq2 ax-mp ) ABECAFCBFEDABCGH $.
  $}

  ${
    imaeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for image.  (Contributed by FL, 15-Dec-2006.) $)
    imaeq1d $p |- ( ph -> ( A " C ) = ( B " C ) ) $=
      ( wceq cima imaeq1 syl ) ABCFBDGCDGFEBCDHI $.

    $( Equality theorem for image.  (Contributed by FL, 15-Dec-2006.) $)
    imaeq2d $p |- ( ph -> ( C " A ) = ( C " B ) ) $=
      ( wceq cima imaeq2 syl ) ABCFDBGDCGFEBCDHI $.

    imaeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality theorem for image.  (Contributed by Mario Carneiro,
       4-Dec-2016.) $)
    imaeq12d $p |- ( ph -> ( A " C ) = ( B " D ) ) $=
      ( cima imaeq1d imaeq2d eqtrd ) ABDHCDHCEHABCDFIADECGJK $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Alternate definition of image.  Compare definition (d) of [Enderton]
       p. 44.  (Contributed by NM, 19-Apr-2004.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    dfima2 $p |- ( A " B ) = { y | E. x e. B x A y } $=
      ( cima cres crn cv wbr wex cab wrex df-ima dfrn2 wa vex brres ancom bitri
      wcel exbii df-rex bitr4i abbii 3eqtri ) CDECDFZGAHZBHZUFIZAJZBKUGUHCIZADL
      ZBKCDMABUFNUJULBUJUGDTZUKOZAJULUIUNAUIUKUMOUNUGUHCDBPQUKUMRSUAUKADUBUCUDU
      E $.

    $( Alternate definition of image.  Compare definition (d) of [Enderton]
       p. 44.  (Contributed by NM, 14-Aug-1994.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    dfima3 $p |- ( A " B ) = { y | E. x ( x e. B /\ <. x , y >. e. A ) } $=
      ( cima cv wbr wrex cab wcel cop wa dfima2 df-br rexbii df-rex bitri abbii
      wex eqtri ) CDEAFZBFZCGZADHZBIUADJUAUBKCJZLASZBIABCDMUDUFBUDUEADHUFUCUEAD
      UAUBCNOUEADPQRT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Membership in an image.  Theorem 34 of [Suppes] p. 65.  (Contributed by
       NM, 20-Jan-2007.) $)
    elimag $p |- ( A e. V -> ( A e. ( B " C ) <-> E. x e. C x B A ) ) $=
      ( vy cv wbr wrex cima wceq breq2 rexbidv dfima2 elab2g ) AGZFGZCHZADIPBCH
      ZADIFBCDJEQBKRSADQBPCLMAFCDNO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    elima.1 $e |- A e. _V $.
    $( Membership in an image.  Theorem 34 of [Suppes] p. 65.  (Contributed by
       NM, 19-Apr-2004.) $)
    elima $p |- ( A e. ( B " C ) <-> E. x e. C x B A ) $=
      ( cvv wcel cima cv wbr wrex wb elimag ax-mp ) BFGBCDHGAIBCJADKLEABCDFMN
      $.

    $( Membership in an image.  Theorem 34 of [Suppes] p. 65.  (Contributed by
       NM, 11-Aug-2004.) $)
    elima2 $p |- ( A e. ( B " C ) <-> E. x ( x e. C /\ x B A ) ) $=
      ( cima wcel cv wbr wrex wa wex elima df-rex bitri ) BCDFGAHZBCIZADJPDGQKA
      LABCDEMQADNO $.

    $( Membership in an image.  Theorem 34 of [Suppes] p. 65.  (Contributed by
       NM, 14-Aug-1994.) $)
    elima3 $p |- ( A e. ( B " C ) <-> E. x ( x e. C /\ <. x , A >. e. B ) ) $=
      ( cima wcel cv wbr wa wex cop elima2 df-br anbi2i exbii bitri ) BCDFGAHZD
      GZRBCIZJZAKSRBLCGZJZAKABCDEMUAUCATUBSRBCNOPQ $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d x y z w $.
    nfima.1 $e |- F/_ x A $.
    nfima.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for image.  (Contributed by NM,
       30-Dec-1996.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    nfima $p |- F/_ x ( A " B ) $=
      ( cima cres crn df-ima nfres nfrn nfcxfr ) ABCFBCGZHBCIAMABCDEJKL $.
  $}

  ${
    $d x y z $.  $d B y z $.  $d A y z $.  $d ph y $.
    nfimad.2 $e |- ( ph -> F/_ x A ) $.
    nfimad.3 $e |- ( ph -> F/_ x B ) $.
    $( Deduction version of bound-variable hypothesis builder ~ nfima .
       (Contributed by FL, 15-Dec-2006.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nfimad $p |- ( ph -> F/_ x ( A " B ) ) $=
      ( vz cv wcel wal cab cima wnfc nfaba1 nfima wb wa nfnfc1 nfan abidnf
      imaeq1d imaeq2d sylan9eq nfceqdf syl2anc mpbii ) ABGHZCIZBJGKZUGDIZBJGKZL
      ZMZBCDLZMZBUIUKUHBGNUJBGNOABCMZBDMZUMUOPEFUPUQQBULUNUPUQBBCRBDRSUPUQULCUK
      LUNUPUICUKBGCTUAUQUKDCBGDTUBUCUDUEUF $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The image of the domain of a class is the range of the class.
       (Contributed by NM, 14-Aug-1994.) $)
    imadmrn $p |- ( A " dom A ) = ran A $=
      ( vx vy cv cdm wcel cop wa wex cab cima crn vex opeldm ancom bitr2i exbii
      pm4.71i abbii dfima3 dfrn3 3eqtr4i ) BDZAEZFZUCCDZGAFZHZBIZCJUGBIZCJAUDKA
      LUIUJCUHUGBUGUGUEHUHUGUEUCUFABMCMNRUGUEOPQSBCAUDTBCAUAUB $.

    $( The image of a class is a subset of its range.  Theorem 3.16(xi) of
       [Monk1] p. 39.  (Contributed by NM, 31-Mar-1995.) $)
    imassrn $p |- ( A " B ) C_ ran A $=
      ( vx vy cv wcel cop wex cab cima crn exsimpr ss2abi dfima3 dfrn3 3sstr4i
      wa ) CEZBFZRDEGAFZQCHZDITCHZDIABJAKUAUBDSTCLMCDABNCDAOP $.
  $}

  $( The image of a set is a set.  Theorem 3.17 of [Monk1] p. 39.  (Contributed
     by NM, 24-Jul-1995.) $)
  imaexg $p |- ( A e. V -> ( A " B ) e. _V ) $=
    ( wcel cima crn wss cvv imassrn rnexg ssexg sylancr ) ACDABEZAFZGNHDMHDABIA
    CJMNHKL $.

  ${
    $d x y A $.
    $( Image under the identity relation.  Theorem 3.16(viii) of [Monk1]
       p. 38.  (Contributed by NM, 30-Apr-1998.) $)
    imai $p |- ( _I " A ) = A $=
      ( vx vy cid cima cv wcel cop wex cab dfima3 weq wbr df-br vex ideq bitr3i
      wa anbi2i bitri ancom exbii eleq1 ceqsexv abbii abid2 3eqtri ) DAEBFZAGZU
      HCFZHDGZRZBIZCJUJAGZCJABCDAKUMUNCUMBCLZUIRZBIUNULUPBULUIUORUPUKUOUIUKUHUJ
      DMUOUHUJDNUHUJCOZPQSUIUOUATUBUIUNBUJUQUHUJAUCUDTUECAUFUG $.
  $}

  $( The range of the restricted identity function.  (Contributed by NM,
     27-Aug-2004.) $)
  rnresi $p |- ran ( _I |` A ) = A $=
    ( cid cima cres crn df-ima imai eqtr3i ) BACBADEABAFAGH $.

  $( The image of a restriction of the identity function.  (Contributed by FL,
     31-Dec-2006.) $)
  resiima $p |- ( B C_ A -> ( ( _I |` A ) " B ) = B ) $=
    ( wss cid cres cima crn wceq df-ima a1i resabs1 rneqd rnresi 3eqtrd ) BACZD
    AEZBFZPBEZGZDBEZGZBQSHOPBIJORTDBAKLUABHOBMJN $.

  $( Image of the empty set.  Theorem 3.16(ii) of [Monk1] p. 38.  (Contributed
     by NM, 20-May-1998.) $)
  ima0 $p |- ( A " (/) ) = (/) $=
    ( c0 cima cres crn df-ima res0 rneqi rn0 3eqtri ) ABCABDZEBEBABFKBAGHIJ $.

  $( Image under the empty relation.  (Contributed by FL, 11-Jan-2007.) $)
  0ima $p |- ( (/) " A ) = (/) $=
    ( c0 cima crn imassrn rn0 sseqtri 0ss eqssi ) BACZBJBDBBAEFGJHI $.

  ${
    $d A y z $.  $d B y z $.  $d C y z $.  $d x y z $.  $d F y z $.
    $( Move class substitution in and out of the image of a function.
       (Contributed by FL, 15-Dec-2006.)  (Revised by NM, 20-Aug-2018.) $)
    csbima12 $p |- [_ A / x ]_ ( F " B ) = ( [_ A / x ]_ F " [_ A / x ]_ B ) $=
      ( vy cvv wcel cima csb wceq csbeq1 imaeq12d eqeq12d nfcsb1v nfima csbeq1a
      cv vex c0 csbprc weq csbief vtoclg wn imaeq2d ima0 syl6req eqtrd pm2.61i
      ) BFGZABDCHZIZABDIZABCIZHZJZAEQZUKIZAUQDIZAUQCIZHZJUPEBFUQBJZURULVAUOAUQB
      UKKVBUSUMUTUNAUQBDKAUQBCKLMAUQUKVAERAUSUTAUQDNAUQCNOAEUADUSCUTAUQDPAUQCPL
      UBUCUJUDZULSUOABUKTVCUOUMSHSVCUNSUMABCTUEUMUFUGUHUI $.

    $( Move class substitution in and out of the image of a function.
       (Contributed by FL, 15-Dec-2006.)  (Proof shortened by Mario Carneiro,
       4-Dec-2016.)  Obsolete as of 20-Aug-2018.  Use ~ csbfv12 instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbima12gOLD $p |- ( A e. C -> [_ A / x ]_ ( F " B ) =
                 ( [_ A / x ]_ F " [_ A / x ]_ B ) ) $=
      ( vy cv cima csb csbeq1 imaeq12d eqeq12d vex nfcsb1v nfima csbeq1a csbief
      wceq vtoclg ) AFGZECHZIZATEIZATCIZHZRABUAIZABEIZABCIZHZRFBDTBRZUBUFUEUIAT
      BUAJUJUCUGUDUHATBEJATBCJKLATUAUEFMAUCUDATENATCNOAGTREUCCUDATEPATCPKQS $.
  $}

  $( A class whose image under another is empty is disjoint with the other's
     domain.  (Contributed by FL, 24-Jan-2007.) $)
  imadisj $p |- ( ( A " B ) = (/) <-> ( dom A i^i B ) = (/) ) $=
    ( cima wceq cres crn cdm cin df-ima eqeq1i dm0rn0 dmres incom eqtri 3bitr2i
    c0 ) ABCZPDABEZFZPDRGZPDAGZBHZPDQSPABIJRKTUBPTBUAHUBABLBUAMNJO $.

  $( A preimage under any class is included in the domain of the class.
     (Contributed by FL, 29-Jan-2007.) $)
  cnvimass $p |- ( `' A " B ) C_ dom A $=
    ( ccnv cima crn cdm imassrn dfdm4 sseqtr4i ) ACZBDJEAFJBGAHI $.

  $( The preimage of the range of a class is the domain of the class.
     (Contributed by Jeff Hankins, 15-Jul-2009.) $)
  cnvimarndm $p |- ( `' A " ran A ) = dom A $=
    ( ccnv cdm cima crn imadmrn df-rn imaeq2i dfdm4 3eqtr4i ) ABZKCZDKEKAEZDACK
    FMLKAGHAIJ $.

  ${
    $d x y A $.  $d x B $.  $d x y R $.
    $( The image of a singleton.  (Contributed by NM, 8-May-2005.) $)
    imasng $p |- ( A e. B -> ( R " { A } ) = { y | A R y } ) $=
      ( vx wcel cvv csn cima wbr cab wceq elex wrex dfima2 rexsng abbidv syl5eq
      cv breq1 syl ) BCFBGFZDBHZIZBASZDJZAKZLBCMUBUDESZUEDJZEUCNZAKUGEADUCOUBUJ
      UFAUIUFEBGUHBUEDTPQRUA $.

    $( The image of a singleton.  (Contributed by NM, 20-May-1998.) $)
    relimasn $p |- ( Rel R -> ( R " { A } ) = { y | A R y } ) $=
      ( wrel cvv wcel csn cima cv wbr cab wceq wn wa c0 snprc imaeq2 sylbi ima0
      ex syl6eq adantl wex brrelex con3and nexdv necon1bbii sylib eqtr4d imasng
      abn0 pm2.61d2 ) CDZBEFZCBGZHZBAIZCJZAKZLZUMUNMZUTUMVANZUPOUSVAUPOLUMVAUPC
      OHZOVAUOOLUPVCLBPUOOCQRCSUAUBVBURAUCZMUSOLVBURAUMURUNUMURUNBUQCUDTUEUFVDU
      SOURAUKUGUHUITABECUJUL $.

    $( Elementhood in the image of a singleton.  (Contributed by Mario
       Carneiro, 3-Nov-2015.) $)
    elrelimasn $p |- ( Rel R -> ( B e. ( R " { A } ) <-> A R B ) ) $=
      ( vx wrel csn cima cv wbr cab relimasn eleq2d cvv wi wb brrelex2 ex breq2
      wcel elab3g syl bitrd ) CEZBCAFGZSBADHZCIZDJZSZABCIZUCUDUGBDACKLUCUIBMSZN
      UHUIOUCUIUJABCPQUFUIDBMUEBACRTUAUB $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    elimasn.1 $e |- B e. _V $.
    elimasn.2 $e |- C e. _V $.
    $( Membership in an image of a singleton.  (Contributed by NM,
       15-Mar-2004.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    elimasn $p |- ( C e. ( A " { B } ) <-> <. B , C >. e. A ) $=
      ( vx csn cima wcel wbr cop cv breq2 cvv cab wceq imasng ax-mp elab2 df-br
      bitri ) CABGHZIBCAJZBCKAIBFLZAJZUCFCUBEUDCBAMBNIUBUEFOPDFBNAQRSBCATUA $.
  $}

  ${
    $d A y z $.  $d B y z $.  $d C y z $.
    $( Membership in an image of a singleton.  (Contributed by Raph Levien,
       21-Oct-2006.) $)
    elimasng $p |- ( ( B e. V /\ C e. W ) ->
                   ( C e. ( A " { B } ) <-> <. B , C >. e. A ) ) $=
      ( vz vy cv csn cima wcel cop wceq sneq imaeq2d eleq2d eleq1d bibi12d vex
      wb opeq1 eleq1 opeq2 elimasn vtocl2g ) FHZAGHZIZJZKZUGUFLZAKZTUFABIZJZKZB
      UFLZAKZTCUNKZBCLZAKZTGFBCDEUGBMZUJUOULUQVAUIUNUFVAUHUMAUGBNOPVAUKUPAUGBUF
      UAQRUFCMZUOURUQUTUFCUNUBVBUPUSAUFCBUCQRAUGUFGSFSUDUE $.
  $}

  $( Membership in an image of a singleton.  (Contributed by NM,
     5-Aug-2010.) $)
  elimasni $p |- ( C e. ( A " { B } ) -> B A C ) $=
    ( cvv wcel wa csn cima wbr wn c0 noel wceq snprc biimpi imaeq2d ima0 syl6eq
    eleq2d mtbiri con4i elex jca cop elimasng df-br syl6bbr biimpd mpcom ) BDEZ
    CDEZFZCABGZHZEZBCAIZUOUJUKUJUOUJJZUOCKECLUQUNKCUQUNAKHKUQUMKAUQUMKMBNOPAQRS
    TUACUNUBUCULUOUPULUOBCUDAEUPABCDDUEBCAUFUGUHUI $.

  ${
    $d y F $.  $d x y $.
    $( Two ways to express the class of unique-valued arguments of ` F ` ,
       which is the same as the domain of ` F ` whenever ` F ` is a function.
       The left-hand side of the equality is from Definition 10.2 of [Quine]
       p. 65.  Quine uses the notation "arg ` F ` " for this class (for which
       we have no separate notation).  Observe the resemblance to the
       alternative definition ~ dffv4 of function value, which is based on the
       idea in Quine's definition.  (Contributed by NM, 8-May-2005.) $)
    args $p |- { x | E. y ( F " { x } ) = { y } } = { x | E! y x F y } $=
      ( cv csn cima wceq wex wbr weu cab cvv wcel vex imasng ax-mp eqeq1i exbii
      euabsn bitr4i abbii ) CADZEFZBDZEZGZBHZUBUDCIZBJZAUGUHBKZUEGZBHUIUFUKBUCU
      JUEUBLMUCUJGANBUBLCOPQRUHBSTUA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    eliniseg.1 $e |- C e. _V $.
    $( Membership in an initial segment.  The idiom ` ( ``' A " { B } ) ` ,
       meaning ` { x | x A B } ` , is used to specify an initial segment in
       (for example) Definition 6.21 of [TakeutiZaring] p. 30.  (Contributed by
       NM, 28-Apr-2004.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    eliniseg $p |- ( B e. V -> ( C e. ( `' A " { B } ) <-> C A B ) ) $=
      ( wcel cvv ccnv csn cima wbr wb wa cop elimasng df-br syl6bbr bitrd mpan2
      brcnvg ) BDFZCGFZCAHZBIJFZCBAKZLEUAUBMZUDBCUCKZUEUFUDBCNUCFUGUCBCDGOBCUCP
      QBCDGATRS $.
  $}

  ${
    $d A x y $.
    epini.1 $e |- A e. _V $.
    $( Any set is equal to its preimage under the converse epsilon relation.
       (Contributed by Mario Carneiro, 9-Mar-2013.) $)
    epini $p |- ( `' _E " { A } ) = A $=
      ( vx cep ccnv csn cima cv wbr cvv wb vex eliniseg ax-mp epelc bitri eqriv
      wcel ) CDEAFGZACHZSRZTADIZTARAJRUAUBKBDATJCLMNTABOPQ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( An idiom that signifies an initial segment of an ordering, used, for
       example, in Definition 6.21 of [TakeutiZaring] p. 30.  (Contributed by
       NM, 28-Apr-2004.) $)
    iniseg $p |- ( B e. V -> ( `' A " { B } ) = { x | x A B } ) $=
      ( wcel cvv ccnv csn cima cv wbr cab wceq elex vex eliniseg abbi2dv syl )
      CDECFEZBGCHIZAJZCBKZALMCDNSUBATBCUAFAOPQR $.
  $}

  ${
    $d x y z A $.  $d x y z R $.
    $( Alternate definition of well-founded relation.  Definition 6.21 of
       [TakeutiZaring] p. 30.  (Contributed by NM, 23-Apr-2004.)  (Revised by
       Mario Carneiro, 23-Jun-2015.) $)
    dffr3 $p |- ( R Fr A <-> A. x ( ( x C_ A /\ x =/= (/) ) ->
                E. y e. x ( x i^i ( `' R " { y } ) ) = (/) ) ) $=
      ( vz wfr cv wss c0 wne wa wbr crab wceq wrex wi wal ccnv cin cvv csn cima
      dffr2 cab wcel vex iniseg ax-mp ineq2i dfrab3 eqtr4i eqeq1i rexbii imbi2i
      albii bitr4i ) CDFAGZCHUQIJKZEGBGZDLZEUQMZINZBUQOZPZAQURUQDRUSUAUBZSZINZB
      UQOZPZAQABECDUCVIVDAVHVCURVGVBBUQVFVAIVFUQUTEUDZSVAVEVJUQUSTUEVEVJNBUFEDU
      STUGUHUIUTEUQUJUKULUMUNUOUP $.
  $}

  ${
    $d x y A $.  $d x y R $.  $d x V $.
    $( Alternate definition of set-like relation.  (Contributed by Mario
       Carneiro, 23-Jun-2015.) $)
    dfse2 $p |- ( R Se A <-> A. x e. A ( A i^i ( `' R " { x } ) ) e. _V ) $=
      ( vy wse cv wbr crab cvv wcel wral ccnv csn cima cin df-se cab dfrab3 vex
      wceq iniseg ax-mp ineq2i eqtr4i eleq1i ralbii bitri ) BCEDFAFZCGZDBHZIJZA
      BKBCLUHMNZOZIJZABKADBCPUKUNABUJUMIUJBUIDQZOUMUIDBRULUOBUHIJULUOTASDCUHIUA
      UBUCUDUEUFUG $.

    $( Any set relation is set-like.  (Contributed by Mario Carneiro,
       22-Jun-2015.) $)
    exse2 $p |- ( R e. V -> R Se A ) $=
      ( vy vx wcel cv wbr crab cvv wral wse cdm wss wa cab df-rab breldm adantl
      vex abssi eqsstri dmexg ssexg sylancr ralrimivw df-se sylibr ) BCFZDGZEGZ
      BHZDAIZJFZEAKABLUIUNEAUIUMBMZNUOJFUNUMUJAFZULOZDPUOULDAQUQDUOULUJUOFUPUJU
      KBDTETRSUAUBBCUCUMUOJUDUEUFEDABUGUH $.
  $}

  $( Subset theorem for image.  (Contributed by NM, 16-Mar-2004.) $)
  imass1 $p |- ( A C_ B -> ( A " C ) C_ ( B " C ) ) $=
    ( wss cres crn cima ssres rnss syl df-ima 3sstr4g ) ABDZACEZFZBCEZFZACGBCGM
    NPDOQDABCHNPIJACKBCKL $.

  $( Subset theorem for image.  Exercise 22(a) of [Enderton] p. 53.
     (Contributed by NM, 22-Mar-1998.) $)
  imass2 $p |- ( A C_ B -> ( C " A ) C_ ( C " B ) ) $=
    ( wss cres crn cima ssres2 rnss syl df-ima 3sstr4g ) ABDZCAEZFZCBEZFZCAGCBG
    MNPDOQDABCHNPIJCAKCBKL $.

  $( The image of a singleton outside the domain is empty.  (Contributed by NM,
     22-May-1998.) $)
  ndmima $p |- ( -. A e. dom B -> ( B " { A } ) = (/) ) $=
    ( cdm wcel wn csn cima cres crn c0 df-ima wceq cin dmres incom eqtri disjsn
    biimpri syl5eq dm0rn0 sylib ) ABCZDEZBAFZGBUDHZIZJBUDKUCUECZJLUFJLUCUGUBUDM
    ZJUGUDUBMUHBUDNUDUBOPUHJLUCUBAQRSUETUAS $.

  ${
    $d x y A $.
    $( A converse is a relation.  Theorem 12 of [Suppes] p. 62.  (Contributed
       by NM, 29-Oct-1996.) $)
    relcnv $p |- Rel `' A $=
      ( vy vx cv wbr ccnv df-cnv relopabi ) BDCDAECBAFCBAGH $.
  $}

  ${
    $( When ` R ` is a relation, the sethood assumptions on ~ brcnv can be
       omitted.  (Contributed by Mario Carneiro, 28-Apr-2015.) $)
    relbrcnvg $p |- ( Rel R -> ( A `' R B <-> B R A ) ) $=
      ( wrel cvv wcel wa ccnv wbr wi relcnv brrelex12 mpan a1i ancomd ex brcnvg
      wb pm5.21ndd ) CDZAEFZBEFZGZABCHZIZBACIZUEUCJTUDDUEUCCKABUDLMNTUFUCTUFGUB
      UABACLOPUCUEUFRJTABEECQNS $.

    $( Eliminate the class existence constraint in ~ eliniseg .  (Contributed
       by Mario Carneiro, 5-Dec-2014.)  (Revised by Mario Carneiro,
       17-Nov-2015.) $)
    eliniseg2 $p |- ( Rel A -> ( C e. ( `' A " { B } ) <-> C A B ) ) $=
      ( ccnv csn cima wcel wbr wrel wb relcnv elrelimasn ax-mp relbrcnvg syl5bb
      ) CADZBEFGZBCPHZAICBAHPIQRJAKBCPLMBCANO $.

    relbrcnv.1 $e |- Rel R $.
    $( When ` R ` is a relation, the sethood assumptions on ~ brcnv can be
       omitted.  (Contributed by Mario Carneiro, 28-Apr-2015.) $)
    relbrcnv $p |- ( A `' R B <-> B R A ) $=
      ( wrel ccnv wbr wb relbrcnvg ax-mp ) CEABCFGBACGHDABCIJ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y z R $.
    $( Two ways of saying a relation is transitive.  Definition of transitivity
       in [Schechter] p. 51.  (Contributed by NM, 27-Dec-1996.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    cotr $p |- ( ( R o. R ) C_ R <->
             A. x A. y A. z ( ( x R y /\ y R z ) -> x R z ) ) $=
      ( ccom wss cv cop wcel wi wal wbr wa wrel wb wex df-co vex albii bitri
      relopabi ssrel ax-mp opelco df-br bicomi imbi12i 19.23v bitr4i alcom ) DD
      EZDFZAGZCGZHZUKIZUODIZJZCKZAKZUMBGZDLVAUNDLMZUMUNDLZJZCKBKZAKUKNULUTOVBBP
      ZACUKACBDDQUAACUKDUBUCUSVEAUSVDBKZCKVEURVGCURVFVCJVGUPVFUQVCBUMUNDDARCRUD
      VCUQUMUNDUEUFUGVBVCBUHUISVDCBUJTST $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z R $.  $d x y z S $.  $d z V $.
    $d z W $.
    $( Two ways to state a relation is reflexive.  Adapted from Tarski.
       (Contributed by FL, 15-Jan-2012.)  (Revised by NM, 30-Mar-2016.) $)
    issref $p |- ( ( _I |` A ) C_ R <-> A. x e. A x R x ) $=
      ( vy vz cv wbr wral wcel wi wal cop cid wss df-ral cvv vex opelresi ax-mp
      sylbi cres wb df-br bicomi imbi12i albii ralidm bitri cxp pm2.27 opelresg
      ralv wa weq ideq opeq2 eleq1d biimpcd syl6bir pm2.43i com3r sylbir syl6bi
      syl6 imp ralrimiv sps ralimi wceq eleq1 imbi12d sylibr wrel relres df-rel
      ralxp mpbi sseli ancri pm3.31 syl5 alimi syl ssel alrimiv impbii 3bitr2ri
      dfss2 ) AFZWICGZABHWIBIZWJJZAKWIWILZMBUAZIZWMCIZJZAKZWNCNZWJABOWQWLAWOWKW
      PWJWIPIZWOWKUBAQZWIBPRSWJWPWIWICUCUDUEUFWRWSWRDFZWNIZXBCIZJZDKZWSWRWQAPHZ
      APHZXFXHXGWRWQAPUGWQAULUHXHXEDPPUIZHZXFXHWIEFZLZWNIZXLCIZJZEPHZAPHXJXGXPA
      PXGWTWQJZAKXPWQAPOXQXPAWTXQXPJXAWTXQWQXPWTWQUJWQXOEPXKPIZXMWQXNXRXMXLMIZW
      KUMWQXNJZWIXKMBPUKXSWKXTXSWIXKMGZWKXTJZWIXKMUCYAAEUNZYBWIXKEQUOWKWQYCXNWK
      WQYCXNJZJZWKWKWOYEWIBBRWOWQWPYDWOWPUJYCWPXNYCWMXLCWIXKWIUPUQURVDUSUTVATVB
      VEVCVAVFVDSVGTVHXEXODAEPPXBXLVIXCXMXDXNXBXLWNVJXBXLCVJVKVPVLXJXBXIIZXEJZD
      KXFXEDXIOYGXEDXCYFXCUMYGXDXCYFWNXIXBWNVMWNXINMBVNWNVOVQVRVSYFXCXDVTWAWBTW
      CVBDWNCWHVLWSWQAWNCWMWDWEWFWG $.

    $( Two ways of saying a relation is symmetric.  Similar to definition of
       symmetry in [Schechter] p. 51.  (Contributed by NM, 28-Dec-1996.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    cnvsym $p |- ( `' R C_ R <-> A. x A. y ( x R y -> y R x ) ) $=
      ( cv cop ccnv wcel wi wal wss wbr alcom wrel relcnv ssrel ax-mp vex brcnv
      wb df-br bitr3i imbi12i 2albii 3bitr4i ) BDZADZEZCFZGZUGCGZHZAIBIZUKBIAIU
      HCJZUFUECKZUEUFCKZHZBIAIUKBALUHMUMULSCNBAUHCOPUPUKABUNUIUOUJUNUEUFUHKUIUE
      UFCBQAQRUEUFUHTUAUEUFCTUBUCUD $.

    $( Two ways of saying a relation is antisymmetric.  Definition of
       antisymmetry in [Schechter] p. 51.  (Contributed by NM, 9-Sep-2004.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    intasym $p |- ( ( R i^i `' R ) C_ _I <->
                  A. x A. y ( ( x R y /\ y R x ) -> x = y ) ) $=
      ( ccnv cin cid wss cv cop wcel wi wal wbr wa weq wrel wb df-br vex bitr3i
      relcnv relin2 ssrel mp2b elin brcnv anbi12i bitr4i imbi12i 2albii bitri
      ideq ) CCDZEZFGZAHZBHZIZUNJZURFJZKZBLALZUPUQCMZUQUPCMZNZABOZKZBLALUMPUNPU
      OVBQCUACUMUBABUNFUCUDVAVGABUSVEUTVFUSURCJZURUMJZNVEURCUMUEVCVHVDVIUPUQCRV
      DUPUQUMMVIUPUQCASBSZUFUPUQUMRTUGUHUTUPUQFMVFUPUQFRUPUQVJULTUIUJUK $.

    $( Two ways of saying a relation is antisymmetric and reflexive.
       ` U. U. R ` is the field of a relation by ~ relfld .  (Contributed by
       NM, 6-May-2008.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    asymref $p |- ( ( R i^i `' R ) = ( _I |` U. U. R ) <->
       A. x e. U. U. R A. y ( ( x R y /\ y R x ) <-> x = y ) ) $=
      ( cv wcel cid cuni wb wal wbr wa wceq wi df-br bitr3i bitri 3bitr4i albii
      vex wrel cop ccnv cin cres wral opeluu simpld adantr pm4.71ri bibi1i elin
      sylbi brcnv anbi12i bitr4i opelres ideq pm5.32 19.21v relcnv relin2 ax-mp
      anbi2ci bibi12i relres eqrel mp2an df-ral ) ADZBDZUAZCCUBZUCZEZVKFCGGZUDZ
      EZHZBIZAIZVIVOEZVIVJCJZVJVICJZKZVIVJLZHZBIZMZAIVMVPLZWGAVOUEVSWHAVSWAWFMZ
      BIWHVRWJBWDWAWEKZHWAWDKZWKHVRWJWDWLWKWDWAWBWAWCWBWAVJVOEZWBVKCEZWAWMKVIVJ
      CNZVIVJCASZBSZUFULUGUHUIUJVNWDVQWKVNWNVKVLEZKWDVKCVLUKWBWNWCWRWOWCVIVJVLJ
      WRVIVJCWPWQUMVIVJVLNOUNUOVQVKFEZWAKWKVIVJFVOWQUPWSWEWAWSVIVJFJWEVIVJFNVIV
      JWQUQOVCPVDWAWDWEURQRWAWFBUSPRVMTZVPTWIVTHVLTWTCUTCVLVAVBFVOVEABVMVPVFVGW
      GAVOVHQ $.

    $( Two ways of saying a relation is antisymmetric and reflexive.
       (Contributed by NM, 6-May-2008.)  (Proof shortened by Mario Carneiro,
       4-Dec-2016.) $)
    asymref2 $p |- ( ( R i^i `' R ) = ( _I |` U. U. R ) <->
   ( A. x e. U. U. R x R x /\ A. x A. y ( ( x R y /\ y R x ) -> x = y ) ) ) $=
      ( ccnv cin cid cuni wceq cv wbr wa wral wi ralbii albii bitri wcel 3bitri
      wal vex cres wb asymref albiim r19.26 ancom equcom imbi1i nfv breq2 breq1
      anbi12d anidm syl6bb equsal df-ral cop df-br opeluu simpld adantr pm2.24d
      wn sylbi com12 alrimiv id ja ax-1 impbii anbi12i ) CCDEFCGGZUAHAIZBIZCJZV
      NVMCJZKZVMVNHZUBBSZAVLLVQVRMZBSZVRVQMZBSZKZAVLLZVMVMCJZAVLLZWAASZKZABCUCV
      SWDAVLVQVRBUDNWEWAAVLLZWCAVLLZKWKWJKWIWAWCAVLUEWJWKUFWKWGWJWHWCWFAVLWCVNV
      MHZVQMZBSWFWBWMBVRWLVQABUGUHOVQWFBAWFBUIWLVQWFWFKWFWLVOWFVPWFVNVMVMCUJVNV
      MVMCUKULWFUMUNUOPNWJVMVLQZWAMZASWHWAAVLUPWOWAAWOWAWNWAWAWNVCZVTBVQWPVRVQW
      NVRVOWNVPVOVMVNUQCQZWNVMVNCURWQWNVNVLQVMVNCATBTUSUTVDVAVBVEVFWAVGVHWAWNVI
      VJOPVKRR $.

    $( Two ways of saying a relation is irreflexive.  Definition of
       irreflexivity in [Schechter] p. 51.  (Contributed by NM, 9-Sep-2004.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    intirr $p |- ( ( R i^i _I ) = (/) <-> A. x -. x R x ) $=
      ( vy cid cin c0 wceq cv cop wcel cvv cdif wi wal wbr wn wss incom 3bitr2i
      df-br eqeq1i disj2 wrel wb reli ssrel ax-mp 3bitri equcom vex wa biantrur
      ideq opex eldif bitr4i xchnxbir imbi12i 2albii breq2 notbid equsal albii
      nfv ) BDEZFGZAHZCHZIZDJZVIKBLZJZMZCNANZVHVGGZVGVHBOZPZMZCNZANVGVGBOZPZANV
      FDBEZFGDVKQZVNVEWBFBDRUADBUBDUCWCVNUDUEACDVKUFUGUHVRVMACVOVJVQVLVOVGVHGVG
      VHDOVJCAUIVGVHCUJUMVGVHDTSVIBJZVLVPWDPZVIKJZWEUKVLWFWEVGVHUNULVIKBUOUPVGV
      HBTUQURUSVSWAAVQWACAWACVDVOVPVTVHVGVGBUTVAVBVCS $.

    $( Two ways of saying that two elements have an upper bound.  (Contributed
       by Mario Carneiro, 3-Nov-2015.) $)
    brcodir $p |- ( ( A e. V /\ B e. W ) ->
      ( A ( `' R o. R ) B <-> E. z ( A R z /\ B R z ) ) ) $=
      ( wcel wa ccnv ccom wbr cv wex brcog wb cvv vex brcnvg mpan anbi2d adantl
      exbidv bitrd ) BEGZCFGZHZBCDIZDJKBALZDKZUHCUGKZHZAMUICUHDKZHZAMABCUGDEFNU
      FUKUMAUEUKUMOUDUEUJULUIUHPGUEUJULOAQUHCPFDRSTUAUBUC $.

    $( Two ways of saying a relation is directed.  (Contributed by Mario
       Carneiro, 22-Nov-2013.) $)
    codir $p |- ( ( A X. B ) C_ ( `' R o. R ) <-> A. x e. A A. y e. B
      E. z ( x R z /\ y R z ) ) $=
      ( cv cop cxp wcel ccnv ccom wi wal wa wbr wral cvv wb vex wex wss brcodir
      opelxp df-br mp2an bitr3i imbi12i 2albii wrel relxp ssrel ax-mp 3bitr4i
      r2al ) AGZBGZHZDEIZJZURFKFLZJZMZBNANZUPDJUQEJOZUPCGZFPUQVFFPOCUAZMZBNANUS
      VAUBZVGBEQADQVCVHABUTVEVBVGUPUQDEUDVBUPUQVAPZVGUPUQVAUEUPRJUQRJVJVGSATBTC
      UPUQFRRUCUFUGUHUIUSUJVIVDSDEUKABUSVAULUMVGABDEUOUN $.

    $( A quantifier-free way of expressing the total order predicate.
       (Contributed by Mario Carneiro, 22-Nov-2013.) $)
    qfto $p |- ( ( A X. B ) C_ ( R u. `' R ) <->
                 A. x e. A A. y e. B ( x R y \/ y R x ) ) $=
      ( cv cop cxp wcel ccnv cun wi wal wa wbr wo wss wral opelxp vex brun wrel
      df-br brcnv orbi2i 3bitr3i imbi12i 2albii relxp ssrel ax-mp r2al 3bitr4i
      wb ) AFZBFZGZCDHZIZUQEEJZKZIZLZBMAMZUOCIUPDINZUOUPEOZUPUOEOZPZLZBMAMURVAQ
      ZVHBDRACRVCVIABUSVEVBVHUOUPCDSUOUPVAOVFUOUPUTOZPVBVHUOUPEUTUAUOUPVAUCVKVG
      VFUOUPEATBTUDUEUFUGUHURUBVJVDUNCDUIABURVAUJUKVHABCDULUM $.

    $( A square cross product ` ( A X. A ) ` is a transitive relation.
       (Contributed by FL, 31-Jul-2009.) $)
    xpidtr $p |- ( ( A X. A ) o. ( A X. A ) ) C_ ( A X. A ) $=
      ( vx vy vz cxp ccom wss cv wbr wa wal wcel simplbi2com adantl sylbi com12
      wi brxp adantr imp ax-gen gen2 cotr mpbir ) AAEZUEFUEGBHZCHZUEIZUGDHZUEIZ
      JUFUIUEIZQZDKZCKBKUMBCULDUHUJUKUHUFALZUGALZJUJUKQZUFUGAARUNUPUOUJUNUKUJUO
      UIALZJUNUKQZUGUIAARUQURUOUKUNUQUFUIAARMNOPSOTUAUBBCDUEUCUD $.

    $( The intersection of two transitive classes is transitive.  (Contributed
       by FL, 31-Jul-2009.) $)
    trin2 $p |- ( ( ( R o. R ) C_ R /\ ( S o. S ) C_ S )
      -> ( ( R i^i S ) o. ( R i^i S ) ) C_ ( R i^i S ) ) $=
      ( vx vy vz ccom wss wa cv cin wbr wal cotr brin simpr simpl com12 alanimi
      wi sylbi anim12d an4s syl2anb syl6ibr ex imp sylibr ) AAFAGZBBFBGZHCIZDIZ
      ABJZKZUKEIZULKZHZUJUNULKZSZELZDLZCLZULULFULGUHUIVAUHUJUKAKZUKUNAKZHZUJUNA
      KZSZELZDLZCLZUIVASCDEAMUIVIVAUIUJUKBKZUKUNBKZHZUJUNBKZSZELZDLZCLZVIVASCDE
      BMVQVIVAVPVHUTCVOVGUSDVNVFUREVNVFHZUPVEVMHZUQUPVRVSUMVBVJHVCVKHVRVSSZUOUJ
      UKABNUKUNABNVBVCVJVKVTVRVDVLHVSVRVDVEVLVMVNVFOVNVFPUAQUBUCQUJUNABNUDRRRUE
      TQTUFCDEULMUG $.

    $( A partial order relation is irreflexive.  (Contributed by Mario
       Carneiro, 2-Nov-2015.) $)
    poirr2 $p |- ( R Po A -> ( R i^i ( _I |` A ) ) = (/) ) $=
      ( vx vy wpo cid cres cin c0 wss wceq wrel relres relin2 cv wcel wbr wa wn
      syl5bi mp1i cop df-br brin bitr3i wi vex brres poirr wb ideq breq2 notbid
      sylbi syl5ibcom expimpd ancomsd con2d imnan sylib pm2.21d relssdv ss0 syl
      ) ABEZBFAGZHZIJVGIKVECDVGIVFLVGLVEFAMBVFNUACOZDOZUBZVGPZVHVIBQZVHVIVFQZRZ
      VEVJIPZVKVHVIVGQVNVHVIVGUCVHVIBVFUDUEVEVNVOVEVLVMSUFVNSVEVMVLVMVHVIFQZVHA
      PZRVEVLSZVHVIFADUGZUHVEVQVPVRVEVQVPVRVEVQRVHVHBQZSVPVRAVHBUIVPVTVLVPVHVIK
      VTVLUJVHVIVSUKVHVIVHBULUNUMUOUPUQTURVLVMUSUTVATVBVGVCVD $.
  $}

  $( The relation induced by a transitive relation on a part of its field is
     transitive.  (Taking the intersection of a relation with a square cross
     product is a way to restrict it to a subset of its field.)  (Contributed
     by FL, 31-Jul-2009.) $)
  trinxp $p |- ( ( R o. R ) C_ R ->
  ( ( R i^i ( A X. A ) ) o. ( R i^i ( A X. A ) ) ) C_ ( R i^i ( A X. A ) ) ) $=
    ( ccom wss cxp cin xpidtr trin2 mpan2 ) BBCBDAAEZJCJDBJFZKCKDAGBJHI $.

  ${
    soi.1 $e |- R Or S $.
    soi.2 $e |- R C_ ( S X. S ) $.
    $( A strict order relation is irreflexive.  (Contributed by NM,
       10-Feb-1996.)  (Revised by Mario Carneiro, 10-May-2013.) $)
    soirri $p |- -. A R A $=
      ( wcel wa wbr wn wor sonr mpan adantl brel con3i pm2.61i ) ACFZQGZAABHZIZ
      QTQCBJQTDCABKLMSRAACCBENOP $.

    ${
      $d A x $.  $d B x $.  $d R x $.
      $( A strict order relation is a transitive relation.  (Contributed by NM,
         10-Feb-1996.)  (Revised by Mario Carneiro, 10-May-2013.) $)
      sotri $p |- ( ( A R B /\ B R C ) -> A R C ) $=
        ( wcel wa wbr brel simpld anim12i wi wor w3a sotr mpan 3expb mpcom ) AE
        HZBEHZCEHZIZIABDJZBCDJZIZACDJZUEUAUFUDUEUAUBABEEDGKLBCEEDGKMUAUBUCUGUHN
        ZEDOUAUBUCPUIFEABCDQRST $.

      $( A strict order relation has no 2-cycle loops.  (Contributed by NM,
         10-Feb-1996.)  (Revised by Mario Carneiro, 10-May-2013.) $)
      son2lpi $p |- -. ( A R B /\ B R A ) $=
        ( wbr wa soirri sotri mto ) ABCGBACGHAACGACDEFIABACDEFJK $.

      $( A transitivity relation.  (Read ` A <_ B ` and ` B < C ` implies
         ` A < C ` .)  (Contributed by Mario Carneiro, 10-May-2013.) $)
      sotri2 $p |- ( ( A e. S /\ -. B R A /\ B R C ) -> A R C ) $=
        ( wcel wbr wn wi brel simpld wa wceq wo wor wb sotric mpan breq1 biimpd
        con2bid sotri ex jaoi syl6bir com3r mpand com3l 3imp ) AEHZBADIZJZBCDIZ
        ACDIZUOULUNUPUOBEHZULUNUPKUOUQCEHBCEEDGLMUQULNZUNUOUPURUNBAOZABDIZPZUOU
        PKZURUMVAEDQURUMVAJRFEBADSTUCUSVBUTUSUOUPBACDUAUBUTUOUPABCDEFGUDUEUFUGU
        HUIUJUK $.

      $( A transitivity relation.  (Read ` A < B ` and ` B <_ C ` implies
         ` A < C ` .)  (Contributed by Mario Carneiro, 10-May-2013.) $)
      sotri3 $p |- ( ( C e. S /\ A R B /\ -. C R B ) -> A R C ) $=
        ( wcel wbr wn wi brel simprd wa wceq wo wor wb sotric mpan breq2 expcom
        con2bid biimprd sotri jaoi syl6bir com3r mpan2d com12 3imp ) CEHZABDIZC
        BDIZJZACDIZUMULUOUPKZUMULBEHZUQUMAEHURABEEDGLMULURNZUOUMUPUSUOCBOZBCDIZ
        PZUMUPKZUSUNVBEDQUSUNVBJRFECBDSTUCUTVCVAUTUPUMCBADUAUDUMVAUPABCDEFGUEUB
        UFUGUHUIUJUK $.
    $}
  $}

  ${
    soiOLD.1 $e |- A e. _V $.
    soiOLD.2 $e |- R Or S $.
    soiOLD.3 $e |- R C_ ( S X. S ) $.
    $( A strict order relation is irreflexive.  (Contributed by NM,
       10-Feb-1996.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    soirriOLD $p |- -. A R A $=
      ( wcel wa wbr wn wor sonr mpan adantl brel con3i pm2.61i ) ACGZRHZAABIZJZ
      RUARCBKRUAECABLMNTSAACCBFOPQ $.

    ${
      sotriOLD.4 $e |- B e. _V $.
      sotriOLD.5 $e |- C e. _V $.
      $( A strict order relation is a transitive relation.  (Contributed by NM,
         10-Feb-1996.)  (Proof modification is discouraged.)
         (New usage is discouraged.) $)
      sotriOLD $p |- ( ( A R B /\ B R C ) -> A R C ) $=
        ( wcel w3a wbr wa brel wi id 3exp a1dd imp43 syl2an wor sotr mpan mpcom
        ) AEKZBEKZCEKZLZABDMZBCDMZNZACDMZUJUFUGNUGUHNUIUKABEEDHOBCEEDHOUFUGUGUH
        UIUFUGUHUIPUGUFUGUHUIUIQRSTUAEDUBUIULUMPGEABCDUCUDUE $.
    $}

    ${
      son2lpiOLD.4 $e |- B e. _V $.
      $( A strict order relation has no 2-cycle loops.  (Contributed by NM,
         10-Feb-1996.)  (Proof modification is discouraged.)
         (New usage is discouraged.) $)
      son2lpiOLD $p |- -. ( A R B /\ B R A ) $=
        ( wbr wa soirri sotri mto ) ABCIBACIJAACIACDFGKABACDFGLM $.
    $}
  $}

  $( Express "less than or equals" for general strict orders.  (Contributed by
     Stefan O'Rear, 17-Jan-2015.) $)
  poleloe $p |- ( B e. V -> ( A ( R u. _I ) B <-> ( A R B \/ A = B ) ) ) $=
    ( cid cun wbr wo wcel wceq brun ideqg orbi2d syl5bb ) ABCEFGABCGZABEGZHBDIZ
    OABJZHABCEKQPROABDLMN $.

  $( Transitive law for general strict orders.  (Contributed by Stefan O'Rear,
     17-Jan-2015.) $)
  poltletr $p |- ( ( R Po X /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A R B /\ B ( R u. _I ) C ) -> A R C ) ) $=
    ( wpo wcel w3a wa wbr cid cun wceq wo poleloe 3ad2ant3 adantl anbi2d com12
    wb wi potr breq2 biimpac a1d jaodan sylbid ) EDFZAEGZBEGZCEGZHZIZABDJZBCDKL
    JZIUNBCDJZBCMZNZIZACDJZUMUOURUNULUOURTZUHUKUIVAUJBCDEOPQRUSUMUTUNUPUMUTUAUQ
    UMUNUPIUTEABCDUBSUNUQIUTUMUQUNUTBCADUCUDUEUFSUG $.

  $( Property of a minimum in a strict order.  (Contributed by Stefan O'Rear,
     17-Jan-2015.) $)
  somin1 $p |- ( ( R Or X /\ ( A e. X /\ B e. X ) ) ->
      if ( A R B , A , B ) ( R u. _I ) A ) $=
    ( wor wcel wa wbr cif cid cun wceq wo iftrue olcd adantl wn sotric mpbird
    wb orcom eqcom orbi2i bitri notbii syl6bb con2bid biimpar iffalse breq1 syl
    eqeq1 orbi12d pm2.61dan poleloe ad2antrl ) DCEZADFZBDFZGGZABCHZABIZACJKHZVB
    ACHZVBALZMZUTVAVFVAVFUTVAVEVDVAABNOPUTVAQZGVFBACHZBALZMZUTVJVGUTVAVJUTVAABL
    ZVHMZQVJQDABCRVLVJVLVHVKMVJVKVHUAVKVIVHABUBUCUDUEUFUGUHVGVFVJTZUTVGVBBLZVMV
    AABUIVNVDVHVEVIVBBACUJVBBAULUMUKPSUNURVCVFTUQUSVBACDUOUPS $.

  $( Commutativity of minimum in a total order.  (Contributed by Stefan O'Rear,
     17-Jan-2015.) $)
  somincom $p |- ( ( R Or X /\ ( A e. X /\ B e. X ) ) ->
      if ( A R B , A , B ) = if ( B R A , B , A ) ) $=
    ( wor wcel wa wbr cif wceq iftrue adantl wn wi so2nr nan mpbi iffalse eqtrd
    eqcomd syl wo sotric con2bid ifeq2 ifid syl6req jaoi syl6bir imp pm2.61dan
    ) DCEADFBDFGGZABCHZUMABIZBACHZBAIZJULUMGZUNAUPUMUNAJULUMABKLUQUPAUQUOMZUPAJ
    ULUMUOGMNUQURNDABCOULUMUOPQUOBARUATSULUMMZGUNBUPUSUNBJULUMABRLULUSBUPJZULUS
    ABJZUOUBZUTULUMVBDABCUCUDVAUTUOVAUPUOBBIBUOABBUEUOBUFUGUOUPBUOBAKTUHUIUJSUK
    $.

  $( Property of a minimum in a strict order.  (Contributed by Stefan O'Rear,
     17-Jan-2015.) $)
  somin2 $p |- ( ( R Or X /\ ( A e. X /\ B e. X ) ) ->
      if ( A R B , A , B ) ( R u. _I ) B ) $=
    ( wor wcel wa wbr cif cid cun somincom somin1 ancom2s eqbrtrd ) DCEZADFZBDF
    ZGGABCHABIBACHBAIZBCJKZABCDLPRQSBTHBACDMNO $.

  $( Being less than a minimum, for a general total order.  (Contributed by
     Stefan O'Rear, 17-Jan-2015.) $)
  soltmin $p |- ( ( R Or X /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( A R if ( B R C , B , C ) <-> ( A R B /\ A R C ) ) ) $=
    ( wor wcel w3a wa wbr cif wpo cid cun 3jca syl12anc poltletr syl22anc breq2
    imp sopo ad2antrr simplr1 simplr2 simplr3 ifcl syl2anc simpll somin1 somin2
    simpr jca ex ifboth impbid1 ) EDFZAEGZBEGZCEGZHZIZABCDJZBCKZDJZABDJZACDJZIZ
    VAVDVGVAVDIZVEVFVHEDLZUQVCEGZURHZVDVCBDMNZJZVEUPVIUTVDEDUAUBZVHUQVJURUQURUS
    UPVDUCZVHURUSVJUQURUSUPVDUDZUQURUSUPVDUEZVBBCEUFUGZVPOVAVDUKZVHUPURUSVMUPUT
    VDUHZVPVQBCDEUIPVIVKIVDVMIVEAVCBDEQTRVHVIUQVJUSHZVDVCCVLJZVFVNVHUQVJUSVOVRV
    QOVSVHUPURUSWBVTVPVQBCDEUJPVIWAIVDWBIVFAVCCDEQTRULUMVBVEVFVDBCBVCADSCVCADSU
    NUO $.

  ${
    $d x y z w $.  $d z w ph $.
    $( The converse of a class abstraction of ordered pairs.  (Contributed by
       NM, 11-Dec-2003.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    cnvopab $p |- `' { <. x , y >. | ph } = { <. y , x >. | ph } $=
      ( vz vw copab ccnv relcnv relopab cop wcel wsb opelopabsbOLD sbcom2 bitri
      cv vex opelcnv 3bitr4i eqrelriiv ) DEABCFZGZACBFZUAHACBIEPZDPZJUAKZACDLBE
      LZUEUDJZUBKUHUCKUFABELCDLUGABCEDMABECDNOUEUDUADQEQRACBDEMST $.
  $}

  ${
    $d x y $.
    $( The converse of the empty set.  (Contributed by NM, 6-Apr-1998.) $)
    cnv0 $p |- `' (/) = (/) $=
      ( vx vy c0 ccnv relcnv rel0 cv cop wcel vex opelcnv noel 2false eqrelriiv
      bitr4i ) ABCDZCCEFAGZBGZHZPIRQHZCIZSCIZQRCAJBJKUBUASLTLMON $.

    $( The converse of the identity relation.  Theorem 3.7(ii) of [Monk1]
       p. 36.  (Contributed by NM, 26-Apr-1998.)  (Proof shortened by Andrew
       Salmon, 27-Aug-2011.) $)
    cnvi $p |- `' _I = _I $=
      ( vy vx cid wbr copab weq ccnv vex ideq equcom bitri opabbii df-cnv df-id
      cv 3eqtr4i ) AOZBOZCDZBAEBAFZBAECGCSTBASABFTQRBHIABJKLBACMBANP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The converse of a union is the union of converses.  Theorem 16 of
       [Suppes] p. 62.  (Contributed by NM, 25-Mar-1998.)  (Proof shortened by
       Andrew Salmon, 27-Aug-2011.) $)
    cnvun $p |- `' ( A u. B ) = ( `' A u. `' B ) $=
      ( vy vx cun ccnv cv wbr copab df-cnv unopab brun opabbii eqtr4i uneq12i
      wo ) ABEZFZCGZDGZAHZDCIZSTBHZDCIZEZAFZBFZERSTQHZDCIZUEDCQJUEUAUCPZDCIUIUA
      UCDCKUHUJDCSTABLMNNUFUBUGUDDCAJDCBJON $.

    $( Distributive law for converse over set difference.  (Contributed by
       Mario Carneiro, 26-Jun-2014.) $)
    cnvdif $p |- `' ( A \ B ) = ( `' A \ `' B ) $=
      ( vx vy cdif ccnv relcnv wss wrel difss relss mp2 cv cop wcel wn wa eldif
      vex opelcnv notbii anbi12i bitri 3bitr4i eqrelriiv ) CDABEZFZAFZBFZEZUFGU
      JUHHUHIUJIUHUIJAGUJUHKLDMZCMZNZUFOUMAOZUMBOZPZQZULUKNZUGOURUJOZUMABRULUKU
      FCSZDSZTUSURUHOZURUIOZPZQUQURUHUIRVBUNVDUPULUKAUTVATVCUOULUKBUTVATUAUBUCU
      DUE $.

    $( Distributive law for converse over intersection.  Theorem 15 of [Suppes]
       p. 62.  (Contributed by NM, 25-Mar-1998.)  (Revised by Mario Carneiro,
       26-Jun-2014.) $)
    cnvin $p |- `' ( A i^i B ) = ( `' A i^i `' B ) $=
      ( cdif ccnv cin cnvdif difeq2i eqtri dfin4 cnveqi 3eqtr4i ) AABCZCZDZADZO
      BDZCZCZABEZDOPENOLDZCRALFTQOABFGHSMABIJOPIK $.
  $}

  $( Distributive law for range over union.  Theorem 8 of [Suppes] p. 60.
     (Contributed by NM, 24-Mar-1998.) $)
  rnun $p |- ran ( A u. B ) = ( ran A u. ran B ) $=
    ( cun ccnv cdm crn cnvun dmeqi dmun eqtri df-rn uneq12i 3eqtr4i ) ABCZDZEZA
    DZEZBDZEZCZNFAFZBFZCPQSCZEUAOUDABGHQSIJNKUBRUCTAKBKLM $.

  $( The range of an intersection belongs the intersection of ranges.  Theorem
     9 of [Suppes] p. 60.  (Contributed by NM, 15-Sep-2004.) $)
  rnin $p |- ran ( A i^i B ) C_ ( ran A i^i ran B ) $=
    ( cin ccnv cdm crn cnvin dmeqi dmin eqsstri df-rn ineq12i 3sstr4i ) ABCZDZE
    ZADZEZBDZEZCZNFAFZBFZCPQSCZEUAOUDABGHQSIJNKUBRUCTAKBKLM $.

  ${
    $d x y z $.  $d y z A $.  $d y z B $.
    $( The range of an indexed union.  (Contributed by Mario Carneiro,
       29-May-2015.) $)
    rniun $p |- ran U_ x e. A B = U_ x e. A ran B $=
      ( vz vy ciun crn cv cop wcel wex wrex rexcom4 elrn2 rexbii eliun 3bitr4ri
      vex exbii 3bitr4i eqriv ) DABCFZGZABCGZFZEHDHZIZUBJZEKZUFUDJZABLZUFUCJUFU
      EJUGCJZEKZABLULABLZEKUKUIULAEBMUJUMABEUFCDRZNOUHUNEAUGBCPSQEUFUBUONAUFBUD
      PTUA $.

    $d x A $.
    $( The range of a union.  Part of Exercise 8 of [Enderton] p. 41.
       (Contributed by NM, 17-Mar-2004.)  (Revised by Mario Carneiro,
       29-May-2015.) $)
    rnuni $p |- ran U. A = U_ x e. A ran x $=
      ( cuni crn cv ciun uniiun rneqi rniun eqtri ) BCZDABAEZFZDABLDFKMABGHABLI
      J $.
  $}

  $( Distributive law for image over union.  Theorem 35 of [Suppes] p. 65.
     (Contributed by NM, 30-Sep-2002.) $)
  imaundi $p |- ( A " ( B u. C ) ) = ( ( A " B ) u. ( A " C ) ) $=
    ( cun cres crn cima resundi rneqi rnun eqtri df-ima uneq12i 3eqtr4i ) ABCDZ
    EZFZABEZFZACEZFZDZAOGABGZACGZDQRTDZFUBPUEABCHIRTJKAOLUCSUDUAABLACLMN $.

  $( The image of a union.  (Contributed by Jeff Hoffman, 17-Feb-2008.) $)
  imaundir $p |- ( ( A u. B ) " C ) = ( ( A " C ) u. ( B " C ) ) $=
    ( cun cima cres crn df-ima resundir rneqi rnun 3eqtri uneq12i eqtr4i ) ABDZ
    CEZACFZGZBCFZGZDZACEZBCEZDPOCFZGQSDZGUAOCHUDUEABCIJQSKLUBRUCTACHBCHMN $.

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( An upper bound for intersection with a domain.  Theorem 40 of [Suppes]
       p. 66, who calls it "somewhat surprising."  (Contributed by NM,
       11-Aug-2004.) $)
    dminss $p |- ( dom R i^i A ) C_ ( `' R " ( R " A ) ) $=
      ( vx vy cdm cin ccnv cima cv wbr wcel wa 19.8a ancoms elima2 sylibr simpl
      wex vex brcnv jca eximi eldm anbi1i elin 19.41v 3bitr4i 3imtr4i ssriv ) C
      BEZAFZBGZBAHZHZCIZDIZBJZUOAKZLZDRZUPUMKZUPUOULJZLZDRUOUKKZUOUNKUSVCDUSVAV
      BUSURUQLZCRZVAURUQVFVECMNCUPBADSZOPUSUQVBUQURQUPUOBVGCSZTPUAUBUOUJKZURLUQ
      DRZURLVDUTVIVJURDUOBVHUCUDUOUJAUEUQURDUFUGDUOULUMVHOUHUI $.

    $( An upper bound for intersection with an image.  Theorem 41 of [Suppes]
       p. 66.  (Contributed by NM, 11-Aug-2004.) $)
    imainss $p |- ( ( R " A ) i^i B ) C_ ( R " ( A i^i ( `' R " B ) ) ) $=
      ( vy vx cima cin ccnv cv wcel wbr wa wex brcnv 19.8a sylan2br elin elima2
      vex anbi1i ancoms anim2i simprl anassrs anbi2i bitri sylibr eximi 3bitr4i
      jca 19.41v 3imtr4i ssriv ) DCAFZBGZCACHZBFZGZFZEIZAJZUTDIZCKZLZVBBJZLZEMZ
      UTURJZVCLZEMVBUOJZVBUSJVFVIEVFVAVEVBUTUPKZLZDMZLZVCLZVIVAVCVEVOVAVCVELZLV
      NVCVPVMVAVEVCVMVCVEVKVMVBUTCDSZESZNVLDOPUAUBVAVCVEUCUJUDVHVNVCVHVAUTUQJZL
      VNUTAUQQVSVMVADUTUPBVRRUEUFTUGUHVBUNJZVELVDEMZVELVJVGVTWAVEEVBCAVQRTVBUNB
      QVDVEEUKUIEVBCURVQRULUM $.
  $}

  $( The image of an intersection (Contributed by Thierry Arnoux,
     16-Dec-2017.) $)
  inimass $p |- ( ( A i^i B ) " C ) C_ ( ( A " C ) i^i ( B " C ) ) $=
    ( cres cin crn cima rnin df-ima resindir rneqi eqtri ineq12i 3sstr4i ) ACDZ
    BCDZEZFZOFZPFZEABEZCGZACGZBCGZEOPHUBUACDZFRUACIUEQABCJKLUCSUDTACIBCIMN $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x V $.
    $( The intersection of the image of singleton (Contributed by Thierry
       Arnoux, 16-Dec-2017.) $)
    inimasn $p |- ( C e. V
      -> ( ( A i^i B ) " { C } ) = ( ( A " { C } ) i^i ( B " { C } ) ) ) $=
      ( vx wcel cin csn cima cv wa elin cop a1i cvv vex elimasng mpan2 anbi12d
      wb 3bitr4rd syl5rbb eqrdv ) CDFZEABGZCHZIZAUFIZBUFIZGZEJZUJFUKUHFZUKUIFZK
      ZUDUKUGFZUKUHUILUDCUKMZUEFZUPAFZUPBFZKZUOUNUQUTTUDUPABLNUDUKOFZUOUQTEPZUE
      CUKDOQRUDULURUMUSUDVAULURTVBACUKDOQRUDVAUMUSTVBBCUKDOQRSUAUBUC $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The converse of a cross product.  Exercise 11 of [Suppes] p. 67.
       (Contributed by NM, 14-Aug-1999.)  (Proof shortened by Andrew Salmon,
       27-Aug-2011.) $)
    cnvxp $p |- `' ( A X. B ) = ( B X. A ) $=
      ( vy vx cv wcel copab ccnv cxp cnvopab ancom opabbii eqtri cnveqi 3eqtr4i
      wa df-xp ) CEAFZDEBFZPZCDGZHZSRPZDCGZABIZHBAIUBTDCGUDTCDJTUCDCRSKLMUEUACD
      ABQNDCBAQO $.
  $}

  $( The cross product with the empty set is empty.  Part of Theorem 3.13(ii)
     of [Monk1] p. 37.  (Contributed by NM, 12-Apr-2004.) $)
  xp0 $p |- ( A X. (/) ) = (/) $=
    ( c0 cxp ccnv 0xp cnveqi cnvxp cnv0 3eqtr3i ) BACZDBDABCBJBAEFBAGHI $.

  ${
    $d x y z A $.  $d x y z B $.
    $( The cross product of nonempty classes is nonempty.  (Variation of a
       theorem contributed by Raph Levien, 30-Jun-2006.)  (Contributed by NM,
       30-Jun-2006.) $)
    xpnz $p |- ( ( A =/= (/) /\ B =/= (/) ) <-> ( A X. B ) =/= (/) ) $=
      ( vx vy vz c0 wne wa cxp cv wcel wex anbi12i eeanv bitr4i cop wceq syl6eq
      n0 necon3i opex eleq1 opelxp syl6bb spcev sylibr exlimivv sylbi xpeq1 0xp
      xpeq2 xp0 jca impbii ) AFGZBFGZHZABIZFGZUQCJZAKZDJZBKZHZDLCLZUSUQVACLZVCD
      LZHVEUOVFUPVGCASDBSMVAVCCDNOVDUSCDVDEJZURKZELUSVIVDEUTVBPZUTVBUAVHVJQVIVJ
      URKVDVHVJURUBUTVBABUCUDUEEURSUFUGUHUSUOUPAFURFAFQURFBIFAFBUIBUJRTBFURFBFQ
      URAFIFBFAUKAULRTUMUN $.
  $}

  $( At least one member of an empty cross product is empty.  (Contributed by
     NM, 27-Aug-2006.) $)
  xpeq0 $p |- ( ( A X. B ) = (/) <-> ( A = (/) \/ B = (/) ) ) $=
    ( cxp c0 wceq wne wa wn wo xpnz necon2bbii ianor nne orbi12i 3bitri ) ABCZD
    EADFZBDFZGZHQHZRHZIADEZBDEZISPDABJKQRLTUBUAUCADMBDMNO $.

  $( Cross products with disjoint sets are disjoint.  (Contributed by NM,
     13-Sep-2004.) $)
  xpdisj1 $p |- ( ( A i^i B ) = (/) -> ( ( A X. C ) i^i ( B X. D ) ) = (/) ) $=
    ( cin c0 wceq cxp inxp xpeq1 0xp syl6eq syl5eq ) ABEZFGZACHBDHENCDEZHZFACBD
    IOQFPHFNFPJPKLM $.

  $( Cross products with disjoint sets are disjoint.  (Contributed by NM,
     13-Sep-2004.) $)
  xpdisj2 $p |- ( ( A i^i B ) = (/) -> ( ( C X. A ) i^i ( D X. B ) ) = (/) ) $=
    ( cin c0 wceq cxp inxp xpeq2 xp0 syl6eq syl5eq ) ABEZFGZCAHDBHECDEZNHZFCADB
    IOQPFHFNFPJPKLM $.

  $( Cross products with two different singletons are disjoint.  (Contributed
     by NM, 28-Jul-2004.) $)
  xpsndisj $p |- ( B =/= D -> ( ( A X. { B } ) i^i ( C X. { D } ) ) = (/) ) $=
    ( wne csn cin c0 wceq cxp disjsn2 xpdisj2 syl ) BDEBFZDFZGHIANJCOJGHIBDKNOA
    CLM $.

  ${
    $d x A $.  $d y B $.
    $( Disjoint unions with disjoint index sets are disjoint.  (Contributed by
       Stefan O'Rear, 21-Nov-2014.) $)
    djudisj $p |- ( ( A i^i B ) = (/) -> ( U_ x e. A ( { x } X. C ) i^i
            U_ y e. B ( { y } X. D ) ) = (/) ) $=
      ( cin c0 wceq cv csn cxp ciun cvv wss djussxp incom syl5eq ssdisj sylancr
      xpdisj1 ) CDGHIZACAJKELMZCNLZOUDBDBJKFLMZGZHIUCUEGHIACEPUBUFUEUDGZHUDUEQU
      BUEDNLZOUHUDGZHIUGHIBDFPUBUIUDUHGHUHUDQCDNNUARUEUHUDSTRUCUDUEST $.
  $}

  $( A double restriction to disjoint classes is the empty set.  (Contributed
     by NM, 7-Oct-2004.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  resdisj $p |- ( ( A i^i B ) = (/) -> ( ( C |` A ) |` B ) = (/) ) $=
    ( cin c0 wceq cres resres reseq2 res0 syl6eq syl5eq ) ABDZEFZCAGBGCMGZECABH
    NOCEGEMECICJKL $.

  $( The range of a cross product.  Part of Theorem 3.13(x) of [Monk1] p. 37.
     (Contributed by NM, 12-Apr-2004.) $)
  rnxp $p |- ( A =/= (/) -> ran ( A X. B ) = B ) $=
    ( c0 wne cxp crn cdm ccnv df-rn cnvxp dmeqi eqtri dmxp syl5eq ) ACDABEZFZBA
    EZGZBPOHZGROISQABJKLBAMN $.

  $( The domain of a cross product is a subclass of the first factor.
     (Contributed by NM, 19-Mar-2007.) $)
  dmxpss $p |- dom ( A X. B ) C_ A $=
    ( cxp cdm wss c0 wceq xpeq2 xp0 syl6eq dm0 0ss syl6eqss wne dmxp eqimss syl
    dmeqd pm2.61ine ) ABCZDZAEZBFBFGZUAFAUCUAFDFUCTFUCTAFCFBFAHAIJRKJALMBFNUAAG
    UBABOUAAPQS $.

  $( The range of a cross product is a subclass of the second factor.
     (Contributed by NM, 16-Jan-2006.)  (Proof shortened by Andrew Salmon,
     27-Aug-2011.) $)
  rnxpss $p |- ran ( A X. B ) C_ B $=
    ( cxp crn ccnv cdm df-rn cnvxp dmeqi dmxpss eqsstri ) ABCZDLEZFZBLGNBACZFBM
    OABHIBAJKK $.

  $( The range of a square cross product.  (Contributed by FL, 17-May-2010.) $)
  rnxpid $p |- ran ( A X. A ) = A $=
    ( cxp crn wceq c0 rn0 xpeq2 xp0 syl6eq rneqd id 3eqtr4a rnxp pm2.61ine ) AA
    BZCZADAEAEDZECEPAFQOEQOAEBEAEAGAHIJQKLAAMN $.

  $( A cross-product subclass relationship is equivalent to the relationship
     for it components.  (Contributed by NM, 17-Dec-2008.) $)
  ssxpb $p |- ( ( A X. B ) =/= (/) -> ( ( A X. B ) C_ ( C X. D ) <->
              ( A C_ C /\ B C_ D ) ) ) $=
    ( cxp c0 wne wss wa cdm wceq xpnz dmxp adantl sylbir adantr eqsstr3d syl6ss
    dmss crn dmxpss rnxp rnss rnxpss jca ex xpss12 impbid1 ) ABEZFGZUICDEZHZACH
    ZBDHZIZUJULUOUJULIZUMUNUPAUKJZCUPAUIJZUQUJURAKZULUJAFGZBFGZIZUSABLZVAUSUTAB
    MNOPULURUQHUJUIUKSNQCDUARUPBUKTZDUPBUITZVDUJVEBKZULUJVBVFVCUTVFVAABUBPOPULV
    EVDHUJUIUKUCNQCDUDRUEUFACBDUGUH $.

  $( The cross product of non-empty classes is one-to-one.  (Contributed by NM,
     31-May-2008.) $)
  xp11 $p |- ( ( A =/= (/) /\ B =/= (/) )
      -> ( ( A X. B ) = ( C X. D ) <-> ( A = C /\ B = D ) ) ) $=
    ( c0 wne wa cxp wceq wi xpnz anidm neeq1 anbi2d syl5bbr wss ssxpb syl5ibcom
    eqimss eqss eqimss2 anim12d anbi12i bitr4i syl6ib sylbid com12 sylbi xpeq12
    an4 impbid1 ) AEFBEFGZABHZCDHZIZACIZBDIZGZULUMEFZUOURJABKUOUSURUOUSUSUNEFZG
    ZURUSUSUSGUOVAUSLUOUSUTUSUMUNEMNOUOVAACPZBDPZGZCAPZDBPZGZGZURUOUSVDUTVGUOUM
    UNPUSVDUMUNSABCDQRUOUNUMPUTVGUNUMUACDABQRUBVHVBVEGZVCVFGZGURVBVCVEVFUJUPVIU
    QVJACTBDTUCUDUEUFUGUHACBDUIUK $.

  $( Cancellation law for cross-product.  (Contributed by NM, 30-Aug-2011.) $)
  xpcan $p |- ( C =/= (/) -> ( ( C X. A ) = ( C X. B ) <-> A = B ) ) $=
    ( c0 wne cxp wceq wb wa xp11 eqid biantrur syl6bbr wn wi simpr xpeq2 syl6eq
    nne xp0 eqeq1d eqcom syl6bb adantl df-ne wo xpeq0 orel1 syl5bi sylbi adantr
    sylbid eqtr3 ee12an sylan2b impbid1 pm2.61dan ) CDEZADEZCAFZCBFZGZABGZHURUS
    IVBCCGZVCIVCCACBJVDVCCKLMURUSNZIVBVCVEURADGZVBVCOADSURVFIZVFVBBDGZVCURVFPVG
    VBVADGZVHVFVBVIHURVFVBDVAGVIVFUTDVAVFUTCDFDADCQCTRUADVAUBUCUDURVIVHOZVFURCD
    GZNZVJCDUEVIVKVHUFVLVHCBUGVKVHUHUIUJUKULABDUMUNUOABCQUPUQ $.

  $( Cancellation law for cross-product.  (Contributed by NM, 30-Aug-2011.) $)
  xpcan2 $p |- ( C =/= (/) -> ( ( A X. C ) = ( B X. C ) <-> A = B ) ) $=
    ( c0 wne cxp wceq wb wa xp11 eqid biantru syl6bbr wn nne simpl xpeq1 syl6eq
    0xp eqeq1d eqcom syl6bb adantr wi df-ne wo xpeq0 orel2 syl5bi adantl sylbid
    sylbi eqtr3 ee12an impbid1 sylanb pm2.61ian ) ADEZCDEZACFZBCFZGZABGZHZURUSI
    VBVCCCGZIVCACBCJVEVCCKLMURNADGZUSVDADOVFUSIZVBVCVGVFVBBDGZVCVFUSPVGVBVADGZV
    HVFVBVIHUSVFVBDVAGVIVFUTDVAVFUTDCFDADCQCSRTDVAUAUBUCUSVIVHUDZVFUSCDGZNZVJCD
    UEVIVHVKUFVLVHBCUGVKVHUHUIULUJUKABDUMUNABCQUOUPUQ $.

  $( If a cross product is a set, one of its components must be a set.
     (Contributed by NM, 27-Aug-2006.) $)
  xpexr $p |- ( ( A X. B ) e. C -> ( A e. _V \/ B e. _V ) ) $=
    ( cxp wcel cvv wn wi wceq 0ex eleq1 mpbiri pm2.24d a1d wne crn rnexg eleq1d
    c0 rnxp syl5ib a1dd pm2.61ine orrd ) ABDZCEZAFEZBFEZUFUGGZUHHZHASASIZUJUFUK
    UGUHUKUGSFEJASFKLMNASOZUFUHUIUFUEPZFEULUHUECQULUMBFABTRUAUBUCUD $.

  $( If a nonempty cross product is a set, so are both of its components.
     (Contributed by NM, 27-Aug-2006.) $)
  xpexr2 $p |- ( ( ( A X. B ) e. C /\ ( A X. B ) =/= (/) ) ->
               ( A e. _V /\ B e. _V ) ) $=
    ( cxp c0 wne wcel wa cvv xpnz cdm wceq dmxp adantl adantr eqeltrrd crn rnxp
    dmexg rnexg anim12dan ancom2s sylan2br ) ABDZEFUDCGZAEFZBEFZHAIGZBIGZHZABJU
    EUGUFUJUEUGUHUFUIUEUGHUDKZAIUGUKALUEABMNUEUKIGUGUDCSOPUEUFHUDQZBIUFULBLUEAB
    RNUEULIGUFUDCTOPUAUBUC $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Subset of the range of a restriction.  (Contributed by NM,
       16-Jan-2006.) $)
    ssrnres $p |- ( B C_ ran ( C |` A ) <-> ran ( C i^i ( A X. B ) ) = B ) $=
      ( vy vx cxp cin crn wceq wss rnss ax-mp cvv cv wex wa elrn2 bitr2i 3bitri
      wcel cres inss2 rnxpss sstri eqss mpbiran ssv xpss12 mp2an sslin sseqtr4i
      ssid df-res sstr mpan2 cop ssel syl6ib ancrd opelxp anbi2i opelres anbi1i
      vex elin anass exbii 19.41v syl6ibr ssrdv impbii ) CABFZGZHZBIZBVNJZBCAUA
      ZHZJZVOVNBJVPVNVLHZBVMVLJVNVTJCVLUBVMVLKLABUCUDVNBUEUFVPVSVPVNVRJZVSVMVQJ
      WAVMCAMFZGZVQVLWBJZVMWCJAAJBMJWDAULBUGAABMUHUIVLWBCUJLCAUMUKVMVQKLBVNVRUN
      UOVSDBVNVSDNZBTZENZWEUPZVQTZEOZWFPZWEVNTZVSWFWJVSWFWEVRTWJBVRWEUQEWEVQDVD
      ZQURUSWLWHVMTZEOWIWFPZEOWKEWEVMWMQWNWOEWNWHCTZWHVLTZPWPWGATZWFPZPZWOWHCVL
      VEWQWSWPWGWEABUTVAWOWPWRPZWFPWTWIXAWFWGWECAWMVBVCWPWRWFVFRSVGWIWFEVHSVIVJ
      VKR $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.
    $( Range of the intersection with a cross product.  (Contributed by NM,
       17-Jan-2006.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    rninxp $p |- ( ran ( C i^i ( A X. B ) ) = B <->
                 A. y e. B E. x e. A x C y ) $=
      ( cres crn wss wcel wral cxp cin wceq wbr wrex dfss3 ssrnres cima df-ima
      cv eleq2i vex elima bitr3i ralbii 3bitr3i ) DECFGZHBTZUGIZBDJECDKLGDMATUH
      ENACOZBDJBDUGPCDEQUIUJBDUIUHECRZIUJUKUGUHECSUAAUHECBUBUCUDUEUF $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x y C $.
    $( Domain of the intersection with a cross product.  (Contributed by NM,
       17-Jan-2006.) $)
    dminxp $p |- ( dom ( C i^i ( A X. B ) ) = A <->
                 A. x e. A E. y e. B x C y ) $=
      ( cxp cin cdm wceq ccnv crn cv wbr wrex wral dfdm4 cnvin cnvxp eqtri vex
      ineq2i rneqi eqeq1i rninxp brcnv rexbii ralbii 3bitri ) ECDFZGZHZCIEJZDCF
      ZGZKZCIBLZALZULMZBDNZACOUQUPEMZBDNZACOUKUOCUKUJJZKUOUJPVBUNVBULUIJZGUNEUI
      QVCUMULCDRUASUBSUCBADCULUDUSVAACURUTBDUPUQEBTATUEUFUGUH $.
  $}

  $( Image of a relation restricted to a rectangular region.  (Contributed by
     Stefan O'Rear, 19-Feb-2015.) $)
  imainrect $p |- ( ( G i^i ( A X. B ) ) " Y ) =
      ( ( G " ( Y i^i A ) ) i^i B ) $=
    ( cxp cin cres crn cima df-res rneqi df-ima eqtri ineq1i ccnv ineq2i eqtr4i
    cvv cdm 3eqtr4ri cnvin inxp inv1 incom xpeq12i eqtr2i xpindir inass 3eqtr4i
    in32 cnveqi cnvxp dmeqi dmres df-rn ) CABEZFZDGZHUQDREZFZHZUQDICDAFZIZBFZUR
    UTUQDJKUQDLVDCVBREZFZHZBFZVAVCVGBVCCVBGZHVGCVBLVIVFCVBJKMNVFOZBGZSZUTOZSVHV
    AVKVMVFRBEZFZOVJVNOZFZVMVKVFVNUAUTVOCUSFZUPFVRAREZVNFZFZUTVOUPVTVRVTARFZRBF
    ZEUPARRBUBWBAWCBAUCWCBRFBRBUDBUCMUEUFPCUPUSUJVOVRVSFZVNFWAVFWDVNVFCUSVSFZFW
    DVEWECDARUGPCUSVSUHQNVRVSVNUHMUIUKVKVJBREZFVQVJBJVPWFVJRBULPQTUMBVJSZFWGBFV
    LVHBWGUDVJBUNVGWGBVFUONTUTUOTQUI $.

  $( The image by a constant function (or other cross product).  (Contributed
     by Thierry Arnoux, 4-Feb-2017.) $)
  xpima $p |- ( ( A X. B ) " C ) = if ( ( A i^i C ) = (/) , (/) , B ) $=
    ( cxp cima cin c0 wceq cif wa wn wo exmid crn cvv rneqi syl6eq syl5eq ancli
    cres df-ima df-res eqtri inxp inv1 xpeq2i 3eqtri xpeq1 0xp rneqd df-ne rnxp
    rn0 wne sylbir orim12i ax-mp eqif mpbir ) ABDZCEZACFZGHZGBIHVCVAGHZJZVCKZVA
    BHZJZLZVCVFLVIVCMVCVEVFVHVCVDVCVAVBBDZNZGVAUTCODFZNZVBBOFZDZNVKVAUTCTZNVMUT
    CUAVPVLUTCUBPUCVLVOABCOUDPVOVJVNBVBBUEUFPUGZVCVKGNGVCVJGVCVJGBDGVBGBUHBUIQU
    JUMQRSVFVGVFVAVKBVQVFVBGUNVKBHVBGUKVBBULUORSUPUQVCVAGBURUS $.

  $( The image by a cross product.  (Contributed by Thierry Arnoux,
     16-Dec-2017.) $)
  xpima1 $p |- ( ( A i^i C ) = (/) -> ( ( A X. B ) " C ) = (/) ) $=
    ( cin c0 wceq cxp cima cif xpima iftrue syl5eq ) ACDEFZABGCHMEBIEABCJMEBKL
    $.

  $( The image by a cross product.  (Contributed by Thierry Arnoux,
     16-Dec-2017.) $)
  xpima2 $p |- ( ( A i^i C ) =/= (/) -> ( ( A X. B ) " C ) = B ) $=
    ( cin c0 wne cxp cima wceq cif xpima ifnefalse syl5eq ) ACDZEFABGCHNEIEBJBA
    BCKNEEBLM $.

  $( The image of a singleton by a cross product.  (Contributed by Thierry
     Arnoux, 14-Jan-2018.) $)
  xpimasn $p |- ( X e. A -> ( ( A X. B ) " { X } ) = B ) $=
    ( wcel csn cin wne cxp cima wceq wss snssi dfss1 sylib snnzg eqnetrd xpima2
    c0 syl ) CADZACEZFZRGABHUAIBJTUBUARTUAAKUBUAJCALUAAMNCAOPABUAQS $.

  ${
    $d x y A $.  $d x B $.  $d x y R $.  $d x V $.
    $( The base set of a strict order is contained in the field of the
       relation, except possibly for one element (note that
       ` (/) Or { B } ` ).  (Contributed by Mario Carneiro, 27-Apr-2015.) $)
    sossfld $p |- ( ( R Or A /\ B e. A ) ->
      ( A \ { B } ) C_ ( dom R u. ran R ) ) $=
      ( vx wor wcel wa csn cdif cdm crn cun cv wne eldifsn wo wi 3expia adantll
      wbr sotrieq necon2abid breldmg an32s brelrng orim12d elun syl6ibr sylbird
      wb anass1rs expimpd syl5bi ssrdv ) ACEZBAFZGZDABHIZCJZCKZLZDMZURFVBAFZVBB
      NZGUQVBVAFZVBABOUQVCVDVEUQVCGZVDVBBCTZBVBCTZPZVEUOVCUPVIVDUJUOVCUPGGVIVBB
      AVBBCUAUBUKVFVIVBUSFZVBUTFZPVEVFVGVJVHVKUOVCUPVGVJQZVCUPVLUOVCUPVGVJVBBAA
      CUCRSUDUPVCVHVKQUOUPVCVHVKBVBCAAUERSUFVBUSUTUGUHUIULUMUN $.

    $( The base set of a nonempty strict order is the same as the field of the
       relation.  (Contributed by Mario Carneiro, 15-May-2015.) $)
    sofld $p |- ( ( R Or A /\ R C_ ( A X. A ) /\ R =/= (/) ) ->
      A = ( dom R u. ran R ) ) $=
      ( vx vy wor cxp wss c0 cdm crn wa wrel ad2antlr wcel ssun1 syl6sseq unssd
      cun cv ex wne w3a wn wceq relxp relss mpi cop wbr df-br csn cdif sseqtr4i
      undif1 simpll dmxpid releldm sylancom sseldd sossfld syl2anc sseldi snssd
      dmss syl5ss syl5bir con3and pm2.21d relssdv necon1ad 3impia rnss 3ad2ant2
      ss0 syl rnxpid eqssd ) ABEZBAAFZGZBHUAZUBABIZBJZRZVRVTWAAWDGZVRVTKZWEBHWF
      WEUCZBHUDZWFWGKZBHGWHWICDBHVTBLZVRWGVTVSLWJAAUEBVSUFUGZMWICSZDSZUHZBNZWNH
      NWFWOWEWOWLWMBUIZWFWEWLWMBUJWFWPWEWFWPKZAAWLUKZULZWRRZWDAAWRRWTAWROAWRUNU
      MWQWSWRWDWQVRWLANWSWDGVRVTWPUOWQWBAWLVTWBAGVRWPVTWBVSIABVSVDAUPPZMWFWPWJW
      LWBNVTWJVRWPWKMWLWMBUQURZUSAWLBUTVAWQWLWDWQWBWDWLWBWCOXBVBVCQVETVFVGVHVIB
      VNVOTVJVKVTVRWDAGWAVTWBWCAXAVTWCVSJABVSVLAVPPQVMVQ $.

    $( If the relation in a strict order is a set, then the base field is also
       a set.  (Contributed by Mario Carneiro, 27-Apr-2015.) $)
    soex $p |- ( ( R Or A /\ R e. V ) -> A e. _V ) $=
      ( vx wor wcel wa cvv c0 wceq simpr 0ex syl6eqel wne cv wex cun unexg wss
      n0 csn cdm snex dmexg rnexg syl2anc sylancr ad2antlr cdif sossfld adantlr
      crn ssundif sylibr ssexd ex exlimdv imp sylan2b pm2.61dane ) ABEZBCFZGZAH
      FZAIVCAIJZGAIHVCVEKLMAINVCDOZAFZDPZVDDATVCVHVDVCVGVDDVCVGVDVCVGGZAVFUAZBU
      BZBULZQZQZHVBVNHFZVAVGVBVJHFVMHFZVOVFUCVBVKHFVLHFVPBCUDBCUEVKVLHHRUFVJVMH
      HRUGUHVIAVJUIVMSZAVNSVAVGVQVBAVFBUJUKAVJVMUMUNUOUPUQURUSUT $.
  $}

  ${
    $d x y R $.
    $( The set of all ordered pairs in a class is the same as the double
       converse.  (Contributed by Mario Carneiro, 16-Aug-2015.) $)
    cnvcnv3 $p |- `' `' R = { <. x , y >. | x R y } $=
      ( ccnv cv wbr copab df-cnv vex brcnv opabbii eqtri ) CDZDBEZAEZMFZABGONCF
      ZABGABMHPQABNOCBIAIJKL $.

    $( Alternate definition of relation.  Exercise 2 of [TakeutiZaring] p. 25.
       (Contributed by NM, 29-Dec-1996.) $)
    dfrel2 $p |- ( Rel R <-> `' `' R = R ) $=
      ( vx vy wrel ccnv wceq relcnv cv cop wcel vex opelcnv bitri eqrelriv mpan
      releq mpbii impbii ) ADZAEZEZAFZUADZSUBTGZBCUAABHZCHZIZUAJUFUEITJUGAJUEUF
      TBKZCKZLUFUEAUIUHLMNOUBUCSUDUAAPQR $.

    $( A relation can be expressed as the set of ordered pairs in it.  An
       analogue of ~ dffn5 for relations.  (Contributed by Mario Carneiro,
       16-Aug-2015.) $)
    dfrel4v $p |- ( Rel R <-> R = { <. x , y >. | x R y } ) $=
      ( wrel ccnv wceq cv wbr copab dfrel2 eqcom cnvcnv3 eqeq2i 3bitri ) CDCEEZ
      CFCOFCAGBGCHABIZFCJOCKOPCABCLMN $.
  $}

  $( The double converse of a class strips out all elements that are not
     ordered pairs.  (Contributed by NM, 8-Dec-2003.) $)
  cnvcnv $p |- `' `' A = ( A i^i ( _V X. _V ) ) $=
    ( ccnv cvv cxp cin wceq wrel relcnv df-rel mpbi relxp dfrel2 sseqtr4i cnvin
    wss dfss cnveqi inss2 mpbir eqtr3i 3eqtr2i ) ABZBZUCCCDZBZBZEZUBUEEZBZAUDEZ
    UCUFOUCUGFUCUDUFUCGUCUDOUBHUCIJUDGUFUDFCCKUDLJMUCUFPJUBUENUJBZBZUIUJUKUHAUD
    NQUJGZULUJFUMUJUDOAUDRUJISUJLJTUA $.

  $( The double converse of a class equals its restriction to the universe.
     (Contributed by NM, 8-Oct-2007.) $)
  cnvcnv2 $p |- `' `' A = ( A |` _V ) $=
    ( ccnv cvv cxp cin cres cnvcnv df-res eqtr4i ) ABBACCDEACFAGACHI $.

  $( The double converse of a class is a subclass.  Exercise 2 of
     [TakeutiZaring] p. 25.  (Contributed by NM, 23-Jul-2004.) $)
  cnvcnvss $p |- `' `' A C_ A $=
    ( ccnv cvv cxp cin cnvcnv inss1 eqsstri ) ABBACCDZEAAFAIGH $.

  $( Equality theorem for converse.  (Contributed by FL, 19-Sep-2011.) $)
  cnveqb $p |- ( ( Rel A /\ Rel B ) -> ( A = B <-> `' A = `' B ) ) $=
    ( wrel wa wceq ccnv cnveq wi dfrel2 eqeq2 syl5ibr eqcoms sylbi eqeq1 imbi2d
    imp impbid2 ) ACZBCZDABEZAFZBFZEZABGRSUCTHZRUAFZAESUDHZAIUFAUESUDAUEEZUCUEB
    EZHZSUBFZBEUIBIUIBUJUCUHBUJEUEUJEUAUBGBUJUEJKLMUGTUHUCAUEBNOKLMPQ $.

  $( A relation empty iff its converse is empty.  (Contributed by FL,
     19-Sep-2011.) $)
  cnveq0 $p |- ( Rel A -> ( A = (/) <-> `' A = (/) ) ) $=
    ( c0 ccnv wceq wrel wb wi cnv0 rel0 cnveqb mpan2 eqeq2 bibi2d syl5ibr ax-mp
    eqcoms ) BCZBDAEZABDZACZBDZFZGZHUCBQRUBBQDZSTQDZFZRBEUFIABJKUDUAUESBQTLMNPO
    $.

  $( Alternate definition of relation.  (Contributed by NM, 14-May-2008.) $)
  dfrel3 $p |- ( Rel R <-> ( R |` _V ) = R ) $=
    ( wrel ccnv wceq cvv cres dfrel2 cnvcnv2 eqeq1i bitri ) ABACCZADAEFZADAGKLA
    AHIJ $.

  $( The domain of a universal restriction.  (Contributed by NM,
     14-May-2008.) $)
  dmresv $p |- dom ( A |` _V ) = dom A $=
    ( cvv cres cdm cin dmres incom inv1 3eqtri ) ABCDBADZEJBEJABFBJGJHI $.

  $( The range of a universal restriction.  (Contributed by NM,
     14-May-2008.) $)
  rnresv $p |- ran ( A |` _V ) = ran A $=
    ( ccnv crn cvv cres cnvcnv2 rneqi rncnvcnv eqtr3i ) ABBZCADEZCACJKAFGAHI $.

  $( Range defined in terms of image.  (Contributed by NM, 14-May-2008.) $)
  dfrn4 $p |- ran A = ( A " _V ) $=
    ( cvv cima cres crn df-ima rnresv eqtr2i ) ABCABDEAEABFAGH $.

  $( Distribute proper substitution through the range of a class.  (Contributed
     by Alan Sare, 10-Nov-2012.) $)
  csbrn $p |- [_ A / x ]_ ran B = ran [_ A / x ]_ B $=
    ( cvv cima csb crn csbima12 wcel wceq csbconstg imaeq2d wn c0 eqcomi csbprc
    0ima imaeq1d syl6eq dfrn4 3eqtr4a pm2.61i eqtri csbeq2i 3eqtr4i ) ABCDEZFZA
    BCFZDEZABCGZFUHGUGUHABDFZEZUIABDCHBDIZULUIJUMUKDUHABDDKLUMMZNNDEZULUIUONDQO
    UNULNUKENUNUHNUKABCPZRUKQSUNUHNDUPRUAUBUCABUJUFCTUDUHTUE $.

  ${
    $d A w y $.  $d B w y $.  $d V w y $.  $d x w y $.
    $( Distribute proper substitution through the range of a class.
       (Contributed by Alan Sare, 10-Nov-2012.)  Obsolete as of 23-Aug-2018.
       Use ~ csbrn instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbrngOLD $p |- ( A e. V -> [_ A / x ]_ ran B = ran [_ A / x ]_ B ) $=
      ( vw vy wcel cv cop wex cab csb crn csbabgOLD sbcexgOLD sbcel2gOLD exbidv
      wsbc bitrd dfrn3 abbidv eqtrd csbeq2i 3eqtr4g ) BDGZABEHFHIZCGZEJZFKZLZUF
      ABCLZGZEJZFKZABCMZLUKMUEUJUHABRZFKUNUHAFBDNUEUPUMFUEUPUGABRZEJUMUGEABDOUE
      UQULEABUFCDPQSUAUBABUOUIEFCTUCEFUKTUD $.
  $}

  $( The restriction of the double converse of a class.  (Contributed by NM,
     8-Apr-2007.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  rescnvcnv $p |- ( `' `' A |` B ) = ( A |` B ) $=
    ( ccnv cres cvv cin cnvcnv2 reseq1i resres wss wceq ssv sseqin2 mpbi 3eqtri
    reseq2i ) ACCZBDAEDZBDAEBFZDABDQRBAGHAEBISBABEJSBKBLBEMNPO $.

  $( The double converse of the restriction of a class.  (Contributed by NM,
     3-Jun-2007.) $)
  cnvcnvres $p |- `' `' ( A |` B ) = ( `' `' A |` B ) $=
    ( cres ccnv wrel wceq relres dfrel2 mpbi rescnvcnv eqtr4i ) ABCZDDZLADDBCLE
    MLFABGLHIABJK $.

  $( The image of the double converse of a class.  (Contributed by NM,
     8-Apr-2007.) $)
  imacnvcnv $p |- ( `' `' A " B ) = ( A " B ) $=
    ( ccnv cres crn cima rescnvcnv rneqi df-ima 3eqtr4i ) ACCZBDZEABDZEKBFABFLM
    ABGHKBIABIJ $.

  ${
    $d x y A $.
    $( The domain of a singleton is nonzero iff the singleton argument is an
       ordered pair.  (Contributed by NM, 14-Dec-2008.)  (Proof shortened by
       Andrew Salmon, 27-Aug-2011.) $)
    dmsnn0 $p |- ( A e. ( _V X. _V ) <-> dom { A } =/= (/) ) $=
      ( vx vy cv cop wceq wex csn cdm wcel cvv cxp wne wbr vex eldm df-br exbii
      c0 opex elsnc eqcom 3bitri bitr2i elvv n0 3bitr4i ) ABDZCDZEZFZCGZBGUHAHZ
      IZJZBGAKKLJUNSMULUOBUOUHUIUMNZCGULCUHUMBOPUPUKCUPUJUMJUJAFUKUHUIUMQUJAUHU
      ITUAUJAUBUCRUDRBCAUEBUNUFUG $.
  $}

  $( The range of a singleton is nonzero iff the singleton argument is an
     ordered pair.  (Contributed by NM, 14-Dec-2008.) $)
  rnsnn0 $p |- ( A e. ( _V X. _V ) <-> ran { A } =/= (/) ) $=
    ( cvv cxp wcel csn cdm c0 wne crn dmsnn0 dm0rn0 necon3bii bitri ) ABBCDAEZF
    ZGHNIZGHAJOGPGNKLM $.

  $( The domain of the singleton of the empty set is empty.  (Contributed by
     NM, 30-Jan-2004.) $)
  dmsn0 $p |- dom { (/) } = (/) $=
    ( c0 csn cdm wceq cvv cxp wcel wn 0nelxp dmsnn0 necon2bbii mpbir ) ABCZADAE
    EFGZHEEINMAAJKL $.

  $( The converse of the singleton of the empty set is empty.  (Contributed by
     Mario Carneiro, 30-Aug-2015.) $)
  cnvsn0 $p |- `' { (/) } = (/) $=
    ( c0 csn ccnv wceq crn dfdm4 dmsn0 eqtr3i wrel wb relcnv relrn0 ax-mp mpbir
    cdm ) ABZCZADZQEZADZPOSAPFGHQIRTJPKQLMN $.

  $( The domain of a singleton is empty if the singleton's argument contains
     the empty set.  (Contributed by NM, 15-Dec-2008.) $)
  dmsn0el $p |- ( (/) e. A -> dom { A } = (/) ) $=
    ( c0 wcel csn cdm wne cvv cxp wn dmsnn0 0nelelxp sylbir necon4ai ) BACZADEZ
    BOBFAGGHCNIAJGGAKLM $.

  ${
    relsn2.1 $e |- A e. _V $.
    $( A singleton is a relation iff it has a nonempty domain.  (Contributed by
       NM, 25-Sep-2013.) $)
    relsn2 $p |- ( Rel { A } <-> dom { A } =/= (/) ) $=
      ( csn wrel cvv cxp wcel cdm c0 wne relsn dmsnn0 bitri ) ACZDAEEFGNHIJABKA
      LM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x V $.
    $( The domain of a singleton of an ordered pair is the singleton of the
       first member.  (Contributed by Mario Carneiro, 26-Apr-2015.) $)
    dmsnopg $p |- ( B e. V -> dom { <. A , B >. } = { A } ) $=
      ( vx vy wcel cop csn cdm cv wceq wex vex opth1 exlimiv opeq1 opeq2 eqeq1d
      spcegv syl5 impbid2 eldm2 opex elsnc exbii bitri elsn 3bitr4g eqrdv ) BCF
      ZDABGZHZIZAHZUJDJZEJZGZUKKZELZUOAKZUOUMFZUOUNFUJUSUTURUTEUOUPABDMZEMNOUTU
      OBGZUKKZUJUSUOABPURVDEBCUPBKUQVCUKUPBUOQRSTUAVAUQULFZELUSEUOULVBUBVEUREUQ
      UKUOUPUCUDUEUFDAUGUHUI $.

    $( The domain of a singleton of an ordered pair is a subset of the
       singleton of the first member (with no sethood assumptions on ` B ` ).
       (Contributed by Mario Carneiro, 30-Apr-2015.) $)
    dmsnopss $p |- dom { <. A , B >. } C_ { A } $=
      ( cvv wcel cop csn cdm wss dmsnopg eqimss syl wn opprc2 sneqd dmeqd dmsn0
      wceq c0 syl6eq 0ss syl6eqss pm2.61i ) BCDZABEZFZGZAFZHZUCUFUGQUHABCIUFUGJ
      KUCLZUFRUGUIUFRFZGRUIUEUJUIUDRABMNOPSUGTUAUB $.

    $( The domain of an unordered pair of ordered pairs.  (Contributed by Mario
       Carneiro, 26-Apr-2015.) $)
    dmpropg $p |- ( ( B e. V /\ D e. W ) ->
        dom { <. A , B >. , <. C , D >. } = { A , C } ) $=
      ( wcel wa cop csn cdm cun cpr wceq dmsnopg uneq12 syl2an df-pr dmeqi dmun
      eqtri 3eqtr4g ) BEGZDFGZHABIZJZKZCDIZJZKZLZAJZCJZLZUEUHMZKZACMUCUGULNUJUM
      NUKUNNUDABEOCDFOUGULUJUMPQUPUFUILZKUKUOUQUEUHRSUFUITUAACRUB $.
  $}

  ${
    $d x y A $.  $d x y B $.
    dmsnop.1 $e |- B e. _V $.
    $( The domain of a singleton of an ordered pair is the singleton of the
       first member.  (Contributed by NM, 30-Jan-2004.)  (Proof shortened by
       Andrew Salmon, 27-Aug-2011.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    dmsnop $p |- dom { <. A , B >. } = { A } $=
      ( cvv wcel cop csn cdm wceq dmsnopg ax-mp ) BDEABFGHAGICABDJK $.

    dmprop.1 $e |- D e. _V $.
    $( The domain of an unordered pair of ordered pairs.  (Contributed by NM,
       13-Sep-2011.) $)
    dmprop $p |- dom { <. A , B >. , <. C , D >. } = { A , C } $=
      ( cvv wcel cop cpr cdm wceq dmpropg mp2an ) BGHDGHABICDIJKACJLEFABCDGGMN
      $.

    dmtpop.1 $e |- F e. _V $.
    $( The domain of an unordered triple of ordered pairs.  (Contributed by NM,
       14-Sep-2011.) $)
    dmtpop $p |- dom { <. A , B >. , <. C , D >. , <. E , F >. }
                        = { A , C , E } $=
      ( cop ctp cdm cpr csn cun df-tp dmeqi dmun dmprop dmsnop uneq12i 3eqtri
      eqtr4i ) ABJZCDJZEFJZKZLZACMZENZOZACEKUHUDUEMZUFNZOZLULLZUMLZOUKUGUNUDUEU
      FPQULUMRUOUIUPUJABCDGHSEFITUAUBACEPUC $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Double converse of a singleton of an ordered pair.  (Unlike ~ cnvsn ,
       this does not need any sethood assumptions on ` A ` and ` B ` .)
       (Contributed by Mario Carneiro, 26-Apr-2015.) $)
    cnvcnvsn $p |- `' `' { <. A , B >. } = `' { <. B , A >. } $=
      ( vx vy cop csn ccnv relcnv cv wcel vex opelcnv wceq wa opth 3bitr4i opex
      ancom elsnc bitri eqrelriiv ) CDABEZFZGZGZBAEZFZGZUDHUGHCIZDIZEZUEJUJUIEZ
      UDJZUKUHJZUIUJUDCKZDKZLUKUCJZULUGJZUMUNUKUBMZULUFMZUQURUIAMZUJBMZNVBVANUS
      UTVAVBRUIUJABUOUPOUJUIBAUPUOOPUKUBUIUJQSULUFUJUIQSPUJUIUCUPUOLUIUJUGUOUPL
      PTUA $.

    $( The domain of the singleton of the singleton of a singleton.
       (Contributed by NM, 15-Sep-2004.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    dmsnsnsn $p |- dom { { { A } } } = { A } $=
      ( vx cvv wcel csn cdm wceq cv cop vex opid sneq sneqd syl5eq dmeqd dmsnop
      eqeq12d vtoclg wn c0 0ex snid dmsn0el ax-mp snprc biimpi 3eqtr4a pm2.61i
      ) ACDZAEZEZEZFZUJGZBHZUOIZEZFZUOEZGUNBACUOAGZURUMUSUJUTUQULUTUPUKUTUPUSEU
      KUOBJZKUTUSUJUOALZMNMOVBQUOUOVAPRUISZTEZEZFZTUMUJTVDDVFTGTUAUBVDUCUDVCULV
      EVCUKVDVCUJTVCUJTGAUEUFZMMOVGUGUH $.
  $}

  $( The range of a singleton of an ordered pair is the singleton of the second
     member.  (Contributed by NM, 24-Jul-2004.)  (Revised by Mario Carneiro,
     30-Apr-2015.) $)
  rnsnopg $p |- ( A e. V -> ran { <. A , B >. } = { B } ) $=
    ( wcel cop csn crn cdm ccnv df-rn dfdm4 cnvcnvsn dmeqi 3eqtri eqtr4i syl5eq
    dmsnopg ) ACDABEFZGZBAEFZHZBFSRIZHZUARJUATIZGUDIZHUCTKUDJUEUBBALMNOBACQP $.

  ${
    $d x y A $.  $d x y B $.
    cnvsn.1 $e |- A e. _V $.
    $( The range of a singleton of an ordered pair is the singleton of the
       second member.  (Contributed by NM, 24-Jul-2004.)  (Revised by Mario
       Carneiro, 26-Apr-2015.) $)
    rnsnop $p |- ran { <. A , B >. } = { B } $=
      ( cvv wcel cop csn crn wceq rnsnopg ax-mp ) ADEABFGHBGICABDJK $.

    cnvsn.2 $e |- B e. _V $.
    $( Extract the first member of an ordered pair.  (See ~ op2nda to extract
       the second member, ~ op1stb for an alternate version, and ~ op1st for
       the preferred version.)  (Contributed by Raph Levien, 4-Dec-2003.) $)
    op1sta $p |- U. dom { <. A , B >. } = A $=
      ( cop csn cdm cuni dmsnop unieqi unisn eqtri ) ABEFGZHAFZHAMNABDIJACKL $.

    $( Converse of a singleton of an ordered pair.  (Contributed by NM,
       11-May-1998.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    cnvsn $p |- `' { <. A , B >. } = { <. B , A >. } $=
      ( cop csn ccnv cnvcnvsn wrel wceq relsnop dfrel2 mpbi eqtr3i ) BAEFZGGZAB
      EFGOBAHOIPOJBADCKOLMN $.

    $( Extract the second member of an ordered pair.  Theorem 5.12(ii) of
       [Monk1] p. 52.  (See ~ op1stb to extract the first member, ~ op2nda for
       an alternate version, and ~ op2nd for the preferred version.)
       (Contributed by NM, 25-Nov-2003.) $)
    op2ndb $p |- |^| |^| |^| `' { <. A , B >. } = B $=
      ( cop csn ccnv cint cnvsn inteqi opex intsn eqtri op1stb ) ABEFGZHZHZHBAE
      ZHZHBQSPRPRFZHROTABCDIJRBAKLMJJBADCNM $.

    $( Extract the second member of an ordered pair.  (See ~ op1sta to extract
       the first member, ~ op2ndb for an alternate version, and ~ op2nd for the
       preferred version.)  (Contributed by NM, 17-Feb-2004.)  (Proof shortened
       by Andrew Salmon, 27-Aug-2011.) $)
    op2nda $p |- U. ran { <. A , B >. } = B $=
      ( cop csn crn cuni rnsnop unieqi unisn eqtri ) ABEFGZHBFZHBMNABCIJBDKL $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Converse of a singleton of an ordered pair.  (Contributed by NM,
       23-Jan-2015.) $)
    cnvsng $p |- ( ( A e. V /\ B e. W ) ->
      `' { <. A , B >. } = { <. B , A >. } ) $=
      ( vx vy cv cop csn ccnv wceq opeq1 sneqd cnveqd opeq2 eqeq12d vex vtocl2g
      cnvsn ) EGZFGZHZIZJZUATHZIZKAUAHZIZJZUAAHZIZKABHZIZJZBAHZIZKEFABCDTAKZUDU
      IUFUKUQUCUHUQUBUGTAUALMNUQUEUJTAUAOMPUABKZUIUNUKUPURUHUMURUGULUABAOMNURUJ
      UOUABALMPTUAEQFQSR $.

    $( Swap the members of an ordered pair.  (Contributed by NM, 14-Dec-2008.)
       (Revised by Mario Carneiro, 30-Aug-2015.) $)
    opswap $p |- U. `' { <. A , B >. } = <. B , A >. $=
      ( cvv wcel wa cop csn ccnv cuni wceq cnvsng unieqd opex unisn syl6eq uni0
      wn c0 opprc sneqd cnveqd cnvsn0 ancom sylnbi 3eqtr4a pm2.61i ) ACDZBCDZEZ
      ABFZGZHZIZBAFZJUIUMUNGZIUNUIULUOABCCKLUNBAMNOUIQZRIRUMUNPUPULRUPULRGZHRUP
      UKUQUPUJRABSTUAUBOLUIUHUGEUNRJUGUHUCBASUDUEUF $.

    $( Membership in a cross product.  This version requires no quantifiers or
       dummy variables.  See also ~ elxp5 , ~ elxp6 , and ~ elxp7 .
       (Contributed by NM, 17-Feb-2004.) $)
    elxp4 $p |- ( A e. ( B X. C ) <-> ( A = <. U. dom { A } , U. ran { A } >.
                 /\ ( U. dom { A } e. B /\ U. ran { A } e. C ) ) ) $=
      ( vx vy wcel cv cop wceq wa wex csn cdm cuni crn sneq unieqd vex pm4.71ri
      syl6req elxp rneqd op2nda anbi1i anass bitri exbii snex rnex uniex eqeq2d
      opeq2 eleq1 anbi2d anbi12d ceqsexv dmeqd op1sta 3bitri dmex opeq1 anbi1d
      cxp ) ABCVCFADGZEGZHZIZVDBFZVECFZJZJZEKZDKVDALZMZNZIZAVDVMOZNZHZIZVHVRCFZ
      JZJZJZDKAVOVRHZIZVOBFZWAJZJZDEABCUAVLWDDVLWCVPVTJZWBJWDVLVEVRIZVKJZEKWCVK
      WLEVKWKVGJZVJJWLVGWMVJVGWKVGVRVFLZOZNVEVGVQWOVGVMWNAVFPUBQVDVEDRZERUCTSUD
      WKVGVJUEUFUGVKWCEVRVQVMAUHZUIUJZWKVGVTVJWBWKVFVSAVEVRVDULUKWKVIWAVHVEVRCU
      MUNUOUPUFVTWJWBVTVPVTVOVSLZMZNVDVTVNWTVTVMWSAVSPUQQVDVRWPWRURTSUDVPVTWBUE
      USUGWCWIDVOVNVMWQUTUJVPVTWFWBWHVPVSWEAVDVOVRVAUKVPVHWGWAVDVOBUMVBUOUPUS
      $.

    $( Membership in a cross product requiring no quantifiers or dummy
       variables.  Provides a slightly shorter version of ~ elxp4 when the
       double intersection does not create class existence problems (caused by
       ~ int0 ).  (Contributed by NM, 1-Aug-2004.) $)
    elxp5 $p |- ( A e. ( B X. C ) <-> ( A = <. |^| |^| A , U. ran { A } >.
                 /\ ( |^| |^| A e. B /\ U. ran { A } e. C ) ) ) $=
      ( vx vy wcel cv cop wceq wex cint csn crn cuni vex syl6req pm4.71ri eleq1
      wa cvv elxp sneq rneqd unieqd op2nda anbi1i anass bitri exbii uniex opeq2
      snex rnex eqeq2d anbi2d anbi12d ceqsexv inteq inteqd op1stb 3bitri adantr
      cxp mpbii exlimiv elex ad2antrl opeq1 anbi1d ceqsexgv pm5.21nii ) ABCVCFA
      DGZEGZHZIZVLBFZVMCFZSZSZEJZDJVLAKZKZIZAVLALZMZNZHZIZVPWFCFZSZSZSZDJZAWBWF
      HZIZWBBFZWISZSZDEABCUAVTWLDVTWKWCWHSZWJSWLVTVMWFIZVSSZEJWKVSXAEVSWTVOSZVR
      SXAVOXBVRVOWTVOWFVNLZMZNVMVOWEXDVOWDXCAVNUBUCUDVLVMDOZEOUEPQUFWTVOVRUGUHU
      IVSWKEWFWEWDAULUMUJZWTVOWHVRWJWTVNWGAVMWFVLUKUNWTVQWIVPVMWFCRUOUPUQUHWHWS
      WJWHWCWHWBWGKZKVLWHWAXGAWGURUSVLWFXEXFUTPQUFWCWHWJUGVAUIWMWBTFZWRWLXHDWCX
      HWKWCVLTFXHXEVLWBTRVDVBVEWPXHWOWIWBBVFVGWKWRDWBTWCWHWOWJWQWCWGWNAVLWBWFVH
      UNWCVPWPWIVLWBBRVIUPVJVKVA $.
  $}

  ${
    $d s t A $.  $d s t B $.  $d s t F $.
    $( An image under the converse of a restriction.  (Contributed by Jeff
       Hankins, 12-Jul-2009.) $)
    cnvresima $p |- ( `' ( F |` A ) " B ) = ( ( `' F " B ) i^i A ) $=
      ( vt vs cres ccnv cima cin cv cop wa wex vex elima3 anbi1i opelcnv bitr4i
      wcel bitri elin opelres anbi2i anass exbii 19.41v 3bitr4ri eqriv ) DCAFZG
      ZBHZCGZBHZAIZDJZUKSEJZBSZUPUOKZUJSZLZEMZUOUNSZEUOUJBDNZOUOUMSZUOASZLUQURU
      LSZLZEMZVELZVBVAVDVHVEEUOULBVCOPUOUMAUAVAVGVELZEMVIUTVJEUTUQVFVELZLVJUSVK
      UQUSUOUPKZUISZVKUPUOUIENZVCQVMVLCSZVELVKUOUPCAVNUBVFVOVEUPUOCVNVCQPRTUCUQ
      VFVEUDRUEVGVEEUFTUGTUH $.
  $}

  $( A class restricted to its domain equals its double converse.  (Contributed
     by NM, 8-Apr-2007.) $)
  resdm2 $p |- ( A |` dom A ) = `' `' A $=
    ( ccnv cdm cres rescnvcnv wrel relcnv resdm ax-mp dmcnvcnv reseq2i 3eqtr3ri
    wceq ) ABZBZOCZDZAPDOAACZDAPEOFQOMNGOHIPRAAJKL $.

  $( Restriction to the domain of a restriction.  (Contributed by NM,
     8-Apr-2007.) $)
  resdmres $p |- ( A |` dom ( A |` B ) ) = ( A |` B ) $=
    ( cres cdm ccnv cvv cxp in12 df-res resdm2 eqtr3i ineq2i incom 3eqtri dmres
    cin xpeq1i xpindir eqtri 3eqtr4i rescnvcnv ) AABCZDZCZAEEZBCZUBABFGZADZFGZP
    ZPZUEUGPZUDUFUKUGAUIPZPUGUEPULAUGUIHUMUEUGAUHCUMUEAUHIAJKLUGUEMNUDAUCFGZPUK
    AUCIUNUJAUNBUHPZFGUJUCUOFABOQBUHFRSLSUEBITABUAS $.

  $( The image of the domain of a restriction.  (Contributed by NM,
     8-Apr-2007.) $)
  imadmres $p |- ( A " dom ( A |` B ) ) = ( A " B ) $=
    ( cres cdm crn cima resdmres rneqi df-ima 3eqtr4i ) AABCZDZCZEKEALFABFMKABG
    HALIABIJ $.

  ${
    $d x y C $.  $d y A $.  $d y B $.  $d y F $.  $d x V $.
    dmmpt2.1 $e |- F = ( x e. A |-> B ) $.
    $( The preimage of a function in maps-to notation.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    mptpreima $p |- ( `' F " C ) = { x e. A | B e. C } $=
      ( vy ccnv cima cv wcel wceq wa copab crab eqtri crn wex cab bitri cnvopab
      cmpt df-mpt cnveqi imaeq1i df-ima resopab rneqi ancom anass exbii df-clel
      cres 19.42v bicomi anbi2i abbii rnopab df-rab 3eqtr4i ) EHZDIAJBKZGJZCLZM
      ZGANZDIZCDKZABOZVAVFDVAVEAGNZHVFEVJEABCUBVJFAGBCUCPUDVEAGUAPUEVGVFDUMZQZV
      IVFDUFVLVCDKZVEMZGANZQZVIVKVOVEGADUGUHVNGRZASVBVHMZASVPVIVQVRAVQVBVDVMMZM
      ZGRZVRVNVTGVNVEVMMVTVMVEUIVBVDVMUJTUKWAVBVSGRZMVRVBVSGUNWBVHVBVHWBGCDULUO
      UPTTUQVNGAURVHABUSUTPPP $.

    $( Converse singleton image of a function defined by maps-to.  (Contributed
       by Stefan O'Rear, 25-Jan-2015.) $)
    mptiniseg $p |- ( C e. V -> ( `' F " { C } ) = { x e. A | B = C } ) $=
      ( wcel ccnv csn cima crab wceq mptpreima elsnc2g rabbidv syl5eq ) DFHZEID
      JZKCSHZABLCDMZABLABCSEGNRTUAABCDFOPQ $.

    $( The domain of the mapping operation in general.  (Contributed by NM,
       16-May-1995.)  (Revised by Mario Carneiro, 22-Mar-2015.) $)
    dmmpt $p |- dom F = { x e. A | B e. _V } $=
      ( cdm ccnv crn cvv cima wcel crab dfdm4 dfrn4 mptpreima 3eqtri ) DFDGZHQI
      JCIKABLDMQNABCIDEOP $.

    $d x A $.
    $( The domain of a mapping is a subset of its base class.  (Contributed by
       Scott Fenton, 17-Jun-2013.) $)
    dmmptss $p |- dom F C_ A $=
      ( cdm cvv wcel crab dmmpt ssrab2 eqsstri ) DFCGHZABIBABCDEJMABKL $.
  $}

  ${
    $d A x y $.  $d B y $.
    $( The domain of the mapping operation is the stated domain, if the
       function value is always a set.  (Contributed by Mario Carneiro,
       9-Feb-2013.)  (Revised by Mario Carneiro, 14-Sep-2013.) $)
    dmmptg $p |- ( A. x e. A B e. V -> dom ( x e. A |-> B ) = A ) $=
      ( wcel wral cvv crab cmpt cdm wceq elex ralimi rabid2 eqid dmmpt syl6reqr
      sylibr ) CDEZABFZBCGEZABHZABCIZJTUAABFBUBKSUAABCDLMUAABNRABCUCUCOPQ $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.
    $( A composition is a relation.  Exercise 24 of [TakeutiZaring] p. 25.
       (Contributed by NM, 26-Jan-1997.) $)
    relco $p |- Rel ( A o. B ) $=
      ( vx vz vy cv wbr wa wex ccom df-co relopabi ) CFDFZBGMEFAGHDICEABJCEDABK
      L $.

    $( Alternate definition of a class composition, using only one bound
       variable.  (Contributed by NM, 19-Dec-2008.) $)
    dfco2 $p |- ( A o. B )
                = U_ x e. _V ( ( `' B " { x } ) X. ( A " { x } ) ) $=
      ( vy vz ccom cvv ccnv cv csn cima cxp wrel wcel cop wex vex elimasn bitri
      wa ciun relco reliun relxp a1i mprgbir wb opelco2g mp2an wrex rexv opelxp
      eliun opelcnv anbi12i exbii 3bitrri eqrelriiv ) DEBCFZAGCHZAIZJZKZBVBKZLZ
      UAZBCUBVFMVEMZAGAGVEUCVGVAGNVCVDUDUEUFDIZEIZOZUSNZVHVAOCNZVAVIOBNZTZAPZVJ
      VFNZVHGNVIGNVKVOUGDQZEQZAVHVIBCGGUHUIVPVJVENZAGUJVSAPVOAVJGVEUMVSAUKVSVNA
      VSVHVCNZVIVDNZTVNVHVIVCVDULVTVLWAVMVTVAVHOUTNVLUTVAVHAQZVQRVAVHCWBVQUNSBV
      AVIWBVRRUOSUPUQSUR $.

    $( Generalization of ~ dfco2 , where ` C ` can have any value between
       ` dom A i^i ran B ` and ` _V ` .  (Contributed by NM, 21-Dec-2008.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    dfco2a $p |- ( ( dom A i^i ran B ) C_ C -> ( A o. B )
         = U_ x e. C ( ( `' B " { x } ) X. ( A " { x } ) ) ) $=
      ( vy vz vw cvv cv cima ciun wcel wrex wex wa cop vex sylbi 3bitr4g eliun
      cdm crn cin wss ccom ccnv csn cxp dfco2 wceq wbr wb eliniseg ax-mp brelrn
      elimasn opeldm anim12ci adantl exlimivv elxp elin 3imtr4i pm4.71rd exbidv
      ssel syl5 rexv df-rex eqrdv syl5eq ) BUAZCUBZUCZDUDZBCUEAHCUFAIZUGZJZBVQJ
      ZUHZKZADVTKZABCUIVOEWAWBVOEIZVTLZAHMZWDADMZWCWALWCWBLVOWDANVPDLZWDOZANWEW
      FVOWDWHAVOWDWGWDVPVNLZVOWGWCFIZGIZPUJZWJVRLZWKVSLZOZOZGNFNVPVLLZVPVMLZOZW
      DWIWPWSFGWOWSWLWMWRWNWQWMWJVPCUKZWRVPHLWMWTULAQZCVPWJHFQZUMUNWJVPCXBXAUOR
      WNVPWKPBLWQBVPWKXAGQZUPVPWKBXAXCUQRURUSUTFGWCVRVSVAVPVLVMVBVCVNDVPVFVGVDV
      EWDAVHWDADVISAWCHVTTAWCDVTTSVJVK $.

    $( Class composition distributes over union.  (Contributed by NM,
       21-Dec-2008.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    coundi $p |- ( A o. ( B u. C ) ) = ( ( A o. B ) u. ( A o. C ) ) $=
      ( vx vz vy cv wbr wa wex copab cun ccom wo unopab brun anbi1i andir bitri
      df-co exbii 19.43 bitr2i opabbii eqtri uneq12i 3eqtr4ri ) DGZEGZBHZUIFGAH
      ZIZEJZDFKZUHUICHZUKIZEJZDFKZLZUHUIBCLZHZUKIZEJZDFKZABMZACMZLAUTMUSUMUQNZD
      FKVDUMUQDFOVGVCDFVCULUPNZEJVGVBVHEVBUJUONZUKIVHVAVIUKUHUIBCPQUJUOUKRSUAUL
      UPEUBUCUDUEVEUNVFURDFEABTDFEACTUFDFEAUTTUG $.

    $( Class composition distributes over union.  (Contributed by NM,
       21-Dec-2008.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    coundir $p |- ( ( A u. B ) o. C ) = ( ( A o. C ) u. ( B o. C ) ) $=
      ( vx vy vz cv wbr wa wex copab cun ccom wo unopab brun anbi2i bitri df-co
      andi exbii 19.43 bitr2i opabbii eqtri uneq12i 3eqtr4ri ) DGEGZCHZUHFGZAHZ
      IZEJZDFKZUIUHUJBHZIZEJZDFKZLZUIUHUJABLZHZIZEJZDFKZACMZBCMZLUTCMUSUMUQNZDF
      KVDUMUQDFOVGVCDFVCULUPNZEJVGVBVHEVBUIUKUONZIVHVAVIUIUHUJABPQUIUKUOTRUAULU
      PEUBUCUDUEVEUNVFURDFEACSDFEBCSUFDFEUTCSUG $.

    $( Restricted first member of a class composition.  (Contributed by NM,
       12-Oct-2004.)  (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
    cores $p |- ( ran B C_ C -> ( ( A |` C ) o. B ) = ( A o. B ) ) $=
      ( vz vy vx crn wss cv wbr cres wa wex copab ccom wcel wb vex brelrn df-co
      ssel brres rbaib syl56 pm5.32d exbidv opabbidv 3eqtr4g ) BGZCHZDIZEIZBJZU
      LFIZACKZJZLZEMZDFNUMULUNAJZLZEMZDFNUOBOABOUJURVADFUJUQUTEUJUMUPUSUMULUIPU
      JULCPZUPUSQUKULBDRERSUICULUAUPUSVBULUNACFRUBUCUDUEUFUGDFEUOBTDFEABTUH $.

    $( Associative law for the restriction of a composition.  (Contributed by
       NM, 12-Dec-2006.) $)
    resco $p |- ( ( A o. B ) |` C ) = ( A o. ( B |` C ) ) $=
      ( vx vy vz ccom cres relres relco cv wbr wcel wex vex anbi1i 19.41v brres
      wa brco an32 bitr4i exbii 3bitr2i 3bitr4i eqbrriv ) DEABGZCHZABCHZGZUGCIA
      UIJDKZEKZUGLZUKCMZSZUKFKZUILZUPULALZSZFNZUKULUHLUKULUJLUOUKUPBLZURSZFNZUN
      SVBUNSZFNUTUMVCUNFUKULABDOZEOZTPVBUNFQVDUSFVDVAUNSZURSUSVAURUNUAUQVGURUKU
      PBCFORPUBUCUDUKULUGCVFRFUKULAUIVEVFTUEUF $.

    $( Image of the composition of two classes.  (Contributed by Jason
       Orendorff, 12-Dec-2006.) $)
    imaco $p |- ( ( A o. B ) " C ) = ( A " ( B " C ) ) $=
      ( vx vy vz ccom cima cv wbr wrex wcel wa wex df-rex vex elima exbii bitri
      rexcom4 r19.41v brco rexbii anbi1i 3bitr4i 3bitr4ri eqriv ) DABGZCHZABCHZ
      HZEIZDIZAJZEUJKULUJLZUNMZENZUMUKLUMUILZUNEUJOEUMAUJDPZQFIZULBJZUNMZENZFCK
      ZVAFCKZUNMZENZURUQVDVBFCKZENVGVBFECTVHVFEVAUNFCUARSURUTUMUHJZFCKVDFUMUHCU
      SQVIVCFCEUTUMABFPUSUBUCSUPVFEUOVEUNFULBCEPQUDRUEUFUG $.

    $( The range of the composition of two classes.  (Contributed by NM,
       12-Dec-2006.) $)
    rnco $p |- ran ( A o. B ) = ran ( A |` ran B ) $=
      ( vy vx vz ccom crn cres cv wbr wex wcel wa vex exbii excom ancom 3bitr4i
      brco elrn 19.41v anbi2i brres bitr4i 3bitri eqriv ) CABFZGZABGZHZGZDIZCIZ
      UGJZDKZEIZUMUJJZEKZUMUHLUMUKLUOULUPBJZUPUMAJZMZEKZDKVADKZEKURUNVBDEULUMAB
      DNCNZSOVADEPVCUQEVCUTUPUILZMZUQUSDKZUTMUTVGMVCVFVGUTQUSUTDUAVEVGUTDUPBENT
      UBRUPUMAUIVDUCUDOUEDUMUGVDTEUMUJVDTRUF $.
  $}

  $( The range of the composition of two classes.  (Contributed by NM,
     27-Mar-2008.) $)
  rnco2 $p |- ran ( A o. B ) = ( A " ran B ) $=
    ( ccom crn cres cima rnco df-ima eqtr4i ) ABCDABDZEDAJFABGAJHI $.

  $( The domain of a composition.  Exercise 27 of [Enderton] p. 53.
     (Contributed by NM, 4-Feb-2004.) $)
  dmco $p |- dom ( A o. B ) = ( `' B " dom A ) $=
    ( ccom cdm ccnv crn cima dfdm4 cnvco rneqi rnco2 imaeq2i eqtr4i 3eqtri ) AB
    CZDOEZFBEZAEZCZFZQADZGZOHPSABIJTQRFZGUBQRKUAUCQAHLMN $.

  ${
    $d w x y z A $.  $d w y z B $.  $d w y z C $.
    $( Composition with an indexed union.  (Contributed by NM, 21-Dec-2008.) $)
    coiun $p |- ( A o. U_ x e. C B ) = U_ x e. C ( A o. B ) $=
      ( vy vz vw ciun ccom relco wrel cv wcel wbr wa wex wrex cop eliun df-br
      reliun a1i mprgbir rexbii 3bitr4i anbi1i r19.41v bitr4i exbii rexcom4 vex
      opelco bitri eqrelriiv ) EFBADCHZIZADBCIZHZBUOJURKUQKZADADUQUAUSALDMBCJUB
      UCELZGLZUONZVAFLZBNZOZGPZUTVACNZVDOZGPZADQZUTVCRZUPMVKURMZVFVHADQZGPVJVEV
      MGVEVGADQZVDOVMVBVNVDUTVARZUOMVOCMZADQVBVNAVODCSUTVAUOTVGVPADUTVACTUDUEUF
      VGVDADUGUHUIVHAGDUJUHGUTVCBUOEUKZFUKZULVLVKUQMZADQVJAVKDUQSVSVIADGUTVCBCV
      QVRULUDUMUEUN $.
  $}

  $( A composition is not affected by a double converse of its first argument.
     (Contributed by NM, 8-Oct-2007.) $)
  cocnvcnv1 $p |- ( `' `' A o. B ) = ( A o. B ) $=
    ( ccnv ccom cvv cres cnvcnv2 coeq1i crn wss wceq ssv cores ax-mp eqtri ) AC
    CZBDAEFZBDZABDZPQBAGHBIZEJRSKTLABEMNO $.

  $( A composition is not affected by a double converse of its second
     argument.  (Contributed by NM, 8-Oct-2007.) $)
  cocnvcnv2 $p |- ( A o. `' `' B ) = ( A o. B ) $=
    ( ccnv ccom cres cnvcnv2 coeq2i resco wrel wceq relco dfrel3 mpbi 3eqtr2i
    cvv ) ABCCZDABOEZDABDZOEZRPQABFGABOHRISRJABKRLMN $.

  $( Absorption of a reverse (preimage) restriction of the second member of a
     class composition.  (Contributed by NM, 11-Dec-2006.) $)
  cores2 $p |- ( dom A C_ C -> ( A o. `' ( `' B |` C ) ) = ( A o. B ) ) $=
    ( cdm wss ccnv cres ccom wceq dfdm4 sseq1i cores sylbi cnvco cocnvcnv1 wrel
    crn relco dfrel2 mpbi eqtri 3eqtr4g cnveqd 3eqtr3g ) ADZCEZABFZCGZFZHZFZFZA
    BHZFZFZUJUMUFUKUNUFUHAFZHZUGUPHZUKUNUFUPQZCEUQURIUEUSCAJKUGUPCLMUKUIFUPHUQA
    UINUHUPOUAABNUBUCUJPULUJIAUIRUJSTUMPUOUMIABRUMSTUD $.

  ${
    $d x y z A $.
    $( Composition with the empty set.  Theorem 20 of [Suppes] p. 63.
       (Contributed by NM, 24-Apr-2004.) $)
    co02 $p |- ( A o. (/) ) = (/) $=
      ( vx vy vz c0 ccom relco rel0 cv cop wcel wbr wa noel df-br mtbir intnanr
      wex nex vex opelco 2false eqrelriiv ) BCAEFZEAEGHBIZCIZJZUDKZUGEKUHUEDIZE
      LZUIUFALZMZDRULDUJUKUJUEUIJZEKUMNUEUIEOPQSDUEUFAEBTCTUAPUGNUBUC $.

    $( Composition with the empty set.  (Contributed by NM, 24-Apr-2004.) $)
    co01 $p |- ( (/) o. A ) = (/) $=
      ( c0 ccnv ccom cnv0 cnvco coeq2i co02 3eqtri eqtr4i cnveqi wrel wceq rel0
      dfrel2 mpbi relco 3eqtr3ri ) BCZCZBADZCZCZBUASUBSBUBEUBACZSDUDBDBBAFSBUDE
      GUDHIJKBLTBMNBOPUALUCUAMBAQUAOPR $.

    $( Composition with the identity relation.  Part of Theorem 3.7(i) of
       [Monk1] p. 36.  (Contributed by NM, 22-Apr-2004.) $)
    coi1 $p |- ( Rel A -> ( A o. _I ) = A ) $=
      ( vx vy vz cid ccom wrel wceq relco cv cop wcel wbr wex vex opelco equcom
      wa ideq bitri anbi1i exbii breq1 ceqsexv df-br eqrelriv mpan ) AEFZGAGUHA
      HAEIBCUHABJZCJZKZUHLZUIUJAMZUKALULUIDJZEMZUNUJAMZRZDNZUMDUIUJAEBOZCOPURUN
      UIHZUPRZDNUMUQVADUOUTUPUOUIUNHUTUIUNDOSBDQTUAUBUPUMDUIUSUNUIUJAUCUDTTUIUJ
      AUETUFUG $.

    $( Composition with the identity relation.  Part of Theorem 3.7(i) of
       [Monk1] p. 36.  (Contributed by NM, 22-Apr-2004.) $)
    coi2 $p |- ( Rel A -> ( _I o. A ) = A ) $=
      ( wrel ccnv ccom cnvco wceq relcnv ax-mp cnveqi eqtr3i dfrel2 coeq2 coeq1
      cid coi1 cnvi sylan9eq mpan2 sylbi biimpi 3eqtr3a ) ABZNCZACZCZDZUENADZAU
      DNDZCUFUEUDNEUHUDUDBUHUDFAGUDOHIJUBUEAFZUFUGFZAKZUIUCNFZUJPUIULUFUCADUGUE
      AUCLUCNAMQRSUBUIUKTUA $.
  $}

  $( Composition with a restricted identity relation.  (Contributed by FL,
     19-Jun-2011.)  (Revised by Stefan O'Rear, 7-Mar-2015.) $)
  coires1 $p |- ( A o. ( _I |` B ) ) = ( A |` B ) $=
    ( ccnv cres ccom cocnvcnv1 wrel wceq relcnv coi1 ax-mp eqtr3i reseq1i resco
    cid rescnvcnv ) ACZCZBDZAOBDEZABDAOEZBDSTUARBROEZUARAOFRGUBRHQIRJKLMAOBNLAB
    PL $.

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.
    $( Associative law for class composition.  Theorem 27 of [Suppes] p. 64.
       Also Exercise 21 of [Enderton] p. 53.  Interestingly, this law holds for
       any classes whatsoever, not just functions or even relations.
       (Contributed by NM, 27-Jan-1997.) $)
    coass $p |- ( ( A o. B ) o. C ) = ( A o. ( B o. C ) ) $=
      ( vx vy vz vw ccom relco cv wbr wa wex cop wcel brco exbii opelco 3bitr4i
      vex excom anass 2exbii bitr4i anbi2i exdistr anbi1i 19.41v eqrelriiv ) DE
      ABHZCHZABCHZHZUJCIAULIDJZFJZCKZUOGJZBKZUQEJZAKZLZLZGMFMZUPURLZUTLZFMZGMZU
      NUSNZUKOZVHUMOZVCVBFMGMVGVBFGUAVEVBGFUPURUTUBUCUDUPUOUSUJKZLZFMUPVAGMZLZF
      MVIVCVLVNFVKVMUPGUOUSABFTETZPUEQFUNUSUJCDTZVORUPVAFGUFSUNUQULKZUTLZGMVDFM
      ZUTLZGMVJVGVRVTGVQVSUTFUNUQBCVPGTPUGQGUNUSAULVPVORVFVTGVDUTFUHQSSUI $.
  $}

  $( A relation is transitive iff its converse is transitive.  (Contributed by
     FL, 19-Sep-2011.) $)
  relcnvtr $p |- ( Rel R ->
     ( ( R o. R ) C_ R <-> ( `' R o. `' R ) C_ `' R ) ) $=
    ( wrel ccom wss ccnv cnvco cnvss syl5eqssr wceq wi sseq1 dfrel2 coeq1 coeq2
    eqtrd id sseq12d biimpd sylbi com12 syl6bi mpsyl impbid2 ) ABZAACZADZAEZUGC
    ZUGDZUFUHUEEUGAAFUEAGHUIUDUFUHEZUGEZUKCZIZUIUJUKDZUDUFJZUGUGFUHUGGUMUNULUKD
    ZUOUJULUKKUDUPUFUDUKAIZUPUFJALUQUPUFUQULUEUKAUQULAUKCUEUKAUKMUKAANOUQPQRSTU
    AUBTUC $.

  ${
    $d x y A $.
    $( A relation is included in the cross product of its domain and range.
       Exercise 4.12(t) of [Mendelson] p. 235.  (Contributed by NM,
       3-Aug-1994.) $)
    relssdmrn $p |- ( Rel A -> A C_ ( dom A X. ran A ) ) $=
      ( vx vy wrel cdm crn cxp id cv cop wi wex 19.8a wa opelxp vex eldm2 elrn2
      wcel anbi12i bitri sylanbrc a1i relssdv ) ADZBCAAEZAFZGZUEHBIZCIZJZASZUKU
      HSZKUEULULCLZULBLZUMULCMULBMUMUIUFSZUJUGSZNUNUONUIUJUFUGOUPUNUQUOCUIABPQB
      UJACPRTUAUBUCUD $.
  $}

  $( The converse is a subset of the cartesian product of range and domain.
     (Contributed by Mario Carneiro, 2-Jan-2017.) $)
  cnvssrndm $p |- `' A C_ ( ran A X. dom A ) $=
    ( ccnv cdm crn cxp wrel relcnv relssdmrn ax-mp df-rn dfdm4 xpeq12i sseqtr4i
    wss ) ABZOCZODZEZADZACZEOFORNAGOHISPTQAJAKLM $.

  $( Composition as a subset of the cross product of factors.  (Contributed by
     Mario Carneiro, 12-Jan-2017.) $)
  cossxp $p |- ( A o. B ) C_ ( dom B X. ran A ) $=
    ( ccom cdm crn cxp wrel wss relco relssdmrn ax-mp dmcoss rncoss mp2an sstri
    xpss12 ) ABCZQDZQEZFZBDZAEZFZQGQTHABIQJKRUAHSUBHTUCHABLABMRUASUBPNO $.

  $( Two ways to describe the structure of a two-place operation.  (Contributed
     by NM, 17-Dec-2008.) $)
  relrelss $p |- ( ( Rel A /\ Rel dom A ) <-> A C_ ( ( _V X. _V ) X. _V ) ) $=
    ( wrel cdm wa cvv cxp wss df-rel anbi2i crn relssdmrn xpss12 mpan2 sylan9ss
    ssv xpss sstr sylibr dmss c0 wne wceq vn0 dmxp ax-mp syl6sseq impbii bitri
    jca ) ABZACZBZDUJUKEEFZGZDZAUMEFZGZULUNUJUKHIUOUQUJUNAUKAJZFZUPAKUNUREGUSUP
    GUROUKUMURELMNUQUJUNUQAUMGZUJUQUPUMGUTUMEPAUPUMQMAHRUQUKUPCZUMAUPSETUAVAUMU
    BUCUMEUDUEUFUIUGUH $.

  ${
    $d x y A $.  $d x y R $.
    $( The membership relation for a relation is inherited by class union.
       (Contributed by NM, 17-Sep-2006.) $)
    unielrel $p |- ( ( Rel R /\ A e. R ) -> U. A e. U. R ) $=
      ( vx vy wrel wcel wa cv cop wceq wex elrel simpr wi vex uniopel a1i eleq1
      cuni unieq eleq1d 3imtr4d exlimivv sylc ) BEZABFZGACHZDHZIZJZDKCKUFASZBSZ
      FZCDABLUEUFMUJUFUMNCDUJUIBFZUISZULFZUFUMUNUPNUJUGUHBCODOPQAUIBRUJUKUOULAU
      ITUAUBUCUD $.
  $}

  $( The double union of a relation is its field.  (Contributed by NM,
     17-Sep-2006.) $)
  relfld $p |- ( Rel R -> U. U. R = ( dom R u. ran R ) ) $=
    ( wrel cuni cdm crn cun cxp wss relssdmrn 3syl unixpss syl6ss dmrnssfld a1i
    uniss eqssd ) ABZACZCZADZAEZFZQSTUAGZCZCZUBQAUCHRUDHSUEHAIAUCORUDOJTUAKLUBS
    HQAMNP $.

  $( Restriction of a relation to its field.  (Contributed by FL,
     15-Apr-2012.) $)
  relresfld $p |- ( Rel R -> ( R |` U. U. R ) = R ) $=
    ( wrel cuni cres wceq cdm crn wi relfld reseq2d resundi wa eqtr resss resdm
    cun wss ssequn2 uneq1 eqeq2d ex syl6bi com3r sylbi syl5com sylancl pm2.43i
    mpsyl ) ABZAACCZDZAEZUIUKAAFZAGZPZDZEZUPAUMDZAUNDZPZEZUIULHUIUJUOAAIJAUMUNK
    UQVALUKUTEZUIULUKUPUTMUSAQZUIURAEZVBULHZAUNNAOVCAUSPZAEZVDVEHUSARVDVBVGULVD
    VBUKVFEZVGULHVDUTVFUKURAUSSTVHVGULUKVFAMUAUBUCUDUHUEUFUG $.

  $( Composition with the identity relation restricted to a relation's field.
     (Contributed by FL, 2-May-2011.) $)
  relcoi2 $p |- ( Rel R -> ( ( _I |` U. U. R ) o. R ) = R ) $=
    ( wrel cid cuni cres ccom crn wss wceq cdm cun dmrnssfld simpr sylbir ax-mp
    wa unss cores mp1i coi2 eqtrd ) ABZCADDZEAFZCAFZAAGZUCHZUDUEIUBAJZUFKUCHZUG
    ALUIUHUCHZUGPUGUHUFUCQUJUGMNOCAUCRSATUA $.

  $( Composition with the identity relation restricted to a relation's field.
     (Contributed by FL, 8-May-2011.) $)
  relcoi1 $p |- ( Rel R -> ( R o. ( _I |` U. U. R ) ) = R ) $=
    ( wrel cid cuni cres ccom cun wceq wi resco reseq1 wa eqtr eqeq1 syl5ibr ex
    syl com3l eqcoms mpcom cdm crn relfld resundi coeq2 coundi coi1 resdm uneq1
    uneq2d wss resss ssequn2 mpbi syl6reqr mpsyl syl5com mpi syl5eq mp2b reseq2
    coeq2d eqeq1d eqtrd ) ABZACADDZEZFZACFZAVFAUAZAUBZGZHZVEVHVIHZAUCVEVNVMACVL
    EZFZVIHZVOCVJEZCVKEZGZHVPAVTFZHZVEVQICVJVKUDVOVTAUEVEVQWBWAVIHVEWAAVRFZAVSF
    ZGZVIAVRVSUFVEVIVJEZWCHZWEVIHZACVJJVIAHZVEWGWHIZAUGZWIWFAVJEZHZVEWJVIAVJKWL
    AHZVEWMWJIAUHWMWNVEWJWMWNVEWJIZWMWNLWFAHZWOWFWLAMWGWPVEWHWPVEWHIZIWCWFWCWFH
    ZWPWQWRWPLWCAHZWQWCWFAMVIVKEZWDHZWSWEAWDGZHZWQACVKJWCAWDUIVEXAXCWHWIVEXAXCW
    HIZIZWKWIWTAVKEZHZVEXEIVIAVKKXAXGVEXDXGVEXDIZIWDWTWDWTHZXGXHXIXGLZXBAXFGZHZ
    XHXJWDXFAWDWTXFMUJXCXLVEWHXCXLWQXCXLLWEXKHZWQWEXBXKMVEWHXMXKVIHVEVIAXKWKXFA
    UKXKAHAVKULXFAUMUNUOWEXKVINOQPRQPSRQTRUPQPSRQPRTUQTURUSVPWAVINOUTVMVHVPVIVM
    VGVOAVFVLCVAVBVCOTWKVD $.

  $( The double union of the converse of a class is its field.  (Contributed by
     NM, 4-Jun-2008.) $)
  unidmrn $p |- U. U. `' A = ( dom A u. ran A ) $=
    ( ccnv cuni crn cdm cun wrel wceq relcnv ax-mp equncomi dfdm4 df-rn uneq12i
    relfld eqtr4i ) ABZCCZQDZQEZFAEZADZFRTSQGRTSFHAIQOJKUASUBTALAMNP $.

  $( if ` R ` is a relation, its double union equals the double union of its
     converse.  (Contributed by FL, 5-Jan-2009.) $)
  relcnvfld $p |- ( Rel R -> U. U. R = U. U. `' R ) $=
    ( wrel cuni cdm crn cun ccnv relfld unidmrn syl6eqr ) ABACCADAEFAGCCAHAIJ
    $.

  $( Alternate definition of domain ~ df-dm that doesn't require dummy
     variables.  (Contributed by NM, 2-Aug-2010.) $)
  dfdm2 $p |- dom A = U. U. ( `' A o. A ) $=
    ( ccnv ccom cuni cdm crn cun cnvco cocnvcnv2 eqtri unieqi eqtr3i wceq df-rn
    unidmrn eqcomi dmcoeq ax-mp rncoeq dfdm4 eqtr4i uneq12i unidm 3eqtrri ) ABZ
    ACZDZDZUFEZUFFZGZAEZULGULUFBZDZDUHUKUNUGUMUFUMUEUEBCUFUEAHUEAIJKKUFOLUIULUJ
    ULUEEZAFZMZUIULMUPUOANPZUEAQRUJUEFZULUQUJUSMURUEASRATUAUBULUCUD $.

  $( The double class union of a non-empty cross product is the union of it
     members.  (Contributed by NM, 17-Sep-2006.) $)
  unixp $p |- ( ( A X. B ) =/= (/) -> U. U. ( A X. B ) = ( A u. B ) ) $=
    ( cxp c0 wne cuni cdm crn cun wrel wceq relxp relfld ax-mp xpeq2 xp0 syl6eq
    necon3i xpeq1 0xp dmxp rnxp uneq12 syl2an syl2anc syl5eq ) ABCZDEZUGFFZUGGZ
    UGHZIZABIZUGJUIULKABLUGMNUHBDEZADEZULUMKZBDUGDBDKUGADCDBDAOAPQRADUGDADKUGDB
    CDADBSBTQRUNUJAKUKBKUPUOABUAABUBUJAUKBUCUDUEUF $.

  ${
    $d x y z A $.  $d x y z B $.
    $( A cross product is empty iff its union is empty.  (Contributed by NM,
       20-Sep-2006.) $)
    unixp0 $p |- ( ( A X. B ) = (/) <-> U. ( A X. B ) = (/) ) $=
      ( vz vx vy cxp c0 wceq cuni unieq uni0 syl6eq wne cv wex n0 cop vex sylbi
      wcel elxp3 wss elssuni opnzi ssn0 sylancl adantl exlimivv exlimiv necon4i
      wa impbii ) ABFZGHZUMIZGHUNUOGIGUMGJKLUMGUOGUMGMCNZUMTZCOUOGMZCUMPUQURCUQ
      DNZENZQZUPHZVAUMTZUKZEODOURDEUPABUAVDURDEVCURVBVCVAUOUBVAGMURVAUMUCUSUTDR
      ERUDVAUOUEUFUGUHSUISUJUL $.
  $}

  $( Field of a square cross product.  (Contributed by FL, 10-Oct-2009.) $)
  unixpid $p |- U. U. ( A X. A ) = A $=
    ( c0 wceq cxp cuni xpeq1 syl6eq wi unieq unieqd uni0 unieqi eqtri wa expcom
    0xp eqtr eqcoms syl5com wne sylancl mpcom wn df-ne cun unixp unidm sylancbr
    xpnz sylbi pm2.61i ) ABCZAADZEZEZACZUMBCZULUPULUMBADBABAFAPGUQUOBEZEZCZUSBC
    ZULUPHUQUNURUMBIJUSURBURBKLKMUTVANUOBCZULUPUOUSBQVBUPHBAVBBACUPUOBAQORSUAUB
    ULUCABTZVCUPABUDZVDVCVCNUMBTZUPAAUIVEUOAAUEAAAUFAUGGUJUHUK $.

  $( The converse of a set is a set.  Corollary 6.8(1) of [TakeutiZaring]
     p. 26.  (Contributed by NM, 17-Mar-1998.) $)
  cnvexg $p |- ( A e. V -> `' A e. _V ) $=
    ( wcel ccnv cdm crn cxp wss cvv wrel relcnv relssdmrn ax-mp df-rn syl5eqelr
    rnexg dfdm4 dmexg xpexg syl2anc ssexg sylancr ) ABCZADZUDEZUDFZGZHZUGICZUDI
    CUDJUHAKUDLMUCUEICUFICUIUCUEAFIANABPOUCUFAEIAQABROUEUFIISTUDUGIUAUB $.

  ${
    cnvex.1 $e |- A e. _V $.
    $( The converse of a set is a set.  Corollary 6.8(1) of [TakeutiZaring]
       p. 26.  (Contributed by NM, 19-Dec-2003.) $)
    cnvex $p |- `' A e. _V $=
      ( cvv wcel ccnv cnvexg ax-mp ) ACDAECDBACFG $.
  $}

  $( A relation is a set iff its converse is a set.  (Contributed by FL,
     3-Mar-2007.) $)
  relcnvexb $p |- ( Rel R -> ( R e. _V <-> `' R e. _V ) ) $=
    ( wrel cvv wcel ccnv cnvexg wceq wi dfrel2 eleq1 syl5ib sylbi impbid2 ) ABZ
    ACDZAEZCDZACFNPEZAGZQOHAIQRCDSOPCFRACJKLM $.

  ${
    $d x y A $.  $d x y B $.
    $( Restriction of a class to a singleton.  (Contributed by Mario Carneiro,
       28-Dec-2014.) $)
    ressn $p |- ( A |` { B } ) = ( { B } X. ( A " { B } ) ) $=
      ( vx vy csn cres cima cxp relres relxp cv cop wcel wa ancom elimasn elsni
      vex sneqd imaeq2d eleq2d syl5bbr pm5.32i opelres opelxp 3bitr4i eqrelriiv
      bitri ) CDABEZFZUIAUIGZHZAUIIUIUKJCKZDKZLZAMZUMUIMZNZUQUNUKMZNZUOUJMUOULM
      URUQUPNUTUPUQOUQUPUSUPUNAUMEZGZMUQUSAUMUNCRDRZPUQVBUKUNUQVAUIAUQUMBUMBQST
      UAUBUCUHUMUNAUIVCUDUMUNUIUKUEUFUG $.
  $}

  ${
    $d A a b x $.  $d B a b $.
    $( The converse of an intersection is the intersection of the converse.
       (Contributed by FL, 15-Oct-2012.) $)
    cnviin $p |- ( A =/= (/) -> `' |^|_ x e. A B = |^|_ x e. A `' B ) $=
      ( va vb ciin ccnv wrel relcnv cvv wss wral cv wcel df-rel cop eliin ax-mp
      wb opex c0 wne wceq cxp wrex r19.2z expcom mpbi a1i mprg iinss syl sylibr
      wi vex opelcnv ralbii bitri 3bitr4i eqrelriv sylancr ) BUAUBZABCFZGZHABCG
      ZFZHZVDVFUCVCIVBVFJJUDZKZVGVBVEVHKZABUEZVIVJVBVKUNABVBVJABLVKVJABUFUGVJAM
      BNVEHVJCIVEOUHUIUJABVEVHUKULVFOUMDEVDVFEMZDMZPZVCNZVNCNZABLZVMVLPZVDNVRVF
      NZVNJNVOVQSVLVMTAVNBCJQRVMVLVCDUOZEUOZUPVSVRVENZABLZVQVRJNVSWCSVMVLTAVRBV
      EJQRWBVPABVMVLCVTWAUPUQURUSUTVA $.
  $}

  ${
    $d x y z A $.  $d x y z R $.
    $( The converse of a partial order relation is a partial order relation.
       (Contributed by NM, 15-Jun-2005.) $)
    cnvpo $p |- ( R Po A <-> `' R Po A ) $=
      ( vx vy vz cv wbr wn wa wi wral wpo r19.26 bitri ralbii 3bitr4i vex brcnv
      c0 ralcom ccnv ralidm wb wceq rzal 2thd r19.3rzv ralbidv pm2.61ine bitr2i
      wne anbi1i breq12d syl5bb notbid cbvralv anbi12ci imbi12i anbi12i df-po
      id ) CFZVBBGZHZVBDFZBGZVEEFZBGZIZVBVGBGZJZIEAKZDAKCAKZVGVGBUAZGZHZVGVEVNG
      ZVEVBVNGZIZVGVBVNGZJZIZCAKZDAKEAKZABLAVNLVLCAKZDAKWCEAKZDAKVMWDWEWFDAWEVD
      CAKZVKEAKZIZCAKZWFVDEAKZWHIZCAKZWGCAKZWHCAKZIZWEWJWMWKCAKZWOIWPWKWHCAMWQW
      NWOWNWGWQVDCAUBWGWQUCASASUDWGWQVDCAUEWKCAUEUFASUKVDWKCAVDEAUGUHUIUJULNVLW
      LCAVDVKEAMOWGWHCAMPWJWBEAKZCAKWFWIWRCAWRVPEAKZWAEAKZIWIVPWAEAMWSWGWTWHVPV
      DECAVGVBUDZVOVCVOVGVGBGXAVCVGVGBEQZXBRXAVGVBVGVBBXAVAZXCUMUNUOUPWAVKEAVSV
      IVTVJVQVHVRVFVGVEBXBDQZRVEVBBXDCQZRUQVGVBBXBXERUROUSUJOWBCEAATNNOVLCDAATW
      CEDAATPCDEABUTEDCAVNUTP $.

    $( The converse of a strict order relation is a strict order relation.
       (Contributed by NM, 15-Jun-2005.) $)
    cnvso $p |- ( R Or A <-> `' R Or A ) $=
      ( vx vy wpo cv wbr weq w3o wral wa ccnv wor cnvpo ralcom vex brcnv equcom
      3orbi123i df-so 2ralbii bitr4i anbi12i 3bitr4i ) ABEZCFZDFZBGZCDHZUGUFBGZ
      IZDAJCAJZKABLZEZUGUFUMGZDCHZUFUGUMGZIZCAJDAJZKABMAUMMUEUNULUSABNULUKCAJDA
      JUSUKCDAAOURUKDCAAUOUHUPUIUQUJUGUFBDPZCPZQDCRUFUGBVAUTQSUAUBUCCDABTDCAUMT
      UD $.
  $}

  $( The composition of two sets is a set.  (Contributed by NM,
     19-Mar-1998.) $)
  coexg $p |- ( ( A e. V /\ B e. W ) -> ( A o. B ) e. _V ) $=
    ( wcel wa ccom cdm crn cxp wss cvv cossxp dmexg rnexg xpexg syl2anr sylancr
    ssexg ) ACEZBDEZFABGZBHZAIZJZKUELEZUBLEABMUAUCLEUDLEUFTBDNACOUCUDLLPQUBUELS
    R $.

  ${
    coex.1 $e |- A e. _V $.
    coex.2 $e |- B e. _V $.
    $( The composition of two sets is a set.  (Contributed by NM,
       15-Dec-2003.) $)
    coex $p |- ( A o. B ) e. _V $=
      ( cvv wcel ccom coexg mp2an ) AEFBEFABGEFCDABEEHI $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Composition of two cross products.  (Contributed by Thierry Arnoux,
       17-Nov-2017.) $)
    xpco $p |- ( B =/= (/) -> ( ( B X. C ) o. ( A X. B ) ) = ( A X. C ) ) $=
      ( vx vy vz c0 wne cv cxp wbr wa wex copab wcel ccom biimpi biantrurd brxp
      n0 ancom anbi1i anbi12i anandi 3bitr4i exbii 19.41v bitr2i opabbidv df-co
      syl6rbb df-xp 3eqtr4g ) BGHZDIZEIZABJZKZUPFIZBCJZKZLZEMZDFNUOAOZUSCOZLZDF
      NUTUQPACJUNVCVFDFUNVFUPBOZEMZVFLZVCUNVHVFUNVHEBTQRVCVGVFLZEMVIVBVJEVDVGLZ
      VGVELZLVGVDLZVLLVBVJVKVMVLVDVGUAUBURVKVAVLUOUPABSUPUSBCSUCVGVDVEUDUEUFVGV
      FEUGUHUKUIDFEUTUQUJDFACULUM $.
  $}

  ${
    $( Composition of two square cross products.  (Contributed by Thierry
       Arnoux, 14-Jan-2018.) $)
    xpcoid $p |- ( ( A X. A ) o. ( A X. A ) ) = ( A X. A ) $=
      ( cxp ccom wceq c0 co01 xpeq12d 0xp syl6eq coeq12d 3eqtr4a xpco pm2.61ine
      id ) AABZOCZODAEAEDZEECEPOEFQOEOEQOEEBEQAEAEQNZRGEHIZSJSKAAALM $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Definite description binder (inverted iota)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c iota $.
  $( Extend class notation with Russell's definition description binder
     (inverted iota). $)
  cio $a class ( iota x ph ) $.

  ${
    $d w x z $.  $d ph w z $.  $d ph w y $.  $d x y $.
    $( Soundness justification theorem for ~ df-iota .  (Contributed by Andrew
       Salmon, 29-Jun-2011.) $)
    iotajust $p |- U. { y | { x | ph } = { y } } =
       U. { z | { x | ph } = { z } } $=
      ( vw cab cv csn wceq sneq eqeq2d cbvabv eqtri unieqi ) ABFZCGZHZIZCFZODGZ
      HZIZDFZSOEGZHZIZEFUCRUFCEPUDIQUEOPUDJKLUFUBEDUDTIUEUAOUDTJKLMN $.
  $}

  ${
    $d y x $.  $d y ph $.
    $( Define Russell's definition description binder, which can be read as
       "the unique ` x ` such that ` ph ` ," where ` ph ` ordinarily contains
       ` x ` as a free variable.  Our definition is meaningful only when there
       is exactly one ` x ` such that ` ph ` is true (see ~ iotaval );
       otherwise, it evaluates to the empty set (see ~ iotanul ).  Russell used
       the inverted iota symbol ` iota ` to represent the binder.

       Sometimes proofs need to expand an iota-based definition.  That is,
       given "X = the x for which ... x ... x ..." holds, the proof needs to
       get to "...  X ...  X ...".  A general strategy to do this is to use
       ~ riotacl2 (or ~ iotacl for unbounded iota), as demonstrated in the
       proof of ~ supub .  This can be easier than applying ~ riotasbc or a
       version that applies an explicit substitution, because substituting an
       iota into its own property always has a bound variable clash which must
       be first renamed or else guarded with NF.

       (Contributed by Andrew Salmon, 30-Jun-2011.) $)
    df-iota $a |- ( iota x ph ) = U. { y | { x | ph } = { y } } $.
  $}

  ${
    $d y x $.  $d y ph $.
    $( Alternate definition for descriptions.  Definition 8.18 in [Quine]
       p. 56.  (Contributed by Andrew Salmon, 30-Jun-2011.) $)
    dfiota2 $p |- ( iota x ph ) = U. { y | A. x ( ph <-> x = y ) } $=
      ( cio cab cv csn wceq cuni wb wal df-iota df-sn eqeq2i abbi bitr4i unieqi
      abbii eqtri ) ABDABEZCFZGZHZCEZIABFUAHZJBKZCEZIABCLUDUGUCUFCUCTUEBEZHUFUB
      UHTBUAMNAUEBOPRQS $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( Bound-variable hypothesis builder for the ` iota ` class.  (Contributed
       by Andrew Salmon, 11-Jul-2011.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nfiota1 $p |- F/_ x ( iota x ph ) $=
      ( vy cio weq wb wal cab cuni dfiota2 nfaba1 nfuni nfcxfr ) BABDABCEFZBGCH
      ZIABCJBONBCKLM $.
  $}

  ${
    $d z ps $.  $d z ph $.  $d x z $.  $d y z $.
    nfiotad.1 $e |- F/ y ph $.
    nfiotad.2 $e |- ( ph -> F/ x ps ) $.
    $( Deduction version of ~ nfiota .  (Contributed by NM, 18-Feb-2013.) $)
    nfiotad $p |- ( ph -> F/_ x ( iota y ps ) ) $=
      ( vz cio weq wb wal cab cuni dfiota2 nfv wn wa wnf adantr cv nfcvf adantl
      wnfc nfcvd nfeqd nfbid nfald2 nfabd nfunid nfcxfrd ) ACBDHBDGIZJZDKZGLZMB
      DGNACUNAUMCGAGOAULCDEACDICKPZQZBUKCABCRUOFSUPCDTZGTZUOCUQUCACDUAUBUPCURUD
      UEUFUGUHUIUJ $.
  $}

  ${
    $d w z ph $.  $d w x z $.  $d w y z $.
    nfiota.1 $e |- F/ x ph $.
    $( Bound-variable hypothesis builder for the ` iota ` class.  (Contributed
       by NM, 23-Aug-2011.) $)
    nfiota $p |- F/_ x ( iota y ph ) $=
      ( cio wnfc wtru nftru wnf a1i nfiotad trud ) BACEFGABCCHABIGDJKL $.
  $}

  ${
    $d z w x $.  $d z w y $.  $d z w ph $.  $d z w ps $.
    cbviota.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    cbviota.2 $e |- F/ y ph $.
    cbviota.3 $e |- F/ x ps $.
    $( Change bound variables in a description binder.  (Contributed by Andrew
       Salmon, 1-Aug-2011.) $)
    cbviota $p |- ( iota x ph ) = ( iota y ps ) $=
      ( vw vz weq wb wal cab cuni cio wsb nfv nfbi equequ1 bibi12d sbequ12 nfsb
      nfs1v cbval sbequ sbie syl6bb bitri abbii unieqi dfiota2 3eqtr4i ) ACHJZK
      ZCLZHMZNBDHJZKZDLZHMZNACOBDOUPUTUOUSHUOACIPZIHJZKZILUSUNVCCIUNIQVAVBCACIU
      CVBCQRCIJAVAUMVBACIUACIHSTUDVCURIDVAVBDACIDFUBVBDQRURIQIDJZVABVBUQVDVAACD
      PBAIDCUEABCDGEUFUGIDHSTUDUHUIUJACHUKBDHUKUL $.
  $}

  ${
    $d ph y $.  $d ps x $.
    cbviotav.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variables in a description binder.  (Contributed by Andrew
       Salmon, 1-Aug-2011.) $)
    cbviotav $p |- ( iota x ph ) = ( iota y ps ) $=
      ( nfv cbviota ) ABCDEADFBCFG $.
  $}

  ${
    $d w z ph $.  $d w z x $.  $d w z y $.
    sb8iota.1 $e |- F/ y ph $.
    $( Variable substitution in description binder.  Compare ~ sb8eu .
       (Contributed by NM, 18-Mar-2013.) $)
    sb8iota $p |- ( iota x ph ) = ( iota y [ y / x ] ph ) $=
      ( vz vw weq wal cab cuni wsb cio nfv sb8 sbbi nfsb equsb3 nfxfr dfiota2
      wb nfbi sbequ cbval sblbis albii 3bitri abbii unieqi 3eqtr4i ) ABEGZTZBHZ
      EIZJABCKZCEGZTZCHZEIZJABLUNCLUMURULUQEULUKBFKZFHUKBCKZCHUQUKBFUKFMNUSUTFC
      USABFKZUJBFKZTCAUJBFOVAVBCABFCDPVBFEGZCFBEQVCCMRUARUTFMUKFCBUBUCUTUPCUJUO
      ABCCBEQUDUEUFUGUHABESUNCESUI $.
  $}

  ${
    $d y z $.  $d x z $.  $d ph z $.
    $( Equality theorem for descriptions.  (Contributed by Andrew Salmon,
       30-Jun-2011.) $)
    iotaeq $p |- ( A. x x = y -> ( iota x ph ) = ( iota y ph ) ) $=
      ( vz cv wceq wal cab csn cuni cio wcel drsb1 df-clab 3bitr4g eqrdv eqeq1d
      wsb abbidv df-iota unieqd 3eqtr4g ) BECEFBGZABHZDEZIZFZDHZJACHZUFFZDHZJAB
      KACKUCUHUKUCUGUJDUCUDUIUFUCDUDUIUCABDRACDRUEUDLUEUILABCDMADBNADCNOPQSUAAB
      DTACDTUB $.
  $}

  ${
    $d ph z $.  $d ps z $.  $d x y z $.
    $( Equivalence theorem for descriptions.  (Contributed by Andrew Salmon,
       30-Jun-2011.) $)
    iotabi $p |- ( A. x ( ph <-> ps ) -> ( iota x ph ) = ( iota x ps ) ) $=
      ( vz wb wal cab cv csn wceq cuni abbi biimpi eqeq1d abbidv unieqd df-iota
      cio 3eqtr4g ) ABECFZACGZDHIZJZDGZKBCGZUBJZDGZKACRBCRTUDUGTUCUFDTUAUEUBTUA
      UEJABCLMNOPACDQBCDQS $.

    $( Part of Theorem 8.17 in [Quine] p. 56.  This theorem serves as a lemma
       for the fundamental property of iota.  (Contributed by Andrew Salmon,
       11-Jul-2011.) $)
    uniabio $p |- ( A. x ( ph <-> x = y ) -> U. { x | ph } = y ) $=
      ( cv wceq wb wal cab cuni csn abbi biimpi df-sn syl6eqr unieqd vex syl6eq
      unisn ) ABDCDZEZFBGZABHZISJZISUAUBUCUAUBTBHZUCUAUBUDEATBKLBSMNOSCPRQ $.

    $( Theorem 8.19 in [Quine] p. 57.  This theorem is the fundamental property
       of iota.  (Contributed by Andrew Salmon, 11-Jul-2011.) $)
    iotaval $p |- ( A. x ( ph <-> x = y ) -> ( iota x ph ) = y ) $=
      ( vz weq wb wal cio cab cuni cv dfiota2 wceq cvv wcel vex sbeqalb equcomi
      wa wi ax-mp ex equequ2 equcoms bibi2d biimpd alimdv com12 alrimiv uniabio
      syl6 impbid syl syl5eq ) ABCEZFZBGZABHABDEZFZBGZDIJZCKZABDLUQUTDCEZFZDGVA
      VBMUQVDDUQUTVCUQUTVCVBNOZUQUTSZVCTCPVEVFCDEVCABVBDKNQCDRUKUAUBVCUQUTVCUPU
      SBVCUPUSVCUOURAUOURFCDCDBUCUDUEUFUGUHULUIUTDCUJUMUN $.

    $( Equivalence between two different forms of ` iota ` .  (Contributed by
       Andrew Salmon, 12-Jul-2011.) $)
    iotauni $p |- ( E! x ph -> ( iota x ph ) = U. { x | ph } ) $=
      ( vz weu cv wceq wb wal wex cio cuni df-eu iotaval uniabio eqtr4d exlimiv
      cab sylbi ) ABDABECEZFGBHZCIABJZABQKZFZABCLTUCCTUASUBABCMABCNOPR $.

    $( Equivalence between two different forms of ` iota ` .  (Contributed by
       Mario Carneiro, 24-Dec-2016.) $)
    iotaint $p |- ( E! x ph -> ( iota x ph ) = |^| { x | ph } ) $=
      ( weu cio cab cuni cint iotauni wceq uniintab biimpi eqtrd ) ABCZABDABEZF
      ZNGZABHMOPIABJKL $.

    $( Property of iota.  (Contributed by NM, 23-Aug-2011.)  (Revised by Mario
       Carneiro, 23-Dec-2016.) $)
    iota1 $p |- ( E! x ph -> ( ph <-> ( iota x ph ) = x ) ) $=
      ( vz weu cv wceq wb wal wex cio df-eu iotaval eqeq2d bitr4d eqcom exlimiv
      sp syl6bb sylbi ) ABDABEZCEZFZGZBHZCIAABJZTFZGZABCKUDUGCUDATUEFZUFUDAUBUH
      UCBQUDUEUATABCLMNTUEORPS $.

    $( Theorem 8.22 in [Quine] p. 57.  This theorem is the result if there
       isn't exactly one ` x ` that satisfies ` ph ` .  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    iotanul $p |- ( -. E! x ph -> ( iota x ph ) = (/) ) $=
      ( vz weu weq wb wal wex cio c0 wceq df-eu wn cab cuni dfiota2 alnex eqidd
      ax-1 cv impbid1 con2bid alimi abbi sylib dfnul2 sylbir unieqd uni0 syl6eq
      syl6eqr syl5eq sylnbi ) ABDABCEFBGZCHZABIZJKABCLUOMZUPUNCNZOZJABCPUQUSJOJ
      UQURJUQUNMZCGZURJKUNCQVAURCCEZMZCNZJVAUNVCFZCGURVDKUTVECUTVBUNUTVBUTUTVBS
      UTCTRUAUBUCUNVCCUDUECUFUKUGUHUIUJULUM $.

    $( The ` iota ` class is a subset of the union of all elements satisfying
       ` ph ` .  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    iotassuni $p |- ( iota x ph ) C_ U. { x | ph } $=
      ( weu cio cab cuni wss wceq iotauni eqimss syl wn c0 iotanul 0ss syl6eqss
      pm2.61i ) ABCZABDZABEFZGZRSTHUAABISTJKRLSMTABNTOPQ $.

    $( Theorem 8.23 in [Quine] p. 58.  This theorem proves the existence of the
       ` iota ` class under our definition.  (Contributed by Andrew Salmon,
       11-Jul-2011.) $)
    iotaex $p |- ( iota x ph ) e. _V $=
      ( vz weu cio cvv wcel cv wceq wb wal wex iotaval eqcomd eximi df-eu isset
      3imtr4i wn c0 iotanul 0ex syl6eqel pm2.61i ) ABDZABEZFGZABHCHZIJBKZCLUHUF
      IZCLUEUGUIUJCUIUFUHABCMNOABCPCUFQRUESUFTFABUAUBUCUD $.

    $( Theorem *14.22 in [WhiteheadRussell] p. 190.  (Contributed by Andrew
       Salmon, 12-Jul-2011.) $)
    iota4 $p |- ( E! x ph -> [. ( iota x ph ) / x ]. ph ) $=
      ( vz weu weq wb wal wex cio wsbc df-eu wsb bi2 alimi sb2 syl wceq iotaval
      wi cv eqcomd dfsbcq2 mpbid exlimiv sylbi ) ABDABCEZFZBGZCHABABIZJZABCKUHU
      JCUHABCLZUJUHUFASZBGUKUGULBAUFMNABCOPUHCTZUIQUKUJFUHUIUMABCRUAABCUIUBPUCU
      DUE $.
  $}

  $( Theorem *14.23 in [WhiteheadRussell] p. 191.  (Contributed by Andrew
     Salmon, 12-Jul-2011.) $)
  iota4an $p |- ( E! x ( ph /\ ps )
            -> [. ( iota x ( ph /\ ps ) ) / x ]. ph ) $=
    ( wa weu cio wsbc iota4 wi cvv wcel iotaex simpl sbcth ax-mp wb sbcimg mpbi
    syl ) ABDZCETCTCFZGZACUAGZTCHTAIZCUAGZUBUCIZUAJKZUETCLZUDCUAJABMNOUGUEUFPUH
    TACUAJQORS $.

  ${
    $d x y A $.  $d x V $.  $d x ph $.  $d y ps $.
    iota5.1 $e |- ( ( ph /\ A e. V ) -> ( ps <-> x = A ) ) $.
    $( A method for computing iota.  (Contributed by NM, 17-Sep-2013.) $)
    iota5 $p |- ( ( ph /\ A e. V ) -> ( iota x ps ) = A ) $=
      ( vy wcel wa cv wceq wb wal cio alrimiv wi eqeq2 bibi2d albidv imbi12d
      iotaval vtoclg adantl mpd ) ADEHZIZBCJZDKZLZCMZBCNZDKZUFUICFOUEUJULPZABUG
      GJZKZLZCMZUKUNKZPUMGDEUNDKZUQUJURULUSUPUICUSUOUHBUNDUGQRSUNDUKQTBCGUAUBUC
      UD $.
  $}

  ${
    $d x ph $.
    iotabidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building deduction rule for iota.  (Contributed by NM,
       20-Aug-2011.) $)
    iotabidv $p |- ( ph -> ( iota x ps ) = ( iota x ch ) ) $=
      ( wb wal cio wceq alrimiv iotabi syl ) ABCFZDGBDHCDHIAMDEJBCDKL $.
  $}

  ${
    iotabii.1 $e |- ( ph <-> ps ) $.
    $( Formula-building deduction rule for iota.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    iotabii $p |- ( iota x ph ) = ( iota x ps ) $=
      ( wb cio wceq iotabi mpg ) ABEACFBCFGCABCHDI $.
  $}

  $( Membership law for descriptions.

     This can useful for expanding an unbounded iota-based definition (see
     ~ df-iota ).  If you have a bounded iota-based definition, ~ riotacl2 may
     be useful.

     (Contributed by Andrew Salmon, 1-Aug-2011.) $)
  iotacl $p |- ( E! x ph -> ( iota x ph ) e. { x | ph } ) $=
    ( weu cio wsbc cab wcel iota4 df-sbc sylib ) ABCABABDZEKABFGABHABKIJ $.

  ${
    $d x y $.  $d y B $.  $d y ps $.
    iota2df.1 $e |- ( ph -> B e. V ) $.
    iota2df.2 $e |- ( ph -> E! x ps ) $.
    iota2df.3 $e |- ( ( ph /\ x = B ) -> ( ps <-> ch ) ) $.
    ${
      iota2df.4 $e |- F/ x ph $.
      iota2df.5 $e |- ( ph -> F/ x ch ) $.
      iota2df.6 $e |- ( ph -> F/_ x B ) $.
      $( A condition that allows us to represent "the unique element such that
         ` ph ` " with a class expression ` A ` .  (Contributed by NM,
         30-Dec-2014.) $)
      iota2df $p |- ( ph -> ( ch <-> ( iota x ps ) = B ) ) $=
        ( cio cv wceq wb wa simpr eqeq2d bibi12d weu iota1 syl wnfc nfiota1 a1i
        nfeqd nfbid vtocldf ) ABBDMZDNZOZPZCUJEOZPDEFGAUKEOZQZBCULUNIUPUKEUJAUO
        RSTABDUAUMHBDUBUCJLACUNDKADUJEDUJUDABDUEUFLUGUHUI $.
    $}

    $d x B $.  $d x ph $.  $d x ch $.
    $( A condition that allows us to represent "the unique element such that
       ` ph ` " with a class expression ` A ` .  (Contributed by NM,
       30-Dec-2014.) $)
    iota2d $p |- ( ph -> ( ch <-> ( iota x ps ) = B ) ) $=
      ( nfv nfvd nfcvd iota2df ) ABCDEFGHIADJACDKADELM $.
  $}

  ${
    $d A x $.  $d ps x $.
    iota2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( The unique element such that ` ph ` .  (Contributed by Jeff Madsen,
       1-Jun-2011.)  (Revised by Mario Carneiro, 23-Dec-2016.) $)
    iota2 $p |- ( ( A e. B /\ E! x ph ) -> ( ps <-> ( iota x ph ) = A ) ) $=
      ( wcel cvv weu cio wceq wb elex wa simpl simpr cv adantl nfv nfeu1 nfcvd
      nfan nfvd iota2df sylan ) DEGDHGZACIZBACJDKLDEMUFUGNZABCDHUFUGOUFUGPCQDKA
      BLUHFRUFUGCUFCSACTUBUHBCUCUHCDUAUDUE $.
  $}

  $( A class abstraction with a unique member can be expressed as a singleton.
     (Contributed by Mario Carneiro, 23-Dec-2016.) $)
  sniota $p |- ( E! x ph -> { x | ph } = { ( iota x ph ) } ) $=
    ( weu cv cab wcel cio csn wb wal wceq nfeu1 iota1 eqcom syl6bb abid 3bitr4g
    vex elsnc alrimi nfab1 nfiota1 nfsn cleqf sylibr ) ABCZBDZABEZFZUGABGZHZFZI
    ZBJUHUKKUFUMBABLUFAUGUJKZUIULUFAUJUGKUNABMUJUGNOABPUGUJBRSQTBUHUKABUABUJABU
    BUCUDUE $.

  ${
    $( The ` iota ` operation using the ` if ` operator.  (Contributed by Scott
       Fenton, 6-Oct-2017.) $)
    dfiota4 $p |- ( iota x ph ) = if ( E! x ph , U. { x | ph } , (/) ) $=
      ( weu cio cab cuni cif wceq iotauni iftrue eqtr4d iotanul iffalse pm2.61i
      c0 wn ) ABCZABDZQABEFZOGZHQRSTABIQSOJKQPROTABLQSOMKN $.
  $}

  ${
    $d A y z $.  $d x y z $.  $d ph z $.
    $( Class substitution within a description binder.  (Contributed by Scott
       Fenton, 6-Oct-2017.)  (Revised by NM, 23-Aug-2018.) $)
    csbiota $p |- [_ A / x ]_ ( iota y ph ) = ( iota y [. A / x ]. ph ) $=
      ( vz cvv wcel cio csb wsbc wceq cv wsb csbeq1 dfsbcq2 iotabidv eqeq12d wn
      c0 con3i vex nfs1v nfiota weq sbequ12 csbief vtoclg csbprc wex sbcex euex
      weu nexdv iotanul 3syl eqtr4d pm2.61i ) DFGZBDACHZIZABDJZCHZKZBELZUSIZABE
      MZCHZKVCEDFVDDKZVEUTVGVBBVDDUSNVHVFVACABEDOPQBVDUSVGEUAVFBCABEUBUCBEUDAVF
      CABEUEPUFUGURRZUTSVBBDUSUHVIVACUIZRVACULZRVBSKVIVACVAURABDUJTUMVKVJVACUKT
      VACUNUOUPUQ $.

    $( Class substitution within a description binder.  (Contributed by Scott
       Fenton, 6-Oct-2017.)  Obsolete as of 23-Aug-2018.  Use ~ csbiota
       instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbiotagOLD $p |- ( A e. V ->
        [_ A / x ]_ ( iota y ph ) = ( iota y [. A / x ]. ph ) ) $=
      ( vz cv cio csb wsb wceq csbeq1 dfsbcq2 iotabidv eqeq12d vex nfs1v nfiota
      wsbc weq sbequ12 csbief vtoclg ) BFGZACHZIZABFJZCHZKBDUEIZABDSZCHZKFDEUDD
      KZUFUIUHUKBUDDUELULUGUJCABFDMNOBUDUEUHFPUGBCABFQRBFTAUGCABFUANUBUC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                 Functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c : $. $( Colon $)
  $c Fun $. $( Function predicate $)
  $c Fn $. $( Function connective $)
  $c --> $. $( Domain-codomain connective $)
  $c -1-1-> $. $( 'One-to-one' domain-codomain connective $)
  $c -onto-> $. $( 'Onto' domain-codomain connective $)
  $c -1-1-onto-> $. $( 'One-to-one' and 'onto' domain-codomain connective $)
  $c ` $. $( Left apostrophe (function value symbol) $)
  $c Isom $. $( Isomorphism $)

  $( Extend the definition of a wff to include the function predicate.  (Read:
     ` A ` is a function.) $)
  wfun $a wff Fun A $.

  $( Extend the definition of a wff to include the function predicate with a
     domain.  (Read: ` A ` is a function on ` B ` .) $)
  wfn $a wff A Fn B $.

  $( Extend the definition of a wff to include the function predicate with
     domain and codomain.  (Read: ` F ` maps ` A ` into ` B ` .) $)
  wf $a wff F : A --> B $.

  $( Extend the definition of a wff to include one-to-one functions.  (Read:
     ` F ` maps ` A ` one-to-one into ` B ` .)  The notation ("1-1" above the
     arrow) is from Definition 6.15(5) of [TakeutiZaring] p. 27. $)
  wf1 $a wff F : A -1-1-> B $.

  $( Extend the definition of a wff to include onto functions.  (Read: ` F `
     maps ` A ` onto ` B ` .)  The notation ("onto" below the arrow) is from
     Definition 6.15(4) of [TakeutiZaring] p. 27. $)
  wfo $a wff F : A -onto-> B $.

  $( Extend the definition of a wff to include one-to-one onto functions.
     (Read: ` F ` maps ` A ` one-to-one onto ` B ` .)  The notation ("1-1"
     above the arrow and "onto" below the arrow) is from Definition 6.15(6) of
     [TakeutiZaring] p. 27. $)
  wf1o $a wff F : A -1-1-onto-> B $.

  $( Extend the definition of a class to include the value of a function.
     (Read:  The value of ` F ` at ` A ` , or " ` F ` of ` A ` .") $)
  cfv $a class ( F ` A ) $.

  $( Extend the definition of a wff to include the isomorphism property.
     (Read: ` H ` is an ` R ` , ` S ` isomorphism of ` A ` onto ` B ` .) $)
  wiso $a wff H Isom R , S ( A , B ) $.

  ${
    $d x A $.  $d x F $.
    $( Define predicate that determines if some class ` A ` is a function.
       Definition 10.1 of [Quine] p. 65.  For example, the expression
       ` Fun cos ` is true once we define cosine ( ~ df-cos ).  This is not the
       same as defining a specific function's mapping, which is typically done
       using the format of ~ cmpt with the maps-to notation (see ~ df-mpt and
       ~ df-mpt2 ).  Contrast this predicate with the predicates to determine
       if some class is a function with a given domain ( ~ df-fn ), a function
       with a given domain and codomain ( ~ df-f ), a one-to-one function
       ( ~ df-f1 ), an onto function ( ~ df-fo ), or a one-to-one onto function
       ( ~ df-f1o ).  For alternate definitions, see ~ dffun2 , ~ dffun3 ,
       ~ dffun4 , ~ dffun5 , ~ dffun6 , ~ dffun7 , ~ dffun8 , and ~ dffun9 .
       (Contributed by NM, 1-Aug-1994.) $)
    df-fun $a |- ( Fun A <-> ( Rel A /\ ( A o. `' A ) C_ _I ) ) $.

    $( Define a function with domain.  Definition 6.15(1) of [TakeutiZaring]
       p. 27.  For alternate definitions, see ~ dffn2 , ~ dffn3 , ~ dffn4 , and
       ~ dffn5 .  (Contributed by NM, 1-Aug-1994.) $)
    df-fn $a |- ( A Fn B <-> ( Fun A /\ dom A = B ) ) $.

    $( Define a function (mapping) with domain and codomain.  Definition
       6.15(3) of [TakeutiZaring] p. 27.  For alternate definitions, see
       ~ dff2 , ~ dff3 , and ~ dff4 .  (Contributed by NM, 1-Aug-1994.) $)
    df-f $a |- ( F : A --> B <-> ( F Fn A /\ ran F C_ B ) ) $.

    $( Define a one-to-one function.  For equivalent definitions see ~ dff12
       and ~ dff13 .  Compare Definition 6.15(5) of [TakeutiZaring] p. 27.  We
       use their notation ("1-1" above the arrow).  (Contributed by NM,
       1-Aug-1994.) $)
    df-f1 $a |- ( F : A -1-1-> B <-> ( F : A --> B /\ Fun `' F ) ) $.

    $( Define an onto function.  Definition 6.15(4) of [TakeutiZaring] p. 27.
       We use their notation ("onto" under the arrow).  For alternate
       definitions, see ~ dffo2 , ~ dffo3 , ~ dffo4 , and ~ dffo5 .
       (Contributed by NM, 1-Aug-1994.) $)
    df-fo $a |- ( F : A -onto-> B <-> ( F Fn A /\ ran F = B ) ) $.

    $( Define a one-to-one onto function.  For equivalent definitions see
       ~ dff1o2 , ~ dff1o3 , ~ dff1o4 , and ~ dff1o5 .  Compare Definition
       6.15(6) of [TakeutiZaring] p. 27.  We use their notation ("1-1" above
       the arrow and "onto" below the arrow).  (Contributed by NM,
       1-Aug-1994.) $)
    df-f1o $a |- ( F : A -1-1-onto-> B <->
                ( F : A -1-1-> B /\ F : A -onto-> B ) ) $.

    $( Define the value of a function, ` ( F `` A ) ` , also known as function
       application.  For example, ` ( cos `` 0 ) = 1 ` (we prove this in ~ cos0
       after we define cosine in ~ df-cos ).  Typically, function ` F ` is
       defined using maps-to notation (see ~ df-mpt and ~ df-mpt2 ), but this
       is not required.  For example,
       ` F = { <. 2 , 6 >. , <. 3 , 9 >. } -> ( F `` 3 ) = 9 ` ( ~ ex-fv ).
       Note that ~ df-ov will define two-argument functions using ordered pairs
       as ` ( A F B ) = ( F `` <. A , B >. ) ` .  This particular definition is
       quite convenient: it can be applied to any class and evaluates to the
       empty set when it is not meaningful (as shown by ~ ndmfv and ~ fvprc ).
       The left apostrophe notation originated with Peano and was adopted in
       Definition *30.01 of [WhiteheadRussell] p. 235, Definition 10.11 of
       [Quine] p. 68, and Definition 6.11 of [TakeutiZaring] p. 26.  It means
       the same thing as the more familiar ` F ( A ) ` notation for a
       function's value at ` A ` , i.e.  " ` F ` of ` A ` ," but without
       context-dependent notational ambiguity.  Alternate definitions are
       ~ dffv2 , ~ dffv3 , ~ fv2 , and ~ fv3 (the latter two previously
       required ` A ` to be a set.)  Restricted equivalents that require ` F `
       to be a function are shown in ~ funfv and ~ funfv2 .  For the familiar
       definition of function value in terms of ordered pair membership, see
       ~ funopfvb .  (Contributed by NM, 1-Aug-1994.)  Revised to use
       ` iota ` .  Original version is now theorem ~ dffv4 .  (Revised by Scott
       Fenton, 6-Oct-2017.) $)
    df-fv $a |- ( F ` A ) = ( iota x A F x ) $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $( Define the isomorphism predicate.  We read this as " ` H ` is an ` R ` ,
       ` S ` isomorphism of ` A ` onto ` B ` ."  Normally, ` R ` and ` S ` are
       ordering relations on ` A ` and ` B ` respectively.  Definition 6.28 of
       [TakeutiZaring] p. 32, whose notation is the same as ours except that
       ` R ` and ` S ` are subscripts.  (Contributed by NM, 4-Mar-1997.) $)
    df-isom $a |- ( H Isom R , S ( A , B ) <-> ( H : A -1-1-onto-> B /\
                 A. x e. A A. y e. A ( x R y <-> ( H ` x ) S ( H ` y ) ) ) ) $.
  $}

  ${
    $d x y z A $.
    $( Alternate definition of a function.  (Contributed by NM,
       29-Dec-1996.) $)
    dffun2 $p |- ( Fun A <-> ( Rel A /\
                 A. x A. y A. z ( ( x A y /\ x A z ) -> y = z ) ) ) $=
      ( wfun wrel cid wss wa cv wbr wal wex copab 3bitri vex albii alcom bitri
      wi ccnv ccom df-fun df-id sseq2i df-co sseq1i ssopab2b brcnv anbi1i exbii
      weq imbi1i 19.23v bitr4i anbi2i ) DEDFZDDUAZUBZGHZIUQAJZBJZDKZVACJDKZIZBC
      ULZTZCLZBLALZIDUCUTVIUQUTVBVAURKZVDIZAMZVFTZCLZBLZVHALZBLVIUTUSVFBCNZHVLB
      CNZVQHVOGVQUSBCUDUEUSVRVQBCADURUFUGVLVFBCUHOVNVPBVNVGALZCLVPVMVSCVMVEAMZV
      FTVSVLVTVFVKVEAVJVCVDVBVADBPAPUIUJUKUMVEVFAUNUOQVGCARSQVHBAROUPS $.

    $( Alternate definition of function.  (Contributed by NM, 29-Dec-1996.) $)
    dffun3 $p |- ( Fun A <-> ( Rel A /\
                 A. x E. z A. y ( x A y -> y = z ) ) ) $=
      ( wfun wrel cv wbr wa weq wi wal wex dffun2 wmo breq2 mo4 nfv mo2 bitr3i
      albii anbi2i bitri ) DEDFZAGZBGZDHZUECGZDHZIBCJZKCLBLZALZIUDUGUJKBLCMZALZ
      IABCDNULUNUDUKUMAUKUGBOUMUGUIBCUFUHUEDPQUGBCUGCRSTUAUBUC $.

    $( Alternate definition of a function.  Definition 6.4(4) of
       [TakeutiZaring] p. 24.  (Contributed by NM, 29-Dec-1996.) $)
    dffun4 $p |- ( Fun A <-> ( Rel A /\
                 A. x A. y A. z ( ( <. x , y >. e. A /\ <. x , z >. e. A )
                 -> y = z ) ) ) $=
      ( wfun wrel cv wbr wa weq wal cop wcel dffun2 df-br anbi12i imbi1i 2albii
      wi albii anbi2i bitri ) DEDFZAGZBGZDHZUDCGZDHZIZBCJZSZCKZBKAKZIUCUDUELDMZ
      UDUGLDMZIZUJSZCKZBKAKZIABCDNUMUSUCULURABUKUQCUIUPUJUFUNUHUOUDUEDOUDUGDOPQ
      TRUAUB $.

    $( Alternate definition of function.  (Contributed by NM, 29-Dec-1996.) $)
    dffun5 $p |- ( Fun A <-> ( Rel A /\
                 A. x E. z A. y ( <. x , y >. e. A -> y = z ) ) ) $=
      ( wfun wrel cv wbr weq wi wal wex wa wcel dffun3 df-br imbi1i albii exbii
      cop anbi2i bitri ) DEDFZAGZBGZDHZBCIZJZBKZCLZAKZMUCUDUETDNZUGJZBKZCLZAKZM
      ABCDOUKUPUCUJUOAUIUNCUHUMBUFULUGUDUEDPQRSRUAUB $.
  $}

  ${
    $d x y w v u $.  $d A w v u $.
    dffun6f.1 $e |- F/_ x A $.
    dffun6f.2 $e |- F/_ y A $.
    $( Definition of function, using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by NM, 9-Mar-1995.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    dffun6f $p |- ( Fun A <-> ( Rel A /\ A. x E* y x A y ) ) $=
      ( vw vv vu wfun wrel cv wbr weq wal wa wmo nfcv nfbr nfv albii wex dffun3
      wi breq2 cbvmo mo2 nfmo breq1 mobidv cbval 3bitr3ri anbi2i bitr4i ) CICJZ
      FKZGKZCLZGHMUCGNHUAZFNZOUNAKZBKZCLZBPZANZOFGHCUBVDUSUNUQGPZFNUOVACLZBPZFN
      USVDVEVGFUQVFGBBUOUPCBUOQEBUPQRVFGSUPVAUOCUDUETVEURFUQGHUQHSUFTVGVCFAVFAB
      AUOVACAUOQDAVAQRUGVCFSFAMVFVBBUOUTVACUHUIUJUKULUM $.
  $}

  ${
    $d x y A $.  $d x y z F $.
    $( Alternate definition of a function using "at most one" notation.
       (Contributed by NM, 9-Mar-1995.) $)
    dffun6 $p |- ( Fun F <-> ( Rel F /\ A. x E* y x F y ) ) $=
      ( nfcv dffun6f ) ABCACDBCDE $.

    $( A function has at most one value for each argument.  (Contributed by NM,
       24-May-1998.) $)
    funmo $p |- ( Fun F -> E* y A F y ) $=
      ( vx wfun cv wbr cvv wcel wa wi wal wmo wrel dffun6 simplbi brrelex ancrd
      ex syl alrimiv wceq breq1 mobidv imbi2d simprbi 19.21bi vtoclg com12 moim
      moanimv sylibr sylc ) CEZBAFZCGZBHIZUPJZKZALURAMZUPAMZUNUSAUNUPUQUNCNZUPU
      QKUNVBDFZUOCGZAMZDLZDACOZPVBUPUQBUOCQSTRUAUNUQVAKUTUQUNVAUNVEKUNVAKDBHVCB
      UBZVEVAUNVHVDUPAVCBUOCUCUDUEUNVEDUNVBVFVGUFUGUHUIUQUPAUKULUPURAUJUM $.
  $}

  $( A function is a relation.  (Contributed by NM, 1-Aug-1994.) $)
  funrel $p |- ( Fun A -> Rel A ) $=
    ( wfun wrel ccnv ccom cid wss df-fun simplbi ) ABACAADEFGAHI $.

  ${
    $d x y z A $.  $d x y z B $.
    $( Subclass theorem for function predicate.  (Contributed by NM,
       16-Aug-1994.)  (Proof shortened by Mario Carneiro, 24-Jun-2014.) $)
    funss $p |- ( A C_ B -> ( Fun B -> Fun A ) ) $=
      ( wss wrel ccnv ccom cid wa wfun relss wi coss1 cnvss coss2 sstrd anim12d
      syl sstr2 df-fun 3imtr4g ) ABCZBDZBBEZFZGCZHADZAAEZFZGCZHBIAIUAUBUFUEUIAB
      JUAUHUDCUEUIKUAUHBUGFZUDABUGLUAUGUCCUJUDCABMUGUCBNQOUHUDGRQPBSAST $.
  $}

  $( Equality theorem for function predicate.  (Contributed by NM,
     16-Aug-1994.) $)
  funeq $p |- ( A = B -> ( Fun A <-> Fun B ) ) $=
    ( wceq wfun wss wi eqimss2 funss syl eqimss impbid ) ABCZADZBDZLBAEMNFBAGBA
    HILABENMFABJABHIK $.

  ${
    funeqi.1 $e |- A = B $.
    $( Equality inference for the function predicate.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.) $)
    funeqi $p |- ( Fun A <-> Fun B ) $=
      ( wceq wfun wb funeq ax-mp ) ABDAEBEFCABGH $.
  $}

  ${
    funeqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for the function predicate.  (Contributed by NM,
       23-Feb-2013.) $)
    funeqd $p |- ( ph -> ( Fun A <-> Fun B ) ) $=
      ( wceq wfun wb funeq syl ) ABCEBFCFGDBCHI $.
  $}

  ${
    nffun.1 $e |- F/_ x F $.
    $( Bound-variable hypothesis builder for a function.  (Contributed by NM,
       30-Jan-2004.) $)
    nffun $p |- F/ x Fun F $=
      ( wfun wrel ccnv ccom cid wa df-fun nfrel nfcnv nfco nfcv nfss nfan nfxfr
      wss ) BDBEZBBFZGZHRZIABJSUBAABCKAUAHABTCABCLMAHNOPQ $.
  $}

  ${
    $d y A $.  $d y F $.
    $( There is exactly one value of a function.  (Contributed by NM,
       22-Apr-2004.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    funeu $p |- ( ( Fun F /\ A F B ) -> E! y A F y ) $=
      ( wfun wbr wa cv wex weu cdm wcel wrel funrel releldm sylan eldmg ibi syl
      wmo wi funmo adantr df-mo sylib mpd ) DEZBCDFZGZBAHDFZAIZUJAJZUIBDKZLZUKU
      GDMUHUNDNBCDOPUNUKABDUMQRSUIUJATZUKULUAUGUOUHABDUBUCUJAUDUEUF $.

    $( There is exactly one value of a function.  (Contributed by NM,
       3-Aug-1994.) $)
    funeu2 $p |- ( ( Fun F /\ <. A , B >. e. F ) -> E! y <. A , y >. e. F ) $=
      ( cop wcel wfun wbr cv weu df-br wa funeu eubii sylib sylan2br ) BCEDFDGZ
      BCDHZBAIZEDFZAJZBCDKQRLBSDHZAJUAABCDMUBTABSDKNOP $.
  $}

  ${
    $d x y A $.
    $( Alternate definition of a function.  One possibility for the definition
       of a function in [Enderton] p. 42.  (Enderton's definition is ambiguous
       because "there is only one" could mean either "there is at most one" or
       "there is exactly one."  However, ~ dffun8 shows that it doesn't matter
       which meaning we pick.)  (Contributed by NM, 4-Nov-2002.) $)
    dffun7 $p |- ( Fun A <-> ( Rel A /\ A. x e. dom A E* y x A y ) ) $=
      ( wfun wrel cv wbr wmo wal wa cdm wral dffun6 wcel wi wex vex eldm bitr4i
      moabs imbi1i albii df-ral anbi2i bitri ) CDCEZAFZBFCGZBHZAIZJUFUIACKZLZJA
      BCMUJULUFUJUGUKNZUIOZAIULUIUNAUIUHBPZUIOUNUHBTUMUOUIBUGCAQRUASUBUIAUKUCSU
      DUE $.

    $( Alternate definition of a function.  One possibility for the definition
       of a function in [Enderton] p. 42.  Compare ~ dffun7 .  (Contributed by
       NM, 4-Nov-2002.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    dffun8 $p |- ( Fun A <-> ( Rel A /\ A. x e. dom A E! y x A y ) ) $=
      ( wfun wrel cv wbr wmo cdm wral wa weu dffun7 wex wi wcel df-mo vex eldm
      wb pm5.5 sylbi syl5bb ralbiia anbi2i bitri ) CDCEZAFZBFCGZBHZACIZJZKUGUIB
      LZAUKJZKABCMULUNUGUJUMAUKUJUIBNZUMOZUHUKPZUMUIBQUQUOUPUMTBUHCARSUOUMUAUBU
      CUDUEUF $.

    $( Alternate definition of a function.  (Contributed by NM, 28-Mar-2007.)
       (Revised by NM, 16-Jun-2017.) $)
    dffun9 $p |- ( Fun A <->
                 ( Rel A /\ A. x e. dom A E* y e. ran A x A y ) ) $=
      ( wfun wrel cv wbr wmo cdm wral wa wrmo dffun7 wcel brelrn pm4.71ri mobii
      crn vex df-rmo bitr4i ralbii anbi2i bitri ) CDCEZAFZBFZCGZBHZACIZJZKUEUHB
      CRZLZAUJJZKABCMUKUNUEUIUMAUJUIUGULNZUHKZBHUMUHUPBUHUOUFUGCASBSOPQUHBULTUA
      UBUCUD $.
  $}

  $( An equivalence for the function predicate.  (Contributed by NM,
     13-Aug-2004.) $)
  funfn $p |- ( Fun A <-> A Fn dom A ) $=
    ( wfun cdm wceq wa wfn eqid biantru df-fn bitr4i ) ABZKACZLDZEALFMKLGHALIJ
    $.

  $( The identity relation is a function.  Part of Theorem 10.4 of [Quine]
     p. 65.  (Contributed by NM, 30-Apr-1998.) $)
  funi $p |- Fun _I $=
    ( cid wfun wrel ccnv ccom wss reli wceq relcnv coi2 ax-mp cnvi eqtri df-fun
    eqimssi mpbir2an ) ABACAADZEZAFGRARQAQCRQHAIQJKLMOANP $.

  $( The universe is not a function.  (Contributed by Raph Levien,
     27-Jan-2004.) $)
  nfunv $p |- -. Fun _V $=
    ( cvv wfun wrel cxp wcel 0nelxp 0ex wss df-rel biimpi sseld mpi mto funrel
    c0 ) ABACZPOAADZEZAAFPOAERGPAQOPAQHAIJKLMANM $.

  ${
    $d t u v w x y z A $.  $d t u v w x y z B $.
    $( A Kuratowski ordered pair is a function only if its components are
       equal.  (Contributed by NM, 5-Jun-2008.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    funopg $p |- ( ( A e. V /\ B e. W /\ Fun <. A , B >. ) -> A = B ) $=
      ( vu vt vx vy vz vw vv wcel cop wceq cv weq wi cpr vex cvv funeqd imbi12d
      wfun opeq1 eqeq1 opeq2 eqeq2 csn wa wex wrel funrel relop sylib opth opid
      preq1i dfop preq2i snex zfpair2 3eqtr4ri eqeq2i bitr3i wal dffun4 simprbi
      prid1 eleq2 mpbiri prid2 jca w3a opeq12 3adant3 eleq1d 3adant2 anbi12d wb
      opex eqeq12 3adant1 spc3gv mp3an syl2im syl5bi dfsn2 preq2 syl5req eqeq2d
      eqtr3 expcom syl6bi com13 imp sylcom exlimdvv mpd vtocl2g 3impia ) ACLBDL
      ABMZUCZABNZEOZFOZMZUCZEFPZQAXEMZUCZAXENZQXBXCQEFABCDXDANZXGXJXHXKXLXFXIXD
      AXEUDUAXDAXEUEUBXEBNZXJXBXKXCXMXIXAXEBAUFUAXEBAUGUBXGXDGOZUHZNZXEXNHOZRZN
      ZUIZHUJGUJZXHXGXFUKZYAXFULGHXDXEESZFSZUMUNXGXTXHGHXGXTGHPZXHXTXFXNXNMZXNX
      QMZRZNZXGYEXTXFXOXRMZNYIXDXEXOXRYCYDUOYJYHXFYFXOXRRZRXOUHZYKRYHYJYFYLYKXN
      GSZUPUQYGYKYFXNXQYMHSZURUSXOXRXNUTGHVAURVBVCVDXGIOZJOZMZXFLZYOKOZMZXFLZUI
      ZJKPZQZKVEJVEIVEZYIYFXFLZYGXFLZUIZYEXGYBUUEIJKXFVFVGYIUUFUUGYIUUFYFYHLYFY
      GXNXNVTVHXFYHYFVIVJYIUUGYGYHLYFYGXNXQVTVKXFYHYGVIVJVLXNTLZUUIXQTLUUEUUHYE
      QZQYMYMYNUUDUUJIJKXNXNXQTTTIGPZJGPZKHPZVMZUUBUUHUUCYEUUNYRUUFUUAUUGUUNYQY
      FXFUUKUULYQYFNUUMYOYPXNXNVNVOVPUUNYTYGXFUUKUUMYTYGNUULYOYSXNXQVNVQVPVRUUL
      UUMUUCYEVSUUKYPXNYSXQWAWBUBWCWDWEWFXPXSYEXHQYEXSXPXHYEXSXEXONZXPXHQYEXRXO
      XEYEXOXNXNRXRXNWGXNXQXNWHWIWJXPUUOXHXDXEXOWKWLWMWNWOWPWQWRWSWT $.
  $}


  ${
    $d x y z $.  $d z ph $.
    $( A class of ordered pairs is a function when there is at most one second
       member for each pair.  (Contributed by NM, 16-May-1995.) $)
    funopab $p |- ( Fun { <. x , y >. | ph } <-> A. x E* y ph ) $=
      ( copab wfun wbr wmo wal wrel relopab nfopab1 nfopab2 dffun6f mpbiran cop
      cv wcel df-br opabid bitri mobii albii ) ABCDZEZBPZCPZUCFZCGZBHZACGZBHUDU
      CIUIABCJBCUCABCKABCLMNUHUJBUGACUGUEUFOUCQAUEUFUCRABCSTUAUBT $.
  $}

  ${
    $d x y $.  $d y A $.
    $( A class of ordered pairs of values is a function.  (Contributed by NM,
       14-Nov-1995.) $)
    funopabeq $p |- Fun { <. x , y >. | y = A } $=
      ( cv wceq copab wfun wmo funopab moeq mpgbir ) BDCEZABFGLBHALABIBCJK $.

    $( A class of ordered pairs of values in the form used by ~ df-mpt is a
       function.  (Contributed by NM, 17-Feb-2013.) $)
    funopab4 $p |- Fun { <. x , y >. | ( ph /\ y = A ) } $=
      ( cv wceq wa copab wss wfun simpr ssopab2i funopabeq funss mp2 ) ACEDFZGZ
      BCHZPBCHZISJRJQPBCAPKLBCDMRSNO $.
  $}

  ${
    $d A y $.  $d B y $.  $d x y $.
    $( A function in maps-to notation is a function.  (Contributed by Mario
       Carneiro, 13-Jan-2013.) $)
    funmpt $p |- Fun ( x e. A |-> B ) $=
      ( vy cmpt wfun cv wcel wceq wa copab funopab4 df-mpt funeqi mpbir ) ABCEZ
      FAGBHZDGCIJADKZFQADCLPRADBCMNO $.
  $}

  ${
    funmpt2.1 $e |- F = ( x e. A |-> B ) $.
    $( Functionality of a class given by a "maps to" notation.  (Contributed by
       FL, 17-Feb-2008.)  (Revised by Mario Carneiro, 31-May-2014.) $)
    funmpt2 $p |- Fun F $=
      ( wfun cmpt funmpt funeqi mpbir ) DFABCGZFABCHDKEIJ $.
  $}

  ${
    $d x y z F $.  $d x y z G $.
    $( The composition of two functions is a function.  Exercise 29 of
       [TakeutiZaring] p. 25.  (Contributed by NM, 26-Jan-1997.)  (Proof
       shortened by Andrew Salmon, 17-Sep-2011.) $)
    funco $p |- ( ( Fun F /\ Fun G ) -> Fun ( F o. G ) ) $=
      ( vx vz vy wfun wa cv wbr wex copab wmo wal funmo alrimiv moexexv syl2anr
      ccom funopab sylibr df-co funeqi ) AFZBFZGZCHZDHZBIZUGEHAIZGDJZCEKZFZABRZ
      FUEUJELZCMULUEUNCUDUHDLUIELZDMUNUCDUFBNUCUODEUGANOUHUIDEPQOUJCESTUMUKCEDA
      BUAUBT $.
  $}

  $( A restriction of a function is a function.  Compare Exercise 18 of
     [TakeutiZaring] p. 25.  (Contributed by NM, 16-Aug-1994.) $)
  funres $p |- ( Fun F -> Fun ( F |` A ) ) $=
    ( cres wss wfun wi resss funss ax-mp ) BACZBDBEJEFBAGJBHI $.

  ${
    $d x y F $.  $d x y G $.  $d x y A $.
    $( The restriction of a function to the domain of a subclass equals the
       subclass.  (Contributed by NM, 15-Aug-1994.) $)
    funssres $p |- ( ( Fun F /\ G C_ F ) -> ( F |` dom G ) = G ) $=
      ( vx vy wfun wss wa cdm cres wceq cv cop wcel wb wal wi vex wex imp wrel
      ssel opeldm a1i adantl weu funeu2 eldm2 ancrd eximdv syl5bi eupick syl2an
      jcad exp43 com23 com34 pm2.43d imp3a impbid opelres syl6rbbr relres relss
      alrimivv funrel mpan9 eqrel sylancr mpbird ) AEZBAFZGZABHZIZBJZCKZDKZLZVN
      MZVRBMZNZDOCOZVLWACDVLVTVRAMZVPVMMZGZVSVLVTWEVKVTWEPVJVKVTWCWDBAVRUAZVTWD
      PVKVPVQBCQZDQZUBUCUMUDVLWCWDVTVLWCWDVTPVLWCWDWCVTVJVKWCWDWCVTPZPZPVJWCVKW
      JVJWCVKWDWIVJWCGWCDUEWCVTGZDRZWIVKWDGDVPVQAUFVKWDWLWDVTDRVKWLDVPBWGUGVKVT
      WKDVKVTWCWFUHUIUJSWCVTDUKULUNUOSUPUQURUSVPVQAVMWHUTVAVDVLVNTBTZVOWBNAVMVB
      VJATVKWMAVEBAVCVFCDVNBVGVHVI $.
  $}

  $( Equality of restrictions of a function and a subclass.  (Contributed by
     NM, 16-Aug-1994.) $)
  fun2ssres $p |- ( ( Fun F /\ G C_ F /\ A C_ dom G ) ->
                  ( F |` A ) = ( G |` A ) ) $=
    ( wfun wss cdm cres wceq wa resabs1 eqcomd funssres reseq1d sylan9eqr 3impa
    ) BDZCBEZACFZEZBAGZCAGZHSPQIZTBRGZAGZUASUDTBARJKUBUCCABCLMNO $.

  ${
    $d x y z F $.  $d x y z G $.
    $( The union of functions with disjoint domains is a function.  Theorem 4.6
       of [Monk1] p. 43.  (Contributed by NM, 12-Aug-1994.) $)
    funun $p |- ( ( ( Fun F /\ Fun G ) /\ ( dom F i^i dom G ) = (/) ) ->
                Fun ( F u. G ) ) $=
      ( vx vy vz wfun wa cdm wrel cv wi wal anim12i wo wn 19.21bi opeldm dffun4
      wcel vex cin c0 wceq cun cop funrel relun sylibr elun anbi12i anddi bitri
      adantr disj1 biimpi imnan sylib nsyl orel2 syl con2d orel1 orim12d adantl
      syl5bi simprbi 19.21bbi jaao syld alrimiv alrimivv sylanbrc ) AFZBFZGZAHZ
      BHZUAUBUCZGZABUDZIZCJZDJZUEZVTSZWBEJZUEZVTSZGZWCWFUCZKZELZDLCLVTFVOWAVRVO
      AIZBIZGWAVMWMVNWNAUFBUFMABUGUHUMVSWLCDVSWKEVSWIWDASZWGASZGZWDBSZWGBSZGZNZ
      WJWIWQWOWSGZNZWRWPGZWTNZNZVSXAWIWOWRNZWPWSNZGXFWEXGWHXHWDABUIWGABUIUJWOWR
      WPWSUKULVRXFXAKVOVRXCWQXEWTVRXBOXCWQKVRWBVPSZWBVQSZGZXBVRXIXJOKZXKOVRXLCV
      RXLCLCVPVQUNUOPZXIXJUPUQWOXIWSXJWBWCACTZDTZQWBWFBXNETZQMURXBWQUSUTVRXDOXE
      WTKVRXJXIGZXDVRXJXIOKXQOVRXIXJXMVAXJXIUPUQWRXJWPXIWBWCBXNXOQWBWFAXNXPQMUR
      XDWTVBUTVCVDVEVOXAWJKVRVMWQWJVNWTVMWQWJKZDEVMXRELDLZCVMWMXSCLCDEARVFPVGVN
      WTWJKZDEVNXTELDLZCVNWNYACLCDEBRVFPVGVHUMVIVJVKCDEVTRVL $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The converse singleton of an ordered pair is a function.  This is
       equivalent to ~ funsn via ~ cnvsn , but stating it this way allows us to
       skip the sethood assumptions on ` A ` and ` B ` .  (Contributed by NM,
       30-Apr-2015.) $)
    funcnvsn $p |- Fun `' { <. A , B >. } $=
      ( vx vy cop csn ccnv wfun wrel cv wbr wmo wal relcnv wceq moeq wcel brcnv
      vex df-br bitri elsni opth1 syl sylbi moimi ax-mp ax-gen dffun6 mpbir2an
      ) ABEZFZGZHUMICJZDJZUMKZDLZCMULNUQCUOAOZDLUQDAPUPURDUPUOUNEZULQZURUPUOUNU
      LKUTUNUOULCSZDSZRUOUNULTUAUTUSUKOURUSUKUBUOUNABVBVAUCUDUEUFUGUHCDUMUIUJ
      $.

    $( A singleton of an ordered pair is a function.  Theorem 10.5 of [Quine]
       p. 65.  (Contributed by NM, 28-Jun-2011.) $)
    funsng $p |- ( ( A e. V /\ B e. W ) -> Fun { <. A , B >. } ) $=
      ( wcel wa cop csn ccnv wfun funcnvsn wceq cnvsng ancoms funeqd mpbii ) AC
      EZBDEZFZBAGHIZJABGHZJBAKSTUARQTUALBADCMNOP $.

    $( Functionality and domain of the singleton of an ordered pair.
       (Contributed by Mario Carneiro, 30-Apr-2015.) $)
    fnsng $p |- ( ( A e. V /\ B e. W ) -> { <. A , B >. } Fn { A } ) $=
      ( wcel wa cop csn wfun cdm wceq wfn funsng dmsnopg adantl df-fn sylanbrc
      ) ACEZBDEZFABGHZITJAHZKZTUALABCDMSUBRABDNOTUAPQ $.

    funsn.1 $e |- A e. _V $.
    funsn.2 $e |- B e. _V $.
    $( A singleton of an ordered pair is a function.  Theorem 10.5 of [Quine]
       p. 65.  (Contributed by NM, 12-Aug-1994.) $)
    funsn $p |- Fun { <. A , B >. } $=
      ( cvv wcel cop csn wfun funsng mp2an ) AEFBEFABGHICDABEEJK $.
  $}

  $( A set of two pairs is a function if their first members are different.
     (Contributed by FL, 26-Jun-2011.) $)
  funprg $p |- ( ( ( A e. V /\ B e. W ) /\ ( C e. X /\ D e. Y ) /\ A =/= B )
     -> Fun { <. A , C >. , <. B , D >. } ) $=
    ( wcel wa cop csn wfun cdm cin c0 wceq funsng syl2anc dmsnopg simp1l simp2l
    wne w3a cun cpr simp1r simp2r ineq12d disjsn2 3ad2ant3 eqtrd funun syl21anc
    syl df-pr funeqi sylibr ) AEIZBFIZJZCGIZDHIZJZABUCZUDZACKZLZBDKZLZUEZMZVGVI
    UFZMVFVHMZVJMZVHNZVJNZOZPQVLVFUSVBVNUSUTVDVEUAVAVBVCVEUBZACEGRSVFUTVCVOUSUT
    VDVEUGVAVBVCVEUHZBDFHRSVFVRALZBLZOZPVFVPWAVQWBVFVBVPWAQVSACGTUOVFVCVQWBQVTB
    DHTUOUIVEVAWCPQVDABUJUKULVHVJUMUNVMVKVGVIUPUQUR $.

  $( A set of three pairs is a function if their first members are different.
     (Contributed by Alexander van der Vekens, 5-Dec-2017.) $)
  funtpg $p |- ( ( ( X e. U /\ Y e. V /\ Z e. W )
                   /\ ( A e. F /\ B e. G /\ C e. H )
                   /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) )
                 -> Fun { <. X , A >. , <. Y , B >. , <. Z , C >. } ) $=
    ( wcel w3a wne cop wfun wceq syl wn cpr csn cun ctp cdm cin c0 3simpa simp1
    funprg syl3an simp13 simp23 funsng syl2anc 3ad2ant2 dmpropg dmsnopg ineq12d
    wa elpri w3o nne biimpri eqcoms 3mix2 3mix3 jaoi 3ianor sylibr con2i disjsn
    wo 3ad2ant3 eqtrd funun syl21anc df-tp funeqi ) JDMZKHMZLIMZNZAEMZBFMZCGMZN
    ZJKOZJLOZKLOZNZNZJAPZKBPZUAZLCPZUBZUCZQZWMWNWPUDZQWLWOQZWQQZWOUEZWQUEZUFZUG
    RWSWCVTWAUTWGWDWEUTZWKWHXAVTWAWBUHWDWEWFUHZWHWIWJUIJKABDHEFUJUKWLWBWFXBVTWA
    WBWGWKULWCWDWEWFWKUMZLCIGUNUOWLXEJKUAZLUBZUFZUGWLXCXIXDXJWLXFXCXIRWGWCXFWKX
    GUPJAKBEFUQSWLWFXDXJRXHLCGURSUSWKWCXKUGRZWGWKLXIMZTXLXMWKXMLJRZLKRZVMZWKTZL
    JKVAXPWHTZWITZWJTZVBZXQXNYAXOXNXSYAXSJLXSJLRJLVCVDVEXSXRXTVFSXOXTYAXTKLXTKL
    RKLVCVDVEXTXRXSVGSVHWHWIWJVIVJSVKXILVLVJVNVOWOWQVPVQWTWRWMWNWPVRVSVJ $.

  ${
    funpr.1 $e |- A e. _V $.
    funpr.2 $e |- B e. _V $.
    funpr.3 $e |- C e. _V $.
    funpr.4 $e |- D e. _V $.
    $( A function with a domain of two elements.  (Contributed by Jeff Madsen,
       20-Jun-2010.) $)
    funpr $p |- ( A =/= B -> Fun { <. A , C >. , <. B , D >. } ) $=
      ( cvv wcel wa wne cop cpr wfun pm3.2i funprg mp3an12 ) AIJZBIJZKCIJZDIJZK
      ABLACMBDMNOSTEFPUAUBGHPABCDIIIIQR $.
  $}

  ${
    funtp.1 $e |- A e. _V $.
    funtp.2 $e |- B e. _V $.
    funtp.3 $e |- C e. _V $.
    funtp.4 $e |- D e. _V $.
    funtp.5 $e |- E e. _V $.
    funtp.6 $e |- F e. _V $.
    $( A function with a domain of three elements.  (Contributed by NM,
       14-Sep-2011.) $)
    funtp $p |- ( ( A =/= B /\ A =/= C /\ B =/= C )
                    -> Fun { <. A , D >. , <. B , E >. , <. C , F >. } ) $=
      ( wne cop csn wfun wa cin c0 wceq w3a cpr cun ctp funpr funsn jctir df-pr
      cdm dmprop eqtri dmsnop ineq12i disjsn2 anim12i sylib syl5eq funun syl2an
      undisj1 3impb df-tp funeqi sylibr ) ABMZACMZBCMZUAADNZBENZUBZCFNZOZUCZPZV
      HVIVKUDZPVEVFVGVNVEVJPZVLPZQVJUIZVLUIZRZSTVNVFVGQZVEVPVQABDEGHJKUECFILUFU
      GWAVTAOZBOZUCZCOZRZSVRWDVSWEVRABUBWDADBEJKUJABUHUKCFLULUMWAWBWERSTZWCWERS
      TZQWFSTVFWGVGWHACUNBCUNUOWBWCWEUTUPUQVJVLURUSVAVOVMVHVIVKVBVCVD $.
  $}

  ${
    fnsn.1 $e |- A e. _V $.
    fnsn.2 $e |- B e. _V $.
    $( Functionality and domain of the singleton of an ordered pair.
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.) $)
    fnsn $p |- { <. A , B >. } Fn { A } $=
      ( cvv wcel cop csn wfn fnsng mp2an ) AEFBEFABGHAHICDABEEJK $.
  $}

  $( Function with a domain of two different values.  (Contributed by FL,
     26-Jun-2011.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
  fnprg $p |- ( ( ( A e. V /\ B e. W ) /\ ( C e. X /\ D e. Y ) /\ A =/= B )
         -> { <. A , C >. , <. B , D >. } Fn { A , B } ) $=
    ( wcel wa wne w3a cop cpr wfun cdm wceq wfn funprg dmpropg 3ad2ant2 df-fn
    sylanbrc ) AEIBFIJZCGIDHIJZABKZLACMBDMNZOUGPABNZQZUGUHRABCDEFGHSUEUDUIUFACB
    DGHTUAUGUHUBUC $.

  $( Function with a domain of three different values.  (Contributed by
     Alexander van der Vekens, 5-Dec-2017.) $)
  fntpg $p |- ( ( ( X e. U /\ Y e. V /\ Z e. W )
                  /\ ( A e. F /\ B e. G /\ C e. H )
                  /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) )
           -> { <. X , A >. , <. Y , B >. , <. Z , C >. } Fn { X , Y , Z } ) $=
    ( wcel w3a wne cop cdm wceq csn cun ctp wfun wfn funtpg wa dmsnopg 3ad2ant1
    cpr 3ad2ant2 jca uneq12 syl df-pr syl6eqr dmeqi eqeq1i dmun sylibr 3ad2ant3
    bitri uneq12d df-tp eqtri 3eqtr4g df-fn sylanbrc ) JDMKHMLIMNZAEMZBFMZCGMZN
    ZJKOJLOKLONZNZJAPZKBPZLCPZUAZUBVQQZJKLUAZRVQVSUCABCDEFGHIJKLUDVMVNVOUHZQZVP
    SZQZTZJKUHZLSZTVRVSVMWAWEWCWFVMVNSZQZVOSZQZTZWERZWAWERZVMWKJSZKSZTZWEVMWHWN
    RZWJWORZUEZWKWPRVKVGWSVLVKWQWRVHVIWQVJJAEUFUGVIVHWRVJKBFUFUIUJUIWHWNWJWOUKU
    LJKUMUNWMWGWITZQZWERWLWAXAWEVTWTVNVOUMUOUPXAWKWEWGWIUQUPUTURVKVGWCWFRZVLVJV
    HXBVILCGUFUSUIVAVRVTWBTZQWDVQXCVNVOVPVBUOVTWBUQVCJKLVBVDVQVSVEVF $.

  ${
    fntp.1 $e |- A e. _V $.
    fntp.2 $e |- B e. _V $.
    fntp.3 $e |- C e. _V $.
    fntp.4 $e |- D e. _V $.
    fntp.5 $e |- E e. _V $.
    fntp.6 $e |- F e. _V $.
    $( A function with a domain of three elements.  (Contributed by NM,
       14-Sep-2011.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    fntp $p |- ( ( A =/= B /\ A =/= C /\ B =/= C )
          -> { <. A , D >. , <. B , E >. , <. C , F >. } Fn { A , B , C } ) $=
      ( wne w3a cop ctp wfun cdm wceq wfn funtp dmtpop a1i df-fn sylanbrc ) ABM
      ACMBCMNZADOBEOCFOPZQUGRABCPZSZUGUHTABCDEFGHIJKLUAUIUFADBECFJKLUBUCUGUHUDU
      E $.
  $}

  $( The empty set is a function.  Theorem 10.3 of [Quine] p. 65.  (Contributed
     by NM, 7-Apr-1998.) $)
  fun0 $p |- Fun (/) $=
    ( c0 cop csn wss wfun 0ss 0ex funsn funss mp2 ) AAABCZDKEAEKFAAGGHAKIJ $.

  $( The double converse of a function is a function.  (Contributed by NM,
     21-Sep-2004.) $)
  funcnvcnv $p |- ( Fun A -> Fun `' `' A ) $=
    ( ccnv wss wfun wi cnvcnvss funss ax-mp ) ABBZACADIDEAFIAGH $.

  ${
    $d f g x y z w v A $.  $d x y B $.  $d x y R $.
    $( A simpler equivalence for single-rooted (see ~ funcnv ).  (Contributed
       by NM, 9-Aug-2004.) $)
    funcnv2 $p |- ( Fun `' A <-> A. y E* x x A y ) $=
      ( ccnv wfun cv wbr wmo wrel relcnv dffun6 mpbiran brcnv mobii albii bitri
      wal vex ) CDZEZBFZAFZSGZAHZBQZUBUACGZAHZBQTSIUECJBASKLUDUGBUCUFAUAUBCBRAR
      MNOP $.

    $( The converse of a class is a function iff the class is single-rooted,
       which means that for any ` y ` in the range of ` A ` there is at most
       one ` x ` such that ` x A y ` .  Definition of single-rooted in
       [Enderton] p. 43.  See ~ funcnv2 for a simpler version.  (Contributed by
       NM, 13-Aug-2004.) $)
    funcnv $p |- ( Fun `' A <-> A. y e. ran A E* x x A y ) $=
      ( cv wbr wmo wal crn wcel wi ccnv wfun wral wa vex pm4.71ri mobii moanimv
      brelrn bitri albii funcnv2 df-ral 3bitr4i ) ADZBDZCEZAFZBGUFCHZIZUHJZBGCK
      LUHBUIMUHUKBUHUJUGNZAFUKUGULAUGUJUEUFCAOBOSPQUJUGARTUAABCUBUHBUIUCUD $.

    $( A condition showing a class is single-rooted.  (See ~ funcnv ).
       (Contributed by NM, 26-May-2006.) $)
    funcnv3 $p |- ( Fun `' A <-> A. y e. ran A E! x e. dom A x A y ) $=
      ( cv wbr wmo crn wral wex ccnv wfun cdm wreu wcel dfrn2 abeq2i biimpi weu
      wa vex biantrurd ralbiia funcnv df-reu breldm pm4.71ri eu5 3bitr2i ralbii
      eubii 3bitr4i ) ADZBDZCEZAFZBCGZHUNAIZUOSZBUPHCJKUNACLZMZBUPHUOURBUPUMUPN
      ZUQUOVAUQUQBUPABCOPQUAUBABCUCUTURBUPUTULUSNZUNSZARUNARURUNAUSUDUNVCAUNVBU
      LUMCATBTUEUFUJUNAUGUHUIUK $.

    $( The double converse of a class is a function iff the class is
       single-valued.  Each side is equivalent to Definition 6.4(2) of
       [TakeutiZaring] p. 23, who use the notation "Un(A)" for single-valued.
       Note that ` A ` is not necessarily a function.  (Contributed by NM,
       13-Aug-2004.) $)
    fun2cnv $p |- ( Fun `' `' A <-> A. x E* y x A y ) $=
      ( ccnv wfun cv wbr wmo wal funcnv2 vex brcnv mobii albii bitri ) CDZDEBFZ
      AFZPGZBHZAIRQCGZBHZAIBAPJTUBASUABQRCBKAKLMNO $.

    $( A single-valued relation is a function.  (See ~ fun2cnv for
       "single-valued.") Definition 6.4(4) of [TakeutiZaring] p. 24.
       (Contributed by NM, 17-Jan-2006.) $)
    svrelfun $p |- ( Fun A <-> ( Rel A /\ Fun `' `' A ) ) $=
      ( vx vy wfun wrel cv wbr wmo wal wa ccnv dffun6 fun2cnv anbi2i bitr4i ) A
      DAEZBFCFAGCHBIZJPAKKDZJBCALRQPBCAMNO $.

    $( Single-rootedness (see ~ funcnv ) of a class cut down by a cross
       product.  (Contributed by NM, 5-Mar-2007.) $)
    fncnv $p |- ( `' ( R i^i ( A X. B ) ) Fn B <->
                  A. y e. B E! x e. A x R y ) $=
      ( cxp cin ccnv wfn wfun cdm wceq wa cv wbr wral wmo wcel wi 3bitr4i df-fn
      crn wreu df-rn eqeq1i anbi2i wrex wrmo rninxp anbi1i funcnv raleq moanimv
      biimt w3a brinxp2 3anan12 bitri mobii df-rmo imbi2i ralbiia syl6bb syl5bb
      syl6rbbr pm5.32i r19.26 ancom reu5 ralbii 3bitr2i ) ECDFGZHZDIVMJZVMKZDLZ
      MVNVLUBZDLZMZANZBNZEOZACUCZBDPZVMDUAVRVPVNVQVODVLUDUEUFVRVNMZWBACUGZWBACU
      HZMZBDPZVSWDVRWGBDPZMWFBDPZWJMWEWIVRWKWJABCDEUIUJVRVNWJVNVTWAVLOZAQZBVQPZ
      VRWJABVLUKVRWNWMBDPWJWMBVQDULWMWGBDWADRZWGWOWGSZWMWOWGUNWOVTCRZWBMZMZAQWO
      WRAQZSWMWPWOWRAUMWLWSAWLWQWOWBUOWSVTWACDEUPWQWOWBUQURUSWGWTWOWBACUTVATVEV
      BVCVDVFWFWGBDVGTVNVRVHWCWHBDWBACVIVJTVK $.

    $( Two ways of stating that ` A ` is one-to-one (but not necessarily a
       function).  Each side is equivalent to Definition 6.4(3) of
       [TakeutiZaring] p. 24, who use the notation "Un_2 (A)" for one-to-one
       (but not necessarily a function).  (Contributed by NM, 17-Jan-2006.) $)
    fun11 $p |- ( ( Fun `' `' A /\ Fun `' A ) <->
         A. x A. y A. z A. w ( ( x A y /\ z A w ) -> ( x = z <-> y = w ) ) ) $=
      ( cv wbr wa weq wi wal ccnv wfun bi2.04 anbi12i 2albii alcom albii 3bitri
      19.26-2 wb dfbi2 imbi2i pm4.76 nfv breq1 anbi1d imbi1d equsal bitri breq2
      3bitr2i bitr2i wmo fun2cnv mo4 funcnv2 alrot4 3bitr4i ) CFZBFZEGZUTDFZEGZ
      HZBDIZJZBKZDKZCKZAFZVCEGZVDHZACIZJZAKZDKCKZHZVKVAEGZVDHZVNVFUAZJZBKAKZDKC
      KZELZLMZWEMZHWBDKCKBKAKWDVHVPHZDKCKVRWCWHCDWCVNVTVFJZJZVFVTVNJZJZHZBKAKWJ
      BKAKZWLBKZAKZHWHWBWMABWBVTVNVFJZVFVNJZHZJVTWQJZVTWRJZHWMWAWSVTVNVFUBUCVTW
      QWRUDWTWJXAWLVTVNVFNVTVFVNNOULPWJWLABTWNVHWPVPWNWJAKZBKVHWJABQXBVGBWIVGAC
      VGAUEVNVTVEVFVNVSVBVDVKUTVAEUFUGUHUIRUJWOVOAWKVOBDVOBUEVFVTVMVNVFVSVLVDVA
      VCVKEUKUGUHUIROSPVHVPCDTUMWFVJWGVQWFVBBUNZCKVGDKBKZCKVJCBEUOXCXDCVBVDBDVA
      VCUTEUKUPRXDVICVGBDQRSWGVLAUNZDKVOCKAKZDKZVQADEUQXEXFDVLVDACVKUTVCEUFUPRX
      GVPCKZDKVQXFXHDVOACQRVPDCQUJSOWBABCDURUS $.

    $( The union of a chain (with respect to inclusion) of functions is a
       function.  (Contributed by NM, 10-Aug-2004.) $)
    fununi $p |- ( A. f e. A ( Fun f /\ A. g e. A ( f C_ g \/ g C_ f ) ) ->
                 Fun U. A ) $=
      ( vx vy vz vw vv cv wfun wss wo wral wa wrel wcel weq wi wal wex cuni cop
      funrel adantr ralimi reluni sylibr r19.28av anim1d dffun4 simprbi 19.21bi
      ssel 19.21bbi syl9r adantl anim2d jaod funeq sseq1 orbi12d anbi12d anbi2d
      sseq2 cbvral2v ralcom orcom syl5bb bitri anbi12i anandir 2ralbii r19.26-2
      imp anidm bitr2i 3bitr3i eluni eeanv an4 ancom 2exbii 3bitr2i imbi1i r2al
      19.23v impexp 2albii albii 3bitr2ri 3imtr4i alrimiv alrimivv syl sylanbrc
      ) BIZJZWPCIZKZWRWPKZLZCAMZNZBAMZAUAZOZDIZEIUBZXEPZXGFIUBZXEPZNZEFQZRZFSZE
      SDSZXEJXDWPOZBAMXFXCXQBAWQXQXBWPUCUDUEBAUFUGXDWQXANZCAMZBAMZXPXCXSBAWQXAC
      AUHUEXTXODEXTXNFGIZJZHIZJZNZYAYCKZYCYAKZLZNZHAMZGAMZXHYAPZXJYCPZNZXMRZHAM
      ZGAMZXTXNYJYPGAYIYOHAYEYHYOYEYFYOYGYDYFYORYBYFYNXHYCPZYMNZYDXMYFYLYRYMYAY
      CXHUMUIYDYSXMRZFYDYTFSZDEYDYCOUUAESDSDEFYCUJUKUNULUOUPYBYGYORYDYGYNYLXJYA
      PZNZYBXMYGYMUUBYLYCYAXJUMUQYBUUCXMRZFYBUUDFSZDEYBYAOUUEESDSDEFYAUJUKUNULU
      OUDURVNUEUEXTXTNYBYHNZHAMGAMZYDYHNZHAMGAMZNZXTYKXTUUGXTUUIXRUUFYBYAWRKZWR
      YAKZLZNBCGHAABGQZWQYBXAUUMWPYAUSUUNWSUUKWTUULWPYAWRUTWPYAWRVDVAVBCHQZUUMY
      HYBUUOUUKYFUULYGWRYCYAVDWRYCYAUTVAVCVEXTXRBAMCAMUUIXRBCAAVFXRUUHWQYAWPKZW
      PYAKZLZNCBGHAACGQZXAUURWQXAWTWSLUUSUURWSWTVGUUSWTUUPWSUUQWRYAWPUTWRYAWPVD
      VAVHVCBHQZWQYDUURYHWPYCUSUUTUUPYFUUQYGWPYCYAVDWPYCYAUTVAVBVEVIVJXTVOYKUUF
      UUHNZHAMGAMUUJYIUVAGHAAYBYDYHVKVLUUFUUHGHAAVMVPVQXNYAAPZYCAPZNZYNNZHTZGTZ
      XMRUVFXMRZGSZYQXLUVGXMXLYLUVBNZGTZYMUVCNZHTZNUVJUVLNZHTGTUVGXIUVKXKUVMGXH
      AVRHXJAVRVJUVJUVLGHVSUVNUVEGHUVNYNUVDNUVEYLUVBYMUVCVTYNUVDWAVIWBWCWDUVFXM
      GWFYQUVDYORZHSGSUVEXMRZHSZGSUVIYOGHAAWEUVPUVOGHUVDYNXMWGWHUVQUVHGUVEXMHWF
      WIWJWCWKWLWMWNDEFXEUJWO $.

    $( The union of a chain (with respect to inclusion) of single-rooted sets
       is single-rooted.  (See ~ funcnv for "single-rooted" definition.)
       (Contributed by NM, 11-Aug-2004.) $)
    funcnvuni $p |- ( A. f e. A ( Fun `' f /\ A. g e. A ( f C_ g \/ g C_ f ) )
                    -> Fun `' U. A ) $=
      ( vy vx vz vw vv cv ccnv wfun wss wo wral wa wceq wrex wi wal weq cbvrexv
      cab cuni cnveq eqeq2d wcel funeqd sseq1 sseq2 orbi12d ralbidv rspcv funeq
      anbi12d biimprcd cnvss orim12i wb sseq12 ancoms syl5ibrcom exp3a rexlimdv
      syl6com com23 alrimdv anim12ii syl5bi alrimiv df-ral vex eqeq1 elab ralab
      rexbidv anbi2i imbi12i albii bitr2i sylib fununi ciun cnvuni cnvex dfiun2
      syl eqtri funeqi sylibr ) BIZJZKZWJCIZLZWMWJLZMZCANZOZBANZDIZEIZJZPZEAQZD
      UBZUCZKZAUCJZKWSFIZKZXIGIZLZXKXILZMZGXENZOZFXENZXGWSXIXBPZEAQZXJXKXBPZEAQ
      ZXNRZGSZOZRZFSZXQWSYEFXSXIHIZJZPZHAQWSYDXRYIEHAEHTXBYHXIXAYGUDUEUAWSYIYDH
      AYGAUFWSYHKZYGWMLZWMYGLZMZCANZOZYIYDRWRYOBYGABHTZWLYJWQYNYPWKYHWJYGUDUGYP
      WPYMCAYPWNYKWOYLWJYGWMUHWJYGWMUIUJUKUNULYJYIXJYNYCYIXJYJXIYHUMUOYNYIYBGYN
      YAYIXNYNXTYIXNRZEAXAAUFYNYGXALZXAYGLZMZXTYQRYMYTCXAACETYKYRYLYSWMXAYGUIWM
      XAYGUHUJULYTXTYIXNYTXNXTYIOZYHXBLZXBYHLZMYRUUBYSUUCYGXAUPXAYGUPUQUUAXLUUB
      XMUUCYIXTXLUUBURXIYHXKXBUSUTXKXBXIYHUSUJVAVBVDVCVEVFVGVDVCVHVIXQXIXEUFZXP
      RZFSYFXPFXEVJUUEYEFUUDXSXPYDXDXSDXIFVKDFTXCXREAWTXIXBVLVOVMXOYCXJXDYAXNGD
      DGTXCXTEAWTXKXBVLVOVNVPVQVRVSVTXEFGWAWFXHXFXHEAXBWBXFEAWCEDAXBXAEVKWDWEWG
      WHWI $.

    $( The union of a chain (with respect to inclusion) of one-to-one functions
       is a one-to-one function.  (Contributed by NM, 11-Aug-2004.) $)
    fun11uni $p |- ( A. f e. A ( ( Fun f /\ Fun `' f ) /\
                   A. g e. A ( f C_ g \/ g C_ f ) ) ->
                   ( Fun U. A /\ Fun `' U. A ) ) $=
      ( cv wfun ccnv wa wo wral cuni simpl anim1i ralimi fununi simpr funcnvuni
      wss syl jca ) BDZEZTFEZGZTCDZQUDTQHCAIZGZBAIZAJZEZUHFEZUGUAUEGZBAIUIUFUKB
      AUCUAUEUAUBKLMABCNRUGUBUEGZBAIUJUFULBAUCUBUEUAUBOLMABCPRS $.
  $}

  ${
    $d x y F $.  $d x y G $.
    $( The intersection with a function is a function.  Exercise 14(a) of
       [Enderton] p. 53.  (Contributed by NM, 19-Mar-2004.)  (Proof shortened
       by Andrew Salmon, 17-Sep-2011.) $)
    funin $p |- ( Fun F -> Fun ( F i^i G ) ) $=
      ( cin wss wfun wi inss1 funss ax-mp ) ABCZADAEJEFABGJAHI $.
  $}

  $( The restriction of a one-to-one function is one-to-one.  (Contributed by
     NM, 25-Mar-1998.) $)
  funres11 $p |- ( Fun `' F -> Fun `' ( F |` A ) ) $=
    ( cres wss ccnv wfun wi resss cnvss funss mp2b ) BACZBDLEZBEZDNFMFGBAHLBIMN
    JK $.

  $( The converse of a restricted function.  (Contributed by NM,
     27-Mar-1998.) $)
  funcnvres $p |- ( Fun `' F -> `' ( F |` A ) = ( `' F |` ( F " A ) ) ) $=
    ( ccnv wfun cima cres cdm df-ima df-rn eqtri reseq2i wceq resss cnvss ax-mp
    crn wss funssres mpan2 syl5req ) BCZDZUABAEZFUABAFZCZGZFZUEUCUFUAUCUDPUFBAH
    UDIJKUBUEUAQZUGUELUDBQUHBAMUDBNOUAUERST $.

  $( Converse of a restricted identity function.  (Contributed by FL,
     4-Mar-2007.) $)
  cnvresid $p |- `' ( _I |` A ) = ( _I |` A ) $=
    ( cid ccnv wceq wfun cres cnvi eqcomi funi funeq cima funcnvres imai syl6eq
    mpbii reseq12i mp2b ) BBCZDZREZBAFZCZUADRBGHSBETIBRJOTUBRBAKZFUAABLRBUCAGAM
    PNQ $.

  $( The converse of a restriction of the converse of a function equals the
     function restricted to the image of its converse.  (Contributed by NM,
     4-May-2005.) $)
  funcnvres2 $p |- ( Fun F -> `' ( `' F |` A ) = ( F |` ( `' F " A ) ) ) $=
    ( wfun ccnv cres cima wceq funcnvcnv funcnvres syl wrel funrel dfrel2 sylib
    reseq1d eqtrd ) BCZBDZAEDZRDZRAFZEZBUAEQTCSUBGBHARIJQTBUAQBKTBGBLBMNOP $.

  $( The image of the preimage of a function.  (Contributed by NM,
     25-May-2004.) $)
  funimacnv $p |- ( Fun F -> ( F " ( `' F " A ) ) = ( A i^i ran F ) ) $=
    ( wfun ccnv cima cres crn cin funcnvres2 rneqd df-ima syl6reqr df-rn ineq2i
    cdm dmres dfdm4 3eqtr2ri syl6eq ) BCZBBDZAEZEZUAAFZDZGZABGZHZTUFBUBFZGUCTUE
    UIABIJBUBKLUHAUAOZHUDOUFUGUJABMNUAAPUDQRS $.

  $( A kind of contraposition law that infers a subclass of an image from a
     preimage subclass.  (Contributed by NM, 25-May-2004.) $)
  funimass1 $p |- ( ( Fun F /\ A C_ ran F ) ->
                 ( ( `' F " A ) C_ B -> A C_ ( F " B ) ) ) $=
    ( ccnv cima wss wfun crn wa imass2 funimacnv wceq dfss biimpi eqcomd sseq1d
    cin sylan9eq syl5ib ) CDAEZBFCTEZCBEZFCGZACHZFZIZAUBFTBCJUFUAAUBUCUEUAAUDQZ
    AACKUEAUGUEAUGLAUDMNORPS $.

  $( A kind of contraposition law that infers an image subclass from a subclass
     of a preimage.  (Contributed by NM, 25-May-2004.) $)
  funimass2 $p |- ( ( Fun F /\ A C_ ( `' F " B ) ) -> ( F " A ) C_ B ) $=
    ( ccnv cima wss wfun imass2 crn cin funimacnv sseq2d inss1 sstr2 mpi syl6bi
    imp sylan2 ) ACDBEZFCGZCAEZCSEZFZUABFZASCHTUCUDTUCUABCIZJZFZUDTUBUFUABCKLUG
    UFBFUDBUEMUAUFBNOPQR $.

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( The image of a difference is the difference of images.  (Contributed by
       NM, 24-May-1998.) $)
    imadif $p |- ( Fun `' F ->
                 ( F " ( A \ B ) ) = ( ( F " A ) \ ( F " B ) ) ) $=
      ( vy vx cdif cima cv wcel wbr wa wex wn exbii wi wmo vex sylib wo elima2
      ccnv wfun anandir 19.40 sylbi wal nfv nfe1 funmo brcnv mobii mopick sylan
      nfan con2d imnan alrimi exancom alnex 3imtr3g anim2d syl5 19.29r sylan2br
      ex andi ianor anbi2i an32 pm3.24 intnan anass mtbir bitri 3bitr4i impbid1
      biorfi eldif anbi1i notbii anbi12i 3bitr4g eqrdv ) CUAZUBZDCABFZGZCAGZCBG
      ZFZWEEHZWFIZWKDHZCJZKZELZWMWHIZWMWIIZMZKZWMWGIWMWJIWEWKAIZWKBIZMZKZWNKZEL
      ZXAWNKZELZXBWNKZELZMZKZWPWTWEXFXLXFXHXCWNKZELZKZWEXLXFXGXMKZELXOXEXPEXAXC
      WNUCNXGXMEUDUEWEXNXKXHWEWNXCKZELZXIMZEUFZXNXKWEXRXTWEXRKZXSEWEXREWEEUGXQE
      UHUNYAXBWNMZOXSYAWNXBWEWNEPZXRWNXCOWEWMWKWDJZEPYCEWMWDUIYDWNEWMWKCDQZEQUJ
      UKRWNXCEULUMUOXBWNUPRUQVEWNXCEURXIEUSZUTVAVBXLXGXSKZELZXFXKXHXTYHYFXGXSEV
      CVDYGXEEXGXCYBSZKXGXCKZXGYBKZSZYGXEXGXCYBVFXSYIXGXBWNVGVHXEYJYLXAXCWNVIYK
      YJYKXAWNYBKZKYMXAWNVJVKXAWNYBVLVMVQVNVONRVPWOXEEWLXDWNWKABVRVSNWQXHWSXKEW
      MCAYETWRXJEWMCBYETVTWAWBEWMCWFYETWMWHWIVRWBWC $.
  $}

  $( The image of an intersection is the intersection of images.  (Contributed
     by Paul Chapman, 11-Apr-2009.) $)
  imain $p |- ( Fun `' F ->
                ( F " ( A i^i B ) ) = ( ( F " A ) i^i ( F " B ) ) ) $=
    ( ccnv wfun cdif cima cin imadif difeq2d eqtrd dfin4 imaeq2i 3eqtr4g ) CDEZ
    CAABFZFZGZCAGZSCBGZFZFZCABHZGSTHORSCPGZFUBAPCIOUDUASABCIJKUCQCABLMSTLN $.

  ${
    $d w B $.  $d x y z w A $.
    $( Axiom of Replacement using abbreviations.  Axiom 39(vi) of [Quine]
       p. 284.  Compare Exercise 9 of [TakeutiZaring] p. 29.  (Contributed by
       NM, 10-Sep-2006.) $)
    funimaexg $p |- ( ( Fun A /\ B e. C ) -> ( A " B ) e. _V ) $=
      ( vw vx vy vz wcel wfun cima cvv cv wceq imaeq2 eleq1d wal wex wel bitri
      wi imbi2d cop wrel dffun5 simprbi wa wb nfv axrep4 isset cab dfima3 abeq2
      eqeq2i exbii sylibr syl vtoclg impcom ) BCHAIZABJZKHZUTADLZJZKHZTUTVBTDBC
      VCBMZVEVBUTVFVDVAKVCBANOUAUTELFLZUBAHZVGGLZMTFPGQEPZVEUTAUCVJEFGAUDUEVJFG
      REDRVHUFEQZUGFPZGQZVEVHEFGDVHGUHUIVEVIVDMZGQVMGVDUJVNVLGVNVIVKFUKZMVLVDVO
      VIEFAVCULUNVKFVIUMSUOSUPUQURUS $.
  $}

  ${
    zfrep5.1 $e |- B e. _V $.
    $( The image of a set under any function is also a set.  Equivalent of
       Axiom of Replacement ~ ax-rep .  Axiom 39(vi) of [Quine] p. 284.
       Compare Exercise 9 of [TakeutiZaring] p. 29.  (Contributed by NM,
       17-Nov-2002.) $)
    funimaex $p |- ( Fun A -> ( A " B ) e. _V ) $=
      ( wfun cvv wcel cima funimaexg mpan2 ) ADBEFABGEFCABEHI $.
  $}

  ${
    $d x z A $.  $d b x y z $.  $d z ph $.
    $( Part of a study of the Axiom of Replacement used by the Isabelle
       prover.  The object PrimReplace is apparently the image of the function
       encoded by ` ph ( x , y ) ` i.e. the class
       ` ( { <. x , y >. | ph } " A ) ` .  If so, we can prove Isabelle's
       "Axiom of Replacement" conclusion without using the Axiom of
       Replacement, for which I (N. Megill) currently have no explanation.
       (Contributed by NM, 26-Oct-2006.)  (Proof shortened by Mario Carneiro,
       4-Dec-2016.) $)
    isarep1 $p |- ( b e. ( { <. x , y >. | ph } " A ) <->
                 E. x e. A [ b / y ] ph ) $=
      ( vz copab cima wcel wbr wrex wsb vex elima cop wsbc df-br sbsbc 3bitri
      cv opelopabsb sbbii bitr2i rexbii nfs1v nfv sbequ12r cbvrex ) ETZABCGZDHI
      FTZUIUJJZFDKACELZBFLZFDKUMBDKFUIUJDEMNULUNFDULUKUIOUJIACUIPZBUKPZUNUKUIUJ
      QABCUKUIUAUNUOBFLUPUMUOBFACERUBUOBFRUCSUDUNUMFBDUMBFUEUMFUFUMFBUGUHS $.
  $}

  ${
    $d w x y A $.  $d b x y $.  $d y z $.  $d w ph $.  $d z ph $.
    isarep2.1 $e |- A e. _V $.
    isarep2.2 $e |- A. x e. A A. y A. z ( ( ph /\ [ z / y ] ph ) -> y = z ) $.
    $( Part of a study of the Axiom of Replacement used by the Isabelle
       prover.  In Isabelle, the sethood of PrimReplace is apparently
       postulated implicitly by its type signature " ` [ ` i, ` [ ` i, i ` ] `
       => o ` ] ` => i", which automatically asserts that it is a set without
       using any axioms.  To prove that it is a set in Metamath, we need the
       hypotheses of Isabelle's "Axiom of Replacement" as well as the Axiom of
       Replacement in the form ~ funimaex .  (Contributed by NM,
       26-Oct-2006.) $)
    isarep2 $p |- E. w w = ( { <. x , y >. | ph } " A ) $=
      ( copab cima cv wcel wa cvv cres resima resopab wmo wi wal imaeq1i eqtr3i
      wfun funopab wsb weq rspec nfv sylibr moanimv mpbir mpgbir funimaex ax-mp
      mo3 eqeltri isseti ) EABCIZFJZUSBKFLZAMZBCIZFJZNURFOZFJUSVCURFPVDVBFABCFQ
      UAUBVBUCZVCNLVEVACRZBVABCUDVFUTACRZSUTAACDUEMCDUFSDTCTZVGVHBFHUGACDADUHUO
      UIUTACUJUKULVBFGUMUNUPUQ $.
  $}

  $( Equality theorem for function predicate with domain.  (Contributed by NM,
     1-Aug-1994.) $)
  fneq1 $p |- ( F = G -> ( F Fn A <-> G Fn A ) ) $=
    ( wceq wfun cdm wa wfn funeq dmeq eqeq1d anbi12d df-fn 3bitr4g ) BCDZBEZBFZ
    ADZGCEZCFZADZGBAHCAHOPSRUABCIOQTABCJKLBAMCAMN $.

  $( Equality theorem for function predicate with domain.  (Contributed by NM,
     1-Aug-1994.) $)
  fneq2 $p |- ( A = B -> ( F Fn A <-> F Fn B ) ) $=
    ( wceq wfun cdm wa wfn eqeq2 anbi2d df-fn 3bitr4g ) ABDZCEZCFZADZGNOBDZGCAH
    CBHMPQNABOIJCAKCBKL $.

  ${
    fneq1d.1 $e |- ( ph -> F = G ) $.
    $( Equality deduction for function predicate with domain.  (Contributed by
       Paul Chapman, 22-Jun-2011.) $)
    fneq1d $p |- ( ph -> ( F Fn A <-> G Fn A ) ) $=
      ( wceq wfn wb fneq1 syl ) ACDFCBGDBGHEBCDIJ $.
  $}

  ${
    fneq2d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function predicate with domain.  (Contributed by
       Paul Chapman, 22-Jun-2011.) $)
    fneq2d $p |- ( ph -> ( F Fn A <-> F Fn B ) ) $=
      ( wceq wfn wb fneq2 syl ) ABCFDBGDCGHEBCDIJ $.
  $}

  ${
    fneq12d.1 $e |- ( ph -> F = G ) $.
    fneq12d.2 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function predicate with domain.  (Contributed by
       NM, 26-Jun-2011.) $)
    fneq12d $p |- ( ph -> ( F Fn A <-> G Fn B ) ) $=
      ( wfn fneq1d fneq2d bitrd ) ADBHEBHECHABDEFIABCEGJK $.
  $}

  ${
    fneq1i.1 $e |- F = G $.
    $( Equality inference for function predicate with domain.  (Contributed by
       Paul Chapman, 22-Jun-2011.) $)
    fneq1i $p |- ( F Fn A <-> G Fn A ) $=
      ( wceq wfn wb fneq1 ax-mp ) BCEBAFCAFGDABCHI $.
  $}

  ${
    fneq2i.1 $e |- A = B $.
    $( Equality inference for function predicate with domain.  (Contributed by
       NM, 4-Sep-2011.) $)
    fneq2i $p |- ( F Fn A <-> F Fn B ) $=
      ( wceq wfn wb fneq2 ax-mp ) ABECAFCBFGDABCHI $.
  $}

  ${
    nffn.1 $e |- F/_ x F $.
    nffn.2 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for a function with domain.
       (Contributed by NM, 30-Jan-2004.) $)
    nffn $p |- F/ x F Fn A $=
      ( wfn wfun cdm wceq wa df-fn nffun nfdm nfeq nfan nfxfr ) CBFCGZCHZBIZJAC
      BKQSAACDLARBACDMENOP $.
  $}

  $( A function with domain is a function.  (Contributed by NM, 1-Aug-1994.) $)
  fnfun $p |- ( F Fn A -> Fun F ) $=
    ( wfn wfun cdm wceq df-fn simplbi ) BACBDBEAFBAGH $.

  $( A function with domain is a relation.  (Contributed by NM, 1-Aug-1994.) $)
  fnrel $p |- ( F Fn A -> Rel F ) $=
    ( wfn wfun wrel fnfun funrel syl ) BACBDBEABFBGH $.

  $( The domain of a function.  (Contributed by NM, 2-Aug-1994.) $)
  fndm $p |- ( F Fn A -> dom F = A ) $=
    ( wfn wfun cdm wceq df-fn simprbi ) BACBDBEAFBAGH $.

  ${
    funfni.1 $e |- ( ( Fun F /\ B e. dom F ) -> ph ) $.
    $( Inference to convert a function and domain antecedent.  (Contributed by
       NM, 22-Apr-2004.) $)
    funfni $p |- ( ( F Fn A /\ B e. A ) -> ph ) $=
      ( wfn wcel wa wfun cdm fnfun adantr fndm eleq2d biimpar syl2anc ) DBFZCBG
      ZHDIZCDJZGZAQSRBDKLQUARQTBCBDMNOEP $.
  $}

  $( A function has a unique domain.  (Contributed by NM, 11-Aug-1994.) $)
  fndmu $p |- ( ( F Fn A /\ F Fn B ) -> A = B ) $=
    ( wfn cdm fndm sylan9req ) CADCBDACEBACFBCFG $.

  $( The first argument of binary relation on a function belongs to the
     function's domain.  (Contributed by NM, 7-May-2004.) $)
  fnbr $p |- ( ( F Fn A /\ B F C ) -> B e. A ) $=
    ( wfn wbr cdm wcel wrel fnrel releldm sylan fndm eleq2d biimpa syldan ) DAE
    ZBCDFZBDGZHZBAHZQDIRTADJBCDKLQTUAQSABADMNOP $.

  $( The first argument of an ordered pair in a function belongs to the
     function's domain.  (Contributed by NM, 8-Aug-1994.) $)
  fnop $p |- ( ( F Fn A /\ <. B , C >. e. F ) -> B e. A ) $=
    ( cop wcel wfn wbr df-br fnbr sylan2br ) BCEDFDAGBCDHBAFBCDIABCDJK $.

  ${
    $d x y F $.  $d x y B $.  $d x A $.
    $( There is exactly one value of a function.  (Contributed by NM,
       22-Apr-2004.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    fneu $p |- ( ( F Fn A /\ B e. A ) -> E! y B F y ) $=
      ( cv wbr weu wfun cdm wa wmo funmo adantr wex wb eldmg ibi adantl exmoeu2
      wcel syl mpbid funfni ) CAEDFZAGZBCDDHZCDIZTZJZUDAKZUEUFUJUHACDLMUIUDANZU
      JUEOUHUKUFUHUKACDUGPQRUDASUAUBUC $.

    $( There is exactly one value of a function.  (Contributed by NM,
       7-Nov-1995.) $)
    fneu2 $p |- ( ( F Fn A /\ B e. A ) -> E! y <. B , y >. e. F ) $=
      ( wfn wcel wa cv wbr weu cop fneu df-br eubii sylib ) DBECBFGCAHZDIZAJCPK
      DFZAJABCDLQRACPDMNO $.
  $}

  $( The union of two functions with disjoint domains.  (Contributed by NM,
     22-Sep-2004.) $)
  fnun $p |- ( ( ( F Fn A /\ G Fn B ) /\ ( A i^i B ) = (/) ) ->
             ( F u. G ) Fn ( A u. B ) ) $=
    ( wfn wa cin c0 wceq cun wfun cdm wi df-fn ineq12 eqeq1d funun syl6bir dmun
    anbi2d uneq12 syl5eq jctird syl6ibr exp3a impcom an4s syl2anb imp ) CAEZDBE
    ZFABGZHIZCDJZABJZEZUJCKZCLZAIZFDKZDLZBIZFUMUPMZUKCANDBNUQUTUSVBVCUSVBFZUQUT
    FZVCVDVEUMUPVDVEUMFZUNKZUNLZUOIZFUPVDVFVGVIVDVFVEURVAGZHIZFVGVDVKUMVEVDVJUL
    HURAVABOPTCDQRVDVHURVAJUOCDSURAVABUAUBUCUNUONUDUEUFUGUHUI $.

  ${
    fnunop.x $e |- ( ph -> X e. _V ) $.
    fnunop.y $e |- ( ph -> Y e. _V ) $.
    fnunop.f $e |- ( ph -> F Fn D ) $.
    fnunop.g $e |- G = ( F u. { <. X , Y >. } ) $.
    fnunop.e $e |- E = ( D u. { X } ) $.
    fnunop.d $e |- ( ph -> -. X e. D ) $.
    $( Extension of a function with a new ordered pair.  (Contributed by NM,
       28-Sep-2013.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    fnunsn $p |- ( ph -> G Fn E ) $=
      ( cop csn cun wfn cvv wcel sylibr cin c0 fnsng syl2anc wn disjsn syl21anc
      wceq fnun fneq1i fneq2i bitri ) ADFGNOZPZBFOZPZQZECQZADBQUMUOQZBUOUAUBUHZ
      UQJAFRSGRSUSHIFGRRUCUDAFBSUEUTMBFUFTBUODUMUIUGURUNCQUQCEUNKUJCUPUNLUKULT
      $.
  $}

  $( Composition of two functions.  (Contributed by NM, 22-May-2006.) $)
  fnco $p |- ( ( F Fn A /\ G Fn B /\ ran G C_ A ) -> ( F o. G ) Fn B ) $=
    ( wfn crn wss w3a ccom wfun cdm wceq fnfun funco syl2an 3adant3 fndm sseq2d
    wa biimpar dmcosseq syl 3adant2 3ad2ant2 eqtrd df-fn sylanbrc ) CAEZDBEZDFZ
    AGZHZCDIZJZUMKZBLUMBEUHUIUNUKUHCJDJUNUIACMBDMCDNOPULUODKZBUHUKUOUPLZUIUHUKS
    UJCKZGZUQUHUSUKUHURAUJACQRTCDUAUBUCUIUHUPBLUKBDQUDUEUMBUFUG $.

  $( A function does not change when restricted to its domain.  (Contributed by
     NM, 5-Sep-2004.) $)
  fnresdm $p |- ( F Fn A -> ( F |` A ) = F ) $=
    ( wfn wrel cdm wss cres wceq fnrel fndm eqimss syl relssres syl2anc ) BACZB
    DBEZAFZBAGBHABIOPAHQABJPAKLBAMN $.

  $( A function restricted to a class disjoint with its domain is empty.
     (Contributed by NM, 23-Sep-2004.) $)
  fnresdisj $p |- ( F Fn A -> ( ( A i^i B ) = (/) <-> ( F |` B ) = (/) ) ) $=
    ( cres c0 wceq cdm wfn wrel wb relres reldm0 ax-mp dmres incom eqtri ineq1d
    cin fndm syl5eq eqeq1d syl5rbb ) CBDZEFZUCGZEFZCAHZABRZEFUCIUDUFJCBKUCLMUGU
    EUHEUGUECGZBRZUHUEBUIRUJCBNBUIOPUGUIABACSQTUAUB $.

  $( Membership in two functions restricted by each other's domain.
     (Contributed by NM, 8-Aug-1994.) $)
  2elresin $p |- ( ( F Fn A /\ G Fn B ) ->
                 ( ( <. x , y >. e. F /\ <. x , z >. e. G ) <->
                   ( <. x , y >. e. ( F |` ( A i^i B ) ) /\
                     <. x , z >. e. ( G |` ( A i^i B ) ) ) ) ) $=
    ( wfn wa cv cop wcel cin cres fnop anim12i vex opres resss sseli wi anbi12d
    an4s elin sylibr biimprd syl ex pm2.43d impbid1 ) FDHZGEHZIZAJZBJZKZFLZUNCJ
    ZKZGLZIZUPFDEMZNZLZUSGVBNZLZIZUMVAVGUMVAVAVGUAZUMVAIZUNVBLZVHVIUNDLZUNELZIZ
    VJUKUQULUTVMUKUQIVKULUTIVLDUNUOFOEUNURGOPUCUNDEUDUEVJVGVAVJVDUQVFUTUNUOFVBB
    QRUNURGVBCQRUBUFUGUHUIVDUQVFUTVCFUPFVBSTVEGUSGVBSTPUJ $.

  $( Restriction of a function with a subclass of its domain.  (Contributed by
     NM, 10-Oct-2007.) $)
  fnssresb $p |- ( F Fn A -> ( ( F |` B ) Fn B <-> B C_ A ) ) $=
    ( cres wfn wfun cdm wceq wa wss df-fn fnfun funres biantrurd ssdmres sseq2d
    syl fndm syl5bbr bitr3d syl5bb ) CBDZBEUBFZUBGBHZIZCAEZBAJZUBBKUFUDUEUGUFUC
    UDUFCFUCACLBCMQNUDBCGZJUFUGBCOUFUHABACRPSTUA $.

  $( Restriction of a function with a subclass of its domain.  (Contributed by
     NM, 2-Aug-1994.) $)
  fnssres $p |- ( ( F Fn A /\ B C_ A ) -> ( F |` B ) Fn B ) $=
    ( wfn cres wss fnssresb biimpar ) CADCBEBDBAFABCGH $.

  $( Restriction of a function's domain with an intersection.  (Contributed by
     NM, 9-Aug-1994.) $)
  fnresin1 $p |- ( F Fn A -> ( F |` ( A i^i B ) ) Fn ( A i^i B ) ) $=
    ( wfn cin wss cres inss1 fnssres mpan2 ) CADABEZAFCKGKDABHAKCIJ $.

  $( Restriction of a function's domain with an intersection.  (Contributed by
     NM, 9-Aug-1994.) $)
  fnresin2 $p |- ( F Fn A -> ( F |` ( B i^i A ) ) Fn ( B i^i A ) ) $=
    ( wfn cin wss cres inss2 fnssres mpan2 ) CADBAEZAFCKGKDBAHAKCIJ $.

  ${
    $d x y A $.  $d x y F $.
    $( An equivalence for functionality of a restriction.  Compare ~ dffun8 .
       (Contributed by Mario Carneiro, 20-May-2015.) $)
    fnres $p |- ( ( F |` A ) Fn A <-> A. x e. A E! y x F y ) $=
      ( cres wfun cdm wa cv wbr wmo wral ancom wal wcel vex mpbiran 3bitr4i wss
      bitri wceq wex wfn wi brres mobii moanimv albii wrel relres dffun6 df-ral
      weu dmres inss1 eqsstri eqss dfss3 elin2 baib eldm syl6bb ralbiia anbi12i
      cin r19.26 df-fn eu5 ralbii ) DCEZFZVJGZCUAZHZAIZBIZDJZBUBZVQBKZHZACLZVJC
      UCVQBUMZACLVSACLZVRACLZHWDWCHVNWAWCWDMVKWCVMWDVOVPVJJZBKZANZVOCOZVSUDZANV
      KWCWFWIAWFWHVQHZBKWIWEWJBWEVQWHHWJVOVPDCBPUEVQWHMTUFWHVQBUGTUHVKVJUIWGDCU
      JABVJUKQVSACULRVMCVLSZWDVMVLCSWKVLCDGZVECDCUNZCWLUOUPVLCUQQWKVOVLOZACLWDA
      CVLURWNVRACWHWNVOWLOZVRWNWHWOVOCWLVLWMUSUTBVODAPVAVBVCTTVDVRVSACVFRVJCVGW
      BVTACVQBVHVIR $.
  $}

  $( Functionality and domain of restricted identity.  (Contributed by NM,
     27-Aug-2004.) $)
  fnresi $p |- ( _I |` A ) Fn A $=
    ( cid cres wfn wfun cdm wceq funi funres ax-mp dmresi df-fn mpbir2an ) BACZ
    ADNEZNFAGBEOHABIJAKNALM $.

  $( The image of a function's domain is its range.  (Contributed by NM,
     4-Nov-2004.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
  fnima $p |- ( F Fn A -> ( F " A ) = ran F ) $=
    ( wfn cima cres crn df-ima fnresdm rneqd syl5eq ) BACZBADBAEZFBFBAGKLBABHIJ
    $.

  ${
    $d x y F $.
    $( A function with empty domain is empty.  (Contributed by NM,
       15-Apr-1998.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    fn0 $p |- ( F Fn (/) <-> F = (/) ) $=
      ( wfn wceq wrel cdm fnrel fndm reldm0 biimpar syl2anc wfun fun0 dm0 df-fn
      c0 mpbir2an fneq1 mpbiri impbii ) AOBZAOCZTADZAEOCZUAOAFOAGUBUAUCAHIJUATO
      OBZUDOKOEOCLMOONPOAOQRS $.
  $}

  $( A class that is disjoint with the domain of a function has an empty image
     under the function.  (Contributed by FL, 24-Jan-2007.) $)
  fnimadisj $p |- ( ( F Fn A /\ ( A i^i C ) = (/) ) -> ( F " C ) = (/) ) $=
    ( wfn cin c0 wceq wa cdm cima fndm ineq1d eqeq1d biimpar imadisj sylibr ) C
    ADZABEZFGZHCIZBEZFGZCBJFGQUBSQUARFQTABACKLMNCBOP $.

  $( Images under a function never map nonempty sets to empty sets.
     _EDITORIAL_: usable in ~ fnwe2lem2 .  (Contributed by Stefan O'Rear,
     21-Jan-2015.) $)
  fnimaeq0 $p |- ( ( F Fn A /\ B C_ A ) ->
      ( ( F " B ) = (/) <-> B = (/) ) ) $=
    ( cima c0 wceq cdm cin wfn wa imadisj incom fndm sseq2d biimpar df-ss sylib
    wss syl5eq eqeq1d syl5bb ) CBDEFCGZBHZEFCAIZBARZJZBEFCBKUFUCBEUFUCBUBHZBUBB
    LUFBUBRZUGBFUDUHUEUDUBABACMNOBUBPQSTUA $.

  ${
    $d y z A $.  $d y z B $.  $d x y z $.
    $( Alternate definition for the "maps to" notation ~ df-mpt .  (Contributed
       by Mario Carneiro, 30-Dec-2016.) $)
    dfmpt3 $p |- ( x e. A |-> B ) = U_ x e. A ( { x } X. { B } ) $=
      ( vy vz cmpt cv wcel wceq copab csn cxp ciun df-mpt cop wex anbi2i 2exbii
      wa elsn eliunxp elopab 3bitr4i eqriv eqtr4i ) ABCFAGZBHZDGZCIZSZADJZABUFK
      CKZLMZADBCNEUMUKEGZUFUHOIZUGUHULHZSZSZDPAPUOUJSZDPAPUNUMHUNUKHURUSADUQUJU
      OUPUIUGDCTQQRADBULUNUAUJADUNUBUCUDUE $.
  $}

  ${
    $d x y z A $.  $d z F $.  $d x y z w $.
    fnopabg.1 $e |- F = { <. x , y >. | ( x e. A /\ ph ) } $.
    $( Functionality and domain of an ordered-pair class abstraction.
       (Contributed by NM, 30-Jan-2004.)  (Proof shortened by Mario Carneiro,
       4-Dec-2016.) $)
    fnopabg $p |- ( A. x e. A E! y ph <-> F Fn A ) $=
      ( wmo wex wa wral cv wcel copab wfn weu wfun cdm wceq wal 3bitr4i moanimv
      wi albii funopab df-ral 3bitr4ri dmopab3 anbi12i r19.26 df-fn ancom bitri
      eu5 ralbii fneq1i ) ACGZACHZIZBDJZBKDLZAIZBCMZDNZACOZBDJEDNUPBDJZUQBDJZIV
      BPZVBQDRZIUSVCVEVGVFVHVACGZBSUTUPUBZBSVGVEVIVJBUTACUAUCVABCUDUPBDUEUFABCD
      UGUHUPUQBDUIVBDUJTVDURBDVDUQUPIURACUMUQUPUKULUNDEVBFUOT $.
  $}

  ${
    $d x y A $.
    fnopab.1 $e |- ( x e. A -> E! y ph ) $.
    fnopab.2 $e |- F = { <. x , y >. | ( x e. A /\ ph ) } $.
    $( Functionality and domain of an ordered-pair class abstraction.
       (Contributed by NM, 5-Mar-1996.) $)
    fnopab $p |- F Fn A $=
      ( weu wral wfn rgen fnopabg mpbi ) ACHZBDIEDJNBDFKABCDEGLM $.
  $}

  ${
    $d x y A $.  $d y B $.
    mptfng.1 $e |- F = ( x e. A |-> B ) $.
    $( The maps-to notation defines a function with domain.  (Contributed by
       Scott Fenton, 21-Mar-2011.) $)
    mptfng $p |- ( A. x e. A B e. _V <-> F Fn A ) $=
      ( vy cvv wcel wral cv wceq weu wfn eueq ralbii cmpt wa copab df-mpt eqtri
      fnopabg bitri ) CGHZABIFJCKZFLZABIDBMUCUEABFCNOUDAFBDDABCPAJBHUDQAFREAFBC
      STUAUB $.

    $( The maps-to notation defines a function with domain.  (Contributed by
       NM, 9-Apr-2013.) $)
    fnmpt $p |- ( A. x e. A B e. V -> F Fn A ) $=
      ( wcel wral cvv wfn elex ralimi mptfng sylib ) CEGZABHCIGZABHDBJOPABCEKLA
      BCDFMN $.
  $}

  $( A mapping operation with empty domain.  (Contributed by Mario Carneiro,
     28-Dec-2014.) $)
  mpt0 $p |- ( x e. (/) |-> A ) = (/) $=
    ( c0 cmpt wfn wceq cvv wcel wral ral0 eqid fnmpt ax-mp fn0 mpbi ) ACBDZCEZP
    CFBGHZACIQRAJACBPGPKLMPNO $.

  ${
    $d x y A $.  $d y B $.
    fnmpti.1 $e |- B e. _V $.
    fnmpti.2 $e |- F = ( x e. A |-> B ) $.
    $( Functionality and domain of an ordered-pair class abstraction.
       (Contributed by NM, 29-Jan-2004.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    fnmpti $p |- F Fn A $=
      ( cvv wcel wral wfn rgenw mptfng mpbi ) CGHZABIDBJNABEKABCDFLM $.

    $( Domain of an ordered-pair class abstraction that specifies a function.
       (Contributed by NM, 6-Sep-2005.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    dmmpti $p |- dom F = A $=
      ( wfn cdm wceq fnmpti fndm ax-mp ) DBGDHBIABCDEFJBDKL $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Union of mappings which are mutually compatible.  (Contributed by Mario
       Carneiro, 31-Aug-2015.) $)
    mptun $p |- ( x e. ( A u. B ) |-> C ) =
        ( ( x e. A |-> C ) u. ( x e. B |-> C ) ) $=
      ( vy cmpt cv wcel wceq wa copab df-mpt uneq12i wo elun anbi1i andir bitri
      cun eqtr4i opabbii unopab ) ABCSZDFAGZUCHZEGDIZJZAEKZABDFZACDFZSZAEUCDLUK
      UDBHZUFJZAEKZUDCHZUFJZAEKZSZUHUIUNUJUQAEBDLAECDLMUHUMUPNZAEKURUGUSAEUGULU
      ONZUFJUSUEUTUFUDBCOPULUOUFQRUAUMUPAEUBTTT $.
  $}

  $( Equality theorem for functions.  (Contributed by NM, 1-Aug-1994.) $)
  feq1 $p |- ( F = G -> ( F : A --> B <-> G : A --> B ) ) $=
    ( wceq wfn crn wss wa wf fneq1 rneq sseq1d anbi12d df-f 3bitr4g ) CDEZCAFZC
    GZBHZIDAFZDGZBHZIABCJABDJQRUATUCACDKQSUBBCDLMNABCOABDOP $.

  $( Equality theorem for functions.  (Contributed by NM, 1-Aug-1994.) $)
  feq2 $p |- ( A = B -> ( F : A --> C <-> F : B --> C ) ) $=
    ( wceq wfn crn wss wa wf fneq2 anbi1d df-f 3bitr4g ) ABEZDAFZDGCHZIDBFZQIAC
    DJBCDJOPRQABDKLACDMBCDMN $.

  $( Equality theorem for functions.  (Contributed by NM, 1-Aug-1994.) $)
  feq3 $p |- ( A = B -> ( F : C --> A <-> F : C --> B ) ) $=
    ( wceq wfn crn wss wa wf sseq2 anbi2d df-f 3bitr4g ) ABEZDCFZDGZAHZIPQBHZIC
    ADJCBDJORSPABQKLCADMCBDMN $.

  $( Equality theorem for functions.  (Contributed by FL, 14-Jul-2007.)  (Proof
     shortened by Andrew Salmon, 17-Sep-2011.) $)
  feq23 $p |- ( ( A = C /\ B = D ) -> ( F : A --> B <-> F : C --> D ) ) $=
    ( wceq wf feq2 feq3 sylan9bb ) ACFABEGCBEGBDFCDEGACBEHBDCEIJ $.

  ${
    feq1d.1 $e |- ( ph -> F = G ) $.
    $( Equality deduction for functions.  (Contributed by NM, 19-Feb-2008.) $)
    feq1d $p |- ( ph -> ( F : A --> B <-> G : A --> B ) ) $=
      ( wceq wf wb feq1 syl ) ADEGBCDHBCEHIFBCDEJK $.
  $}

  ${
    feq2d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for functions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    feq2d $p |- ( ph -> ( F : A --> C <-> F : B --> C ) ) $=
      ( wceq wf wb feq2 syl ) ABCGBDEHCDEHIFBCDEJK $.
  $}

  ${
    feq12d.1 $e |- ( ph -> F = G ) $.
    feq12d.2 $e |- ( ph -> A = B ) $.
    $( Equality deduction for functions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    feq12d $p |- ( ph -> ( F : A --> C <-> G : B --> C ) ) $=
      ( wf feq1d feq2d bitrd ) ABDEIBDFICDFIABDEFGJABCDFHKL $.

    feq123d.3 $e |- ( ph -> C = D ) $.
    $( Equality deduction for functions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    feq123d $p |- ( ph -> ( F : A --> C <-> G : B --> D ) ) $=
      ( wf feq12d wceq wb feq3 syl bitrd ) ABDFKCDGKZCEGKZABCDFGHILADEMRSNJDECG
      OPQ $.
  $}

  $( Equality theorem for functions.  (Contributed by FL, 16-Nov-2008.) $)
  feq123 $p |- ( ( F = G /\ A = C /\ B = D ) ->
    ( F : A --> B <-> G : C --> D ) ) $=
    ( wceq w3a simp1 simp2 simp3 feq123d ) EFGZACGZBDGZHACBDEFMNOIMNOJMNOKL $.

  ${
    feq1i.1 $e |- F = G $.
    $( Equality inference for functions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    feq1i $p |- ( F : A --> B <-> G : A --> B ) $=
      ( wceq wf wb feq1 ax-mp ) CDFABCGABDGHEABCDIJ $.
  $}

  ${
    feq2i.1 $e |- A = B $.
    $( Equality inference for functions.  (Contributed by NM, 5-Sep-2011.) $)
    feq2i $p |- ( F : A --> C <-> F : B --> C ) $=
      ( wceq wf wb feq2 ax-mp ) ABFACDGBCDGHEABCDIJ $.
  $}

  ${
    feq23i.1 $e |- A = C $.
    feq23i.2 $e |- B = D $.
    $( Equality inference for functions.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    feq23i $p |- ( F : A --> B <-> F : C --> D ) $=
      ( wceq wf wb feq23 mp2an ) ACHBDHABEICDEIJFGABCDEKL $.
  $}

  ${
    feq23d.1 $e |- ( ph -> A = C ) $.
    feq23d.2 $e |- ( ph -> B = D ) $.
    $( Equality deduction for functions.  (Contributed by NM, 8-Jun-2013.) $)
    feq23d $p |- ( ph -> ( F : A --> B <-> F : C --> D ) ) $=
      ( eqidd feq123d ) ABDCEFFAFIGHJ $.
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    nff.1 $e |- F/_ x F $.
    nff.2 $e |- F/_ x A $.
    nff.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for a mapping.  (Contributed by NM,
       29-Jan-2004.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nff $p |- F/ x F : A --> B $=
      ( wf wfn crn wss wa df-f nffn nfrn nfss nfan nfxfr ) BCDHDBIZDJZCKZLABCDM
      SUAAABDEFNATCADEOGPQR $.
  $}

  ${
    elimf.1 $e |- G : A --> B $.
    $( Eliminate a mapping hypothesis for the weak deduction theorem ~ dedth ,
       when a special case ` G : A --> B ` is provable, in order to convert
       ` F : A --> B ` from a hypothesis to an antecedent.  (Contributed by NM,
       24-Aug-2006.) $)
    elimf $p |- if ( F : A --> B , F , G ) : A --> B $=
      ( wf cif feq1 elimhyp ) ABCFZABJCDGZFABDFCDABCKHABDKHEI $.
  $}

  $( A mapping is a function.  (Contributed by NM, 2-Aug-1994.) $)
  ffn $p |- ( F : A --> B -> F Fn A ) $=
    ( wf wfn crn wss df-f simplbi ) ABCDCAECFBGABCHI $.

  $( Any function is a mapping into ` _V ` .  (Contributed by NM,
     31-Oct-1995.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
  dffn2 $p |- ( F Fn A <-> F : A --> _V ) $=
    ( wfn crn cvv wss wa wf ssv biantru df-f bitr4i ) BACZMBDZEFZGAEBHOMNIJAEBK
    L $.

  $( A mapping is a function.  (Contributed by NM, 3-Aug-1994.) $)
  ffun $p |- ( F : A --> B -> Fun F ) $=
    ( wf wfn wfun ffn fnfun syl ) ABCDCAECFABCGACHI $.

  $( A mapping is a relation.  (Contributed by NM, 3-Aug-1994.) $)
  frel $p |- ( F : A --> B -> Rel F ) $=
    ( wf wfn wrel ffn fnrel syl ) ABCDCAECFABCGACHI $.

  $( The domain of a mapping.  (Contributed by NM, 2-Aug-1994.) $)
  fdm $p |- ( F : A --> B -> dom F = A ) $=
    ( wf wfn cdm wceq ffn fndm syl ) ABCDCAECFAGABCHACIJ $.

  ${
    fdmi.1 $e |- F : A --> B $.
    $( The domain of a mapping.  (Contributed by NM, 28-Jul-2008.) $)
    fdmi $p |- dom F = A $=
      ( wf cdm wceq fdm ax-mp ) ABCECFAGDABCHI $.
  $}

  $( The range of a mapping.  (Contributed by NM, 3-Aug-1994.) $)
  frn $p |- ( F : A --> B -> ran F C_ B ) $=
    ( wf wfn crn wss df-f simprbi ) ABCDCAECFBGABCHI $.

  $( A function maps to its range.  (Contributed by NM, 1-Sep-1999.) $)
  dffn3 $p |- ( F Fn A <-> F : A --> ran F ) $=
    ( wfn crn wss wa wf ssid biantru df-f bitr4i ) BACZLBDZMEZFAMBGNLMHIAMBJK
    $.

  $( Expanding the codomain of a mapping.  (Contributed by NM, 10-May-1998.)
     (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
  fss $p |- ( ( F : A --> B /\ B C_ C ) -> F : A --> C ) $=
    ( wss wf wfn crn wa sstr2 com12 anim2d df-f 3imtr4g impcom ) BCEZABDFZACDFZ
    PDAGZDHZBEZISTCEZIQRPUAUBSUAPUBTBCJKLABDMACDMNO $.

  $( Composition of two mappings.  (Contributed by NM, 29-Aug-1999.)  (Proof
     shortened by Andrew Salmon, 17-Sep-2011.) $)
  fco $p |- ( ( F : B --> C /\ G : A --> B ) -> ( F o. G ) : A --> C ) $=
    ( wf wa ccom wfn crn wss df-f wi fnco 3expib adantr rncoss sstr mpan adantl
    jctird imp syl2anb sylibr ) BCDFZABEFZGDEHZAIZUGJZCKZGZACUGFUEDBIZDJZCKZGZE
    AIZEJBKZGZUKUFBCDLABELUOURUKUOURUHUJULURUHMUNULUPUQUHBADENOPUNUJULUIUMKUNUJ
    DEQUIUMCRSTUAUBUCACUGLUD $.

  $( Functionality of a composition with weakened out of domain condition on
     the first argument.  (Contributed by Stefan O'Rear, 11-Mar-2015.) $)
  fco2 $p |- ( ( ( F |` B ) : B --> C /\ G : A --> B ) ->
      ( F o. G ) : A --> C ) $=
    ( cres wf wa ccom fco wceq crn wss frn cores syl adantl feq1d mpbid ) BCDBF
    ZGZABEGZHZACTEIZGACDEIZGABCTEJUCACUDUEUBUDUEKZUAUBELBMUFABENDEBOPQRS $.

  $( A mapping is a class of ordered pairs.  (Contributed by NM, 3-Aug-1994.)
     (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
  fssxp $p |- ( F : A --> B -> F C_ ( A X. B ) ) $=
    ( wf cdm crn cxp wrel wss frel relssdmrn syl wceq fdm eqimss xpss12 syl2anc
    frn sstrd ) ABCDZCCEZCFZGZABGZTCHCUCIABCJCKLTUAAIZUBBIUCUDITUAAMUEABCNUAAOL
    ABCRUAAUBBPQS $.

  $( A function with bounded domain and range is a set.  This version of ~ fex
     is proven without the Axiom of Replacement.  (Contributed by Mario
     Carneiro, 24-Jun-2015.) $)
  fex2 $p |- ( ( F : A --> B /\ A e. V /\ B e. W ) -> F e. _V ) $=
    ( wf wcel w3a cxp cvv xpexg 3adant1 wss fssxp 3ad2ant1 ssexd ) ABCFZADGZBEG
    ZHCABIZJRSTJGQABDEKLQRCTMSABCNOP $.

  $( Two ways of specifying a partial function from ` A ` to ` B ` .
     (Contributed by NM, 13-Nov-2007.) $)
  funssxp $p |- ( ( Fun F /\ F C_ ( A X. B ) ) <->
             ( F : dom F --> B /\ dom F C_ A ) ) $=
    ( wfun cxp wss wa cdm wf wfn funfn biimpi rnss rnxpss syl6ss anim12i sylibr
    crn df-f jca dmss dmxpss adantl ffun adantr fssxp xpss1 sylan9ss impbii ) C
    DZCABEZFZGZCHZBCIZUNAFZGZUMUOUPUMCUNJZCRZBFZGUOUJURULUTUJURCKLULUSUKRBCUKMA
    BNOPUNBCSQULUPUJULUNUKHACUKUAABUBOUCTUQUJULUOUJUPUNBCUDUEUOUPCUNBEUKUNBCUFU
    NABUGUHTUI $.

  $( A mapping is a partial function.  (Contributed by NM, 25-Nov-2007.) $)
  ffdm $p |- ( F : A --> B -> ( F : dom F --> B /\ dom F C_ A ) ) $=
    ( wf cdm wss fdm feq2d ibir wceq eqimss syl jca ) ABCDZCEZBCDZOAFZNPNOABCAB
    CGZHINOAJQROAKLM $.

  $( The members of an ordered pair element of a mapping belong to the
     mapping's domain and codomain.  (Contributed by NM, 10-Dec-2003.)
     (Revised by Mario Carneiro, 26-Apr-2015.) $)
  opelf $p |- ( ( F : A --> B /\ <. C , D >. e. F ) ->
              ( C e. A /\ D e. B ) ) $=
    ( wf cop wcel wa cxp fssxp sseld opelxp syl6ib imp ) ABEFZCDGZEHZCAHDBHIZPR
    QABJZHSPETQABEKLCDABMNO $.

  $( The union of two functions with disjoint domains.  (Contributed by NM,
     22-Sep-2004.) $)
  fun $p |- ( ( ( F : A --> C /\ G : B --> D ) /\ ( A i^i B ) = (/) ) ->
             ( F u. G ) : ( A u. B ) --> ( C u. D ) ) $=
    ( cin c0 wceq wf wa cun wfn crn wss fnun expcom wi rnun df-f unss12 anim12d
    syl5eqss a1i anbi12i an4 bitri 3imtr4g impcom ) ABGHIZACEJZBDFJZKZABLZCDLZE
    FLZJZUJEAMZFBMZKZENZCOZFNZDOZKZKZUPUNMZUPNZUOOZKUMUQUJUTVGVEVIUTUJVGABEFPQV
    EVIRUJVEVHVAVCLUOEFSVACVCDUAUCUDUBUMURVBKZUSVDKZKVFUKVJULVKACETBDFTUEURVBUS
    VDUFUGUNUOUPTUHUI $.

  $( The union of two functions with disjoint domains.  (Contributed by Mario
     Carneiro, 12-Mar-2015.) $)
  fun2 $p |- ( ( ( F : A --> C /\ G : B --> C ) /\ ( A i^i B ) = (/) ) ->
             ( F u. G ) : ( A u. B ) --> C ) $=
    ( wf wa cin c0 wceq cun fun wb unidm feq3 ax-mp sylib ) ACDFBCEFGABHIJGABKZ
    CCKZDEKZFZRCTFZABCCDELSCJUAUBMCNSCRTOPQ $.

  $( Composition of two functions.  (Contributed by NM, 22-May-2006.) $)
  fnfco $p |- ( ( F Fn A /\ G : B --> A ) -> ( F o. G ) Fn B ) $=
    ( wf wfn crn wss wa ccom df-f fnco 3expb sylan2b ) BADECAFZDBFZDGAHZICDJBFZ
    BADKOPQRABCDLMN $.

  $( Restriction of a function with a subclass of its domain.  (Contributed by
     NM, 23-Sep-2004.) $)
  fssres $p |- ( ( F : A --> B /\ C C_ A ) -> ( F |` C ) : C --> B ) $=
    ( wf wss cres wfn crn df-f fnssres resss rnss ax-mp sstr mpan anim12i an32s
    wa sylanb sylibr ) ABDEZCAFZSDCGZCHZUDIZBFZSZCBUDEUBDAHZDIZBFZSUCUHABDJUIUC
    UKUHUIUCSUEUKUGACDKUFUJFZUKUGUDDFULDCLUDDMNUFUJBOPQRTCBUDJUA $.

  $( Restriction of a restricted function with a subclass of its domain.
     (Contributed by NM, 21-Jul-2005.) $)
  fssres2 $p |- ( ( ( F |` A ) : A --> B /\ C C_ A ) ->
                ( F |` C ) : C --> B ) $=
    ( cres wf wss wa fssres wb resabs1 feq1d adantl mpbid ) ABDAEZFZCAGZHCBOCEZ
    FZCBDCEZFZABCOIQSUAJPQCBRTDCAKLMN $.

  $( An identity for the mapping relationship under restriction.  (Contributed
     by Scott Fenton, 4-Sep-2011.)  (Proof shortened by Mario Carneiro,
     26-May-2016.) $)
  fresin $p |- ( F : A --> B -> ( F |` X ) : ( A i^i X ) --> B ) $=
    ( wf cin cres wss inss1 fssres mpan2 resres wfn ffn fnresdm reseq1d syl5eqr
    wceq syl feq1d mpbid ) ABCEZADFZBCUCGZEZUCBCDGZEUBUCAHUEADIABUCCJKUBUCBUDUF
    UBUDCAGZDGUFCADLUBUGCDUBCAMUGCRABCNACOSPQTUA $.

  $( If two functions agree on their common domain, express their union as a
     union of three functions with pairwise disjoint domains.  (Contributed by
     Stefan O'Rear, 9-Oct-2014.) $)
  resasplit $p |- ( ( F Fn A /\ G Fn B /\
      ( F |` ( A i^i B ) ) = ( G |` ( A i^i B ) ) ) -> ( F u. G ) =
  ( ( F |` ( A i^i B ) ) u. ( ( F |` ( A \ B ) ) u. ( G |` ( B \ A ) ) ) ) ) $=
    ( wfn cin cres w3a cun fnresdm uneq12 syl2an inundif reseq2i resundi eqtr3i
    wceq cdif uneq1i syl6eq 3adant3 simp3 uneq1d uneq2d incom eqtri uneq12i un4
    syl6reqr unidm eqtr3d ) CAEZDBEZCABFZGZDUNGZQZHZCAGZDBGZIZCDIZUOCABRZGZDBAR
    ZGZIZIZULUMVAVBQZUQULUSCQUTDQVIUMACJBDJUSCUTDKLUAURVAUOUOIZVGIZVHURVAUOVDIZ
    UOVFIZIZVKURVNVLUPVFIZIVAURVMVOVLURUOUPVFULUMUQUBUCUDUSVLUTVOCUNVCIZGUSVLVP
    ACABMNCUNVCOPDUNVEIZGUTVOVQBDVQBAFZVEIBUNVRVEABUESBAMUFNDUNVEOPUGUIUOVDUOVF
    UHTVJUOVGUOUJSTUK $.

  $( The union of two functions which agree on their common domain is a
     function.  (Contributed by Stefan O'Rear, 9-Oct-2014.) $)
  fresaun $p |- ( ( F : A --> C /\ G : B --> C /\
      ( F |` ( A i^i B ) ) = ( G |` ( A i^i B ) ) ) ->
    ( F u. G ) : ( A u. B ) --> C ) $=
    ( wf cin cres wceq cdif cun c0 wss fssres sylancl difss disjdif 3eqtri fun2
    a1i w3a simp1 inss1 simp2 indifdir difeq1i 0dif syl21anc inass ineq2i incom
    indi in0 ineq1i eqtri uneq12i un0 wfn id resasplit syl3an feq1d un12 uneq1i
    ffn inundif uneq2i undif1 feq2i syl6rbbr mpbid ) ACDFZBCEFZDABGZHZEVNHIZUAZ
    VNABJZBAJZKZKZCVODVRHZEVSHZKZKZFZABKZCDEKZFZVQVNCVOFZVTCWDFZVNVTGZLIZWFVQVL
    VNAMWJVLVMVPUBZABUCACVNDNOVQVRCWBFZVSCWCFZVRVSGZLIZWKVQVLVRAMWOWNABPACVRDNO
    VQVMVSBMWPVLVMVPUDBAPBCVSENOWRVQWQAVSGZBVSGZJLWTJLABVSUEWSLWTABQZUFWTUGRTVR
    VSCWBWCSUHWMVQWLVNVRGZVNVSGZKLLKLVNVRVSULXBLXCLXBABVRGZGALGLABVRUIXDLABAQUJ
    AUMRXCBAGZVSGZLVNXEVSABUKZUNXFBWSGBLGLBAVSUIWSLBXAUJBUMRUOUPLUQRTVNVTCVOWDS
    UHVQWIWGCWEFWFVQWGCWHWEVLDAURVMEBURVPVPWHWEIACDVEBCEVEVPUSABDEUTVAVBWAWGCWE
    WAVRVNVSKZKVRBKWGVNVRVSVCXHBVRXHXEVSKBVNXEVSXGVDBAVFUOVGABVHRVIVJVK $.

  $( From the union of two functions that agree on the domain overlap, either
     component can be recovered by restriction.  (Contributed by Stefan O'Rear,
     9-Oct-2014.) $)
  fresaunres2 $p |- ( ( F : A --> C /\ G : B --> C /\
      ( F |` ( A i^i B ) ) = ( G |` ( A i^i B ) ) ) ->
    ( ( F u. G ) |` B ) = G ) $=
    ( wf cin cres wceq cun cdif wfn ffn resundir wss ax-mp c0 cdm eqtri syl5eq
    w3a id resasplit syl3an reseq1d inss2 resabs2 uneq12i ineq2i disjdif ineq1i
    dmres inass inss1 0ss eqssi 3eqtr3i wrel wb relres reldm0 mpbir difss simp3
    uneq2i uneq1d wa uncom un0 resundi incom uneq1i inundif reseq2i fnresdm syl
    adantl syl5eqr 3adant3 eqtrd ) ACDFZBCEFZDABGZHZEWCHZIZUAZDEJZBHWDDABKZHZEB
    AKZHZJZJZBHZEWGWHWNBWADALWBEBLZWFWFWHWNIACDMBCEMZWFUBABDEUCUDUEWGWOWDBHZWMB
    HZJZEWDWMBNWGWTWDWJBHZWLBHZJZJZEWRWDWSXCWCBOWRWDIABUFDWCBUGPWJWLBNUHWGXDWDQ
    WLJZJZEXCXEWDXAQXBWLXAQIZXARZQIZXHBWJRZGZQWJBULXKBWIDRZGZGZQXJXMBDWIULUIBWI
    GZXLGQXLGZXNQXOQXLBAUJUKBWIXLUMXPQQXLUNXPUOUPUQSSXAURXGXIUSWJBUTXAVAPVBWKBO
    XBWLIBAVCEWKBUGPUHVEWGXFWEXEJZEWGWDWEXEWAWBWFVDVFWAWBXQEIWFWAWBVGZXQWEWLJZE
    XEWLWEXEWLQJWLQWLVHWLVISVEXRXSEWCWKJZHZEEWCWKVJXRYAEBHZEXTBEXTBAGZWKJBWCYCW
    KABVKVLBAVMSVNWBYBEIZWAWBWPYDWQBEVOVPVQTVRTVSVTTTTVT $.

  $( From the union of two functions that agree on the domain overlap, either
     component can be recovered by restriction.  (Contributed by Mario
     Carneiro, 16-Feb-2015.) $)
  fresaunres1 $p |- ( ( F : A --> C /\ G : B --> C /\
      ( F |` ( A i^i B ) ) = ( G |` ( A i^i B ) ) ) ->
    ( ( F u. G ) |` A ) = F ) $=
    ( wf cin cres w3a cun uncom reseq1i incom reseq2i eqeq12i eqcom fresaunres2
    wceq bitri 3com12 syl3an3b syl5eq ) ACDFZBCEFZDABGZHZEUEHZRZIDEJZAHEDJZAHZD
    UIUJADEKLUHUCUDEBAGZHZDULHZRZUKDRZUHUNUMRUOUFUNUGUMUEULDABMZNUEULEUQNOUNUMP
    SUDUCUOUPBACEDQTUAUB $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.
    $( Composition of a mapping and restricted identity.  (Contributed by NM,
       13-Dec-2003.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    fcoi1 $p |- ( F : A --> B -> ( F o. ( _I |` A ) ) = F ) $=
      ( wf wfn cid cres ccom wceq ffn wfun cdm wa df-fn wss eqimss ccnv reseq1i
      cnvi syl cnveqi cnvresid eqtr2i coeq2i cores2 syl5eq wrel sylan9eqr sylbi
      funrel coi1 ) ABCDCAEZCFAGZHZCIZABCJULCKZCLZAIZMUOCANURUPUNCFHZCURUQAOZUN
      USIUQAPUTUNCFQZAGZQZHUSUMVCCVCUMQUMVBUMVAFASRUAAUBUCUDCFAUEUFTUPCUGUSCICU
      JCUKTUHUIT $.

    $( Composition of restricted identity and a mapping.  (Contributed by NM,
       13-Dec-2003.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    fcoi2 $p |- ( F : A --> B -> ( ( _I |` B ) o. F ) = F ) $=
      ( wf wfn crn wss wa cid cres ccom wceq df-f cores wrel coi2 syl sylan9eqr
      fnrel sylbi ) ABCDCAEZCFBGZHIBJCKZCLABCMUBUAUCICKZCICBNUACOUDCLACSCPQRT
      $.
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.  $d y C $.
    $( There is exactly one value of a function in its codomain.  (Contributed
       by NM, 10-Dec-2003.) $)
    feu $p |- ( ( F : A --> B /\ C e. A ) -> E! y e. B <. C , y >. e. F ) $=
      ( wf wcel wa cv cop weu wreu wfn ffn fneu2 sylan wb opelf simprd ex mpbid
      pm4.71rd eubidv adantr df-reu sylibr ) BCEFZDBGZHZAIZCGZDUJJEGZHZAKZULACL
      UIULAKZUNUGEBMUHUOBCENABDEOPUGUOUNQUHUGULUMAUGULUKUGULUKUGULHUHUKBCDUJERS
      TUBUCUDUAULACUEUF $.
  $}

  ${
    $d x y F $.  $d x y A $.  $d x y B $.
    $( The converse of a restriction of a function.  (Contributed by NM,
       26-Mar-1998.) $)
    fcnvres $p |- ( F : A --> B -> `' ( F |` A ) = ( `' F |` B ) ) $=
      ( vy vx wf cres ccnv relcnv cv cop wcel wa ex pm4.71d vex opelcnv opelres
      bitri syl6bbr relres opelf simpld simprd anbi1i bitr3d eqrelrdv ) ABCFZDE
      CAGZHZCHZBGZUIIUKBUAUHEJZDJZKZCLZUNUMKZUJLZUQULLZUHUPUPUMALZMZURUHUPUTUHU
      PUTUHUPMZUTUNBLZABUMUNCUBZUCNOURUOUILVAUNUMUIDPZEPZQUMUNCAVERSTUHUPUPVCMZ
      USUHUPVCUHUPVCVBUTVCVDUDNOUSUQUKLZVCMVGUNUMUKBVFRVHUPVCUNUMCVEVFQUESTUFUG
      $.
  $}

  $( The preimage of a class disjoint with a mapping's codomain is empty.
     (Contributed by FL, 24-Jan-2007.) $)
  fimacnvdisj $p |- ( ( F : A --> B /\ ( B i^i C ) = (/) ) ->
    ( `' F " C ) = (/) ) $=
    ( wf cin c0 wceq wa ccnv cdm cima wss crn df-rn frn adantr syl5eqssr ssdisj
    sylancom imadisj sylibr ) ABDEZBCFGHZIZDJZKZCFGHZUFCLGHUCUDUGBMUHUEUGDNZBDO
    UCUIBMUDABDPQRUGBCSTUFCUAUB $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    fint.1 $e |- B =/= (/) $.
    $( Function into an intersection.  (Contributed by NM, 14-Oct-1999.)
       (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
    fint $p |- ( F : A --> |^| B <-> A. x e. B F : A --> x ) $=
      ( wfn crn cint wss wa cv wral wf ssint anbi2i c0 wne wb r19.28zv df-f
      ax-mp bitr4i ralbii 3bitr4i ) DBFZDGZCHZIZJZUEUFAKZIZJZACLZBUGDMBUJDMZACL
      UIUEUKACLZJZUMUHUOUEAUFCNOCPQUMUPREUEUKACSUAUBBUGDTUNULACBUJDTUCUD $.
  $}

  $( Mapping into an intersection.  (Contributed by NM, 14-Sep-1999.)  (Proof
     shortened by Andrew Salmon, 17-Sep-2011.) $)
  fin $p |- ( F : A --> ( B i^i C ) <-> ( F : A --> B /\ F : A --> C ) ) $=
    ( wfn crn cin wss wa wf ssin anbi2i anandi bitr3i df-f anbi12i 3bitr4i ) DA
    EZDFZBCGZHZIZRSBHZIZRSCHZIZIZATDJABDJZACDJZIUBRUCUEIZIUGUJUARSBCKLRUCUEMNAT
    DOUHUDUIUFABDOACDOPQ $.

  ${
    $d A x $.  $d B x $.
    fabexg.1 $e |- F = { x | ( x : A --> B /\ ph ) } $.
    $( Existence of a set of functions.  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    fabexg $p |- ( ( A e. C /\ B e. D ) -> F e. _V ) $=
      ( wcel wa cxp cvv cpw xpexg pwexg wss cv cab wf fssxp elpw sylibr eqsstri
      vex anim1i ss2abi ssab2 sstri ssexg mpan 3syl ) CEIDFIJCDKZLIULMZLIZGLIZC
      DEFNULLOGUMPUNUOGBQZUMIZAJZBRZUMGCDUPSZAJZBRUSHVAURBUTUQAUTUPULPUQCDUPTUP
      ULBUDUAUBUEUFUCABUMUGUHGUMLUIUJUK $.
  $}

  ${
    $d x A $.  $d x B $.
    fabex.1 $e |- A e. _V $.
    fabex.2 $e |- B e. _V $.
    fabex.3 $e |- F = { x | ( x : A --> B /\ ph ) } $.
    $( Existence of a set of functions.  (Contributed by NM, 3-Dec-2007.) $)
    fabex $p |- F e. _V $=
      ( cvv wcel fabexg mp2an ) CIJDIJEIJFGABCDIIEHKL $.
  $}

  $( If a mapping is a set, its domain is a set.  (Contributed by NM,
     27-Aug-2006.)  (Proof shortened by Andrew Salmon, 17-Sep-2011.) $)
  dmfex $p |- ( ( F e. C /\ F : A --> B ) -> A e. _V ) $=
    ( wf wcel cvv cdm wceq wi fdm dmexg eleq1 syl5ib syl impcom ) ABDEZDCFZAGFZ
    QDHZAIZRSJABDKRTGFUASDCLTAGMNOP $.

  $( The empty function.  (Contributed by NM, 14-Aug-1999.) $)
  f0 $p |- (/) : (/) --> A $=
    ( c0 wf wfn crn wss wceq eqid fn0 mpbir rn0 0ss eqsstri df-f mpbir2an ) BAB
    CBBDZBEZAFPBBGBHBIJQBAKALMBABNO $.

  $( A class is a function with empty codomain iff it and its domain are
     empty.  (Contributed by NM, 10-Dec-2003.) $)
  f00 $p |- ( F : A --> (/) <-> ( F = (/) /\ A = (/) ) ) $=
    ( c0 wf wceq wa wfn wfun cdm ffun crn wss frn ss0 syl dm0rn0 df-fn sylanbrc
    sylibr fn0 sylib fdm eqtr3d jca f0 feq1 feq2 sylan9bb mpbiri impbii ) ACBDZ
    BCEZACEZFZUKULUMUKBCGZULUKBHBIZCEZUOACBJUKBKZCEZUQUKURCLUSACBMURNOBPSZBCQRB
    TUAUKUPACACBUBUTUCUDUNUKCCCDZCUEULUKACCDUMVAACBCUFACCCUGUHUIUJ $.

  ${
    $d x y A $.  $d x y B $.
    fconst.1 $e |- B e. _V $.
    $( A cross product with a singleton is a constant function.  (Contributed
       by NM, 14-Aug-1999.)  (Proof shortened by Andrew Salmon,
       17-Sep-2011.) $)
    fconst $p |- ( A X. { B } ) : A --> { B } $=
      ( vx csn cxp wf wfn crn wss fconstmpt fnmpti rnxpss df-f mpbir2an ) ABEZA
      PFZGQAHQIPJDABQCDABKLAPMAPQNO $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A cross product with a singleton is a constant function.  (Contributed
       by NM, 19-Oct-2004.) $)
    fconstg $p |- ( B e. V -> ( A X. { B } ) : A --> { B } ) $=
      ( vx cv csn cxp wf wceq sneq xpeq2d feq1 feq3 sylan9bb syl2anc vex fconst
      wb vtoclg ) ADEZFZAUAGZHZABFZAUDGZHZDBCTBIZUBUEIZUAUDIZUCUFRUGUAUDATBJZKU
      JUHUCAUAUEHUIUFAUAUBUELUAUDAUEMNOATDPQS $.
  $}

  $( A cross product with a singleton is a constant function.  (Contributed by
     NM, 24-Jul-2014.) $)
  fnconstg $p |- ( B e. V -> ( A X. { B } ) Fn A ) $=
    ( wcel csn cxp wf wfn fconstg ffn syl ) BCDABEZALFZGMAHABCIALMJK $.

  $( Constant function with loose range.  (Contributed by Stefan O'Rear,
     1-Feb-2015.) $)
  fconst6g $p |- ( B e. C -> ( A X. { B } ) : A --> C ) $=
    ( wcel csn cxp wf wss fconstg snssi fss syl2anc ) BCDABEZAMFZGMCHACNGABCIBC
    JAMCNKL $.

  ${
    fconst6.1 $e |- B e. C $.
    $( A constant function as a mapping.  (Contributed by Jeff Madsen,
       30-Nov-2009.)  (Revised by Mario Carneiro, 22-Apr-2015.) $)
    fconst6 $p |- ( A X. { B } ) : A --> C $=
      ( wcel csn cxp wf fconst6g ax-mp ) BCEACABFGHDABCIJ $.
  $}

  $( Equality theorem for one-to-one functions.  (Contributed by NM,
     10-Feb-1997.) $)
  f1eq1 $p |- ( F = G -> ( F : A -1-1-> B <-> G : A -1-1-> B ) ) $=
    ( wceq wf ccnv wfun wa wf1 feq1 cnveq funeqd anbi12d df-f1 3bitr4g ) CDEZAB
    CFZCGZHZIABDFZDGZHZIABCJABDJQRUATUCABCDKQSUBCDLMNABCOABDOP $.

  $( Equality theorem for one-to-one functions.  (Contributed by NM,
     10-Feb-1997.) $)
  f1eq2 $p |- ( A = B -> ( F : A -1-1-> C <-> F : B -1-1-> C ) ) $=
    ( wceq wf ccnv wfun wa wf1 feq2 anbi1d df-f1 3bitr4g ) ABEZACDFZDGHZIBCDFZQ
    IACDJBCDJOPRQABCDKLACDMBCDMN $.

  $( Equality theorem for one-to-one functions.  (Contributed by NM,
     10-Feb-1997.) $)
  f1eq3 $p |- ( A = B -> ( F : C -1-1-> A <-> F : C -1-1-> B ) ) $=
    ( wceq wf ccnv wfun wa wf1 feq3 anbi1d df-f1 3bitr4g ) ABEZCADFZDGHZICBDFZQ
    ICADJCBDJOPRQABCDKLCADMCBDMN $.

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    nff1.1 $e |- F/_ x F $.
    nff1.2 $e |- F/_ x A $.
    nff1.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for a one-to-one function.
       (Contributed by NM, 16-May-2004.) $)
    nff1 $p |- F/ x F : A -1-1-> B $=
      ( wf1 wf ccnv wfun wa df-f1 nff nfcnv nffun nfan nfxfr ) BCDHBCDIZDJZKZLA
      BCDMSUAAABCDEFGNATADEOPQR $.
  $}

  ${
    $d x y F $.
    $( Alternate definition of a one-to-one function.  (Contributed by NM,
       31-Dec-1996.) $)
    dff12 $p |- ( F : A -1-1-> B <-> ( F : A --> B /\ A. y E* x x F y ) ) $=
      ( wf1 wf ccnv wfun wa cv wbr wmo wal df-f1 funcnv2 anbi2i bitri ) CDEFCDE
      GZEHIZJSAKBKELAMBNZJCDEOTUASABEPQR $.
  $}

  $( A one-to-one mapping is a mapping.  (Contributed by NM, 31-Dec-1996.) $)
  f1f $p |- ( F : A -1-1-> B -> F : A --> B ) $=
    ( wf1 wf ccnv wfun df-f1 simplbi ) ABCDABCECFGABCHI $.

  $( A one-to-one mapping is a function on its domain.  (Contributed by NM,
     8-Mar-2014.) $)
  f1fn $p |- ( F : A -1-1-> B -> F Fn A ) $=
    ( wf1 wf wfn f1f ffn syl ) ABCDABCECAFABCGABCHI $.

  $( A one-to-one mapping is a function.  (Contributed by NM, 8-Mar-2014.) $)
  f1fun $p |- ( F : A -1-1-> B -> Fun F ) $=
    ( wf1 wfn wfun f1fn fnfun syl ) ABCDCAECFABCGACHI $.

  $( A one-to-one onto mapping is a relation.  (Contributed by NM,
     8-Mar-2014.) $)
  f1rel $p |- ( F : A -1-1-> B -> Rel F ) $=
    ( wf1 wfn wrel f1fn fnrel syl ) ABCDCAECFABCGACHI $.

  $( The domain of a one-to-one mapping.  (Contributed by NM, 8-Mar-2014.) $)
  f1dm $p |- ( F : A -1-1-> B -> dom F = A ) $=
    ( wf1 wfn cdm wceq f1fn fndm syl ) ABCDCAECFAGABCHACIJ $.

  $( A function that is one-to-one is also one-to-one on some superset of its
     range.  (Contributed by Mario Carneiro, 12-Jan-2013.) $)
  f1ss $p |- ( ( F : A -1-1-> B /\ B C_ C ) -> F : A -1-1-> C ) $=
    ( wf1 wss wa wf ccnv wfun f1f fss sylan df-f1 simprbi adantr sylanbrc ) ABD
    EZBCFZGACDHZDIJZACDERABDHZSTABDKABCDLMRUASRUBUAABDNOPACDNQ $.

  $( Combine a one-to-one function with a restriction on the domain.
     (Contributed by Stefan O'Rear, 20-Feb-2015.) $)
  f1ssr $p |- ( ( F : A -1-1-> B /\ ran F C_ C ) -> F : A -1-1-> C ) $=
    ( wf1 crn wss wa wf ccnv wfun f1fn adantr simpr df-f sylanbrc df-f1 simprbi
    wfn ) ABDEZDFCGZHZACDIZDJKZACDEUBDASZUAUCTUEUAABDLMTUANACDOPTUDUATABDIUDABD
    QRMACDQP $.

  $( A function that is one-to-one is also one-to-one on some aubset of its
     domain.  (Contributed by Mario Carneiro, 17-Jan-2015.) $)
  f1ssres $p |- ( ( F : A -1-1-> B /\ C C_ A ) -> ( F |` C ) : C -1-1-> B ) $=
    ( wf1 wss wa cres wf ccnv wfun f1f fssres sylan simprbi funres11 syl adantr
    df-f1 sylanbrc ) ABDEZCAFZGCBDCHZIZUCJKZCBUCEUAABDIZUBUDABDLABCDMNUAUEUBUAD
    JKZUEUAUFUGABDSOCDPQRCBUCST $.

  $( Two ways to express that a set ` A ` (not necessarily a function) is
     one-to-one.  Each side is equivalent to Definition 6.4(3) of
     [TakeutiZaring] p. 24, who use the notation "Un_2 (A)" for one-to-one.  We
     do not introduce a separate notation since we rarely use it.  (Contributed
     by NM, 13-Aug-2004.) $)
  f1cnvcnv $p |- ( `' `' A : dom A -1-1-> _V
             <-> ( Fun `' A /\ Fun `' `' A ) ) $=
    ( cdm cvv ccnv wf1 wf wfun wa df-f1 wfn dffn2 wceq dmcnvcnv mpbiran2 bitr3i
    df-fn wrel relcnv dfrel2 mpbi funeqi anbi12ci bitri ) ABZCADZDZEUDCUFFZUFDZ
    GZHUEGZUFGZHUDCUFIUGUKUIUJUGUFUDJZUKUDUFKULUKUFBUDLAMUFUDPNOUHUEUEQUHUELARU
    ESTUAUBUC $.

  $( Composition of one-to-one functions.  Exercise 30 of [TakeutiZaring]
     p. 25.  (Contributed by NM, 28-May-1998.) $)
  f1co $p |- ( ( F : B -1-1-> C /\ G : A -1-1-> B ) ->
              ( F o. G ) : A -1-1-> C ) $=
    ( wf1 wa ccom wf ccnv wfun df-f1 fco funco cnvco funeqi sylibr anim12i an4s
    ancoms syl2anb ) BCDFZABEFZGACDEHZIZUDJZKZGZACUDFUBBCDIZDJZKZGABEIZEJZKZGUH
    UCBCDLABELUIULUKUNUHUIULGUEUKUNGUGABCDEMUNUKUGUNUKGUMUJHZKUGUMUJNUFUODEOPQT
    RSUAACUDLQ $.

  $( Equality theorem for onto functions.  (Contributed by NM, 1-Aug-1994.) $)
  foeq1 $p |- ( F = G -> ( F : A -onto-> B <-> G : A -onto-> B ) ) $=
    ( wceq wfn crn wa wfo fneq1 rneq eqeq1d anbi12d df-fo 3bitr4g ) CDEZCAFZCGZ
    BEZHDAFZDGZBEZHABCIABDIPQTSUBACDJPRUABCDKLMABCNABDNO $.

  $( Equality theorem for onto functions.  (Contributed by NM, 1-Aug-1994.) $)
  foeq2 $p |- ( A = B -> ( F : A -onto-> C <-> F : B -onto-> C ) ) $=
    ( wceq wfn crn wa wfo fneq2 anbi1d df-fo 3bitr4g ) ABEZDAFZDGCEZHDBFZPHACDI
    BCDINOQPABDJKACDLBCDLM $.

  $( Equality theorem for onto functions.  (Contributed by NM, 1-Aug-1994.) $)
  foeq3 $p |- ( A = B -> ( F : C -onto-> A <-> F : C -onto-> B ) ) $=
    ( wceq wfn crn wa wfo eqeq2 anbi2d df-fo 3bitr4g ) ABEZDCFZDGZAEZHOPBEZHCAD
    ICBDINQROABPJKCADLCBDLM $.

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    nffo.1 $e |- F/_ x F $.
    nffo.2 $e |- F/_ x A $.
    nffo.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for an onto function.  (Contributed by
       NM, 16-May-2004.) $)
    nffo $p |- F/ x F : A -onto-> B $=
      ( wfo wfn crn wceq wa df-fo nffn nfrn nfeq nfan nfxfr ) BCDHDBIZDJZCKZLAB
      CDMSUAAABDEFNATCADEOGPQR $.
  $}

  $( An onto mapping is a mapping.  (Contributed by NM, 3-Aug-1994.) $)
  fof $p |- ( F : A -onto-> B -> F : A --> B ) $=
    ( wfn crn wceq wa wss wfo wf eqimss anim2i df-fo df-f 3imtr4i ) CADZCEZBFZG
    PQBHZGABCIABCJRSPQBKLABCMABCNO $.

  $( An onto mapping is a function.  (Contributed by NM, 29-Mar-2008.) $)
  fofun $p |- ( F : A -onto-> B -> Fun F ) $=
    ( wfo wf wfun fof ffun syl ) ABCDABCECFABCGABCHI $.

  $( An onto mapping is a function on its domain.  (Contributed by NM,
     16-Dec-2008.) $)
  fofn $p |- ( F : A -onto-> B -> F Fn A ) $=
    ( wfo wf wfn fof ffn syl ) ABCDABCECAFABCGABCHI $.

  $( The codomain of an onto function is its range.  (Contributed by NM,
     3-Aug-1994.) $)
  forn $p |- ( F : A -onto-> B -> ran F = B ) $=
    ( wfo wfn crn wceq df-fo simprbi ) ABCDCAECFBGABCHI $.

  $( Alternate definition of an onto function.  (Contributed by NM,
     22-Mar-2006.) $)
  dffo2 $p |- ( F : A -onto-> B <-> ( F : A --> B /\ ran F = B ) ) $=
    ( wfo wf crn wceq wa fof forn jca wfn ffn df-fo biimpri sylan impbii ) ABCD
    ZABCEZCFBGZHRSTABCIABCJKSCALZTRABCMRUATHABCNOPQ $.

  $( The image of the domain of an onto function.  (Contributed by NM,
     29-Nov-2002.) $)
  foima $p |- ( F : A -onto-> B -> ( F " A ) = B ) $=
    ( wfo cdm cima crn imadmrn wf wceq fof fdm syl imaeq2d forn 3eqtr3a ) ABCDZ
    CCEZFCGCAFBCHQRACQABCIRAJABCKABCLMNABCOP $.

  $( A function maps onto its range.  (Contributed by NM, 10-May-1998.) $)
  dffn4 $p |- ( F Fn A <-> F : A -onto-> ran F ) $=
    ( wfn crn wceq wa wfo eqid biantru df-fo bitr4i ) BACZLBDZMEZFAMBGNLMHIAMBJ
    K $.

  $( A function maps its domain onto its range.  (Contributed by NM,
     23-Jul-2004.) $)
  funforn $p |- ( Fun A <-> A : dom A -onto-> ran A ) $=
    ( wfun cdm wfn crn wfo funfn dffn4 bitri ) ABAACZDJAEAFAGJAHI $.

  $( An onto function has unique domain and range.  (Contributed by NM,
     5-Nov-2006.) $)
  fodmrnu $p |- ( ( F : A -onto-> B /\ F : C -onto-> D ) ->
                ( A = C /\ B = D ) ) $=
    ( wfo wa wceq wfn fofn fndmu syl2an crn forn sylan9req jca ) ABEFZCDEFZGACH
    ZBDHQEAIECISRABEJCDEJACEKLQRBEMDABENCDENOP $.

  $( Restriction of a function.  (Contributed by NM, 4-Mar-1997.) $)
  fores $p |- ( ( Fun F /\ A C_ dom F ) ->
              ( F |` A ) : A -onto-> ( F " A ) ) $=
    ( wfun cdm wss cres cima wfo funres anim1i wfn wceq df-fn crn df-ima eqcomi
    wa df-fo mpbiran2 ssdmres anbi2i 3bitr4i sylibr ) BCZABDEZQBAFZCZUEQZABAGZU
    FHZUDUGUEABIJUFAKZUGUFDALZQUJUHUFAMUJUKUFNZUILUIUMBAOPAUIUFRSUEULUGABTUAUBU
    C $.

  $( Composition of onto functions.  (Contributed by NM, 22-Mar-2006.) $)
  foco $p |- ( ( F : B -onto-> C /\ G : A -onto-> B ) ->
             ( F o. G ) : A -onto-> C ) $=
    ( wfo wa ccom crn wceq dffo2 fco ad2ant2r cdm fdm eqtr3 sylan rncoeq eqeq1d
    wf biimpar an32s adantrl jca syl2anb sylibr ) BCDFZABEFZGACDEHZTZUIIZCJZGZA
    CUIFUGBCDTZDIZCJZGZABETZEIZBJZGZUMUHBCDKABEKUQVAGUJULUNURUJUPUTABCDELMUQUTU
    LURUNUTUPULUNUTGDNZUSJZUPULUNVBBJUTVCBCDOVBUSBPQVCULUPVCUKUOCDERSUAQUBUCUDU
    EACUIKUF $.

  $( A nonzero constant function is onto.  (Contributed by NM, 12-Jan-2007.) $)
  foconst $p |- ( ( F : A --> { B } /\ F =/= (/) ) -> F : A -onto-> { B } ) $=
    ( csn wf c0 wne wa crn wceq wfo wn wrel wb frel relrn0 necon3abid syl wss
    wo frn sssn sylib ord sylbid imdistani dffo2 sylibr ) ABDZCEZCFGZHUJCIZUIJZ
    HAUICKUJUKUMUJUKULFJZLZUMUJCMZUKUONAUICOUPUNCFCPQRUJUNUMUJULUISUNUMTAUICUAU
    LBUBUCUDUEUFAUICUGUH $.

  $( Equality theorem for one-to-one onto functions.  (Contributed by NM,
     10-Feb-1997.) $)
  f1oeq1 $p |- ( F = G -> ( F : A -1-1-onto-> B <-> G : A -1-1-onto-> B ) ) $=
    ( wceq wf1 wfo wa wf1o f1eq1 foeq1 anbi12d df-f1o 3bitr4g ) CDEZABCFZABCGZH
    ABDFZABDGZHABCIABDIOPRQSABCDJABCDKLABCMABDMN $.

  $( Equality theorem for one-to-one onto functions.  (Contributed by NM,
     10-Feb-1997.) $)
  f1oeq2 $p |- ( A = B -> ( F : A -1-1-onto-> C <-> F : B -1-1-onto-> C ) ) $=
    ( wceq wf1 wfo wa wf1o f1eq2 foeq2 anbi12d df-f1o 3bitr4g ) ABEZACDFZACDGZH
    BCDFZBCDGZHACDIBCDIOPRQSABCDJABCDKLACDMBCDMN $.

  $( Equality theorem for one-to-one onto functions.  (Contributed by NM,
     10-Feb-1997.) $)
  f1oeq3 $p |- ( A = B -> ( F : C -1-1-onto-> A <-> F : C -1-1-onto-> B ) ) $=
    ( wceq wf1 wfo wa wf1o f1eq3 foeq3 anbi12d df-f1o 3bitr4g ) ABEZCADFZCADGZH
    CBDFZCBDGZHCADICBDIOPRQSABCDJABCDKLCADMCBDMN $.

  $( Equality theorem for one-to-one onto functions.  (Contributed by FL,
     14-Jul-2012.) $)
  f1oeq23 $p |- ( ( A = B /\ C = D ) ->
   ( F : A -1-1-onto-> C <-> F : B -1-1-onto-> D ) ) $=
    ( wceq wf1o f1oeq2 f1oeq3 sylan9bb ) ABFACEGBCEGCDFBDEGABCEHCDBEIJ $.

  ${
    f1eq123d.1 $e |- ( ph -> F = G ) $.
    f1eq123d.2 $e |- ( ph -> A = B ) $.
    f1eq123d.3 $e |- ( ph -> C = D ) $.
    $( Equality deduction for one-to-one functions.  (Contributed by Mario
       Carneiro, 27-Jan-2017.) $)
    f1eq123d $p |- ( ph -> ( F : A -1-1-> C <-> G : B -1-1-> D ) ) $=
      ( wf1 wceq wb f1eq1 syl f1eq2 f1eq3 3bitrd ) ABDFKZBDGKZCDGKZCEGKZAFGLSTM
      HBDFGNOABCLTUAMIBCDGPOADELUAUBMJDECGQOR $.

    $( Equality deduction for onto functions.  (Contributed by Mario Carneiro,
       27-Jan-2017.) $)
    foeq123d $p |- ( ph -> ( F : A -onto-> C <-> G : B -onto-> D ) ) $=
      ( wfo wceq wb foeq1 syl foeq2 foeq3 3bitrd ) ABDFKZBDGKZCDGKZCEGKZAFGLSTM
      HBDFGNOABCLTUAMIBCDGPOADELUAUBMJDECGQOR $.

    $( Equality deduction for one-to-one onto functions.  (Contributed by Mario
       Carneiro, 27-Jan-2017.) $)
    f1oeq123d $p |- ( ph ->
      ( F : A -1-1-onto-> C <-> G : B -1-1-onto-> D ) ) $=
      ( wf1o wceq wb f1oeq1 syl f1oeq2 f1oeq3 3bitrd ) ABDFKZBDGKZCDGKZCEGKZAFG
      LSTMHBDFGNOABCLTUAMIBCDGPOADELUAUBMJDECGQOR $.
  $}

  ${
    $d y F $.  $d y A $.  $d y B $.  $d x y $.
    nff1o.1 $e |- F/_ x F $.
    nff1o.2 $e |- F/_ x A $.
    nff1o.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for a one-to-one onto function.
       (Contributed by NM, 16-May-2004.) $)
    nff1o $p |- F/ x F : A -1-1-onto-> B $=
      ( wf1o wf1 wfo wa df-f1o nff1 nffo nfan nfxfr ) BCDHBCDIZBCDJZKABCDLQRAAB
      CDEFGMABCDEFGNOP $.
  $}

  $( A one-to-one onto mapping is a one-to-one mapping.  (Contributed by NM,
     12-Dec-2003.) $)
  f1of1 $p |- ( F : A -1-1-onto-> B -> F : A -1-1-> B ) $=
    ( wf1o wf1 wfo df-f1o simplbi ) ABCDABCEABCFABCGH $.

  $( A one-to-one onto mapping is a mapping.  (Contributed by NM,
     12-Dec-2003.) $)
  f1of $p |- ( F : A -1-1-onto-> B -> F : A --> B ) $=
    ( wf1o wf1 wf f1of1 f1f syl ) ABCDABCEABCFABCGABCHI $.

  $( A one-to-one onto mapping is function on its domain.  (Contributed by NM,
     12-Dec-2003.) $)
  f1ofn $p |- ( F : A -1-1-onto-> B -> F Fn A ) $=
    ( wf1o wf wfn f1of ffn syl ) ABCDABCECAFABCGABCHI $.

  $( A one-to-one onto mapping is a function.  (Contributed by NM,
     12-Dec-2003.) $)
  f1ofun $p |- ( F : A -1-1-onto-> B -> Fun F ) $=
    ( wf1o wfn wfun f1ofn fnfun syl ) ABCDCAECFABCGACHI $.

  $( A one-to-one onto mapping is a relation.  (Contributed by NM,
     13-Dec-2003.) $)
  f1orel $p |- ( F : A -1-1-onto-> B -> Rel F ) $=
    ( wf1o wfun wrel f1ofun funrel syl ) ABCDCECFABCGCHI $.

  $( The domain of a one-to-one onto mapping.  (Contributed by NM,
     8-Mar-2014.) $)
  f1odm $p |- ( F : A -1-1-onto-> B -> dom F = A ) $=
    ( wf1o wfn cdm wceq f1ofn fndm syl ) ABCDCAECFAGABCHACIJ $.

  $( Alternate definition of one-to-one onto function.  (Contributed by NM,
     10-Feb-1997.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  dff1o2 $p |- ( F : A -1-1-onto-> B
        <-> ( F Fn A /\ Fun `' F /\ ran F = B ) ) $=
    ( wf1o wf1 wfo wa wfn ccnv wfun crn w3a df-f1o wf df-f1 df-fo anbi12i anass
    wceq bitri 3anan12 anbi1i eqimss df-f biimpri sylan2 3adant2 ancom 3bitr4ri
    wss pm4.71i ) ABCDABCEZABCFZGZCAHZCIJZCKZBSZLZABCMUNABCNZUPGZUOURGZGZUSULVA
    UMVBABCOABCPQVCUTUPVBGZGZUSUTUPVBRUSUTGVDUTGUSVEUSVDUTUOUPURUAUBUSUTUOURUTU
    PURUOUQBUJZUTUQBUCUTUOVFGABCUDUEUFUGUKUTVDUHUITTT $.

  $( Alternate definition of one-to-one onto function.  (Contributed by NM,
     25-Mar-1998.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  dff1o3 $p |- ( F : A -1-1-onto-> B <-> ( F : A -onto-> B /\ Fun `' F ) ) $=
    ( wfn ccnv wfun crn wceq w3a wf1o wfo 3anan32 dff1o2 df-fo anbi1i 3bitr4i
    wa ) CADZCEFZCGBHZIRTQZSQABCJABCKZSQRSTLABCMUBUASABCNOP $.

  $( A one-to-one onto function is an onto function.  (Contributed by NM,
     28-Apr-2004.) $)
  f1ofo $p |- ( F : A -1-1-onto-> B -> F : A -onto-> B ) $=
    ( wf1o wfo ccnv wfun dff1o3 simplbi ) ABCDABCECFGABCHI $.

  $( Alternate definition of one-to-one onto function.  (Contributed by NM,
     25-Mar-1998.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  dff1o4 $p |- ( F : A -1-1-onto-> B <-> ( F Fn A /\ `' F Fn B ) ) $=
    ( wf1o wfn ccnv wfun crn w3a wa dff1o2 3anass cdm df-rn eqeq1i anbi2i df-fn
    wceq bitr4i 3bitri ) ABCDCAEZCFZGZCHZBRZIUAUCUEJZJUAUBBEZJABCKUAUCUELUFUGUA
    UFUCUBMZBRZJUGUEUIUCUDUHBCNOPUBBQSPT $.

  $( Alternate definition of one-to-one onto function.  (Contributed by NM,
     10-Dec-2003.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  dff1o5 $p |- ( F : A -1-1-onto-> B <-> ( F : A -1-1-> B /\ ran F = B ) ) $=
    ( wf1o wf1 wfo wa crn wceq df-f1o wf biantrurd dffo2 syl6rbbr pm5.32i bitri
    f1f ) ABCDABCEZABCFZGRCHBIZGABCJRSTRTABCKZTGSRUATABCQLABCMNOP $.

  $( A one-to-one function maps onto its range.  (Contributed by NM,
     13-Aug-2004.) $)
  f1orn $p |- ( F : A -1-1-onto-> ran F <-> ( F Fn A /\ Fun `' F ) ) $=
    ( crn wf1o wfn ccnv wfun wceq w3a wa dff1o2 eqid df-3an mpbiran2 bitri ) AB
    CZBDBAEZBFGZPPHZIZQRJZAPBKTUASPLQRSMNO $.

  $( A one-to-one function maps one-to-one onto its range.  (Contributed by NM,
     4-Sep-2004.) $)
  f1f1orn $p |- ( F : A -1-1-> B -> F : A -1-1-onto-> ran F ) $=
    ( wf1 wfn ccnv wfun crn wf1o f1fn wf df-f1 simprbi f1orn sylanbrc ) ABCDZCA
    ECFGZACHCIABCJPABCKQABCLMACNO $.

  ${
    $d A f $.  $d B f $.
    f1oabexg.1 $e |- F = { f | ( f : A -1-1-onto-> B /\ ph ) } $.
    $( The class of all 1-1-onto functions mapping one set to another is a
       set.  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    f1oabexg $p |- ( ( A e. C /\ B e. D ) -> F e. _V ) $=
      ( wcel wa cv wf1o cab cvv wf wss f1of anim1i ss2abi eqid sylancr syl5eqel
      fabexg ssexg ) BDICEIJZGBCFKZLZAJZFMZNHUEUIBCUFOZAJZFMZPULNIUINIUHUKFUGUJ
      ABCUFQRSAFBCDEULULTUCUIULNUDUAUB $.
  $}

  $( The converse of a one-to-one onto function is also one-to-one onto.
     (Contributed by NM, 11-Feb-1997.)  (Proof shortened by Andrew Salmon,
     22-Oct-2011.) $)
  f1ocnv $p |- ( F : A -1-1-onto-> B -> `' F : B -1-1-onto-> A ) $=
    ( wfn ccnv wa wf1o wrel fnrel wceq dfrel2 fneq1 biimprd sylbi anim2i ancoms
    wi mpcom dff1o4 3imtr4i ) CADZCEZBDZFUCUBEZADZFZABCGBAUBGUCUAUFUAUEUCCHZUAU
    EACIUGUDCJZUAUEQCKUHUEUAAUDCLMNROPABCSBAUBST $.

  $( A relation is a one-to-one onto function iff its converse is a one-to-one
     onto function with domain and range interchanged.  (Contributed by NM,
     8-Dec-2003.) $)
  f1ocnvb $p |- ( Rel F ->
                ( F : A -1-1-onto-> B <-> `' F : B -1-1-onto-> A ) ) $=
    ( wrel wf1o ccnv f1ocnv wceq wb dfrel2 f1oeq1 sylbi syl5ib impbid2 ) CDZABC
    EZBACFZEZABCGRABQFZEZOPBAQGOSCHTPICJABSCKLMN $.

  $( The restriction of a one-to-one function maps one-to-one onto the image.
     (Contributed by NM, 25-Mar-1998.) $)
  f1ores $p |- ( ( F : A -1-1-> B /\ C C_ A ) -> ( F |` C ) : C -1-1-onto->
            ( F " C ) ) $=
    ( wf1 wss wa cres crn wf1o cima f1ssres f1f1orn wceq wb df-ima f1oeq3 ax-mp
    syl sylibr ) ABDECAFGZCDCHZIZUBJZCDCKZUBJZUACBUBEUDABCDLCBUBMSUEUCNUFUDODCP
    UEUCCUBQRT $.

  $( The converse of a one-to-one-onto restricted function.  (Contributed by
     Paul Chapman, 21-Apr-2008.) $)
  f1orescnv $p |- ( ( Fun `' F /\ ( F |` R ) : R -1-1-onto-> P ) ->
                    ( `' F |` P ) : P -1-1-onto-> R ) $=
    ( ccnv wfun cres wf1o wa f1ocnv adantl wceq wb cima funcnvres df-ima dff1o5
    crn wf1 simprbi syl5eq reseq2d sylan9eq f1oeq1 syl mpbid ) CDZEZBACBFZGZHZA
    BUHDZGZABUFAFZGZUIULUGBAUHIJUJUKUMKULUNLUGUIUKUFCBMZFUMBCNUIUOAUFUIUOUHQZAC
    BOUIBAUHRUPAKBAUHPSTUAUBABUKUMUCUDUE $.

  $( Preimage of an image.  (Contributed by NM, 30-Sep-2004.) $)
  f1imacnv $p |- ( ( F : A -1-1-> B /\ C C_ A )
                 -> ( `' F " ( F " C ) ) = C ) $=
    ( wf1 wss wa ccnv cima cres resima wfun wceq df-f1 simprbi adantr funcnvres
    wf syl wf1o imaeq1d f1ores f1ocnv cdm crn imadmrn f1odm imaeq2d wfo 3eqtr3a
    f1ofo forn eqtr3d syl5eqr ) ABDEZCAFZGZDHZDCIZIURUSJZUSIZCURUSKUQDCJZHZUSIZ
    VACUQVCUTUSUQURLZVCUTMUOVEUPUOABDRVEABDNOPCDQSUAUQUSCVCTZVDCMUQCUSVBTVFABCD
    UBCUSVBUCSVFVCVCUDZIVCUEZVDCVCUFVFVGUSVCUSCVCUGUHVFUSCVCUIVHCMUSCVCUKUSCVCU
    LSUJSUMUN $.

  $( A reverse version of ~ f1imacnv .  (Contributed by Jeffrey Hankins,
     16-Jul-2009.) $)
  foimacnv $p |- ( ( F : A -onto-> B /\ C C_ B )
                 -> ( F " ( `' F " C ) ) = C ) $=
    ( wfo wss wa ccnv cima cres resima wfun wceq fofun adantr syl crn cdm df-rn
    syl5eqr funcnvres2 imaeq1d wfn resss cnvss ax-mp cnvcnvss sstri funss mpsyl
    df-ima eqtr2i jctir df-fn sylibr dfdm4 forn sseq2d biimpar syl6sseq ssdmres
    sylib df-fo sylanbrc foima eqtr3d ) ABDEZCBFZGZDDHZCIZIDVKJZVKIZCDVKKVIVJCJ
    ZHZVKIZVMCVIVOVLVKVIDLZVOVLMVGVQVHABDNZOCDUAPUBVIVKCVOEZVPCMVIVOVKUCZVOQZCM
    VSVIVOLZVORZVKMZGVTVIWBWDVGWBVHVODFVGVQWBVOVJHZDVNVJFVOWEFVJCUDVNVJUEUFDUGU
    HVRVODUIUJOVKVNQWCVJCUKVNSULUMVOVKUNUOVIWAVNRZCVNUPVICVJRZFWFCMVICDQZWGVGCW
    HFVHVGWHBCABDUQURUSDSUTCVJVAVBTVKCVOVCVDVKCVOVEPVFT $.

  $( The union of two onto functions with disjoint domains is an onto
     function.  (Contributed by Mario Carneiro, 22-Jun-2016.) $)
  foun $p |- ( ( ( F : A -onto-> B /\ G : C -onto-> D )
            /\ ( A i^i C ) = (/) )
           -> ( F u. G ) : ( A u. C ) -onto-> ( B u. D ) ) $=
    ( wfo wa cin c0 wceq cun wfn crn fofn anim12i fnun sylan rnun forn ad2antrr
    ad2antlr uneq12d syl5eq df-fo sylanbrc ) ABEGZCDFGZHZACIJKZHZEFLZACLZMZULNZ
    BDLZKUMUPULGUIEAMZFCMZHUJUNUGUQUHURABEOCDFOPACEFQRUKUOENZFNZLUPEFSUKUSBUTDU
    GUSBKUHUJABETUAUHUTDKUGUJCDFTUBUCUDUMUPULUEUF $.

  $( The union of two one-to-one onto functions with disjoint domains and
     ranges.  (Contributed by NM, 26-Mar-1998.) $)
  f1oun $p |- ( ( ( F : A -1-1-onto-> B /\ G : C -1-1-onto-> D )
            /\ ( ( A i^i C ) = (/) /\ ( B i^i D ) = (/) ) )
           -> ( F u. G ) : ( A u. C ) -1-1-onto-> ( B u. D ) ) $=
    ( wf1o wa cin c0 wceq cun wfn ccnv wi dff1o4 fnun ex cnvun fneq1i im2anan9
    sylibr an4s syl2anb syl6ibr imp ) ABEGZCDFGZHZACIJKZBDIJKZHZACLZBDLZEFLZGZU
    IULUOUMMZUONZUNMZHZUPUGEAMZENZBMZHFCMZFNZDMZHULUTOZUHABEPCDFPVAVDVCVFVGVAVD
    HZUJUQVCVFHZUKUSVHUJUQACEFQRVIUKUSVIUKHVBVELZUNMUSBDVBVEQUNURVJEFSTUBRUAUCU
    DUMUNUOPUEUF $.

  ${
    $d A u v x z $.  $d A u v y $.  $d B u v y $.  $d B u v z $.  $d C u v x $.
    $d D u v $.  $d S u v x $.
    fun11iun.1 $e |- ( x = y -> B = C ) $.
    fun11iun.2 $e |- B e. _V $.
    $( The union of a chain (with respect to inclusion) of one-to-one functions
       is a one-to-one function.  (Contributed by Mario Carneiro,
       20-May-2013.)  (Revised by Mario Carneiro, 24-Jun-2015.) $)
    fun11iun $p |- ( A. x e. A ( B : D -1-1-> S /\
                       A. y e. A ( B C_ C \/ C C_ B ) ) ->
                     U_ x e. A B : U_ x e. A D -1-1-> S ) $=
      ( vz vu vv wss wral wa wfun wceq cv wrex wcel wf1 wo ciun wf ccnv wfn crn
      cdm cab cuni vex eqeq1 rexbidv elab r19.29 nfre1 nfab nfral nfan wi f1eq1
      nfv biimparc df-f1 ffun anim1i sylbi syl adantlr eqeq2d cbvrexv wb sseq12
      orbi12d biimprcd expdimp rexlimivw sylan an32s adantlll sylan2b ralrimiva
      ancoms imp jca a1i rexlimi fun11uni simpld dfiun2 funeqi sylibr cop nfra1
      wex rsp eldm2 f1dm eleq2d syl5bbr adantr syl6 rexbida eliun exbii rexcom4
      3bitr4i 3bitr4g eqrdv df-fn sylanbrc rniun f1f ralimi iunss syl5eqss df-f
      frn simprd cnveqi ) FGDUAZDEMZEDMZUBZBCNZOZACNZACFUCZGACDUCZUDZYIUEZPZYHG
      YIUAYGYIYHUFZYIUGZGMYJYGYIPZYIUHZYHQYMYGJRZDQZACSZJUIZUJZPZYOYGUUBUUAUEZP
      ZYGKRZPZUUEUEPZOZUUELRZMZUUIUUEMZUBZLYTNZOZKYTNUUBUUDOYGUUNKYTUUEYTTYGUUE
      DQZACSZUUNYSUUPJUUEKUKZYQUUEQYRUUOACYQUUEDULUMUNYGUUPOYFUUOOZACSUUNYFUUOA
      CUOUURUUNACUUHUUMAUUHAVBUULALYTYSAJYRACUPUQUULAVBURUSUURUUNUTARZCTZUURUUH
      UUMYAUUOUUHYEYAUUOOFGUUEUAZUUHUUOUVAYAFGUUEDVAVCUVAFGUUEUDZUUGOUUHFGUUEVD
      UVBUUFUUGFGUUEVEVFVGVHVIUURUULLYTUUIYTTUURUUIDQZACSZUULYSUVDJUUILUKYQUUIQ
      YRUVCACYQUUIDULUMUNUVDUURUUIEQZBCSZUULUVCUVEABCUUSBRQDEUUIHVJVKYEUUOUVFUU
      LYAYEUVFUUOUULYEUVFOYDUVEOZBCSZUUOUULYDUVEBCUOUVHUUOUULUVGUUOUULUTBCYDUVE
      UUOUULUVEUUOOZUULYDUVIUUJYBUUKYCUUOUVEUUJYBVLUUEDUUIEVMWCUUIEUUEDVMVNVOVP
      VQWDVRVSVTWAWAWBWEWFWGVHWAWBYTKLWHVHZWIYIUUAAJCDIWJZWKWLYGKYPYHYGUUEUUIWM
      ZDTZLWOZACSZUUEFTZACSUUEYPTZUUEYHTYGUVNUVPACYFACWNYGUUTUVNUVPVLZYGUUTYFUV
      RYFACWPYAUVRYEUVNUUEDUHZTYAUVPLUUEDUUQWQYAUVSFUUEFGDWRWSWTXAXBWDXCUVLYITZ
      LWOUVMACSZLWOUVQUVOUVTUWALAUVLCDXDXELUUEYIUUQWQUVMALCXFXGAUUECFXDXHXIYIYH
      XJXKYGYNACDUGZUCZGACDXLYGUWBGMZACNUWCGMYFUWDACYAUWDYEYAFGDUDUWDFGDXMFGDXR
      VHXAXNACUWBGXOWLXPYHGYIXQXKYGUUDYLYGUUBUUDUVJXSYKUUCYIUUAUVKXTWKWLYHGYIVD
      XK $.
  $}

  $( The restriction of a one-to-one onto function to a difference maps onto
     the difference of the images.  (Contributed by Paul Chapman,
     11-Apr-2009.) $)
  resdif $p |- ( ( Fun `' F /\ ( F |` A ) : A -onto-> C /\
                               ( F |` B ) : B -onto-> D ) ->
                 ( F |` ( A \ B ) ) : ( A \ B ) -1-1-onto-> ( C \ D ) ) $=
    ( ccnv wfun cres wfo cdif cima wf1o wceq syl wb ax-mp crn df-ima wa forn wf
    w3a cdm wss fofun difss fof fdm syl5sseqr fores syl2anc indif reseq2i eqtri
    cin resres foeq1 rneqi 3eqtr4i foeq3 bitri funres11 biimpri syl2anr 3adant3
    sylib dff1o3 syl5eq anim12i imadif difeq12 sylan9eq sylan2 3impb f1oeq3
    mpbid ) EFGZACEAHZIZBDEBHZIZUBZABJZEWCKZEWCHZLZWCCDJZWELZVQVSWFWAVSWCWDWEIZ
    WEFGZWFVQVSWCVRWCKZVRWCHZIZWIVSVRGWCVRUCZUDWMACVRUEVSAWCWNABUFVSACVRUAWNAMA
    CVRUGACVRUHNUIWCVRUJUKWMWCWKWEIZWIWLWEMWMWOOWLEAWCUOZHWEEAWCUPWPWCEABULUMUN
    ZWCWKWLWEUQPWKWDMWOWIOWLQWEQWKWDWLWEWQURVRWCREWCRUSWKWDWCWEUTPVAVFWCEVBWFWI
    WJSWCWDWEVGVCVDVEWBWDWGMZWFWHOVQVSWAWRVSWASVQEAKZCMZEBKZDMZSZWRVSWTWAXBVSWS
    VRQCEARACVRTVHWAXAVTQDEBRBDVTTVHVIVQXCWDWSXAJWGABEVJWSCXADVKVLVMVNWDWGWCWEV
    ONVP $.

  $( The restriction of a one-to-one onto function to an intersection maps onto
     the intersection of the images.  (Contributed by Paul Chapman,
     11-Apr-2009.) $)
  resin $p |- ( ( Fun `' F /\ ( F |` A ) : A -onto-> C /\
                               ( F |` B ) : B -onto-> D ) ->
      ( F |` ( A i^i B ) ) : ( A i^i B ) -1-1-onto-> ( C i^i D ) ) $=
    ( ccnv wfun cres wfo w3a cdif wf1o cin resdif f1ofo syl wceq wb dfin4 ax-mp
    syld3an3 f1oeq3 f1oeq2 reseq2i f1oeq1 3bitrri sylib ) EFGZACEAHIZBDEBHIZJZA
    ABKZKZCCDKZKZEUMHZLZABMZCDMZEURHZLZUHUIUJULUNEULHZIZUQUKULUNVBLVCABCDENULUN
    VBOPAULCUNENUAVAURUOUTLZUMUOUTLZUQUSUOQVAVDRCDSUSUOURUTUBTURUMQVDVERABSZURU
    MUOUTUCTUTUPQVEUQRURUMEVFUDUMUOUTUPUETUFUG $.

  $( Composition of one-to-one onto functions.  (Contributed by NM,
     19-Mar-1998.) $)
  f1oco $p |- ( ( F : B -1-1-onto-> C /\ G : A -1-1-onto-> B ) ->
              ( F o. G ) : A -1-1-onto-> C ) $=
    ( wf1o wa ccom wf1 wfo df-f1o f1co foco anim12i an4s syl2anb sylibr ) BCDFZ
    ABEFZGACDEHZIZACTJZGZACTFRBCDIZBCDJZGABEIZABEJZGUCSBCDKABEKUDUFUEUGUCUDUFGU
    AUEUGGUBABCDELABCDEMNOPACTKQ $.

  $( The converse of an injective function is bijective.  (Contributed by FL,
     11-Nov-2011.) $)
  f1cnv $p |- ( F : A -1-1-> B -> `' F : ran F -1-1-onto-> A ) $=
    ( wf1 crn wf1o ccnv f1f1orn f1ocnv syl ) ABCDACEZCFKACGFABCHAKCIJ $.

  $( Composition with the converse.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  funcocnv2 $p |- ( Fun F -> ( F o. `' F ) = ( _I |` ran F ) ) $=
    ( wfun ccnv ccom cid wss crn cres wceq wrel df-fun simprbi cdm dfdm4 dmcoeq
    iss ax-mp df-rn eqtr4i a1i reseq2d eqeq2d syl5bb mpbid ) ABZAACZDZEFZUGEAGZ
    HZIZUEAJUHAKLUHUGEUGMZHZIUEUKUGPUEUMUJUGUEULUIEULUIIUEULUFMZUIAMUFGIULUNIAN
    AUFOQARSTUAUBUCUD $.

  $( The composition of an onto function and its converse.  (Contributed by
     Stefan O'Rear, 12-Feb-2015.) $)
  fococnv2 $p |- ( F : A -onto-> B -> ( F o. `' F ) = ( _I |` B ) ) $=
    ( wfo ccnv ccom cid crn cres wfun wceq fofun funcocnv2 forn reseq2d eqtrd
    syl ) ABCDZCCEFZGCHZIZGBIRCJSUAKABCLCMQRTBGABCNOP $.

  $( The composition of a one-to-one onto function and its converse equals the
     identity relation restricted to the function's range.  (Contributed by NM,
     13-Dec-2003.)  (Proof shortened by Stefan O'Rear, 12-Feb-2015.) $)
  f1ococnv2 $p |- ( F : A -1-1-onto-> B -> ( F o. `' F ) = ( _I |` B ) ) $=
    ( wf1o wfo ccnv ccom cid cres wceq f1ofo fococnv2 syl ) ABCDABCECCFGHBIJABC
    KABCLM $.

  $( Composition of an injective function with its converse.  (Contributed by
     FL, 11-Nov-2011.) $)
  f1cocnv2 $p |- ( F : A -1-1-> B -> ( F o. `' F ) = ( _I |` ran F ) ) $=
    ( wf1 wfun ccnv ccom cid crn cres wceq f1fun funcocnv2 syl ) ABCDCECCFGHCIJ
    KABCLCMN $.

  $( The composition of a one-to-one onto function's converse and itself equals
     the identity relation restricted to the function's domain.  (Contributed
     by NM, 13-Dec-2003.) $)
  f1ococnv1 $p |- ( F : A -1-1-onto-> B -> ( `' F o. F ) = ( _I |` A ) ) $=
    ( wf1o ccnv ccom cres wrel wceq f1orel dfrel2 sylib coeq2d f1ocnv f1ococnv2
    cid syl eqtr3d ) ABCDZCEZTEZFZTCFPAGZSUACTSCHUACIABCJCKLMSBATDUBUCIABCNBATO
    QR $.

  $( Composition of an injective function with its converse.  (Contributed by
     FL, 11-Nov-2011.) $)
  f1cocnv1 $p |- ( F : A -1-1-> B -> ( `' F o. F ) = ( _I |` A ) ) $=
    ( wf1 crn wf1o ccnv ccom cid cres wceq f1f1orn f1ococnv1 syl ) ABCDACEZCFCG
    CHIAJKABCLAOCMN $.

  $( Re-express a constraint on a composition as a constraint on the
     composand.  (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
  funcoeqres $p |- ( ( Fun G /\ ( F o. G ) = H ) ->
      ( F |` ran G ) = ( H o. `' G ) ) $=
    ( wfun ccom wceq crn cres cid funcocnv2 coeq2d coass eqcomi coires1 3eqtr3g
    ccnv coeq1 sylan9req ) BDZABEZCFABGZHZTBPZEZCUCESABUCEZEZAIUAHZEUDUBSUEUGAB
    JKUDUFABUCLMAUANOTCUCQR $.

  ${
    $d x F $.  $d x A $.  $d x B $.
    f11o.1 $e |- F e. _V $.
    $( Relationship between a mapping and an onto mapping.  Figure 38 of
       [Enderton] p. 145.  (Contributed by NM, 10-May-1998.) $)
    ffoss $p |- ( F : A --> B <-> E. x ( F : A -onto-> x /\ x C_ B ) ) $=
      ( wf cv wfo wss wa wex crn wfn df-f dffn4 anbi1i bitri rnex wceq foeq3
      sseq1 anbi12d spcev sylbi fof fss sylan exlimiv impbii ) BCDFZBAGZDHZUKCI
      ZJZAKZUJBDLZDHZUPCIZJZUOUJDBMZURJUSBCDNUTUQURBDOPQUNUSAUPDERUKUPSULUQUMUR
      UKUPBDTUKUPCUAUBUCUDUNUJAULBUKDFUMUJBUKDUEBUKCDUFUGUHUI $.

    $( Relationship between one-to-one and one-to-one onto function.
       (Contributed by NM, 4-Apr-1998.) $)
    f11o $p |- ( F : A -1-1-> B <-> E. x ( F : A -1-1-onto-> x /\ x C_ B ) ) $=
      ( wf ccnv wfun wa cv wfo wss wex wf1 wf1o ffoss anbi1i df-f1 dff1o3 bitri
      an32 exbii 19.41v 3bitr4i ) BCDFZDGHZIBAJZDKZUGCLZIZAMZUFIZBCDNBUGDOZUIIZ
      AMZUEUKUFABCDEPQBCDRUOUJUFIZAMULUNUPAUNUHUFIZUIIUPUMUQUIBUGDSQUHUFUIUATUB
      UJUFAUCTUD $.
  $}

  $( The empty set maps one-to-one into any class.  (Contributed by NM,
     7-Apr-1998.) $)
  f10 $p |- (/) : (/) -1-1-> A $=
    ( c0 wf1 wf ccnv wfun f0 fun0 cnv0 funeqi mpbir df-f1 mpbir2an ) BABCBABDBE
    ZFZAGOBFHNBIJKBABLM $.

  $( One-to-one onto mapping of the empty set.  (Contributed by NM,
     15-Apr-1998.) $)
  f1o00 $p |- ( F : (/) -1-1-onto-> A <-> ( F = (/) /\ A = (/) ) ) $=
    ( c0 wf1o wfn ccnv wceq dff1o4 fn0 biimpi adantr cdm dm0 cnveq syl6eq sylbi
    wa cnv0 fneq1d jca biimpa fndm syl syl5reqr biimpri eqid mpbir fneq2 mpbiri
    sylan9bb impbii bitri ) CABDBCEZBFZAEZQZBCGZACGZQZCABHUPUSUPUQURUMUQUOUMUQB
    IZJKUPCCLZAMUPCAEZVAAGUMUOVBUMAUNCUMUQUNCGUTUQUNCFCBCNROZPSUAACUBUCUDTUSUMU
    OUQUMURUMUQUTUEKUSUOCCEZVDCCGCUFCIUGUQUOVBURVDUQAUNCVCSACCUHUJUITUKUL $.

  $( Onto mapping of the empty set.  (Contributed by NM, 22-Mar-2006.) $)
  fo00 $p |- ( F : (/) -onto-> A <-> ( F = (/) /\ A = (/) ) ) $=
    ( c0 wfo wf1o wceq wf1 wfn fofn fn0 f10 f1eq1 mpbiri sylbi syl ancri df-f1o
    wa sylibr f1ofo impbii f1o00 bitri ) CABDZCABEZBCFZACFRUDUEUDCABGZUDRUEUDUG
    UDBCHZUGCABIUHUFUGBJUFUGCACGAKCABCLMNOPCABQSCABTUAABUBUC $.

  $( One-to-one onto mapping of the empty set.  (Contributed by NM,
     10-Sep-2004.) $)
  f1o0 $p |- (/) : (/) -1-1-onto-> (/) $=
    ( c0 wf1o wceq eqid f1o00 mpbir2an ) AAABAACZGADZHAAEF $.

  $( A restriction of the identity relation is a one-to-one onto function.
     (Contributed by NM, 30-Apr-1998.)  (Proof shortened by Andrew Salmon,
     22-Oct-2011.) $)
  f1oi $p |- ( _I |` A ) : A -1-1-onto-> A $=
    ( cid cres wf1o wfn ccnv fnresi cnvresid fneq1i mpbir dff1o4 mpbir2an ) AAB
    ACZDMAEZMFZAEZAGZPNQAOMAHIJAAMKL $.

  $( The identity relation is a one-to-one onto function on the universe.
     (Contributed by NM, 16-May-2004.) $)
  f1ovi $p |- _I : _V -1-1-onto-> _V $=
    ( cvv cid cres wf1o f1oi wceq wb wrel reli dfrel3 mpbi f1oeq1 ax-mp ) AABAC
    ZDZAABDZAENBFZOPGBHQIBJKAANBLMK $.

  ${
    f1osn.1 $e |- A e. _V $.
    f1osn.2 $e |- B e. _V $.
    $( A singleton of an ordered pair is one-to-one onto function.
       (Contributed by NM, 18-May-1998.)  (Proof shortened by Andrew Salmon,
       22-Oct-2011.) $)
    f1osn $p |- { <. A , B >. } : { A } -1-1-onto-> { B } $=
      ( csn cop wf1o wfn ccnv fnsn cnvsn fneq1i mpbir dff1o4 mpbir2an ) AEZBEZA
      BFEZGRPHRIZQHZABCDJTBAFEZQHBADCJQSUAABCDKLMPQRNO $.
  $}

  ${
    $d A a b $.  $d B b $.
    $( A singleton of an ordered pair is one-to-one onto function.
       (Contributed by Mario Carneiro, 12-Jan-2013.) $)
    f1osng $p |- ( ( A e. V /\ B e. W ) ->
                   { <. A , B >. } : { A } -1-1-onto-> { B } ) $=
      ( va vb cv csn cop wf1o wceq sneq f1oeq2 syl opeq1 sneqd f1oeq1 bitrd vex
      wb f1oeq3 opeq2 f1osn vtocl2g ) EGZHZFGZHZUEUGIZHZJZAHZUHAUGIZHZJZULBHZAB
      IZHZJZEFABCDUEAKZUKULUHUJJZUOUTUFULKUKVATUEALUFULUHUJMNUTUJUNKVAUOTUTUIUM
      UEAUGOPULUHUJUNQNRUGBKZUOULUPUNJZUSVBUHUPKUOVCTUGBLUHUPULUNUANVBUNURKVCUS
      TVBUMUQUGBAUBPULUPUNURQNRUEUGESFSUCUD $.
  $}

  ${
    $d A a b $.  $d B b $.
    $( A two-element swap is a bijection on a pair.  (Contributed by Mario
       Carneiro, 23-Jan-2015.) $)
    f1oprswap $p |- ( ( A e. V /\ B e. W ) ->
      { <. A , B >. , <. B , A >. } : { A , B } -1-1-onto-> { A , B } ) $=
      ( wcel cpr cop wf1o wceq csn f1osng anidms ad2antrr dfsn2 syl5eq wfn ccnv
      wa cun cnvsng opeq2 opeq1 preq12d preq2 f1oeq123d adantl mpbid wne simpll
      wb simplr simpr fnprg syl221anc ancoms uneq12d uncom syl6eq adantr cnveqi
      df-pr cnvun eqtri 3eqtr4g fneq1d mpbird dff1o4 sylanbrc pm2.61dane ) ACEZ
      BDEZRZABFZVMABGZBAGZFZHZABVLABIZRAJZVSAAGZJZHZVQVJWBVKVRVJWBAACCKLMVRWBVQ
      UJVLVRVSVMVSVMWAVPVRWAVTVTFVPVTNVRVTVNVTVOABAUAABAUBUCOVRVSAAFVMANABAUDOZ
      WCUEUFUGVLABUHZRZVPVMPZVPQZVMPZVQWEVJVKVKVJWDWFVJVKWDUIZVJVKWDUKZWJWIVLWD
      ULABBACDDCUMUNZWEWHWFWKWEVMWGVPWEVNJZQZVOJZQZSZWLWNSZWGVPVLWPWQIWDVLWPWNW
      LSWQVLWMWNWOWLABCDTVKVJWOWLIBADCTUOUPWNWLUQURUSWGWQQWPVPWQVNVOVAZUTWLWNVB
      VCWRVDVEVFVMVMVPVGVHVI $.
  $}

  $( An unordered pair of ordered pairs with different elements is a one-to-one
     onto function, analogous to ~ f1oprswap .  (Contributed by Alexander van
     der Vekens, 14-Aug-2017.) $)
  f1oprg $p |- ( ( ( A e. V /\ B e. W ) /\ ( C e. X /\ D e. Y ) )
      -> ( ( A =/= C /\ B =/= D )
      -> { <. A , B >. , <. C , D >. } : { A , C } -1-1-onto-> { B , D } ) ) $=
    ( wcel wa wne cpr cop wf1o csn cun wceq df-pr eqcomi a1i c0 f1osng ad2antrr
    cin ad2antlr disjsn2 ad2antrl ad2antll f1oun syl22anc f1oeq123d mpbid ex )
    AEIBFIJZCGIDHIJZJZACKZBDKZJZACLZBDLZABMZCDMZLZNZUPUSJZAOZCOZPZBOZDOZPZVBOZV
    COZPZNZVEVFVGVJVMNZVHVKVNNZVGVHUDUAQZVJVKUDUAQZVPUNVQUOUSABEFUBUCUOVRUNUSCD
    GHUBUEUQVSUPURACUFUGURVTUPUQBDUFUHVGVJVHVKVMVNUIUJVFVIUTVLVAVOVDVOVDQVFVDVO
    VBVCRSTVIUTQVFUTVIACRSTVLVAQVFVAVLBDRSTUKULUM $.

  ${
    $d x F $.  $d x A $.
    $( Function value when ` F ` is not a function.  Theorem 6.12(2) of
       [TakeutiZaring] p. 27.  (Contributed by NM, 30-Apr-2004.)  (Proof
       shortened by Mario Carneiro, 31-Aug-2015.) $)
    tz6.12-2 $p |- ( -. E! x A F x -> ( F ` A ) = (/) ) $=
      ( cv wbr weu wn cfv cio c0 df-fv iotanul syl5eq ) BADCEZAFGBCHNAIJABCKNAL
      M $.

    $( The value of a function at a unique point.  (Contributed by Scott
       Fenton, 6-Oct-2017.) $)
    fveu $p |- ( E! x A F x -> ( F ` A ) = U. { x | A F x } ) $=
      ( cv wbr weu cfv cio cab cuni df-fv iotauni syl5eq ) BADCEZAFBCGNAHNAIJAB
      CKNALM $.
  $}

  ${
    $d x y A $.  $d x y F $.
    $( If ` A ` is a proper class, then there is no unique binary relationship
       with ` A ` as the first element.  (Contributed by Scott Fenton,
       7-Oct-2017.) $)
    brprcneu $p |- ( -. A e. _V -> -. E! x A F x ) $=
      ( vy wcel wn cv wbr wex wi wa weq cop c0 exnal sylibr opprc1 eleq1d df-br
      wal cvv wmo weu dtru equcom albii xchbinx mpbir jctr 19.42v anbi12d anidm
      syl6bb anbi1d exbidv imbi12d mpbiri anbi12i anbi1i 3imtr4g eximdv exanali
      exbii breq2 mo4 notbii 3bitr4ri syl6ibr eu5 imnan bitr4i ) BUAEFZBAGZCHZA
      IZVNAUBZFZJZVNAUCZFZVLVOVNBDGZCHZKZADLZFZKZDIZAIZVQVLVNWGAVLBVMMZCEZWJBWA
      MZCEZKZWEKZDIZVNWGVLWJWOJNCEZWPWEKZDIZJWPWPWEDIZKWRWPWSWSDALZDTZFDAUDWSWD
      DTXAWDDOWDWTDADUEUFUGUHUIWPWEDUJPVLWJWPWOWRVLWINCBVMQRZVLWNWQDVLWMWPWEVLW
      MWPWPKWPVLWJWPWLWPXBVLWKNCBWAQRUKWPULUMUNUOUPUQBVMCSZWFWNDWCWMWEVNWJWBWLX
      CBWACSURUSVCUTVAWCWDJDTZFZAIXDATZFWHVQXDAOWGXEAWCWDDVBVCVPXFVNWBADVMWABCV
      DVEVFVGVHVTVOVPKZFVRVSXGVNAVIVFVOVPVJVKP $.
  $}


  ${
    $d x y A $.  $d x y F $.
    $( A function's value at a proper class is the empty set.  (Contributed by
       NM, 20-May-1998.) $)
    fvprc $p |- ( -. A e. _V -> ( F ` A ) = (/) ) $=
      ( vx cvv wcel wn cv wbr weu cfv c0 wceq brprcneu tz6.12-2 syl ) ADEFACGBH
      CIFABJKLCABMCABNO $.
  $}

  ${
    $d x y A $.  $d x y F $.
    $( Alternate definition of function value.  Definition 10.11 of [Quine]
       p. 68.  (Contributed by NM, 30-Apr-2004.)  (Proof shortened by Andrew
       Salmon, 17-Sep-2011.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    fv2 $p |- ( F ` A ) = U. { x | A. y ( A F y <-> y = x ) } $=
      ( cfv cv wbr cio weq wb wal cab cuni df-fv dfiota2 eqtri ) CDECBFDGZBHQBA
      IJBKALMBCDNQBAOP $.
  $}

  ${
    $d F x y $.  $d A x y $.
    $( A definition of function value in terms of iota.  (Contributed by Scott
       Fenton, 19-Feb-2013.) $)
    dffv3 $p |- ( F ` A ) = ( iota x x e. ( F " { A } ) ) $=
      ( cvv wcel cfv cv csn cima cio wceq wbr wb vex wa cop iotabidv wn syl6eq
      c0 elimasng df-br syl6bbr mpan2 df-fv syl6reqr fvprc snprc biimpi imaeq2d
      ima0 eleq2d weu wex noel nex euex mto iotanul ax-mp eqtr4d pm2.61i ) BDEZ
      BCFZAGZCBHZIZEZAJZKVCVIBVECLZAJVDVCVHVJAVCVEDEZVHVJMANVCVKOVHBVEPCEVJCBVE
      DDUABVECUBUCUDQABCUEUFVCRZVDTVIBCUGVLVIVETEZAJZTVLVHVMAVLVGTVEVLVGCTITVLV
      FTCVLVFTKBUHUIUJCUKSULQVMAUMZRVNTKVOVMAUNVMAVEUOUPVMAUQURVMAUSUTSVAVB $.
  $}


  ${
    $d x y A $.  $d x y F $.
    $( The previous definition of function value, from before the ` iota `
       operator was introduced.  Although based on the idea embodied by
       Definition 10.2 of [Quine] p. 65 (see ~ args ), this definition
       apparently does not appear in the literature.  (Contributed by NM,
       1-Aug-1994.) $)
    dffv4 $p |- ( F ` A ) = U. { x | ( F " { A } ) = { x } } $=
      ( vy cfv csn cima wcel cio cab wceq cuni dffv3 df-iota abid2 eqeq1i abbii
      cv unieqi 3eqtri ) BCEDRCBFGZHZDIUBDJZARFZKZAJZLUAUDKZAJZLDBCMUBDANUFUHUE
      UGAUCUAUDDUAOPQST $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x y F $.
    $( Membership in a function value.  (Contributed by NM, 30-Apr-2004.) $)
    elfv $p |- ( A e. ( F ` B ) <->
               E. x ( A e. x /\ A. y ( B F y <-> y = x ) ) ) $=
      ( cfv wcel cv wbr weq wb wal cab cuni wa wex fv2 eleq2i eluniab bitri ) C
      DEFZGCDBHEIBAJKBLZAMNZGCAHGUBOAPUAUCCABDEQRUBACST $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x G $.
    $( Equality theorem for function value.  (Contributed by NM,
       29-Dec-1996.) $)
    fveq1 $p |- ( F = G -> ( F ` A ) = ( G ` A ) ) $=
      ( vx wceq cv wbr cio cfv breq iotabidv df-fv 3eqtr4g ) BCEZADFZBGZDHAOCGZ
      DHABIACINPQDAOBCJKDABLDACLM $.

    $( Equality theorem for function value.  (Contributed by NM,
       29-Dec-1996.) $)
    fveq2 $p |- ( A = B -> ( F ` A ) = ( F ` B ) ) $=
      ( vx wceq cv wbr cio cfv breq1 iotabidv df-fv 3eqtr4g ) ABEZADFZCGZDHBOCG
      ZDHACIBCINPQDABOCJKDACLDBCLM $.
  $}

  ${
    fveq1i.1 $e |- F = G $.
    $( Equality inference for function value.  (Contributed by NM,
       2-Sep-2003.) $)
    fveq1i $p |- ( F ` A ) = ( G ` A ) $=
      ( wceq cfv fveq1 ax-mp ) BCEABFACFEDABCGH $.
  $}

  ${
    fveq1d.1 $e |- ( ph -> F = G ) $.
    $( Equality deduction for function value.  (Contributed by NM,
       2-Sep-2003.) $)
    fveq1d $p |- ( ph -> ( F ` A ) = ( G ` A ) ) $=
      ( wceq cfv fveq1 syl ) ACDFBCGBDGFEBCDHI $.
  $}

  ${
    fveq2i.1 $e |- A = B $.
    $( Equality inference for function value.  (Contributed by NM,
       28-Jul-1999.) $)
    fveq2i $p |- ( F ` A ) = ( F ` B ) $=
      ( wceq cfv fveq2 ax-mp ) ABEACFBCFEDABCGH $.
  $}

  ${
    fveq2d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function value.  (Contributed by NM,
       29-May-1999.) $)
    fveq2d $p |- ( ph -> ( F ` A ) = ( F ` B ) ) $=
      ( wceq cfv fveq2 syl ) ABCFBDGCDGFEBCDHI $.
  $}

  ${
    fveq12i.1 $e |- F = G $.
    fveq12i.2 $e |- A = B $.
    $( Equality deduction for function value.  (Contributed by FL,
       27-Jun-2014.) $)
    fveq12i $p |- ( F ` A ) = ( G ` B ) $=
      ( cfv fveq1i fveq2i eqtri ) ACGADGBDGACDEHABDFIJ $.
  $}

  ${
    fveq12d.1 $e |- ( ph -> F = G ) $.
    fveq12d.2 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function value.  (Contributed by FL,
       22-Dec-2008.) $)
    fveq12d $p |- ( ph -> ( F ` A ) = ( G ` B ) ) $=
      ( cfv fveq1d fveq2d eqtrd ) ABDHBEHCEHABDEFIABCEGJK $.
  $}

  ${
    $d y z F $.  $d y z A $.  $d x y z $.
    nffv.1 $e |- F/_ x F $.
    nffv.2 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for function value.  (Contributed by
       NM, 14-Nov-1995.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nffv $p |- F/_ x ( F ` A ) $=
      ( vy cfv cv wbr cio df-fv nfcv nfbr nfiota nfcxfr ) ABCGBFHZCIZFJFBCKQAFA
      BPCEDAPLMNO $.
  $}

  ${
    $d x C $.
    $( Bound-variable hypothesis builder for mapping, special case.
       (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    nffvmpt1 $p |- F/_ x ( ( x e. A |-> B ) ` C ) $=
      ( cmpt nfmpt1 nfcv nffv ) ADABCEABCFADGH $.
  $}

  ${
    $d y z A $.  $d y z F $.  $d y ph $.  $d x y z $.
    nffvd.2 $e |- ( ph -> F/_ x F ) $.
    nffvd.3 $e |- ( ph -> F/_ x A ) $.
    $( Deduction version of bound-variable hypothesis builder ~ nffv .
       (Contributed by NM, 10-Nov-2005.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nffvd $p |- ( ph -> F/_ x ( F ` A ) ) $=
      ( vz cv wcel wal cab cfv wnfc nfaba1 nffv wb wa nfnfc1 wceq abidnf adantr
      nfan adantl fveq12d nfceqdf syl2anc mpbii ) ABGHZCIZBJGKZUHDIZBJGKZLZMZBC
      DLZMZBUJULUKBGNUIBGNOABDMZBCMZUNUPPEFUQURQZBUMUOUQURBBDRBCRUBUSUJCULDUQUL
      DSURBGDTUAURUJCSUQBGCTUCUDUEUFUG $.
  $}

  ${
    $d x A $.  $d x F $.
    $( The value of a class exists.  Corollary 6.13 of [TakeutiZaring] p. 27.
       (Contributed by NM, 30-Dec-1996.) $)
    fvex $p |- ( F ` A ) e. _V $=
      ( vx cfv cv wbr cio cvv df-fv iotaex eqeltri ) ABDACEBFZCGHCABILCJK $.
  $}

  $( Move a conditional outside of a function.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  fvif $p |- ( F ` if ( ph , A , B ) ) = if ( ph , ( F ` A ) , ( F ` B ) ) $=
    ( cif cfv fveq2 ifsb ) ABCABCEZDFBDFCDFIBDGICDGH $.

  ${
    $d x y z F $.  $d x y z A $.
    $( Alternate definition of the value of a function.  Definition 6.11 of
       [TakeutiZaring] p. 26.  (Contributed by NM, 30-Apr-2004.)  (Revised by
       Mario Carneiro, 31-Aug-2015.) $)
    fv3 $p |- ( F ` A ) = { x | ( E. y ( x e. y /\ A F y ) /\
              E! y A F y ) } $=
      ( vz cv wcel wbr wa wex weu cfv weq wb wal elfv wi bi2 breq2 sylib anim2i
      alimi vex ceqsalv eximi elequ2 anbi12d cbvexv exsimpr df-eu jca nfeu1 nfv
      sylibr nfa1 nfan nfex nfim bi1 ax-14 syl6 com23 imp3a anc2ri com12 eximdv
      sps syl5bi exlimi imp impbii bitri abbi2i ) AFZBFZGZCVODHZIZBJZVQBKZIZACD
      LZVNWBGVNEFZGZVQBEMZNZBOZIZEJZWAEBVNCDPWIWAWIVSVTWIWDCWCDHZIZEJVSWHWKEWGW
      JWDWGWEVQQZBOWJWFWLBVQWERUBVQWJBWCEUCVOWCCDSUDTUAUEWKVREBEBMWDVPWJVQEBAUF
      WCVOCDSUGUHTWIWGEJZVTWDWGEUIVQBEUJZUNUKVSVTWIVRVTWIQBVTWIBVQBULWHBEWDWGBW
      DBUMWFBUOUPUQURVTWMVRWIWNVRWGWHEWGVRWHWGVRWDWFVRWDQBWFVPVQWDWFVQVPWDWFVQW
      EVPWDQVQWEUSBEAUTVAVBVCVGVDVEVFVHVIVJVKVLVM $.
  $}

  ${
    $d x F $.  $d x A $.  $d x B $.
    $( The value of a restricted function.  (Contributed by NM, 2-Aug-1994.) $)
    fvres $p |- ( A e. B -> ( ( F |` B ) ` A ) = ( F ` A ) ) $=
      ( vx wcel cv cres wbr cio cfv vex brres rbaib iotabidv df-fv 3eqtr4g ) AB
      EZADFZCBGZHZDIARCHZDIASJACJQTUADTUAQARCBDKLMNDASODACOP $.
  $}

  $( The value of a member of the domain of a subclass of a function.
     (Contributed by NM, 15-Aug-1994.) $)
  funssfv $p |- ( ( Fun F /\ G C_ F /\ A e. dom G ) ->
                ( F ` A ) = ( G ` A ) ) $=
    ( wfun wss cdm wcel cfv wceq wa cres fvres eqcomd funssres fveq1d sylan9eqr
    3impa ) BDZCBEZACFZGZABHZACHZIUARSJZUBABTKZHZUCUAUFUBATBLMUDAUECBCNOPQ $.

  ${
    $d y z F $.  $d y z A $.
    $( Function value.  Theorem 6.12(1) of [TakeutiZaring] p. 27.  (Contributed
       by NM, 30-Apr-2004.) $)
    tz6.12-1 $p |- ( ( A F y /\ E! y A F y ) -> ( F ` A ) = y ) $=
      ( cv wbr weu wa cfv cio df-fv wceq iota1 biimpac syl5eq ) BADZCEZPAFZGBCH
      PAIZOABCJQPROKPALMN $.

    $( Function value.  Theorem 6.12(1) of [TakeutiZaring] p. 27.  (Contributed
       by NM, 10-Jul-1994.) $)
    tz6.12 $p |- ( ( <. A , y >. e. F /\ E! y <. A , y >. e. F ) ->
                 ( F ` A ) = y ) $=
      ( cv cop wcel wbr weu cfv wceq df-br eubii tz6.12-1 syl2anbr ) BADZECFZBO
      CGZQAHBCIOJPAHBOCKZQPARLABCMN $.
  $}

  ${
    $d A y z w $.  $d z w v F $.
    tz6.12f.1 $e |- F/_ y F $.
    $( Function value, using bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by NM, 30-Aug-1999.) $)
    tz6.12f $p |- ( ( <. A , y >. e. F /\ E! y <. A , y >. e. F ) ->
                 ( F ` A ) = y ) $=
      ( vz cv cop wcel weu wa cfv wceq wi opeq2 eleq1d wb nfel2 nfv cbveu a1i
      anbi12d eqeq2 imbi12d tz6.12 chvarv ) BEFZGZCHZUHEIZJZBCKZUFLZMBAFZGZCHZU
      OAIZJZUKUMLZMEAUFUMLZUJUQULURUSUHUOUIUPUSUGUNCUFUMBNOZUIUPPUSUHUOEAAUGCDQ
      UOERUTSTUAUFUMUKUBUCEBCUDUE $.
  $}

  ${
    $d y F $.  $d y A $.
    $( Corollary of Theorem 6.12(1) of [TakeutiZaring] p. 27.  (Contributed by
       NM, 30-Apr-2004.) $)
    tz6.12c $p |- ( E! y A F y -> ( ( F ` A ) = y <-> A F y ) ) $=
      ( cv wbr weu cfv wceq wex euex wi nfeu1 nfv tz6.12-1 expcom breq2 biimprd
      nfim syli com12 exlimi mpcom syl5ibcom impbid ) BADZCEZAFZBCGZUEHZUFUGBUH
      CEZUIUFUFAIUGUJUFAJUFUGUJKAUGUJAUFALUJAMRUGUFUJUFUGUIUJUFUGUIABCNOZUIUJUF
      UHUEBCPZQSTUAUBULUCUKUD $.
  $}

  ${
    $d x y F $.  $d x y A $.  $d y B $.
    $( Corollary of Theorem 6.12(2) of [TakeutiZaring] p. 27.  (Contributed by
       Mario Carneiro, 17-Nov-2014.) $)
    tz6.12i $p |- ( B =/= (/) -> ( ( F ` A ) = B -> A F B ) ) $=
      ( vy cfv wceq c0 wne wbr wi fvex cv neeq1 tz6.12-2 necon1ai tz6.12c breq2
      weu wb 3imtr3d syl biimpcd sylbird eqcoms vtocle a1i com12 ) ACEZBFZBGHZA
      BCIZUIUHGHZAUHCIZUJUKULUMJZUIUNDUHACKDLZUHFUOGHZAUOCIZULUMUPUQJUHUOUHUOFZ
      UPULUQUHUOGMULURUQULUQDRZURUQSUSUHGDACNODACPUAUBUCUDUOUHGMUOUHACQTUEUFUHB
      GMUHBACQTUG $.
  $}

  $( Two possibilities for the behavior of a function value.  (Contributed by
     Stefan O'Rear, 2-Nov-2014.)  (Proof shortened by Mario Carneiro,
     31-Aug-2015.) $)
  fvbr0 $p |- ( X F ( F ` X ) \/ ( F ` X ) = (/) ) $=
    ( cfv wbr c0 wceq wne eqid tz6.12i mpi necon1bi orri ) BBACZADZMEFNMEMEGMMF
    NMHBMAIJKL $.

  $( A function value is a member of the range plus null.  (Contributed by
     Scott Fenton, 8-Jun-2011.)  (Revised by Stefan O'Rear, 3-Jan-2015.) $)
  fvrn0 $p |- ( F ` X ) e. ( ran F u. { (/) } ) $=
    ( cfv c0 wceq crn csn cun wcel id ssun2 0ex snid sselii syl6eqel wn cvv wbr
    ssun1 con1i fvprc fvex a1i fvbr0 ori brelrng syl3anc sseldi pm2.61i ) BACZD
    EZUJAFZDGZHZIUKUJDUNUKJUMUNDUMULKDLMNOUKPZULUNUJULUMSUOBQIZUJQIZBUJARZUJULI
    UPUKBAUATUQUOBAUBUCURUKURUKABUDUETBUJAQQUFUGUHUI $.

  $( The result of a function value is always a subset of the union of the
     range, even if it is invalid and thus empty.  (Contributed by Stefan
     O'Rear, 2-Nov-2014.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
  fvssunirn $p |- ( F ` X ) C_ U. ran F $=
    ( cfv crn c0 csn cun cuni wcel wss fvrn0 elssuni ax-mp uniun 0ex uneq2i un0
    unisn 3eqtri sseqtri ) BACZADZEFZGZHZUBHZUAUDIUAUEJABKUAUDLMUEUFUCHZGUFEGUF
    UBUCNUGEUFEORPUFQST $.

  ${
    $d x y A $.  $d x y F $.
    $( The value of a class outside its domain is the empty set.  (Contributed
       by NM, 24-Aug-1995.) $)
    ndmfv $p |- ( -. A e. dom F -> ( F ` A ) = (/) ) $=
      ( vx cvv wcel cdm wn cfv c0 wceq wi cv wbr weu wex eldmg syl5ibr tz6.12-2
      euex con3d syl6 fvprc a1d pm2.61i ) ADEZABFEZGZABHIJZKUEUGACLBMZCNZGUHUEU
      JUFUJUFUEUICOUICSCABDPQTCABRUAUEGUHUGABUBUCUD $.
  $}

  ${
    ndmfvrcl.1 $e |- dom F = S $.
    ndmfvrcl.2 $e |- -. (/) e. S $.
    $( Reverse closure law for function with the empty set not in its domain.
       (Contributed by NM, 26-Apr-1996.) $)
    ndmfvrcl $p |- ( ( F ` A ) e. S -> A e. S ) $=
      ( cfv wcel cdm wn c0 ndmfv eleq1d mtbiri con4i syl6eleq ) ACFZBGZACHZBARG
      ZQSIZQJBGETPJBACKLMNDO $.
  $}

  $( If a function value has a member, the argument belongs to the domain.
     (Contributed by NM, 12-Feb-2007.) $)
  elfvdm $p |- ( A e. ( F ` B ) -> B e. dom F ) $=
    ( cfv wcel c0 wne cdm ne0i ndmfv necon1ai syl ) ABCDZEMFGBCHEZMAINMFBCJKL
    $.

  $( If a function value has a member, the argument is a set.  (Contributed by
     Mario Carneiro, 6-Nov-2015.) $)
  elfvex $p |- ( A e. ( F ` B ) -> B e. _V ) $=
    ( cfv wcel cdm cvv elfvdm elex syl ) ABCDEBCFZEBGEABCHBKIJ $.

  ${
    elfvexd.1 $e |- ( ph -> A e. ( B ` C ) ) $.
    $( If a function value is nonempty, its argument is a set.  Deduction form
       of ~ elfvex .  (Contributed by David Moews, 1-May-2017.) $)
    elfvexd $p |- ( ph -> C e. _V ) $=
      ( cfv wcel cvv elfvex syl ) ABDCFGDHGEBDCIJ $.
  $}

  $( The value of a non-member of a restriction is the empty set.  (Contributed
     by NM, 13-Nov-1995.) $)
  nfvres $p |- ( -. A e. B -> ( ( F |` B ) ` A ) = (/) ) $=
    ( wcel wn cres cdm cfv wceq cin dmres inss1 eqsstri sseli con3i ndmfv syl
    c0 ) ABDZEACBFZGZDZEATHRIUBSUABAUABCGZJBCBKBUCLMNOATPQ $.

  ${
    $d x y A $.  $d x y F $.
    $( If the restriction of a class to a singleton is not a function, its
       value is the empty set.  (Contributed by NM, 8-Aug-2010.)  (Proof
       shortened by Andrew Salmon, 22-Oct-2011.) $)
    nfunsn $p |- ( -. Fun ( F |` { A } ) -> ( F ` A ) = (/) ) $=
      ( vx vy cfv c0 wceq csn cres wfun wn wrel cv wbr wmo wal weu eumo sylbi
      wa wcel vex brres wb elsn breq1 biimpac moimi syl tz6.12-2 alrimiv relres
      nsyl4 jctil dffun6 sylibr con1i ) ABEFGZBAHZIZJZURKZUTLZCMZDMZUTNZDOZCPZT
      VAVBVHVCVBVGCAVEBNZDQZVGURVJVIDOVGVIDRVFVIDVFVDVEBNZVDUSUAZTVIVDVEBUSDUBU
      CVLVKVIVLVDAGVKVIUDCAUEVDAVEBUFSUGSUHUIDABUJUMUKBUSULUNCDUTUOUPUQ $.
  $}

  $( If a class's value at an argument is not the empty set, the argument is
     contained in the domain of the class, and the class restricted to the
     argument is a function.  (Contributed by Alexander van der Vekens,
     26-May-2017.) $)
  fvfundmfvn0 $p |- ( ( F ` A ) =/= (/)
                      -> ( A e. dom F /\ Fun ( F |` { A } ) ) ) $=
    ( cdm wcel csn cres wfun wa cfv c0 wn wo wceq ianor ndmfv nfunsn jaoi sylbi
    necon1ai ) ABCDZBAEFGZHZABIZJUBKTKZUAKZLUCJMZTUANUDUFUEABOABPQRS $.

  $( Function value of the empty set.  (Contributed by Stefan O'Rear,
     26-Nov-2014.) $)
  0fv $p |- ( (/) ` A ) = (/) $=
    ( c0 cdm wcel wn cfv wceq noel dm0 eleq2i mtbir ndmfv ax-mp ) ABCZDZEABFBGO
    ABDAHNBAIJKABLM $.

  $( Equal values imply equal values in a restriction.  (Contributed by NM,
     13-Nov-1995.) $)
  fveqres $p |- ( ( F ` A ) = ( G ` A ) ->
                ( ( F |` B ) ` A ) = ( ( G |` B ) ` A ) ) $=
    ( wcel cfv wceq cres wi fvres eqeq12d biimprd wn nfvres eqtr4d a1d pm2.61i
    c0 ) ABEZACFZADFZGZACBHFZADBHFZGZISUEUBSUCTUDUAABCJABDJKLSMZUEUBUFUCRUDABCN
    ABDNOPQ $.

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y z F $.  $d x y z $.
    $( Move class substitution in and out of a function value.  (Contributed by
       NM, 11-Nov-2005.)  (Revised by NM, 20-Aug-2018.) $)
    csbfv12 $p |- [_ A / x ]_ ( F ` B ) = ( [_ A / x ]_ F ` [_ A / x ]_ B ) $=
      ( vy cvv wcel cfv csb wceq cv wbr cio csbiota sbcbr123 csbconstg df-fv c0
      wsbc csbprc breq2d syl5bb iotabidv syl5eq csbeq2i 3eqtr4g wn fveq1d eqtrd
      0fv syl6req pm2.61i ) BFGZABCDHZIZABCIZABDIZHZJUMABCEKZDLZEMZIZUPUSUQLZEM
      ZUOURUMVBUTABSZEMVDUTAEBNUMVEVCEVEUPABUSIZUQLUMVCABCUSDOUMVFUSUPUQABUSFPU
      AUBUCUDABUNVAECDQUEEUPUQQUFUMUGZUORURABUNTVGURUPRHRVGUPUQRABDTUHUPUJUKUIU
      L $.

    $( Move class substitution in and out of a function value.  (Contributed by
       NM, 11-Nov-2005.)  Obsolete as of 20-Aug-2018.  Use ~ csbfv12 instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbfv12gOLD $p |- ( A e. C ->
                 [_ A / x ]_ ( F ` B ) = ( [_ A / x ]_ F ` [_ A / x ]_ B ) ) $=
      ( vy wcel cv wbr cio csb cfv csbiotagOLD sbcbrgOLD csbconstg breq2d bitrd
      wsbc iotabidv df-fv eqtrd csbeq2i 3eqtr4g ) BDGZABCFHZEIZFJZKZABCKZUEABEK
      ZIZFJZABCELZKUIUJLUDUHUFABRZFJULUFAFBDMUDUNUKFUDUNUIABUEKZUJIUKABCUEDENUD
      UOUEUIUJABUEDOPQSUAABUMUGFCETUBFUIUJTUC $.
  $}

  ${
    $d y A $.  $d y C $.  $d x y F $.
    $( Move class substitution in and out of a function value.  (Contributed by
       NM, 10-Nov-2005.) $)
    csbfv2g $p |- ( A e. C -> [_ A / x ]_ ( F ` B ) =
                  ( F ` [_ A / x ]_ B ) ) $=
      ( wcel cfv csb csbfv12 csbconstg fveq1d syl5eq ) BDFZABCEGHABCHZABEHZGNEG
      ABCEIMNOEABEDJKL $.

    $( Substitution for a function value.  (Contributed by NM, 1-Jan-2006.)
       (Revised by NM, 20-Aug-2018.) $)
    csbfv $p |- [_ A / x ]_ ( F ` x ) = ( F ` A ) $=
      ( cvv wcel cv cfv csb csbfv2g csbvarg fveq2d eqtrd wn csbprc fvprc eqtr4d
      wceq c0 pm2.61i ) BDEZABAFZCGZHZBCGZQTUCABUAHZCGUDABUADCITUEBCABDJKLTMUCR
      UDABUBNBCOPS $.

    $( Substitution for a function value.  (Contributed by NM, 1-Jan-2006.)
       Obsolete as of 20-Aug-2018.  Use ~ csbfv instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbfvgOLD $p |- ( A e. C -> [_ A / x ]_ ( F ` x ) = ( F ` A ) ) $=
      ( wcel cv cfv csb csbfv2g csbvarg fveq2d eqtrd ) BCEZABAFZDGHABNHZDGBDGAB
      NCDIMOBDABCJKL $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y B $.
    $( The second argument of a binary relation on a function is the function's
       value.  (Contributed by NM, 30-Apr-2004.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    funbrfv $p |- ( Fun F -> ( A F B -> ( F ` A ) = B ) ) $=
      ( vy wfun wbr cfv wceq cvv wcel wa wrel funrel brrelex2 sylan cv wi breq2
      anbi2d eqeq2 imbi12d weu funeu tz6.12-1 sylan2 anabss7 vtoclg mpcom ex )
      CEZABCFZACGZBHZBIJZUJUKKZUMUJCLUKUNCMABCNOUJADPZCFZKZULUPHZQUOUMQDBIUPBHZ
      URUOUSUMUTUQUKUJUPBACRSUPBULTUAUJUQUSURUQUQDUBUSDAUPCUCDACUDUEUFUGUHUI $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y B $.
    $( The second element in an ordered pair member of a function is the
       function's value.  (Contributed by NM, 19-Jul-1996.) $)
    funopfv $p |- ( Fun F -> ( <. A , B >. e. F -> ( F ` A ) = B ) ) $=
      ( cop wcel wbr wfun cfv wceq df-br funbrfv syl5bir ) ABDCEABCFCGACHBIABCJ
      ABCKL $.
  $}

  ${
    $d x y F $.  $d x A $.  $d x y B $.  $d x C $.
    $( Equivalence of function value and binary relation.  (Contributed by NM,
       19-Apr-2004.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
    fnbrfvb $p |- ( ( F Fn A /\ B e. A ) ->
                   ( ( F ` B ) = C <-> B F C ) ) $=
      ( vx wfn wcel wa cfv wceq wbr eqid cv wb wi fvex eqeq2 breq2 bibi12d syl
      imbi2d weu fneu tz6.12c vtocl mpbii syl5ibcom fnfun funbrfv adantr impbid
      wfun ) DAFZBAGZHZBDIZCJZBCDKZUOBUPDKZUQURUOUPUPJZUSUPLUOUPEMZJZBVADKZNZOU
      OUTUSNZOEUPBDPVAUPJZVDVEUOVFVBUTVCUSVAUPUPQVAUPBDRSUAUOVCEUBVDEABDUCEBDUD
      TUEUFUPCBDRUGUMURUQOZUNUMDULVGADUHBCDUITUJUK $.

    $( Equivalence of function value and ordered pair membership.  (Contributed
       by NM, 7-Nov-1995.) $)
    fnopfvb $p |- ( ( F Fn A /\ B e. A ) ->
                   ( ( F ` B ) = C <-> <. B , C >. e. F ) ) $=
      ( wfn wcel wa cfv wceq wbr cop fnbrfvb df-br syl6bb ) DAEBAFGBDHCIBCDJBCK
      DFABCDLBCDMN $.
  $}

  ${
    $( Equivalence of function value and binary relation.  (Contributed by NM,
       26-Mar-2006.) $)
    funbrfvb $p |- ( ( Fun F /\ A e. dom F ) ->
                   ( ( F ` A ) = B <-> A F B ) ) $=
      ( wfun cdm wfn wcel cfv wceq wbr wb funfn fnbrfvb sylanb ) CDCCEZFAOGACHB
      IABCJKCLOABCMN $.

    $( Equivalence of function value and ordered pair membership.  Theorem
       4.3(ii) of [Monk1] p. 42.  (Contributed by NM, 26-Jan-1997.) $)
    funopfvb $p |- ( ( Fun F /\ A e. dom F ) ->
                   ( ( F ` A ) = B <-> <. A , B >. e. F ) ) $=
      ( wfun cdm wfn wcel cfv wceq cop wb funfn fnopfvb sylanb ) CDCCEZFAOGACHB
      IABJCGKCLOABCMN $.
  $}

  ${
    $d x y z w A $.  $d x y B $.  $d x y z w F $.  $d x y C $.
    $( Function value in terms of a binary relation.  (Contributed by Mario
       Carneiro, 19-Mar-2014.) $)
    funbrfv2b $p |- ( Fun F ->
                       ( A F B <-> ( A e. dom F /\ ( F ` A ) = B ) ) ) $=
      ( wfun wbr cdm wcel wa cfv wceq wrel funrel releldm syl pm4.71rd funbrfvb
      wi ex pm5.32da bitr4d ) CDZABCEZACFGZUBHUCACIBJZHUAUBUCUACKZUBUCQCLUEUBUC
      ABCMRNOUAUCUDUBABCPST $.

    $( Representation of a function in terms of its values.  (Contributed by
       FL, 14-Sep-2013.)  (Proof shortened by Mario Carneiro, 31-Aug-2015.) $)
    dffn5 $p |- ( F Fn A <-> F = ( x e. A |-> ( F ` x ) ) ) $=
      ( vy wfn cv cfv cmpt wceq wcel wa copab wbr wrel fnrel dfrel4v sylib fnbr
      ex pm4.71rd eqcom fnbrfvb syl5bb pm5.32da bitr4d opabbidv eqtrd fvex eqid
      df-mpt syl6eqr fnmpti fneq1 mpbiri impbii ) CBEZCABAFZCGZHZIZUPCUQBJZDFZU
      RIZKZADLZUSUPCUQVBCMZADLZVEUPCNCVGIBCOADCPQUPVFVDADUPVFVAVFKVDUPVFVAUPVFV
      ABUQVBCRSTUPVAVCVFVCURVBIUPVAKVFVBURUABUQVBCUBUCUDUEUFUGADBURUJUKUTUPUSBE
      ABURUSUQCUHUSUIULBCUSUMUNUO $.

    $( The range of a function expressed as a collection of the function's
       values.  (Contributed by NM, 20-Oct-2005.)  (Proof shortened by Mario
       Carneiro, 31-Aug-2015.) $)
    fnrnfv $p |- ( F Fn A -> ran F = { y | E. x e. A y = ( F ` x ) } ) $=
      ( wfn crn cv cfv cmpt wceq wrex cab dffn5 rneq sylbi eqid rnmpt syl6eq )
      DCEZDFZACAGDHZIZFZBGUAJACKBLSDUBJTUCJACDMDUBNOABCUAUBUBPQR $.

    $( A member of a function's range is a value of the function.  (Contributed
       by NM, 31-Oct-1995.) $)
    fvelrnb $p |- ( F Fn A -> ( B e. ran F <-> E. x e. A ( F ` x ) = B ) ) $=
      ( vy wfn crn wcel cv cfv wceq wrex cab fnrnfv eleq2d cvv fvex eleq1 mpbii
      syl6bb rexlimivw eqeq1 eqcom rexbidv elab3 ) DBFZCDGZHCEIZAIZDJZKZABLZEMZ
      HUJCKZABLZUFUGUMCAEBDNOULUOECUNCPHZABUNUJPHUPUIDQUJCPRSUAUHCKZUKUNABUQUKC
      UJKUNUHCUJUBCUJUCTUDUET $.

    $( Alternate definition of the image of a function.  (Contributed by Raph
       Levien, 20-Nov-2006.) $)
    dfimafn $p |- ( ( Fun F /\ A C_ dom F ) ->
                  ( F " A ) = { y | E. x e. A ( F ` x ) = y } ) $=
      ( wfun cdm wss wa cv cfv wceq wrex cab wbr cima wcel wb ssel funbrfvb ex
      syl9r imp31 rexbidva abbidv dfima2 syl6reqr ) DEZCDFZGZHZAIZDJBIZKZACLZBM
      UKULDNZACLZBMDCOUJUNUPBUJUMUOACUGUIUKCPZUMUOQZUIUQUKUHPZUGURCUHUKRUGUSURU
      KULDSTUAUBUCUDABDCUEUF $.

    $( Alternate definition of the image of a function as an indexed union of
       singletons of function values.  (Contributed by Raph Levien,
       20-Nov-2006.) $)
    dfimafn2 $p |- ( ( Fun F /\ A C_ dom F ) ->
                   ( F " A ) = U_ x e. A { ( F ` x ) } ) $=
      ( vy wfun cdm wss wa cima cv cfv wceq cab ciun wrex dfimafn iunab syl6eqr
      csn wcel df-sn eqcom abbii eqtri a1i iuneq2i ) CEBCFGHZCBIZABAJZCKZDJZLZD
      MZNZABUJSZNUGUHULABODMUNADBCPULADBQRABUOUMUOUMLUIBTUOUKUJLZDMUMDUJUAUPULD
      UKUJUBUCUDUEUFR $.

    $( Membership relation for the values of a function whose image is a
       subclass.  (Contributed by Raph Levien, 20-Nov-2006.) $)
    funimass4 $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( ( F " A ) C_ B <-> A. x e. A ( F ` x ) e. B ) ) $=
      ( vy cdm wss wfun cima cv cfv wcel wral wb wi wal wa wceq wrex syl5bb wbr
      dfss2 eqcom ssel funbrfvb ex syl9 imp31 rexbidva vex elima imbi1d r19.23v
      syl6rbbr syl6bbr albidv ralcom4 eleq1 ceqsalv ralbii bitr3i syl6bb ancoms
      fvex ) BDFZGZDHZDBIZCGZAJZDKZCLZABMZNVIEJZVHLZVNCLZOZEPZVFVGQZVMEVHCUBVSV
      RVNVKRZVPOZABMZEPZVMVSVQWBEVSVQVTABSZVPOWBVSVOWDVPVSWDVJVNDUAZABSVOVSVTWE
      ABVTVKVNRZVSVJBLZQWEVNVKUCVFVGWGWFWENZVFWGVJVELZVGWHBVEVJUDVGWIWHVJVNDUEU
      FUGUHTUIAVNDBEUJUKUNULVTVPABUMUOUPWCWAEPZABMVMWAAEBUQWJVLABVPVLEVKVJDVDVN
      VKCURUSUTVAVBTVC $.

    $( Function value in an image.  Part of Theorem 4.4(iii) of [Monk1] p. 42.
       (Contributed by NM, 29-Apr-2004.)  (Proof shortened by Andrew Salmon,
       22-Oct-2011.) $)
    fvelima $p |- ( ( Fun F /\ A e. ( F " B ) ) ->
                  E. x e. B ( F ` x ) = A ) $=
      ( wfun cima wcel cv cfv wceq wrex wbr elimag ibi funbrfv reximdv syl5 imp
      ) DEZBDCFZGZAHZDIBJZACKZUAUBBDLZACKZSUDUAUFABDCTMNSUEUCACUBBDOPQR $.
  $}

  ${
    $d x y A $.  $d x C $.  $d x y F $.
    feqmptd.1 $e |- ( ph -> F : A --> B ) $.
    $( Deduction form of ~ dffn5 .  (Contributed by Mario Carneiro,
       8-Jan-2015.) $)
    feqmptd $p |- ( ph -> F = ( x e. A |-> ( F ` x ) ) ) $=
      ( wfn cv cfv cmpt wceq wf ffn syl dffn5 sylib ) AECGZEBCBHEIJKACDELQFCDEM
      NBCEOP $.

    feqresmpt.2 $e |- ( ph -> C C_ A ) $.
    $( Express a restricted function as a mapping.  (Contributed by Mario
       Carneiro, 18-May-2016.) $)
    feqresmpt $p |- ( ph -> ( F |` C ) = ( x e. C |-> ( F ` x ) ) ) $=
      ( cres cv cfv cmpt wf wss fssres syl2anc feqmptd fvres mpteq2ia syl6eq )
      AFEIZBEBJZUAKZLBEUBFKZLABEDUAACDFMECNEDUAMGHCDEFOPQBEUCUDUBEFRST $.
  $}

  ${
    $d x z $.  $d x z A $.  $d z F $.
    dffn5f.1 $e |- F/_ x F $.
    $( Representation of a function in terms of its values.  (Contributed by
       Mario Carneiro, 3-Jul-2015.) $)
    dffn5f $p |- ( F Fn A <-> F = ( x e. A |-> ( F ` x ) ) ) $=
      ( vz wfn cv cfv cmpt wceq dffn5 nfcv nffv fveq2 cbvmpt eqeq2i bitri ) CBF
      CEBEGZCHZIZJCABAGZCHZIZJEBCKTUCCEABSUBARCDARLMEUBLRUACNOPQ $.
  $}

  ${
    $d y A $.  $d x y B $.  $d x y C $.  $d x y F $.
    $( Function value in an image.  (Contributed by NM, 20-Jan-2007.)  (Proof
       shortened by Andrew Salmon, 22-Oct-2011.)  (Revised by David Abernethy,
       17-Dec-2011.) $)
    fvelimab $p |- ( ( F Fn A /\ B C_ A ) -> ( C e. ( F " B ) <->
                  E. x e. B ( F ` x ) = C ) ) $=
      ( vy wfn wss wa cima wcel cv cfv wceq wrex cvv anim2i eleq1 wb wi rexbidv
      elex fvex mpbii rexlimivw eqeq2 bibi12d imbi2d wfun cdm fnfun adantr fndm
      cab sseq2d biimpar dfimafn syl2anc abeq2d vtoclg impcom pm5.21nd ) EBGZCB
      HZIZDECJZKZALZEMZDNZACOZVEDPKZIVGVLVEDVFUBQVKVLVEVJVLACVJVIPKVLVHEUCVIDPR
      UDUEQVLVEVGVKSZVEFLZVFKZVIVNNZACOZSZTVEVMTFDPVNDNZVRVMVEVSVOVGVQVKVNDVFRV
      SVPVJACVNDVIUFUAUGUHVEVQFVFVEEUIZCEUJZHZVFVQFUNNVCVTVDBEUKULVCWBVDVCWABCB
      EUMUOUPAFCEUQURUSUTVAVB $.
  $}

  $( The value of the identity function.  (Contributed by NM, 1-May-2004.)
     (Revised by Mario Carneiro, 28-Apr-2015.) $)
  fvi $p |- ( A e. V -> ( _I ` A ) = A ) $=
    ( cid wfun wcel wbr cfv wceq funi ididg funbrfv mpsyl ) CDABEAACFACGAHIABJA
    ACKL $.

  ${
    $d x y A $.  $d y B $.  $d x y F $.
    $( The value of the identity function is a subset of the argument.
       (Contributed by Mario Carneiro, 27-Feb-2016.) $)
    fviss $p |- ( _I ` A ) C_ A $=
      ( vx cid cfv cv wcel id cvv wceq elfvex fvi syl eleqtrd ssriv ) BACDZABEZ
      OFZPOAQGQAHFOAIPACJAHKLMN $.

    $( The indexed intersection of a function's values is the intersection of
       its range.  (Contributed by NM, 20-Oct-2005.) $)
    fniinfv $p |- ( F Fn A -> |^|_ x e. A ( F ` x ) = |^| ran F ) $=
      ( vy wfn crn cint cv cfv wceq wrex cab ciin fnrnfv inteqd dfiin2 syl6reqr
      fvex ) CBEZCFZGDHAHZCIZJABKDLZGABUBMSTUCADBCNOADBUBUACRPQ $.

    $( Singleton of function value.  (Contributed by NM, 22-May-1998.) $)
    fnsnfv $p |- ( ( F Fn A /\ B e. A ) -> { ( F ` B ) } = ( F " { B } ) ) $=
      ( vy wfn wcel wa cv cfv wceq cab wbr csn cima eqcom fnbrfvb syl5bb abbidv
      df-sn a1i wrel fnrel relimasn syl adantr 3eqtr4d ) CAEZBAFZGZDHZBCIZJZDKZ
      BUJCLZDKZUKMZCBMNZUIULUNDULUKUJJUIUNUJUKOABUJCPQRUPUMJUIDUKSTUGUQUOJZUHUG
      CUAURACUBDBCUCUDUEUF $.
  $}

  $( The image of a pair under a funtion.  (Contributed by Jeff Madsen,
     6-Jan-2011.) $)
  fnimapr $p |- ( ( F Fn A /\ B e. A /\ C e. A ) ->
                          ( F " { B , C } ) = { ( F ` B ) , ( F ` C ) } ) $=
    ( wfn wcel w3a csn cima cun cfv fnsnfv 3adant3 3adant2 uneq12d eqcomd df-pr
    cpr wceq imaeq2i imaundi eqtri 3eqtr4g ) DAEZBAFZCAFZGZDBHZIZDCHZIZJZBDKZHZ
    CDKZHZJZDBCRZIZUMUORUGUQULUGUNUIUPUKUDUEUNUISUFABDLMUDUFUPUKSUEACDLNOPUSDUH
    UJJZIULURUTDBCQTDUHUJUAUBUMUOQUC $.

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z F $.
    ssimaex.1 $e |- A e. _V $.
    $( The existence of a subimage.  (Contributed by NM, 8-Apr-2007.) $)
    ssimaex $p |- ( ( Fun F /\ B C_ ( F " A ) ) ->
                 E. x ( x C_ A /\ B = ( F " x ) ) ) $=
      ( vy vz vw cima wss cdm cv wceq wa wex cfv wcel wi ex adantr wfun imaeq2i
      cin cres dmres imadmres eqtr3i sseq2i ssrab2 ssel2 adantll fvelima eleq1a
      crab wrex anim2d fveq2 eleq1d elrab syl6ibr simpr jcad reximdv2 adantl wb
      a1i wfn funfn inss2 sstri fvelimab mpan2 sylbi sylibrd syld adantlr eleq1
      mpd biimpcd rexlimiv impbid eqrdv inex1 rabex sseq1 imaeq2 eqeq2d anbi12d
      syl6 spcev sylancr inss1 sstr anim1i eximi syl sylan2br ) CDBIZJDUAZCDBDK
      ZUCZIZJZALZBJZCDXDIZMZNZAOZXBWRCDDBUDKZIXBWRXJXADDBUEUBDBUFUGUHWSXCNZXDXA
      JZXGNZAOZXIXKFLZDPZCQZFXAUNZXAJZCDXRIZMZXNXQFXAUIZXKGCXTXKGLZCQZYCXTQZXKY
      DYEXKYDNYCXBQZYEXCYDYFWSCXBYCUJUKWSYDYFYERXCWSYDNZYFHLZDPZYCMZHXAUOZYEWSY
      FYKRYDWSYFYKHYCXADULSTYGYKYJHXRUOZYEYDYKYLRWSYDYJYJHXAXRYDYHXAQZYJNZYHXRQ
      ZYJYDYNYMYICQZNZYOYDYJYPYMYCCYIUMUPXQYPFYHXAXOYHMXPYICXOYHDUQURUSZUTYNYJR
      YDYMYJVAVFVBVCVDWSYEYLVEZYDWSDWTVGZYSDVHYTXRWTJYSXRXAWTYBBWTVIVJHWTXRYCDV
      KVLVMTVNVOVPVRSWSYEYDRXCWSYEYLYDWSYEYLHYCXRDULSYJYDHXRYOYQYJYDRZYRYPUUAYM
      YJYPYDYIYCCVQVSVDVMVTWITWAWBXMXSYANAXRXQFXABWTEWCWDXDXRMZXLXSXGYAXDXRXAWE
      UUBXFXTCXDXRDWFWGWHWJWKXMXHAXLXEXGXLXABJXEBWTWLXDXABWMVLWNWOWPWQ $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.
    $( The existence of a subimage.  (Contributed by FL, 15-Apr-2007.) $)
    ssimaexg $p |- ( ( A e. C /\ Fun F /\ B C_ ( F " A ) ) ->
                 E. x ( x C_ A /\ B = ( F " x ) ) ) $=
      ( vy wcel wfun cima wss cv wceq wa wex imaeq2 sseq2d anbi2d sseq2 anbi1d
      wi exbidv imbi12d vex ssimaex vtoclg 3impib ) BDGEHZCEBIZJZAKZBJZCEUJILZM
      ZANZUGCEFKZIZJZMZUJUOJZULMZANZTUGUIMZUNTFBDUOBLZURVBVAUNVCUQUIUGVCUPUHCUO
      BEOPQVCUTUMAVCUSUKULUOBUJRSUAUBAUOCEFUCUDUEUF $.
  $}

  $( A simplified expression for the value of a function when we know it's a
     function.  (Contributed by NM, 22-May-1998.) $)
  funfv $p |- ( Fun F -> ( F ` A ) = U. ( F " { A } ) ) $=
    ( wfun cdm wcel cfv csn cima cuni wceq fvex unisn wfn df-fn mpbiran2 fnsnfv
    wa eqid unieqd c0 sylanbr syl5eqr ex wn ndmfv ndmima syl6eq eqtr4d pm2.61d1
    uni0 ) BCZABDZEZABFZBAGHZIZJZUKUMUQUKUMQZUNUNGZIUPUNABKLURUSUOUKBULMZUMUSUO
    JUTUKULULJULRBULNOULABPUASUBUCUMUDZUNTUPABUEVAUPTITVAUOTABUFSUJUGUHUI $.

  ${
    $d y A $.  $d y F $.
    $( The value of a function.  Definition of function value in [Enderton]
       p. 43.  (Contributed by NM, 22-May-1998.) $)
    funfv2 $p |- ( Fun F -> ( F ` A ) = U. { y | A F y } ) $=
      ( wfun cfv csn cima cuni cv wbr cab funfv wrel funrel relimasn syl unieqd
      wceq eqtrd ) CDZBCECBFGZHBAICJAKZHBCLTUAUBTCMUAUBRCNABCOPQS $.
  $}

  ${
    $d w z A $.  $d w z F $.  $d w y z $.
    funfv2f.1 $e |- F/_ y A $.
    funfv2f.2 $e |- F/_ y F $.
    $( The value of a function.  Version of ~ funfv2 using a bound-variable
       hypotheses instead of distinct variable conditions.  (Contributed by NM,
       19-Feb-2006.) $)
    funfv2f $p |- ( Fun F -> ( F ` A ) = U. { y | A F y } ) $=
      ( vw wfun cfv wbr cab cuni funfv2 nfcv nfbr nfv breq2 cbvab unieqi syl6eq
      cv ) CGBCHBFTZCIZFJZKBATZCIZAJZKFBCLUCUFUBUEFAABUACDEAUAMNUEFOUAUDBCPQRS
      $.
  $}

  $( Value of the union of two functions when the domains are separate.
     (Contributed by FL, 7-Nov-2011.) $)
  fvun $p |- ( ( ( Fun F /\ Fun G ) /\ ( dom F i^i dom G ) = (/) ) ->
                ( ( F u. G ) ` A ) = ( ( F ` A ) u. ( G ` A ) ) ) $=
    ( wfun wa cdm cin c0 wceq cun cfv csn cima cuni funun funfv imaundir eqcomd
    syl a1i unieqd uniun anim12i adantr uneq12 syl5eq 3eqtrd ) BDZCDZEZBFCFGHIZ
    EZABCJZKZUMALZMZNZBUOMZCUOMZJZNZABKZACKZJZULUMDUNUQIBCOAUMPSULUPUTUPUTIULBC
    UOQTUAULVAURNZUSNZJZVDURUSUBULVEVBIZVFVCIZEZVGVDIUJVJUKUHVHUIVIUHVBVEABPRUI
    VCVFACPRUCUDVEVBVFVCUESUFUG $.

  ${
    $d A x $.  $d B x $.  $d X x $.
    $( The value of a union when the argument is in the first domain.
       (Contributed by Scott Fenton, 29-Jun-2013.) $)
    fvun1 $p |- ( ( F Fn A /\ G Fn B /\ ( ( A i^i B ) = (/) /\ X e. A ) ) ->
    ( ( F u. G ) ` X ) = ( F ` X ) ) $=
      ( wfn cin c0 wceq wcel wa w3a cun cfv wfun cdm fnfun 3ad2ant1 fndm wn syl
      3ad2ant2 eqeq1d biimprd adantrd 3impia fvun syl21anc disjel adantl eleq2d
      ineqan12d wb adantr mtbird 3adant1 ndmfv uneq2d un0 syl6eq eqtrd ) CAFZDB
      FZABGZHIZEAJZKZLZECDMNZECNZEDNZMZVJVHCOZDOZCPZDPZGZHIZVIVLIVBVCVMVGACQRVC
      VBVNVGBDQUBVBVCVGVRVBVCKZVEVRVFVSVRVEVSVQVDHVBVCVOAVPBACSBDSZULUCUDUEUFEC
      DUGUHVHVLVJHMVJVHVKHVJVHEVPJZTZVKHIVCVGWBVBVCVGKWAEBJZVGWCTVCABEUIUJVCWAW
      CUMVGVCVPBEVTUKUNUOUPEDUQUAURVJUSUTVA $.
  $}

  $( The value of a union when the argument is in the second domain.
     (Contributed by Scott Fenton, 29-Jun-2013.) $)
  fvun2 $p |- ( ( F Fn A /\ G Fn B /\ ( ( A i^i B ) = (/) /\ X e. B ) ) ->
    ( ( F u. G ) ` X ) = ( G ` X ) ) $=
    ( wfn cin c0 wceq wcel w3a cun cfv uncom fveq1i incom eqeq1i anbi1i fvun1
    wa syl3an3b 3com12 syl5eq ) CAFZDBFZABGZHIZEBJZTZKECDLZMEDCLZMZEDMZEUJUKCDN
    OUEUDUIULUMIZUIUEUDBAGZHIZUHTUNUGUPUHUFUOHABPQRBADCESUAUBUC $.

  ${
    $d x y z A $.  $d x y z F $.
    $( Alternate definition of function value ~ df-fv that doesn't require
       dummy variables.  (Contributed by NM, 4-Aug-2010.) $)
    dffv2 $p |- ( F ` A ) = U. ( ( F " { A } )
            \ U. U. ( ( ( F |` { A } ) o. `' ( F |` { A } ) ) \ _I ) ) $=
      ( vy vz vx cid cdif cuni wceq cvv wcel wn c0 wss unieqd syl6eq wa wbr wex
      wal csn cres wfun cfv cima ccnv ccom snidb fvres sylbi fvprc eqtr4d funfv
      pm2.61i wrel df-fun simprbi ssdif0 sylib uni0 resima dif0 eqtr4i syl6reqr
      difeq2d eqtrd syl5eqr nfunsn cdm cv weq relres dffun3 mpbiran albii alnex
      wi iman bitri exbii exnal 3bitrri con1bii eximi snssi residm dmeqi biimpi
      sp ssdmres syl vex breldm elsn syl6bb biimpa syl2an breq1d biimpd pm2.43d
      eleq2 ex anim1d eximdv exlimdv mpan9 eleq2i elimasni sylbir cpr cop uniop
      opex unisn wrex brrelexi brcnvg sylancr biimpar adantl breq2 breq1 rspcev
      anbi12d mpancom ancoms syldan anim1i an32s eldif rexv brco df-br 3bitr2ri
      wb ideq equcom 3bitr3i notbii syl5eqssr anbi12i bitr2i 3syl unissd sylibr
      uniss prss simpld syl5 exlimiv ssrdv ndmima difeq1d 0dif pm2.61d1 ) BAUAZ
      UBZUCZABUDZBUUPUEZUUQUUQUFZUGZFGZHZHZGZHZIUURUUSAUUQUDZUVGAJKZUVHUUSIZUVI
      AUUPKUVJAUHAUUPBUIUJUVILUVHMUUSAUUQUKABUKULUNUURUVHUUQUUPUEZHUVGAUUQUMUUR
      UVKUVFUURUVFUUTMGZUVKUURUVEMUUTUURUVEMHZMUURUVDMUURUVDUVMMUURUVCMUURUVBFN
      ZUVCMIUURUUQUOZUVNUUQUPUQUVBFURUSOUTPOUTPVEUVKUUTUVLBUUPVAZUUTVBVCVDOVFVG
      UURLZUUSMUVGABVHUVQUVGUVMMUVQUVFMUVQAUUQVIZKZUVFMIZUVQUVSUVTUVQUVSQZUUTUV
      ENUVTUWACUUTUVEUWAADVJZUUQRZDCVKZLZQZDSZCVJZUUTKZUWHUVEKZVQZUVQEVJZUWBUUQ
      RZUWEQZDSZESZUVSUWGUVQUWOCTZESZUWPUWRUURUURUWMUWDVQZDTZCSZETZUWQLZETUWRLU
      URUVOUXBBUUPVLZEDCUUQVMVNUXAUXCEUXAUWOLZCSUXCUWTUXECUWTUWNLZDTUXEUWSUXFDU
      WMUWDVRVOUWNDVPVSVTUWOCWAVSVOUWQEVPWBWCUWQUWOEUWOCWIWDUJUVSUWOUWGEUVSUWNU
      WFDUVSUWMUWCUWEUVSUWMUWCUVSUWMUWMUWCVQUVSUWMQZUWMUWCUXGUWLAUWBUUQUVSUVRUU
      PIZUWLUVRKZUWLAIZUWMUVSUUPUVRNZUXHAUVRWEUXKUVRUUQUUPUBZVIZUUPUXLUUQBUUPWF
      WGUXKUXMUUPIUUPUUQWJWHVGWKUWLUWBUUQEWLDWLZWMUXHUXIUXJUXHUXIUWLUUPKUXJUVRU
      UPUWLXAEAWNWOWPWQWRWSXBWTXCXDXEXFUWFUWKDUWIAUWHUUQRZUWFUWJUWIUWHUVKKUXOUV
      KUUTUWHUVPXGUUQAUWHXHXIUWFUXOUWJUWFUXOQZUWJUWBUVEKZUXPUWHUWBXJZUVENUWJUXQ
      QUXPUXRUWHUWBXKZHUVEUWHUWBCWLZUXNXLUXPUXSUVDUXPUXSUXSUAZHZUVDUXSUWHUWBXMX
      NUXPUXSUVCKZUYAUVCNUYBUVDNUXPUWHUWLUVARZUWMQZEJXOZUWEQZUYCUWCUXOUWEUYGUWC
      UXOQUYFUWEUWCUXOUWHAUVARZUYFUWCUYHUXOUWCUWHJKUVIUYHUXOYOUXTAUWBUUQUXDXPZU
      WHAJJUUQXQXRXSUYHUWCUYFUVIUYHUWCQZUYFUWCUVIUYHUYIXTUYEUYJEAJUXJUYDUYHUWMU
      WCUWLAUWHUVAYAUWLAUWBUUQYBYDYCYEYFYGYHYIUYCUXSUVBKZUXSFKZLZQUYGUXSUVBFYJU
      YKUYFUYMUWEUYFUYEESUWHUWBUVBRUYKUYEEYKEUWHUWBUUQUVAUXTUXNYLUWHUWBUVBYMYNU
      YLUWDUWHUWBFRCDVKUYLUWDUWHUWBUXNYPUWHUWBFYMCDYQYRYSUUAUUBUSUXSUVCWEUYAUVC
      UUFUUCYTUUDYTUWHUWBUVEUXTUXNUUGUUEUUHXBUUIUUJWKUUKUUTUVEURUSXBUVSLZUVFMUV
      EGMUYNUUTMUVEUYNUUTUVKMUVPAUUQUULVGUUMUVEUUNPUUOOUTPULUN $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y G $.  $d x X $.
    $( Domains of a function composition.  (Contributed by NM, 27-Jan-1997.) $)
    dmfco $p |- ( ( Fun G /\ A e. dom G ) ->
               ( A e. dom ( F o. G ) <-> ( G ` A ) e. dom F ) ) $=
      ( vx vy wfun cdm wcel wa ccom cv cop wex cfv wb eldm2g exbidv wceq syl5bb
      cvv vex opelco2g mpan2 bitrd adantl fvex eldm2 opeq1 eleq1d ceqsexv eqcom
      funopfvb anbi1d syl5bbr bitr4d ) CFZACGZHZIZABCJZGHZADKZLCHZVBEKZLZBHZIZD
      MZEMZACNZBGHZURVAVIOUPURVAAVDLUTHZEMVIEAUTUQPURVLVHEURVDTHVLVHOEUADAVDBCU
      QTUBUCQUDUEVKVJVDLZBHZEMUSVIEVJBACUFZUGUSVNVHEVNVBVJRZVFIZDMUSVHVFVNDVJVO
      VPVEVMBVBVJVDUHUIUJUSVQVGDUSVPVCVFVPVJVBRUSVCVBVJUKAVBCULSUMQUNQSUO $.

    $( Value of a function composition.  Similar to second part of Theorem 3H
       of [Enderton] p. 47.  (Contributed by NM, 9-Oct-2004.)  (Proof shortened
       by Andrew Salmon, 22-Oct-2011.)  (Revised by Stefan O'Rear,
       16-Oct-2014.) $)
    fvco2 $p |- ( ( G Fn A /\ X e. A ) -> ( ( F o. G ) ` X ) =
          ( F ` ( G ` X ) ) ) $=
      ( vx wfn wcel wa cv ccom csn cio cfv fnsnfv imaeq2d imaco syl6reqr eleq2d
      cima dffv3 iotabidv 3eqtr4g ) CAFDAGHZEIZBCJZDKZSZGZELUDBDCMZKZSZGZELDUEM
      UIBMUCUHULEUCUGUKUDUCUKBCUFSZSUGUCUJUMBADCNOBCUFPQRUAEDUETEUIBTUB $.
  $}

  $( Value of a function composition.  Similar to Exercise 5 of [TakeutiZaring]
     p. 28.  (Contributed by NM, 22-Apr-2006.)  (Proof shortened by Mario
     Carneiro, 26-Dec-2014.) $)
  fvco $p |- ( ( Fun G /\ A e. dom G ) ->
               ( ( F o. G ) ` A ) = ( F ` ( G ` A ) ) ) $=
    ( wfun cdm wfn wcel ccom cfv wceq funfn fvco2 sylanb ) CDCCEZFANGABCHIACIBI
    JCKNBCALM $.

  $( Value of a function composition.  (Contributed by NM, 3-Jan-2004.)
     (Revised by Mario Carneiro, 26-Dec-2014.) $)
  fvco3 $p |- ( ( G : A --> B /\ C e. A ) ->
             ( ( F o. G ) ` C ) = ( F ` ( G ` C ) ) ) $=
    ( wf wfn wcel ccom cfv wceq ffn fvco2 sylan ) ABEFEAGCAHCDEIJCEJDJKABELADEC
    MN $.

  ${
    fvco4i.a $e |- (/) = ( F ` (/) ) $.
    fvco4i.b $e |- Fun G $.
    $( Conditions for a composition to be expandable without conditions on the
       argument.  (Contributed by Stefan O'Rear, 31-Mar-2015.) $)
    fvco4i $p |- ( ( F o. G ) ` X ) = ( F ` ( G ` X ) ) $=
      ( cdm wcel ccom cfv wceq wfn wfun funfn mpbi fvco2 mpan wn dmcoss ndmfv
      c0 sseli con3i syl fveq2d 3eqtr4a pm2.61i ) CBFZGZCABHZIZCBIZAIZJZBUGKZUH
      UMBLUNEBMNUGABCOPUHQZTTAIUJULDUOCUIFZGZQUJTJUQUHUPUGCABRUAUBCUISUCUOUKTAC
      BSUDUEUF $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y ch $.
    fvopab3g.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    fvopab3g.3 $e |- ( y = B -> ( ps <-> ch ) ) $.
    fvopab3g.4 $e |- ( x e. C -> E! y ph ) $.
    fvopab3g.5 $e |- F = { <. x , y >. | ( x e. C /\ ph ) } $.
    $( Value of a function given by ordered-pair class abstraction.
       (Contributed by NM, 6-Mar-1996.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    fvopab3g $p |- ( ( A e. C /\ B e. D ) -> ( ( F ` A ) = B <-> ch ) ) $=
      ( wcel wa cv wceq wb adantr cop copab cfv anbi12d anbi2d opelopabg fnopab
      eleq1 wfn fnopfvb mpan eleq2i syl6bb ibar 3bitr4d ) FHOZGIOZPFGUAZDQZHOZA
      PZDEUBZOZUPCPZFJUCGRZCVAUPBPVDDEFGHIUSFRUTUPABUSFHUHKUDEQGRBCUPLUEUFUPVEV
      CSUQUPVEURJOZVCJHUIUPVEVFSADEHJMNUGHFGJUJUKJVBURNULUMTUPCVDSUQUPCUNTUO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y ch $.
    fvopab3ig.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    fvopab3ig.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    fvopab3ig.3 $e |- ( x e. C -> E* y ph ) $.
    fvopab3ig.4 $e |- F = { <. x , y >. | ( x e. C /\ ph ) } $.
    $( Value of a function given by ordered-pair class abstraction.
       (Contributed by NM, 23-Oct-1999.) $)
    fvopab3ig $p |- ( ( A e. C /\ B e. D ) -> ( ch -> ( F ` A ) = B ) ) $=
      ( wcel wa cv cfv wceq wi cop copab eleq1 anbi12d anbi2d opelopabg biimpar
      exp43 pm2.43a imp fveq1i wfun funopab moanimv mpbir mpgbir funopfv syl5eq
      wmo ax-mp syl6 ) FHOZGIOZPZCFGUADQZHOZAPZDEUBZOZFJRZGSVBVCCVITZVCVBVKVBVC
      VBCVIVDVIVBCPZVGVBBPVLDEFGHIVEFSVFVBABVEFHUCKUDEQGSBCVBLUEUFUGUHUIUJVIVJF
      VHRZGFJVHNUKVHULZVIVMGSTVNVGEUSZDVGDEUMVOVFAEUSTMVFAEUNUOUPFGVHUQUTURVA
      $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C y $.  $d x D y $.
    fvmptg.1 $e |- ( x = A -> B = C ) $.
    fvmptg.2 $e |- F = ( x e. D |-> B ) $.
    $( Value of a function given in maps-to notation.  (Contributed by NM,
       2-Oct-2007.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    fvmptg $p |- ( ( A e. D /\ C e. R ) -> ( F ` A ) = C ) $=
      ( vy wcel wa wceq cfv eqid cv eqeq2d eqeq1 wmo moeq a1i cmpt copab df-mpt
      eqtri fvopab3ig mpi ) BEKDFKLDDMZBGNDMDOJPZCMZUIDMUHAJBDEFGAPZBMCDUIHQUID
      DRUJJSUKEKZJCTUAGAECUBULUJLAJUCIAJECUDUEUFUG $.

    $( Value of a function given in maps-to notation.  (Contributed by Mario
       Carneiro, 23-Apr-2014.) $)
    fvmpti $p |- ( A e. D -> ( F ` A ) = ( _I ` C ) ) $=
      ( wcel cvv cfv cid wceq wa fvmptg fvi adantl eqtr4d wn c0 cv eleq1d dmmpt
      cdm elrab2 baib notbid ndmfv syl6bir imp fvprc pm2.61dan ) BEIZDJIZBFKZDL
      KZMUMUNNUODUPABCDEJFGHOUNUPDMUMDJPQRUMUNSZNUOTUPUMUQUOTMZUMUQBFUDZIZSURUM
      UTUNUTUMUNCJIUNABEUSAUABMCDJGUBAECFHUCUEUFUGBFUHUIUJUQUPTMUMDLUKQRUL $.

    ${
      fvmpt.3 $e |- C e. _V $.
      $( Value of a function given in maps-to notation.  (Contributed by NM,
         17-Aug-2011.) $)
      fvmpt $p |- ( A e. D -> ( F ` A ) = C ) $=
        ( wcel cvv cfv wceq fvmptg mpan2 ) BEJDKJBFLDMIABCDEKFGHNO $.
    $}
  $}

  ${
    $d y A $.  $d y z B $.  $d x y z C $.
    fvmpts.1 $e |- F = ( x e. C |-> B ) $.
    $( Value of a function given in maps-to notation, using explicit class
       substitution.  (Contributed by Scott Fenton, 17-Jul-2013.)  (Revised by
       Mario Carneiro, 31-Aug-2015.) $)
    fvmpts $p |- ( ( A e. C /\ [_ A / x ]_ B e. V ) ->
        ( F ` A ) = [_ A / x ]_ B ) $=
      ( vy cv csb csbeq1 cmpt nfcv nfcsb1v csbeq1a cbvmpt eqtri fvmptg ) HBAHIZ
      CJZABCJDFEASBCKEADCLHDTLGAHDCTHCMASCNASCOPQR $.
  $}

  ${
    $d x A $.  $d x C $.  $d x D $.  $d x V $.
    fvmpt3.a $e |- ( x = A -> B = C ) $.
    fvmpt3.b $e |- F = ( x e. D |-> B ) $.
    ${
      fvmpt3.c $e |- ( x e. D -> B e. V ) $.
      $( Value of a function given in maps-to notation, with a slightly
         different sethood condition.  (Contributed by Stefan O'Rear,
         30-Jan-2015.) $)
      fvmpt3 $p |- ( A e. D -> ( F ` A ) = C ) $=
        ( wcel cfv wceq cv eleq1d vtoclga fvmptg mpdan ) BEKDGKZBFLDMCGKSABEANB
        MCDGHOJPABCDEGFHIQR $.
    $}

    fvmpt3i.c $e |- B e. _V $.
    $( Value of a function given in maps-to notation, with a slightly different
       sethood condition.  (Contributed by Mario Carneiro, 11-Sep-2015.) $)
    fvmpt3i $p |- ( A e. D -> ( F ` A ) = C ) $=
      ( cvv wcel cv a1i fvmpt3 ) ABCDEFJGHCJKALEKIMN $.
  $}

  ${
    $d x A $.  $d x C $.  $d x D $.  $d x ph $.
    fvmptd.1 $e |- ( ph -> F = ( x e. D |-> B ) ) $.
    fvmptd.2 $e |- ( ( ph /\ x = A ) -> B = C ) $.
    fvmptd.3 $e |- ( ph -> A e. D ) $.
    fvmptd.4 $e |- ( ph -> C e. V ) $.
    $( Deduction version of ~ fvmpt .  (Contributed by Scott Fenton,
       18-Feb-2013.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    fvmptd $p |- ( ph -> ( F ` A ) = C ) $=
      ( cfv cmpt csb fveq1d wcel wceq csbied eqeltrd eqid fvmpts syl2anc 3eqtrd
      ) ACGMCBFDNZMZBCDOZEACGUEIPACFQUGHQUFUGRKAUGEHABCDEFKJSZLTBCDFUEHUEUAUBUC
      UHUD $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d y D $.  $d y z F $.
    fvmpt2.1 $e |- F = ( x e. A |-> B ) $.
    $( Value of a function given by the "maps to" notation.  (Contributed by
       Mario Carneiro, 23-Apr-2014.) $)
    fvmpt2i $p |- ( x e. A -> ( F ` x ) = ( _I ` B ) ) $=
      ( vy cv csb weq csbeq1 csbid syl6eq cmpt nfcv nfcsb1v cbvmpt eqtri fvmpti
      csbeq1a ) FAGZAFGZCHZCBDFAIUBATCHCAUATCJACKLDABCMFBUBMEAFBCUBFCNAUACOAUAC
      SPQR $.

    $( Value of a function given by the "maps to" notation.  (Contributed by
       FL, 21-Jun-2010.) $)
    fvmpt2 $p |- ( ( x e. A /\ B e. C ) -> ( F ` x ) = B ) $=
      ( cv wcel cfv cid fvmpt2i fvi sylan9eq ) AGZBHCDHNEICJICABCEFKCDLM $.

    $d x y z C $.
    $( If all the values of the mapping are subsets of a class ` C ` , then so
       is any evaluation of the mapping, even if ` D ` is not in the base set
       ` A ` .  (Contributed by Mario Carneiro, 13-Feb-2015.) $)
    fvmptss $p |- ( A. x e. A B C_ C -> ( F ` D ) C_ C ) $=
      ( vy wss wcel cfv cv wi wceq fveq2 sseq1d imbi2d nfcv wa c0 dmmptss sseli
      wral cdm nfra1 cmpt nfmpt1 nfcxfr nffv nfss nfim cvv dmmpt rabeq2i fvmpt2
      eqimss syl sylbi wn ndmfv 0ss syl6eqss pm2.61i rsp impcom syl5ss vtoclgaf
      ex vtoclga sylan2 adantl pm2.61dan ) CDIZABUCZEFUDZJZEFKZDIZVPVNEBJZVRVOB
      EABCFGUAUBVSVNVRVNHLZFKZDIZMZVNVRMHEBVTENZWBVRVNWDWAVQDVTEFOPQVNALZFKZDIZ
      MWCAVTBAVTRZVNWBAVMABUEAWADAVTFAFABCUFGABCUGUHWHUIADRUJUKWEVTNZWGWBVNWIWF
      WADWEVTFOPQWEBJZVNWGWJVNSWFCDWEVOJZWFCIZWKWJCULJZSZWLWMAVOBABCFGUMUNWNWFC
      NWLABCULFGUOWFCUPUQURWKUSWFTCWEFUTCVAVBVCVNWJVMVMABVDVEVFVHVGVIVEVJVNVPUS
      ZSVQTDWOVQTNVNEFUTVKDVAVBVL $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d y D $.  $d y z F $.
    fvmpt2d.1 $e |- ( ph -> F = ( x e. A |-> B ) ) $.
    fvmpt2d.4 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( Deduction version of ~ fvmpt2 .  (Contributed by Thierry Arnoux,
       8-Dec-2016.) $)
    fvmpt2d $p   |- ( ( ph /\ x e. A ) -> ( F ` x ) = B ) $=
      ( cv wcel wa cfv cmpt wceq fveq1d adantr simpr eqid fvmpt2 syl2anc eqtrd
      ) ABIZCJZKZUBELZUBBCDMZLZDAUEUGNUCAUBEUFGOPUDUCDFJUGDNAUCQHBCDFUFUFRSTUA
      $.
  $}

  ${
    $d x z $.  $d x y A $.  $d y z B $.  $d y C $.
    fvmptex.1 $e |- F = ( x e. A |-> B ) $.
    fvmptex.2 $e |- G = ( x e. A |-> ( _I ` B ) ) $.
    $( Express a function ` F ` whose value ` B ` may not always be a set in
       terms of another function ` G ` for which sethood is guaranteed.  (Note
       that ` ( _I `` B ) ` is just shorthand for
       ` if ( B e. _V , B , (/) ) ` , and it is always a set by ~ fvex .)  Note
       also that these functions are not the same; wherever ` B ( C ) ` is not
       a set, ` C ` is not in the domain of ` F ` (so it evaluates to the empty
       set), but ` C ` is in the domain of ` G ` , and ` G ( C ) ` is defined
       to be the empty set.  (Contributed by Mario Carneiro, 14-Jul-2013.)
       (Revised by Mario Carneiro, 23-Apr-2014.) $)
    fvmptex $p |- ( F ` C ) = ( G ` C ) $=
      ( vy wcel cfv wceq csb cid cv cmpt nfcv cbvmpt eqtri c0 nfcsb1v nffv fvex
      csbeq1 csbeq1a fvmpti fveq2d fvmpt eqtr4d wn cdm sseli con3i ndmfv dmmpti
      dmmptss syl eleq2i sylnbir pm2.61i ) DBJZDEKZDFKZLVAVBADCMZNKZVCIDAIOZCMZ
      VDBEAVFDCUDZEABCPIBVGPGAIBCVGICQAVFCUAZAVFCUEZRSUFIDVGNKZVEBFVFDLVGVDNVHU
      GFABCNKZPIBVKPHAIBVLVKIVLQAVGNANQVIUBAOVFLCVGNVJUGRSVDNUCUHUIVAUJZVBTVCVM
      DEUKZJZUJVBTLVOVAVNBDABCEGUPULUMDEUNUQVADFUKZJVCTLVPBDABVLFCNUCHUOURDFUNU
      SUIUT $.
  $}

  ${
    $d x A $.  $d x D $.  $d x ph $.
    fvmptdf.1 $e |- ( ph -> A e. D ) $.
    fvmptdf.2 $e |- ( ( ph /\ x = A ) -> B e. V ) $.
    fvmptdf.3 $e |- ( ( ph /\ x = A ) -> ( ( F ` A ) = B -> ps ) ) $.
    ${
      fvmptdf.4 $e |- F/_ x F $.
      fvmptdf.5 $e |- F/ x ps $.
      $( Alternate deduction version of ~ fvmpt , suitable for iteration.
         (Contributed by Mario Carneiro, 7-Jan-2017.) $)
      fvmptdf $p |- ( ph -> ( F = ( x e. D |-> B ) -> ps ) ) $=
        ( cv wceq cmpt wi nfv wcel cfv nfmpt1 nfeq nfim cvv wex syl isset sylib
        elex fveq1 simpr fveq2d adantr eqeltrd eqid fvmpt2 eqtr3d eqeq2d sylbid
        wa syl2anc syl5 exlimdd ) ACNZDOZGCFEPZOZBQCACRVGBCCGVFLCFEUAUBMUCADUDS
        ZVECUEADFSZVHIDFUIUFCDUGUHVGDGTZDVFTZOZAVEUTZBDGVFUJVMVLVJEOBVMVKEVJVMV
        DVFTZVKEVMVDDVFAVEUKZULVMVDFSEHSVNEOVMVDDFVOAVIVEIUMUNJCFEHVFVFUOUPVAUQ
        URKUSVBVC $.
    $}

    $d x F $.  $d x ps $.
    $( Alternate deduction version of ~ fvmpt , suitable for iteration.
       (Contributed by Mario Carneiro, 7-Jan-2017.) $)
    fvmptdv $p |- ( ph -> ( F = ( x e. D |-> B ) -> ps ) ) $=
      ( nfcv nfv fvmptdf ) ABCDEFGHIJKCGLBCMN $.
  $}

  ${
    $d x A $.  $d x C $.  $d x D $.  $d x ph $.
    fvmptdv2.1 $e |- ( ph -> A e. D ) $.
    fvmptdv2.2 $e |- ( ( ph /\ x = A ) -> B e. V ) $.
    fvmptdv2.3 $e |- ( ( ph /\ x = A ) -> B = C ) $.
    $( Alternate deduction version of ~ fvmpt , suitable for iteration.
       (Contributed by Mario Carneiro, 7-Jan-2017.) $)
    fvmptdv2 $p |- ( ph -> ( F = ( x e. D |-> B ) -> ( F ` A ) = C ) ) $=
      ( cfv wceq cmpt cvv eqidd cv wcel elex syl wex isset wa eqeltrrd exlimddv
      sylib fvmptd fveq1 eqeq1d syl5ibrcom ) ACGLZEMGBFDNZMZCULLZEMABCDEFULOAUL
      PKIABQCMZEORBACORZUOBUAACFRUPICFSTBCUBUFAUOUCZDEOKUQDHRDORJDHSTUDUEUGUMUK
      UNECGULUHUIUJ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y C $.
    $( Bidirectional equality theorem for a mapping abstraction.  Equivalent to
       ~ eqfnfv .  (Contributed by Mario Carneiro, 14-Nov-2014.) $)
    mpteqb $p |- ( A. x e. A B e. V ->
      ( ( x e. A |-> B ) = ( x e. A |-> C ) <->
        A. x e. A B = C ) ) $=
      ( wcel wral cvv cmpt wceq wb wfn eqid mptfng wa wi nfmpt1 cfv fvmpt2 syl
      elex ralimi fneq1 3bitr4g biimpd r19.26 nfeq cv simpll ad2ant2lr ad2ant2l
      3eqtr3d exp31 ralrimi ralim syl5bir exp3a mpdd com12 mpteq12 mpan impbid1
      fveq1d ) CEFZABGCHFZABGZABCIZABDIZJZCDJZABGZKVDVEABCEUAUBVFVIVKVIVFVKVIVF
      DHFZABGZVKVIVFVMVIVGBLVHBLVFVMBVGVHUCABCVGVGMZNABDVHVHMZNUDUEVIVFVMVKVFVM
      OVEVLOZABGZVIVKVEVLABUFVIVPVJPZABGVQVKPVIVRABAVGVHABCQABDQUGVIAUHZBFZVPVJ
      VIVTOVPOZVSVGRZVSVHRZCDWAVSVGVHVIVTVPUIVCVTVEWBCJVIVLABCHVGVNSUJVTVLWCDJV
      IVEABDHVHVOSUKULUMUNVPVJABUOTUPUQURUSBBJVKVIBMABCBDUTVAVBT $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.
    $( Closed theorem form of ~ fvmpt .  (Contributed by Scott Fenton,
       21-Feb-2013.)  (Revised by Mario Carneiro, 11-Sep-2015.) $)
    fvmptt $p |- ( ( A. x ( x = A -> B = C ) /\
      F = ( x e. D |-> B ) /\ ( A e. D /\ C e. V ) ) -> ( F ` A ) = C ) $=
      ( cv wceq wi wal cmpt wcel wa w3a cfv simp2 fveq1d wrex cvv elex nfa1 nfv
      risset nfeq1 nfim simprl simplr simprr eqeltrd eqid fvmpt2 syl2anc simpll
      nffvmpt1 fveq2d 3eqtr3d exp43 a2i com23 rexlimd syl7 syl5bi imp32 3adant2
      sps eqtrd ) AHZBIZCDIZJZAKZFAECLZIZBEMZDGMZNZOZBFPBVMPZDVRBFVMVLVNVQQRVLV
      QVSDIZVNVLVOVPVTVOVIAESZVLVPVTJABEUDVPDTMZVLWAVTDGUAVLVIWBVTJZAEVKAUBWBVT
      AWBAUCAVSDAECBUOUEUFVKVHEMZVIWCJJAVKVIWDWCVIVJWDWCJVIVJWDWBVTVIVJNZWDWBNZ
      NZVHVMPZCVSDWGWDCTMWHCIWEWDWBUGWGCDTVIVJWFUHZWEWDWBUIUJAECTVMVMUKULUMWGVH
      BVMVIVJWFUNUPWIUQURUSUTVFVAVBVCVDVEVG $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d x y D $.  $d y F $.
    fvmptf.1 $e |- F/_ x A $.
    fvmptf.2 $e |- F/_ x C $.
    fvmptf.3 $e |- ( x = A -> B = C ) $.
    fvmptf.4 $e |- F = ( x e. D |-> B ) $.
    $( Value of a function given by an ordered-pair class abstraction.  This
       version of ~ fvmptg uses bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by NM, 8-Nov-2005.)  (Revised by
       Mario Carneiro, 15-Oct-2016.) $)
    fvmptf $p |- ( ( A e. D /\ C e. V ) -> ( F ` A ) = C ) $=
      ( wcel cfv wceq cvv elex cv wi nfel1 cmpt nfmpt1 nfcxfr nffv eleq1d fveq2
      nfeq nfim eqeq12d imbi12d fvmpt2 ex vtoclgaf syl5 imp ) BELZDGLZBFMZDNZUP
      DOLZUOURDGPCOLZAQZFMZCNZRUSURRABEHUSURAADOISAUQDABFAFAECTKAECUAUBHUCIUFUG
      VABNZUTUSVCURVDCDOJUDVDVBUQCDVABFUEJUHUIVAELUTVCAECOFKUJUKULUMUN $.

    $( The value of a function given by an ordered-pair class abstraction is
       the empty set when the class it would otherwise map to is a proper
       class.  This version of ~ fvmptn uses bound-variable hypotheses instead
       of distinct variable conditions.  (Contributed by NM, 21-Oct-2003.)
       (Revised by Mario Carneiro, 11-Sep-2015.) $)
    fvmptnf $p |- ( -. C e. _V -> ( F ` A ) = (/) ) $=
      ( cvv wcel wn cdm cfv c0 wceq dmmptss sseli cid cmpt eqid fvmptex fvex cv
      nfcv nffv fveq2d fvmptf mpan2 syl5eq fvprc sylan9eq expcom ndmfv pm2.61d1
      syl5 ) DKLMZBFNZLZBFOZPQZUTBELZURVBUSEBAECFJRSVCURVBVCURVADTOZPVCVABAECTO
      ZUAZOZVDAECBFVFJVFUBZUCVCVDKLVGVDQDTUDABVEVDEVFKGADTATUFHUGAUEBQCDTIUHVHU
      IUJUKDTULUMUNUQBFUOUP $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d y F $.
    fvmptn.1 $e |- ( x = D -> B = C ) $.
    fvmptn.2 $e |- F = ( x e. A |-> B ) $.
    $( This somewhat non-intuitive theorem tells us the value of its function
       is the empty set when the class ` C ` it would otherwise map to is a
       proper class.  This is a technical lemma that can help eliminate
       redundant sethood antecedents otherwise required by ~ fvmptg .
       (Contributed by NM, 21-Oct-2003.)  (Revised by Mario Carneiro,
       9-Sep-2013.) $)
    fvmptn $p |- ( -. C e. _V -> ( F ` D ) = (/) ) $=
      ( nfcv fvmptnf ) AECDBFAEIADIGHJ $.

    $( A mapping always evaluates to a subset of the substituted expression in
       the mapping, even if this is a proper class, or we are out of the
       domain.  (Contributed by Mario Carneiro, 13-Feb-2015.) $)
    fvmptss2 $p |- ( F ` D ) C_ C $=
      ( cdm wcel cfv wss cvv wa cv wceq eleq1d dmmpt elrab2 fvmptg eqimss sylbi
      syl wn c0 ndmfv 0ss syl6eqss pm2.61i ) EFIZJZEFKZDLZUKEBJDMJZNZUMCMJUNAEB
      UJAOEPCDMGQABCFHRSUOULDPUMAECDBMFGHTULDUAUCUBUKUDULUEDEFUFDUGUHUI $.
  $}

  ${
    $d x y A $.
    fvopab4ndm.1 $e |- F = { <. x , y >. | ( x e. A /\ ph ) } $.
    $( Value of a function given by an ordered-pair class abstraction, outside
       of its domain.  (Contributed by NM, 28-Mar-2008.) $)
    fvopab4ndm $p |- ( -. B e. A -> ( F ` B ) = (/) ) $=
      ( wcel wn cdm cfv c0 wceq cv wa copab dmeqi dmopabss eqsstri sseli con3i
      ndmfv syl ) EDHZIEFJZHZIEFKLMUFUDUEDEUEBNDHAOBCPZJDFUGGQABCDRSTUAEFUBUC
      $.
  $}

  ${
    $d A x y $.  $d ps x y $.  $d B y $.  $d C x y $.
    fvopab6.1 $e |- F = { <. x , y >. | ( ph /\ y = B ) } $.
    fvopab6.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    fvopab6.3 $e |- ( x = A -> B = C ) $.
    $( Value of a function given by ordered-pair class abstraction.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       11-Sep-2015.) $)
    fvopab6 $p |- ( ( A e. D /\ C e. R /\ ps ) -> ( F ` A ) = C ) $=
      ( wcel cfv wceq cvv cv wa copab elex eqeq2d anbi12d iba bicomd moeq moani
      wi wmo a1i vex biantrur opabbii eqtri fvopab3ig sylan 3impia ) EHNZGINZBE
      JOGPZUREQNUSBUTUHEHUAADRZFPZSZBVAGPZSZBCDEGQIJCRZEPZABVBVDLVGFGVAMUBUCVDB
      VEVDBUDUEVCDUIVFQNZVBADDFUFUGUJJVCCDTVHVCSZCDTKVCVICDVHVCCUKULUMUNUOUPUQ
      $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y F $.  $d x y G $.  $d x ph $.
    $( Equality of functions is determined by their values.  Special case of
       Exercise 4 of [TakeutiZaring] p. 28 (with domain equality omitted).
       (Contributed by NM, 3-Aug-1994.)  (Proof shortened by Andrew Salmon,
       22-Oct-2011.)  (Proof shortened by Mario Carneiro, 31-Aug-2015.) $)
    eqfnfv $p |- ( ( F Fn A /\ G Fn A ) -> ( F = G <->
                 A. x e. A ( F ` x ) = ( G ` x ) ) ) $=
      ( wfn wa wceq cv cfv cmpt wral dffn5 eqeq12 syl2anb cvv wcel rgenw mpteqb
      wb fvex ax-mp syl6bb ) CBEZDBEZFCDGZABAHZCIZJZABUFDIZJZGZUGUIGABKZUCCUHGD
      UJGUEUKSUDABCLABDLCUHDUJMNUGOPZABKUKULSUMABUFCTQABUGUIORUAUB $.

    $( Equality of functions is determined by their values.  Exercise 4 of
       [TakeutiZaring] p. 28.  (Contributed by NM, 3-Aug-1994.)  (Revised by
       Mario Carneiro, 31-Aug-2015.) $)
    eqfnfv2 $p |- ( ( F Fn A /\ G Fn B ) -> ( F = G <->
                 ( A = B /\ A. x e. A ( F ` x ) = ( G ` x ) ) ) ) $=
      ( wfn wa wceq cv cfv wral dmeq fndm eqeqan12d syl5ib pm4.71rd wb biimparc
      cdm fneq2 eqfnfv sylan2 anassrs pm5.32da bitrd ) DBFZECFZGZDEHZBCHZUIGUJA
      IZDJUKEJHABKZGUHUIUJUIDSZESZHUHUJDELUFUGUMBUNCBDMCEMNOPUHUJUIULUFUGUJUIUL
      QZUGUJGUFEBFZUOUJUPUGBCETRABDEUAUBUCUDUE $.

    $d x B $.
    $( Derive equality of functions from equality of their values.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    eqfnfv3 $p |- ( ( F Fn A /\ G Fn B ) -> ( F = G <-> ( B C_ A /\ A. x e. A
                                  ( x e. B /\ ( F ` x ) = ( G ` x ) ) ) ) ) $=
      ( wfn wa wceq cv cfv wral wss wcel eqfnfv2 ancom bitri anbi1i anass dfss3
      eqss r19.26 bitr4i anbi2i syl6bb ) DBFECFGDEHBCHZAIZDJUFEJHZABKZGZCBLZUFC
      MZUGGABKZGZABCDENUIUJBCLZGZUHGZUMUEUOUHUEUNUJGUOBCTUNUJOPQUPUJUNUHGZGUMUJ
      UNUHRUQULUJUQUKABKZUHGULUNURUHABCSQUKUGABUAUBUCPPUD $.

    eqfnfvd.1 $e |- ( ph -> F Fn A ) $.
    eqfnfvd.2 $e |- ( ph -> G Fn A ) $.
    eqfnfvd.3 $e |- ( ( ph /\ x e. A ) -> ( F ` x ) = ( G ` x ) ) $.
    $( Deduction for equality of functions.  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    eqfnfvd $p |- ( ph -> F = G ) $=
      ( wceq cv cfv wral ralrimiva wfn wb eqfnfv syl2anc mpbird ) ADEIZBJZDKTEK
      IZBCLZAUABCHMADCNECNSUBOFGBCDEPQR $.
  $}

  ${
    $d x z A $.  $d y z F $.  $d y z G $.  $d x y $.
    eqfnfv2f.1 $e |- F/_ x F $.
    eqfnfv2f.2 $e |- F/_ x G $.
    $( Equality of functions is determined by their values.  Special case of
       Exercise 4 of [TakeutiZaring] p. 28 (with domain equality omitted).
       This version of ~ eqfnfv uses bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by NM, 29-Jan-2004.) $)
    eqfnfv2f $p |- ( ( F Fn A /\ G Fn A ) -> ( F = G <->
                 A. x e. A ( F ` x ) = ( G ` x ) ) ) $=
      ( vz wfn wa wceq cv cfv wral eqfnfv nfcv nffv nfeq nfv fveq2 eqeq12d
      cbvral syl6bb ) CBHDBHICDJGKZCLZUCDLZJZGBMAKZCLZUGDLZJZABMGBCDNUFUJGABAUD
      UEAUCCEAUCOZPAUCDFUKPQUJGRUCUGJUDUHUEUIUCUGCSUCUGDSTUAUB $.
  $}

  ${
    $d F x $.  $d G x $.
    $( Equality of functions is determined by their values.  (Contributed by
       Scott Fenton, 19-Jun-2011.) $)
    eqfunfv $p |- ( ( Fun F /\ Fun G ) -> ( F = G <->
                    ( dom F = dom G /\
                      A. x e. dom F ( F ` x ) = ( G ` x ) ) ) ) $=
      ( wfun cdm wfn wceq cv cfv wral wa wb funfn eqfnfv2 syl2anb ) BDBBEZFCCEZ
      FBCGPQGAHZBIRCIGAPJKLCDBMCMAPQBCNO $.
  $}

  ${
    $d x B $.  $d x F $.  $d x G $.
    $( Equality of restricted functions is determined by their values.
       (Contributed by NM, 3-Aug-1994.) $)
    fvreseq $p |- ( ( ( F Fn A /\ G Fn A ) /\ B C_ A ) ->
         ( ( F |` B ) = ( G |` B ) <-> A. x e. B ( F ` x ) = ( G ` x ) ) ) $=
      ( wfn wa wss cres wceq cv cfv wral wb fnssres anim12i anandirs wcel fvres
      eqfnfv eqeq12d ralbiia syl6bb syl ) DBFZEBFZGCBHZGDCIZCFZECIZCFZGZUHUJJZA
      KZDLZUNELZJZACMZNUEUFUGULUEUGGUIUFUGGUKBCDOBCEOPQULUMUNUHLZUNUJLZJZACMURA
      CUHUJTVAUQACUNCRUSUOUTUPUNCDSUNCESUAUBUCUD $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d A x y $.
    $( Two ways to express the locus of differences between two functions.
       (Contributed by Stefan O'Rear, 17-Jan-2015.) $)
    fndmdif $p |- ( ( F Fn A /\ G Fn A ) -> dom ( F \ G ) =
          { x e. A | ( F ` x ) =/= ( G ` x ) } ) $=
      ( vy wfn wa cdm cv cfv wss wceq wcel wbr wex wn wb eqcom fnbrfvb syl5bb
      cdif cin wne crab difss dmss ax-mp fndm adantr syl5sseq dfss1 vex adantll
      sylib necon3abid breq2 notbid ceqsexv syl6bbr adantlr anbi1d brdif exbidv
      eldm fvex bitr2d rabbi2dva eqtr3d ) CBFZDBFZGZBCDUAZHZUBZVMAIZCJZVODJZUCZ
      ABUDVKVMBKVNVMLVKCHZVMBVLCKVMVSKCDUEVLCUFUGVIVSBLVJBCUHUIUJVMBUKUNVKVRABV
      MVOVMMVOEIZVLNZEOZVKVOBMZGZVREVOVLAULVDWDVRVTVPLZVOVTDNZPZGZEOZWBWDVRVOVP
      DNZPZWIWDWJVPVQVJWCVPVQLZWJQVIWLVQVPLVJWCGWJVPVQRBVOVPDSTUMUOWGWKEVPVOCVE
      WEWFWJVTVPVODUPUQURUSWDWHWAEWDWHVOVTCNZWGGWAWDWEWMWGVIWCWEWMQVJWEVPVTLVIW
      CGWMVTVPRBVOVTCSTUTVAVOVTCDVBUSVCVFTVGVH $.

    $( The difference set between two functions is commutative.  (Contributed
       by Stefan O'Rear, 17-Jan-2015.) $)
    fndmdifcom $p |- ( ( F Fn A /\ G Fn A ) ->
        dom ( F \ G ) = dom ( G \ F ) ) $=
      ( vx wfn wa cv cfv wne crab cdif cdm wb wcel necom rabbiia fndmdif ancoms
      a1i wceq 3eqtr4a ) BAEZCAEZFDGZBHZUDCHZIZDAJUFUEIZDAJZBCKLCBKLZUGUHDAUGUH
      MUDANUEUFOSPDABCQUCUBUJUITDACBQRUA $.

    $( The difference set of two functions is empty if and only if the
       functions are equal.  (Contributed by Stefan O'Rear, 17-Jan-2015.) $)
    fndmdifeq0 $p |- ( ( F Fn A /\ G Fn A ) ->
        ( dom ( F \ G ) = (/) <-> F = G ) ) $=
      ( vx wfn wa cdif cdm c0 wceq cv cfv wne crab fndmdif eqeq1d eqfnfv rabeq0
      wral wn nne ralbii bitri syl6rbbr bitrd ) BAECAEFZBCGHZIJDKZBLZUHCLZMZDAN
      ZIJZBCJZUFUGULIDABCOPUFUNUIUJJZDASZUMDABCQUMUKTZDASUPUKDARUQUODAUIUJUAUBU
      CUDUE $.

    $( Two ways to express the locus of equality between two functions.
       (Contributed by Stefan O'Rear, 17-Jan-2015.) $)
    fndmin $p |- ( ( F Fn A /\ G Fn A ) -> dom ( F i^i G ) =
          { x e. A | ( F ` x ) = ( G ` x ) } ) $=
      ( vy wfn wa cin cdm cv cfv wceq copab cmpt dffn5 biimpi df-mpt syl6eq wex
      cab wcel ineqan12d inopab dmeqd 19.42v anandi exbii eqeq1 ceqsexv 3bitr3i
      crab fvex anbi2i abbii dmopab df-rab 3eqtr4i ) CBFZDBFZGZCDHZIAJZBUAZEJZV
      BCKZLZGZVCVDVBDKZLZGZGZAEMZIZVEVHLZABUKZUTVAVLUTVAVGAEMZVJAEMZHVLURUSCVPD
      VQURCABVENZVPURCVRLABCOPAEBVEQRUSDABVHNZVQUSDVSLABDOPAEBVHQRUBVGVJAEUCRUD
      VKESZATVCVNGZATVMVOVTWAAVCVFVIGZGZESVCWBESZGVTWAVCWBEUEWCVKEVCVFVIUFUGWDV
      NVCVIVNEVEVBCULVDVEVHUHUIUMUJUNVKAEUOVNABUPUQR $.
  $}

  ${
    $d F x $.  $d G x $.  $d A x $.
    $( Two functions are equal iff their equalizer is the whole domain.
       (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    fneqeql $p |- ( ( F Fn A /\ G Fn A ) ->
        ( F = G <-> dom ( F i^i G ) = A ) ) $=
      ( vx wfn wa wceq cfv crab cin cdm wral eqfnfv eqcom rabid2 syl6bbr fndmin
      cv bitri eqeq1d bitr4d ) BAECAEFZBCGZDRZBHUDCHGZDAIZAGZBCJKZAGUBUCUEDALZU
      GDABCMUGAUFGUIUFANUEDAOSPUBUHUFADABCQTUA $.

    $( Two functions are equal iff their equalizer contains the whole domain.
       (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    fneqeql2 $p |- ( ( F Fn A /\ G Fn A ) ->
        ( F = G <-> A C_ dom ( F i^i G ) ) ) $=
      ( wfn wceq cin cdm wss fneqeql inss1 dmss ax-mp adantr syl5sseq biantrurd
      wa fndm eqss syl6rbbr bitrd ) BADZCADZPZBCEBCFZGZAEZAUEHZABCIUCUGUEAHZUGP
      UFUCUHUGUCBGZUEAUDBHUEUIHBCJUDBKLUAUIAEUBABQMNOUEARST $.

    $( Two functions are equal on a subset iff their equalizer contains that
       subset.  (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    fnreseql $p |- ( ( F Fn A /\ G Fn A /\ X C_ A ) ->
        ( ( F |` X ) = ( G |` X ) <-> X C_ dom ( F i^i G ) ) ) $=
      ( wfn wss w3a cin cdm wb fnssres 3adant2 3adant1 fneqeql syl2anc resindir
      cres wceq dmeqi dmres eqtr3i eqeq1i df-ss bitr4i syl6bb ) BAEZCAEZDAFZGZB
      DQZCDQZRZUJUKHZIZDRZDBCHZIZFZUIUJDEZUKDEZULUOJUFUHUSUGADBKLUGUHUTUFADCKMD
      UJUKNOUODUQHZDRURUNVADUPDQZIUNVAVBUMBCDPSUPDTUAUBDUQUCUDUE $.
  $}

  ${
    $d x y A $.  $d x y F $.
    $( The range of a choice function (a function that chooses an element from
       each member of its domain) is included in the union of its domain.
       (Contributed by NM, 31-Aug-1999.) $)
    chfnrn $p |- ( ( F Fn A /\ A. x e. A ( F ` x ) e. x ) -> ran F C_ U. A ) $=
      ( vy wfn cv cfv wcel wral wa crn cuni wrex wceq fvelrnb biimpd wi biimpcd
      eleq1 ralimi rexim syl sylan9 eluni2 syl6ibr ssrdv ) CBEZAFZCGZUHHZABIZJZ
      DCKZBLZULDFZUMHZUOUHHZABMZUOUNHUGUPUIUONZABMZUKURUGUPUTABUOCOPUKUSUQQZABI
      UTURQUJVAABUSUJUQUIUOUHSRTUSUQABUAUBUCAUOBUDUEUF $.
  $}

  ${
    $d x F $.  $d x A $.
    $( Ordered pair with function value.  Part of Theorem 4.3(i) of [Monk1]
       p. 41.  (Contributed by NM, 14-Oct-1996.) $)
    funfvop $p |- ( ( Fun F /\ A e. dom F ) -> <. A , ( F ` A ) >. e. F ) $=
      ( wfun cdm wcel wa cfv wceq cop eqid funopfvb mpbii ) BCABDEFABGZMHAMIBEM
      JAMBKL $.
  $}

  $( Two ways to say that ` A ` is in the domain of ` F ` .  (Contributed by
     Mario Carneiro, 1-May-2014.) $)
  funfvbrb $p |- ( Fun F -> ( A e. dom F <-> A F ( F ` A ) ) ) $=
    ( wfun cdm wcel cfv wbr wa funfvop df-br sylibr wrel funrel releldm impbida
    cop sylan ) BCZABDEZAABFZBGZRSHATPBEUAABIATBJKRBLUASBMATBNQO $.

  $( A member of a preimage is a function value argument.  (Contributed by NM,
     4-May-2007.) $)
  fvimacnvi $p |- ( ( Fun F /\ A e. ( `' F " B ) ) -> ( F ` A ) e. B ) $=
    ( wfun ccnv cima wcel cfv csn wss snssi funimass2 sylan2 fvex snss cdm wceq
    wa cnvimass sseli wfn funfn fnsnfv sylanb sseq1d syl5bb mpbird ) CDZACEBFZG
    ZRZACHZBGZCAIZFZBJZUJUHUNUIJUPAUIKUNBCLMUMULIZBJUKUPULBACNOUKUQUOBUJUHACPZG
    ZUQUOQZUIURACBSTUHCURUAUSUTCUBURACUCUDMUEUFUG $.

  $( The argument of a function value belongs to the preimage of any class
     containing the function value.  Raph Levien remarks:  "This proof is
     unsatisfying, because it seems to me that ~ funimass2 could probably be
     strengthened to a biconditional."  (Contributed by Raph Levien,
     20-Nov-2006.) $)
  fvimacnv $p |- ( ( Fun F /\ A e. dom F ) ->
                 ( ( F ` A ) e. B <-> A e. ( `' F " B ) ) ) $=
    ( wfun cdm wcel wa cfv ccnv cima csn cop funfvop wb fvex mpan adantl mpbird
    cvv wss opelcnvg elimasng imass2 sylbi sseld syl5com wi fvimacnvi ex adantr
    snss impbid ) CDZACEZFZGZACHZBFZACIZBJZFZUPAUSUQKZJZFZURVAUPVDUQALUSFZUPVEA
    UQLCFZACMUOVEVFNZUMUQSFZUOVGACOZUQASUNCUAPQRUOVDVENZUMVHUOVJVIUSUQASUNUBPQR
    URVCUTAURVBBTVCUTTUQBVIUKVBBUSUCUDUEUFUMVAURUGUOUMVAURABCUHUIUJUL $.

  ${
    $d F x $.  $d A x $.  $d B x $.
    $( A kind of contraposition law that infers an image subclass from a
       subclass of a preimage.  Raph Levien remarks:  "Likely this could be
       proved directly, and ~ fvimacnv would be the special case of ` A ` being
       a singleton, but it works this way round too."  (Contributed by Raph
       Levien, 20-Nov-2006.) $)
    funimass3 $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( ( F " A ) C_ B <-> A C_ ( `' F " B ) ) ) $=
      ( vx wfun cdm wss wa cima cv ccnv wcel wral funimass4 wb ssel fvimacnv ex
      cfv syl9r imp31 ralbidva bitrd dfss3 syl6bbr ) CEZACFZGZHZCAIBGZDJZCKBIZL
      ZDAMZAULGUIUJUKCSBLZDAMUNDABCNUIUOUMDAUFUHUKALZUOUMOZUHUPUKUGLZUFUQAUGUKP
      UFURUQUKBCQRTUAUBUCDAULUDUE $.

    $( A subclass of a preimage in terms of function values.  (Contributed by
       NM, 15-May-2007.) $)
    funimass5 $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( A C_ ( `' F " B ) <-> A. x e. A ( F ` x ) e. B ) ) $=
      ( wfun cdm wss wa cima ccnv cv cfv wcel wral funimass3 funimass4 bitr3d )
      DEBDFGHDBICGBDJCIGAKDLCMABNBCDOABCDPQ $.

    $( Two ways of specifying that a function is constant on a subdomain.
       (Contributed by NM, 8-Mar-2007.) $)
    funconstss $p |- ( ( Fun F /\ A C_ dom F ) ->
                     ( A. x e. A ( F ` x ) = B <-> A C_ ( `' F " { B } ) ) ) $=
      ( wfun cdm wss wa cfv wceq wral cima csn ccnv wcel funimass4 elsnc ralbii
      cv fvex syl6rbb funimass3 bitrd ) DEBDFGHZASZDIZCJZABKZDBLCMZGZBDNUILGUDU
      JUFUIOZABKUHABUIDPUKUGABUFCUEDTQRUABUIDUBUC $.
  $}


  $( Another proof of ~ fvimacnv , based on ~ funimass3 .  If ~ funimass3 is
     ever proved directly, as opposed to using ~ funimacnv pointwise, then the
     proof of ~ funimacnv should be replaced with this one.  (Contributed by
     Raph Levien, 20-Nov-2006.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  fvimacnvALT $p |- ( ( Fun F /\ A e. dom F ) ->
                    ( ( F ` A ) e. B <-> A e. ( `' F " B ) ) ) $=
    ( wfun cdm wcel wa csn cima wss ccnv cfv wb snssi funimass3 sylan2 fvex wfn
    snss wceq eqid df-fn biimpri mpan2 fnsnfv sylan sseq1d syl5bb snssg 3bitr4d
    adantl ) CDZACEZFZGZCAHZIZBJZUPCKBIZJZACLZBFZAUSFZUNULUPUMJURUTMAUMNUPBCOPV
    BVAHZBJUOURVABACQSUOVDUQBULCUMRZUNVDUQTULUMUMTZVEUMUAVEULVFGCUMUBUCUDUMACUE
    UFUGUHUNVCUTMULAUSUMUIUKUJ $.

  $( Membership in the preimage of a set under a function.  (Contributed by
     Jeff Madsen, 2-Sep-2009.) $)
  elpreima $p |- ( F Fn A -> ( B e. ( `' F " C )
                              <-> ( B e. A /\ ( F ` B ) e. C ) ) ) $=
    ( wfn ccnv cima wcel cfv wa cdm cnvimass sseli fndm eleq2d syl5ib fvimacnvi
    wfun fnfun sylan ex jcad wb fvimacnv funfni biimpd expimpd impbid ) DAEZBDF
    CGZHZBAHZBDICHZJUIUKULUMUKBDKZHUIULUJUNBDCLMUIUNABADNOPUIUKUMUIDRUKUMADSBCD
    QTUAUBUIULUMUKUIULJUMUKUMUKUCABDBCDUDUEUFUGUH $.

  ${
    $d x B $.  $d x C $.  $d x F $.  $d x V $.
    $( Membership in the preimage of a singleton, under a function.
       (Contributed by Mario Carneiro, 12-May-2014.)  (Proof shortened by Mario
       Carneiro, 28-Apr-2015.) $)
    fniniseg $p |- ( F Fn A -> ( C e. ( `' F " { B } ) <->
                     ( C e. A /\ ( F ` C ) = B ) ) ) $=
      ( wfn ccnv csn cima wcel cfv wa wceq elpreima fvex elsnc anbi2i syl6bb )
      DAECDFBGZHICAIZCDJZRIZKSTBLZKACRDMUAUBSTBCDNOPQ $.
  $}

  ${
    $d x A $.  $d x F $.  $d x B $.
    $( Inverse images under functions expressed as abstractions.  (Contributed
       by Stefan O'Rear, 1-Feb-2015.) $)
    fncnvima2 $p |- ( F Fn A -> ( `' F " B ) = { x e. A | ( F ` x ) e. B } ) $=
      ( wfn ccnv cima cv wcel cfv wa cab crab elpreima abbi2dv df-rab syl6eqr )
      DBEZDFCGZAHZBITDJCIZKZALUAABMRUBASBTCDNOUAABPQ $.

    $( Inverse point images under functions expressed as abstractions.
       (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    fniniseg2 $p |- ( F Fn A -> ( `' F " { B } ) =
          { x e. A | ( F ` x ) = B } ) $=
      ( wfn ccnv csn cima cv cfv wcel crab wceq fncnvima2 wb fvex elsnc rabbiia
      a1i syl6eq ) DBEDFCGZHAIZDJZUAKZABLUCCMZABLABUADNUDUEABUDUEOUBBKUCCUBDPQS
      RT $.

    $( Support sets of functions expressed as abstractions.  (Contributed by
       Stefan O'Rear, 1-Feb-2015.) $)
    fnniniseg2 $p |- ( F Fn A -> ( `' F " ( _V \ { B } ) ) =
          { x e. A | ( F ` x ) =/= B } ) $=
      ( wfn ccnv cvv csn cdif cima cv cfv wcel wne fncnvima2 wb eldifsn mpbiran
      crab fvex a1i rabbiia syl6eq ) DBEDFGCHIZJAKZDLZUDMZABSUFCNZABSABUDDOUGUH
      ABUGUHPUEBMUGUFGMUHUEDTUFGCQRUAUBUC $.
  $}

  ${
    $d F x $.  $d A x $.
    $( Existential quantification restricted to a support.  (Contributed by
       Stefan O'Rear, 23-Mar-2015.) $)
    rexsupp $p |- ( F Fn A -> ( E. x e. ( `' F " ( _V \ { Z } ) ) ph <->
          E. x e. A ( ( F ` x ) =/= Z /\ ph ) ) ) $=
      ( wfn cv cfv wne ccnv cvv csn cdif cima wcel elpreima fvex eldifsn syl6bb
      wa mpbiran anbi2i anbi1d anass rexbidv2 ) DCFZABGZDHZEIZATZBDJKELMZNZCUFU
      GULOZATUGCOZUITZATUNUJTUFUMUOAUFUMUNUHUKOZTUOCUGUKDPUPUIUNUPUHKOUIUGDQUHK
      ERUAUBSUCUNUIAUDSUE $.
  $}

  ${
    $d x F $.  $d x A $.  $d x B $.
    $( Preimage of a union.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    unpreima $p |- ( Fun F -> ( `' F " ( A u. B ) )
                                  = ( ( `' F " A ) u. ( `' F " B ) ) ) $=
      ( vx wfun cdm wfn ccnv cun cima wceq funfn cv wcel wa elpreima wo orbi12d
      cfv elun syl5bb anbi2i andi bitri syl6rbbr bitrd eqrdv sylbi ) CECCFZGZCH
      ZABIZJZUKAJZUKBJZIZKCLUJDUMUPUJDMZUMNUQUINZUQCSZULNZOZUQUPNZUIUQULCPUJVBU
      RUSANZOZURUSBNZOZQZVAVBUQUNNZUQUONZQUJVGUQUNUOTUJVHVDVIVFUIUQACPUIUQBCPRU
      AVAURVCVEQZOVGUTVJURUSABTUBURVCVEUCUDUEUFUGUH $.

    $( Preimage of an intersection.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Proof shortened by Mario Carneiro, 14-Jun-2016.) $)
    inpreima $p |- ( Fun F -> ( `' F " ( A i^i B ) )
                                  = ( ( `' F " A ) i^i ( `' F " B ) ) ) $=
      ( wfun ccnv cin cima wceq funcnvcnv imain syl ) CDCEZEDLABFGLAGLBGFHCIABL
      JK $.

    $( Preimage of a difference.  (Contributed by Mario Carneiro,
       14-Jun-2016.) $)
    difpreima $p |- ( Fun F -> ( `' F " ( A \ B ) )
                                  = ( ( `' F " A ) \ ( `' F " B ) ) ) $=
      ( wfun ccnv cdif cima wceq funcnvcnv imadif syl ) CDCEZEDLABFGLAGLBGFHCIA
      BLJK $.

    $( The preimage of a restricted function.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    respreima $p |- ( Fun F -> ( `' ( F |` B ) " A )
                                    = ( ( `' F " A ) i^i B ) ) $=
      ( vx wfun cres ccnv cima cin cdm wfn cv wcel wb cfv wa bitri syl elpreima
      elin funfn ancom anbi1i fvres eleq1d adantl pm5.32i a1i an32 syl6bb fnfun
      wceq funres dmres jctir df-fn sylibr anbi1d syl5bb 3bitr4d sylbi eqrdv )
      CEZDCBFZGAHZCGAHZBIZVCCCJZKZDLZVEMZVJVGMZNCUAVIVJBVHIZMZVJVDOZAMZPZVJVHMZ
      VJCOZAMZPZVJBMZPZVKVLVIVQVRWBPZVTPZWCVQWENVIVQWDVPPWEVNWDVPVNWBVRPWDVJBVH
      TWBVRUBQUCWDVPVTWBVPVTNVRWBVOVSAVJBCUDUEUFUGQUHVRWBVTUIUJVIVDVMKZVKVQNVIV
      DEZVDJVMULZPWFVIWGWHVIVCWGVHCUKBCUMRCBUNUOVDVMUPUQVMVJAVDSRVLVJVFMZWBPVIW
      CVJVFBTVIWIWAWBVHVJACSURUSUTVAVB $.
  $}

  ${
    $d A x y $.  $d B y $.  $d F x y $.
    $( Preimage of an intersection.  (Contributed by FL, 16-Apr-2012.) $)
    iinpreima $p |- ( ( Fun F /\ A =/= (/) )
        -> ( `' F " |^|_ x e. A B ) = |^|_ x e. A ( `' F " B ) ) $=
      ( vy ciin cima wcel wral simpll cnvimass sseli adantl cvv fvimacnvi eliin
      wa wb ax-mp wi wfun wne ccnv cdm cfv fvex adantlr biimpa sylancr fvimacnv
      c0 cv ralbidv syl21anc vex sylibr biimpd ralimdv sylc wrex r19.2zb biimpi
      ex rexlimivw syl6 syl5bi imp syl2anc mpbid impbida eqrdv ) DUAZBUKUBZQZED
      UCZABCFZGZABVOCGZFZVNEULZVQHZVTVSHZVNWAQZVTVRHZABIZWBWCVLVTDUDZHZVTDUEZCH
      ZABIZWEVLVMWAJWAWGVNVQWFVTDVPKLMWCWHNHZWHVPHZWJVTDUFZVLWAWLVMVTVPDOUGWKWL
      WJAWHBCNPZUHUIVLWGQZWJWEWOWIWDABVTCDUJUMUHUNVTNHZWBWEREUOZAVTBVRNPZSZUPVN
      WBQZWLWAWTWJWLWTVLWEWJVLVMWBJZWBWEVNWPWBWETWQWPWBWEWRUQSMVLWDWIABVLWDWIVT
      CDOVCURUSWKWLWJRWMWNSUPWTVLWGWLWARXAVNWBWGVMWBWGTVLWBWEVMWGWSVMWEWDABUTZW
      GVMWEXBTWDABVAVBWDWGABVRWFVTDCKLVDVEVFMVGVTVPDUJVHVIVJVK $.

    $( Preimage of an intersection.  (Contributed by FL, 28-Apr-2012.) $)
    intpreima $p |- ( ( Fun F /\ A =/= (/) )
        -> ( `' F " |^| A ) = |^|_ x e. A ( `' F " x ) ) $=
      ( wfun c0 wne wa ccnv cint cima cv ciin intiin imaeq2i iinpreima syl5eq )
      CDBEFGCHZBIZJQABAKZLZJABQSJLRTQABMNABSCOP $.
  $}

  $( The preimage of the codomain of a mapping is the mapping's domain.
     (Contributed by FL, 25-Jan-2007.) $)
  fimacnv $p |- ( F : A --> B -> ( `' F " B ) = A ) $=
    ( wf ccnv cima crn imassrn cdm dfdm4 fdm ssid syl6eqss syl5eqssr syl5ss wss
    frn wfun wb ffun syl5sseqr funimass3 syl2anc mpbid eqssd ) ABCDZCEZBFZAUFUH
    UGGZAUGBHUFUICIZACJUFUJAAABCKZALZMNOUFCAFZBPZAUHPZUFUMCGBCAHABCQOUFCRAUJPUN
    UOSABCTUFAAUJULUKUAABCUBUCUDUE $.

  ${
    $d k F $.  $d k ph $.  $d k W $.  $d k Z $.
    suppss.f $e |- ( ph -> F : A --> B ) $.
    suppss.n $e |- ( ( ph /\ k e. ( A \ W ) ) -> ( F ` k ) = Z ) $.
    $( Show that the support of a function is contained in a set.  (Contributed
       by Mario Carneiro, 19-Dec-2014.) $)
    suppss $p |- ( ph -> ( `' F " ( _V \ { Z } ) ) C_ W ) $=
      ( ccnv cvv csn cdif cima cv wcel cfv wa wf wfn ffn elpreima 3syl wne fvex
      wb eldifsn mpbiran wceq eldif sylan2br expr necon1ad syl5bi expimpd ssrdv
      wn sylbid ) ADEJKGLMZNZFADOZUTPZVABPZVAEQZUSPZRZVAFPZABCESEBTVBVFUFHBCEUA
      BVAUSEUBUCAVCVEVGVEVDGUDZAVCRZVGVEVDKPVHVAEUEVDKGUGUHVIVGVDGAVCVGUQZVDGUI
      ZVCVJRAVABFMPVKVABFUJIUKULUMUNUOURUP $.
  $}

  ${
    suppssr.f $e |- ( ph -> F : A --> B ) $.
    suppssr.n $e |- ( ph -> ( `' F " ( _V \ { Z } ) ) C_ W ) $.
    $( A function is zero outside its support.  (Contributed by Mario Carneiro,
       19-Dec-2014.) $)
    suppssr $p |- ( ( ph /\ X e. ( A \ W ) ) -> ( F ` X ) = Z ) $=
      ( cdif wcel wn wa cfv wceq eldif wne cvv csn fvex eldifsn mpbiran ccnv wf
      cima wfn wb ffn elpreima 3syl sseld sylbird expdimp syl5bir necon1bd impr
      sylan2b ) FBEJKAFBKZFEKZLZMFDNZGOZFBEPAURUTVBAURMZUSVAGVAGQZVARGSJZKZVCUS
      VFVARKVDFDTVARGUAUBAURVFUSAURVFMZFDUCVEUEZKZUSABCDUDDBUFVIVGUGHBCDUHBFVED
      UIUJAVHEFIUKULUMUNUOUPUQ $.
  $}

  $( Ordered pair with function value.  Part of Theorem 4.3(i) of [Monk1]
     p. 41.  (Contributed by NM, 30-Sep-2004.) $)
  fnopfv $p |- ( ( F Fn A /\ B e. A ) -> <. B , ( F ` B ) >. e. F ) $=
    ( cfv cop wcel funfvop funfni ) BBCDECFABCBCGH $.

  ${
    $d x y F $.  $d x A $.
    $( A function's value belongs to its range.  (Contributed by NM,
       14-Oct-1996.) $)
    fvelrn $p |- ( ( Fun F /\ A e. dom F ) -> ( F ` A ) e. ran F ) $=
      ( vx vy wfun cdm wcel cfv cv wa wi wceq eleq1 anbi2d fveq2 eleq1d imbi12d
      crn cop wex funfvop vex opeq1 spcev syl fvex elrn2 sylibr vtoclg anabsi7
      ) BEZABFZGZABHZBRZGZUKCIZULGZJZUQBHZUOGZKUKUMJZUPKCAULUQALZUSVBVAUPVCURUM
      UKUQAULMNVCUTUNUOUQABOPQUSDIZUTSZBGZDTZVAUSUQUTSZBGZVGUQBUAVFVIDUQCUBVDUQ
      LVEVHBVDUQUTUCPUDUEDUTBUQBUFUGUHUIUJ $.
  $}

  $( A function's value belongs to its range.  (Contributed by NM,
     15-Oct-1996.) $)
  fnfvelrn $p |- ( ( F Fn A /\ B e. A ) -> ( F ` B ) e. ran F ) $=
    ( cfv crn wcel fvelrn funfni ) BCDCEFABCBCGH $.

  $( A function's value belongs to its codomain.  (Contributed by NM,
     12-Aug-1999.) $)
  ffvelrn $p |- ( ( F : A --> B /\ C e. A ) -> ( F ` C ) e. B ) $=
    ( wf wcel wa cfv crn wfn ffn fnfvelrn sylan wi frn sseld adantr mpd ) ABDEZ
    CAFZGCDHZDIZFZUABFZSDAJTUCABDKACDLMSUCUDNTSUBBUAABDOPQR $.

  ${
    ffvrni.1 $e |- F : A --> B $.
    $( A function's value belongs to its codomain.  (Contributed by NM,
       6-Apr-2005.) $)
    ffvelrni $p |- ( C e. A -> ( F ` C ) e. B ) $=
      ( wf wcel cfv ffvelrn mpan ) ABDFCAGCDHBGEABCDIJ $.
  $}

  ${
    ffvelrnd.1 $e |- ( ph -> F : A --> B ) $.
    $( A function's value belongs to its codomain.  (Contributed by Mario
       Carneiro, 29-Dec-2016.) $)
    ffvelrnda $p |- ( ( ph /\ C e. A ) -> ( F ` C ) e. B ) $=
      ( wf wcel cfv ffvelrn sylan ) ABCEGDBHDEICHFBCDEJK $.

    ffvelrnd.2 $e |- ( ph -> C e. A ) $.
    $( A function's value belongs to its codomain.  (Contributed by Mario
       Carneiro, 29-Dec-2016.) $)
    ffvelrnd $p |- ( ph -> ( F ` C ) e. B ) $=
      ( wcel cfv ffvelrnda mpdan ) ADBHDEICHGABCDEFJK $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x ps $.  $d y ph $.
    rexrn.1 $e |- ( x = ( F ` y ) -> ( ph <-> ps ) ) $.
    $( Restricted existential quantification over the range of a function.
       (Contributed by Mario Carneiro, 24-Dec-2013.)  (Revised by Mario
       Carneiro, 20-Aug-2014.) $)
    rexrn $p |- ( F Fn A -> ( E. x e. ran F ph <-> E. y e. A ps ) ) $=
      ( wfn cv cfv crn cvv wcel wa fvex a1i wceq wrex fvelrnb eqcom wb rexxfr2d
      rexbii syl6bb adantl ) FEHZABCDDIZFJZFKZELUHLMUFUGEMNUGFOPUFCIZUIMUHUJQZD
      ERUJUHQZDERDEUJFSUKULDEUHUJTUCUDULABUAUFGUEUB $.

    $( Restricted universal quantification over the range of a function.
       (Contributed by Mario Carneiro, 24-Dec-2013.)  (Revised by Mario
       Carneiro, 20-Aug-2014.) $)
    ralrn $p |- ( F Fn A -> ( A. x e. ran F ph <-> A. y e. A ps ) ) $=
      ( wfn cv cfv crn cvv wcel wa fvex a1i wceq wrex fvelrnb eqcom wb ralxfr2d
      rexbii syl6bb adantl ) FEHZABCDDIZFJZFKZELUHLMUFUGEMNUGFOPUFCIZUIMUHUJQZD
      ERUJUHQZDERDEUJFSUKULDEUHUJTUCUDULABUAUFGUEUB $.
  $}

  ${
    $d F x y $.  $d Y x y $.
    $( For any element in the range of a function there is an element in the
       domain of the function for which the function value is the element of
       the range.  (Contributed by Alexander van der Vekens, 8-Dec-2017.) $)
    elrnrexdm $p |- ( Fun F -> ( Y e. ran F
                                 -> E. x e. dom F Y = ( F ` x ) ) ) $=
      ( vy wfun crn wcel cv wceq cfv cdm wa eqidd ancli adantl eqeq2 rspcev syl
      wrex ex wfn wb funfn rexrn sylbi sylibd ) BEZCBFZGZCDHZIZDUHSZCAHBJZIZABK
      ZSZUGUIULUGUILUICCIZLZULUIURUGUIUQUICMNOUKUQDCUHUJCCPQRTUGBUOUAULUPUBBUCU
      KUNDAUOBUJUMCPUDUEUF $.

    $( For any element in the range of a function there is an element in the
       domain of the function for which the function value is the element of
       the range.  (Contributed by Alexander van der Vekens, 17-Dec-2017.) $)
    elrnrexdmb $p |- ( Fun F -> ( Y e. ran F
                                 <-> E. x e. dom F Y = ( F ` x ) ) ) $=
      ( wfun crn wcel cv cfv wceq cdm wrex wfn funfn fvelrnb sylbi eqcom rexbii
      wb syl6bbr ) BDZCBEFZAGBHZCIZABJZKZCUBIZAUDKTBUDLUAUERBMAUDCBNOUFUCAUDCUB
      PQS $.

    $( For any element in the domain of a function there is an element in the
       range of the function which is the function value for the element of the
       domain.  (Contributed by Alexander van der Vekens, 8-Dec-2017.) $)
    eldmrexrn $p |- ( Fun F -> ( Y e. dom F
                                 -> E. x e. ran F x = ( F ` Y ) ) ) $=
      ( wfun cdm wcel cv cfv wceq crn wrex wa fvelrn eqid eqeq1 rspcev sylancl
      ex ) BDZCBEFZAGZCBHZIZABJZKZSTLUBUDFUBUBIZUECBMUBNUCUFAUBUDUAUBUBOPQR $.

    $( For any element in the domain of a function there is an element in the
       range of the function which is the function value for the element of the
       domain.  Because of the special definition of a function value, the
       theorem is only valid in general if the empty set is not contained in
       the range of the function.  Otherwise, it cannot be distiguished between
       the empty set as a valid function value, or as an indication that the
       function is not defined.  (Contributed by Alexander van der Vekens,
       17-Dec-2017.) $)
    eldmrexrnb $p |- ( ( Fun F /\ (/) e/ ran F )
                         -> ( Y e. dom F <-> E. x e. ran F x = ( F ` Y ) ) ) $=
      ( vy wfun c0 crn wnel wa cdm wcel cv cfv wceq wrex eldmrexrn adantr eleq1
      wi wne wn df-nel nelne2 sylan2b wex n0 elfvdm exlimiv sylbi expcom adantl
      syl com12 syl6bi com13 rexlimdv impbid ) BEZFBGZHZIZCBJKZALZCBMZNZAUSOZUR
      VBVFSUTABCPQVAVEVBAUSVEVCUSKZVAVBVEVGVDUSKZVAVBSVCVDUSRVAVHVBUTVHVBSURVHU
      TVBVHUTIVDFTZVBUTVHFUSKUAVIFUSUBVDFUSUCUDVIDLZVDKZDUEVBDVDUFVKVBDVJCBUGUH
      UIULUJUKUMUNUOUPUQ $.
  $}

  ${
    $d w x z A $.  $d y B $.  $d y ch $.  $d w y z F $.  $d w x z ps $.
    ralrnmpt.1 $e |- F = ( x e. A |-> B ) $.
    ralrnmpt.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( A restricted quantifier over an image set.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    ralrnmpt $p |- ( A. x e. A B e. V ->
      ( A. y e. ran F ps <-> A. x e. A ch ) ) $=
      ( vw vz wcel wral cv wsbc wb dfsbcq syl nfv crn cfv fnmpt nfsbc1v sbceq1a
      wfn ralrn cbvral bicomi cmpt nfmpt1 nfcxfr nfcv nffv nfsbc weq wceq fveq2
      3bitr3g wa fvmpt2 sbcieg adantl bitrd ralimiaa ralbi ) FHMZCENZADGUAZNZAD
      COZGUBZPZCENZBCENZVHADKOZPZKVINZADLOZGUBZPZLENZVJVNVHGEUFVRWBQCEFGHIUCVQW
      AKLEGADVPVTRUGSVJVRAVQDKVIAKTADVPUDADVPUEUHUIWAVMLCEACDVTCVSGCGCEFUJICEFU
      KULCVSUMUNACTUOVMLTLCUPVTVLUQWAVMQVSVKGURADVTVLRSUHUSVHVMBQZCENVNVOQVGWCC
      EVKEMZVGUTZVMADFPZBWEVLFUQVMWFQCEFHGIVAADVLFRSVGWFBQWDABDFHJVBVCVDVEVMBCE
      VFSVD $.

    $( A restricted quantifier over an image set.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    rexrnmpt $p |- ( A. x e. A B e. V ->
      ( E. y e. ran F ps <-> E. x e. A ch ) ) $=
      ( wcel wral wn crn wrex cv wceq notbid ralrnmpt dfrex2 3bitr4g ) FHKCELZA
      MZDGNZLZMBMZCELZMADUDOBCEOUBUEUGUCUFCDEFGHIDPFQABJRSRADUDTBCETUA $.
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y D $.  $d y B $.
    f0cl.1 $e |- F : A --> B $.
    f0cl.2 $e |- (/) e. B $.
    $( Unconditional closure of a function when the range includes the empty
       set.  (Contributed by Mario Carneiro, 12-Sep-2013.) $)
    f0cli $p |- ( F ` C ) e. B $=
      ( wcel cfv ffvelrni cdm fdmi eleq2i wn c0 ndmfv syl6eqel sylnbir pm2.61i
      ) CAGZCDHZBGZABCDEISCDJZGZUAUBACABDEKLUCMTNBCDOFPQR $.
  $}

  $( Alternate definition of a mapping.  (Contributed by NM, 14-Nov-2007.) $)
  dff2 $p |- ( F : A --> B <-> ( F Fn A /\ F C_ ( A X. B ) ) ) $=
    ( wf wfn cxp wss wa ffn fssxp jca crn rnss rnxpss syl6ss anim2i df-f sylibr
    impbii ) ABCDZCAEZCABFZGZHZTUAUCABCIABCJKUDUACLZBGZHTUCUFUAUCUEUBLBCUBMABNO
    PABCQRS $.

  ${
    $d f g x y z A $.  $d f g x y z B $.  $d x y z F $.
    $( Alternate definition of a mapping.  (Contributed by NM, 20-Mar-2007.) $)
    dff3 $p |- ( F : A --> B <->
              ( F C_ ( A X. B ) /\ A. x e. A E! y x F y ) ) $=
      ( vz cxp wss cv wbr weu wa wcel wex cop adantr sylibr sylanbrc wi syl6 wf
      wral fssxp wmo cfv wfun cdm ffun fdm eleq2d biimpar funfvop syl2anc df-br
      fvex breq2 spcev syl funmo eu5 ralrimiva jca wfn crn wceq wrel xpss mpan2
      wal cvv sstr df-rel df-ral eumo imim2i adantl ssel syl5bi opelxp1 exlimdv
      wn con3d exmo ori pm2.61d ex alimdv imp dffun6 dmxpss syl6ss breq1 eubidv
      dmss rspccv euex eldm ssrdv anim12i eqss df-fn rnss rnxpss df-f impbii
      vex ) CDEUAZECDGZHZAIZBIZEJZBKZACUBZLZXGXIXNCDEUCXGXMACXGXJCMZLZXLBNZXLBU
      DZXMXQXJXJEUEZEJZXRXQXJXTOEMZYAXQEUFZXJEUGZMZYBXGYCXPCDEUHZPXGYEXPXGYDCXJ
      CDEUIUJUKXJEULUMXJXTEUNQXLYABXTXJEUOXKXTXJEUPUQURXGXSXPXGYCXSYFBXJEUSURPX
      LBUTRVAVBXOECVCZEVDZDHZXGXOYCYDCVEZYGXOEVFZXSAVIZYCXIYKXNXIEVJVJGZHZYKXIX
      HYMHYNCDVGEXHYMVKVHEVLQPXIXNYLXNXPXMSZAVIXIYLXMACVMXIYOXSAXIYOXSXIYOLXPXS
      YOXPXSSXIXMXSXPXLBVNVOVPXIXPWAZXSSYOXIYPXRWAXSXIXRXPXIXLXPBXIXLXJXKOZXHMZ
      XPXLYQEMXIYRXJXKEUNEXHYQVQVRXJXKCDVSTVTWBXRXSXLBWCWDTPWEWFWGVRWHABEWIRXOY
      DCHZCYDHZLYJXIYSXNYTXIYDXHUGCEXHWNCDWJWKXNFCYDXNFIZCMUUAXKEJZBKZUUAYDMZXM
      UUCAUUACXJUUAVEXLUUBBXJUUAXKEWLWMWOUUCUUBBNUUDUUBBWPBUUAEFXFWQQTWRWSYDCWT
      QECXARXIYIXNXIYHXHVDDEXHXBCDXCWKPCDEXDRXE $.

    $( Alternate definition of a mapping.  (Contributed by NM, 20-Mar-2007.) $)
    dff4 $p |- ( F : A --> B <->
              ( F C_ ( A X. B ) /\ A. x e. A E! y e. B x F y ) ) $=
      ( wf cxp wss cv wbr weu wral wa wreu dff3 wcel cop df-br ssel opelxp2
      syl6 syl5bi pm4.71rd eubidv df-reu syl6bbr ralbidv pm5.32i bitri ) CDEFEC
      DGZHZAIZBIZEJZBKZACLZMUKUNBDNZACLZMABCDEOUKUPURUKUOUQACUKUOUMDPZUNMZBKUQU
      KUNUTBUKUNUSUNULUMQZEPZUKUSULUMERUKVBVAUJPUSEUJVASULUMCDTUAUBUCUDUNBDUEUF
      UGUHUI $.

    $( An onto mapping expressed in terms of function values.  (Contributed by
       NM, 29-Oct-2006.) $)
    dffo3 $p |- ( F : A -onto-> B <-> ( F : A --> B /\
                  A. y e. B E. x e. A y = ( F ` x ) ) ) $=
      ( wfo wf crn wceq wa cv cfv wrex wral dffo2 cab wb wcel wal wi wfn fnrnfv
      ffn eqeq1d simpr ffvelrn adantr eqeltrd exp31 rexlimdv biantrurd syl6rbbr
      syl dfbi2 albidv abeq1 df-ral 3bitr4g bitrd pm5.32i bitri ) CDEFCDEGZEHZD
      IZJVBBKZAKZELZIZACMZBDNZJCDEOVBVDVJVBVDVIBPZDIZVJVBECUAZVDVLQCDEUCVMVCVKD
      ABCEUBUDUMVBVIVEDRZQZBSVNVITZBSVLVJVBVOVPBVBVPVIVNTZVPJVOVBVQVPVBVHVNACVB
      VFCRZVHVNVBVRJZVHJVEVGDVSVHUEVSVGDRVHCDVFEUFUGUHUIUJUKVIVNUNULUOVIBDUPVIB
      DUQURUSUTVA $.

    $( Alternate definition of an onto mapping.  (Contributed by NM,
       20-Mar-2007.) $)
    dffo4 $p |- ( F : A -onto-> B <->
                ( F : A --> B /\ A. y e. B E. x e. A x F y ) ) $=
      ( wfo wf cv wbr wrex wral wa crn wceq dffo2 simpl wcel wex vex wi syl5bbr
      elrn eleq2 biimpar adantll wfn ffn fnbr syl ancrd eximdv syl6ibr ad2antrr
      ex df-rex mpd ralrimiva jca sylbi cfv fnbrfvb eqcom syl6ib sylan reximdva
      biimprd ralimdv imdistani dffo3 sylibr impbii ) CDEFZCDEGZAHZBHZEIZACJZBD
      KZLZVLVMEMZDNZLZVSCDEOWBVMVRVMWAPWBVQBDWBVODQZLVPARZVQWAWCWDVMWAWDWCWDVOV
      TQWAWCAVOEBSUBVTDVOUCUAUDUEVMWDVQTWAWCVMWDVNCQZVPLZARVQVMVPWFAVMVPWEVMECU
      FZVPWETCDEUGZWGVPWECVNVOEUHUNUIUJUKVPACUOULUMUPUQURUSVSVMVOVNEUTZNZACJZBD
      KZLVLVMVRWLVMVQWKBDVMVPWJACVMWGWEVPWJTWHWGWELZVPWIVONZWJWMWNVPCVNVOEVAVFW
      IVOVBVCVDVEVGVHABCDEVIVJVK $.

    $( Alternate definition of an onto mapping.  (Contributed by NM,
       20-Mar-2007.) $)
    dffo5 $p |- ( F : A -onto-> B <->
                ( F : A --> B /\ A. y e. B E. x x F y ) ) $=
      ( wfo wf cv wbr wrex wral wa wex dffo4 rexex ralimi anim2i wcel wfn wi ex
      ffn fnbr syl ancrd eximdv df-rex syl6ibr ralimdv imdistani impbii bitri )
      CDEFCDEGZAHZBHZEIZACJZBDKZLZUMUPAMZBDKZLZABCDENUSVBURVAUMUQUTBDUPACOPQUMV
      AURUMUTUQBDUMUTUNCRZUPLZAMUQUMUPVDAUMUPVCUMECSZUPVCTCDEUBVEUPVCCUNUOEUCUA
      UDUEUFUPACUGUHUIUJUKUL $.

    $( A relation equivalent to the existence of an onto mapping.  The
       right-hand ` f ` is not necessarily a function.  (Contributed by NM,
       20-Mar-2007.) $)
    exfo $p |- ( E. f f : A -onto-> B <->
           E. f ( A. x e. A E! y e. B x f y /\ A. x e. B E. y e. A y f x ) ) $=
      ( vg cv wfo wex wbr wreu wral wrex wa wf dffo4 wss dff4 sylibr foeq1 wceq
      cxp simprbi anim1i sylbi eximi cin crn wcel brinxp reubidva ralimia inss2
      biimpd jctil rninxp biimpri anim12i dffo2 vex inex1 exlimiv cbvexv impbii
      spcev syl sylib ) CDEGZHZEIZAGZBGZVHJZBDKZACLZVLVKVHJBCMADLZNZEIZVIVQEVIC
      DVHOZVPNVQBACDVHPVSVOVPVSVHCDUBZQVOABCDVHRUCUDUEUFVRCDFGZHZFIZVJVQWCEVQCD
      VHVTUGZHZWCVQCDWDOZWDUHDUAZNWEVOWFVPWGVOWDVTQZVKVLWDJZBDKZACLZNWFVOWKWHVN
      WJACVKCUIZVNWJWLVMWIBDVKVLCDVHUJUKUNULVHVTUMUOABCDWDRSWGVPBACDVHUPUQURCDW
      DUSSWBWEFWDVHVTEUTVACDWAWDTVEVFVBWBVIFECDWAVHTVCVGVD $.
  $}

  ${
    $d F x y $.  $d A x y $.  $d B x y $.  $d C x y $.
    $( Property of a surjective function.  (Contributed by Jeff Madsen,
       4-Jan-2011.) $)
    foelrn $p |- ( ( F : A -onto-> B /\ C e. B )
                                  -> E. x e. A C = ( F ` x ) ) $=
      ( vy wfo cv wceq wrex wral wcel dffo3 simprbi eqeq1 rexbidv rspccva sylan
      cfv wf ) BCEGZFHZAHESZIZABJZFCKZDCLDUCIZABJZUABCETUFAFBCEMNUEUHFDCUBDIUDU
      GABUBDUCOPQR $.
  $}

  ${
    $d F x y z $.  $d G x y z $.  $d A y z $.  $d B x y z $.  $d C x y z $.
    $( If a composition of two functions is surjective, then the function on
       the left is surjective.  (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    foco2 $p |- ( ( F : B --> C /\ G : A --> B /\
                        ( F o. G ) : A -onto-> C ) -> F : B -onto-> C ) $=
      ( vy vx vz wf ccom wfo w3a cv cfv wceq wrex wral wa wcel adantll sylanbrc
      simp1 foelrn ffvelrn fvco3 fveq2 eqeq2d rspcev syl2anc rexbidv syl5ibrcom
      eqeq1 rexlimdva syl5 impl ralrimiva 3impa dffo3 ) BCDIZABEIZACDEJZKZLUSFM
      ZGMZDNZOZGBPZFCQZBCDKUSUTVBUBUSUTVBVHUSUTRZVBRVGFCVIVBVCCSZVGVBVJRVCHMZVA
      NZOZHAPVIVGHACVCVAUCVIVMVGHAVIVKASZRZVGVMVLVEOZGBPZVOVKENZBSZVLVRDNZOZVQU
      TVNVSUSABVKEUDTUTVNWAUSABVKDEUETVPWAGVRBVDVROVEVTVLVDVRDUFUGUHUIVMVFVPGBV
      CVLVEULUJUKUMUNUOUPUQGFBCDURUA $.
  $}

  ${
    $d w x y z A $.  $d x y z B $.  $d y z C $.  $d w y z F $.
    fmpt.1 $e |- F = ( x e. A |-> C ) $.
    $( Functionality of the mapping operation.  (Contributed by Mario Carneiro,
       26-Jul-2013.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    fmpt $p |- ( A. x e. A C e. B <-> F : A --> B ) $=
      ( vy wcel wral wf wfn crn wss fnmpt cv wceq wrex cab rnmpt wa biimparc ex
      r19.29 rexlimivw syl abssdv syl5eqss df-f sylanbrc crab ccnv cima fimacnv
      eleq1 mptpreima syl5reqr rabid2 sylib impbii ) DCHZABIZBCEJZVAEBKELZCMVBA
      BDECFNVAVCGOZDPZABQZGRCAGBDEFSVAVFGCVAVFVDCHZVAVFTUTVETZABQVGUTVEABUCVHVG
      ABVEVGUTVDDCUNUAUDUEUBUFUGBCEUHUIVBBUTABUJZPVAVBVIEUKCULBABDCEFUOBCEUMUPU
      TABUQURUS $.

    $( Express bijection for a mapping operation.  (Contributed by Mario
       Carneiro, 30-May-2015.)  (Revised by Mario Carneiro, 4-Dec-2016.) $)
    f1ompt $p |- ( F : A -1-1-onto-> B <->
        ( A. x e. A C e. B /\ A. y e. B E! x e. A y = C ) ) $=
      ( vz wa cv wceq wral wcel wfn wbr weu nfcv bitri vex 3bitr4i wf wf1o wreu
      ccnv wb ffn dff1o4 baib syl cres fnres cmpt nfmpt1 nfcxfr nfv breq1 copab
      nfbr df-mpt eqtri breqi cop df-br opabid syl6bb cbveu brcnv df-reu ralbii
      eubii wrel cdm wss relcnv crn df-rn frn syl5eqssr relssres sylancr fneq1d
      syl5bbr bitr4d pm5.32i f1of pm4.71ri fmpt anbi1i ) CDFUAZCDFUBZIWIBJZEKZA
      CUCZBDLZIWJEDMACLZWNIWIWJWNWIWJFUDZDNZWNWIFCNZWJWQUECDFUFWJWRWQCDFUGUHUIW
      NWPDUJZDNZWIWQWTWKHJZWPOZHPZBDLWNBHDWPUKXCWMBDXAWKFOZHPAJZCMWLIZAPXCWMXDX
      FHAAXAWKFAXAQAFACEULZGACEUMUNAWKQURXFHUOXAXEKXDXEWKFOZXFXAXEWKFUPXHXEWKXF
      ABUQZOZXFXEWKFXIFXGXIGABCEUSUTVAXJXEWKVBXIMXFXEWKXIVCXFABVDRRVEVFXBXDHWKX
      AFBSHSVGVJWLACVHTVIRWIDWSWPWIWPVKWPVLZDVMWSWPKFVNWIXKFVODFVPCDFVQVRWPDVSV
      TWAWBWCWDWJWICDFWEWFWOWIWNACDEFGWGWHT $.

    fmpti.2 $e |- ( x e. A -> C e. B ) $.
    $( Functionality of the mapping operation.  (Contributed by NM,
       19-Mar-2005.)  (Revised by Mario Carneiro, 1-Sep-2015.) $)
    fmpti $p |- F : A --> B $=
      ( wcel wral wf rgen fmpt mpbi ) DCHZABIBCEJNABGKABCDEFLM $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x ph $.
    fmptd.1 $e |- ( ( ph /\ x e. A ) -> B e. C ) $.
    fmptd.2 $e |- F = ( x e. A |-> B ) $.
    $( Domain and codomain of the mapping operation; deduction form.
       (Contributed by Mario Carneiro, 13-Jan-2013.) $)
    fmptd $p |- ( ph -> F : A --> C ) $=
      ( wcel wral wf ralrimiva fmpt sylib ) ADEIZBCJCEFKAOBCGLBCEDFHMN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( A function maps to a class to which all values belong.  (Contributed by
       NM, 3-Dec-2003.) $)
    ffnfv $p |- ( F : A --> B <-> ( F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      ( vy wf wfn cv cfv wcel wral ffn ffvelrn ralrimiva jca crn wss simpl wceq
      wa wrex fvelrnb biimpd nfra1 nfv wi rsp eleq1 biimpcd syl6 rexlimd sylan9
      ssrdv df-f sylanbrc impbii ) BCDFZDBGZAHZDIZCJZABKZTZUQURVBBCDLUQVAABBCUS
      DMNOVCURDPZCQUQURVBRVCEVDCUREHZVDJZUTVESZABUAZVBVECJZURVFVHABVEDUBUCVBVGV
      IABVAABUDVIAUEVBUSBJVAVGVIUFVAABUGVGVAVIUTVECUHUIUJUKULUMBCDUNUOUP $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z F $.  $d x y z $.
    ffnfvf.1 $e |- F/_ x A $.
    ffnfvf.2 $e |- F/_ x B $.
    ffnfvf.3 $e |- F/_ x F $.
    $( A function maps to a class to which all values belong.  This version of
       ~ ffnfv uses bound-variable hypotheses instead of distinct variable
       conditions.  (Contributed by NM, 28-Sep-2006.) $)
    ffnfvf $p |- ( F : A --> B <-> ( F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      ( vz wf wfn cv cfv wcel wral wa ffnfv nfcv nffv nfel nfv weq fveq2 eleq1d
      cbvralf anbi2i bitri ) BCDIDBJZHKZDLZCMZHBNZOUGAKZDLZCMZABNZOHBCDPUKUOUGU
      JUNHABHBQEAUICAUHDGAUHQRFSUNHTHAUAUIUMCUHULDUBUCUDUEUF $.
  $}

  ${
    $d x y A $.  $d x B $.  $d x y F $.
    $( An upper bound for range determined by function values.  (Contributed by
       NM, 8-Oct-2004.) $)
    fnfvrnss $p |- ( ( F Fn A /\ A. x e. A ( F ` x ) e. B ) -> ran F C_ B ) $=
      ( wfn cv cfv wcel wral wa wf crn wss ffnfv frn sylbir ) DBEAFDGCHABIJBCDK
      DLCMABCDNBCDOP $.
  $}

  ${
    $d x A $.  $d x C $.
    rnmptss.1 $e |- F = ( x e. A |-> B ) $.
    $( The range of an operation given by the "maps to" notation as a subset.
       (Contributed by Thierry Arnoux, 24-Sep-2017.) $)
    rnmptss $p |- ( A. x e. A B e. C -> ran F C_ C ) $=
      ( wcel wral wf crn wss fmpt frn sylbi ) CDGABHBDEIEJDKABDCEFLBDEMN $.
  $}

  ${
    $d x A $.  $d y A $.  $d y C $.  $d y F $.  $d x ph $.  $d y ph $.
    fmpt2d.2 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    fmpt2d.1 $e |- ( ph -> F = ( x e. A |-> B ) ) $.
    fmpt2d.3 $e |- ( ( ph /\ y e. A ) -> ( F ` y ) e. C ) $.
    $( Domain and codomain of the mapping operation; deduction form.
       (Contributed by NM, 27-Dec-2014.) $)
    fmpt2d $p |- ( ph -> F : A --> C ) $=
      ( wfn cv cfv wcel wral wf cmpt ralrimiva eqid fnmpt fneq1d ffnfv sylanbrc
      syl mpbird ) AGDLZCMGNFOZCDPDFGQAUGBDERZDLZAEHOZBDPUJAUKBDISBDEUIHUITUAUE
      ADGUIJUBUFAUHCDKSCDFGUCUD $.
  $}

  ${
    $d x y A $.  $d y C $.  $d y F $.  $d x y ph $.
    fmpt2dOLD.1 $e |- ( ph -> ( x e. A -> B e. V ) ) $.
    fmpt2dOLD.2 $e |- F = ( x e. A |-> B ) $.
    fmpt2dOLD.3 $e |- ( ph -> ( y e. A -> ( F ` y ) e. C ) ) $.
    $( Domain and codomain of the mapping operation; deduction form.
       (Contributed by NM, 9-Apr-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    fmpt2dOLD $p |- ( ph -> F : A --> C ) $=
      ( cv wcel imp cmpt wceq a1i cfv fmpt2d ) ABCDEFGHABLDMEHMINGBDEOPAJQACLZD
      MTGRFMKNS $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( A necessary and sufficient condition for a restricted function.
       (Contributed by Mario Carneiro, 14-Nov-2013.) $)
    ffvresb $p |- ( Fun F -> ( ( F |` A ) : A --> B <->
        A. x e. A ( x e. dom F /\ ( F ` x ) e. B ) ) ) $=
      ( wfun cres wf cv cdm wcel cfv wa wral fdm cin dmres inss2 adantl wfn wss
      eqsstri syl6eqssr sselda wceq fvres ffvelrn eqeltrrd jca ralrimiva ralimi
      crn simpl dfss3 sylibr funfn fnssres sylanb sylan2 eleq1d syl5ibr ralimia
      simpr fnfvrnss syl2anc df-f sylanbrc ex impbid2 ) DEZBCDBFZGZAHZDIZJZVLDK
      ZCJZLZABMZVKVQABVKVLBJZLZVNVPVKBVMVLVKBVJIZVMBCVJNWABVMOVMDBPBVMQUAUBUCVT
      VLVJKZVOCVSWBVOUDVKVLBDUEZRBCVLVJUFUGUHUIVIVRVKVIVRLZVJBSZVJUKCTZVKVRVIBV
      MTZWEVRVNABMWGVQVNABVNVPULUJABVMUMUNVIDVMSWGWEDUOVMBDUPUQURZWDWEWBCJZABMZ
      WFWHVRWJVIVQWIABVQWIVSVPVNVPVBVSWBVOCWCUSUTVARABCVJVCVDBCVJVEVFVGVH $.
  $}

  ${
    $d u v w x z A $.  $d u x y B $.  $d u w z F $.  $d u w z G $.  $d u y R $.
    $d u w x z ph $.  $d u x S $.  $d u v w y z T $.
    fmptco.1 $e |- ( ( ph /\ x e. A ) -> R e. B ) $.
    fmptco.2 $e |- ( ph -> F = ( x e. A |-> R ) ) $.
    fmptco.3 $e |- ( ph -> G = ( y e. B |-> S ) ) $.
    fmptco.4 $e |- ( y = R -> S = T ) $.
    $( Composition of two functions expressed as ordered-pair class
       abstractions.  If ` F ` has the equation ` ( x + 2 ) ` and ` G ` the
       equation ` ( 3 * z ) ` then ` ( G o. F ) ` has the equation
       ` ( 3 * ( x + 2 ) ) ` .  (Contributed by FL, 21-Jun-2012.)  (Revised by
       Mario Carneiro, 24-Jul-2014.) $)
    fmptco $p |- ( ph -> ( G o. F ) = ( x e. A |-> T ) ) $=
      ( vu cv wbr wa wcel wceq vz vw vv ccom cmpt relco wfun wrel funmpt funrel
      ax-mp wex csb cop cfv eqid fmptd feq1d mpbird ffun syl funbrfv imp eqcomd
      wf sylan a1d expimpd pm4.71rd exbidv fvex breq2 breq1 anbi12d ceqsexv cdm
      wb funfvbrb fdm eleq2d bitr3d fveq1d eqidd breq123d wi nfcv nffvmpt1 nfbr
      nfv nfcsb1v nfeq2 nfbi fveq2 breq1d csbeq1a eqeq2d bibi12d imbi2d cvv vex
      simpl eleq1d simpr adantr eqeq12d df-mpt brabga sylancl syl2anc biantrurd
      fvmpt2 3bitr4d expcom vtoclgaf impcom pm5.32da bitrd syl5bb opelco eleq2i
      nfim copab nfan eleq1 eqeq1 anbi2d opelopabf bitri 3bitr4g eqrelrdv ) AUA
      UBJIUDZBDHUEZJIUFYLUGYLUHBDHUIYLUJUKAUAPZOPZIQZYNUBPZJQZRZOULZYMDSZYPBYMH
      UMZTZRZYMYPUNZYKSUUDYLSZAYSYNYMIUOZTZYRRZOULZUUCAYRUUHOAYRUUGAYOYQUUGAYOR
      ZUUGYQUUJUUFYNAIUGZYOUUFYNTZADEIVEZUUKAUUMDEBDFUEZVEABDFEUUNKUUNUPZUQADEI
      UUNLURUSZDEIUTVAZUUKYOUULYMYNIVBVCVFVDVGVHVIVJUUIYMUUFIQZUUFYPJQZRZAUUCYR
      UUTOUUFYMIVKUUGYOUURYQUUSYNUUFYMIVLYNUUFYPJVMVNVOAUUTYTYMUUNUOZYPCEGUEZQZ
      RUUCAUURYTUUSUVCAYMIVPZSZUURYTAUUKUVEUURVQUUQYMIVRVAAUVDDYMAUUMUVDDTUUPDE
      IVSVAVTWAAUUFUVAYPYPJUVBAYMIUUNLWBMAYPWCWDVNAYTUVCUUBYTAUVCUUBVQZABPZUUNU
      OZYPUVBQZYPHTZVQZWEAUVFWEBYMDBYMWFAUVFBABWIUVCUUBBBUVAYPUVBBDFYMWGBUVBWFB
      YPWFWHBYPUUABYMHWJZWKWLYAUVGYMTZUVKUVFAUVMUVIUVCUVJUUBUVMUVHUVAYPUVBUVGYM
      UUNWMWNUVMHUUAYPBYMHWOZWPWQWRAUVGDSZUVKAUVORZFYPUVBQZFESZUVJRZUVIUVJUVPUV
      RYPWSSUVQUVSVQKUBWTZCPZESZYNGTZRUVSCOFYPUVBEWSUWAFTZYNYPTZRZUWBUVRUWCUVJU
      WFUWAFEUWDUWEXAXBUWFYNYPGHUWDUWEXCUWDGHTUWENXDXEVNCOEGXFXGXHUVPUVHFYPUVBU
      VPUVOUVRUVHFTAUVOXCKBDFEUUNUUOXKXIWNUVPUVRUVJKXJXLXMXNXOXPXQXRXQOYMYPJIUA
      WTZUVTXSUUEUUDUVOUCPZHTZRZBUCYBZSUUCYLUWKUUDBUCDHXFXTUWJYTUWHUUATZRUUCBUC
      YMYPYTUWLBYTBWIBUWHUUAUVLWKYCUUCUCWIUWGUVTUVMUVOYTUWIUWLUVGYMDYDUVMHUUAUW
      HUVNWPVNUWHYPTUWLUUBYTUWHYPUUAYEYFYGYHYIYJ $.
  $}

  ${
    $d w x y z B $.  $d w y z R $.  $d w x z S $.  $d x z A $.  $d y z T $.
    $d z ph $.
    fmptcof.1 $e |- ( ph -> A. x e. A R e. B ) $.
    fmptcof.2 $e |- ( ph -> F = ( x e. A |-> R ) ) $.
    fmptcof.3 $e |- ( ph -> G = ( y e. B |-> S ) ) $.
    ${
      fmptcof.4 $e |- ( y = R -> S = T ) $.
      $( Version of ~ fmptco where ` ph ` needn't be distinct from ` x ` .
         (Contributed by NM, 27-Dec-2014.) $)
      fmptcof $p |- ( ph -> ( G o. F ) = ( x e. A |-> T ) ) $=
        ( vz vw csb cmpt wceq nfcv ccom cv wcel wral nfcsb1v nfel1 csbeq1a rspc
        eleq1d mpan9 cbvmpt syl6eq csbeq1 fmptco csbeq1d syl6eqr csbiegf ralimi
        nfcsb eqid nfcvd mpteq12 sylancr syl eqtrd ) AJIUAZBDCFGQZRZBDHRZAVFODC
        BOUBZFQZGQZRVHAOPDEVKCPUBZGQZVLIJAFEUCZBDUDZVJDUCVKEUCZKVOVQBVJDBVKEBVJ
        FUEZUFBUBVJSZFVKEBVJFUGZUIUHUJAIBDFRODVKRLBODFVKOFTVRVTUKULAJCEGRPEVNRM
        CPEGVNPGTCVMGUECVMGUGUKULCVMVKGUMUNBODVGVLOVGTBCVKGVRBGTUSVSCFVKGVTUOUK
        UPAVPVHVISZKVPDDSVGHSZBDUDWADUTVOWBBDCFGHEVOCHVANUQURBDVGDHVBVCVDVE $.
    $}

    $( Composition of two functions expressed as mapping abstractions.
       (Contributed by NM, 22-May-2006.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    fmptcos $p |- ( ph -> ( G o. F ) = ( x e. A |-> [_ R / y ]_ S ) ) $=
      ( vz cv csb cmpt nfcv nfcsb1v csbeq1a cbvmpt syl6eq csbeq1 fmptcof ) ABMD
      EFCMNZGOZCFGOHIJKAICEGPMEUEPLCMEGUEMGQCUDGRCUDGSTUACUDFGUBUC $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.  $d x y D $.  $d x E $.
    $( Express composition of two functions as a maps-to applying both in
       sequence.  (Contributed by Stefan O'Rear, 5-Oct-2014.)  (Proof shortened
       by Mario Carneiro, 27-Dec-2014.) $)
    fcompt $p |- ( ( A : D --> E /\ B : C --> D ) -> ( A o. B ) = ( x e. C |->
        ( A ` ( B ` x ) ) ) ) $=
      ( vy wf wa cv cfv wcel ffvelrn adantll wfn cmpt wceq ffn dffn5 sylib
      adantl adantr fveq2 fmptco ) EFBHZDECHZIZAGDEAJZCKZGJZBKZUIBKCBUFUHDLUIEL
      UEDEUHCMNUGCDOZCADUIPQUFULUEDECRUAADCSTUGBEOZBGEUKPQUEUMUFEFBRUBGEBSTUJUI
      BUCUD $.
  $}

  ${
    $d F x y $.  $d I x $.  $d X x y $.  $d Y x y $.
    $( Composition with a constant function.  (Contributed by Stefan O'Rear,
       11-Mar-2015.) $)
    fcoconst $p |- ( ( F Fn X /\ Y e. X ) ->
        ( F o. ( I X. { Y } ) ) = ( I X. { ( F ` Y ) } ) ) $=
      ( vx vy wfn wcel wa csn cxp ccom cfv cmpt simplr wceq fconstmpt a1i cvv
      cv wf simpl dffn2 sylib feqmptd fveq2 fmptco syl6eqr ) ACGZDCHZIZABDJKZLE
      BDAMZNBUMJKUKEFBCDFTZAMUMULAUIUJETBHOULEBDNPUKEBDQRUKFCSAUKUICSAUAUIUJUBC
      AUCUDUEUNDAUFUGEBUMQUH $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    fsn.1 $e |- A e. _V $.
    fsn.2 $e |- B e. _V $.
    $( A function maps a singleton to a singleton iff it is the singleton of an
       ordered pair.  (Contributed by NM, 10-Dec-2003.) $)
    fsn $p |- ( F : { A } --> { B } <-> F = { <. A , B >. } ) $=
      ( vx vy csn cop wceq cv wcel wb wal wa elsn weu eleq1d bitr4i bitr2i wreu
      wf opelf anbi12i sylib ex snid feu mpan2 anbi1i opeq2 pm5.32i ancom eubii
      eueq1 biantru euanv df-reu 3bitr4i sylibr opeq12 syl5ibrcom impbid syl6bb
      opex elsnc opth2 wrel frel relsnop eqrel sylancl mpbird wf1o f1osn f1oeq1
      alrimivv mpbiri f1of syl impbii ) AHZBHZCUBZCABIZHZJZWDWGFKZGKZIZCLZWJWFL
      ZMZGNFNZWDWMFGWDWKWHAJZWIBJZOZWLWDWKWQWDWKWQWDWKOWHWBLZWIWCLZOWQWBWCWHWIC
      UCWRWOWSWPFAPGBPZUDUEUFWDWKWQWECLZWDAWIIZCLZGWCUAZXAWDAWBLXDADUGGWBWCACUH
      UIXAWPOZGQZWSXCOZGQXAXDXEXGGXGWPXCOZXEWSWPXCWTUJXHWPXAOXEWPXCXAWPXBWECWIB
      AUKRULXAWPUMSTUNXAXAWPGQZOXFXIXAGBEUOUPXAWPGUQSXCGWCURUSUTWQWJWECWHWIABVA
      RVBVCWLWJWEJWQWJWEWHWIVEVFWHWIABDEVGTVDVQWDCVHWFVHWGWNMWBWCCVIABDEVJFGCWF
      VKVLVMWGWBWCCVNZWDWGXJWBWCWFVNABDEVOWBWCCWFVPVRWBWCCVSVTWA $.
  $}

  ${
    $d A a b $.  $d B b $.  $d F a b $.
    $( A function maps a singleton to a singleton iff it is the singleton of an
       ordered pair.  (Contributed by NM, 26-Oct-2012.) $)
    fsng $p |- ( ( A e. C /\ B e. D ) ->
                 ( F : { A } --> { B } <-> F = { <. A , B >. } ) ) $=
      ( va vb cv csn wf cop wceq wb sneq feq2d opeq1 sneqd eqeq2d bibi12d vex
      feq3 syl opeq2 fsn vtocl2g ) FHZIZGHZIZEJZEUFUHKZIZLZMAIZUIEJZEAUHKZIZLZM
      UNBIZEJZEABKZIZLZMFGABCDUFALZUJUOUMURVDUGUNUIEUFANOVDULUQEVDUKUPUFAUHPQRS
      UHBLZUOUTURVCVEUIUSLUOUTMUHBNUIUSUNEUAUBVEUQVBEVEUPVAUHBAUCQRSUFUHEFTGTUD
      UE $.
  $}

  ${
    fsn2.1 $e |- A e. _V $.
    $( A function that maps a singleton to a class is the singleton of an
       ordered pair.  (Contributed by NM, 19-May-2004.) $)
    fsn2 $p |- ( F : { A } --> B <->
               ( ( F ` A ) e. B /\ F = { <. A , ( F ` A ) >. } ) ) $=
      ( csn wf cfv wcel cop wceq snid ffvelrn mpan2 wfn ffn crn dffn3 cima syl
      wa biimpi wb cdm imadmrn fndm imaeq2d syl5eqr fnsnfv eqtr4d mpbid jca wss
      feq3 snssi fss ancoms sylan impbii fvex fsn anbi2i bitri ) AEZBCFZACGZBHZ
      VCVEEZCFZTZVFCAVEIEJZTVDVIVDVFVHVDAVCHZVFADKZVCBACLMVDCVCNZVHVCBCOVMVCCPZ
      CFZVHVMVOVCCQUAVMVNVGJVOVHUBVMVNCVCRZVGVMVNCCUCZRVPCUDVMVQVCCVCCUEUFUGVMV
      KVGVPJVLVCACUHMUIVNVGVCCUMSUJSUKVFVGBULZVHVDVEBUNVHVRVDVCVGBCUOUPUQURVHVJ
      VFAVECDACUSUTVAVB $.
  $}

  $( The cross product of two singletons.  (Contributed by Mario Carneiro,
     30-Apr-2015.) $)
  xpsng $p |- ( ( A e. V /\ B e. W ) ->
    ( { A } X. { B } ) = { <. A , B >. } ) $=
    ( wcel wa csn cxp wf cop wceq fconstg adantl fsng mpbid ) ACEZBDEZFAGZBGZRS
    HZIZTABJGKQUAPRBDLMABCDTNO $.

  ${
    xpsn.1 $e |- A e. _V $.
    xpsn.2 $e |- B e. _V $.
    $( The cross product of two singletons.  (Contributed by NM,
       4-Nov-2006.) $)
    xpsn $p |- ( { A } X. { B } ) = { <. A , B >. } $=
      ( cvv wcel csn cxp cop wceq xpsng mp2an ) AEFBEFAGBGHABIGJCDABEEKL $.
  $}

  ${
    dfmpt.1 $e |- B e. _V $.
    $( Alternate definition for the "maps to" notation ~ df-mpt (although it
       requires that ` B ` be a set).  (Contributed by NM, 24-Aug-2010.)
       (Revised by Mario Carneiro, 30-Dec-2016.) $)
    dfmpt $p |- ( x e. A |-> B ) = U_ x e. A { <. x , B >. } $=
      ( cmpt cv csn cxp ciun cop dfmpt3 wceq wcel vex xpsn a1i iuneq2i eqtri )
      ABCEABAFZGCGHZIABSCJGZIABCKABTUATUALSBMSCANDOPQR $.

    $d x y $.  $d y A $.  $d y B $.
    $( A function expressed as the range of another function.  (Contributed by
       Mario Carneiro, 22-Jun-2013.)  (Proof shortened by Mario Carneiro,
       31-Aug-2015.) $)
    fnasrn $p |- ( x e. A |-> B ) = ran ( x e. A |-> <. x , B >. ) $=
      ( vy cmpt cv cop csn ciun crn dfmpt wcel wrex wceq eqid rnmpt elsn eqtr4i
      cab rexbii abbii df-iun ) ABCFABAGCHZIZJZABUDFZKZABCDLUHEGZUEMZABNZETZUFU
      HUIUDOZABNZETULAEBUDUGUGPQUKUNEUJUMABEUDRUAUBSAEBUEUCSS $.
  $}

  $( If ` A ` is not in ` C ` , then the restriction of a singleton of
     ` <. A , B >. ` to ` C ` is null.  (Contributed by Scott Fenton,
     15-Apr-2011.) $)
  ressnop0 $p |- ( -. A e. C -> ( { <. A , B >. } |` C ) = (/) ) $=
    ( wcel wn cop cvv cxp csn cres c0 wceq opelxp1 con3i cin df-res incom eqtri
    disjsn biimpri syl5eq syl ) ACDZEABFZCGHZDZEZUDIZCJZKLUFUCABCGMNUGUIUEUHOZK
    UIUHUEOUJUHCPUHUEQRUJKLUGUEUDSTUAUB $.

  ${
    fpr.1 $e |- A e. _V $.
    fpr.2 $e |- B e. _V $.
    fpr.3 $e |- C e. _V $.
    fpr.4 $e |- D e. _V $.
    $( A function with a domain of two elements.  (Contributed by Jeff Madsen,
       20-Jun-2010.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
    fpr $p |- ( A =/= B
                -> { <. A , C >. , <. B , D >. } : { A , B } --> { C , D } ) $=
      ( wne cop cpr wfn crn wa jctir sylibr csn cun df-pr rnsnop wss wfun funpr
      wf cdm wceq dmprop df-fn rneqi rnun uneq12i eqtr4i 3eqtri eqimssi df-f )
      ABIZACJZBDJZKZABKZLZUSMZCDKZUAZNUTVCUSUDUPVAVDUPUSUBZUSUEUTUFZNVAUPVEVFAB
      CDEFGHUCACBDGHUGOUSUTUHPVBVCVBUQQZURQZRZMVGMZVHMZRZVCUSVIUQURSUIVGVHUJVLC
      QZDQZRVCVJVMVKVNACETBDFTUKCDSULUMUNOUTVCUSUOP $.
  $}

  $( A function with a domain of two elements.  (Contributed by FL,
     2-Feb-2014.) $)
  fprg $p |- ( ( ( A e. E /\ B e. F ) /\ ( C e. G /\ D e. H ) /\ A =/= B )
                -> { <. A , C >. , <. B , D >. } : { A , B } --> { C , D } ) $=
    ( wcel wa cpr cop wf cvv wi elex c0 cif wceq 0ex anim12i neeq1 opeq1 preq1d
    wne preq1 feq12d imbi12d neeq2 preq2d preq2 opeq2 feq123d imbi2d elimel fpr
    eqidd dedth4h syl2an 3impia ) AEIZBFIZJZCGIZDHIZJZABUEZABKZCDKZACLZBDLZKZMZ
    VCANIZBNIZJCNIZDNIZJVGVMOZVFVAVNVBVOAEPBFPUAVDVPVEVQCGPDHPUAVNVOVPVQVRVNAQR
    ZBUEZVSBKZVIVSCLZVKKZMZOVSVOBQRZUEZVSWEKZVIWBWEDLZKZMZOWFWGVPCQRZDKZVSWKLZW
    HKZMZOWFWGWKVQDQRZKZWMWEWPLZKZMZOABCDQQQQAVSSZVGVTVMWDAVSBUBXAVHWAVIVLWCXAV
    JWBVKAVSCUCUDAVSBUFUGUHBWESZVTWFWDWJBWEVSUIXBWAWGVIWCWIXBVKWHWBBWEDUCUJBWEV
    SUKUGUHCWKSZWJWOWFXCWGWGVIWLWIWNXCWBWMWHCWKVSULUDXCWGUQCWKDUFUMUNDWPSZWOWTW
    FXDWGWGWLWQWNWSXDWHWRWMDWPWEULUJXDWGUQDWPWKUKUMUNVSWEWKWPAQNTUOBQNTUOCQNTUO
    DQNTUOUPURUSUT $.

  $( A function with a domain of three elements.  (Contributed by Alexander van
     der Vekens, 4-Dec-2017.) $)
  ftpg $p |- ( ( ( X e. U /\ Y e. V /\ Z e. W )
                 /\ ( A e. F /\ B e. G /\ C e. H )
                 /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) )
               -> { <. X , A >. , <. Y , B >. , <. Z , C >. } :
                  { X , Y , Z } --> { A , B , C } ) $=
    ( wcel w3a wne cpr wf wceq wa wn csn cun cop ctp cin c0 3simpa simp1 syl3an
    fprg eqidd wb simp3 anim12i 3adant3 fsng syl mpbird elpri eqcom nne orbi12i
    bitr4i biimpi ianor sylibr con2i 3adant1 3ad2ant3 disjsn fun syl21anc df-tp
    wo feq1i feq23i bitri ) JDMZKHMZLIMZNZAEMZBFMZCGMZNZJKOZJLOZKLOZNZNZJKPZLUA
    ZUBZABPZCUAZUBZJAUCZKBUCZPZLCUCZUAZUBZQZJKLUDZABCUDZWQWRWTUDZQZWJWKWNWSQZWL
    WOXAQZWKWLUEUFRZXCWAVRVSSWEWBWCSWIWFXHVRVSVTUGWBWCWDUGWFWGWHUHJKABDHEFUJUIW
    JXIXAXARZWJXAUKWJVTWDSZXIXKULWAWEXLWIWAVTWEWDVRVSVTUMWBWCWDUMUNUOLCIGXAUPUQ
    URWJLWKMZTZXJWIWAXNWEWGWHXNWFXMWGWHSZXMLJRZLKRZVNZXOTZLJKUSXRWGTZWHTZVNZXSX
    RYBXPXTXQYAXPJLRXTLJUTJLVAVCXQKLRYALKUTKLVAVCVBVDWGWHVEVFUQVGVHVIWKLVJVFWKW
    LWNWOWSXAVKVLXGXDXEXBQXCXDXEXFXBWQWRWTVMVOXDXEWMWPXBJKLVMABCVMVPVQVF $.

  ${
    ftp.a $e |- A e. _V $.
    ftp.b $e |- B e. _V $.
    ftp.c $e |- C e. _V $.
    ftp.d $e |- X e. _V $.
    ftp.e $e |- Y e. _V $.
    ftp.f $e |- Z e. _V $.
    ftp.g $e |- A =/= B $.
    ftp.h $e |- A =/= C $.
    ftp.i $e |- B =/= C $.
    $( A function with a domain of three elements.  (Contributed by Stefan
       O'Rear, 17-Oct-2014.)  (Proof shortened by Alexander van der Vekens,
       23-Jan-2018.) $)
    ftp $p |- { <. A , X >. , <. B , Y >. , <. C , Z >. } : { A , B , C } -->
        { X , Y , Z } $=
      ( cvv wcel w3a wne ctp cop wf 3pm3.2i ftpg mp3an ) APQZBPQZCPQZRDPQZEPQZF
      PQZRABSZACSZBCSZRABCTDEFTADUABEUACFUATUBUFUGUHGHIUCUIUJUKJKLUCULUMUNMNOUC
      DEFPPPPPPABCUDUE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( A function restricted to a singleton.  (Contributed by NM,
       9-Oct-2004.) $)
    fnressn $p |- ( ( F Fn A /\ B e. A ) ->
                  ( F |` { B } ) = { <. B , ( F ` B ) >. } ) $=
      ( vx wcel wfn csn cres cfv cop wceq cv wi sneq reseq2d fveq2 opeq12 mpdan
      wa cvv sneqd eqeq12d imbi2d wss vex snss fnssres sylan2b wf fsn2 biantrur
      dffn2 fvres ax-mp opeq2i sneqi eqeq2i bitr3i 3bitri expcom vtoclga impcom
      fvex snid sylib ) BAECAFZCBGZHZBBCIZJZGZKZVFCDLZGZHZVMVMCIZJZGZKZMVFVLMDB
      AVMBKZVSVLVFVTVOVHVRVKVTVNVGCVMBNOVTVQVJVTVPVIKVQVJKVMBCPVMVPBVIQRUAUBUCV
      FVMAEZVSVFWASVOVNFZVSWAVFVNAUDWBVMADUEZUFAVNCUGUHWBVNTVOUIVMVOIZTEZVOVMWD
      JZGZKZSZVSVNVOULVMTVOWCUJWIWHVSWEWHVMVOVCUKWGVRVOWFVQWDVPVMVMVNEWDVPKVMWC
      VDVMVNCUMUNUOUPUQURUSVEUTVAVB $.

    $( A function restricted to a singleton.  (Contributed by Mario Carneiro,
       16-Nov-2014.) $)
    funressn $p |- ( Fun F -> ( F |` { B } ) C_ { <. B , ( F ` B ) >. } ) $=
      ( wfun cdm wcel csn cres cfv cop wss wceq wfn funfn fnressn sylanb eqimss
      wa syl wn c0 cin disjsn fnresdisj sylbi syl5bbr biimpa syl6eqss pm2.61dan
      wb 0ss ) BCZABDZEZBAFZGZAABHIFZJZUKUMQUOUPKZUQUKBULLZUMURBMZULABNOUOUPPRU
      KUMSZQUOTUPUKVAUOTKZVAULUNUATKZUKVBULAUBUKUSVCVBUIUTULUNBUCUDUEUFUPUJUGUH
      $.

    $( The value of a function restricted to a singleton.  (Contributed by NM,
       9-Oct-2004.) $)
    fressnfv $p |- ( ( F Fn A /\ B e. A ) ->
                 ( ( F |` { B } ) : { B } --> C <-> ( F ` B ) e. C ) ) $=
      ( vx wcel wfn csn cres wf cfv wb cv wi wceq sneq reseq2 syl wa cop eleq1d
      feq1d feq2 bitrd fveq2 bibi12d imbi2d fnressn vex snid fvres ax-mp opeq2i
      sneqi eqeq2i fsn2 eleq1i iba syl5rbbr syl5bb sylbir expcom vtoclga impcom
      ) BAFDAGZBHZCDVFIZJZBDKZCFZLZVEEMZHZCDVMIZJZVLDKZCFZLZNVEVKNEBAVLBOZVRVKV
      EVSVOVHVQVJVSVMVFOZVOVHLVLBPVTVOVMCVGJVHVTVMCVNVGVMVFDQUBVMVFCVGUCUDRVSVP
      VICVLBDUEUAUFUGVEVLAFZVRVEWASVNVLVPTZHZOZVRAVLDUHWDVNVLVLVNKZTZHZOZVRWGWC
      VNWFWBWEVPVLVLVMFWEVPOVLEUIZUJVLVMDUKULZUMUNUOVOWECFZWHSZWHVQVLCVNWIUPVQW
      KWHWLWEVPCWJUQWHWKURUSUTVARVBVCVD $.
  $}

  $( The value of a constant function.  (Contributed by NM, 30-May-1999.) $)
  fvconst $p |- ( ( F : A --> { B } /\ C e. A ) -> ( F ` C ) = B ) $=
    ( csn wf wcel wa cfv wceq ffvelrn elsni syl ) ABEZDFCAGHCDIZNGOBJANCDKOBLM
    $.

  ${
    $d x A $.  $d x B $.
    $( Express a singleton function in maps-to notation.  (Contributed by NM,
       6-Jun-2006.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.)  (Revised
       by Stefan O'Rear, 28-Feb-2015.) $)
    fmptsn $p |- ( ( A e. V /\ B e. W ) ->
        { <. A , B >. } = ( x e. { A } |-> B ) ) $=
      ( wcel wa csn cmpt cxp cop fconstmpt xpsng syl5reqr ) BDFCEFGABHZCIOCHJBC
      KHAOCLBCDEMN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x S $.
    fmptap.0a $e |- A e. _V $.
    fmptap.0b $e |- B e. _V $.
    fmptap.1 $e |- ( R u. { A } ) = S $.
    fmptap.2 $e |- ( x = A -> C = B ) $.
    $( Append an additional value to a function.  (Contributed by NM,
       6-Jun-2006.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    fmptap $p |- ( ( x e. R |-> C ) u. { <. A , B >. } ) = ( x e. S |-> C ) $=
      ( cmpt cop csn cun cvv wcel wceq fmptsn mp2an cv elsni syl mpteq2ia mptun
      eqtr4i uneq2i mpteq1 ax-mp 3eqtr2i ) AEDKZBCLMZNUJABMZDKZNAEULNZDKZAFDKZU
      KUMUJUKAULCKZUMBOPCOPUKUQQGHABCOORSAULDCATZULPURBQDCQURBUAJUBUCUEUFAEULDU
      DUNFQUOUPQIAUNFDUGUHUI $.
  $}

  $( The value of a restricted identity function.  (Contributed by NM,
     19-May-2004.) $)
  fvresi $p |- ( B e. A -> ( ( _I |` A ) ` B ) = B ) $=
    ( wcel cid cres cfv fvres fvi eqtrd ) BACBDAEFBDFBBADGBAHI $.

  $( Remove an ordered pair not participating in a function value.
     (Contributed by NM, 1-Oct-2013.)  (Revised by Mario Carneiro,
     28-May-2014.) $)
  fvunsn $p |- ( B =/= D
       -> ( ( A u. { <. B , C >. } ) ` D ) = ( A ` D ) ) $=
    ( wne cop csn cun cres cfv c0 wcel wceq syl cvv fvres fvprc eqtr4d pm2.61i
    wn resundir elsni necon3ai ressnop0 uneq2d un0 syl6eq syl5eq fveq1d 3eqtr3g
    snidg ) BDEZDABCFGZHZDGZIZJZDAUOIZJZDUNJZDAJZULDUPURULUPURUMUOIZHZURAUMUOUA
    ULVCURKHURULVBKURULBUOLZTVBKMVDBDBDUBUCBCUOUDNUEURUFUGUHUIDOLZUQUTMZVEDUOLZ
    VFDOUKZDUOUNPNVETZUQKUTDUPQDUNQRSVEUSVAMZVEVGVJVHDUOAPNVIUSKVADURQDAQRSUJ
    $.

  ${
    fvsn.1 $e |- A e. _V $.
    fvsn.2 $e |- B e. _V $.
    $( The value of a singleton of an ordered pair is the second member.
       (Contributed by NM, 12-Aug-1994.) $)
    fvsn $p |- ( { <. A , B >. } ` A ) = B $=
      ( cop csn wfun wcel cfv wceq funsn opex snid funopfv mp2 ) ABEZFZGPQHAQIB
      JABCDKPABLMABQNO $.
  $}

  ${
    $d A a b $.  $d B b $.
    $( The value of a singleton of an ordered pair is the second member.
       (Contributed by NM, 26-Oct-2012.) $)
    fvsng $p |- ( ( A e. V /\ B e. W ) -> ( { <. A , B >. } ` A ) = B ) $=
      ( va vb cv cop csn cfv opeq1 sneqd id fveq12d eqeq1d opeq2 fveq1d eqeq12d
      wceq vex fvsn vtocl2g ) EGZUCFGZHZIZJZUDSAAUDHZIZJZUDSAABHZIZJZBSEFABCDUC
      ASZUGUJUDUNUCAUFUIUNUEUHUCAUDKLUNMNOUDBSZUJUMUDBUOAUIULUOUHUKUDBAPLQUOMRU
      CUDETFTUAUB $.
  $}

  ${
    fvsnun.1 $e |- A e. _V $.
    fvsnun.2 $e |- B e. _V $.
    fvsnun.3 $e |- G = ( { <. A , B >. } u. ( F |` ( C \ { A } ) ) ) $.
    $( The value of a function with one of its ordered pairs replaced, at the
       replaced ordered pair.  See also ~ fvsnun2 .  (Contributed by NM,
       23-Sep-2007.) $)
    fvsnun1 $p |- ( G ` A ) = B $=
      ( csn cres cfv cop cdif cun c0 cin wceq eqtri ax-mp fvres reseq1i disjdif
      resundir incom resdisj uneq2i un0 fveq1i wcel snid fvsn 3eqtr3i ) AEAIZJZ
      KZAABLIZUMJZKZAEKZBAUNUQUNUPDCUMMZJZNZUMJZUQEVBUMHUAVCUQVAUMJZNZUQUPVAUMU
      CVEUQONUQVDOUQUTUMPZOQVDOQVFUMUTPOUTUMUDUMCUBRUTUMDUESUFUQUGRRRUHAUMUIZUO
      USQAFUJZAUMETSURAUPKZBVGURVIQVHAUMUPTSABFGUKRUL $.

    $( The value of a function with one of its ordered pairs replaced, at
       arguments other than the replaced one.  See also ~ fvsnun1 .
       (Contributed by NM, 23-Sep-2007.) $)
    fvsnun2 $p |- ( D e. ( C \ { A } ) -> ( G ` D ) = ( F ` D ) ) $=
      ( csn cdif wcel cres cfv cop cun c0 wceq 3eqtri fvres reseq1i cin disjdif
      resundir wfn wb fnsn fnresdisj ax-mp mpbi residm uneq12i uncom un0 fveq1i
      3eqtr3a ) DCAJZKZLDFURMZNDEURMZNDFNDENDUSUTUSABOJZUTPZURMVAURMZUTURMZPZUT
      FVBURIUAVAUTURUDVEQUTPUTQPUTVCQVDUTUQURUBQRZVCQRZUQCUCVAUQUEVFVGUFABGHUGU
      QURVAUHUIUJEURUKULQUTUMUTUNSSUODURFTDURETUP $.
  $}

  $( Split a function into a single point and all the rest.  (Contributed by
     Stefan O'Rear, 27-Feb-2015.) $)
  fnsnsplit $p |- ( ( F Fn A /\ X e. A ) ->
      F = ( ( F |` ( A \ { X } ) ) u. { <. X , ( F ` X ) >. } ) ) $=
    ( wfn wcel wa cres csn cdif cfv cop cun wceq fnresdm adantr resundi difsnid
    adantl reseq2d fnressn uneq2d 3eqtr3a eqtr3d ) BADZCAEZFZBAGZBBACHZIZGZCCBJ
    KHZLZUDUGBMUEABNOUFBUIUHLZGUJBUHGZLUGULBUIUHPUFUMABUEUMAMUDACQRSUFUNUKUJACB
    TUAUBUC $.

  $( Adjoining a point to a function gives a function.  (Contributed by Stefan
     O'Rear, 28-Feb-2015.) $)
  fsnunf $p |- ( ( F : S --> T /\ ( X e. V /\ -. X e. S ) /\ Y e. T ) ->
      ( F u. { <. X , Y >. } ) : ( S u. { X } ) --> T ) $=
    ( wf wcel wn wa w3a csn cun cop cin c0 wceq simp1 wf1o syl simp2l simp3 fun
    f1osng syl2anc f1of simp2r disjsn sylibr syl21anc wb snssi 3ad2ant3 ssequn2
    wss sylib feq3 mpbid ) ABCGZEDHZEAHIZJZFBHZKZAELZMZBFLZMZCEFNLZMZGZVFBVJGZV
    DUSVEVGVIGZAVEOPQZVKUSVBVCRVDVEVGVISZVMVDUTVCVOUSUTVAVCUAUSVBVCUBEFDBUDUEVE
    VGVIUFTVDVAVNUSUTVAVCUGAEUHUIAVEBVGCVIUCUJVDVHBQZVKVLUKVDVGBUOZVPVCUSVQVBFB
    ULUMVGBUNUPVHBVFVJUQTUR $.

  $( Adjoining a point to a punctured function gives a function.  (Contributed
     by Stefan O'Rear, 28-Feb-2015.) $)
  fsnunf2 $p |- ( ( F : ( S \ { X } ) --> T /\ X e. S /\ Y e. T ) ->
      ( F u. { <. X , Y >. } ) : S --> T ) $=
    ( csn cdif wf wcel w3a cun cop simp1 simp2 neldifsnd simp3 fsnunf syl121anc
    wn wceq difsnid 3ad2ant2 feq2d mpbid ) ADFZGZBCHZDAIZEBIZJZUFUEKZBCDELFKZHZ
    ABULHUJUGUHDUFISUIUMUGUHUIMUGUHUINUJDAOUGUHUIPUFBCADEQRUJUKABULUHUGUKATUIAD
    UAUBUCUD $.

  $( Recover the added point from a point-added function.  (Contributed by
     Stefan O'Rear, 28-Feb-2015.)  (Revised by NM, 18-May-2017.) $)
  fsnunfv $p |- ( ( X e. V /\ Y e. W /\ -. X e. dom F ) ->
      ( ( F u. { <. X , Y >. } ) ` X ) = Y ) $=
    ( wcel cdm wn w3a cop csn cun cres cfv c0 wceq cin dmres 3adant3 syl disjsn
    incom eqtri biimpri syl5eq 3ad2ant3 wb relres reldm0 ax-mp sylibr wfn fnsng
    wrel fnresdm uneq12d resundir uncom un0 eqtr2i 3eqtr4g snidg 3ad2ant1 fvres
    fveq1d fvsng 3eqtr3d ) DBFZECFZDAGZFHZIZDADEJKZLZDKZMZNZDVMNZDVNNZEVLDVPVMV
    LAVOMZVMVOMZLOVMLZVPVMVLVTOWAVMVLVTGZOPZVTOPZVKVHWDVIVKWCVJVOQZOWCVOVJQWFAV
    ORVOVJUBUCWFOPVKVJDUAUDUEUFVTUNWEWDUGAVOUHVTUIUJUKVLVMVOULZWAVMPVHVIWGVKDEB
    CUMSVOVMUOTUPAVMVOUQWBVMOLVMOVMURVMUSUTVAVEVLDVOFZVQVSPVHVIWHVKDBVBVCDVOVNV
    DTVHVIVREPVKDEBCVFSVG $.

  $( Recover the original function from a point-added function.  (Contributed
     by Stefan O'Rear, 28-Feb-2015.) $)
  fsnunres $p |- ( ( F Fn S /\ -. X e. S ) ->
      ( ( F u. { <. X , Y >. } ) |` S ) = F ) $=
    ( wfn wcel wn wa cres cop csn cun c0 fnresdm adantr ressnop0 adantl uneq12d
    wceq resundir un0 eqcomi 3eqtr4g ) BAEZCAFGZHZBAIZCDJKZAIZLBMLZBUHLAIBUFUGB
    UIMUDUGBSUEABNOUEUIMSUDCDAPQRBUHATUJBBUAUBUC $.

  ${
    fvpr1.1 $e |- A e. _V $.
    fvpr1.2 $e |- C e. _V $.
    $( The value of a function with a domain of two elements.  (Contributed by
       Jeff Madsen, 20-Jun-2010.) $)
    fvpr1 $p |- ( A =/= B -> ( { <. A , C >. , <. B , D >. } ` A ) = C ) $=
      ( wne cop cpr cfv csn df-pr fveq1i wceq necom fvunsn sylbi syl5eq fvsn
      cun syl6eq ) ABGZAACHZBDHZIZJZAUCKZJZCUBUFAUGUDKTZJZUHAUEUIUCUDLMUBBAGUJU
      HNABOUGBDAPQRACEFSUA $.
  $}

  ${
    fvpr2.1 $e |- B e. _V $.
    fvpr2.2 $e |- D e. _V $.
    $( The value of a function with a domain of two elements.  (Contributed by
       Jeff Madsen, 20-Jun-2010.) $)
    fvpr2 $p |- ( A =/= B -> ( { <. A , C >. , <. B , D >. } ` B ) = D ) $=
      ( wne cop cpr cfv prcom fveq1i wceq necom fvpr1 sylbi syl5eq ) ABGZBACHZB
      DHZIZJBTSIZJZDBUAUBSTKLRBAGUCDMABNBADCEFOPQ $.
  $}

  $( The value of a function with a domain of (at most) two elements.
     (Contributed by Alexander van der Vekens, 3-Dec-2017.) $)
  fvpr1g $p |- ( ( A e. V /\ C e. W /\ A =/= B )
                 -> ( { <. A , C >. , <. B , D >. } ` A ) = C ) $=
    ( wcel wne w3a cop cpr cfv csn wceq cun df-pr fveq1i necom fvunsn sylbi
    syl5eq 3ad2ant3 fvsng 3adant3 eqtrd ) AEGZCFGZABHZIAACJZBDJZKZLZAUIMZLZCUHU
    FULUNNUGUHULAUMUJMOZLZUNAUKUOUIUJPQUHBAHUPUNNABRUMBDASTUAUBUFUGUNCNUHACEFUC
    UDUE $.

  $( The value of a function with a domain of (at most) two elements.
     (Contributed by Alexander van der Vekens, 3-Dec-2017.) $)
  fvpr2g $p |- ( ( B e. V /\ D e. W /\ A =/= B )
                 -> ( { <. A , C >. , <. B , D >. } ` B ) = D ) $=
    ( wcel wne w3a cop cpr cfv csn wceq cun prcom df-pr eqtri fveq1i fvunsn
    syl5eq 3ad2ant3 fvsng 3adant3 eqtrd ) BEGZDFGZABHZIBACJZBDJZKZLZBUJMZLZDUHU
    FULUNNUGUHULBUMUIMOZLUNBUKUOUKUJUIKUOUIUJPUJUIQRSUMACBTUAUBUFUGUNDNUHBDEFUC
    UDUE $.

  ${
    fvtp1.1 $e |- A e. _V $.
    fvtp1.4 $e |- D e. _V $.
    $( The first value of a function with a domain of three elements.
       (Contributed by NM, 14-Sep-2011.) $)
    fvtp1 $p |- ( ( A =/= B /\ A =/= C )
             -> ( { <. A , D >. , <. B , E >. , <. C , F >. } ` A ) = D ) $=
      ( wne wa cop ctp cfv cpr csn cun df-tp fveq1i wceq necom fvunsn sylan9eqr
      sylbi fvpr1 syl5eq ) ABIZACIZJAADKZBEKZCFKZLZMAUHUINZUJOPZMZDAUKUMUHUIUJQ
      RUGUFUNAULMZDUGCAIUNUOSACTULCFAUAUCABDEGHUDUBUE $.
  $}

  ${
    fvtp2.1 $e |- B e. _V $.
    fvtp2.4 $e |- E e. _V $.
    $( The second value of a function with a domain of three elements.
       (Contributed by NM, 14-Sep-2011.) $)
    fvtp2 $p |- ( ( A =/= B /\ B =/= C )
             -> ( { <. A , D >. , <. B , E >. , <. C , F >. } ` B ) = E ) $=
      ( wne wa cop ctp cfv tprot fveq1i wceq necom fvtp1 ancoms sylanb syl5eq )
      ABIZBCIZJBADKZBEKZCFKZLZMBUEUFUDLZMZEBUGUHUDUEUFNOUBBAIZUCUIEPZABQUCUJUKB
      CAEFDGHRSTUA $.
  $}

  ${
    fvtp3.1 $e |- C e. _V $.
    fvtp3.4 $e |- F e. _V $.
    $( The third value of a function with a domain of three elements.
       (Contributed by NM, 14-Sep-2011.) $)
    fvtp3 $p |- ( ( A =/= C /\ B =/= C )
             -> ( { <. A , D >. , <. B , E >. , <. C , F >. } ` C ) = F ) $=
      ( wne wa cop ctp cfv tprot fveq1i wceq necom fvtp2 sylan2b ancoms syl5eq
      ) ACIZBCIZJCADKZBEKZCFKZLZMCUEUFUDLZMZFCUGUHUDUEUFNOUCUBUIFPZUBUCCAIUJACQ
      BCAEFDGHRSTUA $.
  $}

  $( The value of a function with a domain of (at most) three elements.
     (Contributed by Alexander van der Vekens, 4-Dec-2017.) $)
  fvtp1g $p |- ( ( ( A e. V /\ D e. W ) /\ ( A =/= B /\ A =/= C ) )
                -> ( { <. A , D >. , <. B , E >. , <. C , F >. } ` A ) = D ) $=
    ( wcel wa wne cop ctp cfv cpr csn cun df-tp fveq1i wceq necom fvunsn fvpr1g
    sylbi ad2antll 3expa adantrr eqtrd syl5eq ) AGIZDHIZJZABKZACKZJJZAADLZBELZC
    FLZMZNAUPUQOZURPQZNZDAUSVAUPUQURRSUOVBAUTNZDUNVBVCTZULUMUNCAKVDACUAUTCFAUBU
    DUEULUMVCDTZUNUJUKUMVEABDEGHUCUFUGUHUI $.

  $( The value of a function with a domain of (at most) three elements.
     (Contributed by Alexander van der Vekens, 4-Dec-2017.) $)
  fvtp2g $p |- ( ( ( B e. V /\ E e. W ) /\ ( A =/= B /\ B =/= C ) )
                -> ( { <. A , D >. , <. B , E >. , <. C , F >. } ` B ) = E ) $=
    ( wcel wa wne cop ctp cfv tprot fveq1i wceq wi necom fvtp1g expcom ancoms
    sylanb impcom syl5eq ) BGIEHIJZABKZBCKZJZJBADLZBELZCFLZMZNBUKULUJMZNZEBUMUN
    UJUKULOPUIUFUOEQZUGBAKZUHUFUPRZABSUHUQURUFUHUQJUPBCAEFDGHTUAUBUCUDUE $.

  $( The value of a function with a domain of (at most) three elements.
     (Contributed by Alexander van der Vekens, 4-Dec-2017.) $)
  fvtp3g $p |- ( ( ( C e. V /\ F e. W ) /\ ( A =/= C /\ B =/= C ) )
                -> ( { <. A , D >. , <. B , E >. , <. C , F >. } ` C ) = F ) $=
    ( wcel wa wne cop ctp cfv tprot fveq1i wceq wi necom fvtp2g expcom sylan2b
    ancoms impcom syl5eq ) CGIFHIJZACKZBCKZJZJCADLZBELZCFLZMZNCUKULUJMZNZFCUMUN
    UJUKULOPUIUFUOFQZUHUGUFUPRZUGUHCAKZUQACSUFUHURJUPBCAEFDGHTUAUBUCUDUE $.

  $( The value of a constant function.  (Contributed by NM, 20-Aug-2005.) $)
  fvconst2g $p |- ( ( B e. D /\ C e. A ) -> ( ( A X. { B } ) ` C ) = B ) $=
    ( wcel csn cxp wf cfv wceq fconstg fvconst sylan ) BDEABFZANGZHCAECOIBJABDK
    ABCOLM $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( A constant function expressed as a cross product.  (Contributed by NM,
       27-Nov-2007.) $)
    fconst2g $p |- ( B e. C -> ( F : A --> { B } <-> F = ( A X. { B } ) ) ) $=
      ( vx wcel csn wf cxp wceq wa cv cfv wral fvconst adantlr fvconst2g eqtr4d
      adantll wfn ralrimiva wb ffn fnconstg eqfnfv syl2an mpbird expcom fconstg
      feq1 syl5ibrcom impbid ) BCFZABGZDHZDAUNIZJZUOUMUQUOUMKZUQELZDMZUSUPMZJZE
      ANZURVBEAURUSAFZKUTBVAUOVDUTBJUMABUSDOPUMVDVABJUOABUSCQSRUAUODATUPATUQVCU
      BUMAUNDUCABCUDEADUPUEUFUGUHUMUOUQAUNUPHABCUIAUNDUPUJUKUL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    fvconst2.1 $e |- B e. _V $.
    $( The value of a constant function.  (Contributed by NM, 16-Apr-2005.) $)
    fvconst2 $p |- ( C e. A -> ( ( A X. { B } ) ` C ) = B ) $=
      ( cvv wcel csn cxp cfv wceq fvconst2g mpan ) BEFCAFCABGHIBJDABCEKL $.

    $( A constant function expressed as a cross product.  (Contributed by NM,
       20-Aug-1999.) $)
    fconst2 $p |- ( F : A --> { B } <-> F = ( A X. { B } ) ) $=
      ( cvv wcel csn wf cxp wceq wb fconst2g ax-mp ) BEFABGZCHCANIJKDABECLM $.
  $}

  $( Two ways to express that a function is constant.  (Contributed by NM,
     27-Nov-2007.) $)
  fconst5 $p |- ( ( F Fn A /\ A =/= (/) ) -> ( F = ( A X. { B } ) <->
                 ran F = { B } ) ) $=
    ( wfn c0 wne wa csn cxp wceq crn wi eqeq2d syl5ib adantl cvv adantrd adantr
    rneq wb rnxp wcel wf wfo df-fo fof sylbir fconst2g exp3a fnrel snprc relrn0
    wn wrel biimprd eqeq2 xpeq2 xp0 syl6eq 3imtr4d ex sylbi syl5 pm2.61i impbid
    ) CADZAEFZGZCABHZIZJZCKZVIJZVGVKVMLVFVKVLVJKZJVGVMCVJSVGVNVIVLAVIUAMNOBPUBZ
    VHVMVKLZLVOVFVPVGVOVFVMVKVFVMGZAVICUCZVOVKVQAVICUDVRAVICUEAVICUFUGABPCUHNUI
    QVOUMZVFVPVGVFCUNZVSVPACUJVSVIEJZVTVPLBUKWAVTVPWAVTGVLEJZCEJZVMVKVTWBWCLWAV
    TWCWBCULUOOWAVMWBTVTVIEVLUPRWAVKWCTVTWAVJECWAVJAEIEVIEAUQAURUSMRUTVAVBVCQVD
    VE $.

  ${
    $d F x $.  $d I x $.  $d J x $.
    fnpr.1 $e |- I e. _V $.
    fnpr.2 $e |- J e. _V $.
    $( Representation as a set of pairs of a function whose domain has two
       distinct elements.  (Contributed by FL, 26-Jun-2011.)  (Proof shortened
       by Scott Fenton, 12-Oct-2017.)  (Revised by NM, 10-Dec-2017.) $)
    fnpr $p |- ( I =/= J -> ( F Fn { I , J } <->
       F = { <. I , ( F ` I ) >. , <. J , ( F ` J ) >. } ) ) $=
      ( vx cpr wfn cfv cop wceq wa fvex adantl wcel adantr eqcomd fveq2 eqeq12d
      cdm wne cv wral fndm dmprop syl6eqr eleq2d wo elpr fvpr1 syl5ibrcom fvpr2
      jaod syl5bi sylbid ralrimiv wfun wb fnfun funpr eqfunfv syl2anr mpbir2and
      vex a1i df-fn sylanbrc fneq1 biimprd mpan9 impbida ) BCUAZABCGZHZABBAIZJC
      CAIZJGZKZVLVNLZVRATZVQTZKZFUBZAIZWCVQIZKZFVTUCZVNWBVLVNVTVMWAVMAUDZBVOCVP
      BAMZCAMZUEZUFNVSWFFVTVSWCVTOWCVMOZWFVSVTVMWCVNVTVMKVLWHNUGWLWCBKZWCCKZUHV
      SWFWCBCFVDUIVSWMWFWNVSWFWMVOBVQIZKVSWOVOVLWOVOKVNBCVOVPDWIUJPQWMWDVOWEWOW
      CBARWCBVQRSUKVSWFWNVPCVQIZKVSWPVPVLWPVPKVNBCVOVPEWJULPQWNWDVPWEWPWCCARWCC
      VQRSUKUMUNUOUPVNAUQVQUQZVRWBWGLURVLVMAUSBCVOVPDEWIWJUTZFAVQVAVBVCVLVQVMHZ
      VRVNVLWQWAVMKZWSWRWTVLWKVEVQVMVFVGVRVNWSVMAVQVHVIVJVK $.
  $}

  ${
    $d F x $.  $d I x $.  $d J x $.
    fnprOLD.1 $e |- I e. A $.
    fnprOLD.2 $e |- J e. B $.
    $( Representation as a set of pairs of a function whose domain has two
       distinct elements.  (Contributed by FL, 26-Jun-2011.)  (Proof shortened
       by Scott Fenton, 12-Oct-2017.)  Obsolete version of ~ fnpr as of
       10-Dec-2017.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    fnprOLD $p |- ( I =/= J -> ( F Fn { I , J } <->
       F = { <. I , ( F ` I ) >. , <. J , ( F ` J ) >. } ) ) $=
      ( vx cpr wfn cfv cop wceq wa cdm fvex adantl wcel elexi fveq2 wne cv wral
      fndm dmprop syl6eqr eleq2d wo elpr fvpr1 adantr eqcomd eqeq12d syl5ibrcom
      vex fvpr2 jaod syl5bi sylbid ralrimiv wfun wb fnfun funpr eqfunfv syl2anr
      mpbir2and a1i df-fn sylanbrc fneq1 biimprd mpan9 impbida ) DEUAZCDEIZJZCD
      DCKZLEECKZLIZMZVOVQNZWACOZVTOZMZHUBZCKZWFVTKZMZHWCUCZVQWEVOVQWCVPWDVPCUDZ
      DVREVSDCPZECPZUEZUFQWBWIHWCWBWFWCRWFVPRZWIWBWCVPWFVQWCVPMVOWKQUGWOWFDMZWF
      EMZUHWBWIWFDEHUOUIWBWPWIWQWBWIWPVRDVTKZMWBWRVRVOWRVRMVQDEVRVSDAFSZWLUJUKU
      LWPWGVRWHWRWFDCTWFDVTTUMUNWBWIWQVSEVTKZMWBWTVSVOWTVSMVQDEVRVSEBGSZWMUPUKU
      LWQWGVSWHWTWFECTWFEVTTUMUNUQURUSUTVQCVAVTVAZWAWEWJNVBVOVPCVCDEVRVSWSXAWLW
      MVDZHCVTVEVFVGVOVTVPJZWAVQVOXBWDVPMZXDXCXEVOWNVHVTVPVIVJWAVQXDVPCVTVKVLVM
      VN $.
  $}

  ${
    $d F a $.  $d V a $.  $d A a $.  $d B a $.  $d Z a $.
    $( Two ways to express restriction of a support set.  (Contributed by
       Stefan O'Rear, 5-Feb-2015.) $)
    fnsuppres $p |- ( ( F Fn ( A u. B ) /\ ( A i^i B ) = (/) /\ Z e. V ) ->
        ( ( `' F " ( _V \ { Z } ) ) C_ A <-> ( F |` B ) = ( B X. { Z } ) ) ) $=
      ( va cun wfn wceq wcel cfv crab wss wral wa wn wb a1i syl5bb syl2anc cres
      cin w3a wne csn cxp ccnv cvv cdif cima unss ssrab2 biantrur rabun2 sseq1i
      c0 cv 3bitr4ri wi rabss fvres adantl fvconst2g 3ad2antl3 eqeq12d id simp2
      nne minel syl2anr mtt syl 3bitr2rd ralbidva fnniniseg2 sseq1d simp1 ssun2
      3ad2ant1 fnssres fnconstg 3ad2ant3 eqfnfv 3bitr4d ) CABGZHZABUBUPIZEDJZUC
      ZFUQZCKZEUDZFWELZAMZWJCBUAZKZWJBEUEZUFZKZIZFBNZCUGUHWQUIUJZAMWOWRIZWNWLFB
      LZAMZWIXAWLFALZAMZXEOXFXDGZAMXEWNXFXDAUKXGXEWLFAULUMWMXHAWLFABUNUOURXEWLW
      JAJZUSZFBNWIXAWLFBAUTWIXJWTFBWIWJBJZOZWTWKEIZWLPZXJXLWPWKWSEXKWPWKIWIWJBC
      VAVBWHWFXKWSEIWGBEWJDVCVDVEXNXMQXLWKEVHRXLXIPZXNXJQXKXKWGXOWIXKVFWFWGWHVG
      WJBAVIVJXIWLVKVLVMVNSSWIXBWMAWFWGXBWMIWHFWEECVOVSVPWIWOBHZWRBHZXCXAQWIWFB
      WEMZXPWFWGWHVQXRWIBAVRRWEBCVTTWHWFXQWGBEDWAWBFBWOWRWCTWD $.

    $( The support of a function is empty iff it is identically zero.
       (Contributed by Stefan O'Rear, 22-Mar-2015.) $)
    fnsuppeq0 $p |- ( ( F Fn A /\ Z e. V ) ->
        ( ( `' F " ( _V \ { Z } ) ) = (/) <-> F = ( A X. { Z } ) ) ) $=
      ( wfn wcel wa ccnv cvv csn cdif cima c0 wceq cres cxp wss cun cin adantr
      ss0b un0 uncom eqtr3i fneq2i biimpi incom in0 eqtri a1i fnsuppres syl3anc
      wb simpr syl5bbr fnresdm eqeq1d bitrd ) BAEZDCFZGZBHIDJZKLZMNZBAOZAVBPZNZ
      BVFNVDVCMQZVAVGVCUAVABMARZEZMASZMNZUTVHVGUMUSVJUTUSVJAVIBAMRAVIAUBAMUCUDU
      EUFTVLVAVKAMSMMAUGAUHUIUJUSUTUNMABCDUKULUOVAVEBVFUSVEBNUTABUPTUQUR $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.
    $( A constant function expressed in terms of its functionality, domain, and
       value.  See also ~ fconst2 .  (Contributed by NM, 27-Aug-2004.) $)
    fconstfv $p |- ( F : A --> { B } <->
                   ( F Fn A /\ A. x e. A ( F ` x ) = B ) ) $=
      ( vy vz csn wf wfn cv cfv wceq wral wa syl6bb wcel wrex eqeq1d sylan9bbr
      c0 ffn fvconst ralrimiva jca wi fneq2 fn0 feq1 mpbiri syl6bi feq2 sylibrd
      adantrd wne crn fvelrnb fveq2 rspccva rexbidva r19.9rzv bicomd elsn eqcom
      f0 bitr2i eqrdv an32s exp31 imdistand wfo df-fo fof sylbir syl6 pm2.61ine
      impbii ) BCGZDHZDBIZAJZDKZCLZABMZNZVRVSWCBVQDUAVRWBABBCVTDUBUCUDWDVRUEBTB
      TLZVSVRWCWEVSTVQDHZVRWEVSDTLZWFWEVSDTIWGBTDUFDUGOWGWFTVQTHVQVDTVQDTUHUIUJ
      BTVQDUKULUMBTUNZWDVSDUOZVQLZNZVRWHVSWCWJWHVSWCWJWHWCVSWJWHWCNZVSNZEWIVQWM
      EJZWIPZCWNLZWNVQPZVSWOFJZDKZWNLZFBQZWLWPFBWNDUPWCXAWPFBQZWHWPWCWTWPFBWCWR
      BPNWSCWNWBWSCLAWRBVTWRLWAWSCVTWRDUQRURRUSWHWPXBWPFBUTVASSWQWNCLWPECVBWNCV
      CVEOVFVGVHVIWKBVQDVJVRBVQDVKBVQDVLVMVNVOVP $.

    $( Two ways to express a constant function.  (Contributed by NM,
       15-Mar-2007.) $)
    fconst3 $p |- ( F : A --> { B } <->
                  ( F Fn A /\ A C_ ( `' F " { B } ) ) ) $=
      ( vx csn wf wfn cv cfv wceq wral wa ccnv cima wss fconstfv wfun cdm fnfun
      wb fndm eqimss2 syl funconstss syl2anc pm5.32i bitri ) ABEZCFCAGZDHCIBJDA
      KZLUIACMUHNOZLDABCPUIUJUKUICQACRZOZUJUKTACSUIULAJUMACUAAULUBUCDABCUDUEUFU
      G $.
  $}

  $( Two ways to express a constant function.  (Contributed by NM,
     8-Mar-2007.) $)
  fconst4 $p |- ( F : A --> { B } <->
                ( F Fn A /\ ( `' F " { B } ) = A ) ) $=
    ( csn wf wfn ccnv cima wss wa wceq fconst3 cnvimass fndm syl5sseq biantrurd
    cdm eqss syl6bbr pm5.32i bitri ) ABDZCECAFZACGUBHZIZJUCUDAKZJABCLUCUEUFUCUE
    UDAIZUEJUFUCUGUEUCCQUDACUBMACNOPUDARSTUA $.

  ${
    $d x y A $.  $d x y B $.
    $( The restriction of a function to a set exists.  Compare Proposition 6.17
       of [TakeutiZaring] p. 28.  (Contributed by NM, 7-Apr-1995.)  (Revised by
       Mario Carneiro, 22-Jun-2013.) $)
    resfunexg $p |- ( ( Fun A /\ B e. C ) -> ( A |` B ) e. _V ) $=
      ( vx wfun wcel wa cres cdm cv cfv cop cmpt cima cvv crn wceq funres sylib
      wfn adantr funfn dffn5 fvex fnasrn syl6eq opex eqid dmmpti imaeq2i eqtr3i
      imadmrn syl6eqr funmpt dmresexg adantl funimaexg sylancr eqeltrd ) AEZBCF
      ZGZABHZDVCIZDJZVEVCKZLZMZVDNZOVBVCVHPZVIVBVCDVDVFMZVJVBVCVDTZVCVKQVBVCEZV
      LUTVMVABARUAVCUBSDVDVCUCSDVDVFVEVCUDUEUFVHVHIZNVIVJVNVDVHDVDVGVHVEVFUGVHU
      HUIUJVHULUKUMVBVHEVDOFZVIOFDVDVGUNVAVOUTABCUOUPVHVDOUQURUS $.
  $}

  $( The restriction of a function to a set exists.  Compare Proposition 6.17
     of [TakeutiZaring] p. 28.  This version has a shorter proof than
     ~ resfunexg but requires ~ ax-pow .  (Contributed by NM, 7-Apr-1995.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  resfunexgALT $p |- ( ( Fun A /\ B e. C ) -> ( A |` B ) e. _V ) $=
    ( wfun wcel cres cdm cvv crn cxp dmresexg adantl df-ima funimaexg syl5eqelr
    wa cima jca xpexg wss wrel relres relssdmrn ax-mp ssexg mpan 3syl ) ADZBCEZ
    PZABFZGZHEZUKIZHEZPULUNJZHEZUKHEZUJUMUOUIUMUHABCKLUJUNABQHABMABCNORULUNHHSU
    KUPTZUQURUKUAUSABUBUKUCUDUKUPHUEUFUG $.

  $( Existence of a composition when the first member is a function.
     (Contributed by NM, 8-Oct-2007.) $)
  cofunexg $p |- ( ( Fun A /\ B e. C ) -> ( A o. B ) e. _V ) $=
    ( wfun wcel wa ccom cdm crn cxp wss wrel relco relssdmrn ax-mp dmcoss ssexg
    cvv sylancr rnexg dmexg adantl cres rnco resfunexg sylan2 syl xpexg syl2anc
    syl5eqel ) ADZBCEZFZABGZUNHZUNIZJZKZUQREZUNREUNLURABMUNNOUMUOREZUPREUSULUTU
    KULUOBHZKVAREUTABPBCUAUOVARQSUBUMUPABIZUCZIZRABUDUMVCREZVDREULUKVBREVEBCTAV
    BRUEUFVCRTUGUJUOUPRRUHUIUNUQRQS $.

  $( Existence of a composition when the second member is one-to-one.
     (Contributed by NM, 8-Oct-2007.) $)
  cofunex2g $p |- ( ( A e. V /\ Fun `' B ) -> ( A o. B ) e. _V ) $=
    ( ccnv wfun wcel ccom cvv wa cnvexg cofunexg sylan2 cnvco cocnvcnv2 3eqtrri
    cocnvcnv1 syl5eqel syl ancoms ) BDZEZACFZABGZHFZUAUBITADZGZHFZUDUBUAUEHFUGA
    CJTUEHKLUGUCUFDZHUHUEDZTDGUIBGUCTUEMUIBNABPOUFHJQRS $.

  $( If the domain of a function is a set, the function is a set.  Theorem
     6.16(1) of [TakeutiZaring] p. 28.  This theorem is derived using the Axiom
     of Replacement in the form of ~ resfunexg .  See ~ fnexALT for alternate
     proof.  (Contributed by NM, 14-Aug-1994.)  (Proof shortened by Andrew
     Salmon, 17-Sep-2011.) $)
  fnex $p |- ( ( F Fn A /\ A e. B ) -> F e. _V ) $=
    ( wfn wcel wrel cdm cres cvv fnrel adantr wfun wceq eleq1a impcom resfunexg
    wa df-fn sylan2 anassrs sylanb resdm eleq1d biimpa syl2anc ) CADZABEZQCFZCC
    GZHZIEZCIEZUFUHUGACJKUFCLZUIAMZQUGUKCARUMUNUGUKUNUGQUMUIBEZUKUGUNUOABUINOCU
    IBPSTUAUHUKULUHUJCICUBUCUDUE $.

  $( If the domain of a function is a set, the function is a set.  Theorem
     6.16(1) of [TakeutiZaring] p. 28.  This theorem is derived using the Axiom
     of Replacement in the form of ~ funimaexg .  This version of ~ fnex uses
     ~ ax-pow , whereas ~ fnex does not.  (Contributed by NM, 14-Aug-1994.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  fnexALT $p |- ( ( F Fn A /\ A e. B ) -> F e. _V ) $=
    ( wfn wcel wa cdm crn cxp wss cvv fnrel relssdmrn syl adantr eleq1d biimpar
    wrel cima syl2anc fndm fnfun funimaexg sylan imadmrn imaeq2d syl5eqr syldan
    wfun xpexg ssexg ) CADZABEZFZCCGZCHZIZJZUQKEZCKEULURUMULCRURACLCMNOUNUOBEZU
    PKEZUSULUTUMULUOABACUAZPQULUMCASZKEZVAULCUIUMVDACUBCABUCUDULVAVDULUPVCKULUP
    CUOSVCCUEULUOACVBUFUGPQUHUOUPBKUJTCUQKUKT $.

  $( If the domain of a function exists, so the function.  Part of Theorem
     4.15(v) of [Monk1] p. 46.  This theorem is derived using the Axiom of
     Replacement in the form of ~ fnex .  (Note:  Any resemblance between
     F.U.N.E.X. and "Have You Any Eggs" is purely a coincidence originated by
     Swedish chefs.)  (Contributed by NM, 11-Nov-1995.) $)
  funex $p |- ( ( Fun F /\ dom F e. B ) -> F e. _V ) $=
    ( wfun cdm wfn wcel cvv funfn fnex sylanb ) BCBBDZEKAFBGFBHKABIJ $.

  ${
    $d x y A $.
    opabex.1 $e |- A e. _V $.
    opabex.2 $e |- ( x e. A -> E* y ph ) $.
    $( Existence of a function expressed as class of ordered pairs.
       (Contributed by NM, 21-Jul-1996.) $)
    opabex $p |- { <. x , y >. | ( x e. A /\ ph ) } e. _V $=
      ( cv wcel wa copab wfun cdm cvv wmo funopab moanimv mpbir mpgbir dmopabss
      wi ssexi funex mp2an ) BGDHZAIZBCJZKZUFLZMHUFMHUGUECNZBUEBCOUIUDACNTFUDAC
      PQRUHDEABCDSUAMUFUBUC $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( If the domain of a function given by maps-to notation is a set, the
       function is a set.  (Contributed by FL, 6-Jun-2011.)  (Revised by Mario
       Carneiro, 31-Aug-2015.) $)
    mptexg $p |- ( A e. V -> ( x e. A |-> B ) e. _V ) $=
      ( wcel cmpt wfun cdm cvv funmpt wss eqid dmmptss ssexg mpan funex sylancr
      ) BDEZABCFZGSHZIEZSIEABCJTBKRUAABCSSLMTBDNOISPQ $.
  $}

  ${
    $d x y A $.
    mptex.1 $e |- A e. _V $.
    $( If the domain of a function given by maps-to notation is a set, the
       function is a set.  (Contributed by NM, 22-Apr-2005.)  (Revised by Mario
       Carneiro, 20-Dec-2013.) $)
    mptex $p |- ( x e. A |-> B ) e. _V $=
      ( cvv wcel cmpt mptexg ax-mp ) BEFABCGEFDABCEHI $.
  $}

  $( If the domain of a function exists, so does its range.  Part of Theorem
     4.15(v) of [Monk1] p. 46.  This theorem is derived using the Axiom of
     Replacement in the form of ~ funex .  (Contributed by NM, 11-Nov-1995.) $)
  funrnex $p |- ( dom F e. B -> ( Fun F -> ran F e. _V ) ) $=
    ( wfun cdm wcel cvv crn funex ex rnexg syl6com ) BCZBDAEZBFEZBGFELMNABHIBFJ
    K $.

  ${
    $d ph w v $.  $d x y z w v $.
    $( A version of the Axiom of Replacement.  Normally ` ph ` would have free
       variables ` x ` and ` y ` .  Axiom 6 of [Kunen] p. 12.  The Separation
       Scheme ~ ax-sep cannot be derived from this version and must be stated
       as a separate axiom in an axiom system (such as Kunen's) that uses this
       version in place of our ~ ax-rep .  (Contributed by NM, 10-Oct-2003.) $)
    zfrep6 $p |- ( A. x e. z E! y ph -> E. w A. x e. z E. y e. w ph ) $=
      ( cv wral wcel wa cvv wrex wex wceq sylibr cab vex wi wal wmo 3imtr4i weu
      copab crn wfun crab euex ralimi rabid2 19.42v abbii dmopab df-rab 3eqtr4i
      cdm syl6reqr syl6eqel eumo imim2i moanimv alimi df-ral funopab sylc nfra1
      funrnex eleq2d cop opabid opelrn sylbir impac eximi abeq2i df-rex syl6bir
      ex ralrimi nfopab1 nfrn nfeq2 nfcv nfopab2 rexeqf ralbid spcegv ) ACUAZBD
      FZGZBFZWGHZAIZBCUBZUCZJHZACWMKZBWGGZACEFZKZBWGGZELWHWLUNZJHWLUDZWNWHWTWGJ
      WHWGACLZBWGUEZWTWHXBBWGGWGXCMWFXBBWGACUFUGXBBWGUHNWKCLZBOWJXBIZBOWTXCXDXE
      BWJACUIUJWKBCUKZXBBWGULUMUOZDPUPWJWFQZBRWKCSZBRWHXAXHXIBXHWJACSZQXIWFXJWJ
      ACUQURWJACUSNUTWFBWGVAWKBCVBTJWLVEVCWHWOBWGWFBWGVDWHWJWIWTHZWOWHWTWGWIXGV
      FXDCFZWMHZAIZCLXKWOWKXNCWJAXMWJAXMWKWIXLVGWLHXMWKBCVHWIXLWLBPCPVIVJVPVKVL
      XDBWTXFVMACWMVNTVOVQWSWPEWMJWQWMMWRWOBWGBWQWMBWLWKBCVRVSVTACWQWMCWQWACWLW
      KBCWBVSWCWDWEVC $.
  $}

  $( If the domain of a mapping is a set, the function is a set.  (Contributed
     by NM, 3-Oct-1999.) $)
  fex $p |- ( ( F : A --> B /\ A e. C ) -> F e. _V ) $=
    ( wf wfn wcel cvv ffn fnex sylan ) ABDEDAFACGDHGABDIACDJK $.

  $( If the domain of an onto function exists, so does its codomain.
     (Contributed by NM, 23-Jul-2004.) $)
  fornex $p |- ( A e. C -> ( F : A -onto-> B -> B e. _V ) ) $=
    ( wfo wcel cvv cdm crn wfun funrnex syl5com wf wceq fof fdm syl eleq1d forn
    fofun 3imtr3d com12 ) ABDEZACFZBGFZUCDHZCFZDIZGFZUDUEUCDJUGUIABDTCDKLUCUFAC
    UCABDMUFANABDOABDPQRUCUHBGABDSRUAUB $.

  $( If the codomain of a one-to-one function exists, so does its domain.  This
     theorem is equivalent to the Axiom of Replacement ~ ax-rep .  (Contributed
     by NM, 4-Sep-2004.) $)
  f1dmex $p |- ( ( F : A -1-1-> B /\ B e. C ) -> A e. _V ) $=
    ( wf1 wcel cvv crn wss wf f1f frn syl ssexg sylan ex ccnv wfo wf1o f1cnv
    f1ofo fornex syl5com syld imp ) ABDEZBCFZAGFZUFUGDHZGFZUHUFUGUJUFUIBIZUGUJU
    FABDJUKABDKABDLMUIBCNOPUFUIADQZRZUJUHUFUIAULSUMABDTUIAULUAMUIAGULUBUCUDUE
    $.

  ${
    $d f x y z A $.  $d f y z B $.
    eufnfv.1 $e |- A e. _V $.
    eufnfv.2 $e |- B e. _V $.
    $( A function is uniquely determined by its values.  (Contributed by NM,
       31-Aug-2011.) $)
    eufnfv $p |- E! f ( f Fn A /\ A. x e. A ( f ` x ) = B ) $=
      ( vz cv wfn cfv wceq wral wa weu wb wal wex cmpt mptex cvv eqeq2 pm4.71ri
      bibi2d albidv spcev eqid fnmpti fneq1 mpbiri dffn5 eqeq1 sylbi wcel rgenw
      fvex mpteqb ax-mp syl6bb pm5.32i bitr2i mpg df-eu mpbir ) DHZBIZAHZVDJZCK
      ABLZMZDNVIVDGHZKZOZDPZGQZVIVDABCRZKZOZVNDVMVQDPGVOABCESVJVOKZVLVQDVRVKVPV
      IVJVOVDUAUCUDUEVPVEVPMVIVPVEVPVEVOBIABCVOFVOUFUGBVDVOUHUIUBVEVPVHVEVPABVG
      RZVOKZVHVEVDVSKVPVTOABVDUJVDVSVOUKULVGTUMZABLVTVHOWAABVFVDUOUNABVGCTUPUQU
      RUSUTVAVIDGVBVC $.
  $}

  $( A function's value in a preimage belongs to the image.  (Contributed by
     NM, 23-Sep-2003.) $)
  funfvima $p |- ( ( Fun F /\ B e. dom F ) -> ( B e. A ->
                 ( F ` B ) e. ( F " A ) ) ) $=
    ( wfun cdm wcel wa cfv cima cres dmres elin2 crn funres fvelrn sylan eleq1d
    wi fvres df-ima eleq2i syl6rbbr syl5ibrcom ex syl5bir exp3a com12 pm2.43b
    imp3a ) CDZBCEZFZGBAFZBCHZCAIZFZUMUJULUMUPRZUJUMULUQRUJUMULUQUMULGBCAJZEZFZ
    UJUQBAUKUSCAKLUJUTUQUJUTGUPUMBURHZURMZFZUJURDUTVCACNBUROPUMVCUNVBFUPUMVAUNV
    BBACSQUOVBUNCATUAUBUCUDUEUFUGUIUH $.

  $( A function's value in an included preimage belongs to the image.
     (Contributed by NM, 3-Feb-1997.) $)
  funfvima2 $p |- ( ( Fun F /\ A C_ dom F ) -> ( B e. A ->
                  ( F ` B ) e. ( F " A ) ) ) $=
    ( wfun cdm wss wcel cfv cima wi ssel funfvima ex com23 a2d syl5 imp ) CDZAC
    EZFZBAGZBCHCAIGZJZTUABSGZJRUCASBKRUAUDUBRUDUAUBRUDUCABCLMNOPQ $.

  ${
    $d x A $.  $d x F $.  $d x G $.
    $( A class including a function contains the function's value in the image
       of the singleton of the argument.  (Contributed by NM, 23-Mar-2004.) $)
    funfvima3 $p |- ( ( Fun F /\ F C_ G ) -> ( A e. dom F ->
                    ( F ` A ) e. ( G " { A } ) ) ) $=
      ( vx wss wfun cdm wcel cfv csn cima wi wa cop funfvop ssel syl5 imp wb cv
      wceq sneq imaeq2d eleq2d opeq1 eleq1d vex elimasn vtoclbg ad2antll mpbird
      fvex exp32 impcom ) BCEZBFZABGZHZABIZCAJZKZHZLUOUPURVBUOUPURMZMVBAUSNZCHZ
      UOVCVEVCVDBHUOVEABOBCVDPQRURVBVESUOUPUSCDTZJZKZHVFUSNZCHVBVEDAUQVFAUAZVHV
      AUSVJVGUTCVFAUBUCUDVJVIVDCVFAUSUEUFCVFUSDUGABULUHUIUJUKUMUN $.
  $}

  $( The function value of an operand in a set is contained in the image of
     that set, using the ` Fn ` abbreviation.  (Contributed by Stefan O'Rear,
     10-Mar-2015.) $)
  fnfvima $p |- ( ( F Fn A /\ S C_ A /\ X e. S ) -> ( F ` X ) e. ( F " S ) ) $=
    ( wfn wss wcel w3a wfun cdm wa cima fnfun 3ad2ant1 simp2 wceq fndm sseqtr4d
    cfv jca simp3 funfvima2 sylc ) CAEZBAFZDBGZHZCIZBCJZFZKUFDCSCBLGUGUHUJUDUEU
    HUFACMNUGBAUIUDUEUFOUDUEUIAPUFACQNRTUDUEUFUABDCUBUC $.

  ${
    $d ph y $.  $d ps x $.  $d F x y $.  $d B x y $.  $d A x y $.
    rexima.x $e |- ( x = ( F ` y ) -> ( ph <-> ps ) ) $.
    $( Existential quantification under an image in terms of the base set.
       (Contributed by Stefan O'Rear, 21-Jan-2015.) $)
    rexima $p |- ( ( F Fn A /\ B C_ A ) ->
        ( E. x e. ( F " B ) ph <-> E. y e. B ps ) ) $=
      ( wfn wss wa cv cfv cima cvv wcel fvex a1i wceq wrex rexbii syl6bb adantl
      fvelimab eqcom wb rexxfr2d ) GEIFEJKZABCDDLZGMZGFNZFOUJOPUHUIFPKUIGQRUHCL
      ZUKPUJULSZDFTULUJSZDFTDEFULGUDUMUNDFUJULUEUAUBUNABUFUHHUCUG $.

    $( Universal quantification under an image in terms of the base set.
       (Contributed by Stefan O'Rear, 21-Jan-2015.) $)
    ralima $p |- ( ( F Fn A /\ B C_ A ) ->
        ( A. x e. ( F " B ) ph <-> A. y e. B ps ) ) $=
      ( wfn wss wa cv cfv cima cvv wcel fvex a1i wceq wrex rexbii syl6bb adantl
      fvelimab eqcom wb ralxfr2d ) GEIFEJKZABCDDLZGMZGFNZFOUJOPUHUIFPKUIGQRUHCL
      ZUKPUJULSZDFTULUJSZDFTDEFULGUDUMUNDFUJULUEUAUBUNABUFUHHUCUG $.
  $}

  ${
    $d A u x y $.  $d R u x y $.
    $( TODO:  This is the same as ~ issref (which has a much longer proof).
       Should we replace ~ issref with this one? - NM 9-May-2016.

       Two ways to state a relation is reflexive.  (Adapted from Tarski.)
       (Contributed by FL, 15-Jan-2012.)  (Proof shortened by Mario Carneiro,
       3-Nov-2015.)  (Proof modification is discouraged.) $)
    idref $p |- ( ( _I |` A ) C_ R <-> A. x e. A x R x ) $=
      ( cv cop wcel wral cmpt crn wss wbr cid cres wf eqid fmpt wfn opex fnmpti
      df-f mpbiran bitri df-br ralbii mptresid fnasrn eqtr3i sseq1i 3bitr4ri
      vex ) ADZUKEZCFZABGZABULHZIZCJZUKUKCKZABGLBMZCJUNBCUONZUQABCULUOUOOZPUTUO
      BQUQABULUOUKUKRVASBCUOTUAUBURUMABUKUKCUCUDUSUPCABUKHUSUPABUEABUKAUJUFUGUH
      UI $.
  $}

  ${
    $d x y F $.
    $( Upper bound for the class of values of a class.  (Contributed by NM,
       9-Nov-1995.) $)
    fvclss $p |- { y | E. x y = ( F ` x ) } C_ ( ran F u. { (/) } ) $=
      ( cv cfv wceq wex cab crn wcel c0 csn wo cun wn wne eqcom tz6.12i syl6ibr
      wbr syl5bi eximdv vex elrn com12 necon1bd elsn orrd ss2abi df-un sseqtr4i
      ) BDZADZCEZFZAGZBHULCIZJZULKLZJZMZBHUQUSNUPVABUPURUTUPUROULKFUTUPURULKULK
      PZUPURVBUPUMULCTZAGURVBUOVCAUOUNULFVBVCULUNQUMULCRUAUBAULCBUCUDSUEUFBKUGS
      UHUIBUQUSUJUK $.
  $}

  ${
    $d x y F $.
    fvclex.1 $e |- F e. _V $.
    $( Existence of the class of values of a set.  (Contributed by NM,
       9-Nov-1995.) $)
    fvclex $p |- { y | E. x y = ( F ` x ) } e. _V $=
      ( cv cfv wceq wex cab crn c0 csn cun rnex p0ex unex fvclss ssexi ) BEAECF
      GAHBICJZKLZMSTCDNOPABCQR $.
  $}

  ${
    $d x y z A $.  $d x y z F $.
    fvresex.1 $e |- A e. _V $.
    $( Existence of the class of values of a restricted class.  (Contributed by
       NM, 14-Nov-1995.)  (Revised by Mario Carneiro, 11-Sep-2015.) $)
    fvresex $p |- { y | E. x y = ( ( F |` A ) ` x ) } e. _V $=
      ( vz cv cfv cmpt wceq wex cab cres cvv wss ssv resmpt ax-mp fveq1i wcel
      vex fveq2 eqid fvex fvmpt eqtr3i eqeq2i exbii abbii mptex fvclex eqeltrri
      fveqres ) BGZAGZFCFGZDHZIZHZJZAKZBLUNUODCMHZJZAKZBLNVAVDBUTVCAUSVBUNUOFNU
      QIZCMZHZUSVBUOVFURCNOVFURJCPFNCUQQRSUOVEHUODHZJZVGVBJUONTVIAUAFUOUQVHNVEU
      PUODUBVEUCUODUDUERUOCVEDUMRUFUGUHUIABURFCUQEUJUKUL $.
  $}

  ${
    $d x y z w A $.  $d y z w B $.
    abrexex.1 $e |- A e. _V $.
    $( Existence of a class abstraction of existentially restricted sets. ` x `
       is normally a free-variable parameter in the class expression
       substituted for ` B ` , which can be thought of as ` B ( x ) ` .  This
       simple-looking theorem is actually quite powerful and appears to involve
       the Axiom of Replacement in an intrinsic way, as can be seen by tracing
       back through the path ~ mptexg , ~ funex , ~ fnex , ~ resfunexg , and
       ~ funimaexg .  See also ~ abrexex2 .  (Contributed by NM, 16-Oct-2003.)
       (Proof shortened by Mario Carneiro, 31-Aug-2015.) $)
    abrexex $p |- { y | E. x e. A y = B } e. _V $=
      ( cmpt crn cv wceq wrex cab cvv eqid rnmpt mptex rnex eqeltrri ) ACDFZGBH
      DIACJBKLABCDRRMNRACDEOPQ $.
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( Existence of a class abstraction of existentially restricted sets. ` x `
       is normally a free-variable parameter in ` B ` .  The antecedent assures
       us that ` A ` is a set.  (Contributed by NM, 3-Nov-2003.) $)
    abrexexg $p |- ( A e. V -> { y | E. x e. A y = B } e. _V ) $=
      ( wcel wceq wrex cab cmpt crn cvv eqid rnmpt mptexg rnexg syl syl5eqelr
      cv ) CEFZBSDGACHBIACDJZKZLABCDUAUAMNTUALFUBLFACDEOUALPQR $.
  $}

  ${
    $d w y z B $.  $d w x y z A $.
    elabrex.1 $e |- B e. _V $.
    $( Elementhood in an image set.  (Contributed by Mario Carneiro,
       14-Jan-2014.) $)
    elabrex $p |- ( x e. A -> B e. { y | E. x e. A y = B } ) $=
      ( vz cv wcel csb wceq wrex cab wtru tru csbeq1a equcoms a1tru 2thd rspcev
      mpan2 eqeq1 rexbidv elab sylibr nfv nfcsb1v nfeq2 eqeq2d cbvrex syl6eleqr
      abbii ) AGZCHZDBGZAFGZDIZJZFCKZBLZUNDJZACKZBLUMDUPJZFCKZDUSHUMMVCNVBMFULC
      UOULJZVBMVBAFAUODOZPVDQRSTURVCBDEUTUQVBFCUNDUPUAUBUCUDVAURBUTUQAFCUTFUEAU
      NUPAUODUFUGULUOJDUPUNVEUHUIUKUJ $.
  $}

  ${
    $d A y z $.  $d B y z $.  $d C w $.  $d D y $.  $d w x y $.  $d w z y $.
    abrexco.1 $e |- B e. _V $.
    abrexco.2 $e |- ( y = B -> C = D ) $.
    $( Composition of two image maps ` C ( y ) ` and ` B ( w ) ` .
       (Contributed by NM, 27-May-2013.) $)
    abrexco $p |- { x | E. y e. { z | E. w e. A z = B } x = C } =
        { x | E. w e. A x = D } $=
      ( cv wceq wrex cab wa wex wcel df-rex bitr4i bitri vex eqeq1 rexbidv elab
      anbi1i r19.41v exbii rexcom4 eqeq2d ceqsexv rexbii abbii ) AKZGLZBCKZFLZD
      EMZCNZMZUMHLZDEMZAUSBKZFLZUNOZBPZDEMZVAUSVDDEMZBPZVFUSVBURQZUNOZBPVHUNBUR
      RVJVGBVJVCDEMZUNOVGVIVKUNUQVKCVBBUAUOVBLUPVCDEUOVBFUBUCUDUEVCUNDEUFSUGTVD
      DBEUHSVEUTDEUNUTBFIVCGHUMJUIUJUKTUL $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( The existence of an indexed union. ` x ` is normally a free-variable
       parameter in ` B ` .  (Contributed by NM, 23-Mar-2006.) $)
    iunexg $p |- ( ( A e. V /\ A. x e. A B e. W ) -> U_ x e. A B e. _V ) $=
      ( vy wcel wral ciun wceq wrex cab cuni cvv dfiun2g adantl abrexexg uniexg
      wa cv syl adantr eqeltrd ) BDGZCEGABHZSABCIZFTCJABKFLZMZNUEUFUHJUDAFBCEOP
      UDUHNGZUEUDUGNGUIAFBCDQUGNRUAUBUC $.
  $}

  ${
    $d A x y z $.  $d V x y z $.  $d W x y z $.  $d ph z $.
    $( Existence of an existentially restricted class abstraction.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    abrexex2g $p |- ( ( A e. V /\ A. x e. A { y | ph } e. W )
                                  -> { y | E. x e. A ph } e. _V ) $=
      ( vz wcel cab wral wa wrex cv cvv wsb nfv nfcv nfs1v nfrex weq cbvab ciun
      sbequ12 rexbidv df-clab rexbii eqtr4i df-iun iunexg syl5eqelr syl5eqel
      abbii ) DEHACIZFHBDJKZABDLZCIZGMUMHZBDLZGIZNUPACGOZBDLZGIUSUOVACGUOGPUTCB
      DCDQACGRSCGTAUTBDACGUCUDUAURVAGUQUTBDAGCUEUFULUGUNUSBDUMUBNBGDUMUHBDUMEFU
      IUJUK $.
  $}

  ${
    $d A x y v w z $.  $d ps v w z $.  $d ph x $.
    opabex3d.1 $e |- ( ph -> A e. _V ) $.
    opabex3d.2 $e |- ( ( ph /\ x e. A ) -> { y | ps } e. _V ) $.
    $( Existence of an ordered pair abstraction, deduction version.
       (Contributed by Alexander van der Vekens, 19-Oct-2017.) $)
    opabex3d $p |- ( ph -> { <. x , y >. | ( x e. A /\ ps ) } e. _V ) $=
      ( vz vv vw cv wcel wa cvv wex cop wceq an12 exbii bitri copab csn cab cxp
      ciun 19.42v elxp excom weq elsn anbi1i opeq1 eqeq2d anbi1d ceqsexv nfsab1
      vex nfv nfan opeq2 wsb wb sbequ12 equcoms df-clab syl6rbbr anbi12d 3bitri
      cbvex anbi2i 3bitr4ri wrex eliun df-rex elopab 3bitr4i eqriv wral sylancr
      snex xpexg ralrimiva iunexg syl2anc syl5eqelr ) ACKZELZBMZCDUAZCEWFUBZBDU
      CZUDZUEZNHWMWIWGHKZWLLZMZCOZWNWFDKZPZQZWHMZDOZCOWNWMLZWNWILWPXBCWGWTBMZMZ
      DOWGXDDOZMXBWPWGXDDUFXAXEDWTWGBRSWOXFWGWOWNIKZJKZPZQZXGWJLZXHWKLZMMZJOIOZ
      WNWFXHPZQZXLMZJOZXFIJWNWJWKUGXNXMIOZJOXRXMIJUHXSXQJXSICUIZXJXLMZMZIOXQXMY
      BIXMXKYAMYBXJXKXLRXKXTYAIWFUJUKTSYAXQIWFCUQXTXJXPXLXTXIXOWNXGWFXHULUMUNUO
      TSTXQXDJDXPXLDXPDURBDJUPUSXDJURJDUIZXPWTXLBYCXOWSWNXHWRWFUTUMYCBBDJVAZXLB
      YDVBDJBDJVCVDBJDVEVFVGVIVHVJVKSXCWOCEVLWQCWNEWLVMWOCEVNTWHCDWNVOVPVQAENLW
      LNLZCEVRWMNLFAYECEAWGMWJNLWKNLYEWFVTGWJWKNNWAVSWBCEWLNNWCWDWE $.
  $}

  ${
    $d A x y v w z $.  $d ph v w z $.
    opabex3.1 $e |- A e. _V $.
    opabex3.2 $e |- ( x e. A -> { y | ph } e. _V ) $.
    $( Existence of an ordered pair abstraction.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    opabex3 $p |- { <. x , y >. | ( x e. A /\ ph ) } e. _V $=
      ( vz vv vw cv wcel wa cvv wex cop wceq an12 exbii bitri eqeq2d ciun copab
      csn cab cxp 19.42v elxp excom elsn anbi1i vex opeq1 anbi1d ceqsexv nfsab1
      nfv nfan opeq2 wsb sbequ12 equcoms df-clab syl6rbbr anbi12d 3bitri anbi2i
      wb cbvex 3bitr4ri wrex eliun df-rex 3bitr4i eqriv wral snex xpexg sylancr
      elopab rgen iunexg mp2an eqeltrri ) BDBJZUCZACUDZUEZUAZWDDKZALZBCUBZMGWHW
      KWIGJZWGKZLZBNZWLWDCJZOZPZWJLZCNZBNWLWHKZWLWKKWNWTBWIWRALZLZCNWIXBCNZLWTW
      NWIXBCUFWSXCCWRWIAQRWMXDWIWMWLHJZIJZOZPZXEWEKZXFWFKZLLZINHNZWLWDXFOZPZXJL
      ZINZXDHIWLWEWFUGXLXKHNZINXPXKHIUHXQXOIXQXEWDPZXHXJLZLZHNXOXKXTHXKXIXSLXTX
      HXIXJQXIXRXSHWDUIUJSRXSXOHWDBUKXRXHXNXJXRXGXMWLXEWDXFULTUMUNSRSXOXBICXNXJ
      CXNCUPACIUOUQXBIUPXFWPPZXNWRXJAYAXMWQWLXFWPWDURTYAAACIUSZXJAYBVGCIACIUTVA
      AICVBVCVDVHVEVFVIRXAWMBDVJWOBWLDWGVKWMBDVLSWJBCWLVSVMVNDMKWGMKZBDVOWHMKEY
      CBDWIWEMKWFMKYCWDVPFWEWFMMVQVRVTBDWGMMWAWBWC $.
  $}

  ${
    $d x A $.
    iunex.1 $e |- A e. _V $.
    iunex.2 $e |- B e. _V $.
    $( The existence of an indexed union. ` x ` is normally a free-variable
       parameter in the class expression substituted for ` B ` , which can be
       read informally as ` B ( x ) ` .  (Contributed by NM, 13-Oct-2003.) $)
    iunex $p |- U_ x e. A B e. _V $=
      ( cvv wcel wral ciun rgenw iunexg mp2an ) BFGCFGZABHABCIFGDMABEJABCFFKL
      $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d y z C $.
    $( The image of an indexed union is the indexed union of the images.
       (Contributed by Mario Carneiro, 18-Jun-2014.) $)
    imaiun $p |- ( A " U_ x e. B C ) = U_ x e. B ( A " C ) $=
      ( vy vz ciun cima cv wcel cop wa wex wrex rexcom4 vex elima3 rexbii eliun
      anbi1i r19.41v bitr4i exbii 3bitr4ri 3bitr4i eqriv ) EBACDGZHZACBDHZGZFIZ
      UGJZUKEIZKBJZLZFMZUMUIJZACNZUMUHJUMUJJUKDJZUNLZFMZACNUTACNZFMURUPUTAFCOUQ
      VAACFUMBDEPZQRUOVBFUOUSACNZUNLVBULVDUNAUKCDSTUSUNACUAUBUCUDFUMBUGVCQAUMCU
      ISUEUF $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The image of a union is the indexed union of the images.  Theorem 3K(a)
       of [Enderton] p. 50.  (Contributed by NM, 9-Aug-2004.)  (Proof shortened
       by Mario Carneiro, 18-Jun-2014.) $)
    imauni $p |- ( A " U. B ) = U_ x e. B ( A " x ) $=
      ( cuni cima cv ciun uniiun imaeq2i imaiun eqtri ) BCDZEBACAFZGZEACBMEGLNB
      ACHIABCMJK $.
  $}

  ${
    $d w x y z A $.  $d w x y z F $.
    $( The indexed union of a function's values is the union of its range.
       Compare Definition 5.4 of [Monk1] p. 50.  (Contributed by NM,
       27-Sep-2004.) $)
    fniunfv $p |- ( F Fn A -> U_ x e. A ( F ` x ) = U. ran F ) $=
      ( vy wfn crn cuni cv cfv wceq wrex cab ciun fnrnfv unieqd dfiun2 syl6reqr
      fvex ) CBEZCFZGDHAHZCIZJABKDLZGABUBMSTUCADBCNOADBUBUACRPQ $.

    $( The indexed union of a function's values is the union of its image under
       the index class.

       Note:  This theorem depends on the fact that our function value is the
       empty set outside of its domain.  If the antecedent is changed to
       ` F Fn A ` , the theorem can be proved without this dependency.
       (Contributed by NM, 26-Mar-2006.)  (Proof shortened by Mario Carneiro,
       31-Aug-2015.) $)
    funiunfv $p |- ( Fun F -> U_ x e. A ( F ` x ) = U. ( F " A ) ) $=
      ( wfun cres cdm cv cfv ciun crn cuni cima wfn wceq syl eqtri wcel iuneq2i
      cun c0 funres funfn sylib fniunfv cdif undif2 wss cin dmres inss1 eqsstri
      ssequn1 mpbi iuneq1 ax-mp iunxun wn eldifn ndmfv iun0 uneq2i un0 3eqtr3ri
      fvres df-ima unieqi 3eqtr4g ) CDZACBEZFZAGZVIHZIZVIJZKZABVKCHZIZCBLZKVHVI
      VJMZVMVONVHVIDVSBCUAVIUBUCAVJVIUDOAVJBVJUEZSZVLIZABVLIZVMVQWABNWBWCNWAVJB
      SZBVJBUFVJBUGWDBNVJBCFZUHBCBUIBWEUJUKVJBULUMPAWABVLUNUOWBVMAVTVLIZSZVMAVJ
      VTVLUPWGVMTSVMWFTVMWFAVTTITAVTVLTVKVTQVKVJQUQVLTNVKBVJURVKVIUSORAVTUTPVAV
      MVBPPABVLVPVKBCVDRVCVRVNCBVEVFVG $.
  $}

  ${
    $d x z A $.  $d y z F $.  $d x y $.
    funiunfvf.1 $e |- F/_ x F $.
    $( The indexed union of a function's values is the union of its image under
       the index class.  This version of ~ funiunfv uses a bound-variable
       hypothesis in place of a distinct variable condition.  (Contributed by
       NM, 26-Mar-2006.)  (Revised by David Abernethy, 15-Apr-2013.) $)
    funiunfvf $p |- ( Fun F -> U_ x e. A ( F ` x ) = U. ( F " A ) ) $=
      ( vz wfun cv cfv ciun cima cuni nfcv nffv fveq2 cbviun funiunfv syl5eqr )
      CFABAGZCHZIEBEGZCHZICBJKEABUASATCDATLMESLTRCNOEBCPQ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( Membership in the union of an image of a function.  (Contributed by NM,
       28-Sep-2006.) $)
    eluniima $p |- ( Fun F ->
                   ( B e. U. ( F " A ) <-> E. x e. A B e. ( F ` x ) ) ) $=
      ( cv cfv wcel wrex ciun wfun cima cuni eliun funiunfv eleq2d syl5rbbr ) C
      AEDFZGABHCABQIZGDJZCDBKLZGACBQMSRTCABDNOP $.

    $( Membership in the union of the range of a function.  See ~ elunirnALT
       for alternate proof.  (Contributed by NM, 24-Sep-2006.) $)
    elunirn $p |- ( Fun F ->
                     ( A e. U. ran F <-> E. x e. dom F A e. ( F ` x ) ) ) $=
      ( crn cuni wcel cdm cima wfun cv cfv wrex imadmrn unieqi eluniima syl5bbr
      eleq2i ) BCDZEZFBCCGZHZEZFCIBAJCKFATLUBSBUARCMNQATBCOP $.
  $}

  ${
    $d x A $.  $d x I $.  $d x F $.
    $( Membership in a union of some function-defined family of sets.
       (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    fnunirn $p |- ( F Fn I -> ( A e. U. ran F <->
        E. x e. I A e. ( F ` x ) ) ) $=
      ( wfn crn cuni wcel cv cfv cdm wrex wfun fnfun elunirn fndm rexeqdv bitrd
      wb syl ) CDEZBCFGHZBAICJHZACKZLZUCADLUACMUBUESDCNABCOTUAUCAUDDDCPQR $.
  $}

  ${
    $d x y A $.  $d x y F $.
    $( Membership in the union of the range of a function, proved directly.
       Unlike ~ elunirn , it doesn't appeal to ~ ndmfv (via ~ funiunfv ).
       (Contributed by NM, 24-Sep-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    elunirnALT $p |- ( Fun F -> ( A e. U. ran F <->
                E. x e. dom F A e. ( F ` x ) ) ) $=
      ( vy crn cuni wcel cv wa wex wfun cfv cdm wrex eluni wceq wfn funfn eleq2
      wb fvelrnb sylbi anbi2d r19.42v syl6bbr biimparc reximi syl6bi fvelrn a1d
      exlimdv ancld fvex eleq1 anbi12d spcev syl6 rexlimdva impbid syl5bb ) BCE
      ZFGBDHZGZVBVAGZIZDJZCKZBAHZCLZGZACMZNZDBVAOVGVFVLVGVEVLDVGVEVCVIVBPZIZAVK
      NZVLVGVEVCVMAVKNZIVOVGVDVPVCVGCVKQVDVPTCRAVKVBCUAUBUCVCVMAVKUDUEVNVJAVKVM
      VJVCVIVBBSUFUGUHUKVGVJVFAVKVGVHVKGIZVJVJVIVAGZIZVFVQVJVRVQVRVJVHCUIUJULVE
      VSDVIVHCUMVBVIPVCVJVDVRVBVIBSVBVIVAUNUOUPUQURUSUT $.
  $}

  ${
    $d x y z A $.  $d z ph $.
    abrexex2.1 $e |- A e. _V $.
    abrexex2.2 $e |- { y | ph } e. _V $.
    $( Existence of an existentially restricted class abstraction. ` ph ` is
       normally has free-variable parameters ` x ` and ` y ` .  See also
       ~ abrexex .  (Contributed by NM, 12-Sep-2004.) $)
    abrexex2 $p |- { y | E. x e. A ph } e. _V $=
      ( vz wrex cab cv wcel cvv wsb nfv nfcv nfs1v nfrex weq sbequ12 rexbidv
      cbvab df-clab rexbii abbii eqtr4i ciun df-iun iunex eqeltrri eqeltri ) AB
      DHZCIZGJACIZKZBDHZGIZLULACGMZBDHZGIUPUKURCGUKGNUQCBDCDOACGPQCGRAUQBDACGST
      UAUOURGUNUQBDAGCUBUCUDUEBDUMUFUPLBGDUMUGBDUMEFUHUIUJ $.

    $( Existence of a class abstraction with an existentially quantified
       expression.  Both ` x ` and ` y ` can be free in ` ph ` .  (Contributed
       by NM, 29-Jul-2006.) $)
    abexssex $p |- { y | E. x ( x C_ A /\ ph ) } e. _V $=
      ( cpw wrex cab cv wss wa wex cvv wcel df-rex elpw2 anbi1i exbii bitri
      abbii pwex abrexex2 eqeltrri ) ABDGZHZCIBJZDKZALZBMZCINUFUJCUFUGUEOZALZBM
      UJABUEPULUIBUKUHAUGDEQRSTUAABCUEDEUBFUCUD $.
  $}

  ${
    $d x y A $.
    abexex.1 $e |- A e. _V $.
    abexex.2 $e |- ( ph -> x e. A ) $.
    abexex.3 $e |- { y | ph } e. _V $.
    $( A condition where a class builder continues to exist after its wff is
       existentially quantified.  (Contributed by NM, 4-Mar-2007.) $)
    abexex $p |- { y | E. x ph } e. _V $=
      ( wrex cab wex cvv cv wcel wa df-rex pm4.71ri exbii bitr4i abbii abrexex2
      eqeltrri ) ABDHZCIABJZCIKUBUCCUBBLDMZANZBJUCABDOAUEBAUDFPQRSABCDEGTUA $.
  $}

  ${
    $d x y z A $.  $d z B $.  $d x y z F $.
    $( A one-to-one function in terms of function values.  Compare Theorem
       4.8(iv) of [Monk1] p. 43.  (Contributed by NM, 29-Oct-1996.) $)
    dff13 $p |- ( F : A -1-1-> B <-> ( F : A --> B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      ( vz cv wbr wal wa cfv wceq wi wral wb wcel vex breldm eleq2d bitri dff12
      wf1 wf wmo wfn ffn cdm fndm syl5ib anim12d pm4.71rd eqcom syl5bb bi2anan9
      fnbrfvb anandis pm5.32da bitr4d imbi1d impexp syl6bb albidv 19.21v 19.23v
      wex fvex eqvinc imbi1i bitr4i imbi2i 2albidv breq1 mo4 albii r2al 3bitr4g
      alrot3 syl pm5.32i ) CDEUBCDEUCZAGZFGZEHZAUDZFIZJVTWAEKZBGZEKZLZWAWGLZMZB
      CNACNZJAFCDEUAVTWEWLVTECUEZWEWLOCDEUFWMWCWGWBEHZJZWJMZFIZBIAIZWACPZWGCPZJ
      ZWKMZBIAIWEWLWMWQXBABWMWQXAWBWFLZWBWHLZJZWJMZMZFIZXBWMWPXGFWMWPXAXEJZWJMX
      GWMWOXIWJWMWOXAWOJXIWMWOXAWMWCWSWNWTWCWAEUGZPWMWSWAWBEAQFQZRWMXJCWACEUHZS
      UIWNWGXJPWMWTWGWBEBQXKRWMXJCWGXLSUIUJUKWMXAXEWOWMWSWTXEWOOWMWSJZXCWCWMWTJ
      ZXDWNXCWFWBLXMWCWBWFULCWAWBEUOUMXDWHWBLXNWNWBWHULCWGWBEUOUMUNUPUQURUSXAXE
      WJUTVAVBXHXAXFFIZMXBXAXFFVCXOWKXAXOXEFVEZWJMWKXEWJFVDWIXPWJFWFWHWAEVFVGVH
      VIVJTVAVKWEWPBIAIZFIWRWDXQFWCWNABWAWGWBEVLVMVNWPFABVQTWKABCCVOVPVRVST $.
  $}

  ${
    $d A c d $.  $d C c d $.  $d D d $.  $d F c d $.
    $( If the values of a one-to-one function for two arguments are equal, the
       arguments themselves must be equal.  (Contributed by Alexander van der
       Vekens, 12-Nov-2017.) $)
    f1veqaeq $p |- ( ( F : A -1-1-> B /\ ( C e. A /\ D e. A ) ) ->
                     ( ( F ` C ) = ( F ` D ) -> C = D ) ) $=
      ( vc vd wf1 wcel wa cfv wceq wi wf cv weq wral dff13 fveq2 imbi12d eqeq1d
      eqeq1 eqeq2d eqeq2 rspc2v com12 adantl sylbi imp ) ABEHZCAIDAIJZCEKZDEKZL
      ZCDLZMZUJABENZFOZEKZGOZEKZLZFGPZMZGAQFAQZJUKUPMZFGABERVEVFUQUKVEUPVDUPULV
      ALZCUTLZMFGCDAAURCLZVBVGVCVHVIUSULVAURCESUAURCUTUBTUTDLZVGUNVHUOVJVAUMULU
      TDESUCUTDCUDTUEUFUGUHUI $.
  $}

  ${
    $d x y w v A $.  $d w v B $.  $d z w v F $.  $d x y z $.
    dff13f.1 $e |- F/_ x F $.
    dff13f.2 $e |- F/_ y F $.
    $( A one-to-one function in terms of function values.  Compare Theorem
       4.8(iv) of [Monk1] p. 43.  (Contributed by NM, 31-Jul-2003.) $)
    dff13f $p |- ( F : A -1-1-> B <-> ( F : A --> B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      ( vw vv cv cfv wceq weq wi wral wa nfcv nffv nfeq nfv wf dff13 nfim fveq2
      eqeq2d equequ2 imbi12d cbvral ralbii nfral eqeq1d equequ1 ralbidv anbi2i
      wf1 bitri ) CDEUOCDEUAZHJZEKZIJZEKZLZHIMZNZICOZHCOZPUQAJZEKZBJZEKZLZABMZN
      ZBCOZACOZPHICDEUBVFVOUQVFUSVJLZHBMZNZBCOZHCOVOVEVSHCVDVRIBCVBVCBBUSVABURE
      GBURQRBUTEGBUTQRSVCBTUCVRITIBMZVBVPVCVQVTVAVJUSUTVIEUDUEIBHUFUGUHUIVSVNHA
      CVRABCACQVPVQAAUSVJAUREFAURQRAVIEFAVIQRSVQATUCUJVNHTHAMZVRVMBCWAVPVKVQVLW
      AUSVHVJURVGEUDUKHABULUGUMUHUPUNUP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d y F $.
    f1mpt.1 $e |- F = ( x e. A |-> C ) $.
    f1mpt.2 $e |- ( x = y -> C = D ) $.
    $( Express injection for a mapping operation.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    f1mpt $p |- ( F : A -1-1-> B <->
      ( A. x e. A C e. B /\ A. x e. A A. y e. A ( C = D -> x = y ) ) ) $=
      ( wf1 wf cv cfv wceq wi wral wa wcel wb ralbi nfmpt1 nfcxfr dff13f anbi1i
      cmpt nfcv fmpt eleq1d raaanv fvmpt2 fvmptg eqeqan12d an4s imbi1d ralimdva
      cbvralv ex syl6 ralimia syl sylbir sylan2b anidms pm5.32i 3bitr2i ) CDGJC
      DGKZALZGMZBLZGMZNZVGVINZOZBCPZACPZQEDRZACPZVOQVQEFNZVLOZBCPZACPZQABCDGAGA
      CEUEHACEUAUBBGUFUCVQVFVOACDEGHUGUDVQVOWAVQVOWASZVQVQFDRZBCPZWBVPWCABCVLEF
      DIUHUPVQWDQVPWCQZBCPZACPZWBVPWCABCUIWGVNVTSZACPWBWFWHACVGCRZWFVMVSSZBCPWH
      WIWEWJBCWIVICRZQZWEWJWLWEQVKVRVLWIVPWKWCVKVRSWIVPQWKWCQVHEVJFACEDGHUJAVIE
      FCDGIHUKULUMUNUQUOVMVSBCTURUSVNVTACTUTVAVBVCVDVE $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y F $.
    $( Equality of function values for a one-to-one function.  (Contributed by
       NM, 11-Feb-1997.) $)
    f1fveq $p |- ( ( F : A -1-1-> B /\ ( C e. A /\ D e. A ) ) ->
                 ( ( F ` C ) = ( F ` D ) <-> C = D ) ) $=
      ( wf1 wcel wa cfv wceq f1veqaeq fveq2 impbid1 ) ABEFCAGDAGHHCEIDEIJCDJABC
      DEKCDELM $.
  $}

  ${
    $d F z $.  $d A z $.  $d Y z $.  $d X z $.  $d B z $.
    $( Membership in the image of a 1-1 map.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    f1elima $p |- ( ( F : A -1-1-> B /\ X e. A /\ Y C_ A )
                                -> ( ( F ` X ) e. ( F " Y ) <-> X e. Y ) ) $=
      ( vz wf1 wcel wss w3a cfv cima cv wceq wrex wb wfn wi wa anassrs fvelimab
      f1fn sylan 3adant2 ssel impac f1fveq ancom2s biimpd biimpcd sylan9 anasss
      eleq1 sylan2 rexlimdva 3impa eqid fveq2 eqeq1d rspcev mpan2 impbid1 bitrd
      ) ABCGZDAHZEAIZJZDCKZCELHZFMZCKZVHNZFEOZDEHZVDVFVIVMPZVEVDCAQVFVOABCUBFAE
      VHCUAUCUDVGVMVNVDVEVFVMVNRVDVESZVFSVLVNFEVPVFVJEHZVLVNRZVFVQSVPVJAHZVQSVR
      VFVQVSEAVJUEUFVPVSVQVRVPVSSVLVJDNZVQVNVDVEVSVLVTRVDVEVSSSVLVTVDVSVEVLVTPA
      BVJDCUGUHUITVTVQVNVJDEUMUJUKULUNTUOUPVNVHVHNZVMVHUQVLWAFDEVTVKVHVHVJDCURU
      SUTVAVBVC $.
  $}

  ${
    $d F a b $.  $d A a b $.  $d B a b $.  $d C a b $.  $d D a b $.
    $( Taking images under a one-to-one function preserves subsets.
       (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    f1imass $p |- ( ( F : A -1-1-> B /\ ( C C_ A /\ D C_ A ) ) ->
      ( ( F " C ) C_ ( F " D ) <-> C C_ D ) ) $=
      ( va wf1 wss wa cima cv wcel wi simplrl sseld wb 3expa f1elima syl3anc ex
      simplr simplll simpr simp1rl simp1rr 3imtr3d pm2.43d ssrdv imass2 impbid1
      cfv syld ) ABEGZCAHZDAHZIZIZECJZEDJZHZCDHZUQUTVAUQUTIZFCDVBFKZCLZVCDLZVBV
      DVCALZVDVEMZVBCAVCUMUNUOUTNOVBVFVGVBVFIZVCEUKZURLZVIUSLZVDVEVHURUSVIUQUTV
      FUAOVHUMVFUNVJVDPUMUPUTVFUBZVBVFUCZUQUTVFUNUNUOUMUTVFUDQABEVCCRSVHUMVFUOV
      KVEPVLVMUQUTVFUOUNUOUMUTVFUEQABEVCDRSUFTULUGUHTCDEUIUJ $.

    $( Taking images under a one-to-one function preserves equality.
       (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    f1imaeq $p |- ( ( F : A -1-1-> B /\ ( C C_ A /\ D C_ A ) ) ->
      ( ( F " C ) = ( F " D ) <-> C = D ) ) $=
      ( wf1 wss wa cima wceq f1imass wb ancom2s anbi12d eqss 3bitr4g ) ABEFZCAG
      ZDAGZHHZECIZEDIZGZUBUAGZHCDGZDCGZHUAUBJCDJTUCUEUDUFABCDEKQSRUDUFLABDCEKMN
      UAUBOCDOP $.

    $( Taking images under a one-to-one function preserves proper subsets.
       (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    f1imapss $p |- ( ( F : A -1-1-> B /\ ( C C_ A /\ D C_ A ) ) ->
      ( ( F " C ) C. ( F " D ) <-> C C. D ) ) $=
      ( wf1 wss wa cima wceq wpss f1imass f1imaeq notbid anbi12d dfpss2 3bitr4g
      wn ) ABEFCAGDAGHHZECIZEDIZGZTUAJZRZHCDGZCDJZRZHTUAKCDKSUBUEUDUGABCDELSUCU
      FABCDEMNOTUAPCDPQ $.
  $}

  ${
    $d x y A $.  $d x y F $.
    $( A one-to-one onto function in terms of function values.  (Contributed by
       NM, 29-Mar-2008.) $)
    dff1o6 $p |- ( F : A -1-1-onto-> B <-> ( F Fn A /\ ran F = B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) $=
      ( wf1o wf1 wfo wa wf cv cfv wceq wi wral wfn crn w3a df-f1o dff13 anbi12i
      df-fo df-3an wss eqimss anim2i df-f sylibr pm4.71ri anbi1i 3bitrri 3bitri
      an32 ) CDEFCDEGZCDEHZICDEJZAKZELBKZELMUQURMNBCOACOZIZECPZEQZDMZIZIZVAVCUS
      RZCDESUNUTUOVDABCDETCDEUBUAVFVDUSIUPVDIZUSIVEVAVCUSUCVDVGUSVDUPVDVAVBDUDZ
      IUPVCVHVAVBDUEUFCDEUGUHUIUJUPVDUSUMUKUL $.
  $}

  $( The converse value of the value of a one-to-one onto function.
     (Contributed by NM, 20-May-2004.) $)
  f1ocnvfv1 $p |- ( ( F : A -1-1-onto-> B /\ C e. A ) ->
                 ( `' F ` ( F ` C ) ) = C ) $=
    ( wf1o wcel wa ccnv ccom cfv cid cres wceq f1ococnv1 fveq1d adantr wf fvco3
    f1of sylan fvresi adantl 3eqtr3d ) ABDEZCAFZGCDHZDIZJZCKALZJZCDJUFJZCUDUHUJ
    MUEUDCUGUIABDNOPUDABDQUEUHUKMABDSABCUFDRTUEUJCMUDACUAUBUC $.

  $( The value of the converse value of a one-to-one onto function.
     (Contributed by NM, 20-May-2004.) $)
  f1ocnvfv2 $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                 ( F ` ( `' F ` C ) ) = C ) $=
    ( wf1o wcel ccnv ccom cfv cid cres wceq f1ococnv2 fveq1d adantr f1ocnv f1of
    wa wf syl fvco3 sylan fvresi adantl 3eqtr3d ) ABDEZCBFZRCDDGZHZIZCJBKZIZCUH
    IDIZCUFUJULLUGUFCUIUKABDMNOUFBAUHSZUGUJUMLUFBAUHEUNABDPBAUHQTBACDUHUAUBUGUL
    CLUFBCUCUDUE $.

  $( Relationship between the value of a one-to-one onto function and the value
     of its converse.  (Contributed by Raph Levien, 10-Apr-2004.) $)
  f1ocnvfv $p |- ( ( F : A -1-1-onto-> B /\ C e. A ) ->
                  ( ( F ` C ) = D -> ( `' F ` D ) = C ) ) $=
    ( cfv wceq ccnv wf1o wcel wa fveq2 eqcoms f1ocnvfv1 eqeq2d syl5ib ) CEFZDGD
    EHZFZQRFZGZABEICAJKZSCGUADQDQRLMUBTCSABCENOP $.

  $( Relationship between the value of a one-to-one onto function and the value
     of its converse.  (Contributed by NM, 20-May-2004.) $)
  f1ocnvfvb $p |- ( ( F : A -1-1-onto-> B /\ C e. A /\ D e. B ) ->
                  ( ( F ` C ) = D <-> ( `' F ` D ) = C ) ) $=
    ( wf1o wcel w3a cfv wceq ccnv wi f1ocnvfv 3adant3 wa fveq2 eqcoms f1ocnvfv2
    eqeq2d syl5ib 3adant2 impbid ) ABEFZCAGZDBGZHCEIZDJZDEKIZCJZUCUDUGUILUEABCD
    EMNUCUEUIUGLUDUIUFUHEIZJZUCUEOZUGUKCUHCUHEPQULUJDUFABDERSTUAUB $.

  $( The value of the converse of a one-to-one onto function belongs to its
     domain.  (Contributed by NM, 26-May-2006.) $)
  f1ocnvdm $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                    ( `' F ` C ) e. A ) $=
    ( wf1o ccnv wf f1ocnv f1of syl ffvelrnda ) ABDEZBACDFZLBAMEBAMGABDHBAMIJK
    $.

  $( If the values of a one-to-one function for two arguments from the range of
     the function are equal, the arguments themselves must be equal.
     (Contributed by Alexander van der Vekens, 12-Nov-2017.) $)
  f1ocnvfvrneq $p |- ( ( F : A -1-1-> B /\ ( C e. ran F /\ D e. ran F ) ) ->
                  ( ( `' F ` C ) = ( `' F ` D ) -> C = D ) ) $=
    ( wf1 crn wcel wa ccnv cfv wceq wi wf1o f1f1orn f1ocnv f1of1 f1veqaeq 4syl
    ex imp ) ABEFZCEGZHDUCHIZCEJZKDUEKLCDLMZUBAUCENUCAUENUCAUEFZUDUFMABEOAUCEPU
    CAUEQUGUDUFUCACDUERTSUA $.

  ${
    $d A x y $.  $d B x y $.  $d F x y $.  $d R x y $.
    $( An application is injective if a retraction exists.  Proposition 8 of
       [BourbakiEns] p.  E.II.18.  (Contributed by FL, 11-Nov-2011.)  (Revised
       by Mario Carneiro, 27-Dec-2014.) $)
    fcof1 $p |- ( ( F : A --> B /\ ( R o. F ) = ( _I |` A ) )
         -> F : A -1-1-> B ) $=
      ( vx vy wf ccom wceq wa cfv wral wcel fvco3 syl2anc fveq1d 3eqtr3d fvresi
      cv syl cid cres wi wf1 simpl simprr fveq2d simpll simprll simprlr 3eqtr4d
      simplr expr ralrimivva dff13 sylanbrc ) ABDGZCDHZUAAUBZIZJZUQESZDKZFSZDKZ
      IZVBVDIZUCZFALEALABDUDUQUTUEVAVHEFAAVAVBAMZVDAMZJZVFVGVAVKVFJZJZVBUSKZVDU
      SKZVBVDVMVBURKZVDURKZVNVOVMVCCKZVECKZVPVQVMVCVECVAVKVFUFUGVMUQVIVPVRIUQUT
      VLUHZVAVIVJVFUIZABVBCDNOVMUQVJVQVSIVTVAVIVJVFUJZABVDCDNOUKVMVBURUSUQUTVLU
      LZPVMVDURUSWCPQVMVIVNVBIWAAVBRTVMVJVOVDIWBAVDRTQUMUNEFABDUOUP $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.  $d S x y $.
    $( An application is surjective if a section exists.  Proposition 8 of
       [BourbakiEns] p.  E.II.18.  (Contributed by FL, 17-Nov-2011.)  (Proof
       shortened by Mario Carneiro, 27-Dec-2014.) $)
    fcofo $p |- ( ( F : A --> B /\ S : B --> A /\ ( F o. S ) = ( _I |` B ) )
         -> F : A -onto-> B ) $=
      ( vy vx wf ccom cid cres wceq w3a cfv wrex wral wfo simp1 wcel 3ad2antl2
      cv ffvelrn simpl3 fveq1d fvco3 fvresi adantl 3eqtr3rd fveq2 eqeq2d rspcev
      wa syl2anc ralrimiva dffo3 sylanbrc ) ABDGZBACGZDCHZIBJZKZLZUPETZFTZDMZKZ
      FANZEBOABDPUPUQUTQVAVFEBVAVBBRZUKZVBCMZARZVBVIDMZKZVFUQUPVGVJUTBAVBCUASVH
      VBURMZVBUSMZVKVBVHVBURUSUPUQUTVGUBUCUQUPVGVMVKKUTBAVBDCUDSVGVNVBKVABVBUEU
      FUGVEVLFVIAVCVIKVDVKVBVCVIDUHUIUJULUMFEABDUNUO $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y F $.  $d y ph $.  $d x ps $.
    cbvfo.1 $e |- ( ( F ` x ) = y -> ( ph <-> ps ) ) $.
    $( Change bound variable between domain and range of function.
       (Contributed by NM, 23-Feb-1997.)  (Proof shortened by Mario Carneiro,
       21-Mar-2015.) $)
    cbvfo $p |- ( F : A -onto-> B -> ( A. x e. A ph <-> A. y e. B ps ) ) $=
      ( wfo crn wral wfn wb fofn cv cfv wceq bicomd eqcoms ralrn raleqdv bitr3d
      syl forn ) EFGIZBDGJZKZACEKZBDFKUEGELUGUHMEFGNBADCEGBAMCOGPZDOZUIUJQABHRS
      TUCUEBDUFFEFGUDUAUB $.

    $( Change bound variable between domain and range of function.
       (Contributed by NM, 23-Feb-1997.) $)
    cbvexfo $p |- ( F : A -onto-> B -> ( E. x e. A ph <-> E. y e. B ps ) ) $=
      ( wfo wn wral wrex cv cfv wceq notbid cbvfo dfrex2 3bitr4g ) EFGIZAJZCEKZ
      JBJZDFKZJACELBDFLTUBUDUAUCCDEFGCMGNDMOABHPQPACERBDFRS $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.  $d F x $.  $d H x $.  $d K x $.
    $( An injection is left-cancelable.  (Contributed by FL, 2-Aug-2009.)
       (Revised by Mario Carneiro, 21-Mar-2015.) $)
    cocan1 $p |- ( ( F : B -1-1-> C /\ H : A --> B /\ K : A --> B ) ->
      ( ( F o. H ) = ( F o. K ) <-> H = K ) ) $=
      ( vx wf ccom cfv wceq wral wcel fvco3 3ad2antl2 wb wfn ffn syl syl2anc cv
      wf1 wa 3ad2antl3 eqeq12d simpl1 ffvelrn f1fveq syl12anc ralbidva 3ad2ant1
      w3a bitrd f1f simp2 fnfco simp3 eqfnfv 3bitr4d ) BCDUBZABEHZABFHZULZGUAZD
      EIZJZVDDFIZJZKZGALZVDEJZVDFJZKZGALZVEVGKZEFKZVCVIVMGAVCVDAMZUCZVIVKDJZVLD
      JZKZVMVRVFVSVHVTVAUTVQVFVSKVBABVDDENOVBUTVQVHVTKVAABVDDFNUDUEVRUTVKBMZVLB
      MZWAVMPUTVAVBVQUFVAUTVQWBVBABVDEUGOVBUTVQWCVAABVDFUGUDBCVKVLDUHUIUMUJVCVE
      AQZVGAQZVOVJPVCDBQZVAWDVCBCDHZWFUTVAWGVBBCDUNUKBCDRSZUTVAVBUOZBADEUPTVCWF
      VBWEWHUTVAVBUQZBADFUPTGAVEVGURTVCEAQZFAQZVPVNPVCVAWKWIABERSVCVBWLWJABFRSG
      AEFURTUS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.  $d x y H $.  $d x y K $.
    $( A surjection is right-cancelable.  (Contributed by FL, 21-Nov-2011.)
       (Proof shortened by Mario Carneiro, 21-Mar-2015.) $)
    cocan2 $p |- ( ( F : A -onto-> B /\ H Fn B /\ K Fn B ) ->
      ( ( H o. F ) = ( K o. F ) <-> H = K ) ) $=
      ( vy vx wfn cv ccom cfv wceq wral 3ad2ant1 fvco3 sylan eqeq12d wb syl2anc
      fveq2 wfo w3a wcel wa fof ralbidva cbvfo bitrd simp2 fnfco eqfnfv 3bitr4d
      wf simp3 ) ABCUAZDBHZEBHZUBZFIZDCJZKZUSECJZKZLZFAMZGIZDKZVFEKZLZGBMZUTVBL
      ZDELZURVEUSCKZDKZVMEKZLZFAMZVJURVDVPFAURUSAUCZUDVAVNVCVOURABCUMZVRVAVNLUO
      UPVSUQABCUENZABUSDCOPURVSVRVCVOLVTABUSECOPQUFUOUPVQVJRUQVPVIFGABCVMVFLVNV
      GVOVHVMVFDTVMVFETQUGNUHURUTAHZVBAHZVKVERURUPVSWAUOUPUQUIZVTBADCUJSURUQVSW
      BUOUPUQUNZVTBAECUJSFAUTVBUKSURUPUQVLVJRWCWDGBDEUKSUL $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.  $d S x y $.
    $( Show that two functions are inverse to each other by computing their
       compositions.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    fcof1o $p |- ( ( ( F : A --> B /\ G : B --> A ) /\
      ( ( F o. G ) = ( _I |` B ) /\ ( G o. F ) = ( _I |` A ) ) ) ->
      ( F : A -1-1-onto-> B /\ `' F = G ) ) $=
      ( wf ccom cid cres wceq wf1o ccnv wf1 fcof1 ad2ant2rl fcofo 3expa adantrr
      wa wfo df-f1o sylanbrc simprl coeq2d coass f1ococnv1 fcoi2 ad2antlr eqtrd
      syl coeq1d syl5eqr f1ocnv f1of fcoi1 4syl 3eqtr3rd jca ) ABCEZBADEZRZCDFZ
      GBHZIZDCFGAHZIZRZRZABCJZCKZDIVGABCLZABCSZVHURVEVJUSVCABDCMNUTVCVKVEURUSVC
      VKABDCOPQABCTUAZVGVIVAFZVIVBFZDVIVGVAVBVIUTVCVEUBUCVGVMVICFZDFZDVICDUDVGV
      PVDDFZDVGVOVDDVGVHVOVDIVLABCUEUIUJUSVQDIURVFBADUFUGUHUKVGVHBAVIJBAVIEVNVI
      IVLABCULBAVIUMBAVIUNUOUPUQ $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d A x y $.  $d B x y $.
    $( Condition for function equality in terms of vanishing of the composition
       with the converse. _EDITORIAL_:  Is there a relation-algebraic proof of
       this?  (Contributed by Stefan O'Rear, 12-Feb-2015.) $)
    foeqcnvco $p |- ( ( F : A -onto-> B /\ G : A -onto-> B ) ->
        ( F = G <-> ( F o. `' G ) = ( _I |` B ) ) ) $=
      ( vx vy wfo wa wceq ccnv ccom adantr wfn fofn ad2antlr cv wcel cfv sylibr
      wbr cid wi fococnv2 cnveq coeq2d eqeq1d syl5ibcom ad2antrr wex cop adantl
      cres fnopfv sylan vex brcnv df-br bitri breq2 breq1 anbi12d spcev syl2anc
      fvex weq brco adantlr wb breq mpbid wf ffvelrnda resieq eqcomd eqfnfvd ex
      fof impbid ) ABCGZABDGZHZCDIZCDJZKZUABULZIZVSWBWFUBVTVSCCJZKZWEIWBWFABCUC
      WBWHWDWEWBWGWCCCDUDUEUFUGLWAWFWBWAWFHZEACDVSCAMZVTWFABCNZUHVTDAMZVSWFABDN
      ZOWIEPZAQZHZWNDRZWNCRZWPWQWRWETZWQWRIZWPWQWRWDTZWSWAWOXAWFWAWOHZWQFPZWCTZ
      XCWRCTZHZFUIZXAXBWQWNWCTZWNWRCTZXGXBWNWQUJDQZXHWAWLWOXJVTWLVSWMUKAWNDUMUN
      XHWNWQDTXJWQWNDWNDVDZEUOZUPWNWQDUQURSXBWNWRUJCQZXIWAWJWOXMVSWJVTWKLAWNCUM
      UNWNWRCUQSXFXHXIHFWNXLFEVEXDXHXEXIXCWNWQWCUSXCWNWRCUTVAVBVCFWQWRCWCXKWNCV
      DVFSVGWFXAWSVHWAWOWQWRWDWEVIOVJWAWOWSWTVHZWFXBWQBQWRBQXNWAABWNDVTABDVKVSA
      BDVQUKVLWAABWNCVSABCVKVTABCVQLVLBWQWRVMVCVGVJVNVOVPVR $.

    $( Condition for function equality in terms of vanishing of the composition
       with the inverse.  (Contributed by Stefan O'Rear, 12-Feb-2015.) $)
    f1eqcocnv $p |- ( ( F : A -1-1-> B /\ G : A -1-1-> B ) ->
        ( F = G <-> ( `' F o. G ) = ( _I |` A ) ) ) $=
      ( vx vy wf1 wa wceq ccom wi adantr wfn f1fn adantl cv wcel wbr wb syl cid
      ccnv cres f1cocnv1 coeq2 eqeq1d syl5ibcom equid resieq mpbiri anidms breq
      cfv ad2antlr mpbird wex cop wfun cdm fndm eleq2d biimpar funopfvb syl2anc
      fnfun bicomd df-br eqcom 3bitr4g biimpd syl6rbbr vex brcnv anim12d eximdv
      brco fvex eqvinc 3imtr4g adantlr mpd eqfnfvd eqcomd ex impbid ) ABCGZABDG
      ZHZCDIZCUBZDJZUAAUCZIZWFWIWMKWGWFWJCJZWLIWIWMABCUDWIWNWKWLCDWJUEUFUGLWHWM
      WIWHWMHZDCWOEADCWHDAMZWMWGWPWFABDNOZLWHCAMZWMWFWRWGABCNLZLWOEPZAQZHZWTWTW
      KRZWTDUMZWTCUMZIZXBXCWTWTWLRZXAXGWOXAXGXAXAHXGWTWTIEUHAWTWTUIUJUKOWMXCXGS
      WHXAWTWTWKWLULUNUOWHXAXCXFKWMWHXAHZWTFPZDRZXIWTWJRZHZFUPXIXDIZXIXEIZHZFUP
      XCXFXHXLXOFXHXJXMXKXNXHXJXMXHWTXIUQZDQZXDXIIZXJXMXHXRXQXHDURZWTDUSZQZXRXQ
      SWHXSXAWHWPXSWQADVETLWHYAXAWHXTAWTWHWPXTAIWQADUTTVAVBWTXIDVCVDVFWTXIDVGXI
      XDVHVIVJXHXKXNXHWTXICRZXEXIIZXKXNXHYCXPCQZYBXHCURZWTCUSZQZYCYDSWHYEXAWHWR
      YEWSACVETLWHYGXAWHYFAWTWHWRYFAIWSACUTTVAVBWTXICVCVDWTXICVGVKXIWTCFVLEVLZV
      MXIXEVHVIVJVNVOFWTWTWJDYHYHVPFXDXEWTDVQVRVSVTWAWBWCWDWE $.
  $}

  ${
    fveqf1o.1 $e |- G = ( F o. ( ( _I |` ( A \ { C , ( `' F ` D ) } ) ) u.
      { <. C , ( `' F ` D ) >. , <. ( `' F ` D ) , C >. } ) ) $.
    $( Given a bijection ` F ` , produce another bijection ` G ` which
       additionally maps two specified points.  (Contributed by Mario Carneiro,
       30-May-2015.) $)
    fveqf1o $p |- ( ( F : A -1-1-onto-> B /\ C e. A /\ D e. B ) ->
      ( G : A -1-1-onto-> B /\ ( G ` C ) = D ) ) $=
      ( wf1o wcel cfv wceq cpr cop cun cin a1i syl2anc wb syl eqtrd w3a ccnv c0
      cid cdif cres ccom simp1 f1oi simp2 wf f1of 3syl simp3 ffvelrnd f1oprswap
      f1ocnv incom disjdif eqtri f1oun syl22anc uncom prssi undif syl5eq f1oeq2
      wss sylib mpbid f1oeq3 f1oco f1oeq1 ax-mp sylibr fveq1i wfn fnresi prid1g
      fvco3 f1ofn fvun2 syl112anc wfun f1ofun opex prid1 funopfv ee10 f1ocnvfv2
      fveq2d jca ) ABEHZCAIZDBIZUAZABFHZCFJZDKWPABEUDACDEUBZJZLZUEZUFZCWTMZWTCM
      ZLZNZUGZHZWQWPWMAAXGHZXIWMWNWOUHZWPAXBXANZXGHZXJWPXLXLXGHZXMWPXBXBXCHZXAX
      AXFHZXBXAOZUCKZXRXNXOWPXBUIPWPWNWTAIZXPWMWNWOUJZWPBADWSWPWMBAWSHBAWSUKXKA
      BEUQBAWSULUMWMWNWOUNZUOZCWTAAUPQZXRWPXQXAXBOUCXBXAURXAAUSUTPZYDXBXBXAXAXC
      XFVAVBWPXLAKZXNXMRWPXLXAXBNZAXBXAVCWPXAAVHZYFAKWPWNXSYGXTYBCWTAVDQXAAVEVI
      VFZXLAXLXGVGSVJWPYEXMXJRYHXLAAXGVKSVJZAABEXGVLQFXHKWQXIRGABFXHVMVNVOWPWRC
      XGJZEJZDWPWRCXHJZYKCFXHGVPWPAAXGUKZWNYLYKKWPXJYMYIAAXGULSXTAACEXGVTQVFWPY
      KWTEJZDWPYJWTEWPYJCXFJZWTWPXCXBVQZXFXAVQZXRCXAIZYJYOKYPWPXBVRPWPXPYQYCXAX
      AXFWASYDWPWNYRXTCWTAVSSXBXAXCXFCWBWCWPXFWDZXDXFIYOWTKWPXPYSYCXAXAXFWESXDX
      ECWTWFWGCWTXFWHWITWKWPWMWOYNDKXKYAABDEWJQTTWL $.
  $}

  ${
    $d u v y z A $.  $d u v y z B $.  $d u v x z C $.  $d x y z R $.  $d x Y $.
    $d u v x z D $.  $d u v y z F $.  $d u v x y z ph $.  $d u v x y z X $.
    $d x y z S $.
    flift.1 $e |- F = ran ( x e. X |-> <. A , B >. ) $.
    flift.2 $e |- ( ( ph /\ x e. X ) -> A e. R ) $.
    flift.3 $e |- ( ( ph /\ x e. X ) -> B e. S ) $.
    $( ` F ` , a function lift, is a subset of ` R X. S ` .  (Contributed by
       Mario Carneiro, 23-Dec-2016.) $)
    fliftrel $p |- ( ph -> F C_ ( R X. S ) ) $=
      ( cop cmpt crn cxp wf wss cv wcel wa opelxpi syl2anc eqid fmptd syl5eqss
      frn syl ) AGBHCDLZMZNZEFOZIAHUKUIPUJUKQABHUHUKUIABRHSTCESDFSUHUKSJKCDEFUA
      UBUIUCUDHUKUIUFUGUE $.

    $( Elementhood in the relation ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    fliftel $p |- ( ph -> ( C F D <-> E. x e. X ( C = A /\ D = B ) ) ) $=
      ( wbr cop wceq wrex wa wcel cmpt crn df-br eleq2i eqid elrnmpti 3bitri cv
      opex wb opthg2 syl2anc rexbidva syl5bb ) EFINZEFOZCDOZPZBJQZAECPFDPRZBJQU
      NUOISUOBJUPTZUAZSUREFIUBIVAUOKUCBJUPUOUTUTUDCDUHUEUFAUQUSBJABUGJSRCGSDHSU
      QUSUILMEFCDGHUJUKULUM $.

    $( Elementhood in the relation ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    fliftel1 $p |- ( ( ph /\ x e. X ) -> A F B ) $=
      ( cv wcel wa cop wbr cmpt crn cvv opex eqid mpan2 adantl syl6eleqr sylibr
      elrnmpt1 df-br ) ABLHMZNZCDOZGMCDGPUIUJBHUJQZRZGUHUJULMZAUHUJSMUMCDTBHUJU
      KSUKUAUFUBUCIUDCDGUGUE $.

    $( Converse of the relation ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    fliftcnv $p |- ( ph -> `' F = ran ( x e. X |-> <. B , A >. ) ) $=
      ( vy vz wrel cop wa wceq cv wbr wcel ccnv cmpt crn cxp wss fliftrel relxp
      eqid relss ee10 relcnv jctil wrex fliftel vex brcnv rexbii 3bitr4g bitr4d
      ancom df-br 3bitr3g eqrelrdv2 mpancom ) GUAZNZBHDCOUBUCZNZPAVEVGQAVHVFAVG
      FEUDZUEVINVHABDCFEVGHVGUHZKJUFFEUGVGVIUIUJGUKULALMVEVGALRZMRZVESZVKVLVGSZ
      VKVLOZVETVOVGTAVMVKDQZVLCQZPZBHUMZVNAVLVKGSVQVPPZBHUMVMVSABCDVLVKEFGHIJKU
      NVKVLGLUOMUOUPVRVTBHVPVQUTUQURABDCVKVLFEVGHVJKJUNUSVKVLVEVAVKVLVGVAVBVCVD
      $.

    ${
      fliftfun.4 $e |- ( x = y -> A = C ) $.
      fliftfun.5 $e |- ( x = y -> B = D ) $.
      $( The function ` F ` is the unique function defined by ` F `` A = B ` ,
         provided that the well-definedness condition holds.  (Contributed by
         Mario Carneiro, 23-Dec-2016.) $)
      fliftfun $p |- ( ph -> ( Fun F <->
        A. x e. X A. y e. X ( A = C -> B = D ) ) ) $=
        ( wceq cv wa wrex vz vu vv wfun wi wral nfv cop cmpt nfmpt1 nfrn nfcxfr
        crn nffun wcel cfv fveq2 wbr simplr fliftel1 ad2ant2r sylc simprr eqidd
        funbrfv eqeq2d anbi12d rspcev syl12anc wb fliftel mpbird eqeq12d syl5ib
        anassrs ralrimiva exp31 ralrimd wal cbvrexv syl6bb biimpd reeanv r19.29
        ad2antrr eqtr2 imim1i imp simprlr simprrr 3eqtr4d rexlimivw syl syl5bir
        syl9 alrimdv wrel cxp wss fliftrel relxp relss ee10 dffun2 baib sylibrd
        ex impbid ) AJUDZDFQZEGQZUEZCKUFZBKUFZAXIXMBKABUGBJBJBKDEUHZUIZUMLBXPBK
        XOUJUKULUNAXIBRZKUOZXMAXISZXRSXLCKXSXRCRZKUOZXLXJDJUPZFJUPZQXSXRYASZSZX
        KDFJUQYEYBEYCGYEXIDEJURZYBEQAXIYDUSZAXRYFXIYAABDEHIJKLMNUTVADEJVEVBYEXI
        FGJURZYCGQYGYEYHFDQZGEQZSZBKTZYEYAFFQZGGQZYLXSXRYAVCYEFVDYEGVDYKYMYNSBX
        TKXQXTQZYIYMYJYNYODFFOVFYOEGGPVFVGVHVIAYHYLVJXIYDABDEFGHIJKLMNVKWEVLFGJ
        VEVBVMVNVOVPVQVRAXNUARZUBRZJURZYPUCRZJURZSZYQYSQZUEZUCVSZUBVSZUAVSZXIAX
        NUUEUAAXNUUDUBAXNUUCUCAUUAYPDQZYQEQZSZBKTZYPFQZYSGQZSZCKTZSZXNUUBAUUAUU
        OAYRUUJYTUUNABDEYPYQHIJKLMNVKAYTUUGYSEQZSZBKTUUNABDEYPYSHIJKLMNVKUUQUUM
        BCKYOUUGUUKUUPUULYODFYPOVFYOEGYSPVFVGVTWAVGWBUUOUUIUUMSZCKTZBKTZXNUUBUU
        IUUMBCKKWCXNUUTUUBXNUUTSXMUUSSZBKTUUBXMUUSBKWDUVAUUBBKUVAXLUURSZCKTUUBX
        LUURCKWDUVBUUBCKUVBEGYQYSXLUURXKUURXJXKUUGUUKXJUUHUULYPDFWFVAWGWHXLUUGU
        UHUUMWIXLUUIUUKUULWJWKWLWMWLWMXGWNWOWPWPWPAJWQZXIUUFVJAJHIWRZWSUVDWQUVC
        ABDEHIJKLMNWTHIXAJUVDXBXCXIUVCUUFUAUBUCJXDXEWMXFXH $.

      fliftfund.6 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ A = C ) ) -> B = D ) $.
      $( The function ` F ` is the unique function defined by ` F `` A = B ` ,
         provided that the well-definedness condition holds.  (Contributed by
         Mario Carneiro, 23-Dec-2016.) $)
      fliftfund $p |- ( ph -> Fun F ) $=
        ( wceq wral cv wfun wi wcel 3exp2 imp32 ralrimivva fliftfun mpbird ) AJ
        UADFRZEGRZUBZCKSBKSAUKBCKKABTKUCZCTKUCZUKAULUMUIUJQUDUEUFABCDEFGHIJKLMN
        OPUGUH $.
    $}

    $( The function ` F ` is the unique function defined by ` F `` A = B ` ,
       provided that the well-definedness condition holds.  (Contributed by
       Mario Carneiro, 23-Dec-2016.) $)
    fliftfuns $p |- ( ph -> ( Fun F <-> A. y e. X A. z e. X
      ( [_ y / x ]_ A = [_ z / x ]_ A -> [_ y / x ]_ B = [_ z / x ]_ B ) ) ) $=
      ( cv csb cop cmpt crn nfcsb1v wcel nfcv nfop csbeq1a opeq12d cbvmpt rneqi
      weq eqtri wral ralrimiva nfel1 eleq1d rspc mpan9 csbeq1 fliftfun ) ACDBCN
      ZEOZBUQFOZBDNZEOBUTFOGHIJIBJEFPZQZRCJURUSPZQZRKVBVDBCJVAVCCVAUABURUSBUQES
      ZBUQFSZUBBCUGZEURFUSBUQEUCZBUQFUCZUDUEUFUHAEGTZBJUIUQJTZURGTZAVJBJLUJVJVL
      BUQJBURGVEUKVGEURGVHULUMUNAFHTZBJUIVKUSHTZAVMBJMUJVMVNBUQJBUSHVFUKVGFUSHV
      IULUMUNBUQUTEUOBUQUTFUOUP $.

    $( The domain and range of the function ` F ` .  (Contributed by Mario
       Carneiro, 23-Dec-2016.) $)
    fliftf $p |- ( ph -> ( Fun F <-> F : ran ( x e. X |-> A ) --> S ) ) $=
      ( vy vz crn wa wss wceq cv wex wrex wfun cmpt wf wfn cdm simpr wbr cab wb
      fliftel exbidv adantr rexcom4 wcel elisset syl biantrud syl6rbbr rexbidva
      19.42v syl5bbr bitrd df-dm eqid rnmpt 3eqtr4g df-fn sylanbrc cxp fliftrel
      abbidv rnss rnxpss syl6ss df-f ex ffun impbid1 ) AGUAZBHCUBZNZFGUCZAVSWBA
      VSOZGWAUDZGNZFPWBWCVSGUEZWAQWDAVSUFWCLRZMRZGUGZMSZLUHWGCQZBHTZLUHWFWAWCWJ
      WLLWCWJWKWHDQZOZBHTZMSZWLAWJWPUIVSAWIWOMABCDWGWHEFGHIJKUJUKULWPWNMSZBHTZW
      CWLWNBMHUMAWRWLUIVSAWQWKBHABRHUNOZWKWKWMMSZOWQWSWTWKWSDFUNWTKMDFUOUPUQWKW
      MMUTURUSULVAVBVKLMGVCBLHCVTVTVDVEVFGWAVGVHWCWEEFVIZNZFWCGXAPZWEXBPAXCVSAB
      CDEFGHIJKVJULGXAVLUPEFVMVNWAFGVOVHVPWAFGVQVR $.

    fliftval.4 $e |- ( x = Y -> A = C ) $.
    fliftval.5 $e |- ( x = Y -> B = D ) $.
    fliftval.6 $e |- ( ph -> Fun F ) $.
    $( The value of the function ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    fliftval $p |- ( ( ph /\ Y e. X ) -> ( F ` C ) = D ) $=
      ( wa wceq adantr wcel wfun wbr cfv simpr eqidd anim12ci cv eqeq2d anbi12d
      wrex rspcev syl2anc wb fliftel mpbird funbrfv sylc ) AKJUAZRZIUBZEFIUCZEI
      UDFSAVAUSQTUTVBECSZFDSZRZBJUKZUTUSEESZFFSZRZVFAUSUEAVHUSVGAFUFUSEUFUGVEVI
      BKJBUHKSZVCVGVDVHVJCEEOUIVJDFFPUIUJULUMAVBVFUNUSABCDEFGHIJLMNUOTUPEFIUQUR
      $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y H $.  $d x y G $.
    $d x y R $.  $d x y S $.  $d x y T $.
    $( Equality theorem for isomorphisms.  (Contributed by NM, 17-May-2004.) $)
    isoeq1 $p |- ( H = G ->
          ( H Isom R , S ( A , B ) <-> G Isom R , S ( A , B ) ) ) $=
      ( vx vy wceq wf1o cv wbr cfv wb wral wa wiso f1oeq1 fveq1 df-isom breq12d
      bibi2d 2ralbidv anbi12d 3bitr4g ) FEIZABFJZGKZHKZCLZUHFMZUIFMZDLZNZHAOGAO
      ZPABEJZUJUHEMZUIEMZDLZNZHAOGAOZPABCDFQABCDEQUFUGUPUOVAABFERUFUNUTGHAAUFUM
      USUJUFUKUQULURDUHFESUIFESUAUBUCUDGHABCDFTGHABCDETUE $.

    $( Equality theorem for isomorphisms.  (Contributed by NM, 17-May-2004.) $)
    isoeq2 $p |- ( R = T ->
          ( H Isom R , S ( A , B ) <-> H Isom T , S ( A , B ) ) ) $=
      ( vx vy wceq wf1o cv wbr cfv wb wral wa wiso breq bibi1d df-isom 2ralbidv
      anbi2d 3bitr4g ) CEIZABFJZGKZHKZCLZUFFMUGFMDLZNZHAOGAOZPUEUFUGELZUINZHAOG
      AOZPABCDFQABEDFQUDUKUNUEUDUJUMGHAAUDUHULUIUFUGCERSUAUBGHABCDFTGHABEDFTUC
      $.

    $( Equality theorem for isomorphisms.  (Contributed by NM, 17-May-2004.) $)
    isoeq3 $p |- ( S = T ->
          ( H Isom R , S ( A , B ) <-> H Isom R , T ( A , B ) ) ) $=
      ( vx vy wceq wf1o cv wbr cfv wb wral wa wiso breq bibi2d df-isom 2ralbidv
      anbi2d 3bitr4g ) DEIZABFJZGKZHKZCLZUFFMZUGFMZDLZNZHAOGAOZPUEUHUIUJELZNZHA
      OGAOZPABCDFQABCEFQUDUMUPUEUDULUOGHAAUDUKUNUHUIUJDERSUAUBGHABCDFTGHABCEFTU
      C $.

    $( Equality theorem for isomorphisms.  (Contributed by NM, 17-May-2004.) $)
    isoeq4 $p |- ( A = C ->
          ( H Isom R , S ( A , B ) <-> H Isom R , S ( C , B ) ) ) $=
      ( vx vy wceq wf1o cv wbr cfv wb wral wa wiso f1oeq2 raleq df-isom anbi12d
      raleqbi1dv 3bitr4g ) ACIZABFJZGKZHKZDLUFFMUGFMELNZHAOZGAOZPCBFJZUHHCOZGCO
      ZPABDEFQCBDEFQUDUEUKUJUMACBFRUIULGACUHHACSUBUAGHABDEFTGHCBDEFTUC $.

    $( Equality theorem for isomorphisms.  (Contributed by NM, 17-May-2004.) $)
    isoeq5 $p |- ( B = C ->
          ( H Isom R , S ( A , B ) <-> H Isom R , S ( A , C ) ) ) $=
      ( vx vy wceq wf1o cv wbr cfv wb wral wa wiso f1oeq3 anbi1d df-isom
      3bitr4g ) BCIZABFJZGKZHKZDLUDFMUEFMELNHAOGAOZPACFJZUFPABDEFQACDEFQUBUCUGU
      FBCAFRSGHABDEFTGHACDEFTUA $.
  $}

  ${
    $d y z w H $.  $d y z w R $.  $d y z w S $.  $d y z w A $.  $d y z w B $.
    $d x y z w $.
    nfiso.1 $e |- F/_ x H $.
    nfiso.2 $e |- F/_ x R $.
    nfiso.3 $e |- F/_ x S $.
    nfiso.4 $e |- F/_ x A $.
    nfiso.5 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for an isomorphism.  (Contributed by
       NM, 17-May-2004.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
    nfiso $p |- F/ x H Isom R , S ( A , B ) $=
      ( vy vz cv wbr cfv wral nfcv nfbr nffv wiso wf1o wb wa df-isom nff1o nfbi
      nfral nfan nfxfr ) BCDEFUABCFUBZLNZMNZDOZULFPZUMFPZEOZUCZMBQZLBQZUDALMBCD
      EFUEUKUTAABCFGJKUFUSALBJURAMBJUNUQAAULUMDAULRZHAUMRZSAUOUPEAULFGVATIAUMFG
      VBTSUGUHUHUIUJ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $( An isomorphism is a one-to-one onto function.  (Contributed by NM,
       27-Apr-2004.) $)
    isof1o $p |- ( H Isom R , S ( A , B ) -> H : A -1-1-onto-> B ) $=
      ( vx vy wiso wf1o cv wbr cfv wb wral df-isom simplbi ) ABCDEHABEIFJZGJZCK
      QELRELDKMGANFANFGABCDEOP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $d x y C $.  $d x y D $.
    $( An isomorphism connects binary relations via its function values.
       (Contributed by NM, 27-Apr-2004.) $)
    isorel $p |- ( ( H Isom R , S ( A , B ) /\ ( C e. A /\ D e. A ) ) ->
                 ( C R D <-> ( H ` C ) S ( H ` D ) ) ) $=
      ( vx vy wiso cv wbr cfv wb wral wcel wa wceq fveq2 bibi12d df-isom breq1d
      wf1o simprbi breq1 breq2 breq2d rspc2v mpan9 ) ABEFGJZHKZIKZELZUKGMZULGMZ
      FLZNZIAOHAOZCAPDAPQCDELZCGMZDGMZFLZNZUJABGUCURHIABEFGUAUDUQVCCULELZUTUOFL
      ZNHICDAAUKCRZUMVDUPVEUKCULEUEVFUNUTUOFUKCGSUBTULDRZVDUSVEVBULDCEUFVGUOVAU
      TFULDGSUGTUHUI $.
  $}

  ${
    $d w x y z A $.  $d w z B $.  $d w z C $.  $d w x y z F $.  $d w x y z R $.
    $d w x y z S $.
    $( Express the condition of isomorphism on two strict orders for a
       function's restriction.  (Contributed by Mario Carneiro,
       22-Jan-2015.) $)
    soisores $p |- ( ( ( R Or B /\ S Or C ) /\ ( F : B --> C /\ A C_ B ) ) ->
      ( ( F |` A ) Isom R , S ( A , ( F " A ) ) <->
        A. x e. A A. y e. A ( x R y -> ( F ` x ) S ( F ` y ) ) ) ) $=
      ( vz vw wa cv wbr cfv wi wral wcel wb weq fveq2 wor wf wss cima cres wiso
      isorel fvres breqan12d adantl biimpd ralrimivva w3a wf1o wfn crn wceq ffn
      bitrd ad2antrl simprr fnssres syl2anc 3adant3 df-ima eqcomi a1i eqeqan12d
      wo simprl simpl3 breq1 breq1d imbi12d breq2 breq2d rspc2va syl21anc con3d
      orim12d simpl1r simpl2l simpl2r ffvelrnd sotrieq syl12anc simpl1l 3imtr4d
      sseldd sylbid dff1o6 sotric impbid bitr4d df-isom sylanbrc 3expia impbid2
      wn syl3anbrc ) DFUAZEGUAZKZDEHUBZCDUCZKZKZCHCUDZFGHCUEZUFZALZBLZFMZXKHNZX
      LHNZGMZOZBCPACPZXJXQABCCXJXKCQZXLCQZKZKZXMXPYBXMXKXINZXLXINZGMZXPCXHXKXLF
      GXIUGYAYEXPRXJXSXTYCXNYDXOGXKCHUHXLCHUHUIUJUSUKULXCXFXRXJXCXFXRUMZCXHXIUN
      ZILZJLZFMZYHXINZYIXINZGMZRZJCPICPXJYFXICUOZXIUPZXHUQZYKYLUQZIJSZOZJCPICPY
      GXCXFYOXRXGHDUOZXEYOXDUUAXCXEDEHURUTXCXDXEVADCHVBVCVDYQYFXHYPHCVEVFVGYFYT
      IJCCYFYHCQZYICQZKZKZYRYHHNZYIHNZUQZYSUUDYRUUHRYFUUBUUCYKUUFYLUUGYHCHUHZYI
      CHUHZVHUJUUEUUFUUGGMZUUGUUFGMZVIZWSZYJYIYHFMZVIZWSZUUHYSUUEUUPUUMUUEYJUUK
      UUOUULUUEUUBUUCXRYJUUKOZYFUUBUUCVJZYFUUBUUCVAZXCXFXRUUDVKZXQUURYHXLFMZUUF
      XOGMZOABYHYICCAISZXMUVBXPUVCXKYHXLFVLUVDXNUUFXOGXKYHHTVMVNBJSZUVBYJUVCUUK
      XLYIYHFVOUVEXOUUGUUFGXLYIHTVPVNVQVRZUUEUUCUUBXRUUOUULOZUUTUUSUVAXQUVGYIXL
      FMZUUGXOGMZOABYIYHCCAJSZXMUVHXPUVIXKYIXLFVLUVJXNUUGXOGXKYIHTVMVNBISZUVHUU
      OUVIUULXLYHYIFVOUVKXOUUFUUGGXLYHHTVPVNVQVRZVTVSUUEXBUUFEQZUUGEQZUUHUUNRXA
      XBXFXRUUDWAZUUEDEYHHXDXEXCXRUUDWBZUUECDYHXDXEXCXRUUDWCZUUSWIZWDZUUEDEYIHU
      VPUUECDYIUVQUUTWIZWDZEUUFUUGGWEWFUUEXAYHDQZYIDQZYSUUQRXAXBXFXRUUDWGZUVRUV
      TDYHYIFWEWFWHWJULIJCXHXIWKWTYFYNIJCCUUEYJUUKYMUUEYJUUKUVFUUEUUHUULVIZWSZY
      SUUOVIZWSZUUKYJUUEUWGUWEUUEYSUUHUUOUULYSUUHOUUEYHYIHTVGUVLVTVSUUEXBUVMUVN
      UUKUWFRUVOUVSUWAEUUFUUGGWLWFUUEXAUWBUWCYJUWHRUWDUVRUVTDYHYIFWLWFWHWMUUDYM
      UUKRYFUUBUUCYKUUFYLUUGGUUIUUJUIUJWNULIJCXHFGXIWOWPWQWR $.
  $}

  ${
    $d R x y a b $.  $d S x y a b $.  $d H x y a b $.  $d A x y a b $.
    $d B x y a b $.
    $( Infer isomorphism from one direction of an order proof for isomorphisms
       between strict orders.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    soisoi $p |- ( ( ( R Or A /\ S Po B ) /\ ( H : A -onto-> B /\
          A. x e. A A. y e. A ( x R y -> ( H ` x ) S ( H ` y ) ) ) ) ->
        H Isom R , S ( A , B ) ) $=
      ( va vb wa cv wbr cfv wi wral weq wcel wn sylan fveq2 wor wpo wfo wf1o wb
      wiso wf1 wf wceq simprl fof wo simpll sotrieq con2bid simprr breq1 breq1d
      imbi12d breq2 breq2d rspc2va ancoms simpllr simplrl ffvelrnd poirr notbid
      syl5ibrcom syl2anc con2d syld ancom2s jaod sylbird con4d ralrimivva dff13
      syl sylanbrc df-f1o sotric po2nr imnan sylibr syl12anc impcon4bid df-isom
      ) CEUAZDFUBZJZCDGUCZAKZBKZELZWMGMZWNGMZFLZNZBCOACOZJZJZCDGUDZHKZIKZELZXDG
      MZXEGMZFLZUEZICOHCOCDEFGUFXBCDGUGZWLXCXBCDGUHZXGXHUIZHIPZNZICOHCOXKXBWLXL
      WKWLWTUJZCDGUKZVSXBXOHICCXBXDCQZXECQZJZJZXNXMYAXNRZXFXEXDELZULZXMRZXBWIXT
      YDYBUEWIWJXAUMZWIXTJZXNYDCXDXEEUNUOSYAXFYEYCYAXFXIYEXBWTXTXFXINZWKWLWTUPZ
      XTWTYHWSYHXDWNELZXGWQFLZNABXDXECCAHPZWOYJWRYKWMXDWNEUQYLWPXGWQFWMXDGTURUS
      BIPZYJXFYKXIWNXEXDEUTYMWQXHXGFWNXEGTVAUSVBVCSZYAXMXIYAWJXHDQZXMXIRZNWIWJX
      AXTVDZYACDXEGYAWLXLWKWLWTXTVEXQVSZXBXRXSUPVFZWJYOJZYPXMXHXHFLZRZDXHFVGZXM
      XIUUAXGXHXHFUQVHVIVJVKVLYAYCXHXGFLZYEXBWTXTYCUUDNZYIWTXSXRUUEXSXRJWTUUEWS
      UUEXEWNELZXHWQFLZNABXEXDCCAIPZWOUUFWRUUGWMXEWNEUQUUHWPXHWQFWMXEGTURUSBHPZ
      UUFYCUUGUUDWNXDXEEUTUUIWQXGXHFWNXDGTVAUSVBVCVMSZYAXMUUDYAWJYOXMUUDRZNYQYS
      YTUUKXMUUBUUCXMUUDUUAXGXHXHFUTVHVIVJVKVLVNVOVPVQHICDGVRVTXPCDGWAVTXBXJHIC
      CYAXFXIYNYAXFRZXNYCULZYPXBWIXTUUMUULUEYFYGXFUUMCXDXEEWBUOSYAXNYPYCYAWJYOX
      NYPNYQYSYTYPXNUUBUUCXNXIUUAXNXGXHXHFXDXEGTURVHVIVJYAYCUUDYPUUJYAWJYOXGDQZ
      UUDYPNZYQYSYACDXDGYRXBXRXSUJVFWJYOUUNJJUUDXIJRUUODXHXGFWCUUDXIWDWEWFVLVNV
      OWGVQHICDEFGWHVT $.
  $}

  ${
    $d x y A $.  $d x y R $.
    $( Identity law for isomorphism.  Proposition 6.30(1) of [TakeutiZaring]
       p. 33.  (Contributed by NM, 27-Apr-2004.) $)
    isoid $p |- ( _I |` A ) Isom R , R ( A , A ) $=
      ( vx vy cid cres wiso wf1o wbr cfv wral f1oi wcel fvresi breqan12d bicomd
      cv wb wa rgen2a df-isom mpbir2an ) AABBEAFZGAAUCHCQZDQZBIZUDUCJZUEUCJZBIZ
      RZDAKCAKALUJCDAUDAMZUEAMZSUIUFUKULUGUDUHUEBAUDNAUENOPTCDAABBUCUAUB $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y C $.  $d x y D $.  $d w x y z H $.
    $d w x y z R $.  $d w x y z S $.
    $( Converse law for isomorphism.  Proposition 6.30(2) of [TakeutiZaring]
       p. 33.  (Contributed by NM, 27-Apr-2004.) $)
    isocnv $p |- ( H Isom R , S ( A , B ) -> `' H Isom S , R ( B , A ) ) $=
      ( vx vy vz vw wf1o cv wbr cfv wb wral wa wiso wcel wceq f1ocnvfv2 adantrr
      ccnv f1ocnv adantr adantrl breq12d adantlr wf syl ffvelrn anim12dan breq1
      f1of fveq2 breq1d bibi12d bicom syl6bb breq2d breq2 rspc2va sylan sylanl1
      an32s bitr3d ralrimivva jca df-isom 3imtr4i ) ABEJZFKZGKZCLZVKEMZVLEMZDLZ
      NZGAOFAOZPZBAEUBZJZHKZIKZDLZWBVTMZWCVTMZCLZNZIBOHBOZPABCDEQBADCVTQVSWAWIV
      JWAVRABEUCZUDVSWHHIBBVSWBBRZWCBRZPZPWEEMZWFEMZDLZWDWGVJWMWPWDNVRVJWMPWNWB
      WOWCDVJWKWNWBSWLABWBETUAVJWLWOWCSWKABWCETUEUFUGVJBAVTUHZVRWMWPWGNZVJWAWQW
      JBAVTUMUIWQWMVRWRWQWMPWEARZWFARZPVRWRWQWKWSWLWTBAWBVTUJBAWCVTUJUKVQWRWNVO
      DLZWEVLCLZNZFGWEWFAAVKWESZVQXBXANXCXDVMXBVPXAVKWEVLCULXDVNWNVODVKWEEUNUOU
      PXBXAUQURVLWFSZXAWPXBWGXEVOWOWNDVLWFEUNUSVLWFWECUTUPVAVBVDVCVEVFVGFGABCDE
      VHHIBADCVTVHVI $.

    $( Converse law for isomorphism.  (Contributed by Mario Carneiro,
       30-Jan-2014.) $)
    isocnv2 $p |- ( H Isom R , S ( A , B ) <->
                    H Isom `' R , `' S ( A , B ) ) $=
      ( vy vx wf1o cv wbr cfv wb wral wa ccnv wiso vex brcnv fvex df-isom
      ralcom bibi12i 2ralbii bitr4i anbi2i 3bitr4i ) ABEHZFIZGIZCJZUHEKZUIEKZDJ
      ZLZGAMFAMZNUGUIUHCOZJZULUKDOZJZLZFAMGAMZNABCDEPABUPUREPUOVAUGUOUNFAMGAMVA
      UNFGAAUAUTUNGFAAUQUJUSUMUIUHCGQFQRULUKDUIESUHESRUBUCUDUEFGABCDETGFABUPURE
      TUF $.

    isocnv3.1 $e |- C = ( ( A X. A ) \ R ) $.
    isocnv3.2 $e |- D = ( ( B X. B ) \ S ) $.
    $( Complementation law for isomorphism.  (Contributed by Mario Carneiro,
       9-Sep-2015.) $)
    isocnv3 $p |- ( H Isom R , S ( A , B ) <-> H Isom C , D ( A , B ) ) $=
      ( vx vy cv wbr cfv wb wral wa wiso wcel wn wf1o cxp brxp cdif breqi brdif
      bitri baib sylbir adantl wf f1of ffvelrn anim12dan sylibr sylan syl notbi
      bibi12d syl6rbbr 2ralbidva pm5.32i df-isom 3bitr4i ) ABGUAZJLZKLZEMZVFGNZ
      VGGNZFMZOZKAPJAPZQVEVFVGCMZVIVJDMZOZKAPJAPZQABEFGRABCDGRVEVMVQVEVLVPJKAAV
      EVFASZVGASZQZQZVPVHTZVKTZOVLWAVNWBVOWCVTVNWBOZVEVTVFVGAAUBZMZWDVFVGAAUCVN
      WFWBVNVFVGWEEUDZMWFWBQVFVGCWGHUEVFVGWEEUFUGUHUIUJWAVIVJBBUBZMZVOWCOVEABGU
      KZVTWIABGULWJVTQVIBSZVJBSZQWIWJVRWKVSWLABVFGUMABVGGUMUNVIVJBBUCUOUPVOWIWC
      VOVIVJWHFUDZMWIWCQVIVJDWMIUEVIVJWHFUFUGUHUQUSVHVKURUTVAVBJKABEFGVCJKABCDG
      VCVD $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d H x y $.  $d R x y $.  $d S x y $.
    $( An isomorphism from one well-order to another can be restricted on
       either well-order.  (Contributed by Mario Carneiro, 15-Jan-2013.) $)
    isores2 $p |- ( H Isom R , S ( A , B ) <->
                      H Isom R , ( S i^i ( B X. B ) ) ( A , B ) ) $=
      ( vx vy wf1o cv wbr cfv wb wral wa cxp wiso wcel ffvelrn ralbidva df-isom
      cin wf f1of adantrr adantrl brinxp syl2anc anassrs bibi2d pm5.32i 3bitr4i
      sylan ) ABEHZFIZGIZCJZUNEKZUOEKZDJZLZGAMZFAMZNUMUPUQURDBBOUAZJZLZGAMZFAMZ
      NABCDEPABCVCEPUMVBVGUMVAVFFAUMUNAQZNZUTVEGAVIUOAQZNUSVDUPUMVHVJUSVDLZUMAB
      EUBZVHVJNZVKABEUCVLVMNUQBQZURBQZVKVLVHVNVJABUNERUDVLVJVOVHABUOERUEUQURBBD
      UFUGULUHUISSUJFGABCDETFGABCVCETUK $.
  $}

  ${
    $( An isomorphism from one well-order to another can be restricted on
       either well-order.  (Contributed by Mario Carneiro, 15-Jan-2013.) $)
    isores1 $p |- ( H Isom R , S ( A , B ) <->
                      H Isom ( R i^i ( A X. A ) ) , S ( A , B ) ) $=
      ( wiso cxp cin ccnv isocnv isores2 sylib wf1o wb isof1o isoeq1 sylbi 3syl
      syl mpbid wrel f1orel wceq dfrel2 sylibr impbii ) ABCDEFZABCAAGHZDEFZUGAB
      UHDEIZIZFZUIUGBADUHUJFZULUGBADCUJFZUMABCDEJBADCUJKZLBADUHUJJSUGABEMZEUAZU
      LUINZABCDEOABEUBZUQUKEUCZUREUDZABUHDEUKPQRTUIABCDUKFZUGUIUNVBUIUMUNABUHDE
      JUOUEBADCUJJSUIUPUQVBUGNZABUHDEOUSUQUTVCVAABCDEUKPQRTUF $.
  $}

  ${
    $d H a b c $.  $d R a b c $.  $d S a b c $.  $d K a b c $.  $d A a b c $.
    $d B a b c $.  $d X a b c $.
    $( Induced isomorphism on a subset.  (Contributed by Stefan O'Rear,
       5-Nov-2014.) $)
    isores3 $p |- ( ( H Isom R , S ( A , B ) /\ K C_ A /\ X = ( H " K ) ) ->
        ( H |` K ) Isom R , S ( K , X ) ) $=
      ( va vb wiso wa wf1o cv wbr cfv wb wral ssralv wcel fvres cima wceq f1of1
      wss cres wf1 f1ores expcom syl5 adantr breqan12d adantll biimprd ralimdva
      wi bibi2d syld anim12d df-isom 3imtr4g impcom isoeq5 syl5ibrcom 3impia )
      ABCDEJZFAUDZGEFUAZUBZFGCDEFUEZJZVEVFKVJVHFVGCDVIJZVFVEVKVFABELZHMZIMZCNZV
      MEOZVNEOZDNZPZIAQZHAQZKFVGVILZVOVMVIOZVNVIOZDNZPZIFQZHFQZKVEVKVFVLWBWAWHV
      LABEUFZVFWBABEUCWIVFWBABFEUGUHUIVFWAVTHFQWHVTHFARVFVTWGHFVFVMFSZKZVTVSIFQ
      ZWGVFVTWLUOWJVSIFARUJWKVSWFIFWKVNFSZKZWFVSWNWEVRVOWJWMWEVRPVFWJWMWCVPWDVQ
      DVMFETVNFETUKULUPUMUNUQUNUQURHIABCDEUSHIFVGCDVIUSUTVAFGVGCDVIVBVCVD $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w R $.
    $d x y z w S $.  $d x y z w T $.  $d x y z w G $.  $d x y z w H $.
    $( Composition (transitive) law for isomorphism.  Proposition 6.30(3) of
       [TakeutiZaring] p. 33.  (Contributed by NM, 27-Apr-2004.)  (Proof
       shortened by Mario Carneiro, 5-Dec-2016.) $)
    isotr $p |- ( ( H Isom R , S ( A , B ) /\ G Isom S , T ( B , C ) ) ->
               ( G o. H ) Isom R , T ( A , C ) ) $=
      ( vx vy vz vw cv wbr cfv wb wral wa wcel wceq wf1o simpl f1oco syl2anr wf
      ccom wiso f1of ad2antrr simprl ffvelrnd simprr simplrr breq1 fveq2 breq1d
      bibi12d breq2 breq2d rspc2va syl21anc fvco3 syl2anc breq12d bitr4d bibi2d
      2ralbidva biimpd impancom imp jca df-isom anbi12i 3imtr4i ) ABHUAZIMZJMZD
      NZVPHOZVQHOZENZPZJAQIAQZRZBCGUAZKMZLMZENZWFGOZWGGOZFNZPZLBQKBQZRZRZACGHUF
      ZUAZVRVPWPOZVQWPOZFNZPZJAQIAQZRABDEHUGZBCEFGUGZRACDFWPUGWOWQXBWNWEVOWQWDW
      EWMUBVOWCUBABCGHUCUDWDWNXBVOWNWCXBVOWNRZWCXBXEWBXAIJAAXEVPASZVQASZRZRZWAW
      TVRXIWAVSGOZVTGOZFNZWTXIVSBSVTBSWMWAXLPZXIABVPHVOABHUEZWNXHABHUHUIZXEXFXG
      UJZUKXIABVQHXOXEXFXGULZUKVOWEWMXHUMWLXMVSWGENZXJWJFNZPKLVSVTBBWFVSTZWHXRW
      KXSWFVSWGEUNXTWIXJWJFWFVSGUOUPUQWGVTTZXRWAXSXLWGVTVSEURYAWJXKXJFWGVTGUOUS
      UQUTVAXIWRXJWSXKFXIXNXFWRXJTXOXPABVPGHVBVCXIXNXGWSXKTXOXQABVQGHVBVCVDVEVF
      VGVHVIVJVKXCWDXDWNIJABDEHVLKLBCEFGVLVMIJACDFWPVLVN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $d x y C $.  $d x y D $.
    $( Isomorphisms preserve minimal elements.  Note that ` ( ``' R " { D } ) `
       is Takeuti and Zaring's idiom for the initial segment
       ` { x | x R D } ` .  Proposition 6.31(1) of [TakeutiZaring] p. 33.
       (Contributed by NM, 19-Apr-2004.) $)
    isomin $p |- ( ( H Isom R , S ( A , B ) /\ ( C C_ A /\ D e. A ) ) ->
               ( ( C i^i ( `' R " { D } ) ) = (/) <->
               ( ( H " C ) i^i ( `' S " { ( H ` D ) } ) ) = (/) ) ) $=
      ( vy vx wcel wa cima wceq wex wrex wbr wb wi syl9r cvv wss csn cin c0 cfv
      wiso ccnv wn cv neq0 ssel wf1o wfn isof1o f1ofn fnbrfvb ex imp31 rexbidva
      3syl vex syl6rbbr fvex eliniseg mp1i anbi12d elin r19.41v 3bitr4g adantrr
      elima breq1 biimpar ad2antll isorel bitrd syl5ibr exp32 com34 imp32 exbii
      reximdvai sylbid df-rex 3bitr4i syl6ibr exlimdv syl5bi syl fnfvima 3expia
      con4d sylan adantrd biimpd ax-mp imp3a jcad 3imtr4g n0i syl6 impcon4bid )
      ABEFGUFZCAUAZDAJZKZKZCEUGDUBLZUCZUDMZGCLZFUGDGUEZUBLZUCZUDMZXGXOXJXOUHZHU
      IZXNJZHNXGXJUHZHXNUJXGXRXSHXGXRIUIZXHJZICOZXSXGXRXTGUEZXQMZXQXLFPZKZICOZY
      BXCXDXRYGQXEXCXDKZXQXKJZXQXMJZKYDICOZYEKXRYGYHYIYKYJYEYHYKXTXQGPZICOYIYHY
      DYLICXCXDXTCJZYDYLQZXDYMXTAJZXCYNCAXTUKZXCABGULZGAUMZYOYNRABEFGUNZABGUOZY
      RYOYNAXTXQGUPUQUTSURUSIXQGCHVAZVKVBXLTJZYJYEQYHDGVCZFXLXQTUUAVDVEVFXQXKXM
      VGYDYEICVHVIVJXGYFYAICXCXDXEYMYFYARZRXCXDYMXEUUDXDYMYOXCXEUUDRYPXCYOXEUUD
      YFYAXCYOXEKKZYCXLFPZYDUUFYEYCXQXLFVLVMUUEYAXTDEPZUUFXEYAUUGQXCYOEDXTAIVAV
      DVNZABXTDEFGVOZVPVQVRSVSVTWBWCXTXIJZINZYMYAKZINXSYBUUJUULIXTCXHVGZWAIXIUJ
      ZYAICWDWEWFWGWHWLXSUUKXGXPUUNXGUUJXPIXGUUJYCXNJZXPXGUULYCXKJZYCXMJZKUUJUU
      OXGUULUUPUUQXGYMUUPYAXCYRXFYMUUPRZXCYQYRYSYTWIYRXDUURXEYRXDYMUUPACGXTWJWK
      VJWMWNXGYMYAUUQXCXDXEYMYAUUQRZRXCXDYMXEUUSXDYMYOXCXEUUSRYPXCYOXEUUSUUEYAU
      UGUUQUUHUUEUUGUUFUUQUUEUUGUUFUUIWOUUBUUQUUFQUUCFXLYCTXTGVCVDWPWFWCVRSVSVT
      WQWRUUMYCXKXMVGWSXNYCWTXAWGWHXB $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.  $d x y S $.  $d x y H $.
    $d x y D $.
    $( Isomorphisms preserve initial segments.  Proposition 6.31(2) of
       [TakeutiZaring] p. 33.  (Contributed by NM, 20-Apr-2004.) $)
    isoini $p |- ( ( H Isom R , S ( A , B ) /\ D e. A ) ->
               ( H " ( A i^i ( `' R " { D } ) ) ) =
               ( B i^i ( `' S " { ( H ` D ) } ) ) ) $=
      ( vx vy wcel wa ccnv cfv csn cima cin cv wbr wrex wb syl6bb wiso cab elin
      wceq crn wf1o wfo isof1o f1ofo forn eleq2d 3syl f1ofn fvelrnb bitr3d fvex
      wfn cvv eliniseg mp1i anbi12d adantr anbi2d syl5bb anbi1d anass adantl wi
      vex isorel syl fnbrfvb bicomd sylan adantrr ancom breq1 bitri exp32 com23
      pm5.32i imp pm5.32d bitrd rexbidv2 r19.41v bitr4d abbi2dv dfima2 syl6reqr
      ) ABDEFUAZCAIZJZBEKCFLZMNZOZGPZHPZFQZGADKCMNZOZRZHUBFXANWMXBHWPWRWPIWRBIZ
      WRWOIZJZWMXBWRBWOUCWMXEWQFLZWRUDZGARZWRWNEQZJZXBWKXEXJSWLWKXCXHXDXIWKWRFU
      EZIZXCXHWKABFUFZABFUGZXLXCSABDEFUHZABFUIXNXKBWRABFUJUKULWKXMFAUQZXLXHSXOA
      BFUMZGAWRFUNULUOWNURIXDXISWKCFUPEWNWRURHVIUSUTVAVBWMXBXGXIJZGARXJWMWSXRGX
      AAWMWQXAIZWSJZWQAIZWQCDQZWSJZJZYAXRJWLXTYDSWKWLXTYAYBJZWSJYDWLXSYEWSXSYAW
      QWTIZJWLYEWQAWTUCWLYFYBYADCWQAGVIUSVCVDVEYAYBWSVFTVGWMYAYCXRWKWLYAYCXRSZV
      HWKYAWLYGWKYAWLYGWKYAWLJJZYCXFWNEQZXGJZXRYHYBYIWSXGABWQCDEFVJWKYAWSXGSZWL
      WKXPYAYKWKXMXPXOXQVKXPYAJXGWSAWQWRFVLVMVNVOVAYJXGYIJXRYIXGVPXGYIXIXFWRWNE
      VQWAVRTVSVTWBWCWDWEXGXIGAWFTWGVDWHGHFXAWIWJ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y H $.
    $d x y R $.  $d x y S $.
    isoini2.1 $e |- C = ( A i^i ( `' R " { X } ) ) $.
    isoini2.2 $e |- D = ( B i^i ( `' S " { ( H ` X ) } ) ) $.
    $( Isomorphisms are isomorphisms on their initial segments.  (Contributed
       by Mario Carneiro, 29-Mar-2014.) $)
    isoini2 $p |- ( ( H Isom R , S ( A , B ) /\ X e. A ) ->
                    ( H |` C ) Isom R , S ( C , D ) ) $=
      ( vx vy wiso wcel wf1o wbr cfv wb wral cima wa cres cv wf1 wss isof1o syl
      f1of1 adantr ccnv csn inss1 eqsstri f1ores sylancl isoini imaeq2i 3eqtr4g
      cin wceq f1oeq3 mpbid df-isom simprbi ssralv mpsyl fvres breqan12d bibi2d
      ralimdv ralbidva ralbiia sylibr sylanbrc ) ABEFGMZHANZUAZCDGCUBZOZKUCZLUC
      ZEPZVTVRQZWAVRQZFPZRZLCSZKCSZCDEFVRMVQCGCTZVROZVSVQABGUDZCAUEZWJVOWKVPVOA
      BGOZWKABEFGUFABGUHUGUICAEUJHUKTZUSZAIAWNULUMZABCGUNUOVQWIDUTWJVSRVQGWOTBF
      UJHGQUKTUSWIDABHEFGUPCWOGIUQJURWIDCVRVAUGVBVQWBVTGQZWAGQZFPZRZLCSZKCSZWHW
      LVQXAKASZXBWPWLVQWTLASZKASZXCWPVOXEVPVOWMXEKLABEFGVCVDUIWLXDXAKAWTLCAVEVJ
      VFXAKCAVEVFWGXAKCVTCNZWFWTLCXFWACNZUAWEWSWBXFXGWCWQWDWRFVTCGVGWACGVGVHVIV
      KVLVMKLCDEFVRVCVN $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z H $.  $d w x y z ph $.
    $d w x y z R $.  $d w x y z S $.
    isofrlem.1 $e |- ( ph -> H Isom R , S ( A , B ) ) $.
    isofrlem.2 $e |- ( ph -> ( H " x ) e. _V ) $.
    $( Lemma for ~ isofr .  (Contributed by NM, 29-Apr-2004.)  (Revised by
       Mario Carneiro, 18-Nov-2014.) $)
    isofrlem $p |- ( ph -> ( S Fr B -> R Fr A ) ) $=
      ( vy vw vz cv c0 wa cima wceq wi syl wcel wfr wss wne ccnv wrex wf1o wiso
      csn cin wal isof1o wfn f1ofn wex n0 w3a cfv fnfvima 3expia exlimdv syl5bi
      ne0i expimpd wfo f1ofo crn imassrn forn syl5sseq jctild dffr3 sseq1 neeq1
      cvv anbi12d ineq1 eqeq1d rexeqbi1dv imbi12d spcgv syl5d wfun adantr simpl
      f1ofun fvelima syl2an simpr wb ssel imdistani isomin sneq ineq2d sylan9bb
      imaeq2d syl5ibr exp42 imp com3l com4t reximdvai mpd rexlimdvaa ex adantrd
      a2d syld alrimdv syl6ibr ) ADFUAZBMZCUBZXLNUCZOZXLEUDJMZUHPUINQZJXLUEZRZB
      UJCEUAAXKXSBAXKXOGXLPZFUDZKMZUHZPZUIZNQZKXTUEZRXSAXOXTDUBZXTNUCZOZXKYGACD
      GUFZXOYJRACDEFGUGZYKHCDEFGUKSZYKXOYIYHYKGCULZXOYIRCDGUMYNXMXNYIXNXPXLTZJU
      NYNXMOZYIJXLUOYPYOYIJYNXMYOYIYNXMYOUPXPGUQZXTTYICXLGXPURXTYQVBSUSUTVAVCSY
      KCDGVDZYHCDGVEYRGVFXTDGXLVGCDGVHVISVJSXKLMZDUBZYSNUCZOZYSYDUIZNQZKYSUEZRZ
      LUJZAYJYGRZLKDFVKAXTVNTUUGUUHRIUUFUUHLXTVNYSXTQZUUBYJUUEYGUUIYTYHUUAYIYSX
      TDVLYSXTNVMVOUUDYFKYSXTUUIUUCYENYSXTYDVPVQVRVSVTSVAWAAXOYGXRAXMYGXRRZXNAX
      MUUJAXMOZYFXRKXTUUKYBXTTZYFOZOZYQYBQZJXLUEZXRUUKGWBZUULUUPUUMUUKYKUUQAYKX
      MYMWCCDGWESUULYFWDJYBXLGWFWGUUNUUOXQJXLUUKUUMYOUUOXQRRYOUUOUUKUUMXQUUKYOU
      UOUUMXQRZAXMYOUUOUURRRAXMYOUUOUURUUMXQAXMYOOZOZUUOOYFUULYFWHUUTXQXTYAYQUH
      ZPZUIZNQZUUOYFAYLXMXPCTZOXQUVDWIUUSHXMYOUVEXLCXPWJWKCDXLXPEFGWLWGUUOUVCYE
      NUUOUVBYDXTUUOUVAYCYAYQYBWMWPWNVQWOWQWRWSWTXAWSXBXCXDXEXFXGXHXIBJCEVKXJ
      $.

    $( Lemma for ~ isose .  (Contributed by Mario Carneiro, 23-Jun-2015.) $)
    isoselem $p |- ( ph -> ( R Se A -> S Se B ) ) $=
      ( vy vz cv csn cima cin cvv wcel wral wi wceq wse ccnv cfv dfse2 r19.21bi
      biimpi expcom adantl imaeq2 eleq1d imbi2d vtoclg com12 adantr wiso isoini
      wa sylan sylibd syld ralrimdva crn wf1o wfn wb isof1o sneq imaeq2d ineq2d
      f1ofn ralrn 4syl wfo f1ofo forn raleqdv bitr3d syl6ibr ) ACEUAZDFUBZJLZMZ
      NZOZPQZJDRZDFUAAVSDVTKLZGUCZMZNZOZPQZKCRZWFAVSWLKCAWGCQZUQZVSCEUBWGMNOZPQ
      ZWLWNVSWQSAVSWNWQVSWQKCVSWQKCRKCEUDUFUEUGUHWOWQGWPNZPQZWLAWQWSSWNWQAWSAGB
      LZNZPQZSAWSSBWPPWTWPTZXBWSAXCXAWRPWTWPGUIUJUKIULUMUNWOWRWKPACDEFGUOZWNWRW
      KTHCDWGEFGUPURUJUSUTVAAWEJGVBZRZWMWFAXDCDGVCZGCVDXFWMVEHCDEFGVFZCDGVJWEWL
      JKCGWAWHTZWDWKPXIWCWJDXIWBWIVTWAWHVGVHVIUJVKVLAWEJXEDAXDXGCDGVMXEDTHXHCDG
      VNCDGVOVLVPVQUSJDFUDVR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x H $.  $d x R $.  $d x S $.  $d x V $.
    $( An isomorphism preserves well-foundedness.  Proposition 6.32(1) of
       [TakeutiZaring] p. 33.  (Contributed by NM, 30-Apr-2004.)  (Revised by
       Mario Carneiro, 18-Nov-2014.) $)
    isofr $p |- ( H Isom R , S ( A , B ) -> ( R Fr A <-> S Fr B ) ) $=
      ( vx wiso wfr ccnv id wf1o wfun cima cvv wcel isof1o f1ofun funimaex 3syl
      isofrlem wi isocnv cv vex syl impbid ) ABCDEGZACHZBDHZUGBADCEIZGZUHUIUAAB
      CDEUBUKFBADCUJUKJUKBAUJKUJLUJFUCZMNOBADCUJPBAUJQUJULFUDZRSTUEUGFABCDEUGJU
      GABEKELEULMNOABCDEPABEQEULUMRSTUF $.

    $( An isomorphism preserves set-like relations.  (Contributed by Mario
       Carneiro, 23-Jun-2015.) $)
    isose $p |- ( H Isom R , S ( A , B ) -> ( R Se A <-> S Se B ) ) $=
      ( vx wiso wse wf1o wfun cima cvv wcel isof1o f1ofun vex funimaex isoselem
      id cv 3syl ccnv isocnv 4syl impbid ) ABCDEGZACHBDHUFFABCDEUFSUFABEIEJEFTZ
      KLMABCDENABEOEUGFPZQUARUFFBADCEUBZABCDEUCZUFBADCUIGBAUIIUIJUIUGKLMUJBADCU
      INBAUIOUIUGUHQUDRUE $.

    $( A weak form of ~ isofr that does not need Replacement.  (Contributed by
       Mario Carneiro, 18-Nov-2014.) $)
    isofr2 $p |- ( ( H Isom R , S ( A , B ) /\ B e. V ) ->
                   ( S Fr B -> R Fr A ) ) $=
      ( vx wiso wcel wa simpl cv cima wss cvv crn imassrn wf1o wf isof1o syl5ss
      f1of frn 3syl ssexg sylan isofrlem ) ABCDEHZBFIZJGABCDEUHUIKUHEGLZMZBNUIU
      KOIUHUKEPZBEUJQUHABERABESULBNABCDETABEUBABEUCUDUAUKBFUEUFUG $.
  $}

  ${
    $d H a b c d e f $.  $d R a b c d e f $.  $d S a b c d e f $.
    $d A a b c d e f $.  $d B a b c d e f $.
    $( Lemma for ~ isopo .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    isopolem $p |- ( H Isom R , S ( A , B ) -> ( S Po B -> R Po A ) ) $=
      ( va vb vc vd ve vf cv wbr wa wi wral wcel ex wb anbi12d wiso wpo w3a cfv
      wn wf1o isof1o f1of ffvelrn 3anim123d 3syl imp breq12 anidms notbid breq1
      wf wceq anbi1d imbi12d breq2 imbi1d anbi2d rspc3v syl simpl simpr1 isorel
      syl12anc simpr2 simpr3 sylibrd com23 imp31 ralrimivvva df-po 3imtr4g ) AB
      CDEUAZFLZVSDMZUEZVSGLZDMZWBHLZDMZNZVSWDDMZOZNZHBPGBPFBPZILZWKCMZUEZWKJLZC
      MZWNKLZCMZNZWKWPCMZOZNZKAPJAPIAPZBDUBACUBVRWJXBVRWJNXAIJKAAAVRWJWKAQZWNAQ
      ZWPAQZUCZXAVRXFWJXAVRXFWJXAOVRXFNZWJWKEUDZXHDMZUEZXHWNEUDZDMZXKWPEUDZDMZN
      ZXHXMDMZOZNZXAXGXHBQZXKBQZXMBQZUCZWJXROVRXFYBVRABEUFABEUQZXFYBOABCDEUGABE
      UHYCXCXSXDXTXEYAYCXCXSABWKEUIRYCXDXTABWNEUIRYCXEYAABWPEUIRUJUKULWIXRXJXHW
      BDMZWENZXHWDDMZOZNXJXLXKWDDMZNZYFOZNFGHXHXKXMBBBVSXHURZWAXJWHYGYKVTXIYKVT
      XISVSXHVSXHDUMUNUOYKWFYEWGYFYKWCYDWEVSXHWBDUPUSVSXHWDDUPUTTWBXKURZYGYJXJY
      LYEYIYFYLYDXLWEYHWBXKXHDVAWBXKWDDUPTVBVCWDXMURZYJXQXJYMYIXOYFXPYMYHXNXLWD
      XMXKDVAVCWDXMXHDVAUTVCVDVEXGWMXJWTXQXGWLXIXGVRXCXCWLXISVRXFVFZVRXCXDXEVGZ
      YOABWKWKCDEVHVIUOXGWRXOWSXPXGWOXLWQXNXGVRXCXDWOXLSYNYOVRXCXDXEVJZABWKWNCD
      EVHVIXGVRXDXEWQXNSYNYPVRXCXDXEVKZABWNWPCDEVHVITXGVRXCXEWSXPSYNYOYQABWKWPC
      DEVHVIUTTVLRVMVNVORFGHBDVPIJKACVPVQ $.

    $( An isomorphism preserves partial ordering.  (Contributed by Stefan
       O'Rear, 16-Nov-2014.) $)
    isopo $p |- ( H Isom R , S ( A , B ) -> ( R Po A <-> S Po B ) ) $=
      ( wiso wpo ccnv wi isocnv isopolem syl impbid ) ABCDEFZACGZBDGZNBADCEHZFO
      PIABCDEJBADCQKLABCDEKM $.

    $( Lemma for ~ isoso .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    isosolem $p |- ( H Isom R , S ( A , B ) -> ( S Or B -> R Or A ) ) $=
      ( va vb vc vd wpo cv wbr weq w3o wral wa wor wcel wceq 3orbi123d isopolem
      wiso cfv wi wf1o wf isof1o f1of ffvelrn ex anim12d 3syl breq1 eqeq1 breq2
      imp eqeq2 rspc2v syl isorel wf1 f1of1 f1fveq sylan bicomd ancom2s sylibrd
      wb ralrimdvva df-so 3imtr4g ) ABCDEUBZBDJZFKZGKZDLZFGMZVOVNDLZNZGBOFBOZPA
      CJZHKZIKZCLZHIMZWCWBCLZNZIAOHAOZPBDQACQVLVMWAVTWHABCDEUAVLVTWGHIAAVLWBARZ
      WCARZPZPZVTWBEUCZWCEUCZDLZWMWNSZWNWMDLZNZWGWLWMBRZWNBRZPZVTWRUDVLWKXAVLAB
      EUEZABEUFZWKXAUDABCDEUGZABEUHXCWIWSWJWTXCWIWSABWBEUIUJXCWJWTABWCEUIUJUKUL
      UPVSWRWMVODLZWMVOSZVOWMDLZNFGWMWNBBVNWMSVPXEVQXFVRXGVNWMVODUMVNWMVOUNVNWM
      VODUOTVOWNSXEWOXFWPXGWQVOWNWMDUOVOWNWMUQVOWNWMDUMTURUSWLWDWOWEWPWFWQABWBW
      CCDEUTWLWPWEVLABEVAZWKWPWEVHVLXBXHXDABEVBUSABWBWCEVCVDVEVLWJWIWFWQVHABWCW
      BCDEUTVFTVGVIUKFGBDVJHIACVJVK $.

    $( An isomorphism preserves strict ordering.  (Contributed by Stefan
       O'Rear, 16-Nov-2014.) $)
    isoso $p |- ( H Isom R , S ( A , B ) -> ( R Or A <-> S Or B ) ) $=
      ( wiso wor ccnv wi isocnv isosolem syl impbid ) ABCDEFZACGZBDGZNBADCEHZFO
      PIABCDEJBADCQKLABCDEKM $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y R $.  $d x y z w S $.
    $d x y z w H $.
    $( An isomorphism preserves well-ordering.  Proposition 6.32(3) of
       [TakeutiZaring] p. 33.  (Contributed by NM, 30-Apr-2004.)  (Revised by
       Mario Carneiro, 18-Nov-2014.) $)
    isowe $p |- ( H Isom R , S ( A , B ) -> ( R We A <-> S We B ) ) $=
      ( wiso wfr wor wa wwe isofr isoso anbi12d df-we 3bitr4g ) ABCDEFZACGZACHZ
      IBDGZBDHZIACJBDJPQSRTABCDEKABCDELMACNBDNO $.

    $( A weak form of ~ isowe that does not need Replacement.  (Contributed by
       Mario Carneiro, 18-Nov-2014.) $)
    isowe2 $p |- ( ( H Isom R , S ( A , B ) /\ A. x ( H " x ) e. _V ) ->
                   ( S We B -> R We A ) ) $=
      ( vy wiso cv cima cvv wcel wal wa wfr wor wwe simpl weq df-we isofrlem wi
      imaeq2 eleq1d spv adantl isosolem adantr anim12d 3imtr4g ) BCDEFHZFAIZJZK
      LZAMZNZCEOZCEPZNBDOZBDPZNCEQBDQUPUQUSURUTUPGBCDEFUKUORUOFGIZJZKLZUKUNVCAG
      AGSUMVBKULVAFUCUDUEUFUAUKURUTUBUOBCDEFUGUHUICETBDTUJ $.
  $}

  ${
    $d x y z w v u A $.  $d x y v u B $.  $d x y z w v u H $.
    $d x y z w v u R $.  $d v u S $.
    $( Any one-to-one onto function determines an isomorphism with an induced
       relation ` S ` .  Proposition 6.33 of [TakeutiZaring] p. 34.
       (Contributed by NM, 30-Apr-2004.) $)
    f1oiso $p |- ( ( H : A -1-1-onto-> B /\ S = { <. z , w >. |
     E. x e. A E. y e. A ( ( z = ( H ` x ) /\ w = ( H ` y ) ) /\ x R y ) } ) ->
                  H Isom R , S ( A , B ) ) $=
      ( vv vu cv cfv wceq wa wbr wrex wb wcel anbi1d wf1o copab wral wiso simpl
      wf1 f1of1 cop df-br eleq2 eqeq1 2rexbidv anbi2d opelopab weq anass f1fveq
      fvex equcom syl6bb anassrs syl5bb rexbidv r19.42v rexbidva breq1 ceqsrexv
      adantl bitrd breq2 sylan9bb anandis sylan9bbr an32s syl5rbb sylan df-isom
      ralrimivva sylanbrc ) EFIUAZHCLZALZIMZNZDLZBLZIMZNZOZWBWFGPZOZBEQAEQZCDUB
      ZNZOVTJLZKLZGPZWOIMZWPIMZHPZRZKEUCJEUCZEFGHIUDVTWNUEVTEFIUFZWNXBEFIUGXCWN
      OZXAJKEEWTWRWSUHZHSZXDWOESZWPESZOZOWQWRWSHUIXCXIWNXFWQRWNXFXEWMSZXCXIOZWQ
      HWMXEUJXJWRWCNZWSWGNZOZWJOZBEQZAEQZXKWQWLXLWHOZWJOZBEQAEQXQCDWRWSWOIURWPI
      URWAWRNZWKXSABEEXTWIXRWJXTWDXLWHWAWRWCUKTTULWEWSNZXSXOABEEYAXRXNWJYAWHXMX
      LWEWSWGUKUMTULUNXCXGXHXQWQRXCXGOZXQXMWOWFGPZOZBEQZXCXHOZWQYBXQAJUOZXMWJOZ
      BEQZOZAEQZYEYBXPYJAEYBWBESZOZXPYGYHOZBEQYJYMXOYNBEXOXLYHOYMYNXLXMWJUPYMXL
      YGYHXCXGYLXLYGRXCXGYLOOXLJAUOYGEFWOWBIUQJAUSUTVATVBVCYGYHBEVDUTVEXGYKYERX
      CYIYEAWOEYGYHYDBEYGWJYCXMWBWOWFGVFUMVCVGVHVIYFYEBKUOZYCOZBEQZWQYFYDYPBEYF
      WFESZOXMYOYCXCXHYRXMYORXCXHYROOXMKBUOYOEFWPWFIUQKBUSUTVATVEXHYQWQRXCYCWQB
      WPEWFWPWOGVJVGVHVIVKVLVBVMVNVOVRVPJKEFGHIVQVS $.
  $}

  ${
    $d A w x y z $.  $d B w x y z $.  $d H w x y z $.  $d R w x y z $.
    f1oiso2.1 $e |- S = { <. x , y >. |
      ( ( x e. B /\ y e. B ) /\ ( `' H ` x ) R ( `' H ` y ) ) } $.
    $( Any one-to-one onto function determines an isomorphism with an induced
       relation ` S ` .  (Contributed by Mario Carneiro, 9-Mar-2013.) $)
    f1oiso2 $p |- ( H : A -1-1-onto-> B -> H Isom R , S ( A , B ) ) $=
      ( vz vw cv cfv wceq wa wbr wrex wcel 3adant3 eqcomd syl2anc wf1o wiso w3a
      copab ccnv f1ocnvdm adantrr f1ocnvfv2 anim12dan simp3 fveq2 eqeq2d anbi2d
      adantrl breq2 anbi12d rspcev syl12anc anbi1d breq1 rexbidv 3expib simp3ll
      simp1 simp2l f1of ffvelrnda eqeltrd simp3lr simp2r simp3r wi f1ocnvfv mpd
      3brtr4d jca31 3exp rexlimdvv impbid opabbidv syl5eq f1oiso mpdan ) CDGUAZ
      FAKZIKZGLZMZBKZJKZGLZMZNZWFWJEOZNZJCPZICPZABUDZMCDEFGUBWDFWEDQZWIDQZNZWEG
      UEZLZWIXBLZEOZNZABUDWRHWDXFWQABWDXFWQWDXAXEWQWDXAXEUCZXCCQZWEXCGLZMZWLNZX
      CWJEOZNZJCPZWQWDXAXHXEWDWSXHWTCDWEGUFUGRXGXDCQZXJWIXDGLZMZNZXEXNWDXAXOXEW
      DWTXOWSCDWIGUFUNRWDXAXRXEWDWSXJWTXQWDWSNXIWECDWEGUHSWDWTNXPWICDWIGUHSUIRW
      DXAXEUJXMXRXENJXDCWJXDMZXKXRXLXEXSWLXQXJXSWKXPWIWJXDGUKULUMWJXDXCEUOUPUQU
      RWPXNIXCCWFXCMZWOXMJCXTWMXKWNXLXTWHXJWLXTWGXIWEWFXCGUKULUSWFXCWJEUTUPVAUQ
      TVBWDWOXFIJCCWDWFCQZWJCQZNZWOXFWDYCWOUCZWSWTXEYDWEWGDWHWLWNWDYCVCZYDWDYAW
      GDQWDYCWOVDZWDYAYBWOVEZWDCDWFGCDGVFZVGTVHYDWIWKDWHWLWNWDYCVIZYDWDYBWKDQYF
      WDYAYBWOVJZWDCDWJGYHVGTVHYDWFWJXCXDEWDYCWMWNVKYDWGWEMZXCWFMZYDWEWGYESYDWD
      YAYKYLVLYFYGCDWFWEGVMTVNYDWKWIMZXDWJMZYDWIWKYISYDWDYBYMYNVLYFYJCDWJWIGVMT
      VNVOVPVQVRVSVTWAIJABCDEFGWBWC $.
  $}

  ${
    $d z w R $.  $d x y z w S $.  $d z w A $.  $d z w B $.  $d x y z w F $.
    f1owe.1 $e |- R = { <. x , y >. | ( F ` x ) S ( F ` y ) } $.
    $( Well-ordering of isomorphic relations.  (Contributed by NM,
       4-Mar-1997.) $)
    f1owe $p |- ( F : A -1-1-onto-> B -> ( S We B -> R We A ) ) $=
      ( vz vw wf1o wwe cv wbr cfv wb wral weq fveq2 breq1d breq2d brabg wa wiso
      rgen2a df-isom isowe sylbir mpan2 biimprd ) CDGKZCELZDFLZUKIMZJMZENUNGOZU
      OGOZFNZPZJCQICQZULUMPZUSIJCAMZGOZBMZGOZFNUPVEFNURABUNUOCCEAIRVCUPVEFVBUNG
      STBJRVEUQUPFVDUOGSUAHUBUEUKUTUCCDEFGUDVAIJCDEFGUFCDEFGUGUHUIUJ $.
  $}

  ${
    $d z w v u f R $.  $d x y z w v u f S $.  $d z w v u f A $.
    $d z w v u f B $.  $d x y z w v u f F $.
    f1oweALT.1 $e |- R = { <. x , y >. | ( F ` x ) S ( F ` y ) } $.
    $( Well-ordering of isomorphic relations.  (This version is proved directly
       instead of with the isomorphism predicate.)  (Contributed by NM,
       4-Mar-1997.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    f1oweALT $p |- ( F : A -1-1-onto-> B -> ( S We B -> R We A ) ) $=
      ( vu vf vw vv cv wbr wceq wral wa wi wcel cfv vz wf1o wfr w3o wwe wfo wfn
      f1ofo crn df-fo freq2 biimprd wfun cdm df-fn wss c0 wne wn wrex wal df-fr
      cima cvv vex funimaex wex n0 funfvima2 ne0i syl6 exlimdv syl5bi imp jctil
      imassrn sseq1 neeq1 anbi12d raleq rexeqbi1dv imbi12d spcgv syl7 syl com23
      exp3a anabsi5 imp3a cres wb fores fvres breqan12rd breq1d breq2d syl6rbbr
      fveq2 brab notbid rexbiia breq1 cbvfo rexbidv breq2 ralbidv cbvexfo bitrd
      ralbidva syl5bb sylibrd exp4b com34 alrimdv syl6ibr biimpd sylan9 sylan9r
      imp4a sylbi df-f1o f1fveq bicomd 3orbi123d 2ralbidva eqeq1 eqeq2 sylan9bb
      wf1 a1i anim12d dfwe2 3imtr4g ) CDGUBZDFUCZIMZJMZFNZYPYQOZYQYPFNZUDZJDPZI
      DPZQCEUCZKMZLMZENZUUEUUFOZUUFUUEENZUDZLCPKCPZQDFUECEUEYNYOUUDUUCUUKYNCDGU
      FZYOUUDRZCDGUHUULGCUGZGUIZDOZQUUMCDGUJUUPYOUUOFUCZUUNUUDUUPUUQYOUUODFUKUL
      UUNGUMZGUNZCOZQUUQUUDRGCUOUURUUQUUSEUCZUUTUUDUURUUQUAMZUUSUPZUVBUQURZQUUI
      USZLUVBPZKUVBUTZRZUAVAUVAUURUUQUVHUAUURUUQUVCUVDUVGUURUVCUUQUVDUVGRUURUVC
      UVDUUQUVGUURUVCUVDUUQUVGUURUVCQZUVDUUQQYTUSZJGUVBVCZPZIUVKUTZUVGUVIUVDUUQ
      UVMUURUVCUVDUUQUVMRZRUURUVIUVDUVNUURUUQUVIUVDQZUVMUUQUUEUUOUPZUUEUQURZQZU
      VJJUUEPZIUUEUTZRZKVAZUURUVOUVMRZKIJUUOFVBUURUVKVDSZUWBUWCRGUVBUAVEVFUVOUV
      KUUOUPZUVKUQURZQZUWDUWBUVMUVOUWFUWEUVIUVDUWFUVDUUEUVBSZKVGUVIUWFKUVBVHUVI
      UWHUWFKUVIUWHUUEGTZUVKSUWFUVBUUEGVIUVKUWIVJVKVLVMVNGUVBVPVOUWAUWGUVMRKUVK
      VDUUEUVKOZUVRUWGUVTUVMUWJUVPUWEUVQUWFUUEUVKUUOVQUUEUVKUQVRVSUVSUVLIUUEUVK
      UVJJUUEUVKVTWAWBWCWDWEVMWFWGWHWIUVIUVBUVKGUVBWJZUFZUVGUVMWKUVBGWLUVGUUFUW
      KTZUUEUWKTZFNZUSZLUVBPZKUVBUTZUWLUVMUVFUWQKUVBUWHUVEUWPLUVBUWHUUFUVBSZQZU
      UIUWOUWTUWOUUFGTZUWIFNZUUIUWSUWHUWMUXAUWNUWIFUUFUVBGWMUUEUVBGWMWNAMZGTZBM
      ZGTZFNZUXAUXFFNUXBABUUFUUEELVEZKVEZUXCUUFOUXDUXAUXFFUXCUUFGWRWOUXEUUEOUXF
      UWIUXAFUXEUUEGWRWPHWSZWQWTXIXAUWLUWRYQUWNFNZUSZJUVKPZKUVBUTUVMUWLUWQUXMKU
      VBUWPUXLLJUVBUVKUWKUWMYQOUWOUXKUWMYQUWNFXBWTXCXDUXMUVLKIUVBUVKUWKUWNYPOZU
      XLUVJJUVKUXNUXKYTUWNYPYQFXEWTXFXGXHXJWEXKXLXMWFXSXNUAKLUUSEVBXOUUTUVAUUDU
      USCEUKXPXQXTXRXTWEYNUUKUUCYNCDGYIZUULQUUKUUCWKCDGYAUXOUUKUWIUXAFNZUWIUXAO
      ZUXBUDZLCPZKCPZUULUUCUXOUUJUXRKLCCUXOUUECSUUFCSQQZUUGUXPUUHUXQUUIUXBUUGUX
      PWKUYAUXGUWIUXFFNUXPABUUEUUFEUXIUXHUXCUUEOUXDUWIUXFFUXCUUEGWRWOUXEUUFOUXF
      UXAUWIFUXEUUFGWRWPHWSYJUYAUXQUUHCDUUEUUFGYBYCUUIUXBWKUYAUXJYJYDYEUULUXTYP
      UXAFNZYPUXAOZUXAYPFNZUDZLCPZIDPUUCUXSUYFKICDGUWIYPOZUXRUYELCUYGUXPUYBUXQU
      YCUXBUYDUWIYPUXAFXBUWIYPUXAYFUWIYPUXAFXEYDXFXCUULUYFUUBIDUYEUUALJCDGUXAYQ
      OUYBYRUYCYSUYDYTUXAYQYPFXEUXAYQYPYGUXAYQYPFXBYDXCXFXHYHXTULYKIJDFYLKLCEYL
      YM $.
  $}

  ${
    $d A a b c $.  $d R b c $.  $d F a b c $.
    $( A set-like well-ordering has no nontrivial automorphisms.  (Contributed
       by Stefan O'Rear, 16-Nov-2014.)  (Revised by Mario Carneiro,
       25-Jun-2015.) $)
    weniso $p |- ( ( R We A /\ R Se A /\ F Isom R , R ( A , A ) ) ->
        F = ( _I |` A ) ) $=
      ( va vc vb wceq cfv wral wn wbr wa syl wcel wi fveq2 id eqeq12d wb adantr
      wwe wse wiso w3a cid cres cv crab c0 wne wrex rabn0 rexnal bitri wreu wss
      simpl1 simpl2 ssrab2 a1i simpr wereu2 syl22anc reurex notbid elrab ralrab
      ex con34b bicomi ralbii wf1o wf simpl3 isof1o f1of ffvelrnd breq1 imbi12d
      simprl rspcv com23 f1of1 f1fveq syl12anc pm2.21 ad2antll sylbid syld ccnv
      imp wf1 f1ocnv 3syl isorel f1ocnvfv2 syl2anc breq1d bitr2d biimpa simplrr
      sylc adantl fveq2d 3eqtr3d wo simprr weso sotrieq con2bid mpbird mpjaodan
      wor syl5bi rexlimdv syl5bir pm2.18d fvresi biimprd ralimia 3ad2ant3 f1ofn
      eqeq2d wfn fnresi eqfnfv ) ABUAZABUBZAABBCUCZUDZCUEAUFZGZDUGZCHZYMYKHZGZD
      AIZYJYNYMGZDAIZYQYJYSYSJZYRJZDAUHZUIUJZYJYSUUCUUADAUKYTUUADAULYRDAUMUNYJU
      UCEUGZFUGZBKZJZEUUBIZFUUBUKZYSYJUUCUUIYJUUCLZUUHFUUBUOZUUIUUJYGYHUUBAUPZU
      UCUUKYGYHYIUUCUQYGYHYIUUCURUULUUJUUADAUSUTYJUUCVAFEAUUBBVBVCUUHFUUBVDMVHY
      JUUHYSFUUBUUEUUBNUUEANZUUECHZUUEGZJZLZYJUUHYSOZUUAUUPDUUEAYMUUEGZYRUUOUUS
      YNUUNYMUUEYMUUECPUUSQRVEVFYJUUQUURUUHUUFUUDCHZUUDGZOZEAIZYJUUQLZYSUUHUVAJ
      ZUUGOZEAIUVCUUAUVEUUGEDAYMUUDGZYRUVAUVGYNUUTYMUUDYMUUDCPUVGQRVEVGUVFUVBEA
      UVBUVFUUFUVAVIVJVKUNUVDUUNUUEBKZUVCYSOUUEUUNBKZUVDUVHLUVCUUNCHZUUNGZYSUVD
      UVHUVCUVKOUVDUVCUVHUVKUVDUUNANZUVCUVHUVKOZOUVDAAUUECUVDAACVLZAACVMUVDYIUV
      NYGYHYIUUQVNZAABBCVOZMZAACVPMYJUUMUUPVTZVQZUVBUVMEUUNAUUDUUNGZUUFUVHUVAUV
      KUUDUUNUUEBVRUVTUUTUVJUUDUUNUUDUUNCPUVTQRVSWAMWBWKUVDUVKYSOUVHUVDUVKUUOYS
      UVDAACWLZUVLUUMUVKUUOSUVDUVNUWAUVQAACWCMUVSUVRAAUUNUUECWDWEUUPUUOYSOYJUUM
      UUOYSWFZWGWHTWIUVDUVILZUVCUUECWJZHZCHZUWEGZYSUWCUWEANZUWEUUEBKZUVCUWGOUVD
      UWHUVIUVDAAUUEUWDUVDUVNAAUWDVLAAUWDVMUVQAACWMAAUWDVPWNUVRVQZTUVDUVIUWIUVD
      UWIUWFUUNBKZUVIUVDYIUWHUUMUWIUWKSUVOUWJUVRAAUWEUUEBBCWOWEUVDUWFUUEUUNBUVD
      UVNUUMUWFUUEGZUVQUVRAAUUECWPWQZWRWSWTUWHUVCUWIUWGUVBUWIUWGOEUWEAUUDUWEGZU
      UFUWIUVAUWGUUDUWEUUEBVRUWNUUTUWFUUDUWEUUDUWECPUWNQRVSWAWBXBUVDUWGYSOUVIUV
      DUWGYSUVDUWGLZUUPUUOYSYJUUMUUPUWGXAUWOUWFCHZUWFUUNUUEUWGUWPUWFGUVDUWFUWEC
      PXCUVDUWPUUNGUWGUVDUWFUUECUWMXDTUVDUWLUWGUWMTXEUWBXBVHTWIUVDUVHUVIXFZUUPY
      JUUMUUPXGUVDUUOUWQUVDABXMZUVLUUMUUOUWQJSUVDYGUWRYGYHYIUUQUQABXHMUVSUVRAUU
      NUUEBXIWEXJXKXLXNVHXNXOWIXPXQYRYPDAYMANZYPYRUWSYOYMYNAYMXRYCXSXTMYJCAYDZY
      KAYDZYLYQSYJUVNUWTYIYGUVNYHUVPYAAACYBMUXAYJAYEUTDACYKYFWQXK $.

    $( Thus, there is at most one isomorphism between any two set-like
       well-ordered classes.  Class version of ~ wemoiso .  (Contributed by
       Mario Carneiro, 25-Jun-2015.) $)
    weisoeq $p |- ( ( ( R We A /\ R Se A ) /\
      ( F Isom R , S ( A , B ) /\ G Isom R , S ( A , B ) ) ) -> F = G ) $=
      ( wwe wse wa wiso wceq ccnv ccom cid cres wf1 wf1o isof1o f1of1 3syl id
      isocnv isotr syl2anr weniso sylan2 simprl simprr f1eqcocnv syl2anc mpbird
      3expa wb ) ACGZACHZIZABCDEJZABCDFJZIZIZEFKZELZFMZNAOKZUSUPAACCVCJZVDURURB
      ADCVBJVEUQURUAABCDEUBABACDCVBFUCUDUNUOVEVDACVCUEULUFUTABEPZABFPZVAVDUMUTU
      QABEQVFUPUQURUGABCDERABESTUTURABFQVGUPUQURUHABCDFRABFSTABEFUIUJUK $.

    $( Thus, there is at most one isomorphism between any two set-like
       well-ordered classes.  Class version of ~ wemoiso2 .  (Contributed by
       Mario Carneiro, 25-Jun-2015.) $)
    weisoeq2 $p |- ( ( ( S We B /\ S Se B ) /\
      ( F Isom R , S ( A , B ) /\ G Isom R , S ( A , B ) ) ) -> F = G ) $=
      ( wwe wse wa wiso wceq ccnv isocnv anim12i weisoeq wrel wf1o isof1o 3syl
      f1orel sylan2 wb simprl simprr cnveqb syl2anc mpbird ) BDGBDHIZABCDEJZABC
      DFJZIZIZEFKZELZFLZKZUKUHBADCUNJZBADCUOJZIUPUIUQUJURABCDEMABCDFMNBADCUNUOO
      UAULEPZFPZUMUPUBULUIABEQUSUHUIUJUCABCDERABETSULUJABFQUTUHUIUJUDABCDFRABFT
      SEFUEUFUG $.
  $}

  ${
    $d R f g $.  $d A f g $.  $d S f g $.  $d B f g $.
    $( Thus, there is at most one isomorphism between any two well-ordered
       sets.  TODO:  Shorten ~ finnisoeu .  (Contributed by Stefan O'Rear,
       12-Feb-2015.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    wemoiso $p |- ( R We A -> E* f f Isom R , S ( A , B ) ) $=
      ( vg wwe cv wiso wa weq wi wal wmo wse simpl cvv wcel wf syl isof1o dmfex
      vex wf1o f1of sylancr ad2antrl exse jca weisoeq sylancom ex isoeq1 sylibr
      alrimivv mo4 ) ACGZABCDEHZIZABCDFHZIZJZEFKZLZFMEMUSENUQVDEFUQVBVCUQVBUQAC
      OZJVCUQVBJZUQVEUQVBPVFAQRZVEUSVGUQVAUSURQRABURSZVGEUCUSABURUDVHABCDURUAAB
      URUETABQURUBUFUGACQUHTUIABCDURUTUJUKULUOUSVAEFABCDUTURUMUPUN $.

    $( Thus, there is at most one isomorphism between any two well-ordered
       sets.  (Contributed by Stefan O'Rear, 12-Feb-2015.)  (Revised by Mario
       Carneiro, 25-Jun-2015.) $)
    wemoiso2 $p |- ( S We B -> E* f f Isom R , S ( A , B ) ) $=
      ( vg wwe cv wiso wa wceq wi wal wmo wse simpl cvv wcel crn wf1o wfo f1ofo
      isof1o forn 3syl vex rnex syl6eqelr ad2antrl syl jca weisoeq2 sylancom ex
      exse alrimivv isoeq1 mo4 sylibr ) BDGZABCDEHZIZABCDFHZIZJZVAVCKZLZFMEMVBE
      NUTVGEFUTVEVFUTVEUTBDOZJVFUTVEJZUTVHUTVEPVIBQRZVHVBVJUTVDVBBVASZQVBABVATA
      BVAUAVKBKABCDVAUCABVAUBABVAUDUEVAEUFUGUHUIBDQUOUJUKABCDVAVCULUMUNUPVBVDEF
      ABCDVCVAUQURUS $.
  $}

  ${
    $d w x y z A $.  $d w x y z F $.  $d w V $.  $d w x y X $.
    knatar.1 $e |- X = |^| { z e. ~P A | ( F ` z ) C_ z } $.
    $( The Knaster-Tarski theorem says that every monotone function over a
       complete lattice has a (least) fixpoint.  Here we specialize this
       theorem to the case when the lattice is the powerset lattice ` ~P A ` .
       (Contributed by Mario Carneiro, 11-Jun-2015.) $)
    knatar $p |- ( ( A e. V /\ ( F ` A ) C_ A /\
        A. x e. ~P A A. y e. ~P x ( F ` y ) C_ ( F ` x ) ) ->
      ( X C_ A /\ ( F ` X ) = X ) ) $=
      ( vw wcel cfv wss cv cpw wral wceq fveq2 sylibr rspcv sylc w3a crab pwidg
      cint 3ad2ant1 simp2 id sseq12d intminss syl2anc syl5eqss wi wa adantl vex
      elpw2 simprl simpl3 pweq sseq2d raleqbidv sseq1d sstrd ralrimiva ssintrab
      simprr expr cbvrabv inteqi eqtri syl6sseqr elpw2g mpbird simp3 fvex eqssd
      wb elpw jca ) DFJZDEKZDLZBMZEKZAMZEKZLZBWENZOZADNZOZUAZGDLZGEKZGPWLGCMZEK
      ZWOLZCWJUBZUDZDHWLDWJJZWBWSDLVTWBWTWKDFUCUEZVTWBWKUFZWQWBCDWJWODPZWPWAWOD
      WODEQXCUGUHUIUJUKZWLWNGWLWNIMZEKZXELZIWJUBZUDZGWLXGWNXELZULZIWJOWNXILWLXK
      IWJWLXEWJJZXGXJWLXLXGUMZUMZWNXFXEXNGXENZJZWDXFLZBXOOZWNXFLZXNGXELXPXNGWSX
      EHXMWSXELWLWQXGCXEWJWOXEPZWPXFWOXEWOXEEQXTUGUHZUIUNUKGXEIUOUPRXNXLWKXRWLX
      LXGUQVTWBWKXMURWIXRAXEWJWEXEPZWGXQBWHXOWEXEUSYBWFXFWDWEXEEQUTVASTXQXSBGXO
      WCGPZWDWNXFWCGEQZVBSTWLXLXGVFVCVGVDXGIWNWJVERGWSXIHWRXHWQXGCIWJYAVHVIVJZV
      KZWLGXIWNYEWLWNWJJZWNEKZWNLZXIWNLWLWNDLYGWLWNWADWLGWJJZWDWALZBWJOZWNWALZW
      LYJWMXDVTWBYJWMVQWKGDFVLUEVMZWLWTWKYLXAVTWBWKVNZWIYLADWJWEDPZWGYKBWHWJWED
      USYPWFWAWDWEDEQUTVASTYKYMBGWJYCWDWNWAYDVBSTXBVCWNDGEVOZVRRWLWNGNZJZWDWNLZ
      BYROZYIWLWNGLYSYFWNGYQVRRWLYJWKUUAYNYOWIUUAAGWJWEGPZWGYTBWHYRWEGUSUUBWFWN
      WDWEGEQUTVASTYTYIBWNYRWCWNPWDYHWNWCWNEQVBSTXGYIIWNWJXEWNPZXFYHXEWNXEWNEQU
      UCUGUHUIUJUKVPVS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend class notation to include the value of an operation ` F ` (such as
     ` + ` ) for two arguments ` A ` and ` B ` .  Note that the syntax is
     simply three class symbols in a row surrounded by parentheses.  Since
     operation values are the only possible class expressions consisting of
     three class expressions in a row surrounded by parentheses, the syntax is
     unambiguous.  (For an example of how syntax could become ambiguous if we
     are not careful, see the comment in ~ cneg .) $)
  co $a class ( A F B ) $.

  $( Extend class notation to include class abstraction (class builder) of
     nested ordered pairs. $)
  coprab $a class { <. <. x , y >. , z >. | ph } $.

  $( Extend the definition of a class to include maps-to notation for defining
     an operation via a rule. $)
  cmpt2 $a class ( x e. A , y e. B |-> C ) $.

  $( Define the value of an operation.  Definition of operation value in
     [Enderton] p. 79.  Note that the syntax is simply three class expressions
     in a row bracketed by parentheses.  There are no restrictions of any kind
     on what those class expressions may be, although only certain kinds of
     class expressions - a binary operation ` F ` and its arguments ` A ` and
     ` B ` - will be useful for proving meaningful theorems.  For example, if
     class ` F ` is the operation ` + ` and arguments ` A ` and ` B ` are ` 3 `
     and ` 2 ` , the expression ` ( 3 + 2 ) ` can be proved to equal ` 5 ` (see
     ~ 3p2e5 ).  This definition is well-defined, although not very meaningful,
     when classes ` A ` and/or ` B ` are proper classes (i.e. are not sets);
     see ~ ovprc1 and ~ ovprc2 .  On the other hand, we often find uses for
     this definition when ` F ` is a proper class, such as ` +o ` in ~ oav .
     ` F ` is normally equal to a class of nested ordered pairs of the form
     defined by ~ df-oprab .  (Contributed by NM, 28-Feb-1995.) $)
  df-ov $a |- ( A F B ) = ( F ` <. A , B >. ) $.

  ${
    $d x w $.  $d y w $.  $d z w $.  $d w ph $.
    $( Define the class abstraction (class builder) of a collection of nested
       ordered pairs (for use in defining operations).  This is a special case
       of Definition 4.16 of [TakeutiZaring] p. 14.  Normally ` x ` , ` y ` ,
       and ` z ` are distinct, although the definition doesn't strictly require
       it.  See ~ df-ov for the value of an operation.  The brace notation is
       called "class abstraction" by Quine; it is also called a "class builder"
       in the literature.  The value of the most common operation class builder
       is given by ~ ovmpt2 .  (Contributed by NM, 12-Mar-1995.) $)
    df-oprab $a |- { <. <. x , y >. , z >. | ph } =
                  { w | E. x E. y E. z ( w = <. <. x , y >. , z >. /\ ph ) } $.
  $}

  ${
    $d x z $.  $d y z $.  $d z A $.  $d z B $.  $d z C $.
    $( Define maps-to notation for defining an operation via a rule.  Read as
       "the operation defined by the map from ` x , y ` (in ` A X. B ` ) to
       ` B ( x , y ) ` ."  An extension of ~ df-mpt for two arguments.
       (Contributed by NM, 17-Feb-2008.) $)
    df-mpt2 $a |- ( x e. A , y e. B |-> C ) =
             { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ z = C ) } $.
  $}

  $( Equality theorem for operation value.  (Contributed by NM,
     28-Feb-1995.) $)
  oveq $p |- ( F = G -> ( A F B ) = ( A G B ) ) $=
    ( wceq cop cfv co fveq1 df-ov 3eqtr4g ) CDEABFZCGLDGABCHABDHLCDIABCJABDJK
    $.

  $( Equality theorem for operation value.  (Contributed by NM,
     28-Feb-1995.) $)
  oveq1 $p |- ( A = B -> ( A F C ) = ( B F C ) ) $=
    ( wceq cop cfv co opeq1 fveq2d df-ov 3eqtr4g ) ABEZACFZDGBCFZDGACDHBCDHMNOD
    ABCIJACDKBCDKL $.

  $( Equality theorem for operation value.  (Contributed by NM,
     28-Feb-1995.) $)
  oveq2 $p |- ( A = B -> ( C F A ) = ( C F B ) ) $=
    ( wceq cop cfv co opeq2 fveq2d df-ov 3eqtr4g ) ABEZCAFZDGCBFZDGCADHCBDHMNOD
    ABCIJCADKCBDKL $.

  $( Equality theorem for operation value.  (Contributed by NM,
     16-Jul-1995.) $)
  oveq12 $p |- ( ( A = B /\ C = D ) -> ( A F C ) = ( B F D ) ) $=
    ( wceq co oveq1 oveq2 sylan9eq ) ABFCDFACEGBCEGBDEGABCEHCDBEIJ $.

  ${
    oveq1i.1 $e |- A = B $.
    $( Equality inference for operation value.  (Contributed by NM,
       28-Feb-1995.) $)
    oveq1i $p |- ( A F C ) = ( B F C ) $=
      ( wceq co oveq1 ax-mp ) ABFACDGBCDGFEABCDHI $.

    $( Equality inference for operation value.  (Contributed by NM,
       28-Feb-1995.) $)
    oveq2i $p |- ( C F A ) = ( C F B ) $=
      ( wceq co oveq2 ax-mp ) ABFCADGCBDGFEABCDHI $.

    ${
      oveq12i.2 $e |- C = D $.
      $( Equality inference for operation value.  (Contributed by NM,
         28-Feb-1995.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
      oveq12i $p |- ( A F C ) = ( B F D ) $=
        ( wceq co oveq12 mp2an ) ABHCDHACEIBDEIHFGABCDEJK $.
    $}

    $( Equality inference for operation value.  (Contributed by NM,
       24-Nov-2007.) $)
    oveqi $p |- ( C A D ) = ( C B D ) $=
      ( wceq co oveq ax-mp ) ABFCDAGCDBGFECDABHI $.
  $}

  ${
    oveq123i.1 $e |- A = C $.
    oveq123i.2 $e |- B = D $.
    oveq123i.3 $e |- F = G $.
    $( Equality inference for operation value.  (Contributed by FL,
       11-Jul-2010.) $)
    oveq123i $p |- ( A F B ) = ( C G D ) $=
      ( co oveq12i oveqi eqtri ) ABEJCDEJCDFJACBDEGHKEFCDILM $.
  $}

  ${
    oveq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for operation value.  (Contributed by NM,
       13-Mar-1995.) $)
    oveq1d $p |- ( ph -> ( A F C ) = ( B F C ) ) $=
      ( wceq co oveq1 syl ) ABCGBDEHCDEHGFBCDEIJ $.

    $( Equality deduction for operation value.  (Contributed by NM,
       13-Mar-1995.) $)
    oveq2d $p |- ( ph -> ( C F A ) = ( C F B ) ) $=
      ( wceq co oveq2 syl ) ABCGDBEHDCEHGFBCDEIJ $.

    $( Equality deduction for operation value.  (Contributed by NM,
       9-Sep-2006.) $)
    oveqd $p |- ( ph -> ( C A D ) = ( C B D ) ) $=
      ( wceq co oveq syl ) ABCGDEBHDECHGFDEBCIJ $.

    ${
      oveq12d.2 $e |- ( ph -> C = D ) $.
      $( Equality deduction for operation value.  (Contributed by NM,
         13-Mar-1995.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
      oveq12d $p |- ( ph -> ( A F C ) = ( B F D ) ) $=
        ( wceq co oveq12 syl2anc ) ABCIDEIBDFJCEFJIGHBCDEFKL $.
    $}

    ${
      opreqan12i.2 $e |- ( ps -> C = D ) $.
      $( Equality deduction for operation value.  (Contributed by NM,
         10-Aug-1995.) $)
      oveqan12d $p |- ( ( ph /\ ps ) -> ( A F C ) = ( B F D ) ) $=
        ( wceq co oveq12 syl2an ) ACDJEFJCEGKDFGKJBHICDEFGLM $.

      $( Equality deduction for operation value.  (Contributed by NM,
         10-Aug-1995.) $)
      oveqan12rd $p |- ( ( ps /\ ph ) -> ( A F C ) = ( B F D ) ) $=
        ( co wceq oveqan12d ancoms ) ABCEGJDFGJKABCDEFGHILM $.
    $}
  $}

  ${
    oveq123d.1 $e |- ( ph -> F = G ) $.
    oveq123d.2 $e |- ( ph -> A = B ) $.
    oveq123d.3 $e |- ( ph -> C = D ) $.
    $( Equality deduction for operation value.  (Contributed by FL,
       22-Dec-2008.) $)
    oveq123d $p |- ( ph -> ( A F C ) = ( B G D ) ) $=
      ( co oveqd oveq12d eqtrd ) ABDFKBDGKCEGKAFGBDHLABCDEGIJMN $.
  $}

  ${
    nfovd.2 $e |- ( ph -> F/_ x A ) $.
    nfovd.3 $e |- ( ph -> F/_ x F ) $.
    nfovd.4 $e |- ( ph -> F/_ x B ) $.
    $( Deduction version of bound-variable hypothesis builder ~ nfov .
       (Contributed by NM, 13-Dec-2005.)  (Proof shortened by Andrew Salmon,
       22-Oct-2011.) $)
    nfovd $p |- ( ph -> F/_ x ( A F B ) ) $=
      ( co cop cfv df-ov nfopd nffvd nfcxfrd ) ABCDEICDJZEKCDELABPEGABCDFHMNO
      $.
  $}

  ${
    nfov.1 $e |- F/_ x A $.
    nfov.2 $e |- F/_ x F $.
    nfov.3 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for operation value.  (Contributed by
       NM, 4-May-2004.) $)
    nfov $p |- F/_ x ( A F B ) $=
      ( co wnfc wtru a1i nfovd trud ) ABCDHIJABCDABIJEKADIJFKACIJGKLM $.
  $}

  ${
    $d a ph r s t w $.  $d a r s t w x $.  $d a r s t w y $.  $d a r s t w z $.
    $( The law of concretion.  Special case of Theorem 9.5 of [Quine] p. 61.
       (Contributed by Mario Carneiro, 20-Mar-2013.) $)
    oprabid $p |- ( <. <. x , y >. , z >. e.
        { <. <. x , y >. , z >. | ph } <-> ph ) $=
      ( vw va vt vr vs cv cop wceq wa wex wi vex weq wal wn nfcvf2 opex eqvinop
      coprab biimpi eqeq1 opth1 syl6bi opeq1 eqeq2d df-3an anbi1i 3bitri 3exbii
      w3a otth2 bitri anass nfcvd nfeqd exdistrf eximi excom 3imtr4i 3syl sylbi
      anim2i weu euequ1 eupick mpan syl6 3impd syl5bi com12 eqcom syl6bb anbi1d
      syl5 3exbidv imbi1d imbi12d mpbiri adantr exlimivv com3l mpdd mpcom 19.8a
      ex impbid df-oprab elab2 ) EJZBJZCJZKZDJZKZLZAMZDNZCNZBNZAEWRABCDUCWPWQUA
      WSXCAWMFJZGJZKZLZXFWRLZMZGNFNZWSXCAOZWSXJFGWMWPWQWNWOUADPZUBUDXIWSXKOZFGX
      GXMXHXGWSXDWPLZXKXGWSXHXNWMXFWRUEXDXEWPWQFPGPUFUGXNXGWSXKXNXDHJZIJZKZLZXQ
      WPLZMZINHNXGXMOZHIXDWNWOBPZCPZUBXTYAHIXRYAXSXRXGWMXQXEKZLZXMXRXFYDWMXDXQX
      EUHUIYEXMWRYDLZYFAMZDNCNBNZAOZOYHBHQZCIQZDGQZAMZDNZMCNZMZBNZYFAYHYJYKYMMZ
      MZDNZCNBNZYQYGYSBCDYGYJYKMZYLMZAMUUBYMMYSYFUUCAYFYJYKYLUNZUUCWNWOXOXPWQXE
      YBYCXLUOZYJYKYLUJUPUKUUBYLAUQYJYKYMUQULUMUUAYJYRDNZMZCNBNZYJUUFCNZMZBNYQY
      TBNZCNUUGBNZCNUUAUUHUUKUULCYJYRBDBDQBRSZDWNXOBDTUUMDXOURUSUTVAYTBCVBUUGBC
      VBVCYJUUFBCBCQBRSZCWNXOBCTUUNCXOURUSUTUUJYPBUUIYOYJYKYMCDCDQCRSZDWOXPCDTU
      UODXPURUSUTVFVAVDVEYQYFAYFUUDYQAUUEYQYJYKYLAYQYJYOYKYLAOZOYJBVGYQYJYOOBHV
      HYJYOBVIVJYOYKYNUUPYKCVGYOYKYNOCIVHYKYNCVIVJYLDVGYNUUPDGVHYLADVIVJVKVKVLV
      MVNVRYEWSYFXKYIYEWSYDWRLYFWMYDWRUEYDWRVOVPZYEXCYHAYEWTYGBCDYEWSYFAUUQVQVS
      VTWAWBUGWCWDVEWEWFWCWDWGWSAXCWTXAXBXCWTDWHXACWHXBBWHVDWIWJABCDEWKWL $.
  $}

  $( The result of an operation is a set.  (Contributed by NM, 13-Mar-1995.) $)
  ovex $p |- ( A F B ) e. _V $=
    ( co cop cfv cvv df-ov fvex eqeltri ) ABCDABEZCFGABCHKCIJ $.

  $( The result of an operation value is always a subset of the union of the
     range.  (Contributed by Mario Carneiro, 12-Jan-2017.) $)
  ovssunirn $p |- ( X F Y ) C_ U. ran F $=
    ( co cop cfv crn cuni df-ov fvssunirn eqsstri ) BCADBCEZAFAGHBCAIALJK $.

  ${
    ovprc1.1 $e |- Rel dom F $.
    $( The value of an operation when the one of the arguments is a proper
       class.  Note: this theorem is dependent on our particular definitions of
       operation value, function value, and ordered pair.  (Contributed by
       Mario Carneiro, 26-Apr-2015.) $)
    ovprc $p |- ( -. ( A e. _V /\ B e. _V ) -> ( A F B ) = (/) ) $=
      ( cvv wcel wa wn co cop cfv df-ov cdm wceq wbr df-br wrel brrelex12 mpan
      c0 sylbir con3i ndmfv syl syl5eq ) AEFBEFGZHZABCIABJZCKZTABCLUGUHCMZFZHUI
      TNUKUFUKABUJOZUFABUJPUJQULUFDABUJRSUAUBUHCUCUDUE $.

    $( The value of an operation when the first argument is a proper class.
       (Contributed by NM, 16-Jun-2004.) $)
    ovprc1 $p |- ( -. A e. _V -> ( A F B ) = (/) ) $=
      ( cvv wcel wn wa co c0 wceq simpl con3i ovprc syl ) AEFZGPBEFZHZGABCIJKRP
      PQLMABCDNO $.

    $( The value of an operation when the second argument is a proper class.
       (Contributed by Mario Carneiro, 26-Apr-2015.) $)
    ovprc2 $p |- ( -. B e. _V -> ( A F B ) = (/) ) $=
      ( cvv wcel wn wa co c0 wceq simpr con3i ovprc syl ) BEFZGAEFZPHZGABCIJKRP
      QPLMABCDNO $.

    $( Reverse closure for an operation value.  (Contributed by Mario Carneiro,
       5-May-2015.) $)
    ovrcl $p |- ( C e. ( A F B ) -> ( A e. _V /\ B e. _V ) ) $=
      ( co wcel c0 wceq cvv wa n0i ovprc nsyl2 ) CABDFZGOHIAJGBJGKOCLABDEMN $.
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d y F $.  $d x y $.
    $( Move class substitution in and out of an operation.  (Contributed by NM,
       12-Nov-2005.)  (Revised by NM, 23-Aug-2018.) $)
    csbov123 $p |- [_ A / x ]_ ( B F C ) =
           ( [_ A / x ]_ B [_ A / x ]_ F [_ A / x ]_ C ) $=
      ( vy cvv wcel co csb wceq csbeq1 oveq123d nfcsb1v csbeq1a c0 csbprc eqtrd
      cfv a1i cv eqeq12d vex nfov weq csbief vtoclg cop df-ov eqid eqtri fveq1d
      wn 0fv eqcomd pm2.61i ) BGHZABCDEIZJZABCJZABDJZABEJZIZKZAFUAZURJZAVECJZAV
      EDJZAVEEJZIZKVDFBGVEBKZVFUSVJVCAVEBURLVKVGUTVHVAVIVBAVEBELAVEBCLAVEBDLMUB
      AVEURVJFUCAVGVHVIAVECNAVEENAVEDNUDAFUECVGDVHEVIAVEEOAVECOAVEDOMUFUGUQUMZU
      SPVCABURQVLVCPVLVCUTVAUHZVBSZPVCVNKVLVCVNVNUTVAVBUIVNUJUKTVLVNVMPSZPVLVMV
      BPABEQULVOPKVLVMUNTRRUORUP $.
  $}

  ${
    $d x B $.  $d x C $.
    $( Move class substitution in and out of an operation.  (Contributed by NM,
       23-Aug-2018.) $)
    csbov $p |- [_ A / x ]_ ( B F C ) = ( B [_ A / x ]_ F C ) $=
      ( co csb csbov123 cvv wcel wceq csbconstg oveq12d cop cfv 0fv df-ov eqtri
      c0 oveqd wn 3eqtr4ri csbprc 3eqtr4a pm2.61i ) ABCDEFGABCGZABDGZABEGZFZCDU
      HFZABCDEHBIJZUIUJKUKUFCUGDUHABCILABDILMUKUAZUFUGSFZCDSFZUIUJCDNZSOSUNUMUO
      PCDSQUMUFUGNZSOSUFUGSQUPPRUBULUHSUFUGABEUCZTULUHSCDUQTUDUER $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y z D $.  $d y z F $.
    $d x y z $.
    $( Move class substitution in and out of an operation.  (Contributed by NM,
       12-Nov-2005.)  (Proof shortened by Mario Carneiro, 5-Dec-2016.)
       Obsolete as of 20-Aug-2018.  Use ~ csbov123 instead.
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    csbovgOLD $p |- ( A e. D -> [_ A / x ]_ ( B F C ) =
           ( [_ A / x ]_ B [_ A / x ]_ F [_ A / x ]_ C ) ) $=
      ( vy cv co csb wceq csbeq1 oveq123d eqeq12d nfcsb1v csbeq1a csbief vtoclg
      vex nfov ) AGHZCDFIZJZAUACJZAUADJZAUAFJZIZKABUBJZABCJZABDJZABFJZIZKGBEUAB
      KZUCUHUGULAUABUBLUMUDUIUEUJUFUKAUABFLAUABCLAUABDLMNAUAUBUGGSAUDUEUFAUACOA
      UAFOAUADOTAHUAKCUDDUEFUFAUAFPAUACPAUADPMQR $.
  $}

  ${
    $d x F $.
    $( Move class substitution in and out of an operation.  (Contributed by NM,
       12-Nov-2005.) $)
    csbov12g $p |- ( A e. V ->
                 [_ A / x ]_ ( B F C ) = ( [_ A / x ]_ B F [_ A / x ]_ C ) ) $=
      ( wcel co csb csbov123 csbconstg oveqd syl5eq ) BFGZABCDEHIABCIZABDIZABEI
      ZHOPEHABCDEJNQEOPABEFKLM $.
  $}

  ${
    $d x C $.  $d x F $.
    $( Move class substitution in and out of an operation.  (Contributed by NM,
       12-Nov-2005.) $)
    csbov1g $p |- ( A e. V ->
                  [_ A / x ]_ ( B F C ) = ( [_ A / x ]_ B F C ) ) $=
      ( wcel co csb csbov12g csbconstg oveq2d eqtrd ) BFGZABCDEHIABCIZABDIZEHOD
      EHABCDEFJNPDOEABDFKLM $.
  $}

  ${
    $d x B $.  $d x F $.
    $( Move class substitution in and out of an operation.  (Contributed by NM,
       12-Nov-2005.) $)
    csbov2g $p |- ( A e. V ->
                  [_ A / x ]_ ( B F C ) = ( B F [_ A / x ]_ C ) ) $=
      ( wcel co csb csbov12g csbconstg oveq1d eqtrd ) BFGZABCDEHIABCIZABDIZEHCP
      EHABCDEFJNOCPEABCFKLM $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x y C $.  $d y D $.  $d x y F $.  $d x y S $.
    $( A frequently used special case of ~ rspc2ev for operation values.
       (Contributed by NM, 21-Mar-2007.) $)
    rspceov $p |- ( ( C e. A /\ D e. B /\ S = ( C F D ) ) ->
                 E. x e. A E. y e. B S = ( x F y ) ) $=
      ( cv co wceq oveq1 eqeq2d oveq2 rspc2ev ) GAIZBIZHJZKGEFHJZKGEQHJZKABEFCD
      PEKRTGPEQHLMQFKTSGQFEHNMO $.
  $}

  ${
    $( Equivalence of operation value and ordered triple membership, analogous
       to ~ fnopfvb .  (Contributed by NM, 17-Dec-2008.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    fnotovb $p |- ( ( F Fn ( A X. B ) /\ C e. A /\ D e. B ) ->
                   ( ( C F D ) = R <-> <. C , D , R >. e. F ) ) $=
      ( cxp wfn wcel w3a cop cfv wceq co cotp wb wa opelxpi fnopfvb sylan2
      3impb df-ov eqeq1i df-ot eleq1i 3bitr4g ) FABGZHZCAIZDBIZJCDKZFLZEMZUKEKZ
      FIZCDFNZEMCDEOZFIUHUIUJUMUOPZUIUJQUHUKUGIURCDABRUGUKEFSTUAUPULECDFUBUCUQU
      NFCDEUDUEUF $.
  $}

  ${
    $d E e f p v z $.  $d V e f p v z $.  $d W e v z $.  $d th z $.  $d ps z $.
    opabbrex.1 $e |- ( ( V e. _V /\ E e. _V ) -> ( f ( V W E ) p -> th ) ) $.
    opabbrex.2 $e |- ( ( V e. _V /\ E e. _V )
                       -> { <. f , p >. | th } e. _V ) $.
    $( A collection of ordered pairs with an extension of a binary relation is
       a set.  (Contributed by Alexander van der Vekens, 1-Nov-2017.) $)
    opabbrex $p |- ( ( V e. _V /\ E e. _V )
                    -> { <. f , p >. | ( f ( V W E ) p /\ ps ) } e. _V ) $=
      ( vz cvv wcel wa cv co wbr copab wex cab df-opab syl5eqelr adantrd anim2d
      cop wceq 2eximdv ss2abdv syl5eqss ssexd ) EKLDKLMZCNZGNZEDFOPZAMZCGQZJNUK
      ULUDUEZBMZGRCRZJSZKUJUSBCGQKBCGJTIUAUJUOUPUNMZGRCRZJSUSUNCGJTUJVAURJUJUTU
      QCGUJUNBUPUJUMBAHUBUCUFUGUHUI $.
  $}

  $( The empty set is never an element in an ordered-pair class abstraction.
     (Contributed by Alexander van der Vekens, 5-Nov-2017.) $)
  0neqopab $p |- -. (/) e. { <. x , y >. | ph } $=
    ( c0 copab wcel wn cv cop wa wex elopab nfopab1 nfel2 nfn nfopab2 vex sylbi
    wceq exlimi wne wi opnzi nesym pm2.21 ax-mp adantr id pm2.61i ) DABCEZFZUKG
    ZUKDBHZCHZIZSZAJZCKZBKULABCDLURULBUKBBDUJABCMNOUQULCUKCCDUJABCPNOUPULAUODUA
    ZUPULUBZUMUNBQCQUCUSUPGUTUODUDUPULUERUFUGTTRULUHUI $.

  $( If two classes are in a relationship given by an ordered-pair class
     abstraction, the classes are sets.  (Contributed by Alexander van der
     Vekens, 5-Nov-2017.) $)
  brabv $p |- ( X { <. x , y >. | ph } Y -> ( X e. _V /\ Y e. _V ) ) $=
    ( copab wbr cop wcel cvv wa df-br wn wceq opprc 0neqopab eleq1 mtbiri syl
    c0 con4i sylbi ) DEABCFZGDEHZUCIZDJIEJIKZDEUCLUFUEUFMUDTNZUEMDEOUGUETUCIABC
    PUDTUCQRSUAUB $.

  ${
    $d x z w v $.  $d y z w v $.  $d w ph v $.
    $( Class abstraction for operations in terms of class abstraction of
       ordered pairs.  (Contributed by NM, 12-Mar-1995.) $)
    dfoprab2 $p |- { <. <. x , y >. , z >. | ph } =
                   { <. w , z >. | E. x E. y ( w = <. x , y >. /\ ph ) } $=
      ( vv cv cop wceq wa wex cab coprab copab excom exrot4 opeq1 3bitr3i bitri
      eqeq2d pm5.32ri anbi1i anass an32 exbii opex isseti 19.42v 3exbii 19.42vv
      mpbiran2 2exbii abbii df-oprab df-opab 3eqtr4i ) FGZBGZCGZHZDGZHZIZAJZDKC
      KBKZFLUQEGZVAHZIZVFUTIZAJZCKBKZJZDKEKZFLABCDMVKEDNVEVMFVHVJJZCKBKZEKDKZVO
      DKEKVEVMVODEOVPVNEKZDKCKBKVEVNDEBCPVQVDBCDVQVDVIJZEKZVDVNVREVHVIJZAJVCVIJ
      ZAJVNVRVTWAAVIVHVCVIVGVBUQVFUTVAQTUAUBVHVIAUCVCVIAUDRUEVSVDVIEKEUTURUSUFU
      GVDVIEUHUKSUISVOVLEDVHVJBCUJULRUMABCDFUNVKEDFUOUP $.

    $( An operation class abstraction is a relation.  (Contributed by NM,
       16-Jun-2004.) $)
    reloprab $p |- Rel { <. <. x , y >. , z >. | ph } $=
      ( vw cv cop wceq wa wex coprab dfoprab2 relopabi ) EFBFCFGHAICJBJEDABCDKA
      BCDELM $.
  $}

$(
  @{
    @d x y z w v @.  @d ph v @.
    dfoprab2f.1 @e |- ( ph -> A. w ph ) @.
    @( Class abstraction for operations in terms of class abstraction of
       ordered pairs.  This is a version of ~ dfoprab2 with bound-variable
       hypothesis instead of distinct variable requirement. @)
    dfoprab2f @p |- { <. <. x , y >. , z >. | ph } =
                   { <. w , z >. | E. x E. y ( w = <. x , y >. /\ ph ) } @=
      ( vv coprab cv cop wceq wa wex copab dfoprab2 ax-17 hban hbex weq
      eqeq1 anbi1d 2exbidv cbvopab1
      eqtri ) ABCDHGIZBICIJZKZALZCMZBMZGDNEIZUFKZALZCMBM
      ZEDNABCDGOUJUNGDEUIEBUHECUGAEUGEPFQRRUNGPGESZUHUMBCUOUGULAUEUKUFTUAUBUCUD
      @.
  @}
$)

  ${
    $d w x $.  $d w y $.  $d w z $.  $d w ph $.
    $( The abstraction variables in an operation class abstraction are not
       free.  (Contributed by NM, 25-Apr-1995.)  (Revised by David Abernethy,
       19-Jun-2012.) $)
    nfoprab1 $p |- F/_ x { <. <. x , y >. , z >. | ph } $=
      ( vw coprab cv cop wceq wa wex cab df-oprab nfe1 nfab nfcxfr ) BABCDFEGBG
      CGHDGHIAJDKCKZBKZELABCDEMRBEQBNOP $.

    $( The abstraction variables in an operation class abstraction are not
       free.  (Contributed by NM, 25-Apr-1995.)  (Revised by David Abernethy,
       30-Jul-2012.) $)
    nfoprab2 $p |- F/_ y { <. <. x , y >. , z >. | ph } $=
      ( vw coprab cv cop wceq wa wex cab df-oprab nfe1 nfex nfab nfcxfr ) CABCD
      FEGBGCGHDGHIAJDKZCKZBKZELABCDEMTCESCBRCNOPQ $.

    $( The abstraction variables in an operation class abstraction are not
       free.  (Contributed by NM, 22-Aug-2013.) $)
    nfoprab3 $p |- F/_ z { <. <. x , y >. , z >. | ph } $=
      ( vw coprab cv cop wceq wa wex cab df-oprab nfe1 nfex nfab nfcxfr ) DABCD
      FEGBGCGHDGHIAJZDKZCKZBKZELABCDEMUADETDBSDCRDNOOPQ $.
  $}

  ${
    $d v w x $.  $d v w y $.  $d v w z $.  $d v ph $.
    nfoprab.1 $e |- F/ w ph $.
    $( Bound-variable hypothesis builder for an operation class abstraction.
       (Contributed by NM, 22-Aug-2013.) $)
    nfoprab $p |- F/_ w { <. <. x , y >. , z >. | ph } $=
      ( vv coprab cv cop wceq wa wex cab df-oprab nfv nfan nfex nfab nfcxfr ) E
      ABCDHGIBICIJDIJKZALZDMZCMZBMZGNABCDGOUEEGUDEBUCECUBEDUAAEUAEPFQRRRST $.
  $}

  ${
    $d x z w $.  $d y z w $.  $d w ph $.  $d w ps $.  $d w ch $.
    oprabbid.1 $e |- F/ x ph $.
    oprabbid.2 $e |- F/ y ph $.
    oprabbid.3 $e |- F/ z ph $.
    oprabbid.4 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal operation class abstractions (deduction
       rule).  (Contributed by NM, 21-Feb-2004.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    oprabbid $p |- ( ph ->
           { <. <. x , y >. , z >. | ps } = { <. <. x , y >. , z >. | ch } ) $=
      ( vw cv cop wceq wa wex cab coprab exbid df-oprab anbi2d abbidv 3eqtr4g )
      AKLDLELMFLMNZBOZFPZEPZDPZKQUDCOZFPZEPZDPZKQBDEFRCDEFRAUHULKAUGUKDGAUFUJEH
      AUEUIFIABCUDJUASSSUBBDEFKTCDEFKTUC $.
  $}

  ${
    $d x z w ph $.  $d y z w ph $.  $d w ps $.  $d w ch $.
    oprabbidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal operation class abstractions (deduction
       rule).  (Contributed by NM, 21-Feb-2004.) $)
    oprabbidv $p |- ( ph ->
           { <. <. x , y >. , z >. | ps } = { <. <. x , y >. , z >. | ch } ) $=
      ( nfv oprabbid ) ABCDEFADHAEHAFHGI $.
  $}

  ${
    $d x z w $.  $d y z w $.  $d w ph $.  $d w ps $.
    oprabbii.1 $e |- ( ph <-> ps ) $.
    $( Equivalent wff's yield equal operation class abstractions.  (Contributed
       by NM, 28-May-1995.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    oprabbii $p |- { <. <. x , y >. , z >. | ph }
                 = { <. <. x , y >. , z >. | ps } $=
      ( vw cv wceq coprab eqid wb a1i oprabbidv ax-mp ) GHZPIZACDEJBCDEJIPKQABC
      DEABLQFMNO $.
  $}

  ${
    $d ph w $.  $d ps w $.  $d x w $.  $d y w $.  $d z w $.
    $( Equivalence of ordered pair abstraction subclass and implication.
       Compare ~ ssopab2 .  (Contributed by FL, 6-Nov-2013.)  (Proof shortened
       by Mario Carneiro, 11-Dec-2016.) $)
    ssoprab2 $p |- ( A. x A. y A. z ( ph -> ps ) ->
        { <. <. x , y >. , z >. | ph } C_ { <. <. x , y >. , z >. | ps } ) $=
      ( vw wi wal cv cop wceq wa wex cab coprab id alimi exim syl df-oprab
      anim2d ss2abdv 3sstr4g ) ABGZEHZDHZCHZFICIDIJEIJKZALZEMZDMZCMZFNUHBLZEMZD
      MZCMZFNACDEOBCDEOUGULUPFUGUKUOGZCHULUPGUFUQCUFUJUNGZDHUQUEURDUEUIUMGZEHUR
      UDUSEUDABUHUDPUAQUIUMERSQUJUNDRSQUKUOCRSUBACDEFTBCDEFTUC $.
  $}

  $( Equivalence of ordered pair abstraction subclass and implication.  Compare
     ~ ssopab2b .  (Contributed by FL, 6-Nov-2013.)  (Proof shortened by Mario
     Carneiro, 11-Dec-2016.) $)
  ssoprab2b $p |- ( { <. <. x , y >. , z >. | ph } C_
    { <. <. x , y >. , z >. | ps } <-> A. x A. y A. z ( ph -> ps ) ) $=
    ( coprab wss wi wal nfoprab1 nfss nfoprab2 nfoprab3 cv wcel oprabid 3imtr3g
    cop ssel alrimi ssoprab2 impbii ) ACDEFZBCDEFZGZABHZEIZDIZCIUEUHCCUCUDACDEJ
    BCDEJKUEUGDDUCUDACDELBCDELKUEUFEEUCUDACDEMBCDEMKUECNDNRENRZUCOUIUDOABUCUDUI
    SACDEPBCDEPQTTTABCDEUAUB $.

  $( Equivalence of ordered pair abstraction subclass and biconditional.
     Compare ~ eqopab2b .  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
  eqoprab2b $p |- ( { <. <. x , y >. , z >. | ph } =
    { <. <. x , y >. , z >. | ps } <-> A. x A. y A. z ( ph <-> ps ) ) $=
    ( coprab wss wa wi wceq wb ssoprab2b anbi12i eqss 2albiim albii 19.26 bitri
    wal 3bitr4i ) ACDEFZBCDEFZGZUBUAGZHABIESDSZCSZBAIESDSZCSZHZUAUBJABKESDSZCSZ
    UCUFUDUHABCDELBACDELMUAUBNUKUEUGHZCSUIUJULCABDEOPUEUGCQRT $.

  ${
    $d x y z A $.  $d y z B $.  $d x y z D $.  $d y z E $.  $d z C $.
    $d z F $.
    $( An equality theorem for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.)  (Revised by Mario Carneiro, 19-Mar-2015.) $)
    mpt2eq123 $p |- ( ( A = D /\ A. x e. A ( B = E /\ A. y e. B C = F ) ) ->
                 ( x e. A , y e. B |-> C ) = ( x e. D , y e. E |-> F ) ) $=
      ( vz wceq wral wa cv wcel coprab cmpt2 nfv nfra1 nfan wb nfcv nfral eqeq2
      rsp pm5.32d eleq2 anbi1d sylan9bbr anass 3bitr4g oprabbid df-mpt2 3eqtr4g
      syl6 ) CFJZDGJZEHJZBDKZLZACKZLZAMZCNZBMZDNZLIMZEJZLZABIOVBFNZVDGNZLVFHJZL
      ZABIOABCDEPABFGHPVAVHVLABIUOUTAUOAQUSACRSUOUTBUOBQUSBACBCUAUPURBUPBQUQBDR
      SUBSVAIQVAVCVEVGLZLZVIVJVKLZLZVHVLUTVNVCVOLUOVPUTVCVMVOUTVCUSVMVOTUSACUDU
      RVMVEVKLUPVOURVEVGVKURVEUQVGVKTUQBDUDEHVFUCUNUEUPVEVJVKDGVDUFUGUHUNUEUOVC
      VIVOCFVBUFUGUHVCVEVGUIVIVJVKUIUJUKABICDEULABIFGHULUM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    $( An equality theorem for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.) $)
    mpt2eq12 $p |- ( ( A = C /\ B = D ) ->
                 ( x e. A , y e. B |-> E ) = ( x e. C , y e. D |-> E ) ) $=
      ( wceq wral wa cmpt2 eqid rgenw jctr ralrimivw mpt2eq123 sylan2 ) DFHZCEH
      RGGHZBDIZJZACIABCDGKABEFGKHRUAACRTSBDGLMNOABCDGEFGPQ $.
  $}

  ${
    $d z A $.  $d z B $.  $d z C $.  $d z D $.  $d z E $.  $d x z ph $.
    $d z F $.  $d y z ph $.
    mpt2eq123dv.1 $e |- ( ph -> A = D ) $.
    ${
      mpt2eq123dva.2 $e |- ( ( ph /\ x e. A ) -> B = E ) $.
      mpt2eq123dva.3 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> C = F ) $.
      $( An equality deduction for the maps to notation.  (Contributed by Mario
         Carneiro, 26-Jan-2017.) $)
      mpt2eq123dva $p |- ( ph
              -> ( x e. A , y e. B |-> C ) = ( x e. D , y e. E |-> F ) ) $=
        ( vz cv wcel wa wceq coprab cmpt2 pm5.32da eqeq2d eleq2d anbi1d df-mpt2
        bitrd oprabbidv 3eqtr4g ) ABNZDOZCNZEOZPZMNZFQZPZBCMRUHGOZUJHOZPZUMIQZP
        ZBCMRBCDEFSBCGHISAUOUTBCMAUOULUSPUTAULUNUSAULPFIUMLUATAULURUSAULUIUQPUR
        AUIUKUQAUIPEHUJKUBTAUIUPUQADGUHJUBUCUEUCUEUFBCMDEFUDBCMGHIUDUG $.
    $}

    mpt2eq123dv.2 $e |- ( ph -> B = E ) $.
    mpt2eq123dv.3 $e |- ( ph -> C = F ) $.
    $( An equality deduction for the maps to notation.  (Contributed by NM,
       12-Sep-2011.) $)
    mpt2eq123dv $p |- ( ph
            -> ( x e. A , y e. B |-> C ) = ( x e. D , y e. E |-> F ) ) $=
      ( wceq cv wcel adantr wa mpt2eq123dva ) ABCDEFGHIJAEHMBNDOZKPAFIMSCNEOQLP
      R $.
  $}

  ${
    mpt2eq123i.1 $e |- A = D $.
    mpt2eq123i.2 $e |- B = E $.
    mpt2eq123i.3 $e |- C = F $.
    $( An equality inference for the maps to notation.  (Contributed by NM,
       15-Jul-2013.) $)
    mpt2eq123i $p |- ( x e. A , y e. B |-> C ) = ( x e. D , y e. E |-> F ) $=
      ( cmpt2 wceq wtru a1i mpt2eq123dv trud ) ABCDELABFGHLMNABCDEFGHCFMNIODGMN
      JOEHMNKOPQ $.
  $}

  ${
    $d x z ph $.  $d y z ph $.  $d z A $.  $d z B $.  $d z C $.  $d z D $.
    mpt2eq3dva.1 $e |- ( ( ph /\ x e. A /\ y e. B ) -> C = D ) $.
    $( Slightly more general equality inference for the maps to notation.
       (Contributed by NM, 17-Oct-2013.) $)
    mpt2eq3dva $p |- ( ph -> ( x e. A , y e. B |-> C )
              = ( x e. A , y e. B |-> D ) ) $=
      ( vz cv wcel wa wceq coprab cmpt2 3expb eqeq2d pm5.32da oprabbidv df-mpt2
      3eqtr4g ) ABJDKZCJEKZLZIJZFMZLZBCINUDUEGMZLZBCINBCDEFOBCDEGOAUGUIBCIAUDUF
      UHAUDLFGUEAUBUCFGMHPQRSBCIDEFTBCIDEGTUA $.
  $}

  ${
    mpt2eq3ia.1 $e |- ( ( x e. A /\ y e. B ) -> C = D ) $.
    $( An equality inference for the maps to notation.  (Contributed by Mario
       Carneiro, 16-Dec-2013.) $)
    mpt2eq3ia $p |- ( x e. A , y e. B |-> C ) = ( x e. A , y e. B |-> D ) $=
      ( cmpt2 wceq wtru cv wcel 3adant1 mpt2eq3dva trud ) ABCDEHABCDFHIJABCDEFA
      KCLBKDLEFIJGMNO $.
  $}

  ${
    $d z A $.  $d z B $.  $d z C $.  $d z x $.  $d z y $.
    $( Bound-variable hypothesis builder for an operation in maps-to notation.
       (Contributed by NM, 27-Aug-2013.) $)
    nfmpt21 $p |- F/_ x ( x e. A , y e. B |-> C ) $=
      ( vz cmpt2 cv wcel wa wceq coprab df-mpt2 nfoprab1 nfcxfr ) AABCDEGAHCIBH
      DIJFHEKJZABFLABFCDEMPABFNO $.

    $( Bound-variable hypothesis builder for an operation in maps-to notation.
       (Contributed by NM, 27-Aug-2013.) $)
    nfmpt22 $p |- F/_ y ( x e. A , y e. B |-> C ) $=
      ( vz cmpt2 cv wcel wa wceq coprab df-mpt2 nfoprab2 nfcxfr ) BABCDEGAHCIBH
      DIJFHEKJZABFLABFCDEMPABFNO $.
  $}

  ${
    $d w x z $.  $d w y z $.  $d w A $.  $d w B $.  $d w C $.
    nfmpt2.1 $e |- F/_ z A $.
    nfmpt2.2 $e |- F/_ z B $.
    nfmpt2.3 $e |- F/_ z C $.
    $( Bound-variable hypothesis builder for the maps-to notation.
       (Contributed by NM, 20-Feb-2013.) $)
    nfmpt2 $p |- F/_ z ( x e. A , y e. B |-> C ) $=
      ( vw cmpt2 cv wcel wa wceq coprab df-mpt2 nfcri nfan nfeq2 nfoprab nfcxfr
      ) CABDEFKALDMZBLEMZNZJLZFOZNZABJPABJDEFQUHABJCUEUGCUCUDCCADGRCBEHRSCUFFIT
      SUAUB $.
  $}

  ${
    $d x y z $.
    $( Two ways to state the domain of an operation.  (Contributed by FL,
       24-Jan-2010.) $)
    oprab4 $p |-
      { <. <. x , y >. , z >. | ( <. x , y >. e. ( A X. B ) /\ ph ) } =
        { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ph ) } $=
      ( cv cop cxp wcel wa opelxp anbi1i oprabbii ) BGZCGZHEFIJZAKOEJPFJKZAKBCD
      QRAOPEFLMN $.
  $}

  ${
    $d x y z w v $.  $d v ph $.  $d v ps $.
    cbvoprab1.1 $e |- F/ w ph $.
    cbvoprab1.2 $e |- F/ x ps $.
    cbvoprab1.3 $e |- ( x = w -> ( ph <-> ps ) ) $.
    $( Rule used to change first bound variable in an operation abstraction,
       using implicit substitution.  (Contributed by NM, 20-Dec-2008.)
       (Revised by Mario Carneiro, 5-Dec-2016.) $)
    cbvoprab1 $p |- { <. <. x , y >. , z >. | ph }
                  = { <. <. w , y >. , z >. | ps } $=
      ( vv cv cop wceq wa wex copab coprab nfv nfan nfex eqeq2d anbi12d opabbii
      opeq1 exbidv cbvex dfoprab2 3eqtr4i ) JKZCKZDKZLZMZANZDOZCOZJEPUIFKZUKLZM
      ZBNZDOZFOZJEPACDEQBFDEQUPVBJEUOVACFUNFDUMAFUMFRGSTUTCDUSBCUSCRHSTUJUQMZUN
      UTDVCUMUSABVCULURUIUJUQUKUDUAIUBUEUFUCACDEJUGBFDEJUGUH $.
  $}

  ${
    $d v w x y z $.  $d ph v $.  $d ps v $.
    cbvoprab2.1 $e |- F/ w ph $.
    cbvoprab2.2 $e |- F/ y ps $.
    cbvoprab2.3 $e |- ( y = w -> ( ph <-> ps ) ) $.
    $( Change the second bound variable in an operation abstraction.
       (Contributed by Jeff Madsen, 11-Jun-2010.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    cbvoprab2 $p |- { <. <. x , y >. , z >. | ph } =
                    { <. <. x , w >. , z >. | ps } $=
      ( vv cv cop wceq wa wex cab coprab nfv nfan nfex opeq2 opeq1d cbvex exbii
      eqeq2d anbi12d exbidv abbii df-oprab 3eqtr4i ) JKZCKZDKZLZEKZLZMZANZEOZDO
      ZCOZJPUKULFKZLZUOLZMZBNZEOZFOZCOZJPACDEQBCFEQVAVIJUTVHCUSVGDFURFEUQAFUQFR
      GSTVFDEVEBDVEDRHSTUMVBMZURVFEVJUQVEABVJUPVDUKVJUNVCUOUMVBULUAUBUEIUFUGUCU
      DUHACDEJUIBCFEJUIUJ $.
  $}

  ${
    $d x y z w v u $.  $d u ph $.  $d u ps $.
    cbvoprab12.1 $e |- F/ w ph $.
    cbvoprab12.2 $e |- F/ v ph $.
    cbvoprab12.3 $e |- F/ x ps $.
    cbvoprab12.4 $e |- F/ y ps $.
    cbvoprab12.5 $e |- ( ( x = w /\ y = v ) -> ( ph <-> ps ) ) $.
    $( Rule used to change first two bound variables in an operation
       abstraction, using implicit substitution.  (Contributed by NM,
       21-Feb-2004.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
    cbvoprab12 $p |- { <. <. x , y >. , z >. | ph }
                   = { <. <. w , v >. , z >. | ps } $=
      ( vu cv cop wceq wa wex nfv nfan coprab anbi12d opabbii dfoprab2 3eqtr4i
      copab opeq12 eqeq2d cbvex2 ) MNZCNZDNZOZPZAQZDRCRZMEUFUJFNZGNZOZPZBQZGRFR
      ZMEUFACDEUABFGEUAUPVBMEUOVACDFGUNAFUNFSHTUNAGUNGSITUTBCUTCSJTUTBDUTDSKTUK
      UQPULURPQZUNUTABVCUMUSUJUKULUQURUGUHLUBUIUCACDEMUDBFGEMUDUE $.
  $}

  ${
    $d x y z w v u $.  $d u w v ph $.  $d u x y ps $.
    cbvoprab12v.1 $e |- ( ( x = w /\ y = v ) -> ( ph <-> ps ) ) $.
    $( Rule used to change first two bound variables in an operation
       abstraction, using implicit substitution.  (Contributed by NM,
       8-Oct-2004.) $)
    cbvoprab12v $p |- { <. <. x , y >. , z >. | ph }
                    = { <. <. w , v >. , z >. | ps } $=
      ( nfv cbvoprab12 ) ABCDEFGAFIAGIBCIBDIHJ $.
  $}

  ${
    $d x z w v $.  $d y z w v $.  $d v ph $.  $d v ps $.
    cbvoprab3.1 $e |- F/ w ph $.
    cbvoprab3.2 $e |- F/ z ps $.
    cbvoprab3.3 $e |- ( z = w -> ( ph <-> ps ) ) $.
    $( Rule used to change the third bound variable in an operation
       abstraction, using implicit substitution.  (Contributed by NM,
       22-Aug-2013.) $)
    cbvoprab3 $p |- { <. <. x , y >. , z >. | ph } =
                     { <. <. x , y >. , w >. | ps } $=
      ( vv cv wceq wa wex copab coprab nfv nfan nfex dfoprab2 2exbidv cbvopab2
      cop anbi2d 3eqtr4i ) JKCKDKUCLZAMZDNZCNZJEOUFBMZDNZCNZJFOACDEPBCDFPUIULJE
      FUHFCUGFDUFAFUFFQGRSSUKECUJEDUFBEUFEQHRSSEKFKLZUGUJCDUMABUFIUDUAUBACDEJTB
      CDFJTUE $.
  $}

  ${
    $d x z w v $.  $d y z w v $.  $d w v ph $.  $d z v ps $.
    cbvoprab3v.1 $e |- ( z = w -> ( ph <-> ps ) ) $.
    $( Rule used to change the third bound variable in an operation
       abstraction, using implicit substitution.  (Contributed by NM,
       8-Oct-2004.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    cbvoprab3v $p |- { <. <. x , y >. , z >. | ph } =
                     { <. <. x , y >. , w >. | ps } $=
      ( nfv cbvoprab3 ) ABCDEFAFHBEHGI $.
  $}

  ${
    $d u v w x y z $.  $d u w x y z A $.  $d u w B $.  $d u C $.  $d u y D $.
    $d u E $.
    cbvmpt2x.1 $e |- F/_ z B $.
    cbvmpt2x.2 $e |- F/_ x D $.
    cbvmpt2x.3 $e |- F/_ z C $.
    cbvmpt2x.4 $e |- F/_ w C $.
    cbvmpt2x.5 $e |- F/_ x E $.
    cbvmpt2x.6 $e |- F/_ y E $.
    cbvmpt2x.7 $e |- ( x = z -> B = D ) $.
    cbvmpt2x.8 $e |- ( ( x = z /\ y = w ) -> C = E ) $.
    $( Rule to change the bound variable in a maps-to function, using implicit
       substitution.  This version of ~ cbvmpt2 allows ` B ` to be a function
       of ` x ` .  (Contributed by NM, 29-Dec-2014.) $)
    cbvmpt2x $p |- ( x e. A , y e. B |-> C ) = ( z e. A , w e. D |-> E ) $=
      ( vu cv nfan wcel wa wceq coprab cmpt2 nfv nfcri nfeq2 nfcv weq wb adantr
      eleq1 eleq2d sylan9bb anbi12d eqeq2d cbvoprab12 df-mpt2 3eqtr4i ) ASZEUAZ
      BSZFUAZUBZRSZGUCZUBZABRUDCSZEUAZDSZHUAZUBZVFIUCZUBZCDRUDABEFGUECDEHIUEVHV
      OABRCDVEVGCVBVDCVBCUFCBFJUGTCVFGLUHTVEVGDVBVDDVBDUFDBFDFUIUGTDVFGMUHTVMVN
      AVJVLAVJAUFADHKUGTAVFINUHTVMVNBVMBUFBVFIOUHTACUJZBDUJZUBZVEVMVGVNVRVBVJVD
      VLVPVBVJUKVQVAVIEUMULVPVDVCHUAVQVLVPFHVCPUNVCVKHUMUOUPVRGIVFQUQUPURABREFG
      USCDREHIUSUT $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.
    cbvmpt2.1 $e |- F/_ z C $.
    cbvmpt2.2 $e |- F/_ w C $.
    cbvmpt2.3 $e |- F/_ x D $.
    cbvmpt2.4 $e |- F/_ y D $.
    cbvmpt2.5 $e |- ( ( x = z /\ y = w ) -> C = D ) $.
    $( Rule to change the bound variable in a maps-to function, using implicit
       substitution.  (Contributed by NM, 17-Dec-2013.) $)
    cbvmpt2 $p |- ( x e. A , y e. B |-> C ) = ( z e. A , w e. B |-> D ) $=
      ( nfcv weq eqidd cbvmpt2x ) ABCDEFGFHCFNAFNIJKLACOFPMQ $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.  $d v w z C $.  $d v x y D $.
    cbvmpt2v.1 $e |- ( x = z -> C = E ) $.
    cbvmpt2v.2 $e |- ( y = w -> E = D ) $.
    $( Rule to change the bound variable in a maps-to function, using implicit
       substitution.  With a longer proof analogous to ~ cbvmpt , some distinct
       variable requirements could be eliminated.  (Contributed by NM,
       11-Jun-2013.) $)
    cbvmpt2v $p |- ( x e. A , y e. B |-> C ) = ( z e. A , w e. B |-> D ) $=
      ( nfcv weq sylan9eq cbvmpt2 ) ABCDEFGHCGLDGLAHLBHLACMBDMGIHJKNO $.
  $}

  ${
    elimdelov.1 $e |- ( ph -> C e. ( A F B ) ) $.
    elimdelov.2 $e |- Z e. ( X F Y ) $.
    $( Eliminate a hypothesis which is a predicate expressing membership in the
       result of an operator (deduction version).  See ~ ghomgrplem for an
       example of its use.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
    elimdelov $p |- if ( ph , C , Z ) e.
                     ( if ( ph , A , X ) F if ( ph , B , Y ) ) $=
      ( cif co wcel iftrue oveq12d 3eltr4d wn iffalse syl6eqel eleqtrrd pm2.61i
      ) AADHKZABFKZACGKZELZMADBCELUBUEIADHNAUCBUDCEABFNACGNOPAQZUBFGELZUEUFUBHU
      GADHRJSUFUCFUDGEABFRACGROTUA $.
  $}

  ${
    $d x z w $.  $d y z w $.  $d w ph $.
    $( The domain of an operation class abstraction.  (Contributed by NM,
       17-Mar-1995.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    dmoprab $p |- dom { <. <. x , y >. , z >. | ph } =
                  { <. x , y >. | E. z ph } $=
      ( vw coprab cdm cv cop wceq wa wex copab cab dfoprab2 dmeqi dmopab exrot3
      19.42v 2exbii bitri abbii df-opab eqtr4i 3eqtri ) ABCDFZGEHBHCHIJZAKZCLBL
      ZEDMZGUIDLZENZADLZBCMZUFUJABCDEOPUIEDQULUGUMKZCLBLZENUNUKUPEUKUHDLZCLBLUP
      UHDBCRUQUOBCUGADSTUAUBUMBCEUCUDUE $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The domain of an operation class abstraction.  (Contributed by NM,
       24-Aug-1995.) $)
    dmoprabss $p |- dom { <. <. x , y >. , z >. |
           ( ( x e. A /\ y e. B ) /\ ph ) } C_ ( A X. B ) $=
      ( cv wcel wa coprab cdm wex copab dmoprab 19.42v opabbii opabssxp eqsstri
      cxp ) BGEHCGFHIZAIZBCDJKUADLZBCMZEFSZUABCDNUCTADLZIZBCMUDUBUFBCTADOPUEBCE
      FQRR $.
  $}

  ${
    $d x z w $.  $d y z w $.  $d w ph $.
    $( The range of an operation class abstraction.  (Contributed by NM,
       30-Aug-2004.)  (Revised by David Abernethy, 19-Apr-2013.) $)
    rnoprab $p |- ran { <. <. x , y >. , z >. | ph } =
                  { z | E. x E. y ph } $=
      ( vw coprab crn cv cop wceq wa wex copab cab dfoprab2 rneqi rnopab exrot3
      opex isseti 19.41v mpbiran 2exbii bitri abbii 3eqtri ) ABCDFZGEHBHZCHZIZJ
      ZAKZCLBLZEDMZGUMELZDNACLBLZDNUGUNABCDEOPUMEDQUOUPDUOULELZCLBLUPULEBCRUQAB
      CUQUKELAEUJUHUISTUKAEUAUBUCUDUEUF $.
  $}

  ${
    $d A y $.  $d x y z $.
    $( The range of a restricted operation class abstraction.  (Contributed by
       Scott Fenton, 21-Mar-2012.) $)
    rnoprab2 $p |- ran { <. <. x , y >. , z >. |
                          ( ( x e. A /\ y e. B ) /\ ph ) } =
                    { z | E. x e. A E. y e. B ph } $=
      ( cv wcel wa coprab crn wex cab wrex rnoprab r2ex abbii eqtr4i ) BGEHCGFH
      IAIZBCDJKSCLBLZDMACFNBENZDMSBCDOUATDABCEFPQR $.
  $}

  ${
    $d x y z $.
    $( The domain of an operation class abstraction is a relation.
       (Contributed by NM, 17-Mar-1995.) $)
    reldmoprab $p |- Rel dom { <. <. x , y >. , z >. | ph } $=
      ( wex coprab cdm dmoprab relopabi ) ADEBCABCDFGABCDHI $.

    $( Structure of an operation class abstraction.  (Contributed by NM,
       28-Nov-2006.) $)
    oprabss $p |- { <. <. x , y >. , z >. | ph } C_ ( ( _V X. _V ) X. _V ) $=
      ( coprab cdm crn cxp wrel reloprab relssdmrn ax-mp reldmoprab df-rel mpbi
      cvv wss ssv xpss12 mp2an sstri ) ABCDEZUBFZUBGZHZPPHZPHZUBIUBUEQABCDJUBKL
      UCUFQZUDPQUEUGQUCIUHABCDMUCNOUDRUCUFUDPSTUA $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d w ph $.
    $d x y z w ps $.
    eloprabga.1 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    $( The law of concretion for operation class abstraction.  Compare
       ~ elopab .  (Contributed by NM, 14-Sep-1999.)  (Unnecessary distinct
       variable restrictions were removed by David Abernethy, 19-Jun-2012.)
       (Revised by Mario Carneiro, 19-Dec-2013.) $)
    eloprabga $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
       ( <. <. A , B >. , C >. e. { <. <. x , y >. , z >. | ph } <-> ps ) ) $=
      ( vw wcel cvv cop cv wceq wa wex coprab wb elex w3a wi simpr eqeq1d eqcom
      opex vex otth2 bitri syl6bb anbi1d pm5.32i 3exbidv df-oprab eleq2i bitr2i
      cab abid syl5bb adantl elisset 3anim123i eeeanv sylibr biantrurd 19.41vvv
      eleq1 syl6rbbr adantr 3bitr3d expcom vtocle syl3an ) FINFONZGJNGONZHKNHON
      ZFGPZHPZACDEUAZNZBUBZFIUCGJUCHKUCVQVRVSUDZWDUEMWAVTHUIWEMQZWARZWDWEWGSZWF
      CQZDQZPEQZPZRZASZETDTCTZWIFRZWJGRZWKHRZUDZBSZETDTCTZWCBWHWNWTCDEWHWNWSASW
      TWHWMWSAWHWMWAWLRZWSWHWFWAWLWEWGUFUGXBWLWARWSWAWLUHWIWJFGWKHCUJDUJEUJUKUL
      UMUNWSABLUOUMUPWGWOWCUBWEWOWFWBNZWGWCXCWFWOMUTZNWOWBXDWFACDEMUQURWOMVAUSW
      FWAWBVJVBVCWEXABUBWGWEBWSETDTCTZBSXAWEXEBWEWPCTZWQDTZWRETZUDXEVQXFVRXGVSX
      HCFOVDDGOVDEHOVDVEWPWQWRCDEVFVGVHWSBCDEVIVKVLVMVNVOVP $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d w ph $.
    $d x y z w th $.
    eloprabg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    eloprabg.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    eloprabg.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    $( The law of concretion for operation class abstraction.  Compare
       ~ elopab .  (Contributed by NM, 14-Sep-1999.)  (Revised by David
       Abernethy, 19-Jun-2012.) $)
    eloprabg $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
       ( <. <. A , B >. , C >. e. { <. <. x , y >. , z >. | ph } <-> th ) ) $=
      ( cv wceq syl3an9b eloprabga ) ADEFGHIJKLMEQHRABFQIRCGQJRDNOPST $.
  $}

  ${
    $d ph w $.  $d ps w $.  $d x z w $.  $d y z w $.
    ssoprab2i.1 $e |- ( ph -> ps ) $.
    $( Inference of operation class abstraction subclass from implication.
       (Contributed by NM, 11-Nov-1995.)  (Revised by David Abernethy,
       19-Jun-2012.) $)
    ssoprab2i $p |- { <. <. x , y >. , z >. | ph } C_
                    { <. <. x , y >. , z >. | ps } $=
      ( vw cv cop wceq wex copab coprab anim2i 2eximi ssopab2i dfoprab2 3sstr4i
      wa ) GHCHDHIJZASZDKCKZGELTBSZDKCKZGELACDEMBCDEMUBUDGEUAUCCDABTFNOPACDEGQB
      CDEGQR $.
  $}

  ${
    $d x z $.  $d y z $.  $d z C $.
    $( Operation with universal domain in maps-to notation.  (Contributed by
       NM, 16-Aug-2013.) $)
    mpt2v $p |- ( x e. _V , y e. _V |-> C )
                     = { <. <. x , y >. , z >. | z = C } $=
      ( cvv cmpt2 cv wcel wa coprab df-mpt2 vex pm3.2i biantrur oprabbii eqtr4i
      wceq ) ABEEDFAGEHZBGEHZIZCGDQZIZABCJUAABCJABCEEDKUAUBABCTUARSALBLMNOP $.
  $}

  ${
    $d w x y z A $.  $d w y z B $.  $d w x y C $.  $d w z D $.
    mpt2mpt.1 $e |- ( z = <. x , y >. -> C = D ) $.
    $( Express a two-argument function as a one-argument function, or
       vice-versa.  In this version ` B ( x ) ` is not assumed to be constant
       w.r.t ` x ` .  (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    mpt2mptx $p |- ( z e. U_ x e. A ( { x } X. B ) |-> C ) =
      ( x e. A , y e. B |-> D ) $=
      ( vw cv csn cxp ciun cmpt wcel wceq wa copab wex eqtr4i df-mpt coprab cop
      cmpt2 df-mpt2 eliunxp anbi1i 19.41vv eqeq2d anbi2d pm5.32i 2exbii 3bitr2i
      anass bitri opabbii dfoprab2 ) CADAJZKELMZFNCJZUSOZIJZFPZQZCIRZABDEGUDZCI
      USFUAVFURDOBJZEOQZVBGPZQZABIUBZVEABIDEGUEVEUTURVGUCPZVJQZBSASZCIRVKVDVNCI
      VDVLVHQZBSASZVCQVOVCQZBSASVNVAVPVCABDEUTUFUGVOVCABUHVQVMABVQVLVHVCQZQVMVL
      VHVCUNVLVRVJVLVCVIVHVLFGVBHUIUJUKUOULUMUPVJABICUQTTT $.

    $d x B $.
    $( Express a two-argument function as a one-argument function, or
       vice-versa.  (Contributed by Mario Carneiro, 17-Dec-2013.)  (Revised by
       Mario Carneiro, 29-Dec-2014.) $)
    mpt2mpt $p |- ( z e. ( A X. B ) |-> C ) = ( x e. A , y e. B |-> D ) $=
      ( cv csn cxp ciun cmpt cmpt2 wceq iunxpconst mpteq1 ax-mp mpt2mptx eqtr3i
      ) CADAIJEKLZFMZCDEKZFMZABDEGNUAUCOUBUDOADEPCUAUCFQRABCDEFGHST $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w ph $.
    $( Restriction of an operation class abstraction.  (Contributed by NM,
       10-Feb-2007.) $)
    resoprab $p |- ( { <. <. x , y >. , z >. | ph } |` ( A X. B ) ) =
                  { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ph ) } $=
      ( vw cv cop wceq wex copab cxp cres wcel coprab resopab 19.42vv dfoprab2
      wa eleq1 opelxp syl6bb anbi1d pm5.32i bitri 2exbii bitr3i opabbii reseq1i
      an12 eqtri 3eqtr4i ) GHZBHZCHZIZJZATZCKBKZGDLZEFMZNZURUOEOUPFOTZATZTZCKBK
      ZGDLZABCDPZVBNVEBCDPVCUNVBOZUTTZGDLVHUTGDVBQVKVGGDVKVJUSTZCKBKVGVJUSBCRVL
      VFBCVLURVJATZTVFVJURAUKURVMVEURVJVDAURVJUQVBOVDUNUQVBUAUOUPEFUBUCUDUEUFUG
      UHUIULVIVAVBABCDGSUJVEBCDGSUM $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d D x y z $.  $d E z $.
    $( Restriction of an operator abstraction.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    resoprab2 $p |- ( ( C C_ A /\ D C_ B ) -> ( { <. <. x , y >. , z >. |
                  ( ( x e. A /\ y e. B ) /\ ph ) } |` ( C X. D ) ) =
              { <. <. x , y >. , z >. | ( ( x e. C /\ y e. D ) /\ ph ) } ) $=
      ( wss wa cv wcel coprab cxp cres resoprab anass ssel pm4.71d bicomd an4
      bi2anan9 syl5bb anbi1d syl5bbr oprabbidv syl5eq ) GEIZHFIZJZBKZELZCKZFLZJ
      ZAJZBCDMGHNOUKGLZUMHLZJZUPJZBCDMUSAJZBCDMUPBCDGHPUJUTVABCDUTUSUOJZAJUJVAU
      SUOAQUJVBUSAVBUQULJZURUNJZJUJUSUQURULUNUAUHVCUQUIVDURUHUQVCUHUQULGEUKRSTU
      IURVDUIURUNHFUMRSTUBUCUDUEUFUG $.

    $( Restriction of the mapping operation.  (Contributed by Mario Carneiro,
       17-Dec-2013.) $)
    resmpt2 $p |- ( ( C C_ A /\ D C_ B ) ->
                    ( ( x e. A , y e. B |-> E ) |` ( C X. D ) ) =
                      ( x e. C , y e. D |-> E ) ) $=
      ( vz wss wa cv wcel wceq coprab cxp cres cmpt2 resoprab2 df-mpt2 reseq1i
      3eqtr4g ) ECIFDIJAKZCLBKZDLJHKGMZJABHNZEFOZPUBELUCFLJUDJABHNABCDGQZUFPABE
      FGQUDABHCDEFRUGUEUFABHCDGSTABHEFGSUA $.
  $}

  ${
    $d x y z w $.  $d w ph $.
    $( "At most one" is a sufficient condition for an operation class
       abstraction to be a function.  (Contributed by NM, 28-Aug-2007.) $)
    funoprabg $p |- ( A. x A. y E* z ph ->
                    Fun { <. <. x , y >. , z >. | ph } ) $=
      ( vw wmo wal cv cop wceq wa wex coprab wfun mosubopt alrimiv copab funeqi
      dfoprab2 funopab bitr2i sylib ) ADFCGBGZEHZBHCHIJAKCLBLZDFZEGZABCDMZNZUCU
      FEADBCUDOPUIUEEDQZNUGUHUJABCDESRUEEDTUAUB $.
  $}

  ${
    $d x y z w $.  $d w ph $.
    funoprab.1 $e |- E* z ph $.
    $( "At most one" is a sufficient condition for an operation class
       abstraction to be a function.  (Contributed by NM, 17-Mar-1995.) $)
    funoprab $p |- Fun { <. <. x , y >. , z >. | ph } $=
      ( wmo wal coprab wfun gen2 funoprabg ax-mp ) ADFZCGBGABCDHIMBCEJABCDKL $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Functionality and domain of an operation class abstraction.
       (Contributed by NM, 28-Aug-2007.) $)
    fnoprabg $p |- ( A. x A. y ( ph -> E! z ps ) ->
  { <. <. x , y >. , z >. | ( ph /\ ps ) } Fn { <. x , y >. | ph } ) $=
      ( weu wi wal wa coprab wfun cdm copab wceq wfn wmo eumo imim2i wex sps wb
      moanimv sylibr 2alimi funoprabg syl dmoprab nfa1 nfa2 simpl exlimiv ancld
      euex 19.42v syl6ibr impbid2 opabbid syl5eq df-fn sylanbrc ) ABEFZGZDHZCHZ
      ABIZCDEJZKZVFLZACDMZNVFVIOVDVEEPZDHCHVGVBVJCDVBABEPZGVJVAVKABEQRABEUBUCUD
      VECDEUEUFVDVHVEESZCDMVIVECDEUGVDVLACDVCCUHVBDCUIVCVLAUAZCVBVMDVBVLAVEAEAB
      UJUKVBAABESZIVLVBAVNVAVNABEUMRULABEUNUOUPTTUQURVFVIUSUT $.
  $}

  ${
    $d A w z $.  $d B w z $.  $d C w z $.  $d x y w z $.
    mpt2fun.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( The maps-to notation for an operation is always a function.
       (Contributed by Scott Fenton, 21-Mar-2012.) $)
    mpt2fun $p |- Fun F $=
      ( vz vw wfun cv wcel wa wceq coprab wmo weq wi wal mpbir eqtr3 gen2 eqeq1
      ad2ant2l anbi2d mo4 funoprab cmpt2 df-mpt2 eqtri funeqi ) FJAKCLBKDLMZHKZ
      ENZMZABHOZJUOABHUOHPUOULIKZENZMZMHIQZRZISHSVAHIUNURUTULULUMUQEUAUDUBUOUSH
      IUTUNURULUMUQEUCUEUFTUGFUPFABCDEUHUPGABHCDEUIUJUKT $.
  $}

  ${
    $d x y z $.  $d z ph $.
    fnoprab.1 $e |- ( ph -> E! z ps ) $.
    $( Functionality and domain of an operation class abstraction.
       (Contributed by NM, 15-May-1995.) $)
    fnoprab $p |- { <. <. x , y >. , z >. | ( ph /\ ps ) } Fn
                    { <. x , y >. | ph } $=
      ( weu wi wal wa coprab copab wfn gen2 fnoprabg ax-mp ) ABEGHZDICIABJCDEKA
      CDLMQCDFNABCDEOP $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.  $d x y z w F $.
    $( An operation maps to a class to which all values belong.  (Contributed
       by NM, 7-Feb-2004.) $)
    ffnov $p |- ( F : ( A X. B ) --> C <-> ( F Fn ( A X. B ) /\
         A. x e. A A. y e. B ( x F y ) e. C ) ) $=
      ( vw cxp wf wfn cv cfv wcel wral wa co ffnfv cop wceq fveq2 df-ov syl6eqr
      eleq1d ralxp anbi2i bitri ) CDHZEFIFUGJZGKZFLZEMZGUGNZOUHAKZBKZFPZEMZBDNA
      CNZOGUGEFQULUQUHUKUPGABCDUIUMUNRZSZUJUOEUSUJURFLUOUIURFTUMUNFUAUBUCUDUEUF
      $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y F $.  $d x y R $.  $d x y S $.
    fovcl.1 $e |- F : ( R X. S ) --> C $.
    $( Closure law for an operation.  (Contributed by NM, 19-Apr-2007.) $)
    fovcl $p |- ( ( A e. R /\ B e. S ) -> ( A F B ) e. C ) $=
      ( vx vy wcel wa cv co wral cxp wf wfn ffnov wceq eleq1d ax-mp oveq1 oveq2
      simprbi rspc2v mpi ) ADJBEJKHLZILZFMZCJZIENHDNZABFMZCJZDEOZCFPZUKGUOFUNQU
      KHIDECFRUDUAUJUMAUHFMZCJHIABDEUGASUIUPCUGAUHFUBTUHBSUPULCUHBAFUCTUEUF $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.  $d z D $.  $d x y z F $.
    $d x y z G $.
    $( Equality of two operations is determined by their values.  (Contributed
       by NM, 1-Sep-2005.) $)
    eqfnov $p |- ( ( F Fn ( A X. B ) /\ G Fn ( C X. D ) ) -> ( F = G <->
( ( A X. B ) = ( C X. D ) /\ A. x e. A A. y e. B ( x F y ) = ( x G y ) ) ) ) $=
      ( vz cxp wfn wa wceq cv cfv wral co eqfnfv2 fveq2 df-ov cop eqeq12d ralxp
      eqeq12i syl6bbr anbi2i syl6bb ) GCDJZKHEFJZKLGHMUHUIMZINZGOZUKHOZMZIUHPZL
      UJANZBNZGQZUPUQHQZMZBDPACPZLIUHUIGHRUOVAUJUNUTIABCDUKUPUQUAZMZUNVBGOZVBHO
      ZMUTVCULVDUMVEUKVBGSUKVBHSUBURVDUSVEUPUQGTUPUQHTUDUEUCUFUG $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.  $d G x y $.
    $( Two operators with the same domain are equal iff their values at each
       point in the domain are equal.  (Contributed by Jeff Madsen,
       7-Jun-2010.) $)
    eqfnov2 $p |- ( ( F Fn ( A X. B ) /\ G Fn ( A X. B ) ) ->
                  ( F = G <-> A. x e. A A. y e. B ( x F y ) = ( x G y ) ) ) $=
      ( cxp wfn wa wceq cv co wral eqfnov simpr eqidd ancri impbii syl6bb ) ECD
      GZHFTHIEFJTTJZAKZBKZELUBUCFLJBDMACMZIZUDABCDCDEFNUEUDUAUDOUDUAUDTPQRS $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w F $.
    $( Representation of a function in terms of its values.  (Contributed by
       NM, 7-Feb-2004.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    fnov $p |- ( F Fn ( A X. B ) <->
                    F = ( x e. A , y e. B |-> ( x F y ) ) ) $=
      ( vz cxp wfn cv cfv cmpt wceq cmpt2 dffn5 cop fveq2 df-ov syl6eqr mpt2mpt
      co eqeq2i bitri ) ECDGZHEFUCFIZEJZKZLEABCDAIZBIZETZMZLFUCENUFUJEABFCDUEUI
      UDUGUHOZLUEUKEJUIUDUKEPUGUHEQRSUAUB $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.  $d z D $.
    $( Bidirectional equality theorem for a mapping abstraction.  Equivalent to
       ~ eqfnov2 .  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    mpt22eqb $p |- ( A. x e. A A. y e. B C e. V ->
      ( ( x e. A , y e. B |-> C ) = ( x e. A , y e. B |-> D ) <->
        A. x e. A A. y e. B C = D ) ) $=
      ( vz wcel wral wceq cv wb wal cmpt2 ralimi ralbi syl wa coprab df-mpt2 wi
      pm13.183 eqeq12i eqoprab2b pm5.32 19.21v bitr3i 2albii r2al bitr4i 3bitri
      albii syl6rbbr ) EGIZBDJZACJZEFKZBDJZACJZHLZEKZVAFKZMZHNZBDJZACJZABCDEOZA
      BCDFOZKZUQUSVFMZACJUTVGMUPVKACUPURVEMZBDJVKUOVLBDHEFGUCPURVEBDQRPUSVFACQR
      VJALCIBLDISZVBSZABHTZVMVCSZABHTZKVNVPMZHNZBNANZVGVHVOVIVQABHCDEUAABHCDFUA
      UDVNVPABHUEVTVMVEUBZBNANVGVSWAABVSVMVDUBZHNWAWBVRHVMVBVCUFUMVMVDHUGUHUIVE
      ABCDUJUKULUN $.
  $}

  ${
    $d w x $.  $d w y z A $.  $d w z B $.  $d w z C $.  $d w z F $.  $d z ps $.
    $d x y z D $.  $d x y ph $.
    rngop.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( The range of an operation given by the "maps to" notation.  (Contributed
       by FL, 20-Jun-2011.) $)
    rnmpt2 $p |- ran F = { z | E. x e. A E. y e. B z = C } $=
      ( crn cv wcel wa wceq coprab wrex cab cmpt2 df-mpt2 eqtri rneqi rnoprab2
      ) GIAJDKBJEKLCJFMZLABCNZIUBBEOADOCPGUCGABDEFQUCHABCDEFRSTUBABCDEUAS $.

    $( The domain of an operation defined by maps-to notation is a relation.
       (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    reldmmpt2 $p |- Rel dom F $=
      ( vz cdm wrel cv wcel wa wceq coprab reldmoprab cmpt2 df-mpt2 eqtri dmeqi
      releqi mpbir ) FIZJAKCLBKDLMHKENMZABHOZIZJUDABHPUCUFFUEFABCDEQUEGABHCDERS
      TUAUB $.

    $( Membership in the range of an operation class abstraction.  (Contributed
       by NM, 27-Aug-2007.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    elrnmpt2g $p |- ( D e. V ->
                     ( D e. ran F <-> E. x e. A E. y e. B D = C ) ) $=
      ( vz cv wceq wrex crn eqeq1 2rexbidv rnmpt2 elab2g ) JKZELZBDMACMFELZBDMA
      CMJFGNHSFLTUAABCDSFEOPABJCDEGIQR $.

    ${
      elrnmpt2.1 $e |- C e. _V $.
      $( Membership in the range of an operation class abstraction.
         (Contributed by NM, 1-Aug-2004.)  (Revised by Mario Carneiro,
         31-Aug-2015.) $)
      elrnmpt2 $p |- ( D e. ran F <-> E. x e. A E. y e. B D = C ) $=
        ( vz crn wcel cv wceq wrex cab rnmpt2 eleq2i cvv rexlimivw eleq1 mpbiri
        eqeq1 2rexbidv elab3 bitri ) FGKZLFJMZENZBDOACOZJPZLFENZBDOZACOZUGUKFAB
        JCDEGHQRUJUNJFUMFSLZACULUOBDULUOESLIFESUAUBTTUHFNUIULABCDUHFEUCUDUEUF
        $.
    $}

    ralrnmpt2.2 $e |- ( z = C -> ( ph <-> ps ) ) $.
    $( A restricted quantifier over an image set.  (Contributed by Mario
       Carneiro, 1-Sep-2015.) $)
    ralrnmpt2 $p |- ( A. x e. A A. y e. B C e. V ->
      ( A. z e. ran F ph <-> A. x e. A A. y e. B ps ) ) $=
      ( vw wral cv wceq wrex wi wal wb crn wcel cab rnmpt2 eqeq1 2rexbidv ralab
      raleqi ralcom4 r19.23v albii bitr2i 3bitri bitri nfv ceqsalg ralimi ralbi
      syl syl5bbr syl5bb ) AEIUAZNZEOZHPZDGQZARZESZCFNZHJUBZDGNZCFNZBDGNZCFNZVC
      AEMOZHPZDGQCFQZMUCZNVFCFQZARZESZVIAEVBVRCDMFGHIKUDUHVQVSAEMVOVDPVPVECDFGV
      OVDHUEUFUGVIVGCFNZESWAVGCEFUIWBVTEVFACFUJUKULUMVLVHVMTZCFNVIVNTVKWCCFVHVE
      ARZESZDGNZVKVMWFWDDGNZESVHWDDEGUIWGVGEVEADGUJUKUNVKWEBTZDGNWFVMTVJWHDGABE
      HJBEUOLUPUQWEBDGURUSUTUQVHVMCFURUSVA $.

    $( A restricted quantifier over an image set.  (Contributed by Mario
       Carneiro, 1-Sep-2015.) $)
    rexrnmpt2 $p |- ( A. x e. A A. y e. B C e. V ->
      ( E. z e. ran F ph <-> E. x e. A E. y e. B ps ) ) $=
      ( wcel wral wn crn wrex cv notbid dfrex2 wceq rexbii rexnal bitri 3bitr4g
      ralrnmpt2 ) HJMDGNCFNZAOZEIPZNZOBOZDGNZCFNZOZAEUIQBDGQZCFQZUGUJUMUHUKCDEF
      GHIJKERHUAABLSUFSAEUITUPULOZCFQUNUOUQCFBDGTUBULCFUCUDUE $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d ph x y z $.
    oprabexd.1 $e |- ( ph -> A e. _V ) $.
    oprabexd.2 $e |- ( ph -> B e. _V ) $.
    oprabexd.3 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> E* z ps ) $.
    oprabexd.4 $e |- ( ph -> F = { <. <. x , y >. , z >. |
                                        ( ( x e. A /\ y e. B ) /\ ps ) } ) $.
    $( Existence of an operator abstraction.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    oprabexd $p |- ( ph -> F e. _V ) $=
      ( cv wcel wa coprab cvv wmo wal syl2anc cdm wi ex moanimv sylibr alrimivv
      wfun funoprabg syl cxp wss dmoprabss xpexg ssexg sylancr funex eqeltrd )
      AHCMFNDMGNOZBOZCDEPZQLAUTUGZUTUAZQNZUTQNAUSERZDSCSVAAVDCDAURBERZUBVDAURVE
      KUCURBEUDUEUFUSCDEUHUIAVBFGUJZUKVFQNZVCBCDEFGULAFQNGQNVGIJFGQQUMTVBVFQUNU
      OQUTUPTUQ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    oprabex.1 $e |- A e. _V $.
    oprabex.2 $e |- B e. _V $.
    oprabex.3 $e |- ( ( x e. A /\ y e. B ) -> E* z ph ) $.
    oprabex.4 $e |- F = { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B )
             /\ ph ) } $.
    $( Existence of an operation class abstraction.  (Contributed by NM,
       19-Oct-2004.) $)
    oprabex $p |- F e. _V $=
      ( cv wcel wa coprab cvv wfun cdm wmo wi mpbir funoprab cxp xpex dmoprabss
      moanimv ssexi funex mp2an eqeltri ) GBLEMCLFMNZANZBCDOZPKUMQUMRZPMUMPMULB
      CDULDSUKADSTJUKADUFUAUBUNEFUCEFHIUDABCDEFUEUGPUMUHUIUJ $.
  $}

  ${
    $d x y z w v u f A $.  $d x y z w v u f B $.  $d x y z w v u f C $.
    $d x y z w v u f D $.  $d x y z w v u f H $.  $d x y z R $.
    $d x y z w v u f S $.
    oprabex3.1 $e |- H e. _V $.
    oprabex3.2 $e |- F = { <. <. x , y >. , z >. | ( ( x e. ( H X. H ) /\
                      y e. ( H X. H ) ) /\
                      E. w E. v E. u E. f ( ( x = <. w , v >. /\
                      y = <. u , f >. ) /\ z = R ) ) } $.
    $( Existence of an operation class abstraction (special case).
       (Contributed by NM, 19-Oct-2004.) $)
    oprabex3 $p |- F e. _V $=
      ( cv cop wceq wa wex wmo wcel mosubop cxp xpex anass 2exbii 19.42vv bitri
      moeq mobii mpbir a1i oprabex ) AMZDMEMNOZBMZFMHMNOZPCMGOZPZHQFQZEQDQZABCJ
      JUAZUTIJJKKUBZVAUSCRZULUTSUNUTSPVBUMUOUPPZHQFQZPZEQDQZCRVDCDEULUPCFHUNCGU
      GTTUSVFCURVEDEURUMVCPZHQFQVEUQVGFHUMUOUPUCUDUMVCFHUEUFUDUHUIUJLUK $.
  $}

  ${
    $d A v x y z w $.  $d ph v $.
    oprabrexex2.1 $e |- A e. _V $.
    oprabrexex2.2 $e |- { <. <. x , y >. , z >. | ph } e. _V $.
    $( Existence of an existentially restricted operation abstraction.
       (Contributed by Jeff Madsen, 11-Jun-2010.) $)
    oprabrexex2 $p |- { <. <. x , y >. , z >. | E. w e. A ph } e. _V $=
      ( vv wrex coprab cv cop wa wex cab cvv df-oprab rexcom4 exbii wceq bitr2i
      r19.42v bitri abbii eqtri eqeltrri abrexex2 eqeltri ) AEFJZBCDKZILBLCLMDL
      MUAZANZDOZCOZBOZEFJZIPZQUKULUJNZDOZCOZBOZIPURUJBCDIRVBUQIUQUOEFJZBOVBUOEB
      FSVCVABVCUNEFJZCOVAUNECFSVDUTCVDUMEFJZDOUTUMEDFSVEUSDULAEFUCTUDTUDTUBUEUF
      UPEIFGABCDKUPIPQABCDIRHUGUHUI $.
  $}

  ${
    $d x y z $.  $d z R $.  $d z S $.
    ovid.1 $e |- ( ( x e. R /\ y e. S ) -> E! z ph ) $.
    ovid.2 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction.  (Contributed by NM,
       16-May-1995.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    ovid $p |- ( ( x e. R /\ y e. S ) -> ( ( x F y ) = z <-> ph ) ) $=
      ( cv co wceq cop cfv wcel wa df-ov eqeq1i copab wfn coprab fnoprab fneq1i
      wb mpbir opabid biimpri fnopfvb sylancr eleq2i oprabid bitri bitrd syl5bb
      baib ) BJZCJZGKZDJZLUPUQMZGNZUSLZUPEOUQFOPZAURVAUSUPUQGQRVCVBUTUSMZGOZAVC
      GVCBCSZTZUTVFOZVBVEUDVGVCAPZBCDUAZVFTVCABCDHUBVFGVJIUCUEVHVCVCBCUFUGVFUTU
      SGUHUIVEVCAVEVDVJOVIGVJVDIUJVIBCDUKULUOUMUN $.
  $}

  ${
    $d x y z $.
    ovidig.1 $e |- E* z ph $.
    ovidig.2 $e |- F = { <. <. x , y >. , z >. | ph } $.
    $( The value of an operation class abstraction.  Compare ~ ovidi .  The
       condition ` ( x e. R /\ y e. S ) ` is been removed.  (Contributed by
       Mario Carneiro, 29-Dec-2014.) $)
    ovidig $p |- ( ph -> ( x F y ) = z ) $=
      ( cv co cop cfv df-ov wfun wcel wceq coprab funoprab funeqi mpbir oprabid
      biimpri syl6eleqr funopfv mpsyl syl5eq ) ABHZCHZEIUFUGJZEKZDHZUFUGELEMZAU
      HUJJZENUIUJOUKABCDPZMABCDFQEUMGRSAULUMEULUMNAABCDTUAGUBUHUJEUCUDUE $.
  $}

  ${
    $d x y z $.  $d z R $.  $d z S $.
    ovidi.2 $e |- ( ( x e. R /\ y e. S ) -> E* z ph ) $.
    ovidi.3 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction (weak version).
       (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    ovidi $p |- ( ( x e. R /\ y e. S ) -> ( ph -> ( x F y ) = z ) ) $=
      ( cv wcel wa co wceq wmo wi moanimv mpbir ovidig ex ) BJZEKCJZFKLZAUAUBGM
      DJNUCALZBCDGUDDOUCADOPHUCADQRIST $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z S $.
    $d x y z th $.
    ov.1 $e |- C e. _V $.
    ov.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ov.3 $e |- ( y = B -> ( ps <-> ch ) ) $.
    ov.4 $e |- ( z = C -> ( ch <-> th ) ) $.
    ov.5 $e |- ( ( x e. R /\ y e. S ) -> E! z ph ) $.
    ov.6 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction.  (Contributed by NM,
       16-May-1995.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    ov $p |- ( ( A e. R /\ B e. S ) -> ( ( A F B ) = C <-> th ) ) $=
      ( wcel wa co wceq cop cv coprab cfv df-ov fveq1i eqtri eqeq1i wfn fnoprab
      copab eleq1 anbi1d anbi2d opelopabg ibir fnopfvb sylancr anbi12d eloprabg
      wb cvv mp3an3 bitrd syl5bb bianabs ) HKTZILTZUAZHIMUBZJUCZDVNHIUDZEUEZKTZ
      FUEZLTZUAZAUAZEFGUFZUGZJUCZVLVLDUAZVMWCJVMVOMUGWCHIMUHVOMWBSUIUJUKVLWDVOJ
      UDWBTZWEVLWBVTEFUNZULVOWGTZWDWFVDVTAEFGRUMVLWHVTVJVSUAZVLEFHIKLVPHUCZVQVJ
      VSVPHKUOUPZVRIUCZVSVKVJVRILUOUQZURUSWGVOJWBUTVAVJVKJVETWFWEVDNWAWIBUAVLCU
      AWEEFGHIJKLVEWJVTWIABWKOVBWLWIVLBCWMPVBGUEJUCCDVLQUQVCVFVGVHVI $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z ps $.
    ovigg.1 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    ovigg.4 $e |- E* z ph $.
    ovigg.5 $e |- F = { <. <. x , y >. , z >. | ph } $.
    $( The value of an operation class abstraction.  Compare ~ ovig .  The
       condition ` ( x e. R /\ y e. S ) ` is been removed.  (Contributed by FL,
       24-Mar-2007.)  (Revised by Mario Carneiro, 19-Dec-2013.) $)
    ovigg $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
                         ( ps -> ( A F B ) = C ) ) $=
      ( wcel w3a cop wceq cfv coprab eloprabga df-ov fveq1i eqtri wfun funoprab
      co wi funopfv ax-mp syl5eq syl6bir ) FJPGKPHLPQBFGRZHRACDEUAZPZFGIUHZHSAB
      CDEFGHJKLMUBUPUQUNUOTZHUQUNITURFGIUCUNIUOOUDUEUOUFUPURHSUIACDENUGUNHUOUJU
      KULUM $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z S $.
    $d x y z ps $.
    ovig.1 $e |- ( ( x = A /\ y = B /\ z = C ) -> ( ph <-> ps ) ) $.
    ovig.2 $e |- ( ( x e. R /\ y e. S ) -> E* z ph ) $.
    ovig.3 $e |- F =
                  { <. <. x , y >. , z >. | ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction (weak version).
       (Unnecessary distinct variable restrictions were removed by David
       Abernethy, 19-Jun-2012.)  (Contributed by NM, 14-Sep-1999.)  (Revised by
       Mario Carneiro, 19-Dec-2013.) $)
    ovig $p |- ( ( A e. R /\ B e. S /\ C e. D ) ->
                         ( ps -> ( A F B ) = C ) ) $=
      ( wcel w3a wa wceq cv co 3simpa wb eleq1 bi2anan9 3adant3 anbi12d moanimv
      wmo wi mpbir ovigg mpand ) FJPZGKPZHIPZQUNUORZBFGLUAHSUNUOUPUBCTZJPZDTZKP
      ZRZARZUQBRCDEFGHLJKIURFSZUTGSZETHSZQVBUQABVDVEVBUQUCVFVDUSUNVEVAUOURFJUDU
      TGKUDUEUFMUGVCEUIVBAEUIUJNVBAEUHUKOULUM $.
  $}

  ${
    $d x y z $.  $d z A $.  $d z B $.  $d z C $.  $d z F $.
    ovmpt4g.3 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( Value of a function given by the "maps to" notation.  (This is the
       operation analog of ~ fvmpt2 .)  (Contributed by NM, 21-Feb-2004.)
       (Revised by Mario Carneiro, 1-Sep-2015.) $)
    ovmpt4g $p |- ( ( x e. A /\ y e. B /\ C e. V ) -> ( x F y ) = C ) $=
      ( vz cv wcel co wceq wex wa elisset wmo moeq a1i cmpt2 coprab eqtri ovidi
      df-mpt2 eqeq2 mpbidi exlimdv syl5 3impia ) AJZCKZBJZDKZEGKZUJULFLZEMZUNIJ
      ZEMZINUKUMOZUPIEGPUSURUPIURUOUQMUPUSURABICDFURIQUSIERSFABCDETUSUROABIUAHA
      BICDEUDUBUCUQEUOUEUFUGUHUI $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d z F $.
    $d z R $.
    ovmpt2s.3 $e |- F = ( x e. C , y e. D |-> R ) $.
    $( Value of a function given by the "maps to" notation, expressed using
       explicit substitution.  (Contributed by Mario Carneiro, 30-Apr-2015.) $)
    ovmpt2s $p |- ( ( A e. C /\ B e. D /\ [_ A / x ]_ [_ B / y ]_ R e. V ) ->
      ( A F B ) = [_ A / x ]_ [_ B / y ]_ R ) $=
      ( wcel csb co wceq cvv cv wi nfcv nfcsb1v nfel1 elex cmpt2 nfmpt21 nfcxfr
      nfov nfeq nfim nfmpt22 csbeq1a eleq1d oveq1 eqeq12d imbi12d oveq2 ovmpt4g
      wa 3expia vtocl2gaf csbcom eleq1i eqeq2i 3imtr4g syl5 3impia ) CEKZDFKZAC
      BDGLLZIKZCDHMZVGNZVHVGOKZVEVFUPZVJVGIUAVLBDACGLZLZOKZVIVNNZVKVJGOKZAPZBPZ
      HMZGNZQVMOKZCVSHMZVMNZQVOVPQABCDEFACRZBCRZBDRZWBWDAAVMOACGSZTAWCVMACVSHWE
      AHABEFGUBZJABEFGUCUDAVSRUEWHUFUGVOVPBBVNOBDVMSZTBVIVNBCDHWFBHWIJABEFGUHUD
      WGUEWJUFUGVRCNZVQWBWAWDWKGVMOACGUIZUJWKVTWCGVMVRCVSHUKWLULUMVSDNZWBVOWDVP
      WMVMVNOBDVMUIZUJWMWCVIVMVNVSDCHUNWNULUMVREKVSFKVQWAABEFGHOJUOUQURVGVNOABC
      DGUSZUTVGVNVIWOVAVBVCVD $.
  $}

  ${
    $d t u v w A $.  $d t u v w B $.  $d t u v w x y z C $.  $d t u v w z R $.
    $d t u v w x y z D $.  $d w F $.  $d w G $.  $d t u v w S $.
    ov2gf.a $e |- F/_ x A $.
    ov2gf.c $e |- F/_ y A $.
    ov2gf.d $e |- F/_ y B $.
    ov2gf.1 $e |- F/_ x G $.
    ov2gf.2 $e |- F/_ y S $.
    ov2gf.3 $e |- ( x = A -> R = G ) $.
    ov2gf.4 $e |- ( y = B -> G = S ) $.
    ov2gf.5 $e |- F = ( x e. C , y e. D |-> R ) $.
    $( The value of an operation class abstraction.  A version of ~ ovmpt2g
       using bound-variable hypotheses.  (Contributed by NM, 17-Aug-2006.)
       (Revised by Mario Carneiro, 19-Dec-2013.) $)
    ov2gf $p |- ( ( A e. C /\ B e. D /\ S e. H ) -> ( A F B ) = S ) $=
      ( wcel co wceq cvv wa elex cv wi nfel1 nfmpt21 nfcxfr nfcv nfov nfeq nfim
      cmpt2 nfmpt22 eleq1d oveq1 eqeq12d imbi12d oveq2 ovmpt4g 3expia vtocl2gaf
      syl5 3impia ) CETZDFTZHKTZCDIUAZHUBZVIHUCTZVGVHUDVKHKUEGUCTZAUFZBUFZIUAZG
      UBZUGJUCTZCVOIUAZJUBZUGVLVKUGABCDEFLMNVRVTAAJUCOUHAVSJACVOILAIABEFGUOZSAB
      EFGUIUJAVOUKULOUMUNVLVKBBHUCPUHBVJHBCDIMBIWASABEFGUPUJNULPUMUNVNCUBZVMVRV
      QVTWBGJUCQUQWBVPVSGJVNCVOIURQUSUTVODUBZVRVLVTVKWCJHUCRUQWCVSVJJHVODCIVARU
      SUTVNETVOFTVMVQABEFGIUCSVBVCVDVEVF $.
  $}

  ${
    $d x y z $.  $d x z A $.  $d y z B $.  $d z C $.  $d z D $.  $d z R $.
    $d z S $.
    ovmpt2dx.1 $e |- ( ph -> F = ( x e. C , y e. D |-> R ) ) $.
    ovmpt2dx.2 $e |- ( ( ph /\ ( x = A /\ y = B ) ) -> R = S ) $.
    ovmpt2dx.3 $e |- ( ( ph /\ x = A ) -> D = L ) $.
    ovmpt2dx.4 $e |- ( ph -> A e. C ) $.
    ovmpt2dx.5 $e |- ( ph -> B e. L ) $.
    ovmpt2dx.6 $e |- ( ph -> S e. X ) $.
    ${
      ovmpt2dxf.px $e |- F/ x ph $.
      ovmpt2dxf.py $e |- F/ y ph $.
      ovmpt2dxf.ay $e |- F/_ y A $.
      ovmpt2dxf.bx $e |- F/_ x B $.
      ovmpt2dxf.sx $e |- F/_ x S $.
      ovmpt2dxf.sy $e |- F/_ y S $.
      $( Value of an operation given by a maps-to rule, deduction form.
         (Contributed by Mario Carneiro, 29-Dec-2014.) $)
      ovmpt2dxf $p |- ( ph -> ( A F B ) = S ) $=
        ( co cmpt2 oveqd cv wcel cvv w3a wceq wi wsbc ovmpt4g a1i alrimi spsbcd
        eqid wa adantr simplr ad2antrr eqeltrd simpr 3eltr4d anassrs elex biimt
        wb syl syl3anc oveq12d eqeq12d bitr3d nfeq2 nfan nfmpt22 nfcv nfov nfeq
        wnf sbciedf nfmpt21 mpbid eqtrd ) ADEJUEDEBCFGHUFZUEZIAJWGDEMUGABUHZFUI
        ZCUHZGUIZHUJUIZUKZWIWKWGUEZHULZUMZCEUNZBDUNWHIULZAWRBDFPAWRBSAWQCEKQAWQ
        CTWQABCFGHWGUJWGUSUOUPUQURUQURAWRWSBDFPAWIDULZUTZWQWSCEKAEKUIZWTQVAXAWK
        EULZUTZWPWQWSXDWJWLWMWPWQVJXDWIDFAWTXCVBZADFUIWTXCPVCVDXDEKWKGAXBWTXCQV
        CXAXCVEZXAGKULXCOVAVFXDHIUJAWTXCHIULNVGZAIUJUIZWTXCAILUIXHRILVHVKVCVDWN
        WPVIVLXDWOWHHIXDWIDWKEWGXEXFVMXGVNVOAWTCTCWIDUAVPVQWSCWBXACWHICDEWGUABC
        FGHVRCEVSVTUDWAUPWCSWSBWBABWHIBDEWGBDVSBCFGHWDUBVTUCWAUPWCWEWF $.
    $}

    $d y A $.  $d x B $.  $d x y S $.  $d x y ph $.
    $( Value of an operation given by a maps-to rule, deduction form.
       (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    ovmpt2dx $p |- ( ph -> ( A F B ) = S ) $=
      ( nfv nfcv ovmpt2dxf ) ABCDEFGHIJKLMNOPQRABSACSCDTBETBITCITUA $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y S $.  $d x y ph $.
    ovmpt2d.1 $e |- ( ph -> F = ( x e. C , y e. D |-> R ) ) $.
    ovmpt2d.2 $e |- ( ( ph /\ ( x = A /\ y = B ) ) -> R = S ) $.
    ovmpt2d.3 $e |- ( ph -> A e. C ) $.
    ovmpt2d.4 $e |- ( ph -> B e. D ) $.
    ovmpt2d.5 $e |- ( ph -> S e. X ) $.
    $( Value of an operation given by a maps-to rule, deduction form.
       (Contributed by Mario Carneiro, 7-Dec-2014.) $)
    ovmpt2d $p |- ( ph -> ( A F B ) = S ) $=
      ( cv wceq wa eqidd ovmpt2dx ) ABCDEFGHIJGKLMABQDRSGTNOPUA $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y L $.  $d x y S $.
    ovmpt2x.1 $e |- ( ( x = A /\ y = B ) -> R = S ) $.
    ovmpt2x.2 $e |- ( x = A -> D = L ) $.
    ovmpt2x.3 $e |- F = ( x e. C , y e. D |-> R ) $.
    $( The value of an operation class abstraction.  Variant of ~ ovmpt2ga
       which does not require ` D ` and ` x ` to be distinct.  (Contributed by
       Jeff Madsen, 10-Jun-2010.)  (Revised by Mario Carneiro, 20-Dec-2013.) $)
    ovmpt2x $p |- ( ( A e. C /\ B e. L /\ S e. H ) -> ( A F B ) = S ) $=
      ( wcel cvv co wceq cv adantl elex w3a cmpt2 wa simp1 simp2 simp3 ovmpt2dx
      a1i syl3an3 ) HJOCEOZDKOZHPOZCDIQHRHJUAUKULUMUBZABCDEFGHIKPIABEFGUCRUNNUI
      ASCRZBSDRUDGHRUNLTUOFKRUNMTUKULUMUEUKULUMUFUKULUMUGUHUJ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y S $.
    ovmpt2ga.1 $e |- ( ( x = A /\ y = B ) -> R = S ) $.
    ovmpt2ga.2 $e |- F = ( x e. C , y e. D |-> R ) $.
    $( Value of an operation given by a maps-to rule.  (Contributed by Mario
       Carneiro, 19-Dec-2013.) $)
    ovmpt2ga $p |- ( ( A e. C /\ B e. D /\ S e. H ) -> ( A F B ) = S ) $=
      ( wcel cvv co wceq elex w3a cmpt2 cv a1i adantl simp1 simp2 simp3 ovmpt2d
      wa syl3an3 ) HJMCEMZDFMZHNMZCDIOHPHJQUIUJUKRZABCDEFGHINIABEFGSPULLUAATCPB
      TDPUGGHPULKUBUIUJUKUCUIUJUKUDUIUJUKUEUFUH $.

    ovmpt2a.4 $e |- S e. _V $.
    $( Value of an operation given by a maps-to rule.  (Contributed by NM,
       19-Dec-2013.) $)
    ovmpt2a $p |- ( ( A e. C /\ B e. D ) -> ( A F B ) = S ) $=
      ( wcel cvv co wceq ovmpt2ga mp3an3 ) CEMDFMHNMCDIOHPLABCDEFGHINJKQR $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ph $.
    ovmpt2df.1 $e |- ( ph -> A e. C ) $.
    ovmpt2df.2 $e |- ( ( ph /\ x = A ) -> B e. D ) $.
    ovmpt2df.3 $e |- ( ( ph /\ ( x = A /\ y = B ) ) -> R e. V ) $.
    ovmpt2df.4 $e |- ( ( ph /\ ( x = A /\ y = B ) ) ->
      ( ( A F B ) = R -> ps ) ) $.
    ${
      ovmpt2df.5 $e |- F/_ x F $.
      ovmpt2df.6 $e |- F/ x ps $.
      ovmpt2df.7 $e |- F/_ y F $.
      ovmpt2df.8 $e |- F/ y ps $.
      $( Alternate deduction version of ~ ovmpt2 , suitable for iteration.
         (Contributed by Mario Carneiro, 7-Jan-2017.) $)
      ovmpt2df $p |- ( ph -> ( F = ( x e. C , y e. D |-> R ) -> ps ) ) $=
        ( wcel cv wceq cmpt2 nfv nfmpt21 nfeq nfim cvv wex elex syl isset sylib
        wi wa nfmpt22 co oveq simprl simprr oveq12d adantr eqeltrd adantrr eqid
        ovmpt4g syl3anc eqtr3d eqeq2d sylbid syl5 expr exlimd mpd exlimdd ) ACU
        AZEUBZJCDGHIUCZUBZBUNZCACUDVSBCCJVRPCDGHIUEUFQUGAEUHTZVQCUIAEGTZWALEGUJ
        UKCEULUMAVQUOZDUAZFUBZDUIZVTWCFUHTZWFWCFHTZWGMFHUJUKDFULUMWCWEVTDWCDUDV
        SBDDJVRRCDGHIUPUFSUGAVQWEVTVSEFJUQZEFVRUQZUBZAVQWEUOZUOZBEFJVRURWMWKWII
        UBBWMWJIWIWMVPWDVRUQZWJIWMVPEWDFVRAVQWEUSZAVQWEUTZVAWMVPGTWDHTIKTWNIUBW
        MVPEGWOAWBWLLVBVCWMWDFHWPAVQWHWEMVDVCNCDGHIVRKVRVEVFVGVHVIOVJVKVLVMVNVO
        $.
    $}

    $d x y F $.  $d x y ps $.
    $( Alternate deduction version of ~ ovmpt2 , suitable for iteration.
       (Contributed by Mario Carneiro, 7-Jan-2017.) $)
    ovmpt2dv $p |- ( ph -> ( F = ( x e. C , y e. D |-> R ) -> ps ) ) $=
      ( nfcv nfv ovmpt2df ) ABCDEFGHIJKLMNOCJPBCQDJPBDQR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y ph $.  $d x y S $.
    ovmpt2dv2.1 $e |- ( ph -> A e. C ) $.
    ovmpt2dv2.2 $e |- ( ( ph /\ x = A ) -> B e. D ) $.
    ovmpt2dv2.3 $e |- ( ( ph /\ ( x = A /\ y = B ) ) -> R e. V ) $.
    ovmpt2dv2.4 $e |- ( ( ph /\ ( x = A /\ y = B ) ) -> R = S ) $.
    $( Alternate deduction version of ~ ovmpt2 , suitable for iteration.
       (Contributed by Mario Carneiro, 7-Jan-2017.) $)
    ovmpt2dv2 $p |- ( ph ->
      ( F = ( x e. C , y e. D |-> R ) -> ( A F B ) = S ) ) $=
      ( co wceq cv wa nfcv cmpt2 eqidd eqeq2d biimpd nfmpt21 nfov nfeq1 nfmpt22
      ovmpt2df mpd oveq eqeq1d syl5ibrcom ) ADEJPZIQJBCFGHUAZQZDEUOPZIQZAUOUOQU
      RAUOUBAURBCDEFGHUOKLMNABRDQCREQSSZUQHQURUSHIUQOUCUDBCFGHUEZBUQIBDEUOBDTUT
      BETUFUGBCFGHUHZCUQICDEUOCDTVACETUFUGUIUJUPUNUQIDEJUOUKULUM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y S $.
    ovmpt2g.1 $e |- ( x = A -> R = G ) $.
    ovmpt2g.2 $e |- ( y = B -> G = S ) $.
    ovmpt2g.3 $e |- F = ( x e. C , y e. D |-> R ) $.
    $( Value of an operation given by a maps-to rule.  Special case.
       (Contributed by NM, 14-Sep-1999.)  (Revised by David Abernethy,
       19-Jun-2012.) $)
    ovmpt2g $p |- ( ( A e. C /\ B e. D /\ S e. H ) -> ( A F B ) = S ) $=
      ( cv wceq sylan9eq ovmpt2ga ) ABCDEFGHIKAOCPBODPGJHLMQNR $.

    ovmpt2.4 $e |- S e. _V $.
    $( Value of an operation given by a maps-to rule.  Special case.
       (Contributed by NM, 16-May-1995.)  (Revised by David Abernethy,
       19-Jun-2012.) $)
    ovmpt2 $p |- ( ( A e. C /\ B e. D ) -> ( A F B ) = S ) $=
      ( wcel cvv co wceq ovmpt2g mp3an3 ) CEODFOHPOCDIQHRNABCDEFGHIJPKLMST $.
  $}

  ${
    $d f t u v w x y z A $.  $d f t u v w x y z B $.  $d t F $.  $d x y z R $.
    $d f t u v w y z C $.  $d f t u v w y z D $.  $d f t u v w x y z H $.
    $d f t u v w z S $.
    ov3.1 $e |- S e. _V $.
    ov3.2 $e |- ( ( ( w = A /\ v = B ) /\ ( u = C /\ f = D ) ) ->
         R = S ) $.
    ov3.3 $e |- F = { <. <. x , y >. , z >. | ( ( x e. ( H X. H ) /\
                      y e. ( H X. H ) ) /\
                      E. w E. v E. u E. f ( ( x = <. w , v >. /\
                      y = <. u , f >. ) /\ z = R ) ) } $.
    $( The value of an operation class abstraction.  Special case.
       (Contributed by NM, 28-May-1995.)  (Revised by Mario Carneiro,
       29-Dec-2014.) $)
    ov3 $p |- ( ( ( A e. H /\ B e. H ) /\ ( C e. H /\ D e. H ) ) ->
        ( <. A , B >. F <. C , D >. ) = S ) $=
      ( wa wex wcel cv wceq cop isseti nfv nfcv cxp coprab nfoprab3 nfcxfr nfov
      co nfeq1 eqeq2d copsex4g wi opelxpi nfoprab1 nfim nfoprab2 anbi1d 4exbidv
      eqeq1 oveq1 eqeq1d imbi12d anbi2d oveq2 moeq mosubop anass 2exbii 19.42vv
      wmo bitri mobii mpbir a1i ovidi vtocl2gaf syl2an sylbird eqeq2 mpbidi mpi
      exlimd ) GOUAHOUASZIOUAJOUASZSZCUBZLUCZCTGHUDZIJUDZNUMZLUCZCLPUEWJWLWPCWJ
      CUFCWOLCWMWNNCWMUGCNAUBZOOUHZUABUBZWRUASZWQDUBZEUBZUDZUCZWSFUBZMUBZUDZUCZ
      SZWKKUCZSZMTFTZETDTZSZABCUIZRXNABCUJUKCWNUGULUNWLWOWKUCZWPWJWJWLWMXCUCZWN
      XGUCZSZXJSZMTFTETDTZXPXJWLDEFMGHIJOOXAGUCXBHUCSXEIUCXFJUCSSKLWKQUOUPWHWMW
      RUAWNWRUAYAXPUQZWIGHOOURIJOOURXMWQWSNUMZWKUCZUQXQXHSZXJSZMTFTETDTZWMWSNUM
      ZWKUCZUQYBABWMWNWRWRAWMUGZBWMUGZBWNUGZYGYIAYGAUFAYHWKAWMWSNYJANXORXNABCUS
      UKAWSUGULUNUTYAXPBYABUFBWOWKBWMWNNYKBNXORXNABCVAUKYLULUNUTWQWMUCZXMYGYDYI
      YMXKYFDEFMYMXIYEXJYMXDXQXHWQWMXCVDVBVBVCYMYCYHWKWQWMWSNVEVFVGWSWNUCZYGYAY
      IXPYNYFXTDEFMYNYEXSXJYNXHXRXQWSWNXGVDVHVBVCYNYHWOWKWSWNWMNVIVFVGXMABCWRWR
      NXMCVOZWTYOXDXHXJSZMTFTZSZETDTZCVOYQCDEWQXJCFMWSCKVJVKVKXMYSCXLYRDEXLXDYP
      SZMTFTYRXKYTFMXDXHXJVLVMXDYPFMVNVPVMVQVRVSRVTWAWBWCWKLWOWDWEWGWF $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.  $d w z R $.
    $d w x y z S $.
    ov6g.1 $e |- ( <. x , y >. = <. A , B >. -> R = S ) $.
    ov6g.2 $e |- F = { <. <. x , y >. , z >. | ( <. x , y >. e. C
                      /\ z = R ) } $.
    $( The value of an operation class abstraction.  Special case.
       (Contributed by NM, 13-Nov-2006.) $)
    ov6g $p |- ( ( ( A e. G /\ B e. H /\ <. A , B >. e. C ) /\ S e. J )
                     -> ( A F B ) = S ) $=
      ( vw wcel wa cv wceq wex cop w3a co cfv df-ov eqid biidd copsex2g 3adant3
      mpbiri adantr wi eqeq1 anbi1d eqeq2d eqcoms pm5.32i syl6bb 2exbidv anbi2d
      wb wmo moeq mosubop a1i coprab copab dfoprab2 eleq1 bitr3i 2exbii 19.42vv
      an12 bitri opabbii 3eqtri fvopab3ig 3ad2antl3 mpd syl5eq ) DJPZEKPZDEUAZF
      PZUBZHLPZQZDEIUCWCIUDZHDEIUEWGWCARZBRZUAZSZHHSZQZBTATZWHHSZWEWOWFWAWBWOWD
      WAWBQWOWMHUFWMWMABDEJKWIDSWJESQWMUGUHUJUIUKWDWAWFWOWPULWBORZWKSZCRZGSZQZB
      TATZWLWSHSZQZBTATWOOCWCHFLIWQWCSZXAXDABXEXAWLWTQXDXEWRWLWTWQWCWKUMUNWLWTX
      CWTXCVAWKWCWKWCSGHWSMUOUPUQURUSXCXDWNABXCXCWMWLWSHHUMUTUSXBCVBWQFPZWTCABW
      QCGVCVDVEIWKFPZWTQZABCVFWRXHQZBTATZOCVGXFXBQZOCVGNXHABCOVHXJXKOCXJXFXAQZB
      TATXKXIXLABXIWRXFWTQZQXLWRXMXHWRXFXGWTWQWKFVIUNUQWRXFWTVMVJVKXFXAABVLVNVO
      VPVQVRVSVT $.
  $}

  ${
    $d ph c $.  $d ps x $.  $d ch x y $.  $d th x y z $.  $d ta x y c $.
    $d R x y z c $.  $d S x y z c $.  $d A x y z c $.  $d B x y z c $.
    $d C x y z c $.
    ovg.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ovg.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    ovg.3 $e |- ( z = C -> ( ch <-> th ) ) $.
    ovg.4 $e |- ( ( ta /\ ( x e. R /\ y e. S ) ) -> E! z ph ) $.
    ovg.5 $e |- F = { <. <. x , y >. , z >. |
                                            ( ( x e. R /\ y e. S ) /\ ph ) } $.
    $( The value of an operation class abstraction.  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    ovg $p |- ( ( ta /\ ( A e. R /\ B e. S /\ C e. D ) )
                                            -> ( ( A F B ) = C <-> th ) ) $=
      ( vc wcel w3a wa co wceq cop cv coprab df-ov fveq1i eqtri eqeq1i wb eqeq2
      cfv wi opeq2 eleq1d bibi12d imbi2d copab wfn weu wal ex alrimivv fnoprabg
      syl eleq1 anbi1d anbi2d opelopabg fnopfvb syl2an vtoclg com12 exp32 3imp2
      ibir anbi12d eloprabg adantl bitrd syl5bb biidd bianabs 3adant3 ) EIMUBZJ
      NUBZKLUBZUCZUDZIJOUEZKUFZWIWJUDZDUDZDWOIJUGZFUHZMUBZGUHZNUBZUDZAUDZFGHUIZ
      UPZKUFZWMWQWNXFKWNWROUPXFIJOUJWROXETUKULUMWMXGWRKUGZXEUBZWQEWIWJWKXGXIUNZ
      EWIWJWKXJUQWKEWPUDZXJXKXFUAUHZUFZWRXLUGZXEUBZUNZUQXKXJUQUAKLXLKUFZXPXJXKX
      QXMXGXOXIXLKXFUOXQXNXHXEXLKWRURUSUTVAEXEXCFGVBZVCZWRXRUBZXPWPEXCAHVDZUQZG
      VEFVEXSEYBFGEXCYASVFVGXCAFGHVHVIWPXTXCWIXBUDZWPFGIJMNWSIUFZWTWIXBWSIMVJVK
      ZXAJUFZXBWJWIXAJNVJVLZVMVTXRWRXLXEVNVOVPVQVRVSWLXIWQUNEXDYCBUDWPCUDWQFGHI
      JKMNLYDXCYCABYEPWAYFYCWPBCYGQWAHUHKUFCDWPRVLWBWCWDWEWLWQDUNZEWIWJYHWKWPWQ
      DWPWQWFWGWHWCWD $.
  $}

  $( The value of a restricted operation.  (Contributed by FL, 10-Nov-2006.) $)
  ovres $p |- ( ( A e. C /\ B e. D ) -> ( A ( F |` ( C X. D ) ) B )
    = ( A F B ) ) $=
    ( wcel wa cop cxp cres cfv co wceq opelxpi fvres syl df-ov 3eqtr4g ) ACFBDF
    GZABHZECDIZJZKZTEKZABUBLABELSTUAFUCUDMABCDNTUAEOPABUBQABEQR $.

  ${
    ovresd.1 $e |- ( ph -> A e. X ) $.
    ovresd.2 $e |- ( ph -> B e. X ) $.
    $( Lemma for converting metric theorems to metric space theorems.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ovresd $p |- ( ph -> ( A ( D |` ( X X. X ) ) B ) = ( A D B ) ) $=
      ( wcel cxp cres co wceq ovres syl2anc ) ABEHCEHBCDEEIJKBCDKLFGBCEEDMN $.
  $}

  $( The value of a member of the domain of a subclass of an operation.
     (Contributed by NM, 23-Aug-2007.) $)
  oprssov $p |- ( ( ( Fun F /\ G Fn ( C X. D ) /\ G C_ F ) /\
        ( A e. C /\ B e. D ) ) -> ( A F B ) = ( A G B ) ) $=
    ( wfun cxp wfn wss w3a wcel wa cres co wceq ovres adantl cdm eqtr3d reseq2d
    fndm 3ad2ant2 funssres 3adant2 oveqd adantr ) EGZFCDHZIZFEJZKZACLBDLMZMABEU
    INZOZABEOZABFOZUMUOUPPULABCDEQRULUOUQPUMULUNFABULEFSZNZUNFUJUHUSUNPUKUJURUI
    EUIFUBUAUCUHUKUSFPUJEFUDUETUFUGT $.

  $( An operation's value belongs to its codomain.  (Contributed by NM,
     27-Aug-2006.) $)
  fovrn $p |- ( ( F : ( R X. S ) --> C /\ A e. R /\ B e. S ) ->
               ( A F B ) e. C ) $=
    ( cxp wf wcel co wa cop opelxpi cfv df-ov ffvelrn syl5eqel sylan2 3impb ) D
    EGZCFHZADIZBEIZABFJZCIZUBUCKUAABLZTIZUEABDEMUAUGKUDUFFNCABFOTCUFFPQRS $.

  ${
    fovrnd.1 $e |- ( ph -> F : ( R X. S ) --> C ) $.
    $( An operation's value belongs to its codomain.  (Contributed by Mario
       Carneiro, 29-Dec-2016.) $)
    fovrnda $p |- ( ( ph /\ ( A e. R /\ B e. S ) ) -> ( A F B ) e. C ) $=
      ( wcel co cxp wf fovrn syl3an1 3expb ) ABEIZCFIZBCGJDIZAEFKDGLPQRHBCDEFGM
      NO $.

    fovrnd.2 $e |- ( ph -> A e. R ) $.
    fovrnd.3 $e |- ( ph -> B e. S ) $.
    $( An operation's value belongs to its codomain.  (Contributed by Mario
       Carneiro, 29-Dec-2016.) $)
    fovrnd $p |- ( ph -> ( A F B ) e. C ) $=
      ( cxp wf wcel co fovrn syl3anc ) AEFKDGLBEMCFMBCGNDMHIJBCDEFGOP $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w z C $.  $d w x y z F $.
    $( The range of an operation expressed as a collection of the operation's
       values.  (Contributed by NM, 29-Oct-2006.) $)
    fnrnov $p |- ( F Fn ( A X. B ) -> ran F = { z | E. x e. A E. y e. B
                     z = ( x F y ) } ) $=
      ( vw cxp wfn crn cv cfv wceq wrex cab co fnrnfv cop fveq2 df-ov syl6eqr
      eqeq2d rexxp abbii syl6eq ) FDEHZIFJCKZGKZFLZMZGUFNZCOUGAKZBKZFPZMZBENADN
      ZCOGCUFFQUKUPCUJUOGABDEUHULUMRZMZUIUNUGURUIUQFLUNUHUQFSULUMFTUAUBUCUDUE
      $.

    $( An onto mapping of an operation expressed in terms of operation values.
       (Contributed by NM, 29-Oct-2006.) $)
    foov $p |- ( F : ( A X. B ) -onto-> C <-> ( F : ( A X. B ) --> C /\
                  A. z e. C E. x e. A E. y e. B z = ( x F y ) ) ) $=
      ( vw cxp wfo wf cv cfv wceq wrex wral wa co dffo3 cop fveq2 df-ov syl6eqr
      eqeq2d rexxp ralbii anbi2i bitri ) DEIZFGJUIFGKZCLZHLZGMZNZHUIOZCFPZQUJUK
      ALZBLZGRZNZBEOADOZCFPZQHCUIFGSUPVBUJUOVACFUNUTHABDEULUQURTZNZUMUSUKVDUMVC
      GMUSULVCGUAUQURGUBUCUDUEUFUGUH $.
  $}

  $( An operation's value belongs to its range.  (Contributed by NM,
     10-Feb-2007.) $)
  fnovrn $p |- ( ( F Fn ( A X. B ) /\ C e. A /\ D e. B ) ->
                   ( C F D ) e. ran F ) $=
    ( cxp wfn wcel co crn cop opelxpi cfv df-ov fnfvelrn syl5eqel sylan2 3impb
    wa ) EABFZGZCAHZDBHZCDEIZEJZHZUBUCSUACDKZTHZUFCDABLUAUHSUDUGEMUECDENTUGEOPQ
    R $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d x y z F $.
    $( A member of an operation's range is a value of the operation.
       (Contributed by NM, 7-Feb-2007.)  (Revised by Mario Carneiro,
       30-Jan-2014.) $)
    ovelrn $p |- ( F Fn ( A X. B ) -> ( C e. ran F <->
                  E. x e. A E. y e. B C = ( x F y ) ) ) $=
      ( vz cxp wfn crn wcel cv co wceq wrex cab fnrnov eleq2d cvv rexlimivw
      ovex eleq1 mpbiri eqeq1 2rexbidv elab3 syl6bb ) FCDHIZEFJZKEGLZALZBLZFMZN
      ZBDOACOZGPZKEUMNZBDOZACOZUHUIUPEABGCDFQRUOUSGEURESKZACUQUTBDUQUTUMSKUKULF
      UAEUMSUBUCTTUJENUNUQABCDUJEUMUDUEUFUG $.

    $( Membership relation for the values of a function whose image is a
       subclass.  (Contributed by Mario Carneiro, 23-Dec-2013.) $)
    funimassov $p |- ( ( Fun F /\ ( A X. B ) C_ dom F ) ->
        ( ( F " ( A X. B ) ) C_ C <-> A. x e. A A. y e. B ( x F y ) e. C ) ) $=
      ( vz wfun cxp cdm wss wa cima cv cfv wcel wral co funimass4 cop syl6eqr
      wceq fveq2 df-ov eleq1d ralxp syl6bb ) FHCDIZFJKLFUHMEKGNZFOZEPZGUHQANZBN
      ZFRZEPZBDQACQGUHEFSUKUOGABCDUIULUMTZUBZUJUNEUQUJUPFOUNUIUPFUCULUMFUDUAUEU
      FUG $.

    $( Operation value in an image.  (Contributed by Mario Carneiro,
       23-Dec-2013.)  (Revised by Mario Carneiro, 29-Jan-2014.) $)
    ovelimab $p |- ( ( F Fn A /\ ( B X. C ) C_ A ) ->
        ( D e. ( F " ( B X. C ) ) <-> E. x e. B E. y e. C D = ( x F y ) ) ) $=
      ( vz wfn cxp wss wa cima wcel cv cfv wceq wrex co syl6bb fvelimab syl6eqr
      cop fveq2 df-ov eqeq1d eqcom rexxp ) GCIDEJZCKLFGUIMNHOZGPZFQZHUIRFAOZBOZ
      GSZQZBERADRHCUIFGUAULUPHABDEUJUMUNUCZQZULUOFQUPURUKUOFURUKUQGPUOUJUQGUDUM
      UNGUEUBUFUOFUGTUHT $.
  $}

  ${
    oprvalconst2.1 $e |- C e. _V $.
    $( The value of a constant operation.  (Contributed by NM, 5-Nov-2006.) $)
    ovconst2 $p |- ( ( R e. A /\ S e. B ) ->
                       ( R ( ( A X. B ) X. { C } ) S ) = C ) $=
      ( wcel wa cxp csn co cop cfv df-ov wceq opelxpi fvconst2 syl syl5eq ) DAG
      EBGHZDEABIZCJIZKDELZUBMZCDEUBNTUCUAGUDCODEABPUACUCFQRS $.
  $}

  ${
    $d x z A $.  $d y z B $.  $d z C $.
    ab2rexex.1 $e |- A e. _V $.
    ab2rexex.2 $e |- B e. _V $.
    $( Existence of a class abstraction of existentially restricted sets.
       Variables ` x ` and ` y ` are normally free-variable parameters in the
       class expression substituted for ` C ` , which can be thought of as
       ` C ( x , y ) ` .  See comments for ~ abrexex .  (Contributed by NM,
       20-Sep-2011.) $)
    ab2rexex $p |- { z | E. x e. A E. y e. B z = C } e. _V $=
      ( cv wceq wrex abrexex abrexex2 ) CIFJBEKACDGBCEFHLM $.
  $}

  ${
    $d x z A $.  $d y z B $.
    ab2rexex2.1 $e |- A e. _V $.
    ab2rexex2.2 $e |- B e. _V $.
    ab2rexex2.3 $e |- { z | ph } e. _V $.
    $( Existence of an existentially restricted class abstraction. ` ph ` is
       normally has free-variable parameters ` x ` , ` y ` , and ` z ` .
       Compare ~ abrexex2 .  (Contributed by NM, 20-Sep-2011.) $)
    ab2rexex2 $p |- { z | E. x e. A E. y e. B ph } e. _V $=
      ( wrex abrexex2 ) ACFJBDEGACDFHIKK $.
  $}

  ${
    $d x y S $.  $d x y F $.
    oprssdm.1 $e |- -. (/) e. S $.
    oprssdm.2 $e |- ( ( x e. S /\ y e. S ) -> ( x F y ) e. S ) $.
    $( Domain of closure of an operation.  (Contributed by NM, 24-Aug-1995.) $)
    oprssdm $p |- ( S X. S ) C_ dom F $=
      ( cxp cdm relxp cv cop wcel wa opelxp cfv co df-ov syl5eqelr wn c0 eleq1d
      ndmfv mtbiri con4i syl sylbi relssi ) ABCCGZDHZCCIAJZBJZKZUHLUJCLUKCLMZUL
      UILZUJUKCCNUMULDOZCLZUNUMUOUJUKDPCUJUKDQFRUNUPUNSZUPTCLEUQUOTCULDUBUAUCUD
      UEUFUG $.
  $}

  $( The value of an operation outside its domain.  (Contributed by Alexander
     van der Vekens, 7-Sep-2017.) $)
  nssdmovg $p |- ( ( dom F C_ ( R X. S ) /\ -. ( A e. R /\ B e. S ) )
              -> ( A F B ) = (/) ) $=
    ( cdm cxp wss wcel wa wn co cop cfv c0 df-ov wceq ssel2 opelxp sylib ex syl
    con3and ndmfv syl5eq ) EFZCDGZHZACIBDIJZKJZABELABMZENZOABEPUJUKUFIZKULOQUHU
    MUIUHUMUIUHUMJUKUGIUIUFUGUKRABCDSTUAUCUKEUDUBUE $.

  $( The value of an operation outside its domain.  (Contributed by NM,
     28-Mar-2008.) $)
  ndmovg $p |- ( ( dom F = ( R X. S ) /\ -. ( A e. R /\ B e. S ) )
              -> ( A F B ) = (/) ) $=
    ( cdm cxp wceq wcel wa wn co cop cfv c0 df-ov eleq2 opelxp syl6bb notbid
    ndmfv syl6bir imp syl5eq ) EFZCDGZHZACIBDIJZKZJABELABMZENZOABEPUGUIUKOHZUGU
    IUJUEIZKULUGUMUHUGUMUJUFIUHUEUFUJQABCDRSTUJEUAUBUCUD $.

  ${
    ndmov.1 $e |- dom F = ( S X. S ) $.
    $( The value of an operation outside its domain.  (Contributed by NM,
       24-Aug-1995.) $)
    ndmov $p |- ( -. ( A e. S /\ B e. S ) -> ( A F B ) = (/) ) $=
      ( cdm cxp wceq wcel wa wn co c0 ndmovg mpan ) DFCCGHACIBCIJKABDLMHEABCCDN
      O $.

    ${
      ndmovcl.2 $e |- ( ( A e. S /\ B e. S ) -> ( A F B ) e. S ) $.
      ndmovcl.3 $e |- (/) e. S $.
      $( The closure of an operation outside its domain, when the domain
         includes the empty set.  This technical lemma can make the operation
         more convenient to work in some cases.  It is dependent on our
         particular definitions of operation value, function value, and ordered
         pair.  (Contributed by NM, 24-Sep-2004.) $)
      ndmovcl $p |- ( A F B ) e. S $=
        ( wcel wa co wn c0 ndmov syl6eqel pm2.61i ) ACHBCHIZABDJZCHFPKQLCABCDEM
        GNO $.
    $}

    ${
      ndmovrcl.3 $e |- -. (/) e. S $.
      $( Reverse closure law, when an operation's domain doesn't contain the
         empty set.  (Contributed by NM, 3-Feb-1996.) $)
      ndmovrcl $p |- ( ( A F B ) e. S -> ( A e. S /\ B e. S ) ) $=
        ( wcel wa co wn c0 ndmov eleq1d mtbiri con4i ) ACGBCGHZABDIZCGZPJZRKCGF
        SQKCABCDELMNO $.
    $}

    $( Any operation is commutative outside its domain.  (Contributed by NM,
       24-Aug-1995.) $)
    ndmovcom $p |- ( -. ( A e. S /\ B e. S ) -> ( A F B ) = ( B F A ) ) $=
      ( wcel wa wn co c0 ndmov wceq ancom sylnbi eqtr4d ) ACFZBCFZGZHABDIJBADIZ
      ABCDEKRQPGSJLPQMBACDEKNO $.

    ${
      ndmov.5 $e |- -. (/) e. S $.
      $( Any operation is associative outside its domain, if the domain doesn't
         contain the empty set.  (Contributed by NM, 24-Aug-1995.) $)
      ndmovass $p |- ( -. ( A e. S /\ B e. S /\ C e. S ) ->
              ( ( A F B ) F C ) = ( A F ( B F C ) ) ) $=
        ( wcel w3a wn co c0 wa wceq ndmovrcl anim1i sylibr con3i ndmov syl
        df-3an anim2i 3anass eqtr4d ) ADHZBDHZCDHZIZJZABEKZCEKZLABCEKZEKZUIUJDH
        ZUGMZJUKLNUOUHUOUEUFMZUGMUHUNUPUGABDEFGOPUEUFUGUAQRUJCDEFSTUIUEULDHZMZJ
        UMLNURUHURUEUFUGMZMUHUQUSUEBCDEFGOUBUEUFUGUCQRAULDEFSTUD $.

      ndmov.6 $e |- dom G = ( S X. S ) $.
      $( Any operation is distributive outside its domain, if the domain
         doesn't contain the empty set.  (Contributed by NM, 24-Aug-1995.) $)
      ndmovdistr $p |- ( -. ( A e. S /\ B e. S /\ C e. S ) ->
          ( A G ( B F C ) ) = ( ( A G B ) F ( A G C ) ) ) $=
        ( wcel wn co c0 wa wceq ndmovrcl sylibr con3i ndmov syl anim2i anim12i
        w3a 3anass anandi bitri eqtr4d ) ADJZBDJZCDJZUCZKZABCELZFLZMABFLZACFLZE
        LZULUHUMDJZNZKUNMOUSUKUSUHUIUJNZNZUKURUTUHBCDEGHPUAUHUIUJUDZQRAUMDFISTU
        LUODJZUPDJZNZKUQMOVEUKVEUHUINZUHUJNZNZUKVCVFVDVGABDFIHPACDFIHPUBUKVAVHV
        BUHUIUJUEUFQRUOUPDEGSTUG $.
    $}

    ndmovord.4 $e |- R C_ ( S X. S ) $.
    ndmovord.5 $e |- -. (/) e. S $.
    ndmovord.6 $e |- ( ( A e. S /\ B e. S /\ C e. S ) ->
                   ( A R B <-> ( C F A ) R ( C F B ) ) ) $.
    $( Elimination of redundant antecedents in an ordering law.  (Contributed
       by NM, 7-Mar-1996.) $)
    ndmovord $p |- ( C e. S -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $=
      ( wcel wa wbr co wb wi 3expia brel ndmovrcl simprd wn anim12i syl pm2.61i
      pm5.21ni a1d ) AEKZBEKZLZCEKZABDMZCAFNZCBFNZDMZOZPUGUHUJUOJQUIUAUOUJUKUIU
      NABEEDHRUNULEKZUMEKZLUIULUMEEDHRUPUGUQUHUPUJUGCAEFGISTUQUJUHCBEFGISTUBUCU
      EUFUD $.
  $}

  ${
    ndmovordi.2 $e |- dom F = ( S X. S ) $.
    ndmovordi.4 $e |- R C_ ( S X. S ) $.
    ndmovordi.5 $e |- -. (/) e. S $.
    ndmovordi.6 $e |- ( C e. S -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $.
    $( Elimination of redundant antecedent in an ordering law.  (Contributed by
       NM, 25-Jun-1998.) $)
    ndmovordi $p |- ( ( C F A ) R ( C F B ) -> A R B ) $=
      ( wcel co wbr brel simpld ndmovrcl syl biimprd mpcom ) CEKZCAFLZCBFLZDMZA
      BDMZUCUAEKZTUCUEUBEKUAUBEEDHNOUETAEKCAEFGIPOQTUDUCJRS $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x y E $.  $d x y ph $.
    $d x y F $.
    caovclg.1 $e |- ( ( ph /\ ( x e. C /\ y e. D ) ) -> ( x F y ) e. E ) $.
    $( Convert an operation closure law to class notation.  (Contributed by
       Mario Carneiro, 26-May-2014.) $)
    caovclg $p |- ( ( ph /\ ( A e. C /\ B e. D ) ) -> ( A F B ) e. E ) $=
      ( cv co wcel wral wa ralrimivva wceq oveq1 eleq1d oveq2 rspc2v mpan9 ) AB
      KZCKZILZHMZCGNBFNDFMEGMODEILZHMZAUFBCFGJPUFUHDUDILZHMBCDEFGUCDQUEUIHUCDUD
      IRSUDEQUIUGHUDEDITSUAUB $.

    caovcld.2 $e |- ( ph -> A e. C ) $.
    caovcld.3 $e |- ( ph -> B e. D ) $.
    $( Convert an operation closure law to class notation.  (Contributed by
       Mario Carneiro, 30-Dec-2014.) $)
    caovcld $p |- ( ph -> ( A F B ) e. E ) $=
      ( wcel co id caovclg syl12anc ) AADFMEGMDEINHMAOKLABCDEFGHIJPQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y F $.  $d x y ph $.  $d x y S $.
    caovcl.1 $e |- ( ( x e. S /\ y e. S ) -> ( x F y ) e. S ) $.
    $( Convert an operation closure law to class notation.  (Contributed by NM,
       4-Aug-1995.)  (Revised by Mario Carneiro, 26-May-2014.) $)
    caovcl $p |- ( ( A e. S /\ B e. S ) -> ( A F B ) e. S ) $=
      ( wtru wcel wa co tru cv adantl caovclg mpan ) HCEIDEIJCDFKEILHABCDEEEFAM
      ZEIBMZEIJQRFKEIHGNOP $.
  $}

  ${
    $( General laws for commutative, associative, distributive operations. $)
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d x y z ph $.
    $d x y z F $.  $d x y z G $.  $d x y z H $.  $d x y z K $.  $d x y z R $.
    $d x y z S $.  $d x y z T $.
    ${
      caovcomg.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                          ( x F y ) = ( y F x ) ) $.
      $( Convert an operation commutative law to class notation.  (Contributed
         by Mario Carneiro, 1-Jun-2013.) $)
      caovcomg $p |- ( ( ph /\ ( A e. S /\ B e. S ) ) ->
                        ( A F B ) = ( B F A ) ) $=
        ( cv co wceq wral wcel wa ralrimivva oveq1 oveq2 eqeq12d rspc2v mpan9 )
        ABIZCIZGJZUBUAGJZKZCFLBFLDFMEFMNDEGJZEDGJZKZAUEBCFFHOUEUHDUBGJZUBDGJZKB
        CDEFFUADKUCUIUDUJUADUBGPUADUBGQRUBEKUIUFUJUGUBEDGQUBEDGPRST $.

      caovcomd.2 $e |- ( ph -> A e. S ) $.
      caovcomd.3 $e |- ( ph -> B e. S ) $.
      $( Convert an operation commutative law to class notation.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovcomd $p |- ( ph -> ( A F B ) = ( B F A ) ) $=
        ( wcel co wceq id caovcomg syl12anc ) AADFKEFKDEGLEDGLMANIJABCDEFGHOP
        $.
    $}

    ${
      caovcom.1 $e |- A e. _V $.
      caovcom.2 $e |- B e. _V $.
      caovcom.3 $e |- ( x F y ) = ( y F x ) $.
      $( Convert an operation commutative law to class notation.  (Contributed
         by NM, 26-Aug-1995.)  (Revised by Mario Carneiro, 1-Jun-2013.) $)
      caovcom $p |- ( A F B ) = ( B F A ) $=
        ( cvv wcel wa co wceq pm3.2i cv a1i caovcomg mp2an ) CIJZSDIJZKCDELDCEL
        MFSTFGNSABCDIEAOZBOZELUBUAELMSUAIJUBIJKKHPQR $.
    $}

    ${
      caovassg.1 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
        ( ( x F y ) F z ) = ( x F ( y F z ) ) ) $.
      $( Convert an operation associative law to class notation.  (Contributed
         by Mario Carneiro, 1-Jun-2013.)  (Revised by Mario Carneiro,
         26-May-2014.) $)
      caovassg $p |- ( ( ph /\ ( A e. S /\ B e. S /\ C e. S ) ) ->
          ( ( A F B ) F C ) = ( A F ( B F C ) ) ) $=
        ( cv co wceq wral wcel oveq1 oveq1d eqeq12d oveq2 oveq2d rspc3v mpan9
        w3a ralrimivvva ) ABKZCKZILZDKZILZUEUFUHILZILZMZDHNCHNBHNEHOFHOGHOUCEFI
        LZGILZEFGILZILZMZAULBCDHHHJUDULUQEUFILZUHILZEUJILZMUMUHILZEFUHILZILZMBC
        DEFGHHHUEEMZUIUSUKUTVDUGURUHIUEEUFIPQUEEUJIPRUFFMZUSVAUTVCVEURUMUHIUFFE
        ISQVEUJVBEIUFFUHIPTRUHGMZVAUNVCUPUHGUMISVFVBUOEIUHGFISTRUAUB $.

      caovassd.2 $e |- ( ph -> A e. S ) $.
      caovassd.3 $e |- ( ph -> B e. S ) $.
      caovassd.4 $e |- ( ph -> C e. S ) $.
      $( Convert an operation associative law to class notation.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovassd $p |- ( ph -> ( ( A F B ) F C ) = ( A F ( B F C ) ) ) $=
        ( wcel co wceq id caovassg syl13anc ) AAEHNFHNGHNEFIOGIOEFGIOIOPAQKLMAB
        CDEFGHIJRS $.
    $}

    ${
      caovass.1 $e |- A e. _V $.
      caovass.2 $e |- B e. _V $.
      caovass.3 $e |- C e. _V $.
      caovass.4 $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
      $( Convert an operation associative law to class notation.  (Contributed
         by NM, 26-Aug-1995.)  (Revised by Mario Carneiro, 26-May-2014.) $)
      caovass $p |- ( ( A F B ) F C ) = ( A F ( B F C ) ) $=
        ( cvv wcel co wceq wtru w3a tru cv wa a1i caovassg mpan mp3an ) DLMZELM
        ZFLMZDEGNFGNDEFGNGNOZHIJPUEUFUGQUHRPABCDEFLGASZBSZGNCSZGNUIUJUKGNGNOPUI
        LMUJLMUKLMQTKUAUBUCUD $.
    $}

    ${
      caovcang.1 $e |- ( ( ph /\ ( x e. T /\ y e. S /\ z e. S ) ) ->
                         ( ( x F y ) = ( x F z ) <-> y = z ) ) $.
      $( Convert an operation cancellation law to class notation.  (Contributed
         by NM, 20-Aug-1995.)  (Revised by Mario Carneiro, 30-Dec-2014.) $)
      caovcang $p |- ( ( ph /\ ( A e. T /\ B e. S /\ C e. S ) ) ->
                       ( ( A F B ) = ( A F C ) <-> B = C ) ) $=
        ( cv co wceq wb wral wcel oveq1 oveq2 bibi12d ralrimivvva bibi1d eqeq1d
        w3a eqeq12d eqeq1 eqeq2d eqeq2 rspc3v mpan9 ) ABLZCLZJMZUKDLZJMZNZULUNN
        ZOZDHPCHPBIPEIQFHQGHQUDEFJMZEGJMZNZFGNZOZAURBCDIHHKUAURVCEULJMZEUNJMZNZ
        UQOUSVENZFUNNZOBCDEFGIHHUKENZUPVFUQVIUMVDUOVEUKEULJRUKEUNJRUEUBULFNZVFV
        GUQVHVJVDUSVEULFEJSUCULFUNUFTUNGNZVGVAVHVBVKVEUTUSUNGEJSUGUNGFUHTUIUJ
        $.

      caovcand.2 $e |- ( ph -> A e. T ) $.
      caovcand.3 $e |- ( ph -> B e. S ) $.
      caovcand.4 $e |- ( ph -> C e. S ) $.
      $( Convert an operation cancellation law to class notation.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovcand $p |- ( ph -> ( ( A F B ) = ( A F C ) <-> B = C ) ) $=
        ( wcel co wceq wb id caovcang syl13anc ) AAEIOFHOGHOEFJPEGJPQFGQRASLMNA
        BCDEFGHIJKTUA $.

      caovcanrd.5 $e |- ( ph -> A e. S ) $.
      caovcanrd.6 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                          ( x F y ) = ( y F x ) ) $.
      $( Commute the arguments of an operation cancellation law.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovcanrd $p |- ( ph -> ( ( B F A ) = ( C F A ) <-> B = C ) ) $=
        ( co wceq caovcomd eqeq12d caovcand bitr3d ) AEFJQZEGJQZRFEJQZGEJQZRFGR
        AUCUEUDUFABCEFHJPOMSABCEGHJPONSTABCDEFGHIJKLMNUAUB $.
    $}

    ${
      caovcan.1 $e |- C e. _V $.
      caovcan.2 $e |- ( ( x e. S /\ y e. S ) ->
                   ( ( x F y ) = ( x F z ) -> y = z ) ) $.
      $( Convert an operation cancellation law to class notation.  (Contributed
         by NM, 20-Aug-1995.) $)
      caovcan $p |- ( ( A e. S /\ B e. S ) ->
                   ( ( A F B ) = ( A F C ) -> B = C ) ) $=
        ( cv co wceq wi oveq1 eqeq12d imbi1d oveq2 imbi12d wcel eqeq1d eqeq1 wa
        eqeq2d eqeq2 imbi2d vtocl vtocl2ga ) AKZBKZHLZUIFHLZMZUJFMZNZDUJHLZDFHL
        ZMZUNNDEHLZUQMZEFMZNABDEGGUIDMZUMURUNVBUKUPULUQUIDUJHOUIDFHOPQUJEMZURUT
        UNVAVCUPUSUQUJEDHRUAUJEFUBSUIGTUJGTUCZUKUICKZHLZMZUJVEMZNZNVDUONCFIVEFM
        ZVIUOVDVJVGUMVHUNVJVFULUKVEFUIHRUDVEFUJUESUFJUGUH $.
    $}

    ${
      caovordig.1 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                         ( x R y -> ( z F x ) R ( z F y ) ) ) $.
      $( Convert an operation ordering law to class notation.  (Contributed by
         Mario Carneiro, 31-Dec-2014.) $)
      caovordig $p |- ( ( ph /\ ( A e. S /\ B e. S /\ C e. S ) ) ->
                      ( A R B -> ( C F A ) R ( C F B ) ) ) $=
        ( cv wbr co wi wral wcel wceq oveq2 imbi12d w3a ralrimivvva breq1 breq2
        breq1d breq2d oveq1 breq12d imbi2d rspc3v mpan9 ) ABLZCLZHMZDLZULJNZUOU
        MJNZHMZOZDIPCIPBIPEIQFIQGIQUAEFHMZGEJNZGFJNZHMZOZAUSBCDIIIKUBUSVDEUMHMZ
        UOEJNZUQHMZOUTVFUOFJNZHMZOBCDEFGIIIULERZUNVEURVGULEUMHUCVJUPVFUQHULEUOJ
        SUETUMFRZVEUTVGVIUMFEHUDVKUQVHVFHUMFUOJSUFTUOGRZVIVCUTVLVFVAVHVBHUOGEJU
        GUOGFJUGUHUIUJUK $.

      caovordid.2 $e |- ( ph -> A e. S ) $.
      caovordid.3 $e |- ( ph -> B e. S ) $.
      caovordid.4 $e |- ( ph -> C e. S ) $.
      $( Convert an operation ordering law to class notation.  (Contributed by
         Mario Carneiro, 31-Dec-2014.) $)
      caovordid $p |- ( ph -> ( A R B -> ( C F A ) R ( C F B ) ) ) $=
        ( wcel wbr co wi id caovordig syl13anc ) AAEIOFIOGIOEFHPGEJQGFJQHPRASLM
        NABCDEFGHIJKTUA $.
    $}

    ${
      caovordg.1 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                         ( x R y <-> ( z F x ) R ( z F y ) ) ) $.
      $( Convert an operation ordering law to class notation.  (Contributed by
         NM, 19-Feb-1996.)  (Revised by Mario Carneiro, 30-Dec-2014.) $)
      caovordg $p |- ( ( ph /\ ( A e. S /\ B e. S /\ C e. S ) ) ->
                      ( A R B <-> ( C F A ) R ( C F B ) ) ) $=
        ( cv wbr co wb wral wcel wceq oveq2 bibi12d w3a ralrimivvva breq1 breq2
        breq1d breq2d oveq1 breq12d bibi2d rspc3v mpan9 ) ABLZCLZHMZDLZULJNZUOU
        MJNZHMZOZDIPCIPBIPEIQFIQGIQUAEFHMZGEJNZGFJNZHMZOZAUSBCDIIIKUBUSVDEUMHMZ
        UOEJNZUQHMZOUTVFUOFJNZHMZOBCDEFGIIIULERZUNVEURVGULEUMHUCVJUPVFUQHULEUOJ
        SUETUMFRZVEUTVGVIUMFEHUDVKUQVHVFHUMFUOJSUFTUOGRZVIVCUTVLVFVAVHVBHUOGEJU
        GUOGFJUGUHUIUJUK $.

      caovordd.2 $e |- ( ph -> A e. S ) $.
      caovordd.3 $e |- ( ph -> B e. S ) $.
      caovordd.4 $e |- ( ph -> C e. S ) $.
      $( Convert an operation ordering law to class notation.  (Contributed by
         Mario Carneiro, 30-Dec-2014.) $)
      caovordd $p |- ( ph -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $=
        ( wcel wbr co wb id caovordg syl13anc ) AAEIOFIOGIOEFHPGEJQGFJQHPRASLMN
        ABCDEFGHIJKTUA $.

      caovord2d.com $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                            ( x F y ) = ( y F x ) ) $.
      $( Operation ordering law with commuted arguments.  (Contributed by Mario
         Carneiro, 30-Dec-2014.) $)
      caovord2d $p |- ( ph -> ( A R B <-> ( A F C ) R ( B F C ) ) ) $=
        ( wbr co caovordd caovcomd breq12d bitrd ) AEFHPGEJQZGFJQZHPEGJQZFGJQZH
        PABCDEFGHIJKLMNRAUBUDUCUEHABCGEIJONLSABCGFIJONMSTUA $.

      caovord3d.5 $e |- ( ph -> D e. S ) $.
      $( Ordering law.  (Contributed by Mario Carneiro, 30-Dec-2014.) $)
      caovord3d $p |- ( ph ->
        ( ( A F B ) = ( C F D ) -> ( A R C <-> D R B ) ) ) $=
        ( co wbr wb wceq breq1 caovord2d caovordd bibi12d syl5ibr ) EFKRZGHKRZU
        AEGISZHFISZTAUGGFKRZISZUHUKISZTUGUHUKIUBAUIULUJUMABCDEGFIJKLMONPUCABCDH
        FGIJKLQNOUDUEUF $.
    $}

    ${
      caovord.1 $e |- A e. _V $.
      caovord.2 $e |- B e. _V $.
      caovord.3 $e |- ( z e. S -> ( x R y <-> ( z F x ) R ( z F y ) ) ) $.
      $( Convert an operation ordering law to class notation.  (Contributed by
         NM, 19-Feb-1996.) $)
      caovord $p |- ( C e. S -> ( A R B <-> ( C F A ) R ( C F B ) ) ) $=
        ( wbr cv co wb wceq oveq1 wi oveq2 breq12d bibi2d wcel wa breq1 bibi12d
        breq1d breq2 breq2d sylan9bb imbi2d vtocl2 vtoclga ) DEGMZCNZDIOZUOEIOZ
        GMZPZUNFDIOZFEIOZGMZPCFHUOFQZURVBUNVCUPUTUQVAGUOFDIRUOFEIRUAUBUOHUCZANZ
        BNZGMZUOVEIOZUOVFIOZGMZPZSVDUSSABDEJKVEDQZVFEQZUDVKUSVDVLVKDVFGMZUPVIGM
        ZPVMUSVLVGVNVJVOVEDVFGUEVLVHUPVIGVEDUOITUGUFVMVNUNVOURVFEDGUHVMVIUQUPGV
        FEUOITUIUFUJUKLULUM $.

      $( (We don't bother to eliminate this redundant hypothesis.) $)
      caovord2.3 $e |- C e. _V $.
      caovord2.com $e |- ( x F y ) = ( y F x ) $.
      $( Operation ordering law with commuted arguments.  (Contributed by NM,
         27-Feb-1996.) $)
      caovord2 $p |- ( C e. S -> ( A R B <-> ( A F C ) R ( B F C ) ) ) $=
        ( wcel wbr co caovord caovcom breq12i syl6bb ) FHODEGPFDIQZFEIQZGPDFIQZ
        EFIQZGPABCDEFGHIJKLRUBUDUCUEGABFDIMJNSABFEIMKNSTUA $.

      $( (We don't bother to eliminate redundant hypotheses.) $)
      caovord3.4 $e |- D e. _V $.
      $( Ordering law.  (Contributed by NM, 29-Feb-1996.) $)
      caovord3 $p |- ( ( ( B e. S /\ C e. S ) /\
                ( A F B ) = ( C F D ) ) -> ( A R C <-> D R B ) ) $=
        ( wcel wa co wbr wceq wb caovord2 adantr breq1 sylan9bb ad2antlr bitr4d
        caovord ) EIQZFIQZRZDEJSZFGJSZUAZRDFHTZUNFEJSZHTZGEHTZULUPUMUQHTZUOURUJ
        UPUTUBUKABCDFEHIJKNMLOUCUDUMUNUQHUEUFUKUSURUBUJUOABCGEFHIJPLMUIUGUH $.
    $}

    ${
      caovdig.1 $e |- ( ( ph /\ ( x e. K /\ y e. S /\ z e. S ) ) ->
        ( x G ( y F z ) ) = ( ( x G y ) H ( x G z ) ) ) $.
      $( Convert an operation distributive law to class notation.  (Contributed
         by NM, 25-Aug-1995.)  (Revised by Mario Carneiro, 26-Jul-2014.) $)
      caovdig $p |- ( ( ph /\ ( A e. K /\ B e. S /\ C e. S ) ) ->
        ( A G ( B F C ) ) = ( ( A G B ) H ( A G C ) ) ) $=
        ( cv co wceq wral wcel oveq1 eqeq12d oveq12d oveq2d oveq2 oveq1d rspc3v
        w3a ralrimivvva mpan9 ) ABNZCNZDNZIOZJOZUIUJJOZUIUKJOZKOZPZDHQCHQBLQELR
        FHRGHRUFEFGIOZJOZEFJOZEGJOZKOZPZAUQBCDLHHMUGUQVCEULJOZEUJJOZEUKJOZKOZPE
        FUKIOZJOZUTVFKOZPBCDEFGLHHUIEPZUMVDUPVGUIEULJSVKUNVEUOVFKUIEUJJSUIEUKJS
        UATUJFPZVDVIVGVJVLULVHEJUJFUKISUBVLVEUTVFKUJFEJUCUDTUKGPZVIUSVJVBVMVHUR
        EJUKGFIUCUBVMVFVAUTKUKGEJUCUBTUEUH $.

      caovdid.2 $e |- ( ph -> A e. K ) $.
      caovdid.3 $e |- ( ph -> B e. S ) $.
      caovdid.4 $e |- ( ph -> C e. S ) $.
      $( Convert an operation distributive law to class notation.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovdid $p |- ( ph -> ( A G ( B F C ) ) = ( ( A G B ) H ( A G C ) ) ) $=
        ( wcel co wceq id caovdig syl13anc ) AAELQFHQGHQEFGIRJREFJREGJRKRSATNOP
        ABCDEFGHIJKLMUAUB $.
    $}

    ${
      caovdir2d.1 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
        ( x G ( y F z ) ) = ( ( x G y ) F ( x G z ) ) ) $.
      caovdir2d.2 $e |- ( ph -> A e. S ) $.
      caovdir2d.3 $e |- ( ph -> B e. S ) $.
      caovdir2d.4 $e |- ( ph -> C e. S ) $.
      caovdir2d.cl $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                           ( x F y ) e. S ) $.
      caovdir2d.com $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                            ( x G y ) = ( y G x ) ) $.
      $( Convert an operation distributive law to class notation.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovdir2d $p |- ( ph
          -> ( ( A F B ) G C ) = ( ( A G C ) F ( B G C ) ) ) $=
        ( co caovdid caovcld caovcomd oveq12d 3eqtr4d ) AGEFIQZJQGEJQZGFJQZIQUC
        GJQEGJQZFGJQZIQABCDGEFHIJIHKNLMRABCUCGHJPABCEFHHHIOLMSNTAUFUDUGUEIABCEG
        HJPLNTABCFGHJPMNTUAUB $.
    $}

    ${
      caovdirg.1 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. K ) ) ->
        ( ( x F y ) G z ) = ( ( x G z ) H ( y G z ) ) ) $.
      $( Convert an operation reverse distributive law to class notation.
         (Contributed by Mario Carneiro, 19-Oct-2014.) $)
      caovdirg $p |- ( ( ph /\ ( A e. S /\ B e. S /\ C e. K ) ) ->
        ( ( A F B ) G C ) = ( ( A G C ) H ( B G C ) ) ) $=
        ( cv co wceq wral wcel oveq1 oveq2 w3a ralrimivvva oveq1d oveq2d rspc3v
        eqeq12d oveq12d mpan9 ) ABNZCNZIOZDNZJOZUIULJOZUJULJOZKOZPZDLQCHQBHQEHR
        FHRGLRUAEFIOZGJOZEGJOZFGJOZKOZPZAUQBCDHHLMUBUQVCEUJIOZULJOZEULJOZUOKOZP
        URULJOZVFFULJOZKOZPBCDEFGHHLUIEPZUMVEUPVGVKUKVDULJUIEUJISUCVKUNVFUOKUIE
        ULJSUCUFUJFPZVEVHVGVJVLVDURULJUJFEITUCVLUOVIVFKUJFULJSUDUFULGPZVHUSVJVB
        ULGURJTVMVFUTVIVAKULGEJTULGFJTUGUFUEUH $.

      caovdird.2 $e |- ( ph -> A e. S ) $.
      caovdird.3 $e |- ( ph -> B e. S ) $.
      caovdird.4 $e |- ( ph -> C e. K ) $.
      $( Convert an operation distributive law to class notation.  (Contributed
         by Mario Carneiro, 30-Dec-2014.) $)
      caovdird $p |- ( ph -> ( ( A F B ) G C ) = ( ( A G C ) H ( B G C ) ) ) $=
        ( wcel co wceq id caovdirg syl13anc ) AAEHQFHQGLQEFIRGJREGJRFGJRKRSATNO
        PABCDEFGHIJKLMUAUB $.
    $}

    ${
      caovdi.1 $e |- A e. _V $.
      caovdi.2 $e |- B e. _V $.
      caovdi.3 $e |- C e. _V $.
      caovdi.4 $e |- ( x G ( y F z ) ) = ( ( x G y ) F ( x G z ) ) $.
      $( Convert an operation distributive law to class notation.  (Contributed
         by NM, 25-Aug-1995.)  (Revised by Mario Carneiro, 28-Jun-2013.) $)
      caovdi $p |- ( A G ( B F C ) ) = ( ( A G B ) F ( A G C ) ) $=
        ( cvv wcel co wceq wtru w3a tru cv wa a1i caovdig mpan mp3an ) DMNZEMNZ
        FMNZDEFGOHODEHODFHOGOPZIJKQUFUGUHRUISQABCDEFMGHGMATZBTZCTZGOHOUJUKHOUJU
        LHOGOPQUJMNUKMNULMNRUALUBUCUDUE $.
    $}

    ${
      caovd.1 $e |- ( ph -> A e. S ) $.
      caovd.2 $e |- ( ph -> B e. S ) $.
      caovd.3 $e |- ( ph -> C e. S ) $.
      caovd.com $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
        ( x F y ) = ( y F x ) ) $.
      caovd.ass $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
        ( ( x F y ) F z ) = ( x F ( y F z ) ) ) $.
      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
         30-Dec-2014.) $)
      caov32d $p |- ( ph -> ( ( A F B ) F C ) = ( ( A F C ) F B ) ) $=
        ( co caovcomd oveq2d caovassd 3eqtr4d ) AEFGIOZIOEGFIOZIOEFIOGIOEGIOFIO
        ATUAEIABCFGHIMKLPQABCDEFGHINJKLRABCDEGFHINJLKRS $.

      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
         30-Dec-2014.) $)
      caov12d $p |- ( ph -> ( A F ( B F C ) ) = ( B F ( A F C ) ) ) $=
        ( co caovcomd oveq1d caovassd 3eqtr3d ) AEFIOZGIOFEIOZGIOEFGIOIOFEGIOIO
        ATUAGIABCEFHIMJKPQABCDEFGHINJKLRABCDFEGHINKJLRS $.

      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
         30-Dec-2014.) $)
      caov31d $p |- ( ph -> ( ( A F B ) F C ) = ( ( C F B ) F A ) ) $=
        ( co caovcomd oveq1d caov32d 3eqtr4d ) AEGIOZFIOGEIOZFIOEFIOGIOGFIOEIOA
        TUAFIABCEGHIMJLPQABCDEFGHIJKLMNRABCDGFEHILKJMNRS $.

      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
         30-Dec-2014.) $)
      caov13d $p |- ( ph -> ( A F ( B F C ) ) = ( C F ( B F A ) ) ) $=
        ( co caov31d caovassd 3eqtr3d ) AEFIOGIOGFIOEIOEFGIOIOGFEIOIOABCDEFGHIJ
        KLMNPABCDEFGHINJKLQABCDGFEHINLKJQR $.

      ${
        caovd.4 $e |- ( ph -> D e. S ) $.
        caovd.cl $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x F y ) e. S ) $.
        $( Rearrange arguments in a commutative, associative operation.
           (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
           30-Dec-2014.) $)
        caov4d $p |- ( ph -> ( ( A F B ) F ( C F D ) ) =
                             ( ( A F C ) F ( B F D ) ) ) $=
          ( co caovcld caovassd caov12d oveq2d 3eqtr4d ) AEFGHJRZJRZJREGFHJRZJR
          ZJREFJRUDJREGJRUFJRAUEUGEJABCDFGHIJLMPNOUAUBABCDEFUDIJOKLABCGHIIIJQMP
          STABCDEGUFIJOKMABCFHIIIJQLPSTUC $.

        $( Rearrange arguments in a commutative, associative operation.
           (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
           30-Dec-2014.) $)
        caov411d $p |- ( ph -> ( ( A F B ) F ( C F D ) ) =
                               ( ( C F B ) F ( A F D ) ) ) $=
          ( co caovcomd oveq1d caov4d 3eqtr3d ) AFEJRZGHJRZJRFGJRZEHJRZJREFJRZU
          DJRGFJRZUFJRABCDFEGHIJLKMNOPQUAAUCUGUDJABCFEIJNLKSTAUEUHUFJABCFGIJNLM
          STUB $.

        $( Rearrange arguments in a commutative, associative operation.
           (Contributed by NM, 26-Aug-1995.)  (Revised by Mario Carneiro,
           30-Dec-2014.) $)
        caov42d $p |- ( ph -> ( ( A F B ) F ( C F D ) ) =
                              ( ( A F C ) F ( D F B ) ) ) $=
          ( co caov4d caovcomd oveq2d eqtrd ) AEFJRGHJRJREGJRZFHJRZJRUCHFJRZJRA
          BCDEFGHIJKLMNOPQSAUDUEUCJABCFHIJNLPTUAUB $.
      $}
    $}

    ${
      caov.1 $e |- A e. _V $.
      caov.2 $e |- B e. _V $.
      caov.3 $e |- C e. _V $.
      caov.com $e |- ( x F y ) = ( y F x ) $.
      caov.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.) $)
      caov32 $p |- ( ( A F B ) F C ) = ( ( A F C ) F B ) $=
        ( co caovcom oveq2i caovass 3eqtr4i ) DEFGMZGMDFEGMZGMDEGMFGMDFGMEGMRSD
        GABEFGIJKNOABCDEFGHIJLPABCDFEGHJILPQ $.

      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.) $)
      caov12 $p |- ( A F ( B F C ) ) = ( B F ( A F C ) ) $=
        ( co caovcom oveq1i caovass 3eqtr3i ) DEGMZFGMEDGMZFGMDEFGMGMEDFGMGMRSF
        GABDEGHIKNOABCDEFGHIJLPABCEDFGIHJLPQ $.

      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.) $)
      caov31 $p |- ( ( A F B ) F C ) = ( ( C F B ) F A ) $=
        ( co caovass caov12 eqtri caov32 eqtr3i 3eqtr4i ) DFGMEGMZFDEGMZGMZUAFG
        MFEGMZDGMZTDUCGMUBABCDFEGHJILNABCDFEGHJIKLOPABCDEFGHIJKLQFDGMEGMUDUBABC
        FDEGJHIKLQABCFDEGJHILNRS $.

      $( Rearrange arguments in a commutative, associative operation.
         (Contributed by NM, 26-Aug-1995.) $)
      caov13 $p |- ( A F ( B F C ) ) = ( C F ( B F A ) ) $=
        ( co caov31 caovass 3eqtr3i ) DEGMFGMFEGMDGMDEFGMGMFEDGMGMABCDEFGHIJKLN
        ABCDEFGHIJLOABCFEDGJIHLOP $.

      ${
        caov.4 $e |- D e. _V $.
        $( Rearrange arguments in a commutative, associative operation.
           (Contributed by NM, 26-Aug-1995.) $)
        caov4 $p |- ( ( A F B ) F ( C F D ) ) = ( ( A F C ) F ( B F D ) ) $=
          ( co caov12 oveq2i ovex caovass 3eqtr4i ) DEFGHOZHOZHODFEGHOZHOZHODEH
          OUAHODFHOUCHOUBUDDHABCEFGHJKNLMPQABCDEUAHIJFGHRMSABCDFUCHIKEGHRMST $.

        $( Rearrange arguments in a commutative, associative operation.
           (Contributed by NM, 26-Aug-1995.) $)
        caov411 $p |- ( ( A F B ) F ( C F D ) ) = ( ( C F B ) F ( A F D ) ) $=
          ( co caov31 oveq1i ovex caovass 3eqtr3i ) DEHOZFHOZGHOFEHOZDHOZGHOUAF
          GHOHOUCDGHOHOUBUDGHABCDEFHIJKLMPQABCUAFGHDEHRKNMSABCUCDGHFEHRINMST $.

        $( Rearrange arguments in a commutative, associative operation.
           (Contributed by NM, 26-Aug-1995.) $)
        caov42 $p |- ( ( A F B ) F ( C F D ) ) =
                        ( ( A F C ) F ( D F B ) ) $=
          ( co caov4 caovcom oveq2i eqtri ) DEHOFGHOHODFHOZEGHOZHOTGEHOZHOABCDE
          FGHIJKLMNPUAUBTHABEGHJNLQRS $.
      $}
    $}

    ${
      caovdir.1 $e |- A e. _V $.
      caovdir.2 $e |- B e. _V $.
      caovdir.3 $e |- C e. _V $.
      caovdir.com $e |- ( x G y ) = ( y G x ) $.
      caovdir.distr $e |- ( x G ( y F z ) ) = ( ( x G y ) F ( x G z ) ) $.
      $( Reverse distributive law.  (Contributed by NM, 26-Aug-1995.) $)
      caovdir $p |- ( ( A F B ) G C ) = ( ( A G C ) F ( B G C ) ) $=
        ( co caovdi ovex caovcom oveq12i 3eqtr3i ) FDEGNZHNFDHNZFEHNZGNTFHNDFHN
        ZEFHNZGNABCFDEGHKIJMOABFTHKDEGPLQUAUCUBUDGABFDHKILQABFEHKJLQRS $.

      $d x y z H $.  $d x y z R $.
      caovdl.4 $e |- D e. _V $.
      caovdl.5 $e |- H e. _V $.
      caovdl.ass $e |- ( ( x G y ) G z ) = ( x G ( y G z ) ) $.
      $( Lemma used by real number construction.  (Contributed by NM,
         26-Aug-1995.) $)
      caovdilem $p |- ( ( ( A G C ) F ( B G D ) ) G H ) =
                       ( ( A G ( C G H ) ) F ( B G ( D G H ) ) ) $=
        ( co ovex caovdir caovass oveq12i eqtri ) DFISZEGISZHSJISUEJISZUFJISZHS
        DFJISISZEGJISISZHSABCUEUFJHIDFITEGITQNOUAUGUIUHUJHABCDFJIKMQRUBABCEGJIL
        PQRUBUCUD $.

      caovdl2.6 $e |- R e. _V $.
      caovdl2.com $e |- ( x F y ) = ( y F x ) $.
      caovdl2.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
      $( Lemma used in real number construction.  (Contributed by NM,
         26-Aug-1995.) $)
      caovlem2 $p |- ( ( ( ( A G C ) F ( B G D ) ) G H ) F
                        ( ( ( A G D ) F ( B G C ) ) G R ) ) =
   ( ( A G ( ( C G H ) F ( D G R ) ) ) F ( B G ( ( C G R ) F ( D G H ) ) ) ) $=
        ( co ovex caov42 caovdilem oveq12i caovdi 3eqtr4i ) DFKJUCZJUCZEGKJUCZJ
        UCZIUCZDGHJUCZJUCZEFHJUCZJUCZIUCZIUCUKUPIUCZURUMIUCZIUCDFJUCEGJUCIUCKJU
        CZDGJUCEFJUCIUCHJUCZIUCDUJUOIUCJUCZEUQULIUCJUCZIUCABCUKUMUPURIDUJJUDEUL
        JUDDUOJUDUAUBEUQJUDUEVBUNVCUSIABCDEFGIJKLMNOPQRSUFABCDEGFIJHLMQOPNTSUFU
        GVDUTVEVAIABCDUJUOIJLFKJUDGHJUDPUHABCEUQULIJMFHJUDGKJUDPUHUGUI $.
    $}

    ${
      $d u w A $.  $d u v w x y B $.  $d u v w x y z F $.  $d w x S $.
      $( Identity element. $)
      caovmo.2 $e |- B e. S $.
      caovmo.dom $e |- dom F = ( S X. S ) $.
      caovmo.3 $e |- -. (/) e. S $.
      caovmo.com $e |- ( x F y ) = ( y F x ) $.
      caovmo.ass $e |- ( ( x F y ) F z ) = ( x F ( y F z ) ) $.
      caovmo.id $e |- ( x e. S -> ( x F B ) = x ) $.
      $( Uniqueness of inverse element in commutative, associative operation
         with identity.  Remark in proof of Proposition 9-2.4 of [Gleason]
         p. 119.  (Contributed by NM, 4-Mar-1996.) $)
      caovmo $p |- E* w ( A F w ) = B $=
        ( vv wcel co wceq wa syl vu cv wmo wi oveq1 eqeq1d mobidv wal oveq2 mo4
        simpr oveq2d simpl oveq1d vex caovass caov12 eqtri elexi caovcom eqtr3d
        3eqtr3g syl6eqel simprd id eqeq12d vtoclga 3eqtr3d ax-gen mpgbir vtoclg
        ndmovrcl moanimv mpbir eleq1 mpbiri simpld ancri moimi ax-mp ) EGPZEDUB
        ZHQZFRZSZDUCZWDDUCZWFWAWGUDUAUBZWBHQZFRZDUCZWGUAEGWHERZWJWDDWLWIWCFWHEW
        BHUEUFUGWKWJWHOUBZHQZFRZSZWBWMRZUDZOUHDWJWODOWQWIWNFWBWMWHHUIUFUJWROWPW
        BFHQZWMFHQZWBWMWPWBWNHQZWSWTWPWNFWBHWJWOUKZULWPWIWMHQZFWMHQXAWTWPWIFWMH
        WJWOUMZUNXCWHWBWMHQHQXAABCWHWBWMHUAUOZDUOZOUOZMUPABCWHWBWMHXEXFXGLMUQUR
        ABFWMHFGIUSXGLUTVBVAWPWBGPZWSWBRZWPWHGPZXHWPWIGPXJXHSWPWIFGXDIVCWHWBGHJ
        KVLTVDAUBZFHQZXKRZXIAWBGXKWBRZXLWSXKWBXKWBFHUEXNVEVFNVGTWPWMGPZWTWMRZWP
        XJXOWPWNGPXJXOSWPWNFGXBIVCWHWMGHJKVLTVDXMXPAWMGXKWMRZXLWTXKWMXKWMFHUEXQ
        VEVFNVGTVHVIVJVKWAWDDVMVNWDWEDWDWAWDWAXHWDWCGPZWAXHSWDXRFGPIWCFGVOVPEWB
        GHJKVLTVQVRVSVT $.
    $}
  $}

  ${
    $d n u v w x y z B $.  $d n u v w x y z O $.  $d n u v w x y z ph $.
    $d u v w y z N $.  $d n u v w x y z .+ $.  $d u v w y z X $.
    $d u v w y ps $.
    grprinvlem.c $e |- ( ( ph /\ x e. B /\ y e. B ) -> ( x .+ y ) e. B ) $.
    grprinvlem.o $e |- ( ph -> O e. B ) $.
    grprinvlem.i $e |- ( ( ph /\ x e. B ) -> ( O .+ x ) = x ) $.
    grprinvlem.a $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) )
          -> ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    grprinvlem.n $e |- ( ( ph /\ x e. B ) -> E. y e. B ( y .+ x ) = O ) $.
    ${
      grprinvlem.x $e |- ( ( ph /\ ps ) -> X e. B ) $.
      grprinvlem.e $e |- ( ( ph /\ ps ) -> ( X .+ X ) = X ) $.
      $( Lemma for ~ grprinvd .  (Contributed by NM, 9-Aug-2013.) $)
      grprinvlem $p |- ( ( ph /\ ps ) -> X = O ) $=
        ( cv co wceq wcel vu vv vw wa wrex wral ralrimiva oveq2 rexbidv cbvralv
        eqeq1d sylib rspccva syldan oveq2d adantr simprr oveq1d simpll caovassg
        sylan w3a simprl caovassd id eqeq12d rspcv sylc 3eqtr3d rexlimddv ) ABU
        DZDQZIGRZHSZIHSDFABIFTZVNDFUEZOAVLEQZGRZHSZDFUEZEFUFZVOVPAVLCQZGRZHSZDF
        UEZCFUFWAAWECFNUGWEVTCEFWBVQSZWDVSDFWFWCVRHWBVQVLGUHUKUIUJULVTVPEIFVQIS
        ZVSVNDFWGVRVMHVQIVLGUHUKUIUMVAUNVKVLFTZVNUDZUDZVLIIGRZGRZVMIHVKWLVMSWIV
        KWKIVLGPUOUPWJVMIGRHIGRZWLIWJVMHIGVKWHVNUQZURWJUAUBUCVLIIFGWJAUAQZFTUBQ
        ZFTUCQZFTVBWOWPGRWQGRWOWPWQGRGRSABWIUSACDEWOWPWQFGMUTVAVKWHVNVCVKVOWIOU
        PZWRVDVKWMISZWIVKVOHVLGRZVLSZDFUFZWSOAXBBAHWBGRZWBSZCFUFXBAXDCFLUGXDXAC
        DFWBVLSZXCWTWBVLWBVLHGUHXEVEVFUJULUPXAWSDIFVLISZWTWMVLIVLIHGUHXFVEVFVGV
        HUPVIWNVIVJ $.
    $}

    ${
      grprinvd.x $e |- ( ( ph /\ ps ) -> X e. B ) $.
      grprinvd.n $e |- ( ( ph /\ ps ) -> N e. B ) $.
      grprinvd.e $e |- ( ( ph /\ ps ) -> ( N .+ X ) = O ) $.
      $( Deduce right inverse from left inverse and left identity in an
         associative structure (such as a group).  (Contributed by NM,
         10-Aug-2013.)  (Proof shortened by Mario Carneiro, 6-Jan-2015.) $)
      grprinvd $p |- ( ( ph /\ ps ) -> ( X .+ N ) = O ) $=
        ( co wcel vu vv vw wa cv caovclg adantlr caovcld wceq caovassg caovassd
        3expb oveq1d wral ralrimiva oveq2 id eqeq12d cbvralv sylib adantr rspcv
        w3a sylc 3eqtr3d oveq2d eqtrd grprinvlem ) ABCDEFGIJHGSZKLMNOABUDZUAUBJ
        HFFFGAUAUEZFTZUBUEZFTZUDVKVMGSZFTBACDVKVMFFFGACUEZFTDUEZFTVPVQGSFTKULUF
        UGPQUHZVJVIVIGSJHVIGSZGSVIVJUAUBUCJHVIFGAVLVNUCUEZFTVCVOVTGSVKVMVTGSGSU
        IBACDEVKVMVTFGNUJUGZPQVRUKVJVSHJGVJHJGSZHGSIHGSZVSHVJWBIHGRUMVJUAUBUCHJ
        HFGWAQPQUKVJHFTIVQGSZVQUIZDFUNZWCHUIZQAWFBAIVPGSZVPUIZCFUNWFAWICFMUOWIW
        ECDFVPVQUIZWHWDVPVQVPVQIGUPWJUQURUSUTVAWEWGDHFVQHUIZWDWCVQHVQHIGUPWKUQU
        RVBVDVEVFVGVH $.
    $}

    $( Deduce right identity from left inverse and left identity in an
       associative structure (such as a group).  (Contributed by NM,
       10-Aug-2013.)  (Proof shortened by Mario Carneiro, 6-Jan-2015.) $)
    grpridd $p |- ( ( ph /\ x e. B ) -> ( x .+ O ) = x ) $=
      ( vn vu vv cv wcel wa co wceq vw wrex oveq1 eqeq1d cbvrexv sylib caovassg
      w3a adantlr simprl simprrl caovassd simprrr oveq1d oveq2d 3eqtr3d anassrs
      grprinvd rexlimddv eqtr3d ) ABPZEQZRZGVAFSZVAGFSZVAVCMPZVAFSZGTZVDVETZMEV
      CCPZVAFSZGTZCEUBVHMEUBLVLVHCMEVJVFTVKVGGVJVFVAFUCUDUEUFAVBVFEQZVHRZVIAVBV
      NRZRZVAVFFSZVAFSVAVGFSVDVEVPNOUAVAVFVAEFANPZEQOPZEQUAPZEQUHVRVSFSVTFSVRVS
      VTFSFSTVOABCDVRVSVTEFKUGUIAVBVNUJZAVBVMVHUKZWAULVPVQGVAFAVOBCDEFVFGVAHIJK
      LWAWBAVBVMVHUMZURUNVPVGGVAFWCUOUPUQUSJUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        "Maps to" notation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y z $.  $d B x y z $.  $d C z $.
    elmpt2cl.f $e |- F = ( x e. A , y e. B |-> C ) $.
    $( If a two-parameter class is not empty, constrain the implicit pair.
       (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    elmpt2cl $p |- ( X e. ( S F T ) -> ( S e. A /\ T e. B ) ) $=
      ( vz co wcel cop cxp wa cdm cv wceq coprab cmpt2 df-mpt2 dmoprabss elfvdm
      eqtri dmeqi eqsstri cfv df-ov eleq2s sseldi opelxp sylib ) IFGHLZMZFGNZCD
      OZMFCMGDMPUOHQZUQUPURARCMBRDMPKRESZPABKTZQUQHUTHABCDEUAUTJABKCDEUBUEUFUSA
      BKCDUCUGUPURMIUPHUHUNIUPHUDFGHUIUJUKFGCDULUM $.

    $( If a two-parameter class is not empty, the first argument is in its
       nominal domain.  (Contributed by FL, 15-Oct-2012.)  (Revised by Stefan
       O'Rear, 7-Mar-2015.) $)
    elmpt2cl1 $p |- ( X e. ( S F T ) -> S e. A ) $=
      ( co wcel elmpt2cl simpld ) IFGHKLFCLGDLABCDEFGHIJMN $.

    $( If a two-parameter class is not empty, the second argument is in its
       nominal domain.  (Contributed by FL, 15-Oct-2012.)  (Revised by Stefan
       O'Rear, 7-Mar-2015.) $)
    elmpt2cl2 $p |- ( X e. ( S F T ) -> T e. B ) $=
      ( co wcel elmpt2cl simprd ) IFGHKLFCLGDLABCDEFGHIJMN $.
  $}

  ${
    $d A a b $.  $d B a b $.  $d E a b $.  $d F a b $.  $d X a b $.
    $d Y a b $.  $d V a b $.
    elovmpt2.d $e |- D = ( a e. A , b e. B |-> C ) $.
    elovmpt2.c $e |- C e. _V $.
    elovmpt2.e $e |- ( ( a = X /\ b = Y ) -> C = E ) $.
    $( Utility lemma for two-parameter classes.

       _EDITORIAL_: can simplify ~ isghm , ~ islmhm .  (Contributed by Stefan
       O'Rear, 21-Jan-2015.) $)
    elovmpt2 $p |- ( F e. ( X D Y ) <-> ( X e. A /\ Y e. B /\ F e. E ) ) $=
      ( co wcel wa cvv wceq wal cv w3a elmpt2cl gen2 eleq1d spc2gv mpi ovmpt2ga
      mpd3an3 eleq2d biadan2 df-3an bitr4i ) FGHDNZOZGAOZHBOZPZFEOZPUOUPURUAUNU
      QURIJABCGHDFKUBUQUMEFUOUPEQOZUMERUQCQOZJSISUSUTIJLUCUTUSIJGHABITGRJTHRPCE
      QMUDUEUFIJGHABCEDQMKUGUHUIUJUOUPURUKUL $.
  $}

  ${
    $d x w A $.  $d w B $.  $d w F $.
    relmptopab.1 $e |- F = ( x e. A |-> { <. y , z >. | ph } ) $.
    $( Any function to sets of ordered pairs produces a relation on function
       value unconditionally.  (Contributed by Mario Carneiro, 7-Aug-2014.)
       (Proof shortened by Mario Carneiro, 24-Dec-2016.) $)
    relmptopab $p |- Rel ( F ` B ) $=
      ( cfv wrel cvv cxp wss copab fvmptss cv wcel relopab df-rel mpbi a1i mprg
      mpbir ) FGIZJUDKKLZMZACDNZUEMZUFBEBEUGUEFGHOUHBPEQUGJUHACDRUGSTUAUBUDSUC
      $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d x y ph $.
    f1od.1 $e |- F = ( x e. A |-> C ) $.
    ${
      f1od.2 $e |- ( ( ph /\ x e. A ) -> C e. W ) $.
      f1od.3 $e |- ( ( ph /\ y e. B ) -> D e. X ) $.
      f1od.4 $e |- ( ph -> ( ( x e. A /\ y = C ) <-> ( y e. B /\ x = D ) ) ) $.
      $( Describe an implicit one-to-one onto function.  (Contributed by Mario
         Carneiro, 30-Apr-2015.) $)
      f1ocnvd $p |- ( ph ->
        ( F : A -1-1-onto-> B /\ `' F = ( y e. B |-> D ) ) ) $=
        ( ccnv cmpt wceq wfn wcel copab wf1o wral ralrimiva fnmpt eqid opabbidv
        cv wa df-mpt eqtri cnveqi cnvopab 3eqtr4g fneq1d mpbird dff1o4 sylanbrc
        syl jca ) ADEHUAZHOZCEGPZQAHDRZVAERZUTAFISZBDUBVCAVEBDLUCBDFHIKUDURAVDV
        BERZAGJSZCEUBVFAVGCEMUCCEGVBJVBUEUDURAEVAVBABUGZDSCUGZFQUHZCBTZVIESVHGQ
        UHZCBTVAVBAVJVLCBNUFVAVJBCTZOVKHVMHBDFPVMKBCDFUIUJUKVJBCULUJCBEGUIUMZUN
        UODEHUPUQVNUS $.

      $( Describe an implicit one-to-one onto function.  (Contributed by Mario
         Carneiro, 12-May-2014.) $)
      f1od $p |- ( ph -> F : A -1-1-onto-> B ) $=
        ( wf1o ccnv cmpt wceq f1ocnvd simpld ) ADEHOHPCEGQRABCDEFGHIJKLMNST $.
    $}

    f1o2d.2 $e |- ( ( ph /\ x e. A ) -> C e. B ) $.
    f1o2d.3 $e |- ( ( ph /\ y e. B ) -> D e. A ) $.
    f1o2d.4 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) ->
                    ( x = D <-> y = C ) ) $.
    $( Describe an implicit one-to-one onto function.  (Contributed by Mario
       Carneiro, 30-Apr-2015.) $)
    f1ocnv2d $p |- ( ph ->
      ( F : A -1-1-onto-> B /\ `' F = ( y e. B |-> D ) ) ) $=
      ( cv wcel wceq wa wi eleq1a syl impr biimpar exp42 com34 imp32 jcai com23
      biimpa impbida f1ocnvd ) ABCDEFGHEDIJKABMZDNZCMZFOZPZULENZUJGOZPZAUNPUOUP
      AUKUMUOAUKPFENUMUOQJFEULRSTAUKUMUOUPQAUKUOUMUPAUKUOUMUPAUKUOPPZUPUMLUAUBU
      CUDUEAUQPUKUMAUOUPUKAUOPGDNUPUKQKGDUJRSTAUOUPUKUMQAUOUKUPUMAUKUOUPUMQAUKU
      OUPUMURUPUMLUGUBUFUCUDUEUHUI $.

    $( Describe an implicit one-to-one onto function.  (Contributed by Mario
       Carneiro, 12-May-2014.) $)
    f1o2d $p |- ( ph -> F : A -1-1-onto-> B ) $=
      ( wf1o ccnv cmpt wceq f1ocnv2d simpld ) ADEHMHNCEGOPABCDEFGHIJKLQR $.
  $}

  ${
    $d A w x y z $.  $d B w x y z $.  $d V w y z $.
    $( The cross product of two sets is a set.  Proposition 6.2 of
       [TakeutiZaring] p. 23.  This version is proven using Replacement; see
       ~ xpexg for a version that uses the Power Set axiom instead.
       (Contributed by Mario Carneiro, 20-May-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    xpexgALT $p |- ( ( A e. V /\ B e. W ) -> ( A X. B ) e. _V ) $=
      ( vy vx wcel wa cxp cv csn ciun iunid xpeq2i xpiundi eqtr3i wral syl5eqel
      cvv id cmpt fconstmpt mptexg ralrimivw iunexg syl2anr ) ACGZBDGZHABIZEBAE
      JZKZIZLZSAEBUKLZIUIUMUNBAEBMNEBUKAOPUHUHULSGZEBQUMSGUGUHTUGUOEBUGULFAUJUA
      SFAUJUBFAUJCUCRUDEBULDSUEUFR $.
  $}

  ${
    $d a b A $.  $d a b B $.  $d a b F $.  $d a b ph $.
    f1opw2.1 $e |- ( ph -> F : A -1-1-onto-> B ) $.
    f1opw2.2 $e |- ( ph -> ( `' F " a ) e. _V ) $.
    f1opw2.3 $e |- ( ph -> ( F " b ) e. _V ) $.
    $( A one-to-one mapping induces a one-to-one mapping on power sets.  This
       version of ~ f1opw avoids the Axiom of Replacement.  (Contributed by
       Mario Carneiro, 26-Jun-2015.) $)
    f1opw2 $p |- ( ph ->
        ( b e. ~P A |-> ( F " b ) ) : ~P A -1-1-onto-> ~P B ) $=
      ( cpw cv cima wcel wss crn imassrn wceq syl cvv adantr ccnv cmpt eqid wfo
      wf1o f1ofo forn syl5sseq wb elpwg mpbird cdm dfdm4 f1odm syl5eqr wa elpwi
      adantl foimacnv syl2an eqcomd imaeq2 eqeq2d syl5ibrcom wf1 f1of1 f1imacnv
      impbid f1o2d ) AFEBJZCJZDFKZLZDUAZEKZLZFVJVMUBZVQUCAVMVKMZVLVJMZAVRVMCNZA
      DOZVMCDVLPABCDUDZWACQABCDUEZWBGBCDUFRZBCDUGRUHAVMSMVRVTUIIVMCSUJRUKTAVPVJ
      MZVOVKMZAWEVPBNZAVNOZVPBVNVOPAWHDULZBDUMAWCWIBQGBCDUNRUOUHAVPSMWEWGUIHVPB
      SUJRUKTAVSWFUPZUPZVLVPQZVOVMQZWKWMWLVODVPLZQWKWNVOAWBVOCNZWNVOQWJWDWFWOVS
      VOCUQURBCVODUSUTVAWLVMWNVOVLVPDVBVCVDWKWLWMVLVNVMLZQWKWPVLABCDVEZVLBNZWPV
      LQWJAWCWQGBCDVFRVSWRWFVLBUQTBCVLDVGUTVAWMVPWPVLVOVMVNVBVCVDVHVI $.
  $}

  ${
    $d a b A $.  $d a b B $.  $d a b F $.
    $( A one-to-one mapping induces a one-to-one mapping on power sets.
       (Contributed by Stefan O'Rear, 18-Nov-2014.)  (Revised by Mario
       Carneiro, 26-Jun-2015.) $)
    f1opw $p |- ( F : A -1-1-onto-> B -> ( b e. ~P A |-> ( F " b ) ) :
          ~P A -1-1-onto-> ~P B ) $=
      ( va wf1o id ccnv wfun cv cima cvv wfo dff1o3 simprbi vex funimaex f1ofun
      wcel syl f1opw2 ) ABCFZABCEDUBGUBCHZIZUCEJZKLSUBABCMUDABCNOUCUEEPQTUBCICD
      JZKLSABCRCUFDPQTUA $.
  $}

  ${
    $d k x y A $.  $d x y B $.  $d k x ph $.  $d k x y W $.  $d k x y Z $.
    suppss2.n $e |- ( ( ph /\ k e. ( A \ W ) ) -> B = Z ) $.
    $( Show that the support of a function is contained in a set.  (Contributed
       by Mario Carneiro, 19-Dec-2014.)  (Revised by Mario Carneiro,
       22-Mar-2015.) $)
    suppss2 $p |- ( ph -> ( `' ( k e. A |-> B ) " ( _V \ { Z } ) ) C_ W ) $=
      ( cmpt ccnv cvv csn cdif cima wcel crab eqid mptpreima cv wne wa eldifsni
      wn wceq eldif sylan2br expr necon1ad syl5 3impia rabssdv syl5eqss ) ADBCH
      ZIJFKLZMCUMNZDBOEDBCUMULULPQAUNDBEADRZBNZUNUOENZUNCFSAUPTZUQCJFUAURUQCFAU
      PUQUBZCFUCZUPUSTAUOBELNUTUOBEUDGUEUFUGUHUIUJUK $.
  $}

  ${
    $d ph x $.  $d Y x $.  $d Z x $.
    suppssfv.a $e |- ( ph -> ( `' ( x e. D |-> A ) " ( _V \ { Y } ) ) C_ L ) $.
    suppssfv.f $e |- ( ph -> ( F ` Y ) = Z ) $.
    suppssfv.v $e |- ( ( ph /\ x e. D ) -> A e. V ) $.
    $( Formula building theorem for support restriction, on a function which
       preserves zero.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    suppssfv $p |- ( ph -> ( `' ( x e. D |-> ( F ` A ) ) "
            ( _V \ { Z } ) ) C_ L ) $=
      ( cfv cmpt ccnv cvv csn cdif wcel wceq cima crab wne cv eldifsni elex syl
      wa adantr wi fveq2 eqeq1d syl5ibrcom necon3d imp eldifsn sylanbrc ex syl5
      ss2rabdv eqid mptpreima 3sstr4g sstrd ) ABDCEMZNZOPIQRZUAZBDCNZOPHQRZUAZF
      AVEVGSZBDUBCVJSZBDUBVHVKAVLVMBDVLVEIUCZABUDDSZUHZVMVEPIUEVPVNVMVPVNUHCPSZ
      CHUCZVMVPVQVNVPCGSVQLCGUFUGUIVPVNVRAVNVRUJVOACHVEIAVEITCHTZHEMZITKVSVEVTI
      CHEUKULUMUNUIUOCPHUPUQURUSUTBDVEVGVFVFVAVBBDCVJVIVIVAVBVCJVD $.
  $}

  ${
    $d ph v $.  $d ph x $.  $d B v $.  $d O v $.  $d R v $.  $d Y v $.
    $d Y x $.  $d Z v $.  $d Z x $.
    suppssov1.s $e |- ( ph ->
        ( `' ( x e. D |-> A ) " ( _V \ { Y } ) ) C_ L ) $.
    suppssov1.o $e |- ( ( ph /\ v e. R ) -> ( Y O v ) = Z ) $.
    suppssov1.a $e |- ( ( ph /\ x e. D ) -> A e. V ) $.
    suppssov1.b $e |- ( ( ph /\ x e. D ) -> B e. R ) $.
    $( Formula building theorem for support restrictions: operator with left
       annihilator.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    suppssov1 $p |- ( ph -> ( `' ( x e. D |-> ( A O B ) ) "
            ( _V \ { Z } ) ) C_ L ) $=
      ( co cvv wcel wceq cmpt ccnv csn cdif cima crab cv wa wne elex syl adantr
      eldifsni wral ralrimiva oveq2 eqeq1d rspcva syl2anc oveq1 syl5ibrcom syl5
      necon3d imp eldifsn sylanbrc ex ss2rabdv eqid mptpreima 3sstr4g sstrd ) A
      BFDEIQZUAZUBRLUCUDZUEZBFDUAZUBRKUCUDZUEZHAVMVOSZBFUFDVRSZBFUFVPVSAVTWABFA
      BUGFSZUHZVTWAWCVTUHDRSZDKUIZWAWCWDVTWCDJSWDODJUJUKULWCVTWEVTVMLUIWCWEVMRL
      UMWCDKVMLWCVMLTDKTZKEIQZLTZWCEGSKCUGZIQZLTZCGUNZWHPAWLWBAWKCGNUOULWKWHCEG
      WIETWJWGLWIEKIUPUQURUSWFVMWGLDKEIUTUQVAVCVBVDDRKVEVFVGVHBFVMVOVNVNVIVJBFD
      VRVQVQVIVJVKMVL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             Function operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c oF $.
  $c oR $.

  $( Extend class notation to include mapping of an operation to a function
     operation. $)
  cof $a class oF R $.

  $( Extend class notation to include mapping of a binary relation to a
     function relation. $)
  cofr $a class oR R $.

  ${
    $d f g x R $.
    $( Define the function operation map.  The definition is designed so that
       if ` R ` is a binary operation, then ` oF R ` is the analogous operation
       on functions which corresponds to applying ` R ` pointwise to the values
       of the functions.  (Contributed by Mario Carneiro, 20-Jul-2014.) $)
    df-of $a |- oF R = ( f e. _V , g e. _V |->
     ( x e. ( dom f i^i dom g ) |-> ( ( f ` x ) R ( g ` x ) ) ) ) $.

    $( Define the function relation map.  The definition is designed so that if
       ` R ` is a binary relation, then ` oF R ` is the analogous relation on
       functions which is true when each element of the left function relates
       to the corresponding element of the right function.  (Contributed by
       Mario Carneiro, 28-Jul-2014.) $)
    df-ofr $a |- oR R = { <. f , g >. |
      A. x e. ( dom f i^i dom g ) ( f ` x ) R ( g ` x ) } $.
  $}

  ${
    $d f g x y R $.  $d f g x y S $.
    $( Equality theorem for function operation.  (Contributed by Mario
       Carneiro, 20-Jul-2014.) $)
    ofeq $p |- ( R = S -> oF R = oF S ) $=
      ( vf vg vx wceq cvv cv cdm cin cfv co cmpt cmpt2 cof wcel w3a simp1 oveqd
      df-of mpteq2dv mpt2eq3dva 3eqtr4g ) ABFZCDGGECHZIDHZIJZEHZUEKZUHUFKZALZMZ
      NCDGGEUGUIUJBLZMZNAOBOUDCDGGULUNUDUEGPZUFGPZQZEUGUKUMUQABUIUJUDUOUPRSUAUB
      EACDTEBCDTUC $.

    $( Equality theorem for function relation.  (Contributed by Mario Carneiro,
       28-Jul-2014.) $)
    ofreq $p |- ( R = S -> oR R = oR S ) $=
      ( vx vf vg wceq cv cfv wbr cdm cin wral cofr breq ralbidv opabbidv df-ofr
      copab 3eqtr4g ) ABFZCGZDGZHZUAEGZHZAIZCUBJUDJKZLZDERUCUEBIZCUGLZDERAMBMTU
      HUJDETUFUICUGUCUEABNOPCADEQCBDEQS $.

    $( A function operation restricted to a set is a set.  (Contributed by NM,
       28-Jul-2014.) $)
    ofexg $p |- ( A e. V -> ( oF R |` A ) e. _V ) $=
      ( vf vg vx cof wfun wcel cres cvv cv cdm cin cmpt df-of mpt2fun resfunexg
      cfv co mpan ) BGZHACIUBAJKIDEKKFDLZMELZMNFLZUCSUEUDSBTOUBFBDEPQUBACRUA $.

    nfof.1 $e |- F/_ x R $.
    $( Hypothesis builder for function operation.  (Contributed by Mario
       Carneiro, 20-Jul-2014.) $)
    nfof $p |- F/_ x oF R $=
      ( cof nfcv ) ABDE $.

    $( Hypothesis builder for function relation.  (Contributed by Mario
       Carneiro, 28-Jul-2014.) $)
    nfofr $p |- F/_ x oR R $=
      ( cofr nfcv ) ABDE $.
  $}

  ${
    $d x A $.  $d f g x F $.  $d f g x G $.  $d x ph $.  $d x S $.  $d x X $.
    $d f g x R $.
    offval.1 $e |- ( ph -> F Fn A ) $.
    offval.2 $e |- ( ph -> G Fn B ) $.
    offval.3 $e |- ( ph -> A e. V ) $.
    offval.4 $e |- ( ph -> B e. W ) $.
    offval.5 $e |- ( A i^i B ) = S $.
    ${
      offval.6 $e |- ( ( ph /\ x e. A ) -> ( F ` x ) = C ) $.
      offval.7 $e |- ( ( ph /\ x e. B ) -> ( G ` x ) = D ) $.
      $( Value of an operation applied to two functions.  (Contributed by Mario
         Carneiro, 20-Jul-2014.) $)
      offval $p |- ( ph -> ( F oF R G ) = ( x e. S |-> ( C R D ) ) ) $=
        ( cvv vf vg cof co cdm cin cfv cmpt wcel wceq wfn fnex syl2anc fndm syl
        cv ineq12d syl6eq mpteq1d inex1g syl5eqelr mptexg 3syl eqeltrd wa fveq1
        dmeq ineqan12d oveqan12d mpteq12dv df-of ovmpt2ga syl3anc eleq2i bitr3i
        elin adantrr adantrl oveq12d sylan2b mpteq2dva 3eqtrd ) AIJGUCZUDZBIUEZ
        JUEZUFZBUPZIUGZWHJUGZGUDZUHZBHWKUHZBHEFGUDZUHAITUIZJTUIZWLTUIWDWLUJAICU
        KZCKUIZWOMOCKIULUMAJDUKZDLUIWPNPDLJULUMAWLWMTABWGHWKAWGCDUFZHAWECWFDAWQ
        WECUJMCIUNUOAWSWFDUJNDJUNUOUQQURUSZAWRHTUIWMTUIOWRHWTTQCDKUTVABHWKTVBVC
        VDUAUBIJTTBUAUPZUEZUBUPZUEZUFZWHXBUGZWHXDUGZGUDZUHWLWCTXBIUJZXDJUJZVEBX
        FXIWGWKXJXKXCWEXEWFXBIVGXDJVGVHXJXKXGWIXHWJGWHXBIVFWHXDJVFVIVJBGUAUBVKV
        LVMXAABHWKWNWHHUIZAWHCUIZWHDUIZVEZWKWNUJXLWHWTUIXOWTHWHQVNWHCDVPVOAXOVE
        WIEWJFGAXMWIEUJXNRVQAXNWJFUJXMSVRVSVTWAWB $.

      $( Value of a relation applied to two functions.  (Contributed by Mario
         Carneiro, 28-Jul-2014.) $)
      ofrfval $p |- ( ph -> ( F oR R G <-> A. x e. S C R D ) ) $=
        ( wcel vf vg cofr wbr cv cfv cdm cin wral cvv wb fnex syl2anc wceq dmeq
        wfn wa ineqan12d fveq1 breqan12d raleqbidv df-ofr brabga ineq12d syl6eq
        fndm raleqdv inss1 eqsstr3i sseli sylan2 inss2 breq12d ralbidva 3bitrd
        syl ) AIJGUCZUDZBUEZIUFZVSJUFZGUDZBIUGZJUGZUHZUIZWBBHUIEFGUDZBHUIAIUJTZ
        JUJTZVRWFUKAICUPZCKTWHMOCKIULUMAJDUPZDLTWINPDLJULUMVSUAUEZUFZVSUBUEZUFZ
        GUDZBWLUGZWNUGZUHZUIWFUAUBIJVQUJUJWLIUNZWNJUNZUQWPWBBWSWEWTXAWQWCWRWDWL
        IUOWNJUOURWTXAWMVTWOWAGVSWLIUSVSWNJUSUTVABGUAUBVBVCUMAWBBWEHAWECDUHZHAW
        CCWDDAWJWCCUNMCIVFVPAWKWDDUNNDJVFVPVDQVEVGAWBWGBHAVSHTZUQVTEWAFGXCAVSCT
        VTEUNHCVSHXBCQCDVHVIVJRVKXCAVSDTWAFUNHDVSHXBDQCDVLVIVJSVKVMVNVO $.
    $}

    ${
      ofval.6 $e |- ( ( ph /\ X e. A ) -> ( F ` X ) = C ) $.
      ofval.7 $e |- ( ( ph /\ X e. B ) -> ( G ` X ) = D ) $.
      $( Evaluate a function operation at a point.  (Contributed by Mario
         Carneiro, 20-Jul-2014.) $)
      ofval $p |- ( ( ph /\ X e. S ) -> ( ( F oF R G ) ` X ) = ( C R D ) ) $=
        ( cfv vx wcel wa cof co cv cmpt wceq eqidd offval fveq1d adantr oveq12d
        fveq2 eqid ovex fvmpt adantl inss1 eqsstr3i sseli sylan2 inss2 3eqtrd
        cin ) ALGUBZUCZLHIFUDUEZTZLUAGUAUFZHTZVJITZFUEZUGZTZLHTZLITZFUEZDEFUEAV
        IVOUHVFALVHVNAUABCVKVLFGHIJKMNOPQAVJBUBUCVKUIAVJCUBUCVLUIUJUKULVFVOVRUH
        AUALVMVRGVNVJLUHVKVPVLVQFVJLHUNVJLIUNUMVNUOVPVQFUPUQURVGVPDVQEFVFALBUBV
        PDUHGBLGBCVEZBQBCUSUTVARVBVFALCUBVQEUHGCLGVSCQBCVCUTVASVBUMVD $.

      $( Exhibit a function relation at a point.  (Contributed by Mario
         Carneiro, 28-Jul-2014.) $)
      ofrval $p |- ( ( ph /\ F oR R G /\ X e. S ) -> C R D ) $=
        ( wcel vx cofr wbr w3a cfv wa cv wral eqidd ofrfval biimpa wceq breq12d
        wi fveq2 rspccv syl 3impia simp1 cin inss1 eqsstr3i simp3 syl2anc inss2
        sseldi 3brtr3d ) AHIFUBUCZLGTZUDZLHUEZLIUEZDEFAVHVIVKVLFUCZAVHUFUAUGZHU
        EZVNIUEZFUCZUAGUHZVIVMUNAVHVRAUABCVOVPFGHIJKMNOPQAVNBTUFVOUIAVNCTUFVPUI
        UJUKVQVMUALGVNLULVOVKVPVLFVNLHUOVNLIUOUMUPUQURVJALBTVKDULAVHVIUSZVJGBLG
        BCUTZBQBCVAVBAVHVIVCZVFRVDVJALCTVLEULVSVJGCLGVTCQBCVEVBWAVFSVDVG $.
    $}

    $( The function operation produces a function.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    offn $p |- ( ph -> ( F oF R G ) Fn S ) $=
      ( vx co wfn cfv wcel wa cof cv cmpt ovex eqid fnmpti offval fneq1d mpbiri
      eqidd ) AFGDUAPZEQOEOUBZFRZULGRZDPZUCZEQOEUOUPUMUNDUDUPUEUFAEUKUPAOBCUMUN
      DEFGHIJKLMNAULBSTUMUJAULCSTUNUJUGUHUI $.
  $}

  $( Function value of a pointwise composition.  (Contributed by Stefan O'Rear,
     5-Oct-2014.)  (Proof shortened by Mario Carneiro, 5-Jun-2015.) $)
  fnfvof $p |- ( ( ( F Fn A /\ G Fn A ) /\ ( A e. V /\ X e. A ) ) ->
      ( ( F oF R G ) ` X ) = ( ( F ` X ) R ( G ` X ) ) ) $=
    ( wfn wa wcel cof co cfv wceq simpll simplr simpr inidm eqidd ofval anasss
    ) CAGZDAGZHZAEIZFAIZFCDBJKLFCLZFDLZBKMUCUDHZAAUFUGBACDEEFUAUBUDNUAUBUDOUCUD
    PZUIAQUHUEHZUFRUJUGRST $.

  ${
    $d F x a b $.  $d G x a b $.  $d V x $.  $d W x $.  $d R x a b $.
    $d D x $.
    $( General value of ` ( F oF R G ) ` with no assumptions on functionality
       of ` F ` and ` G ` .  (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    offval3 $p |- ( ( F e. V /\ G e. W ) -> ( F oF R G ) =
        ( x e. ( dom F i^i dom G ) |-> ( ( F ` x ) R ( G ` x ) ) ) ) $=
      ( va vb wcel wa cvv cdm cin cv cfv co cmpt wceq elex adantr adantl inex1g
      dmexg mptexg 3syl dmeq ineqan12d fveq1 oveqan12d mpteq12dv df-of ovmpt2ga
      cof syl3anc ) CEIZDFIZJCKIZDKIZACLZDLZMZANZCOZVBDOZBPZQZKIZCDBUMZPVFRUOUQ
      UPCESTUPURUODFSUAUOVGUPUOUSKIVAKIVGCEUCUSUTKUBAVAVEKUDUETGHCDKKAGNZLZHNZL
      ZMZVBVIOZVBVKOZBPZQVFVHKVICRZVKDRZJAVMVPVAVEVQVRVJUSVLUTVICUFVKDUFUGVQVRV
      NVCVOVDBVBVICUHVBVKDUHUIUJABGHUKULUN $.

    $( Pointwise combination commutes with restriction.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    offres $p |- ( ( F e. V /\ G e. W ) -> ( ( F oF R G ) |` D ) =
        ( ( F |` D ) oF R ( G |` D ) ) ) $=
      ( vx wcel cdm cin cfv co cmpt cres wceq fvres dmres 3eqtr4ri offval3 cvv
      wa cv cof inss2 sseli oveq12d mpteq2ia inindi incom ineq12i eqid mpteq12i
      syl resmpt3 reseq1d resexg syl2an 3eqtr4a ) CEHZDFHZUAZGCIZDIZJZGUBZCKZVE
      DKZBLZMZANZGCANZIZDANZIZJZVEVKKZVEVMKZBLZMZCDBUCZLZANVKVMVTLZGVDAJZVRMGWC
      VHMVSVJGWCVRVHVEWCHVEAHZVRVHOWCAVEVDAUDUEWDVPVFVQVGBVEACPVEADPUFUMUGGVOVR
      WCVRAVDJAVBJZAVCJZJWCVOAVBVCUHVDAUIVLWEVNWFCAQDAQUJRVRUKULGVDAVHUNRVAWAVI
      AGBCDEFSUOUSVKTHVMTHWBVSOUTCAEUPDAFUPGBVKVMTTSUQUR $.
  $}

  ${
    $d z A $.  $d z C $.  $d y z G $.  $d x y z ph $.  $d x y S $.  $d x y T $.
    $d x y z F $.  $d x y z R $.  $d x y z U $.
    off.1 $e |- ( ( ph /\ ( x e. S /\ y e. T ) ) -> ( x R y ) e. U ) $.
    off.2 $e |- ( ph -> F : A --> S ) $.
    off.3 $e |- ( ph -> G : B --> T ) $.
    off.4 $e |- ( ph -> A e. V ) $.
    off.5 $e |- ( ph -> B e. W ) $.
    off.6 $e |- ( A i^i B ) = C $.
    $( The function operation produces a function.  (Contributed by Mario
       Carneiro, 20-Jul-2014.) $)
    off $p |- ( ph -> ( F oF R G ) : C --> U ) $=
      ( vz cof co wf cv cfv cmpt wcel wa wral cin inss1 eqsstr3i ffvelrn syl2an
      sseli inss2 ralrimivva adantr wceq oveq1 eleq1d oveq2 syl21anc eqid fmptd
      rspc2va wfn ffn syl eqidd offval feq1d mpbird ) AFJKLGUBUCZUDFJUAFUAUEZKU
      FZVPLUFZGUCZUGZUDAUAFVSJVTAVPFUHZUIVQHUHZVRIUHZBUEZCUEZGUCZJUHZCIUJBHUJZV
      SJUHZADHKUDZVPDUHZWBWAPFDVPFDEUKZDTDEULUMUPDHVPKUNUOAEILUDZVPEUHZWCWAQFEV
      PFWLETDEUQUMUPEIVPLUNUOAWHWAAWGBCHIOURUSWGWIVQWEGUCZJUHBCVQVRHIWDVQUTWFWO
      JWDVQWEGVAVBWEVRUTWOVSJWEVRVQGVCVBVGVDVTVEVFAFJVOVTAUADEVQVRGFKLMNAWJKDVH
      PDHKVIVJAWMLEVHQEILVIVJRSTAWKUIVQVKAWNUIVRVKVLVMVN $.
  $}

  ${
    $d x A $.  $d x C $.  $d x F $.  $d x G $.  $d x ph $.  $d x R $.
    ofres.1 $e |- ( ph -> F Fn A ) $.
    ofres.2 $e |- ( ph -> G Fn B ) $.
    ofres.3 $e |- ( ph -> A e. V ) $.
    ofres.4 $e |- ( ph -> B e. W ) $.
    ofres.5 $e |- ( A i^i B ) = C $.
    $( Restrict the operands of a function operation to the same domain as that
       of the operation itself.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    ofres $p |- ( ph -> ( F oF R G ) = ( ( F |` C ) oF R ( G |` C ) ) ) $=
      ( vx co cfv wcel cvv wfn cof cv cmpt cres eqidd offval wss inss1 eqsstr3i
      wa cin fnssres sylancl inss2 ssexg sylancr inidm wceq fvres adantl eqtr4d
      ) AFGEUAZPODOUBZFQZVCGQZEPUCFDUDZGDUDZVBPAOBCVDVEEDFGHIJKLMNAVCBRUJVDUEAV
      CCRUJVEUEUFAODDVDVEEDVFVGSSAFBTDBUGZVFDTJDBCUKZBNBCUHUIZBDFULUMAGCTDCUGVG
      DTKDVICNBCUNUICDGULUMAVHBHRDSRVJLDBHUOUPZVKDUQVCDRZVCVFQVDURAVCDFUSUTVLVC
      VGQVEURAVCDGUSUTUFVA $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d y z C $.  $d y F $.  $d y G $.  $d x y ph $.
    $d x y z R $.
    offval2.1 $e |- ( ph -> A e. V ) $.
    offval2.2 $e |- ( ( ph /\ x e. A ) -> B e. W ) $.
    offval2.3 $e |- ( ( ph /\ x e. A ) -> C e. X ) $.
    offval2.4 $e |- ( ph -> F = ( x e. A |-> B ) ) $.
    offval2.5 $e |- ( ph -> G = ( x e. A |-> C ) ) $.
    $( The function operation expressed as a mapping.  (Contributed by Mario
       Carneiro, 20-Jul-2014.) $)
    offval2 $p |- ( ph -> ( F oF R G ) = ( x e. A |-> ( B R C ) ) ) $=
      ( vy co cmpt wceq cof cv cfv wcel wral ralrimiva eqid fnmpt fneq1d mpbird
      wfn inidm wa adantr fveq1d offval nffvmpt1 nfcv nfov fveq2 oveq12d cbvmpt
      syl simpr fvmpt2 syl2anc mpteq2dva syl5eq eqtrd ) AGHFUARQCQUBZBCDSZUCZVJ
      BCESZUCZFRZSZBCDEFRZSZAQCCVLVNFCGHIIAGCUKVKCUKZADJUDZBCUEVSAVTBCMUFBCDVKJ
      VKUGZUHVCACGVKOUIUJAHCUKVMCUKZAEKUDZBCUEWBAWCBCNUFBCEVMKVMUGZUHVCACHVMPUI
      UJLLCULAVJCUDZUMZVJGVKAGVKTWEOUNUOWFVJHVMAHVMTWEPUNUOUPAVPBCBUBZVKUCZWGVM
      UCZFRZSVRQBCVOWJBVLVNFBCDVJUQBFURBCEVJUQUSQWJURVJWGTVLWHVNWIFVJWGVKUTVJWG
      VMUTVAVBABCWJVQAWGCUDZUMZWHDWIEFWLWKVTWHDTAWKVDZMBCDJVKWAVEVFWLWKWCWIETWM
      NBCEKVMWDVEVFVAVGVHVI $.

    $( The function relation acting on maps.  (Contributed by Mario Carneiro,
       20-Jul-2014.) $)
    ofrfval2 $p |- ( ph -> ( F oR R G <-> A. x e. A B R C ) ) $=
      ( vy wbr wral wceq cofr cmpt cfv wfn wcel ralrimiva eqid fnmpt syl fneq1d
      cv mpbird inidm wa adantr fveq1d ofrfval nffvmpt1 nfcv nfbr fveq2 breq12d
      nfv cbvral simpr fvmpt2 syl2anc ralbidva syl5bb bitrd ) AGHFUARQUKZBCDUBZ
      UCZVKBCEUBZUCZFRZQCSZDEFRZBCSZAQCCVMVOFCGHIIAGCUDVLCUDZADJUEZBCSVTAWABCMU
      FBCDVLJVLUGZUHUIACGVLOUJULAHCUDVNCUDZAEKUEZBCSWCAWDBCNUFBCEVNKVNUGZUHUIAC
      HVNPUJULLLCUMAVKCUEZUNZVKGVLAGVLTWFOUOUPWGVKHVNAHVNTWFPUOUPUQVQBUKZVLUCZW
      HVNUCZFRZBCSAVSVPWKQBCBVMVOFBCDVKURBFUSBCEVKURUTWKQVCVKWHTVMWIVOWJFVKWHVL
      VAVKWHVNVAVBVDAWKVRBCAWHCUEZUNZWIDWJEFWMWLWAWIDTAWLVEZMBCDJVLWBVFVGWMWLWD
      WJETWNNBCEKVNWEVFVGVBVHVIVJ $.
  $}

  ${
    $d y A $.  $d x y C $.  $d x y F $.  $d x y G $.  $d x y H $.  $d x y ph $.
    $d x D $.  $d x y R $.
    ofco.1 $e |- ( ph -> F Fn A ) $.
    ofco.2 $e |- ( ph -> G Fn B ) $.
    ofco.3 $e |- ( ph -> H : D --> C ) $.
    ofco.4 $e |- ( ph -> A e. V ) $.
    ofco.5 $e |- ( ph -> B e. W ) $.
    ofco.6 $e |- ( ph -> D e. X ) $.
    ofco.7 $e |- ( A i^i B ) = C $.
    $( The composition of a function operation with another function.
       (Contributed by Mario Carneiro, 19-Dec-2014.) $)
    ofco $p |- ( ph ->
      ( ( F oF R G ) o. H ) = ( ( F o. H ) oF R ( G o. H ) ) ) $=
      ( cfv vx vy cof co ccom cv cmpt ffvelrnda feqmptd wcel eqidd offval fveq2
      wa oveq12d fmptco wfn wf wss cin inss1 eqsstr3i fss sylancl fnfco syl2anc
      wceq inss2 inidm ffn syl fvco2 sylan eqtr4d ) AGHFUCZUDZIUEUAEUAUFZITZGTZ
      VRHTZFUDZUGGIUEZHIUEZVOUDAUAUBEDVRUBUFZGTZWDHTZFUDWAIVPAEDVQIOUHAUAEDIOUI
      AUBBCWEWFFDGHJKMNPQSAWDBUJUNWEUKAWDCUJUNWFUKULWDVRVGWEVSWFVTFWDVRGUMWDVRH
      UMUOUPAUAEEVSVTFEWBWCLLAGBUQEBIURZWBEUQMAEDIURZDBUSWGODBCUTZBSBCVAVBEDBIV
      CVDBEGIVEVFAHCUQECIURZWCEUQNAWHDCUSWJODWICSBCVHVBEDCIVCVDCEHIVEVFRREVIAIE
      UQZVQEUJZVQWBTVSVGAWHWKOEDIVJVKZEGIVQVLVMAWKWLVQWCTVTVGWMEHIVQVLVMULVN $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x H $.  $d x ph $.  $d x R $.
    offveq.1 $e |- ( ph -> A e. V ) $.
    offveq.2 $e |- ( ph -> F Fn A ) $.
    offveq.3 $e |- ( ph -> G Fn A ) $.
    offveq.4 $e |- ( ph -> H Fn A ) $.
    offveq.5 $e |- ( ( ph /\ x e. A ) -> ( F ` x ) = B ) $.
    offveq.6 $e |- ( ( ph /\ x e. A ) -> ( G ` x ) = C ) $.
    ${
      offveq.7 $e |- ( ( ph /\ x e. A ) -> ( B R C ) = ( H ` x ) ) $.
      $( Convert an identity of the operation to the analogous identity on the
         function operation.  (Contributed by Mario Carneiro, 24-Jul-2014.) $)
      offveq $p |- ( ph -> ( F oF R G ) = H ) $=
        ( cof co cfv inidm offn cv wcel wa ofval eqtrd eqfnfvd ) ABCGHFRSZIACCF
        CGHJJLMKKCUAZUBNABUCZCUDUEUKUITDEFSUKITACCDEFCGHJJUKLMKKUJOPUFQUGUH $.
    $}

    $d y A $.  $d y z B $.  $d y z C $.  $d x y z F $.  $d y z G $.  $d y H $.
    $d y R $.  $d y ph $.
    $( Equivalent expressions for equality with a function operation.
       (Contributed by NM, 9-Oct-2014.)  (Proof shortened by Mario Carneiro,
       5-Dec-2016.) $)
    offveqb $p |- ( ph
          -> ( H = ( F oF R G ) <-> A. x e. A ( H ` x ) = ( B R C ) ) ) $=
      ( co wceq cmpt wral cof cfv wfn dffn5 sylib inidm offval eqeq12d cvv wcel
      cv wb fvex a1i ralrimivw mpteqb syl bitrd ) AIGHFUAQZRBCBUKZIUBZSZBCDEFQZ
      SZRZVAVCRBCTZAIVBUSVDAICUCIVBRNBCIUDUEABCCDEFCGHJJLMKKCUFOPUGUHAVAUIUJZBC
      TVEVFULAVGBCVGAUTIUMUNUOBCVAVCUIUPUQUR $.
  $}

  ${
    ofc1.1 $e |- ( ph -> A e. V ) $.
    ofc1.2 $e |- ( ph -> B e. W ) $.
    ofc1.3 $e |- ( ph -> F Fn A ) $.
    ofc1.4 $e |- ( ( ph /\ X e. A ) -> ( F ` X ) = C ) $.
    $( Left operation by a constant.  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    ofc1 $p |- ( ( ph /\ X e. A ) ->
      ( ( ( A X. { B } ) oF R F ) ` X ) = ( B R C ) ) $=
      ( csn cxp wcel wfn fnconstg syl inidm cfv wceq fvconst2g sylan ofval ) AB
      BCDEBBCNOZFGGIACHPZUFBQKBCHRSLJJBTAUGIBPIUFUACUBKBCIHUCUDMUE $.
  $}

  ${
    ofc2.1 $e |- ( ph -> A e. V ) $.
    ofc2.2 $e |- ( ph -> B e. W ) $.
    ofc2.3 $e |- ( ph -> F Fn A ) $.
    ofc2.4 $e |- ( ( ph /\ X e. A ) -> ( F ` X ) = C ) $.
    $( Right operation by a constant.  (Contributed by NM, 7-Oct-2014.) $)
    ofc2 $p |- ( ( ph /\ X e. A ) ->
      ( ( F oF R ( A X. { B } ) ) ` X ) = ( C R B ) ) $=
      ( csn cxp wcel wfn fnconstg syl inidm cfv wceq fvconst2g sylan ofval ) AB
      BDCEBFBCNOZGGILACHPZUFBQKBCHRSJJBTMAUGIBPIUFUACUBKBCIHUCUDUE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.  $d x R $.  $d x W $.
    $d x X $.
    ofc12.1 $e |- ( ph -> A e. V ) $.
    ofc12.2 $e |- ( ph -> B e. W ) $.
    ofc12.3 $e |- ( ph -> C e. X ) $.
    $( Function operation on two constant functions.  (Contributed by Mario
       Carneiro, 28-Jul-2014.) $)
    ofc12 $p |- ( ph ->
      ( ( A X. { B } ) oF R ( A X. { C } ) ) = ( A X. { ( B R C ) } ) ) $=
      ( vx csn cxp co cmpt wcel adantr wceq fconstmpt cof a1i offval2 syl6eqr
      cv ) ABCMNZBDMNZEUAOLBCDEOZPBUHMNALBCDEUFUGFGHIACGQLUEBQZJRADHQUIKRUFLBCP
      SALBCTUBUGLBDPSALBDTUBUCLBUHTUD $.
  $}

  ${
    $d w x B $.  $d w x C $.  $d w x y z F $.  $d w x y z G $.  $d w x y z H $.
    $d w x y z O $.  $d w x y z P $.  $d w x y z ph $.  $d w x y z R $.
    $d w A $.  $d w x y z S $.  $d w x y z T $.  $d w x y z U $.
    caofref.1 $e |- ( ph -> A e. V ) $.
    caofref.2 $e |- ( ph -> F : A --> S ) $.
    ${
      caofref.3 $e |- ( ( ph /\ x e. S ) -> x R x ) $.
      $( Transfer a reflexive law to the function relation.  (Contributed by
         Mario Carneiro, 28-Jul-2014.) $)
      caofref $p |- ( ph -> F oR R F ) $=
        ( vw cofr wbr cv cfv wral wcel wa ffvelrnda ralrimiva adantr id breq12d
        wceq rspcv sylc wf wfn ffn syl inidm eqidd ofrfval mpbird ) AFFDLMKNZFO
        ZUPDMZKCPAUQKCAUOCQZRZUPEQBNZUTDMZBEPZUQACEUOFISAVBURAVABEJTUAVAUQBUPEU
        TUPUDZUTUPUTUPDVCUBZVDUCUEUFTAKCCUPUPDCFFGGACEFUGFCUHICEFUIUJZVEHHCUKUS
        UPULZVFUMUN $.
    $}

    ${
      $d v A $.  $d v F $.  $d x v N $.  $d v S $.  $d v ph $.  $d v w $.
      caofinv.3 $e |- ( ph -> B e. W ) $.
      caofinv.4 $e |- ( ph -> N : S --> S ) $.
      caofinv.5 $e |- ( ph -> G = ( v e. A |-> ( N ` ( F ` v ) ) ) ) $.
      ${
        caofinvl.6 $e |- ( ( ph /\ x e. S ) -> ( ( N ` x ) R x ) = B ) $.
        $( Transfer a left inverse law to the function operation.  (Contributed
           by NM, 22-Oct-2014.) $)
        caofinvl $p |- ( ph -> ( G oF R F ) = ( A X. { B } ) ) $=
          ( vw cfv cof co cmpt csn cv wf wcel wa adantr ffvelrnda ffvelrnd eqid
          cxp fmptd feq1d mpbird wfn wceq fvex fnmpti fneq1d mpbiri dffn5 sylib
          feqmptd offval2 fveq1d fveq2 fveq2d sylan9eq oveq1d wral ralrimiva id
          fvmpt oveq12d eqeq1d rspcva syl2anc eqtrd mpteq2dva fconstmpt syl6eqr
          ) AIHFUAUBZSDEUCZDEUDUMAWDSDSUEZITZWFHTZFUBZUCWEASDWGWHFIHKGGMADGWFIA
          DGIUFDGCDCUEZHTZJTZUCZUFACDWLGWMAWJDUGZUHGGWKJAGGJUFWNPUIADGWJHNUJUKW
          MULZUNADGIWMQUOUPUJADGWFHNUJZAIDUQZISDWGUCURAWQWMDUQCDWLWMWKJUSWOUTAD
          IWMQVAVBSDIVCVDASDGHNVEVFASDWIEAWFDUGZUHZWIWHJTZWHFUBZEWSWGWTWHFAWRWG
          WFWMTWTAWFIWMQVGCWFWLWTDWMWJWFURWKWHJWJWFHVHVIWOWHJUSVOVJVKWSWHGUGBUE
          ZJTZXBFUBZEURZBGVLZXAEURZWPAXFWRAXEBGRVMUIXEXGBWHGXBWHURZXDXAEXHXCWTX
          BWHFXBWHJVHXHVNVPVQVRVSVTWAVTSDEWBWC $.
      $}
    $}

    ${
      caofid0.3 $e |- ( ph -> B e. W ) $.
      ${
        caofid0l.5 $e |- ( ( ph /\ x e. S ) -> ( B R x ) = x ) $.
        $( Transfer a left identity law to the function operation.
           (Contributed by NM, 21-Oct-2014.) $)
        caofid0l $p |- ( ph -> ( ( A X. { B } ) oF R F ) = F ) $=
          ( vw cv cfv wcel wfn syl wceq csn cxp fnconstg wf ffn fvconst2g sylan
          wa eqidd ffvelrnda wral ralrimiva oveq2 eqeq12d rspccva syldan offveq
          co id ) ANCDNOZGPZECDUAUBZGGHJADIQZVBCRLCDIUCSACFGUDGCRKCFGUESZVDAVCU
          TCQZUTVBPDTLCDUTIUFUGAVEUHVAUIAVEVAFQZDVAEURZVATZACFUTGKUJADBOZEURZVI
          TZBFUKVFVHAVKBFMULVKVHBVAFVIVATZVJVGVIVAVIVADEUMVLUSUNUOUGUPUQ $.
      $}

      ${
        caofid0r.5 $e |- ( ( ph /\ x e. S ) -> ( x R B ) = x ) $.
        $( Transfer a right identity law to the function operation.
           (Contributed by NM, 21-Oct-2014.) $)
        caofid0r $p |- ( ph -> ( F oF R ( A X. { B } ) ) = F ) $=
          ( vw cv cfv wfn syl wcel wceq csn cxp wf ffn fnconstg eqidd fvconst2g
          wa sylan ffvelrnda wral ralrimiva oveq1 eqeq12d rspccva syldan offveq
          co id ) ANCNOZGPZDEGCDUAUBZGHJACFGUCGCQKCFGUDRZADISZVBCQLCDIUERVCAUTC
          SZUHVAUFAVDVEUTVBPDTLCDUTIUGUIAVEVAFSZVADEURZVATZACFUTGKUJABOZDEURZVI
          TZBFUKVFVHAVKBFMULVKVHBVAFVIVATZVJVGVIVAVIVADEUMVLUSUNUOUIUPUQ $.
      $}

      caofid1.4 $e |- ( ph -> C e. X ) $.
      ${
        caofid1.5 $e |- ( ( ph /\ x e. S ) -> ( x R B ) = C ) $.
        $( Transfer a right absorption law to the function operation.
           (Contributed by Mario Carneiro, 28-Jul-2014.) $)
        caofid1 $p |- ( ph -> ( F oF R ( A X. { B } ) ) = ( A X. { C } ) ) $=
          ( cfv wfn wcel wceq vw cv csn cxp wf ffn syl fnconstg eqidd fvconst2g
          wa sylan ffvelrnda wral ralrimiva eqeq1d rspccva syldan eqtr4d offveq
          co oveq1 ) AUACUAUBZHQZDFHCDUCUDZCEUCUDZILACGHUEHCRMCGHUFUGADJSZVECRN
          CDJUHUGAEKSZVFCROCEKUHUGAVCCSZUKZVDUIAVGVIVCVEQDTNCDVCJUJULVJVDDFVAZE
          VCVFQZAVIVDGSZVKETZACGVCHMUMABUBZDFVAZETZBGUNVMVNAVQBGPUOVQVNBVDGVOVD
          TVPVKEVOVDDFVBUPUQULURAVHVIVLETOCEVCKUJULUSUT $.
      $}

      caofid2.5 $e |- ( ( ph /\ x e. S ) -> ( B R x ) = C ) $.
      $( Transfer a right absorption law to the function operation.
         (Contributed by Mario Carneiro, 28-Jul-2014.) $)
      caofid2 $p |- ( ph -> ( ( A X. { B } ) oF R F ) = ( A X. { C } ) ) $=
        ( cfv wcel wfn wceq vw cv csn cxp fnconstg syl wf fvconst2g sylan eqidd
        ffn wa co ffvelrnda ralrimiva oveq2 eqeq1d rspccva syldan eqtr4d offveq
        wral ) AUACDUAUBZHQZFCDUCUDZHCEUCUDZILADJRZVECSNCDJUEUFACGHUGHCSMCGHUKU
        FAEKRZVFCSOCEKUEUFAVGVCCRZVCVEQDTNCDVCJUHUIAVIULZVDUJVJDVDFUMZEVCVFQZAV
        IVDGRZVKETZACGVCHMUNADBUBZFUMZETZBGVBVMVNAVQBGPUOVQVNBVDGVOVDTVPVKEVOVD
        DFUPUQURUIUSAVHVIVLETOCEVCKUHUIUTVA $.
    $}

    caofcom.3 $e |- ( ph -> G : A --> S ) $.
    ${
      caofcom.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                        ( x R y ) = ( y R x ) ) $.
      $( Transfer a commutative law to the function operation.  (Contributed by
         Mario Carneiro, 26-Jul-2014.) $)
      caofcom $p |- ( ph -> ( F oF R G ) = ( G oF R F ) ) $=
        ( vw cfv co cmpt wcel wa ffvelrnda cv cof jca caovcomg syldan mpteq2dva
        wceq feqmptd offval2 3eqtr4d ) ANDNUAZGOZUKHOZEPZQNDUMULEPZQGHEUBZPHGUP
        PANDUNUOAUKDRZULFRZUMFRZSUNUOUGAUQSURUSADFUKGKTZADFUKHLTZUCABCULUMFEMUD
        UEUFANDULUMEGHIFFJUTVAANDFGKUHZANDFHLUHZUIANDUMULEHGIFFJVAUTVCVBUIUJ $.
    $}

    ${
      caofrss.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                        ( x R y -> x T y ) ) $.
      $( Transfer a relation subset law to the function relation.  (Contributed
         by Mario Carneiro, 28-Jul-2014.) $)
      caofrss $p |- ( ph -> ( F oR R G -> F oR T G ) ) $=
        ( vw cv wbr wral wcel wi cofr wa ffvelrnda ralrimivva adantr wceq breq1
        cfv imbi12d breq2 rspc2va syl21anc ralimdva wfn ffn inidm eqidd ofrfval
        wf syl 3imtr4d ) AOPZHUHZVBIUHZEQZODRVCVDGQZODRHIEUAQHIGUAQAVEVFODAVBDS
        ZUBZVCFSVDFSBPZCPZEQZVIVJGQZTZCFRBFRZVEVFTZADFVBHLUCADFVBIMUCAVNVGAVMBC
        FFNUDUEVMVOVCVJEQZVCVJGQZTBCVCVDFFVIVCUFVKVPVLVQVIVCVJEUGVIVCVJGUGUIVJV
        DUFVPVEVQVFVJVDVCEUJVJVDVCGUJUIUKULUMAODDVCVDEDHIJJADFHUSHDUNLDFHUOUTZA
        DFIUSIDUNMDFIUOUTZKKDUPZVHVCUQZVHVDUQZURAODDVCVDGDHIJJVRVSKKVTWAWBURVA
        $.
    $}

    caofass.4 $e |- ( ph -> H : A --> S ) $.
    ${
      caofass.5 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                        ( ( x R y ) T z ) = ( x O ( y P z ) ) ) $.
      $( Transfer an associative law to the function operation.  (Contributed
         by Mario Carneiro, 26-Jul-2014.) $)
      caofass $p |- ( ph ->
        ( ( F oF R G ) oF T H ) = ( F oF O ( G oF P H ) ) ) $=
        ( co vw cv cfv cmpt cof wcel wa wceq ralrimivvva adantr ffvelrnda oveq1
        wral wi oveq1d eqeq12d oveq2d rspc3v syl3anc mpd mpteq2dva cvv ovex a1i
        oveq2 feqmptd offval2 3eqtr4d ) AUAEUAUBZJUCZVIKUCZGTZVILUCZITZUDUAEVJV
        KVMFTZMTZUDJKGUETZLIUETJKLFUETZMUETAUAEVNVPAVIEUFZUGZBUBZCUBZGTZDUBZITZ
        WAWBWDFTZMTZUHZDHUMCHUMBHUMZVNVPUHZAWIVSAWHBCDHHHSUIUJVTVJHUFVKHUFVMHUF
        WIWJUNAEHVIJPUKZAEHVIKQUKZAEHVILRUKZWHWJVJWBGTZWDITZVJWFMTZUHVLWDITZVJV
        KWDFTZMTZUHBCDVJVKVMHHHWAVJUHZWEWOWGWPWTWCWNWDIWAVJWBGULUOWAVJWFMULUPWB
        VKUHZWOWQWPWSXAWNVLWDIWBVKVJGVEUOXAWFWRVJMWBVKWDFULUQUPWDVMUHZWQVNWSVPW
        DVMVLIVEXBWRVOVJMWDVMVKFVEUQUPURUSUTVAAUAEVLVMIVQLNVBHOVLVBUFVTVJVKGVCV
        DWMAUAEVJVKGJKNHHOWKWLAUAEHJPVFZAUAEHKQVFZVGAUAEHLRVFZVGAUAEVJVOMJVRNHV
        BOWKVOVBUFVTVKVMFVCVDXCAUAEVKVMFKLNHHOWLWMXDXEVGVGVH $.
    $}

    ${
      caoftrn.5 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                        ( ( x R y /\ y T z ) -> x U z ) ) $.
      $( Transfer a transitivity law to the function relation.  (Contributed by
         Mario Carneiro, 28-Jul-2014.) $)
      caoftrn $p |- ( ph -> ( ( F oR R G /\ G oR T H ) -> F oR U H ) ) $=
        ( vw wbr cv cfv wa wral cofr wcel wi ralrimivvva adantr ffvelrnda breq1
        wceq anbi1d imbi12d breq2 anbi12d imbi1d anbi2d rspc3v syl3anc ralimdva
        mpd wf wfn ffn syl inidm eqidd ofrfval r19.26 syl6bbr 3imtr4d ) ASUAZJU
        BZVMKUBZFTZVOVMLUBZHTZUCZSEUDZVNVQITZSEUDJKFUETZKLHUETZUCZJLIUETAVSWASE
        AVMEUFZUCZBUAZCUAZFTZWHDUAZHTZUCZWGWJITZUGZDGUDCGUDBGUDZVSWAUGZAWOWEAWN
        BCDGGGRUHUIWFVNGUFVOGUFVQGUFWOWPUGAEGVMJOUJAEGVMKPUJAEGVMLQUJWNWPVNWHFT
        ZWKUCZVNWJITZUGVPVOWJHTZUCZWSUGBCDVNVOVQGGGWGVNULZWLWRWMWSXBWIWQWKWGVNW
        HFUKUMWGVNWJIUKUNWHVOULZWRXAWSXCWQVPWKWTWHVOVNFUOWHVOWJHUKUPUQWJVQULZXA
        VSWSWAXDWTVRVPWJVQVOHUOURWJVQVNIUOUNUSUTVBVAAWDVPSEUDZVRSEUDZUCVTAWBXEW
        CXFASEEVNVOFEJKMMAEGJVCJEVDOEGJVEVFZAEGKVCKEVDPEGKVEVFZNNEVGZWFVNVHZWFV
        OVHZVIASEEVOVQHEKLMMXHAEGLVCLEVDQEGLVEVFZNNXIXKWFVQVHZVIUPVPVRSEVJVKASE
        EVNVQIEJLMMXGXLNNXIXJXMVIVL $.
    $}
  $}

  ${
    $d w x y z A $.  $d w x y z F $.  $d w x y z G $.  $d w x y z ph $.
    $d w x y z H $.  $d w x y z K $.  $d w x y z O $.  $d w x y z R $.
    $d w x y z S $.  $d w x y z T $.
    caofdi.1 $e |- ( ph -> A e. V ) $.
    caofdi.2 $e |- ( ph -> F : A --> K ) $.
    caofdi.3 $e |- ( ph -> G : A --> S ) $.
    caofdi.4 $e |- ( ph -> H : A --> S ) $.
    ${
      caofdi.5 $e |- ( ( ph /\ ( x e. K /\ y e. S /\ z e. S ) ) ->
                          ( x T ( y R z ) ) = ( ( x T y ) O ( x T z ) ) ) $.
      $( Transfer a distributive law to the function operation.  (Contributed
         by Mario Carneiro, 26-Jul-2014.) $)
      caofdi $p |- ( ph ->
        ( F oF T ( G oF R H ) ) = ( ( F oF T G ) oF O ( F oF T H ) ) ) $=
        ( co vw cv cfv cmpt cof wcel wa w3a adantlr ffvelrnda caovdid mpteq2dva
        wceq cvv ovex a1i feqmptd offval2 3eqtr4d ) AUAEUAUBZIUCZUTJUCZUTKUCZFT
        ZHTZUDUAEVAVBHTZVAVCHTZMTZUDIJKFUETZHUEZTIJVJTZIKVJTZMUETAUAEVEVHAUTEUF
        ZUGZBCDVAVBVCGFHMLABUBZLUFCUBZGUFDUBZGUFUHVOVPVQFTHTVOVPHTVOVQHTMTUMVMS
        UIAELUTIPUJZAEGUTJQUJZAEGUTKRUJZUKULAUAEVAVDHIVINLUNOVRVDUNUFVNVBVCFUOU
        PAUAELIPUQZAUAEVBVCFJKNGGOVSVTAUAEGJQUQZAUAEGKRUQZURURAUAEVFVGMVKVLNUNU
        NOVFUNUFVNVAVBHUOUPVGUNUFVNVAVCHUOUPAUAEVAVBHIJNLGOVRVSWAWBURAUAEVAVCHI
        KNLGOVRVTWAWCURURUS $.
    $}

    ${
      caofdir.5 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. K ) ) ->
                          ( ( x R y ) T z ) = ( ( x T z ) O ( y T z ) ) ) $.
      $( Transfer a reverse distributive law to the function operation.
         (Contributed by NM, 19-Oct-2014.) $)
      caofdir $p |- ( ph ->
        ( ( G oF R H ) oF T F ) = ( ( G oF T F ) oF O ( H oF T F ) ) ) $=
        ( co vw cfv cmpt cof wcel w3a wceq adantlr ffvelrnda caovdird mpteq2dva
        cv wa cvv ovex a1i feqmptd offval2 3eqtr4d ) AUAEUAULZJUBZUTKUBZFTZUTIU
        BZHTZUCUAEVAVDHTZVBVDHTZMTZUCJKFUDTZIHUDZTJIVJTZKIVJTZMUDTAUAEVEVHAUTEU
        EZUMZBCDVAVBVDGFHMLABULZGUECULZGUEDULZLUEUFVOVPFTVQHTVOVQHTVPVQHTMTUGVM
        SUHAEGUTJQUIZAEGUTKRUIZAELUTIPUIZUJUKAUAEVCVDHVIINUNLOVCUNUEVNVAVBFUOUP
        VTAUAEVAVBFJKNGGOVRVSAUAEGJQUQZAUAEGKRUQZURAUAELIPUQZURAUAEVFVGMVKVLNUN
        UNOVFUNUEVNVAVDHUOUPVGUNUEVNVBVDHUOUPAUAEVAVDHJINGLOVRVTWAWCURAUAEVBVDH
        KINGLOVSVTWBWCURURUS $.
    $}
  $}

  ${
    $d ph x y z $.  $d A x y z $.  $d B y z $.  $d I z $.  $d M x y z $.
    $d S x y $.
    caonncan.i $e |- ( ph -> I e. V ) $.
    caonncan.a $e |- ( ph -> A : I --> S ) $.
    caonncan.b $e |- ( ph -> B : I --> S ) $.
    caonncan.z $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
        ( x M ( x M y ) ) = y ) $.
    $( Transfer ~ nncan -shaped laws to vectors of numbers.  (Contributed by
       Stefan O'Rear, 27-Mar-2015.) $)
    caonncan $p |- ( ph -> ( A oF M ( A oF M B ) ) = B ) $=
      ( vz cv co wcel wceq cvv a1i cfv cmpt wa wral ffvelrnda ralrimivva adantr
      cof id oveq1 oveq12d eqeq1d oveq2 eqeq12d rspc2va syl21anc mpteq2dva fvex
      oveq2d ovex feqmptd offval2 3eqtr4d ) ANGNOZDUAZVEVDEUAZHPZHPZUBNGVFUBDDE
      HUHZPZVIPEANGVHVFAVDGQZUCZVEFQVFFQBOZVMCOZHPZHPZVNRZCFUDBFUDZVHVFRZAGFVDD
      KUEAGFVDELUEAVRVKAVQBCFFMUFUGVQVSVEVEVNHPZHPZVNRBCVEVFFFVMVERZVPWAVNWBVMV
      EVOVTHWBUIVMVEVNHUJUKULVNVFRZWAVHVNVFWCVTVGVEHVNVFVEHUMUSWCUIUNUOUPUQANGV
      EVGHDVJISSJVESQVLVDDURTZVGSQVLVEVFHUTTANGFDKVAZANGVEVFHDEISSJWDVFSQVLVDEU
      RTWEANGFELVAZVBVBWFVC $.
  $}

  ${
    $d f g A $.  $d f g B $.  $d f g x R $.
    $( Equivalent expressions for a restriction of the function operation map.
       Unlike ` oF R ` which is a proper class, ` ( oF R | `` ( A X. B ) ) `
       can be a set by ~ ofmresex , allowing it to be used as a function or
       structure argument.  By ~ ofmresval , the restricted operation map
       values are the same as the original values, allowing theorems for
       ` oF R ` to be reused.  (Contributed by NM, 20-Oct-2014.) $)
    ofmres $p |- ( oF R |` ( A X. B ) ) =
         ( f e. A , g e. B |-> ( f oF R g ) ) $=
      ( vx cvv cv cdm cin cfv co cmpt2 cres wss wceq ssv eqid wcel vex cmpt cxp
      cof resmpt2 mp2an df-of reseq1i dmex inex1 mptex ovmpt4g mp3an mpt2eq123i
      3eqtr4i ) DEGGFDHZIZEHZIZJZFHZUOKUTUQKCLZUAZMZABUBZNZDEABVBMZCUCZVDNDEABU
      OUQVGLZMAGOBGOVEVFPAQBQDEGGABVBUDUEVGVCVDFCDEUFZUGDEABVHABVBARBRUOGSUQGSV
      BGSVHVBPDTZETFUSVAUPURUOVJUHUIUJDEGGVBVGGVIUKULUMUN $.

    ofmresval.f $e |- ( ph -> F e. A ) $.
    ofmresval.g $e |- ( ph -> G e. B ) $.
    $( Value of a restriction of the function operation map.  (Contributed by
       NM, 20-Oct-2014.) $)
    ofmresval $p |- ( ph -> ( F ( oF R |` ( A X. B ) ) G ) = ( F oF R G ) ) $=
      ( wcel cof cxp cres co wceq ovres syl2anc ) AEBIFCIEFDJZBCKLMEFQMNGHEFBCQ
      OP $.
  $}

  ${
    $d f g A $.  $d f g B $.  $d f g R $.
    ofmresex.a $e |- ( ph -> A e. V ) $.
    ofmresex.b $e |- ( ph -> B e. W ) $.
    $( Existence of a restriction of the function operation map.  (Contributed
       by NM, 20-Oct-2014.) $)
    ofmresex $p |- ( ph -> ( oF R |` ( A X. B ) ) e. _V ) $=
      ( cxp cvv wcel cof cres xpexg syl2anc ofexg syl ) ABCIZJKZDLRMJKABEKCFKSG
      HBCEFNORDJPQ $.
  $}

  ${
    $d ph v x $.  $d A x $.  $d B v x $.  $d D x $.  $d O v x $.  $d R v $.
    $d Y v x $.  $d Z v x $.
    suppssof1.s $e |- ( ph -> ( `' A " ( _V \ { Y } ) ) C_ L ) $.
    suppssof1.o $e |- ( ( ph /\ v e. R ) -> ( Y O v ) = Z ) $.
    suppssof1.a $e |- ( ph -> A : D --> V ) $.
    suppssof1.b $e |- ( ph -> B : D --> R ) $.
    suppssof1.d $e |- ( ph -> D e. W ) $.
    $( Formula building theorem for support restrictions: vector operation with
       left annihilator.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    suppssof1 $p |- ( ph -> ( `' ( A oF O B ) " ( _V \ { Z } ) ) C_ L ) $=
      ( vx ccnv cvv cof co csn cdif cima cv cfv cmpt wf wfn ffn syl inidm eqidd
      wcel wa offval cnveqd imaeq1d feqmptd eqsstr3d fvex a1i ffvelrnda eqsstrd
      suppssov1 ) ACDHUAUBZSZTLUCUDZUERERUFZCUGZVJDUGZHUBUHZSZVIUEGAVHVNVIAVGVM
      AREEVKVLHECDJJAEICUICEUJOEICUKULAEFDUIDEUJPEFDUKULQQEUMAVJEUOUPZVKUNVOVLU
      NUQURUSARBVKVLEFGHTKLAREVKUHZSZTKUCUDZUECSZVRUEGAVSVQVRACVPAREICOUTURUSMV
      ANVKTUOVOVJCVBVCAEFVJDPVDVFVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        First and second members of an ordered pair
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c 1st $. $( First member of an ordered pair $)
  $c 2nd $. $( Second member of an ordered pair $)

  $( Extend the definition of a class to include the first member an ordered
     pair function. $)
  c1st $a class 1st $.

  $( Extend the definition of a class to include the second member an ordered
     pair function. $)
  c2nd $a class 2nd $.

  $( Define a function that extracts the first member, or abscissa, of an
     ordered pair.  Theorem ~ op1st proves that it does this.  For example,
     ` ( 1st `` <. 3 , 4 >. ) = 3 ` .  Equivalent to Definition 5.13 (i) of
     [Monk1] p. 52 (compare ~ op1sta and ~ op1stb ).  The notation is the same
     as Monk's.  (Contributed by NM, 9-Oct-2004.) $)
  df-1st $a |- 1st = ( x e. _V |-> U. dom { x } ) $.

  $( Define a function that extracts the second member, or ordinate, of an
     ordered pair.  Theorem ~ op2nd proves that it does this.  For example,
     ` ( 2nd `` <. 3 , 4 >. ) = 4 ` .  Equivalent to Definition 5.13 (ii) of
     [Monk1] p. 52 (compare ~ op2nda and ~ op2ndb ).  The notation is the same
     as Monk's.  (Contributed by NM, 9-Oct-2004.) $)
  df-2nd $a |- 2nd = ( x e. _V |-> U. ran { x } ) $.

  ${
    $d x y A $.  $d x y B $.
    $( The value of the function that extracts the first member of an ordered
       pair.  (Contributed by NM, 9-Oct-2004.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    1stval $p |- ( 1st ` A ) = U. dom { A } $=
      ( vx cvv wcel c1st cfv csn cdm cuni wceq cv sneq dmeqd unieqd df-1st snex
      dmex uniex c0 syl6eq fvmpt wn fvprc snprc biimpi dm0 uni0 eqtr4d pm2.61i
      ) ACDZAEFZAGZHZIZJBABKZGZHZIUNCEUOAJZUQUMURUPULUOALMNBOUMULAPQRUAUJUBZUKS
      UNAEUCUSUNSISUSUMSUSUMSHSUSULSUSULSJAUDUEMUFTNUGTUHUI $.

    $( The value of the function that extracts the second member of an ordered
       pair.  (Contributed by NM, 9-Oct-2004.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    2ndval $p |- ( 2nd ` A ) = U. ran { A } $=
      ( vx cvv wcel c2nd cfv csn crn cuni wceq cv sneq rneqd unieqd df-2nd snex
      rnex uniex c0 syl6eq fvmpt wn fvprc snprc biimpi rn0 uni0 eqtr4d pm2.61i
      ) ACDZAEFZAGZHZIZJBABKZGZHZIUNCEUOAJZUQUMURUPULUOALMNBOUMULAPQRUAUJUBZUKS
      UNAEUCUSUNSISUSUMSUSUMSHSUSULSUSULSJAUDUEMUFTNUGTUHUI $.
  $}

  $( The value of the first-member function at the empty set.  (Contributed by
     NM, 23-Apr-2007.) $)
  1st0 $p |- ( 1st ` (/) ) = (/) $=
    ( c0 c1st cfv csn cdm cuni 1stval dmsn0 unieqi uni0 3eqtri ) ABCADEZFAFAAGL
    AHIJK $.

  $( The value of the second-member function at the empty set.  (Contributed by
     NM, 23-Apr-2007.) $)
  2nd0 $p |- ( 2nd ` (/) ) = (/) $=
    ( c0 c2nd cfv csn crn cuni 2ndval wceq dmsn0 dm0rn0 mpbi unieqi uni0 3eqtri
    cdm ) ABCADZEZFAFAAGQAPOAHQAHIPJKLMN $.

  ${
    op1st.1 $e |- A e. _V $.
    op1st.2 $e |- B e. _V $.
    $( Extract the first member of an ordered pair.  (Contributed by NM,
       5-Oct-2004.) $)
    op1st $p |- ( 1st ` <. A , B >. ) = A $=
      ( cop c1st cfv csn cdm cuni 1stval op1sta eqtri ) ABEZFGNHIJANKABCDLM $.

    $( Extract the second member of an ordered pair.  (Contributed by NM,
       5-Oct-2004.) $)
    op2nd $p |- ( 2nd ` <. A , B >. ) = B $=
      ( cop c2nd cfv csn crn cuni 2ndval op2nda eqtri ) ABEZFGNHIJBNKABCDLM $.

    $( Extract the first member of an ordered pair.  (Contributed by Mario
       Carneiro, 31-Aug-2015.) $)
    op1std $p |- ( C = <. A , B >. -> ( 1st ` C ) = A ) $=
      ( cop wceq c1st cfv fveq2 op1st syl6eq ) CABFZGCHIMHIACMHJABDEKL $.

    $( Extract the second member of an ordered pair.  (Contributed by Mario
       Carneiro, 31-Aug-2015.) $)
    op2ndd $p |- ( C = <. A , B >. -> ( 2nd ` C ) = B ) $=
      ( cop wceq c2nd cfv fveq2 op2nd syl6eq ) CABFZGCHIMHIBCMHJABDEKL $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Extract the first member of an ordered pair.  (Contributed by NM,
       19-Jul-2005.) $)
    op1stg $p |- ( ( A e. V /\ B e. W ) -> ( 1st ` <. A , B >. ) = A ) $=
      ( vx vy cv cop c1st cfv wceq opeq1 fveq2d id eqeq12d opeq2 eqeq1d vtocl2g
      vex op1st ) EGZFGZHZIJZUAKAUBHZIJZAKABHZIJZAKEFABCDUAAKZUDUFUAAUIUCUEIUAA
      UBLMUINOUBBKZUFUHAUJUEUGIUBBAPMQUAUBESFSTR $.

    $( Extract the second member of an ordered pair.  (Contributed by NM,
       19-Jul-2005.) $)
    op2ndg $p |- ( ( A e. V /\ B e. W ) -> ( 2nd ` <. A , B >. ) = B ) $=
      ( vx vy cv cop c2nd cfv wceq opeq1 fveq2d eqeq1d opeq2 id eqeq12d vtocl2g
      vex op2nd ) EGZFGZHZIJZUBKAUBHZIJZUBKABHZIJZBKEFABCDUAAKZUDUFUBUIUCUEIUAA
      UBLMNUBBKZUFUHUBBUJUEUGIUBBAOMUJPQUAUBESFSTR $.

    $( Extract the first member of an ordered triple.  (Due to infrequent
       usage, it isn't worthwhile at this point to define special extractors
       for triples, so we reuse the ordered pair extractors for ~ ot1stg ,
       ~ ot2ndg , ~ ot3rdg .)  (Contributed by NM, 3-Apr-2015.)  (Revised by
       Mario Carneiro, 2-May-2015.) $)
    ot1stg $p |- ( ( A e. V /\ B e. W /\ C e. X )
         -> ( 1st ` ( 1st ` <. A , B , C >. ) ) = A ) $=
      ( wcel cotp c1st cfv wceq wa cop df-ot fveq2i cvv opex op1stg mpan syl5eq
      fveq2d sylan9eqr 3impa ) ADGZBEGZCFGZABCHZIJZIJZAKUFUDUELUIABMZIJAUFUHUJI
      UFUHUJCMZIJZUJUGUKIABCNOUJPGUFULUJKABQUJCPFRSTUAABDERUBUC $.

    $( Extract the second member of an ordered triple.  (See ~ ot1stg
       comment.)  (Contributed by NM, 3-Apr-2015.)  (Revised by Mario Carneiro,
       2-May-2015.) $)
    ot2ndg $p |- ( ( A e. V /\ B e. W /\ C e. X )
         -> ( 2nd ` ( 1st ` <. A , B , C >. ) ) = B ) $=
      ( wcel cotp c1st cfv c2nd wceq wa cop df-ot fveq2i cvv opex op1stg mpan
      syl5eq fveq2d op2ndg sylan9eqr 3impa ) ADGZBEGZCFGZABCHZIJZKJZBLUHUFUGMUK
      ABNZKJBUHUJULKUHUJULCNZIJZULUIUMIABCOPULQGUHUNULLABRULCQFSTUAUBABDEUCUDUE
      $.

    $( Extract the third member of an ordered triple.  (See ~ ot1stg comment.)
       (Contributed by NM, 3-Apr-2015.) $)
    ot3rdg $p |- ( C e. V -> ( 2nd ` <. A , B , C >. ) = C ) $=
      ( wcel cotp c2nd cfv cop df-ot fveq2i cvv wceq opex op2ndg mpan syl5eq )
      CDEZABCFZGHABIZCIZGHZCSUAGABCJKTLERUBCMABNTCLDOPQ $.

    $( Alternate value of the function that extracts the first member of an
       ordered pair.  Definition 5.13 (i) of [Monk1] p. 52.  (Contributed by
       NM, 18-Aug-2006.) $)
    1stval2 $p |- ( A e. ( _V X. _V ) -> ( 1st ` A ) = |^| |^| A ) $=
      ( vx vy cvv cxp wcel cv cop wceq wex c1st cfv cint elvv vex op1stb eqtr4i
      op1st fveq2 inteq inteqd 3eqtr4a exlimivv sylbi ) ADDEFABGZCGZHZIZCJBJAKL
      ZAMZMZIZBCANUHULBCUHUGKLZUGMZMZUIUKUMUEUOUEUFBOZCOZRUEUFUPUQPQAUGKSUHUJUN
      AUGTUAUBUCUD $.

    $( Alternate value of the function that extracts the second member of an
       ordered pair.  Definition 5.13 (ii) of [Monk1] p. 52.  (Contributed by
       NM, 18-Aug-2006.) $)
    2ndval2 $p |- ( A e. ( _V X. _V )
               -> ( 2nd ` A ) = |^| |^| |^| `' { A } ) $=
      ( vx vy cvv cxp wcel cv cop wceq wex c2nd cfv ccnv cint elvv op2nd op2ndb
      csn vex inteqd eqtr4i fveq2 sneq cnveqd 3eqtr4a exlimivv sylbi ) ADDEFABG
      ZCGZHZIZCJBJAKLZARZMZNZNZNZIZBCAOUKURBCUKUJKLZUJRZMZNZNZNZULUQUSUIVDUHUIB
      SZCSZPUHUIVEVFQUAAUJKUBUKUPVCUKUOVBUKUNVAUKUMUTAUJUCUDTTTUEUFUG $.
  $}

  ${
    $d x y z w v A $.  $d x y z B $.  $d x y z w v u $.
    $( The ` 1st ` function maps the universe onto the universe.  (Contributed
       by NM, 14-Oct-2004.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    fo1st $p |- 1st : _V -onto-> _V $=
      ( vx vy cvv c1st wfo wfn crn wceq cv csn cdm cuni snex dmex df-1st fnmpti
      uniex wrex cab wcel rnmpt vex opex op1sta eqcomi sneq dmeqd unieqd eqeq2d
      cop rspcev mp2an 2th abbi2i eqtr4i df-fo mpbir2an ) CCDEDCFDGZCHACAIZJZKZ
      LZDVAUTUSMNQAOZPURBIZVBHZACRZBSCABCVBDVCUAVFBCVDCTVFBUBZVDVDUJZCTVDVHJZKZ
      LZHZVFVDVDUCVKVDVDVDVGVGUDUEVEVLAVHCUSVHHZVBVKVDVMVAVJVMUTVIUSVHUFUGUHUIU
      KULUMUNUOCCDUPUQ $.

    $d x y z w v A $.  $d x y z B $.  $d x y z w v u $.
    $( The ` 2nd ` function maps the universe onto the universe.  (Contributed
       by NM, 14-Oct-2004.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    fo2nd $p |- 2nd : _V -onto-> _V $=
      ( vx vy cvv c2nd wfo wfn crn wceq cv csn cuni snex rnex uniex df-2nd wrex
      fnmpti cab rnmpt wcel vex cop opex op2nda eqcomi sneq rneqd unieqd eqeq2d
      rspcev mp2an 2th abbi2i eqtr4i df-fo mpbir2an ) CCDEDCFDGZCHACAIZJZGZKZDU
      TUSURLMNAOZQUQBIZVAHZACPZBRCABCVADVBSVEBCVCCTVEBUAZVCVCUBZCTVCVGJZGZKZHZV
      EVCVCUCVJVCVCVCVFVFUDUEVDVKAVGCURVGHZVAVJVCVLUTVIVLUSVHURVGUFUGUHUIUJUKUL
      UMUNCCDUOUP $.

    $( Mapping of a restriction of the ` 1st ` (first member of an ordered
       pair) function.  (Contributed by NM, 11-Oct-2004.)  (Revised by Mario
       Carneiro, 8-Sep-2013.) $)
    f1stres $p |- ( 1st |` ( A X. B ) ) : ( A X. B ) --> A $=
      ( vx vy vz cv csn cdm cuni wcel cxp wral c1st cres cop vex wceq cvv cmpt
      wf op1sta eleq1i adantr rgen2 sneq dmeqd unieqd eleq1d ralxp mpbir df-1st
      biimpri reseq1i wss ssv resmpt ax-mp eqtri fmpt mpbi ) CFZGZHZIZAJZCABKZL
      ZVFAMVFNZTVGDFZEFZOZGZHZIZAJZEBLDALVODEABVIAJZVOVJBJVOVPVNVIAVIVJDPEPUAUB
      ULUCUDVEVOCDEABVAVKQZVDVNAVQVCVMVQVBVLVAVKUEUFUGUHUIUJCVFAVDVHVHCRVDSZVFN
      ZCVFVDSZMVRVFCUKUMVFRUNVSVTQVFUOCRVFVDUPUQURUSUT $.

    $( Mapping of a restriction of the ` 2nd ` (second member of an ordered
       pair) function.  (Contributed by NM, 7-Aug-2006.)  (Revised by Mario
       Carneiro, 8-Sep-2013.) $)
    f2ndres $p |- ( 2nd |` ( A X. B ) ) : ( A X. B ) --> B $=
      ( vx vy vz cv csn crn cuni wcel cxp wral c2nd cres cop vex wceq cvv cmpt
      wf op2nda eleq1i adantl rgen2 sneq rneqd unieqd eleq1d ralxp mpbir df-2nd
      biimpri reseq1i wss ssv resmpt ax-mp eqtri fmpt mpbi ) CFZGZHZIZBJZCABKZL
      ZVFBMVFNZTVGDFZEFZOZGZHZIZBJZEBLDALVODEABVJBJZVOVIAJVOVPVNVJBVIVJDPEPUAUB
      ULUCUDVEVOCDEABVAVKQZVDVNBVQVCVMVQVBVLVAVKUEUFUGUHUIUJCVFBVDVHVHCRVDSZVFN
      ZCVFVDSZMVRVFCUKUMVFRUNVSVTQVFUOCRVFVDUPUQURUSUT $.

    $( Onto mapping of a restriction of the ` 1st ` (first member of an ordered
       pair) function.  (Contributed by NM, 14-Dec-2008.) $)
    fo1stres $p |- ( B =/= (/) ->
                 ( 1st |` ( A X. B ) ) : ( A X. B ) -onto-> A ) $=
      ( vx vy c0 wne cxp c1st cres wf crn wa wss cv wcel cfv ax-mp jctil sylibr
      vex wfo wex wi n0 cop opelxp fvres op1st syl6req wfn f1stres ffn fnfvelrn
      wceq mpan eqeltrd sylbir expcom exlimiv sylbi ssrdv frn eqss dffo2 ) BEFZ
      ABGZAHVFIZJZVGKZAUNZLVFAVGUAVEVJVHVEVIAMZAVIMZLVJVEVLVKVECAVIVEDNZBOZDUBC
      NZAOZVOVIOZUCZDBUDVNVRDVPVNVQVPVNLVOVMUEZVFOZVQVOVMABUFVTVOVSVGPZVIVTWAVS
      HPVOVSVFHUGVOVMCTDTUHUIVGVFUJZVTWAVIOVHWBABUKZVFAVGULQVFVSVGUMUOUPUQURUSU
      TVAVHVKWCVFAVGVBQRVIAVCSWCRVFAVGVDS $.

    $( Onto mapping of a restriction of the ` 2nd ` (second member of an
       ordered pair) function.  (Contributed by NM, 14-Dec-2008.) $)
    fo2ndres $p |- ( A =/= (/) ->
                 ( 2nd |` ( A X. B ) ) : ( A X. B ) -onto-> B ) $=
      ( vy vx c0 wne cxp c2nd cres wf crn wa wss cv wcel cfv ax-mp jctil sylibr
      vex wfo wex wi n0 cop opelxp fvres op2nd syl6req wfn f2ndres ffn fnfvelrn
      wceq mpan eqeltrd sylbir ex exlimiv sylbi ssrdv frn eqss dffo2 ) AEFZABGZ
      BHVFIZJZVGKZBUNZLVFBVGUAVEVJVHVEVIBMZBVIMZLVJVEVLVKVECBVIVEDNZAOZDUBCNZBO
      ZVOVIOZUCZDAUDVNVRDVNVPVQVNVPLVMVOUEZVFOZVQVMVOABUFVTVOVSVGPZVIVTWAVSHPVO
      VSVFHUGVMVODTCTUHUIVGVFUJZVTWAVIOVHWBABUKZVFBVGULQVFVSVGUMUOUPUQURUSUTVAV
      HVKWCVFBVGVBQRVIBVCSWCRVFBVGVDS $.
  $}

  ${
    $d x y z w v $.  $d v w A $.
    $( Value of an alternate definition of the ` 1st ` function.  (Contributed
       by NM, 14-Oct-2004.)  (Revised by Mario Carneiro, 30-Dec-2014.) $)
    1st2val $p |- ( { <. <. x , y >. , z >. | z = x } ` A ) = ( 1st ` A ) $=
      ( vw vv cvv wcel weq cfv wceq cv wex vex syl6eq eqtr4d cdm cuni c0 copab
      cxp coprab c1st cop fveq2 co df-ov simpl cmpt2 mpt2v eqcomi ovmpt2a mp2an
      elvv eqtr3i op1std exlimivv sylbi wn csn wa pm3.2i a9ev 2th opabbii df-xp
      dmoprab 3eqtr4ri eleq2i ndmfv sylnbir dmsnn0 biimpri necon1bi unieqd uni0
      wne 1stval syl6eqr pm2.61i ) DGGUAZHZDCAIZABCUBZJZDUCJZKZWBDELZFLZUDZKZFM
      EMWGEFDUNWKWGEFWKWEWHWFWKWEWJWDJZWHDWJWDUEWHWIWDUFZWLWHWHWIWDUGWHGHWIGHWM
      WHKENZFNZABWHWIGGALZWHWDAEIBFIUHABGGWPUIWDABCWPUJUKWNULUMUOOWHWIDWNWOUPPU
      QURWBUSZWEDUTQZRZWFWQWESWSWBDWDQZHWESKWTWADWPGHZBLGHZVAZABTWCCMZABTWAWTXC
      XDABXCXDXAXBANBNVBCAVCVDVEABGGVFWCABCVGVHVIDWDVJVKWQWSSRSWQWRSWBWRSWBWRSV
      QDVLVMVNVOVPOPDVRVSVT $.

    $( Value of an alternate definition of the ` 2nd ` function.  (Contributed
       by NM, 10-Aug-2006.)  (Revised by Mario Carneiro, 30-Dec-2014.) $)
    2nd2val $p |- ( { <. <. x , y >. , z >. | z = y } ` A ) = ( 2nd ` A ) $=
      ( vw vv cvv cxp wcel weq cfv wceq cv wex vex syl6eq eqtr4d cuni c0 copab
      coprab c2nd cop elvv fveq2 co df-ov simpr cmpt2 mpt2v eqcomi mp2an eqtr3i
      ovmpt2a op2ndd exlimivv sylbi wn csn crn cdm wa pm3.2i a9ev opabbii df-xp
      2th dmoprab 3eqtr4ri eleq2i ndmfv sylnbir wne rnsnn0 necon1bi unieqd uni0
      biimpri 2ndval syl6eqr pm2.61i ) DGGHZIZDCBJZABCUAZKZDUBKZLZWCDEMZFMZUCZL
      ZFNENWHEFDUDWLWHEFWLWFWJWGWLWFWKWEKZWJDWKWEUEWIWJWEUFZWMWJWIWJWEUGWIGIWJG
      IWNWJLEOZFOZABWIWJGGBMZWJWEAEJBFJUHABGGWQUIWEABCWQUJUKWPUNULUMPWIWJDWOWPU
      OQUPUQWCURZWFDUSUTZRZWGWRWFSWTWCDWEVAZIWFSLXAWBDAMGIZWQGIZVBZABTWDCNZABTW
      BXAXDXEABXDXEXBXCAOBOVCCBVDVGVEABGGVFWDABCVHVIVJDWEVKVLWRWTSRSWRWSSWCWSSW
      CWSSVMDVNVRVOVPVQPQDVSVTWA $.
  $}

  $( Composition of the first member function with another function.
     (Contributed by NM, 12-Oct-2007.) $)
  1stcof $p |- ( F : A --> ( B X. C ) -> ( 1st o. F ) : A --> B ) $=
    ( cxp wf c1st ccom wfn crn wss cvv wfo fo1st fofn ax-mp ffn dffn2 cres frn
    sylib fnfco sylancr rnco ssres2 rnss 3syl f1stres syl6ss syl5eqss sylanbrc
    df-f ) ABCEZDFZGDHZAIZUOJZBKABUOFUNGLIZALDFZUPLLGMURNLLGOPUNDAIUSAUMDQADRUA
    LAGDUBUCUNUQGDJZSZJZBGDUDUNVBGUMSZJZBUNUTUMKVAVCKVBVDKAUMDTUTUMGUEVAVCUFUGU
    MBVCFVDBKBCUHUMBVCTPUIUJABUOULUK $.

  $( Composition of the first member function with another function.
     (Contributed by FL, 15-Oct-2012.) $)
  2ndcof $p |- ( F : A --> ( B X. C ) -> ( 2nd o. F ) : A --> C ) $=
    ( cxp wf c2nd ccom wfn crn wss cvv wfo fo2nd fofn ax-mp ffn dffn2 cres frn
    sylib fnfco sylancr rnco ssres2 rnss 3syl f2ndres syl6ss syl5eqss sylanbrc
    df-f ) ABCEZDFZGDHZAIZUOJZCKACUOFUNGLIZALDFZUPLLGMURNLLGOPUNDAIUSAUMDQADRUA
    LAGDUBUCUNUQGDJZSZJZCGDUDUNVBGUMSZJZCUNUTUMKVAVCKVBVDKAUMDTUTUMGUEVAVCUFUGU
    MCVCFVDCKBCUHUMCVCTPUIUJACUOULUK $.

  ${
    $d A b c $.  $d B b c $.  $d C b c $.
    $( Location of the first element of a Cartesian product.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    xp1st $p |- ( A e. ( B X. C ) -> ( 1st ` A ) e. B ) $=
      ( vb vc cxp wcel cv cop wceq wex c1st cfv elxp vex op1std biimpar adantrr
      wa eleq1d exlimivv sylbi ) ABCFGADHZEHZIJZUCBGZUDCGZSSZEKDKALMZBGZDEABCNU
      HUJDEUEUFUJUGUEUJUFUEUIUCBUCUDADOEOPTQRUAUB $.
  $}

  ${
    $d A b c $.  $d B b c $.  $d C b c $.
    $( Location of the second element of a Cartesian product.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    xp2nd $p |- ( A e. ( B X. C ) -> ( 2nd ` A ) e. C ) $=
      ( vb vc cxp wcel cv cop wceq wex c2nd cfv elxp vex op2ndd biimpar adantrl
      wa eleq1d exlimivv sylbi ) ABCFGADHZEHZIJZUCBGZUDCGZSSZEKDKALMZCGZDEABCNU
      HUJDEUEUGUJUFUEUJUGUEUIUDCUCUDADOEOPTQRUAUB $.
  $}

  $( Membership in a cross product.  This version requires no quantifiers or
     dummy variables.  See also ~ elxp4 .  (Contributed by NM, 9-Oct-2004.) $)
  elxp6 $p |- ( A e. ( B X. C ) <-> ( A = <. ( 1st ` A ) , ( 2nd ` A ) >.
               /\ ( ( 1st ` A ) e. B /\ ( 2nd ` A ) e. C ) ) ) $=
    ( cxp wcel csn cdm cuni crn cop wceq wa c1st cfv elxp4 1stval 2ndval eleq1i
    c2nd anbi12i opeq12i eqeq2i bitr4i ) ABCDEAAFZGHZUDIHZJZKZUEBEZUFCEZLZLAAMN
    ZASNZJZKZULBEZUMCEZLZLABCOUOUHURUKUNUGAULUEUMUFAPZAQZUAUBUPUIUQUJULUEBUSRUM
    UFCUTRTTUC $.

  $( Membership in a cross product.  This version requires no quantifiers or
     dummy variables.  See also ~ elxp4 .  (Contributed by NM, 19-Aug-2006.) $)
  elxp7 $p |- ( A e. ( B X. C ) <-> ( A e. ( _V X. _V )
               /\ ( ( 1st ` A ) e. B /\ ( 2nd ` A ) e. C ) ) ) $=
    ( cxp wcel c1st cfv c2nd cop wceq wa cvv fvex pm3.2i mpbiran2 anbi1i bitr4i
    elxp6 ) ABCDEAAFGZAHGZIJZSBETCEKZKALLDEZUBKABCRUCUAUBUCUASLEZTLEZKUDUEAFMAH
    MNALLROPQ $.

  ${
    $d A x y $.  $d B x y $.  $d C x y $.  $d D x y $.
    $( Difference of Cartesian products, expressed in terms of a union of
       Cartesian products of differences.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 26-Jun-2014.) $)
    difxp $p |- ( ( C X. D ) \ ( A X. B ) ) =
                ( ( ( C \ A ) X. D ) u. ( C X. ( D \ B ) ) ) $=
      ( vx vy cxp cdif wrel relxp cv wn wa wo anbi2i bitri opelxp eldif 3bitr4i
      wcel cun wss difss relss mp2 relun mpbir2an cop ianor andi notbii anbi12i
      anbi1i an32 anass orbi12i elun eqrelriiv ) EFCDGZABGZHZCAHZDGZCDBHZGZUAZV
      AUSUBUSIVAIUSUTUCCDJVAUSUDUEVFIVCIVEIVBDJCVDJVCVEUFUGEKZFKZUHZUSTZVIUTTZL
      ZMZVIVCTZVIVETZNZVIVATVIVFTVGCTZVHDTZMZVGATZVHBTZMZLZMZVSVTLZMZVSWALZMZNZ
      VMVPWDVSWEWGNZMWIWCWJVSVTWAUIOVSWEWGUJPVJVSVLWCVGVHCDQVKWBVGVHABQUKULVNWF
      VOWHVNVGVBTZVRMZWFVGVHVBDQWLVQWEMZVRMWFWKWMVRVGCARUMVQWEVRUNPPVQVHVDTZMVQ
      VRWGMZMVOWHWNWOVQVHDBROVGVHCVDQVQVRWGUOSUPSVIUSUTRVIVCVEUQSUR $.
  $}

  $( Difference law for cross product.  (Contributed by Scott Fenton,
     18-Feb-2013.)  (Revised by Mario Carneiro, 26-Jun-2014.) $)
  difxp1 $p |- ( ( A \ B ) X. C ) = ( ( A X. C ) \ ( B X. C ) ) $=
    ( cxp cdif cun c0 difxp difid xpeq2i xp0 eqtri uneq2i un0 3eqtrri ) ACDBCDE
    ABECDZACCEZDZFPGFPBCACHRGPRAGDGQGACIJAKLMPNO $.

  $( Difference law for cross product.  (Contributed by Scott Fenton,
     18-Feb-2013.)  (Revised by Mario Carneiro, 26-Jun-2014.) $)
  difxp2 $p |- ( A X. ( B \ C ) ) = ( ( A X. B ) \ ( A X. C ) ) $=
    ( cxp cdif cun c0 difxp difid xpeq1i 0xp eqtri uneq1i uncom un0 3eqtrri ) A
    BDACDEAAEZBDZABCEDZFGSFZSACABHRGSRGBDGQGBAIJBKLMTSGFSGSNSOLP $.

  $( Equality with an ordered pair.  (Contributed by NM, 15-Dec-2008.)
     (Revised by Mario Carneiro, 23-Feb-2014.) $)
  eqopi $p |- ( ( A e. ( V X. W ) /\ ( ( 1st ` A ) = B /\ ( 2nd ` A ) = C ) )
              -> A = <. B , C >. ) $=
    ( cxp wcel cvv c1st cfv wceq c2nd wa cop xpss sseli simplbi opeq12 sylan9eq
    elxp6 sylan ) ADEFZGAHHFZGZAIJZBKALJZCKMZABCNZKUBUCADEOPUDUGAUEUFNZUHUDAUIK
    UEHGUFHGMAHHTQUEUFBCRSUA $.

  ${
    $d x A $.  $d x B $.
    $( Representation of cross product based on ordered pair component
       functions.  (Contributed by NM, 16-Sep-2006.) $)
    xp2 $p |- ( A X. B ) = { x e. ( _V X. _V ) | ( ( 1st ` x ) e. A /\
              ( 2nd ` x ) e. B ) } $=
      ( cxp cv cvv wcel c1st cfv c2nd wa cab crab elxp7 abbi2i df-rab eqtr4i )
      BCDZAEZFFDZGSHIBGSJICGKZKZALUAATMUBARSBCNOUAATPQ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( The membership relation for a cross product is inherited by union.
       (Contributed by NM, 16-Sep-2006.) $)
    unielxp $p |- ( A e. ( B X. C ) -> U. A e. U. ( B X. C ) ) $=
      ( vx cxp wcel cvv c1st cfv c2nd wa cuni elxp7 elvvuni adantr cv cab fveq2
      eleq1d anbi12d wex simprl wceq eleq2 eleq1 spcegv eluniab sylibr crab xp2
      mpcom df-rab eqtri unieqi syl6eleqr mpancom sylbi ) ABCEZFAGGEZFZAHIZBFZA
      JIZCFZKZKZALZURLZFZABCMVGAFZVFVIUTVJVEANOVJVFKZVGDPZUSFZVLHIZBFZVLJIZCFZK
      ZKZDQZLZVHVKVGVLFZVSKZDUAZVGWAFUTVKWDVJUTVEUBWCVKDAUSVLAUCZWBVJVSVFVLAVGU
      DWEVMUTVRVEVLAUSUEWEVOVBVQVDWEVNVABVLAHRSWEVPVCCVLAJRSTTTUFUKVSDVGUGUHURV
      TURVRDUSUIVTDBCUJVRDUSULUMUNUOUPUQ $.
  $}

  $( Reconstruction of a member of a cross product in terms of its ordered pair
     components.  (Contributed by NM, 20-Oct-2013.) $)
  1st2nd2 $p |- ( A e. ( B X. C ) -> A = <. ( 1st ` A ) , ( 2nd ` A ) >. ) $=
    ( cxp wcel c1st cfv c2nd cop wceq wa elxp6 simplbi ) ABCDEAAFGZAHGZIJNBEOCE
    KABCLM $.

  $( Reconstruction of an ordered pair in terms of its components.
     (Contributed by NM, 25-Feb-2014.) $)
  1st2ndb $p |- ( A e. ( _V X. _V )
      <-> A = <. ( 1st ` A ) , ( 2nd ` A ) >. ) $=
    ( cvv cxp wcel c1st cfv c2nd cop wceq 1st2nd2 fvex opelvv syl6eqel impbii
    id ) ABBCZDAAEFZAGFZHZIZABBJTASPTOQRAEKAGKLMN $.

  $( An ordered pair theorem for members of cross products.  (Contributed by
     NM, 20-Jun-2007.) $)
  xpopth $p |- ( ( A e. ( C X. D ) /\ B e. ( R X. S ) ) ->
       ( ( ( 1st ` A ) = ( 1st ` B ) /\
     ( 2nd ` A ) = ( 2nd ` B ) ) <-> A = B ) ) $=
    ( cxp wcel wa wceq c1st cfv c2nd cop 1st2nd2 eqeqan12d fvex opth syl6rbb )
    ACDGHZBEFGHZIABJAKLZAMLZNZBKLZBMLZNZJUBUEJUCUFJITUAAUDBUGACDOBEFOPUBUCUEUFA
    KQAMQRS $.

  $( Two ways to express equality with an ordered pair.  (Contributed by NM,
     3-Sep-2007.)  (Proof shortened by Mario Carneiro, 26-Apr-2015.) $)
  eqop $p |- ( A e. ( V X. W ) -> ( A = <. B , C >.
            <-> ( ( 1st ` A ) = B /\ ( 2nd ` A ) = C ) ) ) $=
    ( cxp wcel cop wceq c1st cfv c2nd wa 1st2nd2 eqeq1d fvex opth syl6bb ) ADEF
    GZABCHZIAJKZALKZHZTIUABIUBCIMSAUCTADENOUAUBBCAJPALPQR $.

  ${
    eqop2.1 $e |- B e. _V $.
    eqop2.2 $e |- C e. _V $.
    $( Two ways to express equality with an ordered pair.  (Contributed by NM,
       25-Feb-2014.) $)
    eqop2 $p |- ( A = <. B , C >.
       <-> ( A e. ( _V X. _V ) /\ ( ( 1st ` A ) = B /\ ( 2nd ` A ) = C ) ) ) $=
      ( cop wceq cvv cxp wcel c1st cfv c2nd wa opelvv eleq1 mpbiri eqop biadan2
      ) ABCFZGZAHHIZJZAKLBGAMLCGNUAUCTUBJBCDEOATUBPQABCHHRS $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Two ways of expressing that an element is the first member of an ordered
       pair.  (Contributed by NM, 22-Sep-2013.)  (Revised by Mario Carneiro,
       23-Feb-2014.) $)
    op1steq $p |- ( A e. ( V X. W )
         -> ( ( 1st ` A ) = B <-> E. x A = <. B , x >. ) ) $=
      ( cxp wcel cvv c1st cfv wceq cv cop wex wb xpss sseli wa c2nd syl eqid ex
      eqopi mpanr2 fvex opeq2 eqeq2d spcev eqop simpl syl6bi exlimdv impbid ) B
      DEFZGBHHFZGZBIJCKZBCALZMZKZANZOUNUOBDEPQUPUQVAUPUQVAUPUQRBCBSJZMZKZVAUPUQ
      VBVBKVDVBUABCVBHHUCUDUTVDAVBBSUEURVBKUSVCBURVBCUFUGUHTUBUPUTUQAUPUTUQVBUR
      KZRUQBCURHHUIUQVEUJUKULUMT $.
  $}

  $( Swap the members of an ordered pair.  (Contributed by NM, 31-Dec-2014.) $)
  2nd1st $p |- ( A e. ( B X. C ) ->
    U. `' { A } = <. ( 2nd ` A ) , ( 1st ` A ) >. ) $=
    ( cxp wcel csn ccnv cuni c1st cfv 1st2nd2 sneqd cnveqd unieqd opswap syl6eq
    c2nd cop ) ABCDEZAFZGZHAIJZAQJZRZFZGZHUCUBRSUAUFSTUESAUDABCKLMNUBUCOP $.

  $( Reconstruction of a member of a relation in terms of its ordered pair
     components.  (Contributed by NM, 29-Aug-2006.) $)
  1st2nd $p |- ( ( Rel B /\ A e. B ) ->
               A = <. ( 1st ` A ) , ( 2nd ` A ) >. ) $=
    ( wrel wcel wa cvv cxp c1st cfv c2nd cop wceq wss df-rel sylanb 1st2nd2 syl
    ssel2 ) BCZABDZEAFFGZDZAAHIAJIKLSBUAMTUBBNBUAAROAFFPQ $.

  $( The first ordered pair component of a member of a relation belongs to the
     domain of the relation.  (Contributed by NM, 17-Sep-2006.) $)
  1stdm $p |- ( ( Rel R /\ A e. R ) -> ( 1st ` A ) e. dom R ) $=
    ( wrel wcel c1st cfv cint cdm cvv cxp wceq wss df-rel biimpi sselda 1stval2
    wa syl elreldm eqeltrd ) BCZABDQZAEFZAGGZBHUBAIIJZDUCUDKUABUEAUABUELBMNOAPR
    BAST $.

  $( The second ordered pair component of a member of a relation belongs to the
     range of the relation.  (Contributed by NM, 17-Sep-2006.) $)
  2ndrn $p |- ( ( Rel R /\ A e. R ) -> ( 2nd ` A ) e. ran R ) $=
    ( wrel wcel wa c1st cfv c2nd cop crn 1st2nd simpr eqeltrrd fvex opelrn syl
    ) BCZABDZEZAFGZAHGZIZBDUABJDSAUBBABKQRLMTUABAFNAHNOP $.

  $( Express an element of a relation as a relationship between first and
     second components.  (Contributed by Mario Carneiro, 22-Jun-2016.) $)
  1st2ndbr $p |- ( ( Rel B /\ A e. B ) -> ( 1st ` A ) B ( 2nd ` A ) ) $=
    ( wrel wcel wa c1st cfv c2nd cop wbr 1st2nd simpr eqeltrrd df-br sylibr ) B
    CZABDZEZAFGZAHGZIZBDSTBJRAUABABKPQLMSTBNO $.

  ${
    $d x y A $.  $d x y B $.
    $( Two ways of expressing membership in the domain of a relation.
       (Contributed by NM, 22-Sep-2013.) $)
    releldm2 $p |- ( Rel A
         -> ( B e. dom A <-> E. x e. A ( 1st ` x ) = B ) ) $=
      ( vy wrel cdm wcel cv c1st cfv wceq wrex cvv wa elex anim2i id fvex wex
      wb syl6eqelr rexlimivw cop eldm2g adantl cxp wss wi df-rel ssel sylbi imp
      op1steq syl rexbidva adantr rexcom4 risset bitr4i syl6bb bitr4d pm5.21nd
      exbii ) BEZCBFZGZAHZIJZCKZABLZVDCMGZNZVFVKVDCVEOPVJVKVDVIVKABVICVHMVIQVGI
      RUAUBPVLVFCDHUCZBGZDSZVJVKVFVOTVDDCBMUDUEVLVJVGVMKZDSZABLZVOVDVJVRTVKVDVI
      VQABVDVGBGZNVGMMUFZGZVIVQTVDVSWAVDBVTUGVSWAUHBUIBVTVGUJUKULDVGCMMUMUNUOUP
      VRVPABLZDSVOVPADBUQVNWBDAVMBURVCUSUTVAVB $.
  $}

  ${
    $d x y z A $.
    $( An expression for the domain of a relation.  (Contributed by NM,
       22-Sep-2013.) $)
    reldm $p |- ( Rel A -> dom A = ran ( x e. A |-> ( 1st ` x ) ) ) $=
      ( vy vz wrel cdm cv c1st cfv cmpt crn wcel wceq wrex releldm2 wfn wb fvex
      eqid fnmpti fvelrnb ax-mp fveq2 fvmpt eqeq1d rexbiia syl5rbb bitrd eqrdv
      a1i ) BEZCBFZABAGZHIZJZKZUKCGZULLDGZHIZUQMZDBNZUQUPLZDBUQOVBURUOIZUQMZDBN
      ZUKVAUOBPVBVEQABUNUOUMHRUOSZTDBUQUOUAUBVEVAQUKVDUTDBURBLVCUSUQAURUNUSBUOU
      MURHUCVFURHRUDUEUFUJUGUHUI $.
  $}

  $( Equality theorem for substitution of a class for an ordered pair (analog
     of ~ sbceq1a that avoids the existential quantifiers of ~ copsexg ).
     (Contributed by NM, 19-Aug-2006.)  (Revised by Mario Carneiro,
     31-Aug-2015.) $)
  sbcopeq1a $p |- ( A = <. x , y >. ->
      ( [. ( 1st ` A ) / x ]. [. ( 2nd ` A ) / y ]. ph <-> ph ) ) $=
    ( cv cop wceq c2nd cfv wsbc c1st wb vex op2ndd eqcomd sbceq1a op1std bitr2d
    syl ) DBEZCEZFGZAACDHIZJZUDBDKIZJZUBUAUCGAUDLUBUCUATUADBMZCMZNOACUCPSUBTUEG
    UDUFLUBUETTUADUGUHQOUDBUEPSR $.

  $( Equality theorem for substitution of a class ` A ` for an ordered pair
     ` <. x , y >. ` in ` B ` (analog of ~ csbeq1a ).  (Contributed by NM,
     19-Aug-2006.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
  csbopeq1a $p |- ( A = <. x , y >. ->
      [_ ( 1st ` A ) / x ]_ [_ ( 2nd ` A ) / y ]_ B = B ) $=
    ( cv cop wceq c2nd cfv csb c1st vex op2ndd eqcomd csbeq1a syl op1std eqtr2d
    ) CAEZBEZFGZDBCHIZDJZACKIZUCJZUATUBGDUCGUAUBTSTCALZBLZMNBUBDOPUASUDGUCUEGUA
    UDSSTCUFUGQNAUDUCOPR $.

  ${
    $d z ph $.  $d x y z $.
    $( A way to define an ordered-pair class abstraction without using
       existential quantifiers.  (Contributed by NM, 18-Aug-2006.)  (Revised by
       Mario Carneiro, 31-Aug-2015.) $)
    dfopab2 $p |- { <. x , y >. | ph } = { z e. ( _V X. _V ) |
                  [. ( 1st ` z ) / x ]. [. ( 2nd ` z ) / y ]. ph } $=
      ( cv cop wceq wex cab cvv cxp wcel c2nd cfv wsbc c1st nfsbc1v 19.41 exbii
      wa copab crab sbcopeq1a pm5.32i nfsbc bitr3i anbi1i 3bitr4i abbii df-opab
      nfcv elvv df-rab 3eqtr4i ) DEZBECEFGZATZCHZBHZDIUOJJKZLZACUOMNZOZBUOPNZOZ
      TZDIABCUAVEDUTUBUSVFDUPCHZVETZBHVGBHZVETUSVFVGVEBVCBVDQRURVHBURUPVETZCHVH
      VJUQCUPVEAABCUOUCUDSUPVECVCCBVDCVDUKACVBQUERUFSVAVIVEBCUOULUGUHUIABCDUJVE
      DUTUMUN $.
  $}

  ${
    $d w ph $.  $d x y z w $.
    $( A way to define an operation class abstraction without using existential
       quantifiers.  (Contributed by NM, 18-Aug-2006.)  (Revised by Mario
       Carneiro, 31-Aug-2015.) $)
    dfoprab3s $p |- { <. <. x , y >. , z >. | ph } = { <. w , z >. |
       ( w e. ( _V X. _V )
           /\ [. ( 1st ` w ) / x ]. [. ( 2nd ` w ) / y ]. ph ) } $=
      ( coprab cv cop wceq wex copab cvv cxp wcel cfv wsbc nfsbc1v 19.41 exbii
      wa c2nd c1st dfoprab2 sbcopeq1a pm5.32i nfcv nfsbc bitr3i 3bitr4i opabbii
      elvv anbi1i eqtri ) ABCDFEGZBGCGHIZATZCJZBJZEDKUNLLMNZACUNUAOZPZBUNUBOZPZ
      TZEDKABCDEUCURVDEDUOCJZVCTZBJVEBJZVCTURVDVEVCBVABVBQRUQVFBUQUOVCTZCJVFVHU
      PCUOVCAABCUNUDUESUOVCCVACBVBCVBUFACUTQUGRUHSUSVGVCBCUNUKULUIUJUM $.
  $}

  ${
    $d x y ph $.  $d w ps $.  $d x y z w $.
    dfoprab3.1 $e |- ( w = <. x , y >. -> ( ph <-> ps ) ) $.
    $( Operation class abstraction expressed without existential quantifiers.
       (Contributed by NM, 16-Dec-2008.) $)
    dfoprab3 $p |- { <. w , z >. | ( w e. ( _V X. _V ) /\ ph ) } =
       { <. <. x , y >. , z >. | ps } $=
      ( coprab cv cvv c2nd cfv wsbc c1st wa copab fvex wceq wb eqcom wcel eqopi
      cxp dfoprab3s cop anbi12i sylan2b syl bicomd ex sbc2iedv pm5.32i opabbii
      eqtr2i ) BCDEHFIZJJUCUAZBDUOKLZMCUONLZMZOZFEPUPAOZFEPBCDEFUDUTVAFEUPUSAUP
      BACDURUQUONQUOKQUPCIZURRZDIZUQRZOZBASUPVFOZABVGUOVBVDUERZABSVFUPURVBRZUQV
      DRZOVHVCVIVEVJVBURTVDUQTUFUOVBVDJJUBUGGUHUIUJUKULUMUN $.
  $}

  ${
    $d w x y A $.  $d w x y B $.  $d x y ph $.  $d w ps $.  $d w x y z $.
    dfoprab4.1 $e |- ( w = <. x , y >. -> ( ph <-> ps ) ) $.
    $( Operation class abstraction expressed without existential quantifiers.
       (Contributed by NM, 3-Sep-2007.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    dfoprab4 $p |- { <. w , z >. | ( w e. ( A X. B ) /\ ph ) } =
      { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ps ) } $=
      ( cv cxp wcel wa copab cvv coprab xpss sseli adantr pm4.71ri opabbii wceq
      cop eleq1 opelxp syl6bb anbi12d dfoprab3 eqtri ) FJZGHKZLZAMZFENUJOOKZLZU
      MMZFENCJZGLDJZHLMZBMZCDEPUMUPFEUMUOULUOAUKUNUJGHQRSTUAUMUTCDEFUJUQURUCZUB
      ZULUSABVBULVAUKLUSUJVAUKUDUQURGHUEUFIUGUHUI $.
  $}

  ${
    $d t u w x y z $.  $d t u w x y A $.  $d t u w x y B $.  $d t u w ps $.
    $d t u ph $.
    dfoprab4f.x $e |- F/ x ph $.
    dfoprab4f.y $e |- F/ y ph $.
    dfoprab4f.1 $e |- ( w = <. x , y >. -> ( ph <-> ps ) ) $.
    $( Operation class abstraction expressed without existential quantifiers.
       (Unnecessary distinct variable restrictions were removed by David
       Abernethy, 19-Jun-2012.)  (Contributed by NM, 20-Dec-2008.)  (Revised by
       Mario Carneiro, 31-Aug-2015.) $)
    dfoprab4f $p |- { <. w , z >. | ( w e. ( A X. B ) /\ ph ) } =
      { <. <. x , y >. , z >. | ( ( x e. A /\ y e. B ) /\ ps ) } $=
      ( vt vu cv wcel wa cop wceq wb nfv cxp copab coprab nfs1v nfbi nfim opeq1
      wsb wi eqeq2d sbequ12 bibi2d imbi12d opeq2 chvar dfoprab4 nfan nfsb eleq1
      bi2anan9 sylan9bbr anbi12d cbvoprab12 eqtr4i ) FNZGHUAOAPFEUBLNZGOZMNZHOZ
      PZBDMUHZCLUHZPZLMEUCCNZGOZDNZHOZPZBPZCDEUCAVLLMEFGHVEVNVHQZRZAVKSZUIZVEVF
      VHQZRZAVLSZUICLWEWFCWECTAVLCIVKCLUDZUEUFVNVFRZWAWEWBWFWHVTWDVEVNVFVHUGUJW
      HVKVLAVKCLUKZULUMVEVNVPQZRZABSZUIWCDMWAWBDWADTAVKDJBDMUDZUEUFVPVHRZWKWAWL
      WBWNWJVTVEVPVHVNUNUJWNBVKABDMUKZULUMKUOUOUPVSVMCDELMVSLTVSMTVJVLCVJCTWGUQ
      VJVLDVJDTVKCLDWMURUQWHWNPVRVJBVLWHVOVGWNVQVIVNVFGUSVPVHHUSUTWNBVKWHVLWOWI
      VAVBVCVD $.
  $}

  ${
    $d x y z u A $.  $d x y z u B $.  $d x y z u C $.
    $( Define the cross product of three classes.  Compare ~ df-xp .
       (Contributed by FL, 6-Nov-2013.)  (Proof shortened by Mario Carneiro,
       3-Nov-2015.) $)
    dfxp3 $p |- ( ( A X. B ) X. C ) =
      { <. <. x , y >. , z >. | ( x e. A /\ y e. B /\ z e. C ) } $=
      ( vu cv cxp wcel wa copab coprab w3a cop wceq biidd dfoprab4 df-xp df-3an
      oprabbii 3eqtr4i ) GHZDEIZJCHFJZKGCLAHZDJZBHZEJZKUEKZABCMUDFIUGUIUENZABCM
      UEUEABCGDEUCUFUHOPUEQRGCUDFSUKUJABCUGUIUETUAUB $.
  $}

  ${
    $d x y A $.  $d x y ph $.
    copsex2ga.1 $e |- ( A = <. x , y >. -> ( ph <-> ps ) ) $.
    $( Implicit substitution inference for ordered pairs.  Compare
       ~ copsex2ga .  (Contributed by NM, 12-Mar-2014.) $)
    copsex2gb $p |- ( E. x E. y ( A = <. x , y >. /\ ps )
         <-> ( A e. ( _V X. _V ) /\ ph ) ) $=
      ( cvv cxp wcel wa cv cop wceq elvv anbi1i 19.41vv pm5.32i 2exbii 3bitr2ri
      wex ) EGGHIZAJECKDKLMZDTCTZAJUBAJZDTCTUBBJZDTCTUAUCACDENOUBACDPUDUECDUBAB
      FQRS $.

    $( Implicit substitution inference for ordered pairs.  Compare
       ~ copsex2g .  (Contributed by NM, 26-Feb-2014.)  (Proof shortened by
       Mario Carneiro, 31-Aug-2015.) $)
    copsex2ga $p |- ( A e. ( V X. W )
        -> ( ph <-> E. x E. y ( A = <. x , y >. /\ ps ) ) ) $=
      ( cxp wcel cvv cv cop wceq wa wex wb xpss sseli copsex2gb baibr syl ) EFG
      IZJEKKIZJZAECLDLMNBODPCPZQUCUDEFGRSUFUEAABCDEHTUAUB $.

    $( Membership in an ordered pair class builder.  (Contributed by NM,
       25-Feb-2014.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    elopaba $p |- ( A e. { <. x , y >. | ps } <->
            ( A e. ( _V X. _V ) /\ ph ) ) $=
      ( copab wcel cv cop wceq wa wex cvv cxp elopab copsex2gb bitri ) EBCDGHEC
      IDIJKBLDMCMENNOHALBCDEPABCDEFQR $.
  $}

  ${
    $d y z ph $.  $d x ps $.  $d x y z $.
    exopxfr.1 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Transfer ordered-pair existence from/to single variable existence.
       (Contributed by NM, 26-Feb-2014.)  (Proof shortened by Mario Carneiro,
       31-Aug-2015.) $)
    exopxfr $p |- ( E. x e. ( _V X. _V ) ph <-> E. y E. z ps ) $=
      ( cvv cxp wrex wex rexxp rexv exbii 3bitri ) ACGGHIBEGIZDGIODJBEJZDJABCDE
      GGFKODLOPDBELMN $.
  $}

  ${
    $d x y z A $.  $d y z ph $.  $d x ps $.
    exopxfr2.1 $e |- ( x = <. y , z >. -> ( ph <-> ps ) ) $.
    $( Transfer ordered-pair existence from/to single variable existence.
       (Contributed by NM, 26-Feb-2014.) $)
    exopxfr2 $p |- ( Rel A -> ( E. x e. A ph
              <-> E. y E. z ( <. y , z >. e. A /\ ps ) ) ) $=
      ( wrel wrex cv wcel wa cvv cxp cop wex wss df-rel biimpi sseld wceq eleq1
      adantrd pm4.71rd rexbidv2 anbi12d exopxfr syl6bb ) FHZACFICJZFKZALZCMMNZI
      DJEJOZFKZBLZEPDPUIAULCFUMUIULUJUMKZUIUKUQAUIFUMUJUIFUMQFRSTUCUDUEULUPCDEU
      JUNUAUKUOABUJUNFUBGUFUGUH $.
  $}

  ${
    $d x y A $.  $d x y ch $.
    elopabi.1 $e |- ( x = ( 1st ` A ) -> ( ph <-> ps ) ) $.
    elopabi.2 $e |- ( y = ( 2nd ` A ) -> ( ps <-> ch ) ) $.
    $( A consequence of membership in an ordered-pair class abstraction, using
       ordered pair extractors.  (Contributed by NM, 29-Aug-2006.) $)
    elopabi $p |- ( A e. { <. x , y >. | ph } -> ch ) $=
      ( copab wcel c1st cfv c2nd cop wrel wceq relopab 1st2nd mpan fvex sylib
      id eqeltrrd opelopab ) FADEIZJZFKLZFMLZNZUEJCUFFUIUEUEOUFFUIPADEQFUERSUFU
      BUCABCDEUGUHFKTFMTGHUDUA $.
  $}

  ${
    $d w x y z A $.  $d w ph $.  $d x y z th $.
    eloprabi.1 $e |- ( x = ( 1st ` ( 1st ` A ) ) -> ( ph <-> ps ) ) $.
    eloprabi.2 $e |- ( y = ( 2nd ` ( 1st ` A ) ) -> ( ps <-> ch ) ) $.
    eloprabi.3 $e |- ( z = ( 2nd ` A ) -> ( ch <-> th ) ) $.
    $( A consequence of membership in an operation class abstraction, using
       ordered pair extractors.  (Contributed by NM, 6-Nov-2006.)  (Revised by
       David Abernethy, 19-Jun-2012.) $)
    eloprabi $p |- ( A e. { <. <. x , y >. , z >. | ph } -> th ) $=
      ( vw cv wceq wex c1st cfv wb syl c2nd coprab wcel wa eqeq1 anbi1d 3exbidv
      cop df-oprab elab2g ibi opex vex op1std fveq2d op1st syl6req op2nd op2ndd
      eqcomd 3bitrd biimpa exlimiv ) HAEFGUAZUBZHEMZFMZUGZGMZUGZNZAUCZGOZFOZEOZ
      DVDVNLMZVINZAUCZGOFOEOVNLHVCVCVOHNZVQVKEFGVRVPVJAVOHVIUDUEUFAEFGLUHUIUJVM
      DEVLDFVKDGVJADVJABCDVJVEHPQZPQZNABRVJVTVGPQVEVJVSVGPVGVHHVEVFUKZGULZUMZUN
      VEVFEULZFULZUOUPISVJVFVSTQZNBCRVJWFVGTQVFVJVSVGTWCUNVEVFWDWEUQUPJSVJVHHTQ
      ZNCDRVJWGVHVGVHHWAWBURUSKSUTVAVBVBVBS $.
  $}

  ${
    $d u v x y z A $.  $d t u v y z B $.  $d t u v z C $.
    $( Express a two-argument function as a one-argument function, or
       vice-versa.  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    mpt2mptsx $p |- ( x e. A , y e. B |-> C ) = ( z e. U_ x e. A ( { x } X. B )
        |-> [_ ( 1st ` z ) / x ]_ [_ ( 2nd ` z ) / y ]_ C ) $=
      ( vu vv cv csn csb cxp ciun cfv cmpt cmpt2 wceq nfcv nfcsb1v csbeq1a c1st
      c2nd cop vex op1std csbeq1d op2ndd csbeq2dv eqtrd mpt2mptx xpeq12d cbviun
      nfxp sneq mpteq1 ax-mp nfcsb sylan9eqr cbvmpt2x 3eqtr4ri ) CGDGIZJZAVAEKZ
      LZMZACIZUANZBVFUBNZFKZKZOZGHDVCAVABHIZFKZKZPCADAIZJZELZMZVJOZABDEFPGHCDVC
      VJVNVFVAVLUCQZVJAVAVIKVNVTAVGVAVIVAVLVFGUDZHUDZUEUFVTAVAVIVMVTBVHVLFVAVLV
      FWAWBUGUFUHUIUJVRVEQVSVKQAGDVQVDGVQRAVBVCAVBRAVAESZUMVOVAQZVPVBEVCVOVAUNA
      VAETZUKULCVRVEVJUOUPABGHDEFVCVNGERWCGFRHFRAVAVMSBAVAVMBVARBVLFSUQWEBIVLQW
      DFVMVNBVLFTAVAVMTURUSUT $.

    $d x B $.
    $( Express a two-argument function as a one-argument function, or
       vice-versa.  (Contributed by Mario Carneiro, 24-Sep-2015.) $)
    mpt2mpts $p |- ( x e. A , y e. B |-> C ) =
      ( z e. ( A X. B ) |-> [_ ( 1st ` z ) / x ]_ [_ ( 2nd ` z ) / y ]_ C ) $=
      ( cv csn cxp ciun c1st cfv c2nd csb cmpt mpt2mptsx wceq iunxpconst mpteq1
      cmpt2 ax-mp eqtri ) ABDEFTCADAGHEIJZACGZKLBUDMLFNNZOZCDEIZUEOZABCDEFPUCUG
      QUFUHQADERCUCUGUESUAUB $.
  $}

  ${
    $d t u v w x y z A $.  $d t u v w y z B $.  $d t u v w z C $.
    $d v w x y z D $.
    fmpt2x.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( The domain of a mapping is a subset of its base class.  (Contributed by
       Mario Carneiro, 9-Feb-2015.) $)
    dmmpt2ssx $p |- dom F C_ U_ x e. A ( { x } X. B ) $=
      ( vu vt vv cv csn csb cxp ciun cfv nfcv nfcsb1v csbeq1a wceq cdm cbvmpt2x
      c1st c2nd cmpt2 cmpt nfcsb sylan9eqr cop vex op1std op2ndd csbeq2dv eqtrd
      csbeq1d mpt2mptx 3eqtr4i dmmptss nfxp sneq xpeq12d cbviun sseqtr4i ) FUAH
      CHKZLZAVDDMZNZOZACAKZLZDNZOIVHAIKZUCPZBVLUDPZEMZMZFABCDEUEHJCVFAVDBJKZEMZ
      MZUEFIVHVPUFABHJCDEVFVSHDQAVDDRZHEQJEQAVDVRRBAVDVRBVDQBVQERUGAVDDSZBKVQTV
      IVDTZEVRVSBVQESAVDVRSUHUBGHJICVFVPVSVLVDVQUITZVPAVDVOMVSWCAVMVDVOVDVQVLHU
      JZJUJZUKUOWCAVDVOVRWCBVNVQEVDVQVLWDWEULUOUMUNUPUQURAHCVKVGHVKQAVEVFAVEQVT
      USWBVJVEDVFVIVDUTWAVAVBVC $.

    $( Functionality, domain and codomain of a class given by the "maps to"
       notation, where ` B ( x ) ` is not constant but depends on ` x ` .
       (Contributed by NM, 29-Dec-2014.) $)
    fmpt2x $p |- ( A. x e. A A. y e. B C e. D <->
      F : U_ x e. A ( { x } X. B ) --> D ) $=
      ( vz vw vv cv csb wcel wral wceq eleq1d wa nfv nfcsb1v csn ciun c1st c2nd
      cxp wf cfv cop op1std csbeq1d op2ndd csbeq2dv eqtrd raliunxp cmpt2 coprab
      cmpt nfcri nfan nfeq2 nfcv nfcsb wb eleq1 adantr csbeq1a eleq2d sylan9bbr
      anbi12d sylan9eqr eqeq2d cbvoprab12 df-mpt2 3eqtr4i mpt2mptx bitr3i nfel1
      fmpt nfral cbvral raleqbidv syl5bb nfxp sneq xpeq12d cbviun feq2i 3bitr4i
      vex ) AILZBJLZEMZMZFNZJAWJDMZOZICOZICWJUAZWOUEZUBZFGUFZEFNZBDOZACOACALZUA
      ZDUEZUBZFGUFWQAKLZUCUGZBXHUDUGZEMZMZFNZKWTOXAXMWNKIJCWOXHWJWKUHPZXLWMFXNX
      LAWJXKMWMXNAXIWJXKWJWKXHIWIZJWIZUIUJXNAWJXKWLXNBXJWKEWJWKXHXOXPUKUJULUMZQ
      UNKWTFXLGABCDEUOZIJCWOWMUOZGKWTXLUQXDCNZBLZDNZRZXHEPZRZABKUPWJCNZWKWONZRZ
      XHWMPZRZIJKUPXRXSYEYJABKIJYEISYEJSYHYIAYFYGAYFASAJWOAWJDTZURUSAXHWMAWJWLT
      ZUTUSYHYIBYHBSBXHWMBAWJWLBWJVABWKETZVBUTUSXDWJPZYAWKPZRZYCYHYDYIYPXTYFYBY
      GYNXTYFVCYOXDWJCVDVEYOYBWKDNYNYGYAWKDVDYNDWOWKAWJDVFZVGVHVIYPEWMXHYOYNEWL
      WMBWKEVFZAWJWLVFZVJVKVIVLABKCDEVMIJKCWOWMVMVNHIJKCWOXLWMXQVOVNVRVPXCWPAIC
      XCISWNAJWOYKAWMFYLVQVSXCWLFNZJDOYNWPXBYTBJDXBJSBWLFYMVQYOEWLFYRQVTYNYTWNJ
      DWOYQYNWLWMFYSQWAWBVTXGWTFGAICXFWSIXFVAAWRWOAWRVAYKWCYNXEWRDWOXDWJWDYQWEW
      FWGWH $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C z $.  $d D x y z $.
    fmpt2.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( Functionality, domain and range of a class given by the "maps to"
       notation.  (Contributed by FL, 17-May-2010.) $)
    fmpt2 $p |- ( A. x e. A A. y e. B C e. D <-> F : ( A X. B ) --> D ) $=
      ( wcel wral cv csn cxp ciun wf fmpt2x iunxpconst feq2i bitri ) EFIBDJACJA
      CAKLDMNZFGOCDMZFGOABCDEFGHPTUAFGACDQRS $.

    $( Functionality and domain of a class given by the "maps to" notation.
       (Contributed by FL, 17-May-2010.) $)
    fnmpt2 $p |- ( A. x e. A A. y e. B C e. V -> F Fn ( A X. B ) ) $=
      ( wcel wral cvv cxp wfn elex ralimi wf fmpt2 dffn2 bitr4i sylib ) EGIZBDJ
      ZACJEKIZBDJZACJZFCDLZMZUBUDACUAUCBDEGNOOUEUFKFPUGABCDEKFHQUFFRST $.

    fnmpt2i.2 $e |- C e. _V $.
    $( Functionality and domain of a class given by the "maps to" notation.
       (Contributed by FL, 17-May-2010.) $)
    fnmpt2i $p |- F Fn ( A X. B ) $=
      ( cvv wcel wral cxp wfn rgen2w fnmpt2 ax-mp ) EIJZBDKACKFCDLMQABCDHNABCDE
      FIGOP $.

    $( Domain of a class given by the "maps to" notation.  (Contributed by FL,
       17-May-2010.) $)
    dmmpt2 $p |- dom F = ( A X. B ) $=
      ( cxp wfn cdm wceq fnmpt2i fndm ax-mp ) FCDIZJFKPLABCDEFGHMPFNO $.
  $}

  ${
    $d A x y z $.  $d B y z $.  $d C z $.
    mpt2exg.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( Existence of an operation class abstraction (version for dependent
       domains).  (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    mpt2exxg $p |- ( ( A e. R /\ A. x e. A B e. S ) -> F e. _V ) $=
      ( wcel wral wa wfun cdm cvv mpt2fun cv csn cxp sylancr ciun wss dmmpt2ssx
      snex xpexg mpan ralimi iunexg sylan2 ssexg funex ) CFJZDGJZACKZLZHMHNZOJZ
      HOJABCDEHIPUOUPACAQZRZDSZUAZUBVAOJZUQABCDEHIUCUNULUTOJZACKVBUMVCACUSOJUMV
      CURUDUSDOGUEUFUGACUTFOUHUIUPVAOUJTOHUKT $.

    $d x B $.
    $( Existence of an operation class abstraction (special case).
       (Contributed by FL, 17-May-2010.)  (Revised by Mario Carneiro,
       1-Sep-2015.) $)
    mpt2exg $p |- ( ( A e. R /\ B e. S ) -> F e. _V ) $=
      ( wcel cvv wral elex ralrimivw syl mpt2exxg sylan2 ) DGJZCFJDKJZACLZHKJRS
      TDGMSSACDKMNOABCDEFKHIPQ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.
    $( If the domain of a function given by maps-to notation is a set, the
       function is a set.  (Contributed by NM, 12-Sep-2011.) $)
    mpt2exga $p |- ( ( A e. V /\ B e. W )
                       -> ( x e. A , y e. B |-> C ) e. _V ) $=
      ( cmpt2 eqid mpt2exg ) ABCDEFGABCDEHZKIJ $.
  $}

  ${
    $d x y A $.  $d y B $.
    mpt2ex.1 $e |- A e. _V $.
    mpt2ex.2 $e |- B e. _V $.
    $( If the domain of a function given by maps-to notation is a set, the
       function is a set.  (Contributed by Mario Carneiro, 20-Dec-2013.) $)
    mpt2ex $p |- ( x e. A , y e. B |-> C ) e. _V $=
      ( cvv wcel wral cmpt2 rgenw eqid mpt2exxg mp2an ) CHIDHIZACJABCDEKZHIFPAC
      GLABCDEHHQQMNO $.
  $}

  ${
    $d E a b e f p v $.  $d V a b c e f p v $.  $d ps c e v $.
    bropopvvv.o $e |- O = ( v e. _V , e e. _V |-> ( a e. v , b e. v |->
                            { <. f , p >. | ph } ) ) $.
    bropopvvv.p $e |- ( ( v = V /\ e = E ) -> ( ph <-> ps ) ) $.
    bropopvvv.oo $e |- ( ( ( V e. _V /\ E e. _V ) /\ ( A e. V /\ B e. V ) )
                         -> ( A ( V O E ) B ) = { <. f , p >. | th } ) $.
    $( If a binary relation holds for the result of an operation which is a
       result of an operation, the involved classes are sets.  (Contributed by
       Alexander van der Vekens, 12-Dec-2017.) $)
    bropopvvv $p |- ( F ( A ( V O E ) B ) P -> ( ( V e. _V /\ E e. _V )
      /\ ( F e. _V /\ P e. _V ) /\ ( A e. V /\ B e. V ) ) ) $=
      ( wcel vc co wbr cvv wa w3a cop wi df-br c0 wne cdm ne0i cfv df-ov syl5eq
      wn ndmfv necon1ai copab cmpt2 cv wceq simpl opabbidv mpt2eq123dv ovmpt2ga
      dmeqd eleq2d coprab cxp dmoprabss sseli opelxp breqd anim2i adantr sylbid
      brabv com23 a1d reldmmpt2 ovprc fveq1 0fv syl6eq df-ne pm2.21 sylbi com12
      ex 3syl pm2.61i pm2.43i anc2ri df-3an syl6ibr df-mpt2 dmeqi eleq2s syl6bi
      syl w3o 3ianor wo df-3or ianor dm0 eleq2i syl6bb noel pm2.21i sylbir anor
      id ancri mpt2exga pm2.24d imp jaoi jaoi2 ) KGEFMJLUBZUBZUCZMUDTZJUDTZUEZK
      UDTGUDTUEZEMTFMTUEZUFZYDKGUGZYCTZYDYJUHZKGYCUIZYLYCUJUKZEFUGZYBULZTZYMYCY
      KUMZYRYCUJYRUQYCYPYBUNZUJEFYBUOZYPYBURUPUSYEYFOPMMBINUTZVAZUDTZUFZYRYMUHZ
      UUEYRYPUUCULZTYMUUEYQUUGYPUUEYBUUCDHMJUDUDOPDVBZUUHAINUTZVAZUUCLUDUUHMVCZ
      HVBJVCZUEZOPUUHUUHUUIMMUUBUUKUULVDZUUNUUMABINRVEVFQVGVHVIYMYPOVBMTPVBMTUE
      UAVBUUBVCZUEOPUAVJZULZUUGYPUUQTYPMMVKZTZYMUUQUURYPUUOOPUAMMVLVMUUSYIYMEFM
      MVNYIYDYGYHUEZYIUEYJYIYDUUTYDYIUUTYDYIUUTUHZYDYLYDUVAUHZYNYLYOUVBYSYGYOUV
      BUHZYGUVBYOYGYIYDUUTYGYIYDUUTUHYGYIUEZYDKGCINUTZUCZUUTUVDYCUVEKGSVOYGUVFU
      UTUHYIYGUVFUUTUVFYHYGCINKGVSVPWKVQVRWKVTWAYGUQZYBUJVCZYCUJVCZUVCMJLDHUDUD
      UUJLQWBWCZUVHYCYPUJUNZUJUVHYCYTUVKUUAYPYBUJWDUPYPWEWFYOUVIUVBYOUVIUQUVIUV
      BUHYCUJWGUVIUVBWHWIWJWLWMXBWIWNWJWOYGYHYIWPWQWIXBUUCUUPOPUAMMUUBWRWSWTXAU
      UEUQYEUQZYFUQZUUDUQZXCZUUFYEYFUUDXDUVOUVLUVMXEZUVNXEUUFUVLUVMUVNXFUVPUUFU
      VNUVPUUFUVPUQZUVNUEUVPUVGUUFYEYFXGUVGYRYPUJTZYMUVGYRYPUJULZTUVRUVGYQUVSYP
      UVGYBUJUVJVHVIUVSUJYPXHXIXJUVRYMYPXKXLXAXMUVQUVNUUFUVQYGUVNUUFUHYEYFXNYGU
      UDUUFYGYEYEUEZUUDYEUVTYFYEYEYEXOXPVQOPMMUUBUDUDXQXBXRXMXSXTYAWIWIWMWLWIWN
      $.
  $}

  ${
    $d w x z $.  $d w y z $.  $d w z B $.  $d w z C $.
    $( A mapping operation with empty domain.  (Contributed by Stefan O'Rear,
       29-Jan-2015.)  (Revised by Mario Carneiro, 15-May-2015.) $)
    mpt20 $p |- ( x e. (/) , y e. B |-> C ) = (/) $=
      ( vz vw c0 cmpt2 cv wcel wa wceq coprab cop wex cab df-mpt2 df-oprab noel
      nex simprll mto abf 3eqtri ) ABGCDHAIZGJZBIZCJZKEIZDLZKZABEMFIUEUGNUINLZU
      KKZEOZBOZAOZFPGABEGCDQUKABEFRUPFUOAUNBUMEUMUFUESULUFUHUJUAUBTTTUCUD $.
  $}

  ${
    $d u v x y z A $.  $d u v y z B $.  $d u v z C $.  $d u v x y z X $.
    ovmptss.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( If all the values of the mapping are subsets of a class ` X ` , then so
       is any evaluation of the mapping.  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    ovmptss $p |- ( A. x e. A A. y e. B C C_ X -> ( E F G ) C_ X ) $=
      ( vz vu vv cv cfv csb wss wral sseq1d nfcv c1st c2nd csn cxp cop co cmpt2
      ciun cmpt mpt2mptsx eqtri fvmptss wceq vex op1std csbeq1d op2ndd csbeq2dv
      eqtrd raliunxp nfcsb1v nfxp sneq csbeq1a xpeq12d cbviun raleqi nfss nfral
      weq nfv cbvral raleqbidv syl5bb 3bitr4ri df-ov sseq1i 3imtr4i ) AKNZUAOZB
      VSUBOZEPZPZIQZKACANZUCZDUDZUHZRZFHUEZGOZIQEIQZBDRZACRZFHGUFZIQKWHWCIWJGGA
      BCDEUGKWHWCUIJABKCDEUJUKULWDKLCLNZUCZAWPDPZUDZUHZRAWPBMNZEPZPZIQZMWRRZLCR
      WIWNWDXDKLMCWRVSWPXAUEUMZWCXCIXFWCAWPWBPXCXFAVTWPWBWPXAVSLUNZMUNZUOUPXFAW
      PWBXBXFBWAXAEWPXAVSXGXHUQUPURUSSUTWDKWHWTALCWGWSLWGTAWQWRAWQTAWPDVAZVBALV
      JZWFWQDWRWEWPVCAWPDVDZVEVFVGWMXEALCWMLVKXDAMWRXIAXCIAWPXBVAAITVHVIWMXBIQZ
      MDRXJXEWLXLBMDWLMVKBXBIBXAEVABITVHBMVJEXBIBXAEVDSVLXJXLXDMDWRXKXJXBXCIAWP
      XBVDSVMVNVLVOWOWKIFHGVPVQVR $.
  $}

  ${
    $d t u v w x y z $.  $d t u v y B $.  $d t C $.  $d t D $.  $d t u v ph $.
    $d t u v x y A $.
    relmpt2opab.1 $e |- F = ( x e. A , y e. B |-> { <. z , w >. | ph } ) $.
    $( Any function to sets of ordered pairs produces a relation on function
       value unconditionally.  (Contributed by Mario Carneiro, 9-Feb-2015.) $)
    relmpt2opab $p |- Rel ( C F D ) $=
      ( co wrel cvv cxp wss copab wral relopab df-rel mpbi rgen2w ovmptss ax-mp
      mpbir ) HIJLZMUFNNOZPZADEQZUGPZCGRBFRUHUJBCFGUIMUJADESUITUAUBBCFGUIHJIUGK
      UCUDUFTUE $.
  $}

  ${
    $d t u v w x y B $.  $d t u w x y z C $.  $d x y ph $.  $d t u v w x y S $.
    $d u v w x y A $.  $d t u v w z R $.  $d t z T $.
    fmpt2co.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> R e. C ) $.
    fmpt2co.2 $e |- ( ph -> F = ( x e. A , y e. B |-> R ) ) $.
    fmpt2co.3 $e |- ( ph -> G = ( z e. C |-> S ) ) $.
    fmpt2co.4 $e |- ( z = R -> S = T ) $.
    $( Composition of two functions.  Variation of ~ fmptco when the second
       function has two arguments.  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    fmpt2co $p |- ( ph -> ( G o. F ) = ( x e. A , y e. B |-> T ) ) $=
      ( vw vu vv csb ccom cxp cv c2nd c1st cmpt cmpt2 wcel wral ralrimivva eqid
      cfv wf fmpt2 sylib nfcv nfcsb1v weq csbeq1a sylan9eq cbvmpt2 cop wceq vex
      nfcsb op2ndd csbeq1d op1std csbeq2dv mpt2mpt eqtr4i sylibr syl6eq fmptcos
      eqtrd fmpt wa w3a 3impb nfcvd csbiegf syl mpt2eq3dva syl5eq ) ALKUAQEFUBZ
      DCQUCZUDULZBWFUEULZHTZTZITZUFZBCEFJUGZAQDWEGWJIKLAWEGBCEFHUGZUMZWJGUHQWEU
      IAHGUHZCFUIBEUIWOAWPBCEFMUJBCEFHGWNWNUKUNUOQWEGWJWNWNRSEFCSUCZBRUCZHTZTZU
      GQWEWJUFZBCRSEFHWTRHUPSHUPBCWQWSBWQUPBWRHUQVEZCWQWSUQZBRURZCSURZHWSWTBWRH
      USCWQWSUSUTZVARSQEFWJWTWFWRWQVBVCZWJCWQWITWTXGCWGWQWIWRWQWFRVDZSVDZVFVGXG
      CWQWIWSXGBWHWRHWRWQWFXHXIVHVGVIVOZVJVKZVPVLAKWNXANXKVMOVNAWLBCEFDHITZUGZW
      MWLRSEFDWTITZUGXMRSQEFWKXNXGDWJWTIXJVGVJBCRSEFXLXNRXLUPSXLUPBDWTIXBBIUPVE
      CDWTIXCCIUPVEXDXEVQDHWTIXFVGVAVKABCEFXLJABUCEUHZCUCFUHZVRWPXLJVCAXOXPWPMV
      SDHIJGWPDJVTPWAWBWCWDVO $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y z D $.  $d w x y z H $.
    $d w z C $.
    oprabco.1 $e |- ( ( x e. A /\ y e. B ) -> C e. D ) $.
    oprabco.2 $e |- F = ( x e. A , y e. B |-> C ) $.
    oprabco.3 $e |- G = ( x e. A , y e. B |-> ( H ` C ) ) $.
    $( Composition of a function with an operator abstraction.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       26-Sep-2015.) $)
    oprabco $p |- ( H Fn D -> G = ( H o. F ) ) $=
      ( vz wfn ccom cfv cmpt2 cv wcel wceq adantl a1i cmpt dffn5 biimpi fmpt2co
      wa fveq2 syl6reqr ) IFNZIGOABCDEIPZQHUJABMCDFEMRZIPZUKGIARCSBRDSUGEFSUJJU
      AGABCDEQTUJKUBUJIMFUMUCTMFIUDUEULEIUHUFLUI $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w z C $.  $d w z D $.  $d w x y z M $.
    $d x y z R $.  $d x y z S $.
    oprab2co.1 $e |- ( ( x e. A /\ y e. B ) -> C e. R ) $.
    oprab2co.2 $e |- ( ( x e. A /\ y e. B ) -> D e. S ) $.
    oprab2co.3 $e |- F = ( x e. A , y e. B |-> <. C , D >. ) $.
    oprab2co.4 $e |- G = ( x e. A , y e. B |-> ( C M D ) ) $.
    $( Composition of operator abstractions.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by David Abernethy, 23-Apr-2013.) $)
    oprab2co $p |- ( M Fn ( R X. S ) -> G = ( M o. F ) ) $=
      ( cop cxp cv wcel cmpt2 wa opelxpi syl2anc cfv wceq df-ov mpt2eq3ia eqtri
      co a1i oprabco ) ABCDEFPZGHQZIJKARCSBRDSUAZEGSFHSULUMSLMEFGHUBUCNJABCDEFK
      UIZTABCDULKUDZTOABCDUOUPUOUPUEUNEFKUFUJUGUHUK $.
  $}

  ${
    $d w x y z $.
    $( An alternate possible definition of the ` 1st ` function.  (Contributed
       by NM, 14-Oct-2004.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    df1st2 $p |- { <. <. x , y >. , z >. | z = x } = ( 1st |` ( _V X. _V ) ) $=
      ( vw c1st cvv cxp cres cv cfv wceq copab wcel wa coprab wfn wfo fo1st vex
      cmpt fofn ax-mp dffn5 mpbi mptv eqtri reseq1i resopab cop op1std dfoprab3
      eqeq2d 3eqtrri ) EFFGZHCIZDIZEJZKZDCLZUNHUPUNMURNDCLUOAIZKZABCOEUSUNEDFUQ
      TZUSEFPZEVBKFFEQVCRFFEUAUBDFEUCUDDCUQUEUFUGURDCUNUHURVAABCDUPUTBIZUIKUQUT
      UOUTVDUPASBSUJULUKUM $.

    $( An alternate possible definition of the ` 2nd ` function.  (Contributed
       by NM, 10-Aug-2006.)  (Revised by Mario Carneiro, 31-Aug-2015.) $)
    df2nd2 $p |- { <. <. x , y >. , z >. | z = y } = ( 2nd |` ( _V X. _V ) ) $=
      ( vw c2nd cvv cxp cres cv cfv wceq copab wcel wa coprab wfn wfo fo2nd vex
      cmpt fofn ax-mp dffn5 mpbi mptv eqtri reseq1i resopab cop op2ndd dfoprab3
      eqeq2d 3eqtrri ) EFFGZHCIZDIZEJZKZDCLZUNHUPUNMURNDCLUOBIZKZABCOEUSUNEDFUQ
      TZUSEFPZEVBKFFEQVCRFFEUAUBDFEUCUDDCUQUEUFUGURDCUNUHURVAABCDUPAIZUTUIKUQUT
      UOVDUTUPASBSUJULUKUM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y V $.
    $( The mapping of a restriction of the ` 1st ` function to a constant
       function.  (Contributed by NM, 14-Dec-2008.) $)
    1stconst $p |- ( B e. V ->
             ( 1st |` ( A X. { B } ) ) : ( A X. { B } ) -1-1-onto-> A ) $=
      ( vx vy wcel csn cxp c1st wfo cv wbr wmo wceq wa vex cfv cvv jca syl2anc
      cres ccnv wfun wf1o c0 wne snnzg fo1stres syl wal cop moeq moani brres wb
      wfn fo1st fofn ax-mp fnbrfvb mp2an anbi1i c2nd elxp7 eleq1 biimpa adantrr
      adantrl elsni sylanr2 adantrrl sylan2b adantl simprr fveq2d simprl op1stg
      eqopi an12s simpl eqtrd snidg adantr opelxpi eqeltrd syl5bb mobidv mpbiri
      impbida syl5bbr alrimiv funcnv2 sylibr dff1o3 sylanbrc ) BCFZABGZHZAIWRUA
      ZJZWSUBUCZWRAWSUDWPWQUEUFWTBCUGAWQUHUIWPDKZEKZWSLZDMZEUJXAWPXEEWPXEXCAFZX
      BXCBUKZNZOZDMXHXFDDXGULUMWPXDXIDXDXBXCILZXBWRFZOZWPXIXBXCIWREPUNXLXBIQZXC
      NZXKOZWPXIXNXJXKIRUPZXBRFXNXJUORRIJXPUQRRIURUSDPRXBXCIUTVAVBWPXOXIXOXIWPX
      KXNXBRRHFZXMAFZXBVCQZWQFZOZOZXIXBAWQVDXNYBOXFXHXNYAXFXQXNXRXFXTXNXRXFXMXC
      AVEVFVGVHXNXQXTXHXRXTXNXQXSBNZXHXSBVIXQXNYCXHXBXCBRRVRVSVJVKSVLVMWPXIOZXN
      XKYDXMXGIQZXCYDXBXGIWPXFXHVNZVOYDXFWPYEXCNWPXFXHVPZWPXIVTXCBACVQTWAYDXBXG
      WRYFYDXFBWQFZXGWRFYGWPYHXIBCWBWCXCBAWQWDTWESWIWJWFWGWHWKDEWSWLWMWRAWSWNWO
      $.

    $( The mapping of a restriction of the ` 2nd ` function to a converse
       constant function.  (Contributed by NM, 27-Mar-2008.) $)
    2ndconst $p |- ( A e. V ->
             ( 2nd |` ( { A } X. B ) ) : ( { A } X. B ) -1-1-onto-> B ) $=
      ( vx vy wcel csn cxp c2nd wfo cv wbr wmo wceq wa vex cfv cvv adantrl jca
      cres ccnv wfun wf1o c0 wne snnzg fo2ndres syl wal cop moeq moani brres wb
      fo2nd fofn ax-mp fnbrfvb mp2an anbi1i c1st elxp7 eleq1 biimpa elsni eqopi
      wfn ancom2s an12s sylanr2 adantrrr sylan2b adantl op2ndg sylan9eqr simprr
      fveq2 adantr simprl opelxpi syl2anc eqeltrd impbida syl5bbr syl5bb mobidv
      mpan2 snidg mpbiri alrimiv funcnv2 sylibr dff1o3 sylanbrc ) ACFZAGZBHZBIW
      RUAZJZWSUBUCZWRBWSUDWPWQUEUFWTACUGWQBUHUIWPDKZEKZWSLZDMZEUJXAWPXEEWPXEXCB
      FZXBAXCUKZNZOZDMXHXFDDXGULUMWPXDXIDXDXBXCILZXBWRFZOZWPXIXBXCIWREPZUNXLXBI
      QZXCNZXKOZWPXIXOXJXKIRVHZXBRFXOXJUORRIJXQUPRRIUQURDPRXBXCIUSUTVAWPXPXIXPX
      IWPXKXOXBRRHFZXBVBQZWQFZXNBFZOZOZXIXBWQBVCXOYCOXFXHXOYBXFXRXOYAXFXTXOYAXF
      XNXCBVDVESSXOXRXTXHYAXTXOXRXSANZXHXSAVFXRXOYDXHXRYDXOXHXBAXCRRVGVIVJVKVLT
      VMVNWPXIOZXOXKWPXHXOXFXHWPXNXGIQZXCXBXGIVRWPXCRFYFXCNXMAXCCRVOWHVPSYEXBXG
      WRWPXFXHVQYEAWQFZXFXGWRFWPYGXIACWIVSWPXFXHVTAXCWQBWAWBWCTWDWEWFWGWJWKDEWS
      WLWMWRBWSWNWO $.
  $}

  ${
    $d v w x y A $.  $d v w x y B $.  $d v w C $.
    dfmpt2.1 $e |- C e. _V $.
    $( Alternate definition for the "maps to" notation ~ df-mpt2 (although it
       requires that ` C ` be a set).  (Contributed by NM, 19-Dec-2008.)
       (Revised by Mario Carneiro, 31-Aug-2015.) $)
    dfmpt2 $p |- ( x e. A , y e. B |-> C )
                = U_ x e. A U_ y e. B { <. <. x , y >. , C >. } $=
      ( vw cmpt2 cxp cv cfv csb cop csn ciun csbex nfcv nfcsb1v nfop nfsn dfmpt
      c1st c2nd cmpt mpt2mpts nfcsb wceq csbopeq1a opeq12d sneqd iunxpf 3eqtri
      id ) ABCDEHGCDIZAGJZUBKZBUOUCKZELZLZUDGUNUOUSMZNZOACBDAJBJMZEMZNZOOABGCDE
      UEGUNUSAUPURBUQEFPPUAGABCDVAVDAUTAUOUSAUOQAUPURRSTBUTBUOUSBUOQBAUPURBUPQB
      UQERUFSTGVDQUOVBUGZUTVCVEUOVBUSEVEUMABUOEUHUIUJUKUL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x F $.  $d x G $.
    curry1.1 $e |- G = ( F o. `' ( 2nd |` ( { C } X. _V ) ) ) $.
    $( Composition with ` ``' ( 2nd |`` ( { C } X. _V ) ) ` turns any binary
       operation ` F ` with a constant first operand into a function ` G ` of
       the second operand only.  This transformation is called "currying."
       (Contributed by NM, 28-Mar-2008.)  (Revised by Mario Carneiro,
       26-Dec-2014.) $)
    curry1 $p |- ( ( F Fn ( A X. B ) /\ C e. A ) ->
                 G = ( x e. B |-> ( C F x ) ) ) $=
      ( cxp wfn wcel wa cfv wceq c2nd cvv cres adantr cin syl5eq eqtrd cmpt csn
      cv co ccnv ccom wfun cdm fnfun wf1o 2ndconst wfo dff1o3 simprbi syl funco
      syl2an cima dmco fndm crn imacnvcnv df-ima resres rneqi 3eqtri inxp incom
      imaeq2d inv1 eqtri xpeq2i wss snssi df-ss sylib xpeq1d reseq2d rneqd forn
      f1ofo adantl fneq1i df-fn bitri sylanbrc dffn5 fveq1i dff1o4 simprd fvco2
      3syl vex mpan2 ad2antlr cop snidg jctir opelxp sylibr jca op2ndg f1ocnvfv
      fvres sylc fveq2d adantll df-ov syl6eqr mpteq2dva ) EBCHZIZDBJZKZFACAUCZF
      LZUAZACDXOEUDZUAXNFCIZFXQMXNENDUBZOHZPZUEZUFZUGZYDUHZCMZXSXLEUGYCUGZYEXMX
      KEUIXMYAOYBUJZYHDOBUKZYIYAOYBULYHYAOYBUMUNUOEYCUPUQXNYFYCUEZEUHZURZCEYCUS
      XNYMYKXKURZCXNYLXKYKXLYLXKMXMXKEUTQVIXMYNCMXLXMYNNYAXKRZPZVAZCYNYBXKURYBX
      KPZVAYQYBXKVBYBXKVCYRYPNYAXKVDVEVFXMYQNXTCHZPZVAZCXMYPYTXMYOYSNXMYOXTBRZC
      HZYSYOUUBOCRZHUUCXTOBCVGUUDCUUBUUDCORCOCVHCVJVKVLVKXMUUBXTCXMXTBVMUUBXTMD
      BVNXTBVOVPVQSVRVSXMYSCYTUJYSCYTULUUACMDCBUKYSCYTWAYSCYTVTWLTSWBTSXSYDCIYE
      YGKCFYDGWCYDCWDWEWFACFWGVPXNACXPXRXNXOCJZKZXPXOYCLZELZXRUUFXPXOYDLZUUHXOF
      YDGWHXMUUIUUHMZXLUUEXMYCOIZUUJXMYBYAIZUUKXMYIUULUUKKYJYAOYBWIVPWJUUKXOOJZ
      UUJAWMZOEYCXOWKWNUOWOSUUFUUHDXOWPZELZXRXMUUEUUHUUPMXLXMUUEKZUUGUUOEUUQYIU
      UOYAJZKUUOYBLZXOMZUUGUUOMUUQYIUURXMYIUUEYJQXMUURUUEXMDXTJZUUMKUURXMUVAUUM
      DBWQUUNWRDXOXTOWSWTZQXAXMUUTUUEXMUUSUUONLZXOXMUURUUSUVCMUVBUUOYANXDUOXMUU
      MUVCXOMUUNDXOBOXBWNTQYAOUUOXOYBXCXEXFXGDXOEXHXITXJT $.

    $( The value of a curried function with a constant first argument.
       (Contributed by NM, 28-Mar-2008.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    curry1val $p |- ( ( F Fn ( A X. B ) /\ C e. A ) ->
        ( G ` D ) = ( C F D ) ) $=
      ( vx cxp wfn wcel wa cfv cv co wceq wn c0 cdm con3i curry1 fveq1d dmmptss
      cmpt eqid sseli ndmfv adantl fndm adantr simpr ndmovg syl2an eqtr4d oveq2
      syl ex ovex fvmpt pm2.61d2 eqtrd ) EABIZJZCAKZLZDFMDHBCHNZEOZUDZMZCDEOZVE
      DFVHHABCEFGUAUBVEDBKZVIVJPZVEVKQZVLVEVMLVIRVJVMVIRPZVEVMDVHSZKZQVNVPVKVOB
      DHBVGVHVHUEZUCUFTDVHUGUPUHVEESVBPZVDVKLZQVJRPVMVCVRVDVBEUIUJVSVKVDVKUKTCD
      ABEULUMUNUQHDVGVJBVHVFDCEUOVQCDEURUSUTVA $.

    $( Functionality of a curried function with a constant first argument.
       (Contributed by NM, 29-Mar-2008.) $)
    curry1f $p |- ( ( F : ( A X. B ) --> D /\ C e. A ) ->
                 G : B --> D ) $=
      ( vx cxp wf wcel wa cv co cmpt fovrn 3expa eqid fmptd wfn wceq ffn curry1
      sylan feq1d mpbird ) ABIZDEJZCAKZLZBDFJBDHBCHMZENZOZJUJHBULDUMUHUIUKBKULD
      KCUKDABEPQUMRSUJBDFUMUHEUGTUIFUMUAUGDEUBHABCEFGUCUDUEUF $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x F $.  $d x G $.
    curry2.1 $e |- G = ( F o. `' ( 1st |` ( _V X. { C } ) ) ) $.
    $( Composition with ` ``' ( 1st |`` ( _V X. { C } ) ) ` turns any binary
       operation ` F ` with a constant second operand into a function ` G ` of
       the first operand only.  This transformation is called "currying."  (If
       this becomes frequently used, we can introduce a new notation for the
       hypothesis.)  (Contributed by NM, 16-Dec-2008.) $)
    curry2 $p |- ( ( F Fn ( A X. B ) /\ C e. B ) ->
                 G = ( x e. A |-> ( x F C ) ) ) $=
      ( cxp wfn wcel wa cfv wceq c1st cvv cres adantr cin syl5eq eqtrd cmpt csn
      cv co ccnv ccom wfun cdm fnfun wf1o 1stconst wfo dff1o3 simprbi syl funco
      syl2an cima dmco fndm crn imacnvcnv df-ima resres rneqi 3eqtri inxp incom
      imaeq2d inv1 eqtri xpeq1i wss snssi df-ss sylib xpeq2d reseq2d rneqd forn
      f1ofo adantl fneq1i df-fn bitri sylanbrc dffn5 fveq1i dff1o4 simprd fvco2
      3syl vex sylancl ad2antlr cop a1i snidg opelxp jca op1stg ancoms f1ocnvfv
      fvres sylc fveq2d adantll df-ov syl6eqr mpteq2dva ) EBCHZIZDCJZKZFABAUCZF
      LZUAZABXODEUDZUAXNFBIZFXQMXNENODUBZHZPZUEZUFZUGZYDUHZBMZXSXLEUGYCUGZYEXMX
      KEUIXMYAOYBUJZYHODCUKZYIYAOYBULYHYAOYBUMUNUOEYCUPUQXNYFYCUEZEUHZURZBEYCUS
      XNYMYKXKURZBXNYLXKYKXLYLXKMXMXKEUTQVIXMYNBMXLXMYNNYAXKRZPZVAZBYNYBXKURYBX
      KPZVAYQYBXKVBYBXKVCYRYPNYAXKVDVEVFXMYQNBXTHZPZVAZBXMYPYTXMYOYSNXMYOBXTCRZ
      HZYSYOOBRZUUBHUUCOXTBCVGUUDBUUBUUDBORBOBVHBVJVKVLVKXMUUBXTBXMXTCVMUUBXTMD
      CVNXTCVOVPVQSVRVSXMYSBYTUJYSBYTULUUABMBDCUKYSBYTWAYSBYTVTWLTSWBTSXSYDBIYE
      YGKBFYDGWCYDBWDWEWFABFWGVPXNABXPXRXNXOBJZKZXPXOYCLZELZXRUUFXPXOYDLZUUHXOF
      YDGWHXMUUIUUHMZXLUUEXMYCOIZXOOJZUUJXMYBYAIZUUKXMYIUUMUUKKYJYAOYBWIVPWJAWM
      ZOEYCXOWKWNWOSUUFUUHXODWPZELZXRXMUUEUUHUUPMXLXMUUEKZUUGUUOEUUQYIUUOYAJZKU
      UOYBLZXOMUUGUUOMUUQYIUURXMYIUUEYJQUUQUULDXTJZUURUULUUQUUNWQXMUUTUUEDCWRZQ
      XODOXTWSZWFWTUUQUUSUUONLZXOXMUUSUVCMZUUEXMUURUVDXMUULUUTUURUULXMUUNWQUVAU
      VBWFUUOYANXDUOQUUEXMUVCXOMXODBCXAXBTYAOUUOXOYBXCXEXFXGXODEXHXITXJT $.

    $( Functionality of a curried function with a constant second argument.
       (Contributed by NM, 16-Dec-2008.) $)
    curry2f $p |- ( ( F : ( A X. B ) --> D /\ C e. B ) ->
                 G : A --> D ) $=
      ( vx cxp wf wcel wa cv co cmpt fovrn 3com23 3expa eqid fmptd wfn wceq ffn
      curry2 sylan feq1d mpbird ) ABIZDEJZCBKZLZADFJADHAHMZCENZOZJUKHAUMDUNUIUJ
      ULAKZUMDKZUIUOUJUPULCDABEPQRUNSTUKADFUNUIEUHUAUJFUNUBUHDEUCHABCEFGUDUEUFU
      G $.

    $( The value of a curried function with a constant second argument.
       (Contributed by NM, 16-Dec-2008.) $)
    curry2val $p |- ( ( F Fn ( A X. B ) /\ C e. B ) ->
        ( G ` D ) = ( D F C ) ) $=
      ( vx cxp wfn wcel wa cfv cv co wceq wn c0 cdm con3i cmpt curry2 fveq1d wi
      eqid dmmptss sseli ndmfv adantl fndm simpl ndmovg syl2an eqtr4d ex adantr
      syl oveq1 ovex fvmpt pm2.61d2 eqtrd ) EABIZJZCBKZLZDFMDHAHNZCEOZUAZMZDCEO
      ZVFDFVIHABCEFGUBUCVFDAKZVJVKPZVDVLQZVMUDVEVDVNVMVDVNLVJRVKVNVJRPZVDVNDVIS
      ZKZQVOVQVLVPADHAVHVIVIUEZUFUGTDVIUHUQUIVDESVCPVLVELZQVKRPVNVCEUJVSVLVLVEU
      KTDCABEULUMUNUOUPHDVHVKAVIVGDCEURVRDCEUSUTVAVB $.
  $}

  $( Lemma for ~ cnvf1o .  (Contributed by Mario Carneiro, 27-Apr-2014.) $)
  cnvf1olem $p |- ( ( Rel A /\ ( B e. A /\ C = U. `' { B } ) ) ->
                    ( C e. `' A /\ B = U. `' { C } ) ) $=
    ( wrel wcel csn ccnv cuni wceq c2nd cfv c1st cop simprr sneqd cnveqd unieqd
    wa opswap fvex 1st2nd adantrr syl6eq simprl eqeltrrd opelcnv sylibr eqeltrd
    eqtrd eqcomi 3eqtr4a jca ) ADZBAEZCBFZGZHZIZRRZCAGZEBCFZGZHZIUSCBJKZBLKZMZU
    TUSCVEVDMZFZGZHZVFUSCUQVJUMUNURNUSUPVIUSUOVHUSBVGUMUNBVGIURBAUAUBZOPQUIVEVD
    SUCZUSVGAEVFUTEUSBVGAVKUMUNURUDUEVDVEABJTBLTUFUGUHUSVGVFFZGZHZBVCVOVGVDVESU
    JVKUSVBVNUSVAVMUSCVFVLOPQUKUL $.

  ${
    $d x y A $.
    $( Describe a function that maps the elements of a set to its converse
       bijectively.  (Contributed by Mario Carneiro, 27-Apr-2014.) $)
    cnvf1o $p |- ( Rel A ->
                   ( x e. A |-> U. `' { x } ) : A -1-1-onto-> `' A ) $=
      ( vy wrel ccnv cv csn cuni cmpt cvv eqid wcel wa snex cnvex a1i cnvf1olem
      uniex wceq wb relcnv simpr sylancr dfrel2 eleq2 sylbi anbi1d adantr mpbid
      impbida f1od ) BDZACBBEZAFZGZEZHZCFZGZEZHZABUQIZJJVBKUQJLULUNBLZMUPUOUNNO
      RPVAJLULURUMLZMUTUSURNORPULVCURUQSZMZVDUNVASMZBUNURQULVGMZUNUMEZLZVEMZVFV
      HUMDVGVKBUAULVGUBUMURUNQUCULVKVFTVGULVJVCVEULVIBSVJVCTBUDVIBUNUEUFUGUHUIU
      JUK $.
  $}

  ${
    $d x A $.  $d y B $.  $d v w x y z F $.  $d v w x y z G $.
    $d s t u v w x y z $.
    $( Lemma for ~ fpar .  (Contributed by NM, 22-Dec-2008.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    fparlem1 $p |- ( `' ( 1st |` ( _V X. _V ) ) " { x } ) = ( { x } X. _V ) $=
      ( vy c1st cvv cxp cres ccnv cv csn cima wcel cfv wceq wa fvres eqeq1d vex
      c2nd elsnc2 fvex biantru bitr3i syl6bb pm5.32i wf wfn wb f1stres fniniseg
      ffn mp2b elxp7 3bitr4i eqriv ) BCDDEZFZGAHZIZJZURDEZBHZUOKZVAUPLZUQMZNZVB
      VACLZURKZVARLDKZNZNVAUSKZVAUTKVBVDVIVBVDVFUQMZVIVBVCVFUQVAUOCOPVKVGVIVFUQ
      AQSVHVGVARTUAUBUCUDUODUPUEUPUOUFVJVEUGDDUHUODUPUJUOUQVAUPUIUKVAURDULUMUN
      $.

    $( Lemma for ~ fpar .  (Contributed by NM, 22-Dec-2008.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    fparlem2 $p |- ( `' ( 2nd |` ( _V X. _V ) ) " { y } ) = ( _V X. { y } ) $=
      ( vx c2nd cvv cxp cres ccnv cv csn cima wcel cfv wceq wa fvres eqeq1d vex
      c1st elsnc2 fvex biantrur bitr3i syl6bb pm5.32i wfn f2ndres fniniseg mp2b
      wf wb ffn elxp7 3bitr4i eqriv ) BCDDEZFZGAHZIZJZDUREZBHZUOKZVAUPLZUQMZNZV
      BVARLDKZVACLZURKZNZNVAUSKZVAUTKVBVDVIVBVDVGUQMZVIVBVCVGUQVAUOCOPVKVHVIVGU
      QAQSVFVHVARTUAUBUCUDUODUPUIUPUOUEVJVEUJDDUFUODUPUKUOUQVAUPUGUHVADURULUMUN
      $.

    $( Lemma for ~ fpar .  (Contributed by NM, 22-Dec-2008.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    fparlem3 $p |- ( F Fn A
          -> ( `' ( 1st |` ( _V X. _V ) ) o. ( F o. ( 1st |` ( _V X. _V ) ) ) )
            = U_ x e. A ( ( { x } X. _V ) X. ( { ( F ` x ) } X. _V ) ) ) $=
      ( vy cvv cxp cres ccnv cv csn cima ciun ccom cdm crn cin wceq ax-mp eqtri
      wss wfn c1st cfv coiun inss1 fndm syl5sseq dfco2a syl coeq2d dmxpss sstri
      wcel wa fvex fparlem1 sneq xpeq1d syl5eq imaeq2d df-ima xpssres rneqi wne
      ssid c0 snnz rnxp syl6eq xpeq12d iunxsn cnveqi cnvco cnvxp 3eqtr3i xpeq2i
      fnsnfv syl5eqr cnveqd iuneq2dv 3eqtr4a ) CBUAZUBEEFGZHZABWDAIZJZKZCWFKZFZ
      LZMABWDWIMZLWDCWCMZMABWFEFZWECUCZJZEFZFZLAWDWIBUDWBWLWJWDWBCNZWCOZPZBTWLW
      JQWBWRWTBWRWSUEBCUFUGACWCBUHUIUJWBABWQWKWBWEBUMUNZWQWDWOWMFZHZMZWKXBWCMZH
      WPWMFZHXDWQXEXFXEDWOWDDIZJZKZXBXHKZFZLZXFXBNZWSPZWOTXEXLQXNXMWOXMWSUEWOWM
      UKULDXBWCWOUHRDWNXKXFWECUOZXGWNQZXIWPXJWMXPXIXHEFWPDUPXPXHWOEXGWNUQZURUSX
      PXJXBWOKZWMXPXHWOXBXQUTXRXBWOGZOZWMXBWOVAXTXBOZWMXSXBWOWOTXSXBQWOVEWOWMWO
      VBRVCWOVFVDYAWMQWNXOVGWOWMVHRSSVIVJVKSVLXBWCVMWPWMVNVOXAXCWIWDXAXCWHWGFZH
      WIXAXBYBXAXBWOWGFYBWGWMWOAUPVPXAWOWHWGBWECVQURVRVSWHWGVNVIUJVRVTWA $.

    $( Lemma for ~ fpar .  (Contributed by NM, 22-Dec-2008.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    fparlem4 $p |- ( G Fn B
          -> ( `' ( 2nd |` ( _V X. _V ) ) o. ( G o. ( 2nd |` ( _V X. _V ) ) ) )
            = U_ y e. B ( ( _V X. { y } ) X. ( _V X. { ( G ` y ) } ) ) ) $=
      ( vx cvv cxp cres ccnv cv csn cima ciun ccom cdm crn cin wceq ax-mp eqtri
      wss wfn c2nd cfv coiun inss1 fndm syl5sseq dfco2a syl coeq2d dmxpss sstri
      wcel wa fvex fparlem2 sneq xpeq2d syl5eq imaeq2d df-ima xpssres rneqi wne
      ssid c0 snnz rnxp syl6eq xpeq12d iunxsn cnveqi cnvco cnvxp 3eqtr3i xpeq2i
      fnsnfv xpeq1d syl5eqr cnveqd iuneq2dv 3eqtr4a ) CBUAZUBEEFGZHZABWEAIZJZKZ
      CWGKZFZLZMABWEWJMZLWECWDMZMABEWGFZEWFCUCZJZFZFZLAWEWJBUDWCWMWKWEWCCNZWDOZ
      PZBTWMWKQWCWSXABWSWTUEBCUFUGACWDBUHUIUJWCABWRWLWCWFBUMUNZWRWEWPWNFZHZMZWL
      XCWDMZHWQWNFZHXEWRXFXGXFDWPWEDIZJZKZXCXIKZFZLZXGXCNZWTPZWPTXFXMQXOXNWPXNW
      TUEWPWNUKULDXCWDWPUHRDWOXLXGWFCUOZXHWOQZXJWQXKWNXQXJEXIFWQDUPXQXIWPEXHWOU
      QZURUSXQXKXCWPKZWNXQXIWPXCXRUTXSXCWPGZOZWNXCWPVAYAXCOZWNXTXCWPWPTXTXCQWPV
      EWPWNWPVBRVCWPVFVDYBWNQWOXPVGWPWNVHRSSVIVJVKSVLXCWDVMWQWNVNVOXBXDWJWEXBXD
      WIWHFZHWJXBXCYCXBXCWPWHFYCWHWNWPAUPVPXBWPWIWHBWFCVQVRVSVTWIWHVNVIUJVSWAWB
      $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z G $.
    fpar.1 $e |- H = ( ( `' ( 1st |` ( _V X. _V ) )
                        o. ( F o. ( 1st |` ( _V X. _V ) ) ) )
                i^i ( `' ( 2nd |` ( _V X. _V ) )
                       o. ( G o. ( 2nd |` ( _V X. _V ) ) ) ) ) $.
    $( Merge two functions in parallel.  Use as the second argument of a
       composition with a (2-place) operation to build compound operations such
       as ` z = ( ( sqr `` x ) + ( abs `` y ) ) ` .  (Contributed by NM,
       17-Sep-2007.)  (Proof shortened by Mario Carneiro, 28-Apr-2015.) $)
    fpar $p |- ( ( F Fn A /\ G Fn B )
       -> H = ( x e. A , y e. B |-> <. ( F ` x ) , ( G ` y ) >. ) ) $=
      ( cvv cxp ccom cin csn ciun cop inxp inv1 xpeq12i xpsn 3eqtri wfn wa c1st
      cres ccnv c2nd cv cmpt2 fparlem3 fparlem4 ineqan12d opex dfmpt2 wceq wcel
      cfv incom eqtri vex fvex a1i iuneq2i 2iunin 3eqtr2i 3eqtr4g ) ECUAZFDUAZU
      BUCIIJZUDZUEEVIKKZUFVHUDZUEFVKKKZLACAUGZMZIJZVMEUPZMZIJZJZNZBDIBUGZMZJZIW
      AFUPZMZJZJZNZLZGABCDVPWDOZUHZVFVGVJVTVLWHACEUIBDFUJUKHWKACBDVMWAOZWJOMZNZ
      NACBDVSWGLZNZNWIABCDWJVPWDULZUMACWPWNWPWNUNVMCUOBDWOWMWOWMUNWADUOWOVOWCLZ
      VRWFLZJWLMZWJMZJWMVOVRWCWFPWRWTWSXAWRVNILZIWBLZJVNWBJWTVNIIWBPXBVNXCWBVNQ
      XCWBILWBIWBUQWBQURRVMWAAUSBUSSTWSVQILZIWELZJVQWEJXAVQIIWEPXDVQXEWEVQQXEWE
      ILWEIWEUQWEQURRVPWDVMEUTWAFUTSTRWLWJVMWAULWQSTVAVBVAVBABCDVSWGVCVDVE $.
  $}

  ${
    $d w x y z $.
    $( A function that can be used to feed a common value to both operands of
       an operation.  Use as the second argument of a composition with the
       function of ~ fpar in order to build compound functions such as
       ` y = ( ( sqr `` x ) + ( abs `` x ) ) ` .  (Contributed by NM,
       17-Sep-2007.) $)
    fsplit $p |- `' ( 1st |` _I ) = ( x e. _V |-> <. x , x >. ) $=
      ( vy vz cv c1st cid cres ccnv wbr copab cop wceq cvv cmpt vex wcel wa wex
      exbii bitri brcnv brres cfv 19.42v op1std eqeq1d pm5.32ri wfn wb wfo fofn
      fo1st ax-mp fnbrfvb mp2an dfid2 eleq2i nfe1 elopab biantru 3bitr4i bitr2i
      19.9 equid anbi12i 3bitr3ri id opeq12d eqeq2d ceqsexv opabbii wrel relcnv
      dfrel4v mpbi mptv 3eqtr4i ) ADZBDZEFGZHZIZABJZVSVRVRKZLZABJWAAMWDNWBWEABW
      BVSVRVTIZWEVRVSVTAOZBOZUAWFVSVREIZVSFPZQZWEVSVREFWGUBWKCDZVRLZVSWLWLKZLZQ
      ZCRZWEVSEUCZVRLZWOQZCRWSWOCRZQWQWKWSWOCUDWTWPCWOWSWMWOWRWLVRWLWLVSCOZXBUE
      UFUGSWSWIXAWJEMUHZVSMPWSWIUIMMEUJXCULMMEUKUMWHMVSVREUNUOWJVSWLWLLZCCJZPZX
      AFXEVSCUPUQWOXDQZCRZCRXHXFXAXHCXGCURVCXDCCVSUSWOXGCXDWOCVDUTSVAVBVEVFWOWE
      CVRWGWMWNWDVSWMWLVRWLVRWMVGZXIVHVIVJTTTVKWAVLWAWCLVTVMABWAVNVOABWDVPVQ $.
  $}

  $( The ` 2nd ` (second member of an ordered pair) function restricted to a
     function ` F ` is a function of ` F ` into the codomain of ` F ` .
     (Contributed by Alexander van der Vekens, 4-Feb-2018.) $)
  f2ndf $p |- ( F : A --> B -> ( 2nd |` F ) : F --> B ) $=
    ( wf c2nd cres cxp wss f2ndres fssxp fssres sylancr wceq resabs1 syl eqcomd
    feq1d mpbird ) ABCDZCBECFZDCBEABGZFZCFZDZSUABUBDCUAHZUDABIABCJZUABCUBKLSCBT
    UCSUCTSUEUCTMUFECUANOPQR $.

  ${
    $d A x y $.  $d B x y $.  $d F x y $.
    $( The ` 2nd ` (second member of an ordered pair) function restricted to a
       function ` F ` is a function of ` F ` onto the range of ` F ` .
       (Contributed by Alexander van der Vekens, 4-Feb-2018.) $)
    fo2ndf $p |- ( F : A --> B -> ( 2nd |` F ) : F -onto-> ran F ) $=
      ( vy vx wf crn c2nd cres wceq wfo wfn ffn dffn3 f2ndf syl cv wcel cfv vex
      sylib wss sylbi frn cop wex elrn2g wa fvres adantl op2nd syl6req fnfvelrn
      ibi sylan eqeltrd ex exlimdv syl5 ssrdv eqssd dffo2 sylanbrc ) ABCFZCCGZH
      CIZFZVFGZVEJCVEVFKVDAVECFZVGVDCALZVIABCMZACNZUAAVECOZPVDVHVEVDVGVHVEUBVDV
      JVGVKVJVIVGVLVMUCPCVEVFUDPVDDVEVHDQZVERZEQZVNUEZCRZEUFZVDVNVHRZVOVSEVNCVE
      UGUNVDVRVTEVDVRVTVDVRUHZVNVQVFSZVHWAWBVQHSZVNVRWBWCJVDVQCHUIUJVPVNETDTUKU
      LVDVFCLZVRWBVHRVDCBVFFWDABCOCBVFMPCVQVFUMUOUPUQURUSUTVACVEVFVBVC $.
  $}

  ${
    $d A a b v w x y $.  $d B a b v w x y $.  $d F a b v w x y $.
    $( The ` 2nd ` (second member of an ordered pair) function restricted to a
       one-to-one function ` F ` is a one-to-one function of ` F ` onto the
       range of ` F ` .  (Contributed by Alexander van der Vekens,
       4-Feb-2018.) $)
    f1o2ndf1 $p |- ( F : A -1-1-> B -> ( 2nd |` F ) : F -1-1-onto-> ran F ) $=
      ( vx vy va vv vb vw c2nd syl cv cfv wceq wi wcel wa wrex ex com23 wf1 crn
      cres wfo ccnv wfun wf1o f1f fo2ndf weq wral f2ndf cxp wss fssxp cop ssel2
      elxp2 sylib anim12dan fvres adantr ad2antlr eqeq12d op2nd eqeq12i funopfv
      wf vex f1fun anim12d eqcom biimpi eqeqan12d simpl anim12i f1veqaeq sylan2
      opeq12 syl6 com14 syl6bi pm2.43i syld impcom syl5bi sylbid adantl adantlr
      com13 com12 wb eleq1 bi2anan9 anbi2d fveq2 simpllr imbi12d imbi2d 3imtr4d
      simpr rexlimdvva rexlimivv imp mpcom ralrimivv dff13 df-f1 simprbi dff1o3
      sylanbrc ) ABCUAZCCUBZJCUCZUDZXNUEUFZCXMXNUGXLABCVHZXOABCUHZABCUIKXLCBXNU
      AZXPXLCBXNVHZDLZXNMZELZXNMZNZDEUJZOZECUKDCUKXSXLXQXTXRABCULKXLYGDECCCABUM
      ZUNZXLYACPZYCCPZQZYGOXLXQYIXRABCUOKYIYLXLYGYIYLXLYGOZYAFLZGLZUPZNZGBRFARZ
      YCHLZILZUPZNZIBRHARZQYIYLQZYMYIYJYRYKUUCYIYJQYAYHPYRCYHYAUQFGYAABURUSYIYK
      QYCYHPUUCCYHYCUQHIYCABURUSUTYRUUCUUDYMOZYQUUCUUEOZFGABYNAPZYOBPZQZYQUUFUU
      IYQQZUUBUUEHIABUUJYSAPZYTBPZQZQZUUBUUEUUNUUBQZYIYPCPZUUACPZQZQZXLYPXNMZUU
      AXNMZNZYPUUANZOZOZUUDYMUUNUUSUVEOZUUBUUIUUMUVFYQUUSUUIUUMQZUVEUURUVGUVEOY
      IUURUVGUVEUURUVGQZUVBXLUVCUVHUVBYPJMZUUAJMZNZXLUVCOZUVHUUTUVIUVAUVJUURUUT
      UVINZUVGUUPUVMUUQYPCJVAVBVBUUQUVAUVJNUUPUVGUUACJVAVCVDUVKGIUJZUVHUVLUVIYO
      UVJYTYNYOFVIGVIVEYSYTHVIIVIVEVFUVHXLUVNUVCUVGUURXLUVNUVCOZOXLUURUVGUVOXLU
      URYNCMZYONZYSCMZYTNZQZUVGUVOOXLCUFZUURUVTOABCVJUWAUUPUVQUUQUVSYNYOCVGYSYT
      CVGVKKXLUVGUVTUVOUVNUVGUVTXLUVCUVNUVGUVTUVLOOUVTUVNUVGUVNUVLUVTUVNUVPUVRN
      ZUVGUVNUVLOOUVQUVSYOUVPYTUVRUVQYOUVPNUVPYOVLVMUVSYTUVRNUVRYTVLVMVNXLUVGUV
      NUWBUVCXLUVGUVNUWBUVCOOXLUVGQZUWBUVNUVCUWCUWBFHUJZUVOUVGXLUUGUUKQUWBUWDOU
      UIUUGUUMUUKUUGUUHVOUUKUULVOVPABYNYSCVQVRUWDUVNUVCYNYOYSYTVSSVTTSWAWBWAWCW
      ATWDWJWETWFWGTSWHWKWIVBUUOYLUURYIUUNYJUUPUUBYKUUQYQYJUUPWLUUIUUMYAYPCWMVC
      YCUUACWMWNWOUUOYGUVDXLUUOYEUVBYFUVCUUNUUBYBUUTYDUVAYQYBUUTNUUIUUMYAYPXNWP
      VCYCUUAXNWPVNUUOYAYPYCUUAUUIYQUUMUUBWQUUNUUBXAVDWRWSWTSXBSXCXDXESTXEXFDEC
      BXNXGXKXSXTXPCBXNXHXIKCXMXNXJXK $.
  $}

  ${
    algrflem.1 $e |- B e. _V $.
    algrflem.2 $e |- C e. _V $.
    $( Lemma for ~ algrf and related theorems.  (Contributed by Mario Carneiro,
       28-May-2014.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    algrflem $p |- ( B ( F o. 1st ) C ) = ( F ` B ) $=
      ( c1st ccom co cop cfv df-ov cvv wf wcel wceq wfo fo1st fof ax-mp opex
      fvco3 mp2an op1st fveq2i 3eqtri ) ABCFGZHABIZUFJZUGFJZCJZACJABUFKLLFMZUGL
      NUHUJOLLFPUKQLLFRSABTLLUGCFUAUBUIACABDEUCUDUE $.
  $}

  ${
    $d A a b c s v w x y z $.  $d B a b d s v w x y z $.
    $d R a b c s v w x y $.  $d S a b d s t u v w x y $.  $d T a b s w z $.
    frxp.1 $e |- T = { <. x , y >. | ( ( x e. ( A X. B ) /\ y e. ( A X. B ) )
      /\ ( ( 1st ` x ) R ( 1st ` y ) \/
           ( ( 1st ` x ) = ( 1st ` y ) /\ ( 2nd ` x ) S ( 2nd ` y ) ) ) ) } $.
    $( A lexicographical ordering of two well-founded classes.  (Contributed by
       Scott Fenton, 17-Mar-2011.)  (Revised by Mario Carneiro, 7-Mar-2013.)
       (Proof shortened by Wolf Lammen, 4-Oct-2014.) $)
    frxp $p |- ( ( R Fr A /\ S Fr B ) -> T Fr ( A X. B ) ) $=
      ( vw vz vb wa cv c0 wbr wn wi wceq wcel wex vs vc va vv vd vt wfr cxp wss
      wne wral wrex wal cdm ssn0 xpnz biimpri simprd syl dmxp dmss sseq2 syl5ib
      vu impcom syldan wb relxp relss mpi reldm0 necon3bid biimpa jca df-fr vex
      wrel dmex sseq1 neeq1 anbi12d raleq rexeqbi1dv spcv sylbi syl5 adantr w3a
      imbi12d cop csn cima crn imassrn wo xpeq0 orcs ss0 syl6bi rn0 0ss eqsstri
      rneq syl6eqss syl6 rnxp rnss pm2.61ine syl5ss eldm elimasn bitr4i cvv cfv
      c1st c2nd breq1 notbid rspccv exp3a weq adantl syl5ibr com3l eleq1 op1std
      ex eqeq1d op2ndd breq1d mpdd ianor fveq2 anbi2d breq2d bitri df-rex exbii
      orbi12d sylibr df-br ne0i sylbir exlimiv imaexg ax-mp syl2ani 1stdm elrel
      syl5bir opeq1 eleq1d imbi1d exlimivv adantlr jcad ralrimiv sylan olc opex
      ralimi anbi1d eqeq2d xchnxbir pm4.62 anbi2i orbi2i ralbii syl6ibr reximdv
      brab ioran com23 impl expimpd 3adant3 cres resss eqid eqeq1 breq2 ralbidv
      sylcom spcev sylanb eximi excom sylib elsnres anbi1i 19.41v anass 3bitr2i
      mpan ssrexv mpsyl rexlimdv 3expib alrimiv ) CEUGZDFUGZLZUAMZCDUHZUIZUXCNU
      JZLZIMZJMZGOZPZIUXCUKZJUXCULZQZUAUMUXDGUGUXBUXNUAUXBUXGUBMZUCMZEOZPZUBUXC
      UNZUKZUCUXSULZUXMUWTUXGUYAQUXAUXGUXSCUIZUXSNUJZLZUWTUYAUXGUYBUYCUXEUXFDNU
      JZUYBUXGUXDNUJZUYEUXCUXDUOUYFCNUJZUYEUYGUYELUYFCDUPUQURUSUYEUXEUYBUYEUXDU
      NZCRZUXEUYBQCDUTUXEUXSUYHUIUYIUYBUXCUXDVAUYHCUXSVBVCUSVEVFUXEUXFUYCUXEUXC
      NUXSNUXEUXCVQZUXCNRZUXSNRVGUXEUXDVQUYJCDVHUXCUXDVIVJZUXCVKUSVLVMVNUWTUDMZ
      CUIZUYMNUJZLZUXRUBUYMUKZUCUYMULZQZUDUMUYDUYAQZUDUCUBCEVOUYSUYTUDUXSUXCUAV
      PZVRUYMUXSRZUYPUYDUYRUYAVUBUYNUYBUYOUYCUYMUXSCVSUYMUXSNVTWAUYQUXTUCUYMUXS
      UXRUBUYMUXSWBWCWIWDWEWFWGUXAUXGUYAUXMQZQUWTUXAUXEUXFVUCUXAUXEUXFWHZUXTUXM
      UCUXSVUDUXPUXSSZUXTUXMVUDVUEUXTLZUXHUXPKMZWJZGOZPZIUXCUKZKUXCUXPWKZWLZULZ
      UXMUXAUXEVUFVUNQUXFUXAUXELVUEUXTVUNUXAUXEVUEUXTVUNQZUXAUXEVUELUEMZVUGFOZP
      ZUEVUMUKZKVUMULZVUOUXEUXAVUMDUIZVUMNUJZVUTVUEUXEVUMUXCWMZDUXCVULWNUXEVVCD
      UIZQZCNCNRZUXEUYKVVDVVFUXDNRZUXEUYKQVVFDNRZVVGVVGVVFVVHWOCDWPUQWQVVGUXEUX
      CNUIUYKUXDNUXCVBUXCWRWSUSUYKVVCNWMZDUXCNXCVVINDWTDXAXBXDXEUYGUXDWMZDRZVVE
      CDXFUXEVVCVVJUIVVKVVDUXCUXDXGVVJDVVCVBVCUSXHXIVUEUXPVUGUXCOZKTVVBKUXPUXCU
      CVPZXJVVLVVBKVVLVUGVUMSZVVBVVNVUHUXCSZVVLUXCUXPVUGVVMKVPZXKZUXPVUGUXCUUAX
      LVUMVUGUUBUUCUUDWEUXAUYMDUIZUYOLZVURUEUYMUKZKUYMULZQZUDUMVVAVVBLZVUTQZUDK
      UEDFVOVWBVWDUDVUMUXCXMSVUMXMSVUAUXCVULXMUUEUUFUYMVUMRZVVSVWCVWAVUTVWEVVRV
      VAUYOVVBUYMVUMDVSUYMVUMNVTWAVVTVUSKUYMVUMVURUEUYMVUMWBWCWIWDWEUUGUXEVUTVU
      OQVUEUXEUXTVUTVUNUXEUXTVUTVUNQUXEUXTLZVUSVUKKVUMVWFVUSUXHUXDSZVUHUXDSZLZP
      ZUXHXOXNZUXPEOZPZVWKUXPRZUXHXPXNZVUGFOZPZQZLZWOZIUXCUKZVUKVWFVUSVWSIUXCUK
      ZVXAUXEUYJUXTVUSVXBQUYLUYJUXTLZVUSVXBVXCVUSLZVWSIUXCVXDUXHUXCSZVWMVWRVXCV
      XEVWMQZVUSUXTUYJVXFUXTUYJVXEVWMUYJVXELVWKUXSSUXTVWMUXHUXCUUHUXRVWMUBVWKUX
      SUXOVWKRUXQVWLUXOVWKUXPEXQXRXSWFXTVEWGUYJVUSVXEVWRQZUXTUYJVUSLZVXEUXHUFMZ
      VDMZWJZRZVDTUFTZVWRUYJVXEVXMQVUSUYJVXEVXMUFVDUXHUXCUUIYGWGVXMVXHVXEVWRVXL
      VXHVXGQUFVDVXHVXGVXLVXKUXCSZUFUCYAZVXJVUGFOZPZQZQVXOVXHVXNVXQVXHVXNVXQQVX
      OUXPVXJWJZUXCSZVXQQZVUSVYAUYJVXTVXJVUMSVUSVXQUXCUXPVXJVVMVDVPZXKVURVXQUEV
      XJVUMUEVDYAVUQVXPVUPVXJVUGFXQXRXSUUJYBVXOVXNVXTVXQVXOVXKVXSUXCVXIUXPVXJUU
      KUULUUMYCYDVXLVXEVXNVWRVXRUXHVXKUXCYEVXLVWNVXOVWQVXQVXLVWKVXIUXPVXIVXJUXH
      UFVPZVYBYFYHVXLVWPVXPVXLVWOVXJVUGFVXIVXJUXHVYCVYBYIYJXRWIWIYCUUNYDYKUUOUU
      PUUQYGUURVWSVWTIUXCVWSVWJUUSUVAXEVUJVWTIUXCVUJVWJVWLVWNVWPLZWOZPZWOZVWTVW
      IVYELZVYGVUIVWIVYEYLAMZUXDSZBMZUXDSZLZVYIXOXNZVYKXOXNZEOZVYNVYORZVYIXPXNZ
      VYKXPXNZFOZLZWOZLVWGVYLLZVWKVYOEOZVWKVYORZVWOVYSFOZLZWOZLVYHABUXHVUHGIVPU
      XPVUGUUTZAIYAZVYMWUCWUBWUHWUJVYJVWGVYLVYIUXHUXDYEUVBWUJVYPWUDWUAWUGWUJVYN
      VWKVYOEVYIUXHXOYMZYJWUJVYQWUEVYTWUFWUJVYNVWKVYOWUKYHWUJVYRVWOVYSFVYIUXHXP
      YMYJWAYSWAVYKVUHRZWUCVWIWUHVYEWULVYLVWHVWGVYKVUHUXDYEYNWULWUDVWLWUGVYDWUL
      VYOUXPVWKEUXPVUGVYKVVMVVPYFZYOWULWUEVWNWUFVWPWULVYOUXPVWKWUMUVCWULVYSVUGV
      WOFUXPVUGVYKVVMVVPYIYOWAYSWAHUVKUVDVYFVWSVWJVYFVWMVYDPZLVWSVWLVYDUVLWUNVW
      RVWMWUNVWNPVWQWOVWRVWNVWPYLVWNVWPUVEXLUVFYPUVGYPUVHUVIUVJYGUVMWGUWCUVNUVO
      UVPUXCVULUVQZUXCUIVUNUXLJWUOULZUXMUXCVULUVRVUNUXIVUHRZVVOUXLLZLZKTZJTZWUP
      VUNWUSJTZKTZWVAVUNVVNVUKLZKTWVCVUKKVUMYQWVDWVBKVVNVVOVUKWVBVVQVUHVUHRZVVO
      VUKLZWVBVUHUVSWUSWVEWVFLJVUHWUIWUQWUQWVEWURWVFUXIVUHVUHUVTWUQUXLVUKVVOWUQ
      UXKVUJIUXCWUQUXJVUIUXIVUHUXHGUWAXRUWBYNWAUWDUWNUWEUWFWEWUSKJUWGUWHWUPUXIW
      UOSZUXLLZJTWVAUXLJWUOYQWVHWUTJWVHWUQVVOLZKTZUXLLWVIUXLLZKTWUTWVGWVJUXLKUX
      IUXCUXPVVMUWIUWJWVIUXLKUWKWVKWUSKWUQVVOUXLUWLYRUWMYRYPYTUXLJWUOUXCUWOUWPX
      EXTUWQUWRYBYKUWSUAJIUXDGVOYT $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d R x y $.  $d S x y $.  $d a x y $.
    $d b x y $.  $d c x y $.  $d d x y $.
    xporderlem.1 $e |- T = { <. x , y >. | ( ( x e. ( A X. B )
     /\ y e. ( A X. B ) )
     /\ ( ( 1st ` x ) R ( 1st ` y )
       \/ ( ( 1st ` x ) = ( 1st ` y ) /\ ( 2nd ` x ) S ( 2nd ` y ) ) ) ) } $.
    $( Lemma for lexicographical ordering theorems.  (Contributed by Scott
       Fenton, 16-Mar-2011.) $)
    xporderlem $p |- ( <. a , b >. T <. c , d >. <->
                        ( ( ( a e. A /\ c e. A ) /\ ( b e. B /\ d e. B ) ) /\
                          ( a R c \/ ( a = c /\ b S d ) ) ) ) $=
      ( cv wbr wcel wa cfv wceq vex anbi12d cop c1st c2nd wo copab df-br eleq2i
      bitri opex eleq1 opelxp syl6bb anbi1d op1std breq1d eqeq1d op2ndd orbi12d
      cxp anbi2d breq2d eqeq2d opelopab an4 anbi1i 3bitri ) HMZIMZUAZJMZKMZUAZG
      NZVIVLUAZAMZCDUSZOZBMZVPOZPZVOUBQZVRUBQZENZWAWBRZVOUCQZVRUCQZFNZPZUDZPZAB
      UEZOZVGCOZVHDOZPZVJCOZVKDOZPZPZVGVJENZVGVJRZVHVKFNZPZUDZPZWMWPPWNWQPPZXDP
      VMVNGOWLVIVLGUFGWKVNLUGUHWJWOVSPZVGWBENZVGWBRZVHWFFNZPZUDZPXEABVIVLVGVHUI
      VJVKUIVOVIRZVTXGWIXLXMVQWOVSXMVQVIVPOWOVOVIVPUJVGVHCDUKULUMXMWCXHWHXKXMWA
      VGWBEVGVHVOHSZISZUNZUOXMWDXIWGXJXMWAVGWBXPUPXMWEVHWFFVGVHVOXNXOUQUOTURTVR
      VLRZXGWSXLXDXQVSWRWOXQVSVLVPOWRVRVLVPUJVJVKCDUKULUTXQXHWTXKXCXQWBVJVGEVJV
      KVRJSZKSZUNZVAXQXIXAXJXBXQWBVJVGXTVBXQWFVKVHFVJVKVRXRXSUQVATURTVCWSXFXDWM
      WNWPWQVDVEVF $.
  $}

  ${
    $d A a b c d e f t u v x y $.  $d B a b c d e f t u v x y $.
    $d R a b c d e f t u v x y $.  $d S a b c d e f t u v x y $.
    $d T a b c d e f t u v $.
    poxp.1 $e |- T = { <. x , y >. | ( ( x e. ( A X. B ) /\ y e. ( A X. B ) )
      /\ ( ( 1st ` x ) R ( 1st ` y ) \/
           ( ( 1st ` x ) = ( 1st ` y ) /\ ( 2nd ` x ) S ( 2nd ` y ) ) ) ) } $.
    $( A lexicographical ordering of two posets.  (Contributed by Scott Fenton,
       16-Mar-2011.)  (Revised by Mario Carneiro, 7-Mar-2013.) $)
    poxp $p |- ( ( R Po A /\ S Po B ) -> T Po ( A X. B ) ) $=
      ( va vb vc vd ve vf wa cv wbr wn wi wcel vt vu wpo cxp wral cop wceq elxp
      vv wex w3a 3an6 weq wo poirr intnand im2anan9 ioran syl6ibr imp 3ad2antr1
      ex an4 potr 3impia orcd 3expia expdimp breq2 biimpa expcom adantrd adantl
      jaod anim2d orim2d breq1 equequ1 anbi1d orbi12d syl5ibr exp3a com12 imp3a
      imbi2d jaao sylan2b biimpi 3adant2 jctild adantld syl5bi wb breq12 anidms
      an4s jca notbid 3adant3 3adant1 anbi12d imbi12d xporderlem notbii anbi12i
      3ad2ant1 imbi12i syl6bb exp3acom23 sylbi 3exp com3l exlimivv 3imp syl3anb
      com3r ralrimiv ralrimivva df-po sylibr ) CEUCZDFUCZOZUAPZYDGQZRZYDUBPZGQZ
      YGUIPZGQZOZYDYIGQZSZOZUICDUDZUEZUBYOUEUAYOUEYOGUCYCYPUAUBYOYOYCYDYOTZYGYO
      TZOZOYNUIYOYCYSYIYOTZYNSYSYTYCYNYQYRYTYCYNSZYQYDIPZJPZUFZUGZUUBCTZUUCDTZO
      ZOZJUJIUJZYRYGKPZLPZUFZUGZUUKCTZUULDTZOZOZLUJKUJZYTYIMPZNPZUFZUGZUUTCTZUV
      ADTZOZOZNUJMUJZUUAIJYDCDUHKLYGCDUHMNYICDUHUUJUUSUVHUUAUUIUUSUVHUUASSIJUVH
      UUIUUSUUAUVGUUIUUSUUASSMNUUSUVGUUIUUAUURUVGUUIUUASSKLUUIUURUVGUUAUUIUURUV
      GUUAUUIUURUVGUKUUEUUNUVCUKZUUHUUQUVFUKZOUUAUUEUUHUUNUUQUVCUVFULUVIUVJUUAU
      VIYCUVJYNYCUVJOZYNUVIUUFUUFOUUGUUGOOZUUBUUBEQZIIUMZUUCUUCFQZOZUNZOZRZUUFU
      UOOUUGUUPOOZUUBUUKEQZIKUMZUUCUULFQZOZUNZOZUUOUVDOUUPUVEOOZUUKUUTEQZKMUMZU
      ULUVAFQZOZUNZOZOZUUFUVDOUUGUVEOOZUUBUUTEQZIMUMZUUCUVAFQZOZUNZOZSZOZUVKUVS
      UXBYCUUQUUHUVSUVFYCUUHOUVQUVLYCUUHUVQRZYCUUHUVMRZUVPRZOUXDYAUUFUXEYBUUGUX
      FYAUUFUXECUUBEUOVBYBUUGUXFYBUUGOUVOUVNDUUCFUOUPVBUQUVMUVPURUSUTUPVAUWNUVT
      UWGOZUWEUWLOZOUVKUXAUVTUWEUWGUWLVCUVKUXHUXAUXGUVKUXHUWTUWOUVJYCUUFUUOUVDU
      KZUUGUUPUVEUKZOUXHUWTSZUUFUUGUUOUUPUVDUVEULYAUXIYBUXJUXKYAUXIOZYBUXJOZOUW
      EUWLUWTUXLUWAUWLUWTSZUXMUWDUXLUWAUXNUXLUWAOUWHUWTUWKUXLUWAUWHUWTYAUXIUWAU
      WHOZUWTYAUXIUXOUKUWPUWSYAUXIUXOUWPCUUBUUKUUTEVDVEVFVGVHUWAUWKUWTSUXLUWAUW
      IUWTUWJUWIUWAUWTUWIUWAOUWPUWSUWIUWAUWPUUKUUTUUBEVIVJVFVKVLVMVNVBUXMUWBUWC
      UXNUWBUXMUWCUXNSUWBUXMUWCUXNUXMUWCOZUXNUWBUWLUWHUWIUWROZUNZSUXPUWKUXQUWHU
      XPUWJUWRUWIUXMUWCUWJUWRDUUCUULUVAFVDVHVOVPUWBUWTUXRUWLUWBUWPUWHUWSUXQUUBU
      UKUUTEVQUWBUWQUWIUWRIKMVRVSVTWEWAWBWCWDWFWDWPWGUVJUWOYCUUHUVFUWOUUQUUHUVF
      OUWOUUFUUGUVDUVEVCWHWIVMWJWKWLWQUVIYNUUDUUDGQZRZUUDUUMGQZUUMUVBGQZOZUUDUV
      BGQZSZOUXCUVIYFUXTYMUYEUUEUUNYFUXTWMUVCUUEYEUXSUUEYEUXSWMYDUUDYDUUDGWNWOW
      RXFUVIYKUYCYLUYDUVIYHUYAYJUYBUUEUUNYHUYAWMUVCYDUUDYGUUMGWNWSUUNUVCYJUYBWM
      UUEYGUUMYIUVBGWNWTXAUUEUVCYLUYDWMUUNYDUUDYIUVBGWNWIXBXAUXTUVSUYEUXBUXSUVR
      ABCDEFGIJIJHXCXDUYCUWNUYDUXAUYAUWFUYBUWMABCDEFGIJKLHXCABCDEFGKLMNHXCXEABC
      DEFGIJMNHXCXGXEXHWAXIUTXJXKXLXMXLXMXLXMXNXOVGXPUTXQXRUAUBUIYOGXSXT $.
  $}

  ${
    $d A a b c d t u x y $.  $d B a b c d t u x y $.  $d R a b c d t u x y $.
    $d S a b c d t u x y $.  $d T a b c d t u $.
    soxp.1 $e |- T = { <. x , y >. | ( ( x e. ( A X. B ) /\ y e. ( A X. B ) )
      /\ ( ( 1st ` x ) R ( 1st ` y ) \/
           ( ( 1st ` x ) = ( 1st ` y ) /\ ( 2nd ` x ) S ( 2nd ` y ) ) ) ) } $.
    $( A lexicographical ordering of two strictly ordered classes.
       (Contributed by Scott Fenton, 17-Mar-2011.)  (Revised by Mario Carneiro,
       7-Mar-2013.) $)
    soxp $p |- ( ( R Or A /\ S Or B ) -> T Or ( A X. B ) ) $=
      ( va vb vc vd wa cv wbr wceq w3o wi wo wn vt wor cxp wpo wral sopo syl2an
      vu poxp wcel cop elxp ioran ianor anbi2i bitri anbi12i solin 3orass df-or
      wex sylib orim2d im2anan9 pm2.53 orc syl6 adantr orel1 imor biimpri com12
      anim2d equcomi anim1i olcd ex syld a1d jaoi imp syl6com jaod imp3a syl5bi
      df-3or sylibr pm3.2 ad2ant2l idd simpr ancomd 3orim123d mpd expcom breq12
      an4s eqeq12 wb ancoms 3orbi123d xporderlem opth 3orbi123i syl6bb biimprcd
      vex com3r exlimivv syl2anb ralrimivv df-so sylanbrc ) CEUBZDFUBZMZCDUCZGU
      DZUANZUHNZGOZXSXTPZXTXSGOZQZUHXQUEUAXQUEXQGUBXNCEUDDFUDXRXOCEUFDFUFABCDEF
      GHUIUGXPYDUAUHXQXQXSXQUJZXTXQUJZMXPYDYEXSINZJNZUKZPZYGCUJZYHDUJZMZMZJVAIV
      AZXTKNZLNZUKZPZYPCUJZYQDUJZMZMZLVAKVAZXPYDRZYFIJXSCDULKLXTCDULYOUUDUUEYNU
      UDUUERIJUUDYNUUEUUCYNUUERKLYNUUCUUEYJYSYMUUBUUEYJYSMZYMUUBMZUUEUUGXPUUFYD
      UUGXPYKYTMZYLUUAMZMZYGYPEOZYGYPPZYHYQFOZMZSZMZUULYHYQPZMZYTYKMZUUAYLMZMZY
      PYGEOZYPYGPZYQYHFOZMZSZMZQZUUFYDRYKYTYLUUAXPUVHRXPUUJUVHXNUUHXOUUIUVHXNUU
      HMZXOUUIMZMZUUOUURUVFQZUVHUVKUUOUURSZTZUVFRZUVLUVNUUKTZUULTZUUMTZSZMZUVQU
      UQTZSZMZUVKUVFUVNUUOTZUURTZMUWCUUOUURUMUWDUVTUWEUWBUWDUVPUUNTZMUVTUUKUUNU
      MUWFUVSUVPUULUUMUNUOUPUULUUQUNUQUPUVKUVTUWBUVFUVKUVTUULUVBSZUVQUUQUVDSZSZ
      MZUWBUVFRUVIUVPUWGUVJUVSUWIUVIUUKUULUVBQZUVPUWGRZCYGYPEURUWKUUKUWGSUWLUUK
      UULUVBUSUUKUWGUTUPVBUVJUVRUWHUVQUVJUUMUUQUVDQZUVRUWHRZDYHYQFURUWMUUMUWHSU
      WNUUMUUQUVDUSUUMUWHUTUPVBVCVDUWJUVQUVFUWAUWGUVQUVFRUWIUWGUVQUVBUVFUULUVBV
      EUVBUVEVFZVGVHUWAUWJUWGUVQUVDSZMUVFUWAUWIUWPUWGUWAUWHUVDUVQUUQUVDVIVCVMUW
      GUWPUVFUULUWPUVFRUVBUULUWPUVDUVFUWPUULUVDUULUVDRUWPUULUVDVJVKVLUULUVDUVFU
      ULUVDMUVEUVBUULUVCUVDIKVNVOVPVQVRUVBUVFUWPUWOVSVTWAWBWCVGWDWEUVLUVMUVFSUV
      OUUOUURUVFWFUVMUVFUTUPWGUVKUUOUUPUURUURUVFUVGUUHUUIUUOUUPRXNXOUUJUUOWHWIU
      VKUURWJUVIUUSUUTUVFUVGRUVJUVIYKYTXNUUHWKWLUVJYLUUAXOUUIWKWLUVAUVFWHUGWMWN
      WQWOWQUUFYDUVHUUFYDYIYRGOZYIYRPZYRYIGOZQUVHUUFYAUWQYBUWRYCUWSXSYIXTYRGWPX
      SYIXTYRWRYSYJYCUWSWSXTYRXSYIGWPWTXAUWQUUPUWRUURUWSUVGABCDEFGIJKLHXBYGYHYP
      YQIXGJXGXCABCDEFGKLIJHXBXDXEXFVGXHWAWQWOXIVLXIWAXJVLXKUAUHXQGXLXM $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d R x y $.  $d S x y $.
    wexp.1 $e |- T = { <. x , y >. | ( ( x e. ( A X. B ) /\ y e. ( A X. B ) )
      /\ ( ( 1st ` x ) R ( 1st ` y ) \/
           ( ( 1st ` x ) = ( 1st ` y ) /\ ( 2nd ` x ) S ( 2nd ` y ) ) ) ) } $.
    $( A lexicographical ordering of two well-ordered classes.  (Contributed by
       Scott Fenton, 17-Mar-2011.)  (Revised by Mario Carneiro, 7-Mar-2013.) $)
    wexp $p |- ( ( R We A /\ S We B ) -> T We ( A X. B ) ) $=
      ( wwe wa cxp wfr wor wefr frxp syl2an weso soxp df-we sylanbrc ) CEIZDFIZ
      JCDKZGLZUCGMZUCGIUACELDFLUDUBCENDFNABCDEFGHOPUACEMDFMUEUBCEQDFQABCDEFGHRP
      UCGST $.
  $}

  ${
    $d s u v w x y z A $.  $d u v w x y z B $.  $d s w x y G $.  $d w x z ph $.
    $d u v w x y z F $.  $d s w x y Q $.  $d u v w x y R $.  $d u v w x y S $.
    $d s w T $.
    fnwe.1 $e |- T = { <. x , y >. | ( ( x e. A /\ y e. A ) /\
      ( ( F ` x ) R ( F ` y ) \/ ( ( F ` x ) = ( F ` y ) /\ x S y ) ) ) } $.
    fnwe.2 $e |- ( ph -> F : A --> B ) $.
    fnwe.3 $e |- ( ph -> R We B ) $.
    fnwe.4 $e |- ( ph -> S We A ) $.
    fnwe.5 $e |- ( ph -> ( F " w ) e. _V ) $.
    ${
      fnwelem.6 $e |- Q = { <. u , v >. |
        ( ( u e. ( B X. A ) /\ v e. ( B X. A ) ) /\
          ( ( 1st ` u ) R ( 1st ` v ) \/
            ( ( 1st ` u ) = ( 1st ` v ) /\ ( 2nd ` u ) S ( 2nd ` v ) ) ) ) } $.
      fnwelem.7 $e |- G = ( z e. A |-> <. ( F ` z ) , z >. ) $.
      $( Lemma for ~ fnwe .  (Contributed by Mario Carneiro, 10-Mar-2013.)
         (Revised by Mario Carneiro, 18-Nov-2014.) $)
      fnwelem $p |- ( ph -> T We A ) $=
        ( crn wwe cxp wss wf cv cfv wcel wa ffvelrn simpr opelxp sylanbrc fmptd
        cop frn 3syl wexp syl2anc wess sylc ccnv wiso cima cvv wal wi wf1o wceq
        wf1 weq wral fveq2 id opeq12d opex fvmpt eqeqan12d fvex vex opth syl6bi
        simprbi rgen2a a1i dff13 f1f1orn f1ocnv 4syl copab eqid f1oiso2 wb wrel
        wbr wo frel dfrel2 sylib fveq1d breq12d syl adantr breqan12d adantl jca
        anim12dan biantrurd c1st c2nd syl6bb anbi1d op1std breq1d eqeq1d op2ndd
        anbi12d orbi12d anbi2d breq2d eqeq2d syl6rbbr 3bitrrd pm5.32da opabbidv
        eleq1 brab syl5eq isoeq3 syl5ibr isocnv imacnvcnv sylancl cres imadmres
        cdm dmres elin2 xpexg simprr f1dm eleqtrd wfn ffn cin syl5sseq syl5eqss
        fndm simprl eleqtrrd fnfvima syl3anc syl6eleq opelxpi eqeltrd ralrimiva
        inss2 sylan2b wfun f1fun resss dmss funimass4 mpbird syl5eqssr syl5eqel
        ax-mp ssexd alrimiv isowe2 mpd ) AOUCZJUDZHMUDZAUVNIHUEZUFZUVQJUDZUVOAH
        INUGZHUVQOUGZUVRQUVTDHDUHZNUIZUWBUQZUVQOUVTUWBHUJZUKUWCIUJUWEUWDUVQUJHI
        UWBNULUVTUWEUMUWCUWBIHUNUOUBUPZHUVQOURUSAIKUDHLUDUVSRSGFIHKLJUAUTVAUVNU
        VQJVBVCAHUVNMJOVDZVDZVEZUWHEUHZVFZVGUJZEVHUVOUVPVIAUVNHJMUWGVEZUWIAUVTU
        VNHUWGVJZUWMQAUVTHUVQOVLZHUVNOVJUWNQUVTUWABUHZOUIZCUHZOUIZVKZBCVMZVIZCH
        VNBHVNZUWOUWFUXCUVTUXBBCHUWPHUJZUWRHUJZUKZUWTUWPNUIZUWPUQZUWRNUIZUWRUQZ
        VKZUXAUXDUXEUWQUXHUWSUXJDUWPUWDUXHHODBVMZUWCUXGUWBUWPUWBUWPNVOUXLVPVQUB
        UXGUWPVRZVSZDUWRUWDUXJHODCVMZUWCUXIUWBUWRUWBUWRNVOUXOVPVQUBUXIUWRVRZVSZ
        VTUXKUXGUXIVKZUXAUXGUWPUXIUWRUWPNWAZBWBZWCWEWDWFWGBCHUVQOWHUOZHUVQOWIHU
        VNOWJWKUWNUWMUVTUVNHJUXFUWPUWHUIZUWRUWHUIZJWQZUKZBCWLZUWGVEZBCUVNHJUYFU
        WGUYFWMWNUVTMUYFVKUWMUYGWOUVTMUXFUXGUXIKWQZUXRUWPUWRLWQZUKZWRZUKZBCWLUY
        FPUVTUYLUYEBCUVTUXFUYKUYDUVTUXFUKZUYDUWQUWSJWQZUXHUXJJWQZUYKUVTUYDUYNWO
        ZUXFUVTUWAUYPUWFUWAUYBUWQUYCUWSJUWAUWPUWHOUWAOWPUWHOVKHUVQOWSOWTXAZXBUW
        AUWRUWHOUYQXBXCXDXEUXFUYNUYOWOUVTUXDUXEUWQUXHUWSUXJJUXNUXQXFXGUYMUYKUXG
        IUJZUXDUKZUXIIUJZUXEUKZUKZUYKUKZUYOUYMVUBUYKUVTUXDUYSUXEVUAUVTUXDUKUYRU
        XDHIUWPNULUVTUXDUMXHUVTUXEUKUYTUXEHIUWRNULUVTUXEUMXHXIXJGUHZUVQUJZFUHZU
        VQUJZUKZVUDXKUIZVUFXKUIZKWQZVUIVUJVKZVUDXLUIZVUFXLUIZLWQZUKZWRZUKUYSVUG
        UKZUXGVUJKWQZUXGVUJVKZUWPVUNLWQZUKZWRZUKVUCGFUXHUXJJUXMUXPVUDUXHVKZVUHV
        URVUQVVCVVDVUEUYSVUGVVDVUEUXHUVQUJUYSVUDUXHUVQYHUXGUWPIHUNXMXNVVDVUKVUS
        VUPVVBVVDVUIUXGVUJKUXGUWPVUDUXSUXTXOZXPVVDVULVUTVUOVVAVVDVUIUXGVUJVVEXQ
        VVDVUMUWPVUNLUXGUWPVUDUXSUXTXRXPXSXTXSVUFUXJVKZVURVUBVVCUYKVVFVUGVUAUYS
        VVFVUGUXJUVQUJVUAVUFUXJUVQYHUXIUWRIHUNXMYAVVFVUSUYHVVBUYJVVFVUJUXIUXGKU
        XIUWRVUFUWRNWAZCWBZXOZYBVVFVUTUXRVVAUYIVVFVUJUXIUXGVVIYCVVFVUNUWRUWPLUX
        IUWRVUFVVGVVHXRYBXSXTXSUAYIYDYEYFYGYJUVNHJMUYFUWGYKXDYLVCUVNHJMUWGYMXDA
        UWLEAUWKOUWJVFZVGOUWJYNAVVJNUWJVFZUWJUEZVGAVVKVGUJUWJVGUJVVLVGUJTEWBVVK
        UWJVGVGUUAYOAVVJOOUWJYPZYRZVFZVVLOUWJYQAVVOVVLUFZUWQVVLUJZBVVNVNZAVVQBV
        VNUWPVVNUJAUWPUWJUJZUWPOYRZUJZUKZVVQUWPUWJVVTVVNOUWJYSYTAVWBUKZUWQUXHVV
        LVWCUXDUWQUXHVKVWCUWPVVTHAVVSVWAUUBAVVTHVKZVWBAUVTUWOVWDQUYAHUVQOUUCUSX
        EUUDZUXNXDVWCUXGVVKUJVVSUXHVVLUJVWCUXGNNUWJYPYRZVFZVVKVWCNHUUEZVWFHUFUW
        PVWFUJZUXGVWGUJAVWHVWBAUVTVWHQHINUUFXDXEZVWCVWFUWJNYRZUUGZHNUWJYSZVWCVW
        KVWLHUWJVWKUUSVWCVWHVWKHVKVWJHNUUJXDZUUHUUIVWCVVSUWPVWKUJVWIAVVSVWAUUKZ
        VWCUWPHVWKVWEVWNUULUWPUWJVWKVWFVWMYTUOHVWFNUWPUUMUUNNUWJYQUUOVWOUXGUWPV
        VKUWJUUPVAUUQUUTUURAOUVAZVVNVVTUFZVVPVVRWOAUVTUWOVWPQUYAHUVQOUVBUSVVMOU
        FVWQOUWJUVCVVMOUVDUVIBVVNVVLOUVEYOUVFUVGUVJUVHUVKEHUVNMJUWHUVLVAUVM $.
    $}

    $( A variant on lexicographic order, which sorts first by some function of
       the base set, and then by a "backup" well-ordering when the function
       value is equal on both elements.  (Contributed by Mario Carneiro,
       10-Mar-2013.)  (Revised by Mario Carneiro, 18-Nov-2014.) $)
    fnwe $p |- ( ph -> T We A ) $=
      ( vz vv vu cv cfv cxp wcel wa c1st wbr wceq c2nd wo cop cmpt eqid fnwelem
      copab ) ABCPDQREFRSZFEUAZUBQSZUOUBUCUNUDTZUPUDTZGUEUQURUFUNUGTUPUGTHUEUCU
      HUCRQUMZGHIJPEPSZJTUTUIUJZKLMNOUSUKVAUKUL $.
  $}

  ${
    $d x y z A $.  $d u w B $.  $d u w x y F $.  $d w z ph $.  $d u w x y R $.
    $d u z $.  $d x y S $.  $d w z T $.
    fnse.1 $e |- T = { <. x , y >. | ( ( x e. A /\ y e. A ) /\
      ( ( F ` x ) R ( F ` y ) \/ ( ( F ` x ) = ( F ` y ) /\ x S y ) ) ) } $.
    fnse.2 $e |- ( ph -> F : A --> B ) $.
    fnse.3 $e |- ( ph -> R Se B ) $.
    fnse.4 $e |- ( ph -> ( `' F " w ) e. _V ) $.
    $( Condition for the well-order in ~ fnwe to be set-like.  (Contributed by
       Mario Carneiro, 25-Jun-2015.) $)
    fnse $p |- ( ph -> T Se A ) $=
      ( vz cv cvv wcel wa wbr ccnv csn cima cin wral wse cfv crab cun ffvelrnda
      vu seex sylan syldan snex sylancl wceq imaeq2 eleq1d imbi2d vtoclg impcom
      unexg wi wss inss2 wb vex eliniseg ax-mp fveq2 breqan12d eqeqan12d breq12
      anbi12d orbi12d brab2ga adantrr breq1 elrab3 syl biimprd simpl fvex elsnc
      wo sylibr a1i orim12d elun syl6ibr simprl jctild wfn ffn elpreima sylibrd
      wf adantr expimpd syl5bi ssrdv syl5ss ssexd ralrimiva dfse2 ) AEIUAOPZUBU
      CZUDZQRZOEUEEIUFAXJOEAXGERZSZXIJUAZUKPZXGJUGZGTZUKFUHZXOUBZUIZUCZQAXKXSQR
      ZXTQRZXLXQQRZXRQRYAAXKXOFRZYCAEFXGJLUJAFGUFYDYCMUKFXOGULUMUNXOUOXQXRQQVCU
      PYAAYBAXMDPZUCZQRZVDAYBVDDXSQYEXSUQZYGYBAYHYFXTQYEXSXMURUSUTNVAVBUNAXIXTV
      EXKAXIXHXTEXHVFADXHXTYEXHRZYEXGITZAYEXTRZXGQRYIYJVGOVHIXGYEQDVHVIVJYJYEER
      ZXKSZYEJUGZXOGTZYNXOUQZYEXGHTZSZWFZSAYKBPZJUGZCPZJUGZGTZUUAUUCUQZYTUUBHTZ
      SZWFYSBCYEXGEEIYTYEUQZUUBXGUQZSZUUDYOUUGYRUUHUUIUUAYNUUCXOGYTYEJVKZUUBXGJ
      VKZVLUUJUUEYPUUFYQUUHUUIUUAYNUUCXOUUKUULVMYTYEUUBXGHVNVOVPKVQAYMYSYKAYMSZ
      YSYLYNXSRZSZYKUUMYSUUNYLUUMYSYNXQRZYNXRRZWFUUNUUMYOUUPYRUUQUUMUUPYOUUMYNF
      RZUUPYOVGAYLUURXKAEFYEJLUJVRXPYOUKYNFXNYNXOGVSVTWAWBYRUUQVDUUMYRYPUUQYPYQ
      WCYNXOYEJWDWEWGWHWIYNXQXRWJWKAYLXKWLWMUUMJEWNZYKUUOVGAUUSYMAEFJWRUUSLEFJW
      OWAWSEYEXSJWPWAWQWTXAXAXBXCWSXDXEOEIXFWG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Special "Maps to" operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
The following theorems are about maps-to operations ( see ~ df-mpt2 ) where the
first argument is a pair and the base set of the second argument is the first
component of the first argument, in short "x-maps-to operations". For labels,
the abbreviations "mpt2x" are used (since "x" usually denotes the first
argument). This is in line with the currently used conventions for such cases
(see ~ cbvmpt2x , ~ ovmpt2x and ~ fmpt2x ). However, there is a proposal by
Norman Megill to use the abbreviation "mpo" or "mpto" instead of "mpt2"
(see beginning of set.mm). If this proposal will be realized, the labels in the
following should also be adapted. If the first argument is an ordered pair,
as in the following, the abbreviation is extended to "mpt2xop", and the maps-to
operations are called "x-op maps-to operations" for short.
$)

  ${
    $d x y $.  $d K x $.  $d V x $.  $d W x $.
    mpt2xopn0yelv.f $e |- F = ( x e. _V , y e. ( 1st ` x ) |-> C ) $.
    $( If there is an element of the value of an operation given by a maps-to
       rule, where the first argument is a pair and the base set of the second
       argument is the first component of the first argument, then the second
       argument is an element of the first component of the first argument.
       (Contributed by Alexander van der Vekens, 10-Oct-2017.) $)
    mpt2xopn0yelv $p |- ( ( V e. X /\ W e. Y )
                          -> ( N e. ( <. V , W >. F K ) -> K e. V ) ) $=
      ( cop co wcel c1st cfv wa cvv cv csn cxp ciun cdm dmmpt2ssx elfvdm eleq2s
      df-ov sseldi fveq2 opeliunxp2 simprbi syl op1stg eleq2d syl5ib ) FGHLZEDM
      ZNZEUPOPZNZGINHJNQZEGNURUPELZARASZTVCOPZUAUBZNZUTURDUCZVEVBABRVDCDKUDVBVG
      NFVBDPUQFVBDUEUPEDUGUFUHVFUPRNUTARVDUPEUSVCUPOUIUJUKULVAUSGEGHIJUMUNUO $.

    $d K n $.  $d F n $.  $d V n $.  $d W n $.  $d X n $.  $d Y n $.
    $( If the second argument of an operation given by a maps-to rule, where
       the first argument is a pair and the base set of the second argument is
       the first component of the first argument is not element of the the
       first component of the first argument, then the value of the operation
       is the empty set.  (Contributed by Alexander van der Vekens,
       10-Oct-2017.) $)
    mpt2xopynvov0g $p |- ( ( ( V e. X /\ W e. Y ) /\ K e/ V )
                          -> ( <. V , W >. F K ) = (/) ) $=
      ( vn wcel wa wnel cop co c0 wceq wn cv neq0 mpt2xopn0yelv syl6ibr exlimdv
      wex nnel syl5bi con4d imp ) FHLGILMZEFNZFGOEDPZQRZUJUMUKUMSKTZULLZKUEUJUK
      SZKULUAUJUOUPKUJUOEFLUPABCDEUNFGHIJUBEFUFUCUDUGUHUI $.

    $d F x $.
    $( If the first argument of an operation given by a maps-to rule, where the
       first argument is a pair and the base set of the second argument is the
       first component of the first argument, is not an ordered pair, then the
       value of the operation is the empty set.  (Contributed by Alexander van
       der Vekens, 10-Oct-2017.) $)
    mpt2xopxnop0 $p |- ( -. V e. ( _V X. _V ) -> ( V F K ) = (/) ) $=
      ( vn c0 cvv cxp wcel cv wex csn c1st cfv cdm wa sylbi co wceq wn neq0 cop
      ciun dmmpt2ssx elfvdm df-ov eleq2s sseldi fveq2 opeliunxp2 cuni eluni wne
      wi ne0i ad2antlr dmsnn0 sylibr ex exlimiv 1stval impcom syl con1i ) FEDUA
      ZIUBZFJJKLZVIUCAMZVHLZANVJAVHUDVLVJAVLFEUEZAJVKOVKPQZKUFZLZVJVLDRZVOVMABJ
      VNCDGUGVMVQLVKVMDQVHVKVMDUHFEDUIUJUKVPFJLZEFPQZLZSVJAJVNFEVSVKFPULUMVTVRV
      JVRVJUQZEFORZUNZVSEWCLEHMZLZWDWBLZSZHNWAHEWBUOWGWAHWGVRVJWGVRSWBIUPZVJWFW
      HWEVRWBWDURUSFUTVAVBVCTFVDUJVETVFVCTVG $.

    $( If the first argument of an operation given by a maps-to rule, where the
       first argument is a pair and the base set of the second argument is the
       first component of the first argument, is the empty set, then the value
       of the operation is the empty set.  (Contributed by Alexander van der
       Vekens, 10-Oct-2017.) $)
    mpt2xopx0ov0 $p |- ( (/) F K ) = (/) $=
      ( c0 cvv cxp wcel wn co wceq 0nelxp mpt2xopxnop0 ax-mp ) GHHIJKGEDLGMHHNA
      BCDEGFOP $.

    $( If the components of the first argument of an operation given by a
       maps-to rule, where the first argument is a pair and the base set of the
       second argument is the first component of the first argument, are not
       sets, then the value of the operation is the empty set.  (Contributed by
       Alexander van der Vekens, 10-Oct-2017.) $)
    mpt2xopxprcov0 $p |- ( -. ( V e. _V /\ W e. _V )
                           -> ( <. V , W >. F K ) = (/) ) $=
      ( cvv wcel wa cop cxp co c0 wceq opelxp mpt2xopxnop0 sylnbir ) FIJGIJKFGL
      ZIIMJTEDNOPFGIIQABCDETHRS $.

    $( If the second argument of an operation given by a maps-to rule, where
       the first argument is a pair and the base set of the second argument is
       the first component of the first argument is not element of the the
       first component of the first argument, then the value of the operation
       is the empty set.  (Contributed by Alexander van der Vekens,
       10-Oct-2017.) $)
    mpt2xopynvov0 $p |- ( K e/ V -> ( <. V , W >. F K ) = (/) ) $=
      ( cvv wcel wa wnel cop co c0 wceq wi mpt2xopynvov0g ex wn mpt2xopxprcov0
      a1d pm2.61i ) FIJGIJKZEFLZFGMEDNOPZQUDUEUFABCDEFGIIHRSUDTUFUEABCDEFGHUAUB
      UC $.
  $}

  ${
    $d K n x y $.  $d V n x y $.  $d W n x y $.  $d X n x y $.  $d Y n x y $.
    mpt2xopoveq.f $e |- F = ( x e. _V , y e. ( 1st ` x )
                            |-> { n e. ( 1st ` x ) | ph } ) $.
    $( Value of an operation given by a maps-to rule, where the first argument
       is a pair and the base set of the second argument is the first component
       of the first argument.  (Contributed by Alexander van der Vekens,
       11-Oct-2017.) $)
    mpt2xopoveq $p |- ( ( ( V e. X /\ W e. Y ) /\ K e. V )
                 -> ( <. V , W >. F K )
                      = { n e. V | [. <. V , W >. / x ]. [. K / y ]. ph } ) $=
      ( vz wcel wa cvv cv c1st wceq adantl nfcv cop cfv crab cmpt2 fveq2 op1stg
      wsbc a1i adantr sylan9eqr adantrr wb sbceq1a bitrd rabeqbidv simpr rabexg
      opex ad2antrr weq wnf equid nfvd ax-mp nfsbc1v nfrab nfsbc ovmpt2dxf ) GI
      MZHJMZNZFGMZNZBCGHUAZFOBPZQUBZADVPUCZACFUGZBVNUGZDGUCZEGOEBCOVPVQUDRVMKUH
      VMVOVNRZCPFRZNZNZAVSDVPGVMWAVPGRWBWAVMVPVNQUBZGVOVNQUEVKWEGRVLGHIJUFUIUJZ
      UKWDAVRVSWCAVRULZVMWBWGWAACFUMSSWCVRVSULZVMWAWHWBVRBVNUMUISUNUOWFVNOMVMGH
      URUHVKVLUPVIVTOMVJVLVSDGIUQUSLLUTZVMBVALVBZWIVMBVCVDWIVMCVAWJWIVMCVCVDCVN
      TZBFTVSBDGVRBVNVEBGTVFVSCDGVRCBVNWKACFVEVGCGTVFVH $.

    $d N x y $.
    $( Element of the value of an operation given by a maps-to rule, where the
       first argument is a pair and the base set of the second argument is the
       first component of the first argument.  (Contributed by Alexander van
       der Vekens and Mario Carneiro, 10-Oct-2017.) $)
    mpt2xopovel $p |- ( ( V e. X /\ W e. Y ) -> ( N e. ( <. V , W >. F K )
                <-> ( K e. V /\ N e. V /\ [. <. V , W >. / x ].
                      [. K / y ]. [. N / n ]. ph ) ) ) $=
      ( wcel wa cop co wsbc crab sbccom bitri w3a cv cfv mpt2xopn0yelv pm4.71rd
      c1st mpt2xopoveq eleq2d nfcv elrabsf sbcbii anbi2i syl6bb pm5.32da 3anass
      syl6bbr bitrd ) HJMIKMNZGHIOZFEPZMZFHMZVANZVBGHMZADGQCFQZBUSQZUAZURVAVBBC
      ADBUBUFUCREFGHIJKLUDUEURVCVBVDVFNZNVGURVBVAVHURVBNZVAGACFQZBUSQZDHRZMZVHV
      IUTVLGABCDEFHIJKLUGUHVMVDVKDGQZNVHVKDGHDHUIUJVNVFVDVNVJDGQZBUSQVFVJDBGUSS
      VOVEBUSADCGFSUKTULTUMUNVBVDVFUOUPUQ $.

    $d F x $.
    mpt2xopoveqd.1 $e |- ( ps -> ( V e. X /\ W e. Y ) ) $.
    mpt2xopoveqd.2 $e |- ( ( ps /\ -. K e. V )
                -> { n e. V | [. <. V , W >. / x ]. [. K / y ]. ph } = (/) ) $.
    $( Value of an operation given by a maps-to rule, where the first argument
       is a pair and the base set of the second argument is the first component
       of the first argument, deduction version.  (Contributed by Alexander van
       der Vekens, 11-Oct-2017.) $)
    mpt2xopoveqd $p |- ( ps -> ( <. V , W >. F K )
                       = { n e. V | [. <. V , W >. / x ]. [. K / y ]. ph } ) $=
      ( wcel wsbc crab wceq wa c0 cop co wi mpt2xopoveq ex com12 wn wnel df-nel
      syl cv c1st cfv mpt2xopynvov0 sylbir adantr eqcomd ancoms eqtrd pm2.61i )
      GHOZBHIUAZGFUBZADGPCVBPEHQZRZUCBVAVEBHJOIKOSZVAVEUCMVFVAVEACDEFGHIJKLUDUE
      UJUFVAUGZBVEVGBSVCTVDVGVCTRZBVGGHUHVHGHUICDAECUKULUMQFGHILUNUOUPBVGTVDRBV
      GSVDTNUQURUSUEUT $.
  $}

  ${
    $d x y z $.  $d X x y z $.  $d Y x y z $.  $d C z $.
    mpt2ndm0.f $e |- F = ( x e. X , y e. Y |-> C ) $.
    $( The value of an operation given by a maps-to rule is the empty set if
       the arguments ar not contained in the base sets of the rule.
       (Contributed by Alexander van der Vekens, 12-Oct-2017.) $)
    mpt2ndm0 $p |- ( -. ( V e. X /\ W e. Y ) -> ( V F W ) = (/) ) $=
      ( vz cdm cxp wss wcel wa wn co c0 wceq cv cmpt2 df-mpt2 dmoprabss eqsstri
      coprab eqtri dmeqi nssdmovg mpan ) DKZGHLZMEGNFHNOPEFDQRSUJATGNBTHNOJTCSZ
      OABJUEZKUKDUMDABGHCUAUMIABJGHCUBUFUGULABJGHUCUDEFGHDUHUI $.
  $}

  ${
    $d x y $.
    brovex.1 $e |- O = ( x e. _V , y e. _V |-> C ) $.
    brovex.2 $e |- ( ( V e. _V /\ E e. _V ) -> Rel ( V O E ) ) $.
    $( A binary relation of the value of an operation given by the "maps to"
       notation.  (Contributed by Alexander van der Vekens, 21-Oct-2017.) $)
    brovex $p |- ( F ( V O E ) P
                   -> ( ( V e. _V /\ E e. _V ) /\ ( F e. _V /\ P e. _V ) ) ) $=
      ( co wbr cvv wcel wa cop wi df-br c0 wne ne0i mpt2ndm0 necon1ai brrelex12
      wrel sylan id syldan ex 3syl sylbi pm2.43i ) FDHEGKZLZHMNEMNOZFMNDMNOZOZU
      NFDPZUMNZUNUQQZFDUMRUSUMSTUOUTUMURUAUOUMSABCGHEMMIUBUCUOUNUQUOUNUPUQUOUMU
      EUNUPJFDUMUDUFUQUGUHUIUJUKUL $.
  $}

  ${
    $d w x y z $.
    brovmpt2ex.1 $e |- O = ( x e. _V , y e. _V |-> { <. z , w >. | ph } ) $.
    $( A binary relation of the value of an operation given by the "maps to"
       notation.  (Contributed by Alexander van der Vekens, 21-Oct-2017.) $)
    brovmpt2ex $p |- ( F ( V O E ) P
                   -> ( ( V e. _V /\ E e. _V ) /\ ( F e. _V /\ P e. _V ) ) ) $=
      ( copab co wrel cvv wcel wa relmpt2opab a1i brovex ) BCADELFGHIJKJGIMNJOP
      GOPQABCDEOOJGIKRST $.
  $}

  ${
    $d E e f p v $.  $d V e f p v $.  $d W e v $.  $d ps e v $.
    sprmpt2.1 $e |- M = ( v e. _V , e e. _V
                          |-> { <. f , p >. | ( f ( v W e ) p /\ ch ) } ) $.
    sprmpt2.2 $e |- ( ( v = V /\ e = E ) -> ( ch <-> ps ) ) $.
    sprmpt2.3 $e |- ( ( V e. _V /\ E e. _V ) -> ( f ( V W E ) p -> th ) ) $.
    sprmpt2.4 $e |- ( ( V e. _V /\ E e. _V ) -> { <. f , p >. | th } e. _V ) $.
    $( The extension of a binary relation which is the value of an operation
       given in maps-to notation.  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    sprmpt2 $p |- ( ( V e. _V /\ E e. _V ) -> ( V M E )
                    = { <. f , p >. | ( f ( V W E ) p /\ ps ) } ) $=
      ( cvv wcel wa cv wceq co wbr copab cmpt2 a1i oveq12 adantl breqd opabbidv
      wb anbi12d simpl simpr opabbrex ovmpt2d ) IPQZGPQZRZDEIGPPFSZKSZDSZESZJUA
      ZUBZBRZFKUCZUSUTIGJUAZUBZARZFKUCHPHDEPPVFUDTURLUEURVAITVBGTRZRZVEVIFKVKVD
      VHBAVKVCVGUSUTVJVCVGTURVAIVBGJUFUGUHVJBAUJURMUGUKUIUPUQULUPUQUMACFGIJKNOU
      NUO $.
  $}

  ${
    $d F f p $.  $d P f p $.  $d W f p $.  $d ch f p $.
    isprmpt2.1 $e |- ( ph -> M = { <. f , p >. | ( f W p /\ ps ) } ) $.
    isprmpt2.2 $e |- ( ( f = F /\ p = P ) -> ( ps <-> ch ) ) $.
    $( Properties of a pair in an extended binary relation.  (Contributed by
       Alexander van der Vekens, 30-Oct-2017.) $)
    isprmpt2 $p |- ( ph -> ( ( F e. X /\ P e. Y )
                     -> ( F M P <-> ( F W P /\ ch ) ) ) ) $=
      ( wcel wa wbr wb cop cv wceq copab adantr eleq2d syl5bb breq12 opelopabga
      df-br anbi12d adantl bitrd ex ) AFINDJNOZFDGPZFDHPZCOZQAULOZUMFDRZESZKSZH
      PZBOZEKUAZNZUOUMUQGNUPVCFDGUGUPGVBUQAGVBTULLUBUCUDULVCUOQAVAUOEKFDIJURFTU
      SDTOUTUNBCURFUSDHUEMUHUFUIUJUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Function transposition
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c tpos $. $( Function transposition $)

  $( The transposition of a function. $)
  ctpos $a class tpos F $.

  ${
    $d F x $.
    $( Define the transposition of a function, which is a function
       ` G = tpos F ` satisfying ` G ( x , y ) = F ( y , x ) ` .  (Contributed
       by Mario Carneiro, 10-Sep-2015.) $)
    df-tpos $a |- tpos F = ( F o.
        ( x e. ( `' dom F u. { (/) } ) |-> U. `' { x } ) ) $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d w x y z F $.  $d x G $.
    $( Subset theorem for transposition.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    tposss $p |- ( F C_ G -> tpos F C_ tpos G ) $=
      ( vx wss cdm ccnv c0 csn cun cv cuni cmpt ccom ctpos coss1 cres wceq dmss
      cnvss df-tpos unss1 resmpt 4syl resss syl6eqssr coss2 syl sstrd 3sstr4g )
      ABDZACAEZFZGHZIZCJHFKZLZMZBCBEZFZUMIZUOLZMZANBNUJUQBUPMZVBABUPOUJUPVADVCV
      BDUJUPVAUNPZVAUJUKURDULUSDUNUTDVDUPQABRUKURSULUSUMUACUTUNUOUBUCVAUNUDUEUP
      VABUFUGUHCATCBTUI $.

    $( Equality theorem for transposition.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    tposeq $p |- ( F = G -> tpos F = tpos G ) $=
      ( wceq ctpos wss eqimss tposss syl eqimss2 eqssd ) ABCZADZBDZKABELMEABFAB
      GHKBAEMLEBAIBAGHJ $.

    ${
      tposeqd.1 $e |- ( ph -> F = G ) $.
      $( Equality theorem for transposition.  (Contributed by Mario Carneiro,
         7-Jan-2017.) $)
      tposeqd $p |- ( ph -> tpos F = tpos G ) $=
        ( wceq ctpos tposeq syl ) ABCEBFCFEDBCGH $.
    $}

    $( The transposition is a subset of a cross product.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    tposssxp $p |- tpos F C_ ( ( `' dom F u. { (/) } ) X. ran F ) $=
      ( vx ctpos cdm ccnv csn cun cuni cmpt crn cxp ccom df-tpos cossxp eqsstri
      c0 cv wss eqid dmmptss xpss1 ax-mp sstri ) ACZBADEPFGZBQFEHZIZDZAJZKZUEUI
      KZUDAUGLUJBAMAUGNOUHUERUJUKRBUEUFUGUGSTUHUEUIUAUBUC $.

    $( The transposition is a relation.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    reltpos $p |- Rel tpos F $=
      ( ctpos cdm ccnv c0 csn cun crn cxp wss wrel tposssxp relxp relss mp2 ) A
      BZACDEFGZAHZIZJSKPKALQRMPSNO $.

    $( Value of the transposition at a pair ` <. A , B >. ` .  (Contributed by
       Mario Carneiro, 10-Sep-2015.) $)
    brtpos2 $p |- ( B e. V -> ( A tpos F B <->
      ( A e. ( `' dom F u. { (/) } ) /\ U. `' { A } F B ) ) ) $=
      ( vy vx wcel cvv wbr cdm ccnv csn cuni wa wi a1i wb cv wceq bitri reltpos
      ctpos c0 cun brrelexi elex adantr cmpt wex df-tpos breqi brcog syl5bb cfv
      ccom wfun funmpt funbrfv2b ax-mp snex cnvex uniex eqid dmmpti eleq2i sneq
      eqcom anbi12i cnveqd unieqd fvmpt eqeq2d pm5.32i ancom anbi1i anass exbii
      breq1 anbi2d ceqsexv syl6bb expcom pm5.21ndd ) BDGZAHGZABCUBZIZACJKUCLUDZ
      GZALZKZMZBCIZNZWGWEOWDABWFCUAUEPWNWEOWDWIWEWMAWHUFUGPWEWDWGWNQWEWDNZWGAER
      ZFWHFRZLZKZMZUHZIZWPBCIZNZEUIZWNWGABCXAUOZIWOXEABWFXFFCUJUKEABCXAHDULUMXE
      WPWLSZWIXCNZNZEUIWNXDXIEXDXGWINZXCNXIXBXJXCXBWIXGNZXJXBAXAJZGZAXAUNZWPSZN
      ZXKXAUPXBXPQFWHWTUQAWPXAURUSXPWIWPXNSZNXKXMWIXOXQXLWHAFWHWTXAWSWRWQUTVAVB
      XAVCZVDVEXNWPVGVHWIXQXGWIXNWLWPFAWTWLWHXAWQASZWSWKXSWRWJWQAVFVIVJXRWKWJAU
      TVAVBZVKVLVMTTWIXGVNTVOXGWIXCVPTVQXHWNEWLXTXGXCWMWIWPWLBCVRVSVTTWAWBWC $.

    $( The behavior of ` tpos ` when the left argument is the empty set (which
       is not an ordered pair but is the "default" value of an ordered pair
       when the arguments are proper classes).  This allows us to eliminate
       sethood hypotheses on ` A , B ` in ~ brtpos .  (Contributed by Mario
       Carneiro, 10-Sep-2015.) $)
    brtpos0 $p |- ( A e. V -> ( (/) tpos F A <-> (/) F A ) ) $=
      ( wcel c0 ctpos wbr cdm ccnv csn cun cuni brtpos2 ssun2 0ex snid biantrur
      wa sselii cnvsn0 unieqi uni0 eqtri breq1i bitr3i syl6bb ) ACDEABFGEBHIZEJ
      ZKZDZUHIZLZABGZRZEABGZEABCMUNUMUOUJUMUHUIEUHUGNEOPSQULEABULELEUKETUAUBUCU
      DUEUF $.

    $( Necessary and sufficient condition for ` dom tpos F ` to be a relation.
       (Contributed by Mario Carneiro, 10-Sep-2015.) $)
    reldmtpos $p |- ( Rel dom tpos F <-> -. (/) e. dom F ) $=
      ( vy vx cdm wrel c0 wcel wn cv wbr wex 0ex eldm cvv wb vex ax-mp wi sylbi
      wss ctpos brtpos0 cxp 0nelxp df-rel ssel mtoi breldm nsyl3 sylbir exlimiv
      con2i wa ccnv csn relcnv mpbi sseli a1i elsni breq1d pm2.24d syl6bi com3l
      impcom wo cuni brtpos2 simplbi elun sylib adantl mpjaod ex exlimdv syl5bi
      cun ssrdv sylibr impbii ) AUAZDZEZFADZGZHZWEWCWEFBIZAJZBKWCHZBFALMWHWIBWH
      FWGWAJZWIWGNGZWJWHOBPZWGANUBQZWCFWBGZWJWCWNFNNUCZGZNNUDWCWBWOTZWNWPRWBUEZ
      WBWOFUFSUGFWGWALWLUHUIUJUKSULWFWQWCWFCWBWOCIZWBGWSWGWAJZBKWFWSWOGZBWSWACP
      MWFWTXABWFWTXAWFWTUMZWSWDUNZGZXAWSFUOZGZXDXARXBXCWOWSXCEXCWOTWDUPXCUEUQUR
      USWTWFXFXARXFWTWFXAXFWTWJWFXARZXFWSFWGWAWSFUTVAWJWHXGWMWHWEXAFWGALWLUHVBS
      VCVDVEWTXDXFVFZWFWTWSXCXEVQGZXHWTXIWSUOUNVGWGAJZWKWTXIXJUMOWLWSWGANVHQVIW
      SXCXEVJVKVLVMVNVOVPVRWRVSVT $.

    $( The transposition swaps arguments of a three-parameter relation.
       (Contributed by Mario Carneiro, 10-Sep-2015.) $)
    brtpos $p |- ( C e. V -> ( <. A , B >. tpos F C <-> <. B , A >. F C ) ) $=
      ( wcel cvv wa cop ctpos wbr wb cdm ccnv c0 csn adantr wn opprc breq1d cun
      cuni brtpos2 wi opex breldmg 3expia mpan opelcnvg adantl sylibrd pm4.71rd
      elun1 opswap breq1i anbi2i syl6bbr bitr4d ex brtpos0 ancom sylnbi bibi12d
      syl6 syl5ibrcom pm2.61d ) CEFZAGFZBGFZHZABIZCDJZKZBAIZCDKZLZVGVJVPVGVJHZV
      MVKDMZNZOPZUAFZVKPNUBZCDKZHZVOVGVMWDLVJVKCDEUCQVQVOWAVOHWDVQVOWAVQVOVKVSF
      ZWAVQVOVNVRFZWEVGVOWFUDZVJVNGFZVGWGBAUEWHVGVOWFVNCGEDUFUGUHQVJWEWFLVGABGG
      VRUIUJUKVKVSVTUMVDULWCVOWAWBVNCDABUNUOUPUQURUSVGVPVJRZOCVLKZOCDKZLCDEUTWI
      VMWJVOWKWIVKOCVLABSTVJVIVHHZVOWKLVHVIVAWLRVNOCDBASTVBVCVEVF $.

    $( The transposition swaps the first two elements in a collection of
       ordered triples.  (Contributed by Mario Carneiro, 1-Dec-2014.) $)
    ottpos $p |- ( C e. V ->
      ( <. A , B , C >. e. tpos F <-> <. B , A , C >. e. F ) ) $=
      ( wcel cop ctpos cotp wbr brtpos df-br 3bitr3g df-ot eleq1i 3bitr4g ) CEF
      ZABGZCGZDHZFZBAGZCGZDFZABCIZTFBACIZDFQRCTJUBCDJUAUDABCDEKRCTLUBCDLMUESTAB
      CNOUFUCDBACNOP $.

    $( The transposition swaps arguments of a three-parameter relation.
       (Contributed by Mario Carneiro, 3-Nov-2015.) $)
    relbrtpos $p |- ( Rel F ->
      ( <. A , B >. tpos F C <-> <. B , A >. F C ) ) $=
      ( wrel cop ctpos wbr cvv wcel reltpos a1i brrelex2 sylan brtpos pm5.21nd
      ) DEZABFZCDGZHZBAFZCDHCIJZQSEZTUBUCQDKLRCSMNUACDMABCDIOP $.

    $( The domain of ` tpos F ` when ` dom F ` is a relation.  (Contributed by
       Mario Carneiro, 10-Sep-2015.) $)
    dmtpos $p |- ( Rel dom F -> dom tpos F = `' dom F ) $=
      ( vx vy vz ctpos cdm wrel ccnv wa wceq cvv wcel cop wbr wex vex opex eldm
      c0 cv cxp wss wn 0nelxp ssel df-rel reldmtpos 3imtr4i relcnv jctir brtpos
      mtoi wb mp1i exbidv opelcnv bitri 3bitr4g eqrelrdv2 mpancom ) AEZFZGZAFZH
      ZGZIVDGZVBVEJVGVCVFVDKKUAZUBZSVDLZUCVGVCVIVJSVHLKKUDVDVHSUEULVDUFAUGUHVDU
      IUJVGBCVBVEVGBTZCTZMZDTZVANZDOVLVKMZVNANZDOZVMVBLVMVELZVGVOVQDVNKLVOVQUMV
      GDPVKVLVNAKUKUNUODVMVAVKVLQRVSVPVDLVRVKVLVDBPCPUPDVPAVLVKQRUQURUSUT $.

    $( The range of ` tpos F ` when ` dom F ` is a relation.  (Contributed by
       Mario Carneiro, 10-Sep-2015.) $)
    rntpos $p |- ( Rel dom F -> ran tpos F = ran F ) $=
      ( vz vw vx vy cdm wrel crn cv wcel wbr wex vex elrn cop wceq breldm elrel
      wi breq1 ctpos ccnv dmtpos eleq2d syl5ib relcnv mpan syl6 wb brtpos ax-mp
      cvv syl6bb opex brelrn syl6bi exlimivv syli exlimdv syl5bi ex syl5 impbid
      syl6bbr eqrdv ) AFZGZBAUAZHZAHZVGBIZVIJZVKVJJZVLCIZVKVHKZCLVGVMCVKVHBMZNV
      GVOVMCVOVGVNDIZEIZOZPZELDLZVMVGVOVNVFUBZJZWAVOVNVHFZJVGWCVNVKVHCMZVPQVGWD
      WBVNAUCUDUEWBGWCWAVFUFDEVNWBRUGUHVTVOVMSDEVTVOVRVQOZVKAKZVMVTVOVSVKVHKZWG
      VNVSVKVHTVKULJWHWGUIVPVQVRVKAULUJUKZUMWFVKAVRVQUNVPUOUPUQURUSUTVMVNVKAKZC
      LVGVLCVKAVPNVGWJVLCWJVGVNWFPZDLELZVLWJVNVFJZVGWLVNVKAWEVPQVGWMWLEDVNVFRVA
      VBWKWJVLSEDWKWJWHVLWKWJWGWHVNWFVKATWIVDVSVKVHVQVRUNVPUOUPUQURUSUTVCVE $.

    $( The transposition of a set is a set.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    tposexg $p |- ( F e. V -> tpos F e. _V ) $=
      ( wcel ctpos cdm ccnv c0 csn cun crn cxp wss cvv tposssxp cnvexg syl p0ex
      dmexg unexg sylancl rnexg xpexg syl2anc ssexg sylancr ) ABCZADZAEZFZGHZIZ
      AJZKZLUMMCZUGMCANUFUKMCZULMCUNUFUIMCZUJMCUOUFUHMCUPABRUHMOPQUIUJMMSTABUAU
      KULMMUBUCUGUMMUDUE $.

    $( The transposition swaps the arguments in a two-argument function.  When
       ` F ` is a matrix, which is to say a function from
       ` ( 1 ... m ) X. ( 1 ... n ) ` to ` RR ` or some ring, ` tpos F ` is the
       transposition of ` F ` , which is where the name comes from.
       (Contributed by Mario Carneiro, 10-Sep-2015.) $)
    ovtpos $p |- ( A tpos F B ) = ( B F A ) $=
      ( vy cop ctpos cfv co cv wbr cio cvv wcel wb vex brtpos ax-mp df-fv df-ov
      3eqtr4i iotabii ) ABEZCFZGZBAEZCGZABUCHBACHUBDIZUCJZDKUEUGCJZDKUDUFUHUIDU
      GLMUHUINDOABUGCLPQUADUBUCRDUECRTABUCSBACST $.

    $( The transposition of a function is a function.  (Contributed by Mario
       Carneiro, 10-Sep-2015.) $)
    tposfun $p |- ( Fun F -> Fun tpos F ) $=
      ( vx wfun cdm ccnv c0 csn cun cv cuni cmpt ccom ctpos funco mpan2 df-tpos
      funmpt funeqi sylibr ) ACZABADEFGHZBIGEJZKZLZCZAMZCTUCCUEBUAUBQAUCNOUFUDB
      APRS $.

    $( Alternate definition of ` tpos ` when ` F ` has relational domain.
       (Contributed by Mario Carneiro, 10-Sep-2015.) $)
    dftpos2 $p |- ( Rel dom F -> tpos F =
        ( F o. ( x e. `' dom F |-> U. `' { x } ) ) ) $=
      ( cdm wrel ctpos cres ccnv csn cuni cmpt ccom dmtpos reseq2d wceq reltpos
      cv resdm ax-mp c0 cun df-tpos reseq1i resco resmpt coeq2i 3eqtri 3eqtr3g
      wss ssun1 ) BCZDZBEZULCZFZULUJGZFZULBAUOAPHGIZJZKZUKUMUOULBLMULDUNULNBOUL
      QRUPBAUOSHZTZUQJZKZUOFBVBUOFZKUSULVCUOABUAUBBVBUOUCVDURBUOVAUHVDURNUOUTUI
      AVAUOUQUDRUEUFUG $.

    $( Alternate definition of ` tpos ` when ` F ` has relational domain.
       Compare ~ df-cnv .  (Contributed by Mario Carneiro, 10-Sep-2015.) $)
    dftpos3 $p |- ( Rel dom F -> tpos F =
      { <. <. x , y >. , z >. | <. y , x >. F z } ) $=
      ( vw cdm wrel ctpos cv cop wceq wbr wa wex cab wcel cvv cxp bitr3i syl6bb
      coprab wss relcnv dmtpos releqd mpbiri reltpos jctil relrelss sylib sseld
      ccnv elvvv syl6ib pm4.71rd 19.41vvv eleq1 df-br vex brtpos pm5.32i 3exbii
      wb ax-mp abbi2dv df-oprab syl6eqr ) DFZGZDHZEIZAIZBIZJZCIZJZKZVMVLJVODLZM
      ZCNBNANZEOVRABCUAVIVTEVJVIVKVJPZVQCNBNANZWAMZVTVIWAWBVIWAVKQQRQRZPWBVIVJW
      DVKVIVJGZVJFZGZMVJWDUBVIWGWEVIWGVHULZGVHUCVIWFWHDUDUEUFDUGUHVJUIUJUKABCVK
      UMUNUOWCVQWAMZCNBNANVTVQWAABCUPWIVSABCVQWAVRVQWAVPVJPZVRVKVPVJUQWJVNVOVJL
      ZVRVNVOVJURVOQPWKVRVCCUSVLVMVODQUTVDSTVAVBSTVEVRABCEVFVG $.

    $( Alternate definition of ` tpos ` .  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    dftpos4 $p |- tpos F =
        ( F o. ( x e. ( ( _V X. _V ) u. { (/) } ) |-> U. `' { x } ) ) $=
      ( vy vz vw cvv csn cun cv ccnv cuni wss wceq cop wcel wbr wa wex vex wb
      ctpos cxp cmpt ccom cdm df-tpos cres wrel relcnv df-rel mpbi unss1 resmpt
      c0 mp2b resss eqsstr3i coss2 ax-mp eqsstri relco opelco eleq1 sneq cnveqd
      unieqd eqeq2d anbi12d anbi2d df-mpt brab wi simplr breldm adantl eqeltrrd
      eqeq1 opswap eleq1i opelcnv bitr4i eleq1d bibi12d mpbiri exlimivv biimpcd
      elvv sylbi elun1 syl6 syl elun2 a1i wo simpll sylib mpjaod simpr eqbrtrrd
      elun jca sylanb brtpos2 sylibr df-br exlimiv relssi eqssi ) BUAZBAFFUBZUN
      GZHZAIZGZJZKZUCZUDZXIBABUEZJZXKHZXPUCZUDZXRABUFYBXQLYCXRLYBXQYAUGZXQXTXJL
      ZYAXLLYDYBMXTUHYEXSUIXTUJUKXTXJXKULAXLYAXPUMUOXQYAUPUQYBXQBURUSUTCDXRXIBX
      QVACIZDIZNZXROYFEIZXQPZYIYGBPZQZERYHXIOZEYFYGBXQCSZDSZVBYLYMEYLYFYGXIPZYM
      YLYFYAOZYFGZJZKZYGBPZQZYPYJYFXLOZYIYTMZQZYKUUBXMXLOZYGXPMZQUUCYGYTMZQUUEA
      DYFYIXQYNESZXMYFMZUUFUUCUUGUUHXMYFXLVCUUJXPYTYGUUJXOYSUUJXNYRXMYFVDVEVFVG
      VHYGYIMUUHUUDUUCYGYIYTVQVIADXLXPVJVKUUEYKQZYQUUAUUKYFXJOZYQYFXKOZUUKYTXSO
      ZUULYQVLUUKYIYTXSUUCUUDYKVMZYKYIXSOUUEYIYGBUUIYOVNVOVPUUNUULYFXTOZYQUULUU
      NUUPUULYFYGYINZMZERDRUUNUUPTZDEYFWGUURUUSDEUURUUSUUQGZJZKZXSOZUUQXTOZTUVC
      YIYGNZXSOUVDUVBUVEXSYGYIVRVSYGYIXSYOUUIVTWAUURUUNUVCUUPUVDUURYTUVBXSUURYS
      UVAUURYRUUTYFUUQVDVEVFWBYFUUQXTVCWCWDWEWHWFYFXTXKWIWJWKUUMYQVLUUKYFXKXTWL
      WMUUKUUCUULUUMWNUUCUUDYKWOYFXJXKWTWPWQUUKYIYTYGBUUOUUEYKWRWSXAXBYGFOYPUUB
      TYOYFYGBFXCUSXDYFYGXIXEWPXFWHXGXH $.

    $( Value of the double transposition for a general class ` F ` .
       (Contributed by Mario Carneiro, 16-Sep-2015.) $)
    tpostpos $p |- tpos tpos F =
        ( F i^i ( ( ( _V X. _V ) u. { (/) } ) X. _V ) ) $=
      ( vz vx vy cvv c0 csn wrel cv ccnv wcel wbr wa wo wb syl6bb syl6eq breq1d
      cuni vex vw ctpos cxp cun cin reltpos wss inss2 relxp relss relcnv df-rel
      mp2 cdm mpbi simpl sseldi simpr cop wceq elvv eleq1 opelcnv cnveqd unieqd
      sneq opswap anbi12d opex breldm pm4.71ri brtpos ax-mp bitr3i breq1 bitr4d
      wex exlimivv sylbi iba bitrd pm5.21nii elsni sneqd cnvsn0 brtpos0 pm5.32i
      uni0 ancom bitri orbi12i andi 3bitr4i elun anbi1i mpbiran2 anbi2i brtpos2
      andir brxp brin eqbrriv ) UABAUBZUBZAEEUCZFGZUDZEUCZUEZXCUFXIXHUGXHHXIHAX
      HUHXGEUIXIXHUJUMUAIZXCUNZJZXFUDKZXJGZJZSZBIZXCLZMZXJXQALZXJXQXHLZMZXJXQXD
      LZXJXQXILXJXLKZXJXFKZNZXRMZXTXJXEKZYENZMZXSYBYDXRMZYEXRMZNXTYHMZXTYEMZNYG
      YJYKYMYLYNYKYHYMYKXLXEXJXLHXLXEUGXKUKXLULUOYDXRUPUQXTYHURYHYKXTYMYHXJCIZD
      IZUSZUTZDVQCVQYKXTOZCDXJVAYRYSCDYRYKYQXQALZXTYRYKYPYOUSZXKKZUUAXQXCLZMZYT
      YRYDUUBXRUUCYRYDYQXLKUUBXJYQXLVBYOYPXKCTDTVCPYRXPUUAXQXCYRXPYQGZJZSUUAYRX
      OUUFYRXNUUEXJYQVFVDVEYOYPVGQRVHUUDUUCYTUUCUUBUUAXQXCYPYOVIBTZVJVKXQEKZUUC
      YTOUUGYPYOXQAEVLVMVNPXJYQXQAVOVPVRVSYHXTVTWAWBYLYEXTMYNYEXRXTYEXRFXQALZXT
      YEXRFXQXCLZUUIYEXPFXQXCYEXPFSFYEXOFYEXOXFJFYEXNXFYEXJFXJFWCZWDVDWEQVEWHQR
      UUHUUJUUIOUUGXQAEWFVMPYEXJFXQAUUKRVPWGYEXTWIWJWKYDYEXRWSXTYHYEWLWMXMYFXRX
      JXLXFWNWOYAYIXTYAXJXGKZYIYAUULUUHUUGXJXQXGEWTWPXJXEXFWNWJWQWMUUHYCXSOUUGX
      JXQXCEWRVMXJXQAXHXAWMXB $.

    $( Value of the double transposition for a relation on triples.
       (Contributed by Mario Carneiro, 16-Sep-2015.) $)
    tpostpos2 $p |- ( ( Rel F /\ Rel dom F ) -> tpos tpos F = F ) $=
      ( wrel cdm wa ctpos cvv cxp csn cun cin tpostpos wss relrelss ssun1 xpss1
      c0 wceq ax-mp sstr mpan2 sylbi df-ss sylib syl5eq ) ABACBDZAEEAFFGZPHZIZF
      GZJZAAKUEAUILZUJAQUEAUFFGZLZUKAMUMULUILZUKUFUHLUNUFUGNUFUHFORAULUISTUAAUI
      UBUCUD $.

    $( The domain of a transposition.  (Contributed by NM, 10-Sep-2015.) $)
    tposfn2 $p |- ( Rel A -> ( F Fn A -> tpos F Fn `' A ) ) $=
      ( wrel wfun cdm wceq wa ctpos ccnv wfn wi tposfun a1i dmtpos releq eqeq2d
      cnveq 3imtr3d com12 df-fn anim12d 3imtr4g ) ACZBDZBEZAFZGBHZDZUGEZAIZFZGB
      AJUGUJJUCUDUHUFUKUDUHKUCBLMUFUCUKUFUECZUIUEIZFZUCUKULUNKUFBNMUEAOUFUMUJUI
      UEAQPRSUABATUGUJTUB $.

    $( Condition for a surjective transposition.  (Contributed by NM,
       10-Sep-2015.) $)
    tposfo2 $p |- ( Rel A ->
        ( F : A -onto-> B -> tpos F : `' A -onto-> B ) ) $=
      ( wrel wfn crn wceq wa ctpos ccnv wfo tposfn2 adantrd cdm releqd biimparc
      fndm rntpos syl df-fo eqeq1d biimprd expimpd jcad 3imtr4g ) ADZCAEZCFZBGZ
      HZCIZAJZEZUKFZBGZHABCKULBUKKUFUJUMUOUFUGUMUIACLMUFUGUIUOUFUGHZUOUIUPUNUHB
      UPCNZDZUNUHGUGURUFUGUQAACQOPCRSUAUBUCUDABCTULBUKTUE $.

    $( The domain and range of a transposition.  (Contributed by NM,
       10-Sep-2015.) $)
    tposf2 $p |- ( Rel A -> ( F : A --> B -> tpos F : `' A --> B ) ) $=
      ( wrel wf ccnv ctpos crn wss wfo wfn ffn dffn4 sylib tposfo2 syl5 imp fof
      wa syl frn adantl fss syl2anc ex ) ADZABCEZAFZBCGZEZUFUGSZUHCHZUIEZULBIZU
      JUKUHULUIJZUMUFUGUOUGAULCJZUFUOUGCAKUPABCLACMNAULCOPQUHULUIRTUGUNUFABCUAU
      BUHULBUIUCUDUE $.

    $( Condition for an injective transposition.  (Contributed by NM,
       10-Sep-2015.) $)
    tposf12 $p |- ( Rel A -> ( F : A -1-1-> B -> tpos F : `' A -1-1-> B ) ) $=
      ( vx wrel wf1 ccnv ctpos wa cdm cv csn cuni cmpt wceq wb syl f1eq1 mpbird
      3syl ccom simpr relcnv cnvf1o f1of1 simpl dfrel2 sylib f1eq3 mpbii cnveqd
      wf1o mp2b f1dm mpteq1 f1co syl2anc releqd biimparc dftpos2 ex ) AEZABCFZA
      GZBCHZFZVBVCIZVFVDBCDCJZGZDKLGMZNZUAZFZVGVCVDAVKFZVMVBVCUBZVGVNVDADVDVJNZ
      FZVGVDVDGZVPFZVQVDEVDVRVPULVSAUCDVDUDVDVRVPUEUMVGVRAOZVSVQPVGVBVTVBVCUFAU
      GUHVRAVDVPUIQUJVGVIVDOVKVPOVNVQPVGVHAVGVCVHAOVOABCUNZQUKDVIVDVJUOVDAVKVPR
      TSVDABCVKUPUQVGVHEZVEVLOVFVMPVCWBVBVCVHAWAURUSDCUTVDBVEVLRTSVA $.

    $( Condition of a bijective transposition.  (Contributed by NM,
       10-Sep-2015.) $)
    tposf1o2 $p |- ( Rel A ->
      ( F : A -1-1-onto-> B -> tpos F : `' A -1-1-onto-> B ) ) $=
      ( wrel wf1 wfo wa ccnv ctpos wf1o tposf12 tposfo2 anim12d df-f1o 3imtr4g
      ) ADZABCEZABCFZGAHZBCIZEZSBTFZGABCJSBTJPQUARUBABCKABCLMABCNSBTNO $.

    $( The domain and range of a transposition.  (Contributed by NM,
       10-Sep-2015.) $)
    tposfo $p |- ( F : ( A X. B ) -onto-> C ->
              tpos F : ( B X. A ) -onto-> C ) $=
      ( cxp wfo ccnv ctpos wrel wi relxp tposfo2 ax-mp wceq cnvxp foeq2 sylib
      wb ) ABEZCDFZSGZCDHZFZBAEZCUBFZSITUCJABKSCDLMUAUDNUCUERABOUAUDCUBPMQ $.

    $( The domain and range of a transposition.  (Contributed by NM,
       10-Sep-2015.) $)
    tposf $p |- ( F : ( A X. B ) --> C -> tpos F : ( B X. A ) --> C ) $=
      ( cxp wf ccnv ctpos wrel wi relxp tposf2 ax-mp cnvxp feq2i sylib ) ABEZCD
      FZQGZCDHZFZBAEZCTFQIRUAJABKQCDLMSUBCTABNOP $.

    $( Functionality of a transposition.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    tposfn $p |- ( F Fn ( A X. B ) -> tpos F Fn ( B X. A ) ) $=
      ( cxp cvv wf ctpos wfn tposf dffn2 3imtr4i ) ABDZECFBADZECGZFCLHNMHABECIL
      CJMNJK $.

    $( Transposition of the empty set.  (Contributed by NM, 10-Sep-2015.) $)
    tpos0 $p |- tpos (/) = (/) $=
      ( c0 ctpos wfn wceq ccnv wrel rel0 eqid fn0 mpbir tposfn2 mp2 cnv0 fneq2i
      mpbi ) ABZACZPADPAEZCZQAFAACZSGTAADAHAIJAAKLRAPMNOPIO $.

    $( Transposition of a composition.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    tposco $p |- tpos ( F o. G ) = ( F o. tpos G ) $=
      ( vx ccom cvv cxp c0 csn cun cv ccnv cuni cmpt ctpos coass dftpos4 coeq2i
      3eqtr4i ) ABDZCEEFGHICJHKLMZDABTDZDSNABNZDABTOCSPUBUAACBPQR $.

    $( Two ways to say a function is symmetric.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    tpossym $p |- ( F Fn ( A X. A ) ->
      ( tpos F = F <-> A. x e. A A. y e. A ( x F y ) = ( y F x ) ) ) $=
      ( cxp ctpos wceq cv co wral wb tposfn eqfnov2 mpancom eqcom ovtpos eqeq2i
      wfn bitri 2ralbii syl6bb ) DCCEZRZDFZDGZAHZBHZUDIZUFUGDIZGZBCJACJZUIUGUFD
      IZGZBCJACJUDUBRUCUEUKKCCDLABCCUDDMNUJUMABCCUJUIUHGUMUHUIOUHULUIUFUGDPQSTU
      A $.

  $}

  ${
    tposeqi.1 $e |- F = G $.
    $( Equality theorem for transposition.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    tposeqi $p |- tpos F = tpos G $=
      ( wceq ctpos tposeq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    tposex.1 $e |- F e. _V $.
    $( A transposition is a set.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    tposex $p |- tpos F e. _V $=
      ( cvv wcel ctpos tposexg ax-mp ) ACDAECDBACFG $.
  $}

  ${
    $d x y $.  $d y F $.
    nftpos.1 $e |- F/_ x F $.
    $( Hypothesis builder for transposition.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    nftpos $p |- F/_ x tpos F $=
      ( vy ctpos cvv cxp c0 csn cv ccnv cuni cmpt ccom dftpos4 nfcv nfco nfcxfr
      cun ) ABEBDFFGHISDJIKLMZNDBOABTCATPQR $.
  $}

  ${
    $d a b c w x y z $.  $d a b c w ph $.
    tposoprab.1 $e |- F = { <. <. x , y >. , z >. | ph } $.
    $( Transposition of a class of ordered triples.  (Contributed by Mario
       Carneiro, 10-Sep-2015.) $)
    tposoprab $p |- tpos F = { <. <. y , x >. , z >. | ph } $=
      ( vb va vc ctpos coprab cv cop wbr tposeqi wceq nfcv nfbr nfv weq dftpos3
      cdm reldmoprab ax-mp nfoprab2 nfoprab1 wa opeq12 ancoms breq1d cbvoprab12
      wrel nfoprab3 breq2 df-br oprabid bitri syl6bb cbvoprab3 eqtri 3eqtri
      wcel ) EJABCDKZJZGLZHLZMZILZVCNZHGIKZACBDKZEVCFOVCUBULVDVJPABCDUCHGIVCUAU
      DVJBLZCLZMZVHVCNZCBIKVKVIVOHGICBCVGVHVCCVGQABCDUECVHQRBVGVHVCBVGQABCDUFBV
      HQRVOHSVOGSHCTZGBTZUGVGVNVHVCVQVPVGVNPVEVFVLVMUHUIUJUKVOACBIDDVNVHVCDVNQA
      BCDUMDVHQRAISIDTVOVNDLZVCNZAVHVRVNVCUNVSVNVRMVCVBAVNVRVCUOABCDUPUQURUSUTV
      A $.
  $}

  ${
    $d x y z $.  $d z A $.  $d z B $.  $d z C $.
    tposmpt2.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( Transposition of a two-argument mapping.  (Contributed by Mario
       Carneiro, 10-Sep-2015.) $)
    tposmpt2 $p |- tpos F = ( y e. B , x e. A |-> C ) $=
      ( vz ctpos cv wcel wceq coprab cmpt2 df-mpt2 ancom anbi1i oprabbii 3eqtri
      wa tposoprab eqtr4i ) FIBJDKZAJCKZTZHJELZTZBAHMBADCENUGABHFFABCDENUDUCTZU
      FTZABHMUGABHMGABHCDEOUIUGABHUHUEUFUDUCPQRSUABAHDCEOUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Curry and uncurry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c curry $.
  $c uncurry $.

  $( Extend class notation to include the currying function. $)
  ccur $a class curry A $.

  $( Extend class notation to include the uncurrying function. $)
  cunc $a class uncurry A $.

  ${
    $d x y z F $.
    $( Define the currying of ` F ` , which splits a function of two arguments
       into a function of the first argument, producing a function over the
       second argument.  (Contributed by Mario Carneiro, 7-Jan-2017.) $)
    df-cur $a |- curry F = ( x e. dom dom F |->
      { <. y , z >. | <. x , y >. F z } ) $.

    $( Define the uncurrying of ` F ` , which takes a function producing
       functions, and transforms it into a two-argument function.  (Contributed
       by Mario Carneiro, 7-Jan-2017.) $)
    df-unc $a |- uncurry F = { <. <. x , y >. , z >. | y ( F ` x ) z } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Proper subset relation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c [C.] $.

  $( Extend class notation to include the reified proper subset relation. $)
  crpss $a class [C.] $.

  ${
    $d x y A $.  $d x y B $.
    $( Define a relation which corresponds to proper subsethood ~ df-pss on
       sets.  This allows us to use proper subsethood with general concepts
       that require relations, such as strict ordering, see ~ sorpss .
       (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    df-rpss $a |- [C.] = { <. x , y >. | x C. y } $.

    $( The proper subset relation is a relation.  (Contributed by Stefan
       O'Rear, 2-Nov-2014.) $)
    relrpss $p |- Rel [C.] $=
      ( vx vy cv wpss crpss df-rpss relopabi ) ACBCDABEABFG $.

    $( The proper subset relation on sets is the same as class proper
       subsethood.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    brrpssg $p |- ( B e. V -> ( A [C.] B <-> A C. B ) ) $=
      ( vx vy wcel crpss wbr wpss wa elex relrpss brrelexi anim12i adantr pssss
      cvv wss ssexg cv syl2anr jca psseq1 psseq2 df-rpss brabg ancoms pm5.21nd
      wb ) BCFZABGHZABIZBQFZAQFZJUJUMUKUNBCKZABGLMNUJULJUMUNUJUMULUOOULABRUMUNU
      JABPUOABQSUAUBUNUMUKULUIDTZETZIAUQIULDEABQQGUPAUQUCUQBAUDDEUEUFUGUH $.
  $}

  ${
    brrpss.a $e |- B e. _V $.
    $( The proper subset relation on sets is the same as class proper
       subsethood.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    brrpss $p |- ( A [C.] B <-> A C. B ) $=
      ( cvv wcel crpss wbr wpss wb brrpssg ax-mp ) BDEABFGABHICABDJK $.
  $}

  ${
    $d x y z A $.
    $( Every class is partially ordered by proper subsets.  (Contributed by
       Stefan O'Rear, 2-Nov-2014.) $)
    porpss $p |- [C.] Po A $=
      ( vx vy vz crpss wpo cv wbr wn wa wi wral wpss pssirr psstr brrpss notbii
      vex anbi12i imbi12i mpbir2an rgenw rgen2w df-po mpbir ) AEFBGZUFEHZIZUFCG
      ZEHZUIDGZEHZJZUFUKEHZKZJZDALZCALBALUQBCAAUPDAUPUFUFMZIZUFUIMZUIUKMZJZUFUK
      MZKZUFNUFUIUKOUHUSUOVDUGURUFUFBRPQUMVBUNVCUJUTULVAUFUICRPUIUKDRZPSUFUKVEP
      TSUAUBUCBCDAEUDUE $.

    $( Express strict ordering under proper subsets, i.e. the notion of a chain
       of sets.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    sorpss $p |- ( [C.] Or A <-> A. x e. A A. y e. A ( x C_ y \/ y C_ x ) ) $=
      ( cv crpss wbr weq w3o wral wpo wss wor porpss biantrur wpss sspsstri vex
      wa wo brrpss biid 3orbi123i bitr4i 2ralbii df-so 3bitr4ri ) ADZBDZEFZABGZ
      UHUGEFZHZBCIACIZCEJZUMRUGUHKUHUGKSZBCIACICELUNUMCMNUOULABCCUOUGUHOZUJUHUG
      OZHULUGUHPUIUPUJUJUKUQUGUHBQTUJUAUHUGAQTUBUCUDABCEUEUF $.
  $}

  $( Property of a chain of sets.  (Contributed by Stefan O'Rear,
     2-Nov-2014.) $)
  sorpssi $p |- ( ( [C.] Or A /\ ( B e. A /\ C e. A ) ) ->
      ( B C_ C \/ C C_ B ) ) $=
    ( crpss wor wcel wa wpss wceq w3o wss wo wbr solin wb elex ad2antll brrpssg
    cvv syl biidd ad2antrl 3orbi123d mpbid sspsstri sylibr ) ADEZBAFZCAFZGGZBCH
    ZBCIZCBHZJZBCKCBKLUJBCDMZULCBDMZJUNABCDNUJUOUKULULUPUMUJCSFZUOUKOUIUQUGUHCA
    PQBCSRTUJULUAUJBSFZUPUMOUHURUGUIBAPUBCBSRTUCUDBCUEUF $.

  $( A chain of sets is closed under binary union.  (Contributed by Mario
     Carneiro, 16-May-2015.) $)
  sorpssun $p |- ( ( [C.] Or A /\ ( B e. A /\ C e. A ) ) ->
      ( B u. C ) e. A ) $=
    ( crpss wor wcel wa wss cun simprr wb ssequn1 eleq1 sylbi syl5ibrcom simprl
    wceq ssequn2 sorpssi mpjaod ) ADEZBAFZCAFZGGZBCHZBCIZAFZCBHZUDUGUEUCUAUBUCJ
    UEUFCQUGUCKBCLUFCAMNOUDUGUHUBUAUBUCPUHUFBQUGUBKCBRUFBAMNOABCST $.

  $( A chain of sets is closed under binary intersection.  (Contributed by
     Mario Carneiro, 16-May-2015.) $)
  sorpssin $p |- ( ( [C.] Or A /\ ( B e. A /\ C e. A ) ) ->
      ( B i^i C ) e. A ) $=
    ( crpss wor wcel wa wss cin simprl wceq df-ss eleq1 sylbi syl5ibrcom simprr
    wb dfss1 sorpssi mpjaod ) ADEZBAFZCAFZGGZBCHZBCIZAFZCBHZUDUGUEUBUAUBUCJUEUF
    BKUGUBQBCLUFBAMNOUDUGUHUCUAUBUCPUHUFCKUGUCQCBRUFCAMNOABCST $.

  ${
    $d Y z w u v $.
    $( In a chain of sets, a maximal element is the union of the chain.
       (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    sorpssuni $p |- ( [C.] Or Y -> ( E. u e. Y A. v e. Y -. u C. v <->
        U. Y e. Y ) ) $=
      ( crpss wor cv wpss wn wral wrex cuni wcel w3a wss wa sorpssi syl elssuni
      wo wi anassrs sspss orel1 eqimss2 syl6com sylbi ax-1 jaoi ralimdva 3impia
      weq unissb sylibr 3ad2ant2 eqssd simp2 rexlimdv3a ssnpss rgen wceq psseq1
      eqeltrd notbid ralbidv rspcev mpan2 impbid1 ) CDEZBFZAFZGZHZACIZBCJZCKZCL
      ZVHVMVPBCVHVICLZVMMZVOVICVRVOVIVRVJVINZACIZVOVINVHVQVMVTVHVQOZVLVSACWAVJC
      LZOVIVJNZVSSZVLVSTZVHVQWBWDCVIVJPUAWCWEVSWCVKBAUKZSZWEVIVJUBVLWGWFVSVKWFU
      CVJVIUDUEUFVSVLUGUHQUIUJACVIULUMVQVHVIVONVMVICRUNUOVHVQVMUPVBUQVPVOVJGZHZ
      ACIZVNWIACWBVJVONWIVJCRVJVOURQUSVMWJBVOCVIVOUTZVLWIACWKVKWHVIVOVJVAVCVDVE
      VFVG $.

    $( In a chain of sets, a minimal element is the intersection of the chain.
       (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    sorpssint $p |- ( [C.] Or Y -> ( E. u e. Y A. v e. Y -. v C. u <->
        |^| Y e. Y ) ) $=
      ( crpss wor cv wpss wn wral wrex cint wcel w3a wss intss1 3ad2ant2 wa syl
      wo wi sorpssi anassrs ax-1 weq sspss orel1 eqimss2 syl6com sylbi ralimdva
      jaoi 3impia ssint sylibr eqssd eqeltrd rexlimdv3a ssnpss rgen wceq psseq2
      simp2 notbid ralbidv rspcev mpan2 impbid1 ) CDEZAFZBFZGZHZACIZBCJZCKZCLZV
      HVMVPBCVHVJCLZVMMZVOVJCVRVOVJVQVHVOVJNVMVJCOPVRVJVINZACIZVJVONVHVQVMVTVHV
      QQZVLVSACWAVICLZQVSVIVJNZSZVLVSTZVHVQWBWDCVJVIUAUBVSWEWCVSVLUCWCVKABUDZSZ
      WEVIVJUEVLWGWFVSVKWFUFVJVIUGUHUIUKRUJULAVJCUMUNUOVHVQVMVBUPUQVPVIVOGZHZAC
      IZVNWIACWBVOVINWIVICOVOVIURRUSVMWJBVOCVJVOUTZVLWIACWKVKWHVJVOVIVAVCVDVEVF
      VG $.
  $}

  ${
    $d Y z w b c $.  $d Y x y $.  $d Y d $.  $d d A b c $.  $d A x y b c $.
    $d Y u $.  $d A u $.  $d d u x y $.
    $( The componentwise complement of a chain of sets is also a chain of
       sets.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    sorpsscmpl $p |- ( [C.] Or Y -> [C.] Or { u e. ~P A | ( A \ u ) e. Y } ) $=
      ( vx vy crpss wor cv wss wo cdif wcel wral wa difeq2 eleq1d elrab syl2anb
      weq wi cpw crab an4 biimpi sorpssi expcom wceq vex elpw dfss4 bitri sscon
      sseq12 syl5ib ancoms orim12d com12 orcoms syl6 com3l imp3a syl5 ralrimivv
      wb sorpss sylibr ) CFGZDHZEHZIZVIVHIZJZEBAHZKZCLZABUAZUBZMDVQMVQFGVGVLDEV
      QVQVHVQLZVIVQLZNVHVPLZVIVPLZNZBVHKZCLZBVIKZCLZNZNZVGVLVRVTWDNZWAWFNZWHVSV
      OWDAVHVPADSVNWCCVMVHBOPQVOWFAVIVPAESVNWECVMVIBOPQWIWJNWHVTWDWAWFUCUDRVGWB
      WGVLWGVGWBVLWGVGWCWEIZWEWCIZJZWBVLTZVGWGWMCWCWEUEUFWLWKWNWBWLWKJZVLVTBWCK
      ZVHUGZBWEKZVIUGZWOVLTWAVTVHBIWQVHBDUHUIVHBUJUKWAVIBIWSVIBEUHUIVIBUJUKWQWS
      NZWLVJWKVKWLWPWRIWTVJWEWCBULWPVHWRVIUMUNWKWRWPIZWTVKWCWEBULWSWQXAVKVDWRVI
      WPVHUMUOUNUPRUQURUSUTVAVBVCDEVQVEVF $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Iota properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z A $.  $d w z F $.  $d x ps $.
    fvopab5.1 $e |- F = { <. x , y >. | ph } $.
    fvopab5.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( The value of a function that is expressed as an ordered pair
       abstraction.  (Contributed by NM, 19-Feb-2006.)  (Revised by Mario
       Carneiro, 11-Sep-2015.) $)
    fvopab5 $p |- ( A e. V -> ( F ` A ) = ( iota y ps ) ) $=
      ( vz wcel cvv cio wceq cv wbr nfcv nfcxfr nfbr nfv elex df-fv breq2 copab
      cfv nfopab2 cbviota eqtri wb nfopab1 nfbi breq1 bibi12d cop eleq2i opabid
      df-br 3bitri vtoclgf iotabidv syl5eq syl ) EGKELKZEFUEZBDMZNEGUAVCVDEDOZF
      PZDMZVEVDEJOZFPZJMVHJEFUBVJVGJDVIVFEFUCDEVIFDEQDFACDUDZHACDUFRDVIQSVGJTUG
      UHVCVGBDCOZVFFPZAUIVGBUICELCEQZVGBCCEVFFVNCFVKHACDUJRCVFQSBCTUKVLENVMVGAB
      VLEVFFULIUMVMVLVFUNZFKVOVKKAVLVFFUQFVKVOHUOACDUPURUSUTVAVB $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.  $d y ch $.  $d w z ph $.
    $d w x y z D $.  $d x ps $.
    opiota.1 $e |- I =
      ( iota z E. x e. A E. y e. B ( z = <. x , y >. /\ ph ) ) $.
    opiota.2 $e |- X = ( 1st ` I ) $.
    opiota.3 $e |- Y = ( 2nd ` I ) $.
    opiota.4 $e |- ( x = C -> ( ph <-> ps ) ) $.
    opiota.5 $e |- ( y = D -> ( ps <-> ch ) ) $.
    $( The property of a uniquely specified ordered pair.  (Contributed by
       Mario Carneiro, 21-May-2015.) $)
    opiota $p |- ( E! z E. x e. A E. y e. B ( z = <. x , y >. /\ ph ) ->
      ( ( C e. A /\ D e. B /\ ch ) <-> ( C = X /\ D = Y ) ) ) $=
      ( wceq wa cv cop wrex weu wcel c1st cfv c2nd w3a ceqsrex2v bicomd cio cvv
      opex a1i id wb eqeq1 eqcom opth bitri syl6bb anbi1d 2rexbidv adantl nfeu1
      vex nfcvd iota2df eqeq1i syl6bbr sylan9bbr pm5.32da cxp cab opelxpi simpl
      nfvd eleq1d syl5ibrcom rexlimivv abssi iotacl sseldi opelxp eleq1 syl5bbr
      syl5eqel pm4.71rd 1st2nd2 eqeq2d 3bitr2d df-3an eqeq2i anbi12i fvex opth2
      syl bitr4i 3bitr4g ) FUAZDUAZEUAZUBZSZATZEHUCDGUCZFUDZIGUEZJHUEZTZCTZIJUB
      ZKUFUGZKUHUGZUBZSZXIXJCUIILSZJMSZTZXHXLXKXMKSZTYAXQXHXKCYAXKCXBISXCJSTZAT
      ZEHUCDGUCZXHYAXKYDCABCDEIJGHQRUJUKXHYDXGFULZXMSZYAXHXGYDFXMUMXMUMUEXHIJUN
      UOXHUPXAXMSZXGYDUQXHYGXFYCDEGHYGXEYBAYGXEXMXDSZYBXAXMXDURYHXDXMSYBXMXDUSX
      BXCIJDVGEVGUTVAVBVCVDVEXGFVFXHYDFVRXHFXMVHVIYAKXMSYFXMKUSKYEXMNVJVAVKVLVM
      XHYAXKXHXKYAKGHVNZUEZXHKYEYINXHXGFVOYIYEXGFYIXFXAYIUEZDEGHXBGUEXCHUETYKXF
      XDYIUEXBXCGHVPXFXAXDYIXEAVQVSVTWAWBXGFWCWDWHZXKXMYIUEYAYJIJGHWEXMKYIWFWGV
      TWIXHKXPXMXHYJKXPSYLKGHWJWRWKWLXIXJCWMXTIXNSZJXOSZTXQXRYMXSYNLXNIOWNMXOJP
      WNWOIJXNXOKUFWPKUHWPWQWSWT $.
  $}

  ${
    $d x y z B $.  $d x y z F $.  $d z ph $.  $d x z ps $.
    opabiota.1 $e |- F = { <. x , y >. | { y | ph } = { y } } $.
    $( Define a function whose value is "the unique ` y ` such that
       ` ph ( x , y ) ` ".  (Contributed by NM, 19-May-2015.) $)
    opabiotafun $p |- Fun F $=
      ( vz wfun cab cv csn wceq copab wmo funopab cuni mo2icl unieq vex mpbir
      wi unisn syl6req mpg nfv nfab1 nfeq1 sneq eqeq2d cbvmo mpgbir funeqi ) DG
      ACHZCIZJZKZBCLZGZUQUOCMZBUOBCNURULFIZJZKZFMZVAUSULOZKTVBFVAFVCPVAVCUTOUSU
      LUTQUSFRUAUBUCUOVACFUOFUDCULUTACUEUFUMUSKUNUTULUMUSUGUHUISUJDUPEUKS $.

    $( Define a function whose value is "the unique ` y ` such that
       ` ph ( x , y ) ` ".  (Contributed by NM, 16-Nov-2013.) $)
    opabiotadm $p |- dom F = { x | E! y ph } $=
      ( cab cv csn wceq copab cdm wex weu dmopab dmeqi euabsn abbii 3eqtr4i ) A
      CFCGHIZBCJZKSCLZBFDKACMZBFSBCNDTEOUBUABACPQR $.

    opabiota.2 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Define a function whose value is "the unique ` y ` such that
       ` ph ( x , y ) ` ".  (Contributed by NM, 16-Nov-2013.) $)
    opabiota $p |- ( B e. dom F -> ( F ` B ) = ( iota y ps ) ) $=
      ( cv cfv cio wceq cdm fveq2 iotabidv eqeq12d wcel vex sylib sylbi wbr wex
      eldm nfiota1 nfeq2 wfun opabiotafun funbrfv ax-mp cab csn cop copab df-br
      wi eleq2i opabid 3bitri snid id syl5eleqr weu wb breldm opabiotadm abeq2i
      abid iota1 syl mpbid eqtr4d exlimi vtoclga ) CIZFJZADKZLZEFJZBDKZLCEFMZVN
      ELZVOVRVPVSVNEFNWAABDHOPVNVTQZVNDIZFUAZDUBVQDVNFCRZUCWDVQDDVOVPADUDUEWDVO
      WCVPFUFWDVOWCLUOACDFGUGVNWCFUHUIWDAVPWCLZWDADUJZWCUKZLZAWDVNWCULZFQWJWICD
      UMZQWIVNWCFUNFWKWJGUPWICDUQURWIWCWGQAWIWCWHWGWCDRZUSWIUTVAADVGSTWDADVBZAW
      FVCWDWBWMVNWCFWEWLVDWMCVTACDFGVEVFSADVHVIVJVKVLTVM $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cantor's Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y F $.
    canth.1 $e |- A e. _V $.
    $( No set ` A ` is equinumerous to its power set (Cantor's theorem), i.e.
       no function can map ` A ` it onto its power set.  Compare Theorem 6B(b)
       of [Enderton] p. 132.  For the equinumerosity version, see ~ canth2 .
       Note that ` A ` must be a set: this theorem does not hold when ` A ` is
       too large to be a set; see ~ ncanth for a counterexample.  (Use ~ nex if
       you want the form ` -. E. f f : A -onto-> ~P A ` .)  (Contributed by NM,
       7-Aug-1994.)  (Proof shortened by Mario Carneiro, 7-Jun-2016.) $)
    canth $p |- -. F : A -onto-> ~P A $=
      ( vx vy cpw wfo cv cfv wcel wn crab crn wss ssrab2 elpw2 mpbir forn wceq
      wb syl5eleqr wrex id fveq2 eleq12d elrab baibr nbbn sylib eleq2 nsyl nrex
      notbid wfn fofn fvelrnb syl mtbiri pm2.65i ) AAFZBGZDHZVBBIZJZKZDALZBMZJZ
      VAVFUTVGVFUTJVFANVEDAOVFACPQAUTBRUAVAVHEHZBIZVFSZEAUBZVKEAVIAJZVIVJJZVIVF
      JZTZVKVMVNKZVOTVPKVOVMVQVEVQDVIAVBVISZVDVNVRVBVIVCVJVRUCVBVIBUDUEUMUFUGVN
      VOUHUIVJVFVIUJUKULVABAUNVHVLTAUTBUOEAVFBUPUQURUS $.
  $}

  $( Cantor's theorem fails for the universal class (which is not a set but a
     proper class by ~ vprc ).  Specifically, the identity function maps the
     universe onto its power class.  Compare ~ canth that works for sets.  See
     also the remark in ~ ru about NF, in which Cantor's theorem fails for sets
     that are "too large."  This theorem gives some intuition behind that
     failure: in NF the universal class is a set, and it equals its own power
     set.  (Contributed by NM, 29-Jun-2004.) $)
  ncanth $p |- _I : _V -onto-> ~P _V $=
    ( cvv cpw cid wf1o wfo f1ovi wceq wb pwv f1oeq3 ax-mp mpbir f1ofo ) AABZCDZ
    ANCEOAACDZFNAGOPHINAACJKLANCMK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Undefined values and restricted iota (description binder)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Undef $.
  $c iota_ $.

  $( Extend class notation with undefined value function. $)
  cund $a class Undef $.

  $( Extend class notation with restricted description binder. $)
  crio $a class ( iota_ x e. A ph ) $.

  $( Define the undefined value function, whose value at set ` s ` is
     guaranteed not to be a member of ` s ` (see ~ pwuninel ).  (Contributed by
     NM, 15-Sep-2011.) $)
  df-undef $a |- Undef = ( s e. _V |-> ~P U. s ) $.

  $( Direct proof of ~ pwuninel avoiding functions and thus several ZF axioms.
     (Contributed by Stefan O'Rear, 22-Feb-2015.) $)
  pwuninel2 $p |- ( U. A e. V -> -. ~P U. A e. A ) $=
    ( cuni wcel cpw wss pwnss elssuni nsyl ) ACZBDJEZJFKADJBGKAHI $.

  $( The power set of the union of a set does not belong to the set.  This
     theorem provides a way of constructing a new set that doesn't belong to a
     given set.  See also ~ pwuninel2 .  (Contributed by NM, 27-Jun-2008.)
     (Proof shortened by Mario Carneiro, 23-Dec-2016.) $)
  pwuninel $p |- -. ~P U. A e. A $=
    ( cuni cpw wcel wn cvv elex pwexb sylibr pwuninel2 syl id pm2.61i ) ABZCZAD
    ZPEZPNFDZQPOFDROAGNHIAFJKQLM $.

  ${
    $d s S $.
    $( Value of the undefined value function.  Normally we will not reference
       the explicit value but will use ~ undefnel instead.  (Contributed by NM,
       15-Sep-2011.)  (Revised by Mario Carneiro, 24-Dec-2016.) $)
    undefval $p |- ( S e. V -> ( Undef ` S ) = ~P U. S ) $=
      ( vs wcel cvv cuni cpw cund cfv wceq elex uniexg pwexg syl cv unieq pweqd
      df-undef fvmptg syl2anc ) ABDZAEDAFZGZEDZAHIUCJABKUAUBEDUDABLUBEMNCACOZFZ
      GUCEEHUEAJUFUBUEAPQCRST $.
  $}

  $( The undefined value generated from a set is not a member of the set.
     (Contributed by NM, 15-Sep-2011.) $)
  undefnel2 $p |- ( S e. V -> -. ( Undef ` S ) e. S ) $=
    ( wcel cund cfv cuni cpw pwuninel undefval eleq1d mtbiri ) ABCZADEZACAFGZAC
    AHLMNAABIJK $.

  $( The undefined value generated from a set is not a member of the set.
     (Contributed by NM, 15-Sep-2011.) $)
  undefnel $p |- ( S e. V -> ( Undef ` S ) e/ S ) $=
    ( wcel cund cfv wn wnel undefnel2 df-nel sylibr ) ABCADEZACFKAGABHKAIJ $.

  ${
    $( Define restricted description binder.  In case it doesn't exist, we
       return a set which is not a member of the domain of discourse ` A ` .
       See also comments for ~ df-iota .  (Contributed by NM, 15-Sep-2011.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    df-riota $a |- ( iota_ x e. A ph ) = if ( E! x e. A ph ,
      ( iota x ( x e. A /\ ph ) ) , ( Undef ` { x | x e. A } ) ) $.
  $}

  ${
    $d x ph $.
    riotaeqdv.1 $e |- ( ph -> A = B ) $.
    $( Formula-building deduction rule for iota.  (Contributed by NM,
       15-Sep-2011.) $)
    riotaeqdv $p |- ( ph -> ( iota_ x e. A ps ) = ( iota_ x e. B ps ) ) $=
      ( wreu cv wcel wa cio cab cund cfv cif crio weu eleq2d df-reu df-riota
      anbi1d eubidv 3bitr4g iotabidv abbidv fveq2d ifbieq12d 3eqtr4g ) ABCDGZCH
      ZDIZBJZCKZUKCLZMNZOBCEGZUJEIZBJZCKZUQCLZMNZOBCDPBCEPAUIUPUMUOUSVAAULCQURC
      QUIUPAULURCAUKUQBADEUJFRZUAZUBBCDSBCESUCAULURCVCUDAUNUTMAUKUQCVBUEUFUGBCD
      TBCETUH $.
  $}

  ${
    $d x ph $.
    riotabidv.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Formula-building deduction rule for restricted iota.  (Contributed by
       NM, 15-Sep-2011.) $)
    riotabidv $p |- ( ph -> ( iota_ x e. A ps ) = ( iota_ x e. A ch ) ) $=
      ( wreu cv wcel cio cab cund cfv cif crio reubidv anbi2d iotabidv df-riota
      wa eqidd ifbieq12d 3eqtr4g ) ABDEGZDHEIZBTZDJZUEDKLMZNCDEGZUECTZDJZUHNBDE
      OCDEOAUDUIUGUHUKUHABCDEFPAUFUJDABCUEFQRAUHUAUBBDESCDESUC $.
  $}

  ${
    $d x ph $.
    riotaeqbidv.1 $e |- ( ph -> A = B ) $.
    riotaeqbidv.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality deduction for restricted universal quantifier.  (Contributed by
       NM, 15-Sep-2011.) $)
    riotaeqbidv $p |- ( ph -> ( iota_ x e. A ps ) = ( iota_ x e. B ch ) ) $=
      ( crio riotabidv riotaeqdv eqtrd ) ABDEICDEICDFIABCDEHJACDEFGKL $.
  $}

  $( Restricted iota is a set.  (Contributed by NM, 15-Sep-2011.) $)
  riotaex $p |- ( iota_ x e. A ps ) e. _V $=
    ( crio wreu wcel cio cab cund cfv cif cvv df-riota iotaex fvex ifex eqeltri
    cv wa ) ABCDABCEZBRCFZASZBGZUABHZIJZKLABCMTUCUEUBBNUDIOPQ $.

  $( An iota restricted to the universe is unrestricted.  (Contributed by NM,
     18-Sep-2011.) $)
  riotav $p |- ( iota_ x e. _V ph ) = ( iota x ph ) $=
    ( cvv crio wreu wcel cio cab cund cfv cif df-riota wceq iftrue vex biantrur
    cv wa wn c0 iotabii syl6reqr weu reuv iotanul sylnbi abid2 vprc fvprc ax-mp
    fveq2i eqtri syl6eqr iffalse eqtr4d pm2.61i eqtr4i ) ABCDABCEZBQCFZARZBGZUS
    BHZIJZKZABGZABCLURVEVDMURVDVAVEURVAVCNAUTBUSABOPUAUBURSZVEVCVDVFVETVCURABUC
    VETMABUDABUEUFVCCIJZTVBCIBCUGUKCCFSVGTMUHCIUIUJULUMURVAVCUNUOUPUQ $.

  $( Restricted iota in terms of iota.  (Contributed by NM, 15-Sep-2011.) $)
  riotaiota $p |- ( E! x e. A ph
         -> ( iota_ x e. A ph ) = ( iota x ( x e. A /\ ph ) ) ) $=
    ( wreu crio cv wcel wa cio cab cund cfv cif df-riota iftrue syl5eq ) ABCDZA
    BCEQBFCGZAHBIZRBJKLZMSABCNQSTOP $.

  $( Restricted iota in terms of class union.  (Contributed by NM,
     11-Oct-2011.) $)
  riotauni $p |- ( E! x e. A ph
                    -> ( iota_ x e. A ph ) = U. { x e. A | ph } ) $=
    ( wreu crio cv wcel wa cio crab cuni riotaiota cab weu df-reu iotauni sylbi
    wceq df-rab unieqi syl6eqr eqtrd ) ABCDZABCEBFCGAHZBIZABCJZKZABCLUCUEUDBMZK
    ZUGUCUDBNUEUIRABCOUDBPQUFUHABCSTUAUB $.

  ${
    $d x y A $.  $d y ph $.
    $( The abstraction variable in a restricted iota descriptor isn't free.
       (Contributed by NM, 12-Oct-2011.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nfriota1 $p |- F/_ x ( iota_ x e. A ph ) $=
      ( crio wreu cv wcel wa cio cab cund cfv cif df-riota nfreu1 nfiota1 nfab1
      nfcv nffv nfif nfcxfr ) BABCDABCEZBFCGZAHZBIZUCBJZKLZMABCNUBBUEUGABCOUDBP
      BUFKBKRUCBQSTUA $.
  $}

  ${
    nfriotad.1 $e |- F/ y ph $.
    nfriotad.2 $e |- ( ph -> F/ x ps ) $.
    nfriotad.3 $e |- ( ph -> F/_ x A ) $.
    $( Deduction version of ~ nfriota .  (Contributed by NM, 18-Feb-2013.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfriotad $p |- ( ph -> F/_ x ( iota_ y e. A ps ) ) $=
      ( crio wreu cv wcel wa cio cab cund cfv cif wnfc adantr nfreud weq wal wn
      df-riota nfnae nfan nfcvf adantl nfeld wnf nfand nfiotad ex nfiota1 eqidd
      drnfc1 mpbiri pm2.61d2 nfcvd nfabd2 nffvd nfifd nfcxfrd ) ACBDEIBDEJZDKZE
      LZBMZDNZVGDOZPQZRBDEUEAVECVIVKABCDEFHGUAACDUBCUCZCVISZAVLUDZVMAVNMZVHCDAV
      NDFCDDUFUGVOVGBCVOCVFEVNCVFSACDUHUIACESVNHTUJZABCUKVNGTULUMUNVLVMDVISVHDU
      OCDVIVIVLVIUPUQURUSACVJPACPUTAVGCDFVPVAVBVCVD $.
  $}

  ${
    $d x y z $.  $d z A $.  $d z ph $.
    nfriota.1 $e |- F/ x ph $.
    nfriota.2 $e |- F/_ x A $.
    $( A variable not free in a wff remains so in a restricted iota
       descriptor.  (Contributed by NM, 12-Oct-2011.) $)
    nfriota $p |- F/_ x ( iota_ y e. A ph ) $=
      ( crio wnfc wtru nftru wnf a1i nfriotad trud ) BACDGHIABCDCJABKIELBDHIFLM
      N $.
  $}

  ${
    $d x z A $.  $d y z A $.  $d z ph $.  $d z ps $.
    cbvriota.1 $e |- F/ y ph $.
    cbvriota.2 $e |- F/ x ps $.
    cbvriota.3 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variable in a restricted description binder.  (Contributed
       by NM, 18-Mar-2013.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    cbvriota $p |- ( iota_ x e. A ph ) = ( iota_ y e. A ps ) $=
      ( vz wreu cv wcel wa cio cab cund cfv cif crio nfv cbvreu wsb weq sbequ12
      eleq1 anbi12d nfs1v nfan sbequ sbie syl6bb nfsb eqtri abid2 eqtr4i fveq2i
      cbviota ifbieq12i df-riota 3eqtr4i ) ACEJZCKZELZAMZCNZVCCOZPQZRBDEJZDKZEL
      ZBMZDNZVJDOZPQZRACESBDESVAVHVEVGVLVNABCDEFGHUAVEIKZELZACIUBZMZINVLVDVRCIC
      IUCVCVPAVQVBVOEUEACIUDUFVDITVPVQCVPCTACIUGUHUQVRVKIDIDUCZVPVJVQBVOVIEUEVS
      VQACDUBBAIDCUIABCDGHUJUKUFVPVQDVPDTACIDFULUHVKITUQUMVFVMPVFEVMCEUNDEUNUOU
      PURACEUSBDEUSUT $.
  $}

  ${
    $d x A $.  $d y A $.  $d y ph $.  $d x ps $.
    cbvriotav.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Change bound variable in a restricted description binder.  (Contributed
       by NM, 18-Mar-2013.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    cbvriotav $p |- ( iota_ x e. A ph ) = ( iota_ y e. A ps ) $=
      ( nfv cbvriota ) ABCDEADGBCGFH $.
  $}

  ${
    $d y z A $.  $d x z w B $.  $d w z ph $.  $d w x y $.
    $( Interchange class substitution and restricted description binder.
       (Contributed by NM, 24-Feb-2013.) $)
    csbriotag $p |- ( A e. V
      -> [_ A / x ]_ ( iota_ y e. B ph ) = ( iota_ y e. B [. A / x ]. ph ) ) $=
      ( vz cv crio csb wsb wceq wsbc csbeq1 dfsbcq2 riotabidv eqeq12d vex nfs1v
      nfcv nfriota weq sbequ12 csbief vtoclg ) BGHZACEIZJZABGKZCEIZLBDUGJZABDMZ
      CEIZLGDFUFDLZUHUKUJUMBUFDUGNUNUIULCEABGDOPQBUFUGUJGRUIBCEABGSBETUABGUBAUI
      CEABGUCPUDUE $.
  $}

  $( Membership law for "the unique element in ` A ` such that ` ph ` ."

     This can useful for expanding an iota-based definition (see ~ df-iota ).
     If you have an unbounded iota, ~ iotacl may be useful.

     (Contributed by NM, 21-Aug-2011.)  (Revised by Mario Carneiro,
     23-Dec-2016.) $)
  riotacl2 $p |- ( E! x e. A ph -> ( iota_ x e. A ph ) e. { x e. A | ph } ) $=
    ( wreu crio cv wcel wa cio crab riotaiota cab df-reu iotacl sylbi syl6eleqr
    weu df-rab eqeltrd ) ABCDZABCEBFCGAHZBIZABCJZABCKTUBUABLZUCTUABQUBUDGABCMUA
    BNOABCRPS $.

  ${
    $d x A $.
    $( Closure of restricted iota.  (Contributed by NM, 21-Aug-2011.) $)
    riotacl $p |- ( E! x e. A ph -> ( iota_ x e. A ph ) e. A ) $=
      ( wreu crab crio ssrab2 riotacl2 sseldi ) ABCDABCECABCFABCGABCHI $.
  $}

  $( Substitution law for descriptions.  Compare ~ iotasbc .  (Contributed by
     NM, 23-Aug-2011.)  (Proof shortened by Mario Carneiro, 24-Dec-2016.) $)
  riotasbc $p |- ( E! x e. A ph -> [. ( iota_ x e. A ph ) / x ]. ph ) $=
    ( wreu crio cab wcel wsbc crab rabssab riotacl2 sseldi df-sbc sylibr ) ABCD
    ZABCEZABFZGABPHOABCIQPABCJABCKLABPMN $.

  ${
    $d x ph $.
    riotabidva.1 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions (deduction
       rule).  ( ~ rabbidva analog.)  (Contributed by NM, 17-Jan-2012.) $)
    riotabidva $p |- ( ph -> ( iota_ x e. A ps ) = ( iota_ x e. A ch ) ) $=
      ( wreu cv wcel wa cio cab cund cfv crio pm5.32da iotabidv ifeq1d df-riota
      cif reubidva ifbid eqtrd 3eqtr4g ) ABDEGZDHEIZBJZDKZUFDLMNZTZCDEGZUFCJZDK
      ZUITZBDEOCDEOAUJUEUMUITUNAUEUHUMUIAUGULDAUFBCFPQRAUEUKUMUIABCDEFUAUBUCBDE
      SCDESUD $.
  $}

  ${
    riotabiia.1 $e |- ( x e. A -> ( ph <-> ps ) ) $.
    $( Equivalent wff's yield equal restricted iotas (inference rule).
       ( ~ rabbiia analog.)  (Contributed by NM, 16-Jan-2012.) $)
    riotabiia $p |- ( iota_ x e. A ph ) = ( iota_ x e. A ps ) $=
      ( cvv wceq crio eqid cv wcel wb adantl riotabidva ax-mp ) FFGZACDHBCDHGFI
      PABCDCJDKABLPEMNO $.
  $}

  ${
    $d x y A $.
    $( Property of restricted iota.  Compare ~ iota1 .  (Contributed by Mario
       Carneiro, 15-Oct-2016.) $)
    riota1 $p |- ( E! x e. A ph ->
      ( ( x e. A /\ ph ) <-> ( iota_ x e. A ph ) = x ) ) $=
      ( wreu cv wcel wa cio wceq weu df-reu iota1 sylbi riotaiota eqeq1d bitr4d
      crio wb ) ABCDZBEZCFAGZUABHZTIZABCQZTISUABJUAUCRABCKUABLMSUDUBTABCNOP $.
  $}

  $( Property of iota.  (Contributed by NM, 23-Aug-2011.) $)
  riota1a $p |- ( ( x e. A /\ E! x e. A ph ) ->
          ( ph <-> ( iota x ( x e. A /\ ph ) ) = x ) ) $=
    ( cv wcel wa wreu cio wceq ibar weu wb df-reu iota1 sylbi sylan9bb ) BDZCEZ
    ARAFZABCGZSBHQIZRAJTSBKSUALABCMSBNOP $.

  ${
    $d x A $.
    riota2df.1 $e |- F/ x ph $.
    riota2df.2 $e |- ( ph -> F/_ x B ) $.
    riota2df.3 $e |- ( ph -> F/ x ch ) $.
    riota2df.4 $e |- ( ph -> B e. A ) $.
    riota2df.5 $e |- ( ( ph /\ x = B ) -> ( ps <-> ch ) ) $.
    $( A deduction version of ~ riota2f .  (Contributed by NM, 17-Feb-2013.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    riota2df $p |- ( ( ph /\ E! x e. A ps ) ->
            ( ch <-> ( iota_ x e. A ps ) = B ) ) $=
      ( wreu wa cv wcel cio wceq crio adantr simpr weu df-reu eqeltrd biantrurd
      sylib adantlr bitr3d nfreu1 nfan wnf wnfc iota2df riotaiota adantl eqeq1d
      wb bitr4d ) ABDELZMZCDNZEOZBMZDPZFQBDERZFQUSVBCDFEAFEOZURJSZUSURVBDUAAURT
      BDEUBUEUSUTFQZMZBVBCVHVABVHUTFEUSVGTUSVEVGVFSUCUDAVGBCUPURKUFUGAURDGBDEUH
      UIACDUJURISADFUKURHSULUSVDVCFURVDVCQABDEUMUNUOUQ $.
  $}

  ${
    $d y ph $.  $d x y A $.  $d y B $.
    riota2f.1 $e |- F/_ x B $.
    riota2f.2 $e |- F/ x ps $.
    riota2f.3 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( This theorem shows a condition that allows us to represent a descriptor
       with a class expression ` B ` .  (Contributed by NM, 23-Aug-2011.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    riota2f $p |- ( ( B e. A /\ E! x e. A ph ) ->
            ( ps <-> ( iota_ x e. A ph ) = B ) ) $=
      ( wcel nfel1 wnfc a1i wnf id cv wceq wb adantl riota2df ) EDIZABCDECEDFJC
      EKTFLBCMTGLTNCOEPABQTHRS $.
  $}

  ${
    $d x ps $.  $d x A $.  $d x B $.
    riota2.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( This theorem shows a condition that allows us to represent a descriptor
       with a class expression ` B ` .  (Contributed by NM, 23-Aug-2011.)
       (Revised by Mario Carneiro, 10-Dec-2016.) $)
    riota2 $p |- ( ( B e. A /\ E! x e. A ph ) ->
            ( ps <-> ( iota_ x e. A ph ) = B ) ) $=
      ( nfcv nfv riota2f ) ABCDECEGBCHFI $.
  $}

  ${
    $d y ph $.  $d x y A $.  $d y B $.
    riotaprop.0 $e |- F/ x ps $.
    riotaprop.1 $e |- B = ( iota_ x e. A ph ) $.
    riotaprop.3 $e |- ( x = B -> ( ph <-> ps ) ) $.
    $( Properties of a restricted definite description operator.  Todo: can
       some uses of ~ riota2f be shortened with this?  (Contributed by NM,
       23-Nov-2013.) $)
    riotaprop $p |- ( E! x e. A ph -> ( B e. A /\ ps ) ) $=
      ( wreu wcel crio riotacl syl5eqel wa wceq eqcomi nfriota1 nfcxfr riota2f
      mpbiri mpancom jca ) ACDIZEDJZBUCEACDKZDGACDLMZUDUCBUFUDUCNBUEEOEUEGPABCD
      ECEUEGACDQRFHSTUAUB $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ph $.  $d y ps $.
    riota5f.1 $e |- ( ph -> F/_ x B ) $.
    riota5f.2 $e |- ( ph -> B e. A ) $.
    riota5f.3 $e |- ( ( ph /\ x e. A ) -> ( ps <-> x = B ) ) $.
    $( A method for computing restricted iota.  (Contributed by NM,
       16-Apr-2013.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    riota5f $p |- ( ph -> ( iota_ x e. A ps ) = B ) $=
      ( vy cv wceq wb wral ralrimiva wi wcel wa wtru a1tru nfv crio wsbc adantl
      wreu reu6i nfra1 nfan nfcvd nfvd simprl simpr simplrr simplrl eqeltrd rsp
      sylc mpbird 2thd mpdan mpbid expr rspsbc nfeqd nfan1 eqeq2d bibi2d ralbid
      riota2df imbi12d sbcied mpd ) ABCJZEKZLZCDMZBCDUAZEKZAVNCDHNABVLIJZKZLZCD
      MZVPVRKZOZIEUBZVOVQOZAEDPWCIDMWDGAWCIDAVRDPZWAWBAWFWAQZQZRWBWHSWHBCDUDZRW
      BLWGWIABCDVRUEUCWHBRCDVRAWGCACTZWFWACWFCTVTCDUFUGUGWHCVRUHWHRCUIAWFWAUJWH
      VSQZBRWKBVSWHVSUKZWKWAVLDPVTAWFWAVSULWKVLVRDWLAWFWAVSUMUNVTCDUOUPUQWKSURV
      HUSUTVANWCIEDVBUPAWCWEIEDGAVREKZQZWAVOWBVQWNVTVNCDAWMCWJACVREACVRUHFVCVDW
      NVSVMBWNVREVLAWMUKZVEVFVGWNVREVPWOVEVIVJUTVK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    riota5.1 $e |- ( ph -> B e. A ) $.
    riota5.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> x = B ) ) $.
    $( A method for computing restricted iota.  (Contributed by NM,
       20-Oct-2011.)  (Revised by Mario Carneiro, 6-Dec-2016.) $)
    riota5 $p |- ( ph -> ( iota_ x e. A ps ) = B ) $=
      ( nfcvd riota5f ) ABCDEACEHFGI $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Restriction of a unique element to a smaller class.  (Contributed by NM,
       21-Aug-2011.)  (Revised by NM, 22-Mar-2013.) $)
    riotass2 $p |- ( ( ( A C_ B /\ A. x e. A ( ph -> ps ) ) /\ ( E. x e. A ph
           /\ E! x e. B ps ) )
         -> ( iota_ x e. A ph ) = ( iota_ x e. B ps ) ) $=
      ( wi wral wa wrex wreu crio wsbc wceq reuss2 simplr riotasbc wcel riotacl
      wss syl rspsbc sbcimg sylibd mpid sylc wb ssel ad2antrr mpd simprr nfsbc1
      nfriota1 sbceq1a riota2f syl2anc mpbid eqcomd ) DESZABFZCDGZHZACDIZBCEJZH
      ZHZBCEKZACDKZVEBCVGLZVFVGMZVEACDJZUTVHABCDENZURUTVDOVJUTACVGLZVHACDPVJVGD
      QZUTVLVHFZFACDRZVMUTUSCVGLVNUSCVGDUAABCVGDUBUCTUDUEVEVGEQZVCVHVIUFVEVMVPV
      EVJVMVKVOTURVMVPFUTVDDEVGUGUHUIVAVBVCUJBVHCEVGACDULZBCVGVQUKBCVGUMUNUOUPU
      Q $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y ph $.
    $( Restriction of a unique element to a smaller class.  (Contributed by NM,
       19-Oct-2005.)  (Revised by Mario Carneiro, 24-Dec-2016.) $)
    riotass $p |- ( ( A C_ B /\ E. x e. A ph /\ E! x e. B ph ) ->
                ( iota_ x e. A ph ) = ( iota_ x e. B ph ) ) $=
      ( wss wrex wreu w3a crio wsbc wceq reuss riotasbc syl wcel riotacl sseldd
      wb simp1 simp3 nfriota1 nfsbc1 sbceq1a riota2f syl2anc mpbid eqcomd ) CDE
      ZABCFZABDGZHZABDIZABCIZUKABUMJZULUMKZUKABCGZUNABCDLZABCMNUKUMDOUJUNUORUKC
      DUMUHUIUJSUKUPUMCOUQABCPNQUHUIUJTAUNBDUMABCUAZABUMURUBABUMUCUDUEUFUG $.

    $( Restriction of a unique element to a smaller class.  (Contributed by NM,
       19-Feb-2006.)  (Revised by NM, 16-Jun-2017.) $)
    moriotass $p |- ( ( A C_ B /\ E. x e. A ph /\ E* x e. B ph ) ->
                ( iota_ x e. A ph ) = ( iota_ x e. B ph ) ) $=
      ( wss wrex wrmo wreu crio wceq w3a ssrexv imp 3adant3 simp3 reu5 sylanbrc
      riotass syld3an3 ) CDEZABCFZABDGZABDHZABCIABDIJTUAUBKABDFZUBUCTUAUDUBTUAU
      DABCDLMNTUAUBOABDPQABCDRS $.
  $}

  ${
    $d y A $.  $d y ph $.  $d x y $.
    $( A restricted class abstraction with a unique member can be expressed as
       a singleton.  (Contributed by NM, 30-May-2006.) $)
    snriota $p |- ( E! x e. A ph ->
                   { x e. A | ph } = { ( iota_ x e. A ph ) } ) $=
      ( wreu crab cv wcel cio csn crio cab df-rab weu wceq df-reu sniota syl5eq
      wa sylbi riotaiota sneqd eqtr4d ) ABCDZABCEZBFCGARZBHZIZABCJZIUCUDUEBKZUG
      ABCLUCUEBMUIUGNABCOUEBPSQUCUHUFABCTUAUB $.
  $}

  ${
    $d x B $.  $d x z C $.  $d x y z A $.  $d x y ph $.  $d ps y z $.
    $d ch x z $.
    riotaxfrd.1 $e |- F/_ y C $.
    riotaxfrd.2 $e |- ( ( ph /\ y e. A ) -> B e. A ) $.
    riotaxfrd.3 $e |- ( ( ph /\ ( iota_ y e. A ch ) e. A ) -> C e. A ) $.
    riotaxfrd.4 $e |- ( x = B -> ( ps <-> ch ) ) $.
    riotaxfrd.5 $e |- ( y = ( iota_ y e. A ch ) -> B = C ) $.
    riotaxfrd.6 $e |- ( ( ph /\ x e. A ) -> E! y e. A x = B ) $.
    $( Change the variable ` x ` in the expression for "the unique ` x ` such
       that ` ps ` " to another variable ` y ` contained in expression ` B ` .
       Use ~ reuhypd to eliminate the last hypothesis.  (Contributed by NM,
       16-Jan-2012.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    riotaxfrd $p |- ( ( ph /\ E! x e. A ps ) -> ( iota_ x e. A ps ) = C ) $=
      ( wreu wa crio crab wcel adantl rabid baib riotabiia wceq reuxfrd riotacl
      cv riotacl2 wb nfriota1 rabxfrd sylan2 mpbird ex sylbid imp baibr reubiia
      syl5 biimpi nfcv nfrab1 nfel2 eleq1 riota2f syl2anc mpbid syl5eqr ) ABDFO
      ZPZBDFQDUGZBDFRZSZDFQZHVMBDFVMVKFSZBBDFUAZUBUCVJHVLSZVNHUDZAVIVQAVICEFOZV
      QABCDEGFJNLUEZAVSVQAVSPVQCEFQZCEFRSZVSWBACEFUHTVSAWAFSZVQWBUICEFUFZABCDEG
      WAHFCEFUJIJLMUKULUMUNUOUPVJHFSZVMDFOZVQVRUIAVIWEAVIVSWEVTVSWCAWEWDAWCWEKU
      NUSUOUPVIWFAVIWFBVMDFVMVOBVPUQURUTTVMVQDFHDHVADHVLBDFVBVCVKHVLVDVEVFVGVH
      $.
  $}

  ${
    $d x y z A $.  $d x z B $.
    eusvobj1.1 $e |- B e. _V $.
    $( Specify the same property in two ways when class ` B ( y ) ` is
       single-valued.  (Contributed by NM, 1-Nov-2010.)  (Proof shortened by
       Mario Carneiro, 24-Dec-2016.) $)
    eusvobj2 $p |- ( E! x E. y e. A x = B
       -> ( E. y e. A x = B <-> A. y e. A x = B ) ) $=
      ( vz cv wceq wrex weu wral cab csn wex wi euabsn2 wcel eleq2 abid exlimiv
      3bitr3g nfre1 nfeq1 elabrex elsnc eqcom bitri syl6bb syl5ib ralrimi eqeq1
      elsn nfab ralbidv syl5ibrcom sylbid sylbi c0 wne euex rexn0 r19.2z impbid
      ex 3syl ) AGZDHZBCIZAJZVHVGBCKZVIVHALZFGZMZHZFNVHVJOZVHAFPVNVOFVNVHVFVLHZ
      VJVNVFVKQVFVMQVHVPVKVMVFRVHASAVLULUAVNVJVPVLDHZBCKVNVQBCBVKVMVHBAVGBCUBUM
      UCBGCQDVKQZVNVQBACDEUDVNVRDVMQZVQVKVMDRVSDVLHVQDVLEUEDVLUFUGUHUIUJVPVGVQB
      CVFVLDUKUNUOUPTUQVIVHANCURUSZVJVHOVHAUTVHVTAVGBCVATVTVJVHVGBCVBVDVEVC $.

    $( Specify the same object in two ways when class ` B ( y ) ` is
       single-valued.  (Contributed by NM, 1-Nov-2010.)  (Proof shortened by
       Mario Carneiro, 19-Nov-2016.) $)
    eusvobj1 $p |- ( E! x E. y e. A x = B
       -> ( iota x E. y e. A x = B ) = ( iota x A. y e. A x = B ) ) $=
      ( cv wceq wrex weu wral wb wal cio nfeu1 eusvobj2 alrimi iotabi syl ) AFD
      GZBCHZAIZTSBCJZKZALTAMUBAMGUAUCATANABCDEOPTUBAQR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( There is one domain element for each value of a one-to-one onto
       function.  (Contributed by NM, 26-May-2006.) $)
    f1ofveu $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                  E! x e. A ( F ` x ) = C ) $=
      ( wf1o wcel wa cv cfv wceq wreu cop ccnv wf f1ocnv f1of syl wb wfn 3com23
      feu sylan f1ocnvfvb dff1o4 simprbi fnopfvb 3adant3 syl3an1 bitrd reubidva
      w3a 3expa mpbird ) BCEFZDCGZHZAIZEJDKZABLDURMENZGZABLZUOCBUTOZUPVBUOCBUTF
      VCBCEPCBUTQRACBDUTUBUCUQUSVAABUOUPURBGZUSVASUOUPVDULUSDUTJURKZVAUOVDUPUSV
      ESBCURDEUDUAUOUTCTZUPVDVEVASZUOEBTVFBCEUEUFVFUPVGVDCDURUTUGUHUIUJUMUKUN
      $.

    $( Value of the converse of a one-to-one onto function.  (Contributed by
       NM, 26-May-2006.)  (Proof shortened by Mario Carneiro, 24-Dec-2016.) $)
    f1ocnvfv3 $p |- ( ( F : A -1-1-onto-> B /\ C e. B ) ->
                  ( `' F ` C ) = ( iota_ x e. A ( F ` x ) = C ) ) $=
      ( wf1o wcel wa cv cfv wceq crio ccnv f1ocnvdm f1ocnvfvb 3expa an32s eqcom
      wb syl6bbr riota5 eqcomd ) BCEFZDCGZHZAIZEJDKZABLDEMJZUEUGABUHBCDENUEUFBG
      ZHUGUHUFKZUFUHKUCUIUDUGUJSZUCUIUDUKBCUFDEOPQUFUHRTUAUB $.
  $}

  ${
    $d x A $.
    $( Restricted iota equals the undefined value of its domain of discourse
       ` A ` when not meaningful.  (Contributed by NM, 16-Jan-2012.)  (Revised
       by Mario Carneiro, 15-Oct-2016.) $)
    riotaund $p |- ( -. E! x e. A ph
                      -> ( iota_ x e. A ph ) = ( Undef ` A ) ) $=
      ( wreu wn cv wcel cio cab cund cfv cif crio iffalse df-riota abid2 eqcomi
      wa fveq2i 3eqtr4g ) ABCDZEUABFCGZARBHZUBBIZJKZLUEABCMCJKUAUCUENABCOCUDJUD
      CBCPQST $.

    $( For proper classes, restricted and unrestricted iota are the same.
       (Contributed by NM, 15-Sep-2011.) $)
    riotaprc $p |- ( -. A e. _V
           -> ( iota_ x e. A ph ) = ( iota x ( x e. A /\ ph ) ) ) $=
      ( cvv wcel wn wreu crio cv wa cio wceq cund cfv c0 adantr riotaund adantl
      fvprc weu df-reu iotanul sylnbi 3eqtr4d ex riotaiota pm2.61d2 ) CDEFZABCG
      ZABCHZBICEAJZBKZLZUHUIFZUMUHUNJCMNZOUJULUHUOOLUNCMSPUNUJUOLUHABCQRUNULOLZ
      UHUIUKBTUPABCUAUKBUBUCRUDUEABCUFUG $.

    $( The restricted iota class is limited in size by the base set.
       (Contributed by Mario Carneiro, 24-Dec-2016.)  Obsolete as of
       28-Aug-2018.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    riotassuniOLD $p |- ( iota_ x e. A ph ) C_ ( ~P U. A u. U. A ) $=
      ( wreu crio cuni cpw cun wss crab riotauni ssrab2 syl6eqss wn cund cvv wa
      wceq adantl c0 unissi ssun2 sstri cfv riotaund wcel ssun1 fvprc pm2.61dan
      undefval 0ss eqsstrd pm2.61i ) ABCDZABCEZCFZGZUPHZIUNUOABCJZFZURABCKUTUPU
      RUSCABCLUAUPUQUBUCMUNNZUOCOUDZURABCUEVACPUFZVBURIVAVCQVBUQURVCVBUQRVACPUJ
      SUQUPUGMVAVCNZQVBTURVDVBTRVACOUHSURUKMUIULUM $.

    $( Closure of restricted iota.  (Contributed by NM, 28-Feb-2013.)  (Revised
       by Mario Carneiro, 24-Dec-2016.) $)
    riotaclbg $p |- ( A e. V
          -> ( E! x e. A ph <-> ( iota_ x e. A ph ) e. A ) ) $=
      ( wcel wreu crio riotacl wn cund cfv undefnel2 riotaund eleq1d syl5ibrcom
      notbid con4d impbid2 ) CDEZABCFZABCGZCEZABCHSTUBSUBITIZCJKZCEZICDLUCUBUEU
      CUAUDCABCMNPOQR $.

    riotaclb.1 $e |- A e. _V $.
    $( Closure of restricted iota.  (Contributed by NM, 15-Sep-2011.) $)
    riotaclb $p |- ( E! x e. A ph <-> ( iota_ x e. A ph ) e. A ) $=
      ( cvv wcel wreu crio wb riotaclbg ax-mp ) CEFABCGABCHCFIDABCEJK $.

    $( Restricted iota equals the undefined value of its domain of discourse
       ` A ` when not meaningful.  (Contributed by NM, 26-Sep-2011.) $)
    riotaundb $p |- ( -. E! x e. A ph
                      <-> ( iota_ x e. A ph ) = ( Undef ` A ) ) $=
      ( wreu wn crio cund cfv wceq riotaund wcel riotacl undefnel2 ax-mp nelne2
      wne cvv sylancl necon2bi impbii ) ABCEZFABCGZCHIZJABCKUBUCUDUBUCCLUDCLFZU
      CUDQABCMCRLUEDCRNOUCUDCPSTUA $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d z D $.  $d z ph $.
    $d x z ps $.
    riotasvd.1 $e |- ( ph
        -> D = ( iota_ x e. A A. y e. B ( ps -> x = C ) ) ) $.
    riotasvd.2 $e |- ( ph -> D e. A ) $.
    $( Deduction version of ~ riotasv .  (Contributed by NM, 4-Mar-2013.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    riotasvd $p |- ( ( ph /\ A e. V ) -> ( ( y e. B /\ ps ) -> D = C ) ) $=
      ( vz wcel wa cv wceq wi wral adantr syl crio wsbc wreu eqeltrrd riotaclbg
      wb adantl mpbird riotasbc eqeq1 imbi2d ralbidv nfra1 nfriota nfeq2 ralbid
      nfcv sbcie2g mpbid rsp imp3a eqeq1d sylibrd ) AEIMZNZDOFMZBNBCOZGPZQZDFRZ
      CEUAZGPZHGPVEVFBVLVEBVLQZDFRZVFVMQVEVJCVKUBZVNVEVJCEUCZVOVEVPVKEMZVEHVKEA
      HVKPVDJSZAHEMVDKSUDZVDVPVQUFAVJCEIUEUGUHVJCEUITVEVQVOVNUFVSVJBLOZGPZQZDFR
      VNCLVKEVGVTPZVIWBDFWCVHWABVGVTGUJUKULVTVKPZWBVMDFDVTVKVJDCEVIDFUMDEUQUNUO
      WDWAVLBVTVKGUJUKUPURTUSVMDFUTTVAVEHVKGVRVBVC $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d z D $.  $d z ph $.
    $d x z ps $.
    riotasvdOLD.1 $e |- ( ph -> A. x ph ) $.
    riotasvdOLD.2 $e |- ( ph -> A. y ph ) $.
    riotasvdOLD.3 $e |- ( ph
        -> D = ( iota_ x e. A A. y e. B ( ps -> x = C ) ) ) $.
    $( Deduction version of ~ riotasv .  (Contributed by NM, 1-Feb-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    riotasvdOLD $p |- ( ( ( ph /\ A e. V ) /\ D e. A /\ ( y e. B /\ ps ) )
         -> D = C ) $=
      ( wcel wa wceq wi wb wnfc nfcvd nfan1 cv wral crio eqcomd ad2antrr eleq1d
      wreu adantr riotaclbg adantl bitr4d biimpa nfi nfceqdf mpbiri nfeld nfra1
      nfriota1 nfcv nfriota nfvd nfeqd nfimd nfrald simpr imbi2d ralbid adantlr
      eqeq1 riota2df adantllr mpdan mpbird ex rsp syl6 imp4a 3imp ) AEIMZNZHEMZ
      DUAFMZBNHGOZVTWAWBBWCVTWABWCPZDFUBZWBWDPVTWAWEVTWANZWEBCUAZGOZPZDFUBZCEUC
      ZHOZAWLVSWAAHWKLUDUEWFWJCEUGZWEWLQZVTWAWMVTWAWKEMZWMAWAWOQVSAHWKELUFUHVSW
      MWOQAWJCEIUIUJUKULAWAWMWNVSAWANZWJWECEHAWACACJUMZACHEACHRZCWKRWJCEURACHWK
      WQLUNUOZACESUPTAWRWAWSUHZWPWDCDFAWADADKUMZADHEADHRDWKRWJDCEWIDFUQDEUSUTAD
      HWKXALUNUOZADESUPTWPCFSWPBWCCWPBCVAWPCHGWTWPCGSVBVCVDAWAVEAWGHOZWJWEQWAAX
      CNZWIWDDFAXCDXAADWGHADWGSXBVBTXDWHWCBXCWHWCQAWGHGVIUJVFVGVHVJVKVLVMVNWDDF
      VOVPVQVR $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x z C $.  $d z D $.  $d y z E $.
    $d z F $.  $d z ph $.  $d x z ps $.
    riotasv2d.1 $e |- F/ y ph $.
    riotasv2d.2 $e |- ( ph -> F/_ y F ) $.
    riotasv2d.3 $e |- ( ph -> F/ y ch ) $.
    riotasv2d.4 $e |- ( ph
        -> D = ( iota_ x e. A A. y e. B ( ps -> x = C ) ) ) $.
    riotasv2d.5 $e |- ( ( ph /\ y = E ) -> ( ps <-> ch ) ) $.
    riotasv2d.6 $e |- ( ( ph /\ y = E ) -> C = F ) $.
    riotasv2d.7 $e |- ( ph -> D e. A ) $.
    riotasv2d.8 $e |- ( ph -> E e. B ) $.
    riotasv2d.9 $e |- ( ph -> ch ) $.
    $( Value of description binder ` D ` for a single-valued class expression
       ` C ( y ) ` (as in e.g. ~ reusv2 ).  Special case of ~ riota2f .
       (Contributed by NM, 2-Mar-2013.) $)
    riotasv2d $p |- ( ( ph /\ A e. V ) -> D = F ) $=
      ( wcel cvv wceq elex wa adantr cv wi eleq1 adantl anbi12d imbi12d adantlr
      wb eqeq2d riotasvd nfv nfan nfcvd nfvd nfand wnfc wral crio nfra1 nfriota
      wnf nfcv nfceqdf mpbiri nfeqd nfimd vtocldf mp2and sylan2 ) FLUBAFUCUBZIK
      UDZFLUEAVQUFZJGUBZCVRAVTVQTUGZACVQUAUGVSEUHZGUBZBUFZIHUDZUIZVTCUFZVRUIZEJ
      GWAAWBJUDZWFWHUOVQAWIUFZWDWGWEVRWJWCVTBCWIWCVTUOAWBJGUJUKQULWJHKIRUPUMUNA
      BDEFGHIUCPSUQAVQEMVQEURUSVSEJUTAWHEVHVQAWGVREAVTCEAVTEVAOVBAEIKAEIVCEBDUH
      HUDUIZEGVDZDFVEZVCWLEDFWKEGVFEFVIVGAEIWMMPVJVKNVLVMUGVNVOVP $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x z C $.  $d z D $.  $d y z E $.
    $d z F $.  $d z ph $.  $d x z ps $.
    riotasv2dOLD.1 $e |- ( ph -> A. x ph ) $.
    riotasv2dOLD.2 $e |- ( ph -> A. y ph ) $.
    riotasv2dOLD.3 $e |- ( ph -> ( z e. F -> A. y z e. F ) ) $.
    riotasv2dOLD.4 $e |- ( ph -> ( ch -> A. y ch ) ) $.
    riotasv2dOLD.5 $e |- ( ph
        -> D = ( iota_ x e. A A. y e. B ( ps -> x = C ) ) ) $.
    riotasv2dOLD.6 $e |- ( ph -> ( y = E -> ( ps <-> ch ) ) ) $.
    riotasv2dOLD.7 $e |- ( ph -> ( y = E -> C = F ) ) $.
    $( Value of description binder ` D ` for a single-valued class expression
       ` C ( y ) ` (as in e.g. ~ reusv2 ).  Special case of ~ riota2f .
       (Contributed by NM, 1-Feb-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    riotasv2dOLD $p |- ( ( ( ph /\ A e. V ) /\ ( D e. A /\ E e. B /\ ch ) )
             -> D = F ) $=
      ( wcel cvv w3a wceq elex wa wi wnfc wnf cv wal nfcvd wral crio nfra1 nfcv
      wb nfriota nfi nfv nfan ad2antrr nfceqdf mpbiri nfeld nfvd nfd nfcd nfeqd
      nf3and nfimd eleq1 adantl imp 3anbi23d eqeq2d imbi12d ex riotasvdOLD 3exp
      alrimi exp4a 3impd adantr simpr vtoclgft syl221anc 3expd pm2.43d sylanl2
      com23 3imp2 ) GMUAAGUBUAZJGUAZKHUAZCUCZJLUDZGMUEAWMUFZWNWOCWQWRWOWNCWQUGZ
      WRWOWNWSUGZWRWOWOWTUGWRWOUFZWNWOWSXAWNWOCWQXAEKUHWPWQUGZEUIEUJZKUDZWNXCHU
      AZBUCZJIUDZUGZXBUQZUGZEUKXHEUKZWOXBXAEKULXAWPWQEXAWNWOCEXAEJGXAEJUHEBDUJI
      UDUGZEHUMZDGUNZUHXMEDGXLEHUOEGUPURXAEJXNWRWOEAWMEAEOUSZWMEUTVAZWOEUTVAZAJ
      XNUDWMWORVBVCVDZXAEGULVEXAWOEVFACEUIWMWOACEXOQVGVBVJXAEJLXRAELUHWMWOAEFLA
      FUTAFUJLUAEXOPVGVHVBVIVKXAXJEXQAXJWMWOAXDXIAXDUFZXFWPXGWQXSXEWOBCWNXDXEWO
      UQAXCKHVLVMAXDBCUQSVNVOXSILJAXDILUDTVNVPVQVRVBWAWRXKWOWRXHEXPWRWNXEBXGWRW
      NXEBXGWRWNXEBUFXGABDEGHIJUBNORVSVTWBWCWAWDWRWOWEXHXBEKHWFWGWHWKVRWIWKWLWJ
      $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x z C $.  $d z D $.  $d x y z E $.
    $d x z ph $.
    riotasv2s.2 $e |- D = ( iota_ x e. A A. y e. B ( ph -> x = C ) ) $.
    $( The value of description binder ` D ` for a single-valued class
       expression ` C ( y ) ` (as in e.g. ~ reusv2 ) in the form of a
       substitution instance.  Special case of ~ riota2f .  (Contributed by NM,
       3-Mar-2013.)  (Proof shortened by Mario Carneiro, 6-Dec-2016.) $)
    riotasv2s $p |- ( ( A e. V /\ D e. A /\ ( E e. B /\ [. E / y ]. ph ) )
            -> D = [_ E / y ]_ C ) $=
      ( wcel wsbc wa w3a csb wceq cv nfan a1i adantl 3simpc simp1 wi wral nfra1
      crio nfcv nfriota nfcxfr nfel1 nfv nfsbc1v nfcsb1v wnf wb sbceq1a csbeq1a
      wnfc simpl simprl simprr riotasv2d syl2anc ) DIKZGDKZHEKZACHLZMZNVEVHMZVD
      GCHFOZPVDVEVHUAVDVEVHUBVIAVGBCDEFGHVJIVEVHCCGDCGABQFPUCZCEUDZBDUFZJVLCBDV
      KCEUECDUGUHUIUJVFVGCVFCUKACHULZRRCVJURVICHFUMSVGCUNVIVNSGVMPVIJSCQHPZAVGU
      OVIACHUPTVOFVJPVICHFUQTVEVHUSVEVFVGUTVEVFVGVAVBVC $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d x z ph $.  $d z D $.
    riotasv.1 $e |- A e. _V $.
    riotasv.2 $e |- D = ( iota_ x e. A A. y e. B ( ph -> x = C ) ) $.
    $( Value of description binder ` D ` for a single-valued class expression
       ` C ( y ) ` (as in e.g. ~ reusv2 ).  Special case of ~ riota2f .
       (Contributed by NM, 26-Jan-2013.)  (Proof shortened by Mario Carneiro,
       6-Dec-2016.) $)
    riotasv $p |- ( ( D e. A /\ y e. B /\ ph ) -> D = C ) $=
      ( wcel cv wceq cvv wa wi wral crio a1i id riotasvd mpan2 3impib ) GDJZCKE
      JZAGFLZUCDMJUDANUEOHUCABCDEFGMGABKFLOCEPBDQLUCIRUCSTUAUB $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d z D $.  $d z ph $.
    $d x z ps $.
    riotasv3d.1 $e |- F/ y ph $.
    riotasv3d.2 $e |- ( ph -> F/ y th ) $.
    riotasv3d.3 $e |- ( ph
           -> D = ( iota_ x e. A A. y e. B ( ps -> x = C ) ) ) $.
    riotasv3d.4 $e |- ( ( ph /\ C = D ) -> ( ch <-> th ) ) $.
    riotasv3d.5 $e |- ( ph -> ( ( y e. B /\ ps ) -> ch ) ) $.
    riotasv3d.6 $e |- ( ph -> D e. A ) $.
    riotasv3d.7 $e |- ( ph -> E. y e. B ps ) $.
    $( A property ` ch ` holding for a representative of a single-valued class
       expression ` C ( y ) ` (see e.g. ~ reusv2 ) also holds for its
       description binder ` D ` (in the form of property ` th ` ).
       (Contributed by NM, 5-Mar-2013.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    riotasv3d $p |- ( ( ph /\ A e. V ) -> th ) $=
      ( wcel wa cvv elex wrex adantr wi wral nfv imp adantrl wceq riotasvd impr
      cv wb eqcomd syldan mpbid exp45 ralrimd wnf r19.23t syl sylibd mpd sylan2
      ) GKSAGUASZDGKUBAVFTBFHUCZDAVGVFRUDAVFVGDUEZAVFBDUEZFHUFZVHAVFVIFHLVFFUGA
      VFFUMHSZBDAVFVKBTZTZTZCDAVLCVFAVLCPUHUIAVMIJUJCDUNVNJIAVFVLJIUJABEFGHIJUA
      NQUKULUOOUPUQURUSADFUTVJVHUNMBDFHVAVBVCUHVDVE $.
  $}

  ${
    $d x y z A $.  $d x z B $.  $d x z C $.  $d z D $.  $d z ph $.
    $d x z ps $.
    riotasv3dOLD.1 $e |- ( ph -> A. x ph ) $.
    riotasv3dOLD.2 $e |- ( ph -> A. y ph ) $.
    riotasv3dOLD.3 $e |- ( ph -> ( th -> A. y th ) ) $.
    riotasv3dOLD.4 $e |- ( ph
           -> D = ( iota_ x e. A A. y e. B ( ps -> x = C ) ) ) $.
    riotasv3dOLD.5 $e |- ( ph -> ( C = D -> ( ch <-> th ) ) ) $.
    riotasv3dOLD.6 $e |- ( ph -> ( ( y e. B /\ ps ) -> ch ) ) $.
    $( A property ` ch ` holding for a representative of a single-valued class
       expression ` C ( y ) ` (see e.g. ~ reusv2 ) also holds for its
       description binder ` D ` (in the form of property ` th ` ).
       (Contributed by NM, 1-Feb-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    riotasv3dOLD $p |- ( ( ph /\ ( A e. V /\ D e. A /\ E. y e. B ps ) )
          -> th ) $=
      ( wcel wi wa wrex cvv elex wral nfi cv adantrl wb wceq riotasvdOLD eqcomd
      imp w3a 3exp ex imp4c syld mpbid exp45 com23 ralrimi nfvd wnfc crio nfra1
      wnf nfcv nfriota nfceqdf mpbiri nfcvd nfeld nfand r19.21t syl nfd r19.23t
      sylibd exp3a syl5 3imp2 ) AGKRZJGRZBFHUAZDWBGUBRZAWCWDDSZSGKUCAWEWCWFAWEW
      CTZBDSZFHUDZWFAWGWHSZFHUDZWGWISZAWJFHAFMUEZAWGFUFHRZWHAWGWNBDAWGWNBTZTZTC
      DAWOCWGAWOCQULUGAWPCDUHZAWPIJUIZWQAWEWCWOWRAWEWCWOWRSSAWETZWCWOWRWSWCWOUM
      JIABEFGHIJUBLMOUJUKUNUOUPPUQULURUSUTVAAWGFVFWKWLUHAWEWCFAWEFVBAFJGAFJVCFB
      EUFIUISZFHUDZEGVDZVCXAFEGWTFHVEFGVGVHAFJXBWMOVIVJAFGVKVLVMWGWHFHVNVOURADF
      VFWIWFUHADFWMNVPBDFHVQVOVRVSVTWA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Functions on ordinals; strictly monotone ordinal functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( The indexed union of a set of ordinal numbers ` B ( x ) ` is an ordinal
       number.  (Contributed by NM, 13-Oct-2003.)  (Revised by Mario Carneiro,
       5-Dec-2016.) $)
    iunon $p |- ( ( A e. V /\ A. x e. A B e. On ) -> U_ x e. A B e. On ) $=
      ( wcel con0 wral wa ciun cmpt crn cuni wceq dfiun3g adantl cvv wss mptexg
      rnexg syl wf eqid fmpt frn sylbi ssonuni imp syl2an eqeltrd ) BDEZCFEABGZ
      HABCIZABCJZKZLZFUKULUOMUJABCFNOUJUNPEZUNFQZUOFEZUKUJUMPEUPABCDRUMPSTUKBFU
      MUAUQABFCUMUMUBUCBFUMUDUEUPUQURUNPUFUGUHUI $.

    iunonOLD.1 $e |- A e. _V $.
    iunonOLD.2 $e |- B e. _V $.
    $( The indexed union of a set of ordinal numbers ` B ( x ) ` is an ordinal
       number.  (Contributed by NM, 13-Oct-2003.)  (Revised by Mario Carneiro,
       5-Dec-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    iunonOLD $p |- ( A. x e. A B e. On -> U_ x e. A B e. On ) $=
      ( cvv wcel con0 wral ciun iunon mpan ) BFGCHGABIABCJHGDABCFKL $.
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( The nonempty indexed intersection of a class of ordinal numbers
       ` B ( x ) ` is an ordinal number.  (Contributed by NM, 13-Oct-2003.)
       (Proof shortened by Mario Carneiro, 5-Dec-2016.) $)
    iinon $p |- ( ( A. x e. A B e. On /\ A =/= (/) ) ->
                |^|_ x e. A B e. On ) $=
      ( con0 wcel wral c0 wne wa ciin cmpt crn cint wceq dfiin3g adantr wf eqid
      wss fmpt frn sylbi dm0rn0 dmmptg eqeq1d syl5bbr necon3bid biimpar oninton
      cdm syl2anc eqeltrd ) CDEABFZBGHZIZABCJZABCKZLZMZDUMUPUSNUNABCDOPUOURDSZU
      RGHZUSDEUMUTUNUMBDUQQUTABDCUQUQRTBDUQUAUBPUMVAUNUMURGBGURGNUQUJZGNUMBGNUQ
      UCUMVBBGABCDUDUEUFUGUHURUIUKUL $.
  $}

  ${
    $d x y S $.  $d x y F $.  $d x T $.
    onfununi.1 $e |- ( Lim y -> ( F ` y ) = U_ x e. y ( F ` x ) ) $.
    onfununi.2 $e |- ( ( x e. On /\ y e. On /\ x C_ y )
                  -> ( F ` x ) C_ ( F ` y ) ) $.
    $( A property of functions on ordinal numbers.  Generalization of Theorem
       Schema 8E of [Enderton] p. 218.  (Contributed by Eric Schmidt,
       26-May-2009.) $)
    onfununi $p |- ( ( S e. T /\ S C_ On /\ S =/= (/) )
                -> ( F ` U. S ) = U_ x e. S ( F ` x ) ) $=
      ( wcel con0 wss cfv ciun wa wceq word wi syl6 imp adantr fveq2 c0 wne w3a
      cuni cv wn wlim ssorduni ad2antrr nelneq wo elssuni adantl ssel ordsseleq
      eloni syl2an anabss1 mpbid ord con1d syl5 exp4b pm2.43d com23 ssrdv sylan
      wb ssn0 unissd orduniss syl eqssd df-lim syl3anbrc an32s 3adantl1 ssonuni
      limeq iuneq1 eqeq12d imbi12d vtoclg 3adant3 mpd wral eluni2 anim1d onelon
      wrex adantrd a1i syland 3jcad exp3a reximdvai syl5bi ssiun ralrimiv iunss
      ordelss sylibr cbviunv syl6sseq 3ad2ant2 eqsstrd ex ssiun2s pm2.61d2 jcad
      sseq2 anbi2d sseq2d 3com12 3expib vtoclga sylsyld ) CDHZCIJZCUAUBZUCZCUDZ
      EKZACAUEZEKZLZYAYBCHZYCYFJZYAYGUFZYHYAYIMZYCAYBYELZYFYJYBUGZYCYKNZXSXTYIY
      LXRXSYIXTYLXSYIMZXTMYBOZYBUAUBZYBYBUDZNZYLXSYOYIXTCUHZUIYNCYBJXTYPYNACYBX
      SYIYDCHZYDYBHZPXSYTYIUUAXSYTYIUUAPXSYTYTYIUUAYTYIMYDYBNZUFXSYTMZUUAYDYBCU
      JUUCUUAUUBUUCUUAUUBUUCYDYBJZUUAUUBUKZYTUUDXSYDCULZUMXSYTUUDUUEVHZUUCYDOZY
      OUUGXSXSYTUUHXSYTYDIHZUUHCIYDUNZYDUPQRYSYDYBUOUQURUSUTVAVBVCVDVERVFZCYBVI
      VGYNYRXTYNYBYQYNCYBUUKVJXSYQYBJZYIXSYOUULYSYBVKVLSVMSYBVNVOVPVQYAYLYMPZYI
      XRXSUUMXTXRXSUUMXRXSYBIHZUUMCDVRZBUEZUGZUUPEKZAUUPYELZNZPUUMBYBIUUPYBNZUU
      QYLUUTYMUUPYBVSUVAUURYCUUSYKUUPYBETZAUUPYBYEVTWAWBFWCQRWDSWEYAYKYFJZYIXSX
      RUVCXTXSYKBCUURLZYFXSYEUVDJZAYBWFYKUVDJXSUVEAYBXSUUAYEUURJZBCWJZUVEUUAYDU
      UPHZBCWJXSUVGBYDCWGXSUVHUVFBCXSUUPCHZUVHUVFXSUVIUVHMZUUIUUPIHZYDUUPJZUCUV
      FXSUVJUUIUVKUVLXSUVJUVKUVHMUUIXSUVIUVKUVHCIUUPUNZWHUUPYDWIQXSUVIUVKUVHUVM
      WKXSUVIUUPOZUVHUVLXSUVIUVKUVNUVMUUPUPQUVNUVHMUVLPXSUUPYDXAWLWMWNGQWOWPWQB
      CUURYEWRQWSAYBYEUVDWTXBBACUURYEUUPYDETXCXDXESXFXGACYEYBYCYDYBETXHXIYAYEYC
      JZACWFYFYCJYAUVOACYAUUNYTUUIUUDMZUVOXRXSUUNXTXRXSUUNUUORWDYAYTUUIUUDXSXRY
      TUUIPXTUUJXEYTUUDPYAUUFWLXJUUIUVLMZUVFPUVPUVOPBYBIUVAUVQUVPUVFUVOUVAUVLUU
      DUUIUUPYBYDXKXLUVAUURYCYEUVBXMWBUVKUUIUVLUVFUUIUVKUVLUVFGXNXOXPXQWSACYEYC
      WTXBVM $.
  $}

  ${
    $d w x y z A $.  $d w x y z F $.  $d w x y z K $.  $d w x y L $.
    $d w x y z S $.  $d w T $.
    onovuni.1 $e |- ( Lim y -> ( A F y ) = U_ x e. y ( A F x ) ) $.
    onovuni.2 $e |- ( ( x e. On /\ y e. On /\ x C_ y )
                  -> ( A F x ) C_ ( A F y ) ) $.
    ${
      $d x T $.
      $( A variant of ~ onfununi for operations.  (Contributed by Eric Schmidt,
         26-May-2009.)  (Revised by Mario Carneiro, 11-Sep-2015.) $)
      onovuni $p |- ( ( S e. T /\ S C_ On /\ S =/= (/) )
                     -> ( A F U. S ) = U_ x e. S ( A F x ) ) $=
        ( vz wcel con0 cvv cv co cfv ciun wceq oveq2 ovex fvmpt wss c0 wne cuni
        w3a cmpt wlim vex ax-mp a1i iuneq2i 3eqtr4g 3sstr4g onfununi uniexg syl
        eqid 3ad2ant1 3eqtr3d ) DEJZDKUAZDUBUCZUEZDUDZILCIMZFNZUFZOZADAMZVGOZPZ
        CVDFNZADCVIFNZPZABDEVGBMZUGCVOFNZAVOVMPVOVGOZAVOVJPGVOLJVQVPQBUHIVOVFVP
        LVGVEVOCFRVGUQZCVOFSTUIZAVOVJVMVJVMQZVIVOJVILJVTAUHIVIVFVMLVGVEVICFRVRC
        VIFSTUIZUJUKULVIKJVOKJVIVOUAUEVMVPVJVQHWAVSUMUNUTVAVHVLQZVBUTVDLJWBDEUO
        IVDVFVLLVGVEVDCFRVRCVDFSTUPURVKVNQVCADVJVMVTVIDJWAUJUKUJUS $.
    $}

    $( A variant of ~ onovuni with indexed unions.  (Contributed by Eric
       Schmidt, 26-May-2009.)  (Proof shortened by Mario Carneiro,
       5-Dec-2016.) $)
    onoviun $p |- ( ( K e. T /\ A. z e. K L e. On /\ K =/= (/) )
                -> ( A F U_ z e. K L ) = U_ z e. K ( A F L ) ) $=
      ( vw wcel con0 c0 wne ciun co wceq 3ad2ant2 cvv wral w3a cmpt crn cuni cv
      dfiun3g oveq2d wss simp1 mptexg rnexg 3syl wf simp2 eqid fmpt frn syl cdm
      sylib dmmptg simp3 eqnetrd dm0rn0 necon3bii onovuni syl3anc wrex wb oveq2
      eleq2d rexrnmpt eliun 3bitr4g eqrdv 3eqtrd ) GELZHMLCGUAZGNOZUBZDCGHPZFQD
      CGHUCZUDZUEZFQZAWDDAUFZFQZPZCGDHFQZPZWAWBWEDFVSVRWBWERVTCGHMUGSUHWAWDTLZW
      DMUIZWDNOZWFWIRWAVRWCTLWLVRVSVTUJCGHEUKWCTULUMWAGMWCUNZWMWAVSWOVRVSVTUOCG
      MHWCWCUPZUQVAGMWCURUSWAWCUTZNOWNWAWQGNVSVRWQGRVTCGHMVBSVRVSVTVCVDWQNWDNWC
      VEVFVAABDWDTFIJVGVHWAKWIWKWAKUFZWHLZAWDVIZWRWJLZCGVIZWRWILWRWKLVSVRWTXBVJ
      VTWSXACAGHWCMWPWGHRWHWJWRWGHDFVKVLVMSAWRWDWHVNCWRGWJVNVOVPVQ $.
  $}

  ${
    $d w x y z F $.
    $( There are no length ` om ` decreasing sequences in the ordinals.  See
       also ~ noinfep for a stronger version assuming Regularity.  (Contributed
       by Mario Carneiro, 19-May-2015.) $)
    onnseq $p |- ( ( F ` (/) ) e. On ->
      E. x e. om -. ( F ` suc x ) e. ( F ` x ) ) $=
      ( vy vw vz c0 cfv con0 wcel cv csuc com wral wrex wceq fveq2 eleq1d sylib
      wne cvv wn cmpt crn cin wa cep wwe wss epweon a1i wf simpl fveq2d eleq12d
      wi suceq rspcv onelon expcom syl6 adantld finds2 com12 ralrimiv eqid fmpt
      frn syl cdm peano1 fdm syl5eleqr ne0i dm0rn0 necon3bii wefrc syl3anc fvex
      wb rgenw cbvmptv ineq2 eqeq1d rexrnmpt ax-mp peano2 adantl eqeq2d sylancl
      rspcev elrnmpt sylibr rspccva adantll inelcm syl2anc neneqd nrexdv rexnal
      pm2.65da ) FBGZHIZAJZKZBGZXCBGZIZALMZUAXGUAALNXBXHCLCJZBGZUBZUCZDJZBGZUDZ
      FOZDLNZXBXHUEZXLEJZUDZFOZEXLNZXQXRHUFUGZXLHUHZXLFSZYBYCXRUIUJXRLHXKUKZYDX
      RXJHIZCLMYFXRYGCLXILIXRYGYGXBXSBGZHIZXSKZBGZHIZXRCEXIFOXJXAHXIFBPQXIXSOXJ
      YHHXIXSBPQXIYJOXJYKHXIYJBPQXBXHULXSLIZXHYIYLUOZXBYMXHYKYHIZYNXGYOAXSLXCXS
      OZXEYKXFYHYPXDYJBXCXSUPUMXCXSBPUNUQYIYOYLYHYKURUSUTVAVBVCVDCLHXJXKXKVEZVF
      RZLHXKVGVHXRXKVIZFSZYEXRFYSIYTXRFLYSVJXRYFYSLOYRLHXKVKVHVLYSFVMVHYSFXLFXK
      VNVOREHXLVPVQXNTIZDLMYBXQVSUUADLXMBVRVTYAXPDELXNXKTCDLXJXNXIXMBPWAXSXNOXT
      XOFXSXNXLWBWCWDWERXRXPDLXRXMLIZUEZXOFUUCXMKZBGZXLIZUUEXNIZXOFSUUCUUEXJOZC
      LNZUUFUUCUUDLIZUUEUUEOZUUIUUBUUJXRXMWFWGUUEVEUUHUUKCUUDLXIUUDOXJUUEUUEXIU
      UDBPWHWJWIUUETIUUFUUIVSUUDBVRCLXJUUEXKTYQWKWEWLXHUUBUUGXBXGUUGAXMLXCXMOZX
      EUUEXFXNUULXDUUDBXCXMUPUMXCXMBPUNWMWNUUEXLXNWOWPWQWRWTXGALWSWL $.
  $}

  $c Smo $.

  $( Introduce the strictly monotone ordinal function.  A strictly monotone
     function is one that is constantly increasing across the ordinals. $)
  wsmo $a wff Smo A $.

  ${
    $d x y A $.
    $( Definition of a strictly monotone ordinal function.  Definition 7.46 in
       [TakeutiZaring] p. 50.  (Contributed by Andrew Salmon, 15-Nov-2011.) $)
    df-smo $a |- ( Smo A <-> ( A : dom A --> On /\ Ord dom A /\ A. x e. dom A
       A. y e. dom A ( x e. y -> ( A ` x ) e. ( A ` y ) ) ) ) $.
  $}

  ${
    $d F x y $.
    $( Alternate definition of a strictly monotone ordinal function.
       (Contributed by Mario Carneiro, 4-Mar-2013.) $)
    dfsmo2 $p |- ( Smo F <-> ( F : dom F --> On /\ Ord dom F /\ A. x e. dom F
       A. y e. x ( F ` y ) e. ( F ` x ) ) ) $=
      ( wsmo cdm con0 wf word wel cfv wcel wral w3a df-smo ralcom impexp 3anass
      cv wi wa simpr ordtr1 3impib 3com23 simp3 3expia impbid2 syl5bbr ralbidv2
      jca imbi1d ralbidva syl5bb pm5.32i anbi2i 3bitr4i bitri ) CDCEZFCGZURHZBA
      IZBRZCJARZCJKZSZAURLBURLZMZUSUTVDBVCLZAURLZMZBACNUSUTVFTZTUSUTVITZTVGVJVK
      VLUSUTVFVIVFVEBURLZAURLUTVIVEBAURUROUTVMVHAURUTVCURKZTZVEVDBURVCVBURKZVES
      VPVATZVDSVOVEVPVAVDPVOVQVAVDVOVQVAVPVAUAUTVNVAVQUTVNVAMVPVAUTVAVNVPUTVAVN
      VPVBVCURUBUCUDUTVNVAUEUJUFUGUKUHUIULUMUNUOUSUTVFQUSUTVIQUPUQ $.
  $}

  ${
    $d x y A $.
    issmo.1 $e |- A : B --> On $.
    issmo.2 $e |- Ord B $.
    issmo.3 $e |- ( ( x e. B /\ y e. B ) -> ( x e. y -> ( A ` x ) e. ( A ` y
       ) ) ) $.
    issmo.4 $e |- dom A = B $.
    $( Conditions for which ` A ` is a strictly monotone ordinal function.
       (Contributed by Andrew Salmon, 15-Nov-2011.) $)
    issmo $p |- Smo A $=
      ( wsmo cdm con0 wf word cv wcel cfv wi wral mpbir eleq2i feq2i wceq ordeq
      wb ax-mp syl2anb rgen2a df-smo mpbir3an ) CICJZKCLZUJMZANZBNZOUMCPUNCPOQZ
      BUJRAUJRUKDKCLEUJDKCHUASULDMZFUJDUBULUPUDHUJDUCUESUOABUJUMUJOUMDOUNDOUOUN
      UJOUJDUMHTUJDUNHTGUFUGABCUHUI $.
  $}

  ${
    $d A x $.  $d F x y $.
    $( Alternative definition of a strictly monotone ordinal function.
       (Contributed by Mario Carneiro, 12-Mar-2013.) $)
    issmo2 $p |- ( F : A --> B -> ( ( B C_ On /\ Ord A /\
       A. x e. A A. y e. x ( F ` y ) e. ( F ` x ) ) -> Smo F ) ) $=
      ( wf con0 wss word cv cfv wcel wral w3a cdm wsmo fss ex fdm biimprd feq2d
      sylibrd wceq wb ordeq syl raleqdv 3anim123d dfsmo2 syl6ibr ) CDEFZDGHZCIZ
      BJEKAJZEKLBUNMZACMZNEOZGEFZUQIZUOAUQMZNEPUKULURUMUSUPUTUKULCGEFZURUKULVAC
      DGEQRUKUQCGECDESZUAUBUKUSUMUKUQCUCUSUMUDVBUQCUEUFTUKUTUPUKUOAUQCVBUGTUHAB
      EUIUJ $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for strictly monotone functions.  (Contributed by
       Andrew Salmon, 16-Nov-2011.) $)
    smoeq $p |- ( A = B -> ( Smo A <-> Smo B ) ) $=
      ( vx vy wceq cdm con0 wf word cv wcel cfv wi wral w3a wsmo raleqdv df-smo
      id fveq1 dmeq feq12d wb ordeq syl eleq12d imbi2d ralbidv 3bitrd 3anbi123d
      2ralbidv 3bitr4g ) ABEZAFZGAHZUNIZCJZDJZKZUQALZURALZKZMZDUNNCUNNZOBFZGBHZ
      VEIZUSUQBLZURBLZKZMZDVENZCVENZOAPBPUMUOVFUPVGVDVMUMUNVEGABUMSABUAZUBUMUNV
      EEUPVGUCVNUNVEUDUEUMVDVKDUNNZCUNNVLCUNNVMUMVCVKCDUNUNUMVBVJUSUMUTVHVAVIUQ
      ABTURABTUFUGUKUMVOVLCUNUMVKDUNVEVNQUHUMVLCUNVEVNQUIUJCDARCDBRUL $.

    $( The domain of a strictly monotone function is an ordinal.  (Contributed
       by Andrew Salmon, 16-Nov-2011.) $)
    smodm $p |- ( Smo A -> Ord dom A ) $=
      ( vx vy wsmo cdm con0 wf word cv wcel cfv wi wral df-smo simp2bi ) ADAEZF
      AGPHBIZCIZJQAKRAKJLCPMBPMBCANO $.

    $( A strictly monotone function restricted to an ordinal remains strictly
       monotone.  (Contributed by Andrew Salmon, 16-Nov-2011.)  (Proof
       shortened by Mario Carneiro, 5-Dec-2016.) $)
    smores $p |- ( ( Smo A /\ B e. dom A ) -> Smo ( A |` B ) ) $=
      ( vx vy cdm wcel wsmo con0 wf word cv cfv wi wral w3a wss ax-mp wceq syl
      wa cres wfn crn wfun funres funfn 3imtr3i resss rnss sstr anim12i 3imtr4i
      mpan df-f a1i ordelord expcom ordin ex syli wb dmres ordeq syl6ibr ssralv
      cin ralimi inss1 eqsstri simpl sseldi fvres simpr eleq12d imbi2d ralbidva
      dmss ralbiia sylibr 3anim123d df-smo 3imtr4g impcom ) BAEZFZAGZABUAZGZWEW
      DHAIZWDJZCKZDKZFZWKALZWLALZFZMZDWDNZCWDNZOWGEZHWGIZWTJZWMWKWGLZWLWGLZFZMZ
      DWTNZCWTNZOWFWHWEWIXAWJXBWSXHWIXAMWEAWDUBZAUCZHPZTWGWTUBZWGUCZHPZTWIXAXIX
      LXKXNAUDWGUDXIXLBAUEAUFWGUFUGXMXJPZXKXNWGAPZXOABUHZWGAUIQXMXJHUJUMUKWDHAU
      NWTHWGUNULUOWEWJBWDVFZJZXBWJWEBJZXSWJWEXTWDBUPUQXTWJXSBWDURUSUTWTXRRXBXSV
      AABVBZWTXRVCQVDWSXHMWEWSWQDWTNZCWTNZXHWSWRCWTNZYCWTWDPZWSYDMXPYEXQWGAVQQZ
      WRCWTWDVEQWRYBCWTYEWRYBMYFWQDWTWDVEQVGSXGYBCWTWKWTFZXFWQDWTYGWLWTFZTZXEWP
      WMYIXCWNXDWOYIWKBFXCWNRYIWTBWKWTXRBYABWDVHVIZYGYHVJVKWKBAVLSYIWLBFXDWORYI
      WTBWLYJYGYHVMVKWLBAVLSVNVOVPVRVSUOVTCDAWACDWGWAWBWC $.

    $( A strictly monotone function restricted to an ordinal remains strictly
       monotone.  (Contributed by Andrew Salmon, 19-Nov-2011.) $)
    smores3 $p |- ( ( Smo ( A |` B ) /\ C e. ( dom A i^i B ) /\ Ord B ) -> Smo
       ( A |` C ) ) $=
      ( cres wsmo cdm cin wcel word w3a dmres incom eqtri eleq2i smores 3adant3
      sylan2br wss wceq wb inss2 sseli ordelss sylan 3adant1 resabs1 smoeq 3syl
      ancoms mpbid ) ABDZEZCAFZBGZHZBIZJZUKCDZEZACDZEZULUOUSUPUOULCUKFZHUSVBUNC
      VBBUMGUNABKBUMLMNUKCOQPUQCBRZURUTSUSVATUOUPVCULUOCBHZUPVCUNBCUMBUAUBUPVDV
      CBCUCUIUDUEACBUFURUTUGUHUJ $.
  $}

  ${
    $d A x y $.  $d F x y $.
    $( A strictly monotone ordinal function restricted to an ordinal is still
       monotone.  (Contributed by Mario Carneiro, 15-Mar-2013.) $)
    smores2 $p |- ( ( Smo F /\ Ord A ) -> Smo ( F |` A ) ) $=
      ( vy vx wsmo word wa cdm con0 wf cv cfv wcel wral crn wss wfun dfsmo2 syl
      wceq cres wfn simp1bi ffun funres funfn sylib df-ima imassrn eqsstr3i frn
      cima syl5ss df-f sylanbrc adantr smodm cin ordin dmres ordeq ax-mp sylibr
      wb ancoms sylan resss dmss simp3bi ssralv mpsyl wel wi ordtr1 inss1 sseli
      eqsstri exp3acom23 imp31 fvres ad2antlr eleq12d ralbidva mpbird syl3anbrc
      syl6 ) BEZAFZGZBAUAZHZIWJJZWKFZCKZWJLZDKZWJLZMZCWPNZDWKNZWJEWGWLWHWGWJWKU
      BZWJOZIPWLWGBQZXAWGBHZIBJZXCWGXEXDFZWNBLZWPBLZMZCWPNZDXDNZDCBRZUCZXDIBUDS
      XCWJQXAABUEWJUFUGSWGXBBOZIXBBAULXNBAUHBAUIUJWGXEXNIPXMXDIBUKSUMWKIWJUNUOU
      PWGXFWHWMBUQWHXFWMWHXFGAXDURZFZWMAXDUSWKXOTWMXPVDBAUTZWKXOVAVBVCVEVFZWIWT
      XJDWKNZWGXSWHWKXDPZWGXKXSWJBPXTBAVGWJBVHVBWGXEXFXKXLVIXJDWKXDVJVKUPWIWSXJ
      DWKWIWPWKMZGZWRXICWPYBCDVLZGZWOXGWQXHYDWNAMZWOXGTWIYAYCYEWIYCYAYEWIYCYAGZ
      WNWKMZYEWIWMYFYGVMXRWNWPWKVNSWKAWNWKXOAXQAXDVOVQZVPWFVRVSWNABVTSYAWQXHTZW
      IYCYAWPAMYIWKAWPYHVPWPABVTSWAWBWCWCWDDCWJRWE $.
  $}

  $( The domain of a strictly monotone ordinal function is an ordinal.
     (Contributed by Mario Carneiro, 12-Mar-2013.) $)
  smodm2 $p |- ( ( F Fn A /\ Smo F ) -> Ord A ) $=
    ( wsmo wfn cdm word smodm wceq wb fndm ordeq syl biimpa sylan2 ) BCBADZBEZF
    ZAFZBGOQROPAHQRIABJPAKLMN $.

  ${
    $d F x y $.
    $( The function values of a strictly monotone ordinal function are
       ordinals.  (Contributed by Mario Carneiro, 12-Mar-2013.) $)
    smofvon2 $p |- ( Smo F -> ( F ` B ) e. On ) $=
      ( vy vx cdm wcel wsmo cfv con0 wi word wral dfsmo2 simp1bi ffvelrn expcom
      wf cv syl5 wn c0 ndmfv 0elon syl6eqel a1d pm2.61i ) ABEZFZBGZABHZIFZJUIUG
      IBQZUHUKUIULUGKCRBHDRZBHFCUMLDUGLDCBMNULUHUKUGIABOPSUHTZUKUIUNUJUAIABUBUC
      UDUEUF $.
  $}

  ${
    $d x y A $.
    iordsmo.1 $e |- Ord A $.
    $( The identity relation restricted to the ordinals is a strictly monotone
       function.  (Contributed by Andrew Salmon, 16-Nov-2011.) $)
    iordsmo $p |- Smo ( _I |` A ) $=
      ( vx vy cid cres con0 wf wfn crn wss fnresi rnresi word ordsson wcel wceq
      cv cfv fvresi ax-mp eqsstri df-f mpbir2an wa adantr adantl eleq12d dmresi
      biimprd issmo ) CDEAFZAAGULHULAIULJZGKALUMAGAMANAGKBAOUAUBAGULUCUDBCRZAPZ
      DRZAPZUEZUNULSZUPULSZPUNUPPURUSUNUTUPUOUSUNQUQAUNTUFUQUTUPQUOAUPTUGUHUJAU
      IUK $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y F $.
    $( The null set is a strictly monotone ordinal function.  (Contributed by
       Andrew Salmon, 20-Nov-2011.) $)
    smo0 $p |- Smo (/) $=
      ( cid c0 cres wsmo ord0 iordsmo wceq wb res0 smoeq ax-mp mpbi ) ABCZDZBDZ
      BEFMBGNOHAIMBJKL $.

    $( If ` B ` is a strictly monotone ordinal function, and ` A ` is in the
       domain of ` B ` , then the value of the function at ` A ` is an
       ordinal.  (Contributed by Andrew Salmon, 20-Nov-2011.) $)
    smofvon $p |- ( ( Smo B /\ A e. dom B ) -> ( B ` A ) e. On ) $=
      ( vx vy wsmo cdm con0 wf word cv wcel cfv wral df-smo simp1bi ffvelrnda
      wi ) BEZBFZGABRSGBHSICJZDJZKTBLUABLKQDSMCSMCDBNOP $.

    $( If ` x ` is less than ` y ` then a strictly monotone function's value
       will be strictly less at ` x ` than at ` y ` .  (Contributed by Andrew
       Salmon, 22-Nov-2011.) $)
    smoel $p |- ( ( Smo B /\ A e. dom B /\ C e. A ) -> ( B ` C ) e. ( B ` A )
       ) $=
      ( vx vy wsmo cdm wcel cfv wa wi word smodm ordtr1 expdimp wral wceq fveq2
      cv imbi12d ancomsd sylan con0 w3a df-smo eleq1 eleq1d eleq2 eleq2d rspc2v
      wf ancoms com12 3ad2ant3 sylbi syld pm2.43d 3impia ) BFZABGZHZCAHZCBIZABI
      ZHZUSVAJZVBVEVFVBCUTHZVBVEKZUSUTLZVAVBVGKBMVIVAVBVGVIVBVAVGCAUTNUAOUBUSVA
      VGVHUSUTUCBUKZVIDSZESZHZVKBIZVLBIZHZKZEUTPDUTPZUDVAVGJZVHKZDEBUEVRVJVTVIV
      SVRVHVGVAVRVHKVQVHCVLHZVCVOHZKDECAUTUTVKCQZVMWAVPWBVKCVLUFWCVNVCVOVKCBRUG
      TVLAQZWAVBWBVEVLACUHWDVOVDVCVLABRUITUJULUMUNUOOUPUQUR $.

    $( The value of a strictly monotone ordinal function contains its indexed
       union.  (Contributed by Andrew Salmon, 22-Nov-2011.) $)
    smoiun $p |- ( ( Smo B /\ A e. dom B ) -> U_ x e. A ( B ` x )
       C_ ( B ` A ) ) $=
      ( vy wsmo cdm wcel wa cv cfv ciun wrex eliun con0 wi smofvon smoel 3expia
      ontr1 exp3acom23 sylsyld rexlimdv syl5bi ssrdv ) CEZBCFGZHZDABAIZCJZKZBCJ
      ZDIZUJGULUIGZABLUGULUKGZAULBUIMUGUMUNABUGUKNGZUHBGZUIUKGZUMUNOBCPUEUFUPUQ
      BCUHQRUOUMUQUNULUIUKSTUAUBUCUD $.

    $( If ` F ` is an isomorphism from an ordinal ` A ` onto ` B ` , which is a
       subset of the ordinals, then ` F ` is a strictly monotonic function.
       Exercise 3 in [TakeutiZaring] p. 50.  (Contributed by Andrew Salmon,
       24-Nov-2011.) $)
    smoiso $p |- ( ( F Isom _E , _E ( A , B ) /\ Ord A /\ B C_ On )
        -> Smo F ) $=
      ( vx vy cep wiso word con0 wss w3a wf cv wcel cfv wral wb wa eleq2d wbr
      cdm wi wsmo wf1o isof1o f1of syl ffdm simpld fss 3adant2 syl3an1 wceq fdm
      sylan eqcomd ordeq 4syl biimpa 3adant3 3syl isorel epel fvex epelc biimpd
      anbi12d 3bitr3g ex sylbid ralrimivv 3ad2ant1 df-smo syl3anbrc ) ABFFCGZAH
      ZBIJZKCUAZICLZVRHZDMZEMZNZWACOZWBCOZNZUBZEVRPDVRPZCUCVOABCLZVPVQVSVOABCUD
      ZWIABFFCUEZABCUFZUGWIVQVSVPWIVRBCLZVQVSWIWMVRAJABCUHUIVRBICUJUOUKULVOVPVT
      VQVOVPVTVOWJWIAVRUMVPVTQWKWLWIVRAABCUNZUPAVRUQURUSUTVOVPWHVQVOWGDEVRVRVOW
      AVRNZWBVRNZRZWAANZWBANZRZWGVOWJWIWQWTQWKWLWIWOWRWPWSWIVRAWAWNSWIVRAWBWNSV
      GVAVOWTWGVOWTRZWCWFXAWAWBFTWDWEFTWCWFABWAWBFFCVBDEVCWDWEWBCVDVEVHVFVIVJVK
      VLDECVMVN $.
  $}

  ${
    $d A w x z $.  $d B w z $.  $d F w x y z $.
    $( A strictly monotone ordinal function preserves the epsilon relation.
       (Contributed by Mario Carneiro, 12-Mar-2013.) $)
    smoel2 $p |- ( ( ( F Fn A /\ Smo F ) /\ ( B e. A /\ C e. B ) )
      -> ( F ` C ) e. ( F ` B ) ) $=
      ( wfn wsmo wa wcel cfv cdm fndm eleq2d anbi1d biimprd smoel 3expib sylan9
      imp ) DAEZDFZGBAHZCBHZGZCDIBDIHZSUCBDJZHZUBGZTUDSUGUCSUFUAUBSUEABADKLMNTU
      FUBUDBDCOPQR $.
  $}

  ${
    $d A w x y z $.  $d F w x y z $.
    $( A strictly monotone ordinal function is one-to-one.  (Contributed by
       Mario Carneiro, 28-Feb-2013.) $)
    smo11 $p |- ( ( F : A --> B /\ Smo F ) -> F : A -1-1-> B ) $=
      ( vz vw vy vx wa cv cfv weq wi wral wcel word ex w3a 3ad2ant1 fveq2 sylan
      wsmo wceq wf1 simpl wfn ffn smodm2 ordelord syl anim12d wel w3o ordtri3or
      wf simp1rr smoel2 ralrimivva adantr simp2 eleq2d raleqbi1dv eleq1d rspccv
      simp3 rspcv syl6 3imp eleq1 biimpac syl31anc wn con0 smofvon2 ordirr 3syl
      eloni ad2antlr pm2.21dd 3exp ax-1 simp1rl eleq2 3jaod syl5 mpdd ralrimivv
      a1i dff13 sylanbrc ) ABCUNZCUAZHWJDIZCJZEIZCJZUBZDEKZLZEAMDAMZABCUCWJWKUD
      WJCAUEZWKWSABCUFWTWKHZWRDEAAXAWLANZWNANZHZWLOZWNOZHZWRXAXBXEXCXFXAAOZXBXE
      LACUGZXHXBXEAWLUHPUIXAXHXCXFLXIXHXCXFAWNUHPUIUJXAXDXGWRLXGDEUKZWQEDUKZULX
      AXDHZWRWLWNUMXLXJWRWQXKXLXJWPWQXLXJWPQZWOWONZWQXMXCFIZCJZGIZCJZNZFXQMZGAM
      ZXJWPXNXBXCXAXJWPUOXLXJYAWPXAYAXDXAXSGFAXQAXQXOCUPUQURZRXLXJWPUSXLXJWPVDX
      CYAXJQWMWONZWPXNXCYAXJYCXCYAXPWONZFWNMZXJYCLXTYEGWNAXSYDFXQWNGEKXRWOXPXQW
      NCSUTVAVEYDYCFWLWNFDKXPWMWOXOWLCSVBVCVFVGWPYCXNWMWOWOVHVITVJXLXJXNVKZWPWK
      YFWTXDWKWOVLNWOOYFWNCVMWOVPWOVNVOVQZRVRVSWQWRLXLWQWPVTWGXLXKWPWQXLXKWPQZX
      NWQYHXBYAXKWPXNXBXCXAXKWPWAXLXKYAWPYBRXLXKWPUSXLXKWPVDXBYAXKQWOWMNZWPXNXB
      YAXKYIXBYAXPWMNZFWLMZXKYILXTYKGWLAXSYJFXQWLGDKXRWMXPXQWLCSUTVAVEYJYIFWNWL
      FEKXPWOWMXOWNCSVBVCVFVGWPYIXNWMWOWOWBVITVJXLXKYFWPYGRVRVSWCWDPWEWFTDEABCW
      HWI $.
  $}

  ${
    $( A strictly monotone ordinal function preserves strict ordering.
       (Contributed by Mario Carneiro, 4-Mar-2013.) $)
    smoord $p |- ( ( ( F Fn A /\ Smo F ) /\ ( C e. A /\ D e. A ) ) ->
      ( C e. D <-> ( F ` C ) e. ( F ` D ) ) ) $=
      ( wa wcel word cfv ordelord syl2anc w3a simp3 wi smoel2 3expia ordirr syl
      wn 3adant3 neleqtrd wfn wsmo wb smodm2 adantr simprl simprr w3o ordtri3or
      wceq expr adantrl 3impia 2thd con0 smofvon2 ad2antlr eloni fveq2d 2falsed
      3syl ordn2lp pm3.2 3ad2ant3 mtod adantrlr 3impb pm3.21 3jaod syl5 mp2and
      ) DAUAZDUBZEZBAFZCAFZEZEZBGZCGZBCFZBDHZCDHZFZUCZVRAGZVOVSVNWFVQADUDUEZVNV
      OVPUFABIJZVRWFVPVTWGVNVOVPUGACIJZVSVTEWABCUJZCBFZUHVRWEBCUIVRWAWEWJWKVNVQ
      WAWEVNVQWAKWAWDVNVQWALVNVQWAWDVNVPWAWDMVOVNVPWAWDACBDNUKULUMUNOVNVQWJWEVN
      VQWJKZWAWDWLBCBVNVQBBFRZWJVRVSWMWHBPQSVNVQWJLZTWLWBWCWBVNVQWBWBFRZWJVRWBU
      OFZWBGZWOVMWPVLVQBDUPUQZWBURZWBPVASWLBCDWNUSTUTOVNVQWKWEVNVQWKKZWAWDWTWAW
      KWAEZWTVTXARVNVQVTWKWISCBVBQWKVNWAXAMVQWKWAVCVDVEWTWDWDWCWBFZEZWTWQXCRVNV
      QWQWKVRWPWQWRWSQSWBWCVBQWTXBWDXCMVNVQWKXBVNVOWKXBVPABCDNVFVGXBWDVHQVEUTOV
      IVJVK $.
  $}

  ${
    $( A strictly monotone ordinal function preserves weak ordering.
       (Contributed by Mario Carneiro, 4-Mar-2013.) $)
    smoword $p |- ( ( ( F Fn A /\ Smo F ) /\ ( C e. A /\ D e. A ) ) ->
      ( C C_ D <-> ( F ` C ) C_ ( F ` D ) ) ) $=
      ( wfn wsmo wa wcel wn cfv wss word ordelord syl2anc ordtri1 con0 smofvon2
      wb eloni 3syl smoord notbid ancom2s smodm2 adantr simprl simprr 3bitr4d
      simplr ) DAEZDFZGZBAHZCAHZGZGZCBHZIZCDJZBDJZHZIZBCKZUTUSKZULUNUMURVBRULUN
      UMGGUQVAACBDUAUBUCUPBLZCLZVCURRUPALZUMVEULVGUOADUDUEZULUMUNUFABMNUPVGUNVF
      VHULUMUNUGACMNBCONUPUTLZUSLZVDVBRUPUKUTPHVIUJUKUOUIZBDQUTSTUPUKUSPHVJVKCD
      QUSSTUTUSONUH $.
  $}

  ${
    $d A y x $.  $d C x $.  $d F y x $.
    $( A strictly monotone ordinal function is greater than or equal to its
       argument.  Exercise 1 in [TakeutiZaring] p. 50.  (Contributed by Andrew
       Salmon, 23-Nov-2011.)  (Revised by Mario Carneiro, 28-Feb-2013.) $)
    smogt $p |- ( ( F Fn A /\ Smo F /\ C e. A ) -> C C_ ( F ` C ) ) $=
      ( vx vy wcel cfv wss wa cv wi id fveq2 sseq12d w3a word syl2anc imp com12
      wral wfn wsmo wceq imbi2d con0 smodm2 3adant3 simp3 ordelord vex elon weq
      sylibr eleq1 3anbi3d imbi12d simpl1 simpl2 ordtr1 exp3acom23 sylc syl3anc
      wel pm2.27 ralimdva simp31 simp32 smofvon2 3ad2ant2 eloni simp33 3adantr3
      smoel2 3impa ordtr2 syl22anc 3expia 3expd 3impia dfss3 syl6ibr syld tfis2
      syl a1i mpcom vtoclga ) CAUAZCUBZBAFZBBCGZHZWJWHWIIZWLWMDJZWNCGZHZKWMWLKD
      BAWNBUCZWPWLWMWQWNBWOWKWQLWNBCMNUDWMWNAFZWPWHWIWRWPWNUEFZWHWIWROZWPWTWNPZ
      WSWTAPZWRXAWHWIXBWRACUFZUGZWHWIWRUHZAWNUIZQWNDUJUKUMWTWPKZWHWIEJZAFZOZXHX
      HCGZHZKZDEDEULZWTXJWPXLXNWRXIWHWIWNXHAUNUOXNWNXHWOXKXNLWNXHCMNUPXMEWNTZXG
      KWSWTXOWPWTXOXLEWNTZWPWTXMXLEWNWTEDVCZIWHWIXIXMXLKWHWIWRXQUQWHWIWRXQURWTX
      QXIWTXBWRXQXIKXDXEXBXQWRXIXHWNAUSUTVARXJXLVDVBVEWTXPXHWOFZEWNTWPWTXLXREWN
      WTXQXLXRKZWHWIWRXQXSKWMWRXQXLXRWHWIWRXQXLOZXRWHWIXTOZXHPZWOPZXLXKWOFZXRYA
      XAXQYBYAXBWRXAWHWIXBXTXCUGWHWIWRXQXLVFXFQWHWIWRXQXLVGWNXHUIQYAWOUEFZYCWIW
      HYEXTWNCVHVIWOVJWDWHWIWRXQXLVKWHWIXTYDWMWRXQYDXLAWNXHCVMVLVNYBYCIXLYDIXRX
      HXKWOVORVPVQVRVSRVEEWNWOVTWAWBSWEWCWFVQSWGSVS $.
  $}

  ${
    $d A x $.  $d B x $.  $d F x $.
    $( The range of a strictly monotone ordinal function dominates the domain.
       (Contributed by Mario Carneiro, 13-Mar-2013.) $)
    smorndom $p |- ( ( F : A --> B /\ Smo F /\ Ord B ) -> A C_ B ) $=
      ( vx wf wsmo word w3a cv wcel wa cfv wss wfn simpl1 ffn syl simpl2 smodm2
      syl2anc ordelord sylancom simpl3 simpr smogt syl3anc 3ad2antl1 ordtr2 imp
      ffvelrn syl22anc ex ssrdv ) ABCEZCFZBGZHZDABUQDIZAJZURBJZUQUSKZURGZUPURUR
      CLZMZVCBJZUTUQUSAGZVBVACANZUOVFVAUNVGUNUOUPUSOABCPQZUNUOUPUSRZACSTAURUAUB
      UNUOUPUSUCVAVGUOUSVDVHVIUQUSUDAURCUEUFUNUOUSVEUPABURCUJUGVBUPKVDVEKUTURVC
      BUHUIUKULUM $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.
    $( The strictly monotone ordinal functions are also epsilon isomorphisms of
       subclasses of ` On ` .  (Contributed by Mario Carneiro, 20-Mar-2013.) $)
    smoiso2 $p |- ( ( Ord A /\ B C_ On ) ->
      ( ( F : A -onto-> B /\ Smo F ) <-> F Isom _E , _E ( A , B ) ) ) $=
      ( vx vy word con0 wss wa wfo wsmo cep cv wbr cfv wral sylan sylanbrc wcel
      adantl wiso wf1o wb wf1 fof smo11 simpl df-f1o wfn fofn smoord epel epelc
      wf 3bitr4g ralrimivva df-isom ex w3a isof1o f1ofo syl 3ad2ant1 smoiso jca
      fvex 3expib com12 impbid ) AFZBGHZIZABCJZCKZIZABLLCUAZVLVOVPVLVOIABCUBZDM
      ZEMZLNZVRCOZVSCOZLNZUCZEAPDAPZVPVOVQVLVOABCUDZVMVQVMABCUNVNWFABCUEABCUFQV
      MVNUGABCUHRTVOWEVLVMCAUIZVNWEABCUJWGVNIZWDDEAAWHVRASVSASIIVRVSSWAWBSVTWCA
      VRVSCUKDEULWAWBVSCVFUMUOUPQTDEABLLCUQRURVPVLVOVPVJVKVOVPVJVKUSVMVNVPVJVMV
      KVPVQVMABLLCUTABCVAVBVCABCVDVEVGVHVI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    "Strong" transfinite recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c recs $.

  $( Notation for a function defined by strong transfinite recursion. $)
  crecs $a class recs ( F ) $.

  ${
    $d F f x y $.
    $( Define a function ` recs ( F ) ` on ` On ` , the class of ordinal
       numbers, by transfinite recursion given a rule ` F ` which sets the next
       value given all values so far.  See ~ df-rdg for more details on why
       this definition is desirable.  Unlike ~ df-rdg which restricts the
       update rule to use only the previous value, this version allows the
       update rule to use _all_ previous values, which is why it is described
       as "strong", although it is actually more primitive.  See ~ recsfnon and
       ~ recsval for the primary contract of this definition.

       _EDITORIAL_: there are several existing versions of this construction
       without the definition, notably in ~ ordtype , ~ zorn2 , and
       ~ dfac8alem .  (Contributed by Stefan O'Rear, 18-Jan-2015.)
       (New usage is discouraged.) $)
    df-recs $a |- recs ( F ) = U. { f | E. x e. On ( f Fn x /\
        A. y e. x ( f ` y ) = ( F ` ( f |` y ) ) ) } $.
  $}

  ${
    $d F a b c y $.  $d G a b c y $.  $d x y a b c $.
    $( Equality theorem for ` recs ` .  (Contributed by Stefan O'Rear,
       18-Jan-2015.) $)
    recseq $p |- ( F = G -> recs ( F ) = recs ( G ) ) $=
      ( va vb vc wceq cv wfn cfv cres wral wa con0 wrex cuni crecs fveq1 eqeq2d
      cab df-recs ralbidv anbi2d rexbidv abbidv unieqd 3eqtr4g ) ABFZCGZDGZHZEG
      ZUHIZUHUKJZAIZFZEUIKZLZDMNZCSZOUJULUMBIZFZEUIKZLZDMNZCSZOAPBPUGUSVEUGURVD
      CUGUQVCDMUGUPVBUJUGUOVAEUIUGUNUTULUMABQRUAUBUCUDUEDECATDECBTUF $.

    nfrecs.f $e |- F/_ x F $.
    $( Bound-variable hypothesis builder for ` recs ` .  (Contributed by Stefan
       O'Rear, 18-Jan-2015.) $)
    nfrecs $p |- F/_ x recs ( F ) $=
      ( va vb vc crecs cv wfn cfv cres wceq wral wa con0 wrex cuni df-recs nfcv
      cab nfv nffv nfeq2 nfral nfan nfrex nfab nfuni nfcxfr ) ABGDHZEHZIZFHZUJJ
      ZUJUMKZBJZLZFUKMZNZEOPZDTZQEFDBRAVAUTADUSAEOAOSULURAULAUAUQAFUKAUKSAUNUPA
      UOBCAUOSUBUCUDUEUFUGUHUI $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z w F $.  $d x y z w G $.
    $( A technical lemma for transfinite recursion.  Compare Lemma 1 of
       [TakeutiZaring] p. 47.  (Contributed by NM, 23-Mar-1995.)  (Revised by
       David Abernethy, 19-Jun-2012.) $)
    tfrlem1 $p |- ( A e. On -> ( ( F Fn A /\ G Fn A ) ->
                  ( A. x e. A ( ( F ` x ) = ( B ` ( F |` x ) ) /\
                                        ( G ` x ) = ( B ` ( G |` x ) ) ) ->
                  A. x e. A ( F ` x ) = ( G ` x ) ) ) ) $=
      ( vy vz vw con0 wcel wa wss cv cfv wceq wral wi raleq imbi12d syl6 imbi2d
      wfn cres ssid sseq1 anbi2d anbi12d ralim onelss sstr2 anim2d ssralv com23
      anim12d ralrimdv nfra1 fveq2 eqeq12d cbvralv syl5bb cbvral fvreseq fveq2d
      nfv biimpar eqeq12 syl5ibr exp4c com4l syl9 imp4a ralimdva syl5bi imim12d
      imp31 ex pm2.43 syl56 tfis2 vtoclga mpii ) BIJDBUBEBUBKZBBLZAMZDNZDWDUCZC
      NZOWDENZEWDUCZCNZOKZABPZWEWHOZABPZQZBUDWBFMZBLZWKAWPPZWMAWPPZQZQZQWBWCWOQ
      ZQFBIWPBOZXAXBWBXCWQWCWTWOWPBBUEXCWRWLWSWNWKAWPBRWMAWPBRSSUAWPIJZWBWQWRWS
      WBWQKZWRKZWSQZWBGMZBLZKZWKAXHPZKZWMAXHPZQZFGWPXHOZXFXLWSXMXOXEXJWRXKXOWQX
      IWBWPXHBUEUFWKAWPXHRUGWMAWPXHRSXNGWPPXLGWPPZXMGWPPZQXDXFXGQXGXLXMGWPUHXDX
      FXPXQXGXDXFXLGWPXDXHWPJZXFXLXDXRXHWPLZXFXLQWPXHUIXSXEXJWRXKXSWQXIWBXHWPBU
      JUKWKAXHWPULUNTUMUOXDXQXEWRWSXDXEXQWTXDXEXQWTQXQHMZDNZXTENZOZHWDPZAWPPZXD
      XEKZWTXMYDGAWPWMAXHUPYDGVDXMYCHXHPXHWDOYDWMYCAHXHWDXTOWEYAWHYBWDXTDUQWDXT
      EUQURUSYCHXHWDRUTVAYFYEWKWMQZAWPPWTYFYDYGAWPXDXEWDWPJZYDYGQZXDYHXEYIXDYHW
      BWQYIXDYHWDWPLZWBWQYIQQWPWDUIYJWQWDBLZWBYIWDWPBUJWKWBYKYDWMWKWBYKYDWMWBYK
      KZYDKZWMWKWGWJOYMWFWICYLWFWIOYDHBWDDEVBVEVCWEWGWHWJVFVGVHVIVJTVKUMVOVLWKW
      MAWPUHTVMVPUMVKVNXFWSVQVRVSVHVTWA $.
  $}

  ${
    $d w A $.  $d w F $.  $d w G $.  $d w x $.
    $( Lemma for transfinite recursion.  This provides some messy details
       needed to link ~ tfrlem1 into the main proof.  (Contributed by NM,
       23-Mar-1995.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    tfrlem2 $p |- ( ( F Fn A /\ G Fn A ) ->
       ( ( <. x , y >. e. F /\ <. x , z >. e. G ) ->
       ( A e. On -> ( A. w ( A e. On -> ( w e. A ->
          ( ( F ` w ) = ( B ` ( F |` w ) ) /\
            ( G ` w ) = ( B ` ( G |` w ) ) ) ) ) ->
       y = z ) ) ) ) $=
      ( wfn wa cv cop wcel cfv cres wceq wi wal 19.28v imp con0 abai albii wral
      df-ral anbi2i fnop adantlr tfrlem1 com12 imp3a adantr fveq2 eqeq12d rspcv
      3bitr3ri sylsyld adantlrr sylan2br wfun fnfun anim12i funopfv an4s eqeq12
      wb sylan syl mpbid sylan2b exp43 ) GEIZHEIZJZAKZBKZLGMZVOCKZLHMZJZEUAMZWA
      DKZEMWBGNZGWBOFNPWBHNZHWBOFNPJZQZQZDRZVPVRPZWAWHJZVNVTJZWAWFDRZJZWIWAWFJZ
      DRWAWGJZDRWMWJWNWODWAWFUBUCWAWFDSWAWGDSUPWKWMJVOGNZVOHNZPZWIWMWKWAWEDEUDZ
      JZWRWSWLWAWEDEUEUFVNVQWTWRVSVNVQJZWTWRXAVOEMZWTWCWDPZDEUDZWRVLVQXBVMEVOVP
      GUGUHVNWTXDQVQVNWAWSXDWAVNWSXDQDEFGHUIUJUKULXCWRDVOEWBVOPWCWPWDWQWBVOGUMW
      BVOHUMUNUOUQTURUSWKWRWIVFZWMWKWPVPPZWQVRPZJZXEVNGUTZHUTZJVTXHVLXIVMXJEGVA
      EHVAVBXIVQXJVSXHXIVQJXFXJVSJXGXIVQXFVOVPGVCTXJVSXGVOVRHVCTVBVDVGWPVPWQVRV
      EVHULVIVJVK $.
  $}

  ${
    $d x y f g $.  $d x y z $.  $d g z $.  $d f g F $.  $d x z F $.
    tfrlem3.1 $e |- A = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( F ` ( f |` y ) ) ) } $.
    $( Lemma for transfinite recursion.  Let ` A ` be the class of "acceptable"
       functions.  The final thing we're interested in is the union of all
       these acceptable functions.  This lemma just changes some bound
       variables in ` A ` for later use.  (Contributed by NM, 9-Apr-1995.) $)
    tfrlem3 $p |- A = { g | E. z e. On ( g Fn z /\
                A. y e. z ( g ` y ) = ( F ` ( g |` y ) ) ) } $=
      ( cv wfn cfv cres wceq wral wa con0 wrex cab wcel anbi12d vex fneq1 fveq1
      reseq1 fveq2d eqeq12d ralbidv rexbidv elab fneq2 raleq bitri abbi2i eqtri
      cbvrexv ) DEIZAIZJZBIZUPKZUPUSLZGKZMZBUQNZOZAPQZERZFIZCIZJZUSVHKZVHUSLZGK
      ZMZBVINZOZCPQZFRHVQFVGVHVGSVHUQJZVNBUQNZOZAPQZVQVFWAEVHFUAUPVHMZVEVTAPWBU
      RVRVDVSUQUPVHUBWBVCVNBUQWBUTVKVBVMUSUPVHUCWBVAVLGUPVHUSUDUEUFUGTUHUIVTVPA
      CPUQVIMVRVJVSVOUQVIVHUJVNBUQVIUKTUOULUMUN $.
  $}

  ${
    $d x y f g $.  $d f g F $.
    tfrlem3a.1 $e |- A = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( F ` ( f |` y ) ) ) } $.
    $( Lemma for transfinite recursion.  Let ` A ` be the class of "acceptable"
       functions.  The final thing we're interested in is the union of all
       these acceptable functions.  This lemma just changes some bound
       variables in ` A ` for later use.  (Contributed by NM, 22-Jul-2012.) $)
    tfrlem3a $p |- A = { g | E. x e. On ( g Fn x /\
                A. y e. x ( g ` y ) = ( F ` ( g |` y ) ) ) } $=
      ( cv wfn cfv cres wceq wral wa con0 wrex cab fneq1 fveq1 reseq1 eqeq12d
      fveq2d ralbidv anbi12d rexbidv cbvabv eqtri ) CDHZAHZIZBHZUHJZUHUKKZFJZLZ
      BUIMZNZAOPZDQEHZUIIZUKUSJZUSUKKZFJZLZBUIMZNZAOPZEQGURVGDEUHUSLZUQVFAOVHUJ
      UTUPVEUIUHUSRVHUOVDBUIVHULVAUNVCUKUHUSSVHUMVBFUHUSUKTUBUAUCUDUEUFUG $.
  $}

  ${
    $d f g x y z B $.  $d f x y z C $.  $d f g h u v w x y z F $.
    $d g h z A $.
    tfrlem.1 $e |- A = { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( F ` ( f |` y ) ) ) } $.
    $( Lemma for transfinite recursion. ` A ` is the class of all "acceptable"
       functions, and ` F ` is their union.  First we show that an acceptable
       function is in fact a function.  (Contributed by NM, 9-Apr-1995.) $)
    tfrlem4 $p |- ( g e. A -> Fun g ) $=
      ( vz cv wcel wfn cfv cres wceq wral wa con0 wrex wfun tfrlem3 fnfun sylbi
      abeq2i adantr rexlimivw ) EIZCJUFHIZKZBIZUFLUFUIMFLNBUGOZPZHQRZUFSZULECAB
      HCDEFGTUCUKUMHQUHUMUJUGUFUAUDUEUB $.

    $( Lemma for transfinite recursion.  The values of two acceptable functions
       are the same within their domains.  (Contributed by NM, 9-Apr-1995.) $)
    tfrlem5 $p |- ( ( g e. A /\ h e. A ) ->
                  ( ( <. x , u >. e. g /\ <. x , v >. e. h ) -> u = v ) ) $=
      ( vz vw cv wcel wa wfn cfv cres con0 wi wceq wral wrex cop tfrlem3 abeq2i
      weq anbi12i reeanv bitr4i cin wal onin r19.26m simpr elin sylib prth syl5
      wss wb onelss impac fvres resabs1 fveq2d eqeqan12rd anbi12d bicomd mpbidi
      exp3a sylbir anim2i an4s 2elresin fnresin1 fnresin2 tfrlem2 syl2an sylbid
      syl alimi com24 com3r imp32 ex rexlimivv sylbi ) GMZENZHMZENZOZWIKMZPZBMZ
      WIQZWIWPRZIQZUAZBWNUBZOZWKLMZPZWPWKQZWKWPRZIQZUAZBXCUBZOZOZLSUCKSUCZAMZDM
      UDZWINXMCMUDZWKNOZDCUGZTZWMXBKSUCZXJLSUCZOXLWJXSWLXTXSGEABKEFGIJUEUFXTHEA
      BLEFHIJUEUFUHXBXJKLSSUIUJXKXRKLSSWNSNXCSNOZXKXRYAWNXCUKZSNZWOXDOZYCWPYBNZ
      WPWIYBRZQZYFWPRZIQZUAZWPWKYBRZQZYKWPRZIQZUAZOZTTZBULZOZXRXKWNXCUMWOXDXAXI
      YSXAXIOZYRYDYTWPWNNZWTTWPXCNZXHTOZBULYRWTXHBWNXCUNUUCYQBUUCYCYEYPYCYEOZWT
      XHOZYPUUCUUDUUAUUBOZUUCUUEUUDYEUUFYCYEUOWPWNXCUPUQUUAWTUUBXHURUSUUDYPUUEU
      UDWPYBUTZYEOZYPUUEVAYCYEUUGYBWPVBVCUUHYJWTYOXHYEUUGYGWQYIWSWPYBWIVDUUGYHW
      RIWIWPYBVEVFVGYEUUGYLXEYNXGWPYBWKVDUUGYMXFIWKWPYBVEVFVGVHWAVIVJVKWBVLVMVN
      YCYDYRXRYDYRYCXRYDXPYCYRXQYDXPXNYFNXOYKNOZYCYRXQTTZADCWNXCWIWKVOWOYFYBPYK
      YBPUUIUUJTXDWNXCWIVPXCWNWKVQADCBYBIYFYKVRVSVTWCWDWEVSWFWGWH $.

    $( Lemma for transfinite recursion.  The definition ` recs ` is the union
       of all acceptable functions.  (Contributed by Mario Carneiro,
       9-May-2015.) $)
    recsfval $p |- recs ( F ) = U. A $=
      ( crecs cv wfn cfv cres wceq wral wa con0 wrex cab cuni df-recs unieqi
      eqtr4i ) EGDHZAHZIBHZUBJUBUDKEJLBUCMNAOPDQZRCRABDESCUEFTUA $.

    $( Lemma for transfinite recursion.  The union of all acceptable functions
       is a relation.  (Contributed by NM, 8-Aug-1994.)  (Revised by Mario
       Carneiro, 9-May-2015.) $)
    tfrlem6 $p |- Rel recs ( F ) $=
      ( vg crecs wrel cuni reluni wcel wfun tfrlem4 funrel syl mprgbir recsfval
      cv releqi mpbir ) EHZICJZIZUDGSZIZGCGCKUECLUEMUFABCDGEFNUEOPQUBUCABCDEFRT
      UA $.

    $( Lemma for transfinite recursion.  The union of all acceptable functions
       is a function.  (Contributed by NM, 9-Aug-1994.) $)
    tfrlem7 $p |- Fun recs ( F ) $=
      ( vu vv vg vh cv cop wcel wa wal wex eleq2i eluni bitri sylbi wfun weq wi
      crecs wrel tfrlem6 cuni recsfval anbi12i eeanv an4 ancom tfrlem5 exlimivv
      bitr4i imp ax-gen gen2 dffun4 mpbir2an ) EUDZUAVAUEAKZGKLZVAMZVBHKLZVAMZN
      ZGHUBZUCZHOZGOAOABCDEFUFVJAGVIHVGVCIKZMZVKCMZNZVEJKZMZVOCMZNZNZJPIPZVHVGV
      NIPZVRJPZNVTVDWAVFWBVDVCCUGZMWAVAWCVCABCDEFUHZQIVCCRSVFVEWCMWBVAWCVEWDQJV
      ECRSUIVNVRIJUJUOVSVHIJVSVMVQNZVLVPNZNZVHVSWFWENWGVLVMVPVQUKWFWEULSWEWFVHA
      BHGCDIJEFUMUPTUNTUQURAGHVAUSUT $.

    $( Lemma for transfinite recursion.  The domain of ` recs ` is ordinal.
       (Contributed by NM, 14-Aug-1994.)  (Proof shortened by Alan Sare,
       11-Mar-2008.) $)
    tfrlem8 $p |- Ord dom recs ( F ) $=
      ( vz vg crecs cdm word cv wceq wrex cuni con0 wcel cfv rexlimiv ax-mp cab
      wss wi wfn cres wral wa tfrlem3 abeq2i fndm adantr eleq1d biimprcd eleq1a
      sylbi syl abssi ssorduni ciun recsfval dmeqi dmuni vex dmex dfiun2 3eqtri
      wb ordeq mpbir ) EIZJZKZGLZHLZJZMZHCNZGUAZOZKZVRPUBVTVQGPVPVMPQZHCVNCQZVO
      PQZVPWAUCWBVNVMUDZBLZVNRVNWEUEERMBVMUFZUGZGPNZWCWHHCABGCDHEFUHUIWGWCGPWGW
      CWAWGVOVMPWDVOVMMWFVMVNUJUKULUMSUOVOPVMUNUPSUQVRURTVKVSMVLVTVGVKCOZJHCVOU
      SVSVJWIABCDEFUTVAHCVBHGCVOVNHVCVDVEVFVKVSVHTVI $.

    $( Lemma for transfinite recursion.  Here we compute the value of ` recs `
       (the union of all acceptable functions).  (Contributed by NM,
       17-Aug-1994.) $)
    tfrlem9 $p |- ( B e. dom recs ( F ) ->
      ( recs ( F ) ` B ) = ( F ` ( recs ( F ) |` B ) ) ) $=
      ( vz cdm wcel cv wex cfv cres wceq wa con0 wi syl com3l crecs cop ibi wfn
      eldm2g wral wrex cab cuni df-recs eleq2i eluniab bitri wss abeq2i elssuni
      fnop rspe recsfval syl6sseqr sylbir fveq2 reseq2 fveq2d rspcv fndm eleq2d
      eqeq12d wfun tfrlem7 funssfv mp3an1 adantrl eleq1d onelss imp31 fun2ssres
      syl6bir w3a sylan2 exbiri exp31 com34 com24 sylbird syld imp4d mpdi exp4d
      ex com4r pm2.43i imp4a rexlimdv imp exlimiv sylbi ) DFUAZIZJZDHKZUBZWRJZH
      LZDWRMZWRDNZFMZOZWTXDHDWRWSUEUCXCXHHXCXBEKZJZXIAKZUDZBKZXIMZXIXMNZFMZOZBX
      KUFZPZAQUGZPZELZXHXCXBXTEUHUIZJYBWRYCXBABEFUJUKXTEXBULUMYAXHEXJXTXHXJXSXH
      AQXJXKQJZXLXRXHXLXJYDXRXHRZXLXJYDYERRXLXJYDXLYEXLXJYDXLYERRXLXJPZYDXLXRXH
      YFDXKJZYDXSPZXHRXKDXAXIUQYGYHXIWRUNZXHYHXTYIXSAQURXTXICJZYIXTECGUOYJXICUI
      WRXICUPABCEFGUSUTVASYGYDXLXRYIXHRZYGXRXLYDYKYGXRDXIMZXIDNZFMZOZXLYDYKRZRX
      QYOBDXKXMDOZXNYLXPYNXMDXIVBYQXOYMFXMDXIVCVDVHVEXLYGYOYPXLYGDXIIZJZYOYPRXL
      YRXKDXKXIVFZVGXLYDYOYSYKXLYDYSYOYKXLYDYSYOYKRYIXLYDPZYSPZYOXHYIUUBXHYOYIU
      UBPXEYLXGYNYIYSXEYLOZUUAWRVIZYIYSUUCABCEFGVJZDWRXIVKVLVMUUBYIDYRUNZXGYNOZ
      XLYDYSUUFXLYDYRQJYSUUFRXLYRXKQYTVNYRDVOVRVPUUDYIUUFUUGUUEUUDYIUUFVSXFYMFD
      WRXIVQVDVLVTVHWATWBWCWDWETWFWDWGWHSWIWJWKWLTWMWNWOWPWQWPS $.

    $( Lemma for transfinite recursion.  Without using ~ ax-rep , show that all
       the restrictions of ` recs ` are sets.  (Contributed by Mario Carneiro,
       16-Nov-2014.) $)
    tfrlem9a $p |- ( B e. dom recs ( F ) -> ( recs ( F ) |` B ) e. _V ) $=
      ( vg vz cdm wcel cfv cv wa cres cvv wceq con0 wss a1i cop tfrlem7 funfvop
      crecs wex wfun mpan cuni recsfval eleq2i eluni bitri wfn wral wrex simprr
      sylib tfrlem3 abeq2i simplrr elssuni syl6sseqr word fndm ad2antll eqeltrd
      syl simprl eloni simpll fvex simplrl df-br sylibr breldmg syl3anc ordelss
      wbr syl2anc fun2ssres vex resex expr adantrd rexlimdva mpd exlimddv ) DFU
      DZJZKZDDWHLZUAZHMZKZWMCKZNZWHDOZPKZHWJWLWHKZWPHUEZWHUFZWJWSABCEFGUBZDWHUC
      UGWSWLCUHZKWTWHXCWLABCEFGUIZUJHWLCUKULUQWJWPNZWMIMZUMZBMZWMLWMXHOFLQBXFUN
      ZNZIRUOZWRXEWOXKWJWNWOUPXKHCABICEHFGURUSUQXEXJWRIRXEXFRKZNXGWRXIXEXLXGWRX
      EXLXGNZNZWQWMDOZPXNXAWMWHSDWMJZSZWQXOQXAXNXBTXNWMXCWHXNWOWMXCSWJWNWOXMUTW
      MCVAVGXDVBXNXPVCZDXPKZXQXNXPRKXRXNXPXFRXGXPXFQXEXLXFWMVDVEXEXLXGVHVFXPVIV
      GXNWJWKPKZDWKWMVRZXSWJWPXMVJXTXNDWHVKTXNWNYAWJWNWOXMVLDWKWMVMVNDWKWIPWMVO
      VPXPDVQVSDWHWMVTVPXOPKXNWMDHWAWBTVFWCWDWEWFWG $.

    ${
      tfrlem.3 $e |- C = ( recs ( F ) u. { <. dom recs ( F ) ,
        ( F ` recs ( F ) ) >. } ) $.
      $( Lemma for transfinite recursion.  We define class ` C ` by extending
         ` recs ` with one ordered pair.  We will assume, falsely, that domain
         of ` recs ` is a member of, and thus not equal to, ` On ` .  Using
         this assumption we will prove facts about ` C ` that will lead to a
         contradiction in ~ tfrlem14 , thus showing the domain of ` recs ` does
         in fact equal ` On ` .  Here we show (under the false assumption) that
         ` C ` is a function extending the domain of ` recs ( F ) ` by one.
         (Contributed by NM, 14-Aug-1994.)  (Revised by Mario Carneiro,
         9-May-2015.) $)
      tfrlem10 $p |- ( dom recs ( F ) e. On -> C Fn suc dom recs ( F ) ) $=
        ( cdm con0 wcel csn cun wfn wfun wceq wa cin c0 cvv crecs cfv csuc fvex
        cop funsng mpan2 tfrlem7 jctil dmsnop ineq2i word tfrlem8 orddisj ax-mp
        eqtri funun sylancl uneq2i df-suc 3eqtr4i jctir df-fn sylibr fneq1i
        dmun ) FUAZIZJKZVGVHVGFUBZUELZMZVHUCZNZDVMNVIVLOZVLIZVMPZQVNVIVOVQVIVGO
        ZVKOZQVHVKIZRZSPVOVIVSVRVIVJTKVSVGFUDZVHVJJTUFUGABCEFGUHUIWAVHVHLZRZSVT
        WCVHVHVJWBUJZUKVHULWDSPABCEFGUMVHUNUOUPVGVKUQURVHVTMVHWCMVPVMVTWCVHWEUS
        VGVKVFVHUTVAVBVLVMVCVDVMDVLHVEVD $.

      $( Lemma for transfinite recursion.  Compute the value of ` C ` .
         (Contributed by NM, 18-Aug-1994.)  (Revised by Mario Carneiro,
         9-May-2015.) $)
      tfrlem11 $p |- ( dom recs ( F ) e. On ->
         ( B e. suc dom recs ( F ) -> ( C ` B ) = ( F ` ( C |` B ) ) ) ) $=
        ( wcel wceq con0 cfv cres wi wa syl wss cop csn cdm csuc wo elsuci wfun
        crecs wfn tfrlem10 fnfun cun ssun1 tfrlem9 funssfv 3expa adantrl onelss
        sseqtr4i imp fun2ssres fveq2d sylan2 eqeq12d syl5ibr mpanl2 sylan exp32
        pm2.43i pm2.43d opex snid opeq1 adantl eqimss mp3an2 syl2an reseq2 wrel
        tfrlem6 resdm ax-mp syl6eq eqtrd opeq2d sneqd syl5eleq syl6eleqr adantr
        elun2 wb simpr sucidg eqeltrd fnopfvb syl2anc mpbird ex jaod syl5 ) DGU
        FZUAZUBZJZDWTJZDWTKZUCWTLJZDEMZEDNZGMZKZDWTUDXEXCXIXDXEXCXIXEXCXCXIOZOX
        EXEXCXJXEEUEZXEXCPZXJXEEXAUGZXKABCEFGHIUHZXAEUIQZXKWSERZXLXJWSWSWTWSGMZ
        SZTZUJZEWSXSUKIUQZXCXIXKXPPZXLPZDWSMZWSDNZGMZKABCDFGHULYCXFYDXHYFYBXCXF
        YDKZXEXKXPXCYGDEWSUMUNUOXLYBDWTRZXHYFKXEXCYHWTDUPURYBYHPXGYEGXKXPYHXGYE
        KZDEWSUSZUNUTVAVBVCVDVEVFVGVHXEXDXIXEXDPZXIDXHSZEJZYKYLXTEYKYLXSJYLXTJY
        KYLYLTXSYLDXHVIVJYKYLXRYKYLWTXHSZXRXDYLYNKXEDWTXHVKVLYKXHXQWTYKXGWSGYKX
        GYEWSXEXKYHYIXDXODWTVMXKXPYHYIYAYJVNVOXDYEWSKXEXDYEWSWTNZWSDWTWSVPWSVQY
        OWSKABCFGHVRWSVSVTWAVLWBUTWCWBWDWEYLXSWSWHQIWFYKXMXBXIYMWIXEXMXDXNWGYKD
        WTXAXEXDWJXEWTXAJXDWTLWKWGWLXADXHEWMWNWOWPWQWR $.

      $( Lemma for transfinite recursion.  Show ` C ` is an acceptable
         function.  (Contributed by NM, 15-Aug-1994.)  (Revised by Mario
         Carneiro, 9-May-2015.) $)
      tfrlem12 $p |- ( recs ( F ) e. _V -> C e. A ) $=
        ( vz cvv wcel cv wfn cfv cres wceq wral wa con0 wrex crecs word tfrlem8
        cdm dmexg elon2 sylanbrc csuc suceloni tfrlem10 tfrlem11 ralrimiv fveq2
        reseq2 fveq2d eqeq12d cbvralv sylib fneq2 raleq anbi12d rspcev syl12anc
        a1i syl wb cop csn snex unexg mpan2 syl5eqel fneq1 fveq1 reseq1 ralbidv
        cun rexbidv elab2g mpbird ) FUAZJKZDCKZDALZMZBLZDNZDWFOZFNZPZBWDQZRZAST
        ZWBWAUDZSKZWMWBWNUBZWNJKWOWPWBABCEFGUCVDWAJUEWNUFUGWOWNUHZSKDWQMZWJBWQQ
        ZWMWNUIABCDEFGHUJWOILZDNZDWTOZFNZPZIWQQWSWOXDIWQABCWTDEFGHUKULXDWJIBWQW
        TWFPZXAWGXCWIWTWFDUMXEXBWHFWTWFDUNUOUPUQURWLWRWSRAWQSWDWQPWEWRWKWSWDWQD
        USWJBWDWQUTVAVBVCVEWBDJKWCWMVFWBDWAWNWAFNVGZVHZVQZJHWBXGJKXHJKXFVIWAXGJ
        JVJVKVLELZWDMZWFXINZXIWFOZFNZPZBWDQZRZASTWMEDCJXIDPZXPWLASXQXJWEXOWKWDX
        IDVMXQXNWJBWDXQXKWGXMWIWFXIDVNXQXLWHFXIDWFVOUOUPVPVAVRGVSVEVT $.
    $}

    $( Lemma for transfinite recursion.  If ` recs ` is a set function, then
       ` C ` is acceptable, and thus a subset of ` recs ` , but ` dom C ` is
       bigger than ` dom recs ` .  This is a contradiction, so ` recs ` must be
       a proper class function.  (Contributed by NM, 14-Aug-1994.)  (Revised by
       Mario Carneiro, 14-Nov-2014.) $)
    tfrlem13 $p |- -. recs ( F ) e. _V $=
      ( crecs cvv wcel cdm word wn tfrlem8 ordirr ax-mp cfv cop wss 3syl con0
      csn cun eqid tfrlem12 cuni elssuni recsfval syl6sseqr dmss csuc a1i dmexg
      elon2 sylanbrc sucidg syl wfn wceq tfrlem10 fndm eleqtrrd sseldd mto ) EG
      ZHIZVDJZVFIZVFKZVGLABCDEFMZVFNOVEVDVFVDEPQUAUBZJZVFVFVEVJCIZVJVDRVKVFRABC
      VJDEFVJUCZUDVLVJCUEVDVJCUFABCDEFUGUHVJVDUISVEVFVFUJZVKVEVFTIZVFVNIVEVHVFH
      IVOVHVEVIUKVDHULVFUMUNZVFTUOUPVEVOVJVNUQVKVNURVPABCVJDEFVMUSVNVJUTSVAVBVC
      $.

    $( Lemma for transfinite recursion.  Assuming ~ ax-rep ,
       ` dom recs e. _V <-> recs e. _V ` , so since ` dom recs ` is an ordinal,
       it must be equal to ` On ` .  (Contributed by NM, 14-Aug-1994.)
       (Revised by Mario Carneiro, 9-May-2015.) $)
    tfrlem14 $p |- dom recs ( F ) = On $=
      ( crecs cdm con0 wcel wceq cvv tfrlem13 wfun tfrlem7 funex mpan mto word
      wo tfrlem8 ordeleqon mpbi mtp-or ) EGZHZIJZUFIKZUGUELJZABCDEFMUENUGUIABCD
      EFOIUEPQRUFSUGUHTABCDEFUAUFUBUCUD $.

    $( Lemma for transfinite recursion.  Without assuming ~ ax-rep , we can
       show that all proper initial subsets of ` recs ` are sets, while nothing
       larger is a set.  (Contributed by Mario Carneiro, 14-Nov-2014.) $)
    tfrlem15 $p |- ( B e. On ->
        ( B e. dom recs ( F ) <-> ( recs ( F ) |` B ) e. _V ) ) $=
      ( con0 wcel crecs cdm cres cvv tfrlem9a adantl wa wss wn tfrlem13 word wb
      simpr resss a1i wrel tfrlem6 resdm ax-mp ssres2 syl5eqssr eqssd syl5ibcom
      wceq eleq1d tfrlem8 eloni adantr ordtri1 con2bid sylancr mpbird impbida
      mtoi ) DHIZDFJZKZIZVEDLZMIZVGVIVDABCDEFGNOVDVIPZVGVFDQZRZVJVKVEMIZABCEFGS
      VJVIVKVMVDVIUBVKVHVEMVKVHVEVHVEQVKVEDUCUDVKVEVEVFLZVHVEUEVNVEUMABCEFGUFVE
      UGUHVFDVEUIUJUKUNULVCVJVFTZDTZVGVLUAABCEFGUOVDVPVIDUPUQVOVPPVKVGVFDURUSUT
      VAVB $.

    $( Lemma for finite recursion.  Without assuming ~ ax-rep , we can show
       that the domain of the constructed function is a limit ordinal, and
       hence contains all the finite ordinals.  (Contributed by Mario Carneiro,
       14-Nov-2014.) $)
    tfrlem16 $p |- Lim dom recs ( F ) $=
      ( vz crecs cdm c0 wceq cv con0 wcel cres cvv ax-mp pm2.21i csn cun ordzsl
      csuc wrex wlim w3o word tfrlem8 mpbi wn res0 eqeltri 0elon tfrlem15 mpbir
      0ex wb tfrlem13 wa simpr df-suc syl6eq reseq2d wrel tfrlem6 resdm resundi
      n0i 3eqtr3g vex syl5eleqr tfrlem9a syl cfv cop snex wfun tfrlem7 funressn
      sucid wss ssexi unexg sylancl eqeltrd rexlimiva mto id 3jaoi ) EHZIZJKZWJ
      GLZUBZKZGMUCZWJUDZUEZWPWJUFWQABCDEFUGGWJUAUHWKWPWOWPWKWPJWJNZWKUIWRWIJOZP
      NZWSJPWIUJUOUKJMNWRWTUPULABCJDEFUMQUNWJJVGQRWOWPWOWIPNZABCDEFUQWNXAGMWLMN
      ZWNURZWIWIWLOZWIWLSZOZTZPXCWIWJOZWIWLXETZOWIXGXCWJXIWIXCWJWMXIXBWNUSZWLUT
      VAVBWIVCXHWIKABCDEFVDWIVEQWIWLXEVFVHXCXDPNZXFPNXGPNXCWLWJNXKXCWLWMWJWLGVI
      VSXJVJABCWLDEFVKVLXFWLWLWIVMVNZSZXLVOWIVPXFXMVTABCDEFVQWLWIVRQWAXDXFPPWBW
      CWDWEWFRWPWGWHQ $.
  $}

  ${
    $d f x y A $.  $d x y B $.  $d x y F $.  $d f u v x y G $.
    tfr.1 $e |- F = recs ( G ) $.
    $( A weak version of ~ tfr1 which is useful for proofs that avoid the Axiom
       of Replacement.  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    tfr1a $p |- ( Fun F /\ Lim dom F ) $=
      ( vx vy vf wfun cdm wlim crecs cv wfn cfv cres wceq wral con0 wrex mpbir
      wa cab eqid tfrlem7 funeqi tfrlem16 wb dmeqi limeq ax-mp pm3.2i ) AGZAHZI
      ZUKBJZGDEFKZDKZLEKZUOMUOUQNBMOEUPPTDQRFUAZFBURUBZUCAUNCUDSUMUNHZIZDEURFBU
      SUEULUTOUMVAUFAUNCUGULUTUHUISUJ $.

    $( A weak version of ~ tfr2 which is useful for proofs that avoid the Axiom
       of Replacement.  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    tfr2a $p |- ( A e. dom F -> ( F ` A ) = ( G ` ( F |` A ) ) ) $=
      ( vx vy vf cdm wcel crecs cfv cres wceq cv wfn wral wa con0 wrex cab eqid
      tfrlem9 dmeqi eleq2s fveq1i reseq1i fveq2i 3eqtr4g ) ABHZIACJZKZUJALZCKZA
      BKBALZCKUKUMMAUJHUIEFGNZENZOFNZUOKUOUQLCKMFUPPQERSGTZAGCURUAUBBUJDUCUDABU
      JDUEUNULCBUJADUFUGUH $.

    $( Without assuming ~ ax-rep , we can show that all proper initial subsets
       of ` recs ` are sets, while nothing larger is a set.  (Contributed by
       Mario Carneiro, 24-Jun-2015.) $)
    tfr2b $p |- ( Ord A -> ( A e. dom F <-> ( F |` A ) e. _V ) ) $=
      ( vx vy vf word con0 wcel wceq wo cdm cres cvv wb cv cfv eleq1i mtbiri wa
      ordeleqon crecs wfn wral wrex cab eqid dmeqi eleq2i reseq1i 3bitr4g onprc
      tfrlem15 elex mto eleq1 tfrlem13 mtbir reseq2 wrel wfun wlim tfr1a simpli
      wss funrel ax-mp simpri limord ordsson mp2b relssres mp2an syl6eq 2falsed
      eleq1d jaoi sylbi ) AHAIJZAIKZLABMZJZBANZOJZPZAUBVTWFWAVTACUCZMZJWGANZOJW
      CWEEFGQZEQZUDFQZWJRWJWLNCRKFWKUEUAEIUFGUGZAGCWMUHZUNWBWHABWGDUIUJWDWIOBWG
      ADUKSULWAWCWEWAWCIWBJZWOIOJUMIWBUOUPAIWBUQTWAWEBOJZWPWGOJEFWMGCWNURBWGODS
      USWAWDBOWAWDBINZBAIBUTBVAZWBIVFZWQBKBVBZWRWTWBVCZBCDVDZVEBVGVHXAWBHWSWTXA
      XBVIWBVJWBVKVLBIVMVNVOVQTVPVRVS $.

    $( Principle of Transfinite Recursion, part 1 of 3.  Theorem 7.41(1) of
       [TakeutiZaring] p. 47.  We start with an arbitrary class ` G ` ,
       normally a function, and define a class ` A ` of all "acceptable"
       functions.  The final function we're interested in is the union
       ` F = recs ( G ) ` of them. ` F ` is then said to be defined by
       transfinite recursion.  The purpose of the 3 parts of this theorem is to
       demonstrate properties of ` F ` .  In this first part we show that ` F `
       is a function whose domain is all ordinal numbers.  (Contributed by NM,
       17-Aug-1994.)  (Revised by Mario Carneiro, 18-Jan-2015.) $)
    tfr1 $p |- F Fn On $=
      ( vx vy vf con0 wfn crecs wfun cdm wceq cv cfv cres wral wa wrex cab eqid
      tfrlem7 tfrlem14 df-fn mpbir2an fneq1i mpbir ) AGHBIZGHZUHUGJUGKGLDEFMZDM
      ZHEMZUINUIUKOBNLEUJPQDGRFSZFBULTZUADEULFBUMUBUGGUCUDGAUGCUEUF $.

    $( Principle of Transfinite Recursion, part 2 of 3.  Theorem 7.41(2) of
       [TakeutiZaring] p. 47.  Here we show that the function ` F ` has the
       property that for any function ` G ` whatsoever, the "next" value of
       ` F ` is ` G ` recursively applied to all "previous" values of ` F ` .
       (Contributed by NM, 9-Apr-1995.)  (Revised by Stefan O'Rear,
       18-Jan-2015.) $)
    tfr2 $p |- ( A e. On -> ( F ` A ) = ( G ` ( F |` A ) ) ) $=
      ( con0 wcel cdm cfv cres wceq wfn tfr1 fndm ax-mp eleq2i tfr2a sylbir ) A
      EFABGZFABHBAICHJREABEKREJBCDLEBMNOABCDPQ $.

    $( Principle of Transfinite Recursion, part 3 of 3.  Theorem 7.41(3) of
       [TakeutiZaring] p. 47.  Finally, we show that ` F ` is unique.  We do
       this by showing that any class ` B ` with the same properties of ` F `
       that we showed in parts 1 and 2 is identical to ` F ` .  (Contributed by
       NM, 18-Aug-1994.)  (Revised by Mario Carneiro, 9-May-2015.) $)
    tfr3 $p |- ( ( B Fn On /\
             A. x e. On ( B ` x ) = ( G ` ( B |` x ) ) ) -> B = F ) $=
      ( vy con0 wfn cv cfv cres wceq wral wa nfv nfra1 wi fveq2 wb imp nfan rsp
      wcel nfim eqeq12d imbi2d r19.21v wss fvreseq mpanl2 syl6bir sylan2 ancoms
      onss tfr1 adantr tfr2 jctr jcab sylibr eqeq12 adantl mpbird exp43 pm2.43d
      syl6 com4t exp4a syl com3l imp3a syl5bi tfis2f com12 ralrimi eqfnfv mpan2
      a2d biimpar syldan ) BGHZAIZBJZBWBKZDJZLZAGMZWCWBCJZLZAGMZBCLZWAWGNZWIAGW
      AWGAWAAOWFAGPUAZWBGUCZWLWIWLWIQZWLFIZBJZWPCJZLZQZAFWLWSAWMWSAOUDWBWPLZWIW
      SWLXAWCWQWHWRWBWPBRWBWPCRUEUFWTFWBMWLWSFWBMZQWNWOWLWSFWBUGWNWLXBWIWNWAWGX
      BWIQZWGWNWAXCWGWNWFQZWNWAXCQZQWFAGUBXDWNXEXDWNWNWAXCWNWANZXBXDWNWIXFXBXDW
      NWIXFXBNZXDWNNZNWIWECWBKZDJZLZXGXKXHXFXBXKWAWNXBXKQZWNWAWBGUHZXLWBUNWAXMN
      XBWDXILZXKWACGHZXMXNXBSCDEUOZFGWBBCUIUJWDXIDRUKULUMTUPXHWIXKSZXGXDWNXQXDW
      NWFWHXJLZNZXQXDXDWNXRQZNWNXSQXDXTWBCDEUQURWNWFXRUSUTWCWEWHXJVAVFTVBVCVDVG
      VHVEVIVJVKVRVLVMVNVOWAWKWJWAXOWKWJSXPAGBCVPVQVSVT $.

  $}

  $( Strong transfinite recursion defines a function on ordinals.  (Contributed
     by Stefan O'Rear, 18-Jan-2015.) $)
  recsfnon $p |- recs ( F ) Fn On $=
    ( crecs eqid tfr1 ) ABZAECD $.

  $( Strong transfinite recursion in terms of all previous values.
     (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
  recsval $p |- ( A e. On -> ( recs ( F ) ` A ) =
        ( F ` ( recs ( F ) |` A ) ) ) $=
    ( crecs eqid tfr2 ) ABCZBFDE $.

  ${
    $d x y $.  $d y A $.  $d y H $.
    tz7.44lem1.1 $e |- G = { <. x , y >. | ( ( x = (/) /\ y = A ) \/
            ( -. ( x = (/) \/ Lim dom x ) /\ y = ( H ` ( x ` U. dom x ) ) )
                \/ ( Lim dom x /\ y = U. ran x ) ) } $.
    $( ` G ` is a function.  Lemma for ~ tz7.44-1 , ~ tz7.44-2 , and
       ~ tz7.44-3 .  (Contributed by NM, 23-Apr-1995.)  (Revised by David
       Abernethy, 19-Jun-2012.) $)
    tz7.44lem1 $p |- Fun G $=
      ( wfun cv c0 wceq wa cdm wlim wo cuni cfv cvv wcel wb limeq crn w3o copab
      wn wmo funopab fvex vex rnexg uniexg mp2b nlim0 dm0 ax-mp dmeq syl biimpa
      mtbir mto moeq3 mpgbir funeqi mpbir ) DGAHZIJZBHZCJKVEVDLZMZNUDVFVGOVDPZE
      PZJKVHVFVDUAZOZJKUBZABUCZGZVOVMBUEAVMABUFVEVHBCVJVLVIEUGVDQRVKQRVLQRAUHVD
      QUIVKQUJUKVEVHKILZMZVQIMZULVPIJVQVRSUMVPITUNURVEVHVQVEVGVPJVHVQSVDIUOVGVP
      TUPUQUSUTVADVNFVBVC $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x y F $.  $d y G $.  $d x H $.  $d y X $.
    tz7.44.1 $e |- G = ( x e. _V |-> if ( x = (/) , A ,
                if ( Lim dom x , U. ran x , ( H ` ( x ` U. dom x ) ) ) ) ) $.
    tz7.44.2 $e |- ( y e. X -> ( F ` y ) = ( G ` ( F |` y ) ) ) $.
    ${
      tz7.44-1.3 $e |- A e. _V $.
      $( The value of ` F ` at ` (/) ` .  Part 1 of Theorem 7.44 of
         [TakeutiZaring] p. 49.  (Contributed by NM, 23-Apr-1995.)  (Revised by
         Mario Carneiro, 14-Nov-2014.) $)
      tz7.44-1 $p |- ( (/) e. X -> ( F ` (/) ) = A ) $=
        ( c0 wcel cfv cv cres wceq syl6eq cvv cuni cif fveq2 reseq2 res0 fveq2d
        eqeq12d vtoclga 0ex cdm wlim crn iftrue fvmpt ax-mp ) KGLKDMZKEMZCBNZDM
        ZDUPOZEMZPUNUOPBKGUPKPZUQUNUSUOUPKDUAUTURKEUTURDKOKUPKDUBDUCQUDUEIUFKRL
        UOCPUGAKANZKPZCVAUHZUIVAUJSVCSVAMFMTZTCREVBCVDUKHJULUMQ $.
    $}

    tz7.44.3 $e |- ( y e. X -> ( F |` y ) e. _V ) $.
    tz7.44.4 $e |- F Fn X $.
    tz7.44.5 $e |- Ord X $.
    $( The value of ` F ` at a successor ordinal.  Part 2 of Theorem 7.44 of
       [TakeutiZaring] p. 49.  (Unnecessary distinct variable restrictions were
       removed by David Abernethy, 19-Jun-2012.)  (Contributed by NM,
       23-Apr-1995.)  (Revised by Mario Carneiro, 14-Nov-2014.) $)
    tz7.44-2 $p |- ( suc B e. X -> ( F ` suc B ) = ( H ` ( F ` B ) ) ) $=
      ( wcel cfv c0 wceq cuni cvv syl csuc cres cdm crn cif fveq2 reseq2 fveq2d
      wlim cv eqeq12d vtoclga eleq1d noel dmeq dm0 syl6eq con0 word wss ordsson
      ax-mp wtr ordtr trsuc mpan sseldi sucidg cin dmres ordelss fndm syl6sseqr
      wn df-ss sylib syl5eq eleqtrrd eleq2 syl5ibcom syl5 mtoi iffalse nlimsucg
      wfn limeq mtbird unieqd eloni ordunisuc eqtrd fvres 3eqtrd syl6eqel eqeq1
      wb fvex rneq fveq1 ifbieq12d ifbieq2d fvmptg syl2anc ) DUAZHNZXDEOZEXDUBZ
      FOZXGPQZCXGUCZUIZXGUDZRZXJRZXGOZGOZUEZUEZDEOZGOZBUJZEOZEYAUBZFOZQXFXHQBXD
      HYAXDQZYBXFYDXHYAXDEUFYEYCXGFYAXDEUGZUHUKJULXEXGSNZXRSNXHXRQYCSNYGBXDHYEY
      CXGSYFUMKULXEXRXTSXEXRXQXPXTXEXIVNXRXQQXEXIDPNZDUNXIXJPQZXEYHXIXJPUCPXGPU
      OUPUQXEDXJNYIYHXEDXDXJXEDURNZDXDNZXEHURDHUSZHURUTMHVAVBHVCZXEDHNYLYMMHVDV
      BHDVEVFVGZDURVHTZXEXJXDEUCZVIZXDEXDVJXEXDYPUTYQXDQXEXDHYPYLXEXDHUTMHXDVKV
      FEHWEYPHQLHEVLVBVMXDYPVOVPVQZVRXJPDVSVTWAWBXICXQWCTXEXKVNXQXPQXEXKXDUIZXE
      YJYSVNYNDURWDTXEXJXDQXKYSWPYRXJXDWFTWGXKXMXPWCTXEXOXSGXEXODXGOZXSXEXNDXGX
      EXNXDRZDXEXJXDYRWHXEYJUUADQZYNYJDUSUUBDWIDWJTTWKUHXEYKYTXSQYODXDEWLTWKUHW
      MZXSGWQWNAXGAUJZPQZCUUDUCZUIZUUDUDZRZUUFRZUUDOZGOZUEZUEXRSSFUUDXGQZUUEXIU
      UMXQCUUDXGPWOUUNUUGXKUUIUULXMXPUUNUUFXJQUUGXKWPUUDXGUOZUUFXJWFTUUNUUHXLUU
      DXGWRWHUUNUUKXOGUUNUUKUUJXGOXOUUJUUDXGWSUUNUUJXNXGUUNUUFXJUUOWHUHWKUHWTXA
      IXBXCUUCWM $.

    $( The value of ` F ` at a limit ordinal.  Part 3 of Theorem 7.44 of
       [TakeutiZaring] p. 49.  (Contributed by NM, 23-Apr-1995.)  (Revised by
       David Abernethy, 19-Jun-2012.) $)
    tz7.44-3 $p |- ( ( B e. X /\ Lim B ) -> ( F ` B ) = U. ( F " B ) ) $=
      ( wcel cfv cuni wceq c0 cvv syl wlim wa cres crn cima fveq2 reseq2 fveq2d
      cv eqeq12d vtoclga adantr cdm cif eleq1d wn simpr nlim0 wb cin dmres word
      wss ordelss mpan wfn fndm ax-mp syl6sseqr df-ss syl5eq dmeq dm0 sylan9req
      sylib syl6eq limeq mtbiri ex mt2d iffalse mpbird iftrue eqtrd uniexg 3syl
      rnexg eqeltrd eqeq1 unieqd fveq1 ifbieq12d ifbieq2d fvmptg syl2anc df-ima
      rneq unieqi syl6eqr ) DHNZDUAZUBZDEOZEDUCZUDZPZEDUEZPXBXCXDFOZXFWTXCXHQZX
      ABUIZEOZEXJUCZFOZQXIBDHXJDQZXKXCXMXHXJDEUFXNXLXDFXJDEUGZUHUJJUKULXBXHXDRQ
      ZCXDUMZUAZXFXQPZXDOZGOZUNZUNZXFXBXDSNZYCSNXHYCQWTYDXAXLSNYDBDHXNXLXDSXOUO
      KUKULZXBYCXFSXBYCYBXFXBXPUPYCYBQXBXPXAWTXAUQZXBXPXAUPXBXPUBZXARUAZURYGDRQ
      XAYHUSXBXPDXQRXBXQDEUMZUTZDEDVAXBDYIVCYJDQXBDHYIWTDHVCZXAHVBWTYKMHDVDVEUL
      EHVFYIHQLHEVGVHVIDYIVJVOVKZXPXQRUMRXDRVLVMVPVNDRVQTVRVSVTXPCYBWATXBXRYBXF
      QXBXRXAYFXBXQDQXRXAUSYLXQDVQTWBXRXFYAWCTWDZXBYDXESNXFSNYEXDSWGXESWEWFWHAX
      DAUIZRQZCYNUMZUAZYNUDZPZYPPZYNOZGOZUNZUNYCSSFYNXDQZYOXPUUCYBCYNXDRWIUUDYQ
      XRYSUUBXFYAUUDYPXQQYQXRUSYNXDVLZYPXQVQTUUDYRXEYNXDWQWJUUDUUAXTGUUDUUAYTXD
      OXTYTYNXDWKUUDYTXSXDUUDYPXQUUEWJUHWDUHWLWMIWNWOYMWDWDXGXEEDWPWRWS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Recursive definition generator
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define a constant for the recursive definition generator. $)
  $c rec $.

  $( Extend class notation with the recursive definition generator, with
     characteristic function ` F ` and initial value ` I ` . $)
  crdg $a class rec ( F , I ) $.

  ${
    $d x y f g F $.  $d x y f g I $.
    $( Define a recursive definition generator on ` On ` (the class of ordinal
       numbers) with characteristic function ` F ` and initial value ` I ` .
       This combines functions ` F ` in ~ tfr1 and ` G ` in ~ tz7.44-1 into one
       definition.  This rather amazing operation allows us to define, with
       compact direct definitions, functions that are usually defined in
       textbooks only with indirect self-referencing recursive definitions.  A
       recursive definition requires advanced metalogic to justify - in
       particular, eliminating a recursive definition is very difficult and
       often not even shown in textbooks.  On the other hand, the elimination
       of a direct definition is a matter of simple mechanical substitution.
       The price paid is the daunting complexity of our ` rec ` operation.  But
       once we get past this hurdle, otherwise recursive definitions become
       relatively simple, as in for example ~ oav , from which we prove the
       recursive textbook definition as theorems ~ oa0 , ~ oasuc , and ~ oalim
       (with the help of theorems ~ rdg0 , ~rdgsuc , and ~ rdglim2a ).  We can
       also restrict the ` rec ` operation to define otherwise recursive
       functions on the natural numbers ` om ` ; see ~ fr0g and ~ frsuc .  Our
       ` rec ` operation apparently does not appear in published literature,
       although closely related is Definition 25.2 of [Quine] p. 177, which he
       uses to "turn...a recursion into a genuine or direct definition" (p.
       174).  Note that the ` if ` operations (see ~ df-if ) select cases based
       on whether the domain of ` g ` is zero, a successor, or a limit ordinal.

       An important use of this definition is in the recursive sequence
       generator ~ df-seq on the natural numbers (as a subset of the complex
       numbers), allowing us to define, with direct definitions, recursive
       infinite sequences such as the factorial function ~ df-fac and integer
       powers ~ df-exp .

       _Note:  We introduce ` rec ` with the philosophical goal of being able_
       _to eliminate all definitions with direct mechanical substitution and_
       _to verify easily the soundness of definitions.  Metamath itself has no_
       _built-in technical limitation that prevents multiple-part recursive_
       _definitions in the traditional textbook style_.  (Contributed by NM,
       9-Apr-1995.)  (Revised by Mario Carneiro, 9-May-2015.) $)
    df-rdg $a |- rec ( F , I ) = recs ( ( g e. _V |-> if ( g = (/) , I ,
                if ( Lim dom g , U. ran g , ( F ` ( g ` U. dom g ) ) ) ) ) ) $.
  $}

  ${
    $d x y z f g F $.  $d x y z f g G $.  $d x y z f g A $.  $d x y z f g B $.
    $( Equality theorem for the recursive definition generator.  (Contributed
       by NM, 9-Apr-1995.)  (Revised by Mario Carneiro, 9-May-2015.) $)
    rdgeq1 $p |- ( F = G -> rec ( F , A ) = rec ( G , A ) ) $=
      ( vg wceq cvv cv cdm wlim crn cuni cfv cif cmpt crecs fveq1 ifeq2d df-rdg
      c0 crdg mpteq2dv recseq syl 3eqtr4g ) BCEZDFDGZSEZAUFHZIZUFJKZUHKUFLZBLZM
      ZMZNZOZDFUGAUIUJUKCLZMZMZNZOZBATCATUEUOUTEUPVAEUEDFUNUSUEUGUMURAUEUIULUQU
      JUKBCPQQUAUOUTUBUCDBARDCARUD $.


    $( Equality theorem for the recursive definition generator.  (Contributed
       by NM, 9-Apr-1995.)  (Revised by Mario Carneiro, 9-May-2015.) $)
    rdgeq2 $p |- ( A = B -> rec ( F , A ) = rec ( F , B ) ) $=
      ( vg wceq cvv cv cdm wlim crn cuni cfv cif cmpt crecs crdg ifeq1 mpteq2dv
      c0 df-rdg recseq syl 3eqtr4g ) ABEZDFDGZSEZAUEHZIUEJKUGKUELCLMZMZNZOZDFUF
      BUHMZNZOZCAPCBPUDUJUMEUKUNEUDDFUIULUFABUHQRUJUMUAUBDCATDCBTUC $.
  $}

  $( Equality theorem for the recursive definition generator.  (Contributed by
     Scott Fenton, 28-Apr-2012.) $)
  rdgeq12 $p |- ( ( F = G /\ A = B ) -> rec ( F , A ) = rec ( G , B ) ) $=
    ( wceq crdg rdgeq2 rdgeq1 sylan9eqr ) ABECDECAFCBFDBFABCGBCDHI $.

  ${
    $d g F $.  $d g A $.  $d x g $.
    nfrdg.1 $e |- F/_ x F $.
    nfrdg.2 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for the recursive definition
       generator.  (Contributed by NM, 14-Sep-2003.)  (Revised by Mario
       Carneiro, 8-Sep-2013.) $)
    nfrdg $p |- F/_ x rec ( F , A ) $=
      ( vg crdg cvv cv c0 wceq cdm wlim crn cuni cfv cif nfcv nfv nfif df-rdg
      cmpt crecs nffv nfmpt nfrecs nfcxfr ) ACBGFHFIZJKZBUHLZMZUHNOZUJOUHPZCPZQ
      ZQZUBZUCFCBUAAUQAFHUPAHRUIABUOUIASEUKAULUNUKASAULRAUMCDAUMRUDTTUEUFUG $.
  $}

  ${
    $d x y f g $.  $d x y z g $.  $d f g G $.  $d x z G $.  $d y z w g G $.
    $( Lemma used with the recursive definition generator.  This is a trivial
       lemma that just changes bound variables for later use.  (Contributed by
       NM, 9-Apr-1995.) $)
    rdglem1 $p |- { f | E. x e. On ( f Fn x /\
                A. y e. x ( f ` y ) = ( G ` ( f |` y ) ) ) }
                = { g | E. z e. On ( g Fn z /\
                A. w e. z ( g ` w ) = ( G ` ( g |` w ) ) ) } $=
      ( cv wfn cfv cres wceq wral wa con0 wrex cab eqid tfrlem3 fveq2 eqeq12d
      reseq2 fveq2d cbvralv anbi2i rexbii abbii eqtri ) EHZAHZIBHZUIJUIUKKGJLBU
      JMNAOPEQZFHZCHZIZUKUMJZUMUKKZGJZLZBUNMZNZCOPZFQUODHZUMJZUMVCKZGJZLZDUNMZN
      ZCOPZFQABCULEFGULRSVBVJFVAVICOUTVHUOUSVGBDUNUKVCLZUPVDURVFUKVCUMTVKUQVEGU
      KVCUMUBUCUAUDUEUFUGUH $.
  $}

  ${
    $d x y z f g u v w F $.  $d x y z f g u v w A $.
    $( The recursive definition generator is a function.  (Contributed by Mario
       Carneiro, 16-Nov-2014.) $)
    rdgfun $p |- Fun rec ( F , A ) $=
      ( vg crdg wfun cdm wlim cvv cv c0 wceq crn cuni cfv cif cmpt df-rdg tfr1a
      simpli ) BADZETFGTCHCIZJKAUAFZGUALMUBMUANBNOOPCBAQRS $.

    $( The domain of the recursive definition generator is a limit ordinal.
       (Contributed by NM, 16-Nov-2014.) $)
    rdgdmlim $p |- Lim dom rec ( F , A ) $=
      ( vg crdg wfun cdm wlim cvv cv c0 wceq crn cuni cfv cif cmpt df-rdg tfr1a
      simpri ) BADZETFGTCHCIZJKAUAFZGUALMUBMUANBNOOPCBAQRS $.

    $( The recursive definition generator is a function on ordinal numbers.
       (Contributed by NM, 9-Apr-1995.)  (Revised by Mario Carneiro,
       9-May-2015.) $)
    rdgfnon $p |- rec ( F , A ) Fn On $=
      ( vg crdg cvv cv c0 wceq cdm wlim crn cuni cfv cif cmpt df-rdg tfr1 ) BAD
      CECFZGHARIZJRKLSLRMBMNNOCBAPQ $.
  $}

  ${
    $d x y f g v w F $.  $d x y f g v w A $.  $d f x y B $.
    $( Value of the recursive definition generator.  (Contributed by NM,
       9-Apr-1995.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    rdgvalg $p |- ( B e. dom rec ( F , A ) ->
      ( rec ( F , A ) ` B ) = ( ( g e. _V |->
  if ( g = (/) , A , if ( Lim dom g , U. ran g , ( F ` ( g ` U. dom g ) ) ) ) )
                   ` ( rec ( F , A ) |` B ) ) ) $=
      ( crdg cvv cv c0 wceq cdm wlim crn cuni cfv cif cmpt df-rdg tfr2a ) BDAEC
      FCGZHIASJZKSLMTMSNDNOOPCDAQR $.

    $( Value of the recursive definition generator.  (Contributed by NM,
       9-Apr-1995.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    rdgval $p |- ( B e. On -> ( rec ( F , A ) ` B ) = ( ( g e. _V |->
  if ( g = (/) , A , if ( Lim dom g , U. ran g , ( F ` ( g ` U. dom g ) ) ) ) )
                   ` ( rec ( F , A ) |` B ) ) ) $=
      ( crdg cvv cv c0 wceq cdm wlim crn cuni cfv cif cmpt df-rdg tfr2 ) BDAECF
      CGZHIASJZKSLMTMSNDNOOPCDAQR $.
  $}

  ${
    $d x y f g v w F $.  $d x y f g v w A $.  $d f x y B $.
    ${
      rdg.1 $e |- A e. _V $.
      $( The initial value of the recursive definition generator.  (Contributed
         by NM, 23-Apr-1995.)  (Revised by Mario Carneiro, 14-Nov-2014.) $)
      rdg0 $p |- ( rec ( F , A ) ` (/) ) = A $=
        ( vx vy crdg cdm wcel cfv wceq com wlim wss rdgdmlim limomss ax-mp cuni
        c0 cv cif peano1 sselii cvv crn cmpt eqid rdgvalg tz7.44-1 ) RBAFZGZHRU
        IIAJKUJRUJLKUJMABNUJOPUAUBDEAUIDUCDSZRJAUKGZLUKUDQULQUKIBITTUEZBUJUMUFA
        ESDBUGCUHP $.
    $}

    $( The initial segments of the recursive definition generator are sets.
       (Contributed by Mario Carneiro, 16-Nov-2014.) $)
    rdgseg $p |- ( B e. dom rec ( F , A ) ->
                 ( rec ( F , A ) |` B ) e. _V ) $=
      ( vg vx vy vw vv vf crdg cdm wcel cres cvv cv c0 wceq cuni cfv cif df-rdg
      wlim crn cmpt crecs reseq1i wfn wral con0 wrex cab rdglem1 tfrlem9a dmeqi
      wa eleq2s syl5eqel ) BCAJZKZLURBMDNDOZPQAUTKZUBUTUCRVARUTSCSTTUDZUEZBMZNU
      RVCBDCAUAZUFVDNLBVCKUSEFGOZFOZUGHOZVFSVFVHMVBSQHVGUHUOFUIUJGUKBIVBFHEFGIV
      BULUMURVCVEUNUPUQ $.

    $( The value of the recursive definition generator at a successor.
       (Contributed by NM, 16-Nov-2014.) $)
    rdgsucg $p |- ( B e. dom rec ( F , A ) ->
                 ( rec ( F , A ) ` suc B ) = ( F ` ( rec ( F , A ) ` B ) ) ) $=
      ( vx vy crdg cdm wcel csuc cfv wceq wlim wb rdgdmlim limsuc ax-mp cv cuni
      cvv cif c0 crn cmpt eqid rdgvalg rdgseg wfun wfn rdgfun funfn mpbi limord
      word tz7.44-2 sylbi ) BCAFZGZHZBIZUQHZUSUPJBUPJCJKUQLZURUTMACNZUQBOPDEABU
      PDSDQZUAKAVCGZLVCUBRVDRVCJCJTTUCZCUQVEUDAEQZDCUEAVFCUFUPUGUPUQUHACUIUPUJU
      KVAUQUMVBUQULPUNUO $.

    $( The value of the recursive definition generator at a successor.
       (Contributed by NM, 23-Apr-1995.)  (Revised by Mario Carneiro,
       14-Nov-2014.) $)
    rdgsuc $p |- ( B e. On ->
                 ( rec ( F , A ) ` suc B ) = ( F ` ( rec ( F , A ) ` B ) ) ) $=
      ( con0 wcel crdg cdm csuc cfv wceq wfn rdgfnon fndm eleq2i rdgsucg sylbir
      ax-mp ) BDEBCAFZGZEBHRIBRICIJSDBRDKSDJACLDRMQNABCOP $.

    $( The value of the recursive definition generator at a limit ordinal.
       (Contributed by NM, 16-Nov-2014.) $)
    rdglimg $p |- ( ( B e. dom rec ( F , A ) /\ Lim B ) ->
                   ( rec ( F , A ) ` B ) = U. ( rec ( F , A ) " B ) ) $=
      ( vx vy crdg cvv cv c0 wceq cdm wlim crn cuni cfv cif cmpt rdgvalg rdgseg
      eqid wfun wfn rdgfun funfn mpbi word rdgdmlim limord ax-mp tz7.44-3 ) DEA
      BCAFZDGDHZIJAULKZLULMNUMNULOCOPPQZCUKKZUNTAEHZDCRAUPCSUKUAUKUOUBACUCUKUDU
      EUOLUOUFACUGUOUHUIUJ $.

    $( The value of the recursive definition generator at a limit ordinal.
       (Contributed by NM, 23-Apr-1995.)  (Revised by Mario Carneiro,
       14-Nov-2014.) $)
    rdglim $p |- ( ( B e. C /\ Lim B ) ->
                   ( rec ( F , A ) ` B ) = U. ( rec ( F , A ) " B ) ) $=
      ( wcel wlim crdg cdm cfv cima cuni wceq wa con0 limelon wfn rdgfnon ax-mp
      fndm syl6eleqr rdglimg sylancom ) BCEZBFZBDAGZHZEBUEIUEBJKLUCUDMBNUFBCOUE
      NPUFNLADQNUESRTABDUAUB $.
  $}

  ${
    $d x A $.  $d x F $.
    $( The initial value of the recursive definition generator.  (Contributed
       by NM, 25-Apr-1995.) $)
    rdg0g $p |- ( A e. C -> ( rec ( F , A ) ` (/) ) = A ) $=
      ( vx c0 cv crdg cfv wceq rdgeq2 fveq1d id eqeq12d vex rdg0 vtoclg ) ECDFZ
      GZHZQIECAGZHZAIDABQAIZSUAQAUBERTQACJKUBLMQCDNOP $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y D $.  $d y F $.
    rdgsucmptf.1 $e |- F/_ x A $.
    rdgsucmptf.2 $e |- F/_ x B $.
    rdgsucmptf.3 $e |- F/_ x D $.
    rdgsucmptf.4 $e |- F = rec ( ( x e. _V |-> C ) , A ) $.
    rdgsucmptf.5 $e |- ( x = ( F ` B ) -> C = D ) $.
    $( The value of the recursive definition generator at a successor (special
       case where the characteristic function uses the map operation).
       (Contributed by NM, 22-Oct-2003.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    rdgsucmptf $p |- ( ( B e. On /\ D e. V ) -> ( F ` suc B ) = D ) $=
      ( con0 wcel csuc cfv cvv cmpt crdg fveq1i rdgsuc fveq2i 3eqtr4g wceq fvex
      nfmpt1 nfrdg nfcxfr nffv eqid fvmptf mpan sylan9eq ) CMNZEGNZCOZFPZCFPZAQ
      DRZPZEUNUPUSBSZPCVAPZUSPUQUTBCUSUAUPFVAKTURVBUSCFVAKTUBUCURQNUOUTEUDCFUEA
      URDEQUSGACFAFVAKABUSAQDUFHUGUHIUIJLUSUJUKULUM $.

    $( The value of the recursive definition generator at a successor (special
       case where the characteristic function is an ordered-pair class
       abstraction and where the mapping class ` D ` is a proper class).  This
       is a technical lemma that can be used together with ~ rdgsucmptf to help
       eliminate redundant sethood antecedents.  (Contributed by NM,
       22-Oct-2003.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    rdgsucmptnf $p |- ( -. D e. _V -> ( F ` suc B ) = (/) ) $=
      ( cvv wcel wn csuc cfv cmpt crdg c0 fveq1i cdm wceq rdgdmlim limsuc ax-mp
      wlim wb rdgsucg fveq2i syl6eqr nfmpt1 nfrdg nfcxfr nffv fvmptnf sylan9eqr
      eqid ex syl5bir ndmfv pm2.61d1 syl5eq ) ELMNZCOZFPVDALDQZBRZPZSVDFVFJTVCV
      DVFUAZMZVGSUBZVICVHMZVCVJVHUFVKVIUGBVEUCVHCUDUEVCVKVJVKVCVGCFPZVEPZSVKVGC
      VFPZVEPVMBCVEUHVLVNVECFVFJTUIUJAVLDELVEACFAFVFJABVEALDUKGULUMHUNIKVEUQUOU
      PURUSVDVFUTVAVB $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y C $.  $d y z D $.  $d x z E $.  $d z F $.
    rdgsucmpt2.1 $e |- F = rec ( ( x e. _V |-> C ) , A ) $.
    rdgsucmpt2.2 $e |- ( y = x -> E = C ) $.
    rdgsucmpt2.3 $e |- ( y = ( F ` B ) -> E = D ) $.
    $( This version of ~ rdgsucmpt avoids the not-free hypothesis of
       ~ rdgsucmptf by using two substitutions instead of one.  (Contributed by
       Mario Carneiro, 11-Sep-2015.) $)
    rdgsucmpt2 $p |- ( ( B e. On /\ D e. V ) -> ( F ` suc B ) = D ) $=
      ( nfcv cvv cmpt crdg wceq cbvmptv rdgeq1 ax-mp eqtr4i rdgsucmptf ) BCDGFH
      IBCMBDMBFMHANEOZCPZBNGOZCPZJUEUCQUFUDQBANGEKRCUEUCSTUALUB $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x y D $.  $d y F $.
    rdgsucmpt.1 $e |- F = rec ( ( x e. _V |-> C ) , A ) $.
    rdgsucmpt.2 $e |- ( x = ( F ` B ) -> C = D ) $.
    $( The value of the recursive definition generator at a successor (special
       case where the characteristic function uses the map operation).
       (Contributed by Mario Carneiro, 9-Sep-2013.) $)
    rdgsucmpt $p |- ( ( B e. On /\ D e. V ) -> ( F ` suc B ) = D ) $=
      ( nfcv rdgsucmptf ) ABCDEFGABJACJAEJHIK $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( The value of the recursive definition generator at a limit ordinal, in
       terms of the union of all smaller values.  (Contributed by NM,
       23-Apr-1995.) $)
    rdglim2 $p |- ( ( B e. C /\ Lim B ) -> ( rec ( F , A ) ` B ) =
                  U. { y | E. x e. B y = ( rec ( F , A ) ` x ) } ) $=
      ( wcel wlim wa crdg cfv cima cuni cv wceq cab wex con0 wb word rdglim cop
      wrex dfima3 df-rex wi limord ordelord ex vex elon syl6ibr syl wfn rdgfnon
      eqcom fnopfvb mpan syl5bb syl6 pm5.32d exbidv abbidv syl5eq unieqd adantl
      syl5rbb eqtrd ) DEGZDHZIDFCJZKVKDLZMZBNZANZVKKZOZADUCZBPZMZCDEFUAVJVMVTOV
      IVJVLVSVJVLVODGZVOVNUBVKGZIZAQZBPVSABVKDUDVJWDVRBVRWAVQIZAQVJWDVQADUEVJWE
      WCAVJWAVQWBVJWAVORGZVQWBSVJDTZWAWFUFDUGWGWAVOTZWFWGWAWHDVOUHUIVOAUJUKULUM
      VQVPVNOZWFWBVNVPUPVKRUNWFWIWBSCFUORVOVNVKUQURUSUTVAVBVGVCVDVEVFVH $.

    $( The value of the recursive definition generator at a limit ordinal, in
       terms of indexed union of all smaller values.  (Contributed by NM,
       28-Jun-1998.) $)
    rdglim2a $p |- ( ( B e. C /\ Lim B ) -> ( rec ( F , A ) ` B ) =
                  U_ x e. B ( rec ( F , A ) ` x ) ) $=
      ( vy wcel wlim wa crdg cfv cv wceq wrex cab cuni ciun rdglim2 fvex dfiun2
      syl6eqr ) CDGCHICEBJZKFLALZUBKZMACNFOPACUDQAFBCDERAFCUDUCUBSTUA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( We use the next 3 theorems for finite recursion.  Note that we take
     advantage of what we have done for transfinite recursion, which allows
     us to explicitly specify the function and moreover not require the
     existence of omega. $)

  ${
    $d f g u v x y A $.  $d f g u v x y F $.  $d u x B $.
    $( The function generated by finite recursive definition generation is a
       function on omega.  (Contributed by NM, 15-Oct-1996.)  (Revised by Mario
       Carneiro, 14-Nov-2014.) $)
    frfnom $p |- ( rec ( F , A ) |` om ) Fn om $=
      ( crdg com cres wfn wfun cdm wceq rdgfun funres ax-mp dmres wlim rdgdmlim
      cin wss limomss df-ss mpbi eqtri df-fn mpbir2an ) BACZDEZDFUEGZUEHZDIUDGU
      FABJDUDKLUGDUDHZPZDUDDMDUHQZUIDIUHNUJABOUHRLDUHSTUAUEDUBUC $.

    $( The initial value resulting from finite recursive definition
       generation.  (Contributed by NM, 15-Oct-1996.) $)
    fr0g $p |- ( A e. B -> ( ( rec ( F , A ) |` om ) ` (/) ) = A ) $=
      ( wcel c0 crdg com cres cfv wceq peano1 fvres ax-mp rdg0g syl5eq ) ABDECA
      FZGHIZEPIZAEGDQRJKEGPLMABCNO $.

    $( The successor value resulting from finite recursive definition
       generation.  (Contributed by NM, 15-Oct-1996.)  (Revised by Mario
       Carneiro, 16-Nov-2014.) $)
    frsuc $p |- ( B e. om -> ( ( rec ( F , A ) |` om ) ` suc B ) =
                ( F ` ( ( rec ( F , A ) |` om ) ` B ) ) ) $=
      ( com wcel csuc crdg cfv cres cdm wceq wss rdgdmlim limomss ax-mp rdgsucg
      wlim sseli syl fvres peano2b sylbi fveq2d 3eqtr4d ) BDEZBFZCAGZHZBUGHZCHZ
      UFUGDIZHZBUKHZCHUEBUGJZEUHUJKDUNBUNQDUNLACMUNNORABCPSUEUFDEULUHKBUAUFDUGT
      UBUEUMUICBDUGTUCUD $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y D $.  $d y F $.
    frsucmpt.1 $e |- F/_ x A $.
    frsucmpt.2 $e |- F/_ x B $.
    frsucmpt.3 $e |- F/_ x D $.
    frsucmpt.4 $e |- F = ( rec ( ( x e. _V |-> C ) , A ) |` om ) $.
    frsucmpt.5 $e |- ( x = ( F ` B ) -> C = D ) $.
    $( The successor value resulting from finite recursive definition
       generation (special case where the generation function is expressed in
       maps-to notation).  (Contributed by NM, 14-Sep-2003.)  (Revised by Scott
       Fenton, 2-Nov-2011.) $)
    frsucmpt $p |- ( ( B e. om /\ D e. V ) -> ( F ` suc B ) = D ) $=
      ( com wcel csuc cfv cvv cmpt crdg fveq1i cres frsuc fveq2i 3eqtr4g nfmpt1
      wceq fvex nfrdg nfcv nfres nfcxfr nffv eqid fvmptf mpan sylan9eq ) CMNZEG
      NZCOZFPZCFPZAQDRZPZEUQUSVBBSZMUAZPCVEPZVBPUTVCBCVBUBUSFVEKTVAVFVBCFVEKTUC
      UDVAQNURVCEUFCFUGAVADEQVBGACFAFVEKAVDMABVBAQDUEHUHAMUIUJUKIULJLVBUMUNUOUP
      $.

    $( The value of the finite recursive definition generator at a successor
       (special case where the characteristic function is a mapping abstraction
       and where the mapping class ` D ` is a proper class).  This is a
       technical lemma that can be used together with ~ frsucmpt to help
       eliminate redundant sethood antecedents.  (Contributed by Scott Fenton,
       19-Feb-2011.)  (Revised by Mario Carneiro, 11-Sep-2015.) $)
    frsucmptn $p |- ( -. D e. _V -> ( F ` suc B ) = (/) ) $=
      ( cvv wcel wn csuc cfv com c0 fveq1i wceq cmpt crdg cres cdm frfnom ax-mp
      wfn fndm eleq2i peano2b frsuc fveq2i syl6eqr nfmpt1 nfrdg nfcv nfres nffv
      nfcxfr eqid fvmptnf sylan9eqr ex syl5bir syl5bi ndmfv pm2.61d1 syl5eq ) E
      LMNZCOZFPVJALDUAZBUBZQUCZPZRVJFVMJSVIVJVMUDZMZVNRTZVPVJQMZVIVQVOQVJVMQUGV
      OQTBVKUEQVMUHUFUIVRCQMZVIVQCUJVIVSVQVSVIVNCFPZVKPZRVSVNCVMPZVKPWABCVKUKVT
      WBVKCFVMJSULUMAVTDELVKACFAFVMJAVLQABVKALDUNGUOAQUPUQUSHURIKVKUTVAVBVCVDVE
      VJVMVFVGVH $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y C $.  $d y z D $.  $d x z E $.  $d z F $.
    frsucmpt2.1 $e |- F = ( rec ( ( x e. _V |-> C ) , A ) |` om ) $.
    frsucmpt2.2 $e |- ( y = x -> E = C ) $.
    frsucmpt2.3 $e |- ( y = ( F ` B ) -> E = D ) $.
    $( The successor value resulting from finite recursive definition
       generation (special case where the generation function is expressed in
       maps-to notation), using double-substitution instead of a bound variable
       condition.  (Contributed by Mario Carneiro, 11-Sep-2015.) $)
    frsucmpt2 $p |- ( ( B e. om /\ D e. V ) -> ( F ` suc B ) = D ) $=
      ( nfcv cvv cmpt crdg com cres wceq cbvmptv rdgeq1 reseq1i eqtr4i frsucmpt
      ax-mp ) BCDGFHIBCMBDMBFMHANEOZCPZQRBNGOZCPZQRJUIUGQUHUFSUIUGSBANGEKTCUHUF
      UAUEUBUCLUD $.
  $}

  ${
    $d y z w A $.  $d x y z w F $.
    tz7.48.1 $e |- F Fn On $.
    ${
      $d x A $.
      $( A way of showing an ordinal function is one-to-one.  (Contributed by
         NM, 9-Feb-1997.) $)
      tz7.48lem $p |- ( ( A C_ On /\ A. x e. A A. y e. x
                    -. ( F ` x ) = ( F ` y ) ) -> Fun `' ( F |` A ) ) $=
        ( vw vz con0 cv cfv wceq wn wral wa weq wi wel wcel wal r2al cres simpl
        ccnv anim1i imim1i exp3a 2alimi sylbi sylibr elequ1 fveq2 eqeq2d notbid
        imbi12d cbvralv ralbii elequ2 eqeq1d ralbidv bitri 3bitri ralcom2 ancri
        wss wfun r19.26-2 syl wb fvres eqeqan12d ad2antrl ssel anim12d wo oridm
        pm3.48 eqcom notbii orbi1i bitr3i syl6ibr con2d word eloni syl2an syl9r
        ordtri3 biimprd syl6 imp32 exp32 a2d 2alimdv 3imtr4g syl5 imdistani wfn
        sylbid fnssres mpan cvv wf dffn2 wf1 dff13 df-f1 simprbi sylanb sylan )
        CHVDZAIZDJZBIZDJZKZLZBXKMACMZNXJXKDCUAZJZXMXRJZKZABOZPZBCMACMZNXRUCVEZX
        JXQYDXQABQZXNXLKZLZPZBAQZXPPZNZBCMACMZXJYDXQYKBCMZACMZYMXQXKCRZXMCRZNZY
        KPZBSASZYOXQYPYJNZXPPZBSASYTXPABCXKTUUBYSABUUBYRYJXPYRYJNUUAXPYRYPYJYPY
        QUBUDUEUFUGUHYKABCCTUIYOYIBCMACMZYONYMYOUUCYOYIACMZBCMZUUCYOFAQZXLFIZDJ
        ZKZLZPZFCMZACMFGQZGIZDJZUUHKZLZPZFCMZGCMZUUEYNUULACYKUUKBFCBFOZYJUUFXPU
        UJBFAUJUVAXOUUIUVAXNUUHXLXMUUGDUKULUMUNUOUPUULUUSAGCAGOZUUKUURFCUVBUUFU
        UMUUJUUQAGFUQUVBUUIUUPUVBXLUUOUUHXKUUNDUKURUMUNUSUOUUTAGQZUUOXLKZLZPZAC
        MZGCMUUEUUSUVGGCUURUVFFACFAOZUUMUVCUUQUVEFAGUJUVHUUPUVDUVHUUHXLUUOUUGXK
        DUKULUMUNUOUPUVGUUDGBCGBOZUVFYIACUVIUVCYFUVEYHGBAUQUVIUVDYGUVIUUOXNXLUU
        NXMDUKURUMUNUSUOUTVAYIBACVBUHVCYIYKABCCVFUIVGXJYRYLPZBSASYRYCPZBSASYMYD
        XJUVJUVKABXJYRYLYCXJYRYLYCXJYRYLNNYAXOYBYRYAXOVHXJYLYPYQXSXLXTXNXKCDVIX
        MCDVIVJVKXJYRYLXOYBPZXJYRXKHRZXMHRZNZYLUVLPXJYPUVMYQUVNCHXKVLCHXMVLVMYL
        XOYFYJVNZLZUVOYBYLUVPXOYLUVPYHXPVNZXPYFYHYJXPVPXPXPXPVNUVRXPVOXPYHXPXOY
        GXLXNVQVRVSVTWAWBUVMXKWCZXMWCZUVQYBPUVNXKWDXMWDUVSUVTNYBUVQXKXMWGWHWEWF
        WIWJWRWKWLWMYLABCCTYCABCCTWNWOWPXJXRCWQZYDYEDHWQXJUWAEHCDWSWTUWACXAXRXB
        ZYDYECXRXCUWBYDNZUWBYEUWCCXAXRXDUWBYENABCXAXRXECXAXRXFVTXGXHXIVG $.
    $}

    $( Proposition 7.48(2) of [TakeutiZaring] p. 51.  (Contributed by NM,
       9-Feb-1997.)  (Revised by David Abernethy, 5-May-2013.) $)
    tz7.48-2 $p |- ( A. x e. On ( F ` x ) e. ( A \ ( F " x ) ) -> Fun `' F ) $=
      ( vy cv cfv cima cdif wcel con0 wral cres ccnv wfun wss wceq wa wi ax-mp
      wn ssid wel onelon ancoms cdm wfn fndm eleq2i funfvima mpan impcom eleq1a
      fnfun eldifn nsyli syl sylan2br expimpd com12 ralrimiv ralimiaa tz7.48lem
      syldan sylancr wrel fnrel eqimssi relssres mp2an cnveqi funeqi sylib ) AF
      ZCGZBCVNHZIJZAKLZCKMZNZOZCNZOVRKKPVOEFZCGZQZUAZEVNLZAKLWAKUBVQWGAKVNKJZVQ
      RZWFEVNEAUCZWIWFWJWHVQWFWJWHWCKJZVQWFSZWHWJWKVNWCUDUEWKWJWCCUFZJZWLWMKWCC
      KUGZWMKQDKCUHTZUIWJWNRWDVPJZWLWNWJWQCOZWNWJWQSWOWRDKCUNTVNWCCUJUKULWQWEVO
      VPJVQWDVPVOUMVOBVPUOUPUQURVDUSUTVAVBAEKCDVCVEVTWBVSCCVFZWMKPVSCQWOWSDKCVG
      TWMKWPVHCKVIVJVKVLVM $.

    $d x A $.
    $( Proposition 7.48(1) of [TakeutiZaring] p. 51.  (Contributed by NM,
       9-Feb-1997.) $)
    tz7.48-1 $p |- ( A. x e. On ( F ` x ) e. ( A \ ( F " x ) ) ->
                   ran F C_ A ) $=
      ( vy cv cfv cima cdif wcel con0 wral crn wceq wa wex cop vex elrn2 wi cdm
      opeldm wfn fndm ax-mp syl6eleq ancri wb fnopfvb mpan pm5.32i sylibr eximi
      sylbi nfra1 nfv rsp eldifi eleq1 syl5ibcom imim2i imp3a exlimd syl5 ssrdv
      syl ) AFZCGZBCVGHZIJZAKLZECMZBEFZVLJZVGKJZVHVMNZOZAPZVKVMBJZVNVGVMQCJZAPV
      RAVMCERZSVTVQAVTVOVTOVQVTVOVTVGCUAZKVGVMCARWAUBCKUCZWBKNDKCUDUEUFUGVOVPVT
      WCVOVPVTUHDKVGVMCUIUJUKULUMUNVKVQVSAVJAKUOVSAUPVKVOVJTZVQVSTVJAKUQWDVOVPV
      SVJVPVSTVOVJVHBJVPVSVHBVIURVHVMBUSUTVAVBVFVCVDVE $.

    $( Proposition 7.48(3) of [TakeutiZaring] p. 51.  (Contributed by NM,
       9-Feb-1997.) $)
    tz7.48-3 $p |- ( A. x e. On ( F ` x ) e. ( A \ ( F " x ) ) ->
                    -. A e. _V ) $=
      ( cv cfv cima cdif wcel con0 wral cvv crn cdm onprc wfn wceq eleq1i syl
      wi fndm ax-mp mtbir ccnv wfun tz7.48-2 funrnex com12 df-rn dfdm4 mtoi wss
      3imtr4g tz7.48-1 ssexg ex mtod ) AEZCFBCURGHIAJKZBLIZCMZLIZUSVBCNZLIZVDJL
      IOVCJLCJPVCJQDJCUAUBRUCUSCUDZUEZVBVDTABCDUFVFVENZLIZVEMZLIZVBVDVHVFVJLVEU
      GUHVAVGLCUIRVCVILCUJRUMSUKUSVABULZUTVBTABCDUNVKUTVBVABLUOUPSUQ $.
  $}

  ${
    tz7.49.1 $e |- F Fn On $.
    $d x y z A $.  $d x y z F $.  $d ph y z $.
    tz7.49.2 $e |- ( ph <-> A. x e. On ( ( A \ ( F " x ) ) =/= (/) ->
                               ( F ` x ) e. ( A \ ( F " x ) ) ) ) $.
    $( Proposition 7.49 of [TakeutiZaring] p. 51.  (Contributed by NM,
       10-Feb-1997.)  (Revised by Mario Carneiro, 10-Jan-2013.) $)
    tz7.49 $p |- ( ( A e. B /\ ph ) ->
                     E. x e. On ( A. y e. x ( A \ ( F " y ) ) =/= (/) /\
                     ( F " x ) = A /\ Fun `' ( F |` x ) ) ) $=
      ( vz wcel c0 wral wceq con0 wrex wa wn wi wss nfv cima cdif wne cres ccnv
      cv wfun w3a cfv df-ne ralbii ralim sylbi syl5bir cvv tz7.48-3 nsyl3 nsyli
      elex dfrex2 syl6ibr imaeq2 difeq2d eqeq1d onminex syl6 anbi2i nfra1 nfxfr
      rexbii simpllr wfn fnfun ax-mp fvelima mpan nfan rsp adantld onelon fveq2
      neeq1d eleq12d imbi12d rspcv syl5bi com23 syl sylcom com3r imp exp3acom23
      eldifi eleq1 syl5ibcom syl8 com34 rexlimd syl5 ssrdv biimpri anim12i eqss
      ssdif0 sylibr onss ssel fndm syl6sseqr funfvima2 sylancr com12 ee23 imp4a
      cdm eldifn eleq1a con3d syl5com syldd com4r imp31 ralrimi ancld tz7.48lem
      a1i ex syl56 ancoms adantr 3jca exp41 reximdai syld impcom ) ADEJZDFCUFZU
      AZUBZKUCZCBUFZLZFUUAUAZDMZFUUAUDUEUGZUHZBNOZAYPDUUCUBZKMZUUBPZBNOZUUGAYPU
      UIYSKMZQZCUUALZPZBNOZUUKAYPUUIBNOZUUPAYPUUIQZBNLZQUUQAUUSUUAFUIZUUHJZBNLZ
      YPUUSUUHKUCZBNLZAUVBUVCUURBNUUHKUJUKAUVCUVARZBNLZUVDUVBRHUVCUVABNULUMUNUV
      BDUOJYPBDFGUPDEUSUQURUUIBNUTVAUUIUULBCUUAYQMZUUHYSKUVGUUCYRDUUAYQFVBVCZVD
      VEVFUUJUUOBNUUBUUNUUIYTUUMCUUAYSKUJUKVGVJVAAUUJUUFBNAUVFBHUVEBNVHVIAUUANJ
      ZUUIUUBUUFAUVIUUBUUIUUFAUUBUVIUUIUUFRAUUBUVIUUIUUFAUUBPZUVIPZUUIPZUUBUUDU
      UEAUUBUVIUUIVKUVLUUCDSZDUUCSZPUUDUVKUVMUUIUVNUVKIUUCDUVJUVIIUFZUUCJZUVODJ
      ZRUVJUVPUVIUVQUVPYQFUIZUVOMZCUUAOZUVJUVIUVQRZFUGZUVPUVTFNVLZUWBGNFVMVNZCU
      VOUUAFVOVPUVJUVSUWACUUAAUUBCACTZYTCUUAVHZVQUWACTUVJYQUUAJZUVIUVSUVQUVJUWG
      UVIUVRYSJZUVSUVQRUVJUVIUWGUWHAUUBUVIUWGPZUWHRUUBUWIAUWHUUBUWIYTAUWHRZUUBU
      WGYTUVIYTCUUAVRZVSUWIYQNJZYTUWJRUUAYQVTUWLAYTUWHAUVFUWLYTUWHRZHUVEUWMBYQN
      UVGUVCYTUVAUWHUVGUUHYSKUVHWBUVGUUTUVRUUHYSUUAYQFWAUVHWCWDWEWFWGZWHWIWJWKW
      LUWHUVRDJUVSUVQUVRDYRWMUVRUVODWNWOWPWQWRWSWGWKWTUVNUUIDUUCXDXAXBUUCDXCXEU
      VKUUEUUIUVJUVIUUEUUBAUVIUUERUVIUUANSZUUBAPZUWOUVRUVOFUIZMZQZIYQLZCUUALZPU
      UEUUAXFUWPUWOUXAUWPUWOUXAUWPUWOPZUWTCUUAUWPUWOCUUBACUWFUWEVQUWOCTVQUXBUWG
      UWTUXBUWGPZUWSIYQUXCITUWPUWOUWGUVOYQJZUWSRUWOUWGUXDUWPUWSUWOUWGUXDUWQYRJZ
      UWPUWSRUWOUWGUWLUXDUXERZUUANYQXGZUWLUWBYQFXOZSUXFUWDUWLYQNUXHYQXFUWCUXHNM
      GNFXHVNXIYQUVOFXJXKVFUWOUWGUWPUXEUWSUWOUWGUWPUWHUXEUWSRUWOUWGUUBAUWHUWOUW
      GUWLUUBYTUWJUXGUWGUUBYTRRUWOUUBUWGYTUWKXLYFUWNXMXNUWHUVRYRJZQUXEUWSUVRDYR
      XPUXEUWRUXIUWQYRUVRXQXRXSWPWQXTYAYBYCYGYCYGYDCIUUAFGYEYHYIWKYJYKYLWGWQXNY
      MYNYO $.
  $}

  ${
    $d A x y $.  $d F x y $.
    tz7.49c.1 $e |- F Fn On $.
    $( Corollary of Proposition 7.49 of [TakeutiZaring] p. 51.  (Contributed by
       NM, 10-Feb-1997.)  (Revised by Mario Carneiro, 19-Jan-2013.) $)
    tz7.49c $p |- ( ( A e. B /\ A. x e. On ( ( A \ ( F " x ) ) =/= (/) ->
                 ( F ` x ) e. ( A \ ( F " x ) ) ) ) ->
                 E. x e. On ( F |` x ) : x -1-1-onto-> A ) $=
      ( vy wcel cv cima cdif c0 wne cfv con0 wral wa wceq w3a wrex wfn cres crn
      wi ccnv wfun wf1o biid tz7.49 3simpc fnssres sylancr df-ima eqeq1i biimpi
      wss onss anim12i anim1i dff1o2 3anan32 bitri sylibr expl syl5 reximia syl
      ) BCGBDAHZIZJZKLVGDMVIGUCANOZPBDFHIJKLFVGOZVHBQZDVGUAZUDUEZRZANSVGBVMUFZA
      NSVJAFBCDEVJUGUHVOVPANVOVLVNPVGNGZVPVKVLVNUIVQVLVNVPVQVLPZVNPVMVGTZVMUBZB
      QZPZVNPZVPVRWBVNVQVSVLWAVQDNTVGNUOVSEVGUPNVGDUJUKVLWAVHVTBDVGULUMUNUQURVP
      VSVNWARWCVGBVMUSVSVNWAUTVAVBVCVDVEVF $.
  $}

  $c seqom $.

  ${
    $( Extend class notation to include index-aware recursive definitions. $)
    cseqom $a class seqom ( F , I ) $.

    $d F i v $.  $d I i v $.

    $( Index-aware recursive definitions over ` om ` .  A mashup of ~ df-rdg
       and ~ df-seq , this allows for recursive definitions that use an index
       in the recursion in cases where Infinity is not admitted.  (Contributed
       by Stefan O'Rear, 1-Nov-2014.) $)
    df-seqom $a |- seqom ( F , I ) = ( rec ( ( i e. om , v e. _V |->
        <. suc i , ( i F v ) >. ) , <. (/) , ( _I ` I ) >. ) " om ) $.
  $}

  ${
    $d F a b c d $.  $d I a b c d $.

    $( Lemma for ` seqom ` .  Change bound variables.  (Contributed by Stefan
       O'Rear, 1-Nov-2014.) $)
    seqomlem0 $p |- rec ( ( a e. om , b e. _V |-> <. suc a , ( a F b ) >. ) ,
      <. (/) , ( _I ` I ) >. ) = rec ( ( c e. om , d e. _V |->
      <. suc c , ( c F d ) >. ) , <. (/) , ( _I ` I ) >. ) $=
      ( com cvv cv csuc co cop cmpt2 wceq c0 cid cfv crdg weq suceq oveq1 oveq2
      opeq12d opeq2d cbvmpt2v rdgeq1 ax-mp ) CDGHCIZJZUHDIZAKZLZMZEFGHEIZJZUNFI
      ZAKZLZMZNUMOBPQLZRUSUTRNCDEFGHULURUOUNUJAKZLCESUIUOUKVAUHUNTUHUNUJAUAUCDF
      SVAUQUOUJUPUNAUBUDUEUTUMUSUFUG $.
  $}

  ${
    $d Q a b c i v $.  $d A a b i v $.  $d F a b i v $.  $d I a b $.
    seqomlem.a $e |- Q = rec ( ( i e. om , v e. _V |->
        <. suc i , ( i F v ) >. ) , <. (/) , ( _I ` I ) >. ) $.
    $( Lemma for ` seqom ` .  The underlying recursion generates a sequence of
       pairs with the expected first values.  (Contributed by Stefan O'Rear,
       1-Nov-2014.)  (Revised by Mario Carneiro, 23-Jun-2015.) $)
    seqomlem1 $p |- ( A e. om -> ( Q ` A ) =
      <. A , ( 2nd ` ( Q ` A ) ) >. ) $=
      ( cv cfv c2nd cop wceq c0 fveq2 id fveq2d opeq12d eqeq12d com opeq2d csuc
      va vb cid cvv co cmpt2 crdg fveq1i opex rdg0 eqtri 0ex fvex eqcomi opeq2i
      op2nd 3eqtr4a ax-mp wcel df-ov suceq oveq1 oveq2 eqid ovmpt2 mpan2 eqeq1d
      syl5eqr syl5ibrcom vex sucex ovex a1i syld frsuc peano2 fvres syl syl6eqr
      cres 3eqtr3d sylibrd finds ) UBHZCIZWEWFJIZKZLMCIZMWIJIZKZLZUCHZCIZWMWNJI
      ZKZLZWMUAZCIZWRWSJIZKZLZBCIZBXCJIZKZLUBUCBWEMLZWFWIWHWKWEMCNZXFWEMWGWJXFO
      XFWFWIJXGPQRWEWMLZWFWNWHWPWEWMCNZXHWEWMWGWOXHOXHWFWNJXIPQRWEWRLZWFWSWHXAW
      EWRCNZXJWEWRWGWTXJOXJWFWSJXKPQRWEBLZWFXCWHXEWEBCNZXLWEBWGXDXLOXLWFXCJXMPQ
      RWIMFUDIZKZLZWLWIMDASUEDHZUAZXQAHZEUFZKZUGZXOUHZIXOMCYCGUIXOYBMXNUJUKULXP
      XOMXOJIZKWIWKXNYDMYDXNMXNUMFUDUNUQUOUPXPOXPWJYDMWIXOJNTURUSWMSUTZWQWNYBIZ
      WRYFJIZKZLZXBYEWQYFWRWMWOEUFZKZLZYIYEYLWQWPYBIZYKLYEYMWMWOYBUFZYKWMWOYBVA
      YEWOUEUTYNYKLWNJUNDAWMWOSUEYAYKYBWRWMXSEUFZKXQWMLXRWRXTYOXQWMVBXQWMXSEVCQ
      XSWOLYOYJWRXSWOWMEVDTYBVEWRYJUJVFVGVIWQYFYMYKWNWPYBNVHVJYEYIYLYKWRYKJIZKZ
      LYEYJYPWRYJYPLYEYPYJWRYJWMUCVKVLWMWOEVMUQUOVNTYLYFYKYHYQYLOYLYGYPWRYFYKJN
      TRVJVOYEWSYFXAYHYEWRYCSWAZIZWMYRIZYBIWSYFXOWMYBVPYEYSWRYCIZWSYEWRSUTYSUUA
      LWMVQWRSYCVRVSWRCYCGUIVTYEYTWNYBYEYTWMYCIWNWMSYCVRWMCYCGUIVTPWBZYEWTYGWRY
      EWSYFJUUBPTRWCWD $.

    $( Lemma for ` seqom ` .  (Contributed by Stefan O'Rear, 1-Nov-2014.)
       (Revised by Mario Carneiro, 23-Jun-2015.) $)
    seqomlem2 $p |- ( Q " om ) Fn om $=
      ( va vb vc com wfn cvv wf cv cfv wcel cop c2nd wceq eqeq1d cima cres wral
      crn cxp wss wbr weu csuc co cmpt2 c0 cid crdg frfnom reseq1i fneq1i mpbir
      fvres seqomlem1 eqtrd fvex opelxpi mpan2 eqeltrd ffnfv mpbir2an frn ax-mp
      rgen wb wal wex wrex df-br fvelrnb rexbiia 3bitri adantl vex opth1 syl6bi
      fveq2 biimpd syli op2nd syl6req syl6 rexlimdva rspcev mpdan opeq2 rexbidv
      wa eqeq2d syl5ibrcom impbid syl5bb alrimiv eqeq2 bibi2d albidv syl sylibr
      spcev df-eu dff3 df-ima feq1i dffn2 ) BJUAZJKJLXKMZXLJLBJUBZUDZMZXOXNJLUE
      ZUFZGNZHNZXNUGZHUHZGJUCJXPXMMZXQYBXMJKZXSXMOZXPPZHJUCYCCAJLCNZUIYFANDUJQU
      KZULEUMOQZUNZJUBZJKYHYGUOJXMYJBYIJFUPUQURZYEHJXSJPZYDXSXSBOZROZQZXPYLYDYM
      YOXSJBUSAXSBCDEFUTVAYLYNLPYOXPPYMRVBXSYNJLVCVDVEVJHJXPXMVFVGJXPXMVHVIYAGJ
      XRJPZXTXSINZSZVKZHVLZIVMZYAYPXTXSXRBOZROZSZVKZHVLZUUAYPUUEHXTYQBOZXRXSQZS
      ZIJVNZYPUUDXTUUHXNPZYQXMOZUUHSZIJVNZUUJXRXSXNVOYCUUKUUNVKYKIJUUHXMVPVIUUM
      UUIIJYQJPZUULUUGUUHYQJBUSTVQVRYPUUJUUDYPUUIUUDIJYPUUOWNZUUIUUBUUHSZUUDUUI
      UUPYQXRSZUUQUUPUUIYQUUGROZQZUUHSUURUUPUUGUUTUUHUUOUUGUUTSYPAYQBCDEFUTVSTY
      QUUSXRXSIVTUUGRVBWAWBUURUUIUUQUURUUGUUBUUHYQXRBWCZTWDWEUUQUUCUUHROXSUUBUU
      HRWCXRXSGVTHVTWFWGWHWIYPUUJUUDUUGXRUUCQZSZIJVNZYPUUBUVBSZUVDAXRBCDEFUTUVC
      UVEIXRJUURUUGUUBUVBUVATWJWKUUDUUIUVCIJUUDUUHUVBUUGXSUUCXRWLWOWMWPWQWRWSYT
      UUFIUUCUUBRVBYQUUCSZYSUUEHUVFYRUUDXTYQUUCXSWTXAXBXEXCXTHIXFXDVJGHJLXNXGVG
      JLXKXNBJXHXIURJXKXJUR $.

    $( Lemma for ` seqom ` .  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    seqomlem3 $p |- ( ( Q " om ) ` (/) ) = ( _I ` I ) $=
      ( c0 com cima cfv cid wceq cop wcel cres cv peano1 wfn mpbir mp2an wbr co
      crn cvv csuc cmpt2 crdg fvres ax-mp fveq1i opex rdg0 3eqtri frfnom fneq1i
      reseq1i fnfvelrn eqeltrri df-ima eleqtrri df-br wb seqomlem2 fnbrfvb ) GB
      HIZJEKJZLZGVFVEUAZVHGVFMZVENVIBHOZUCZVEGVJJZVIVKVLGBJZGCAHUDCPZUEVNAPDUBM
      UFZVIUGZJVIGHNZVLVMLQGHBUHUIGBVPFUJVIVOGVFUKULUMVJHRZVQVLVKNVRVPHOZHRVIVO
      UNHVJVSBVPHFUPUOSQHGVJUQTURBHUSUTGVFVEVASVEHRVQVGVHVBABCDEFVCQHGVFVEVDTS
      $.

    $( Lemma for ` seqom ` .  (Contributed by Stefan O'Rear, 1-Nov-2014.)
       (Revised by Mario Carneiro, 23-Jun-2015.) $)
    seqomlem4 $p |- ( A e. om -> ( ( Q " om ) ` suc A ) =
      ( A F ( ( Q " om ) ` A ) ) ) $=
      ( com wcel csuc cfv co wceq wbr cop cres fvres cvv eqtrd wfn cima crn syl
      peano2 cv cmpt2 c2nd c0 cid frsuc fveq1i syl6eqr fveq2d 3eqtr3d seqomlem1
      crdg df-ov fvex suceq oveq1 opeq12d oveq2 opeq2d eqid ovmpt2 mpan2 frfnom
      opex reseq1i fneq1i mpbir fnfvelrn eqeltrrd df-ima syl6eleqr df-br sylibr
      mpan wb seqomlem2 fnbrfvb mpbird eqcomd oveq2d syl5eqr 3eqtrd sylancr ) B
      HIZBJZCHUAZKBBWJKZELZMZWIWLWJNZWHWIWLOZWJIWNWHWOCHPZUBZWJWHWIWPKZWOWQWHWR
      WICKZWOWHWIHIZWRWSMBUDZWIHCQUCWHWSBCKZDAHRDUEZJZXCAUEZELZOZUFZKZBXBUGKZOZ
      XHKZWOWHWIXHUHFUIKOZUPZHPZKZBXOKZXHKWSXIXMBXHUJWHXPWIXNKZWSWHWTXPXRMXAWIH
      XNQUCWICXNGUKULWHXQXBXHWHXQBXNKXBBHXNQBCXNGUKULUMUNWHXBXKXHABCDEFGUOZUMWH
      XLBXJXHLZWOBXJXHUQWHXTWIBXJELZOZWOWHXJRIXTYBMXBUGURDABXJHRXGYBXHWIBXEELZO
      XCBMXDWIXFYCXCBUSXCBXEEUTVAXEXJMYCYAWIXEXJBEVBVCXHVDWIYAVHVEVFWHYAWLWIWHX
      JWKBEWHWKXJWHWKXJMZBXJWJNZWHXKWJIYEWHXKWQWJWHBWPKZXKWQWHYFXBXKBHCQXSSWPHT
      ZWHYFWQIYGXOHTXMXHVGHWPXOCXNHGVIVJVKZHBWPVLVRVMCHVNZVOBXJWJVPVQWJHTZWHYDY
      EVSACDEFGVTZHBXJWJWAVRWBWCWDVCSWEWFSWHYGWTWRWQIYHXAHWIWPVLWGVMYIVOWIWLWJV
      PVQWHYJWTWMWNVSYKXAHWIWLWJWAWGWB $.
  $}

  ${
    $d A a b $.  $d B a b $.  $d C a b $.  $d D a b $.
    $( Equality theorem for ` seqom ` .  (Contributed by Stefan O'Rear,
       1-Nov-2014.) $)
    seqomeq12 $p |- ( ( A = B /\ C = D ) -> seqom ( A , C ) =
      seqom ( B , D ) ) $=
      ( va vb wceq com cvv cv co cop cmpt2 c0 cid cfv crdg cima cseqom wcel wa
      csuc oveq opeq2d 3ad2ant1 mpt2eq3dva fveq2 rdgeq12 syl2an imaeq1d 3eqtr4g
      df-seqom ) ABGZCDGZUAZEFHIEJZUBZUPFJZAKZLZMZNCOPZLZQZHREFHIUQUPURBKZLZMZN
      DOPZLZQZHRACSBDSUOVDVJHUMVAVGGVCVIGVDVJGUNUMEFHIUTVFUMUPHTUTVFGURITUMUSVE
      UQUPURABUCUDUEUFUNVBVHNCDOUGUDVCVIVAVGUHUIUJFEACULFEBDULUK $.
  $}

  ${
    $d F a b c d $.  $d I a b c d $.  $d G a b c d $.  $d A a b c d $.
    seqom.a $e |- G = seqom ( F , I ) $.
    $( An index-aware recursive definition defines a function on the natural
       numbers.  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fnseqom $p |- G Fn om $=
      ( va vb vd vc com wfn cvv cv csuc co cop cmpt2 c0 cid cfv crdg cima eqtri
      seqomlem0 seqomlem2 cseqom df-seqom fneq1i mpbir ) BIJEFIKELZMUIFLANOPQCR
      SOTZIUAZIJGUJHACACEFHGUCUDIBUKBACUEUKDFEACUFUBUGUH $.

    $( Value of an index-aware recursive definition at 0.  (Contributed by
       Stefan O'Rear, 1-Nov-2014.) $)
    seqom0g $p |- ( I e. _V -> ( G ` (/) ) = I ) $=
      ( va vb vd vc cvv wcel c0 cfv cid com cv csuc co cop cmpt2 eqtri df-seqom
      crdg cima cseqom fveq1i seqomlem0 seqomlem3 fvi syl5eq ) CIJKBLZCMLZCUJKE
      FNIEOZPULFOAQRSKUKRUBZNUCZLUKKBUNBACUDUNDFEACUATUEGUMHACACEFHGUFUGTCIUHUI
      $.

    $( Value of an index-aware recursive definition at a successor.
       (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    seqomsuc $p |- ( A e. om -> ( G ` suc A ) = ( A F ( G ` A ) ) ) $=
      ( va vb vd vc com wcel csuc cvv cv co cop cmpt2 c0 cfv fveq1i crdg cseqom
      cid cima seqomlem0 seqomlem4 df-seqom eqtri oveq2i 3eqtr4g ) AJKALZFGJMFN
      ZLULGNBOPQRDUCSPUAZJUDZSAAUNSZBOUKCSAACSZBOHAUMIBDBDFGIHUEUFUKCUNCBDUBUNE
      GFBDUGUHZTUPUOABACUNUQTUIUJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Abian's "most fundamental" fixed point theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    abianfp.1 $e |- A e. _V $.
    abianfp.2 $e |- G = rec ( ( z e. _V |-> ( F ` z ) ) , x ) $.
    ${
      $d v x y $.  $d v y z F $.  $d v y G $.
      $( Lemma for ~ abianfp .  We prove by transfinite induction that if ` F `
         has a fixed point ` x ` , then its iterates also equal ` x ` .  This
         lemma is used for the "trivial" direction of the main theorem.
         (Contributed by NM, 4-Sep-2004.) $)
      abianfplem $p |- ( v e. On -> ( ( F ` x ) = x -> ( G ` v ) = x ) ) $=
        ( vy cv cfv wceq c0 fveq2 eqeq1d cvv fveq1i vex wcel ciun csuc cmpt a1i
        crdg rdg0 eqtri con0 fvex rdgsucmpt2 mpan2 sylan9eqr sylan9eq wlim wral
        wa id exp32 rdglim2a mpan iuneq2i 3eqtr4g adantr iuneq2 wne word df-lim
        wi cuni simp2bi iunconst syl eqtrd ex a1d tfinds2 ) CJZFKZAJZLZMFKZVRLZ
        IJZFKZVRLZWBUAZFKZVRLZVREKZVRLZCIVPMLVQVTVRVPMFNOVPWBLVQWCVRVPWBFNOVPWE
        LVQWFVRVPWEFNOWAWIVTMBPBJZEKZUBZVRUDZKVRMFWMHQVRWLARUEUFUCWBUGSZWIWDWGW
        NWIWDUOWFWCEKZVRWNWOPSWFWOLWCEUHBCVRWBWKWOVPEKFPHVPWJENVPWCENUIUJWDWIWO
        WHVRWCVRENWIUPUKULUQVPUMZWDIVPUNZVSVGWIWPWQVSWPWQUOVQIVPWCTZVRWPVQWRLWQ
        WPVPWMKZIVPWBWMKZTZVQWRVPPSWPWSXALCRIVRVPPWLURUSVPFWMHQIVPWCWTWCWTLWBVP
        SWBFWMHQUCUTVAVBWQWPWRIVPVRTZVRIVPWCVRVCWPVPMVDZXBVRLWPVPVEXCVPVPVHLVPV
        FVIIVPVRVJVKUKVLVMVNVO $.
    $}

    $d v x y A $.  $d v x y z F $.  $d u v y G $.
    $( No longer active:
       ~ http://www.math.ucdavis.edu/~~suh/abian/abian-themostfixed.html . $)
    $( "A most fundamental fixed point theorem" of Alexander Abian (1923-1999),
       apparently proved in 1998.  Let ` G `` 0 = x ` , ` G `` 1 = F `` x ` ,
       ` G `` 2 = F `` ( F `` x ) ` ,... be the iterates of ` F ` .  The
       theorem reads (using our variable names):  "Let ` F ` be a mapping from
       a set ` A ` into itself.  Then ` F ` has a fixed point if and only if:
       There exists an element ` x ` of ` A ` such that for every ordinal
       ` v ` , ` G `` v ` is an element of ` A ` , and if ` G `` v ` is not a
       fixed point of ` F ` then the ` G `` u ` 's are all distinct for every
       ordinal ` u e. v ` ."  See ~ df-rdg for the ` rec ` operation.  The
       proof's key idea is to assume that ` F ` does not have a fixed point,
       then use the Axiom of Replacement in the form of ~ f1dmex to derive that
       the class of all ordinal numbers exists, contradicting ~ onprc .  Our
       version of this theorem does not require the hypothesis that ` F ` be a
       mapping.  Reference:
       ~ http://us2.metamath.org:88/abian-themostfixed.html .  For an
       application of this theorem, see
       ~ http://groups.google.com/group/sci.stat.math/msg/1737ee1133c24aeb for
       its use in a proof of Tarski's fixed point theorem.  (Contributed by NM,
       5-Sep-2004.)  (Revised by David Abernethy, 19-Jun-2012.) $)
    abianfp $p |- ( E. x e. A ( F ` x ) = x <-> E. x e. A
           A. v e. On ( ( G ` v ) e. A /\ ( -. ( F ` ( G ` v ) ) = ( G ` v ) ->
                    A. u e. v -. ( G ` v ) = ( G ` u ) ) ) ) $=
      ( vy cv cfv wceq wcel wn wral wi wa con0 imp wrex abianfplem eleq1d fveq2
      biimprd id eqeq12d biimprcd sylcom pm2.24d jctird ex ralrimdv reximia cvv
      com13 onprc r19.26 notbid rspccv imim1d ralimdv ralim syl6 com12 wf1 ccnv
      wfun wfn cmpt crdg rdgfnon fneq1i mpbir ffnfv biimpri mpan cres tz7.48lem
      wf wss ssid fnresdm ax-mp cnveqi funeqi sylib anim12i df-f1 sylibr f1dmex
      sylancl syld exp3acom23 sylbi mtoi rexlimivw cbvrexv dfrex2 bitr2i impbii
      ) AKZFLZXBMZAEUAZCKZGLZENZXGFLZXGMZOZXGDKGLMODXFPZQZRZCSPZAEUAZXDXOAEXBEN
      ZXDXNCSXFSNZXDXQXNXRXDXQXNQXRXDRZXQXHXMXSXHXQXSXGXBEXRXDXGXBMZABCEFGHIUBZ
      TUCUEXSXJXLXRXDXJXRXDXTXJYAXTXJXDXTXIXCXGXBXGXBFUDXTUFUGUHUITUJUKULUPUMUN
      XPJKZFLZYBMZOZJEPZOZXEXOYGAEXOYFSUONZUQXOXHCSPZXMCSPZRYFYHQZXHXMCSURYIYJY
      KYIYFYJYHYIYFYJRZXLCSPZYHYLYIYMYFYJYIYMQZYFYJXHXLQZCSPYNYFXMYOCSYFXHXKXLY
      EXKJXGEYBXGMZYDXJYPYCXIYBXGYBXGFUDYPUFUGUSUTVAVBXHXLCSVCVDTVEYIYMYHYIYMRZ
      SEGVFZEUONYHYQSEGVTZGVGZVHZRYRYIYSYMUUAGSVIZYIYSUUBBUOBKFLVJZXBVKZSVIXBUU
      CVLSGUUDIVMVNZYSUUBYIRCSEGVOVPVQYMGSVRZVGZVHZUUASSWAYMUUHSWBCDSGUUEVSVQUU
      GYTUUFGUUBUUFGMUUESGWCWDWEWFWGWHSEGWIWJHSEUOGWKWLULWMWNTWOWPWQXEYDJEUAYGX
      DYDAJEXBYBMZXCYCXBYBXBYBFUDUUIUFUGWRYDJEWSWTWGXA $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordinal arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c 1o $. $( The ordinal number 1 $)
  $c 2o $. $( The ordinal number 2 $)
  $c 3o $. $( The ordinal number 3 $)
  $c 4o $. $( The ordinal number 4 $)
  $c +o $.  $( Ordinal addition operation (plus subscript o) $)
  $c .o $.  $( Ordinal multiplication operation (center dot subscript o) $)
  $c ^o $.  $( Ordinal exponentiation operation (caret subscript o) $)

  $( Extend the definition of a class to include the ordinal number 1. $)
  c1o $a class 1o $.

  $( Extend the definition of a class to include the ordinal number 2. $)
  c2o $a class 2o $.

  $( Extend the definition of a class to include the ordinal number 3. $)
  c3o $a class 3o $.

  $( Extend the definition of a class to include the ordinal number 4. $)
  c4o $a class 4o $.

  $( Extend the definition of a class to include the ordinal addition
     operation. $)
  coa $a class +o $.

  $( Extend the definition of a class to include the ordinal multiplication
     operation. $)
  comu $a class .o $.

  $( Extend the definition of a class to include the ordinal exponentiation
     operation. $)
  coe $a class ^o $.

  $( Define the ordinal number 1.  (Contributed by NM, 29-Oct-1995.) $)
  df-1o $a |- 1o = suc (/) $.

  $( Define the ordinal number 2.  (Contributed by NM, 18-Feb-2004.) $)
  df-2o $a |- 2o = suc 1o $.

  $( Define the ordinal number 3.  (Contributed by Mario Carneiro,
     14-Jul-2013.) $)
  df-3o $a |- 3o = suc 2o $.

  $( Define the ordinal number 4.  (Contributed by Mario Carneiro,
     14-Jul-2013.) $)
  df-4o $a |- 4o = suc 3o $.

  ${
    $d x y z $.
    $( Define the ordinal addition operation.  (Contributed by NM,
       3-May-1995.) $)
    df-oadd $a |- +o = ( x e. On , y e. On |->
                ( rec ( ( z e. _V |-> suc z ) , x ) ` y ) ) $.

    $( Define the ordinal multiplication operation.  (Contributed by NM,
       26-Aug-1995.) $)
    df-omul $a |- .o = ( x e. On , y e. On |->
                ( rec ( ( z e. _V |-> ( z +o x ) ) , (/) ) ` y ) ) $.

    $( Define the ordinal exponentiation operation.  (Contributed by NM,
       30-Dec-2004.) $)
    df-oexp $a |- ^o = ( x e. On , y e. On |->
                   if ( x = (/) , ( 1o \ y ) ,
                 ( rec ( ( z e. _V |-> ( z .o x ) ) , 1o ) ` y ) ) ) $.
  $}

  $( Ordinal 1 is an ordinal number.  (Contributed by NM, 29-Oct-1995.) $)
  1on $p |- 1o e. On $=
    ( c1o c0 csuc con0 df-1o 0elon onsuci eqeltri ) ABCDEBFGH $.

  $( Ordinal 2 is an ordinal number.  (Contributed by NM, 18-Feb-2004.)  (Proof
     shortened by Andrew Salmon, 12-Aug-2011.) $)
  2on $p |- 2o e. On $=
    ( c2o c1o csuc con0 df-2o 1on onsuci eqeltri ) ABCDEBFGH $.

  $( Ordinal two is not zero.  (Contributed by Scott Fenton, 17-Jun-2011.) $)
  2on0 $p |- 2o =/= (/) $=
    ( c2o c1o csuc c0 df-2o nsuceq0 eqnetri ) ABCDEBFG $.

  $( Ordinal 3 is an ordinal number.  (Contributed by Mario Carneiro,
     5-Jan-2016.) $)
  3on $p |- 3o e. On $=
    ( c3o c2o csuc con0 df-3o 2on onsuci eqeltri ) ABCDEBFGH $.

  $( Ordinal 3 is an ordinal number.  (Contributed by Mario Carneiro,
     5-Jan-2016.) $)
  4on $p |- 4o e. On $=
    ( c4o c3o csuc con0 df-4o 3on onsuci eqeltri ) ABCDEBFGH $.

  $( Expanded value of the ordinal number 1.  (Contributed by NM,
     4-Nov-2002.) $)
  df1o2 $p |- 1o = { (/) } $=
    ( c1o c0 csuc csn df-1o suc0 eqtri ) ABCBDEFG $.

  $( Expanded value of the ordinal number 2.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  df2o3 $p |- 2o = { (/) , 1o } $=
    ( c2o c1o csuc csn cun c0 cpr df-2o df-suc df1o2 uneq1i df-pr eqtr4i 3eqtri
    ) ABCBBDZEZFBGZHBIPFDZOEQBROJKFBLMN $.

  $( Expanded value of the ordinal number 2.  (Contributed by NM,
     29-Jan-2004.) $)
  df2o2 $p |- 2o = { (/) , { (/) } } $=
    ( c2o c0 c1o cpr csn df2o3 df1o2 preq2i eqtri ) ABCDBBEZDFCJBGHI $.

  $( Ordinal one is not equal to ordinal zero.  (Contributed by NM,
     26-Dec-2004.) $)
  1n0 $p |- 1o =/= (/) $=
    ( c1o c0 csn df1o2 0ex snnz eqnetri ) ABCBDBEFG $.

  $( Cross products with the singletons of ordinals 0 and 1 are disjoint.
     (Contributed by NM, 2-Jun-2007.) $)
  xp01disj $p |- ( ( A X. { (/) } ) i^i ( C X. { 1o } ) ) = (/) $=
    ( c0 c1o wne csn cxp cin wceq 1n0 necomi xpsndisj ax-mp ) CDEACFGBDFGHCIDCJ
    KACBDLM $.

  $( Two ways to express that an ordinal class is positive.  (Contributed by
     NM, 21-Dec-2004.) $)
  ordgt0ge1 $p |- ( Ord A -> ( (/) e. A <-> 1o C_ A ) ) $=
    ( word c0 wcel csuc wss c1o con0 0elon ordelsuc mpan df-1o sseq1i syl6bbr
    wb ) ABZCADZCEZAFZGAFCHDPQSOICAHJKGRALMN $.

  $( An ordinal greater than or equal to 1 is nonzero.  (Contributed by NM,
     21-Dec-2004.) $)
  ordge1n0 $p |- ( Ord A -> ( 1o C_ A <-> A =/= (/) ) ) $=
    ( word c0 wcel c1o wss wne ordgt0ge1 ord0eln0 bitr3d ) ABCADEAFACGAHAIJ $.

  $( Membership in ordinal one.  (Contributed by NM, 5-Jan-2005.) $)
  el1o $p |- ( A e. 1o <-> A = (/) ) $=
    ( c1o wcel c0 csn wceq df1o2 eleq2i 0ex elsnc2 bitri ) ABCADEZCADFBLAGHADIJ
    K $.

  $( Two ways to say that ` A ` is a nonzero number of the set ` B ` .
     (Contributed by Mario Carneiro, 21-May-2015.) $)
  dif1o $p |- ( A e. ( B \ 1o ) <-> ( A e. B /\ A =/= (/) ) ) $=
    ( c1o cdif wcel c0 csn wne wa df1o2 difeq2i eleq2i eldifsn bitri ) ABCDZEAB
    FGZDZEABEAFHIOQACPBJKLABFMN $.

  $( Two ways to say that ` A ` is a nonzero ordinal number.  (Contributed by
     Mario Carneiro, 21-May-2015.) $)
  ondif1 $p |- ( A e. ( On \ 1o ) <-> ( A e. On /\ (/) e. A ) ) $=
    ( con0 c1o cdif wcel c0 wne wa dif1o on0eln0 pm5.32i bitr4i ) ABCDEABEZAFGZ
    HMFAEZHABIMONAJKL $.

  $( Two ways to say that ` A ` is an ordinal greater than one.  (Contributed
     by Mario Carneiro, 21-May-2015.) $)
  ondif2 $p |- ( A e. ( On \ 2o ) <-> ( A e. On /\ 1o e. A ) ) $=
    ( con0 c2o cdif wcel wn wa c1o eldif wb 1on wss ontri1 onsssuc df-2o eleq2i
    csuc syl6bbr bitr3d mpan2 con1bid pm5.32i bitri ) ABCDEABEZACEZFZGUDHAEZGAB
    CIUDUFUGUDUGUEUDHBEZUGFZUEJKUDUHGZAHLZUIUEAHMUJUKAHQZEUEAHNCULAOPRSTUAUBUC
    $.

  $( Closure of the pair swapping function on ` 2o ` .  (Contributed by Mario
     Carneiro, 27-Sep-2015.) $)
  2oconcl $p |- ( A e. 2o -> ( 1o \ A ) e. 2o ) $=
    ( c1o cdif c2o wcel c0 cpr wceq wo elpri difeq2 syl6eq difid orim12i orcomd
    dif0 syl con0 cvv df2o3 1on difexg ax-mp elpr sylibr syl6eleqr eleq2s ) BAC
    ZDEAFBGZDAUIEZUHUIDUJUHFHZUHBHZIZUHUIEUJAFHZABHZIZUMAFBJUPULUKUNULUOUKUNUHB
    FCBAFBKBPLUOUHBBCFABBKBMLNOQUHFBBREUHSEUABARUBUCUDUETUFTUG $.

  $( Ordinal zero is less than ordinal one.  (Contributed by NM,
     5-Jan-2005.) $)
  0lt1o $p |- (/) e. 1o $=
    ( c0 c1o wcel wceq eqid el1o mpbir ) ABCAADAEAFG $.

  $( An ordinal greater than one is greater than zero.  (Contributed by Mario
     Carneiro, 25-May-2015.) $)
  dif20el $p |- ( A e. ( On \ 2o ) -> (/) e. A ) $=
    ( con0 c2o cdif wcel c1o c0 ondif2 simprbi 0lt1o wa wi eldifi ontr1 syl mpd
    mpani ) ABCDEZFAEZGAEZRABEZSAHIRGFEZSTJRUAUBSKTLABCMGFANOQP $.

  $( The empty set is a well-ordering of ordinal one.  (Contributed by Mario
     Carneiro, 9-Feb-2015.) $)
  0we1 $p |- (/) We 1o $=
    ( c1o c0 wwe csn wbr wn wcel noel df-br mtbir wrel wb rel0 wesn ax-mp mpbir
    cop wceq df1o2 weeq2 ) ABCZBDZBCZUCBBBEZFZUDBBQZBGUFHBBBIJBKUCUELMBBNOPAUBR
    UAUCLSAUBBTOP $.

  ${
    $d O a b $.  $d A a b $.  $d B a b $.
    brwitnlem.r $e |- R = ( `' O " ( _V \ 1o ) ) $.
    brwitnlem.o $e |- O Fn X $.
    $( Lemma for relations which assert the existence of a witness in a
       two-parameter set.  (Contributed by Stefan O'Rear, 25-Jan-2015.)
       (Revised by Mario Carneiro, 23-Aug-2015.) $)
    brwitnlem $p |- ( A R B <-> ( A O B ) =/= (/) ) $=
      ( cop ccnv cvv c1o cdif cima wcel c0 wne wbr wa ax-mp 3bitr4i cfv co fvex
      dif1o mpbiran anbi2i wfn wb elpreima cdm ndmfv necon1ai syl6eleq pm4.71ri
      wceq fndm breqi df-br bitri df-ov neeq1i ) ABHZDIJKLZMZNZVBDUAZOPZABCQZAB
      DUBZOPVBENZVFVCNZRZVJVGRVEVGVKVGVJVKVFJNVGVBDUCVFJUDUEUFDEUGZVEVLUHGEVBVC
      DUISVGVJVGVBDUJZEVBVNNVFOVBDUKULVMVNEUOGEDUPSUMUNTVHABVDQVEABCVDFUQABVDUR
      USVIVFOABDUTVAT $.
  $}

  ${
    $d x y z $.
    $( Functionality and domain of ordinal addition.  (Contributed by NM,
       26-Aug-1995.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    fnoa $p |- +o Fn ( On X. On ) $=
      ( vx vy vz con0 cv cvv csuc cmpt crdg cfv coa df-oadd fvex fnmpt2i ) ABDD
      BEZCFCEGHAEIZJKABCLOPMN $.

    $( Functionality and domain of ordinal multiplication.  (Contributed by NM,
       26-Aug-1995.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    fnom $p |- .o Fn ( On X. On ) $=
      ( vx vy vz con0 cv cvv coa co cmpt c0 crdg cfv comu df-omul fvex fnmpt2i
      ) ABDDBEZCFCEAEGHIJKZLMABCNQROP $.

    $( Functionality and domain of ordinal exponentiation.  (Contributed by
       Mario Carneiro, 29-May-2015.) $)
    fnoe $p |- ^o Fn ( On X. On ) $=
      ( vx vy vz con0 cv c0 wceq c1o cdif cvv comu co cmpt crdg cfv cif df-oexp
      coe wcel 1on difexg ax-mp fvex ifex fnmpt2i ) ABDDAEZFGZHBEZIZUHCJCEUFKLM
      HNZOZPRABCQUGUIUKHDSUIJSTHUHDUAUBUHUJUCUDUE $.
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( Value of ordinal addition.  (Contributed by NM, 3-May-1995.)  (Revised
       by Mario Carneiro, 8-Sep-2013.) $)
    oav $p |- ( ( A e. On /\ B e. On ) ->
             ( A +o B ) = ( rec ( ( x e. _V |-> suc x ) , A ) ` B ) ) $=
      ( vy vz con0 cv cvv csuc cmpt crdg cfv coa wceq rdgeq2 fveq2 df-oadd fvex
      fveq1d ovmpt2 ) DEBCFFEGZAHAGIJZDGZKZLCUBBKZLMUAUELUCBNUAUDUEUCBUBOSUACUE
      PDEAQCUERT $.

    $( Value of ordinal multiplication.  (Contributed by NM, 17-Sep-1995.)
       (Revised by Mario Carneiro, 23-Aug-2014.) $)
    omv $p |- ( ( A e. On /\ B e. On ) ->
     ( A .o B ) = ( rec ( ( x e. _V |-> ( x +o A ) ) , (/) ) ` B ) ) $=
      ( vy vz con0 cv cvv coa co cmpt c0 crdg cfv comu wceq mpteq2dv rdgeq1 syl
      oveq2 fveq1d fveq2 df-omul fvex ovmpt2 ) DEBCFFEGZAHAGZDGZIJZKZLMZNCAHUGB
      IJZKZLMZNOUFUNNUHBPZUFUKUNUOUJUMPUKUNPUOAHUIULUHBUGITQLUJUMRSUAUFCUNUBDEA
      UCCUNUDUE $.
  $}

  ${
    oe0lem.1 $e |- ( ( ph /\ A = (/) ) -> ps ) $.
    oe0lem.2 $e |- ( ( ( A e. On /\ ph ) /\ (/) e. A ) -> ps ) $.
    $( A helper lemma for ~ oe0 and others.  (Contributed by NM,
       6-Jan-2005.) $)
    oe0lem $p |- ( ( A e. On /\ ph ) -> ps ) $=
      ( con0 wcel wa c0 wceq wi ex adantl wne on0eln0 adantr sylbird pm2.61dne
      wb ) CFGZAHZBCIACIJZBKTAUBBDLMUACINZICGZBTUDUCSACOPUAUDBELQR $.
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( Value of ordinal exponentiation.  (Contributed by NM, 30-Dec-2004.)
       (Revised by Mario Carneiro, 23-Aug-2014.) $)
    oev $p |- ( ( A e. On /\ B e. On ) -> ( A ^o B ) = if ( A = (/) ,
      ( 1o \ B ) , ( rec ( ( x e. _V |-> ( x .o A ) ) , 1o ) ` B ) ) ) $=
      ( vy vz con0 cv c0 wceq c1o cdif cvv comu co cmpt crdg cfv cif coe eqeq1
      oveq2 mpteq2dv rdgeq1 syl fveq1d ifbieq2d fveq2 ifeq12d df-oexp 1on elexi
      difeq2 difss ssexi fvex ifex ovmpt2 ) DEBCFFDGZHIZJEGZKZUTALAGZURMNZOZJPZ
      QZRBHIZJCKZCALVBBMNZOZJPZQZRSVGVAUTVKQZRURBIZUSVGVFVMVAURBHTVNUTVEVKVNVDV
      JIVEVKIVNALVCVIURBVBMUAUBJVDVJUCUDUEUFUTCIVGVAVHVMVLUTCJULUTCVKUGUHDEAUIV
      GVHVLVHJJFUJUKJCUMUNCVKUOUPUQ $.

    $( Value of ordinal exponentiation at a nonzero mantissa.  (Contributed by
       NM, 31-Dec-2004.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    oevn0 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. A ) -> ( A ^o B ) =
                ( rec ( ( x e. _V |-> ( x .o A ) ) , 1o ) ` B ) ) $=
      ( con0 wcel wa c0 coe co cvv cv comu cmpt c1o crdg cfv wceq wn wb wne cif
      on0eln0 df-ne syl6bb adantr cdif oev iffalse sylan9eq ex sylbid imp ) BDE
      ZCDEZFZGBEZBCHIZCAJAKBLIMNOPZQZUOUPBGQZRZUSUMUPVASUNUMUPBGTVABUBBGUCUDUEU
      OVAUSUOVAUQUTNCUFZURUAURABCUGUTVBURUHUIUJUKUL $.
  $}

  ${
    $d x y A $.
    $( Addition with zero.  Proposition 8.3 of [TakeutiZaring] p. 57.
       (Contributed by NM, 3-May-1995.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    oa0 $p |- ( A e. On -> ( A +o (/) ) = A ) $=
      ( vx con0 wcel c0 coa co cvv cv csuc cmpt crdg cfv wceq 0elon mpan2 rdg0g
      oav eqtrd ) ACDZAEFGZEBHBIJKZALMZATECDUAUCNOBAERPACUBQS $.

    $( Ordinal multiplication with zero.  Definition 8.15 of [TakeutiZaring]
       p. 62.  (Contributed by NM, 17-Sep-1995.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    om0 $p |- ( A e. On -> ( A .o (/) ) = (/) ) $=
      ( vx con0 wcel c0 comu co cvv coa cmpt crdg cfv wceq 0elon omv mpan2 rdg0
      cv 0ex syl6eq ) ACDZAEFGZEBHBRAIGJZEKLZEUAECDUBUDMNBAEOPEUCSQT $.

    $( Ordinal exponentiation with zero mantissa.  (Contributed by NM,
       31-Dec-2004.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    oe0m $p |- ( A e. On -> ( (/) ^o A ) = ( 1o \ A ) ) $=
      ( vx con0 wcel c0 coe co wceq c1o cdif cvv cv comu cmpt cfv cif 0elon oev
      crdg mpan eqid iftrue ax-mp syl6eq ) ACDZEAFGZEEHZIAJZABKBLEMGNISOZPZUHEC
      DUEUFUJHQBEARTUGUJUHHEUAUGUHUIUBUCUD $.
  $}

  $( Ordinal multiplication with zero.  Definition 8.15 of [TakeutiZaring]
     p. 62.  Unlike ~ om0 , this version works whether or not ` A ` is an
     ordinal.  However, since it is an artifact of our particular function
     value definition outside the domain, we will not use it in order to be
     conventional and present it only as a curiosity.  (Contributed by NM,
     1-Feb-1996.) $)
  om0x $p |- ( A .o (/) ) = (/) $=
    ( con0 wcel c0 wa comu co wceq om0 adantr cxp wfn cdm fnom fndm ax-mp ndmov
    pm2.61i ) ABCZDBCZEADFGDHZSUATAIJADBFFBBKZLFMUBHNUBFOPQR $.

  $( Ordinal exponentiation with zero mantissa and zero exponent.  Proposition
     8.31 of [TakeutiZaring] p. 67.  (Contributed by NM, 31-Dec-2004.) $)
  oe0m0 $p |- ( (/) ^o (/) ) = 1o $=
    ( c0 con0 wcel coe co c1o wceq 0elon cdif oe0m dif0 syl6eq ax-mp ) ABCZAADE
    ZFGHNOFAIFAJFKLM $.

  $( Ordinal exponentiation with zero mantissa and nonzero exponent.
     Proposition 8.31(2) of [TakeutiZaring] p. 67 and its converse.
     (Contributed by NM, 5-Jan-2005.) $)
  oe0m1 $p |- ( A e. On -> ( (/) e. A <-> ( (/) ^o A ) = (/) ) ) $=
    ( con0 wcel c0 c1o wss coe co wceq word wb eloni ordgt0ge1 cdif oe0m eqeq1d
    syl ssdif0 syl6rbbr bitrd ) ABCZDACZEAFZDAGHZDIZUAAJUBUCKALAMQUAUEEANZDIUCU
    AUDUFDAOPEARST $.

  ${
    $d x A $.
    $( Ordinal exponentiation with zero exponent.  Definition 8.30 of
       [TakeutiZaring] p. 67.  (Contributed by NM, 31-Dec-2004.)  (Revised by
       Mario Carneiro, 8-Sep-2013.) $)
    oe0 $p |- ( A e. On -> ( A ^o (/) ) = 1o ) $=
      ( vx con0 wcel c0 coe co c1o wceq oveq1 oe0m0 syl6eq adantl cvv comu cmpt
      wa cv crdg cfv 0elon oevn0 mpanl2 1on elexi rdg0 adantll oe0lem anidms )
      ACDZAEFGZHIZUJULAAEIZULUJUMUKEEFGHAEEFJKLMUJEADZULUJUJUNQUKEBNBRAOGPZHSTZ
      HUJECDUNUKUPIUABAEUBUCHUOHCUDUEUFLUGUHUI $.

    $( Alternate value of ordinal exponentiation.  Compare ~ oev .
       (Contributed by NM, 2-Jan-2004.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    oev2 $p |- ( ( A e. On /\ B e. On ) -> ( A ^o B ) = ( ( rec (
          ( x e. _V |-> ( x .o A ) ) , 1o ) ` B )
                  i^i ( ( _V \ |^| A ) u. |^| B ) ) ) $=
      ( con0 wcel coe co cvv c1o cint cdif cun cin wceq c0 syl6eq eqtr4d ineq2d
      wa adantl comu cmpt crdg cfv oveq12 oe0m0 fveq2 1on elexi rdg0 inteq int0
      cv ineq12d inv1 a1i sylan9eqr oveq1 oe0m1 biimpa an32s int0el in0 difeq2d
      oe0lem difid uneq2d uncom un0 3eqtr3g oevn0 dif0 unv syl6req eqtrd ) CDEZ
      BCFGZCAHAUMBUAGUBZIUCZUDZHBJZKZCJZLZMZNBVPBONZSZVQVTWCMZWEWFVQWHNCWFCONZS
      ZVQIWHWJVQOOFGIBOCOFUEUFPWIWFWHIHMZIWIVTIWCHWIVTOVSUDICOVSUGIVRIDUHUIUJPW
      IWCOJZHCOUKULPUNWKINWFIUOUPUQQWGOCEZSVQOWHVPWMWFVQONWFVPWMSVQOCFGZOBOCFUR
      VPWMWNONCUSUTUQVAWMWHONWGWMWHVTOMOWMWCOVTCVBRVTVCPTQVEWGWDWCVTWFWDWCNVPWF
      WCWBLZWCOLWDWCWFWBOWCWFWBHHKOWFWAHHWFWAWLHBOUKULPVDHVFPVGWCWBVHZWCVIVJTRQ
      BDEVPSZOBEZSZVQVTWEABCVKWSWEVTHMVTWSWDHVTWRWDHNWQWRWOWCHLWDHWRWBHWCWRWBHO
      KHWRWAOHBVBVDHVLPVGWPWCVMVJTRVTUOVNVOVE $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Addition with successor.  Definition 8.1 of [TakeutiZaring] p. 56.
       (Contributed by NM, 3-May-1995.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    oasuc $p |- ( ( A e. On /\ B e. On ) ->
                ( A +o suc B ) = suc ( A +o B ) ) $=
      ( vx con0 wcel wa csuc cvv cv cmpt crdg cfv coa co rdgsuc adantl suceloni
      wceq oav sylan2 ovex suceq eqid sucex fvmpt ax-mp fveq2d syl5eqr 3eqtr4d
      ) ADEZBDEZFZBGZCHCIZGZJZAKZLZBUQLZUPLZAUMMNZABMNZGZUKURUTRUJABUPOPUKUJUMD
      EVAURRBQCAUMSTULVCVBUPLZUTVBHEVDVCRABMUAZCVBUOVCHUPUNVBUBUPUCVBVEUDUEUFUL
      VBUSUPCABSUGUHUI $.
  $}

  ${
    $d x A $.  $d x B $.
    oesuclem.1 $e |- Lim X $.
    oesuclem.2 $e |- ( B e. X ->
      ( rec ( ( x e. _V |-> ( x .o A ) ) , 1o ) ` suc B ) =
        ( ( x e. _V |-> ( x .o A ) ) `
          ( rec ( ( x e. _V |-> ( x .o A ) ) , 1o ) ` B ) ) ) $.
    $( Lemma for ~ oesuc .  (Contributed by NM, 31-Dec-2004.)  (Revised by
       Mario Carneiro, 15-Nov-2014.) $)
    oesuclem $p |- ( ( A e. On /\ B e. X ) ->
                ( A ^o suc B ) = ( ( A ^o B ) .o A ) ) $=
      ( wcel coe co comu wceq c0 wa oveq1 ax-mp mpan syl wb con0 cfv csuc oe0m1
      word wlim limord ordelord 0elsuc ordelon sylbi mpbid sylan9eqr id oveq12d
      limsuc oveq2 c1o oe0m0 1on eqeltri syl6eqel adantl biimpa adantll mpancom
      0elon oe0lem om0 eqtr4d cvv cv cmpt crdg ad2antlr oevn0 sylanl2 ovex eqid
      fvmpt fveq2d syl5eqr 3eqtr4d ) CDGZBCUAZHIZBCHIZBJIZKBWBBLKZMWDLWFWGWBWDL
      WCHIZLBLWCHNWBLWCGZWHLKZWBCUCZWIDUCZWBWKDUDZWLEDUEOZDCUFPCUGQWBWCDGZWIWJR
      ZWMWBWOREDCUNOZWOWCSGZWPWLWOWRWNDWCUHPZWCUBQUIUJUKWGWBWFLCHIZLJIZLWGWEWTB
      LJBLCHNWGULUMWBWTSGZXALKCSGZWBXBWLWBXCWNDCUHPZWBXBCCLKZXBWBXEWTLLHIZSCLLH
      UOXFUPSUQURUSUTVAWBLCGZXBXCWBXGMWTLSWBXGWTLKZWBXCXGXHRXDCUBQVBVEUTVCVFVDW
      TVGQUKVHBSGZWBMLBGZMZWCAVIAVJZBJIZVKZUPVLZTZCXOTZXNTZWDWFWBXPXRKXIXJFVMWB
      XIWRXJWDXPKWBWOWRWQWSUIABWCVNVOXKWFWEXNTZXRWEVIGXSWFKBCHVPAWEXMWFVIXNXLWE
      BJNXNVQWEBJVPVROXKWEXQXNWBXIXCXJWEXQKXDABCVNVOVSVTWAVF $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Multiplication with successor.  Definition 8.15 of [TakeutiZaring]
       p. 62.  (Contributed by NM, 17-Sep-1995.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    omsuc $p |- ( ( A e. On /\ B e. On ) ->
                ( A .o suc B ) = ( ( A .o B ) +o A ) ) $=
      ( vx con0 wcel wa csuc cvv cv coa cmpt crdg cfv comu wceq rdgsuc omv ovex
      co c0 adantl suceloni sylan2 oveq1 fvmpt ax-mp fveq2d syl5eqr 3eqtr4d
      eqid ) ADEZBDEZFZBGZCHCIZAJSZKZTLZMZBURMZUQMZAUNNSZABNSZAJSZULUSVAOUKTBUQ
      PUAULUKUNDEVBUSOBUBCAUNQUCUMVDVCUQMZVAVCHEVEVDOABNRCVCUPVDHUQUOVCAJUDUQUJ
      VCAJRUEUFUMVCUTUQCABQUGUHUI $.

    $( Ordinal exponentiation with a successor exponent.  Definition 8.30 of
       [TakeutiZaring] p. 67.  (Contributed by NM, 31-Dec-2004.)  (Revised by
       Mario Carneiro, 8-Sep-2013.) $)
    oesuc $p |- ( ( A e. On /\ B e. On ) ->
                ( A ^o suc B ) = ( ( A ^o B ) .o A ) ) $=
      ( vx con0 limon c1o cvv cv comu co cmpt rdgsuc oesuclem ) CABDEFBCGCHAIJK
      LM $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Addition with successor.  Theorem 4I(A2) of [Enderton] p. 79.  (Note
       that this version of ~ oasuc does not need Replacement.)  (Contributed
       by Mario Carneiro, 16-Nov-2014.) $)
    onasuc $p |- ( ( A e. On /\ B e. om ) ->
                  ( A +o suc B ) = suc ( A +o B ) ) $=
      ( vx con0 wcel com wa csuc cvv cv cfv coa co wceq adantl fvres syl fveq2d
      oav sylan2 cmpt crdg cres frsuc peano2 3eqtr3d nnon ovex suceq eqid sucex
      suceloni fvmpt ax-mp syl5eqr 3eqtr4d ) ADEZBFEZGZBHZCICJZHZUAZAUBZKZBVDKZ
      VCKZAUTLMZABLMZHZUSUTVDFUCZKZBVKKZVCKZVEVGURVLVNNUQABVCUDOUSUTFEZVLVENURV
      OUQBUEOUTFVDPQUSVMVFVCURVMVFNUQBFVDPORUFURUQUTDEZVHVENURBDEZVPBUGZBULQCAU
      TSTUSVJVIVCKZVGVIIEVSVJNABLUHZCVIVBVJIVCVAVIUIVCUJVIVTUKUMUNUSVIVFVCURUQV
      QVIVFNVRCABSTRUOUP $.

    $( Multiplication with successor.  Theorem 4J(A2) of [Enderton] p. 80.
       (Contributed by NM, 20-Sep-1995.)  (Revised by Mario Carneiro,
       14-Nov-2014.) $)
    onmsuc $p |- ( ( A e. On /\ B e. om ) ->
                  ( A .o suc B ) = ( ( A .o B ) +o A ) ) $=
      ( vx con0 wcel com comu co cvv coa c0 cfv wceq nnon syl omv sylan2 adantl
      fvres eqtr4d wa csuc cv cmpt crdg cres peano2 ovex oveq1 eqid fvmpt ax-mp
      fveq2d syl5eqr frsuc ) ADEZBFEZUAZABUBZGHZUSCICUCZAJHZUDZKUEZFUFZLZABGHZA
      JHZURUTUSVDLZVFUQUPUSDEZUTVIMUQUSFEZVJBUGZUSNOCAUSPQURVKVFVIMUQVKUPVLRUSF
      VDSOTURVHBVELZVCLZVFURVHVGVCLZVNVGIEVOVHMABGUHCVGVBVHIVCVAVGAJUIVCUJVGAJU
      HUKULURVGVMVCURVGBVDLZVMUQUPBDEVGVPMBNCABPQUQVMVPMUPBFVDSRTUMUNUQVFVNMUPK
      BVCUORTT $.

    $( Exponentiation with a successor exponent.  Definition 8.30 of
       [TakeutiZaring] p. 67.  (Contributed by Mario Carneiro, 14-Nov-2014.) $)
    onesuc $p |- ( ( A e. On /\ B e. om ) ->
                ( A ^o suc B ) = ( ( A ^o B ) .o A ) ) $=
      ( vx com limom wcel csuc cvv cv comu co cmpt c1o crdg cres cfv frsuc wceq
      peano2 fvres syl fveq2d 3eqtr3d oesuclem ) CABDEBDFZBGZCHCIAJKLZMNZDOZPZB
      UIPZUGPUFUHPZBUHPZUGPMBUGQUEUFDFUJULRBSUFDUHTUAUEUKUMUGBDUHTUBUCUD $.
  $}

  $( Addition with 1 is same as successor.  Proposition 4.34(a) of [Mendelson]
     p. 266.  (Contributed by NM, 29-Oct-1995.)  (Revised by Mario Carneiro,
     16-Nov-2014.) $)
  oa1suc $p |- ( A e. On -> ( A +o 1o ) = suc A ) $=
    ( con0 wcel c1o coa co c0 csuc df-1o oveq2i wceq peano1 onasuc mpan2 syl5eq
    com oa0 suceq syl eqtrd ) ABCZADEFZAGEFZHZAHZUAUBAGHZEFZUDDUFAEIJUAGPCUGUDK
    LAGMNOUAUCAKUDUEKAQUCARST $.

  ${
    $d x y z A $.  $d x B $.
    $( Ordinal addition with a limit ordinal.  Definition 8.1 of
       [TakeutiZaring] p. 56.  (Contributed by NM, 3-Aug-2004.)  (Revised by
       Mario Carneiro, 8-Sep-2013.) $)
    oalim $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) ->
                ( A +o B ) = U_ x e. B ( A +o x ) ) $=
      ( vy wcel wlim wa con0 coa co ciun wceq limelon simpr jca cfv oav sylan2
      cv cvv csuc cmpt crdg rdglim2a adantl wb anassrs iuneq2dv eqeq12d adantrr
      onelon mpbird ) CDFZCGZHZBIFZCIFZUOHZBCJKZACBATZJKZLZMZUPURUOCDNUNUOOPUQU
      SHVDCEUAETUBUCZBUDZQZACVAVFQZLZMZUSVJUQABCIVEUEUFUQURVDVJUGUOUQURHZUTVGVC
      VIEBCRVKACVBVHUQURVACFZVBVHMZURVLHUQVAIFVMCVAULEBVARSUHUIUJUKUMS $.

    $( Ordinal multiplication with a limit ordinal.  Definition 8.15 of
       [TakeutiZaring] p. 62.  (Contributed by NM, 3-Aug-2004.)  (Revised by
       Mario Carneiro, 8-Sep-2013.) $)
    omlim $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) ->
                ( A .o B ) = U_ x e. B ( A .o x ) ) $=
      ( vy wcel wlim wa con0 comu co cv ciun wceq limelon simpr cfv omv sylan2
      c0 jca cvv coa cmpt crdg rdglim2a adantl anassrs iuneq2dv eqeq12d adantrr
      wb onelon mpbird ) CDFZCGZHZBIFZCIFZUPHZBCJKZACBALZJKZMZNZUQUSUPCDOUOUPPU
      AURUTHVECEUBELBUCKUDZTUEZQZACVBVGQZMZNZUTVKURATCIVFUFUGURUSVEVKULUPURUSHZ
      VAVHVDVJEBCRVLACVCVIURUSVBCFZVCVINZUSVMHURVBIFVNCVBUMEBVBRSUHUIUJUKUNS $.

    $( Ordinal exponentiation with a limit exponent and nonzero mantissa.
       Definition 8.30 of [TakeutiZaring] p. 67.  (Contributed by NM,
       1-Jan-2005.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    oelim $p |- ( ( ( A e. On /\ ( B e. C /\ Lim B ) ) /\ (/) e. A ) ->
                ( A ^o B ) = U_ x e. B ( A ^o x ) ) $=
      ( vy wcel wlim wa con0 c0 coe co ciun wceq limelon c1o cfv oevn0 sylanl2
      cv simpr jca comu cmpt crdg rdglim2a ad2antlr wb onelon exp42 com34 imp41
      cvv iuneq2dv eqeq12d adantlrr mpbird ) CDFZCGZHZBIFZCIFZUSHZJBFZBCKLZACBA
      TZKLZMZNZUTVBUSCDOURUSUAUBVAVCHVDHVICEUMETBUCLUDZPUEZQZACVFVKQZMZNZVCVOVA
      VDAPCIVJUFUGVAVBVDVIVOUHUSVAVBHVDHZVEVLVHVNEBCRVPACVGVMVAVBVDVFCFZVGVMNZV
      AVBVQVDVRVAVBVQVDVRVBVQHVAVFIFVDVRCVFUIEBVFRSUJUKULUNUOUPUQS $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Closure law for ordinal addition.  Proposition 8.2 of [TakeutiZaring]
       p. 57.  (Contributed by NM, 5-May-1995.) $)
    oacl $p |- ( ( A e. On /\ B e. On ) -> ( A +o B ) e. On ) $=
      ( vx vy con0 wcel coa co cv c0 csuc oveq2 eleq1d oa0 wi wa syl5ibr expcom
      wceq cvv ibir suceloni oasuc wlim wral ciun vex iunon mpan mpanr1 tfinds3
      oalim impcom ) BEFAEFZABGHZEFZACIZGHZEFZAJGHZEFZADIZGHZEFZAVBKZGHZEFZUPUN
      CDBUQJSURUTEUQJAGLMUQVBSURVCEUQVBAGLMUQVESURVFEUQVEAGLMUQBSURUOEUQBAGLMUN
      VAUNUTAEANMUAUNVBEFZVDVGOVDVGUNVHPZVCKZEFVCUBVIVFVJEAVBUCMQRUNUQUDZVDDUQU
      EZUSOVLUSUNVKPZDUQVCUFZEFZUQTFZVLVOCUGZDUQVCTUHUIVMURVNEUNVPVKURVNSVQDAUQ
      TULUJMQRUKUM $.

    $( Closure law for ordinal multiplication.  Proposition 8.16 of
       [TakeutiZaring] p. 57.  (Contributed by NM, 3-Aug-2004.)  (Proof
       shortened by Andrew Salmon, 22-Oct-2011.) $)
    omcl $p |- ( ( A e. On /\ B e. On ) -> ( A .o B ) e. On ) $=
      ( vx vy con0 wcel comu co cv c0 csuc wceq oveq2 eleq1d 0elon wi wa expcom
      om0 cvv syl6eqel coa oacl adantr omsuc sylibrd wlim wral ciun iunon omlim
      vex mpan mpanr1 syl5ibr tfinds3 impcom ) BEFAEFZABGHZEFZACIZGHZEFZAJGHZEF
      ADIZGHZEFZAVEKZGHZEFZUTURCDBVAJLVBVDEVAJAGMNVAVELVBVFEVAVEAGMNVAVHLVBVIEV
      AVHAGMNVABLVBUSEVABAGMNURVDJEASOUAURVEEFZVGVJPURVKQZVGVFAUBHZEFZVJURVGVNP
      VKVGURVNVFAUCRUDVLVIVMEAVEUENUFRURVAUGZVGDVAUHZVCPVPVCURVOQZDVAVFUIZEFZVA
      TFZVPVSCULZDVAVFTUJUMVQVBVREURVTVOVBVRLWADAVATUKUNNUORUPUQ $.

    $( Closure law for ordinal exponentiation.  (Contributed by NM,
       1-Jan-2005.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
    oecl $p |- ( ( A e. On /\ B e. On ) -> ( A ^o B ) e. On ) $=
      ( vx vy con0 wcel coe co c0 wceq oveq2 c1o 1on syl6eqel wa oe0lem syl5ibr
      eleq1d wi cvv oe0m0 eqeltri adantl oe0m1 biimpa 0elon anidms oveq1 impcom
      adantll cv csuc oe0 adantr comu omcl oesuc sylibrd adantrd wlim wral ciun
      expcom iunon mpan oelim mpanlr1 anasss an12s ex tfinds3 exp3a com12 imp31
      vex ) BEFZABGHZEFZAAIJZVPVRVPVRVSIBGHZEFZVPWAVPWABBIJZWAVPWBVTIIGHZEBIIGK
      WCLEUAMUBNUCVPIBFZWAVPVPWDOVTIEVPWDVTIJBUDUEUFNUJPUGVSVQVTEAIBGUHRQUIAEFZ
      VPIAFZVRVPWEWFVRSVPWEWFVRACUKZGHZEFZAIGHZEFZADUKZGHZEFZAWLULZGHZEFZVRWEWF
      OZCDBWGIJWHWJEWGIAGKRWGWLJWHWMEWGWLAGKRWGWOJWHWPEWGWOAGKRWGBJWHVQEWGBAGKR
      WEWKWFWEWJLEAUMMNUNWLEFZWEWNWQSZWFWEWSWTWEWSOZWNWMAUOHZEFZWQWEWNXCSWSWNWE
      XCWMAUPVCUNXAWPXBEAWLUQRURVCUSWGUTZWRWNDWGVAZWISXEWIXDWROZDWGWMVBZEFZWGTF
      ZXEXHCVOZDWGWMTVDVEXFWHXGEWEXDWFWHXGJZWEXDWFXKWEXIXDWFXKXJDAWGTVFVGVHVIRQ
      VJVKVLVMVNP $.
  $}

  ${
    $d x y $.  $d x A $.
    $( Ordinal addition with zero.  Proposition 8.3 of [TakeutiZaring] p. 57.
       (Contributed by NM, 5-May-1995.) $)
    oa0r $p |- ( A e. On -> ( (/) +o A ) = A ) $=
      ( vx vy c0 cv coa co wceq csuc oveq2 id eqeq12d con0 wcel 0elon oa0 ax-mp
      mpan ciun cvv oasuc suceq sylan9eq ex wral wlim iuneq2 uniiun syl6eqr vex
      cuni wa oalim limuni syl5ibr tfinds ) DBEZFGZUQHZDDFGZDHZDCEZFGZVBHZDVBIZ
      FGZVEHZDAFGZAHBCAUQDHZURUTUQDUQDDFJVIKLUQVBHZURVCUQVBUQVBDFJVJKLUQVEHZURV
      FUQVEUQVEDFJVKKLUQAHZURVHUQAUQADFJVLKLDMNZVAODPQVBMNZVDVGVNVDVFVCIZVEVMVN
      VFVOHODVBUARVCVBUBUCUDVDCUQUEZUSUQUFZCUQVCSZUQUKZHVPVRCUQVBSVSCUQVCVBUGCU
      QUHUIVQURVRUQVSUQTNZVQURVRHZBUJVMVTVQULWAOCDUQTUMRRUQUNLUOUP $.
  $}

  ${
    $d x y A $.
    $( Ordinal multiplication with zero.  Proposition 8.18(1) of
       [TakeutiZaring] p. 63.  (Contributed by NM, 3-Aug-2004.) $)
    om0r $p |- ( A e. On -> ( (/) .o A ) = (/) ) $=
      ( vx vy c0 cv comu co wceq csuc oveq2 eqeq1d om0x con0 wcel 0elon syl5ibr
      coa mpan ciun cvv oveq1 omsuc oa0 ax-mp eqcomi a1i eqeq12d wral wlim iun0
      iuneq2 syl6eq vex wa omlim tfinds ) DBEZFGZDHZDDFGZDHDCEZFGZDHZDVAIZFGZDH
      ZDAFGZDHBCAUQDHURUTDUQDDFJKUQVAHURVBDUQVADFJKUQVDHURVEDUQVDDFJKUQAHURVGDU
      QADFJKDLVCVFVAMNZVBDQGZDDQGZHVBDDQUAVHVEVIDVJDMNZVHVEVIHODVAUBRDVJHVHVJDV
      KVJDHODUCUDUEUFUGPVCCUQUHZUSUQUIZCUQVBSZDHVLVNCUQDSDCUQVBDUKCUQUJULVMURVN
      DUQTNZVMURVNHZBUMVKVOVMUNVPOCDUQTUORRKPUP $.
  $}

  $( 1 + 1 = 2 for ordinal numbers.  (Contributed by NM, 18-Feb-2004.) $)
  o1p1e2 $p |- ( 1o +o 1o ) = 2o $=
    ( c1o coa co csuc c2o con0 wcel wceq 1on oa1suc ax-mp df-2o eqtr4i ) AABCZA
    DZEAFGNOHIAJKLM $.

  $( Ordinal multiplication with 1.  Proposition 8.18(2) of [TakeutiZaring]
     p. 63.  (Contributed by NM, 29-Oct-1995.) $)
  om1 $p |- ( A e. On -> ( A .o 1o ) = A ) $=
    ( con0 wcel c1o comu co coa csuc df-1o oveq2i com wceq peano1 onmsuc syl5eq
    c0 mpan2 om0 oveq1d oa0r 3eqtrd ) ABCZADEFZAPEFZAGFZPAGFAUBUCAPHZEFZUEDUFAE
    IJUBPKCUGUELMAPNQOUBUDPAGARSATUA $.

  ${
    $d x y $.  $d x A $.
    $( Ordinal multiplication with 1.  Proposition 8.18(2) of [TakeutiZaring]
       p. 63.  (Contributed by NM, 3-Aug-2004.) $)
    om1r $p |- ( A e. On -> ( 1o .o A ) = A ) $=
      ( vx vy c1o cv comu co wceq c0 oveq2 id eqeq12d con0 wcel wa coa 1on mpan
      ciun cvv csuc om0x omsuc oveq1 sylan9eq oa1suc adantr ex wral wlim iuneq2
      eqtrd cuni uniiun syl6eqr vex omlim limuni syl5ibr tfinds ) DBEZFGZVAHZDI
      FGZIHDCEZFGZVEHZDVEUAZFGZVHHZDAFGZAHBCAVAIHZVBVDVAIVAIDFJVLKLVAVEHZVBVFVA
      VEVAVEDFJVMKLVAVHHZVBVIVAVHVAVHDFJVNKLVAAHZVBVKVAAVAADFJVOKLDUBVEMNZVGVJV
      PVGOVIVEDPGZVHVPVGVIVFDPGZVQDMNZVPVIVRHQDVEUCRVFVEDPUDUEVPVQVHHVGVEUFUGUL
      UHVGCVAUIZVCVAUJZCVAVFSZVAUMZHVTWBCVAVESWCCVAVFVEUKCVAUNUOWAVBWBVAWCVATNZ
      WAVBWBHZBUPVSWDWAOWEQCDVATUQRRVAURLUSUT $.
  $}

  $( Ordinal exponentiation with an exponent of 1.  (Contributed by NM,
     2-Jan-2005.) $)
  oe1 $p |- ( A e. On -> ( A ^o 1o ) = A ) $=
    ( con0 wcel c1o coe co comu csuc df-1o oveq2i com wceq peano1 onesuc syl5eq
    c0 mpan2 oe0 oveq1d om1r 3eqtrd ) ABCZADEFZAPEFZAGFZDAGFAUBUCAPHZEFZUEDUFAE
    IJUBPKCUGUELMAPNQOUBUDDAGARSATUA $.

  ${
    $d x y $.  $d x A $.
    $( Ordinal exponentiation with a mantissa of 1.  Proposition 8.31(3) of
       [TakeutiZaring] p. 67.  (Contributed by NM, 2-Jan-2005.) $)
    oe1m $p |- ( A e. On -> ( 1o ^o A ) = 1o ) $=
      ( vx vy c1o cv coe co wceq c0 oveq2 eqeq1d con0 wcel ax-mp comu mpan ciun
      1on cvv wa csuc oe0 oesuc oveq1 syl6eq sylan9eq ex wral wlim iuneq2 0lt1o
      om1 vex oelim mpan2 wne 0ellim ne0i iunconst eqeq2d bitr4d syl5ibr tfinds
      3syl ) DBEZFGZDHZDIFGZDHZDCEZFGZDHZDVJUAZFGZDHZDAFGZDHBCAVEIHVFVHDVEIDFJK
      VEVJHVFVKDVEVJDFJKVEVMHVFVNDVEVMDFJKVEAHVFVPDVEADFJKDLMZVIRDUBNVJLMZVLVOV
      RVLVNVKDOGZDVQVRVNVSHRDVJUCPVLVSDDOGZDVKDDOUDVQVTDHRDULNUEUFUGVLCVEUHVGVE
      UIZCVEVKQZCVEDQZHZCVEVKDUJWAVGWBDHWDWAVFWBDVESMZWAVFWBHZBUMVQWEWATZWFRVQW
      GTIDMWFUKCDVESUNUOPPKWAWCDWBWAIVEMVEIUPWCDHVEUQVEIURCVEDUSVDUTVAVBVC $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Ordering property of ordinal addition.  Proposition 8.4 of
       [TakeutiZaring] p. 58.  (Contributed by NM, 5-Dec-2004.) $)
    oaordi $p |- ( ( B e. On /\ C e. On ) ->
                 ( A e. B -> ( C +o A ) e. ( C +o B ) ) ) $=
      ( vx vy con0 wcel coa co wi wa csuc wss oveq2 sseq2d imbi2d ancoms ex cvv
      wceq onelon adantll word eloni ordsucss syl ad2antlr sucelon cv ssid a1ii
      sssucid sstr2 mpi oasuc syl5ibr ad2antrr a2d wlim wral ciun sylbir limsuc
      sucssel biimpd sylan9r imp ssiun2s adantr vex mpanr1 adantlr sseqtr4d a1d
      oalim exp31 syl5bi com4r imp31 sseq1d ovex ax-mp syl6bi 3syld an32s mpdan
      tfindsg ) CFGZBFGZABGZCAHIZCBHIZGZJWHWIKZWJWMWNWJKAFGZWMWIWJWOWHBAUAUBWNW
      OWJWMWNWOKZWJWMWPWJALZBMZCWQHIZWLMZWMWIWJWRJZWHWOWIBUCXABUDABUEUFUGWHWIWO
      WRWTJWIWOWRWHWTWOWQFGZWIWRWHWTJZJAUHZWIXBWRXCWHWSCDUIZHIZMZJZWHWSWSMZJWHW
      SCEUIZHIZMZJZWHWSCXJLZHIZMZJXCDEBWQXEWQTZXGXIWHXQXFWSWSXEWQCHNOPXEXJTZXGX
      LWHXRXFXKWSXEXJCHNOPXEXNTZXGXPWHXSXFXOWSXEXNCHNOPXEBTZXGWTWHXTXFWLWSXEBCH
      NOPXBWHXIWSUJUKXJFGZXBKWQXJMZKWHXLXPYAWHXLXPJZJXBYBYAWHYCXLXPYAWHKZWSXKLZ
      MZXLXKYEMYFXKULWSXKYEUMUNYDXOYEWSWHYAXOYETCXJUOQOUPRUQURXEUSZXBKZWQXEMZKZ
      XHYBXMJEXEUTYJWHXGYJWHKWSEXEXKVAZXFYJWSYKMZWHYJWQXEGZYLYHYIYMXBYIAXEGZYGY
      MXBWOYIYNJXDAXEFVDVBYGYNYMXEAVCVEVFVGEXEXKWQWSXJWQCHNVHUFVIYHWHXFYKTZYIYG
      WHYOXBWHYGYOWHXESGYGYODVJECXESVOVKQVLVLVMRVNWGVPVQVRVSWHWOWTWMJWIWHWOKZWT
      WKLZWLMZWMYPWSYQWLCAUOVTWKSGYRWMJCAHWAWKWLSVDWBWCVLWDVGWEWFRQ $.
  $}

  $( Ordering property of ordinal addition.  Proposition 8.4 of [TakeutiZaring]
     p. 58 and its converse.  (Contributed by NM, 5-Dec-2004.) $)
  oaord $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A e. B <-> ( C +o A ) e. ( C +o B ) ) ) $=
    ( con0 wcel coa co wi oaordi wceq wo wn word wa wb oacl syl anim12i ordtri2
    eloni w3a 3adant1 oveq2 a1i 3adant2 orim12d con3d df-3an ancom anandi sylbi
    3bitri 3adant3 3imtr4d impbid ) ADEZBDEZCDEZUAZABEZCAFGZCBFGZEZUQURUTVCHUPA
    BCIUBUSVAVBJZVBVAEZKZLZABJZBAEZKZLZVCUTUSVJVFUSVHVDVIVEVHVDHUSABCFUCUDUPURV
    IVEHUQBACIUEUFUGUSVAMZVBMZNZVCVGOUSURUPNZURUQNZNZVNUSUPUQNZURNURVRNVQUPUQUR
    UHVRURUIURUPUQUJULVOVLVPVMVOVADEVLCAPVATQVPVBDEVMCBPVBTQRUKVAVBSQUSAMZBMZNZ
    UTVKOUPUQWAURUPVSUQVTATBTRUMABSQUNUO $.

  $( Left cancellation law for ordinal addition.  Corollary 8.5 of
     [TakeutiZaring] p. 58.  (Contributed by NM, 5-Dec-2004.) $)
  oacan $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                   ( ( A +o B ) = ( A +o C ) <-> B = C ) ) $=
    ( con0 wcel w3a wo wn coa co wceq wb oaord word eloni ordtri3 syl2an wa syl
    oacl 3comr 3com13 orbi12d notbid 3adant1 3impdi 3bitr4rd ) ADEZBDEZCDEZFZBC
    EZCBEZGZHZABIJZACIJZEZUQUPEZGZHZBCKZUPUQKZUKUNUTUKULURUMUSUIUJUHULURLBCAMUA
    UJUIUHUMUSLCBAMUBUCUDUIUJVBUOLZUHUIBNCNVDUJBOCOBCPQUEUHUIUJVCVALZUHUIRZUPNZ
    UQNZVEUHUJRZVFUPDEVGABTUPOSVIUQDEVHACTUQOSUPUQPQUFUG $.

  $( Weak ordering property of ordinal addition.  (Contributed by NM,
     6-Dec-2004.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  oaword $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A C_ B <-> ( C +o A ) C_ ( C +o B ) ) ) $=
    ( con0 wcel w3a wn coa co wb oaord 3com12 notbid ontri1 3adant3 oacl ancoms
    wss 3adant2 3adant1 syl2anc 3bitr4d ) ADEZBDEZCDEZFZBAEZGZCBHIZCAHIZEZGZABR
    ZUJUIRZUFUGUKUDUCUEUGUKJBACKLMUCUDUMUHJUEABNOUFUJDEZUIDEZUNULJUCUEUOUDUEUCU
    OCAPQSUDUEUPUCUEUDUPCBPQTUJUINUAUB $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Weak ordering property of ordinal addition.  Proposition 8.7 of
       [TakeutiZaring] p. 59.  (Contributed by NM, 7-Dec-2004.) $)
    oawordri $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A C_ B -> ( A +o C ) C_ ( B +o C ) ) ) $=
      ( vx vy con0 wcel wss coa co wi cv c0 csuc wa wceq oveq2 sseq12d oa0 cvv
      adantr adantl biimpar wb word eloni syl ordsucsssuc syl2an anandirs oasuc
      oacl adantlr adantll bitr4d biimpd expcom wlim wral vex ciun ss2iun oalim
      adantrd syl5ibr mpanr1 tfinds3 exp4c com3l 3imp ) AFGZBFGZCFGZABHZACIJZBC
      IJZHZKZVMVKVLVRVMVKVLVNVQADLZIJZBVSIJZHZAMIJZBMIJZHZAELZIJZBWFIJZHZAWFNZI
      JZBWJIJZHZVQVKVLOZVNODECVSMPVTWCWAWDVSMAIQVSMBIQRVSWFPVTWGWAWHVSWFAIQVSWF
      BIQRVSWJPVTWKWAWLVSWJAIQVSWJBIQRVSCPVTVOWAVPVSCAIQVSCBIQRWNWEVNWNWCAWDBVK
      WCAPVLASUAVLWDBPVKBSUBRUCWFFGZWNWIWMKZVNWNWOWPWNWOOZWIWMWQWIWGNZWHNZHZWMV
      KVLWOWIWTUDZVKWOOZWGUEZWHUEZXAVLWOOZXBWGFGXCAWFULWGUFUGXEWHFGXDBWFULWHUFU
      GWGWHUHUIUJWQWKWRWLWSVKWOWKWRPVLAWFUKUMVLWOWLWSPVKBWFUKUNRUOUPUQVDVSURZWN
      WIEVSUSZWBKZVNWNXFXHWNVSTGZXFXHDUTXGWBWNXIXFOZOZEVSWGVAZEVSWHVAZHEVSWGWHV
      BXKVTXLWAXMVKXJVTXLPVLEAVSTVCUMVLXJWAXMPVKEBVSTVCUNRVEVFUQVDVGVHVIVJ $.
  $}

  $( An ordinal is less than its sum with a nonzero ordinal.  Theorem 18 of
     [Suppes] p. 209 and its converse.  (Contributed by NM, 6-Dec-2004.) $)
  oaord1 $p |- ( ( A e. On /\ B e. On ) ->
               ( (/) e. B <-> A e. ( A +o B ) ) ) $=
    ( con0 wcel c0 coa co wb wa 0elon oaord mp3an1 wceq oa0 adantl eleq1d bitrd
    ancoms ) BCDZACDZEBDZAABFGZDZHSTIZUAAEFGZUBDZUCECDSTUAUFHJEBAKLUDUEAUBTUEAM
    SANOPQR $.

  $( An ordinal is less than or equal to its sum with another.  Part of
     Exercise 5 of [TakeutiZaring] p. 62.  (For the other part see ~ oaord1 .)
     (Contributed by NM, 6-Dec-2004.) $)
  oaword1 $p |- ( ( A e. On /\ B e. On ) -> A C_ ( A +o B ) ) $=
    ( con0 wcel wa c0 coa co wceq oa0 adantr wss 0ss 0elon oaword 3com13 mp3an3
    wb mpbii eqsstr3d ) ACDZBCDZEZAAFGHZABGHZUAUDAIUBAJKUCFBLZUDUELZBMUAUBFCDZU
    FUGRZNUHUBUAUIFBAOPQST $.

  $( An ordinal is less than or equal to its sum with another.  Theorem 21 of
     [Suppes] p. 209.  (Contributed by NM, 7-Dec-2004.) $)
  oaword2 $p |- ( ( A e. On /\ B e. On ) -> A C_ ( B +o A ) ) $=
    ( con0 wcel coa co wss wa c0 0ss wi oawordri mp3an1 wceq oa0r adantl sseq1d
    0elon sylibd mpi ancoms ) BCDZACDZABAEFZGZUBUCHZIBGZUEBJUFUGIAEFZUDGZUEICDU
    BUCUGUIKRIBALMUFUHAUDUCUHANUBAOPQSTUA $.

  ${
    $d x y z A $.  $d x y z B $.  $d x z S $.
    oawordeulem.1 $e |- A e. On $.
    oawordeulem.2 $e |- B e. On $.
    oawordeulem.3 $e |- S = { y e. On | B C_ ( A +o y ) } $.
    $( Lemma for ~ oawordex .  (Contributed by NM, 11-Dec-2004.) $)
    oawordeulem $p |- ( A C_ B -> E! x e. On ( A +o x ) = B ) $=
      ( vz wss cv coa co wceq con0 wa wcel c0 oveq2 ax-mp wrex wi wral wreu wne
      cint crab ssrab2 eqsstri oaword2 sseq2d elrab2 mpbir2an ne0i oninton csuc
      mp2an cvv wlim w3o onzsl mpbi oa0 syl6eq biimprd oasuc mpan sylan9eqr vex
      sseq1d sucid eleq2 mpbiri oneli inteqi eleq2i onnminsb syl5bi oacl ontri1
      wn sylancr con2bid sylibrd mpcom word onordi ordsucss 3syl adantl eqsstrd
      wb rexlimiva a1d ciun oalim iunss onelssi syl mprgbir syl6eqss 3jaoi nfcv
      rspcev nfrab1 nfint nfov nfss onminsb oveq2i sseqtr4i jctir sylibr eqeq1d
      eqss eqtr3 oacan mp3an1 syl5ib rgen2a reu4 ) CDJZCAKZLMZDNZAOUAZYECBKZLMZ
      DNZPZYCYGNZUBZBOUCAOUCZPYEAOUDYBYFYMYBEUFZOQZCYNLMZDNZYFEOJERUEZYOEDYHJZB
      OUGZOHYSBOUHUIDEQZYRUUADOQZDCDLMZJZGUUBCOQZUUDGFDCUJUQZYSUUDBDOEYGDNYHUUC
      DYGDCLSUKZHULUMEDUNTEUOUQZYBYPDJZDYPJZPYQYBUUIUUJYNRNZYNIKZUPZNZIOUAZYNUR
      QYNUSPZUTZYBUUIUBZYOUUQUUHIYNVAVBUUKUURUUOUUPUUKUUIYBUUKYPCDUUKYPCRLMZCYN
      RCLSUUEUUSCNFCVCTVDVJVEUUOUUIYBUUNUUIIOUULOQZUUNPYPCUULLMZUPZDUUNUUTYPCUU
      MLMZUVBYNUUMCLSUUEUUTUVCUVBNFCUULVFVGVHUUNUVBDJZUUTUUNUULYNQZUVADQZUVDUUN
      UVEUULUUMQUULIVIVKYNUUMUULVLVMUUTUVEUVFYNUULUUHVNUUTUVEDUVAJZWAZUVFUVEUUL
      YTUFZQUUTUVHYNUVIUULEYTHVOZVPYSUVGBUULYGUULNYHUVADYGUULCLSUKVQVRUUTUVGUVF
      UUTUUBUVAOQZUVGUVFWAWLGUUEUUTUVKFCUULVSVGDUVAVTWBWCWDWEZDWFUVFUVDUBDGWGUV
      ADWHTWIWJWKWMWNUUPUUIYBUUPYPIYNUVAWOZDUUEUUPYPUVMNFICYNURWPVGUVMDJUVADJZI
      YNIYNUVADWQUVEUVFUVNUVLDUVAGWRWSWTXAWNXBTDCUVILMZYPYSBOUAZDUVOJZUUBUUDUVP
      GUUFYSUUDBDOUUGXDUQYSUVQBBDUVOBDXCBCUVILBCXCBLXCBYTYSBOXEXFXGXHYGUVINYHUV
      ODYGUVICLSUKXITYNUVICLUVJXJXKXLYPDXOXMYEYQAYNOYCYNNYDYPDYCYNCLSXNXDWBYLAB
      OYJYDYHNZYCOQZYGOQZPYKYDYHDXPUUEUVSUVTUVRYKWLFCYCYGXQXRXSXTXLYEYIABOYKYDY
      HDYCYGCLSXNYAXM $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Existence theorem for weak ordering of ordinal sum.  Proposition 8.8 of
       [TakeutiZaring] p. 59.  (Contributed by NM, 11-Dec-2004.) $)
    oawordeu $p |- ( ( ( A e. On /\ B e. On ) /\ A C_ B ) ->
                  E! x e. On ( A +o x ) = B ) $=
      ( vy con0 wcel wa wss cv coa co wceq wreu wi c0 cif reubidv imbi12d 0elon
      elimel sseq1 oveq1 eqeq1d sseq2 eqeq2 crab eqid oawordeulem dedth2h imp )
      BEFZCEFZGBCHZBAIZJKZCLZAEMZUKULUMUQNUKBOPZCHZURUNJKZCLZAEMZNURULCOPZHZUTV
      CLZAEMZNBCOOBURLZUMUSUQVBBURCUAVGUPVAAEVGUOUTCBURUNJUBUCQRCVCLZUSVDVBVFCV
      CURUDVHVAVEAECVCUTUEQRADURVCVCURDIJKHDEUFZBOESTCOESTVIUGUHUIUJ $.

    $( Existence theorem for weak ordering of ordinal sum.  (Contributed by NM,
       12-Dec-2004.) $)
    oawordexr $p |- ( ( A e. On /\ E. x e. On ( A +o x ) = B ) -> A C_ B ) $=
      ( con0 wcel cv coa co wceq wrex wss oaword1 sseq2 syl5ibcom rexlimdva imp
      wa ) BDEZBAFZGHZCIZADJBCKZRUAUBADRSDEQBTKUAUBBSLTCBMNOP $.

    $( Existence theorem for weak ordering of ordinal sum.  Proposition 8.8 of
       [TakeutiZaring] p. 59 and its converse.  See ~ oawordeu for uniqueness.
       (Contributed by NM, 12-Dec-2004.) $)
    oawordex $p |- ( ( A e. On /\ B e. On ) ->
                  ( A C_ B <-> E. x e. On ( A +o x ) = B ) ) $=
      ( con0 wcel wa wss cv co wceq wrex wreu oawordeu ex reurex syl6 oawordexr
      coa wi adantr impbid ) BDEZCDEZFZBCGZBAHRICJZADKZUDUEUFADLZUGUDUEUHABCMNU
      FADOPUBUGUESUCUBUGUEABCQNTUA $.

    $( Existence theorem for ordering of ordinal sum.  Similar to Proposition
       4.34(f) of [Mendelson] p. 266 and its converse.  (Contributed by NM,
       12-Dec-2004.) $)
    oaordex $p |- ( ( A e. On /\ B e. On ) ->
                  ( A e. B <-> E. x e. On ( (/) e. x /\ ( A +o x ) = B ) ) ) $=
      ( con0 wcel wa c0 cv coa co wceq wss onelss adantl oawordex sylibd oaord1
      wrex wi adantr eleq2 sylan9bb biimprcd exp4c com12 imp4b simpr jcad exp3a
      a1i reximdvai ex mpdd biimpd exp31 com34 imp4a rexlimdv impbid ) BDEZCDEZ
      FZBCEZGAHZEZBVDIJZCKZFZADRZVBVCVGADRZVIVBVCBCLZVJVAVCVKSUTCBMNABCOPUTVCVJ
      VISZSVAUTVCVLUTVCFZVGVHADVMVDDEZVGVHVMVNVGFZVEVGUTVCVNVGVEVCUTVNVGVESSVCU
      TVNVGVEUTVNFZVGFZVEVCVPVEBVFEVGVCBVDQVFCBUAUBZUCUDUEUFVOVGSVMVNVGUGUJUHUI
      UKULTUMUTVIVCSVAUTVHVCADUTVNVEVGVCUTVNVGVEVCUTVNVGVEVCSVQVEVCVRUNUOUPUQUR
      TUS $.
  $}

  $( An ordinal sum is zero iff both of its arguments are zero.  (Contributed
     by NM, 6-Dec-2004.) $)
  oa00 $p |- ( ( A e. On /\ B e. On ) ->
             ( ( A +o B ) = (/) <-> ( A = (/) /\ B = (/) ) ) ) $=
    ( con0 wcel wa coa co c0 wceq wne on0eln0 adantr oaword1 sseld sylbird ne0i
    wb syl6 necon4d 0elon adantl oaord mp3an1 ancoms bitr3d syl6bi oveq12 ax-mp
    jcad oa0 syl6eq impbid1 ) ACDZBCDZEZABFGZHIZAHIZBHIZEZUOUQURUSUOAHUPHUOAHJZ
    HUPDZUPHJZUOVAHADZVBUMVDVAQUNAKLUOAUPHABMNOUPHPRSUOBHUPHUOBHJZAHFGZUPDZVCUO
    HBDZVEVGUNVHVEQUMBKUAUNUMVHVGQZHCDZUNUMVITHBAUBUCUDUEUPVFPUFSUIUTUPHHFGZHAH
    BHFUGVJVKHITHUJUHUKUL $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( The ordinal sum with a limit ordinal is a limit ordinal.  Proposition
       8.11 of [TakeutiZaring] p. 60.  (Contributed by NM, 8-Dec-2004.) $)
    oalimcl $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) -> Lim ( A +o B ) ) $=
      ( vy vx con0 wcel wlim wa coa co c0 wceq csuc wn sylan2 wi mpd adantl wb
      word cv wrex limelon oacl eloni syl 0ellim n0i ad2antll oa00 simpr syl6bi
      wo con3d ciun vex sucid oalim eqeq1 syl5ib imp syl5eleq eliun sylib sylan
      onelon onnbtwn imnan sylibr com12 ad2antrl ordsucelsuc 3syl eleq2d bitr4d
      oasuc eleq1 bicomd sylan9bbr adantr sucelon jca oaord 3expa ancoms biimpd
      exp32 com4l imp32 mtod exp44 rexlimdv expcom nrexdv ioran sylanbrc dflim3
      pm2.01d ) AFGZBCGZBHZIZIZABJKZUAZXELMZXEDUBZNZMZDFUCZUNOZXEHXCWTBFGZXFBCU
      DZWTXMIZXEFGXFABUEXEUFUGPXDXGOZXKOXLXDBLMZOZXPXBXRWTXAXBLBGXRBUHBLUIUGUJX
      CWTXMXRXPQXNXOXGXQXOXGALMZXQIXQABUKXSXQULUMUOPRXDXJDFXDXJOZXHFGXDXJXJXDXT
      XJXDIZXHAEUBZJKZGZEBUCZXTYAXHEBYCUPZGYEYAXHXIYFXHDUQURXJXDXIYFMZXDXEYFMXJ
      YGEABCUSXEXIYFUTVAVBVCEXHBYCVDVEXDYEXTQXJXDYDXTEBWTXCYBBGZYDXTQQWTXCYHYDX
      TWTXCYHIZYDIIXJBYBNZGZYIYKOZWTYDYIYBFGZYLXCXMYHYMXNBYBVGVFZYHYMYLQXCYMYHY
      LYMYHYKIOYHYLQYBBVHYHYKVIVJVKSRVLWTYIYDXJYKQXJWTYIYDYKXJWTYIYDYKQXJWTYIIZ
      IZYDYKYPYDXEAYJJKZGZYKYOYDXIYQGZXJYRYIWTYMYDYSTYNWTYMIZYDXIYCNZGZYSYTYCFG
      YCUAYDUUBTAYBUEYCUFXHYCVMVNYTYQUUAXIAYBVQVOVPPXJYRYSXEXIYQVRVSVTYOYKYRTZX
      JYIWTUUCYIXMYJFGZIWTUUCYIXMUUDXCXMYHXNWAYIYMUUDYNYBWBVEWCXMUUDWTUUCBYJAWD
      WEVFWFSVPWGWHWIWJWKWLVBWMSRWNWSWAWOXGXKWPWQDXEWRWQ $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x C $.
    $( Ordinal addition is associative.  Theorem 25 of [Suppes] p. 211.
       (Contributed by NM, 10-Dec-2004.) $)
    oaass $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( ( A +o B ) +o C ) = ( A +o ( B +o C ) ) ) $=
      ( vy vz con0 wcel coa co wceq wa oveq2 oveq2d eqeq12d adantl cvv wss wrex
      c0 wi vx vw cv csuc oa0 syl eqtr4d suceq oasuc sylan sylan2 eqtrd anassrs
      oacl syl5ibr expcom wlim wral ciun vex oalim mpanr1 ancoms adantr oalimcl
      ovex limelon onelon ex adantld 0ellim onelss sseq2d sylibrd rspcev syl2an
      mpan expr adantrl adantrr wb oawordex ad2ant2l oaord 3expb eleq1 sylan9bb
      imp biimpar eqimss2 ad3antlr jca anasss reximdv2 sylbid wo word ordtri2or
      an32s eloni syl2anr exp45 imp32 simplrr exp32 com12 imp31 adantll adantlr
      mpjaod simpll ad2antlr oaword syl3anc rexbidva mpbid mpdd ralrimiv iunss2
      mpd exp4a oaordi anim1d eleq2d syl6 exp3a eliun 3imtr4g ssrdv eqssd an12s
      rexlimdv iuneq2 exp31 tfinds3 3impia ) AFGZBFGZCFGZABHIZCHIZABCHIZHIZJZYS
      YQYRKZUUDYTUAUCZHIZABUUFHIZHIZJZYTSHIZABSHIZHIZJYTDUCZHIZABUUNHIZHIZJZYTU
      UNUDZHIZABUUSHIZHIZJZUUDUUEUADCUUFSJZUUGUUKUUIUUMUUFSYTHLUVDUUHUULAHUUFSB
      HLMNUUFUUNJZUUGUUOUUIUUQUUFUUNYTHLUVEUUHUUPAHUUFUUNBHLMNUUFUUSJZUUGUUTUUI
      UVBUUFUUSYTHLUVFUUHUVAAHUUFUUSBHLMNUUFCJZUUGUUAUUIUUCUUFCYTHLUVGUUHUUBAHU
      UFCBHLMNUUEUUKYTUUMUUEYTFGZUUKYTJABUNZYTUEUFYRUUMYTJYQYRUULBAHBUEZMOUGUUE
      UUNFGZUURUVCTUURUVCUUEUVKKZUUOUDZUUQUDZJUUOUUQUHUVLUUTUVMUVBUVNUUEUVHUVKU
      UTUVMJUVIYTUUNUIUJYQYRUVKUVBUVNJYQYRUVKKZKUVBAUUPUDZHIZUVNUVOUVBUVQJYQUVO
      UVAUVPAHBUUNUIMOUVOYQUUPFGZUVQUVNJBUUNUNZAUUPUIUKULUMNUOUPUUFUQZUUEUURDUU
      FURZUUJUVTUUEKZUWAKZUUGDUUFUUOUSZUUIUWBUUGUWDJZUWAUUEUVTUWEUUEUVHUVTUWEUV
      IUVHUUFPGZUVTUWEUAUTZDYTUUFPVAVBUJVCVDUWCUUIDUUFUUQUSZUWDUWBUUIUWHJZUWAYQ
      UVTYRUWIYQUVTYRKZKZUUIEUUHAEUCZHIZUSZUWHUWJYQUUHUQZUUIUWNJZYRUVTUWOYRUWFU
      VTUWOUWGBUUFPVEVBVCYQUUHPGUWOUWPBUUFHVFEAUUHPVAVBUKUWKUWNUWHUWJYQUWNUWHQZ
      UWJYQKZUWMUUQQZDUUFRZEUUHURUWQUWRUWTEUUHUVTYRYQUWLUUHGZUWTTUVTYRYQUXAUWTU
      VTUUFFGZYRYQUXAKZUWTTZTUWFUVTUXBUWGUUFPVGVQZUVTUXBYRUXDUVTUXBYRKZKZUXCUWL
      FGZUWTUXFUXCUXHTUVTUXFUXAUXHYQUXFUUHFGZUXAUXHTYRUXBUXIBUUFUNVCUXIUXAUXHUU
      HUWLVHVIUFVJOUXGUXCUXHUWTUXGUXCUXHKZKZUWLUUPQZDUUFRZUWTUXGUXCUXHUXMUXGUXA
      UXHUXMTZYQUVTUXFUXAUXNTUVTUXFUXAUXHUXMUVTUXFUXAUXHKZKZKUWLBGZUXMBUWLQZUVT
      UXFUXQUXMTZUXOUVTYRUXSUXBUVTYRUXQUXMUVTSUUFGUWLUULQZUXMYRUXQKUUFVKYRUXQUX
      TYRUXQUWLBQUXTBUWLVLYRUULBUWLUVJVMVNWHUXLUXTDSUUFUUNSJUUPUULUWLUUNSBHLVMV
      OVPVRVSVTUXPUXRUXMTUVTUXPUXRUUPUWLJZDFRZUXMYRUXHUXRUYBWAUXBUXADBUWLWBWCUX
      FUXAUYBUXMTUXHUXFUXAKZUYAUXLDFUUFUVKUYAKZUYCUUNUUFGZUXLKZUYDUXFUXAUYFUYDU
      XFKZUXAKUYEUXLUYGUYEUXAUVKUXFUYAUYEUXAWAUVKUXFKUYEUUPUUHGZUYAUXAUVKUXBYRU
      YEUYHWAUUNUUFBWDWEUUPUWLUUHWFWGWSWIUYAUXLUVKUXFUXAUWLUUPWJWKWLWMUPWNVTWOO
      UXPUXQUXRWPZUVTYRUXHUYIUXBUXAUXHUWLWQBWQUYIYRUWLWTBWTUWLBWRXAWCOXJXBWHVJX
      CUXKUXLUWSDUUFUXKUYEKUXHUVRYQUXLUWSWAUXGUXCUXHUYEXDUXGUYEUVRUXJUXFUYEUVRU
      VTUXBYRUYEUVRYRUXBUYEUVRTYRUXBUYEUVRUXBUYEKYRUVKUVRUUFUUNVHUVSUKXEXFXGXHX
      IUXJYQUXGUYEYQUXAUXHXKXLUWLUUPAXMXNXOXPXEXQXEXTYAXGXREDUUHUUFUWMUUQXSUFVC
      UWJUWHUWNQZYQUVTUXBYRUYJUXEUXFUBUWHUWNUXFUBUCZUUQGZDUUFRUYKUWMGZEUUHRZUYK
      UWHGUYKUWNGUXFUYLUYNDUUFUXFUYEUYLUYNUXFUYEUYLKUYHUYLKUYNUXFUYEUYHUYLUUNUU
      FBYBYCUYMUYLEUUPUUHUWLUUPJUWMUUQUYKUWLUUPAHLYDVOYEYFYLDUYKUUFUUQYGEUYKUUH
      UWMYGYHYIUJOYJULYKVDUWAUWDUWHJUWBDUUFUUOUUQYMOUGUGYNYOXFYP $.
  $}

  ${
    $d x y z w A $.  $d x y z B $.
    $( Recursive definition of ordinal addition.  Exercise 25 of [Enderton]
       p. 240.  (Contributed by NM, 26-Dec-2004.)  (Revised by Mario Carneiro,
       30-May-2015.) $)
    oarec $p |- ( ( A e. On /\ B e. On ) ->
                ( A +o B ) = ( A u. ran ( x e. B |-> ( A +o x ) ) ) ) $=
      ( vw vy wcel coa co cv cmpt crn wceq c0 oveq2 mpteq1 syl6eq rneqd wa wrex
      cun vz con0 csuc rn0 uneq2d eqeq12d oa0 un0 syl6eqr wi csn uneq1 unass wo
      mpt0 rexun df-suc rexeqi cvv wb vex eqid elrnmpt ax-mp elsn eqeq2d bitr4i
      rexsn orbi12i 3bitr4i ovex elrnmpti elun eqriv uneq2i eqtr4i oasuc eqeq1d
      syl5ibr expcom wlim wral ciun oalim mpanr1 ancoms adantr iuneq2 iunun wne
      adantl 0ellim ne0i iunconst 3syl cuni limuni rexeqdv df-rex rexbii eluni2
      wex bitri anbi1i r19.41v exbii rexcom4 eliun 3bitr4g eqrdv uneq12d syl5eq
      syl6rbbr ad2antrr 3eqtrd exp31 tfinds3 impcom ) CUBFBUBFZBCGHZBACBAIZGHZJ
      ZKZTZLZBUAIZGHZBAYGYBJZKZTZLZBMGHZBMTZLBDIZGHZBAYOYBJZKZTZLZBYOUCZGHZBAUU
      AYBJZKZTZLZYFXSUADCYGMLZYHYMYKYNYGMBGNUUGYJMBUUGYJMKMUUGYIMUUGYIAMYBJMAYG
      MYBOAYBUOPQUDPUEUFYGYOLZYHYPYKYSYGYOBGNUUHYJYRBUUHYIYQAYGYOYBOQUEUFYGUUAL
      ZYHUUBYKUUEYGUUABGNUUIYJUUDBUUIYIUUCAYGUUAYBOQUEUFYGCLZYHXTYKYEYGCBGNUUJY
      JYDBUUJYIYCAYGCYBOQUEUFXSYMBYNBUGBUHUIXSYOUBFZYTUUFUJYTUUFXSUUKRZYPYPUKZT
      ZUUELYTUUNYSUUMTZUUEYPYSUUMULUUOBYRUUMTZTUUEBYRUUMUMUUDUUPBEUUDUUPEIZYBLZ
      AUUASZUUQYRFZUUQUUMFZUNZUUQUUDFUUQUUPFUURAYOYOUKZTZSUURAYOSZUURAUVCSZUNUU
      SUVBUURAYOUVCUPUURAUUAUVDYOUQURUUTUVEUVAUVFUUQUSFUUTUVEUTEVAAYOYBUUQYQUSY
      QVBVCVDZUVAUUQYPLZUVFEYPVEUURUVHAYODVAYAYOLYBYPUUQYAYOBGNVFVHVGVIVJAUUAYB
      UUQUUCUUCVBBYAGVKZVLUUQYRUUMVMVJVNVOVPPUULUUBUUNUUEUULUUBYPUCUUNBYOVQYPUQ
      PVRVSVTYGWAZXSYTDYGWBZYLUVJXSRZUVKRYHDYGYPWCZDYGYSWCZYKUVLYHUVMLZUVKXSUVJ
      UVOXSYGUSFUVJUVOUAVADBYGUSWDWEWFWGUVKUVMUVNLUVLDYGYPYSWHWKUVJUVNYKLXSUVKU
      VJUVNDYGBWCZDYGYRWCZTYKDYGBYRWIUVJUVPBUVQYJUVJMYGFYGMWJUVPBLYGWLYGMWMDYGB
      WNWOUVJEUVQYJUVJUUTDYGSZUURAYGSZUUQUVQFUUQYJFUVJUVSUURAYGWPZSZUVRUVJUURAY
      GUVTYGWQWRUVRYAYOFZUURRZAXBZDYGSZUWAUUTUWDDYGUUTUVEUWDUVGUURAYOWSXCWTYAUV
      TFZUURRZAXBUWCDYGSZAXBUWAUWEUWGUWHAUWGUWBDYGSZUURRUWHUWFUWIUURDYAYGXAXDUW
      BUURDYGXEVGXFUURAUVTWSUWCDAYGXGVJVGXMDUUQYGYRXHAYGYBUUQYIYIVBUVIVLXIXJXKX
      LXNXOXPXQXR $.
  $}

  ${
    $d x y A $.
    $( Left addition by a constant is a bijection from ordinals to ordinals
       greater than the constant.  (Contributed by Mario Carneiro,
       30-May-2015.) $)
    oaf1o $p |- ( A e. On ->
        ( x e. On |-> ( A +o x ) ) : On -1-1-onto-> ( On \ A ) ) $=
      ( vy con0 wcel cv coa co cdif wral wceq wa wss wn ontri1 syldan ralrimiva
      wreu wb adantl cmpt wf1o oacl oaword1 mpbid eldifd eldifi eldifn oawordeu
      simpl mpbird syl21anc eqcom reubii sylib eqid f1ompt sylanbrc ) BDEZBAFZG
      HZDBIZEZADJCFZVAKZADRZCVBJDVBADVAUAZUBUSVCADUSUTDEZLZVADBBUTUCZVIBVAMZVAB
      ENZBUTUDUSVHVADEVKVLSVJBVAOPUEUFQUSVFCVBUSVDVBEZLZVAVDKZADRZVFVNUSVDDEZBV
      DMZVPUSVMUJVMVQUSVDDBUGTZVNVRVDBENZVMVTUSVDDBUHTUSVMVQVRVTSVSBVDOPUKABVDU
      IULVOVEADVAVDUMUNUOQACDVBVAVGVGUPUQUR $.
  $}

  ${
    $d x A $.  $d x B $.
    oacomf1olem.1 $e |- F = ( x e. A |-> ( B +o x ) ) $.
    $( Lemma for ~ oacomf1o .  (Contributed by Mario Carneiro, 30-May-2015.) $)
    oacomf1olem $p |- ( ( A e. On /\ B e. On ) ->
      ( F : A -1-1-onto-> ran F /\ ( ran F i^i B ) = (/) ) ) $=
      ( con0 wcel wa crn wf1o cin c0 wceq cdif wf1 cv cmpt wss syl wb coa oaf1o
      cres adantl f1of1 onss adantr f1ssres syl2anc syl6eqr f1eq1 mpbid f1f1orn
      co resmpt wf f1f frn 3syl difss2d reldisj mpbird jca ) BFGZCFGZHZBDIZDJZV
      GCKLMZVFBFCNZDOZVHVFBVJAFCAPUAUNZQZBUCZOZVKVFFVJVMOZBFRZVOVFFVJVMJZVPVEVR
      VDACUBUDFVJVMUESVDVQVEBUFUGZFVJBVMUHUIVFVNDMVOVKTVFVNABVLQZDVFVQVNVTMVSAF
      BVLUOSEUJBVJVNDUKSULZBVJDUMSVFVIVGVJRZVFVKBVJDUPWBWABVJDUQBVJDURUSZVFVGFR
      VIWBTVFVGFCWCUTVGCFVASVBVC $.
  $}

  ${
    $d x A $.  $d x B $.
    oacomf1o.1 $e |- F = ( ( x e. A |-> ( B +o x ) ) u.
      `' ( x e. B |-> ( A +o x ) ) ) $.
    $( Define a bijection from ` A +o B ` to ` B +o A ` .  Thus, the two are
       equinumerous even if they are not equal (which sometimes occurs, e.g.
       ~ oancom ).  (Contributed by Mario Carneiro, 30-May-2015.) $)
    oacomf1o $p |- ( ( A e. On /\ B e. On ) ->
      F : ( A +o B ) -1-1-onto-> ( B +o A ) ) $=
      ( con0 wcel wa coa co wf1o cmpt crn cun cin c0 wceq eqid syl wb cv simpld
      oacomf1olem ancoms f1ocnv incom simprd syl5eq f1oun syl22anc f1oeq1 ax-mp
      ccnv sylibr oarec f1oeq2 mpbird uncom syl6eq f1oeq3 ) BFGZCFGZHZBCIJZCBIJ
      ZDKZVDABCAUAZIJLZMZCNZDKZVCVKBACBVGIJLZMZNZVJDKZVCVNVJVHVLUMZNZKZVOVCBVIV
      HKZVMCVPKZBVMOZPQVICOPQZVRVCVSWBABCVHVHRUCZUBVCCVMVLKZVTVCWDVMBOZPQZVBVAW
      DWFHACBVLVLRUCUDZUBCVMVLUESVCWAWEPBVMUFVCWDWFWGUGUHVCVSWBWCUGBVIVMCVHVPUI
      UJDVQQVOVRTEVNVJDVQUKULUNVCVDVNQVKVOTABCUOVDVNVJDUPSUQVCVEVJQVFVKTVCVECVI
      NZVJVBVAVEWHQACBUOUDCVIURUSVEVJVDDUTSUQ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Ordering property of ordinal multiplication.  Half of Proposition 8.19
       of [TakeutiZaring] p. 63.  (Contributed by NM, 14-Dec-2004.) $)
    omordi $p |- ( ( ( B e. On /\ C e. On ) /\ (/) e. C ) ->
                 ( A e. B -> ( C .o A ) e. ( C .o B ) ) ) $=
      ( vx vy con0 wcel c0 comu co wi wa wceq eleq2 oveq2 eleq2d imbi12d biimpa
      sylan adantr onelon ex cv csuc noel pm2.21i a1i coa elsuci omcl simpl jca
      wo oaword1 sseld imim2d imp adantrl oaord1 eleq1d syl5ibrcom adantrr jaod
      syl5 wb omsuc sylibrd exp43 com12 adantld imp3a wlim wral wss id ad2ant2r
      limsuc ssiun2s syl adantll cvv vex omlim mpanr1 sseqtr4d anabss1 eleqtrrd
      ciun sseldd exp53 com13 imp4c a1dd tfinds3 com23 exp4a com34 com24 imp31
      mpdd ) BFGZCFGZHCGZABGZCAIJZCBIJZGZKZXAXDXCXBXGXAXDXBXCXGXAXDAFGZXBXCXGKZ
      KXAXDXIBAUAUBXAXDXIXBXJXAXDXIXBLZXCXGXAXKXCLZXDXGADUCZGZXECXMIJZGZKZAHGZX
      ECHIJZGZKZAEUCZGZXECYBIJZGZKZAYBUDZGZXECYGIJZGZKZXHXLDEBXMHMZXNXRXPXTXMHA
      NYLXOXSXEXMHCIOPQXMYBMZXNYCXPYEXMYBANYMXOYDXEXMYBCIOPQXMYGMZXNYHXPYJXMYGA
      NYNXOYIXEXMYGCIOPQXMBMZXNXDXPXGXMBANYOXOXFXEXMBCIOPQYAXLXRXTAUEUFUGYBFGZX
      KXCYFYKKZYPXBXCYQKZXIXBYPYRXBYPXCYFYKXBYPLZXCYFLZLZYHXEYDCUHJZGZYJYHYCAYB
      MZUMZUUAUUCAYBUIYSYDFGZXBLZYTUUEUUCKYSUUFXBCYBUJXBYPUKULUUGYTLYCUUCUUDUUG
      YFYCUUCKZXCUUGYFUUHUUGYEUUCYCUUGYDUUBXEYDCUNUOUPUQURUUGXCUUDUUCKYFUUGXCLU
      UCUUDYDUUBGZUUGXCUUIYDCUSRUUDXEYDUUBAYBCIOUTVAVBVCSVDYSYJUUCVEYTYSYIUUBXE
      CYBVFPTVGVHVIVJVKXMVLZXLXQYFEXMVMUUJXIXBXCXQXBXIUUJXCXQKXBXIUUJXCXNXPXBXI
      LZUUJXCLLZXNLCAUDZIJZXOXEUULXBUUJLZXNUUNXOVNXBUUJUUOXIXCUUOVOVPUUOXNLUUNE
      XMYDWHZXOUUJXNUUNUUPVNZXBUUJXNLUUMXMGZUUQUUJXNUURXMAVQREXMYDUUMUUNYBUUMCI
      OVRVSVTUUOXOUUPMZXNXBXMWAGUUJUUSDWBECXMWAWCWDTWESUULXEUUNGZXNUUKXCUUTUUJU
      UKXCLXEXECUHJZUUNUUKXCXEUVAGZXBXIXCUVBVEZUUKXEFGXBUVCCAUJXECUSSWFRUUKUUNU
      VAMXCCAVFTWGURTWIWJWKWLWMWNWOWPWPWTWQWRWS $.
  $}

  $( Ordering property of ordinal multiplication.  (Contributed by NM,
     25-Dec-2004.) $)
  omord2 $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. C ) ->
               ( A e. B <-> ( C .o A ) e. ( C .o B ) ) ) $=
    ( con0 wcel wa comu co wi omordi wceq wo wn omcl word ordtri2 syl2an adantr
    wb eloni w3a 3adantl1 oveq2 a1i 3adantl2 orim12d con3d anandis ancoms 3impa
    c0 3adant3 3imtr4d impbid ) ADEZBDEZCDEZUAZUKCEZFZABEZCAGHZCBGHZEZUPUQUSVAV
    DIUOABCJUBUTVBVCKZVCVBEZLZMZABKZBAEZLZMZVDVAUTVKVGUTVIVEVJVFVIVEIUTABCGUCUD
    UOUQUSVJVFIUPBACJUEUFUGURVDVHSZUSUOUPUQVMUQUOUPFVMUQUOUPVMUQUOFVBDEZVCDEZVM
    UQUPFCANCBNVNVBOVCOVMVOVBTVCTVBVCPQQUHUIUJRURVAVLSZUSUOUPVPUQUOAOBOVPUPATBT
    ABPQULRUMUN $.

  $( Ordering property of ordinal multiplication.  Proposition 8.19 of
     [TakeutiZaring] p. 63.  (Contributed by NM, 14-Dec-2004.) $)
  omord $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
               ( ( A e. B /\ (/) e. C ) <-> ( C .o A ) e. ( C .o B ) ) ) $=
    ( con0 wcel w3a c0 wa comu co wb omord2 ex pm5.32rd simpl wi ne0i wceq om0r
    wne eqeq1d syl5ibrcom necon3d adantr on0eln0 adantl sylibrd 3adant1 impbid2
    oveq1 syl5 ancld bitrd ) ADEZBDEZCDEZFZABEZGCEZHCAIJZCBIJZEZUSHZVBUQUSURVBU
    QUSURVBKABCLMNUQVCVBVBUSOUQVBUSUOUPVBUSPUNUOUPHVBCGTZUSUOVBVDPUPVBVAGTUOVDV
    AUTQUOCGVAGUOVAGRCGRZGBIJZGRBSVEVAVFGCGBIUJUAUBUCUKUDUPUSVDKUOCUEUFUGUHULUI
    UM $.

  $( Left cancellation law for ordinal multiplication.  Proposition 8.20 of
     [TakeutiZaring] p. 63 and its converse.  (Contributed by NM,
     14-Dec-2004.) $)
  omcan $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. A ) ->
                   ( ( A .o B ) = ( A .o C ) <-> B = C ) ) $=
    ( con0 wcel wa comu co wceq wo wn wi omordi ex ancoms imp word omcl eloni
    wb w3a c0 3adant2 3adant3 orim12d syl ordtri3 syl2an 3impdi 3adant1 3imtr4d
    con3d adantr oveq2 impbid1 ) ADEZBDEZCDEZUAZUBAEZFZABGHZACGHZIZBCIZVAVBVCEZ
    VCVBEZJZKZBCEZCBEZJZKZVDVEVAVLVHVAVJVFVKVGUSUTVJVFLZUPURUTVNLZUQURUPVOURUPF
    UTVNBCAMNOUCPUSUTVKVGLZUPUQUTVPLZURUQUPVQUQUPFUTVPCBAMNOUDPUEULUSVDVITZUTUP
    UQURVRUPUQFZVBQZVCQZVRUPURFZVSVBDEVTABRVBSUFWBVCDEWAACRVCSUFVBVCUGUHUIUMUSV
    EVMTZUTUQURWCUPUQBQCQWCURBSCSBCUGUHUJUMUKBCAGUNUO $.

  $( Weak ordering property of ordinal multiplication.  (Contributed by NM,
     21-Dec-2004.) $)
  omword $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. C ) ->
                   ( A C_ B <-> ( C .o A ) C_ ( C .o B ) ) ) $=
    ( con0 wcel w3a c0 wa wceq wo co wss omord2 wb 3anrot omcan onsseleq adantr
    comu omcl sylanbr bicomd orbi12d 3adant3 anim12dan ancoms 3impa syl 3bitr4d
    ) ADEZBDEZCDEZFZGCEZHZABEZABIZJZCASKZCBSKZEZUSUTIZJZABLZUSUTLZUOUPVAUQVBABC
    MUOVBUQUMULUJUKFUNVBUQNULUJUKOCABPUAUBUCUMVDURNZUNUJUKVFULABQUDRUMVEVCNZUNU
    MUSDEZUTDEZHZVGUJUKULVJULUJUKHVJULUJVHUKVICATCBTUEUFUGUSUTQUHRUI $.

  $( Weak ordering property of ordinal multiplication.  (Contributed by NM,
     21-Dec-2004.) $)
  omwordi $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                   ( A C_ B -> ( C .o A ) C_ ( C .o B ) ) ) $=
    ( con0 wcel w3a c0 wss comu co wi wa omword biimpd ex wn wceq sseq12d oveq1
    om0r wb word ord0eln0 necon2bbid syl 3ad2ant3 ssid adantr adantl syl5ibrcom
    eloni mpbiri 3adant3 sylbird a1dd pm2.61d ) ADEZBDEZCDEZFZGCEZABHZCAIJZCBIJ
    ZHZKZUTVAVFUTVALVBVEABCMNOUTVAPZVEVBUTVGCGQZVEUSUQVHVGUAZURUSCUBZVICUKVJVAC
    GCUCUDUEUFUQURVHVEKUSUQURLZVEVHGAIJZGBIJZHZVKVNGGHGUGVKVLGVMGUQVLGQURATUHUR
    VMGQUQBTUIRULVHVCVLVDVMCGAISCGBISRUJUMUNUOUP $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Weak ordering property of ordinal multiplication.  Proposition 8.21 of
       [TakeutiZaring] p. 63.  (Contributed by NM, 20-Dec-2004.) $)
    omwordri $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
        ( A C_ B -> ( A .o C ) C_ ( B .o C ) ) ) $=
      ( vx vy con0 wcel wss comu co wi wa cv c0 wceq oveq2 sseq12d coa omcl cvv
      csuc om0 0ss syl6eqss ad2antrr w3a 3adant2 3adant1 simp1 oawordri syl3anc
      imp adantrl wb oaword syld3an3 biimpa adantrr sstrd adantr 3sstr4d exp520
      omsuc com3r imp4c wlim wral vex ciun ss2iun omlim adantl syl5ibr anandirs
      ad2ant2rl mpanr1 expcom adantrd tfinds3 exp3a 3impib 3coml ) CFGZAFGZBFGZ
      ABHZACIJZBCIJZHZKZWCWDWEWJWCWDWELZWFWIADMZIJZBWLIJZHZANIJZBNIJZHZAEMZIJZB
      WSIJZHZAWSUAZIJZBXCIJZHZWIWKWFLDECWLNOWMWPWNWQWLNAIPWLNBIPQWLWSOWMWTWNXAW
      LWSAIPWLWSBIPQWLXCOWMXDWNXEWLXCAIPWLXCBIPQWLCOWMWGWNWHWLCAIPWLCBIPQWDWRWE
      WFWDWPNWQAUBWQUCUDUEWSFGZWDWEWFXBXFKZWDWEXGWFXHKWDWEXGWFXBXFWDWEXGUFZWFXB
      LZLZWTARJZXABRJZXDXEXKXLXAARJZXMXIXBXLXNHZWFXIXBXOXIWTFGZXAFGZWDXBXOKWDXG
      XPWEAWSSUGWEXGXQWDBWSSUHZWDWEXGUIWTXAAUJUKULUMXIWFXNXMHZXBXIWFXSWDWEXGXQW
      FXSUNXRABXAUOUPUQURUSXIXDXLOZXJWDXGXTWEAWSVCUGUTXIXEXMOZXJWEXGYAWDBWSVCUH
      UTVAVBVDVEWLVFZWKXBEWLVGZWOKZWFWKYBYDWKWLTGZYBYDDVHWDWEYEYBLZYDYCWOWDYFLZ
      WEYFLZLZEWLWTVIZEWLXAVIZHEWLWTXAVJYIWMYJWNYKWDYFWMYJOYFWEEAWLTVKVOYHWNYKO
      YGEBWLTVKVLQVMVNVPVQVRVSVTWAWB $.
  $}

  $( An ordinal is less than or equal to its product with another.
     (Contributed by NM, 21-Dec-2004.) $)
  omword1 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. B ) ->
                 A C_ ( A .o B ) ) $=
    ( con0 wcel wa c0 comu co wss c1o wb word eloni ordgt0ge1 syl adantl wi 1on
    omwordi mp3an1 ancoms wceq om1 adantr sseq1d sylibd sylbid imp ) ACDZBCDZEZ
    FBDZAABGHZIZUKULJBIZUNUJULUOKZUIUJBLUPBMBNOPUKUOAJGHZUMIZUNUJUIUOURQZJCDUJU
    IUSRJBASTUAUKUQAUMUIUQAUBUJAUCUDUEUFUGUH $.

  $( An ordinal is less than or equal to its product with another.
     (Contributed by NM, 21-Dec-2004.) $)
  omword2 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. B ) ->
                 A C_ ( B .o A ) ) $=
    ( con0 wcel wa c0 c1o comu co wceq om1r ad2antrr wss eloni ordgt0ge1 biimpa
    word sylan adantll wi 1on omwordri mp3an1 ancoms adantr mpd eqsstr3d ) ACDZ
    BCDZEZFBDZEZAGAHIZBAHIZUHUMAJUIUKAKLULGBMZUMUNMZUIUKUOUHUIBQZUKUOBNUQUKUOBO
    PRSUJUOUPTZUKUIUHURGCDUIUHURUAGBAUBUCUDUEUFUG $.

  $( The product of two ordinal numbers is zero iff at least one of them is
     zero.  Proposition 8.22 of [TakeutiZaring] p. 64.  (Contributed by NM,
     21-Dec-2004.) $)
  om00 $p |- ( ( A e. On /\ B e. On ) -> ( ( A .o B ) = (/) <->
              ( A = (/) \/ B = (/) ) ) ) $=
    ( con0 wcel wa comu co c0 wceq c1o wss wne wi word wb eloni ordge1n0 adantr
    adantl ex wo wn neanior syl biimprd on0eln0 omword1 sylbird anim12d syl5bir
    sstr syl6 omcl 3syl sylibd necon4bd oveq1 om0r sylan9eqr oveq2 jaod impbid
    om0 ) ACDZBCDZEZABFGZHIZAHIZBHIZUAZVFVKVGHVFVKUBZJVGKZVGHLZVLAHLZBHLZEZVFVM
    AHBHUCVFVQJAKZAVGKZEVMVFVOVRVPVSVDVOVRMVEVDVRVOVDANVRVOOAPAQUDUERVFVPHBDZVS
    VEVTVPOVDBUFSVFVTVSABUGTUHUIJAVGUKULUJVFVGCDVGNVMVNOABUMVGPVGQUNUOUPVFVIVHV
    JVEVIVHMVDVEVIVHVIVEVGHBFGHAHBFUQBURUSTSVDVJVHMVEVDVJVHVJVDVGAHFGHBHAFUTAVC
    USTRVAVB $.

  $( The product of two nonzero ordinal numbers is nonzero.  (Contributed by
     NM, 28-Dec-2004.) $)
  om00el $p |- ( ( A e. On /\ B e. On ) -> ( (/) e. ( A .o B ) <->
              ( (/) e. A /\ (/) e. B ) ) ) $=
    ( con0 wcel wa comu co c0 wne wceq wo om00 necon3abid omcl on0eln0 bi2anan9
    wn wb syl neanior syl6bb 3bitr4d ) ACDZBCDZEZABFGZHIZAHJBHJKZQZHUFDZHADZHBD
    ZEZUEUHUFHABLMUEUFCDUJUGRABNUFOSUEUMAHIZBHIZEUIUCUKUNUDULUOAOBOPAHBHTUAUB
    $.

  ${
    $d x y z w v A $.  $d x y z w v B $.  $d x y C $.
    $( Ordering involving the product of a limit ordinal.  Proposition 8.23 of
       [TakeutiZaring] p. 64.  (Contributed by NM, 25-Dec-2004.) $)
    omordlim $p |- ( ( ( A e. On /\ ( B e. D /\ Lim B ) ) /\ C e. ( A .o B ) )
                -> E. x e. B C e. ( A .o x ) ) $=
      ( con0 wcel wlim wa comu co cv wrex ciun omlim eleq2d eliun syl6bb biimpa
      ) BFGCEGCHIIZDBCJKZGZDBALJKZGACMZTUBDACUCNZGUDTUAUEDABCEOPADCUCQRS $.

    $( The product of any nonzero ordinal with a limit ordinal is a limit
       ordinal.  Proposition 8.24 of [TakeutiZaring] p. 64.  (Contributed by
       NM, 25-Dec-2004.) $)
    omlimcl $p |- ( ( ( A e. On /\ ( B e. C /\ Lim B ) ) /\ (/) e. A ) ->
                  Lim ( A .o B ) ) $=
      ( vy vx con0 wcel wa c0 comu co word wceq wn syl adantr wb sylan wi c1o
      wlim cv csuc wrex wo limelon omcl sylan2 0ellim n0i anim12ci adantll om00
      eloni notbid ioran syl6bb mpbird ciun vex sucid omlim eqeq1 biimpac eliun
      syl5eleq sylib adantlr onelon onnbtwn imnan sylibr com12 adantl mpd simpl
      jca anim2i anassrs coa ordsucelsuc oa1suc eleq2d bitr4d wss ordgt0ge1 1on
      oaword mp3an1 syldan bitrd biimpa omsuc sseqtr4d sseld eleq1 biimprd syl9
      com23 adantlrl sucelon w3a omord syl6bir syl3an2b 3comr 3expb syl6d an32s
      sylbid imp mtod exp31 rexlimdv pm2.01da nrexdv sylanbrc dflim3 ) AFGZBCGZ
      BUAZHZHZIAGZHZABJKZLZYFIMZYFDUBZUCZMZDFUDZUENZYFUAYCYGYDYBXSBFGZYGBCUFZXS
      YNHZYFFGYGABUGYFUNOUHPYEYHNZYLNYMYEYQAIMZNZBIMZNZHZYBYDUUBXSYAYDUUBXTYAUU
      AYDYSYAIBGUUABUIBIUJOAIUJUKULULYCYQUUBQZYDYBXSYNUUCYOYPYQYRYTUEZNUUBYPYHU
      UDABUMUOYRYTUPUQUHPURYEYKDFYEYKNZYIFGYEYKYEYKHYIAEUBZJKZGZEBUDZUUEYCYKUUI
      YDYCYKHZYIEBUUGUSZGUUIUUJYIYJUUKYIDUTVAYCYFUUKMZYKYJUUKMZEABCVBYKUULUUMYF
      YJUUKVCVDRVFEYIBUUGVEVGVHYEUUIUUESYKYEUUHUUEEBYEUUFBGZUUHUUEYEUUNHZUUHHYK
      BUUFUCZGZUUOUUQNZUUHYCUUNUURYDYBUUNUURXSYBUUNHZUUFFGZUURYBYNUUNUUTYOBUUFV
      IZRUUNUUTUURSYBUUTUUNUURUUTUUNUUQHNUUNUURSUUFBVJUUNUUQVKVLVMVNVOULVHPUUOU
      UHYKUUQSZYCUUNYDUUHUVBSZYCUUNHXSYNUUTHZHZYDUVCXSYBUUNUVEUUSUVDXSYBYNUUNUV
      DYOYNUUNHYNUUTYNUUNVPUVAVQRVRVSUVEYDHUUHYKYFAUUPJKZGZUUQXSUUTYDUUHYKUVGSS
      YNXSUUTHZYDHZYKUUHUVGUVIUUHYJUVFGZYKUVGUVIUUHYJUUGTVTKZGZUVJUVHUUHUVLQZYD
      UVHUUGFGZUVMAUUFUGZUVNUUHYJUUGUCZGZUVLUVNUUGLUUHUVQQUUGUNYIUUGWAOUVNUVKUV
      PYJUUGWBWCWDOPUVIUVKUVFYJUVIUVKUUGAVTKZUVFUVHYDUVKUVRWEZUVHYDTAWEZUVSXSYD
      UVTQZUUTXSALUWAAUNAWFOPXSUUTUVNUVTUVSQZUVOTFGXSUVNUWBWGTAUUGWHWIWJWKWLUVH
      UVFUVRMYDAUUFWMPWNWOXJYKUVGUVJYFYJUVFWPWQWRWSWTUVEUVGUUQSZYDXSYNUUTUWCYNU
      UTXSUWCUUTYNUUPFGZXSUWCUUFXAYNUWDXSXBUVGUUQYDHUUQBUUPAXCUUQYDVPXDXEXFXGPX
      HRXIXKXLXMXNPVOXOPXPYHYLUPXQDYFXRXQ $.

    $( Distributive law for ordinal arithmetic.  Proposition 8.25 of
       [TakeutiZaring] p. 64.  (Contributed by NM, 26-Dec-2004.) $)
    odi $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( A .o ( B +o C ) ) = ( ( A .o B ) +o ( A .o C ) ) ) $=
      ( vz vw vv con0 wcel coa co comu wceq c0 wa oveq2 oveq2d syl wi cvv wss
      vx vy cv csuc eqeq12d omcl oa0 om0 adantr adantl 3eqtr4rd w3a oveq1 oasuc
      3adant1 oacl omsuc sylan2 3impb eqtrd 3adant2 oaass syl3an1 syl3an2 exp4b
      3exp pm2.43a com4r pm2.43i 3imp syl5ibr com3r imp3a wlim wral vex limelon
      eqtr4d mpan om0r oveqan12d 0elon ax-mp syl6req ancoms exp3a imp a1dd ciun
      oveq12d wo wn wb simplr onelon sylan ontri1 oawordex bitr3d syl2anc oaord
      wrex 3expb eleq1 sylan9bb iba an32s biimpcd reximdvai sylbid orrd sylanl1
      exp4c adantlrl adantlr 0ellim om00el biimprd imp31 adantlrr omordi onelss
      sylan2i a1d sseq2d sylibrd syld adantll jcad rspcev adantrr mpd ralrimiva
      syl6 iunss2 mpanr1 oaordi an12s anim2i ovex ancom1s adantrd rspccv syl5ib
      eqeq1 eqimss2 imim2i ad2antll rexlimdvw jaod omordlim word limord ordelon
      ex rspccva eleq2d adantrl eqssd oalimcl omlim ad2antlr jctl omlimcl jctil
      rexlimdva oalim 3eqtr4d exp43 com3l oe0lem com12 tfinds3 exp3acom3r ) AGH
      ZBGHZCGHZABCIJZKJZABKJZACKJZIJZLZUVQUVOUVPUWCABUAUCZIJZKJZUVTAUWDKJZIJZLZ
      ABMIJZKJZUVTAMKJZIJZLABUBUCZIJZKJZUVTAUWNKJZIJZLZABUWNUDZIJZKJZUVTAUWTKJZ
      IJZLZUWCUVOUVPNZUAUBCUWDMLZUWFUWKUWHUWMUXGUWEUWJAKUWDMBIOPUXGUWGUWLUVTIUW
      DMAKOPUEUWDUWNLZUWFUWPUWHUWRUXHUWEUWOAKUWDUWNBIOPUXHUWGUWQUVTIUWDUWNAKOPU
      EUWDUWTLZUWFUXBUWHUXDUXIUWEUXAAKUWDUWTBIOPUXIUWGUXCUVTIUWDUWTAKOPUEUWDCLZ
      UWFUVSUWHUWBUXJUWEUVRAKUWDCBIOPUXJUWGUWAUVTIUWDCAKOPUEUXFUVTMIJZUVTUWMUWK
      UXFUVTGHZUXKUVTLABUFZUVTUGZQUXFUWLMUVTIUVOUWLMLUVPAUHUIPUXFUWJBAKUVPUWJBL
      UVOBUGUJPUKUWNGHZUVOUVPUWSUXERZUVOUVPUXOUXPUVOUVPUXOUXPUWSUXEUVOUVPUXOULZ
      UWPAIJZUWRAIJZLUWPUWRAIUMUXQUXBUXRUXDUXSUXQUXBAUWOUDZKJZUXRUXQUXAUXTAKUVP
      UXOUXAUXTLUVOBUWNUNUOPUVOUVPUXOUYAUXRLZUVPUXONUVOUWOGHUYBBUWNUPAUWOUQURUS
      UTUXQUXDUVTUWQAIJZIJZUXSUXQUXCUYCUVTIUVOUXOUXCUYCLUVPAUWNUQVAPUVOUVPUXOUX
      SUYDLZUVOUVPUXOUYERRUVOUVPUXOUVOUYEUVPUVOUXOUVOUYERZRUVOUVPUVOUXOUYFUXFUV
      OUXONZUVOUYEUYGUXFUWQGHZUVOUYEAUWNUFUXFUXLUYHUVOUYEUXMUVTUWQAVBVCVDVFVEVG
      VHVIVJVRUEVKVFVLVMUXFUWDVNZUWSUBUWDVOZUWIRZUVPUYIUYKRZAUVPAMLZNUYIUWIUYJU
      VPUYMUYIUWIRUYMUYIUVPUWIUYMUYIUVPUWIUYIUVPNZUWIUYMMUWEKJZMBKJZMUWDKJZIJZL
      ZUVPUYIUYSUYIUVPUWDGHZUYSUWDSHZUYIUYTUAVPZUWDSVQVSZUVPUYTNZUYOMUYRVUDUWEG
      HZUYOMLBUWDUPZUWEVTQVUDUYRMMIJZMUVPUYTUYPMUYQMIBVTUWDVTWAMGHVUGMLWBMUGWCW
      DUTURWEUYMUWFUYOUWHUYRAMUWEKUMUYMUVTUYPUWGUYQIAMBKUMAMUWDKUMWJUEVKWFVLWGW
      HUXFMAHZUYLUYIUXFVUHUYKUYIUXFVUHUYJUWIUYIUXFNZVUHUYJNZNZDUWEADUCZKJZWIZEU
      WGUVTEUCZIJZWIZUWFUWHVUKVUNVUQVUKVUMVUPTZEUWGXBZDUWEVOVUNVUQTVUKVUSDUWEVU
      KVULUWEHZNVULBHZFUCZUWDHZBVVBIJZVULLZNZFGXBZWKZVUSVUIVUTVVHVUJUYIUVPVUTVV
      HUVOUYIUYTUVPVUTVVHVUCUYTUVPNZVUTNZVVAVVGVVJVVAWLZVVEFGXBZVVGVVJUVPVULGHZ
      VVKVVLWMUYTUVPVUTWNVVIVUEVUTVVMUVPUYTVUEVUFWEUWEVULWOWPUVPVVMNBVULTVVKVVL
      BVULWQFBVULWRWSWTVVJVVEVVFFGVVIVUTVVBGHZVVEVVFRRVUTVVNVVEVVIVVFVUTVVNVVEV
      VIVVFVVNVVENVVINVUTVVFVVNVVIVVEVUTVVFWMVVNVVINZVVENVVCVUTVVFVVOVVCVVDUWEH
      ZVVEVUTVVNUYTUVPVVCVVPWMVVBUWDBXAXCVVDVULUWEXDXEVVEVVCVVFWMVVOVVEVVCXFUJW
      SXGXHXMVHWGXIXJXKXLXNXOVUKVVHVUSRVUTVUKVVAVUSVVGVUIVUHVVAVUSRUYJVUIVUHNZV
      VAMUWGHZVUMUXKTZNVUSVVQVVAVVRVVSUYIUVOVUHVVAVVRRUVPUYIUVONZVUHNZVVRVVAUYI
      UVOVUHVVRUVOUYIVUHVVRRUVOUYIVUHUYIVVRUVOUYIVUHUYIVVRUYIUVOUYTVUHUYINVVRRV
      UCUYIUVOUYTNZVUHMUWDHZVVRUWDXPVWBVVRVUHVWCNAUWDXQXRYCURVEVHVGXSYDXTUXFVUH
      VVAVVSRUYIUXFVUHNVVAVUMUVTHZVVSUVPUVOVUHVVAVWDRVULBAYAUUAUXFVWDVVSRZVUHUX
      FUXLVWEUXMUXLVWDVUMUVTTVVSUVTVUMYBUXLUXKUVTVUMUXNYEYFQUIYGYHYIVURVVSEMUWG
      VUOMLVUPUXKVUMVUOMUVTIOYEYJYNYKUYIUVOVUJVVGVUSRUVPVVTVUJNZVVFVUSFGVWFVVFA
      VVBKJZUWGHZVUMUVTVWGIJZTZNVUSVWFVVFVWHVWJVVTVUHVVFVWHRUYJVWAVVCVWHVVEUYIU
      YTUVOVUHVVCVWHRVUCVVBUWDAYAXLUUBYKUYJVVFVWJRZVVTVUHUYJVVCAVVDKJZVWILZRZVW
      KUWSVWMUBVVBUWDUWNVVBLZUWPVWLUWRVWIVWOUWOVVDAKUWNVVBBIOPVWOUWQVWGUVTIUWNV
      VBAKOPUEZUUCVWNVVCVVEVWJVWMVVEVWJRVVCVWMVVEVWIVUMLZVWJVVEVWLVUMLVWMVWQVVD
      VULAKOVWLVWIVUMUUEUUDVUMVWIUUFYNUUGVMQUUHYIVURVWJEVWGUWGVUOVWGLVUPVWIVUMV
      UOVWGUVTIOYEYJYNUUIXTUUJUIYLYMDEUWEUWGVUMVUPYOQVUIUYJVUQVUNTZVUHVUIUYJNZV
      UPVUMTZDUWEXBZEUWGVOVWRVWSVXAEUWGVWSVUOUWGHZNVUOVWGHZFUWDXBZVXAVUIVXBVXDU
      YJUYIUVOVXBVXDUVPVVTVXBVXDUVOUYIVXBVXDRZUVOVUAUYIVXEVUBUVOVUAUYINZNZVXBVX
      DFAUWDVUOSUUKUUOYPWEWGXTXOVWSVXDVXARVXBVWSVXCVXAFUWDVWSVVCNZVXCVVPVUPVWLT
      ZNVXAVXHVXCVVPVXIVUIVVCVXCVVPRUYJVUIVVCNZVVPVXCUYIUVPVVCVVPUVOUYNVVCVVPUY
      IUYTUVPVVCVVPRVUCVVBUWDBYQWPWGXNYDXOVXHVXCVUPVWLHZVXIVXHVXCVUPVWIHZVXKVUI
      VVCVXCVXLRZUYJUYIVVCUXFVXMUYIVVCNZVVNUXFVXMUYIUWDUULVVCVVNUWDUUMUWDVVBUUN
      WPZVVNUXFNVWGGHZUXLVXMVVNUVOVXPUVPUVOVVNVXPAVVBUFWEYKUXFUXLVVNUXMUJVUOVWG
      UVTYQWTWPXGXOUYJVVCVXKVXLWMVUIUYJVVCNVWLVWIVUPUWSVWMUBVVBUWDVWPUUPUUQYHYF
      VUIVVCVXKVXIRZUYJVXJVWLGHZVXQUYIVVCUXFVXRVXNVVNUXFVXRVXOUVOVVNUVPVXRVVNUV
      PNUVOVVDGHZVXRUVPVVNVXSBVVBUPWEAVVDUFURYRWPXGVWLVUPYBQXOYGYIVWTVXIDVVDUWE
      VULVVDLVUMVWLVUPVULVVDAKOYEYJYNUVFUIYLYMEDUWGUWEVUPVUMYOQUURUUSVUIUWFVUNL
      ZVUJVUIUVOUWEVNZNZVXTUVOUYIUVPVYBUYNVYAUVOUVPUYIVYAUVPVUAUYIVYAVUBBUWDSUU
      TYPWEYSYRUVOUWESHVYAVXTBUWDIYTDAUWESUVAYPQUIVUIVUHUWHVUQLZUYJVVQUXLUWGSHZ
      UWGVNZNVYCUXFUXLUYIVUHUXMUVBVVQVYEVYDUYIUVOVUHVYEUVPVVTVXGVUHVYEUVOUYIVXG
      UYIVXFUVOUYIVUAVUBUVCYSWEAUWDSUVDWPXTAUWDKYTUVEEUVTUWGSUVGWTYKUVHUVIUVJWG
      UVKUVLUVMUVNVJ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( Multiplication of ordinal numbers is associative.  Theorem 8.26 of
       [TakeutiZaring] p. 65.  (Contributed by NM, 28-Dec-2004.) $)
    omass $p |- ( ( A e. On /\ B e. On /\ C e. On ) ->
                 ( ( A .o B ) .o C ) = ( A .o ( B .o C ) ) ) $=
      ( vy vz con0 wcel comu co wceq c0 wa oveq2 oveq2d eqeq12d sylan9eqr sylan
      wi cvv wss vx cv csuc omcl om0 syl eqtr4d w3a coa oveq1 omsuc 3adant1 odi
      3impa syl3an2 3exp exp3a com34 pm2.43d 3imp eqtrd syl5ibr com3r wlim wral
      imp3a ciun ancoms vex omlim mpanr1 an32s ad2antrr iuneq2 wrex mpan anim1i
      limelon omordi ssid sseq2d rspcev mpan2 syl6 iunss2 adantlr sylan2 onelon
      ralrimiv omordlim ad2antlr onelss 3ad2ant2 omwordi syld exp4d imp32 com23
      ex imp reximdvai exp31 imp4c mpcom ralrimiva adantr eqssd omlimcl mpanlr1
      syl5 ovex wn wb eloni ord0eln0 necon2bbid oveq1d anassrs sylan9eq adantll
      word om0r sylbird a1dd pm2.61d com3l tfinds3 ) AFGZBFGZCFGZABHIZCHIZABCHI
      ZHIZJZYJYHYIYOYJYHYIYOYKUAUBZHIZABYPHIZHIZJZYKKHIZABKHIZHIZJYKDUBZHIZABUU
      DHIZHIZJZYKUUDUCZHIZABUUIHIZHIZJZYOYHYILZUADCYPKJZYQUUAYSUUCYPKYKHMUUOYRU
      UBAHYPKBHMNOYPUUDJZYQUUEYSUUGYPUUDYKHMUUPYRUUFAHYPUUDBHMNOYPUUIJZYQUUJYSU
      ULYPUUIYKHMUUQYRUUKAHYPUUIBHMNOYPCJZYQYLYSYNYPCYKHMUURYRYMAHYPCBHMNOUUNUU
      AKUUCUUNYKFGZUUAKJABUDZYKUEUFYIYHUUCAKHIZKYIUUBKAHBUENAUEZPUGUUDFGZYHYIUU
      HUUMRZYHYIUVCUVDYHYIUVCUVDUUHUUMYHYIUVCUHZUUEYKUIIZUUGYKUIIZJUUEUUGYKUIUJ
      UVEUUJUVFUULUVGYHYIUVCUUJUVFJZUUNUUSUVCUVHUUTYKUUDUKQUNUVEUULAUUFBUIIZHIZ
      UVGUVEUUKUVIAHYIUVCUUKUVIJYHBUUDUKULNYHYIUVCUVJUVGJZYHYIUVCUVKRYHYIUVCYIU
      VKYHYIUVCYIUVKRYHYIUVCLZYIUVKUVLYHUUFFGZYIUVKBUUDUDZAUUFBUMUOUPUQURUSUTVA
      OVBUPVCVFYPVDZYHYIUUHDYPVEZYTRZYIUVOYHUVQYIUVOYHUVQYIUVOLZYHLZKBGZUVQUVSU
      VTUVPYTUVSUVTLZUVPLYQDYPUUEVGZYSUVSYQUWBJZUVTUVPYIYHUVOUWCYIYHLUUSUVOUWCY
      HYIUUSUUTVHUUSYPSGZUVOUWCUAVIZDYKYPSVJVKQVLVMUVPUWAUWBDYPUUGVGZYSDYPUUEUU
      GVNUWAUWFEYRAEUBZHIZVGZYSUWAUWFUWIUVRUVTUWFUWITZYHUVRUVTLZUUGUWHTZEYRVOZD
      YPVEUWJUWKUWMDYPUWKUUDYPGZUUFYRGZUWMUVRYPFGZYILZUVTUWNUWORUVOYIUWQUVOUWPY
      IUWDUVOUWPUWEYPSVRVPZVQVHUUDYPBVSQUWOUUGUUGTZUWMUUGVTUWLUWSEUUFYRUWGUUFJU
      WHUUGUUGUWGUUFAHMWAWBWCWDWIDEYPYRUUGUWHWEUFWFUVSUWIUWFTZUVTUVSUWHUUGTZDYP
      VOZEYRVEUWTUVSUXBEYRUWGFGZUVSUWGYRGZLUXBUVRUXDUXCYHUVRYRFGZUXDUXCUVOYIUWP
      UXEUWRBYPUDWGYRUWGWHQWFUXCUVRYHUXDUXBUXCUVRYHUXDUXBRUXCUVRLZYHLZUXDUWGUUF
      GZDYPVOZUXBUVRUXDUXIRZUXCYHYIUWDUVOUXJUWEYIUWDUVOLLUXDUXIDBYPUWGSWJWSVKWK
      UXGUXHUXADYPUXFYHUWNUXHUXARZRUXFUWNYHUXKUXCYIUVOUWNYHUXKRZRUXCYIUVOUWNUXL
      YIUVOUWNLZLUVMUXCUXLUXMYIUVCUVMUVOUWPUWNUVCUWRYPUUDWHQUVNWGUXCUVMYHUXKUXC
      UVMYHUHUXHUWGUUFTZUXAUVMUXCUXHUXNRYHUUFUWGWLWMUWGUUFAWNWOUPXJWPWQWRWTXAWO
      XBXCXDXEEDYRYPUWHUUGWEUFXFXGUVRUVTYHYSUWIJZYHUWKUXOUWKYHYRVDZUXOYIUWDUVOU
      VTUXPUWEBYPSXHXIYHYRSGUXPUXOBYPHXKEAYRSVJVKWGVHVLUGPVAXBUVSUVTXLZYTUVPUVS
      UXQBKJZYTYIUXRUXQXMZUVOYHYIBYAZUXSBXNUXTUVTBKBXOXPUFVMUVOYHUXRYTRZYIUVOUW
      PYHUYAUWRUWPYHLZUXRYTUYBUXRLYQKYSUWPYHUXRYQKJYHUXRLZUWPYQKYPHIZKUYCYKKYPH
      UXRYHYKUVAKBKAHMUVBPXQYPYBZPXRUWPUXRYHYSKJUWPUXRLZYHYSUVAKUYFYRKAHUXRUWPY
      RUYDKBKYPHUJUYEPNUVBXSVLUGWSQXTYCYDYEXBYFVFYGUQYFUT $.
  $}

  $( If an ordinal number is even, its successor is odd.  (Contributed by NM,
     26-Jan-2006.) $)
  oneo $p |- ( ( A e. On /\ B e. On /\ C = ( 2o .o A ) ) ->
              -. suc C = ( 2o .o B ) ) $=
    ( con0 wcel c2o comu co wceq csuc wa wb sucid mpbii 2on mp3an3 c1o coa mpan
    omord wn onnbtwn 3ad2ant1 suceq eqeq1d 3ad2ant3 wi ovex eleq2 simpl syl6bir
    w3a syl5 simpr omcl oa1suc syl 1on elexi df-2o eleqtrri oaord mp3an12 omsuc
    eleqtrrd eqeltrrd ad2antrr suceloni sylan2 ancoms adantr mpbird simpld jcad
    c0 ex 3adant3 sylbid mtod ) ADEZBDEZCFAGHZIZULZCJZFBGHZIZABEZBAJZEZKZVTWAWK
    UAWCABUBUCWDWGWBJZWFIZWKWCVTWGWMLWAWCWEWLWFCWBUDUEUFVTWAWMWKUGWCVTWAKZWMWHW
    JWMWBWFEZWNWHWMWBWLEWOWBFAGUHMWLWFWBUINWNWOWHVOFEZKZWHVTWAFDEZWQWOLOABFTPWH
    WPUJUKUMWNWMWJWNWMKZWJWPWSWJWPKZWFFWIGHZEZWSWLWFXAWNWMUNVTWLXAEWAWMVTWBQRHZ
    WLXAVTWBDEZXCWLIWRVTXDOFAUOSZWBUPUQVTXCWBFRHZXAVTQFEZXCXFEZQQJFQQDURUSMUTVA
    VTXDXGXHLZXEQDEWRXDXIUROQFWBVBVCUQNWRVTXAXFIOFAVDSVEVFVGVFWNWTXBLZWMWAVTXJV
    TWAWIDEZXJAVHWAXKWRXJOBWIFTPVIVJVKVLVMVPVNVQVRVS $.

  ${
    $d A w x z $.  $d A x y z $.  $d B w x z $.  $d B x y z $.
    $( Lemma for ~ omeu : existence part.  (Contributed by Mario Carneiro,
       28-Feb-2013.) $)
    omeulem1 $p |- ( ( A e. On /\ B e. On /\ A =/= (/) ) ->
      E. x e. On E. y e. A ( ( A .o x ) +o y ) = B ) $=
      ( vz vw con0 wcel c0 w3a cv csuc comu co wrex wceq eleq2d syl2anc wa wi
      wne coa simp2 sucelon sylib simp1 on0eln0 biimpar 3adant2 syl21anc sucidg
      wss omword2 ssel syl5 sylc suceq oveq2d rspcev wral weq onminex wlim word
      w3o vex elon ordzsl bitri noel oveq2 om0x syl6eq mtbiri simp3 raleq sucid
      wn a1i notbid rspcv ax-mp syl6bi 3expia rexlimdvw ralnex ciun simpr simpl
      cvv omlim syl12anc wel limord 3ad2ant1 sylibr onelon suceloni syl sssucid
      eliun omwordi mpi syl3anc sseld reximdvai syl5bi sylbid expimpd 3ad2antl1
      con3d com12 3jaod impr wb simpl1 simprr omcl simpl2 ontri1 oawordex mpbid
      mpbird simp3r simp21 simp11 simp23 omsuc eleqtrd eqeltrd simp3l oaord jca
      3adantr1 reximdv2 mpd expcom com13 ) CGHZDGHZCIUAZJZDCAKZLZMNZHZAGOZCUUCM
      NZBKZUBNZDPZBCOZAGOZUUBYTDCDLZMNZHZUUGYSYTUUAUCZUUBUUNUUOULZYTUUPUUBUUNGH
      ZYSICHZUURUUBYTUUSUUQDUDUEYSYTUUAUFYSUUAUUTYTYSUUTUUACUGUHUIUUNCUMUJUUQYT
      DUUNHUURUUPDGUKUUNUUODUNUOUPUUFUUPADGUUCDPZUUEUUODUVAUUDUUNCMUUCDUQURQUSR
      UUGUUFDCEKZLZMNZHZVRZEUUCUTZSZAGOUUBUUMUUFUVEAEAEVAZUUEUVDDUVIUUDUVCCMUUC
      UVBUQURQVBUUBUVHUULAGUVHUUCGHZUUBUULUUFUVGUVJUUBUULTUUBUUFUVGUVJJZUULUUBU
      VKSZUUKBGOZUULUUBUVGUVJUVMUUFUUBUVGUVJSZSZUUHDULZUVMUVOUVPDUUHHZVRZUUBUVG
      UVJUVRUVJUUCIPZUUCFKZLZPZFGOZUUCVCZVEZUUBUVGSZUVRUVJUUCVDZUWEUUCAVFZVGZFU
      UCVHVIUWFUVSUVRUWCUWDUVSUVRTUWFUVSUVQDIHDVJUVSUUHIDUVSUUHCIMNIUUCICMVKCVL
      VMQVNVSUWFUWBUVRFGUUBUVGUWBUVRUUBUVGUWBJZUWBDCUWAMNZHZVRZUVRUUBUVGUWBVOZU
      WJUWBUVGUWMUWNUUBUVGUWBUCUWBUVGUVFEUWAUTZUWMUVFEUUCUWAVPUVTUWAHUWOUWMTUVT
      FVFVQUVFUWMEUVTUWAEFVAZUVEUWLUWPUVDUWKDUWPUVCUWACMUVBUVTUQURQVTWAWBWCUPUW
      BUVRUWMUWBUVQUWLUWBUUHUWKDUUCUWACMVKQVTUHRWDWEYSYTUVGUWDUVRTUUAUWDYSUVGSU
      VRUWDYSUVGUVRUVGUVEEUUCOZVRUWDYSSZUVRUVEEUUCWFUWRUVQUWQUWRUVQDEUUCCUVBMNZ
      WGZHZUWQUWRUUHUWTDUWRYSUUCWJHZUWDUUHUWTPUWDYSWHUXBUWRUWHVSUWDYSWIECUUCWJW
      KWLQUXADUWSHZEUUCOUWRUWQEDUUCUWSXAUWRUXCUVEEUUCUWDYSEAWMZUXCUVETUWDYSUXDJ
      ZUWSUVDDUXEUVBGHZUVCGHZYSUWSUVDULZUXEUVJUXDUXFUXEUWGUVJUWDYSUWGUXDUUCWNWO
      UWIWPUWDYSUXDVOUUCUVBWQRZUXEUXFUXGUXIUVBWRWSUWDYSUXDUCUXFUXGYSJUVBUVCULUX
      HUVBWTUVBUVCCXBXCXDXEWDXFXGXHXKXGXIXLXJXMXGXNUVOUUHGHZYTUVPUVRXOUVOYSUVJU
      XJYSYTUUAUVNXPUUBUVGUVJXQCUUCXRZRZYSYTUUAUVNXSZUUHDXTRYCUVOUXJYTUVPUVMXOU
      XLUXMBUUHDYARYBYNUVLUUKUUKBGCUUBUVKUUIGHZUUKSZUUICHZUUKSUUBUVKUXOJZUXPUUK
      UXQUXPUUJUUHCUBNZHZUXQUUJDUXRUUBUVKUXNUUKYDZUXQDUUEUXRUUBUUFUVGUVJUXOYEUX
      QYSUVJUUEUXRPYSYTUUAUVKUXOYFZUUBUUFUVGUVJUXOYGZCUUCYHRYIYJUXQUXNYSUXJUXPU
      XSXOUUBUVKUXNUUKYKUYAUXQYSUVJUXJUYAUYBUXKRUUICUUHYLXDYCUXTYMWDYOYPYQWDYRX
      FUOYP $.
  $}

  $( Lemma for ~ omeu : uniqueness part.  (Contributed by Mario Carneiro,
     28-Feb-2013.)  (Revised by Mario Carneiro, 29-May-2015.) $)
  omeulem2 $p |- ( ( ( A e. On /\ A =/= (/) ) /\
      ( B e. On /\ C e. A ) /\ ( D e. On /\ E e. A ) ) ->
    ( ( B e. D \/ ( B = D /\ C e. E ) ) ->
      ( ( A .o B ) +o C ) e. ( ( A .o D ) +o E ) ) ) $=
    ( con0 wcel c0 wa w3a comu co coa wceq wss wi wb syl syl31anc syl2anc eloni
    csuc word simp3l ordsucss 3syl simp2l suceloni simp1l simp1r on0eln0 mpbird
    wne omword sylibd omcl simp3r onelon oaword1 sstr expcom syld simp2r biimpa
    oaord omsuc eleqtrrd simpr syl5ib oveq2 oveq1d adantr eleq2d mpbidi syl3anc
    ssel ee21 jaod ) AFGZAHUMZIZBFGZCAGZIZDFGZEAGZIZJZBDGZABKLZCMLZADKLZEMLZGZB
    DNZCEGZIZWHWIABUBZKLZWMOZWKWSGWNWHWIWSWLOZWTWHWIWRDOZXAWHWEDUCWIXBPWAWDWEWF
    UDZDUABDUEUFWHWRFGZWEVSHAGZXBXAQWHWBXDWAWBWCWGUGZBUHRXCVSVTWDWGUIZWHXEVTVSV
    TWDWGUJWHVSXEVTQXGAUKRULWRDAUNSUOWHWLFGZEFGZXAWTPZWHVSWEXHXGXCADUPTWHVSWFXI
    XGWAWDWEWFUQAEURTZXHXIIWLWMOZXJWLEUSXAXLWTWSWLWMUTVARTVBWHWKWJAMLZWSWHCFGZV
    SWJFGZWCWKXMGZWHVSWCXNXGWAWBWCWGVCZACURTZXGWHVSWBXOXGXFABUPTZXQXNVSXOJWCXPC
    AWJVEVDSWHVSWBWSXMNXGXFABVFTVGWSWMWKVPVQWHXNXIXOWQWNPXRXKXSWQWKWJEMLZGZWNXN
    XIXOJZWQWPYBYAWOWPVHCEWJVEVIWQXTWMWKWOXTWMNWPWOWJWLEMBDAKVJVKVLVMVNVOVR $.

  $( An ordered pair-like theorem for ordinal multiplication.  (Contributed by
     Mario Carneiro, 29-May-2015.) $)
  omopth2 $p |- ( ( ( A e. On /\ A =/= (/) ) /\
      ( B e. On /\ C e. A ) /\ ( D e. On /\ E e. A ) ) ->
    ( ( ( A .o B ) +o C ) = ( ( A .o D ) +o E ) <-> ( B = D /\ C = E ) ) ) $=
    ( con0 wcel wa comu coa wceq w3o word eloni syl syl2anc syl5 mtod pm2.21d
    co wne w3a simpl2l simpl3l ordtri3or simpr simpl1l omcl simpl3r onelon oacl
    c0 wn ordirr 3syl eqneltrd wo orc omeulem2 adantr neleqtrrd simpl1r simpl2r
    wi idd syl222anc 3jaod mpd olc mpand eqcomd jca ex oveq2 oveqan12d impbid1
    id ) AFGZAULUAZHZBFGZCAGZHZDFGZEAGZHZUBZABITZCJTZADITZEJTZKZBDKZCEKZHZWGWLW
    OWGWLHZWMWNWPBDGZWMDBGZLZWMWPBMZDMZWSWPWAWTWAWBVTWFWLUCZBNOWPWDXAWDWEVTWCWL
    UDZDNOBDUEPWPWQWMWMWRWPWQWMWPWQWIWKGZWPWIWKWKWGWLUFZWPWKFGZWKMWKWKGUMWPWJFG
    ZEFGZXFWPVRWDXGVRVSWCWFWLUGZXCADUHPWPVRWEXHXIWDWEVTWCWLUIZAEUJZPWJEUKPWKNWK
    UNUOZUPZWQWQWMCEGZHZUQZWPXDWQXOURWGXPXDVDWLABCDEUSUTZQRSWPWMVEWPWRWMWPWRWKW
    IGZWPWIWKWKXLXEVAZWRWRDBKZECGZHZUQZWPXRWRYBURWPVRVSWDWEWAWBYCXRVDXIVRVSWCWF
    WLVBXCXJXBWAWBVTWFWLVCZADEBCUSVFZQRSVGVHZWPXNWNYALZWNWPCMZEMZYGWPVRWBYHXIYD
    VRWBHCFGYHACUJCNOPWPVRWEYIXIXJVRWEHXHYIXKENOPCEUEPWPXNWNWNYAWPXNWNWPXNXDXMW
    PWMXNXDYFXOXPWPXDXOWQVIXQQVJRSWPWNVEWPYAWNWPYAXRXSWPXTYAXRWPBDYFVKYBYCWPXRY
    BWRVIYEQVJRSVGVHVLVMWMWNWHWJCEJBDAIVNWNVQVOVP $.

  ${
    $d A r s t x y z $.  $d B r s t x y z $.
    $( The division algorithm for ordinal multiplication.  (Contributed by
       Mario Carneiro, 28-Feb-2013.) $)
    omeu $p |- ( ( A e. On /\ B e. On /\ A =/= (/) ) ->
        E! z E. x e. On E. y e. A
          ( z = <. x , y >. /\ ( ( A .o x ) +o y ) = B ) ) $=
      ( vt vr vs con0 wcel cv cop wceq comu co coa wa wrex wex wi omeulem1 opex
      wne w3a wal weu isseti 19.41v mpbiran rexbii rexcom4 bitr3i bitri simp2rl
      c0 sylib simp3rl simp2rr simp3rr eqtr4d wb simp11 simp2ll simp2lr simp3ll
      simp13 simp3lr omopth2 syl222anc mpbid opeq12 syl exp4b rexlimdvv expimpd
      3expia exp3a imp alrimivv opeq1 eqeq2d oveq2 oveq1d eqeq1d opeq2 cbvrex2v
      anbi12d eqeq1 anbi1d 2rexbidv syl5bb eu4 sylanbrc ) DIJZEIJZDUOUCZUDZCKZA
      KZBKZLZMZDWSNOZWTPOZEMZQZBDRZAIRZCSZXHFKZGKZHKZLZMZDXKNOZXLPOZEMZQZHDRGIR
      ZQWRXJMZTZFUECUEXHCUFWQXEBDRZAIRZXIABDEUAYCXGCSZAIRXIYBYDAIYBXFCSZBDRYDYE
      XEBDYEXBCSXECXAWSWTUBUGXBXECUHUIUJXFBCDUKULUJXGACIUKUMUPWQYACFWQXHXSXTWQX
      HQXRXTGHIDWQXHXKIJZXLDJZQZXRXTTTZWQXFYIABIDWQWSIJZWTDJZQZXFYIWQYLXFQZYHXR
      XTWQYMYHXRQZXTWQYMYNUDZWRXAXJXBXEYLWQYNUNYOXJXMXAXNXQYHWQYMUQYOWSXKMZWTXL
      MZQZXAXMMYOXDXPMZYRYOXDEXPXBXEYLWQYNURXNXQYHWQYMUSUTYOWNWPYJYKYFYGYSYRVAW
      NWOWPYMYNVBWNWOWPYMYNVFYJYKXFWQYNVCYJYKXFWQYNVDYFYGXRWQYMVEYFYGXRWQYMVGDW
      SWTXKXLVHVIVJWSWTXKXLVKVLUTUTVPVMVQVNVRVNVOVSXHXSCFXHWRXMMZXQQZHDRGIRXTXS
      XFUUAWRXKWTLZMZXOWTPOZEMZQABGHIDYPXBUUCXEUUEYPXAUUBWRWSXKWTVTWAYPXDUUDEYP
      XCXOWTPWSXKDNWBWCWDWGYQUUCYTUUEXQYQUUBXMWRWTXLXKWEWAYQUUDXPEWTXLXOPWBWDWG
      WFXTUUAXRGHIDXTYTXNXQWRXJXMWHWIWJWKWLWM $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Ordinal exponentiation with a nonzero mantissa is nonzero.  Proposition
       8.32 of [TakeutiZaring] p. 67.  (Contributed by NM, 4-Jan-2005.) $)
    oen0 $p |- ( ( ( A e. On /\ B e. On ) /\ (/) e. A ) ->
               (/) e. ( A ^o B ) ) $=
      ( vx vy con0 wcel c0 coe co wi cv wa wceq oveq2 eleq2d c1o adantr wss cvv
      wb csuc 0lt1o oe0 syl5eleqr comu simpl oecl omordi eleq1d ad2antlr sylibd
      jca om0 sylan oesuc sylibrd exp31 com12 com34 imp3a wlim wral ciun 0ellim
      eqimss2 syl sseq2d rspcev syl2an ssiun adantrr oelim mpanlr1 anasss an12s
      wrex vex sseqtr4d word limelon mpan ancoms eloni ordgt0ge1 3syl mpbird ex
      a1dd tfinds3 exp3a imp31 ) AEFZBEFZGAFZGABHIZFZWMWLWNWPJWMWLWNWPGACKZHIZF
      ZGAGHIZFZGADKZHIZFZGAXBUAZHIZFZWPWLWNLZCDBWQGMWRWTGWQGAHNOWQXBMWRXCGWQXBA
      HNOWQXEMWRXFGWQXEAHNOWQBMWRWOGWQBAHNOWLXAWNWLGPWTUBAUCZUDQXBEFZWLWNXDXGJX
      JWLXDWNXGWLXJXDWNXGJZJWLXJXDXKWLXJLZXDLWNGXCAUEIZFZXGXLWLXCEFZLZXDWNXNJXL
      WLXOWLXJUFAXBUGULXPXDLWNXCGUEIZXMFZXNGAXCUHXOXRXNTWLXDXOXQGXMXCUMUIUJUKUN
      XLXGXNTXDXLXFXMGAXBUOOQUPUQURUSUTWQVAZXHWSXDDWQVBXSXHWSXSXHLZWSPWRRZXTPDW
      QXCVCZWRXSWLPYBRZWNXSWLLZPXCRZDWQVPZYCXSGWQFPWTRZYFWLWQVDWLWTPMYGXIPWTVEV
      FYEYGDGWQXBGMXCWTPXBGAHNVGVHVIDWQXCPVJVFVKWLXSWNWRYBMZWLXSWNYHWLWQSFZXSWN
      YHCVQZDAWQSVLVMVNVOVRXSWLWSYATZWNYDWREFZWRVSYKXSWQEFZWLYLYIXSYMYJWQSVTWAW
      LYMYLAWQUGWBUNWRWCWRWDWEVKWFWGWHWIWJURWK $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Ordering law for ordinal exponentiation.  Proposition 8.33 of
       [TakeutiZaring] p. 67.  (Contributed by NM, 5-Jan-2005.)  (Revised by
       Mario Carneiro, 24-May-2015.) $)
    oeordi $p |- ( ( B e. On /\ C e. ( On \ 2o ) ) ->
                 ( A e. B -> ( C ^o A ) e. ( C ^o B ) ) ) $=
      ( vy con0 wcel coe co wi wceq oveq2 eleq2d imbi2d wa comu adantr syl21anc
      c1o syl cvv vx c2o cdif cv csuc eldifi oecl sylan ondif2 simprbi c0 simpr
      om1 dif20el oen0 omordi mpd eqeltrrd oesuc eleqtrrd expcom suceloni ontr1
      syl2an mpan2d a2d wral wlim bi2.04 ralbii r19.21v ciun limsuc biimpa elex
      bitri sucexb sucidg sylbir eleq2 imbi12d rspcv anc2li rspcev eliun sylibr
      mpid wrex syl6 adantl simpl vex oelim mpanlr1 adantlr sylibrd ex tfindsg2
      syl5bi impancom ) BEFABFCEUBUCFZCAGHZCBGHZFZXAXBCUAUDZGHZFZIZXAXBCAUEZGHZ
      FZIXAXBCDUDZGHZFZIZXAXBCXLUEZGHZFZIXAXDIUADBAXEXIJZXGXKXAXSXFXJXBXEXICGKL
      MXEXLJZXGXNXAXTXFXMXBXEXLCGKLMXEXPJZXGXRXAYAXFXQXBXEXPCGKLMXEBJZXGXDXAYBX
      FXCXBXEBCGKLMXAAEFZXKXAYCNZXBXBCOHZXJYDXBROHZXBYEYDXBEFZYFXBJXACEFZYCYGCE
      UBUFZCAUGUHZXBUMSYDRCFZYFYEFZXAYKYCXAYHYKCUIUJZPYDYHYGUKXBFZYKYLIXAYHYCYI
      PZYJYDYHYCUKCFZYNYOXAYCULXAYPYCCUNZPCAUOQRCXBUPQUQURXAYHYCXJYEJYICAUSUHUT
      VAXLEFZAXLFZNXAXNXRYRXAXNXRIZIYSXAYRYTXAYRNZXNXMXQFZXRUUAXMXMCOHZXQUUAXMR
      OHZXMUUCUUAXMEFZUUDXMJXAYHYRUUEYICXLUGUHZXMUMSUUAYKUUDUUCFZXAYKYRYMPUUAYH
      UUEUKXMFZYKUUGIXAYHYRYIPZUUFUUAYHYRYPUUHUUIXAYRULXAYPYRYQPCXLUOQRCXMUPQUQ
      URXAYHYRXQUUCJYICXLUSUHUTUUAXQEFZXNUUBNXRIXAYHXPEFUUJYRYIXLVBCXPUGVDXBXMX
      QVCSVEVAPVFYSXOIZDXEVGZXAYSXNIZDXEVGZIZXEVHZAXEFZNZXHUULXAUUMIZDXEVGUUOUU
      KUUSDXEYSXAXNVIVJXAUUMDXEVKVPUURXAUUNXGUURXAUUNXGIUURXANZUUNXBDXEXMVLZFZX
      GUURUUNUVBIZXAUURXIXEFZUVCUUPUUQUVDXEAVMVNUVDUUNUVDXKNZUVBUVDUUNXKUVDUUNA
      XIFZXKUVDXITFZUVFXIXEVOUVGATFUVFAVQATVRVSSUUMUVFXKIDXIXEXLXIJZYSUVFXNXKXL
      XIAVTUVHXMXJXBXLXICGKLZWAWBWGWCUVEXNDXEWHUVBXNXKDXIXEUVIWDDXBXEXMWEWFWISP
      UUTXFUVAXBUUPXAXFUVAJZUUQUUPXANYHUUPYPUVJXAYHUUPYIWJUUPXAWKXAYPUUPYQWJYHX
      ETFUUPYPUVJUAWLDCXETWMWNQWOLWPWQVFWSWRWT $.
  $}

  $( Ordering property of ordinal exponentiation.  Corollary 8.34 of
     [TakeutiZaring] p. 68 and its converse.  (Contributed by NM, 6-Jan-2005.)
     (Revised by Mario Carneiro, 24-May-2015.) $)
  oeord $p |- ( ( A e. On /\ B e. On /\ C e. ( On \ 2o ) ) ->
               ( A e. B <-> ( C ^o A ) e. ( C ^o B ) ) ) $=
    ( con0 wcel c2o coe co wi oeordi wceq wo wn oecl syl2anc word eloni ordtri2
    wb syl2an w3a 3adant1 oveq2 a1i 3adant2 orim12d con3d eldifi 3ad2ant3 simp1
    cdif simp2 3adant3 3imtr4d impbid ) ADEZBDEZCDFUKEZUAZABEZCAGHZCBGHZEZUQURU
    TVCIUPABCJUBUSVAVBKZVBVAEZLZMZABKZBAEZLZMZVCUTUSVJVFUSVHVDVIVEVHVDIUSABCGUC
    UDUPURVIVEIUQBACJUEUFUGUSVADEZVBDEZVCVGSZUSCDEZUPVLURUPVOUQCDFUHUIZUPUQURUJ
    CANOUSVOUQVMVPUPUQURULCBNOVLVAPVBPVNVMVAQVBQVAVBRTOUPUQUTVKSZURUPAPBPVQUQAQ
    BQABRTUMUNUO $.

  $( Left cancellation law for ordinal exponentiation.  (Contributed by NM,
     6-Jan-2005.)  (Revised by Mario Carneiro, 24-May-2015.) $)
  oecan $p |- ( ( A e. ( On \ 2o ) /\ B e. On /\ C e. On ) ->
                   ( ( A ^o B ) = ( A ^o C ) <-> B = C ) ) $=
    ( con0 c2o wcel co wceq wo wn wi oeordi ancoms wb oecl syl2anc word ordtri3
    coe eloni cdif w3a 3adant2 3adant3 con3d eldifi 3ad2ant1 simp2 simp3 syl2an
    orim12d 3adant1 3imtr4d oveq2 impbid1 ) ADEUAFZBDFZCDFZUBZABSGZACSGZHZBCHZU
    SUTVAFZVAUTFZIZJZBCFZCBFZIZJZVBVCUSVJVFUSVHVDVIVEUPURVHVDKZUQURUPVLBCALMUCU
    PUQVIVEKZURUQUPVMCBALMUDUKUEUSUTDFZVADFZVBVGNZUSADFZUQVNUPUQVQURADEUFUGZUPU
    QURUHABOPUSVQURVOVRUPUQURUIACOPVNUTQVAQVPVOUTTVATUTVARUJPUQURVCVKNZUPUQBQCQ
    VSURBTCTBCRUJULUMBCASUNUO $.

  $( Weak ordering property of ordinal exponentiation.  (Contributed by NM,
     6-Jan-2005.)  (Revised by Mario Carneiro, 24-May-2015.) $)
  oeword $p |- ( ( A e. On /\ B e. On /\ C e. ( On \ 2o ) ) ->
                   ( A C_ B <-> ( C ^o A ) C_ ( C ^o B ) ) ) $=
    ( con0 wcel c2o cdif w3a wceq wo coe co wss oeord oecan 3coml onsseleq oecl
    wb wa bicomd orbi12d 3adant3 eldifi id anim12dan syl syl2anr 3impa 3bitr4d
    ) ADEZBDEZCDFGEZHZABEZABIZJZCAKLZCBKLZEZURUSIZJZABMZURUSMZUNUOUTUPVAABCNUNV
    AUPUMUKULVAUPSCABOPUAUBUKULVCUQSUMABQUCUKULUMVDVBSZUMCDEZUKULTZVEVGCDFUDVGU
    EVFVGTURDEZUSDEZTVEVFUKVHULVICARCBRUFURUSQUGUHUIUJ $.

  $( Weak ordering property of ordinal exponentiation.  (Contributed by NM,
     6-Jan-2005.) $)
  oewordi $p |- ( ( ( A e. On /\ B e. On /\ C e. On ) /\ (/) e. C ) ->
                   ( A C_ B -> ( C ^o A ) C_ ( C ^o B ) ) ) $=
    ( con0 wcel w3a c0 wss coe co wi c1o wceq wo wb word syl wa oe1m oveq1 mpan
    eloni ordgt0ge1 1on onsseleq bitrd 3ad2ant3 c2o ondif2 oeword biimpd 3expia
    cdif syl5bir 3impia adantr adantl eqtr4d eqimss sseq12d syl5ibcom a1dd jaod
    exp3a 3adant3 sylbid imp ) ADEZBDEZCDEZFZGCEZABHZCAIJZCBIJZHZKZVKVLLCEZLCMZ
    NZVQVJVHVLVTOVIVJVLLCHZVTVJCPVLWAOCUBCUCQLDEVJWAVTOUDLCUEUAUFUGVKVRVQVSVHVI
    VJVRVQKVHVIRZVJVRVQVJVRRCDUHUMEZWBVQCUIVHVIWCVQVHVIWCFVMVPABCUJUKULUNVDUOVK
    VSVPVMVHVIVSVPKVJWBLAIJZLBIJZHZVSVPWBWDWEMWFWBWDLWEVHWDLMVIASUPVIWELMVHBSUQ
    URWDWEUSQVSWDVNWEVOLCAITLCBITUTVAVEVBVCVFVG $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Weak ordering property of ordinal exponentiation.  Proposition 8.35 of
       [TakeutiZaring] p. 68.  (Contributed by NM, 6-Jan-2005.) $)
    oewordri $p |- ( ( B e. On /\ C e. On ) ->
        ( A e. B -> ( A ^o C ) C_ ( B ^o C ) ) ) $=
      ( vx vy con0 wcel coe co wss wi c0 wceq oveq2 sseq12d c1o adantr imp cvv
      wa csuc onelon oe0 syl eqtr4d eqimss simpl onelss jca31 comu oecl 3adant2
      w3a 3adant1 simp1 omwordri syl3anc adantrl omwordi syld3an3 adantrr sstrd
      cv oesuc 3sstr4d exp520 com3r imp4c syl5 wlim wral ancri vex limelon mpan
      0ellim oe0m1 biimpa syl2anc 0ss syl6eqss oveq1 sseq1d syl5ibr adantl a1dd
      ciun ss2iun oelim mpanlr1 an32s adantllr anim1i wne ne0i on0eln0 adantlll
      adantlr ex oe0lem com12 tfinds3 exp3a impcom ) CFGZBFGZABGZACHIZBCHIZJZKX
      EXFXGXJADVCZHIZBXKHIZJZALHIZBLHIZJZAEVCZHIZBXRHIZJZAXRUAZHIZBYBHIZJZXJXFX
      GTZDECXKLMXLXOXMXPXKLAHNXKLBHNOXKXRMXLXSXMXTXKXRAHNXKXRBHNOXKYBMXLYCXMYDX
      KYBAHNXKYBBHNOXKCMXLXHXMXIXKCAHNXKCBHNOYFXOXPMXQYFXOPXPYFAFGZXOPMBAUBZAUC
      UDXFXPPMXGBUCQUEXOXPUFUDYFYGXFTABJZTXRFGZYAYEKZYFYGXFYIYHXFXGUGZXFXGYIBAU
      HRUIYJYGXFYIYKYGXFYJYIYKKYGXFYJYIYAYEYGXFYJUMZYIYATZTZXSAUJIZXTBUJIZYCYDY
      OYPXTAUJIZYQYMYAYPYRJZYIYMYAYSYMXSFGZXTFGZYGYAYSKYGYJYTXFAXRUKULXFYJUUAYG
      BXRUKUNZYGXFYJUOXSXTAUPUQRURYMYIYRYQJZYAYMYIUUCYGXFYJUUAYIUUCKUUBABXTUSUT
      RVAVBYMYCYPMZYNYGYJUUDXFAXRVDULQYMYDYQMZYNXFYJUUEYGBXRVDUNQVEVFVGVHVIYFYG
      YFTZXKVJZYAEXKVKZXNKZYFYGYHVLUUFUUGUUIYFUUGUUIKAYFALMZTUUGXNUUHUUJUUGXNKY
      FUUGXNUUJLXKHIZXMJUUGUUKLXMUUGXKFGZLXKGZUUKLMZXKSGZUUGUULDVMZXKSVNVOXKVPU
      ULUUMUUNXKVQVRVSXMVTWAUUJXLUUKXMALXKHWBWCWDWEWFUUFLAGZTZUUGUUIUUHXNUURUUG
      TZEXKXSWGZEXKXTWGZJEXKXSXTWHUUSXLUUTXMUVAYGUUQUUGXLUUTMZYFYGUUGUUQUVBYGUU
      OUUGUUQUVBUUPEAXKSWIWJWKWLYFUUQUUGXMUVAMZYGYFUUGUVCUUQYFUUGTXFUUGTLBGZUVC
      YFXFUUGYLWMYFUVDUUGXFXGUVDXGUVDXFBLWNBAWOBWPWDRQXFUUOUUGUVDUVCUUPEBXKSWIW
      JVSWRWQOWDWSWTXAVIXBXCXD $.

    $( Ordinal exponentiation compared to its exponent.  Proposition 8.37 of
       [TakeutiZaring] p. 68.  (Contributed by NM, 7-Jan-2005.)  (Revised by
       Mario Carneiro, 24-May-2015.) $)
    oeworde $p |- ( ( A e. ( On \ 2o ) /\ B e. On ) -> B C_ ( A ^o B ) ) $=
      ( vx vy con0 wcel c2o coe co wss cv c0 csuc wceq id oveq2 sseq12d wa word
      eloni cdif 0ss a1i wi wb adantl eldifi oecl sylan syl ordsucsssuc syl2anc
      suceloni syl2an vex sucid oeordi mpi syl2anr ordsucss sylc syl5com sylbid
      expcom wlim wral dif20el jca ciun ss2iun cuni limuni uniiun syl6eq adantr
      sstr2 cvv oelim mpanlr1 anasss an12s syl5ibr ex syl5 tfinds3 impcom ) BEF
      AEGUAFZBABHIZJZCKZAWJHIZJZLALHIZJZDKZAWOHIZJZWOMZAWRHIZJZWIWGCDBWJLNZWJLW
      KWMXAOWJLAHPQWJWONZWJWOWKWPXBOWJWOAHPQWJWRNZWJWRWKWSXCOWJWRAHPQWJBNZWJBWK
      WHXDOWJBAHPQWNWGWMUBUCWGWOEFZWQWTUDWGXERZWQWRWPMZJZWTXFWOSZWPSZWQXHUEXEXI
      WGWOTUFXFWPEFZXJWGAEFZXEXKAEGUGZAWOUHUIWPTUJWOWPUKULXFXGWSJZXHWTXFWSSZWPW
      SFZXNXFWSEFZXOWGXLWREFZXQXEXMWOUMZAWRUHUNWSTUJXEXRWGXPWGXSWGOXRWGRWOWRFXP
      WODUOUPWOWRAUQURUSWPWSUTVAWRXGWSVPVBVCVDWGXLLAFZRZWJVEZWQDWJVFZWLUDZWGXLX
      TXMAVGVHYBYAYDYCWLYBYARZDWJWOVIZDWJWPVIZJDWJWOWPVJYEWJYFWKYGYBWJYFNYAYBWJ
      WJVKYFWJVLDWJVMVNVOXLYBXTWKYGNZXLYBXTYHXLWJVQFYBXTYHCUODAWJVQVRVSVTWAQWBW
      CWDWEWF $.
  $}

  $( Ordering property of ordinal exponentiation with a successor exponent.
     Corollary 8.36 of [TakeutiZaring] p. 68.  (Contributed by NM,
     7-Jan-2005.) $)
  oeordsuc $p |- ( ( B e. On /\ C e. On ) ->
      ( A e. B -> ( A ^o suc C ) e. ( B ^o suc C ) ) ) $=
    ( con0 wcel wa coe co wi ex adantr comu wss 3adant1 oecl 3adant2 syld oesuc
    wceq c0 csuc onelon w3a oewordri simp1 omwordri syl3anc sseq1d sylibrd ne0i
    wne on0eln0 syl5ibr oen0 simpl omordi sylan com23 mpdd eleq2d 3expa sucelon
    jca jcad ontr2 syl2an anandirs sylan2b exp31 com4l imp ) BDEZCDEZFZABEZADEZ
    ACUAZGHZBVQGHZEZVLVOVPIVMVLVOVPBAUBJKVLVMVOVPVTIIVPVLVMVOVTVPVLVMVOVTIVPVLF
    ZVMFVOVRBCGHZALHZMZWCVSEZFZVTVPVLVMVOWFIVPVLVMUCZVOWDWEWGVOACGHZALHZWCMZWDW
    GVOWHWBMZWJVLVMVOWKIVPABCUDNWGWHDEZWBDEZVPWKWJIVPVMWLVLACOPVLVMWMVPBCOZNVPV
    LVMUEWHWBAUFUGQWGVRWIWCVPVMVRWISVLACRPUHUIWGVOWCWBBLHZEZWEVLVMVOWPIZVPVNVOT
    WBEZWPVNVOTBEZWRVLVOWSIVMVOWSVLBTUKBAUJBULUMKVNWSWRBCUNJQVNWRVOWPVNWRWQVNVL
    WMFWRWQVNVLWMVLVMUOWNVCABWBUPUQJURUSNWGVSWOWCVLVMVSWOSVPBCRNUTUIVDVAVMWAVQD
    EZWFVTIZCVBVPVLWTXAVPWTFVRDEVSDEXAVLWTFAVQOBVQOVRWCVSVEVFVGVHQVIVJVKUS $.

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( Ordinal exponentiation with a limit exponent.  Part of Exercise 4.36 of
       [Mendelson] p. 250.  (Contributed by NM, 6-Jan-2005.) $)
    oelim2 $p |- ( ( A e. On /\ ( B e. C /\ Lim B ) ) ->
                ( A ^o B ) = U_ x e. ( B \ 1o ) ( A ^o x ) ) $=
      ( vy wcel wa coe co c1o cv ciun wceq c0 con0 wi sylan wne syl wss limelon
      wlim cdif 0ellim adantl oe0m1 biimpa syl2anc wn eldif word limord ordelon
      on0eln0 el1o necon3bbii syl6bbr biimpd sylbird impr sylan2b iuneq2dv csuc
      df-1o limsuc mpbid syl5eqel onirri jctir sylibr ne0i iunconst 3syl eqtr4d
      1on eqtrd oveq1 iuneq2d eqeq12d syl5ibr oelim wrex wral nsuceq0 a1i dif1o
      impcom sylanbrc ex ad2antlr sssucid suceloni ancli id 3expa ancoms sylan2
      anassrs oewordi an32s jcad oveq2 sseq2d rspcev syl6 ralrimiv iunss2 difss
      w3a mpi iunss1 ax-mp cbviunv sseqtri eqssd adantlrl oe0lem ) CDFZCUBZGZBC
      HIZACJUCZBAKZHIZLZMZBBNMZXTYFXTYFYGNCHIZAYBNYCHIZLZMXTYHNYJXTCOFZNCFZYHNM
      ZCDUAXSYLXRCUDZUEYKYLYMCUFUGUHXSYJNMXRXSYJAYBNLZNXSAYBYINYCYBFXSYCCFZYCJF
      ZUIZGYINMZYCCJUJXSYPYRYSXSYPGYCOFZYRYSPXSCUKZYPYTCULZCYCUMQYTYRNYCFZYSYTU
      UCYCNRYRYCUNYQYCNYCUOUPUQYTUUCYSYCUFURUSSUTVAVBXSJYBFZYBNRYONMXSJCFZJJFUI
      ZGUUDXSUUEUUFXSJNVCZCVDXSYLUUGCFYNCNVEVFVGJVOVHVIJCJUJVJYBJVKAYBNVLVMVPUE
      VNYGYAYHYEYJBNCHVQYGAYBYDYIBNYCHVQVRVSVTWGBOFZXTGNBFZGYAECBEKZHIZLZYEEBCD
      WAUUHXSUUIUULYEMXRUUHXSGZUUIGZUULYEUUNUUKYDTZAYBWBZECWCUULYETUUNUUPECUUNU
      UJCFZUUJVCZYBFZUUKBUURHIZTZGUUPUUNUUQUUSUVAXSUUQUUSPUUHUUIXSUUQUUSXSUUQGZ
      UURCFZUURNRZUUSXSUUQUVCCUUJVEUGUVDUVBUUJWDWEUURCWFWHWIWJUUNUUQUVAUUNUUQGU
      UJUURTZUVAUUJWKUUMUUQUUIUVEUVAPZUUMUUQGUUJOFZUUROFZUUHXIZUUIUVFUUHXSUUQUV
      IUVBUUHUVGUVHGZUVIUVBUVGUVJXSUUAUUQUVGUUBCUUJUMQUVGUVHUUJWLWMSUVJUUHUVIUV
      GUVHUUHUVIUVIWNWOWPWQWRUUJUURBWSQWTXJWIXAUUOUVAAUURYBYCUURMYDUUTUUKYCUURB
      HXBXCXDXEXFEACYBUUKYDXGSYEUULTUUNYEACYDLZUULYBCTYEUVKTCJXHAYBCYDXKXLAECYD
      UUKYCUUJBHXBXMXNWEXOXPVPXQ $.
  $}

  ${
    $d x C $.  $d x y z w A $.  $d x y z w B $.
    oeoalem.1 $e |- A e. On $.
    oeoalem.2 $e |- (/) e. A $.
    oeoalem.3 $e |- B e. On $.
    $( Lemma for ~ oeoa .  (Contributed by Eric Schmidt, 26-May-2009.) $)
    oeoalem $p |- ( C e. On
               -> ( A ^o ( B +o C ) ) = ( ( A ^o B ) .o ( A ^o C ) ) ) $=
      ( vy coa co coe comu wceq c0 oveq2 oveq2d con0 wcel wa mpan cvv vx vz c1o
      vw csuc eqeq12d oecl mp2an om1 ax-mp oe0 oveq2i 3eqtr4ri oasuc oacl oesuc
      cv oa0 sylancr eqtrd oveq1 sylan9eq omass mp3an13 eqtr4d adantr wlim wral
      syl ex ciun vex oalim wne word limord ordelon sylan ralrimiva 0ellim ne0i
      a1i oelim mpan2 wss wi oewordi mp3an3 3impia onoviun syl3anc iuneq2 omlim
      w3a omwordi tfinds ) ABUAUQZHIZJIZABJIZAWQJIZKIZLZABMHIZJIZWTAMJIZKIZLABG
      UQZHIZJIZWTAXHJIZKIZLZABXHUEZHIZJIZWTAXNJIZKIZLZABCHIZJIZWTACJIZKIZLUAGCW
      QMLZWSXEXBXGYDWRXDAJWQMBHNOYDXAXFWTKWQMAJNOUFWQXHLZWSXJXBXLYEWRXIAJWQXHBH
      NOYEXAXKWTKWQXHAJNOUFWQXNLZWSXPXBXRYFWRXOAJWQXNBHNOYFXAXQWTKWQXNAJNOUFWQC
      LZWSYAXBYCYGWRXTAJWQCBHNOYGXAYBWTKWQCAJNOUFWTUCKIZWTXGXEWTPQZYHWTLAPQZBPQ
      ZYIDFABUGUHZWTUIUJXFUCWTKYJXFUCLDAUKUJULXDBAJYKXDBLFBURUJULUMXHPQZXMXSYMX
      MRXPXLAKIZXRYMXMXPXJAKIZYNYKYMXPYOLFYKYMRZXPAXIUEZJIZYOYPXOYQAJBXHUNOYPYJ
      XIPQZYRYOLDBXHUOZAXIUPUSUTSXJXLAKVAVBYMYNXRLZXMYJYMUUADYJYMRZYNWTXKAKIZKI
      ZXRUUBXKPQZYNUUDLZAXHUGZYIUUEYJUUFYLDWTXKAVCVDVIUUBXQUUCWTKAXHUPOVESVFUTV
      JWQVGZXMGWQVHZXCUUHUUIRWSGWQXLVKZXBUUHUUIWSGWQXJVKZUUJUUHWSAGWQXIVKZJIZUU
      KUUHWRUULAJWQTQZUUHWRUULLZUAVLZYKUUNUUHRZUUOFGBWQTVMSSOUUHUUNYSGWQVHWQMVN
      ZUUMUUKLUUNUUHUUPWBZUUHYSGWQUUHXHWQQZRZYKYMYSFUUHWQVOUUTYMWQVPWQXHVQVRZYT
      USVSUUHMWQQUURWQVTWQMWAVIZUBUDGATJWQXIUDUQZTQZUVDVGZAUVDJIZUBUVDAUBUQZJIZ
      VKLZUDVLZYJUVEUVFRZUVJDYJUVLRMAQZUVJEUBAUVDTWCWDSSUVHPQZUVDPQZUVHUVDWEZUV
      IUVGWEZUVNUVOYJUVPUVQWFZDUVNUVOYJWNUVMUVREUVHUVDAWGWDWHWIWJWKUTGWQXJXLWLV
      BUUHXBUUJLUUIUUHXBWTGWQXKVKZKIZUUJUUHXAUVSWTKUUNUUHXAUVSLZUUPYJUUQUWADYJU
      UQRUVMUWAEGAWQTWCWDSSOUUHUUNUUEGWQVHUURUVTUUJLUUSUUHUUEGWQUVAYJYMUUEDUVBU
      UGUSVSUVCUBUDGWTTKWQXKUVEUVFWTUVDKIZUBUVDWTUVHKIZVKLZUVKYIUVLUWDYLUBWTUVD
      TWMSSUVNUVOUVPUWCUWBWEZUVNUVOYIUVPUWEWFYLUVHUVDWTWOWHWIWJWKUTVFVEVJWP $.
  $}

  $( Sum of exponents law for ordinal exponentiation.  Theorem 8R of [Enderton]
     p. 238.  Also Proposition 8.41 of [TakeutiZaring] p. 69.  (Contributed by
     Eric Schmidt, 26-May-2009.) $)
  oeoa $p |- ( ( A e. On /\ B e. On /\ C e. On )
          -> ( A ^o ( B +o C ) ) = ( ( A ^o B ) .o ( A ^o C ) ) ) $=
    ( con0 wcel coa co coe comu wceq wa c0 oveq2d c1o oveq2 0elon oecl wb oveq1
    syl oa00 biimpar oe0m0 syl6eq oveqan12d mp2an om1 adantl eqtr4d wn wne oacl
    ax-mp on0eln0 oe0m1 necon3abid 3bitr3d adantr orbi12d neorian syl6bb biimpa
    wo oveq1d mpan om0r sylan9eq an32s om0 sylan9eqr anassrs jaodan sylbird imp
    ex pm2.61dan oveq12d eqeq12d syl5ibr impcom wi cif imbi2d eleq1 anbi12d 1on
    eleq2 0lt1o pm3.2i elimhyp simpli simpri elimel oeoalem dedth2h impr oe0lem
    3impb ) ADEZBDEZCDEZABCFGZHGZABHGZACHGZIGZJZWTXAKZXGAALJZXHXGXHXGXILXBHGZLB
    HGZLCHGZIGZJZXHBLJZCLJZKZXNXHXQKZXJLLHGZXMXRXBLLHXHXBLJXQBCUAZUBMXQXMXSJXHX
    QXMXSNIGZXSXOXPXKXSXLNIBLLHOXPXLXSNCLLHOUCUDUEXSDEZYAXSJLDEZYCYBPPLLQUFXSUG
    UMUDUHUIXHXQUJZKXJLXMXHXJLJZYDXHLXBEZXBLUKZYEYDXHXBDEZYFYGRBCULZXBUNTXHYHYF
    YERYIXBUOTXHXQXBLXTUPUQUBXHYDXMLJZXHYDLBEZLCEZVCZYJXHYMBLUKZCLUKZVCYDXHYKYN
    YLYOWTYKYNRXABUNURXAYLYORWTCUNUHUSBLCLUTVAXHYMYJXHYKYJYLWTYKXAYJWTYKKZXAXML
    XLIGZLYPXKLXLIWTYKXKLJBUOVBVDXAXLDEZYQLJYCXAYRPLCQVEXLVFTVGVHWTXAYLYJXAYLKZ
    WTXMXKLIGZLYSXLLXKIXAYLXLLJCUOVBMWTXKDEZYTLJYCWTUUAPLBQVEXKVITVJVKVLVOVMVNU
    IVPXIXCXJXFXMALXBHSXIXDXKXEXLIALBHSALCHSVQVRVSVTWSLAEZXHXGWSUUBKZWTXAXGUUCW
    TXAXGWAXAUUCANWBZXBHGZUUDBHGZUUDCHGZIGZJZWAXAUUDWTBNWBZCFGZHGZUUDUUJHGZUUGI
    GZJZWAABNNAUUDJZXGUUIXAUUPXCUUEXFUUHAUUDXBHSUUPXDUUFXEUUGIAUUDBHSAUUDCHSVQV
    RWCBUUJJZUUIUUOXAUUQUUEUULUUHUUNUUQXBUUKUUDHBUUJCFSMUUQUUFUUMUUGIBUUJUUDHOV
    DVRWCUUDUUJCUUDDEZLUUDEZUUCUURUUSKNDEZLNEZKANUUPWSUURUUBUUSAUUDDWDAUUDLWGWE
    NUUDJUUTUURUVAUUSNUUDDWDNUUDLWGWEUUTUVAWFWHWIWJZWKUURUUSUVBWLBNDWFWMWNWOWPV
    HWQWR $.

  ${
    $d x C $.  $d x y z w A $.  $d x y z w B $.
    oeoelem.1 $e |- A e. On $.
    oeoelem.2 $e |- (/) e. A $.
    $( Lemma for ~ oeoe .  (Contributed by Eric Schmidt, 26-May-2009.) $)
    oeoelem $p |- ( ( B e. On /\ C e. On )
               -> ( ( A ^o B ) ^o C ) = ( A ^o ( B .o C ) ) ) $=
      ( vy vz con0 wcel coe co comu wceq cv c0 oveq2 oveq2d eqeq12d wa cvv csuc
      vx vw c1o oecl mpan oe0 syl om0 ax-mp syl6eq eqtr4d oveq1 oesuc sylan coa
      omsuc omcl oeoa mp3an1 anabss1 eqtrd syl5ibr expcom wlim wral ciun iuneq2
      wi vex oen0 mpan2 oelim sylanl1 sylan2 mpanl1 mpanr1 omlim wne a1i limord
      word ordelon anassrs ralrimiva 0ellim ne0i adantl wss w3a oewordi onoviun
      mp3an3 3impia syl3anc tfinds3 impcom ) CHIBHIZABJKZCJKZABCLKZJKZMZWSUBNZJ
      KZABXDLKZJKZMZWSOJKZABOLKZJKZMWSFNZJKZABXLLKZJKZMZWSXLUAZJKZABXQLKZJKZMZX
      CWRUBFCXDOMZXEXIXGXKXDOWSJPYBXFXJAJXDOBLPQRXDXLMZXEXMXGXOXDXLWSJPYCXFXNAJ
      XDXLBLPQRXDXQMZXEXRXGXTXDXQWSJPYDXFXSAJXDXQBLPQRXDCMZXEWTXGXBXDCWSJPYEXFX
      AAJXDCBLPQRWRXIUDXKWRWSHIZXIUDMAHIZWRYFDABUEZUFZWSUGUHWRXKAOJKZUDWRXJOAJB
      UIQYGYJUDMDAUGUJUKULWRXLHIZXPYAVIXPYAWRYKSZXMWSLKZXOWSLKZMXMXOWSLUMYLXRYM
      XTYNWRYFYKXRYMMYIWSXLUNUOYLXTAXNBUPKZJKZYNYLXSYOAJBXLUQQWRYKYPYNMZYLXNHIZ
      WRYQBXLURZYGYRWRYQDAXNBUSUTUOVAVBRVCVDWRXDVEZXPFXDVFZXHVIUUAXHWRYTSZFXDXM
      VGZFXDXOVGZMFXDXMXOVHUUBXEUUCXGUUDWRXDTIZYTXEUUCMZUBVJZYGWRUUEYTSZUUFDYGW
      RSZUUHUUFUUIUUIUUHSOWSIZUUFUUIOAIZUUJEABVKVLUUIYFUUHUUJUUFYHFWSXDTVMVNVOV
      AVPVQUUBXGAFXDXNVGZJKZUUDUUBXFUULAJWRUUEYTXFUULMUUGFBXDTVRVQQUUBUUEYRFXDV
      FXDOVSZUUMUUDMUUEUUBUUGVTUUBYRFXDWRYTXLXDIZYRYTUUOSWRYKYRYTXDWBUUOYKXDWAX
      DXLWCUOYSVOWDWEYTUUNWRYTOXDIUUNXDWFXDOWGUHWHGUCFATJXDXNUCNZTIZUUPVEZAUUPJ
      KZGUUPAGNZJKZVGMZUCVJYGUUQUURSZUVBDYGUVCSUUKUVBEGAUUPTVMVLUFUFUUTHIZUUPHI
      ZUUTUUPWIZUVAUUSWIZUVDUVEYGUVFUVGVIZDUVDUVEYGWJUUKUVHEUUTUUPAWKVLWMWNWLWO
      VBRVCVDWPWQ $.
  $}

  $( Product of exponents law for ordinal exponentiation.  Theorem 8S of
     [Enderton] p. 238.  Also Proposition 8.42 of [TakeutiZaring] p. 70.
     (Contributed by Eric Schmidt, 26-May-2009.) $)
  oeoe $p |- ( ( A e. On /\ B e. On /\ C e. On )
          -> ( ( A ^o B ) ^o C ) = ( A ^o ( B .o C ) ) ) $=
    ( con0 wcel coe co wceq wa c0 c1o oveq2 oe0m0 syl6eq oveq1d sylan9eqr oe0m1
    syl biimpa oveq1 comu wo oe1m adantll 0elon oecl oe0 adantlr jaodan biimpar
    mpan om00 oveq2d eqtr4d wne on0eln0 bi2anan9 neanior syl6bb sylan9eq om00el
    wn an4s wb bitr3d ex sylbird imp pm2.61dan eqeq12d syl5ibr impcom wi imbi2d
    omcl cif eleq1 eleq2 anbi12d 1on 0lt1o pm3.2i elimhyp simpli simpri oeoelem
    dedth an32s oe0lem 3impb ) ADEZBDEZCDEZABFGZCFGZABCUAGZFGZHZWLWMIZWRAAJHZWS
    WRWSWRWTJBFGZCFGZJWPFGZHZWSBJHZCJHZUBZXDWSXGIZXBKXCWSXEXBKHZXFWMXEXIWLXEWMX
    BKCFGKXEXAKCFXEXAJJFGZKBJJFLMNOCUCPUDWLXFXIWMXFWLXBXAJFGZKCJXAFLWLXADEZXKKH
    JDEWLXLUEJBUFUKXAUGRPUHUIXHXCXJKXHWPJJFWSWPJHXGBCULUJUMMNUNWSXGVBZXDWSXMJBE
    ZJCEZIZXDWSXPBJUOZCJUOZIXMWLXNXQWMXOXRBUPCUPUQBJCJURUSWSXPXDWSXPIXBJXCWLXNW
    MXOXBJHWLXNIZWMXOIXBJCFGZJXSXAJCFWLXNXAJHBQSOWMXOXTJHCQSUTVCWSXPXCJHZWSJWPE
    ZXPYABCVAWSWPDEYBYAVDBCVOWPQRVESUNVFVGVHVIWTWOXBWQXCWTWNXACFAJBFTOAJWPFTVJV
    KVLWKJAEZWSWRWKYCIZWSWRYDWSWRVMWSYDAKVPZBFGZCFGZYEWPFGZHZVMAKAYEHZWRYIWSYJW
    OYGWQYHYJWNYFCFAYEBFTOAYEWPFTVJVNYEBCYEDEZJYEEZYDYKYLIKDEZJKEZIAKYJWKYKYCYL
    AYEDVQAYEJVRVSKYEHYMYKYNYLKYEDVQKYEJVRVSYMYNVTWAWBWCZWDYKYLYOWEWFWGVHWHWIWJ
    $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( The ordinal exponential with a limit ordinal is a limit ordinal.
       (Contributed by Mario Carneiro, 29-May-2015.) $)
    oelimcl $p |- ( ( A e. ( On \ 2o ) /\ ( B e. C /\ Lim B ) ) ->
               Lim ( A ^o B ) ) $=
      ( vx vy con0 c2o cdif wcel wlim wa coe co word c0 cv syl adantr syl2anc
      wi csuc wral eldifi limelon oecl syl2an eloni adantl dif20el syl21anc c1o
      oen0 ciun wceq oelim2 sylan eleq2d wrex wss simprl onelon simprr ordsucss
      eliun sylc simpll oeordi mpd suceloni mp2and expr sylan2 rexlimdva syl5bi
      ontr2 sylbid ralrimiv dflim4 syl3anbrc ) AFGHIZBCIBJKZKZABLMZNZOWCIZDPZUA
      ZWCIZDWCUBWCJWBWCFIZWDVTAFIZBFIZWIWAAFGUCZBCUDZABUEUFZWCUGQWBWJWKOAIZWEVT
      WJWAWLRZWAWKVTWMUHZVTWOWAAUIRABULUJWBWHDWCWBWFWCIWFEBUKHZAEPZLMZUMZIZWHWB
      WCXAWFVTWJWAWCXAUNWLEABCUOUPUQXBWFWTIZEWRURWBWHEWFWRWTVDWBXCWHEWRWSWRIWBW
      SBIZXCWHTWSBUKUCWBXDXCWHWBXDXCKZKZWGWTUSZWTWCIZWHXFWTNZXCXGXFWTFIZXIXFWJW
      SFIZXJWBWJXEWPRXFWKXDXKWBWKXEWQRZWBXDXCUTZBWSVASAWSUESZWTUGQWBXDXCVBZWFWT
      VCVEXFXDXHXMXFWKVTXDXHTXLVTWAXEVFWSBAVGSVHXFWGFIZWIXGXHKWHTXFWFFIZXPXFXJX
      CXQXNXOWTWFVASWFVIQWBWIXEWNRWGWTWCVOSVJVKVLVMVNVPVQDWCVRVS $.
  $}

  ${
    $d a d e w x y z A $.  $d a d e w x y z B $.  $d a d e D $.  $d a d e E $.
    $d a d e w y z X $.
    oeeu.1 $e |- X = U. |^| { x e. On | B e. ( A ^o x ) } $.
    $( Lemma for ~ oeeu .  (Contributed by Mario Carneiro, 28-Feb-2013.) $)
    oeeulem $p |- ( ( A e. ( On \ 2o ) /\ B e. ( On \ 1o ) ) -> ( X e. On /\
        ( A ^o X ) C_ B /\ B e. ( A ^o suc X ) ) ) $=
      ( vy con0 wcel c1o wa coe co wss syl wceq oveq2 eleq2d wn c0 simprbi cdif
      c2o csuc crab cint cuni wrex eldifi adantl suceloni oeworde syldan sucidg
      cv sseldd rspcev syl2anc onintrab2 sylib onuni syl5eqel wlim wo wne dif1o
      ssrab2 rabn0 sylibr onint sylancr eleq1 syl5ibcom elrab adantr oe0 syl6bb
      el1o syl5ib syld necon3ad mpd ciun limuni syl6eqr eqeltrrd cbvrabv elrab2
      ad2antrr wb limeq ibi anim12i dif20el oelim syl21anc eleqtrd eliun sselda
      onss biimpar onnminsb sylc nrexdv pm2.65da ioran sylanbrc word eloni 3syl
      unizlim mtbird orduniorsuc ord suceq syl6reqr inteqi syl6eleq oecl ontri1
      ax-mp mpbird eqeltrd 3jca ) BGUBUAHZCGIUAHZJZDGHZBDKLZCMZCBDUCZKLZHZYFDCB
      AUNZKLZHZAGUDZUEZUFZGEYFYQGHZYRGHYFYOAGUGZYSYFCUCZGHZCBUUAKLZHZYTYFCGHZUU
      BYEUUEYDCGIUHUIZCUJNZYFUUAUUCCYDYEUUBUUAUUCMUUGBUUAUKULYFUUECUUAHUUFCGUMN
      UOYOUUDAUUAGYMUUAOYNUUCCYMUUABKPQUPUQZYOAURUSZYQUTNVAZYFYICYHHZRZYFYGDCBF
      UNZKLZHZFGUDZUEZHUULUUJYFDYQUUQYFDYJYQYFYGDYJHUUJDGUMNYFYQYRUCZYJYFYQYROZ
      RYQUUROZYFUUSYQSOZYQVBZVCZYFUVARZUVBRUVCRYFCSVDZUVDYEUVEYDYEUUEUVECGVETUI
      YFUVACSYFUVASYPHZCSOZYFYQYPHZUVAUVFYFYPGMYPSVDZUVHYOAGVFYFYTUVIUUHYOAGVGV
      HYPVIVJZYQSYPVKVLUVFCBSKLZHZYFUVGUVFSGHUVLYOUVLASGYMSOYNUVKCYMSBKPQVMTYFU
      VLCIHUVGYFUVKICYFBGHZUVKIOYDUVMYEBGUBUHZVNZBVONQCVQVPVRVSVTWAYFUVBUUOFDUG
      ZYFUVBJZCFDUUNWBZHUVPUVQCYHUVRUVQDYPHZUUKUVQYQDYPUVBYQDOZYFUVBYQYRDYQWCEW
      DZUIZYFUVHUVBUVJVNWEUVSYGUUKUUOUUKFDGYPUUMDOUUNYHCUUMDBKPQZYOUUOAFGYMUUMO
      YNUUNCYMUUMBKPQZWFZWGTNUVQUVMYGDVBZJSBHZYHUVROYDUVMYEUVBUVNWHYFYGUVBUWFUU
      JUVBUWFUVBUVTUVBUWFWIUWAYQDWJNWKWLYDUWGYEUVBBWMWHFBDGWNWOWPFCDUUNWQUSUVQU
      UOFDUVQUUMDHZJUUMGHUUMYQHZUUORUVQDGUUMUVQYGDGMYFYGUVBUUJVNDWSNWRUVQUWIUWH
      UVQYQDUUMUWBQWTYOUUOAUUMUWDXAXBXCXDUVAUVBXEXFYFYSYQXGZUUSUVCWIUUIYQXHZYQX
      JXIXKYFUUSUUTYFYSUWJUUSUUTVCUUIUWKYQXLXIXMWADYROYJUUROEDYRXNXTXOZWPYPUUPU
      WEXPXQUUOUUKFDUWCXAXBYFYHGHZUUEYIUULWIYFUVMYGUWMUVOUUJBDXRUQUUFYHCXSUQYAY
      FYJYPHZYLYFYJYQYPUWLUVJYBUWNYJGHYLUUOYLFYJGYPUUMYJOUUNYKCUUMYJBKPQUWEWGTN
      YC $.

    oeeu.2 $e |- P = ( iota w E. y e. On E. z e. ( A ^o X )
      ( w = <. y , z >. /\ ( ( ( A ^o X ) .o y ) +o z ) = B ) ) $.
    oeeu.3 $e |- Y = ( 1st ` P ) $.
    oeeu.4 $e |- Z = ( 2nd ` P ) $.
    $( The division algorithm for ordinal exponentiation.  (This version of
       ~ oeeu gives an explicit expression for the unique solution of the
       equation, in terms of the solution ` P ` to ~ omeu .)  (Contributed by
       Mario Carneiro, 25-May-2015.) $)
    oeeui $p |- ( ( A e. ( On \ 2o ) /\ B e. ( On \ 1o ) ) ->
        ( ( ( C e. On /\ D e. ( A \ 1o ) /\ E e. ( A ^o C ) ) /\
          ( ( ( A ^o C ) .o D ) +o E ) = B ) <->
          ( C = X /\ D = Y /\ E = Z ) ) ) $=
      ( con0 wcel co va vd ve c2o cdif c1o wa coe comu coa wceq w3a wb wss csuc
      eldifi adantr ad2antrr simprl oecl syl2anc om1 syl c0 csn df1o2 wne dif1o
      simprbi ad2antll onelon on0eln0 mpbird snssd syl5eqss 1on omwordi syl3anc
      wi a1i eqsstr3d omcl simplrl oaword1 simplrr sseqtrd sstrd oeeulem simp3d
      mpd simp1d suceloni ontr2 mp2and simplll oeord simp2d word eloni ordsucss
      onsssuc sylc dif20el syl21anc omword syl31anc mpbid oaord eqeltrrd oa1suc
      oen0 odi oveq2d 3eqtr3d eleqtrrd sseldd oesuc ad2antrl jca eqeltrd simprr
      eqssd suceq eqtr3d eleqtrd omord2 oveq1d oveq2 eleq1d anass 3anass eqeq1d
      wn cv cop wrex cio weq eqeq2d anbi12d eqsstrd adantl om0 eqtrd syl5ibrcom
      ontri1 sylibd necon3bd sylanbrc impbida ex pm5.32rd syl6bb eleq2d syl5bbr
      oa0r 3anbi23d ne0i omeu opeq1 opeq2 cbvrex2v eqeq1 anbi1d 2rexbidv syl5bb
      weu cbviotav eqtri opiota sylan9bbr pm5.32da bitrd df-3an anbi1i 3bitr4g
      bitri ) ERUDUESZFRUFUESZUGZGRSZHEUFUESZUGZJEGUHTZSZUWDHUITZJUJTZFUKZUGZUG
      ZGKUKZHLUKZJMUKZUGZUGZUWAUWBUWEULZUWHUGZUWKUWLUWMULUVTUWJUWKHRSZUWIUGZUGZ
      UWOUVTUWJUWKUWRUGZUWIUGUWTUVTUWIUWCUXAUVTUWIUWCUXAUMUVTUWIUGZUWCUXAUXBUWC
      UGZUWKUWRUXCGKUXCGKUNZGKUOZSZUXCUXFUWDEUXEUHTZSZUXCUWDFUNZFUXGSZUXHUXCUWD
      UWFFUXCUWDUWDUFUITZUWFUXCUWDRSZUXKUWDUKUXCERSZUWAUXLUVTUXMUWIUWCUVRUXMUVS
      ERUDUPUQZURZUXBUWAUWBUSZEGUTZVAZUWDVBVCZUXCUFHUNZUXKUWFUNZUXCUFVDVEHVFUXC
      VDHUXCVDHSZHVDVGZUWBUYCUXBUWAUWBHESZUYCHEVHZVIVJUXCUWRUYBUYCUMUXCUXMUYDUW
      RUXOUWBUYDUXBUWAHEUFUPVJZEHVKVAZHVLVCVMVNVOUXCUFRSZUWRUXLUXTUYAVSUYHUXCVP
      VTZUYGUXRUFHUWDVQVRWJWAUXCUWFUWGFUXCUWFRSZJRSZUWFUWGUNZUXCUXLUWRUYJUXRUYG
      UWDHWBZVAZUXCUXLUWEUYKUXRUVTUWEUWHUWCWCZUWDJVKZVAZUWFJWDZVAUVTUWEUWHUWCWE
      ZWFWGUVTUXJUWIUWCUVTKRSZEKUHTZFUNZUXJAEFKNWHZWIZURUXCUXLUXGRSZUXIUXJUGUXH
      VSUXRUXCUXMUXERSZVUEUXOUXCUYTVUFUVTUYTUWIUWCUVTUYTVUBUXJVUCWKZURZKWLVCZEU
      XEUTVAUWDFUXGWMVAWNUXCUWAVUFUVRUXFUXHUMUXPVUIUVRUVSUWIUWCWOZGUXEEWPVRVMUX
      CUWAUYTUXDUXFUMUXPVUHGKXAVAVMUXCKGUNZKGUOZSZUXCVUMVUAEVULUHTZSZUXCVUBFVUN
      SZVUOUVTVUBUWIUWCUVTUYTVUBUXJVUCWQZURUXCFUWDEUITZVUNUXCUWDHUOZUITZVURFUXC
      VUSEUNZVUTVURUNZUXCEWRZUYDVVAUXCUXMVVCUXOEWSVCUYFHEWTXBUXCVUSRSZUXMUXLVDU
      WDSZVVAVVBUMUXCUWRVVDUYGHWLVCUXOUXRUXCUXMUWAVDESZVVEUXOUXPUXCUVRVVFVUJEXC
      ZVCEGXKZXDVUSEUWDXEXFXGUXCFUWFUWDUJTZVUTUXCUWGFVVIUYSUXCUWEUWGVVISZUYOUXC
      UYKUXLUYJUWEVVJUMUYQUXRUYNJUWDUWFXHVRXGXIUXCUWDHUFUJTZUITZUWFUXKUJTZVUTVV
      IUXCUXLUWRUYHVVLVVMUKUXRUYGUYIUWDHUFXLVRUXCVVKVUSUWDUIUXCUWRVVKVUSUKUYGHX
      JVCXMUXCUXKUWDUWFUJUXSXMXNXOXPUXCUXMUWAVUNVURUKZUXOUXPEGXQZVAXOUXCVUARSZV
      UNRSZVUBVUPUGVUOVSUXCUXMUYTVVPUXOVUHEKUTZVAUXCUXMVULRSZVVQUXOUWAVVSUXBUWB
      GWLXRZEVULUTVAVUAFVUNWMVAWNUXCUYTVVSUVRVUMVUOUMVUHVVTVUJKVULEWPVRVMUXCUYT
      UWAVUKVUMUMVUHUXPKGXAVAVMYBUYGXSUXBUXAUGZUWAUWBVWAGKRUXBUWKUWRUSZUVTUYTUW
      IUXAVUGURXTZVWAUYDUYCUWBVWAUYDUWFVURSZVWAUWFFUNZFVURSZVWDVWAUWFUWGFVWAUYJ
      UYKUYLVWAUXLUWRUYJVWAUXMUWAUXLUVTUXMUWIUXAUXNURZVWCUXQVAZUXBUWKUWRYAZUYMV
      AZVWAUXLUWEUYKVWHUVTUWEUWHUXAWCZUYPVAZUYRVAUVTUWEUWHUXAWEZWFVWAFUXGVURUVT
      UXJUWIUXAVUDURVWAVUNUXGVURVWAVULUXEEUHUWKVULUXEUKUXBUWRGKYCXRXMVWAUXMUWAV
      VNVWGVWCVVOVAYDYEVWAUYJVURRSZVWEVWFUGVWDVSVWJVWAUXLUXMVWNVWHVWGUWDEWBVAUW
      FFVURWMVAWNVWAUWRUXMUXLVVEUYDVWDUMVWIVWGVWHVWAUXMUWAVVFVVEVWGVWCUVTVVFUWI
      UXAUVRVVFUVSVVGUQZURVVHXDHEUWDYFXFVMVWAFUWDSZYMZUYCVWAUXIVWQVWAUWDVUAFVWA
      GKEUHVWBXMUVTVUBUWIUXAVUQURUUAVWAUXLFRSZUXIVWQUMVWHUVTVWRUWIUXAUVSVWRUVRF
      RUFUPUUBZURUWDFUUFVAXGVWAVWPHVDVWAHVDUKZUWGUWDSZVWPVWAVXAVWTUWDVDUITZJUJT
      ZUWDSVWAVXCJUWDVWAVXCVDJUJTZJVWAVXBVDJUJVWAUXLVXBVDUKVWHUWDUUCVCYGVWAUYKV
      XDJUKVWLJUUPVCUUDVWKXTVWTUWGVXCUWDVWTUWFVXBJUJHVDUWDUIYHYGYIUUEVWAUWGFUWD
      VWMYIUUGUUHWJUYEUUIXSUUJUUKUULUWKUWRUWIYJUUMUVTUWKUWSUWNUWKUWSUWRJVUASZVU
      AHUITZJUJTZFUKZULZUVTUWNUWSUWRUWEUWHULUWKVXIUWRUWEUWHYKUWKUWEVXEUWHVXHUWR
      UWKUWDVUAJGKEUHYHZUUNUWKUWGVXGFUWKUWFVXFJUJUWKUWDVUAHUIVXJYGYGYLUUQUUOUVT
      VVPVWRVUAVDVGZVXIUWNUMZUVTUXMUYTVVPUXNVUGVVRVAVWSUVTVDVUASZVXKUVTUXMUYTVV
      FVXMUXNVUGVWOEKXKXDVUAVDUURVCVVPVWRVXKULUAYNZUBYNZUCYNZYOZUKZVUAVXOUITZVX
      PUJTZFUKZUGZUCVUAYPUBRYPZUAUVGVXLUBUCUAVUAFUUSVYAVXFVXPUJTZFUKVXHUBUCUARV
      UAHJILMIDYNZBYNZCYNZYOZUKZVUAVYFUITZVYGUJTZFUKZUGZCVUAYPBRYPZDYQVYCUAYQOV
      YNVYCDUAVYNVYEVXQUKZVYAUGZUCVUAYPUBRYPDUAYRZVYCVYMVYPVYEVXOVYGYOZUKZVXSVY
      GUJTZFUKZUGBCUBUCRVUABUBYRZVYIVYSVYLWUAWUBVYHVYRVYEVYFVXOVYGUUTYSWUBVYKVY
      TFWUBVYJVXSVYGUJVYFVXOVUAUIYHYGYLYTCUCYRZVYSVYOWUAVYAWUCVYRVXQVYEVYGVXPVX
      OUVAYSWUCVYTVXTFVYGVXPVXSUJYHYLYTUVBVYQVYPVYBUBUCRVUAVYQVYOVXRVYAVYEVXNVX
      QUVCUVDUVEUVFUVHUVIPQVXOHUKZVXTVYDFWUDVXSVXFVXPUJVXOHVUAUIYHYGYLVXPJUKVYD
      VXGFVXPJVXFUJYHYLUVJVCVRUVKUVLUVMUWQUWCUWEUGZUWHUGUWJUWPWUEUWHUWAUWBUWEUV
      NUVOUWCUWEUWHYJUVQUWKUWLUWMYKUVP $.
  $}

  ${
    $d a b c d w x y z A $.  $d a b c d w x y z B $.
    $( The division algorithm for ordinal exponentiation.  (Contributed by
       Mario Carneiro, 25-May-2015.) $)
    oeeu $p |- ( ( A e. ( On \ 2o ) /\ B e. ( On \ 1o ) ) ->
        E! w E. x e. On E. y e. ( A \ 1o ) E. z e. ( A ^o x )
          ( w = <. x , y , z >. /\ ( ( ( A ^o x ) .o y ) +o z ) = B ) ) $=
      ( va vd vb vc con0 wcel wa cv wceq coe co wex wrex eqid c2o cdif c1o cotp
      w3a comu coa weu crab cint cuni cop cio c1st cfv c2nd cvv wss csuc simp1d
      oeeulem elex fvex oeeui euotd df-3an ancom bitri anbi1i anbi2i an12 anass
      syl 3bitri exbii df-rex r19.42v 3bitr2i 2exbii r2ex bitr4i eubii sylib
      a1i ) EKUAUBLFKUCUBLMZDNANZBNZCNZUDOZWFKLZWGEUCUBZLZWHEWFPQZLZUEZWMWGUFQW
      HUGQFOZMZMZCRZBRARZDUHWIWPMZCWMSZBWKSAKSZDUHWEWQDFEGNPQLGKUIUJUKZHNINZJNZ
      ULOEXDPQZXEUFQXFUGQFOMJXGSIKSHUMZUNUOZXHUPUOZABCWEXDKLZXDUQLWEXKXGFURFEXD
      USPQLGEFXDXDTZVAUTXDKVBVMXIUQLWEXHUNVCWDXJUQLWEXHUPVCWDGIJHEFWFWGXHWHXDXI
      XJXLXHTXITXJTVDVEWTXCDWTWJWLMZXBMZBRARXCWSXNABWSWNXMXAMZMZCRXOCWMSXNWRXPC
      WRWIWNXMMZWPMZMXQXAMXPWQXRWIWOXQWPWOXMWNMXQWJWLWNVFXMWNVGVHVIVJWIXQWPVKWN
      XMXAVLVNVOXOCWMVPXMXACWMVQVRVSXBABKWKVTWAWBWC $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Natural number arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Addition with zero.  Theorem 4I(A1) of [Enderton] p. 79.  (Contributed by
     NM, 20-Sep-1995.) $)
  nna0 $p |- ( A e. om -> ( A +o (/) ) = A ) $=
    ( com wcel con0 c0 coa co wceq nnon oa0 syl ) ABCADCAEFGAHAIAJK $.

  $( Multiplication with zero.  Theorem 4J(A1) of [Enderton] p. 80.
     (Contributed by NM, 20-Sep-1995.) $)
  nnm0 $p |- ( A e. om -> ( A .o (/) ) = (/) ) $=
    ( com wcel con0 c0 comu co wceq nnon om0 syl ) ABCADCAEFGEHAIAJK $.

  $( Addition with successor.  Theorem 4I(A2) of [Enderton] p. 79.
     (Contributed by NM, 20-Sep-1995.)  (Revised by Mario Carneiro,
     14-Nov-2014.) $)
  nnasuc $p |- ( ( A e. om /\ B e. om ) ->
                ( A +o suc B ) = suc ( A +o B ) ) $=
    ( com wcel con0 csuc coa co wceq nnon onasuc sylan ) ACDAEDBCDABFGHABGHFIAJ
    ABKL $.

  $( Multiplication with successor.  Theorem 4J(A2) of [Enderton] p. 80.
     (Contributed by NM, 20-Sep-1995.)  (Revised by Mario Carneiro,
     14-Nov-2014.) $)
  nnmsuc $p |- ( ( A e. om /\ B e. om ) ->
                ( A .o suc B ) = ( ( A .o B ) +o A ) ) $=
    ( com wcel con0 csuc comu co coa wceq nnon onmsuc sylan ) ACDAEDBCDABFGHABG
    HAIHJAKABLM $.

  $( Exponentiation with a successor exponent.  Definition 8.30 of
     [TakeutiZaring] p. 67.  (Contributed by Mario Carneiro, 14-Nov-2014.) $)
  nnesuc $p |- ( ( A e. om /\ B e. om ) ->
              ( A ^o suc B ) = ( ( A ^o B ) .o A ) ) $=
    ( com wcel con0 csuc coe co comu wceq nnon onesuc sylan ) ACDAEDBCDABFGHABG
    HAIHJAKABLM $.

  ${
    $d x y A $.  $d x B $.
    $( Addition to zero.  Remark in proof of Theorem 4K(2) of [Enderton]
       p. 81.  Note:  In this and later theorems, we deliberately avoid the
       more general ordinal versions of these theorems (in this case ~ oa0r )
       so that we can avoid ~ ax-rep , which is not needed for finite recursive
       definitions.  (Contributed by NM, 20-Sep-1995.)  (Revised by Mario
       Carneiro, 14-Nov-2014.) $)
    nna0r $p |- ( A e. om -> ( (/) +o A ) = A ) $=
      ( vx vy c0 cv coa co wceq csuc oveq2 id eqeq12d con0 wcel 0elon oa0 ax-mp
      com peano1 nnasuc mpan suceq eqeq2d syl5ibcom finds ) DBEZFGZUFHDDFGZDHZD
      CEZFGZUJHZDUJIZFGZUMHZDAFGZAHBCAUFDHZUGUHUFDUFDDFJUQKLUFUJHZUGUKUFUJUFUJD
      FJURKLUFUMHZUGUNUFUMUFUMDFJUSKLUFAHZUGUPUFAUFADFJUTKLDMNUIODPQUJRNZUNUKIZ
      HZULUODRNVAVCSDUJTUAULVBUMUNUKUJUBUCUDUE $.

    $( Multiplication with zero.  Exercise 16 of [Enderton] p. 82.
       (Contributed by NM, 20-Sep-1995.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    nnm0r $p |- ( A e. om -> ( (/) .o A ) = (/) ) $=
      ( vx vy c0 cv comu co wceq csuc oveq2 eqeq1d om0x com wcel coa oveq1 con0
      0elon oa0 ax-mp syl6eq peano1 nnmsuc mpan syl5ibr finds ) DBEZFGZDHDDFGZD
      HDCEZFGZDHZDUJIZFGZDHZDAFGZDHBCAUGDHUHUIDUGDDFJKUGUJHUHUKDUGUJDFJKUGUMHUH
      UNDUGUMDFJKUGAHUHUPDUGADFJKDLULUOUJMNZUKDOGZDHULURDDOGZDUKDDOPDQNUSDHRDST
      UAUQUNURDDMNUQUNURHUBDUJUCUDKUEUF $.

    $( Closure of addition of natural numbers.  Proposition 8.9 of
       [TakeutiZaring] p. 59.  (Contributed by NM, 20-Sep-1995.)  (Proof
       shortened by Andrew Salmon, 22-Oct-2011.) $)
    nnacl $p |- ( ( A e. om /\ B e. om ) -> ( A +o B ) e. om ) $=
      ( vx vy com wcel coa co cv wceq oveq2 eleq1d imbi2d csuc nna0 ibir peano2
      wi c0 wa nnasuc syl5ibr expcom finds2 vtoclga impcom ) BEFAEFZABGHZEFZUGA
      CIZGHZEFZRUGUIRCBEUJBJZULUIUGUMUKUHEUJBAGKLMULASGHZEFZADIZGHZEFZAUPNZGHZE
      FZUGCDUJSJUKUNEUJSAGKLUJUPJUKUQEUJUPAGKLUJUSJUKUTEUJUSAGKLUGUOUGUNAEAOLPU
      GUPEFZURVARURVAUGVBTZUQNZEFUQQVCUTVDEAUPUALUBUCUDUEUF $.

    $( Closure of multiplication of natural numbers.  Proposition 8.17 of
       [TakeutiZaring] p. 63.  (Contributed by NM, 20-Sep-1995.)  (Proof
       shortened by Andrew Salmon, 22-Oct-2011.) $)
    nnmcl $p |- ( ( A e. om /\ B e. om ) -> ( A .o B ) e. om ) $=
      ( vx vy wcel comu co cv wi wceq oveq2 eleq1d imbi2d c0 csuc nnm0 syl6eqel
      com peano1 expcom coa nnacl adantr nnmsuc sylibrd finds2 vtoclga impcom
      wa ) BREAREZABFGZREZUJACHZFGZREZIUJULICBRUMBJZUOULUJUPUNUKRUMBAFKLMUOANFG
      ZREADHZFGZREZAUROZFGZREZUJCDUMNJUNUQRUMNAFKLUMURJUNUSRUMURAFKLUMVAJUNVBRU
      MVAAFKLUJUQNRAPSQUJURREZUTVCIUJVDUIZUTUSAUAGZREZVCUJUTVGIVDUTUJVGUSAUBTUC
      VEVBVFRAURUDLUETUFUGUH $.

    $( Closure of exponentiation of natural numbers.  Proposition 8.17 of
       [TakeutiZaring] p. 63.  (Contributed by NM, 24-Mar-2007.)  (Proof
       shortened by Andrew Salmon, 22-Oct-2011.) $)
    nnecl $p |- ( ( A e. om /\ B e. om ) -> ( A ^o B ) e. om ) $=
      ( vx vy com wcel coe co cv wi wceq oveq2 eleq1d imbi2d csuc c1o con0 nnon
      c0 expcom oe0 syl df-1o peano1 peano2 ax-mp eqeltri syl6eqel nnmcl adantr
      wa comu nnesuc sylibrd finds2 vtoclga impcom ) BEFAEFZABGHZEFZURACIZGHZEF
      ZJURUTJCBEVABKZVCUTURVDVBUSEVABAGLMNVCASGHZEFADIZGHZEFZAVFOZGHZEFZURCDVAS
      KVBVEEVASAGLMVAVFKVBVGEVAVFAGLMVAVIKVBVJEVAVIAGLMURVEPEURAQFVEPKARAUAUBPS
      OZEUCSEFVLEFUDSUEUFUGUHURVFEFZVHVKJURVMUKZVHVGAULHZEFZVKURVHVPJVMVHURVPVG
      AUITUJVNVJVOEAVFUMMUNTUOUPUQ $.
  $}

  ${
    nncli.1 $e |- A e. om $.
    nncli.2 $e |- B e. om $.
    $( ` om ` is closed under addition.  Inference form of ~ nnacl .
       (Contributed by Scott Fenton, 20-Apr-2012.)  (Revised by Mario Carneiro,
       12-May-2012.) $)
    nnacli $p |- ( A +o B ) e. om $=
      ( com wcel coa co nnacl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( ` om ` is closed under multiplication.  Inference form of ~ nnmcl .
       (Contributed by Scott Fenton, 20-Apr-2012.)  (Revised by Mario Carneiro,
       12-May-2012.) $)
    nnmcli $p |- ( A .o B ) e. om $=
      ( com wcel comu co nnmcl mp2an ) AEFBEFABGHEFCDABIJ $.

  $}

  $( Reverse closure law for addition of natural numbers.  Exercise 1 of
     [TakeutiZaring] p. 62 and its converse.  (Contributed by NM,
     12-Dec-2004.) $)
  nnarcl $p |- ( ( A e. On /\ B e. On ) ->
               ( ( A +o B ) e. om <-> ( A e. om /\ B e. om ) ) ) $=
    ( con0 wcel wa coa co com wss oaword1 word eloni ordom ordtr2 sylancl exp3a
    wi adantr mpd oaword2 ancoms adantl jcad nnacl impbid1 ) ACDZBCDZEZABFGZHDZ
    AHDZBHDZEUHUJUKULUHAUIIZUJUKQZABJUFUMUNQUGUFUMUJUKUFAKHKZUMUJEUKQALMAUIHNOP
    RSUHBUIIZUJULQZUGUFUPBATUAUGUPUQQUFUGUPUJULUGBKUOUPUJEULQBLMBUIHNOPUBSUCABU
    DUE $.

  ${
    $d x y A $.  $d x y z B $.  $d x y z C $.
    $( Addition of natural numbers is commutative.  Theorem 4K(2) of [Enderton]
       p. 81.  (Contributed by NM, 6-May-1995.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    nnacom $p |- ( ( A e. om /\ B e. om ) -> ( A +o B ) = ( B +o A ) ) $=
      ( vx vy com wcel coa co wceq cv wi oveq1 oveq2 eqeq12d c0 csuc nna0 suceq
      syl nnasuc vz imbi2d nna0r eqtr4d wa peano2 syl5ibr expcom finds2 vtoclga
      sylan imp ) AEFBEFZABGHZBAGHZIZUMCJZBGHZBUQGHZIZKUMUPKCAEUQAIZUTUPUMVAURU
      NUSUOUQABGLUQABGMNUBUTOBGHZBOGHZIDJZBGHZBVDGHZIZVDPZBGHZBVHGHZIZUMCDUQOIZ
      URVBUSVCUQOBGLUQOBGMNUQVDIURVEUSVFUQVDBGLUQVDBGMNUQVHIURVIUSVJUQVHBGLUQVH
      BGMNUMVBBVCBUCBQUDUMVDEFZVGVKKVGVKUMVMUEZVEPZVFPZIVEVFRVNVIVOVJVPUMVMVIVO
      IZVMVHUQGHZVDUQGHZPZIZKVMVQKCBEUQBIZWAVQVMWBVRVIVTVOUQBVHGMWBVSVEIVTVOIUQ
      BVDGMVSVERSNUBWAVHOGHZVDOGHZPZIVHUAJZGHZVDWFGHZPZIZVHWFPZGHZVDWKGHZPZIZVM
      CUAVLVRWCVTWEUQOVHGMVLVSWDIVTWEIUQOVDGMVSWDRSNUQWFIZVRWGVTWIUQWFVHGMWPVSW
      HIVTWIIUQWFVDGMVSWHRSNUQWKIZVRWLVTWNUQWKVHGMWQVSWMIVTWNIUQWKVDGMVSWMRSNVM
      WCVHWEVMVHEFZWCVHIVDUFZVHQSVMWDVDIWEVHIVDQWDVDRSUDVMWFEFZWJWOKWJWOVMWTUEZ
      WGPZWIPZIWGWIRXAWLXBWNXCVMWRWTWLXBIWSVHWFTUKXAWMWIIWNXCIVDWFTWMWIRSNUGUHU
      IUJULBVDTNUGUHUIUJUL $.

    $( Ordering property of addition.  Proposition 8.4 of [TakeutiZaring]
       p. 58, limited to natural numbers.  (Contributed by NM, 3-Feb-1996.)
       (Revised by Mario Carneiro, 15-Nov-2014.) $)
    nnaordi $p |- ( ( B e. om /\ C e. om ) ->
                 ( A e. B -> ( C +o A ) e. ( C +o B ) ) ) $=
      ( vx vy com wcel coa co wi wa ancoms csuc wss cv wceq oveq2 sseq2d imbi2d
      nnasuc elnn adantll word nnord ordsucss syl ad2antlr peano2b ssid sssucid
      a1ii sstr2 mpi syl5ibr ex ad2antrr findsg exp31 syl5bi com4r imp31 sseq1d
      a2d cvv ovex sucssel ax-mp syl6bi adantlr 3syld imp an32s mpdan ) CFGZBFG
      ZABGZCAHIZCBHIZGZJVNVOKZVPVSVTVPKAFGZVSVOVPWAVNVPVOWAABUALUBVTWAVPVSVTWAK
      ZVPVSWBVPAMZBNZCWCHIZVRNZVSVOVPWDJZVNWAVOBUCWGBUDABUEUFUGVNVOWAWDWFJVOWAW
      DVNWFWAWCFGZVOWDVNWFJZJAUHVOWHWDWIVNWECDOZHIZNZJVNWEWENZJVNWECEOZHIZNZJVN
      WECWNMZHIZNZJWIDEBWCWJWCPZWLWMVNWTWKWEWEWJWCCHQRSWJWNPZWLWPVNXAWKWOWEWJWN
      CHQRSWJWQPZWLWSVNXBWKWRWEWJWQCHQRSWJBPZWLWFVNXCWKVRWEWJBCHQRSWHVNWMWEUIUK
      WNFGZWHKWCWNNZKVNWPWSXDVNWPWSJZJWHXEXDVNXFWPWSXDVNKZWEWOMZNZWPWOXHNXIWOUJ
      WEWOXHULUMXGWRXHWEVNXDWRXHPCWNTLRUNUOUPVCUQURUSUTVAVNWAWFVSJVOVNWAKZWFVQM
      ZVRNZVSXJWEXKVRCATVBVQVDGXLVSJCAHVEVQVRVDVFVGVHVIVJVKVLVMUOL $.
  $}

  $( Ordering property of addition.  Proposition 8.4 of [TakeutiZaring] p. 58,
     limited to natural numbers, and its converse.  (Contributed by NM,
     7-Mar-1996.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
  nnaord $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( A e. B <-> ( C +o A ) e. ( C +o B ) ) ) $=
    ( com wcel coa co wi nnaordi wceq wo wn word wa nnacl nnord anim12i ordtri2
    wb syl w3a 3adant1 oveq2 a1i 3adant2 con3d df-3an ancom anandi 3bitri sylbi
    orim12d 3adant3 3imtr4d impbid ) ADEZBDEZCDEZUAZABEZCAFGZCBFGZEZUQURUTVCHUP
    ABCIUBUSVAVBJZVBVAEZKZLZABJZBAEZKZLZVCUTUSVJVFUSVHVDVIVEVHVDHUSABCFUCUDUPUR
    VIVEHUQBACIUEULUFUSVAMZVBMZNZVCVGSUSURUPNZURUQNZNZVNUSUPUQNZURNURVRNVQUPUQU
    RUGVRURUHURUPUQUIUJVOVLVPVMVOVADEVLCAOVAPTVPVBDEVMCBOVBPTQUKVAVBRTUSAMZBMZN
    ZUTVKSUPUQWAURUPVSUQVTAPBPQUMABRTUNUO $.

  $( Ordering property of addition of natural numbers.  (Contributed by NM,
     9-Nov-2002.) $)
  nnaordr $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( A e. B <-> ( A +o C ) e. ( B +o C ) ) ) $=
    ( com wcel w3a coa nnaord wceq nnacom ancoms 3adant2 3adant1 eleq12d bitrd
    co ) ADEZBDEZCDEZFZABECAGPZCBGPZEACGPZBCGPZEABCHTUAUCUBUDQSUAUCIZRSQUECAJKL
    RSUBUDIZQSRUFCBJKMNO $.

  ${
    $d A x y $.  $d B x y $.  $d C x y $.
    $( Adding to both sides of an inequality in ` om ` (Contributed by Scott
       Fenton, 16-Apr-2012.)  (Revised by Mario Carneiro, 12-May-2012.) $)
    nnawordi $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
             ( A C_ B -> ( A +o C ) C_ ( B +o C ) ) ) $=
      ( vx vy com wcel wss coa co wi wa c0 wceq sseq12d imbi2d con0 nnon ancoms
      oveq2 cv csuc weq oa0 adantr adantl biimprd syl2an wb nnacl adantrr eloni
      word adantrl ordsucsssuc syl2anc biimpa nnasuc mpbird ex imim2d a2d finds
      3syl com12 3impia ) AFGZBFGZCFGZABHZACIJZBCIJZHZKZVIVGVHLZVNVOVJADUAZIJZB
      VPIJZHZKZKVOVJAMIJZBMIJZHZKZKVOVJAEUAZIJZBWEIJZHZKZKVOVJAWEUBZIJZBWJIJZHZ
      KZKVOVNKDECVPMNZVTWDVOWOVSWCVJWOVQWAVRWBVPMAITVPMBITOPPDEUCZVTWIVOWPVSWHV
      JWPVQWFVRWGVPWEAITVPWEBITOPPVPWJNZVTWNVOWQVSWMVJWQVQWKVRWLVPWJAITVPWJBITO
      PPVPCNZVTVNVOWRVSVMVJWRVQVKVRVLVPCAITVPCBITOPPVGAQGZBQGZWDVHARBRWSWTLZWCV
      JXAWAAWBBWSWAANWTAUDUEWTWBBNWSBUDUFOUGUHWEFGZVOWIWNXBVOWIWNKXBVOLZWHWMVJX
      CWHWMXCWHLWMWFUBZWGUBZHZXCWHXFXCWFUMZWGUMZWHXFUIXCWFFGZWFQGXGXBVGXIVHVGXB
      XIAWEUJSUKWFRWFULVDXCWGFGZWGQGXHXBVHXJVGVHXBXJBWEUJSUNWGRWGULVDWFWGUOUPUQ
      XCWMXFUIWHXCWKXDWLXEXBVGWKXDNZVHVGXBXKAWEURSUKXBVHWLXENZVGVHXBXLBWEURSUNO
      UEUSUTVAUTVBVCVEVF $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.
    $( Addition of natural numbers is associative.  Theorem 4K(1) of [Enderton]
       p. 81.  (Contributed by NM, 20-Sep-1995.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    nnaass $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( ( A +o B ) +o C ) = ( A +o ( B +o C ) ) ) $=
      ( vx vy com wcel coa co wceq wa cv wi oveq2 oveq2d eqeq12d c0 csuc nnasuc
      nnacl imbi2d nna0 adantl eqtr4d suceq sylan sylan2 anassrs syl5ibr expcom
      syl eqtrd finds2 vtoclga com12 3impia ) AFGZBFGZCFGZABHIZCHIZABCHIZHIZJZU
      SUQURKZVDVEUTDLZHIZABVFHIZHIZJZMVEVDMDCFVFCJZVJVDVEVKVGVAVIVCVFCUTHNVKVHV
      BAHVFCBHNOPUAVJUTQHIZABQHIZHIZJUTELZHIZABVOHIZHIZJZUTVORZHIZABVTHIZHIZJZV
      EDEVFQJZVGVLVIVNVFQUTHNWEVHVMAHVFQBHNOPVFVOJZVGVPVIVRVFVOUTHNWFVHVQAHVFVO
      BHNOPVFVTJZVGWAVIWCVFVTUTHNWGVHWBAHVFVTBHNOPVEVLUTVNVEUTFGZVLUTJABTZUTUBU
      KURVNUTJUQURVMBAHBUBOUCUDVEVOFGZVSWDMVSWDVEWJKZVPRZVRRZJVPVRUEWKWAWLWCWMV
      EWHWJWAWLJWIUTVOSUFUQURWJWCWMJUQURWJKZKWCAVQRZHIZWMWNWCWPJUQWNWBWOAHBVOSO
      UCWNUQVQFGWPWMJBVOTAVQSUGULUHPUIUJUMUNUOUP $.

    $( Distributive law for natural numbers.  Theorem 4K(3) of [Enderton]
       p. 81.  (Contributed by NM, 20-Sep-1995.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    nndi $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( A .o ( B +o C ) ) = ( ( A .o B ) +o ( A .o C ) ) ) $=
      ( vx vy com wcel coa co comu wceq wa cv wi oveq2 oveq2d eqeq12d c0 eqtr4d
      csuc imbi2d nna0 adantl nnmcl syl nnm0 adantr oveq1 nnasuc 3adant1 nnmsuc
      w3a nnacl sylan2 3impb eqtrd 3adant2 nnaass syl3an1 syl3an2 exp4b pm2.43a
      3exp com4r pm2.43i 3imp syl5ibr com3r imp3a finds2 vtoclga exp3acom3r ) A
      FGZBFGZCFGZABCHIZJIZABJIZACJIZHIZKZVOVMVNWAVMVNLZABDMZHIZJIZVRAWCJIZHIZKZ
      NWBWANDCFWCCKZWHWAWBWIWEVQWGVTWIWDVPAJWCCBHOPWIWFVSVRHWCCAJOPQUAWHABRHIZJ
      IZVRARJIZHIZKABEMZHIZJIZVRAWNJIZHIZKZABWNTZHIZJIZVRAWTJIZHIZKZWBDEWCRKZWE
      WKWGWMXFWDWJAJWCRBHOPXFWFWLVRHWCRAJOPQWCWNKZWEWPWGWRXGWDWOAJWCWNBHOPXGWFW
      QVRHWCWNAJOPQWCWTKZWEXBWGXDXHWDXAAJWCWTBHOPXHWFXCVRHWCWTAJOPQWBWKVRRHIZWM
      WBWKVRXIWBWJBAJVNWJBKVMBUBUCPWBVRFGZXIVRKABUDZVRUBUESWBWLRVRHVMWLRKVNAUFU
      GPSWNFGZVMVNWSXENZVMVNXLXMVMVNXLXMWSXEVMVNXLULZWPAHIZWRAHIZKWPWRAHUHXNXBX
      OXDXPXNXBAWOTZJIZXOXNXAXQAJVNXLXAXQKVMBWNUIUJPVMVNXLXRXOKZVNXLLVMWOFGXSBW
      NUMAWOUKUNUOUPXNXDVRWQAHIZHIZXPXNXCXTVRHVMXLXCXTKVNAWNUKUQPVMVNXLXPYAKZVM
      VNXLYBNNVMVNXLVMYBVNVMXLVMYBNZNVMVNVMXLYCWBVMXLLZVMYBYDWBWQFGZVMYBAWNUDWB
      XJYEVMYBXKVRWQAURUSUTVCVAVBVDVEVFSQVGVCVHVIVJVKVLVF $.

    $( Multiplication of natural numbers is associative.  Theorem 4K(4) of
       [Enderton] p. 81.  (Contributed by NM, 20-Sep-1995.)  (Revised by Mario
       Carneiro, 15-Nov-2014.) $)
    nnmass $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                 ( ( A .o B ) .o C ) = ( A .o ( B .o C ) ) ) $=
      ( vx vy com wcel comu co wceq wa cv wi oveq2 oveq2d eqeq12d c0 nnmcl nnm0
      coa imbi2d csuc syl sylan9eqr eqtr4d w3a oveq1 nnmsuc sylan 3impa 3adant1
      nndi syl3an2 exp3a com34 pm2.43d eqtrd syl5ibr com3r imp3a finds2 vtoclga
      3exp 3imp exp3acom3r ) AFGZBFGZCFGZABHIZCHIZABCHIZHIZJZVHVFVGVMVFVGKZVIDL
      ZHIZABVOHIZHIZJZMVNVMMDCFVOCJZVSVMVNVTVPVJVRVLVOCVIHNVTVQVKAHVOCBHNOPUAVS
      VIQHIZABQHIZHIZJVIELZHIZABWDHIZHIZJZVIWDUBZHIZABWIHIZHIZJZVNDEVOQJZVPWAVR
      WCVOQVIHNWNVQWBAHVOQBHNOPVOWDJZVPWEVRWGVOWDVIHNWOVQWFAHVOWDBHNOPVOWIJZVPW
      JVRWLVOWIVIHNWPVQWKAHVOWIBHNOPVNWAQWCVNVIFGZWAQJABRZVISUCVGVFWCAQHIQVGWBQ
      AHBSOASUDUEWDFGZVFVGWHWMMZVFVGWSWTVFVGWSWTWHWMVFVGWSUFZWEVITIZWGVITIZJWEW
      GVITUGXAWJXBWLXCVFVGWSWJXBJZVNWQWSXDWRVIWDUHUIUJXAWLAWFBTIZHIZXCXAWKXEAHV
      GWSWKXEJVFBWDUHUKOVFVGWSXFXCJZVFVGWSXGMVFVGWSVGXGVFVGWSVGXGMVFVGWSKZVGXGX
      HVFWFFGVGXGBWDRAWFBULUMVCUNUOUPVDUQPURVCUSUTVAVBVEVD $.

    $( Multiplication with successor.  Exercise 16 of [Enderton] p. 82.
       (Contributed by NM, 21-Sep-1995.)  (Proof shortened by Andrew Salmon,
       22-Oct-2011.) $)
    nnmsucr $p |- ( ( A e. om /\ B e. om ) ->
                  ( suc A .o B ) = ( ( A .o B ) +o B ) ) $=
      ( vx vy com wcel csuc comu co coa wceq cv wi oveq2 id oveq12d eqeq12d syl
      c0 eqtr4d imbi2d peano2 nnm0 peano1 nnmcl mpan2 nna0 oveq1 peano2b nnmsuc
      wa sylanb nnaass syl3an3b syl3an1 3expb anidms oveq1d an42s nnacom nnasuc
      suceq ancoms 3eqtr4d oveq2d syl5ibr expcom finds2 vtoclga impcom ) BEFAEF
      ZAGZBHIZABHIZBJIZKZVKVLCLZHIZAVQHIZVQJIZKZMVKVPMCBEVQBKZWAVPVKWBVRVMVTVOV
      QBVLHNWBVSVNVQBJVQBAHNWBOPQUAWAVLSHIZASHIZSJIZKVLDLZHIZAWFHIZWFJIZKZVLWFG
      ZHIZAWKHIZWKJIZKZVKCDVQSKZVRWCVTWEVQSVLHNWPVSWDVQSJVQSAHNWPOPQVQWFKZVRWGV
      TWIVQWFVLHNWQVSWHVQWFJVQWFAHNWQOPQVQWKKZVRWLVTWNVQWKVLHNWRVSWMVQWKJVQWKAH
      NWROPQVKWCWDWEVKWCSWDVKVLEFZWCSKAUBVLUCRAUCTVKWDEFZWEWDKVKSEFWTUDASUEUFWD
      UGRTVKWFEFZWJWOMWJWOVKXAUKZWGVLJIZWIVLJIZKWGWIVLJUHXBWLXCWNXDVKWSXAWLXCKA
      UIZVLWFUJULXBWHAJIZWKJIZWHAWKJIZJIZWNXDXBXGXIKZXBVKXAXJXBWHEFZVKXAXJAWFUE
      ZXAXKVKWKEFXJWFUIWHAWKUMUNUOUPUQXBWMXFWKJAWFUJURXBXDWHWFVLJIZJIZXIXBXDXNK
      ZVKXAXAVKXOXBXAVKXOXBXKXAVKXOXLVKXKXAWSXOXEWHWFVLUMUNUOUPUSUQXBXHXMWHJXBA
      WFJIZGZWFAJIZGZXHXMXBXPXRKXQXSKAWFUTXPXRVBRAWFVAXAVKXMXSKWFAVAVCVDVETVDQV
      FVGVHVIVJ $.

    $( Multiplication of natural numbers is commutative.  Theorem 4K(5) of
       [Enderton] p. 81.  (Contributed by NM, 21-Sep-1995.)  (Proof shortened
       by Andrew Salmon, 22-Oct-2011.) $)
    nnmcom $p |- ( ( A e. om /\ B e. om ) -> ( A .o B ) = ( B .o A ) ) $=
      ( vx vy com wcel comu co wceq cv wi oveq1 oveq2 eqeq12d imbi2d csuc nnm0r
      c0 nnm0 coa eqtr4d wa nnmsucr nnmsuc ancoms syl5ibr ex finds2 vtoclga imp
      ) AEFBEFZABGHZBAGHZIZUKCJZBGHZBUOGHZIZKUKUNKCAEUOAIZURUNUKUSUPULUQUMUOABG
      LUOABGMNOURRBGHZBRGHZIDJZBGHZBVBGHZIZVBPZBGHZBVFGHZIZUKCDUORIUPUTUQVAUORB
      GLUORBGMNUOVBIUPVCUQVDUOVBBGLUOVBBGMNUOVFIUPVGUQVHUOVFBGLUOVFBGMNUKUTRVAB
      QBSUAVBEFZUKVEVIKVEVIVJUKUBZVCBTHZVDBTHZIVCVDBTLVKVGVLVHVMVBBUCUKVJVHVMIB
      VBUDUENUFUGUHUIUJ $.
  $}

  $( Weak ordering property of addition.  (Contributed by NM, 17-Sep-1995.)
     (Revised by Mario Carneiro, 15-Nov-2014.) $)
  nnaword $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                ( A C_ B <-> ( C +o A ) C_ ( C +o B ) ) ) $=
    ( com wcel w3a wn coa co wss nnaord 3com12 notbid word nnord ordtri1 syl2an
    wb nnacl ancoms 3adant3 3adant2 3adant1 syl2anc 3bitr4d ) ADEZBDEZCDEZFZBAE
    ZGZCBHIZCAHIZEZGZABJZUMULJZUIUJUNUGUFUHUJUNRBACKLMUFUGUPUKRZUHUFANBNURUGAOB
    OABPQUAUIUMDEZULDEZUQUORZUFUHUSUGUHUFUSCASTUBUGUHUTUFUHUGUTCBSTUCUSUMNULNVA
    UTUMOULOUMULPQUDUE $.

  $( Cancellation law for addition of natural numbers.  (Contributed by NM,
     27-Oct-1995.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
  nnacan $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                   ( ( A +o B ) = ( A +o C ) <-> B = C ) ) $=
    ( com wcel w3a coa co wss wa wb nnaword 3comr 3com13 anbi12d bicomd 3bitr4g
    wceq eqss ) ADEZBDEZCDEZFZABGHZACGHZIZUEUDIZJZBCIZCBIZJZUDUERBCRUCUKUHUCUIU
    FUJUGUAUBTUIUFKBCALMUBUATUJUGKCBALNOPUDUESBCSQ $.

  $( Weak ordering property of addition.  (Contributed by NM, 9-Nov-2002.)
     (Revised by Mario Carneiro, 15-Nov-2014.) $)
  nnaword1 $p |- ( ( A e. om /\ B e. om ) -> A C_ ( A +o B ) ) $=
    ( com wcel wa c0 coa co wceq adantr wss 0ss wb peano1 nnaword 3com13 mp3an3
    nna0 mpbii eqsstr3d ) ACDZBCDZEZAAFGHZABGHZUAUDAIUBARJUCFBKZUDUEKZBLUAUBFCD
    ZUFUGMZNUHUBUAUIFBAOPQST $.

  $( Weak ordering property of addition.  (Contributed by NM, 9-Nov-2002.) $)
  nnaword2 $p |- ( ( A e. om /\ B e. om ) -> A C_ ( B +o A ) ) $=
    ( com wcel wa coa co nnaword1 nnacom sseqtrd ) ACDBCDEAABFGBAFGABHABIJ $.

  ${
    $d x y A $.  $d x B $.  $d x y C $.
    $( Ordering property of multiplication.  Half of Proposition 8.19 of
       [TakeutiZaring] p. 63, limited to natural numbers.  (Contributed by NM,
       18-Sep-1995.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
    nnmordi $p |- ( ( ( B e. om /\ C e. om ) /\ (/) e. C ) ->
                    ( A e. B -> ( C .o A ) e. ( C .o B ) ) ) $=
      ( vx vy com wcel c0 comu co wi wa wceq eleq2 oveq2 eleq2d imbi12d coa imp
      cv elnn expcom imbi2d csuc pm2.21i a1i wo elsuci nnmcl simpl jca nnaword1
      noel sseld imim2d adantrl nna0 ad2antrr ancoms eqeltrrd eleq1d syl5ibrcom
      nnaordi adantrr jaod sylan syl5 nnmsuc adantr sylibrd exp43 com12 adantld
      wb imp3a finds2 vtoclga com23 exp4a mpdd com34 com24 imp31 ) BFGZCFGZHCGZ
      ABGZCAIJZCBIJZGZKZWDWGWFWEWJWDWGWEWFWJWDWGAFGZWEWFWJKZKWGWDWLABUAUBWDWGWL
      WEWMWDWGWLWELZWFWJWDWNWFLZWGWJWOADTZGZWHCWPIJZGZKZKWOWKKDBFWPBMZWTWKWOXAW
      QWGWSWJWPBANXAWRWIWHWPBCIOPQUCWTAHGZWHCHIJZGZKZAETZGZWHCXFIJZGZKZAXFUDZGZ
      WHCXKIJZGZKZWODEWPHMZWQXBWSXDWPHANXPWRXCWHWPHCIOPQWPXFMZWQXGWSXIWPXFANXQW
      RXHWHWPXFCIOPQWPXKMZWQXLWSXNWPXKANXRWRXMWHWPXKCIOPQXEWOXBXDAUMUEUFXFFGZWN
      WFXJXOKZXSWEWFXTKZWLWEXSYAWEXSWFXJXOWEXSLZWFXJLZLZXLWHXHCRJZGZXNXLXGAXFMZ
      UGZYDYFAXFUHYBXHFGZWELZYCYHYFKYBYIWECXFUIWEXSUJUKYJYCLXGYFYGYJXJXGYFKZWFY
      JXJYKYJXIYFXGYJXHYEWHXHCULUNUOSUPYJWFYGYFKXJYJWFLZYFYGXHYEGYLXHHRJZXHYEYI
      YMXHMWEWFXHUQURYJWFYMYEGZWEYIWFYNKHCXHVCUSSUTYGWHXHYEAXFCIOVAVBVDVEVFVGYB
      XNYFVNYCYBXMYEWHCXFVHPVIVJVKVLVMVOVPVQVRVSVSVTWAWBWC $.
  $}

  $( Ordering property of multiplication.  Proposition 8.19 of [TakeutiZaring]
     p. 63, limited to natural numbers.  (Contributed by NM, 22-Jan-1996.)
     (Revised by Mario Carneiro, 15-Nov-2014.) $)
  nnmord $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
               ( ( A e. B /\ (/) e. C ) <-> ( C .o A ) e. ( C .o B ) ) ) $=
    ( com wcel c0 wa comu co wi nnmordi ex com23 3adant1 wne wceq wb word nnord
    syl2anc w3a imp3a ne0i nnm0r eqeq1d syl5ibrcom necon3d syl5 adantr ord0eln0
    oveq1 syl adantl sylibrd wo wn oveq2 a1i 3adantl2 con3d simpl3 simpl1 nnmcl
    orim12d simpl2 ordtri2 syl2an 3imtr4d mpdd jcad impbid ) ADEZBDEZCDEZUAZABE
    ZFCEZGZCAHIZCBHIZEZVMVNVRWAJVLVMVNGZVPVQWAWBVQVPWAWBVQVPWAJABCKLMUBNVOWAVPV
    QVOWAVQVPVMVNWAVQJVLWBWACFOZVQVMWAWCJVNWAVTFOVMWCVTVSUCVMCFVTFVMVTFPCFPZFBH
    IZFPBUDWDVTWEFCFBHUKUEUFUGUHUIVNVQWCQZVMVNCRWFCSCUJULUMUNNZVOVQWAVPVOVQWAVP
    JVOVQGZVSVTPZVTVSEZUOZUPZABPZBAEZUOZUPZWAVPWHWOWKWHWMWIWNWJWMWIJWHABCHUQURV
    LVNVQWNWJJVMBACKUSVDUTWHVSDEZVTDEZWAWLQZWHVNVLWQVLVMVNVQVAZVLVMVNVQVBZCAVCT
    WHVNVMWRWTVLVMVNVQVEZCBVCTWQVSRVTRWSWRVSSVTSVSVTVFVGTWHVLVMVPWPQZXAXBVLARBR
    XCVMASBSABVFVGTVHLMVIWGVJVK $.

  $( Weak ordering property of ordinal multiplication.  (Contributed by Mario
     Carneiro, 17-Nov-2014.) $)
  nnmword $p |- ( ( ( A e. om /\ B e. om /\ C e. om ) /\ (/) e. C ) ->
                  ( A C_ B <-> ( C .o A ) C_ ( C .o B ) ) ) $=
    ( com wcel w3a c0 wa wn comu co wss iba con0 nnon syl ontri1 syl2anc nnmcl
    wb nnmord 3com12 sylan9bbr notbid simpl1 simpl2 simpl3 3bitr4d ) ADEZBDEZCD
    EZFZGCEZHZBAEZIZCBJKZCAJKZEZIZABLZURUQLZUNUOUSUMUOUOUMHZULUSUMUOMUJUIUKVCUS
    TBACUAUBUCUDUNANEZBNEZVAUPTUNUIVDUIUJUKUMUEZAOPUNUJVEUIUJUKUMUFZBOPABQRUNUR
    NEZUQNEZVBUTTUNURDEZVHUNUKUIVJUIUJUKUMUGZVFCASRUROPUNUQDEZVIUNUKUJVLVKVGCBS
    RUQOPURUQQRUH $.

  $( Cancellation law for multiplication of natural numbers.  (Contributed by
     NM, 26-Oct-1995.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
  nnmcan $p |- ( ( ( A e. om /\ B e. om /\ C e. om ) /\ (/) e. A ) ->
                   ( ( A .o B ) = ( A .o C ) <-> B = C ) ) $=
    ( com wcel w3a c0 comu wss wceq 3anrot nnmword sylanb 3anrev anbi12d bicomd
    wa co wb eqss 3bitr4g ) ADEZBDEZCDEZFZGAEZQZABHRZACHRZIZUIUHIZQZBCIZCBIZQZU
    HUIJBCJUGUOULUGUMUJUNUKUEUCUDUBFUFUMUJSUBUCUDKBCALMUEUDUCUBFUFUNUKSUBUCUDNC
    BALMOPUHUITBCTUA $.

  $( Weak ordering property of multiplication.  (Contributed by Mario Carneiro,
     17-Nov-2014.) $)
  nnmwordi $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                  ( A C_ B -> ( C .o A ) C_ ( C .o B ) ) ) $=
    ( com wcel w3a c0 wss comu co wi wa nnmword biimpd ex wn wceq nnm0r sseq12d
    oveq1 word nnord ord0eln0 necon2bbid syl 3ad2ant3 ssid adantr adantl mpbiri
    wb syl5ibrcom 3adant3 sylbird a1dd pm2.61d ) ADEZBDEZCDEZFZGCEZABHZCAIJZCBI
    JZHZKZUTVAVFUTVALVBVEABCMNOUTVAPZVEVBUTVGCGQZVEUSUQVHVGUKZURUSCUAZVICUBVJVA
    CGCUCUDUEUFUQURVHVEKUSUQURLZVEVHGAIJZGBIJZHZVKVNGGHGUGVKVLGVMGUQVLGQURARUHU
    RVMGQUQBRUISUJVHVCVLVDVMCGAITCGBITSULUMUNUOUP $.

  $( Weak ordering property of ordinal multiplication.  Proposition 8.21 of
     [TakeutiZaring] p. 63, limited to natural numbers.  (Contributed by Mario
     Carneiro, 17-Nov-2014.) $)
  nnmwordri $p |- ( ( A e. om /\ B e. om /\ C e. om ) ->
                    ( A C_ B -> ( A .o C ) C_ ( B .o C ) ) ) $=
    ( com wcel w3a comu co nnmwordi wceq nnmcom 3adant2 3adant1 sseq12d sylibrd
    wss ) ADEZBDEZCDEZFZABPCAGHZCBGHZPACGHZBCGHZPABCITUCUAUDUBQSUCUAJRACKLRSUDU
    BJQBCKMNO $.

  ${
    $d x y A $.  $d x y B $.
    $( Equivalence for weak ordering of natural numbers.  (Contributed by NM,
       8-Nov-2002.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
    nnawordex $p |- ( ( A e. om /\ B e. om ) -> ( A C_ B <->
                  E. x e. om ( A +o x ) = B ) ) $=
      ( vy com wcel wa wss coa co wceq con0 syl2anc oveq2 sseq2d word c0 adantr
      syl nfcv wrex crab cint simplr nnon simpll nnaword2 elrab sylanbrc intss1
      cv wne ssrab2 ne0i oninton sylancr eloni ordom ordtr2 sylancl mp2and csuc
      nna0 ad2antrr simpr eqsstrd sseq1d syl5ibrcom simprr oveq2d simprl nnasuc
      wi eqtrd nnord wn sucid syl5eleqr onnminsb sylc adantl wb ordtri1 con2bid
      nnacl mpbird ordsucss rexlimdvaa wo nn0suc mpjaod onint nfrab1 nfint nfov
      vex nfss elrabf simprbi eqssd eqeq1d rspcev ex nnaword1 adantlr syl5ibcom
      sseq2 rexlimdva impbid ) BEFZCEFZGZBCHZBAUKZIJZCKZAEUAZXLXMXQXLXMGZCBDUKZ
      IJZHZDLUBZUCZEFZBYCIJZCKZXQXRYCCHZXKYDXRCYBFZYGXRCLFZCBCIJZHZYHXRXKYIXJXK
      XMUDZCUESXRXKXJYKYLXJXKXMUFZCBUGMYAYKDCLXSCKXTYJCXSCBINOUHUIZCYBUJSYLXRYC
      PZEPYGXKGYDVMXRYCLFZYOXRYBLHZYBQULZYPYADLUMZXRYHYRYNYBCUNSZYBUOUPYCUQSURY
      CCEUSUTVAZXRYECXRYCQKZYECHZYCXNVBZKZAEUAZXRUUCUUBBQIJZCHXRUUGBCXJUUGBKXKX
      MBVCVDXLXMVEVFUUBYEUUGCYCQBINVGVHXRUUEUUCAEXRXNEFZUUEGZGZYEXOVBZCUUJYEBUU
      DIJZUUKUUJYCUUDBIXRUUHUUEVIVJUUJXJUUHUULUUKKXRXJUUIYMRZXRUUHUUEVKZBXNVLMV
      NUUJCPZXOCFZUUKCHXRUUOUUIXRXKUUOYLCVOSRZUUJUUPCXOHZVPZUUIUUSXRUUIXNLFZXNY
      CFUUSUUHUUTUUEXNUERUUIXNUUDYCXNAWPVQUUHUUEVEVRYAUURDXNXSXNKXTXOCXSXNBINOV
      SVTWAUUJUURUUPUUJUUOXOPZUURUUPVPWBUUQUUJXOEFZUVAUUJXJUUHUVBUUMUUNBXNWEMXO
      VOSCXOWCMWDWFXOCWGVTVFWHXRYDUUBUUFWIUUAAYCWJSWKXRYCYBFZCYEHZXRYQYRUVCYSYT
      YBWLUPUVCYPUVDYAUVDDYCLDYBYADLWMWNZDLTDCYEDCTDBYCIDBTDITUVEWOWQXSYCKXTYEC
      XSYCBINOWRWSSWTXPYFAYCEXNYCKXOYECXNYCBINXAXBMXCXLXPXMAEXLUUHGBXOHZXPXMXJU
      UHUVFXKBXNXDXEXOCBXGXFXHXI $.

    $( Equivalence for ordering.  Compare Exercise 23 of [Enderton] p. 88.
       (Contributed by NM, 5-Dec-1995.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    nnaordex $p |- ( ( A e. om /\ B e. om ) -> ( A e. B <->
                  E. x e. om ( (/) e. x /\ ( A +o x ) = B ) ) ) $=
      ( com wcel wa c0 cv coa co wceq wrex con0 wi nnon adantl onelss wb adantr
      wss nnawordex sylibd simplr syl5ibrcom peano1 nnaord mp3an1 ancoms eleq1d
      syl eleq2 nna0 bitrd adantlr sylibrd ancrd reximdva mpdd biimpa syl5ibcom
      ex expimpd rexlimdva impbid ) BDEZCDEZFZBCEZGAHZEZBVIIJZCKZFZADLZVGVHVLAD
      LZVNVGVHBCTZVOVGCMEZVHVPNVFVQVECOPCBQUJABCUAUBVEVHVOVNNZNVFVEVHVRVEVHFZVL
      VMADVSVIDEZFZVLVJWAVLBVKEZVJWAWBVLVHVEVHVTUCVKCBUKZUDVEVTVJWBRVHVEVTFZVJB
      GIJZVKEZWBVTVEVJWFRZGDEVTVEWGUEGVIBUFUGUHWDWEBVKVEWEBKVTBULSUIUMZUNUOUPUQ
      VASURVEVNVHNVFVEVMVHADWDVJVLVHWDVJFWBVLVHWDVJWBWHUSWCUTVBVCSVD $.
  $}

  $( One is a natural number.  (Contributed by NM, 29-Oct-1995.) $)
  1onn $p |- 1o e. om $=
    ( c1o c0 csuc com df-1o wcel peano1 peano2 ax-mp eqeltri ) ABCZDEBDFKDFGBHI
    J $.

  $( The ordinal 2 is a natural number.  (Contributed by NM, 28-Sep-2004.) $)
  2onn $p |- 2o e. om $=
    ( c2o c1o csuc com df-2o wcel 1onn peano2 ax-mp eqeltri ) ABCZDEBDFKDFGBHIJ
    $.

  $( The ordinal 3 is a natural number.  (Contributed by Mario Carneiro,
     5-Jan-2016.) $)
  3onn $p |- 3o e. om $=
    ( c3o c2o csuc com df-3o wcel 2onn peano2 ax-mp eqeltri ) ABCZDEBDFKDFGBHIJ
    $.

  $( The ordinal 4 is a natural number.  (Contributed by Mario Carneiro,
     5-Jan-2016.) $)
  4onn $p |- 4o e. om $=
    ( c4o c3o csuc com df-4o wcel 3onn peano2 ax-mp eqeltri ) ABCZDEBDFKDFGBHIJ
    $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Lemma for ~ oaabs .  (Contributed by NM, 9-Dec-2004.) $)
    oaabslem $p |- ( ( om e. On /\ A e. om ) -> ( A +o om ) = om ) $=
      ( vx com con0 wcel wa coa co wss cv ciun wlim wceq nnon limom jctr syl2an
      oalim wral word ordom nnacl ordelss sylancr ralrimiva iunss sylibr adantr
      eqsstrd ancoms oaword2 sylan2 eqssd ) CDEZACEZFACGHZCUOUNUPCIUOUNFUPBCABJ
      ZGHZKZCUOADEZUNCLZFUPUSMUNANZUNVAOPBACDRQUOUSCIZUNUOURCIZBCSVCUOVDBCUOUQC
      EFCTURCEVDUAAUQUBCURUCUDUEBCURCUFUGUHUIUJUOUNUTCUPIVBCAUKULUM $.

    $( Ordinal addition absorbs a natural number added to the left of a
       transfinite number.  Proposition 8.10 of [TakeutiZaring] p. 59.
       (Contributed by NM, 9-Dec-2004.)  (Proof shortened by Mario Carneiro,
       29-May-2015.) $)
    oaabs $p |- ( ( ( A e. om /\ B e. On ) /\ om C_ B ) -> ( A +o B ) = B ) $=
      ( vx com wcel con0 wa wss cv coa wceq wrex wreu cvv ssexg omelon2 syl6com
      co ex adantr imp adantll simplr jca oawordeu sylancom syl ad3antrrr simpr
      reurex nnon oaass syl3anc simpll oaabslem syl2anc oveq1d oveq2 id eqeq12d
      eqtr3d syl5ibcom rexlimdva mpd ) ADEZBFEZGZDBHZGZDCIZJRZBKZCFLZABJRZBKZVI
      VLCFMZVMVGVHDFEZVFGVPVIVQVFVFVHVQVEVFVHVQVHVFDNEZVQVHVFVRDBFOSPQUAUBZVEVF
      VHUCUDCDBUEUFVLCFUJUGVIVLVOCFVIVJFEZGZAVKJRZVKKVLVOWAADJRZVJJRZWBVKWAAFEZ
      VQVTWDWBKVEWEVFVHVTAUKUHVIVQVTVSTVIVTUIADVJULUMWAWCDVJJVIWCDKZVTVIVQVEWFV
      SVEVFVHUNAUOUPTUQVAVLWBVNVKBVKBAJURVLUSUTVBVCVD $.

    $( The absorption law ~ oaabs is also a property of higher powers of
       ` om ` .  (Contributed by Mario Carneiro, 29-May-2015.) $)
    oaabs2 $p |- ( ( ( A e. ( om ^o C ) /\ B e. On ) /\ ( om ^o C ) C_ B ) ->
        ( A +o B ) = B ) $=
      ( vx vy com coe co wcel con0 wa wss coa wceq c0 syl syl2anc adantr c1o wi
      vz cv wrex wreu n0i cxp wfn cdm fnoe fndm ax-mp ndmov nsyl2 ad2antrr oecl
      simplr simpr oawordeu syl21anc reurex simpll onelon syl3anc csuc wlim w3o
      oaass word simprd eloni ordzsl sylib simplll simpld oe0 sylan9eqr eleqtrd
      oveq2 el1o oveq1d oa0r eqtrd ex simprl limom jctir simprr oveq2d omordlim
      comu oesuc nnon ad2antrl ordelss oawordri mpd odi oaabslem eqtr3d 3eqtr4d
      omcl sseqtrd rexlimddv oaword2 eqssd rexlimdvaa cdif ciun oelim2 syl12anc
      eliun eldifi c2o 1onn ondif2 sylanbrc oelimcl oalim wral wb eleq2d syl6bb
      a1i simplrl simplrr ssun1 ad3antrrr ordunel peano1 oewordi syl31anc sstrd
      cun mpi ordsucss 1on suceloni expr sylan2 rexlimdva ssun2 mpbid ordom mp2
      oaword mp1i omwordi omsuc om1 eqtr2d 3sstr4d sylbid ralrimiv iunss sylibr
      sylc eqsstrd 3jaod id eqeq12d syl5ibcom ) AFCGHZIZBJIZKZUVBBLZKZUVBDUBZMH
      ZBNZDJUCZABMHZBNZUVGUVJDJUDZUVKUVGUVBJIZUVDUVFUVNUVGFJIZCJIZKZUVOUVCUVRUV
      DUVFUVCUVBONUVRUVBAUEFCJGGJJUFZUGGUHUVSNUIUVSGUJUKULUMUNZFCUOPZUVCUVDUVFU
      PUVEUVFUQDUVBBURUSUVJDJUTPUVGUVJUVMDJUVGUVHJIZKZAUVIMHZUVINUVJUVMUWCAUVBM
      HZUVHMHZUWDUVIUWCAJIZUVOUWBUWFUWDNUVGUWGUWBUVGUVOUVCUWGUWAUVCUVDUVFVAUVBA
      VBQZRUVGUVOUWBUWARUVGUWBUQAUVBUVHVGVCUWCUWEUVBUVHMUVGUWEUVBNZUWBUVGCONZCU
      VHVDZNZDJUCZCVEZVFZUWIUVGCVHZUWOUVGUVQUWPUVGUVPUVQUVTVIZCVJPZDCVKVLUVGUWJ
      UWIUWMUWNUVGUWJUWIUVGUWJKZUWEOUVBMHZUVBUWSAOUVBMUWSASIAONUWSAUVBSUVCUVDUV
      FUWJVMUWJUVGUVBFOGHZSCOFGVRUVGUVPUXASNUVGUVPUVQUVTVNZFVOPVPVQAVSVLVTUWSUV
      OUWTUVBNUVGUVOUWJUWARUVBWAPWBWCUVGUWLUWIDJUVGUWBUWLKZKZUWEUVBUXDAFUVHGHZE
      UBZWJHZIZUWEUVBLZEFUXDUXEJIZUVPFVEZKAUXEFWJHZIUXHEFUCUXDUVPUWBUXJUVGUVPUX
      CUXBRZUVGUWBUWLWDZFUVHUOZQZUXDUVPUXKUXMWEWFUXDAUVBUXLUVCUVDUVFUXCVMUXDUVB
      FUWKGHZUXLUXDCUWKFGUVGUWBUWLWGWHUXDUVPUWBUXQUXLNUXMUXNFUVHWKQWBZVQEUXEFAJ
      WIUSUXDUXFFIZUXHKZKZUWEUXGUVBMHZUVBUYAAUXGLZUWEUYBLZUYAUXGVHZUXHUYCUYAUXG
      JIZUYEUYAUXJUXFJIZUYFUXDUXJUXTUXPRZUXSUYGUXDUXHUXFWLWMZUXEUXFXAQZUXGVJPUX
      DUXSUXHWGUXGAWNQUYAUWGUYFUVOUYCUYDTUVGUWGUXCUXTUWHUNUYJUVGUVOUXCUXTUWAUNA
      UXGUVBWOVCWPUYAUXGUXLMHZUXLUYBUVBUYAUXEUXFFMHZWJHZUYKUXLUYAUXJUYGUVPUYMUY
      KNUYHUYIUXDUVPUXTUXMRZUXEUXFFWQVCUYAUYLFUXEWJUYAUVPUXSUYLFNUYNUXDUXSUXHWD
      UXFWRQWHWSUYAUVBUXLUXGMUXDUVBUXLNUXTUXRRZWHUYOWTXBXCUVGUVBUWELZUXCUVGUVOU
      WGUYPUWAUWHUVBAXDQZRXEXFUVGUWNUWIUVGUWNKZUWEUVBUYRAUXEIZDCSXGZUCZUXIUYRAD
      UYTUXEXHZIVUAUYRAUVBVUBUVCUVDUVFUWNVMUYRUVPUVQUWNUVBVUBNUVGUVPUWNUXBRZUVG
      UVQUWNUWQRZUVGUWNUQZDFCJXIXJVQDAUYTUXEXKVLUYRUYSUXIDUYTUVHUYTIUYRUVHCIZUY
      SUXITUVHCSXLUYRVUFUYSUXIUYRVUFUYSKZKZUWEEUVBAUXFMHZXHZUVBVUHUWGUVOUVBVEZU
      WEVUJNUVGUWGUWNVUGUWHUNZUVGUVOUWNVUGUWAUNVUHFJXMXGIZUVQUWNVUKVUHUVPSFIZVU
      MUYRUVPVUGVUCRZVUNVUHXNYCFXOXPUYRUVQVUGVUDRZUVGUWNVUGUPFCJXQXJEAUVBJXRXJV
      UHVUIUVBLZEUVBXSVUJUVBLVUHVUQEUVBVUHUXFUVBIZUXFFUAUBZGHZIZUAUYTUCZVUQUYRV
      URVVBXTVUGUYRVURUXFUAUYTVUTXHZIVVBUYRUVBVVCUXFUYRUVPUVQUWNUVBVVCNVUCVUDVU
      EUAFCJXIXJYAUAUXFUYTVUTXKYBRVUHVVAVUQUAUYTVUSUYTIVUHVUSCIZVVAVUQTVUSCSXLV
      UHVVDVVAVUQVUHVVDVVAKZKZVUIFUVHVUSYMZVDZGHZUVBVVFVUIFVVGGHZVVJMHZVVIVVFVU
      IVVJUXFMHZVVKVVFAVVJLZVUIVVLLZVVFAUXEVVJVVFUXEVHZUYSAUXELVVFUXJVVOVVFUVPU
      WBUXJVUHUVPVVEVUORZVVFUVQVUFUWBVUHUVQVVEVUPRZUYRVUFUYSVVEYDZCUVHVBQZUXOQU
      XEVJPUYRVUFUYSVVEYEUXEAWNQVVFUVHVVGLZUXEVVJLZUVHVUSYFVVFUWBVVGJIZUVPOFIZV
      VTVWATVVSVVFUVQVVGCIZVWBVVQVVFUWPVUFVVDVWDUVGUWPUWNVUGVVEUWRYGZVVRVUHVVDV
      VAWDZCUVHVUSYHVCZCVVGVBQZVVPVWCVVFYIYCZUVHVVGFYJYKYNYLVVFUWGVVJJIZUYGVVMV
      VNTVUHUWGVVEVULRVVFUVPVWBVWJVVPVWHFVVGUOQZVVFVUTJIZVVAUYGVVFUVPVUSJIZVWLV
      VPVVFUVQVVDVWMVVQVWFCVUSVBQZFVUSUOQZVUHVVDVVAWGZVUTUXFVBQZAVVJUXFWOVCWPVV
      FUXFVVJLZVVLVVKLZVVFUXFVUTVVJVVFVUTVHZVVAUXFVUTLVVFVWLVWTVWOVUTVJPVWPVUTU
      XFWNQVVFVUSVVGLZVUTVVJLZVUSUVHUUAVVFVWMVWBUVPVWCVXAVXBTVWNVWHVVPVWIVUSVVG
      FYJYKYNYLVVFUYGVWJVWJVWRVWSXTVWQVWKVWKUXFVVJVVJUUEVCUUBYLVVFVVJSVDZWJHZVV
      JFWJHZVVKVVIVVFVXCFLZVXDVXELZFVHVUNVXFUUCXNSFYOUUDVVFVXCJIZUVPVWJVXFVXGTS
      JIZVXHVVFYPSYQUUFVVPVWKVXCFVVJUUGVCYNVVFVXDVVJSWJHZVVJMHZVVKVVFVWJVXIVXDV
      XKNVWKVXIVVFYPYCVVJSUUHQVVFVXJVVJVVJMVVFVWJVXJVVJNVWKVVJUUIPVTUUJVVFUVPVW
      BVVIVXENVVPVWHFVVGWKQUUKYLVVFVVHCLZVVIUVBLZVVFUWPVWDVXLVWEVWGVVGCYOUUPVVF
      VVHJIZUVQUVPVWCVXLVXMTVVFVWBVXNVWHVVGYQPVVQVVPVWIVVHCFYJYKWPYLYRYSYTUULUU
      MEUVBVUIUVBUUNUUOUUQYRYSYTWPUVGUYPUWNUYQRXEWCUURWPRVTWSUVJUWDUVLUVIBUVIBA
      MVRUVJUUSUUTUVAYTWP $.

    $( Lemma for ~ omabs .  (Contributed by Mario Carneiro, 30-May-2015.) $)
    omabslem $p |- ( ( om e. On /\ A e. om /\ (/) e. A ) ->
        ( A .o om ) = om ) $=
      ( vx com con0 wcel c0 w3a comu co wa ciun wlim wceq nnon limom jctr omlim
      wss cv syl2an wral word ordom nnmcl ordelss ralrimiva iunss sylibr adantr
      sylancr eqsstrd ancoms 3adant3 omword2 3impa syl3an2 eqssd ) CDEZACEZFAEZ
      GACHIZCURUSVACRZUTUSURVBUSURJVABCABSZHIZKZCUSADEZURCLZJVAVEMURANZURVGOPBA
      CDQTUSVECRZURUSVDCRZBCUAVIUSVJBCUSVCCEJCUBVDCEVJUCAVCUDCVDUEUJUFBCVDCUGUH
      UIUKULUMUSURVFUTCVARZVHURVFUTVKCAUNUOUPUQ $.

    $( Ordinal multiplication is also absorbed by powers of ` om ` .
       (Contributed by Mario Carneiro, 30-May-2015.) $)
    omabs $p |- ( ( ( A e. om /\ (/) e. A ) /\ ( B e. On /\ (/) e. B ) ) ->
        ( A .o ( om ^o B ) ) = ( om ^o B ) ) $=
      ( vy vz com wcel c0 wa con0 coe co comu wi oveq2d eqeq12d adantr ad2antrr
      wceq syl syl2anc vx cv csuc eleq2 oveq2 imbi12d pm2.21i a1i simprl simpll
      noel simplr omabslem syl3anc c1o suceq df-1o syl6eqr oe1 ad2antrl 3eqtr4d
      sylan9eqr ex a1dd oveq1 oesuc adantl nnon oecl omass eqtr4d syl5ibr com23
      imim2d simprr on0eqel mpjaod anassrs expcom wlim wral ad3antrrr cvv jctil
      ciun vex limelon c2o cdif 1onn ondif2 sylanbrc oelimcl omlim syl12anc wss
      wo wrex simplrl oelim2 eleq2d eliun syl6bb wb wne onelon on0eln0 pm5.32da
      anass dif1o syl6bbr anbi1d syl5bbr rexbidv2 bitr4d r19.29 imp anim1i word
      anasss eloni omord2 syl31anc mpbid eleqtrd oeord mp2and ordelss rexlimdva
      ontr1 syl5 expdimp sylbid ralrimiv iunss sylibr eqsstrd simpllr omword2
      id syl21anc eqssd tfinds3 com12 adantrr imp32 an32s nnm0 cxp wfn cdm fnoe
      wn fndm ax-mp ndmov pm2.61dan ) AEFZGAFZHZBIFZGBFZHZHZEIFZUVAHZAEBJKZLKZU
      VGRZUUTUVFUVCUVIUUTUVFHUVAUVBUVIUUTUVEUVAUVBUVIMZMUVAUVAUUTUVEHZUVJGUAUBZ
      FZAEUVLJKZLKZUVNRZMZGGFZAEGJKZLKZUVSRZMZGCUBZFZAEUWCJKZLKZUWERZMZGUWCUCZF
      ZAEUWIJKZLKZUWKRZMZUVJUVKUACBUVLGRZUVMUVRUVPUWAUVLGGUDUWOUVOUVTUVNUVSUWOU
      VNUVSALUVLGEJUEZNUWPOUFUVLUWCRZUVMUWDUVPUWGUVLUWCGUDUWQUVOUWFUVNUWEUWQUVN
      UWEALUVLUWCEJUEZNUWROUFUVLUWIRZUVMUWJUVPUWMUVLUWIGUDUWSUVOUWLUVNUWKUWSUVN
      UWKALUVLUWIEJUEZNUWTOUFUVLBRZUVMUVBUVPUVIUVLBGUDUXAUVOUVHUVNUVGUXAUVNUVGA
      LUVLBEJUEZNUXBOUFUWBUVKUVRUWAGUKUGUHUVKUWCIFZUWHUWNMZUUTUVEUXCUXDUUTUVEUX
      CHZHZUWHUWMUWJUXFUWCGRZUWHUWMMUWDUXFUXGUWMUWHUXFUXGUWMUXFUXGHZAELKZEUWLUW
      KUXFUXIERZUXGUXFUVEUURUUSUXJUUTUVEUXCUIZUURUUSUXEUJUURUUSUXEULAUMUNPUXHUW
      KEALUXGUXFUWKEUOJKZEUXGUWIUOEJUXGUWIGUCUOUWCGUPUQURNUVEUXLERUUTUXCEUSUTVB
      ZNUXMVAVCVDUXFUWHUWDUWMUXFUWGUWMUWDUWGUWMUXFUWFELKZUWEELKZRUWFUWEELVEUXFU
      WLUXNUWKUXOUXFUWLAUXOLKZUXNUXFUWKUXOALUXEUWKUXORUUTEUWCVFVGZNUXFAIFZUWEIF
      ZUVEUXNUXPRUURUXRUUSUXEAVHZQUXEUXSUUTEUWCVIZVGUXKAUWEEVJUNVKUXQOVLVNVMUXF
      UXCUXGUWDWQUUTUVEUXCVOUWCVPSVQVDVRVSUVKUVLVTZUWHCUVLWAZUVQMUVKUYBHUYCUVPU
      VMUUTUVEUYBUYCUVPMUUTUVEUYBHZHZUYCUVPUYEUYCHZUVOUVNUYFUVODUVNADUBZLKZWEZU
      VNUYFUXRUVNIFZUVNVTZUVOUYIRUURUXRUUSUYDUYCUXTWBZUYEUYJUYCUYEUVEUVLIFZUYJU
      UTUVEUYBUIZUYEUVLWCFZUYBHZUYMUYEUYBUYOUUTUVEUYBVOUAWFWDZUVLWCWGSZEUVLVITZ
      PZUYFEIWHWIFZUYPUYKUYEVUAUYCUYEUVEUOEFZVUAUYNVUBUYEWJUHEWKWLZPUYEUYPUYCUY
      QPZEUVLWCWMTDAUVNIWNWOUYFUYHUVNWPZDUVNWAUYIUVNWPUYFVUEDUVNUYFUYGUVNFZUWDU
      YGUWEFZHZCUVLWRZVUEUYFVUFVUGCUVLUOWIZWRZVUIUYFVUFUYGCVUJUWEWEZFVUKUYFUVNV
      ULUYGUYFUVEUYPUVNVULRUUTUVEUYBUYCWSVUDCEUVLWCWTTXACUYGVUJUWEXBXCUYFUYMVUI
      VUKXDUYEUYMUYCUYRPUYMVUHVUGCUVLVUJUWCUVLFZVUHHVUMUWDHZVUGHUYMUWCVUJFZVUGH
      VUMUWDVUGXIUYMVUNVUOVUGUYMVUNVUMUWCGXEZHVUOUYMVUMUWDVUPUYMVUMHUXCUWDVUPXD
      UVLUWCXFZUWCXGSXHUWCUVLXJXKXLXMXNSXOUYEUYCVUIVUEUYCVUIHUWHVUHHZCUVLWRUYEV
      UEUWHVUHCUVLXPUYEVURVUECUVLVURUWGVUGHZUYEVUMHZVUEUWHUWDVUGVUSUWHUWDHUWGVU
      GUWHUWDUWGUWHYTXQXRXTVUTVUSVUEVUTVUSHZUVNXSZUYHUVNFZVUEVVAUYJVVBUYEUYJVUM
      VUSUYSQZUVNYASVVAUYHUWEFZUWEUVNFZVVCVVAUYHUWFUWEVVAVUGUYHUWFFZVUTUWGVUGVO
      ZVVAUYGIFZUXSUXRUUSVUGVVGXDVVAUXSVUGVVIVVAUVEUXCUXSUYEUVEVUMVUSUYNQVVAUYM
      VUMUXCUYEUYMVUMVUSUYRQZUYEVUMVUSULZVUQTZUYATZVVHUWEUYGXFTVVMUYEUXRVUMVUSU
      URUXRUUSUYDUXTQQUYEUUSVUMVUSUURUUSUYDULQUYGUWEAYBYCYDVUTUWGVUGUIYEVVAVUMV
      VFVVKVVAUXCUYMVUAVUMVVFXDVVLVVJUYEVUAVUMVUSVUCQUWCUVLEYFUNYDVVAUYJVVEVVFH
      VVCMVVDUYHUWEUVNYJSYGUVNUYHYHTVCYKYIYKYLYMYNDUVNUYHUVNYOYPYQUYFUYJUXRUUSU
      VNUVOWPUYTUYLUURUUSUYDUYCYRUVNAYSUUAUUBVCVRVDVSUUCUUDUUEUUFUUGUVDUVFUUMZH
      ZAGLKZGUVHUVGUURVVPGRUUSUVCVVNAUUHWBVVOUVGGALVVNUVGGRUVDEBIJJIIUUIZUUJJUU
      KVVQRUULVVQJUUNUUOUUPVGZNVVRVAUUQ $.
  $}

  $( Multiply an element of ` om ` by ` 1o ` .  (Contributed by Mario Carneiro,
     17-Nov-2014.) $)
  nnm1 $p |- ( A e. om -> ( A .o 1o ) = A ) $=
    ( com wcel c1o comu co c0 csuc df-1o oveq2i wceq peano1 nnmsuc mpan2 oveq1d
    coa nnm0 nna0r 3eqtrd syl5eq ) ABCZADEFAGHZEFZADUBAEIJUAUCAGEFZAPFZGAPFAUAG
    BCUCUEKLAGMNUAUDGAPAQOARST $.

  $( Multiply an element of ` om ` by ` 2o ` (Contributed by Scott Fenton,
     18-Apr-2012.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  nnm2 $p |- ( A e. om -> ( A .o 2o ) = ( A +o A ) ) $=
    ( com wcel c2o comu c1o csuc coa df-2o oveq2i wceq 1onn nnmsuc mpan2 oveq1d
    co nnm1 eqtrd syl5eq ) ABCZADEPAFGZEPZAAHPZDUAAEIJTUBAFEPZAHPZUCTFBCUBUEKLA
    FMNTUDAAHAQORS $.

  $( Multiply an element of ` om ` by ` 2o ` (Contributed by Scott Fenton,
     16-Apr-2012.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  nn2m $p |- ( A e. om -> ( 2o .o A ) = ( A +o A ) ) $=
    ( com wcel c2o comu co coa wceq 2onn nnmcom mpan nnm2 eqtrd ) ABCZDAEFZADEF
    ZAAGFDBCNOPHIDAJKALM $.

  $( If a natural number is even, its successor is odd.  (Contributed by Mario
     Carneiro, 16-Nov-2014.) $)
  nnneo $p |- ( ( A e. om /\ B e. om /\ C = ( 2o .o A ) ) ->
              -. suc C = ( 2o .o B ) ) $=
    ( com wcel c2o comu co wceq csuc wa con0 nnon syl wb sucid mpbii nnmord c1o
    2onn w3a wn onnbtwn 3ad2ant1 suceq eqeq1d 3ad2ant3 wi eleq2 c0 mp3an3 simpl
    ovex syl5 simpr coa nnmcl mpan oa1suc 3syl 1onn elexi df-2o eleqtrri nnaord
    syl6bir mp3an12 nnmsuc eleqtrrd eqeltrrd peano2 sylan2 ancoms adantr mpbird
    ad2antrr simpld ex jcad 3adant3 sylbid mtod ) ADEZBDEZCFAGHZIZUAZCJZFBGHZIZ
    ABEZBAJZEZKZWCWDWNUBZWFWCALEWOAMABUCNUDWGWJWEJZWIIZWNWFWCWJWQOWDWFWHWPWICWE
    UEUFUGWCWDWQWNUHWFWCWDKZWQWKWMWQWEWIEZWRWKWQWEWPEWSWEFAGUMPWPWIWEUIQWRWSWKU
    JFEZKZWKWCWDFDEZXAWSOTABFRUKWKWTULVFUNWRWQWMWRWQKZWMWTXCWMWTKZWIFWLGHZEZXCW
    PWIXEWRWQUOWCWPXEEWDWQWCWESUPHZWPXEWCWEDEZWELEXGWPIXBWCXHTFAUQURZWEMWEUSUTW
    CXGWEFUPHZXEWCSFEZXGXJEZSSJFSSDVAVBPVCVDWCXHXKXLOZXISDEXBXHXMVATSFWEVEVGNQX
    BWCXEXJITFAVHURVIVJVPVJWRXDXFOZWQWDWCXNWCWDWLDEZXNAVKWDXOXBXNTBWLFRUKVLVMVN
    VOVQVRVSVTWAWB $.

  ${
    $d x y z A $.
    $( A natural number is even iff its successor is odd.  (Contributed by NM,
       26-Jan-2006.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
    nneob $p |- ( A e. om ->
      ( E. x e. om A = ( 2o .o x ) <-> -. E. x e. om suc A = ( 2o .o x ) ) ) $=
      ( vy com wcel comu co wceq wrex csuc wn eqeq2d wi c0 suceq eqeq1d rexbidv
      c2o notbid eqeq1 vz cv oveq2 wa nnneo 3com23 3expa nrexdv rexlimiva sylbi
      cbvrexv imbi12d peano1 eqid syl6eq rspcev mp2an a1i peano2 coa c1o nnmsuc
      om0x 2onn mpan df-2o oveq2i nnmcl 1onn nnasuc sylancl syl5req con0 oa1suc
      nnon 4syl 3eqtr2rd syl2anc syl syl5ibrcom rexlimiv syl5bi con3d con1 syl9
      finds impbid2 ) BDEBRAUBZFGZHZADIZBJZWIHZADIZKZWKBRCUBZFGZHZCDIWOWJWRACDW
      HWPHZWIWQBWHWPRFUCZLUKWRWOCDWPDEZWRUDWMADXAWRWHDEZWMKZXAXBWRXCWPWHBUEUFUG
      UHUIUJWPJZWIHZADIZKZWPWIHZADIZMNJZWIHZADIZKZNWIHZADIZMUAUBZJZWIHZADIZKZXP
      WIHZADIZMZXQJZWIHZADIZKZXSMWOWKMCUABWPNHZXGXMXIXOYHXFXLYHXEXKADYHXDXJWIWP
      NOPQSYHXHXNADWPNWITQULWPXPHZXGXTXIYBYIXFXSYIXEXRADYIXDXQWIWPXPOPQSYIXHYAA
      DWPXPWITQULWPXQHZXGYGXIXSYJXFYFYJXEYEADYJXDYDWIWPXQOPQSYJXHXRADWPXQWITQUL
      WPBHZXGWOXIWKYKXFWNYKXEWMADYKXDWLWIWPBOPQSYKXHWJADWPBWITQULXOXMNDENNHZXOU
      MNUNXNYLANDWHNHZWINNYMWIRNFGNWHNRFUCRVCUOLUPUQURXPDEZYGYBKYCXSYNYBYFYBXPW
      QHZCDIZYNYFYAYOACDWSWIWQXPWTLUKYPYFMYNYOYFCDXAYFYOWQJZJZWIHZADIZXAXDDEYRR
      XDFGZHZYTWPUSXAUUAWQRUTGZWQVAUTGZJZYRRDEZXAUUAUUCHVDRWPVBVEXAUUCWQVAJZUTG
      ZUUERUUGWQUTVFVGXAWQDEZVADEUUHUUEHUUFXAUUIVDRWPVHVEZVIWQVAVJVKVLXAUUIWQVM
      EUUDYQHUUEYRHUUJWQVOWQVNUUDYQOVPVQYSUUBAXDDWHXDHWIUUAYRWHXDRFUCLUPVRYOYEY
      SADYOYDYRWIYOXQYQHYDYRHXPWQOXQYQOVSPQVTWAURWBWCXSYBWDWEWFWG $.
  $}

  ${
    $d y z w A $.  $d x y z w F $.
    $( Lemma for ~ omsmo .  (Contributed by NM, 30-Nov-2003.)  (Revised by
       David Abernethy, 1-Jan-2014.) $)
    omsmolem $p |- ( y e. om -> ( ( ( A C_ On /\ F : om --> A ) /\
        A. x e. om ( F ` x ) e. ( F ` suc x ) ) ->
       ( z e. y -> ( F ` z ) e. ( F ` y ) ) ) ) $=
      ( vw cv wcel cfv wi c0 csuc con0 com wa eleq2 fveq2 eleq2d imbi12d weq wf
      wss wral wceq noel pm2.21i a1i wo vex elsuc suceq eleq12d rspccva adantll
      fveq2d peano2b ffvelrn sylan2b ssel ontr1 exp3acom23 syl56 adantlr imim2d
      impl mpd imp eleq1d syl5ibrcom adantr jaod syl5bi exp31 com12 finds2 ) CG
      ZBGZHZVPEIZVQEIZHZJVPKHZVSKEIZHZJZVPFGZHZVSWFEIZHZJZVPWFLZHZVSWKEIZHZJZDM
      UBZNDEUAZOZAGZEIZWSLZEIZHZANUCZOZBFVQKUDZVRWBWAWDVQKVPPXFVTWCVSVQKEQRSBFT
      ZVRWGWAWIVQWFVPPXGVTWHVSVQWFEQRSVQWKUDZVRWLWAWNVQWKVPPXHVTWMVSVQWKEQRSWEX
      EWBWDVPUEUFUGXEWFNHZWJWOJXEXIWJWOWLWGCFTZUHXEXIOZWJOZWNVPWFCUIUJXLWGWNXJX
      KWJWGWNJXKWIWNWGXKWHWMHZWIWNJZXDXIXMWRXCXMAWFNAFTZWTWHXBWMWSWFEQXOXAWKEWS
      WFUKUOULUMZUNWRXIXMXNJZXDWPWQXIXQWQXIOWMDHZWPWMMHZXQXIWQWKNHXRWFUPNDWKEUQ
      URDMWMUSXSWIXMWNVSWHWMUTVAVBVEVCVFVDVGXKXJWNJZWJXDXIXTWRXDXIOWNXJXMXPXJVS
      WHWMVPWFEQVHVIUNVJVKVLVMVNVO $.

    $( A strictly monotonic ordinal function on the set of natural numbers is
       one-to-one.  (Contributed by NM, 30-Nov-2003.)  (Revised by David
       Abernethy, 1-Jan-2014.) $)
    omsmo $p |- ( ( ( A C_ On /\ F : om --> A ) /\
          A. x e. om ( F ` x ) e. ( F ` suc x ) ) -> F : om -1-1-> A ) $=
      ( vy vz con0 com wa cv cfv wcel wral wceq wi wo omsmolem adantl imp word
      wn wss wf csuc simplr adantr orim12d ancoms con3d wb ffvelrn ssel expdimp
      wf1 syl5 eloni syl6 anim12d ordtri3 syl adantlr syl2an 3imtr4d ralrimivva
      nnord dff13 sylanbrc ) BFUAZGBCUBZHZAIZCJVJUCCJKAGLZHZVHDIZCJZEIZCJZMZVMV
      OMZNZEGLDGLGBCUMVGVHVKUDVLVSDEGGVLVMGKZVOGKZHZHZVNVPKZVPVNKZOZTZVMVOKZVOV
      MKZOZTZVQVRWCWJWFWBVLWJWFNWBVLHWHWDWIWEWBVLWHWDNZWAVLWLNVTAEDBCPQRWBVLWIW
      ENZVTVLWMNWAADEBCPUERUFUGUHVIWBVQWGUIZVKVIWBHVNSZVPSZHZWNVIWBWQVIVTWOWAWP
      VIVTVNFKZWOVGVHVTWRVHVTHVNBKVGWRGBVMCUJBFVNUKUNULVNUOUPVIWAVPFKZWPVGVHWAW
      SVHWAHVPBKVGWSGBVOCUJBFVPUKUNULVPUOUPUQRVNVPURUSUTWBVRWKUIZVLVTVMSVOSWTWA
      VMVDVOVDVMVOURVAQVBVCDEGBCVEVF $.
  $}

  ${
    omopthlem1.1 $e |- A e. om $.
    omopthlem1.2 $e |- C e. om $.
    $( Lemma for ~ omopthi .  (Contributed by Scott Fenton, 18-Apr-2012.)
       (Revised by Mario Carneiro, 17-Nov-2014.) $)
    omopthlem1 $p |- ( A e. C ->
                ( ( A .o A ) +o ( A .o 2o ) ) e. ( C .o C ) ) $=
      ( csuc wss comu co wcel c2o coa wi ax-mp mp3an nnoni onsucssi nnmcli wceq
      com mp2an peano2 nnmwordi nnmwordri sstrd 2onn nnacli nnasuc nnmsuc eqtri
      nnaass nnmcom oveq1i nnm2 oveq2i 3eqtr4ri suceq sseq1i bitri 3imtr4i ) AE
      ZBFZUTUTGHZBBGHZFZABIAAGHZAJGHZKHZVCIZVAVBUTBGHZVCUTSIZBSIZVJVAVBVIFLASIZ
      VJCAUAMZDVMUTBUTUBNVJVKVKVAVIVCFLVMDDUTBBUCNUDABACOBDOPVHVGEZVCFVDVGVCVGV
      EVFAACCQZAJCUEQUFOVCBBDDQOPVNVBVCUTAGHZUTKHZVPAKHZEZVBVNVPSIVLVQVSRUTAVMC
      QCVPAUGTVJVLVBVQRVMCUTAUHTVGVRRVNVSRVEAKHZAKHZVEAAKHZKHZVRVGVESIVLVLWAWCR
      VOCCVEAAUJNVPVTAKVPAUTGHZVTVJVLVPWDRVMCUTAUKTVLVLWDVTRCCAAUHTUIULVFWBVEKV
      LVFWBRCAUMMUNUOVGVRUPMUOUQURUS $.
  $}

  ${
    omopthlem2.1 $e |- A e. om $.
    omopthlem2.2 $e |- B e. om $.
    omopthlem2.3 $e |- C e. om $.
    omopthlem2.4 $e |- D e. om $.
    $( Lemma for ~ omopthi .  (Contributed by Scott Fenton, 16-Apr-2012.)
       (Revised by Mario Carneiro, 17-Nov-2014.) $)
    omopthlem2 $p |- ( ( A +o B ) e. C ->
     -. ( ( C .o C ) +o D ) = ( ( ( A +o B ) .o ( A +o B ) ) +o B ) ) $=
      ( comu co coa wceq wcel nnmcli nnacli nnoni com wss mp2an nnacom nnaword1
      onirri eleq1 mtbii c2o sseqtri nnaass mp3an nnm2 ax-mp eqtr4i wi nnawordi
      2onn 3sstr4i omopthlem1 con0 wa ontr2 sylancr sseldi nsyl3 ) CCIJZDKJZABK
      JZVEIJZBKJZLZVGVDMZVECMZVHVDVDMVIVDVDVCDCCGGNZHOPUBVDVGVDUCUDVJVCVDVGVCQM
      DQMVCVDRVKHVCDUASVJVGVFVEUEIJZKJZRZVMVCMZVGVCMZBVFKJZVLVFKJZVGVMBVLRZVQVR
      RZBVEAKJZBKJZVLBBWAKJZWBBQMZWAQMZBWCRFVEAABEFOZEOZBWAUASWDWEWCWBLFWGBWATS
      UFWBVEVEKJZVLVEQMZAQMWDWBWHLWFEFVEABUGUHWIVLWHLWFVEUIUJUKUFWDVLQMZVFQMZVS
      VTULFVEUEWFUNNZVEVEWFWFNZBVLVFUMUHUJWKWDVGVQLWMFVFBTSWKWJVMVRLWMWLVFVLTSU
      OVECWFGUPVGUQMVCUQMVNVOURVPULVGVFBWMFOPVCVKPVGVMVCUSSUTVAVB $.
  $}

  ${
    omopth.1 $e |- A e. om $.
    omopth.2 $e |- B e. om $.
    omopth.3 $e |- C e. om $.
    omopth.4 $e |- D e. om $.
    $( An ordered pair theorem for ` om ` .  Theorem 17.3 of [Quine] p. 124.
       This proof is adapted from ~ nn0opthi .  (Contributed by Scott Fenton,
       16-Apr-2012.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    omopthi $p |- ( ( ( ( A +o B ) .o ( A +o B ) ) +o B ) =
                     ( ( ( C +o D ) .o ( C +o D ) ) +o D ) <->
                     ( A = C /\ B = D ) ) $=
      ( coa co comu wceq wn wcel word wb nnacli mp2an oveq12d com wa wo ordtri3
      nnoni onordi con2bii omopthlem2 eqcom sylnib jaoi sylbir id oveq1d eqtr4d
      con4i nnmcli nnacan mp3an sylib oveq2d nnacom 3eqtr4g oveq12 simpr impbii
      jca ) ABIJZVGKJZBIJZCDIJZVJKJZDIJZLZACLZBDLZUAZVMVNVOVMBAIJZBCIJZLZVNVMVG
      CBIJZVQVRVMVGVJVTVGVJLZVMWAMVGVJNZVJVGNZUBZVMMZWAWDVGOVJOWAWDMPVGVGABEFQZ
      UDUEVJVJCDGHQZUDUEVGVJUCRUFWBWEWCWBVLVILVMABVJDEFWGHUGVLVIUHUICDVGBGHWFFU
      GUJUKUOZVMBDCIVMVIVHDIJZLZVOVMVIVLWIVMULVMVHVKDIVMVGVJVGVJKWHWHSUMUNVHTNB
      TNZDTNWJVOPVGVGWFWFUPFHVHBDUQURUSZUTUNWKATNZVQVGLFEBAVARWKCTNZVRVTLFGBCVA
      RVBWKWMWNVSVNPFEGBACUQURUSWLVFVPVHVKBDIVPVGVJVGVJKACBDIVCZWOSVNVOVDSVE $.
  $}

  $( An ordered pair theorem for finite integers.  Analagous to ~ nn0opthi .
     (Contributed by Scott Fenton, 1-May-2012.)  (Revised by Mario Carneiro,
     12-May-2012.) $)
  omopth $p |- ( ( ( A e. om /\ B e. om ) /\ ( C e. om /\ D e. om ) ) ->
                 ( ( ( ( A +o B ) .o ( A +o B ) ) +o B ) =
                     ( ( ( C +o D ) .o ( C +o D ) ) +o D ) <->
                     ( A = C /\ B = D ) ) ) $=
    ( com wcel coa co comu wceq wa wb c0 cif oveq1 oveq12d oveq1d peano1 elimel
    bibi12d eqeq1d eqeq1 anbi1d oveq2 id anbi2d eqeq2d eqeq2 omopthi dedth4h )
    AEFZBEFZCEFZDEFZABGHZUOIHZBGHZCDGHZURIHZDGHZJZACJZBDJZKZLUKAMNZBGHZVFIHZBGH
    ZUTJZVECJZVCKZLVEULBMNZGHZVMIHZVLGHZUTJZVJVLDJZKZLVOUMCMNZDGHZVTIHZDGHZJZVE
    VSJZVQKZLVOVSUNDMNZGHZWGIHZWFGHZJZWDVLWFJZKZLABCDMMMMAVEJZVAVIVDVKWMUQVHUTW
    MUPVGBGWMUOVFUOVFIAVEBGOZWNPQUAWMVBVJVCAVECUBUCTBVLJZVIVPVKVRWOVHVOUTWOVGVN
    BVLGWOVFVMVFVMIBVLVEGUDZWPPWOUEPUAWOVCVQVJBVLDUBUFTCVSJZVPWCVRWEWQUTWBVOWQU
    SWADGWQURVTURVTICVSDGOZWRPQUGWQVJWDVQCVSVEUHUCTDWFJZWCWJWEWLWSWBWIVOWSWAWHD
    WFGWSVTWGVTWGIDWFVSGUDZWTPWSUEPUGWSVQWKWDDWFVLUHUFTVEVLVSWFAMERSBMERSCMERSD
    MERSUIUJ $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Equivalence relations and classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c Er $.  $( Equivalence predicate $)
  $c /. $.  $( Long slash for quotient set $)

  $( Extend the definition of a wff to include the equivalence predicate. $)
  wer $a wff R Er A $.

  $( Extend the definition of a class to include equivalence class. $)
  cec $a class [ A ] R $.

  $( Extend the definition of a class to include quotient set. $)
  cqs $a class ( A /. R ) $.

  $( Define the equivalence relation predicate.  Our notation is not standard.
     A formal notation doesn't seem to exist in the literature; instead only
     informal English tends to be used.  The present definition, although
     somewhat cryptic, nicely avoids dummy variables.  In ~ dfer2 we derive a
     more typical definition.  We show that an equivalence relation is
     reflexive, symmetric, and transitive in ~ erref , ~ ersymb , and ~ ertr .
     (Contributed by NM, 4-Jun-1995.)  (Revised by Mario Carneiro,
     2-Nov-2015.) $)
  df-er $a |- ( R Er A <->
    ( Rel R /\ dom R = A /\ ( `' R u. ( R o. R ) ) C_ R ) ) $.

  ${
    $d x y z R $.
    $( Alternate definition of equivalence predicate.  (Contributed by NM,
       3-Jan-1997.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    dfer2 $p |- ( R Er A <->
    ( Rel R /\ dom R = A /\ A. x A. y A. z
          ( ( x R y -> y R x ) /\ ( ( x R y /\ y R z ) -> x R z ) ) ) ) $=
      ( wer wrel cdm wceq ccnv wss w3a cv wbr wi wa wal albii 19.26 bitri df-er
      ccom cun cnvsym cotr anbi12i unss 19.28v bitr2i 3bitr3i 3anbi3i ) DEFEGZE
      HDIZEJZEEUBZUCEKZLULUMAMZBMZENZURUQENOZUSURCMZENPUQVAENOZPCQZBQZAQZLDEUAU
      PVEULUMUNEKZUOEKZPUTBQZAQZVBCQZBQZAQZPZUPVEVFVIVGVLABEUDABCEUEUFUNUOEUGVE
      VHVKPZAQVMVDVNAVDUTVJPZBQVNVCVOBUTVBCUHRUTVJBSTRVHVKASUIUJUKT $.
  $}

  $( Define the ` R ` -coset of ` A ` .  Exercise 35 of [Enderton] p. 61.  This
     is called the equivalence class of ` A ` modulo ` R ` when ` R ` is an
     equivalence relation (i.e. when ` Er R ` ; see ~ dfer2 ).  In this case,
     ` A ` is a representative (member) of the equivalence class ` [ A ] R ` ,
     which contains all sets that are equivalent to ` A ` .  Definition of
     [Enderton] p. 57 uses the notation ` [ A ] ` (subscript) ` R ` , although
     we simply follow the brackets by ` R ` since we don't have subscripted
     expressions.  For an alternate definition, see ~ dfec2 .  (Contributed by
     NM, 23-Jul-1995.) $)
  df-ec $a |- [ A ] R = ( R " { A } ) $.

  ${
    $d y A x $.  $d y R x $.
    $( Alternate definition of ` R ` -coset of ` A ` .  Definition 34 of
       [Suppes] p. 81.  (Contributed by NM, 3-Jan-1997.)  (Proof shortened by
       Mario Carneiro, 9-Jul-2014.) $)
    dfec2 $p |- ( A e. V -> [ A ] R = { y | A R y } ) $=
      ( wcel cec csn cima cv wbr cab df-ec imasng syl5eq ) BDEBCFCBGHBAICJAKBCL
      ABDCMN $.
  $}

  $( An equivalence class modulo a set is a set.  (Contributed by NM,
     24-Jul-1995.) $)
  ecexg $p |- ( R e. B -> [ A ] R e. _V ) $=
    ( wcel cec csn cima cvv df-ec imaexg syl5eqel ) CBDACECAFZGHACICLBJK $.

  $( A nonempty equivalence class implies the representative is a set.
     (Contributed by Mario Carneiro, 9-Jul-2014.) $)
  ecexr $p |- ( A e. [ B ] R -> B e. _V ) $=
    ( cvv wcel csn cima cec c0 wceq n0i wn snprc imaeq2 sylbi ima0 syl6eq nsyl2
    df-ec eleq2s ) BDEZACBFZGZBCHAUCEUCIJUAUCAKUALZUCCIGZIUDUBIJUCUEJBMUBICNOCP
    QRBCST $.

  ${
    $d x y A $.  $d x y R $.
    $( Define quotient set. ` R ` is usually an equivalence relation.
       Definition of [Enderton] p. 58.  (Contributed by NM, 23-Jul-1995.) $)
    df-qs $a |- ( A /. R ) = { y | E. x e. A y = [ x ] R } $.
  $}

  $( Equality theorem for equivalence predicate.  (Contributed by NM,
     4-Jun-1995.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
  ereq1 $p |- ( R = S -> ( R Er A <-> S Er A ) ) $=
    ( wceq wrel cdm ccnv ccom cun wss releq dmeq eqeq1d cnveq coeq1 coeq2 eqtrd
    w3a wer df-er uneq12d sseq1d sseq2 bitrd 3anbi123d 3bitr4g ) BCDZBEZBFZADZB
    GZBBHZIZBJZRCEZCFZADZCGZCCHZIZCJZRABSACSUGUHUOUJUQUNVABCKUGUIUPABCLMUGUNUTB
    JVAUGUMUTBUGUKURULUSBCNUGULCBHUSBCBOBCCPQUAUBBCUTUCUDUEABTACTUF $.

  $( Equality theorem for equivalence predicate.  (Contributed by Mario
     Carneiro, 12-Aug-2015.) $)
  ereq2 $p |- ( A = B -> ( R Er A <-> R Er B ) ) $=
    ( wceq wrel cdm ccnv ccom cun wss w3a wer eqeq2 3anbi2d df-er 3bitr4g ) ABD
    ZCEZCFZADZCGCCHICJZKRSBDZUAKACLBCLQTUBRUAABSMNACOBCOP $.

  $( An equivalence relation is a relation.  (Contributed by Mario Carneiro,
     12-Aug-2015.) $)
  errel $p |- ( R Er A -> Rel R ) $=
    ( wer wrel cdm wceq ccnv ccom cun wss df-er simp1bi ) ABCBDBEAFBGBBHIBJABKL
    $.

  $( The domain of an equivalence relation.  (Contributed by Mario Carneiro,
     12-Aug-2015.) $)
  erdm $p |- ( R Er A -> dom R = A ) $=
    ( wer wrel cdm wceq ccnv ccom cun wss df-er simp2bi ) ABCBDBEAFBGBBHIBJABKL
    $.

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    ersym.1 $e |- ( ph -> R Er X ) $.
    ersym.2 $e |- ( ph -> A R B ) $.
    $( Elementhood in the field of an equivalence relation.  (Contributed by
       Mario Carneiro, 12-Aug-2015.) $)
    ercl $p |- ( ph -> A e. X ) $=
      ( cdm wrel wbr wcel wer errel syl releldm syl2anc wceq erdm eleqtrd ) ABD
      HZEADIZBCDJBTKAEDLZUAFEDMNGBCDOPAUBTEQFEDRNS $.

    $( An equivalence relation is symmetric.  (Contributed by NM, 4-Jun-1995.)
       (Revised by Mario Carneiro, 12-Aug-2015.) $)
    ersym $p |- ( ph -> B R A ) $=
      ( ccnv wbr cvv wcel wa wb wrel wer errel syl brrelex12 syl2anc brcnvg cun
      ancoms mpbird ccom wss cdm wceq df-er simp3bi unssad ssbrd mpd ) ACBDHZIZ
      CBDIAUNBCDIZGABJKZCJKZLZUNUOMZADNZUOURAEDOZUTFEDPQGBCDRSUQUPUSCBJJDTUBQUC
      AUMDCBAUMDDUDZDAVAUMVBUADUEZFVAUTDUFEUGVCEDUHUIQUJUKUL $.

    $( Elementhood in the field of an equivalence relation.  (Contributed by
       Mario Carneiro, 12-Aug-2015.) $)
    ercl2 $p |- ( ph -> B e. X ) $=
      ( ersym ercl ) ACBDEFABCDEFGHI $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.  $d x R $.
    ersymb.1 $e |- ( ph -> R Er X ) $.
    $( An equivalence relation is symmetric.  (Contributed by NM,
       30-Jul-1995.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    ersymb $p |- ( ph -> ( A R B <-> B R A ) ) $=
      ( wbr wa wer adantr simpr ersym impbida ) ABCDGZCBDGZANHBCDEAEDIZNFJANKLA
      OHCBDEAPOFJAOKLM $.

    $( An equivalence relation is transitive.  (Contributed by NM,
       4-Jun-1995.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    ertr $p |- ( ph -> ( ( A R B /\ B R C ) -> A R C ) ) $=
      ( vx wbr wa ccom cv wex cvv wcel syl simpr brrelex syl2an wceq wrel errel
      breq2 breq1 anbi12d spcegv sylc wb simpl brrelex2 brcog syl2anc mpbird ex
      wer ccnv cun wss cdm df-er simp3bi unssbd ssbrd syld ) ABCEIZCDEIZJZBDEEK
      ZIZBDEIAVGVIAVGJZVIBHLZEIZVKDEIZJZHMZVJCNOZVGVOAEUAZVFVPVGAFEUOZVQGFEUBPZ
      VEVFQZCDERSAVGQVNVGHCNVKCTVLVEVMVFVKCBEUCVKCDEUDUEUFUGVJBNOZDNOZVIVOUHAVQ
      VEWAVGVSVEVFUIBCERSAVQVFWBVGVSVTCDEUJSHBDEENNUKULUMUNAVHEBDAEUPZVHEAVRWCV
      HUQEURZGVRVQEUSFTWDFEUTVAPVBVCVD $.

    ${
      ertrd.5 $e |- ( ph -> A R B ) $.
      ertrd.6 $e |- ( ph -> B R C ) $.
      $( A transitivity relation for equivalences.  (Contributed by Mario
         Carneiro, 9-Jul-2014.) $)
      ertrd $p |- ( ph -> A R C ) $=
        ( wbr ertr mp2and ) ABCEJCDEJBDEJHIABCDEFGKL $.

      $( A transitivity relation for equivalences.  (Contributed by Mario
         Carneiro, 9-Jul-2014.) $)
      ertr2d $p |- ( ph -> C R A ) $=
        ( ertrd ersym ) ABDEFGABCDEFGHIJK $.
    $}

    ${
      ertr3d.5 $e |- ( ph -> B R A ) $.
      ertr3d.6 $e |- ( ph -> B R C ) $.
      $( A transitivity relation for equivalences.  (Contributed by Mario
         Carneiro, 9-Jul-2014.) $)
      ertr3d $p |- ( ph -> A R C ) $=
        ( ersym ertrd ) ABCDEFGACBEFGHJIK $.
    $}

    ${
      ertr4d.5 $e |- ( ph -> A R B ) $.
      ertr4d.6 $e |- ( ph -> C R B ) $.
      $( A transitivity relation for equivalences.  (Contributed by Mario
         Carneiro, 9-Jul-2014.) $)
      ertr4d $p |- ( ph -> A R C ) $=
        ( ersym ertrd ) ABCDEFGHADCEFGIJK $.
    $}

    erref.2 $e |- ( ph -> A e. X ) $.
    $( An equivalence relation is reflexive on its field.  Compare Theorem 3M
       of [Enderton] p. 56.  (Contributed by Mario Carneiro, 6-May-2013.)
       (Revised by Mario Carneiro, 12-Aug-2015.) $)
    erref $p |- ( ph -> A R A ) $=
      ( vx cv wbr cdm wcel wex wer wceq erdm syl eleqtrrd wb eldmg mpbid adantr
      wa simpr ertr4d exlimddv ) ABGHZCIZBBCIGABCJZKZUGGLZABDUHFADCMZUHDNEDCOPQ
      ABDKUIUJRFGBCDSPTAUGUBBUFBCDAUKUGEUAAUGUCZULUDUE $.
  $}

  ${
    $d x y A $.  $d x y R $.
    $( The converse of an equivalence relation is itself.  (Contributed by
       Mario Carneiro, 12-Aug-2015.) $)
    ercnv $p |- ( R Er A -> `' R = R ) $=
      ( vx vy wrel wer ccnv wceq errel relcnv cv wbr wcel id ersymb brcnv df-br
      cop vex bitr3i 3bitr3g eqrelrdv2 mpanl1 mpancom ) BEZABFZBGZBHZABIUGEUEUF
      UHBJUFCDUGBUFDKZCKZBLZUJUIBLUJUIRZUGMZULBMUFUIUJBAUFNOUKUJUIUGLUMUJUIBCSD
      SPUJUIUGQTUJUIBQUAUBUCUD $.
  $}

  $( The range and domain of an equivalence relation are equal.  (Contributed
     by Rodolfo Medina, 11-Oct-2010.)  (Revised by Mario Carneiro,
     12-Aug-2015.) $)
  errn $p |- ( R Er A -> ran R = A ) $=
    ( wer crn ccnv cdm df-rn ercnv dmeqd erdm eqtrd syl5eq ) ABCZBDBEZFZABGMOBF
    AMNBABHIABJKL $.

  $( An equivalence relation is a subset of the cartesian product of the
     field.  (Contributed by Mario Carneiro, 12-Aug-2015.) $)
  erssxp $p |- ( R Er A -> R C_ ( A X. A ) ) $=
    ( wer cdm crn cxp wrel wss errel relssdmrn syl erdm errn xpeq12d sseqtrd )
    ABCZBBDZBEZFZAAFPBGBSHABIBJKPQARAABLABMNO $.

  $( An equivalence relation is a set if its domain is a set.  (Contributed by
     Rodolfo Medina, 15-Oct-2010.)  (Proof shortened by Mario Carneiro,
     12-Aug-2015.) $)
  erex $p |- ( R Er A -> ( A e. V -> R e. _V ) ) $=
    ( wer wcel cvv cxp wss erssxp xpexg anidms ssexg syl2an ex ) ABDZACEZBFEZOB
    AAGZHRFEZQPABIPSAACCJKBRFLMN $.

  $( An equivalence relation is a set if and only if its domain is a set.
     (Contributed by Rodolfo Medina, 15-Oct-2010.)  (Revised by Mario Carneiro,
     12-Aug-2015.) $)
  erexb $p |- ( R Er A -> ( R e. _V <-> A e. _V ) ) $=
    ( wer cvv wcel cdm dmexg erdm eleq1d syl5ib erex impbid ) ABCZBDEZADEZNBFZD
    EMOBDGMPADABHIJABDKL $.

  ${
    $d x y z R $.  $d x A $.  $d x y z ph $.
    iserd.1 $e |- ( ph -> Rel R ) $.
    iserd.2 $e |- ( ( ph /\ x R y ) -> y R x ) $.
    iserd.3 $e |- ( ( ph /\ ( x R y /\ y R z ) ) -> x R z ) $.
    iserd.4 $e |- ( ph -> ( x e. A <-> x R x ) ) $.
    $( A reflexive, symmetric, transitive relation is an equivalence relation
       on its domain.  (Contributed by Mario Carneiro, 9-Jul-2014.)  (Revised
       by Mario Carneiro, 12-Aug-2015.) $)
    iserd $p |- ( ph -> R Er A ) $=
      ( wer wceq cv wbr wi wa wal ex alrimiv wcel cdm eqidd jca dfer2 syl3anbrc
      wrel adantr simpr erref vex breldm impbid1 bitr4d eqrdv ereq2 syl mpbid
      wb ) AFUAZFKZEFKZAFUFUSUSLBMZCMZFNZVCVBFNZOZVDVCDMZFNPZVBVGFNZOZPZDQZCQZB
      QUTGAUSUBAVMBAVLCAVKDAVFVJAVDVEHRAVHVIIRUCSSSBCDUSFUDUEZAUSELUTVAURABUSEA
      VBUSTZVBVBFNZVBETAVOVPAVOVPAVOPVBFUSAUTVOVNUGAVOUHUIRVBVBFBUJZVQUKULJUMUN
      USEFUOUPUQ $.
  $}

  ${
    swoer.1 $e |- R = ( ( X X. X ) \ ( .< u. `' .< ) ) $.
    $( Evaluate the incomparability relation.  (Contributed by Mario Carneiro,
       9-Jul-2014.) $)
    brdifun $p |- ( ( A e. X /\ B e. X ) ->
      ( A R B <-> -. ( A .< B \/ B .< A ) ) ) $=
      ( wcel wa wbr ccnv cun wn wo cxp wb cop opelxpi df-br sylibr cdif brcnvg
      breqi brdif bitri baib syl brun orbi2d syl5bb notbid bitrd ) AEGBEGHZABCI
      ZABDDJZKZIZLZABDIZBADIZMZLULABEENZIZUMUQOULABPVAGVBABEEQABVARSUMVBUQUMABV
      AUOTZIVBUQHABCVCFUBABVAUOUCUDUEUFULUPUTUPURABUNIZMULUTABDUNUGULVDUSURABEE
      DUAUHUIUJUK $.

    $d u v w R $.  $d x y z .< $.  $d x y z A $.  $d x y z B $.  $d x y z C $.
    $d u v w x y z ph $.  $d u x y z X $.  $d x y Y $.
    swoer.2 $e |- ( ( ph /\ ( y e. X /\ z e. X ) ) ->
                    ( y .< z -> -. z .< y ) ) $.
    swoer.3 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) ) ->
                    ( x .< y -> ( x .< z \/ z .< y ) ) ) $.
    $( Incomparability under a strict weak partial order is an equivalence
       relation.  (Contributed by Mario Carneiro, 9-Jul-2014.)  (Revised by
       Mario Carneiro, 12-Aug-2015.) $)
    swoer $p |- ( ph -> R Er X ) $=
      ( cv wbr wa wo wn wb wcel brdifun syl syl2anc vu vv wrel cxp wss ccnv cun
      vw cdif difss eqsstri relxp relss mp2 a1i simpr orcom notbid ssbri adantl
      brxp sylib simprd simpld 3bitr4d mpbid simprl simplbi simprbi simprr brel
      ad2antrl wi simpl swopolem syl13anc syl6ibr orim12d or4 syl6ib mpbird wpo
      mtord swopo poirr sylan pm1.2 nsyl impbida iserd ) AUAUBUHGEEUCZAEGGUDZUE
      WLUCWKEWLFFUFUGZUIWLHWLWMUJUKZGGULEWLUMUNUOAUAKZUBKZELZMZWQWPWOELZAWQUPWR
      WOWPFLZWPWOFLZNZOZXAWTNZOZWQWSWRXBXDXBXDPWRWTXAUQUOURWRWOGQZWPGQZMZWQXCPZ
      WRWOWPWLLZXHWQXJAEWLWOWPWNUSZUTWOWPGGVAZVBZWOWPEFGHRZSWRXGXFWSXEPWRXFXGXM
      VCWRXFXGXMVDWPWOEFGHRTVEVFAWQWPUHKZELZMZMZWOXOELZWOXOFLZXOWOFLZNZOZXRYBXB
      WPXOFLZXOWPFLZNZXRWQXCAWQXPVGXRXFXGXIXRXJXFWQXJAXPXKVLZXJXFXGXLVHSZXRXJXG
      YGXJXFXGXLVISZXNTVFXRXPYFOZAWQXPVJZXRXGXOGQZXPYJPYIXRXPYLYKXPXGYLWPXOGGEW
      NVKVCSZWPXOEFGHRTVFXRYBWTYDNZXAYENZNXBYFNXRXTYNYAYOXRAXFYLXGXTYNVMAXQVNZY
      HYMYIABCDGFWOXOWPJVOVPXRYAYEXANZYOXRAYLXFXGYAYQVMYPYMYHYIABCDGFXOWOWPJVOV
      PXAYEUQVQVRWTYDXAYEVSVTWCXRXFYLXSYCPYHYMWOXOEFGHRTWAAXFWOWOELZAXFMZYRWOWO
      FLZYTNZOZYSYTUUAAGFWBXFYTOABCDGFIJWDGWOFWEWFYTWGWHYSXFXFYRUUBPAXFUPZUUCWO
      WOEFGHRTWAYRXFAYRWOWOWLLZXFEWLWOWOWNUSUUDXFXFWOWOGGVAVHSUTWIWJ $.

    ${
      swoord.4 $e |- ( ph -> B e. X ) $.
      swoord.5 $e |- ( ph -> C e. X ) $.
      swoord.6 $e |- ( ph -> A R B ) $.
      $( The incomparability equivalence relation is compatible with the
         original order.  (Contributed by Mario Carneiro, 31-Dec-2014.) $)
      swoord1 $p |- ( ph -> ( A .< C <-> B .< C ) ) $=
        ( wbr wo wcel wn wi cxp ccnv cun cdif difss eqsstri ssbri df-br opelxp1
        id cop sylbi 3syl swopolem syl13anc wb brdifun syl2anc mpbid nsyl biorf
        orc syl sylibrd olc impbid ) AEGIQZFGIQZAVHEFIQZVIRZVIAAEJSZGJSZFJSZVHV
        KUAAUKZAEFHQZEFJJUBZQZVLPHVQEFHVQIIUCUDZUEVQKVQVSUFUGUHVREFULVQSVLEFVQU
        IEFJJUJUMUNZONABCDJIEGFMUOUPAVJTVIVKUQAVJFEIQZRZVJAVPWBTZPAVLVNVPWCUQVT
        NEFHIJKURUSUTZVJWAVCVAVJVIVBVDVEAVIWAVHRZVHAAVNVMVLVIWEUAVONOVTABCDJIFG
        EMUOUPAWATVHWEUQAWBWAWDWAVJVFVAWAVHVBVDVEVG $.

      $( The incomparability equivalence relation is compatible with the
         original order.  (Contributed by Mario Carneiro, 31-Dec-2014.) $)
      swoord2 $p |- ( ph -> ( C .< A <-> C .< B ) ) $=
        ( wbr wo wcel wi id cxp ccnv cun cdif difss eqsstri ssbri df-br opelxp1
        cop sylbi swopolem syl13anc idd wn wb brdifun syl2anc mpbid olc pm2.21d
        3syl nsyl jaod syld orc impbid ) AGEIQZGFIQZAVIVJFEIQZRZVJAAGJSZEJSZFJS
        ZVIVLTAUAZOAEFHQZEFJJUBZQZVNPHVREFHVRIIUCUDZUEVRKVRVTUFUGUHVSEFUKVRSVNE
        FVRUIEFJJUJULVCZNABCDJIGEFMUMUNAVJVJVKAVJUOAVKVJAEFIQZVKRZVKAVQWCUPZPAV
        NVOVQWDUQWANEFHIJKURUSUTZVKWBVAVDVBVEVFAVJVIWBRZVIAAVMVOVNVJWFTVPONWAAB
        CDJIGFEMUMUNAVIVIWBAVIUOAWBVIAWCWBWEWBVKVGVDVBVEVFVH $.
    $}

    swoso.4 $e |- ( ph -> Y C_ X ) $.
    swoso.5 $e |- ( ( ph /\ ( x e. Y /\ y e. Y /\ x R y ) ) -> x = y ) $.
    $( If the incomparability relation is equivalent to equality in a subset,
       then the partial order strictly orders the subset.  (Contributed by
       Mario Carneiro, 30-Dec-2014.) $)
    swoso $p |- ( ph -> .< Or Y ) $=
      ( wpo cv wcel wa wbr wo w3o wss poss sylc weq wn sselda anim12dan brdifun
      swopo wb syl w3a df-3an sylan2br expr sylbird 3orcomb df-3or bitri sylibr
      orrd issod ) ABCHFAHGUAGFNHFNLABCDGFJKUIHGFUBUCABOZHPZCOZHPZQZQZVCVEFRZVE
      VCFRZSZBCUDZSZVIVLVJTZVHVKVLVHVKUEZVCVEERZVLVHVCGPZVEGPZQVPVOUJAVDVQVFVRA
      HGVCLUFAHGVELUFUGVCVEEFGIUHUKAVGVPVLVGVPQAVDVFVPULVLVDVFVPUMMUNUOUPVAVNVI
      VJVLTVMVIVLVJUQVIVJVLURUSUTVB $.
  $}

  ${
    $d w x y $.  $d x y z $.  $d y A $.  $d v x B $.
    eqer.1 $e |- ( x = y -> A = B ) $.
    eqer.2 $e |- R = { <. x , y >. | A = B } $.
    $( Lemma for ~ eqer .  (Contributed by NM, 17-Mar-2008.)  (Proof shortened
       by Mario Carneiro, 6-Dec-2016.) $)
    eqerlem $p |- ( z R w <-> [_ z / x ]_ A = [_ w / x ]_ A ) $=
      ( cv wceq wsbc csb cvv wcel wb vex nfcsb1v weq sbciegf brabsb nfeq csbief
      wbr nfv nfcv csbeq1 syl5eqr eqeq2d ax-mp csbeq1a eqeq1d syl5bb bitri ) CJ
      ZDJZGUDEFKZBUPLZAUOLZAUOEMZAUPEMZKZUQABUOUPGIUAUONOUSVBPCQURVBAUONAUTVAAU
      OERAUPERUBUREVAKZACSZVBUPNOURVCPDQUQVCBUPNVCBUEBDSZFVAEVEFABJZEMVAAVFEFBQ
      AFUFHUCAVFUPEUGUHUITUJVDEUTVAAUOEUKULUMTUJUN $.

    $d v w x y z $.  $d v w z R $.
    $( Equivalence relation involving equality of dependent classes ` A ( x ) `
       and ` B ( y ) ` .  (Contributed by NM, 17-Mar-2008.)  (Revised by Mario
       Carneiro, 12-Aug-2015.) $)
    eqer $p |- R Er _V $=
      ( vz vw vv cvv wtru wceq a1i cv wbr csb eqerlem 3imtr4i adantl wer eqcomd
      wrel relopabi id wa eqtr anbi12i wcel wb vex eqid mpbir 2th iserd trud )
      KEUALHIJKEEUCLCDMABEGUDNHOZIOZEPZURUQEPZLAUQCQZAURCQZMZVBVAMUSUTVCVAVBVCU
      EUBABHICDEFGRZABIHCDEFGRSTUSURJOZEPZUFZUQVEEPZLVCVBAVECQZMZUFVAVIMVGVHVAV
      BVIUGUSVCVFVJVDABIJCDEFGRUHABHJCDEFGRSTUQKUIZUQUQEPZUJLVKVLHUKVLVAVAMVAUL
      ABHHCDEFGRUMUNNUOUP $.
  $}

  ${
    $d x y z $.
    $( The identity relation is an equivalence relation.  (Contributed by NM,
       10-May-1998.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.)  (Proof
       shortened by Mario Carneiro, 9-Jul-2014.) $)
    ider $p |- _I Er _V $=
      ( vx vy cv cid weq id dfid3 eqer ) ABACBCDABEFABGH $.

    $( The empty set is an equivalence relation on the empty set.  (Contributed
       by Mario Carneiro, 5-Sep-2015.) $)
    0er $p |- (/) Er (/) $=
      ( vx vy vz c0 wer wtru wrel rel0 a1i cv wbr wcel df-br noel pm2.21i sylbi
      cop adantl ad2antrl wb 2false bitr4i iserd trud ) DDEFABCDDDGFHIAJZBJZDKZ
      UFUEDKZFUGUEUFQZDLZUHUEUFDMZUJUHUINZOPRUGUECJZDKZFUFUMDKUGUJUNUKUJUNULOPS
      UEDLZUEUEDKZTFUOUEUEQZDLZUPUOURUENUQNUAUEUEDMUBIUCUD $.
  $}

  $( Equality theorem for equivalence class.  (Contributed by NM,
     23-Jul-1995.) $)
  eceq1 $p |- ( A = B -> [ A ] C = [ B ] C ) $=
    ( wceq csn cima cec sneq imaeq2d df-ec 3eqtr4g ) ABDZCAEZFCBEZFACGBCGLMNCAB
    HIACJBCJK $.

  $( Equality theorem for equivalence class.  (Contributed by NM,
     23-Jul-1995.) $)
  eceq2 $p |- ( A = B -> [ C ] A = [ C ] B ) $=
    ( wceq csn cima cec imaeq1 df-ec 3eqtr4g ) ABDACEZFBKFCAGCBGABKHCAICBIJ $.

  ${
    $d x A $.  $d x B $.  $d x R $.
    $( Membership in an equivalence class.  Theorem 72 of [Suppes] p. 82.
       (Contributed by Mario Carneiro, 9-Jul-2014.) $)
    elecg $p |- ( ( A e. V /\ B e. W ) -> ( A e. [ B ] R <-> B R A ) ) $=
      ( wcel wa csn cima cop cec wbr elimasng ancoms df-ec eleq2i df-br 3bitr4g
      wb ) ADFZBEFZGACBHIZFZBAJCFZABCKZFBACLUATUCUDSCBAEDMNUEUBABCOPBACQR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    elec.1 $e |- A e. _V $.
    elec.2 $e |- B e. _V $.
    $( Membership in an equivalence class.  Theorem 72 of [Suppes] p. 82.
       (Contributed by NM, 23-Jul-1995.) $)
    elec $p |- ( A e. [ B ] R <-> B R A ) $=
      ( cvv wcel cec wbr wb elecg mp2an ) AFGBFGABCHGBACIJDEABCFFKL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.
    $( Membership in an equivalence class when ` R ` is a relation.
       (Contributed by Mario Carneiro, 11-Sep-2015.) $)
    relelec $p |- ( Rel R -> ( A e. [ B ] R <-> B R A ) ) $=
      ( wrel cec wcel wbr cvv wa elex ecexr jca adantl brrelex12 elecg pm5.21nd
      ancomd ) CDZABCEZFZBACGZAHFZBHFZIZTUDRTUBUCASJABCKLMRUAIUCUBBACNQABCHHOP
      $.
  $}

  ${
    $d x y R $.
    ecss.1 $e |- ( ph -> R Er X ) $.
    $( An equivalence class is a subset of the domain.  (Contributed by NM,
       6-Aug-1995.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    ecss $p |- ( ph -> [ A ] R C_ X ) $=
      ( crn cec csn cima df-ec imassrn eqsstri wer wceq errn syl syl5sseq ) ACF
      ZBCGZDSCBHZIRBCJCTKLADCMRDNEDCOPQ $.
  $}

  ${
    $d x R $.  $d x A $.
    $( A representative of a nonempty equivalence class belongs to the domain
       of the equivalence relation.  (Contributed by NM, 15-Feb-1996.)
       (Revised by Mario Carneiro, 9-Jul-2014.) $)
    ecdmn0 $p |- ( A e. dom R <-> [ A ] R =/= (/) ) $=
      ( vx cdm wcel cvv cec c0 wne elex cv wex n0 ecexr exlimiv sylbi wbr elecg
      wb vex mpan exbidv a1i eldmg 3bitr4rd pm5.21nii ) ABDZEZAFEZABGZHIZAUGJUK
      CKZUJEZCLZUICUJMZUMUICULABNOPUIUNAULBQZCLUKUHUIUMUPCULFEUIUMUPSCTULABFFRU
      AUBUKUNSUIUOUCCABFUDUEUF $.
  $}

  ${
    ereldm.1 $e |- ( ph -> R Er X ) $.
    ereldm.2 $e |- ( ph -> [ A ] R = [ B ] R ) $.
    $( Equality of equivalence classes implies equivalence of domain
       membership.  (Contributed by NM, 28-Jan-1996.)  (Revised by Mario
       Carneiro, 12-Aug-2015.) $)
    ereldm $p |- ( ph -> ( A e. X <-> B e. X ) ) $=
      ( cdm wcel cec c0 wne neeq1d ecdmn0 3bitr4g wer wceq erdm syl eleq2d
      3bitr3d ) ABDHZIZCUBIZBEICEIABDJZKLCDJZKLUCUDAUEUFKGMBDNCDNOAUBEBAEDPUBEQ
      FEDRSZTAUBECUGTUA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x ph $.
    erth.1 $e |- ( ph -> R Er X ) $.
    erth.2 $e |- ( ph -> A e. X ) $.
    $( Basic property of equivalence relations.  Theorem 73 of [Suppes] p. 82.
       (Contributed by NM, 23-Jul-1995.)  (Revised by Mario Carneiro,
       6-Jul-2015.) $)
    erth $p |- ( ph -> ( A R B <-> [ A ] R = [ B ] R ) ) $=
      ( vx wbr cec wa wcel ertr impl sylan impbida cvv wb adantr elecg cv simpl
      wceq ersymb biimpa jca vex sylancr wrel wer errel syl 3bitr4d eqrdv erref
      brrelex2 syl2anc mpbird simpr eleqtrd ereldm mpbid ersym ) ABCDIZBDJZCDJZ
      UCZAVDKZHVEVFVHBHUAZDIZCVIDIZVIVELZVIVFLZVHVJVKVHACBDIZKVJVKVHAVNAVDUBAVD
      VNABCDEFUDUEUFAVNVJVKACBVIDEFMNOAVDVKVJABCVIDEFMNPVHVIQLZBELZVLVJRHUGZAVP
      VDGSVIBDQETUHVHVOCQLZVMVKRVQADUIZVDVRAEDUJZVSFEDUKULBCDUPOVICDQQTUHUMUNAV
      GKZCBDEAVTVGFSZWABVFLZVNWABVEVFWABVELZBBDIZAWEVGABDEFGUOSWAVPVPWDWERAVPVG
      GSZWFBBDEETUQURAVGUSZUTWAVPCELZWCVNRWFWAVPWHWFWABCDEWBWGVAVBBCDEETUQVBVCP
      $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x ph $.
    erth2.1 $e |- ( ph -> R Er X ) $.
    erth2.2 $e |- ( ph -> B e. X ) $.
    $( Basic property of equivalence relations.  Compare Theorem 73 of [Suppes]
       p. 82.  Assumes membership of the second argument in the domain.
       (Contributed by NM, 30-Jul-1995.)  (Revised by Mario Carneiro,
       6-Jul-2015.) $)
    erth2 $p |- ( ph -> ( A R B <-> [ A ] R = [ B ] R ) ) $=
      ( wbr cec wceq ersymb erth eqcom syl6bb bitrd ) ABCDHCBDHZBDIZCDIZJZABCDE
      FKAPRQJSACBDEFGLRQMNO $.
  $}

  ${
    erthi.1 $e |- ( ph -> R Er X ) $.
    erthi.2 $e |- ( ph -> A R B ) $.
    $( Basic property of equivalence relations.  Part of Lemma 3N of [Enderton]
       p. 57.  (Contributed by NM, 30-Jul-1995.)  (Revised by Mario Carneiro,
       9-Jul-2014.) $)
    erthi $p |- ( ph -> [ A ] R = [ B ] R ) $=
      ( wbr cec wceq ercl erth mpbid ) ABCDHBDICDIJGABCDEFABCDEFGKLM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x X $.
    $( Equivalence classes do not overlap.  In other words, two equivalence
       classes are either equal or disjoint.  Theorem 74 of [Suppes] p. 83.
       (Contributed by NM, 15-Jun-2004.)  (Revised by Mario Carneiro,
       9-Jul-2014.) $)
    erdisj $p |- ( R Er X ->
                ( [ A ] R = [ B ] R \/ ( [ A ] R i^i [ B ] R ) = (/) ) ) $=
      ( vx wer cec cin c0 wceq wcel wbr adantl cvv wb ecexr elecg sylancr mpbid
      syl wn cv wex neq0 wa simpl elin simplbi vex simprbi ertr4d erthi exlimdv
      ex syl5bi orrd orcomd ) DCFZACGZBCGZHZIJZUSUTJZURVBVCVBUAEUBZVAKZEUCURVCE
      VAUDURVEVCEURVEVCURVEUEZABCDURVEUFZVFAVDBCDVGVFVDUSKZAVDCLZVEVHURVEVHVDUT
      KZVDUSUTUGZUHMZVFVDNKZANKZVHVIOEUIZVFVHVNVLVDACPTVDACNNQRSVFVJBVDCLZVEVJU
      RVEVHVJVKUJMZVFVMBNKZVJVPOVOVFVJVRVQVDBCPTVDBCNNQRSUKULUNUMUOUPUQ $.
  $}

  $( An equivalence class modulo the identity relation is a singleton.
     (Contributed by NM, 24-Oct-2004.) $)
  ecidsn $p |- [ A ] _I = { A } $=
    ( cid cec csn cima df-ec imai eqtri ) ABCBADZEIABFIGH $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Equality theorem for quotient set.  (Contributed by NM, 23-Jul-1995.) $)
    qseq1 $p |- ( A = B -> ( A /. C ) = ( B /. C ) ) $=
      ( vy vx wceq cv cec wrex cab cqs rexeq abbidv df-qs 3eqtr4g ) ABFZDGEGCHF
      ZEAIZDJQEBIZDJACKBCKPRSDQEABLMEDACNEDBCNO $.

    $( Equality theorem for quotient set.  (Contributed by NM, 23-Jul-1995.) $)
    qseq2 $p |- ( A = B -> ( C /. A ) = ( C /. B ) ) $=
      ( vy vx wceq cec wrex cab cqs eceq2 eqeq2d rexbidv abbidv df-qs 3eqtr4g
      cv ) ABFZDQZEQZAGZFZECHZDISTBGZFZECHZDICAJCBJRUCUFDRUBUEECRUAUDSABTKLMNED
      CAOEDCBOP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( Closed form of ~ elqs .  (Contributed by Rodolfo Medina,
       12-Oct-2010.) $)
    elqsg $p |- ( B e. V ->
      ( B e. ( A /. R ) <-> E. x e. A B = [ x ] R ) ) $=
      ( vy cv cec wceq wrex cqs eqeq1 rexbidv df-qs elab2g ) FGZAGDHZIZABJCQIZA
      BJFCBDKEPCIRSABPCQLMAFBDNO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    elqs.1 $e |- B e. _V $.
    $( Membership in a quotient set.  (Contributed by NM, 23-Jul-1995.) $)
    elqs $p |- ( B e. ( A /. R ) <-> E. x e. A B = [ x ] R ) $=
      ( cvv wcel cqs cv cec wceq wrex wb elqsg ax-mp ) CFGCBDHGCAIDJKABLMEABCDF
      NO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( Membership in a quotient set.  (Contributed by NM, 23-Jul-1995.) $)
    elqsi $p |- ( B e. ( A /. R ) -> E. x e. A B = [ x ] R ) $=
      ( cqs wcel cv cec wceq wrex elqsg ibi ) CBDEZFCAGDHIABJABCDMKL $.
  $}

  ${
    $d R x $.  $d B x $.  $d A x $.
    $( Membership of an equivalence class in a quotient set.  (Contributed by
       Jeff Madsen, 10-Jun-2010.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    ecelqsg $p |- ( ( R e. V /\ B e. A ) -> [ B ] R e. ( A /. R ) ) $=
      ( vx wcel cec cv wceq wrex cqs eqid eceq1 eqeq2d rspcev mpan2 ecexg elqsg
      cvv wb syl biimpar sylan2 ) BAFZCDFZBCGZEHZCGZIZEAJZUFACKFZUDUFUFIZUJUFLU
      IULEBAUGBIUHUFUFUGBCMNOPUEUKUJUEUFSFUKUJTBDCQEAUFCSRUAUBUC $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    ecelqsi.1 $e |- R e. _V $.
    $( Membership of an equivalence class in a quotient set.  (Contributed by
       NM, 25-Jul-1995.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    ecelqsi $p |- ( B e. A -> [ B ] R e. ( A /. R ) ) $=
      ( cvv wcel cec cqs ecelqsg mpan ) CEFBAFBCGACHFDABCEIJ $.
  $}

  ${
    ecopqsi.1 $e |- R e. _V $.
    ecopqsi.2 $e |- S = ( ( A X. A ) /. R ) $.
    $( "Closure" law for equivalence class of ordered pairs.  (Contributed by
       NM, 25-Mar-1996.) $)
    ecopqsi $p |- ( ( B e. A /\ C e. A ) -> [ <. B , C >. ] R e. S ) $=
      ( wcel wa cop cxp cec opelxpi cqs ecelqsi syl6eleqr syl ) BAHCAHIBCJZAAKZ
      HZRDLZEHBCAAMTUASDNESRDFOGPQ $.
  $}

  ${
    $d x y A $.  $d x y R $.
    $( A quotient set exists.  (Contributed by FL, 19-May-2007.)  (Revised by
       Mario Carneiro, 9-Jul-2014.) $)
    qsexg $p |- ( A e. V -> ( A /. R ) e. _V ) $=
      ( vy vx wcel cqs cv cec wceq wrex cab cvv df-qs abrexexg syl5eqel ) ACFAB
      GDHEHBIZJEAKDLMEDABNEDAQCOP $.
  $}

  ${
    $d x y A $.  $d x y R $.
    qsex.1 $e |- A e. _V $.
    $( A quotient set exists.  (Contributed by NM, 14-Aug-1995.) $)
    qsex $p |- ( A /. R ) e. _V $=
      ( cvv wcel cqs qsexg ax-mp ) ADEABFDECABDGH $.
  $}

  ${
    $d x y A $.  $d x y R $.  $d x V $.
    $( The union of a quotient set.  (Contributed by NM, 9-Dec-2008.) $)
    uniqs $p |- ( R e. V -> U. ( A /. R ) = ( R " A ) ) $=
      ( vy vx wcel cv cec wceq wrex cab cuni ciun cqs cima wral ecexg ralrimivw
      cvv dfiun2g syl eqcomd df-qs unieqi csn df-ec a1i iuneq2i imaiun 3eqtr2ri
      iunid imaeq2i 3eqtr4g ) BCFZDGEGZBHZIEAJDKZLZEAUPMZABNZLBAOZUNUSURUNUPSFZ
      EAPUSURIUNVBEAUOCBQREDAUPSTUAUBUTUQEDABUCUDUSEABUOUEZOZMBEAVCMZOVAEAUPVDU
      PVDIUOAFUOBUFUGUHEBAVCUIVEABEAUKULUJUM $.
  $}

  ${
    $d x y A $.  $d x y ph $.  $d x y R $.
    qsss.1 $e |- ( ph -> R Er A ) $.
    $( A quotient set is a set of subsets of the base set.  (Contributed by
       Mario Carneiro, 9-Jul-2014.)  (Revised by Mario Carneiro,
       12-Aug-2015.) $)
    qsss $p |- ( ph -> ( A /. R ) C_ ~P A ) $=
      ( vx vy cqs cpw cv wcel cec wceq wrex vex elqs ecss sseq1 syl5ibrcom elpw
      wss syl6ibr rexlimdvw syl5bi ssrdv ) AEBCGZBHZEIZUEJUGFIZCKZLZFBMAUGUFJZF
      BUGCENZOAUJUKFBAUJUGBTZUKAUMUJUIBTAUHCBDPUGUIBQRUGBULSUAUBUCUD $.

    qsss.2 $e |- ( ph -> R e. V ) $.
    $( The union of a quotient set.  (Contributed by Mario Carneiro,
       11-Jul-2014.) $)
    uniqs2 $p |- ( ph -> U. ( A /. R ) = A ) $=
      ( cqs cuni crn cdm cima wcel wceq uniqs syl erdm imaeq2d eqtr4d imadmrn
      wer syl6eq errn eqtrd ) ABCGHZCIZBAUDCCJZKZUEAUDCBKZUGACDLUDUHMFBCDNOAUFB
      CABCTZUFBMEBCPOQRCSUAAUIUEBMEBCUBOUC $.
  $}

  ${
    $d x y A $.  $d x y R $.
    snec.1 $e |- A e. _V $.
    $( The singleton of an equivalence class.  (Contributed by NM,
       29-Jan-1999.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    snec $p |- { [ A ] R } = ( { A } /. R ) $=
      ( vy vx cv cec wceq csn wrex cab cqs eceq1 eqeq2d rexsn abbii df-qs df-sn
      3eqtr4ri ) DFZEFZBGZHZEAIZJZDKTABGZHZDKUDBLUFIUEUGDUCUGEACUAAHUBUFTUAABMN
      OPEDUDBQDUFRS $.
  $}

  ${
    ecqs.1 $e |- R e. _V $.
    $( Equivalence class in terms of quotient set.  (Contributed by NM,
       29-Jan-1999.) $)
    ecqs $p |- [ A ] R = U. ( { A } /. R ) $=
      ( cec csn cima cqs cuni df-ec cvv wcel wceq uniqs ax-mp eqtr4i ) ABDBAEZF
      ZPBGHZABIBJKRQLCPBJMNO $.
  $}

  ${
    $d y A $.
    ecid.1 $e |- A e. _V $.
    $( A set is equal to its converse epsilon coset.  (Note: converse epsilon
       is not an equivalence relation.)  (Contributed by NM, 13-Aug-1995.)
       (Revised by Mario Carneiro, 9-Jul-2014.) $)
    ecid $p |- [ A ] `' _E = A $=
      ( vy cep ccnv cec cv wcel wbr vex elec brcnv epelc 3bitri eqriv ) CADEZFZ
      ACGZQHARPIRADIRAHRAPCJZBKARDBSLRABMNO $.
  $}

  ${
    $d x y A $.
    $( A set is equal to its quotient set mod converse epsilon.  (Note:
       converse epsilon is not an equivalence relation.)  (Contributed by NM,
       13-Aug-1995.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    qsid $p |- ( A /. `' _E ) = A $=
      ( vy vx cep ccnv cqs cv cec wceq wrex wcel vex eqeq2i equcom bitri rexbii
      ecid elqs risset 3bitr4i eqriv ) BADEZFZABGZCGZUBHZIZCAJUEUDIZCAJUDUCKUDA
      KUGUHCAUGUDUEIUHUFUEUDUECLQMBCNOPCAUDUBBLRCUDASTUA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x ps $.  $d x ch $.
    ectocl.1 $e |- S = ( B /. R ) $.
    ectocl.2 $e |- ( [ x ] R = A -> ( ph <-> ps ) ) $.
    ${
      ectocld.3 $e |- ( ( ch /\ x e. B ) -> ph ) $.
      $( Implicit substitution of class for equivalence class.  (Contributed by
         Mario Carneiro, 9-Jul-2014.) $)
      ectocld $p |- ( ( ch /\ A e. S ) -> ps ) $=
        ( wcel cv cec wceq wrex cqs elqsi eleq2s wa wb syl5ibcom rexlimdva syl5
        eqcoms imp ) CEHLZBUGEDMZGNZOZDFPZCBUKEFGQHDFEGRISCUJBDFCUHFLTAUJBKABUA
        UIEJUEUBUCUDUF $.
    $}

    ectocl.3 $e |- ( x e. B -> ph ) $.
    $( Implicit substitution of class for equivalence class.  (Contributed by
       NM, 23-Jul-1995.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    ectocl $p |- ( A e. S -> ps ) $=
      ( wtru wcel tru cv adantl ectocld mpan ) KDGLBMABKCDEFGHICNELAKJOPQ $.
  $}

  ${
    $d x R $.  $d x A $.  $d x B $.
    $( A quotient set doesn't contain the empty set.  (Contributed by NM,
       24-Aug-1995.) $)
    elqsn0 $p |- ( ( dom R = A /\ B e. ( A /. R ) ) -> B =/= (/) ) $=
      ( vx cv cec c0 wne cdm wceq eqid neeq1 wcel wa eleq2 biimpar ecdmn0 sylib
      cqs ectocld ) DEZCFZGHZBGHCIZAJZDBACACSZUFKUBBGLUEUAAMZNUAUDMZUCUEUHUGUDA
      UAOPUACQRT $.
  $}

  ${
    $( Membership of an equivalence class in a quotient set.  (Contributed by
       NM, 30-Jul-1995.) $)
    ecelqsdm $p |- ( ( dom R = A /\ [ B ] R e. ( A /. R ) ) -> B e. A ) $=
      ( cdm wceq cec cqs wcel wa c0 wne elqsn0 ecdmn0 sylibr simpl eleqtrd ) CD
      ZAEZBCFZACGHZIZBQAUASJKBQHASCLBCMNRTOP $.
  $}

  $( A square cross product is an equivalence relation (in general it's not a
     poset).  (Contributed by FL, 31-Jul-2009.)  (Revised by Mario Carneiro,
     12-Aug-2015.) $)
  xpider $p |- ( A X. A ) Er A $=
    ( cxp wer wrel cdm wceq ccnv ccom cun relxp dmxpid cnvxp xpidtr uneq1 unss2
    wss wi unidm wa eqtr sseq2 biimpd syl mpan2 syl2im mp2 df-er mpbir3an ) AAA
    BZCUIDUIEAFUIGZUIUIHZIZUIPZAAJAKUJUIFZUKUIPZUMAALAMUNUJUIIZUIUIIZFZUOULUPPZ
    UMUJUIUINUKUIUJOURUQUIFZUSUMQZUIRURUTSUPUIFZVAUPUQUITVBUSUMUPUIULUAUBUCUDUE
    UFAUIUGUH $.

  ${
    $d u v w x A $.  $d u v w x B $.  $d u v w R $.
    $( The intersection of a nonempty family of equivalence relations is an
       equivalence relation.  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    iiner $p |- ( ( A =/= (/) /\ A. x e. A R Er B ) ->
                  |^|_ x e. A R Er B ) $=
      ( vu wral wa cvv wrex cv wbr cop wcel wi df-br wb opex eliin ax-mp bitri
      vv vw c0 wne wer ciin cxp wss wrel r19.2z errel df-rel sylib reximi iinss
      sylibr id ersymb biimpd 3imtr3g ral2imi adantl 3imtr4g imp r19.26 anbi12i
      3syl syl5bir simpl simpr erref expcom ralimdv com12 cdm vex opeldm eleq2d
      ertr erdm biimpa sylan2 rexlimivw syl ex expdimp impbid syl6bbr iserd ) B
      UCUDZCDUEZABFZGZEUAUBCABDUFZWMWNHHUGZUHZWNUIWMWKABIDWOUHZABIWPWKABUJWKWQA
      BWKDUIWQCDUKDULUMUNABDWOUOVGWNULUPWMEJZUAJZWNKZWSWRWNKZWMWRWSLZDMZABFZWSW
      RLZDMZABFZWTXAWLXDXGNWJWKXCXFABWKWRWSDKZWSWRDKZXCXFWKXHXIWKWRWSDCWKUQZURU
      SWRWSDOZWSWRDOUTVAVBWTXBWNMZXDWRWSWNOXBHMXLXDPWRWSQAXBBDHRSTZXAXEWNMZXGWS
      WRWNOXEHMXNXGPWSWRQAXEBDHRSTVCVDWMWTWSUBJZWNKZGZWRXOWNKZWMXDWSXOLZDMZABFZ
      GZWRXOLZDMZABFZXQXRYBXCXTGZABFZWMYEXCXTABVEWLYGYENWJWKYFYDABWKXHWSXODKZGW
      RXODKYFYDWKWRWSXODCXJVSXHXCYHXTXKWSXODOVFWRXODOUTVAVBVHWTXDXPYAXMXPXSWNMZ
      YAWSXOWNOXSHMYIYAPWSXOQAXSBDHRSTVFXRYCWNMZYEWRXOWNOYCHMYJYEPWRXOQAYCBDHRS
      TVCVDWMWRCMZWRWRLZDMZABFZWRWRWNKZWMYKYNWLYKYNNWJYKWLYNYKWKYMABWKYKYMWKYKG
      ZWRWRDKYMYPWRDCWKYKVIWKYKVJVKWRWRDOUMVLVMVNVBWJWLYNYKWLYNGWKYMGZABFZWJYKW
      KYMABVEWJYRYKWJYRGYQABIYKYQABUJYQYKABYMWKWRDVOZMZYKWRWRDEVPZUUAVQWKYTYKWK
      YSCWRCDVTVRWAWBWCWDWEVHWFWGYOYLWNMZYNWRWRWNOYLHMUUBYNPWRWRQAYLBDHRSTWHWI
      $.

    $( The relative intersection of a family of equivalence relations is an
       equivalence relation.  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    riiner $p |- ( A. x e. A R Er B ->
      ( ( B X. B ) i^i |^|_ x e. A R ) Er B ) $=
      ( wer wral cxp ciin cin c0 wa xpider wb riin0 adantl ereq1 syl mpbiri wne
      wceq iiner ancoms wss erssxp ralimi riinn0 sylan mpbird pm2.61dane ) CDEZ
      ABFZCCCGZABDHZIZEZBJUKBJTZKZUOCULEZCLUQUNULTZUOURMUPUSUKAULDBNOCUNULPQRUK
      BJSZKZUOCUMEZUTUKVBABCDUAUBVAUNUMTZUOVBMUKDULUCZABFUTVCUJVDABCDUDUEAULDBU
      FUGCUNUMPQUHUI $.
  $}

  ${
    $d x y z B $.  $d x y z ph $.  $d x y z R $.
    erinxp.r $e |- ( ph -> R Er A ) $.
    erinxp.a $e |- ( ph -> B C_ A ) $.
    $( A restricted equivalence relation is an equivalence relation.
       (Contributed by Mario Carneiro, 10-Jul-2015.)  (Revised by Mario
       Carneiro, 12-Aug-2015.) $)
    erinxp $p |- ( ph -> ( R i^i ( B X. B ) ) Er B ) $=
      ( vx vy vz wrel cv wbr wa wcel w3a brinxp2 sylib simp2d adantr simp3d cxp
      cin wss inss2 relxp relss mp2 a1i simpr simp1d wer ersym syl3anbrc simprr
      adantrr ertrd sselda erref ex pm4.71rd brin brxp anidm bitri anbi2i iserd
      syl6bbr ) AGHICDCCUAZUBZVIJZAVIVHUCVHJVJDVHUDCCUEVIVHUFUGUHAGKZHKZVILZMZV
      LCNZVKCNZVLVKDLVLVKVILVNVPVOVKVLDLZVNVMVPVOVQOAVMUIVKVLCCDPQZRVNVPVOVQVRU
      JZVNVKVLDBABDUKZVMESVNVPVOVQVRTZULVLVKCCDPUMAVMVLIKZVILZMZMZVPWBCNZVKWBDL
      VKWBVILAVMVPWCVSUOWEVOWFVLWBDLZWEWCVOWFWGOAVMWCUNVLWBCCDPQZRWEVKVLWBDBAVT
      WDESAVMVQWCWAUOWEVOWFWGWHTUPVKWBCCDPUMAVPVKVKDLZVPMZVKVKVILZAVPWIAVPWIAVP
      MVKDBAVTVPESACBVKFUQURUSUTWKWIVKVKVHLZMWJVKVKDVHVAWLVPWIWLVPVPMVPVKVKCCVB
      VPVCVDVEVDVGVF $.
  $}

  $( Restrict the relation in an equivalence class to a base set.  (Contributed
     by Mario Carneiro, 10-Jul-2015.) $)
  ecinxp $p |- ( ( ( R " A ) C_ A /\ B e. A ) ->
      [ B ] R = [ B ] ( R i^i ( A X. A ) ) ) $=
    ( cima wss wcel csn cxp cin cec wceq simpr snssd df-ss sylib imaeq2d ineq1d
    wa imass2 df-ec syl simpl sstrd eqtr2d imainrect syl6eqr 3eqtr4g ) CADZAEZB
    AFZRZCBGZDZCAAHIZULDZBCJBUNJUKUMCULAIZDZAIZUOUKURUMAIZUMUKUQUMAUKUPULCUKULA
    EZUPULKUKBAUIUJLMZULANOPQUKUMAEUSUMKUKUMUHAUKUTUMUHEVAULACSUAUIUJUBUCUMANOU
    DAACULUEUFBCTBUNTUG $.

  ${
    $d x y A $.  $d x B $.  $d x y C $.  $d x y ph $.  $d x y R $.
    $( Restrict the equivalence relation in a quotient set to the base set.
       (Contributed by Mario Carneiro, 23-Feb-2015.) $)
    qsinxp $p |- ( ( R " A ) C_ A ->
        ( A /. R ) = ( A /. ( R i^i ( A X. A ) ) ) ) $=
      ( vy vx cima wss cv cec wceq wrex cab cxp cin cqs wcel wa ecinxp rexbidva
      eqeq2d df-qs abbidv 3eqtr4g ) BAEAFZCGZDGZBHZIZDAJZCKUDUEBAALMZHZIZDAJZCK
      ABNAUINUCUHULCUCUGUKDAUCUEAOPUFUJUDAUEBQSRUADCABTDCAUITUB $.

    qsdisj.1 $e |- ( ph -> R Er X ) $.
    qsdisj.2 $e |- ( ph -> B e. ( A /. R ) ) $.
    qsdisj.3 $e |- ( ph -> C e. ( A /. R ) ) $.
    $( Members of a quotient set do not overlap.  (Contributed by Rodolfo
       Medina, 12-Oct-2010.)  (Revised by Mario Carneiro, 11-Jul-2014.) $)
    qsdisj $p |- ( ph -> ( B = C \/ ( B i^i C ) = (/) ) ) $=
      ( vx vy wcel wceq cin c0 wo cv cec eqeq1d orbi12d cqs eqid eqeq1 ineq1 wa
      adantr eqeq2 ineq2 wer ad2antrr erdisj syl ectocld mpdan ) ACBEUAZLCDMZCD
      NZOMZPZHJQZERZDMZVADNZOMZPZUSAJCBEUOUOUBZVACMZVBUPVDURVACDUCVGVCUQOVACDUD
      STAUTBLZUEZDUOLZVEAVJVHIUFVAKQZERZMZVAVLNZOMZPZVEVIKDBEUOVFVLDMZVMVBVOVDV
      LDVAUGVQVNVCOVLDVAUHSTVIVKBLZUEFEUIZVPAVSVHVRGUJUTVKEFUKULUMUNUMUN $.
  $}

  ${
    $d x y A $.  $d x y X $.  $d x y R $.
    $( A quotient set is a disjoint set.  (Contributed by Mario Carneiro,
       10-Dec-2016.) $)
    qsdisj2 $p |- ( R Er X -> Disj_ x e. ( A /. R ) x ) $=
      ( vy wer cv wceq cin c0 wo cqs wral wdisj wcel simpl simprl simprr qsdisj
      wa ralrimivva id disjor sylibr ) DCFZAGZEGZHZUFUGIJHKZEBCLZMAUJMAUJUFNUEU
      IAEUJUJUEUFUJOZUGUJOZTZTBUFUGCDUEUMPUEUKULQUEUKULRSUAUJUFUGAEUHUBUCUD $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x R $.  $d x X $.
    $( If an element of a quotient set contains a given element, it is equal to
       the equivalence class of the element.  (Contributed by Mario Carneiro,
       12-Aug-2015.) $)
    qsel $p |- ( ( R Er X /\ B e. ( A /. R ) /\ C e. B ) -> B = [ C ] R ) $=
      ( vx wer cqs wcel cec wceq cv wi eqid eleq2 eqeq1 imbi12d wbr wa cvv syl5
      wb vex elecg mpan2 ibi simpll simpr erthi ex ectocld 3impia ) EDGZBADHZIC
      BIZBCDJZKZCFLZDJZIZUSUPKZMUOUQMUMFBADUNUNNUSBKUTUOVAUQUSBCOUSBUPPQUTURCDR
      ZUMURAIZSZVAUTVBUTURTIUTVBUBFUCCURDUSTUDUEUFVDVBVAVDVBSURCDEUMVCVBUGVDVBU
      HUIUJUAUKUL $.
  $}

  ${
    $d b c x A $.  $d b c x B $.  $d b c x C $.  $d b c x R $.
    uniinqs.1 $e |- R Er X $.
    $( Class union distributes over the intersection of two subclasses of a
       quotient space.  Compare ~ uniin .  (Contributed by FL, 25-May-2007.)
       (Proof shortened by Mario Carneiro, 11-Jul-2014.) $)
    uniinqs $p |- ( ( B C_ ( A /. R ) /\ C C_ ( A /. R ) ) ->
      U. ( B i^i C ) = ( U. B i^i U. C ) ) $=
      ( vx vb vc wss wa cin cuni a1i cv wcel wrex eluni2 elin c0 anbi12i reeanv
      cqs uniin 3bitr4i w3a simp3l simp2l wne inelcm 3ad2ant3 wer simp1l sseldd
      wceq simp1r simp2r qsdisj ord necon1ad mpd eqeltrd sylanbrc elunii 3expia
      syl2anc rexlimdvva syl5bi ssrdv eqssd ) BADUCZJZCVKJZKZBCLZMZBMZCMZLZVPVS
      JVNBCUDNVNGVSVPGOZVSPZVTHOZPZVTIOZPZKZICQHBQZVNVTVPPZVTVQPZVTVRPZKWCHBQZW
      EICQZKWAWGWIWKWJWLHVTBRIVTCRUAVTVQVRSWCWEHIBCUBUEVNWFWHHIBCVNWBBPZWDCPZKZ
      WFWHVNWOWFUFZWCWBVOPZWHVNWOWCWEUGWPWMWBCPWQVNWMWNWFUHZWPWBWDCWPWBWDLZTUIZ
      WBWDUOZWFVNWTWOVTWBWDUJUKWPXAWSTWPXAWSTUOWPAWBWDDEEDULWPFNWPBVKWBVLVMWOWF
      UMWRUNWPCVKWDVLVMWOWFUPVNWMWNWFUQZUNURUSUTVAXBVBWBBCSVCVTWBVOVDVFVEVGVHVI
      VJ $.
  $}

  ${
    $d y z A $.  $d x B $.  $d x C $.  $d x D $.  $d x y z ph $.  $d x y z R $.
    $d y z F $.  $d x y z X $.  $d x y z Y $.
    qlift.1 $e |- F = ran ( x e. X |-> <. [ x ] R , A >. ) $.
    qlift.2 $e |- ( ( ph /\ x e. X ) -> A e. Y ) $.
    qlift.3 $e |- ( ph -> R Er X ) $.
    qlift.4 $e |- ( ph -> X e. _V ) $.
    $( ` F ` , a function lift, is a subset of ` R X. S ` .  (Contributed by
       Mario Carneiro, 23-Dec-2016.) $)
    qliftlem $p |- ( ( ph /\ x e. X ) -> [ x ] R e. ( X /. R ) ) $=
      ( cvv wcel cv cec cqs wer erex sylc ecelqsg sylan ) ADLMZBNZFMUCDOFDPMAFD
      QFLMUBJKFDLRSFUCDLTUA $.

    $( ` F ` , a function lift, is a subset of ` R X. S ` .  (Contributed by
       Mario Carneiro, 23-Dec-2016.) $)
    qliftrel $p |- ( ph -> F C_ ( ( X /. R ) X. Y ) ) $=
      ( cv cec cqs qliftlem fliftrel ) ABBLDMCFDNGEFHABCDEFGHIJKOIP $.

    $( Elementhood in the relation ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    qliftel $p |- ( ph -> ( [ C ] R F D <-> E. x e. X ( C R x /\ D = A ) ) ) $=
      ( cec wbr cv wceq wa wrex cqs qliftlem wcel wer adantr simpr erth2 anbi1d
      fliftel rexbidva bitr4d ) ADFNZEGOUKBPZFNZQZECQZRZBHSDULFOZUORZBHSABUMCUK
      EHFTIGHJABCFGHIJKLMUAKUHAURUPBHAULHUBZRZUQUNUOUTDULFHAHFUCUSLUDAUSUEUFUGU
      IUJ $.

    $( Elementhood in the relation ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    qliftel1 $p |- ( ( ph /\ x e. X ) -> [ x ] R F A ) $=
      ( cv cec cqs qliftlem fliftel1 ) ABBLDMCFDNGEFHABCDEFGHIJKOIP $.

    ${
      qliftfun.4 $e |- ( x = y -> A = B ) $.
      $( The function ` F ` is the unique function defined by
         ` F `` [ x ] = A ` , provided that the well-definedness condition
         holds.  (Contributed by Mario Carneiro, 23-Dec-2016.) $)
      qliftfun $p |- ( ph -> ( Fun F <-> A. x A. y ( x R y -> A = B ) ) ) $=
        ( cv cec wceq wi wal wa wfun wral wbr cqs qliftlem fliftfun wcel adantr
        eceq1 wer simpr ercl ercl2 jca ex pm4.71rd simprl pm5.32da bitrd imbi1d
        erth impexp syl6bb 2albidv r2al syl6bbr bitr4d ) AGUABOZFPZCOZFPZQZDEQZ
        RZCHUBBHUBZVHVJFUCZVMRZCSBSZABCVIDVKEHFUDIGHJABDFGHIJKLMUEKVHVJFUINUFAV
        RVHHUGZVJHUGZTZVNRZCSBSVOAVQWBBCAVQWAVLTZVMRWBAVPWCVMAVPWAVPTWCAVPWAAVP
        WAAVPTZVSVTWDVHVJFHAHFUJZVPLUHZAVPUKZULWDVHVJFHWFWGUMUNUOUPAWAVPVLAWATV
        HVJFHAWEWALUHAVSVTUQVAURUSUTWAVLVMVBVCVDVNBCHHVEVFVG $.

      qliftfund.6 $e |- ( ( ph /\ x R y ) -> A = B ) $.
      $( The function ` F ` is the unique function defined by
         ` F `` [ x ] = A ` , provided that the well-definedness condition
         holds.  (Contributed by Mario Carneiro, 23-Dec-2016.) $)
      qliftfund $p |- ( ph -> Fun F ) $=
        ( wfun cv wbr wceq wal wi ex alrimivv qliftfun mpbird ) AGPBQCQFRZDESZU
        AZCTBTAUHBCAUFUGOUBUCABCDEFGHIJKLMNUDUE $.
    $}

    $( The function ` F ` is the unique function defined by
       ` F `` [ x ] = A ` , provided that the well-definedness condition
       holds.  (Contributed by Mario Carneiro, 23-Dec-2016.) $)
    qliftfuns $p |- ( ph -> ( Fun F <->
      A. y A. z ( y R z -> [_ y / x ]_ A = [_ z / x ]_ A ) ) ) $=
      ( cv csb cec cop cmpt crn wcel nfcv nfcsb1v nfop weq eceq1 csbeq1a cbvmpt
      opeq12d rneqi eqtri wral ralrimiva nfel1 eleq1d mpan9 csbeq1 qliftfun
      rspc ) ACDBCNZEOZBDNZEOFGHIGBHBNZFPZEQZRZSCHUSFPZUTQZRZSJVEVHBCHVDVGCVDUA
      BVFUTBVFUABUSEUBZUCBCUDZVCVFEUTVBUSFUEBUSEUFZUHUGUIUJAEITZBHUKUSHTUTITZAV
      LBHKULVLVMBUSHBUTIVIUMVJEUTIVKUNURUOLMBUSVAEUPUQ $.

    $( The domain and range of the function ` F ` .  (Contributed by Mario
       Carneiro, 23-Dec-2016.) $)
    qliftf $p |- ( ph -> ( Fun F <-> F : ( X /. R ) --> Y ) ) $=
      ( vy wfun cv cec cmpt crn wf cqs wceq qliftlem fliftf wrex cab df-qs eqid
      rnmpt eqtr4i a1i feq2d bitr4d ) AEMBFBNDOZPZQZGERFDSZGERABULCUOGEFHABCDEF
      GHIJKUAIUBAUOUNGEUOUNTAUOLNULTBFUCLUDUNBLFDUEBLFULUMUMUFUGUHUIUJUK $.

    qliftval.4 $e |- ( x = C -> A = B ) $.
    qliftval.6 $e |- ( ph -> Fun F ) $.
    $( The value of the function ` F ` .  (Contributed by Mario Carneiro,
       23-Dec-2016.) $)
    qliftval $p |- ( ( ph /\ C e. X ) -> ( F ` [ C ] R ) = B ) $=
      ( cv cec cqs qliftlem eceq1 fliftval ) ABBPZFQCEFQDHFRIGHEJABCFGHIJKLMSKU
      BEFTNOUA $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d x y z ps $.
    ecoptocl.1 $e |- S = ( ( B X. C ) /. R ) $.
    ecoptocl.2 $e |- ( [ <. x , y >. ] R = A -> ( ph <-> ps ) ) $.
    ecoptocl.3 $e |- ( ( x e. B /\ y e. C ) -> ph ) $.
    $( Implicit substitution of class for equivalence class of ordered pair.
       (Contributed by NM, 23-Jul-1995.) $)
    ecoptocl $p |- ( A e. S -> ps ) $=
      ( vz cxp cqs wcel cv cec wceq wi wrex elqsi cop eceq1 eqeq2d imbi1d wa wb
      eqid eqcoms syl5ibcom optocl rexlimiv syl eleq2s ) BEFGNZHOZIEUQPEMQZHRZS
      ZMUPUABMUPEHUBUTBMUPECQZDQZUCZHRZSZBTUTBTCDURFGUPUPUIVCURSZVEUTBVFVDUSEVC
      URHUDUEUFVAFPVBGPUGAVEBLABUHVDEKUJUKULUMUNJUO $.
  $}

  ${
    $d x y z w A $.  $d z w B $.  $d x y z w C $.  $d x y z w D $.  $d z w S $.
    $d x y z w R $.  $d x y ps $.  $d z w ch $.
    2ecoptocl.1 $e |- S = ( ( C X. D ) /. R ) $.
    2ecoptocl.2 $e |- ( [ <. x , y >. ] R = A -> ( ph <-> ps ) ) $.
    2ecoptocl.3 $e |- ( [ <. z , w >. ] R = B -> ( ps <-> ch ) ) $.
    2ecoptocl.4 $e |- ( ( ( x e. C /\ y e. D ) /\
                      ( z e. C /\ w e. D ) ) -> ph ) $.
    $( Implicit substitution of classes for equivalence classes of ordered
       pairs.  (Contributed by NM, 23-Jul-1995.) $)
    2ecoptocl $p |- ( ( A e. S /\ B e. S ) -> ch ) $=
      ( wcel wi cv cop cec wceq imbi2d wa ex ecoptocl com12 impcom ) IMRHMRZCUJ
      BSUJCSFGIJKLMNFTZGTZUALUBIUCBCUJPUDUJUKJRULKRUEZBUMASUMBSDEHJKLMNDTZETZUA
      LUBHUCABUMOUDUNJRUOKRUEUMAQUFUGUHUGUI $.
  $}

  ${
    $d x y z w v u A $.  $d z w v u B $.  $d v u C $.  $d x y z w v u D $.
    $d z w v u S $.  $d x y z w v u R $.  $d x y ps $.  $d z w ch $.
    $d v u th $.
    3ecoptocl.1 $e |- S = ( ( D X. D ) /. R ) $.
    3ecoptocl.2 $e |- ( [ <. x , y >. ] R = A -> ( ph <-> ps ) ) $.
    3ecoptocl.3 $e |- ( [ <. z , w >. ] R = B -> ( ps <-> ch ) ) $.
    3ecoptocl.4 $e |- ( [ <. v , u >. ] R = C -> ( ch <-> th ) ) $.
    3ecoptocl.5 $e |- ( ( ( x e. D /\ y e. D ) /\
                      ( z e. D /\ w e. D ) /\ ( v e. D /\ u e. D ) ) -> ph ) $.
    $( Implicit substitution of classes for equivalence classes of ordered
       pairs.  (Contributed by NM, 9-Aug-1995.) $)
    3ecoptocl $p |- ( ( A e. S /\ B e. S /\ C e. S ) -> th ) $=
      ( wcel wa wi cop cec wceq imbi2d 3expib ecoptocl com12 2ecoptocl 3impib
      cv ) KPUBZLPUBZMPUBZDUPUQUCUODUOBUDUOCUDUODUDGHIJLMNNOPQGUNZHUNZUEOUFLUGB
      CUOSUHIUNZJUNZUEOUFMUGCDUOTUHUOURNUBUSNUBUCZUTNUBVANUBUCZUCZBVDAUDVDBUDEF
      KNNOPQEUNZFUNZUEOUFKUGABVDRUHVENUBVFNUBUCVBVCAUAUIUJUKULUKUM $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.  $d x y z w v u .~ $.  $d x y H $.  $d z w v u G $.
    $d x y ph $.  $d z w v u ps $.
    brecop.1 $e |- .~ e. _V $.
    brecop.2 $e |- .~ Er ( G X. G ) $.
    brecop.4 $e |- H = ( ( G X. G ) /. .~ ) $.
    brecop.5 $e |- .<_ = { <. x , y >. | ( ( x e. H /\ y e. H ) /\
                      E. z E. w E. v E. u ( ( x = [ <. z , w >. ] .~ /\
                      y = [ <. v , u >. ] .~ ) /\ ph ) ) } $.
    brecop.6 $e |- ( ( ( ( z e. G /\ w e. G ) /\ ( A e. G /\ B e. G ) ) /\
                       ( ( v e. G /\ u e. G ) /\ ( C e. G /\ D e. G ) ) ) ->
                     ( ( [ <. z , w >. ] .~ = [ <. A , B >. ] .~ /\
                         [ <. v , u >. ] .~ = [ <. C , D >. ] .~ ) ->
                     ( ph <-> ps ) ) ) $.
    $( Binary relation on a quotient set.  Lemma for real number construction.
       (Contributed by NM, 29-Jan-1996.) $)
    brecop $p |- ( ( ( A e. G /\ B e. G ) /\ ( C e. G /\ D e. G ) ) ->
                ( [ <. A , B >. ] .~ .<_ [ <. C , D >. ] .~ <-> ps ) ) $=
      ( wcel wa cop cec wbr cv wceq wex ecopqsi copab df-br eleq2i bitri anbi1d
      wb eqeq1 4exbidv anbi2d opelopab2 syl5bb syl2an wi opeq12 syl anim12i cxp
      eceq1 opelxpi opelxp wer id ereldm syl5bbr syl5ibr im2anan9 an4s ex com13
      a1i mpdd pm5.74d cgsex4g eqcom anbi12i biimt anbi12d 3bitr4d bitrd ) INUB
      JNUBUCZKNUBLNUBUCZUCZIJUDZMUEZKLUDZMUEZPUFZWNEUGZFUGZUDZMUEZUHZWPGUGZHUGZ
      UDZMUEZUHZUCZAUCZHUIGUIFUIEUIZBWJWNOUBZWPOUBZWQXJUPWKNIJMOQSUJNKLMOQSUJWQ
      WNWPUDZCUGZOUBDUGZOUBUCXNXAUHZXOXFUHZUCZAUCZHUIGUIFUIEUIZUCCDUKZUBZXKXLUC
      XJWQXMPUBYBWNWPPULPYAXMTUMUNXTXBXQUCZAUCZHUIGUIFUIEUIXJCDWNWPOOXNWNUHZXSY
      DEFGHYEXRYCAYEXPXBXQXNWNXAUQUOUOURXOWPUHZYDXIEFGHYFYCXHAYFXQXGXBXOWPXFUQU
      SUOURUTVAVBWLXAWNUHZXFWPUHZUCZWLAVCZUCZHUIGUIFUIEUIWLBVCZXJBYJYLYIEFGHIJK
      LNNWRIUHWSJUHUCZYGXCKUHXDLUHUCZYHYMWTWMUHYGWRWSIJVDWTWMMVHVEYNXEWOUHYHXCX
      DKLVDXEWOMVHVEVFYIWLABYIWLWRNUBWSNUBUCZXCNUBXDNUBUCZUCZABUPZYGWJYOYHWKYPW
      JYOYGWMNNVGZUBZIJNNVIYOWTYSUBYGYTWRWSNNVJYGWTWMMYSYSMVKZYGRVTYGVLVMVNVOWK
      YPYHWOYSUBZKLNNVIYPXEYSUBYHUUBXCXDNNVJYHXEWOMYSUUAYHRVTYHVLVMVNVOVPYQWLYI
      YRYQWLYIYRVCZYOWJYPWKUUCUAVQVRVSWAWBWCWLXIYKEFGHWLXHYIAYJXHYIUPWLXBYGXGYH
      WNXAWDWPXFWDWEVTWLAWFWGURWLBWFWHWI $.
  $}

  ${
    brecop2.1 $e |- .~ e. _V $.
    brecop2.5 $e |- dom .~ = ( G X. G ) $.
    brecop2.6 $e |- H = ( ( G X. G ) /. .~ ) $.
    brecop2.7 $e |- R C_ ( H X. H ) $.
    brecop2.8 $e |- .<_ C_ ( G X. G ) $.
    brecop2.9 $e |- -. (/) e. G $.
    brecop2.10 $e |- dom .+ = ( G X. G ) $.
    brecop2.11 $e |- ( ( ( A e. G /\ B e. G ) /\ ( C e. G /\ D e. G ) ) ->
                    ( [ <. A , B >. ] .~ R [ <. C , D >. ] .~ <->
                    ( A .+ D ) .<_ ( B .+ C ) ) ) $.
    $( Binary relation on a quotient set.  Lemma for real number construction.
       Eliminates antecedent from last hypothesis.  (Contributed by NM,
       13-Feb-1996.) $)
    brecop2 $p |- ( [ <. A , B >. ] .~ R [ <. C , D >. ] .~ <->
                    ( A .+ D ) .<_ ( B .+ C ) ) $=
      ( wcel wa cop cec wbr co brel cxp cqs cdm wceq ecelqsdm mpan eleq2s sylib
      opelxp anim12i syl ndmovrcl an42 pm5.21nii ) ABUAZFUBZCDUAZFUBZGUCZAHSZBH
      SZTZCHSZDHSZTZTZADEUDZBCEUDZJUCZVDVAISZVCISZTVKVAVCIIGNUEVOVGVPVJVOUTHHUF
      ZSZVGVRVAVQFUGZIFUHVQUIZVAVSSVRLVQUTFUJUKMULABHHUNUMVPVBVQSZVJWAVCVSIVTVC
      VSSWALVQVBFUJUKMULCDHHUNUMUOUPVNVEVITZVFVHTZTZVKVNVLHSZVMHSZTWDVLVMHHJOUE
      WEWBWFWCADHEQPUQBCHEQPUQUOUPVEVIVFVHURUMRUS $.
  $}

  ${
    $d p q r s t u w x y z A $.  $d p q r s t u w x y z B $.  $d p q x y z L $.
    $d p q w x y z J $.  $d p q r s t u x y z P $.  $d p q r s t u w x y z R $.
    $d p q w x y z K $.  $d p q r s t u x y z Q $.  $d p q r s t u w x y z S $.
    $d p q r s t u w x y z .+ $.  $d p q r s t u w x y z ph $.
    $d p q r s t u w x y z T $.  $d p q r s t u w z X $.
    $d p q r s t u w z Y $.
    eropr.1 $e |- J = ( A /. R ) $.
    eropr.2 $e |- K = ( B /. S ) $.
    eropr.3 $e |- ( ph -> T e. Z ) $.
    eropr.4 $e |- ( ph -> R Er U ) $.
    eropr.5 $e |- ( ph -> S Er V ) $.
    eropr.6 $e |- ( ph -> T Er W ) $.
    eropr.7 $e |- ( ph -> A C_ U ) $.
    eropr.8 $e |- ( ph -> B C_ V ) $.
    eropr.9 $e |- ( ph -> C C_ W ) $.
    eropr.10 $e |- ( ph -> .+ : ( A X. B ) --> C ) $.
    eropr.11 $e |- ( ( ph /\ ( ( r e. A /\ s e. A ) /\ ( t e. B /\ u e. B ) ) )
                      -> ( ( r R s /\ t S u ) -> ( r .+ t ) T ( s .+ u ) ) ) $.
    $( Lemma for ~ erov and ~ eroprf .  (Contributed by Jeff Madsen,
       10-Jun-2010.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    eroveu $p |- ( ( ph /\ ( X e. J /\ Y e. K ) ) -> E! z E. p e. A E. q e. B
                ( ( X = [ p ] R /\ Y = [ q ] S ) /\ z = [ ( p .+ q ) ] T ) ) $=
      ( vw wcel wa cv cec wceq co wrex wex weq wal weu cqs elqsi eleq2s anim12i
      wi adantl reeanv sylibr adantr ecexg elisset 3syl biantrud 2rexbidv mpbid
      19.42v bicomi rexbii rexcom4 bitri sylib eceq1 eqeq2d anbi1d oveq1 anbi2d
      cvv syl anbi12d oveq2 cbvrex2v anbi12i bitr4i wbr wer simprll sseldd erth
      wss simprrl wf fovrnd 3imtr3d eqeq2 biimprcd syl6 imp3a wb eqeq1 bi2anan9
      cxp imbi12d syl5ibrcom anassrs rexlimdvva syl5bir alrimivv eu4 sylanbrc )
      AQMUPZRNUPZUQZUQZQUCURZIUSZUTZRUBURZJUSZUTZUQZBURZYJYMHVAZKUSZUTZUQZUBFVB
      ZUCEVBZBVCZUUCYPUOURZYSUTZUQZUBFVBUCEVBZUQZBUOVDZVKZUOVEBVEUUCBVFYIYPYTBV
      CZUQZUBFVBZUCEVBZUUDYIYPUBFVBUCEVBZUUOYIYLUCEVBZYOUBFVBZUQZUUPYHUUSAYFUUQ
      YGUURUUQQEIVGMUCEQIVHUDVIUURRFJVGNUBFRJVHUEVIVJVLYLYOUCUBEFVMVNYIYPUUMUCU
      BEFYIUULYPYIKSUPZYSWMUPUULAUUTYHUFVOYRSKVPBYSWMVQVRVSVTWAUUOUUBBVCZUCEVBU
      UDUUNUVAUCEUUNUUABVCZUBFVBUVAUUMUVBUBFUVBUUMYPYTBWBWCWDUUAUBBFWEWFWDUUBUC
      BEWEWFWGYIUUKBUOAUUKYHUUIQUAURZIUSZUTZRDURZJUSZUTZUQZYQUVCUVFHVAZKUSZUTZU
      QZDFVBZQTURZIUSZUTZRCURZJUSZUTZUQZUUEUVOUVRHVAZKUSZUTZUQZCFVBZUQZTEVBUAEV
      BZAUUJUWHUVNUAEVBZUWFTEVBZUQUUIUVNUWFUATEEVMUUCUWIUUHUWJUUAUVMUVEYOUQZYQU
      VCYMHVAZKUSZUTZUQUCUBUADEFUCUAVDZYPUWKYTUWNUWOYLUVEYOUWOYKUVDQYJUVCIWHWIW
      JUWOYSUWMYQUWOYRUWLUTYSUWMUTYJUVCYMHWKYRUWLKWHWNWIWOUBDVDZUWKUVIUWNUVLUWP
      YOUVHUVEUWPYNUVGRYMUVFJWHWIWLUWPUWMUVKYQUWPUWLUVJUTUWMUVKUTYMUVFUVCHWPUWL
      UVJKWHWNWIWOWQUUGUWEUVQYOUQZUUEUVOYMHVAZKUSZUTZUQUCUBTCEFUCTVDZYPUWQUUFUW
      TUXAYLUVQYOUXAYKUVPQYJUVOIWHWIWJUXAYSUWSUUEUXAYRUWRUTYSUWSUTYJUVOYMHWKYRU
      WRKWHWNWIWOUBCVDZUWQUWAUWTUWDUXBYOUVTUVQUXBYNUVSRYMUVRJWHWIWLUXBUWSUWCUUE
      UXBUWRUWBUTUWSUWCUTYMUVRUVOHWPUWRUWBKWHWNWIWOWQWRWSAUWGUUJUATEEUWGUVMUWEU
      QZCFVBDFVBAUVCEUPZUVOEUPZUQZUQZUUJUVMUWEDCFFVMUXGUXCUUJDCFFAUXFUVFFUPZUVR
      FUPZUQZUXCUUJVKAUXFUXJUQZUQZUVMUWEUUJUXLUWEUUJVKUVMUVDUVPUTZUVGUVSUTZUQZU
      WDUQZUVKUUEUTZVKUXLUXOUWDUXQUXLUXOUVKUWCUTZUWDUXQVKUXLUVCUVOIWTZUVFUVRJWT
      ZUQUVJUWBKWTUXOUXRUNUXLUXSUXMUXTUXNUXLUVCUVOILALIXAUXKUGVOUXLELUVCAELXEUX
      KUJVOAUXDUXEUXJXBZXCXDUXLUVFUVRJOAOJXAUXKUHVOUXLFOUVFAFOXEUXKUKVOAUXFUXHU
      XIXFZXCXDWOUXLUVJUWBKPAPKXAUXKUIVOUXLGPUVJAGPXEUXKULVOUXLUVCUVFGEFHAEFXQG
      HXGUXKUMVOUYAUYBXHXCXDXIUWDUXQUXRUUEUWCUVKXJXKXLXMUVMUWEUXPUUJUXQUVIUWEUX
      PXNUVLUVIUWAUXOUWDUVEUVQUXMUVHUVTUXNQUVDUVPXORUVGUVSXOXPWJVOUVLUUJUXQXNUV
      IYQUVKUUEXOVLXRXSXMXTYAYBYAYBVOYCUUCUUHBUOUUJUUAUUGUCUBEFUUJYTUUFYPYQUUEY
      SXOWLVTYDYE $.

    eropr.12 $e |- .+^ = { <. <. x , y >. , z >. | E. p e. A E. q e. B
                ( ( x = [ p ] R /\ y = [ q ] S ) /\ z = [ ( p .+ q ) ] T ) } $.
    $( Lemma for ~ erov and ~ eroprf .  (Contributed by Jeff Madsen,
       10-Jun-2010.)  (Revised by Mario Carneiro, 30-Dec-2014.) $)
    erovlem $p |- ( ph -> .+^ = ( x e. J , y e. K |->
      ( iota z E. p e. A E. q e. B
        ( ( x = [ p ] R /\ y = [ q ] S ) /\ z = [ ( p .+ q ) ] T ) ) ) ) $=
      ( vw cv cec wceq wa co wrex coprab wcel cio cmpt2 simpl reximi cqs eleq2i
      vex elqs bitri anbi12i reeanv bitr4i sylibr pm4.71ri weu eroveu iota1 syl
      wb eqcom syl6bb pm5.32da syl5bb oprabbidv df-mpt2 nfv nfiota1 nfeq2 eqeq1
      nfan anbi2d cbvoprab3 eqtr4i 3eqtr4g ) ABURZUDURZLUSUTZCURZUCURZMUSUTZVAZ
      DURZXAXDJVBNUSUTZVAZUCHVCZUDGVCZBCDVDWTPVEZXCQVEZVAZXGXKDVFZUTZVAZBCDVDZK
      BCPQXOVGZAXKXQBCDXKXNXKVAAXQXKXNXKXFUCHVCZUDGVCZXNXJXTUDGXIXFUCHXFXHVHVIV
      IXNXBUDGVCZXEUCHVCZVAYAXLYBXMYCXLWTGLVJZVEYBPYDWTUEVKUDGWTLBVLVMVNXMXCHMV
      JZVEYCQYEXCUFVKUCHXCMCVLVMVNVOXBXEUDUCGHVPVQVRVSAXNXKXPAXNVAZXKXOXGUTZXPY
      FXKDVTXKYGWDADEFGHIJLMNOPQRSWTXCTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOWAXKDWBWCX
      OXGWEWFWGWHWIUPXSXNUQURZXOUTZVAZBCUQVDXRBCUQPQXOWJXQYJBCDUQXQUQWKXNYIDXND
      WKDYHXOXKDWLWMWOXGYHUTXPYIXNXGYHXOWNWPWQWRWS $.

    eropr.13 $e |- ( ph -> R e. X ) $.
    eropr.14 $e |- ( ph -> S e. Y ) $.
    $( The value of an operation defined on equivalence classes.  (Contributed
       by Jeff Madsen, 10-Jun-2010.)  (Revised by Mario Carneiro,
       30-Dec-2014.) $)
    erov $p |- ( ( ph /\ P e. A /\ Q e. B )
                             -> ( [ P ] R .+^ [ Q ] S ) = [ ( P .+ Q ) ] T ) $=
      ( wcel w3a cec co cv wceq wa cio cvv cmpt2 erovlem 3ad2ant1 simprl eqeq1d
      wrex simprr anbi12d 2rexbidv iotabidv cqs ecelqsg syl6eleqr sylan 3adant3
      anbi1d 3adant2 iotaex ovmpt2d eqid pm3.2i eceq1 eqeq2d oveq1 anbi2d oveq2
      a1i rspc2ev mp3an3 3adant1 ecexg simp1 eroveu syl12anc simpr iota2d mpbid
      syl weu eqtrd ) AJGVCZMHVCZVDZJNVEZMOVEZLVFXOUHVGZNVEZVHZXPUGVGZOVEZVHZVI
      ZDVGZXQXTKVFZPVEZVHZVIZUGHVQUHGVQZDVJZJMKVFZPVEZXNBCXOXPRSBVGZXRVHZCVGZYA
      VHZVIZYGVIZUGHVQUHGVQZDVJZYJLVKAXLLBCRSYTVLVHXMABCDEFGHIKLNOPQRSTUAUDUEUF
      UGUHUIUJUKULUMUNUOUPUQURUSUTVMVNXNYMXOVHZYOXPVHZVIVIZYSYIDUUCYRYHUHUGGHUU
      CYQYCYGUUCYNXSYPYBUUCYMXOXRXNUUAUUBVOVPUUCYOXPYAXNUUAUUBVRVPVSWGVTWAAXLXO
      RVCZXMANUBVCZXLUUDVAUUEXLVIXOGNWBRGJNUBWCUIWDWEWFZAXMXPSVCZXLAOUCVCZXMUUG
      VBUUHXMVIXPHOWBSHMOUCWCUJWDWEWHZYJVKVCXNYIDWIWRWJXNYCYLYFVHZVIZUGHVQUHGVQ
      ZYJYLVHXLXMUULAXLXMXOXOVHZXPXPVHZVIZYLYLVHZVIZUULUUOUUPUUMUUNXOWKXPWKWLYL
      WKWLUUKUUQUUMYBVIZYLJXTKVFZPVEZVHZVIUHUGJMGHXQJVHZYCUURUUJUVAUVBXSUUMYBUV
      BXRXOXOXQJNWMWNWGUVBYFUUTYLUVBYEUUSVHYFUUTVHXQJXTKWOYEUUSPWMXIWNVSXTMVHZU
      URUUOUVAUUPUVCYBUUNUUMUVCYAXPXPXTMOWMWNWPUVCUUTYLYLUVCUUSYKVHUUTYLVHXTMJK
      WQUUSYKPWMXIWNVSWSWTXAXNYIUULDYLVKAXLYLVKVCZXMAPUDVCUVDUKYKUDPXBXIVNXNAUU
      DUUGYIDXJAXLXMXCUUFUUIADEFGHIKNOPQRSTUAXOXPUDUEUFUGUHUIUJUKULUMUNUOUPUQUR
      USXDXEXNYDYLVHZVIZYHUUKUHUGGHUVFYGUUJYCUVFYDYLYFXNUVEXFVPWPVTXGXHXK $.

    eropr.15 $e |- L = ( C /. T ) $.
    $( Functionality of an operation defined on equivalence classes.
       (Contributed by Jeff Madsen, 10-Jun-2010.)  (Revised by Mario Carneiro,
       30-Dec-2014.) $)
    eroprf $p |- ( ph -> .+^ : ( J X. K ) --> L ) $=
      ( cxp wf cv cec wceq wa co wrex cio cmpt2 wcel cab wi cqs ad2antrr adantr
      fovrnda ecelqsg syl2anc syl6eleqr eleq1a adantld rexlimdvva abssdv eroveu
      wral syl iotacl sseldd ralrimivva eqid fmpt2 sylib erovlem feq1d mpbird
      weu ) APQVCZRKVDWTRBCPQBVEZUGVEZLVFVGCVEZUFVEZMVFVGVHZDVEZXBXDJVIZNVFZVGZ
      VHZUFHVJUGGVJZDVKZVLZVDZAXLRVMZCQWHBPWHXNAXOBCPQAXAPVMXCQVMVHZVHZXKDVNZRX
      LXQXKDRXQXJXFRVMZUGUFGHXQXBGVMXDHVMVHZVHZXIXSXEYAXHRVMXIXSVOYAXHINVPZRYAN
      UCVMZXGIVMXHYBVMAYCXPXTUJVQXQXBXDIGHJAGHVCIJVDXPUQVRVSIXGNUCVTWAVBWBXHRXF
      WCWIWDWEWFXQXKDWSXLXRVMADEFGHIJLMNOPQSTXAXCUCUDUEUFUGUHUIUJUKULUMUNUOUPUQ
      URWGXKDWJWIWKWLBCPQXLRXMXMWMWNWOAWTRKXMABCDEFGHIJKLMNOPQSTUCUDUEUFUGUHUIU
      JUKULUMUNUOUPUQURUSWPWQWR $.
  $}

  ${
    $d p q r s t u x y z A $.  $d p q r s t u x y z P $.  $d p q r s t u z X $.
    $d p q r s t u x y z .+ $.  $d p q r s t u x y z .~ $.  $d p q x y z J $.
    $d p q r s t u x y z ph $.  $d p q r s t u x y z Q $.
    eropr2.1 $e |- J = ( A /. .~ ) $.
    eropr2.2 $e |- .+^ = { <. <. x , y >. , z >. | E. p e. A E. q e. A
             ( ( x = [ p ] .~ /\ y = [ q ] .~ ) /\ z = [ ( p .+ q ) ] .~ ) } $.
    eropr2.3 $e |- ( ph -> .~ e. X ) $.
    eropr2.4 $e |- ( ph -> .~ Er U ) $.
    eropr2.5 $e |- ( ph -> A C_ U ) $.
    eropr2.6 $e |- ( ph -> .+ : ( A X. A ) --> A ) $.
    eropr2.7 $e |- ( ( ph /\ ( ( r e. A /\ s e. A ) /\ ( t e. A /\ u e. A ) ) )
      -> ( ( r .~ s /\ t .~ u ) -> ( r .+ t ) .~ ( s .+ u ) ) ) $.
    $( The value of an operation defined on equivalence classes.  (Contributed
       by Jeff Madsen, 10-Jun-2010.) $)
    erov2 $p |- ( ( ph /\ P e. A /\ Q e. A )
                          -> ( [ P ] .~ .+^ [ Q ] .~ ) = [ ( P .+ Q ) ] .~ ) $=
      ( erov ) ABCDEFGGGHIJKLLLMNNMMOOOPQRSTTUBUCUCUCUDUDUDUEUFUAUBUBUG $.

    $( Functionality of an operation defined on equivalence classes.
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    eroprf2 $p |- ( ph -> .+^ : ( J X. J ) --> J ) $=
      ( eroprf ) ABCDEFGGGHIJJJKLLLKKMMMNOPQRRTUAUAUAUBUBUBUCUDSTTRUE $.
  $}

  ${
    $d f g h t s r A $.  $d f g h t s r B $.  $d f g h t s r C $.
    $d f g h t s r D $.  $d x y z w v u f g h t s r .+ $.  $d f g h t s r .~ $.
    $d x y z w v u f g h t s r S $.
    ecopopr.1 $e |- .~ = { <. x , y >. | ( ( x e. ( S X. S ) /\ y e. ( S X. S )
          ) /\ E. z E. w E. v E. u ( ( x = <. z , w >. /\ y = <. v , u >. ) /\
          ( z .+ u ) = ( w .+ v ) ) ) } $.
    ${
      $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
      $d x y z w v u D $.
      $( This is the first of several theorems about equivalence relations of
         the kind used in construction of fractions and signed reals, involving
         operations on equivalent classes of ordered pairs.  This theorem
         expresses the relation ` .~ ` (specified by the hypothesis) in terms
         of its operation ` F ` .  (Contributed by NM, 16-Aug-1995.) $)
      ecopoveq $p |- ( ( ( A e. S /\ B e. S ) /\
                     ( C e. S /\ D e. S ) ) ->
          ( <. A , B >. .~ <. C , D >. <-> ( A .+ D ) = ( B .+ C ) ) ) $=
        ( cv co wceq wb wa oveq12 eqeqan12d an42s opbrop ) COZFOZKPZDOZEOZKPZQZ
        GJKPZHIKPZQZABCDEFGHIJLMUDGQZUEJQZUGHQZUHIQZUJUMRUNUOSUPUQSUFUKUIULUDGU
        EJKTUGHUHIKTUAUBNUC $.
    $}

    ${
      ecopopr.com $e |- ( x .+ y ) = ( y .+ x ) $.
      $( Assuming the operation ` F ` is commutative, show that the relation
         ` .~ ` , specified by the first hypothesis, is symmetric.
         (Contributed by NM, 27-Aug-1995.)  (Revised by Mario Carneiro,
         26-Apr-2015.) $)
      ecopovsym $p |- ( A .~ B -> B .~ A ) $=
        ( wbr wcel wa wb cv wceq co vf vg vh cxp cop wex copab opabssxp eqsstri
        brel eqid breq1 breq2 bibi12d ecopoveq vex caovcom eqeq12i eqcom syl6bb
        vt bitri ancoms bitr4d 2optocl syl ibi ) GHJNZHGJNZVHGKKUDZOHVJOPVHVIQZ
        GHVJVJJJARZVJOBRZVJOPVLCRZDRZUESVMERZFRZUESPVNVQITVOVPITSPFUFEUFDUFCUFZ
        PABUGVJVJUDLVRABVJVJUHUIUJUARZUBRZUEZUCRZVARZUEZJNZWDWAJNZQGWDJNZWDGJNZ
        QVKUAUBUCVAGHKKVJVJUKWAGSWEWGWFWHWAGWDJULWAGWDJUMUNWDHSWGVHWHVIWDHGJUMW
        DHGJULUNVSKOVTKOPZWBKOWCKOPZPZWEWBVTITZWCVSITZSZWFWKWEVSWCITZVTWBITZSZW
        NABCDEFVSVTWBWCIJKLUOWQWMWLSWNWOWMWPWLABVSWCIUAUPVAUPMUQABVTWBIUBUPUCUP
        MUQURWMWLUSVBUTWJWIWFWNQABCDEFWBWCVSVTIJKLUOVCVDVEVFVG $.

      ${
        $( Assume the operation is closed. $)
        ecopopr.cl $e |- ( ( x e. S /\ y e. S ) -> ( x .+ y ) e. S ) $.
        $( Assume the operation is associative. $)
        ecopopr.ass $e |- ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) $.
        $( Assume the operation has the cancellation property. $)
        ecopopr.can $e |- ( ( x e. S /\ y e. S ) ->
                   ( ( x .+ y ) = ( x .+ z ) -> y = z ) ) $.
        $( Assuming that operation ` F ` is commutative (second hypothesis),
           closed (third hypothesis), associative (fourth hypothesis), and has
           the cancellation property (fifth hypothesis), show that the relation
           ` .~ ` , specified by the first hypothesis, is transitive.
           (Contributed by NM, 11-Feb-1996.)  (Revised by Mario Carneiro,
           26-Apr-2015.) $)
        ecopovtrn $p |- ( ( A .~ B /\ B .~ C ) -> A .~ C ) $=
          ( wcel wa co vf vg vh vt vs vr cxp w3a wbr cv cop wceq copab opabssxp
          wex eqsstri brel simpld anim12i 3anass sylibr wi breq1 anbi1d imbi12d
          eqid anbi12d imbi1d anbi2d wb ecopoveq 3adant3 3adant1 oveq12 caov411
          breq2 vex caov4 eqtr3i 3eqtr4g syl6bi caovcl ovex syl2an 3impb 3com12
          caovcan 3adant3l 3adant1r syld 3adant2 sylibrd 3optocl mpcom ) GLLUGZ
          RZHWORZIWORZUHZGHKUIZHIKUIZSZGIKUIZXBWPWQWRSZSWSWTWPXAXDWTWPWQGHWOWOK
          KAUJZWORBUJZWORSXECUJZDUJZUKULXFEUJZFUJZUKULSXGXJJTXHXIJTULSFUOEUODUO
          CUOZSABUMWOWOUGMXKABWOWOUNUPZUQURHIWOWOKXLUQUSWPWQWRUTVAUAUJZUBUJZUKZ
          UCUJZUDUJZUKZKUIZXRUEUJZUFUJZUKZKUIZSZXOYBKUIZVBGXRKUIZYCSZGYBKUIZVBW
          THYBKUIZSZYHVBXBXCVBUAUBUCUDUEUFGHILWOLWOVFXOGULZYDYGYEYHYKXSYFYCXOGX
          RKVCVDXOGYBKVCVEXRHULZYGYJYHYLYFWTYCYIXRHGKVPXRHYBKVCVGVHYBIULZYJXBYH
          XCYMYIXAWTYBIHKVPVIYBIGKVPVEXMLRZXNLRZSZXPLRXQLRSZXTLRZYALRZSZUHZYDXM
          YAJTZXNXTJTZULZYEUUAYDXPXQJTZUUBJTZUUEUUCJTZULZUUDUUAYDXMXQJTZXNXPJTZ
          ULZXPYAJTZXQXTJTZULZSZUUHUUAXSUUKYCUUNYPYQXSUUKVJYTABCDEFXMXNXPXQJKLM
          VKVLYQYTYCUUNVJYPABCDEFXPXQXTYAJKLMVKVMVGUUOUUIUULJTUUJUUMJTZUUFUUGUU
          IUUJUULUUMJVNABCXPXQXMYAJUCVQZUDVQZUAVQNPUFVQVOXNXQJTXPXTJTJTUUGUUPAB
          CXNXQXPXTJUBVQZUURUUQNPUEVQZVOABCXNXQXPXTJUUSUURUUQNPUUTVRVSVTWAYNYQY
          TUUHUUDVBZYOYNYQYSUVAYRYQYNYSUVAYQYNYSUVAYQUUELRUUBLRUVAYNYSSABXPXQLJ
          OWBABXMYALJOWBABCUUEUUBUUCLJXNXTJWCQWGWDWEWFWHWIWJYPYTYEUUDVJYQABCDEF
          XMXNXTYAJKLMVKWKWLWMWN $.

        $( Assuming that operation ` F ` is commutative (second hypothesis),
           closed (third hypothesis), associative (fourth hypothesis), and has
           the cancellation property (fifth hypothesis), show that the relation
           ` .~ ` , specified by the first hypothesis, is an equivalence
           relation.  (Contributed by NM, 16-Feb-1996.)  (Revised by Mario
           Carneiro, 12-Aug-2015.) $)
        ecopover $p |- .~ Er ( S X. S ) $=
          ( vg vh wtru cv wa wbr vf cxp wer wrel wcel cop wceq wex relopabi a1i
          co ecopovsym adantl ecopovtrn wral vex caovcom ecopoveq mpbiri anidms
          wi rgen2a ralxp mpbir rspec copab opabssxp eqsstri ssbri brxp simplbi
          wb breq12 syl impbid1 iserd trud ) IIUBZHUCQUAOPVRHHUDQARZVRUEBRZVRUE
          SVSCRZDRZUFUGVTERZFRZUFUGSWAWDGUKWBWCGUKUGSFUHEUHDUHCUHZSZABHJUIUJUAR
          ZORZHTZWHWGHTQABCDEFWGWHGHIJKULUMWIWHPRZHTSWGWJHTQABCDEFWGWHWJGHIJKLM
          NUNUMQWGVRUEZWGWGHTZWKWLVAQWLUAVRWLUAVRUOWHWJUFZWMHTZPIUOOIUOWNOPIWHI
          UEWJIUESZWNWOWOSWNWHWJGUKWJWHGUKUGABWHWJGOUPPUPKUQABCDEFWHWJWHWJGHIJU
          RUSUTVBWLWNUAOPIIWGWMUGWLWNVLWGWMWGWMHVMUTVCVDVEUJWLWGWGVRVRUBZTZWKHW
          PWGWGHWFABVFWPJWEABVRVRVGVHVIWQWKWKWGWGVRVRVJVKVNVOVPVQ $.
      $}

    $}
  $}

  ${
    $d x y .+ $.  $d x y S $.  $d x y A $.  $d x y B $.  $d x y C $.
    $d x y D $.
    eceqoveq.5 $e |- .~ Er ( S X. S ) $.
    eceqoveq.7 $e |- dom .+ = ( S X. S ) $.
    eceqoveq.8 $e |- -. (/) e. S $.
    eceqoveq.9 $e |- ( ( x e. S /\ y e. S ) -> ( x .+ y ) e. S ) $.
    eceqoveq.10 $e |- ( ( ( A e. S /\ B e. S ) /\
                     ( C e. S /\ D e. S ) ) ->
          ( <. A , B >. .~ <. C , D >. <-> ( A .+ D ) = ( B .+ C ) ) ) $.
    $( Equality of equivalence relation in terms of an operation.  (Contributed
       by NM, 15-Feb-1996.)  (Proof shortened by Mario Carneiro,
       12-Aug-2015.) $)
    eceqoveq $p |- ( ( A e. S /\ C e. S ) ->
                      ( [ <. A , B >. ] .~ = [ <. C , D >. ] .~ <->
                      ( A .+ D ) = ( B .+ C ) ) ) $=
      ( wcel wa wceq syl wn c0 cop cec co wb cxp opelxpi ad2antrr wer a1i simpr
      ereldm mpbid opelxp2 ex wi caovcl syl5ibr ndmovrcl simprd syl6com adantll
      eleq1 wbr adantr erth bitr3d expr pm5.21ndd an32s eqcom erdm ax-mp eleq2i
      wne cdm ecdmn0 opelxp 3bitr3i simplbi2 ad2antlr necon2bd con3i ndmov syl6
      mtbiri simprbi necon1bd impbid syl5bb necon1bi adantl eqeq1d simpl eqeq2d
      syl5 3bitr4d pm2.61dan ) CIOZEIOZPZDIOZCDUAZHUBZEFUAZHUBZQZCFGUCZDEGUCZQZ
      UDZWRXAWSXJWRXAPZWSPZFIOZXFXIXLXFXMXLXFPZXDIIUEZOZXMXNXBXOOZXPXKXQWSXFCDI
      IUFZUGXNXBXDHXOXOHUHZXNJUIXLXFUJUKULEFIIUMRUNXAWSXIXMUOWRXIXAWSPZXGIOZXMX
      TYAXIXHIOABDEIGMUPXGXHIVBUQYAWRXMCFIGKLURUSUTVAXKWSXMXJXKWSXMPZPZXBXDHVCX
      FXIYCXBXDHXOXSYCJUIXKXQYBXRVDVENVFVGVHVIWTXASZPZTXEQZXGTQZXFXIYFXETQZYEYG
      TXEVJYEYHYGYEYHXMSZYGYEXMXETWSXMXETVNZUOWRYDYJWSXMXDHVOZOXPYJYBYKXOXDXSYK
      XOQJXOHVKVLZVMXDHVPEFIIVQVRZVSVTWAYIWRXMPZSYGYNXMWRXMUJWBCFIGKWCRWDYGYASY
      EYHYGYATIOLXGTIVBWEYEYAXETYJXMYEYAYJWSXMYMWFWRXMYAUOWSYDWRXMYAABCFIGMUPUN
      UGWOWGWOWHWIYEXCTXEYDXCTQWTXAXCTXCTVNZWRXAXBYKOXQYOXKYKXOXBYLVMXBHVPCDIIV
      QVRWFWJWKWLYEXHTXGYDXHTQZWTYDXTSYPXTXAXAWSWMWBDEIGKWCRWKWNWPWQ $.
  $}

  ${
    $d x y z w v u .+ $.  $d x y z w v u .~ $.  $d x y z w v u S $.
    $d x y z w v u A $.  $d x y z w v u B $.
    th3qlem1.1 $e |- .~ Er S $.
    $( Compatibility assumption. $)
    th3qlem1.3 $e |- ( ( ( y e. S /\ w e. S ) /\ ( z e. S /\ v e. S ) ) ->
                 ( ( y .~ w /\ z .~ v ) -> ( y .+ z ) .~ ( w .+ v ) ) ) $.
    $( Lemma for Exercise 44 version of Theorem 3Q of [Enderton] p. 60.  The
       third hypothesis is the compatibility assumption.  (Contributed by NM,
       3-Aug-1995.)  (Revised by Mario Carneiro, 9-Jul-2014.) $)
    th3qlem1 $p |- ( ( A e. ( S /. .~ ) /\ B e. ( S /. .~ ) ) -> E* x
       E. y E. z ( ( A = [ y ] .~ /\ B = [ z ] .~ ) /\
       x = [ ( y .+ z ) ] .~ ) ) $=
      ( vu wcel wa cv cec wceq wex ecelqsdm cqs co wi wal ee4anv eleq1 bi2anan9
      wmo an4 wb adantr biimpac anim12i an4s adantl wer a1i wbr simprl cdm erdm
      eqtr2 ax-mp simpll sylancr mpbird simprr simplr eqeltrrd syl22anc syl2anc
      erth mp2and erthi eqeq12 syl5ibrcom expimpd syl5bi exlimdvv syl5bir eqeq1
      alrimivv anbi2d 2exbidv eceq1 eqeq2d oveq12 anbi12d cbvex2v syl6bb sylibr
      syl mo4 ) FJIUAZNZGWNNZOZFBPZIQZRZGCPZIQZRZOZAPZWRXAHUBZIQZRZOZCSBSZFDPZI
      QZRZGEPZIQZRZOZMPZXKXNHUBZIQZRZOZESDSZOZXEXRRZUCZMUDAUDXJAUHWQYFAMYDXIYBO
      ZESDSZCSBSWQYEXIYBBCDEUEWQYHYEBCWQYGYEDEYGXDXQOZXHYAOZOWQYEXDXHXQYAUIWQYI
      YJYEWQYIOZYEYJXGXTRZYKWSWNNZXBWNNZOZWSXLRZXBXORZOZYLYIWQYOXDWQYOUJXQWTWOY
      MXCWPYNFWSWNUFGXBWNUFUGUKULYIYRWQWTXMXCXPYRWTXMOYPXCXPOYQFWSXLVBGXBXOVBUM
      UNUOYOYROZXFXSIJJIUPZYSKUQZYSWRXKIURZXAXNIURZXFXSIURZYSUUBYPYOYPYQUSZYSWR
      XKIJUUAYSIUTJRZYMWRJNZYTUUFKJIVAVCZYMYNYRVDZJWRITVEZVLVFYSUUCYQYOYPYQVGZY
      SXAXNIJUUAYSUUFYNXAJNZUUHYMYNYRVHZJXAITVEZVLVFYSUUGXKJNZUULXNJNZUUBUUCOUU
      DUCUUJYSUUFXLWNNUUOUUHYSWSXLWNUUEUUIVIJXKITVEUUNYSUUFXOWNNUUPUUHYSXBXOWNU
      UKUUMVIJXNITVELVJVMVNVKXEXGXRXTVOVPVQVRVSVSVTWBXJYCAMYEXJXDXRXGRZOZCSBSYC
      YEXIUURBCYEXHUUQXDXEXRXGWAWCWDUURYBBCDEWRXKRZXAXNRZOZXDXQUUQYAUUSWTXMUUTX
      CXPUUSWSXLFWRXKIWEWFUUTXBXOGXAXNIWEWFUGUVAXGXTXRUVAXFXSRYLWRXKXAXNHWGXFXS
      IWEWLWFWHWIWJWMWK $.
  $}

  ${
    $d x y z w v u t s f g h .~ $.  $d x y z w v u t s f g h S $.
    $d x y z w v u t s f A $.  $d x y z w v u t s f B $.  $d x y z w v u t C $.
    $d x y z w v u t D $.  $d x y z w v u t s f g h .+ $.
    th3q.1 $e |- .~ e. _V $.
    th3q.2 $e |- .~ Er ( S X. S ) $.
    $( Compatibility assumption. $)
    th3q.4 $e |- ( ( ( ( w e. S /\ v e. S ) /\ ( u e. S /\ t e. S ) )
       /\ ( ( s e. S /\ f e. S ) /\ ( g e. S /\ h e. S ) ) ) ->
       ( ( <. w , v >. .~ <. u , t >. /\ <. s , f >. .~ <. g , h >. ) ->
       ( <. w , v >. .+ <. s , f >. ) .~ ( <. u , t >. .+ <. g , h >. ) ) ) $.
    $( Lemma for Exercise 44 version of Theorem 3Q of [Enderton] p. 60,
       extended to operations on ordered pairs.  The fourth hypothesis is the
       compatibility assumption.  (Contributed by NM, 4-Aug-1995.)  (Revised by
       Mario Carneiro, 12-Aug-2015.) $)
    th3qlem2 $p |- ( ( A e. ( ( S X. S ) /. .~ ) /\ B e. ( ( S X. S ) /. .~ ) )
           -> E* z E. w E. v E. u E. t (
           ( A = [ <. w , v >. ] .~ /\ B = [ <. u , t >. ] .~ ) /\
                  z = [ ( <. w , v >. .+ <. u , t >. ) ] .~ ) ) $=
      ( wcel wa wceq vx vy cxp cqs cv cec co wex wmo cop wbr breq1 anbi1d oveq1
      eqid breq1d imbi12d imbi2d breq2 breq2d anbi2d oveq2 expcom 2optocl com12
      wi imp th3qlem1 opex eceq1 eqeq2d bi2anan9 oveq12 anbi12d spc2ev exlimivv
      syl moimi ) FJJUCZIUDZRGVTRSFNUEZIUFZTZGUAUEZIUFZTZSZAUEZWAWDHUGZIUFZTZSZ
      UAUHNUHZAUIFBUEZCUEZUJZIUFZTZGDUEZEUEZUJZIUFZTZSZWHWPXAHUGZIUFZTZSZEUHDUH
      ZCUHBUHZAUIANUAKUBFGHIVSPWAVSRKUEZVSRSWDVSRUBUEZVSRSZWAXKIUKZWDXLIUKZSZWI
      XKXLHUGZIUKZVFZXMWPXAIUKZXOSZWPWDHUGZXAXLHUGZIUKZVFZVFXMWAXAIUKZXOSZWIYCI
      UKZVFZVFXMXSVFBCDEWAXKJJVSVSUOZWPWATZYEYIXMYKYAYGYDYHYKXTYFXOWPWAXAIULUMY
      KYBWIYCIWPWAWDHUNUPUQURXAXKTZYIXSXMYLYGXPYHXRYLYFXNXOXAXKWAIUSUMYLYCXQWII
      XAXKXLHUNUTUQURXMWNJRWOJRSWSJRWTJRSSZYEYMXTWAXKUJZLUEZMUEZUJZIUKZSZWPYNHU
      GZXAYQHUGZIUKZVFZVFYMXTWDYQIUKZSZYBUUAIUKZVFZVFYMYEVFNKLMWDXLJJVSYJYNWDTZ
      UUCUUGYMUUHYSUUEUUBUUFUUHYRUUDXTYNWDYQIULVAUUHYTYBUUAIYNWDWPHVBUPUQURYQXL
      TZUUGYEYMUUIUUEYAUUFYDUUIUUDXOXTYQXLWDIUSVAUUIUUAYCYBIYQXLXAHVBUTUQURYMWA
      JRXKJRSYOJRYPJRSSUUCQVCVDVEVDVGVHXJWMAXIWMBCXHWMDEWLXHNUAWPXAWNWOVIWSWTVI
      WAWPTZWDXATZSZWGXDWKXGUUJWCWRUUKWFXCUUJWBWQFWAWPIVJVKUUKWEXBGWDXAIVJVKVLU
      ULWJXFWHUULWIXETWJXFTWAWPWDXAHVMWIXEIVJVQVKVNVOVPVPVRVQ $.

    ${
      th3q.5 $e |- G = { <. <. x , y >. , z >. | ( ( x e. ( ( S X. S ) /. .~ )
           /\ y e. ( ( S X. S ) /. .~ ) ) /\ E. w E. v E. u E. t ( (
           x = [ <. w , v >. ] .~ /\ y = [ <. u , t >. ] .~ ) /\
           z = [ ( <. w , v >. .+ <. u , t >. ) ] .~ ) ) } $.
      $( Corollary of Theorem 3Q of [Enderton] p. 60.  (Contributed by NM,
         12-Nov-1995.)  (Revised by David Abernethy, 4-Jun-2013.) $)
      th3qcor $p |- Fun G $=
        ( cv wfun cxp cqs wcel wa cop cec co wex coprab wmo wi th3qlem2 moanimv
        wceq mpbir funoprab funeqi ) NUAATZJJUBIUCZUDBTZUTUDUEZUSDTETUFZIUGUOVA
        FTGTUFZIUGUOUECTVCVDHUHIUGUOUEGUIFUIEUIDUIZUEZABCUJZUAVFABCVFCUKVBVECUK
        ULCDEFGUSVAHIJKLMOPQRUMVBVECUNUPUQNVGSURUP $.

      $( Theorem 3Q of [Enderton] p. 60, extended to operations on ordered
         pairs.  (Contributed by NM, 4-Aug-1995.)  (Revised by Mario Carneiro,
         19-Dec-2013.) $)
      th3q $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) ) ->
                 ( [ <. A , B >. ] .~ G [ <. C , D >. ] .~ ) =
                 [ ( <. A , B >. .+ <. C , D >. ) ] .~ ) $=
        ( wcel wa cop cec cxp cqs cv wceq co wex opelxpi ecelqsi anim12i pm3.2i
        eqid wb opeq12 eceq1 eqeq2d anbi1d oveq1 anbi12d spc2egv anbi2d 2eximdv
        syl oveq2 sylan9 mp2ani cvv wi ecexg ax-mp eqeq1 bi2anan9 3impa 4exbidv
        w3a th3qlem2 ovig mp3an3 sylc ) HNUDINUDUEZJNUDKNUDUEZUEZHIUFZMUGZNNUHZ
        MUIZUDZJKUFZMUGZWLUDZUEWJDUJZEUJZUFZMUGZUKZWOFUJZGUJZUFZMUGZUKZUEZWIWNL
        ULZMUGZWSXDLULZMUGZUKZUEZGUMFUMZEUMDUMZWJWORULXIUKZWFWMWGWPWFWIWKUDWMHI
        NNUNWKWIMTUOVIWGWNWKUDWPJKNNUNWKWNMTUOVIUPWHWJWJUKZWOWOUKZUEZXIXIUKZXOX
        QXRWJURWOURUQXIURWFXSXTUEZXAXRUEZXIWSWNLULZMUGZUKZUEZEUMDUMWGXOYFYADEHI
        NNWQHUKWRIUKUEWSWIUKZYFYAUSWQWRHIUTYGYBXSYEXTYGXAXQXRYGWTWJWJWSWIMVAVBV
        CYGYDXIXIYGYCXHUKYDXIUKWSWIWNLVDYCXHMVAVIVBVEVIVFWGYFXNDEXMYFFGJKNNXBJU
        KXCKUKUEXDWNUKZXMYFUSXBXCJKUTYHXGYBXLYEYHXFXRXAYHXEWOWOXDWNMVAVBVGYHXKY
        DXIYHXJYCUKXKYDUKXDWNWSLVJXJYCMVAVIVBVEVIVFVHVKVLWMWPXIVMUDZXOXPVNMVMUD
        YITXHVMMVOVPAUJZWTUKZBUJZXEUKZUEZCUJZXKUKZUEZGUMFUMEUMDUMXOABCWJWOXIVMW
        LWLRYJWJUKZYLWOUKZYOXIUKZWAYQXMDEFGYRYSYTYQXMUSYRYSUEYNXGYTYPXLYRYKXAYS
        YMXFYJWJWTVQYLWOXEVQVRYOXIXKVQVRVSVTCDEFGYJYLLMNOPQSTUAUBWBUCWCWDWE $.
    $}
  $}

  ${
    $d a b c d f u v w x y z C $.  $d a b c d f u v w x y z D $.  $d x y z J $.
    $d a b c d f g h u v w x y z A $.  $d u v w z ch $.  $d f u v w x y z H $.
    $d a b c d f g h u v w x y z B $.  $d f u v w x y z K $.  $d u v w z ps $.
    $d f u v w x y z L $.  $d x y ph $.  $d a b c d f g h s t u v w x y z S $.
    $d a b c d g h s t x y z .+ $.  $d a b c d g h s t x y z .~ $.
    ovec.1 $e |- H e. _V $.
    ovec.2 $e |- K e. _V $.
    ovec.3 $e |- L e. _V $.
    ovec.4 $e |- .~ e. _V $.
    ovec.5 $e |- .~ Er ( S X. S ) $.
    $( Equivalence relation. $)
    ovec.7 $e |- .~ = { <. x , y >. | ( ( x e. ( S X. S ) /\
                      y e. ( S X. S ) ) /\
                      E. z E. w E. v E. u ( ( x = <. z , w >. /\
                      y = <. v , u >. ) /\ ph ) ) } $.
    $( Substitutions for equivalence relation. $)
    ovec.8 $e |- ( ( ( z = a /\ w = b ) /\ ( v = c /\ u = d ) ) ->
                     ( ph <-> ps ) ) $.
    ovec.9 $e |- ( ( ( z = g /\ w = h ) /\ ( v = t /\ u = s ) ) ->
                     ( ph <-> ch ) ) $.
    $( Pre-operation. $)
    ovec.10 $e |- .+ = { <. <. x , y >. , z >. | ( ( x e. ( S X. S ) /\
                      y e. ( S X. S ) ) /\
                      E. w E. v E. u E. f ( ( x = <. w , v >. /\
                      y = <. u , f >. ) /\ z = J ) ) } $.
    $( Substitutions for pre-operation. $)
    ovec.11 $e |- ( ( ( w = a /\ v = b ) /\ ( u = g /\ f = h ) ) -> J = K ) $.
    ovec.12 $e |- ( ( ( w = c /\ v = d ) /\ ( u = t /\ f = s ) ) -> J = L ) $.
    ovec.13 $e |- ( ( ( w = A /\ v = B ) /\ ( u = C /\ f = D ) ) -> J = H ) $.
    $( Main operation. $)
    ovec.14 $e |- .+^ = { <. <. x , y >. , z >. | ( ( x e. Q /\ y e. Q ) /\
           E. a E. b E. c E. d ( (
           x = [ <. a , b >. ] .~ /\ y = [ <. c , d >. ] .~ ) /\
           z = [ ( <. a , b >. .+ <. c , d >. ) ] .~ ) ) } $.
    $( Quotient class for main operation. $)
    ovec.15 $e |- Q = ( ( S X. S ) /. .~ ) $.
    $( Lemma to establish compatibility of pre-operation. $)
    ovec.16 $e |- ( ( ( ( a e. S /\ b e. S ) /\ ( c e. S /\ d e. S ) ) /\
                       ( ( g e. S /\ h e. S ) /\ ( t e. S /\ s e. S ) ) ) ->
                   ( ( ps /\ ch ) -> K .~ L ) ) $.
    $( Express an operation on equivalence classes of ordered pairs in terms of
       equivalence class of operations on ordered pairs.  See set.mm for
       additional comments describing the hypotheses.  (Unnecessary distinct
       variable restrictions were removed by David Abernethy, 4-Jun-2013.)
       (Contributed by NM, 6-Aug-1995.)  (Revised by Mario Carneiro,
       4-Jun-2013.) $)
    ovec $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) ) ->
                ( [ <. A , B >. ] .~ .+^ [ <. C , D >. ] .~ ) =
                   [ H ] .~ ) $=
      ( wcel wa cop cec co cv wbr opbrop bi2anan9 wb ov3 breqan12d an4s 3imtr4d
      wceq wex coprab cxp eleq2i anbi12i anbi1i oprabbii eqtri th3q eceq1 eqtrd
      cqs syl ) KSVGLSVGVHMSVGNSVGVHVHZKLVIZRVJMNVIZRVJPVKWPWQOVKZRVJZUCRVJZDEF
      UHUIUJUKKLMNORSUBJUGPUAUOUPUHVLZSVGUIVLZSVGVHZUJVLZSVGUKVLZSVGVHZVHZUAVLZ
      SVGUBVLZSVGVHZJVLZSVGUGVLZSVGVHZVHZVHBCVHUEUFRVMZXAXBVIZXDXEVIZRVMZXHXIVI
      ZXKXLVIZRVMZVHXPXSOVKZXQXTOVKZRVMZVFXGXRBXNYACABDEFGHIXAXBXDXERSURUQVNACD
      EFGHIXHXIXKXLRSUSUQVNVOXCXJXFXMYDXOVPXCXJVHXFXMVHYBUEYCUFRDEFGHIXAXBXHXIU
      DUETOSUMVAUTVQDEFGHIXDXEXKXLUDUFTOSUNVBUTVQVRVSVTPDVLZQVGZEVLZQVGZVHZYEXP
      RVJWAYGXQRVJWAVHFVLXPXQOVKRVJWAVHUKWBUJWBUIWBUHWBZVHZDEFWCYESSWDRWMZVGZYG
      YLVGZVHZYJVHZDEFWCVDYKYPDEFYIYOYJYFYMYHYNQYLYEVEWEQYLYGVEWEWFWGWHWIWJWOWR
      UCWAWSWTWADEFGHIKLMNUDUCTOSULVCUTVQWRUCRWKWNWL $.
  $}

  ${
    $d x y z w A $.  $d z w B $.  $d x y z w .+ $.  $d x y z w .~ $.
    $d x y z w S $.  $d z w C $.
    ecovcom.1 $e |- C = ( ( S X. S ) /. .~ ) $.
    $( D,G for AFB $)
    ecovcom.2 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
 ( [ <. x , y >. ] .~ .+ [ <. z , w >. ] .~ ) = [ <. D , G >. ] .~ ) $.
    $( H,J for BFA $)
    ecovcom.3 $e |- ( ( ( z e. S /\ w e. S ) /\ ( x e. S /\ y e. S ) ) ->
 ( [ <. z , w >. ] .~ .+ [ <. x , y >. ] .~ ) = [ <. H , J >. ] .~ ) $.
    ecovcom.4 $e |- D = H $.
    ecovcom.5 $e |- G = J $.
    $( Lemma used to transfer a commutative law via an equivalence relation.
       (Contributed by NM, 29-Aug-1995.)  (Revised by David Abernethy,
       4-Jun-2013.) $)
    ecovcom $p |- ( ( A e. C /\ B e. C ) -> ( A .+ B ) = ( B .+ A ) ) $=
      ( wceq cv cop cec co oveq1 oveq2 eqeq12d wa opeq12 eceq1 syl mp2an ancoms
      wcel 3eqtr4a 2ecoptocl ) AUAZBUAZUBJUCZCUAZDUAZUBJUCZIUDZVBUSIUDZTEVBIUDZ
      VBEIUDZTEFIUDZFEIUDZTABCDEFKKJGOUSETVCVEVDVFUSEVBIUEUSEVBIUFUGVBFTVEVGVFV
      HVBFEIUFVBFEIUEUGUQKUNURKUNUHZUTKUNVAKUNUHZUHHLUBZJUCZMNUBZJUCZVCVDHMTZLN
      TZVLVNTZRSVOVPUHVKVMTVQHLMNUIVKVMJUJUKULPVJVIVDVNTQUMUOUP $.
  $}

  ${
    $d x y z w v u A $.  $d z w v u B $.  $d x y z w v u C $.
    $d x y z w v u .+ $.  $d x y z w v u .~ $.  $d x y z w v u S $.
    $d z w v u D $.
    ecovass.1 $e |- D = ( ( S X. S ) /. .~ ) $.
    ecovass.2 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
 ( [ <. x , y >. ] .~ .+ [ <. z , w >. ] .~ ) = [ <. G , H >. ] .~ ) $.
    ecovass.3 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. z , w >. ] .~ .+ [ <. v , u >. ] .~ ) = [ <. N , Q >. ] .~ ) $.
    ecovass.4 $e |- ( ( ( G e. S /\ H e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. G , H >. ] .~ .+ [ <. v , u >. ] .~ ) = [ <. J , K >. ] .~ ) $.
    ecovass.5 $e |- ( ( ( x e. S /\ y e. S ) /\ ( N e. S /\ Q e. S ) ) ->
 ( [ <. x , y >. ] .~ .+ [ <. N , Q >. ] .~ ) = [ <. L , M >. ] .~ ) $.
    ecovass.6 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
                     ( G e. S /\ H e. S ) ) $.
    ecovass.7 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
                     ( N e. S /\ Q e. S ) ) $.
    ecovass.8 $e |- J = L $.
    ecovass.9 $e |- K = M $.
    $( Lemma used to transfer an associative law via an equivalence relation.
       (Contributed by NM, 31-Aug-1995.)  (Revised by David Abernethy,
       4-Jun-2013.) $)
    ecovass $p |- ( ( A e. D /\ B e. D /\ C e. D ) ->
                 ( ( A .+ B ) .+ C ) = ( A .+ ( B .+ C ) ) ) $=
      ( cv cop cec co wceq oveq1 oveq1d eqeq12d oveq2 oveq2d wcel wa w3a opeq12
      eceq1 syl mp2an adantr sylan eqtrd 3impa adantl sylan2 3eqtr4a 3ecoptocl
      3impb ) AUKZBUKZULMUMZCUKZDUKZULMUMZKUNZEUKZFUKZULMUMZKUNZVSWBWFKUNZKUNZU
      OGWBKUNZWFKUNZGWHKUNZUOGHKUNZWFKUNZGHWFKUNZKUNZUOWMIKUNZGHIKUNZKUNZUOABCD
      EFGHINMJUBVSGUOZWGWKWIWLWTWCWJWFKVSGWBKUPUQVSGWHKUPURWBHUOZWKWNWLWPXAWJWM
      WFKWBHGKUSUQXAWHWOGKWBHWFKUPUTURWFIUOZWNWQWPWSWFIWMKUSXBWOWRGKWFIHKUSUTUR
      VQNVAVRNVAVBZVTNVAWANVAVBZWDNVAWENVAVBZVCQRULZMUMZSTULZMUMZWGWIQSUOZRTUOZ
      XGXIUOZUIUJXJXKVBXFXHUOXLQRSTVDXFXHMVEVFVGXCXDXEWGXGUOXCXDVBZXEVBWGOPULMU
      MZWFKUNZXGXMWGXOUOXEXMWCXNWFKUCUQVHXMONVAPNVAVBXEXOXGUOUGUEVIVJVKXCXDXEWI
      XIUOXCXDXEVBZVBWIVSUALULMUMZKUNZXIXPWIXRUOXCXPWHXQVSKUDUTVLXPXCUANVALNVAV
      BXRXIUOUHUFVMVJVPVNVO $.
  $}

  ${
    $d x y z w v u A $.  $d z w v u B $.  $d w v u C $.  $d x y z w v u .+ $.
    $d x y z w v u .~ $.  $d x y z w v u S $.  $d x y z w v u .x. $.
    $d z w v u D $.
    ecovdi.1 $e |- D = ( ( S X. S ) /. .~ ) $.
    $( M,N for BFC $)
    ecovdi.2 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. z , w >. ] .~ .+ [ <. v , u >. ] .~ ) = [ <. M , N >. ] .~ ) $.
    $( H,J for AG(BFC) $)
    ecovdi.3 $e |- ( ( ( x e. S /\ y e. S ) /\ ( M e. S /\ N e. S ) ) ->
 ( [ <. x , y >. ] .~ .x. [ <. M , N >. ] .~ ) = [ <. H , J >. ] .~ ) $.
    $( W,X for AGB $)
    ecovdi.4 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
 ( [ <. x , y >. ] .~ .x. [ <. z , w >. ] .~ ) = [ <. W , X >. ] .~ ) $.
    $( Y,Z for AGC $)
    ecovdi.5 $e |- ( ( ( x e. S /\ y e. S ) /\ ( v e. S /\ u e. S ) ) ->
 ( [ <. x , y >. ] .~ .x. [ <. v , u >. ] .~ ) = [ <. Y , Z >. ] .~ ) $.
    $( K,L for (AGB)F(AGC) $)
    ecovdi.6 $e |- ( ( ( W e. S /\ X e. S ) /\ ( Y e. S /\ Z e. S ) ) ->
 ( [ <. W , X >. ] .~ .+ [ <. Y , Z >. ] .~ ) = [ <. K , L >. ] .~ ) $.
    ecovdi.7 $e |- ( ( ( z e. S /\ w e. S ) /\ ( v e. S /\ u e. S ) ) ->
                     ( M e. S /\ N e. S ) ) $.
    ecovdi.8 $e |- ( ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ->
                     ( W e. S /\ X e. S ) ) $.
    ecovdi.9 $e |- ( ( ( x e. S /\ y e. S ) /\ ( v e. S /\ u e. S ) ) ->
                     ( Y e. S /\ Z e. S ) ) $.
    ecovdi.10 $e |- H = K $.
    ecovdi.11 $e |- J = L $.
    $( Lemma used to transfer a distributive law via an equivalence relation.
       (Contributed by NM, 2-Sep-1995.)  (Revised by David Abernethy,
       4-Jun-2013.) $)
    ecovdi $p |- ( ( A e. D /\ B e. D /\ C e. D ) ->
                 ( A .x. ( B .+ C ) ) = ( ( A .x. B ) .+ ( A .x. C ) ) ) $=
      ( cv cop co wceq oveq1 oveq12d eqeq12d oveq2d oveq2 oveq1d wcel wa opeq12
      cec w3a eceq1 syl mp2an adantl sylan2 eqtrd 3impb oveqan12d syl2an 3impdi
      3eqtr4a 3ecoptocl ) AUPZBUPZUQLVIZCUPZDUPZUQLVIZEUPZFUPZUQLVIZKURZNURZWEW
      HNURZWEWKNURZKURZUSGWLNURZGWHNURZGWKNURZKURZUSGHWKKURZNURZGHNURZWSKURZUSG
      HIKURZNURZXCGINURZKURZUSABCDEFGHIMLJUEWEGUSZWMWQWPWTWEGWLNUTXIWNWRWOWSKWE
      GWHNUTWEGWKNUTVAVBWHHUSZWQXBWTXDXJWLXAGNWHHWKKUTVCXJWRXCWSKWHHGNVDVEVBWKI
      USZXBXFXDXHXKXAXEGNWKIHKVDVCXKWSXGXCKWKIGNVDVCVBWCMVFWDMVFVGZWFMVFWGMVFVG
      ZWIMVFWJMVFVGZVJOPUQZLVIZQRUQZLVIZWMWPOQUSZPRUSZXPXRUSZUNUOXSXTVGXOXQUSYA
      OPQRVHXOXQLVKVLVMXLXMXNWMXPUSXLXMXNVGZVGWMWESTUQLVIZNURZXPYBWMYDUSXLYBWLY
      CWENUFVCVNYBXLSMVFTMVFVGYDXPUSUKUGVOVPVQXLXMXNWPXRUSXLXMVGZXLXNVGZVGWPUAU
      BUQLVIZUCUDUQLVIZKURZXRYEYFWNYGWOYHKUHUIVRYEUAMVFUBMVFVGUCMVFUDMVFVGYIXRU
      SYFULUMUJVSVPVTWAWB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The mapping operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c ^m $.  $( The mapping operation. $)
  $c ^pm $.  $( The mapping operation. $)

  $( Extend the definition of a class to include the mapping operation.  (Read
     for ` A ^m B ` , "the set of all functions that map from ` B ` to
     ` A ` .) $)
  cmap $a class ^m $.

  $( Extend the definition of a class to include the partial mapping
     operation.  (Read for ` A ^m B ` , "the set of all partial functions that
     map from ` B ` to ` A ` .) $)
  cpm $a class ^pm $.

  ${
    $d x y f $.
    $( Define the mapping operation or set exponentiation.  The set of all
       functions that map from ` B ` to ` A ` is written ` ( A ^m B ) ` (see
       ~ mapval ).  Many authors write ` A ` followed by ` B ` as a superscript
       for this operation and rely on context to avoid confusion other
       exponentiation operations (e.g.  Definition 10.42 of [TakeutiZaring]
       p. 95).  Other authors show ` B ` as a prefixed superscript, which is
       read " ` A ` pre ` B ` " (e.g. definition of [Enderton] p. 52).
       Definition 8.21 of [Eisenberg] p. 125 uses the notation Map( ` B ` ,
       ` A ` ) for our ` ( A ^m B ) ` .  The up-arrow is used by Donald Knuth
       for iterated exponentiation (_Science_ 194, 1235-1242, 1976).  We adopt
       the first case of his notation (simple exponentiation) and subscript it
       with _m_ to distinguish it from other kinds of exponentiation.
       (Contributed by NM, 8-Dec-2003.) $)
    df-map $a |- ^m = ( x e. _V , y e. _V |-> { f | f : y --> x } ) $.

    $( Define the partial mapping operation.  A partial function from ` B ` to
       ` A ` is a function from a subset of ` B ` to ` A ` .  The set of all
       partial functions from ` B ` to ` A ` is written ` ( A ^pm B ) ` (see
       ~ pmvalg ).  A notation for this operation apparently does not appear in
       the literature.  We use ` ^pm ` to distinguish it from the less general
       set exponentiation operation ` ^m ` ( ~ df-map ) .  See ~ mapsspm for
       its relationship to set exponentiation.  (Contributed by NM,
       15-Nov-2007.) $)
    df-pm $a |- ^pm = ( x e. _V , y e. _V |->
                    { f e. ~P ( y X. x ) | Fun f } ) $.
  $}

  $( Note:  an alternate way to express partial functions is as follows,
     which would be added after df-fun above.  The symbol would be _pfun.gif.
     This definition would be needed only if we need proper class partial
     functions, which seems unlikely.  While nice-looking, for ordinary usage
     it would inconveniently require a new set of equality theorems, etc. $)
  $( Define a partial function, which is a function from a subset of the
     domain ` A ` to the codomain ` B ` .  The notation of a stroke through
     the arrow is used by the Z language: see, for example,
     ~ http://staff.washington.edu/jon/z/dcs.html . $)
  $(
  df-fp $a |- ( F : A -|-> B <-> ( Fun F /\ F C_ ( X X. Y ) ) $.
  $)

  ${
    $d f x A $.  $d f x B $.
    $( When ` A ` is a proper class, the class of all functions mapping ` A `
       to ` B ` is empty.  Exercise 4.41 of [Mendelson] p. 255.  (Contributed
       by NM, 8-Dec-2003.) $)
    mapprc $p |- ( -. A e. _V -> { f | f : A --> B } = (/) ) $=
      ( cvv wcel cv wf cab c0 wne wex abn0 cdm fdm dmex syl6eqelr exlimiv sylbi
      vex necon1bi ) ADEZABCFZGZCHZIUDIJUCCKUAUCCLUCUACUCAUBMDABUBNUBCSOPQRT $.

    $( The class of all partial functions from one set to another is a set.
       (Contributed by NM, 15-Nov-2007.) $)
    pmex $p |- ( ( A e. C /\ B e. D ) ->
                   { f | ( Fun f /\ f C_ ( A X. B ) ) } e. _V ) $=
      ( wcel wa cv wfun cxp wss cab cvv ancom abbii xpexg abssexg syl syl5eqel
      ) ACFBDFGZEHZIZUAABJZKZGZELUDUBGZELZMUEUFEUBUDNOTUCMFUGMFABCDPUBEUCMQRS
      $.

    $( The class of all functions mapping one set to another is a set.  Remark
       after Definition 10.24 of [Kunen] p. 31.  (Contributed by Raph Levien,
       4-Dec-2003.) $)
    mapex $p |- ( ( A e. C /\ B e. D ) -> { f | f : A --> B } e. _V ) $=
      ( wcel wa cv cab cxp cpw wss cvv fssxp ss2abi df-pw sseqtr4i xpexg pwexg
      wf syl ssexg sylancr ) ACFBDFGZABEHZTZEIZABJZKZLUIMFZUGMFUGUEUHLZEIUIUFUK
      EABUENOEUHPQUDUHMFUJABCDRUHMSUAUGUIMUBUC $.
  $}

  ${
    $d f x y $.
    $( Set exponentiation has a universal domain.  (Contributed by NM,
       8-Dec-2003.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    fnmap $p |- ^m Fn ( _V X. _V ) $=
      ( vx vy vf cvv cv wf cab cmap df-map wcel vex mapex mp2an fnmpt2i ) ABDDB
      EZAEZCEFCGZHABCIODJPDJQDJBKAKOPDDCLMN $.

    $( Partial function exponentiation has a universal domain.  (Contributed by
       Mario Carneiro, 14-Nov-2013.) $)
    fnpm $p |- ^pm Fn ( _V X. _V ) $=
      ( vx vy vf cvv cv wfun cxp cpw crab cpm df-pm vex xpex pwex rabex fnmpt2i
      ) ABDDCEFZCBEZAEZGZHZIJABCKQCUATRSBLALMNOP $.

    $( Set exponentiation is a well-behaved binary operator.  (Contributed by
       Stefan O'Rear, 27-Feb-2015.) $)
    reldmmap $p |- Rel dom ^m $=
      ( vx vy vf cvv cv wf cab cmap df-map reldmmpt2 ) ABDDBEAECEFCGHABCIJ $.
  $}

  ${
    $d x y f A $.  $d x y f B $.
    $( The value of set exponentiation. ` ( A ^m B ) ` is the set of all
       functions that map from ` B ` to ` A ` .  Definition 10.24 of [Kunen]
       p. 24.  (Contributed by NM, 8-Dec-2003.)  (Revised by Mario Carneiro,
       8-Sep-2013.) $)
    mapvalg $p |- ( ( A e. C /\ B e. D ) ->
                  ( A ^m B ) = { f | f : B --> A } ) $=
      ( vx vy wcel wa cv wf cab cvv cmap co wceq mapex ancoms elex abbidv feq3
      wi feq2 df-map ovmpt2g 3expia syl2an mpd ) ACHZBDHZIBAEJZKZELZMHZABNOUMPZ
      UJUIUNBADCEQRUIAMHZBMHZUNUOUBUJACSBDSUPUQUNUOFGABMMGJZFJZUKKZELUMNURAUKKZ
      ELMUSAPUTVAEUSAURUKUATURBPVAULEURBAUKUCTFGEUDUEUFUGUH $.

    $( The value of the partial mapping operation. ` ( A ^pm B ) ` is the set
       of all partial functions that map from ` B ` to ` A ` .  (Contributed by
       NM, 15-Nov-2007.)  (Revised by Mario Carneiro, 8-Sep-2013.) $)
    pmvalg $p |- ( ( A e. C /\ B e. D ) ->
                  ( A ^pm B ) = { f e. ~P ( B X. A ) | Fun f } ) $=
      ( vx vy wcel wa cv cxp cpw crab cvv cpm wceq syl elex pweqd rabeq wfun co
      wss ssrab2 xpexg ancoms pwexg ssexg sylancr wi xpeq2 xpeq1 ovmpt2g 3expia
      df-pm syl2an mpd ) ACHZBDHZIZEJUAZEBAKZLZMZNHZABOUBVDPZUTVDVCUCVCNHZVEVAE
      VCUDUTVBNHZVGUSURVHBADCUEUFVBNUGQVDVCNUHUIURANHZBNHZVEVFUJUSACRBDRVIVJVEV
      FFGABNNVAEGJZFJZKZLZMZVDOVAEVKAKZLZMZNVLAPZVNVQPVOVRPVSVMVPVLAVKUKSVAEVNV
      QTQVKBPZVQVCPVRVDPVTVPVBVKBAULSVAEVQVCTQFGEUOUMUNUPUQ $.
  $}

  ${
    $d f A $.  $d f B $.
    mapval.1 $e |- A e. _V $.
    mapval.2 $e |- B e. _V $.
    $( The value of set exponentiation (inference version). ` ( A ^m B ) ` is
       the set of all functions that map from ` B ` to ` A ` .  Definition
       10.24 of [Kunen] p. 24.  (Contributed by NM, 8-Dec-2003.) $)
    mapval $p |- ( A ^m B ) = { f | f : B --> A } $=
      ( cvv wcel cmap co cv wf cab wceq mapvalg mp2an ) AFGBFGABHIBACJKCLMDEABF
      FCNO $.
  $}

  ${
    $d g A $.  $d g B $.  $d g C $.
    $( Membership relation for set exponentiation.  (Contributed by NM,
       17-Oct-2006.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
    elmapg $p |- ( ( A e. V /\ B e. W ) ->
                  ( C e. ( A ^m B ) <-> C : B --> A ) ) $=
      ( vg wcel wa cmap co cv wf cab mapvalg eleq2d cvv wi wb fex2 3com13 bitrd
      3expia feq1 elab3g syl ) ADGZBEGZHZCABIJZGCBAFKZLZFMZGZBACLZUHUIULCABDEFN
      OUHUNCPGZQUMUNRUFUGUNUOUNUGUFUOBACEDSTUBUKUNFCPBAUJCUCUDUEUA $.

    $( The predicate "is a partial function."  (Contributed by Mario Carneiro,
       14-Nov-2013.) $)
    elpmg $p |- ( ( A e. V /\ B e. W ) ->
                  ( C e. ( A ^pm B ) <-> ( Fun C /\ C C_ ( B X. A ) ) ) ) $=
      ( vg wcel wa cpm co wfun cxp cpw wss cv crab syl6bb cvv wi a1i funeq elex
      pmvalg eleq2d elrab ancom xpexg ancoms ssexg expcom elpwg pm5.21ndd bitrd
      syl wb anbi2d ) ADGZBEGZHZCABIJZGZCKZCBALZMZGZHZVBCVCNZHUSVAVEVBHZVFUSVAC
      FOZKZFVDPZGVHUSUTVKCABDEFUCUDVJVBFCVDVICUAUEQVEVBUFQUSVEVGVBUSCRGZVEVGVEV
      LSUSCVDUBTUSVCRGZVGVLSURUQVMBAEDUGUHVGVMVLCVCRUIUJUNVLVEVGUOSUSCVCRUKTULU
      PUM $.

    $( The predicate "is a partial function."  (Contributed by NM,
       31-Dec-2013.) $)
    elpm2g $p |- ( ( A e. V /\ B e. W ) ->
                ( F e. ( A ^pm B ) <-> ( F : dom F --> A /\ dom F C_ B ) ) ) $=
      ( wcel wa cpm co wfun cxp wss cdm wf elpmg funssxp syl6bb ) ADFBEFGCABHIF
      CJCBAKLGCMZACNRBLGABCDEOBACPQ $.

    $( Sufficient condition for being a partial function.  (Contributed by NM,
       31-Dec-2013.) $)
    elpm2r $p |- ( ( ( A e. V /\ B e. W ) /\ ( F : C --> A /\ C C_ B ) ) ->
                   F e. ( A ^pm B ) ) $=
      ( wcel wa wf wss cpm co cdm wb fdm feq2d sseq1d anbi12d adantr ibir imp
      elpm2g syl5ibr ) AEGBFGHZCADIZCBJZHZDABKLGZUGUHUDDMZADIZUIBJZHZUGULUEULUG
      NUFUEUJUEUKUFUEUICADCADOZPUEUICBUMQRSTABDEFUBUCUA $.

    $( A partial function is a function.  (Contributed by Mario Carneiro,
       15-Sep-2015.) $)
    elpmi $p |- ( F e. ( A ^pm B ) -> ( F : dom F --> A /\ dom F C_ B ) ) $=
      ( cpm co wcel cdm wf wss wa cvv wb c0 wceq n0i cxp wfn fnpm fndm ax-mp
      ndmov nsyl2 elpm2g syl ibi ) CABDEZFZCGZACHUHBIJZUGAKFBKFJZUGUILUGUFMNUJU
      FCOABKDDKKPZQDGUKNRUKDSTUAUBABCKKUCUDUE $.

    $( A partial function is a function.  (Contributed by Mario Carneiro,
       30-Jan-2014.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    pmfun $p |- ( F e. ( A ^pm B ) -> Fun F ) $=
      ( cpm co wcel cdm wf wss wa wfun elpmi ffun adantr syl ) CABDEFCGZACHZPBI
      ZJCKZABCLQSRPACMNO $.
  $}

  ${
    $d a b c d $.
    $( Eliminate antecedent for mapping theorems: domain can be taken to be a
       set.  (Contributed by Stefan O'Rear, 8-Oct-2014.) $)
    elmapex $p |- ( A e. ( B ^m C ) -> ( B e. _V /\ C e. _V ) ) $=
      ( cmap co wcel c0 wceq cvv n0i cxp wfn cdm fnmap fndm ax-mp ndmov nsyl2
      wa ) ABCDEZFTGHBIFCIFSTAJBCIDDIIKZLDMUAHNUADOPQR $.
  $}

  $( A mapping is a function, forward direction only with superfluous
     antecedent removed.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
  elmapi $p |- ( A e. ( B ^m C ) -> A : C --> B ) $=
    ( cmap co wcel wf cvv wa wb elmapex elmapg syl ibi ) ABCDEFZCBAGZOBHFCHFIOP
    JABCKBCAHHLMN $.

  $( A total function is a partial function.  (Contributed by Mario Carneiro,
     31-Dec-2013.) $)
  fpmg $p |- ( ( A e. V /\ B e. W /\ F : A --> B ) -> F e. ( B ^pm A ) ) $=
    ( wcel wf cpm co wa wss ssid elpm2r mpanr2 3impa 3com12 ) BEFZADFZABCGZCBAH
    IFZQRSTQRJSAAKTALBAACEDMNOP $.

  ${
    $d f A $.  $d f B $.  $d f C $.  $d f D $.  $d f V $.  $d f W $.
    $( Subset relation for the set of partial functions.  (Contributed by Mario
       Carneiro, 31-Dec-2013.) $)
    pmss12g $p |- ( ( ( A C_ C /\ B C_ D ) /\ ( C e. V /\ D e. W ) ) ->
                   ( A ^pm B ) C_ ( C ^pm D ) ) $=
      ( vf wss wa wcel cpm co cv wfun cxp wi wb cvv ssexg elpmg xpss12 sstr syl
      ancoms expcom anim2d adantr syl2an an4s adantl 3imtr4d ssrdv ) ACHZBDHZIZ
      CEJZDFJZIZIZGABKLZCDKLZUSGMZNZVBBAOZHZIZVCVBDCOZHZIZVBUTJZVBVAJZUOVFVIPUR
      UOVEVHVCUOVDVGHZVEVHPUNUMVLBDACUAUDVEVLVHVBVDVGUBUEUCUFUGUMUPUNUQVJVFQZUM
      UPIARJBRJVMUNUQIACESBDFSABVBRRTUHUIURVKVIQUOCDVBEFTUJUKUL $.
  $}

  $( Elementhood of a restricted function in the set of partial functions.
     (Contributed by Mario Carneiro, 31-Dec-2013.) $)
  pmresg $p |- ( ( B e. V /\ F e. ( A ^pm C ) ) ->
                 ( F |` B ) e. ( A ^pm B ) ) $=
    ( wcel cpm co wa cvv cdm cin cres wf c0 wceq simpld adantl wss 3syl n0i cxp
    wfn fnpm fndm ax-mp ndmov nsyl2 simpl elpmi fssres sylancl wfun ffun resres
    inss1 funrel resdm reseq1 syl5eqr feq1d mpbid inss2 elpm2r mpanr2 syl21anc
    wrel ) BEFZDACGHZFZIZAJFZVHDKZBLZADBMZNZVOABGHFZVJVLVHVJVLCJFZVJVIOPVLVRIVI
    DUAACJGGJJUBZUCGKVSPUDVSGUEUFUGUHQRVHVJUIVKVNADVNMZNZVPVKVMADNZVNVMSWAVJWBV
    HVJWBVMCSACDUJQRZVMBUPVMAVNDUKULVKVNAVTVOVKWBDUMZVTVOPWCVMADUNWDVTDVMMZBMZV
    ODVMBUOWDDVGWEDPWFVOPDUQDURWEDBUSTUTTVAVBVLVHIVPVNBSVQVMBVCABVNVOJEVDVEVF
    $.

  ${
    $d g A $.  $d f g B $.  $d g F $.
    elmap.1 $e |- A e. _V $.
    elmap.2 $e |- B e. _V $.
    $( Membership relation for set exponentiation.  (Contributed by NM,
       8-Dec-2003.) $)
    elmap $p |- ( F e. ( A ^m B ) <-> F : B --> A ) $=
      ( cvv wcel cmap co wf wb elmapg mp2an ) AFGBFGCABHIGBACJKDEABCFFLM $.

    $( Alternate expression for the value of set exponentiation.  (Contributed
       by NM, 3-Nov-2007.) $)
    mapval2 $p |- ( A ^m B ) = ( ~P ( B X. A ) i^i { f | f Fn B } ) $=
      ( vg cmap co cxp cpw cv wfn cab cin wf wss wa wcel dff2 bitri ancom elmap
      elin vex elpw fneq1 elab anbi12i 3bitr4i eqriv ) FABGHZBAIZJZCKZBLZCMZNZB
      AFKZOZURULPZURBLZQZURUKRURUQRZUSVAUTQVBBAURSVAUTUATABURDEUBVCURUMRZURUPRZ
      QVBURUMUPUCVDUTVEVAURULFUDZUEUOVACURVFBUNURUFUGUHTUIUJ $.

    $( The predicate "is a partial function."  (Contributed by NM,
       15-Nov-2007.)  (Revised by Mario Carneiro, 14-Nov-2013.) $)
    elpm $p |- ( F e. ( A ^pm B ) <-> ( Fun F /\ F C_ ( B X. A ) ) ) $=
      ( cvv wcel cpm co wfun cxp wss wa wb elpmg mp2an ) AFGBFGCABHIGCJCBAKLMND
      EABCFFOP $.

    $( The predicate "is a partial function."  (Contributed by NM,
       15-Nov-2007.)  (Revised by Mario Carneiro, 31-Dec-2013.) $)
    elpm2 $p |- ( F e. ( A ^pm B ) <-> ( F : dom F --> A /\ dom F C_ B ) ) $=
      ( cvv wcel cpm co cdm wf wss wa wb elpm2g mp2an ) AFGBFGCABHIGCJZACKQBLMN
      DEABCFFOP $.

    $( A total function is a partial function.  (Contributed by NM,
       15-Nov-2007.)  (Revised by Mario Carneiro, 31-Dec-2013.) $)
    fpm $p |- ( F : A --> B -> F e. ( B ^pm A ) ) $=
      ( cvv wcel wf cpm co fpmg mp3an12 ) AFGBFGABCHCBAIJGDEABCFFKL $.
  $}

  ${
    $d f A $.  $d f B $.
    $( Set exponentiation is a subset of partial maps.  (Contributed by NM,
       15-Nov-2007.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    mapsspm $p |- ( A ^m B ) C_ ( A ^pm B ) $=
      ( vf cmap co cpm cv wcel cvv wf elmapex simprd simpld elmapi fpmg syl3anc
      ssriv ) CABDEZABFEZCGZRHZBIHZAIHZBATJTSHUAUCUBTABKZLUAUCUBUDMTABNBATIIOPQ
      $.

    $( Partial maps are a subset of the power set of the cross product of its
       arguments.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    pmsspw $p |- ( A ^pm B ) C_ ~P ( B X. A ) $=
      ( vf cpm co cxp cpw cv wcel wss wfun wa cvv wb c0 wceq n0i wfn cdm fnpm
      fndm ax-mp ndmov nsyl2 elpmg syl ibi simprd vex elpw sylibr ssriv ) CABDE
      ZBAFZGZCHZUMIZUPUNJZUPUOIUQUPKZURUQUSURLZUQAMIBMILZUQUTNUQUMOPVAUMUPQABMD
      DMMFZRDSVBPTVBDUAUBUCUDABUPMMUEUFUGUHUPUNCUIUJUKUL $.

    $( Set exponentiation is a subset of the power set of the cross product of
       its arguments.  (Contributed by NM, 8-Dec-2006.)  (Revised by Mario
       Carneiro, 26-Apr-2015.) $)
    mapsspw $p |- ( A ^m B ) C_ ~P ( B X. A ) $=
      ( cmap co cpm cxp cpw mapsspm pmsspw sstri ) ABCDABEDBAFGABHABIJ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y D $.  $d x y R $.
    fvmptmap.1 $e |- C e. _V $.
    fvmptmap.2 $e |- D e. _V $.
    fvmptmap.3 $e |- R e. _V $.
    fvmptmap.4 $e |- ( x = A -> B = C ) $.
    fvmptmap.5 $e |- F = ( x e. ( R ^m D ) |-> B ) $.
    $( Special case of ~ fvmpt for operator theorems.  (Contributed by NM,
       27-Nov-2007.) $)
    fvmptmap $p |- ( A : D --> R -> ( F ` A ) = C ) $=
      ( wf cmap co wcel cfv wceq elmap fvmpt sylbir ) EFBMBFENOZPBGQDRFEBJISABC
      DUBGKLHTUA $.
  $}

  ${
    $d f A $.  $d f B $.  $d f V $.  $d f W $.
    $( Set exponentiation with an empty exponent (ordinal number 0) is ordinal
       number 1.  Exercise 4.42(a) of [Mendelson] p. 255.  (Contributed by NM,
       10-Dec-2003.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    map0e $p |- ( A e. V -> ( A ^m (/) ) = 1o ) $=
      ( vf wcel c0 cmap co c1o cv wf cvv wb 0ex elmapg mpan2 wceq wfn crn wss
      wa fn0 anbi1i df-f rneq rn0 syl6eq syl6eqss pm4.71i 3bitr4i bitr4i syl6bb
      0ss el1o eqrdv ) ABDZCAEFGZHUOCIZUPDZEAUQJZUQHDZUOEKDURUSLMAEUQBKNOUSUQEP
      ZUTUQEQZUQRZASZTVAVDTUSVAVBVAVDUQUAUBEAUQUCVAVDVAVCEAVAVCEREUQEUDUEUFAULU
      GUHUIUQUMUJUKUN $.

    $( Set exponentiation with an empty base is the empty set, provided the
       exponent is non-empty.  Theorem 96 of [Suppes] p. 89.  (Contributed by
       NM, 10-Dec-2003.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
    map0b $p |- ( A =/= (/) -> ( (/) ^m A ) = (/) ) $=
      ( vf c0 wne cmap co cv wcel wf wceq elmapi cdm fdm crn wss frn ss0 dm0rn0
      syl sylibr eqtr3d necon3ai eq0rdv ) ACDBCAEFZBGZUDHZACUFACUEIZACJUECAKUGU
      ELZACACUEMUGUENZCJZUHCJUGUICOUJACUEPUIQSUERTUASUBUC $.

    $( Set exponentiation is empty iff the base is empty and the exponent is
       not empty.  Theorem 97 of [Suppes] p. 89.  (Contributed by Mario
       Carneiro, 30-Apr-2015.) $)
    map0g $p |- ( ( A e. V /\ B e. W ) ->
      ( ( A ^m B ) = (/) <-> ( A = (/) /\ B =/= (/) ) ) ) $=
      ( vf wcel wa cmap co c0 wceq wne cv wex n0 wf elmapg syl5ibr ne0i syl6 f0
      csn cxp fconst6g exlimdv syl5bi necon4d feq2 mpbiri necon2d jcad sylan9eq
      oveq1 map0b impbid1 ) ACFBDFGZABHIZJKZAJKZBJLZGUPURUSUTUPAJUQJAJLEMZAFZEN
      UPUQJLZEAOUPVBVCEUPVBBVAUBUCZUQFZVCVBVEUPBAVDPBVAAUDABVDCDQRUQVDSTUEUFUGU
      PBJUQJUPBJKZJUQFZVCVFVGUPBAJPZVFVHJAJPAUABJAJUHUIABJCDQRUQJSTUJUKUSUTUQJB
      HIJAJBHUMBUNULUO $.
  $}

  ${
    $d f x y A $.  $d f x y B $.
    map0.1 $e |- A e. _V $.
    map0.2 $e |- B e. _V $.
    $( Set exponentiation is empty iff the base is empty and the exponent is
       not empty.  Theorem 97 of [Suppes] p. 89.  (Contributed by NM,
       10-Dec-2003.) $)
    map0 $p |- ( ( A ^m B ) = (/) <-> ( A = (/) /\ B =/= (/) ) ) $=
      ( cvv wcel cmap co c0 wceq wne wa wb map0g mp2an ) AEFBEFABGHIJAIJBIKLMCD
      ABEENO $.

    $( The value of set exponentiation with a singleton exponent.  Theorem 98
       of [Suppes] p. 89.  (Contributed by NM, 10-Dec-2003.) $)
    mapsn $p |- ( A ^m { B } ) = { f | E. y e. A f = { <. B , y >. } } $=
      ( cv cop csn wceq wrex cmap wcel wf wex snid cima syl mpbiri wf1o co snex
      wa crn wbr weu wfn ffn fneu sylancl cab euabsn wrel frel relimasn imadmrn
      elmap cdm fdm imaeq2d syl5reqr eqtr3d eqeq1d exbidv mpbid vex eleq2 sseld
      syl5bb frn syl5 wfo dffn4 sylib fof feq3 syl5ibcom fsn syl6ib jcad eximdv
      mpd df-rex sylibr wss f1osn f1oeq1 f1of fss syl2an expcom rexlimiv impbii
      snssi bitri abbi2i ) DGZCAGZHIZJZABKZDBCIZLUAZWQXCMXBBWQNZXABXBWQECUBUQXD
      XAXDWRBMZWTUCZAOZXAXDWQUDZWRIZJZAOZXGXDCWRWQUEZAUFZXKXDWQXBUGZCXBMXMXBBWQ
      UHZCFPAXBCWQUIUJXMXLAUKZXIJZAOXDXKXLAULXDXQXJAXDXPXHXIXDWQXBQZXPXHXDWQUMX
      RXPJXBBWQUNACWQUORXDXHWQWQURZQXRWQUPXDXSXBWQXBBWQUSUTVAVBVCVDVIVEXDXJXFAX
      DXJXEWTXJWRXHMZXDXEXJXTWRXIMWRAVFZPXHXIWRVGSXDXHBWRXBBWQVJVHVKXDXJXBXIWQN
      ZWTXDXBXHWQNZXJYBXDXBXHWQVLZYCXDXNYDXOXBWQVMVNXBXHWQVORXHXIXBWQVPVQCWRWQF
      YAVRVSVTWAWBWTABWCWDWTXDABWTXEXDWTYBXIBWEXDXEWTXBXIWQTZYBWTYEXBXIWSTCWRFY
      AWFXBXIWQWSWGSXBXIWQWHRWRBWNXBXIBWQWIWJWKWLWMWOWP $.
  $}

  ${
    $d f A $.  $d f B $.  $d f C $.  $d f V $.
    $( Subset inheritance for set exponentiation.  Theorem 99 of [Suppes]
       p. 89.  (Contributed by NM, 10-Dec-2003.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    mapss $p |- ( ( B e. V /\ A C_ B ) -> ( A ^m C ) C_ ( B ^m C ) ) $=
      ( vf wcel wss wa cmap co cv wf elmapi adantl simplr fss syl2anc wb simpll
      cvv elmapex simprd elmapg mpbird ex ssrdv ) BDFZABGZHZEACIJZBCIJZUIEKZUJF
      ZULUKFZUIUMHZUNCBULLZUOCAULLZUHUPUMUQUIULACMNUGUHUMOCABULPQUOUGCTFZUNUPRU
      GUHUMSUMURUIUMATFURULACUAUBNBCULDTUCQUDUEUF $.
  $}

  ${
    $d B x $.  $d I x $.  $d V x $.  $d W x $.  $d X x $.
    fdiagfn.f $e |- F = ( x e. B |-> ( I X. { x } ) ) $.
    $( Functionality of the diagonal map.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    fdiagfn $p |- ( ( B e. V /\ I e. W ) -> F : B --> ( B ^m I ) ) $=
      ( wcel wa cv csn cxp cmap co wf fconst6g adantl wb elmapg adantr mpbird
      fmptd ) BEHDFHIZABDAJZKLZBDMNZCUCUDBHZIUEUFHZDBUEOZUGUIUCDUDBPQUCUHUIRUGB
      DUEEFSTUAGUB $.

    $( Functionality of the diagonal map.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    fvdiagfn $p |- ( ( I e. W /\ X e. B ) -> ( F ` X ) = ( I X. { X } ) ) $=
      ( wcel wa csn cxp cvv cfv wceq simpr snex xpexg mpan2 adantr cv syl2anc
      sneq xpeq2d fvmptg ) DEHZFBHZIUFDFJZKZLHZFCMUHNUEUFOUEUIUFUEUGLHUIFPDUGEL
      QRSAFDATZJZKUHBLCUJFNUKUGDUJFUBUCGUDUA $.
  $}

  ${
    $d B x y $.  $d S x y $.  $d X y $.
    mapsncnv.s $e |- S = { X } $.
    mapsncnv.b $e |- B e. _V $.
    mapsncnv.x $e |- X e. _V $.
    $( Every singleton map is a constant function.  (Contributed by Stefan
       O'Rear, 25-Mar-2015.) $)
    mapsnconst $p |- ( F e. ( B ^m S ) -> F = ( S X. { ( F ` X ) } ) ) $=
      ( cfv csn cxp wceq cmap co wcel wf snex elmap cop fsn2 simprbi fvex sylbi
      xpeq1i xpsn eqtr2i syl6eq oveq2i eleq2s ) CBDCHZIZJZKZCADIZLMZABLMCUNNUMA
      COZULAUMCFDPQUOCDUIRIZUKUOUIANCUPKDACGSTUKUMUJJUPBUMUJEUCDUIGDCUAUDUEUFUB
      BUMALEUGUH $.

    ${
      mapsncnv.f $e |- F = ( x e. ( B ^m S ) |-> ( x ` X ) ) $.
      $( Expression for the inverse of the canonical map between a set and its
         set of singleton functions.  (Contributed by Stefan O'Rear,
         21-Mar-2015.) $)
      mapsncnv $p |- `' F = ( y e. B |-> ( S X. { y } ) ) $=
        ( cv cmap co wcel cfv wceq wa copab csn cxp ccnv cmpt wf elmapi ffvelrn
        snid sylancl eqid mapsnconst jca eleq1 xpeq2d eqeq2d anbi12d syl5ibrcom
        sneq imp fconst6g snex elmap sylibr fvconst2 eqcomd fveq1 impbii oveq2i
        vex mp1i eleq2i anbi1i xpeq1i eqeq2i anbi2i 3bitr4i df-mpt eqtri cnveqi
        opabbii cnvopab 3eqtr4i ) AKZCDLMZNZBKZFWAOZPZQZBARZWDCNZWADWDSZTZPZQZB
        AREUAZBCWKUBWGWMBAWACFSZLMZNZWFQZWIWAWOWJTZPZQZWGWMWRXAWQWFXAWQXAWFWECN
        ZWAWOWESZTZPZQWQXBXEWQWOCWAUCFWONZXBWACWOUDFIUFZWOCFWAUEUGCWOWAFWOUHHIU
        IUJWFWIXBWTXEWDWECUKWFWSXDWAWFWJXCWOWDWEUPULUMUNUOUQWIWTWRWIWRWTWSWPNZW
        DFWSOZPZQWIXHXJWIWOCWSUCXHWOWDCURCWOWSHFUSUTVAWIXIWDXFXIWDPWIXGWOWDFBVG
        VBVHVCUJWTWQXHWFXJWAWSWPUKWTWEXIWDFWAWSVDUMUNUOUQVEWCWQWFWBWPWADWOCLGVF
        VIVJWLWTWIWKWSWADWOWJGVKVLVMVNVRWNWGABRZUAWHEXKEAWBWEUBXKJABWBWEVOVPVQW
        GABVSVPBACWKVOVT $.

      $( Explicit bijection between a set and its singleton functions.
         (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
      mapsnf1o2 $p |- F : ( B ^m S ) -1-1-onto-> B $=
        ( vy cmap co wf1o wfn ccnv cv cfv fnmpti csn snex fvex cxp eqeltri xpex
        cvv mapsncnv dff1o4 mpbir2an ) BCKLZBDMDUINDOZBNAUIEAPZQDEUKUAIRJBCJPZS
        ZUBUJCUMCESUEFETUCULTUDAJBCDEFGHIUFRUIBDUGUH $.
    $}

    mapsnf1o3.f $e |- F = ( y e. B |-> ( S X. { y } ) ) $.
    $( Explicit bijection in the reverse of ~ mapsnf1o2 .  (Contributed by
       Stefan O'Rear, 24-Mar-2015.) $)
    mapsnf1o3 $p |- F : B -1-1-onto-> ( B ^m S ) $=
      ( vx cmap co wf1o cv cfv cmpt ccnv eqid mapsnf1o2 ax-mp f1ocnv wb csn cxp
      wceq mapsncnv eqtr4i f1oeq1 mpbir ) BBCKLZDMZBUJJUJEJNOPZQZMZUJBULMUNJBCU
      LEFGHULRZSUJBULUATDUMUEUKUNUBDABCANUCUDPUMIJABCULEFGHUOUFUGBUJDUMUHTUI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Infinite Cartesian products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c X_ $.

  $( Extend class notation to include infinite Cartesian products. $)
  cixp $a class X_ x e. A B $.

  ${
    $d f x $.  $d f A $.  $d f B $.
    $( Definition of infinite Cartesian product of [Enderton] p. 54.  Enderton
       uses a bold "X" with ` x e. A ` written underneath or as a subscript, as
       does Stoll p. 47.  Some books use a capital pi, but we will reserve that
       notation for products of numbers.  Usually ` B ` represents a class
       expression containing ` x ` free and thus can be thought of as
       ` B ( x ) ` .  Normally, ` x ` is not free in ` A ` , although this is
       not a requirement of the definition.  (Contributed by NM,
       28-Sep-2006.) $)
    df-ixp $a |- X_ x e. A B =
               { f | ( f Fn { x | x e. A } /\ A. x e. A ( f ` x ) e. B ) } $.

    $d x A $.
    $( Eliminate the expression ` { x | x e. A } ` in ~ df-ixp , under the
       assumption that ` A ` and ` x ` are disjoint.  This way, we can say that
       ` x ` is bound in ` X_ x e. A B ` even if it appears free in ` A ` .
       (Contributed by Mario Carneiro, 12-Aug-2016.) $)
    dfixp $p |- X_ x e. A B =
                 { f | ( f Fn A /\ A. x e. A ( f ` x ) e. B ) } $=
      ( cixp cv wcel cab wfn cfv wral wa df-ixp abid2 fneq2i anbi1i abbii eqtri
      ) ABCEDFZAFZBGAHZIZTSJCGABKZLZDHSBIZUCLZDHABCDMUDUFDUBUEUCUABSABNOPQR $.
  $}

  ${
    $d f x A $.  $d f B $.  $d x C $.  $d x D $.  $d f x F $.
    $( Membership in an infinite Cartesian product.  See ~ df-ixp for
       discussion of the notation.  (Contributed by NM, 28-Sep-2006.) $)
    elixp2 $p |- ( F e. X_ x e. A B <->
                ( F e. _V /\ F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      ( vf cvv wcel cixp wa wfn cv cfv wral w3a wceq fneq1 fveq1 eleq1d ralbidv
      anbi12d dfixp elab2g pm5.32i elex pm4.71ri 3anass 3bitr4i ) DFGZDABCHZGZI
      UHDBJZAKZDLZCGZABMZIZIUJUHUKUONUHUJUPEKZBJZULUQLZCGZABMZIUPEDUIFUQDOZURUK
      VAUOBUQDPVBUTUNABVBUSUMCULUQDQRSTABCEUAUBUCUJUHDUIUDUEUHUKUOUFUG $.

    fvixp.1 $e |- ( x = C -> B = D ) $.
    $( Projection of a factor of an indexed Cartesian product.  (Contributed by
       Mario Carneiro, 11-Jun-2016.) $)
    fvixp $p |- ( ( F e. X_ x e. A B /\ C e. A ) -> ( F ` C ) e. D ) $=
      ( cixp wcel cv cfv wral cvv wfn elixp2 simp3bi wceq fveq2 eleq12d rspccva
      sylan ) FABCHIZAJZFKZCIZABLZDBIDFKZEIZUBFMIFBNUFABCFOPUEUHADBUCDQUDUGCEUC
      DFRGSTUA $.
  $}

  ${
    $d A f x $.  $d B f $.  $d F f $.  $d f x $.
    $( A nuple is a function.  (Contributed by FL, 6-Jun-2011.)  (Revised by
       Mario Carneiro, 31-May-2014.) $)
    ixpfn $p |- ( F e. X_ x e. A B -> F Fn A ) $=
      ( vf cv wfn cixp fneq1 wcel cvv cfv wral elixp2 simp2bi vtoclga ) EFZBGZD
      BGEDABCHZBQDIQSJQKJRAFQLCJABMABCQNOP $.
  $}

  ${
    $d x F $.  $d x I $.  $d x A $.
    elixp.1 $e |- F e. _V $.
    $( Membership in an infinite Cartesian product.  (Contributed by NM,
       28-Sep-2006.) $)
    elixp $p |- ( F e. X_ x e. A B <->
                ( F Fn A /\ A. x e. A ( F ` x ) e. B ) ) $=
      ( cixp wcel cvv wfn cv cfv wral w3a wa elixp2 3anass mpbiran bitri ) DABC
      FGDHGZDBIZAJDKCGABLZMZTUANZABCDOUBSUCESTUAPQR $.

    $d x B $.
    $( Membership in an infinite Cartesian product of a constant ` B ` .
       (Contributed by NM, 12-Apr-2008.) $)
    elixpconst $p |- ( F e. X_ x e. A B <-> F : A --> B ) $=
      ( cixp wcel wfn cv cfv wral wa wf elixp ffnfv bitr4i ) DABCFGDBHAIDJCGABK
      LBCDMABCDENABCDOP $.
  $}

  ${
    $d f x A $.  $d f x B $.
    $( Infinite Cartesian product of a constant ` B ` .  (Contributed by Mario
       Carneiro, 11-Jan-2015.) $)
    ixpconstg $p |- ( ( A e. V /\ B e. W ) -> X_ x e. A B = ( B ^m A ) ) $=
      ( vf wcel cixp cmap co wceq wa cab mapvalg vex elixpconst abbi2i syl6reqr
      cv wf ancoms ) CEGZBDGZABCHZCBIJZKUBUCLUEBCFSZTZFMUDCBEDFNUGFUDABCUFFOPQR
      UA $.

    ixpconst.1 $e |- A e. _V $.
    ixpconst.2 $e |- B e. _V $.
    $( Infinite Cartesian product of a constant ` B ` .  (Contributed by NM,
       28-Sep-2006.) $)
    ixpconst $p |- X_ x e. A B = ( B ^m A ) $=
      ( cvv wcel cixp cmap co wceq ixpconstg mp2an ) BFGCFGABCHCBIJKDEABCFFLM
      $.
  $}

  ${
    $d f x A $.  $d f x B $.  $d f C $.
    $( Equality theorem for infinite Cartesian product.  (Contributed by NM,
       29-Sep-2006.) $)
    ixpeq1 $p |- ( A = B -> X_ x e. A C = X_ x e. B C ) $=
      ( vf wceq cv wfn cfv wcel wral wa cixp fneq2 raleq anbi12d abbidv 3eqtr4g
      cab dfixp ) BCFZEGZBHZAGUBIDJZABKZLZESUBCHZUDACKZLZESABDMACDMUAUFUIEUAUCU
      GUEUHBCUBNUDABCOPQABDETACDETR $.

    ixpeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for infinite Cartesian product.  (Contributed by Mario
       Carneiro, 11-Jun-2016.) $)
    ixpeq1d $p |- ( ph -> X_ x e. A C = X_ x e. B C ) $=
      ( wceq cixp ixpeq1 syl ) ACDGBCEHBDEHGFBCDEIJ $.
  $}

  ${
    $d f A $.  $d f B $.  $d f C $.  $d f x $.
    $( Subclass theorem for infinite Cartesian product.  (Contributed by NM,
       29-Sep-2006.)  (Revised by Mario Carneiro, 12-Aug-2016.) $)
    ss2ixp $p |- ( A. x e. A B C_ C -> X_ x e. A B C_ X_ x e. A C ) $=
      ( vf wss wral cv wcel cab wfn cfv cixp ssel ral2imi anim2d ss2abdv df-ixp
      wa 3sstr4g ) CDFZABGZEHZAHZBIAJKZUDUCLZCIZABGZSZEJUEUFDIZABGZSZEJABCMABDM
      UBUIULEUBUHUKUEUAUGUJABCDUFNOPQABCERABDERT $.
  $}

  $( Equality theorem for infinite Cartesian product.  (Contributed by NM,
     29-Sep-2006.) $)
  ixpeq2 $p |- ( A. x e. A B = C -> X_ x e. A B = X_ x e. A C ) $=
    ( wss wral wa cixp wceq ss2ixp anim12i eqss ralbii r19.26 bitri 3imtr4i ) C
    DEZABFZDCEZABFZGZABCHZABDHZEZUCUBEZGCDIZABFZUBUCIRUDTUEABCDJABDCJKUGQSGZABF
    UAUFUHABCDLMQSABNOUBUCLP $.

  ${
    $d x ph $.
    ixpeq2dva.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Equality theorem for infinite Cartesian product.  (Contributed by Mario
       Carneiro, 11-Jun-2016.) $)
    ixpeq2dva $p |- ( ph -> X_ x e. A B = X_ x e. A C ) $=
      ( wceq wral cixp ralrimiva ixpeq2 syl ) ADEGZBCHBCDIBCEIGAMBCFJBCDEKL $.
  $}

  ${
    $d x ph $.
    ixpeq2dv.1 $e |- ( ph -> B = C ) $.
    $( Equality theorem for infinite Cartesian product.  (Contributed by Mario
       Carneiro, 11-Jun-2016.) $)
    ixpeq2dv $p |- ( ph -> X_ x e. A B = X_ x e. A C ) $=
      ( wceq cv wcel adantr ixpeq2dva ) ABCDEADEGBHCIFJK $.
  $}

  ${
    $d f x y w $.  $d f x y z $.  $d A f x y $.  $d B f w $.  $d C f z $.
    cbvixp.1 $e |- F/_ y B $.
    cbvixp.2 $e |- F/_ x C $.
    cbvixp.3 $e |- ( x = y -> B = C ) $.
    $( Change bound variable in an indexed Cartesian product.  (Contributed by
       Jeff Madsen, 20-Jun-2011.) $)
    cbvixp $p |- X_ x e. A B = X_ y e. A C $=
      ( vf cv wfn cfv wcel wral wa cab cixp nfel2 weq dfixp fveq2 cbvral anbi2i
      eleq12d abbii 3eqtr4i ) IJZCKZAJZUGLZDMZACNZOZIPUHBJZUGLZEMZBCNZOZIPACDQB
      CEQUMURIULUQUHUKUPABCBUJDFRAUOEGRABSUJUODEUIUNUGUAHUDUBUCUEACDITBCEITUF
      $.
  $}

  ${
    $d A x y f $.  $d B y f z $.  $d C x f z $.
    cbvixpv.1 $e |- ( x = y -> B = C ) $.
    $( Change bound variable in an indexed Cartesian product.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    cbvixpv $p |- X_ x e. A B = X_ y e. A C $=
      ( nfcv cbvixp ) ABCDEBDGAEGFH $.
  $}

  ${
    $d x z $.  $d y z $.  $d A z $.  $d B z $.
    nfixp.1 $e |- F/_ y A $.
    nfixp.2 $e |- F/_ y B $.
    $( Bound-variable hypothesis builder for indexed cross product.
       (Contributed by Mario Carneiro, 15-Oct-2016.) $)
    nfixp $p |- F/_ y X_ x e. A B $=
      ( vz cixp cv wcel cab wfn cfv wa wnfc wtru wal a1i nfeld trud wral df-ixp
      nfcv nftru wn nfcvf adantl nfabd2 nffn wi df-ral nffvd nfimd nfald2 nfxfr
      weq wnf nfan nfab nfcxfr ) BACDHGIZAIZCJZAKZLZVBVAMZDJZACUAZNZGKACDGUBVIB
      GVEVHBBVDVABVAUCZBVDOPVCBAAUDZPBAUPBQUEZNZBVBCVLBVBOPBAUFUGZBCOVMERSZUHTU
      IVHVCVGUJZAQZBVGACUKVQBUQPVPBAVKVMVCVGBVOVMBVFDVMBVBVABVAOVMVJRVNULBDOVMF
      RSUMUNTUOURUSUT $.
  $}

  ${
    $d x y $.  $d A y $.  $d B y $.
    $( The index variable in an indexed cross product is not free.
       (Contributed by Jeff Madsen, 19-Jun-2011.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nfixp1 $p |- F/_ x X_ x e. A B $=
      ( vy cixp cv wcel cab wfn cfv wral df-ixp nfcv nfab1 nffn nfra1 nfan nfab
      wa nfcxfr ) AABCEDFZAFZBGZAHZIZUBUAJCGZABKZSZDHABCDLUHADUEUGAAUDUAAUAMUCA
      NOUFABPQRT $.
  $}

  ${
    $d f x A $.  $d f B $.
    $( A cartesian product of proper-class many sets is empty, because any
       function in the cartesian product has to be a set with domain ` A ` ,
       which is not possible for a proper class domain.  (Contributed by Mario
       Carneiro, 25-Jan-2015.) $)
    ixpprc $p |- ( -. A e. _V -> X_ x e. A B = (/) ) $=
      ( vf cixp c0 wceq cvv wcel wn cv wex neq0 wfn cdm fndm vex dmex syl6eqelr
      ixpfn syl exlimiv sylbi con1i ) ABCEZFGZBHIZUFJDKZUEIZDLUGDUEMUIUGDUIUHBN
      ZUGABCUHTUJBUHOHBUHPUHDQRSUAUBUCUD $.
  $}

  ${
    $d f x y A $.  $d f y B $.  $d x y F $.  $d f C $.
    $( A member of an infinite Cartesian product maps to the indexed union of
       the product argument.  Remark in [Enderton] p. 54.  (Contributed by NM,
       28-Sep-2006.) $)
    ixpf $p |- ( F e. X_ x e. A B -> F : A --> U_ x e. A B ) $=
      ( cixp wcel cvv wfn cv cfv wral w3a ciun wf elixp2 wa ssiun2 ralimia nfcv
      sseld anim2i nfiu1 ffnfvf sylibr 3adant1 sylbi ) DABCEFDGFZDBHZAIZDJZCFZA
      BKZLBABCMZDNZABCDOUHULUNUGUHULPUHUJUMFZABKZPUNULUPUHUKUOABUIBFCUMUJABCQTR
      UAABUMDABSABCUBADSUCUDUEUF $.

    $( The union of an infinite Cartesian product is included in a cross
       product.  (Contributed by NM, 28-Sep-2006.)  (Revised by Mario Carneiro,
       24-Jun-2015.) $)
    uniixp $p |- U. X_ x e. A B C_ ( A X. U_ x e. A B ) $=
      ( vf cixp ciun cxp cpw wss cuni cv wcel wf ixpf fssxp syl vex elpw sylibr
      ssriv sspwuni mpbi ) ABCEZBABCFZGZHZIUCJUEIDUCUFDKZUCLZUGUEIZUGUFLUHBUDUG
      MUIABCUGNBUDUGOPUGUEDQRSTUCUEUAUB $.

    $( The existence of an infinite Cartesian product. ` x ` is normally a
       free-variable parameter in ` B ` .  Remark in Enderton p. 54.
       (Contributed by NM, 28-Sep-2006.)  (Revised by Mario Carneiro,
       25-Jan-2015.) $)
    ixpexg $p |- ( A. x e. A B e. V -> X_ x e. A B e. _V ) $=
      ( cvv wcel wral cixp cuni ciun cxp wss uniixp iunexg xpexg syldan sylancr
      wa ssexg uniexb sylibr wn c0 ixpprc 0ex syl6eqel adantr pm2.61ian ) BEFZC
      DFABGZABCHZEFZUIUJRZUKIZEFZULUMUNBABCJZKZLUQEFZUOABCMUIUJUPEFURABCEDNBUPE
      EOPUNUQESQUKTUAUIUBZULUJUSUKUCEABCUDUEUFUGUH $.

    $( The intersection of two infinite Cartesian products.  (Contributed by
       Mario Carneiro, 3-Feb-2015.) $)
    ixpin $p |- X_ x e. A ( B i^i C ) = ( X_ x e. A B i^i X_ x e. A C ) $=
      ( vf cin cixp cv wfn wcel wral wa anandi elin ralbii r19.26 bitri 3bitr4i
      cfv elixp anbi2i vex anbi12i eqriv ) EABCDFZGZABCGZABDGZFZEHZBIZAHUJSZUEJ
      ZABKZLZUJUGJZUJUHJZLZUJUFJUJUIJUKULCJZABKZULDJZABKZLZLUKUTLZUKVBLZLUOURUK
      UTVBMUNVCUKUNUSVALZABKVCUMVFABULCDNOUSVAABPQUAUPVDUQVEABCUJEUBZTABDUJVGTU
      CRABUEUJVGTUJUGUHNRUD $.
  $}

  ${
    $d f x y A $.  $d f x y B $.  $d f C $.
    $( The indexed intersection of a collection of infinite Cartesian
       products.  (Contributed by Mario Carneiro, 6-Feb-2015.) $)
    ixpiin $p |- ( B =/= (/) ->
      X_ x e. A |^|_ y e. B C = |^|_ y e. B X_ x e. A C ) $=
      ( vf c0 cixp ciin cv wcel wral wa cvv wb eliin ax-mp elixp ralbii bitri
      wne wfn cfv r19.28zv vex fvex ralcom anbi2i 3bitr4g eqrdv eqcomd ) DGUAZB
      DACEHZIZACBDEIZHZULFUNUPULFJZCUBZAJZUQUCZEKZACLZMZBDLZURVBBDLZMZUQUNKZUQU
      PKZURVBBDUDVGUQUMKZBDLZVDUQNKVGVJOFUEZBUQDUMNPQVIVCBDACEUQVKRSTVHURUTUOKZ
      ACLZMVFACUOUQVKRVMVEURVMVABDLZACLVEVLVNACUTNKVLVNOUSUQUFBUTDENPQSVAABCDUG
      TUHTUIUJUK $.

    $( The intersection of a collection of infinite Cartesian products.
       (Contributed by Mario Carneiro, 3-Feb-2015.) $)
    ixpint $p |- ( B =/= (/) -> X_ x e. A |^| B = |^|_ y e. B X_ x e. A y ) $=
      ( c0 wne cint cixp cv ciin wceq ixpeq2 wcel intiin a1i mprg ixpiin syl5eq
      ) DEFACDGZHZACBDBIZJZHZBDACUAHJSUBKZTUCKACACSUBLUDAICMBDNOPABCDUAQR $.
  $}

  ${
    $d f x $.  $d f A $.
    $( An infinite Cartesian product with an empty index set.  (Contributed by
       NM, 21-Sep-2007.) $)
    ixp0x $p |- X_ x e. (/) A = { (/) } $=
      ( vf c0 cixp cv wfn cfv wcel wral wa cab csn dfixp wceq elsn ral0 biantru
      fn0 3bitr2i abbi2i eqtr4i ) ADBECFZDGZAFUCHBIZADJZKZCLDMZADBCNUGCUHUCUHIU
      CDOUDUGCDPUCSUFUDUEAQRTUAUB $.
  $}

  ${
    $d A f x $.  $d B f $.  $d C f $.  $d V f $.
    $( An infinite Cartesian product is a subset of set exponentiation.  This
       version of ~ ixpssmapg avoids ~ ax-rep .  (Contributed by Mario
       Carneiro, 16-Nov-2014.) $)
    ixpssmap2g $p |- ( U_ x e. A B e. V ->
        X_ x e. A B C_ ( U_ x e. A B ^m A ) ) $=
      ( vf ciun wcel cixp cmap co cv wa wf ixpf adantl cvv wb c0 wceq n0i nsyl2
      ixpprc elmapg sylan2 mpbird ex ssrdv ) ABCFZDGZEABCHZUHBIJZUIEKZUJGZULUKG
      ZUIUMLUNBUHULMZUMUOUIABCULNOUMUIBPGZUNUOQUMUJRSUPUJULTABCUBUAUHBULDPUCUDU
      EUFUG $.

    $( An infinite Cartesian product is a subset of set exponentiation.
       (Contributed by Jeff Madsen, 19-Jun-2011.) $)
    ixpssmapg $p |- ( A. x e. A B e. V ->
        X_ x e. A B C_ ( U_ x e. A B ^m A ) ) $=
      ( vf wcel wral cixp ciun cmap co cv wa cvv wss c0 wceq n0i ixpprc nsyl2
      id iunexg syl2anr ixpssmap2g syl simpr sseldd ex ssrdv ) CDFABGZEABCHZABC
      IZBJKZUJELZUKFZUNUMFUJUOMZUKUMUNUPULNFZUKUMOUOBNFZUJUQUJUOUKPQURUKUNRABCS
      TUJUAABCNDUBUCABCNUDUEUJUOUFUGUHUI $.
  $}

  $( Membership of the empty set in an infinite Cartesian product.
     (Contributed by Steve Rodriguez, 29-Sep-2006.) $)
  0elixp $p |- (/) e. X_ x e. (/) A $=
    ( c0 csn cixp 0ex snid ixp0x eleqtrri ) CCDACBECFGABHI $.

  ${
    $d f A $.  $d f B $.  $d f x $.
    $( The infinite Cartesian product of a family ` B ( x ) ` with an empty
       member is empty.  The converse of this theorem is equivalent to the
       Axiom of Choice, see ~ ac9 .  (Contributed by Mario Carneiro,
       22-Jun-2016.) $)
    ixpn0 $p |- ( X_ x e. A B =/= (/) -> A. x e. A B =/= (/) ) $=
      ( vf cixp c0 wne cv wcel wex wral n0 cfv cab wfn wa df-ixp abeq2i simprbi
      ne0i ralimi syl exlimiv sylbi ) ABCEZFGDHZUEIZDJCFGZABKZDUELUGUIDUGAHZUFM
      ZCIZABKZUIUGUFUJBIANOZUMUNUMPDUEABCDQRSULUHABCUKTUAUBUCUD $.

    $( The infinite Cartesian product of a family ` B ( x ) ` with an empty
       member is empty.  The converse of this theorem is equivalent to the
       Axiom of Choice, see ~ ac9 .  (Contributed by NM, 1-Oct-2006.)  (Proof
       shortened by Mario Carneiro, 22-Jun-2016.) $)
    ixp0 $p |- ( E. x e. A B = (/) -> X_ x e. A B = (/) ) $=
      ( c0 wceq wrex wne wral wn cixp rexbii rexnal bitr3i ixpn0 necon1bi sylbi
      nne ) CDEZABFZCDGZABHZIZABCJZDESTIZABFUBUDRABCDQKTABLMUAUCDABCNOP $.
  $}

  ${
    $d f x A $.  $d f B $.
    ixpssmap.2 $e |- B e. _V $.
    $( An infinite Cartesian product is a subset of set exponentation.  Remark
       in [Enderton] p. 54.  (Contributed by NM, 28-Sep-2006.) $)
    ixpssmap $p |- X_ x e. A B C_ ( U_ x e. A B ^m A ) $=
      ( cvv wcel wral cixp ciun cmap co wss rgenw ixpssmapg ax-mp ) CEFZABGABCH
      ABCIBJKLPABDMABCENO $.
  $}

  ${
    $d A x $.  $d B x $.  $d F x $.
    $( Restriction of an element of an infinite Cartesian product.
       (Contributed by FL, 7-Nov-2011.)  (Proof shortened by Mario Carneiro,
       31-May-2014.) $)
    resixp $p |- ( ( B C_ A /\ F e. X_ x e. A C )
       -> ( F |` B ) e. X_ x e. B C ) $=
      ( wss cixp wcel wa cres cvv wfn cfv wral resexg adantl w3a simpr elixp2
      cv sylib simp2d simpl fnssres syl2anc simp3d ssralv eleq1d ralbiia sylibr
      sylc fvres syl3anbrc ) CBFZEABDGZHZIZECJZKHZURCLZATZURMZDHZACNZURACDGHUPU
      SUNECUOOPUQEBLZUNUTUQEKHZVEVAEMZDHZABNZUQUPVFVEVIQUNUPRABDESUAZUBUNUPUCZB
      CEUDUEUQVHACNZVDUQUNVIVLVKUQVFVEVIVJUFVHACBUGUKVCVHACVACHVBVGDVACEULUHUIU
      JACDURSUM $.
  $}

  ${
    $d A x $.  $d B x $.  $d F x $.  $d G x $.
    $( Union of two projections of a cartesian product.  (Contributed by FL,
       7-Nov-2011.) $)
    undifixp $p |-
    ( ( F e. X_ x e. B C /\ G e. X_ x e. ( A \ B ) C /\ B C_ A )
        -> ( F u. G ) e. X_ x e. A C ) $=
      ( cixp wcel cun wfn wral wi wa c0 wceq sylancl syl syl5com wn eqcoms cdif
      wss w3a cvv cfv unexg 3adant3 ixpfn cin 3simpa ancomd disjdif fnun biimpi
      cv undif eqcomd 3ad2ant3 fneq2d mpbird 3exp 3imp cdm fndm elndif wb eleq2
      notbid ndmfv syl6bi syl2im ralrimiv elixp2 simp3bi uneq2 un0 eleq1 biimpd
      eqtr com12 ral2imi impcom eldifn uneq1 uncom imp ralunb sylanbrc ex raleq
      imbi2d syl5ibr sylbi com3l wfun df-fn anim12i ineq12 syl6eq ad2ant2l fvun
      simpl syl2anc eleq1d ralbidv syl3anbrc ) EACDGZHZFABCUAZDGZHZCBUBZUCZEFIZ
      UDHZXNBJZAUOZXNUEZDHZABKZXNABDGHXHXKXOXLEFXGXJUFUGXHXKXLXPXHECJZXKXLXPLZA
      CDEUHZXKFXIJZYAYBLAXIDFUHZYDYAXLXPYDYAXLUCZXPXNCXIIZJZYFYAYDMCXIUIZNOYHYF
      YDYAYDYAXLUJUKCBULZCXIEFUMPYFBYGXNXLYDBYGOZYAXLYGBXLYGBOZCBUPZUNUQURUSUTV
      AQRVBXMXTXQEUEZXQFUEZIZDHZABKZXHXKXLYRXLXHXKYRXLYLXHXKYRLZLZYMYTBYGXHYSYK
      XKYQAYGKZLXHXKUUAXHXKMYQACKZYQAXIKZUUAXKXHUUBXKYDXHUUBLYEYDYONOZACKZXHUUB
      YDUUDACYDFVCZXIOZXQCHZXQXIHZSZUUDXIFVDXQCBVEUUGUUJXQUUFHZSZUUDUUJUULVFXIU
      UFXIUUFOUUIUUKXIUUFXQVGVHTXQFVIVJVKVLXHYNDHZACKZUUEUUBLXHEUDHYAUUNACDEVMV
      NUUMUUDYQACUUDUUMYQUUDYPYNNIZOZUUOYNOZUUMYQLZYONYNVOYNVPUUPUUQMYPYNOUURYP
      UUOYNVSUURYNYPYNYPOUUMYQYNYPDVQVRTQPVTWAQRQWBXHXKUUCXHYAXKUUCLYCYAYNNOZAX
      IKZXKUUCYAUUSAXIYAEVCZCOZUUIUUHSZUUSCEVDXQBCWCUVCUUSLCUVACUVAOZUVCXQUVAHZ
      SUUSUVDUUHUVECUVAXQVGVHXQEVIVJTVKVLXKYODHZAXIKZUUTUUCLXKFUDHYDUVGAXIDFVMV
      NUVFUUSYQAXIUUSUVFYQUUSYPNYOIZOZUVHYONIZOZUVFYQLZYNNYOWDNYOWEUVIUVKMYPUVJ
      OZUVJYOOZUVLYPUVHUVJVSYOVPUVMUVNMYPYOOUVLYPUVJYOVSUVLYOYPYOYPOUVFYQYOYPDV
      QVRTQPPVTWAQRQWFYQACXIWGWHWIYKYRUUAXKYQABYGWJWKWLTWMWNVBXHXKXLXTYRVFZXHYA
      XKXLUVOLZYCXKYDYAUVPLZYEYDFWOZUUGMZUVQFXIWPYAUVSUVPYAEWOZUVBMZUVSUVPLECWP
      UWAUVSXLUVOUWAUVSXLUCZXSYQABUWBXRYPDUWBUVTUVRMZUVAUUFUIZNOZXRYPOUWAUVSUWC
      XLUWAUVTUVSUVRUVTUVBXBUVRUUGXBWQUGUWAUVSUWEXLUVBUUGUWEUVTUVRUVBUUGMUWDYIN
      UVACUUFXIWRYJWSWTUGXQEFXAXCXDXEVAWMVTWMQRVBUTABDXNVMXF $.
  $}

  ${
    $d I x y z $.  $d J y z $.  $d K y z $.
    $( Condition for an explicit member of an indexed product.  (Contributed by
       Stefan O'Rear, 4-Jan-2015.) $)
    mptelixpg $p |- ( I e. V -> ( ( x e. I |-> J ) e. X_ x e. I K <->
          A. x e. I J e. K ) ) $=
      ( vy wcel cvv cmpt cixp wral wb elex cv cfv wa fvmpt2 ralimiaa wi syl wfn
      csb w3a nfcv nfcsb1v csbeq1a cbvixp eleq2i elixp2 3anass eqid fnmpt simpr
      3bitri eqeltrd jca dffn2 fmpt eleq1d biimpd ralim sylbir sylbi imp impbii
      wf nfv nffvmpt1 nfel weq fveq2 eleq12d cbvral anbi2i bitri mptexg syl5rbb
      biantrurd syl5bb ) BEGBHGZABCIZABDJZGZCDGZABKZLBEMWCWAHGZWABUAZFNZWAOZAWH
      DUBZGZFBKZPZPZVTWEWCWAFBWJJZGWFWGWLUCWNWBWOWAAFBDWJFDUDAWHDUEZAWHDUFZUGUH
      FBWJWAUIWFWGWLUJUNWEWMVTWNWEWGANZWAOZDGZABKZPZWMWEXBWEWGXAABCWADWAUKZULWD
      WTABWRBGZWDPWSCDABCDWAXCQXDWDUMUORUPWGXAWEWGBHWAVFZXAWESZBWAUQXECHGZABKZX
      FABHCWAXCURXHWTWDSZABKXFXGXIABXDXGPZWTWDXJWSCDABCHWAXCQUSUTRWTWDABVATVBVC
      VDVEXAWLWGWTWKAFBWTFVGAWIWJABCWHVHWPVIAFVJWSWIDWJWRWHWAVKWQVLVMVNVOVTWFWM
      ABCHVPVRVQVST $.
  $}

  ${
    $d f g h x y z A $.  $d f g h x y z B $.  $d f g h y C $.  $d g h y F $.
    resixpfo.1 $e |- F = ( f e. X_ x e. A C |-> ( f |` B ) ) $.
    $( Restriction of elements of an infinite Cartesian product creates a
       surjection, if the original Cartesian product is nonempty.  (Contributed
       by Mario Carneiro, 27-Aug-2015.) $)
    resixpfo $p |- ( ( B C_ A /\ X_ x e. A C =/= (/) ) ->
        F : X_ x e. A C -onto-> X_ x e. B C ) $=
      ( vh vy vg vz wa cv cfv wceq wral wcel cmpt wi cvv wss cixp c0 wne wf wfo
      wrex cres resixp fmptd adantr wex cif eleq1 ifbid fveq12d cbvmptv wfn vex
      n0 id elixp simprbi fveq1 eleq1d simpl imp simplrr ifbothda exp32 ralimi2
      wn syl adantl ralim sylan2 wb n0i ixpprc mptelixpg mpbird syl5eqel iftrue
      nsyl2 fveq1d mpteq2ia resmpt ad2antrr ixpfn ad2antlr dffn5 sylib syl6eqel
      3eqtr4a reseq1 fvmptg syl2anc eqtr2d fveq2 eqeq2d rspcev ralrimdva syl5bi
      ex exlimdv dffo3 sylanbrc ) CBUAZABDUBZUCUDZLXIACDUBZFUEZHMZIMZFNZOZIXIUG
      ZHXKPZXIXKFUFXHXLXJXHEXIEMZCUHZXKFABCDXSUIGUJUKXHXJXRXJJMZXIQZJULXHXRJXIU
      TXHYBXRJXHYBXQHXKXHXMXKQZLZYBXQYDYBLZKBKMZYFCQZXMYAUMZNZRZXIQZXMYJFNZOZXQ
      YEYJABAMZYNCQZXMYAUMZNZRZXIKABYIYQYFYNOZYFYNYHYPYSYGYOXMYAYFYNCUNUOYSVAUP
      UQYEYRXIQZYQDQZABPZYBYDYNYANZDQZABPZUUBYBYABURUUEABDYAJUSVBVCYDUUEUUBYDUU
      DUUASZABPZUUEUUBSYCUUGXHYCYNXMNZDQZACPZUUGYCXMCURZUUJACDXMHUSZVBVCUUIUUFA
      CBYOUUISZYNBQZUUDUUAYOUUIUUDUUAUUMUUNUUDLZLZXMYAXMYPOUUHYQDYNXMYPVDVEYAYP
      OUUCYQDYNYAYPVDVEUUPYOUUIUUMUUOVFVGUUMUUNUUDYOVLVHVIVJVKVMVNUUDUUAABVOVMV
      GVPYEBTQZYTUUBVQYBUUQYDYBXIUCOUUQXIYAVRABDVSWDVNABYQDTVTVMWAWBZYEYLYJCUHZ
      XMYEYKUUSTQYLUUSOUURYEUUSXMTYEKCYIRZKCYFXMNZRZUUSXMKCYIUVAYGYFYHXMYGXMYAW
      CWEWFXHUUSUUTOYCYBKBCYIWGWHYEUUKXMUVBOYCUUKXHYBACDXMWIWJKCXMWKWLWNZUULWME
      YJXTUUSXITFXSYJCWOGWPWQUVCWRXPYMIYJXIXNYJOXOYLXMXNYJFWSWTXAWQXDXBXEXCVGIH
      XIXKFXFXG $.
  $}

  ${
    $d B x y z w $.  $d F x y z w $.  $d A x y z w $.  $d V x y z w $.
    $( Membership in a class of singleton functions.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    elixpsn $p |- ( A e. V -> ( F e. X_ x e. { A } B <->
        E. y e. B F = { <. A , y >. } ) ) $=
      ( vz vw cv csn cixp wcel cop wceq wrex cvv cfv wa vex eleq1d sneq ixpeq1d
      eleq2d opeq1 sneqd eqeq2d elex snex eleq1 mpbiri rexlimivw eqeq1 wfn wral
      rexbidv elixp fveq2 ralsn anbi2i simpl biimpri adantl ffnfv sylanbrc fsn2
      wf sylib opeq2 rspcev syl fvsn id syl5eqel fnsn jctil fneq1 fveq1 anbi12d
      syl5ibrcom rexlimiv impbii 3bitri vtoclbg pm5.21nii ) EAGIZJZDKZLZEWEBIZM
      ZJZNZBDOZEACJZDKZLECWIMZJZNZBDOGCFWECNZWGWOEWSAWFWNDWECUAUBUCWSWLWRBDWSWK
      WQEWSWJWPWECWIUDUEUFUOWHEPLZWMEWGUGWLWTBDWLWTWKPLWJUHEWKPUIUJUKHIZWGLZXAW
      KNZBDOZWHWMHEPXAEWGUIXAENXCWLBDXAEWKULUOXBXAWFUMZAIZXAQZDLZAWFUNZRXEWEXAQ
      ZDLZRZXDAWFDXAHSUPXIXKXEXHXKAWEGSZXFWENXGXJDXFWEXAUQTURUSXLXDXLXKXAWEXJMZ
      JZNZRZXDXLWFDXAVFZXQXLXEWIXAQZDLZBWFUNZXRXEXKUTXKYAXEYAXKXTXKBWEXMWIWENXS
      XJDWIWEXAUQTURVAVBBWFDXAVCVDWEDXAXMVEVGXCXPBXJDWIXJNZWKXOXAYBWJXNWIXJWEVH
      UEUFVIVJXCXLBDWIDLZXLXCWKWFUMZWEWKQZDLZRYCYFYDYCYEWIDWEWIXMBSZVKYCVLVMWEW
      IXMYGVNVOXCXEYDXKYFWFXAWKVPXCXJYEDWEXAWKVQTVRVSVTWAWBWCWDWC $.
  $}

  ${
    $d I a b c x y $.  $d A a b c x y $.  $d V a b c x y $.  $d F a b c y $.
    $d W a b c x y $.  $d X x c $.
    ixpsnf1o.f $e |- F = ( x e. A |-> ( { I } X. { x } ) ) $.
    $( A bijection between a class and single-point functions to it.
       (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    ixpsnf1o $p |- ( I e. V -> F : A -1-1-onto-> X_ y e. { I } A ) $=
      ( va vb vc wcel csn cv crn cuni cvv wa vex wceq eqeq2d cixp cxp snex xpex
      a1i rnex uniex cop wrex sneq xpeq1d anbi2d elixpsn ixpeq1d eleq2d syl5bbr
      ax-mp anbi1d xpsn eqeq2i anbi2i eqid weq opeq2 sneqd rspcev op2nda eqcomi
      wb mpan2 jctir eqeq1 rexbidv unieqd anbi12d syl5ibrcom imp wi eqidd ancli
      rneq eleq1 syl5bi imbi12d rexlimiv impbii bitri vtoclbg f1od ) EFKZAHCBEL
      ZCUAZWKAMZLZUBZHMZNZOZDPPGWOPKWJWMCKZQWKWNEUCWMUCUDUEWRPKWJWPWLKZQWQWPHRU
      FUGUEWSWPIMZLZWNUBZSZQZWPXAJMZUHZLZSZJCUIZWMWRSZQZWSWPWOSZQWTXKQIEFXAESZX
      DXMWSXNXCWOWPXNXBWKWNXAEUJZUKTULXNXJWTXKXJWPBXBCUAZKZXNWTXAPKXQXJVIIRZBJX
      ACWPPUMUQXNXPWLWPXNBXBWKCXOUNUOUPURXEWSWPXAWMUHZLZSZQZXLXDYAWSXCXTWPXAWMX
      RARZUSUTVAYBXLWSYAXLWSXLYAXTXHSZJCUIZWMXTNZOZSZQWSYEYHWSXTXTSZYEXTVBYDYIJ
      WMCJAVCZXHXTXTYJXGXSXFWMXAVDVETVFVJYGWMXAWMXRYCVGVHVKYAXJYEXKYHYAXIYDJCWP
      XTXHVLVMYAWRYGWMYAWQYFWPXTWAVNTVOVPVQXJXKYBXIXKYBVRZJCXFCKZYKXIWMXHNZOZSZ
      WSXHXTSZQZVRYOAJVCZYLYQYNXFWMXAXFXRJRVGUTYLYQYRYLXHXHSZQYLYSYLXHVSVTYRWSY
      LYPYSWMXFCWBYRXTXHXHYRXSXGWMXFXAVDVETVOVPWCXIXKYOYBYQXIWRYNWMXIWQYMWPXHWA
      VNTXIYAYPWSWPXHXTVLULWDVPWEVQWFWGWHWI $.

    $( A bijection between a set and single-point functions to it.
       (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    mapsnf1o $p |- ( ( A e. V /\ I e. W ) ->
        F : A -1-1-onto-> ( A ^m { I } ) ) $=
      ( vy wcel wa csn cmap co wf1o cixp ixpsnf1o adantl wceq wb cvv eqcomd syl
      snex ixpconstg mpan adantr f1oeq3 mpbird ) BEIZDFIZJZBBDKZLMZCNZBHULBOZCN
      ZUJUPUIAHBCDFGPQUKUMUORZUNUPSUIUQUJULTIZUIUQDUCURUIJUOUMHULBTEUDUAUEUFUMU
      OBCUGUBUH $.
  $}

  ${
    $d A y z $.  $d B y z $.  $d I x y z $.
    $( A rectangular subset of a rectangular set can be recovered as the
       relative intersection of single-axis restrictions.  (Contributed by
       Stefan O'Rear, 22-Feb-2015.) $)
    boxriin $p |- ( A. x e. I A C_ B -> X_ x e. I A = ( X_ x e. I B i^i
            |^|_ y e. I X_ x e. I if ( x = y , A , B ) ) ) $=
      ( vz wral cixp weq cv wcel wa wi ral2imi adantr impr eleq2 jca elixp cvv
      wss cif ciin cin wfn simprl ssel simplr wn ssel2 ifbothda ralrimivw jca31
      ex simprll simpr ralimi ralcom wceq iftrue equcoms eleq2d rspcva ralimiaa
      cfv sylbi syl ad2antll impbida elin wb eliin ax-mp ralbii anbi12i 3bitr4g
      vex bitri eqrdv ) CDUAZAEGZFAECHZAEDHZBEAEABIZCDUBZHZUCZUDZWAFJZEUEZAJZWI
      VEZCKZAEGZLZWJWLDKZAEGZLZWJWLWEKZAEGZLZBEGZLZWIWBKWIWHKZWAWOXCWAWOLZWJWQX
      BWAWJWNUFZWAWJWNWQWAWNWQMWJVTWMWPAECDWLUGNOPXEXABEXEWJWTXFWAWJWNWTWAWNWTM
      WJVTWMWSAEVTWMWSWDWMWPWSVTWMLZCDCWEWLQDWEWLQVTWMWDUHXGWPWDUICDWLUJOUKUNNO
      PRULUMWAXCLWJWNWAWJWQXBUOXBWNWAWRXBWTBEGZWNXAWTBEWJWTUPUQXHWSBEGZAEGWNWSB
      AEEURXIWMAEWSWMBWKEBAIWECWLWECUSABWDCDUTVAVBVCVDVFVGVHRVIAECWIFVQZSXDWIWC
      KZWIWGKZLXCWIWCWGVJXKWRXLXBAEDWIXJSXLWIWFKZBEGZXBWITKXLXNVKXJBWIEWFTVLVMX
      MXABEAEWEWIXJSVNVRVOVRVPVS $.
  $}

  ${
    $d A k l m z $.  $d B l m n z $.  $d C l m n z $.  $d X k l m n z $.
    $( The relative complement of a box set restricted on one axis.
       (Contributed by Stefan O'Rear, 22-Feb-2015.) $)
    boxcutc $p |- ( ( X e. A /\ A. k e. A C C_ B ) ->
        ( X_ k e. A B \ X_ k e. A if ( k = X , C , B ) ) =
          X_ k e. A if ( k = X , ( B \ C ) , B ) ) $=
      ( vl vm wcel wss wral wa cv cif cdif wn cfv csb eleq2 nfv eleq12d vz cixp
      wceq eldifi adantl sseq1 difss ssid keephyp rgenw ss2ixp sselda wfn ixpfn
      mp1i biantrurd vex elixp syl6rbbr notbid wrex simpl simprbi nfcsb1v nfel2
      rexnal fveq2 csbeq1a cbvral csbeq1 rspcva syl2an neldif adantr syl5ibrcom
      sylib sylan ad2antlr r19.21bi ifbothda ralrimiva dfral2 ex con4d difeq12d
      weq simplll simpll iftrue eqtrd eldifbd rspcev syl2anc impbida nfif eqeq1
      imp nfn ifbieq12d cbvrex nfdif 3bitr4g syl5bbr bitrd wb ibar eldif eqrdav
      3bitr3d ) EAHZCBIDAJZKZUADABUBZDADLZEUCZCBMZUBZNZDAXOBCNZBMZUBZXMUALZXRHZ
      YBXMHZXLYBXMXQUDUEXLYAXMYBXTBIZDAJYAXMIXLYEDAXOXSBIBBIYEXSBXSXTBUFBXTBUFB
      CUGBUHUIUJDAXTBUKUOULXLYDKZYDYBXQHZOZKZYBAUMZXNYBPZXTHZDAJZKZYCYBYAHYFYHY
      MYIYNYFYHYKXPHZDAJZOZYMYFYGYPYFYPYJYPKYGYFYJYPYDYJXLDABYBUNUEZUPDAXPYBUAU
      QZURUSUTYQYOOZDAVAZYFYMYODAVFYFFLZYBPZUUBEUCZDUUBCQZDUUBBQZMZHZOZFAVAZGLZ
      YBPZUUKEUCZDUUKBQZDUUKCQZNZUUNMZHZGAJZUUAYMYFUUJUUSYFUUJKZUURGAUUMUULUUPH
      ZUULUUNHZUURUUTUUKAHZKZUUPUUNUUPUUQUULRUUNUUQUULRUVDUUMUVAUVDUVAUUMEYBPZD
      EBQZDECQZNZHZUUTUVIUVCYFUUJUVIYFUVIUUJYFUVIOZUUJOZYFUVJKZUUHFAJUVKUVLUUHF
      AUUDUUCUUEHZUUCUUFHZUUHUVLUUBAHZKZUUEUUFUUEUUGUUCRUUFUUGUUCRUVPUUDUVMUVPU
      VMUUDUVEUVGHZUVLUVQUVOYFUVEUVFHZUVJUVQXLXJUVNFAJZUVRYDXJXKVBYDYKBHZDAJZUV
      SYDYJUWADABYBYSURVCZUVTUVNDFAUVTFSDUUCUUFDUUBBVDZVEDFWFZYKUUCBUUFXNUUBYBV
      GZDUUBBVHZTVIVPZUVNUVRFEAUUDUUCUVEUUFUVFUUBEYBVGZDUUBEBVJTVKVLUVEUVFUVGVM
      VQVNUUDUUCUVEUUEUVGUWHDUUBECVJZTVOWQUVPUVNUUDOUVLUVNFAYDUVSXLUVJUWGVRVSVN
      VTWAUUHFAWBVPWCWDWQVNUUMUULUVEUUPUVHUUKEYBVGZUUMUUNUVFUUOUVGDUUKEBVJDUUKE
      CVJWEZTVOWQUVDUVBUUMOUUTUVBGAYDUVBGAJZXLUUJYDUWAUWLUWBUVTUVBDGAUVTGSDUULU
      UNDUUKBVDZVEDGWFZYKUULBUUNXNUUKYBVGZDUUKBVHZTVIVPVRVSVNVTWAYFUUSKZXJUVQOZ
      UUJXJXKYDUUSWGUWQUVEUVFUVGYFXJUUSUVIXJXKYDWHUURUVIGEAUUMUULUVEUUQUVHUWJUU
      MUUQUUPUVHUUMUUPUUNWIUWKWJTVKVQWKUUIUWRFEAUUDUUHUVQUUDUUCUVEUUGUVGUWHUUDU
      UGUUEUVGUUDUUEUUFWIUWIWJTUTWLWMWNYTUUIDFAYTFSUUHDDUUCUUGUUDDUUEUUFUUDDSDU
      UBCVDUWCWOVEWRUWDYOUUHUWDYKUUCXPUUGUWEUWDXOUUDCBUUEUUFXNUUBEWPDUUBCVHUWFW
      STUTWTYLUURDGAYLGSDUULUUQUUMDUUPUUNUUMDSDUUNUUOUWMDUUKCVDXAUWMWOVEUWNYKUU
      LXTUUQUWOUWNXOUUMXSBUUPUUNXNUUKEWPUWNBUUNCUUOUWPDUUKCVHWEUWPWSTVIXBXCXDYD
      YHYIXEXLYDYHXFUEYFYJYMYRUPXIYBXMXQXGDAXTYBYSURXBXH $.
  $}

$(
  @{
    xpixp.1 @e |- P = X_ x e. { (/) , 1o } if ( x = (/) , A , B ) @.
    xpixp.1 @e |- P = X_ x e. 2o if ( x = (/) , A , B ) @.
    xpixp.1 @e |- P =
               X_ x e. { (/) , 1o } ( { <. (/) , A >. , <. 1o , B >. } ` x ) @.
    @( A cross product in terms of an infinite Cartesian product. @)
    xpixp @p |- ( A X. B ) =
                ( ran ( U. P |` { (/) } ) X. ran ( U. P |` { 1o } ) ) @=
?@.
      @( [ ?] @) @( [29-Sep-2006] @)
  @}

  @{
    ixpxp.1 @e |- P = ( A X. B ) @.
    @( An infinite Cartesian product in terms of a cross product. @)
    ixpxp @p |- X_ x e. { (/) , 1o } if ( x = (/) , A , B ) =
                { ( { (/) } X. dom P ) , ( { 1o } X. ran P ) } @=
?@.
      @( [ ?] @) @( [29-Sep-2006] @)
  @}
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Equinumerosity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  $( Introduce new constant symbols. $)
  $c ~~ $.  $( Equinumerosity relation ("approximately equals" symbol) $)
  $c ~<_ $.  $( Dominance relation (curly less-than-or-equal) $)
  $c ~< $.  $( Strict dominance relation (curly less-than) $)
  $c Fin $.  $( Class of all finite sets. $)

  $( Extend class definition to include the equinumerosity relation
     ("approximately equals" symbol) $)
  cen $a class ~~ $.

  $( Extend class definition to include the dominance relation (curly
     less-than-or-equal) $)
  cdom $a class ~<_ $.

  $( Extend class definition to include the strict dominance relation (curly
     less-than) $)
  csdm $a class ~< $.

  $( Extend class definition to include the class of all finite sets. $)
  cfn $a class Fin $.

  ${
    $d x y f $.
    $( Define the equinumerosity relation.  Definition of [Enderton] p. 129.
       We define ` ~~ ` to be a binary relation rather than a connective, so
       its arguments must be sets to be meaningful.  This is acceptable because
       we do not consider equinumerosity for proper classes.  We derive the
       usual definition as ~ bren .  (Contributed by NM, 28-Mar-1998.) $)
    df-en $a |- ~~ = { <. x , y >. | E. f f : x -1-1-onto-> y } $.

    $( Define the dominance relation.  For an alternate definition see
       ~ dfdom2 .  Compare Definition of [Enderton] p. 145.  Typical textbook
       definitions are derived as ~ brdom and ~ domen .  (Contributed by NM,
       28-Mar-1998.) $)
    df-dom $a |- ~<_ = { <. x , y >. | E. f f : x -1-1-> y } $.

    $( Define the strict dominance relation.  Alternate possible definitions
       are derived as ~ brsdom and ~ brsdom2 .  Definition 3 of [Suppes]
       p. 97.  (Contributed by NM, 31-Mar-1998.) $)
    df-sdom $a |- ~< = ( ~<_ \ ~~ ) $.

    $( Define the (proper) class of all finite sets.  Similar to Definition
       10.29 of [TakeutiZaring] p. 91, whose "Fin(a)" corresponds to
       our " ` a e. Fin ` ".  This definition is meaningful whether or not we
       accept the Axiom of Infinity ~ ax-inf2 .  If we accept Infinity, we can
       also express ` A e. Fin ` by ` A ~< om ` (theorem ~ isfinite .)
       (Contributed by NM, 22-Aug-2008.) $)
    df-fin $a |- Fin = { x | E. y e. om x ~~ y } $.
  $}

  ${
    $d x y f $.  $d x y f $.
    $( Equinumerosity is a relation.  (Contributed by NM, 28-Mar-1998.) $)
    relen $p |- Rel ~~ $=
      ( vx vy vf cv wf1o wex cen df-en relopabi ) ADBDCDECFABGABCHI $.

    $( Dominance is a relation.  (Contributed by NM, 28-Mar-1998.) $)
    reldom $p |- Rel ~<_ $=
      ( vx vy vf cv wf1 wex cdom df-dom relopabi ) ADBDCDECFABGABCHI $.
  $}

  $( Strict dominance is a relation.  (Contributed by NM, 31-Mar-1998.) $)
  relsdom $p |- Rel ~< $=
    ( cdom wrel csdm reldom cen cdif reldif df-sdom releqi sylibr ax-mp ) ABZCB
    ZDLAEFZBMAEGCNHIJK $.

  ${
    $d f x y A $.  $d f x y B $.  $d y C $.
    $( Equinumerosity relation.  (Contributed by NM, 15-Jun-1998.) $)
    bren $p |- ( A ~~ B <-> E. f f : A -1-1-onto-> B ) $=
      ( vx vy cen wbr cvv wcel wa cv wf1o wex wrel brrelex12 syl6eqelr syl wceq
      relen exbidv mpan wfn f1ofn cdm fndm vex dmex crn wfo f1ofo forn rnex jca
      exlimiv f1oeq2 f1oeq3 df-en brabg pm5.21nii ) ABFGZAHIZBHIZJZABCKZLZCMZFN
      UTVCSABFOUAVEVCCVEVAVBVEVDAUBZVAABVDUCVGAVDUDHAVDUEVDCUFZUGPQVEBVDUHZHVEA
      BVDUIVIBRABVDUJABVDUKQVDVHULPUMUNDKZEKZVDLZCMAVKVDLZCMVFDEABHHFVJARVLVMCV
      JAVKVDUOTVKBRVMVECVKBAVDUPTDECUQURUS $.

    $( Dominance relation.  (Contributed by NM, 15-Jun-1998.) $)
    brdomg $p |- ( B e. C -> ( A ~<_ B <-> E. f f : A -1-1-> B ) ) $=
      ( vx vy cvv wcel cdom wbr cv wf1 wex wb wi wceq f1eq2 exbidv f1eq3 df-dom
      brabg ex wn reldom brrelexi wf f1f cdm fdm vex dmex syl6eqelr syl exlimiv
      pm5.21ni a1d pm2.61i ) AGHZBCHZABIJZABDKZLZDMZNZOURUSVDEKZFKZVALZDMAVFVAL
      ZDMVCEFABGCIVEAPVGVHDVEAVFVAQRVFBPVHVBDVFBAVASREFDTUAUBURUCVDUSUTURVCABIU
      DUEVBURDVBABVAUFZURABVAUGVIAVAUHGABVAUIVADUJUKULUMUNUOUPUQ $.

    $( Dominance relation.  (Contributed by Mario Carneiro, 26-Apr-2015.) $)
    brdomi $p |- ( A ~<_ B -> E. f f : A -1-1-> B ) $=
      ( cdom wbr cv wf1 wex cvv wcel wb reldom brrelex2i brdomg syl ibi ) ABDEZ
      ABCFGCHZQBIJQRKABDLMABICNOP $.
  $}

  ${
    $d f x y A $.  $d f x y B $.  $d f w x y z $.
    bren.1 $e |- B e. _V $.
    $( Dominance relation.  (Contributed by NM, 15-Jun-1998.) $)
    brdom $p |- ( A ~<_ B <-> E. f f : A -1-1-> B ) $=
      ( cvv wcel cdom wbr cv wf1 wex wb brdomg ax-mp ) BEFABGHABCIJCKLDABECMN
      $.

    $( Dominance in terms of equinumerosity.  Example 1 of [Enderton] p. 146.
       (Contributed by NM, 15-Jun-1998.) $)
    domen $p |- ( A ~<_ B <-> E. x ( A ~~ x /\ x C_ B ) ) $=
      ( vf cdom wbr cv wf1 wex cen wss brdom wf1o vex f11o exbii bitri bitr4i
      wa excom bren anbi1i 19.41v ) BCFGBCEHZIZEJZBAHZKGZUHCLZTZAJZBCEDMUGBUHUE
      NZUJTZEJZAJZULUGUNAJZEJUPUFUQEABCUEEOPQUNEAUARUKUOAUKUMEJZUJTUOUIURUJBUHE
      UBUCUMUJEUDSQSR $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Dominance in terms of equinumerosity, with the sethood requirement
       expressed as an antecedent.  Example 1 of [Enderton] p. 146.
       (Contributed by NM, 24-Apr-2004.) $)
    domeng $p |- ( B e. C -> ( A ~<_ B <-> E. x ( A ~~ x /\ x C_ B ) ) ) $=
      ( vy cv cdom wbr cen wss wex breq2 wceq sseq2 anbi2d exbidv domen vtoclbg
      wa vex ) BEFZGHBAFZIHZUBUAJZSZAKBCGHUCUBCJZSZAKECDUACBGLUACMZUEUGAUHUDUFU
      CUACUBNOPABUAETQR $.
  $}

  ${
    $d f A $.  $d f B $.  $d f F $.
    $( The domain and range of a one-to-one, onto function are equinumerous.
       This variation of ~ f1oeng does not require the Axiom of Replacement.
       (Contributed by NM, 13-Jan-2007.)  (Revised by Mario Carneiro,
       10-Sep-2015.) $)
    f1oen3g $p |- ( ( F e. V /\ F : A -1-1-onto-> B ) -> A ~~ B ) $=
      ( vf wcel wf1o wa cv wex cen wbr f1oeq1 spcegv imp bren sylibr ) CDFZABCG
      ZHABEIZGZEJZABKLRSUBUASECDABTCMNOABEPQ $.

    $( The domain and range of a one-to-one, onto function are equinumerous.
       This variation of ~ f1oeng does not require the Axiom of Replacement.
       (Contributed by Mario Carneiro, 10-Sep-2015.) $)
    f1oen2g $p |- ( ( A e. V /\ B e. W /\ F : A -1-1-onto-> B ) -> A ~~ B ) $=
      ( wcel wf1o w3a cvv cen wbr f1of fex2 syl3an1 3coml simp3 f1oen3g syl2anc
      wf ) ADFZBEFZABCGZHCIFZUBABJKUBTUAUCUBABCSTUAUCABCLABCDEMNOTUAUBPABCIQR
      $.

    $( The domain of a one-to-one function is dominated by its codomain.  This
       variation of ~ f1domg does not require the Axiom of Replacement.
       (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    f1dom2g $p |- ( ( A e. V /\ B e. W /\ F : A -1-1-> B ) -> A ~<_ B ) $=
      ( vf wcel wf1 w3a cdom wbr cv wex cvv wf f1f fex2 syl3an1 3coml simp3 wb
      f1eq1 spcegv sylc brdomg 3ad2ant2 mpbird ) ADGZBEGZABCHZIZABJKZABFLZHZFMZ
      UKCNGZUJUOUJUHUIUPUJABCOUHUIUPABCPABCDEQRSUHUIUJTUNUJFCNABUMCUBUCUDUIUHUL
      UOUAUJABEFUEUFUG $.

    $( The domain and range of a one-to-one, onto function are equinumerous.
       (Contributed by NM, 19-Jun-1998.) $)
    f1oeng $p |- ( ( A e. C /\ F : A -1-1-onto-> B ) -> A ~~ B ) $=
      ( wcel wf1o cvv cen wbr wfo f1ofo fornex syl5 imp f1oen2g 3com23 mpd3an3
      ) ACEZABDFZBGEZABHIZRSTSABDJRTABDKABCDLMNRTSUAABDCGOPQ $.

    $( The domain of a one-to-one function is dominated by its codomain.
       (Contributed by NM, 4-Sep-2004.) $)
    f1domg $p |- ( B e. C -> ( F : A -1-1-> B -> A ~<_ B ) ) $=
      ( vf wcel wf1 cv wex cdom wbr cvv f1dmex wf f1f sylan syldan expcom f1eq1
      fex spcegv syli brdomg sylibrd ) BCFZABDGZABEHZGZEIZABJKUFUEDLFZUIUFUEUJU
      FUEALFZUJABCDMUFABDNUKUJABDOABLDTPQRUHUFEDLABUGDSUAUBABCEUCUD $.
  $}

  ${
    f1oen.1 $e |- A e. _V $.
    $( The domain and range of a one-to-one, onto function are equinumerous.
       (Contributed by NM, 19-Jun-1998.) $)
    f1oen $p |- ( F : A -1-1-onto-> B -> A ~~ B ) $=
      ( cvv wcel wf1o cen wbr f1oeng mpan ) AEFABCGABHIDABECJK $.
  $}

  ${
    f1dom.1 $e |- B e. _V $.
    $( The domain of a one-to-one function is dominated by its codomain.
       (Contributed by NM, 19-Jun-1998.) $)
    f1dom $p |- ( F : A -1-1-> B -> A ~<_ B ) $=
      ( cvv wcel wf1 cdom wbr wi f1domg ax-mp ) BEFABCGABHIJDABECKL $.
  $}

  $( Strict dominance relation, meaning " ` B ` is strictly greater in size
     than ` A ` ."  Definition of [Mendelson] p. 255.  (Contributed by NM,
     25-Jun-1998.) $)
  brsdom $p |- ( A ~< B <-> ( A ~<_ B /\ -. A ~~ B ) ) $=
    ( cop csdm wcel cdom cen cdif wbr wn wa df-sdom eleq2i df-br notbii anbi12i
    eldif bitr4i 3bitr4i ) ABCZDETFGHZEZABDIABFIZABGIZJZKZDUATLMABDNUFTFEZTGEZJ
    ZKUBUCUGUEUIABFNUDUHABGNOPTFGQRS $.

  ${
    $d x y f A $.
    $( Express " ` A ` is finite."  Definition 10.29 of [TakeutiZaring] p. 91
       (whose " ` Fin ` " is a predicate instead of a class).  (Contributed by
       NM, 22-Aug-2008.) $)
    isfi $p |- ( A e. Fin <-> E. x e. om A ~~ x ) $=
      ( vy cfn wcel cen wbr com wrex cab df-fin eleq2i relen brrelexi rexlimivw
      cv cvv wceq breq1 rexbidv elab3 bitri ) BDEBCPZAPZFGZAHIZCJZEBUDFGZAHIZDU
      GBCAKLUFUICBUHBQEAHBUDFMNOUCBRUEUHAHUCBUDFSTUAUB $.

    $( Equinumerosity implies dominance.  (Contributed by NM, 31-Mar-1998.) $)
    enssdom $p |- ~~ C_ ~<_ $=
      ( vx vy vf cen cdom relen cop wf1o wex copab wcel wf1 f1of1 eximi 3imtr4i
      cv opabid df-en eleq2i df-dom relssi ) ABDEFAPZBPZGZUBUCCPZHZCIZABJZKZUDU
      BUCUELZCIZABJZKZUDDKUDEKUGUKUIUMUFUJCUBUCUEMNUGABQUKABQODUHUDABCRSEULUDAB
      CTSOUA $.
  $}

  $( Alternate definition of dominance.  (Contributed by NM, 17-Jun-1998.) $)
  dfdom2 $p |- ~<_ = ( ~< u. ~~ ) $=
    ( cen csdm cun cdom cdif df-sdom uncom wss wceq enssdom undif mpbi 3eqtr3ri
    uneq2i ) ABCADAEZCZBACDBOAFNABGADHPDIJADKLM $.

  $( Equinumerosity implies dominance.  Theorem 15 of [Suppes] p. 94.
     (Contributed by NM, 28-May-1998.) $)
  endom $p |- ( A ~~ B -> A ~<_ B ) $=
    ( cen cdom enssdom ssbri ) CDABEF $.

  $( Strict dominance implies dominance.  (Contributed by NM, 10-Jun-1998.) $)
  sdomdom $p |- ( A ~< B -> A ~<_ B ) $=
    ( csdm wbr cdom cen wn brsdom simplbi ) ABCDABEDABFDGABHI $.

  $( Strict dominance implies non-equinumerosity.  (Contributed by NM,
     10-Jun-1998.) $)
  sdomnen $p |- ( A ~< B -> -. A ~~ B ) $=
    ( csdm wbr cdom cen wn brsdom simprbi ) ABCDABEDABFDGABHI $.

  $( Dominance in terms of strict dominance and equinumerosity.  Theorem 22(iv)
     of [Suppes] p. 97.  (Contributed by NM, 17-Jun-1998.) $)
  brdom2 $p |- ( A ~<_ B <-> ( A ~< B \/ A ~~ B ) ) $=
    ( cop cdom wcel csdm cen cun wbr wo dfdom2 eleq2i df-br orbi12i elun bitr4i
    3bitr4i ) ABCZDERFGHZEZABDIABFIZABGIZJZDSRKLABDMUCRFEZRGEZJTUAUDUBUEABFMABG
    MNRFGOPQ $.

  $( Equinumerosity expressed in terms of dominance and strict dominance.
     (Contributed by NM, 23-Oct-2004.) $)
  bren2 $p |- ( A ~~ B <-> ( A ~<_ B /\ -. A ~< B ) ) $=
    ( cen wbr cdom csdm wn endom sdomnen con2i jca brdom2 biimpi orcanai impbii
    wa wo ) ABCDZABEDZABFDZGZPRSUAABHTRABIJKSTRSTRQABLMNO $.

  $( Equinumerosity is reflexive.  Theorem 1 of [Suppes] p. 92.  (Contributed
     by NM, 18-Jun-1998.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
  enrefg $p |- ( A e. V -> A ~~ A ) $=
    ( wcel cen wbr cid cres wf1o f1oi f1oen2g mp3an3 anidms ) ABCZAADEZMMAAFAGZ
    HNAIAAOBBJKL $.

  ${
    enref.1 $e |- A e. _V $.
    $( Equinumerosity is reflexive.  Theorem 1 of [Suppes] p. 92.  (Contributed
       by NM, 25-Sep-2004.) $)
    enref $p |- A ~~ A $=
      ( cvv wcel cen wbr enrefg ax-mp ) ACDAAEFBACGH $.
  $}

  $( Equality implies equinumerosity.  (Contributed by NM, 26-Oct-2003.) $)
  eqeng $p |- ( A e. V -> ( A = B -> A ~~ B ) ) $=
    ( wcel cen wbr wceq enrefg breq2 syl5ibcom ) ACDAAEFABGABEFACHABAEIJ $.

  $( Dominance is reflexive.  (Contributed by NM, 18-Jun-1998.) $)
  domrefg $p |- ( A e. V -> A ~<_ A ) $=
    ( wcel cen wbr cdom enrefg endom syl ) ABCAADEAAFEABGAAHI $.

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d x y ph $.
    en2d.1 $e |- ( ph -> A e. _V ) $.
    en2d.2 $e |- ( ph -> B e. _V ) $.
    en2d.3 $e |- ( ph -> ( x e. A -> C e. _V ) ) $.
    en2d.4 $e |- ( ph -> ( y e. B -> D e. _V ) ) $.
    en2d.5 $e |- ( ph -> ( ( x e. A /\ y = C ) <-> ( y e. B /\ x = D ) ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function.
       (Contributed by NM, 27-Jul-2004.)  (Revised by Mario Carneiro,
       12-May-2014.) $)
    en2d $p |- ( ph -> A ~~ B ) $=
      ( cvv wcel cmpt wf1o cen wbr cv imp eqid f1od f1oen2g syl3anc ) ADMNEMNDE
      BDFOZPDEQRHIABCDEFGUEMMUEUAABSDNFMNJTACSENGMNKTLUBDEUEMMUCUD $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d x y ph $.
    en3d.1 $e |- ( ph -> A e. _V ) $.
    en3d.2 $e |- ( ph -> B e. _V ) $.
    en3d.3 $e |- ( ph -> ( x e. A -> C e. B ) ) $.
    en3d.4 $e |- ( ph -> ( y e. B -> D e. A ) ) $.
    en3d.5 $e |- ( ph -> ( ( x e. A /\ y e. B ) -> ( x = D <-> y = C ) ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function.
       (Contributed by NM, 27-Jul-2004.)  (Revised by Mario Carneiro,
       12-May-2014.) $)
    en3d $p |- ( ph -> A ~~ B ) $=
      ( cvv wcel cmpt wf1o cen cv imp wceq wbr eqid wa wb f1o2d f1oen2g syl3anc
      ) ADMNEMNDEBDFOZPDEQUAHIABCDEFGUHUHUBABRZDNZFENJSACRZENZGDNKSAUJULUCUIGTU
      KFTUDLSUEDEUHMMUFUG $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    en2i.1 $e |- A e. _V $.
    en2i.2 $e |- B e. _V $.
    en2i.3 $e |- ( x e. A -> C e. _V ) $.
    en2i.4 $e |- ( y e. B -> D e. _V ) $.
    en2i.5 $e |- ( ( x e. A /\ y = C ) <-> ( y e. B /\ x = D ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function.
       (Contributed by NM, 4-Jan-2004.) $)
    en2i $p |- A ~~ B $=
      ( cen wtru cvv wcel a1i cv wi wceq wa wbr wb en2d trud ) CDLUAMABCDEFCNOM
      GPDNOMHPAQZCOZENORMIPBQZDOZFNORMJPUFUGESTUHUEFSTUBMKPUCUD $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    en3i.1 $e |- A e. _V $.
    en3i.2 $e |- B e. _V $.
    en3i.3 $e |- ( x e. A -> C e. B ) $.
    en3i.4 $e |- ( y e. B -> D e. A ) $.
    en3i.5 $e |- ( ( x e. A /\ y e. B ) -> ( x = D <-> y = C ) ) $.
    $( Equinumerosity inference from an implicit one-to-one onto function.
       (Contributed by NM, 19-Jul-2004.) $)
    en3i $p |- A ~~ B $=
      ( cen wbr wtru cvv wcel a1i cv wi wceq wa wb en3d trud ) CDLMNABCDEFCOPNG
      QDOPNHQARZCPZEDPSNIQBRZDPZFCPSNJQUFUHUAUEFTUGETUBSNKQUCUD $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d y z C $.  $d x z D $.  $d x y ph $.
    dom2d.1 $e |- ( ph -> ( x e. A -> C e. B ) ) $.
    dom2d.2 $e |- ( ph -> ( ( x e. A /\ y e. A ) -> ( C = D <-> x = y ) ) ) $.
    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain.  (Contributed by NM,
       24-Jul-2004.) $)
    dom2lem $p |- ( ph -> ( x e. A |-> C ) : A -1-1-> B ) $=
      ( cv cfv wceq wi wral wcel wa imp anbi2d wb eqeq12d cmpt wf ralrimiv eqid
      wf1 fmpt sylib fvmpt2 adantll mpdan adantrr nfv nffvmpt1 nfeq1 nfim eleq1
      imbi1d anbi1d anidm syl6bb fveq2 adantr biimparc ex sylbird pm5.74d bitrd
      chvar adantrl biimpd sylbid ralrimivva nfmpt1 nfcv dff13f sylanbrc ) ADEB
      DFUAZUBZBJZVQKZCJZVQKZLZVSWALZMZCDNBDNDEVQUEAFEOZBDNVRAWFBDHUCBDEFVQVQUDZ
      UFUGAWEBCDDAVSDOZWADOZPZPZWCFGLZWDWKVTFWBGAWHVTFLZWIAWHPZWFWMAWHWFHQWHWFW
      MABDFEVQWGUHUIUJZUKAWIWBGLZWHWNWMMZAWIPZWPMZBCWRWPBWRBULBWBGBDFWAUMUNUOWD
      WQWRWMMWSWDWNWRWMWDWHWIAVSWADUPZRUQWDWRWMWPWDWRWKWMWPSZWDWJWIAWDWJWIWIPWI
      WDWHWIWIWTURWIUSUTRWDWKXAWDWKPVTWBFGWDWCWKVSWAVQVAVBWKWLWDAWJWLWDSIQZVCTV
      DVEVFVGWOVHVITWKWLWDXBVJVKVLBCDEVQBDFVMCVQVNVOVP $.

    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain.  (Contributed by NM,
       24-Jul-2004.)  (Revised by Mario Carneiro, 20-May-2013.) $)
    dom2d $p |- ( ph -> ( B e. R -> A ~<_ B ) ) $=
      ( cmpt wf1 wcel cdom wbr dom2lem f1domg syl5com ) ADEBDFKZLEHMDENOABCDEFG
      IJPDEHSQR $.

    dom3d.3 $e |- ( ph -> A e. V ) $.
    dom3d.4 $e |- ( ph -> B e. W ) $.
    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain.  (Contributed by Mario
       Carneiro, 20-May-2013.) $)
    dom3d $p |- ( ph -> A ~<_ B ) $=
      ( vz cdom wbr wf1 cvv wcel syl cv wex cmpt dom2lem f1f fex2 syl3anc f1eq1
      wf spcegv sylc wb brdomg mpbird ) ADEOPZDENUAZQZNUBZABDFUCZRSZDEUSQZURADE
      USUIZDHSEISZUTAVAVBABCDEFGJKUDZDEUSUETLMDEUSHIUFUGVDUQVANUSRDEUPUSUHUJUKA
      VCUOURULMDEINUMTUN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.
    dom2.1 $e |- ( x e. A -> C e. B ) $.
    dom2.2 $e |- ( ( x e. A /\ y e. A ) -> ( C = D <-> x = y ) ) $.
    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain. ` C ` and ` D ` can be
       read ` C ( x ) ` and ` D ( y ) ` , as can be inferred from their
       distinct variable conditions.  (Contributed by NM, 26-Oct-2003.) $)
    dom2 $p |- ( B e. V -> A ~<_ B ) $=
      ( wceq wcel cdom wbr wi eqid cv a1i wa wb dom2d ax-mp ) CCJZDGKCDLMNCOUBA
      BCDEFGAPZCKZEDKNUBHQUDBPZCKREFJUCUEJSNUBIQTUA $.

    $d x y V $.  $d x y W $.
    $( A mapping (first hypothesis) that is one-to-one (second hypothesis)
       implies its domain is dominated by its codomain. ` C ` and ` D ` can be
       read ` C ( x ) ` and ` D ( y ) ` , as can be inferred from their
       distinct variable conditions.  (Contributed by Mario Carneiro,
       20-May-2013.) $)
    dom3 $p |- ( ( A e. V /\ B e. W ) -> A ~<_ B ) $=
      ( wcel wa cv wi a1i wceq wb simpl simpr dom3d ) CGKZDHKZLZABCDEFGHAMZCKZE
      DKNUCIOUEBMZCKLEFPUDUFPQNUCJOUAUBRUAUBST $.
  $}

  ${
    $d x y $.
    $( Equality implies equinumerosity.  (Contributed by NM, 30-Apr-1998.)
       (Revised by Mario Carneiro, 15-Nov-2014.) $)
    idssen $p |- _I C_ ~~ $=
      ( vx vy cid cen reli cv wbr cop wcel weq vex ideq eqeng ax-mp sylbi df-br
      cvv wi 3imtr3i relssi ) ABCDEAFZBFZCGZUAUBDGZUAUBHZCIUEDIUCABJZUDUAUBBKLU
      AQIUFUDRAKUAUBQMNOUAUBCPUAUBDPST $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A set dominates its subsets.  Theorem 16 of [Suppes] p. 94.
       (Contributed by NM, 19-Jun-1998.)  (Revised by Mario Carneiro,
       24-Jun-2015.) $)
    ssdomg $p |- ( B e. V -> ( A C_ B -> A ~<_ B ) ) $=
      ( wss wcel cdom wbr wa cvv cid cres wf1 ssexg simpr wf ccnv wfun wfo wf1o
      ax-mp f1oi dff1o3 mpbi simpli fof fss mpan funi cnvi mpbir funres11 jctir
      funeqi df-f1 sylibr adantr f1dom2g syl3anc expcom ) ABDZBCEZABFGZUTVAHAIE
      VAABJAKZLZVBABCMUTVANUTVDVAUTABVCOZVCPQZHVDUTVEVFAAVCOZUTVEAAVCRZVGVHVFAA
      VCSVHVFHAUAAAVCUBUCUDAAVCUETAABVCUFUGJPZQZVFVJJQUHVIJUIUMUJAJUKTULABVCUNU
      OUPABVCICUQURUS $.
  $}

  ${
    $d f g x y z $.
    $( Equinumerosity is an equivalence relation.  (Contributed by NM,
       19-Mar-1998.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
    ener $p |- ~~ Er _V $=
      ( vx vy vz vf cvv cen wtru a1i wbr wf1o wex bren wcel vex f1oen2g mp3an12
      vg cv syl wa wrel relen ccnv f1ocnv exlimiv sylbi adantl eeanv ccom f1oco
      wer ancoms exlimivv sylbir syl2anb wb enref 2th iserd trud ) EFUKGABCEFFU
      AGUBHARZBRZFIZVBVAFIZGVCVAVBDRZJZDKVDVAVBDLVFVDDVFVBVAVEUCZJZVDVAVBVEUDVB
      EMVAEMZVHVDBNANZVBVAVGEEOPSUEUFUGVCVBCRZFIZTVAVKFIZGVCVAVBQRZJZQKZVBVKVEJ
      ZDKZVMVLVAVBQLVBVKDLVPVRTVOVQTZDKQKVMVOVQQDUHVSVMQDVSVAVKVEVNUIZJZVMVQVOW
      AVAVBVKVEVNUJULVIVKEMWAVMVJCNVAVKVTEEOPSUMUNUOUGVIVAVAFIZUPGVIWBVJVAVJUQU
      RHUSUT $.
  $}

  $( Symmetry of equinumerosity.  Theorem 2 of [Suppes] p. 92.  (Contributed by
     Mario Carneiro, 26-Apr-2015.) $)
  ensymb $p |- ( A ~~ B <-> B ~~ A ) $=
    ( cen wbr wb wtru cvv wer ener a1i ersymb trud ) ABCDBACDEFABCGGCHFIJKL $.

  $( Symmetry of equinumerosity.  Theorem 2 of [Suppes] p. 92.  (Contributed by
     NM, 26-Oct-2003.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
  ensym $p |- ( A ~~ B -> B ~~ A ) $=
    ( cen wbr ensymb biimpi ) ABCDBACDABEF $.

  ${
    ensymi.2 $e |- A ~~ B $.
    $( Symmetry of equinumerosity.  Theorem 2 of [Suppes] p. 92.  (Contributed
       by NM, 25-Sep-2004.) $)
    ensymi $p |- B ~~ A $=
      ( cen wbr ensym ax-mp ) ABDEBADECABFG $.
  $}

  ${
    ensymd.1 $e |- ( ph -> A ~~ B ) $.
    $( Symmetry of equinumerosity.  Deduction form of ~ ensym .  (Contributed
       by David Moews, 1-May-2017.) $)
    ensymd $p |- ( ph -> B ~~ A ) $=
      ( cen wbr ensym syl ) ABCEFCBEFDBCGH $.
  $}

  ${
    $d x y z f g h A $.  $d x y z f g B $.  $d x y z f g h C $.
    $( Transitivity of equinumerosity.  Theorem 3 of [Suppes] p. 92.
       (Contributed by NM, 9-Jun-1998.) $)
    entr $p |- ( ( A ~~ B /\ B ~~ C ) -> A ~~ C ) $=
      ( cen wbr wa wi wtru cvv wer ener a1i ertr trud ) ABDEBCDEFACDEGHABCDIIDJ
      HKLMN $.

    $( Transitivity of dominance relation.  Theorem 17 of [Suppes] p. 94.
       (Contributed by NM, 4-Jun-1998.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    domtr $p |- ( ( A ~<_ B /\ B ~<_ C ) -> A ~<_ C ) $=
      ( vx vy vz vg vf vh cdom reldom cv wbr wf1 wex vex brdom wa eeanv ccom
      f1co ancoms coex f1eq1 spcev syl sylibr exlimivv sylbir syl2anb vtoclr )
      DEFABCJKDLZELZJMULUMGLZNZGOZUMFLZHLZNZHOZULUQJMZUMUQJMULUMGEPQUMUQHFPZQUP
      UTRUOUSRZHOGOVAUOUSGHSVCVAGHVCULUQILZNZIOZVAVCULUQURUNTZNZVFUSUOVHULUMUQU
      RUNUAUBVEVHIVGURUNHPGPUCULUQVDVGUDUEUFULUQIVBQUGUHUIUJUK $.
  $}

  ${
    entri.1 $e |- A ~~ B $.
    entri.2 $e |- B ~~ C $.
    $( A chained equinumerosity inference.  (Contributed by NM,
       25-Sep-2004.) $)
    entri $p |- A ~~ C $=
      ( cen wbr entr mp2an ) ABFGBCFGACFGDEABCHI $.
  $}

  ${
    entr2i.1 $e |- A ~~ B $.
    entr2i.2 $e |- B ~~ C $.
    $( A chained equinumerosity inference.  (Contributed by NM,
       25-Sep-2004.) $)
    entr2i $p |- C ~~ A $=
      ( entri ensymi ) ACABCDEFG $.
  $}

  ${
    entr3i.1 $e |- A ~~ B $.
    entr3i.2 $e |- A ~~ C $.
    $( A chained equinumerosity inference.  (Contributed by NM,
       25-Sep-2004.) $)
    entr3i $p |- B ~~ C $=
      ( ensymi entri ) BACABDFEG $.
  $}

  ${
    entr4i.1 $e |- A ~~ B $.
    entr4i.2 $e |- C ~~ B $.
    $( A chained equinumerosity inference.  (Contributed by NM,
       25-Sep-2004.) $)
    entr4i $p |- A ~~ C $=
      ( ensymi entri ) ABCDCBEFG $.
  $}

  $( Transitivity of equinumerosity and dominance.  (Contributed by NM,
     7-Jun-1998.) $)
  endomtr $p |- ( ( A ~~ B /\ B ~<_ C ) -> A ~<_ C ) $=
    ( cen wbr cdom endom domtr sylan ) ABDEABFEBCFEACFEABGABCHI $.

  $( Transitivity of dominance and equinumerosity.  (Contributed by NM,
     7-Jun-1998.) $)
  domentr $p |- ( ( A ~<_ B /\ B ~~ C ) -> A ~<_ C ) $=
    ( cen wbr cdom endom domtr sylan2 ) BCDEABFEBCFEACFEBCGABCHI $.

  $( A one-to-one function's image under a subset of its domain is equinumerous
     to the subset.  (Contributed by Mario Carneiro, 15-May-2015.) $)
  f1imaeng $p |- ( ( F : A -1-1-> B /\ C C_ A /\ C e. V ) ->
    ( F " C ) ~~ C ) $=
    ( wf1 wss wcel w3a cima cen wbr cres wf1o f1ores f1oeng ancoms sylan 3impa
    wa ensymd ) ABDFZCAGZCEHZICDCJZUBUCUDCUEKLZUBUCTCUEDCMZNZUDUFABCDOUDUHUFCUE
    EUGPQRSUA $.

  $( A one-to-one function's image under a subset of its domain is equinumerous
     to the subset.  (This version of ~ f1imaen does not need ~ ax-reg .)
     (Contributed by Mario Carneiro, 16-Nov-2014.)  (Revised by Mario Carneiro,
     25-Jun-2015.) $)
  f1imaen2g $p |- ( ( ( F : A -1-1-> B /\ B e. V ) /\ ( C C_ A /\ C e. V ) ) ->
    ( F " C ) ~~ C ) $=
    ( wf1 wcel wa wss cima cvv cres wf1o cen wbr simprr simplr wf f1f crn ssexd
    imassrn frn syl5ss syl ad2antrr f1ores ad2ant2r f1oen2g syl3anc ensymd ) AB
    DFZBEGZHZCAIZCEGZHZHZCDCJZURUPUSKGCUSDCLZMZCUSNOUNUOUPPURUSBEULUMUQQULUSBIZ
    UMUQULABDRZVBABDSVCUSDTBDCUBABDUCUDUEUFUAULUOVAUMUPABCDUGUHCUSUTEKUIUJUK $.

  ${
    f1imaen.1 $e |- C e. _V $.
    $( A one-to-one function's image under a subset of its domain is
       equinumerous to the subset.  (Contributed by NM, 30-Sep-2004.) $)
    f1imaen $p |- ( ( F : A -1-1-> B /\ C C_ A ) -> ( F " C ) ~~ C ) $=
      ( wf1 wss cvv wcel cima cen wbr f1imaeng mp3an3 ) ABDFCAGCHIDCJCKLEABCDHM
      N $.
  $}

  ${
    $d f A $.
    $( The empty set is equinumerous only to itself.  Exercise 1 of
       [TakeutiZaring] p. 88.  (Contributed by NM, 27-May-1998.) $)
    en0 $p |- ( A ~~ (/) <-> A = (/) ) $=
      ( vf c0 cen wbr wceq cv wf1o wex bren ccnv f1ocnv f1o00 simprbi syl sylbi
      exlimiv 0ex enref breq1 mpbiri impbii ) ACDEZACFZUCACBGZHZBIUDACBJUFUDBUF
      CAUEKZHZUDACUELUHUGCFUDAUGMNOQPUDUCCCDECRSACCDTUAUB $.
  $}

  ${
    $d f A $.
    ensn1.1 $e |- A e. _V $.
    $( A singleton is equinumerous to ordinal one.  (Contributed by NM,
       4-Nov-2002.) $)
    ensn1 $p |- { A } ~~ 1o $=
      ( vf csn c0 c1o cen wbr cv wf1o wex cop 0ex f1osn snex f1oeq1 spcev ax-mp
      bren mpbir df1o2 breqtrri ) ADZEDZFGUCUDGHUCUDCIZJZCKZUCUDAELZDZJZUGAEBMN
      UFUJCUIUHOUCUDUEUIPQRUCUDCSTUAUB $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A singleton is equinumerous to ordinal one.  (Contributed by NM,
       23-Apr-2004.) $)
    ensn1g $p |- ( A e. V -> { A } ~~ 1o ) $=
      ( vx cv csn c1o cen wbr wceq sneq breq1d vex ensn1 vtoclg ) CDZEZFGHAEZFG
      HCABOAIPQFGOAJKOCLMN $.
  $}

  $( ` { A , A } ` has only one element.  (Contributed by FL, 15-Feb-2010.) $)
  enpr1g $p |- ( A e. V -> { A , A } ~~ 1o ) $=
    ( wcel cpr csn c1o cen dfsn2 ensn1g syl5eqbrr ) ABCAADAEFGAHABIJ $.

  ${
    $d x f y A $.  $d y ph $.
    $( A set is equinumerous to ordinal one iff it is a singleton.
       (Contributed by NM, 25-Jul-2004.) $)
    en1 $p |- ( A ~~ 1o <-> E. x A = { x } ) $=
      ( vf c1o cen wbr cv csn wceq wex wf1o df1o2 breq2i bren bitri crn syl 0ex
      c0 exlimiv ccnv cfv f1ocnv wfo f1ofo forn wf f1of wcel fsn2 simprbi rneqd
      rnsnop syl6eq eqtr3d fvex sneq eqeq2d spcev 3syl sylbi ensn1 breq1 mpbiri
      cop vex impbii ) BDEFZBAGZHZIZAJZVHBSHZCGZKZCJZVLVHBVMEFVPDVMBELMBVMCNOVO
      VLCVOVMBVNUAZKZBSVQUBZHZIZVLBVMVNUCVRVQPZBVTVRVMBVQUDWBBIVMBVQUEVMBVQUFQV
      RWBSVSVEHZPVTVRVQWCVRVMBVQUGZVQWCIZVMBVQUHWDVSBUIWESBVQRUJUKQULSVSRUMUNUO
      VKWAAVSSVQUPVIVSIVJVTBVIVSUQURUSUTTVAVKVHAVKVHVJDEFVIAVFVBBVJDEVCVDTVG $.

    $( A set is equinumerous to ordinal one iff it is a singleton.
       (Contributed by Mario Carneiro, 17-Jan-2015.) $)
    en1b $p |- ( A ~~ 1o <-> A = { U. A } ) $=
      ( vx c1o cen wbr cuni csn wceq cv wex en1 id unieq vex unisn syl6eq sneqd
      cvv wcel syl eqtr4d exlimiv sylbi syl6eqel uniexg ensn1g eqbrtrd impbii
      snex ) ACDEZAAFZGZHZUJABIZGZHZBJUMBAKUPUMBUPAUOULUPLUPUKUNUPUKUOFUNAUOMUN
      BNOPQUAUBUCUMAULCDUMLZUMUKRSZULCDEUMARSURUMAULRUQUKUIUDARUETUKRUFTUGUH $.

    $( Two ways to express "exactly one".  (Contributed by Stefan O'Rear,
       28-Oct-2014.) $)
    reuen1 $p |- ( E! x e. A ph <-> { x e. A | ph } ~~ 1o ) $=
      ( vy wreu crab cv csn wceq wex c1o cen wbr reusn en1 bitr4i ) ABCEABCFZDG
      HIDJQKLMABDCNDQOP $.

    $( Two ways to express "exactly one".  (Contributed by Stefan O'Rear,
       28-Oct-2014.) $)
    euen1 $p |- ( E! x ph <-> { x | ph } ~~ 1o ) $=
      ( cvv wreu crab c1o cen wbr weu cab reuen1 reuv rabab breq1i 3bitr3i ) AB
      CDABCEZFGHABIABJZFGHABCKABLPQFGABMNO $.

    $( Two ways to express " ` A ` has a unique element".  (Contributed by
       Mario Carneiro, 9-Apr-2015.) $)
    euen1b $p |- ( A ~~ 1o <-> E! x x e. A ) $=
      ( cv wcel weu cab c1o cen wbr euen1 abid2 breq1i bitr2i ) ACBDZAENAFZGHIB
      GHINAJOBGHABKLM $.
  $}

  ${
    $d x y f A $.
    $( A set that dominates ordinal 2 has at least 2 different members.
       (Contributed by NM, 25-Jul-2004.) $)
    2dom $p |- ( 2o ~<_ A -> E. x e. A E. y e. A -. x = y ) $=
      ( vf c2o cdom wbr c0 csn cpr cv wf1 wceq wn wrex cfv wcel ffvelrn sylancl
      notbid wex df2o2 breq1i brdomi sylbi wf f1f 0ex prid1 p0ex prid2 0nep0 wb
      neii f1fveq mpanr12 mtbiri eqeq1 eqeq2 rspc2ev syl3anc exlimiv syl ) ECFG
      ZHHIZJZCDKZLZDUAZAKZBKZMZNZBCOACOZVDVFCFGVIEVFCFUBUCVFCDUDUEVHVNDVHHVGPZC
      QZVEVGPZCQZVOVQMZNZVNVHVFCVGUFZHVFQZVPVFCVGUGZHVEUHUIZVFCHVGRSVHWAVEVFQZV
      RWCHVEUJUKZVFCVEVGRSVHVSHVEMZHVEULUNVHWBWEVSWGUMWDWFVFCHVEVGUOUPUQVMVTVOV
      KMZNABVOVQCCVJVOMVLWHVJVOVKURTVKVQMWHVSVKVQVOUSTUTVAVBVC $.
  $}

  ${
    $d x y z w F $.
    fundmen.1 $e |- F e. _V $.
    $( A function is equinumerous to its domain.  Exercise 4 of [Suppes]
       p. 98.  (Contributed by NM, 28-Jul-2004.)  (Revised by Mario Carneiro,
       15-Nov-2014.) $)
    fundmen $p |- ( Fun F -> dom F ~~ F ) $=
      ( vx vy vz vw cv cop cint cvv wcel a1i ex wi wa wceq wb wex vex adantl
      wfun cdm cfv dmex funfvop wrel funrel elreldm syl cxp df-rel sylib sselda
      wss elvv inteq inteqd op1stb syl6eq eqeq1 syl5ibr opeq1 syl6 imp biimprcd
      eqeq2 ancoms eleq1d funopfv adantr sylbid exp32 com24 imp43 opeq2d eqtr4d
      mpd exlimdvv adantrl fvex syl6req impbid1 en3d ) AUAZCDAUBZACGZWFAUCZHZDG
      ZIZIZWEJKWDABUDLAJKWDBLWDWFWEKZWHAKWFAUEMWDAUFZWIAKZWKWEKZNAUGZWMWNWOAWIU
      HMUIWDWLWNOZWFWKPZWIWHPZQWDWQOWRWSWDWNWRWSNZWLWDWNOZWIEGZFGZHZPZFRERZWTXA
      WIJJUJZKXFWDAXGWIWDWMAXGUNWPAUKULUMEFWIUOULXAXEWTEFXAXEWRWSXAXEWROZOZWIWF
      XCHZWHXHWIXJPZXAWRXEXKWRXEOZXJXDPZXKWRXEXMWRXEWFXBPZXMXEXNWRWKXBPXEWKXDIZ
      IXBXEWJXOWIXDUPUQXBXCESFSURUSWFWKXBUTVAWFXBXCVBVCVDXEXMXKNWRXMXKXEXJXDWIV
      FVETVQZVGTXIWGXCWFWDWNXEWRWGXCPZWDWRXEWNXQWDWRXEWNXQNWDXLOWNXJAKZXQXLWNXR
      QWDXLWIXJAXPVHTWDXRXQNXLWFXCAVIVJVKVLVMVNVOVPVLVRVQVSWSWKWHIZIWFWSWJXSWIW
      HUPUQWFWGCSWFAVTURWAWBMWC $.
  $}

  ${
    $d x A $.  $d x F $.
    $( A function is equinumerous to its domain.  Exercise 4 of [Suppes]
       p. 98.  (Contributed by NM, 17-Sep-2013.) $)
    fundmeng $p |- ( ( F e. V /\ Fun F ) -> dom F ~~ F ) $=
      ( vx wcel wfun cdm cen wbr cv wceq funeq dmeq breq12d imbi12d vex fundmen
      wi id vtoclg imp ) ABDAEZAFZAGHZCIZEZUDFZUDGHZQUAUCQCABUDAJZUEUAUGUCUDAKU
      HUFUBUDAGUDALUHRMNUDCOPST $.

    $( A relational set is equinumerous to its converse.  (Contributed by Mario
       Carneiro, 28-Dec-2014.) $)
    cnven $p |- ( ( Rel A /\ A e. V ) -> A ~~ `' A ) $=
      ( vx wrel wcel wa ccnv cvv csn cuni cmpt wf1o cen wbr simpr cnvexg adantl
      cv cnvf1o adantr f1oen2g syl3anc ) ADZABEZFUDAGZHEZAUECACRIGJKZLZAUEMNUCU
      DOUDUFUCABPQUCUHUDCASTAUEUGBHUAUB $.
  $}

  $( A function is equinumerate to its domain.  (Contributed by Paul Chapman,
     22-Jun-2011.) $)
  fndmeng $p |- ( ( F Fn A /\ A e. C ) -> A ~~ F ) $=
    ( wfn wcel wa cdm cen wbr wfun fnex fnfun adantr fundmeng syl2anc wb breq1d
    cvv fndm mpbid ) CADZABEZFZCGZCHIZACHIZUCCRECJZUEABCKUAUGUBACLMCRNOUAUEUFPU
    BUAUDACHACSQMT $.

  ${
    $d w y z A $.  $d w y z B $.
    mapsnen.1 $e |- A e. _V $.
    mapsnen.2 $e |- B e. _V $.
    $( Set exponentiation to a singleton exponent is equinumerous to its base.
       Exercise 4.43 of [Mendelson] p. 255.  (Contributed by NM, 17-Dec-2003.)
       (Revised by Mario Carneiro, 15-Nov-2014.) $)
    mapsnen $p |- ( A ^m { B } ) ~~ A $=
      ( vz vw vy csn cmap cv cfv cop cvv wcel a1i wceq wa wex wrex 3bitr2i ovex
      fvex snex mapsn abeq2i anbi1i r19.41v df-rex fveq1 vex fvsn syl6eq eqeq2d
      equcom syl6bb pm5.32i anass ancom exbii eleq1 opeq2 sneqd anbi12d ceqsexv
      co anbi2i 3bitri en2i ) EFABHZIVEZABEJZKZBFJZLZHZAVIIUACVLMNVKVJNZBVKUBOV
      OMNVMANZVNUCOVPVMVLPZQZGJZANZVKBVTLZHZPZVRQZQZGRZVTVMPZWAWDQZQZGRVQVKVOPZ
      QZVSWDGASZVRQWEGASWGVPWMVRWMEVJGABECDUDUEUFWDVRGAUGWEGAUHTWFWJGWFWAWDWHQZ
      QWIWHQWJWEWNWAWDVRWHWDVRVMVTPWHWDVLVTVMWDVLBWCKVTBVKWCUIBVTDGUJUKULUMFGUN
      UOUPVFWAWDWHUQWIWHURTUSWIWLGVMFUJWHWAVQWDWKVTVMAUTWHWCVOVKWHWBVNVTVMBVAVB
      UMVCVDVGVH $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y V $.
    $( Set exponentiation: ordinal 1 to any set is equinumerous to ordinal 1.
       Exercise 4.42(b) of [Mendelson] p. 255.  (Contributed by NM,
       17-Dec-2003.) $)
    map1 $p |- ( A e. V -> ( 1o ^m A ) ~~ 1o ) $=
      ( vx vy wcel c1o cmap co c0 csn cvv a1i df1o2 p0ex cv 0ex wceq wa syl6rbb
      wb cxp ovex eqeltri a1ii xpexg mpan2 a1d el1o oveq1i eleq2i elmapg syl5bb
      wf mpan fconst2 anbi12d ancom en2d ) ABEZCDFAGHZFIAIJZUAZUTKEUSFAGUBLFKEU
      SFVAKMNUCLUSCOZUTEZIKEPUDUSVBKEZDOZFEZUSVAKEZVENAVABKUEUFUGUSVGVCVBQZRVFI
      QZVDRVDVJRUSVGVJVIVDVGVJTUSVFUHLUSVDAVAVCUMZVIVDVCVAAGHZEZUSVKUTVLVCFVAAG
      MUIUJVHUSVMVKTNVAAVCKBUKUNULAIVCPUOSUPVJVDUQSUR $.

    $( Two singletons are equinumerous.  (Contributed by NM, 9-Nov-2003.) $)
    en2sn $p |- ( ( A e. C /\ B e. D ) -> { A } ~~ { B } ) $=
      ( wcel csn c1o cen wbr ensn1g ensymd entr syl2an ) ACEAFZGHIGBFZHINOHIBDE
      ZACJPOGBDJKNGOLM $.

    $( A singleton is finite.  (Contributed by NM, 4-Nov-2002.) $)
    snfi $p |- { A } e. Fin $=
      ( vx csn cfn wcel cv cen wbr com wrex cvv c1o ensn1g breq2 rspcev sylancr
      1onn wn c0 wceq snprc en0 peano1 mpan sylbir sylbi pm2.61i isfi mpbir ) A
      CZDEUJBFZGHZBIJZAKEZUMUNLIEUJLGHZUMQAKMULUOBLIUKLUJGNOPUNRUJSTZUMAUAUPUJS
      GHZUMUJUBSIEUQUMUCULUQBSIUKSUJGNOUDUEUFUGBUJUHUI $.

    $( The class of finite sets is a proper class.  (Contributed by Jeffrey
       Hankins, 3-Oct-2008.) $)
    fiprc $p |- Fin e/ _V $=
      ( vx vy cv csn wceq wex cab cvv wnel cfn snnex wcel wss snfi eleq1 mpbiri
      wn exlimiv abssi df-nel ssexg mpan con3i 3imtr4i ax-mp ) ACZBCZDZEZBFZAGZ
      HIZJHIZABKUKHLZQJHLZQULUMUOUNUKJMUOUNUJAJUIUFJLZBUIUPUHJLUGNUFUHJOPRSUKJH
      UAUBUCUKHTJHTUDUE $.

    $( Equinumerosity of union of disjoint sets.  Theorem 4 of [Suppes] p. 92.
       (Contributed by NM, 11-Jun-1998.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    unen $p |- ( ( ( A ~~ B /\ C ~~ D ) /\
  ( ( A i^i C ) = (/) /\ ( B i^i D ) = (/) ) ) -> ( A u. C ) ~~ ( B u. D ) ) $=
      ( vx vy cen wbr wa cin c0 wceq cun cv wf1o wex wi bren cvv vex eeanv wcel
      unex f1oun f1oen3g sylancr ex exlimivv sylbir syl2anb imp ) ABGHZCDGHZIAC
      JKLBDJKLIZACMZBDMZGHZULABENZOZEPZCDFNZOZFPZUNUQQZUMABERCDFRUTVCIUSVBIZFPE
      PVDUSVBEFUAVEVDEFVEUNUQVEUNIURVAMZSUBUOUPVFOUQURVAETFTUCABCDURVAUDUOUPVFS
      UEUFUGUHUIUJUK $.
  $}

  $( All decrements of a set are equinumerous.  (Contributed by Stefan O'Rear,
     19-Feb-2015.) $)
  difsnen $p |- ( ( X e. V /\ A e. X /\ B e. X ) ->
      ( X \ { A } ) ~~ ( X \ { B } ) ) $=
    ( wcel csn cdif cen wbr wceq cvv difexg enrefg syl wne cun c0 incom disjdif
    cin w3a 3ad2ant1 sneq difeq2d breq2d syl5ibcom imp wa simpl1 dif32 syl6breq
    4syl simpl3 simpl2 en2sn syl2anc eqtri unen syl22anc simpr eldifsn sylanbrc
    a1i necomd difsnid 3brtr3d pm2.61dane ) DCEZADEZBDEZUAZDAFZGZDBFZGZHIZABVKA
    BJZVPVKVMVMHIZVQVPVHVIVRVJVHVMKEZVRDVLCLZVMKMNUBVQVMVOVMHVQVLVNDABUCUDUEUFU
    GVKABOZUHZVMVNGZVNPZVOVLGZVLPZVMVOHWBWCWEHIVNVLHIZWCVNTZQJZWEVLTZQJZWDWFHIW
    BWCWCWEHWBVHVSWCKEWCWCHIVHVIVJWAUIVTVMVNKLWCKMULDVLVNUJUKWBVJVIWGVHVIVJWAUM
    ZVHVIVJWAUNZBADDUOUPWIWBWHVNWCTQWCVNRVNVMSUQVCWKWBWJVLWETQWEVLRVLVOSUQVCWCW
    EVNVLURUSWBBVMEZWDVMJWBVJBAOWNWLWBABVKWAUTZVDBDAVAVBVMBVENWBAVOEZWFVOJWBVIW
    AWPWMWOADBVAVBVOAVENVFVG $.

  ${
    $d A f x $.  $d B f x $.  $d C f x $.
    $( Dominance over a set with one element removed.  (Contributed by Stefan
       O'Rear, 19-Feb-2015.)  (Revised by Mario Carneiro, 24-Jun-2015.) $)
    domdifsn $p |- ( A ~< B -> A ~<_ ( B \ { C } ) ) $=
      ( vf vx csdm wbr wcel csn cdif wa cv cvv wb syl adantr adantl wn ad2antrr
      cdom wf1 wex sdomdom relsdom brrelex2i brdomg mpbid crn c0 wne wss wf f1f
      frn cen sdomnen wceq wf1o vex dff1o5 biimpri f1oen3g sylancr necon3bd mpd
      wi ex pssdifn0 syl2anc n0 sylib brrelexi difexg cin eldifn disjsn reldisj
      sylibr syldan f1dom2g syl3anc eldifi ad2antll simplr difsnen domentr expr
      f1ssr exlimdv exlimddv difsn breq2d mpbird pm2.61dan ) ABFGZCBHZABCIJZTGZ
      WOWPKZABDLZUAZWRDWOXADUBZWPWOABTGZXBABUCZWOBMHZXCXBNABFUDUEZABMDUFOUGPWSX
      AKZELZBWTUHZJZHZEUBZWRXGXJUIUJZXLXGXIBUKZXIBUJZXMXAXNWSXAABWTULXNABWTUMAB
      WTUNOZQXGABUOGZRZXOWOXRWPXAABUPSXAXRXOVFWSXAXQXIBXAXIBUQZXQXAXSKZWTMHABWT
      URZXQDUSYAXTABWTUTVAABWTMVBVCVGVDQVEXIBVHVIEXJVJVKXGXKWREWSXAXKWRWSXAXKKZ
      KZABXHIZJZTGZYEWQUOGZWRYCAMHZYEMHZAYEWTUAZYFWOYHWPYBABFUDVLSYCXEYIWOXEWPY
      BXFSZBYDMVMOYBYJWSXAXKXIYEUKZYJYBXIYDVNUIUQZYLXKYMXAXKXHXIHRYMXHBXIVOXIXH
      VPVRQYBXNYMYLNXAXNXKXPPXIYDBVQOUGABYEWTWHVSQAYEWTMMVTWAYCXEXHBHZWPYGYKXKY
      NWSXAXHBXIWBWCWOWPYBWDXHCMBWEWAAYEWQWFVIWGWIVEWJWOWPRZKWRXCWOXCYOXDPYOWRX
      CNWOYOWQBATCBWKWLQWMWN $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    xpsnen.1 $e |- A e. _V $.
    xpsnen.2 $e |- B e. _V $.
    $( A set is equinumerous to its cross-product with a singleton.
       Proposition 4.22(c) of [Mendelson] p. 254.  (Contributed by NM,
       4-Jan-2004.)  (Revised by Mario Carneiro, 15-Nov-2014.) $)
    xpsnen $p |- ( A X. { B } ) ~~ A $=
      ( vy vx vz cv cint cop wcel wceq wex cvv inteq inteqd vex op1stb adantr
      wa csn cxp snex xpex elxp syl6eq syl6eqel exlimivv sylbi opex eleq1 mpbii
      a1i wb ancom anass elsn anbi1i 3bitr3i exbii opeq2 eqeq2d ceqsexv syl6req
      anbi1d pm4.71ri bitri 3bitri anbi12d ceqsexgv syl5bb syl pm5.32ri pm4.71i
      opeq1 bitr2i en2i ) EFABUAZUBZAEHZIZIZFHZBJZAVRCBUCUDCVTVSKZVTWCGHZJZLZWC
      AKZWFVRKZTZTZGMZFMZWBNKZFGVTAVRUEZWLWOFGWHWOWKWHWBWCNWHWBWGIZIWCWHWAWQVTW
      GOPWCWFFQZGQRUFWRUGSUHUIWDNKWIWCBUJUMWEWCWBLZTVTWBBJZLZWBAKZTZWSTZVTWDLZW
      ITZWIXETWSWEXCWSWOWEXCUNWSWCNKWOWRWCWBNUKULWEWSXFTZFMZWOXCWEWNXHWPWMXGFWM
      WFBLZWHWITZTZGMXFXGWLXKGXJWJTWJXJTWLXKXJWJUOWHWIWJUPWJXIXJGBUQURUSUTXJXFG
      BDXIWHXEWIXIWGWDVTWFBWCVAVBVEVCXFWSXETZWITXGXEXLWIXEWSXEWBWDIZIWCXEWAXMVT
      WDOPWCBWRDRVDZVFURWSXEWIUPVGVHUTVGXFXCFWBNWSXEXAWIXBWSWDWTVTWCWBBVOVBWCWB
      AUKVIZVJVKVLVMXFXFWSTXDXFWSXEWSWIXNSVNWSXFXCXOVMVPXEWIUOVHVQ $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A set is equinumerous to its cross-product with a singleton.
       Proposition 4.22(c) of [Mendelson] p. 254.  (Contributed by NM,
       22-Oct-2004.) $)
    xpsneng $p |- ( ( A e. V /\ B e. W ) -> ( A X. { B } ) ~~ A ) $=
      ( vx vy cv csn cxp cen wbr wceq xpeq1 id breq12d xpeq2d breq1d vex xpsnen
      sneq vtocl2g ) EGZFGZHZIZUBJKAUDIZAJKABHZIZAJKEFABCDUBALZUEUFUBAJUBAUDMUI
      NOUCBLZUFUHAJUJUDUGAUCBTPQUBUCERFRSUA $.
  $}

  $( One times a cardinal number.  (Contributed by NM, 27-Sep-2004.)  (Revised
     by Mario Carneiro, 29-Apr-2015.) $)
  xp1en $p |- ( A e. V -> ( A X. 1o ) ~~ A ) $=
    ( wcel c1o cxp c0 csn cen df1o2 xpeq2i cvv wbr 0ex xpsneng mpan2 syl5eqbr )
    ABCZADEAFGZEZAHDRAIJQFKCSAHLMAFBKNOP $.

  ${
    $d x y A $.  $d x y B $.
    endisj.1 $e |- A e. _V $.
    endisj.2 $e |- B e. _V $.
    $( Any two sets are equinumerous to disjoint sets.  Exercise 4.39 of
       [Mendelson] p. 255.  (Contributed by NM, 16-Apr-2004.) $)
    endisj $p |- E. x E. y ( ( x ~~ A /\ y ~~ B ) /\ ( x i^i y ) = (/) ) $=
      ( c0 csn cxp cen wbr c1o wa cin wceq cv wex xpsnen xpex breq1 con0 pm3.2i
      0ex elexi xp01disj p0ex snex bi2anan9 ineq12 eqeq1d anbi12d spc2ev mp2an
      1on ) CGHZIZCJKZDLHZIZDJKZMZUPUSNZGOZAPZCJKZBPZDJKZMZVDVFNZGOZMZBQAQUQUTC
      GEUCRDLFLUAUNUDRUBCDUEVKVAVCMABUPUSCUOEUFSDURFLUGSVDUPOZVFUSOZMZVHVAVJVCV
      LVEUQVMVGUTVDUPCJTVFUSDJTUHVNVIVBGVDUPVFUSUIUJUKULUM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    $( Dominance law for union.  Proposition 4.24(a) of [Mendelson] p. 257.
       (Contributed by NM, 3-Sep-2004.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    undom $p |- ( ( ( A ~<_ B /\ C ~<_ D ) /\ ( B i^i D ) = (/) ) ->
                ( A u. C ) ~<_ ( B u. D ) ) $=
      ( vx vy cdom wbr wa cin c0 wceq cen wss wex cun cvv wcel reldom brrelex2i
      cv cdif wb domeng syl ibi brrelexi difss ssdomg ee10 domtr mpancom adantr
      anim12i eeanv simprll simprrl disjdif ss2in ad2ant2l adantl sseq0 syl2anc
      a1i simplr undif2 unen syl5eqbrr syl22anc ad3antrrr ad3antlr unexg unss12
      sylc endomtr ex exlimdvv syl5bir mpd ) ABGHZCDGHZIZBDJZKLZIZAEUAZMHZWFBNZ
      IZEOZCAUBZFUAZMHZWLDNZIZFOZIZACPZBDPZGHZWBWQWDVTWJWAWPVTWJVTBQRZVTWJUCABG
      STZEABQUDUEUFWAWKDGHZWPWKCGHZWAXCWACQRWKCNXDCDGSUGCAUHWKCQUIUJWKCDUKULXCW
      PXCDQRZXCWPUCWKDGSTFWKDQUDUEUFUEUNUMWQWIWOIZFOEOWEWTWIWOEFUOWEXFWTEFWEXFW
      TWEXFIZWRWFWLPZMHZXHWSGHZWTXGWGWMAWKJKLZWFWLJZKLZXIWEWGWHWOUPWEWIWMWNUQXK
      XGACURVDXGXLWCNZWDXMXFXNWEWHWNXNWGWMWFBWLDUSUTVAWBWDXFVEXLWCVBVCWGWMIXKXM
      IIWRAWKPXHMACVFAWFWKWLVGVHVIXGWSQRZXHWSNZXJXGXAXEXOVTXAWAWDXFXBVJWAXEVTWD
      XFCDGSTVKBDQQVLVCXFXPWEWHWNXPWGWMWFBWLDVMUTVAXHWSQUIVNWRXHWSVOVCVPVQVRVS
      $.
  $}

  ${
    $d u v w x y z A $.  $d u v w x y z B $.  $d u v C $.  $d u v w y z F $.
    $d u v w G $.
    xpcomf1o.1 $e |- F = ( x e. ( A X. B ) |-> U. `' { x } ) $.
    $( The canonical bijection from ` ( A X. B ) ` to ` ( B X. A ) ` .
       (Contributed by Mario Carneiro, 23-Apr-2014.) $)
    xpcomf1o $p |- F : ( A X. B ) -1-1-onto-> ( B X. A ) $=
      ( cxp ccnv wf1o cv cuni cmpt wrel relxp cnvf1o ax-mp wceq wb f1oeq1 mpbir
      csn cnvxp f1oeq3 mpbi ) BCFZUDGZDHZUDCBFZDHZUFUDUEAUDAITGJKZHZUDLUJBCMAUD
      NODUIPUFUJQEUDUEDUIROSUEUGPUFUHQBCUAUEUGUDDUBOUC $.

    xpcomco.1 $e |- G = ( y e. B , z e. A |-> C ) $.
    $( Composition with the bijection of ~ xpcomf1o swaps the arguments to a
       mapping.  (Contributed by Mario Carneiro, 30-May-2015.) $)
    xpcomco $p |- ( G o. F ) = ( z e. A , y e. B |-> C ) $=
      ( vu vw vv cv wbr wa wex wceq wcel nfcv copab cop ccom cmpt2 cfv cxp wf1o
      cdm wfun wb xpcomf1o f1ofun funbrfv2b mp2b ancom eqcom f1odm ax-mp eleq2i
      anbi12i 3bitri anbi1i anass bitri exbii fvex breq1 anbi2d ceqsexv nfmpt22
      elxp nfcxfr nfbr 19.41 nfmpt21 fveq2 opelxpi ccnv cuni sneq cnveqd unieqd
      csn opswap syl6eq opex fvmpt sylan9eq breq1d coprab df-br df-mpt2 oprabid
      syl eqtri baib ancoms adantl bitrd pm5.32da pm5.32i 3bitr2i opabbii df-co
      bitr3i dfoprab2 3eqtr4i ) KNZLNZGOZXIMNZHOZPZLQZKMUAXHCNZBNZUBZRZXODSZXPE
      SZPZXKFRZPZPZBQZCQZKMUAZHGUCCBDEFUDZXNYFKMXNXIXHGUEZRZXHDEUFZSZXLPZPZLQYL
      YIXKHOZPZYFXMYNLXMYJYLPZXLPYNXJYQXLXJXHGUHZSZYIXIRZPZYTYSPYQYKEDUFZGUGZGU
      IXJUUAUJADEGIUKZYKUUBGULXHXIGUMUNYSYTUOYTYJYSYLYIXIUPYRYKXHUUCYRYKRUUDYKU
      UBGUQURUSUTVAVBYJYLXLVCVDVEYMYPLYIXHGVFYJXLYOYLXIYIXKHVGVHVIYPXRYAPZBQZCQ
      ZYOPUUFYOPZCQYFYLUUGYOCBXHDEVKVBUUFYOCCYIXKHCYITCHBCEDFUDZJBCEDFVJVLCXKTV
      MVNUUHYECUUHUUEYOPZBQYEUUEYOBBYIXKHBYITBHUUIJBCEDFVOVLBXKTVMVNUUJYDBUUJXR
      YAYOPZPYDXRYAYOVCXRUUKYCXRYAYOYBUUEYOXPXOUBZXKHOZYBUUEYIUULXKHXRYAYIXQGUE
      ZUULXHXQGVPYAXQYKSUUNUULRXOXPDEVQAXQANZWCZVRZVSZUULYKGUUOXQRZUURXQWCZVRZV
      SUULUUSUUQUVAUUSUUPUUTUUOXQVTWAWBXOXPWDWEIXPXOWFWGWNWHWIYAUUMYBUJZXRXTXSU
      VBUUMXTXSPZYBUUMUULXKUBZHSUVDUVCYBPZBCMWJZSUVEUULXKHWKHUVFUVDHUUIUVFJBCME
      DFWLWOUSUVEBCMWMVAWPWQWRWSWTXAVDVEXEVEXBVAXCKMLHGXDYHYCCBMWJYGCBMDEFWLYCC
      BMKXFWOXG $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    xpcomen.1 $e |- A e. _V $.
    xpcomen.2 $e |- B e. _V $.
    $( Commutative law for equinumerosity of cross product.  Proposition
       4.22(d) of [Mendelson] p. 254.  (Contributed by NM, 5-Jan-2004.)
       (Revised by Mario Carneiro, 15-Nov-2014.) $)
    xpcomen $p |- ( A X. B ) ~~ ( B X. A ) $=
      ( cxp cvv wcel csn ccnv cuni cmpt wf1o cen wbr xpex eqid xpcomf1o f1oen2g
      vx cv mp3an ) ABEZFGBAEZFGUBUCSUBSTHIJKZLUBUCMNABCDOBADCOSABUDUDPQUBUCUDF
      FRUA $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( Commutative law for equinumerosity of cross product.  Proposition
       4.22(d) of [Mendelson] p. 254.  (Contributed by NM, 27-Mar-2006.) $)
    xpcomeng $p |- ( ( A e. V /\ B e. W ) -> ( A X. B ) ~~ ( B X. A ) ) $=
      ( vx vy cv cxp cen wbr wceq xpeq1 xpeq2 breq12d vex xpcomen vtocl2g ) EGZ
      FGZHZSRHZIJASHZSAHZIJABHZBAHZIJEFABCDRAKTUBUAUCIRASLRASMNSBKUBUDUCUEISBAM
      SBALNRSEOFOPQ $.
  $}

  $( A set is equinumerous to its cross-product with a singleton on the left.
     (Contributed by Stefan O'Rear, 21-Nov-2014.) $)
  xpsnen2g $p |- ( ( A e. V /\ B e. W ) -> ( { A } X. B ) ~~ B ) $=
    ( wcel wa csn cxp cen wbr cvv snex xpcomeng mpan adantl xpsneng ancoms entr
    syl2anc ) ACEZBDEZFAGZBHZBUBHZIJZUDBIJZUCBIJUAUETUBKEUAUEALUBBKDMNOUATUFBAD
    CPQUCUDBRS $.

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    xpassen.1 $e |- A e. _V $.
    xpassen.2 $e |- B e. _V $.
    xpassen.3 $e |- C e. _V $.
    $( Associative law for equinumerosity of cross product.  Proposition
       4.22(e) of [Mendelson] p. 254.  (Contributed by NM, 22-Jan-2004.)
       (Revised by Mario Carneiro, 15-Nov-2014.) $)
    xpassen $p |- ( ( A X. B ) X. C ) ~~ ( A X. ( B X. C ) ) $=
      ( vz vw vv vu csn cdm cuni crn cop wcel wceq wa wex unieqd vx vy cxp xpex
      cvv opex a1i sneq dmeqd sneqd vex op1sta sneqi dmeqi unieqi eqtri syl6req
      rneqd rneqi op2nda opeq12d eq2tri anass anbi12i an32 3bitr4i exbii 19.41v
      3bitr3i 2exbii 19.41vv elxp excom anbi1i an12 exrot4 eqeq2d anbi1d anbi2d
      opeq1 ceqsexv 3bitri 3exbii anbi2i 19.42vv bitri bitr3i exrot3 opeq2 en2i
      cv ) UAUBABUCZCUCZABCUCZUCZUAWKZKZLZMZKZLZMZWTNZMZWQNZMZOZOZUBWKZKZLZMZXJ
      NZMZKZLZMZOZXONZMZOZWLCABDEUDFUDAWNDBCEFUDUDXHUEPWPWMPZXBXGUFUGYAUEPXIWOP
      ZXRXTUFUGWPGWKZHWKZOZIWKZOZQZYDAPZYEBPZRZYGCPZRZRZISZHSGSZXIXHQZRZXIYDYEY
      GOZOZQZYJYKYMRZRZRZISZHSZGSZWPYAQZRZYBYRRYCUUIRYPYRRZHSGSUUFUUIRZHSGSYSUU
      JUUKUULGHYOYRRZISUUEUUIRZISUUKUULUUMUUNIYIYRRZYNRUUBUUIRZUUDRUUMUUNUUOUUP
      YNUUDWPXIYHUUAXHYAYIYDXBYTXGYIXBYHKZLZMZKZLZMZYDYIXAUVAYIWTUUTYIWSUUSYIWR
      UURYIWQUUQWPYHUHZUITUJZUITUVBYFKZLZMYDUVAUVFUUTUVEUUSYFYFYGYDYEUFZIUKZULU
      MZUNUOYDYEGUKZHUKZULUPUQYIYEXDYGXFYIXDUUTNZMZYEYIXCUVLYIWTUUTUVDURTUVMUVE
      NZMYEUVLUVNUUTUVEUVIUSUOYDYEUVJUVKUTUPUQYIXFUUQNZMYGYIXEUVOYIWQUUQUVCURTY
      FYGUVGUVHUTUQVAVAUUBYFXRYGXTUUBYDXLYEXQUUBXLUUAKZLZMYDUUBXKUVQUUBXJUVPXIU
      UAUHZUITYDYTUVJYEYGUFZULUQUUBXQUVPNZMZKZLZMZYEUUBXPUWCUUBXOUWBUUBXNUWAUUB
      XMUVTUUBXJUVPUVRURTUJZUITUWDYTKZLZMYEUWCUWGUWBUWFUWAYTYDYTUVJUVSUTUMZUNUO
      YEYGUVKUVHULUPUQVAUUBXTUWBNZMZYGUUBXSUWIUUBXOUWBUWEURTUWJUWFNZMYGUWIUWKUW
      BUWFUWHUSUOYEYGUVKUVHUTUPUQVAVBYJYKYMVCVDYIYNYRVEUUBUUDUUIVEVFVGYOYRIVHUU
      EUUIIVHVIVJYPYRGHVKUUFUUIGHVKVIYBYQYRYBWPJWKZYGOZQZUWLWLPZYMRRZISJSUWPJSI
      SZYQJIWPWLCVLUWPJIVMUWQUWLYFQZYLRZUWNYMRZRZHSGSZJSISUXAJSZISHSGSYQUWPUXBI
      JUWOUWTRUWSHSGSZUWTRUWPUXBUWOUXDUWTGHUWLABVLVNUWNUWOYMVOUWSUWTGHVKVFVJUXA
      IJGHVPUXCYOGHIUXCUWRYLUWTRZRZJSYLYIYMRZRZYOUXAUXFJUWRYLUWTVCVGUXEUXHJYFUV
      GUWRUWTUXGYLUWRUWNYIYMUWRUWMYHWPUWLYFYGVTVQVRVSWAYLYIYMVOWBWCWBWBVNYCUUHU
      UIYCXIYDUWLOZQZYJUWLWNPZRRZJSZGSUUHGJXIAWNVLUXMUUGGUXMUWLYTQZUXJUUDRZRZIS
      HSZJSUXPJSZISHSUUGUXLUXQJUXJYJRZUXKRUXSUXNUUCRZISHSZRZUXLUXQUXKUYAUXSHIUW
      LBCVLWDUXJYJUXKVCUYBUXSUXTRZISHSUXQUXSUXTHIWEUYCUXPHIUYCUXNUXSUUCRZRUXPUX
      SUXNUUCVOUYDUXOUXNUXJYJUUCVCWDWFVJWGVIVGUXPJHIWHUXRUUEHIUXOUUEJYTUVSUXNUX
      JUUBUUDUXNUXIUUAXIUWLYTYDWIVQVRWAVJWBVGWFVNVFWJ $.
  $}

  ${
    $d f u v w x y z A $.  $d f u v w x y z B $.  $d f u v w x y z C $.
    xpdom.2 $e |- C e. _V $.
    $( Dominance law for cross product.  Proposition 10.33(2) of
       [TakeutiZaring] p. 92.  (Contributed by NM, 24-Jul-2004.)  (Revised by
       Mario Carneiro, 15-Nov-2014.) $)
    xpdom2 $p |- ( A ~<_ B -> ( C X. A ) ~<_ ( C X. B ) ) $=
      ( vz vw vv vu cdom cv wa csn cdm cuni cop cvv wcel wi wceq wb wbr wf1 cxp
      vf vx vy brdomi crn cfv wf f1f ffvelrn ex syl anim2d adantld elxp4 opelxp
      3imtr4g adantl wrex elxp2 vex fvex opth f1fveq ancoms anbi2d ad2ant2l imp
      syl5bb adantlr dmeqd unieqd op1sta syl6eq op2nda fveq2d opeq12d eqeqan12d
      sneq rneqd ad2antlr eqeq12 syl6bb 3bitr4d exp53 com23 rexlimivv rexlimdvv
      syl2anb com12 reldom brrelexi xpexg sylancr adantr brrelex2i exlimddv
      dom3d ) ABIUAZABUDJZUBZCAUCZCBUCZIUAUDABUDUGXAXCKUEUFXDXEUEJZLZMZNZXGUHZN
      ZXBUIZOZUFJZLZMZNZXOUHZNZXBUIZOZPPXCXFXDQZXMXEQZRXAXCXFXIXKOSZXICQZXKAQZK
      ZKYEXLBQZKZYBYCXCYGYIYDXCYFYHYEXCABXBUJZYFYHRABXBUKYJYFYHABXKXBULUMUNUOUP
      XFCAUQXIXLCBURUSUTXCYBXNXDQZKZXMYASZXFXNSZTZRXAYLXCYOYBXFEJZFJZOZSZFAVAEC
      VAZXNGJZHJZOZSZHAVAGCVAZXCYORZYKEFXFCAVBGHXNCAVBYTUUEUUFYTUUDUUFGHCAYSUUA
      CQZUUBAQZKZUUDUUFRZREFCAYPCQZYQAQZKZUUIYSUUJUUMUUIYSUUDXCYOUUMUUIKZYSUUDK
      ZKXCKYPYQXBUIZOZUUAUUBXBUIZOZSZYPUUASZYQUUBSZKZYMYNUUNXCUUTUVCTZUUOUUNXCU
      VDUULUUHXCUVDRUUKUUGUULUUHKZXCUVDUUTUVAUUPUURSZKUVEXCKZUVCYPUUPUUAUUREVCZ
      YQXBVDVEUVGUVFUVBUVAXCUVEUVFUVBTABYQUUBXBVFVGVHVKUMVIVJVLUUOYMUUTTUUNXCYS
      UUDXMUUQYAUUSYSXIYPXLUUPYSXIYRLZMZNYPYSXHUVJYSXGUVIXFYRWAZVMVNYPYQUVHFVCZ
      VOVPYSXKYQXBYSXKUVIUHZNYQYSXJUVMYSXGUVIUVKWBVNYPYQUVHUVLVQVPVRVSUUDXQUUAX
      TUURUUDXQUUCLZMZNUUAUUDXPUVOUUDXOUVNXNUUCWAZVMVNUUAUUBGVCZHVCZVOVPUUDXSUU
      BXBUUDXSUVNUHZNUUBUUDXRUVSUUDXOUVNUVPWBVNUUAUUBUVQUVRVQVPVRVSVTWCUUOYNUVC
      TUUNXCUUOYNYRUUCSUVCXFYRXNUUCWDYPYQUUAUUBUVHUVLVEWEWCWFWGWHWIWJVJWKWLUTXA
      XDPQZXCXACPQZAPQUVTDABIWMWNCAPPWOWPWQXAXEPQZXCXAUWABPQUWBDABIWMWRCBPPWOWP
      WQWTWS $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x V $.  $d x W $.
    $( Dominance law for cross product.  Theorem 6L(c) of [Enderton] p. 149.
       (Contributed by Mario Carneiro, 26-Apr-2015.) $)
    xpdom2g $p |- ( ( C e. V /\ A ~<_ B ) ->
                  ( C X. A ) ~<_ ( C X. B ) ) $=
      ( vx wcel cdom wbr cxp cv wceq xpeq1 breq12d imbi2d vex xpdom2 vtoclg imp
      wi ) CDFABGHZCAIZCBIZGHZTEJZAIZUDBIZGHZSTUCSECDUDCKZUGUCTUHUEUAUFUBGUDCAL
      UDCBLMNABUDEOPQR $.

    $( Dominance law for cross product.  Theorem 6L(c) of [Enderton] p. 149.
       (Contributed by NM, 25-Mar-2006.)  (Revised by Mario Carneiro,
       26-Apr-2015.) $)
    xpdom1g $p |- ( ( C e. V /\ A ~<_ B ) ->
                  ( A X. C ) ~<_ ( B X. C ) ) $=
      ( wcel cdom wbr wa cxp cen reldom brrelexi xpcomeng ancoms sylan2 xpdom2g
      cvv brrelex2i domentr syl2anc endomtr ) CDEZABFGZHZACIZCAIZJGZUFBCIZFGZUE
      UHFGUCUBAQEZUGABFKLUJUBUGACQDMNOUDUFCBIZFGUKUHJGZUIABCDPUCUBBQEULABFKRCBD
      QMOUFUKUHSTUEUFUHUAT $.

    $( A set is dominated by its cross product with a non-empty set.  Exercise
       6 of [Suppes] p. 98.  (Contributed by NM, 27-Jul-2004.)  (Revised by
       Mario Carneiro, 29-Apr-2015.) $)
    xpdom3 $p |- ( ( A e. V /\ B e. W /\ B =/= (/) ) -> A ~<_ ( A X. B ) ) $=
      ( vx wcel c0 wne cxp cdom wbr cv wex wa n0 w3a csn cen cvv wss ensymd syl
      xpsneng 3adant2 xpexg 3adant3 simp3 ssdomg endomtr syl2anc 3expia exlimdv
      snssd xpss2 sylc syl5bi 3impia ) ACFZBDFZBGHZAABIZJKZUTELZBFZEMURUSNZVBEB
      OVEVDVBEURUSVDVBURUSVDPZAAVCQZIZRKVHVAJKZVBVFVHAURVDVHARKUSAVCCBUCUDUAVFV
      ASFZVHVATZVIURUSVJVDABCDUEUFVFVGBTVKVFVCBURUSVDUGUMVGBAUNUBVHVASUHUOAVHVA
      UIUJUKULUPUQ $.
  $}

  ${
    xpdom1.2 $e |- C e. _V $.
    $( Dominance law for cross product.  Theorem 6L(c) of [Enderton] p. 149.
       (Contributed by NM, 28-Sep-2004.)  (Revised by Mario Carneiro,
       29-Mar-2006.) $)
    xpdom1 $p |- ( A ~<_ B -> ( A X. C ) ~<_ ( B X. C ) ) $=
      ( cvv wcel cdom wbr cxp xpdom1g mpan ) CEFABGHACIBCIGHDABCEJK $.
  $}

  ${
    $d f A $.  $d f B $.  $d f X $.  $d f Y $.
    domunsncan.a $e |- A e. _V $.
    domunsncan.b $e |- B e. _V $.
    $( A singleton cancellation law for dominance.  (Contributed by Stefan
       O'Rear, 19-Feb-2015.)  (Revised by Stefan O'Rear, 5-May-2015.) $)
    domunsncan $p |- ( ( -. A e. X /\ -. B e. Y ) ->
        ( ( { A } u. X ) ~<_ ( { B } u. Y ) <-> X ~<_ Y ) ) $=
      ( vf wcel wa csn cun cdom wbr cvv wss sylancr cdif cima wceq ad2antll wf1
      wn ssun2 reldom brrelex2i adantl ssexg wex brdomi cen cres wf1o vex resex
      cv simprr difss f1ores sylancl f1oen3g ccnv wfun df-f1 simprbi imadif syl
      wf cfv snex simprl difexg f1f crn imassrn frn syl5ss ssdifd wfn f1fn snid
      unexg elun1 ax-mp fnsnfv difeq2d ssdomg sylc ffvelrn mp1i difsnen syl3anc
      sseqtr4d domentr syl2anc eqbrtrd endomtr uncom difeq1i difun2 eqtri difsn
      syl5eq ad2antrr ad2antlr 3brtr3d expr exlimdv syl5 impancom mpd cin en2sn
      c0 mp2an endom simpr incom disjsn biimpri undom syl21anc impbida ) ACHUBZ
      BDHUBZIZAJZCKZBJZDKZLMZCDLMZYEYJIZDNHZYKYLDYIOYINHZYMDYHUCYJYNYEYGYILUDUE
      UFDYINUGPYEYMYJYKYJYGYIGUOZUAZGUHYEYMIZYKYGYIGUIYQYPYKGYEYMYPYKYEYMYPIZIZ
      YGYFQZYIYHQZCDLYSYTYOYTRZUJMZUUBUUALMYTUUALMYSYOYTUKZNHYTUUBUUDULZUUCYOYT
      GUMUNYSYPYTYGOUUEYEYMYPUPYGYFUQYGYIYTYOURUSYTUUBUUDNUTPYSUUBYOYGRZYOYFRZQ
      ZUUALYPUUBUUHSZYEYMYPYOVAVBZUUIYPYGYIYOVGZUUJYGYIYOVCVDYGYFYOVEVFTYSUUHYI
      AYOVHZJZQZLMZUUNUUAUJMZUUHUUALMYSUUNNHZUUHUUNOUUOYSYNUUQYSYHNHYMYNBVIYEYM
      YPVJYHDNNWAPZYIUUMNVKVFYSUUHYIUUGQUUNYSUUFYIUUGYPUUFYIOZYEYMYPUUKUUSYGYIY
      OVLZUUKUUFYOVMYIYOYGVNYGYIYOVOVPVFTVQYSUUMUUGYIYSYOYGVRZAYGHZUUMUUGSYPUVA
      YEYMYGYIYOVSTAYFHUVBAEVTAYFCWBWCZYGAYOWDUSWEWLUUHUUNNWFWGYSYNUULYIHZBYIHZ
      UUPUURYPUVDYEYMYPUUKUVBUVDUUTUVCYGYIAYOWHUSTBYHHUVEYSBFVTBYHDWBWIUULBNYIW
      JWKUUHUUNUUAWMWNWOYTUUBUUAWPWNYCYTCSYDYRYCYTCYFQZCYTCYFKZYFQUVFYGUVGYFYFC
      WQWRCYFWSWTACXAXBXCYDUUADSYCYRYDUUADYHQZDUUADYHKZYHQUVHYIUVIYHYHDWQWRDYHW
      SWTBDXAXBXDXEXFXGXHXIXJYEYKIZYFYHLMZYKYHDXKZXMSZYJYFYHUJMZUVKUVJANHBNHUVN
      EFABNNXLXNYFYHXOWIYEYKXPYDUVMYCYKYDUVLDYHXKZXMYHDXQUVOXMSYDDBXRXSXBXDYFYH
      CDXTYAYB $.
  $}

  ${
    $d A f $.  $d A m n r s x y $.  $d B f $.  $d B m n r s x y $.  $d F f $.
    $d F m n r s $.
    omxpenlem.1 $e |- F = ( x e. B , y e. A |-> ( ( A .o x ) +o y ) ) $.
    $( Lemma for ~ omxpen .  (Contributed by Mario Carneiro, 3-Mar-2013.)
       (Revised by Mario Carneiro, 25-May-2015.) $)
    omxpenlem $p |- ( ( A e. On /\ B e. On ) ->
        F : ( B X. A ) -1-1-onto-> ( A .o B ) ) $=
      ( vm vn con0 wcel wa comu co cv wss syl wb syl2anc wceq c0 cxp wfn wf coa
      ccnv wf1o wral csuc word eloni ad2antlr simprl ordsucss sylc wi ad2ant2lr
      onelon suceloni simplr simpll omwordi syl3anc simprr ad2ant2rl omcl oaord
      mpd mpbid omsuc eleqtrrd ralrimivva fmpt2 sylib ffn cres wbr weu cop wrex
      sseldd wne sylan wn noel oveq1 sylan9eqr eleq2d mtbiri ex necon2ad adantl
      om0r imp omeu vex brcnv wex eleq1 biimpac simplll simplrr oaword1 simplrl
      simpr ad2antrr ontr2 mp2and simpllr on0eln0 mpbird om00el simpld syl31anc
      ne0i omord2 impbid expr pm5.32rd sylan2 anbi2i syl6bb anbi2d an12 2exbidv
      eqcom copab cmpt2 coprab df-mpt2 dfoprab2 3eqtri breqi opabid 3bitri r2ex
      df-br 3bitr4g syl5bb eubidv ralrimiva fnres sylibr wrel cdm crn df-rn frn
      relcnv syl5eqssr relssres sylancr fneq1d dff1o4 sylanbrc ) CIJZDIJZKZEDCU
      AZUBZEUEZCDLMZUBZUURUVAEUFUUQUURUVAEUCZUUSUUQCANZLMZBNZUDMZUVAJZBCUGADUGU
      VCUUQUVHABDCUUQUVDDJZUVFCJZKZKZCUVDUHZLMZUVAUVGUVLUVMDOZUVNUVAOZUVLDUIZUV
      IUVOUUPUVQUUOUVKDUJUKUUQUVIUVJULUVDDUMUNUVLUVMIJZUUPUUOUVOUVPUOUVLUVDIJZU
      VRUUPUVIUVSUUOUVJDUVDUQZUPZUVDURPUUOUUPUVKUSUUOUUPUVKUTZUVMDCVAVBVGUVLUVG
      UVECUDMZUVNUVLUVJUVGUWCJZUUQUVIUVJVCUVLUVFIJZUUOUVEIJZUVJUWDQUUOUVJUWEUUP
      UVICUVFUQZVDUWBUVLUUOUVSUWFUWBUWACUVDVEZRUVFCUVEVFVBVHUVLUUOUVSUVNUWCSUWB
      UWACUVDVIRVJVTVKABDCUVGUVAEFVLVMZUURUVAEVNPUUQUUTUVAVOZUVAUBZUVBUUQGNZHNZ
      UUTVPZHVQZGUVAUGUWKUUQUWOGUVAUUQUWLUVAJZKZUWOUWMUVDUVFVRSZUVGUWLSZKZBCVSA
      IVSZHVQZUWQUUOUWLIJZCTWAZUXBUUOUUPUWPUTUUQUVAIJZUWPUXCCDVEZUVAUWLUQWBUUQU
      WPUXDUUPUWPUXDUOUUOUUPUWPCTUUPCTSZUWPWCUUPUXGKZUWPUWLTJUWLWDUXHUVATUWLUXG
      UUPUVATDLMTCTDLWEDWLWFWGWHWIWJWKWMABHCUWLWNVBUWQUWNUXAHUWNUWMUWLEVPZUWQUX
      AUWLUWMEGWOHWOWPUWQUWRUVKUWLUVGSZKZKZBWQAWQZUVSUVJKZUWTKZBWQAWQUXIUXAUWQU
      XLUXOABUWQUXLUWRUXNUWSKZKUXOUWQUXKUXPUWRUWQUXKUXNUXJKUXPUWQUXJUVKUXNUUQUW
      PUXJUVKUXNQZUWPUXJKUUQUVHUXQUXJUWPUVHUWLUVGUVAWRWSUUQUVHKUVJUVIUVSUUQUVHU
      VJUVIUVSQUUQUVHUVJKZKZUVIUVSUUPUVIUVSUOUUOUXRUUPUVIUVSUVTWIUKUXSUVSUVIUXS
      UVSKZUVIUVEUVAJZUXTUVEUVGOZUVHUYAUXTUWFUWEUYBUXTUUOUVSUWFUUOUUPUXRUVSWTZU
      XSUVSXDZUWHRZUXTUUOUVJUWEUYCUUQUVHUVJUVSXAUWGRUVEUVFXBRUUQUVHUVJUVSXCZUXT
      UWFUXEUYBUVHKUYAUOUYEUUQUXEUXRUVSUXFXEZUVEUVGUVAXFRXGUXTUVSUUPUUOTCJZUVIU
      YAQUYDUUOUUPUXRUVSXHUYCUXTUYHTDJZUXTTUVAJZUYHUYIKZUXTUYJUVATWAZUXTUVHUYLU
      YFUVAUVGXNPUXTUXEUYJUYLQUYGUVAXIPXJUUQUYJUYKQUXRUVSCDXKXEVHXLUVDDCXOXMXJW
      IXPXQXRXSXQXRUXJUWSUXNUWLUVGYEXTYAYBUWRUXNUWSYCYAYDUXIUWMUWLUXMHGYFZVPUWM
      UWLVRUYMJUXMUWMUWLEUYMEABDCUVGYGUXKABGYHUYMFABGDCUVGYIUXKABGHYJYKYLUWMUWL
      UYMYPUXMHGYMYNUWTABICYOYQYRYSXJYTGHUVAUUTUUAUUBUUQUVAUWJUUTUUQUUTUUCUUTUU
      DZUVAOUWJUUTSEUUHUUQUYNEUUEZUVAEUUFUUQUVCUYOUVAOUWIUURUVAEUUGPUUIUUTUVAUU
      JUUKUULVHUURUVAEUUMUUN $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( The cardinal and ordinal products are always equinumerous.  Exercise 10
       of [TakeutiZaring] p. 89.  (Contributed by Mario Carneiro,
       3-Mar-2013.) $)
    omxpen $p |- ( ( A e. On /\ B e. On ) -> ( A .o B ) ~~ ( A X. B ) ) $=
      ( vx vy con0 wcel wa cxp comu co cen wbr xpcomeng cvv cv cmpt2 wf1o xpexg
      coa ancoms omcl eqid omxpenlem f1oen2g syl3anc entr syl2anc ensymd ) AEFZ
      BEFZGZABHZABIJZUKULBAHZKLUNUMKLZULUMKLABEEMUKUNNFZUMEFUNUMCDBAACOIJDOSJPZ
      QUOUJUIUPBAEERTABUACDABUQUQUBUCUNUMUQNEUDUEULUNUMUFUGUH $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    omf1o.1 $e |- F = ( x e. B , y e. A |-> ( ( A .o x ) +o y ) ) $.
    omf1o.2 $e |- G = ( x e. B , y e. A |-> ( ( B .o y ) +o x ) ) $.
    $( Construct an explicit bijection from ` A .o B ` to ` B .o A ` .
       (Contributed by Mario Carneiro, 30-May-2015.) $)
    omf1o $p |- ( ( A e. On /\ B e. On ) ->
        ( G o. `' F ) : ( A .o B ) -1-1-onto-> ( B .o A ) ) $=
      ( vz con0 wcel cxp comu co wf1o ccnv ccom cv cmpt2 eqid coa csn cuni cmpt
      wa omxpenlem ancoms xpcomf1o f1oco sylancl wb xpcomco eqtr4i f1oeq1 ax-mp
      wceq sylibr f1ocnv syl syl2anc ) CJKZDJKZUEZDCLZDCMNZFOZCDMNZVDEPZOZVGVEF
      VHQOVCVDVEBACDDBRMNARUANZSZIVDIRUBPUCUDZQZOZVFVCCDLZVEVKOZVDVOVLOVNVBVAVP
      BADCVKVKTZUFUGIDCVLVLTZUHVDVOVEVKVLUIUJFVMUPVFVNUKFABDCVJSVMHIBADCVJVLVKV
      RVQULUMVDVEFVMUNUOUQVCVDVGEOVIABCDEGUFVDVGEURUSVGVDVEFVHUIUT $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y ph $.  $d x y z S $.
    $d x y G $.
    pw2f1o.1 $e |- ( ph -> A e. V ) $.
    pw2f1o.2 $e |- ( ph -> B e. W ) $.
    pw2f1o.3 $e |- ( ph -> C e. W ) $.
    pw2f1o.4 $e |- ( ph -> B =/= C ) $.
    $( Lemma for ~ pw2f1o .  (Contributed by Mario Carneiro, 6-Oct-2014.) $)
    pw2f1olem $p |- ( ph ->
      ( ( S e. ~P A /\ G = ( z e. A |-> if ( z e. S , C , B ) ) ) <->
        ( G e. ( { B , C } ^m A ) /\ S = ( `' G " { C } ) ) ) ) $=
      ( vy cv wcel wceq wa syl wb vx wss cif cmpt cpr wf ccnv csn cima cpw cmap
      co prid2g prid1g ifcl syl2anc adantr fmptd simprr feq1d mpbird cfv iftrue
      wne wn ad2antrr iffalse neeq1d syl5ibrcom necon4bd impbid2 simplrr fveq1d
      eqid eleq1 ifbid fvmptg syl2anr eqtrd eqeq1d bitr4d pm5.32da simprl sseld
      id pm4.71rd wfn ffn fniniseg 3bitr4d eqrdv jca cnvimass ad2antrl syl5sseq
      cdm eqsstrd dffn5 sylib eleq2d baibd bitrd biimpa adantl eqtr4d ffvelrnda
      fdm wo fvex elpr ord sylibrd con1d imp pm2.61dan mpteq2dva impbida elpw2g
      cbvmptv a1i eqeq2d anbi12d cvv prex elmapg sylancr anbi1d ) AFCUBZGNCNOZF
      PZEDUCZUDZQZRZCDEUEZGUFZFGUGEUHZUIZQZRZFCUJPZGBCBOZFPZEDUCZUDZQZRGYOCUKUL
      PZYSRAYNYTAYNRZYPYSUUHYPCYOYLUFZAUUIYNANCYKYOYLAYKYOPZYICPZAEYOPZDYOPZUUJ
      AEIPUULLDEIUMSZADIPUUMKDEIUNSZYJEDYOUOUPUQYLVNZURUQUUHCYOGYLAYHYMUSUTVAZU
      UHUAFYRUUHUAOZCPZUURFPZRUUSUURGVBZEQZRZUUTUURYRPZUUHUUSUUTUVBUUHUUSRZUUTU
      UTEDUCZEQZUVBUVEUUTUVGUUTEDVCUVEUUTUVFEUVEUVFEVDUUTVEZDEVDZAUVIYNUUSMVFUV
      HUVFDEUUTEDVGVHVIVJVKUVEUVAUVFEUVEUVAUURYLVBZUVFUVEUURGYLAYHYMUUSVLVMUUSU
      USUVFYOPZUVJUVFQUUHUUSWEAUVKYNAUULUUMUVKUUNUUOUUTEDYOUOUPUQNUURYKUVFCYOYL
      YIUURQYJUUTEDYIUURFVOVPUUPVQVRVSVTWAWBUUHUUTUUSUUHFCUURAYHYMWCWDWFUUHGCWG
      ZUVDUVCTUUHYPUVLUUQCYOGWHZSCEUURGWISWJWKWLAYTRZYHYMUVNFYRCAYPYSUSUVNGWPZY
      RCGYQWMYPUVOCQAYSCYOGXGWNWOWQUVNGNCYIGVBZUDZYLUVNUVLGUVQQYPUVLAYSUVMWNZNC
      GWRWSUVNNCUVPYKUVNUUKRZYJUVPYKQUVSYJRUVPEYKUVSYJUVPEQZUVSYJYIYRPZUVTUVSFY
      RYIAYPYSUUKVLWTUVNUWAUUKUVTUVNUVLUWAUUKUVTRTUVRCEYIGWISXAXBZXCYJYKEQUVSYJ
      EDVCXDXEUVSYJVEZRUVPDYKUVSUWCUVPDQZUVSUWDYJUVSUWDVEUVTYJUVSUWDUVTUVSUVPYO
      PUWDUVTXHUVNCYOYIGAYPYSWCXFUVPDEYIGXIXJWSXKUWBXLXMXNUWCYKDQUVSYJEDVGXDXEX
      OXPVSWLXQAUUAYHUUFYMACHPZUUAYHTJFCHXRSAUUEYLGUUEYLQABNCUUDYKUUBYIQUUCYJED
      UUBYIFVOVPXSXTYAYBAUUGYPYSAYOYCPUWEUUGYPTDEYDJYOCGYCHYEYFYGWJ $.

    pw2f1o.5 $e |- F = ( x e. ~P A |->
      ( z e. A |-> if ( z e. x , C , B ) ) ) $.
    $( The power set of a set is equinumerous to set exponentiation with an
       unordered pair base of ordinal 2.  Generalized from Proposition 10.44 of
       [TakeutiZaring] p. 96.  (Contributed by Mario Carneiro, 6-Oct-2014.) $)
    pw2f1o $p |- ( ph -> F : ~P A -1-1-onto-> ( { B , C } ^m A ) ) $=
      ( vy cv wcel ccnv cvv wa cpw cpr cmap co cif cmpt csn cima wceq pw2f1olem
      eqid biimpa mpanr2 simpld vex cnvex imaexg mp1i f1od ) ABODUAZEFUBDUCUDZC
      DCPBPZQFEUEUFZOPZRZFUGZUHZGVASNAVBUTQZTVCVAQZVBVCRVFUHUIZAVHVCVCUIZVIVJTZ
      VCUKAVHVKTVLACDEFVBVCHIJKLMUJULUMUNVESQVGSQAVDVAQTVDOUOUPVEVFSUQURACDEFVB
      VDHIJKLMUJUS $.
  $}

  ${
    $d x z A $.  $d x V $.
    $( The power set of a set is equinumerous to set exponentiation with a base
       of ordinal ` 2o ` .  (Contributed by FL, 22-Feb-2011.)  (Revised by
       Mario Carneiro, 1-Jul-2015.) $)
    pw2eng $p |- ( A e. V -> ~P A ~~ ( 2o ^m A ) ) $=
      ( vx vz wcel cpw c0 csn cpr cmap co c2o cen cvv wel cif cmpt wf1o wbr a1i
      pwexg ovex id 0ex p0ex wne 0nep0 eqid pw2f1o f1oen2g syl3anc df2o2 oveq1i
      syl6breqr ) ABEZAFZGGHZIZAJKZLAJKMUOUPNEUSNEZUPUSCUPDADCOUQGPQQZRUPUSMSAB
      UAUTUOURAJUBTUOCDAGUQVABNUOUCGNEUOUDTUQNEUOUETGUQUFUOUGTVAUHUIUPUSVANNUJU
      KLURAJULUMUN $.

    pw2en.1 $e |- A e. _V $.
    $( The power set of a set is equinumerous to set exponentiation with a base
       of ordinal 2.  Proposition 10.44 of [TakeutiZaring] p. 96.  (Contributed
       by NM, 29-Jan-2004.)  (Proof shortened by Mario Carneiro,
       1-Jul-2015.) $)
    pw2en $p |- ~P A ~~ ( 2o ^m A ) $=
      ( cvv wcel cpw c2o cmap co cen wbr pw2eng ax-mp ) ACDAEFAGHIJBACKL $.
  $}

  ${
    $d A a b c $.  $d B a b c $.  $d F a b c $.
    $( Covering implies injection on power sets.  (Contributed by Stefan
       O'Rear, 6-Nov-2014.)  (Revised by Mario Carneiro, 24-Jun-2015.) $)
    fopwdom $p |- ( ( F e. _V /\ F : A -onto-> B ) -> ~P B ~<_ ~P A ) $=
      ( va vb cvv wcel wa cpw cv cima wss crn syl adantl imaeq2 elpwid foimacnv
      wceq wb wfo ccnv imassrn cdm dfdm4 fof fdm syl5eqr syl5sseq cnvexg adantr
      wf imaexg 3syl mpbird a1d simpllr simplrl syl2anc simplrr 3eqtr3d impbid1
      elpwg ex rnexg forn eleq1d syl5ibcom imp pwexg dmfex sylan2 dom3d ) CFGZA
      BCUAZHZDEBIZAIZCUBZDJZKZVSEJZKZFFVPWAVRGZVTVQGZVPWDWAALZVOWFVNVOVSMZWAAVS
      VTUCVOWGCUDZACUEVOABCULZWHASABCUFZABCUGNUHUIOVPVSFGZWAFGWDWFTVNWKVOCFUJUK
      VSVTFUMWAAFVCUNUOUPVPWEWBVQGZHZWAWCSZVTWBSZTVPWMHZWNWOWPWNWOWPWNHZCWAKZCW
      CKZVTWBWNWRWSSWPWAWCCPOWQVOVTBLWRVTSVNVOWMWNUQZWQVTBVPWEWLWNURQABVTCRUSWQ
      VOWBBLWSWBSWTWQWBBVPWEWLWNUTQABWBCRUSVAVDVTWBVSPVBVDVPBFGZVQFGVNVOXAVNCMZ
      FGVOXACFVEVOXBBFABCVFVGVHVIBFVJNVPAFGZVRFGVOVNWIXCWJABFCVKVLAFVJNVM $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Schroeder-Bernstein Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.  $d x D $.  $d x f $.  $d x g $.
    sbthlem.1 $e |- A e. _V $.
    sbthlem.2 $e |- D = { x |
                   ( x C_ A /\ ( g " ( B \ ( f " x ) ) ) C_ ( A \ x ) ) } $.
    $( Lemma for ~ sbth .  (Contributed by NM, 22-Mar-1998.) $)
    sbthlem1 $p |- U. D C_ ( A \ ( g " ( B \ ( f " U. D ) ) ) ) $=
      ( cuni cv cima cdif wss unissb wcel wa abeq2i imass2 sscon 3syl wi difss2
      ssconb exbiri syl5 pm2.43d imp sylbi elssuni sstrd mprgbir ) DIZBFJZCEJZU
      LKZLZKZLZMAJZURMADADURNUSDOZUSBUMCUNUSKZLZKZLZURUTUSBMZVCBUSLMZPZUSVDMZVG
      ADHQVEVFVHVEVFVHVFVCBMZVEVFVHUAVCBUSUBVEVIVHVFUSVCBUCUDUEUFUGUHUTUPVBMZUQ
      VCMVDURMUTUSULMVAUOMVJUSDUIUSULUNRVAUOCSTUPVBUMRUQVCBSTUJUK $.

    $( Lemma for ~ sbth .  (Contributed by NM, 22-Mar-1998.) $)
    sbthlem2 $p |- ( ran g C_ A ->
                     ( A \ ( g " ( B \ ( f " U. D ) ) ) ) C_ U. D ) $=
      ( cv crn wss cuni cima cdif wcel wa cab imass2 sscon mp2b sbthlem1 ssconb
      wb imassrn sstr2 ax-mp difss sylancl mpbiri jctil ssexi wceq sseq1 imaeq2
      difeq2d imaeq2d difeq2 sseq12d anbi12d elab sylibr syl6eleqr elssuni syl
      wi ) FIZJZBKZBVFCEIZDLZMZNZMZNZDOVNVJKVHVNAIZBKZVFCVIVOMZNZMZBVONZKZPZAQZ
      DVHVNBKZVFCVIVNMZNZMZBVNNZKZPZVNWCOVHWIWDVHWIVNBWGNKZWFVLKZWGVMKWKVJVNKVK
      WEKWLABCDEFGHUAVJVNVIRVKWECSTWFVLVFRWGVMBSTVHWGBKZWDWIWKUCWGVGKVHWMVEVFWF
      UDWGVGBUEUFBVMUGZWGVNBUBUHUIWNUJWBWJAVNVNBGWNUKVOVNULZVPWDWAWIVOVNBUMWOVS
      WGVTWHWOVRWFVFWOVQWECVOVNVIUNUOUPVOVNBUQURUSUTVAHVBVNDVCVD $.

    $( Lemma for ~ sbth .  (Contributed by NM, 22-Mar-1998.) $)
    sbthlem3 $p |- ( ran g C_ A ->
                  ( g " ( B \ ( f " U. D ) ) ) = ( A \ U. D ) ) $=
      ( cv crn wss cuni cdif cima wa wceq sbthlem2 sbthlem1 jctil eqss wi sstr2
      sylibr difeq2d imassrn ax-mp dfss4 sylib eqtr2d ) FIZJZBKZBDLZMBBUJCEIUMN
      MZNZMZMZUOULUMUPBULUMUPKZUPUMKZOUMUPPULUSURABCDEFGHQABCDEFGHRSUMUPTUCUDUL
      UOBKZUQUOPUOUKKULUTUAUJUNUEUOUKBUBUFUOBUGUHUI $.

    $( Lemma for ~ sbth .  (Contributed by NM, 27-Mar-1998.) $)
    sbthlem4 $p |- ( ( ( dom g = B /\ ran g C_ A ) /\ Fun `' g ) ->
                  ( `' g " ( A \ U. D ) ) = ( B \ ( f " U. D ) ) ) $=
      ( cv cdm wceq crn wss wa ccnv wfun cuni cima cdif cres dfdm4 difss mpbiri
      sseq2 ssdmres sylib syl5reqr funcnvres sbthlem3 reseq2d sylan9eqr anassrs
      rneqd sylan9eq df-ima syl6reqr ) FIZJZCKZUQLBMZNUQOZPZNCEIDQZRZSZVABVCSZT
      ZLZVAVFRUSUTVBVEVHKUSUTVBNZVEUQVETZOZLZVHUSVLVJJZVEVJUAUSVEURMZVMVEKUSVNV
      ECMCVDUBURCVEUDUCVEUQUEUFUGVIVKVGVBUTVKVAUQVERZTVGVEUQUHUTVOVFVAABCDEFGHU
      IUJUKUMUNULVAVFUOUP $.

    ${
      $d x H $.
      sbthlem.3 $e |- H = ( ( f |` U. D ) u. ( `' g |` ( A \ U. D ) ) ) $.
      $( Lemma for ~ sbth .  (Contributed by NM, 22-Mar-1998.) $)
      sbthlem5 $p |- ( ( dom f = A /\ ran g C_ A ) -> dom H = A ) $=
        ( cv cdm wceq wss cdif cun cin cima dfss eqtri crn sbthlem1 difss sstri
        wa sseq2 mpbiri sylib uneq1d sbthlem3 imassrn syl6eqssr uneq2d sylan9eq
        cuni cres ccnv dmeqi dmun dmres df-rn eqcomi ineq2i syl6reqr undif mpbi
        uneq12i syl6eq ) EKZLZBMZFKZUAZBNZUEZGLZDUOZBVQOZPZBVOVSVQVJQZVRVMQZPZV
        PVKVNVSVTVRPWBVKVQVTVRVKVQVJNZVQVTMVKWCVQBNZVQBVLCVIVQROZRZOBABCDEFHIUB
        BWFUCUDZVJBVQUFUGVQVJSUHUIVNVRWAVTVNVRVMNVRWAMVNVRWFVMABCDEFHIUJVLWEUKU
        LVRVMSUHUMUNVPVIVQUPZVLUQZVRUPZPZLZWBGWKJURWLWHLZWJLZPWBWHWJUSWMVTWNWAV
        IVQUTWNVRWILZQWAWIVRUTWOVMVRVMWOVLVAVBVCTVGTTVDWDVSBMWGVQBVEVFVH $.

      $( Lemma for ~ sbth .  (Contributed by NM, 27-Mar-1998.) $)
      sbthlem6 $p |- ( ( ran f C_ B /\
               ( ( dom g = B /\ ran g C_ A ) /\ Fun `' g ) ) -> ran H = B ) $=
        ( cv wceq crn wss wa cima cdif cun cres df-ima cdm ccnv sbthlem4 uneq2d
        wfun cuni syl5reqr rneqi uneq1i 3eqtr4i syl6reqr wi imassrn sstr2 ax-mp
        rnun undif sylib sylan9eqr ) FKZUACLUTMBNOUTUBZUEOZEKZMZCNZGMZVCDUFZPZC
        VHQZRZCVBVJVHVABVGQZSZMZRZVFVBVIVMVHVBVMVAVKPVIVAVKTABCDEFHIUCUGUDVCVGS
        ZVLRZMVOMZVMRVFVNVOVLUPGVPJUHVHVQVMVCVGTUIUJUKVEVHCNZVJCLVHVDNVEVRULVCV
        GUMVHVDCUNUOVHCUQURUS $.

      $( Lemma for ~ sbth .  (Contributed by NM, 27-Mar-1998.) $)
      sbthlem7 $p |- ( ( Fun f /\ Fun `' g ) -> Fun H ) $=
        ( cv wfun wa cres funres cdm cin c0 wss ax-mp ccnv cuni cdif wceq dmres
        cun inss1 eqsstri ssrin sslin sstri disjdif sseqtri funun syl2an funeqi
        ss0 mpan2 sylibr ) EKZLZFKUAZLZMUTDUBZNZVBBVDUCZNZUFZLZGLVAVELZVGLZVIVC
        VDUTOVFVBOVJVKMVEPZVGPZQZRUDZVIVNRSVOVNVDVFQZRVNVDVMQZVPVLVDSVNVQSVLVDU
        TPZQVDUTVDUEVDVRUGUHVLVDVMUITVMVFSVQVPSVMVFVBPZQVFVBVFUEVFVSUGUHVMVFVDU
        JTUKVDBULUMVNUQTVEVGUNURUOGVHJUPUS $.

      $( Lemma for ~ sbth .  (Contributed by NM, 27-Mar-1998.) $)
      sbthlem8 $p |- ( ( Fun `' f /\ ( ( ( Fun g /\ dom g = B ) /\ ran g C_ A )
                     /\ Fun `' g ) ) -> Fun `' H ) $=
        ( cv ccnv wfun cdm wceq wa crn cres cdif cun wss cin funres11 funcnvcnv
        cuni c0 syl ad3antrrr anim12i cima df-ima df-rn eqtr2i sbthlem4 syl5eqr
        eqtri ineq12 sylancr disjdif syl6eq adantlll adantl funun syl2anc cnvun
        cnveqi funeqi sylibr ) EKZLMZFKZMZVKNCOZPVKQBUAZPVKLZMZPZPZVIDUEZRZLZVO
        BVSSZRZLZTZMZGLZMVRWAMZWDMZPWANZWDNZUBZUFOZWFVJWHVQWIVSVIUCVLWIVMVNVPVL
        VOLMWIVKUDWBVOUCUGUHUIVQWMVJVMVNVPWMVLVMVNPVPPZWLVIVSUJZCWOSZUBZUFWNWJW
        OOWKWPOWLWQOWOVTQWJVIVSUKVTULUMWNWKVOWBUJZWPWRWCQWKVOWBUKWCULUPABCDEFHI
        UNUOWJWOWKWPUQURWOCUSUTVAVBWAWDVCVDWGWEWGVTWCTZLWEGWSJVFVTWCVEUPVGVH $.

      $( Lemma for ~ sbth .  (Contributed by NM, 28-Mar-1998.) $)
      sbthlem9 $p |- ( ( f : A -1-1-> B /\ g : B -1-1-> A ) ->
                    H : A -1-1-onto-> B ) $=
        ( wfun cdm wceq wa crn ccnv wfn df-fn anbi1i bitri cv wss wf1o sbthlem7
        wf1 sbthlem5 adantrl anim12i an42s adantlr sbthlem8 adantll simpr df-rn
        anim1i sbthlem6 syl5eqr sylanr1 jca32 df-f1 df-f anbi12i dff1o4 3imtr4i
        wf ) EUAZKZVFLBMZNZVFOCUBZNZVFPKZNZFUAZKZVNLCMZNZVNOBUBZNZVNPKZNZNZGKZG
        LBMZNZGPZKZWFLZCMZNZNZBCVFUEZCBVNUEZNBCGUCZWBWEWGWIVKWAWEVLVIWAWEVJVGVT
        VHVSWEVGVTNWCVHVSNWDABCDEFGHIJUDVHVRWDVQABCDEFGHIJUFUGUHUIUJUJVLWAWGVKA
        BCDEFGHIJUKULVKWAWIVLVJWAWIVIVSVJVPVRNZVTWIVQVPVRVOVPUMUOVJWOVTNNWHGOCG
        UNABCDEFGHIJUPUQURULUJUSWLVMWMWAWLBCVFVEZVLNVMBCVFUTWPVKVLWPVFBQZVJNVKB
        CVFVAWQVIVJVFBRSTSTWMCBVNVEZVTNWACBVNUTWRVSVTWRVNCQZVRNVSCBVNVAWSVQVRVN
        CRSTSTVBWNGBQZWFCQZNWKBCGVCWTWEXAWJGBRWFCRVBTVD $.

      ${
        $d f g A $.  $d f g B $.
        sbthlem.4 $e |- B e. _V $.
        $( Lemma for ~ sbth .  (Contributed by NM, 28-Mar-1998.) $)
        sbthlem10 $p |- ( ( A ~<_ B /\ B ~<_ A ) -> A ~~ B ) $=
          ( cdom wbr wa cv wf1 wex brdom cvv cres cen anbi12i eeanv bitr4i wcel
          wf1o cuni ccnv cdif cun vex resex cnvex unex eqeltri sbthlem9 f1oen3g
          sylancr exlimivv sylbi ) BCLMZCBLMZNZBCEOZPZCBFOZPZNZFQEQZBCUAMZVCVEE
          QZVGFQZNVIVAVKVBVLBCEKRCBFHRUBVEVGEFUCUDVHVJEFVHGSUEBCGUFVJGVDDUGZTZV
          FUHZBVMUIZTZUJSJVNVQVDVMEUKULVOVPVFFUKUMULUNUOABCDEFGHIJUPBCGSUQURUSU
          T $.
      $}
    $}

  $}

  ${
    $d x y z w f g A $.  $d x y z w f g B $.
    $( Schroeder-Bernstein Theorem.  Theorem 18 of [Suppes] p. 95.  This
       theorem states that if set ` A ` is smaller (has lower cardinality) than
       ` B ` and vice-versa, then ` A ` and ` B ` are equinumerous (have the
       same cardinality).  The interesting thing is that this can be proved
       without invoking the Axiom of Choice, as we do here, but the proof as
       you can see is quite difficult.  (The theorem can be proved more easily
       if we allow AC.) The main proof consists of lemmas ~ sbthlem1 through
       ~ sbthlem10 ; this final piece mainly changes bound variables to
       eliminate the hypotheses of ~ sbthlem10 .  We follow closely the proof
       in Suppes, which you should consult to understand our proof at a higher
       level.  Note that Suppes' proof, which is credited to J. M. Whitaker,
       does not require the Axiom of Infinity.  (Contributed by NM,
       8-Jun-1998.) $)
    sbth $p |- ( ( A ~<_ B /\ B ~<_ A ) -> A ~~ B ) $=
      ( vz vw vx vy cdom wbr wa cen cvv wi cv wceq breq1 breq2 anbi12d wss cima
      cdif vg vf wcel reldom brrelexi imbi12d cab cuni cres ccnv cun vex imaeq2
      sseq1 difeq2d imaeq2d difeq2 sseq12d cbvabv eqid sbthlem10 vtocl2g syl2an
      pm2.43i ) ABGHZBAGHZIZABJHZVEAKUCBKUCVGVHLZVFABGUDUEBAGUDUECMZDMZGHZVKVJG
      HZIZVJVKJHZLAVKGHZVKAGHZIZAVKJHZLVICDABKKVJANZVNVRVOVSVTVLVPVMVQVJAVKGOVJ
      AVKGPQVJAVKJOUFVKBNZVRVGVSVHWAVPVEVQVFVKBAGPVKBAGOQVKBAJPUFEVJVKFMZVJRZUA
      MZVKUBMZWBSZTZSZVJWBTZRZIZFUGZUBUAWEWLUHZUIWDUJVJWMTUIUKZCULWKEMZVJRZWDVK
      WEWOSZTZSZVJWOTZRZIFEWBWONZWCWPWJXAWBWOVJUNXBWHWSWIWTXBWGWRWDXBWFWQVKWBWO
      WEUMUOUPWBWOVJUQURQUSWNUTDULVAVBVCVD $.
  $}

  $( Schroeder-Bernstein Theorem and its converse.  (Contributed by NM,
     8-Jun-1998.) $)
  sbthb $p |- ( ( A ~<_ B /\ B ~<_ A ) <-> A ~~ B ) $=
    ( cdom wbr wa cen sbth endom ensym syl jca impbii ) ABCDZBACDZEABFDZABGOMNA
    BHOBAFDNABIBAHJKL $.

  ${
    $d x y $.
    $( Schroeder-Bernstein Theorem in class form.  (Contributed by NM,
       28-Mar-1998.) $)
    sbthcl $p |- ~~ = ( ~<_ i^i `' ~<_ ) $=
      ( vx vy cen cdom ccnv cin relen wss wrel inss1 reldom relss mp2 cv wbr wa
      brin vex brcnv anbi2i sbthb 3bitrri eqbrriv ) ABCDDEZFZGUEDHDIUEIDUDJKUED
      LMANZBNZUEOUFUGDOZUFUGUDOZPUHUGUFDOZPUFUGCOUFUGDUDQUIUJUHUFUGDARBRSTUFUGU
      AUBUC $.
  $}

  $( Alternate definition of strict dominance.  Compare Definition 3 of
     [Suppes] p. 97.  (Contributed by NM, 31-Mar-1998.) $)
  dfsdom2 $p |- ~< = ( ~<_ \ `' ~<_ ) $=
    ( csdm cdom cen cdif ccnv cin df-sdom sbthcl difeq2i difin 3eqtri ) ABCDBBB
    EZFZDBLDGCMBHIBLJK $.

  ${
    brsdom2.1 $e |- A e. _V $.
    brsdom2.2 $e |- B e. _V $.
    $( Alternate definition of strict dominance.  Definition 3 of [Suppes]
       p. 97.  (Contributed by NM, 27-Jul-2004.) $)
    brsdom2 $p |- ( A ~< B <-> ( A ~<_ B /\ -. B ~<_ A ) ) $=
      ( cop csdm wcel cdom ccnv cdif wbr wn dfsdom2 eleq2i df-br opelcnv bitr4i
      wa notbii anbi12i eldif 3bitr4i ) ABEZFGUCHHIZJZGZABFKABHKZBAHKZLZRZFUEUC
      MNABFOUJUCHGZUCUDGZLZRUFUGUKUIUMABHOUHULUHBAEHGULBAHOABHCDPQSTUCHUDUAQUB
      $.
  $}

  $( Strict dominance is asymmetric.  Theorem 21(ii) of [Suppes] p. 97.
     (Contributed by NM, 8-Jun-1998.) $)
  sdomnsym $p |- ( A ~< B -> -. B ~< A ) $=
    ( csdm wbr cen sdomnen cdom sdomdom sbth syl2an mtand ) ABCDZBACDZABEDZABFL
    ABGDBAGDNMABHBAHABIJK $.

  $( Theorem 22(i) of [Suppes] p. 97.  (Contributed by NM, 10-Jun-1998.) $)
  domnsym $p |- ( A ~<_ B -> -. B ~< A ) $=
    ( cdom wbr csdm cen wo wn brdom2 sdomnsym sdomnen ensym nsyl3 jaoi sylbi )
    ABCDABEDZABFDZGBAEDZHZABIPSQABJRBAFDQBAKABLMNO $.

  $( Any set dominates the empty set.  (Contributed by NM, 26-Oct-2003.)
     (Revised by Mario Carneiro, 26-Apr-2015.) $)
  0domg $p |- ( A e. V -> (/) ~<_ A ) $=
    ( wcel c0 wss cdom wbr 0ss ssdomg mpi ) ABCDAEDAFGAHDABIJ $.

  $( A set dominated by the empty set is empty.  (Contributed by NM,
     22-Nov-2004.) $)
  dom0 $p |- ( A ~<_ (/) <-> A = (/) ) $=
    ( c0 cdom wbr cen wceq cvv wcel reldom brrelexi 0domg syl pm4.71i sbthb en0
    wa 3bitri ) ABCDZRBACDZPABEDABFRSRAGHSABCIJAGKLMABNAOQ $.

  $( A set strictly dominates the empty set iff it is not empty.  (Contributed
     by NM, 23-Mar-2006.) $)
  0sdomg $p |- ( A e. V -> ( (/) ~< A <-> A =/= (/) ) ) $=
    ( wcel c0 csdm wbr cen wn wne cdom wb 0domg brsdom baib syl wceq ensymb en0
    bitri necon3bbii syl6bb ) ABCZDAEFZDAGFZHZADIUBDAJFZUCUEKABLUCUFUEDAMNOUDAD
    UDADGFADPDAQARSTUA $.

  ${
    0sdom.1 $e |- A e. _V $.
    $( Any set dominates the empty set.  (Contributed by NM, 26-Oct-2003.)
       (Revised by Mario Carneiro, 26-Apr-2015.) $)
    0dom $p |- (/) ~<_ A $=
      ( cvv wcel c0 cdom wbr 0domg ax-mp ) ACDEAFGBACHI $.

    $( A set strictly dominates the empty set iff it is not empty.
       (Contributed by NM, 29-Jul-2004.) $)
    0sdom $p |- ( (/) ~< A <-> A =/= (/) ) $=
      ( cvv wcel c0 csdm wbr wne wb 0sdomg ax-mp ) ACDEAFGAEHIBACJK $.
  $}

  $( The empty set does not strictly dominate any set.  (Contributed by NM,
     26-Oct-2003.) $)
  sdom0 $p |- -. A ~< (/) $=
    ( csdm wbr cdom cvv wcel relsdom brrelexi 0domg syl domnsym con2i pm2.65i
    c0 ) ANBCZNADCZOAEFPANBGHAEIJPONAKLM $.

  $( Transitivity of strict dominance and dominance.  Theorem 22(iii) of
     [Suppes] p. 97.  (Contributed by NM, 26-Oct-2003.)  (Revised by Mario
     Carneiro, 26-Apr-2015.) $)
  sdomdomtr $p |- ( ( A ~< B /\ B ~<_ C ) -> A ~< C ) $=
    ( csdm wbr cdom wa cen sdomdom domtr sylan simpl simpr ensym domentr syl2an
    wn domnsym syl ex mt2d brsdom sylanbrc ) ABDEZBCFEZGZACFEZACHEZQACDEUDABFEU
    EUGABIABCJKUFUHUDUDUELUFUHUDQZUFUHGBAFEZUIUFUECAHEUJUHUDUEMACNBCAOPBARSTUAA
    CUBUC $.

  $( Transitivity of strict dominance and equinumerosity.  Exercise 11 of
     [Suppes] p. 98.  (Contributed by NM, 26-Oct-2003.) $)
  sdomentr $p |- ( ( A ~< B /\ B ~~ C ) -> A ~< C ) $=
    ( cen wbr csdm cdom endom sdomdomtr sylan2 ) BCDEABFEBCGEACFEBCHABCIJ $.

  $( Transitivity of dominance and strict dominance.  Theorem 22(ii) of
     [Suppes] p. 97.  (Contributed by NM, 10-Jun-1998.)  (Revised by Mario
     Carneiro, 26-Apr-2015.) $)
  domsdomtr $p |- ( ( A ~<_ B /\ B ~< C ) -> A ~< C ) $=
    ( cdom wbr wa cen wn sdomdom domtr sylan2 simpr ensym simpl endomtr syl2anr
    csdm domnsym syl ex mt2d brsdom sylanbrc ) ABDEZBCQEZFZACDEZACGEZHACQEUEUDB
    CDEUGBCIABCJKUFUHUEUDUELUFUHUEHZUFUHFCBDEZUIUHCAGEUDUJUFACMUDUENCABOPCBRSTU
    AACUBUC $.

  $( Transitivity of equinumerosity and strict dominance.  (Contributed by NM,
     26-Oct-2003.)  (Revised by Mario Carneiro, 26-Apr-2015.) $)
  ensdomtr $p |- ( ( A ~~ B /\ B ~< C ) -> A ~< C ) $=
    ( cen wbr cdom csdm endom domsdomtr sylan ) ABDEABFEBCGEACGEABHABCIJ $.

  $( Strict dominance is irreflexive.  Theorem 21(i) of [Suppes] p. 97.
     (Contributed by NM, 4-Jun-1998.) $)
  sdomirr $p |- -. A ~< A $=
    ( cvv wcel csdm wbr cen sdomnen enrefg nsyl3 relsdom brrelexi con3i pm2.61i
    wn ) ABCZAADEZNPAAFEOAAGABHIPOAADJKLM $.

  $( Strict dominance is transitive.  Theorem 21(iii) of [Suppes] p. 97.
     (Contributed by NM, 9-Jun-1998.) $)
  sdomtr $p |- ( ( A ~< B /\ B ~< C ) -> A ~< C ) $=
    ( csdm wbr cdom sdomdom domsdomtr sylan ) ABDEABFEBCDEACDEABGABCHI $.

  $( Strict dominance has no 2-cycle loops.  (Contributed by NM,
     6-May-2008.) $)
  sdomn2lp $p |- -. ( A ~< B /\ B ~< A ) $=
    ( csdm wbr wa sdomirr sdomtr mto ) ABCDBACDEAACDAFABAGH $.

  $( Equality-like theorem for equinumerosity.  (Contributed by NM,
     18-Dec-2003.) $)
  enen1 $p |- ( A ~~ B -> ( A ~~ C <-> B ~~ C ) ) $=
    ( cen wbr ensym entr sylan impbida ) ABDEZACDEZBCDEZJBADEKLABFBACGHABCGI $.

  $( Equality-like theorem for equinumerosity.  (Contributed by NM,
     18-Dec-2003.) $)
  enen2 $p |- ( A ~~ B -> ( C ~~ A <-> C ~~ B ) ) $=
    ( cen wbr entr ancoms ensym sylan impbida ) ABDEZCADEZCBDEZLKMCABFGKBADEZML
    ABHMNLCBAFGIJ $.

  $( Equality-like theorem for equinumerosity and dominance.  (Contributed by
     NM, 8-Nov-2003.) $)
  domen1 $p |- ( A ~~ B -> ( A ~<_ C <-> B ~<_ C ) ) $=
    ( cen wbr cdom ensym endomtr sylan impbida ) ABDEZACFEZBCFEZKBADELMABGBACHI
    ABCHJ $.

  $( Equality-like theorem for equinumerosity and dominance.  (Contributed by
     NM, 8-Nov-2003.) $)
  domen2 $p |- ( A ~~ B -> ( C ~<_ A <-> C ~<_ B ) ) $=
    ( cen wbr cdom domentr ancoms ensym sylan impbida ) ABDEZCAFEZCBFEZMLNCABGH
    LBADEZNMABINOMCBAGHJK $.

  $( Equality-like theorem for equinumerosity and strict dominance.
     (Contributed by NM, 8-Nov-2003.) $)
  sdomen1 $p |- ( A ~~ B -> ( A ~< C <-> B ~< C ) ) $=
    ( cen wbr csdm ensym ensdomtr sylan impbida ) ABDEZACFEZBCFEZKBADELMABGBACH
    IABCHJ $.

  $( Equality-like theorem for equinumerosity and strict dominance.
     (Contributed by NM, 8-Nov-2003.) $)
  sdomen2 $p |- ( A ~~ B -> ( C ~< A <-> C ~< B ) ) $=
    ( cen wbr csdm sdomentr ancoms ensym sylan impbida ) ABDEZCAFEZCBFEZMLNCABG
    HLBADEZNMABINOMCBAGHJK $.

  $( Dominance is trichotomous in the restricted case of ordinal numbers.
     (Contributed by Jeff Hankins, 24-Oct-2009.) $)
  domtriord $p |- ( ( A e. On /\ B e. On ) -> ( A ~<_ B <-> -. B ~< A ) ) $=
    ( con0 wcel wa cdom wbr csdm wn cen wi sbth expcom a1i iman brsdom xchbinxr
    wss ssdomg syld syl6ib onelss adantl con3d ontri1 ancoms adantr ensym endom
    wb sylibrd syl con3i jcad syl6ibr con1d impbid ) ACDZBCDZEZABFGZBAHGZIZUTVA
    BAFGZBAJGZKZVCVAVFKUTVDVAVEBALMNVFVDVEIZEZVBVDVEOBAPZQUAUTVAVBUTVAIZVHVBUTV
    JVDVGUTVJBARZVDUTVJABDZIZVKUTVLVAUSVLVAKURUSVLABRVABAUBABCSTUCUDUSURVKVMUJB
    AUEUFUKURVKVDKUSBACSUGTVJVGKUTVEVAVEABJGVABAUHABUIULUMNUNVIUOUPUQ $.

  $( Strict dominance implies ordinal membership.  (Contributed by Mario
     Carneiro, 13-Jan-2013.) $)
  sdomel $p |- ( ( A e. On /\ B e. On ) -> ( A ~< B -> A e. B ) ) $=
    ( con0 wcel csdm wbr wi wa wss cdom wn ssdomg adantl ontri1 domtriord con4d
    3imtr3d ancoms ) BCDZACDZABEFZABDZGSTHZUBUAUCBAIZBAJFZUBKUAKTUDUEGSBACLMBAN
    BAOQPR $.

  $( The difference of a set from a smaller set cannot be empty.  (Contributed
     by Mario Carneiro, 5-Feb-2013.) $)
  sdomdif $p |- ( A ~< B -> ( B \ A ) =/= (/) ) $=
    ( csdm wbr cdif c0 wceq wn cvv wcel relsdom brrelexi wss ssdif0 cdom ssdomg
    wi domnsym syl6 syl5bir syl con2d pm2.43i neneqad ) ABCDZBAEZFUEUFFGZHUEUGU
    EUEAIJZUGUEHZQABCKLUGBAMZUHUIBANUHUJBAODUIBAIPBARSTUAUBUCUD $.

  $( An ordinal with more elements of some type is larger.  (Contributed by
     Stefan O'Rear, 2-Nov-2014.) $)
  onsdominel $p |- ( ( A e. On /\ B e. On /\ ( A i^i C ) ~< ( B i^i C ) ) ->
      A e. B ) $=
    ( con0 wcel cin csdm wbr wa wn wb ontri1 ancoms wi cdom inex1g ssrin ssdomg
    wss cvv syl2im domnsym syl6 adantr sylbird con4d 3impia ) ADEZBDEZACFZBCFZG
    HZABEZUHUIIZUMULUNUMJZBASZULJZUIUHUPUOKBALMUHUPUQNUIUHUPUKUJOHZUQUHUJTEUPUK
    UJSURACDPBACQUKUJTRUAUKUJUBUCUDUEUFUG $.

  ${
    $d f g z A $.  $d f g z B $.  $d z C $.
    $( Dominance over a set with one element added.  (Contributed by Mario
       Carneiro, 18-May-2015.) $)
    domunsn $p |- ( A ~< B -> ( A u. { C } ) ~<_ B ) $=
      ( vz csdm wbr cv wcel csn cun cdom c0 wceq wn wex sylib wa cvv mpan2 cin
      sdom0 breq2 mtbiri con2i neq0 cdif domdifsn cen vex en2sn endom syl snprc
      adantr snex 0dom syl6eqbr pm2.61i incom disjdif eqtri undom sylancl uncom
      biimpi wss simpr snssd undif syl5eq breqtrd exlimddv ) ABEFZDGZBHZACIZJZB
      KFDVMBLMZNVODOVRVMVRVMALEFAUABLAEUBUCUDDBUEPVMVOQZVQBVNIZUFZVTJZBKVSAWAKF
      ZVPVTKFZVQWBKFZVMWCVOABVNUGUNCRHZWDWFVPVTUHFZWDWFVNRHWGDUICVNRRUJSVPVTUKU
      LWFNZVPLVTKWHVPLMCUMVEVTVNUOUPUQURWCWDQWAVTTZLMWEWIVTWATLWAVTUSVTBUTVAAWA
      VPVTVBSVCVSWBVTWAJZBWAVTVDVSVTBVFWJBMVSVNBVMVOVGVHVTBVIPVJVKVL $.

    $( There exists a mapping from a set onto any (non-empty) set that it
       dominates.  (Contributed by NM, 23-Mar-2006.) $)
    fodomr $p |- ( ( (/) ~< B /\ B ~<_ A ) -> E. f f : A -onto-> B ) $=
      ( vz vg c0 cdom wa cvv wcel cv wex adantl wne crn cun sylib wceq wfun cdm
      csdm wbr wf1 wfo reldom brrelex2i wb brrelexi 0sdomg n0 syl6bb syl brdomi
      biimpac ccnv cdif csn cxp difexg snex xpexg sylancl vex cnvex jctil unexb
      wi wfn wf df-f1 simprbi fconst ffun ax-mp jctir df-rn eqcomi snnz ineq12i
      cin dmxp disjdif eqtri funun dmun uneq1i uneq2i 3eqtr2i wss f1f frn undif
      syl5eq df-fn sylanbrc rnun dfdm4 f1dm syl5eqr uneq1d xpeq1 0xp syl6eq rn0
      rneqd 0ss syl6eqss a1d rnxp adantr eqsstrd ex pm2.61ine ssequn2 sylan9eqr
      snssi df-fo foeq1 spcegv syl2im expdimp exlimdv syl3c ) FBUAUBZBAGUBZHAIJ
      ZDKZBJZDLZBAEKZUCZELZABCKZUDZCLZYEYFYDBAGUEUFMYEYDYIYEBIJZYDYIUGBAGUEUHYP
      YDBFNYIBIUIDBUJUKULUNYEYLYDBAEUMMYFYHYLYOVGZDYFYHYQYFYHHYKYOEYFYHYKYOYFYJ
      UOZAYJOZUPZYGUQZURZPZIJZYHYKHZABUUCUDZYOYFYRIJZUUBIJZHUUDYFUUHUUGYFYTIJUU
      AIJUUHAYSIUSYGUTYTUUAIIVAVBYJEVCVDVEYRUUBVFQUUEUUCAVHZUUCOZBRUUFUUEUUCSZU
      UCTZARZUUIYKUUKYHYKYRSZUUBSZHYRTZUUBTZVTZFRUUKYKUUNUUOYKBAYJVIZUUNBAYJVJV
      KYTUUAUUBVIUUOYTYGDVCZVLYTUUAUUBVMVNVOUURYSYTVTFUUPYSUUQYTYSUUPYJVPZVQUUA
      FNUUQYTRYGUUTVRYTUUAWAVNZVSYSAWBWCYRUUBWDVBMYKUUMYHYKUULYSYTPZAUULUUPUUQP
      YSUUQPUVCYRUUBWEYSUUPUUQUVAWFUUQYTYSUVBWGWHYKYSAWIZUVCARYKUUSUVDBAYJWJBAY
      JWKULYSAWLQWMMUUCAWNWOUUEUUJYROZUUBOZPZBYRUUBWPYKYHUVGBUVFPZBYKUVEBUVFYKU
      VEYJTBYJWQBAYJWRWSWTYHUVFBWIZUVHBRYHUVIVGYTFYTFRZUVIYHUVJUVFFBUVJUVFFOFUV
      JUUBFUVJUUBFUUAURFYTFUUAXAUUAXBXCXEXDXCBXFXGXHYTFNZYHUVIUVKYHHUVFUUABUVKU
      VFUUARYHYTUUAXIXJYHUUABWIUVKYGBXPMXKXLXMUVFBXNQXOWMABUUCXQWOYNUUFCUUCIABY
      MUUCXRXSXTYAYBXLYBYC $.
  $}

  ${
    $d f A $.  $d f B $.
    $( Injection of sets implies injection on power sets.  (Contributed by
       Mario Carneiro, 9-Apr-2015.) $)
    pwdom $p |- ( A ~<_ B -> ~P A ~<_ ~P B ) $=
      ( vf cdom wbr cpw c0 wceq pweq breq1d wne wfo wex cvv wcel reldom syl wss
      wa cv wb brrelexi 0sdomg biimpar simpl fodomr syl2anc vex fopwdom exlimiv
      csdm mpan brrelex2i pwexg 0ss sspwb mpbi ssdomg ee10 pm2.61ne ) ABDEZAFZB
      FZDEZGFZVCDEZAGAGHVBVEVCDAGIJVAAGKZSZBACTZLZCMZVDVHGAUKEZVAVKVAVLVGVAANOV
      LVGUAABDPUBANUCQUDVAVGUEBACUFUGVJVDCVINOVJVDCUHBAVIUIULUJQVAVCNOZVEVCRZVF
      VABNOVMABDPUMBNUNQGBRVNBUOGBUPUQVEVCNURUSUT $.
  $}

  ${
    $d x y z f A $.
    canth2.1 $e |- A e. _V $.
    $( Cantor's Theorem.  No set is equinumerous to its power set.
       Specifically, any set has a cardinality (size) strictly less than the
       cardinality of its power set.  For example, the cardinality of real
       numbers is the same as the cardinality of the power set of integers, so
       real numbers cannot be put into a one-to-one correspondence with
       integers.  Theorem 23 of [Suppes] p. 97.  For the function version, see
       ~ canth .  (Contributed by NM, 7-Aug-1994.) $)
    canth2 $p |- A ~< ~P A $=
      ( vx vy vf cpw csdm wbr cdom cen wn cvv wcel pwex cv csn snelpwi wceq wb
      wa vex sneqr sneq impbii a1i dom3 mp2an wf1o wex wfo canth f1ofo mto bren
      nex mtbir brsdom mpbir2an ) AAFZGHAUSIHZAUSJHZKALMUSLMUTBABNCDAUSCOZPZDOZ
      PZLLVBAQVCVERZVBVDRZSVBAMVDAMTVFVGVBVDCUAUBVBVDUCUDUEUFUGVAAUSEOZUHZEUIVI
      EVIAUSVHUJAVHBUKAUSVHULUMUOAUSEUNUPAUSUQUR $.
  $}

  ${
    $d x A $.
    $( Cantor's theorem with the sethood requirement expressed as an
       antecedent.  Theorem 23 of [Suppes] p. 97.  (Contributed by NM,
       7-Nov-2003.) $)
    canth2g $p |- ( A e. V -> A ~< ~P A ) $=
      ( vx cv cpw csdm wbr wceq wb pweq breq12 mpdan vex canth2 vtoclg ) CDZPEZ
      FGZAAEZFGZCABPAHQSHRTIPAJPAQSFKLPCMNO $.
  $}

  $( The power set of the power set of the union of a set does not belong to
     the set.  This theorem provides a way of constructing a new set that
     doesn't belong to a given set.  (Contributed by NM, 27-Jun-2008.) $)
  2pwuninel $p |- -. ~P ~P U. A e. A $=
    ( cuni cvv wcel cpw wn csdm wbr sdomirr wss elssuni cdom ssdomg pwexb sylbi
    canth2g sdomtr syl2anc domsdomtr ex syl5com syld syl5 mtoi elex bitri con3i
    sylibr pm2.61i ) ABZCDZUJEZEZADZFUKUNUMUMGHZUMIUNUMUJJZUKUOUMAKUKUPUMUJLHZU
    OUMUJCMUKUJUMGHZUQUOUKUJULGHULUMGHZURUJCPUKULCDZUSUJNZULCPOUJULUMQRUQURUOUM
    UJUMSTUAUBUCUDUNUKUNUMCDZUKUMAUEUKUTVBVAULNUFUHUGUI $.

  $( No set equals the power set of its power set.  (Contributed by NM,
     17-Nov-2008.) $)
  2pwne $p |- ( A e. V -> ~P ~P A =/= A ) $=
    ( wcel cpw wceq csdm wbr sdomirr canth2g cvv pwexg syl sdomtr syl2anc breq1
    syl5ibrcom mtoi neneqad ) ABCZADZDZASUAAEZUAUAFGZUAHSUCUBAUAFGZSATFGTUAFGZU
    DABISTJCUEABKTJILATUAMNUAAUAFOPQR $.

  ${
    $d x A $.  $d x B $.  $d x V $.  $d x W $.
    $( A stronger form of ~ pwuninel .  We can use ~ pwuninel , ~ 2pwuninel to
       create one or two sets disjoint from a given set ` A ` , but here we
       show that in fact such constructions exist for arbitrarily large
       disjoint extensions, which is to say that for any set ` B ` we can
       construct a set ` x ` that is equinumerous to it and disjoint from
       ` A ` .  (Contributed by Mario Carneiro, 7-Feb-2015.) $)
    disjen $p |- ( ( A e. V /\ B e. W ) ->
      ( ( A i^i ( B X. { ~P U. ran A } ) ) = (/) /\
          ( B X. { ~P U. ran A } ) ~~ B ) ) $=
      ( vx wcel crn cuni cpw csn cxp wceq c2nd cfv c1st ad2antll fvex syl cvv
      wa cin c0 cen wbr cop 1st2nd2 simprl eqeltrrd opelrn pwuninel xp2nd elsni
      eleq1d mtbiri pm2.65da elin sylnibr eq0rdv simpr rnexg adantr uniexg 3syl
      cv pwexg xpsneng syl2anc jca ) ACFZBDFZTZABAGZHZIZJZKZUAZUBLVPBUCUDZVKEVQ
      VKEVDZAFZVSVPFZTZVSVQFVKWBVSMNZVLFZVKWBTZVSONZWCUEZAFWDWEVSWGAWAVSWGLVKVT
      VSBVOUFPVKVTWAUGUHWFWCAVSOQVSMQUIRWEWDVNVLFVLUJWEWCVNVLWEWCVOFZWCVNLWAWHV
      KVTVSBVOUKPWCVNULRUMUNUOVSAVPUPUQURVKVJVNSFZVRVIVJUSVKVLSFZVMSFWIVIWJVJAC
      UTVAVLSVBVMSVEVCBVNDSVFVGVH $.

    $( Existence version of ~ disjen .  (Contributed by Mario Carneiro,
       7-Feb-2015.) $)
    disjenex $p |- ( ( A e. V /\ B e. W ) ->
      E. x ( ( A i^i x ) = (/) /\ x ~~ B ) ) $=
      ( wcel wa crn cuni cpw csn cxp cvv cin c0 wceq cen wbr cv wex simpr xpexg
      snex sylancl disjen ineq2 eqeq1d breq1 anbi12d spcegv sylc ) BDFZCEFZGZCB
      HIJZKZLZMFZBUQNZOPZUQCQRZGZBASZNZOPZVCCQRZGZATUNUMUPMFURULUMUAUOUCCUPEMUB
      UDBCDEUEVGVBAUQMVCUQPZVEUTVFVAVHVDUSOVCUQBUFUGVCUQCQUHUIUJUK $.
  $}

  ${
    domss2.1 $e |- G = `' ( F u.
      ( 1st |` ( ( B \ ran F ) X. { ~P U. ran A } ) ) ) $.
    $( A corollary of ~ disjenex .  If ` F ` is an injection from ` A ` to
       ` B ` then ` G ` is a right inverse of ` F ` from ` B ` to a superset of
       ` A ` .  (Contributed by Mario Carneiro, 7-Feb-2015.)  (Revised by Mario
       Carneiro, 24-Jun-2015.) $)
    domss2 $p |- ( ( F : A -1-1-> B /\ A e. V /\ B e. W ) ->
     ( G : B -1-1-onto-> ran G /\ A C_ ran G /\ ( G o. F ) = ( _I |` A ) ) ) $=
      ( wcel crn wf1o wss ccom cres wceq cun c0 cvv syl wb ax-mp cdif cuni c1st
      wf1 w3a cid cpw csn cxp ccnv cin f1f1orn 3ad2ant1 simp2 rnexg uniexg 3syl
      pwexg 1stconst cen wa difexg 3ad2ant3 disjen syl2anc simpld disjdif f1oun
      wbr a1i syl22anc undif2 f1f frn ssequn1 sylib syl5eq f1oeq3 f1ocnv f1oeq1
      mpbid sylibr wfo f1ofo forn mpbird ssun1 syl5sseqr ssid cores dmres f1odm
      wf cdm ineq2d syl6eq wrel relres reldm0 uneq2d cnvun eqtri resundir df-rn
      reseq1i reseq2i relcnv resdm uneq1i 3eqtrri 3eqtr3g coeq1d f1cocnv1 eqtrd
      un0 syl5eqr 3jca ) ABCUDZAEHZBFHZUEZBDIZDJZAYBKDCLZUFAMZNYAYCBABCIZUAZAIZ
      UBZUGZUHUIZOZDJZYABYLCUCYKMZOZUJZJZYMYAYLBYOJZYQYAYLYFYGOZYOJZYRYAAYFCJZY
      KYGYNJZAYKUKPNZYFYGUKZPNZYTXRXSUUAXTABCULUMYAYJQHZUUBYAYHQHZYIQHUUFYAXSUU
      GXRXSXTUNZAEUORYHQUPYIQURUQYGYJQUSRZYAUUCYKYGUTVIZYAXSYGQHZUUCUUJVAUUHXTX
      RUUKXSBYFFVBVCAYGEQVDVEVFUUEYAYFBVGZVJAYFYKYGCYNVHVKYAYSBNYTYRSYAYSYFBOZB
      YFBVLYAYFBKZUUMBNYAABCWMZUUNXRXSUUOXTABCVMUMABCVNRYFBVOVPVQYSBYLYOVRRWAYL
      BYOVSRDYPNYMYQSGBYLDYPVTTWBZYAYBYLNZYCYMSYAYMBYLDWCUUQUUPBYLDWDBYLDWEUQZY
      BYLBDVRRWFYAYLAYBAYKWGUURWHYAYDDYFMZCLZYEYFYFKUUTYDNYFWIDCYFWJTYAUUTCUJZC
      LZYEYAUUSUVACYAUVAYNUJZYFMZOZUVAPOUUSUVAYAUVDPUVAYAUVDWNZPNZUVDPNZYAUVFYF
      UVCWNZUKZPUVCYFWKYAUVJUUDPYAUVIYGYFYAUUBYGYKUVCJUVIYGNUUIYKYGYNVSYGYKUVCW
      LUQWOUULWPVQUVDWQUVHUVGSUVCYFWRUVDWSTWBWTUUSUVAUVCOZYFMUVAYFMZUVDOUVEDUVK
      YFDYPUVKGCYNXAXBXEUVAUVCYFXCUVLUVAUVDUVLUVAUVAWNZMZUVAYFUVMUVACXDXFUVAWQU
      VNUVANCXGUVAXHTXBXIXJUVAXOXKXLXRXSUVBYENXTABCXMUMXNXPXQ $.
  $}

  ${
    $d f g x A $.  $d f g x B $.  $d g F $.  $d f W $.
    $( A corollary of ~ disjenex .  If ` F ` is an injection from ` A ` to
       ` B ` then there is a right inverse ` g ` of ` F ` from ` B ` to a
       superset of ` A ` .  (Contributed by Mario Carneiro, 7-Feb-2015.)
       (Revised by Mario Carneiro, 24-Jun-2015.) $)
    domssex2 $p |- ( ( F : A -1-1-> B /\ A e. V /\ B e. W ) ->
      E. g ( g : B -1-1-> _V /\ ( g o. F ) = ( _I |` A ) ) ) $=
      ( wf1 wcel w3a crn cres cvv ccom wceq wa wf fex2 sylancl syl wss c1st cpw
      cdif cuni csn cxp cun ccnv cid cv wex f1f syl3an1 f1stres difexg 3ad2ant3
      a1i snex xpexg syl3anc unexg syl2anc cnvexg wf1o eqid domss2 simp1d f1of1
      ssv f1ss simp3d jca f1eq1 coeq1 eqeq1d anbi12d spcegv sylc ) ABDGZAEHZBFH
      ZIZDUABDJZUCZAJUDUBZUEZUFZKZUGZUHZLHZBLWJGZWJDMZUIAKZNZOZBLCUJZGZWQDMZWNN
      ZOZCUKWBWILHZWKWBDLHZWHLHZXBVSABDPVTWAXCABDULABDEFQUMWBWGWDWHPZWGLHZWDLHZ
      XDXEWBWDWFUNUQWBXGWFLHXFWAVSXGVTBWCFUOUPZWEURWDWFLLUSRXHWGWDWHLLQUTDWHLLV
      AVBWILVCSWBWLWOWBBWJJZWJGZXILTWLWBBXIWJVDZXJWBXKAXITZWOABDWJEFWJVEVFZVGBX
      IWJVHSXIVIBXILWJVJRWBXKXLWOXMVKVLXAWPCWJLWQWJNZWRWLWTWOBLWQWJVMXNWSWMWNWQ
      WJDVNVOVPVQVR $.

    $( Weakening of ~ domssex to forget the functions in favor of dominance and
       equinumerosity.  (Contributed by Mario Carneiro, 7-Feb-2015.)  (Revised
       by Mario Carneiro, 24-Jun-2015.) $)
    domssex $p |- ( A ~<_ B -> E. x ( A C_ x /\ B ~~ x ) ) $=
      ( vf cdom wbr cv wf1 wex cvv wcel wss cen crn cres syl3anc syl wceq sylc
      wa brdomi reldom brrelex2i wi c1st cdif cuni cpw csn cxp cun ccnv f1stres
      vex wf a1i difexg adantl snex xpexg sylancl fex2 unexg sylancr rnexg wf1o
      cnvexg ccom cid simpl f1dm dmex syl6eqelr adantr simpr eqid domss2 simp2d
      w3a cdm simp1d f1oen3g syl2anc jca sseq2 breq2 anbi12d spcegv ex exlimiv
      ) BCEFBCDGZHZDICJKZBAGZLZCWNMFZTZAIZBCDUABCEUBUCWLWMWRUDDWLWMWRWLWMTZWKUE
      CWKNZUFZBNUGUHZUIZUJZOZUKZULZNZJKZBXHLZCXHMFZTZWRWSXGJKZXIWSXFJKZXMWSWKJK
      XEJKZXNDUNZWSXDXAXEUOZXDJKZXAJKZXOXQWSXAXCUMUPWSXSXCJKXRWMXSWLCWTJUQURZXB
      USXAXCJJUTVAXTXDXAXEJJVBPWKXEJJVCVDXFJVGQZXGJVEQWSXJXKWSCXHXGVFZXJXGWKVHV
      IBORZWSWLBJKZWMYBXJYCVSWLWMVJWLYDWMWLBWKVTJBCWKVKWKXPVLVMVNWLWMVOBCWKXGJJ
      XGVPVQPZVRWSXMYBXKYAWSYBXJYCYEWACXHXGJWBWCWDWQXLAXHJWNXHRWOXJWPXKWNXHBWEW
      NXHCMWFWGWHSWIWJS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Equinumerosity (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d s t u v w x y z A $.  $d s t u v w x y z C $.  $d s t u v w y z X $.
    $d u v w x z B $.  $d u v w y z D $.  $d s t u v w x z Y $.  $d u w z ph $.
    xpf1o.1 $e |- ( ph -> ( x e. A |-> X ) : A -1-1-onto-> B ) $.
    xpf1o.2 $e |- ( ph -> ( y e. C |-> Y ) : C -1-1-onto-> D ) $.
    $( Construct a bijection on a cross product given bijections on the
       factors.  (Contributed by Mario Carneiro, 30-May-2015.) $)
    xpf1o $p |- ( ph -> ( x e. A , y e. C |-> <. X , Y >. ) :
        ( A X. C ) -1-1-onto-> ( B X. D ) ) $=
      ( vu vz vw vs vt wcel wral wceq wa vv cv c1st cfv csb c2nd cop wreu cmpt2
      cxp wf1o xp1st adantl cmpt eqid f1ompt sylib simpld nfcsb1v nfel1 csbeq1a
      adantr eleq1d rspc sylc xp2nd opelxpi syl2anc ralrimiva weq wrex r19.21bi
      wb simprd reu6 anim12dan reeanv pm4.38 ralimdv com12 impcom reximi sylbir
      syl vex op1std csbeq1d eqeq2d op2ndd anbi12d eqeq1 bibi12d ralxp nfv nfcv
      ex nfeq2 nfan nfbi nfral anbi2d opeq2 eqeq1d cbvral anbi1d ralbidv syl5bb
      opeq1 bitr4i eqeq2 syl6bb bibi2d 2ralbidv rexxp sylibr ralrimivva reubidv
      opth nfop opeq12 syl2an cbvmpt2 opeq12d mpt2mpt eqtr4i sylanbrc ) ABLUBZU
      CUDZHUEZCYGUFUDZIUEZUGZEGUJZQZLDFUJZRUAUBZYLSZLYOUHZUAYMRZYOYMBCDFHIUGZUI
      ZUKAYNLYOAYGYOQZTZYIEQZYKGQZYNUUCYHDQZHEQZBDRZUUDUUBUUFAYGDFULUMAUUHUUBAU
      UHMUBZHSZBDUHZMERZADEBDHUNZUKUUHUULTJBMDEHUUMUUMUOUPUQZURVBUUGUUDBYHDBYIE
      BYHHUSUTBUBZYHSHYIEBYHHVAVCVDVEUUCYJFQZIGQZCFRZUUEUUBUUPAYGDFVFUMAUURUUBA
      UURNUBZISZCFUHZNGRZAFGCFIUNZUKUURUVBTKCNFGIUVCUVCUOUPUQZURVBUUQUUECYJFCYK
      GCYJIUSUTCUBZYJSIYKGCYJIVAVCVDVEYIYKEGVGVHVIAUUIYISZUUSYKSZTZLYOUHZNGRMER
      YSAUVIMNEGAUUIEQZUUSGQZTTZUVHLUAVJZVMZLYORZUAYOVKZUVIUVLUUJUUTTZBOVJZCPVJ
      ZTZVMZCFRZBDRZPFVKZODVKZUVPUVLUUJUVRVMZBDRZODVKZUUTUVSVMZCFRZPFVKZTZUWEAU
      VJUWHUVKUWKAUVJTUUKUWHAUUKMEAUUHUULUUNVNVLUUJBODVOUQAUVKTUVAUWKAUVANGAUUR
      UVBUVDVNVLUUTCPFVOUQVPUWLUWGUWJTZPFVKZODVKUWEUWGUWJOPDFVQUWNUWDODUWMUWCPF
      UWJUWGUWCUWJUWFUWBBDUWFUWJUWBUWFUWIUWACFUWFUWIUWAUUJUUTUVRUVSVRWPVSVTVSWA
      WBWBWCWDUVOUWCUAOPDFUVOUVQUUOUVEUGZYPSZVMZCFRZBDRZYPOUBZPUBZUGZSZUWCUVOUU
      IBUWTHUEZSZUUSCUXAIUEZSZTZUXBYPSZVMZPFRZODRUWSUVNUXJLOPDFYGUXBSZUVHUXHUVM
      UXIUXLUVFUXEUVGUXGUXLYIUXDUUIUXLBYHUWTHUWTUXAYGOWEZPWEZWFWGWHUXLYKUXFUUSU
      XLCYJUXAIUWTUXAYGUXMUXNWIWGWHWJYGUXBYPWKWLWMUWRUXKBODUWROWNUXJBPFBFWOUXHU
      XIBUXEUXGBBUUIUXDBUWTHUSWQUXGBWNWRUXIBWNWSWTUWRUUJUXGTZUUOUXAUGZYPSZVMZPF
      RUVRUXKUWQUXRCPFUWQPWNUXOUXQCUUJUXGCUUJCWNCUUSUXFCUXAIUSWQWRUXQCWNWSUVSUV
      QUXOUWPUXQUVSUUTUXGUUJUVSIUXFUUSCUXAIVAWHXAUVSUWOUXPYPUVEUXAUUOXBXCWLXDUV
      RUXRUXJPFUVRUXOUXHUXQUXIUVRUUJUXEUXGUVRHUXDUUIBUWTHVAWHXEUVRUXPUXBYPUUOUW
      TUXAXHXCWLXFXGXDXIUXCUWQUWABCDFUXCUWPUVTUVQUXCUWPUWOUXBSUVTYPUXBUWOXJUUOU
      VEUWTUXABWECWEXRXKXLXMXGXNXOUVHLUAYOVOXOXPYRUVIUAMNEGYPUUIUUSUGZSZYQUVHLY
      OUXTYQUXSYLSUVHYPUXSYLWKUUIUUSYIYKMWEZNWEZXRXKXQWMXOLUAYOYMYLUUAUUAMNDFBU
      UIHUEZCUUSIUEZUGZUILYOYLUNBCMNDFYTUYEMYTWONYTWOBUYCUYDBUUIHUSBUYDWOXSCUYC
      UYDCUYCWOCUUSIUSXSBMVJHUYCSIUYDSYTUYESCNVJBUUIHVACUUSIVAHIUYCUYDXTYAYBMNL
      DFYLUYEYGUXSSZYIUYCYKUYDUYFBYHUUIHUUIUUSYGUYAUYBWFWGUYFCYJUUSIUUIUUSYGUYA
      UYBWIWGYCYDYEUPYF $.
  $}

  ${
    $d A a c $.  $d B a c $.  $d C c $.  $d D a c $.
    $( Equinumerosity law for cross product.  Proposition 4.22(b) of
       [Mendelson] p. 254.  (Contributed by NM, 24-Jul-2004.)  (Proof shortened
       by Mario Carneiro, 26-Apr-2015.) $)
    xpen $p |- ( ( A ~~ B /\ C ~~ D ) -> ( A X. C ) ~~ ( B X. D ) ) $=
      ( cen wbr cxp cdom cvv wcel relen endom xpdom1g syl2anr brrelex2i xpdom2g
      brrelexi syl2an domtr syl2anc wa ensym syl sbth ) ABEFZCDEFZUAZACGZBDGZHF
      ZUIUHHFZUHUIEFUGUHBCGZHFZULUIHFZUJUFCIJABHFUMUECDEKQABLABCIMNUEBIJCDHFUNU
      FABEKOCDLCDBIPRUHULUISTUGUIADGZHFZUOUHHFZUKUFDIJBAHFZUPUECDEKOUEBAEFURABU
      BBALUCBADIMNUEAIJDCHFZUQUFABEKQUFDCEFUSCDUBDCLUCDCAIPRUIUOUHSTUHUIUDT $.
  $}

  ${
    $d f g x y A $.  $d f g x y B $.  $d f g x y C $.  $d f g x y D $.
    $( Two set exponentiations are equinumerous when their bases and exponents
       are equinumerous.  Theorem 6H(c) of [Enderton] p. 139.  (Contributed by
       NM, 16-Dec-2003.)  (Proof shortened by Mario Carneiro, 26-Apr-2015.) $)
    mapen $p |- ( ( A ~~ B /\ C ~~ D ) -> ( A ^m C ) ~~ ( B ^m D ) ) $=
      ( vf vg cv wf1o wex cmap wa ccom cvv wcel wf f1of adantr syl wb wceq bren
      vx vy cen wbr co eeanv ccnv a1i elmapi fco sylan f1ocnv adantl syl2anc ex
      ovex syl5 crn wfo f1ofo forn vex rnex syl6eqelr elmapg sylibrd id syl2anr
      cdm f1odm dmex coass cres f1ococnv2 ad2antrr coeq1d adantrl fcoi2 syl5eqr
      eqtrd eqeq2d f1ococnv1 ad2antlr coeq2d adantrr fcoi1 syl5eq syl6bb bitr4d
      cid eqcom wf1 f1of1 simprl cocan1 syl3anc wfn ffn ad2antll cocan2 3bitr3d
      syl2ani en3d exlimivv sylbir syl2anb ) ABUDUEABEGZHZEIZCDFGZHZFIZACJUFZBD
      JUFZUDUEZCDUDUEABEUACDFUAXJXMKXIXLKZFIEIXPXIXLEFUGXQXPEFXQUBUCXNXOXHUBGZL
      ZXKUHZLZXHUHZUCGZXKLZLZXNMNXQACJUQUIXOMNXQBDJUQUIXQXRXNNZDBYAOZYAXONZYFCA
      XROZXQYGXRACUJZXQYIYGXQYIKCBXSOZDCXTOZYGXQABXHOZYIYKXIYMXLABXHPQCABXHXRUK
      ULZXQYLYIXQDCXTHZYLXLYOXICDXKUMUNDCXTPRQDCBXSXTUKUOZUPURXQBMNDMNYHYGSXQBX
      HUSZMXQABXHUTZYQBTXIYRXLABXHVAQABXHVBRXHEVCZVDVEXQDXKUSZMXQCDXKUTZYTDTXLU
      UAXICDXKVAUNZCDXKVBRXKFVCZVDVEBDYAMMVFUOVGXQYCXONZCAYEOZYEXNNZUUDDBYCOZXQ
      UUEYCBDUJZXQUUGUUEXQUUGKBAYBOZCBYDOZUUEXQUUIUUGXQBAYBHZUUIXIUUKXLABXHUMQB
      AYBPRQUUGUUGCDXKOZUUJXQUUGVHXLUULXICDXKPUNCDBYCXKUKVIZCBAYBYDUKUOZUPURXQA
      MNCMNUUFUUESXQAXHVJZMXIUUOATXLABXHVKQXHYSVLVEXQCXKVJZMXLUUPCTXICDXKVKUNXK
      UUCVLVEACYEMMVFUOVGYFXQYIUUGXRYETZYCYATZSZUUDYJUUHXQYIUUGKZUUSXQUUTKZXSXH
      YELZTZYDYAXKLZTZUUQUURUVAUVCXSYDTZUVEUVAUVBYDXSUVAUVBXHYBLZYDLZYDXHYBYDVM
      UVAUVHWKBVNZYDLZYDUVAUVGUVIYDXIUVGUVITXLUUTABXHVOVPVQUVAUUJUVJYDTXQUUGUUJ
      YIUUMVRCBYDVSRWAVTWBUVAUVEYDXSTUVFUVAUVDXSYDUVAUVDXSXTXKLZLZXSXSXTXKVMUVA
      UVLXSWKCVNZLZXSUVAUVKUVMXSXLUVKUVMTXIUUTCDXKWCWDWEUVAYKUVNXSTXQYIYKUUGYNW
      FCBXSWGRWAWHWBYDXSWLWIWJUVAABXHWMZYIUUEUVCUUQSXIUVOXLUUTABXHWNVPXQYIUUGWO
      XQUUGUUEYIUUNVRCABXHXRYEWPWQUVAUUAYCDWRZYADWRZUVEUURSXQUUAUUTUUBQUUGUVPXQ
      YIDBYCWSWTUVAYGUVQXQYIYGUUGYPWFDBYAWSRCDXKYCYAXAWQXBUPXCXDXEXFXG $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Order-preserving property of set exponentiation.  Theorem 6L(c) of
       [Enderton] p. 149.  (Contributed by NM, 27-Jul-2004.)  (Revised by Mario
       Carneiro, 9-Mar-2013.) $)
    mapdom1 $p |- ( A ~<_ B -> ( A ^m C ) ~<_ ( B ^m C ) ) $=
      ( vx cdom wbr cvv wcel cmap co wa cv cen wss wex wb reldom adantl syl2anc
      c0 brrelex2i domeng syl ibi adantr simpl enrefg mapen syl2anr ovex simprr
      ad2antrr mapss ssdomg mpsyl endomtr exlimddv wn wceq elmapex simprd con3i
      eq0rdv 0dom syl6eqbr pm2.61dan ) ABEFZCGHZACIJZBCIJZEFZVGVHKZADLZMFZVMBNZ
      KZVKDVGVPDOZVHVGVQVGBGHZVGVQPABEQUAZDABGUBUCUDUEVLVPKZVIVMCIJZMFZWAVJEFZV
      KVPVNCCMFZWBVLVNVOUFVHWDVGCGUGRAVMCCUHUIVJGHVTWAVJNZWCBCIUJZVTVRVOWEVGVRV
      HVPVSULVLVNVOUKVMBCGUMSWAVJGUNUOVIWAVJUPSUQVGVHURZKVITVJEWGVITUSVGWGDVIVM
      VIHZVHWHAGHVHVMACUTVAVBVCRVJWFVDVEVF $.
  $}

  ${
    $d f g x y A $.  $d f g x y z B $.  $d f g x y z C $.  $d f g x y V $.
    $d f g x y W $.  $d f g x y X $.
    $( Equinumerosity law for double set exponentiation.  Proposition 10.45 of
       [TakeutiZaring] p. 96.  (Contributed by NM, 21-Feb-2004.)  (Revised by
       Mario Carneiro, 24-Jun-2015.) $)
    mapxpen $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
      ( ( A ^m B ) ^m C ) ~~ ( A ^m ( B X. C ) ) ) $=
      ( vx vy wcel cmap co cv cfv cmpt cvv wf wral wa eqid wceq vf vg w3a cmpt2
      cxp ovex a1i elmapi ffvelrnda syl an32s ralrimiva fmpt2 sylib simp1 xpexg
      3adant1 elmapg syl2anc syl5ibr fovrn 3expa sylanl1 fmptd 3adant3 ad2antrr
      wb adantl mpbird simp3 sylancr sylibrd wfn ad2antll fnov adantlrl 3adant2
      ex ffn simp1l2 simp1l1 fex2 syl3anc fvmpt2 simp2 sylancl eqtrd mpt2eq3dva
      fveq1d eqtr4d nfmpt1 nfmpt nfeq2 fveq1 a1d ralrimi jctil mpt2eq123 eqeq2d
      nfcv syl5ibrcom ad2antrl feqmptd simprl sylan mpteq2dva nfmpt22 eqidd nfv
      nfmpt21 fvex ovmpt4g mp3an3 oveq eqeq1d exp3acom23 ralrimd mpteq12 ee12an
      impbid en3d ) ADIZBEIZCFIZUCZUAUBABJKZCJKZABCUEZJKZGHBCGLZHLZUALZMZMZUDZH
      CGBYJYKUBLZKZNZNZYGOIYEYFCJUFUGYIOIYEAYHJUFUGYLYGIZYOYIIZYEYHAYOPZYTYNAIZ
      HCQZGBQUUBYTUUDGBYTYJBIZRUUCHCYTYKCIZUUEUUCYTUUFRZBAYJYMUUGYMYFIBAYMPZYTC
      YFYKYLYLYFCUHZUIYMABUHUJZUIUKULULGHBCYNAYOYOSZUMUNYEYBYHOIZUUAUUBVGYBYCYD
      UOYCYDUULYBBCEFUPUQAYHYODOURUSUTYEYPYIIZCYFYSPZYSYGIZYEUUMUUNYEUUMRZHCYRY
      FYSUUPUUFRZYRYFIZBAYRPZUUQGBYQAYRUUPYHAYPPZUUFUUEYQAIZUUMUUTYEYPAYHUHZVHU
      UTUUEUUFUVAUUTUUEUUFUVAYJYKABCYPVAVBUKVCYRSZVDZYEUURUUSVGZUUMUUFYBYCUVEYD
      ABYRDEURVEVFVIYSSZVDVRYEYFOIYDUUOUUNVGABJUFYBYCYDVJYFCYSOFURVKVLYEYTUUMRZ
      YLYSTZYPYOTZVGYEUVGRZUVHUVIUVJUVIUVHYPGHBCYJYKYSMZMZUDZTUVJYPGHBCYQUDZUVM
      UVJYPYHVMZYPUVNTUUMUVOYEYTUUMUUTUVOUVBYHAYPVSUJVNGHBCYPVOUNUVJGHBCUVLYQUV
      JUUEUUFUCZUVLYJYRMZYQUVPYJUVKYRUVPUUFYROIZUVKYRTUVJUUEUUFVJUVPUUSYCYBUVRU
      VJUUFUUSUUEYEUUMUUFUUSYTUVDVPVQYBYCYDUVGUUEUUFVTYBYCYDUVGUUEUUFWABAYREDWB
      WCHCYROYSUVFWDUSWIUVPUUEYQOIUVQYQTUVJUUEUUFWEYJYKYPUFGBYQOYRUVCWDWFWGWHWJ
      UVHYOUVMYPUVHBBTZCCTZYNUVLTZHCQZRZGBQYOUVMTBSUVHUWCGBGYLYSGHCYRGCWTGBYQWK
      WLWMUVHUWCUUEUVHUWBUVTUVHUWAHCHYLYSHCYRWKWMUVHUWAUUFUVHYJYMUVKYKYLYSWNWIW
      OWPCSZWQWOWPGHBCYNBCUVLWRVKWSXAUVJUVHUVIYLHCGBYNNZNZTUVJYLHCYMNUWFUVJHCYF
      YLYTCYFYLPYEUUMUUIXBXCUVJHCYMUWEUVJUUFRGBAYMUVJYTUUFUUHYEYTUUMXDUUJXEXCXF
      WGUVIYSUWFYLUVIUVTYRUWETZHCQYSUWFTUWDUVIUWGHCHYPYOGHBCYNXGWMUVIUVSUUFYQYN
      TZGBQUWGUVIBXHUVIUUFUWHGBGYPYOGHBCYNXJWMUUFGXIUVIUUEUUFUWHUUEUUFRUWHUVIYJ
      YKYOKZYNTZUUEUUFYNOIUWJYJYMXKGHBCYNYOOUUKXLXMUVIYQUWIYNYJYKYPYOXNXOUTXPXQ
      GBYQBYNXRXSWPHCYRCUWEXRVKWSXAXTVRYA $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z w C $.
    xpmapen.1 $e |- A e. _V $.
    xpmapen.2 $e |- B e. _V $.
    xpmapen.3 $e |- C e. _V $.
    ${
      $d y z D $.  $d y z R $.  $d x z S $.
      xpmapenlem.4 $e |- D = ( z e. C |-> ( 1st ` ( x ` z ) ) ) $.
      xpmapenlem.5 $e |- R = ( z e. C |-> ( 2nd ` ( x ` z ) ) ) $.
      xpmapenlem.6 $e |- S = ( z e. C |->
               <. ( ( 1st ` y ) ` z ) , ( ( 2nd ` y ) ` z ) >. ) $.
      $( Lemma for ~ xpmapen .  (Contributed by NM, 1-May-2004.)  (Revised by
         Mario Carneiro, 16-Nov-2014.) $)
      xpmapenlem $p |- ( ( A X. B ) ^m C ) ~~ ( ( A ^m C ) X. ( B ^m C ) ) $=
        ( wcel cfv c1st wa wceq cxp cmap co cop ovex cv wf elmap ffvelrn sylanb
        xpex xp1st syl fmptd c2nd xp2nd opelxpi syl2anc sylib ffvelrnda 1st2nd2
        sylibr ad2antlr cmpt feqmptd simplr fveq1d cvv opex fvmpt2 mpan2 adantl
        eqtrd fveq2d fvex op1st syl6eq syl5eq eqtr4d op2nd opeq12d simpll simpr
        mpteq2dva ad2antrr op1stg sylan9eq op2ndg impbida en3i ) ABDEUAZFUBUCZD
        FUBUCZEFUBUCZUAZGHUDZIWKFUBUEWMWNDFUBUEEFUBUEUKAUFZWLPZGWMPZHWNPZWPWOPW
        RFDGUGWSWRCFCUFZWQQZRQZDGWRXAFPZSZXBWKPZXCDPWRFWKWQUGZXDXFWKFWQDEJKUKZL
        UHZFWKXAWQUIUJZXBDEULUMMUNDFGJLUHVBZWRFEHUGWTWRCFXBUOQZEHXEXFXLEPXJXBDE
        UPUMNUNEFHKLUHVBZGHWMWNUQURBUFZWOPZFWKIUGIWLPXOCFXAXNRQZQZXAXNUOQZQZUDZ
        WKIXOXDSXQDPXSEPXTWKPXOFDXAXPXOXPWMPFDXPUGXNWMWNULDFXPJLUHUSZUTXOFEXAXR
        XOXRWNPFEXRUGXNWMWNUPEFXRKLUHUSZUTXQXSDEUQUROUNWKFIXHLUHVBWRXOSZWQITZXN
        WPTZYCYDSZXNXPXRUDZWPXOXNYGTWRYDXNWMWNVAVCYFXPGXRHYFXPCFXQVDZGXOXPYHTWR
        YDXOCFDXPYAVEVCYFGCFXCVDYHMYFCFXCXQYFXDSZXCXTRQXQYIXBXTRYIXBXAIQZXTYIXA
        WQIYCYDXDVFVGXDYJXTTZYFXDXTVHPYKXQXSVICFXTVHIOVJVKVLVMZVNXQXSXAXPVOZXAX
        RVOZVPVQWDVRVSYFXRCFXSVDZHXOXRYOTWRYDXOCFEXRYBVEVCYFHCFXLVDYONYFCFXLXSY
        IXLXTUOQXSYIXBXTUOYLVNXQXSYMYNVTVQWDVRVSWAVMYCYESZWQCFXBVDZIYPCFWKWQYPW
        RXGWRXOYEWBXIUSZVEYPICFXTVDYQOYPCFXTXBYPXDSZXTXCXLUDZXBYSXQXCXSXLYPXDXQ
        XAGQZXCYPXAXPGYPXPWPRQZGYPXNWPRYCYEWCZVNYPWSWTUUBGTWRWSXOYEXKWEZWRWTXOY
        EXMWEZGHWMWNWFURVMVGXDXCVHPUUAXCTXBRVOCFXCVHGMVJVKWGYPXDXSXAHQZXLYPXAXR
        HYPXRWPUOQZHYPXNWPUOUUCVNYPWSWTUUGHTUUDUUEGHWMWNWHURVMVGXDXLVHPUUFXLTXB
        UOVOCFXLVHHNVJVKWGWAYSXFXBYTTYPFWKXAWQYRUTXBDEVAUMVSWDVRVSWIWJ $.
    $}

    $( Equinumerosity law for set exponentiation of a cross product.  Exercise
       4.47 of [Mendelson] p. 255.  (Contributed by NM, 23-Feb-2004.)  (Proof
       shortened by Mario Carneiro, 16-Nov-2014.) $)
    xpmapen $p |- ( ( A X. B ) ^m C ) ~~ ( ( A ^m C ) X. ( B ^m C ) ) $=
      ( vx vy vz vw cv cfv c1st cmpt c2nd cop weq fveq2 fveq2d cbvmptv opeq12d
      xpmapenlem ) GHIABCJCJKZGKZLZMLZNJCUEOLZNJCUCHKZMLZLZUCUHOLZLZPZNDEFJICUF
      IKZUDLZMLJIQZUEUOMUCUNUDRZSTJICUGUOOLUPUEUOOUQSTJICUMUNUILZUNUKLZPUPUJURU
      LUSUCUNUIRUCUNUKRUATUB $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y V $.  $d x y W $.
    $d x y X $.
    $( Equinumerosity law for set exponentiation of a disjoint union.  Exercise
       4.45 of [Mendelson] p. 255.  (Contributed by NM, 23-Sep-2004.)  (Revised
       by Mario Carneiro, 29-Apr-2015.) $)
    mapunen $p |- ( ( ( A e. V /\ B e. W /\ C e. X ) /\ ( A i^i B ) = (/) ) ->
                  ( C ^m ( A u. B ) ) ~~ ( ( C ^m A ) X. ( C ^m B ) ) ) $=
      ( vx wcel c0 wceq wa cun cmap co cres cop cvv wf wb syl2anc vy w3a cin cv
      cxp c1st cfv c2nd ovex a1i xpex wss elmapi ssun1 fssres sylancl ssun2 jca
      opelxp simpl3 simpl1 elmapg simpl2 anbi12d syl5bb syl5ibr xp1st syl xp2nd
      adantl simplr fun2 syl21anc unexg sylibrd 1st2nd2 ad2antll adantrl eqtr4i
      res0 reseq2d 3eqtr4a fresaunres1 syl3anc fresaunres2 eqtr4d reseq1 eqeq2d
      opeq12d syl5ibrcom wfn ffn fnresdm 3syl ad2antrl eqcomd vex op1std op2ndd
      ex resex uneq12d resundi syl6eqr impbid en3d ) ADHZBEHZCFHZUBZABUCZIJZKZG
      UACABLZMNZCAMNZCBMNZUEZGUDZAOZXSBOZPZUAUDZUFUGZYCUHUGZLZXOQHXMCXNMUIUJXRQ
      HXMXPXQCAMUICBMUIUKUJXSXOHZYBXRHZXMACXTRZBCYARZKZYGYIYJYGXNCXSRZAXNULYIXS
      CXNUMZABUNXNCAXSUOUPYGYLBXNULYJYMBAUQXNCBXSUOUPURYHXTXPHZYAXQHZKXMYKXTYAX
      PXQUSXMYNYIYOYJXMXIXGYNYISXGXHXIXLUTZXGXHXIXLVAZCAXTFDVBTXMXIXHYOYJSYPXGX
      HXIXLVCZCBYAFEVBTVDVEVFXMYCXRHZXNCYFRZYFXOHZXMYSYTXMYSKZACYDRZBCYERZXLYTU
      UBYDXPHZUUCYSUUEXMYCXPXQVGVJYDCAUMVHZUUBYEXQHZUUDYSUUGXMYCXPXQVIVJYECBUMV
      HZXJXLYSVKABCYDYEVLVMWTXMXIXNQHZUUAYTSYPXMXGXHUUIYQYRABDEVNTCXNYFFQVBTVOX
      MYGYSKZXSYFJZYCYBJZSXMUUJKZUUKUULUUMUULUUKYCYFAOZYFBOZPZJUUMYCYDYEPZUUPYS
      YCUUQJXMYGYCXPXQVPVQUUMUUNYDUUOYEUUMUUCUUDYDXKOZYEXKOZJZUUNYDJXMYSUUCYGUU
      FVRZXMYSUUDYGUUHVRZUUMYDIOZYEIOZUURUUSUVCIUVDYDVTYEVTVSUUMXKIYDXJXLUUJVKZ
      WAUUMXKIYEUVEWAWBZABCYDYEWCWDUUMUUCUUDUUTUUOYEJUVAUVBUVFABCYDYEWEWDWIWFUU
      KYBUUPYCUUKXTUUNYAUUOXSYFAWGXSYFBWGWIWHWJUUMUUKUULXSXSXNOZJUUMUVGXSYGUVGX
      SJZXMYSYGYLXSXNWKUVHYMXNCXSWLXNXSWMWNWOWPUULYFUVGXSUULYFXTYALUVGUULYDXTYE
      YAXTYAYCXSAGWQZXAZXSBUVIXAZWRXTYAYCUVJUVKWSXBXSABXCXDWHWJXEWTXF $.
  $}

  ${
    $d x y z w v u A $.
    $( A cardinal power with exponent 2 is equivalent to a cross product with
       itself.  (Contributed by Mario Carneiro, 31-May-2015.) $)
    map2xp $p |- ( A e. V -> ( A ^m 2o ) ~~ ( A X. A ) ) $=
      ( vx wcel c2o cmap co c0 csn c1o cxp cen wbr cvv wceq snex a1i id breq12d
      oveq1 cun cpr df2o3 df-pr eqtri oveq2i cin wn 1n0 neii elsni disjsn mpbir
      mto mapunen syl31anc syl5eqbr cv vex mapsnen vtoclg df1o2 eqeltri syl2anc
      0ex xpen entr ) ABDZAEFGZAHIZFGZAJIZFGZKZLMVNAAKZLMZVIVOLMVHVIAVJVLUAZFGZ
      VNLEVQAFEHJUBVQUCHJUDUEUFVHVJNDZVLNDZVHVJVLUGHOZVRVNLMVSVHHPZQVTVHJPQVHRW
      AVHWAJVJDZUHWCJHOJHUIUJJHUKUNVJJULUMQVJVLANNBUOUPUQVHVKALMZVMALMZVPCURZVJ
      FGZWFLMWDCABWFAOZWGVKWFALWFAVJFTWHRZSWFHCUSZVEUTVAWFVLFGZWFLMWECABWHWKVMW
      FALWFAVLFTWISWFJWJJVJNVBWBVCUTVAVKAVMAVFVDVIVNVOVGVD $.
  $}

  ${
    $d x y A $.  $d x B $.  $d x C $.  $d x V $.  $d x W $.
    $( Order-preserving property of set exponentiation.  Theorem 6L(d) of
       [Enderton] p. 149.  (Contributed by NM, 23-Sep-2004.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    mapdom2 $p |- ( ( A ~<_ B /\ -. ( A = (/) /\ C = (/) ) ) ->
                  ( C ^m A ) ~<_ ( C ^m B ) ) $=
      ( vx cdom wbr c0 wceq wa wn cvv wcel cmap co wne syl ovex cen syl2anc a1i
      simpr oveq1d simplr idd jctird mtod neneqad map0b eqtrd 0dom syl6eqbr wss
      cv wex simpll wb reldom brrelex2i ad2antrr domeng enrefg ad2antlr simprrl
      mpbid mapen cdif cxp simprl difexg map0g simpl syl6bi necon3d mpd syl3anc
      wi xpdom3 cun cin vex disjdif mapunen syl31anc ensymd simprrr undif sylib
      breqtrd domentr endomtr expr exlimdv adantlr pm2.61dane an32s ex reldmmap
      oveq2d ovprc1 pm2.61d1 ) ABEFZAGHZCGHZIZJZIZCKLZCAMNZCBMNZEFZXFXGXJXAXGXE
      XJXAXGIZXEIZXJCGXLXCIZXHGXIEXMXHGAMNZGXMCGAMXLXCUAZUBXMAGOXNGHXMAGXMXBXDX
      KXEXCUCXMXBXBXCXMXBUDXOUEUFUGAUHPUIXICBMQUJZUKXKCGOZXJXEXKXQIZADUMZRFZXSB
      ULZIZDUNZXJXRXAYCXAXGXQUOXRBKLZXAYCUPXAYDXGXQABEUQURZUSDABKUTPVDXRYBXJDXK
      XQYBXJXKXQYBIZIZXHCXSMNZRFZYHXIEFZXJYGCCRFZXTYIXGYKXAYFCKVAVBXKXQXTYAVCCC
      AXSVESYGYHYHCBXSVFZMNZVGZEFZYNXIRFYJYGYHKLZYMKLZYMGOZYOYPYGCXSMQTYQYGCYLM
      QTYGXQYRXKXQYBVHYGXGYLKLZXQYRVPXAXGYFUCZYGYDYSXAYDXGYFYEUSBXSKVIPZXGYSIZY
      MGCGUUBYMGHXCYLGOZIXCCYLKKVJXCUUCVKVLVMSVNYHYMKKVQVOYGYNCXSYLVRZMNZXIRYGU
      UEYNYGXSKLZYSXGXSYLVSGHZUUEYNRFUUFYGDVTTUUAYTUUGYGXSBWATXSYLCKKKWBWCWDYGU
      UDBCMYGYAUUDBHXKXQXTYAWEXSBWFWGWRWHYHYNXIWISXHYHXIWJSWKWLVNWMWNWOWPXGJXHG
      XIECAMWQWSXPUKWT $.

    $( Set exponentiation dominates the mantissa.  (Contributed by Mario
       Carneiro, 30-Apr-2015.) $)
    mapdom3 $p |- ( ( A e. V /\ B e. W /\ B =/= (/) ) -> A ~<_ ( A ^m B ) ) $=
      ( vx vy wcel c0 wne cmap co cdom wbr cv wex wa n0 cen wceq vex w3a csn id
      oveq1 breq12d mapsnen vtoclg 3ad2ant1 ensymd wss simp2 simp3 snssd ssdomg
      wn sylc snnz simpl necon3ai ax-mp mapdom2 sylancl endomtr syl2anc exlimdv
      3expia syl5bi 3impia ) ACGZBDGZBHIZAABJKZLMZVKENZBGZEOVIVJPZVMEBQVPVOVMEV
      IVJVOVMVIVJVOUAZAAVNUBZJKZRMVSVLLMZVMVQVSAVIVJVSARMZVOFNZVRJKZWBRMWAFACWB
      ASZWCVSWBARWBAVRJUDWDUCUEWBVNFTETZUFUGUHUIVQVRBLMZVRHSZAHSZPZUOZVTVQVJVRB
      UJWFVIVJVOUKVQVNBVIVJVOULUMVRBDUNUPVRHIWJVNWEUQWIVRHWGWHURUSUTVRBAVAVBAVS
      VLVCVDVFVEVGVH $.

    $( If two sets are equinumerous, then their power sets are equinumerous.
       Proposition 10.15 of [TakeutiZaring] p. 87.  (Contributed by NM,
       29-Jan-2004.)  (Revised by Mario Carneiro, 9-Apr-2015.) $)
    pwen $p |- ( A ~~ B -> ~P A ~~ ~P B ) $=
      ( cen wbr cpw c2o cmap cvv wcel relen brrelexi pw2eng syl com elexi enref
      co 2onn entr syl2anc mapen mpan brrelex2i ensym 3syl ) ABCDZAEZFAGQZCDZUH
      BEZCDZUGUJCDUFAHIUIABCJKAHLMUFUHFBGQZCDZULUJCDZUKFFCDUFUMFFNROPFFABUAUBUF
      BHIUJULCDUNABCJUCBHLUJULUDUEUHULUJSTUGUHUJST $.
  $}

  ${
    $d x y z f A $.  $d x y z f B $.  $d x y z f C $.
    $( Equinumerosity of equinumerous subsets of a set.  (Contributed by NM,
       30-Sep-2004.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
    ssenen $p |- ( A ~~ B ->
             { x | ( x C_ A /\ x ~~ C ) } ~~ { x | ( x C_ B /\ x ~~ C ) } ) $=
      ( vf cen wbr cv cab cin wss wa cima cvv wcel wceq syl sylan elin elpw cpw
      vy vz wf1o wex bren ccnv cdm f1odm vex dmex syl6eqelr inex1g 3syl crn wfo
      pwexg f1ofo forn rnex wf1 f1of1 adantr simpr f1imaen2g syl22anc entr expl
      a1i imassrn syl5sseq jctild breq1 elab anbi12i bitri imaexg ax-mp 3imtr4g
      wi f1ocnv f1f1orn f1imaen cnvex wb simpl elpwid imaeq2 wrel f1orel dfrel2
      sylbi sylib imaeq1d eqtr3d sylan9eqr eqcomd sylan2 adantrl adantrr impbid
      f1imacnv ex en3d exlimiv df-pw ineq1i inab eqtri 3brtr3g ) BCFGZBUAZAHZDF
      GZAIZJZCUAZXOJZXMBKZXNLAIZXMCKZXNLAIZFXKBCEHZUDZEUEXPXRFGZBCEUFYDYEEYDUBU
      CXPXRYCUBHZMZYCUGZUCHZMZYDBNOXLNOXPNOYDBYCUHNBCYCUIYCEUJZUKULBNUQXLXONUMU
      NYDCNOZXQNOXRNOYDCYCUOZNYDBCYCUPZYMCPBCYCURZBCYCUSZQYCYKUTULZCNUQXQXONUMU
      NYDYFBKZYFDFGZLZYGCKZYGDFGZLZYFXPOZYGXROZYDYTUUBUUAYDYRYSUUBYDYRLZYGYFFGZ
      YSUUBUUFBCYCVAZYLYRYFNOZUUGYDUUHYRBCYCVBZVCYDYLYRYQVCYDYRVDUUIUUFUBUJZVIB
      CYFYCNVEVFYGYFDVGRVHYDYNUUAYOYNYMYGCYCYFVJYPVKQVLUUDYFXLOZYFXOOZLZYTYFXLX
      OSZUULYRUUMYSYFBUUKTXNYSAYFUUKXMYFDFVMVNVOVPUUEYGXQOZYGXOOZLUUCYGXQXOSUUP
      UUAUUQUUBYGCYCNOYGNOYKYCYFNVQVRZTXNUUBAYGUURXMYGDFVMVNVOVPVSYDYICKZYIDFGZ
      LZYJBKZYJDFGZLZYIXROZYJXPOZYDCBYHUDZUVAUVDVTBCYCWAZUVGUVAUVCUVBUVGUUSUUTU
      VCUVGUUSLYJYIFGZUUTUVCUVGCYHUOZYHVAZUUSUVIUVGCBYHVAZCUVJYHUDUVKCBYHVBZCBY
      HWBCUVJYHVBUNCUVJYIYHUCUJZWCRYJYIDVGRVHUVGCBYHUPZUVBCBYHURUVOUVJYJBYHYIVJ
      CBYHUSVKQVLQUVEYIXQOZYIXOOZLZUVAYIXQXOSZUVPUUSUVQUUTYICUVNTXNUUTAYIUVNXMY
      IDFVMVNVOVPUVFYJXLOZYJXOOZLUVDYJXLXOSUVTUVBUWAUVCYJBYHNOYJNOYCYKWDYHYINVQ
      VRZTXNUVCAYJUWBXMYJDFVMVNVOVPVSYDUUDUVELZYFYJPZYIYGPZWEYDUWCLUWDUWEYDUVEU
      WDUWEVTZUUDUVEYDUUSUWFUVEUVRUUSUVSUVRYICUVPUVQWFWGWLYDUUSLZUWDUWEUWGUWDLY
      GYIUWDUWGYGYCYJMZYIYFYJYCWHUWGYHUGZYJMZUWHYIYDUWJUWHPUUSYDUWIYCYJYDYCWIUW
      IYCPBCYCWJYCWKWMWNVCYDUVLUUSUWJYIPYDUVGUVLUVHUVMQCBYIYHXBRWOWPWQXCWRWSYDU
      UDUWEUWDVTZUVEUUDYDYRUWKUUDUUNYRUUOUUNYFBUULUUMWFWGWLUUFUWEUWDUUFUWELYJYF
      UWEUUFYJYHYGMZYFYIYGYHWHYDUUHYRUWLYFPUUJBCYFYCXBRWPWQXCWRWTXAXCXDXEWLXPXS
      AIZXOJXTXLUWMXOABXFXGXSXNAXHXIXRYAAIZXOJYBXQUWNXOACXFXGYAXNAXHXIXJ $.
  $}

  ${
    $d f x y A $.  $d x y V $.
    limenpsi.1 $e |- Lim A $.
    $( A limit ordinal is equinumerous to a proper subset of itself.
       (Contributed by NM, 30-Oct-2003.)  (Revised by Mario Carneiro,
       16-Nov-2014.) $)
    limenpsi $p |- ( A e. V -> A ~~ ( A \ { (/) } ) ) $=
      ( vx vy wcel c0 csn cdif cdom wbr cv csuc wb ax-mp con0 wceq ordelon mpan
      cvv cen difexg wne wlim limsuc biimpi nsuceq0 jctir eldifsn sylibr limord
      wa word suc11 syl2an dom3 mpdan wss difss ssdomg mpi sbth syl2anc ) ABFZA
      AGHZIZJKZVFAJKZAVFUAKVDVFTFVGAVEBUBDEAVFDLZMZELZMZBTVIAFZVJAFZVJGUCZULVJV
      FFVMVNVOVMVNAUDZVMVNNCAVIUEOUFVIUGUHVJAGUIUJVMVIPFZVKPFZVJVLQVIVKQNVKAFZA
      UMZVMVQVPVTCAUKOZAVIRSVTVSVRWAAVKRSVIVKUNUOUPUQVDVFAURVHAVEUSVFABUTVAAVFV
      BVC $.
  $}

  ${
    limensuci.1 $e |- Lim A $.
    $( A limit ordinal is equinumerous to its successor.  (Contributed by NM,
       30-Oct-2003.) $)
    limensuci $p |- ( A e. V -> A ~~ suc A ) $=
      ( wcel csn cdif cun csuc cen wbr limenpsi ensymd cvv 0ex en2sn wceq ax-mp
      c0 cin mpbi mpan wa incom disjdif eqtri wn word wlim limord ordirr disjsn
      mpbir unen mpanr12 syl2anc 0ellim snss undif uncom eqtr3i df-suc 3brtr4g
      wss ) ABDZAREZFZVEGZAAEZGZAAHIVDVFAIJZVEVHIJZVGVIIJZVDAVFABCKLRMDVDVKNRAM
      BOUAVJVKUBVFVESZRPAVHSRPZVLVMVEVFSRVFVEUCVEAUDUEVNAADUFZAUGZVOAUHZVPCAUIQ
      AUJQAAUKULVFAVEVHUMUNUOVEVFGZAVGVEAVCZVRAPRADZVSVQVTCAUPQRANUQTVEAURTVEVF
      USUTAVAVB $.
  $}

  $( A limit ordinal is equinumerous to its successor.  (Contributed by NM,
     30-Oct-2003.) $)
  limensuc $p |- ( ( A e. V /\ Lim A ) -> A ~~ suc A ) $=
    ( wlim wcel csuc cen wbr wi con0 cif wceq eleq1 suceq breq12d imbi12d limeq
    id limon elimhyp limensuci dedth impcom ) ACZABDZAAEZFGZUCUDUFHUCAIJZBDZUGU
    GEZFGZHAIAUGKZUDUHUFUJAUGBLUKAUGUEUIFUKQAUGMNOUGBUCUGCICAIAUGPIUGPRSTUAUB
    $.

  ${
    $d x y A $.
    $( Any infinite ordinal is equinumerous to its successor.  Exercise 7 of
       [TakeutiZaring] p. 88.  Proved without the Axiom of Infinity.
       (Contributed by NM, 30-Oct-2003.)  (Revised by Mario Carneiro,
       13-Jan-2013.) $)
    infensuc $p |- ( ( A e. On /\ om C_ A ) -> A ~~ suc A ) $=
      ( vx vy con0 wcel com wss wa csuc cen wbr wceq cvv wi cv id suceq breq12d
      csn vex onprc eleq1 mtbiri ssexg nsyl3 omon ori nsyl2 weq limom limensuci
      ancoms sucex en2sn mp2an cin c0 wel wn eloni ordirr disjsn sylibr sucelon
      word syl 3imtr4i jca cun unen df-suc 3brtr4g ex syl5 mpan2 com12 ad2antrr
      wlim wral limensuc mpan a1d tfindsg exp31 com23 imp mpd ) ADEZFAGZHZFDEZA
      AIZJKZWJFDLZWKWNFMEZWJWNWODMEUAFDMUBUCWIWHWOFADUDULUEWKWNUFUGUHWHWIWKWMNW
      HWKWIWMWHWKWIWMBOZWPIZJKZFFIZJKCOZWTIZJKZXAXAIZJKZWMBCAFWPFLZWPFWQWSJXEPW
      PFQRBCUIZWPWTWQXAJXFPWPWTQRWPXALZWPXAWQXCJXGPWPXAQRWPALZWPAWQWLJXHPWPAQRF
      DUJUKWTDEZXBXDNWKFWTGZXBXIXDXBWTSZXASZJKZXIXDNWTMEXAMEXMCTZWTXNUMWTXAMMUN
      UOXIWTXKUPUQLZXAXLUPUQLZHZXBXMHZXDXIXOXPXICCURUSZXOXIWTVEXSWTUTWTVAVFWTWT
      VBVCXADEZXAXAEUSZXIXPXTXAVEYAXAUTXAVAVFWTVDXAXAVBVGVHXRXQXDXRXQHWTXKVIXAX
      LVIXAXCJWTXAXKXLVJWTVKXAVKVLVMVNVOVPVQWPVRZWKHFWPGZHWRXJXBNCWPVSYBWRWKYCW
      PMEYBWRBTWPMVTWAVQWBWCWDWEWFWG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Pigeonhole Principle
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for Pigeonhole Principle.  If we join a natural number to itself
     minus an element, we end up with its successor minus the same element.
     (Contributed by NM, 25-May-1998.) $)
  phplem1 $p |- ( ( A e. om /\ B e. A ) ->
             ( { A } u. ( A \ { B } ) ) = ( suc A \ { B } ) ) $=
    ( com wcel wa csn cin c0 wceq cdif cun csuc word nnord nordeq disjsn2 sylan
    wne syl undif4 df-suc equncomi difeq1i syl6eqr ) ACDZBADZEAFZBFZGHIZUGAUHJK
    ZALZUHJZIUEAMZUFUIANUMUFEABRUIABOABPSQUIUJUGAKZUHJULUGAUHTUKUNUHUKAUGAUAUBU
    CUDS $.

  ${
    $d f A $.  $d f B $.
    phplem2.1 $e |- A e. _V $.
    phplem2.2 $e |- B e. _V $.
    $( Lemma for Pigeonhole Principle.  A natural number is equinumerous to its
       successor minus one of its elements.  (Contributed by NM, 11-Jun-1998.)
       (Revised by Mario Carneiro, 16-Nov-2014.) $)
    phplem2 $p |- ( ( A e. om /\ B e. A ) -> A ~~ ( suc A \ { B } ) ) $=
      ( com wcel wa csn cdif cun csuc cen wbr cin c0 wceq cvv wss syl syl5eq
      cop wf1o snex f1osn mp2an difss ssexi enref pm3.2i incom ssrin ax-mp word
      f1oen3g nnord orddisj syl5sseq disjdif jctil sylancr adantr uncom difsnid
      ss0 unen adantl phplem1 3brtr3d ) AEFZBAFZGBHZAVKIZJZAHZVLJZAAKVKILVIVMVO
      LMZVJVIVKVNLMZVLVLLMZGVKVLNOPZVNVLNZOPZGVPVQVRBAUAZHZQFVKVNWCUBVQWBUCBADC
      UDVKVNWCQUNUEVLVLACAVKUFZUGUHUIVIWAVSVIVTVLVNNZOVNVLUJVIWEORWEOPVIAVNNZWE
      OVLARWEWFRWDVLAVNUKULVIAUMWFOPAUOAUPSUQWEVDSTVKAURUSVKVNVLVLVEUTVAVJVMAPV
      IVJVMVLVKJAVKVLVBABVCTVFABVGVH $.

    $( Lemma for Pigeonhole Principle.  A natural number is equinumerous to its
       successor minus any element of the successor.  (Contributed by NM,
       26-May-1998.) $)
    phplem3 $p |- ( ( A e. om /\ B e. suc A ) -> A ~~ ( suc A \ { B } ) ) $=
      ( csuc wcel com wceq wo csn cdif cen wbr elsuci phplem2 enref word orddif
      wa nnord syl sneq difeq2d eqcoms sylan9eq syl5breq jaodan sylan2 ) BAEZFA
      GFZBAFZBAHZIAUIBJZKZLMZBANUJUKUOULABCDOUJULSAAUNLACPUJULAUIAJZKZUNUJAQAUQ
      HATARUAUQUNHABABHUPUMUIABUBUCUDUEUFUGUH $.

    $( Lemma for Pigeonhole Principle.  Equinumerosity of successors implies
       equinumerosity of the original natural numbers.  (Contributed by NM,
       28-May-1998.)  (Revised by Mario Carneiro, 24-Jun-2015.) $)
    phplem4 $p |- ( ( A e. om /\ B e. om ) -> ( suc A ~~ suc B -> A ~~ B ) ) $=
      ( csuc cen wbr com wcel csn cdif cima cvv sylancl ensymd wceq syl imaeq2d
      vf wa cv wf1o wex bren cfv wf1 f1of1 adantl wss sssucid f1imaen2g mpanr12
      sucex word nnord orddif wfn f1ofn sucid fnsnfv difeq2d crn imadmrn eqcomi
      cdm wfo f1ofo forn f1odm 3eqtr3a difeq1d ccnv wfun dff1o3 imadif 3eqtr4rd
      simprbi sylan9eq breqtrd fnfvelrn eleq2d mpbid fvex phplem3 sylan2 syl2an
      wb entr anandirs ex exlimdv syl5bi ) AEZBEZFGWMWNSUAZUBZSUCAHIZBHIZTZABFG
      ZWMWNSUDWSWPWTSWSWPWTWQWRWPWTWQWPTZAWNAWOUEZJZKZFGXDBFGWTWRWPTZXAAWOALZXD
      FXAXFAXAWMWNWOUFZWNMIZXFAFGZWPXGWQWMWNWOUGUHBDUMXGXHTAWMUIAMIXIAUJCWMWNAW
      OMUKULNOWQWPXFWOWMAJZKZLZXDWQAXKWOWQAUNAXKPAUOAUPQRWPWOWMLZXCKXMWOXJLZKZX
      DXLWPXCXNXMWPWOWMUQZAWMIZXCXNPWMWNWOURZACUSZWMAWOUTNVAWPWNXMXCWPWOVBZWOWO
      VEZLZWNXMYBXTWOVCVDWPWMWNWOVFZXTWNPWMWNWOVGZWMWNWOVHZQWPYAWMWOWMWNWOVIRVJ
      VKWPWOVLVMZXLXOPWPYCYFWMWNWOVNVQWMXJWOVOQVPVRVSXEBXDWPWRXBWNIZBXDFGWPXBXT
      IZYGWPXPXQYHXRXSWMAWOVTNWPYCYHYGWGYDYCXTWNXBYEWAQWBBXBDAWOWCWDWEOAXDBWHWF
      WIWJWKWL $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Two equinumerous natural numbers are equal.  Proposition 10.20 of
       [TakeutiZaring] p. 90 and its converse.  Also compare Corollary 6E of
       [Enderton] p. 136.  (Contributed by NM, 28-May-1998.) $)
    nneneq $p |- ( ( A e. om /\ B e. om ) -> ( A ~~ B <-> A = B ) ) $=
      ( vz vy vw com wcel cen wceq cv wi wral breq1 eqeq1 imbi12d ralbidv breq2
      wbr c0 eqeq2 vx wa csuc ensym en0 eqcom bitri sylib rgenw wrex wo bibi12d
      nn0suc wb mpbiri biimpd a1i nfv nfra1 nfan rsp vex phplem4 imim1d ex syl5
      a2d imp suceq syl8 biimprcd syl6 rexlimd jaod syl7 ralrimdv cbvralv finds
      syl6ib rspcv mpan9 eqeng adantr impbid ) AFGZBFGZUBABHRZABIZWEACJZHRZAWII
      ZKZCFLZWFWGWHKZUAJZWIHRZWOWIIZKZCFLSWIHRZSWIIZKZCFLDJZWIHRZXBWIIZKZCFLZXB
      UCZWIHRZXGWIIZKZCFLZWMUADAWOSIZWRXACFXLWPWSWQWTWOSWIHMWOSWINOPWOXBIZWRXEC
      FXMWPXCWQXDWOXBWIHMWOXBWINOPWOXGIZWRXJCFXNWPXHWQXIWOXGWIHMWOXGWINOPWOAIZW
      RWLCFXOWPWJWQWKWOAWIHMWOAWINOPXACFWSWISHRZWTSWIUDXPWISIWTWIUEWISUFUGUHUIX
      BFGZXFXGEJZHRZXGXRIZKZEFLXKXQXFYAEFXRFGXRSIZXRWIUCZIZCFUJZUKZXQXFYACXRUMX
      QXFYFYAKXQXFUBZYBYAYEYBYAKYGYBXSXTYBXSXTUNXGSHRZXGSIZUNXGUEYBXSYHXTYIXRSX
      GHQXRSXGTULUOUPUQYGYDYACFXQXFCXQCURXECFUSUTYACURYGWIFGZXGYCHRZXGYCIZKZYDY
      AKYGYJYKXDYLXQXFYJYKXDKZKZXFYJXEKXQYOXECFVAXQYJXEYNXQYJXEYNKXQYJUBYKXCXDX
      BWIDVBCVBVCVDVEVGVFVHXBWIVIVJYDYAYMYDXSYKXTYLXRYCXGHQXRYCXGTOVKVLVMVNVEVO
      VPYAXJECFXRWIIXSXHXTXIXRWIXGHQXRWIXGTOVQVSVRWLWNCBFWIBIWJWGWKWHWIBAHQWIBA
      TOVTWAWEWHWGKWFABFWBWCWD $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Pigeonhole Principle.  A natural number is not equinumerous to a proper
       subset of itself.  Theorem (Pigeonhole Principle) of [Enderton] p. 134.
       The theorem is so-called because you can't put _n_ + 1 pigeons into _n_
       holes (if each hole holds only one pigeon).  The proof consists of
       lemmas ~ phplem1 through ~ phplem4 , ~ nneneq , and this final piece of
       the proof.  (Contributed by NM, 29-May-1998.) $)
    php $p |- ( ( A e. om /\ B C. A ) -> -. A ~~ B ) $=
      ( vx vy com wcel wpss cen wbr wn wi wa cv wceq c0 wss wne cdom cvv imp wb
      csuc wrex 0ss sspsstr mpan df-ne bitri sylib nn0suc orcanai sylan2 pssnel
      0pss wex csn cdif pssss ssdif cin disjsn disj3 bitr3i sseq1 sylbi syl5ibr
      sucex difss ssexi ssdomg ax-mp syl56 phplem3 ensymd domentr exp43 exlimiv
      vex syl2an com4r mpcom endomtr sssucid mp2 sbth sylancl expcom word nnord
      peano2b sucid nordeq nneneq sylanb anidms mpbird nsyli com12 psseq2 breq1
      necon3bbid syli notbid imbi12d syl5ibrcom rexlimiv syl ex pm2.43d ) AEFZB
      AGZABHIZJZXJXKXMXJXKXKXMKZXJXKLACMZUBZNZCEUCZXNXKXJAONZJZXRXKOAGZXTOBPXKY
      ABUDOBAUEUFYAAOQXTAUNAOUGUHUIXJXSXRCAUJUKULXQXNCEXOEFZXNXQBXPGZXPBHIZJZKY
      CYBYEYBYCBXORIZYEDMZXPFZYGBFJZLZDUOYCYBYFKZDBXPUMYJYCYKKZDYHYIYLYIYCYBYHY
      FYIYCYBYHYFYIYCLBXPYGUPZUQZRIZYNXOHIYFYBYHLZYIYCYOYCBXPPZYIBYNPZYOBXPURYQ
      YRYIBYMUQZYNPZBXPYMUSYIBYSNZYRYTUAYIBYMUTONUUABYGVABYMVBVCBYSYNVDVEVFYNSF
      YRYOKYNXPXOCVRZVGZXPYMVHVIBYNSVJVKVLTYPXOYNXOYGUUBDVRVMVNBYNXOVOVSVPVTTVQ
      WAYFYDXPXOHIZYBYDYFUUDYDYFLXPXORIXOXPRIZUUDXPBXOWBXPSFXOXPPUUEUUCXOWCXOXP
      SVJWDXPXOWEWFWGYBUUDJXPXOQZYBXPWHZXOXPFUUFYBXPEFZUUGXOWJZXPWIVEXOUUBWKXPX
      OWLWFYBUUDXPXOYBUUDXPXONUAZYBUUHYBUUJUUIXPXOWMWNWOXAWPWQXBWRXQXKYCXMYEAXP
      BWSXQXLYDAXPBHWTXCXDXEXFXGXHXIT $.

    $( Corollary of Pigeonhole Principle.  (Contributed by NM, 31-May-1998.) $)
    php2 $p |- ( ( A e. om /\ B C. A ) -> B ~< A ) $=
      ( vx com wcel wpss csdm wbr cv wa wceq eleq1 psseq2 anbi12d breq2 imbi12d
      wi cdom cen cvv wss vex pssss ssdomg mpsyl adantl php ensym nsyl sylanbrc
      wn brsdom vtoclg anabsi5 ) ADEZBAFZBAGHZCIZDEZBURFZJZBURGHZQUOUPJZUQQCADU
      RAKZVAVCVBUQVDUSUOUTUPURADLURABMNURABGOPVABURRHZBURSHZUKVBUTVEUSURTEUTBUR
      UAVECUBBURUCBURTUDUEUFVAURBSHVFURBUGBURUHUIBURULUJUMUN $.
  $}

  ${
    $d f x y A $.  $d f x y B $.
    $( Corollary of Pigeonhole Principle.  If ` A ` is finite and ` B ` is a
       proper subset of ` A ` , the ` B ` is strictly less numerous than
       ` A ` .  Stronger version of Corollary 6C of [Enderton] p. 135.
       (Contributed by NM, 22-Aug-2008.) $)
    php3 $p |- ( ( A e. Fin /\ B C. A ) -> B ~< A ) $=
      ( vx vf vy wcel wpss wbr cv cen com wi wa wn wss imp wf1o wex cima syl c0
      cfn csdm wrex isfi cdom relen brrelexi pssss ssdomg syl2an adantll imass2
      cvv bren adantl cdif wceq pssnel eldif cfv wfn f1ofn difss fnfvima 3expia
      sylancl ccnv wfun wfo dff1o3 simprbi imadif eleq2d sylibd syl5bir exlimdv
      n0i syl6 sylan2 ssdif0 sylnibr dfpss3 sylanbrc wb cdm crn imadmrn imaeq2d
      f1odm f1ofo forn 3eqtr3a psseq2d adantr mpbid php cres f1of1 f1ores resex
      wf1 f1oeq1 spcev sylibr entr expcom mtod exp32 syl5bi imp31 ensym syl6com
      vex ex ad2antlr brsdom exp31 rexlimiv sylbi ) AUBFZBAGZBAUCHZYAACIZJHZCKU
      DYBYCLZCAUEYEYFCKYDKFZYEYBYCYGYEMYBMZBAUFHZBAJHZNYCYEYBYIYGYEAUNFZBAOZYIY
      BAYDJUGUHBAUIZYKYLYIBAUNUJPUKULYHYJYDBJHZYGYEYBYNNZYEAYDDIZQZDRYGYBYOLZAY
      DDUOYGYQYRDYGYQYBYOYGYQYBMZMYNYDYPBSZJHZYSYGYTYDGZUUANYSYTYPASZGZUUBYSYTU
      UCOZUUCYTOZNUUDYBUUEYQYBYLUUEYMBAYPUMTUPYSUUCYTUQZUAURZUUFYBYQEIZAFUUIBFN
      MZERZUUHNZEBAUSYQUUKUULYQUUJUULEUUJUUIABUQZFZYQUULUUIABUTYQUUNUUIYPVAZUUG
      FZUULYQUUNUUOYPUUMSZFZUUPYQYPAVBZUUMAOZUUNUURLAYDYPVCABVDUUSUUTUUNUURAUUM
      YPUUIVEVFVGYQUUQUUGUUOYQYPVHVIZUUQUUGURYQAYDYPVJZUVAAYDYPVKVLABYPVMTVNVOU
      UGUUOVRVSVPVQPVTUUCYTWAWBYTUUCWCWDYQUUDUUBWEYBYQUUCYDYTYQYPYPWFZSYPWGZUUC
      YDYPWHYQUVCAYPAYDYPWJWIYQUVBUVDYDURAYDYPWKAYDYPWLTWMWNWOWPYDYTWQVTYSYNUUA
      LZYGYSBYTJHZUVEYSBYTYPBWRZQZUVFYQAYDYPXBYLUVHYBAYDYPWSYMAYDBYPWTUKUVHBYTU
      UIQZERUVFUVIUVHEUVGYPBDXNXABYTUUIUVGXCXDBYTEUOXETYNUVFUUAYDBYTXFXGTUPXHXI
      VQXJXKYEYJYNLYGYBYJYEBYDJHZYNYJYEUVJBAYDXFXOBYDXLXMXPXHBAXQWDXRXSXTP $.
  $}

  $( Corollary of the Pigeonhole Principle ~ php : a natural number is strictly
     dominated by its successor.  (Contributed by NM, 26-Jul-2004.) $)
  php4 $p |- ( A e. om -> A ~< suc A ) $=
    ( com wcel csuc wpss csdm wbr sucidg word wa wb nnord ordsuc ancli ordelpss
    biimpi 3syl mpbid peano2b php2 sylanb mpdan ) ABCZAADZEZAUDFGZUCAUDCZUEABHU
    CAIZUHUDIZJUGUEKALUHUIUHUIAMPNAUDOQRUCUDBCUEUFASUDATUAUB $.

  $( Corollary of the Pigeonhole Principle ~ php : a natural number is not
     equinumerous to its successor.  Corollary 10.21(1) of [TakeutiZaring]
     p. 90.  (Contributed by NM, 26-Jul-2004.) $)
  php5 $p |- ( A e. om -> -. A ~~ suc A ) $=
    ( com wcel csuc csdm wbr cen wn php4 sdomnen syl ) ABCAADZEFALGFHAIALJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Finite sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( An ordinal number equinumerous to a natural number is equal to it.
     Proposition 10.22 of [TakeutiZaring] p. 90 and its converse.  (Contributed
     by NM, 26-Jul-2004.) $)
  onomeneq $p |- ( ( A e. On /\ B e. om ) -> ( A ~~ B <-> A = B ) ) $=
    ( con0 wcel com wa cen wbr wceq wss adantl cdom ssdomg sylan2 ancoms adantr
    wn wb wi word csuc php5 ad2antlr mtbird peano2 sssucid ee10 endomtr adantll
    enen1 a1d ssel com12 eloni ordelsuc sylibd syld jcad sbth syl6 mtod ordtri1
    sylancr con2bid ad2antrr mpbird simplr jca nneneq biimpa sylancom ex impbid
    ordom eqeng ) ACDZBEDZFZABGHZABIZVRVSVTVRVSAEDZVQFZVTVRVSFZWAVQWCWAEAJZQZWC
    WDABUAZGHZWCWGBWFGHZVQWHQVPVSBUBUCVSWGWHRVRABWFUJKUDWCWDAWFLHZWFALHZFWGWCWD
    WIWJVQVSWDWISVPVQVSFWIWDVSVQWIVQVSBWFLHZWIVQWFEDBWFJWKBUEBUFBWFEMUGABWFUHNO
    UKUIVRWDWJSZVSVQVPWLVQVPFZWDWFAJZWJWMWDBADZWNVQWDWOSVPWDVQWOEABULUMPVPVQATZ
    WOWNRAUNZBAEUONUPVPWNWJSVQWFACMKUQOPURAWFUSUTVAVPWAWERVQVSVPWDWAVPETWPWDWAQ
    RVNWQEAVBVCVDVEVFVPVQVSVGVHWBVSVTABVIVJVKVLVPVTVSSVQABCVOPVM $.

  ${
    $d x A $.
    $( An ordinal number is finite iff it is a natural number.  Proposition
       10.32 of [TakeutiZaring] p. 92.  (Contributed by NM, 26-Jul-2004.) $)
    onfin $p |- ( A e. On -> ( A e. Fin <-> A e. om ) ) $=
      ( vx cfn wcel cv cen wbr wrex con0 isfi wa wceq onomeneq wi eleq1a adantl
      com sylbid rexlimdva enrefg breq2 rspcev mpdan impbid1 syl5bb ) ACDABEZFG
      ZBQHZAIDZAQDZBAJUIUHUJUIUGUJBQUIUFQDZKUGAUFLZUJAUFMUKULUJNUIUFQAOPRSUJAAF
      GZUHAQTUGUMBAQUFAAFUAUBUCUDUE $.
  $}

  $( A set is a natural number iff it is a finite ordinal.  (Contributed by
     Mario Carneiro, 22-Jan-2013.) $)
  onfin2 $p |- om = ( On i^i Fin ) $=
    ( vx com con0 cfn cin cv wcel nnon onfin biimprcd jcai biimpa impbii bitr4i
    wa elin eqriv ) ABCDEZAFZBGZSCGZSDGZOZSRGTUCTUAUBSHUAUBTSIZJKUAUBTUDLMSCDPN
    Q $.

  $( Natural numbers are finite sets.  (Contributed by Stefan O'Rear,
     21-Mar-2015.) $)
  nnfi $p |- ( A e. om -> A e. Fin ) $=
    ( com cfn con0 cin onfin2 inss2 eqsstri sseli ) BCABDCECFDCGHI $.

  $( Cardinal ordering agrees with natural number ordering.  Example 3 of
     [Enderton] p. 146.  (Contributed by NM, 17-Jun-1998.) $)
  nndomo $p |- ( ( A e. om /\ B e. om ) -> ( A ~<_ B <-> A C_ B ) ) $=
    ( com wcel wa cdom wbr wpss wn wi csdm php2 ex domnsym nsyli adantr word wb
    wss nnord ordtri1 ordelpss ancoms notbid bitrd syl2an sylibrd ssdomg adantl
    impbid ) ACDZBCDZEZABFGZABSZUMUNBAHZIZUOUKUNUQJULUKUPBAKGZUNUKUPURABLMABNOP
    UKAQZBQZUOUQRULATBTUSUTEZUOBADZIUQABUAVAVBUPUTUSVBUPRBAUBUCUDUEUFUGULUOUNJU
    KABCUHUIUJ $.

  $( Cardinal ordering agrees with natural number ordering.  (Contributed by
     NM, 17-Jun-1998.) $)
  nnsdomo $p |- ( ( A e. om /\ B e. om ) -> ( A ~< B <-> A C. B ) ) $=
    ( com wcel wa cdom wbr cen wn wceq csdm nndomo nneneq notbid anbi12d brsdom
    wss wpss dfpss2 3bitr4g ) ACDBCDEZABFGZABHGZIZEABQZABJZIZEABKGABRUAUBUEUDUG
    ABLUAUCUFABMNOABPABST $.

  $( Strict dominance of natural numbers is the same as dominance over the
     successor of the smaller.  (Contributed by NM, 25-Jul-2004.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  omsucdomOLD $p |- ( ( A e. om /\ B e. om ) -> ( A ~< B <-> suc A ~<_ B ) ) $=
    ( com wcel wa wpss csuc wss csdm cdom word wb nnord ordelpss sylan ordelsuc
    wbr bitr3d sylan2 nnsdomo peano2b nndomo sylanb 3bitr4d ) ACDZBCDZEABFZAGZB
    HZABIQUHBJQZUFUEBKZUGUILBMUEUKEABDZUGUIUEAKUKULUGLAMABNOABCPRSABTUEUHCDUFUJ
    UILAUAUHBUBUCUD $.

  ${
    $d f w A $.  $d f w B $.
    $( Strict dominance of a set over another set implies dominance over its
       successor.  (Contributed by Mario Carneiro, 12-Jan-2013.)  (Proof
       shortened by Mario Carneiro, 27-Apr-2015.) $)
    sucdom2 $p |- ( A ~< B -> suc A ~<_ B ) $=
      ( vf vw csdm wbr cv wf1 cdom wex syl wa cun wceq cvv adantr a1i wss sylib
      wcel csuc sdomdom brdomi csn crn cdif cin c0 relsdom brrelexi vex f1f1orn
      rnex adantl f1of1 f1dom2g syl3anc wn cen sdomnen ssdif0 simplr wfn wf f1f
      wf1o df-f simprd simpr eqssd dff1o5 sylanbrc f1oen3g sylancr syl5bir mtod
      neq0 snssi en2sn sylancl brrelex2i difexg ssdomg 3syl endomtr ee12an syl5
      ex wi exlimdv mpd disjdif syl21anc df-suc undif2 ssequn1 syl5req exlimddv
      undom 3brtr4d ) ABEFZABCGZHZAUAZBIFCXAABIFXCCJABUBABCUCKXAXCLZAAUDZMZXBUE
      ZBXHUFZMZXDBIXEAXHIFZXFXIIFZXHXIUGUHNZXGXJIFXEAOTZXHOTZAXHXBHZXKXAXNXCABE
      UIUJPZXOXEXBCUKZUMQXEAXHXBVFZXPXCXSXAABXBULUNAXHXBUOKAXHXBOOUPUQXEDGZXITZ
      DJZXLXEXIUHNZURYBXEYCABUSFZXAYDURXCABUTPYCBXHRZXEYDBXHVAXEYEYDXEYELZXBOTA
      BXBVFZYDXRYFXCXHBNYGXAXCYEVBZYFXHBYFXCXHBRZYHXCXBAVCZYIXCABXBVDYJYILABXBV
      EABXBVGSVHZKXEYEVIVJABXBVKVLABXBOVMVNWHVOVPDXIVQSXEYAXLDYAXTUDZXIRZXEXLXT
      XIVRXEXFYLUSFZYMYLXIIFZXLXEXNXTOTYNXQDUKAXTOOVSVTXEBOTZXIOTYMYOWIXAYPXCAB
      EUIWAPBXHOWBYLXIOWCWDXFYLXIWEWFWGWJWKXMXEXHBWLQAXHXFXIWSWMXDXGNXEAWNQXEXJ
      XHBMZBXHBWOXEYIYQBNXCYIXAYKUNXHBWPSWQWTWR $.
  $}

  $( Strict dominance of a set over a natural number is the same as dominance
     over its successor.  (Contributed by Mario Carneiro, 12-Jan-2013.) $)
  sucdom $p |- ( A e. om -> ( A ~< B <-> suc A ~<_ B ) ) $=
    ( com wcel csdm wbr csuc cdom sucdom2 wi php4 sdomdomtr ex syl impbid2 ) AC
    DZABEFZAGZBHFZABIPAREFZSQJAKTSQARBLMNO $.

  $( Dominance of a set over a successor of a natural number implies strict
     dominance over the number.  For the converse, see ~ sucdom .  (Contributed
     by NM, 26-Jul-2004.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  sucdomiOLD $p |- ( ( A e. om /\ B e. C ) ->
                   ( suc A ~<_ B -> A ~< B ) ) $=
    ( com wcel csuc cdom wbr csdm wi php4 sdomdomtr ex syl adantr ) ADEZAFZBGHZ
    ABIHZJZBCEPAQIHZTAKUARSAQBLMNO $.

  ${
    $d x A $.
    $( Strict dominance over zero is the same as dominance over one.
       (Contributed by NM, 28-Sep-2004.) $)
    0sdom1dom $p |- ( (/) ~< A <-> 1o ~<_ A ) $=
      ( c0 csdm wbr csuc cdom c1o com wcel wb peano1 sucdom ax-mp breq1i bitr4i
      df-1o ) BACDZBEZAFDZGAFDBHIQSJKBALMGRAFPNO $.
  $}

  $( Ordinal 1 is strictly dominated by ordinal 2.  (Contributed by NM,
     4-Apr-2007.) $)
  1sdom2 $p |- 1o ~< 2o $=
    ( c1o csuc c2o csdm com wcel wbr 1onn php4 ax-mp df-2o breqtrri ) AABZCDAEF
    AMDGHAIJKL $.

  $( A set has less than one member iff it is empty.  (Contributed by Stefan
     O'Rear, 28-Oct-2014.) $)
  sdom1 $p |- ( A ~< 1o <-> A = (/) ) $=
    ( c1o csdm wbr c0 wceq wn cdom domnsym con2i 0sdom1dom sylnibr wcel relsdom
    cvv wb brrelexi 0sdomg necon2bbid syl mpbird wne 1n0 con0 elexi 0sdom mpbir
    1on breq1 mpbiri impbii ) ABCDZAEFZULUMEACDZGZULBAHDZUNUPULBAIJAKLULAOMZUMU
    OPABCNQUQUNAEAORSTUAUMULEBCDZURBEUBUCBBUDUHUEUFUGAEBCUIUJUK $.

  $( Two ways to express "at most one".  (Contributed by Stefan O'Rear,
     28-Oct-2014.) $)
  modom $p |- ( E* x ph <-> { x | ph } ~<_ 1o ) $=
    ( wmo wex weu wi wn wo cab c1o cdom wbr df-mo imor csdm c0 wceq abn0 bitr4i
    cen necon1bbii sdom1 euen1 orbi12i brdom2 3bitri ) ABCABDZABEZFUGGZUHHZABIZ
    JKLZABMUGUHNUJUKJOLZUKJTLZHULUIUMUHUNUIUKPQUMUGUKPABRUAUKUBSABUCUDUKJUESUF
    $.

  ${
    $d x A $.
    $( Two ways to express "at most one".  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    modom2 $p |- ( E* x x e. A <-> A ~<_ 1o ) $=
      ( cv wcel wmo cab c1o cdom wbr modom abid2 breq1i bitri ) ACBDZAENAFZGHIB
      GHINAJOBGHABKLM $.
  $}

  ${
    $d a f x y A $.
    $( A set that strictly dominates ordinal 1 has at least 2 different
       members.  (Closely related to ~ 2dom .)  (Contributed by Mario Carneiro,
       12-Jan-2013.) $)
    1sdom $p |- ( A e. V -> ( 1o ~< A <-> E. x e. A E. y e. A -. x = y ) ) $=
      ( va vf c1o cv csdm wbr wrex cdom c2o c0 cpr wf1 cop vex ccnv csn wn csuc
      weq breq2 rexeq rexeqbi1dv com wcel wb 1onn sucdom ax-mp df-2o 2dom df2o3
      breq1i wel wa wex wss wne wfun 0ex elexi funpr df-ne 1n0 necomi fpr df-f1
      mpbiran cun cnvsn uneq12i df-pr cnveqi cnvun eqtri 3eqtr4i funeqi 3imtr3i
      wf bitr2i prssi f1ss syl2an f1eq1 spcev syl brdom sylibr expcom rexlimivv
      prex syl5eqbr impbii 3bitr2i vtoclbg ) GEHZIJZABUCUAZBWSKZAWSKZGCIJXABCKZ
      ACKECDWSCGIUDXBXDAWSCXABWSCUEUFWTGUBZWSLJZMWSLJZXCGUGUHWTXFUIUJGWSUKULMXE
      WSLUMUPXGXCABWSUNXCMNGOZWSLUOXAXHWSLJZABWSWSXAAEUQBEUQURZXIXAXJURZXHWSFHZ
      PZFUSZXIXKXHWSNAHZQZGBHZQZOZPZXNXAXHXOXQOZXSPZYAWSUTXTXJXOXQVAXONQZXQGQZO
      ZVBZXAYBXOXQNGARZBRZVCGUGUJVDZVEXOXQVFYBXSSZVBZYFYBXHYAXSWBZYKNGVAYLGNVGV
      HNGXOXQVCYIYGYHVIULXHYAXSVJVKYJYEXPTZSZXRTZSZVLZYCTZYDTZVLYJYEYNYRYPYSNXO
      VCYGVMGXQYIYHVMVNYJYMYOVLZSYQXSYTXPXRVOVPYMYOVQVRYCYDVOVSVTWCWAXOXQWSWDXH
      YAWSXSWEWFXMXTFXSXPXRWNXHWSXLXSWGWHWIXHWSFERWJWKWLWMWOWPWQWR $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Strict dominance of a finite set over a natural number is the same as
       dominance over its successor.  (Contributed by NM, 26-Jul-2004.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    fisucdomOLD $p |- ( ( A e. om /\ B e. Fin ) ->
                     ( A ~< B <-> suc A ~<_ B ) ) $=
      ( vx cfn wcel com cv cen wbr wrex csdm csuc cdom wb wa omsucdomOLD adantr
      isfi sdomen2 adantl domen2 3bitr4d exp31 rexlimdv imp sylan2b ) BDEAFEZBC
      GZHIZCFJZABKIZALZBMIZNZCBRUGUJUNUGUIUNCFUGUHFEZUIUNUGUOOZUIOAUHKIZULUHMIZ
      UKUMUPUQURNUIAUHPQUIUKUQNUPBUHASTUIUMURNUPBUHULUATUBUCUDUEUF $.
  $}

  ${
    $d F f w z $.  $d a b f m n s t w x z $.
    unxpdomlem1.1 $e |- F = ( x e. ( a u. b ) |-> G ) $.
    unxpdomlem1.2 $e |- G = if ( x e. a , <. x , if ( x = m , t , s ) >. ,
                                          <. if ( x = t , n , m ) , x >. ) $.
    $( Lemma for ~ unxpdom .  (Trivial substitution proof.)  (Contributed by
       Mario Carneiro, 13-Jan-2013.) $)
    unxpdomlem1 $p |- ( z e. ( a u. b ) -> ( F ` z ) =
       if ( z e. a , <. z , if ( z = m , t , s ) >. ,
                     <. if ( z = t , n , m ) , z >. ) ) $=
      ( cv wel weq cif cop equequ1 ifbid eqtrd elequ1 opeq1 opeq2d opeq1d opeq2
      cun ifbieq12d syl5eq opex ifex fvmpt ) ABMZGBINZULBDOZCMZHMZPZQZBCOZEMZDM
      ZPZULQZPZIMJMUFFABOZGAINZAMZADOZUOUPPZQZACOZUTVAPZVGQZPVDLVEVFUMVJVMURVCA
      BIUAVEVJULVIQURVGULVIUBVEVIUQULVEVHUNUOUPABDRSUCTVEVMVBVGQVCVEVLVBVGVEVKU
      SUTVAABCRSUDVGULVBUETUGUHKUMURVCULUQUIVBULUIUJUK $.

    ${
      unxpdomlem2.1 $e |- ( ph -> w e. ( a u. b ) ) $.
      unxpdomlem2.2 $e |- ( ph -> -. m = n ) $.
      unxpdomlem2.3 $e |- ( ph -> -. s = t ) $.
      $( Lemma for ~ unxpdom .  (Contributed by Mario Carneiro,
         13-Jan-2013.) $)
      unxpdomlem2 $p |- ( ( ph /\ ( z e. a /\ -. w e. a ) ) ->
        -. ( F ` z ) = ( F ` w ) ) $=
        ( cv wceq weq wel wn cfv adantr cif cop wcel elun1 ad2antrl unxpdomlem1
        wa cun syl iftrue eqtrd iffalse ad2antll eqeq12d biimpa ifex opth sylib
        vex simprd eqeq1d syl5ib simpld syl5ibr syld ad2antrr notbid syl5ibrcom
        equequ1 pm2.65d mt3d 3eqtr3d mtand ) ACKUAZDKUAZUBZUKZUKZCRZHUCZDRZHUCZ
        SZJETZAWHUBWAQUDWBWGUKZCFTZERZJRZUEZWEWLWKWIWCDETZGRZFRZUEZSZWMWESZWIWC
        WMUFZWQWEUFZSZWRWSUKWBWGXBWBWDWTWFXAWBWDVRWTCETWOWPUEWCUFZUEZWTWBWCKRZL
        RZULZUGZWDXDSVRXHAVTWCXEXFUHUIBCEFGHIJKLMNUJUMVRXDWTSAVTVRWTXCUNUIUOWBW
        FVSWEDFTWKWLUEUFZXAUEZXAWBWEXGUGZWFXJSAXKWAOUDBDEFGHIJKLMNUJUMVTXJXASAV
        RVSXIXAUPUQUOURUSWCWMWQWECVCWJWKWLEVCJVCUTVAVBZVDZWIWJUBWMWLSWIWJCGTZWI
        WJWNXNWJWMWKSWIWNWJWKWLUNWIWMWEWKXMVEVFWNXNWIWQWOSWNWOWPUNWIWCWQWOWIWRW
        SXLVGZVEVHVIWIXNUBWJFGTZUBZAXQWAWGPVJWJXNXPCFGVMVKVLVNZWJWKWLUPUMWIWNWJ
        XRWNUBWJWIWQWPSWNWOWPUPWIWCWQWPXOVEVHVOVPVQ $.
    $}

    $( Lemma for ~ unxpdom .  (Contributed by Mario Carneiro, 13-Jan-2013.)
       (Revised by Mario Carneiro, 16-Nov-2014.) $)
    unxpdomlem3 $p |- ( ( 1o ~< a /\ 1o ~< b )
                        -> ( a u. b ) ~<_ ( a X. b ) ) $=
      ( vz vw cv weq wrex wcel wa wceq cif c1o csdm wbr wn cun cxp cdom cvv vex
      wb 1sdom ax-mp reeanv wel w3a wf1 wf cfv wi wral simpr simp2r simp1r ifcl
      cop syl2anc ad2antrr opelxpi simp2l simp1l wo elun sylib orcanai syl5eqel
      ifclda fmptd unxpdomlem1 ad2antrl iftrue adantr sylan9eq ad2antll eqeq12d
      adantl opth1 syl6bi simprr simpll simplr unxpdomlem2 pm2.21d eqcom simprl
      ifex ancom2s iffalse simprbi 4casesdan ralrimivva 3ad2ant3 dff13 sylanbrc
      syl5bi opth unex xpex f1dom2g mp3an12 3expia rexlimdvva syl5bir rexlimivv
      syl sylbir syl2anb ) UAHNZUBUCZCDOUDZDXQPZCXQPZGBOUDZBINZPZGYCPZXQYCUEZXQ
      YCUFZUGUCZUAYCUBUCZXQUHQXRYAUJHUIZCDXQUHUKULYCUHQYIYEUJIUIZGBYCUHUKULYAYE
      RXTYDRZGYCPCXQPYHXTYDCGXQYCUMYLYHCGXQYCYLXSYBRZBYCPDXQPCHUNZGIUNZRZYHXSYB
      DBXQYCUMYPYMYHDBXQYCYPDHUNZBIUNZRZYMYHYPYSYMUOZYFYGEUPZYHYTYFYGEUQLNZEURZ
      MNZEURZSZLMOZUSZMYFUTLYFUTZUUAYTAYFFYGEYTANZYFQZRZFAHUNZUUJACOZBNZGNZTZVE
      ZABOZDNZCNZTZUUJVEZTYGKUULUUMUURUVCYGUULUUMRUUMUUQYCQZUURYGQUULUUMVAYTUVD
      UUKUUMYTYRYOUVDYPYQYRYMVBYNYOYSYMVCUUNUUOUUPYCVDVFVGUUJUUQXQYCVHVFUULUUMU
      DZRUVBXQQZAIUNZUVCYGQYTUVFUUKUVEYTYQYNUVFYPYQYRYMVIYNYOYSYMVJUUSUUTUVAXQV
      DVFVGUULUUMUVGUULUUKUUMUVGVKYTUUKVAUUJXQYCVLVMVNUVBUUJXQYCVHVFVPVOJVQYMYP
      UUIYSYMUUHLMYFYFYMUUBYFQZUUDYFQZRZRZLHUNZMHUNZUUHUVKUVLUVMRZRZUUFUUBLCOZU
      UOUUPTZVEZUUDMCOUUOUUPTZVEZSUUGUVOUUCUVRUUEUVTUVKUVNUUCUVLUVRLBOZUUTUVATZ
      UUBVEZTZUVRUVHUUCUWDSYMUVIALBCDEFGHIJKVRVSZUVLUWDUVRSUVMUVLUVRUWCVTWAWBUV
      KUVNUUEUVMUVTMBOUUTUVATZUUDVEZTZUVTUVIUUEUWHSYMUVHAMBCDEFGHIJKVRWCZUVMUWH
      UVTSUVLUVMUVTUWGVTWEWBWDUUBUVQUUDUVSLUIZUVPUUOUUPBUIGUIWOWFWGUVKUVLUVMUDZ
      RRUUFUUGUVKALMBCDEFGHIJKYMUVHUVIWHXSYBUVJWIZXSYBUVJWJZWKWLUUFUUEUUCSZUVKU
      VLUDZUVMRRZUUGUUCUUEWMUWPUWNUUGUVKUVMUWOUWNUDUVKAMLBCDEFGHIJKYMUVHUVIWNUW
      LUWMWKWPWLXDUVKUWOUWKRZRZUUFUWCUWGSZUUGUWRUUCUWCUUEUWGUVKUWQUUCUWDUWCUWEU
      WOUWDUWCSUWKUVLUVRUWCWQWAWBUVKUWQUUEUWHUWGUWIUWKUWHUWGSUWOUVMUVTUWGWQWEWB
      WDUWSUWBUWFSUUGUWBUUBUWFUUDUWAUUTUVADUICUIWOUWJXEWRWGWSWTXALMYFYGEXBXCYFU
      HQYGUHQUUAYHXQYCYJYKXFXQYCYJYKXGYFYGEUHUHXHXIXNXJXKXLXMXOXP $.
  $}

  ${
    $d A x y $.  $d B y $.  $d t u v w x y z $.
    $( Cross product dominates union for sets with cardinality greater than 1.
       Proposition 10.36 of [TakeutiZaring] p. 93.  (Contributed by Mario
       Carneiro, 13-Jan-2013.)  (Proof shortened by Mario Carneiro,
       27-Apr-2015.) $)
    unxpdom $p |- ( ( 1o ~< A /\ 1o ~< B ) -> ( A u. B ) ~<_ ( A X. B ) ) $=
      ( vx vy vz vw vv vu cvv wcel wa c1o csdm wbr cun cxp cdom cv wi cif breq2
      vt relsdom brrelex2i anim12i wceq anbi1d uneq1 xpeq1 breq12d anbi2d uneq2
      imbi12d xpeq2 weq cop cmpt eqid unxpdomlem3 vtocl2g mpcom ) AIJZBIJZKLAMN
      ZLBMNZKZABOZABPZQNZVDVBVEVCLAMUCUDLBMUCUDUELCRZMNZLDRZMNZKZVJVLOZVJVLPZQN
      ZSVDVMKZAVLOZAVLPZQNZSVFVISCDABIIVJAUFZVNVRVQWAWBVKVDVMVJALMUAUGWBVOVSVPV
      TQVJAVLUHVJAVLUIUJUMVLBUFZVRVFWAVIWCVMVEVDVLBLMUAUKWCVSVGVTVHQVLBAULVLBAU
      NUJUMEFGHEVOERZVJJWDEGUOFRUBRTUPEFUOHRGRTWDUPTZUQZWEUBCDWFURWEURUSUTVA $.
  $}

  ${
    $( Corollary of ~ unxpdom .  (Contributed by NM, 16-Sep-2004.) $)
    unxpdom2 $p |- ( ( 1o ~< A /\ B ~<_ A ) -> ( A u. B ) ~<_ ( A X. A ) ) $=
      ( c1o csdm wbr cdom cun csn cxp c0 cen cvv xpsneng sylancl ensymd domentr
      wcel com syl2anc sdomentr wa cin wceq relsdom brrelex2i adantr 1onn endom
      syl simpr 0ex wne xpsndisj mp1i undom syl21anc syldan unxpdom xpen domtr
      1n0 ) CADEZBAFEZUAZABGZACHIZAJHIZGZFEZVHAAIZFEZVEVJFEVDAVFFEZBVGFEZVFVGUB
      JUCZVIVDAVFKEZVLVDVFAVDALQZCRQVFAKEZVBVPVCCADUDUEUFZUGACLRMNZOZAVFUHUIVDV
      CAVGKEZVMVBVCUJVDVGAVDVPJLQVGAKEZVRUKAJLLMNZOZBAVGPSCJULVNVDVAACAJUMUNAVF
      BVGUOUPVDVHVFVGIZFEZWEVJKEZVKVDCVFDEZCVGDEZWFVBVCVOWHVTCAVFTUQVBVCWAWIWDC
      AVGTUQVFVGURSVDVQWBWGVSWCVFAVGAUSSVHWEVJPSVEVHVJUTS $.
  $}

  ${
    $d x A $.
    $( Cross product dominates successor for set with cardinality greater than
       1.  Proposition 10.38 of [TakeutiZaring] p. 93 (but generalized to
       arbitrary sets, not just ordinals).  (Contributed by NM, 3-Sep-2004.)
       (Proof shortened by Mario Carneiro, 27-Apr-2015.) $)
    sucxpdom $p |- ( 1o ~< A -> suc A ~<_ ( A X. A ) ) $=
      ( c1o csdm wbr csn cun cxp cdom c0 cen wcel con0 xpsneng sylancl sdomentr
      cvv ensymd syl syl2anc mpdan csuc df-suc cin wceq relsdom brrelex2i endom
      1on ensn1g ensdomtr mpancom 0ex sdomdom wne 1n0 xpsndisj syl21anc unxpdom
      mp1i undom domtr xpen domentr syl5eqbr ) BACDZAUAAAEZFZAAGZHAUBVEVGABEGZA
      IEGZGZHDZVKVHJDZVGVHHDVEVGVIVJFZHDZVNVKHDZVLVEAVIHDZVFVJHDZVIVJUCIUDZVOVE
      AVIJDZVQVEVIAVEAPKZBLKVIAJDZBACUEUFZUHABPLMNZQZAVIUGRVEVFVJCDZVRVEVFACDZA
      VJJDZWFVFBJDZVEWGVEWAWIWCAPUIRVFBAUJUKVEVJAVEWAIPKVJAJDZWCULAIPPMNZQZVFAV
      JOSVFVJUMRBIUNVSVEUOABAIUPUSAVIVFVJUTUQVEBVICDZBVJCDZVPVEVTWMWEBAVIOTVEWH
      WNWLBAVJOTVIVJURSVGVNVKVASVEWBWJVMWDWKVIAVJAVBSVGVKVHVCSVD $.
  $}

  $( A set equinumerous to a proper subset of itself is infinite.  Corollary
     6D(a) of [Enderton] p. 136.  (Contributed by NM, 2-Jun-1998.) $)
  pssinf $p |- ( ( A C. B /\ A ~~ B ) -> -. B e. Fin ) $=
    ( wpss cen wbr cfn wcel wn csdm php3 ex sdomnen syl6com con2d imp ) ABCZABD
    EZBFGZHPRQRPABIEZQHRPSBAJKABLMNO $.

  $( A finite set is equal to its subset if they are equinumerous.
     (Contributed by FL, 11-Aug-2008.) $)
  fisseneq $p |- ( ( B e. Fin /\ A C_ B /\ A ~~ B ) -> A = B ) $=
    ( cen wbr wss cfn wcel wceq wa wn wpss df-pss pssinf expcom syl5bir expdimp
    wne necon4ad 3impia 3com13 ) ABCDZABEZBFGZABHZUAUBUCUDUAUBIUCABUAUBABQZUCJZ
    UBUEIABKZUAUFABLUGUAUFABMNOPRST $.

  $( The set of natural numbers is infinite.  Corollary 6D(b) of [Enderton]
     p. 136.  (Contributed by NM, 2-Jun-1998.) $)
  ominf $p |- -. om e. Fin $=
    ( vx com cfn wcel wn wi cv cen wbr wrex isfi wpss wss wne wa wb nnord ordom
    word ordelssne ibi df-pss sylibr ensym pssinf syl2an rexlimiva sylbi pm2.01
    sylancl ax-mp ) BCDZULEZFUMULBAGZHIZABJUMABKUOUMABUNBDZUNBLZUNBHIUMUOUPUNBM
    UNBNOZUQUPURUPUNSBSUPURPUNQRUNBTUJUAUNBUBUCBUNUDUNBUEUFUGUHULUIUK $.

  ${
    $d A f m x y z $.  $d A m n x y $.  $d f g m x y z $.
    $( Any set that is not finite is literally infinite, in the sense that it
       contains subsets of arbitrarily large finite cardinality.  (It cannot be
       proven that the set has _countably infinite_ subsets unless AC is
       invoked.)  The proof does not require the Axiom of Infinity.
       (Contributed by Mario Carneiro, 15-Jan-2013.) $)
    isinf $p |- ( -. A e. Fin -> A. n e. om E. x ( x C_ A /\ x ~~ n ) ) $=
      ( vm vy vf vz vg wcel cv wss cen wbr wa wex com c0 wceq wi wf1o cfn breq2
      wn anbi2d exbidv wb sseq1 adantl breq1 sylan9bbr anbi12d cbvexdva 0ss 0ex
      csuc enref spcev mp2an a1i w3a cdif ssdif0 eqss wrex biimpa sylan2 sylibr
      rspe isfi expcom sylanbr ex sylan2br 3impd com12 bren neq0 csn cun eldifi
      con3d snssd unss biimpi ad2ant2r cop cin vex f1osn jctr eldifn word nnord
      disjsn orddisj syl anim12i f1oun syl2an df-suc f1oeq3 ax-mp f1oeq1 sylbir
      snex unex adantll syl2anc exlimiv sylbi com13 3imp 3expia finds2 ralrimiv
      syld com3l ) BUAIZUCZAJZBKZXTCJZLMZNZAOZCPYBPIXSYEYEYAXTQLMZNZAOZYAXTDJZL
      MZNZAOZEJZBKZYMYIUOZLMZNZEOZXSCDYBQRZYDYGAYSYCYFYAYBQXTLUBUDUEYBYIRZYDYKA
      YTYCYJYAYBYIXTLUBUDUEYBYORZYDYQAEUUAXTYMRZNYAYNYCYPUUBYAYNUFUUAXTYMBUGUHU
      UBYCYMYBLMUUAYPXTYMYBLUIYBYOYMLUBUJUKULYHXSQBKZQQLMZYHBUMQUNUPYGUUCUUDNAQ
      UNXTQRYAUUCYFUUDXTQBUGXTQQLUIUKUQURUSYLYIPIZXSYRYKUUEXSYRSZSAYAYJUUEUUFYA
      YJUUEUTZXSBXTVAZQRZUCZYRUUGUUIXRUUIUUGXRUUIYAYJUUEXRYAUUIYJUUEXRSZSZUUIYA
      BXTKZUULBXTVBYAUUMNZYJUUKUUNXTBRZYJUUKXTBVCUUEUUOYJNZXRUUEUUPNBYILMZDPVDZ
      XRUUPUUEUUQUURUUOYJUUQXTBYILUIVEUUQDPVHVFDBVIVGVJVKVLVMVJVNVOWAYAYJUUEUUJ
      YRSZYJYAUUEUUSSZYJXTYIFJZTZFOYAUUTSZXTYIFVPUVBUVCFYAUVBUUTUUJUUEYAUVBNZYR
      UUJGJZUUHIZGOUUEUVDYRSZSZGUUHVQUVFUVHGUVFUUEUVGUVDUVFUUENZYRUVDUVINXTUVEV
      RZVSZBKZUVKYOLMZYRYAUVFUVLUVBUUEUVFYAUVJBKZUVLUVFUVEBUVEBXTVTWBYAUVNNUVLX
      TUVJBWCWDVFWEUVBUVIUVMYAUVBUVINUVKYIYIVRZVSZUVAUVEYIWFZVRZVSZTZUVMUVBUVBU
      VJUVOUVRTZNXTUVJWGQRZYIUVOWGQRZNUVTUVIUVBUWAUVEYIGWHDWHWIWJUVFUWBUUEUWCUV
      FUVEXTIUCUWBUVEBXTWKXTUVEWNVGUUEYIWLUWCYIWMYIWOWPWQXTYIUVJUVOUVAUVRWRWSUV
      TUVKYOUVSTZUVMYOUVPRUWDUVTUFYIWTYOUVPUVKUVSXAXBUWDUVKYOHJZTZHOUVMUWFUWDHU
      VSUVAUVRFWHUVQXEXFUVKYOUWEUVSXCUQUVKYOHVPVGXDWPXGYQUVLUVMNEUVKXTUVJAWHUVE
      XEXFYMUVKRYNUVLYPUVMYMUVKBUGYMUVKYOLUIUKUQXHVJVLXIXJXKVJXIXJVOXLXPXMXIXQX
      NVOXO $.
  $}

  ${
    $d b c d e A $.  $d b c e V $.
    $( Lemma for ~ fineqv .  (Contributed by Mario Carneiro, 20-Jan-2013.)
       (Proof shortened by Stefan O'Rear, 3-Nov-2014.)  (Revised by Mario
       Carneiro, 17-May-2015.) $)
    fineqvlem $p |- ( ( A e. V /\ -. A e. Fin ) -> om ~<_ ~P ~P A ) $=
      ( vb vc vd ve wcel wa cpw cvv com wbr pwexg syl cv cen crab wss wb wi cfn
      wn cdom adantr ssrab2 elpw2g mpbiri a1d wceq wex isinf r19.21bi ad2ant2lr
      elpw biimpri anim1i breq1 elrab sylibr eximi eleq2 biimpcd adantl simprbi
      vex ensym entr sylan syl2an nneneq biimpd ad2antlr 3syld exlimddv rabbidv
      ex breq2 impbid1 dom2d mpd ) ABGZAUAGUBZHZAIZIZJGZKWEUCLWCWDJGZWFWAWGWBAB
      MUDZWDJMNWCCDKWEEOZCOZPLZEWDQZWIDOZPLZEWDQZJWCWLWEGZWJKGZWCWPWLWDRZWKEWDU
      EWCWGWPWRSWHWLWDJUFNUGUHWCWQWMKGZHZWLWOUIZWJWMUIZSWCWTHZXAXBXCFOZWLGZXAXB
      TFXCXDARZXDWJPLZHZFUJZXEFUJWBWQXIWAWSWBXICKFACUKULUMXHXEFXHXDWDGZXGHXEXFX
      JXGXJXFXDAFVEUNUOUPWKXGEXDWDWIXDWJPUQURZUSUTNXCXEHXAXDWOGZWJWMPLZXBXEXAXL
      TXCXAXEXLWLWOXDVAVBVCXEXLXMTXCXEXLXMXEXGXDWMPLZXMXLXEXJXGXKVDXLXJXNWNXNEX
      DWDWIXDWMPUQURVDXGWJXDPLXNXMXDWJVFWJXDWMVGVHVIVPVCWTXMXBTWCXEWTXMXBWJWMVJ
      VKVLVMVNXBWKWNEWDWJWMWIPVQVOVRVPVSVT $.
  $}

  ${
    $d a n x y $.
    $( If the Axiom of Infinity is denied, then all sets are finite (which
       implies the Axiom of Choice).  (Contributed by Mario Carneiro,
       20-Jan-2013.)  (Revised by Mario Carneiro, 3-Jan-2015.) $)
    fineqv $p |- ( -. om e. _V <-> Fin = _V ) $=
      ( va com cvv wcel wn cfn wceq wss ssv a1i cpw cdom wbr vex fineqvlem mpan
      cv reldom brrelexi syl con1i a1d ssrdv eqssd ominf eleq2 mtbii impbii ) B
      CDZEZFCGZUJFCFCHUJFIJUJACFUJAQZFDZULCDZUMUIUMEZBULKKZLMZUIUNUOUQANULCOPBU
      PLRSTUAUBUCUDUKBFDUIUEFCBUFUGUH $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x C $.
    $( Equinmerous sets have the same finiteness.  (Contributed by NM,
       22-Aug-2008.) $)
    enfi $p |- ( A ~~ B -> ( A e. Fin <-> B e. Fin ) ) $=
      ( vx cen wbr cv com wrex cfn wcel enen1 rexbidv isfi 3bitr4g ) ABDEZACFZD
      EZCGHBPDEZCGHAIJBIJOQRCGABPKLCAMCBMN $.

    $( A set equinumerous to a finite set is finite.  (Contributed by Mario
       Carneiro, 12-Mar-2015.) $)
    enfii $p |- ( ( B e. Fin /\ A ~~ B ) -> A e. Fin ) $=
      ( cen wbr cfn wcel enfi biimparc ) ABCDAEFBEFABGH $.

    $( A proper subset of a natural number is equinumerous to some smaller
       number.  Lemma 6F of [Enderton] p. 137.  (Contributed by NM,
       22-Jun-1998.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
    pssnn $p |- ( ( A e. om /\ B C. A ) -> E. x e. A B ~~ x ) $=
      ( vw vz vy com wcel wpss wa cen wbr wrex wss wi wal c0 wceq imbi12d wn cv
      cvv pssss ssexg sylan ancoms psseq2 rexeq albidv weq npss0 pm2.21i ax-gen
      csuc nfv nfa1 wel elequ1 biimpcd con3d adantl sseld elsuci ord con1d syl6
      imp impancom ssrdv anim1i dfpss2 sylibr elelsuc reximi2 imim12i exp4c sps
      syld com4t csn cdif anidm ssdif word nnord orddif syl sseq2d syl5ibr syl5
      pssnel eleq2 eldifi syl6bir eleq1a sylan9r adantr pm2.61d expimpd exlimdv
      wex im2anan9r syl5bir syl6ibr psseq1 breq1 rexbidv cbvalv vex difss ssexi
      spcv sylbi sylan9 ordsucelsuc biimpd adantrd elnn cun cin wf1o snex f1osn
      ex cop f1oen3g mp2an jctr orddisj incom disjdif eqtr3i jctil unen difsnid
      syl2an eqcomd breq2 rspcev a1d a1i breq12d sylan2i exp4d com24 imp4b jcad
      df-suc df-rex cbvrexv 3imtr4g eqelsuc enref sylancl pm2.61ii alrimd finds
      expl spcgv com3l mpd ) BGHZCBIZJCUBHZCAUAZKLZABMZUVCUVBUVDUVCCBNUVBUVDCBU
      CCBGUDUEUFUVBUVCUVDUVGOUVDUVBUVCUVGUVBDUAZBIZUVHUVEKLZABMZOZDPZUVDUVCUVGO
      ZUVHEUAZIZUVJAUVOMZOZDPUVHQIZUVJAQMZOZDPUVHFUAZIZUVJAUWBMZOZDPZUVHUWBUNZI
      ZUVJAUWGMZOZDPUVMEFBUVOQRZUVRUWADUWKUVPUVSUVQUVTUVOQUVHUGUVJAUVOQUHSUIEFU
      JZUVRUWEDUWLUVPUWCUVQUWDUVOUWBUVHUGUVJAUVOUWBUHSUIUVOUWGRZUVRUWJDUWMUVPUW
      HUVQUWIUVOUWGUVHUGUVJAUVOUWGUHSUIUVOBRZUVRUVLDUWNUVPUVIUVQUVKUVOBUVHUGUVJ
      AUVOBUHSUIUWADUVSUVTUVHUKULUMUWBGHZUWFUWJDUWODUOUWEDUPUWOUWFUWJFDUQZDFUJZ
      UWOUWFJZUWJOUWRUWHUWPTZUWQTZUWIUWFUWHUWSUWTUWIOOOZUWOUWEUXADUWEUWHUWSUWTU
      WIUWHUWSJZUWTJZUWCUWDUWIUXCUVHUWBNZUWTJUWCUXBUXDUWTUXBEUVHUWBUWHEDUQZUWSE
      FUQZUWHUXEJUWSUWLTZUXFUXEUWSUXGOUWHUXEUWLUWPUWLUXEUWPEFDURUSUTVAUWHUXEUXG
      UXFOZUWHUXEUVOUWGHZUXHUWHUVHUWGUVOUVHUWGUCZVBUXIUXFUWLUXIUXFUWLUVOUWBVCVD
      ZVEVFVGVRVHVIVJUVHUWBVKVLUVJUVJAUWBUWGAFUQZUVEUWGHUVJUVEUWBVMVJVNVOVPVQVA
      VSUWPUWOUWFUWJUWPUWOJZUWFJUWHUVHUWBVTZWAZUVEKLZAUWBMZUWIUXMUWHUXOUWBIZUWF
      UXQUXMUWHUXOUWBNZUXOUWBRZTZJZUXRUWHUWHUWHJUXMUYBUWHWBUWOUWHUXSUWPUWHUYAUW
      HUVHUWGNZUWOUXSUXJUYCUXSUWOUXOUWGUXNWAZNUVHUWGUXNWCUWOUWBUYDUXOUWOUWBWDZU
      WBUYDRUWBWEZUWBWFWGWHWIWJUWHUXIUXETZJZEXAUWPUYAEUVHUWGWKUWPUYHUYAEUWPUXIU
      YGUYAUWPUXIJZUXTUXEUYIUXTUXEUYIUXTJUXFUXEUXTUXFUXEOUYIUXTUXFUVOUXOHUXEUXO
      UWBUVOWLUVOUVHUXNWMWNVAUYIUXFTZUXEOUXTUXIUYJUWLUWPUXEUXKUWBUVHUVOWOWPWQWR
      YDUTWSWTWJXBXCUXOUWBVKXDUWFUVOUWBIZUVOUVEKLZAUWBMZOZEPUXRUXQOZUWEUYNDEDEU
      JZUWCUYKUWDUYMUVHUVOUWBXEUYPUVJUYLAUWBUVHUVOUVEKXFXGSXHUYNUYOEUXOUXOUVHDX
      IZUVHUXNXJXKUVOUXORZUYKUXRUYMUXQUVOUXOUWBXEUYRUYLUXPAUWBUVOUXOUVEKXFXGSXL
      XMXNUXMUXQUWIOUWFUXMUXLUXPJZAXAUVHUVOKLZEUWGMZUXQUWIUXMUYSVUAAUXMUYSUVEUN
      ZUWGHZUVHVUBKLZJVUAUXMUYSVUCVUDUXMUXLVUCUXPUWOUXLVUCOZUWPUWOUYEVUEUYFUYEU
      XLVUCUVEUWBXOXPWGVAXQUWPUWOUXLUXPVUDUWPUXPUXLUWOVUDUWPUXPUXLUWOVUDUXLUWOJ
      UWPUXPUVEGHZVUDUVEUWBXRUXPVUFJVUDUWPUXOUXNXSZUVEUVEVTZXSZKLZUXPUXPUXNVUHK
      LZJUXOUXNXTZQRZUVEVUHXTQRZJVUJVUFUXPVUKUWBUVEYEZVTZUBHUXNVUHVUPYAVUKVUOYB
      UWBUVEFXIAXIYCUXNVUHVUPUBYFYGYHVUFVUNVUMVUFUVEWDVUNUVEWEUVEYIWGUXNUXOXTVU
      LQUXNUXOYJUXNUVHYKYLYMUXOUVEUXNVUHYNYPUWPUVHVUGVUBVUIKUWPVUGUVHUVHUWBYOYQ
      VUBVUIRUWPUVEUUHUUAUUBWIUUCUUDUUEUUFUUGUYTVUDEVUBUWGUVOVUBUVHKYRYSVFWTUXP
      AUWBUUIUVJUYTAEUWGUVEUVOUVHKYRUUJUUKWQVRUURUWQUWJUWRUWQUWIUWHUWQUVHUWGHUV
      HUVHKLZUWIUVHUWBUYQUULUVHUYQUUMUVJVUQAUVHUWGUVEUVHUVHKYRYSUUNYTYTUUOYDUUP
      UUQUVLUVNDCUBUVHCRZUVIUVCUVKUVGUVHCBXEVURUVJUVFABUVHCUVEKXFXGSUUSWJUUTVGU
      VA $.

    $( A subset of a natural number is finite.  (Contributed by NM,
       24-Jun-1998.) $)
    ssnnfi $p |- ( ( A e. om /\ B C_ A ) -> B e. Fin ) $=
      ( vx com wcel wss wa cv cen wbr wrex cfn wpss wceq wo sspss pssnn wi elnn
      expcom anim1d reximdv2 adantr mpd eleq1 biimparc enrefg ancli rspcev 3syl
      breq2 jaodan sylan2b isfi sylibr ) ADEZBAFZGBCHZIJZCDKZBLEUQUPBAMZBANZOUT
      BAPUPVAUTVBUPVAGUSCAKZUTCABQUPVCUTRVAUPUSUSCADUPURAEZURDEZUSVDUPVEURASTUA
      UBUCUDUPVBGBDEZVFBBIJZGUTVBVFUPBADUEUFVFVGBDUGUHUSVGCBDURBBIUKUIUJULUMCBU
      NUO $.

    $( A subset of a finite set is finite.  Corollary 6G of [Enderton] p. 138.
       (Contributed by NM, 24-Jun-1998.) $)
    ssfi $p |- ( ( A e. Fin /\ B C_ A ) -> B e. Fin ) $=
      ( vx vz vy cfn wcel wss cv cen wbr com wrex wi isfi wf1o wex bren sylan
      wa cima wfo f1ofo crn imassrn forn syl5sseq syl ssnnfi sylib adantrr cres
      sylan2 wf1 f1of1 f1ores resex f1oeq1 spcev sylibr entr ex reximdv syl6ibr
      vex adantl mpd exp32 exlimdv syl5bi rexlimiv sylbi imp ) AFGZBAHZBFGZVNAC
      IZJKZCLMVOVPNZCAOVRVSCLVRAVQDIZPZDQVQLGZVSAVQDRWBWAVSDWBWAVOVPWBWAVOTZTVT
      BUAZEIZJKZELMZVPWBWAWGVOWAWBWDVQHZWGWAAVQVTUBZWHAVQVTUCWIVTUDWDVQVTBUEAVQ
      VTUFUGUHWBWHTWDFGWGVQWDUIEWDOUJUMUKWCWGVPNWBWCWGBWEJKZELMVPWCWFWJELWCWFWJ
      WCBWDVTBULZPZWFWJWAAVQVTUNVOWLAVQVTUOAVQBVTUPSWLBWDJKZWFWJWLBWDVQPZCQWMWN
      WLCWKVTBDVEUQBWDVQWKURUSBWDCRUTBWDWEVASSVBVCEBOVDVFVGVHVIVJVKVLVM $.

    $( A set dominated by a finite set is finite.  (Contributed by NM,
       23-Mar-2006.)  (Revised by Mario Carneiro, 12-Mar-2015.) $)
    domfi $p |- ( ( A e. Fin /\ B ~<_ A ) -> B e. Fin ) $=
      ( vx cfn wcel cdom wbr cv cen wss wa domeng ssfi adantrl adantrr sylancom
      wex enfii ex exlimdv sylbid imp ) ADEZBAFGZBDEZUCUDBCHZIGZUFAJZKZCQUECBAD
      LUCUIUECUCUIUEUCUIUFDEZUEUCUHUJUGAUFMNUJUGUEUHBUFROPSTUAUB $.

    $( The components of a non-empty finite cross product are finite.
       (Contributed by Paul Chapman, 11-Apr-2009.)  (Proof shortened by Mario
       Carneiro, 29-Apr-2015.) $)
    xpfir $p |- ( ( ( A X. B ) e. Fin /\ ( A X. B ) =/= (/) ) ->
                 ( A e. Fin /\ B e. Fin ) ) $=
      ( cxp cfn wcel c0 wne wa cdom wbr cvv xpexr2 simpld simprd xpdom3 syl3anc
      simpr domfi syldan syl2anc xpnz sylibr cen xpcomeng domentr jca ) ABCZDEZ
      UGFGZHZADEZBDEZUHUIAUGIJZUKUJAKEZBKEZBFGZUMUJUNUOABDLZMZUJUNUOUQNZUJAFGZU
      PUJUIUTUPHUHUIQABUAUBZNABKKOPUGARSUHUIBUGIJZULUJBBACZIJZVCUGUCJZVBUJUOUNU
      TVDUSURUJUTUPVAMBAKKOPUJUOUNVEUSURBAKKUDTBVCUGUETUGBRSUF $.
  $}

  $( The interection of two sets is finite if one of them is.  (Contributed by
     Thierry Arnoux, 14-Feb-2017.) $)
  infi $p |- ( A e. Fin -> ( A i^i B ) e. Fin ) $=
    ( cfn wcel cin wss inss1 ssfi mpan2 ) ACDABEZAFJCDABGAJHI $.

  ${
    $d x A $.
    $( A restricted class built from a finite set is finite.  (Contributed by
       Thierry Arnoux, 14-Feb-2017.) $)
    rabfi $p |- ( A e. Fin -> { x e. A | ph } e. Fin ) $=
      ( cfn wcel crab cab cin dfrab3 infi syl5eqel ) CDEABCFCABGZHDABCICLJK $.
  $}

  $( The restriction of a finite set is finite.  (Contributed by Alexander van
     der Vekens, 3-Jan-2018.) $)
  finresfin $p |- ( E e. Fin -> ( E |` B ) e. Fin ) $=
    ( cfn wcel cres wss resss ssfi mpan2 ) BCDBAEZBFJCDBAGBJHI $.

  $( Any injection from one finite set to another of equal size must be a
     bijection.  (Contributed by Jeff Madsen, 5-Jun-2010.)  (Revised by Mario
     Carneiro, 27-Feb-2014.) $)
  f1finf1o $p |- ( ( A ~~ B /\ B e. Fin ) ->
    ( F : A -1-1-> B <-> F : A -1-1-onto-> B ) ) $=
    ( cen wbr cfn wcel wa wf1 wf1o wfo simpr adantl syl wb cvv syl2anc sylanbrc
    csdm ex wfn crn wceq wf f1f ffn simpll wne wpss wn wss frn df-pss baib cmap
    co simplr relen brrelexi elmapg mpbird f1f1orn f1oen3g php3 ensdomtr ee12an
    wi sdomnen syl6 sylbird necon4ad mpd df-fo df-f1o f1of1 impbid1 ) ABDEZBFGZ
    HZABCIZABCJZVSVTWAVSVTHZVTABCKZWAVSVTLWBCAUAZCUBZBUCZWCWBABCUDZWDVTWGVSABCU
    EMZABCUFNWBVQWFVQVRVTUGZWBVQWEBWBWEBUHZWEBUIZVQUJZWBWEBUKZWKWJOWBWGWMWHABCU
    LNWKWMWJWEBUMUNNWBWKABSEZWLWBAWEDEZWKWEBSEZWNWBCBAUOUPZGZAWECJZWOWBWRWGWHWB
    VRAPGZWRWGOVQVRVTUQZWBVQWTWIABDURUSNBACFPUTQVAVTWSVSABCVBMAWECWQVCQWBVRWKWP
    VGXAVRWKWPBWEVDTNAWEBVEVFABVHVIVJVKVLABCVMRABCVNRTABCVOVP $.

  $( The empty set is finite.  (Contributed by FL, 14-Jul-2008.) $)
  0fin $p |- (/) e. Fin $=
    ( c0 com wcel wss cfn peano1 ssid ssnnfi mp2an ) ABCAADAECFAGAAHI $.

  ${
    $d A x $.
    $( If a class is not finite, it contains at least one element.
       (Contributed by Alexander van der Vekens, 12-Jan-2018.) $)
    nfielex $p |- ( -. A e. Fin -> E. x x e. A ) $=
      ( cfn wcel wn c0 wceq cv wex 0fin eleq1 mpbiri con3i neq0 sylib ) BCDZEBF
      GZEAHBDAIQPQPFCDJBFCKLMABNO $.
  $}

  $( A set with one element is a singleton.  (Contributed by FL,
     18-Aug-2008.) $)
  en1eqsn $p |- ( ( A e. B /\ B ~~ 1o ) -> B = { A } ) $=
    ( wcel c1o cen wbr csn cfn wss wceq com 1onn ssid ssnnfi mp2an enfii adantl
    wa mpan snssi adantr ensn1g ensym entr syl2an fisseneq syl3anc eqcomd ) ABC
    ZBDEFZRZAGZBUKBHCZULBIZULBEFZULBJUJUMUIDHCZUJUMDKCDDIUPLDMDDNOBDPSQUIUNUJAB
    TUAUIULDEFDBEFUOUJABUBBDUCULDBUDUEULBUFUGUH $.

  $( If ` A ` is finite, ` ( A \ B ) ` is finite.  (Contributed by FL,
     3-Aug-2009.) $)
  diffi $p |- ( A e. Fin -> ( A \ B ) e. Fin ) $=
    ( cfn wcel cdif wss difss ssfi mpan2 ) ACDABEZAFJCDABGAJHI $.

  ${
    $d A x $.  $d X x $.  $d M x $.
    dif1en.1 $e |- A e. _V $.
    $( If a set ` A ` is equinumerous to the successor of a natural number
       ` M ` , then ` A ` with an element removed is equinumerous to ` M ` .
       (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dif1enOLD $p |- ( ( M e. om /\ A ~~ suc M /\ X e. A )
                                                -> ( A \ { X } ) ~~ M ) $=
      ( vx com wcel csuc cen wbr csn wrex wa cfn peano2 breq2 wceq wi cin c0 cv
      w3a cdif rspcev isfi sylibr sylan diffi sylib syl 3adant3 cun en2sn mpan2
      cvv word nnord orddisj incom disjdif eqtri unen an4s mpanl2 expcom syl2an
      vex 3ad2antl3 wb difsnid df-suc eqcomi breq12d 3ad2ant3 adantr ensym entr
      a1i nneneq sylan2 syl5ib exp3a imp an32s 3adantl3 sylbid peano4 3ad2antl1
      syl5 biimpd 3syld biimprcd sylcom rexlimdva mpd ) BFGZABHZIJZCAGZUBZACKZU
      CZEUAZIJZEFLZXBBIJZWPWRXEWSWPWRMANGZXEWPWQFGZWRXGBOZXHWRMAXCIJZEFLXGXJWRE
      WQFXCWQAIPUDEAUEUFUGXGXBNGXEAXAUHEXBUEUIUJUKWTXDXFEFWTXCFGZMZXDBXCQZXFXLX
      DXBXAULZXCXCKZULZIJZWQXCHZQZXMWSWPXKXDXQRZWRWSXAXOIJZXCXOSTQZXTXKWSXCUOGY
      AEVGCXCAUOUMUNXKXCUPYBXCUQXCURUJXDYAYBMZXQXDXBXASZTQZYCXQYDXAXBSTXBXAUSXA
      AUTVAXDYAYEYBXQXBXCXAXOVBVCVDVEVFVHXLXQAXRIJZXSWTXQYFVIZXKWSWPYGWRWSXNAXP
      XRIACVJXPXRQWSXRXPXCVKVLVRVMVNVOWPWRXKYFXSRZWSWPXKWRYHWPXKMZWRYHWPXHXKWRY
      HRXIWRWQAIJZXHXKMZYHAWQVPYKYJYFXSYJYFMWQXRIJZYKXSWQAXRVQXKXHXRFGYLXSVIXCO
      WQXRVSVTWAWBWIUGWCWDWEWFWPWRXKXSXMRWSYIXSXMBXCWGWJWHWKXMXFXDBXCXBIPWLWMWN
      WO $.
  $}

  ${
    $d A x $.  $d X x $.  $d M x $.
    $( If a set ` A ` is equinumerous to the successor of a natural number
       ` M ` , then ` A ` with an element removed is equinumerous to ` M ` .
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Stefan O'Rear,
       16-Aug-2015.) $)
    dif1en $p |- ( ( M e. om /\ A ~~ suc M /\ X e. A ) ->
        ( A \ { X } ) ~~ M ) $=
      ( vx com wcel csuc cen wbr csn wrex wa cfn peano2 breq2 isfi wceq wi cin
      c0 w3a cdif rspcev sylibr sylan diffi sylib syl 3adant3 cun cvv vex en2sn
      cv mpan2 word nnord orddisj incom disjdif eqtri unen mpanl2 expcom syl2an
      an4s 3ad2antl3 wb difsnid df-suc eqcomi a1i breq12d 3ad2ant3 adantr ensym
      entr nneneq sylan2 syl5ib exp3a syl5 imp 3adantl3 sylbid peano4 3ad2antl1
      an32s biimpd 3syld biimprcd sylcom rexlimdva mpd ) BEFZABGZHIZCAFZUAZACJZ
      UBZDUNZHIZDEKZXABHIZWOWQXDWRWOWQLAMFZXDWOWPEFZWQXFBNZXGWQLAXBHIZDEKXFXIWQ
      DWPEXBWPAHOUCDAPUDUEXFXAMFXDAWTUFDXAPUGUHUIWSXCXEDEWSXBEFZLZXCBXBQZXEXKXC
      XAWTUJZXBXBJZUJZHIZWPXBGZQZXLWRWOXJXCXPRZWQWRWTXNHIZXBXNSTQZXSXJWRXBUKFXT
      DULCXBAUKUMUOXJXBUPYAXBUQXBURUHXCXTYALZXPXCXAWTSZTQZYBXPYCWTXASTXAWTUSWTA
      UTVAXCXTYDYAXPXAXBWTXNVBVFVCVDVEVGXKXPAXQHIZXRWSXPYEVHZXJWRWOYFWQWRXMAXOX
      QHACVIXOXQQWRXQXOXBVJVKVLVMVNVOWOWQXJYEXRRZWRWOXJWQYGWOXJLZWQYGWOXGXJWQYG
      RXHWQWPAHIZXGXJLZYGAWPVPYJYIYEXRYIYELWPXQHIZYJXRWPAXQVQXJXGXQEFYKXRVHXBNW
      PXQVRVSVTWAWBUEWCWHWDWEWOWQXJXRXLRWRYHXRXLBXBWFWIWGWJXLXEXCBXBXAHOWKWLWMW
      N $.
  $}

  ${
    enp1ilem.1 $e |- T = ( { x } u. S ) $.
    $( Lemma for uses of ~ enp1i .  (Contributed by Mario Carneiro,
       5-Jan-2016.) $)
    enp1ilem $p |- ( x e. A -> ( ( A \ { x } ) = S -> A = T ) ) $=
      ( cv csn cdif wceq cun wcel uneq1 undif1 uncom eqtr4i 3eqtr3g wss ssequn2
      snssi sylib eqeq1d syl5ib ) BAFZGZHZCIZBUDJZDIUCBKZBDIUFUEUDJCUDJZUGDUECU
      DLBUDMUIUDCJDCUDNEOPUHUGBDUHUDBQUGBIUCBSUDBRTUAUB $.
  $}

  ${
    $d x A $.  $d x N $.
    enp1i.1 $e |- M e. om $.
    enp1i.2 $e |- N = suc M $.
    enp1i.3 $e |- ( ( A \ { x } ) ~~ M -> ph ) $.
    enp1i.4 $e |- ( x e. A -> ( ph -> ps ) ) $.
    $( Proof induction for ~ en2i and related theorems.  (Contributed by Mario
       Carneiro, 5-Jan-2016.) $)
    enp1i $p |- ( A ~~ N -> E. x ps ) $=
      ( cen wbr cv wcel wex c0 wceq wn csuc sylib wne nsuceq0 breq1 en0 syl5eqr
      ensym syl6bi necon3ad mpi con2i neq0 wi breq2i csn cdif com dif1en mp3an1
      wa syl ex sylbi sylcom eximdv mpd ) DFKLZCMZDNZCOZBCOVFDPQZRVIVJVFVJESZPU
      AVFREUBVJVFVKPVJVFPFKLZVKPQDPFKUCVLVKFPHVLFPKLFPQPFUFFUDTUEUGUHUIUJCDUKTV
      FVHBCVFVHABVFDVKKLZVHAULFVKDKHUMVMVHAVMVHUSDVGUNUOEKLZAEUPNVMVHVNGDEVGUQU
      RIUTVAVBJVCVDVE $.
  $}

  ${
    $d x y f A $.
    $( A set equinumerous to ordinal 2 is a pair.  (Contributed by Mario
       Carneiro, 5-Jan-2016.) $)
    en2 $p |- ( A ~~ 2o -> E. x E. y A = { x , y } ) $=
      ( cv csn cdif wceq wex cpr c1o c2o 1onn df-2o cen wbr en1 biimpi enp1ilem
      wcel df-pr eximdv enp1i ) CADZEFZBDZEZGZBHZCUCUEIZGZBHACJKLMUDJNOUHBUDPQU
      CCSUGUJBACUFUIUCUETRUAUB $.
  $}

  ${
    $d x y z A $.
    $( A set equinumerous to ordinal 3 is a triple.  (Contributed by Mario
       Carneiro, 5-Jan-2016.) $)
    en3 $p |- ( A ~~ 3o -> E. x E. y E. z A = { x , y , z } ) $=
      ( cv csn cdif cpr wceq wex ctp c2o c3o 2onn df-3o en2 wcel tpass enp1ilem
      2eximdv enp1i ) DAEZFGZBEZCEZHZIZCJBJDUBUDUEKZIZCJBJADLMNOBCUCPUBDQUGUIBC
      ADUFUHUBUDUERSTUA $.
  $}

  ${
    $d w x y z A $.
    $( A set equinumerous to ordinal 4 is a quadruple.  (Contributed by Mario
       Carneiro, 5-Jan-2016.) $)
    en4 $p |- ( A ~~ 4o ->
      E. x E. y E. z E. w A = ( { x , y } u. { z , w } ) ) $=
      ( cv csn cdif ctp wceq wex cpr cun c3o c4o 3onn df-4o en3 wcel qdassr
      enp1ilem eximdv 2eximdv enp1i ) EAFZGHZBFZCFZDFZIZJZDKZCKBKEUEUGLUHUILMZJ
      ZDKZCKBKAENOPQBCDUFRUEESZULUOBCUPUKUNDAEUJUMUEUGUHUITUAUBUCUD $.
  $}

  ${
    $d v w x y z $.  $d A x y z $.  $d ps x $.  $d ch x $.  $d th x $.
    $d ta x $.  $d ph v w y z $.
    findcard.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    findcard.2 $e |- ( x = ( y \ { z } ) -> ( ph <-> ch ) ) $.
    findcard.3 $e |- ( x = y -> ( ph <-> th ) ) $.
    findcard.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    findcard.5 $e |- ps $.
    findcard.6 $e |- ( y e. Fin -> ( A. z e. y ch -> th ) ) $.
    $( Schema for induction on the cardinality of a finite set.  The inductive
       hypothesis is that the result is true on the given set with any one
       element removed.  The result is then proven to be true for all finite
       sets.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    findcard $p |- ( A e. Fin -> ta ) $=
      ( vw wcel cen wbr com vv cfn cv wrex isfi wi wal csuc breq2 imbi1d albidv
      c0 wceq en0 mpbiri sylbi ax-gen w3a wa peano2 rspcev sylan sylibr 3adant2
      wral csn cdif dif1en 3expa cvv vex difexg ax-mp imbi12d syl5com ralrimdva
      breq1 spcv imp an32s 3impa alrimdv cbvalv syl6ibr finds1 19.21bi rexlimiv
      sylc 3exp vtoclga ) AEFIUBMFUCZUBQWKPUCZRSZPTUDAPWKUEWMAPTWLTQWMAUFZFWNFU
      GWKULRSZAUFZFUGWKUAUCZRSZAUFZFUGZWKWQUHZRSZAUFZFUGZPUAWLULUMZWNWPFXEWMWOA
      WLULWKRUIUJUKWLWQUMZWNWSFXFWMWRAWLWQWKRUIUJUKWLXAUMZWNXCFXGWMXBAWLXAWKRUI
      UJUKWPFWOWKULUMZAWKUNXHABNJUOUPUQWQTQZWTGUCZXARSZDUFZGUGXDXIWTXLGXIWTXKDX
      IWTXKURXJUBQZCHXJVEZDXIXKXMWTXIXKUSZXJWLRSZPTUDZXMXIXATQXKXQWQUTXPXKPXATW
      LXAXJRUIVAVBPXJUEVCVDXIWTXKXNXIXKWTXNXOWTXNXOWTCHXJXOHUCZXJQZUSXJXRVFZVGZ
      WQRSZWTCXIXKXSYBXJWQXRVHVIWSYBCUFFYAXJVJQYAVJQGVKXJXTVJVLVMWKYAUMWRYBACWK
      YAWQRVQKVNVRVOVPVSVTWAOWHWIWBXCXLFGWKXJUMXBXKADWKXJXARVQLVNWCWDWEWFWGUPWJ
      $.
  $}

  ${
    $d v w x y z $.  $d A w x y z $.  $d ps x $.  $d ch x $.  $d th x $.
    $d ta x $.  $d ph v w y z $.
    findcard2.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    findcard2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    findcard2.3 $e |- ( x = ( y u. { z } ) -> ( ph <-> th ) ) $.
    findcard2.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    findcard2.5 $e |- ps $.
    findcard2.6 $e |- ( y e. Fin -> ( ch -> th ) ) $.
    $( Schema for induction on the cardinality of a finite set.  The inductive
       step shows that the result is true if one more element is added to the
       set.  The result is then proven to be true for all finite sets.
       (Contributed by Jeff Madsen, 8-Jul-2010.) $)
    findcard2 $p |- ( A e. Fin -> ta ) $=
      ( vw cen wi c0 wceq vv cfn wcel wbr com wrex isfi wal breq2 imbi1d albidv
      cv csuc weq en0 mpbiri sylbi ax-gen wne wa nsuceq0 breq1 anbi2d wb peano1
      wsbc peano2 nneneq sylancr biimpa eqcomd syl6bi com12 necon3d mpi wel wex
      ex csn cdif dif1en 3expia wss cun snssi uncom undif biimpi syl5eq cvv vex
      n0 difexg ax-mp uneq1 dfsbcq syl imbi2d imbi12d rspe sylibr pm2.27 adantl
      spv sylsyld syl5 snex unex sbcie syl6ibr vtocl syl5ib 3syl adantr exlimdv
      exp3a mpdd syl5bi com23 alrimdv nfsbc1v nfim sbceq1a cbval finds1 19.21bi
      nfv rexlimiv vtoclga ) AEFIUBMFULZUBUCYJPULZQUDZPUEUFAPYJUGYLAPUEYKUEUCYL
      ARZFYMFUHYJSQUDZARZFUHYJUAULZQUDZARZFUHZYJYPUMZQUDZARZFUHZPUAYKSTZYMYOFUU
      DYLYNAYKSYJQUIUJUKPUAUNZYMYRFUUEYLYQAYKYPYJQUIUJUKYKYTTZYMUUBFUUFYLUUAAYK
      YTYJQUIUJUKYOFYNYJSTZAYJUOUUGABNJUPUQURYPUEUCZYSYKYTQUDZAFYKVFZRZPUHUUCUU
      HYSUUKPUUHUUIYSUUJUUHUUIYKSUSZYSUUJRZUUHUUIUULUUHUUIUTZYTSUSUULYPVAUUNYKS
      YTSUUDUUNYTSTZUUDUUNUUHSYTQUDZUTZUUOUUDUUIUUPUUHYKSYTQVBVCUUQSYTUUHUUPSYT
      TZUUHSUEUCYTUEUCUUPUURVDVEYPVGSYTVHVIVJVKVLVMVNVOVRUUHUUIUULUUMRUULHPVPZH
      VQUUNUUMHYKWLUUNUUSUUMHUUNUUSYKHULZVSZVTZYPQUDZUUMUUHUUIUUSUVCYKYPUUTWAWB
      UUHUUSUVCUUMRZRUUIUUSUUHUVDUUSUUHUVCUUMUUSUVAYKWCZUVBUVAWDZYKTZUUHUVCUTZU
      UMRUUTYKWEUVEUVFUVAUVBWDZYKUVBUVAWFUVEUVIYKTUVAYKWGWHWIUVHYSAFUVFVFZRZUVG
      UUMUUHGULZYPQUDZUTZYSAFUVLUVAWDZVFZRZRUVHUVKRGUVBYKWJUCUVBWJUCPWKYKUVAWJW
      MWNUVLUVBTZUVNUVHUVQUVKUVRUVMUVCUUHUVLUVBYPQVBVCUVRUVPUVJYSUVRUVOUVFTUVPU
      VJVDUVLUVBUVAWOAFUVOUVFWPWQWRWSUVNYSDUVPYSUVMCRZUVNDYRUVSFGFGUNYQUVMACYJU
      VLYPQVBKWSXDUVNUVLUBUCZUVSCDUVNUVMUAUEUFUVTUVMUAUEWTUAUVLUGXAUVMUVSCRUUHU
      VMCXBXCOXEXFADFUVOUVLUVAGWKUUTXGXHLXIXJXKUVGUVJUUJYSAFUVFYKWPWRXLXMXPVMXN
      XQXOXRVRXQXSXTUUBUUKFPUUBPYGUUIUUJFUUIFYGAFYKYAYBFPUNUUAUUIAUUJYJYKYTQVBA
      FYKYCWSYDXJYEYFYHUQYI $.
  $}

  ${
    $d A x y z $.  $d ch x $.  $d ph y z $.  $d ps x $.  $d ta x $.  $d th x $.
    findcard2s.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    findcard2s.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    findcard2s.3 $e |- ( x = ( y u. { z } ) -> ( ph <-> th ) ) $.
    findcard2s.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    findcard2s.5 $e |- ps $.
    findcard2s.6 $e |- ( ( y e. Fin /\ -. z e. y ) -> ( ch -> th ) ) $.
    $( Variation of ~ findcard2 requiring that the element added in the
       induction step not be a member of the original set.  (Contributed by
       Paul Chapman, 30-Nov-2012.) $)
    findcard2s $p |- ( A e. Fin -> ta ) $=
      ( cv wcel wceq cun sylib cfn wi wn ex csn wa wex uncom wss snssi syl5reqr
      ssequn1 vex eqvinc bicomd sylan9bb exlimiv syl biimpd pm2.61d2 findcard2
      wb ) ABCDEFGHIJKLMNGPZUAQZHPZVCQZCDUBZVDVFUCVGOUDVFCDVFFPZVCRZVHVCVEUEZSZ
      RZUFZFUGZCDVBZVFVCVKRVNVFVKVJVCSZVCVJVCUHVFVJVCUIVPVCRVEVCUJVJVCULTUKFVCV
      KGUMUNTVMVOFVICAVLDVIACKUOLUPUQURUSUTVA $.
  $}

  ${
    $d w x y z $.  $d w y z ph $.  $d w x A $.  $d w x ta $.  $d x ch $.
    findcard3.1 $e |- ( x = y -> ( ph <-> ch ) ) $.
    findcard3.2 $e |- ( x = A -> ( ph <-> ta ) ) $.
    findcard3.3 $e |- ( y e. Fin -> ( A. x ( x C. y -> ph ) -> ch ) ) $.
    $( Schema for strong induction on the cardinality of a finite set.  The
       inductive hypothesis is that the result is true on any proper subset.
       The result is then proven to be true for all finite sets.  (Contributed
       by Mario Carneiro, 13-Dec-2013.) $)
    findcard3 $p |- ( A e. Fin -> ta ) $=
      ( vw vz cfn wcel cen wbr wi wal wa com wrex cv isfi wral con0 eleq1 breq2
      nnon wceq imbi1d albidv imbi12d wpss rspe sylibr 19.21v ralbii bitr3i wss
      ralcom4 pssss ssfi sylib syl2an csdm ensym ad2antll sylan adantr sdomentr
      php3 simpllr syl2anc ensdomtr ad2antrl ad3antrrr sdomel mpd ex simpr jcad
      a1i reximdv2 r19.29 expcom syl word ordom ordelss mpan sseld pm2.27 imp3a
      ad2antrr syl6 rexlimdv com23 alimdv syl5bi sylsyld impancom alrimiv breq1
      syld cbvalv syl6ibr tfis2 mpcom rgen sylbi spcgv rexlimdvw ) FLMZDUAZJUAZ
      NOZAPZDQZFXNNOZRZJSTZCXLXRJSTZXTJFUBXQJSUCYAXTXQJSXNUDMZXNSMZXQXNUGZYCXQP
      ZKUAZSMZXMYFNOZAPZDQZPZJKXNYFUHZYCYGXQYJXNYFSUEYLXPYIDYLXOYHAXNYFXMNUFUIU
      JUKYKKXNUCZYEPYBYMYCEUAZXNNOZBPZEQZXQYCYMYQYCYMRYPEYCYOYMBYCYORZYNLMZYMXM
      YNULZAPZDQZBYRYOJSTYSYOJSUMJYNUBUNZYMYGYIPZKXNUCZDQZYRUUBYMUUDDQZKXNUCUUF
      UUGYKKXNYGYIDUOUPUUDKDXNUSUQYRUUEUUADYRYTUUEAYRYTUUEAPYRYTRZUUEUUDYHRZKXN
      TZAUUHYHKXNTZUUEUUJPUUHYHKSTZUUKYRYSXMYNURZUULYTUUCXMYNUTYSUUMRXMLMUULYNX
      MVAKXMUBVBVCUUHYHYHKSXNUUHYGYHRZYFXNMZYHUUHUUNUUOUUHUUNRZYFXNVDOZUUOUUPYF
      XMNOZXMXNVDOZUUQYHUURUUHYGXMYFVEVFUUPXMYNVDOZYOUUSUUHUUTUUNYRYSYTUUTUUCYN
      XMVJVGVHYCYOYTUUNVKXMYNXNVIVLYFXMXNVMVLUUPYFUDMZYBUUQUUOPYGUVAUUHYHYFUGVN
      YCYBYOYTUUNYDVOYFXNVPVLVQVRUUNYHPUUHYGYHVSWAVTWBVQUUEUUKUUJUUDYHKXNWCWDWE
      UUHUUIAKXNUUHUUOYGUUIAPUUHXNSYFYCXNSURZYOYTSWFYCUVBWGSXNWHWIWMWJYGUUDYHAY
      GYIWKWLWNWOXCVRWPWQWRIWSWTXAWDXPYPDEXMYNUHXOYOABXMYNXNNXBGUKXDXEWAXFXGXHX
      QXRJSWCWIXIXLXSCJSXLXQXRCXPXRCPDFLXMFUHXOXRACXMFXNNXBHUKXJWLXKVQ $.
  $}

  ${
    $d f u w x z A $.  $d f g u w x y z B $.  $d f g u w z ph $.
    $d g u w y z ps $.
    ac6sfi.1 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( A version of ~ ac6s for finite sets.  (Contributed by Jeffrey Hankins,
       26-Jun-2009.)  (Proof shortened by Mario Carneiro, 29-Jan-2014.) $)
    ac6sfi $p |- ( ( A e. Fin /\ A. x e. A E. y e. B ph ) ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      ( vg wcel wral cv wf wa wex wi c0 wceq raleq wb vu vw vz cfn wrex csn cun
      cfv wsbc feq2 anbi12d exbidv imbi12d weq feq1 fvex sbcie fveq1 dfsbcq syl
      syl5bbr ralbidv cbvexv syl6bb f0 0ex ral0 biantru spcev mp1i wel wn ssun1
      wss ssralv ax-mp imim1i ssun2 cvv vex ralsnsg sbcrex bitri sylib nfv nfcv
      nfsbc1v nfral nfan nfex nfim w3a cop cin simprl wf1o f1osn f1of snssd fss
      simpl2 simpl1 disjsn sylibr fun2 syl21anc simprr wne eleq1a impcom fvunsn
      syl2anc necon3bd syl6rbb 3syl ralbidva mpbid simpl3 wfun ffun snid dmsnop
      cdm eleqtrri funssfv mp3an23 syl6req elsni fveq2d eqeq2d biimparc sbceq1a
      fvsn ralun snex unex ex exlimdv 3exp syl5 rexlimd a2d adantl findcard2s
      imp ) EUDJADFUEZCEKZEFGLZMZBCEKZNZGOZUUFCUALZKZUUMFUUHMZBCUUMKZNZGOZPUUFC
      QKZQFUUHMZBCQKZNZGOZPUUFCUBLZKZUVDFUUHMZBCUVDKZNZGOZPZUUFCUVDUCLZUFZUGZKZ
      UVMFILZMZADCLZUVOUHZUIZCUVMKZNZIOZPZUUGUULPUAUBUCEUUMQRZUUNUUSUURUVCUUFCU
      UMQSUWDUUQUVBGUWDUUOUUTUUPUVAUUMQFUUHUJBCUUMQSUKULUMUAUBUNZUUNUVEUURUVIUU
      FCUUMUVDSUWEUUQUVHGUWEUUOUVFUUPUVGUUMUVDFUUHUJBCUUMUVDSUKULUMUUMUVMRZUUNU
      VNUURUWBUUFCUUMUVMSUWFUURUVMFUUHMZBCUVMKZNZGOUWBUWFUUQUWIGUWFUUOUWGUUPUWH
      UUMUVMFUUHUJBCUUMUVMSUKULUWIUWAGIGIUNZUWGUVPUWHUVTUVMFUUHUVOUOUWJBUVSCUVM
      BADUVQUUHUHZUIZUWJUVSABDUWKUVQUUHUPHUQZUWJUWKUVRRUWLUVSTUVQUUHUVOURADUWKU
      VRUSUTVAVBUKVCVDUMUUMERZUUNUUGUURUULUUFCUUMESUWNUUQUUKGUWNUUOUUIUUPUUJUUM
      EFUUHUJBCUUMESUKULUMQFQMZUVCUUSFVEUVBUWOGQVFUVBUUTUUHQRUWOUVAUUTBCVGVHQFU
      UHQUOVAVIVJUCUBVKZVLZUVJUWCPUVDUDJUVJUVNUVIPUWQUWCUVNUVEUVIUVDUVMVNUVNUVE
      PUVDUVLVMUUFCUVDUVMVOVPVQUWQUVNUVIUWBUVNACUVKUIZDFUEZUWQUVIUWBPZUVNUUFCUV
      LKZUWSUVLUVMVNUVNUXAPUVLUVDVRUUFCUVLUVMVOVPUXAUUFCUVKUIZUWSUVKVSJZUXAUXBT
      UCVTZUUFCUVKVSWAVPACDUVKFWBWCWDUWQUWRUWTDFUWQDWEUVIUWBDUVIDWEUWADIUVPUVTD
      UVPDWEUVSDCUVMDUVMWFADUVRWGWHWIWJWKUWQDLZFJZUWRUWTUWQUXFUWRWLZUVHUWBGUXGU
      VHUWBUXGUVHNZUVMFUUHUVKUXEWMZUFZUGZMZADUVQUXKUHZUIZCUVMKZUWBUXHUVFUVLFUXJ
      MZUVDUVLWNQRZUXLUXGUVFUVGWOUXHUVLUXEUFZUXJMZUXRFVNUXPUVLUXRUXJWPUXSUXHUVK
      UXEUXDDVTZWQUVLUXRUXJWRVJUXHUXEFUWQUXFUWRUVHXAWSUVLUXRFUXJWTXLUXHUWQUXQUW
      QUXFUWRUVHXBZUVDUVKXCXDUVDUVLFUUHUXJXEXFZUXHUXNCUVDKZUXNCUVLKZUXOUXHUVGUY
      CUXGUVFUVGXGUXHUWQUVGUYCTUYAUWQBUXNCUVDUWQCUBVKZNUVKUVQXHZUXMUWKRZBUXNTUY
      EUWQUYFUYEUWPUVKUVQUVQUVDUVKXIXMXJUUHUVKUXEUVQXKUYGUXNUWLBADUXMUWKUSUWMXN
      XOXPUTXQUXHUWRUYDUWQUXFUWRUVHXRUXHUXEUVKUXKUHZRZUWRUYDTUXHUYHUVKUXJUHZUXE
      UXHUXLUXKXSZUYHUYJRZUYBUVMFUXKXTUYKUXJUXKVNUVKUXJYCZJUYLUXJUUHVRUVKUVLUYM
      UVKUXDYAUVKUXEUXTYBYDUVKUXKUXJYEYFXOUVKUXEUXDUXTYMYGUWRACUVLKZUYIUYDUXCUY
      NUWRTUXDACUVKVSWAVPUYIAUXNCUVLUYIUVQUVLJZNUXEUXMRZAUXNTUYOUYPUYIUYOUXMUYH
      UXEUYOUVQUVKUXKUVQUVKYHYIYJYKADUXMYLUTXPVAUTXQUXNCUVDUVLYNXLUWAUXLUXONIUX
      KUUHUXJGVTUXIYOYPUVOUXKRZUVPUXLUVTUXOUVMFUVOUXKUOUYQUVSUXNCUVMUYQUVRUXMRU
      VSUXNTUVQUVOUXKURADUVRUXMUSUTVBUKVIXLYQYRYSUUAYTUUBYTUUCUUDUUE $.
  $}

  ${
    $d R u v w x y z $.  $d A w x y $.
    $( A partial order is well-founded on a finite set.  (Contributed by Jeff
       Madsen, 18-Jun-2010.)  (Proof shortened by Mario Carneiro,
       29-Jan-2014.) $)
    frfi $p |- ( ( R Po A /\ A e. Fin ) -> R Fr A ) $=
      ( vx vw vv vu vz wcel wpo wfr cv wi c0 imbi12d wss wa wbr wn wral wrex vy
      cfn csn cun wceq poeq2 freq2 weq fr0 a1i ssun1 poss ax-mp imim1i wne cdif
      wal uncom sseq2i ssundif bitri wel breq1 cbvrexv simpllr simplrl sylan2br
      anbi1i w3a impcom ad2ant2r simpr1 simpr2 3ad2antr3 nbrne2 syl2anc eldifsn
      poirr sylanbrc sylan ne0i syl difss cvv vex difexg mpanl1 ssrexv syl12anc
      fri mpsyl notbid rspcv adantr simplr2 simplr1 simplr3 simpr potr syl13anc
      simpll mpand con3d ralsn syl6ibr syld ralun sylcom difsnid raleqdv sylibd
      ex reximdva mpd 3exp2 rexlimdv syl5bi ralnex ralbidv rspcev expcom sylbir
      breq2 pm2.61d1 difsn expr neeq1 raleq rexbidv syl5ibcom adantll impr syl5
      wb com23 pm2.61d alrimiv df-fr sylibr findcard2 ) AUBHABIZABJZCKZBIZUUCBJ
      ZLMBIZMBJZLUAKZBIZUUHBJZLZUUHDKZUCZUDZBIZUUNBJZLZUUAUUBLCUADAUUCMUEUUDUUF
      UUEUUGUUCMBUFUUCMBUGNCUAUHUUDUUIUUEUUJUUCUUHBUFUUCUUHBUGNUUCUUNUEUUDUUOUU
      EUUPUUCUUNBUFUUCUUNBUGNUUCAUEUUDUUAUUEUUBUUCABUFUUCABUGNUUGUUFBUIUJUUKUUQ
      LUUHUBHUUKUUOUUJUUPUUOUUIUUJUUHUUNOUUOUUILUUHUUMUKUUHUUNBULUMUNUUOUUJUUPU
      UOUUJPZUUCUUNOZUUCMUOZPZEKZFKZBQZRZEUUCSZFUUCTZLZCUQUUPUURUVHCUVAUUCUUMUP
      ZUUHOZUUTPZUURUVGUUSUVJUUTUUSUUCUUMUUHUDZOUVJUUNUVLUUCUUHUUMURUSUUCUUMUUH
      UTVAZVHUURUVKUVGUURUVKPZDCVBZUVGUVNUVBUULBQZEUUCTZUVOUVGLZUVQGKZUULBQZGUU
      CTUVNUVRUVPUVTEGUUCUVBUVSUULBVCVDUVNUVTUVRGUUCUVNGCVBZUVTUVOUVGUVNUWAUVTU
      VOVIZPZUVEEUVISZFUUCTZUVGUWCUUJUVJUVIMUOZUWEUUOUUJUVKUWBVEUURUVJUUTUWBVFU
      WCUVSUVIHZUWFUVNUUDUWBUWGUUOUVJUUDUUJUUTUVJUUOUUSUUDUVMUUSUUOUUDUUCUUNBUL
      VJVGVKZUUDUWBPZUWAUVSUULUOZUWGUUDUWAUVTUVOVLUWIUVTUULUULBQRZUWJUUDUWAUVTU
      VOVMUUDUWAUVOUWKUVTUUCUULBVRVNUVSUULUULBVOVPUVSUUCUULVQVSZVTUVIUVSWAWBUVI
      UUCOUUJUVJUWFPZPUWDFUVITZUWEUUCUUMWCUVIWDHZUUJUWMUWNUUCWDHUWOCWEUUCUUMWDW
      FUMFEUUHUVIWDBWJWGUWDFUVIUUCWHWKZWIUVNUUDUWBUWEUVGLUWHUWIUWDUVFFUUCUWIFCV
      BZPZUWDUVEEUVIUUMUDZSZUVFUWRUWDUVEEUUMSZUWTUWRUWDUVSUVCBQZRZUXAUWIUWDUXCL
      ZUWQUWIUWGUXDUWLUVEUXCEUVSUVIEGUHUVDUXBUVBUVSUVCBVCWLWMWBWNUWRUXCUULUVCBQ
      ZRZUXAUWRUXEUXBUWRUVTUXEUXBUWAUVTUVOUUDUWQWOUWRUUDUWAUVOUWQUVTUXEPUXBLUUD
      UWBUWQXAUWAUVTUVOUUDUWQWPUWAUVTUVOUUDUWQWQZUWIUWQWRUUCUVSUULUVCBWSWTXBXCU
      VEUXFEUULDWEEDUHUVDUXEUVBUULUVCBVCWLXDXEXFUWDUXAUWTUVEEUVIUUMXGXLXHUWRUVO
      UWTUVFYNUXGUVOUVEEUWSUUCUUCUULXIXJWBXKXMVTXNXOXPXQUVQRUVPRZEUUCSZUVRUVPEU
      UCXRUVOUXIUVGUVFUXIFUULUUCFDUHZUVEUXHEUUCUXJUVDUVPUVCUULUVBBYCWLXSXTYAYBY
      DUVORUVIUUCUEZUVNUVGUULUUCYEUURUVJUUTUXKUVGLZUUJUVJUUTUXLLUUOUUJUVJPZUXKU
      UTUVGUXMUWFUWELUXKUUTUVGLUUJUVJUWFUWEUWPYFUXKUWFUUTUWEUVGUVIUUCMYGUXKUWDU
      VFFUUCUVEEUVIUUCYHYINYJYOYKYLYMYPXLXQYQCFEUUNBYRYSXLXHUJYTVJ $.
  $}

  ${
    $d R x y z $.  $d A x y z $.
    $( A finite set has a maximum under a total order.  (Contributed by Jeff
       Madsen, 18-Jun-2010.)  (Proof shortened by Mario Carneiro,
       29-Jan-2014.) $)
    fimax2g $p |- ( ( R Or A /\ A e. Fin /\ A =/= (/) ) ->
                                        E. x e. A A. y e. A -. x R y ) $=
      ( wor cfn wcel c0 wne w3a ccnv cv wbr wn wral wrex wpo sylib wa vex cnvpo
      wfr sopo frfi sylan 3adant3 wss ssid fri mpanr1 an32s brcnv notbii ralbii
      wi rexbii ex 3adant1 mpd ) CDEZCFGZCHIZJCDKZUBZALZBLZDMZNZBCOZACPZUTVAVDV
      BUTCVCQZVAVDUTCDQVKCDUCCDUARCVCUDUEUFVAVBVDVJUOUTVAVBSZVDVJVLVDSVFVEVCMZN
      ZBCOZACPZVJVAVDVBVPVAVDSCCUGVBVPCUHABCCFVCUIUJUKVOVIACVNVHBCVMVGVFVEDBTAT
      ULUMUNUPRUQURUS $.

    $( A finite set has a maximum under a total order.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       29-Jan-2014.) $)
    fimaxg $p |- ( ( R Or A /\ A e. Fin /\ A =/= (/) ) ->
                            E. x e. A A. y e. A ( x =/= y -> y R x ) ) $=
      ( wor cfn wcel c0 wne w3a cv wbr wi wral wrex wn fimax2g wb wa weq imbi1i
      df-ne pm4.64 bitri sotric con2bid syl5bb anassrs ralbidva rexbidva mpbird
      wo 3ad2ant1 ) CDEZCFGZCHIZJAKZBKZIZURUQDLZMZBCNZACOZUQURDLZPZBCNZACOZABCD
      QUNUOVCVGRUPUNVBVFACUNUQCGZSVAVEBCUNVHURCGZVAVERVAABTZUTULZUNVHVISSZVEVAV
      JPZUTMVKUSVMUTUQURUBUAVJUTUCUDVLVDVKCUQURDUEUFUGUHUIUJUMUK $.

    $( Lemma showing existence and closure of supremum of a finite set.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    fisupg $p |- ( ( R Or A /\ A e. Fin /\ A =/= (/) ) -> E. x e. A ( A. y e. A
            -. x R y /\ A. y e. A ( y R x -> E. z e. A y R z ) ) ) $=
      ( wor cfn wcel c0 wne w3a cv wbr wi wral wrex wn wa ex anassrs fimaxg weq
      sotrieq2 simprbda a1dd pm2.27 so2nr pm3.21 con3d syl9r pm2.61dne ralimdva
      syl5com breq2 rspcev ralrimivw adantl jctird reximdva 3ad2ant1 mpd ) DEFZ
      DGHZDIJZKALZBLZJZVFVEEMZNZBDOZADPZVEVFEMZQZBDOZVHVFCLZEMZCDPZNZBDOZRZADPZ
      ABDEUAVBVCVKWANVDVBVJVTADVBVEDHZRZVJVNVSWCVIVMBDWCVFDHZRZVIVMNVEVFWEABUBZ
      VMVIVBWBWDWFVMNVBWBWDRRZWFVMWGWFVMVHQDVEVFEUCUDSTUEVGVIVHWEVMVGVHUFVBWBWD
      VHVMNWGVLVHRZQVHVMDVEVFEUGVHVLWHVHVLUHUIUMTUJUKULWBVSVBWBVRBDWBVHVQVPVHCV
      EDVOVEVFEUNUOSUPUQURUSUTVA $.
  $}

  $( A total order on a finite set is a well-order.  (Contributed by Jeff
     Madsen, 18-Jun-2010.)  (Proof shortened by Mario Carneiro,
     29-Jan-2014.) $)
  wofi $p |- ( ( R Or A /\ A e. Fin ) -> R We A ) $=
    ( wor cfn wcel wa wfr wwe wpo sopo frfi sylan simpl df-we sylanbrc ) ABCZAD
    EZFABGZPABHPABIQRABJABKLPQMABNO $.

  ${
    $d A x y $.
    $( The maximum of a finite collection of ordinals is in the set.
       (Contributed by Mario Carneiro, 28-May-2013.)  (Revised by Mario
       Carneiro, 29-Jan-2014.) $)
    ordunifi $p |- ( ( A C_ On /\ A e. Fin /\ A =/= (/) ) -> U. A e. A ) $=
      ( vx vy con0 wss cfn wcel c0 wne w3a cuni cv wrex cep wn wral wb wa ssel2
      wor wbr wwe epweon weso ax-mp soss mpi fimax2g syl3an1 adantr ontri1 epel
      adantlr notbii syl6rbbr syl2anc ralbidva unissb syl6bbr rexbidva 3ad2ant1
      mpbid elssuni wceq eqss eleq1 biimpcd syl5bir mpand rexlimiv syl ) ADEZAF
      GZAHIZJZAKZBLZEZBAMZVPAGZVOVQCLZNUAZOZCAPZBAMZVSVLANTZVMVNWEVLDNTZWFDNUBW
      GUCDNUDUEADNUFUGBCANUHUIVLVMWEVSQVNVLWDVRBAVLVQAGZRZWDWAVQEZCAPVRWIWCWJCA
      WIWAAGZRWADGZVQDGZWCWJQVLWKWLWHADWASUMWIWMWKADVQSUJWLWMRWJVQWAGZOWCWAVQUK
      WBWNBCULUNUOUPUQCAVQURUSUTVAVBVRVTBAWHVQVPEZVRVTVQAVCWOVRRVQVPVDZWHVTVQVP
      VEWPWHVTVQVPAVFVGVHVIVJVK $.
  $}

  ${
    $( The union (supremum) of a finite set of finite ordinals is a finite
       ordinal.  (Contributed by Stefan O'Rear, 5-Nov-2014.) $)
    nnunifi $p |- ( ( S C_ om /\ S e. Fin ) -> U. S e. om ) $=
      ( com wss cfn wcel wa cuni wceq unieq uni0 peano1 eqeltri syl6eqel adantl
      c0 wne simpll con0 omsson syl6ss simplr simpr ordunifi syl3anc pm2.61dane
      sseldd ) ABCZADEZFZAGZBEZAOAOHZUKUIULUJOGZBAOIUMOBJKLMNUIAOPZFZABUJUGUHUN
      QZUOARCUHUNUJAEUOABRUPSTUGUHUNUAUIUNUBAUCUDUFUE $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Lemma for ~ unbnn .  After removing the successor of an element from an
       unbounded set of natural numbers, the intersection of the result belongs
       to the original unbounded set.  (Contributed by NM, 3-Dec-2003.) $)
    unblem1 $p |- ( ( ( B C_ om /\ A. x e. om E. y e. B x e. y ) /\
                 A e. B ) -> |^| ( B \ suc A ) e. B ) $=
      ( com wss cv wcel wrex wral wa csuc cdif cint con0 c0 ssel wn wi syl6 wne
      omsson sstr mpan2 ssdifssd peano2b syl6ib wceq eleq1 rexbidv rspccva word
      ad2antrr nnord ordn2lp imnan sylibr con2d syl imdistand eldif ne0i sylbir
      exp3a rexlimdv syl5 sylan2d impl onint syl2anc eldifad ) DEFZAGZBGZHZBDIZ
      AEJZKCDHZKZDCLZMZNZDVTVSWAOFZWAPUAZWBWAHVLWCVQVRVLDOVTVLEOFDOFUBDEOUCUDUE
      UMVLVQVRWDVLVRVTEHZVQWDVLVRCEHWEDECQCUFUGVQWEKVTVNHZBDIZVLWDVPWGAVTEVMVTU
      HVOWFBDVMVTVNUIUJUKVLWFWDBDVLVNDHZWFWDVLWHWFKWHVNVTHZRZKZWDVLWHWFWJVLWHVN
      EHZWFWJSZDEVNQWLVNULZWMVNUNWNWIWFWNWIWFKRWIWFRSVNVTUOWIWFUPUQURUSTUTWKVNW
      AHWDVNDVTVAWAVNVBVCTVDVEVFVGVHWAVIVJVK $.
  $}

  ${
    $d u v w x y z A $.  $d u v w y z F $.
    unblem.2 $e |- F =
          ( rec ( ( x e. _V |-> |^| ( A \ suc x ) ) , |^| A ) |` om ) $.
    $( Lemma for ~ unbnn .  The value of the function ` F ` belongs to the
       unbounded set of natural numbers ` A ` .  (Contributed by NM,
       3-Dec-2003.) $)
    unblem2 $p |- ( ( A C_ om /\ A. w e. om E. v e. A w e. v ) -> ( z e. om ->
                ( F ` z ) e. A ) ) $=
      ( cv com wcel wss wa cfv c0 csuc wceq fveq2 eleq1d cint con0 vu wrex wral
      vy wne omsson sstr mpan2 wi peano1 eleq1 rexbidv rspcv ax-mp df-rex sylib
      wex exsimpl syl n0 sylibr onint syl2an cdif cmpt crdg cres fveq1i syl5req
      cvv fr0g ibi unblem1 wb suceq difeq2d inteqd frsucmpt2 eqcomd ex ibd syl5
      exp3a finds2 com12 ) BHZIJEIKZCHZDHZJZDEUBZCIUCZLZWFFMZEJZWONFMZEJZUAHZFM
      ZEJZWROZFMZEJZWMBUAWFNPWNWPEWFNFQRWFWRPWNWSEWFWRFQRWFXAPWNXBEWFXAFQRWMESZ
      EJZWQWGETKZENUEZXEWLWGITKXFUFEITUGUHWLWIEJZDUQZXGWLXHNWIJZLDUQZXIWLXJDEUB
      ZXKNIJWLXLUIUJWKXLCNIWHNPWJXJDEWHNWIUKULUMUNXJDEUOUPXHXJDURUSDEUTVAEVBVCX
      EWQXEXDWPEXEWPNAVJEAHZOZVDZSZVEZXDVFIVGZMXDNFXRGVHXDEXQVKVIRVLUSWRIJZWMWT
      XCWMWTLEWSOZVDZSZEJZXSXCCDWSEVMXSYCXCXSYCYCXCVNXSYCLZYBXBEYDXBYBAUDXDWRXP
      YBEUDHZOZVDZSFEGYEXMPZYGXOYHYFXNEYEXMVOVPVQYEWSPZYGYAYIYFXTEYEWSVOVPVQVRV
      SRVTWAWBWCWDWE $.

    $( Lemma for ~ unbnn .  The value of the function ` F ` is less than its
       value at a successor.  (Contributed by NM, 3-Dec-2003.) $)
    unblem3 $p |- ( ( A C_ om /\ A. w e. om E. v e. A w e. v ) -> ( z e. om ->
                ( F ` z ) e. ( F ` suc z ) ) ) $=
      ( vy com wss cv wcel wa cfv csuc cdif cint con0 wceq ex wrex wral unblem2
      imp omsson sstr mpan2 ssel anc2li syl ad2antrr mpd onmindif unblem1 suceq
      wi syld difeq2d inteqd frsucmpt2 sylcom eleqtrrd ) EIJZCKDKLDEUACIUBZMZBK
      ZILZVFFNZVFOFNZLVEVGMZVHEVHOZPZQZVIVJERJZVHRLZMZVHVMLVJVHELZVPVEVGVQABCDE
      FGUCZUDVCVQVPUPZVDVGVCVNVSVCIRJVNUEEIRUFUGVNVQVOERVHUHUIUJUKULEVHUMUJVEVG
      VIVMSZVEVGVMELZVTVEVGVQWAVRVEVQWACDVHEUNTUQVGWAVTAHEQVFEAKZOZPZQVMEHKZOZP
      ZQFEGWEWBSZWGWDWHWFWCEWEWBUOURUSWEVHSZWGVLWIWFVKEWEVHUOURUSUTTVAUDVBT $.

    $( Lemma for ~ unbnn .  The function ` F ` maps the set of natural numbers
       one-to-one to the set of unbounded natural numbers ` A ` .  (Contributed
       by NM, 3-Dec-2003.) $)
    unblem4 $p |- ( ( A C_ om /\ A. w e. om E. v e. A w e. v ) ->
                 F : om -1-1-> A ) $=
      ( vz com wss cv wcel wrex wral wa con0 cfv csuc wfn cint ralrimiv wf sstr
      wf1 omsson mpan2 adantr cvv cdif cmpt crdg cres frfnom fneq1i mpbir ffnfv
      unblem2 biimpri sylancr unblem3 omsmo syl21anc ) DHIZBJCJKCDLBHMZNZDOIZHD
      EUAZGJZEPZVGQEPKZGHMHDEUCVBVEVCVBHOIVEUDDHOUBUEUFVDEHRZVHDKZGHMZVFVJAUGDA
      JQUHSUIZDSZUJHUKZHRVNVMULHEVOFUMUNVDVKGHAGBCDEFUPTVFVJVLNGHDEUOUQURVDVIGH
      AGBCDEFUSTGDEUTVA $.
  $}

  ${
    $d x y z w A $.
    $( Any unbounded subset of natural numbers is equinumerous to the set of
       all natural numbers.  Part of the proof of Theorem 42 of [Suppes]
       p. 151.  See ~ unbnn3 for a stronger version without the first
       assumption.  (Contributed by NM, 3-Dec-2003.) $)
    unbnn $p |- ( ( om e. _V /\ A C_ om /\ A. x e. om E. y e. A x e. y ) ->
      A ~~ om ) $=
      ( vz com cvv wcel wss wrex wral w3a cdom wbr cen ssdomg 3adant3 csuc cint
      cv imp cdif cmpt crdg cres wf1 simp1 ssexg ancoms unblem4 3adant1 f1dom2g
      eqid syl3anc sbth syl2anc ) EFGZCEHZASBSGBCIAEJZKZCELMZECLMZCENMUPUQUTURU
      PUQUTCEFOTPUSUPCFGZECDFCDSQUARUBCRUCEUDZUEZVAUPUQURUFUPUQVBURUQUPVBCEFUGU
      HPUQURVDUPDABCVCVCULUIUJECVCFFUKUMCEUNUO $.

    $( Version of ~ unbnn that does not require a strict upper bound.
       (Contributed by NM, 24-Apr-2004.) $)
    unbnn2 $p |- ( ( om e. _V /\ A C_ om /\ A. x e. om E. y e. A x C_ y ) ->
      A ~~ om ) $=
      ( vz cv wss wrex com wral cvv wcel cen wbr csuc peano2 wceq sseq1 rexbidv
      rspcv wi vex sucssel ax-mp reximi syl6com syl5 ralrimiv unbnn syl3an3 ) A
      EZBEZFZBCGZAHIZHJKCHFDEZUKKZBCGZDHICHLMUNUQDHUOHKUONZHKZUNUQUOOUSUNURUKFZ
      BCGZUQUMVAAURHUJURPULUTBCUJURUKQRSUTUPBCUOJKUTUPTDUAUOUKJUBUCUDUEUFUGDBCU
      HUI $.
  $}

  ${
    $d x y z w A $.
    $( Any set strictly dominated by the class of natural numbers is finite.
       Sufficiency part of Theorem 42 of [Suppes] p. 151.  This theorem does
       not require the Axiom of Infinity.  (Contributed by NM, 24-Apr-2004.) $)
    isfinite2 $p |- ( A ~< om -> A e. Fin ) $=
      ( vy vz vw com cvv wcel csdm wbr cfn cv cen wss wa wrex wral syl2anc con0
      wn wi relsdom brrelex2i wex sdomdom domeng syl5ib ensym ad2antrl ensdomtr
      cdom simpl sdomnen syl simpr unbnn 3expia syl2an mtod rexnal csuc word wb
      omsson sstr mpan2 nnord cuni ssel2 vex sylib ordtri1 sylan an32s ralbidva
      elon unissb ralnex bicomi 3bitr4g ordunisssuc bitr3d ssnnfi sylanb adantl
      peano2b sylbid rexlimdva syl5bir ad2antll mpd simprl enfii exlimdv sylcom
      ex mpcom ) EFGZAEHIZAJGZAEHUAUBZWQWRABKZLIZXAEMZNZBUCZWSWRAEUJIWQXEAEUDBA
      EFUEUFWRXDWSBWRXDWSWRXDNZXAJGZXBWSXFCKZDKZGZDXAOZCEPZSZXGXFXLXAELIZXFXAEH
      IZXNSXFXAALIZWRXOXBXPWRXCAXAUGUHWRXDUKXAAEUIQXAEULUMWRWQXCXLXNTXDWTXBXCUN
      WQXCXLXNCDXAUOUPUQURXCXMXGTWRXBXMXKSZCEOXCXGXKCEUSXCXQXGCEXCXHEGZNXQXAXHU
      TZMZXGXCXARMZXHVAZXQXTVBXRXCERMYAVCXAERVDVEXHVFYAYBNZXAVGXHMZXQXTYCXIXHMZ
      DXAPXJSZDXAPZYDXQYCYEYFDXAYAXIXAGZYBYEYFVBZYAYHNZXIVAZYBYIYJXIRGYKXARXIVH
      XIDVIVOVJXIXHVKVLVMVNDXAXHVPYGXQXJDXAVQVRVSXAXHVTWAUQXRXTXGTXCXRXTXGXRXSE
      GXTXGXHWEXSXAWBWCWOWDWFWGWHWIWJWRXBXCWKAXAWLQWOWMWNWP $.
  $}

  ${
    $d x A $.
    $( Omega strictly dominates a natural number.  Example 3 of [Enderton]
       p. 146.  In order to avoid the Axiom of infinity, we include it as a
       hypothesis.  (Contributed by NM, 15-Jun-1998.) $)
    nnsdomg $p |- ( ( om e. _V /\ A e. om ) -> A ~< om ) $=
      ( vx com cvv wcel wa cdom wbr cen csdm wss word ordom ordelss mpan ssdomg
      wn syl5 imp cfn ominf ensym cv wrex rspcev isfi sylibr mtoi adantl brsdom
      breq2 ex sylanbrc ) CDEZACEZFACGHZACIHZQZACJHUNUOUPUOACKZUNUPCLUOUSMCANOA
      CDPRSUOURUNUOUQCTEZUAUQCAIHZUOUTACUBUOVAUTUOVAFCBUCZIHZBCUDUTVCVABACVBACI
      UKUEBCUFUGULRUHUIACUJUM $.

    $( A set is finite iff it is strictly dominated by the class of natural
       number.  Theorem 42 of [Suppes] p. 151.  In order to avoid the Axiom of
       infinity, we include it as a hypothesis.  (Contributed by NM,
       3-Nov-2002.)  (Revised by Mario Carneiro, 27-Apr-2015.) $)
    isfiniteg $p |- ( om e. _V -> ( A e. Fin <-> A ~< om ) ) $=
      ( vx com cvv wcel cfn csdm wbr cv wrex isfi wa nnsdomg sdomen1 syl5ibrcom
      cen rexlimdva syl5bi isfinite2 impbid1 ) CDEZAFEZACGHZUBABIZPHZBCJUAUCBAK
      UAUEUCBCUAUDCELUCUEUDCGHUDMAUDCNOQRAST $.
  $}

  ${
    $( An infinite set strictly dominates a natural number.  (Contributed by
       NM, 22-Nov-2004.)  (Revised by Mario Carneiro, 27-Apr-2015.) $)
    infsdomnn $p |- ( ( om ~<_ A /\ B e. om ) -> B ~< A ) $=
      ( com cdom wbr wcel wa csdm reldom brrelexi nnsdomg sylan simpl sdomdomtr
      cvv syl2anc ) CADEZBCFZGBCHEZQBAHEQCOFRSCADIJBKLQRMBCANP $.

    $( An infinite set is not empty.  (Contributed by NM, 23-Oct-2004.) $)
    infn0 $p |- ( om ~<_ A -> A =/= (/) ) $=
      ( com cdom wbr c0 csdm wne peano1 infsdomnn mpan2 cvv wb reldom brrelex2i
      wcel 0sdomg syl mpbid ) BACDZEAFDZAEGZSEBOTHAEIJSAKOTUALBACMNAKPQR $.
  $}

  $( This (useless) theorem, which was proved without the Axiom of Infinity,
     demonstrates an artifact of our definition of binary relation, which is
     meaningful only when its arguments exist.  In particular, the antecedent
     cannot be satisfied unless ` om ` exists.  (Contributed by NM,
     13-Nov-2003.) $)
  fin2inf $p |- ( A ~< om -> om e. _V ) $=
    ( com csdm relsdom brrelex2i ) ABCDE $.

  ${
    $d x y A $.  $d w x y z B $.  $d w y z F $.
    unfilem1.1 $e |- A e. om $.
    unfilem1.2 $e |- B e. om $.
    unfilem1.3 $e |- F = ( x e. B |-> ( A +o x ) ) $.
    $( Lemma for proving that the union of two finite sets is finite.
       (Contributed by NM, 10-Nov-2002.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    unfilem1 $p |- ran F = ( ( A +o B ) \ A ) $=
      ( vy coa co cv wceq wcel wa com wb word nnord sylancr eleq1 crn cdif wrex
      wn elnn mpan2 nnaord mp3an23 syl ibi wss nnaword1 ax-mp nnacl ordtri1 jca
      notbid anbi12d biimparc rexlimiva nnacli syl2an nnawordex bitr3d sylan9bb
      mpbid sylan biimprcd wi biimpi adantl a1i jcad reximdv2 sylbid imp impbii
      eqcom ovex elrnmpti eldif 3bitr4i eqriv ) HDUAZBCIJZBUBZHKZBAKZIJZLZACUCZ
      WGWEMZWGBMZUDZNZWGWDMWGWFMWKWOWJWOACWHCMZWIWEMZWIBMZUDZNZWJWOWPWQWSWPWQWP
      WHOMZWPWQPZWPCOMZXAFWHCUEUFZXAXCBOMZXBFEWHCBUGUHZUIUJWPXEXAWSEXDXEXANZBWI
      UKZWSBWHULXGBQZWIQZXHWSPXEXIEBRZUMXGWIOMXJBWHUNWIRUIBWIUOSVFSUPWJWOWTWJWL
      WQWNWSWGWIWETWJWMWRWGWIBTUQURUSVGUTWLWNWKWLWNWIWGLZAOUCZWKWLXEWGOMZWNXMPE
      WLWEOMXNBCEFVAWGWEUEUFXEXNNBWGUKZWNXMXEXIWGQXOWNPXNXKWGRBWGUOVBABWGVCVDSW
      LXLWJAOCWLXAXLNZWPWJXPWPWLXAWPWQXLWLXFWIWGWETVEVHXPWJVIWLXLWJXAXLWJWIWGVR
      VJVKVLVMVNVOVPVQACWIWGDGBWHIVSVTWGWEBWAWBWC $.

    $( Lemma for proving that the union of two finite sets is finite.
       (Contributed by NM, 10-Nov-2002.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    unfilem2 $p |- F : B -1-1-onto-> ( ( A +o B ) \ A ) $=
      ( vz vw coa co cv cfv wceq wral ovex mpbir2an wcel oveq2 com cdif wf1 wfo
      wf1o wf wi wfn crn fnmpti unfilem1 df-fo ax-mp wa fvmpt eqeqan12d wb elnn
      fof mpan2 nnacan mp3an1 syl2an bitrd biimpd rgen2a dff13 df-f1o ) CBCJKBU
      AZDUDCVHDUBZCVHDUCZVICVHDUEZHLZDMZILZDMZNZVLVNNZUFZICOHCOVJVKVJDCUGDUHVHN
      ACBALZJKZDBVSJPGUIABCDEFGUJCVHDUKQZCVHDURULVRHICVLCRZVNCRZUMZVPVQWDVPBVLJ
      KZBVNJKZNZVQWBWCVMWEVOWFAVLVTWECDVSVLBJSGBVLJPUNAVNVTWFCDVSVNBJSGBVNJPUNU
      OWBVLTRZVNTRZWGVQUPZWCWBCTRZWHFVLCUQUSWCWKWIFVNCUQUSBTRWHWIWJEBVLVNUTVAVB
      VCVDVEHICVHDVFQWACVHDVGQ $.
  $}

  ${
    $d x y f A $.  $d x y f B $.
    $( Lemma for proving that the union of two finite sets is finite.
       (Contributed by NM, 16-Nov-2002.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    unfilem3 $p |- ( ( A e. om /\ B e. om ) -> B ~~ ( ( A +o B ) \ A ) ) $=
      ( vx com wcel coa co cdif cen wbr c0 wceq oveq1 id difeq12d breq2d peano1
      cif cvv elimel oveq2 difeq1d breq12d cmpt wf1o ovex difexg ax-mp unfilem2
      cv eqid f1oen2g mp3an dedth2h ) ADEZBDEZBABFGZAHZIJBUOAKRZBFGZUSHZIJUPBKR
      ZUSVBFGZUSHZIJZABKKAUSLZURVABIVFUQUTAUSAUSBFMVFNOPBVBLZBVBVAVDIVGNVGUTVCU
      SBVBUSFUAUBUCVBDEVDSEZVBVDCVBUSCUJFGUDZUEVEBKDQTZVCSEVHUSVBFUFVCUSSUGUHCU
      SVBVIAKDQTVJVIUKUIVBVDVIDSULUMUN $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The union of two finite sets is finite.  Part of Corollary 6K of
       [Enderton] p. 144.  (Contributed by NM, 16-Nov-2002.) $)
    unfi $p |- ( ( A e. Fin /\ B e. Fin ) -> ( A u. B ) e. Fin ) $=
      ( vx vy vz cfn wcel cdif cun wa cv cen wbr com wrex isfi cin wceq disjdif
      c0 diffi reeanv anbi12i bitr4i coa co nnacl unfilem3 entr expcom syl unen
      mpanr12 undif2 a1i wss nnaword1 undif sylib breq12d syl5ib sylan2d rspcev
      wi breq2 sylibr ee12an rexlimivv sylbir sylan2 ) BFGAFGZBAHZFGZABIZFGZBAU
      AVKVMJZACKZLMZVLDKZLMZJZDNOCNOZVOWBVRCNOZVTDNOZJVPVRVTCDNNUBVKWCVMWDCAPDV
      LPUCUDWAVOCDNNVQNGVSNGJZVQVSUEUFZNGZWAVNWFLMZVOVQVSUGWEVTVLWFVQHZLMZVRWHW
      EVSWILMZVTWJVDVQVSUHVTWKWJVLVSWIUIUJUKVRWJJZAVLIZVQWIIZLMZWEWHWLAVLQTRVQW
      IQTRWOABSVQWFSAVQVLWIULUMWEWMVNWNWFLWMVNRWEABUNUOWEVQWFUPWNWFRVQVSUQVQWFU
      RUSUTVAVBWGWHJVNEKZLMZENOVOWQWHEWFNWPWFVNLVEVCEVNPVFVGVHVIVJ $.
  $}

  $( If a union is finite, the operands are finite.  Converse of ~ unfi .
     (Contributed by FL, 3-Aug-2009.) $)
  unfir $p |- ( ( A u. B ) e. Fin -> ( A e. Fin /\ B e. Fin ) ) $=
    ( cun cfn wcel wss ssun1 ssfi mpan2 ssun2 jca ) ABCZDEZADEZBDEZMALFNABGLAHI
    MBLFOBAJLBHIK $.

  $( The union of two finite sets is finite.  Part of Corollary 6K of
     [Enderton] p. 144.  This version of ~ unfi is useful only if we assume the
     Axiom of Infinity (see comments in ~ fin2inf ).  (Contributed by NM,
     22-Oct-2004.)  (Revised by Mario Carneiro, 27-Apr-2015.) $)
  unfi2 $p |- ( ( A ~< om /\ B ~< om ) -> ( A u. B ) ~< om ) $=
    ( com csdm wbr wa cun cfn wcel isfinite2 syl2an wb fin2inf adantr isfiniteg
    unfi cvv syl mpbid ) ACDEZBCDEZFZABGZHIZUCCDEZTAHIBHIUDUAAJBJABPKUBCQIZUDUE
    LTUFUAAMNUCORS $.

  $( An infinite set ` A ` minus a finite set is infinite.  (Contributed by FL,
     3-Aug-2009.) $)
  difinf $p |- ( ( -. A e. Fin /\ B e. Fin ) -> -. ( A \ B ) e. Fin ) $=
    ( cfn wcel wn cdif wa cun undif1 eleq1i unfir simpld sylbi syl expcom con3d
    unfi impcom ) BCDZACDZEABFZCDZESUBTUBSTUBSGUABHZCDZTUABQUDABHZCDZTUCUECABIJ
    UFTSABKLMNOPR $.

  ${
    $d A w x y z $.  $d B w x y z $.
    $( The Cartesian product of two finite sets is finite.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 12-Mar-2015.) $)
    xpfi $p |- ( ( A e. Fin /\ B e. Fin ) -> ( A X. B ) e. Fin ) $=
      ( vx vy vz vw cfn wcel cxp cv wi c0 csn cdif wceq xpeq1 eleq1d imbi2d cvv
      wa 0xp 0fin eqeltri a1i wral wn wex neq0 sneq difeq2d xpeq1d rspcv adantl
      pm2.27 ad2antlr cen wbr c2nd cres wf1o snex xpexg id vex 2ndconst f1oen2g
      mpan mp1i syl3anc enfii mpdan cun unfi xpundir difsnid biimpd syl5 mpan2d
      syl5eqr 3syld ex exlimdv syl5bi syl6eqel a1d pm2.61d2 com23 findcard imp
      ) AGHBGHZABIZGHZWJCJZBIZGHZKWJLBIZGHZKWJDJZEJZMZNZBIZGHZKZWJWRBIZGHZKWJWL
      KCDEAWMLOZWOWQWJXGWNWPGWMLBPQRWMXAOZWOXCWJXHWNXBGWMXABPQRWMWROZWOXFWJXIWN
      XEGWMWRBPQRWMAOZWOWLWJXJWNWKGWMABPQRWQWJWPLGBUAUBUCZUDWRGHZWJXDEWRUEZXFXL
      WJXMXFKZXLWJTZWRLOZXNXPUFFJZWRHZFUGXOXNFWRUHXOXRXNFXOXRXNXOXRTZXMWJWRXQMZ
      NZBIZGHZKZYCXFXRXMYDKXOXDYDEXQWRWSXQOZXCYCWJYEXBYBGYEXAYABYEWTXTWRWSXQUIU
      JUKQRULUMWJYDYCKXLXRWJYCUNUOXSYCXTBIZGHZXFWJYGXLXRWJYFBUPUQZYGWJYFSHZWJYF
      BURYFUSZUTZYHXTSHWJYIXQVAXTBSGVBVGWJVCXQSHYKWJFVDXQBSVEVHYFBYJSGVFVIYFBVJ
      VKUOYCYGTYBYFVLZGHZXSXFYBYFVMXRYMXFKXOXRYMXFXRYLXEGXRYLYAXTVLZBIXEYAXTBVN
      XRYNWRBWRXQVOUKVSQVPUMVQVRVTWAWBWCXPXFXMXPXEWPGWRLBPXKWDWEWFWAWGWHWI $.
  $}

  ${
    $d A a b c f $.  $d B a b c f $.  $d X a b c f $.  $d Y a b c f $.
    $( A finite set union cancellation law for dominance.  (Contributed by
       Stefan O'Rear, 19-Feb-2015.)  (Revised by Stefan O'Rear, 5-May-2015.) $)
    domunfican $p |- ( ( ( A e. Fin /\ B ~~ A ) /\
          ( ( A i^i X ) = (/) /\ ( B i^i Y ) = (/) ) ) ->
        ( ( A u. X ) ~<_ ( B u. Y ) <-> X ~<_ Y ) ) $=
      ( wcel wbr c0 wceq wa cun cdom wb wi cima anbi1d uneq1d breq12d bibi1d wn
      wss vf va vb vc cfn cen cin cv wf1o wex ensym bren sylib ssid sseq1 uneq1
      w3a csn imaeq2 imbi12d uncom un0 eqtri ima0 breq12i a1i ssun1 sstr2 ax-mp
      uneq1i anim1i imim1i cfv unass imaundi wfn simprlr f1ofn syl ssun2 sylibr
      vex snss adantr ad2antrl fnsnfv syl2anc eqcomd uneq2d syl5eq syl6eq incom
      simplr simprrl minel wo ioran elun xchnxbir sylanbrc f1of1 adantl f1elima
      wf1 syl3anc biimpd mtod adantrr wf f1of ffvelrnd simprrr domunsncan bitrd
      fvex bitr ex syl5 findcard2s exp3a mpani 3imp f1ofo foima breq2d 3ad2ant2
      a2d wfo mpbid 3exp exlimdv imp31 ) AUEEZBAUFFZACUGZGHZBDUGZGHZIZACJZBDJZK
      FZCDKFZLZYNABUAUHZUIZUAUJZYMYSUUDMZYNABUFFUUGBAUKABUAULUMYMUUFUUHUAYMUUFY
      SUUDYMUUFYSUQYTUUEANZDJZKFZUUCLZUUDYMUUFYSUULYMAATZUUFYSUULMAUNYMUUMUUFIZ
      YSUULUBUHZATZUUFIZYSIZUUOCJZUUEUUONZDJZKFZUUCLZMGATZUUFIZYSIZGCJZUUEGNZDJ
      ZKFZUUCLZMUCUHZATZUUFIZYSIZUVLCJZUUEUVLNZDJZKFZUUCLZMZUVLUDUHZURZJZATZUUF
      IZYSIZUWDCJZUUEUWDNZDJZKFZUUCLZMZUUNYSIZUULMUBUCUDAUUOGHZUURUVFUVCUVKUWOU
      UQUVEYSUWOUUPUVDUUFUUOGAUOOOUWOUVBUVJUUCUWOUUSUVGUVAUVIKUUOGCUPUWOUUTUVHD
      UUOGUUEUSPQRUTUUOUVLHZUURUVOUVCUVTUWPUUQUVNYSUWPUUPUVMUUFUUOUVLAUOOOUWPUV
      BUVSUUCUWPUUSUVPUVAUVRKUUOUVLCUPUWPUUTUVQDUUOUVLUUEUSPQRUTUUOUWDHZUURUWGU
      VCUWLUWQUUQUWFYSUWQUUPUWEUUFUUOUWDAUOOOUWQUVBUWKUUCUWQUUSUWHUVAUWJKUUOUWD
      CUPUWQUUTUWIDUUOUWDUUEUSPQRUTUUOAHZUURUWNUVCUULUWRUUQUUNYSUWRUUPUUMUUFUUO
      AAUOOOUWRUVBUUKUUCUWRUUSYTUVAUUJKUUOACUPUWRUUTUUIDUUOAUUEUSPQRUTUVKUVFUVG
      CUVIDKUVGCGJCGCVACVBVCUVIGDJZDUVHGDUUEVDVJUWSDGJDGDVADVBVCVCVEVFUWAUWGUVT
      MUVLUEEZUWBUVLEZSZIZUWMUWGUVOUVTUWFUVNYSUWEUVMUUFUVLUWDTUWEUVMMUVLUWCVGUV
      LUWDAVHVIZVKVKVLUXCUWGUVTUWLUXCUWGUVTUWLMZUXCUWGIZUWKUVSLZUXEUXFUWKUWCUVP
      JZUWBUUEVMZURZUVRJZKFZUVSUXFUWHUXHUWJUXKKUWHUXHHUXFUWHUWCUVLJZCJUXHUWDUXM
      CUVLUWCVAVJUWCUVLCVNVCVFUXFUWJUVQUXJJZDJZUXKUXFUWIUXNDUXFUWIUVQUUEUWCNZJU
      XNUUEUVLUWCVOUXFUXPUXJUVQUXFUXJUXPUXFUUEAVPZUWBAEZUXJUXPHUXFUUFUXQUXCUWEU
      UFYSVQZABUUEVRVSUWFUXRUXCYSUWEUXRUUFUWEUWCATZUXRUWCUWDTUWEUXTMUWCUVLVTUWC
      UWDAVHVIUWBAUDWBZWCWAWDZWEZAUWBUUEWFWGWHWIWJPUXOUXJUVQJZDJUXKUXNUYDDUVQUX
      JVAVJUXJUVQDVNVCWKQUXFUWBUVPEZSZUXIUVREZSZUXLUVSLUXFUXBUWBCEZSZUYFUWTUXBU
      WGWMUXFUXRCAUGZGHUYJUYCUXFUYKYOGCAWLUXCUWFYPYRWNWJUWBACWOWGUXAUYIWPUXBUYJ
      IUYEUXAUYIWQUWBUVLCWRWSWTUXFUXIUVQEZSZUXIDEZSZUYHUXCUWFUYMYSUXCUWFIUYLUXA
      UWTUXBUWFWMUWFUYLUXAMUXCUWFUYLUXAUWFABUUEXDZUXRUVMUYLUXALUUFUYPUWEABUUEXA
      XBUYBUWEUVMUUFUXDWDABUUEUWBUVLXCXEXFXBXGXHUXFUXIBEDBUGZGHUYOUXFABUWBUUEUX
      FUUFABUUEXIUXSABUUEXJVSUYCXKUXFUYQYQGDBWLUXCUWFYPYRXLWJUXIBDWOWGUYLUYNWPU
      YMUYOIUYGUYLUYNWQUXIUVQDWRWSWTUWBUXIUVPUVRUYAUWBUUEXOXMWGXNUXGUVTUWLUWKUV
      SUUCXPXQVSXQYGXRXSXTYAYBUUFYMUULUUDLYSUUFUUKUUBUUCUUFUUJUUAYTKUUFUUIBDUUF
      ABUUEYHUUIBHABUUEYCABUUEYDVSPYERYFYIYJYKXRYL $.
  $}

  ${
    $d x A $.
    infcntss.1 $e |- A e. _V $.
    $( Every infinite set has a denumerable subset.  Similar to Exercise 8 of
       [TakeutiZaring] p. 91.  (However, we need neither AC nor the Axiom of
       Infinity because of the way we express "infinite" in the antecedent.)
       (Contributed by NM, 23-Oct-2004.) $)
    infcntss $p |- ( om ~<_ A -> E. x ( x C_ A /\ x ~~ om ) ) $=
      ( com cdom wbr cv cen wss wa wex domen ensym anim2i ancoms eximi sylbi )
      DBEFDAGZHFZRBIZJZAKTRDHFZJZAKADBCLUAUCATSUCSUBTDRMNOPQ $.
  $}

  $( An unordered pair is finite.  (Contributed by NM, 22-Aug-2008.) $)
  prfi $p |- { A , B } e. Fin $=
    ( cpr csn cun cfn df-pr wcel snfi unfi mp2an eqeltri ) ABCADZBDZEZFABGMFHNF
    HOFHAIBIMNJKL $.

  $( An unordered triple is finite.  (Contributed by Mario Carneiro,
     28-Sep-2013.) $)
  tpfi $p |- { A , B , C } e. Fin $=
    ( ctp cpr csn cun cfn df-tp wcel prfi snfi unfi mp2an eqeltri ) ABCDABEZCFZ
    GZHABCIPHJQHJRHJABKCLPQMNO $.

  ${
    $d x y z w v f A $.
    $( Equivalent ways of stating the finite intersection property.  We show
       two ways of saying, "the intersection of elements in every finite
       non-empty subcollection of ` A ` is in ` A ` ."  This theorem is
       applicable to a topology, which (among other axioms) is closed under
       finite intersections.  Some texts use the left-hand version of this
       axiom and others the right-hand version, but as our proof here shows,
       their "intuitively obvious" equivalence can be non-trivial to establish
       formally.  (Contributed by NM, 22-Sep-2002.) $)
    fiint $p |- ( A. x e. A A. y e. A ( x i^i y ) e. A <->
      A. x ( ( x C_ A /\ x =/= (/) /\ x e. Fin ) -> |^| x e. A ) ) $=
      ( vz vw vf cv cin wcel wss c0 wa cint wi wal cen wbr wceq cvv eleq1d wral
      wne cfn w3a com wrex isfi ensym csuc breq1 anbi2d imbi1d albidv weq sylib
      vv en0 anim1i ancoms adantll wn pm3.24 pm2.21i sylan2b syl ax-gen a1i nfv
      df-ne nfa1 wf1o wex bren cima cfv wf f1of sucid ffvelrn sylancl ssel syl5
      vex imp adantr crn imassrn ccnv wfun dff1o2 simp3bi syl5sseq sstr2 anim1d
      wfn wf1 f1of1 sssucid f1imaen2g mpanr12 ensymd jctird ax-mp sseq1 anbi12d
      imaexg neeq1 breq2 inteq imbi12d sylan9 ineq1 ineq2 rspc2v ex com4r exp5c
      spcv syl6 com14 imp43 syl5bir int0 syl6eq ineq1d ssv sseqin2 mpbi biimprd
      pm2.61d2 mpd wb csn cun fvex intunsn f1ofn fnsnfv com13 biantru wfo f1ofo
      uneq2d df-suc imaeq2i imaundi eqtr2i foima eqtrd syl5eqr ad2antlr exlimdv
      inteqd mpbid exp43 syl5bi adantlr alrimd exp4a com24 rexlimiv sylbi imp3a
      finds2 sp alrimiv cpr zfpair2 eleq1 prss prnz prfi 3bitrri eleq1i 3imtr3g
      intpr ralrimivv impbii cbvral2v df-3an imbi1i albii 3bitr4i ) DGZEGZHZCIZ
      ECUADCUAZAGZCJZUWIKUBZLZUWIUCIZLZUWIMZCIZNZAOZUWIBGZHZCIZBCUAACUAUWJUWKUW
      MUDZUWPNZAOUWHUWRUWHUWQAUWHUWLUWMUWPUWMUWLUWHUWPUWMUWIUWSPQZBUEUFUWLUWHUW
      PNZNZBUWIUGUXDUXFBUEUXDUWSUWIPQZUWSUEIZUXFUWIUWSUHUXHUWHUWLUXGUWPUXHUWHUW
      LUXGUWPUXHUWHUWLUXGLZUWPNZAOZUXJUXKUWLKUWIPQZLZUWPNZAOZUWLUPGZUWIPQZLZUWP
      NZAOZUWLUXPUIZUWIPQZLZUWPNZAOZUWHBUPUWSKRZUXJUXNAUYFUXIUXMUWPUYFUXGUXLUWL
      UWSKUWIPUJUKULUMBUPUNZUXJUXSAUYGUXIUXRUWPUYGUXGUXQUWLUWSUXPUWIPUJUKULUMUW
      SUYARZUXJUYDAUYHUXIUYCUWPUYHUXGUYBUWLUWSUYAUWIPUJUKULUMUXOUWHUXNAUXMUWIKR
      ZUWKLZUWPUWKUXLUYJUWJUXLUWKUYJUXLUYIUWKUXLUWIKPQUYIKUWIUHUWIUQUOURUSUTUWK
      UYIUYIVAZUWPUWIKVIUYIUYKLUWPUYIVBVCVDVEVFVGUWHUXTUYENNUXPUEIUWHUXTUYDAUWH
      AVHUXSAVJUYCUXTUWHUWPUWJUYBUXTUXENZUWKUWJUYBUYLUYBUYAUWIFGZVKZFVLUWJUYLUY
      AUWIFVMUWJUYNUYLFUWJUYNUXTUWHUWPUWJUYNLZUXTUWHLZLZUYMUXPVNZMZUXPUYMVOZHZC
      IZUWPUYQUYTCIZVUBUYOVUCUYPUWJUYNVUCUYNUYTUWIIZUWJVUCUYNUYAUWIUYMVPUXPUYAI
      ZVUDUYAUWIUYMVQUXPUPWCZVRZUYAUWIUXPUYMVSVTUWICUYTWAWBWDWEUYQUYRKRZVUCVUBN
      ZVUHVAUYRKUBZUYQVUIUYRKVIUWJUYNUXTUWHVUJVUINZUWHUYNUXTUWJVUKUWHUYNUXTUWJV
      UJVUIUYNUXTLZUWJVUJLZVUCUWHVUBVULVUMUYSCIZVUCUWHVUBNZNUYNVUMUYRCJZVUJLZUX
      PUYRPQZLZUXTVUNUYNVUMVUQVURUYNUWJVUPVUJUYNUYRUWIJUWJVUPNUYNUYMWFZUYRUWIUY
      MUXPWGUYNUYMUYAWOZUYMWHWIVUTUWIRUYAUWIUYMWJWKWLUYRUWICWMVEWNUYNUYRUXPUYNU
      YAUWIUYMWPZUWISIZUYRUXPPQZUYAUWIUYMWQAWCVVBVVCLUXPUYAJUXPSIVVDUXPWRVUFUYA
      UWIUXPUYMSWSWTVTXAXBUXSVUSVUNNAUYRUYMSIUYRSIFWCUYMUXPSXFXCUWIUYRRZUXRVUSU
      WPVUNVVEUWLVUQUXQVURVVEUWJVUPUWKVUJUWIUYRCXDUWIUYRKXGXEUWIUYRUXPPXHXEVVEU
      WOUYSCUWIUYRXITXJXRXKVUNVUCVUOUWGVUBUYSUWEHZCIDEUYSUYTCCUWDUYSRUWFVVFCUWD
      UYSUWEXLTUWEUYTRVVFVUACUWEUYTUYSXMTXNXOXSXPXQXTYAYBVUHVUBVUCVUHVUAUYTCVUH
      VUASUYTHZUYTVUHUYSSUYTVUHUYSKMSUYRKXIYCYDYEUYTSJVVGUYTRUYTYFUYTSYGYHYDTYI
      YJYKUYNVUBUWPYLUWJUYPUYNVUAUWOCUYNVUAUYRUYTYMZYNZMUWOUYRUYTUXPUYMYOYPUYNV
      VIUWIUYNVVIUYMUYAVNZUWIUYNVVIUYRUYMUXPYMZVNZYNZVVJUYNVVHVVLUYRUYNVVAVUEVV
      HVVLRUYAUWIUYMYQVUGUYAUXPUYMYRVTUUCVVJUYMUXPVVKYNZVNVVMUYAVVNUYMUXPUUDUUE
      UYMUXPVVKUUFUUGYDUYNUYAUWIUYMUUAVVJUWIRUYAUWIUYMUUBUYAUWIUYMUUHVEUUIUUMUU
      JTUUKUUNUUOUULUUPWDUUQYSUURVGUVDUXJAUVEXSUUSUUTWBUVAUVBYSUVCUVFUWRUWGDECC
      UWRUWDUWEUVGZCJZVVOKUBZLZVVOUCIZLZVVOMZCIZUWDCIUWECILZUWGUWQVVTVWBNAVVODE
      UVHUWIVVORZUWNVVTUWPVWBVWDUWLVVRUWMVVSVWDUWJVVPUWKVVQUWIVVOCXDUWIVVOKXGXE
      UWIVVOUCUVIXEVWDUWOVWACUWIVVOXITXJXRVWCVVPVVRVVTUWDUWECDWCZEWCZUVJVVQVVPU
      WDUWEVWEUVKYTVVSVVRUWDUWEUVLYTUVMVWAUWFCUWDUWEVWEVWFUVPUVNUVOUVQUVRUXAUWG
      UWDUWSHZCIABDECCADUNUWTVWGCUWIUWDUWSXLTBEUNVWGUWFCUWSUWEUWDXMTUVSUXCUWQAU
      XBUWNUWPUWJUWKUWMUVTUWAUWBUWC $.
  $}

  ${
    $d f x y z A $.  $d f B $.  $d x y z F $.
    $( A version of ~ fnex for finite sets that does not require Replacement.
       (Contributed by Mario Carneiro, 16-Nov-2014.)  (Revised by Mario
       Carneiro, 24-Jun-2015.) $)
    fnfi $p |- ( ( F Fn A /\ A e. Fin ) -> F e. Fin ) $=
      ( vx vy vz cfn wcel wa cres wceq adantr cv wi c0 csn reseq2 eleq1d imbi2d
      cun a1i wfn fnresdm res0 0fin eqeltri resundi cfv cop wss snfi wfun fnfun
      funressn syl ssfi sylancr unfi sylan2 syl5eqel findcard2 anabsi7 eqeltrrd
      expcom a2i ) BAUAZAFGZHZBAIZBFVEVHBJVFABUBKVEVFVHFGZVGBCLZIZFGZMVGBNIZFGZ
      MVGBDLZIZFGZMZVGBVOELZOZSZIZFGZMZVGVIMCDEAVJNJZVLVNVGWEVKVMFVJNBPQRVJVOJZ
      VLVQVGWFVKVPFVJVOBPQRVJWAJZVLWCVGWGVKWBFVJWABPQRVJAJZVLVIVGWHVKVHFVJABPQR
      VNVGVMNFBUCUDUETVRWDMVOFGVGVQWCVQVGWCVQVGHWBVPBVTIZSZFBVOVTUFVGVQWIFGZWJF
      GVGVSVSBUGUHZOZFGWIWMUIZWKWLUJVEWNVFVEBUKWNABULVSBUMUNKWMWIUOUPVPWIUQURUS
      VCVDTUTVAVB $.

    $( An onto function implies dominance of domain over range, for finite
       sets.  Unlike ~ fodom for arbitrary sets, this theorem does not require
       the Axiom of Choice for its proof.  (Contributed by NM, 23-Mar-2006.)
       (Proof shortened by Mario Carneiro, 16-Nov-2014.) $)
    fodomfi $p |- ( ( A e. Fin /\ F : A -onto-> B ) -> B ~<_ A ) $=
      ( vz wcel wa cima cdom wceq wbr cv wi c0 csn cun imaeq2 id breq12d imbi2d
      cvv vx cfn wfo foima adantl wfn fofn ima0 syl6eq 0ex 0dom a1i cid cfv wss
      vy wn cres crn cop wfun fnfun ad2antrl funressn rnss df-ima rnsnop eqcomi
      3syl vex 3sstr4g snex ssexg sylancl fvi syl uneq2d imaundi syl6eqr simprr
      cin cen ssdomg mpsyl c1o fvex entr4i domentr eqbrtrd simplr disjsn sylibr
      ensn1 undom syl21anc eqbrtrrd exp32 a2d findcard2s syl5 imp ) AUBEZABCUCZ
      FCAGZBAHXCXDBIXBABCUDUEXBXCXDAHJZXCCAUFZXBXEABCUGXFCUAKZGZXGHJZLXFMMHJZLX
      FCUPKZGZXKHJZLXFCXKDKZNZOZGZXPHJZLXFXELUAUPDAXGMIZXIXJXFXSXHMXGMHXSXHCMGM
      XGMCPCUHUIXSQRSXGXKIZXIXMXFXTXHXLXGXKHXGXKCPXTQRSXGXPIZXIXRXFYAXHXQXGXPHX
      GXPCPYAQRSXGAIZXIXEXFYBXHXDXGAHXGACPYBQRSXJXFMUJUKULXKUBEZXNXKEUQZFZXFXMX
      RYEXFXMXRYEXFXMFZFZXLCXOGZUMUNZOZXQXPHYGYJXLYHOXQYGYIYHXLYGYHTEZYIYHIYGYH
      XNCUNZNZUOZYMTEZYKYGCXOURZUSZXNYLUTNZUSZYHYMYGCVAZYPYRUOYQYSUOXFYTYEXMACV
      BVCXNCVDYPYRVEVICXOVFYSYMXNYLDVJZVGVHVKZYLVLZYHYMTVMVNYHTVOVPZVQCXKXOVRVS
      YGXMYIXOHJXKXOWAMIZYJXPHJYEXFXMVTYGYIYHXOHUUDYGYHYMHJZYMXOWBJYHXOHJYOYGYN
      UUFUUCUUBYHYMTWCWDYMWEXOYLXNCWFWMXNUUAWMWGYHYMXOWHVNWIYGYDUUEYCYDYFWJXKXN
      WKWLXLXKYIXOWNWOWPWQWRWSWTXAWP $.

    $( Equivalence of an onto mapping and dominance for a non-empty finite
       set.  Unlike ~ fodomb for arbitrary sets, this theorem does not require
       the Axiom of Choice for its proof.  (Contributed by NM, 23-Mar-2006.) $)
    fodomfib $p |- ( A e. Fin ->
    ( ( A =/= (/) /\ E. f f : A -onto-> B ) <-> ( (/) ~< B /\ B ~<_ A ) ) ) $=
      ( cfn wcel c0 wne cv wfo wa csdm wbr wceq syl eqeq1d cvv 0sdomg ex jcad
      wi wex cdom cdm wf fof fdm dm0rn0 syl5bb bitr3d necon3bid biimpac adantll
      crn forn vex rnex syl6eqelr adantl adantlr mpbird fodomfi exlimdv expimpd
      wb adantr sdomdomtr syl5ib fodomr a1i impbid ) ADEZAFGZABCHZIZCUAZJFBKLZB
      AUBLZJZVKVLVOVRVKVLJZVNVRCVSVNVPVQVSVNVPVSVNJVPBFGZVLVNVTVKVNVLVTVNAFBFVN
      VMUCZFMZAFMBFMZVNWAAFVNABVMUDWAAMABVMUEABVMUFNOWBVMUMZFMVNWCVMUGVNWDBFABV
      MUNZOUHUIUJUKULVKVNVPVTVDZVLVKVNJBPEZWFVNWGVKVNBWDPWEVMCUOUPUQURBPQNUSUTR
      VKVNVQTVLVKVNVQABVMVARVESVBVCVKVRVLVOVRFAKLVKVLFBAVFADQVGVRVOTVKABCVHVISV
      J $.
  $}

  ${
    $d u w x y z A $.  $d u w x y z B $.  $d u w x y z F $.
    $( Any surjection from one finite set to another of equal size must be a
       bijection.  (Contributed by Mario Carneiro, 19-Aug-2014.) $)
    fofinf1o $p |- ( ( F : A -onto-> B /\ A ~~ B /\ B e. Fin ) ->
                     F : A -1-1-onto-> B ) $=
      ( vx vy vz vw vu wbr wcel cv cfv wceq weq wa syl2anc sylanbrc adantr wrex
      wne wfo cen cfn w3a wf1 wf1o wf wi wral simp1 fof syl csn cdif wn domnsym
      cdom csdm wpss simp3 simp2 enfii ad2antrr difssd simplrr neldifsn sylancl
      wss nelne1 necomd df-pss php3 sdomentr nsyl3 cres difss ssfi fssres sylan
      foelrn simprll simprrr eldifsn simprrl eqcomd fveq2 eqeq2d rspcev rexbidv
      eqeq1d syl5ibrcom imp mpan2 sylbir adantll pm2.61dane fvres rexbiia eqeq1
      eqid syl5bb rexlimdva syldan ralrimiva dffo3 fodomfi anassrs necon1bd mpd
      expr ex ralrimivva dff13 df-f1o ) ABCUAZABUBIZBUCJZUDZABCUEZXOABCUFXRABCU
      GZDKZCLZEKZCLZMZDENZUHZEAUIDAUIXSXRXOXTXOXPXQUJZABCUKULZXRYGDEAAXRYAAJZYC
      AJZOZOZYEYFYMYEOZBAYCUMZUNZUQIZUOYFYQYPBURIZYNBYPUPYNYPAURIZXPYRYNAUCJZYP
      AUSZYSXRYTYLYEXRXQXPYTXOXPXQUTXOXPXQVAZABVBPZVCYNYPAVHZYPATUUAYNAYOVDYNAY
      PYNYKYCYPJUOAYPTXRYJYKYEVEYCAVFYCAYPVIVGVJYPAVKQAYPVLPXRXPYLYEUUBVCYPABVM
      PVNYNYQYAYCYMYEYAYCTZYQXRYLYEUUEOZYQXRYLUUFOZOZYPUCJZYPBCYPVOZUAZYQUUHYTU
      UDUUIXRYTUUGUUCRAYOVPZAYPVQVGUUHYPBUUJUGZFKZGKZUUJLZMZGYPSZFBUIUUKUUHXTUU
      DUUMXRXTUUGYIRUULABYPCVRVGUUHUURFBUUHUUNBJZUUNHKZCLZMZHASZUURUUHXOUUSUVCX
      RXOUUGYHRHABUUNCVTVSUUHUVCUURUUHUVBUURHAUUHUUTAJZOZUURUVBUVAUUOCLZMZGYPSZ
      UVEUVHUUTYCUVEHENZUVHUUHUVIUVHUHUVDUUHUVHUVIYDUVFMZGYPSZUUHYAYPJZYDYBMZUV
      KUUHYJUUEUVLXRYJYKUUFWAXRYLYEUUEWBYAAYCWCQUUHYBYDXRYLYEUUEWDWEUVJUVMGYAYP
      GDNUVFYBYDUUOYACWFWGWHPUVIUVGUVJGYPUVIUVAYDUVFUUTYCCWFWJWIWKRWLUVDUUTYCTZ
      UVHUUHUVDUVNOUUTYPJZUVHUUTAYCWCUVOUVAUVAMZUVHUVAWTUVGUVPGUUTYPGHNUVFUVAUV
      AUUOUUTCWFWGWHWMWNWOWPUURUUNUVFMZGYPSUVBUVHUUQUVQGYPUUOYPJUUPUVFUUNUUOYPC
      WQWGWRUVBUVQUVGGYPUUNUVAUVFWSWIXAWKXBWLXCXDGFYPBUUJXEQYPBUUJXFPXGXJXHXIXK
      XLDEABCXMQYHABCXNQ $.
  $}

  ${
    $d x F $.
    $( Any finite set dominates its domain.  (Contributed by Mario Carneiro,
       22-Sep-2013.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
    fidomdm $p |- ( F e. Fin -> dom F ~<_ F ) $=
      ( vx cfn wcel cdm cvv cres cdom dmresv wbr cv c1st cfv cmpt wfo finresfin
      crn wfn fvex eqid fnmpti dffn4 mpbi wrel wceq wb relres reldm foeq3 mpbir
      mp2b fodomfi sylancl wss resss ssdomg mpi domtr syl2anc syl5eqbrr ) ACDZA
      EAFGZEZAHAIVAVCVBHJZVBAHJZVCAHJVAVBCDVBVCBVBBKZLMZNZOZVDFAPVIVBVHQZVHOZVH
      VBRVKBVBVGVHVFLSVHTUAVBVHUBUCVBUDVCVJUEVIVKUFAFUGBVBUHVCVJVBVHUIUKUJVBVCV
      HULUMVAVBAUNVEAFUOVBACUPUQVCVBAURUSUT $.
  $}

  $( The domain of a finite set is finite.  (Contributed by Mario Carneiro,
     24-Sep-2013.) $)
  dmfi $p |- ( A e. Fin -> dom A e. Fin ) $=
    ( cfn wcel cdm cdom wbr fidomdm domfi mpdan ) ABCADZAEFJBCAGAJHI $.

  $( If a set is finite, its converse is as well.  (Contributed by Mario
     Carneiro, 28-Dec-2014.) $)
  cnvfi $p |- ( A e. Fin -> `' A e. Fin ) $=
    ( cfn wcel ccnv cen wbr wss cnvcnvss ssfi mpan2 relcnv cnvexg cnven sylancr
    wrel cvv enfii syl2anc ) ABCZADZDZBCZTUAEFZTBCSUAAGUBAHAUAIJSTOTPCUCAKABLTP
    MNTUAQR $.

  $( The range of a finite set is finite.  (Contributed by Mario Carneiro,
     28-Dec-2014.) $)
  rnfi $p |- ( A e. Fin -> ran A e. Fin ) $=
    ( cfn wcel crn ccnv cdm df-rn cnvfi dmfi syl syl5eqel ) ABCZADAEZFZBAGLMBCN
    BCAHMIJK $.

  ${
    $d w x y z A $.  $d w y z B $.
    $( If a function has a finite domain, its range is finite.  Theorem 37 of
       [Suppes] p. 104.  (Contributed by NM, 25-Mar-2007.) $)
    fofi $p |- ( ( A e. Fin /\ F : A -onto-> B ) -> B e. Fin ) $=
      ( cfn wcel wfo cdom wbr fodomfi domfi syldan ) ADEABCFBAGHBDEABCIABJK $.

    $( If a 1-to-1 function has a finite codomain its domain is finite.
       (Contributed by FL, 31-Jul-2009.)  (Revised by Mario Carneiro,
       24-Jun-2015.) $)
    f1fi $p |- ( ( B e. Fin /\ F : A -1-1-> B ) -> A e. Fin ) $=
      ( cfn wcel wf1 wa crn ccnv wfo wss wf f1f frn syl ssfi sylan2 wf1o adantl
      f1f1orn f1ocnv f1ofo 3syl fofi syl2anc ) BDEZABCFZGZCHZDEZUIACIZJZADEUGUF
      UIBKZUJUGABCLUMABCMABCNOBUIPQUHAUICRZUIAUKRULUGUNUFABCTSAUICUAUIAUKUBUCUI
      AUKUDUE $.

    $( The finite union of finite sets is finite.  Exercise 13 of [Enderton]
       p. 144.  This is the indexed union version of ~ unifi .  Note that ` B `
       depends on ` x ` , i.e. can be thought of as ` B ( x ) ` .  (Contributed
       by NM, 23-Mar-2006.)  (Proof shortened by Mario Carneiro,
       31-Aug-2015.) $)
    iunfi $p |- ( ( A e. Fin /\ A. x e. A B e. Fin )
        -> U_ x e. A B e. Fin ) $=
      ( vw vy vz cfn wcel wral ciun cv wi c0 cun wceq iuneq1 eleq1d imbi12d a1i
      raleq csn 0iun syl6eq wss ssun1 ssralv ax-mp imim1i wa iunxun csb nfcsb1v
      0fin nfcv csbeq1a cbviun csbeq1 iunxsn eqtri ssun2 snid sselii nfel1 rspc
      vex syl5eqel unfi sylan2 expcom sylcom findcard2 imp ) BGHCGHZABIZABCJZGH
      ZVMADKZIZAVQCJZGHZLVMAMIZMGHZLVMAEKZIZAWCCJZGHZLZVMAWCFKZUAZNZIZAWJCJZGHZ
      LZVNVPLDEFBVQMOZVRWAVTWBVMAVQMTWOVSMGWOVSAMCJMAVQMCPACUBUCQRVQWCOZVRWDVTW
      FVMAVQWCTWPVSWEGAVQWCCPQRVQWJOZVRWKVTWMVMAVQWJTWQVSWLGAVQWJCPQRVQBOZVRVNV
      TVPVMAVQBTWRVSVOGAVQBCPQRWBWAUMSWGWNLWCGHWGWKWFWMWKWDWFWCWJUDWKWDLWCWIUEV
      MAWCWJUFUGUHWFWKWMWFWKUIWLWEAWICJZNZGAWCWICUJWKWFWSGHWTGHWKWSAWHCUKZGWSEW
      IAWCCUKZJXAAEWICXBECUNAWCCULAWCCUOUPEWHXBXAFVEZAWCWHCUQURUSWHWJHWKXAGHZLW
      IWJWHWIWCUTWHXCVAVBVMXDAWHWJAXAGAWHCULVCAKWHOCXAGAWHCUOQVDUGVFWEWSVGVHVFV
      IVJSVKVL $.

    $( The finite union of finite sets is finite.  Exercise 13 of [Enderton]
       p. 144.  (Contributed by NM, 22-Aug-2008.)  (Revised by Mario Carneiro,
       31-Aug-2015.) $)
    unifi $p |- ( ( A e. Fin /\ A C_ Fin ) -> U. A e. Fin ) $=
      ( vx cfn wss wcel cv wral cuni dfss3 ciun uniiun iunfi syl5eqel sylan2b
      wa ) ACDACEZBFZCEBAGZAHZCEBACIPROSBAQJCBAKBAQLMN $.

    $( The finite union of finite sets is finite.  Exercise 13 of [Enderton]
       p. 144.  This version of ~ unifi is useful only if we assume the Axiom
       of Infinity (see comments in ~ fin2inf ).  (Contributed by NM,
       11-Mar-2006.) $)
    unifi2 $p |- ( ( A ~< om /\ A. x e. A x ~< om ) -> U. A ~< om ) $=
      ( com csdm wbr cv wral wa cuni cfn wcel wss isfinite2 ralimi dfss3 sylibr
      unifi syl2an cvv wb fin2inf adantr isfiniteg syl mpbid ) BCDEZAFZCDEZABGZ
      HZBIZJKZUKCDEZUFBJKBJLZULUIBMUIUGJKZABGUNUHUOABUGMNABJOPBQRUJCSKZULUMTUFU
      PUIBUAUBUKUCUDUE $.
  $}

  ${
    $d A x $.  $d B x $.
    $( If an infinite set ` A ` is included in the underlying set of a finite
       cover ` B ` , then there exists a set of the cover that contains an
       infinite number of element of ` A ` .  (Contributed by FL,
       2-Aug-2009.) $)
    infssuni $p |- ( ( -. A e. Fin /\ B e. Fin /\ A C_ U. B )
        -> E. x e. B -. ( A i^i x ) e. Fin ) $=
      ( cfn wcel wn cuni wss w3a cv cin wrex wral dfral2 wi wa ciun sylbi com12
      eleq1i iunfi iunin2 uniiun eqcomi ineq2i df-ss eleq1 pm2.24 syl6bi syl ex
      wceq com24 3imp syl5bir pm2.18d ) BDEZFZCDEZBCGZHZIZBAJZKZDEZFACLZVFFVEAC
      MZVBVFVEACNURUSVAVGVFOZUSURVAVHOUSVGVAURVFUSVGVAURVFOZOZUSVGPACVDQZDEZVJA
      CVDUAVLBACVCQZKZDEZVJVKVNDACBVCUBTVOBUTKZDEZVJVNVPDVMUTBUTVMACUCUDUETVAVQ
      VIVAVPBULZVQVIOBUTUFVRVQUQVIVPBDUGUQVFUHUIRSRRUJUKUMSUNUOUP $.
  $}

  ${
    unirnffid.1 $e |- ( ph -> F : T --> Fin ) $.
    unirnffid.2 $e |- ( ph -> T e. Fin ) $.
    $( The union of the range of a function from a finite set into the class of
       finite sets is finite.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    unirnffid $p |- ( ph -> U. ran F e. Fin ) $=
      ( crn cfn wcel wss cuni wfn wf ffn syl fnfi syl2anc rnfi frn unifi ) ACFZ
      GHZTGIZTJGHACGHZUAACBKZBGHUCABGCLZUDDBGCMNEBCOPCQNAUEUBDBGCRNTSP $.
  $}


  $( Images of finite sets are finite.  (Contributed by Stefan O'Rear,
     22-Feb-2015.) $)
  imafi $p |- ( ( Fun F /\ X e. Fin ) -> ( F " X ) e. Fin ) $=
    ( wfun cfn wcel wa cima cres cdm imadmres wfo wss simpr dmres inss1 eqsstri
    cin ssfi sylancl resss dmss mp1i fores syldan fofi syl2anc syl5eqelr ) ACZB
    DEZFZABGAABHZIZGZDABJUJULDEZULUMAULHZKZUMDEUJUIULBLUNUHUIMULBAIZQBABNBUQOPB
    ULRSUHUIULUQLZUPUKALURUJABTUKAUAUBULAUCUDULUMUOUEUFUG $.

  ${
    suppfif1.f $e |- ( ph -> ( `' F " ( _V \ { Z } ) ) e. Fin ) $.
    suppfif1.g $e |- ( ph -> G : X -1-1-> Y ) $.
    $( Formula building theorem for finite supports: rearranging the index
       set.  (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
    suppfif1 $p |- ( ph -> ( `' ( F o. G ) " ( _V \ { Z } ) ) e. Fin ) $=
      ( ccom ccnv cvv csn cdif cima cfn cnvco imaeq1i imaco eqtri wcel wfun wf1
      wf df-f1 simprbi syl imafi syl2anc syl5eqel ) ABCIJZKFLMZNZCJZBJZUKNZNZOU
      LUMUNIZUKNUPUJUQUKBCPQUMUNUKRSAUMUAZUOOTUPOTADECUBZURHUSDECUCURDECUDUEUFG
      UMUOUGUHUI $.
  $}

  ${
    $d d F $.  $d c d y b $.  $d c d y x $.
    pwfilem.1 $e |- F = ( c e. ~P b |-> ( c u. { x } ) ) $.
    $( Lemma for ~ pwfi .  (Contributed by NM, 26-Mar-2007.) $)
    pwfilem $p |- ( ~P b e. Fin ->
                    ~P ( b u. { x } ) e. Fin ) $=
      ( vd cv cpw cfn wcel csn cun cdif cdom wbr domfi wss wceq sylib syl2anc
      pwundif crn wfo wfn vex snex unex fnmpti dffn4 fodomfi mpan2 mpdan eldifi
      elpwun undif1 elpwunsn snssd ssequn2 syl5req uneq1 eqeq2d rspcev elrnmpti
      mpbi wrex sylibr ssriv ssdomg ee10 unfi mpancom syl5eqel ) CGZHZIJZVMAGZK
      ZLHZVRVNMZVNLZIVMVQUAVSIJZVOVTIJVOBUBZIJZVSWBNOZWAVOWBVNNOZWCVOVNWBBUCZWE
      BVNUDWFDVNDGZVQLZBWGVQDUEVPUFZUGZEUHVNBUIVDVNWBBUJUKVNWBPULZVOWCVSWBQWDWK
      FVSWBFGZVSJZWLWHRZDVNVEZWLWBJWMWLVQMZVNJZWLWPVQLZRZWOWMWLVRJWQWLVRVNUMWLV
      MVQWIUNSWMWRWLVQLZWLWLVQUOWMVQWLQWTWLRWMVPWLWLVMVPUPUQVQWLURSUSWNWSDWPVNW
      GWPRWHWRWLWGWPVQUTVAVBTDVNWHWLBEWJVCVFVGVSWBIVHVIWBVSPTVSVNVJVKVL $.
  $}

  ${
    $d m A $.  $d c k m y $.
    $( The power set of a finite set is finite and vice-versa.  Theorem 38 of
       [Suppes] p. 104 and its converse, Theorem 40 of [Suppes] p. 105.
       (Contributed by NM, 26-Mar-2007.) $)
    pwfi $p |- ( A e. Fin <-> ~P A e. Fin ) $=
      ( vm vk vc cfn wcel cpw cen wbr com wrex csn cun wceq pweq eleq1d c1o cvv
      cv c0 isfi csuc df-suc pweqi syl6eq pw0 df1o2 eqtr4i wss 1onn ssid ssnnfi
      mp2an eqeltri wi cmpt eqid pwfilem a1i finds1 pwen enfii syl2an rexlimiva
      sylbi cdom csdm elex pwexb sylibr canth2g sdomdom 3syl domfi mpdan impbii
      ) AEFZAGZEFZVQABSZHIZBJKVSBAUAWAVSBJVTJFVTGZEFZVRWBHIVSWAWCTGZEFCSZGZEFZW
      EWELZMZGZEFZBCVTTNWBWDEVTTOPVTWENWBWFEVTWEOPVTWEUBZNZWBWJEWMWBWLGWJVTWLOW
      LWIWEUCUDUEPWDQEWDTLQUFUGUHQJFQQUIQEFUJQUKQQULUMUNWGWKUOWEJFCDWFDSWHMUPZC
      DWNUQURUSUTAVTVAVRWBVBVCVDVEVSAVRVFIZVQVSARFZAVRVGIWOVSVRRFWPVREVHAVIVJAR
      VKAVRVLVMVRAVNVOVP $.
  $}

  $( Set exponentiation of finite sets is finite.  (Contributed by Jeff Madsen,
     19-Jun-2011.) $)
  mapfi $p |- ( ( A e. Fin /\ B e. Fin ) -> ( A ^m B ) e. Fin ) $=
    ( cfn wcel wa cxp cpw cmap wss xpfi ancoms pwfi sylib mapsspw ssfi sylancl
    co ) ACDZBCDZEZBAFZGZCDZABHQZUBIUDCDTUACDZUCSRUEBAJKUALMABNUBUDOP $.

  ${
    $d A x $.
    $( A cross product of finitely many finite sets is finite.  (Contributed by
       Jeff Madsen, 19-Jun-2011.) $)
    ixpfi $p |- ( ( A e. Fin /\ A. x e. A B e. Fin ) -> X_ x e. A B e. Fin ) $=
      ( cfn wcel wral wa ciun cmap co cixp iunfi simpl mapfi syl2anc ixpssmap2g
      wss syl ssfi ) BDEZCDEABFZGZABCHZBIJZDEZABCKZUDQZUFDEUBUCDEZTUEABCLZTUAMU
      CBNOUBUHUGUIABCDPRUDUFSO $.
  $}

  ${
    $d f g x A $.  $d f g B $.  $d f g x C $.  $d f g x ph $.
    ixpfi2.1 $e |- ( ph -> C e. Fin ) $.
    ixpfi2.2 $e |- ( ( ph /\ x e. A ) -> B e. Fin ) $.
    ixpfi2.3 $e |- ( ( ph /\ x e. ( A \ C ) ) -> B C_ { D } ) $.
    $( A cross product of finite sets such that all but finitely many are
       singletons is finite.  (Note that ` B ( x ) ` and ` D ( x ) ` are both
       possibly dependent on ` x ` . ) (Contributed by Mario Carneiro,
       25-Jan-2015.) $)
    ixpfi2 $p |- ( ph -> X_ x e. A B e. Fin ) $=
      ( vf vg cfn wcel cv wral syl2anc wa wceq cfv wfn cin cixp cres cmpt inss2
      wf1 wss ssfi sylancl inss1 ralrimiva ssralv mpsyl ixpfi wi resixp mpan wb
      a1i cdif simprl vex elixp sylib simprd simprr difss ax-mp csn sseld elsni
      r19.26 syl6 anim12d eqtr3 ralimdva adantr syl5bir mp2and biantrud eqeq12d
      syl5 fvres ralbiia cun inundif raleqi ralunb bitr3i 3bitr4g simpld eqfnfv
      fnssres 3bitr4d ex dom2lem f1fi ) ABCEUAZDUBZLMZBCDUBZWSJXAJNZWRUCZUDZUFX
      ALMAWRLMZDLMZBWROZWTAELMWREUGXEGCEUEEWRUHUIWRCUGZAXFBCOXGCEUJZAXFBCHUKXFB
      WRCULUMBWRDUNPAJKXAWSXCKNZWRUCZXBXAMZXCWSMZUOAXHXLXMXIBCWRDXBUPUQUSAXLXJX
      AMZQZXCXKRZXBXJRZURAXOQZBNZXCSZXSXKSZRZBWROZXSXBSZXSXJSZRZBCOZXPXQXRYFBWR
      OZYHYFBCEUTZOZQZYCYGXRYJYHXRYDDMZBCOZYEDMZBCOZYJXRXBCTZYMXRXLYPYMQAXLXNVA
      BCDXBJVBVCVDZVEXRXJCTZYOXRXNYRYOQAXLXNVFBCDXJKVBVCVDZVEYMYOQYLYNQZBCOZXRY
      JYLYNBCVLUUAYTBYIOZXRYJYICUGUUAUUBUOCEVGYTBYICULVHAUUBYJUOXOAYTYFBYIAXSYI
      MQZYTYDFRZYEFRZQYFUUCYLUUDYNUUEUUCYLYDFVIZMUUDUUCDUUFYDIVJYDFVKVMUUCYNYEU
      UFMUUEUUCDUUFYEIVJYEFVKVMVNYDYEFVOVMVPVQWBVRVSVTYBYFBWRXSWRMXTYDYAYEXSWRX
      BWCXSWRXJWCWAWDYGYFBWRYIWEZOYKYFBUUGCCEWFWGYFBWRYIWHWIWJXRXCWRTZXKWRTZXPY
      CURXRYPXHUUHXRYPYMYQWKZXICWRXBWMUIXRYRXHUUIXRYRYOYSWKZXICWRXJWMUIBWRXCXKW
      LPXRYPYRXQYGURUUJUUKBCXBXJWLPWNWOWPXAWSXDWQP $.
  $}

  ${
    $d A x y $.  $d B y $.
    $( A finite mapping set is finite.  (Contributed by Mario Carneiro,
       31-Aug-2015.) $)
    mptfi $p |- ( A e. Fin -> ( x e. A |-> B ) e. Fin ) $=
      ( cfn wcel cmpt cdm wfn wfun funmpt funfn mpbi wss eqid dmmptss ssfi fnfi
      mpan2 sylancr ) BDEZABCFZUAGZHZUBDEZUADEUAIUCABCJUAKLTUBBMUDABCUAUANOBUBP
      RUBUAQS $.

    $( An image set from a finite set is finite.  (Contributed by Mario
       Carneiro, 13-Feb-2014.) $)
    abrexfi $p |- ( A e. Fin -> { y | E. x e. A y = B } e. Fin ) $=
      ( cfn wcel cv wceq wrex cab cmpt crn eqid rnmpt mptfi rnfi syl syl5eqelr
      ) CEFZBGDHACIBJACDKZLZEABCDTTMNSTEFUAEFACDOTPQR $.
  $}

  $( Membership in a class of finite subsets.  (Contributed by Stefan O'Rear,
     4-Apr-2015.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
  elfpw $p |- ( A e. ( ~P B i^i Fin ) <-> ( A C_ B /\ A e. Fin ) ) $=
    ( cpw cfn cin wcel wa wss elin elpwg pm5.32ri bitri ) ABCZDEFAMFZADFZGABHZO
    GAMDIONPABDJKL $.

  ${
    $d a b A $.  $d a b B $.  $d a b F $.
    $( A set is the union of its finite subsets.  (Contributed by Stefan
       O'Rear, 2-Apr-2015.) $)
    unifpw $p |- U. ( ~P A i^i Fin ) = A $=
      ( va cpw cfn cin cuni cv inss1 unissi unipw sseqtri sseli csn wss snelpwi
      wcel snfi a1i elin sylanbrc elssuni syl snidg sseldd impbii eqriv ) BACZD
      EZFZABGZUIPUJAPZUIAUJUIUGFAUHUGUGDHIAJKLUKUJMZUIUJUKULUHPZULUINUKULUGPULD
      PZUMUJAOUNUKUJQRULUGDSTULUHUAUBUJAUCUDUEUF $.

    $( A one-to-one mapping induces a one-to-one mapping on finite subsets.
       (Contributed by Mario Carneiro, 25-Jan-2015.) $)
    f1opwfi $p |- ( F : A -1-1-onto-> B ->
      ( b e. ( ~P A i^i Fin ) |-> ( F " b ) ) :
        ( ~P A i^i Fin ) -1-1-onto-> ( ~P B i^i Fin ) ) $=
      ( va wf1o cpw cfn cin cima wcel wa wss wfo wceq syl adantr adantl syl2anc
      wb ccnv cmpt eqid crn imassrn f1ofo forn syl5sseq cres inss2 simpr sseldi
      cv wfun cdm f1ofun inss1 sseli elpwi f1odm sseqtr4d fores fofi elpwg elin
      mpbird sylanbrc dfdm4 syl5eqr dff1o3 simprbi f1ocnv anim12i syl2an eqcomd
      foimacnv imaeq2 eqeq2d syl5ibrcom wf1 f1of1 f1imacnv impbid sylan2 f1o2d
      ) ABCFZDEAGZHIZBGZHIZCDUMZJZCUAZEUMZJZDWHWLUBZWPUCWFWKWHKZLZWLWIKZWLHKZWL
      WJKWRWSWLBMZWFXAWQWFCUDZWLBCWKUEWFABCNZXBBOABCUFZABCUGPUHQWRWTWSXATWRWKHK
      WKWLCWKUIZNZWTWRWHHWKWGHUJWFWQUKULWRCUNZWKCUOZMXFWFXGWQABCUPQWRWKAXHWQWKA
      MZWFWQWKWGKZXIWHWGWKWGHUQURZWKAUSZPRWFXHAOWQABCUTZQVAWKCVBSWKWLXEVCSZWLBH
      VDPVFXNWLWIHVEVGWFWNWJKZLZWOWGKZWOHKZWOWHKXPXQWOAMZWFXSXOWFWMUDZWOAWMWNUE
      WFXTXHACVHXMVIUHQXPXRXQXSTXPWNHKWNWOWMWNUIZNZXRXPWJHWNWIHUJWFXOUKULXPWMUN
      ZWNWMUOZMYBWFYCXOWFXCYCABCVJVKQXPWNBYDXPWNWIKZWNBMZXOYEWFWJWIWNWIHUQURZRW
      NBUSZPXPBAWMFZYDBOWFYIXOABCVLQBAWMUTPVAWNWMVBSWNWOYAVCSZWOAHVDPVFYJWOWGHV
      EVGWQXOLWFXJYELZWKWOOZWNWLOZTWQXJXOYEXKYGVMWFYKLZYLYMYNYMYLWNCWOJZOYNYOWN
      WFXCYFYOWNOYKXDYEYFXJYHRABWNCVPVNVOYLWLYOWNWKWOCVQVRVSYNYLYMWKWMWLJZOYNYP
      WKWFABCVTXIYPWKOYKABCWAXJXIYEXLQABWKCWBVNVOYMWOYPWKWNWLWMVQVRVSWCWDWE $.
  $}

  ${
    $d A c f $.  $d A x $.  $d B c f $.  $d B x z $.  $d f x z $.
    $( A finite subset of a union is covered by finitely many elements.
       (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    fissuni $p |- ( ( A C_ U. B /\ A e. Fin ) ->
        E. c e. ( ~P B i^i Fin ) A C_ U. c ) $=
      ( vf vx vz cuni wss cfn wcel wa cv wral simpr dfss3 adantr syl2anc sylibr
      wrex cvv cfv cpw cin wel wex eluni2 ralbii bitri biimpi eleq2 ac6sfi cima
      wf crn imassrn frn syl5ss vex imaexg ax-mp elpw ad2antrl wfun ffun simplr
      imafi elin sylanbrc wfn ffn ssid a1i fnfvima syl3anc elssuni syl ralimdva
      sseld imp adantl wceq unieq sseq2d rspcev exlimddv ) ABGZHZAIJZKZABDLZUMZ
      ELZWLWJUAZJZEAMZKZACLZGZHZCBUBZIUCZSZDWIWHEFUDZFBSZEAMZWPDUEWGWHNWGXEWHWG
      XEWGWLWFJZEAMXEEAWFOXFXDEAFWLBUFUGUHUIPXCWNEFABDFLWMWLUJUKQWIWPKZWJAULZXA
      JZAXHGZHZXBXGXHWTJZXHIJZXIWKXLWIWOWKXHBHXLWKXHWJUNBWJAUOABWJUPUQXHBWJTJXH
      TJDURWJATUSUTVARVBXGWJVCZWHXMWKXNWIWOABWJVDVBWGWHWPVEWJAVFQXHWTIVGVHWPXKW
      IWPWLXJJZEAMZXKWKWOXPWKWNXOEAWKWLAJZKZWMXJWLXRWMXHJZWMXJHXRWJAVIZAAHZXQXS
      WKXTXQABWJVJPYAXRAVKVLWKXQNAAWJWLVMVNWMXHVOVPVRVQVSEAXJORVTWSXKCXHXAWQXHW
      AWRXJAWQXHWBWCWDQWE $.
  $}

  ${
    $d A c f $.  $d A x $.  $d B c f $.  $d B x y $.  $d F c f $.  $d F x y $.
    $d f x y $.
    $( Given a finite subset ` A ` of the range of a function, there exists a
       finite subset of the domain whose image is ` A ` .  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Stefan O'Rear, 22-Feb-2015.) $)
    fipreima $p |- ( ( F Fn B /\ A C_ ran F /\ A e. Fin ) ->
        E. c e. ( ~P B i^i Fin ) ( F " c ) = A ) $=
      ( vf vx vy wfn wss cfn wcel cv cfv wceq wral wa cima syl2anc cvv ad2antrl
      crn w3a wf cpw cin wrex simp3 dfss3 fvelrnb ralbidv syl5bb biimpa 3adant3
      wex fveq2 eqeq1d ac6sfi imassrn syl5ss imaexg ax-mp elpw sylibr wfun ffun
      frn vex simpl3 imafi elin sylanbrc ccom cid cres wi fvresi adantl eqeq12d
      fvco3 ralbidva biimprd impr simpl1 ffn fnco syl3anc fnresi eqfnfv sylancl
      wb mpbird imaeq1d imaco ssid resiima 3eqtr3g imaeq2 rspcev exlimddv ) CBH
      ZACUAZIZAJKZUBZABELZUCZFLZXEMZCMZXGNZFAOZPZCDLZQZANZDBUDZJUEZUFZEXDXCGLZC
      MZXGNZGBUFZFAOZXLEUNWTXBXCUGWTXBYCXCWTXBYCXBXGXAKZFAOWTYCFAXAUHWTYDYBFAGB
      XGCUIUJUKULUMYAXJFGABEXSXHNXTXIXGXSXHCUOUPUQRXDXLPZXEAQZXQKZCYFQZANZXRYEY
      FXPKZYFJKZYGXFYJXDXKXFYFBIYJXFYFXEUAZBXEAURABXEVFZUSYFBXESKYFSKEVGXEASUTV
      AVBVCTYEXEVDZXCYKXFYNXDXKABXEVETWTXBXCXLVHXEAVIRYFXPJVJVKYECXEVLZAQVMAVNZ
      AQZYHAYEYOYPAYEYOYPNZXGYOMZXGYPMZNZFAOZXDXFXKUUBXFXKUUBVOXDXFUUBXKXFUUAXJ
      FAXFXGAKZPYSXIYTXGABXGCXEVSUUCYTXGNXFAXGVPVQVRVTWAVQWBYEYOAHZYPAHYRUUBWJY
      EWTXEAHZYLBIZUUDWTXBXCXLWCXFUUEXDXKABXEWDTXFUUFXDXKYMTBACXEWEWFAWGFAYOYPW
      HWIWKWLCXEAWMAAIYQANAWNAAWOVAWPXOYIDYFXQXMYFNXNYHAXMYFCWQUPWRRWS $.
  $}

  ${
    $d a b c u w x y z A $.  $d a b c z B $.
    $( A finite subset of the union of a superset chain is a subset of some
       element of the chain.  A useful preliminary result for ~ alexsub and
       others.  (Contributed by Jeff Hankins, 25-Jan-2010.)  (Proof shortened
       by Mario Carneiro, 11-Feb-2015.)  (Revised by Mario Carneiro,
       18-May-2015.) $)
    finsschain $p |- ( ( ( A =/= (/) /\ [C.] Or A ) /\
        ( B e. Fin /\ B C_ U. A ) ) -> E. z e. A B C_ z ) $=
      ( va vb vc vw vu c0 wa wcel wss cv wrex wceq sseq1 rexbidv imbi12d imbi2d
      wi wne crpss wor cfn cuni csn cun wral 0ss rgenw r19.2z adantr a1d unssad
      mpan2 id imim1i sseq2 cbvrexv simpr unssbd vex sylibr eluni2 sylib reeanv
      snss simpllr simprlr simprll sorpssun simprrr simprrl snssd unss12 rspcev
      syl12anc syl2anc expr rexlimdvva syl5bir mpand syl5bi ex a2d syl5 a2i a1i
      findcard2 com12 imp32 ) BIUAZBUBUCZJZCUDKZCBUEZLZCAMZLZABNZWOWNWQWTTZWNDM
      ZWPLZXBWRLZABNZTZTWNIWPLZIWRLZABNZTZTWNEMZWPLZXKWRLZABNZTZTZWNXKFMZUFZUGZ
      WPLZXSWRLZABNZTZTZWNXATDEFCXBIOZXFXJWNYEXCXGXEXIXBIWPPYEXDXHABXBIWRPQRSXB
      XKOZXFXOWNYFXCXLXEXNXBXKWPPYFXDXMABXBXKWRPQRSXBXSOZXFYCWNYGXCXTXEYBXBXSWP
      PYGXDYAABXBXSWRPQRSXBCOZXFXAWNYHXCWQXEWTXBCWPPYHXDWSABXBCWRPQRSWNXIXGWLXI
      WMWLXHABUHXIXHABWRUIUJXHABUKUOULUMXPYDTXKUDKWNXOYCXOXTXNTWNYCXTXLXNXTXKXR
      WPXTUPUNUQWNXTXNYBWNXTXNYBTXNXKGMZLZGBNZWNXTJZYBXMYJAGBWRYIXKURUSYLXQHMZK
      ZHBNZYKYBYLXQWPKZYOYLXRWPLYPYLXKXRWPWNXTUTVAXQWPFVBVGVCHXQBVDVEYOYKJYNYJJ
      ZGBNHBNYLYBYNYJHGBBVFYLYQYBHGBBYLYMBKZYIBKZJZYQYBYLYTYQJZJZYIYMUGZBKZXSUU
      CLZYBUUBWMYSYRUUDWLWMXTUUAVHYLYRYSYQVIYLYRYSYQVJBYIYMVKVQUUBYJXRYMLUUEYLY
      TYNYJVLUUBXQYMYLYTYNYJVMVNXKYIXRYMVOVRYAUUEAUUCBWRUUCXSURVPVRVSVTWAWBWCWD
      WEWFWGWHWIWJWK $.
  $}

  ${
    $d c f w x y z A $.  $d c f w x y z B $.  $d c f w z ph $.
    $( If for every element of a finite indexing set ` A ` there exists a
       corresponding element of another set ` B ` , then there exists a finite
       subset of ` B ` consisting only of those elements which are indexed by
       ` A ` .  Proven without the Axiom of Choice, unlike ~ indexdom .
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    indexfi $p |- ( ( A e. Fin /\ B e. M /\ A. x e. A E. y e. B ph ) ->
                E. c e. Fin ( c C_ B /\ A. x e. A E. y e. c ph /\
                                                A. y e. c E. x e. A ph ) ) $=
      ( vf vz vw cfn wcel wrex wral cv wa wsbc nfv dfsbcq syl wss w3a wf cbvrex
      cfv wex nfsbc1v sbceq1a ralbii ac6sfi sylan2b crn wfo simpll wfn ad2antrl
      ffn dffn4 sylib syl2anc frn wi fnfvelrn sylan rspesbca ex ralimdva adantl
      fofi imp simpr simprr weq wceq wb fveq2 cbvral r19.21bi ralrimiva rexbidv
      bitrd ralrn mpbird nfcv nfrex sylibr sseq1 rexeq ralbidv 3anbi123d rspcev
      raleq syl13anc exlimddv 3adant2 ) DKLZACEMZBDNZGOZEUAZACWSMZBDNZABDMZCWSN
      ZUBZGKMZEFLWPWRPZDEHOZUCZACBOZXHUEZQZBDNZPZXFHWRWPACIOZQZIEMZBDNXNHUFWQXQ
      BDAXPCIEAIRACXOUGZACXOUHZUDUIXPXLBIDEHACXOXKSUJUKXGXNPZXHULZKLZYAEUAZACYA
      MZBDNZXCCYANZXFXTWPDYAXHUMZYBWPWRXNUNXTXHDUOZYGXIYHXGXMDEXHUQZUPZDXHURUSD
      YAXHVIUTXIYCXGXMDEXHVAUPXNYEXGXIXMYEXIXLYDBDXIXJDLZPXKYALZXLYDVBXIYHYKYLY
      IDXJXHVCVDYLXLYDACXKYAVEVFTVGVJVHXTXPBDMZIYANZYFXTYNACJOZXHUEZQZBDMZJDNZX
      TYRJDXTYODLZPYTYQBYOQZYRXTYTVKXTUUAJDXTXMUUAJDNXGXIXMVLXLUUABJDXLJRYQBYOU
      GBJVMZXLYQUUAUUBXKYPVNXLYQVOXJYOXHVPACXKYPSTYQBYOUHWAVQUSVRYQBYODVEUTVSXT
      YHYNYSVOYJYMYRIJDXHXOYPVNXPYQBDACXOYPSVTWBTWCXCYMCIYAXCIRXPCBDCDWDXRWECIV
      MAXPBDXSVTVQWFXEYCYEYFUBGYAKWSYAVNZWTYCXBYEXDYFWSYAEWGUUCXAYDBDACWSYAWHWI
      XCCWSYAWLWJWKWMWNWO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Finite intersections
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c fi $.
  $( Extend class notation with the function whose value is the class of all
     the finite intersections of the elements of a given set. $)
  cfi $a class fi $.

  ${
    $d x y z $.
    $( Function whose value is the class of all the finite intersections of the
       elements of ` x ` .  (Contributed by FL, 27-Apr-2008.) $)
    df-fi $a |- fi = ( x e. _V |-> { z |
                  E. y e. ( ~P x i^i Fin ) z = |^| y } ) $.
  $}

  ${
    $d x y z A $.  $d x y B $.  $d x V $.  $d x W $.
    $( The set of all the finite intersections of the elements of ` A ` .
       (Contributed by FL, 27-Apr-2008.)  (Revised by Mario Carneiro,
       24-Nov-2013.) $)
    fival $p |- ( A e. V -> ( fi ` A ) = { y |
                  E. x e. ( ~P A i^i Fin ) y = |^| x } ) $=
      ( vz wcel cvv cv cint wceq cpw cfn cin wrex cab cfi cfv elex wss sylibr
      wa simpr c0 wne inss1 sseli elpwid vex eleq1 mpbii intex intssuni2 syl2an
      cuni eqsstrd elpw rexlimiva abssi uniexg pwexg ssexg sylancr pweq rexeqdv
      syl ineq1d abbidv df-fi fvmptg syl2anc ) CDFZCGFBHZAHZIZJZACKZLMZNZBOZGFZ
      CPQVSJCDRVKVSCUNZKZSWBGFZVTVRBWBVOVLWBFZAVQVMVQFZVOUAZVLWASWDWFVLVNWAWEVO
      UBWEVMCSVMUCUDZVNWASVOWEVMCVQVPVMVPLUEUFUGVOVNGFZWGVOVLGFWHBUHZVLVNGUIUJV
      MUKTVMCULUMUOVLWAWIUPTUQURVKWAGFWCCDUSWAGUTVEVSWBGVAVBECVOAEHZKZLMZNZBOVS
      GGPWJCJZWMVRBWNVOAWLVQWNWKVPLWJCVCVFVDVGEABVHVIVJ $.

    $( Specific properties of an element of ` ( fi `` B ) ` .  (Contributed by
       FL, 27-Apr-2008.)  (Revised by Mario Carneiro, 24-Nov-2013.) $)
    elfi $p |- ( ( A e. V /\ B e. W ) -> ( A e. ( fi ` B ) <->
        E. x e. ( ~P B i^i Fin ) A = |^| x ) ) $=
      ( vy wcel cfi cfv cv cint wceq cpw cfn cin wrex cab fival eleq2d eqeq1
      rexbidv elabg sylan9bbr ) CEGZBCHIZGBFJZAJKZLZACMNOZPZFQZGBDGBUGLZAUIPZUD
      UEUKBAFCERSUJUMFBDUFBLUHULAUIUFBUGTUAUBUC $.

    $( The empty intersection need not be considered in the set of finite
       intersections.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    elfi2 $p |- ( B e. V -> ( A e. ( fi ` B ) <->
        E. x e. ( ( ~P B i^i Fin ) \ { (/) } ) A = |^| x ) ) $=
      ( wcel cvv cfi cfv cv cint wceq cpw cfn c0 wrex wi a1i wa simpr ancom cin
      csn cdif elex wne eldifsni adantr intex sylib eqeltrd rexlimiva elfi vprc
      wb elsni inteqd syl6eq eleq1d mtbiri simpll eqeltrrd nsyl3 biantrud eldif
      wn int0 syl6bbr pm5.32da 3bitr4g rexbidv2 bitrd expcom pm5.21ndd ) CDEZBF
      EZBCGHZEZBAIZJZKZACLMUAZNUBZUCZOZVQVOPVNBVPUDQWDVOPVNVTVOAWCVRWCEZVTRZBVS
      FWEVTSWFVRNUEZVSFEZWEWGVTVRWANUFUGVRUHUIUJUKQVOVNVQWDUNVOVNRZVQVTAWAOWDAB
      CFDULWIVTVTAWAWCWIVTVRWAEZRVTWERWJVTRWFWIVTWJWEWIVTRZWJWJVRWBEZVEZRWEWKWM
      WJWLWHWKWLWHFFEUMWLVSFFWLVSNJFWLVRNVRNUOUPVFUQURUSWKBVSFWIVTSVOVNVTUTVAVB
      VCVRWAWBVDVGVHWJVTTWEVTTVIVJVKVLVM $.

    $( Sufficient condition for an element of ` ( fi `` B ) ` .  (Contributed
       by Mario Carneiro, 24-Nov-2013.) $)
    elfir $p |- ( ( B e. V /\ ( A C_ B /\ A =/= (/) /\ A e. Fin ) ) ->
        |^| A e. ( fi ` B ) ) $=
      ( vx wcel wss c0 wne cfn w3a wa cint cfi cfv cv wceq cpw cin wrex cvv imp
      simp1 elpw2g syl5ibr simpr3 elin sylanbrc eqid inteq eqeq2d sylancl simp2
      rspcev wb intex sylib id elfi syl2anr mpbird ) BCEZABFZAGHZAIEZJZKZALZBMN
      EZVGDOZLZPZDBQZIRZSZVFAVMEZVGVGPZVNVFAVLEZVDVOVAVEVQVEVQVAVBVBVCVDUBABCUC
      UDUAVAVBVCVDUEAVLIUFUGVGUHVKVPDAVMVIAPVJVGVGVIAUIUJUMUKVEVGTEZVAVHVNUNVAV
      EVCVRVBVCVDULAUOUPVAUQDVGBTCURUSUT $.

    $( Sufficient condition for the intersection of the range of a function to
       be in the set of finite intersections.  (Contributed by Mario Carneiro,
       30-Aug-2015.) $)
    intrnfi $p |- ( ( B e. V /\ ( F : A --> B /\ A =/= (/) /\ A e. Fin ) )
        -> |^| ran F e. ( fi ` B ) ) $=
      ( wcel wf c0 wne cfn w3a crn wss cint cfi cfv wa simpr1 frn syl sylib cdm
      wceq fdm simpr2 eqnetrd dm0rn0 necon3bii wfo simpr3 wfn ffn dffn4 syl2anc
      fofi 3jca elfir syldan ) BDEZABCFZAGHZAIEZJZCKZBLZVCGHZVCIEZJVCMBNOEURVBP
      ZVDVEVFVGUSVDURUSUTVAQZABCRSVGCUAZGHVEVGVIAGVGUSVIAUBVHABCUCSURUSUTVAUDUE
      VIGVCGCUFUGTVGVAAVCCUHZVFURUSUTVAUIVGCAUJZVJVGUSVKVHABCUKSACULTAVCCUNUMUO
      VCBDUPUQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C $.
    $( An indexed intersection of elements of ` C ` is an element of the finite
       intersections of ` C ` .  (Contributed by Mario Carneiro,
       30-Aug-2015.) $)
    iinfi $p |- ( ( C e. V /\ ( A. x e. A B e. C /\ A =/= (/) /\ A e. Fin ) )
        -> |^|_ x e. A B e. ( fi ` C ) ) $=
      ( vy wcel wral c0 wne cfn w3a wa ciin cmpt crn cint cfi cfv wceq wrex cab
      simpr1 dfiin2g syl eqid rnmpt inteqi syl6eqr fmpt 3anbi1i intrnfi sylan2b
      cv wf eqeltrd ) DEGZCDGABHZBIJZBKGZLZMZABCNZABCOZPZQZDRSZVBVCFUNCTABUAFUB
      ZQZVFVBURVCVITUQURUSUTUCAFBCDUDUEVEVHAFBCVDVDUFZUGUHUIVAUQBDVDUOZUSUTLVFV
      GGURVKUSUTABDCVDVJUJUKBDVDEULUMUP $.
  $}

  ${
    $d p A $.  $d p B $.  $d p V $.  $d p X $.
    $( The interesection of two sets is a finite intersection.  (Contributed by
       Thierry Arnoux, 6-Jan-2017.) $)
    inelfi $p |- ( ( X e. V /\ A e. X /\ B e. X )
      -> ( A i^i B ) e. ( fi ` X ) ) $=
      ( vp wcel w3a cin cfi cfv cint wceq cpw cfn wrex cpr 3adant1 syl2anc cvv
      cv prelpwi prfi elin sylanbrc intprg eqcomd inteq eqeq2d rspcev wb inex1g
      a1i 3ad2ant2 simp1 elfi mpbird ) DCFZADFZBDFZGZABHZDIJFZVAETZKZLZEDMZNHZO
      ZUTABPZVGFZVAVIKZLZVHUTVIVFFZVINFZVJURUSVMUQABDUAQVNUTABUBULVIVFNUCUDUTVK
      VAURUSVKVALUQABDDUEQUFVEVLEVIVGVCVILVDVKVAVCVIUGUHUIRUTVASFZUQVBVHUJURUQV
      OUSABDUKUMUQURUSUNEVADSCUORUP $.
  $}

  ${
    $d A x y $.  $d x V $.
    $( Any element of a set ` A ` is the intersection of a finite subset of
       ` A ` .  (Contributed by FL, 27-Apr-2008.)  (Proof shortened by Mario
       Carneiro, 21-Mar-2015.) $)
    ssfii $p |- ( A e. V -> A C_ ( fi ` A ) ) $=
      ( vx wcel cfi cfv cv wa csn cint vex intsn wss c0 wne cfn simpl simpr a1i
      snssd snnz snfi elfir syl13anc syl5eqelr ex ssrdv ) ABDZCAAEFZUHCGZADZUJU
      IDUHUKHZUJUJIZJZUIUJCKZLULUHUMAMUMNOZUMPDZUNUIDUHUKQULUJAUHUKRTUPULUJUOUA
      SUQULUJUBSUMABUCUDUEUFUG $.

    $( The set of finite intersections of the empty set.  (Contributed by Mario
       Carneiro, 30-Aug-2015.) $)
    fi0 $p |- ( fi ` (/) ) = (/) $=
      ( vy vx c0 cfi cfv cv cint wceq cpw cfn cin wrex cab cvv wcel fival ax-mp
      0ex vprc id inss1 sseli elpwi 3syl inteqd int0 syl6eq sylan9eqr rexlimiva
      wss ss0 vex syl6eqelr mto abf eqtri ) CDEZAFZBFZGZHZBCIZJKZLZAMZCCNOUQVEH
      RBACNPQVDAVDNNOSVDNURNVAURNHBVCVAUSVCOZURUTNVATVFUTCGNVFUSCVFUSVBOUSCUJUS
      CHVCVBUSVBJUAUBUSCUCUSUKUDUEUFUGUHUIAULUMUNUOUP $.

    $( If ` A ` is not empty, the class of all the finite intersections of
       ` A ` is not empty either.  (Contributed by FL, 27-Apr-2008.)  (Revised
       by Mario Carneiro, 24-Nov-2013.) $)
    fieq0 $p |- ( A e. V -> ( A = (/) <-> ( fi ` A ) = (/) ) ) $=
      ( wcel c0 wceq cfi cfv fveq2 fi0 syl6eq wss ssfii sseq0 sylan ex impbid2
      ) ABCZADEZAFGZDEZRSDFGDADFHIJQTRQASKTRABLASMNOP $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( The elements of ` ( fi `` C ) ` are closed under finite intersection.
       (Contributed by Mario Carneiro, 24-Nov-2013.) $)
    fiin $p |- ( ( A e. ( fi ` C ) /\ B e. ( fi ` C ) ) ->
                 ( A i^i B ) e. ( fi ` C ) ) $=
      ( vz vx vy cfi wcel wa cin cv cint wceq cfn wrex cvv wb elfi elin wss cfv
      cpw elfvex mpdan ibi adantr simpr ancoms sylan mpbid wi cun elpwi anim12i
      unss sylib unex elpw sylibr unfi an4s syl2anb ineq12 intun syl6eqr eqeq2d
      vex inteq rspcev syl2an rexlimdvaa rexlimiva sylc inex1g syl2anc mpbird )
      ACGUAZHZBVQHZIZABJZVQHZWADKZLZMZDCUBZNJZOZVTAEKZLZMZEWGOZBFKZLZMZFWGOZWHV
      RWLVSVRWLVRCPHZVRWLQACGUCZEACVQPRUDUEUFVTVSWPVRVSUGVRWQVSVSWPQZWRVSWQWSFB
      CVQPRUHUIUJWKWPWHUKEWGWIWGHZWKIWOWHFWGWTWMWGHZWKWOWHWTXAIZWIWMULZWGHZWAXC
      LZMZWHWKWOIZXBXCWFHZXCNHZIZXDWTWIWFHZWINHZIWMWFHZWMNHZIXJXAWIWFNSWMWFNSXK
      XMXLXNXJXKXMIZXHXLXNIXIXOXCCTZXHXOWICTZWMCTZIXPXKXQXMXRWICUMWMCUMUNWIWMCU
      OUPXCCWIWMEVGFVGUQURUSWIWMUTUNVAVBXCWFNSUSXGWAWJWNJXEAWJBWNVCWIWMVDVEWEXF
      DXCWGWCXCMWDXEWAWCXCVHVFVIVJVAVKVLVMVRWBWHQZVSVRWAPHWQXSABVQVNWRDWACPPRVO
      UFVP $.
  $}

  ${
    $d t x y z A $.  $d x y z B $.  $d y z V $.
    $( The set of finite intersections is the smallest set that contains ` A `
       and is closed under pairwise intersection.  (Contributed by Mario
       Carneiro, 24-Nov-2013.) $)
    dffi2 $p |- ( A e. V -> ( fi ` A ) =
        |^| { z | ( A C_ z /\ A. x e. z A. y e. z ( x i^i y ) e. z ) } ) $=
      ( vt wcel cvv cfi cv wss cin wral wa cint wceq wi wal cfn w3a cfv cab cpw
      elex wrex wb vex elfi mpan biimpd wex df-rex wne fiint inss1 sseli elpwid
      3ad2ant2 simp1 sstrd eleq1 mpbii intex sylibr 3ad2ant3 3jca 3expib pm2.27
      inss2 syl6 biimprd adantl a1i syldd com23 alimdv syl5bi imp 19.23v sylan9
      c0 sylib ssrdv ex alrimiv ssintab ssfii fiin rgen2a fvex sseq2 raleqbi1dv
      eleq2 anbi12d elab sylanbrc intss1 syl eqssd ) DEGDHGZDIUAZDCJZKZAJZBJZLZ
      XBGZBXBMZAXBMZNZCUBZOZPDEUDWTXAXLWTXJXAXBKZQZCRXAXLKWTXNCWTXJXMWTXJNFXAXB
      WTFJZXAGZXOXDOZPZADUCZSLZUEZXJXOXBGZWTXPYAXOHGZWTXPYAUFFUGZAXODHHUHUIUJYA
      XDXTGZXRNZAUKZXJYBXRAXTULXJYFYBQZARZYGYBQXCXIYIXIXDXBKZXDWAUMZXDSGZTZXQXB
      GZQZARXCYIABXBUNXCYOYHAXCYFYOYBXCYFYOYNYBXCYFYMYOYNQXCYEXRYMXCYEXRTZYJYKY
      LYPXDDXBYEXCXDDKXRYEXDDXTXSXDXSSUOUPUQURXCYEXRUSUTXRXCYKYEXRXQHGZYKXRYCYQ
      YDXOXQHVAVBXDVCVDVEYEXCYLXRXTSXDXSSVIUPURVFVGYMYNVHVJYFYNYBQZQXCXRYRYEXRY
      BYNXOXQXBVAVKVLVMVNVOVPVQVRYFYBAVSWBVQVTWCWDWEXJCXAWFVDWTXAXKGZXLXAKWTDXA
      KZXFXAGZBXAMZAXAMZYSDHWGUUCWTUUAABXAXDXEDWHWIVMXJYTUUCNCXADIWJXBXAPXCYTXI
      UUCXBXADWKXHUUBAXBXAXGUUABXBXAXBXAXFWMWLWLWNWOWPXAXKWQWRWSWR $.

    $( Subset relationship for function ` fi ` .  (Contributed by Jeff Hankins,
       7-Oct-2009.)  (Revised by Mario Carneiro, 24-Nov-2013.) $)
    fiss $p |- ( ( B e. V /\ A C_ B ) -> ( fi ` A ) C_ ( fi ` B ) ) $=
      ( vy vx vz wcel wss wa cv cin wral cab cint cfi cfv syl cvv wceq dffi2 wi
      sstr2 adantl anim1d ss2abdv intss ssexg ancoms adantr 3sstr4d ) BCGZABHZI
      ZADJZHZEJFJKUNGFUNLEUNLZIZDMZNZBUNHZUPIZDMZNZAOPZBOPZUMVBURHUSVCHUMVAUQDU
      MUTUOUPULUTUOUAUKABUNUBUCUDUEVBURUFQUMARGZVDUSSULUKVFABCUGUHEFDARTQUKVEVC
      SULEFDBCTUIUJ $.

    $( A set which is closed under pairwise intersection is closed under finite
       intersection.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by
       Mario Carneiro, 24-Nov-2013.) $)
    inficl $p |- ( A e. V ->
        ( A. x e. A A. y e. A ( x i^i y ) e. A <-> ( fi ` A ) = A ) ) $=
      ( vz wcel cv cin wral cfi cfv wceq wss ssfii wa cab cint eleq2 raleqbi1dv
      eqimss2 bitr3d elabg intss1 syl6bir dffi2 sseq1d sylibrd eqss simplbi2com
      biantrurd sylsyld fiin rgen2a mpbii impbid1 ) CDFZAGZBGZHZCFZBCIZACIZCJKZ
      CLZUPCVCMZVBVCCMZVDCDNUPVBCEGZMZUSVGFZBVGIZAVGIZOZEPZQZCMZVFUPVBCVMFVOVLV
      BECDVGCLZVKVLVBVPVHVKCVGTUJVJVAAVGCVIUTBVGCVGCUSRSSUAUBCVMUCUDUPVCVNCABEC
      DUEUFUGVDVFVEVCCUHUIUKVDUSVCFZBVCIZAVCIVBVQABVCUQURCULUMVRVAAVCCVQUTBVCCV
      CCUSRSSUNUO $.

    $( The set of finite intersections of a set is contained in the powerset of
       the union of the elements of ` A ` .  (Contributed by Mario Carneiro,
       24-Nov-2013.)  (Proof shortened by Mario Carneiro, 21-Mar-2015.) $)
    fipwuni $p |- ( fi ` A ) C_ ~P U. A $=
      ( vx vy cvv wcel cfi cfv cuni cpw wss uniexg pwexg syl pwuni fiss sylancl
      cv cin wral elpw wceq ssinss1 inex1 3imtr4i adantr rgen2a wb inficl mpbii
      vex sseqtrd wn c0 fvprc 0ss syl6eqss pm2.61i ) ADEZAFGZAHZIZJURUSVAFGZVAU
      RVADEZAVAJUSVBJURUTDEVCADKUTDLMZANAVADOPURBQZCQZRZVAEZCVASBVASZVBVAUAZVHB
      CVAVEVAEZVHVFVAEVEUTJVGUTJVKVHVEVFUTUBVEUTBUJZTVGUTVEVFVLUCTUDUEUFURVCVIV
      JUGVDBCVADUHMUIUKURULUSUMVAAFUNVAUOUPUQ $.

    $( A singleton is closed under finite intersections.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    fisn $p |- ( fi ` { A } ) = { A } $=
      ( vx vy cv cin csn wcel wral cfi cfv wceq wa elsni ineqan12d inidm syl6eq
      vex inex1 elsnc cvv sylibr rgen2a wb snex inficl ax-mp mpbi ) BDZCDZEZAFZ
      GZCUKHBUKHZUKIJUKKZULBCUKUHUKGZUIUKGZLZUJAKULUQUJAAEAUOUPUHAUIAUHAMUIAMNA
      OPUJAUHUIBQRSUAUBUKTGUMUNUCAUDBCUKTUEUFUG $.
  $}

  $( The union of the finite intersections of a set is simply the union of the
     set itself.  (Contributed by Jeff Hankins, 5-Sep-2009.)  (Revised by Mario
     Carneiro, 24-Nov-2013.) $)
  fiuni $p |- ( A e. V -> U. A = U. ( fi ` A ) ) $=
    ( wcel cuni cfi cfv ssfii unissd wss cpw fipwuni unissi unipw sseqtri eqssd
    a1i ) ABCZADZAEFZDZQASABGHTRIQTRJZDRSUAAKLRMNPO $.

  $( If a set is a family of subsets of some base set, then so is its finite
     intersection.  (Contributed by Stefan O'Rear, 2-Aug-2015.) $)
  fipwss $p |- ( A C_ ~P X -> ( fi ` A ) C_ ~P X ) $=
    ( cvv wcel cpw wss cfi cuni fiuni sseq1d sspwuni 3bitr4g biimpa wn c0 fvprc
    cfv 0ss syl6eqss adantr pm2.61ian ) ACDZABEZFZAGQZUCFZUBUDUFUBAHZBFUEHZBFUD
    UFUBUGUHBACIJABKUEBKLMUBNZUFUDUIUEOUCAGPUCRSTUA $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d x y z K $.
    $( A finite intersection of elements taken from a union of collections.
       (Contributed by Jeff Hankins, 15-Nov-2009.)  (Proof shortened by Mario
       Carneiro, 26-Nov-2013.) $)
    elfiun $p |- ( ( B e. D /\ C e. K ) -> ( A e. ( fi ` ( B u. C ) ) <-> ( A
    e. ( fi ` B ) \/ A e. ( fi ` C ) \/ E. x e. ( fi ` B ) E. y e. ( fi ` C ) A
    = ( x i^i y ) ) ) ) $=
      ( wcel wa cin wceq wrex cvv wi 3expib cfn c0 wss cdif syl cun cfi cfv w3o
      vz cv elex adantl simpll simplr 3jca 3anim1i inex1 eleq1 mpbiri rexlimivv
      w3a vex a1i 3jaoi impcom cint cpw wb simp1 unexg 3adant1 elfi syl2anc wne
      simpl1 intex syl6bbr syl5ibcom nne simp23 simp3l inss1 sseli reldisj 3syl
      elpwid mpbid uncom difeq1i difun2 eqtri difss eqsstri syl6ss simp3r inss2
      wn elfir syl13anc 3mix2 sylbi simp22 3mix1 simp1l ssfi sylancl indi df-ss
      simp1r biimpi syl5reqr inteqd intun syl6eq ineq1 eqeq2d ineq2 3mix3 ecase
      rspc2ev syl3anc eqeq1 2rexbidv 3orbi123d syl5ibrcom expr rexlimdva sylbid
      com23 mpdd ssun1 fiss sseld ssun2 fiin eleq1a syl6 rexlimdvv 3jaod impbid
      anim12d pm5.21nd ) DFHZEGHZIZCDEUAZUBUCZHZCDUBUCZHZCEUBUCZHZCAUFZBUFZJZKZ
      BUUGLAUUELZUDZCMHZYSYTUQZUUAUUDIUUOYSYTUUDUUOUUACUUCUGUHYSYTUUDUIYSYTUUDU
      JUKUUNUUAUUPUUFUUAUUPNUUHUUMUUFYSYTUUPUUFUUOYSYTCUUEUGULOUUHYSYTUUPUUHUUO
      YSYTCUUGUGULOUUMYSYTUUPUUMUUOYSYTUULUUOABUUEUUGUULUUONUUIUUEHZUUJUUGHZIZU
      ULUUOUUKMHUUIUUJAURUMCUUKMUNUOUSUPULOUTVAUUPUUDUUNUUPUUDCUEUFZVBZKZUEUUBV
      CZPJZLZUUNUUPUUOUUBMHZUUDUVEVDUUOYSYTVEYSYTUVFUUODEFGVFZVGUECUUBMMVHVIUUP
      UVBUUNUEUVDUUPUUTUVDHZIZUVBUUTQVJZUUNUVIUUOUVBUVJUUOYSYTUVHVKUVBUUOUVAMHU
      VJCUVAMUNUUTVLVMVNUVIUVJUVBUUNUUPUVHUVJUVBUUNNUUPUVHUVJIZIZUUNUVBUVAUUEHZ
      UVAUUGHZUVAUUKKZBUUGLAUUELZUDZUUTDJZQVJZUUTEJZQVJZUVLUVQNZUVSWMUVRQKZUWBU
      VRQVOUWCUUPUVKUVQUWCUUPUVKUQZUVNUVQUWDYTUUTERUVJUUTPHZUVNUWCUUOYSYTUVKVPU
      WDUUTUUBDSZEUWDUWCUUTUWFRZUWCUUPUVKVEUWDUVHUUTUUBRZUWCUWGVDUWCUUPUVHUVJVQ
      ZUVHUUTUUBUVDUVCUUTUVCPVRVSWBZUUTDUUBVTWAWCUWFEDSZEUWFEDUAZDSUWKUUBUWLDDE
      WDWEEDWFWGEDWHWIWJUWCUUPUVHUVJWKUWDUVHUWEUWIUVDPUUTUVCPWLVSZTUUTEGWNWOUVN
      UVMUVPWPTOWQUWAWMUVTQKZUWBUVTQVOUWNUUPUVKUVQUWNUUPUVKUQZUVMUVQUWOYSUUTDRU
      VJUWEUVMUWNUUOYSYTUVKWRUWOUUTUUBESZDUWOUWNUUTUWPRZUWNUUPUVKVEUWOUVHUWHUWN
      UWQVDUWNUUPUVHUVJVQZUWJUUTEUUBVTWAWCUWPDESDDEWFDEWHWIWJUWNUUPUVHUVJWKUWOU
      VHUWEUWRUWMTUUTDFWNWOUVMUVNUVPWSTOWQUVSUWAIZUUPUVKUVQUWSUUPUVKUQZUVPUVQUW
      TUVRVBZUUEHZUVTVBZUUGHZUVAUXAUXCJZKZUVPUWTYSUVRDRZUVSUVRPHZUXBUWSUUOYSYTU
      VKWRUXGUWTUUTDWLUSUVSUWAUUPUVKWTUWTUWEUVRUUTRUXHUWTUVHUWEUWSUUPUVHUVJVQZU
      WMTZUUTDVRUUTUVRXAXBUVRDFWNWOUWTYTUVTERZUWAUVTPHZUXDUWSUUOYSYTUVKVPUXKUWT
      UUTEWLUSUVSUWAUUPUVKXEUWTUWEUVTUUTRUXLUXJUUTEVRUUTUVTXAXBUVTEGWNWOUWTUVHU
      WHUXFUXIUWJUWHUVAUVRUVTUAZVBUXEUWHUUTUXMUWHUXMUUTUUBJZUUTUUTDEXCUWHUXNUUT
      KUUTUUBXDXFXGXHUVRUVTXIXJWAUVOUXFUVAUXAUUJJZKABUXAUXCUUEUUGUUIUXAKUUKUXOU
      VAUUIUXAUUJXKXLUUJUXCKUXOUXEUVAUUJUXCUXAXMXLXPXQUVPUVMUVNXNTOXOUVBUUFUVMU
      UHUVNUUMUVPCUVAUUEUNCUVAUUGUNUVBUULUVOABUUEUUGCUVAUUKXRXSXTYAYBYEYFYCYDUU
      PUUFUUDUUHUUMUUPUUEUUCCYSYTUUEUUCRZUUOUUAUVFDUUBRUXPUVGDEYGDUUBMYHXBVGZYI
      UUPUUGUUCCYSYTUUGUUCRZUUOUUAUVFEUUBRUXRUVGEDYJEUUBMYHXBVGZYIUUPUULUUDABUU
      EUUGUUPUUSUUIUUCHZUUJUUCHZIZUULUUDNZUUPUUQUXTUURUYAUUPUUEUUCUUIUXQYIUUPUU
      GUUCUUJUXSYIYQUYBUUKUUCHUYCUUIUUJUUBYKUUKUUCCYLTYMYNYOYPYR $.
  $}

  ${
    $d a b c d m n v x y A $.  $d a b c d m n v x y R $.  $d c d m n x y V $.
    $d a b u v y z $.
    dffi3.1 $e |- R = ( u e. _V |->
      ran ( y e. u , z e. u |-> ( y i^i z ) ) ) $.
    $( The set of finite intersections can be "constructed" inductively by
       iterating binary intersection ` om ` -many times.  (Contributed by Mario
       Carneiro, 21-Mar-2015.) $)
    dffi3 $p |- ( A e. V -> ( fi ` A ) = U. ( rec ( R , A ) " om ) ) $=
      ( vx vn va vb vv wcel com cv wss wral wa wceq cvv vc vd cfi cfv crdg cres
      vm crn cuni cima cin cab cint dffi2 fr0g wfn frfnom peano1 fnfvelrn mp2an
      c0 syl6eqelr elssuni syl wrex ciun reeanv eliun anbi12i wb fniunfv eleq2d
      anbi12d ax-mp 3bitr2i cun wi word ordunel adantl simprl jca weq con0 nnon
      ordom csuc fveq2 sseq1d sseq2d raleqbi1dv eqsstrd cmpt2 eqidd ineq1 ineq2
      ad2antlr eqeq2d syl6eq rspc2ev syl3anc eqid rnmpt2 sylibr fvex uniex pwex
      cpw cxp wf adantr syl5ss vex inex1 elpw rgen2a fmpt2 mpbi ssexi nfcv cmpt
      frn mpt2eq12 anidms rneqd frsucmpt sylancl ralimdv ssralv sylib ralrimiva
      ex a1i sseq2 imbi12d sseq1 rspc2v syl3c sseld simprr mp3an1 onsseleq rzal
      wo syl2anc biantrud bitr3d ssfii csn id inidm abeq2i ssriv simpl cbvmpt2v
      inss1 cbvmptv eqtri rdgeq1 reseq1i syl5sseqr syl5com jctird df-suc raleqi
      sstr2 ralsn ralunb syl6ibr fiin syld mpi jctild expimpd a1d finds2 impcom
      bitri simprd r19.21bi eqimss jaod sylbid ssun1 ssun2 peano2 ssiun2s eqeq1
      3syl 2rexbidv elab syl6eleqr eleqtrrd sseldd syl6eleq rexlimdvva sylan2br
      syl2and imp ralrimivva simpld elpw2 sylancr sspwuni ssexg eleq2 mpbir2and
      fnfvrnss elabg intss1 eqssd df-ima unieqi syl6eqr ) DFMZDUCUDZEDUEZNUFZUH
      ZUIZUXQNUJZUIUXOUXPUXTUXOUXPDHOZPZUAOZUBOZUKZUYBMZUBUYBQZUAUYBQZRZHULZUMZ
      UXTUAUBHDFUNUXOUXTUYKMZUYLUXTPUXOUYMDUXTPZUYFUXTMZUBUXTQZUAUXTQZUXODUXSMU
      YNUXODVAUXRUDZUXSDFEUOZUXRNUPZVANMUYRUXSMDEUQZURNVAUXRUSUTVBDUXSVCVDUXOUY
      OUAUBUXTUXTUYDUXTMZUYEUXTMZRZUXOUYDUGOZUXRUDZMZUYEIOZUXRUDZMZRZINVEUGNVEZ
      UYOVULVUGUGNVEZVUJINVEZRUYDUGNVUFVFZMZUYEINVUIVFZMZRZVUDVUGVUJUGINNVGVUPV
      UMVURVUNUGUYDNVUFVHIUYENVUIVHVIUYTVUSVUDVJVUAUYTVUPVUBVURVUCUYTVUOUXTUYDU
      GNUXRVKVLUYTVUQUXTUYEINUXRVKVLVMVNVOUXOVULUYOUXOVUKUYOUGINNUXOVUENMZVUHNM
      ZRZRZVUGUYDVUEVUHVPZUXRUDZMZVUJUYEVVEMZUYOVVCVUFVVEUYDVVCVVDNMZVUTRAOZUYB
      PZVVIUXRUDZUYBUXRUDZPZVQZANQZHNQZVUEVVDPZVUFVVEPZVVCVVHVUTVVBVVHUXONVRVUT
      VVAVVHWFNVUEVUHVSUUAZVTZUXOVUTVVAWAWBUXOVVPVVBUXOVVOHNUXOUYBNMZRZVVNANVWB
      VVINMZRZVVJVVIUYBMZAHWCZUUDZVVMVWDVVIWDMZUYBWDMZVVJVWGVJVWCVWHVWBVVIWEVTV
      WAVWIUXOVWCUYBWEWQVVIUYBUUBUUEVWDVWEVVMVWFVWBVWEVVMVQVWCVWBVWEVVMVWBVVMAU
      YBVWBVVLUXPPZVVMAUYBQZVWAUXOVWJVWKRZVWLUYRUXPPZVUIUXPPZVVKVUIPZAVUHQZRZVU
      HWGZUXRUDZUXPPZVVKVWSPZAVWRQZRZUXOHIUYBVASZVWJVWLVWMVXDVWKVWJVVMAUYBUUCUU
      FVXDVVLUYRUXPUYBVAUXRWHWIUUGHIWCZVWJVWNVWKVWPVXEVVLVUIUXPUYBVUHUXRWHZWIVV
      MVWOAUYBVUHVXEVVLVUIVVKVXFWJWKVMUYBVWRSZVWJVWTVWKVXBVXGVVLVWSUXPUYBVWRUXR
      WHZWIVVMVXAAUYBVWRVXGVVLVWSVVKVXHWJWKVMUXOUYRDUXPUYSDFUUHWLVVAVWQVXCVQUXO
      VVAVWNVWPVXCVVAVWNRZVWPVXBVWTVXIVWPVXAAVUHQZVXAAVUHUUIZQZRZVXBVXIVWPVXJVX
      LVXIVWOVXAAVUHVXIVUIVWSPZVWOVXAVXIJKVUIVUIJOZKOZUKZWMZUHZVUIVWSHVUIVXSUYB
      VUIMZUYBVXQSZKVUIVEJVUIVEZUYBVXSMVXTVXTVXTHHWCZVYBVXTUUJZVYDVXTUYBWNVYAVY
      CUYBUYBVXPUKZSJKUYBUYBVUIVUIJHWCVXQVYEUYBVXOUYBVXPWOWRKHWCZVYEUYBUYBVYFVY
      EUYBUYBUKUYBVXPUYBUYBWPUYBUUKWSWRWTXAVYBHVXSJKHVUIVUIVXQVXRVXRXBZXCUULXDU
      UMVXIVVAVXSTMVWSVXSSVVAVWNUUNVXSVUIUIZXHZVYHVUIVUHUXRXEXFXGVUIVUIXIZVYIVX
      RXJZVXSVYIPVXQVYIMZKVUIQJVUIQVYKVYLJKVUIVXOVUIMZVXPVUIMZRZVXQVYHPVYLVYOVX
      QVXOVYHVXOVXPUUPZVYMVXOVYHPVYNVXOVUIVCXKXLVXQVYHVXOVXPJXMXNZXOXDXPJKVUIVU
      IVXQVYIVXRVYGXQXRVYJVYIVXRYBVNXSLDVUHJKLOZVYRVXQWMZUHZVXSUXRTLDXTZLVUHXTL
      VXSXTUXQLTVYTYAZDUEZNEWUBSUXQWUCSECTABCOZWUDVVIBOZUKZWMZUHZYAWUBGCLTWUHVY
      TCLWCZWUGVYSWUIWUGABVYRVYRWUFWMZVYSWUIWUGWUJSABWUDWUDVYRVYRWUFYCYDABJKVYR
      VYRWUFVXQVXOWUEUKVVIVXOWUEWOWUEVXPVXOWPUUOWSYEUUQUURDEWUBUUSVNUUTZVYRVUIS
      ZVYSVXRWULVYSVXRSJKVYRVYRVUIVUIVXQYCYDYEYFYGZUVAZVVKVUIVWSUVFUVBYHVXIVXNV
      XLWUNVXAVXNAVUHIXMAIWCZVVKVUIVWSVVIVUHUXRWHZWIUVGXDUVCVXBVXAAVUHVXKVPZQVX
      MVXAAVWRWUQVUHUVDUVEVXAAVUHVXKUVHUVRUVIVXIVWSVXSUXPWUMVWNVXSUXPPZVVAVWNVY
      JUXPVXRXJZWURVWNVXQUXPMZKVUIQZJVUIQZWUSVWNWUTKUXPQZJUXPQZWVBWUTJKUXPVXOVX
      PDUVJXPVWNWVDWVAJUXPQWVBVWNWVCWVAJUXPWUTKVUIUXPYIYHWVAJVUIUXPYIUVKUVLJKVU
      IVUIVXQUXPVXRVYGXQYJVYJUXPVXRYBVDVTWLUVMUVNUVOUVPUVQZUVSUVTYLXKVWFVVMVQVW
      DVWFVVKVVLSVVMVVIUYBUXRWHVVKVVLUWAVDYMUWBUWCYKYKXKZVVQVVCVUEVUHUWDYMVVNVV
      QVVRVQVVIVVDPZVVKVVEPZVQZHAVVDVUENNUYBVVDSZVVJWVGVVMWVHUYBVVDVVIYNWVJVVLV
      VEVVKUYBVVDUXRWHWJYOZAUGWCZWVGVVQWVHVVRVVIVUEVVDYPWVLVVKVUFVVEVVIVUEUXRWH
      WIYOYQYRYSVVCVUIVVEUYEVVCVVHVVARVVPVUHVVDPZVUIVVEPZVVCVVHVVAVVTUXOVUTVVAY
      TWBWVFWVMVVCVUHVUEUWEYMVVNWVMWVNVQWVIHAVVDVUHNNWVKWUOWVGWVMWVHWVNVVIVUHVV
      DYPWUOVVKVUIVVEWUPWIYOYQYRYSVVCVVFVVGRZUYOVVCWVORZUYFHNVVLVFZUXTWVPVVDWGZ
      UXRUDZWVQUYFWVPVVHWVRNMWVSWVQPVVBVVHUXOWVOVVSWQZVVDUWFHNVVLWVRWVSUYBWVRUX
      RWHUWGUWIWVPUYFJKVVEVVEVXQWMZUHZWVSWVPUYFVYAKVVEVEJVVEVEZHULZWWBWVPUYFVXQ
      SZKVVEVEJVVEVEZUYFWWDMWVPVVFVVGUYFUYFSZWWFVVCVVFVVGWAVVCVVFVVGYTWVPUYFWNW
      WEWWGUYFUYDVXPUKZSJKUYDUYEVVEVVEJUAWCVXQWWHUYFVXOUYDVXPWOWRKUBWCWWHUYFUYF
      VXPUYEUYDWPWRWTXAWWCWWFHUYFUYDUYEUAXMXNUYBUYFSVYAWWEJKVVEVVEUYBUYFVXQUWHU
      WJUWKXDJKHVVEVVEVXQWWAWWAXBZXCUWLWVPVVHWWBTMWVSWWBSWVTWWBVVEUIZXHZWWJVVEV
      VDUXRXEXFXGVVEVVEXIZWWKWWAXJZWWBWWKPVXQWWKMZKVVEQJVVEQWWMWWNJKVVEVXOVVEMZ
      WWNVXPVVEMWWOVXQWWJPWWNWWOVXQVXOWWJVYPVXOVVEVCXLVXQWWJVYQXOXDXKXPJKVVEVVE
      VXQWWKWWAWWIXQXRWWLWWKWWAYBVNXSLDVVDVYTWWBUXRTWUALVVDXTLWWBXTWUKVYRVVESZV
      YSWWAWWPVYSWWASJKVYRVYRVVEVVEVXQYCYDYEYFYGUWMUWNUYTWVQUXTSVUAHNUXRVKVNUWO
      YLUWRUWPUWSUWQUWTUXOUXTTMZUYMUYNUYQRZVJUXOUXTUXPPZUXPTMWWQUXOUXSUXPXHZPZW
      WSUXOUYTVVLWWTMZHNQWXAVUAUXOWXBHNVWBVWJWXBVWBVWJVWKWVEUXAVVLUXPDUCXEZUXBX
      DYKHNWWTUXRUXHUXCUXSUXPUXDYJZWXCUXTUXPTUXEYGUYJWWRHUXTTUYBUXTSUYCUYNUYIUY
      QUYBUXTDYNUYHUYPUAUYBUXTUYGUYOUBUYBUXTUYBUXTUYFUXFWKWKVMUXIVDUXGUXTUYKUXJ
      VDWLWXDUXKUYAUXSUXQNUXLUXMUXN $.
  $}

  ${
    $d x y A $.  $d x F $.  $d x y V $.
    fifo.1 $e |- F = ( y e. ( ( ~P A i^i Fin ) \ { (/) } ) |-> |^| y ) $.
    $( Describe a surjection from nonempty finite sets to finite
       intersections.  (Contributed by Mario Carneiro, 18-May-2015.) $)
    fifo $p |- ( A e. V ->
      F : ( ( ~P A i^i Fin ) \ { (/) } ) -onto-> ( fi ` A ) ) $=
      ( vx wcel cpw cfn cin c0 csn cdif cfi wfo cv cvv sylib wceq wb cint intex
      cfv crn wfn wral wne eldifsni rgen fnmpt mp1i dffn4 elfi2 elrnmpt syl6bbr
      wrex vex ax-mp eqrdv foeq3 syl mpbird ) BDGZBHIJZKLMZBNUCZCOZVECUDZCOZVCC
      VEUEZVIAPZUAZQGZAVEUFVJVCVMAVEVKVEGVKKUGVMVKVDKUHVKUBRUIAVEVLCQEUJUKVECUL
      RVCVFVHSVGVITVCFVFVHVCFPZVFGVNVLSAVEUPZVNVHGZAVNBDUMVNQGVPVOTFUQAVEVLVNCQ
      EUNURUOUSVFVHVECUTVAVB $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Hall's marriage theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a b c d e f g h i j k $.

    $( Core induction for Philip Hall's marriage theorem.  (Contributed by
       Stefan O'Rear, 19-Feb-2015.) $)
    marypha1lem $p |- ( A e. Fin -> ( b e. Fin ->
          A. c e. ~P ( A X. b ) ( A. d e. ~P A d ~<_ ( c " d ) ->
              E. e e. ~P c e : A -1-1-> _V ) ) ) $=
      ( wcel cdom wbr cpw wral cvv wf1 wi wceq wa c0 sylib syl cin wss va vf vg
      vh vi vj vk cv cfn cima wrex cxp xpeq1 pweqd pweq raleqdv rexbidv imbi12d
      weq f1eq2 raleqbidv imbi2d wpss wal wne f1eq1 rspcev mp2an mpbiri a1i wex
      csdm n0 id imaeq2 breq12d rspcva 0sdom mpbir imaexg ax-mp adantl ad2antlr
      csn vex impr cdif difexg ad2antrl biimpi simprr psseq1 spv sylc pm2.61dne
      elpwi expr df-ss imaeq2d ineq1d indif2 crn rnxpss syl6ss difeq1d ad2antrr
      rnss syl5eq breqtrrd ralrimiva cbvralv adantllr inss2 difss adantr imaeq1
      elpw breq2d ralbidv rexeqdv mpd cbvrexv cun inss1 unssd elpw2 sylibr wf1o
      f1f1orn disjdif incom ssdisj sylancl syl22anc wb mpbid syl2anc rexlimdvaa
      exlimdv wn bi2.04 albii 19.21v bitri f10 snelpwi snnz snex sdomdomtr mpan
      0elpw expcom syl5 mp2b 0dom breq1 simpll difsnpss sspsstrd neeq1 domdifsn
      jca anbi12d adantlrr adantll imassrn syl5ss eqtrd imainrect syl5eqr xpss2
      sstri inex1 simpllr ad2antll spcv sylancr cop snssd ad2ant2lr f1osn eqtri
      elimasn f1oun snssi undif f1oeq2 f1of1 ssv f1ss exp3a syl5bi exanali cres
      ex simprll pssss sspwb simplrr ssralv resima2 eqcomd ralbiia ssres df-res
      simplrl inxp xpss12 eqsstri resex imaundi undif2 eqtr4i syl6breq cen ssfi
      simp-4l bren2 sylanbrc ensymd ssdifin0 syl6eq neeq1d biimpar disj4 bicomi
      domunfican necon1abii resss df-ima syl6sseqr imp sylan2br pm2.61dan exp32
      mp2d ralrimiv exp31 a2d findcard3 ) CUHZUIFZEUHZDUHZVUCUJZGHZEUAUHZIZJZVU
      GKBUHZLZBVUDIZUKZMZDVUGVUAULZIZJZMZVUBVUFEUBUHZIZJZVUSKVUJLZBVULUKZMZDVUS
      VUAULZIZJZMZVUBVUFEAIZJZAKVUJLZBVULUKZMZDAVUAULZIZJZMUAUBAUAUBUSZVUQVVGVU
      BVVQVUNVVDDVUPVVFVVQVUOVVEVUGVUSVUAUMUNVVQVUIVVAVUMVVCVVQVUFEVUHVUTVUGVUS
      UOUPVVQVUKVVBBVULVUGVUSKVUJUTUQURVAVBVUGANZVUQVVPVUBVVRVUNVVMDVUPVVOVVRVU
      OVVNVUGAVUAUMUNVVRVUIVVJVUMVVLVVRVUFEVUHVVIVUGAUOUPVVRVUKVVKBVULVUGAKVUJU
      TUQURVAVBVUGVUSVCZVURMZUAVDZVUBVVSVUQMZUAVDZMZVUSUIFZVVHVWAVUBVWBMZUAVDVW
      DVVTVWFUAVVSVUBVUQUUAUUBVUBVWBUAUUCUUDVWEVUBVWCVVGVWEVUBVWCVVGVWEVUBOZVWC
      OZVUCUCUHZVUCUJZGHZEVUTJZVVBBVWIIZUKZMZUCVVFJVVGVWHVWOUCVVFVWHVWIVVFFZVWL
      VWNVWHVWPVWLOZOZUDUHZVUSVCZVWSPVEZOZVWSVWIVWSUJZVLHZMZUDVDZVWNVWRVXFOZVWN
      VUSPVUSPNZVWNMVXGVXHVWNPKVUJLZBVWMUKZPVWMFPKPLZVXJVWIUUKKUUEVXIVXKBPVWMPK
      VUJPVFVGVHVXHVVBVXIBVWMVUSPKVUJUTUQVIVJVUSPVEUEUHZVUSFZUEVKVXGVWNUEVUSVMV
      XGVXMVWNUEVWRVXFVXMVWNVWRVXFVXMOZOZUFUHZVWIVXLWDZUJZFZUFVKZVWNVXOVXRPVEZV
      XTVWRVXFVXMVYAVWQVXMVYAMZVWHVXFVWLVYBVWPVXMVXQVUTFZVWLVYAVXLVUSUUFVYCVWLV
      YAVYCVWLOVXQVXRGHZVYAVWKVYDEVXQVUTVUCVXQNZVUCVXQVWJVXRGVYEVNVUCVXQVWIVOVP
      VQVYDPVXRVLHZVYAPVXQVLHZVYDVYFVYGVXQPVEVXLUEWEZUUGVXQVXLUUHVRVSPVXQVXRUUI
      UUJVXRVWIKFZVXRKFUCWEZVWIVXQKVTWAVRQRUULUUMWBWCWFUFVXRVMQVXOVXSVWNUFVWRVX
      FVXMVXSVWNMVXGVXMVXSVWNVWRVXFVXMVXSOZVWNVWRVXFVYKOZOZVUSVXQWGZKUGUHZLZUGV
      WIVYNVUAVXPWDZWGZULZSZIZUKZVWNVYMVYNKVUJLZBWUAUKZWUBVYMVUCVYTVUCUJZGHZEVY
      NIZJZWUDVWGVWQVYLWUHVWCVWGVWQOZVYLOZVUDVWIVUDVYNSZUJZVYRSZGHZDWUGJWUHWUJW
      UNDWUGWUJVUDWUGFZOZVUDVWIVUDUJZVYQWGZWUMGVYLWUOVUDWURGHZWUIVXFVXMWUOWUSVX
      SVXNWUOOZWUSVUDPVUDPNZWUSMWUTWVAWUSPWURGHWURVYIWUQKFWURKFVYJVWIVUDKVTWUQV
      YQKWHUUNUUOVUDPWURGUUPVIVJVXNWUOVUDPVEZWUSVXNWUOWVBOZOZVUDWUQVLHZWUSWVDVX
      FVUDVUSVCZWVBOZWVEVXFVXMWVCUUQWVDWVFWVBWVDVUDVYNVUSWUOVUDVYNTZVXNWVBVUDVY
      NWPZWIVXMVYNVUSVCZVXFWVCVXMWVJVXLVUSUURWJZWCUUSVXNWUOWVBWKUVBVXEWVGWVEMUD
      DUDDUSZVXBWVGVXDWVEWVLVWTWVFVXAWVBVWSVUDVUSWLVWSVUDPUUTUVCWVLVWSVUDVXCWUQ
      VLWVLVNVWSVUDVWIVOVPURWMWNVUDWUQVXPUVARWQWOUVDUVEWUPWUMWUQVYRSZWURWUOWUMW
      VMNWUJWUOWULWUQVYRWUOWUKVUDVWIWUOWVHWUKVUDNWVIVUDVYNWRQWSWTWBWUIWVMWURNVY
      LWUOWUIWVMWUQVUASZVYQWGZWURWUQVUAVYQXAVWPWVOWURNVWGVWLVWPWVNWUQVYQVWPWUQV
      UATWVNWUQNVWPWUQVWIXBZVUAVWIVUDUVFVWPVWIVVETZWVPVUATVWIVVEWPZWVQWVPVVEXBV
      UAVWIVVEXGVUSVUAXCXDRUVGWUQVUAWRQZXEWIXHXFUVHXIXJWUNWUFDEWUGDEUSZVUDVUCWU
      MWUEGWVTVNZWVTWUMVYTVUDUJWUEVYNVYRVWIVUDUVIVUDVUCVYTVOUVJVPXKQXLVYMVYTVYN
      VUAULZIZFZVUFEWUGJZWUCBVULUKZMZDWWCJZWUHWUDMZWWDVYTWWBTVYTVYSWWBVWIVYSXMZ
      VYRVUATVYSWWBTVUAVYQXNVYRVUAVYNUVKWAUVLVYTWWBVWIVYSVYJUVMXQVSVYMVWCWVJWWH
      VWGVWCVWQVYLUVNVYKWVJVWRVXFVXMWVJVXSWVKXOUVOVWBWVJWWHMUAVYNVUSKFZVYNKFUBW
      EZVUSVXQKWHWAVUGVYNNZVVSWVJVUQWWHVUGVYNVUSWLWWMVUNWWGDVUPWWCWWMVUOWWBVUGV
      YNVUAUMUNWWMVUIWWEVUMWWFWWMVUFEVUHWUGVUGVYNUOUPWWMVUKWUCBVULVUGVYNKVUJUTU
      QURVAURUVPWNWWGWWIDVYTWWCVUDVYTNZWWEWUHWWFWUDWWNVUFWUFEWUGWWNVUEWUEVUCGVU
      DVYTVUCXPXRXSWWNWUCBVULWUAVUDVYTUOXTURVQUVQYAWUCVYPBUGWUAVYNKVUJVYOVFYBQV
      WGVWQVYLWUBVWNMZVWCWUIVXFVYKWWOVWQVYKWWOMZVWGVXFVWPWWPVWLVWPVYKWWOVWPVYKO
      ZVYPVWNUGWUAWWQVYOWUAFZVYPOZOZVXLVXPUVRZWDZVYOYCZVWMFZVUSKWXCLZVWNVYKWWRW
      XDVWPVYPVYKWWROZWXCVWITWXDWXFWXBVYOVWIVXSWXBVWITVXMWWRVXSWXAVWIVXSWXAVWIF
      VWIVXLVXPVYHUFWEZUWCWJUVSWCWWRVYOVWITVYKWWRVYOVYTVWIVYOVYTWPZVWIVYSYDXDWB
      YEWXCVWIVYJYFYGUVTWWTVUSVYQVYOXBZYCZWXCYHZWXEWWTVXQVYNYCZWXJWXCYHZWXKWWSW
      XMWWQWWSVXQVYQWXBYHZVYNWXIVYOYHZVXQVYNSPNZVYQWXISZPNZWXMWXNWWSVXLVXPVYHWX
      GUWAVJVYPWXOWWRVYNKVYOYIWBWXPWWSVXQVUSYJVJWWRWXRVYPWWRWXQWXIVYQSZPVYQWXIY
      KWWRWXIVYRTZVYRVYQSZPNWXSPNWWRVYOVYSTZWXTWWRVYOVYTVYSWXHWWJXDWYBWXIVYSXBV
      YRVYOVYSXGVYNVYRXCXDRWYAVYQVYRSPVYRVYQYKVYQVUAYJUWBWXIVYRVYQYLYMXHXOVXQVY
      QVYNWXIWXBVYOUWDYNWBWWQWXMWXKYOZWWSWWQWXLVUSNZWYCWWQVXQVUSTZWYDVXMWYEVWPV
      XSVXLVUSUWEWIVXQVUSUWFQWXLVUSWXJWXCUWGRXOYPWXKVUSWXJWXCLWXJKTWXEVUSWXJWXC
      UWHWXJUWIVUSWXJKWXCUWJYMRVVBWXEBWXCVWMVUSKVUJWXCVFVGYQYRUWOXOWCWFXLYAWQUW
      KWFYSYAWQYSUWLWOVXFYTVWRVXBVXDYTZOZUDVKZVWNVXBVXDUDUWMVWRWYHVWNVWRWYGVWNU
      DVWRWYGVWNVWRWYGOZVWSKVXLLZUEVWIVWSUWNZIZUKZVUSVWSWGZKVXPLZUFVWIWYNVUAVXC
      WGZULZSZIZUKZVWNWYIVWSKVUJLZBWYLUKZWYMWYIVUCWYKVUCUJZGHZEVWSIZJZXUBWYIVWK
      EXUEJZXUFWYIXUEVUTTZVWLXUGWYIVWSVUSTZXUHWYIVWTXUIVWRVWTVXAWYFUWPZVWSVUSUW
      QZRZVWSVUSUWRQVWHVWPVWLWYGUWSVWKEXUEVUTUWTWNVWKXUDEXUEVUCXUEFZVWJXUCVUCGX
      UMXUCVWJXUMVUCVWSTXUCVWJNVUCVWSWPVWIVUCVWSUXARUXBXRUXCQWYIWYKVWSVUAULZIZF
      ZVUFEXUEJZXUABVULUKZMZDXUOJZXUFXUBMZWYIVWPXUPVWHVWPVWLWYGUXFZVWPWYKXUNTZX
      UPVWPWVQXVCWVRWVQWYKVVEVWSUWNZXUNVWIVVEVWSUXDXVDVVEVWSKULSZXUNVVEVWSUXEXV
      EVUSVWSSZVUAKSZULZXUNVUSVUAVWSKUXGXVFVWSTXVGVUATXVHXUNTVUSVWSXMVUAKYDXVFV
      WSXVGVUAUXHVHUXIUXIXDRWYKXUNVWIVWSVYJUXJXQYGRWYIVWCVWTXUTVWGVWCVWQWYGUVNZ
      XUJVWBVWTXUTMUAUDUAUDUSZVVSVWTVUQXUTVUGVWSVUSWLXVJVUNXUSDVUPXUOXVJVUOXUNV
      UGVWSVUAUMUNXVJVUIXUQVUMXURXVJVUFEVUHXUEVUGVWSUOUPXVJVUKXUABVULVUGVWSKVUJ
      UTUQURVAURWMWNXUSXVADWYKXUOVUDWYKNZXUQXUFXURXUBXVKVUFXUDEXUEXVKVUEXUCVUCG
      VUDWYKVUCXPXRXSXVKXUABVULWYLVUDWYKUOXTURVQYQYAXUAWYJBUEWYLVWSKVUJVXLVFYBQ
      WYIWYNKVUJLZBWYSUKZWYTWYIVUCWYRVUCUJZGHZEWYNIZJZXVMVWGVWQWYGXVQVWCWUIWYGO
      ZVUDVWIVUDWYNSZUJZWYPSZGHZDXVPJXVQXVRXWBDXVPXVRVUDXVPFZOZVUDWVNVXCWGZXWAG
      XWDVUDWUQVXCWGZXWEGXWDVWSVUDYCZVXCXWFYCZGHZVUDXWFGHZXWDXWGVWIXWGUJZXWHGXW
      DXWGVUTFZVWLXWGXWKGHZXWDXWGVUSTXWLXWDVWSVUDVUSWYGXUIWUIXWCVWTXUIVXAWYFXUK
      XFWCZXWCVUDVUSTXVRXWCVUDWYNVUSVUDWYNWPZVUSVWSXNXDWBYEXWGVUSWWLYFYGWUIVWLW
      YGXWCVWGVWPVWLWKXFZVWKXWMEXWGVUTVUCXWGNZVUCXWGVWJXWKGXWQVNVUCXWGVWIVOVPVQ
      YQXWKVXCWUQYCXWHVWIVWSVUDUXKVXCWUQUXLUXMUXNXWDVWSUIFZVXCVWSUXOHVWSVUDSZPN
      ZVXCXWFSPNZXWIXWJYOXWDVWEXUIXWRVWEVUBVWQWYGXWCUXQXWNVUSVWSUXPYQXWDVWSVXCX
      WDVWSVXCGHZWYFVWSVXCUXOHXWDVWSVUTFZVWLXXBXWDXUIXXCXWNVWSVUSUDWEXQYGXWPVWK
      XXBEVWSVUTEUDUSZVUCVWSVWJVXCGXXDVNVUCVWSVWIVOVPVQYQWUIVXBWYFXWCUWSVWSVXCU
      XRUXSUXTXWCXWTXVRXWCVUDWYNTZXWTXWOXXEXWSVUDVWSSPVWSVUDYKVUDVUSVWSUYAXHRWB
      XXAXWDVXCWUQYJVJVWSVXCVUDXWFUYGYNYPWUIXWEXWFNZWYGXWCVWPXXFVWGVWLVWPWVNWUQ
      VXCWVSXEWIXFXIXWCXWAXWENXVRXWCXWAWUQWYPSXWEXWCXVTWUQWYPXWCXVSVUDVWIXWCXXE
      XVSVUDNXWOVUDWYNWRQWSWTWUQVUAVXCXAUYBWBXIXJXWBXVODEXVPWVTVUDVUCXWAXVNGWWA
      WVTXWAWYRVUDUJXVNWYNWYPVWIVUDUVIVUDVUCWYRVOUVJVPXKQXLWYIWYRWYNVUAULZIZFZV
      UFEXVPJZXVLBVULUKZMZDXXHJZXVQXVMMZXXIWYRXXGTWYRWYQXXGVWIWYQXMZWYPVUATWYQX
      XGTVUAVXCXNWYPVUAWYNUVKWAUVLWYRXXGVWIWYQVYJUVMXQVSWYIVWCWYNVUSVCZXXMXVIVX
      BXXPVWRWYFVXBXVFPVEZXXPVWTXXQVXAVWTXVFVWSPVWTXVFVWSVUSSZVWSVUSVWSYKVWTXUI
      XXRVWSNXUKVWSVUSWRQXHUYCUYDXXPXVFPXVFPNXXPYTVUSVWSUYEUYFUYHQWIVWBXXPXXMMU
      AWYNWWKWYNKFWWLVUSVWSKWHWAVUGWYNNZVVSXXPVUQXXMVUGWYNVUSWLXXSVUNXXLDVUPXXH
      XXSVUOXXGVUGWYNVUAUMUNXXSVUIXXJVUMXXKXXSVUFEVUHXVPVUGWYNUOUPXXSVUKXVLBVUL
      VUGWYNKVUJUTUQURVAURUVPWNXXLXXNDWYRXXHVUDWYRNZXXJXVQXXKXVMXXTVUFXVOEXVPXX
      TVUEXVNVUCGVUDWYRVUCXPXRXSXXTXVLBVULWYSVUDWYRUOXTURVQUVQYAXVLWYOBUFWYSWYN
      KVUJVXPVFYBQWYIVWPXUIWYMWYTVWNMZMXVBXULVWPXUIOZWYJXYAUEWYLXYBVXLWYLFZWYJO
      ZOZWYOVWNUFWYSXYEVXPWYSFZWYOOZOZVXLVXPYCZVWMFZVUSKXYILZVWNXYHXYIVWITXYJXY
      HVXLVXPVWIXYDVXLVWITZXYBXYGXYCXYLWYJXYCVXLWYKVWIVXLWYKWPZVWIVWSUYIXDXOWCX
      YFVXPVWITXYEWYOXYFVXPWYRVWIVXPWYRWPZVWIWYQYDXDWIYEXYIVWIVYJYFYGXYHVUSVXLX
      BZVXPXBZYCZXYILZXYQKTXYKXYHVUSXYQXYIYHZXYRXYHVWSWYNYCZXYQXYIYHZXYSXYHVWSX
      YOVXLYHZWYNXYPVXPYHZVWSWYNSPNZXYOXYPSPNZYUAXYDYUBXYBXYGWYJYUBXYCVWSKVXLYI
      WBWCWYOYUCXYEXYFWYNKVXPYIUVOYUDXYHVWSVUSYJVJXYHXYOVXCTZVXCXYPSZPNYUEXYDYU
      FXYBXYGXYCYUFWYJXYCXYOWYKXBZVXCXYCVXLWYKTXYOYUHTXYMVXLWYKXGRVWIVWSUYJUYKX
      OWCXYHYUGXYPVXCSZPVXCXYPYKXYHXYPWYPTZWYPVXCSZPNYUIPNXYFYUJXYEWYOXYFXYPWYQ
      XBZWYPXYFVXPWYQTXYPYULTXYFVXPWYRWYQXYNXXOXDVXPWYQXGRWYNWYPXCXDWIYUKVXCWYP
      SPWYPVXCYKVXCVUAYJUWBXYPWYPVXCYLYMXHXYOVXCXYPYLYQVWSXYOWYNXYPVXLVXPUWDYNX
      YHXYTVUSNZYUAXYSYOXYBYUMXYDXYGXUIYUMVWPXUIYUMVWSVUSUWFWJWBXFXYTVUSXYQXYIU
      WGRYPVUSXYQXYIUWHRXYQUWIVUSXYQKXYIUWJYMVVBXYKBXYIVWMVUSKVUJXYIVFVGYQYRYRY
      QUYPUWOYSUYLUYMUYNUYOUYQVWOVVDUCDVVFUCDUSZVWLVVAVWNVVCYUNVWKVUFEVUTYUNVWJ
      VUEVUCGVWIVUDVUCXPXRXSYUNVVBBVWMVULVWIVUDUOXTURXKQUYRUYSUWLUYT $.
  $}

  ${
    $d ph d f $.  $d A b c d f $.  $d B b c $.  $d C c d f $.
    marypha1.a $e |- ( ph -> A e. Fin ) $.
    marypha1.b $e |- ( ph -> B e. Fin ) $.
    marypha1.c $e |- ( ph -> C C_ ( A X. B ) ) $.
    marypha1.d $e |- ( ( ph /\ d C_ A ) -> d ~<_ ( C " d ) ) $.
    $( (Philip) Hall's marriage theorem, sufficiency: a finite relation
       contains an injection if there is no subset of its domain which would be
       forced to violate the pidgeonhole principle.  (Contributed by Stefan
       O'Rear, 20-Feb-2015.) $)
    marypha1 $p |- ( ph -> E. f e. ~P C f : A -1-1-> B ) $=
      ( vc vb cvv cv cpw wral wcel wss wi cfn wf1 wrex cima wbr elpwi ralrimiva
      cdom sylan2 cxp xpexg syl2anc elpw2g syl mpbird wceq xpeq2 raleqdv imbi2d
      pweqd marypha1lem vtoclga sylc imaeq1 breq2d ralbidv pweq rexeqdv imbi12d
      wb com12 rspcva mpd wa sylan9ssr rnss rnxpss syl6ss f1ssr expcom reximdva
      crn ) ABMENZUAZEDOZUBZBCWBUAZEWDUBAFNZDWGUCZUGUDZFBOZPZWEAWIFWJWGWJQAWGBR
      WIWGBUEJUHUFADBCUIZOZQZWGKNZWGUCZUGUDZFWJPZWCEWOOZUBZSZKWMPZWKWESZAWNDWLR
      ZIAWLMQZWNXDVIABTQZCTQZXEGHBCTTUJUKDWLMULUMUNAXGXFXBHGXFXAKBLNZUIZOZPZSXF
      XBSLCTXHCUOZXKXBXFXLXAKXJWMXLXIWLXHCBUPUSUQURXFXHTQXKBELKFUTVJVAVBXAXCKDW
      MWODUOZWRWKWTWEXMWQWIFWJXMWPWHWGUGWODWGVCVDVEXMWCEWSWDWODVFVGVHVKUKVLAWCW
      FEWDAWBWDQZVMZWBWAZCRZWCWFSXOXPWLWAZCXOWBWLRXPXRRXNAWBDWLWBDUEIVNWBWLVOUM
      BCVPVQWCXQWFBMCWBVRVSUMVTVL $.
  $}

  ${
    $d A x y z $.  $d F x y z $.  $d G x y $.  $d X x y $.
    marypha2lem.t $e |- T = U_ x e. A ( { x } X. ( F ` x ) ) $.
    $( Lemma for ~ marypha2 .  Properties of the used relation.  (Contributed
       by Stefan O'Rear, 20-Feb-2015.) $)
    marypha2lem1 $p |- T C_ ( A X. U. ran F ) $=
      ( csn cfv cxp ciun crn cuni wss iunss wcel snssi fvssunirn xpss12 sylancl
      cv mprgbir eqsstri ) CABASZFZUBDGZHZIZBDJKZHZEUFUHLUEUHLZABABUEUHMUBBNUCB
      LUDUGLUIUBBODUBPUCBUDUGQRTUA $.

    $( Lemma for ~ marypha2 .  Properties of the used relation.  (Contributed
       by Stefan O'Rear, 20-Feb-2015.) $)
    marypha2lem2 $p |- T = { <. x , y >. | ( x e. A /\ y e. ( F ` x ) ) } $=
      ( vz cv csn cfv cxp ciun wcel wa copab wceq fveq2 wrex bitri 3eqtri df-xp
      sneq xpeq12d cbviunv a1i iuneq2i iunopab elsn equcom anbi1i rexbii eleq2d
      ceqsrexbv opabbii ) DACAHZIZUOEJZKZLGCGHZIZUSEJZKZLZUOCMBHZUQMZNZABOZFAGC
      URVBUOUSPZUPUTUQVAUOUSUBUOUSEQUCUDVCGCUOUTMZVDVAMZNZABOZLVKGCRZABOVGGCVBV
      LVBVLPUSCMABUTVAUAUEUFVKABGCUGVMVFABVMUSUOPZVJNZGCRVFVKVOGCVIVNVJVIVHVNAU
      SUHAGUISUJUKVJVEGUOCVNVAUQVDUSUOEQULUMSUNTT $.

    $( Lemma for ~ marypha2 .  Properties of the used relation.  (Contributed
       by Stefan O'Rear, 20-Feb-2015.) $)
    marypha2lem3 $p |- ( ( F Fn A /\ G Fn A ) -> ( G C_ T <->
          A. x e. A ( G ` x ) e. ( F ` x ) ) ) $=
      ( vy wfn wa wss cv wcel cfv wceq wi wal wral copab syl6bb albii dffn5 a1i
      biimpi adantl df-mpt syl6eq marypha2lem2 sseq12d ssopab2b 19.21v imdistan
      cmpt fvex eleq1 ceqsalv imbi2i 3bitr3i df-ral bitr4i ) DBHZEBHZIZECJZAKZB
      LZGKZVDEMZNZIZVEVFVDDMZLZIZOZGPZAPZVGVJLZABQZVBVCVIAGRZVLAGRZJVOVBEVRCVSV
      BEABVGULZVRVAEVTNZUTVAWAABEUAUCUDAGBVGUEUFCVSNVBAGBCDFUGUBUHVIVLAGUISVOVE
      VPOZAPVQVNWBAVEVHVKOZOZGPVEWCGPZOVNWBVEWCGUJWDVMGVEVHVKUKTWEVPVEVKVPGVGVD
      EUMVFVGVJUNUOUPUQTVPABURUSS $.

    $( Lemma for ~ marypha2 .  Properties of the used relation.  (Contributed
       by Stefan O'Rear, 20-Feb-2015.) $)
    marypha2lem4 $p |- ( ( F Fn A /\ X C_ A ) -> ( T " X ) = U. ( F " X ) ) $=
      ( vy wfn wss wa cima cv cfv wcel copab crn wceq cab syl5eq eqtrd resopab2
      ciun cuni cres marypha2lem2 imaeq1i df-ima eqtri adantl rneqd rnopab wrex
      wex df-rex bicomi abbii df-iun eqtr4i a1i wfun fnfun adantr funiunfv syl
      ) DBHZEBIZJZCEKZAEALZDMZUBZDEKUCZVGVHVIBNGLVJNZJAGOZEUDZPZVKVHVNEKVPCVNEA
      GBCDFUEUFVNEUGUHVGVPVIENVMJZAGOZPZVKVGVOVRVFVOVRQVEVMAGEBUAUIUJVGVSVQAUMZ
      GRZVKVQAGUKWAVKQVGWAVMAEULZGRVKVTWBGWBVTVMAEUNUOUPAGEVJUQURUSSTSVGDUTZVKV
      LQVEWCVFBDVAVBAEDVCVDT $.
  $}

  ${
    $d ph d g x $.  $d A d g x $.  $d F d g x $.
    marypha2.a $e |- ( ph -> A e. Fin ) $.
    marypha2.b $e |- ( ph -> F : A --> Fin ) $.
    marypha2.c $e |- ( ( ph /\ d C_ A ) -> d ~<_ U. ( F " d ) ) $.
    $( Version of ~ marypha1 using a functional family of sets instead of a
       relation.  (Contributed by Stefan O'Rear, 20-Feb-2015.) $)
    marypha2 $p |- ( ph -> E. g ( g : A -1-1-> _V /\
          A. x e. A ( g ` x ) e. ( F ` x ) ) ) $=
      ( cuni cv wf1 cfv cxp cvv wcel wa wex wss cima crn csn ciun cpw wrex wral
      unirnffid eqid marypha2lem1 a1i cdom wfn wceq cfn wf ffn syl marypha2lem4
      sylan breqtrrd marypha1 df-rex ssv f1ss mpan2 ad2antll ad2antrl wb adantr
      elpwi f1fn marypha2lem3 syl2anc mpbid jca ex eximdv syl5bi mpd ) ACEUAJZD
      KZLZDBCBKZUBWCEMZNUCZUDZUEZCOWALZWCWAMWDPBCUFZQZDRZACVTWEDFGACEHGUGWECVTN
      SABCWEEWEUHZUIUJAFKZCSZQWMEWMTJZWEWMTZUKIAECULZWNWPWOUMACUNEUOWQHCUNEUPUQ
      ZBCWEEWMWLURUSUTVAWGWAWFPZWBQZDRAWKWBDWFVBAWTWJDAWTWJAWTQZWHWIWBWHAWSWBVT
      OSWHVTVCCVTOWAVDVEVFXAWAWESZWIWSXBAWBWAWEVJVGXAWQWACULZXBWIVHAWQWTWRVIWBX
      CAWSCVTWAVKVFBCWEEWAWLVLVMVNVOVPVQVRVS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Supremum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Add new constant symbol. $)
  $c sup $.  $( Supremum. $)

  $( Extend class notation to include supremum of class ` A ` .  Here ` R ` is
     ordinarily a relation that strictly orders class ` B ` .  For example,
     ` R ` could be 'less than' and ` B ` could be the set of real numbers. $)
  csup $a class sup ( A , B , R ) $.

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.
    $( Define the supremum of class ` A ` .  It is meaningful when ` R ` is a
       relation that strictly orders ` B ` and when the supremum exists.  For
       example, ` R ` could be 'less than', ` B ` could be the set of real
       numbers, and ` A ` could be the set of all positive reals whose square
       is less than 2; in this case the supremum is defined as the square root
       of 2 per ~ sqrval .  See ~ dfsup2 for alternate definition not requiring
       dummy variables.

       We will also use this notation for "infimum" by replacing ` R ` with
       ` ``' R ` .  (Contributed by NM, 22-May-1999.) $)
    df-sup $a |- sup ( A , B , R ) = U. { x e. B | ( A. y e. A -. x R y /\
                  A. y e. B ( y R x -> E. z e. A y R z ) ) } $.

    $( can't be used if A is a proper class... important?  we already
       have U. as sup for On... but since sup exists, can't use sup for
       On anyway e.g. sup of On itself.
    df-supNEW $a |- sup = { <. <. x , y >. , z >. | z =
             U. { w e. ( 1st ` x ) | ( A. v e. y -. w ( 2nd ` x ) v /\
                  A. v e. ( 1st ` x ) ( v ( 2nd ` x ) w ->
                 E. u e. y v ( 2nd ` x ) u ) ) } } $.
    $)
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d R x y z $.
    $( Quantifier free definition of supremum.  (Contributed by Scott Fenton,
       19-Feb-2013.) $)
    dfsup2 $p |- sup ( B , A , R ) =
      U. ( A \ ( ( `' R " B ) u. ( R " ( A \ ( `' R " B ) ) ) ) ) $=
      ( vx vy vz cv wbr wn wral wrex wi wa cdif cvv wcel vex elima bitri eqtri
      csup crab cuni ccnv cima cun df-sup cab cin dfrab3 wb abeq1 eldif mpbiran
      wceq dfrex2 orbi12i elun ianor 3bitr4i con2bii brcnv notbii ralbii impexp
      imbi1i rexbii imbi2i con34b bitr3i ralbii2 anbi12i 3bitr2ri mpgbir ineq2i
      wo invdif unieqi ) BACUADGZEGZCHZIZEBJZVTVSCHZVTFGZCHZFBKZLZEAJZMZDAUBZUC
      ACUDZBUEZCAWMNZUEZUFZNZUCDEFBACUGWKWQWKAWJDUHZUIZWQWJDAUJWSAOWPNZUIWQWRWT
      AWRWTUOWJVSWTPZUKDWJDWTULXAVSWPPZIZVTVSWLHZIZEBJZWDIZEWNJZMZWJXAVSOPXCDQZ
      VSOWPUMUNXBXIVSWMPZVSWOPZVPXFIZXHIZVPXBXIIXKXMXLXNXKXDEBKXMEVSWLBXJRXDEBU
      PSXLWDEWNKXNEVSCWNXJRWDEWNUPSUQVSWMWOURXFXHUSUTVAXFWCXHWIXEWBEBXDWAVTVSCE
      QZXJVBVCVDXGWHEWNAVTAPZVTWMPZIZMZXGLXPXRXGLZLVTWNPZXGLXPWHLXPXRXGVEYAXSXG
      VTAWMUMVFWHXTXPWHWDXQLXTXQWGWDXQWEVTWLHZFBKWGFVTWLBXORYBWFFBWEVTCFQXOVBVG
      SVHWDXQVIVJVHUTVKVLVMVNVOAWPVQTTVRT $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d R x y z $.
    $( Quantifier-free definition of supremum.  (Contributed by Scott Fenton,
       18-Feb-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfsup2OLD $p |- sup ( B , A , R ) =
      U. ( A \ ( ( `' R " B ) u. ( ( R \ ( ( `' R " B ) X. _V ) ) " A ) ) ) $=
      ( vx vy vz cv wbr wn wrex cvv cdif cin wcel vex notbii bitri elima rexbii
      wa csup wral wi crab cuni ccnv cima cxp cun df-sup cab dfrab2 incom abeq1
      wceq wb eldif mpbiran wo elun ioran brcnv ralnex bitr4i brdif brxp 3bitri
      mpbiran2 anbi2i con2bii anbi12i 3bitrri mpgbir ineq2i invdif eqtri 3eqtri
      rexanali unieqi ) BACUADGZEGZCHZIEBUBZWAVTCHZWAFGZCHZFBJZUCEAUBZTZDAUDZUE
      ACUFZBUGZCWLKUHZLZAUGZUIZLZUEDEFBACUJWJWQWJWIDUKZAMAWRMZWQWIDAULWRAUMWSAK
      WPLZMWQWRWTAWRWTUOWIVTWTNZUPDWIDWTUNXAVTWPNZIZVTWLNZIZVTWONZIZTZWIXAVTKNZ
      XCDOZVTKWPUQURXCXDXFUSZIXHXBXKVTWLWOUTPXDXFVAQXEWCXGWHXEWBEBJZIWCXDXLXDWA
      VTWKHZEBJXLEVTWKBXJRXMWBEBWAVTCEOZXJVBSQPWBEBVCVDXGWDWGIZTZEAJZIWHXFXQXFW
      AVTWNHZEAJXQEVTWNAXJRXRXPEAXRWDWAVTWMHZIZTXPWAVTCWMVEXTXOWDXSWGXSWAWLNZWE
      WAWKHZFBJWGXSYAXIXJWAVTWLKVFVHFWAWKBXNRYBWFFBWEWACFOXNVBSVGPVIQSQPXQWHWDW
      GEAVRVJVDVKVLVMVNAWPVOVPVQVSVP $.

  $}

  $( Quantifier-free definition of supremum.  (Contributed by Scott Fenton,
     19-Feb-2013.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  dfsup3OLD $p |- sup ( B , A , R ) =
    U. ( A \ ( ( `' R " B ) u. ( R " ( A \ ( `' R " B ) ) ) ) ) $=
    ( csup ccnv cima cvv cxp cdif cun cuni dfsup2OLD cres crn cin incom 3eqtr4i
    indifcom df-res df-ima difxp1 ineq2i rneqi uneq2i difeq2i unieqi eqtri ) BA
    CDACEBFZCUHGHZIZAFZJZIZKAUHCAUHIZFZJZIZKABCLUMUQULUPAUKUOUHUJAMZNCUNMZNUKUO
    URUSUJAGHZOZCUNGHZOZURUSUTUJOCUTUIIZOVAVCUTCUIRUJUTPVBVDCAUHGUAUBQUJASCUNSQ
    UCUJATCUNTQUDUEUFUG $.

  ${
    $d x y z R $.  $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Equality theorem for supremum.  (Contributed by NM, 22-May-1999.) $)
    supeq1 $p |- ( B = C -> sup ( B , A , R ) = sup ( C , A , R ) ) $=
      ( vx vy vz wceq cv wbr wn wral wrex wi wa crab cuni csup raleq df-sup
      rexeq imbi2d ralbidv anbi12d rabbidv unieqd 3eqtr4g ) BCHZEIZFIZDJKZFBLZU
      JUIDJZUJGIDJZGBMZNZFALZOZEAPZQUKFCLZUMUNGCMZNZFALZOZEAPZQBADRCADRUHUSVEUH
      URVDEAUHULUTUQVCUKFBCSUHUPVBFAUHUOVAUMUNGBCUAUBUCUDUEUFEFGBADTEFGCADTUG
      $.
  $}

  ${
    supeq1d.1 $e |- ( ph -> B = C ) $.
    $( Equality deduction for supremum.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    supeq1d $p |- ( ph -> sup ( B , A , R ) = sup ( C , A , R ) ) $=
      ( wceq csup supeq1 syl ) ACDGCBEHDBEHGFBCDEIJ $.
  $}

  ${
    supeq1i.1 $e |- B = C $.
    $( Equality inference for supremum.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    supeq1i $p |- sup ( B , A , R ) = sup ( C , A , R ) $=
      ( wceq csup supeq1 ax-mp ) BCFBADGCADGFEABCDHI $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d R x y z $.
    $( Equality theorem for supremum.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    supeq2 $p |- ( B = C -> sup ( A , B , R ) = sup ( A , C , R ) ) $=
      ( vx vy vz wceq cv wbr wn wral wrex wi wa crab cuni csup rabeq df-sup
      raleq anbi2d rabbidv eqtrd unieqd 3eqtr4g ) BCHZEIZFIZDJKFALZUIUHDJUIGIDJ
      GAMNZFBLZOZEBPZQUJUKFCLZOZECPZQABDRACDRUGUNUQUGUNUMECPUQUMEBCSUGUMUPECUGU
      LUOUJUKFBCUAUBUCUDUEEFGABDTEFGACDTUF $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d R x y z $.  $d S x y z $.
    $( Equality theorem for supremum.  (Contributed by Scott Fenton,
       13-Jun-2018.) $)
    supeq3 $p |- ( R = S -> sup ( A , B , R ) = sup ( A , B , S ) ) $=
      ( vx vy vz cv wbr wn wral wrex wi wa crab cuni csup breq ralbidv df-sup
      wceq notbid rexbidv imbi12d anbi12d rabbidv unieqd 3eqtr4g ) CDUAZEHZFHZC
      IZJZFAKZUKUJCIZUKGHZCIZGALZMZFBKZNZEBOZPUJUKDIZJZFAKZUKUJDIZUKUPDIZGALZMZ
      FBKZNZEBOZPABCQABDQUIVBVLUIVAVKEBUIUNVEUTVJUIUMVDFAUIULVCUJUKCDRUBSUIUSVI
      FBUIUOVFURVHUKUJCDRUIUQVGGAUKUPCDRUCUDSUEUFUGEFGABCTEFGABDTUH $.
  $}


  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d D x y z $.  $d E x y z $.
    $d F x y z $.  $d ph x y z $.
    supeq123d.a $e |- ( ph -> A = D ) $.
    supeq123d.b $e |- ( ph -> B = E ) $.
    supeq123d.c $e |- ( ph -> C = F ) $.
    $( Equality deduction for supremum.  (Contributed by Stefan O'Rear,
       20-Jan-2015.) $)
    supeq123d $p |- ( ph -> sup ( A , B , C ) = sup ( D , E , F ) ) $=
      ( vx vy vz cv wbr wn wral wrex wi breqd wa crab cuni csup imbi12d anbi12d
      notbid raleqbidv rexeqbidv rabeqbidv unieqd df-sup 3eqtr4g ) AKNZLNZDOZPZ
      LBQZUOUNDOZUOMNZDOZMBRZSZLCQZUAZKCUBZUCUNUOGOZPZLEQZUOUNGOZUOUTGOZMERZSZL
      FQZUAZKFUBZUCBCDUDEFGUDAVFVPAVEVOKCFIAURVIVDVNAUQVHLBEHAUPVGADGUNUOJTUGUH
      AVCVMLCFIAUSVJVBVLADGUOUNJTAVAVKMBEHADGUOUTJTUIUEUHUFUJUKKLMBCDULKLMEFGUL
      UM $.
  $}


  ${
    nfsup.1 $e |- F/_ x A $.
    nfsup.2 $e |- F/_ x B $.
    nfsup.3 $e |- F/_ x R $.
    $( Hypothesis builder for supremum.  (Contributed by Mario Carneiro,
       20-Mar-2014.) $)
    nfsup $p |- F/_ x sup ( A , B , R ) $=
      ( csup ccnv cima cdif cun cuni dfsup2 nfcnv nfima nfdif nfun nfuni nfcxfr
      ) ABCDHCDIZBJZDCUBKZJZLZKZMCBDNAUFACUEFAUBUDAUABADGOEPZADUCGACUBFUGQPRQST
      $.
  $}

  ${
    $d x y z w A $.  $d x y z w R $.  $d x y z w B $.  $d w C $.  $d w ph $.
    supmo.1 $e |- ( ph -> R Or A ) $.
    $( Any class ` B ` has at most one supremum in ` A ` (where ` R ` is
       interpreted as 'less than').  (Contributed by NM, 5-May-1999.)  (Revised
       by Mario Carneiro, 24-Dec-2016.) $)
    supmo $p |- ( ph -> E* x e. A ( A. y e. B -. x R y /\
                  A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
      ( vw cv wbr wn wral wrex wi wa weq breq1 breq2 syl5bi wrmo wor wcel ancom
      anbi2ci an42 3bitr4i ralnex rexbidv imbi12d cbvrexv syl6ibr con3d expimpd
      rspcva ad2antrl ad2antll anim12d sylibrd ralrimivva notbid ralbidv imbi1d
      sotrieq2 syl anbi12d rmo4 sylibr ) ABJZCJZGKZLZCFMZVJVIGKZVJDJZGKZDFNZOZC
      EMZPZIJZVJGKZLZCFMZVJWAGKZVQOZCEMZPZPZBIQZOZIEMBEMZVTBEUAAEGUBZWLHWMWKBIE
      EWMVIEUCZWAEUCZPPZWIVIWAGKZLZWAVIGKZLZPZWJWIWGVMPZVSWDPZPZWPXAVMWDPZWGVSP
      ZPXFWDVMPZPWIXDXEXGXFVMWDUDUEVMVSWDWGUFWGVMVSWDUFUGWPXBWRXCWTWNXBWROWMWOW
      NWGVMWRVMVKCFNZLWNWGPZWRVKCFUHXIWQXHXIWQVIVOGKZDFNZXHWFWQXKOCVIECBQZWEWQV
      QXKVJVIWAGRXLVPXJDFVJVIVOGRUIUJUOVKXJCDFVJVOVIGSUKULUMTUNUPWOXCWTOWMWNWOV
      SWDWTWDWBCFNZLWOVSPZWTWBCFUHXNWSXMXNWSWAVOGKZDFNZXMVRWSXPOCWAECIQZVNWSVQX
      PVJWAVIGRXQVPXODFVJWAVOGRUIUJUOWBXOCDFVJVOWAGSUKULUMTUNUQURTEVIWAGVDUSUTV
      EVTWHBIEWJVMWDVSWGWJVLWCCFWJVKWBVIWAVJGRVAVBWJVRWFCEWJVNWEVQVIWAVJGSVCVBV
      FVGVH $.

    $( A supremum is a set.  (Contributed by NM, 22-May-1999.)  (Revised by
       Mario Carneiro, 24-Dec-2016.) $)
    supexd $p |- ( ph -> sup ( B , A , R ) e. _V ) $=
      ( vx vy vz csup cv wbr wn wral wrex wi wa crab cuni cvv wcel df-sup supmo
      wrmo rmorabex uniexg 3syl syl5eqel ) ACBDIFJZGJZDKLGCMUIUHDKUIHJDKHCNOGBM
      PZFBQZRZSFGHCBDUAAUJFBUCUKSTULSTAFGHBCDEUBUJFBUDUKSUEUFUG $.

    ${
      supeu.2 $e |- ( ph -> E. x e. A ( A. y e. B -. x R y /\
                      A. y e. A ( y R x -> E. z e. B y R z ) ) ) $.
      $( A supremum is unique.  Similar to Theorem I.26 of [Apostol] p. 24 (but
         for suprema in general).  (Contributed by NM, 12-Oct-2004.) $)
      supeu $p |- ( ph ->
                    E! x e. A ( A. y e. B -. x R y /\
                    A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
        ( cv wbr wn wral wrex wi wa wrmo wreu supmo reu5 sylanbrc ) ABJZCJZGKLC
        FMUCUBGKUCDJGKDFNOCEMPZBENUDBEQUDBERIABCDEFGHSUDBETUA $.

      $( Alternative expression for the supremum.  (Contributed by Mario
         Carneiro, 24-Dec-2016.) $)
      supval2 $p |- ( ph -> sup ( B , A , R ) =
        ( iota_ x e. A ( A. y e. B -. x R y /\
                    A. y e. A ( y R x -> E. z e. B y R z ) ) ) ) $=
        ( cv wbr wn wral wrex wi wa crio crab cuni csup wreu supeu riotauni syl
        wceq df-sup syl6reqr ) ABJZCJZGKLCFMUIUHGKUIDJGKDFNOCEMPZBEQZUJBERSZFEG
        TAUJBEUAUKULUEABCDEFGHIUBUJBEUCUDBCDFEGUFUG $.
    $}

    ${
      $d x y C $.
      $( Sufficient condition for an element to be equal to the supremum.
         (Contributed by Mario Carneiro, 21-Apr-2015.) $)
      eqsup $p |- ( ph -> ( ( C e. A /\ A. y e. B -. C R y /\
       A. y e. A ( y R C -> E. z e. B y R z ) ) -> sup ( B , A , R ) = C ) ) $=
        ( vx wcel cv wbr wn wral wrex wi wceq wa ralbidv syl2anc w3a wor adantr
        csup crio simpr1 3simpc adantl breq1 notbid breq2 imbi1d anbi12d rspcev
        supval2 wreu wb supeu riota2 mpbid eqtrd ex ) AFDJZFBKZGLZMZBENZVDFGLZV
        DCKGLCEOZPZBDNZUAZEDGUDZFQAVLRZVMIKZVDGLZMZBENZVDVOGLZVIPZBDNZRZIDUEZFV
        NIBCDEGADGUBVLHUCZVNVCVGVKRZWBIDOAVCVGVKUFZVLWEAVCVGVKUGUHZWBWEIFDVOFQZ
        VRVGWAVKWHVQVFBEWHVPVEVOFVDGUIUJSWHVTVJBDWHVSVHVIVOFVDGUKULSUMZUNTZUOVN
        WEWCFQZWGVNVCWBIDUPWEWKUQWFVNIBCDEGWDWJURWBWEIDFWIUSTUTVAVB $.

      $d y ph $.
      eqsupd.2 $e |- ( ph -> C e. A ) $.
      eqsupd.3 $e |- ( ( ph /\ y e. B ) -> -. C R y ) $.
      eqsupd.4 $e |- ( ( ph /\ ( y e. A /\ y R C ) ) -> E. z e. B y R z ) $.
      $( Sufficient condition for an element to be equal to the supremum.
         (Contributed by Mario Carneiro, 21-Apr-2015.) $)
      eqsupd $p |- ( ph -> sup ( B , A , R ) = C ) $=
        ( wcel cv wbr wn wral wrex wi csup ralrimiva wceq expr eqsup mp3and ) A
        FDLFBMZGNOZBEPUEFGNZUECMGNCEQZRZBDPEDGSFUAIAUFBEJTAUIBDAUEDLUGUHKUBTABC
        DEFGHUCUD $.
    $}

    supcl.2 $e |- ( ph -> E. x e. A ( A. y e. B -. x R y /\
                      A. y e. A ( y R x -> E. z e. B y R z ) ) ) $.
    $( A supremum belongs to its base class (closure law).  See also ~ supub
       and ~ suplub .  (Contributed by NM, 12-Oct-2004.) $)
    supcl $p |- ( ph -> sup ( B , A , R ) e. A ) $=
      ( csup cv wbr wn wral wrex wi wa crio supval2 wreu wcel supeu riotacl syl
      eqeltrd ) AFEGJBKZCKZGLMCFNUGUFGLUGDKGLDFOPCENQZBERZEABCDEFGHISAUHBETUIEU
      AABCDEFGHIUBUHBEUCUDUE $.

    $( A supremum is an upper bound.  See also ~ supcl and ~ suplub .

       This proof demonstrates how to expand an iota-based definition
       ( ~ df-iota ) using ~ riotacl2 .

       (Contributed by NM, 12-Oct-2004.)  (Proof shortened by Mario Carneiro,
       24-Dec-2016.) $)
    supub $p |- ( ph -> ( C e. B -> -. sup ( B , A , R ) R C ) ) $=
      ( vw cv wbr wn wral wcel wi syl wceq notbid csup crab wrex wa a1i ss2rabi
      simpl crio supval2 wreu supeu riotacl2 eqeltrd sseldi breq2 cbvralv breq1
      ralbidv syl5bb elrab simprbi rspccv ) AFEHUAZKLZHMZNZKFOZGFPVCGHMZNZQAVCB
      LZCLZHMZNZCFOZBEUBZPZVGAVNVKVJHMVKDLHMDFUCQCEOZUDZBEUBZVOVCVRVNBEVRVNQVJE
      PVNVQUGUEUFAVCVRBEUHZVSABCDEFHIJUIAVRBEUJVTVSPABCDEFHIJUKVRBEULRUMUNVPVCE
      PVGVNVGBVCEVNVJVDHMZNZKFOVJVCSZVGVMWBCKFVKVDSVLWAVKVDVJHUOTUPWCWBVFKFWCWA
      VEVJVCVDHUQTURUSUTVARVFVIKGFVDGSVEVHVDGVCHUOTVBR $.

    $d z C $.
    $( A supremum is the least upper bound.  See also ~ supcl and ~ supub .
       (Contributed by NM, 13-Oct-2004.)  (Revised by Mario Carneiro,
       24-Dec-2016.) $)
    suplub $p |- ( ph -> ( ( C e. A /\ C R sup ( B , A , R ) ) ->
                    E. z e. B C R z ) ) $=
      ( vw cv wbr wrex wi wral wcel wceq breq1 syl csup wa crab rexbidv imbi12d
      wn simpr cbvralv sylib a1i ss2rabi crio supval2 wreu supeu eqeltrd sseldi
      riotacl2 breq2 imbi1d ralbidv elrab simprbi rspccv imp3a ) AKLZFEHUAZHMZV
      FDLZHMZDFNZOZKEPZGEQZGVGHMZUBGVIHMZDFNZOAVGVFBLZHMZVKOZKEPZBEUCZQZVMAVRCL
      ZHMUFCFPZWDVRHMZWDVIHMZDFNZOZCEPZUBZBEUCZWBVGWKWABEWKWAOVREQWKWJWAWEWJUGW
      IVTCKEWDVFRZWFVSWHVKWDVFVRHSWMWGVJDFWDVFVIHSUDUEUHUIUJUKAVGWKBEULZWLABCDE
      FHIJUMAWKBEUNWNWLQABCDEFHIJUOWKBEURTUPUQWCVGEQVMWAVMBVGEVRVGRZVTVLKEWOVSV
      HVKVRVGVFHUSUTVAVBVCTVMVNVOVQVLVOVQOKGEVFGRZVHVOVKVQVFGVGHSWPVJVPDFVFGVIH
      SUDUEVDVET $.

    ${
      suplub2.3 $e |- ( ph -> B C_ A ) $.
      $( Bidirectional form of ~ suplub .  (Contributed by Mario Carneiro,
         6-Sep-2014.) $)
      suplub2 $p |- ( ( ph /\ C e. A ) ->
                    ( C R sup ( B , A , R ) <-> E. z e. B C R z ) ) $=
        ( vw wcel wa wbr cv wrex breq2 wi ad2antrr csup expdimp cbvrexv biimprd
        suplub wceq a1i wor simplr adantr sselda supcl sotr syl13anc exp3acom23
        wss wo supub imp sotric syl12anc con2bid mpbird mpjaod rexlimdva syl5bi
        wn wb impbid ) AGEMZNZGFEHUAZHOZGDPZHOZDFQZAVJVMVPABCDEFGHIJUEUBVPGLPZH
        OZLFQVKVMVOVRDLFVNVQGHRUCVKVRVMLFVKVQFMZNZVLVQUFZVRVMSZVQVLHOZWAWBSVTWA
        VMVRVLVQGHRUDUGVTVRWCVMVTEHUHZVJVQEMZVLEMZVRWCNVMSAWDVJVSITZAVJVSUIVKFE
        VQAFEUPVJKUJUKZAWFVJVSABCDEFHIJULTZEGVQVLHUMUNUOVTWAWCUQZVLVQHOZVGZVKVS
        WLAVSWLSVJABCDEFVQHIJURUJUSVTWKWJVTWDWFWEWKWJVGVHWGWIWHEVLVQHUTVAVBVCVD
        VEVFVI $.
    $}

    $( An upper bound is not less than the supremum.  (Contributed by NM,
       13-Oct-2004.) $)
    supnub $p |- ( ph -> ( ( C e. A /\ A. z e. B -. C R z ) ->
                    -. C R sup ( B , A , R ) ) ) $=
      ( wcel cv wbr wn wral csup wa wrex suplub expdimp dfrex2 syl6ib expimpd
      con2d ) AGEKZGDLHMZNDFOZGFEHPHMZNAUEQZUHUGUIUHUFDFRZUGNAUEUHUJABCDEFGHIJS
      TUFDFUAUBUDUC $.
  $}

  ${
    supex.1 $e |- R Or A $.
    $( A supremum is a set.  (Contributed by NM, 22-May-1999.) $)
    supex $p |- sup ( B , A , R ) e. _V $=
      ( wor csup cvv wcel id supexd ax-mp ) ACEZBACFGHDLABCLIJK $.
  $}

  ${
    $d x A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    $( A set that contains the greatest element satisfies the antecedent in
       supremum theorems.  This allows ` sup ( A , B , R ) ` to be used in some
       situations without the completeness axiom.  (Contributed by Jeff
       Hoffman, 17-Jun-2008.) $)
    supmaxlem $p |- ( ( C e. A /\ C e. B /\ A. z e. B -. C R z ) -> E. x e. A
         ( A. y e. B -. x R y /\ A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
      ( wcel cv wbr wn wral wrex wi wa breq2 rspcev wceq notbid ralbidv cbvralv
      ex ralrimivw biimpi anim12ci breq1 imbi1d anbi12d sylan2 3impb ) FDHZFEHZ
      FCIZGJZKZCELZAIZBIZGJZKZBELZURUQGJZURUMGJZCEMZNZBDLZOZADMZULUPOUKFURGJZKZ
      BELZURFGJZVDNZBDLZOZVHULVNUPVKULVMBDULVLVDVCVLCFEUMFURGPQUBUCUPVKUOVJCBEU
      MURRUNVIUMURFGPSUAUDUEVGVOAFDUQFRZVAVKVFVNVPUTVJBEVPUSVIUQFURGUFSTVPVEVMB
      DVPVBVLVDUQFURGPUGTUHQUIUJ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d R x y z $.  $d y ph $.
    supmax.1 $e |- ( ph -> R Or A ) $.
    supmax.2 $e |- ( ph -> C e. A ) $.
    supmax.3 $e |- ( ph -> C e. B ) $.
    supmax.4 $e |- ( ( ph /\ y e. B ) -> -. C R y ) $.
    $( The greatest element of a set is its supremum.  Note that the converse
       is not true; the supremum might not be an element of the set
       considered.  (Contributed by Jeff Hoffman, 17-Jun-2008.) $)
    supmax $p |- ( ph -> sup ( B , A , R ) = C ) $=
      ( vx vz csup wbr wn wcel cv wral wrex wa wceq ralrimiva supmaxlem syl3anc
      wi supub mpd supnub mp2and wor wb supcl sotrieq2 syl12anc mpbir2and ) ADC
      FMZEUAZUPEFNOZEUPFNOZAEDPZURIAKLBCDEFGAECPZUTEBQZFNOZBDRZKQZLQZFNOLDRVFVE
      FNVFVBFNBDSUELCRTKCSHIAVCBDJUBZKLBCDEFUCUDZUFUGAVAVDUSHVGAKLBCDEFGVHUHUIA
      CFUJUPCPVAUQURUSTUKGAKLBCDFGVHULHCUPEFUMUNUO $.
  $}

  ${
    $d A x y z $.  $d R x y z $.  $d B x y z $.
    $( A finite set satisfies the conditions to have a supremum.  (Contributed
       by Mario Carneiro, 28-Apr-2015.) $)
    fisup2g $p |- ( ( R Or A /\ ( B e. Fin /\ B =/= (/) /\ B C_ A ) ) ->
      E. x e. B ( A. y e. B -. x R y /\
        A. y e. A ( y R x -> E. z e. B y R z ) ) ) $=
      ( wor cfn wcel c0 wne wss w3a wa cv wbr wn wral wrex wi wreu simp1 fisupg
      soss supeu 3exp syl6 com4l 3imp2 reurex breq2 rspcev ralrimivw a1d anim2d
      ex reximia 3syl ) DFGZEHIZEJKZEDLZMNAOZBOZFPQBERZVDVCFPZVDCOZFPZCESZTZBER
      ZNZAEUAZVLAESVEVJBDRZNZAESUSUTVAVBVMVBUSUTVAVMVBUSEFGZUTVAVMTTEDFUDVPUTVA
      VMVPUTVAMABCEEFVPUTVAUBABCEFUCUEUFUGUHUIVLAEUJVLVOAEVCEIZVKVNVEVQVNVKVQVJ
      BDVQVFVIVHVFCVCEVGVCVDFUKULUPUMUNUOUQUR $.

    $( A nonempty finite set contains its supremum.  (Contributed by Jeff
       Madsen, 9-May-2011.) $)
    fisupcl $p |- ( ( R Or A /\ ( B e. Fin /\ B =/= (/) /\ B C_ A ) )
                                    -> sup ( B , A , R ) e. B ) $=
      ( vx vy vz wor cfn wcel c0 wa cv wbr wral wrex wi crio sylc wreu supeu wn
      wne wss w3a csup simpl simpr3 fisup2g ssrexv supval2 wceq breq2 rspcev ex
      ralrimivw a1d anim2d rgen a1i soss simpr1 simpr2 fisupg riotass2 syl22anc
      syl3anc riotacl syl eqeltrrd eqeltrd ) ACGZBHIZBJUBZBAUCZUDZKZBACUEDLZELZ
      CMUAEBNZVRVQCMZVRFLZCMZFBOZPZEANZKZDAQZBVPDEFABCVKVOUFZVPVNWFDBOWFDAOVKVL
      VMVNUGZDEFABCUHWFDBAUIRZUJVPVSWDEBNZKZDBQZWGBVPVNWLWFPZDBNZWLDBOZWFDASWMW
      GUKWIWOVPWNDBVQBIZWKWEVSWQWEWKWQWDEAWQVTWCWBVTFVQBWAVQVRCULUMUNUOUPUQURUS
      VPBCGZVLVMWPVPVNVKWRWIWHBACUTRZVKVLVMVNVAVKVLVMVNVBDEFBCVCVFZVPDEFABCWHWJ
      TWLWFDBAVDVEVPWLDBSWMBIVPDEFBBCWSWTTWLDBVGVHVIVJ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    $( The supremum of a pair.  (Contributed by NM, 17-Jun-2007.)  (Proof
       shortened by Mario Carneiro, 24-Dec-2016.) $)
    suppr $p |- ( ( R Or A /\ B e. A /\ C e. A ) -> sup ( { B , C } , A , R ) =
                if ( C R B , B , C ) ) $=
      ( vy wor wcel w3a cpr wbr 3adant1 wn wceq breq1 notbid adantr ifbothda wa
      sonr breq2 cif simp1 ifcl ifpr cv wral 3adant3 simpr wi so2nr 3impb imnan
      3com23 sylibr imp 3adant2 wb ralprg mpbir2and r19.21bi supmax ) ADFZBAGZC
      AGZHZEABCIZCBDJZBCUAZDVBVCVDUBVCVDVHAGVBVGBCAUCKVCVDVHVFGVBVGBCAAUDKVEVHE
      UEZDJZLZEVFVEVKEVFUFZVHBDJZLZVHCDJZLZVGBBDJZLZVGLZVNVEBCBVHMZVQVMBVHBDNOC
      VHMZVGVMCVHBDNOVEVRVGVBVCVRVDABDSUGPVEVSUHQVGBCDJZLZCCDJZLZVPVEBCVTWBVOBV
      HCDNOWAWDVOCVHCDNOVEVGWCVEVGWBRLZVGWCUIVBVDVCWFVBVDVCWFACBDUJUKUMVGWBULUN
      UOVEWEVSVBVDWEVCACDSUPPQVCVDVLVNVPRUQVBVKVNVPEBCAAVIBMVJVMVIBVHDTOVICMVJV
      OVICVHDTOURKUSUTVA $.

    $( The supremum of a singleton.  (Contributed by NM, 2-Oct-2007.) $)
    supsn $p |- ( ( R Or A /\ B e. A ) -> sup ( { B } , A , R ) = B ) $=
      ( wor wcel wa csn csup wbr cif cpr dfsn2 supeq1i wceq suppr 3anidm23 ifid
      syl5eq syl6eq ) ACDZBAEZFZBGZACHZBBCIZBBJZBUBUDBBKZACHZUFAUCUGCBLMTUAUHUF
      NABBCOPRUEBQS $.
  $}

  ${
    $d u v w x y z A $.  $d u v w x y z C $.  $d w y z D $.  $d u w ph $.
    $d u v w x y z F $.  $d u w x y z R $.  $d u v w x y z S $.
    $d u v w x y z B $.
    supiso.1 $e |- ( ph -> F Isom R , S ( A , B ) ) $.
    supiso.2 $e |- ( ph -> C C_ A ) $.
    $( Lemma for ~ supiso .  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    supisolem $p |- ( ( ph /\ D e. A ) ->
      ( ( A. y e. C -. D R y /\ A. y e. A ( y R D -> E. z e. C y R z ) ) <->
        ( A. w e. ( F " C ) -. ( F ` D ) S w /\
          A. w e. B ( w S ( F ` D ) -> E. v e. ( F " C ) w S v ) ) ) ) $=
      ( wa wcel wbr wral wb adantr wiso wss cv wn wrex wi cfv jca simpll simplr
      cima sselda isorel syl12anc notbid ralbidva wfn wf1o syl f1ofn wceq breq2
      isof1o ralima syl2anc bitr4d simpr rexima imbi12d wfo f1ofo breq1 rexbidv
      rexbidva cbvfo 3syl bitrd anbi12d sylan ) AFGJKLUAZHFUBZOZIFPZIBUCZJQZUDZ
      BHRZWDIJQZWDCUCZJQZCHUEZUFZBFRZOILUGZDUCZKQZUDZDLHUKZRZWOWNKQZWOEUCZKQZEW
      RUEZUFZDGRZOSAVTWAMNUHWBWCOZWGWSWMXEXFWGWNWDLUGZKQZUDZBHRZWSXFWFXIBHXFWDH
      PZOZWEXHXLVTWCWDFPZWEXHSXFVTXKVTWAWCUIZTWBWCXKUJXFHFWDVTWAWCUJZULFGIWDJKL
      UMUNUOUPXFLFUQZWAWSXJSXFFGLURZXPXFVTXQXNFGJKLVCUSZFGLUTUSZXOWQXIDBFHLWOXG
      VAWPXHWOXGWNKVBUOVDVEVFXFWMXGWNKQZXGXAKQZEWRUEZUFZBFRZXEXFWLYCBFXFXMOZWHX
      TWKYBYEVTXMWCWHXTSXFVTXMXNTZXFXMVGWBWCXMUJFGWDIJKLUMUNYEWKXGWILUGZKQZCHUE
      ZYBYEWJYHCHYEWIHPZOVTXMWIFPWJYHSYEVTYJYFTXFXMYJUJYEHFWIXFWAXMXOTZULFGWDWI
      JKLUMUNVNYEXPWAYBYISXFXPXMXSTYKYAYHECFHLXAYGXGKVBVHVEVFVIUPXFXQFGLVJYDXES
      XRFGLVKYCXDBDFGLXGWOVAZXTWTYBXCXGWOWNKVLYLYAXBEWRXGWOXAKVLVMVIVOVPVQVRVS
      $.

    supisoex.3 $e |- ( ph -> E. x e. A ( A. y e. C -. x R y /\
                      A. y e. A ( y R x -> E. z e. C y R z ) ) ) $.
    $( Lemma for ~ supiso .  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    supisoex $p |- ( ph -> E. u e. B ( A. w e. ( F " C ) -. u S w /\
          A. w e. B ( w S u -> E. v e. ( F " C ) w S v ) ) ) $=
      ( cv wbr wral wi wn wrex wa cima wiso wss wcel simpl simpr supisolem wf1o
      cfv wf isof1o f1of 3syl ffvelrnda wceq breq1 notbid ralbidv breq2 anbi12d
      imbi1d rspcev ex syl sylbid rexlimdva syl2anc mpd ) ABQZCQZKRUACJSVMVLKRV
      MDQKRDJUBTCHSUCZBHUBZGQZEQZLRZUAZEMJUDZSZVQVPLRZVQFQLRFVTUBZTZEISZUCZGIUB
      ZPAHIKLMUEZJHUFZVOWGTNOWHWIUCZVNWGBHWJVLHUGUCZVNVLMULZVQLRZUAZEVTSZVQWLLR
      ZWCTZEISZUCZWGWJCDEFHIJVLKLMWHWIUHZWHWIUIUJWKWLIUGZWSWGTWJHIVLMWJWHHIMUKH
      IMUMWTHIKLMUNHIMUOUPUQXAWSWGWFWSGWLIVPWLURZWAWOWEWRXBVSWNEVTXBVRWMVPWLVQL
      USUTVAXBWDWQEIXBWBWPWCVPWLVQLVBVDVAVCVEVFVGVHVIVJVK $.

    supiso.4 $e |- ( ph -> R Or A ) $.
    $( Image of a supremum under an isomorphism.  (Contributed by Mario
       Carneiro, 24-Dec-2016.) $)
    supiso $p |- ( ph ->
      sup ( ( F " C ) , B , S ) = ( F ` sup ( C , A , R ) ) ) $=
      ( vw vv vu cv wbr wral cima csup cfv wor wiso isoso syl mpbid wf1o isof1o
      wb wf f1of 3syl supcl ffvelrnd wn wrex wi supub ralrimiv suplub supisolem
      wa wcel exp3a mpdan mpbi2and simpld r19.21bi simprd impr eqsupd ) AOPFJGU
      AZGEHUBZJUCZIAEHUDZFIUDZNAEFHIJUEZVQVRUKKEFHIJUFUGUHAEFVOJAVSEFJUIEFJULKE
      FHIJUJEFJUMUNABCDEGHNMUOZUPAVPORZISUQZOVNAWBOVNTZWAVPISZWAPRISPVNURZUSZOF
      TZAVOQRZHSUQZQGTZWHVOHSZWHDRHSDGURZUSZQETZWCWGVDZAWIQGABCDEGWHHNMUTVAAWMQ
      EAWHEVEWKWLABCDEGWHHNMVBVFVAAVOEVEWJWNVDWOUKVTAQDOPEFGVOHIJKLVCVGVHZVIVJA
      WAFVEWDWEAWFOFAWCWGWPVKVJVLVM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Ordinal isomorphism, Hartog's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c OrdIso $.

  $( Extend class definition to include the canonical order isomorphism to an
     ordinal. $)
  coi $a class OrdIso ( R , A ) $.

  ${
    $d h j t u v w x z A $.  $d h j t u v w x z R $.
    $( Define the canonical order isomorphism from the well-order ` R ` on
       ` A ` to an ordinal.  (Contributed by Mario Carneiro, 23-May-2015.) $)
    df-oi $a |- OrdIso ( R , A ) = if ( ( R We A /\ R Se A ) ,
      ( recs ( ( h e. _V |->
      ( iota_ v e. { w e. A | A. j e. ran h j R w }
           A. u e. { w e. A | A. j e. ran h j R w } -. u R v ) ) ) |`
       { x e. On | E. t e. A A. z e. ( recs ( ( h e. _V |->
      ( iota_ v e. { w e. A | A. j e. ran h j R w }
           A. u e. { w e. A | A. j e. ran h j R w } -. u R v ) ) ) " x )
      z R t } ) , (/) ) $.
  $}

  ${
    $d h j t u v w x z A $.  $d u v C $.  $d z F $.  $d h j t u v w x z R $.
    dfoi.1 $e |- C = { w e. A | A. j e. ran h j R w } $.
    dfoi.2 $e |- G = ( h e. _V |-> ( iota_ v e. C A. u e. C -. u R v ) ) $.
    dfoi.3 $e |- F = recs ( G ) $.
    $( Rewrite ~ df-oi with abbreviations.  (Contributed by Mario Carneiro,
       24-Jun-2015.) $)
    dfoi $p |- OrdIso ( R , A ) = if ( ( R We A /\ R Se A ) , ( F |`
       { x e. On | E. t e. A A. z e. ( F " x ) z R t } ) , (/) ) $=
      ( cvv cv wral wceq coi wwe wse wa wbr crab crio cmpt crecs cima wrex con0
      wn crn cres c0 cif df-oi wcel a1i riotaeqbidv mpteq2ia eqtri recseq ax-mp
      raleqdv wb imaeq1i raleqi rexbii rabbiia reseq12i ifeq1 eqtr4i ) GIUAGIUB
      GIUCUDZJQERDRIUEUMZEKRCRIUEKJRZUNSCGUFZSZDVRUGZUHZUIZBRFRIUEZBWBARZUJZSZF
      GUKZAULUFZUOZUPUQZVOLWCBLWDUJZSZFGUKZAULUFZUOZUPUQZABCDEFGIJKURWOWITWPWJT
      LWBWNWHLMUIZWBPMWATWQWBTMJQVPEHSZDHUGZUHWAOJQWSVTVQQUSZWRVSDHVRHVRTWTNUTZ
      WTVPEHVRXAVFVAVBVCMWAVDVEVCZWMWGAULWMWGVGWDULUSWLWFFGWCBWKWELWBWDXBVHVIVJ
      UTVKVLVOWOWIUPVMVEVN $.
  $}

  ${
    $d h j t u v w x z A $.  $d h j t u v w x z B $.  $d h j t u v w x z R $.
    $d h j t u v w x z S $.
    $( Equality theorem for ordinal isomorphism.  (Contributed by Mario
       Carneiro, 23-May-2015.) $)
    oieq1 $p |- ( R = S -> OrdIso ( R , A ) = OrdIso ( S , A ) ) $=
      ( vh vu vv vj vw vz vt vx wceq cvv cv wbr wral crab con0 c0 breq wwe crio
      wse wa wn crn cmpt crecs cima wrex cres cif weeq1 anbi12d ralbidv rabbidv
      coi notbid raleqbidv riotaeqbidv mpteq2dv recseq imaeq1d rexbidv reseq12d
      seeq1 syl eqidd ifbieq12d df-oi 3eqtr4g ) BCLZABUAZABUCZUDZDMENZFNZBOZUEZ
      EGNZHNZBOZGDNUFZPZHAQZPZFWEUBZUGZUHZINZJNZBOZIWIKNZUIZPZJAUJZKRQZUKZSULAC
      UAZACUCZUDZDMVPVQCOZUEZEVTWACOZGWCPZHAQZPZFXFUBZUGZUHZWJWKCOZIXJWMUIZPZJA
      UJZKRQZUKZSULABUQACUQVLVOXAWRSXPSVLVMWSVNWTABCUMABCVFUNVLWIXJWQXOVLWHXILW
      IXJLVLDMWGXHVLWFXGFWEXFVLWDXEHAVLWBXDGWCVTWABCTUOUPZVLVSXCEWEXFXQVLVRXBVP
      VQBCTURUSUTVAWHXIVBVGZVLWPXNKRVLWOXMJAVLWLXKIWNXLVLWIXJWMXRVCWJWKBCTUSVDU
      PVEVLSVHVIKIHFEJABDGVJKIHFEJACDGVJVK $.

    $( Equality theorem for ordinal isomorphism.  (Contributed by Mario
       Carneiro, 23-May-2015.) $)
    oieq2 $p |- ( A = B -> OrdIso ( R , A ) = OrdIso ( R , B ) ) $=
      ( vh vu vv vj vw vz vt vx wceq wwe cvv cv wbr wral crab con0 c0 wse wa wn
      crn crio cmpt crecs cima wrex cif weeq2 seeq2 anbi12d raleqdv riotaeqbidv
      cres coi rabeq mpteq2dv syl imaeq1d rexeqbi1dv rabbidv reseq12d ifbieq12d
      recseq eqidd df-oi 3eqtr4g ) ABLZACMZACUAZUBZDNEOFOCPUCZEGOHOCPGDOUDQZHAR
      ZQZFVPUEZUFZUGZIOJOCPZIVTKOZUHZQZJAUIZKSRZUPZTUJBCMZBCUAZUBZDNVNEVOHBRZQZ
      FWKUEZUFZUGZWAIWOWBUHZQZJBUIZKSRZUPZTUJACUQBCUQVJVMWJWGTWTTVJVKWHVLWIABCU
      KABCULUMVJVTWOWFWSVJVSWNLVTWOLVJDNVRWMVJVQWLFVPWKVOHABURZVJVNEVPWKXAUNUOU
      SVSWNVFUTZVJWEWRKSWDWQJABVJWAIWCWPVJVTWOWBXBVAUNVBVCVDVJTVGVEKIHFEJACDGVH
      KIHFEJBCDGVHVI $.
  $}

  ${
    $d a h j t u v w x y z $.  $d a h j t u v w y z A $.
    $d a h j t u v w y z R $.
    nfoi.1 $e |- F/_ x R $.
    nfoi.2 $e |- F/_ x A $.
    $( Hypothesis builder for ordinal isomorphism.  (Contributed by Mario
       Carneiro, 23-May-2015.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfoi $p |- F/_ x OrdIso ( R , A ) $=
      ( vh vu vv vj vw vz vt va cvv cv wbr wral con0 c0 nfcv coi wwe wse wa crn
      crab crio cmpt crecs cima wrex cres df-oi nfwe nfse nfan nfbr nfral nfrab
      wn cif nfn nfriota nfmpt nfrecs nfima nfrex nfres nfif nfcxfr ) ABCUABCUB
      ZBCUCZUDZFNGOZHOZCPZUTZGIOZJOZCPZIFOUEZQZJBUFZQZHWCUGZUHZUIZKOZLOZCPZKWGM
      OZUJZQZLBUKZMRUFZULZSVAMKJHGLBCFIUMVMAWPSVKVLAABCDEUNABCDEUOUPAWGWOAWFAFN
      WEANTWDAHWCVQAGWCWBAJBVTAIWAAWATAVRVSCAVRTDAVSTUQUREUSZVPAAVNVOCAVNTDAVOT
      UQVBURWQVCVDVEZWNAMRWMALBEWJAKWLAWGWKWRAWKTVFAWHWICAWHTDAWITUQURVGARTUSVH
      ASTVIVJ $.
  $}

  ${
    $d f w x y z A $.  $d f w x y z B $.  $d w x y z F $.
    $( Generalize ~ ordiso to proper classes.  (Contributed by Mario Carneiro,
       24-Jun-2015.) $)
    ordiso2 $p |- ( ( F Isom _E , _E ( A , B ) /\ Ord A /\ Ord B ) ->
                    A = B ) $=
      ( vx vy vz vw cep cv cfv wceq wral wcel wi fveq2 id eqeq12d wa wb syl w3a
      wiso word wss ordsson 3ad2ant2 sseld eleq1 imbi12d imbi2d r19.21v ordelss
      con0 3ad2antl2 sselda ralbidva ccnv wf1o isof1o 3ad2ant1 ad2antrr simpll3
      pm5.5 simpr wf f1of simplrl ffvelrn syl2anc ordtr1 sylc f1ocnvfv2 eqeltrd
      jca wbr simpll1 f1ocnv 3syl isorel syl12anc vex epelc fvex 3bitr3g mpbird
      simplrr rspcv eqtr3d simprr rspccva sylan epel adantl simpl2 simprl mpbid
      biimpri sylib eqeltrrd impbida eqrdv sylbid ex com23 a2i a1i syl5bi tfis2
      expr com3l mpdd ralrimiv adantll 3ad2antl1 adantlr wrex simpl1 f1ofo forn
      crn wfo eleq2d wfn f1ofn adantr fvelrnb bitr3d simpl exp43 syldd rexlimdv
      simplr imp impbid mpdan ) ABHHCUBZAUCZBUCZUAZDIZCJZYTKZDALZABKYSUUBDAYSYT
      AMZYTUMMZUUBYSAUMYTYQYPAUMUDYRAUEUFUGUUEYSUUDUUBYSUUDUUBNZNZYSEIZAMZUUHCJ
      ZUUHKZNZNZDEYTUUHKZUUFUULYSUUNUUDUUIUUBUUKYTUUHAUHUUNUUAUUJYTUUHYTUUHCOUU
      NPQUIUJUUMEYTLYSUULEYTLZNZUUEUUGYSUULEYTUKUUPUUGNUUEYSUUOUUFYSUUDUUOUUBYS
      UUDUUOUUBNYSUUDRZUUOUUKEYTLZUUBUUQUULUUKEYTUUQUUHYTMRUUIUULUUKSUUQYTAUUHY
      QYPUUDYTAUDZYRAYTULZUNUOUUIUUKVCTUPYSUUDUURUUBYSUUDUURRZRZFUUAYTUVBFIZUUA
      MZUVCYTMZUVBUVDRZUVCUVCCUQZJZYTUVFUVHCJZUVCUVHUVFABCURZUVCBMZUVIUVCKYSUVJ
      UVAUVDYPYQUVJYRABHHCUSZUTVAZUVFYRUVDUUABMZRUVKYPYQYRUVAUVDVBUVFUVDUVNUVBU
      VDVDZUVFABCVEZUUDUVNYSUVPUVAUVDYPYQUVPYRYPUVJUVPUVLABCVFTZUTVAYSUUDUURUVD
      VGZABYTCVHVIVNUVCUUABVJVKZABUVCCVLVIZUVFUVHYTMZUURUVIUVHKZUVFUWAUVIUUAMZU
      VFUVIUVCUUAUVTUVOVMUVFUVHYTHVOZUVIUUAHVOZUWAUWCUVFYPUVHAMZUUDUWDUWESYPYQY
      RUVAUVDVPUVFBAUVGVEZUVKUWFUVFUVJBAUVGURUWGUVMABCVQBAUVGVFVRUVSBAUVCUVGVHV
      IUVRABUVHYTHHCVSVTUVHYTDWAWBUVIUUAYTCWCZWBWDWEZYSUUDUURUVDWFUUKUWBEUVHYTU
      UHUVHKZUUJUVIUUHUVHUUHUVHCOUWJPQWGVKWHUWIVMUVBUVERZUVCCJZUVCUUAUVBUURUVEU
      WLUVCKZYSUUDUURWIUUKUWMEUVCYTUUHUVCKZUUJUWLUUHUVCUUHUVCCOUWNPQWJWKUWKUWLU
      UAHVOZUWLUUAMUWKUVCYTHVOZUWOUVEUWPUVBUWPUVEFDWLWQWMUWKYPUVCAMZUUDUWPUWOSY
      PYQYRUVAUVEVPUVBYTAUVCUVBYQUUDUUSYPYQYRUVAWNYSUUDUURWOUUTVIUOYSUUDUURUVEV
      GABUVCYTHHCVSVTWPUWLUUAUWHWBWRWSWTXAXIXBXCXDXEXFXGXHXJXKXLYSUUCRZFABUWRUW
      QUVKUWRUWQUVKUWRUWQRUWLUVCBUUCUWQUWMYSUUBUWMDUVCAYTUVCKZUUAUWLYTUVCYTUVCC
      OUWSPQWJXMYSUWQUWLBMZUUCYPYQUWQUWTYRYPUVPUWQUWTUVQABUVCCVHWKXNXOWSXCUWRUV
      KGIZCJZUVCKZGAXPZUWQUWRUVCCXTZMZUVKUXDUWRUXEBUVCUWRYPUXEBKZYPYQYRUUCXQYPU
      VJABCYAUXGUVLABCXRABCXSVRTYBUWRCAYCZUXFUXDSYSUXHUUCYPYQUXHYRYPUVJUXHUVLAB
      CYDTUTYEGAUVCCYFTYGUWRUXCUWQGAYSUUCUXAAMZUXCUWQNZNYSUXIUUCUXJYSUXIUUCUXBU
      XAKZUXJUXIUUCUXKNNYSUUBUXKDUXAAYTUXAKZUUAUXBYTUXAYTUXACOUXLPQWGXFYSUXIUXK
      UXCUWQYSUXIRZUXKUXCRZRUVCUXAAUXNUVCUXAKUXMUXNUXBUVCUXAUXKUXCVDUXKUXCYHWHW
      MYSUXIUXNYLVMYIYJXDYMYKXBYNXAYO $.

    $( Order-isomorphic ordinal numbers are equal.  (Contributed by Jeff
       Hankins, 16-Oct-2009.)  (Proof shortened by Mario Carneiro,
       24-Jun-2015.) $)
    ordiso $p |- ( ( A e. On /\ B e. On ) -> ( A = B
                <-> E. f f Isom _E , _E ( A , B ) ) ) $=
      ( con0 wcel wa wceq cep wiso wex cid cres cvv resiexg isoid isoeq1 spcegv
      cv word eloni ee10 adantr isoeq5 exbidv syl5ibcom wi ordiso2 3coml 3expia
      syl2an exlimdv impbid ) ADEZBDEZFZABGZABHHCRZIZCJZUOAAHHUQIZCJZUPUSUMVAUN
      UMKALZMEAAHHVBIZVAADNAHOUTVCCVBMAAHHVBUQPQUAUBUPUTURCAABHHUQUCUDUEUOURUPC
      UMASZBSZURUPUFUNATBTVDVEURUPURVDVEUPABUQUGUHUIUJUKUL $.
  $}

  ${
    $d f r s u v C $.  $d a h j t u v w x z M $.  $d a b j u w N $.
    $d a b c f h i j m r s t u v w x y z R $.  $d a b c T $.
    $d a b c h j m r s t u v w x y z A $.  $d a b c m t u v x O $.
    $d a b m t x ph $.
    ordtypelem.1 $e |- F = recs ( G ) $.
    ordtypelem.2 $e |- C = { w e. A | A. j e. ran h j R w } $.
    ordtypelem.3 $e |- G =
      ( h e. _V |-> ( iota_ v e. C A. u e. C -. u R v ) ) $.
    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 26-Jun-2015.) $)
    ordtypecbv $p |- recs ( ( f e. _V |->
      ( iota_ s e. { y e. A | A. i e. ran f i R y }
           A. r e. { y e. A | A. i e. ran f i R y } -. r R s ) ) ) = F $=
      ( cv wral crecs cvv wbr wn crn crab crio cmpt wceq weq breq1 notbid breq2
      cbvralv ralbidv syl5bb cbvriotav cbvrabv rneq raleqdv rabbidv riotaeqbidv
      eqtri syl5eq cbvmptv recseq ax-mp eqtr2i ) LMUAZHUBOSZNSZGUCZUDZOJSZASZGU
      CZJHSZUEZTZAEUFZTZNVTUGZUHZUAZPMWCUIVIWDUIMIUBDSZCSZGUCZUDZDFTZCFUGZUHWCR
      IHUBWJWBIHUJZWJVMOFTZNFUGWBWIWLCNFWIVJWFGUCZUDZOFTCNUJZWLWHWNDOFDOUJWGWMW
      EVJWFGUKULUNWOWNVMOFWOWMVLWFVKVJGUMULUOUPUQWKWLWANFVTWKFVPJISZUEZTZAEUFZV
      TFKSZBSZGUCZKWQTZBEUFWSQXCWRBAEXCVNXAGUCZJWQTBAUJZWRXBXDKJWQWTVNXAGUKUNXE
      XDVPJWQXAVOVNGUMUOUPURVCWKWRVSAEWKVPJWQVRWPVQUSUTVAVDZWKVMOFVTXFUTVBVDVEV
      CMWCVFVGVH $.

    $d a b c h j t u v w x z F $.
    ordtypelem.5 $e |- T = { x e. On | E. t e. A A. z e. ( F " x ) z R t } $.
    ordtypelem.6 $e |- O = OrdIso ( R , A ) $.
    ordtypelem.7 $e |- ( ph -> R We A ) $.
    ordtypelem.8 $e |- ( ph -> R Se A ) $.
    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    ordtypelem1 $p |- ( ph -> O = ( F |` T ) ) $=
      ( wwe wse wa cv wbr cima wral wrex con0 crab cres cif wceq iftrue syl2anc
      c0 coi dfoi eqtri reseq2i 3eqtr4g ) AHJUDZHJUEZUFZNCUGGUGJUHCNBUGUIUJGHUK
      BULUMZUNZUSUOZVIPNKUNAVEVFVJVIUPUBUCVGVIUSUQURPHJUTVJUABCDEFGHIJLMNORSQVA
      VBKVHNTVCVD $.

    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    ordtypelem2 $p |- ( ph -> Ord T ) $=
      ( va wtr word cv wss wral wcel wbr cima wrex con0 crab ssrab2 eqsstri a1i
      wa sselda onss syl eloni weq imaeq2 raleqdv rexbidv elrab2 simprbi adantl
      wi ordelss imass2 ssralv reximdv 3syl ralrimdva ssrab syl6sseqr ralrimiva
      sylc sylanbrc dftr3 sylibr ordon trssord mp3an23 ) AKUEZKUFZAUDUGZKUHZUDK
      UIWHAWKUDKAWJKUJZUSZWJCUGGUGJUKZCNBUGZULZUIZGHUMZBUNUOZKWMWJUNUHZWRBWJUIZ
      WJWSUHWMWJUNUJZWTAKUNWJKUNUHZAKWSUNTWRBUNUPUQZURUTZWJVAVBWMWJUFZWNCNWJULZ
      UIZGHUMZXAWMXBXFXEWJVCVBWLXIAWLXBXIWRXIBWJUNKBUDVDZWQXHGHXJWNCWPXGWOWJNVE
      VFVGTVHVIVJXFXIWRBWJXFWOWJUJUSWOWJUHWPXGUHZXIWRVKWJWOVLWOWJNVMXKXHWQGHWNC
      WPXGVNVOVPVQWAWRBUNWJVRWBTVSVTUDKWCWDWHXCUNUFWIXDWEKUNWFWGVB $.

    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    ordtypelem3 $p |- ( ( ph /\ M e. ( T i^i dom F ) ) ->
        ( F ` M ) e. { v e. { w e. A | A. j e. ( F " M ) j R w } |
          A. u e. { w e. A | A. j e. ( F " M ) j R w } -. u R v } ) $=
      ( cdm cin wcel wa cfv cv wbr wn cima wral crab crio cres wceq inss2 simpr
      sseldi tfr2a syl cvv word wb wlim wfun tfr1a simpri limord ax-mp ordelord
      sylancr tfr2b mpbid crn df-ima syl6eqr raleqdv rabbidv syl5eq riotaeqbidv
      rneq riotaex fvmpt eqtrd wreu wwe wse wss c0 wne adantr ssrab2 wrex inss1
      a1i con0 imaeq2 rexbidv elrab2 simprbi breq1 cbvralv breq2 ralbidv syl5bb
      cbvrexv sylibr rabn0 wereu2 syl22anc riotacl2 eqeltrd ) APKNUEZUFZUGZUHZP
      NUIZFUJEUJJUKULZFMUJZDUJZJUKZMNPUMZUNZDHUOZUNZEYGUPZYHEYGUOZXSXTNPUQZOUIZ
      YIXSPXPUGZXTYLURXSXQXPPKXPUSAXRUTZVAZPNORVBVCXSYKVDUGZYLYIURXSYMYPYOXSPVE
      ZYMYPVFXSXPVEZYMYQXPVGZYRNVHYSNORVIVJXPVKVLYOXPPVMVNPNORVOVCVPLYKYAFIUNZE
      IUPYIVDOLUJZYKURZYTYHEIYGUUBIYDMUUAVQZUNZDHUOYGSUUBUUDYFDHUUBYDMUUCYEUUBU
      UCYKVQYEUUAYKWDNPVRVSVTWAWBZUUBYAFIYGUUEVTWCTYHEYGWEWFVCWGXSYHEYGWHZYIYJU
      GXSHJWIZHJWJZYGHWKZYGWLWMZUUFAUUGXRUCWNAUUHXRUDWNUUIXSYFDHWOWRXSYFDHWPZUU
      JXSCUJZGUJZJUKZCYEUNZGHWPZUUKXSPKUGZUUPXSXQKPKXPWQYNVAUUQPWSUGUUPUUNCNBUJ
      ZUMZUNZGHWPUUPBPWSKUURPURZUUTUUOGHUVAUUNCUUSYEUURPNWTVTXAUAXBXCVCYFUUODGH
      YFUULYCJUKZCYEUNYCUUMURZUUOYDUVBMCYEYBUULYCJXDXEUVCUVBUUNCYEYCUUMUULJXFXG
      XHXIXJYFDHXKXJEFHYGJXLXMYHEYGXNVCXO $.

    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    ordtypelem4 $p |- ( ph -> O : ( T i^i dom F ) --> A ) $=
      ( va cdm cin wf cres wfn cfv wcel wral wfun wlim tfr1a simpli funres mp1i
      cv funfn sylib dmres fneq2i wa wceq inss1 simpr sseldi fvres syl wbr cima
      wn crab ssrab2 sstri ordtypelem3 eqeltrd ffnfv sylanbrc ordtypelem1 feq1d
      ralrimiva mpbird ) AKNUEZUFZHPUGWFHNKUHZUGZAWGWFUIZUDUSZWGUJZHUKZUDWFULWH
      AWGWGUEZUIZWIAWGUMZWNNUMZWOAWPWEUNNOQUOUPKNUQURWGUTVAWMWFWGNKVBVCVAAWLUDW
      FAWJWFUKZVDZWKWJNUJZHWRWJKUKWKWSVEWRWFKWJKWEVFAWQVGVHWJKNVIVJWRFUSEUSJVKV
      MFMUSDUSJVKMNWJVLULZDHVNZULZEXAVNZHWSXCXAHXBEXAVOWTDHVOVPABCDEFGHIJKLMNOW
      JPQRSTUAUBUCVQVHVRWCUDWFHWGVSVTAWFHPWGABCDEFGHIJKLMNOPQRSTUAUBUCWAWBWD $.

    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 25-Jun-2015.) $)
    ordtypelem5 $p |- ( ph -> ( Ord dom O /\ O : dom O --> A ) ) $=
      ( cdm word wf cin ordtypelem2 wlim wfun tfr1a simpri limord ax-mp sylancl
      ordin wceq wb ordtypelem4 fdm syl ordeq mpbird feq2d jca ) APUDZUEZVFHPUF
      ZAVGKNUDZUGZUEZAKUEVIUEZVKABCDEFGHIJKLMNOPQRSTUAUBUCUHVIUIZVLNUJVMNOQUKUL
      VIUMUNKVIUPUOAVFVJUQZVGVKURAVJHPUFZVNABCDEFGHIJKLMNOPQRSTUAUBUCUSZVJHPUTV
      AZVFVJVBVAVCAVHVOVPAVFVJHPVQVDVCVE $.

    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 24-Jun-2015.) $)
    ordtypelem6 $p |- ( ( ph /\ M e. dom O )
            -> ( N e. M -> ( O ` N ) R ( O ` M ) ) ) $=
      ( va cdm wcel cfv wbr wa cv wral simprr cima crab wn ssrab2 simpr wceq wf
      cin ordtypelem4 fdm adantr eleqtrd ordtypelem3 syldan breq2 ralbidv elrab
      syl sseldi simprbi wfn wb wfun wlim tfr1a simpli funfn mpbi simpri limord
      wss word ax-mp inss2 syl6eqss sselda ordelss sylancr breq1 ralima adantrr
      mpbid fveq2 breq1d rspcv sylc cres ordtypelem1 fveq1d ordtypelem2 syl2anc
      inss1 sseldd fvres eqtrd 3brtr4d expr ) APRUGZUHZQPUHZQRUIZPRUIZJUJAXMXNU
      KZUKZQNUIZPNUIZXOXPJXRXNUFULZNUIZXTJUJZUFPUMZXSXTJUJZAXMXNUNZAXMYDXNAXMUK
      ZMULZXTJUJZMNPUOZUMZYDYGXTYHDULZJUJZMYJUMZDHUPZUHZYKYGFULEULJUJUQFYOUMZEY
      OUPZYOXTYQEYOURAXMPKNUGZVBZUHXTYRUHYGPXLYTAXMUSAXLYTUTZXMAYTHRVAUUAABCDEF
      GHIJKLMNORSTUAUBUCUDUEVCYTHRVDVLZVEVFABCDEFGHIJKLMNOPRSTUAUBUCUDUEVGVHVMY
      PXTHUHYKYNYKDXTHYLXTUTYMYIMYJYLXTYHJVIVJVKVNVLYGNYSVOZPYSWEZYKYDVPNVQZUUC
      UUEYSVRZNOSVSZVTNWAWBYGYSWFZPYSUHUUDUUFUUHUUEUUFUUGWCYSWDWGAXLYSPAXLYTYSU
      UBKYSWHWIWJYSPWKWLYIYCMUFYSPNYHYBXTJWMWNWLWPWOYCYEUFQPYAQUTYBXSXTJYAQNWQW
      RWSWTXRXOQNKXAZUIZXSXRQRUUIARUUIUTXQABCDEFGHIJKLMNORSTUAUBUCUDUEXBVEZXCXR
      QKUHUUJXSUTXRPKQXRKWFZPKUHZPKWEAUULXQABCDEFGHIJKLMNORSTUAUBUCUDUEXDVEAXMU
      UMXNAXLKPAXLYTKUUBKYSXFWIWJWOZKPWKXEYFXGQKNXHVLXIXRXPPUUIUIZXTXRPRUUIUUKX
      CXRUUMUUOXTUTUUNPKNXHVLXIXJXK $.

    $( Lemma for ~ ordtype . ` ran O ` is an initial segment of ` A ` under the
       well-order ` R ` .  (Contributed by Mario Carneiro, 25-Jun-2015.) $)
    ordtypelem7 $p |- ( ( ( ph /\ N e. A ) /\ M e. dom O )
            -> ( ( O ` M ) R N \/ N e. ran O ) ) $=
      ( va vb wcel wa cdm crn cfv wbr wn wi cdif eldif con0 wf wceq ordtypelem4
      cin adantr fdm syl inss1 word ordtypelem2 ordsson syl5ss eqsstrd sseld cv
      wss eleq1 fveq2 breq1d imbi12d imbi2d wral r19.21v wlim wfun tfr1a simpri
      limord ax-mp ordin sylancl ordeq mpbird ordelss sylan sselda pm5.5 eldifn
      ralbidva ad2antlr wfn ad2antrr ffn simprl eleqtrd fnfvelrn syl5ibcom mtod
      wb syl2anc cima crab eldifi simprr cres ordtypelem1 adantrr sseqtrd fveq1
      syl6ss ssel2 fvres sylan9eq anassrs mpbid simpli funfn inss2 breq1 ralima
      mpbi sylancr breq2 ralbidv elrab sylanbrc fveq1d sseldi eqtrd ordtypelem3
      simpll notbid eqeltrd simprbi rspcv sylc wor wwe ffvelrnd sotric syl12anc
      wo weso ioran syl6bb mpbir2and sylbid ex com23 a2i a1i syl5bi tfis3 com3l
      expr mpdd sylan2br impancom orrd orcomd ) AQHUHZUIZPRUJZUHZUIZQRUKZUHZPRU
      LZQJUMZUVMUVOUVQUVJUVOUNZUVLUVQAUVIUVRUVLUVQUOZUVIUVRUIAQHUVNUPUHZUVSQHUV
      NUQAUVTUIZUVLPURUHZUVQUWAUVKURPUWAUVKKNUJZVBZURUWAUWDHRUSZUVKUWDUTZAUWEUV
      TABCDEFGHIJKLMNORSTUAUBUCUDUEVAZVCUWDHRVDZVEZUWAUWDKURKUWCVFZUWAKVGZKURVN
      AUWKUVTABCDEFGHIJKLMNORSTUAUBUCUDUEVHVCZKVIVEVJVKVLUWBUWAUVLUVQUWAUFVMZUV
      KUHZUWMRULZQJUMZUOZUOZUWAUGVMZUVKUHZUWSRULZQJUMZUOZUOZUWAUVSUOUFUGPUWMUWS
      UTZUWQUXCUWAUXEUWNUWTUWPUXBUWMUWSUVKVOUXEUWOUXAQJUWMUWSRVPVQVRVSUWMPUTZUW
      QUVSUWAUXFUWNUVLUWPUVQUWMPUVKVOUXFUWOUVPQJUWMPRVPVQVRVSUXDUGUWMVTUWAUXCUG
      UWMVTZUOZUWMURUHZUWRUWAUXCUGUWMWAUXHUWRUOUXIUWAUXGUWQUWAUWNUXGUWPUWAUWNUX
      GUWPUOUWAUWNUIZUXGUXBUGUWMVTZUWPUXJUXCUXBUGUWMUXJUWSUWMUHZUIUWTUXCUXBXGUX
      JUWMUVKUWSUWAUVKVGZUWNUWMUVKVNZUWAUXMUWDVGZUWAUWKUWCVGZUXOUWLUWCWBZUXPNWC
      ZUXQNOSWDZWEUWCWFWGKUWCWHWIUWAUWFUXMUXOXGUWIUVKUWDWJVEWKUVKUWMWLWMZWNUWTU
      XBWOVEWQUWAUWNUXKUWPUWAUWNUXKUIZUIZUWPUWOQUTZUNZQUWOJUMZUNZUYBUYCUVOUVTUV
      RAUYAQHUVNWPWRUYBUWOUVNUHZUYCUVOUYBRUWDWSZUWMUWDUHZUYGUYBUWEUYHAUWEUVTUYA
      UWGWTZUWDHRXAVEUYBUWMUVKUWDUWAUWNUXKXBUYBUWEUWFUYJUWHVEZXCZUWDUWMRXDXHUWO
      QUVNVOXEXFUYBQMVMZDVMZJUMZMNUWMXIZVTZDHXJZUHZFVMZUWOJUMZUNZFUYRVTZUYFUYBU
      VIUYMQJUMZMUYPVTZUYSUVTUVIAUYAQHUVNXKWRZUYBVUEUWSNULZQJUMZUGUWMVTZUYBUXKV
      UIUWAUWNUXKXLUYBRNKXMZUTZUWMKVNZUXKVUIXGAVUKUVTUYAABCDEFGHIJKLMNORSTUAUBU
      CUDUEXNWTZUYBUWMUWDKUYBUWMUVKUWDUWAUWNUXNUXKUXTXOUYKXPZUWJXRVUKVULUIZUXBV
      UHUGUWMVUOUXLUIUXAVUGQJVUKVULUXLUXAVUGUTVUKVULUXLUIZUXAUWSVUJULZVUGUWSRVU
      JXQVUPUWSKUHVUQVUGUTUWMKUWSXSUWSKNXTVEYAYBVQWQXHYCUYBNUWCWSZUWMUWCVNVUEVU
      IXGUXRVURUXRUXQUXSYDNYEYIUYBUWMUWDUWCVUNKUWCYFXRVUDVUHMUGUWCUWMNUYMVUGQJY
      GYHYJWKUYQVUEDQHUYNQUTUYOVUDMUYPUYNQUYMJYKYLYMYNUYBUWOUYTEVMZJUMZUNZFUYRV
      TZEUYRXJZUHZVUCUYBUWOUWMNULZVVCUYBUWOUWMVUJULZVVEUYBUWMRVUJVUMYOUYBUWMKUH
      VVFVVEUTUYBUWDKUWMUWJUYLYPUWMKNXTVEYQUYBAUYIVVEVVCUHAUVTUYAYSUYLABCDEFGHI
      JKLMNOUWMRSTUAUBUCUDUEYRXHUUAVVDUWOUYRUHVUCVVBVUCEUWOUYRVUSUWOUTZVVAVUBFU
      YRVVGVUTVUAVUSUWOUYTJYKYTYLYMUUBVEVUBUYFFQUYRUYTQUTVUAUYEUYTQUWOJYGYTUUCU
      UDUYBUWPUYCUYEUUJUNZUYDUYFUIUYBHJUUEZUWOHUHUVIUWPVVHXGAVVIUVTUYAAHJUUFVVI
      UDHJUUKVEWTUYBUWDHUWMRUYJUYLUUGVUFHUWOQJUUHUUIUYCUYEUULUUMUUNUVCUUOUUPUUQ
      UURUUSUUTUVAUVBUVDUVEYBUVFUVGUVH $.

    $( Lemma for ~ ordtype .  (Contributed by Mario Carneiro, 17-Oct-2009.) $)
    ordtypelem8 $p |- ( ph -> O Isom _E , R ( dom O , ran O ) ) $=
      ( va vb cdm cep wor crn wpo wfo cv wbr cfv wi wral wiso con0 wss cin wceq
      wf ordtypelem4 fdm syl word ordtypelem2 ordsson syl5ss eqsstrd wwe epweon
      inss1 weso ax-mp soss ee10 frn wess sylc sopo 3syl wfun ffun funforn wcel
      sylib wa epel ordtypelem6 syl5bi ralrimiva ralrimivw soisoi syl22anc ) AP
      UFZUGUHZPUIZJUJZWPWRPUKZUDULZUEULZUGUMZXAPUNXBPUNJUMZUOZUEWPUPZUDWPUPWPWR
      UGJPUQAWPURUSURUGUHZWQAWPKNUFZUTZURAXIHPVBZWPXIVAABCDEFGHIJKLMNOPQRSTUAUB
      UCVCZXIHPVDVEAXIKURKXHVMAKVFKURUSABCDEFGHIJKLMNOPQRSTUAUBUCVGKVHVEVIVJURU
      GVKXGVLURUGVNVOWPURUGVPVQAWRJVKZWRJUHWSAWRHUSZHJVKXLAXJXMXKXIHPVRVEUBWRHJ
      VSVTWRJVNWRJWAWBAPWCZWTAXJXNXKXIHPWDVEPWEWGAXFUDWPAXEUEWPXCXAXBWFAXBWPWFW
      HXDUDUEWIABCDEFGHIJKLMNOXBXAPQRSTUAUBUCWJWKWLWMUDUEWPWRUGJPWNWO $.

    ${
      ordtypelem9.1 $e |- ( ph -> O e. _V ) $.
      $( Lemma for ~ ordtype .  Either the function ` OrdIso ` is an
         isomorphism onto all of ` A ` , or ` OrdIso ` is not a set, which by
         ~ oif implies that either ` ran O C_ A ` is a proper class or
         ` dom O = On ` .  (Contributed by Mario Carneiro, 25-Jun-2015.) $)
      ordtypelem9 $p |- ( ph -> O Isom _E , R ( dom O , A ) ) $=
        ( vb vm vc va cdm crn cep wiso ordtypelem8 wceq cin wss ordtypelem4 frn
        wb wf syl cv wcel wa cfv wn wrex wral cima word ordtypelem2 ordirr con0
        wbr wlim wfun tfr1a simpri limord ax-mp cres ordtypelem1 eqeltrrd tfr2b
        cvv mpbird ordelon sylancr raleqdv rexbidv crab weq breq1 cbvralv breq2
        imaeq2 ralbidv syl5bb cbvrexv cbvrabv eqtri elrab2 baib ralnex r19.21bi
        mtbid sylibr rneqd df-ima syl6eqr adantr ffun funfn sylib bitr3d rexnal
        wfn ralrn ordtypelem7 ord rexlimdva mpd ex ssrdv eqssd isoeq5 mpbid ) A
        PUIZPUJZUKJPULZYHHUKJPULZABCDEFGHIJKLMNOPQRSTUAUBUCUMAYIHUNYJYKUSAYIHAK
        NUIZUOZHPUTZYIHUPABCDEFGHIJKLMNOPQRSTUAUBUCUQZYMHPURVAAUEHYIAUEVBZHVCZY
        PYIVCZAYQVDZUFVBZPVEZYPJVNZVFZUFYHVGZYRYSUUBUFYHVHZVFUUDYSUGVBZYPJVNZUG
        NKVIZVHZUUEAUUIVFZUEHAUUIUEHVGZVFUUJUEHVHAKKVCZUUKAKVJZUULVFABCDEFGHIJK
        LMNOPQRSTUAUBUCVKZKVLVAAKVMVCZUULUUKUSAYLVJZKYLVCZUUOYLVOZUUPNVPUURNOQV
        QVRYLVSVTAUUQNKWAZWEVCZAPUUSWEABCDEFGHIJKLMNOPQRSTUAUBUCWBZUDWCAUUMUUQU
        UTUSUUNKNOQWDVAWFYLKWGWHUULUUOUUKUUGUGNUHVBZVIZVHZUEHVGZUUKUHKVMKUVBKUN
        ZUVDUUIUEHUVFUUGUGUVCUUHUVBKNWPWIWJKCVBZGVBZJVNZCNBVBZVIZVHZGHVGZBVMWKU
        VEUHVMWKTUVMUVEBUHVMUVMUUGUGUVKVHZUEHVGBUHWLZUVEUVLUVNGUEHUVLUUFUVHJVNZ
        UGUVKVHGUEWLZUVNUVIUVPCUGUVKUVGUUFUVHJWMWNUVQUVPUUGUGUVKUVHYPUUFJWOWQWR
        WSUVOUVNUVDUEHUVOUUGUGUVKUVCUVJUVBNWPWIWJWRWTXAXBXCVAXFUUIUEHXDXGXEYSUU
        GUGYIVHZUUIUUEYSUUGUGYIUUHAYIUUHUNYQAYIUUSUJUUHAPUUSUVAXHNKXIXJXKWIYSPY
        HXQZUVRUUEUSAUVSYQAPVPZUVSAYNUVTYOYMHPXLVAPXMXNXKUUGUUBUGUFYHPUUFUUAYPJ
        WMXRVAXOXFUUBUFYHXPXGYSUUCYRUFYHYSYTYHVCVDUUBYRABCDEFGHIJKLMNOYTYPPQRST
        UAUBUCXSXTYAYBYCYDYEYHYIHUKJPYFVAYG $.
    $}

    $( Lemma for ~ ordtype .  Using ~ ax-rep , exclude the possibility that
       ` O ` is a proper class and does not enumerate all of ` A ` .
       (Contributed by Mario Carneiro, 25-Jun-2015.) $)
    ordtypelem10 $p |- ( ph -> O Isom _E , R ( dom O , A ) ) $=
      ( vb vc vm cdm crn cep wiso ordtypelem8 wb cin wf wss ordtypelem4 frn syl
      wceq cv wcel wa simprl wf1o wfo wwe adantr wse cvv isof1o f1of 3syl f1of1
      wf1 wbr crab simpl seex syl2an wral cfv wrex rexnal ordtypelem7 rexlimdva
      ord syl5bir con1d impr wfn wfun ffun funfn sylib breq1 ralrn mpbird ssrab
      wn sylanbrc ssexd f1dmex syl2anc fex ordtypelem9 f1ofo forn 4syl eleqtrrd
      expr pm2.18d ex ssrdv eqssd isoeq5 mpbid ) APUGZPUHZUIJPUJZXQHUIJPUJZABCD
      EFGHIJKLMNOPQRSTUAUBUCUKAXRHUSZXSXTULAXRHAKNUGUMZHPUNZXRHUOZABCDEFGHIJKLM
      NOPQRSTUAUBUCUPZYBHPUQURZAUDHXRAUDUTZHVAZYGXRVAZAYHVBZYIAYHYIWSZYIAYHYKVB
      ZVBZYGHXRAYHYKVCYMXTXQHPVDXQHPVEYAYMBCDEFGHIJKLMNOPQRSTUAAHJVFYLUBVGZAHJV
      HZYLUCVGZYMXQXRPUNZXQVIVAZPVIVAYMXSXQXRPVDZYQYMBCDEFGHIJKLMNOPQRSTUAYNYPU
      KZXQXRUIJPVJZXQXRPVKVLYMXQXRPVNZXRVIVAYRYMXSYSUUBYTUUAXQXRPVMVLYMXRUEUTZY
      GJVOZUEHVPZVIAYOYHUUEVIVAYLUCYHYKVQUEHYGJVRVSYMYDUUDUEXRVTZXRUUEUOAYDYLYF
      VGYMUUFUFUTZPWAZYGJVOZUFXQVTZAYHYKUUJYJUUJYIUUJWSUUIWSZUFXQWBYJYIUUIUFXQW
      CYJUUKYIUFXQYJUUGXQVAVBUUIYIABCDEFGHIJKLMNOUUGYGPQRSTUAUBUCWDWFWEWGWHWIYM
      PXQWJZUUFUUJULAUULYLAPWKZUULAYCUUMYEYBHPWLURPWMWNVGUUDUUIUEUFXQPUUCUUHYGJ
      WOWPURWQUUDUEHXRWRWTXAXQXRVIPXBXCXQXRVIPXDXCXEXQHUIJPVJXQHPXFXQHPXGXHXIXJ
      XKXLXMXNXQXRHUIJPXOURXP $.
  $}

  ${
    $d t u v x F $.  $d h j t u v w x z M $.  $d f h i j r s t u v w x y z R $.
    $d f h j r s t u v w x y z A $.  $d j u w N $.
    oicl.1 $e |- F = OrdIso ( R , A ) $.
    $( Definition of the ordinal isomorphism when its arguments are not
       meaningful.  (Contributed by Mario Carneiro, 25-Jun-2015.) $)
    oi0 $p |- ( -. ( R We A /\ R Se A ) -> F = (/) ) $=
      ( vh vu vv vj vw vz vt vx wwe wse wn cv wbr wral crab c0 wa cvv crio cmpt
      crn crecs cima wrex con0 cres cif coi df-oi eqtri iffalse syl5eq ) ABMABN
      UAZOCUQEUBFPGPBQOFHPIPBQHEPUERIASZRGURUCUDUFZJPKPBQJUSLPUGRKAUHLUISUJZTUK
      ZTCABULVADLJIGFKABEHUMUNUQUTTUOUP $.

    $( The order type of the well-order ` R ` on ` A ` is an ordinal.
       (Contributed by Mario Carneiro, 23-May-2015.)  (Revised by Mario
       Carneiro, 25-Jun-2015.) $)
    oicl $p |- Ord dom F $=
      ( vx vz vw vv vu vt vj vh vf vr vs cv wbr wral eqid c0 vi vy wwe wse word
      wa cdm wf crn crab cvv wn crio cmpt crecs cima wrex con0 ordtypecbv simpl
      simpr ordtypelem5 simpld ord0 wceq oi0 dmeqd dm0 syl6eq ordeq syl pm2.61i
      wb mpbiri ) ABUCZABUDZUFZCUGZUEZVQVSVRACUHVQEFGHIJAKPGPBQKLPUIRGAUJZBFPJP
      BQFMUKNPOPBQULNUAPUBPBQUAMPUIRUBAUJZROWAUMUNUOZEPUPRJAUQEURUJZLKWBLUKIPHP
      BQULIVTRHVTUMUNZCUBGHIAVTBMLUAKWDUOZWDONWESVTSZWDSZUSWFWGWCSDVOVPUTVOVPVA
      VBVCVQULZVSTUEZVDWHVRTVEVSWIVMWHVRTUGTWHCTABCDVFVGVHVIVRTVJVKVNVL $.

    $( The order isomorphism of the well-order ` R ` on ` A ` is a function.
       (Contributed by Mario Carneiro, 23-May-2015.) $)
    oif $p |- F : dom F --> A $=
      ( vx vz vw vv vu vt vj vh vf vr vs cv wbr wral eqid c0 vi vy wwe wse word
      wa cdm wf crn crab cvv wn crio cmpt crecs cima wrex con0 ordtypecbv simpl
      simpr ordtypelem5 simprd f0 oi0 dmeqd dm0 syl6eq feq12d mpbiri pm2.61i )
      ABUCZABUDZUFZCUGZACUHZVNVOUEVPVNEFGHIJAKPGPBQKLPUIRGAUJZBFPJPBQFMUKNPOPBQ
      ULNUAPUBPBQUAMPUIRUBAUJZROVRUMUNUOZEPUPRJAUQEURUJZLKVSLUKIPHPBQULIVQRHVQU
      MUNZCUBGHIAVQBMLUAKWAUOZWAONWBSVQSZWASZUSWCWDVTSDVLVMUTVLVMVAVBVCVNULZVPT
      ATUHAVDWEVOTACTABCDVEZWEVOTUGTWECTWFVFVGVHVIVJVK $.

    $( The order isomorphism of the well-order ` R ` on ` A ` is an isomorphism
       onto ` ran O ` (which is a subset of ` A ` by ~ oif ).  (Contributed by
       Mario Carneiro, 25-Jun-2015.) $)
    oiiso2 $p |- ( ( R We A /\ R Se A ) -> F Isom _E , R ( dom F , ran F ) ) $=
      ( vx vz vw vv vu vt vj vh vf vr vs vi cv wbr wral eqid vy wwe wse wa crab
      crn cvv crio cmpt crecs cima wrex con0 ordtypecbv simpl simpr ordtypelem8
      wn ) ABUBZABUCZUDEFGHIJAKQGQBRKLQUFSGAUEZBFQJQBRFMUGNQOQBRURNPQUAQBRPMQUF
      SUAAUEZSOVBUHUIUJZEQUKSJAULEUMUEZLKVCLUGIQHQBRURIVASHVAUHUIZCUAGHIAVABMLP
      KVEUJZVEONVFTVATZVETZUNVGVHVDTDUSUTUOUSUTUPUQ $.

    $( For any set-like well-ordered class, there is an isomorphic ordinal
       number called its order type.  (Contributed by Jeff Hankins,
       17-Oct-2009.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    ordtype $p |- ( ( R We A /\ R Se A ) -> F Isom _E , R ( dom F , A ) ) $=
      ( vx vz vw vv vu vt vj vh vf vr vs vi cv wbr wral eqid vy wwe wse wa crab
      crn wn crio cmpt crecs cima wrex con0 ordtypecbv simpl simpr ordtypelem10
      cvv ) ABUBZABUCZUDEFGHIJAKQGQBRKLQUFSGAUEZBFQJQBRFMURNQOQBRUGNPQUAQBRPMQU
      FSUAAUEZSOVBUHUIUJZEQUKSJAULEUMUEZLKVCLURIQHQBRUGIVASHVAUHUIZCUAGHIAVABML
      PKVEUJZVEONVFTVATZVETZUNVGVHVDTDUSUTUOUSUTUPUQ $.

    $( ` ran F ` is an initial segment of ` A ` under the well-order ` R ` .
       (Contributed by Mario Carneiro, 26-Jun-2015.) $)
    oiiniseg $p |- ( ( ( R We A /\ R Se A ) /\ ( N e. A /\ M e. dom F ) )
            -> ( ( F ` M ) R N \/ N e. ran F ) ) $=
      ( vx vz vw vv vu vt vj vh vf vr wbr cv wral eqid vs vi vy wwe wse wa wcel
      cdm cfv crn wo crab crio cmpt crecs cima wrex con0 ordtypecbv simpl simpr
      cvv wn ordtypelem7 anasss ) ABUDZABUEZUFZEAUGDCUHUGDCUIEBQECUJUGUKVHGHIJK
      LAMRIRBQMNRUJSIAULZBHRLRBQHOVBPRUARBQVCPUBRUCRBQUBORUJSUCAULZSUAVJUMUNUOZ
      GRUPSLAUQGURULZNMVKNVBKRJRBQVCKVISJVIUMUNZDECUCIJKAVIBONUBMVMUOZVMUAPVNTV
      ITZVMTZUSVOVPVLTFVFVGUTVFVGVAVDVE $.

    $( For any set-like well-ordered class, if the order isomorphism exists (is
       a set), then it maps some ordinal onto ` A ` isomorphically.  Otherwise,
       ` F ` is a proper class, which implies that either ` ran F C_ A ` is a
       proper class or ` dom F = On ` .  This weak version of ~ ordtype does
       not require the Axiom of Replacement.  (Contributed by Mario Carneiro,
       25-Jun-2015.) $)
    ordtype2 $p |- ( ( R We A /\ R Se A /\ F e. _V )
           -> F Isom _E , R ( dom F , A ) ) $=
      ( vx vz vw vv vu vt vj vh vf vr vs vi cv wbr wral eqid vy wwe wse cvv w3a
      wcel crn crab crio cmpt crecs cima wrex con0 ordtypecbv simp1 simp2 simp3
      wn ordtypelem9 ) ABUBZABUCZCUDUFZUEEFGHIJAKQGQBRKLQUGSGAUHZBFQJQBRFMUDNQO
      QBRUSNPQUAQBRPMQUGSUAAUHZSOVEUIUJUKZEQULSJAUMEUNUHZLKVFLUDIQHQBRUSIVDSHVD
      UIUJZCUAGHIAVDBMLPKVHUKZVHONVITVDTZVHTZUOVJVKVGTDVAVBVCUPVAVBVCUQVAVBVCUR
      UT $.

    $( The order isomorphism on a set is a set.  (Contributed by Mario
       Carneiro, 25-Jun-2015.) $)
    oiexg $p |- ( A e. V -> F e. _V ) $=
      ( wcel wwe wse cvv cdm wf1 cep wiso wf1o ordtype isof1o f1of1 3syl f1dmex
      wa wf f1f fex sylan syldan expcom syl5 wn c0 oi0 0ex syl6eqel pm2.61d1 )
      ADFZABGABHTZCIFZUOCJZACKZUNUPUOUQALBCMUQACNURABCEOUQALBCPUQACQRURUNUPURUN
      UQIFZUPUQADCSURUQACUAUSUPUQACUBUQAICUCUDUEUFUGUOUHCUIIABCEUJUKULUM $.

    $( The order type of the well-order ` R ` on ` A ` is an ordinal.
       (Contributed by Stefan O'Rear, 11-Feb-2015.)  (Revised by Mario
       Carneiro, 23-May-2015.) $)
    oion $p |- ( A e. V -> dom F e. On ) $=
      ( wcel cdm con0 word oicl cvv wb oiexg dmexg elong 3syl mpbiri ) ADFZCGZH
      FZSIZABCEJRCKFSKFTUALABCDEMCKNSKOPQ $.

    $( The order isomorphism of the well-order ` R ` on ` A ` is an
       isomorphism.  (Contributed by Mario Carneiro, 23-May-2015.) $)
    oiiso $p |- ( ( A e. V /\ R We A ) -> F Isom _E , R ( dom F , A ) ) $=
      ( wcel wse wwe cdm cep wiso exse ordtype ancoms sylan ) ADFABGZABHZCIAJBC
      KZABDLQPRABCEMNO $.

    $( The order type of a well-ordered set is equinumerous to the set.
       (Contributed by Mario Carneiro, 23-May-2015.) $)
    oien $p |- ( ( A e. V /\ R We A ) -> dom F ~~ A ) $=
      ( wcel wwe wa cvv cdm wf1o cen wbr oiexg adantr cep wiso oiiso isof1o syl
      f1oen3g syl2anc ) ADFZABGZHZCIFZCJZACKZUGALMUCUFUDABCDENOUEUGAPBCQUHABCDE
      RUGAPBCSTUGACIUAUB $.

    $( Uniqueness of the unique ordinal isomorphism.  (Contributed by Mario
       Carneiro, 23-May-2015.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    oieu $p |- ( ( R We A /\ R Se A ) ->
      ( ( Ord B /\ G Isom _E , R ( B , A ) ) <-> ( B = dom F /\ G = F ) ) ) $=
      ( wwe wse wa word cep wiso cdm wceq ccnv adantr syl a1i wb isoeq4 ordtype
      ccom simprr isocnv isotr syl2anc oicl ordiso2 syl3anc ordwe ad2antrl epse
      simprl mpbird weisoeq syl22anc jca ex jctil ordeq isoeq1 sylan9bb anbi12d
      syl5ibrcom impbid ) ACGACHIZBJZBAKCELZIZBDMZNZEDNZIZVFVIVMVFVIIZVKVLVNBVJ
      KKDOZEUBZLZVGVJJZVKVNVHAVJCKVOLZVQVFVGVHUCZVNVJAKCDLZVSVFWAVIACDFUAZPZVJA
      KCDUDQBAVJKCKVOEUEUFVFVGVHUMVRVNACDFUGZRBVJVPUHUIZVNBKGZBKHZVHBAKCDLZVLVG
      WFVFVHBUJUKWGVNBULRVTVNWHWAWCVNVKWHWASWEBAVJKCDTQUNBAKCEDUOUPUQURVFVIVMVR
      WAIVFWAVRWBWDUSVMVGVRVHWAVKVGVRSVLBVJUTPVKVHVJAKCELVLWABAVJKCETVJAKCDEVAV
      BVCVDVE $.
  $}

  ${
    $d x y A $.  $d x y F $.
    oismo.1 $e |- F = OrdIso ( _E , A ) $.
    $( When ` A ` is a subclass of ` On ` , ` F ` is a strictly monotone
       ordinal functions, and it is also complete (it is an isomorphism onto
       all of ` A ` ).  The proof avoids ~ ax-rep (the second statement is
       trivial under ~ ax-rep ).  (Contributed by Mario Carneiro,
       26-Jun-2015.) $)
    oismo $p |- ( A C_ On -> ( Smo F /\ ran F = A ) ) $=
      ( vx vy con0 wss wfo wa cep wiso wwe wf sylancr a1i wcel cvv mp1i syl3anc
      cv wsmo crn wceq cdm wse epweon wess mpi epse oiiso2 sylancl word wb oicl
      oif frn ax-mp id syl5ss smoiso2 mpbird simprd simprl wf1o adantr wfn wral
      wn cfv ffn wbr simplrr wo ad2antrr simplrl oiiniseg syl22anc ord mt3d vex
      simpr epelc sylib ralrimiva ffnfv sylanbrc smogt wi ordelon simpll sseldd
      ontr2 syl2anc mp2and ssrdv ssexd fex2 ordtype2 isof1o f1ofo forn eleqtrrd
      ex 4syl expr pm2.18d eqssd jca ) AFGZBUAZBUBZAUCZXIBUDZXKBHZXJXIXNXJIZXMX
      KJJBKZXIAJLZAJUEZXPXIFJLXQUFAFJUGUHZAUIZAJBCUJUKXIXMULZXKFGXOXPUMAJBCUNZX
      IXKAFXMABMZXKAGZAJBCUOZXMABUPUQZXIURUSXMXKBUTNVAVBZXIXKAYDXIYFOXIDAXKXIDT
      ZAPZYHXKPZXIYIIYJXIYIYJVHZYJXIYIYKIZIZYHAXKXIYIYKVCZYMXMAJJBKZXMABVDXMABH
      XLYMXQXRBQPZYOXIXQYLXSVEXRYMXTOYMXMYHBMZXMQPYIYPYMBXMVFZETZBVIZYHPZEXMVGY
      QYCYRYMYEXMABVJZRYMUUAEXMYMYSXMPZIZYTYHJVKZUUAUUDUUEYJXIYIYKUUCVLUUDUUEYJ
      UUDXQXRYIUUCUUEYJVMXIXQYLUUCXSVNXRUUDXTOXIYIYKUUCVOZYMUUCWAZAJBYSYHCVPVQV
      RVSYTYHDVTWBWCZWDEXMYHBWEWFYMXMYHAYNYMEXMYHYMUUCYSYHPZUUDYSYTGZUUAUUIUUDY
      RXJUUCUUJYCYRUUDYEUUBRXIXJYLUUCYGVNUUGXMYSBWGSUUHUUDYSFPZYHFPUUJUUAIUUIWH
      UUDYAUUCUUKYBUUGXMYSWINUUDAFYHXIYLUUCWJUUFWKYSYTYHWLWMWNXCWOWPYNXMYHBQAWQ
      SAJBCWRSXMAJJBWSXMABWTXMABXAXDXBXEXFXCWOXGXH $.
  $}

  $( The order type of an ordinal under the ` e. ` order is itself, and the
     order isomorphism is the identity function.  (Contributed by Mario
     Carneiro, 26-Jun-2015.) $)
  oiid $p |- ( Ord A -> OrdIso ( _E , A ) = ( _I |` A ) ) $=
    ( word cep wwe wse coi wiso cid cres wceq ordwe epse a1i cdm crn eqid mpbid
    wb syl syl3anc oiiso2 sylancl wsmo con0 wa ordsson oismo simprd isoeq5 oicl
    wss id ordiso2 isoeq4 weniso ) ABZACDZACEZAACCACFZGZUSHAIJAKZURUPALZMUPUSNZ
    ACCUSGZUTUPVCUSOZCCUSGZVDUPUQURVFVAVBACUSUSPZUAUBUPVEAJZVFVDRUPUSUCZVHUPAUD
    UKVIVHUEAUFAUSVGUGSUHVCVEACCUSUISQZUPVCAJZVDUTRUPVDVCBZUPVKVJVLUPACUSVGUJMU
    PULVCAUSUMTVCAACCUSUNSQACUSUOT $.

  ${
    $d f s t w y z $.  $d f r x y A $.  $d r x R $.  $d r y V $.
    hartogslem.2 $e |- F = { <. r , y >. |
       ( ( ( dom r C_ A /\ ( _I |` dom r ) C_ r /\ r C_ ( dom r X. dom r ) ) /\
         ( r \ _I ) We dom r ) /\ y = dom OrdIso ( ( r \ _I ) , dom r ) ) } $.
    hartogslem.3 $e |- R = { <. s , t >. | E. w e. y E. z e. y
       ( ( s = ( f ` w ) /\ t = ( f ` z ) ) /\ w _E z ) } $.
    $( Lemma for ~ hartogs .  (Contributed by Mario Carneiro, 14-Jan-2013.)
       (Revised by Mario Carneiro, 15-May-2015.) $)
    hartogslem1 $p |- ( dom F C_ ~P ( A X. A ) /\ Fun F /\
      ( A e. V -> ran F = { x e. On | x ~<_ A } ) ) $=
      ( wss wceq cid wa syl cep cdm cxp cpw wfun wcel crn cv cdom wbr con0 crab
      cres w3a cdif wwe coi wex cab copab dmeqi dmopab eqtri simp3 simp1 xpss12
      wi syl2anc sstrd vex elpw sylibr ad2antrr exlimiv eqsstri funopab4 funeqi
      abssi mpbir breq1 elrab wf1 brdomi cun cin wf f1f adantl resss ssun2 wf1o
      frn sstri f1oi f1of fssxp mp2b ssini a1i inss2 3jca word eloni ordwe wiso
      adantr wb cfv wrex f1f1orn f1oiso sylancl isores2 sylib isowe mpbid c0 wn
      wal weso brel simpld sonr syl2an pm2.01da alrimiv weeq1 ax-mp eqid mpbiri
      wor cvv dmss sseq12d indif1 anbi12d ex exlimdv imp sylan2 cen intirr rnex
      disj3 isoeq3 wse exse oieu mpbi2and inex2 sseq1 dmxpid syl6sseq syl5eqssr
      xpex dmresi sseq2 eqssd sseq1d reseq2d id xpeq12d 3anbi123d difeq1 difun2
      ineq1i 3eqtr3i syl6eq weeq2 bitrd oieq1 oieq2 eqtrd dmeqd eqeq2d syl21anc
      spcev simpr dmex oion syl6eqel simplr oien sylancr eqbrtrd simpll1 ssdomg
      endomtr jca impbid2 syl5bb abbi2dv rneqi rnopab syl6reqr 3pm3.2i ) IUAZFF
      UBZUCZOIUDZFJUEZIUFZAUGZFUHUIZAUJUKZPVFUWPLUGZUAZFOZQUXFULZUXEOZUXEUXFUXF
      UBZOZUMZUXFUXEQUNZUOZRZBUGZUXFUXMUPZUAZPZRZBUQZLURZUWRUWPUXTLBUSZUAUYBIUY
      CMUTUXTLBVAVBUYALUWRUXTUXEUWRUEZBUXLUYDUXNUXSUXLUXEUWQOUYDUXLUXEUXJUWQUXG
      UXIUXKVCUXLUXGUXGUXJUWQOUXGUXIUXKVDZUYEUXFFUXFFVEVGVHUXEUWQLVIZVJVKVLVMVQ
      VNUWSUYCUDUXOLBUXRVOIUYCMVPVRUWTUXDUXTLUQZBURZUXAUWTUYGBUXDUXPUXDUEUXPUJU
      EZUXPFUHUIZRZUWTUYGUXCUYJAUXPUJUXBUXPFUHVSVTUWTUYKUYGUYJUYIUXPFHUGZWAZHUQ
      ZUYGUXPFHWBUYIUYNUYGUYIUYMUYGHUYIUYMUYGUYIUYMRZUYLUFZFOZQUYPULZGQWCZUYPUY
      PUBZWDZOZVUAUYTOZUMZUYPGUYTWDZQUNZUOZUXPUYPVUFUPZUAZPZUYGUYOUYQVUBVUCUYOU
      XPFUYLWEZUYQUYMVUKUYIUXPFUYLWFWGUXPFUYLWKSVUBUYOUYRUYSUYTUYRQUYSQUYPWHQGW
      IWLUYPUYPUYRWJUYPUYPUYRWEUYRUYTOUYPWMUYPUYPUYRWNUYPUYPUYRWOWPWQZWRVUCUYOU
      YSUYTWSZWRWTUYOUYPVUEUOZVUGUYOUXPTUOZVUNUYIVUOUYMUYIUXPXAZVUOUXPXBZUXPXCS
      XEUYOUXPUYPTVUEUYLXDZVUOVUNXFUYOUXPUYPTGUYLXDZVURUYOUXPUYPUYLWJZGKUGDUGZU
      YLXGPEUGCUGZUYLXGPRVVAVVBTUIRCUXPXHDUXPXHKEUSPVUSUYMVUTUYIUXPFUYLXIWGNDCK
      EUXPUYPTGUYLXJXKUXPUYPTGUYLXLXMZUXPUYPTVUEUYLXNSXOZUYOVUEVUFPZVUNVUGXFUYO
      VUEQWDXPPZVVEUYOUXBUXBVUEUIZXQZAXRVVFUYOVVHAUYOVVGUYOUYPVUEYJZUXBUYPUEZVV
      HVVGUYOVUNVVIVVDUYPVUEXSSVVGVVJVVJUXBUXBUYPUYPVUEGUYTWSXTYAUYPUXBVUEYBYCY
      DYEAVUEUUAVKVUEQUUCXMZUYPVUEVUFYFSXOZUYOVUJUYLVUHPZUYOVUPUXPUYPTVUFUYLXDZ
      VUJVVMRZUYIVUPUYMVUQXEUYOVURVVNVVCUYOVVEVURVVNXFVVKUXPUYPTVUEVUFUYLUUDSXO
      UYOVUGUYPVUFUUEZVUPVVNRVVOXFVVLUYPYKUEVVPUYLHVIUUBZUYPVUFYKUUFYGUYPUXPVUF
      VUHUYLVUHYHUUGXKUUHYAUXTVUDVUGRZVUJRLVUAUYTUYSUYPUYPVVQVVQUUNUUIUXEVUAPZU
      XOVVRUXSVUJVVSUXLVUDUXNVUGVVSUXGUYQUXIVUBUXKVUCVVSUXFUYPFVVSUXFUYPVVSUXFU
      YTUAZUYPVVSUXEUYTOZUXFVVTOVVSVWAVUCVUMUXEVUAUYTUUJYIUXEUYTYLSUYPUUKUULVVS
      UYPUYRUAZUXFUYPUUOVVSUYRUXEOZVWBUXFOVVSVWCVUBVULUXEVUAUYRUUPYIUYRUXEYLSUU
      MUUQZUURVVSUXHUYRUXEVUAVVSUXFUYPQVWDUUSVVSUUTZYMVVSUXEVUAUXJUYTVWEVVSUXFU
      YPUXFUYPVWDVWDUVAYMUVBVVSUXNUXFVUFUOZVUGVVSUXMVUFPZUXNVWFXFVVSUXMVUAQUNZV
      UFUXEVUAQUVCUYSQUNZUYTWDGQUNZUYTWDVWHVUFVWIVWJUYTGQUVDUVEUYSUYTQYNGUYTQYN
      UVFUVGZUXFUXMVUFYFSVVSUXFUYPPZVWFVUGXFVWDUXFUYPVUFUVHSUVIYOVVSUXRVUIUXPVV
      SUXQVUHVVSUXQUXFVUFUPZVUHVVSVWGUXQVWMPVWKUXFUXMVUFUVJSVVSVWLVWMVUHPVWDUXF
      UYPVUFUVKSUVLUVMUVNYOUVPUVOYPYQYRYSUWTUXTUYKLUWTUXTUYKUWTUXTRZUYIUYJUXTUY
      IUWTUXTUXPUXRUJUXOUXSUVQZUXFYKUEZUXRUJUEUXEUYFUVRZUXFUXMUXQYKUXQYHZUVSYGU
      VTWGVWNUXPUXFYTUIZUXFFUHUIZUYJUXTVWSUWTUXTUXPUXRUXFYTVWOUXTVWPUXNUXRUXFYT
      UIVWQUXLUXNUXSUWAUXFUXMUXQYKVWRUWBUWCUWDWGUXTUWTUXGVWTUXGUXIUXKUXNUXSUWEU
      WTUXGVWTUXFFJUWFYRYSUXPUXFFUWGVGUWHYPYQUWIUWJUWKUXAUYCUFUYHIUYCMUWLUXTLBU
      WMVBUWNUWO $.

    $( Lemma for ~ hartogs .  (Contributed by Mario Carneiro, 14-Jan-2013.) $)
    hartogslem2 $p |- ( A e. V -> { x e. On | x ~<_ A } e. _V ) $=
      ( wcel crn cv cvv syl sylancr cdom wbr con0 crab cdm cxp cpw wfun wceq wi
      wss hartogslem1 simp3i simp2i simp1i xpexg anidms pwexg ssexg funex rnexg
      eqeltrrd ) FJOZIPZAQFUAUBAUCUDZRIUEZFFUFZUGZUKZIUHZVCVDVEUIUJZABCDEFGHIJK
      LMNULZUMVCIROZVDROVCVJVFROZVMVIVJVKVLUNVCVIVHROZVNVIVJVKVLUOVCVGROZVOVCVP
      FFJJUPUQVGRURSVFVHRUSTRIUTTIRVASVB $.
  $}

  ${
    $d g r s t w x y z $.  $d g r x y z A $.  $d r y V $.
    $( Given any set, the Hartogs number of the set is the least ordinal not
       dominated by that set.  This theorem proves that there is always an
       ordinal which satisfies this.  (This theorem can be proven trivially
       using the AC - see theorem ~ ondomon - but this proof works in ZF.)
       (Contributed by Jeff Hankins, 22-Oct-2009.)  (Revised by Mario Carneiro,
       15-May-2015.) $)
    hartogs $p |- ( A e. V -> { x e. On | x ~<_ A } e. On ) $=
      ( vy vz vw vt vs vg vr wcel cv cdom wbr con0 word wss wa cvv wceq crab wi
      wtr wal onelon vex onelss imp ssdomg mpsyl jca domtr anim2i anassrs sylan
      exp31 com12 imp3a breq1 elrab 3imtr4g gen2 dftr2 mpbir ssrab2 ordon mp3an
      trssord cfv cep wrex copab cdm cid cres cxp w3a cdif wwe eqid hartogslem2
      wb coi elong syl mpbiri ) BCKZALZBMNZAOUAZOKZWJPZWJUCZWJOQOPWLWMDLZELZKZW
      OWJKZRWNWJKZUBZEUDDUDWSDEWPWQWRWPWOOKZWOBMNZRWNOKZWNBMNZRZWQWRWPWTXAXDWTW
      PXAXDUBWTWPXAXDWTWPRZXBWNWOMNZRXAXDXEXBXFWOWNUEWOSKXEWNWOQZXFEUFWTWPXGWOW
      NUGUHWNWOSUIUJUKXBXFXAXDXFXARXCXBWNWOBULUMUNUOUPUQURWIXAAWOOWHWOBMUSUTWIX
      CAWNOWHWNBMUSUTVAUHVBDEWJVCVDWIAOVEVFWJOVHVGWGWJSKWKWLWBADEFGBHLFLZILZVIT
      GLWOXIVITRXHWOVJNREWNVKFWNVKHGVLZIJLZVMZBQVNXLVOXKQXKXLXLVPQVQXLXKVNVRZVS
      RWNXLXMWCVMTRJDVLZCHJXNVTXJVTWAWJSWDWEWF $.
  $}

  ${
    $d y z A $.  $d y z R $.
    wofib.1 $e |- A e. _V $.
    $( The only sets which are well-ordered forwards and backwards are finite
       sets.  (Contributed by Mario Carneiro, 30-Jan-2014.)  (Revised by Mario
       Carneiro, 23-May-2015.) $)
    wofib $p |- ( ( R Or A /\ A e. Fin ) <-> ( R We A /\ `' R We A ) ) $=
      ( vz vy wor cfn wcel wa wwe ccnv wofi jca adantr com wss cep wbr wn cvv
      cnvso sylanb weso coi cdm cv wral wrex csuc peano2 sucidg wceq brcnv epel
      vex bitri eleq2 syl5bb rspcev syl2anc dfrex2 sylib nrex word wb eqid oicl
      ordom ordtri1 mp2an wfr c0 wne con0 oion mp1i simpr ssexd wiso oiiso mpan
      isocnv2 wefr isofr biimpar syl2an c1o 1onn ne0i fri syl22anc syl5bir mt3i
      ex ssid ssnnfi sylancl cen simpl oien sylancr enfi syl mpbid impbii ) ABF
      ZAGHZIZABJZABKZJZIZXHXIXKABLXFAXJFXGXKABUAAXJLUBMXLXFXGXIXFXKABUCNXLABUDZ
      UEZGHZXGXLXNOHZXNXNPXOXLXPDUFZEUFZQKZRZSDOUGZEOUHZYAEOXROHZXTDOUHZYASYCXR
      UIZOHXRYEHZYDXRUJXROUKXTYFDYEOXTXRXQHZXQYEULYFXTXRXQQRYGXQXRQDUOEUOUMEDUN
      UPXQYEXRUQURUSUTXTDOVAVBVCXPSZOXNPZXLYBOVDXNVDYIYHVEVHABXMXMVFZVGOXNVIVJX
      LYIYBXLYIIZOTHXNXSVKZYIOVLVMZYBYKOXNVNATHZXNVNHYKCABXMTYJVOVPXLYIVQZVRXLY
      LYIXIXNAXSXJXMVSZAXJVKZYLXKXIXNAQBXMVSZYPYNXIYRCABXMTYJVTWAXNAQBXMWBVBAXJ
      WCYPYLYQXNAXSXJXMWDWEWFNYOWGOHYMYKWHOWGWIVPEDXNOTXSWJWKWNWLWMXNWOXNXNWPWQ
      XLXNAWRRZXOXGVEXLYNXIYSCXIXKWSABXMTYJWTXAXNAXBXCXDMXE $.
  $}

  ${
    $d a b c d x B $.  $d a b c d T $.  $d a b c d U $.  $d a b c w x y z X $.
    $d a b c d w x y z A $.  $d a b c d w x y z P $.  $d a b c d w x y z Q $.
    $d a b c d w x y z R $.  $d a b c d w x y z S $.  $d c d x Z $.
    wemapso.t $e |- T = { <. x , y >. | E. z e. A ( ( x ` z ) S ( y ` z ) /\
        A. w e. A ( w R z -> ( x ` w ) = ( y ` w ) ) ) } $.
    $( Value of the lexicographic order on a sequence space.  (Contributed by
       Stefan O'Rear, 18-Jan-2015.) $)
    wemaplem1 $p |- ( ( P e. V /\ Q e. W ) -> ( P T Q <->
        E. a e. A ( ( P ` a ) S ( Q ` a ) /\
          A. b e. A ( b R a -> ( P ` b ) = ( Q ` b ) ) ) ) ) $=
      ( cv cfv wbr wceq wi wral wrex breqan12d eqeqan12d imbi2d ralbidv anbi12d
      wa fveq1 rexbidv fveq2 breq12d breq2 imbi1d breq1 eqeq12d imbi12d cbvralv
      weq syl6bb cbvrexv brabga ) CPZAPZQZVCBPZQZIRZDPZVCHRZVIVDQZVIVFQZSZTZDEU
      AZUHZCEUBZMPZFQZVRGQZIRZNPZVRHRZWBFQZWBGQZSZTZNEUAZUHZMEUBZABFGJKLVDFSZVF
      GSZUHZVQVCFQZVCGQZIRZVJVIFQZVIGQZSZTZDEUAZUHZCEUBWJWMVPXBCEWMVHWPVOXAWKWL
      VEWNVGWOIVCVDFUIVCVFGUIUCWMVNWTDEWMVMWSVJWKWLVKWQVLWRVIVDFUIVIVFGUIUDUEUF
      UGUJXBWICMECMUSZWPWAXAWHXCWNVSWOVTIVCVRFUKVCVRGUKULXCXAVIVRHRZWSTZDEUAWHX
      CWTXEDEXCVJXDWSVCVRVIHUMUNUFXEWGDNEDNUSZXDWCWSWFVIWBVRHUOXFWQWDWRWEVIWBFU
      KVIWBGUKUPUQURUTUGVAUTOVB $.

    ${
      $d ph d $.
      wemaplem2.a $e |- ( ph -> A e. _V ) $.
      wemaplem2.p $e |- ( ph -> P e. ( B ^m A ) ) $.
      wemaplem2.x $e |- ( ph -> X e. ( B ^m A ) ) $.
      wemaplem2.q $e |- ( ph -> Q e. ( B ^m A ) ) $.
      wemaplem2.r $e |- ( ph -> R Or A ) $.
      wemaplem2.s $e |- ( ph -> S Po B ) $.
      ${
        wemaplem2.px1 $e |- ( ph -> a e. A ) $.
        wemaplem2.px2 $e |- ( ph -> ( P ` a ) S ( X ` a ) ) $.
        wemaplem2.px3 $e |- ( ph -> A. c e. A ( c R a ->
            ( P ` c ) = ( X ` c ) ) ) $.
        wemaplem2.xq1 $e |- ( ph -> b e. A ) $.
        wemaplem2.xq2 $e |- ( ph -> ( X ` b ) S ( Q ` b ) ) $.
        wemaplem2.xq3 $e |- ( ph -> A. c e. A ( c R b ->
            ( X ` c ) = ( Q ` c ) ) ) $.
        $( Lemma for ~ wemapso .  Transitivity.  (Contributed by Stefan O'Rear,
           17-Jan-2015.) $)
        wemaplem2 $p |- ( ph -> P T Q ) $=
          ( vd wbr cv cfv wceq wi wral wrex cif wcel ifcl syl2anc weq w3o solin
          wa wor syl12anc adantr breq1 fveq2 eqeq12d imbi12d rspcva imp breqtrd
          wb iftrue fveq2d breq12d adantl mpbird wpo cmap co wf elmapi ffvelrnd
          w3a 3jca syl5ibcom potr syl22anc ifeq1 ifid syl6eq eqbrtrd sopo po2nr
          syl wn nan mpbi iffalse 3jaodan r19.26 sylanbrc prth eqtr syl6 ralimi
          mpdan simpl1 simpr simpl2 simpl3 soltmin syl13anc biimpd ralimdva mpd
          imim1d syl2im breq2 imbi1d ralbidv anbi12d rspcev wemaplem1 ) AHILUKZ
          UJULZHUMZYJIUMZKUKZPULZYJJUKZYNHUMZYNIUMZUNZUOZPFUPZVEZUJFUQZANULZOUL
          ZJUKZUUCUUDURZFUSZUUFHUMZUUFIUMZKUKZYNUUFJUKZYRUOZPFUPZUUBAUUCFUSZUUD
          FUSZUUGUDUGUUEUUCUUDFUTVAAUUENOVBZUUDUUCJUKZVCZUUJAFJVFZUUNUUOUURUBUD
          UGFUUCUUDJVDVGAUUEUUJUUPUUQAUUEVEZUUJUUCHUMZUUCIUMZKUKZUUTUVAUUCMUMZU
          VBKAUVAUVDKUKZUUEUEVHAUUEUVDUVBUNZAUUNYNUUDJUKZYNMUMZYQUNZUOZPFUPZUUE
          UVFUOZUDUIUVJUVLPUUCFPNVBZUVGUUEUVIUVFYNUUCUUDJVIUVMUVHUVDYQUVBYNUUCM
          VJYNUUCIVJVKVLVMVAVNVOUUEUUJUVCVPAUUEUUHUVAUUIUVBKUUEUUFUUCHUUEUUCUUD
          VQZVRUUEUUFUUCIUVNVRVSVTWAAUUPVEZUUJUUDHUMZUUDIUMZKUKZUVOGKWBZUVPGUSZ
          UUDMUMZGUSZUVQGUSZWHZUVPUWAKUKZUWAUVQKUKZUVRAUVSUUPUCVHAUWDUUPAUVTUWB
          UWCAFGUUDHAHGFWCWDZUSZFGHWESHGFWFWSUGWGAFGUUDMAMUWGUSFGMWETMGFWFWSUGW
          GAFGUUDIAIUWGUSZFGIWEUAIGFWFWSUGWGWIVHAUUPUWEAUVEUUPUWEUEUUPUVAUVPUVD
          UWAKUUCUUDHVJUUCUUDMVJVSWJVNAUWFUUPUHVHUVSUWDVEUWEUWFVEUVRGUVPUWAUVQK
          WKVNWLUUPUUJUVRVPZAUUPUUHUVPUUIUVQKUUPUUFUUDHUUPUUFUUEUUDUUDURUUDUUEU
          UCUUDUUDWMUUEUUDWNWOZVRUUPUUFUUDIUWKVRVSVTWAAUUQVEZUUJUVRUWLUVPUWAUVQ
          KAUUQUVPUWAUNZAUUOYNUUCJUKZYPUVHUNZUOZPFUPZUUQUWMUOZUGUFUWPUWRPUUDFPO
          VBZUWNUUQUWOUWMYNUUDUUCJVIUWSYPUVPUVHUWAYNUUDHVJYNUUDMVJVKVLVMVAVNAUW
          FUUQUHVHWPUWLUUEWTZUWJAUUQUUEVEWTZUOUWLUWTUOAFJWBZUUOUUNUXAAUUSUXBUBF
          JWQWSUGUDFUUDUUCJWRVGAUUQUUEXAXBUWTUUHUVPUUIUVQKUWTUUFUUDHUUEUUCUUDXC
          ZVRUWTUUFUUDIUXCVRVSWSWAXDXKAUWPUVJVEZPFUPZUUMAUWQUVKUXEUFUIUWPUVJPFX
          EXFAUUSUUNUUOWHZUXEUWNUVGVEZYRUOZPFUPUUMAUUSUUNUUOUBUDUGWIUXDUXHPFUXD
          UXGUWOUVIVEYRUWNUWOUVGUVIXGYPUVHYQXHXIXJUXFUXHUULPFUXFYNFUSZVEZUUKUXG
          YRUXJUUKUXGUXJUUSUXIUUNUUOUUKUXGVPUUSUUNUUOUXIXLUXFUXIXMUUSUUNUUOUXIX
          NUUSUUNUUOUXIXOYNUUCUUDJFXPXQXRYAXSYBXTUUAUUJUUMVEUJUUFFYJUUFUNZYMUUJ
          YTUUMUXKYKUUHYLUUIKYJUUFHVJYJUUFIVJVSUXKYSUULPFUXKYOUUKYRYJUUFYNJYCYD
          YEYFYGVGAUWHUWIYIUUBVPSUABCDEFHIJKLUWGUWGUJPQYHVAWA $.
      $}

      $d ph a b c $.
      wemaplem3.px $e |- ( ph -> P T X ) $.
      wemaplem3.xq $e |- ( ph -> X T Q ) $.
      $( Lemma for ~ wemapso .  Transitivity.  (Contributed by Stefan O'Rear,
         17-Jan-2015.) $)
      wemaplem3 $p |- ( ph -> P T Q ) $=
        ( va vc vb cv cfv wbr wceq wi wral wa wrex cmap co wb wemaplem1 syl2anc
        mpbid cvv ad2antrr wor wpo simplrl simp2rl 3expa simprr ad2antlr simprl
        wcel simprrl simprrr wemaplem2 rexlimdvaa mp2d ) AUCUFZHUGVPMUGKUHZUDUF
        ZVPJUHVRHUGVRMUGZUIUJUDFUKZULZUCFUMZUEUFZMUGWCIUGKUHZVRWCJUHVSVRIUGUIUJ
        UDFUKZULZUEFUMZHILUHZAHMLUHZWBUAAHGFUNUOZVJZMWJVJZWIWBUPPQBCDEFHMJKLWJW
        JUCUDNUQURUSAMILUHZWGUBAWLIWJVJZWMWGUPQRBCDEFMIJKLWJWJUEUDNUQURUSAWAWGW
        HUJUCFAVPFVJZWAULZULZWFWHUEFWQWCFVJZWFULZULBCDEFGHIJKLMUCUEUDNAFUTVJWPW
        SOVAAWKWPWSPVAAWLWPWSQVAAWNWPWSRVAAFJVBWPWSSVAAGKVCWPWSTVAAWOWAWSVDAWPW
        SVQVQVTWOAWSVEVFWPVTAWSWOVQVTVGVHWQWRWFVIWQWRWDWEVKWQWRWDWEVLVMVNVNVO
        $.
    $}

    $( Construct lexicographic order on a function space based on a
       well-ordering of the indexes and a total ordering of the values.

       Without totality on the values or least differing indexes, the best we
       can prove here is a partial order.  (Contributed by Stefan O'Rear,
       18-Jan-2015.) $)
    wemappo $p |- ( ( A e. V /\ R Or A /\ S Po B ) -> T Po ( B ^m A ) ) $=
      ( va vb vc wcel cvv wpo cv wa wbr wor cmap co elex w3a cfv wceq wral wrex
      wi wn simpll3 wf elmapi adantl ffvelrnda poirr syl2anc intnanrd nrexdv wb
      vex wemaplem1 mp2an sylnibr simpll1 simplr1 simplr2 simplr3 simprl simprr
      simpll2 wemaplem3 ex ispod syl3an1 ) EJOEPOZEGUAZFHQZFEUBUCZIQEJUDVQVRVSU
      EZLMNVTIWALRZVTOZSZMRZWBUFZWFHTZNRZWEGTWHWBUFZWIUGUJNEUHZSZMEUIZWBWBITZWD
      WKMEWDWEEOZSZWGWJWOVSWFFOWGUKVQVRVSWCWNULWDEFWEWBWCEFWBUMWAWBFEUNUOUPFWFH
      UQURUSUTWBPOZWPWMWLVALVBZWQABCDEWBWBGHIPPMNKVCVDVEWAWCWEVTOZWHVTOZUEZSZWB
      WEITZWEWHITZSZWBWHITXAXDSABCDEFWBWHGHIWEKVQVRVSWTXDVFWCWRWSWAXDVGWCWRWSWA
      XDVHWCWRWSWAXDVIVQVRVSWTXDVLVQVRVSWTXDULXAXBXCVJXAXBXCVKVMVNVOVP $.

    ${
      $d ph a b c d $.
      wemapso2lem.1 $e |- U C_ ( B ^m A ) $.
      wemapso2lem.2 $e |- ( ph -> A e. _V ) $.
      wemapso2lem.3 $e |- ( ph -> R Or A ) $.
      wemapso2lem.4 $e |- ( ph -> S Or B ) $.
      wemapso2lem.5 $e |- ( ( ph /\ ( ( a e. U /\ b e. U ) /\ a =/= b ) ) ->
        E. c e. dom ( a \ b ) A. d e. dom ( a \ b ) -. d R c ) $.
      $( Lemma for ~ wemapso .  (Contributed by Stefan O'Rear, 18-Jan-2015.)
         (Revised by Mario Carneiro, 8-Feb-2015.) $)
      wemapso2lem $p |- ( ph -> T Or U ) $=
        ( cmap co wss wpo cvv wcel wor sopo syl wemappo syl3anc mpsyl cv wa weq
        poss wbr wo w3o wn wne df-ne cfv wceq wi wral wrex cdif cdm crab wfn wf
        simprll sseldi elmapi simprlr fndmdif syl2anc eleq2d nesym fveq2 notbid
        eqeq12d syl5bb elrab syl6bb imbi1d impexp con34b imbi2i bitr4i ralbidv2
        anbi12d anass rexbidv2 mpbid ad2antrr ffvelrnda sotrieq con2bid biimprd
        ffn syl12anc anim1d reximdva mpd wb wemaplem1 mp2an orbi12i andir eqcom
        vex r19.43 ralbii anbi2i orbi2i bitr2i rexbii bitri sylibr expr syl5bir
        orrd 3orrot 3orass sylib issod ) ALMKJKGFUBUCZUDAYJJUEZKJUEQAFUFUGFHUHG
        IUEZYKRSAGIUHZYLTGIUIUJBCDEFGHIJUFPUKULKYJJUQUMALUNZKUGZMUNZKUGZUOZUOZL
        MUPZYPYNJURZYNYPJURZUSZUSZUUBYTUUAUTZYSYTUUCYTVAYNYPVBZYSUUCYNYPVCAYRUU
        FUUCAYRUUFUOZUOZNUNZYPVDZUUIYNVDZIURZUUKUUJIURZUSZOUNZUUIHURZUUOYPVDZUU
        OYNVDZVEZVFZOFVGZUOZNFVHZUUCUUHUUJUUKVEZVAZUVAUOZNFVHZUVCUUHUUPVAZOYNYP
        VIVJZVGZNUVIVHUVGUAUUHUVJUVFNUVIFUUHUUIUVIUGZUVJUOUUIFUGZUVEUOZUVAUOUVL
        UVFUOUUHUVKUVMUVJUVAUUHUVKUUIBUNZYNVDZUVNYPVDZVBZBFVKZUGUVMUUHUVIUVRUUI
        UUHYNFVLZYPFVLZUVIUVRVEUUHFGYNVMZUVSUUHYNYJUGUWAUUHKYJYNQAYOYQUUFVNVOYN
        GFVPUJZFGYNXCUJUUHFGYPVMZUVTUUHYPYJUGUWCUUHKYJYPQAYOYQUUFVQVOYPGFVPUJZF
        GYPXCUJBFYNYPVRVSZVTUVQUVEBUUIFUVQUVPUVOVEZVAZBNUPZUVEUVOUVPWAZUWHUWFUV
        DUWHUVPUUJUVOUUKUVNUUIYPWBUVNUUIYNWBWDWCWEWFWGUUHUVHUUTOUVIFUUHUUOUVIUG
        ZUVHVFUUOFUGZUUSVAZUOZUVHVFZUWKUUTVFZUUHUWJUWMUVHUUHUWJUUOUVRUGUWMUUHUV
        IUVRUUOUWEVTUVQUWLBUUOFUVQUWGBOUPZUWLUWIUWPUWFUUSUWPUVPUUQUVOUURUVNUUOY
        PWBUVNUUOYNWBWDWCWEWFWGWHUWNUWKUWLUVHVFZVFUWOUWKUWLUVHWIUUTUWQUWKUUPUUS
        WJWKWLWGWMWNUVLUVEUVAWOWGWPWQUUHUVFUVBNFUUHUVLUOZUVEUUNUVAUWRYMUUJGUGZU
        UKGUGZUVEUUNVFAYMUUGUVLTWRUUHFGUUIYPUWDWSUUHFGUUIYNUWBWSYMUWSUWTUOUOZUU
        NUVEUXAUVDUUNGUUJUUKIWTXAXBXDXEXFXGUUCUULUVAUOZUUMUUPUURUUQVEZVFZOFVGZU
        OZUSZNFVHZUVCUUCUXBNFVHZUXFNFVHZUSUXHUUAUXIUUBUXJYPUFUGZYNUFUGZUUAUXIXH
        MXNZLXNZBCDEFYPYNHIJUFUFNOPXIXJUXLUXKUUBUXJXHUXNUXMBCDEFYNYPHIJUFUFNOPX
        IXJXKUXBUXFNFXOWLUXGUVBNFUVBUXBUUMUVAUOZUSUXGUULUUMUVAXLUXOUXFUXBUVAUXE
        UUMUUTUXDOFUUSUXCUUPUUQUURXMWKXPXQXRXSXTYAYBYCYDYEUUEYTUUAUUBUTUUDUUBYT
        UUAYFYTUUAUUBYGXSYHYI $.
    $}

    $( Construct lexicographic order on a function space based on a
       well-ordering of the indexes and a total ordering of the values.
       (Contributed by Stefan O'Rear, 18-Jan-2015.)  (Revised by Mario
       Carneiro, 8-Feb-2015.) $)
    wemapso $p |- ( ( A e. V /\ R We A /\ S Or B ) -> T Or ( B ^m A ) ) $=
      ( vc vd wcel cvv wor cv wa wss syl va vb wwe cmap co elex ssid simp1 weso
      w3a 3ad2ant2 simp3 wne cdif cdm wfr c0 wbr wn wral wrex simpl1 difss dmss
      ax-mp wfn wceq wf simprll elmapi ffn fndm syl5sseq ssexd simpl2 simprr wb
      wefr simprlr fndmdifeq0 syl2anc necon3bid mpbird fri syl22anc wemapso2lem
      syl3an1 ) EJNEONZEGUCZFHPZFEUDUEZIPEJUFWHWIWJUJZABCDEFGHIWKUAUBLMKWKUGWHW
      IWJUHWIWHEGPWJEGUIUKWHWIWJULWLUAQZWKNZUBQZWKNZRZWMWOUMZRZRZWMWOUNZUOZONEG
      UPZXBESXBUQUMZMQLQGURUSMXBUTLXBVAWTXBEOWHWIWJWSVBWTWMUOZXBEXAWMSXBXESWMWO
      VCXAWMVDVEWTWMEVFZXEEVGWTEFWMVHZXFWTWNXGWLWNWPWRVIWMFEVJTEFWMVKTZEWMVLTVM
      ZVNWTWIXCWHWIWJWSVOEGVRTXIWTXDWRWLWQWRVPWTXBUQWMWOWTXFWOEVFZXBUQVGWMWOVGV
      QXHWTEFWOVHZXJWTWPXKWLWNWPWRVSWOFEVJTEFWOVKTEWMWOVTWAWBWCLMEXBOGWDWEWFWG
      $.

    wemapso2.u $e |- U = { x e. ( B ^m A ) |
      ( `' x " ( _V \ { Z } ) ) e. Fin } $.
    $( An alternative to having a well-order on ` R ` in ~ wemapso is to
       restrict the function set to finitely-supported functions.  (Contributed
       by Mario Carneiro, 8-Feb-2015.) $)
    wemapso2 $p |- ( ( A e. V /\ R Or A /\ S Or B ) -> T Or U ) $=
      ( vc wcel cfn wa wceq syl va vb vd cvv wor elex w3a cv ccnv csn cdif cima
      cmap co crab ssrab2 eqsstri simp1 simp2 simp3 wne cdm cun wfr wss c0 wral
      wbr wrex simprll cnveq imaeq1d eleq1d elrab2 simprbi simprlr unfi syl2anc
      wn cfv wfn wf sseldi elmapi ffn fndmdif wi wo eqtr3 necon3ai neorian elun
      sylibr adantr elpreima simpr biantrurd bitr4d fvex eldifsn mpbiran syl6bb
      orbi12d syl5bb syl5ibr ralrimiva rabss eqsstrd ssfi wwe cnvimass syl5sseq
      fdm unssd soss sylc wofi wefr simprr fndmdifeq0 necon3bid mpbird syl22anc
      wb fri wemapso2lem syl3an1 ) EKPEUDPZEGUEZFHUEZJIUEEKUFYHYIYJUGZABCDEFGHI
      JUAUBOUCMJAUHZUIZUDLUJUKZULZQPZAFEUMUNZUOYQNYPAYQUPUQZYHYIYJURYHYIYJUSZYH
      YIYJUTYKUAUHZJPZUBUHZJPZRZYTUUBVAZRZRZYTUUBUKVBZQPZYTUIZYNULZUUBUIZYNULZV
      CZGVDZUUHUUNVEZUUHVFVAZUCUHOUHZGVHVSUCUUHVGOUUHVIUUGUUNQPZUUPUUIUUGUUKQPZ
      UUMQPZUUSUUGUUAUUTYKUUAUUCUUEVJZUUAYTYQPZUUTYPUUTAYTYQJYLYTSZYOUUKQUVDYMU
      UJYNYLYTVKVLVMNVNVOTUUGUUCUVAYKUUAUUCUUEVPZUUCUUBYQPZUVAYPUVAAUUBYQJYLUUB
      SZYOUUMQUVGYMUULYNYLUUBVKVLVMNVNVOTUUKUUMVQVRZUUGUUHUURYTVTZUURUUBVTZVAZO
      EUOZUUNUUGYTEWAZUUBEWAZUUHUVLSUUGEFYTWBZUVMUUGUVCUVOUUGJYQYTYRUVBWCYTFEWD
      TZEFYTWETZUUGEFUUBWBZUVNUUGUVFUVRUUGJYQUUBYRUVEWCUUBFEWDTZEFUUBWETZOEYTUU
      BWFVRUUGUVKUURUUNPZWGZOEVGUVLUUNVEUUGUWBOEUVKUWAUUGUUREPZRZUVILVAZUVJLVAZ
      WHZUVKUVILSUVJLSRZVSUWGUWHUVIUVJUVIUVJLWIWJUVILUVJLWKWMUWAUURUUKPZUURUUMP
      ZWHUWDUWGUURUUKUUMWLUWDUWIUWEUWJUWFUWDUWIUVIYNPZUWEUWDUWIUWCUWKRZUWKUWDUV
      MUWIUWLYDUUGUVMUWCUVQWNEUURYNYTWOTUWDUWCUWKUUGUWCWPZWQWRUWKUVIUDPUWEUURYT
      WSUVIUDLWTXAXBUWDUWJUVJYNPZUWFUWDUWJUWCUWNRZUWNUWDUVNUWJUWOYDUUGUVNUWCUVT
      WNEUURYNUUBWOTUWDUWCUWNUWMWQWRUWNUVJUDPUWFUURUUBWSUVJUDLWTXAXBXCXDXEXFUVK
      OEUUNXGWMXHZUUNUUHXIVRUUGUUNGXJZUUOUUGUUNGUEZUUSUWQUUGUUNEVEYIUWRUUGUUKUU
      MEUUGYTVBZUUKEYTYNXKUUGUVOUWSESUVPEFYTXMTXLUUGUUBVBZUUMEUUBYNXKUUGUVRUWTE
      SUVSEFUUBXMTXLXNYKYIUUFYSWNUUNEGXOXPUVHUUNGXQVRUUNGXRTUWPUUGUUQUUEYKUUDUU
      EXSUUGUUHVFYTUUBUUGUVMUVNUUHVFSYTUUBSYDUVQUVTEYTUUBXTVRYAYBOUCUUNUUHQGYEY
      CYFYG $.
  $}

  ${
    $d A x y z $.
    $( Proof that the alternate definition ~ cardval2 is always a set, and
       indeed is an ordinal.  (Contributed by Mario Carneiro, 14-Jan-2013.) $)
    card2on $p |- { x e. On | x ~< A } e. On $=
      ( vy vz cvv wcel cv csdm wbr con0 crab word wss wa wi wal cdom imp breq1
      c0 wtr onelon vex onelss ssdomg mpsyl domsdomtr anassrs sylan exp31 com12
      anim2i imp3a elrab 3imtr4g gen2 dftr2 mpbir ssrab2 ordon trssord mp3an wb
      jca hartogs sdomdom ss2rabi ssexg mpan elong 3syl mpbiri wceq 0elon eleq1
      a1i wrex wne df-ne rabn0 bitr3i relsdom brrelex2i rexlimivw sylbi pm2.61i
      wn nsyl4 ) BEFZAGZBHIZAJKZJFZWIWMWLLZWLUAZWLJMJLWNWOCGZDGZFZWQWLFZNWPWLFZ
      OZDPCPXACDWRWSWTWRWQJFZWQBHIZNWPJFZWPBHIZNZWSWTWRXBXCXFXBWRXCXFOXBWRXCXFX
      BWRNZXDWPWQQIZNXCXFXGXDXHWQWPUBWQEFXGWPWQMZXHDUCXBWRXIWQWPUDRWPWQEUEUFVDX
      DXHXCXFXHXCNXEXDWPWQBUGULUHUIUJUKUMWKXCAWQJWJWQBHSUNWKXEAWPJWJWPBHSUNUORU
      PCDWLUQURWKAJUSUTWLJVAVBWIWJBQIZAJKZJFZWLEFZWMWNVCABEVEWLXKMXLXMWKXJAJWKX
      JOWJJFWJBVFVPVGWLXKJVHVIWLEVJVKVLWLTVMZWMWIXNWMTJFVNWLTJVOVLXNWGZWKAJVQZW
      IXOWLTVRXPWLTVSWKAJVTWAWKWIAJWJBHWBWCWDWEWHWF $.
  $}

  ${
    $d A x y n $.
    card2inf.1 $e |- A e. _V $.
    $( The definition ~ cardval2 has the curious property that for
       non-numerable sets (for which ~ ndmfv yields ` (/) ` ), it still
       evaluates to a non-empty set, and indeed it contains ` om ` .
       (Contributed by Mario Carneiro, 15-Jan-2013.)  (Revised by Mario
       Carneiro, 27-Apr-2015.) $)
    card2inf $p |- ( -. E. y e. On y ~~ A -> om C_ { x e. On | x ~< A } ) $=
      ( vn cv cen wbr con0 wn csdm com wcel c0 breq1 rspcev cdom brsdom mpbiran
      wss wrex wral crab csuc 0elon mpan con3i 0dom wa sucdom2 ad2antll wi nnon
      sylibr suceloni 3syl con3and adantrr sylanbrc exp32 finds2 com12 ralrimiv
      ex omsson ssrab ) BFZCGHZBIUAZJZAFZCKHZALUBZLVLAIUCTZVJVLALVKLMVJVLVLNCKH
      ZEFZCKHZVPUDZCKHZVJAEVKNCKOVKVPCKOVKVRCKOVJNCGHZJZVOVTVINIMVTVIUEVHVTBNIV
      GNCGOPUFUGVONCQHWACDUHNCRSUNVPLMZVJVQVSWBVJVQUIUIVRCQHZVRCGHZJZVSVQWCWBVJ
      VPCUJUKWBVJWEVQWBWDVIWBVPIMVRIMZWDVIULVPUMVPUOWFWDVIVHWDBVRIVGVRCGOPVDUPU
      QURVRCRUSUTVAVBVCVNLITVMVEVLAILVFSUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Hartogs function, order types, weak dominance
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c har ~<_* $.

  $( Class symbol for the Hartogs/cardinal successor function. $)
  char $a class har $.

  $( Class symbol for the weak dominance relation. $)
  cwdom $a class ~<_* $.

  ${
    $d x y z $.

    $( Define the _Hartogs function_ , which maps all sets to the smallest
       ordinal that cannot be injected into the given set.  In the important
       special case where ` x ` is an ordinal, this is the _cardinal successor_
       operation.

       Traditionally, the Hartogs number of a set is written ` aleph ( X ) `
       and the cardinal successor ` X + ` ; we use functional notation for
       this, and cannot use the aleph symbol because it is taken for the
       enumerating function of the infinite initial ordinals ~ df-aleph .

       Some authors define the Hartogs number of a set to be the least
       *infinite* ordinal which does not inject into it, thus causing the range
       to consist only of alephs.  We use the simpler definition where the
       value can be any successor cardinal.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    df-har $a |- har = ( x e. _V |-> { y e. On | y ~<_ x } ) $.

    $( A set is _weakly dominated_ by a "larger" set iff the "larger" set can
       be mapped onto the "smaller" set or the smaller set is empty;
       equivalently if the smaller set can be placed into bijection with some
       partition of the larger set.  When choice is assumed (as ~ fodom ), this
       concides with the 1-1 defition ~ df-dom ; however, it is not known
       whether this is a choice-equivalent or a strictly weaker form.  Some
       discussion of this question can be found at
       ~ http://boolesrings.org/asafk/2014/on-the-partition-principle/ .
       (Contributed by Stefan O'Rear, 11-Feb-2015.) $)
    df-wdom $a |- ~<_* = { <. x , y >. | ( x = (/) \/
            E. z z : y -onto-> x ) } $.
  $}

  ${
    $d x y X $.  $d x y Y $.
    $( Functionality of the Hartogs function.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    harf $p |- har : _V --> On $=
      ( vx vy cvv con0 cv cdom wbr crab char df-har hartogs fmpti ) ACDBEAEZFGB
      DHIABJBMCKL $.

    $( Closure of the Hartogs function in the ordinals.  (Contributed by Stefan
       O'Rear, 11-Feb-2015.) $)
    harcl $p |- ( har ` X ) e. On $=
      ( cvv con0 char harf 0elon f0cli ) BCADEFG $.

    $( Function value of the Hartogs function.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    harval $p |- ( X e. V -> ( har ` X ) = { y e. On | y ~<_ X } ) $=
      ( vx wcel cvv char cfv cdom wbr con0 crab wceq elex breq2 rabbidv hartogs
      cv df-har fvmpt3 syl ) CBECFECGHARZCIJZAKLZMCBNDCUBDRZIJZAKLUDFGKUECMUFUC
      AKUECUBIOPDASAUEFQTUA $.

    $( The Hartogs number of a set is greater than all ordinals which inject
       into it.  (Contributed by Stefan O'Rear, 11-Feb-2015.)  (Revised by
       Mario Carneiro, 15-May-2015.) $)
    elharval $p |- ( Y e. ( har ` X ) <->
          ( Y e. On /\ Y ~<_ X ) ) $=
      ( vy char cfv wcel cvv con0 cdom wbr wa elfvex reldom brrelex2i adantl cv
      crab harval eleq2d breq1 elrab syl6bb pm5.21nii ) BADEZFZAGFZBHFZBAIJZKZB
      ADLUHUFUGBAIMNOUFUEBCPZAIJZCHQZFUIUFUDULBCGARSUKUHCBHUJBAITUAUBUC $.

    $( The Hartogs number of a set does not inject into that set.  (Contributed
       by Stefan O'Rear, 11-Feb-2015.)  (Revised by Mario Carneiro,
       15-May-2015.) $)
    harndom $p |- -. ( har ` X ) ~<_ X $=
      ( char cfv wcel cdom wbr harcl onirri con0 elharval mpbiran mtbi ) ABCZMD
      ZMAEFZMAGZHNMIDOPAMJKL $.

    $( Weak ordering property of the Hartogs function.  (Contributed by Stefan
       O'Rear, 14-Feb-2015.) $)
    harword $p |- ( X ~<_ Y -> ( har ` X ) C_ ( har ` Y ) ) $=
      ( vy cdom wbr cv con0 crab char cfv wi wcel expcom adantr cvv wceq reldom
      domtr harval syl ss2rabdv brrelexi brrelex2i 3sstr4d ) ABDEZCFZADEZCGHZUF
      BDEZCGHZAIJZBIJZUEUGUICGUEUGUIKUFGLUGUEUIUFABRMNUAUEAOLUKUHPABDQUBCOASTUE
      BOLULUJPABDQUCCOBSTUD $.
  $}

  ${
    $d X x y z w $.  $d Y x y z w $.  $d F x y z $.  $d Z x y z w $.

    $( Weak dominance is a relation.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    relwdom $p |- Rel ~<_* $=
      ( vx vy vz cv c0 wceq wfo wex wo cwdom df-wdom relopabi ) ADZEFBDMCDGCHIA
      BJABCKL $.

    $( Property of weak dominance (definitional form).  (Contributed by Stefan
       O'Rear, 11-Feb-2015.) $)
    brwdom $p |- ( Y e. V -> ( X ~<_* Y <->
          ( X = (/) \/ E. z z : Y -onto-> X ) ) ) $=
      ( vx vy wcel cvv cwdom wbr c0 wceq cv wfo wex wo wb wi a1i exbidv relwdom
      elex brrelexi 0ex eleq1a ax-mp crn forn rnex syl6eqelr exlimiv jaoi eqeq1
      vex foeq3 orbi12d foeq2 orbi2d df-wdom brabg expcom pm5.21ndd syl ) DBGDH
      GZCDIJZCKLZDCAMZNZAOZPZQZDBUBVDCHGZVEVJVEVLRVDCDIUAUCSVJVLRVDVFVLVIKHGVFV
      LRUDKHCUEUFVHVLAVHCVGUGHDCVGUHVGAUNUIUJUKULSVLVDVKEMZKLZFMZVMVGNZAOZPVFVO
      CVGNZAOZPVJEFCDHHIVMCLZVNVFVQVSVMCKUMVTVPVRAVMCVOVGUOTUPVODLZVSVIVFWAVRVH
      AVODCVGUQTUREFAUSUTVAVBVC $.

    $( Property of weak dominance, forward direction only.  (Contributed by
       Mario Carneiro, 5-May-2015.) $)
    brwdomi $p |- ( X ~<_* Y -> ( X = (/) \/ E. z z : Y -onto-> X ) ) $=
      ( cwdom wbr c0 wceq cv wfo wex wo cvv wb relwdom brrelex2i brwdom syl ibi
      wcel ) BCDEZBFGCBAHIAJKZTCLSTUAMBCDNOALBCPQR $.

    $( Weak dominance over nonempty sets.  (Contributed by Stefan O'Rear,
       11-Feb-2015.)  (Revised by Mario Carneiro, 5-May-2015.) $)
    brwdomn0 $p |- ( X =/= (/) -> ( X ~<_* Y <-> E. z z : Y -onto-> X ) ) $=
      ( c0 wne cvv wcel cwdom wbr cv wfo wex wi relwdom brrelex2i a1i cdm wf wb
      wceq fof fdm syl vex syl6eqelr exlimiv wo brwdom df-ne biorf sylbi bicomd
      dmex wn sylan9bbr ex pm5.21ndd ) BDEZCFGZBCHIZCBAJZKZALZUTUSMURBCHNOPVCUS
      MURVBUSAVBCVAQZFVBCBVARVDCTCBVAUACBVAUBUCVAAUDUMUEUFPURUSUTVCSUSUTBDTZVCU
      GZURVCAFBCUHURVCVFURVEUNVCVFSBDUIVEVCUJUKULUOUPUQ $.

    $( Any set weakly dominates the empty set.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    0wdom $p |- ( X e. V -> (/) ~<_* X ) $=
      ( vz wcel c0 cwdom wbr wceq cv wfo wex wo eqid orci brwdom mpbiri ) BADEB
      FGEEHZBECIJCKZLQREMNCAEBOP $.

    $( An onto function implies weak dominance.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    fowdom $p |- ( ( F e. V /\ F : Y -onto-> X ) -> X ~<_* Y ) $=
      ( vz wcel cvv wfo cwdom wbr elex wa c0 wceq cv wex wo foeq1 spcegv imp wb
      olcd wf fof dmfex sylan2 brwdom syl mpbird sylan ) ABFAGFZDCAHZCDIJZABKUK
      ULLZUMCMNZDCEOZHZEPZQZUNURUOUKULURUQULEAGDCUPARSTUBUNDGFZUMUSUAULUKDCAUCU
      TDCAUDDCGAUEUFEGCDUGUHUIUJ $.

    $( Reflexivity of weak dominance.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    wdomref $p |- ( X e. V -> X ~<_* X ) $=
      ( wcel cid cres cvv wfo cwdom wbr resiexg wf1o f1ofo ax-mp fowdom sylancl
      f1oi ) BACDBEZFCBBQGZBBHIBAJBBQKRBPBBQLMQFBBNO $.

    $( Alternate characterization of the weak dominance predicate which does
       not require special treatment of the empty set.  (Contributed by Stefan
       O'Rear, 11-Feb-2015.) $)
    brwdom2 $p |- ( Y e. V -> ( X ~<_* Y <->
          E. y e. ~P Y E. z z : y -onto-> X ) ) $=
      ( vx vw wcel cvv cwdom cv wfo wex c0 wceq wa foeq1 adantl cun wfn wbr cpw
      wrex elex 0wdom breq1 syl5ibrcom imp 0elpw wf1o f1o0 f1ofo 0ex spcev mp2b
      wb foeq2 exbidv rspcev mp2an foeq3 rexbidv mpbiri 2thd wne brwdomn0 pwidg
      cbvexv ad2antrr sylancom ex syl5bi n0 biimpi ad2antlr cdif csn cxp difexg
      vex snex xpexg sylancl unexg sylancr adantr crn cin fofn fnconstg disjdif
      mp1i a1i fnun syl21anc wss elpwi undif sylib ad2antrl mpbid rnun ad2antll
      fneq2d forn uneq1d wf fconst6g frn syl eqtrd syl5eq df-fo sylanbrc spcegv
      ssequn2 sylc exlimddv expr exlimdv rexlimdva impbid bitrd pm2.61dane ) EC
      HEIHZDEJUAZAKZDBKZLZBMZAEUBZUCZUPZECUDYEYMDNYEDNOZPYFYLYEYNYFYEYFYNNEJUAI
      EUEDNEJUFUGUHYNYLYEYNYLYGNYHLZBMZAYKUCZNYKHNNYHLZBMZYQEUINNNUJNNNLZYSUKNN
      NULYRYTBNUMNNYHNQUNUOYPYSANYKYGNOYOYRBYGNNYHUQURUSUTYNYJYPAYKYNYIYOBDNYGY
      HVAURVBVCRVDYEDNVEZPZYFEDFKZLZFMZYLUUAYFUUEUPYEFDEVFRUUBUUEYLUUEEDYHLZBMZ
      UUBYLUUDUUFFBEDUUCYHQVHUUBUUGYLUUBUUGEYKHZYLYEUUHUUAUUGEIVGVIYJUUGAEYKYGE
      OYIUUFBYGEDYHUQURUSVJVKVLUUBYJUUEAYKUUBYGYKHZPYIUUEBUUBUUIYIUUEUUBUUIYIPZ
      PZGKZDHZUUEGUUAUUMGMZYEUUJUUAUUNGDVMVNVOUUKUUMPZYHEYGVPZUULVQZVRZSZIHZEDU
      USLZUUEUUBUUTUUJUUMYEUUTUUAYEYHIHUURIHZUUTBVTYEUUPIHUUQIHUVBEYGIVSUULWAUU
      PUUQIIWBWCYHUURIIWDWEWFVIUUOUUSETZUUSWGZDOUVAUUOUUSYGUUPSZTZUVCUUOYHYGTZU
      URUUPTZYGUUPWHNOZUVFUUJUVGUUBUUMYIUVGUUIYGDYHWIRVOUULIHUVHUUOGVTUUPUULIWJ
      WLUVIUUOYGEWKWMYGUUPYHUURWNWOUUOUVEEUUSUUKUVEEOZUUMUUIUVJUUBYIUUIYGEWPUVJ
      YGEWQYGEWRWSWTWFXDXAUUOUVDYHWGZUURWGZSZDYHUURXBUUOUVMDUVLSZDUUOUVKDUVLUUK
      UVKDOZUUMYIUVOUUBUUIYGDYHXEXCWFXFUUOUVLDWPZUVNDOUUMUVPUUKUUMUUPDUURXGUVPU
      UPUULDXHUUPDUURXIXJRUVLDXPWSXKXLEDUUSXMXNUUDUVAFUUSIEDUUCUUSQXOXQXRXSXTYA
      YBYCYDXJ $.

    $( Weak dominance is implied by dominance in the usual sense.  (Contributed
       by Stefan O'Rear, 11-Feb-2015.) $)
    domwdom $p |- ( X ~<_ Y -> X ~<_* Y ) $=
      ( vy cdom wbr cwdom c0 wceq cv wfo wex wo wn wa wb cvv wcel reldom mpbird
      syl csdm df-ne biimpri adantl brrelexi 0sdomg adantr simpl fodomr syl2anc
      wne ex orrd brrelex2i brwdom ) ABDEZABFEZAGHZBACIJCKZLZUPURUSUPURMZUSUPVA
      NZGAUAEZUPUSVBVCAGUKZVAVDUPVDVAAGUBUCUDUPVCVDOZVAUPAPQVEABDRUEAPUFTUGSUPV
      AUHBACUIUJULUMUPBPQUQUTOABDRUNCPABUOTS $.

    $( Transitivity of weak dominance.  (Contributed by Stefan O'Rear,
       11-Feb-2015.)  (Revised by Mario Carneiro, 5-May-2015.) $)
    wdomtr $p |- ( ( X ~<_* Y /\ Y ~<_* Z ) -> X ~<_* Z ) $=
      ( vz vy cwdom wbr wa c0 cvv wcel wceq adantl syl wne cv wfo wex wb mpbid
      wi relwdom brrelex2i 0wdom breq1 syl5ibrcom simpll simpllr simplr cdm crn
      brwdomn0 dm0rn0 necon3bii a1i fof fdm neeq1d forn 3bitr3rd ccom coex foco
      wf vex fowdom sylancr expr exlimdv mpd exlimddv ex pm2.61dne ) ABFGZBCFGZ
      HZACFGZAIVPCJKZAILZVQUAVOVRVNBCFUBUCMVRVQVSICFGJCUDAICFUEUFNVPAIOZVQVPVTH
      ZBADPZQZVQDWAVNWCDRZVNVOVTUGVTVNWDSVPDABULMTWAWCHZCBEPZQZERZVQWEVOWHVNVOV
      TWCUHWEBIOZVOWHSWEVTWIVPVTWCUIWCVTWISWAWCWBUJZIOZWBUKZIOZWIVTWKWMSWCWJIWL
      IWBUMUNUOWCWJBIWCBAWBVDWJBLBAWBUPBAWBUQNURWCWLAIBAWBUSURUTMTEBCULNTWEWGVQ
      EWAWCWGVQWCWGHZVQWAWNWBWFVAZJKCAWOQVQWBWFDVEEVEVBCBAWBWFVCWOJACVFVGMVHVIV
      JVKVLVM $.

    $( Equality-like theorem for equinumerosity and weak dominance.
       (Contributed by Mario Carneiro, 18-May-2015.) $)
    wdomen1 $p |- ( A ~~ B -> ( A ~<_* C <-> B ~<_* C ) ) $=
      ( cen wbr cwdom cdom ensym endom domwdom 3syl wdomtr sylan syl impbida )
      ABDEZACFEZBCFEZPBAFEZQRPBADEBAGESABHBAIBAJKBACLMPABFEZRQPABGETABIABJNABCL
      MO $.

    $( Equality-like theorem for equinumerosity and weak dominance.
       (Contributed by Mario Carneiro, 18-May-2015.) $)
    wdomen2 $p |- ( A ~~ B -> ( C ~<_* A <-> C ~<_* B ) ) $=
      ( cen wbr cwdom cdom endom domwdom syl wdomtr syl2anr ensym 3syl impbida
      id ) ABDEZCAFEZCBFEZRRABFEZSQRPQABGETABHABIJCABKLSSBAFEZRQSPQBADEBAGEUAAB
      MBAHBAINCBAKLO $.

    $( Weak dominance strengthens to usual dominance on the power sets.
       (Contributed by Stefan O'Rear, 11-Feb-2015.)  (Revised by Mario
       Carneiro, 5-May-2015.) $)
    wdompwdom $p |- ( X ~<_* Y -> ~P X ~<_ ~P Y ) $=
      ( vz cwdom wbr cpw cdom wi c0 wceq cvv wcel wss relwdom brrelex2i syl 0ss
      pwexg sspwb mpbi ssdomg ee10 pweq breq1d syl5ibr wne wfo wex brwdomn0 vex
      cv fopwdom mpan exlimiv syl6bi pm2.61ine ) ABDEZAFZBFZGEZHAIUQUTAIJZIFZUS
      GEZUQUSKLZVBUSMZVCUQBKLVDABDNOBKRPIBMVEBQIBSTVBUSKUAUBVAURVBUSGAIUCUDUEAI
      UFUQBACUKZUGZCUHUTCABUIVGUTCVFKLVGUTCUJBAVFULUMUNUOUP $.
  $}

  ${
    $d x y z f A $.
    $( Cantor's Theorem, stated using weak dominance (this is actually a
       stronger statement than ~ canth2 , equivalent to ~ canth ).
       (Contributed by Mario Carneiro, 15-May-2015.) $)
    canthwdom $p |- -. ~P A ~<_* A $=
      ( vf vx cpw cwdom wbr cv wfo wex c0 wne wcel 0elpw ne0i mp1i syl cvv wceq
      wb wn brwdomn0 ibi relwdom brrelex2i foeq2 pweq foeq3 bitrd notbid vtoclg
      vex canth nexdv pm2.65i ) ADZAEFZAUOBGZHZBIZUPUSUPUOJKZUPUSSJUOLUTUPAMUOJ
      NOBUOAUAPUBUPURBUPAQLURTZUOAEUCUDCGZVBDZUQHZTVACAQVBARZVDURVEVDAVCUQHZURV
      BAVCUQUEVEVCUORVFURSVBAUFVCUOAUQUGPUHUIVBUQCUKULUJPUMUN $.
  $}

  ${
    $d A v w x y z $.  $d B v w x y z $.  $d X v w x z $.  $d ph w x y $.
    wdom2d.a $e |- ( ph -> A e. V ) $.
    wdom2d.b $e |- ( ph -> B e. W ) $.
    wdom2d.o $e |- ( ( ph /\ x e. A ) -> E. y e. B x = X ) $.
    $( Deduce weak dominance from an implicit onto function (stated in a way
       which avoids ~ ax-rep ).  (Contributed by Stefan O'Rear,
       13-Feb-2015.) $)
    wdom2d $p |- ( ph -> A ~<_* B ) $=
      ( vz vw vv cv wcel wbr cvv wceq wrex csb crab cwdom cmpt wfo rabexg xpexg
      cxp syl syl2anc wf wss csbeq1 eleq1d elrab simprbi eqid fmptd fssxp ssexd
      adantl cfv wral wa wi eleq1 biimpcd ancrd reximdv mpd nfcsb1v nfel1 nfeq2
      nfv csbeq1a eqeq2d anbi12d cbvrex sylib fvmptg mpdan rexbiia rexrab bitri
      nfan sylibr ralrimiva sylanbrc fowdom cdom ssrab2 ssdomg mpi domwdom 3syl
      dffo3 wdomtr ) ADCLOZHUAZDPZLEUBZUCQZXAEUCQZDEUCQAMXACMOZHUAZUDZRPXADXFUE
      ZXBAXFXADUHZRAXARPZDFPXHRPAEGPZXIJWTLEGUFUIIXADRFUGUJAXADXFUKZXFXHULAMXAX
      EDXFXDXAPZXEDPZAXLXDEPXMWTXMLXDEWRXDSWSXEDCWRXDHUMUNUOUPVAXFUQZURZXADXFUS
      UIUTAXKBOZNOZXFVBZSZNXATZBDVCXGXOAXTBDAXPDPZVDZCXQHUAZDPZXPYCSZVDZNETZXTY
      BHDPZXPHSZVDZCETZYGYBYICETYKKYBYIYJCEYAYIYJVEAYAYIYHYIYAYHXPHDVFVGVHVAVIV
      JYJYFCNEYJNVNYDYECCYCDCXQHVKZVLCXPYCYLVMWECOXQSZYHYDYIYEYMHYCDCXQHVOZUNYM
      HYCXPYNVPVQVRVSXTYENXATYGXSYENXAXQXAPZXRYCXPYOYDXRYCSYOXQEPYDWTYDLXQEWRXQ
      SWSYCDCWRXQHUMUNZUOUPMXQXEYCXADXFCXDXQHUMXNVTWAVPWBWTYDYENLEYPWCWDWFWGNBX
      ADXFWPWHXFRDXAWIUJAXJXAEWJQZXCJXJXAEULYQWTLEWKXAEGWLWMXAEWNWODXAEWQUJ $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d ph x y $.  $d X x $.
    wdomd.b $e |- ( ph -> B e. W ) $.
    wdomd.o $e |- ( ( ph /\ x e. A ) -> E. y e. B x = X ) $.
    $( Deduce weak dominance from an implicit onto function.  (Contributed by
       Stefan O'Rear, 13-Feb-2015.) $)
    wdomd $p |- ( ph -> A ~<_* B ) $=
      ( cvv cv wceq wrex cab wcel abrexexg syl wi wal wss ex alrimiv ssab ssexd
      sylibr wdom2d ) ABCDEJFGADBKZGLCEMZBNZJAEFOUIJOHCBEGFPQAUGDOZUHRZBSDUITAU
      KBAUJUHIUAUBUHBDUCUEUDHIUF $.
  $}

  ${
    $d X f w x y z $.  $d Y f w x y z $.
    $( Condition for weak dominance with a condition reminiscent of ~ wdomd .
       (Contributed by Stefan O'Rear, 13-Feb-2015.)  (Revised by Mario
       Carneiro, 25-Jun-2015.) $)
    brwdom3 $p |- ( ( X e. V /\ Y e. W ) -> ( X ~<_* Y <->
          E. f A. x e. X E. y e. Y x = ( f ` y ) ) ) $=
      ( vz vw wcel cvv cv cfv wceq wrex wral wex wb wa adantl cwdom wbr wfo cpw
      elex brwdom2 wf dffo3 simprbi wi wss elpwi ssrexv syl ralimdv syl5 eximdv
      rexlimdva sylbid simpll simplr eqeq1 rexbidv fveq2 eqeq2d cbvrexv cbvralv
      syl6bb biimpi r19.21bi wdom2d ex exlimdv impbid syl2an ) FDJFKJZGKJZFGUAU
      BZALZBLZCLZMZNZBGOZAFPZCQZRGEJFDUEGEUEVPVQSZVRWFWGVRHLZFWAUCZCQZHGUDZOZWF
      VQVRWLRVPHCKFGUFTWGWJWFHWKWGWHWKJZSZWIWECWIWCBWHOZAFPZWNWEWIWHFWAUGWPBAWH
      FWAUHUIWNWOWDAFWMWOWDUJZWGWMWHGUKWQWHGULWCBWHGUMUNTUOUPUQURUSWGWEVRCWGWEV
      RWGWESZHIFGKKILZWAMZVPVQWEUTVPVQWEVAWRWHWTNZIGOZHFWEXBHFPZWGWEXCWDXBAHFVS
      WHNZWDWHWBNZBGOXBXDWCXEBGVSWHWBVBVCXEXABIGVTWSNWBWTWHVTWSWAVDVEVFVHVGVITV
      JVKVLVMVNVO $.

    $( Weak dominance implies existance of a covering function.  (Contributed
       by Stefan O'Rear, 13-Feb-2015.) $)
    brwdom3i $p |- ( X ~<_* Y -> E. f A. x e. X E. y e. Y x = ( f ` y ) ) $=
      ( cwdom wbr cv cfv wceq wrex wral wex cvv wcel relwdom brrelexi brrelex2i
      wb brwdom3 syl2anc ibi ) DEFGZAHBHCHIJBEKADLCMZUCDNOENOUCUDSDEFPQDEFPRABC
      NNDETUAUB $.
  $}

  ${
    $d A a b f g y z $.  $d B a b f g y z $.  $d C a b f g y z $.
    $d D a b f g y z $.  $d V f g y z $.  $d W f g y z $.
    $( Weak dominance of a (disjoint) union.  (Contributed by Stefan O'Rear,
       13-Feb-2015.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    unwdomg $p |- ( ( A ~<_* B /\ C ~<_* D /\ ( B i^i D ) = (/) ) ->
      ( A u. C ) ~<_* ( B u. D ) ) $=
      ( va vb vf vg vz cwdom wbr wceq cv cfv wrex wa cvv wcel relwdom eqeq2d vy
      cin w3a wral cun wex brwdom3i 3ad2ant1 3ad2ant2 adantr cif brrelexi unexg
      c0 syl2an 3adant3 brrelex2i wi wo elun eqeq1 rexbidv rspcva fveq2 cbvrexv
      wss ssun1 iftrue fveq1d biimprd reximia ssrexv mpsyl sylbi ancoms adantlr
      syl adantll syl6bb rspccva ssun2 wn minel iffalse reximdva sylan2 anassrs
      imp adantlrl jaodan sylan2b expl 3ad2ant3 impl expr exlimdv mpd exlimddv
      wdom2d ) ABJKZCDJKZBDUBUNLZUCZEMZFMZGMZNZLZFBOZEAUDZACUEZBDUEZJKZGWTXAXJG
      UFXBEFGABUGUHXCXJPZXDXEHMZNZLZFDOZECUDZHUFZXMXCXTXJXAWTXTXBEFHCDUGUIUJXNX
      SXMHXCXJXSXMXCXJXSPZPUAIXKXLQQIMZYBBRZXFXOUKZNZXCXKQRZYAWTXAYFXBWTAQRCQRY
      FXAABJSULCDJSULACQQUMUOUPUJXCXLQRZYAWTXAYGXBWTBQRDQRYGXAABJSUQCDJSUQBDQQU
      MUOUPUJXCYAUAMZXKRZYHYELZIXLOZXBWTYAYIPYKURXAXBYAYIYKYIXBYAPZYHARZYHCRZUS
      YKYHACUTYLYMYKYNYAYMYKXBXJYMYKXSYMXJYKYMXJPYHXGLZFBOZYKXIYPEYHAXDYHLZXHYO
      FBXDYHXGVAVBVCYPYHYBXFNZLZIBOZYKYOYSFIBXEYBLZXGYRYHXEYBXFVDTVEBXLVFYTYJIB
      OYKBDVGYSYJIBYCYJYSYCYEYRYHYCYBYDXFYCXFXOVHVITVJVKYJIBXLVLVMVNVQVOVPVRXBX
      SYNYKXJXBXSYNYKXSYNPXBYHYBXONZLZIDOZYKXRUUDEYHCYQXRYHXPLZFDOUUDYQXQUUEFDX
      DYHXPVAVBUUEUUCFIDUUAXPUUBYHXEYBXOVDTVEVSVTDXLVFXBUUDPYJIDOZYKDBWAXBUUDUU
      FXBUUCYJIDXBYBDRZPZYJUUCUUHYEUUBYHUUHYBYDXOUUHYCWBZYDXOLUUGXBUUIYBDBWCVOY
      CXFXOWDVQVITVJWEWHYJIDXLVLVMWFWGWIWJWKWLWMWNWSWOWPWQWR $.
  $}

  ${
    $d A a b c f g x y $.  $d B a b c d f g x y $.  $d C a c d f g x y $.
    $d D a b c d f g x y $.  $d V f g x y $.  $d W f g x y $.
    $( Weak dominance of a cross product.  (Contributed by Stefan O'Rear,
       13-Feb-2015.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    xpwdomg $p |- ( ( A ~<_* B /\ C ~<_* D ) -> ( A X. C ) ~<_* ( B X. D ) ) $=
      ( va vb vf vc vd vg vx cwdom wa cv cfv wceq wrex wral cvv wcel vy wbr wex
      cxp brwdom3i adantr adantl wi c1st c2nd cop relwdom brrelexi xpexg syl2an
      brrelex2i pm3.2 ralimdv com12 impcom reximdv ralimi syl eqeq1 opth syl6bb
      2rexbidv ralxp sylibr r19.21bi op1std fveq2d op2ndd opeq12d rexxp adantll
      vex eqeq2d wdom2d expr exlimdv ex mp2d ) ABLUBZCDLUBZMZENZFNZGNZOZPZFBQZE
      ARZGUCZHNZINZJNZOZPZIDQZHCRZJUCZACUDZBDUDZLUBZWDWNWEEFGABUEUFWEXBWDHIJCDU
      EUGWFWMXBXEUHZGWFWMXFWFWMMXAXEJWFWMXAXEWFWMXAMZMKUAXCXDSSUANZUIOZWIOZXHUJ
      OZWQOZUKZWFXCSTZXGWDASTCSTXNWEABLULUMCDLULUMACSSUNUOUFWFXDSTZXGWDBSTDSTXO
      WEABLULUPCDLULUPBDSSUNUOUFXGKNZXCTZXPXMPZUAXDQZWFXGXQMXPWJWRUKZPZIDQFBQZX
      SXGYBKXCXGWKWSMZIDQZFBQZHCRZEARZYBKXCRXGWLWTMZHCRZEARZYGXAWMYJXAWLYIEAWLX
      AYIWLWTYHHCWLWTUQURUSURUTYIYFEAYHYEHCWTWLYEWTWKYDFBWKWTYDWKWSYCIDWKWSUQVA
      USVAUTVBVBVCYBYEKEHACXPWGWOUKZPZYAYCFIBDYLYAYKXTPYCXPYKXTVDWGWOWJWREVQHVQ
      VEVFVGVHVIVJXRYAUAFIBDXHWHWPUKPZXMXTXPYMXJWJXLWRYMXIWHWIWHWPXHFVQZIVQZVKV
      LYMXKWPWQWHWPXHYNYOVMVLVNVRVOVIVPVSVTWAWBWAWC $.
  $}

  $( A set is weakly dominant over its image under any function.  This version
     of ~ wdomimag is stated so as to avoid ~ ax-rep .  (Contributed by Mario
     Carneiro, 25-Jun-2015.) $)
  wdomima2g $p |- ( ( Fun F /\ A e. V /\ ( F " A ) e. W ) ->
      ( F " A ) ~<_* A ) $=
    ( wfun wcel cima w3a crn cwdom df-ima cdm wbr cvv wfo wf funres syl syl2anc
    cres funforn sylib 3ad2ant1 fof wss dmres inss1 eqsstri simp2 ssexg sylancr
    cin simp3 syl5eqelr fex2 syl3anc fowdom cdom ssdomg domwdom 3ad2ant2 wdomtr
    mpi syl5eqbr ) BEZACFZBAGZDFZHZVGBATZIZAJBAKZVIVKVJLZJMZVMAJMZVKAJMVIVJNFZV
    MVKVJOZVNVIVMVKVJPZVMNFZVKDFVPVIVQVRVEVFVQVHVEVJEVQABQVJUAUBUCZVMVKVJUDRVIV
    MAUEZVFVSVMABLZULABAUFAWBUGUHZVEVFVHUIVMACUJUKVIVKVGDVLVEVFVHUMUNVMVKVJNDUO
    UPVTVJNVKVMUQSVFVEVOVHVFVMAURMZVOVFWAWDWCVMACUSVCVMAUTRVAVKVMAVBSVD $.

  $( A set is weakly dominant over its image under any function.  (Contributed
     by Stefan O'Rear, 14-Feb-2015.)  (Revised by Mario Carneiro,
     25-Jun-2015.) $)
  wdomimag $p |- ( ( Fun F /\ A e. V ) -> ( F " A ) ~<_* A ) $=
    ( wfun wcel cima cvv cwdom wbr funimaexg wdomima2g mpd3an3 ) BDACEBAFZGEMAH
    IBACJABCGKL $.

  ${
    $d f x y A $.  $d f x y B $.  $d f x y C $.
    $( Lemma for ~ unxpwdom .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    unxpwdom2 $p |- ( ( A X. A ) ~~ ( B u. C ) -> ( A ~<_* B \/ A ~<_ C ) ) $=
      ( vf vx cen wbr cwdom cdom cv c1st wceq wss wa cvv syl sylancr adantr cfv
      wcel vy cxp cun ensym wf1o wex bren cres ccom cima cdif ssdif0 cdm dmxpid
      wo c0 crn wfo f1ofo forn vex syl6eqelr dmexg syl5eqelr imassrn wf f1stres
      rnex f1of fco frn syl5ss ssexd simpr ssdomg sylc domwdom wfun ssun1 f1odm
      ffun dmex ssexg wdomima2g syl3anc wdomtr syl2anc orcd ex syl5bir wne ccnv
      n0 csn ssun2 wb wfn f1ofn elpreima wn wi elun df-or bitri eldifn ad2antlr
      ad2antrr simprr sseldi fvco3 eldifi adantl snssd xpss1 simprl fvres xp1st
      sseldd eqeltrd elsni eqtrd ffn a1i eqeltrrd expr mtod imim1d syl5bi imp3a
      fnfvima sylbid ssrdv f1ocnv f1of1 snex xpexg f1imaen2g syl22anc xpsnen2g
      wf1 entr domen1 mpbid olcd exlimdv pm2.61dne exlimiv sylbi ) AAUBZBCUCZFG
      UUJUUIFGZABHGZACIGZUOZUUIUUJUDUUKUUJUUIDJZUEZDUFUUNUUJUUIDUGUUPUUNDUUPUUN
      AKUUIUHZUUOUIZBUJZUKZUPUUTUPLAUUSMZUUPUUNAUUSULUUPUVAUUNUUPUVANZUULUUMUVB
      AUUSHGZUUSBHGZUULUVBAUUSIGZUVCUVBUUSOTZUVAUVEUUPUVFUVAUUPUUSAOUUPAUUIUMZO
      AUNUUPUUIOTUVGOTUUPUUIUUOUQZOUUPUUJUUIUUOURUVHUUILUUJUUIUUOUSUUJUUIUUOUTP
      UUODVAZVHVBUUIOVCPVDZUUPUUSUURUQZAUURBVEUUPUUJAUURVFZUVKAMUUPUUIAUUQVFUUJ
      UUIUUOVFZUVLAAVGUUJUUIUUOVIZUUJUUIAUUQUUOVJQZUUJAUURVKPVLVMZRUUPUVAVNAUUS
      OVOVPAUUSVQPUUPUVDUVAUUPUURVRZBOTZUVFUVDUUPUVLUVQUVOUUJAUURWAPUUPBUUJMZUU
      JOTZUVRBCVSZUUPUUJUUOUMOUUJUUIUUOVTUUOUVIWBVBZBUUJOWCQUVPBUUROOWDWERAUUSB
      WFWGWHWIWJUUTUPWKEJZUUTTZEUFUUPUUNEUUTWMUUPUWDUUNEUUPUWDUUNUUPUWDNZUUMUUL
      UWEUUOWLZUWCWNZAUBZUJZCIGZUUMUWECOTZUWICMUWJUUPUWKUWDUUPCUUJMUVTUWKCBWOUW
      BCUUJOWCQRUWEUAUWICUWEUAJZUWITZUWLUUJTZUWLUUOSZUWHTZNZUWLCTZUUPUWMUWQWPZU
      WDUUPUUOUUJWQUWSUUJUUIUUOWRUUJUWLUWHUUOWSPRUWEUWNUWPUWRUWNUWLBTZWTZUWRXAZ
      UWEUWPUWRXAUWNUWTUWRUOUXBUWLBCXBUWTUWRXCXDUWEUWPUXAUWRUWEUWPUXAUWEUWPNUWT
      UWCUUSTZUWDUXCWTUUPUWPUWCAUUSXEXFUWEUWPUWTUXCUWEUWPUWTNZNZUWLUURSZUWCUUSU
      XEUXFUWOUUQSZUWCUXEUVMUWNUXFUXGLUUPUVMUWDUXDUVNXGUXEBUUJUWLUWAUWEUWPUWTXH
      ZXIUUJUUIUWLUUQUUOXJWGUXEUXGUWGTUXGUWCLUXEUXGUWOKSZUWGUXEUWOUUITUXGUXILUX
      EUWHUUIUWOUWEUWHUUIMZUXDUWEUWGAMUXJUWEUWCAUWDUWCATUUPUWCAUUSXKXLXMUWGAAXN
      PZRUWEUWPUWTXOZXRUWOUUIKXPPUXEUWPUXIUWGTUXLUWOUWGAXQPXSUXGUWCXTPYAUXEUURU
      UJWQZUVSUWTUXFUUSTUUPUXMUWDUXDUUPUVLUXMUVOUUJAUURYBPXGUVSUXEUWAYCUXHUUJBU
      URUWLYJWEYDYEYFWIYGYHYIYKYLUWICOVOVPUWEUWIAFGZUWJUUMWPUWEUWIUWHFGZUWHAFGZ
      UXNUWEUUIUUJUWFYTZUVTUXJUWHOTZUXOUUPUXQUWDUUPUUIUUJUWFUEUXQUUJUUIUUOYMUUI
      UUJUWFYNPRUUPUVTUWDUWBRUXKUWEUWGOTAOTZUXRUWCYOUUPUXSUWDUVJRZUWGAOOYPQUUIU
      UJUWHUWFOYQYRUWEUWCOTUXSUXPEVAUXTUWCAOOYSQUWIUWHAUUAWGUWIACUUBPUUCUUDWIUU
      EYHUUFUUGUUHP $.

    $( If a cross product is dominated by a union, then the base set is either
       weakly dominated by one factor of the union or dominated by the other.
       Extracted from Lemma 2.3 of [KanamoriPincus] p. 420.  (Contributed by
       Mario Carneiro, 15-May-2015.) $)
    unxpwdom $p |- ( ( A X. A ) ~<_ ( B u. C ) -> ( A ~<_* B \/ A ~<_ C ) ) $=
      ( vx cun cdom wbr cen wss wa cwdom wo cvv wcel syl wi ssexg sylancr inss2
      cin cxp cv wex reldom brrelex2i domeng ibi simprl indi simprr df-ss sylib
      wb wceq syl5eqr breqtrrd unxpwdom2 ssun1 adantr ssdomg ee10 wdomtr expcom
      domwdom ssun2 domtr orim12d mpd exlimddv ) AAUAZBCEZFGZVJDUBZHGZVMVKIZJZA
      BKGZACFGZLZDVLVPDUCZVLVKMNZVLVTUMVJVKFUDUEZDVJVKMUFOUGVLVPJZAVMBTZKGZAVMC
      TZFGZLZVSWCVJWDWFEZHGWHWCVJVMWIHVLVNVOUHWCWIVMVKTZVMVMBCUIWCVOWJVMUNVLVNV
      OUJVMVKUKULUOUPAWDWFUQOWCWEVQWGVRWCWDBKGZWEVQPWCWDBFGZWKWCBMNZWDBIWLWCBVK
      IWAWMBCURVLWAVPWBUSZBVKMQRVMBSWDBMUTVAWDBVDOWEWKVQAWDBVBVCOWCWFCFGZWGVRPW
      CCMNZWFCIWOWCCVKIWAWPCBVEWNCVKMQRVMCSWFCMUTVAWGWOVRAWFCVFVCOVGVHVI $.
  $}

  ${
    $d r y V $.  $d f r s t w x y z X $.
    $( The Hartogs function is weakly dominated by ` ~P ( X X. X ) ` .  This
       follows from a more precise analysis of the bound used in ~ hartogs to
       prove that ` ( har `` X ) ` is a set.  (Contributed by Mario Carneiro,
       15-May-2015.) $)
    harwdom $p |- ( X e. V -> ( har ` X ) ~<_* ~P ( X X. X ) ) $=
      ( vr vy vx vz vw vt vs vf wcel cfv cv cdm wss wa wceq cwdom wbr cvv copab
      char cid cres cxp w3a cdif wwe coi cpw wfo wfun crn cdom con0 crab wi cep
      wrex hartogslem1 simp2i simp1i xpexg anidms pwexg syl ssexg sylancr funex
      eqid wfn funfn mpbi a1i simp3i harval eqtr4d df-fo sylanbrc fowdom ssdomg
      syl2anc ee10 domwdom wdomtr ) BAKZBUBLZCMZNZBOUCWIUDWHOWHWIWIUEOUFWIWHUCU
      GZUHPDMZWIWJUINQPCDUAZNZRSZWMBBUEZUJZRSZWGWPRSWFWLTKZWMWGWLUKZWNWFWLULZWM
      TKZWRWMWPOZWTWFWLUMZEMBUNSEUOUPZQUQZEDFGHBIMGMZJMZLQHMFMZXGLQPXFXHURSPFWK
      USGWKUSIHUAZJWLAICWLVJXIVJUTZVAZWFXBWPTKZXAXBWTXEXJVBZWFWOTKZXLWFXNBBAAVC
      VDWOTVEVFZWMWPTVGVHTWLVIVHWFWLWMVKZXCWGQWSXPWFWTXPXKWLVLVMVNWFXCXDWGXBWTX
      EXJVOEABVPVQWMWGWLVRVSWLTWGWMVTWBWFWMWPUNSZWQWFXLXBXQXOXMWMWPTWAWCWMWPWDV
      FWGWMWPWEWB $.
  $}

  ${
    $d f g k x y z A $.  $d f g k y z B $.  $d f z V $.  $d f z W $.
    $( Describe an onto function from the indexed cartesian product to the
       indexed union.  Together with ~ ixpssmapg this shows that
       ` U_ x e. A B ` and ` X_ x e. A B ` have closely linked cardinalities.
       (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    ixpiunwdom $p |- ( ( A e. V /\ U_ x e. A B e. W /\ X_ x e. A B =/= (/) ) ->
        U_ x e. A B ~<_* ( X_ x e. A B X. A ) ) $=
      ( vf vy vz vg vk wcel cv cfv cvv wral wfn syl weq sylib wceq ciun cixp c0
      wne w3a cmpt2 cxp wfo cwdom wbr wf vex elixp simprbi ssiun2 sseld ralimia
      nfv nfiu1 nfel2 fveq2 eleq1d cbvral adantl ralrimiva eqid cmap ixpssmap2g
      fmpt2 co wss 3ad2ant2 ovex ssex simp1 xpexg syl2anc simp2 syl3anc crn ffn
      fex2 dffn4 wb wrex cab wi wal wex eliun nfixp1 nfrex cif cmpt csb simplrr
      n0 wa iftrue csbeq1a equcoms eqcomd eleq12d syl5ibrcom wn adantr r19.21bi
      nfcsb1v iffalse pm2.61d ixpfn fndm dmex syl6eqelr mptelixpg mpbird cbvixp
      cdm nfcv syl6eleqr simprl fvmpt fveq1 eqeq2d rspc2ev exp32 rexlimd syl5bi
      ad2antrl exlimiv sylbi 3ad2ant3 alrimiv sylibr rnmpt2 syl6sseqr frn eqssd
      ssab foeq3 fowdom ) BDKZABCUAZEKZABCUBZUCUDZUEZFGUUEBGLZFLZMZUFZNKZUUEBUG
      ZUUCUUKUHZUUCUUMUIUJUUGUUMUUCUUKUKZUUMNKZUUDUULUUGUUJUUCKZGBOZFUUEOUUOUUG
      UURFUUEUUIUUEKZUURUUGUUSALZUUIMZUUCKZABOZUURUUSUVACKZABOZUVCUUSUUIBPUVEAB
      CUUIFULUMUNUVDUVBABUUTBKZCUUCUVAABCUOUPUQQUVBUUQAGBUVBGURAUUJUUCABCUSUTAG
      RUVAUUJUUCUUTUUHUUIVAVBVCSVDVEFGUUEBUUJUUCUUKUUKVFZVISZUUGUUENKZUUBUUPUUG
      UUEUUCBVGVJZVKZUVIUUDUUBUVKUUFABCEVHVLUUEUVJUUCBVGVMVNQUUBUUDUUFVOUUEBNDV
      PVQUUBUUDUUFVRUUMUUCUUKNEWBVSUUGUUNUUMUUKVTZUUKUHZUUGUUKUUMPZUVMUUGUUOUVN
      UVHUUMUUCUUKWAQUUMUUKWCSUUGUUCUVLTUUNUVMWDUUGUUCUVLUUGUUCHLZUUJTZGBWEZFUU
      EWEZHWFZUVLUUGUVOUUCKZUVRWGZHWHUUCUVSVKUUGUWAHUUFUUBUWAUUDUUFILZUUEKZIWIU
      WAIUUEWQUWCUWAIUVTUVOCKZABWEUWCUVRAUVOBCWJUWCUWDUVRABAUWBUUEABCWKZUTUVQAF
      UUEUWEUVQAURWLUWCUVFUWDUVRUWCUVFUWDWRZWRZJBJARZUVOJLZUWBMZWMZWNZUUEKUVFUV
      OUUTUWLMZTZUVRUWGUWLJBAUWICWOZUBZUUEUWGUWLUWPKZUWKUWOKZJBOZUWGUWRJBUWGUWI
      BKZWRZUWHUWRUXAUWRUWHUWDUWCUVFUWDUWTWPUWHUWKUVOUWOCUWHUVOUWJWSZUWHCUWOCUW
      OTAJAUWICWTZXAXBXCXDUXAUWRUWHXEZUWJUWOKZUWGUXEJBUWGUUTUWBMZCKZABOZUXEJBOU
      WCUXHUWFUWCUWBBPZUXHABCUWBIULZUMUNXFUXGUXEAJBUXGJURAUWJUWOAUWICXHZUTAJRUX
      FUWJCUWOUUTUWIUWBVAUXCXCVCSXGUXDUWKUWJUWOUWHUVOUWJXIVBXDXJVEUWGBNKUWQUWSW
      DUWGBUWBXRZNUWGUXIUXLBTUWCUXIUWFABCUWBXKXFBUWBXLQUWBUXJXMXNJBUWKUWONXOQXP
      AJBCUWOJCXSUXKUXCXQXTUWCUVFUWDYAUWGUWMUVOUVFUWMUVOTUWCUWDJUUTUWKUVOBUWLUX
      BUWLVFHULYBYIXBUVPUWNUVOUUHUWLMZTFGUWLUUTUUEBUUIUWLTUUJUXMUVOUUHUUIUWLYCY
      DGARUXMUWMUVOUUHUUTUWLVAYDYEVSYFYGYHYJYKYLYMUVRHUUCYSYNFGHUUEBUUJUUKUVGYO
      YPUUGUUOUVLUUCVKUVHUUMUUCUUKYQQYRUUCUVLUUMUUKYTQXPUUKNUUCUUMUUAVQ $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Regularity
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Introduce the Axiom of Regularity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Axiom of Regularity.  An axiom of Zermelo-Fraenkel set theory.  Also
       called the Axiom of Foundation.  A rather non-intuitive axiom that
       denies more than it asserts, it states (in the form of ~ zfreg ) that
       every non-empty set contains a set disjoint from itself.  One
       consequence is that it denies the existence of a set containing itself
       ( ~ elirrv ).  A stronger version that works for proper classes is
       proved as ~ zfregs .  (Contributed by NM, 14-Aug-1993.) $)
    ax-reg $a |- ( E. y y e. x ->
                 E. y ( y e. x /\ A. z ( z e. y -> -. z e. x ) ) ) $.

    $( Axiom of Regularity expressed more compactly.  (Contributed by NM,
       14-Aug-2003.) $)
    axreg2 $p |- ( x e. y ->
                 E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) $=
      ( wel wn wi wal wa wex ax-reg 19.23bi ) ABDZLCADCBDEFCGHAIABACJK $.
  $}

  ${
    $d x y A z $.
    zfregcl.1 $e |- A e. _V $.
    $( The Axiom of Regularity with class variables.  (Contributed by NM,
       5-Aug-1994.) $)
    zfregcl $p |- ( E. x x e. A -> E. x e. A A. y e. x -. y e. A ) $=
      ( vz wel wex wn cv wral wrex wi wcel wceq eleq2 exbidv ralbidv rexeqbi1dv
      notbid imbi12d nfre1 wal axreg2 df-ral rexbii df-rex bitr2i sylib exlimi
      wa vtocl ) AEFZAGZBEFZHZBAIZJZAEIZKZLUPCMZAGZBIZCMZHZBUPJZACKZLECDURCNZUM
      VAUSVFVGULUTAURCUPOPUQVEAURCVGUOVDBUPVGUNVCURCVBOSQRTULUSAUQAURUAULULBAFU
      OLBUBZUJAGZUSAEBUCUSVHAURKVIUQVHAURUOBUPUDUEVHAURUFUGUHUIUK $.
  $}

  ${
    $d x A y $.
    zfreg.1 $e |- A e. _V $.
    $( The Axiom of Regularity using abbreviations.  Axiom 6 of [TakeutiZaring]
       p. 21.  This is called the "weak form."  There is also a "strong form,"
       not requiring that ` A ` be a set, that can be proved with more
       difficulty (see ~ zfregs ).  (Contributed by NM, 26-Nov-1995.) $)
    zfreg $p |- ( A =/= (/) -> E. x e. A ( x i^i A ) = (/) ) $=
      ( vy cv wcel wex wn wral wrex c0 wne cin wceq zfregcl disj rexbii 3imtr4i
      n0 ) AEZBFAGDEBFHDTIZABJBKLTBMKNZABJADBCOABSUBUAABDTBPQR $.
  $}

  ${
    $d x A y $.
    zfreg2.1 $e |- A e. _V $.
    $( The Axiom of Regularity using abbreviations.  This form with the
       intersection arguments commuted (compared to ~ zfreg ) is formally more
       convenient for us in some cases.  Axiom Reg of [BellMachover] p. 480.
       (Contributed by NM, 17-Sep-2003.) $)
    zfreg2 $p |- ( A =/= (/) -> E. x e. A ( A i^i x ) = (/) ) $=
      ( vy cv wcel wex wn wral wrex c0 wne wceq zfregcl n0 disjr rexbii 3imtr4i
      cin ) AEZBFAGDEBFHDTIZABJBKLBTSKMZABJADBCNABOUBUAABDBTPQR $.
  $}

  ${
    $d x y z $.
    $( The membership relation is irreflexive: no set is a member of itself.
       Theorem 105 of [Suppes] p. 54.  (This is trivial to prove from ~ zfregfr
       and ~ efrirr , but this proof is direct from the Axiom of Regularity.)
       (Contributed by NM, 19-Aug-1993.) $)
    elirrv $p |- -. x e. x $=
      ( vz vy cv wcel csn wn wral wrex wex eleq1 vex snid spei snex zfregcl weq
      ax-mp elsn wi ax-14 equcoms com12 syl5bi notbid mt2i nsyli con2d ralrimiv
      rspccv ralnex sylib mt2 ) ADZUNEZBDZUNFZEZGZBCDZHZCUQIZUTUQEZCJVBVCUNUQEZ
      CAUTUNUQKUNALMZNCBUQUNOPRUOVAGZCUQHVBGUOVFCUQUOVAVCUOVCUNUTEZVAVCCAQZUOVG
      CUNSVHUOVGUOVGTACACAUAUBUCUDVAVGVDVEUSVDGBUNUTBAQURVDUPUNUQKUEUJUFUGUHUIV
      ACUQUKULUM $.
  $}

  ${
    $d A x $.
    $( No class is a member of itself.  Exercise 6 of [TakeutiZaring] p. 22.
       (Contributed by NM, 7-Aug-1994.)  (Proof shortened by Andrew Salmon,
       9-Jul-2011.) $)
    elirr $p |- -. A e. A $=
      ( vx wcel wn wi cv wceq id eleq12d notbid elirrv vtoclg pm2.01 ax-mp ) AA
      CZODZEPBFZQCZDPBAAQAGZROSQAQASHZTIJBKLOMN $.

    $( A class is equal to its successor iff it is a proper class (assuming the
       Axiom of Regularity).  (Contributed by NM, 9-Jul-2004.) $)
    sucprcreg $p |- ( -. A e. _V <-> suc A = A ) $=
      ( vx cvv wcel wn csuc sucprc cv wi wal elirr nfv eleq1 ceqsalg mtbiri csn
      wceq elsn wss syl5bir wo olc cun elun wb df-suc eqeq1i sseq1 sylbi mpbiri
      ssid sseld syl5 alrimiv nsyl3 impbii ) ACDZEAFZAQZAGUQBHZAQZUTADZIZBJZUSU
      QVDAADZAKVBVEBACVEBLUTAAMNOUSVCBVAUTAPZDZUSVBBARVGVBVGUAZUSVBVGVBUBVHUTAV
      FUCZDUSVBUTAVFUDUSVIAUTUSVIASZAASZAUKUSVIAQVJVKUEURVIAAUFUGVIAAUHUIUJULTU
      MTUNUOUP $.
  $}

  $( The Russell class is equal to the universe ` _V ` .  Exercise 5 of
     [TakeutiZaring] p. 22.  (Contributed by Alan Sare, 4-Oct-2008.) $)
  ruv $p |- { x | x e/ x } = _V $=
    ( cvv weq cab cv wnel df-v equid elirrv nelir 2th abbii eqtr2i ) BAACZADAEZ
    OFZADAGNPANPAHOOAIJKLM $.

  $( Alternate proof of Russell's Paradox ~ ru , simplified using (indirectly)
     the Axiom of Regularity ~ ax-reg .  (Contributed by Alan Sare,
     4-Oct-2008.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ruALT $p |- { x | x e/ x } e/ _V $=
    ( cv wnel cab cvv wcel wn vprc df-nel mpbir wceq wb ruv neleq1 ax-mp ) ABZP
    CADZECZEECZSEEFGHEEIJQEKRSLAMQEENOJ $.

  ${
    $d x y A $.
    $( The epsilon relation is well-founded on any class.  (Contributed by NM,
       26-Nov-1995.) $)
    zfregfr $p |- _E Fr A $=
      ( vx vy cep wfr cv wss c0 wne wa wceq wrex wi dfepfr zfreg2 adantl mpgbir
      cin vex ) ADEBFZAGZTHIZJTCFRHKCTLZMBBCANUBUCUACTBSOPQ $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( No class has 2-cycle membership loops.  Theorem 7X(b) of [Enderton]
       p. 206.  (Contributed by NM, 16-Oct-1996.)  (Revised by Mario Carneiro,
       25-Jun-2015.) $)
    en2lp $p |- -. ( A e. B /\ B e. A ) $=
      ( cvv wcel wa wn cep wfr zfregfr efrn2lp mpan elex anim12i con3i pm2.61i
      ) ACDZBCDZEZABDZBADZEZFZCGHRUBCICABJKUARSPTQABLBALMNO $.

  $}

  ${
    preleq.1 $e |- A e. _V $.
    preleq.2 $e |- B e. _V $.
    preleq.3 $e |- C e. _V $.
    preleq.4 $e |- D e. _V $.
    $( Equality of two unordered pairs when one member of each pair contains
       the other member.  (Contributed by NM, 16-Oct-1996.) $)
    preleq $p |- ( ( ( A e. B /\ C e. D ) /\ { A , B } = { C , D } ) ->
                   ( A = C /\ B = D ) ) $=
      ( cpr wceq wcel wa wn wo preq12b biimpi ord en2lp eleq12 anbi1d mtbiri
      syl6 con4d impcom ) ABICDIJZABKZCDKZLZACJBDJLZUEUIUHUEUIMADJBCJLZUHMUEUIU
      JUEUIUJNABCDEFGHOPQUJUHDCKZUGLDCRUJUFUKUGADBCSTUAUBUCUD $.

    $( Theorem for alternate representation of ordered pairs, requiring the
       Axiom of Regularity ~ ax-reg (via the ~ preleq step).  See ~ df-op for a
       description of other ordered pair representations.  Exercise 34 of
       [Enderton] p. 207.  (Contributed by NM, 16-Oct-1996.) $)
    opthreg $p |- ( { A , { A , B } } = { C , { C , D } } <->
                   ( A = C /\ B = D ) ) $=
      ( cpr wceq wa wcel prid1 prex preleq mpanl12 preq1 eqeq1d preqr2 syl6bi
      imdistani syl adantr preq12 preq2d eqtrd impbii ) AABIZIZCCDIZIZJZACJZBDJ
      ZKZULUMUHUJJZKZUOAUHLCUJLULUQABEMCDGMAUHCUJEABNGCDNOPUMUPUNUMUPCBIZUJJUNU
      MUHURUJACBQRBDCFHSTUAUBUOUICUHIZUKUMUIUSJUNACUHQUCUOUHUJCABCDUDUEUFUG $.
  $}

  $( The successor operation behaves like a one-to-one function (assuming the
     Axiom of Regularity).  Exercise 35 of [Enderton] p. 208 and its converse.
     (Contributed by NM, 25-Oct-2003.) $)
  suc11reg $p |- ( suc A = suc B <-> A = B ) $=
    ( csuc wceq cvv wcel wi wa wn wo sucidg eleq2 elsucg sylibd imp com23 eqcom
    ord ex sucexb en2lp mpbi syl5ibcom syl5ibrcom syl6ib jaao mpi notbii nelneq
    ianor syl2anb pm2.21d ancoms syl5bi sucprc eqeqan12d biimpd 4cases impbii
    suceq ) ACZBCZDZABDZAEFZBEFZVCVDGZVEVFHABFZIZBAFZIZJZVGVHVJHIVLABUAVHVJUJUB
    VEVIVGVFVKVEVCVIVDVEVCVIVDGVEVCHVHVDVEVCVHVDJZVEVCAVBFZVMVEAVAFVCVNAEKVAVBA
    LUCABEMNORSPVFVCVKVDVFVCVKVDGVFVCHZVKBADZVDVOVJVPVFVCVJVPJZVFVCBVAFZVQVFVRV
    CBVBFBEKVAVBBLUDBAEMNORBAQUESPUFUGVEVFIZHVCVDVEVAEFZVBEFZIVCIVSATZVFWABTZUH
    VAVBEUIUKULVCVBVADZVEIZVFHZVDVAVBQWFWDVDVFWEWDIZVFWAVTIWGWEWCVEVTWBUHVBVAEU
    IUKUMULUNWEVSHVCVDWEVSVAAVBBAUOBUOUPUQURABUTUS $.

  ${
    $d x y A $.
    $( Assuming ~ ax-reg , an ordinal is a transitive class on which inclusion
       satisfies trichotomy.  (Contributed by Scott Fenton, 27-Oct-2010.) $)
    dford2 $p |- ( Ord A <-> ( Tr A /\
                    A. x e. A A. y e. A ( x e. y \/ x = y \/ y e. x ) ) ) $=
      ( word wtr cep wwe wa wel weq w3o wral df-ord wbr wfr zfregfr dfwe2 bitri
      cv epel mpbiran biid 3orbi123i 2ralbii anbi2i ) CDCEZCFGZHUFABIZABJZBAIZK
      ZBCLACLZHCMUGULUFUGASZBSZFNZUIUNUMFNZKZBCLACLZULUGCFOURCPABCFQUAUQUKABCCU
      OUHUIUIUPUJABTUIUBBATUCUDRUER $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Axiom of Infinity equivalents
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( First we prove the equivalence of our version of Infinity with
     some others. $)

  ${
    $d x y z w v u f $.
    inf0.1 $e |- om e. _V $.
    $( Our Axiom of Infinity derived from existence of omega.  The proof shows
       that the especially contrived
       class " ` ran ( rec ( ( v e. _V |-> suc v ) , x ) |`` om ) ` " exists,
       is a subset of its union, and contains a given set ` x ` (and thus is
       non-empty).  Thus, it provides an example demonstrating that a set ` y `
       exists with the necessary properties demanded by ~ ax-inf .
       (Contributed by NM, 15-Oct-1996.) $)
    inf0 $p |- E. y ( x e. y /\ A. z ( z e. y -> E. w ( z e. w /\ w e. y )
                   ) ) $=
      ( vv vf cv cvv csuc com wcel wel wa wex wi c0 wceq ax-mp eleq2 crn frfnom
      cmpt crdg cres wal cfv vex fr0g wfn peano1 fnfvelrn eqeltrri wrex fvelrnb
      mp2an fvex sucid sucex eqid suceq frsucmpt2 mpan2 syl5eleqr eleq1 peano2b
      syl5ib mpan sylbi a1i jcad anbi12d spcev syl6com rexlimiv ax-gen cdm wfun
      wb fndm eqeltri fnfun funrnex mp2 anbi2d exbidv imbi12d albidv ) AHZFIFHZ
      JZUCZWIUDKUEZUAZLZCHZWNLZCDMZDHZWNLZNZDOZPZCUFZABMZCBMZWRDBMZNZDOZPZCUFZN
      ZBOQWMUGZWIWNWIILXMWIRAUHWIIWLUISWMKUJZQKLXMWNLWIWLUBZUKKQWMULUPUMXCCWQGH
      ZWMUGZWPRZGKUNZXBXNWQXSVSXOGKWPWMUOSXRXBGKXRXPKLZWPXPJZWMUGZLZYBWNLZNZXBX
      RXTYCYDXTXQYBLXRYCXTXQXQJZYBXQXPWMUQZURXTYFILYBYFRXQYGUSFCWIXPWKYFWPJWMIW
      MUTWPWJVAWPXQVAVBVCVDXQWPYBVEVGXTYDPXRXTYAKLZYDXPVFXNYHYDXOKYAWMULVHVIVJV
      KXAYEDYBYAWMUQWSYBRWRYCWTYDWSYBWPTWSYBWNVEVLVMVNVOVIVPXLWOXDNBWNWMVQZILWM
      VRZWNILYIKIXNYIKRXOKWMVTSEWAXNYJXOKWMWBSIWMWCWDBHZWNRZXEWOXKXDYKWNWITYLXJ
      XCCYLXFWQXIXBYKWNWPTYLXHXADYLXGWTWRYKWNWSTWEWFWGWHVLVMUP $.
  $}

  ${
    inf1.1 $e |- E. x ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) $.
    $( Variation of Axiom of Infinity (using ~ zfinf as a hypothesis).  Axiom
       of Infinity in [FreydScedrov] p. 283.  (Contributed by NM,
       14-Oct-1996.)  (Revised by David Abernethy, 1-Oct-2013.) $)
    inf1 $p |- E. x ( x =/= (/) /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) $=
      ( wel wa wex wi wal cv c0 wne ne0i anim1i eximii ) BAEZPBCECAEFCGHBIZFAJZ
      KLZQFADPSQRBJMNO $.

    $d x y z $.
    $( Variation of Axiom of Infinity.  There exists a non-empty set that is a
       subset of its union (using ~ zfinf as a hypothesis).  Abbreviated
       version of the Axiom of Infinity in [FreydScedrov] p. 283.  (Contributed
       by NM, 28-Oct-1996.) $)
    inf2 $p |- E. x ( x =/= (/) /\ x C_ U. x ) $=
      ( cv c0 wne cuni wss wa wex wel wi wal inf1 wcel dfss2 eluni imbi2i albii
      bitri anbi2i exbii mpbir ) AEZFGZUEUEHZIZJZAKUFBALZBCLCALJCKZMZBNZJZAKABC
      DOUIUNAUHUMUFUHUJBEZUGPZMZBNUMBUEUGQUQULBUPUKUJCUOUERSTUAUBUCUD $.
  $}

  ${
    $d x y z w v u f g $.  $d v u f g G $.  $d v u f g F $.  $d v u f g A $.
    $d v u f g B $.
    inf3lem.1 $e |- G = ( y e. _V |-> { w e. x | ( w i^i x ) C_ y } ) $.
    inf3lem.2 $e |- F = ( rec ( G , (/) ) |` om ) $.
    inf3lem.3 $e |- A e. _V $.
    inf3lem.4 $e |- B e. _V $.
    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 28-Oct-1996.) $)
    inf3lema $p |- ( A e. ( G ` B ) <-> ( A e. x /\ ( A i^i x ) C_ B ) ) $=
      ( vf vv cv cin wss wceq ineq1 cvv crab cfv sseq1d wcel sseq2 rabbidv cmpt
      cbvrabv syl6eq cbvmptv eqtri vex rabex fvmpt ax-mp elrab2 ) LNZANZOZEPZDU
      QOZEPLDUQEGUAZUPDQURUTEUPDUQRUBESUCVAUSLUQTZQKMEURMNZPZLUQTZVBSGVCEQVDUSL
      UQVCEURUDUEGBSCNZUQOZBNZPZCUQTZUFMSVEUFHBMSVJVEVHVCQZVJVGVCPZCUQTVEVKVIVL
      CUQVHVCVGUDUEVLVDCLUQVFUPQVGURVCVFUPUQRUBUGUHUIUJUSLUQAUKULUMUNUO $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 28-Oct-1996.) $)
    inf3lemb $p |- ( F ` (/) ) = (/) $=
      ( c0 cfv crdg com cres fveq1i cvv wcel wceq 0ex fr0g ax-mp eqtri ) LFMLGL
      NOPZMZLLFUEIQLRSUFLTUALRGUBUCUD $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 28-Oct-1996.) $)
    inf3lemc $p |- ( A e. om -> ( F ` suc A ) = ( G ` ( F ` A ) ) ) $=
      ( com wcel csuc c0 crdg cres cfv frsuc fveq1i fveq2i 3eqtr4g ) DLMDNZGOPL
      QZRDUDRZGRUCFRDFRZGRODGSUCFUDITUFUEGDFUDITUAUB $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 28-Oct-1996.) $)
    inf3lemd $p |- ( A e. om -> ( F ` A ) C_ x ) $=
      ( vv vu com wcel cfv cv wss c0 wceq wi fveq2 inf3lemb syl6eq 0ss syl6eqss
      a1d wne wa csuc wrex vex inf3lemc eleq2d cin fvex inf3lema simplbi syl6bi
      nnsuc ssrdv sseq1d syl5ibrcom rexlimiv syl expcom pm2.61ine ) DNOZDFPZAQZ
      RZUADSDSTZVKVHVLVISVJVLVISFPSDSFUBABCDEFGHIJKUCUDVJUEUFUGVHDSUHZVKVHVMUID
      LQZUJZTZLNUKVKLDUTVPVKLNVNNOZVKVPVOFPZVJRVQMVRVJVQMQZVROVSVNFPZGPZOZVSVJO
      ZVQVRWAVSABCVNEFGHILULKUMUNWBWCVSVJUOVTRABCVSVTFGHIMULVNFUPUQURUSVAVPVIVR
      VJDVOFUBVBVCVDVEVFVG $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 28-Oct-1996.) $)
    inf3lem1 $p |- ( A e. om -> ( F ` A ) C_ ( F ` suc A ) ) $=
      ( vv cfv csuc wss c0 wceq fveq2 suceq wcel vu fveq2d sseq12d inf3lemb 0ss
      cv eqsstri com wa wi cin sstr2 com12 anim2d inf3lemc eleq2d fvex inf3lema
      vex syl6bb peano2b sucex sylbi imbi12d syl5ibr imp ssrdv ex finds ) LUFZF
      MZVJNZFMZOPFMZPNZFMZOUAUFZFMZVQNZFMZOZVTVSNZFMZOZDFMZDNZFMZOLUADVJPQZVKVN
      VMVPVJPFRWHVLVOFVJPSUBUCVJVQQZVKVRVMVTVJVQFRWIVLVSFVJVQSUBUCVJVSQZVKVTVMW
      CVJVSFRWJVLWBFVJVSSUBUCVJDQZVKWEVMWGVJDFRWKVLWFFVJDSUBUCVNPVPABCDDFGHIJJU
      DVPUEUGVQUHTZWAWDWLWAUILVTWCWLWAVJVTTZVJWCTZUJZWAWOWLVJAUFZTZVJWPUKZVROZU
      IZWQWRVTOZUIZUJWAWSXAWQWSWAXAWRVRVTULUMUNWLWMWTWNXBWLWMVJVRGMZTWTWLVTXCVJ
      ABCVQDFGHIUAUSZJUOUPABCVJVRFGHILUSZVQFUQURUTWLWNVJVTGMZTXBWLWCXFVJWLVSUHT
      WCXFQVQVAABCVSDFGHIVQXDVBJUOVCUPABCVJVTFGHIXEVSFUQURUTVDVEVFVGVHVI $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 28-Oct-1996.) $)
    inf3lem2 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( A e. om -> ( F ` A ) =/= x ) ) $=
      ( vv vf wcel c0 wne wa cfv wi wceq vu com cv cuni wss fveq2 neeq1d imbi2d
      csuc inf3lemb eqeq1i eqcom biimpi necon3i adantr vex inf3lemd wn wex wpss
      bitri df-pss pssnel sylbir ssel eluni syl6ib biimparc inf3lemc eleq2d cin
      eleq2 elin fvex simprbi sseld syl5bir syl6bi syl5 com23 exp5c com34 imp3a
      inf3lema exlimdv sylan9r pm2.43d id necon3bd sylani exp4b pm2.43a adantld
      syl6 a2d finds com12 ) DUBNAUCZOPZWRWRUDZUEZQZDFRZWRPZXBLUCZFRZWRPZSXBOFR
      ZWRPZSXBUAUCZFRZWRPZSXBXJUIZFRZWRPZSXBXDSLUADXEOTZXGXIXBXPXFXHWRXEOFUFUGU
      HXEXJTZXGXLXBXQXFXKWRXEXJFUFUGUHXEXMTZXGXOXBXRXFXNWRXEXMFUFUGUHXEDTZXGXDX
      BXSXFXCWRXEDFUFUGUHWSXIXAXHWRWROXHWRTZWROTZXTOWRTYAXHOWRABCDEFGHIJKUJUKOW
      RULVAUMUNUOXJUBNZXBXLXOYBXAXLXOSZWSXAYBYCYBXAYBXLXOYBYBXAQZXKWRUEZXLXOABC
      XJEFGHIUAUPZKUQYEXLQZXEWRNZXEXKNZURZQZLUSZYDXOYGXKWRUTYLXKWRVBLXKWRVCVDYD
      YKXOLYDYHYJXOYDYHXNWRTZYISZYJXOSYDYHYNXAYHXEMUCZNZYOWRNZQZMUSZYBYHYNSZXAY
      HXEWTNYSWRWTXEVEMXEWRVFVGYBYRYTMYBYPYQYTYBYPYHYQYNYBYPYHYQYMYIYBYQYMQZYPY
      HQZYIUUAYOXNNZYBUUBYISZYMUUCYQXNWRYOVLVHYBUUCYOXKGRZNZUUDYBXNUUEYOABCXJEF
      GHIYFKVIVJUUBXEYOWRVKZNUUFYIXEYOWRVMUUFUUGXKXEUUFYQUUGXKUEABCYOXKFGHIMUPX
      JFVNWDVOVPVQVRVSVTWAWBWCWEWFWGYNYIXNWRYNWHWIWNWCWEVSWJWKWLWMWOWPWQ $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  In the proof, we invoke the Axiom of
       Regularity in the form of ~ zfreg .  (Contributed by NM,
       29-Oct-1996.) $)
    inf3lem3 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( A e. om -> ( F ` A ) =/= ( F ` suc A ) ) ) $=
      ( vv wcel cv c0 wne wss wa cfv com12 com cuni csuc cdif inf3lemd inf3lem2
      pssdifn0 ee12an cin wceq vex difss ssexi zfreg wn eldifi inssdif0 biimpri
      wrex anim12i inf3lema sylibr inf3lemc eleq2d syl5ibr wi eldifn adantr a1i
      fvex jcad eleq2 biimprd iman sylib necon2ai syl6 exp3a rexlimdv syl5 syld
      ) DUAMZANZOPWCWCUBQRZDFSZDUCFSZPZWBWDWCWEUDZOPZWGWBWEWCQWDWEWCPZWIABCDEFG
      HIJKUEWDWBWJABCDEFGHIJKUFTWEWCUGUHWILNZWHUIOUJZLWHUSWBWGLWHWHWCAUKWCWEULU
      MUNWBWLWGLWHWBWKWHMZWLWGWBWMWLRZWKWFMZWKWEMZUOZRZWGWBWNWOWQWNWOWBWKWEGSZM
      ZWNWKWCMZWKWCUIWEQZRWTWMXAWLXBWKWCWEUPXBWLWKWCWEUQURUTABCWKWEFGHILUKDFVJV
      AVBWBWFWSWKABCDEFGHIJKVCVDVEWNWQVFWBWMWQWLWKWCWEVGVHVIVKWRWEWFWEWFUJZWOWP
      VFWRUOXCWPWOWEWFWKVLVMWOWPVNVOVPVQVRVSVTWAT $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 29-Oct-1996.) $)
    inf3lem4 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( A e. om -> ( F ` A ) C. ( F ` suc A ) ) ) $=
      ( cv c0 wne cuni wss wa com wcel cfv csuc wpss inf3lem1 a1i inf3lem3 jcad
      wi df-pss syl6ibr ) ALZMNUJUJOPQZDRSZDFTZDUAFTZPZUMUNNZQUMUNUBUKULUOUPULU
      OUGUKABCDEFGHIJKUCUDABCDEFGHIJKUEUFUMUNUHUI $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 29-Oct-1996.) $)
    inf3lem5 $p |- ( ( x =/= (/) /\ x C_ U. x ) ->
                    ( ( A e. om /\ B e. A ) -> ( F ` B ) C. ( F ` A ) ) ) $=
      ( com wcel wa cfv wpss wi wceq fveq2 psseq2d vv vu cv wne cuni wss ancoms
      c0 elnn csuc word nnord ordsucss syl adantr peano2b imbi2d inf3lem4 com12
      sylbir vex psstr expcom syl6com a2d ad2antrr findsg sylan2b syld impancom
      ex mpd ) DLMZEDMZNZAUCZUHUDVPVPUEUFNZEFOZDFOZPZVOELMZVQVTQZVNVMWAEDUIUGVM
      WAVNWBVMWANVNEUJZDUFZWBVMVNWDQZWAVMDUKWEDULEDUMUNUOWAVMWCLMZWDWBQEUPZVMWF
      NWDWBVQVRUAUCZFOZPZQVQVRWCFOZPZQZVQVRUBUCZFOZPZQZVQVRWNUJZFOZPZQZWBUAUBDW
      CWHWCRZWJWLVQXBWIWKVRWHWCFSTUQWHWNRZWJWPVQXCWIWOVRWHWNFSTUQWHWRRZWJWTVQXD
      WIWSVRWHWRFSTUQWHDRZWJVTVQXEWIVSVRWHDFSTUQWFWAWMWGVQWAWLABCEEFGHIKKURUSUT
      WNLMZWQXAQWFWCWNUFXFVQWPWTVQXFWOWSPZWPWTQABCWNEFGHIUBVAKURWPXGWTVRWOWSVBV
      CVDVEVFVGVKVHVIVJVLUS $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  (Contributed by NM, 29-Oct-1996.) $)
    inf3lem6 $p |- ( ( x =/= (/) /\ x C_ U. x ) -> F : om -1-1-> ~P x ) $=
      ( vv vu cv c0 wss wa com wceq wcel wne cuni cpw wf cfv wi wral wo wn wpss
      wf1 vex inf3lem5 dfpss2 simprbi syl6 expdimp adantrl eqcom sylnib adantrr
      jaod con2d wb word nnord ordtri3 syl2an adantl sylibrd ralrimivva wfn crn
      crdg cres frfnom fneq1 mpbiri wrex fvelrnb inf3lemd fvex sylibr syl5ibcom
      elpw eleq1 rexlimiv syl6bi ssrdv ancli mp2b df-f mpbir jctil dff13 ) ANZO
      UAWPWPUBPQZRWPUCZFUDZLNZFUEZMNZFUEZSZWTXBSZUFZMRUGLRUGZQRWRFUKWQXGWSWQXFL
      MRRWQWTRTZXBRTZQZQZXDWTXBTZXBWTTZUHZUIZXEXKXNXDXKXLXDUIZXMWQXIXLXPUFXHWQX
      IXLXPWQXIXLQXAXCUJZXPABCXBWTFGHIMULZLULZUMXQXAXCPXPXAXCUNUOUPUQURWQXHXMXP
      UFXIWQXHXMXPWQXHXMQXCXAUJZXPABCWTXBFGHIXSXRUMXTXCXASZXDXTXCXAPYAUIXCXAUNU
      OXCXAUSUTUPUQVAVBVCXJXEXOVDZWQXHWTVEXBVEYBXIWTVFXBVFWTXBVGVHVIVJVKWSFRVLZ
      FVMZWRPZQZFGOVNRVOZSZYCYFIYHYCYGRVLOGVPRFYGVQVRYCYEYCMYDWRYCXBYDTXAXBSZLR
      VSXBWRTZLRXBFVTYIYJLRXHXAWRTZYIYJXHXAWPPYKABCWTEFGHIXSKWAXAWPWTFWBWEWCXAX
      BWRWFWDWGWHWIWJWKRWRFWLWMWNLMRWRFWOWC $.

    $( Lemma for our Axiom of Infinity => standard Axiom of Infinity.  See
       ~ inf3 for detailed description.  In the proof, we invoke the Axiom of
       Replacement in the form of ~ f1dmex .  (Contributed by NM,
       29-Oct-1996.)  (Proof shortened by Mario Carneiro, 19-Jan-2013.) $)
    inf3lem7 $p |- ( ( x =/= (/) /\ x C_ U. x ) -> om e. _V ) $=
      ( cv c0 wne cuni wss wa com cvv wcel cpw wf1 inf3lem6 pwex f1dmex sylancl
      vex ) ALZMNUHUHOPQRUHUAZFUBUISTRSTABCDEFGHIJKUCUHAUGUDRUISFUEUF $.
  $}

  ${
    $d x y z w $.
    inf3.1 $e |- E. x ( x =/= (/) /\ x C_ U. x ) $.
    $( Note: the special <HTML> tag is handled in mmwtex.c.  All comment text
       between <HTML> and </HTML> is passed as-is to the web page, except
       that ` (symbols) ` , ~ (label) , and [(reference)] markups are still
       interpreted. $)
    $( Our Axiom of Infinity ~ ax-inf implies the standard Axiom of Infinity.
       The hypothesis is a variant of our Axiom of Infinity provided by
       ~ inf2 , and the conclusion is the version of the Axiom of Infinity
       shown as Axiom 7 in [TakeutiZaring] p. 43.  (Other standard versions are
       proved later as ~ axinf2 and ~ zfinf2 .)  The main proof is provided by
       ~ inf3lema through ~ inf3lem7 , and this final piece eliminates the
       auxiliary hypothesis of ~ inf3lem7 .  This proof is due to
       Ian Sutherland, Richard Heck, and Norman Megill and was posted
       on Usenet as shown below.  Although the result is not new, the authors
       were unable to find a published proof.
       <HTML>
       <PRE>
       (As posted to sci.logic on 30-Oct-1996, with annotations added.)

       Theorem:  The statement "There exists a non-empty set that is a subset
       of its union" implies the Axiom of Infinity.

       Proof:  Let X be a nonempty set which is a subset of its union; the
       latter
       property is equivalent to saying that for any y in X, there exists a z
       in X
       such that y is in z.

       Define by finite recursion a function F:omega-->(power X) such that
       F_0 = 0  (See ~ inf3lemb .)
       F_n+1 = {y&lt;X | y^X subset F_n}  (See ~ inf3lemc .)
       Note: ^ means intersect, &lt; means \in ("element of").
       (Finite recursion as typically done requires the existence of omega;
       to avoid this we can just use transfinite recursion restricted to omega.
       F is a class-term that is not necessarily a set at this point.)

       Lemma 1.  F_n subset F_n+1.  (See ~ inf3lem1 .)
       Proof:  By induction:  F_0 subset F_1.  If y &lt; F_n+1, then y^X subset
       F_n,
       so if F_n subset F_n+1, then y^X subset F_n+1, so y &lt; F_n+2.

       Lemma 2.  F_n =/= X.  (See ~ inf3lem2 .)
       Proof:  By induction:  F_0 =/= X because X is not empty.  Assume F_n =/=
       X.
       Then there is a y in X that is not in F_n.  By definition of X, there is
       a
       z in X that contains y.  Suppose F_n+1 = X.  Then z is in F_n+1, and z^X
       contains y, so z^X is not a subset of F_n, contrary to the definition of
       F_n+1.

       Lemma 3.  F_n =/= F_n+1.  (See ~ inf3lem3 .)
       Proof:  Using the identity y^X subset F_n &lt;-> y^(X-F_n) = 0, we have
       F_n+1 = {y&lt;X | y^(X-F_n) = 0}.  Let q = {y&lt;X-F_n | y^(X-F_n) = 0}.
       Then q subset F_n+1.  Since X-F_n is not empty by Lemma 2 and q is the
       set of \in-minimal elements of X-F_n, by Foundation q is not empty, so q
       and therefore F_n+1 have an element not in F_n.

       Lemma 4.  F_n proper_subset F_n+1.  (See ~ inf3lem4 .)
       Proof:  Lemmas 1 and 3.

       Lemma 5.  F_m proper_subset F_n, m &lt; n.  (See ~ inf3lem5 .)
       Proof:  Fix m and use induction on n > m.  Basis: F_m proper_subset
       F_m+1
       by Lemma 4.  Induction:  Assume F_m proper_subset F_n.  Then since F_n
       proper_subset F_n+1, F_m proper_subset F_n+1 by transitivity of proper
       subset.

       By Lemma 5, F_m =/= F_n for m =/= n, so F is 1-1.  (See ~ inf3lem6 .)
       Thus, the inverse of F is a function with range omega and domain a
       subset
       of power X, so omega exists by Replacement.  (See ~ inf3lem7 .)
       Q.E.D.
       </PRE> </HTML> (Contributed by NM, 29-Oct-1996.)  $)
    inf3 $p |- om e. _V $=
      ( vy vw cv c0 wne cuni wss wex com cvv wcel cin crab cmpt crdg cres eqid
      wa vex inf3lem7 exlimiv ax-mp ) AEZFGUEUEHITZAJKLMZBUFUGAACDUEUECLDEUENCE
      IDUEOPZFQKRZUHUHSUISAUAZUJUBUCUD $.
  $}

  ${
    $d x y z w $.
    $( Half of ~ infeq5 .  (Contributed by Mario Carneiro, 16-Nov-2014.) $)
    infeq5i $p |- ( om e. _V -> E. x x C. U. x ) $=
      ( com cvv wcel c0 csn cdif cuni wpss cv wex difexg 0ex snid wn wceq disj4
      cin disj3 bitr3i peano1 eleq2 mpbii eldifbd sylbi mt4 unidif0 wlim limuni
      limom ax-mp eqtr4i psseq2i mpbir psseq1 unieq psseq2d bitrd spcegv ee10 )
      BCDBEFZGZCDVBVBHZIZAJZVEHZIZAKBVACLVDVBBIZEVADZVHEMNVHOZBVBPZVIOVJBVAREPV
      KBVAQBVASTVKEBVAVKEBDEVBDUABVBEUBUCUDUEUFVCBVBVCBHZBBUGBUHBVLPUJBUIUKULUM
      UNVGVDAVBCVEVBPZVGVBVFIVDVEVBVFUOVMVFVCVBVEVBUPUQURUSUT $.

    $( The statement "there exists a set that is a proper subset of its union"
       is equivalent to the Axiom of Infinity (shown on the right-hand side in
       the form of ~ omex .)  The left-hand side provides us with a very short
       way to express the Axiom of Infinity using only elementary symbols.
       This proof of equivalence does not depend on the Axiom of Infinity.
       (Contributed by NM, 23-Mar-2004.)  (Revised by Mario Carneiro,
       16-Nov-2014.) $)
    infeq5 $p |- ( E. x x C. U. x <-> om e. _V ) $=
      ( vy vw cv cuni wpss wex com cvv wcel c0 wne wa df-pss wceq unieq syl6req
      wss uni0 eqid eqtr mpdan necon3i anim1i ancoms sylbi eximi crab cmpt crdg
      cin cres vex inf3lem7 exlimiv syl infeq5i impbii ) ADZUSEZFZAGZHIJZVBUSKL
      ZUSUTRZMZAGVCVAVFAVAVEUSUTLZMVFUSUTNVGVEVFVGVDVEUSKUSUTUSKOZKUTOUSUTOVHUT
      KEKUSKPSQUSKUTUAUBUCUDUEUFUGVFVCAABCUSUSBICDUSUKBDRCUSUHUIZKUJHULZVIVITVJ
      TAUMZVKUNUOUPAUQUR $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZF Set Theory - add the Axiom of Infinity
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Introduce the Axiom of Infinity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
         +-------------------------------------------------+
         |         "Cantor's Paradise" begins here!        |
         | (i.e. we start to assume the Axiom of Infinity) |
         +-------------------------------------------------+
$)

  ${
    $d x y z w $.
    $( Axiom of Infinity.  An axiom of Zermelo-Fraenkel set theory.  This axiom
       is the gateway to "Cantor's paradise" (an expression coined by
       Hilbert).  It asserts that given a starting set ` x ` , an infinite set
       ` y ` built from it exists.  Although our version is apparently not
       given in the literature, it is similar to, but slightly shorter than,
       the Axiom of Infinity in [FreydScedrov] p. 283 (see ~ inf1 and
       ~ inf2 ).  More standard versions, which essentially state that there
       exists a set containing all the natural numbers, are shown as ~ zfinf2
       and ~ omex and are based on the (nontrivial) proof of ~ inf3 .  This
       version has the advantage that when expanded to primitives, it has fewer
       symbols than the standard version ~ ax-inf2 .  Theorem ~ inf0 shows the
       reverse derivation of our axiom from a standard one.  Theorem ~ inf5
       shows a very short way to state this axiom.

       The standard version of Infinity ~ ax-inf2 requires this axiom along
       with Regularity ~ ax-reg for its derivation (as theorem ~ axinf2
       below).  In order to more easily identify the normal uses of Regularity,
       we will usually reference ~ ax-inf2 instead of this one.  The derivation
       of this axiom from ~ ax-inf2 is shown by theorem ~ axinf .

       Proofs should normally use the standard version ~ ax-inf2 instead of
       this axiom.  (New usage is discouraged.)  (Contributed by NM,
       16-Aug-1993.) $)
    ax-inf $a |- E. y ( x e. y /\
                 A. z ( z e. y -> E. w ( z e. w /\ w e. y ) ) ) $.

    $( Axiom of Infinity expressed with the fewest number of different
       variables.  (New usage is discouraged.)  (Contributed by NM,
       14-Aug-2003.) $)
    zfinf $p |- E. x ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) $=
      ( vw wel wa wex wal ax-inf weq elequ1 anbi1d exbidv imbi12d cbvalv anbi2i
      wi exbii mpbi ) BAEZDAEZDCEZCAEZFZCGZQZDHZFZAGTTBCEZUCFZCGZQZBHZFZAGBADCI
      UHUNAUGUMTUFULDBDBJZUATUEUKDBAKUOUDUJCUOUBUIUCDBCKLMNOPRS $.

    $( A standard version of Axiom of Infinity, expanded to primitives, derived
       from our version of Infinity ~ ax-inf and Regularity ~ ax-reg .

       This theorem should not be referenced in any proof.  Instead, use
       ~ ax-inf2 below so that the ordinary uses of Regularity can be more
       easily identified.  (New usage is discouraged.)  (Contributed by NM,
       3-Nov-1996.) $)
    axinf2 $p |- E. x ( E. y ( y e. x /\ A. z -. z e. y ) /\ A. y ( y e. x ->
          E. z ( z e. x /\ A. w ( w e. z <-> ( w e. y \/ w = y ) ) ) ) ) $=
      ( c0 cv wcel wel csuc wi wal wa wex wn wceq com eleq2 wrex df-rex bitri
      wo wb peano1 peano2 ax-gen zfinf inf2 inf3 imbi12d albidv spcev mp2an 0el
      anbi12d sucel imbi2i albii anbi12i exbii mpbi ) EAFZGZBAHZBFZIZVAGZJZBKZL
      ZAMZVCCBHNCKZLBMZVCCAHDCHDBHDFVDOUAUBDKZLCMZJZBKZLZAMEPGZVDPGZVEPGZJZBKZV
      JUCWABVDUDUEVIVRWBLAPAABCABCUFUGUHVAPOZVBVRVHWBVAPEQWCVGWABWCVCVSVFVTVAPV
      DQVAPVEQUIUJUNUKULVIVQAVBVLVHVPVBVKBVARVLBCVAUMVKBVASTVGVOBVFVNVCVFVMCVAR
      VNCDVDVAUOVMCVASTUPUQURUSUT $.

    $( A standard version of Axiom of Infinity of ZF set theory.  In English,
       it says: there exists a set that contains the empty set and the
       successors of all of its members.  Theorem ~ zfinf2 shows it converted
       to abbreviations.  This axiom was derived as theorem ~ axinf2 above,
       using our version of Infinity ~ ax-inf and the Axiom of Regularity
       ~ ax-reg .  We will reference ~ ax-inf2 instead of ~ axinf2 so that the
       ordinary uses of Regularity can be more easily identified.  The reverse
       derivation of ~ ax-inf from ~ ax-inf2 is shown by theorem ~ axinf .
       (Contributed by NM, 30-Aug-1993.) $)
    ax-inf2 $a |- E. x ( E. y ( y e. x /\ A. z -. z e. y ) /\ A. y ( y e. x ->
          E. z ( z e. x /\ A. w ( w e. z <-> ( w e. y \/ w = y ) ) ) ) ) $.
  $}

  ${
    $d x y z w $.
    $( A standard version of the Axiom of Infinity, using definitions to
       abbreviate.  Axiom Inf of [BellMachover] p. 472.  (See ~ ax-inf2 for the
       unabbreviated version.)  (Contributed by NM, 30-Aug-1993.) $)
    zfinf2 $p |- E. x ( (/) e. x /\ A. y e. x suc y e. x ) $=
      ( vz vw c0 cv wcel csuc wral wa wex wel wn wal weq wo wrex df-rex bitri
      wb wi ax-inf2 0el sucel ralbii df-ral anbi12i exbii mpbir ) EAFZGZBFZHUJG
      ZBUJIZJZAKBALZCBLMCNZJBKZUPCALDCLDBLDBOPTDNZJCKZUABNZJZAKABCDUBUOVBAUKURU
      NVAUKUQBUJQURBCUJUCUQBUJRSUNUTBUJIVAUMUTBUJUMUSCUJQUTCDULUJUDUSCUJRSUEUTB
      UJUFSUGUHUI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Existence of omega (the set of natural numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The existence of omega (the class of natural numbers).  Axiom 7 of
       [TakeutiZaring] p. 43.  This theorem is proved assuming the Axiom of
       Infinity and in fact is equivalent to it, as shown by the reverse
       derivation ~ inf0 .

       A finitist (someone who doesn't believe in infinity) could, without
       contradiction, replace the Axiom of Infinity by its denial
       ` -. om e. _V ` ; this would lead to ` om = On ` by ~ omon and
       ` Fin = _V ` (the universe of all sets) by ~ fineqv .  The finitist
       could still develop natural number, integer, and rational number
       arithmetic but would be denied the real numbers (as well as much of the
       rest of mathematics).  In deference to the finitist, much of our
       development is done, when possible, without invoking the Axiom of
       Infinity; an example is Peano's axioms ~ peano1 through ~ peano5 (which
       many textbooks prove more easily assuming Infinity).  (Contributed by
       NM, 6-Aug-1994.) $)
    omex $p |- om e. _V $=
      ( vx vy c0 cv wcel csuc wral wa wex com wss zfinf2 wi ax-1 ralimi2 peano5
      cvv sylan2 eximi vex ssex exlimiv mp2b ) CADZEZBDZFUDEZBUDGZHZAIJUDKZAIJQ
      EZABLUIUJAUHUEUFUDEUGMZBJGUJUGULBUDJULUFJENOBUDPRSUJUKAJUDATUAUBUC $.
  $}

  ${
    $d x y z w $.
    $( The first version of the Axiom of Infinity ~ ax-inf proved from the
       second version ~ ax-inf2 .  Note that we didn't use ~ ax-reg , unlike
       the other direction ~ axinf2 .  (Contributed by NM, 24-Apr-2009.) $)
    axinf $p |- E. y ( x e. y /\
                 A. z ( z e. y -> E. w ( z e. w /\ w e. y ) ) ) $=
      ( omex inf0 ) ABCDEF $.
  $}

  ${
    $d x y z w $.
    $( The statement "there exists a set that is a proper subset of its union"
       is equivalent to the Axiom of Infinity (see theorem ~ infeq5 ).  This
       provides us with a very compact way to express the Axiom of Infinity
       using only elementary symbols.  (Contributed by NM, 3-Jun-2005.) $)
    inf5 $p |- E. x x C. U. x $=
      ( com cvv wcel cv cuni wpss wex omex infeq5i ax-mp ) BCDAEZLFGAHIAJK $.
  $}

  $( Omega is an ordinal number.  (Contributed by NM, 10-May-1998.)  (Revised
     by Mario Carneiro, 30-Jan-2013.) $)
  omelon $p |- om e. On $=
    ( com cvv wcel con0 omex omelon2 ax-mp ) ABCADCEFG $.

  ${
    $d x y z $.
    $( The class of natural numbers omega can be defined as the smallest
       "inductive set," which is valid provided we assume the Axiom of
       Infinity.  Definition 6.3 of [Eisenberg] p. 82.  (Contributed by NM,
       6-Aug-1994.) $)
    dfom3 $p |- om = |^| { x | ( (/) e. x /\ A. y e. x suc y e. x ) } $=
      ( vz com c0 cv wcel csuc wral wa cab cint wss 0ex elintab simpl wal eleq2
      wi wceq mpgbir suceq eleq1d rspccv adantl a2i alimi vex sucex rgenw mp2an
      3imtr4i peano5 peano1 peano2 rgen raleqbi1dv anbi12d imbi12d sylbi mp2ani
      omex spcv ssriv eqssi ) DEAFZGZBFZHZVFGZBVFIZJZAKLZEVMGZCFZVMGZVOHZVMGZSZ
      CDIDVMMVNVLVGSAVLAENOVGVKPUAVSCDVLVOVFGZSZAQZVLVQVFGZSZAQVPVRWAWDAVLVTWCV
      KVTWCSVGVJWCBVOVFVHVOTVIVQVFVHVOUBUCUDUEUFUGVLAVOCUHZOZVLAVQVOWEUIOULUJCV
      MUMUKCVMDVPEDGZVIDGZBDIZVODGZUNWHBDVHUOUPVPWBWGWIJZWJSZWFWAWLADVBVFDTZVLW
      KVTWJWMVGWGVKWIVFDERVJWHBVFDVFDVIRUQURVFDVORUSVCUTVAVDVE $.
  $}

  ${
    $d A x $.
    $( A simplification of ~ elom assuming the Axiom of Infinity.  (Contributed
       by NM, 30-May-2003.) $)
    elom3 $p |- ( A e. om <-> A. x ( Lim x -> A e. x ) ) $=
      ( com wcel con0 cv wlim wi wal wa elom limom omex wceq limeq imbi12d spcv
      eleq2 mpi nnon syl pm4.71ri bitr4i ) BCDZBEDZAFZGZBUFDZHZAIZJUJABKUJUEUJU
      DUEUJCGZUDLUIUKUDHACMUFCNUGUKUHUDUFCOUFCBRPQSBTUAUBUC $.
  $}

  ${
    $d x y $.
    $( A simplification of ~ df-om assuming the Axiom of Infinity.
       (Contributed by NM, 30-May-2003.) $)
    dfom4 $p |- om = { x | A. y ( Lim y -> x e. y ) } $=
      ( cv wlim wel wi wal com elom3 abbi2i ) BCDABEFBGAHBACIJ $.
  $}

  ${
    $d x y $.
    $( ` om ` is the smallest limit ordinal and can be defined as such
       (although the Axiom of Infinity is needed to ensure that at least one
       limit ordinal exists).  (Contributed by FL, 22-Feb-2011.)  (Revised by
       Mario Carneiro, 2-Feb-2013.) $)
    dfom5 $p |- om = |^| { x | Lim x } $=
      ( vy com cv wlim cab cint wcel wel wi wal elom3 vex elintab bitr4i eqriv
      ) BCADEZAFGZBDZCHQBAIJAKSRHASLQASBMNOP $.
  $}

  $( Ordinal addition is not commutative.  This theorem shows a
     counterexample.  Remark in [TakeutiZaring] p. 60.  (Contributed by NM,
     10-Dec-2004.) $)
  oancom $p |- ( 1o +o om ) =/= ( om +o 1o ) $=
    ( c1o com coa wcel wne csuc omex sucid con0 wceq omelon 1onn oaabslem mp2an
    co oa1suc ax-mp 3eltr4i 1on oacl wss wa wb onelpss simprbi ) ABCOZBACOZDZUF
    UGEZBBFZUFUGBGHBIDZABDUFBJKLAMNUKUGUJJKBPQRUHUFUGUAZUIUFIDZUGIDZUHULUIUBUCA
    IDZUKUMSKABTNUKUOUNKSBATNUFUGUDNUEQ $.

  $( A set is finite iff it is strictly dominated by the class of natural
     number.  Theorem 42 of [Suppes] p. 151.  The Axiom of Infinity is used for
     the forward implication.  (Contributed by FL, 16-Apr-2011.) $)
  isfinite $p |- ( A e. Fin <-> A ~< om ) $=
    ( com cvv wcel cfn csdm wbr wb omex isfiniteg ax-mp ) BCDAEDABFGHIAJK $.

  $( A natural number is strictly dominated by the set of natural numbers.
     Example 3 of [Enderton] p. 146.  (Contributed by NM, 28-Oct-2003.) $)
  nnsdom $p |- ( A e. om -> A ~< om ) $=
    ( com cvv wcel csdm wbr omex nnsdomg mpan ) BCDABDABEFGAHI $.

  $( Omega is equinumerous to a proper subset of itself.  Example 13.2(4) of
     [Eisenberg] p. 216.  (Contributed by NM, 30-Jul-2003.) $)
  omenps $p |- om ~~ ( om \ { (/) } ) $=
    ( com cvv wcel c0 csn cdif cen wbr omex limom limenpsi ax-mp ) ABCAADEFGHIA
    BJKL $.

  $( The set of natural numbers is equinumerous to its successor.  (Contributed
     by NM, 30-Oct-2003.) $)
  omensuc $p |- om ~~ suc om $=
    ( com cvv wcel csuc cen wbr omex limom limensuci ax-mp ) ABCAADEFGABHIJ $.

  ${
    $d f x y z A $.  $d f x y z B $.
    $( Removing a singleton from an infinite set does not change the
       cardinality of the set.  (Contributed by Mario Carneiro, 30-Apr-2015.)
       (Revised by Mario Carneiro, 16-May-2015.) $)
    infdifsn $p |- ( om ~<_ A -> ( A \ { B } ) ~~ A ) $=
      ( vf com cdom wbr wcel csn cdif cen wa cvv adantl peano1 sylancl cun wceq
      c0 syl wss wf1 wex brdomi adantr cfv reldom brrelex2i ad2antrr simplr f1f
      cv wf ffvelrn difsnen syl3anc crn cin wf1o f1f1orn f1oen3g sylancr ensymd
      vex brrelexi limom limenpsi cima cres resex simpr difss f1ores ccnv f1orn
      wfun wfn simprbi imadif 3syl f1fn fnima fnsnfv eqcomd difeq12d eqtrd entr
      breqtrd syl2anc difexg enrefg disjdif a1i ssrin ax-mp sseq0 unen syl22anc
      mp2an frn undif sylib uncom wn eldifn fnfvelrn nsyl3 disjsn sylibr undif4
      syl5eq difeq1d 3brtr3d exlimddv difsn eqbrtrd pm2.61dan ) DAEFZBAGZABHIZA
      JFZXQXRKZDACUKZUAZXTCXQYCCUBXRDACUCUDYAYCKZXSARYBUEZHZIZJFZYGAJFXTYDALGZX
      RYEAGZYHXQYIXRYCDAEUFUGZUHZXQXRYCUIYDDAYBULZRDGZYJYCYMYADAYBUJMZNDARYBUMO
      BYELAUNUOYDAYGYDYBUPZAYPIZPZYPYFIZYQPZAYGJYDYPYSJFZYQYQJFZYPYQUQZRQZYSYQU
      QZRQZYRYTJFYDYPDJFDYSJFZUUAYDDYPYDYBLGDYPYBURZDYPJFCVCZYCUUHYADAYBUSMZDYP
      YBLUTVAVBYDDDRHZIZJFZUULYSJFUUGYDDLGZUUMXQUUNXRYCDAEUFVDUHDLVEVFSYDUULYBU
      ULVGZYSJYDYBUULVHZLGUULUUOUUPURZUULUUOJFYBUULUUIVIYDYCUULDTUUQYAYCVJDUUKV
      KDAUULYBVLOUULUUOUUPLUTVAYDUUOYBDVGZYBUUKVGZIZYSYDUUHYBVMVOZUUOUUTQUUJUUH
      YBDVPZUVADYBVNVQDUUKYBVRVSYDUURYPUUSYFYDUVBUURYPQYCUVBYADAYBVTMZDYBWASYDY
      FUUSYDUVBYNYFUUSQUVCNDRYBWBOWCWDWEWGDUULYSWFWHYPDYSWFWHYDYIYQLGUUBYLAYPLW
      IYQLWJVSUUDYDYPAWKZWLUUFYDUUEUUCTZUUDUUFYSYPTUVEYPYFVKYSYPYQWMWNUVDUUEUUC
      WOWRWLYPYSYQYQWPWQYDYPATZYRAQYDYMUVFYODAYBWSSYPAWTXAZYDYTYQYSPZYGYSYQXBYD
      UVHYQYPPZYFIZYGYDYQYFUQRQZUVHUVJQYDYEYQGZXCUVKUVLYEYPGZYDYEAYPXDYDUVBYNUV
      MUVCNDRYBXEOXFYQYEXGXHYQYPYFXISYDUVIAYFYDUVIYRAYQYPXBUVGXJXKWEXJXLVBXSYGA
      WFWHXMXQXRXCZKXSAAJUVNXSAQXQBAXNMXQAAJFZUVNXQYIUVOYKALWJSUDXOXP $.

    $( Removing a finite set from an infinite set does not change the
       cardinality of the set.  (Contributed by Mario Carneiro,
       30-Apr-2015.) $)
    infdiffi $p |- ( ( om ~<_ A /\ B e. Fin ) -> ( A \ B ) ~~ A ) $=
      ( vx vy vz cfn wcel com cdom wbr cdif cen cv wi wceq difeq2 syl6eq breq1d
      c0 imbi2d csn dif0 cun difun1 cvv reldom brrelex2i enrefg syl wa biimparc
      domen2 infdifsn entr sylancom ex a2i a1i findcard2 impcom ) BFGHAIJZABKZA
      LJZVAACMZKZALJZNVAAALJZNVAADMZKZALJZNZVAVIEMZUAZKZALJZNZVAVCNCDEBVDSOZVFV
      GVAVQVEAALVQVEASKAVDSAPAUBQRTVDVHOZVFVJVAVRVEVIALVDVHAPRTVDVHVMUCZOZVFVOV
      AVTVEVNALVTVEAVSKVNVDVSAPAVHVMUDQRTVDBOZVFVCVAWAVEVBALVDBAPRTVAAUEGVGHAIU
      FUGAUEUHUIVKVPNVHFGVAVJVOVAVJVOVAVJVNVILJZVOVAVJUJHVIIJZWBVJWCVAVIAHULUKV
      IVLUMUIVNVIAUNUOUPUQURUSUT $.
  $}

  ${
    $d x y z A $.
    $( Any unbounded subset of natural numbers is equinumerous to the set of
       all natural numbers.  This version of ~ unbnn eliminates its hypothesis
       by assuming the Axiom of Infinity.  (Contributed by NM, 4-May-2005.) $)
    unbnn3 $p |- ( ( A C_ om /\ A. x e. om E. y e. A x e. y ) -> A ~~ om ) $=
      ( com cvv wcel wss wel wrex wral cen wbr omex unbnn mp3an1 ) DEFCDGABHBCI
      ADJCDKLMABCNO $.
  $}

  ${
    $d w x y z F $.
    $( Using the Axiom of Regularity in the form ~ zfregfr , show that there
       are no infinite descending ` e. ` -chains.  Proposition 7.34 of
       [TakeutiZaring] p. 44.  (Contributed by NM, 26-Jan-2006.)  (Revised by
       Mario Carneiro, 22-Mar-2013.) $)
    noinfep $p |- E. x e. om ( F ` suc x ) e/ ( F ` x ) $=
      ( vz vy vw cv cep wn com cfv wrex wnel cvv wcel c0 wne wceq fvex ax-mp wi
      wbr cmpt crn wral csuc wfr wss omex rnex zfregfr ssid cdm dmmptg a1i mprg
      mptex peano1 ne0i eqnetri dm0rn0 necon3bii mpbi fri mp4an wfn eqid fnmpti
      fvelrnb peano2 fveq2 fvmpt syl fnfvelrn sylancr eqeltrrd wel eleq1 syl5bb
      wb epel notbid df-nel syl6bbr rspccv syl5com syl5ibcom neleq2 biimpd syl6
      eqeq1 com23 syld com12 reximdvai syl5bi rexlimiv ) CFZDFZGUAZHZCEIEFZBJZU
      BZUCZUDZDXDKZAFZUEZBJZXGBJZLZAIKZXDMNXDGUFXDXDUGXDOPZXFXCEIXBUHUPUIXDUJXD
      UKXCULZOPXMXNIOXBMNZXNIQEIEIXBMUMXOXAINXABRZUNUOOINIOPUQIOURSUSXNOXDOXCUT
      VAVBDCXDXDMGVCVDXEXLDXDXEWRXDNZXLXQXGXCJZWRQZAIKZXEXLXCIVEZXQXTVSEIXBXCXP
      XCVFZVGZAIWRXCVHSXEXSXKAIXGINZXEXSXKTZYDXEXIWRLZYEYDXIXDNXEYFYDXHXCJZXIXD
      YDXHINZYGXIQXGVIZEXHXBXIIXCXAXHBVJYBXHBRVKVLYDYAYHYGXDNYCYIIXHXCVMVNVOWTY
      FCXIXDWQXIQZWTXIWRNZHYFYJWSYKWSCDVPYJYKCDVTWQXIWRVQVRWAXIWRWBWCWDWEYDXSYF
      XKYDXSWRXJQZYFXKTYDXRXJQXSYLEXGXBXJIXCXAXGBVJYBXGBRVKXRWRXJWJWFYLYFXKWRXJ
      XIWGWHWIWKWLWMWNWOWMWPS $.
  $}

  ${
    $d x y z F $.
    $( Using the Axiom of Regularity in the form ~ zfregfr , show that there
       are no infinite descending ` e. ` -chains.  Proposition 7.34 of
       [TakeutiZaring] p. 44.  (Contributed by NM, 26-Jan-2006.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    noinfepOLD $p |- ( F Fn om -> E. x e. om -. ( F ` suc x ) e. ( F ` x ) ) $=
      ( vz vy com wfn cv cep wn wrex cfv wcel cvv c0 wne wceq eleq2 syl notbid
      wa wbr crn wral csuc cdm wfun fndm omex syl6eqel fnfun sylc peano1 mpbiri
      funrnex ne0i dm0rn0 necon3bii sylib wfr zfregfr wss mpanr1 mpanl2 syl2anc
      ssid fri wi fvelrnb adantr peano2 fnfvelrn adantlr simplr jca epel syl5bb
      wb eleq1 rspcva syl5ibr syl5 sylan2i com12 reximdva sylbid com23 rexlimdv
      ex mpd ) BEFZCGZDGZHUAZIZCBUBZUCZDWOJZAGZUDZBKZWRBKZLZIZAEJZWJWOMLZWONOZW
      QWJBUEZMLBUFXEWJXGEMEBUGZUHUIEBUJMBUNUKWJXGEPZXFXHXIXGNOZXFXINXGLZXJXIXKN
      ELULXGENQUMXGNUORXGNWONBUPUQURRXEWOHUSZXFWQWOUTXEXLTWOWOVAXFWQWOVEDCWOWOM
      HVFVBVCVDWJWPXDDWOWJWPWLWOLZXDWJWPXMXDVGWJWPTZXMXAWLPZAEJZXDWJXMXPVQWPAEW
      LBVHVIXNXOXCAEXOXNWRELZTXCXQXOXNWSELZXCWRVJXNXRTZWTWOLZWPTZXOXCXSXTWPWJXR
      XTWPEWSBVKVLWJWPXRVMVNYAXCXOWTWLLZIZWNYCCWTWOWKWTPZWMYBWMWKWLLYDYBCDVOWKW
      TWLVRVPSVSXOXBYBXAWLWTQSVTWAWBWCWDWEWHWFWGWI $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cantor normal form
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CNF $.

  $( Extend class notation with the Cantor normal form function. $)
  ccnf $a class CNF $.

  ${
    $d x y f g h k z $.
    $( Define the Cantor normal form function, which takes as input a finitely
       supported function from ` y ` to ` x ` and outputs the corresponding
       member of the ordinal exponential ` x ^o y ` .  The content of the
       original Cantor Normal Form theorem is that for ` x = om ` this function
       is a bijection onto ` om ^o y ` for any ordinal ` y ` (or, since the
       function restricts naturally to different ordinals, the statement that
       the composite function is a bijection to ` On ` ).  More can be said
       about the function, however, and in particular it is an order
       isomorphism for a certain easily defined well-ordering of the finitely
       supported functions, which gives an alternate definition ~ cantnffval2
       of this function in terms of ~ df-oi .  (Contributed by Mario Carneiro,
       25-May-2015.) $)
    df-cnf $a |- CNF = ( x e. On , y e. On |->
      ( f e. { g e. ( x ^m y ) | ( `' g " ( _V \ 1o ) ) e. Fin } |->
        [_ OrdIso ( _E , ( `' f " ( _V \ 1o ) ) ) / h ]_
        ( seqom ( ( k e. _V , z e. _V |-> ( ( ( x ^o ( h ` k ) ) .o
          ( f ` ( h ` k ) ) ) +o z ) ) , (/) ) ` dom h ) ) ) $.
  $}

  ${
    $d f g h k x y z A $.  $d f g h k x y z B $.  $d f x y S $.
    cantnffval.1 $e |- S =
      { g e. ( A ^m B ) | ( `' g " ( _V \ 1o ) ) e. Fin } $.
    cantnffval.2 $e |- ( ph -> A e. On ) $.
    cantnffval.3 $e |- ( ph -> B e. On ) $.
    $( The value of the Cantor normal form function.  (Contributed by Mario
       Carneiro, 25-May-2015.) $)
    cantnffval $p |- ( ph -> ( A CNF B ) =
      ( f e. S |-> [_ OrdIso ( _E , ( `' f " ( _V \ 1o ) ) ) / h ]_
        ( seqom ( ( k e. _V , z e. _V |-> ( ( ( A ^o ( h ` k ) ) .o
          ( f ` ( h ` k ) ) ) +o z ) ) , (/) ) ` dom h ) ) ) $=
      ( con0 wcel co cv cvv cfv c0 wceq ccnf ccnv c1o cdif cima cep coi cdm coe
      vx vy comu coa cmpt2 cseqom csb cmpt cfn cmap wa oveq12 rabeq syl syl6eqr
      crab w3a simp1l oveq1d mpt2eq3dva eqid seqomeq12 sylancl fveq1d mpteq12dv
      csbeq2dv df-cnf ovex rabex eqeltri mptex ovmpt2a syl2anc ) ACMNDMNCDUAOFE
      HFPZUBQUCUDZUEUFUGZHPZUHZIBQQCIPZWFRZUIOZWIWCRZULOZBPZUMOZUNZSUOZRZUPZUQZ
      TKLUJUKCDMMFGPUBWDUEURNZGUJPZUKPZUSOZVEZHWEWGIBQQXAWIUIOZWKULOZWMUMOZUNZS
      UOZRZUPZUQWSUAXACTZXBDTZUTZFXDXKEWRXNXDWTGCDUSOZVEZEXNXCXOTXDXPTXACXBDUSV
      AWTGXCXOVBVCJVDXNHWEXJWQXNWGXIWPXNXHWOTSSTXIWPTXNIBQQXGWNXNWHQNZWMQNZVFZX
      FWLWMUMXSXEWJWKULXSXACWIUIXLXMXQXRVGVHVHVHVISVJXHWOSSVKVLVMVOVNUJUKBFGHIV
      PFEWREXPQJWTGXOCDUSVQVRVSVTWAWB $.

    $( The domain of the Cantor normal form function (in later lemmas we will
       use ` dom ( A CNF B ) ` to abbreviate "the set of finitely supported
       functions from ` B ` to ` A ` ").  (Contributed by Mario Carneiro,
       25-May-2015.) $)
    cantnfdm $p |- ( ph -> dom ( A CNF B ) = S ) $=
      ( vf vh vk vz ccnf co cdm cv ccnv cvv c1o cfv cdif cima cep coi coe cmpt2
      comu coa cseqom csb cmpt cantnffval dmeqd wcel wral wceq fvex csbex rgenw
      c0 dmmptg ax-mp syl6eq ) ABCMNZOIDJIPZQRSUAUBUCUDZJPZOZKLRRBKPVGTZUENVIVE
      TUGNLPUHNUFUTUIZTZUJZUKZOZDAVDVMALBCDIEJKFGHULUMVLRUNZIDUOVNDUPVOIDJVFVKV
      HVJUQURUSIDVLRVAVBVC $.
  $}

  ${
    $d k z A $.  $d k z B $.  $d x y F $.
    cantnfvalf.f $e |- F =
      seqom ( ( k e. A , z e. B |-> ( C +o D ) ) , (/) ) $.
    $( Lemma for ~ cantnf .  The function appearing in ~ cantnfval is
       unconditionally a function.  (Contributed by Mario Carneiro,
       20-May-2015.) $)
    cantnfvalf $p |- F : om --> On $=
      ( vx vy com con0 wf cfv wcel wral coa co c0 wceq wfn cv fnseqom csuc wrex
      cmpt2 wo nn0suc fveq2 cvv 0ex seqom0g ax-mp 0elon syl6eqel seqomsuc df-ov
      syl6eq cop cxp fnoa oacl rgen2a ffnov mpbir2an f0cli eqeltri rgen2w fmpt2
      eqid mpbi eleq1d syl5ibrcom rexlimiv jaoi syl rgen ffnfv ) KLGMGKUAIUBZGN
      ZLOZIKPFABCDEQRZUFZGSHUCWAIKVSKOVSSTZVSJUBZUDZTZJKUEZUGWAJVSUHWDWAWHWDVTS
      LWDVTSGNZSVSSGUISUJOWISTUKWCGSHULUMURUNUOWGWAJKWEKOZWAWGWFGNZLOWJWKWEWEGN
      ZUSZWCNZLWJWKWEWLWCRWNWEWCGSHUPWEWLWCUQURBCUTZLWMWCWBLOZACPFBPWOLWCMWPFAB
      CWBDEUSZQNLDEQUQLLUTZLWQQWRLQMQWRUAVSWEQRLOZJLPILPVAWSIJLVSWEVBVCIJLLLQVD
      VEUNVFVGVHFABCWBLWCWCVJVIVKUNVFUOWGVTWKLVSWFGUIVLVMVNVOVPVQIKLGVRVE $.
  $}

  ${
    $d c f g h k n t u v w x y z B $.  $d a b c d g w x y z C $.  $d k n z D $.
    $d a b c d f g h k n t u v w x y z A $.  $d x y M $.  $d c f g k t u v T $.
    $d f g h k u v w x y z F $.  $d c f g k t u v x y z S $.  $d g t x y z Z $.
    $d c f h k t u v w x y z G $.  $d f h u v x y H $.  $d k t u v x z K $.
    $d k u w x y z O $.  $d f g k n t u v x y z ph $.  $d k t w x y z Y $.
    $d a b d k t u w x y z X $.
    cantnfs.1 $e |- S = dom ( A CNF B ) $.
    cantnfs.2 $e |- ( ph -> A e. On ) $.
    cantnfs.3 $e |- ( ph -> B e. On ) $.
    $( Elementhood in the set of finitely supported functions from ` B ` to
       ` A ` .  (Contributed by Mario Carneiro, 25-May-2015.) $)
    cantnfs $p |- ( ph -> ( F e. S <->
      ( F : B --> A /\ ( `' F " ( _V \ 1o ) ) e. Fin ) ) ) $=
      ( vg wcel cmap co ccnv cvv c1o cdif cima cfn wa con0 wf cv crab ccnf eqid
      cdm cantnfdm syl5eq eleq2d wceq cnveq imaeq1d eleq1d elrab syl6bb syl2anc
      wb elmapg anbi1d bitrd ) AEDJZEBCKLZJZEMZNOPZQZRJZSZCBEUAZVGSAVAEIUBZMZVE
      QZRJZIVBUCZJVHADVNEADBCUDLUFVNFABCVNIVNUEGHUGUHUIVMVGIEVBVJEUJZVLVFRVOVKV
      DVEVJEUKULUMUNUOAVCVIVGABTJCTJVCVIUQGHBCETTURUPUSUT $.

    ${
      cantnfval.3 $e |- G = OrdIso ( _E , ( `' F " ( _V \ 1o ) ) ) $.
      cantnfval.4 $e |- ( ph -> F e. S ) $.
      $( Basic properties of the order isomorphism ` G ` used later.  The
         support of an ` F e. S ` is a finite subset of ` A ` , so it is
         well-ordered by ` _E ` and the order isomorphism has domain a finite
         ordinal.  (Contributed by Mario Carneiro, 25-May-2015.) $)
      cantnfcl $p |- ( ph ->
        ( _E We ( `' F " ( _V \ 1o ) ) /\ dom G e. om ) ) $=
        ( cvv cep wwe cdm com wcel con0 wss cfn ccnv cdif cima cnvimass wf wceq
        c1o wa cantnfs mpbid simpld fdm syl syl5sseq onss sstrd epweon wess cin
        ee10 cnvexg imaexg oion 4syl cen wbr simprd oien syl2anc enfii sylanbrc
        elin onfin2 syl6eleqr jca ) AEUAZLUGUBZUCZMNZFOZPQAVRRSRMNVSAVRCRAEOZVR
        CEVQUDACBEUEZWACUFAWBVRTQZAEDQZWBWCUHKABCDEGHIUIUJZUKCBEULUMUNACRQCRSIC
        UOUMUPUQVRRMURUTZAVTRTUSZPAVTRQZVTTQZVTWGQAWDVPLQVRLQWHKEDVAVPVQLVBVRMF
        LJVCVDAWCVTVRVEVFZWIAWBWCWEVGZAWCVSWJWKWFVRMFTJVHVIVTVRVJVIVTRTVLVKVMVN
        VO $.

      cantnfval.5 $e |- H = seqom ( ( k e. _V , z e. _V |->
        ( ( ( A ^o ( G ` k ) ) .o ( F ` ( G ` k ) ) ) +o z ) ) , (/) ) $.
      $( The value of the Cantor normal form function.  (Contributed by Mario
         Carneiro, 25-May-2015.) $)
      cantnfval $p |- ( ph -> ( ( A CNF B ) ` F ) = ( H ` dom G ) ) $=
        ( co cfv cvv wcel wceq vf vg vh ccnf cv ccnv c1o cdif cima cfn cmap cep
        crab coi cdm coe comu coa cmpt2 c0 cseqom cmpt eqid cantnffval cantnfdm
        csb fveq1d syl5eq eleqtrd vex cnvex imaexg oiexg a1i simpr simpl cnveqd
        mp2b wa imaeq1d oieq2 syl eqtrd syl6eqr oveq2d fveq12d oveq12d 3ad2ant1
        oveq1d mpt2eq3dva seqomeq12 sylancl dmeqd csbied fvex fvmpt ) AGCDUDPZQ
        GUAUBUEUFRUGUHZUIUJSUBCDUKPUMZUCUAUEZUFZWRUIZULUNZUCUEZUOZFBRRCFUEZXDQZ
        UPPZXGWTQZUQPZBUEZURPZUSZUTVAZQZVFZVBZQZHUOZIQZAGWQXQABCDWSUAUBUCFWSVCZ
        KLVDVGAGWSSXRXTTAGEWSNAEWQUOWSJACDWSUBYAKLVEVHVIUAGXPXTWSXQWTGTZUCXCXOX
        TRXCRSZYBXARSXBRSYCWTUAVJVKXAWRRVLXBULXCRXCVCVMVRVNYBXDXCTZVSZXEXSXNIYE
        XNFBRRCXFHQZUPPZYFGQZUQPZXKURPZUSZUTVAZIYEXMYKTUTUTTXNYLTYEFBRRXLYJYEXF
        RSXLYJTXKRSYEXJYIXKURYEXHYGXIYHUQYEXGYFCUPYEXFXDHYEXDGUFZWRUIZULUNZHYEX
        DXCYOYBYDVOYEXBYNTXCYOTYEXAYMWRYEWTGYBYDVPZVQVTXBYNULWAWBWCMWDZVGZWEYEX
        GYFWTGYPYRWFWGWIWHWJUTVCXMYKUTUTWKWLOWDYEXDHYQWMWFWNXQVCXSIWOWPWBWC $.

      $( Alternate expression for the value of the Cantor normal form
         function.  (Contributed by Mario Carneiro, 25-May-2015.) $)
      cantnfval2 $p |- ( ph -> ( ( A CNF B ) ` F ) =
          ( seqom ( ( k e. dom G , z e. On |-> ( ( ( A ^o ( G ` k ) ) .o
            ( F ` ( G ` k ) ) ) +o z ) ) , (/) ) ` dom G ) ) $=
        ( cfv con0 c0 wceq wi vu vv ccnf co cdm cv coe comu coa cmpt2 cantnfval
        cseqom wss ssid com wcel ccnv cvv c1o cdif cima cep wwe cantnfcl simprd
        csuc sseq1 fveq2 0ex seqom0g syl6eq eqid eqeq12d imbi12d imbi2d a1ii wa
        ax-mp sssucid sstr mpan imim1i oveq2 seqomsuc ad2antrl cxp cres resmpt2
        ssv mp2an oveqi simprr vex sucid a1i sseldd cantnfvalf ffvelrni syl2anc
        ovres syl5eqr eqtrd syl5ibr expr a2d syl5 expcom finds mpcom mpi ) AGCD
        UCUDPHUEZIPZXKFBXKQCFUFHPZUGUDXMGPUHUDZBUFZUIUDZUJZRULZPZABCDEFGHIJKLMN
        OUKAXKXKUMZXLXSSZXKUNXKUOUPZAXTYATZAGUQURUSUTVAVBVCYBACDEGHJKLMNVDVEAUA
        UFZXKUMZYDIPZYDXRPZSZTZTARXKUMZRRSZTZTAUBUFZXKUMZYMIPZYMXRPZSZTZTAYMVFZ
        XKUMZYSIPZYSXRPZSZTZTAYCTUAUBXKYDRSZYIYLAUUEYEYJYHYKYDRXKVGUUEYFRYGRUUE
        YFRIPZRYDRIVHRURUPZUUFRSVIFBURURXPUJZIROVJVRVKUUEYGRXRPZRYDRXRVHUUGUUIR
        SVIXQXRRXRVLZVJVRVKVMVNVOYDYMSZYIYRAUUKYEYNYHYQYDYMXKVGUUKYFYOYGYPYDYMI
        VHYDYMXRVHVMVNVOYDYSSZYIUUDAUULYEYTYHUUCYDYSXKVGUULYFUUAYGUUBYDYSIVHYDY
        SXRVHVMVNVOYDXKSZYIYCAUUMYEXTYHYAYDXKXKVGUUMYFXLYGXSYDXKIVHYDXKXRVHVMVN
        VOAYJYKRVLVPYMUOUPZAYRUUDAUUNYRUUDTYRYTYQTAUUNVQZUUDYTYNYQYMYSUMYTYNYMV
        SYMYSXKVTWAWBUUOYTYQUUCAUUNYTYQUUCTYQUUCAUUNYTVQVQZYMYOUUHUDZYMYPUUHUDZ
        SYOYPYMUUHWCUUPUUAUUQUUBUURUUNUUAUUQSAYTYMUUHIROWDWEUUPUUBYMYPXQUDZUURU
        UNUUBUUSSAYTYMXQXRRUUJWDWEUUPUUSYMYPUUHXKQWFWGZUDZUURUUTXQYMYPXKURUMQUR
        UMUUTXQSXKWIQWIFBURURXKQXPWHWJWKUUPYMXKUPYPQUPZUVAUURSUUPYSXKYMAUUNYTWL
        YMYSUPUUPYMUBWMWNWOWPUUNUVBAYTUOQYMXRBXKQXNXOFXRUUJWQWRWEYMYPXKQUUHWTWS
        XAXBVMXCXDXEXFXGXEXHXIXJXB $.

      $( The value of the recursive function ` H ` at a successor.
         (Contributed by Mario Carneiro, 25-May-2015.) $)
      cantnfsuc $p |- ( ( ph /\ K e. om ) -> ( H ` suc K ) =
        ( ( ( A ^o ( G ` K ) ) .o ( F ` ( G ` K ) ) ) +o ( H ` K ) ) ) $=
        ( cfv cvv co coa vu vv com wcel wa csuc cv coe comu cmpt2 wceq seqomsuc
        adantl elex fvex simpl fveq2d oveq2d oveq12d simpr fveq2 oveq2 cbvmpt2v
        c0 oveq1d ovex ovmpt2a sylancl eqtrd ) AJUCUDZUEZJUFIQZJJIQZFBRRCFUGZHQ
        ZUHSZVOGQZUISZBUGZTSZUJZSZCJHQZUHSZWCGQZUISZVMTSZVJVLWBUKAJWAIVDPULUMVK
        JRUDZVMRUDWBWGUKVJWHAJUCUNUMJIUOUAUBJVMRRCUAUGZHQZUHSZWJGQZUISZUBUGZTSZ
        WGWAWIJUKZWNVMUKZUEZWMWFWNVMTWRWKWDWLWEUIWRWJWCCUHWRWIJHWPWQUPUQZURWRWJ
        WCGWSUQUSWPWQUTUSFBUAUBRRVTWOWMVSTSVNWIUKZVRWMVSTWTVPWKVQWLUIWTVOWJCUHV
        NWIHVAZURWTVOWJGXAUQUSVEVSWNWMTVBVCWFVMTVFVGVHVI $.

      ${
        cantnfle.5 $e |- ( ph -> C e. B ) $.
        $( A lower bound on the ` CNF ` function.  Since
           ` ( ( A CNF B ) `` F ) ` is defined as the sum of
           ` ( A ^o x ) .o ( F `` x ) ` over all ` x ` in the support of
           ` F ` , it is larger than any of these terms (and all other terms
           are zero, so we can extend the statement to all ` C e. B ` instead
           of just those ` C ` in the support).  (Contributed by Mario
           Carneiro, 28-May-2015.) $)
        cantnfle $p |- ( ph ->
            ( ( A ^o C ) .o ( F ` C ) ) C_ ( ( A CNF B ) ` F ) ) $=
          ( wss c0 wcel vx vy coe co cfv comu ccnf wceq oveq2 sseq1d wne wa cdm
          ccnv cvv c1o cdif cima wf1o wf cep wiso wwe con0 cnvimass cfn cantnfs
          mpbid simpld fdm syl syl5sseq ssexd com cantnfcl oiiso syl2anc isof1o
          adantr f1ocnv f1of 3syl simpr fvex mpbiran sylibr wfn wb ffn elpreima
          dif1o mpbir2and ffvelrnd wi simprd cv eqimss biantrurd bitr3d imbi12d
          eleq2 fveq2 sseq2d imbi2d csuc sseq1 anbi12d pm2.21i adantl a1i elsuc
          noel sssucid sstr mpan ad2antrl simprr pm2.27 coa cantnfvalf ffvelrni
          ad2antlr ad3antrrr sucidg sseldd oif onelon oecl omcl oaword2 simplll
          wo simplr cantnfsuc sseqtr4d expcom adantrr syld expr fveq2d ad2antrr
          f1ocnvfv2 eqtr3d oveq2d oveq12d oaword1 eqsstr3d syl5bi expimpd com23
          a1dd jaod finds2 vtoclga mpcom mpd cantnfval om0 syl6eqss pm2.61ne
          0ss ) ACEUCUDZEHUEZUFUDZHCDUGUDUEZRUVBSUFUDZUVERUVCSUVCSUHUVDUVFUVEUV
          CSUVBUFUIUJAUVCSUKZULZUVDIUMZJUEZUVEUVHEIUNZUEZUVITZUVDUVJRZUVHHUNUOU
          PUQZURZUVIEUVKUVHUVIUVPIUSZUVPUVIUVKUSUVPUVIUVKUTAUVQUVGAUVIUVPVAVAIV
          BZUVQAUVPUOTUVPVAVCZUVRAUVPDVDMAHUMZUVPDHUVOVEADCHUTZUVTDUHAUWAUVPVFT
          ZAHFTUWAUWBULOACDFHKLMVGVHVIZDCHVJVKVLZVMAUVSUVIVNTZACDFHIKLMNOVOZVIU
          VPVAIUONVPVQUVIUVPVAVAIVRVKVSZUVIUVPIVTUVPUVIUVKWAWBUVHEUVPTZEDTZUVCU
          VOTZAUWIUVGQVSUVHUVGUWJAUVGWCUWJUVCUOTUVGEHWDUVCUOWKWEWFUVHUWAHDWGUWH
          UWIUWJULWHAUWAUVGUWCVSDCHWIDEUVOHWJWBWLZWMUWEUVHUVMUVNWNZAUWEUVGAUVSU
          WEUWFWOVSUVHUAWPZUVIRZUVLUWMTZULZUVDUWMJUEZRZWNZWNUVHUWLWNUAUVIVNUWMU
          VIUHZUWSUWLUVHUWTUWPUVMUWRUVNUWTUWOUWPUVMUWTUWNUWOUWMUVIWQWRUWMUVIUVL
          XAWSUWTUWQUVJUVDUWMUVIJXBXCWTXDUWSSUVIRZUVLSTZULZUVDSJUEZRZWNZUBWPZUV
          IRZUVLUXGTZULZUVDUXGJUEZRZWNZUXGXEZUVIRZUVLUXNTZULZUVDUXNJUEZRZWNZUVH
          UAUBUWMSUHZUWPUXCUWRUXEUYAUWNUXAUWOUXBUWMSUVIXFUWMSUVLXAXGUYAUWQUXDUV
          DUWMSJXBXCWTUWMUXGUHZUWPUXJUWRUXLUYBUWNUXHUWOUXIUWMUXGUVIXFUWMUXGUVLX
          AXGUYBUWQUXKUVDUWMUXGJXBXCWTUWMUXNUHZUWPUXQUWRUXSUYCUWNUXOUWOUXPUWMUX
          NUVIXFUWMUXNUVLXAXGUYCUWQUXRUVDUWMUXNJXBXCWTUXFUVHUXBUXEUXAUXBUXEUVLX
          LXHXIXJUVHUXGVNTZUXMUXTWNUVHUYDULZUXQUXMUXSUYEUXOUXPUXMUXSWNZUXPUXIUV
          LUXGUHZYLUYEUXOULZUYFUVLUXGEUVKWDXKUYHUXIUYFUYGUYEUXOUXIUYFUYEUXOUXIU
          LULZUXMUXLUXSUYIUXHUXIUXMUXLWNUXOUXHUYEUXIUXGUXNRUXOUXHUXGXMUXGUXNUVI
          XNXOXPUYEUXOUXIXQUXJUXLXRVQUYEUXOUXLUXSWNZUXIUYHUXKUXRRZUYJUYHUXKCUXG
          IUEZUCUDZUYLHUEZUFUDZUXKXSUDZUXRUYHUXKVDTZUYOVDTZUXKUYPRUYDUYQUVHUXOV
          NVDUXGJBUOUOCGWPIUEZUCUDUYSHUEUFUDBWPGJPXTYAYBZUYHUYMVDTZUYNVDTZUYRUY
          HCVDTZUYLVDTZVUAAVUCUVGUYDUXOLYCZUYHDVDTZUYLDTVUDAVUFUVGUYDUXOMYCUYHU
          VPDUYLAUVPDRUVGUYDUXOUWDYCUYHUXGUVITUYLUVPTUYHUXNUVIUXGUYEUXOWCUYDUXG
          UXNTUVHUXOUXGVNYDYBYEUVIUVPUXGIUVPVAINYFYAVKYEZDUYLYGVQCUYLYHVQUYHVUC
          UYNCTVUBVUEUYHDCUYLHAUWAUVGUYDUXOUWCYCVUGWMCUYNYGVQUYMUYNYIVQZUXKUYOY
          JVQUYHAUYDUXRUYPUHZAUVGUYDUXOYKUVHUYDUXOYMABCDFGHIJUXGKLMNOPYNVQZYOUX
          LUYKUXSUVDUXKUXRXNYPVKYQYRYSUYHUYGUXSUXMUYEUXOUYGUXSUYEUXOUYGULZULZUV
          DUYPUXRVULUVDUYOUYPVULUYMUVBUYNUVCUFVULUYLECUCVULUVLIUEZUYLEVULUVLUXG
          IUYEUXOUYGXQYTUVHVUMEUHZUYDVUKUVHUVQUWHVUNUWGUWKUVIUVPEIUUBVQUUAUUCZU
          UDVULUYLEHVUOYTUUEUYEUXOUYOUYPRZUYGUYHUYRUYQVUPVUHUYTUYOUXKUUFVQYQUUG
          UYEUXOVUIUYGVUJYQYOYSUUKUULUUHUUIUUJYPUUMUUNUUOUUPAUVEUVJUHUVGABCDFGH
          IJKLMNOPUUQVSYOAUVFSUVEAUVBVDTZUVFSUHAVUCEVDTZVUQLAVUFUWIVURMQDEYGVQC
          EYHVQUVBUURVKUVEUVAUUSUUT $.
      $}

      cantnflt.a $e |- ( ph -> (/) e. A ) $.
      cantnflt.1 $e |- ( ph -> K e. suc dom G ) $.
      cantnflt.2 $e |- ( ph -> C e. On ) $.
      cantnflt.3 $e |- ( ph -> ( G " K ) C_ C ) $.
      $( An upper bound on the partial sums of the ` CNF ` function.  Since
         each term dominates all previous terms, by induction we can bound the
         whole sum with any exponent ` A ^o C ` where ` C ` is larger than any
         exponent ` ( G `` x ) , x e. K ` which has been summed so far.
         (Contributed by Mario Carneiro, 28-May-2015.) $)
      cantnflt $p |- ( ph -> ( H ` K ) e. ( A ^o C ) ) $=
        ( vx vy c0 wceq cfv coe co wcel cv csuc com wrex con0 oen0 syl21anc cvv
        fveq2 0ex comu coa cmpt2 seqom0g ax-mp syl6eq eleq1d syl5ibrcom wa word
        wss adantr eloni syl cima cdm wfn ccnv c1o cdif wf cep oif mp1i wb oicl
        ffn ordsuc mpbi ordelon sylancr ordsssuc sylancl mpbird sucid syl5eleqr
        vex simprr fnfvima syl3anc sseldd ordsucss sylc wi cnvimass cfn cantnfs
        mpbid simpld fdm syl5sseq onss sstrd eqeltrrd ffvelrni suceloni oewordi
        syl31anc fveq2d simprl eleq1 suceq oveq2d eleq12d imbi12d sselda sylan2
        mpd ffvelrnd onelon syl2anc oecl cantnfsuc omcl oesuc ad2antrr ad2antrl
        3eltr4d wbr epelc peano2 ordsucelsuc sylibr simpl omord2 peano1 a1i oa0
        oveq2i syl5eq eqtrd ex wtr ordtr trsuc mpan imim1i sseqtr4d sucex mpbir
        wiso wwe ssexd cantnfcl oiiso isorel syl12anc mpbii fvex sylib ad2antlr
        omwordi cantnfvalf oaord omsuc exp32 a2d expcom finds2 syl3c rexlimdvaa
        syl5 eqeltrd wo simprd elnn nn0suc mpjaod ) AKUDUEZKJUFZCEUGUHZUIZKUBUJ
        ZUKZUEZUBULUMZAUWKUWHUDUWJUIZACUNUIZEUNUIZUDCUIZUWPMTRCEUOUPUWHUWIUDUWJ
        UWHUWIUDJUFZUDKUDJURUDUQUIUWTUDUEUSGBUQUQCGUJIUFZUGUHUXAHUFUTUHZBUJZVAU
        HVBJUDQVCVDZVEVFVGAUWNUWKUBULAUWLULUIZUWNVHZVHZCUWLIUFZUKZUGUHZUWJUWIUX
        GUXIEVJZUXJUWJVJZUXGEVIZUXHEUIUXKUXGUWRUXMAUWRUXFTVKZEVLVMUXGIKVNZEUXHA
        UXOEVJUXFUAVKUXGIIVOZVPZKUXPVJZUWLKUIUXHUXOUIUXPHVQUQVRVSZVNZIVTUXQUXGU
        XTWAIOWBZUXPUXTIWFWCAUXRUXFAUXRKUXPUKZUIZSAKUNUIZUXPVIZUXRUYCWDAUYBVIZU
        YCUYDUYEUYFUXTWAIOWEZUXPWGWHSUYBKWIWJUYGKUXPWKWLWMVKUXGUWLUWMKUWLUBWPWN
        AUXEUWNWQZWOUXPKIUWLWRWSWTUXHEXAXBUXGUXIUNUIZUWRUWQUWSUXKUXLXCUXGUXHUNU
        IUYIUXGUXTUNUXHAUXTUNVJZUXFAUXTDUNAHVOZUXTDHUXSXDADCHVTZUYKDUEAUYLUXTXE
        UIZAHFUIUYLUYMVHPACDFHLMNXFXGXHZDCHXIVMXJZADUNUIDUNVJNDXKVMXLZVKUXGUWLU
        XPUIZUXHUXTUIUXGUWMUYBUIZUYQUXGKUWMUYBUYHAUYCUXFSVKXMUYEUYQUYRWDUYGUWLU
        XPUUAVDUUBZUXPUXTUWLIUYAXNVMWTUXHXOVMUXNAUWQUXFMVKAUWSUXFRVKUXIECXPXQYG
        UXGUWIUWMJUFZUXJUXGKUWMJUYHXRUXGUXEAUYQUYTUXJUIZAUXEUWNXSAUXFUUCUYSUYQV
        UAXCUDUXPUIZUDUKZJUFZCUDIUFZUKZUGUHZUIZXCUCUJZUXPUIZVUIUKZJUFZCVUIIUFZU
        KZUGUHZUIZXCZVUKUXPUIZVUKUKZJUFZCVUKIUFZUKZUGUHZUIZXCZAUBUCUWLUDUEZUYQV
        UBVUAVUHUWLUDUXPXTVVFUYTVUDUXJVUGVVFUWMVUCJUWLUDYAXRVVFUXIVUFCUGVVFUXHV
        UEUEUXIVUFUEUWLUDIURUXHVUEYAVMYBYCYDUWLVUIUEZUYQVUJVUAVUPUWLVUIUXPXTVVG
        UYTVULUXJVUOVVGUWMVUKJUWLVUIYAXRVVGUXIVUNCUGVVGUXHVUMUEUXIVUNUEUWLVUIIU
        RUXHVUMYAVMYBYCYDUWLVUKUEZUYQVURVUAVVDUWLVUKUXPXTVVHUYTVUTUXJVVCVVHUWMV
        USJUWLVUKYAXRVVHUXIVVBCUGVVHUXHVVAUEUXIVVBUEUWLVUKIURUXHVVAYAVMYBYCYDAV
        UBVUHAVUBVHZCVUEUGUHZVUEHUFZUTUHZVVJCUTUHZVUDVUGVVIVVKCUIZVVLVVMUIZVVID
        CVUEHAUYLVUBUYNVKVUBAVUEUXTUIZVUEDUIUXPUXTUDIUYAXNZAUXTDVUEUYOYEYFYHZVV
        IVVKUNUIZUWQVVJUNUIZUDVVJUIZVVNVVOWDVVIUWQVVNVVSAUWQVUBMVKZVVRCVVKYIYJZ
        VWBVVIUWQVUEUNUIZVVTVWBVUBAVVPVWDVVQAUXTUNVUEUYPYEYFZCVUEYKYJZVVIUWQVWD
        UWSVWAVWBVWEAUWSVUBRVKCVUEUOUPVVKCVVJUUDXQXGVVIVUDVVLUWTVAUHZVVLVUBAUDU
        LUIZVUDVWGUEVWHVUBUUEUUFABCDFGHIJUDLMNOPQYLYFVVIVWGVVLUDVAUHZVVLUWTUDVV
        LVAUXDUUHVVIVVLUNUIZVWIVVLUEVVIVVTVVSVWJVWFVWCVVJVVKYMYJVVLUUGVMUUIUUJV
        VIUWQVWDVUGVVMUEVWBVWECVUEYNYJYQUUKAVUIULUIZVUQVVEXCVUQVURVUPXCAVWKVHZV
        VEVURVUJVUPUXPUULZVURVUJUYEVWMUYGUXPUUMVDUXPVUIUUNUUOZUUPVWLVURVUPVVDVW
        LVURVUPVVDVWLVURVUPVHZVHZCVVAUGUHZVVAHUFZUKZUTUHZVVCVUTVWPVWTVWQCUTUHZV
        VCVWPVWSCVJZVWTVXAVJZVWPCVIZVWRCUIZVXBVWPUWQVXDAUWQVWKVWOMYOZCVLVMVWPDC
        VVAHAUYLVWKVWOUYNYOVWPUXTDVVAAUXTDVJVWKVWOUYOYOVURVVAUXTUIVWLVUPUXPUXTV
        UKIUYAXNYPZWTYHZVWRCXAXBVWPVWSUNUIZUWQVWQUNUIZVXBVXCXCVWPVWRUNUIZVXIVWP
        UWQVXEVXKVXFVXHCVWRYIYJZVWRXOVMVXFVWPUWQVVAUNUIZVXJVXFVWPUXTUNVVAAUYJVW
        KVWOUYPYOZVXGWTZCVVAYKYJZVWSCVWQUVKWSYGVWPUWQVXMVVCVXAUEVXFVXOCVVAYNYJU
        UQVWPVWQVWRUTUHZVULVAUHZVXQVWQVAUHZVUTVWTVWPVULVWQUIZVXRVXSUIZVWPVUOVWQ
        VULVWPVUNVVAVJZVUOVWQVJZVWPVVAVIZVUMVVAUIZVYBVWPVXMVYDVXOVVAVLVMVWPVUMV
        VAWAYRZVYEVWPVUIVUKWAYRZVYFVYGVUIVUKUIVUIUCWPZWNVUIVUKVUIVYHUURYSUUSVWP
        UXPUXTWAWAIUUTZVUJVURVYGVYFWDAVYIVWKVWOAUXTUQUIUXTWAUVAZVYIAUXTDUNNUYOU
        VBAVYJUXPULUIZACDFHILMNOPUVCZXHUXTWAIUQOUVDYJYOVURVUJVWLVUPVWNYPZVWLVUR
        VUPXSUXPUXTVUIVUKWAWAIUVEUVFUVGVUMVVAVUKIUVHYSUVIVUMVVAXAXBVWPVUNUNUIZV
        XMUWQUWSVYBVYCXCVWPVUMUNUIVYNVWPUXTUNVUMVXNVWPVUJVUMUXTUIVYMUXPUXTVUIIU
        YAXNVMWTVUMXOVMVXOVXFAUWSVWKVWORYOVUNVVACXPXQYGVWLVURVUPWQWTVWPVULUNUIZ
        VXJVXQUNUIZVXTVYAWDVWPVUKULUIZVYOVWKVYQAVWOVUIYTZUVJULUNVUKJBUQUQUXBUXC
        GJQUVLXNVMVXPVWPVXJVXKVYPVXPVXLVWQVWRYMYJVULVWQVXQUVMWSXGVWLVUTVXRUEZVW
        OVWKAVYQVYSVYRABCDFGHIJVUKLMNOPQYLYFVKVWPVXJVXKVWTVXSUEVXPVXLVWQVWRUVNY
        JYQWTUVOUVPUWAUVQUVRUVSUWBWTUVTAKULUIZUWHUWOUWCAUYCUYBULUIZVYTSAVYKWUAA
        VYJVYKVYLUWDUXPYTVMKUYBUWEYJUBKUWFVMUWG $.
    $}

    ${
      cantnflt2.4 $e |- ( ph -> F e. S ) $.
      cantnflt2.5 $e |- ( ph -> (/) e. A ) $.
      cantnflt2.6 $e |- ( ph -> C e. On ) $.
      cantnflt2.7 $e |- ( ph -> ( `' F " ( _V \ 1o ) ) C_ C ) $.
      $( An upper bound on the ` CNF ` function.  (Contributed by Mario
         Carneiro, 28-May-2015.) $)
      cantnflt2 $p |- ( ph -> ( ( A CNF B ) ` F ) e. ( A ^o C ) ) $=
        ( vk vz co cfv cvv cep wcel ccnf ccnv c1o cdif cima coi cdm cv coe comu
        coa cmpt2 c0 cseqom eqid cantnfval con0 csuc oion sucidg 3syl wiso wf1o
        ssexd wfo wceq wwe com cantnfcl simpld oiiso syl2anc isof1o f1ofo foima
        4syl eqsstrd cantnflt eqeltrd ) AFBCUAPQFUBRUCUDUEZSUFZUGZNORRBNUHWAQZU
        IPWCFQUJPOUHUKPULUMUNZQBDUIPAOBCENFWAWDGHIWAUOZJWDUOZUPAOBCDENFWAWDWBGH
        IWEJWFKAVTRTZWBUQTWBWBURTAVTDUQLMVDZVTSWARWEUSWBUQUTVALAWAWBUEZVTDAWBVT
        SSWAVBZWBVTWAVCWBVTWAVEWIVTVFAWGVTSVGZWJWHAWKWBVHTABCEFWAGHIWEJVIVJVTSW
        ARWEVKVLWBVTSSWAVMWBVTWAVNWBVTWAVOVPMVQVRVS $.
    $}

    $( The ` CNF ` function is a function from finitely supported functions
       from ` B ` to ` A ` , to the ordinal exponential ` A ^o B ` .
       (Contributed by Mario Carneiro, 28-May-2015.) $)
    cantnff $p |- ( ph -> ( A CNF B ) : S --> ( A ^o B ) ) $=
      ( vf vk vz cv cvv c1o cfv coe co c0 wcel wceq adantr vx vh ccnv cdif cima
      vg cep coi cdm comu coa cmpt2 cseqom csb ccnf wa fvex csbex a1i cmap crab
      cfn cmpt eqid cantnffval cantnfdm syl5eq mpteq1d con0 simpr cantnfval cen
      eqtr4d wbr wwe vex cnvex imaexg com cantnfcl simpld oien sylancr cnvimass
      ax-mp wss cantnfs simprbda fdm syl syl5sseq feq3 syl5ibcom imp f00 simprd
      wf sylib sseq0 syl2anc breqtrd en0 fveq2d seqom0g mp1i 3eqtrd el1o sylibr
      0ex oveq2d oe0 eqtrd eleqtrrd wne wb on0eln0 biimpar cantnflt2 pm2.61dane
      fmpt2d ) AHUADUBHKZUCLMUDZUEUGUHZUBKZUIZIJLLBIKZYDNZOPYGYANUJPJKZUKPULQUM
      ZNZUNZBCOPZBCUOPZLYKLRAYADRUPUBYCYJYEYIUQURUSAYMHUFKUCYBUEVBRUFBCUTPVAZYK
      VCHDYKVCAJBCYNHUFUBIYNVDZFGVEAHDYNYKADYMUIYNEABCYNUFYOFGVFVGVHVMAUAKZDRZU
      PZYPYMNZYLRBQYRBQSZUPZYSMYLUUAYSQSYSMRUUAYSYPUCZYBUEZUGUHZUIZIJLLBYFUUDNZ
      OPUUFYPNUJPYHUKPULZQUMZNZQUUHNZQYRYSUUISYTYRJBCDIYPUUDUUHEABVIRZYQFTZACVI
      RZYQGTZUUDVDZAYQVJZUUHVDZVKTUUAUUEQUUHUUAUUEQVLVNUUEQSUUAUUEUUCQVLYRUUEUU
      CVLVNZYTYRUUCLRZUUCUGVOZUURUUBLRUUSYPUAVPVQUUBYBLVRWEYRUUTUUEVSRYRBCDYPUU
      DEUULUUNUUOUUPVTWAUUCUGUUDLUUOWBWCTUUAUUCCWFZCQSZUUCQSYRUVAYTYRYPUIZUUCCY
      PYBWDYRCBYPWQZUVCCSAYQUVDUUCVBRABCDYPEFGWGWHZCBYPWIWJWKZTUUAYPQSZUVBUUACQ
      YPWQZUVGUVBUPYRYTUVHYRUVDYTUVHUVEBQCYPWLWMWNCYPWOWRWPZUUCCWSWTXAUUEXBWRXC
      QLRUUJQSUUAXIUUGUUHQUUQXDXEXFYSXGXHUUAYLBQOPZMUUACQBOUVIXJUUAUUKUVJMSYRUU
      KYTUULTBXKWJXLXMYRBQXNZUPBCCDYPEYRUUKUVKUULTYRUUMUVKUUNTZYRYQUVKUUPTYRQBR
      ZUVKYRUUKUVMUVKXOUULBXPWJXQUVLYRUVAUVKUVFTXRXSXT $.

    ${
      cantnf0.1 $e |- ( ph -> (/) e. A ) $.
      $( The value of the zero function.  (Contributed by Mario Carneiro,
         30-May-2015.) $)
      cantnf0 $p |- ( ph -> ( ( A CNF B ) ` ( B X. { (/) } ) ) = (/) ) $=
        ( vk vz c0 co cfv cvv c1o cep coi eqid wcel wceq csn cxp ccnf ccnv cdif
        cima cdm cv coe comu coa cmpt2 cseqom wf cfn fconst6g syl 0lt1o disjdif
        cin mp1i fimacnvdisj sylancl syl6eqel cantnfs mpbir2and cantnfval oieq2
        0fin dmeqd cen wbr wwe 0ex we0 oien mp2an en0 mpbi syl6eq fveq2d 3eqtrd
        seqom0g ) ACKUAUBZBCUCLMWDUDNOUEZUFZPQZUGZIJNNBIUHWGMZUILWIWDMUJLJUHUKL
        ULZKUMZMKWKMZKAJBCDIWDWGWKEFGWGRAWDDSCBWDUNZWFUOSAKBSWMHCKBUPUQAWFKUOAC
        OWDUNZOWEUTKTWFKTZKOSWNAURCKOUPVAONUSCOWEWDVBVCZVIVDABCDWDEFGVEVFWKRZVG
        AWHKWKAWHKPQZUGZKAWGWRAWOWGWRTWPWFKPVHUQVJWSKVKVLZWSKTKNSZKPVMWTVNPVOKP
        WRNWRRVPVQWSVRVSVTWAXAWLKTAVNWJWKKWQWCVAWB $.
    $}

    ${
      cantnfres.5 $e |- ( ph -> D e. On ) $.
      cantnfres.6 $e |- ( ph -> B C_ D ) $.
      cantnfres.7 $e |- ( ( ph /\ n e. ( D \ B ) ) -> X = (/) ) $.
      $( The support of an extended function is the same as the original.
         (Contributed by Mario Carneiro, 25-May-2015.) $)
      cantnfreslem $p |- ( ph -> ( `' ( n e. B |-> X ) " ( _V \ 1o ) ) =
                                 ( `' ( n e. D |-> X ) " ( _V \ 1o ) ) ) $=
        ( cvv c1o cdif wcel crab cmpt wa ccnv cima cv cab sseld anim1d wn eldif
        wceq sylan2br expr el1o elndif sylbir syl6 con4d impr simprr jca impbid
        c0 ex abbidv df-rab 3eqtr4g eqid mptpreima ) AGNOPZQZFCRZVIFDRZFCGSZUAV
        HUBFDGSZUAVHUBAFUCZCQZVITZFUDVNDQZVITZFUDVJVKAVPVRFAVPVRAVOVQVIACDVNLUE
        UFAVRVPAVRTVOVIAVQVIVOAVQTZVOVIVSVOUGZGVAUIZVIUGZAVQVTWAVQVTTAVNDCPQWAV
        NDCUHMUJUKWAGOQWBGULGONUMUNUOUPUQAVQVIURUSVBUTVCVIFCVDVIFDVDVEFCGVHVLVL
        VFVGFDGVHVMVMVFVGVE $.

      cantnfres.8 $e |- ( ph -> (/) e. A ) $.
      cantnfres.9 $e |- T = dom ( A CNF D ) $.
      $( A function is finitely supported from ` B ` to ` A ` iff the extended
         function is finitely supported from ` D ` to ` A ` .  (Contributed by
         Mario Carneiro, 25-May-2015.) $)
      cantnfrescl $p |- ( ph ->
        ( ( n e. B |-> X ) e. S <-> ( n e. D |-> X ) e. T ) ) $=
        ( cfn wcel wa wral cmpt wf ccnv cvv c1o cdif cima cun cv adantr eqeltrd
        c0 ralrimiva biantrud ralunb syl6bbr wss wceq undif sylib raleqdv bitrd
        eqid fmpt 3bitr3g cantnfreslem eleq1d anbi12d cantnfs 3bitr4d ) ACBGCHU
        AZUBZVKUCUDUEUFZUGZQRZSDBGDHUAZUBZVPUCVMUGZQRZSVKERVPFRAVLVQVOVSAHBRZGC
        TZVTGDTZVLVQAWAVTGCDCUFZUHZTZWBAWAWAVTGWCTZSWEAWFWAAVTGWCAGUIWCRZSHULBN
        AULBRWGOUJUKUMUNVTGCWCUOUPAVTGWDDACDUQWDDURMCDUSUTVAVBGCBHVKVKVCVDGDBHV
        PVPVCVDVEAVNVRQABCDEGHIJKLMNVFVGVHABCEVKIJKVIABDFVPPJLVIVJ $.

      $d k z T $.
      cantnfres.10 $e |- ( ph -> ( n e. B |-> X ) e. S ) $.
      $( The ` CNF ` function respects extensions of the domain to a larger
         ordinal.  (Contributed by Mario Carneiro, 25-May-2015.) $)
      cantnfres $p |- ( ph -> ( ( A CNF B ) ` ( n e. B |-> X ) ) =
                              ( ( A CNF D ) ` ( n e. D |-> X ) ) ) $=
        ( vk vz wceq cmpt ccnv cvv c1o cdif cima cep coi cdm con0 cv cfv coe co
        comu coa cmpt2 c0 cseqom ccnf wcel w3a cantnfreslem syl fveq1d 3ad2ant1
        oveq2d cres crab eqid mptpreima ssrab2 eqsstri ffvelrni sseldi 3ad2ant2
        oieq2 oif fvres wss resmpt fveq2d 3eqtr3d oveq12d oveq1d dmeqd mpt2eq12
        mpt2eq3dva sylancl eqtrd seqomeq12 fveq12d cantnfval2 cantnfrescl mpbid
        3eqtr4d ) AGCHUAZUBUCUDUEZUFZUGUHZUIZRSXAUJBRUKZWTULZUMUNZXCWQULZUOUNZS
        UKZUPUNZUQZURUSZULGDHUAZUBWRUFZUGUHZUIZRSXNUJBXBXMULZUMUNZXOXKULZUOUNZX
        GUPUNZUQZURUSZULWQBCUTUNULXKBDUTUNULAXAXNXJYAAXIXTTURURTXJYATAXIRSXAUJX
        SUQZXTARSXAUJXHXSAXBXAVAZXGUJVAZVBZXFXRXGUPYEXDXPXEXQUOYEXCXOBUMAYCXCXO
        TYDAXBWTXMAWSXLTWTXMTABCDEGHIJKLMNVCWSXLUGVQVDZVEVFZVGYEXCXKCVHZULZXCXK
        ULZXEXQYEXCCVAZYIYJTYCAYKYDYCWSCXCWSHWRVAZGCVICGCHWRWQWQVJVKYLGCVLVMXAW
        SXBWTWSUGWTWTVJZVRVNVOVPXCCXKVSVDYEXCYHWQYECDVTZYHWQTAYCYNYDMVFGDCHWAVD
        VEYEXCXOXKYGWBWCWDWEWHAXAXNTUJUJTYBXTTAWTXMYFWFZUJVJRSXAUJXNUJXSWGWIWJU
        RVJXIXTURURWKWIYOWLASBCERWQWTRSUCUCXHUQURUSZIJKYMQYPVJWMASBDFRXKXMRSUCU
        CXSUQURUSZPJLXMVJAWQEVAXKFVAQABCDEFGHIJKLMNOPWNWOYQVJWMWP $.
    $}

    ${
      cantnfp1.4 $e |- ( ph -> G e. S ) $.
      cantnfp1.5 $e |- ( ph -> X e. B ) $.
      cantnfp1.6 $e |- ( ph -> Y e. A ) $.
      cantnfp1.7 $e |- ( ph -> ( `' G " ( _V \ 1o ) ) C_ X ) $.
      cantnfp1.f $e |- F = ( t e. B |-> if ( t = X , Y , ( G ` t ) ) ) $.
      $( Lemma for ~ cantnfp1 .  (Contributed by Mario Carneiro,
         20-Jun-2015.) $)
      cantnfp1lem1 $p |- ( ph -> F e. S ) $=
        ( wcel cvv wceq vk wf ccnv c1o cdif cima cfn cv cfv cif wa adantr mpbid
        cantnfs simpld ffvelrnda ifcl syl2anc fmptd csn cun simprd snfi sylancl
        wss unfi df1o2 difeq2i imaeq2i eldifi adantl ifexg eqeq1 fveq2 ifbieq2d
        c0 fvex fvmptg wn eldifn elsn elun2 sylbir nsyl iffalse syl ssun1 sscon
        ax-mp eqimss2 mp1i suppssr sylan2 3eqtrd suppss syl5eqss ssfi mpbir2and
        sseli ) AFERDCFUBFUCZSUDUEZUFZUGRZABDBUHZHTZIXDGUIZUJZCFAXDDRZUKICRZXFC
        RXGCRAXIXHOULADCXDGADCGUBZGUCZXAUFZUGRZAGERXJXMUKMACDEGJKLUNUMZUOZUPXEI
        XFCUQURQUSZAXLHUTZVAZUGRZXBXRVEXCAXMXQUGRXSAXJXMXNVBHVCXLXQVFVDAXBWTSVP
        UTZUEZUFXRXAYAWTUDXTSVGVHZVIADCUAFXRVPXPAUAUHZDXRUEZRZUKZYCFUIZYCHTZIYC
        GUIZUJZYIVPYFYCDRZYJSRZYGYJTYEYKAYCDXRVJVKYFXIYISRYLAXIYEOULYCGVQYHIYIC
        SVLVDBYCXGYJDSFXDYCTXEYHXFYIIXDYCHVMXDYCGVNVOQVRURYFYHVSYJYITYFYCXRRZYH
        YEYMVSAYCDXRVTVKYHYCXQRYMUAHWAYCXQXLWBWCWDYHIYIWEWFYEAYCDXLUEZRYIVPTYDY
        NYCXLXRVEYDYNVEXLXQWGXLXRDWHWIWSADCGXLYCVPXOXLXKYAUFZTYOXLVEAXAYAXKYBVI
        YOXLWJWKWLWMWNWOWPXRXBWQURACDEFJKLUNWR $.

      ${
        cantnfp1.8 $e |- ( ph -> (/) e. Y ) $.
        cantnfp1.o $e |- O = OrdIso ( _E , ( `' F " ( _V \ 1o ) ) ) $.
        $( Lemma for ~ cantnfp1 .  (Contributed by Mario Carneiro,
           28-May-2015.) $)
        cantnfp1lem2 $p |- ( ph -> dom O = suc U. dom O ) $=
          ( cdm cuni wceq wn csuc c0 wlim wo ccnv cvv c1o cdif cima wcel cfv cv
          wne cif iftrue fvmptg syl2anc con0 wb onelon on0eln0 syl eqnetrd fvex
          mpbid dif1o mpbiran sylibr wf wfn adantr cfn cantnfs simpld ffvelrnda
          wa ifcl fmptd ffn elpreima mpbir2and n0i cen wbr cep wwe cnvimass fdm
          3syl syl5sseq ssexd com cantnfp1lem1 cantnfcl oien breq1 ensymb bitri
          syl6bb syl5ibcom mtod simprd nnlim ioran sylanbrc word unizlim mtbird
          en0 nnord orduniorsuc ord mpd ) AHUAZXRUBZUCZUDXRXSUEUCZAXTXRUFUCZXRU
          GZUHZAYBUDYCUDZYDUDAYBFUIUJUKULZUMZUFUCZAIYGUNZYHUDAYIIDUNZIFUOZYFUNZ
          OAYKUFUQZYLAYKJUFAYJJCUNZYKJUCOPBIBUPZIUCZJYOGUOZURZJDCFYPJYQUSRUTVAA
          UFJUNZJUFUQZSAJVBUNZYSYTVCACVBUNYNUUALPCJVDVAJVEVFVIVGYLYKUJUNYMIFVHY
          KUJVJVKVLADCFVMZFDVNYIYJYLVTVCABDYRCFAYODUNZVTYNYQCUNYRCUNAYNUUCPVOAD
          CYOGADCGVMZGUIYFUMVPUNZAGEUNUUDUUEVTNACDEGKLMVQVIVRVSYPJYQCWAVARWBZDC
          FWCDIYFFWDWMWEYGIWFVFAXRYGWGWHZYBYHAYGUJUNYGWIWJZUUGAYGDVBMAFUAZYGDFY
          FWKAUUBUUIDUCUUFDCFWLVFWNWOAUUHXRWPUNZACDEFHKLMTABCDEFGIJKLMNOPQRWQWR
          ZVRYGWIHUJTWSVAYBUUGUFYGWGWHZYHXRUFYGWGWTUULYGUFWGWHYHUFYGXAYGXMXBXCX
          DXEAUUJYEAUUHUUJUUKXFZXRXGVFYBYCXHXIAUUJXRXJZXTYDVCUUMXRXNZXRXKWMXLAX
          TYAAUUJUUNXTYAUHUUMUUOXRXOWMXPXQ $.

        cantnfp1.h $e |- H = seqom ( ( k e. _V , z e. _V |->
          ( ( ( A ^o ( O ` k ) ) .o ( F ` ( O ` k ) ) ) +o z ) ) , (/) ) $.
        cantnfp1.k $e |- K = OrdIso ( _E , ( `' G " ( _V \ 1o ) ) ) $.
        cantnfp1.m $e |- M = seqom ( ( k e. _V , z e. _V |->
          ( ( ( A ^o ( K ` k ) ) .o ( G ` ( K ` k ) ) ) +o z ) ) , (/) ) $.
        $( Lemma for ~ cantnfp1 .  (Contributed by Mario Carneiro,
           28-May-2015.) $)
        cantnfp1lem3 $p |- ( ph -> ( ( A CNF B ) ` F ) =
            ( ( ( A ^o X ) .o Y ) +o ( ( A CNF B ) ` G ) ) ) $=
          ( vx vy cfv cdm csuc coe comu coa cantnfval fveq2d com wcel wceq ccnv
          co cvv c1o cdif cima cep wwe cantnfcl simprd sylibr cantnfsuc wo wf1o
          wn wss wf wiso cnvimass cv cif wa adantr mpbid simpld syl2anc fdm syl
          con0 syl5sseq 3syl c0 wne fvmptg wb onelon fvex dif1o mpbiran wfn ffn
          elpreima word sylancr wbr epelc eleq2d sseld wi ffvelrni sseldd eloni
          csn oif ordirr syl5ibrcom cun imaeq2i eldifi adantl ifexg sylancl weq
          syld eqeq1 fveq2 ifbieq2d iffalse ax-mp sylib eqtrd oveq12d a1i eleq1
          eqtr3d eqeq12d imbi12d imbi2d syldan ccnf cantnfp1lem1 eqeltrrd mpdan
          cuni cantnfp1lem2 peano2b cfn ffvelrnda ifcl fmptd ssexd oiiso isof1o
          cantnfs f1ocnv f1of iftrue on0eln0 eqnetrd mpbir2and ffvelrnd elssuni
          oicl ordelon ontri1 sucidg eleqtrrd isorel syl12anc 3bitr3g f1ocnvfv2
          nnon bitrd mtbid onss sstrd ordn2lp imnan elsni notbid difeq2i eldifn
          df1o2 elsn elun2 sylbir nsyl ssun1 sscon sseli eqimss2 suppssr sylan2
          mp1i 3eqtrd suppss syl5eqss elun mpjaod ioran sylanbrc ordtri3 mpbird
          oveq2d cres nnord sssucid syl5sseqr f1ofo foima fnsnfv sneqd difeq12d
          wfo cin disjsn disj3 difun2 syl6eqr df-suc syl6eq difeq1d eqtr4d wfun
          imaeq2d dff1o3 simprbi imadif ssneldd sylbird syl5bir necon1bd eqeq1d
          mpand mpd ssid syl5ibcom pm2.61d 3sstr4g reldisj uncom syl6sseq eqssd
          ssundif 3eqtr4rd isores3 syl3anc wse epse oieu mpbi2and cmpt2 seqom0g
          0ex wtr ordtr trsuc sylan imim1d oveq2 elnn ancoms fveq1d ordsucelsuc
          biimpa fvres eleqtrd nelneq 3eqtr3rd oveq1d syl5ibr a2d finds 3eqtr4d
          ex a2i mpcom ) AHDEUUAVCZUKMULZJUKVVTUUEZUMZJUKZDNUNVCZOUOVCZIVVSUKZU
          PVCZABDEFGHMJPQRUEACDEFHINOPQRSTUAUBUCUUBZUFUQAVVTVWBJACDEFHIMNOPQRST
          UAUBUCUDUEUUFZURAVWCDVWAMUKZUNVCZVWJHUKZUOVCZVWAJUKZUPVCZVWGAVWAUSUTZ
          VWCVWOVAAVWBUSUTVWPAVVTVWBUSVWIAHVBZVDVEVFZVGZVHVIZVVTUSUTZADEFHMPQRU
          EVWHVJZVKZUUCVWAUUGVLZABDEFGHMJVWAPQRUEVWHUFVMUUDAVWMVWEVWNVWFUPAVWKV
          WDVWLOUOAVWJNDUNAVWJNVAZVWJNUTZNVWJUTZVNVPZAVXFVPVXGVPZVXHAVWANMVBZUK
          ZUTZVXFAVXKVWAVQZVXLVPZAVXKVVTUTZVXMAVWSVVTNVXJAVVTVWSMVOZVWSVVTVXJVO
          VWSVVTVXJVRAVVTVWSVHVHMVSZVXPAVWSVDUTVWTVXQAVWSEWJRAHULZVWSEHVWRVTAED
          HVRZVXREVAACECWAZNVAZOVXTIUKZWBZDHAVXTEUTZWCODUTZVYBDUTVYCDUTAVYEVYDU
          AWDAEDVXTIAEDIVRZIVBZVWRVGZUUHUTZAIFUTVYFVYIWCSADEFIPQRUUOWEWFZUUIVYA
          OVYBDUUJWGUCUUKZEDHWHWIWKZUULAVWTVXAVXBWFVWSVHMVDUEUUMWGZVVTVWSVHVHMU
          UNWIZVVTVWSMUUPVWSVVTVXJUUQWLANVWSUTZNEUTZNHUKZVWRUTZTAVYQWMWNZVYRAVY
          QOWMAVYPVYEVYQOVATUACNVYCOEDHVYAOVYBUURUCWOWGZAWMOUTZOWMWNZUDAOWJUTZW
          UAWUBWPADWJUTVYEWUCQUADOWQWGOUUSWIWEUUTVYRVYQVDUTVYSNHWRVYQVDWSWTVLAV
          XSHEXAVYOVYPVYRWCWPVYKEDHXBENVWRHXCWLUVAZUVBZVXKVVTUVCWIAVXKWJUTZVWAW
          JUTZVXMVXNWPAVVTXDZVXOWUFVWSVHMUEUVDWUEVVTVXKUVEXEAVWPWUGVXDVWAUVMWIV
          XKVWAUVFWGWEAVXLVWJVXKMUKZUTZVXFAVWAVXKVHXFZVWJWUIVHXFZVXLWUJAVXQVWAV
          VTUTZVXOWUKWULWPVYMAVWAVWBVVTAVWPVWAVWBUTVXDVWAUSUVGWIVWIUVHZWUEVVTVW
          SVWAVXKVHVHMUVIUVJVWAVXKNVXJWRXGVWJWUIVXKMWRXGUVKAWUINVWJAVXPVYOWUINV
          AVYNWUDVVTVWSNMUVLWGXHUVNUVOAVWJVYHUTZVXIVWJNXNZUTZAWUOVXFVXIAVYHNVWJ
          UBXIAVXFVXGWCVPZVXFVXIXJAVWJXDZWURAVWJWJUTWUSAVWSWJVWJAVWSEWJVYLAEWJU
          TZEWJVQREUVPWIUVQAWUMVWJVWSUTWUNVVTVWSVWAMVWSVHMUEXOZXKWIZXLVWJXMWIZV
          WJNUVRWIVXFVXGUVSVLYEAVXIWUQNNUTZVPZANXDZWVEANWJUTZWVFAWUTVYPWVGRTENW
          QWGNXMWIZNXPWIZWUQVXGWVDWUQVWJNNVWJNUVTXHUWAXQAVWJVYHWUPXRZUTWUOWUQVN
          AVWSWVJVWJAVWSVWQVDWMXNZVFZVGZWVJVWRWVLVWQVEWVKVDUWDUWBZXSZAEDGHWVJWM
          VYKAGWAZEWVJVFZUTZWCZWVPHUKZWVPNVAZOWVPIUKZWBZWWBWMWVSWVPEUTZWWCVDUTZ
          WVTWWCVAZWVRWWDAWVPEWVJXTYAWVSVYEWWBVDUTZWWEAVYEWVRUAWDWVPIWRZWWAOWWB
          DVDYBZYCCWVPVYCWWCEVDHCGYDVYAWWAVYBWWBOVXTWVPNYFVXTWVPIYGYHUCWOZWGWVS
          WWAVPZWWCWWBVAWVSWVPWVJUTZWWAWVRWWLVPAWVPEWVJUWCYAWWAWVPWUPUTWWLGNUWE
          WVPWUPVYHUWFUWGUWHWWAOWWBYIZWIWVRAWVPEVYHVFZUTWWBWMVAZWVQWWNWVPVYHWVJ
          VQWVQWWNVQVYHWUPUWIVYHWVJEUWJYJUWKAEDIVYHWVPWMVYJVYHVYGWVLVGZVAWWPVYH
          VQAVWRWVLVYGWVNXSZWWPVYHUWLUWOUWMUWNUWPUWQUWRZWVBXLVWJVYHWUPUWSYKUWTV
          XFVXGUXAUXBAWUSWVFVXEVXHWPWVCWVHVWJNUXCWGUXDZUXEAVWLVYQOAVWJNHWWSURVY
          TYLYMAVWALUKZKULZLUKVWNVWFAVWAWXALAVWAWXAVAZMVWAUXFZKVAZAVWAXDZVWAVYH
          VHVHWXCVSZWXBWXDWCZAVWPWXEVXDVWAUXGWIZAVXQVWAVVTVQVYHMVWAVGZVAWXFVYMA
          VWBVWAVVTVWAUXHVWIUXIAMVVTVGZMVWAXNZVGZVFZVWSWUPVFZWXIVYHAWXJVWSWXLWU
          PAVVTVWSMUXOZWXJVWSVAAVXPWXOVYNVVTVWSMUXJWIVVTVWSMUXKWIAVWJXNZWXLWUPA
          MVVTXAZWUMWXPWXLVAVVTVWSMVRWXQWVAVVTVWSMXBYJWUNVVTVWAMUXLXEAVWJNWWSUX
          MYPUXNAWXIMVVTWXKVFZVGZWXMAVWAWXRMAVWAVWAWXKXRZWXKVFZWXRAVWAVWAWXKVFZ
          WYAAVWAWXKUXPWMVAZVWAWYBVAAVWAVWAUTVPZWYCAWXEWYDWXHVWAXPWIVWAVWAUXQVL
          VWAWXKUXRYKVWAWXKUXSUXTAVVTWXTWXKAVVTVWBWXTVWIVWAUYAUYBUYCUYDUYFAVXPV
          XJUYEZWXSWXMVAVYNVXPWXOWYEVVTVWSMUYGUYHVVTWXKMUYIWLYLAVYHWXNAVYHWUPUX
          PWMVAZVYHWXNVQZANVYHUTZVPZWYFAVYHNNUBWVIUYJZVYHNUXQVLAVYHVWSVQWYFWYGW
          PAWWPWVMVYHVWSAEDGIWVMWMVYJAWVPEWVMVFUTZWCZWWAWWOWYLWWOWWANIUKZWMVAZA
          WYNWYKAWVEWYNWVIAWVDWYMWMWYMWMWNZWYMVWRUTZAWVDWYPWYMVDUTWYONIWRWYMVDW
          SWTAVYPWYPWVDTAVYPWYPWCZWYHWVDAIEXAZWYHWYQWPAVYFWYRVYJEDIXBWIENVWRIXC
          WIAVYHNNUBXIUYKUYOUYLUYMUYPWDWWAWWBWYMWMWVPNIYGUYNXQWYLWWCWMVAWWKWWOW
          YLWVTWWCWMWYLWWDWWEWWFWYKWWDAWVPEWVMXTYAWYLVYEWWGWWEAVYEWYKUAWDWWHWWI
          YCWWJWGAEDHWVMWVPWMVYKWVMWVMVQAWVMUYQYNUWMYPWWKWWCWWBWMWWMUYNUYRUYSUW
          QWWQWVOUYTVYHWUPVWSVUAWIWEAVWSWUPVYHXRZVQWXNVYHVQAVWSWVJWYSWWRVYHWUPV
          UBVUCVWSWUPVYHVUEYKVUDVUFVVTVWSVHVHMVWAVYHVUGVUHAVYHVHVIZVYHVHVUIWXEW
          XFWCWXGWPAWYTWXAUSUTADEFIKPQRUGSVJWFVYHVUJVYHVWAVHKWXCUGVUKYCVULZWFZU
          RAWUMVWNWWTVAZWUNVWPAWUMXUCXJZVXDAUIWAZVVTUTZXUEJUKZXUELUKZVAZXJZXJAW
          MVVTUTZWMJUKZWMVAZXJZXJAUJWAZVVTUTZXUOJUKZXUOLUKZVAZXJZXJZAXUOUMZVVTU
          TZXVBJUKZXVBLUKZVAZXJZXJZAXUDXJUIUJVWAXUEWMVAZXUJXUNAXVIXUFXUKXUIXUMX
          UEWMVVTYOXVIXUGXULXUHWMXUEWMJYGXVIXUHWMLUKZWMXUEWMLYGWMVDUTZXVJWMVAVU
          OGBVDVDDWVPKUKZUNVCXVLIUKUOVCBWAZUPVCVUMLWMUHVUNYJUYBYQYRYSUIUJYDZXUJ
          XUTAXVNXUFXUPXUIXUSXUEXUOVVTYOXVNXUGXUQXUHXURXUEXUOJYGXUEXUOLYGYQYRYS
          XUEXVBVAZXUJXVGAXVOXUFXVCXUIXVFXUEXVBVVTYOXVOXUGXVDXUHXVEXUEXVBJYGXUE
          XVBLYGYQYRYSXUEVWAVAZXUJXUDAXVPXUFWUMXUIXUCXUEVWAVVTYOXVPXUGVWNXUHWWT
          XUEVWAJYGXUEVWALYGYQYRYSXUNAXVKXUMXUKVUOGBVDVDDWVPMUKZUNVCXVQHUKUOVCX
          VMUPVCVUMJWMUFVUNUWOYNXVAXVHXJXUOUSUTZAXUTXVGAXUTXVCXUSXJXVGAXVCXUPXU
          SAXVCXUPAVVTVUPZXVCXUPAWUHXVSAVXAWUHVXCVVTUXGWIVVTVUQWIVVTXUOVURVUSZV
          VPVUTAXVCXUSXVFAXVCXUSXVFXJXUSXVFAXVCWCZDXUOMUKZUNVCZXWBHUKZUOVCZXUQU
          PVCZXWEXURUPVCZVAXUQXURXWEUPVVAXWAXVDXWFXVEXWGAXVCXVRXVDXWFVAAXVCXUPX
          VRXVTAVXAXUPXVRVXCXUPVXAXVRXUOVVTVVBVVCVUSYTZABDEFGHMJXUOPQRUEVWHUFVM
          YTXWAXVEDXUOKUKZUNVCZXWIIUKZUOVCZXURUPVCZXWGAXVCXVRXVEXWMVAXWHABDEFGI
          KLXUOPQRUGSUHVMYTXWAXWLXWEXURUPXWAXWJXWCXWKXWDUOXWAXWIXWBDUNXWAXUOWXC
          UKZXWIXWBAXWNXWIVAXVCAXUOWXCKAWXBWXDXUAVKVVDWDXWAXUOVWAUTZXWNXWBVAXWA
          XWOXVBVWBUTZAXVCXWPAVVTVWBXVBVWIXHVVFXWAWXEXWOXWPWPAWXEXVCWXHWDXUOVWA
          VVEWIUXDZXUOVWAMVVGWIYPZUXEXWAXWIHUKZXWINVAZOXWKWBZXWDXWKXWAXWIEUTXXA
          VDUTZXWSXXAVAXWAVYHEXWIAVYHEVQXVCAIULZVYHEIVWRVTAVYFXXCEVAVYJEDIWHWIW
          KWDXWAXUOWXAUTXWIVYHUTZXWAXUOVWAWXAXWQAWXBXVCXUBWDVVHWXAVYHXUOKVYHVHK
          UGXOXKWIZXLXWAVYEXWKVDUTXXBAVYEXVCUAWDXWIIWRXWTOXWKDVDYBYCCXWIVYCXXAE
          VDHVXTXWIVAVYAXWTVYBXWKOVXTXWINYFVXTXWIIYGYHUCWOWGXWAXWIXWBHXWRURXWAX
          WTVPZXXAXWKVAXWAXXDWYIXXFXXEAWYIXVCWYJWDXWINVYHVVIWGXWTOXWKYIWIVVJYMV
          VKYLYQVVLVVPVVMYEVVQYNVVNVVRUYPABDEFGIKLPQRUGSUHUQVVOYMYLUWP $.
      $}

      $( If ` F ` is created by adding a single term ` ( F `` X ) = Y ` to
         ` G ` , where ` X ` is larger than any element of the support of
         ` G ` , then ` F ` is also a finitely supported function and it is
         assigned the value ` ( ( A ^o X ) .o Y ) +o z ` where ` z ` is the
         value of ` G ` .  (Contributed by Mario Carneiro, 28-May-2015.) $)
      cantnfp1 $p |- ( ph -> ( F e. S /\ ( ( A CNF B ) ` F ) =
          ( ( ( A ^o X ) .o Y ) +o ( ( A CNF B ) ` G ) ) ) ) $=
        ( wcel co c0 vz vk ccnf cfv coe comu coa wceq wa cv cmpt cif eqeq1 con0
        wn word onelon syl2anc eloni ordirr 3syl wne cvv c1o cdif dif1o mpbiran
        fvex ccnv wf wfn wb cfn cantnfs mpbid simpld ffn elpreima sseld sylbird
        cima mpand syl5bir necon1bd mpd ad3antrrr simpr fveq2d simpllr 3eqtr4rd
        eqidd ifbothda mpteq2dva syl5eq feqmptd adantr eqeltrd cantnff ffvelrnd
        eqtr4d oecl syl oveq2 om0 sylan9eqr oveq1d jca wss cantnfp1lem1 cep coi
        oa0r cmpt2 cseqom on0eln0 biimpar eqid cantnfp1lem3 pm2.61dane ) AFERZF
        CDUCSZUDZCHUESZIUFSZGYAUDZUGSZUHZUIITAITUHZUIZXTYGYIFGEYIFBDBUJZGUDZUKZ
        GYIFBDYJHUHZIYKULZUKYLQYIBDYNYKYMIYKUHYKYKUHYNYKUHYIYJDRZUIZIYKIYNYKUMY
        KYNYKUMYPYMUIZHGUDZTYKIAYRTUHZYHYOYMAHHRZUOZYSAHUNRZHUPUUAADUNRZHDRZUUB
        LNDHUQURZHUSHUTVAAYTYRTYRTVBZYRVCVDVEZRZAYTUUHYRVCRUUFHGVHYRVCVFVGAUUDU
        UHYTNAUUDUUHUIZHGVIUUGWAZRZYTADCGVJZGDVKUUKUUIVLAUULUUJVMRZAGERZUULUUMU
        IMACDEGJKLVNVOVPZDCGVQDHUUGGVRVAAUUJHHPVSVTWBWCWDWEWFYQYJHGYPYMWGWHAYHY
        OYMWIWJYPYMUOUIYKWKWLWMWNAGYLUHYHABDCGUUOWOWPWTZAUUNYHMWPWQYITYEUGSZYEY
        FYBYIYEUNRZUUQYEUHAUURYHACDUESZUNRZYEUUSRUURACUNRZUUCUUTKLCDXAURAEUUSGY
        AACDEJKLWRMWSUUSYEUQURWPYEXLXBYIYDTYEUGYHAYDYCTUFSZTITYCUFXCAYCUNRZUVBT
        UHAUVAUUBUVCKUUECHXAURYCXDXBXEXFYIFGYAUUPWHWJXGAITVBZUIZXTYGUVEBCDEFGHI
        JAUVAUVDKWPZAUUCUVDLWPZAUUNUVDMWPZAUUDUVDNWPZAICRZUVDOWPZAUUJHXHUVDPWPZ
        QXIUVEUABCDEUBFGUBUAVCVCCUBUJZFVIUUGWAXJXKZUDZUESUVOFUDUFSUAUJZUGSXMTXN
        ZUUJXJXKZUBUAVCVCCUVMUVRUDZUESUVSGUDUFSUVPUGSXMTXNZUVNHIJUVFUVGUVHUVIUV
        KUVLQATIRZUVDAIUNRZUWAUVDVLAUVAUVJUWBKOCIUQURIXOXBXPUVNXQUVQXQUVRXQUVTX
        QXRXGXS $.
    $}

    oemapval.t $e |- T = { <. x , y >. | E. z e. B ( ( x ` z ) e. ( y ` z )
      /\ A. w e. B ( z e. w -> ( x ` w ) = ( y ` w ) ) ) } $.
    $( The relation ` T ` is a strict order on ` S ` (a corollary of
       ~ wemapso2 ).  (Contributed by Mario Carneiro, 28-May-2015.) $)
    oemapso $p |- ( ph -> T Or S ) $=
      ( vg wor cv ccnv wcel cep cfv cvv c1o cdif cima cfn cmap co crab con0 wwe
      word eloni ordwe weso 4syl cnvso sylib c0 wceq wi wral wa wrex copab fvex
      wbr epelc vex brcnv bitri imbi1i ralbii anbi12i rexbii opabbii eqtr4i csn
      epel cnveq imaeq1d difeq2i imaeq2i syl6eq eleq1d cbvrabv wemapso2 syl3anc
      df1o2 wb ccnf cdm eqid cantnfdm syl5eq soeq2 syl mpbird ) AHIOZNPZQZUAUBU
      CZUDZUERZNFGUFUGZUHZIOZAGUIRZGSQZOZFSOZXFLAGSOZXIAXGGUKGSUJXKLGULGUMGSUNU
      OGSUPUQAFUIRFUKFSUJXJKFULFUMFSUNUOBCDEGFXHSIXEUIURIDPZBPZTZXLCPZTZRZXLEPZ
      RZXRXMTXRXOTUSZUTZEGVAZVBZDGVCZBCVDXNXPSVFZXRXLXHVFZXTUTZEGVAZVBZDGVCZBCV
      DMYJYDBCYIYCDGYEXQYHYBXNXPXLXOVEVGYGYAEGYFXSXTYFXLXRSVFXSXRXLSEVHDVHVIDEV
      RVJVKVLVMVNVOVPXCXMQZUAURVQZUCZUDZUERNBXDWSXMUSZXBYNUEYOXBYKXAUDYNYOWTYKX
      AWSXMVSVTXAYMYKUBYLUAWHWAWBWCWDWEWFWGAHXEUSWRXFWIAHFGWJUGWKXEJAFGXENXEWLK
      LWMWNHXEIWOWPWQ $.

    ${
      oemapval.3 $e |- ( ph -> F e. S ) $.
      oemapval.4 $e |- ( ph -> G e. S ) $.
      $( Value of the relation ` T ` .  (Contributed by Mario Carneiro,
         28-May-2015.) $)
      oemapval $p |- ( ph -> ( F T G <-> E. z e. B ( ( F ` z ) e. ( G ` z )
        /\ A. w e. B ( z e. w -> ( F ` w ) = ( G ` w ) ) ) ) ) $=
        ( wcel cfv wceq wbr cv wi wral wa wrex wb fveq1 eleq12 syl2an eqeqan12d
        imbi2d ralbidv anbi12d rexbidv brabga syl2anc ) AJHRKHRJKIUADUBZJSZURKS
        ZRZUREUBZRZVBJSZVBKSZTZUCZEGUDZUEZDGUFZUGPQURBUBZSZURCUBZSZRZVCVBVKSZVB
        VMSZTZUCZEGUDZUEZDGUFVJBCJKIHHVKJTZVMKTZUEZWAVIDGWDVOVAVTVHWBVLUSTVNUTT
        VOVAUGWCURVKJUHURVMKUHVLUSVNUTUIUJWDVSVGEGWDVRVFVCWBWCVPVDVQVEVBVKJUHVB
        VMKUHUKULUMUNUOOUPUQ $.

      $d c F $.  $d c ph $.
      oemapvali.5 $e |- ( ph -> F T G ) $.
      oemapvali.6 $e |- X = U. { c e. B | ( F ` c ) e. ( G ` c ) } $.
      $( If ` F < G ` , then there is some ` z ` witnessing this, but we can
         say more and in fact there is a definable expression ` X ` that also
         witnesses ` F < G ` .  (Contributed by Mario Carneiro,
         25-May-2015.) $)
      oemapvali $p |- ( ph -> ( X e. B /\ ( F ` X ) e. ( G ` X ) /\
        A. w e. B ( X e. w -> ( F ` w ) = ( G ` w ) ) ) ) $=
        ( cv cfv wcel wceq wi wral wa w3a wbr wrex oemapval mpbid crab cuni wss
        con0 cfn c0 wne ssrab2 adantr onss syl syl5ss ccnv cvv c1o cdif cima wf
        cantnfs simprd simp2 ne0i 3ad2ant3 fvex dif1o mpbiran sylibr wfn simpld
        wb 3ad2ant1 elpreima 3syl mpbir2and rabssdv ssfi syl2anc simprl simprrl
        ffn weq fveq2 eleq12d sylanbrc ordunifi syl3anc syl5eqel cbvrabv elrab2
        elrab sylib simprrr wn word ffvelrnd onelon eloni ordirr nelneq eqeq12d
        eleq2 imbi12d rspccv sylc ssexg sylancr ssonuni ontri1 mpbird syl6sseqr
        mtod elssuni eqssd eleq1 imbi1d ralbidv 3jca rexlimddv ) ADUBZJUCZYLKUC
        ZUDZYLEUBZUDZYPJUCZYPKUCZUEZUFZEGUGZUHZLGUDZLJUCZLKUCZUDZLYPUDZYTUFZEGU
        GZUIDGAJKIUJUUCDGUKTABCDEFGHIJKNOPQRSULUMAYLGUDZUUCUHZUHZUUDUUGUUJUUMUU
        DUUGUUMLMUBZJUCZUUNKUCZUDZMGUNZUDUUDUUGUHUUMLUURUOZUURUAUUMUURUQUPZUURU
        RUDZUURUSUTZUUSUURUDUUMUURGUQUUQMGVAZUUMGUQUDZGUQUPAUVDUULPVBZGVCVDVEZU
        UMKVFVGVHVIZVJZURUDZUURUVHUPZUVAAUVIUULAGFKVKZUVIAKHUDUVKUVIUHSAFGHKNOP
        VLUMZVMVBAUVJUULAUUQMGUVHAUUNGUDZUUQUIZUUNUVHUDZUVMUUPUVGUDZAUVMUUQVNUV
        NUUPUSUTZUVPUUQAUVQUVMUUPUUOVOVPUVPUUPVGUDUVQUUNKVQUUPVGVRVSVTUVNUVKKGW
        AUVOUVMUVPUHWCAUVMUVKUUQAUVKUVIUVLWBZWDGFKWMGUUNUVGKWEWFWGWHVBUVHUURWIW
        JUUMYLUURUDZUVBUUMUUKYOUVSAUUKUUCWKZAUUKYOUUBWLUUQYOMYLGMDWNUUOYMUUPYNU
        UNYLJWOUUNYLKWOWPXCWQZUURYLVOVDUURWRWSWTBUBZJUCZUWBKUCZUDZUUGBLGUURUWBL
        UEUWCUUEUWDUUFUWBLJWOUWBLKWOWPUUQUWEMBGMBWNUUOUWCUUPUWDUUNUWBJWOUUNUWBK
        WOWPXAXBXDZWBZUUMUUDUUGUWFVMZUUMUUJUUBAUUKYOUUBXEZUUMLYLUEZUUJUUBWCUUML
        YLUUMLYLUPZYLLUDZXFZUUMUWLUUEUUFUEZUUMUUGUUFUUFUDXFZUWNXFUWHUUMUUFUQUDZ
        UUFXGUWOUUMFUQUDZUUFFUDUWPAUWQUULOVBUUMGFLKAUVKUULUVRVBUWGXHFUUFXIWJUUF
        XJUUFXKWFUUEUUFUUFXLWJUUMUUBUUDUWLUWNUFZUWIUWGUUAUWRELGYPLUEZYQUWLYTUWN
        YPLYLXNUWSYRUUEYSUUFYPLJWOYPLKWOXMXOXPXQYDUUMLUQUDYLUQUDZUWKUWMWCUUMLUU
        SUQUAUUMUURVGUDZUUTUUSUQUDUUMUURGUPUVDUXAUVCUVEUURGUQXRXSUVFUURVGXTXQWT
        UUMUVDUUKUWTUVEUVTGYLXIWJLYLYAWJYBUUMUVSYLLUPUWAUVSYLUUSLYLUURYEUAYCVDY
        FUWJUUIUUAEGUWJUUHYQYTLYLYPYGYHYIVDYBYJYK $.

      $( Lemma for ~ cantnf .  (Contributed by Mario Carneiro, 4-Jun-2015.) $)
      cantnflem1a $p |- ( ph -> X e. ( `' G " ( _V \ 1o ) ) ) $=
        ( ccnv cvv c1o cdif cima wcel cfv cv wceq wi oemapvali simp1d c0 simp2d
        wral wne ne0i syl fvex dif1o mpbiran sylibr wf wfn wa cfn cantnfs mpbid
        wb simpld ffn elpreima 3syl mpbir2and ) ALKUBUCUDUEZUFZUGZLGUGZLKUHZVPU
        GZAVSLJUHZVTUGZLEUIZUGWDJUHWDKUHUJUKEGUPZABCDEFGHIJKLMNOPQRSTUAULZUMAVT
        UNUQZWAAWCWGAVSWCWEWFUOVTWBURUSWAVTUCUGWGLKUTVTUCVAVBVCAGFKVDZKGVEVRVSW
        AVFVJAWHVQVGUGZAKHUGWHWIVFSAFGHKNOPVHVIVKGFKVLGLVPKVMVNVO $.

      cantnflem1.o $e |- O = OrdIso ( _E , ( `' G " ( _V \ 1o ) ) ) $.
      $( Lemma for ~ cantnf .  (Contributed by Mario Carneiro, 4-Jun-2015.) $)
      cantnflem1b $p |- ( ( ph /\ ( suc u e. dom O /\ ( `' O ` X ) C_ u ) ) ->
          X C_ ( O ` u ) ) $=
        ( cv csuc cdm wcel ccnv cfv wss wa wn simprr con0 wb word cvv cdif cima
        c1o cep oicl wf1o wf wiso wwe cnvimass cfn cantnfs mpbid simpld fdm syl
        wceq syl5sseq ssexd com cantnfcl syl2anc isof1o f1ocnv f1of cantnflem1a
        oiiso 3syl ffvelrnd ordelon sylancr adantr sylan sucelon sylibr adantrr
        a1i ontri1 wbr wtr ordtr mp1i simprl trsuc isorel syl12anc fvex 3bitr3g
        epelc f1ocnvfv2 eleq2d bitrd mtbid oemapvali simp1d onelon oif ffvelrni
        wi wral sseldd mpbird ) AFUEZUFZMUGZUHZNMUIZUJZYAUKZULZULZNYAMUJZUKZYJN
        UHZUMZYIYAYFUHZYLYIYGYNUMZAYDYGUNYIYFUOUHZYAUOUHZYGYOUPAYPYHAYCUQZYFYCU
        HZYPLUIURVAUSZUTZVBMUDVCZAUUAYCNYEAYCUUAMVDZUUAYCYEVDUUAYCYEVEAYCUUAVBV
        BMVFZUUCAUUAURUHUUAVBVGZUUDAUUAHUORALUGZUUAHLYTVHAHGLVEZUUFHVOAUUGUUAVI
        UHZALIUHUUGUUHULUAAGHILPQRVJVKVLHGLVMVNVPZVQAUUEYCVRUHAGHILMPQRUDUAVSVL
        UUAVBMURUDWEVTZYCUUAVBVBMWAVNZYCUUAMWBUUAYCYEWCWFABCDEGHIJKLNOPQRSTUAUB
        UCWDZWGZYCYFWHWIWJAYDYQYGAYDULYBUOUHZYQAYRYDUUNYRAUUBWOYCYBWHWKYAWLWMWN
        YFYAWPVTVKYIYNYJYFMUJZUHZYLYIYAYFVBWQZYJUUOVBWQZYNUUPYIUUDYAYCUHZYSUUQU
        URUPAUUDYHUUJWJYIYCWRZYDUUSYRUUTYIUUBYCWSWTAYDYGXAYCYAXBVTZAYSYHUUMWJYC
        UUAYAYFVBVBMXCXDYAYFNYEXEXGYJUUOYFMXEXGXFYIUUONYJAUUONVOZYHAUUCNUUAUHUV
        BUUKUULYCUUANMXHVTWJXIXJXKYINUOUHZYJUOUHZYKYMUPAUVCYHAHUOUHZNHUHZUVCRAU
        VFNKUJNLUJUHNEUEZUHUVGKUJUVGLUJVOXQEHXRABCDEGHIJKLNOPQRSTUAUBUCXLXMHNXN
        VTWJYIUVEYJHUHUVDAUVEYHRWJYIUUAHYJAUUAHUKYHUUIWJYIUUSYJUUAUHUVAYCUUAYAM
        UUAVBMUDXOXPVNXSHYJXNVTNYJWPVTXT $.

      $( Lemma for ~ cantnf .  (Contributed by Mario Carneiro, 4-Jun-2015.) $)
      cantnflem1c $p |- ( ( ( ( ph /\ ( suc u e. dom O /\ ( `' O ` X ) C_ u ) )
          /\ x e. B ) /\ ( ( F ` x ) =/= (/) /\ ( O ` u ) e. x ) ) ->
             x e. ( `' G " ( _V \ 1o ) ) ) $=
        ( cv csuc cdm wcel ccnv cfv wss wa c0 wne cvv c1o cdif cima simplr wceq
        wral oemapvali simp3d ad3antrrr cantnflem1b ad2antrr simprr con0 simp1d
        wi onelon syl2anc onss sselda adantlr adantr ontr2 mp2and eleq2 eqeq12d
        syl fveq2 imbi12d rspcv syl3c simprl eqnetrrd fvex dif1o mpbiran sylibr
        wfn wb wf cfn cantnfs mpbid simpld ffn elpreima mpbir2and ) AFUEZUFMUGU
        HNMUIUJXBUKULZULZBUEZHUHZULZXEKUJZUMUNZXBMUJZXEUHZULZULZXELUIUOUPUQZURZ
        UHZXFXELUJZXNUHZXDXFXLUSZXMXQUMUNZXRXMXHXQUMXMXFNEUEZUHZYAKUJZYALUJZUTZ
        VJZEHVAZNXEUHZXHXQUTZXSAYGXCXFXLANHUHZNKUJNLUJUHZYGABCDEGHIJKLNOPQRSTUA
        UBUCVBZVCVDXMNXJUKZXKYHXDYMXFXLABCDEFGHIJKLMNOPQRSTUAUBUCUDVEVFXGXIXKVG
        XMNVHUHZXEVHUHZYMXKULYHVJAYNXCXFXLAHVHUHZYJYNRAYJYKYGYLVIHNVKVLVDXGYOXL
        AXFYOXCAHVHXEAYPHVHUKRHVMWAVNVOVPNXJXEVQVLVRYFYHYIVJEXEHYAXEUTZYBYHYEYI
        YAXENVSYQYCXHYDXQYAXEKWBYAXELWBVTWCWDWEXGXIXKWFWGXRXQUOUHXTXELWHXQUOWIW
        JWKXMLHWLZXPXFXRULWMAYRXCXFXLAHGLWNZYRAYSXOWOUHZALIUHYSYTULUAAGHILPQRWP
        WQWRHGLWSWAVDHXEXNLWTWAXA $.

      cantnflem1.h $e |- H = seqom ( ( k e. _V , z e. _V |->
        ( ( ( A ^o ( O ` k ) ) .o ( G ` ( O ` k ) ) ) +o z ) ) , (/) ) $.
      $( Lemma for ~ cantnf .  (Contributed by Mario Carneiro, 4-Jun-2015.) $)
      cantnflem1d $p |- ( ph ->
         ( ( A CNF B ) ` ( x e. B |-> if ( x C_ X , ( F ` x ) , (/) ) ) ) e.
           ( H ` suc ( `' O ` X ) ) ) $=
        ( coe co cfv comu ccnv csuc cv wss c0 cif cmpt ccnf con0 wcel wceq wral
        coa wi oemapvali simp1d onelon syl2anc oecl wf cvv c1o cdif cima cfn wa
        cantnfs simpld ffvelrnd omcl com cdm wf1o cep wiso wwe cnvimass fdm syl
        mpbid syl5sseq ssexd cantnfcl oiiso isof1o f1ocnv f1of 3syl cantnflem1a
        simprd elnn cantnfvalf ffvelrni cantnfsuc mpdan f1ocnvfv2 oveq2d fveq2d
        oaword1 oveq12d oveq1d eqtrd sseqtr4d wo wb onss sselda adantr onsseleq
        orcom syl6bb ifbid mpteq2dva ffvelrnda wne ne0i on0eln0 ifcl eqid fmptd
        mpbird csn df1o2 imaeq2i suppss2 syl5eqss adantl fveq2 syl3anc sseldd
        difeq2i eqimss2 mp1i suppssr ifeq1d ifid ssfi mpbir2and iffalse ifeq1da
        syl6eq wn eldifn eleq1 eqidd ifbieq12d fvex 0ex ifex ifeq2d eqtr3d ifor
        fvmpt syl6reqr mpteq2ia cantnfp1 omsuc word eloni ordsucss sylc omwordi
        simp2d suceloni mpd eqsstr3d cantnflt2 oaord eqeltrd ) AFOUGUHZOLUIZUJU
        HZONUKZUIZULMUIZBGBUMZOUNZUWFKUIZUOUPZUQZFGURUHZUIZAUWBUWBUWDMUIZVCUHZU
        WEAUWBUSUTZUWMUSUTZUWBUWNUNAUVTUSUTZUWAUSUTZUWOAFUSUTZOUSUTZUWQRAGUSUTZ
        OGUTZUWTSAUXBOKUIZUWAUTZOEUMZUTUXEKUIUXELUIVAVDEGVBZABCDEFGHIKLOPQRSTUA
        UBUCUDVEZVFZGOVGVHZFOVIVHZAUWSUWAFUTZUWRRAGFOLAGFLVJZLUKVKVLVMZVNZVOUTZ
        ALHUTUXLUXOVPUBAFGHLQRSVQWJVRZUXHVSZFUWAVGVHZUVTUWAVTVHAUWDWAUTZUWPAUWD
        NWBZUTUXTWAUTZUXSAUXNUXTOUWCAUXTUXNNWCZUXNUXTUWCWCUXNUXTUWCVJAUXTUXNWDW
        DNWEZUYBAUXNVKUTUXNWDWFZUYCAUXNGUSSALWBZUXNGLUXMWGAUXLUYEGVAUXPGFLWHWIW
        KWLAUYDUYAAFGHLNQRSUEUBWMZVRUXNWDNVKUEWNVHUXTUXNWDWDNWOWIZUXTUXNNWPUXNU
        XTUWCWQWRABCDEFGHIKLOPQRSTUAUBUCUDWSZVSAUYDUYAUYFWTUWDUXTXAVHZWAUSUWDMD
        VKVKFJUMNUIZUGUHUYJLUIUJUHDUMJMUFXBXCWIUWBUWMXIVHAUWEFUWDNUIZUGUHZUYKLU
        IZUJUHZUWMVCUHZUWNAUXSUWEUYOVAUYIADFGHJLNMUWDQRSUEUBUFXDXEAUYNUWBUWMVCA
        UYLUVTUYMUWAUJAUYKOFUGAUYBOUXNUTUYKOVAUYGUYHUXTUXNONXFVHZXGAUYKOLUYPXHX
        JXKXLXMAUWLUVTUXCUJUHZCGCUMZOUTZUYRKUIZUOUPZUQZUWKUIZVCUHZUWBAUWLBGUWFO
        VAZUWFOUTZXNZUWHUOUPZUQZUWKUIZVUDAUWJVUIUWKABGUWIVUHAUWFGUTZVPZUWGVUGUW
        HUOVULUWGVUFVUEXNZVUGVULUWFUSUTUWTUWGVUMXOAGUSUWFAUXAGUSUNSGXPWIXQAUWTV
        UKUXIXRUWFOXSVHVUFVUEXTYAYBYCXHAVUIHUTVUJVUDVAABFGHVUIVUBOUXCQRSAVUBHUT
        GFVUBVJVUBUKZUXMVNZVOUTZACGVUAFVUBAUYRGUTZVPUYTFUTUOFUTZVUAFUTAGFUYRKAG
        FKVJZKUKZUXMVNZVOUTZAKHUTVUSVVBVPUAAFGHKQRSVQWJZVRZYDAVURVUQAVURFUOYEZA
        UXKVVEUXQFUWAYFWIAUWSVURVVEXORFYGWIYKZXRUYSUYTUOFYHVHVUBYIZYJAVVBVUOVVA
        UNVUPAVUSVVBVVCWTAVUOVUNVKUOYLZVMZVNZVVAUXMVVIVUNVLVVHVKYMUUAZYNZAGVUAC
        VVAUOAUYRGVVAVMUTVPZVUAUYSUOUOUPUOVVMUYSUYTUOUOAGFKVVAUYRUOVVDVVAVUTVVI
        VNZVAVVNVVAUNAUXMVVIVUTVVKYNVVNVVAUUBUUCUUDUUEUYSUOUUFUUKYOYPVVAVUOUUGV
        HAFGHVUBQRSVQUUHZUXHAGFOKVVDUXHVSZAVUOVVJOVVLAGVUACOUOAUYRGOVMUTZVPUYSU
        ULZVUAUOVAVVQVVRAUYRGOUUMYQUYSUYTUOUUIWIYOYPZBGVUHVUEUXCUWFVUBUIZUPZVUK
        VWAVUEUWHVUFUWHUOUPZUPZVUHVUKVUEUWHVVTUPVWAVWCVUKVUEUWHUXCVVTVUEUWHUXCV
        AVUKUWFOKYRYQUUJVUKVUEVVTVWBUWHCUWFVUAVWBGVUBUYRUWFVAZUYSVUFUYTUOUWHUOU
        YRUWFOUUNUYRUWFKYRVWDUOUUOUUPVVGVUFUWHUOUWFKUUQUURUUSUVCUUTUVAVUEVUFUWH
        UOUVBUVDUVEUVFWTXLAUYQUVTVCUHZUWBVUDAVWEUVTUXCULZUJUHZUWBAUWQUXCUSUTZVW
        GVWEVAUXJAUWSUXCFUTVWHRVVPFUXCVGVHZUVTUXCUVGVHAVWFUWAUNZVWGUWBUNZAUWAUV
        HZUXDVWJAUWRVWLUXRUWAUVIWIAUXBUXDUXFUXGUVMUXCUWAUVJUVKAVWFUSUTZUWRUWQVW
        JVWKVDAVWHVWMVWIUXCUVNWIUXRUXJVWFUWAUVTUVLYSUVOUVPAVUCUVTUTZVUDVWEUTZAF
        GOHVUBQRSVVOVVFUXIVVSUVQZAVUCUSUTZUWQUYQUSUTZVWNVWOXOAUWQVWNVWQUXJVWPUV
        TVUCVGVHUXJAUWQVWHVWRUXJVWIUVTUXCVTVHVUCUVTUYQUVRYSWJYTUVSYT $.

      $( Lemma for ~ cantnf .  This part of the proof is showing uniqueness of
         the Cantor normal form.  We already know that the relation ` T ` is a
         strict order, but we haven't shown it is a well-order yet.  But being
         a strict order is enough to show that two distinct ` F , G ` are ` T `
         -related as ` F < G ` or ` G < F ` , and WLOG assuming that
         ` F < G ` , we show that ` CNF ` respects this order and maps these
         two to different ordinals.  (Contributed by Mario Carneiro,
         28-May-2015.) $)
      cantnflem1 $p |- ( ph -> ( ( A CNF B ) ` F ) e. ( ( A CNF B ) ` G ) ) $=
        ( vu co cfv cdm csuc cv wss c0 cif cmpt ccnv cvv c1o cdif cima cfn wcel
        wf wa cantnfs mpbid simpld wceq eqeq2 eqidd wn con0 wb syl cep 3syl cen
        wo wbr syl2anc syl6bb syl5ibcom simprd word mp1i eleqtrrd sseldd onelon
        com ffvelrni adantr ontri1 simprl wf1o ffvelrnd elssuni ordelon sylancr
        wi eloni ordtri1 sylancl isorel syl12anc epelc 3bitr3g f1ocnvfv2 eleq2d
        fvex bitrd mtbid mpbird simprr adantrr mp2and weq fveq2 eqeq12d imbi12d
        ad2antrr imaeq2i eqtrd fveq2d eleq1 sseq2 anbi12d sseq2d ifbid mpteq2dv
        expr suceq eleq12d coe comu coa wne ifid syl6eq ifeq1 ccnf cuni feqmptd
        onss sselda cnvimass fdm syl5sseq cnvexg imaexg oion uniexg sucidg wlim
        cantnflem1a n0i ssexd cantnfcl oien breq1 ensymb bitri mtod nnlim ioran
        wwe en0 sylanbrc oicl unizlim orduniorsuc ord mpd oif con2bid oemapvali
        mtbird simp3d oiiso isof1o f1ocnv orduni ax-mp simp1d ontr2 eleq2 rspcv
        wral wiso f1of syl3c ffvelrn sylancom pm2.65da eldifd csn df1o2 difeq2i
        eqimss2 suppssr syldan sylbird ifbothda mpteq2dva peano2b sylibr imbi2d
        imp eqeltrrd cantnflem1d eqeltrd ss0 adantl a1i sylan onsseleq ordsssuc
        sucelon wtr ordtr trsuc jca oecl cantnff ffvelrnda ne0i ifcl eqid fmptd
        on0eln0 ifeq1d suppss2 syl5eqss ssfi mpbir2and cantnfvalf oaord syl3anc
        elnn omcl adantlr onsssuc sucid sucex mpbii ordelsuc sylbid cantnflem1c
        vex sseld eleq1d con2d sylibrd impbid orbi1d bitr4d orcom pm2.61ne crab
        mptpreima 0ex ifex mpbiran necon3i iffalse necon1ai expimpd syl5 syl5bi
        dif1o 3impia rabssdv eqeq1 sseq1 orbi12d ifbieq12d cbvmptv fvmpt ifeq2d
        ifeq1da syl6eqr eqtr3d mpteq2ia eqtr4i cantnfp1 cantnfsuc oveq2d oveq1d
        ifor eqtr4d biimpd embantd a1dd com23 finds2 vtoclga mpcom cantnfval
        jaod ) AKFGUUAUHZUIZNUJZUUBZUKZMUIZLVWTUIZAVXABGBULZVXCNUIZUMZVXGKUIZUN
        UOZUPZVWTUIZVXEAKVXLVWTAKBGVXJUPVXLABGFKAGFKVDZKUQZURUSUTZVAZVBVCZAKHVC
        VXNVXRVEUAAFGHKQRSVFVGZVHZUUCABGVXJVXKVXIVXJVXJVIVXJUNVIZVXJVXKVIAVXGGV
        CZVEZVXJUNVXJVXKVXJVJUNVXKVXJVJVYCVXIVEVXJVKVYCVXIVLZVYAVYCVYDVXHVXGVCZ
        VYAVYCVXIVYEVYCVXGVMVCZVXHVMVCZVXIVYEVLVNAGVMVXGAGVMVCZGVMUMSGUUDVOUUEZ
        AVYGVYBAVYHVXHGVCVYGSALUQZVXPVAZGVXHALUJZVYKGLVXPUUFAGFLVDZVYLGVIAVYMVY
        KVBVCZALHVCZVYMVYNVEUBAFGHLQRSVFVGVHZGFLUUGVOUUHZAVXCVXBVCZVXHVYKVCAVXC
        VXDVXBAVXBVMVCZVXCURVCVXCVXDVCAVYJURVCZVYKURVCZVYSAVYOVYTUBLHUUIVOVYJVX
        PURUUJVYKVPNURUEUUKVQVXBVMUULVXCURUUMVQAVXBVXCVIZVLVXBVXDVIZAWUBVXBUNVI
        ZVXBUUNZVSZAWUDVLWUEVLZWUFVLAWUDVYKUNVIZAOVYKVCZWUHVLABCDEFGHIKLOPQRSTU
        AUBUCUDUUOZVYKOUUPVOAVXBVYKVRVTZWUDWUHAWUAVYKVPUVFZWUKAVYKGVMSVYQUUQZAW
        ULVXBWJVCZAFGHLNQRSUEUBUURZVHZVYKVPNURUEUUSWAWUDWUKUNVYKVRVTZWUHVXBUNVY
        KVRUUTWUQVYKUNVRVTWUHUNVYKUVAVYKUVGUVBWBWCUVCAWUNWUGAWULWUNWUOWDZVXBUVD
        VOWUDWUEUVEUVHVXBWEZWUBWUFVNAVYKVPNUEUVIZVXBUVJWFUVQAWUBWUCWUSWUBWUCVSA
        WUTVXBUVKWFUVLUVMZWGZVXBVYKVXCNVYKVPNUEUVNZWKVOWHGVXHWIWAZWLVXGVXHWMWAU
        VOAVYBVYEVYAAVYBVYEVEZVEZVXJVXGLUIZUNWVFVYBOEULZVCZWVHKUIZWVHLUIZVIZWTZ
        EGUWHZOVXGVCZVXJWVGVIZAVYBVYEWNZAWVNWVEAOGVCZOKUIOLUIZVCZWVNABCDEFGHIKL
        OPQRSTUAUBUCUDUVPZUVRZWLWVFOVXHUMZVYEWVOAWWCWVEAWWCVXHOVCZVLZAVXCONUQZU
        IZVCZWWDAWWGVXCUMZWWHVLZAWWGVXBVCZWWIAVYKVXBOWWFAVXBVYKNWOZVYKVXBWWFWOZ
        VYKVXBWWFVDZAVXBVYKVPVPNUWIZWWLAWUAWULWWOWUMWUPVYKVPNURUEUVSWAZVXBVYKVP
        VPNUVTZVOZVXBVYKNUWAZVYKVXBWWFUWJZVQZWUJWPZWWGVXBWQVOZAWWGWEZVXCWEZWWIW
        WJVNAWWGVMVCZWXDAWUSWWKWXFWUTWXBVXBWWGWRWSZWWGXAVOWUSWXEWUTVXBUWBUWCZWW
        GVXCXBXCVGAWWHVXHWWGNUIZVCZWWDAVXCWWGVPVTZVXHWXIVPVTZWWHWXJAWWOVYRWWKWX
        KWXLVNWWPWVBWXBVXBVYKVXCWWGVPVPNXDXEVXCWWGOWWFXJXFVXHWXIWWGNXJXFXGAWXIO
        VXHAWWLWUIWXIOVIZWWRWUJVXBVYKONXHWAZXIXKXLAOVMVCZVYGWWCWWEVNAVYHWVRWXOS
        AWVRWVTWVNWWAUWDZGOWIWAZWVDOVXHWMWAXMWLAVYBVYEXNZWVFWXOVYFWWCVYEVEWVOWT
        AWXOWVEWXQWLAVYBVYFVYEVYIXOOVXHVXGUWEWAXPWVMWVOWVPWTEVXGGEBXQZWVIWVOWVL
        WVPWVHVXGOUWFWXSWVJVXJWVKWVGWVHVXGKXRWVHVXGLXRXSXTUWGUWKAWVEVXGGVYKUTVC
        WVGUNVIWVFVXGGVYKWVQWVFVXGVYKVCZVXCVXGWWFUIZVCZWVFWXTVEZWYBVYEWVFVYEWXT
        WXRWLWYCWYBVXHWYANUIZVCZVYEWYCVXCWYAVPVTZVXHWYDVPVTZWYBWYEWYCWWOVYRWYAV
        XBVCZWYFWYGVNAWWOWVEWXTWWPYAAVYRWVEWXTWVBYAWVFWXTWWNWYHAWWNWVEWXTWXAYAV
        YKVXBVXGWWFUWLUWMZVXBVYKVXCWYAVPVPNXDXEVXCWYAVXGWWFXJZXFVXHWYDWYANXJZXF
        XGWYCWYDVXGVXHWVFWXTWWLWYDVXGVIZAWWLWVEWXTWWRYAVXBVYKVXGNXHZUWMXIXKXMWY
        CWYAVXCUMZWYBVLZWYCWYHWYNWYIWYAVXBWQVOWYCWYAWEZWXEWYNWYOVNWYCWYAVMVCZWY
        PWYCWUSWYHWYQWUTWYIVXBWYAWRZWSWYAXAZVOWXHWYAVXCXBXCVGUWNUWOAGFLVYKVXGUN
        VYPVYKVYJURUNUWPZUTZVAZVIXUBVYKUMAVXPXUAVYJUSWYTURUWQUWRZYBXUBVYKUWSWFU
        WTUXAYCYKUXBUXHUXCUXDYCYDAVYRWWIVXMVXEVCZWVBWXCVXCWJVCZAVYRWWIVEZXUDWTZ
        AVXDWJVCXUEAVXBVXDWJWVAWURUXIVXCUXEUXFACULZVXBVCZWWGXUHUMZVEZBGVXGXUHNU
        IZUMZVXJUNUOZUPZVWTUIZXUHUKZMUIZVCZWTZWTAXUGWTCVXCWJXUHVXCVIZXUTXUGAXVA
        XUKXUFXUSXUDXVAXUIVYRXUJWWIXUHVXCVXBYEXUHVXCWWGYFYGXVAXUPVXMXURVXEXVAXU
        OVXLVWTXVABGXUNVXKXVAXUMVXIVXJUNXVAXULVXHVXGXUHVXCNXRYHYIYJYDXVAXUQVXDM
        XUHVXCYLYDYMXTUXGXUTUNVXBVCZWWGUNUMZVEZBGVXGUNNUIZUMZVXJUNUOZUPZVWTUIZU
        NUKZMUIZVCZWTUGULZVXBVCZWWGXVMUMZVEZBGVXGXVMNUIZUMZVXJUNUOZUPZVWTUIZXVM
        UKZMUIZVCZWTZXWBVXBVCZWWGXWBUMZVEZBGVXGXWBNUIZUMZVXJUNUOZUPZVWTUIZXWBUK
        ZMUIZVCZWTZACUGXUHUNVIZXUKXVDXUSXVLXWRXUIXVBXUJXVCXUHUNVXBYEXUHUNWWGYFY
        GXWRXUPXVIXURXVKXWRXUOXVHVWTXWRBGXUNXVGXWRXUMXVFVXJUNXWRXULXVEVXGXUHUNN
        XRYHYIYJYDXWRXUQXVJMXUHUNYLYDYMXTCUGXQZXUKXVPXUSXWDXWSXUIXVNXUJXVOXUHXV
        MVXBYEXUHXVMWWGYFYGXWSXUPXWAXURXWCXWSXUOXVTVWTXWSBGXUNXVSXWSXUMXVRVXJUN
        XWSXULXVQVXGXUHXVMNXRYHYIYJYDXWSXUQXWBMXUHXVMYLYDYMXTXUHXWBVIZXUKXWHXUS
        XWPXWTXUIXWFXUJXWGXUHXWBVXBYEXUHXWBWWGYFYGXWTXUPXWMXURXWOXWTXUOXWLVWTXW
        TBGXUNXWKXWTXUMXWJVXJUNXWTXULXWIVXGXUHXWBNXRYHYIYJYDXWTXUQXWNMXUHXWBYLY
        DYMXTABGVXGWXIUMZVXJUNUOZUPZVWTUIZWWGUKZMUIZVCZXVDXVLAXXDBGVXGOUMZVXJUN
        UOZUPZVWTUIXXFAXXCXXJVWTABGXXBXXIAXXAXXHVXJUNAWXIOVXGWXNYHYIYJYDABCDEFG
        HIJKLMNOPQRSTUAUBUCUDUEUFUXJUXKZXVCXXGXVLVNXVBXVCXXDXVIXXFXVKXVCXXCXVHV
        WTXVCBGXXBXVGXVCXXAXVFVXJUNXVCWXIXVEVXGXVCWWGUNNWWGUXLZYDYHYIYJYDXVCXXE
        XVJMXVCWWGUNVIXXEXVJVIXXLWWGUNYLVOYDYMUXMWCAXWEXWQWTWTXVMWJVCAXWHXWEXWP
        AXWFXWGXWEXWPWTZAXWFVEZXWGWWGXWBVCZWWGXWBVIZVSZXXMXXNWXFXWBVMVCZXWGXXQV
        NAWXFXWFWXGWLZAWUSXWFXXRWUSAWUTUXNVXBXWBWRZUXOZWWGXWBUXPWAXXNXXOXXMXXPX
        XNXXOXVOXXMXXNWXFXVMWEZXVOXXOVNZXXSXXNXVMVMVCZXYBXXNXXRXYDXYAXVMUXRUXFZ
        XVMXAVOWWGXVMUXQWAAXWFXVOXXMAXWFXVOVEZVEZXVPXWDXWPXYGXVNXVOXYGVXBUXSZXW
        FXVNWUSXYHXYGWUTVXBUXTWFAXWFXVOWNZVXBXVMUYAWAZAXWFXVOXNZUYBXYGXWDXWPXYG
        XWDFXWIYNUHZXWIKUIZYOUHZXWAYPUHZXYNXWCYPUHZVCZXWPXYGXWAVMVCZXWCVMVCZXYN
        VMVCZXWDXYQVNXYGFGYNUHZVMVCZXWAYUAVCXYRXYGFVMVCZVYHYUBAYUCXYFRWLZAVYHXY
        FSWLZFGUYCWAXYGHYUAXVTVWTXYGFGHQYUDYUEUYDAXVTHVCZXYFAYUFGFXVTVDXVTUQZVX
        PVAZVBVCZABGXVSFXVTVYCVXJFVCUNFVCZXVSFVCAGFVXGKVXTUYEAYUJVYBAYUJFUNYQZA
        WVSFVCYUKAGFOLVYPWXPWPFWVSUYFVOAYUCYUJYUKVNRFUYJVOXMWLXVRVXJUNFUYGWAXVT
        UYHZUYIAVXRYUHVXQUMYUIAVXNVXRVXSWDAYUHYUGXUAVAVXQVXPXUAYUGXUCYBAGXVSBVX
        QUNAVXGGVXQUTVCVEZXVSXVRUNUNUOZUNYUMXVRVXJUNUNAGFKVXQVXGUNVXTVXQVXOXUAV
        AZVIYUOVXQUMAVXPXUAVXOXUCYBYUOVXQUWSWFUWTUYKXVRUNYRZYSUYLUYMVXQYUHUYNWA
        AFGHXVTQRSVFUYOWLZWPYUAXWAWIWAXYGXWBWJVCZXYSXYGXWFWUNYURXYIAWUNXYFWURWL
        XWBVXBUYSWAZWJVMXWBMDURURFJULNUIZYNUHYUTLUIYOUHDULJMUFUYPWKVOXYGXYLVMVC
        ZXYMVMVCZXYTXYGYUCXWIVMVCZYVAYUDXYGVYHXWIGVCZYVCYUEXYGVYKGXWIAVYKGUMXYF
        VYQWLZXYGXWFXWIVYKVCXYIVXBVYKXWBNWVCWKVOWHZGXWIWIWAZFXWIUYCWAXYGYUCXYMF
        VCYVBYUDXYGGFXWIKAVXNXYFVXTWLYVFWPZFXYMWIWAXYLXYMUYTWAXWAXWCXYNUYQUYRXY
        GXWMXYOXWOXYPXYGXWMBGVXGXWIVIZXVRVSZVXJUNUOZUPZVWTUIZXYOXYGXWLYVLVWTXYG
        BGXWKYVKXYGVYBVEZXWKYVKVIUNUNVIVXJUNVYAXWKUNYVKUNVYAXWKXWJUNUNUOUNXWJVX
        JUNUNYTXWJUNYRYSVYAYVKYVJUNUNUOUNYVJVXJUNUNYTYVJUNYRYSXSYVNVXJUNYQZVEZX
        WJYVJVXJUNYVPXWJXVRYVIVSZYVJYVPXWJVXGXWIVCZYVIVSZYVQYVNXWJYVSVNZYVOYVNV
        YFYVCYVTAVYBVYFXYFVYIVUAZXYGYVCVYBYVGWLVXGXWIUXPWAWLYVPXVRYVRYVIYVPXVRY
        VRYVPXVRVXGXVQUKZVCZYVRYVPVYFXVQVMVCZXVRYWCVNYVNVYFYVOYWAWLZXYGYWDVYBYV
        OXYGVYHXVQGVCYWDYUEXYGVYKGXVQYVEXYGXVNXVQVYKVCXYJVXBVYKXVMNWVCWKVOWHGXV
        QWIWAZYAZVXGXVQVUBWAYVPYWBXWIVXGXYGYWBXWIUMZVYBYVOXYGXVQXWIVCZYWHXYGXVM
        XWBVCZYWIXVMUGVUIZVUCXYGXVMXWBVPVTZXVQXWIVPVTZYWJYWIXYGWWOXVNXWFYWLYWMV
        NAWWOXYFWWPWLZXYJXYIVXBVYKXVMXWBVPVPNXDXEXVMXWBXVMYWKVUDZXFXVQXWIXWBNXJ
        ZXFXGVUEXYGYWDXWIWEZYWIYWHVNYWFXYGYVCYWQYVGXWIXAVOXVQXWIVMVUFWAVGYAVUJV
        UGZYVPYVRXVQVXGVCZVLZXVRYVPYWSYVRYVNYVOYWSYVRVLYVNYVOYWSVEZVEZWYAXWBVCZ
        YVRYXBXWBWYAUMZYXCVLZYXBXVMWYAVCZYXDYXBYXFXVQWYDVCZYXBXVQVXGWYDYVNYVOYW
        SXNYXBWWLWXTWYLYXBWWOWWLXYGWWOVYBYXAYWNYAZWWQVOZABCDEUGFGHIKLNOPQRSTUAU
        BUCUDUEVUHZWYMWAZWGYXBXVMWYAVPVTZXVQWYDVPVTZYXFYXGYXBWWOXVNWYHYXLYXMVNY
        XHXYGXVNVYBYXAXYJYAYXBVYKVXBVXGWWFYXBWWLWWMWWNYXIWWSWWTVQYXJWPZVXBVYKXV
        MWYAVPVPNXDXEXVMWYAWYJXFXVQWYDWYKXFXGXMZYXBYXFWYPYXFYXDVNYXOYXBWYQWYPYX
        BWUSWYHWYQWUTYXNWYRWSZWYSVOXVMWYAWYAVUFWAVGYXBXXRWYQYXDYXEVNYXBWUSXWFXX
        RWUTXYGXWFVYBYXAXYIYAZXXTWSYXPXWBWYAWMWAVGYXBYXCWYDXWIVCZYVRYXBWYAXWBVP
        VTZWYDXWIVPVTZYXCYXRYXBWWOWYHXWFYXSYXTVNYXHYXNYXQVXBVYKWYAXWBVPVPNXDXEW
        YAXWBYWOXFWYDXWIYWPXFXGYXBWYDVXGXWIYXKVUKXKXLYKVULYVPVYFYWDXVRYWTVNYWEY
        WGVXGXVQWMWAVUMVUNVUOVUPXVRYVIVUQWBYIYVNUNVKVURUXDYDXYGYVLHVCYVMXYOVIXY
        GCFGHYVLXVTXWIXYMQYUDYUEYUQYVFYVHXYGYUHXVSVXPVCZBGVUSXWIBGXVSVXPXVTYULV
        UTXYGYYABGXWIXYGVYBYYAYVRYYAXVSUNYQZYVNYVRYYAXVSURVCYYBXVRVXJUNVXGKXJVV
        AVVBXVSURVVJVVCYYBYVOXVRVEYVNYVRYYBYVOXVRVXJUNXVSUNVYAXVSYUNUNXVRVXJUNU
        NYTYUPYSVVDXVRXVSUNXVRVXJUNVVEVVFUYBYVNYVOXVRYVRYWRVVGVVHVVIVVKVVLUYMYV
        LCGXUHXWIVIZXUHXVQUMZVSZXUHKUIZUNUOZUPCGYYCXYMXUHXVTUIZUOZUPBCGYVKYYGBC
        XQZYVJYYEVXJUNYYFUNYYJYVIYYCXVRYYDVXGXUHXWIVVMVXGXUHXVQVVNZVVOVXGXUHKXR
        ZYYJUNVKZVVPVVQCGYYIYYGXUHGVCZYYCYYFYYHUOZYYIYYGYYNYYCYYFXYMYYHYYCYYFXY
        MVIYYNXUHXWIKXRUXMVVTYYNYYOYYCYYFYYDYYFUNUOZUOYYGYYNYYCYYHYYPYYFBXUHXVS
        YYPGXVTYYJXVRYYDVXJUNYYFUNYYKYYLYYMVVPYULYYDYYFUNXUHKXJVVAVVBVVRVVSYYCY
        YDYYFUNVWIVWAVWBVWCVWDVWEWDYCXYGXWOXYLXWILUIZYOUHZXWCYPUHZXYPAXYFYURXWO
        YYSVIYUSADFGHJLNMXWBQRSUEUBUFVWFUXAXYGXYNYYRXWCYPXYGXYMYYQXYLYOXYGYVDWV
        NOXWIVCZXYMYYQVIZYVFAWVNXYFWWBWLXYGWXIOXWIAWXMXYFWXNWLXYGXXOWXIXWIVCZXY
        GXVOXXOXYKXYGWXFXYDXYCAWXFXYFWXGWLAXWFXYDXVOXYEXOWWGXVMVUBWAVGXYGWWGXWB
        VPVTZWXIXWIVPVTZXXOUUUBXYGWWOWWKXWFUUUCUUUDVNYWNAWWKXYFWXBWLXYIVXBVYKWW
        GXWBVPVPNXDXEWWGXWBYWOXFWXIXWIYWPXFXGVGUXIWVMYYTUUUAWTEXWIGWVHXWIVIZWVI
        YYTWVLUUUAWVHXWIOUWFUUUEWVJXYMWVKYYQWVHXWIKXRWVHXWILXRXSXTUWGUWKVWGVWHV
        WJYMVUPVWKVWLYKUXBXXNXXPXWPXWEAXXPXWPWTXWFAXXGXXPXWPXXKXXPXXDXWMXXFXWOX
        XPXXCXWLVWTXXPBGXXBXWKXXPXXAXWJVXJUNXXPWXIXWIVXGWWGXWBNXRYHYIYJYDXXPXXE
        XWNMWWGXWBYLYDYMWCWLVWMVWSVUGVVGVWNUXNVWOVWPVWQXPUXKAVXFVXBMUIVXEADFGHJ
        LNMQRSUEUBUFVWRAVXBVXDMWVAYDYCWG $.
    $}

    ${
      cantnf.1 $e |- ( ph -> C e. ( A ^o B ) ) $.
      cantnf.2 $e |- ( ph -> C C_ ran ( A CNF B ) ) $.
      cantnf.3 $e |- ( ph -> (/) e. C ) $.
      $( Lemma for ~ cantnf .  (Contributed by Mario Carneiro, 28-May-2015.) $)
      cantnflem2 $p |- ( ph -> ( A e. ( On \ 2o ) /\ C e. ( On \ 1o ) ) ) $=
        ( con0 wcel c1o c2o cdif c0 wceq wo coe co oecl syl2anc onelon sylanbrc
        wss ondif1 eldifbd ssel syl5com mtod oe0m syl difss syl6eqss syl5ibrcom
        oveq1 sseq1d oe1m eqimss 3syl jaod cpr elpri df2o3 eleq2s nsyl eldifd
        jca ) AFRUAUBSHRTUBSZAFRUALAFUCUDZFTUDZUEZFUASAVSFGUFUGZTULZAWAHTSZAHRT
        AHRSZUCHSVPAVTRSZHVTSZWCAFRSGRSZWDLMFGUHUIOVTHUJUIQHUMUKZUNAWEWAWBOVTTH
        UOUPUQAVQWAVRAWAVQUCGUFUGZTULAWHTGUBZTAWFWHWIUDMGURUSTGUTVAVQVTWHTFUCGU
        FVCVDVBAWAVRTGUFUGZTULZAWFWJTUDWKMGVEWJTVFVGVRVTWJTFTGUFVCVDVBVHUQVSFUC
        TVIUAFUCTVJVKVLVMVNWGVO $.

      cantnf.4 $e |- X = U. |^| { c e. On | C e. ( A ^o c ) } $.
      cantnf.5 $e |- P = ( iota d E. a e. On E. b e. ( A ^o X )
        ( d = <. a , b >. /\ ( ( ( A ^o X ) .o a ) +o b ) = C ) ) $.
      cantnf.6 $e |- Y = ( 1st ` P ) $.
      cantnf.7 $e |- Z = ( 2nd ` P ) $.
      ${
        cantnf.8 $e |- ( ph -> G e. S ) $.
        cantnf.9 $e |- ( ph -> ( ( A CNF B ) ` G ) = Z ) $.
        cantnf.f $e |- F = ( t e. B |-> if ( t = X , Y , ( G ` t ) ) ) $.
        $( Lemma for ~ cantnf .  Here we show existence of Cantor normal
           forms.  Assuming (by transfinite induction) that every number less
           than ` C ` has a normal form, we can use ~ oeeu to factor ` C ` into
           the form ` ( ( A ^o X ) .o Y ) +o Z ` where ` 0 < Y < A ` and
           ` Z < ( A ^o X ) ` (and a fortiori ` X < B ` ).  Then since
           ` Z < ( A ^o X ) <_ ( A ^o X ) .o Y <_ C ` , ` Z ` has a normal
           form, and by appending the term ` ( A ^o X ) .o Y ` using ~ cantnfp1
           we get a normal form for ` C ` .  (Contributed by Mario Carneiro,
           28-May-2015.) $)
        cantnflem3 $p |- ( ph -> C e. ran ( A CNF B ) ) $=
          ( vk ccnf co cfv crn coe comu coa wcel wceq wss con0 c1o cdif w3a c2o
          c0 wa cantnflem2 eqid 3pm3.2i oeeui mpbiri simpld simp1d oecl syl2anc
          syl simp2d eldifad onelon wne dif1o simprbi wb on0eln0 mpbird omword1
          syl21anc omcl simp3d oaword1 simprd sseqtrd sstrd ontr2 oeord syl3anc
          wi mp2and ccnv cvv cima cv adantr cdm cnvimass cantnfs mpbid syl5sseq
          cfn fdm sselda ffvelrnd wfn ffn elpreima 3syl simplbda cep coi cseqom
          wf cmpt2 cantnfle ex cantnfp1 oveq2d 3eqtrd cantnff fnfvelrn eqeltrrd
          ssrdv ) AMGHUQURZUSZIYSUTZAYTGOVAURZPVBURZNYSUSZVCURZUUCQVCURZIAMKVDZ
          YTUUEVEZAFGHKMNOPUBUCUDUMAOHVDZUUBGHVAURZVDZAUUBIVFZIUUJVDZUUKAUUBUUC
          IAUUBVGVDZPVGVDZVLPVDZUUBUUCVFAGVGVDZOVGVDZUUNUCAUURPGVHVIVDZQUUBVDZA
          UURUUSUUTVJZUUFIVEZAGVGVKVIVDZIVGVHVIVDZVMZUVAUVBVMZABCDEGHIKLUBUCUDU
          EUFUGUHVNZUVEUVFOOVEZPPVEZQQVEZVJUVHUVIUVJOVOPVOQVOVPTRSUAGIOPJQOPQUI
          UJUKULVQVRWCZVSZVTZGOWAWBZAUUQPGVDZUUOUCAPGVHAUURUUSUUTUVLWDZWEZGPWFW
          BZAUUPPVLWGZAUUSUVSUVPUUSUVOUVSPGWHWIWCAUUOUUPUVSWJUVRPWKWCWLUUBPWMWN
          AUUCUUFIAUUCVGVDZQVGVDZUUCUUFVFAUUNUUOUVTUVNUVRUUBPWOWBAUUNUUTUWAUVNA
          UURUUSUUTUVLWPZUUBQWFWBUUCQWQWBAUVAUVBUVKWRZWSWTUFAUUNUUJVGVDZUULUUMV
          MUUKXDUVNAUUQHVGVDZUWDUCUDGHWAWBUUBIUUJXAWBXEAUURUWEUVCUUIUUKWJUVMUDA
          UVCUVDUVGVSZOHGXBXCWLUVQABNXFXGVHVIZXHZOABXIZUWHVDZUWIOVDZAUWJVMZUWKG
          UWIVAURZUUBVDZUWLUWMQVFZUUTUWNUWLUWMUWMUWINUSZVBURZQUWLUWMVGVDZUWPVGV
          DZVLUWPVDZUWMUWQVFUWLUUQUWIVGVDZUWRAUUQUWJUCXJZUWLUWEUWIHVDZUXAAUWEUW
          JUDXJZAUWHHUWIANXKZUWHHNUWGXLAHGNYHZUXEHVEAUXFUWHXPVDZANKVDZUXFUXGVMU
          MAGHKNUBUCUDXMXNVSZHGNXQWCXOXRZHUWIWFWBZGUWIWAWBZUWLUUQUWPGVDUWSUXBUW
          LHGUWINAUXFUWJUXIXJUXJXSGUWPWFWBZUWLUWTUWPVLWGZUWLUWPUWGVDZUXNAUWJUXC
          UXOAUXFNHXTUWJUXCUXOVMWJUXIHGNYAHUWIUWGNYBYCYDUXOUWPXGVDUXNUWPXGWHWIW
          CUWLUWSUWTUXNWJUXMUWPWKWCWLUWMUWPWMWNUWLUWQUUDQUWLDGHUWIKUPNUWHYEYFZU
          PDXGXGGUPXIUXPUSZVAURUXQNUSVBURDXIVCURYIVLYGZUBUXBUXDUXPVOAUXHUWJUMXJ
          UXRVOUXJYJAUUDQVEUWJUNXJWSWTAUUTUWJUWBXJUWLUWRUUNUWOUUTVMUWNXDUXLAUUN
          UWJUVNXJUWMQUUBXAWBXEUWLUXAUURUVCUWKUWNWJUXKAUURUWJUVMXJAUVCUWJUWFXJU
          WIOGXBXCWLYKYRUOYLZWRAUUDQUUCVCUNYMUWCYNAYSKXTZUUGYTUUAVDAKUUJYSYHUXT
          AGHKUBUCUDYOKUUJYSYAWCAUUGUUHUXSVSKMYSYPWBYQ $.
      $}

      $( Lemma for ~ cantnf .  Complete the induction step of ~ cantnflem3 .
         (Contributed by Mario Carneiro, 25-May-2015.) $)
      cantnflem4 $p |- ( ph -> C e. ran ( A CNF B ) ) $=
        ( vg vt cv ccnf co cfv wceq crn wcel wrex coe comu coa con0 wss c1o w3a
        cdif c2o wa cantnflem2 eqid 3pm3.2i oeeui mpbiri syl simpld simp1d oecl
        syl2anc simp2d eldifad onelon omcl simp3d oaword1 dif1o simprbi on0eln0
        c0 wne wb mpbird omword1 syl21anc sseldd simprd eleqtrd wfn cantnff ffn
        fvelrnb 3syl mpbid cif cmpt adantr simprl simprr cantnflem3 rexlimddv
        wf ) AUJULZFGUMUNZUONUPZHXMUQZURUJJANXOURZXNUJJUSZAHXONUDANFLUTUNZMVAUN
        ZNVBUNZHAXSXTNAXSVCURZNVCURZXSXTVDAXRVCURZMVCURZYAAFVCURZLVCURZYCTAYFMF
        VEVGURZNXRURZAYFYGYHVFZXTHUPZAFVCVHVGURHVCVEVGURVIZYIYJVIZABCDEFGHJKSTU
        AUBUCUDUEVJYKYLLLUPZMMUPZNNUPZVFYMYNYOLVKMVKNVKVLQOPRFHLMINLMNUFUGUHUIV
        MVNVOZVPZVQFLVRVSZAYEMFURZYDTAMFVEAYFYGYHYQVTZWAFMWBVSZXRMWCVSAYCYHYBYR
        AYFYGYHYQWDZXRNWBVSXSNWEVSAXRXSNAYCYDWIMURZXRXSVDYRUUAAUUCMWIWJZAYGUUDY
        TYGYSUUDMFWFWGVOAYDUUCUUDWKUUAMWHVOWLXRMWMWNUUBWOWOAYIYJYPWPWQWOAJFGUTU
        NZXMXKXMJWRXPXQWKAFGJSTUAWSJUUEXMWTUJJNXMXAXBXCAXLJURZXNVIZVIBCDEUKFGHI
        JKUKGUKULZLUPMUUHXLUOXDXEZXLLMNOPQRSAYEUUGTXFAGVCURUUGUAXFUBAHUUEURUUGU
        CXFAHXOVDUUGUDXFAWIHURUUGUEXFUFUGUHUIAUUFXNXGAUUFXNXHUUIVKXIXJ $.
    $}

    $d c ph $.
    $( The Cantor Normal Form theorem.  The function ` ( A CNF B ) ` , which
       maps a finitely supported function from ` B ` to ` A ` to the sum
       ` ( ( A ^o f ( a 1 ) ) o. a 1 ) +o `
       ` ( ( A ^o f ( a 2 ) ) o. a 2 ) +o ... ` over all indexes ` a < B ` such
       that ` f ( a ) ` is nonzero, is an order isomorphism from the ordering
       ` T ` of finitely supported functions to the set ` ( A ^o B ) ` under
       the natural order.  Setting ` A = om ` and letting ` B ` be arbitrarily
       large, the surjectivity of this function implies that every ordinal has
       a Cantor normal form (and injectivity, together with coherence
       ~ cantnfres , implies that such a representation is unique).
       (Contributed by Mario Carneiro, 28-May-2015.) $)
    cantnf $p |- ( ph -> ( A CNF B ) Isom T , _E ( S , ( A ^o B ) ) ) $=
      ( cep cv cfv wcel wceq wa c0 vf vg vt vd va vb vc vk vu vv wor coe co wpo
      ccnf wfo wbr wral wiso oemapso word wwe con0 oecl syl2anc eloni syl ordwe
      wi weso sopo 4syl crn cantnff wss frn onss sseld weq eleq1 imbi12d imbi2d
      wf r19.21v wel ordelss sylan sselda pm5.5 ralbidva dfss3 syl6bbr wne crab
      wb cop cint cuni comu coa wrex cio c1st c2nd adantr simplrl simprl onelon
      simplrr on0eln0 biimpar eqid cantnflem4 csn cxp coi cdm cmpt2 cseqom ccnv
      cvv c1o cdif cima fconstmpt mptpreima neirr ax-mp cfn ne0i a1i eqtri expr
      wn 0ex copab fveq2 ralbidv anbi12d fveq1 dif1o simprbi rgenw rabeq0 mpbir
      eqtr2i oieq2 ad2antrl oveq1 neeq1d syl5ibcom necon2d oe0m1 bitr3d 3imtr4d
      mto syl5 imp fmptd 0fin eqeltrri cantnfs mpbir2and cantnfval cen we0 oien
      mp2an en0 fveq2i seqom0g syl6eq wfn ffn fnfvelrn eqeltrrd pm2.61ne sylbid
      mpbi com23 a2i syl5bi tfis2 com3l mpdd ssrdv eqssd dffo2 sylanbrc eleq12d
      ex imbi1d cbvrexv eleq12 syl2an eqeqan12d rexbidv syl5bb cbvopabv simprll
      simprlr simprr cantnflem1 fvex epelc sylibr ralrimivva soisoi syl22anc )
      AHIUKFGULUMZNUNZHUXJFGUOUMZUPZUAOZUBOZIUQZUXNUXLPZUXOUXLPZNUQZVIZUBHURUAH
      URHUXJINUXLUSABCDEFGHIJKLMUTAUXJVAZUXJNVBUXJNUKUXKAUXJVCQZUYAAFVCQZGVCQZU
      YBKLFGVDVEZUXJVFVGZUXJVHUXJNVJUXJNVKVLAHUXJUXLWCZUXLVMZUXJRUXMAFGHJKLVNZA
      UYHUXJAUYGUYHUXJVOUYIHUXJUXLVPVGAUCUXJUYHAUCOZUXJQZUYJVCQZUYJUYHQZAUXJVCU
      YJAUYBUXJVCVOUYEUXJVQVGVRUYLAUYKUYMAUYKUYMVIZVIZACOZUXJQZUYPUYHQZVIZVIZUC
      CUCCVSZUYNUYSAVUAUYKUYQUYMUYRUYJUYPUXJVTUYJUYPUYHVTWAWBUYTCUYJURAUYSCUYJU
      RZVIZUYLUYOAUYSCUYJWDVUCUYOVIUYLAVUBUYNAUYKVUBUYMAUYKVUBUYMVIAUYKSZVUBUYJ
      UYHVOZUYMVUDVUBUYRCUYJURVUEVUDUYSUYRCUYJVUDCUCWESUYQUYSUYRWOVUDUYJUXJUYPA
      UYAUYKUYJUXJVOUYFUXJUYJWFWGWHUYQUYRWIVGWJCUYJUYHWKWLAUYKVUEUYMAUYKVUESZSZ
      UYMTUYHQUYJTUYJTUYHVTVUGUYJTWMZSBCDEFGUYJUDOUEOZUFOZWPRFUYJFUGOZULUMQUGVC
      WNWQWRZULUMZVUIWSUMVUJWTUMUYJRSUFVUMXAUEVCXAUDXBZHIVULVUNXCPZVUNXDPZUEUFU
      GUDJVUGUYCVUHAUYCVUFKXEZXEVUGUYDVUHAUYDVUFLXEZXEMAUYKVUEVUHXFAUYKVUEVUHXI
      VUGTUYJQZVUHVUGUYLVUSVUHWOVUGUYBUYKUYLAUYBVUFUYEXEAUYKVUEXGUXJUYJXHVEUYJX
      JVGXKVULXLVUNXLVUOXLVUPXLXMVUGGTXNXOZUXLPZTUYHVUGVVATNXPZXQZUHDYAYAFUHOZV
      VBPZULUMVVEVUTPWSUMDOZWTUMXRZTXSZPZTVUGDFGHUHVUTVVBVVHJVUQVURTVUTXTYAYBYC
      ZYDZRVVBVVKNXPRVVKTVVJQZCGWNZTCGTVVJVUTCGTYEZYFVVMTRVVLYNZCGURVVOCGVVLTTW
      MZTYGVVLTYAQZVVPTYAUUAUUBUUPUUCVVLCGUUDUUEUUFZTVVKNUUGYHVUGVUTHQZGFVUTWCZ
      VVKYIQZVUGCGTFVUTVUGUYPGQZTFQZVWBGTWMZVUGVWCGUYPYJVUGTGULUMZTRZFTWMZVWDVW
      CVUGFTVWETVUGUXJTWMZFTRZVWETWMUYKVWHAVUEUXJUYJYJUUHVWIUXJVWETFTGULUUIUUJU
      UKUULVUGUYDVWDVWFWOVURUYDTGQVWDVWFGXJGUUMUUNVGVUGUYCVWCVWGWOVUQFXJVGUUOUU
      QUURVVNUUSVWAVUGTVVKYIVVRUUTUVAYKAVVSVVTVWASWOVUFAFGHVUTJKLUVBXEUVCZVVHXL
      ZUVDVVITVVHPZTVVCTVVHVVCTUVEUQZVVCTRVVQTNVBVWMYONUVFTNVVBYAVVBXLUVGUVHVVC
      UVIUVSUVJVVQVWLTRYOVVGVVHTVWKUVKYHYLUVLVUGUXLHUVMZVVSVVAUYHQVUGUYGVWNAUYG
      VUFUYIXEHUXJUXLUVNVGVWJHVUTUXLUVOVEUVPUVQYMUVRUWKUVTUWAYKUWBUWCUWDUWEUWFU
      WGHUXJUXLUWHUWIAUXTUAUBHHAUXNHQZUXOHQZSZUXPUXSAVWQUXPSZSZUXQUXRQUXSVWSUIU
      JUCEFGHIUHUXNUXOUHUCYAYAFVVDUXOXTVVJYDNXPZPZULUMVXAUXOPWSUMUYJWTUMXRTXSZV
      WTVUKUXNPVUKUXOPQUGGWNWRZUGJAUYCVWRKXEAUYDVWRLXEIVVFBOZPZVVFUYPPZQZDEWEZE
      OZVXDPZVXIUYPPZRZVIZEGURZSZDGXAZBCYPUYJUIOZPZUYJUJOZPZQZUCEWEZVXIVXQPZVXI
      VXSPZRZVIZEGURZSZUCGXAZUIUJYPMVXPVYIBCUIUJVXPUYJVXDPZUYJUYPPZQZVYBVXLVIZE
      GURZSZUCGXABUIVSZCUJVSZSZVYIVXOVYODUCGDUCVSZVXGVYLVXNVYNVYSVXEVYJVXFVYKVV
      FUYJVXDYQVVFUYJUYPYQUWJVYSVXMVYMEGVYSVXHVYBVXLVVFUYJVXIVTUWLYRYSUWMVYRVYO
      VYHUCGVYRVYLVYAVYNVYGVYPVYJVXRRVYKVXTRVYLVYAWOVYQUYJVXDVXQYTUYJUYPVXSYTVY
      JVXRVYKVXTUWNUWOVYRVYMVYFEGVYRVXLVYEVYBVYPVYQVXJVYCVXKVYDVXIVXDVXQYTVXIUY
      PVXSYTUWPWBYRYSUWQUWRUWSYLAVWOVWPUXPUWTAVWOVWPUXPUXAAVWQUXPUXBVXCXLVWTXLV
      XBXLUXCUXQUXRUXOUXLUXDUXEUXFYMUXGUAUBHUXJINUXLUXHUXI $.

    $( The lexicographic order on a function space of ordinals gives a
       well-ordering with order type equal to the ordinal exponential.  This
       provides an alternative definition of the ordinal exponential.
       (Contributed by Mario Carneiro, 28-May-2015.) $)
    oemapwe $p |- ( ph -> ( T We S /\ dom OrdIso ( T , S ) = ( A ^o B ) ) ) $=
      ( wwe wceq cep con0 wcel syl cvv coi cdm co word oecl syl2anc eloni ordwe
      coe 3syl ccnf wiso wb cantnf isowe mpbird ccnv wa isocnv wse ovex eqeltri
      dmex exse ax-mp eqid oieu sylancl mpbi2and simpld eqcomd jca ) AHINZHIUAZ
      UBZFGUIUCZOAVMVPPNZAVPQRZVPUDZVQAFQRGQRVRKLFGUEUFZVPUGZVPUHUJAHVPIPFGUKUC
      ZULZVMVQUMABCDEFGHIJKLMUNZHVPIPWBUOSUPZAVPVOAVPVOOZWBUQZVNOZAVSVPHPIWGULZ
      WFWHURZAVRVSVTWASAWCWIWDHVPIPWBUSSAVMHIUTZVSWIURWJUMWEHTRWKHWBUBTJWBFGUKV
      AVCVBHITVDVEHVPIVNWGVNVFVGVHVIVJVKVL $.

    $( An alternative definition of ~ df-cnf which relies on ~ cantnf .  (Note
       that although the use of ` S ` seems self-referential, one can use
       ~ cantnfdm to eliminate it.)  (Contributed by Mario Carneiro,
       28-May-2015.) $)
    cantnffval2 $p |- ( ph -> ( A CNF B ) = `' OrdIso ( T , S ) ) $=
      ( ccnf ccnv wceq cep con0 wcel cvv coi wrel coe wiso cantnf isof1o f1orel
      co wf1o 3syl dfrel2 sylib cdm word wa syl2anc eloni syl isocnv wwe wse wb
      oecl oemapwe simpld ovex dmex eqeltri exse ax-mp eqid oieu sylancl simprd
      mpbi2and cnveqd eqtr3d ) AFGNUHZOZOZVRHIUAZOAVRUBZVTVRPAHFGUCUHZIQVRUDZHW
      CVRUIWBABCDEFGHIJKLMUEZHWCIQVRUFHWCVRUGUJVRUKULAVSWAAWCWAUMZPZVSWAPZAWCUN
      ZWCHQIVSUDZWGWHUOZAWCRSZWIAFRSGRSWLKLFGVCUPWCUQURAWDWJWEHWCIQVRUSURAHIUTZ
      HIVAZWIWJUOWKVBAWMWFWCPABCDEFGHIJKLMVDVEHTSWNHVRUMTJVRFGNVFVGVHHITVIVJHWC
      IWAVSWAVKVLVMVOVNVPVQ $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y z ph $.  $d x y z S $.
    cantnff1o.1 $e |- S = dom ( A CNF B ) $.
    cantnff1o.2 $e |- ( ph -> A e. On ) $.
    cantnff1o.3 $e |- ( ph -> B e. On ) $.
    $( Simplify the isomorphism of ~ cantnf to simple bijection.  (Contributed
       by Mario Carneiro, 30-May-2015.) $)
    cantnff1o $p |- ( ph -> ( A CNF B ) : S -1-1-onto-> ( A ^o B ) ) $=
      ( vz vx vy vw coe co cv cfv wcel wceq wi wral cep wa wrex copab ccnf wiso
      wf1o eqid cantnf isof1o syl ) ADBCLMZHNZINZOULJNZOPULKNZPUOUMOUOUNOQRKCSU
      AHCUBIJUCZTBCUDMZUEDUKUQUFAIJHKBCDUPEFGUPUGUHDUKUPTUQUIUJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d f g x F $.  $d f g x G $.  $d f g ph $.
    $d x D $.  $d f g S $.  $d f g T $.  $d x W $.  $d x Z $.
    mapfien.s $e |- S = { x e. ( B ^m A ) |
      ( `' x " ( _V \ { Z } ) ) e. Fin } $.
    mapfien.t $e |- T = { x e. ( D ^m C ) |
      ( `' x " ( _V \ { W } ) ) e. Fin } $.
    mapfien.w $e |- W = ( G ` Z ) $.
    mapfien.f $e |- ( ph -> F : C -1-1-onto-> A ) $.
    mapfien.g $e |- ( ph -> G : B -1-1-onto-> D ) $.
    mapfien.a $e |- ( ph -> A e. _V ) $.
    mapfien.b $e |- ( ph -> B e. _V ) $.
    mapfien.c $e |- ( ph -> C e. _V ) $.
    mapfien.d $e |- ( ph -> D e. _V ) $.
    mapfien.z $e |- ( ph -> Z e. B ) $.
    $( A bijection of the base sets induces a bijection on the set of finitely
       supported functions.  (Contributed by Mario Carneiro, 30-May-2015.) $)
    mapfien $p |- ( ph ->
        ( f e. S |-> ( G o. ( f o. F ) ) ) : S -1-1-onto-> T ) $=
      ( vg cv ccom ccnv cmpt eqid wcel wa cmap co cvv csn cdif cima cfn wf wf1o
      f1of syl adantr weq cnveq imaeq1d eleq1d elrab2 simplbi adantl elmapi fco
      syl2anc wb elmapg mpbird cnvco imaeq1i imaco eqtri 3eqtri wfun wfo dff1o3
      simprbi wss wceq f1ofun funcnvcnv imadif 4syl ssv ssdif ax-mp eqcomi fvex
      cfv elsnc mpbir a1i wfn ffn elpreima 3syl mpbir2and sscond syl5ss eqsstrd
      snssd imass2 imafi syl5eqel sylanbrc f1ocnv simpr sylib imacnvcnv imaeq2i
      ssfi simpld simplbda snidg fnfvima syl6eq coass cid cres f1ococnv1 coeq2d
      syl3anc adantrl fcoi1 eqtrd syl5eq eqeq2d coeq1d adantrr fcoi2 syl5eqr
      eqcom syl6bb bitr4d f1ofo cocan2 wf1 f1of1 cocan1 3bitr3d f1o2d ) AIUDGHK
      IUEZJUFZUFZKUGZUDUEZUFZJUGZUFZIGUULUHZUURUIAUUJGUJZUKZUULFEULUMZUJZUULUGZ
      UNLUOZUPZUQZURUJZUULHUJUUTUVBEFUULUSZUUTDFKUSZEDUUKUSZUVHAUVIUUSADFKUTZUV
      IRDFKVAZVBVCZUUTCDUUJUSZECJUSZUVJUUTUUJDCULUMZUJZUVNUUSUVQAUUSUVQUUJUGZUN
      MUOZUPZUQZURUJZBUEZUGZUVTUQZURUJZUWBBUUJUVPGBIVDZUWEUWAURUWGUWDUVRUVTUWCU
      UJVEVFVGNVHZVIVJZUUJDCVKZVBAUVOUUSAECJUTZUVOQECJVAVBVCECDUUJJVLVMZEDFKUUK
      VLVMZAUVBUVHVNZUUSAFUNUJEUNUJUWNUBUAFEUULUNUNVOVMVCVPUUTUVFUUPUVRUUMUVEUQ
      ZUQZUQZURUVFUUKUGZUWOUQZUUPUVRUFZUWOUQUWQUVFUWRUUMUFZUVEUQUWSUVCUXAUVEKUU
      KVQVRUWRUUMUVEVSVTUWRUWTUWOUUJJVQVRUUPUVRUWOVSWAUUTUUPWBZUWPURUJZUWQURUJU
      UTUWKUXBAUWKUUSQVCUWKECJWCZUXBECJWDWEVBUUTUWBUWPUWAWFZUXCUUSUWBAUUSUVQUWB
      UWHWEVJUUTUWOUVTWFUXEUUTUWOUUMUNUQZUUMUVDUQZUPZUVTUUTUVKKWBUUMUGZWBUWOUXH
      WGAUVKUUSRVCDFKWHKWIUNUVDUUMWJWKUUTUXHUNUXGUPZUVTUXFUNWFUXHUXJWFUXFWLUXFU
      NUXGWMWNUUTUVSUXGUNUUTMUXGUUTMUXGUJZMDUJZMKWQZUVDUJZAUXLUUSUCVCUXNUUTUXNU
      XMLWGLUXMPWOUXMLMKWPWRWSWTUUTUVIKDXAZUXKUXLUXNUKVNUVMDFKXBZDMUVDKXCXDXEXI
      XFXGXHUWOUVTUVRXJVBUWAUWPXSVMUUPUWPXKVMXLUWDUVEUQZURUJZUVGBUULUVAHUWCUULW
      GZUXQUVFURUXSUWDUVCUVEUWCUULVEVFVGOVHXMAUUNHUJZUKZUUQUVPUJZJUUOUGZUVTUQZU
      QZURUJZUUQGUJUYAUYBCDUUQUSZUYAEDUUOUSZCEUUPUSZUYGUYAFDUUMUSZEFUUNUSZUYHAU
      YJUXTAUVKFDUUMUTZUYJRDFKXNZFDUUMVAXDVCUYAUUNUVAUJZUYKUYAUYNUUNUGZUVEUQZUR
      UJZUYAUXTUYNUYQUKZAUXTXOUXRUYQBUUNUVAHBUDVDZUXQUYPURUYSUWDUYOUVEUWCUUNVEV
      FVGOVHZXPXTUUNFEVKVBZEFDUUMUUNVLVMZAUYIUXTAUWKCEUUPUTUYIQECJXNCEUUPVAXDVC
      CEDUUOUUPVLVMZAUYBUYGVNZUXTADUNUJCUNUJVUDTSDCUUQUNUNVOVMVCVPUYAJWBZUYDURU
      JUYFAVUEUXTAUWKVUEQECJWHVBVCUYAUYDUYOKUVTUQZUQZURUYDUYOUXIUFZUVTUQUYOUXIU
      VTUQZUQVUGUYCVUHUVTUUMUUNVQVRUYOUXIUVTVSVUIVUFUYOKUVTXQXRWAUYAUYQVUGUYPWF
      ZVUGURUJAUXTUYNUYQUXTUYRVNAUYTWTYAUYAVUFUVEWFVUJUYAVUFKUNUQZKUVSUQZUPZUVE
      UYAUVKUUMWBZVUFVUMWGAUVKUXTRVCZUVKDFKWCVUNDFKWDWEUNUVSKWJXDUYAVUMUNVULUPZ
      UVEVUKUNWFVUMVUPWFVUKWLVUKUNVULWMWNUYAUVDVULUNUYALVULUYALUXMVULPUYAUXOUVS
      DWFMUVSUJZUXMVULUJUYAUVKUVIUXOVUOUVLUXPXDUYAMDAUXLUXTUCVCZXIUYAUXLVUQVURM
      DYBVBDUVSKMYCYJXLXIXFXGXHVUFUVEUYOXJVBUYPVUGXSVMXLJUYDXKVMUWFUYFBUUQUVPGU
      WCUUQWGZUWEUYEURVUSUWEUUPUGZUYCUFZUVTUQZUYEVUSUWDVVAUVTVUSUWDUUQUGVVAUWCU
      UQVEUUOUUPVQYDVFVVBVUTUYDUQUYEVUTUYCUVTVSJUYDXQVTYDVGNVHXMAUUSUXTUKZUKZUU
      KUUQJUFZWGZUUOUUMUULUFZWGZUUJUUQWGZUUNUULWGZVVDVVFUUKUUOWGZVVHVVDVVEUUOUU
      KVVDVVEUUOUUPJUFZUFZUUOUUOUUPJYEVVDVVMUUOYFEYGZUFZUUOVVDVVLVVNUUOVVDUWKVV
      LVVNWGAUWKVVCQVCZECJYHVBYIVVDUYHVVOUUOWGAUXTUYHUUSVUBYKEDUUOYLVBYMYNYOVVD
      VVHUUOUUKWGVVKVVDVVGUUKUUOVVDVVGUUMKUFZUUKUFZUUKUUMKUUKYEVVDVVRYFDYGZUUKU
      FZUUKVVDVVQVVSUUKVVDUVKVVQVVSWGAUVKVVCRVCDFKYHVBYPVVDUVJVVTUUKWGAUUSUVJUX
      TUWLYQEDUUKYRVBYMYSYOUUOUUKYTUUAUUBVVDUXDUUJCXAZUUQCXAZVVFVVIVNVVDUWKUXDV
      VPECJUUCVBAUUSVWAUXTUUTUVQUVNVWAUWIUWJCDUUJXBXDYQAUXTVWBUUSUYAUYGVWBVUCCD
      UUQXBVBYKECJUUJUUQUUDYJVVDFDUUMUUEZUYKUVHVVHVVJVNVVDUYLVWCAUYLVVCAUVKUYLR
      UYMVBVCFDUUMUUFVBAUXTUYKUUSVUAYKAUUSUVHUXTUWMYQEFDUUMUUNUULUUGYJUUHUUI $.
  $}

  ${
    $d a b c d f w x y z A $.  $d a b c d f x y B $.  $d a b c d f w x y z F $.
    $d a b c d f x y G $.  $d a b c d f x y ph $.  $d c d w z R $.  $d c z S $.
    $d c d f x y U $.  $d f x Z $.
    wemapwe.t $e |- T = { <. x , y >. | E. z e. A ( ( x ` z ) S ( y ` z ) /\
        A. w e. A ( z R w -> ( x ` w ) = ( y ` w ) ) ) } $.
    wemapwe.u $e |- U = { x e. ( B ^m A ) |
      ( `' x " ( _V \ { Z } ) ) e. Fin } $.
    wemapwe.2 $e |- ( ph -> R We A ) $.
    wemapwe.3 $e |- ( ph -> S We B ) $.
    wemapwe.4 $e |- ( ph -> B =/= (/) ) $.
    wemapwe.5 $e |- F = OrdIso ( R , A ) $.
    wemapwe.6 $e |- G = OrdIso ( S , B ) $.
    wemapwe.7 $e |- Z = ( G ` (/) ) $.
    $( Construct lexicographic order on a function space based on a reverse
       well-ordering of the indexes and a well-ordering of the values.
       (Contributed by Mario Carneiro, 29-May-2015.) $)
    wemapwe $p |- ( ph -> T We U ) $=
      ( vf vc va vb vd cvv wcel wa wwe cxp cin ccnv ccom cmpt cfv wceq cdm wral
      cv wi wrex copab wbr ccnf co wf1o csn cdif cima cfn cmap crab eqid simprr
      cep wiso adantr oiiso syl2anc isof1o syl simprl 3syl oiexg ad2antll dmexg
      ad2antrl c0 wne crn wfo f1ofo forn sylibr wb oif ffvelrni c1o con0 syl5eq
      oion mpbird weinxp fveq2 breq12d ralbidv anbi12d vex coexg sylancr syl2an
      fveq1 weq coeq2d fvmptg ad2antrr wf sseldi elmapi ffvelrn isorel syl12anc
      coeq1 sylancl fvco3 sylancom fveq2d eqtrd bitr4d eqeq12d imbi12d ffvelrnd
      fco adantrr ex inopab eqtri wn f1ocnv dm0rn0 necon3bii word oicl ord0eln0
      eqnetrd ax-mp syl5eqel mapfien cantnfdm f1ocnvfv1 syl6eqr difeq2d imaeq2d
      fveq2i sneqd df1o2 eleq1d rabbidv eqtr4d f1oeq3 coi coe simpld f1owe sylc
      oemapwe sylib wfn f1ofn breq1 imbi1d rexrn cnvexg eleq12 eqeqan12d imbi2d
      rexeqdv rexbidv brabga isocnv ssrab2 eqsstri epelc syl6bb eleq12d raleqdv
      fvex simpr breq2 ralrn bitr3d epel syl5bbr f1fveq 3bitrd anassrs ralbidva
      wf1 f1of1 rexbidva 3bitr4rd 3bitr3d pm5.32rd df-xp ineq12i ineq2i 3eqtr4g
      opabbidv weeq1 we0 elmapex con3i pm2.21d ralrimiv rabeq0 mpbiri pm2.61d1
      weeq2 ) AGUHUIZFUHUIZUJZKJUKZAUYCUYDAUYCUJZKJKKULZUMZUKZUYDUYEUYHKBVAZUCK
      MUNZUCVAZLUOZUOZUPZUQZCVAZUYNUQZUDVAZUEVAZUQZUYRUFVAZUQZUIZUYRUGVAZUIZVUD
      UYSUQZVUDVUAUQZURZVBZUGLUSZUTZUJZUDVUJVCZUEUFVDZVEZBCVDZUYFUMZUKZUYEKVUPU
      KZVURUYEKMUSZVUJVFVGUSZUYNVHZVVAVUNUKZVUSUYEVVBKUYIUNZUHNUYJUQZVIZVJZVKZV
      LUIZBVUTVUJVMVGZVNZUYNVHZUYEBFGVUJVUTKVVKUCLUYJVVENPVVKVOVVEVOUYEVUJFVQHL
      VRZVUJFLVHZUYEUYBFHUKZVVMAUYAUYBVPZAVVOUYCQVSFHLUHTVTWAZVUJFVQHLWBWCZUYEV
      UTGVQIMVRZVUTGMVHZGVUTUYJVHZUYEUYAGIUKZVVSAUYAUYBWDZAVWBUYCRVSGIMUHUAVTWA
      ZVUTGVQIMWBZVUTGMUUAZWEVVPVWCUYELUHUIZVUJUHUIUYBVWGAUYAFHLUHTWFWGZLUHWHWC
      UYEMUHUIZVUTUHUIUYAVWIAUYBGIMUHUAWFWIZMUHWHWCUYENWJMUQZGUBUYEWJVUTUIZVWKG
      UIUYEVUTWJWKZVWLUYEMWLZWJWKVWMUYEVWNGWJUYEVVTVUTGMWMVWNGURUYEVVSVVTVWDVWE
      WCZVUTGMWNVUTGMWOWEAGWJWKUYCSVSUUGVUTWJVWNWJMUUBUUCWPVUTUUDVWLVWMWQGIMUAU
      UEVUTUUFUUHWPZVUTGWJMGIMUAWRWSWCUUIUUJUYEVVAVVKURVVBVVLWQUYEVVAVVDUHWTVJZ
      VKZVLUIZBVVJVNZVVKUYEVUTVUJVWTBVWTVOUYAVUTXAUIAUYBGIMUHUAXCWIZUYBVUJXAUIA
      UYAFHLUHTXCWGZUUKUYEVVIVWSBVVJUYEVVHVWRVLUYEVVGVWQVVDUYEVVFWTUHUYEVVFWJVI
      WTUYEVVEWJUYEVVEVWKUYJUQZWJNVWKUYJUBUUPUYEVVTVWLVXCWJURVWOVWPVUTGWJMUULWA
      XBUUQUURUUMUUNUUOUUSUUTUVAVVAVVKKUYNUVBWCXDUYEVVCVVAVUNUVCUSVUTVUJUVDVGUR
      UYEUEUFUDUGVUTVUJVVAVUNVVAVOVXAVXBVUNVOZUVHUVEBCKVVAVUPVUNUYNVUPVOUVFUVGK
      VUPXEUVIUYEUYGVUQURUYHVURWQUYEDVAZUYIUQZVXEUYPUQZIVEZVXEEVAZHVEZVXIUYIUQZ
      VXIUYPUQZURZVBZEFUTZUJZDFVCZUYIKUIZUYPKUIZUJZUJZBCVDZVUOVXTUJZBCVDZUYGVUQ
      UYEVYAVYCBCUYEVXTVXQVUOUYEVXTVXQVUOWQUYEVXTUJZVXPDLWLZVCZUYRLUQZUYIUQZVYH
      UYPUQZIVEZVYHVXIHVEZVXMVBZEFUTZUJZUDVUJVCZVXQVUOVYEVVNLVUJUVJZVYGVYPWQUYE
      VVNVXTVVRVSZVUJFLUVKZVXPVYODUDVUJLVXEVYHURZVXHVYKVXOVYNVYTVXFVYIVXGVYJIVX
      EVYHUYIXFVXEVYHUYPXFXGVYTVXNVYMEFVYTVXJVYLVXMVXEVYHVXIHUVLUVMXHXIUVNWEVYE
      VXPDVYFFVYEVVNVUJFLWMVYFFURVYRVUJFLWNVUJFLWOWEZUVSVYEUYJUYILUOZUOZUYJUYPL
      UOZUOZVUNVEZUYRWUCUQZUYRWUEUQZUIZVUEVUDWUCUQZVUDWUEUQZURZVBZUGVUJUTZUJZUD
      VUJVCZVUOVYPVYEWUCUHUIZWUEUHUIZWUFWUPWQVYEUYJUHUIZWUBUHUIZWUQVYEVWIWUSUYE
      VWIVXTVWJVSMUHUVOWCZVYEUYIUHUIVWGWUTBXJUYEVWGVXTVWHVSZUYILUHUHXKXLUYJWUBU
      HUHXKWAZVYEWUSWUDUHUIZWURWVAVYEUYPUHUIVWGWVDCXJWVBUYPLUHUHXKXLUYJWUDUHUHX
      KWAZVUMWUPUEUFWUCWUEVUNUHUHUYSWUCURZVUAWUEURZUJZVULWUOUDVUJWVHVUCWUIVUKWU
      NWVFUYTWUGURVUBWUHURVUCWUIWQWVGUYRUYSWUCXNUYRVUAWUEXNUYTWUGVUBWUHUVPXMWVH
      VUIWUMUGVUJWVHVUHWULVUEWVFWVGVUFWUJVUGWUKVUDUYSWUCXNVUDVUAWUEXNUVQUVRXHXI
      UVTVXDUWAWAVYEUYOWUCUYQWUEVUNVYEVXRWUQUYOWUCURUYEVXRVXSWDZWVCUCUYIUYMWUCK
      UHUYNUCBXOUYLWUBUYJUYKUYILYEXPUYNVOZXQWAVYEVXSWURUYQWUEURUYEVXRVXSVPZWVEU
      CUYPUYMWUEKUHUYNUCCXOUYLWUDUYJUYKUYPLYEXPWVJXQWAXGVYEVYOWUOUDVUJVYEUYRVUJ
      UIZUJZVYKWUIVYNWUNWVMVYKVYIUYJUQZVYJUYJUQZUIZWUIWVMVYKWVNWVOVQVEZWVPWVMGV
      UTIVQUYJVRZVYIGUIZVYJGUIZVYKWVQWQWVMVVSWVRUYEVVSVXTWVLVWDXRVUTGVQIMUWBWCV
      YEFGUYIXSZVYHFUIZWVSWVLVYEUYIGFVMVGZUIZWWAVYEKWWCUYIKVVDUHNVIVJVKVLUIZBWW
      CVNZWWCPWWEBWWCUWCUWDZWVIXTUYIGFYAWCZVUJFUYRLFHLTWRZWSZFGVYHUYIYBXMVYEFGU
      YPXSZWWBWVTWVLVYEUYPWWCUIWWKVYEKWWCUYPWWGWVKXTUYPGFYAWCZWWJFGVYHUYPYBXMGV
      UTVYIVYJIVQUYJYCYDWVNWVOVYJUYJUWIUWEUWFWVMWUGWVNWUHWVOWVMWUGUYRWUBUQZUYJU
      QZWVNVYEWVLVUJGWUBXSZWUGWWNURWVMWWAVUJFLXSZWWOVYEWWAWVLWWHVSWWIVUJFGUYILY
      OYFZVUJGUYRUYJWUBYGYHWVMWWMVYIUYJWVMWWPWVLWWMVYIURWWIVYEWVLUWJZVUJFUYRUYI
      LYGXLYIYJWVMWUHUYRWUDUQZUYJUQZWVOVYEWVLVUJGWUDXSZWUHWWTURWVMWWKWWPWXAVYEW
      WKWVLWWLVSWWIVUJFGUYPLYOYFZVUJGUYRUYJWUDYGYHWVMWWSVYJUYJWVMWWPWVLWWSVYJUR
      WWIWWRVUJFUYRUYPLYGXLYIYJUWGYKWVMVYNVYHVUDLUQZHVEZWXCUYIUQZWXCUYPUQZURZVB
      ZUGVUJUTZWUNVYEVYNWXIWQWVLVYEVYMEVYFUTZVYNWXIVYEVYMEVYFFWUAUWHVYEVVNVYQWX
      JWXIWQVYRVYSVYMWXHEUGVUJLVXIWXCURZVYLWXDVXMWXGVXIWXCVYHHUWKWXKVXKWXEVXLWX
      FVXIWXCUYIXFVXIWXCUYPXFYLYMUWLWEUWMVSWVMWUMWXHUGVUJVYEWVLVUDVUJUIZWUMWXHW
      QVYEWVLWXLUJZUJZVUEWXDWULWXGVUEUYRVUDVQVEZWXNWXDUDUGUWNVYEWXMVVMWXOWXDWQU
      YEVVMVXTWXMVVQXRVUJFUYRVUDVQHLYCYHUWOWXNWULVUDWUBUQZUYJUQZVUDWUDUQZUYJUQZ
      URZWXPWXRURZWXGWXNWUJWXQWUKWXSWXNWWOWXLWUJWXQURVYEWVLWWOWXLWWQYPZVYEWVLWX
      LVPZVUJGVUDUYJWUBYGWAWXNWXAWXLWUKWXSURVYEWVLWXAWXLWXBYPZWYCVUJGVUDUYJWUDY
      GWAYLWXNGVUTUYJUWTZWXPGUIWXRGUIWXTWYAWQWXNVVTVWAWYEUYEVVTVXTWXMVWOXRVWFGV
      UTUYJUXAWEWXNVUJGVUDWUBWYBWYCYNWXNVUJGVUDWUDWYDWYCYNGVUTWXPWXRUYJUWPYDWXN
      WXPWXEWXRWXFWXNWWPWXLWXPWXEURWWIWYCVUJFVUDUYILYGXLWXNWWPWXLWXRWXFURWWIWYC
      VUJFVUDUYPLYGXLYLUWQYMUWRUWSYKXIUXBUXCUXDYQUXEUXJUYGVXQBCVDZVXTBCVDZUMVYB
      JWYFUYFWYGOBCKKUXFZUXGVXQVXTBCYRYSVUQVUPWYGUMVYDUYFWYGVUPWYHUXHVUOVXTBCYR
      YSUXIKUYGVUQUXKWCXDKJXEWPYQUYCYTZUYDWJJUKZJUXLWYIKWJURUYDWYJWQWYIKWWFWJPW
      YIWWEYTZBWWCUTWWFWJURWYIWYKBWWCWYIWWDWYKWWDUYCUYIGFUXMUXNUXOUXPWWEBWWCUXQ
      WPXBKWJJUXTWCUXRUXS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y ph $.
    $d x y F $.  $d x y G $.
    oef1o.f $e |- ( ph -> F : A -1-1-onto-> C ) $.
    oef1o.g $e |- ( ph -> G : B -1-1-onto-> D ) $.
    oef1o.a $e |- ( ph -> A e. ( On \ 1o ) ) $.
    oef1o.b $e |- ( ph -> B e. On ) $.
    oef1o.c $e |- ( ph -> C e. On ) $.
    oef1o.d $e |- ( ph -> D e. On ) $.
    oef1o.z $e |- ( ph -> ( F ` (/) ) = (/) ) $.
    oef1o.k $e |- K = ( y e. { x e. ( A ^m B ) |
      ( `' x " ( _V \ 1o ) ) e. Fin } |-> ( F o. ( y o. `' G ) ) ) $.
    oef1o.h $e |- H = ( ( ( C CNF D ) o. K ) o. `' ( A CNF B ) ) $.
    $( A bijection of the base sets induces a bijection on ordinal
       exponentials.  (The assumption ` ( F `` (/) ) = (/) ` can be discharged
       using ~ fveqf1o .)  (Contributed by Mario Carneiro, 30-May-2015.) $)
    oef1o $p |- ( ph -> H : ( A ^o B ) -1-1-onto-> ( C ^o D ) ) $=
      ( coe co ccnf ccom ccnv wf1o cdm eqid cantnff1o cv cvv c1o cdif cima wcel
      cfn cmap crab c0 cfv csn cmpt wb df1o2 difeq2i imaeq2i eleq1i a1i rabbiia
      f1ocnv syl con0 sseldi eldifad ondif1 simprbi mapfien f1oeq1 ax-mp sylibr
      wceq cantnfdm syl6eqr difeq2d imaeq2d eleq1d rabbidv eqtr4d f1oeq3 mpbird
      ssv sneqd f1oeq2 f1oco syl2anc ) ADEUAUBZFGUAUBZFGUCUBZKUDZDEUCUBZUEZUDZU
      FZWPWQJUFZAWTUGZWQWSUFZWPXEXAUFZXCAWRUGZWQWRUFXEXHKUFZXFAFGXHXHUHPQUIAXIB
      UJZUEZUKULUMZUNZUPUOZBDEUQUBZURZXHKUFZAXQXPXKUKUSHUTZVAZUMZUNZUPUOZBFGUQU
      BZURZKUFZAXPYDCXPHCUJIUEZUDUDVBZUFZYEABEDGFXPYDCYFHXRUSXNXKUKUSVAZUMZUNZU
      PUOZBXOXNYLVCXJXOUOXMYKUPXLYJXKULYIUKVDVEVFVGVHVIYDUHXRUHAEGIUFGEYFUFMEGI
      VJVKLAVLUKEVLWKZOVMAVLUKDYMADVLULNVNZVMAVLUKGYMQVMAVLUKFYMPVMADVLULUMUOZU
      SDUOZNYODVLUOYPDVOVPVKVQKYGWAYEYHVCSXPYDKYGVRVSVTAXHYDWAXQYEVCAXHXNBYCURZ
      YDAFGYQBYQUHPQWBAYBXNBYCAYAXMUPAXTXLXKAXSULUKAXSYIULAXRUSRWLVDWCWDWEWFWGW
      HXHYDXPKWIVKWJAXEXPWAXIXQVCADEXPBXPUHYNOWBXEXPXHKWMVKWJXEXHWQWRKWNWOAXEWP
      WTUFXGADEXEXEUHYNOUIXEWPWTVJVKWPXEWQWSXAWNWOJXBWAXDXCVCTWPWQJXBVRVSVT $.
  $}

  ${
    $d k x z A $.  $d k u v w x y z I $.  $d x y M $.  $d u v w y ph $.
    $d f k u v w x y z F $.  $d u v w K $.  $d u v w y z T $.  $d u v x W $.
    $d f k u v w x y z G $.  $d f u v w x y H $.  $d k z S $.
    cnfcom.s $e |- S = dom ( om CNF A ) $.
    cnfcom.a $e |- ( ph -> A e. On ) $.
    cnfcom.b $e |- ( ph -> B e. ( om ^o A ) ) $.
    cnfcom.f $e |- F = ( `' ( om CNF A ) ` B ) $.
    cnfcom.g $e |- G = OrdIso ( _E , ( `' F " ( _V \ 1o ) ) ) $.
    cnfcom.h $e |- H = seqom ( ( k e. _V , z e. _V |-> ( M +o z ) ) , (/) ) $.
    cnfcom.t $e |- T = seqom ( ( k e. _V , f e. _V |-> K ) , (/) ) $.
    cnfcom.m $e |- M = ( ( om ^o ( G ` k ) ) .o ( F ` ( G ` k ) ) ) $.
    cnfcom.k $e |- K = ( ( x e. M |-> ( dom f +o x ) ) u.
      `' ( x e. dom f |-> ( M +o x ) ) ) $.
    ${
      cnfcom.1 $e |- ( ph -> I e. dom G ) $.
      ${
        cnfcom.2 $e |- ( ph -> O e. ( om ^o ( G ` I ) ) ) $.
        cnfcom.3 $e |- ( ph -> ( T ` I ) : ( H ` I ) -1-1-onto-> O ) $.
        $( Lemma for ~ cnfcom .  (Contributed by Mario Carneiro,
           30-May-2015.) $)
        cnfcomlem $p |- ( ph -> ( T ` suc I ) : ( H ` suc I ) -1-1-onto->
          ( ( om ^o ( G ` I ) ) .o ( F ` ( G ` I ) ) ) ) $=
          ( vy vu vv csuc cfv com coe co comu coa wf1o cv cmpt ccnv con0 omelon
          cun wcel cvv c1o cdif cima cdm cnvimass wf wceq cfn wa ccnf cantnff1o
          a1i f1ocnv f1of 3syl ffvelrnd syl5eqel cantnfs mpbid fdm syl syl5sseq
          simpld cep oif ffvelrni sseldd onelon syl2anc oecl nnon omcl cantnfcl
          sylancr wwe simprd elnn cantnfvalf eqid oacomf1o wb cmpt2 c0 seqomsuc
          nfcv weq oveq2 cbvmptv simpl fveq2d oveq2d oveq12d syl5eq simpr dmeqd
          oveq1d mpteq12dv cnveqd uneq12d simprl f1odm sylan9eqr elex fvex ovex
          cbvmpt2 mptex mpbird cseqom syl21anc wss wbr adantr cnvex unex f1oeq1
          ovmpt2d eqtrd oveq1i mpt2eq3ia seqomeq12 mp2an eqtri cantnfsuc f1oeq2
          sssucid sseldi wral epelg biimpar wiso ssexd word oicl ordelss sselda
          oiiso isorel syl12anc epelc sylib ralrimiva wfun ffun ax-mp funimass4
          w3a simpll simplr peano1 simpr1 simpr2 cantnflt syl23anc wne elpreima
          simpr3 wfn ffn dif1o simprbi on0eln0 omword1 oaabs2 f1oeq3 ) AMULZLUM
          ZMLUMZUNMKUMZUOUPZUWPJUMZUQUPZURUPZUWMGUMZUSZUWNUWSUXAUSZAUXBUWSUWOUR
          UPZUWTUXAUSZAUXEUXDUWTUIUWSUWOUIUTZURUPZVAZUIUWOUWSUXFURUPZVAZVBZVEZU
          SZAUWSVCVFZUWOVCVFZUXMAUWQVCVFZUWRVCVFZUXNAUNVCVFZUWPVCVFZUXPVDADVCVF
          ZUWPDVFZUXSRAJVBVGVHVIZVJZDUWPAJVKZUYCDJUYBVLADUNJVMZUYDDVNAUYEUYCVOV
          FZAJFVFZUYEUYFVPAJEUNDVQUPZVBZUMFTAUNDUOUPZFEUYIAFUYJUYHUSUYJFUYIUSUY
          JFUYIVMAUNDFQUXRAVDVSZRVRFUYJUYHVTUYJFUYIWAWBSWCWDZAUNDFJQUYKRWEWFWJZ
          DUNJWGWHWIZAMKVKZVFZUWPUYCVFZUFUYOUYCMKUYCWKKUAWLZWMWHZWNZDUWPWOWPZUN
          UWPWQXAZAUWRUNVFUXQADUNUWPJUYMUYTWCUWRWRWHZUWQUWRWSWPZAMUNVFZUXOAUYPU
          YOUNVFZVUEUFAUYCWKXBZVUFAUNDFJKQUYKRUAUYLWTZXCMUYOXDWPZUNVCMLCVGVGOCU
          TZILUBXEWMWHUIUWSUWOUXLUXLXFXGWPAUXAUXLVNUXEUXMXHAUXAMMGUMZIHVGVGNXIZ
          UPZUXLAVUEUXAVUMVNVUIMVULGXJUCXKWHAUJUKMVUKVGVGUIUNUJUTZKUMZUOUPZVUOJ
          UMZUQUPZUKUTZVKZUXFURUPZVAZUIVUTVURUXFURUPZVAZVBZVEZUXLVULVGVULUJUKVG
          VGVVFXIVNAIHUJUKVGVGNVVFUJNXLUKNXLIVVFXLHVVFXLIUJXMZHUKXMZVPZNBOHUTZV
          KZBUTZURUPZVAZBVVKOVVLURUPZVAZVBZVEVVFUEVVIVVNVVBVVQVVEVVIVVNUIOVVKUX
          FURUPZVAVVBBUIOVVMVVRVVLUXFVVKURXNXOVVIUIOVVRVURVVAVVIOUNIUTZKUMZUOUP
          ZVVTJUMZUQUPZVURUDVVIVWAVUPVWBVUQUQVVIVVTVUOUNUOVVIVVSVUNKVVGVVHXPXQZ
          XRVVIVVTVUOJVWDXQXSXTZVVIVVKVUTUXFURVVIVVJVUSVVGVVHYAYBZYCYDXTVVIVVPV
          VDVVIVVPUIVVKOUXFURUPZVAVVDBUIVVKVVOVWGVVLUXFOURXNXOVVIUIVVKVWGVUTVVC
          VWFVVIOVURUXFURVWEYCYDXTYEYFXTYMVSAVUNMVNZVUSVUKVNZVPZVPZVVBUXHVVEUXK
          VWKUIVURVVAUWSUXGVWKVUPUWQVUQUWRUQVWKVUOUWPUNUOVWKVUNMKAVWHVWIYGXQZXR
          VWKVUOUWPJVWLXQXSZVWKVUTUWOUXFURVWJAVUTVUKVKZUWOVWJVUSVUKVWHVWIYAYBAU
          WOPVUKUSVWNUWOVNUHUWOPVUKYHWHYIZYCYDVWKVVDUXJVWKUIVUTVVCUWOUXIVWOVWKV
          URUWSUXFURVWMYCYDYEYFAUYPMVGVFUFMUYOYJWHVUKVGVFAMGYKVSUXLVGVFAUXHUXKU
          IUWSUXGUWQUWRUQYLYNUXJUIUWOUXIMLYKYNUUAUUBVSUUDUUEUXDUWTUXAUXLUUCWHYO
          AUWNUXDVNZUXBUXEXHAUXTUYGVUEVWPRUYLVUIUXTUYGVPZCUNDFIJKLMQUXRVWQVDVSU
          XTUYGXPUAUXTUYGYALICVGVGOVUJURUPZXIZXJYPZICVGVGVWCVUJURUPZXIZXJYPZUBV
          WSVXBVNXJXJVNVWTVXCVNICVGVGVWRVXAVWRVXAVNVVSVGVFVUJVGVFVPOVWCVUJURUDU
          UFVSUUGXJXFVWSVXBXJXJUUHUUIUUJZUUKYQUWNUXDUWTUXAUULWHYOAUWTUWSVNZUXBU
          XCXHAUWOUWQVFZUXNUWQUWSYRZVXEAUXTUYGMUYOULZVFZUXSKMVJUWPYRZVXFRUYLAUY
          OVXHMUYOUUMUFUUNVUAAVXJUXFKUMZUWPVFZUIMUUOZAVXLUIMAUXFMVFZVPZVXKUWPWK
          YSZVXLVXOUXFMWKYSZVXPAVXQVXNAUYPVXQVXNXHUFUXFMUYOUUPWHUUQVXOUYOUYCWKW
          KKUURZUXFUYOVFUYPVXQVXPXHAVXRVXNAUYCVGVFVUGVXRAUYCDVCRUYNUUSAVUGVUFVU
          HWJUYCWKKVGUAUVDWPYTAMUYOUXFAUYOUUTUYPMUYOYRZUYCWKKUAUVAUFUYOMUVBXAZU
          VCAUYPVXNUFYTUYOUYCUXFMWKWKKUVEUVFWFVXKUWPMKYKUVGUVHUVIAKUVJZVXSVXJVX
          MXHUYOUYCKVMVYAUYRUYOUYCKUVKUVLVXTUIMUWPKUVMXAYOVWQVXIUXSVXJUVNZVPZCU
          NDUWPFIJKLMQUXRVYCVDVSUXTUYGVYBUVOUAUXTUYGVYBUVPVXDXJUNVFVYCUVQVSVWQV
          XIUXSVXJUVRVWQVXIUXSVXJUVSVWQVXIUXSVXJUWDUVTUWAVUDAUXPUXQXJUWRVFZVXGV
          UBVUCAVYDUWRXJUWBZAUWRUYBVFZVYEAUYAVYFAUYQUYAVYFVPZUYSAUYEJDUWEUYQVYG
          XHUYMDUNJUWFDUWPUYBJUWCWBWFXCVYFUWRVGVFVYEUWRVGUWGUWHWHAUXQVYDVYEXHVU
          CUWRUWIWHYOUWQUWRUWJYQUWOUWSUWPUWKYQUWTUWSUWNUXAUWLWHWF $.
      $}

      $( Any ordinal ` B ` is equinumerous to the leading term of its Cantor
         normal form.  Here we show that bijection explicitly.  (Contributed by
         Mario Carneiro, 30-May-2015.) $)
      cnfcom $p |- ( ph -> ( T ` suc I ) : ( H ` suc I ) -1-1-onto->
        ( ( om ^o ( G ` I ) ) .o ( F ` ( G ` I ) ) ) ) $=
        ( vw vy cdm wcel csuc cfv com coe co comu wf1o wi ccnv cvv c1o cdif cep
        cima wwe con0 omelon a1i wf cantnff1o f1ocnv ffvelrnd syl5eqel cantnfcl
        ccnf f1of 3syl simprd elnn syl2anc wceq eleq1 suceq fveq2d fveq2 oveq2d
        cv oveq12d f1oeq123d imbi12d imbi2d c0 wa adantr simpr wss cnvimass cfn
        cantnfs mpbid simpld fdm syl syl5sseq onss sstrd ffvelrni syl2an peano1
        oif ssel2 oen0 syl21anc 0ex cmpt2 seqom0g ax-mp f1o0 wb coa f1oeq2 mp2b
        mpbir f1oeq1 mpbiri mp1i cnfcomlem ex wtr word oicl ordtr mpan ad2antrr
        trsuc ad2antrl sseldd wbr epelc syl31anc mpd eloni vex sucid wiso ssexd
        imim1i simprl oiiso syl12anc sucex fvex 3bitr3g mpbii ordsucss suceloni
        isorel sylc oewordi nnon oecl omord2 oesuc eleqtrrd simprr exp32 expcom
        a2d syl5 finds2 vtoclga mpcom ) AMKUHZUIZMUJZLUKZULMKUKZUMUNZUVPJUKZUOU
        NZUVNGUKZUPZUEMULUIZAUVMUWAUQZAUVMUVLULUIZUWBUEAJURUSUTVAZVCZVBVDZUWDAU
        LDFJKPULVEUIZAVFVGZQTAJEULDVNUNZURZUKFSAULDUMUNZFEUWKAFUWLUWJUPUWLFUWKU
        PUWLFUWKVHAULDFPUWIQVIFUWLUWJVJUWLFUWKVOVPRVKVLZVMZVQMUVLVRVSAUFWFZUVLU
        IZUWOUJZLUKZULUWOKUKZUMUNZUWSJUKZUOUNZUWQGUKZUPZUQZUQAUWCUQUFMULUWOMVTZ
        UXEUWCAUXFUWPUVMUXDUWAUWOMUVLWAUXFUWRUVOUXBUVSUXCUVTUXFUWQUVNGUWOMWBZWC
        UXFUWQUVNLUXGWCUXFUWTUVQUXAUVRUOUXFUWSUVPULUMUWOMKWDZWEUXFUWSUVPJUXHWCW
        GWHWIWJUXEWKUVLUIZWKUJZLUKZULWKKUKZUMUNZUXLJUKZUOUNZUXJGUKZUPZUQUGWFZUV
        LUIZUXRUJZLUKZULUXRKUKZUMUNZUYBJUKZUOUNZUXTGUKZUPZUQZUXTUVLUIZUXTUJZLUK
        ZULUXTKUKZUMUNZUYLJUKZUOUNZUYJGUKZUPZUQZAUFUGUWOWKVTZUWPUXIUXDUXQUWOWKU
        VLWAUYSUWRUXKUXBUXOUXCUXPUYSUWQUXJGUWOWKWBZWCUYSUWQUXJLUYTWCUYSUWTUXMUX
        AUXNUOUYSUWSUXLULUMUWOWKKWDZWEUYSUWSUXLJVUAWCWGWHWIUWOUXRVTZUWPUXSUXDUY
        GUWOUXRUVLWAVUBUWRUYAUXBUYEUXCUYFVUBUWQUXTGUWOUXRWBZWCVUBUWQUXTLVUCWCVU
        BUWTUYCUXAUYDUOVUBUWSUYBULUMUWOUXRKWDZWEVUBUWSUYBJVUDWCWGWHWIUWOUXTVTZU
        WPUYIUXDUYQUWOUXTUVLWAVUEUWRUYKUXBUYOUXCUYPVUEUWQUYJGUWOUXTWBZWCVUEUWQU
        YJLVUFWCVUEUWTUYMUXAUYNUOVUEUWSUYLULUMUWOUXTKWDZWEVUEUWSUYLJVUGWCWGWHWI
        AUXIUXQAUXIWLZBCDEFGHIJKLWKNOWKPADVEUIZUXIQWMAEUWLUIZUXIRWMSTUAUBUCUDAU
        XIWNVUHUWHUXLVEUIZWKULUIZWKUXMUIUWHVUHVFVGAUWFVEWOUXLUWFUIVUKUXIAUWFDVE
        AJUHZUWFDJUWEWPADULJVHZVUMDVTAVUNUWFWQUIZAJFUIVUNVUOWLUWMAULDFJPUWIQWRW
        SWTZDULJXAXBXCZAVUIDVEWOZQDXDXBZXEUVLUWFWKKUWFVBKTXIZXFUWFVEUXLXJXGVULV
        UHXHVGULUXLXKXLWKGUKZWKVTZWKLUKZWKVVAUPZVUHWKUSUIZVVBXMIHUSUSNXNGWKUBXO
        XPVVBVVDVVCWKWKUPZVVFWKWKWKUPZXQVVEVVCWKVTVVFVVGXRXMICUSUSOCWFXSUNXNLWK
        UAXOVVCWKWKWKXTYAYBVVCWKVVAWKYCYDYEYFYGAUXRULUIZUYHUYRUQUYHUYIUYGUQAVVH
        WLZUYRUYIUXSUYGUVLYHZUYIUXSUVLYIVVJUWFVBKTYJUVLYKXPUVLUXRYNYLZUUFVVIUYI
        UYGUYQVVIUYIUYGUYQVVIUYIUYGWLZWLZBCDEFGHIJKLUXTNOUYEPAVUIVVHVVLQYMAVUJV
        VHVVLRYMSTUAUBUCUDVVIUYIUYGUUGZVVMULUYBUJZUMUNZUYMUYEVVMVVOUYLWOZVVPUYM
        WOZVVMUYLYIZUYBUYLUIZVVQVVMUYLVEUIZVVSVVMDVEUYLAVURVVHVVLVUSYMZVVMUWFDU
        YLAUWFDWOVVHVVLVUQYMZUYIUYLUWFUIVVIUYGUVLUWFUXTKVUTXFYOYPYPZUYLUUAXBVVM
        UXRUXTUIZVVTUXRUGUUBZUUCVVMUXRUXTVBYQZUYBUYLVBYQZVWEVVTVVMUVLUWFVBVBKUU
        DZUXSUYIVWGVWHXRAVWIVVHVVLAUWFUSUIUWGVWIAUWFDVEQVUQUUEAUWGUWDUWNWTUWFVB
        KUSTUUHVSYMUYIUXSVVIUYGVVKYOZVVNUVLUWFUXRUXTVBVBKUUPUUIUXRUXTUXRVWFUUJY
        RUYBUYLUXTKUUKYRUULUUMUYBUYLUUNUUQVVMVVOVEUIZVWAUWHVULVVQVVRUQVVMUYBVEU
        IZVWKVVMDVEUYBVWBVVMUWFDUYBVWCVVMUXSUYBUWFUIVWJUVLUWFUXRKVUTXFXBYPZYPZU
        YBUUOXBVWDUWHVVMVFVGZVULVVMXHVGZVVOUYLULUURYSYTVVMUYEUYCULUOUNZVVPVVMUY
        DULUIZUYEVWQUIZVVMDULUYBJAVUNVVHVVLVUPYMVWMVKZVVMUYDVEUIZUWHUYCVEUIZWKU
        YCUIZVWRVWSXRVVMVWRVXAVWTUYDUUSXBVWOVVMUWHVWLVXBVWOVWNULUYBUUTVSVVMUWHV
        WLVULVXCVWOVWNVWPULUYBXKXLUYDULUYCUVAYSWSVVMUWHVWLVVPVWQVTVWOVWNULUYBUV
        BVSUVCYPVVIUYIUYGUVDYFUVEUVGUVHUVFUVIUVJUVKYT $.
    $}

    $d k x z ph $.
    cnfcom.w $e |- W = ( G ` U. dom G ) $.
    ${
      cnfcom2.1 $e |- ( ph -> (/) e. B ) $.
      $( Lemma for ~ cnfcom2 .  (Contributed by Mario Carneiro,
         30-May-2015.) $)
      cnfcom2lem $p |- ( ph -> dom G = suc U. dom G ) $=
        ( cdm cuni wceq wn csuc c0 wlim wo wcel n0i syl wa com ccnf cfv csn cxp
        co cmpt cv wf ccnv cvv c1o cdif cima cfn coe wf1o con0 omelon cantnff1o
        a1i f1ocnv f1of 3syl ffvelrnd syl5eqel cantnfs mpbid simpld adantr dif0
        feqmptd eleq2i wss df1o2 difeq2i imaeq2i cen wbr simpr cep wwe cnvimass
        fdm syl5sseq ssexd cantnfcl oien syl2anc eqbrtrrd ensymd en0 sylib ss0b
        syl5eqr sylibr suppssr sylan2br mpteq2dva eqtrd fconstmpt fveq2d fveq2i
        syl6eqr syl5eq peano1 cantnf0 3eqtr3d mtand simprd nnlim ioran sylanbrc
        f1ocnvfv2 word wb oicl unizlim ax-mp sylnibr orduniorsuc mp1i ord mpd )
        AKUGZUUCUHZUIZUJUUCUUDUKUIZAUUCULUIZUUCUMZUNZUUEAUUGUJUUHUJZUUIUJAUUGEU
        LUIZAULEUOUUKUJUFEULUPUQAUUGURZJUSDUTVDZVAZDULVBZVCZUUMVAZEULUULJUUPUUM
        UULJBDULVEZUUPUULJBDBVFZJVAZVEUURUULBDUSJADUSJVGZUUGAUVAJVHZVIVJVKZVLZV
        MUOZAJFUOUVAUVEURAJEUUMVHZVAZFSAUSDVNVDZFEUVFAFUVHUUMVOZUVHFUVFVOUVHFUV
        FVGAUSDFPUSVPUOAVQVSZQVRZFUVHUUMVTUVHFUVFWAWBRWCWDZAUSDFJPUVJQWEWFWGZWH
        ZWJUULBDUUTULUUSDUOUULUUSDULVKZUOUUTULUIUVODUUSDWIWKUULDUSJULUUSULUVNUU
        LUVBVIUUOVKZVLZULUIUVQULWLUULUVQUVDULUVCUVPUVBVJUUOVIWMWNWOUULUVDULWPWQ
        UVDULUIUULULUVDUULUUCULUVDWPAUUGWRAUUCUVDWPWQZUUGAUVDVIUOUVDWSWTZUVRAUV
        DDVPQAJUGZUVDDJUVCXAAUVAUVTDUIUVMDUSJXBUQXCXDAUVSUUCUSUOZAUSDFJKPUVJQTU
        VLXEZWGUVDWSKVITXFXGWHXHXIUVDXJXKXMUVQXLXNXOXPXQXRBDULXSYBXTAUUNEUIUUGA
        UUNUVGUUMVAZEJUVGUUMSYAAUVIEUVHUOUWCEUIUVKRFUVHEUUMYLXGYCWHAUUQULUIUUGA
        USDFPUVJQULUSUOAYDVSYEWHYFYGAUWAUUJAUVSUWAUWBYHUUCYIUQUUGUUHYJYKUUCYMZU
        UEUUIYNUVDWSKTYOZUUCYPYQYRAUUEUUFUWDUUEUUFUNAUWEUUCYSYTUUAUUB $.

      $( Any nonzero ordinal ` B ` is equinumerous to the leading term of its
         Cantor normal form.  (Contributed by Mario Carneiro, 30-May-2015.) $)
      cnfcom2 $p |- ( ph -> ( T ` dom G ) : B -1-1-onto->
          ( ( om ^o W ) .o ( F ` W ) ) ) $=
        ( cdm cuni csuc cfv com coe comu wf1o con0 ccnv cvv wcel cdif cima ccnf
        co c1o fvex eqeltri cnvex imaexg oion mp2b elexi uniex sucid cnfcom2lem
        cep syl5eleqr cnfcom wceq wb oveq2i fveq2i oveq12i f1oeq3 sylibr fveq2d
        f1oeq1 syl mpbird omelon a1i wf cantnff1o f1ocnv f1of ffvelrnd syl5eqel
        ax-mp 3syl cv coa cmpt2 c0 cseqom oveq1i mpt2eq3ia eqid seqomeq12 mp2an
        wa eqtri cantnfval syl5reqr f1ocnvfv2 syl2anc 3eqtr3d f1oeq2 mpbid ) AK
        UGZUHZUIZLUJZUKOULVBZOJUJZUMVBZXQGUJZUNZEYCYDUNZAYEXTYCXSGUJZUNZAXTUKXR
        KUJZULVBZYIJUJZUMVBZYGUNZYHABCDEFGHIJKLXRMNPQRSTUAUBUCUDAXRXSXQXRXQXQUO
        JUPZUQURYNUQVCUSZUTZUQURXQUOURJJEUKDVAVBZUPZUJZUQSEYRVDVEVFYNYOUQVGYPVN
        KUQTVHVIVJVKVLABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFVMZVOVPYCYLVQYHYMVRYAYJYB
        YKUMOYIUKULUEVSOYIJUEVTWAYCYLXTYGWBWPWCAYDYGVQYEYHVRAXQXSGYTWDXTYCYDYGW
        EWFWGAXTEVQYEYFVRAXQLUJZYSYQUJZXTEAUUBJYQUJUUAJYSYQSVTACUKDFIJKLPUKUOUR
        AWHWIZQTAJYSFSAUKDULVBZFEYRAFUUDYQUNZUUDFYRUNUUDFYRWJAUKDFPUUCQWKZFUUDY
        QWLUUDFYRWMWQRWNWOLICUQUQNCWRZWSVBZWTZXAXBZICUQUQUKIWRZKUJZULVBUULJUJUM
        VBZUUGWSVBZWTZXAXBZUAUUIUUOVQXAXAVQUUJUUPVQICUQUQUUHUUNUUHUUNVQUUKUQURU
        UGUQURXHNUUMUUGWSUCXCWIXDXAXEUUIUUOXAXAXFXGXIXJXKAXQXSLYTWDAUUEEUUDURUU
        BEVQUUFRFUUDEYQXLXMXNXTEYCYDXOWFXP $.
    $}

    cnfcom3.1 $e |- ( ph -> om C_ B ) $.
    $( Lemma for ~ cnfcom3 .  (Contributed by Mario Carneiro, 30-May-2015.) $)
    cnfcom3lem $p |- ( ph -> W e. ( On \ 1o ) ) $=
      ( con0 wcel wne c1o cdif cdm cuni cfv ccnv cvv cima cnvimass com wceq cfn
      c0 wf wa ccnf coe wf1o omelon a1i cantnff1o f1ocnv f1of ffvelrnd syl5eqel
      3syl cantnfs mpbid simpld fdm syl syl5sseq csuc fvex eqeltri cnvex imaexg
      co cep oion mp2b elexi uniex sucid peano1 sseldd cnfcom2lem syl5eleqr oif
      ffvelrni onelon syl2anc wn wb oecl sylancr ontri1 fveq2i f1ocnvfv2 syl5eq
      wss adantr 1on cv wiso wwe ssexd cantnfcl oiiso ad2antrr ffvelrn sylancom
      isof1o elssuni onuni ax-mp sylancl wbr isorel epelc breq1i bitr3i 3bitr3g
      syl12anc simplr eleq12d bitrd mtbid wo onss ex sstrd sselda ord mt3d el1o
      on0eqel ssrdv cantnflt2 oe1 syl6eleq eqeltrrd necon3bd mpd dif1o sylanbrc
      sylibr ) AOUGUHOVBUIZOUGUJUKUHAOKULZUMZKUNZUGUEADUGUHZUUTDUHUUTUGUHQAJUOZ
      UPUJUKZUQZDUUTAJULZUVDDJUVCURADUSJVCZUVEDUTAUVFUVDVAUHZAJFUHZUVFUVGVDAJEU
      SDVEWGZUOZUNZFSAUSDVFWGZFEUVJAFUVLUVIVGZUVLFUVJVGUVLFUVJVCAUSDFPUSUGUHZAV
      HVIZQVJZFUVLUVIVKUVLFUVJVLVORVMVNZAUSDFJPUVOQVPVQVRDUSJVSVTWAZAUUSUURUHZU
      UTUVDUHAUUSUUSWBUURUUSUURUURUGUVBUPUHUVDUPUHZUURUGUHZJJUVKUPSEUVJWCWDWEUV
      BUVCUPWFUVDWHKUPTWIWJZWKWLWMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEAUSEVBUFVBUSUHZ
      AWNVIWOWPWQZUURUVDUUSKUVDWHKTWRWSVTWODUUTWTXAVNAEUSUHZXBZUUQAUSEXJZUWFUFA
      UVNEUGUHZUWGUWFXCVHAUVLUGUHZEUVLUHZUWHAUVNUVAUWIVHQUSDXDXERUVLEWTXAUSEXFX
      EVQAUWEOVBAOVBUTZUWEAUWKVDZJUVIUNZEUSAUWMEUTUWKAUWMUVKUVIUNZEJUVKUVISXGAU
      VMUWJUWNEUTUVPRFUVLEUVIXHXAXIXKUWLUWMUSUJVFWGZUSUWLUSDUJFJPUVNUWLVHVIAUVA
      UWKQXKAUVHUWKUVQXKUWCUWLWNVIUJUGUHUWLXLVIUWLBUVDUJUWLBXMZUVDUHZUWPUJUHZUW
      LUWQVDZUWPVBUTZUWRUWSUWTVBUWPUHZUWSUUSUWPKUOZUNZUHZUXAUWSUXCUUSXJZUXDXBZU
      WSUXCUURUHZUXEUWLUWQUVDUURUXBVCZUXGUWSUURUVDKVGZUVDUURUXBVGUXHUWSUURUVDWH
      WHKXNZUXIAUXJUWKUWQAUVTUVDWHXOZUXJAUVDDUGQUVRXPAUXKUURUSUHAUSDFJKPUVOQTUV
      QXQVRUVDWHKUPTXRXAXSZUURUVDWHWHKYBVTZUURUVDKVKUVDUURUXBVLVOUVDUURUWPUXBXT
      YAZUXCUURYCVTUWSUXCUGUHZUUSUGUHZUXEUXFXCUWSUWAUXGUXOUWBUXNUURUXCWTXEUWAUX
      PUWBUURYDYEUXCUUSXFYFVQUWSUXDOUXCKUNZUHZUXAUWSUUSUXCWHYGZUUTUXQWHYGZUXDUX
      RUWSUXJUVSUXGUXSUXTXCUXLAUVSUWKUWQUWDXSUXNUURUVDUUSUXCWHWHKYHYMUUSUXCUWPU
      XBWCYIUXTOUXQWHYGUXROUUTUXQWHUEYJOUXQUXCKWCYIYKYLUWSOVBUXQUWPAUWKUWQYNUWL
      UWQUXIUXQUWPUTUXMUURUVDUWPKXHYAYOYPYQUWSUWTUXAUWSUWPUGUHUWTUXAYRUWLUVDUGU
      WPAUVDUGXJUWKAUVDDUGUVRAUVADUGXJQDYSVTUUAXKUUBUWPUUFVTUUCUUDUWPUUEUUPYTUU
      GUUHUVNUWOUSUTVHUSUUIYEUUJUUKYTUULUUMOUGUUNUUO $.

    cnfcom.x $e |- X = ( u e. ( F ` W ) , v e. ( om ^o W ) |->
      ( ( ( F ` W ) .o v ) +o u ) ) $.
    cnfcom.y $e |- Y = ( u e. ( F ` W ) , v e. ( om ^o W ) |->
      ( ( ( om ^o W ) .o u ) +o v ) ) $.
    cnfcom.n $e |- N = ( ( X o. `' Y ) o. ( T ` dom G ) ) $.
    $( Any infinite ordinal ` B ` is equinumerous to a power of ` om ` .  (We
       are being careful here to show explicit bijections rather than simple
       equinumerosity because we want a uniform construction for ~ cnfcom3c .)
       (Contributed by Mario Carneiro, 28-May-2015.) $)
    cnfcom3 $p |- ( ph -> N : B -1-1-onto-> ( om ^o W ) ) $=
      ( com coe ccnv ccom cdm cfv wf1o comu con0 wcel omelon cdif cima cnvimass
      co cvv c1o wceq cfn ccnf a1i cantnff1o f1ocnv f1of 3syl ffvelrnd syl5eqel
      wf wa cantnfs mpbid simpld fdm syl syl5sseq cuni csuc fvex eqeltri imaexg
      cnvex cep oion mp2b elexi uniex c0 peano1 sseldd cnfcom2lem syl5eleqr oif
      sucid ffvelrni onelon syl2anc oecl sylancr nnon omf1o wb wne wfn elpreima
      ffn simprd dif1o simprbi on0eln0 mpbird cnfcom3lem ondif1 syl22anc f1oeq3
      omabs cnfcom2 f1oco f1oeq1 ax-mp sylibr ) AGUORUPVIZSTUQURZMUSZIUTZURZVAZ
      GYOQVAZAYORLUTZVBVIZYOYPVAZGUUCYRVAYTAUUCUUBYOVBVIZYPVAZUUDAYOVCVDZUUBVCV
      DZUUFAUOVCVDZRVCVDZUUGVEAFVCVDRFVDZUUJUBALUQZVJVKVFZVGZFRALUSZUUNFLUUMVHA
      FUOLWBZUUOFVLAUUPUUNVMVDZALHVDUUPUUQWCALGUOFVNVIZUQZUTZHUDAUOFUPVIZHGUUSA
      HUVAUURVAUVAHUUSVAUVAHUUSWBAUOFHUAUUIAVEVOZUBVPHUVAUURVQUVAHUUSVRVSUCVTWA
      AUOFHLUAUVBUBWDWEWFZFUOLWGWHWIARYQWJZMUTZUUNUJAUVDYQVDUVEUUNVDAUVDUVDWKYQ
      UVDYQYQVCUULVJVDUUNVJVDYQVCVDLLUUTVJUDGUUSWLWMWOUULUUMVJWNUUNWPMVJUEWQWRW
      SWTXGABCFGHIJKLMNOPRUAUBUCUDUEUFUGUHUIUJAUOGXAUKXAUOVDAXBVOXCZXDXEYQUUNUV
      DMUUNWPMUEXFXHWHWAZXCZFRXIXJZUORXKXLAUUBUOVDZUUHAFUORLUVCUVHVTZUUBXMZWHED
      YOUUBTSUMULXNXJAUUEYOVLZUUFUUDXOAUVJXAUUBVDZUUJXARVDZUVMUVKAUVNUUBXAXPZAU
      UBUUMVDZUVPAUUKUVQARUUNVDZUUKUVQWCZUVGAUUPLFXQUVRUVSXOUVCFUOLXSFRUUMLXRVS
      WEXTUVQUUBVJVDUVPUUBVJYAYBWHAUVJUUHUVNUVPXOUVKUVLUUBYCVSYDUVIARVCVKVFVDZU
      VOABCFGHIJKLMNOPRUAUBUCUDUEUFUGUHUIUJUKYEUVTUUJUVORYFYBWHUUBRYIYGUUEYOUUC
      YPYHWHWEABCFGHIJKLMNOPRUAUBUCUDUEUFUGUHUIUJUVFYJGUUCYOYPYRYKXJQYSVLUUAYTX
      OUNGYOQYSYLYMYN $.
  $}

  ${
    $d b g k u v w x z A $.  $d u v K $.  $d g w L $.  $d x M $.  $d u v z T $.
    $d f k u v x z F $.  $d f k u v x z G $.  $d f u v x H $.  $d k z S $.
    $d u v w x W $.
    cnfcom3c.s $e |- S = dom ( om CNF A ) $.
    cnfcom3c.f $e |- F = ( `' ( om CNF A ) ` b ) $.
    cnfcom3c.g $e |- G = OrdIso ( _E , ( `' F " ( _V \ 1o ) ) ) $.
    cnfcom3c.h $e |- H = seqom ( ( k e. _V , z e. _V |-> ( M +o z ) ) , (/) )
        $.
    cnfcom3c.t $e |- T = seqom ( ( k e. _V , f e. _V |-> K ) , (/) ) $.
    cnfcom3c.m $e |- M = ( ( om ^o ( G ` k ) ) .o ( F ` ( G ` k ) ) ) $.
    cnfcom3c.k $e |- K = ( ( x e. M |-> ( dom f +o x ) ) u.
      `' ( x e. dom f |-> ( M +o x ) ) ) $.
    cnfcom3c.w $e |- W = ( G ` U. dom G ) $.
    cnfcom3c.x $e |- X = ( u e. ( F ` W ) , v e. ( om ^o W ) |->
      ( ( ( F ` W ) .o v ) +o u ) ) $.
    cnfcom3c.y $e |- Y = ( u e. ( F ` W ) , v e. ( om ^o W ) |->
      ( ( ( om ^o W ) .o u ) +o v ) ) $.
    cnfcom3c.n $e |- N = ( ( X o. `' Y ) o. ( T ` dom G ) ) $.
    cnfcom3c.l $e |- L = ( b e. ( om ^o A ) |-> N ) $.
    $( Lemma for ~ cnfcom3c .  (Contributed by Mario Carneiro, 30-May-2015.) $)
    cnfcom3clem $p |- ( A e. On -> E. g A. b e. A ( om C_ b ->
      E. w e. ( On \ 1o ) ( g ` b ) : b -1-1-onto-> ( om ^o w ) ) ) $=
      ( con0 wcel com cv wss coe co cfv wf1o c1o cdif wrex wi wex w3a simp1 c2o
      wral omelon ondif2 mpbir2an oeworde sylancr simp2 sseldd simp3 cnfcom3lem
      1onn cnfcom3 wceq wb cvv wf f1of syl vex fex sylancl fvmpt2 f1oeq1 mpbird
      syl2anc oveq2 f1oeq3 rspcev 3expia ralrimiva cmpt ovex mptex nfmpt1 nfeq2
      eqeltri nfcxfr fveq1 rexbidv imbi2d ralbid spcev ) FUOUPZUQUBURZUSZXOUQCU
      RZUTVAZXOPVBZVCZCUOVDVEZVFZVGZUBFVLZXPXOXRXOJURZVBZVCZCYAVFZVGZUBFVLZJVHX
      NYCUBFXNXOFUPZXPYBXNYKXPVIZSYAUPXOUQSUTVAZXSVCZYBYLABFXOGHIKLMNOQSUCXNYKX
      PVJZYLFUQFUTVAZXOYLUQUOVKVEUPZXNFYPUSYQUQUOUPVDUQUPVMWBUQVNVOYOUQFVPVQXNY
      KXPVRVSZUDUEUFUGUHUIUJXNYKXPVTZWAYLYNXOYMRVCZYLABDEFXOGHIKLMNOQRSTUAUCYOY
      RUDUEUFUGUHUIUJYSUKULUMWCZYLXSRWDZYNYTWEYLXOYPUPRWFUPZUUBYRYLXOYMRWGZXOWF
      UPUUCYLYTUUDUUAXOYMRWHWIUBWJXOYMWFRWKWLUBYPRWFPUNWMWPXOYMXSRWNWIWOXTYNCSY
      AXQSWDXRYMWDXTYNWEXQSUQUTWQXRYMXOXSWRWIWSWPWTXAYJYDJPPUBYPRXBZWFUNUBYPRUQ
      FUTXCXDXGYEPWDZYIYCUBFUBYEPUBPUUEUNUBYPRXEXHXFUUFYHYBXPUUFYGXTCYAUUFYFXSW
      DYGXTWEXOYEPXIXOXRYFXSWNWIXJXKXLXMWI $.
  $}

  ${
    $d b f g k u v w x z A $.
    $( Wrap the construction of ~ cnfcom3 into an existence quantifier.  For
       any ` om C_ b ` , there is a bijection from ` b ` to some power of
       ` om ` .  Furthermore, this bijection is _canonical_ , which means that
       we can find a single function ` g ` which will give such bijections for
       every ` b ` less than some arbitrarily large bound ` A ` .  (Contributed
       by Mario Carneiro, 30-May-2015.) $)
    cnfcom3c $p |- ( A e. On -> E. g A. b e. A ( om C_ b ->
      E. w e. ( On \ 1o ) ( g ` b ) : b -1-1-onto-> ( om ^o w ) ) ) $=
      ( vx vz vv vu vk vf com co cdm cvv cv ccnv cfv coa cmpt2 eqid c1o cep coi
      ccnf cdif cima coe comu cmpt cun c0 cseqom cuni ccom cnfcom3clem ) EFAGHB
      KBUDLZMZIJNNEKIODOUPPQZPNUAUEUFUBUCZQZUGLUTURQUHLZJOMZEOZRLUIEVBVAVCRLUIP
      UJZSUKULZJCIURUSIFNNVAFORLSUKULZVDDKBUGLHGUSMZUMUSQZURQZKVHUGLZVIGOZUHLHO
      ZRLSZHGVIVJVJVLUHLVKRLSZPUNVGVEQUNZUIZVAVOVHVMVNDUQTURTUSTVFTVETVATVDTVHT
      VMTVNTVOTVPTUO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Transitive closure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x z $.  $d v x y A $.  $d u v x y F $.
    trcl.1 $e |- A e. _V $.
    trcl.2 $e |- F = ( rec ( ( z e. _V |-> ( z u. U. z ) ) , A ) |` om ) $.
    trcl.3 $e |- C = U_ y e. om ( F ` y ) $.
    $( For any set ` A ` , show the properties of its transitive closure
       ` C ` .  Similar to Theorem 9.1 of [TakeutiZaring] p. 73 except that we
       show an explicit expression for the transitive closure rather than just
       its existence.  See ~ tz9.1 for an abbreviated version showing
       existence.  (Contributed by NM, 14-Sep-2003.)  (Revised by Mario
       Carneiro, 11-Sep-2015.) $)
    trcl $p |- ( A C_ C /\ Tr C /\ A. x ( ( A C_ x /\ Tr x ) -> C C_ x ) ) $=
      ( vv vu wss cv com cfv wrex c0 wcel wceq fveq2 wtr wa wal ciun peano1 cvv
      wi cuni cun cmpt crdg cres fveq1i fr0g ax-mp eqtr2i eqimssi sseq2d rspcev
      mp2an ssiun sseqtr4i dftr2 eliun anbi2i r19.42v bitr4i elunii ssun2 uniex
      csuc fvex unex unieq uneq12d frsucmpt2 mpan2 syl5sseqr sseld syl5 reximia
      weq id sylbi peano2 eleq2d syl rexlimiv cbvrexv sylibr ax-gen mpgbir treq
      ex mpbir wral sseq1d eqtri sseq1i biimpri adantr uniss df-tr sstr2 syl5bi
      wb anc2li unss syl6ib biimprd syl9r com23 adantld finds2 ralrimiv cbviunv
      com12 iunss bitri 3pm3.2i ) DELEUAZDAMZLZYBUAZUBZEYBLZUGZAUCDBNBMZFOZUDZE
      DYILZBNPZDYJLQNRDQFOZLZYLUEDYMYMQCUFCMZYOUHZUIZUJZDUKNULZOZDQFYSHUMZDUFRY
      TDSGDUFYRUNUOZUPUQYKYNBQNYHQSYIYMDYHQFTURUSUTBNYIDVAUOIVBYAYJUAZUUCJMZKMZ
      RZUUEYJRZUBZUUDYJRZUGZKUCJJKYJVCUUJKUUHUUDYHVKZFOZRZBNPZUUIUUHUUFUUEYIRZU
      BZBNPZUUNUUHUUFUUOBNPZUBUUQUUGUURUUFBUUENYIVDVEUUFUUOBNVFVGUUPUUMBNUUPUUD
      YIUHZRYHNRZUUMUUDUUEYIVHUUTUUSUULUUDUUTYIUUSUIZUUSUULUUSYIVIUUTUVAUFRUULU
      VASYIUUSYHFVLZYIUVBVJVMCADYHYQUVAYBYBUHZUIFUFHACWBZYBYOUVCYPUVDWCYBYOVNVO
      YBYISZYBYIUVCUUSUVEWCYBYIVNVOVPVQZVRVSVTWAWDUUNUUDYIRZBNPZUUIUUNUUDUUEFOZ
      RZKNPZUVHUUMUVKBNUUTUUKNRZUUMUVKUGYHWEUVLUUMUVKUVJUUMKUUKNUUEUUKSUVIUULUU
      DUUEUUKFTWFUSWNWGWHUVGUVJBKNBKWBYIUVIUUDYHUUEFTWFWIWJBUUDNYIVDWJWGWKWLEYJ
      SYAUUCXFIEYJWMUOWOYGAYEUUDFOZYBLZJNWPZYFYEUVNJNUUDNRYEUVNUVNYMYBLZYIYBLZU
      ULYBLZYEJBUUDQSUVMYMYBUUDQFTWQJBWBUVMYIYBUUDYHFTWQUUDUUKSUVMUULYBUUDUUKFT
      WQYCUVPYDUVPYCYMDYBYMYTDUUAUUBWRWSWTXAUUTYDUVQUVRUGYCUUTUVQYDUVRUVQYDUVAY
      BLZUUTUVRUVQYDUVQUUSYBLZUBUVSUVQYDUVTUVQUUSUVCLZYDUVTUGYIYBXBYDUVCYBLUWAU
      VTYBXCUUSUVCYBXDXEWGXGYIUUSYBXHXIUUTUVRUVSUUTUULUVAYBUVFWQXJXKXLXMXNXQXOY
      FJNUVMUDZYBLUVOEUWBYBEYJUWBIBJNYIUVMYHUUDFTXPWRWSJNUVMYBXRXSWJWKXT $.
  $}

  ${
    $d A x y z w v $.
    tz9.1.1 $e |- A e. _V $.
    $( Every set has a transitive closure (the smallest transitive extension).
       Theorem 9.1 of [TakeutiZaring] p. 73.  See ~ trcl for an explicit
       expression for the transitive closure.  Apparently open problems are
       whether this theorem can be proved without the Axiom of Infinity; if
       not, then whether it implies Infinity; and if not, what is the
       "property" that Infinity has that the other axioms don't have that is
       weaker than Infinity itself?

       (Added 22-Mar-2011) The following article seems to answer the first
       question, that it can't be proved without Infinity, in the affirmative:
       Mancini, Antonella and Zambella, Domenico (2001).  "A note on recursive
       models of set theories." _Notre Dame Journal of Formal Logic_,
       42(2):109-115.  (Thanks to Scott Fenton.)  (Contributed by NM,
       15-Sep-2003.) $)
    tz9.1 $p |- E. x ( A C_ x /\ Tr x
                /\ A. y ( ( A C_ y /\ Tr y ) -> x C_ y ) ) $=
      ( vz vw com cv cvv cuni cun cmpt crdg cres wss wtr wi wal w3a eqid cfv wa
      ciun trcl omex fvex iunex wceq sseq2 treq sseq1 imbi2d albidv spcev ax-mp
      wex 3anbi123d ) CEGEHZFIFHZUSJKLCMGNZUAZUCZOZVBPZCBHZOVEPUBZVBVEOZQZBRZSZ
      CAHZOZVKPZVFVKVEOZQZBRZSZAUPBEFCVBUTDUTTVBTUDVQVJAVBEGVAUEURUTUFUGVKVBUHZ
      VLVCVMVDVPVIVKVBCUIVKVBUJVRVOVHBVRVNVGVFVKVBVEUKULUMUQUNUO $.

    $( Alternative expression for the existence of transitive closures
       ~ tz9.1 : the intersection of all transitive sets containing ` A ` is a
       set.  (Contributed by Mario Carneiro, 22-Mar-2013.) $)
    tz9.1c $p |- |^| { x | ( A C_ x /\ Tr x ) } e. _V $=
      ( vw vz cv wss wtr wa cab c0 wne cint cvv wcel wex com cuni cun eqid cmpt
      crdg cres cfv ciun wi wal w3a trcl 3simpa omex fvex iunex wceq sseq2 treq
      anbi12d spcev mp2b abn0 mpbir intex mpbi ) BAFZGZVDHZIZAJZKLZVHMNOVIVGAPZ
      BDQDFZENEFZVLRSUABUBQUCZUDZUEZGZVOHZVGVOVDGUFAUGZUHVPVQIZVJADEBVOVMCVMTVO
      TUIVPVQVRUJVGVSAVODQVNUKVKVMULUMVDVOUNVEVPVFVQVDVOBUOVDVOUPUQURUSVGAUTVAV
      HVBVC $.
  $}

  ${
    $d x y z w A $.
    $( The strong form of the Axiom of Regularity (no sethood requirement on
       ` A ` ), with the axiom itself present as an antecedent.  See also
       ~ zfregs .  (Contributed by Mario Carneiro, 22-Mar-2013.) $)
    epfrs $p |- ( ( _E Fr A /\ A =/= (/) ) -> E. x e. A ( x i^i A ) = (/) ) $=
      ( vz vy vw c0 wne cv cin wceq wrex wcel wex wi n0 wss wtr wa wel syl5 cep
      wfr csn wal w3a snex tz9.1 snssi anim2i ssin snss bitr4i sylib ne0i inss2
      vex syl inex1 epfrc mp3an2 elin anbi1i anass bitri inss1 sseli ancri trel
      inass incom ineq2i eqtri eleq2i bitr2i sylbi ex exp3a com34 imp3a exlimdv
      syl6 syl5bi imp necon4d anim2d expimpd reximdv2 exp3acom23 impcom 3adant3
      com23 exlimiv ax-mp ) BFGZBUAUBZAHZBIZFJZABKZWNCHZBLZCMWOWSNZCBOXAXBCWTUC
      ZDHZPZXDQZXCEHZPXGQRXDXGPNEUDZUEZDMXAXBNZDEXCWTUFUGXIXJDXEXFXJXHXFXEXJXFX
      EXAXBXEXARZXDBIZFGZXFXBXKWTXLLZXMXKXEXCBPZRZXNXAXOXEWTBUHUIXPXCXLPXNXCXDB
      UJWTXLCUPUKULUMXLWTUNUQXFWOXMWSWOXMRXLWPIZFJZAXLKZXFWSWOXLBPXMXSXDBUOABXL
      XDBDUPURUSUTXFXRWRAXLBWPXLLZXRRZADSZWPBLZXRRZRZXFYCWRRZYAYBYCRZXRRYEXTYGX
      RWPXDBVAVBYBYCXRVCVDXFYBYDYFXFYBRZXRWRYCYHWQFXQFXFYBWQFGZXQFGZNXFYIYBYJYI
      XGWQLZEMXFYBYJNZEWQOXFYKYLEYKEASZYKRXFYLYKYMWQWPXGWPBVEVFVGXFYMYKYLXFYMYB
      YKYJXFYMYBYKYJNZXFYMYBREDSZYNXDXGWPVHYOYKYJYOYKRZXGXQLZYJYQXGXDWQIZLYPXQY
      RXGXQXDBWPIZIYRXDBWPVIYSWQXDBWPVJVKVLVMXGXDWQVAVNXQXGUNVOVPWAVQVRVSTVTWBW
      KWCWDWEWFWBWGTWHTVQWIWJWLWMWLVOWI $.
  $}

  ${
    $d x A $.
    $( The strong form of the Axiom of Regularity, which does not require that
       ` A ` be a set.  Axiom 6' of [TakeutiZaring] p. 21.  See also ~ epfrs .
       (Contributed by NM, 17-Sep-2003.) $)
    zfregs $p |- ( A =/= (/) -> E. x e. A ( x i^i A ) = (/) ) $=
      ( cep wfr c0 wne cv cin wceq wrex zfregfr epfrs mpan ) BCDBEFAGBHEIABJBKA
      BLM $.
  $}

  ${
    $d x y A $.
    $( Alternate strong form of the Axiom of Regularity.  Not every element of
       a non-empty class contains some element of that class.  (Contributed by
       Alan Sare, 24-Oct-2011.)  (Proof shortened by Wolf Lammen,
       27-Sep-2013.) $)
    zfregs2 $p |- ( A =/= (/) -> -. A. x e. A E. y ( y e. A /\ y e. x ) ) $=
      ( c0 wne cv wcel wa wex wn wral wrex wi wal cin zfregs incom rexbii sylib
      wceq eqeq1i disj1 alinexa dfrex2 notnot ralbii sylnibr ) CDEZBFZCGZUIAFZG
      ZHBIZJZJZACKZUMACKUHUNACLZUPJUHUJULJMBNZACLZUQUHCUKOZDTZACLZUSUHUKCOZDTZA
      CLVBACPVDVAACVCUTDUKCQUARSVAURACBCUKUBRSURUNACUJULBUCRSUNACUDSUMUOACUMUEU
      FUG $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Lemma for ~ en3lp .  (Contributed by Alan Sare, 28-Oct-2011.) $)
    en3lplem1 $p |- ( ( A e. B /\ B e. C /\ C e. A ) ->
                    ( x = A -> ( x i^i { A , B , C } ) =/= (/) ) ) $=
      ( wcel w3a cv wceq ctp cin c0 wne simp3 syl5ibrcom tpid3g 3ad2ant3 inelcm
      eleq2 sylan2 expcom syld ) BCEZCDEZDBEZFZAGZBHZDUFEZUFBCDIZJKLZUEUHUGUDUB
      UCUDMUFBDRNUHUEUJUEUHDUIEZUJUDUBUKUCDBBCOPDUFUIQSTUA $.

    $( Lemma for ~ en3lp .  (Contributed by Alan Sare, 28-Oct-2011.) $)
    en3lplem2 $p |- ( ( A e. B /\ B e. C /\ C e. A ) -> ( x e. { A , B , C }
                    -> ( x i^i { A , B , C } ) =/= (/) ) ) $=
      ( wcel ctp cin c0 wne wceq wo wi en3lplem1 a1d tprot ineq2i neeq1i syl8ib
      imp syl6ib w3a cv 3comr bicomi jao sylsyld 3coml w3o cab idd dftp2 eleq2i
      wa abid df-3or mpjaod ex ) BCEZCDEZDBEZUAZAUBZBCDFZEZVBVCGZHIZVAVDUMVBBJZ
      VBCJZKZVFVBDJZVAVDVIVFLZVAVGVFLVDVHVFLVKABCDMVAVDVHVBCDBFZGZHIZVFVAVHVNLZ
      VDUSUTURVOACDBMUCNVFVNVEVMHVCVLVBBCDOPQUDRVGVFVHUEUFSVAVDVJVFLVAVDVJVBDBC
      FZGZHIZVFVAVJVRLZVDUTURUSVSADBCMUGNVQVEHVPVCVBDBCOPQRSVAVDVIVJKZVAVDVGVHV
      JUHZVTVAVDVBWAAUIZEZWAVAVDVDWCVAVDUJVCWBVBABCDUKULTWAAUNTVGVHVJUOTSUPUQ
      $.

    $( No class has 3-cycle membership loops.  This proof was automatically
       generated from the virtual deduction proof ~ en3lpVD using a translation
       program.  (Contributed by Alan Sare, 24-Oct-2011.) $)
    en3lp $p |- -. ( A e. B /\ B e. C /\ C e. A ) $=
      ( vx wcel w3a wn ctp c0 wceq noel eleq2 mtbiri tpid3g nsyl simp3 wne wrex
      cv cin tpex zfreg en3lplem2 com12 necon2bd rexlimiv syl pm2.61ine ) ABEZB
      CEZCAEZFZGZABCHZIUNIJZUKULUOCUNEZUKUOUPCIECKUNICLMCAABNOUIUJUKPOUNIQDSZUN
      TZIJZDUNRUMDUNABCUAUBUSUMDUNUQUNEZULURIULUTURIQDABCUCUDUEUFUGUH $.
  $}

  ${
    $d x y z A $.
    $( Set (epsilon) induction.  Theorem 5.22 of [TakeutiZaring] p. 21.
       (Contributed by NM, 17-Sep-2003.) $)
    setind $p |- ( A. x ( x C_ A -> x e. A ) -> A = _V ) $=
      ( vy cv wss wcel wi wal cvv cdif c0 wceq cin wrex wn ssindif0 sseq1 eleq1
      imbi12d spv syl5bir eldifn nsyli imp nrexdv zfregs necon1bi vdif0 sylibr
      syl ) ADZBEZUKBFZGZAHZIBJZKLZBILUOCDZUPMKLZCUPNZOUQUOUSCUPUOURUPFZUSOUOUS
      URBFZVAUSURBEZUOVBURBPUNVCVBGACUKURLULVCUMVBUKURBQUKURBRSTUAURIBUBUCUDUEU
      TUPKCUPUFUGUJBUHUI $.
  $}

  ${
    $d x A $.
    $( Set (epsilon) induction, stated compactly.  Given as a homework problem
       in 1992 by George Boolos (1940-1996).  (Contributed by NM,
       17-Sep-2003.) $)
    setind2 $p |- ( ~P A C_ A -> A = _V ) $=
      ( vx cpw wss cv wcel wi wal cvv wceq pwss setind sylbi ) ACADBEZADNAFGBHA
      IJBAAKBALM $.
  $}

  $c TC $. $( Transitive closure $)

  $( Extend class notation to include the transitive closure function. $)
  ctc $a class TC $.

  ${
    $d u x y $.
    $( The transitive closure function.  (Contributed by Mario Carneiro,
       23-Jun-2013.) $)
    df-tc $a |- TC = ( x e. _V |-> |^| { y | ( x C_ y /\ Tr y ) } ) $.
  $}

  ${
    $d A x y $.
    $( Value of the transitive closure function.  (The fact that this
       intersection exists is a non-trivial fact that depends on ~ ax-inf ; see
       ~ tz9.1 .)  (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tcvalg $p |- ( A e. V -> ( TC ` A ) = |^| { x | ( A C_ x /\ Tr x ) } ) $=
      ( vy cv ctc cfv wss wtr wa cab cint wceq fveq2 sseq1 anbi1d abbidv inteqd
      cvv wcel eqeq12d vex tz9.1c df-tc fvmpt2 mp2an vtoclg ) DEZFGZUHAEZHZUJIZ
      JZAKZLZMZBFGZBUJHZULJZAKZLZMDBCUHBMZUIUQUOVAUHBFNVBUNUTVBUMUSAVBUKURULUHB
      UJOPQRUAUHSTUOSTUPDUBZAUHVCUCDSUOSFDAUDUEUFUG $.
  $}

  ${
    $d A x y $.
    $( Defining property of the transitive closure function: it contains its
       argument as a subset.  (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tcid $p |- ( A e. V -> A C_ ( TC ` A ) ) $=
      ( vx wcel cv wss wtr wa cab cint ctc cfv ssmin tcvalg syl5sseqr ) ABDACEZ
      FPGZHCIJAAKLQCAMCABNO $.

    $( Defining property of the transitive closure function: it is transitive.
       (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tctr $p |- Tr ( TC ` A ) $=
      ( vx vy cvv wcel ctc cfv wtr cv wss wa cab cint trint wceq treq wb mpbiri
      syl c0 vex sseq2 anbi12d elab simprbi mprg tcvalg wn tr0 fvprc pm2.61i )
      ADEZAFGZHZULUNABIZJZUOHZKZBLZMZHZCIZHZVACUSCUSNVBUSEAVBJZVCURVDVCKBVBCUAU
      OVBOUPVDUQVCUOVBAUBUOVBPUCUDUEUFULUMUTOUNVAQBADUGUMUTPSRULUHZUNTHZUIVEUMT
      OUNVFQAFUJUMTPSRUK $.

    $d B x y $.
    $( Defining property of the transitive closure function: it is a subset of
       any transitive class containing ` A ` .  (Contributed by Mario Carneiro,
       23-Jun-2013.) $)
    tcmin $p |- ( A e. V -> ( ( A C_ B /\ Tr B ) -> ( TC ` A ) C_ B ) ) $=
      ( vy vx wcel wss wtr wa cv cab cint ctc cfv wex cvv tcvalg fvex syl6eqelr
      intexab sylibr ssin biimpi trin anim12i an4s expcom inex1 wceq sseq2 treq
      cin vex anbi12d intss1 sylbir inss2 syl6ss exlimdv syl5com sseq1d sylibrd
      elab syl6 ) ACFZABGZBHZIZADJZGZVIHZIZDKZLZBGZAMNZBGVEAEJZGZVQHZIZEOZVHVOV
      EVTEKLZPFWAVEWBVPPEACQAMRSVTETUAVHVTVOEVHVTAVQBULZGZWCHZIZVOVTVHWFVRVFVSV
      GWFVRVFIZWDVSVGIWEWGWDAVQBUBUCVQBUDUEUFUGWFVNWCBWFWCVMFVNWCGVLWFDWCVQBEUM
      UHVIWCUIVJWDVKWEVIWCAUJVIWCUKUNVCWCVMUOUPVQBUQURVDUSUTVEVPVNBDACQVAVB $.
  $}

  ${
    $d A x y $.
    tc2.1 $e |- A e. _V $.
    $( A variant of the definition of the transitive closure function, using
       instead the smallest transitive set containing ` A ` as a member, gives
       almost the same set, except that ` A ` itself must be added because it
       is not usually a member of ` ( TC `` A ) ` (and it is never a member if
       ` A ` is well-founded).  (Contributed by Mario Carneiro,
       23-Jun-2013.) $)
    tc2 $p |- ( ( TC ` A ) u. { A } ) = |^| { x | ( A e. x /\ Tr x ) } $=
      ( ctc cfv cun wcel wtr wa cab cint wss wceq ax-mp eqsstri mpbi unssi cuni
      cvv df-tr csn cv tcvalg trss imdistanri ss2abi intss elintab simpl mpgbir
      wi snss snid elun2 uniun tctr unisn tcid ssun1 sstri mpbir fvex snex unex
      eleq2 treq anbi12d elab mpbir2an intss1 eqssi ) BDEZBUAZFZBAUBZGZVOHZIZAJ
      ZKZVLVMVTVLBVOLZVQIZAJZKZVTBSGZVLWDMCABSUCNVSWCLWDVTLVRWBAVQVPWAVOBUDUEUF
      VSWCUGNOBVTGZVMVTLWFVRVPUKAVRABCUHVPVQUIUJBVTCULPQVNVSGZVTVNLWGBVNGZVNHZB
      VMGWHBCUMBVMVLUNNWIVNRZVNLWJVLVNWJVLRZVMRZFVLVLVMUOWKWLVLVLHWKVLLBUPVLTPW
      LBVLBCUQWEBVLLCBSURNOQOVLVMUSUTVNTVAVRWHWIIAVNVLVMBDVBBVCVDVOVNMVPWHVQWIV
      OVNBVEVOVNVFVGVHVIVNVSVJNVK $.

    $( The transitive closure of a singleton.  Proof suggested by G&eacute;rard
       Lang.  (Contributed by Mario Carneiro, 4-Jun-2015.) $)
    tcsni $p |- ( TC ` { A } ) = ( ( TC ` A ) u. { A } ) $=
      ( vx cv wcel wtr wa cab cint csn wss ctc cfv cun snss anbi1i abbii inteqi
      tc2 cvv wceq snex tcvalg ax-mp 3eqtr4ri ) ACDZEZUFFZGZCHZIAJZUFKZUHGZCHZI
      ZALMUKNUKLMZUJUNUIUMCUGULUHAUFBOPQRCABSUKTEUPUOUAAUBCUKTUCUDUE $.

    $d B x $.
    $( The transitive closure function inherits the subset relation.
       (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tcss $p |- ( B C_ A -> ( TC ` B ) C_ ( TC ` A ) ) $=
      ( vx wss ctc cfv cv wtr wa cab cint cvv wcel wceq tcvalg syl sstr2 anim1d
      ssex ss2abdv intss ax-mp syl6sseqr eqsstrd ) BAEZBFGZBDHZEZUHIZJZDKZLZAFG
      ZUFBMNUGUMOBACTDBMPQUFUMAUHEZUJJZDKZLZUNUFUQULEUMUREUFUPUKDUFUOUIUJBAUHRS
      UAUQULUBQAMNUNUROCDAMPUCUDUE $.

    $( The transitive closure function converts the element relation to the
       subset relation.  (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tcel $p |- ( B e. A -> ( TC ` B ) C_ ( TC ` A ) ) $=
      ( vx wcel ctc cfv cv wss wtr wa cab cint tcvalg wi ssel com12 syl6com cvv
      trss imp3a simpr a1i jcad ss2abdv intss syl wceq ax-mp syl6sseqr eqsstrd
      ) BAEZBFGBDHZIZUMJZKZDLZMZAFGZDBANULURAUMIZUOKZDLZMZUSULVBUQIURVCIULVAUPD
      ULVAUNUOULUTUOUNUTULBUMEZUOUNOAUMBPUOVDUNUMBTQRUAVAUOOULUTUOUBUCUDUEVBUQU
      FUGASEUSVCUHCDASNUIUJUK $.
  $}

  $( The transitive closure function is idempotent.  (Contributed by Mario
     Carneiro, 23-Jun-2013.) $)
  tcidm $p |- ( TC ` ( TC ` A ) ) = ( TC ` A ) $=
    ( ctc cfv wss wtr ssid tctr cvv wcel wa fvex tcmin ax-mp mp2an tcid eqssi
    wi ) ABCZBCZRRRDZREZSRDZRFAGRHIZTUAJUBQABKZRRHLMNUCRSDUDRHOMP $.

  $( The transitive closure of the empty set.  (Contributed by Mario Carneiro,
     4-Jun-2015.) $)
  tc0 $p |- ( TC ` (/) ) = (/) $=
    ( c0 ctc cfv wss wtr ssid tr0 cvv wcel wa 0ex tcmin ax-mp mp2an 0ss eqssi
    wi ) ABCZAAADZAEZRADZAFGAHISTJUAQKAAHLMNROP $.

  $( The transitive closure is empty iff its argument is.  Proof suggested by
     G&eacute;rard Lang.  (Contributed by Mario Carneiro, 4-Jun-2015.) $)
  tc00 $p |- ( A e. V -> ( ( TC ` A ) = (/) <-> A = (/) ) ) $=
    ( wcel ctc cfv c0 wceq wss wi tcid sseq0 ex syl fveq2 tc0 syl6eq impbid1 )
    ABCZADEZFGZAFGZRASHZTUAIABJUBTUAASKLMUASFDEFAFDNOPQ $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Rank
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c R1 $. $( Cumulative hierarchy of sets function $)
  $c rank $. $( Rank function $)

  $( Extend class definition to include the cumulative hierarchy of sets
     function. $)
  cr1 $a class R1 $.

  $( Extend class definition to include rank function. $)
  crnk $a class rank $.

  ${
    $d x y $.
    $( Define the cumulative hierarchy of sets function, using Takeuti and
       Zaring's notation ( ` R1 ` ).  Starting with the empty set, this
       function builds up layers of sets where the next layer is the power set
       of the previous layer (and the union of previous layers when the
       argument is a limit ordinal).  Using the Axiom of Regularity, we can
       show that any set whatsoever belongs to one of the layers of this
       hierarchy (see ~ tz9.13 ).  Our definition expresses Definition 9.9 of
       [TakeutiZaring] p. 76 in a closed form, from which we derive the
       recursive definition as theorems ~ r10 , ~ r1suc , and ~ r1lim .
       Theorem ~ r1val1 shows a recursive definition that works for all values,
       and theorems ~ r1val2 and ~ r1val3 show the value expressed in terms of
       rank.  Other notations for this function are _R_ with the argument as a
       subscript (Equation 3.1 of [BellMachover] p. 477), ` _V ` with a
       subscript (Definition of [Enderton] p. 202), _M_ with a subscript
       (Definition 15.19 of [Monk1] p. 113), the capital Greek letter psi
       (Definition of [Mendelson] p. 281), and bold-face R (Definition 2.1 of
       [Kunen] p. 95).  (Contributed by NM, 2-Sep-2003.) $)
    df-r1 $a |- R1 = rec ( ( x e. _V |-> ~P x ) , (/) ) $.

    $( Define the rank function.  See ~ rankval , ~ rankval2 , ~ rankval3 , or
       ~ rankval4 its value.  The rank is a kind of "inverse" of the cumulative
       hierarchy of sets function ` R1 ` : given a set, it returns an ordinal
       number telling us the smallest layer of the hierarchy to which the set
       belongs.  Based on Definition 9.14 of [TakeutiZaring] p. 79.  Theorem
       ~ rankid illustrates the "inverse" concept.  Another nice theorem
       showing the relationship is ~ rankr1a .  (Contributed by NM,
       11-Oct-2003.) $)
    df-rank $a |- rank = ( x e. _V |->
        |^| { y e. On | x e. ( R1 ` suc y ) } ) $.
  $}

  $( The cumulative hierarchy of sets function is a function on a limit
     ordinal.  (This weak form of ~ r1fnon avoids ~ ax-rep .)  (Contributed by
     Mario Carneiro, 16-Nov-2014.) $)
  r1funlim $p |- ( Fun R1 /\ Lim dom R1 ) $=
    ( vx cr1 wfun cdm wlim cvv cv cpw cmpt c0 crdg rdgfun df-r1 funeqi rdgdmlim
    mpbir wceq wb dmeqi limeq ax-mp pm3.2i ) BCZBDZEZUCAFAGHIZJKZCJUFLBUGAMZNPU
    EUGDZEZJUFOUDUIQUEUJRBUGUHSUDUITUAPUB $.

  $( The cumulative hierarchy of sets function is a function on the class of
     ordinal numbers.  (Contributed by NM, 5-Oct-2003.)  (Revised by Mario
     Carneiro, 10-Sep-2013.) $)
  r1fnon $p |- R1 Fn On $=
    ( vx cr1 con0 wfn cvv cv cpw cmpt c0 crdg rdgfnon df-r1 fneq1i mpbir ) BCDA
    EAFGHZIJZCDIOKCBPALMN $.

  $( Value of the cumulative hierarchy of sets function at ` (/) ` .  Part of
     Definition 9.9 of [TakeutiZaring] p. 76.  (Contributed by NM,
     2-Sep-2003.)  (Revised by Mario Carneiro, 10-Sep-2013.) $)
  r10 $p |- ( R1 ` (/) ) = (/) $=
    ( vx c0 cr1 cfv cvv cv cpw cmpt crdg df-r1 fveq1i 0ex rdg0 eqtri ) BCDBAEAF
    GHZBIZDBBCPAJKBOLMN $.

  ${
    $d x y A $.
    $( Value of the cumulative hierarchy of sets function at a successor
       ordinal.  Part of Definition 9.9 of [TakeutiZaring] p. 76.  (Contributed
       by Mario Carneiro, 16-Nov-2014.) $)
    r1sucg $p |- ( A e. dom R1 -> ( R1 ` suc A ) = ~P ( R1 ` A ) ) $=
      ( vx cr1 cdm wcel csuc cvv cv cpw cmpt crdg cfv wceq rdgsucg df-r1 eleq2s
      c0 dmeqi fveq1i fvex pweq eqid pwex fvmpt ax-mp fveq2i eqtr3i 3eqtr4g ) A
      CDZEAFZBGBHZIZJZQKZLZAUNLZUMLZUJCLACLZIZUOUQMAUNDUIQAUMNCUNBOZRPUJCUNUTSU
      RUMLZUSUQURGEVAUSMACTZBURULUSGUMUKURUAUMUBURVBUCUDUEURUPUMACUNUTSUFUGUH
      $.

    $( Value of the cumulative hierarchy of sets function at a successor
       ordinal.  Part of Definition 9.9 of [TakeutiZaring] p. 76.  (Contributed
       by NM, 2-Sep-2003.)  (Revised by Mario Carneiro, 10-Sep-2013.) $)
    r1suc $p |- ( A e. On -> ( R1 ` suc A ) = ~P ( R1 ` A ) ) $=
      ( csuc cr1 cfv cpw wceq cdm con0 r1sucg r1fnon fndm ax-mp eqcomi eleq2s
      wfn ) ABCDACDEFACGZHAIPHCHOPHFJHCKLMN $.

    $( Value of the cumulative hierarchy of sets function at a limit ordinal.
       Part of Definition 9.9 of [TakeutiZaring] p. 76.  (Contributed by Mario
       Carneiro, 16-Nov-2014.) $)
    r1limg $p |- ( ( A e. dom R1 /\ Lim A ) ->
      ( R1 ` A ) = U_ x e. A ( R1 ` x ) ) $=
      ( vy cr1 cdm wcel wlim wa cvv cv cpw cmpt c0 crdg cfv cima cuni ciun wceq
      df-r1 dmeqi eleq2i rdglimg sylanb fveq1i r1funlim simpli funiunfv imaeq1i
      wfun ax-mp unieqi eqtri 3eqtr4g ) BDEZFZBGZHBCICJKLZMNZOZUSBPZQZBDOABAJDO
      RZUPBUSEZFUQUTVBSUOVDBDUSCTZUAUBMBURUCUDBDUSVEUEVCDBPZQZVBDUJZVCVGSVHUOGU
      FUGABDUHUKVFVADUSBVEUIULUMUN $.

    $( Value of the cumulative hierarchy of sets function at a limit ordinal.
       Part of Definition 9.9 of [TakeutiZaring] p. 76.  (Contributed by NM,
       4-Oct-2003.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
    r1lim $p |- ( ( A e. B /\ Lim A ) -> ( R1 ` A ) = U_ x e. A ( R1 ` x ) ) $=
      ( wcel wlim cr1 cdm cfv cv ciun wceq wa con0 limelon wfn r1fnon syl6eleqr
      fndm ax-mp r1limg sylancom ) BCDZBEZBFGZDBFHABAIFHJKUBUCLBMUDBCNFMOUDMKPM
      FRSQABTUA $.
  $}

  ${
    $d A n $.  $d m n $.
    $( The first ` om ` levels of the cumulative hierarchy are all finite.
       (Contributed by Mario Carneiro, 15-May-2013.) $)
    r1fin $p |- ( A e. om -> ( R1 ` A ) e. Fin ) $=
      ( vn vm cv cr1 cfv cfn wcel c0 csuc wceq fveq2 eleq1d r10 eqeltri com cpw
      0fin cdm wlim wss r1funlim simpri limomss ax-mp sseli r1sucg syl syl6rbbr
      wfun pwfi biimpd finds ) BDZEFZGHIEFZGHCDZEFZGHZUQJZEFZGHZAEFZGHBCAUNIKUO
      UPGUNIELMUNUQKUOURGUNUQELMUNUTKUOVAGUNUTELMUNAKUOVCGUNAELMUPIGNROUQPHZUSV
      BVDVBURQZGHUSVDVAVEGVDUQESZHVAVEKPVFUQVFTZPVFUAEUJVGUBUCVFUDUEUFUQUGUHMUR
      UKUIULUM $.
  $}

  ${
    $d A x $.  $d B x y $.
    $( Each stage in the cumulative hierarchy is strictly larger than the
       last.  (Contributed by Mario Carneiro, 19-Apr-2013.) $)
    r1sdom $p |- ( ( A e. On /\ B e. A ) -> ( R1 ` B ) ~< ( R1 ` A ) ) $=
      ( vx vy con0 wcel cr1 cfv csdm wbr cv wi c0 wceq eleq2 fveq2 imbi12d syl5
      breq2d cvv csuc noel pm2.21i wo elsuci fvex canth2 r1suc syl5breqr sdomtr
      cpw expcom syl com12 imim2i breq1d syl5ibr jaod com3r wlim wral wrex cuni
      a1i limuni eleq2d eluni2 syl6bb wa r19.29 cdom wss ciun ssiun2 r1lim mpan
      vex sseq2d ssdomg ee02 id sdomdomtr syl6 rexlimdv exp3acom23 sylbid com23
      imp tfinds ) AEFBAFZBGHZAGHZIJZBCKZFZWKWNGHZIJZLBMFZWKMGHZIJZLBDKZFZWKXAG
      HZIJZLZBXAUAZFZWKXFGHZIJZLWJWMLCDAWNMNZWOWRWQWTWNMBOXJWPWSWKIWNMGPSQWNXAN
      ZWOXBWQXDWNXABOXKWPXCWKIWNXAGPSQWNXFNZWOXGWQXIWNXFBOXLWPXHWKIWNXFGPSQWNAN
      ZWOWJWQWMWNABOXMWPWLWKIWNAGPSQWRWTBUBUCXEXGXAEFZXIXGXBBXANZUDXEXNXILZBXAU
      EXEXBXPXOXDXPXBXNXDXIXNXCXHIJZXDXILXNXCXCUKXHIXCXAGUFUGXAUHUIZXDXQXIWKXCX
      HUJULUMUNUOXOXPLXEXNXIXOXQXRXOWKXCXHIBXAGPUPUQVDURRUSWNUTZWOXEDWNVAZWQXSW
      OXBDWNVBZXTWQLXSWOBWNVCZFYAXSWNYBBWNVEVFDBWNVGVHXSXTYAWQXTYAVIXEXBVIZDWNV
      BXSWQXEXBDWNVJXSYCWQDWNXSXAWNFZXCWPVKJZYCWQLWPTFXSYDXCWPVLZYEWNGUFYDYFXSX
      CDWNXCVMZVLDWNXCVNXSWPYGXCWNTFXSWPYGNCVQDWNTVOVPVRUQXCWPTVSVTYCXDYEWQXEXB
      XDXEWAWHXDYEWQWKXCWPWBULRWCWDRWEWFWGWIWH $.
  $}

  ${
    $d x y $.
    $( The cumulative hierarchy is a one-to-one function.  (Contributed by
       Mario Carneiro, 19-Apr-2013.) $)
    r111 $p |- R1 : On -1-1-> _V $=
      ( vx vy con0 cvv cr1 cv cfv wi wral wcel wa wel word eloni w3a wbr r1sdom
      csdm syl5ibcom mtoi wf1 wf wceq weq wfn r1fnon dffn2 w3o ordtri3or syl2an
      mpbi wn sdomirr breq1 3adant1 pm2.21d 3expia ax-1 a1i breq2 3adant2 3jaod
      mpd rgen2a dff13 mpbir2an ) CDEUACDEUBZAFZEGZBFZEGZUCZABUDZHZBCIACIECUEVG
      UFCEUGUKVNABCVHCJZVJCJZKZABLZVMBALZUHZVNVOVHMVJMVTVPVHNVJNVHVJUIUJVQVRVNV
      MVSVOVPVRVNVOVPVROVLVMVPVRVLULZVOVPVRKZVLVKVKRPZVKUMZWBVIVKRPVLWCVJVHQVIV
      KVKRUNSTUOUPUQVMVNHVQVMVLURUSVOVPVSVNVOVPVSOVLVMVOVSWAVPVOVSKZVLWCWDWEVKV
      IRPVLWCVHVJQVIVKVKRUTSTVAUPUQVBVCVDABCDEVEVF $.
  $}

  ${
    $d x y z A $.
    $( The cumulative hierarchy of sets is transitive.  Lemma 7T of [Enderton]
       p. 202.  (Contributed by NM, 8-Sep-2003.)  (Revised by Mario Carneiro,
       16-Nov-2014.) $)
    r1tr $p |- Tr ( R1 ` A ) $=
      ( vx vy cr1 wcel cfv wtr con0 wlim c0 wceq wb fveq2 treq syl tr0 wa ndmfv
      wn mpbiri cdm word wfun r1funlim simpri limord ordsson mp2b sseli cv csuc
      wss r10 syl6eq limsuc ax-mp simpr pwtr r1sucg syl5ibrcom syl5bir pm2.61d1
      cpw sylib wral ciun triun r1limg ancoms syl5ibr impancom tfinds pm2.61i
      ex ) ADUAZEZADFZGZVPAHEVRVOHAVOIZVOUBVOHULDUCVSUDUEZVOUFVOUGUHUIBUJZDFZGZ
      JGZCUJZDFZGZWEUKZDFZGZVRBCAWAJKZWBJKZWCWDLZWKWBJDFJWAJDMUMUNWBJNZOWAWEKWB
      WFKWCWGLWAWEDMWBWFNOWAWHKWBWIKWCWJLWAWHDMWBWINOWAAKWBVQKWCVRLWAADMWBVQNOP
      WEHEZWGWJWOWGQZWHVOEZWJWQWEVOEZWPWJVSWRWQLVTVOWEUOUPWPWJWRWFVCZGZWPWGWTWO
      WGUQWFURVDWRWIWSKWJWTLWEUSWIWSNOUTVAWQSZWJWDPXAWIJKWJWDLWHDRWIJNOTVBVNWAI
      ZWGCWAVEZWCXBXCQWAVOEZWCXBXDXCWCXCWCXBXDQZCWAWFVFZGZCWAWFVGXEWBXFKZWCXGLX
      DXBXHCWAVHVIWBXFNOVJVKXDSZWCWDPXIWLWMWADRWNOTVBVNVLOVPSZVRWDPXJVQJKVRWDLA
      DRVQJNOTVM $.
  $}

  $( The union of a cumulative hierarchy of sets at ordinal ` A ` is a subset
     of the hierarchy at ` A ` .  JFM CLASSES1 th. 40.  (Contributed by FL,
     20-Apr-2011.) $)
  r1tr2 $p |- U. ( R1 ` A ) C_ ( R1 ` A ) $=
    ( cr1 cfv wtr cuni wss r1tr df-tr mpbi ) ABCZDJEJFAGJHI $.

  ${
    $d x y A $.  $d x B $.
    $( Ordering relation for the cumulative hierarchy of sets.  Part of
       Proposition 9.10(2) of [TakeutiZaring] p. 77.  (Contributed by NM,
       8-Sep-2003.) $)
    r1ordg $p |- ( B e. dom R1 -> ( A e. B -> ( R1 ` A ) e. ( R1 ` B ) ) ) $=
      ( vy cr1 wcel cfv wa con0 wss word ax-mp syl wi wceq eleq1 eleq2d imbi12d
      fveq2 wb syl2anc vx cdm csuc simpl wlim wfun r1funlim simpri limord sseli
      ordsson onelon sylan suceloni ordsucss imp cv cpw fvex pwid limsuc r1sucg
      eloni sylbir syl5eleqr a1i wtr r1tr dftr4 mpbi syl5sseqr a2i syl5bir wral
      sseld ciun wrex simprl simplr sucelon sylibr ad2antrr mpbird mpbid simprr
      ordelsuc ordtr1 rspcev eliun simpll r1limg eleqtrrd expr a1d tfindsg impr
      syl22anc ex ) BDUBZEZABEZADFZBDFZEZWTXAGZBHEZAUCZHEZXGBIZWTXDXEWTXFWTXAUD
      ZWSHBWSJZWSHIWSUEZXKDUFXLUGUHZWSUIKZWSUKKUJZLXEAHEZXHWTXFXAXPXOBAULUMAUNL
      WTXFXAXIXOXFXAXIXFBJXAXIMBVCABUOLUPUMXJXFXHGXIWTXDUAUQZWSEZXBXQDFZEZMZXGW
      SEZXBXGDFZEZMZCUQZWSEZXBYFDFZEZMZYFUCZWSEZXBYKDFZEZMZWTXDMUACBXGXQXGNZXRY
      BXTYDXQXGWSOYPXSYCXBXQXGDRPQXQYFNZXRYGXTYIXQYFWSOYQXSYHXBXQYFDRPQXQYKNZXR
      YLXTYNXQYKWSOYRXSYMXBXQYKDRPQXQBNZXRWTXTXDXQBWSOYSXSXCXBXQBDRPQYEXHYBXBXB
      URZYCXBADUSUTZYBAWSEZYCYTNZXLUUBYBSXMWSAVAKAVBZVDVEVFYJYOMYFHEXHGXGYFIZGY
      LYGYJYNXLYGYLSXMWSYFVAKYGYIYNYGYHYMXBYGYHURZYHYMYHVGYHUUFIYFVHYHVIVJYFVBV
      KVOVLVMVFXQUEZXHGZXGXQIZGYAUUEYJMCXQVNUUHUUIXRXTUUHUUIXRGZGZXBCXQYHVPZXSU
      UKYICXQVQZXBUULEUUKXGXQEZYDUUMUUKAXQEZUUNUUKUUOUUIUUHUUIXRVRUUKXPXQJZUUOU
      UISUUKXHXPUUGXHUUJVSAVTWAUUGUUPXHUUJXQUIWBAXQHWFTWCZUUGUUOUUNSXHUUJXQAVAW
      BWDUUKXBYTYCUUAUUKUUBUUCUUKUUOXRUUBUUQUUHUUIXRWEZXKUUOXRGUUBMXNAXQWSWGKTU
      UDLVEYIYDCXGXQYFXGNYHYCXBYFXGDRPWHTCXBXQYHWIWAUUKXRUUGXSUULNUURUUGXHUUJWJ
      CXQWKTWLWMWNWOWPWQWR $.
  $}

  $( Ordering relation for the cumulative hierarchy of sets.  Part of Theorem
     3.3(i) of [BellMachover] p. 478.  (Contributed by NM, 22-Sep-2003.) $)
  r1ord3g $p |- ( ( A e. dom R1 /\ B e. dom R1 ) -> ( A C_ B ->
               ( R1 ` A ) C_ ( R1 ` B ) ) ) $=
    ( cr1 cdm wcel wa wss wceq wo con0 wb wlim word wfun r1funlim simpri limord
    cfv sseli wi ordsson mp2b onsseleq syl2an r1ordg adantl wtr r1tr trss ax-mp
    syl6 fveq2 eqimss syl a1i jaod sylbid ) ACDZEZBUREZFZABGZABEZABHZIZACRZBCRZ
    GZUSAJEBJEVBVEKUTURJAURLZURMURJGCNVIOPURQURUAUBZSURJBVJSABUCUDVAVCVHVDVAVCV
    FVGEZVHUTVCVKTUSABUEUFVGUGVKVHTBUHVGVFUIUJUKVDVHTVAVDVFVGHVHABCULVFVGUMUNUO
    UPUQ $.

  $( Ordering relation for the cumulative hierarchy of sets.  Part of
     Proposition 9.10(2) of [TakeutiZaring] p. 77.  (Contributed by NM,
     8-Sep-2003.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
  r1ord $p |- ( B e. On -> ( A e. B -> ( R1 ` A ) e. ( R1 ` B ) ) ) $=
    ( con0 wcel cr1 cdm cfv wi wfn wceq r1fnon fndm ax-mp eleq2i r1ordg sylbir
    ) BCDBEFZDABDAEGBEGDHQCBECIQCJKCELMNABOP $.

  $( Ordering relation for the cumulative hierarchy of sets.  Part of
     Proposition 9.10(2) of [TakeutiZaring] p. 77.  (Contributed by NM,
     22-Sep-2003.) $)
  r1ord2 $p |- ( B e. On -> ( A e. B -> ( R1 ` A ) C_ ( R1 ` B ) ) ) $=
    ( con0 wcel cr1 cfv wss r1ord wtr wi r1tr trss ax-mp syl6 ) BCDABDAEFZBEFZD
    ZOPGZABHPIQRJBKPOLMN $.

  $( Ordering relation for the cumulative hierarchy of sets.  Part of Theorem
     3.3(i) of [BellMachover] p. 478.  (Contributed by NM, 22-Sep-2003.) $)
  r1ord3 $p |- ( ( A e. On /\ B e. On ) -> ( A C_ B ->
               ( R1 ` A ) C_ ( R1 ` B ) ) ) $=
    ( con0 wcel cr1 cdm wss cfv wi wfn wceq r1fnon fndm eleq2i r1ord3g syl2anbr
    ax-mp ) ACDAEFZDBRDABGAEHBEHGIBCDRCAECJRCKLCEMQZNRCBSNABOP $.

  $( The value of the cumulative hierarchy of sets function is a subset of its
     value at the successor.  JFM CLASSES1 Th. 39.  (Contributed by FL,
     20-Apr-2011.) $)
  r1sssuc $p |- ( A e. On -> ( R1 ` A ) C_ ( R1 ` suc A ) ) $=
    ( con0 wcel cr1 cfv cpw csuc wtr wss r1tr dftr4 mpbi r1suc syl5sseqr ) ABCA
    DEZFZOAGDEOHOPIAJOKLAMN $.

  ${
    $d x y A $.  $d x y B $.
    $( Each set of the cumulative hierarchy is closed under subsets.
       (Contributed by Mario Carneiro, 16-Nov-2014.) $)
    r1pwss $p |- ( A e. ( R1 ` B ) -> ~P A C_ ( R1 ` B ) ) $=
      ( vx vy cr1 cfv wcel c0 wceq con0 wa cpw wss ax-mp sylib wb limsuc sylibr
      wrex syl cv csuc cvv wlim w3o cdm word wfun r1funlim simpri limord elfvdm
      ordsson sseldi onzsl noel fveq2 syl6eq eleq2d biimpcd pm2.21d simpl simpr
      r10 mtoi fveq2d adantr eqeltrrd r1sucg eqtrd eleqtrd elpwi sspwb sseqtr4d
      ex rexlimdvw wtr r1tr ciun r1limg sylan eliun simprl ad2antlr simprr trss
      mpbid mpsyl ad2antrr wi ordtr1 syl2anc fvex elpw2 eleqtrrd rspcev adantld
      rexlimddv 3jaod mpd ) ABEFZGZBHIZBCUAZUBZIZCJSZBUCGZBUDZKZUEZALZXAMZXBBJG
      XKXBEUFZJBXNUGZXNJMXNUDZXOEUHXPUIUJZXNUKNZXNUMNABEULZUNCBUOOXBXCXMXGXJXBX
      CXMXBXCAHGZAUPXCXBXTXCXAHAXCXAHEFHBHEUQVDURUSUTVEVAXBXFXMCJXBXFXMXBXFKZXL
      XDEFZLZXAYAAYCGZXLYCMZYAAXAYCXBXFVBYAXAXEEFZYCYABXEEXBXFVCZVFYAXDXNGZYFYC
      IZYAXEXNGZYHYABXEXNYGXBBXNGZXFXSVGVHXPYHYJPXQXNXDQNZRXDVIZTVJZVKYDAYBMZYE
      AYBVLAYBVMZOTYNVNVOVPXBXIXMXHXBXIXMXAVQXBXIKZXLXAGXMBVRYQXLDBDUAZEFZVSZXA
      YQXLYSGZDBSZXLYTGYQAYBGZUUBCBYQACBYBVSZGUUCCBSYQAXAUUDXBXIVBXBYKXIXAUUDIX
      SCBVTWAVKCABYBWBOYQXDBGZUUCKZKZXEUBZBGZXLUUHEFZGZUUBUUGXEBGZUUIUUGUUEUULY
      QUUEUUCWCZXIUUEUULPXBUUFBXDQWDWGXIUULUUIPXBUUFBXEQWDWGUUGXLYFLZUUJUUGXLYF
      MXLUUNGUUGXLYCYFUUGYOYEYBVQUUGUUCYOXDVRYQUUEUUCWEYBAWFWHYPOUUGYHYIUUGUUEY
      KYHUUMXBYKXIUUFXSWIXOUUEYKKYHWJXRXDBXNWKNWLZYMTVNXLYFXEEWMWNRUUGYJUUJUUNI
      UUGYHYJUUOYLOXEVITWOUUAUUKDUUHBYRUUHIYSUUJXLYRUUHEUQUSWPWLWRDXLBYSWBRXBYK
      XIXAYTIXSDBVTWAWOXAXLWFWHVOWQWSWT $.
  $}

  $( Each set of the cumulative hierarchy is closed under subsets.
     (Contributed by Mario Carneiro, 16-Nov-2014.) $)
  r1sscl $p |- ( ( A e. ( R1 ` B ) /\ C C_ A ) -> C e. ( R1 ` B ) ) $=
    ( cr1 cfv wcel wss wa cpw r1pwss adantr elpw2g biimpar sseldd ) ABDEZFZCAGZ
    HAIZOCPROGQABJKPCRFQCAOLMN $.

  ${
    $d x y z w v A $.
    $( The value of the cumulative hierarchy of sets function expressed
       recursively.  Theorem 7Q of [Enderton] p. 202.  (Contributed by NM,
       25-Nov-2003.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    r1val1 $p |- ( A e. dom R1 -> ( R1 ` A ) = U_ x e. A ~P ( R1 ` x ) ) $=
      ( cr1 wcel cfv ciun c0 wceq con0 wlim wss word ax-mp sylib fveq2d eqsstrd
      wa simpr wi syl cdm cv cpw csuc wrex cvv w3o wfun r1funlim simpri ordsson
      limord sseli onzsl r10 syl6eq 0ss a1i nfv nfcv nfiu1 eleq1 biimpac limsuc
      nfss wb sylibr r1sucg eqtrd vex sucid syl5eleqr ssiun2 ex a1d rexlimd imp
      r1limg wral r1tr dftr4 mpbi ralrimivw ss2iun adantrl 3jaodan mpdan ordtr1
      ancoms ordelord mpan adantr ordelsuc syl2anc mpbid simpl r1ord3g eqsstr3d
      wtr mpd ralrimiva iunss eqssd ) BCUAZDZBCEZABAUBZCEZUCZFZXEBGHZBXGUDZHZAI
      UEZBUFDZBJZQZUGZXFXJKZXEBIDXRXDIBXDLZXDIKXDJZXTCUHYAUIUJZXDULMZXDUKMUMABU
      NNXEXKXSXNXQXEXKQZXFGXJYDXFGCEGYDBGCXEXKROUOUPGXJKYDXJUQURPXEXNXSXEXMXSAI
      XEAUSAXFXJAXFUTABXIVAVEXEXMXSSXGIDXEXMXSXEXMQZXFXIXJYEXFXLCEZXIYEBXLCXEXM
      RZOYEXGXDDZYFXIHZYEXLXDDZYHXMXEYJBXLXDVBVCYAYHYJVFYBXDXGVDMZVGXGVHZTVIYEX
      GBDZXIXJKYEXGXLBXGAVJVKYGVLABXIVMTPVNVOVPVQXEXPXSXOXEXPQZXFABXHFZXJABVRYN
      XHXIKZABVSYOXJKYNYPABYPYNXHWSYPXGVTXHWAWBURWCABXHXIWDTPWEWFWGXEXIXFKZABVS
      XJXFKXEYQABXEYMQZXIYFXFYRYHYIYMXEYHXTYMXEQYHSYCXGBXDWHMWIZYLTYRXLBKZYFXFK
      ZYRYMYTXEYMRZYRYMBLZYMYTVFUUBXEUUCYMXTXEUUCYCXDBWJWKWLXGBBWMWNWOYRYJXEYTU
      UASYRYHYJYSYKNXEYMWPXLBWQWNWTWRXAABXIXFXBVGXC $.
  $}

  ${
    $d x y z w v A $.  $d x y u F $.
    tz9.12lem.1 $e |- A e. _V $.
    tz9.12lem.2 $e |- F = ( z e. _V |-> |^| { v e. On | z e. ( R1 ` v ) } ) $.
    $( Lemma for ~ tz9.12 .  (Contributed by NM, 22-Sep-2003.)  (Revised by
       Mario Carneiro, 11-Sep-2015.) $)
    tz9.12lem1 $p |- ( F " A ) C_ On $=
      ( vx cima crn con0 imassrn cv cr1 cfv wcel crab cint wceq cvv wrex cab id
      rnmpt wss wne ssrab2 vex syl6eqelr intex sylibr oninton sylancr rexlimivw
      c0 eqeltrd abssi eqsstri sstri ) DCHDIZJDCKUSGLZALBLMNOZBJPZQZRZASTZGUAJA
      GSVCDFUCVEGJVDUTJOASVDUTVCJVDUBZVDVBJUDVBUNUEZVCJOVABJUFVDVCSOVGVDVCUTSVF
      GUGUHVBUIUJVBUKULUOUMUPUQUR $.

    $( Lemma for ~ tz9.12 .  (Contributed by NM, 22-Sep-2003.) $)
    tz9.12lem2 $p |- suc U. ( F " A ) e. On $=
      ( cima cuni con0 wss wcel tz9.12lem1 wfun cvv cv cr1 cfv crab cint ax-mp
      funmpt2 funimaex ssonunii onsuci ) DCGZHZUEIJUFIKABCDEFLUEDMUENKANAOBOPQK
      BIRSDFUADCEUBTUCTUD $.

    $( Lemma for ~ tz9.12 .  (Contributed by NM, 22-Sep-2003.)  (Revised by
       Mario Carneiro, 11-Sep-2015.) $)
    tz9.12lem3 $p |- ( A. x e. A E. y e. On x e. ( R1 ` y ) ->
                    A e. ( R1 ` suc suc U. ( F " A ) ) ) $=
      ( cv cr1 cfv wcel con0 wrex wral csuc wss cvv wceq sylibr cima cuni wa wi
      wfun cdm crab cint funmpt2 c0 fveq2 eleq2d rspcev rabn0 intex sylib eleq1
      wne vex rabbidv inteqd eleq1d dmmpt elrab2 funfvima tz9.12lem2 tz9.12lem1
      mpbiran sylancr onsucuni ax-mp sseli r1ord2 mpsyl syl6 fvmptg mpan ssrab2
      imp sylbi onint eqeltrd cbvrabv simprbi 3syl adantr sseldd exp31 rexlimdv
      com3r ralimia cpw r1suc eleq2i elpw dfss3 3bitri ) AIZBIZJKZLZBMNZAEOWRFE
      UAZUBPZJKZLZAEOZEXDPJKZLZXBXFAEWRELZXAXFBMWSMLZXAXJXFXKXAXJXFXKXAUCZXJUCW
      RFKZJKZXEWRXLXJXNXEQZXLXJXMXCLZXOXLFUEWRFUFZLZXJXPUDCRCIZDIZJKZLZDMUGZUHZ
      FHUIXLWRYALZDMUGZUHZRLZXRXLYFUJURZYHXLYEDMNYIYEXADWSMXTWSSYAWTWRXTWSJUKUL
      ZUMYEDMUNTZYFUOZUPXRWRRLZYHAUSZYDRLYHCWRRXQXSWRSZYDYGRYOYCYFYOYBYEDMXSWRY
      AUQUTVAZVBCRYDFHVCVDVHTEWRFVEVIXDMLZXPXMXDLXOCDEFGHVFZXCXDXMXCMQXCXDQCDEF
      GHVGXCVJVKVLXMXDVMVNVOVSXLWRXNLZXJXLYIXMYFLZYSYKYIXMYGYFYIYHXMYGSZYLYMYHU
      UAYNCWRYDYGRRFYPHVPVQVTYFMQYIYGYFLYEDMVRYFWAVQWBYTXMMLYSXAYSBXMMYFWSXMSWT
      XNWRWSXMJUKULYEXADBMYJWCVDWDWEWFWGWHWJWIWKXIEXEWLZLEXEQXGXHUUBEYQXHUUBSYR
      XDWMVKWNEXEGWOAEXEWPWQT $.
  $}

  ${
    $d x y z w v A $.
    tz9.12.1 $e |- A e. _V $.
    $( A set is well-founded if all of its elements are well-founded.
       Proposition 9.12 of [TakeutiZaring] p. 78.  The main proof consists of
       ~ tz9.12lem1 through ~ tz9.12lem3 .  (Contributed by NM,
       22-Sep-2003.) $)
    tz9.12 $p |- ( A. x e. A E. y e. On x e. ( R1 ` y ) ->
              E. y e. On A e. ( R1 ` y ) ) $=
      ( vz vv cv cr1 cfv wcel con0 wrex wral cvv crab cint cmpt cima cuni csuc
      eqid tz9.12lem2 onsuci tz9.12lem3 wceq fveq2 eleq2d rspcev sylancr ) AGBG
      ZHIZJBKLACMENEGFGHIJFKOPQZCRSTZTZKJCUNHIZJZCUKJZBKLUMEFCULDULUAZUBUCABEFC
      ULDURUDUQUPBUNKUJUNUEUKUOCUJUNHUFUGUHUI $.
  $}

  ${
    $d x y z w A $.
    tz9.13.1 $e |- A e. _V $.
    $( Every set is well-founded, assuming the Axiom of Regularity.  In other
       words, every set belongs to a layer of the cumulative hierarchy of
       sets.  Proposition 9.13 of [TakeutiZaring] p. 78.  (Contributed by NM,
       23-Sep-2003.) $)
    tz9.13 $p |- E. x e. On A e. ( R1 ` x ) $=
      ( vy vz vw cr1 cfv wcel con0 wrex cab cvv wss wceq vex eleq1 rexbidv elab
      cv setind wral ssel syl6ib ralrimiv tz9.12 syl sylibr mpg eleqtrri mpbi
      wi ) BDTZATGHZIZAJKZDLZIBUNIZAJKZBMUQCETZUQNZUTUQIZULUQMOEEUQUAVAUTUNIZAJ
      KZVBVAFTZUNIZAJKZFUTUBVDVAVGFUTVAVEUTIVEUQIVGUTUQVEUCUPVGDVEFPUMVEOUOVFAJ
      UMVEUNQRSUDUEFAUTEPZUFUGUPVDDUTVHUMUTOUOVCAJUMUTUNQRSUHUIUJUPUSDBCUMBOUOU
      RAJUMBUNQRSUK $.
  $}

  ${
    $d x y A $.
    $( Every set is well-founded, assuming the Axiom of Regularity.
       Proposition 9.13 of [TakeutiZaring] p. 78.  This variant of ~ tz9.13
       expresses the class existence requirement as an antecedent.
       (Contributed by NM, 4-Oct-2003.) $)
    tz9.13g $p |- ( A e. V -> E. x e. On A e. ( R1 ` x ) ) $=
      ( vy cv cr1 cfv wcel con0 wrex wceq eleq1 rexbidv vex tz9.13 vtoclg ) DEZ
      AEFGZHZAIJBRHZAIJDBCQBKSTAIQBRLMAQDNOP $.
  $}

  ${
    $d A x y z $.
    $( Two ways of saying a set is well-founded.  (Contributed by NM,
       11-Oct-2003.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
    rankwflemb $p |- ( A e. U. ( R1 " On ) <->
        E. x e. On A e. ( R1 ` suc x ) ) $=
      ( vy cr1 con0 cima cuni wcel cv csuc cfv wrex wa wceq r1funlim wss elfvdm
      wi ax-mp crn wex eluni wfun cdm wlim simpli fvelima mpan biimprcd cpw wtr
      eleq2 r1tr trss elpwg mpbird syl eleqtrrd a1i syl9 reximdvai syl5 exlimiv
      r1sucg sylbi fvelrn sylancr cres df-ima wrel funrel simpri limord ordsson
      imp word mp2b relssres mp2an rneqi eqtri syl6eleqr elunii mpdan rexlimivw
      impbii ) BDEFZGHZBAIZJZDKZHZAELZWHBCIZHZWNWGHZMZCUAWMCBWGUBWQWMCWOWPWMWPW
      IDKZWNNZAELZWOWMDUCZWPWTXADUDZUEZOUFZAWNEDUGUHWOWSWLAEWOWSBWRHZWIEHZWLWSX
      EWOWRWNBULUIXEWLRXFXEBWRUJZWKXEBXGHBWRPZWRUKXEXHRWIUMWRBUNSBWRWRUOUPXEWIX
      BHWKXGNBWIDQWIVDUQURUSUTVAVBVOVCVEWLWHAEWLWKWGHWHWLWKDTZWGWLXAWJXBHWKXIHX
      DBWJDQWJDVFVGWGDEVHZTXIDEVIXJDDVJZXBEPZXJDNXAXKXDDVKSXCXBVPXLXAXCOVLXBVMX
      BVNVQDEVRVSVTWAWBBWKWGWCWDWEWF $.
  $}

  ${
    $d x y z $.
    $( The domain and range of the ` rank ` function.  (Contributed by Mario
       Carneiro, 28-May-2013.)  (Revised by Mario Carneiro, 12-Sep-2013.) $)
    rankf $p |- rank : U. ( R1 " On ) --> On $=
      ( vx vy vz cr1 con0 cima cuni crnk wf wfn cv cfv wcel wceq eqtri mpbir2an
      cdm cvv mpan sylbi wral wfun csuc crab cint df-rank copab cmpt mptv dmeqi
      funmpt2 wex dmopab wb abeq1 wrex rankwflemb intexrab isset 3bitrri mpgbir
      cab df-fn c0 wne rabn0 bitr4i intex vex fvmpt2 wss ssrab2 oninton eqeltrd
      rgen ffnfv ) DEFGZEHIHVQJZAKZHLZEMZAVQUAVRHUBHQZVQNARVSBKUCDLMZBEUDZUEZHA
      BUFZUKWBCKWENZACUGZQZVQHWHHARWEUHWHWFACWEUIOUJWIWGCULZAVBZVQWGACUMWKVQNWJ
      VSVQMZUNAWJAVQUOWLWCBEUPZWERMZWJBVSUQZWCBEURCWEUSUTVAOOHVQVCPWAAVQWLWDVDV
      EZWAWLWMWPWOWCBEVFVGWPVTWEEWPWNVTWENZWDVHVSRMWNWQAVIARWERHWFVJSTWDEVKWPWE
      EMWCBEVLWDVMSVNTVOAVQEHVPP $.
  $}

  ${
    $d x y z A $.
    $( The rank of a set is an ordinal number.  Proposition 9.15(1) of
       [TakeutiZaring] p. 79.  (Contributed by NM, 5-Oct-2003.)  (Revised by
       Mario Carneiro, 12-Sep-2013.) $)
    rankon $p |- ( rank ` A ) e. On $=
      ( cr1 con0 cima cuni crnk rankf 0elon f0cli ) BCDECAFGHI $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Any member of the cumulative hierarchy is well-founded.  (Contributed by
       Mario Carneiro, 28-May-2013.)  (Revised by Mario Carneiro,
       16-Nov-2014.) $)
    r1elwf $p |- ( A e. ( R1 ` B ) -> A e. U. ( R1 " On ) ) $=
      ( vx cr1 cfv wcel cv csuc con0 wrex cima cuni cdm wlim word wfun r1funlim
      wss simpri wceq limord ordsson mp2b elfvdm sseldi cpw wtr r1tr trss ax-mp
      wi elpwg mpbird r1sucg syl eleqtrrd suceq fveq2d eleq2d rspcev rankwflemb
      syl2anc sylibr ) ABDEZFZACGZHZDEZFZCIJZADIKLFVEBIFABHZDEZFZVJVEDMZIBVNNZV
      NOVNIRDPVOQSVNUAVNUBUCABDUDZUEVEAVDUFZVLVEAVQFAVDRZVDUGVEVRUKBUHVDAUIUJAV
      DVDULUMVEBVNFVLVQTVPBUNUOUPVIVMCBIVFBTZVHVLAVSVGVKDVFBUQURUSUTVBCAVAVC $.
  $}

  ${
    $d A x y $.
    $( Value of the rank function.  Definition 9.14 of [TakeutiZaring] p. 79
       (proved as a theorem from our definition).  This variant of ~ rankval
       does not use Regularity, and so requires the assumption that ` A ` is in
       the range of ` R1 ` .  (Contributed by NM, 11-Oct-2003.)  (Revised by
       Mario Carneiro, 10-Sep-2013.) $)
    rankvalb $p |- ( A e. U. ( R1 " On ) ->
        ( rank ` A ) = |^| { x e. On | A e. ( R1 ` suc x ) } ) $=
      ( vy cr1 con0 cima cuni wcel cvv csuc crab cint crnk wceq elex rankwflemb
      cv cfv wrex intexrab bitri biimpi rabbidv inteqd df-rank fvmptg syl2anc
      eleq1 ) BDEFGZHZBIHBAQJDRZHZAEKZLZIHZBMRUNNBUIOUJUOUJULAESUOABPULAETUAUBC
      BCQZUKHZAEKZLUNIIMUPBNZURUMUSUQULAEUPBUKUHUCUDCAUEUFUG $.
  $}

  ${
    $d A x $.  $d B x $.
    $( One direction of ~ rankr1a .  (Contributed by Mario Carneiro,
       28-May-2013.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankr1ai $p |- ( A e. ( R1 ` B ) -> ( rank ` A ) e. B ) $=
      ( vx cr1 cfv wcel cv csuc con0 crab wss wrex eleq2d wa wb wi ax-mp sseldi
      syl sylbird cint crnk cdm elfvdm cpw ciun r1val1 eliun word wlim r1funlim
      syl6bb wfun simpri limord ordtr1 ancoms r1sucg ordsson rabid intss1 sylan
      sylbir reximdva sylbid mpcom cima cuni wceq r1elwf rankvalb sseq1d adantr
      ex rankon ontr2 sylancr exp3acom23 imp rexlimdva mpd ) ABDEZFZACGZHDEZFZC
      IJZUAZWDKZCBLZAUBEZBFZBDUCZFZWCWJABDUDZWNWCAWDDEUEZFZCBLZWJWNWCACBWPUFZFW
      RWNWBWSACBUGMCABWPUHULWNWQWICBWNWDBFZNZWQWFWIXAWDWMFZWFWQOWTWNXBWMUIZWTWN
      NXBPWMUJZXCDUMXDUKUNWMUOQZWDBWMUPQUQZXBWEWPAWDURMSXAWFWIXAWDIFZWFWIXAWMIW
      DXCWMIKXEWMUSQZXFRXGWFNWDWGFWIWFCIUTWDWGVAVCVBVNTVDVEVFWCWIWLCBWCWTNWIWKW
      DKZWLWCXIWIOWTWCWKWHWDWCADIVGVHFWKWHVIABVJCAVKSVLVMWCWTXIWLPWCXIWTWLWCWKI
      FBIFXIWTNWLPAVOWCWMIBXHWORWKWDBVPVQVRVSTVTWA $.
  $}

  ${
    $d x y z A $.
    $( Value of the rank function at a non-well-founded set.  (The antecedent
       is always false under Foundation, by ~ unir1 , unless ` A ` is a proper
       class.)  (Contributed by Mario Carneiro, 22-Mar-2013.)  (Revised by
       Mario Carneiro, 10-Sep-2013.) $)
    rankvaln $p |- ( -. A e. U. ( R1 " On ) -> ( rank ` A ) = (/) ) $=
      ( cr1 con0 cima cuni wcel crnk cdm cfv c0 wceq rankf eleq2i ndmfv sylnbir
      fdmi ) ABCDEZFAGHZFAGIJKRQAQCGLPMAGNO $.
  $}

  ${
    $d x y A $.
    $( Identity law for the rank function.  (Contributed by NM, 3-Oct-2003.)
       (Revised by Mario Carneiro, 22-Mar-2013.) $)
    rankidb $p |- ( A e. U. ( R1 " On ) -> A e. ( R1 ` suc ( rank ` A ) ) ) $=
      ( vx cr1 con0 cima cuni wcel csuc cfv crab cint crnk wrex rankwflemb nfcv
      cv nfrab1 wceq suceq fveq2d nfint nfsuc nffv nfel2 onminsb sylbi rankvalb
      eleq2d syl eleqtrrd ) ACDEFGZAABPZHZCIZGZBDJZKZHZCIZALIZHZCIUKUOBDMAUSGZB
      ANUOVBBBAUSBURCBCOBUQBUPUOBDQUAUBUCUDULUQRZUNUSAVCUMURCULUQSTUHUEUFUKVAUR
      CUKUTUQRVAURRBAUGUTUQSUITUJ $.
  $}

  $( A rank is a member of the cumulative hierarchy.  (Contributed by Mario
     Carneiro, 17-Nov-2014.) $)
  rankdmr1 $p |- ( rank ` A ) e. dom R1 $=
    ( cr1 con0 cima cuni wcel crnk cfv cdm csuc rankidb elfvdm syl wlim wb wfun
    r1funlim ax-mp c0 com simpri limsuc sylibr wn rankvaln wss limomss syl6eqel
    peano1 sselii pm2.61i ) ABCDEFZAGHZBIZFZULUMJZUNFZUOULAUPBHFUQAKAUPBLMUNNZU
    OUQOBPURQUAZUNUMUBRUCULUDUMSUNAUETUNSURTUNUFUSUNUGRUIUJUHUK $.

  $( A version of ~ rankr1a that is suitable without assuming Regularity or
     Replacement.  (Contributed by Mario Carneiro, 3-Jun-2013.)  (Revised by
     Mario Carneiro, 17-Nov-2014.) $)
  rankr1ag $p |- ( ( A e. U. ( R1 " On ) /\ B e. dom R1 ) ->
      ( A e. ( R1 ` B ) <-> ( rank ` A ) e. B ) ) $=
    ( cr1 con0 cima cuni wcel cdm cfv crnk rankr1ai csuc wss word wlim r1funlim
    wa wi wfun syl simpri limord ax-mp ordelord adantl ordsucss rankidb r1ord3g
    mpan elfvdm sylan adantr ssel syl5com 3syld impbid2 ) ACDEFGZBCHZGZQZABCIZG
    ZAJIZBGZABKUTVDVCLZBMZVECIZVAMZVBUTBNZVDVFRUSVIUQURNZUSVIUROZVJCSVKPUAURUBU
    CURBUDUIUEVCBUFTUQVEURGZUSVFVHRUQAVGGZVLAUGZAVECUJTVEBUHUKUTVMVHVBUQVMUSVNU
    LVGVAAUMUNUOUP $.

  $( A relationship between rank and ` R1 ` .  See ~ rankr1ag for the
     membership version.  (Contributed by Mario Carneiro, 17-Nov-2014.) $)
  rankr1bg $p |- ( ( A e. U. ( R1 " On ) /\ B e. dom R1 ) ->
    ( A C_ ( R1 ` B ) <-> ( rank ` A ) C_ B ) ) $=
    ( cr1 con0 cima cuni wcel cdm wa csuc cfv crnk wb wlim wfun r1funlim simpri
    wss ax-mp adantl limsuc rankr1ag sylan2b cpw wceq r1sucg fvex elpw2 syl6rbb
    eleq2d rankon word limord ordelon mpan onsssuc sylancr 3bitr4d ) ACDEFGZBCH
    ZGZIZABJZCKZGZALKZVCGZABCKZRZVFBRZVAUSVCUTGZVEVGMUTNZVAVKMCOVLPQZUTBUASAVCU
    BUCVBVEAVHUDZGVIVBVDVNAVAVDVNUEUSBUFTUJAVHBCUGUHUIVBVFDGBDGZVJVGMAUKVAVOUSU
    TULZVAVOVLVPVMUTUMSUTBUNUOTVFBUPUQUR $.

  $( Any set is a subset of the hierarchy of its rank.  (Contributed by Mario
     Carneiro, 3-Jun-2013.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  r1rankidb $p |- ( A e. U. ( R1 " On ) -> A C_ ( R1 ` ( rank ` A ) ) ) $=
    ( cr1 con0 cima cuni wcel crnk cfv wss ssid cdm wb rankdmr1 rankr1bg mpbiri
    mpan2 ) ABCDEFZAAGHZBHIZRRIZRJQRBKFSTLAMARNPO $.

  ${
    $d x A $.
    $( The range of the ` R1 ` function is transitive.  Lemma 2.10 of [Kunen]
       p. 97.  One direction of ~ r1elss that doesn't need ` A ` to be a set.
       (Contributed by Mario Carneiro, 22-Mar-2013.)  (Revised by Mario
       Carneiro, 16-Nov-2014.) $)
    r1elssi $p |- ( A e. U. ( R1 " On ) -> A C_ U. ( R1 " On ) ) $=
      ( vx cr1 con0 cima cuni wtr wcel wss wi cfv ciun triun r1tr a1i mprg wceq
      cv wb ax-mp wfun cdm wlim r1funlim simpli funiunfv treq mpbi trss ) CDEFZ
      GZAUJHAUJIJBDBRZCKZLZGZUKUMGZUOBDBDUMMUPULDHULNOPUNUJQZUOUKSCUAZUQURCUBUC
      UDUEBDCUFTUNUJUGTUHUJAUIT $.
  $}

  ${
    $d x y A $.
    r1elss.1 $e |- A e. _V $.
    $( The range of the ` R1 ` function is transitive.  Lemma 2.10 of [Kunen]
       p. 97.  (Contributed by Mario Carneiro, 22-Mar-2013.)  (Revised by Mario
       Carneiro, 16-Nov-2014.) $)
    r1elss $p |- ( A e. U. ( R1 " On ) <-> A C_ U. ( R1 " On ) ) $=
      ( vy vx cr1 con0 cima cuni wcel wss r1elssi cv cfv wrex wral tz9.12 dfss3
      eleq2i eliun bitr3i ciun wfn wfun wceq r1fnon fnfun funiunfv ralbii bitri
      mp2b 3imtr4i impbii ) AEFGHZIZAUMJZAKCLZDLEMZIDFNZCAOZAUQIDFNZUOUNCDABPUO
      UPUMIZCAOUSCAUMQVAURCAVAUPDFUQUAZIURVBUMUPEFUBEUCVBUMUDUEFEUFDFEUGUJZRDUP
      FUQSTUHUIUNAVBIUTVBUMAVCRDAFUQSTUKUL $.
  $}

  $( A power set is well-founded iff the base set is.  (Contributed by Mario
     Carneiro, 8-Jun-2013.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
  pwwf $p |- ( A e. U. ( R1 " On ) <-> ~P A e. U. ( R1 " On ) ) $=
    ( cr1 con0 cima cuni wcel cpw crnk cfv csuc wss r1rankidb sspwb wceq r1sucg
    sylib ax-mp sylibr syl cvv rankdmr1 syl6sseqr fvex elpw2 wlim wfun r1funlim
    cdm wb simpri limsuc mpbi syl6eleqr r1elwf r1elssi elex pwexb sseldd impbii
    pwidg ) ABCDEZFZAGZVAFZVBVCAHIZJZJZBIZFVDVBVCVFBIZGZVHVBVCVIKVCVJFVBVCVEBIZ
    GZVIVBAVKKVCVLKALAVKMPVEBUHZFZVIVLNAUAZVEOQUBVCVIVFBUCUDRVFVMFZVHVJNVNVPVOV
    MUEZVNVPUIBUFVQUGUJVMVEUKQULVFOQUMVCVGUNSVDVCVAAVCUOVDATFZAVCFVDVCTFVRVCVAU
    PAUQRATUTSURUS $.

  $( A subset of a well-founded set is well-founded.  (Contributed by Mario
     Carneiro, 17-Nov-2014.) $)
  sswf $p |- ( ( A e. U. ( R1 " On ) /\ B C_ A ) -> B e. U. ( R1 " On ) ) $=
    ( cr1 con0 cima cuni wcel wss crnk cfv csuc rankidb r1sscl sylan r1elwf syl
    wa ) ACDEFZGZBAHZQBAIJKZCJZGZBRGSAUBGTUCALAUABMNBUAOP $.

  $( A singleton is well-founded if its element is.  (Contributed by Mario
     Carneiro, 10-Jun-2013.)  (Revised by Mario Carneiro, 16-Nov-2014.) $)
  snwf $p |- ( A e. U. ( R1 " On ) -> { A } e. U. ( R1 " On ) ) $=
    ( cr1 con0 cima cuni wcel cpw csn pwwf wss snsspw sswf mpan2 sylbi ) ABCDEZ
    FAGZOFZAHZOFZAIQRPJSAKPRLMN $.

  $( A binary union is well-founded iff its elements are.  (Contributed by
     Mario Carneiro, 10-Jun-2013.)  (Revised by Mario Carneiro,
     17-Nov-2014.) $)
  unwf $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) <->
      ( A u. B ) e. U. ( R1 " On ) ) $=
    ( cr1 con0 wcel cun cfv wss r1rankidb ssun1 wi rankdmr1 ax-mp r1ord3g mp2an
    crnk syl6ss ssun2 sswf mpan2 cima cuni wa csuc cpw adantr cdm word r1funlim
    wlim wfun simpri limord ordunel mp3an adantl unssd fvex elpw2 sylibr r1sucg
    wceq syl6eleqr r1elwf syl jca impbii ) ACDUAUBZEZBVHEZUCZABFZVHEZVKVLAPGZBP
    GZFZUDZCGZEVMVKVLVPCGZUEZVRVKVLVSHVLVTEVKABVSVKAVNCGZVSVIAWAHVJAIUFVNVPHZWA
    VSHZVNVOJVNCUGZEZVPWDEZWBWCKALZWDUHZWEVOWDEZWFWDUJZWHCUKWJUIULWDUMMWGBLZWDV
    NVOUNUOZVNVPNOMQVKBVOCGZVSVJBWMHVIBIUPVOVPHZWMVSHZVOVNRWIWFWNWOKWKWLVOVPNOM
    QUQVLVSVPCURUSUTWFVRVTVBWLVPVAMVCVLVQVDVEVMVIVJVMAVLHVIABJVLASTVMBVLHVJBARV
    LBSTVFVG $.

  $( An unordered pair is well-founded if its elements are.  (Contributed by
     Mario Carneiro, 10-Jun-2013.)  (Revised by Mario Carneiro,
     17-Nov-2014.) $)
  prwf $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) ->
      { A , B } e. U. ( R1 " On ) ) $=
    ( cr1 con0 cima cuni wcel wa cpr csn df-pr snwf unwf biimpi syl2an syl5eqel
    cun ) ACDEFZGZBRGZHABIAJZBJZQZRABKSUARGZUBRGZUCRGZTALBLUDUEHUFUAUBMNOP $.

  $( An ordered pair is well-founded if its elements are.  (Contributed by
     Mario Carneiro, 10-Jun-2013.) $)
  opwf $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) ->
      <. A , B >. e. U. ( R1 " On ) ) $=
    ( cr1 con0 cima cuni wcel wa cop csn dfopg snwf adantr prwf syl2anc eqeltrd
    cpr ) ACDEFZGZBRGZHZABIAJZABQZQZRABRRKUAUBRGZUCRGUDRGSUETALMABNUBUCNOP $.

  $( The cumulative hierarchy of sets covers the universe.  Proposition 4.45
     (b) to (a) of [Mendelson] p. 281.  (Contributed by NM, 27-Sep-2004.)
     (Revised by Mario Carneiro, 8-Jun-2013.) $)
  unir1 $p |- U. ( R1 " On ) = _V $=
    ( vx cv cr1 con0 cima cuni wss wcel cvv wceq setind vex r1elss biimpri mpg
    wi ) ABZCDEFZGZQRHZPRIJAARKTSQALMNO $.

  $( Every set belongs to some value of the cumulative hierarchy of sets
     function ` R1 ` , i.e. the indexed union of all values of ` R1 ` is the
     universe.  Lemma 9.3 of [Jech] p. 71.  (Contributed by NM, 4-Oct-2003.)
     (Revised by Mario Carneiro, 8-Jun-2013.) $)
  jech9.3 $p |- U_ x e. On ( R1 ` x ) = _V $=
    ( con0 cv cr1 cfv ciun crn cuni cima cvv wfn wceq r1fnon fniunfv ax-mp fndm
    cdm imaeq2i imadmrn eqtr3i unieqi unir1 3eqtr2i ) ABACDEFZDGZHZDBIZHJDBKZUD
    UFLMABDNOUGUEDDQZIUGUEUIBDUHUIBLMBDPORDSTUAUBUC $.

  ${
    $d x A $.
    $( Every set is well-founded, assuming the Axiom of Regularity.
       Proposition 9.13 of [TakeutiZaring] p. 78.  This variant of ~ tz9.13g is
       useful in proofs of theorems about the rank function.  (Contributed by
       NM, 4-Oct-2003.) $)
    rankwflem $p |- ( A e. V -> E. x e. On A e. ( R1 ` suc x ) ) $=
      ( wcel cr1 con0 cima cuni cv csuc cfv wrex cvv unir1 syl6eleqr rankwflemb
      elex sylib ) BCDZBEFGHZDBAIJEKDAFLSBMTBCQNOABPR $.
  $}

  ${
    $d x y z A $.
    rankval.1 $e |- A e. _V $.
    $( Value of the rank function.  Definition 9.14 of [TakeutiZaring] p. 79
       (proved as a theorem from our definition).  (Contributed by NM,
       24-Sep-2003.)  (Revised by Mario Carneiro, 10-Sep-2013.) $)
    rankval $p |- ( rank ` A ) = |^| { x e. On | A e. ( R1 ` suc x ) } $=
      ( cr1 con0 cima cuni wcel crnk cfv csuc crab cint wceq cvv unir1 eleqtrri
      cv rankvalb ax-mp ) BDEFGZHBIJBARKDJHAELMNBOUACPQABST $.
  $}

  ${
    $d x y A $.
    $( Value of the rank function.  Definition 9.14 of [TakeutiZaring] p. 79
       (proved as a theorem from our definition).  This variant of ~ rankval
       expresses the class existence requirement as an antecedent instead of a
       hypothesis.  (Contributed by NM, 5-Oct-2003.) $)
    rankvalg $p |- ( A e. V ->
                   ( rank ` A ) = |^| { x e. On | A e. ( R1 ` suc x ) } ) $=
      ( vy cv crnk cfv csuc wcel con0 crab cint wceq fveq2 eleq1 rabbidv inteqd
      cr1 eqeq12d vex rankval vtoclg ) DEZFGZUCAEHRGZIZAJKZLZMBFGZBUEIZAJKZLZMD
      BCUCBMZUDUIUHULUCBFNUMUGUKUMUFUJAJUCBUEOPQSAUCDTUAUB $.

    $( Value of an alternate definition of the rank function.  Definition of
       [BellMachover] p. 478.  (Contributed by NM, 8-Oct-2003.) $)
    rankval2 $p |- ( A e. B ->
                   ( rank ` A ) = |^| { x e. On | A C_ ( R1 ` x ) } ) $=
      ( wcel crnk cfv cv csuc cr1 con0 crab cint wss rankvalg r1suc eleq2d fvex
      cpw elpw2 syl6bb rabbiia inteqi syl6eq ) BCDBEFBAGZHIFZDZAJKZLBUDIFZMZAJK
      ZLABCNUGUJUFUIAJUDJDZUFBUHRZDUIUKUEULBUDOPBUHUDIQSTUAUBUC $.
  $}

  ${
    $d x y A $.
    $( A union is well-founded iff the base set is.  (Contributed by Mario
       Carneiro, 8-Jun-2013.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    uniwf $p |- ( A e. U. ( R1 " On ) <-> U. A e. U. ( R1 " On ) ) $=
      ( cr1 con0 cima cuni wcel crnk cfv csuc cpw wss wtr r1tr rankidb trss cdm
      mpsyl wceq rankdmr1 r1sucg ax-mp syl6sseq sspwuni sylib fvex elpw2 sylibr
      syl6eleqr r1elwf syl pwwf pwuni sswf mpan2 sylbi impbii ) ABCDEZFZAEZUQFZ
      URUSAGHZIZBHZFUTURUSVABHZJZVCURUSVDKZUSVEFURAVEKVFURAVCVEVCLURAVCFAVCKVBM
      ANVCAOQVABPFVCVERASVATUAZUBAVDUCUDUSVDVABUEUFUGVGUHUSVBUIUJUTUSJZUQFZURUS
      UKVIAVHKURAULVHAUMUNUOUP $.
  $}

  $( Lemma for ~ rankr1c .  (Contributed by NM, 6-Oct-2003.)  (Revised by Mario
     Carneiro, 17-Nov-2014.) $)
  rankr1clem $p |- ( ( A e. U. ( R1 " On ) /\ B e. dom R1 ) ->
                  ( -. A e. ( R1 ` B ) <-> B C_ ( rank ` A ) ) ) $=
    ( cr1 con0 cima cuni wcel cdm wa cfv wn crnk rankr1ag notbid word wlim wfun
    wss wb r1funlim simpri limord ordelon adantl rankon ontri1 sylancl bitr4d
    ax-mp mpan ) ACDEFGZBCHZGZIZABCJGZKALJZBGZKZBUPRZUNUOUQABMNUNBDGZUPDGUSURSU
    MUTUKULOZUMUTULPZVACQVBTUAULUBUIULBUCUJUDAUEBUPUFUGUH $.

  ${
    $d x y A $.  $d x y B $.
    $( A relationship between the rank function and the cumulative hierarchy of
       sets function ` R1 ` .  Proposition 9.15(2) of [TakeutiZaring] p. 79.
       (Contributed by Mario Carneiro, 22-Mar-2013.)  (Revised by Mario
       Carneiro, 17-Nov-2014.) $)
    rankr1c $p |- ( A e. U. ( R1 " On ) -> ( B = ( rank ` A ) <->
                 ( -. A e. ( R1 ` B ) /\ A e. ( R1 ` suc B ) ) ) ) $=
      ( cr1 con0 cima cuni wcel cdm crnk cfv wceq wn csuc wa wi wb ax-mp adantl
      a1i wss rankdmr1 syl6eqel elfvdm r1funlim simpri limsuc sylibr rankr1clem
      wlim wfun rankr1ag sylan2b rankon word limord ordelon mpan onsssuc bitr4d
      id sylancr anbi12d eqss syl6rbbr ex pm5.21ndd ) ACDEFGZBCHZGZBAIJZKZABCJG
      LZABMZCJGZNZVKVIOVGVKBVJVHVKUTAUAUBSVOVIOVGVNVIVLVNVMVHGZVIAVMCUCVHUIZVIV
      PPCUJVQUDUEZVHBUFQZUGRSVGVIVKVOPVGVINZVOBVJTZVJBTZNVKVTVLWAVNWBABUHVTVNVJ
      VMGZWBVIVGVPVNWCPVSAVMUKULVTVJDGBDGZWBWCPAUMVIWDVGVHUNZVIWDVQWEVRVHUOQVHB
      UPUQRVJBURVAUSVBBVJVCVDVEVF $.
  $}

  $( A relationship between the rank function and the cumulative hierarchy of
     sets function ` R1 ` .  (Contributed by Mario Carneiro, 17-Nov-2014.) $)
  rankidn $p |- ( A e. U. ( R1 " On ) -> -. A e. ( R1 ` ( rank ` A ) ) ) $=
    ( cr1 con0 cima cuni wcel crnk cfv wn csuc wceq eqid rankr1c mpbii simpld
    wa ) ABCDEFZAAGHZBHFIZARJBHFZQRRKSTPRLARMNO $.

  $( The rank of a power set.  Part of Exercise 30 of [Enderton] p. 207.
     (Contributed by Mario Carneiro, 3-Jun-2013.) $)
  rankpwi $p |- ( A e. U. ( R1 " On ) ->
      ( rank ` ~P A ) = suc ( rank ` A ) ) $=
    ( cr1 con0 cima cuni wcel crnk cfv csuc cpw wceq rankidn rankon r1suc ax-mp
    wn eleq2i wss elpwi pwidg ssel syl5com syl5 syl5bi mtod r1rankidb syl6sseqr
    sspwb sylib fvex elpw2 sylibr onsuci syl6eleqr wa wb pwwf rankr1c mpbir2and
    sylbi eqcomd ) ABCDEZFZAGHZIZAJZGHZVCVEVGKZVFVEBHZFZPZVFVEIBHZFZVCVJAVDBHZF
    ZALVJVFVNJZFZVCVOVIVPVFVDCFVIVPKAMZVDNOZQVQVFVNRZVCVOVFVNSVCAVFFVTVOAVBTVFV
    NAUAUBUCUDUEVCVFVIJZVLVCVFVIRVFWAFVCVFVPVIVCAVNRVFVPRAUFAVNUHUIVSUGVFVIVEBU
    JUKULVECFVLWAKVDVRUMVENOUNVCVFVBFVHVKVMUOUPAUQVFVEURUTUSVA $.

  $( The membership relation is inherited by the rank function.  Proposition
     9.16 of [TakeutiZaring] p. 79.  (Contributed by NM, 4-Oct-2003.)  (Revised
     by Mario Carneiro, 17-Nov-2014.) $)
  rankelb $p |- ( B e. U. ( R1 " On ) -> ( A e. B ->
        ( rank ` A ) e. ( rank ` B ) ) ) $=
    ( cr1 con0 cima cuni wcel crnk cfv wa wn r1elssi sseld rankidn syl6 imp wss
    rankon mp2an rankdmr1 ontri1 cdm r1ord3g r1rankidb sselda ssel syl5com syl5
    wb wi syl5bir mt3d ex ) BCDEFZGZABGZAHIZBHIZGZUOUPJZUSAUQCIZGZUOUPVBKZUOUPA
    UNGVCUOBUNABLMANOPUSKZURUQQZUTVBURDGUQDGVEVDUIBRARURUQUASVEURCIZVAQZUTVBURC
    UBZGUQVHGVEVGUJBTATURUQUCSUTAVFGVGVBUOBVFABUDUEVFVAAUFUGUHUKULUM $.

  $( A well-founded set is not a member of itself.  This proof does not require
     the axiom of regularity, unlike ~ elirr .  (Contributed by Mario Carneiro,
     2-Jan-2017.) $)
  wfelirr $p |- ( A e. U. ( R1 " On ) -> -. A e. A ) $=
    ( cr1 con0 cima cuni wcel crnk cfv rankon onirri rankelb mtoi ) ABCDEFAAFAG
    HZMFMAIJAAKL $.

  ${
    $d x y A $.
    $( The value of the rank function expressed recursively: the rank of a set
       is the smallest ordinal number containing the ranks of all members of
       the set.  Proposition 9.17 of [TakeutiZaring] p. 79.  (Contributed by
       Mario Carneiro, 17-Nov-2014.) $)
    rankval3b $p |- ( A e. U. ( R1 " On ) ->
          ( rank ` A ) = |^| { x e. On | A. y e. A ( rank ` y ) e. x } ) $=
      ( cr1 con0 cima wcel crnk cfv cv wral cint wa wss wi wn wb syl2anc sylibr
      ex cab wal rankon simprl ontri1 sylancr con2bid cdm r1elssi adantr sselda
      cuni crab rankdmr1 wlim word r1funlim simpri limord ordtr1 mpan2 ad2antlr
      wfun rankr1ag ralbidva biimpar an32s dfss3 simpll adantl rankr1bg adantrl
      mp2b mpbid sylbird pm2.18d alrimiv ssintab df-rab inteqi rankelb ralrimiv
      syl6sseqr wceq eleq2 ralbidv onintss mpsyl eqssd ) CDEFULZGZCHIZBJZHIZAJZ
      GZBCKZAEUMZLZWKWLWOEGZWQMZAUAZLZWSWKXAWLWONZOZAUBWLXCNWKXEAWKXAXDWKXAMZXD
      XFXDPWOWLGZXDXFXDXGXFWLEGZWTXDXGPQCUCZWKWTWQUDWLWOUEUFUGWKWQXGXDOWTWKWQMZ
      XGXDXJXGMZCWODIZNZXDXKWMXLGZBCKZXMWKXGWQXOWKXGMZXOWQXPXNWPBCXPWMCGZMWMWJG
      WODUHZGZXNWPQXPCWJWMWKCWJNXGCUIUJUKXGXSWKXQXGWLXRGZXSCUNXRUOZXRUPXGXTMXSO
      DVCYAUQURXRUSWOWLXRUTVMVAZVBWMWOVDRVEVFVGBCXLVHSXKWKXSXMXDQWKWQXGVIXGXSXJ
      YBVJCWOVKRVNTVLVOVPTVQXAAWLVRSWRXBWQAEVSVTWCXHWKWNWLGZBCKZWSWLNXIWKYCBCWM
      CWAWBWQYDAWLWOWLWDWPYCBCWOWLWNWEWFWGWHWI $.

    $( The rank of a singleton.  Theorem 15.17(v) of [Monk1] p. 112.
       (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    ranksnb $p |- ( A e. U. ( R1 " On ) ->
        ( rank ` { A } ) = suc ( rank ` A ) ) $=
      ( vy vx cr1 con0 cima cuni wcel cv crnk cfv csn wral crab cint csuc fveq2
      wceq eleq1d ralsng rabbidv inteqd snwf rankval3b syl rankon onsucmin mp1i
      3eqtr4d ) ADEFGZHZBIZJKZCIZHZBALZMZCENZOZAJKZUNHZCENZOZUPJKZUTPZUKURVBUKU
      QVACEUOVABAUJULARUMUTUNULAJQSTUAUBUKUPUJHVDUSRAUCCBUPUDUEUTEHVEVCRUKAUFCU
      TUGUHUI $.
  $}

  ${
    $d x y z A $.
    $( Lemma for ~ rankonid .  (Contributed by NM, 14-Oct-2003.)  (Revised by
       Mario Carneiro, 22-Mar-2013.) $)
    rankonidlem $p |- ( A e. dom R1 ->
        ( A e. U. ( R1 " On ) /\ ( rank ` A ) = A ) ) $=
      ( vx vy vz con0 wcel cr1 crnk cfv wceq wa ax-mp cv wi eleq1 wral syl csuc
      wb wss cima cuni word wlim wfun r1funlim simpri limord ordelon mpan fveq2
      cdm id eqeq12d anbi12d imbi12d ordtr1 ancoms ralbidva cpw simplr ad2antrr
      pm5.5 eloni ordelsuc syl2anc mpbid adantr limsuc sylib simpll r1ord3g mpd
      rankidb ad2antrl suceq ad2antll fveq2d eleqtrd sseldd ralimdva imp sylibr
      ex dfss3 vex elpw r1sucg eleqtrrd r1elwf crab cint rankval3b adantl ralbi
      ralimi syl6bbr rabbidv inteqd intmin 3eqtrd jca sylbid com12 tfis3 mpcom
      a1i ) AEFZAGULZFZAGEUAUBZFZAHIZAJZKZXIUCZXJXHXIUDZXPGUEXQUFUGZXIUHLZXIAUI
      UJBMZXIFZXTXKFZXTHIZXTJZKZNZCMZXIFZYGXKFZYGHIZYGJZKZNZXJXONBCAXTYGJZYAYHY
      EYLXTYGXIOYNYBYIYDYKXTYGXKOYNYCYJXTYGXTYGHUKYNUMUNUOUPXTAJZYAXJYEXOXTAXIO
      YOYBXLYDXNXTAXKOYOYCXMXTAXTAHUKYOUMUNUOUPYMCXTPZYFNXTEFZYAYPYEYAYPYLCXTPZ
      YEYAYMYLCXTYAYGXTFZKZYHYMYLSYSYAYHXPYSYAKYHNXSYGXTXIUQLURZYHYLVCQUSYAYRYE
      YAYRKZYBYDUUBXTXTRZGIZFYBUUBXTXTGIZUTZUUDUUBXTUUETZXTUUFFUUBYGUUEFZCXTPZU
      UGYAYRUUIYAYLUUHCXTYTYLUUHYTYLKZYGRZGIZUUEYGUUJUUKXTTZUULUUETZUUJYSUUMYAY
      SYLVAZUUJYSXTUCZYSUUMSUUOUUJYQUUPYAYQYSYLXPYAYQXSXIXTUIUJZVBXTVDQYGXTXTVE
      VFVGUUJUUKXIFZYAUUMUUNNUUJYHUURYTYHYLUUAVHXQYHUURSXRXIYGVILVJYAYSYLVKUUKX
      TVLVFVMUUJYGYJRZGIZUULYIYGUUTFYTYKYGVNVOUUJUUSUUKGYKUUSUUKJYTYIYJYGVPVQVR
      VSVTWDWAWBCXTUUEWEWCXTUUEBWFWGWCYAUUDUUFJYRXTWHVHWIXTUUCWJQZUUBYCYJDMZFZC
      XTPZDEWKZWLZXTUVBTZDEWKZWLZXTUUBYBYCUVFJUVADCXTWMQYRUVFUVIJYAYRUVEUVHYRUV
      DUVGDEYRUVDYGUVBFZCXTPZUVGYRUVCUVJSZCXTPUVDUVKSYLUVLCXTYKUVLYIYJYGUVBOWNW
      PUVCUVJCXTWOQCXTUVBWEWQWRWSWNUUBYQUVIXTJYAYQYRUUQVHDXTEWTQXAXBWDXCXDXGXEX
      F $.
  $}

  ${
    $d x y z $.
    $( The rank of an ordinal number is itself.  Proposition 9.18 of
       [TakeutiZaring] p. 79 and its converse.  (Contributed by NM,
       14-Oct-2003.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankonid $p |- ( A e. dom R1 <-> ( rank ` A ) = A ) $=
      ( cr1 wcel crnk wceq con0 cima cuni rankonidlem simprd rankdmr1 syl6eqelr
      cdm cfv id impbii ) ABMZCZADNZAEZRABFGHCTAIJTASQTOAKLP $.
  $}

  $( The ordinals are all well-founded.  (Contributed by Mario Carneiro,
     22-Mar-2013.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  onwf $p |- On C_ U. ( R1 " On ) $=
    ( vx con0 cr1 cdm cima cuni wceq r1fnon fndm ax-mp cv wcel crnk rankonidlem
    wfn cfv simpld ssriv eqsstr3i ) BCDZCBEFZCBOTBGHBCIJATUAAKZTLUBUALUBMPUBGUB
    NQRS $.

  ${
    $d A x $.
    $( Initial segments of the ordinals are contained in initial segments of
       the cumulative hierarchy.  (Contributed by FL, 20-Apr-2011.)  (Revised
       by Mario Carneiro, 17-Nov-2014.) $)
    onssr1 $p |- ( A e. dom R1 -> A C_ ( R1 ` A ) ) $=
      ( vx cr1 cdm wcel cfv cv crnk con0 cima cuni wceq wlim word wfun r1funlim
      wa wi simpri limord ordtr1 ancoms rankonidlem syl simprd simpr eqeltrd wb
      mp2b simpld simpl rankr1ag syl2anc mpbird ex ssrdv ) ACDZEZBAACFZURBGZAEZ
      UTUSEZURVAQZVBUTHFZAEZVCVDUTAVCUTCIJKEZVDUTLZVCUTUQEZVFVGQVAURVHUQMZUQNVA
      URQVHRCOVIPSUQTUTAUQUAUIUBUTUCUDZUEURVAUFUGVCVFURVBVEUHVCVFVGVJUJURVAUKUT
      AULUMUNUOUP $.
  $}

  $( A relationship between the rank function and the cumulative hierarchy of
     sets function ` R1 ` .  Proposition 9.15(2) of [TakeutiZaring] p. 79.
     (Contributed by NM, 6-Oct-2003.)  (Revised by Mario Carneiro,
     17-Nov-2014.) $)
  rankr1g $p |- ( A e. V -> ( B = ( rank ` A ) <->
               ( -. A e. ( R1 ` B ) /\ A e. ( R1 ` suc B ) ) ) ) $=
    ( wcel cr1 con0 cima cuni crnk cfv wceq wn csuc wa cvv elex unir1 syl6eleqr
    wb rankr1c syl ) ACDZAEFGHZDBAIJKABEJDLABMEJDNSUBAOUCACPQRABTUA $.

  ${
    $d x y A $.
    rankid.1 $e |- A e. _V $.
    $( Identity law for the rank function.  (Contributed by NM, 3-Oct-2003.)
       (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankid $p |- A e. ( R1 ` suc ( rank ` A ) ) $=
      ( cr1 con0 cima cuni wcel crnk cfv csuc cvv unir1 eleqtrri rankidb ax-mp
      ) ACDEFZGAAHIJCIGAKPBLMANO $.

    $( A relationship between the rank function and the cumulative hierarchy of
       sets function ` R1 ` .  Proposition 9.15(2) of [TakeutiZaring] p. 79.
       (Contributed by NM, 6-Oct-2003.)  (Proof shortened by Mario Carneiro,
       17-Nov-2014.) $)
    rankr1 $p |- ( B = ( rank ` A ) <->
                 ( -. A e. ( R1 ` B ) /\ A e. ( R1 ` suc B ) ) ) $=
      ( cvv wcel crnk cfv wceq cr1 wn csuc wa wb rankr1g ax-mp ) ADEBAFGHABIGEJ
      ABKIGELMCABDNO $.

    $( A relationship between an ordinal number less than or equal to a rank,
       and the cumulative hierarchy of sets ` R1 ` .  Proposition 9.15(3) of
       [TakeutiZaring] p. 79.  (Contributed by NM, 8-Oct-2003.)  (Revised by
       Mario Carneiro, 17-Nov-2014.) $)
    ssrankr1 $p |- ( B e. On ->
                   ( B C_ ( rank ` A ) <-> -. A e. ( R1 ` B ) ) ) $=
      ( con0 wcel cr1 cfv wn crnk wss cima cuni cdm cvv unir1 eleqtrri wfn wceq
      wb r1fnon fndm ax-mp eleq2i biimpri rankr1clem sylancr bicomd ) BDEZABFGE
      HZBAIGJZUHAFDKLZEBFMZEZUIUJSANUKCOPUMUHULDBFDQULDRTDFUAUBUCUDABUEUFUG $.

    $( A relationship between rank and ` R1 ` , clearly equivalent to
       ~ ssrankr1 and friends through trichotomy, but in Raph's opinion
       considerably more intuitive.  See ~ rankr1b for the subset verion.
       (Contributed by Raph Levien, 29-May-2004.) $)
    rankr1a $p |- ( B e. On -> ( A e. ( R1 ` B ) <-> ( rank ` A ) e. B ) ) $=
      ( con0 wcel cr1 cfv wss wn ssrankr1 wb rankon ontri1 mpan2 bitr3d con4bid
      crnk ) BDEZABFGEZAQGZBEZRBTHZSIUAIZABCJRTDEUBUCKALBTMNOP $.
  $}

  ${
    $d x y A $.
    $( The value of the cumulative hierarchy of sets function expressed in
       terms of rank.  Definition 15.19 of [Monk1] p. 113.  (Contributed by NM,
       30-Nov-2003.) $)
    r1val2 $p |- ( A e. On -> ( R1 ` A ) = { x | ( rank ` x ) e. A } ) $=
      ( con0 wcel cv crnk cfv cr1 vex rankr1a abbi2dv ) BCDAEZFGBDABHGLBAIJK $.

    $( The value of the cumulative hierarchy of sets function expressed in
       terms of rank.  Theorem 15.18 of [Monk1] p. 113.  (Contributed by NM,
       30-Nov-2003.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    r1val3 $p |- ( A e. On ->
                 ( R1 ` A ) = U_ x e. A ~P { y | ( rank ` y ) e. x } ) $=
      ( con0 wcel cr1 cfv cv cpw ciun crnk cab cdm wceq wfn r1fnon ax-mp eleq2i
      fndm r1val1 sylbir wa onelon r1val2 syl pweqd iuneq2dv eqtrd ) CDEZCFGZAC
      AHZFGZIZJZACBHKGUKEBLZIZJUICFMZEUJUNNUQDCFDOUQDNPDFSQRACTUAUIACUMUPUIUKCE
      UBZULUOURUKDEULUONCUKUCBUKUDUEUFUGUH $.
  $}

  ${
    rankel.1 $e |- B e. _V $.
    $( The membership relation is inherited by the rank function.  Proposition
       9.16 of [TakeutiZaring] p. 79.  (Contributed by NM, 4-Oct-2003.)
       (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankel $p |- ( A e. B -> ( rank ` A ) e. ( rank ` B ) ) $=
      ( cr1 con0 cima cuni wcel crnk cfv wi cvv unir1 eleqtrri rankelb ax-mp )
      BDEFGZHABHAIJBIJHKBLQCMNABOP $.
  $}

  ${
    $d x y A $.
    rankval3.1 $e |- A e. _V $.
    $( The value of the rank function expressed recursively: the rank of a set
       is the smallest ordinal number containing the ranks of all members of
       the set.  Proposition 9.17 of [TakeutiZaring] p. 79.  (Contributed by
       NM, 11-Oct-2003.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankval3 $p |- ( rank ` A ) =
                  |^| { x e. On | A. y e. A ( rank ` y ) e. x } $=
      ( cr1 con0 cima cuni wcel crnk cfv wral crab cint wceq cvv unir1 eleqtrri
      cv rankval3b ax-mp ) CEFGHZICJKBSJKASIBCLAFMNOCPUBDQRABCTUA $.
  $}

  ${
    $d x y A $.
    $( Any class whose elements have bounded rank is a set.  Proposition 9.19
       of [TakeutiZaring] p. 80.  (Contributed by NM, 13-Oct-2003.) $)
    bndrank $p |- ( E. x e. On A. y e. A ( rank ` y ) C_ x -> A e. _V ) $=
      ( cv crnk cfv wss wral cvv wcel con0 csuc cr1 word wb rankon onordi eloni
      ordsucsssuc sylancr onsuci suceloni r1ord3 sylbid vex rankid ssel syl6mpi
      wi ralimdv dfss3 fvex ssex sylbir syl6 rexlimiv ) BDZEFZADZGZBCHZCIJZAKUS
      KJZVAUQUSLZMFZJZBCHZVBVCUTVFBCVCUTURLZMFZVEGZUQVIJVFVCUTVHVDGZVJVCURNUSNU
      TVKOURUQPZQUSRURUSSTVCVHKJVDKJVKVJUIURVLUAUSUBVHVDUCTUDUQBUEUFVIVEUQUGUHU
      JVGCVEGVBBCVEUKCVEVDMULUMUNUOUP $.

    $( The elements of a proper class have unbounded rank.  Exercise 2 of
       [TakeutiZaring] p. 80.  (Contributed by NM, 13-Oct-2003.) $)
    unbndrank $p |- ( -. A e. _V -> A. x e. On E. y e. A x e. ( rank ` y ) ) $=
      ( cv crnk cfv wcel wrex con0 wral cvv wn wss wb rankon ontri1 mpan ralnex
      ralbidv syl6bb rexbiia rexnal bitri bndrank sylbir con1i ) ADZBDZEFZGZBCH
      ZAIJZCKGZULLZUIUGMZBCJZAIHZUMUQUKLZAIHUNUPURAIUGIGZUPUJLZBCJURUSUOUTBCUII
      GUSUOUTNUHOUIUGPQSUJBCRTUAUKAIUBUCABCUDUEUF $.
  $}

  ${
    rankpw.1 $e |- A e. _V $.
    $( The rank of a power set.  Part of Exercise 30 of [Enderton] p. 207.
       (Contributed by NM, 22-Nov-2003.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    rankpw $p |- ( rank ` ~P A ) = suc ( rank ` A ) $=
      ( cr1 con0 cima cuni wcel cpw crnk cfv csuc wceq cvv unir1 eleqtrri ax-mp
      rankpwi ) ACDEFZGAHIJAIJKLAMRBNOAQP $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The rank of a set belongs to a limit ordinal iff the rank of its power
       set does.  (Contributed by NM, 18-Sep-2006.) $)
    ranklim $p |- ( Lim B ->
                  ( ( rank ` A ) e. B <-> ( rank ` ~P A ) e. B ) ) $=
      ( vx cvv wcel wlim crnk cfv cpw wb wa csuc limsuc adantl cv eleq1d adantr
      wceq c0 fvprc pweq fveq2d fveq2 suceq syl eqeq12d rankpw vtoclg bitr4d wn
      vex pwexb sylnbi eqtr4d pm2.61ian ) ADEZBFZAGHZBEZAIZGHZBEZJZUPUQKUSURLZB
      EZVBUQUSVEJUPBURMNUPVBVEJUQUPVAVDBCOZIZGHZVFGHZLZRVAVDRCADVFARZVHVAVJVDVK
      VGUTGVFAUAUBVKVIURRVJVDRVFAGUCVIURUDUEUFVFCUKUGUHPQUIUPUJZVCUQVLURVABVLUR
      SVAAGTUPUTDEVASRAULUTGTUMUNPQUO $.

    $( A stronger property of ` R1 ` than ~ rankpw .  The latter merely proves
       that ` R1 ` of the successor is a power set, but here we prove that if
       ` A ` is in the cumulative hierarchy, then ` ~P A ` is in the cumulative
       hierarchy of the successor.  (Contributed by Raph Levien, 29-May-2004.)
       (Revised by Mario Carneiro, 17-Nov-2014.) $)
    r1pw $p |- ( B e. On ->
                 ( A e. ( R1 ` B ) <-> ~P A e. ( R1 ` suc B ) ) ) $=
      ( cr1 con0 cima cuni wcel cfv cpw csuc wb wi wa crnk rankpwi syl rankr1ag
      r1elwf wss cvv eleq1d word eloni ordsucelsuc bicomd sylan9bb cdm suceloni
      pwwf biimpi wfn wceq r1fnon fndm ax-mp syl6eleqr syl2an sylan2br 3bitr4rd
      eleq2i ex r1elssi ssid elex pwexb sylibr elpwg mpbiri sseldd pm5.21ni a1d
      wn pm2.61i ) ACDEFZGZBDGZABCHGZAIZBJZCHZGZKZLVOVPWBVOVPMVRNHZVSGZANHZBGZW
      AVQVOWDWEJZVSGZVPWFVOWCWGVSAOUAVPWFWHVPBUBWFWHKBUCWEBUDPUEUFVOVRVNGZVSCUG
      ZGWAWDKVPVOWIAUIUJVPVSDWJBUHCDUKWJDULUMDCUNUOZUPVRVSQUQVPVOBWJGVQWFKWJDBW
      KUTABQURUSVAVOVLWBVPVQVOWAABRWAVRVNAWAWIVRVNSVRVSRVRVBPWAAVRGZAASZAVCWAAT
      GZWLWMKWAVRTGWNVRVTVDAVEVFAATVGPVHVIVJVKVM $.

    $( A stronger property of ` R1 ` than ~ rankpw .  The latter merely proves
       that ` R1 ` of the successor is a power set, but here we prove that if
       ` A ` is in the cumulative hierarchy, then ` ~P A ` is in the cumulative
       hierarchy of the successor.  (Contributed by Raph Levien, 29-May-2004.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    r1pwOLD $p |- ( B e. On ->
                 ( A e. ( R1 ` B ) <-> ~P A e. ( R1 ` suc B ) ) ) $=
      ( vx cvv wcel con0 cr1 cfv cpw csuc wb wi cv wceq eleq1 pweq crnk rankr1a
      syl elex eleq1d bibi12d imbi2d word eloni ordsucelsuc bitrd rankpw eleq1i
      vex syl6bbr suceloni pwex bitr4d vtoclg pwexb sylibr pm5.21ni a1d pm2.61i
      wn ) ADEZBFEZABGHZEZAIZBJZGHZEZKZLZVCCMZVDEZVLIZVHEZKZLVKCADVLANZVPVJVCVQ
      VMVEVOVIVLAVDOVQVNVFVHVLAPUAUBUCVCVMVNQHZVGEZVOVCVMVLQHZJZVGEZVSVCVMVTBEZ
      WBVLBCUJZRVCBUDWCWBKBUEVTBUFSUGVRWAVGVLWDUHUIUKVCVGFEVOVSKBULVNVGVLWDUMRS
      UNUOVBVAVJVCVEVBVIAVDTVIVFDEVBVFVHTAUPUQURUSUT $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( The cumulative hierarchy of a limit ordinal is closed under power set.
       (Contributed by Raph Levien, 29-May-2004.)  (Proof shortened by Mario
       Carneiro, 17-Nov-2014.) $)
    r1pwcl $p |- ( Lim B -> ( A e. ( R1 ` B ) <-> ~P A e. ( R1 ` B ) ) ) $=
      ( wlim cr1 con0 cima cuni cdm wa cfv wi r1elwf elfvdm jca a1i wb rankr1ag
      wcel crnk adantl cpw pwwf sylibr csuc limsuc adantr wceq rankpwi ad2antrl
      eleq1d bitr4d sylanb 3bitr4d ex pm5.21ndd ) BCZADEFGZRZBDHRZIZABDJZRZAUAZ
      VARZVBUTKUPVBURUSABLABDMNOVDUTKUPVDURUSVDVCUQRZURVCBLAUBZUCVCBDMNOUPUTVBV
      DPUPUTIZASJZBRZVCSJZBRZVBVDVGVIVHUDZBRZVKUPVIVMPUTBVHUEUFVGVJVLBURVJVLUGU
      PUSAUHUIUJUKUTVBVIPUPABQTUTVDVKPZUPURVEUSVNVFVCBQULTUMUNUO $.
  $}

  $( The subset relation is inherited by the rank function.  Exercise 1 of
     [TakeutiZaring] p. 80.  (Contributed by NM, 25-Nov-2003.)  (Revised by
     Mario Carneiro, 17-Nov-2014.) $)
  rankssb $p |- ( B e. U. ( R1 " On ) ->
      ( A C_ B -> ( rank ` A ) C_ ( rank ` B ) ) ) $=
    ( cr1 con0 cima cuni wcel wss crnk cfv wa simpr r1rankidb adantr sstrd sswf
    cdm wb rankdmr1 rankr1bg sylancl mpbid ex ) BCDEFZGZABHZAIJBIJZHZUEUFKZAUGC
    JZHZUHUIABUJUEUFLUEBUJHUFBMNOUIAUDGUGCQGUKUHRBAPBSAUGTUAUBUC $.

  ${
    rankss.1 $e |- B e. _V $.
    $( The subset relation is inherited by the rank function.  Exercise 1 of
       [TakeutiZaring] p. 80.  (Contributed by NM, 25-Nov-2003.)  (Revised by
       Mario Carneiro, 17-Nov-2014.) $)
    rankss $p |- ( A C_ B -> ( rank ` A ) C_ ( rank ` B ) ) $=
      ( cr1 con0 cima cuni wcel wss crnk cfv cvv unir1 eleqtrri rankssb ax-mp
      wi ) BDEFGZHABIAJKBJKIQBLRCMNABOP $.
  $}

  ${
    $d A x y z $.  $d B x y $.
    $( The rank of the union of two sets.  Theorem 15.17(iii) of [Monk1]
       p. 112.  (Contributed by Mario Carneiro, 10-Jun-2013.)  (Revised by
       Mario Carneiro, 17-Nov-2014.) $)
    rankunb $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) ->
        ( rank ` ( A u. B ) ) = ( ( rank ` A ) u. ( rank ` B ) ) ) $=
      ( vx vy con0 wcel cun crnk cfv cv wral wi wceq sylbi rankelb rankon eleq2
      syl6 wss rankssb cr1 cima cuni wa crab cint rankval3b eleq2d vex elintrab
      unwf syl6bb wo elun elun1 elun2 jaao syl5bi ralrimiv onun2i ralbidv rspcv
      imbi12d ax-mp syl5com sylbid ssrdv ssun1 mpi ssun2 unssd eqssd ) AUAEUBUC
      ZFZBVMFZUDZABGZHIZAHIZBHIZGZVPCVRWAVPCJZVRFZWBHIZDJZFZCVQKZWBWEFZLZDEKZWB
      WAFZVPWCWBWGDEUEUFZFWJVPVRWLWBVPVQVMFZVRWLMABUKZDCVQUGNUHWGDWBECUIUJULVPW
      DWAFZCVQKZWJWKVPWOCVQWBVQFWBAFZWBBFZUMVPWOWBABUNVNWQWOVOWRVNWQWDVSFWOWBAO
      WDVSVTUORVOWRWDVTFWOWBBOWDVTVSUPRUQURUSWAEFWJWPWKLZLVSVTAPBPUTWIWSDWAEWEW
      AMZWGWPWHWKWTWFWOCVQWEWAWDQVAWEWAWBQVCVBVDVEVFVGVPWMWAVRSWNWMVSVTVRWMAVQS
      VSVRSABVHAVQTVIWMBVQSVTVRSBAVJBVQTVIVKNVL $.

    $( The rank of an unordered pair.  Part of Exercise 30 of [Enderton]
       p. 207.  (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    rankprb $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) ->
        ( rank ` { A , B } ) = suc ( ( rank ` A ) u. ( rank ` B ) ) ) $=
      ( cr1 con0 cima cuni wcel wa csn cun crnk cfv csuc wceq snwf ranksnb word
      syl2an rankon onordi cpr rankunb uneq12 eqtrd df-pr fveq2i ordsucun mp2an
      3eqtr4g ) ACDEFZGZBUJGZHZAIZBIZJZKLZAKLZMZBKLZMZJZABUAZKLURUTJMZUMUQUNKLZ
      UOKLZJZVBUKUNUJGUOUJGUQVGNULAOBOUNUOUBRUKVEUSNVFVANVGVBNULAPBPVEUSVFVAUCR
      UDVCUPKABUEUFURQUTQVDVBNURASTUTBSTURUTUGUHUI $.

    $( The rank of an ordered pair.  Part of Exercise 4 of [Kunen] p. 107.
       (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    rankopb $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) ->
        ( rank ` <. A , B >. ) = suc suc ( ( rank ` A ) u. ( rank ` B ) ) ) $=
      ( cr1 con0 cima cuni wcel cop crnk cfv csn cpr cun csuc dfopg fveq2d wceq
      wa rankprb syl2anc snwf adantr wss snsspr1 ssequn1 fveq2i rankunb 3eqtr3a
      prwf mpbi suceq syl 3eqtrd ) ACDEFZGZBUNGZRZABHZIJAKZABLZLZIJZUSIJUTIJZMZ
      NZAIJBIJMNZNZUQURVAIABUNUNOPUQUSUNGZUTUNGZVBVEQUOVHUPAUAUBZABUIZUSUTSTUQV
      DVFQVEVGQUQUSUTMZIJZVCVDVFVLUTIUSUTUCVLUTQABUDUSUTUEUJUFUQVHVIVMVDQVJVKUS
      UTUGTABSUHVDVFUKULUM $.

    $( The value of the rank function expressed recursively: the rank of a set
       is the smallest ordinal number containing the ranks of all members of
       the set.  Proposition 9.17 of [TakeutiZaring] p. 79.  (Contributed by
       Mario Carneiro, 8-Jun-2013.) $)
    rankuni2b $p |- ( A e. U. ( R1 " On ) ->
          ( rank ` U. A ) = U_ x e. A ( rank ` x ) ) $=
      ( vy vz cr1 con0 cima cuni wcel crnk cfv cv ciun wral wss cvv wi ralrimiv
      wceq sseld crab cint uniwf rankval3b sylbi iuneq1 eleq1d vex rankon rgenw
      iunon mp2an vtoclg wrex eluni2 nfv nfiu1 nfel2 r1elssi rankelb ssiun2 a1i
      syl6 syldd rexlimd syl5bi eleq2 ralbidv elrab sylanbrc intss1 syl eqsstrd
      biimpi elssuni rankssb syl2im iunss sylibr eqssd ) BEFGHZIZBHZJKZABALZJKZ
      MZWBWDCLZJKZDLZIZCWCNZDFUAZUBZWGWBWCWAIZWDWNSBUCZDCWCUDUEWBWGWMIZWNWGOWBW
      GFIZWIWGIZCWCNZWQAWHWFMZFIZWRCBWAWHBSXAWGFAWHBWFUFUGWHPIWFFIZAWHNXBCUHXCA
      WHWEUIUJAWHWFPUKULUMWBWSCWCWHWCIWHWEIZABUNWBWSAWHBUOWBXDWSABWBAUPAWIWGABW
      FUQURWBWEBIZXDWIWFIZWSWBXEWEWAIXDXFQWBBWAWEBUSTWHWEUTVCXEXFWSQQWBXEWFWGWI
      ABWFVATVBVDVEVFRWLWTDWGFWJWGSWKWSCWCWJWGWIVGVHVIVJWGWMVKVLVMWBWFWDOZABNWG
      WDOWBXGABWBWOXEWEWCOXGWBWOWPVNWEBVOWEWCVPVQRABWFWDVRVSVT $.
  $}

  ${
    $d x A $.
    ranksn.1 $e |- A e. _V $.
    $( The rank of a singleton.  Theorem 15.17(v) of [Monk1] p. 112.
       (Contributed by NM, 28-Nov-2003.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    ranksn $p |- ( rank ` { A } ) = suc ( rank ` A ) $=
      ( cr1 con0 cima cuni wcel csn crnk cfv csuc wceq cvv unir1 eleqtrri ax-mp
      ranksnb ) ACDEFZGAHIJAIJKLAMRBNOAQP $.

    $( The rank of a union.  Part of Theorem 15.17(iv) of [Monk1] p. 112.
       (Contributed by NM, 30-Nov-2003.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    rankuni2 $p |- ( rank ` U. A ) = U_ x e. A ( rank ` x ) $=
      ( cr1 con0 cima cuni wcel crnk cfv ciun wceq cvv unir1 eleqtrri rankuni2b
      cv ax-mp ) BDEFGZHBGIJABAQIJKLBMSCNOABPR $.

    rankun.2 $e |- B e. _V $.
    $( The rank of the union of two sets.  Theorem 15.17(iii) of [Monk1]
       p. 112.  (Contributed by NM, 26-Nov-2003.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    rankun $p |- ( rank ` ( A u. B ) ) = ( ( rank ` A ) u. ( rank ` B ) ) $=
      ( cr1 con0 cima cuni wcel cun crnk cfv wceq unir1 eleqtrri rankunb mp2an
      cvv ) AEFGHZIBSIABJKLAKLBKLJMARSCNOBRSDNOABPQ $.

    $( The rank of an unordered pair.  Part of Exercise 30 of [Enderton]
       p. 207.  (Contributed by NM, 28-Nov-2003.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    rankpr $p |- ( rank ` { A , B } ) = suc ( ( rank ` A ) u. ( rank ` B ) ) $=
      ( cr1 con0 cima cuni wcel cpr crnk cfv cun csuc wceq cvv eleqtrri rankprb
      unir1 mp2an ) AEFGHZIBUAIABJKLAKLBKLMNOAPUACSQBPUADSQABRT $.

    $( The rank of an ordered pair.  Part of Exercise 4 of [Kunen] p. 107.
       (Contributed by NM, 13-Sep-2006.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    rankop $p |- ( rank ` <. A , B >. ) =
                 suc suc ( ( rank ` A ) u. ( rank ` B ) ) $=
      ( cr1 con0 cima cuni wcel cop crnk cfv cun csuc wceq cvv eleqtrri rankopb
      unir1 mp2an ) AEFGHZIBUAIABJKLAKLBKLMNNOAPUACSQBPUADSQABRT $.
  $}

  $( Any set is a subset of the hierarchy of its rank.  (Contributed by NM,
     14-Oct-2003.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  r1rankid $p |- ( A e. V -> A C_ ( R1 ` ( rank ` A ) ) ) $=
    ( wcel cr1 con0 cima cuni crnk cfv wss cvv elex unir1 syl6eleqr r1rankidb
    syl ) ABCZADEFGZCAAHIDIJQAKRABLMNAOP $.

  $( A set is empty iff its rank is empty.  (Contributed by Mario Carneiro,
     17-Nov-2014.) $)
  rankeq0b $p |- ( A e. U. ( R1 " On ) ->
                   ( A = (/) <-> ( rank ` A ) = (/) ) ) $=
    ( cr1 con0 cima cuni wcel c0 wceq crnk cfv fveq2 cdm com wlim wfun r1funlim
    wss simpri limomss ax-mp peano1 sselii rankonid mpbi syl6eq wa eqimss simpl
    adantl wb rankr1bg sylancl mpbird r10 syl6sseq ss0 syl ex impbid2 ) ABCDEFZ
    AGHZAIJZGHZVAVBGIJZGAGIKGBLZFZVDGHMVEGVENZMVEQBOVGPRVESTUAUBZGUCUDUEUTVCVAU
    TVCUFZAGQVAVIAGBJZGVIAVJQZVBGQZVCVLUTVBGUGUIVIUTVFVKVLUJUTVCUHVHAGUKULUMUNU
    OAUPUQURUS $.

  ${
    $d x A $.
    rankeq0.1 $e |- A e. _V $.
    $( A set is empty iff its rank is empty.  (Contributed by NM,
       18-Sep-2006.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankeq0 $p |- ( A = (/) <-> ( rank ` A ) = (/) ) $=
      ( cr1 con0 cima cuni wcel c0 wceq crnk cfv wb cvv unir1 eleqtrri rankeq0b
      ax-mp ) ACDEFZGAHIAJKHILAMRBNOAPQ $.
  $}

  ${
    $d x y z A $.
    $( The rank of the hierarchy of an ordinal number is itself.  (Contributed
       by NM, 14-Oct-2003.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankr1id $p |- ( A e. dom R1 <-> ( rank ` ( R1 ` A ) ) = A ) $=
      ( cr1 cdm wcel cfv crnk wceq wss ssid con0 cima cuni csuc cpw fvex r1sucg
      wb pwid syl5eleqr r1elwf syl rankr1bg mpancom mpbii biimpi onssr1 rankssb
      rankonid sylc eqsstr3d eqssd id rankdmr1 syl6eqelr impbii ) ABCZDZABEZFEZ
      AGZUQUSAUQURURHZUSAHZURIURBJKLDZUQVAVBQUQURAMZBEZDVCUQURURNVEURABORAPSURV
      DTUAZURAUBUCUDUQAAFEZUSUQVGAGAUHUEUQVCAURHVGUSHVFAUFAURUGUIUJUKUTAUSUPUTU
      LURUMUNUO $.

    $( The rank of a union.  Part of Exercise 4 of [Kunen] p. 107.
       (Contributed by NM, 15-Sep-2006.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    rankuni $p |- ( rank ` U. A ) = U. ( rank ` A ) $=
      ( vx vy vz cvv wcel cuni crnk cfv wceq cv fveq2 unieqd fvex wa wex rankon
      cr1 con0 c0 unieq fveq2d eqeq12d wrex cab ciun vex rankuni2 dfiun2 df-rex
      eqtri rankel anim1i eximi 19.42v eleq1 pm5.32ri exbii simpl cdm oneli wfn
      r1fnon fndm ax-mp syl6eleqr rankr1id sylib eqcomd eqeq2d spcev syl impbii
      ancli 3bitr3i sylbi abssi unissi eqsstri csuc cpw pwuni uniex pwex rankss
      rankpw sseqtri onunisuci eqssi vtoclg wn uniexb fvprc sylnbi uni0 syl6eqr
      wss eqtr4d pm2.61i ) AEFZAGZHIZAHIZGZJZBKZGZHIZXFHIZGZJXEBAEXFAJZXHXBXJXD
      XKXGXAHXFAUAUBXKXIXCXFAHLMUCXHXJXHCKZDKZHIZJZDXFUDZCUEZGZXJXHDXFXNUFXRDXF
      BUGZUHDCXFXNXMHNUIUKXQXIXPCXIXPXMXFFZXOOZDPZXLXIFZXODXFUJYBXNXIFZXOOZDPZY
      CYAYEDXTYDXOXMXFXSULUMUNYCXOOZDPYCXODPZOZYFYCYCXODUOYGYEDXOYCYDXLXNXIUPUQ
      URYIYCYCYHUSYCYHYCXLXLRIZHIZJZYHYCYKXLYCXLRUTZFYKXLJYCXLSYMXIXLXFQVARSVBY
      MSJVCSRVDVEVFXLVGVHVIXOYLDYJXLRNXMYJJXNYKXLXMYJHLVJVKVLVNVMVOVHVPVQVRVSXJ
      XHVTZGXHXIYNXIXGWAZHIZYNXFYOWQXIYPWQXFWBXFYOXGXFXSWCZWDWEVEXGYQWFWGVRXHXG
      QWHWGWIWJWTWKZXBTGZXDYRXBTYSWTXAEFXBTJAWLXAHWMWNWOWPYRXCTAHWMMWRWS $.
  $}

  ${
    $d x y z A $.  $d x B $.
    rankr1b.1 $e |- A e. _V $.
    $( A relationship between rank and ` R1 ` .  See ~ rankr1a for the
       membership version.  (Contributed by NM, 15-Sep-2006.)  (Revised by
       Mario Carneiro, 17-Nov-2014.) $)
    rankr1b $p |- ( B e. On ->
      ( A C_ ( R1 ` B ) <-> ( rank ` A ) C_ B ) ) $=
      ( con0 wcel cr1 cdm cfv wss crnk wb wfn wceq r1fnon fndm eleq2i cima cuni
      ax-mp cvv unir1 eleqtrri rankr1bg mpan sylbir ) BDEBFGZEZABFHIAJHBIKZUFDB
      FDLUFDMNDFOSPAFDQRZEUGUHATUICUAUBABUCUDUE $.

    $( The rank of a successor.  (Contributed by NM, 18-Sep-2006.) $)
    ranksuc $p |- ( rank ` suc A ) = suc ( rank ` A ) $=
      ( csuc crnk cfv csn cun df-suc fveq2i snex rankun ranksn wss wceq sssucid
      uneq2i ssequn1 mpbi eqtri ) ACZDEAAFZGZDEZADEZCZTUBDAHIUCUDUADEZGZUEAUABA
      JKUGUDUEGZUEUFUEUDABLPUDUEMUHUENUDOUDUEQRSSS $.

    $( Upper bound of the rank of a union.  Part of Exercise 30 of [Enderton]
       p. 207.  (Contributed by NM, 30-Nov-2003.) $)
    rankuniss $p |- ( rank ` U. A ) C_ ( rank ` A ) $=
      ( cuni crnk cfv rankuni word wss rankon onordi orduniss ax-mp eqsstri ) A
      CDEADEZCZNAFNGONHNAIJNKLM $.

    $( The rank of a set is the supremum of the successors of the ranks of its
       members.  Exercise 9.1 of [Jech] p. 72.  Also a special case of Theorem
       7V(b) of [Enderton] p. 204.  (Contributed by NM, 12-Oct-2003.) $)
    rankval4 $p |- ( rank ` A ) = U_ x e. A suc ( rank ` x ) $=
      ( vy crnk cfv cv cr1 wss wcel wi nfcv con0 rankon mp2an r1ord3 ax-mp crab
      cvv cint csuc ciun nfiu1 nffv dfss2f vex rankid ssiun2 onsuci rgenw iunon
      wral syl sseld mpgbir fvex rankss mpan ss2rabi intss wceq rankval2 intmin
      mpi eqcomi 3sstr4i sstri iunss rankel onsucssi sylib mprgbir eqssi ) BEFZ
      ABAGZEFZUAZUBZVNVRHFZEFZVRBVSIZVNVTIWAVOBJZVOVSJZKAABVSABLAVRHAHLABVQUCUD
      UEWBVOVQHFZJWCVOAUFUGWBWDVSVOWBVQVRIZWDVSIZABVQUHVQMJZVRMJZWEWFKVPVONZUIZ
      BSJWGABULWHCWGABWJUJABVQSUKOZVQVRPOUMUNVDUOBVSVRHUPZUQQVSDGZHFIZDMRZTZVRW
      MIZDMRZTZVTVRWRWOIWPWSIWQWNDMWHWMMJWQWNKWKVRWMPURUSWRWOUTQVSSJVTWPVAWLDVS
      SVBQWSVRWHWSVRVAWKDVRMVCQVEVFVGVRVNIVQVNIZABABVQVNVHWBVPVNJWTVOBCVIVPVNWI
      BNVJVKVLVM $.

    $( The rank of a set is bounded by a bound for the successor of its
       members.  (Contributed by NM, 18-Sep-2006.) $)
    rankbnd $p |- ( A. x e. A suc ( rank ` x ) C_ B <-> ( rank ` A ) C_ B ) $=
      ( crnk cfv wss cv csuc ciun wral rankval4 sseq1i iunss bitr2i ) BEFZCGABA
      HEFIZJZCGQCGABKPRCABDLMABQCNO $.

    $( The rank of a set is bounded by the successor of a bound for its
       members.  (Contributed by NM, 15-Sep-2006.) $)
    rankbnd2 $p |- ( B e. On -> ( A. x e. A ( rank ` x ) C_ B <->
                  ( rank ` A ) C_ suc B ) ) $=
      ( cv crnk cfv wss wral cuni con0 wcel csuc rankuni rankuni2 eqtr3i sseq1i
      ciun iunss bitr2i word wb rankon onssi eloni ordunisssuc sylancr syl5bb )
      AEFGZCHABIZBFGZJZCHZCKLZUKCMHZUMABUIRZCHUJULUPCBJFGULUPBNABDOPQABUICSTUNU
      KKHCUAUMUOUBUKBUCUDCUEUKCUFUGUH $.

    $( A relationship that can be used for computation of rank.  (Contributed
       by NM, 16-Sep-2006.) $)
    rankc1 $p |- ( A. x e. A ( rank ` x ) e. ( rank ` U. A ) <->
                 ( rank ` A ) = ( rank ` U. A ) ) $=
      ( crnk cfv cuni wa cv wcel wral wceq rankuniss biantru csuc ciun rankval4
      wss iunss sseq1i rankon onsucssi ralbii 3bitr4ri eqss 3bitr4i ) BDEZBFZDE
      ZQZUIUHUFQZGAHZDEZUHIZABJZUFUHKUJUIBCLMABULNZOZUHQUOUHQZABJUIUNABUOUHRUFU
      PUHABCPSUMUQABULUHUKTUGTUAUBUCUFUHUDUE $.

    $( A relationship that can be used for computation of rank.  (Contributed
       by NM, 16-Sep-2006.) $)
    rankc2 $p |- ( E. x e. A ( rank ` x ) = ( rank ` U. A ) ->
                 ( rank ` A ) = suc ( rank ` U. A ) ) $=
      ( cv crnk cfv cuni wceq wrex csuc wss cpw pwuni uniex rankss ax-mp rankpw
      pwex wcel rankon a1i rankel eleq1 syl5ibcom rexlimiv onsucssi sylib eqssd
      sseqtri ) ADZEFZBGZEFZHZABIZBEFZUMJZUPUQKUOUPULLZEFZUQBURKUPUSKBMBURULBCN
      ZROPULUTQUIUAUOUMUPSZUQUPKUNVAABUJBSUKUPSUNVAUJBCUBUKUMUPUCUDUEUMUPULTBTU
      FUGUH $.
  $}

  ${
    rankelun.1 $e |- A e. _V $.
    rankelun.2 $e |- B e. _V $.
    rankelun.3 $e |- C e. _V $.
    rankelun.4 $e |- D e. _V $.
    $( Rank membership is inherited by union.  (Contributed by NM,
       18-Sep-2006.)  (Proof shortened by Mario Carneiro, 17-Nov-2014.) $)
    rankelun $p |- ( ( ( rank ` A ) e. ( rank ` C ) /\ ( rank ` B ) e.
          ( rank ` D ) ) -> ( rank ` ( A u. B ) ) e. ( rank ` ( C u. D ) ) ) $=
      ( crnk cfv wcel wa cun word rankon onun2i onordi a1i elun1 rankun ordunel
      adantr elun2 adantl syl3anc 3eltr4g ) AIJZCIJZKZBIJZDIJZKZLZUGUJMZUHUKMZA
      BMIJCDMIJUMUONZUGUOKZUJUOKZUNUOKUPUMUOUHUKCODOPQRUIUQULUGUHUKSUBULURUIUJU
      KUHUCUDUOUGUJUAUEABEFTCDGHTUF $.

    $( Rank membership is inherited by unordered pairs.  (Contributed by NM,
       18-Sep-2006.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    rankelpr $p |- ( ( ( rank ` A ) e. ( rank ` C ) /\ ( rank ` B ) e.
            ( rank ` D ) ) -> ( rank ` { A , B } ) e. ( rank ` { C , D } ) ) $=
      ( crnk cfv wcel wa cun csuc cpr rankelun rankun 3eltr3g rankon rankpr wb
      word onun2i onordi ordsucelsuc ax-mp sylib 3eltr4g ) AIJZCIJZKBIJZDIJZKLZ
      UIUKMZNZUJULMZNZABOIJCDOIJUMUNUPKZUOUQKZUMABMIJCDMIJUNUPABCDEFGHPABEFQCDG
      HQRUPUBURUSUAUPUJULCSDSUCUDUNUPUEUFUGABEFTCDGHTUH $.

    $( Rank membership is inherited by ordered pairs.  (Contributed by NM,
       18-Sep-2006.) $)
    rankelop $p |- ( ( ( rank ` A ) e. ( rank ` C ) /\ ( rank ` B ) e.
        ( rank ` D ) ) -> ( rank ` <. A , B >. ) e. ( rank ` <. C , D >. ) ) $=
      ( crnk cfv wcel cpr csuc cop ax-mp cun rankop wceq rankpr suceq wa rankon
      rankelpr word wb onordi ordsucelsuc sylib eqtr4i 3eltr4g ) AIJZCIJZKBIJZD
      IJZKUAZABLIJZMZCDLZIJZMZABNIJZCDNIJZUOUPUSKZUQUTKZABCDEFGHUCUSUDVCVDUEUSU
      RUBUFUPUSUGOUHVAUKUMPMZMZUQABEFQUPVERUQVFRABEFSUPVETOUIVBULUNPMZMZUTCDGHQ
      USVGRUTVHRCDGHSUSVGTOUIUJ $.
  $}

  ${
    rankxpl.1 $e |- A e. _V $.
    rankxpl.2 $e |- B e. _V $.
    $( A lower bound on the rank of a cross product.  (Contributed by NM,
       18-Sep-2006.) $)
    rankxpl $p |- ( ( A X. B ) =/= (/) -> ( rank ` ( A u. B ) ) C_
                  ( rank ` ( A X. B ) ) ) $=
      ( cxp c0 wne cun crnk cfv cuni unixp xpex uniex rankuniss sstri syl6eqssr
      fveq2d ) ABEZFGZABHZIJSKZKZIJZSIJZTUCUAIABLRUDUBIJUEUBSABCDMZNOSUFOPQ $.

    $( An upper bound on the rank of a cross product.  (Contributed by NM,
       18-Sep-2006.) $)
    rankxpu $p |- ( rank ` ( A X. B ) ) C_
                 suc suc ( rank ` ( A u. B ) ) $=
      ( cxp crnk cfv cun cpw csuc wss xpsspw unex pwex rankss ax-mp rankpw wceq
      suceq eqtri sseqtri ) ABEZFGZABHZIZIZFGZUDFGJZJZUBUFKUCUGKABLUBUFUEUDABCD
      MZNZNOPUGUEFGZJZUIUEUKQULUHRUMUIRUDUJQULUHSPTUA $.

    $( An upper bound on the rank of a function.  (Contributed by G&eacute;rard
       Lang, 5-Aug-2018.) $)
    rankfu $p |- ( F : A --> B
        -> ( rank ` F ) C_ suc suc ( rank ` ( A u. B ) ) ) $=
      ( wf cxp wss crnk cfv cun csuc fssxp xpex rankss rankxpu syl6ss syl ) ABC
      FCABGZHZCIJZABKIJLLZHABCMTUASIJUBCSABDENOABDEPQR $.

    $( An upper bound on the rank of set exponentiation.  (Contributed by
       G&eacute;rard Lang, 5-Aug-2018.) $)
    rankmapu $p |- ( rank ` ( A ^m B ) )
                  C_ suc suc suc ( rank ` ( A u. B ) ) $=
      ( cmap co crnk cfv cxp cpw cun csuc ax-mp wceq suceq rankon onordi onsuci
      wss word mapsspw xpex pwex rankss rankpw rankxpu uncom fveq2i ordsucsssuc
      sseqtri wb mp2an mpbi eqsstri sstri ) ABEFZGHZBAIZJZGHZABKZGHZLZLZLZUPUSS
      UQUTSABUAUPUSURBADCUBZUCUDMUTURGHZLZVEURVFUEVGVDSZVHVESZVGBAKZGHZLZLZVDBA
      DCUFVMVCNZVNVDNVLVBNVOVKVAGBAUGUHVLVBOMVMVCOMUJVGTVDTVIVJUKVGURPQVDVCVBVA
      PRRQVGVDUIULUMUNUO $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    rankxplim.1 $e |- A e. _V $.
    rankxplim.2 $e |- B e. _V $.
    $( The rank of a cross product when the rank of the union of its arguments
       is a limit ordinal.  Part of Exercise 4 of [Kunen] p. 107.  See
       ~ rankxpsuc for the successor case.  (Contributed by NM,
       19-Sep-2006.) $)
    rankxplim $p |- ( ( Lim ( rank ` ( A u. B ) ) /\ ( A X. B ) =/= (/) ) ->
                    ( rank ` ( A X. B ) ) = ( rank ` ( A u. B ) ) ) $=
      ( vx vy vz cun crnk cfv wa wss cv csuc wral wcel cpw cuni pwuni wceq wlim
      cxp c0 wne cop cpr uniop pweqi sseqtri unipr sspwb mpbi sstri unex rankss
      vex pwex ax-mp rankel rankelun syl2an adantl wb ranklim bitrd adantr con0
      mpbid wi rankon ontr2 mp2an sylancr onsucssi sylib ralrimivva fveq2 suceq
      syl sseq1d ralxp xpex rankbnd bitr3i rankxpl eqssd ) ABHZIJZUAZABUBZUCUDZ
      KWJIJZWHWIWLWHLZWKWIEMZFMZUEZIJZNZWHLZFBOEAOZWMWIWSEFABWIWNAPZWOBPZKZKZWQ
      WHPZWSXDWQWNWOHZQZQZIJZLZXIWHPZXEWPXHLXJWPWNWOUFZQZXHWPWPRZQXMWPSXNXLWNWO
      EUPZFUPZUGUHUIXLXGLXMXHLXLXLRZQXGXLSXQXFWNWOXOXPUJUHUIXLXGUKULUMWPXHXGXFW
      NWOXOXPUNUQUQUOURXDXFIJWHPZXKXCXRWIXAWNIJAIJPWOIJBIJPXRXBWNACUSWOBDUSWNWO
      ABXOXPCDUTVAVBWIXRXKVCXCWIXRXGIJWHPXKXFWHVDXGWHVDVEVFVHWQVGPWHVGPXJXKKXEV
      IWPVJZWGVJZWQXIWHVKVLVMWQWHXSXTVNVOVPWTGMZIJZNZWHLZGWJOWMYDWSGEFABYAWPTZY
      CWRWHYEYBWQTYCWRTYAWPIVQYBWQVRVSVTWAGWJWHABCDWBWCWDVOVFWKWHWLLWIABCDWEVBW
      F $.


    $( If the rank of a cross product is a limit ordinal, so is the rank of the
       union of its arguments.  (Contributed by NM, 19-Sep-2006.) $)
    rankxplim2 $p |- ( Lim ( rank ` ( A X. B ) ) ->
                     Lim ( rank ` ( A u. B ) ) ) $=
      ( cxp wne crnk cfv wlim cun wceq wcel 0ellim n0i syl cuni limuni2 rankuni
      c0 wn df-ne rankeq0 notbii bitr2i sylib unieqi eqtr2i unixp fveq2d syl5eq
      xpex wb limeq syl5ib mpcom ) ABEZSFZUPGHZIZABJZGHZIZUSURSKZTZUQUSSURLVDUR
      MURSNOUQUPSKZTVDUPSUAVEVCUPABCDUKUBUCUDUEUSURPZPZIZUQVBUSVFIVHURQVFQOUQVG
      VAKVHVBULUQVGUPPZPZGHZVAVKVIGHZPVGVIRVLVFUPRUFUGUQVJUTGABUHUIUJVGVAUMOUNU
      O $.

    $( The rank of a cross product is a limit ordinal iff its union is.
       (Contributed by NM, 19-Sep-2006.) $)
    rankxplim3 $p |- ( Lim ( rank ` ( A X. B ) ) <->
                     Lim U. ( rank ` ( A X. B ) ) ) $=
      ( vx vy crnk cfv cuni c0 wceq wn csuc con0 wrex wa wcel wss wb adantr cxp
      wlim limuni2 cun cv 0ellim n0i unieq uni0 syl6eq con3i 3syl rankon onsuci
      elexi sucid ontri1 mp2an con2bii mpbi rankxpu sstr mpan2 reeanv wi simprl
      mto simpr rankuni unieqi eqtri wne df-ne xpex rankeq0 notbii bitr2i sylib
      unixp syl fveq2d syl5reqr eqimss eqsstr3d adantrr limuni sseqtr4d cvv vex
      word onordi orduni ax-mp ordelsuc sylibr limsuc mpbid eqeltrd ordsucelsuc
      onsucuni2 mpan ad2antll eleqtrd onsucssi ex a1d rexlimdvv syl5bir mtoi wo
      ianor un00 olc adantl sylbir xpeq0 unex w3o ordzsl 3ori sylan orim12d imp
      syl5bi simpl necon3abii rankxplim sylan2br mpbird expcom idd jaod syl2anc
      limeq mpd impbii ) ABUAZGHZUBZYRIZUBZYRUCUUAYRJKZLZABUDZGHZEUEZMZKZENOZYR
      FUEZMKZFNOZPZLZYSUUAJYTQYTJKZLUUCYTUFYTJUGUUBUUOUUBYTJIJYRJUHUIUJUKULZUUA
      UUMUUEMZMZMZYRRZUUTUUSUURRZUURUUSQZUVALUURUURNUUQUUEUUDUMZUNUNZUOUPUVAUVB
      UUSNQUURNQUVAUVBLSUURUVDUNUVDUUSUURUQURUSUTUUTYRUURRUVAABCDVAUUSYRUURVBVC
      VGUUMUUHUUKPZFNOENOUUAUUTUUHUUKEFNNVDUUAUVEUUTEFNNUUAUVEUUTVEUUFNQUUJNQPU
      UAUVEUUTUUAUVEPZUURYRQUUTUVFUURYTMZYRUVFUUQYTQZUURUVGQZUVFUUEYTQZUVHUVFUU
      EUUGYTUUAUUHUUKVFUVFUUFYTQZUUGYTQZUVFUUGYTRZUVKUVFUUGYTIZYTUUAUUHUUGUVNRU
      UKUUAUUHPUUGUUEUVNUUAUUHVHUUAUUEUVNRZUUHUUAUUEUVNKUVOUUAUVNYQIZIZGHZUUEUV
      RUVPGHZIUVNUVPVIUVSYTYQVIVJVKUUAUVQUUDGUUAYQJVLZUVQUUDKUUAUUCUVTUUPUVTYQJ
      KZLZUUCYQJVMUWAUUBYQABCDVNVOZVPZVQVRABVSVTWAWBUUEUVNWCVTTWDWEUUAYTUVNKUVE
      YTWFTWGUUFWHQYTWJZUVKUVMSEWIYRWJZUWEYRYQUMZWKZYRWLWMZUUFYTWHWNURWOUUAUVKU
      VLSUVEYTUUFWPTWQWRUUAUVJUVHSUVEYTUUEWPTWQUWEUVHUVISUWIUUQYTWSWMVRUUKUVGYR
      KZUUAUUHYRNQUUKUWJUWGYRUUJWTXAXBXCUURYRUVDUWGXDVRXEXFXGXHXIUUCUUNPUUEUBZY
      SXJZYSUUCUUNUWLUUNUUILZUULLZXJUUCUWLUUIUULXKUUCUWMUWKUWNYSUUCUWMUWKUUCUUE
      JKZLZUWMUWKUUCUUDJKZLZUWPUUCUWBUWRUWDUWQUWAUWQAJKZBJKZXJZUWAUWQUWSUWTPUXA
      ABXLUWTUXAUWSUWTUWSXMXNXOABXPWOUKXOUWQUWOUUDABCDXQVOVPVRUWOUUIUWKUUEWJUWO
      UUIUWKXRUUEUVCWKEUUEXSUTXTYAXEUUCUWNYSUUBUULYSUWFUUBUULYSXRUWHFYRXSUTXTXE
      YBYDYCUUCUWLYSVEUUNUUCUWKYSYSUWKUUCYSUWKUUCPZYSUWKUWKUUCYEUXBYRUUEKZYSUWK
      SUUCUWKUVTUXCUUBYQJUWCYFABCDYGYHYRUUEYNVTYIYJUUCYSYKYLTYOYMYP $.

    $( The rank of a cross product when the rank of the union of its arguments
       is a successor ordinal.  Part of Exercise 4 of [Kunen] p. 107.  See
       ~ rankxplim for the limit ordinal case.  (Contributed by NM,
       19-Sep-2006.) $)
    rankxpsuc $p |- ( ( ( rank ` ( A u. B ) ) = suc C /\ ( A X. B ) =/= (/) )
                  -> ( rank ` ( A X. B ) ) = suc suc ( rank ` ( A u. B ) ) ) $=
      ( vx crnk cfv csuc wceq c0 cuni sylibr con0 wlim wn cvv wcel wo mpbi wrex
      cun cxp wne wa rankuni unieqi eqtri unixp fveq2d syl5reqr suc11reg adantl
      cv fvex eleq1 mpbii sucexb nlimsucg syl limeq mtbird rankxplim2 nsyl xpex
      rankeq0 necon3abii w3o word rankon onordi ordzsl 3orass ori sylbi syl5com
      ord con1d vex ax-mp mtbiri rankxplim3 sylnib syl6com unixp0 eqeq1i 3bitri
      rexlimivw uniex onuni syld impcom onsucuni2 mpan eqtrd imp eqtr2d ) ABUBZ
      GHZCIZJZABUCZKUDZUEZWSIZIZXBGHZLZIZXGXDXEXHJXFXIJXDXEXHLZIZXHXCXEXKJZXAXC
      WSXJJXLXCXJXBLZLZGHZWSXOXMGHZLXJXMUFXPXHXBUFZUGUHXCXNWRGABUIUJUKWSXJULMUM
      XDXHFUNZIZJZFNUAZXKXHJZXCXAYAXCXAXHOZPZYAXAXCXGXSJZFNUAZYDXAXGOZPZXCYFXAW
      SOZYGXAYIWTOZXACQRZYJPXAWTQRZYKXAWSQRYLWRGUOWSWTQUPUQCURMCQUSUTWSWTVAVBAB
      DEVCVDXCYFYGXCYFYGXCXGKJZPYFYGSZYMXBKXBABDEVEZVFVGYMYNYMYFYGVHZYMYNSXGVIY
      PXGXBVJZVKFXGVLTYMYFYGVMTVNVOVQVRVPZYFYGYCYEYHFNYEYGXSOZXRQRYSPFVSXRQUSVT
      XGXSVAWAWHABDEWBWCWDXCYAYCXCYAYCXCXHKJZPYAYCSZYTXBKXBKJXMKJXPKJYTABWEXMXB
      YOWIVFXPXHKXQWFWGVGYTUUAYTYAYCVHZYTUUASXHVIUUBXHXGNRZXHNRZYQXGWJVTZVKFXHV
      LTYTYAYCVMTVNVOVQVRWKWLXTYBFNUUDXTYBUUEXHXRWMWNWHUTWOXEXHULMXDYFXIXGJZXAX
      CYFYRWPYEUUFFNUUCYEUUFYQXGXRWMWNWHUTWQ $.
  $}

  ${
    $( The transitive closure function is well-founded if its argument is.
       (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tcwf $p |- ( A e. U. ( R1 " On ) -> ( TC ` A ) e. U. ( R1 " On ) ) $=
      ( vx cr1 con0 cima cuni wcel ctc cfv wss r1elssi wtr dftr3 mprgbir mpan2i
      cv tcmin mpd fvex r1elss sylibr ) ACDEFZGZAHIZUBJZUDUBGUCAUBJZUEAKUCUFUBL
      ZUEUGBPZUBJBUBBUBMUHKNAUBUBQORUDAHSTUA $.
  $}

  ${
    $d A x y z $.  $d x y z w u $.
    $( This theorem expresses two different facts from the two subset
       implications in this equality.  In the forward direction, it says that
       the transitive closure has members of every rank below ` A ` .  Stated
       another way, to construct a set at a given rank, you have to climb the
       entire hierarchy of ordinals below ` ( rank `` A ) ` , constructing at
       least one set at each level in order to move up the ranks.  In the
       reverse direction, it says that every member of ` ( TC `` A ) ` has a
       rank below the rank of ` A ` , since intuitively it contains only the
       members of ` A ` and the members of those and so on, but nothing
       "bigger" than ` A ` .  (Contributed by Mario Carneiro, 23-Jun-2013.) $)
    tcrank $p |- ( A e. U. ( R1 " On ) ->
        ( rank ` A ) = ( rank " ( TC ` A ) ) ) $=
      ( vy vz vx vu cr1 con0 cima wcel crnk cfv ctc wrex wss wral wi fveq2 wceq
      wa syl vw cuni cv rankwflemb suceloni weq raleqdv imaeq2d sseq12d cbvralv
      csuc syl6bb wn simpr simprl simplr rankr1ai rspcv r1elwf r1rankidb ssralv
      3syl syld sylc crab rankval3b eleq2d biimpd rankon oneli ralbidv onnminsb
      cint eleq2 sylcom imp rexnal sylibr adantl syl2anc w3a simp2 cvv vex tcid
      r19.29 ax-mp sseli eqeq1d rspcev ex simp3l sseld simp1l wfn wb wf ffn wtr
      rankf r1tr trel tcwf fvex r1elss sylib fvelimab tcel ssrexv adantr sylbid
      sylancr wo w3o word eloni ordtri3or syl2an 3orass orcanai ad2ant2l mpjaod
      3adant2 rexlimdv3a r1elssi sylan2 sylibrd ssrdv ralrimiva rspccv rexlimiv
      expr tfis3 sylbi cab tcvalg sseq2 treq anbi12d elab intss1 sylbir sylancl
      eqsstrd imass2 wfun ffun fvelima mpan eleq1 syl5ibcom ssriv syl6ss eqssd
      ) AFGHUBZIZAJKZJALKZHZUUPABUCZUKZFKZIZBGMUUQUUSNZBAUDUVCUVDBGUUTGIUVAGICU
      CZJKZJUVELKZHZNZCUVBOZUVCUVDPUUTUEUVICDUCZFKZOZEUCZJKZJUVNLKZHZNZEUUTFKZO
      ZUVJDBUVADBUFZUVMUVICUVSOUVTUWAUVICUVLUVSUVKUUTFQUGUVIUVRCEUVSCEUFZUVFUVO
      UVHUVQUVEUVNJQUWBUVGUVPJUVEUVNLQUHUIUJULUVKUVARUVICUVLUVBUVKUVAFQUGUVKGIZ
      UVTBUVKOZUVMUWCUWDSZUVICUVLUWEUVEUVLIZSZUAUVFUVHUWGUAUCZUVFIZUVKJKZUWHRZD
      UVGMZUWHUVHIZUWEUWFUWIUWLUWEUWFUWISZSZUWNUVRUVOUWHIZUMZSZEUVEMZUWLUWEUWNU
      NUWOUVREUVEOZUWQEUVEMZUWSUWOUWFUWDUWTUWEUWFUWIUOUWCUWDUWNUPUWFUWDUVREUVFF
      KZOZUWTUWFUVFUVKIUWDUXCPUVEUVKUQUVTUXCBUVFUVKUUTUVFRUVREUVSUXBUUTUVFFQUGU
      RTUWFUVEUUOIZUVEUXBNUXCUWTPUVEUVKUSZUVEUTUVREUVEUXBVAVBVCVDUWNUXAUWEUWNUW
      PEUVEOZUMZUXAUWFUWIUXGUWFUXDUWIUXGPUXEUXDUWIUWHUVOUVKIZEUVEOZDGVEVMZIZUXG
      UXDUWIUXKUXDUVFUXJUWHDEUVEVFVGVHUWIUWHGIZUXKUXGPUVFUWHUVEVIVJZUXIUXFDUWHD
      UAUFUXHUWPEUVEUVKUWHUVOVNVKVLTVOTVPUWPEUVEVQVRVSUVRUWQEUVEWFVTUWNUWRUWLEU
      VEUWNUVNUVEIZUWRWAZUVOUWHRZUWLUWHUVOIZUXOUXNUVNUVGIZUXPUWLPUWNUXNUWRWBZUV
      EUVGUVNUVEWCIUVEUVGNCWDZUVEWCWEWGWHUXRUXPUWLUWKUXPDUVNUVGDEUFUWJUVOUWHUVK
      UVNJQWIWJWKVBUXOUXQUWHUVQIZUWLUXOUVOUVQUWHUWNUXNUVRUWQWLWMUXOUXNUWFUYAUWL
      PUXSUWFUWIUXNUWRWNUXNUWFSZUYAUWKDUVPMZUWLUYBJUUOWOZUVPUUONZUYAUYCWPUUOGJW
      QZUYDWTUUOGJWRWGZUYBUVNUVLIZUVNUUOIZUYEUVLWSUYBUYHPUVKXAUVLUVNUVEXBWGUVNU
      VKUSUYIUVPUUOIUYEUVNXCUVPUVNLXDXEXFVBDUUOUVPUWHJXGXLUXNUYCUWLPZUWFUXNUVPU
      VGNUYJUVEUVNUXTXHUWKDUVPUVGXITXJXKVTVCUWNUWRUXPUXQXMZUXNUWIUWQUYKUWFUVRUW
      IUWPUYKUWIUWPUXPUXQXNZUWPUYKXMUWIUVOGIZUXLUYLUVNVIUXMUYMUVOXOUWHXOUYLUXLU
      VOXPUWHXPUVOUWHXQXRXLUWPUXPUXQXSXFXTYAYCYBYDVDYLUWFUWMUWLWPZUWEUWFUXDUYNU
      XEUXDUYDUVGUUOIZUYNUYGUVEXCUYOUYDUVGUUONUYNUVGYEDUUOUVGUWHJXGYFXLTVSYGYHY
      IWKYMUVIUVDCAUVBUVEARZUVFUUQUVHUUSUVEAJQUYPUVGUURJUVEALQUHUIYJVBYKYNUUPUU
      RUUQFKZNZUUSUUQNUUPUURAUVKNZUVKWSZSZDYOZVMZUYQDAUUOYPUUPAUYQNZUYQWSZVUCUY
      QNZAUTUUQXAVUDVUESZUYQVUBIVUFVUAVUGDUYQUUQFXDUVKUYQRUYSVUDUYTVUEUVKUYQAYQ
      UVKUYQYRYSYTUYQVUBUUAUUBUUCUUDUYRUUSJUYQHZUUQUURUYQJUUEDVUHUUQUVKVUHIZUUT
      JKZUVKRZBUYQMZUVKUUQIZJUUFZVUIVULUYFVUNWTUUOGJUUGWGBUVKUYQJUUHUUIVUKVUMBU
      YQUUTUYQIVUJUUQIVUKVUMUUTUUQUQVUJUVKUUQUUJUUKYKTUULUUMTUUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Scott's trick; collection principle; Hilbert's epsilon
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.
    $( Scott's trick collects all sets that have a certain property and are of
       the smallest possible rank.  This theorem shows that the resulting
       collection, expressed as in Equation 9.3 of [Jech] p. 72, is a set.
       (Contributed by NM, 13-Oct-2003.) $)
    scottex $p |- { x e. A | A. y e. A ( rank ` x ) C_ ( rank ` y ) } e. _V $=
      ( vw vz c0 wceq crnk cfv wss wral crab cvv wcel 0ex eleq1 mpbiri syl con0
      cv rabexg wn neq0 nfra1 nfcv nfrab nfel1 wi com12 ralrimivw ss2rab sylibr
      wex rsp wrex rankon fveq2 sseq1d elrab simprbi sseq2 ralbidv rspcev mp2an
      rgen bndrank ax-mp ssex exlimi sylbi pm2.61i ) CFGZATZHIZBTZHIZJZBCKZACLZ
      MNZVLCMNZVTVLWAFMNOCFMPQVRACMUARVLUBVOCNZBUMVTBCUCWBVTBBVSMVRBACVQBCUDBCU
      EUFUGWBVSVQACLZJZVTWBVRVQUHZACKWDWBWEACVRWBVQVQBCUNUIUJVRVQACUKULVSWCDTZH
      IZETZJZDWCKZESUOZWCMNVPSNWGVPJZDWCKZWKVOUPWLDWCWFWCNWFCNWLVQWLAWFCVMWFGVN
      WGVPVMWFHUQURUSUTVEWJWMEVPSWHVPGWIWLDWCWHVPWGVAVBVCVDEDWCVFVGVHRVIVJVK $.
  $}

  ${
    $d x y z w A $.
    $( Scott's trick collects all sets that have a certain property and are of
       the smallest possible rank.  This theorem shows that the resulting
       collection, expressed as in Equation 9.3 of [Jech] p. 72, contains at
       least one representative with the property, if there is one.  In other
       words, the collection is empty iff no set has the property (i.e. ` A `
       is empty).  (Contributed by NM, 15-Oct-2003.) $)
    scott0 $p |- ( A = (/) <->
               { x e. A | A. y e. A ( rank ` x ) C_ ( rank ` y ) } = (/) ) $=
      ( c0 wceq cv crnk cfv wss crab wne wrex wcel mpan2 wa eqeq1 sylibr df-rex
      wex con0 wral rabeq rab0 syl6eq ciin n0 nfre1 eqid rspe exlimi sylbi fvex
      cab anbi2d spcev eximi excom exbii 3imtr4i abn0 cint dfiin2 rankon mpbiri
      syl eleq1 rexlimivw abssi onint mpan syl5eqel nfii1 nfeq2 rexbid ibi ssid
      elabg fveq2 sseq1d rspcev iinss sseq1 syl5ib ralrimiv reximi 4syl necon4i
      rabn0 impbii ) CDEZAFZGHZBFZGHZIZBCUAZACJZDEWJWQWPADJDWPACDUBWPAUCUDCDWQD
      CDKZWPACLZWQDKWRWMWLEZACLZBUMZDKZACWLUEZXBMZXDWLEZACLZWSWRXABSZXCWRWLWLEZ
      ACLZXHWRWKCMZASXJACUFXKXJAXIACUGXKXIXJWLUHXIACUINUJUKXKXIOZASZXKWTOZASZBS
      ZXJXHXMXNBSZASXPXLXQAXNXLBWLWKGULZWTWTXIXKWMWLWLPUNUOUPXNBAUQQXIACRXAXOBW
      TACRURUSVEXABUTQXCXDXBVAZXBABCWLXRVBXBTIXCXSXBMXABTWTWMTMZACWTXTWLTMWKVCW
      MWLTVFVDVGVHXBVIVJVKXEXGXAXGBXDXBWMXDEWTXFACAWMXDACWLVLVMWMXDWLPVNVQVOXFW
      PACXFWOBCWMCMZXDWNIZXFWOYAWOACLZYBYAWNWNIZYCWNVPWOYDAWMCWKWMEWLWNWNWKWMGV
      RVSVTNACWLWNWAVEXDWLWNWBWCWDWEWFWPACWHQWGWI $.
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( Theorem scheme version of ~ scottex .  The collection of all ` x ` of
       minimum rank such that ` ph ( x ) ` is true, is a set.  (Contributed by
       NM, 13-Oct-2003.) $)
    scottexs $p |- { x | ( ph /\
         A. y ( [. y / x ]. ph -> ( rank ` x ) C_ ( rank ` y ) ) ) } e. _V $=
      ( vz cv crnk cfv wss cab wral crab wsbc wi wal wa cvv wcel nfcv nfab1 nfv
      nfral fveq2 sseq1d ralbidv cbvrab df-rab abid df-ral df-sbc imbi1i bitr4i
      weq albii anbi12i abbii 3eqtri scottex eqeltrri ) DEZFGZCEZFGZHZCABIZJZDV
      DKZAABVALZBEZFGZVBHZMZCNZOZBIZPVFVJCVDJZBVDKVHVDQZVOOZBIVNVEVODBVDDVDRABS
      ZVCBCVDVRVCBTUAVODTDBULZVCVJCVDVSUTVIVBUSVHFUBUCUDUEVOBVDUFVQVMBVPAVOVLAB
      UGVOVAVDQZVJMZCNVLVJCVDUHVKWACVGVTVJABVAUIUJUMUKUNUOUPDCVDUQUR $.
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( Theorem scheme version of ~ scott0 .  The collection of all ` x ` of
       minimum rank such that ` ph ( x ) ` is true, is not empty iff there is
       an ` x ` such that ` ph ( x ) ` holds.  (Contributed by NM,
       13-Oct-2003.) $)
    scott0s $p |- ( E. x ph <-> { x | ( ph /\
       A. y ( [. y / x ]. ph -> ( rank ` x ) C_ ( rank ` y ) ) ) } =/= (/) ) $=
      ( vz wex cab c0 wne cv crnk cfv wss wi wal wa wceq wral crab wcel nfv weq
      wsbc abn0 scott0 nfcv nfab1 nfral fveq2 sseq1d ralbidv cbvrab df-rab abid
      df-ral df-sbc imbi1i albii bitr4i anbi12i 3eqtri eqeq1i necon3bii bitr3i
      abbii bitri ) ABEABFZGHAABCIZUBZBIZJKZVGJKZLZMZCNZOZBFZGHABUCVFGVPGVFGPDI
      ZJKZVKLZCVFQZDVFRZGPVPGPDCVFUDWAVPGWAVLCVFQZBVFRVIVFSZWBOZBFVPVTWBDBVFDVF
      UEABUFZVSBCVFWEVSBTUGWBDTDBUAZVSVLCVFWFVRVJVKVQVIJUHUIUJUKWBBVFULWDVOBWCA
      WBVNABUMWBVGVFSZVLMZCNVNVLCVFUNVMWHCVHWGVLABVGUOUPUQURUSVDUTVAVEVBVC $.
  $}

  ${
    $d x y z w A $.  $d y z w B $.  $d w C $.  $d w D $.
    cplem1.1 $e |- C = { y e. B | A. z e. B ( rank ` y ) C_ ( rank ` z ) } $.
    cplem1.2 $e |- D = U_ x e. A C $.
    $( Lemma for the Collection Principle ~ cp .  (Contributed by NM,
       17-Oct-2003.) $)
    cplem1 $p |- A. x e. A ( B =/= (/) -> ( B i^i D ) =/= (/) ) $=
      ( vw c0 wne cin wi cv wcel wex wceq crnk cfv wral scott0 eqeq1i necon3bii
      wss crab bitr4i n0 bitri wa ssrab2 eqsstri sseli a1i ciun syl6sseqr sseld
      ssiun2 jcad inelcm syl6 exlimdv syl5bi rgen ) EKLZEGMKLZNADVEJOZFPZJQZAOD
      PZVFVEFKLVIEKFKEKRBOSTCOSTUECEUAZBEUFZKRFKRBCEUBFVLKHUCUGUDJFUHUIVJVHVFJV
      JVHVGEPZVGGPZUJVFVJVHVMVNVHVMNVJFEVGFVLEHVKBEUKULUMUNVJFGVGVJFADFUOGADFUR
      IUPUQUSVGEGUTVAVBVCVD $.
  $}

  ${
    $d x y z w A $.  $d y z w B $.
    cplem2.1 $e |- A e. _V $.
    $( -Lemma for the Collection Principle ~ cp .  (Contributed by NM,
       17-Oct-2003.) $)
    cplem2 $p |- E. y A. x e. A ( B =/= (/) -> ( B i^i y ) =/= (/) ) $=
      ( vz vw c0 wne cv crnk cfv wss wral crab ciun cin wi wex eqid cplem1 wceq
      scottex iunex nfiu1 nfeq2 ineq2 neeq1d imbi2d ralbid spcev ax-mp ) DHIZDA
      CFJKLGJKLMGDNFDOZPZQZHIZRZACNZUMDBJZQZHIZRZACNZBSAFGCDUNUOUNTUOTUAVDUSBUO
      ACUNEFGDUCUDUTUOUBZVCURACAUTUOACUNUEUFVEVBUQUMVEVAUPHUTUODUGUHUIUJUKUL $.
  $}

  ${
    $d ph z w $.  $d x y z w $.
    $( Collection Principle.  This remarkable theorem scheme is in effect a
       very strong generalization of the Axiom of Replacement.  The proof makes
       use of Scott's trick ~ scottex that collapses a proper class into a set
       of minimum rank.  The wff ` ph ` can be thought of as
       ` ph ( x , y ) ` .  Scheme "Collection Principle" of [Jech] p. 72.
       (Contributed by NM, 17-Oct-2003.) $)
    cp $p |- E. w A. x e. z ( E. y ph -> E. y e. w ph ) $=
      ( cab c0 wne cv cin wi wral wex wrex vex cplem2 abn0 wcel wa exbii anbi1i
      elin abid ancom 3bitri nfab1 nfcv nfin df-rex 3bitr4i imbi12i ralbii mpbi
      n0f ) ACFZGHZUOEIZJZGHZKZBDIZLZEMACMZACUQNZKZBVALZEMBEVAUODOPVBVFEUTVEBVA
      UPVCUSVDACQCIZURRZCMVGUQRZASZCMUSVDVHVJCVHVGUORZVISAVISVJVGUOUQUBVKAVIACU
      CUAAVIUDUETCURCUOUQACUFCUQUGUHUNACUQUIUJUKULTUM $.
  $}

  ${
    $d ph z w $.  $d x y z w $.
    $( A very strong generalization of the Axiom of Replacement (compare
       ~ zfrep6 ), derived from the Collection Principle ~ cp .  Its strength
       lies in the rather profound fact that ` ph ( x , y ) ` does not have to
       be a "function-like" wff, as it does in the standard Axiom of
       Replacement.  This theorem is sometimes called the Boundedness Axiom.
       (Contributed by NM, 17-Oct-2004.) $)
    bnd $p |- ( A. x e. z E. y ph -> E. w A. x e. z E. y e. w ph ) $=
      ( wex cv wral wrex wi cp ralim eximii 19.37aiv ) ACFZBDGZHZACEGIZBPHZEORJ
      BPHQSJEABCDEKORBPLMN $.
  $}

  ${
    $d ph z w v $.  $d x z w v A $.  $d x y z w v B $.
    bnd2.1 $e |- A e. _V $.
    $( A variant of the Boundedness Axiom ~ bnd that picks a subset ` z ` out
       of a possibly proper class ` B ` in which a property is true.
       (Contributed by NM, 4-Feb-2004.) $)
    bnd2 $p |- ( A. x e. A E. y e. B ph ->
              E. z ( z C_ B /\ A. x e. A E. y e. z ph ) ) $=
      ( vw vv wrex wral cv wcel wa wex wss df-rex wi wceq raleq bnd vtocl sylbi
      ralbii exbidv imbi12d cin inex1 inss2 sseq1 mpbiri biantrurd rexeq anbi1i
      vex elin anass bitri rexbii2 syl6bb ralbidv bitr3d spcev exlimiv syl ) AC
      FJZBEKZCLZFMZANZCHLZJZBEKZHOZDLZFPZACVOJZBEKZNZDOZVGVJCOZBEKZVNVFWABEACFQ
      UDWABILZKZVLBWCKZHOZRWBVNRIEGWCESZWDWBWFVNWABWCETWGWEVMHVLBWCETUEUFVJBCIH
      UAUBUCVMVTHVSVMDVKFUGZVKFHUOUHVOWHSZVRVSVMWIVPVRWIVPWHFPVKFUIVOWHFUJUKULW
      IVQVLBEWIVQACWHJVLACVOWHUMAVJCWHVKVHWHMZANVHVKMZVINZANWKVJNWJWLAVHVKFUPUN
      WKVIAUQURUSUTVAVBVCVDVE $.
  $}

  ${
    $d x y z A $.
    $( The collection of all sets equinumerous to a set ` A ` and having the
       least possible rank is a set.  This is the part of the justification of
       the definition of kard of [Enderton] p. 222.  (Contributed by NM,
       14-Dec-2003.) $)
    kardex $p |- { x | ( x ~~ A /\
                  A. y ( y ~~ A -> ( rank ` x ) C_ ( rank ` y ) ) ) } e. _V $=
      ( vz cv crnk cfv wss cen wbr cab wral crab wi wal cvv wcel df-rab breq1
      wa vex elab ralab anbi12i abbii eqtri scottex eqeltrri ) AEZFGBEZFGHZBDEZ
      CIJZDKZLZAUNMZUICIJZUJCIJZUKNBOZTZAKZPUPUIUNQZUOTZAKVAUOAUNRVCUTAVBUQUOUS
      UMUQDUIAUAULUICISUBUMURUKBDULUJCISUCUDUEUFABUNUGUH $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d z C $.  $d z D $.
    karden.1 $e |- A e. _V $.
    karden.2 $e |- B e. _V $.
    karden.3 $e |- C =
       { x | ( x ~~ A /\ A. y ( y ~~ A -> ( rank ` x ) C_ ( rank ` y ) ) ) } $.
    karden.4 $e |- D =
       { x | ( x ~~ B /\ A. y ( y ~~ B -> ( rank ` x ) C_ ( rank ` y ) ) ) } $.
    $( If we allow the Axiom of Regularity, we can avoid the Axiom of Choice by
       defining the cardinal number of a set as the set of all sets
       equinumerous to it and having the least possible rank.  This theorem
       proves the equinumerosity relationship for this definition (compare
       ~ carden ).  The hypotheses correspond to the definition of kard of
       [Enderton] p. 222 (which we don't define separately since currently we
       do not use it elsewhere).  This theorem along with ~ kardex justify the
       definition of kard.  The restriction to the least rank prevents the
       proper class that would result from ` { x | x ~~ A } ` .  (Contributed
       by NM, 18-Dec-2003.) $)
    karden $p |- ( C = D <-> A ~~ B ) $=
      ( vz vw cen wbr cv crnk breq1 wa wi wal wceq cfv wss cab wral wrex c0 wne
      crab wex enref spcev ax-mp abn0 mpbir scott0 necon3bii mpbi wcel vex elab
      rabn0 ralab anbi12i simpl a1i wb eqeq12i abbi bitr4i sseq1d imbi2d albidv
      fveq2 anbi12d bibi12d spv sylbi syl6bi jcad ensym entr sylan syl5bi exp3a
      syl6 rexlimdv mpi enen2 imbi1d abbidv 3eqtr4g impbii ) EFUAZCDMNZWNKOZPUB
      ZBOZPUBZUCZBLOZCMNZLUDZUEZKXCUFZWOXDKXCUIZUGUHZXEXCUGUHZXGXHXBLUJZCCMNZXI
      CGUKXBXJLCGXACCMQULUMXBLUNUOXCUGXFUGKBXCUPUQURXDKXCVBURWNXDWOKXCWNWPXCUSZ
      XDWOXKXDRWPCMNZWRCMNZWTSZBTZRZWNWOXKXLXDXOXBXLLWPKUTXAWPCMQVAXBXMWTBLXAWR
      CMQVCVDWNXPXLWPDMNZRWOWNXPXLXQXPXLSWNXLXOVEVFWNXPXQWRDMNZWTSZBTZRZXQWNAOZ
      CMNZXMYBPUBZWSUCZSZBTZRZYBDMNZXRYESZBTZRZVGZATZXPYAVGZWNYHAUDZYLAUDZUAYNE
      YPFYQIJVHYHYLAVIVJYMYOAKYBWPUAZYHXPYLYAYRYCXLYGXOYBWPCMQYRYFXNBYRYEWTXMYR
      YDWQWSYBWPPVNVKZVLVMVOYRYIXQYKXTYBWPDMQYRYJXSBYRYEWTXRYSVLVMVOVPVQVRXQXTV
      EVSVTXLCWPMNXQWOWPCWACWPDWBWCWFWDWEWGWHWOYPYQEFWOYHYLAWOYCYIYGYKCDYBWIWOY
      FYJBWOXMXRYECDWRWIWJVMVOWKIJWLWM $.
  $}

  ${
    $d x y A $.  $d x y R $.
    htalem.1 $e |- A e. _V $.
    htalem.2 $e |- B = ( iota_ x e. A A. y e. A -. y R x ) $.
    $( Lemma for defining an emulation of Hilbert's epsilon.  Hilbert's epsilon
       is described at ~ http://plato.stanford.edu/entries/epsilon-calculus/ .
       This theorem is equivalent to Hilbert's "transfinite axiom," described
       on that page, with the additional ` R We A ` antecedent.  The element
       ` B ` is the epsilon that the theorem emulates.  (Contributed by NM,
       11-Mar-2004.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    htalem $p |- ( ( R We A /\ A =/= (/) ) -> B e. A ) $=
      ( wwe c0 wne wa cv wbr wn wral crio wreu wcel cvv a1i simpl ssid syl13anc
      wss simpr wereu riotacl syl syl5eqel ) CEHZCIJZKZDBLALEMNBCOZACPZCGULUMAC
      QZUNCRULUJCSRZCCUDZUKUOUJUKUAUPULFTUQULCUBTUJUKUEABCCESUFUCUMACUGUHUI $.
  $}

  ${
    $d x y $.  $d w z A $.  $d y ph $.  $d w z R $.
    hta.1 $e |- A = { x | ( ph /\ A. y ( [. y / x ]. ph ->
                                         ( rank ` x ) C_ ( rank ` y ) ) ) } $.
    hta.2 $e |- B = ( iota_ z e. A A. w e. A -. w R z ) $.
    $( A ZFC emulation of Hilbert's transfinite axiom.  The set ` B ` has the
       properties of Hilbert's epsilon, except that it also depends on a
       well-ordering ` R ` .  This theorem arose from discussions with Raph
       Levien on 5-Mar-2004 about translating the HOL proof language, which
       uses Hilbert's epsilon.  See
       ~ http://us.metamath.org/downloads/choice.txt (copy of obsolete link
       ~ http://ghilbert.org/choice.txt) and
       ~ http://us.metamath.org/downloads/megillaward2005he.pdf .

       Hilbert's epsilon is described at
       ~ http://plato.stanford.edu/entries/epsilon-calculus/ .  This theorem
       differs from Hilbert's transfinite axiom described on that page in that
       it requires ` R We A ` as an antecedent.  Class ` A ` collects the sets
       of the least rank for which ` ph ( x ) ` is true.  Class ` B ` , which
       emulates the epsilon, is the minimum element in a well-ordering ` R ` on
       ` A ` .

       If a well-ordering ` R ` on ` A ` can be expressed in a closed form, as
       might be the case if we are working with say natural numbers, we can
       eliminate the antecedent with modus ponens, giving us the exact
       equivalent of Hilbert's transfinite axiom.  Otherwise, we replace ` R `
       with a dummy set variable, say ` w ` , and attach ` w We A ` as an
       antecedent in each step of the ZFC version of the HOL proof until the
       epsilon is eliminated.  At that point, ` B ` (which will have ` w ` as a
       free variable) will no longer be present, and we can eliminate
       ` w We A ` by applying ~ exlimiv and ~ weth , using ~ scottexs to
       establish the existence of ` A ` .

       For a version of this theorem scheme using class (meta)variables instead
       of wff (meta)variables, see ~ htalem .  (Contributed by NM,
       11-Mar-2004.)  (Revised by Mario Carneiro, 25-Jun-2015.) $)
    hta $p |- ( R We A -> ( ph -> [. B / x ]. ph ) ) $=
      ( c0 wne wwe wcel wsbc wex cv crnk cfv cab 19.8a wss wi wa scott0s neeq1i
      wal bitr4i sylib cvv scottexs eqeltri htalem ex simpl ss2abi sseli df-sbc
      eqsstri sylibr syl56 ) AFKLZFHMZGFNZABGOZAABPZVBABUAVFAABCQZOBQRSVGRSUBUC
      CUGZUDZBTZKLVBABCUEFVJKIUFUHUIVCVBVDDEFGHFVJUJIABCUKULJUMUNVDGABTZNVEFVKG
      FVJVKIVIABAVHUOUPUSUQABGURUTVA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cardinal numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c card $. $( Cardinal size function $)
  $c aleph $. $( Aleph function $)
  $c cf $. $( Cofinality function $)
  $c AC_ $.

  $( Extend class definition to include the cardinal size function. $)
  ccrd $a class card $.

  $( Extend class definition to include the aleph function. $)
  cale $a class aleph $.

  $( Extend class definition to include the cofinality function. $)
  ccf $a class cf $.

  $( The axiom of choice for limited-length sequences. $)
  wacn $a class AC_ A $.

  ${
    $d f g u v x y z A $.
    $( Define the cardinal number function.  The cardinal number of a set is
       the least ordinal number equinumerous to it.  In other words, it is the
       "size" of the set.  Definition of [Enderton] p. 197.  See ~ cardval for
       its value, ~ cardval2 for a simpler version of its value.  The principle
       theorem relating cardinality to equinumerosity is ~ carden .  Our
       notation is from Enderton.  Other textbooks often use a double bar over
       the set to express this function.  (Contributed by NM, 21-Oct-2003.) $)
    df-card $a |- card = ( x e. _V |-> |^| { y e. On | y ~~ x } ) $.

    $( Define the aleph function.  Our definition expresses Definition 12 of
       [Suppes] p. 229 in a closed form, from which we derive the recursive
       definition as theorems ~ aleph0 , ~ alephsuc , and ~ alephlim .  The
       aleph function provides a one-to-one, onto mapping from the ordinal
       numbers to the infinite cardinal numbers.  Roughly, any aleph is the
       smallest infinite cardinal number whose size is strictly greater than
       any aleph before it.  (Contributed by NM, 21-Oct-2003.) $)
    df-aleph $a |- aleph = rec ( har , om ) $.

    $( Define the cofinality function.  Definition B of Saharon Shelah,
       _Cardinal Arithmetic_ (1994), p. xxx (Roman numeral 30).  See ~ cfval
       for its value and a description.  (Contributed by NM, 1-Apr-2004.) $)
    df-cf $a |- cf = ( x e. On |-> |^| { y | E. z ( y = ( card ` z ) /\
                ( z C_ x /\ A. v e. x E. u e. z v C_ u ) ) } ) $.

    $( Define a local and length-limited version of the axiom of choice.  The
       definition of the predicate ` X e. AC_ A ` is that for all families of
       nonempty subsets of ` X ` indexed on ` A ` (i.e. functions
       ` A --> ~P X \ { (/) } ` ), there is a function which selects an element
       from each set in the family.  (Contributed by Mario Carneiro,
       31-Aug-2015.) $)
    df-acn $a |- AC_ A = { x | ( A e. _V /\ A. f e. ( ( ~P x \ { (/) } ) ^m A )
      E. g A. y e. A ( g ` y ) e. ( f ` y ) ) } $.
  $}

  ${
    $d w x y z A $.  $d x B $.
    $( The cardinality function is a function with domain the well-orderable
       sets.  Assuming AC, this is the universe.  (Contributed by Mario
       Carneiro, 6-Jun-2013.)  (Revised by Mario Carneiro, 20-Sep-2014.) $)
    cardf2 $p |- card : { x | E. y e. On y ~~ x } --> On $=
      ( vz vw cv cen wbr con0 wrex cab ccrd wss wceq cvv crab cint df-card wcel
      mpbir2an wa wfn cxp wfun funmpt2 rabab dmmpt intexrab abbii 3eqtr4i df-fn
      wf cdm copab c0 wne simpr syl6eqelr intex sylibr rabn0 sylib rexbidv elab
      vex breq2 ssrab2 oninton sylancr eqeltrd ssopab2i cmpt df-mpt eqtri df-xp
      jca 3sstr4i dff2 ) BEZAEZFGZBHIZAJZHKUKKWBUAZKWBHUBZLWCKUCKULZWBMANVTBHOP
      ZKABQZUDWFNRZANOWHAJWEWBWHAUEANWFKWGUFWAWHAVTBHUGUHUIKWBUJSCEZNRZDEZVRWIF
      GZBHOZPZMZTZCDUMZWIWBRZWKHRZTZCDUMKWDWPWTCDWPWRWSWPWLBHIZWRWPWMUNUOZXAWPW
      NNRXBWPWNWKNWJWOUPZDVDUQWMURUSZWLBHUTVAWAXAAWICVDVSWIMVTWLBHVSWIVRFVEVBVC
      USWPWKWNHXCWPWMHLXBWNHRWLBHVFXDWMVGVHVIVOVJKCNWNVKWQCBQCDNWNVLVMCDWBHVNVP
      WBHKVQS $.

    $( The cardinal number of a set is an ordinal number.  Proposition 10.6(1)
       of [TakeutiZaring] p. 85.  (Contributed by Mario Carneiro, 7-Jan-2013.)
       (Revised by Mario Carneiro, 13-Sep-2013.) $)
    cardon $p |- ( card ` A ) e. On $=
      ( vy vx cv cen wbr con0 wrex cab ccrd cardf2 0elon f0cli ) BDCDEFBGHCIGAJ
      CBKLM $.

    $( A way to express well-orderability without bound or distinct variables.
       (Contributed by Stefan O'Rear, 28-Feb-2015.)  (Revised by Mario
       Carneiro, 27-Apr-2015.) $)
    isnum2 $p |- ( A e. dom card <-> E. x e. On x ~~ A ) $=
      ( vy ccrd cdm wcel cen wbr con0 wrex cab cardf2 fdmi eleq2i cvv brrelex2i
      cv relen rexlimivw wceq breq2 rexbidv elab3 bitri ) BDEZFBAQZCQZGHZAIJZCK
      ZFUFBGHZAIJZUEUJBUJIDCALMNUIULCBUKBOFAIUFBGRPSUGBTUHUKAIUGBUFGUAUBUCUD $.

    $( A set equinumerous to an ordinal is numerable.  (Contributed by Mario
       Carneiro, 29-Apr-2015.) $)
    isnumi $p |- ( ( A e. On /\ A ~~ B ) -> B e. dom card ) $=
      ( vx con0 wcel cen wbr wa cv wrex ccrd cdm breq1 rspcev isnum2 sylibr ) A
      DEABFGZHCIZBFGZCDJBKLESQCADRABFMNCBOP $.

    $( Equinumerous sets are equi-numerable.  (Contributed by Mario Carneiro,
       29-Apr-2015.) $)
    ennum $p |- ( A ~~ B -> ( A e. dom card <-> B e. dom card ) ) $=
      ( vx cen wbr cv con0 wrex ccrd cdm wcel enen2 rexbidv isnum2 3bitr4g ) AB
      DEZCFZADEZCGHQBDEZCGHAIJZKBTKPRSCGABQLMCANCBNO $.
  $}

  ${
    $d x y z A $.  $d x y B $.
    $( Every finite set is numerable.  (Contributed by Mario Carneiro,
       4-Feb-2013.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    finnum $p |- ( A e. Fin -> A e. dom card ) $=
      ( vx cfn wcel cv cen wbr com wrex ccrd isfi con0 nnon ensym isnumi syl2an
      cdm rexlimiva sylbi ) ACDABEZFGZBHIAJQDZBAKUAUBBHTHDTLDTAFGUBUATMATNTAOPR
      S $.

    $( Every ordinal number is numerable.  (Contributed by Mario Carneiro,
       29-Apr-2015.) $)
    onenon $p |- ( A e. On -> A e. dom card ) $=
      ( con0 wcel cen wbr ccrd cdm enrefg isnumi mpdan ) ABCAADEAFGCABHAAIJ $.

    $( A Tarski set is well-orderable.  (Contributed by Mario Carneiro,
       19-Apr-2013.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    tskwe $p |- ( ( A e. V /\ { x e. ~P A | x ~< A } C_ A ) ->
        A e. dom card ) $=
      ( vy vz wcel cv csdm wbr wss wa con0 cin cvv word wi sylanbrc adantr nfcv
      breq1 cpw crab cen ccrd cdm pwexg rabexg incom inex1g syl5eqelr wtr inss1
      sseli onelon ancoms sylan2 onelss impcom inss2 elrab simpld elpwid adantl
      wal sylib sstrd vex elpw sylibr cdom ssdomg simprd domsdomtr syl2anc elin
      mpsyl gen2 dftr2 mpbir ordon trssord mp3an elong mpbiri 4syl simpr syl5ss
      wn mpd ordirr mp1i w3a 3ad2ant1 wb elpw2g mpbird 3adant3 nfrab1 nfin nfbr
      simp3 elrabf 3expia mtod bren2 isnumi ) BCFZAGZBHIZABUAZUBZBJZKZLXKMZLFZX
      NBUCIZBUDUEFXGXOXLXGXJNFXKNFZXNNFZXOBCUFXIAXJNUGXQXNXKLMNXKLUHXKLNUIUJXRX
      OXNOZXNUKZXNLJLOXSXTDGZEGZFZYBXNFZKZYAXNFZPZEVDDVDYGDEYEYALFZYAXKFZYFYDYC
      YBLFZYHXNLYBLXKULZUMZYJYCYHYBYAUNUOUPYEYAXJFZYABHIZYIYEYABJYMYEYAYBBYDYCY
      JYAYBJZYLYJYCYOYBYAUQURUPZYDYBBJYCYDYBBYDYBXJFZYBBHIZYDYBXKFYQYRKXNXKYBLX
      KUSZUMXIYRAYBXJXHYBBHTUTVEZVAVBVCVFYABDVGVHVIYEYAYBVJIZYRYNYBNFYEYOUUAEVG
      YPYAYBNVKVPYDYRYCYDYQYRYTVLVCYAYBBVMVNXIYNAYAXJXHYABHTUTQYALXKVOQVQDEXNVR
      VSYKVTXNLWAWBZXNNWCWDWEZRXMXNBVJIZXNBHIZWHXPXMXNBJZUUDXMXNXKBYSXGXLWFWGZX
      GUUFUUDPXLXNBCVKRWIXMUUEXNXNFZXSUUHWHXMUUBXNWJWKXGXLUUEUUHXGXLUUEWLZXOXNX
      KFZUUHXGXLXOUUEUUCWMUUIXNXJFZUUEUUJXGXLUUKUUEXMUUKUUFUUGXGUUKUUFWNXLXNBCW
      ORWPWQXGXLUUEXAXIUUEAXNXJALXKALSXIAXJWRWSZAXJSAXNBHUULAHSABSWTXHXNBHTXBQX
      NLXKVOQXCXDXNBXEQXNBXFVN $.

    $( The cartesian product of numerable sets is numerable.  (Contributed by
       Mario Carneiro, 3-Mar-2013.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    xpnum $p |- ( ( A e. dom card /\ B e. dom card ) ->
      ( A X. B ) e. dom card ) $=
      ( vx vy ccrd cdm wcel cv cen wbr con0 wrex cxp isnum2 wa reeanv comu omcl
      co adantr omxpen xpen entr syl2an isnumi syl2anc rexlimivv sylbir syl2anb
      ex ) AEFZGCHZAIJZCKLZDHZBIJZDKLZABMZUKGZBUKGCANDBNUNUQOUMUPOZDKLCKLUSUMUP
      CDKKPUTUSCDKKULKGUOKGOZUTUSVAUTOULUOQSZKGZVBURIJZUSVAVCUTULUORTVAVBULUOMZ
      IJVEURIJVDUTULUOUAULAUOBUBVBVEURUCUDVBURUEUFUJUGUHUI $.
  $}

  ${
    $d A w y z $.  $d A x y z $.
    $( An alternative definition of the value of ` ( card `` A ) ` that does
       not require AC to prove.  (Contributed by Mario Carneiro, 7-Jan-2013.)
       (Revised by Mario Carneiro, 27-Apr-2015.) $)
    cardval3 $p |- ( A e. dom card ->
                     ( card ` A ) = |^| { x e. On | x ~~ A } ) $=
      ( vy ccrd cdm wcel cvv cv cen wbr con0 crab cint wceq elex wrex c0 isnum2
      cfv wne rabn0 intex 3bitr2i biimpi rabbidv inteqd df-card fvmptg syl2anc
      breq2 ) BDEZFZBGFAHZBIJZAKLZMZGFZBDSUPNBUKOULUQULUNAKPUOQTUQABRUNAKUAUOUB
      UCUDCBUMCHZIJZAKLZMUPGGDURBNZUTUOVAUSUNAKURBUMIUJUEUFCAUGUHUI $.
  $}

  ${
    $d A x $.  $d A y $.
    $( Any numerable set is equinumerous to its cardinal number.  Proposition
       10.5 of [TakeutiZaring] p. 85.  (Contributed by Mario Carneiro,
       7-Jan-2013.) $)
    cardid2 $p |- ( A e. dom card -> ( card ` A ) ~~ A ) $=
      ( vy ccrd cdm wcel cfv cen wbr con0 crab cint cardval3 wss wne ssrab2 cvv
      cv c0 fvex syl6eqelr intex sylibr onint sylancr eqeltrd breq1 simprbi syl
      elrab ) ACDEZACFZBQZAGHZBIJZEZUKAGHZUJUKUNKZUNBALZUJUNIMUNRNZUQUNEUMBIOUJ
      UQPEUSUJUQUKPURACSTUNUAUBUNUCUDUEUOUKIEUPUMUPBUKIULUKAGUFUIUGUH $.

    $( A set is numerable iff it is equinumerous with its cardinal.
       (Contributed by Mario Carneiro, 29-Apr-2015.) $)
    isnum3 $p |- ( A e. dom card <-> ( card ` A ) ~~ A ) $=
      ( ccrd cdm wcel cfv cen wbr cardid2 con0 cardon isnumi mpan impbii ) ABCD
      ZABEZAFGZAHOIDPNAJOAKLM $.
  $}

  ${
    $d x y z A $.
    $( The value of the cardinal number function with an ordinal number as its
       argument.  Unlike ~ cardval , this theorem does not require the Axiom of
       Choice.  (Contributed by NM, 24-Nov-2003.)  (Revised by Mario Carneiro,
       13-Sep-2013.) $)
    oncardval $p |- ( A e. On -> ( card ` A ) = |^| { x e. On | x ~~ A } ) $=
      ( con0 wcel ccrd cdm cfv cv cen wbr crab cint wceq onenon cardval3 syl )
      BCDBEFDBEGAHBIJACKLMBNABOP $.

    $( Any ordinal number is equinumerous to its cardinal number.  Unlike
       ~ cardid , this theorem does not require the Axiom of Choice.
       (Contributed by NM, 26-Jul-2004.) $)
    oncardid $p |- ( A e. On -> ( card ` A ) ~~ A ) $=
      ( con0 wcel ccrd cdm cfv cen wbr onenon cardid2 syl ) ABCADECADFAGHAIAJK
      $.

    $( The cardinal of an ordinal number is less than or equal to the ordinal
       number.  Proposition 10.6(3) of [TakeutiZaring] p. 85.  (Contributed by
       NM, 22-Oct-2003.) $)
    cardonle $p |- ( A e. On -> ( card ` A ) C_ A ) $=
      ( vx con0 wcel ccrd cfv cv cen wbr crab cint oncardval wss breq1 intminss
      enrefg mpdan eqsstrd ) ACDZAEFBGZAHIZBCJKZABALSAAHIZUBAMACPUAUCBACTAAHNOQ
      R $.
  $}

  $( The cardinality of the empty set is the empty set.  (Contributed by NM,
     25-Oct-2003.) $)
  card0 $p |- ( card ` (/) ) = (/) $=
    ( c0 ccrd cfv wss wceq con0 wcel 0elon cardonle ax-mp ss0b mpbi ) ABCZADZMA
    EAFGNHAIJMKL $.

  ${
    $d A x y $.  $d A z $.
    $( The cardinality function is idempotent.  Proposition 10.11 of
       [TakeutiZaring] p. 85.  (Contributed by Mario Carneiro, 7-Jan-2013.) $)
    cardidm $p |- ( card ` ( card ` A ) ) = ( card ` A ) $=
      ( vy ccrd cdm wcel cfv wceq cv cen wbr con0 crab cint cardid2 ensymd entr
      wi expcom syl c0 impbid rabbidv inteqd cardval3 cardon oncardval 3eqtr4rd
      mp1i wn card0 ndmfv fveq2d 3eqtr4a pm2.61i ) ACDEZACFZCFZUPGUOBHZAIJZBKLZ
      MURUPIJZBKLZMZUPUQUOUTVBUOUSVABKUOUSVAUOAUPIJZUSVAQUOUPAANZOUSVDVAURAUPPR
      SUOUPAIJZVAUSQVEVAVFUSURUPAPRSUAUBUCBAUDUPKEUQVCGUOAUEBUPUFUHUGUOUIZTCFTU
      QUPUJVGUPTCACUKZULVHUMUN $.
  $}

  ${
    $d A x $.
    $( A set is a cardinal number iff it equals its own cardinal number.
       Proposition 10.9 of [TakeutiZaring] p. 85.  (Contributed by Mario
       Carneiro, 7-Jan-2013.) $)
    oncard $p |- ( E. x A = ( card ` x ) <-> A = ( card ` A ) ) $=
      ( cv ccrd cfv wceq wex fveq2 cardidm syl6eq eqtr4d exlimiv cvv wcel eleq1
      id fvex mpbiri eqeq2d spcegv mpcom impbii ) BACZDEZFZAGZBBDEZFZUEUHAUEBUD
      UGUEPUEUGUDDEUDBUDDHUCIJKLBMNZUHUFUHUIUGMNBDQBUGMORUEUHABMUCBFUDUGBUCBDHS
      TUAUB $.

    $( The cardinal number of a finite set is a finite ordinal.  (Contributed
       by Paul Chapman, 11-Apr-2009.)  (Revised by Mario Carneiro,
       4-Feb-2013.) $)
    ficardom $p |- ( A e. Fin -> ( card ` A ) e. om ) $=
      ( vx cv cen wbr com wrex cfn wcel ccrd cfv isfi biimpi wi wceq cdm finnum
      wa cardid2 syl entr sylan con0 wb cardon onomeneq mpan syl5ib eleq1a syld
      exp3acom23 rexlimiv mpcom ) ABCZDEZBFGZAHIZAJKZFIZUQUPBALMUOUQUSNBFUNFIZU
      QUOUSUTUQUORZURUNOZUSVAURUNDEZUTVBUQURADEZUOVCUQAJPIVDAQASTURAUNUAUBURUCI
      UTVCVBUDAUEURUNUFUGUHUNFURUIUJUKULUM $.

    $( A finite set is equinumerous to its cardinal number.  (Contributed by
       Mario Carneiro, 21-Sep-2013.) $)
    ficardid $p |- ( A e. Fin -> ( card ` A ) ~~ A ) $=
      ( cfn wcel ccrd cdm cfv cen wbr finnum cardid2 syl ) ABCADECADFAGHAIAJK
      $.

    $( The cardinality of a natural number is the number.  Corollary 10.23 of
       [TakeutiZaring] p. 90.  (Contributed by Mario Carneiro, 7-Jan-2013.) $)
    cardnn $p |- ( A e. om -> ( card ` A ) = A ) $=
      ( com wcel ccrd cfv cen wbr wceq con0 cdm nnon onenon cardid2 3syl wb cfn
      nnfi ficardom syl nneneq mpancom mpbid ) ABCZADEZAFGZUDAHZUCAICADJCUEAKAL
      AMNUDBCZUCUEUFOUCAPCUGAQARSUDATUAUB $.

    $( The empty set is the only numerable set with cardinality zero.
       (Contributed by Mario Carneiro, 7-Jan-2013.) $)
    cardnueq0 $p |- ( A e. dom card -> ( ( card ` A ) = (/) <-> A = (/) ) ) $=
      ( ccrd cdm wcel cfv c0 wceq cen wbr cardid2 ensymd breq2 syl6bb syl5ibcom
      en0 fveq2 card0 syl6eq impbid1 ) ABCDZABEZFGZAFGZTAUAHIZUBUCTUAAAJKUBUDAF
      HIUCUAFAHLAOMNUCUAFBEFAFBPQRS $.
  $}

  ${
    $d A x $.  $d B x $.
    $( No member of a cardinal number of a set is equinumerous to the set.
       Proposition 10.6(2) of [TakeutiZaring] p. 85.  (Contributed by Mario
       Carneiro, 9-Jan-2013.) $)
    cardne $p |- ( A e. ( card ` B ) -> -. A ~~ B ) $=
      ( vx ccrd cdm wcel cfv cen wbr wn elfvdm wi wa wss cv con0 crab adantl wb
      cint cardon oneli breq1 onintss syl cardval3 sseq1d adantr sylibrd ontri1
      sylancr sylibd con2d ex pm2.43d mpcom ) BDEFZABDGZFZABHIZJZABDKUQUSVAUQUS
      USVALUQUSMZUTUSVBUTURANZUSJZVBUTCOZBHIZCPQTZANZVCUSUTVHLZUQUSAPFZVIURABUA
      ZUBZVFUTCAVEABHUCUDUERUQVCVHSUSUQURVGACBUFUGUHUIUSVCVDSZUQUSURPFVJVMVKVLU
      RAUJUKRULUMUNUOUP $.

    $( If two sets have equal nonzero cardinalities, then they are
       equinumerous.  (This assertion and ~ carden2b are meant to replace
       ~ carden in ZF without AC.) (Contributed by Mario Carneiro,
       9-Jan-2013.) $)
    carden2a $p |- ( ( ( card ` A ) = ( card ` B ) /\ ( card ` A ) =/= (/) )
       -> A ~~ B ) $=
      ( ccrd cfv c0 wne wceq wn cen wbr df-ne wa wcel ndmfv eqeq1 syl5ibr con1d
      cdm imp cardid2 syl wi nsyl4 ensymd breq2 entr ex syl6bi syl5 mpd sylan2b
      ) ACDZEFULBCDZGZULEGZHZABIJZULEKUNUPLZUMBIJZUQURBCRZMZUSUNUPVAUNVAUOVAHUO
      UNUMEGBCNULUMEOPQSBTUAUNUPUSUQUBZUPAULIJZUNVBUPULAAUTMULAIJUOATACNUCUDUNV
      CAUMIJZVBULUMAIUEVDUSUQAUMBUFUGUHUISUJUK $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( If two sets are equinumerous, then they have equal cardinalities.  (This
       assertion and ~ carden2a are meant to replace ~ carden in ZF without
       AC.) (Contributed by Mario Carneiro, 9-Jan-2013.)  (Proof shortened by
       Mario Carneiro, 27-Apr-2015.) $)
    carden2b $p |- ( A ~~ B -> ( card ` A ) = ( card ` B ) ) $=
      ( cen wbr ccrd wcel cfv wceq wa wss cardne biimpa cardid2 entr nsyl3 con0
      wn syl wb c0 cdm ennum ensym adantr syl2anc cardon ontri1 mp2an sylibr id
      syl2anr eqssd ndmfv adantl notbid eqtr4d pm2.61dan ) ABCDZAEUAZFZAEGZBEGZ
      HURUTIZVAVBVCVBVAFZQZVAVBJZVDVBACDZVCVBAKVCVBBCDZBACDZVGVCBUSFZVHURUTVJAB
      UBZLBMRURVIUTABUCUDVBBANUEOVAPFZVBPFZVFVESAUFZBUFZVAVBUGUHUIVCVAVBFZQZVBV
      AJZVPVABCDZVCVABKUTVAACDURVSURAMURUJVAABNUKOVMVLVRVQSVOVNVBVAUGUHUIULURUT
      QZIZVATVBVTVATHURAEUMUNWAVJQZVBTHURVTWBURUTVJVKUOLBEUMRUPUQ $.
  $}

  ${
    $d A x $.
    $( A set has cardinality one iff it is a singleton.  (Contributed by Mario
       Carneiro, 10-Jan-2013.) $)
    card1 $p |- ( ( card ` A ) = 1o <-> E. x A = { x } ) $=
      ( ccrd cfv c1o wceq cen wbr cv csn wex wne com wcel 1onn cardnn ax-mp 1n0
      c0 eqnetri carden2a mpan2 eqcoms ensymd carden2b impbii eqeq2i 3bitr3i
      en1 ) BCDZECDZFZBEGHZUJEFBAIJFAKULUMULEBEBGHZUKUJUKUJFUKSLUNUKESEMNUKEFOE
      PQZRTEBUAUBUCUDBEUEUFUKEUJUOUGABUIUH $.

    $( A singleton has cardinality one.  (Contributed by Mario Carneiro,
       10-Jan-2013.) $)
    cardsn $p |- ( A e. V -> ( card ` { A } ) = 1o ) $=
      ( vx wcel csn cv wceq wex ccrd cfv c1o eqid sneq eqeq2d spcegv mpi sylibr
      card1 ) ABDZAEZCFZEZGZCHZTIJKGSTTGZUDTLUCUECABUAAGUBTTUAAMNOPCTRQ $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Two sets have the dominance relationship if their cardinalities have the
       subset relationship and one is numerable.  See also ~ carddom , which
       uses AC. (Contributed by Mario Carneiro, 11-Jan-2013.)  (Revised by
       Mario Carneiro, 29-Apr-2015.) $)
    carddomi2 $p |- ( ( A e. dom card /\ B e. V ) ->
      ( ( card ` A ) C_ ( card ` B ) -> A ~<_ B ) ) $=
      ( ccrd cdm wcel wa cfv wss cdom wbr wi c0 wceq wb wne cvv cardid2 syl2anc
      cen cardnueq0 adantr biimpa 0domg ad2antlr eqbrtrd a1d fvex simprr ssdomg
      mpsyl ad2antrr simprl ssn0 ndmfv necon1ai 3syl domen1 sylan9bb mpbid expr
      domen2 pm2.61dane ) ADEZFZBCFZGZADHZBDHZIZABJKZLVHMVGVHMNZGZVKVJVMAMBJVGV
      LAMNZVEVLVNOVFAUAUBUCVFMBJKVEVLBCUDUEUFUGVGVHMPZVJVKVGVOVJGZGZVHVIJKZVKVI
      QFVQVJVRBDUHVGVOVJUIZVHVIQUJUKVQVHATKZVIBTKZVRVKOVEVTVFVPARULVQVIMPZBVDFZ
      WAVQVJVOWBVSVGVOVJUMVHVIUNSWCVIMBDUOUPBRUQVTVRAVIJKWAVKVHAVIURVIBAVBUSSUT
      VAVC $.
  $}

  ${
    $d B x $.
    $( A set strictly dominates if its cardinal strictly dominates.
       (Contributed by Mario Carneiro, 13-Jan-2013.) $)
    sdomsdomcardi $p |- ( A ~< ( card ` B ) -> A ~< B ) $=
      ( ccrd cfv csdm wbr cen cdm wn c0 sdom0 ndmfv breq2d mtbiri con4i cardid2
      wcel syl sdomentr mpdan ) ABCDZEFZUABGFZABEFUBBCHQZUCUDUBUDIZUBAJEFAKUEUA
      JAEBCLMNOBPRAUABST $.
  $}

  ${
    $d A x $.
    $( An infinite cardinal is a limit ordinal.  Equivalent to Exercise 4 of
       [TakeutiZaring] p. 91.  (Contributed by Mario Carneiro, 13-Jan-2013.) $)
    cardlim $p |- ( om C_ ( card ` A ) <-> Lim ( card ` A ) ) $=
      ( vx com ccrd cfv wss wlim wceq con0 wn wcel wa cen wbr wi wb ex c0 mpbi
      wo cv csuc wrex sseq2 limom limsssuc ax-mp infensuc syl5bir sylan9r breq2
      biimpd adantl sylibrd com3r imp vex sucid mpbiri cardidm syl6eleqr cardne
      eleq2 syl a1i pm2.65d nrexdv peano1 ssel mpi n0i w3o cardon onordi ordzsl
      word 3orass ori 3syl ord mpd limomss impbii ) CADEZFZWDGZWEWDBUAZUBZHZBIU
      CZJWFWEWIBIWEWGIKZLZWIWGWDMNZWEWKWIWMOWKWIWEWMWKWIWEWMOWKWILWEWGWHMNZWMWI
      WECWHFZWKWNWIWEWOWDWHCUDULWOCWGFZWKWNCGWPWOPUECWGUFUGWKWPWNWGUHQUIUJWIWMW
      NPWKWDWHWGMUKUMUNQUOUPWIWMJZOWLWIWGWDDEZKWQWIWGWDWRWIWGWDKWGWHKWGBUQURWDW
      HWGVCUSAUTVAWGWDVBVDVEVFVGWEWJWFWERWDKZWDRHZJWJWFTZWERCKWSVHCWDRVIVJWDRVK
      WTXAWTWJWFVLZWTXATWDVPXBWDAVMVNBWDVOSWTWJWFVQSVRVSVTWAWDWBWC $.
  $}

  ${
    $d B x $.
    $( A cardinal strictly dominates its members.  Equivalent to Proposition
       10.37 of [TakeutiZaring] p. 93.  This is half of the assertion
       ~ cardsdomel and can be proven without the AC. (Contributed by Mario
       Carneiro, 15-Jan-2013.) $)
    cardsdomelir $p |- ( A e. ( card ` B ) -> A ~< B ) $=
      ( ccrd cfv wcel cdom wbr cen wn csdm con0 wss cardon onelssi ssdomg mpsyl
      cdm elfvdm cardid2 syl domentr syl2anc cardne brsdom sylanbrc ) ABCDZEZAB
      FGZABHGIABJGUGAUFFGZUFBHGZUHUFKEUGAUFLUIBMZUFAUKNAUFKOPUGBCQEUJABCRBSTAUF
      BUAUBABUCABUDUE $.
  $}

  $( A cardinal strictly dominates its members.  Equivalent to Proposition
     10.37 of [TakeutiZaring] p. 93.  (Contributed by Mario Carneiro,
     15-Jan-2013.)  (Revised by Mario Carneiro, 4-Jun-2015.) $)
  cardsdomel $p |- ( ( A e. On /\ B e. dom card ) ->
      ( A ~< B <-> A e. ( card ` B ) ) ) $=
    ( con0 wcel ccrd cdm wa csdm wbr cfv cen cardid2 ensymd sdomentr sylan2 wss
    wi wn wb mpan cdom ssdomg cardon domtriord sylibd con2d ontri1 con2bid syl5
    sylibrd exp3acom23 imp cardsdomelir impbid1 ) ACDZBEFDZGABHIZABEJZDZUOUPUQU
    SQUOUQUPUSUQUPGAURHIZUOUSUPUQBURKIUTUPURBBLMABURNOUOUTURAPZRUSUOVAUTUOVAURA
    UAIZUTRZURACUBURCDZUOVBVCSBUCZURAUDTUEUFUOVAUSVDUOVAUSRSVEURAUGTUHUJUIUKULA
    BUMUN $.

  ${
    $d A x $.
    $( Two ways to express the property of being a cardinal number.
       (Contributed by Mario Carneiro, 15-Jan-2013.) $)
    iscard $p |- ( ( card ` A ) = A <-> ( A e. On /\ A. x e. A x ~< A ) ) $=
      ( ccrd cfv wceq con0 wcel cv csdm wbr wral cardon eleq1 mpbii wb cardonle
      wss eqss baibr syl wa cdm onelon onenon cardsdomel syl2anc ralbidva dfss3
      adantr syl6rbbr bitr3d biadan2 ) BCDZBEZBFGZAHZBIJZABKZUNUMFGUOBLUMBFMNUO
      BUMQZUNURUOUMBQZUSUNOBPUNUTUSUMBRSTUOURUPUMGZABKUSUOUQVAABUOUPBGZUAUPFGBC
      UBGZUQVAOBUPUCUOVCVBBUDUIUPBUEUFUGABUMUHUJUKUL $.
  $}

  ${
    $d A x y $.
    $( Two ways to express the property of being a cardinal number.  Definition
       8 of [Suppes] p. 225.  (Contributed by Mario Carneiro, 15-Jan-2013.) $)
    iscard2 $p |- ( ( card ` A ) = A <->
                  ( A e. On /\ A. x e. On ( A ~~ x -> A C_ x ) ) ) $=
      ( vy ccrd cfv wceq con0 wcel cv cen wbr wss wi wral cardon eleq1 mpbii wa
      crab bitri cint cardonle biantrurd eqss syl6rbbr sseq2d bitrd ssint breq1
      oncardval elrab ensymb anbi2i imbi1i impexp ralbii2 syl6bb biadan2 ) BDEZ
      BFZBGHZBAIZJKZBVBLZMZAGNZUTUSGHVABOUSBGPQVAUTBCIZBJKZCGSZUAZLZVFVAUTBUSLZ
      VKVAVLUSBLZVLRUTVAVMVLBUBUCUSBUDUEVAUSVJBCBUJUFUGVKVDAVINVFABVIUHVDVEAVIG
      VBVIHZVDMVBGHZVCRZVDMVOVEMVNVPVDVNVOVBBJKZRVPVHVQCVBGVGVBBJUIUKVQVCVOVBBU
      LUMTUNVOVCVDUOTUPTUQUR $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Two numerable sets have the dominance relationship iff their
       cardinalities have the subset relationship.  See also ~ carddom , which
       uses AC. (Contributed by Mario Carneiro, 11-Jan-2013.)  (Revised by
       Mario Carneiro, 29-Apr-2015.) $)
    carddom2 $p |- ( ( A e. dom card /\ B e. dom card ) ->
                     ( ( card ` A ) C_ ( card ` B ) <-> A ~<_ B ) ) $=
      ( ccrd cdm wcel cfv wss cdom wbr carddomi2 csdm cen brdom2 cardon onelssi
      wa wo wn wi con0 ancoms domnsym syl56 con2d ontri1 mp2an syl6ibr carden2b
      wb wceq eqimss syl a1i jaod syl5bi impbid ) ACDZEZBUQEZPZACFZBCFZGZABHIZA
      BUQJVDABKIZABLIZQUTVCABMUTVEVCVFUTVEVBVAEZRZVCUTVGVEVGVBVAGZUTBAHIZVERVAV
      BANZOUSURVIVJSBAUQJUABAUBUCUDVATEVBTEVCVHUIVKBNVAVBUEUFUGVFVCSUTVFVAVBUJV
      CABUHVAVBUKULUMUNUOUP $.
  $}

  ${
    $d A x y z $.  $d V y $.
    $( The class of ordinal numbers dominated by a set is a cardinal number.
       Theorem 59 of [Suppes] p. 228.  (Contributed by Mario Carneiro,
       20-Jan-2013.)  (Revised by Mario Carneiro, 15-May-2015.) $)
    harcard $p |- ( card ` ( har ` A ) ) = ( har ` A ) $=
      ( vx vy char cfv ccrd wceq con0 wcel cv cen wbr wss wral cdom syl2anc cvv
      wi wa ex harcl harndom wn simpll simpr elharval simpld ontri1 simpllr vex
      sylib ssdomg ax-mp simprd domtr syl2anr endomtr sylbird mt3i rgen iscard2
      wb ssrdv mpbir2an ) ADEZFEVEGVEHIVEBJZKLZVEVFMZRZBHNAUAVIBHVFHIZVGVHVJVGS
      ZCVEVFVKCJZVEIZVLVFIZVKVMSZVNVEAOLZAUBVOVNUCZVFVLMZVPVOVJVLHIZVRVQVBVJVGV
      MUDVOVSVLAOLZVOVMVSVTSVKVMUEAVLUFUKZUGVFVLUHPVOVRVPVOVRSVGVFAOLZVPVJVGVMV
      RUIVRVFVLOLZVTWBVOVLQIVRWCRCUJVFVLQULUMVOVSVTWAUNVFVLAUOUPVEVFAUQPTURUSTV
      CTUTBVEVAVD $.
  $}

  ${
    $d A w y z $.  $d A x y z $.
    cardprclem.1 $e |- A = { x | ( card ` x ) = x } $.
    $( Lemma for ~ cardprc .  (Contributed by Mario Carneiro, 22-Jan-2013.)
       (Revised by Mario Carneiro, 15-May-2015.) $)
    cardprclem $p |- -. A e. _V $=
      ( vy vz vw cvv wcel char cfv wa con0 cdom wbr ccrd wceq ssriv domrefg syl
      cv cuni wss csdm wral cab eleq2i abid iscard simplbi ssonuni mpi elharval
      3bitri sylanbrc sseli ancli sylibr harcard fvex fveq2 eqeq12d elab2 mpbir
      wex id eleq2 eleq1 anbi12d spcev sylancl eluni sselii jctir word wn eloni
      ordn2lp 3syl pm2.65i ) BGHZBUAZWAIJZHZWBWAHZKZVTWCWDVTWALHZWAWAMNZWCVTBLU
      BWFABLATZBHZWHLHZDTWHUCNDWHUDZWIWHWHOJZWHPZAUEZHWMWJWKKBWNWHCUFWMAUGDWHUH
      UMUIQZBGUJUKZVTWFWGWPWALRSWAWAULUNBWAWBEBWAETZBHZWQFTZHZWSBHZKZFVDZWQWAHW
      RWQWQIJZHZXDBHZXCWRWQLHZXEBLWQWOUOXGXGWQWQMNZKXEXGXHWQLRUPWQWQULUQSXFXDOJ
      ZXDPZWQURWMXJAXDBWQIUSZWHXDPZWLXIWHXDWHXDOUTXLVEVACVBVCXBXEXFKFXDXKWSXDPW
      TXEXAXFWSXDWQVFWSXDBVGVHVIVJFWQBVKUQQWBBHWBOJZWBPZWAURWMXNAWBBWAIUSWHWBPZ
      WLXMWHWBWHWBOUTXOVEVACVBVCVLVMVTWFWAVNWEVOWPWAVPWAWBVQVRVS $.
  $}

  ${
    $d x y $.
    $( The class of all cardinal numbers is not a set (i.e. is a proper
       class).  Theorem 19.8 of [Eisenberg] p. 310.  In this proof (which does
       not use AC), we cannot use Cantor's construction ~ canth3 to ensure that
       there is always a cardinal larger than a given cardinal, but we can use
       Hartogs' construction ~ hartogs to construct (effectively)
       ` ( aleph `` suc A ) ` from ` ( aleph `` A ) ` , which achieves the same
       thing.  (Contributed by Mario Carneiro, 22-Jan-2013.) $)
    cardprc $p |- { x | ( card ` x ) = x } e/ _V $=
      ( vy cv ccrd cfv wceq cab cvv weq fveq2 eqeq12d cbvabv cardprclem nelir
      id ) ACZDEZPFZAGZHBSRBCZDEZTFABABIZQUAPTPTDJUBOKLMN $.
  $}

  ${
    $d A x y $.  $d B y $.
    $( The union of a set of cardinals is a cardinal.  Theorem 18.14 of [Monk1]
       p. 133.  (Contributed by Mario Carneiro, 20-Jan-2013.) $)
    carduni $p |- ( A e. V ->
                  ( A. x e. A ( card ` x ) = x -> ( card ` U. A ) = U. A ) ) $=
      ( vy wcel cv ccrd cfv wceq wa wss con0 id cardon syl5 imp syl wi onenon
      wb wral wn fveq2 eqeq12d rspcv eleq1 mpbii syl6com ssrdv ssonuni cardonle
      cuni onirri wex eluni cdom elssuni ssdomg adantl ax-mp syl6eqelr carddom2
      wbr syl2an sylibrd sseq1 adantr sylibd ssel syl6 com3r syld com4r exlimiv
      cdm sylbi com13 sylancom mtoi word onordi eloni ordtri4 sylancr mpbir2and
      ex ) BCEZAFZGHZWHIZABUAZBULZGHZWLIZWGWKJZWNWMWLKZWMWLEZUBZWOWLLEZWPWGWKWS
      WKBLKWGWSWKDBLDFZBEZWKWTGHZWTIZWTLEZWJXCAWTBWHWTIZWIXBWHWTWHWTGUCXEMUDUEZ
      XCXBLEZXDWTNZXBWTLUFUGUHUIBCUJOPZWLUKQWOWQWMWMEZWMWLNZUMWGWKWSWQXJRZXIWSW
      KXLWQWKWSXJWQWMWTEZXAJZDUNWKWSXJRRZDWMBUOXNXODXMXAXOXAWKWSXMXJXAWKXCWSXMX
      JRZRXFXCWSXAXPXCWSXAXPRXCWSJZXAWTWMKZXPXQXAXBWMKZXRXQXAWTWLUPVCZXSXAWTWLK
      ZXQXTWTBUQWSYAXTRXCWTWLLURUSOXCWTGVOZEWLYBEXSXTTWSXCWTXBYBXCMXGXBYBEXHXBS
      UTVAWLSWTWLVBVDVEXCXSXRTWSXBWTWMVFVGVHWTWMWMVIVJWFVKVLVMPVNVPVQPVRVSWOWMV
      TWLVTZWNWPWRJTWMXKWAWOWSYCXIWLWBQWMWLWCWDWEWF $.
  $}

  ${
    $d x y z A $.  $d y z B $.
    $( The indexed union of a set of cardinals is a cardinal.  (Contributed by
       NM, 3-Nov-2003.) $)
    cardiun $p |- ( A e. V -> ( A. x e. A ( card ` B ) = B ->
                  ( card ` U_ x e. A B ) = U_ x e. A B ) ) $=
      ( vz vy wcel ccrd cfv wceq wral ciun wa cv wrex cab cuni cvv abrexexg vex
      eqeq1 rexbidv elab cardidm fveq2 3eqtr4a rexlimivw rgen carduni ee10 fvex
      id sylbi dfiun2 fveq2i 3eqtr4g adantr iuneq2 adantl fveq2d 3eqtr3d ex ) B
      DGZCHIZCJABKZABCLZHIZVFJVCVEMZABVDLZHIZVIVGVFVCVJVIJVEVCENZVDJZABOZEPZQZH
      IZVOVJVIVCVNRGFNZHIZVQJZFVNKVPVOJAEBVDDSVSFVNVQVNGVQVDJZABOZVSVMWAEVQFTVK
      VQJVLVTABVKVQVDUAUBUCVTVSABVTVDHIVDVRVQCUDVQVDHUEVTULUFUGUMUHFVNRUIUJVIVO
      HAEBVDCHUKUNZUOWBUPUQVHVIVFHVEVIVFJVCABVDCURUSZUTWCVAVB $.
  $}

  $( If ` A ` is equinumerous to a natural number, then that number is its
     cardinal.  (Contributed by Mario Carneiro, 11-Jan-2013.) $)
  cardennn $p |- ( ( A ~~ B /\ B e. om ) -> ( card ` A ) = B ) $=
    ( cen wbr com wcel ccrd cfv carden2b cardnn sylan9eq ) ABCDBEFAGHBGHBABIBJK
    $.

  $( The cardinality of the successor of an infinite ordinal.  (Contributed by
     Mario Carneiro, 11-Jan-2013.) $)
  cardsucinf $p |- ( ( A e. On /\ om C_ A )
         -> ( card ` suc A ) = ( card ` A ) ) $=
    ( con0 wcel com wss ccrd cfv csuc cen wbr wceq infensuc carden2b syl eqcomd
    wa ) ABCDAEPZAFGZAHZFGZQASIJRTKALASMNO $.

  $( The cardinality of the successor of a finite ordinal (natural number).
     This theorem does not hold for infinite ordinals; see ~ cardsucinf .
     (Contributed by NM, 7-Nov-2008.) $)
  cardsucnn $p |- ( A e. om -> ( card ` suc A ) = suc ( card ` A ) ) $=
    ( com wcel csuc ccrd cfv wceq peano2 cardnn syl suceq eqtr4d ) ABCZADZEFZNA
    EFZDZMNBCONGAHNIJMPAGQNGAIPAKJL $.

  $( The set of natural numbers is a cardinal number.  Theorem 18.11 of [Monk1]
     p. 133.  (Contributed by NM, 28-Oct-2003.) $)
  cardom $p |- ( card ` om ) = om $=
    ( com ccrd cfv wcel wceq cen wbr con0 omelon oncardid ax-mp csdm wn sdomnen
    nnsdom syl mt2 wss wo cardonle cardon onsseli mpbi mtp-or ) ABCZADZUEAEZUFU
    EAFGZAHDZUHIAJKUFUEALGUHMUEOUEANPQUEARZUFUGSUIUJIATKUEAAUAIUBUCUD $.

  $( Two numerable sets are equinumerous iff their cardinal numbers are equal.
     Unlike ~ carden , the Axiom of Choice is not required.  (Contributed by
     Mario Carneiro, 22-Sep-2013.) $)
  carden2 $p |- ( ( A e. dom card /\ B e. dom card ) ->
               ( ( card ` A ) = ( card ` B ) <-> A ~~ B ) ) $=
    ( ccrd cdm wcel wa cfv wss cdom wbr wceq cen carddom2 ancoms anbi12d bicomi
    wb eqss sbthb 3bitr3g ) ACDZEZBUAEZFZACGZBCGZHZUFUEHZFZABIJZBAIJZFUEUFKZABL
    JUDUGUJUHUKABMUCUBUHUKQBAMNOULUIUEUFRPABST $.

  $( A numerable set is strictly dominated by another iff their cardinalities
     are strictly ordered.  (Contributed by Stefan O'Rear, 30-Oct-2014.)
     (Revised by Mario Carneiro, 29-Apr-2015.) $)
  cardsdom2 $p |- ( ( A e. dom card /\ B e. dom card ) ->
    ( ( card ` A ) e. ( card ` B ) <-> A ~< B ) ) $=
    ( ccrd cdm wcel wa cfv wss wne cdom wbr wn csdm carddom2 carden2 necon3abid
    cen anbi12d con0 cardon wb onelpss mp2an brsdom 3bitr4g ) ACDZEBUFEFZACGZBC
    GZHZUHUIIZFZABJKZABQKZLZFUHUIEZABMKUGUJUMUKUOABNUGUNUHUIABOPRUHSEUISEUPULUA
    ATBTUHUIUBUCABUDUE $.

  $( Trichotomy of dominance for numerable sets (does not use AC).
     (Contributed by Mario Carneiro, 29-Apr-2015.) $)
  domtri2 $p |- ( ( A e. dom card /\ B e. dom card ) ->
    ( A ~<_ B <-> -. B ~< A ) ) $=
    ( ccrd cdm wcel wa cfv wss cdom wbr csdm wn carddom2 wb cardon ontri1 mp2an
    con0 cardsdom2 ancoms notbid syl5bb bitr3d ) ACDZEZBUDEZFZACGZBCGZHZABIJBAK
    JZLZABMUJUIUHEZLZUGULUHREUIREUJUNNAOBOUHUIPQUGUMUKUFUEUMUKNBASTUAUBUC $.

  $( Strict dominance and elementhood are the same for finite ordinals.
     (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
  nnsdomel $p |- ( ( A e. om /\ B e. om ) -> ( A e. B <-> A ~< B ) ) $=
    ( com wcel ccrd cfv csdm wbr wceq cardnn eleq12 syl2an cdm con0 nnon onenon
    wa wb syl cardsdom2 bitr3d ) ACDZBCDZQAEFZBEFZDZABDZABGHZUBUDAIUEBIUFUGRUCA
    JBJUDAUEBKLUBAEMZDZBUIDZUFUHRUCUBANDUJAOAPSUCBNDUKBOBPSABTLUA $.

  ${
    $d x A $.
    $( An alternate version of the value of the cardinal number of a set.
       Compare ~ cardval .  This theorem could be used to give us a simpler
       definition of ` card ` in place of ~ df-card .  It apparently does not
       occur in the literature.  (Contributed by NM, 7-Nov-2003.) $)
    cardval2 $p |- ( A e. dom card -> ( card ` A ) = { x e. On | x ~< A } ) $=
      ( ccrd cdm wcel cfv cv con0 csdm wbr wa cab wb cardsdomel ancoms pm5.32da
      crab cardon oneli pm4.71ri syl6rbbr abbi2dv df-rab syl6eqr ) BCDEZBCFZAGZ
      HEZUGBIJZKZALUIAHQUEUJAUFUEUJUHUGUFEZKUKUEUHUIUKUHUEUIUKMUGBNOPUKUHUFUGBR
      STUAUBUIAHUCUD $.
  $}

  ${
    $d A c f a $.  $d B c f a $.
    $( An infinite set contains subsets equinumerous to every finite set.
       Extension of ~ isinf from finite ordinals to all finite sets.
       (Contributed by Stefan O'Rear, 8-Oct-2014.) $)
    isinffi $p |- ( ( -. A e. Fin /\ B e. Fin ) -> E. f f : B -1-1-> A ) $=
      ( vc va cfn wcel wn wa cv wss ccrd cfv cen wbr wf1 wex com wral syl2anc
      ficardom isinf wceq anbi2d exbidv rspcva syl2anr simprr ficardid ad2antlr
      breq2 wf1o entr ensymd bren sylib f1of1 adantl simplrl f1ss ex eximdv mpd
      exlimddv ) AFGHZBFGZIZDJZAKZVHBLMZNOZIZBACJZPZCQZDVFVJRGVIVHEJZNOZIZDQZER
      SVLDQZVEBUADAEUBVSVTEVJRVPVJUCZVRVLDWAVQVKVIVPVJVHNUKUDUEUFUGVGVLIZBVHVMU
      LZCQZVOWBBVHNOWDWBVHBWBVKVJBNOZVHBNOVGVIVKUHVFWEVEVLBUIUJVHVJBUMTUNBVHCUO
      UPWBWCVNCWBWCVNWBWCIBVHVMPZVIVNWCWFWBBVHVMUQURVGVIVKWCUSBVHAVMUTTVAVBVCVD
      $.

    $( Trichotomy of dominance without AC when one set is finite.  (Contributed
       by Stefan O'Rear, 30-Oct-2014.)  (Revised by Mario Carneiro,
       27-Apr-2015.) $)
    fidomtri $p |- ( ( A e. Fin /\ B e. V ) -> ( A ~<_ B <-> -. B ~< A ) ) $=
      ( va cfn wcel wa cdom wbr csdm wn domnsym wi cdm wb finnum adantr domtri2
      ccrd syl2an biimprd wf1 wex isinffi ancoms adantlr brdomg ad2antlr mpbird
      cv a1d pm2.61dan impbid2 ) AEFZBCFZGZABHIZBAJIKZABLUPBEFZURUQMUPUSGUQURUP
      ASNZFZBUTFUQUROUSUNVAUOAPQBPABRTUAUPUSKZGZUQURVCUQABDUJUBDUCZUNVBVDUOVBUN
      VDBADUDUEUFUOUQVDOUNVBABCDUGUHUIUKULUM $.

    $( Trichotomy of dominance without AC when one set is finite.  (Contributed
       by Stefan O'Rear, 30-Oct-2014.)  (Revised by Mario Carneiro,
       7-May-2015.) $)
    fidomtri2 $p |- ( ( A e. V /\ B e. Fin ) -> ( A ~<_ B <-> -. B ~< A ) ) $=
      ( wcel cfn wa cdom wbr csdm wn domnsym cen sdomdom con3i fidomtri syl5ibr
      wb ancoms wi ensym endom syl a1i jcad brsdom syl6ibr con1d impbid2 ) ACDZ
      BEDZFZABGHZBAIHZJABKUKULUMUKULJZBAGHZBALHZJZFUMUKUNUOUQUNUOUKABIHZJZURULA
      BMNUJUIUOUSQBACORPUNUQSUKUPULUPABLHULBATABUAUBNUCUDBAUEUFUGUH $.
  $}

  $( The Hartogs number of a well-orderable set strictly dominates the set.
     (Contributed by Mario Carneiro, 15-May-2015.) $)
  harsdom $p |- ( A e. dom card -> A ~< ( har ` A ) ) $=
    ( ccrd cdm wcel char cfv csdm cdom wn harndom wb con0 harcl onenon ax-mp wa
    wbr domtri2 con2bid mpan mpbiri ) ABCZDZAAEFZGQZUDAHQZIZAJUDUBDZUCUEUGKUDLD
    UHAMUDNOUHUCPUFUEUDARSTUA $.

  ${
    $d x y A $.
    $( Any well-orderable set is strictly dominated by an ordinal number.
       (Contributed by Jeff Hankins, 22-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 15-May-2015.) $)
    onsdom $p |- ( A e. dom card -> E. x e. On A ~< x ) $=
      ( ccrd cdm wcel char cfv con0 csdm wbr cv wrex harcl harsdom breq2 rspcev
      sylancr ) BCDEBFGZHEBRIJZBAKZIJZAHLBMBNUASARHTRBIOPQ $.

    $( An alternative expression for the Hartogs number of a well-orderable
       set.  (Contributed by Mario Carneiro, 15-May-2015.) $)
    harval2 $p |- ( A e. dom card ->
      ( har ` A ) = |^| { x e. On | A ~< x } ) $=
      ( vy ccrd cdm wcel char cfv cv csdm wbr con0 crab cint wss wral cdom wceq
      wi wa harval adantr domsdomtr sdomel syl5 imp ancoms 3impb rabssdv adantl
      an4s eqsstrd expr ralrimiva ssintrab sylibr harcl a1i harsdom breq2 elrab
      sylanbrc intss1 syl eqssd ) BDEZFZBGHZBAIZJKZALMZNZVGVJVHVIOZSZALPVHVLOVG
      VNALVGVILFZVJVMVGVOVJTZTVHCIZBQKZCLMZVIVGVHVSRVPCVFBUAUBVPVSVIOVGVPVRCLVI
      VPVQLFZVRVQVIFZVTVRTVPWAVTVOVRVJWAVTVOTZVRVJTZWAWCVQVIJKWBWAVQBVIUCVQVIUD
      UEUFUKUGUHUIUJULUMUNVJAVHLUOUPVGVHVKFZVLVHOVGVHLFZBVHJKZWDWEVGBUQURBUSVJW
      FAVHLVIVHBJUTVAVBVHVKVCVDVE $.
  $}

  ${
    $d A x y $.
    $( The smallest ordinal that strictly dominates a set is a cardinal, if it
       exists.  (Contributed by Mario Carneiro, 2-Feb-2013.) $)
    cardmin2 $p |- ( E. x e. On A ~< x <->
                      ( card ` |^| { x e. On | A ~< x } ) =
                               |^| { x e. On | A ~< x } ) $=
      ( vy cv csdm wbr con0 cint ccrd wceq wcel wa cen wn wss sylan sylanb nfcv
      c0 cvv wrex crab cfv wral onintrab2 biimpi cdom adantr word eloni ordelss
      ssdomg sylc onelon nfrab1 nfint nfbr breq2 onminsb sdomentr ssrab2 onnmin
      wi elrab mpan sylbir expcom syl impancom con2d ensym nsyl brsdom sylanbrc
      mpd ralrimiva iscard wne vprc inteq int0 syl6eq eleq1d mtbiri eleq1 mpbii
      fvex necon2ai rabn0 sylib impbii ) BADZEFZAGUAZWMAGUBZHZIUCZWPJZWNWPGKZCD
      ZWPEFZCWPUDWRWNWSWMAUEZUFZWNXACWPWNWTWPKZLZWTWPUGFZWTWPMFZNXAXEWSWTWPOZXF
      WNWSXDXCUHWNWSXDXHXBWSWPUIXDXHWPUJWPWTUKPQWTWPGULUMXEWPWTMFZXGXEWTGKZXINZ
      WNWSXDXJXBWPWTUNQWNXJXDXKWNXJLXIXDWNXIXJXDNZWNXILBWTEFZXJXLVCWNBWPEFZXIXM
      WMXNAABWPEABRAERAWOWMAGUOUPUQWLWPBEURUSBWPWTUTPXJXMXLXJXMLWTWOKZXLWMXMAWT
      GWLWTBEURVDWOGOXOXLWMAGVAWOWTVBVEVFVGVHVIVJVIVOWTWPVKVLWTWPVMVNVPCWPVQVNW
      RWOSVRWNWRWOSWOSJZWPTKZWRXPXQTTKVSXPWPTTXPWPSHTWOSVTWAWBWCWDWRWQTKXQWPIWG
      WQWPTWEWFVLWHWMAGWIWJWK $.
  $}

  ${
    $d x A $.
    $( In Theorem *54.43 of [WhiteheadRussell] p. 360, the number 1 is defined
       as the collection of all sets with cardinality 1 (i.e. all singletons;
       see ~ card1 ), so that their ` A e. 1 ` means, in our notation,
       ` A e. { x | ( card `` x ) = 1o } ` .  Here we show that this is
       equivalent to ` A ~~ 1o ` so that we can use the latter more convenient
       notation in ~ pm54.43 .  (Contributed by NM, 4-Nov-2013.) $)
    pm54.43lem $p |- ( A ~~ 1o <-> A e. { x | ( card ` x ) = 1o } ) $=
      ( c1o cen wbr ccrd cfv wceq cv cab wcel carden2b 1onn cardnn ax-mp syl6eq
      com eqeq2i biimpri c0 cdm wb 1n0 neii eqeq1 mtbiri ndmfv nsyl2 1on onenon
      con0 carden2 sylancl mpbid impbii cvv elex syl fveq2 eqeq1d elab3 bitr4i
      ) BCDEZBFGZCHZBAIZFGZCHZAJKVCVEVCVDCFGZCBCLCQKVICHMCNOZPVEVDVIHZVCVKVEVIC
      VDVJRSVEBFUAZKZCVLKZVKVCUBVEVDTHZVMVEVOCTHCTUCUDVDCTUEUFBFUGUHZCUKKVNUICU
      JOBCULUMUNUOVHVEABVEVMBUPKVPBVLUQURVFBHVGVDCVFBFUSUTVAVB $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Theorem *54.43 of [WhiteheadRussell] p. 360.  "From this proposition it
       will follow, when arithmetical addition has been defined, that 1+1=2."
       See ~ http://en.wikipedia.org/wiki/Principia_Mathematica#Quotations .
       This theorem states that two sets of cardinality 1 are disjoint iff
       their union has cardinality 2.

       Whitehead and Russell define 1 as the collection of all sets with
       cardinality 1 (i.e. all singletons; see ~ card1 ), so that their
       ` A e. 1 ` means, in our notation, ` A e. { x | ( card `` x ) = 1o } `
       which is the same as ` A ~~ 1o ` by ~ pm54.43lem .  We do not have
       several of their earlier lemmas available (which would otherwise be
       unused by our different approach to arithmetic), so our proof is
       longer.  (It is also longer because we must show every detail.)

       Theorem ~ pm110.643 shows the derivation of 1+1=2 for cardinal numbers
       from this theorem.  (Contributed by NM, 4-Apr-2007.) $)
    pm54.43 $p |- ( ( A ~~ 1o /\ B ~~ 1o ) -> ( ( A i^i B ) = (/) <->
                  ( A u. B ) ~~ 2o ) ) $=
      ( vx vy c1o cen wbr wa cin c0 wceq cun c2o csn wi 1on ensn1 wn ex csdm cv
      con0 elexi ensymi entr mpan2 wcel onirri disjsn mpbir mpanr2 sylan2 df-2o
      unen csuc df-suc eqtri breq2i syl6ibr wex en1 wne unidm sneq syl5reqr vex
      uneq2d 1sdom2 ensdomtr mp2an syl6eqbr sdomnen syl necon2ai disjsn2 uneq12
      a1i breq1d ineq12 eqeq1d 3imtr4d exlimdv exlimiv imp syl2anb impbid ) AEF
      GZBEFGZHZABIZJKZABLZMFGZWIWKWLEENZLZFGZWMWHWGBWNFGZWKWPOWHEWNFGWQWNEEEUBP
      UCQUDBEWNUEUFWGWQHZWKWPWRWKEWNIJKZWPWSEEUGREPUHEEUIUJAEBWNUNUKSULMWOWLFME
      UOWOUMEUPUQURUSWGACUAZNZKZCUTZBDUAZNZKZDUTZWMWKOZWHCAVADBVAXCXGXHXBXGXHOC
      XBXFXHDXBXFXHXBXFHZXAXELZMFGZXAXEIZJKZWMWKXKXMOXIXKWTXDVBXMXKWTXDWTXDKZXJ
      MTGXKRXNXJXAMTXNXAXAXALXJXAVCXNXAXEXAWTXDVDVGVEXAEFGEMTGXAMTGWTCVFQVHXAEM
      VIVJVKXJMVLVMVNWTXDVOVMVQXIWLXJMFAXABXEVPVRXIWJXLJAXABXEVSVTWASWBWCWDWEWF
      $.
  $}

  $( Lemma for ~ pr2ne .  (Contributed by FL, 17-Aug-2008.) $)
  pr2nelem $p |- ( ( A e. C /\ B e. D /\ A =/= B ) -> { A , B } ~~ 2o ) $=
    ( wcel wne cpr c2o cen wbr csn cin c0 wceq disjsn2 wi c1o ensn1g wa cun ex
    pm54.43 df-pr breq1i syl6bbr biimpd syl2an syl7 3imp ) ACEZBDEZABFZABGZHIJZ
    ULAKZBKZLMNZUJUKUNABOUJUKUQUNPZUJUOQIJZUPQIJZURUKACRBDRUSUTSZUQUNVAUQUOUPTZ
    HIJUNUOUPUBUMVBHIABUCUDUEUFUGUAUHUI $.

  $( If an unordered pair has two elements they are different.  (Contributed by
     FL, 14-Feb-2010.) $)
  pr2ne $p |- ( ( A e. C /\ B e. D ) -> ( { A , B } ~~ 2o <-> A =/= B ) ) $=
    ( wcel wa cpr c2o cen wbr wne wceq wn wi c1o cvv ax-mp entr ex syl prex a1d
    preq2 eqcoms enpr1g eqeng csdm 1sdom2 sdomnen ensym mtoi com12 a1dd pm2.43a
    com23 imp syl5 necon2ad pr2nelem 3expia impbid ) ACEZBDEZFZABGZHIJZABKZVDVF
    ABABLVEAAGZLZVDVFMZVIBABAAUCUDVIVDVJVBVCVIVDVJNZNVBVIVCVKVBVHOIJZVIVCVKNNAC
    UEVLVIVKVCVIVLVKVIVEVHIJZVLVKNVEPEVIVMNABUAVEVHPUFQVMVLVKVMVLFVEOIJZVKVEVHO
    RVNVJVDVNVFOHIJZOHUGJVOMUHOHUIQVNOVEIJZVFVONVEOUJVPVFVOOVEHRSTUKUBTSTULUMTU
    OUPUNUQURVBVCVGVFABCDUSUTVA $.

  $( An unordered pair has at most two elements.  (Contributed by FL,
     22-Feb-2011.) $)
  prdom2 $p |- ( ( A e. C /\ B e. D ) -> { A , B } ~<_ 2o ) $=
    ( wcel wa cpr c2o cdom wbr wi wceq csn dfsn2 c1o cen ensn1g csdm endom syl
    1sdom2 domsdomtr sdomdom sylancl syl5eqbrr preq2 breq1d syl5ibr adantrd wne
    eqcoms pr2ne biimprd syl6com pm2.61ine ) ACEZBDEZFZABGZHIJZKABABLUPUTUQUPUT
    KBAUPUTBALZAAGZHIJUPVBAMZHIANUPVCOPJZVCHIJZACQVDVCOIJZOHRJZVEVCOSUAVFVGFVCH
    RJVEVCOHUBVCHUCTUDTUEVAUSVBHIBAAUFUGUHUKUIURABUJZUSHPJZUTURVIVHABCDULUMUSHS
    UNUO $.

  $( Building a set with two elements.  (Contributed by FL, 11-Aug-2008.)
     (Revised by Mario Carneiro, 10-Sep-2015.) $)
  en2eqpr $p |- ( ( C ~~ 2o /\ A e. C /\ B e. C )
     -> ( A =/= B -> C = { A , B } ) ) $=
    ( c2o cen wbr wcel w3a wne cpr wceq wa cfn wss com 2onn nnfi simpl1 syl2anc
    ax-mp enfii sylancr simpl2 simpl3 prssi pr2nelem 3expa 3adantl1 ensymd entr
    fisseneq syl3anc eqcomd ex ) CDEFZACGZBCGZHZABIZCABJZKURUSLZUTCVACMGZUTCNZU
    TCEFZUTCKVADMGZUOVBDOGVEPDQTUOUPUQUSRZCDUAUBVAUPUQVCUOUPUQUSUCUOUPUQUSUDABC
    UESVAUTDEFZDCEFVDUPUQUSVGUOUPUQUSVGABCCUFUGUHVACDVFUIUTDCUJSUTCUKULUMUN $.

  ${
    $d A m n $.  $d X m $.
    $( The cardinality of a non-empty finite set is one greater than the
       cardinality of the set with one element removed.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       2-Feb-2013.) $)
    dif1card $p |- ( ( A e. Fin /\ X e. A ) -> ( card ` A ) =
                                      suc ( card ` ( A \ { X } ) ) ) $=
      ( vm cfn wcel ccrd cfv csn csuc wceq cen wbr com cun cin a1i syl 3ad2ant2
      c0 cardennn cdif wi diffi cv wrex isfi wa w3a simp3 en2sn 3adant3 disjdif
      incom eqtri wel wn word ordirr disjsn sylibr unen syl22anc difsnid df-suc
      nnord wb eqcomi breq12d 3ad2ant1 mpbid peano2 syl2anc ancoms suceq eqtr4d
      3adant1 3expib com12 rexlimiva sylbi imp ) ADEZBAEZAFGZABHZUAZFGZIZJZWBWF
      DEZWCWIUBZAWEUCWJWFCUDZKLZCMUEWKCWFUFWMWKCMWCWLMEZWMUGWIWCWNWMWIWCWNWMUHZ
      WDWLIZWHWOAWPKLZWPMEZWDWPJWOWFWENZWLWLHZNZKLZWQWOWMWEWTKLZWFWEOZSJZWLWTOS
      JZXBWCWNWMUIWCWNXCWMBWLAMUJUKXEWOXDWEWFOSWFWEUMWEAULUNPWNWCXFWMWNCCUOUPZX
      FWNWLUQXGWLVEWLURQWLWLUSUTRWFWLWEWTVAVBWCWNXBWQVFWMWCWSAXAWPKABVCXAWPJWCW
      PXAWLVDVGPVHVIVJWNWCWRWMWLVKRAWPTVLWOWGWLJZWHWPJWNWMXHWCWMWNXHWFWLTVMVPWG
      WLVNQVOVQVRVSVTQWA $.
  $}

  ${
    $d a A $.  $d w J $.  $d u w z L $.  $d m z M $.  $d w z ph $.  $d z Q $.
    $d a m u w x y z $.  $d u R $.
    leweon.1 $e |- L = { <. x , y >. |
      ( ( x e. ( On X. On ) /\ y e. ( On X. On ) )
        /\ ( ( 1st ` x ) e. ( 1st ` y ) \/
          ( ( 1st ` x ) = ( 1st ` y ) /\ ( 2nd ` x ) e. ( 2nd ` y ) ) ) ) } $.
    $( Lexicographical order is a well-ordering of ` On X. On ` .  Proposition
       7.56(1) of [TakeutiZaring] p. 54.  Note that unlike ~ r0weon , this
       order is _not_ set-like, as the preimage of ` <. 1o , (/) >. ` is the
       proper class ` ( { (/) } X. On ) ` .  (Contributed by Mario Carneiro,
       9-Mar-2013.) $)
    leweon $p |- L We ( On X. On ) $=
      ( con0 cep wwe epweon cv wcel wa c1st cfv c2nd wo copab fvex epelc anbi2i
      wbr cxp wceq orbi12i opabbii eqtr4i wexp mp2an ) EFGZUHEEUAZCGHHABEEFFCCA
      IZUIJBIZUIJKZUJLMZUKLMZJZUMUNUBZUJNMZUKNMZJZKZOZKZABPULUMUNFTZUPUQURFTZKZ
      OZKZABPDVGVBABVFVAULVCUOVEUTUMUNUKLQRVDUSUPUQURUKNQRSUCSUDUEUFUG $.

    r0weon.1 $e |- R = { <. z , w >. |
      ( ( z e. ( On X. On ) /\ w e. ( On X. On ) ) /\
        ( ( ( 1st ` z ) u. ( 2nd ` z ) ) e. ( ( 1st ` w ) u. ( 2nd ` w ) ) \/
          ( ( ( 1st ` z ) u. ( 2nd ` z ) ) = ( ( 1st ` w ) u. ( 2nd ` w ) ) /\
         z L w ) ) ) } $.
    $( A set-like well-ordering of the class of ordinal pairs.  Proposition
       7.58(1) of [TakeutiZaring] p. 54.  (Contributed by Mario Carneiro,
       7-Mar-2013.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    r0weon $p |- ( R We ( On X. On ) /\ R Se ( On X. On ) ) $=
      ( con0 wa wtru cep c1st cfv c2nd wcel fvex a1i wss syl vu cxp wwe wse cun
      cv cmpt wceq wbr copab weq fveq2 uneq12d eqid unex fvmpt breqan12d syl6bb
      wo epelc eqeqan12d anbi1d orbi12d pm5.32i opabbii eqtr4i word xp1st xp2nd
      wf elon ordun syl2anb syl2anc sylibr fmpti epweon leweon cima cvv cdm crn
      vex dmex rnex cres imadmres ccnv cin crab inss2 cpr ssun1 cop sseli inss1
      wral 1st2nd2 eqeltrrd opeldm sseldi ssun2 opelrn prssi ordunpr rgen ssrab
      sseldd mpbir2an dmres fdmi ineq2i eqtri mptpreima 3sstr4i wb funmpt resss
      wfun dmss ax-mp funimass3 mp2an mpbir eqsstr3i ssexi fnwe epse cuni uniex
      cpw pwex xpex cab df-rab adantr elssuni adantl elpw jca unssad elxp6 fnse
      unssbd sylanbrc abssi eqsstri trud ) IIUBZEUCZUUIEUDZJKUUJUUKKCDUAUUIILFE
      AUUIAUFZMNZUULONZUEZUGZECUFZUUIPZDUFZUUIPZJZUUQMNZUUQONZUEZUUSMNZUUSONZUE
      ZPZUVDUVGUHZUUQUUSFUIZJZUSZJZCDUJUVAUUQUUPNZUUSUUPNZLUIZUVNUVOUHZUVJJZUSZ
      JZCDUJHUVTUVMCDUVAUVSUVLUVAUVPUVHUVRUVKUVAUVPUVDUVGLUIUVHUURUUTUVNUVDUVOU
      VGLAUUQUUOUVDUUIUUPACUKUUMUVBUUNUVCUULUUQMULUULUUQOULUMUUPUNZUVBUVCUUQMQU
      UQOQUOUPZAUUSUUOUVGUUIUUPADUKUUMUVEUUNUVFUULUUSMULUULUUSOULUMUWAUVEUVFUUS
      MQUUSOQUOZUPZUQUVDUVGUWCUTURUVAUVQUVIUVJUURUUTUVNUVDUVOUVGUWBUWDVAVBVCVDV
      EVFZUUIIUUPVJKAUUIIUUOUUPUWAUULUUIPZUUOVGZUUOIPUWFUUMIPZUUNIPZUWGUULIIVHZ
      UULIIVIZUWHUUMVGUUNVGUWGUWIUUMUULMQZVKUUNUULOQZVKUUMUUNVLVMVNUUOUUMUUNUWL
      UWMUOVKVOVPZRZILUCKVQRUUIFUCKABFGVRRUUPUAUFZVSZVTPKUWQUWPWAZUWPWBZUEZUWRU
      WSUWPUAWCZWDUWPUXAWEUOUWQUUPUUPUWPWFZWAZVSZUWTUUPUWPWGUXDUWTSZUXCUUPWHZUW
      TVSZSZUWPUUIWIZUUOUWTPZAUUIWJZUXCUXGUXIUXKSUXIUUISUXJAUXIWQUWPUUIWKZUXJAU
      XIUULUXIPZUUMUUNWLZUWTUUOUXMUUMUWTPUUNUWTPUXNUWTSUXMUWRUWTUUMUWRUWSWMUXMU
      UMUUNWNZUWPPZUUMUWRPUXMUULUXOUWPUXMUWFUULUXOUHZUXIUUIUULUXLWOZUULIIWRZTUX
      IUWPUULUWPUUIWPWOWSZUUMUUNUWPUWLUWMWTTXAUXMUWSUWTUUNUWSUWRXBUXMUXPUUNUWSP
      UXTUUMUUNUWPUWLUWMXCTXAUUMUUNUWTXDVNUXMUWHUWIUUOUXNPUXMUWFUWHUXRUWJTUXMUW
      FUWIUXRUWKTUUMUUNXEVNXHXFUXJAUUIUXIXGXIUXCUWPUUPWAZWIUXIUUPUWPXJUYAUUIUWP
      UUIIUUPUWNXKXLXMAUUIUUOUWTUUPUWAXNXOUUPXSUXCUYASZUXEUXHXPAUUIUUOXQUXBUUPS
      UYBUUPUWPXRUXBUUPXTYAUXCUWTUUPYBYCYDYEYFRYGKCDUAUUIILFEUUPUWEUWOILUDKIYHR
      UXFUWPVSZVTPKUYCUWPYIZYKZUYEUBZUYEUYEUYDUWPUXAYJYLZUYGYMUYCUWFUUOUWPPZJZA
      YNZUYFUYCUYHAUUIWJUYJAUUIUUOUWPUUPUWAXNUYHAUUIYOXMUYIAUYFUYIUXQUUMUYEPZUU
      NUYEPZJUULUYFPUWFUXQUYHUXSYPUYIUYKUYLUYIUUMUYDSUYKUYIUUMUUNUYDUYHUUOUYDSU
      WFUUOUWPYQYRZUUAUUMUYDUWLYSVOUYIUUNUYDSUYLUYIUUMUUNUYDUYMUUDUUNUYDUWMYSVO
      YTUULUYEUYEUUBUUEUUFUUGYFRUUCYTUUH $.

    infxpen.1 $e |- Q = ( R i^i ( ( a X. a ) X. ( a X. a ) ) ) $.
    infxpen.2 $e |- ( ph <-> ( ( a e. On /\
        A. m e. a ( om C_ m -> ( m X. m ) ~~ m ) ) /\
      ( om C_ a /\ A. m e. a m ~< a ) ) ) $.
    infxpen.3 $e |- M = ( ( 1st ` w ) u. ( 2nd ` w ) ) $.
    infxpen.4 $e |- J = OrdIso ( Q , ( a X. a ) ) $.
    $( Lemma for ~ infxpen .  (Contributed by Mario Carneiro, 9-Mar-2013.)
       (Revised by Mario Carneiro, 26-Jun-2015.) $)
    infxpenlem $p |- ( ( A e. On /\ om C_ A ) -> ( A X. A ) ~~ A ) $=
      ( wcel con0 com wss cxp cen wbr cv wi wceq sseq2 xpeq12 anidms id breq12d
      imbi12d wral wa csdm cdom ccnv crn cdm wf1 wf1o cep wiso cvv wwe vex xpex
      cin simpll sylbi onss syl xpss12 syl2anc wse r0weon simpli sylib wb ax-mp
      sylibr sylancr 4syl f1oen 3syl cfv ccrd csn cima adantr eqeltri fvex word
      csuc c1st c2nd cun unex simprbi simplbi 3adant3 onelon sylan2 syl2im sylc
      elxp7 wlim simprr simprl sylbir mpbid a1i ontr2 imp syl22anc ssdomg mpsyl
      wo cfn syl2an expcom rspccv omelon ontri1 simplr ensdomtr pm2.61d endomtr
      wn c0 nnsdom expr wrex entr sylan ex mpd weinxp weeq1 oiiso isof1o f1ocnv
      wess ee10 f1of1 f1f1orn wfn f1ofn cres cnvimass inss2 eqsstri dmss dmxpid
      sseqtri sstri f1ores sylancl inex2 cnvex imaexg sseqin2 mpbi isocnv simpr
      imaeq2i isoini epini ineq2i oicl wf f1of ffvelrnda ordelss syl5eq syl5eqr
      dfss1 eqtrd breqtrd ensymd sucex w3a xpss simp3 eliniseg breqi brin bitri
      brxp sseldi xp1st eloni ordunel 3expib iscard cardlim limeq bibi12d mpbii
      syl5eqel biimpa syl21anc limsuc ssun1 cop copab df-br eleq2i opabid simpl
      3bitri orim2i elsuc suceq syl6eleqr xp2nd ssun2 biimpri 3expia ssrdv nnfi
      syl12anc xpfi isfinite sdomdomtr sylbird sylsyld domsdomtr ordelon onenon
      breq1 cardsdomel eleq2 ralrimiva fnfvrnss c1o df1o2 1onn eqeltrri sdomdom
      mp2b domtr xpsnen ensymi xpdom2 ad2antrl sbth rexnal onelss syld simplbi2
      0ex bren2 syl6 reximdvai syl5bir r19.29 domentr domnsym nsyl mpan syl5ibr
      ensym exp3a impcom imim1d imp32 ancoms xpen ad2antll rexlimdv exp31 tfis3
      syldan ) FUATUBFUCZFFUDZFUEUFZUBMUGZUCZVWAVWAUDZVWAUEUFZUHUBIUGZUCZVWEVWE
      UDZVWEUEUFZUHZVVRVVTUHMIFVWAVWEUIZVWBVWFVWDVWHVWAVWEUBUJVWJVWCVWGVWAVWEUE
      VWJVWCVWGUIVWAVWEVWAVWEUKULVWJUMUNUOVWAFUIZVWBVVRVWDVVTVWAFUBUJVWKVWCVVSV
      WAFUEVWKVWCVVSUIVWAFVWAFUKULVWKUMUNUOVWAUATZVWIIVWAUPZVWBVWDVWLVWMUQZVWBU
      QVWEVWAURUFZIVWAUPZVWDVWNVWBVWPVWDVWNVWBVWPUQZUQZVWCVWAUSUFZVWAVWCUSUFZVW
      DVWRAVWSQAVWCJUTZVAZUEUFZVXBVWAUSUFZVWSAVWCJVBZVXAVCZVWCVXBVXAVDVXCAVXEVW
      CVEGJVFZVXEVWCJVDZVWCVXEVXAVDZVXFAVWCVGTVWCGVHZVXGVWAVWAMVIZVXKVJZAVWCHVW
      CVWCUDZVKZVHZVXJAVWCHVHZVXOAVWCUAUAUDZUCZVXQHVHZVXPAVWAUAUCZVXTVXRAVWLVXT
      AVWRVWLQVWLVWMVWQVLVMZVWAVNVOZVYBVWAUAVWAUAVPVQVXSVXQHVRBCDEHKNOVSVTVWCVX
      QHUUFUUGVWCHUUAWAGVXNUIVXJVXOWBPVWCGVXNUUBWCWDVWCGJVGSUUCWEZVXEVWCVEGJUUD
      ZVXEVWCJUUEZVWCVXEVXAUUHZWFVWCVXEVXAUUIVWCVXBVXAVXLWGWHAVXAVWCUUJZEUGZVXA
      WIZVWATZEVWCUPZVXDAVXGVXHVXIVYGVYCVYDVYEVWCVXEVXAUUKWFAVYJEVWCAVYHVWCTZUQ
      ZVYIVWAWJWIZTZVYJVYMVYIVWAURUFZVYOVYMVYIGUTZVYHWKZWLZUEUFVYSVWAURUFZVYPVY
      MVYSVYIVYMVYSVXAVYSWLZVYIUEVYMVXGVYSWUAVXAVYSUULZVDZVYSWUAUEUFAVXGVYLVYCW
      MZVXGVXFVYSVWCUCZWUCVXGVXHVXIVXFVYDVYEVYFWHVYSGVBZVWCGVYRUUMWUFVXMVBZVWCG
      VXMUCWUFWUGUCGVXNVXMPHVXMUUNUUOGVXMUUPWCVWCUUQUURUUSZVWCVXEVYSVXAUUTUVAVY
      SWUAWUBVYQVGTVYSVGTGGVXNVGPVXMHVWCVWCVXLVXLVJUVBWNUVCVYQVYRVGUVDWCWGWHVYM
      WUAVXAVWCVYSVKZWLZVYIWUIVYSVXAWUEWUIVYSUIWUHVYSVWCUVEUVFUVIVYMWUJVXEVEUTV
      YIWKWLZVKZVYIVYMVWCVXEGVEVXAVFZVYLWUJWULUIVYMVXGWUMWUDVXEVWCVEGJUVGVOAVYL
      UVHZVWCVXEVYHGVEVXAUVJVQVYMWULVXEVYIVKZVYIWUKVYIVXEVYIVYHVXAWOUVKUVLVYMVY
      IVXEUCZWUOVYIUIVYMVXEWPZVYIVXETZWUPVWCGJSUVMZAVWCVXEVYHVXAAVXGVXHVXIVWCVX
      EVXAUVNVYCVYDVYEVWCVXEVXAUVOWFUVPZVXEVYIUVQWEVYIVXEUVTWAUVRUWAUVSUWBUWCVY
      MVYSLWQZWVAUDZUSUFZWVBVWAURUFZVYTWVBVGTVYMVYSWVBUCWVCWVAWVALLVYHWRWIZVYHW
      SWIZWTZVGRWVEWVFVYHWRWOVYHWSWOXAWNUWDZWVHVJVYMDVYSWVBAVYLDUGZVYSTZWVIWVBT
      ZAVYLWVJUWEZWVIVGVGUDZTZWVIWRWIZWVATZWVIWSWIZWVATZWVKWVLVWCWVMWVIVWAVWAUW
      FWVLWVIVYHGUFZWVIVYHVXMUFZWVIVWCTZWVLWVJWVSAVYLWVJUWGVYHVGTWVJWVSWBEVIGVY
      HWVIVGDVIUWHWCWAZWVSWVIVYHHUFZWVTWVSWVIVYHVXNUFWWCWVTUQWVIVYHGVXNPUWIWVIV
      YHHVXMUWJUWKZXBWVTWWAVYLWVIVYHVWCVWCUWLXCWHZUWMWVLWVOUATZWVAUATZWVOWVOWVQ
      WTZUCZWWHWVATZWVPWVLVWLWWAWWFAVYLVWLWVJAVWLVYLVYAWMZXDZWWEWWAVWLWVOVWATWW
      FWVIVWAVWAUWNVWAWVOXEXFVQAVYLWWGWVJVYMVWLWVAVWATZWWGWWKVYMLVWATZWWMVYMLWV
      GVWARVYMVWLVYLWVGVWATZWWKWUNVWLVWAWPZVYLWVEVWATZWVFVWATZUQZWWOVWAUWOVYLVY
      HWVMTWWSVYHVWAVWAXIXBWWPWWQWWRWWOVWAWVEWVFUWPUWQXGXHUXCVYMVWAXJZWWNWWMWBA
      WWTVYLAVWLVWPVWBWWTVYAAVWRVWPQVWNVWBVWPXKVMZAVWRVWBQVWNVWBVWPXLVMZVWLVWPU
      QZVWBWWTWXCVYNVWAUIZVWBWWTWBZIVWAUWRZWXDUBVYNUCZVYNXJZWBWXEVWAUWSWXDWXGVW
      BWXHWWTVYNVWAUBUJVYNVWAUWTUXAUXBXMUXDUXEWMVWALUXFVOXNZVWAWVAXEVQZXDZWWIWV
      LWVOWVQUXGXOWVLWVSWWCWWJWWBWVSWWCWVTWWDXCWWCWWHWVGWQZWVAWWCWWHWVGTZWWHWVG
      UIZYAZWWHWXLTWWCWXMWXNWVIVYHKUFZUQZYAZWXOWWCWVIVXQTVYHVXQTUQZWXRWWCWVIVYH
      UXHZHTWXTWXSWXRUQZDEUXIZTWYAWVIVYHHUXJHWYBWXTOUXKWYADEUXLUXNXBWXQWXNWXMWX
      NWXPUXMUXOVOWWHWVGWVOWVQWVIWRWOWVIWSWOXAUXPWDLWVGUIWVAWXLUIRLWVGUXQWCUXRW
      HZWWFWWGUQWWIWWJUQWVPWVOWWHWVAXPXQXRWVLWVQUATZWWGWVQWWHUCZWWJWVRWVLVWLWWA
      WYDWWLWWEWWAVWLWVQVWATWYDWVIVWAVWAUXSVWAWVQXEXFVQWXKWYEWVLWVQWVOUXTXOWYCW
      YDWWGUQWYEWWJUQWVRWVQWWHWVAXPXQXRWVKWVNWVPWVRUQUQWVIWVAWVAXIUYAUYEUYBUYCV
      YSWVBVGXSXTVYMWVAUBTZWVDVYMVWBWYFWVDUHAVWBVYLWXBWMWYFVWBWVDWYFWVBUBURUFZU
      BVWAUSUFZWVDVWBWYFWVAYBTZWYGWVAUYDWYIWVBYBTZWYGWYIWYJWVAWVAUYFULWVBUYGWAV
      OVWAVGTZVWBWYHUHVXKUBVWAVGXSWCZWVBUBVWAUYHYCYDVOVYMWVAVWAURUFZWYFYLZWVBWV
      AUEUFZWVDVYMVWPWWMWYMAVWPVYLWXAWMZWXIVWOWYMIWVAVWAVWEWVAVWAURUYNYEXHVYMWY
      NUBWVAUCZWYOVYMUBUATZWWGWYQWYNWBYFWXJUBWVAYGWEVYMVWMWWMWYQWYOUHZAVWMVYLAV
      WRVWMQVWLVWMVWQYHVMWMWXIVWIWYSIWVAVWAVWEWVAUIZVWFWYQVWHWYOVWEWVAUBUJWYTVW
      GWVBVWEWVAUEWYTVWGWVBUIVWEWVAVWEWVAUKULWYTUMUNUOYEXHUYIWYOWYMWVDWVBWVAVWA
      YIYDUYJYJVYSWVBVWAUYKVQVYIVYSVWAYIVQVYMVYIUATZVWAWJVBTZVYPVYOWBVYMWUQWURX
      UAWUSWUTVXEVYIUYLWEVYMVWLXUBWWKVWAUYMVOVYIVWAUYOVQXNVYMVWLVWPVYOVYJWBZWWK
      WYPWXCWXDXUCWXFVYNVWAVYIUYPXMVQXNUYQWYKVYGVYKUQVXBVWAUCVXDVXKEVWCVWAVXAUY
      RVXBVWAVGXSXTVQVWCVXBVWAYKVQXMVWBVWTVWNVWPVWBYMWKZVWAUSUFZVWTVWBXUDUBUSUF
      ZWYHXUEXUDUBTXUDUBURUFXUFUYSXUDUBUYTVUAVUBXUDYNXUDUBVUCVUDWYLXUDUBVWAVUEW
      EXUEVWAVWAXUDUDZUEUFXUGVWCUSUFVWTXUGVWAVWAYMVXKVUOVUFVUGXUDVWAVWAVXKVUHVW
      AXUGVWCYKWEVOVUIVWCVWAVUJVQYOVWNVWBVWPYLZVWDVWNVWBXUHUQZUQZVWIVWEVWAUEUFZ
      UQZIVWAYPZVWDXUJVWMXUKIVWAYPZXUMVWLVWMXUIYHXUJVWLXUHXUNVWLVWMXUIVLZVWNVWB
      XUHXKXUHVWOYLZIVWAYPVWLXUNVWOIVWAVUKVWLXUPXUKIVWAVWLVWEVWATZVWEVWAUSUFZXU
      PXUKUHVWLXUQVWEVWAUCXURVWAVWEVULVWEVWAUAXSVUMXUKXURXUPVWEVWAVUPVUNVUQVURV
      USXHVWIXUKIVWAVUTVQXUJVWBVWLXUMVWDUHVWNVWBXUHXLXUOVWBVWLUQXULVWDIVWAVWBVW
      LXUQXULVWDUHVWBVWLXUQUQZUQZXULVWDXUTXULUQVWHVWDXUTVWIXUKVWHXUTXUKVWFVWHXU
      SVWBXUKVWFUHXUSVWBXUKVWFXUSVWEUATZVWBXUKUQUBVWEUSUFZVWFVWAVWEXEVWBWYHVWAV
      WEUEUFZXVBXUKWYLVWEVWAVVFZUBVWAVWEVVAYCXVBVWFXVAVWEUBTZYLZXVBVWEUBURUFXVE
      UBVWEVVBVWEYNVVCWYRXVAVWFXVFWBYFUBVWEYGVVDVVEXGVVGVVHVVIVVJXUKVWHVWDUHXUT
      VWIXUKVWHVWDXUKVWHVWGVWAUEUFZVWDVWHXUKXVGVWGVWEVWAYQVVKXUKXVCXVGVWDXVDXVC
      VWCVWGUEUFZXVGVWDXVCXVHVWAVWEVWAVWEVVLULVWCVWGVWAYQYRYRVVQYSVVMYTYSYOVVNV
      QYTYOYJVVOVVPXQ $.
  $}

  ${
    $d a m s t w x y z A $.
    $( Every infinite ordinal is equinumerous to its cross product.
       Proposition 10.39 of [TakeutiZaring] p. 94, whose proof we follow
       closely.  The key idea is to show that the relation ` R ` is a
       well-ordering of ` ( On X. On ) ` with the additional property that
       ` R ` -initial segments of ` ( x X. x ) ` (where ` x ` is a limit
       ordinal) are of cardinality at most ` x ` .  (Contributed by Mario
       Carneiro, 9-Mar-2013.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    infxpen $p |- ( ( A e. On /\ om C_ A ) -> ( A X. A ) ~~ A ) $=
      ( vm vx vy vz vw vs vt cv wcel cxp wbr c1st cfv c2nd cun wceq eqid fveq2
      wa va con0 com wss cen wi wral csdm wo copab cin coi eleq1 uneq12d adantr
      bi2anan9 adantl eleq12d eqeqan12d breq12 anbi12d cbvopabv biid infxpenlem
      orbi12d ) UAIZUBJUCBIZUDVGVGKVGUELUFBVFUGTUCVFUDVGVFUHLBVFUGTTZCDEFAGIZUB
      UBKZJZHIZVJJZTZVIMNZVIONZPZVLMNZVLONZPZJZVQVTQZVIVLCIZVJJDIZVJJTWCMNZWDMN
      ZJWEWFQWCONWDONJTUITCDUJZLZTZUIZTZGHUJZVFVFKZWMKUKZWLBWMWNULZWGFIZMNZWPON
      ZPZUAWGRWKEIZVJJZWPVJJZTZWTMNZWTONZPZWSJZXFWSQZWTWPWGLZTZUIZTGHEFVIWTQZVL
      WPQZTZVNXCWJXKXLVKXAXMVMXBVIWTVJUMVLWPVJUMUPXNWAXGWIXJXNVQXFVTWSXLVQXFQXM
      XLVOXDVPXEVIWTMSVIWTOSUNZUOXMVTWSQXLXMVRWQVSWRVLWPMSVLWPOSUNZUQURXNWBXHWH
      XIXLXMVQXFVTWSXOXPUSVIWTVLWPWGUTVAVEVAVBWNRVHVCWSRWORVD $.
  $}

  $( The cross product of omega (the set of ordinal natural numbers) with
     itself is equinumerous to omega.  Exercise 1 of [Enderton] p. 133.
     (Contributed by NM, 23-Jul-2004.)  (Revised by Mario Carneiro,
     9-Mar-2013.) $)
  xpomen $p |- ( om X. om ) ~~ om $=
    ( com con0 wcel wss cxp cen wbr omelon ssid infxpen mp2an ) ABCAADAAEAFGHAI
    AJK $.

  ${
    $d A x $.
    $( The cross product of an infinite set with itself is idempotent.  This
       theorem provides the basis for infinite cardinal arithmetic.
       Proposition 10.40 of [TakeutiZaring] p. 95.  See also ~ infxpidm .
       (Contributed by Mario Carneiro, 9-Mar-2013.)  (Revised by Mario
       Carneiro, 29-Apr-2015.) $)
    infxpidm2 $p |- ( ( A e. dom card /\ om ~<_ A ) -> ( A X. A ) ~~ A ) $=
      ( ccrd cdm wcel com cdom wbr wa cxp cfv cen cardid2 ensymd syl2anc adantr
      xpen con0 wss cardon entr cardom wb omelon onenon carddom2 mpan syl5eqssr
      ax-mp biimpar infxpen sylancr ) ABCZDZEAFGZHZAAIZABJZKGZUQAKGZUPAKGUOUPUQ
      UQIZKGZUTUQKGZURUMVAUNUMAUQKGZVCVAUMUQAALZMZVEAUQAUQPNOUOUQQDEUQRVBASUOEE
      BJZUQUAUMVFUQRZUNEULDZUMVGUNUBEQDVHUCEUDUHEAUEUFUIUGUQUJUKUPUTUQTNUMUSUNV
      DOUPUQATN $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y N $.  $d x y ph $.  $d w x y z W $.
    $d x y X $.  $d x y Y $.
    infxpenc.1 $e |- ( ph -> A e. On ) $.
    infxpenc.2 $e |- ( ph -> om C_ A ) $.
    infxpenc.3 $e |- ( ph -> W e. ( On \ 1o ) ) $.
    infxpenc.4 $e |- ( ph -> F : ( om ^o 2o ) -1-1-onto-> om ) $.
    infxpenc.5 $e |- ( ph -> ( F ` (/) ) = (/) ) $.
    infxpenc.6 $e |- ( ph -> N : A -1-1-onto-> ( om ^o W ) ) $.
    infxpenc.k $e |- K = ( y e. { x e. ( ( om ^o 2o ) ^m W ) |
      ( `' x " ( _V \ 1o ) ) e. Fin } |-> ( F o. ( y o. `' ( _I |` W ) ) ) ) $.
    infxpenc.h $e |- H =
      ( ( ( om CNF W ) o. K ) o. `' ( ( om ^o 2o ) CNF W ) ) $.
    infxpenc.l $e |- L = ( y e. { x e. ( om ^m ( W .o 2o ) ) |
      ( `' x " ( _V \ 1o ) ) e. Fin } |->
        ( ( _I |` om ) o. ( y o. `' ( Y o. `' X ) ) ) ) $.
    infxpenc.x $e |- X = ( z e. 2o , w e. W |-> ( ( W .o z ) +o w ) ) $.
    infxpenc.y $e |- Y = ( z e. 2o , w e. W |-> ( ( 2o .o w ) +o z ) ) $.
    infxpenc.j $e |- J =
      ( ( ( om CNF ( 2o .o W ) ) o. L ) o. `' ( om CNF ( W .o 2o ) ) ) $.
    infxpenc.z $e |- Z = ( x e. ( om ^o W ) , y e. ( om ^o W ) |->
      ( ( ( om ^o W ) .o x ) +o y ) ) $.
    infxpenc.t $e |- T =
      ( x e. A , y e. A |-> <. ( N ` x ) , ( N ` y ) >. ) $.
    infxpenc.g $e |- G = ( `' N o. ( ( ( H o. J ) o. Z ) o. T ) ) $.
    $( A canonical version of ~ infxpen , by a completely different approach
       (although it uses ~ infxpen via ~ xpomen ).  Using Cantor's normal form,
       we can show that ` A ^o B ` respects equinumerosity ( ~ oef1o ), so that
       all the steps of ` ( om ^ W ) x. ( om ^ W ) ~~ om ^ ( 2 W ) ~~ `
       ` ( om ^ 2 ) ^ W ~~ om ^ W ` can be verified using bijections to do the
       ordinal commutations.  (The assumption on ` N ` can be satisfied using
       ~ cnfcom3c .)  (Contributed by Mario Carneiro, 30-May-2015.) $)
    infxpenc $p |- ( ph -> G : ( A X. A ) -1-1-onto-> A ) $=
      ( cxp ccnv ccom wf1o com coe co f1ocnv syl comu c2o cid cres f1oi con0 c0
      a1i wcel c1o cdif omelon 2on oecl sylancl peano1 syl21anc ondif1 sylanbrc
      oen0 eldifad oef1o omf1o mpbir2an omcl syl2anc cfv wceq fvresi wb syl3anc
      mp1i oeoe f1oeq3 mpbird f1oco coa csuc df-2o oveq2i 1on syl5eq om1 oveq1d
      omsuc eqtrd oveq2d oeoa f1oeq2 mpbid omxpenlem cv cmpt2 cmpt f1of feqmptd
      cop wf f1oeq1 xpf1o ax-mp sylibr ) AFFUNZFNUOZJKUPZRUPZGUPZUPZUQZYEFIUQZA
      UROUSUTZFYFUQZYEYMYIUQZYKAFYMNUQZYNUDFYMNVAVBAYMYMUNZYMYHUQZYEYQGUQZYOAYM
      YMVCUTZYMYGUQZYQYTRUQZYRAUROVDVCUTZUSUTZYMYGUQZUUAAURVDUSUTZOUSUTZYMJUQUU
      DUUGKUQZUUEABCUUFOUROHVEOVFZJLUBOOUUIUQAOVGVJAUUFVHVKZVIUUFVKZUUFVHVLVMZV
      KAURVHVKZVDVHVKZUUJUUMAVNVJZVOURVDVPVQAUUMUUNVIURVKZUUKUUOUUNAVOVJZUUPAVR
      VJURVDWBVSUUFVTWAAOVHVLUAWCZUUOUURUCUEUFWDAUUHUUDURVDOVCUTZUSUTZKUQZABCUR
      UUCURUUSVEURVFZQPUOUPZKMURURUVBUQAURVGVJAOVHVKZUUNUUCUUSUVCUQUURVODEOVDPQ
      UHUIWEVQURUULVKZAUVEUUMUUPVNVRURVTWFVJAUVDUUNUUCVHVKUURVOOVDWGVQUUOAUUNUV
      DUUSVHVKUUQUURVDOWGWHUUPVIUVBWIVIWJAVRURVIWKWNUGUJWDAUUGUUTWJZUUHUVAWLAUU
      MUUNUVDUVFUUOUUQUURURVDOWOWMUUGUUTUUDKWPVBWQUUDUUGYMJKWRWHAUUDYTWJUUEUUAW
      LAUUDUROOWSUTZUSUTZYTAUUCUVGURUSAUUCOVLVCUTZOWSUTZUVGAUUCOVLWTZVCUTZUVJVD
      UVKOVCXAXBAUVDVLVHVKUVLUVJWJUURXCOVLXGVQXDAUVIOOWSAUVDUVIOWJUUROXEVBXFXHX
      IAUUMUVDUVDUVHYTWJUUOUURUURUROOXJWMXHUUDYTYMYGXKVBXLAYMVHVKZUVMUUBAUUMUVD
      UVMUUOUURUROVPWHZUVNBCYMYMRUKXMWHYQYTYMYGRWRWHAYEYQBCFFBXNNWIZCXNNWIZXSXO
      ZUQZYSABCFYMFYMUVOUVPAYPFYMBFUVOXPZUQZUDANUVSWJYPUVTWLABFYMNAYPFYMNXTUDFY
      MNXQVBZXRFYMNUVSYAVBXLAYPFYMCFUVPXPZUQZUDANUWBWJYPUWCWLACFYMNUWAXRFYMNUWB
      YAVBXLYBGUVQWJYSUVRWLULYEYQGUVQYAYCYDYEYQYMYHGWRWHYEYMFYFYIWRWHIYJWJYLYKW
      LUMYEFIYJYAYCYD $.
  $}

  ${
    $d b g n u w x y A $.  $d b w x y ph $.  $d g w x y z W $.  $d g x y F $.
    $d g u G $.  $d x y X $.  $d x y Y $.
    infxpenc2.1 $e |- ( ph -> A e. On ) $.
    infxpenc2.2 $e |- ( ph -> A. b e. A ( om C_ b ->
      E. w e. ( On \ 1o ) ( n ` b ) : b -1-1-onto-> ( om ^o w ) ) ) $.
    infxpenc2.3 $e |- W =
      ( `' ( x e. ( On \ 1o ) |-> ( om ^o x ) ) ` ran ( n ` b ) ) $.
    $( Lemma for ~ infxpenc2 .  (Contributed by Mario Carneiro,
       30-May-2015.) $)
    infxpenc2lem1 $p |- ( ( ph /\ ( b e. A /\ om C_ b ) ) ->
      ( W e. ( On \ 1o ) /\ ( n ` b ) : b -1-1-onto-> ( om ^o W ) ) ) $=
      ( cv wcel com wa coe co con0 c1o wceq cvv wss cfv wf1o cdif wrex r19.21bi
      vy impr simpr crn cmpt ccnv oveq2 eqid ovex fvmpt ad2antrl f1ofo ad2antll
      wi wfo forn syl eqtr4d wf1 a1ii wb c2o omelon 1onn ondif2 mpbir2an eldifi
      a1i oecan syl3anc ex dom2lem f1f1orn simprl f1ocnvfv syl5eq eleq1d oveq2d
      syl2anc mpd f1oeq3 anbi12d mpbird rexlimddv ) AGKZDLZMWKUAZNNZWKMCKZOPZWK
      EKUBZUCZFQRUDZLZWKMFOPZWQUCZNZCWSAWLWMWRCWSUEZAWMXDUTGDIUFUHWNWOWSLZWRNZN
      ZXCXFWNXFUIXGWTXEXBWRXGFWOWSXGFWQUJZBWSMBKZOPZUKZULUBZWOJXGWOXKUBZXHSZXLW
      OSZXGXMWPXHXEXMWPSWNWRBWOXJWPWSXKXIWOMOUMXKUNMWOOUOUPUQXGWKWPWQVAZXHWPSWR
      XPWNXEWKWPWQURUSWKWPWQVBVCVDXGWSXKUJZXKUCZXEXNXOUTXGWSTXKVEXRXGBUGWSTXJMU
      GKZOPZXGXIWSLZXJTLMXIOUOVFXGYAXSWSLZNZXJXTSXIXSSVGZXGYCNZMQVHUDLZXIQLZXSQ
      LZYDYFYEYFMQLRMLVIVJMVKVLVNYAYGXGYBXIQRVMUQYBYHXGYAXSQRVMUSMXIXSVOVPVQVRW
      STXKVSVCWNXEWRVTWSXQWOXHXKWAWEWFWBZWCXGXAWPSXBWRVGXGFWOMOYIWDXAWPWKWQWGVC
      WHWIWJ $.

    infxpenc2.4 $e |- ( ph -> F : ( om ^o 2o ) -1-1-onto-> om ) $.
    infxpenc2.5 $e |- ( ph -> ( F ` (/) ) = (/) ) $.
    ${
      infxpenc2.k $e |- K = ( y e. { x e. ( ( om ^o 2o ) ^m W ) |
        ( `' x " ( _V \ 1o ) ) e. Fin } |-> ( F o. ( y o. `' ( _I |` W ) ) ) )
          $.
      infxpenc2.h $e |- H =
        ( ( ( om CNF W ) o. K ) o. `' ( ( om ^o 2o ) CNF W ) ) $.
      infxpenc2.l $e |- L = ( y e. { x e. ( om ^m ( W .o 2o ) ) |
        ( `' x " ( _V \ 1o ) ) e. Fin } |->
          ( ( _I |` om ) o. ( y o. `' ( Y o. `' X ) ) ) ) $.
      infxpenc2.x $e |- X = ( z e. 2o , w e. W |-> ( ( W .o z ) +o w ) ) $.
      infxpenc2.y $e |- Y = ( z e. 2o , w e. W |-> ( ( 2o .o w ) +o z ) ) $.
      infxpenc2.j $e |- J =
        ( ( ( om CNF ( 2o .o W ) ) o. L ) o. `' ( om CNF ( W .o 2o ) ) ) $.
      infxpenc2.z $e |- Z = ( x e. ( om ^o W ) , y e. ( om ^o W ) |->
        ( ( ( om ^o W ) .o x ) +o y ) ) $.
      infxpenc2.t $e |- T =
        ( x e. b , y e. b |-> <. ( ( n ` b ) ` x ) , ( ( n ` b ) ` y ) >. ) $.
      infxpenc2.g $e |- G = ( `' ( n ` b ) o. ( ( ( H o. J ) o. Z ) o. T ) ) $.
      $( Lemma for ~ infxpenc2 .  (Contributed by Mario Carneiro,
         30-May-2015.) $)
      infxpenc2lem2 $p |- ( ph -> E. g A. b e. A ( om C_ b ->
        ( g ` b ) : ( b X. b ) -1-1-onto-> b ) ) $=
        ( cmpt cvv wcel com cv wss cxp cfv wf1o wral wex con0 mptexg syl adantr
        wi wa simprl onelon syl2anc simprr c1o cdif coe co infxpenc2lem1 simpld
        c2o c0 wceq simprd infxpenc wb wf f1of vex xpex fex sylancl eqid fvmpt2
        f1oeq1 mpbird expr ralrimiva nfmpt1 nfeq2 fveq1 imbi2d ralbid spcegv
        sylc ) ATFKUOZUPUQZURTUSZUTZXIXIVAZXIXIXGVBZVCZVJZTFVDZXJXKXIXIHUSZVBZV
        CZVJZTFVDZHVEAFVFUQZXHUATFKVFVGVHAXNTFAXIFUQZXJXMAYBXJVKZVKZXMXKXIKVCZY
        DBCDEXIGJKLMNOXIIUSVBZPQRSYDYAYBXIVFUQAYAYCUAVIAYBXJVLZFXIVMVNAYBXJVOYD
        PVFVPVQUQZXIURPVRVSYFVCZABEFIPTUAUBUCVTZWAAURWBVRVSURJVCYCUDVIAWCJVBWCW
        DYCUEVIYDYHYIYJWEUFUGUHUIUJUKULUMUNWFZYDXLKWDZXMYEWGYDYBKUPUQZYLYGYDXKX
        IKWHZXKUPUQYMYDYEYNYKXKXIKWIVHXIXITWJZYOWKXKXIUPKWLWMTFKUPXGXGWNWOVNXKX
        IXLKWPVHWQWRWSXTXOHXGUPXPXGWDZXSXNTFTXPXGTFKWTXAYPXRXMXJYPXQXLWDXRXMWGX
        IXPXGXBXKXIXQXLWPVHXCXDXEXF $.
    $}

    $( Lemma for ~ infxpenc2 .  (Contributed by Mario Carneiro,
       30-May-2015.) $)
    infxpenc2lem3 $p |- ( ph -> E. g A. b e. A ( om C_ b ->
      ( g ` b ) : ( b X. b ) -1-1-onto-> b ) ) $=
      ( vy ccnv com co ccom eqid vz cv cfv cop cmpt2 ccnf cvv c1o cdif cima cfn
      wcel c2o coe cmap crab cid cres cmpt comu coa infxpenc2lem2 ) ABOUACDBOIU
      BZVCBUBZVCFUBUCZUCOUBZVEUCUDUEZEFGVEPQHUFROVDPUGUHUIUJUKULZBQUMUNRZHUORUP
      GVFUQHURPSSUSZSVIHUFRPSZQUMHUTRUFROVHBQHUMUTRZUORUPUQQURVFUACUMHUMCUBZUTR
      UAUBZVARUEZUACUMHHVNUTRVMVARUEZPSPSSUSZSQVLUFRPSZSBOQHUNRZVSVSVDUTRVFVARU
      EZSVGSSZVKVRVJVQHVPVOVTIJKLMNVJTVKTVQTVPTVOTVRTVTTVGTWATVB $.
  $}

  ${
    $d b f g n w x y z A $.
    $( Existence form of ~ infxpenc .  A "uniform" or "canonical" version of
       ~ infxpen , asserting the existence of a single function ` g ` that
       simultaneously demonstrates product idempotence of all ordinals below a
       given bound.  (Contributed by Mario Carneiro, 30-May-2015.) $)
    infxpenc2 $p |- ( A e. On -> E. g A. b e. A ( om C_ b ->
      ( g ` b ) : ( b X. b ) -1-1-onto-> b ) ) $=
      ( vn vf vw con0 wcel com cv coe co cfv wf1o c1o wex wceq omelon wa c0 wss
      vx vy vz cdif wrex wi wral c2o cxp cnfcom3c cen wbr comu df-2o oveq2i 1on
      csuc oesuc mp2an oe1 ax-mp oveq1i 3eqtri omxpen eqbrtri xpomen entri bren
      a1i sylib eeanv cid ccnv cpr cres cop cun ccom cmpt simpl simprl sseq2 wb
      crn oveq2 f1oeq3 cbvrexv fveq2 f1oeq1 f1oeq2 bitrd rexbidv syl5bb imbi12d
      syl cbvralv cbvmptv cnveqi fveq1i peano1 oen0 mpan2 eqid fveqf1o ad2antll
      2on mp3an23 simpld simprd infxpenc2lem3 ex exlimdvv syl5bir mp2and ) AGHZ
      IUBJZUAZXQIUCJZKLZXQDJZMZNZUCGOUEZUFZUGZUBAUHZDPZIUIKLZIEJZNZEPZICJZUAZYM
      YMUJYMYMBJMNUGCAUHBPZUCADUBUKXPYIIULUMZYLYPXPYIIIUJZIYIIIUNLZYQULYIIOURZK
      LZIOKLZIUNLZYRUIYSIKUOUPIGHZOGHYTUUBQRUQIOUSUTUUAIIUNUUCUUAIQRIVAVBVCVDUU
      CUUCYRYQULUMRRIIVEUTVFVGVHVJYIIEVIVKYHYLSYGYKSZEPDPXPYOYGYKDEVLXPUUDYODEX
      PUUDYOXPUUDSZUDFABDYJVMYITTYJVNMZVOUEVPTUUFVQUUFTVQVOVRVSZYMYAMZWEZCYDIYM
      KLZVTZVNZMCXPUUDWAUUEYGYNYMIFJZKLZUUHNZFYDUFZUGZCAUHXPYGYKWBYFUUQUBCAXQYM
      QZXRYNYEUUPXQYMIWCYEXQUUNYBNZFYDUFUURUUPYCUUSUCFYDXSUUMQXTUUNQYCUUSWDXSUU
      MIKWFXTUUNXQYBWGWPWHUURUUSUUOFYDUURUUSXQUUNUUHNZUUOUURYBUUHQUUSUUTWDXQYMY
      AWIXQUUNYBUUHWJWPXQYMUUNUUHWKWLWMWNWOWQVKUUIUULUDYDIUDJZKLZVTZVNUUKUVCCUD
      YDUUJUVBYMUVAIKWFWRWSWTUUEYIIUUGNZTUUGMTQZYKUVDUVESZXPYGYKTYIHZTIHZUVFUUC
      UIGHZUVGRXGUUCUVISUVHUVGXAIUIXBXCUTXAYIITTYJUUGUUGXDXEXHXFZXIUUEUVDUVEUVJ
      XJXKXLXMXNXO $.
  $}

  ${
    $d n B $.
    $( The union ` U_ n e. C ( A ^m n ) ` is a disjoint union.  (Contributed by
       Mario Carneiro, 17-May-2015.)  (Revised by NM, 16-Jun-2017.) $)
    iunmapdisj $p |- E* n e. C B e. ( A ^m n ) $=
      ( cv cmap co wcel wrmo wa wmo cdm wceq moeq elmapi fdm eqcomd syl moimi
      wf ax-mp moani df-rmo mpbir ) BADEZFGHZDCIUECHZUFJDKUFUGDUEBLZMZDKUFDKDUH
      NUFUIDUFUEABTZUIBAUEOUJUHUEUEABPQRSUAUBUFDCUCUD $.
  $}

  ${
    $d y B $.  $d y C $.  $d a b f n x z F $.  $d a b k m y z G $.  $d w z K $.
    $d a b f k m n x y z A $.  $d a b k m n w x y z ph $.
    fseqenlem.a $e |- ( ph -> A e. V ) $.
    fseqenlem.b $e |- ( ph -> B e. A ) $.
    fseqenlem.f $e |- ( ph -> F : ( A X. A ) -1-1-onto-> A ) $.
    fseqenlem.g $e |- G = seqom ( ( n e. _V , f e. _V |->
      ( x e. ( A ^m suc n ) |-> ( ( f ` ( x |` n ) ) F ( x ` n ) ) ) ) ,
      { <. (/) , B >. } ) $.
    $( Lemma for ~ fseqen .  (Contributed by Mario Carneiro, 17-May-2015.) $)
    fseqenlem1 $p |- ( ( ph /\ C e. om ) ->
      ( G ` C ) : ( A ^m C ) -1-1-> A ) $=
      ( wcel cmap cfv wceq wb syl vy vm va vb vz com co cv wi fveq2 f1eq1 oveq2
      wf1 f1eq2 bitrd imbi2d c0 cop csn csuc snex cres cmpt cmpt2 seqom0g ax-mp
      cvv syl6eq weq wss wf1o 0ex f1osng sylancr f1of1 snssd f1ss syl2anc map0e
      c1o df1o2 mpbird wral cxp ad2antrr f1of f1f ad2antll adantr elmapi adantl
      wa wf sssucid fssres sylancl vex elmapg ffvelrnd sucid ffvelrn eqid fmptd
      fovrnd seqomsuc ad2antrl reseq1 fveq2d fveq1 oveq12d cbvmptv suceq oveq2d
      fvex simpr reseq2 fveq12d simpl mpteq12dv nfcv cbvmpt2 ovex mptex ovmpt2a
      syl5eq mp2an feq1d wfn ffn a1i fvreseq eqeq12d fveq1d fvmpt eqtrd opelxpi
      df-ov f1fveq syl12anc syl6bb syl21anc ralsn bicomi anbi12d simplrr anbi1d
      opth 3bitrd eqfnfv cun df-suc raleqi ralunb bitri biimpd ralrimivva dff13
      3bitr4d sylanbrc expr expcom finds2 vtoclga impcom ) EUFOACEPUGZCEIQZUMZA
      CUAUHZPUGZCUVHIQZUMZUIAUVGUIUAEUFUVHERZUVKUVGAUVLUVKUVICUVFUMZUVGUVLUVJUV
      FRUVKUVMSUVHEIUJUVICUVJUVFUKTUVLUVIUVERUVMUVGSUVHECPULUVIUVECUVFUNTUOUPUV
      KCUQPUGZCUQDURZUSZUMZCUBUHZPUGZCUVRIQZUMZCUVRUTZPUGZCUWBIQZUMZAUAUBUVHUQR
      ZUVKUVICUVPUMZUVQUWFUVJUVPRUVKUWGSUWFUVJUQIQZUVPUVHUQIUJUVPVGOUWHUVPRUVOV
      AGFVGVGBCGUHZUTZPUGZBUHZUWIVBZFUHZQZUWIUWLQZHUGZVCZVDZIUVPNVEVFVHUVICUVJU
      VPUKTUWFUVIUVNRUWGUVQSUVHUQCPULUVIUVNCUVPUNTUOUAUBVIZUVKUVICUVTUMZUWAUWTU
      VJUVTRUVKUXASUVHUVRIUJUVICUVJUVTUKTUWTUVIUVSRUXAUWASUVHUVRCPULUVIUVSCUVTU
      NTUOUVHUWBRZUVKUVICUWDUMZUWEUXBUVJUWDRUVKUXCSUVHUWBIUJUVICUVJUWDUKTUXBUVI
      UWCRUXCUWESUVHUWBCPULUVIUWCCUWDUNTUOAUVQUQUSZCUVPUMZAUXDDUSZUVPUMZUXFCVJU
      XEAUXDUXFUVPVKZUXGAUQVGODCOUXHVLLUQDVGCVMVNUXDUXFUVPVOTADCLVPUXDUXFCUVPVQ
      VRAUVNUXDRUVQUXESAUVNVTUXDACJOZUVNVTRKCJVSTWAVHUVNUXDCUVPUNTWBAUVRUFOZUWA
      UWEUIAUXJUWAUWEAUXJUWAWLZWLZUWCCUWDWMZUCUHZUWDQZUDUHZUWDQZRZUCUDVIZUIZUDU
      WCWCUCUWCWCUWEUXLUXMUWCCUEUWCUEUHZUVRVBZUVTQZUVRUYAQZHUGZVCZWMUXLUEUWCUYE
      CUYFUXLUYAUWCOZWLZUYCUYDCCCHUYHCCWDZCHVKZUYICHWMAUYJUXKUYGMWEUYICHWFTUYHU
      VSCUYBUVTUXLUVSCUVTWMZUYGUWAUYKAUXJUVSCUVTWGWHZWIUYHUYBUVSOZUVRCUYBWMZUYH
      UWBCUYAWMZUVRUWBVJZUYNUYGUYOUXLUYACUWBWJWKZUVRWNZUWBCUVRUYAWOWPUYHUXIUVRV
      GOZUYMUYNSAUXIUXKUYGKWEUBWQZCUVRUYBJVGWRWPWBWSUYHUYOUVRUWBOZUYDCOUYQUVRUY
      TWTZUWBCUVRUYAXAWPXDUYFXBZXCUXLUWCCUWDUYFUXLUWDUVRUVTUWSUGZUYFUXJUWDVUDRA
      UWAUVRUWSIUVPNXEXFUYSUVTVGOVUDUYFRUYTUVRIXNUCUDUVRUVTVGVGBCUXNUTZPUGZUWLU
      XNVBZUXPQZUXNUWLQZHUGZVCZUYFUWSUCUBVIZUXPUVTRZWLZVUKUEVUFUYAUXNVBZUXPQZUX
      NUYAQZHUGZVCUYFBUEVUFVUJVURBUEVIZVUHVUPVUIVUQHVUSVUGVUOUXPUWLUYAUXNXGXHUX
      NUWLUYAXIXJXKVUNUEVUFVURUWCUYEVUNVUEUWBCPVULVUEUWBRVUMUXNUVRXLWIXMVUNVUPU
      YCVUQUYDHVUNVUOUYBUXPUVTVULVUMXOVULVUOUYBRVUMUXNUVRUYAXPWIXQVUNUXNUVRUYAV
      ULVUMXRXHXJXSYEGFUCUDVGVGUWRVUKUCUWRXTUDUWRXTGVUKXTFVUKXTGUCVIZFUDVIZWLZB
      UWKUWQVUFVUJVVBUWJVUECPVUTUWJVUERVVAUWIUXNXLWIXMVVBUWOVUHUWPVUIHVVBUWMVUG
      UWNUXPVUTVVAXOVUTUWMVUGRVVAUWIUXNUWLXPWIXQVVBUWIUXNUWLVUTVVAXRXHXJXSYAUEU
      WCUYECUWBPYBYCYDYFVHZYGWBUXLUXTUCUDUWCUWCUXLUXNUWCOZUXPUWCOZWLZWLZUXRUXSV
      VGUXNUVRVBZUXPUVRVBZRZUVRUXNQZUVRUXPQZRZWLZUWLUXNQZUWLUXPQZRZBUVRWCZVVQBU
      VRUSZWCZWLZUXRUXSVVGVVJVVRVVMVVTVVGUXNUWBYHZUXPUWBYHZUYPVVJVVRSVVGUWBCUXN
      WMZVWBVVDVWDUXLVVEUXNCUWBWJXFZUWBCUXNYITZVVGUWBCUXPWMZVWCVVEVWGUXLVVDUXPC
      UWBWJWHZUWBCUXPYITZUYPVVGUYRYJBUWBUVRUXNUXPYKUUAVVMVVTSVVGVVTVVMVVQVVMBUV
      RUYTBUBVIVVOVVKVVPVVLUWLUVRUXNUJUWLUVRUXPUJYLUUBUUCYJUUDVVGUXRVVHUVTQZVVK
      URZHQZVVIUVTQZVVLURZHQZRZVWJVWMRZVVMWLZVVNVVGUXOVWLUXQVWOVVGUXOVWJVVKHUGZ
      VWLVVGUXOUXNUYFQZVWSVVGUXNUWDUYFUXLUWDUYFRVVFVVCWIZYMVVDVWTVWSRUXLVVEUEUX
      NUYEVWSUWCUYFUEUCVIZUYCVWJUYDVVKHVXBUYBVVHUVTUYAUXNUVRXGXHUVRUYAUXNXIXJVU
      CVWJVVKHYBYNXFYOVWJVVKHYQVHVVGUXQVWMVVLHUGZVWOVVGUXQUXPUYFQZVXCVVGUXPUWDU
      YFVXAYMVVEVXDVXCRUXLVVDUEUXPUYEVXCUWCUYFUEUDVIZUYCVWMUYDVVLHVXEUYBVVIUVTU
      YAUXPUVRXGXHUVRUYAUXPXIXJVUCVWMVVLHYBYNWHYOVWMVVLHYQVHYLVVGVWPVWKVWNRZVWR
      VVGUYICHUMZVWKUYIOZVWNUYIOZVWPVXFSVVGUYJVXGAUYJUXKVVFMWEUYICHVOTVVGVWJCOV
      VKCOZVXHVVGUVSCVVHUVTUXLUYKVVFUYLWIZVVGVVHUVSOZUVRCVVHWMZVVGVWDUYPVXMVWEU
      YRUWBCUVRUXNWOWPVVGUXIUYSVXLVXMSAUXIUXKVVFKWEZUYTCUVRVVHJVGWRWPWBZWSVVGVW
      DVUAVXJVWEVUBUWBCUVRUXNXAWPVWJVVKCCYPVRVVGVWMCOVVLCOZVXIVVGUVSCVVIUVTVXKV
      VGVVIUVSOZUVRCVVIWMZVVGVWGUYPVXRVWHUYRUWBCUVRUXPWOWPVVGUXIUYSVXQVXRSVXNUY
      TCUVRVVIJVGWRWPWBZWSVVGVWGVUAVXPVWHVUBUWBCUVRUXPXAWPVWMVVLCCYPVRUYICVWKVW
      NHYRYSVWJVVKVWMVVLVVHUVTXNUVRUXNXNUUGYTVVGVWQVVJVVMVVGUWAVXLVXQVWQVVJSAUX
      JUWAVVFUUEVXOVXSUVSCVVHVVIUVTYRYSUUFUUHVVGUXSVVQBUWBWCZVWAVVGVWBVWCUXSVXT
      SVWFVWIBUWBUXNUXPUUIVRVXTVVQBUVRVVSUUJZWCVWAVVQBUWBVYAUVRUUKUULVVQBUVRVVS
      UUMUUNYTUURUUOUUPUCUDUWCCUWDUUQUUSUUTUVAUVBUVCUVD $.

    fseqenlem.k $e |- K = ( y e. U_ k e. om ( A ^m k ) |->
      <. dom y , ( ( G ` dom y ) ` y ) >. ) $.
    $( Lemma for ~ fseqen .  (Contributed by Mario Carneiro, 17-May-2015.) $)
    fseqenlem2 $p |- ( ph ->
      K : U_ k e. om ( A ^m k ) -1-1-> ( om X. A ) ) $=
      ( com cfv wcel vz vw cv cmap co ciun cxp wf wbr wmo wal wf1 cdm cop eliun
      wrex wceq elmapi ad2antll fdm syl simprl eqeltrd fveq2d fveq1d fseqenlem1
      wa adantrr f1f simprr ffvelrnd opelxpi syl2anc rexlimdvaa syl5bi imp c2nd
      fmptd c1st ccnv wfun ffun funbrfv2b 3syl simplbda simprbda adantr eleqtrd
      wi wb dmeq fveq12d opeq12d opex fvmpt eqtr3d vex dmex op1st syl6eq cnveqd
      id fvex op2nd crn wf1o adantl simpl simpr oveq2d eleqtrrd rexlimiva sylbi
      jca simpld syldan f1f1orn simprd f1ocnvfv1 eqtr2d ex alrimiv mo2icl dff12
      sylanbrc ) AGRDGUCZUDUEZUFZRDUGZKUHZUAUCZUBUCZKUIZUAUJZUBUKYHYIKULACYHCUC
      ZUMZYOYPJSZSZUNZYIKAYOYHTZYSYITZYTYOYGTZGRUPAUUAGYORYGUOAUUBUUAGRAYFRTZUU
      BVGVGZYPRTYRDTUUAUUDYPYFRUUDYFDYOUHZYPYFUQUUBUUEAUUCYODYFURUSYFDYOUTVAZAU
      UCUUBVBVCUUDYRYOYFJSZSDUUDYOYQUUGUUDYPYFJUUFVDVEUUDYGDYOUUGUUDYGDUUGULZYG
      DUUGUHAUUCUUHUUBABDEYFFHIJLMNOPVFVHYGDUUGVIVAAUUCUUBVJVKVCYPYRRDVLVMVNVOV
      PQVRZAYNUBAYMYKYLVQSZYLVSSZJSZVTZSZUQZWIZUAUKYNAUUPUAAYMUUOAYMVGZUUNYKYKU
      MZJSZSZUUSVTZSZYKUUQUUJUUTUUMUVAUUQUULUUSUUQUUKUURJUUQUUKUURUUTUNZVSSUURU
      UQYLUVCVSUUQYKKSZYLUVCAYMYKKUMZTZUVDYLUQZAYJKWAYMUVFUVGVGWJUUIYHYIKWBYKYL
      KWCWDZWEUUQYKYHTZUVDUVCUQUUQYKUVEYHAYMUVFUVGUVHWFAUVEYHUQZYMAYJUVJUUIYHYI
      KUTVAWGWHZCYKYSUVCYHKYOYKUQZYPUURYRUUTYOYKWKZUVLYOYKYQUUSUVLYPUURJUVMVDUV
      LXBWLWMQUURUUTWNWOVAWPZVDUURUUTYKUAWQWRZYKUUSXCZWSWTVDXAUUQUUJUVCVQSUUTUU
      QYLUVCVQUVNVDUURUUTUVOUVPXDWTWLUUQDUURUDUEZUUSXEZUUSXFZYKUVQTZUVBYKUQUUQU
      VQDUUSULZUVSAYMUURRTZUWAUUQUWBUVTUUQUVIUWBUVTVGZUVKUVIYKYGTZGRUPUWCGYKRYG
      UOUWDUWCGRUUCUWDVGZUWBUVTUWEUURYFRUWEYFDYKUHZUURYFUQUWDUWFUUCYKDYFURXGYFD
      YKUTVAZUUCUWDXHVCUWEYKYGUVQUUCUWDXIUWEUURYFDUDUWGXJXKXNXLXMVAZXOABDEUURFH
      IJLMNOPVFXPUVQDUUSXQVAUUQUWBUVTUWHXRUVQUVRYKUUSXSVMXTYAYBYMUAUUNYCVAYBUAU
      BYHYIKYDYE $.
  $}

  ${
    $d n x y A $.  $d x y V $.
    $( One half of ~ fseqen .  (Contributed by Mario Carneiro, 18-Nov-2014.) $)
    fseqdom $p |- ( A e. V -> ( om X. A ) ~<_ U_ n e. om ( A ^m n ) ) $=
      ( vx vy wcel com cv cmap co cvv cxp c1st cfv csuc c2nd wa adantl wb wceq
      ciun cdom wbr omex ovex iunex csn wrex xp1st peano2 syl wf xp2nd fconst6g
      elmapg sylan2 mpbird oveq2 eleq2d rspcev syl2anc eliun sylibr wne nsuceq0
      ex c0 fvex snnz xp11 mp2an peano4 syl2an sneqbg mp1i anbi12d syl5bb bitrd
      xpopth dom2d mpi ) ACFZBGABHZIJZUAZKFGALZWEUBUCBGWDUDAWCIUEUFWBDEWFWEDHZM
      NZOZWGPNZUGZLZEHZMNZOZWMPNZUGZLZKWBWGWFFZWLWEFZWBWSQZWLWDFZBGUHZWTXAWIGFZ
      WLAWIIJZFZXCWSXDWBWSWHGFZXDWGGAUIZWHUJUKZRXAXFWIAWLULZXAWJAFZXJWSXKWBWGGA
      UMRWIWJAUNUKWSWBXDXFXJSXIAWIWLCGUOUPUQXBXFBWIGWCWITWDXEWLWCWIAIURUSUTVABW
      LGWDVBVCVFWBWSWMWFFZQZWLWRTZWGWMTZSWBXMQZXNWHWNTZWJWPTZQZXOXNWIWOTZWKWQTZ
      QZXPXSWIVGVDWKVGVDXNYBSWHVEWJWGPVHZVIWIWKWOWQVJVKXPXTXQYAXRXMXTXQSZWBWSXG
      WNGFYDXLXHWMGAUIWHWNVLVMRWJKFYAXRSXPYCWJWPKVNVOVPVQXMXSXOSWBWGWMGAGAVSRVR
      VFVTWA $.
  $}

  ${
    $d b f g k n x y A $.
    $( A set that is equinumerous to its cross product is equinumerous to the
       set of finite sequences on it.  (This can be proven more easily using
       some choice but this proof avoids it.)  (Contributed by Mario Carneiro,
       18-Nov-2014.) $)
    fseqen $p |- ( ( ( A X. A ) ~~ A /\ A =/= (/) ) ->
      U_ n e. om ( A ^m n ) ~~ ( om X. A ) ) $=
      ( vf vb vx vk vg vy cxp cen wbr cv wex wcel com cmap co c0 cvv cfv wne n0
      wf1o ciun bren wa eeanv cdom cdm csuc cres cmpt cmpt2 cop csn cseqom omex
      wf1 crn wfo wceq simpl f1ofo forn 3syl rnex syl6eqelr xpexg sylancr simpr
      vex eqid fseqenlem2 f1domg sylc fseqdom syl sbth syl2anc exlimivv syl2anb
      sylbir ) AAIZAJKWCACLZUCZCMZDLZANZDMZBOABLPQUDZOAIZJKZARUAWCACUEDAUBWFWIU
      FWEWHUFZDMCMWLWEWHCDUGWMWLCDWMWJWKUHKZWKWJUHKZWLWMWKSNZWJWKEWJELZUIZWQWRF
      GSSHAFLZUJPQHLZWSUKGLTWSWTTWDQULUMRWGUNUOUPZTTUNULZURWNWMOSNASNZWPUQWMAWD
      USZSWMWEWCAWDUTXDAVAWEWHVBZWCAWDVCWCAWDVDVEWDCVKVFVGZOASSVHVIWMHEAWGGBFWD
      XAXBSXFWEWHVJXEXAVLXBVLVMWJWKSXBVNVOWMXCWOXFABSVPVQWJWKVRVSVTWBWA $.
  $}

  ${
    $d x y A $.
    $( The collection of finite subsets of a set dominates the set.  (We use
       the weaker sethood assumption ` ( ~P A i^i Fin ) e. _V ` because this
       theorem also implies that ` A ` is a set if ` ~P A i^i Fin ` is.)
       (Contributed by Mario Carneiro, 17-May-2015.) $)
    infpwfidom $p |- ( ( ~P A i^i Fin ) e. _V -> A ~<_ ( ~P A i^i Fin ) ) $=
      ( vx vy cpw cfn cin cv csn cvv wcel snelpwi snfi a1i elin sylanbrc sneqbg
      wceq wb adantr dom2 ) BCAADZEFZBGZHZCGZHZIUCAJZUDUAJUDEJZUDUBJUCAKUHUGUCL
      MUDUAENOUGUDUFQUCUEQRUEAJUCUEAPST $.
  $}

  ${
    $d f g x y A $.  $d g C $.  $d f x y F $.
    $( Hypotheses for transfinite recursion. $)
    dfac8alem.2 $e |- F = recs ( G ) $.
    $( Generator function.  ` g ` is a choice function on ` ~P A ` . $)
    dfac8alem.3 $e |- G = ( f e. _V |-> ( g ` ( A \ ran f ) ) ) $.
    $( Lemma for ~ dfac8a .  If the power set of a set has a choice function,
       then the set is numerable.  (Contributed by NM, 10-Feb-1997.)  (Revised
       by Mario Carneiro, 5-Jan-2013.) $)
    dfac8alem $p |- ( A e. C -> ( E. g A. y e. ~P A ( y =/= (/) ->
       ( g ` y ) e. y ) -> A e. dom card ) ) $=
      ( vx wcel cv c0 wne cfv wi wral cvv con0 wceq cpw ccrd cdm elex cima cdif
      wa w3a wss difss elpw2g mpbiri neeq1 fveq2 eleq12d imbi12d rspcv syl 3imp
      id cres tfr2 wfun wfn tfr1 fnfun ax-mp vex resfunexg mp2an df-ima syl6eqr
      crn rneq fveq2d fvex fvmpt syl6eq eleq1d syl5ibrcom 3expia com23 ralrimiv
      difeq2d wf1o wrex tz7.49c cen wbr f1oen isnumi sylan2 rexlimiva syl6 syld
      ex exlimdv ) BCKZALZMNZWSELZOZWSKZPZABUAZQZBUBUCKZEWRBRKZXFXGPBCUDXHXFBFJ
      LZUEZUFZMNZXIFOZXKKZPZJSQZXGXHXFXPXHXFUGZXOJSXQXLXISKZXNXHXFXLXRXNPXHXFXL
      UHXNXRXKXAOZXKKZXHXFXLXTXHXKXEKZXFXLXTPZPXHYAXKBUIBXJUJXKBRUKULXDYBAXKXEW
      SXKTZWTXLXCXTWSXKMUMYCXBXSWSXKWSXKXAUNYCUTUOUPUQURUSXRXMXSXKXRXMFXIVAZGOZ
      XSXIFGHVBYDRKZYEXSTFVCZXIRKYFFSVDYGFGHVEZSFVFVGJVHZFXIRVIVJDYDBDLZVMZUFZX
      AOXSRGYJYDTZYLXKXAYMYKXJBYMYKYDVMXJYJYDVNFXIVKVLWDVOIXKXAVPVQVGVRVSVTWAWB
      WCWPXHXPXIBYDWEZJSWFZXGXHXPYOJBRFYHWGWPYNXGJSYNXRXIBWHWIXGXIBYDYIWJXIBWKW
      LWMWNWOURWQ $.
  $}

  ${
    $d f h u v y A $.  $d h B $.
    $( Numeration theorem: every set with a choice function on its power set is
       numerable.  With AC, this reduces to the statement that every set is
       numerable.  Similar to Theorem 10.3 of [TakeutiZaring] p. 84.
       (Contributed by NM, 10-Feb-1997.)  (Revised by Mario Carneiro,
       5-Jan-2013.) $)
    dfac8a $p |- ( A e. B -> ( E. h A. y e. ~P A ( y =/= (/) ->
        ( h ` y ) e. y ) -> A e. dom card ) ) $=
      ( vf vv cvv cv crn cdif cfv cmpt crecs eqid rneq difeq2d fveq2d dfac8alem
      weq cbvmptv ) ABCEDFGBFHZIZJZDHZKZLZMZUFUGNFEGUEBEHZIZJZUDKFESZUCUJUDUKUB
      UIBUAUHOPQTR $.
  $}

  ${
    $d f w x z A $.
    $( The well-ordering theorem: every numerable set is well-orderable.
       (Contributed by Mario Carneiro, 5-Jan-2013.)  (Revised by Mario
       Carneiro, 29-Apr-2015.) $)
    dfac8b $p |- ( A e. dom card -> E. x x We A ) $=
      ( vf vz vw ccrd cdm wcel cfv cv wex wwe cen wbr cardid2 sylib cep cin cvv
      wf1o bren ccnv copab cxp xpexg anidms incom inex1g syl5eqel f1ocnv cardon
      syl word onordi ordwe ax-mp eqid f1owe weinxp weeq1 spcegv syl2im exlimdv
      ee10 mpd ) BFGZHZBFIZBCJZTZCKZBAJZLZAKZVGVHBMNVKBOVHBCUAPVGVJVNCVGDJVIUBZ
      IEJVOIQNDEUCZBBUDZRZSHZVJBVRLZVNVGVQSHZVSVGWABBVFVFUEUFWAVRVQVPRSVPVQUGVQ
      VPSUHUIULVJBVPLZVTVJBVHVOTVHQLZWBVHBVIUJVHUMWCVHBUKUNVHUOUPDEBVHVPQVOVPUQ
      URVDBVPUSPVMVTAVRSBVLVRUTVAVBVCVE $.
  $}

  ${
    $d a b f r s z A $.  $d r s B $.  $d f z F $.
    dfac8clem.1 $e |- F = ( s e. ( A \ { (/) } ) |->
       ( iota_ a e. s A. b e. s -. b r a ) ) $.
    $( Lemma for ~ dfac8c .  (Contributed by Mario Carneiro, 10-Jan-2013.) $)
    dfac8clem $p |- ( A e. B -> ( E. r r We U. A ->
       E. f A. z e. A ( z =/= (/) -> ( f ` z ) e. z ) ) ) $=
      ( wcel cv c0 wne cfv wi wral wa cvv wceq cuni wwe wex csn cdif wf wn crio
      wbr eldifsn wss elssuni ad2antrl wreu wse simplr exse2 mp1i simprr wereu2
      vex syl22anc riotacl syl sseldd sylan2b difexg adantr uniexg fex2 syl3anc
      fmptd riotaex fvmpt2 sylbir adantl eqeltrd expr ralrimiva nfv cmpt nfmpt1
      mpan2 nfcxfr nfcv nffv nfel1 neeq1 fveq2 id eleq12d imbi12d cbvral sylibr
      nfim fveq1 eleq1d imbi2d ralbidv spcegv sylc ex exlimdv ) BCKZBUAZGLZUBZA
      LZMNZXHDLZOZXHKZPZABQZDUCZGXDXGXOXDXGRZESKZXIXHEOZXHKZPZABQZXOXPBMUDZUEZX
      EEUFYCSKZXESKZXQXPFYCILHLXFUIUGIFLZQZHYFUHZXEEYFYCKZXPYFBKZYFMNZRZYHXEKYF
      BMUJZXPYLRZYFXEYHYJYFXEUKZXPYKYFBULUMZYNYGHYFUNZYHYFKYNXGXEXFUOZYOYKYQXDX
      GYLUPXFSKYRYNGVAXEXFSUQURYPXPYJYKUSHIXEYFXFUTVBYGHYFVCVDZVEVFJVLXDYDXGBYB
      CVGVHXDYEXGBCVIVHYCXEESSVJVKXPYKYFEOZYFKZPZFBQYAXPUUBFBXPYJYKUUAYNYTYHYFY
      LYTYHTZXPYLYIUUCYMYIYHSKUUCYGHYFVMFYCYHSEJVNWCVOVPYSVQVRVSXTUUBAFBXIXSFXI
      FVTFXRXHFXHEFEFYCYHWAJFYCYHWBWDFXHWEWFWGWOUUBAVTXHYFTZXIYKXSUUAXHYFMWHUUD
      XRYTXHYFXHYFEWIUUDWJWKWLWMWNXNYADESXJETZXMXTABUUEXLXSXIUUEXKXRXHXHXJEWPWQ
      WRWSWTXAXBXC $.
  $}

  ${
    $d f r w x y z A $.  $d r x B $.
    $( If the union of a set is well-orderable, then the set has a choice
       function.  (Contributed by Mario Carneiro, 5-Jan-2013.) $)
    dfac8c $p |- ( A e. B -> ( E. r r We U. A ->
       E. f A. z e. A ( z =/= (/) -> ( f ` z ) e. z ) ) ) $=
      ( vx vw vy c0 csn cdif cv wbr wn wral crio cmpt eqid dfac8clem ) ABCDFBIJ
      KGLHLELMNGFLZOHTPQZFEHGUARS $.
  $}

  ${
    $d A f x y $.  $d f w x z $.
    $( A proof of the Well ordering theorem ~ weth , an Axiom of Choice
       equivalent, restricted to sets dominated by some ordinal (in particular
       finite sets and countable sets), proven in ZF without AC. (Contributed
       by Mario Carneiro, 5-Jan-2013.) $)
    ac10ct $p |- ( E. y e. On A ~<_ y -> E. x x We A ) $=
      ( vf vw vz cv cdom wbr wwe wex con0 wcel wi wa cep wss syl cfv cvv wf1 wf
      vex brdom crn f1f onss sstr2 syl2im epweon wess syl6mpi adantl copab wf1o
      frn f1f1orn eqid f1owe cxp cin weinxp reldom brrelexi xpexg anidms inex1g
      incom syl5eqelr weeq1 spcegv 4syl syl5bi sylan9r syld impancom exlimdv ex
      pm2.43b rexlimiv ) CBGZHIZCAGZJZAKZBLWALMZWBWEWBWFWBWENWBCWADGZUAZDKWBWFO
      ZWECWADBUCUDWIWHWEDWBWHWFWEWBWHOWFWGUEZPJZWEWHWFWKNWBWHWFWJLQZLPJWKWHWJWA
      QZWFWALQWLWHCWAWGUBWMCWAWGUFCWAWGUPRWAUGWJWALUHUIUJWJLPUKULUMWHWKCEGWGSFG
      WGSPIEFUNZJZWBWEWHCWJWGUOWKWONCWAWGUQEFCWJWNPWGWNURUSRWOCWNCCUTZVAZJZWBWE
      CWNVBWBCTMZWPTMZWQTMWRWENCWAHVCVDWSWTCCTTVEVFWTWQWPWNVATWPWNVHWPWNTVGVIWD
      WRAWQTCWCWQVJVKVLVMVNVOVPVQVMVRVSVT $.
  $}

  ${
    $d A f r x y $.  $d V f r y $.
    $( A set is numerable iff it can be well-ordered.  (Contributed by Mario
       Carneiro, 5-Jan-2013.) $)
    ween $p |- ( A e. dom card <-> E. r r We A ) $=
      ( vx vf ccrd cdm wcel cv wwe wex dfac8b cvv cpw cuni wor weso vex sylancl
      soex wi exlimiv wceq wb unipw weeq2 ax-mp exbii biimpri c0 wne wral pwexg
      cfv dfac8c syl dfac8a syld sylc impbii ) AEFGZABHZIZBJZBAKVCALGZAMZNZVAIZ
      BJZUTVBVDBVBAVAOVALGVDAVAPBQAVALSRUAVHVCVGVBBVFAUBVGVBUCAUDVFAVAUEUFUGUHV
      DVHCHZUIUJVIDHUMVIGTCVEUKDJZUTVDVELGVHVJTALULCVELDBUNUOCALDUPUQURUS $.
  $}

  ${
    $d f g r x y A $.
    $( A version of ~ ac5b with the choice as a hypothesis.  (Contributed by
       Mario Carneiro, 27-Aug-2015.) $)
    ac5num $p |- ( ( U. A e. dom card /\ -. (/) e. A ) ->
               E. f ( f : A --> U. A /\ A. x e. A ( f ` x ) e. x ) ) $=
      ( vg vr vy wcel c0 wa cv cfv wi wral wf wex cvv sylibr sylc wceq fveq2 wn
      cuni ccrd cdm wne wwe elex uniexb dfac8b dfac8c adantr cmpt nelne2 ancoms
      adantll pm2.27 syl ralimdva id eleq12d rspccva sylan elunii sylancom eqid
      imp fmptd ad2antrr fex2 syl3anc fvex fvmpt ralbiia jca feq1 fveq1 ralbidv
      eleq1d anbi12d spcegv exlimddv ) BUBZUCUDZGZHBGUAZIZAJZHUEZWGDJZKZWGGZLZA
      BMZBWBCJZNZWGWNKZWGGZABMZIZCOZDWDWMDOZWEWDBPGZWBEJUFEOXAWDWBPGZXBWBWCUGZB
      UHQZEWBUIABPDEUJRUKWFWMIZFBFJZWIKZULZPGZBWBXINZWGXIKZWGGZABMZIZWTXFXKXBXC
      XJXFFBXHWBXIXFXGBGZXHXGGZXHWBGXFWKABMZXPXQWFWMXRWFWLWKABWFWGBGZIWHWLWKLWE
      XSWHWDXSWEWHWGHBUMUNUOWHWKUPUQURVFZWKXQAXGBWGXGSZWJXHWGXGWGXGWITYAUSUTVAV
      BXHXGBVCVDXIVEZVGZWDXBWEWMXEVHWDXCWEWMXDVHBWBXIPPVIVJXFXKXNYCXFXRXNXTXMWK
      ABXSXLWJWGFWGXHWJBXIXGWGWITYBWGWIVKVLVRVMQVNWSXOCXIPWNXISZWOXKWRXNBWBWNXI
      VOYDWQXMABYDWPXLWGWGWNXIVPVRVQVSVTRWA $.
  $}

  ${
    $d x A $.  $d r x B $.
    $( If a set is dominated by an ordinal, then it is numerable.  (Contributed
       by Mario Carneiro, 5-Jan-2013.) $)
    ondomen $p |- ( ( A e. On /\ B ~<_ A ) -> B e. dom card ) $=
      ( vr vx con0 wcel cdom wbr wa cv wwe wex ccrd cdm breq2 rspcev ac10ct syl
      wrex ween sylibr ) AEFBAGHZIZBCJKCLZBMNFUCBDJZGHZDESUDUFUBDAEUEABGOPCDBQR
      BCTUA $.
  $}

  $( A set dominated by a numerable set is numerable.  (Contributed by Mario
     Carneiro, 28-Apr-2015.) $)
  numdom $p |- ( ( A e. dom card /\ B ~<_ A ) -> B e. dom card ) $=
    ( ccrd cdm wcel cdom wbr cfv con0 cardon cen cardid2 domen2 biimpar ondomen
    wa wb syl sylancr ) ACDZEZBAFGZPACHZIEBUCFGZBTEAJUAUDUBUAUCAKGUDUBQALUCABMR
    NUCBOS $.

  $( A subset of a numerable set is numerable.  (Contributed by Mario Carneiro,
     28-Apr-2015.) $)
  ssnum $p |- ( ( A e. dom card /\ B C_ A ) -> B e. dom card ) $=
    ( ccrd cdm wcel wss cdom wbr ssdomg imp numdom syldan ) ACDZEZBAFZBAGHZBMEN
    OPBAMIJABKL $.

  $( All subsets of the ordinals are numerable.  (Contributed by Mario
     Carneiro, 12-Feb-2013.) $)
  onssnum $p |- ( ( A e. V /\ A C_ On ) -> A e. dom card ) $=
    ( wcel con0 wss wa cuni csuc ccrd cdm cvv word uniexg ssorduni elong syl2an
    biimpar suceloni onenon 3syl onsucuni adantl ssnum syl2anc ) ABCZADEZFZAGZH
    ZIJZCZAUIEZAUJCUGUHDCZUIDCUKUEUHKCZUHLZUMUFABMANUNUMUOUHKOQPUHRUISTUFULUEAU
    AUBUIAUCUD $.

  ${
    $d x y T $.  $d x A $.  $d x S $.  $d x ch $.  $d x y ph $.  $d x th $.
    $d y R $.  $d y ps $.
    indcardi.a $e |- ( ph -> A e. V ) $.
    indcardi.b $e |- ( ph -> T e. dom card ) $.
    indcardi.c $e |- ( ( ph /\ R ~<_ T /\ A. y ( S ~< R -> ch ) ) -> ps ) $.
    indcardi.d $e |- ( x = y -> ( ps <-> ch ) ) $.
    indcardi.e $e |- ( x = A -> ( ps <-> th ) ) $.
    indcardi.f $e |- ( x = y -> R = S ) $.
    indcardi.g $e |- ( x = A -> R = T ) $.
    $( Indirect strong induction on the cardinality of a finite or numerable
       set.  (Contributed by Stefan O'Rear, 24-Aug-2015.) $)
    indcardi $p |- ( ph -> th ) $=
      ( cdom wi wbr ccrd cdm wcel domrefg syl cfv con0 cardon a1i wss wa simpl1
      wal w3a csdm simpr wb sdomdom adantl simpl3 domtr numdom cardsdom2 mpbird
      syl2anc id com3l sylc ex com23 alimdv 3exp com34 3imp1 syl3anc weq breq1d
      imbi12d cv wceq fveq2d tfisi mpd ) AJJSUAZDAJUBUCZUDZWEMJWFUEUFAHJSUAZBTI
      JSUAZCTZWEDTEFGHUBUGZIUBUGZJUBUGZKLWMUHUDAJUIUJAWKUHUDWKWMUKULZWLWKUDZWJT
      ZFUNZUOZWHBWRWHULAWHIHUPUAZCTZFUNZBAWNWQWHUMWRWHUQAWNWQWHXAAWNWHWQXAAWNWH
      WQXATAWNWHUOZWPWTFXBWSWPCXBWSWPCTZXBWSULZWOWIXCXDWOWSXBWSUQXDIWFUDZHWFUDZ
      WOWSURXDWGWIXEXDAWGAWNWHWSUMMUFZXDIHSUAZWHWIWSXHXBIHUSUTAWNWHWSVAZIHJVBVF
      ZJIVCVFXDWGWHXFXGXIJHVCVFIHVDVFVEXJWPWOWICWPVGVHVIVJVKVLVMVNVONVPVJEFVQZW
      HWIBCXKHIJSQVROVSEVTGWAZWHWEBDXLHJJSRVRPVSXKHIUBQWBXLHJUBRWBWCWD $.
  $}

  ${
    $d f g h x y z A $.  $d g y z B $.  $d f g x F $.  $d g ph $.  $d y ps $.
    $d f g x y C $.  $d f g h x y X $.
    $( Reverse closure for the choice set predicate.  (Contributed by Mario
       Carneiro, 31-Aug-2015.) $)
    acnrcl $p |- ( X e. AC_ A -> A e. _V ) $=
      ( vy vg vf vx cvv wcel cv cfv wral wex cpw c0 csn cdif cmap co wa cab wne
      wacn ne0i abn0 simpl exlimiv sylbi syl df-acn eleq2s ) AGHZBUKCIZDIJULEIJ
      HCAKDLEFIMNOPAQRKZSZFTZAUBBUOHUONUAZUKUOBUCUPUNFLUKUNFUDUNUKFUKUMUEUFUGUH
      FCAEDUIUJ $.

    $( Equality theorem for the choice set function.  (Contributed by Mario
       Carneiro, 31-Aug-2015.) $)
    acneq $p |- ( A = C -> AC_ A = AC_ C ) $=
      ( vy vg vf vx wceq cvv wcel cv cfv wral wex cpw cmap co cab wacn df-acn
      wa c0 csn cdif eleq1 oveq2 raleq exbidv raleqbidv anbi12d abbidv 3eqtr4g
      ) ABGZAHIZCJZDJKUNEJKIZCALZDMZEFJNUAUBUCZAOPZLZTZFQBHIZUOCBLZDMZEURBOPZLZ
      TZFQARBRULVAVGFULUMVBUTVFABHUDULUQVDEUSVEABUROUEULUPVCDUOCABUFUGUHUIUJFCA
      EDSFCBEDSUK $.

    $( The property of being a choice set of length ` A ` .  (Contributed by
       Mario Carneiro, 31-Aug-2015.) $)
    isacn $p |- ( ( X e. V /\ A e. W ) -> ( X e. AC_ A <->
      A. f e. ( ( ~P X \ { (/) } ) ^m A )
        E. g A. x e. A ( g ` x ) e. ( f ` x ) ) ) $=
      ( vy wcel wacn cvv cv cfv wral wex cpw cdif cmap co wa c0 csn wceq oveq1d
      pweq difeq1d raleqdv anbi2d df-acn elab2g wb elex biid baib syl sylan9bb
      ) GEIGBJZIBKIZALZDLMUSCLMIABNDOZCGPZUAUBZQZBRSZNZTZBFIZVEURUTCHLZPZVBQZBR
      SZNZTVFHGUQEVHGUCZVLVEURVMUTCVKVDVMVJVCBRVMVIVAVBVHGUEUFUDUGUHHABCDUIUJVG
      URVFVEUKBFULVFURVEVFUMUNUOUP $.

    $( The property of being a choice set of length ` A ` .  (Contributed by
       Mario Carneiro, 31-Aug-2015.) $)
    acni $p |- ( ( X e. AC_ A /\ F : A --> ( ~P X \ { (/) } ) ) ->
        E. g A. x e. A ( g ` x ) e. ( F ` x ) ) $=
      ( vf wacn wcel cpw c0 csn cdif wf wa cv cfv wral wex cvv wb cmap co pwexg
      difexg acnrcl elmapg syl2anc biimpar isacn mpdan adantr wceq fveq1 eleq2d
      syl ibi ralbidv exbidv rspcv sylc ) EBGZHZBEIZJKZLZDMZNDVEBUAUBZHZAOZCOPZ
      VIFOZPZHZABQZCRZFVGQZVJVIDPZHZABQZCRZVBVHVFVBVESHZBSHZVHVFTVBVCSHWAEVAUCV
      CVDSUDUOBEUEZVEBDSSUFUGUHVBVPVFVBVPVBWBVBVPTWCABFCVASEUIUJUPUKVOVTFDVGVKD
      ULZVNVSCWDVMVRABWDVLVQVJVIVKDUMUNUQURUSUT $.

    ${
      $d f B $.
      $( The property of being a choice set of length ` A ` .  (Contributed by
         Mario Carneiro, 31-Aug-2015.) $)
      acni2 $p |- ( ( X e. AC_ A /\ A. x e. A ( B C_ X /\ B =/= (/) ) ) ->
          E. g ( g : A --> X /\ A. x e. A ( g ` x ) e. B ) ) $=
        ( vy vf wcel c0 wa wral cv cfv cmpt wex wf wceq fveq2 cvv eleq1d elpw2g
        wacn wss wne cpw csn cdif eldifsn anbi1d syl5bb ralbidv eqid fmpt sylib
        biimpar syldan nffvmpt1 nfel2 nfv eleq12d cbvral simplr wb simpll simpr
        ssexd fvmpt2 syl2anc eleq2d ex adantrd ralimdva imp ralbi syl biimpa wi
        acni ssel adantr ral2imi sylc rspccva sylan acnrcl fex2 syl3anc ralbiia
        fmptd fvex fvmpt sylibr jca feq1 fveq1 anbi12d spcegv syl5bi exlimdv
        mpd ) EBUBZHZCEUCZCIUDZJZABKZJZFLZGLZMZXHABCNZMZHZFBKZGOZBEDLZPZALZXPMZ
        CHZABKZJZDOZXBXFBEUEZIUFUGZXKPZXOXGCYEHZABKZYFXBYHXFXBYGXEABYGCYDHZXDJX
        BXECYDIUHXBYIXCXDCEXAUAUIUJUKUOABYECXKXKULZUMUNFBGXKEVRUPXGXNYCGXNXRXIM
        ZXRXKMZHZABKZXGYCXMYMFABAXJXLABCXHUQURYMFUSXHXRQXJYKXLYLXHXRXIRZXHXRXKR
        UTVAXGYNYCXGYNJZFBXJNZSHZBEYQPZXRYQMZCHZABKZJZYCYPYSBSHZXBYRYPFBXJEYQYP
        YKEHZABKZXHBHXJEHZYPXFYKCHZABKZUUFXBXFYNVBXGYNUUIXGYMUUHVCZABKZYNUUIVCX
        BXFUUKXBXEUUJABXBXRBHZJZXCUUJXDUUMXCUUJUUMXCJZYLCYKUUNUULCSHYLCQXBUULXC
        VBUUNCEXAXBUULXCVDUUMXCVEVFABCSXKYJVGVHVIVJVKVLVMYMUUHABVNVOVPZXEUUHUUE
        ABXCUUHUUEVQXDCEYKVSVTWAWBUUEUUGAXHBXRXHQYKXJEXRXHXIRTWCWDYQULZWIZYPXBU
        UDXBXFYNVDZBEWEVOUURBEYQSXAWFWGYPYSUUBUUQYPUUIUUBUUOUUAUUHABUULYTYKCFXR
        XJYKBYQYOUUPXRXIWJWKTWHWLWMYBUUCDYQSXPYQQZXQYSYAUUBBEXPYQWNUUSXTUUAABUU
        SXSYTCXRXPYQWOTUKWPWQWBVJWRWSWT $.
    $}

    ${
      acni3.1 $e |- ( y = ( g ` x ) -> ( ph <-> ps ) ) $.
      $( The property of being a choice set of length ` A ` .  (Contributed by
         Mario Carneiro, 31-Aug-2015.) $)
      acni3 $p |- ( ( X e. AC_ A /\ A. x e. A E. y e. X ph ) ->
          E. g ( g : A --> X /\ A. x e. A ps ) ) $=
        ( wacn wcel wrex wral wa cv wf cfv crab wex wss ralimi c0 rabn0 biimpri
        wne ssrab2 jctil acni2 sylan2 elrab simprbi anim2i eximi syl ) GEIJZADG
        KZCELZMEGFNZOZCNUQPZADGQZJZCELZMZFRZURBCELZMZFRUPUNUTGSZUTUAUDZMZCELVDU
        OVICEUOVHVGVHUOADGUBUCADGUEUFTCEUTFGUGUHVCVFFVBVEURVABCEVAUSGJBABDUSGHU
        IUJTUKULUM $.
    $}

    $( Construct a mapping satisfying the consequent of ~ isacn .  (Contributed
       by Mario Carneiro, 31-Aug-2015.) $)
    acnlem $p |- ( ( A e. V /\ A. x e. A B e. ( f ` x ) ) ->
      E. g A. x e. A ( g ` x ) e. ( f ` x ) ) $=
      ( wcel cv cfv wral wa cmpt cvv wex crn cuni wf fvssunirn simpr ralimiaa
      sseldi eqid fmpt sylib id rnex uniex mp3an3 syl2anr fvmpt2 eqeltrd adantl
      vex fex2 wceq nfmpt1 nfeq2 fveq1 eleq1d ralbid spcegv sylc ) BFGZCAHZDHZI
      ZGZABJZKABCLZMGZVDVIIZVFGZABJZVDEHZIZVFGZABJZENVHBVEOZPZVIQZVCVJVCVHCVSGZ
      ABJVTVGWAABVDBGZVGKZVFVSCVEVDRWBVGSZUATABVSCVIVIUBZUCUDVCUEVTVCVSMGVJVRVE
      DUMUFUGBVSVIFMUNUHUIVHVMVCVGVLABWCVKCVFABCVFVIWEUJWDUKTULVQVMEVIMVNVIUOZV
      PVLABAVNVIABCUPUQWFVOVKVFVDVNVIURUSUTVAVB $.

    $( A well-orderable set has choice sequences of every length.  (Contributed
       by Mario Carneiro, 31-Aug-2015.) $)
    numacn $p |- ( A e. V -> ( X e. dom card -> X e. AC_ A ) ) $=
      ( vx vg vf vh vy wcel cvv wa cv cfv wral wex c0 wf wss syl syl2anc cdm wi
      ccrd wacn elex cpw csn cdif cmap co crn cuni simpll elmapi adantl difss2d
      wn frn sspwuni sylib ssnum cin wceq ssdifin0 disjsn ac5num simpllr wfn wb
      ffn fveq2 id eleq12d ralrn biimpa adantrl acnlem exlimddv ralrimiva isacn
      mpbird expcom ) ABIAJIZCUCUAZIZCAUDIZUBABUEWEWCWFWEWCKZWFDLZELMWHFLZMZIDA
      NEOZFCUFZPUGZUHZAUIUJZNWGWKFWOWGWIWOIZKZWIUKZWRULZGLZQZHLZWTMZXBIZHWRNZKZ
      WKGWQWSWDIZPWRIUQZXFGOWQWEWSCRZXGWEWCWPUMWQWRWLRXIWQWRWLWMWQAWNWIQZWRWNRZ
      WPXJWGWIWNAUNUOZAWNWIURSZUPWRCUSUTCWSVATWQWRWMVBPVCZXHWQXKXNXMWRWLWMVDSWR
      PVEUTHWRGVFTWQXFKWCWJWTMZWJIZDANZWKWEWCWPXFVGWQXEXQXAWQXEXQWQWIAVHZXEXQVI
      WQXJXRXLAWNWIVJSXDXPHDAWIXBWJVCZXCXOXBWJXBWJWTVKXSVLVMVNSVOVPDAXOFEJVQTVR
      VSDAFEWDJCVTWAWBS $.

    $( Every set has finite choice sequences.  (Contributed by Mario Carneiro,
       31-Aug-2015.) $)
    finacn $p |- ( A e. Fin -> AC_ A = _V ) $=
      ( vx vy vg vf vz cfn wcel wacn cvv cv cfv wral wex cpw c0 wa wf ralrimiva
      syl csn cdif cmap co wrex elmapi adantl wne ffvelrn eldifsni sylib sylibr
      n0 rexv eleq1 ac6sfi syldan exsimpr vex isacn mpan mpbird a1i 2thd eqrdv
      wb ) AGHZBAIZJVGBKZVHHZVIJHZVGVJCKZDKZLZVLEKZLZHZCAMZDNZEVIOZPUAUBZAUCUDZ
      MZVGVSEWBVGVOWBHZQZAJVMRZVRQDNZVSVGWDFKZVPHZFJUEZCAMZWGWEAWAVORZWKWDWLVGV
      OWAAUFUGWLWJCAWLVLAHQZWIFNZWJWMVPPUHZWNWMVPWAHWOAWAVLVOUIVPVTPUJTFVPUMUKW
      IFUNULSTWIVQCFAJDWHVNVPUOUPUQWFVRDURTSVKVGVJWCVFBUSZCAEDJGVIUTVAVBVKVGWPV
      CVDVE $.
  $}

  ${
    $d f g h k x y z A $.  $d f g k x y z B $.  $d f g h k x y z X $.
    $d f g k x Y $.
    $( A set with long choice sequences also has shorter choice sequences,
       where "shorter" here means the new index set is dominated by the old
       index set.  (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    acndom $p |- ( A ~<_ B -> ( X e. AC_ B -> X e. AC_ A ) ) $=
      ( vf vx vz vh vg vk vy cv wex wcel c0 wceq cfv wral wa wf cvv cdom wbr wi
      wf1 wacn brdomi wn neq0 w3a cpw csn cdif cmap crn ccnv cif wss wne simpl3
      co elmapi ad2antlr wf1o simpll1 f1f1orn f1ocnv f1of 4syl ffvelrnda simpl2
      ad2antrr ifclda ffvelrnd eldifsn elpwi anim1i sylbi syl ralrimiva syl2anc
      acni2 cdm f1dm vex syl6eqelr 3ad2ant1 f1f frn ssralv iftrue fveq2d eleq2d
      dmex ralbiia syl6ib wfn wb f1fn fveq2 eleq12d ralrn 3syl sylibd f1ocnvfv1
      sylan ralbidva impr acnlem elex isacn syl2anr 3adant2 mpbird 3exp exlimdv
      exlimddv syl5bi acneq 0fin finacn ax-mp syl6eq syl5ibr pm2.61d2 exlimiv
      cfn ) ABUAUBABDKZUDZDLCBUEZMZCAUEZMZUCZABDUFYHYMDYHANOZYMYNUGEKZAMZELYHYM
      EAUHYHYPYMEYHYPYJYLYHYPYJUIZYLFKZGKPYRHKZPZMFAQGLZHCUJZNUKULZAUMUTZQZYQUU
      AHUUDYQYSUUDMZRZBCIKZSZJKZUUHPZUUJYGUNZMZUUJYGUOZPZYOUPZYSPZMZJBQZRZUUAIU
      UGYJUUQCUQZUUQNURZRZJBQUUTILYHYPYJUUFUSUUGUVCJBUUGUUJBMZRZUUQUUCMZUVCUVEA
      UUCUUPYSUUFAUUCYSSYQUVDYSUUCAVAVBUVEUUMUUOYOAUVEUULAUUJUUNUVEYHAUULYGVCZU
      ULAUUNVCUULAUUNSYHYPYJUUFUVDVDABYGVEZAUULYGVFUULAUUNVGVHVIUUGYPUVDUUMUGYH
      YPYJUUFVJVKVLVMUVFUUQUUBMZUVBRUVCUUQUUBNVNUVIUVAUVBUUQCVOVPVQVRVSJBUUQICW
      AVTUUGUUTRATMZYRYGPZUUHPZYTMZFAQZUUAYQUVJUUFUUTYHYPUVJYJYHAYGWBTABYGWCYGD
      WDWMWEZWFVKUUGUUIUUSUVNUUGUUIRZUUSUVLUVKUUNPZYSPZMZFAQZUVNUVPUUSUUKUUOYSP
      ZMZJUULQZUVTUVPUUSUURJUULQZUWCUVPYHABYGSUULBUQUUSUWDUCYHYPYJUUFUUIVDZABYG
      WGABYGWHUURJUULBWIVHUURUWBJUULUUMUUQUWAUUKUUMUUPUUOYSUUMUUOYOWJWKWLWNWOUV
      PYHYGAWPUWCUVTWQUWEABYGWRUWBUVSJFAYGUUJUVKOZUUKUVLUWAUVRUUJUVKUUHWSUWFUUO
      UVQYSUUJUVKUUNWSWKWTXAXBXCUVPUVSUVMFAUVPYRAMZRZUVRYTUVLUWHUVQYRYSUVPUVGUW
      GUVQYROUVPYHUVGUWEUVHVRAUULYRYGXDXEWKWLXFXCXGFAUVLHGTXHVTXPVSYHYJYLUUEWQZ
      YPYJCTMZUVJUWIYHCYIXIZUVOFAHGTTCXJXKXLXMXNXOXQYJYLYNUWJUWKYNYKTCYNYKNUEZT
      ANXRNYFMUWLTOXSNXTYAYBWLYCYDYEVR $.

    $( A set ` X ` which has choice sequences on it of length ` ~P X ` is
       well-orderable (and hence has choice sequences of every length).
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    acnnum $p |- ( X e. AC_ ~P X <-> X e. dom card ) $=
      ( vx vf cpw wacn wcel ccrd cdm cv c0 wne cfv wi wral wex wa wss cvv pwexg
      mpcom csn cdif wf cdom wbr difss ssdomg acndom eldifsn elpwi anim1i sylbi
      ee10 rgen acni2 sylancl simpr imbi1i impexp bitri ralbii2 sylib eximi syl
      dfac8a mpd numacn impbii ) AADZEZFZAGHZFZVKBIZJKZVNCIZLVNFZMZBVINZCOZVMVK
      VIJUAZUBZAVPUCZVQBWBNZPZCOZVTVKAWBEFZVNAQZVOPZBWBNWFWBVIUDUEZVKWGVKVIRFZW
      BVIQWJAVJSVIWAUFWBVIRUGUMWBVIAUHTWIBWBVNWBFZVNVIFZVOPZWIVNVIJUIZWMWHVOVNA
      UJUKULUNBWBVNCAUOUPWEVSCWEWDVSWCWDUQVQVRBWBVIWLVQMWNVQMWMVRMWLWNVQWOURWMV
      OVQUSUTVAVBVCVDBAVJCVEVFWKVMVKAVLSVIRAVGTVH $.

    $( The class of choice sets of length ` A ` is a cardinal invariant.
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    acnen $p |- ( A ~~ B -> AC_ A = AC_ B ) $=
      ( vx cen wbr wacn cv wcel cdom ensym endom acndom 3syl syl impbid eqrdv
      wi ) ABDEZCAFZBFZRCGZSHZUATHZRBADEBAIEUBUCQABJBAKBAUALMRABIEUCUBQABKABUAL
      NOP $.

    $( A set smaller than one with choice sequences of length ` A ` also has
       choice sequences of length ` A ` .  (Contributed by Mario Carneiro,
       31-Aug-2015.) $)
    acndom2 $p |- ( X ~<_ Y -> ( Y e. AC_ A -> X e. AC_ A ) ) $=
      ( vf vx vh vg vk cv wex wcel wa cfv wral c0 wf wss wne syl cvv wbr wf1 wi
      cdom wacn brdomi cpw csn cdif cmap co cima simplr crn imassrn simplll f1f
      frn 3syl syl5ss cdm cin wceq elmapi adantl ffvelrnda elpwid f1dm sseqtr4d
      eldifad dfss1 sylib eldifsni eqnetrd necon3bii sylibr jca ralrimiva acni2
      imadisj syl2anc ccnv acnrcl ad3antlr wf1o simp-4l simprr sseldi f1ocnvfv2
      f1f1orn eqeltrd wb f1ocnv f1of ffvelrnd ad2ant2r f1elima syl3anc ralimdva
      mpbid expr impr acnlem exlimddv vex dmex syl6eqelr isacn syl2an mpbird ex
      exlimiv ) BCUDUABCDIZUBZDJCAUEZKZBXOKZUCZBCDUFXNXRDXNXPXQXNXPLZXQEIZFIMXT
      GIZMZKEANFJZGBUGZOUHZUIZAUJUKZNZXSYCGYGXSYAYGKZLZACHIZPZXTYKMZXMYBULZKZEA
      NZLZYCHYJXPYNCQZYNORZLZEANYQHJXNXPYIUMYJYTEAYJXTAKZLZYRYSUUBYNXMUNZCXMYBU
      OZUUBXNBCXMPUUCCQXNXPYIUUAUPZBCXMUQBCXMURUSUTUUBXMVAZYBVBZORYSUUBUUGYBOUU
      BYBUUFQUUGYBVCUUBYBBUUFUUBYBBUUBYBYDYEYJAYFXTYAYIAYFYAPXSYAYFAVDVEVFZVJVG
      ZUUBXNUUFBVCUUEBCXMVHZSVIYBUUFVKVLUUBYBYFKYBORUUHYBYDOVMSVNYNOUUGOXMYBVTV
      OVPVQVREAYNHCVSWAYJYQLATKZYMXMWBZMZYBKZEANZYCXPUUKXNYIYQACWCZWDYJYLYPUUOY
      JYLLZYOUUNEAUUQUUAYOUUNUUQUUAYOLZLZUUMXMMZYNKZUUNUUSUUTYMYNUUSBUUCXMWEZYM
      UUCKUUTYMVCUUSXNUVBXNXPYIYLUURWFZBCXMWJSZUUSYNUUCYMUUDUUQUUAYOWGZWHZBUUCY
      MXMWIWAUVEWKUUSXNUUMBKYBBQZUVAUUNWLUVCUUSUUCBYMUULUUSUVBUUCBUULWEUUCBUULP
      UVDBUUCXMWMUUCBUULWNUSUVFWOYJUUAUVGYLYOUUIWPBCXMUUMYBWQWRWTXAWSXBEAUUMGFT
      XCWAXDVRXNBTKUUKXQYHWLXPXNBUUFTUUJXMDXEXFXGUUPEAGFTTBXHXIXJXKXLS $.

    $( The class of sets with choice sequences of length ` A ` is a cardinal
       invariant.  (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    acnen2 $p |- ( X ~~ Y -> ( X e. AC_ A <-> Y e. AC_ A ) ) $=
      ( cen wbr wacn wcel cdom wi ensym endom acndom2 3syl syl impbid ) BCDEZBA
      FZGZCQGZPCBDECBHERSIBCJCBKACBLMPBCHESRIBCKABCLNO $.
  $}

  ${
    $d f x y z A $.  $d f x y z B $.  $d f x y z F $.
    $( A version of ~ fodom that doesn't require the Axiom of Choice ~ ax-ac .
       If ` A ` has choice sequences of length ` B ` , then any surjection from
       ` A ` to ` B ` can be inverted to an injection the other way.
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    fodomacn $p |- ( A e. AC_ B -> ( F : A -onto-> B -> B ~<_ A ) ) $=
      ( vf vx vy vz wcel wa cv cfv wceq fveq2 cvv weq id fveq2d eqeq12d rspccva
      wral wacn wfo cdom wbr wf wex foelrn ralrimiva eqeq2d acni3 sylan2 simpll
      wrex wf1 acnrcl syl wi simprl simprr eqeqan12d anandis syl5ibr ralrimivva
      wb sylan dff13 sylanbrc f1dom2g syl3anc exlimddv ex ) ABUAZHZABCUBZBAUCUD
      ZVMVNIZBADJZUEZEJZVSVQKZCKZLZEBTZIZVODVNVMVSFJZCKZLZFAUMZEBTWDDUFVNWHEBFA
      BVSCUGUHWGWBEFBDAWEVTLWFWAVSWEVTCMUIUJUKVPWDIZBNHZVMBAVQUNZVOWIVMWJVMVNWD
      ULZBAUOUPWLWIVRWEVQKZGJZVQKZLZFGOZUQZGBTFBTWKVPVRWCURWIWRFGBBWPWQWIWEBHZW
      NBHZIZIWMCKZWOCKZLZWMWOCMWIWCXAWQXDVDZVPVRWCUSWCWSWTXEWCWSIWCWTIWEXBWNXCW
      BWEXBLEWEBEFOZVSWEWAXBXFPXFVTWMCVSWEVQMQRSWBWNXCLEWNBEGOZVSWNWAXCXGPXGVTW
      OCVSWNVQMQRSUTVAVEVBVCFGBAVQVFVGBAVQNVLVHVIVJVK $.
  $}

  ${
    $d r x y z A $.  $d r w x z B $.  $d r t w x y z F $.
    $( A version of ~ fodom that doesn't require the Axiom of Choice ~ ax-ac .
       (Contributed by Mario Carneiro, 28-Feb-2013.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    fodomnum $p |- ( A e. dom card -> ( F : A -onto-> B -> B ~<_ A ) ) $=
      ( wfo ccrd cdm wcel wacn cdom wbr cvv fornex com12 numacn syli fodomacn )
      ABCDZAEFZGZABHGZBAIJQSTSQBKGZTSQUAABRCLMBKANOMABCPO $.
  $}

  $( A surjection maps numerable sets to numerable sets.  (Contributed by Mario
     Carneiro, 30-Apr-2015.) $)
  fonum $p |- ( ( A e. dom card /\ F : A -onto-> B ) -> B e. dom card ) $=
    ( ccrd cdm wcel wfo cdom wbr fodomnum imp numdom syldan ) ADEZFZABCGZBAHIZB
    NFOPQABCJKABLM $.

  ${
    $d f A $.  $d f B $.
    $( A surjection maps numerable sets to numerable sets.  (Contributed by
       Mario Carneiro, 27-Aug-2015.) $)
    numwdom $p |- ( ( A e. dom card /\ B ~<_* A ) -> B e. dom card ) $=
      ( vf cwdom wbr ccrd cdm wcel c0 wceq cv wfo wex wo brwdomi simpr cfn 0fin
      wa finnum ax-mp syl6eqel fonum ex exlimdv imp jaodan sylan2 ) BADEAFGZHZB
      IJZABCKZLZCMZNBUIHZCBAOUJUKUOUNUJUKSBIUIUJUKPIQHIUIHRITUAUBUJUNUOUJUMUOCU
      JUMUOABULUCUDUEUFUGUH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x V $.  $d x X $.  $d x Y $.
    $( Onto functions define dominance when a finite number of choices need to
       be made.  (Contributed by Stefan O'Rear, 28-Feb-2015.) $)
    fodomfi2 $p |- ( ( A e. V /\ B e. Fin /\ F : A -onto-> B ) -> B ~<_ A ) $=
      ( vx wcel cfn wfo w3a wceq cdom wbr wss 3ad2ant3 syl sseli adantl syl2anc
      cdm sylc cv cima cpw cin wrex wfn crn fofn eqimss2 simp2 fipreima syl3anc
      forn wa ccrd cres inss2 finnum wfun simpl3 fofun inss1 elpwid wf fof 3syl
      fdm sseqtr4d fores fodomnum simpl1 ssdomg domtr breq1 syl5ibcom rexlimdva
      mpd ) ADFZBGFZABCHZIZCEUAZUBZBJZEAUCZGUDZUEZBAKLZWACAUFZBCUGZMZVSWGVTVRWI
      VSABCUHNVTVRWKVSVTWJBJWKABCUMBWJUIONVRVSVTUJBACEUKULWAWDWHEWFWAWBWFFZUNZW
      CAKLZWDWHWMWCWBKLZWBAKLZWNWMWBUOSFZWBWCCWBUPZHZWOWMWBGFZWQWLWTWAWFGWBWEGU
      QPQWBUROWMCUSZWBCSZMWSWMVTXAVRVSVTWLUTZABCVAOWMWBAXBWLWBAMZWAWLWBAWFWEWBW
      EGVBPVCQZWMVTABCVDXBAJXCABCVEABCVGVFVHWBCVIRWBWCWRVJTWMVRXDWPVRVSVTWLVKXE
      WBADVLTWCWBAVMRWCBAKVNVOVPVQ $.

    $( Weak dominance agrees with normal for finite left sets.  (Contributed by
       Stefan O'Rear, 28-Feb-2015.)  (Revised by Mario Carneiro,
       5-May-2015.) $)
    wdomfil $p |- ( X e. Fin -> ( X ~<_* Y <-> X ~<_ Y ) ) $=
      ( vx cfn wcel cwdom wbr cdom wi c0 wceq cvv relwdom brrelex2i 0domg breq1
      syl syl5ibr adantl wa wne cv wfo wex wb brwdomn0 wf vex fof dmfex sylancr
      simpl simpr fodomfi2 syl3anc ex adantr exlimdv pm2.61dane domwdom impbid1
      sylbid ) ADEZABFGZABHGZVCVDVEIZAJAJKZVFVCVDVEVGJBHGZVDBLEZVHABFMNBLOQAJBH
      PRSVCAJUAZTZVDBACUBZUCZCUDZVEVJVDVNUEVCCABUFSVKVMVECVCVMVEIVJVCVMVEVCVMTV
      IVCVMVEVMVIVCVMVLLEBAVLUGVICUHBAVLUIBALVLUJUKSVCVMULVCVMUMBAVLLUNUOUPUQUR
      VBUSABUTVA $.
  $}

  ${
    $d m n x y A $.
    $( Any infinite well-orderable set is equinumerous to its set of finite
       subsets.  (Contributed by Mario Carneiro, 18-May-2015.) $)
    infpwfien $p |- ( ( A e. dom card /\ om ~<_ A ) ->
      ( ~P A i^i Fin ) ~~ A ) $=
      ( vn vx vy vm wcel com cdom wbr wa cfn cen cv cmap syl2anc wf wss syl cvv
      wceq ccrd cdm cpw cin co ciun crn cmpt wfo cxp wne infxpidm2 infn0 adantl
      c0 fseqen xpdom1g domentr endomtr numdom syldan wfn eliun elmapi ad2antll
      wrex frn vex rnex elpw sylibr simprl ssid ssnnfi sylancl dffn4 sylib fofi
      ffn elin sylanbrc expr rexlimdva syl5bi imp eqid fmptd inss2 simpr sseldi
      wex isfi wf1o ensym bren inss1 simplr elpwid fss wb simplll elmapg mpbird
      f1of oveq2 eleq2d rspcev f1ofo forn eqcomd jca eximdv syl5 mpd ex elrnmpt
      ax-mp df-rex bitri syl6ibr ssrdv eqssd df-fo fodomnum domtr adantr inex1g
      sylc pwexg infpwfidom sbth ) AUAUBZFZGAHIZJZAUCZKUDZAHIZAYQHIZYQALIYOYQBG
      ABMZNUEZUFZHIZUUBAHIZYRYOUUBYLFZUUBYQCUUBCMZUGZUHZUIZUUCYMYNUUDUUEYOUUBGA
      UJZLIZUUJAHIZUUDYOAAUJZALIZAUOUKZUUKAULZYNUUOYMAUMUNABUPOYOUUJUUMHIUUNUUL
      GAAYLUQUUPUUJUUMAUROUUBUUJAUSOZAUUBUTVAYOUUHUUBVBZUUHUGZYQTUUIYOUUBYQUUHP
      ZUURYOCUUBUUGYQUUHYOUUFUUBFZUUGYQFZUVAUUFUUAFZBGVFZYOUVBBUUFGUUAVCZYOUVCU
      VBBGYOYTGFZUVCUVBYOUVFUVCJJZUUGYPFZUUGKFZUVBUVGUUGAQZUVHUVGYTAUUFPZUVJUVC
      UVKYOUVFUUFAYTVDVEZYTAUUFVGRUUGAUUFCVHVIVJVKUVGYTKFZYTUUGUUFUIZUVIUVGUVFY
      TYTQUVMYOUVFUVCVLYTVMYTYTVNVOUVGUVKUVNUVLUVKUUFYTVBUVNYTAUUFVSYTUUFVPVQRY
      TUUGUUFVROUUGYPKVTWAWBWCWDWEUUHWFZWGZUUBYQUUHVSRYOUUSYQYOUUTUUSYQQUVPUUBY
      QUUHVGRYODYQUUSYODMZYQFZUVAUVQUUGTZJZCWKZUVQUUSFZYOUVRUWAYOUVRJZUVQEMZLIZ
      EGVFZUWAUWCUVQKFUWFUWCYQKUVQYPKWHYOUVRWIWJEUVQWLVQUWCUWEUWAEGUWEUWDUVQUUF
      WMZCWKZUWCUWDGFZJZUWAUWEUWDUVQLIUWHUVQUWDWNUWDUVQCWOVQUWJUWGUVTCUWCUWIUWG
      UVTUWCUWIUWGJZJZUVAUVSUWLUVDUVAUWLUWIUUFAUWDNUEZFZUVDUWCUWIUWGVLUWLUWNUWD
      AUUFPZUWLUWDUVQUUFPZUVQAQUWOUWGUWPUWCUWIUWDUVQUUFXDVEUWLUVQAUWLYQYPUVQYPK
      WPYOUVRUWKWQWJWRUWDUVQAUUFWSOUWLYMUWDSFUWNUWOWTYMYNUVRUWKXAEVHAUWDUUFYLSX
      BVOXCUVCUWNBUWDGYTUWDTUUAUWMUUFYTUWDANXEXFXGOUVEVKUWLUUGUVQUWLUWDUVQUUFUI
      ZUUGUVQTUWGUWQUWCUWIUWDUVQUUFXHVEUWDUVQUUFXIRXJXKWBXLXMWCXNXOUWBUVSCUUBVF
      ZUWAUVQSFUWBUWRWTDVHCUUBUUGUVQUUHSUVOXPXQUVSCUUBXRXSXTYAYBUUBYQUUHYCWAUUB
      YQUUHYDYHUUQYQUUBAYEOYOYQSFZYSYOYPSFZUWSYMUWTYNAYLYIYFYPKSYGRAYJRYQAYKO
      $.

    $( The set of finite intersections of an infinite well-orderable set is
       equinumerous to the set itself.  (Contributed by Mario Carneiro,
       18-May-2015.) $)
    inffien $p |- ( ( A e. dom card /\ om ~<_ A ) -> ( fi ` A ) ~~ A ) $=
      ( vx ccrd cdm wcel com cdom wbr wa cfi cfv cen cpw cfn cin cvv wss ssdomg
      syl2anc adantr c0 csn cdif cv cint wfo infpwfien relen brrelexi syl difss
      cmpt ee10 domentr numdom syldan eqid fifo fodomnum sylc domtr ssfii mpsyl
      fvex sbth ) ACDZEZFAGHZIZAJKZAGHZAVJGHZVJALHVIVJAMNOZUAUBZUCZGHZVOAGHZVKV
      IVOVFEZVOVJBVOBUDUEULZUFZVPVGVHVQVRVIVOVMGHZVMALHZVQVIVMPEZVOVMQWAVIWBWCA
      UGZVMALUHUIUJVMVNUKVOVMPRUMWDVOVMAUNSZAVOUOUPVGVTVHBAVSVFVSUQURTVOVJVSUSU
      TWEVJVOAVASVJPEVIAVJQZVLAJVDVGWFVHAVFVBTAVJPRVCVJAVES $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Weak dominance agrees with normal for numerable right sets.
       (Contributed by Stefan O'Rear, 28-Feb-2015.)  (Revised by Mario
       Carneiro, 5-May-2015.) $)
    wdomnumr $p |- ( B e. dom card -> ( A ~<_* B <-> A ~<_ B ) ) $=
      ( vx ccrd cdm wcel cwdom wbr cdom c0 wceq cv wfo wex wo brwdom syl5ibrcom
      0domg breq1 fodomnum exlimdv jaod sylbid domwdom impbid1 ) BDEZFZABGHZABI
      HZUGUHAJKZBACLZMZCNZOUICUFABPUGUJUIUMUGUIUJJBIHBUFRAJBISQUGULUICBAUKTUAUB
      UCABUDUE $.
  $}

  $( The aleph function is a function on the class of ordinal numbers.
     (Contributed by NM, 21-Oct-2003.)  (Revised by Mario Carneiro,
     13-Sep-2013.) $)
  alephfnon $p |- aleph Fn On $=
    ( cale con0 wfn char com crdg rdgfnon df-aleph fneq1i mpbir ) ABCDEFZBCEDGB
    AKHIJ $.

  $( The first infinite cardinal number, discovered by Georg Cantor in 1873,
     has the same size as the set of natural numbers ` om ` (and under our
     particular definition is also equal to it).  In the literature, the
     argument of the aleph function is often written as a subscript, and the
     first aleph is written ` aleph ` _0.  Exercise 3 of [TakeutiZaring]
     p. 91.  Also Definition 12(i) of [Suppes] p. 228.  From Mosh&eacute
     Machover, _Set Theory, Logic, and Their Limitations_, p. 95:  "Aleph...the
     first letter in the Hebrew alphabet...is also the first letter of the
     Hebrew word...(_einsoph_, meaning infinity), which is a cabbalistic
     appellation of the deity.  The notation is due to Cantor, who was deeply
     interested in mysticism."  (Contributed by NM, 21-Oct-2003.)  (Revised by
     Mario Carneiro, 13-Sep-2013.) $)
  aleph0 $p |- ( aleph ` (/) ) = om $=
    ( c0 cale cfv char com crdg df-aleph fveq1i omex rdg0 eqtri ) ABCADEFZCEABL
    GHEDIJK $.

  ${
    $d x y A $.  $d x B $.
    $( Value of the aleph function at a limit ordinal.  Definition 12(iii) of
       [Suppes] p. 91.  (Contributed by NM, 21-Oct-2003.)  (Revised by Mario
       Carneiro, 13-Sep-2013.) $)
    alephlim $p |- ( ( A e. V /\ Lim A ) -> ( aleph ` A ) =
                   U_ x e. A ( aleph ` x ) ) $=
      ( wcel wlim char com crdg cfv ciun cale rdglim2a df-aleph fveq1i wceq a1i
      wa cv iuneq2i 3eqtr4g ) BCDBEQBFGHZIABARZUAIZJBKIABUBKIZJAGBCFLBKUAMNABUD
      UCUDUCOUBBDUBKUAMNPST $.

    $( Value of the aleph function at a successor ordinal.  Definition 12(ii)
       of [Suppes] p. 91.  Here we express the successor aleph in terms of the
       Hartogs function ~ df-har , which gives the smallest ordinal that
       strictly dominates its argument (or the supremum of all ordinals that
       are dominated by the argument).  (Contributed by Mario Carneiro,
       13-Sep-2013.)  (Revised by Mario Carneiro, 15-May-2015.) $)
    alephsuc $p |- ( A e. On ->
      ( aleph ` suc A ) = ( har ` ( aleph ` A ) ) ) $=
      ( con0 wcel csuc char com crdg cale rdgsuc df-aleph fveq1i fveq2i 3eqtr4g
      cfv ) ABCADZEFGZNAPNZENOHNAHNZENFAEIOHPJKRQEAHPJKLM $.

    $( An aleph is an ordinal number.  (Contributed by NM, 10-Nov-2003.)
       (Revised by Mario Carneiro, 13-Sep-2013.) $)
    alephon $p |- ( aleph ` A ) e. On $=
      ( vy vx con0 cale wf wfn cv wcel wral alephfnon c0 csuc wceq fveq2 eleq1d
      cfv com aleph0 cvv eqeltri char alephsuc harcl syl6eqel a1d wlim ciun vex
      omelon fvex iunonOLD alephlim mpan tfinds rgen ffnfv mpbir2an 0elon f0cli
      syl5ibr ) DDAEDDEFEDGBHZEQZDIZBDJKVDBDCHZEQZDIZLEQZDIVDVBMZEQZDIZVDCBVBVE
      LNVFVHDVELEOPVEVBNVFVCDVEVBEOPZVEVINVFVJDVEVIEOPVLVHRDSUJUAVBDIZVKVDVMVJV
      CUBQDVBUCVCUDUEUFVDBVEJVGVEUGZBVEVCUHZDIBVEVCCUIZVBEUKULVNVFVODVETIVNVFVO
      NVPBVETUMUNPVAUOUPBDDEUQURUSUT $.

    $( Every aleph is a cardinal number.  Theorem 65 of [Suppes] p. 229.
       (Contributed by NM, 25-Oct-2003.)  (Revised by Mario Carneiro,
       2-Feb-2013.) $)
    alephcard $p |- ( card ` ( aleph ` A ) ) = ( aleph ` A ) $=
      ( vx vy con0 wcel cale cfv ccrd wceq cv c0 csuc fveq2d eqeq12d com aleph0
      fveq2 3eqtr4a cvv ax-mp cardom fveq2i 3eqtr4i char alephsuc a1d wlim wral
      harcard wa ciun wi vex cardiun adantl alephlim mpan adantr 3eqtr4d tfinds
      ex wn card0 cdm wfn alephfnon fndm eleq2i ndmfv sylnbir pm2.61i ) ADEZAFG
      ZHGZVMIZBJZFGZHGZVQIZKFGZHGZVTICJZFGZHGZWCIZWBLZFGZHGZWGIZVOBCAVPKIZVRWAV
      QVTWJVQVTHVPKFQZMWKNVPWBIZVRWDVQWCWLVQWCHVPWBFQZMWMNVPWFIZVRWHVQWGWNVQWGH
      VPWFFQZMWONVPAIZVRVNVQVMWPVQVMHVPAFQZMWQNOHGOWAVTUAVTOHPUBPUCWBDEZWIWEWRW
      CUDGZHGWSWHWGWCUIWRWGWSHWBUEZMWTRUFVPUGZWECVPUHZVSXAXBUJZCVPWCUKZHGZXDVRV
      QXBXEXDIZXAVPSEZXBXFULBUMZCVPWCSUNTUOXCVQXDHXAVQXDIZXBXGXAXIXHCVPSUPUQURZ
      MXJUSVAUTVLVBZKHGKVNVMVCXKVMKHVLAFVDZEVMKIXLDAFDVEXLDIVFDFVGTVHAFVIVJZMXM
      RVK $.

    $( No cardinal can be sandwiched between an aleph and its successor aleph.
       Theorem 67 of [Suppes] p. 229.  (Contributed by NM, 10-Nov-2003.)
       (Revised by Mario Carneiro, 15-May-2015.) $)
    alephnbtwn $p |- ( ( card ` B ) = B ->
                   -. ( ( aleph ` A ) e. B /\ B e. ( aleph ` suc A ) ) ) $=
      ( vx con0 wcel ccrd cfv wceq cale csuc wa wn wi wbr wb cdm alephon onenon
      csdm adantl cardon syl6eqelr syl cardsdomel sylancr eleq2 bitrd crab cint
      id char alephsuc harval2 syl6eq eleq2d biimpd breq2 onnminsb sylan9 con2d
      cv mp2b sylan2 sylbird imnan sylib ex n0i wfn alephfnon fndm ax-mp eleq2i
      c0 ndmfv sylnbir nsyl2 sucelon sylibr con3i a1d pm2.61i ) ADEZBFGZBHZAIGZ
      BEZBAJZIGZEZKZLZMWCWEWLWCWEKZWGWJLZMWLWMWGWFBSNZWNWEWOWGOWCWEWOWFWDEZWGWE
      WFDEZBFPZEZWOWPOAQZWEBDEZWSWEBWDDWEUJBUAUBZBRUCWFBUDUEWDBWFUFUGTWEWCXAWOW
      NMXBWCXAKWJWOWCWJBWFCVAZSNZCDUHUIZEZXAWOLWCWJXFWCWIXEBWCWIWFUKGZXEAULWQWF
      WREXGXEHWTWFRCWFUMVBUNUOUPXDWOCBXCBWFSUQURUSUTVCVDWGWJVEVFVGWCLWLWEWKWCWJ
      WCWGWJWHDEZWCWJWIVNHZXHWIBVHXHWHIPZEXIXJDWHIDVIXJDHVJDIVKVLVMWHIVOVPVQAVR
      VSTVTWAWB $.
  $}

  $( No set has equinumerosity between an aleph and its successor aleph.
     (Contributed by NM, 3-Nov-2003.)  (Revised by Mario Carneiro,
     2-Feb-2013.) $)
  alephnbtwn2 $p |- -. ( ( aleph ` A ) ~< B /\ B ~< ( aleph ` suc A ) ) $=
    ( cale cfv csdm wbr wa ccrd wcel ax-mp cen con0 alephon wb cardsdomel mp2an
    onenon eleq2i bitri sylib csuc wceq cardidm alephnbtwn cdom sdomdom ondomen
    wn cdm sylancr cardid2 syl ensymd sdomentr sylan2 cardon ensdomtr alephcard
    mpancom adantl jca mto ) ACDZBEFZBAUAZCDZEFZGZVCBHDZIZVIVFIZGZVIHDZVIUBVLUH
    BUCZAVIUDJVHVJVKVHVCVIEFZVJVGVDBVIKFVOVGVIBVGBHUIZIZVIBKFZVGVFLIZBVFUEFVQVE
    MZBVFUFVFBUGUJBUKULZUMVCBVIUNUOVOVCVMIZVJVCLIVIVPIZVOWBNAMVILIZWCBUPZVIQJVC
    VIOPVMVIVCVNRSTVHVIVFEFZVKVGWFVDVRVGWFWAVIBVFUQUSUTWFVIVFHDZIZVKWDVFVPIZWFW
    HNWEVSWIVTVFQJVIVFOPWGVFVIVEURRSTVAVB $.

  ${
    $d x z A $.
    $( Lemma for ~ alephordi .  (Contributed by NM, 23-Oct-2009.)  (Revised by
       Mario Carneiro, 15-May-2015.) $)
    alephordilem1 $p |- ( A e. On -> ( aleph ` A ) ~< ( aleph ` suc A ) ) $=
      ( con0 wcel cale cfv char csuc csdm ccrd cdm wbr alephon harsdom alephsuc
      onenon mp2b syl5breqr ) ABCADEZRFEZAGDEHRBCRIJCRSHKALRORMPANQ $.
  $}

  ${
    $d A w x $.  $d A x y $.  $d B x $.
    $( Strict ordering property of the aleph function.  (Contributed by Mario
       Carneiro, 2-Feb-2013.) $)
    alephordi $p |- ( B e. On ->
                    ( A e. B -> ( aleph ` A ) ~< ( aleph ` B ) ) ) $=
      ( vx vy vw cv wcel cale cfv csdm wbr wi c0 eleq2 fveq2 breq2d imbi12d cvv
      wceq wss csuc noel pm2.21i con0 wo vex elsuc2 alephordilem1 sdomtr sylan2
      expcom imim2d com23 breq1d syl5ibr a1d com3r jaod syl5bi wlim wral cen wn
      cdom fvex ciun ssiun2s alephlim mpan sseq2d ssdomg ee02 limsuc sylbid imp
      wa domnsym syl limelon onelon sylan ensym ensdomtr ex syl2im syl5com mtod
      jcad brsdom syl6ibr tfinds ) ACFZGZAHIZWLHIZJKZLZAMGZWNMHIZJKZLADFZGZWNXA
      HIZJKZLZAXAUAZGZWNXFHIZJKZLABGZWNBHIZJKZLCDBWLMSZWMWRWPWTWLMANXMWOWSWNJWL
      MHOPQWLXASZWMXBWPXDWLXAANXNWOXCWNJWLXAHOPQWLXFSZWMXGWPXIWLXFANXOWOXHWNJWL
      XFHOPQWLBSZWMXJWPXLWLBANXPWOXKWNJWLBHOPQWRWTAUBUCXAUDGZXGXEXIXGXBAXASZUEX
      QXEXILZXAADUFUGXQXBXSXRXQXEXBXIXQXDXIXBXDXQXIXQXDXCXHJKZXIXAUHZWNXCXHUIUJ
      UKULUMXRXEXQXIXRXQXILXEXQXIXRXTYAXRWNXCXHJAXAHOUNUOUPUQURUSUMWLUTZWQXEDWL
      VAYBWMWNWOVDKZWNWOVBKZVCZVPWPYBWMYCYEWORGZYBWMWNWOTZYCWLHVEZWMYGYBWNEWLEF
      ZHIZVFZTEWLYJAWNYIAHOVGYBWOYKWNWLRGZYBWOYKSCUFZEWLRVHVIZVJUOWNWORVKVLYBWM
      YEYBWMVPZYDWOAUAZHIZJKZYOYQWOVDKZYRVCYBWMYSYBWMYPWLGZYSWLAVMYFYBYTYQWOTZY
      SYHYTUUAYBYQYKTEWLYJYPYQYIYPHOVGYBWOYKYQYNVJUOYQWORVKVLVNVOYQWOVQVRYOAUDG
      ZYDYRYBWLUDGZWMUUBYLYBUUCYMWLRVSVIWLAVTWAYDWOWNVBKZUUBWNYQJKZYRWNWOWBAUHU
      UDUUEYRWOWNYQWCWDWEWFWGWDWHWNWOWIWJUPWK $.
  $}

  $( Ordering property of the aleph function.  (Contributed by NM,
     26-Oct-2003.)  (Revised by Mario Carneiro, 9-Feb-2013.) $)
  alephord $p |- ( ( A e. On /\ B e. On ) ->
                 ( A e. B <-> ( aleph ` A ) ~< ( aleph ` B ) ) ) $=
    ( con0 wcel wa cale cfv csdm wbr wi alephordi adantl cdom wn brsdom alephon
    cen syl5bi sylibrd wceq wss wne wb domtriord mp2an con3d adantr fveq2 eqeng
    ontri1 mpsyl necon3bi a1i anim12d onelpss impbid ) ACDZBCDZEZABDZAFGZBFGZHI
    ZURUTVCJUQABKLVCVAVBMIZVAVBQIZNZEZUSUTVAVBOUSVGABUAZABUBZEUTUSVDVHVFVIUSVDB
    ADZNZVHUQVDVKJURVDVBVAHIZNZUQVKVACDZVBCDVDVMUCAPZBPVAVBUDUEUQVJVLBAKUFRUGAB
    UJSVFVIJUSVEABVNABTVAVBTVEVOABFUHVAVBCUIUKULUMUNABUOSRUP $.

  $( Ordering property of the aleph function.  Theorem 8A(a) of [Enderton]
     p. 213 and its converse.  (Contributed by NM, 3-Nov-2003.)  (Revised by
     Mario Carneiro, 9-Feb-2013.) $)
  alephord2 $p |- ( ( A e. On /\ B e. On ) ->
                  ( A e. B <-> ( aleph ` A ) e. ( aleph ` B ) ) ) $=
    ( con0 wcel wa cale cfv csdm wbr alephord ccrd wb alephon onenon cardsdomel
    cdm ax-mp mp2an alephcard eleq2i bitri syl6bb ) ACDBCDEABDAFGZBFGZHIZUCUDDZ
    ABJUEUCUDKGZDZUFUCCDUDKPDZUEUHLAMUDCDUIBMUDNQUCUDORUGUDUCBSTUAUB $.

  $( Ordering property of the aleph function.  Theorem 66 of [Suppes] p. 229.
     (Contributed by NM, 25-Oct-2003.) $)
  alephord2i $p |- ( B e. On ->
                   ( A e. B -> ( aleph ` A ) e. ( aleph ` B ) ) ) $=
    ( con0 wcel cale cfv wa onelon alephord2 biimpd expimpd mpcom ex ) BCDZABDZ
    AEFBEFDZACDZNOGPBAHQNOPQNGOPABIJKLM $.

  $( Ordering property of the aleph function.  (Contributed by NM,
     11-Nov-2003.) $)
  alephord3 $p |- ( ( A e. On /\ B e. On ) ->
                  ( A C_ B <-> ( aleph ` A ) C_ ( aleph ` B ) ) ) $=
    ( con0 wcel wa wn cale cfv wss alephord2 ancoms notbid ontri1 alephon mp2an
    wb a1i 3bitr4d ) ACDZBCDZEZBADZFBGHZAGHZDZFZABIUDUCIZUAUBUETSUBUEPBAJKLABMU
    GUFPZUAUDCDUCCDUHANBNUDUCMOQR $.

  ${
    $d A x y $.  $d B x $.
    $( A set dominated by an aleph is strictly dominated by its successor aleph
       and vice-versa.  (Contributed by NM, 3-Nov-2003.)  (Revised by Mario
       Carneiro, 2-Feb-2013.) $)
    alephsucdom $p |- ( B e. On ->
                      ( A ~<_ ( aleph ` B ) <-> A ~< ( aleph ` suc B ) ) ) $=
      ( con0 wcel cale cfv cdom wbr csuc alephordilem1 domsdomtr ex syl5com cen
      csdm ccrd cdm sdomdom alephon ondomen mpan 3syl ensymd alephnbtwn2 imnani
      cardid2 wn ensdomtr mpancom nsyl3 cardon domtriord sylibr endomtr syl2anc
      wb mp2an impbid1 ) BCDZABEFZGHZABIZEFZOHZUSUTVCOHZVAVDBJVAVEVDAUTVCKLMVDA
      APFZNHVFUTGHZVAVDVFAVDAVCGHZAPQDZVFANHZAVCRVCCDVHVIVBSVCATUAAUFUBZUCVDUTV
      FOHZUGZVGVLVFVCOHZVDVLVNBVFUDUEVJVDVNVKVFAVCUHUIUJVFCDUTCDVGVMUPAUKBSVFUT
      ULUQUMAVFUTUNUOUR $.

    $( An alternate representation of a successor aleph.  The aleph function is
       the function obtained from the ~ hartogs function by transfinite
       recursion, starting from ` om ` .  Using this theorem we could define
       the aleph function with ` { z e. On | z ~<_ x } ` in place of
       ` |^| { z e. On | x ~< z } ` in ~ df-aleph .  (Contributed by NM,
       3-Nov-2003.)  (Revised by Mario Carneiro, 2-Feb-2013.) $)
    alephsuc2 $p |- ( A e. On ->
                ( aleph ` suc A ) = { x e. On | x ~<_ ( aleph ` A ) } ) $=
      ( vy con0 wcel cv cale cfv cdom wbr crab csuc csdm alephsucdom rabbidv wa
      alephon oneli wral ccrd wceq alephcard iscard mpbi simpri rspec wi sdomel
      jca mpan2 imp impbii breq1 elrab bitr4i eqriv syl6reqr ) BDEZAFZBGHIJZADK
      USBLZGHZMJZADKZVBURUTVCADUSBNOCVBVDCFZVBEZVEDEZVEVBMJZPZVEVDEVFVIVFVGVHVB
      VEVAQZRVHCVBVBDEZVHCVBSZVBTHVBUAVKVLPVAUBCVBUCUDUEUFUIVGVHVFVGVKVHVFUGVJV
      EVBUHUJUKULVCVHAVEDUSVEVBMUMUNUOUPUQ $.
  $}

  $( Relationship between inclusion of ordinal numbers and dominance of
     infinite initial ordinals.  (Contributed by Jeff Hankins, 23-Oct-2009.) $)
  alephdom $p |- ( ( A e. On /\ B e. On )
        -> ( A C_ B <-> ( aleph ` A ) ~<_ ( aleph ` B ) ) ) $=
    ( con0 wcel cale cfv cdom wbr wceq wo alephord sdomdom syl6bi cen wi cvv wn
    csdm word eloni wa wss onsseleq fvex fveq2 eqeng mpsyl a1i syl6 jaod sylbid
    endom ordtri2or syl2anr ord con1d wb ancoms sdomnen sbth ex mtod impcon4bid
    syl syld ) ACDZBCDZUAZABUBZAEFZBEFZGHZVHVIABDZABIZJVLABUCVHVMVLVNVHVMVJVKRH
    VLABKVJVKLMVHVNVJVKNHZVLVNVOOVHVJPDVNVJVKIVOAEUDABEUEVJVKPUFUGUHVJVKULUIUJU
    KVHVIQBADZVLQZVHVPVIVHVPVIVGBSASVPVIJVFBTATBAUMUNUOUPVHVPVKVJRHZVQVGVFVPVRU
    QBAKURVRVLVKVJNHZVKVJUSVRVKVJGHZVLVSOVKVJLVTVLVSVKVJUTVAVDVBMVEVC $.

  $( Every aleph is greater than or equal to the set of natural numbers.
     (Contributed by NM, 11-Nov-2003.) $)
  alephgeom $p |- ( A e. On <-> om C_ ( aleph ` A ) ) $=
    ( con0 wcel com cale cfv wss c0 aleph0 0elon alephord3 mpan mpbii syl5eqssr
    0ss wb cdm wn peano1 word ordom ord0 ordtri1 mp2an mpbi ndmfv sseq2d mtbiri
    con2bii con4i wfn wceq alephfnon fndm ax-mp syl6eleq impbii ) ABCZDAEFZGZUR
    DHEFZUSIURHAGZVAUSGZAOHBCURVBVCPJHAKLMNUTAEQZBAVDCZUTVERZUTDHGZHDCZVGRSVGVH
    DTHTVGVHRPUAUBDHUCUDUIUEVFUSHDAEUFUGUHUJEBUKVDBULUMBEUNUOUPUQ $.

  $( Every aleph is a limit ordinal.  (Contributed by NM, 11-Nov-2003.) $)
  alephislim $p |- ( A e. On <-> Lim ( aleph ` A ) ) $=
    ( con0 wcel com cale cfv wlim alephgeom ccrd cardlim alephcard sseq2i limeq
    wss wceq wb ax-mp 3bitr3i bitri ) ABCDAEFZNZTGZAHDTIFZNUCGZUAUBTJUCTDAKZLUC
    TOUDUBPUEUCTMQRS $.

  $( The aleph function is one-to-one.  (Contributed by NM, 3-Aug-2004.) $)
  aleph11 $p |- ( ( A e. On /\ B e. On ) ->
                ( ( aleph ` A ) = ( aleph ` B ) <-> A = B ) ) $=
    ( con0 wcel wa wceq cale cfv wss alephord3 wb ancoms anbi12d 3bitr4g bicomd
    eqss ) ACDZBCDZEZABFZAGHZBGHZFZSABIZBAIZEUAUBIZUBUAIZETUCSUDUFUEUGABJRQUEUG
    KBAJLMABPUAUBPNO $.

  ${
    $d x y $.
    $( The aleph function is a one-to-one mapping from the ordinals to the
       infinite cardinals.  See also ~ alephf1ALT .  (Contributed by Mario
       Carneiro, 2-Feb-2013.) $)
    alephf1 $p |- aleph : On -1-1-> On $=
      ( vx vy con0 cale wf1 wf cv cfv wceq weq wi wral wfn wcel alephfnon rgenw
      alephon ffnfv mpbir2an wa aleph11 biimpd rgen2a dff13 ) CCDECCDFZAGZDHZBG
      ZDHIZABJZKZBCLACLUEDCMUGCNZACLOULACUFQPACCDRSUKABCUFCNUHCNTUIUJUFUHUAUBUC
      ABCCDUDS $.
  $}

  ${
    $d j k x y A $.  $d j k x y B $.
    $( If an ordinal is smaller than an initial ordinal, it is strictly
       dominated by it.  (Contributed by Jeff Hankins, 24-Oct-2009.)  (Proof
       shortened by Mario Carneiro, 20-Sep-2014.) $)
    alephsdom $p |- ( ( A e. On /\ B e. On )
          -> ( A e. ( aleph ` B ) <-> A ~< ( aleph ` B ) ) ) $=
      ( con0 wcel wa cale cfv csdm wbr ccrd cdm simpl alephon onenon cardsdomel
      wb ax-mp sylancl alephcard eleq2i syl6rbb ) ACDZBCDZEZABFGZHIZAUEJGZDZAUE
      DUDUBUEJKDZUFUHPUBUCLUECDUIBMUENQAUEORUGUEABSTUA $.
  $}

  $( A dominated initial ordinal is included.  (Contributed by Jeff Hankins,
     24-Oct-2009.) $)
  alephdom2 $p |- ( ( A e. On /\ B e. On )
        -> ( ( aleph ` A ) C_ B <-> ( aleph ` A ) ~<_ B ) ) $=
    ( con0 wcel wa cale cfv wn csdm wbr cdom wb alephsdom ancoms notbid alephon
    wss word onordi adantl eloni ordtri1 sylancr domtriord mpan 3bitr4d ) ACDZB
    CDZEZBAFGZDZHZBUJIJZHZUJBQZUJBKJZUIUKUMUHUGUKUMLBAMNOUHUOULLZUGUHUJRBRUQUJA
    PZSBUAUJBUBUCTUHUPUNLZUGUJCDUHUSURUJBUDUETUF $.

  ${
    $d x y A $.
    $( The argument of the aleph function is less than or equal to its value.
       Exercise 2 of [TakeutiZaring] p. 91.  (Later, in ~ alephfp2 , we will
       that equality can sometimes hold.)  (Contributed by NM, 9-Nov-2003.)
       (Proof shortened by Mario Carneiro, 22-Feb-2013.) $)
    alephle $p |- ( A e. On -> A C_ ( aleph ` A ) ) $=
      ( vx vy cv cale cfv wss weq id sseq12d wceq con0 wcel wral wel alephord2i
      fveq2 wa imp wi onelon alephon ontr2 sylancl mpan2d ralimdva onirri eleq1
      wn rspccv mtoi wb ontri1 mpan2 syl5ibr syld tfis3 ) BDZUREFZGZCDZVAEFZGZA
      AEFZGBCABCHZURVAUSVBVEIURVAEQJURAKZURAUSVDVFIURAEQJURLMZVCCURNVAUSMZCURNZ
      UTVGVCVHCURVGCBOZRZVCVBUSMZVHVGVJVLVAURPSVKVALMUSLMZVCVLRVHTURVAUAURUBZVA
      VBUSUCUDUEUFVIUTVGUSURMZUIZVIVOUSUSMZUSVNUGVHVQCUSURVAUSUSUHUJUKVGVMUTVPU
      LVNURUSUMUNUOUPUQ $.

    $( Given any transfinite cardinal number ` A ` , there is exactly one aleph
       that is equal to it.  Here we compute that aleph _explicitly_.
       (Contributed by NM, 9-Nov-2003.)  (Revised by Mario Carneiro,
       2-Feb-2013.) $)
    cardaleph $p |- ( ( om C_ A /\ ( card ` A ) = A ) ->
                  A = ( aleph ` |^| { x e. On | A C_ ( aleph ` x ) } ) ) $=
      ( vy com wss ccrd cfv wceq wa cale con0 c0 wrex wo wi fveq2 sseq2d adantl
      wcel wn crab cint csuc wlim cardon eleq1 mpbii alephle rspcev nfcv nfrab1
      cv mpdan nfint nffv nfss onminsb a1i aleph0 syl6eq sseq1d biimprd anim12d
      3syl eqss syl6ibr com12 ancoms vex sucid eleq2 onnminsb syl5 imp alephsuc
      mpbiri char sylan9eqr eleq2d biimpd cdom wbr elharval simprbi cdm alephon
      wb onenon syl ax-mp carddom2 sylancl sseq1 alephcard sseq2i syl6bb bitr3d
      syl5ib sylan9r mtod rexlimdvaa onintrab2 sylib onelon sylan adantld mpcom
      onelssi nsyl nrexdv adantr ciun alephlim eliun mtbird jaod onsseleq mpan2
      ex mpbid ord sylsyld word eloni w3o ordzsl 3orass bitri mpjaod ) DBEZBFGZ
      BHZIBAULZJGZEZAKUAZUBZLHZBYQJGZHZYQCULZUCZHZCKMZYQUDZNZYLYJYRYTOYRYLYJIZY
      TYRUUGBYSEZYSBEZIYTYRYLUUHYJUUIYLUUHOYRYLBKSZYOAKMZUUHYLYKKSUUJBUEYKBKUFU
      GZUUJBBJGZEZUUKBUHYOUUNABKYMBHYNUUMBYMBJPQUIUMZYOUUHAABYSABUJAYQJAJUJAYPY
      OAKUKUNUOUPYMYQHYNYSBYMYQJPQUQZVDURYRUUIYJYRYSDBYRYSLJGDYQLJPUSUTVAVBVCBY
      SVEVFVGVHYLUUFYTOYJYLUUJUUFBYSSZTZYTUULYLUUDUURUUEYLUUCUURCKYLUUAKSZUUCIZ
      IUUQBUUAJGZEZUUTUVBTZYLUUSUUCUVCUUCUUAYQSZUUSUVCUUCUVDUUAUUBSUUACVIVJYQUU
      BUUAVKVPYOUVBAUUAYMUUAHYNUVABYMUUAJPQVLZVMVNRUUTUUQBUVAVQGZSZYLUVBUUTUUQU
      VGUUTYSUVFBUUCUUSYSUUBJGUVFYQUUBJPUUAVOVRVSVTUVGBUVAWAWBZYLUVBUVGUUJUVHUV
      ABWCWDYLYKUVAFGZEZUVHUVBYLBFWEZSZUVAUVKSZUVJUVHWGYLUUJUVLUULBWHWIUVAKSUVM
      UUAWFZUVAWHWJBUVAWKWLYLUVJBUVIEUVBYKBUVIWMUVIUVABUUAWNWOWPWQWRWSWTXAYLUUJ
      UUEUUROUULUUJUUEUURUUJUUEIZUUQBUVASZCYQMZUUJUVQTUUEUUJUVPCYQUUJUVDIZUVBUV
      PUUSUVRUVCUUJYQKSZUVDUUSUUJUUKUVSUUOYOAXBXCZYQUUAXDXEUUSUVDUVCUUJUVEXFXGU
      VABUVNXHXIXJXKUVOUUQBCYQUVAXLZSUVQUVOYSUWABUUJUVSUUEYSUWAHUVTCYQKXMXEVSCB
      YQUVAXNWPXOXSWIXPUUJUUQYTUUJUUHUUQYTNZUUJUUKUUHUUOUUPWIUUJYSKSUUHUWBWGYQW
      FBYSXQXRXTYAYBRYLYRUUFNZYJYLUUJUVSUWCUULUVTUVSYQYCZUWCYQYDUWDYRUUDUUEYEUW
      CCYQYFYRUUDUUEYGYHXCVDRYI $.

    $( Every transfinite cardinal is an aleph and vice-versa.  Theorem 8A(b) of
       [Enderton] p. 213 and its converse.  (Contributed by NM, 5-Nov-2003.) $)
    cardalephex $p |- ( om C_ A ->
                   ( ( card ` A ) = A <-> E. x e. On A = ( aleph ` x ) ) ) $=
      ( vy com wss ccrd cfv wceq cv cale con0 wrex wa crab cint simpl cardaleph
      wcel sseq2d fveq2 alephgeom syl6bbr mpbid eqeq2d rspcev syl2anc alephcard
      ex id 3eqtr4a rexlimivw impbid1 ) DBEZBFGZBHZBAIZJGZHZAKLZUMUOUSUMUOMZBCI
      JGECKNOZKRZBVAJGZHZUSUTUMVBUMUOPUTUMDVCEVBUTBVCDCBQZSVAUAUBUCVEURVDAVAKUP
      VAHUQVCBUPVAJTUDUEUFUHURUOAKURUQFGUQUNBUPUGBUQFTURUIUJUKUL $.
  $}

  ${
    $d x y z A $.
    $( An infinite numerable set is equinumerous to an infinite initial
       ordinal.  (Contributed by Jeff Hankins, 23-Oct-2009.)  (Revised by Mario
       Carneiro, 29-Apr-2015.) $)
    infenaleph $p |- ( ( A e. dom card /\ om ~<_ A ) ->
      E. x e. ran aleph x ~~ A ) $=
      ( ccrd cdm wcel com cdom wbr wa cfv cale crn cen cv wrex wceq con0 wss wb
      ax-mp cardidm cardom simpr omelon onenon simpl carddom2 sylancr syl5eqssr
      mpbird cardalephex syl mpbii eqcom rexbii sylib alephfnon fvelrnb cardid2
      wfn sylibr adantr breq1 rspcev syl2anc ) BCDZEZFBGHZIZBCJZKLZEZVJBMHZANZB
      MHZAVKOVIVNKJZVJPZAQOZVLVIVJVPPZAQOZVRVIVJCJVJPZVTBUAVIFVJRWAVTSVIFFCJZVJ
      UBVIWBVJRZVHVGVHUCVIFVFEZVGWCVHSFQEWDUDFUETVGVHUFFBUGUHUJUIAVJUKULUMVSVQA
      QVJVPUNUOUPKQUTVLVRSUQAQVJKURTVAVGVMVHBUSVBVOVMAVJVKVNVJBMVCVDVE $.
  $}

  ${
    $d x A $.
    $( Two ways to express the property of being a transfinite cardinal.
       (Contributed by NM, 9-Nov-2003.) $)
    isinfcard $p |- ( ( om C_ A /\ ( card ` A ) = A ) <-> A e. ran aleph ) $=
      ( vx cale crn wcel cv cfv wceq con0 wrex com wss ccrd wa wfn wb alephfnon
      fvelrnb ax-mp alephgeom biimpi sseq2 rexlimiv pm4.71ri rexbii cardalephex
      syl5ibrcom eqcom pm5.32i 3bitr4i bitr2i ) ACDEZBFZCGZAHZBIJZKALZAMGAHZNZC
      IOULUPPQBIACRSAUNHZBIJZUQVANUPUSVAUQUTUQBIUMIEZUQUTKUNLZVBVCUMTUAAUNKUBUG
      UCUDUOUTBIUNAUHUEUQURVABAUFUIUJUK $.
  $}

  $( Two ways to express the property of being a cardinal number.  (Contributed
     by NM, 9-Nov-2003.) $)
  iscard3 $p |- ( ( card ` A ) = A <-> A e. ( om u. ran aleph ) ) $=
    ( ccrd cfv wceq com wcel cale crn wo cun wn wss word con0 eleq1 mpbii eloni
    cardon syl ordom ordtri2or sylancl ord wa isinfcard biimpi expcom syld orrd
    cardnn bicomi simprbi jaoi impbii elun bitr4i ) ABCZADZAEFZAGHZFZIZAEUTJFUR
    VBURUSVAURUSKEALZVAURUSVCURAMZEMUSVCIURANFZVDURUQNFVEARUQANOPAQSTAEUAUBUCVC
    URVAVCURUDZVAAUEZUFUGUHUIUSURVAAUJVAVCURVFVAVGUKULUMUNAEUTUOUP $.

  $( Two ways to express the class of all cardinal numbers, which consists of
     the finite ordinals in ` om ` plus the transfinite alephs.  (Contributed
     by NM, 10-Sep-2004.) $)
  cardnum $p |- { x | ( card ` x ) = x } = ( om u. ran aleph ) $=
    ( com cale crn cun cv ccrd cfv wceq cab wcel iscard3 bicomi abbi2i eqcomi )
    BCDEZAFZGHQIZAJRAPRQPKQLMNO $.

  ${
    $d w x y z A $.
    $( An infinite initial ordinal is characterized by the property of being
       initial - that is, it is a subset of any dominating ordinal.
       (Contributed by Jeff Hankins, 29-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 20-Sep-2014.) $)
    alephinit $p |- ( ( A e. On /\ om C_ A )
          -> ( A e. ran aleph <-> A. x e. On ( A ~<_ x -> A C_ x ) ) ) $=
      ( con0 wcel com wss wa cale ccrd cfv wceq cdom wi wb adantl onenon adantr
      wbr cardonle cen crn cv wral isinfcard bicomi baib carddom2 syl2an expcom
      cdm sstr syl sylbird sseq1 imbi2d syl5ibcom ralrimdva oncardid ensym 3syl
      endom cardon breq2 sseq2 imbi12d rspcv ax-mp biantrurd eqss sylibd impbid
      syl5com syl6bbr bitrd ) BCDZEBFZGZBHUADZBIJZBKZBAUBZLRZBWAFZMZACUCZVPVRVT
      NVOVRVPVTVPVTGVRBUDUEUFOVQVTWEVQVTWDACVQWACDZGZWBVSWAFZMVTWDWGWBVSWAIJZFZ
      WHVQBIUJZDZWAWKDWJWBNWFVOWLVPBPQWAPBWAUGUHWGWIWAFZWJWHMWFWMVQWASOWJWMWHVS
      WIWAUKUIULUMVTWHWCWBVSBWAUNUOUPUQVQWEBVSFZVTVQBVSLRZWEWNVOWOVPVOVSBTRBVST
      RWOBURVSBUSBVSVAUTQVSCDWEWOWNMZMBVBWDWPAVSCWAVSKWBWOWCWNWAVSBLVCWAVSBVDVE
      VFVGVLVQWNVSBFZWNGVTVQWQWNVOWQVPBSQVHVSBVIVMVJVKVN $.
  $}

  ${
    $d x F $.  $d x A $.
    $( The union of the image of a mapping to cardinals is a cardinal.
       Proposition 11.16 of [TakeutiZaring] p. 104.  (Contributed by NM,
       4-Nov-2004.) $)
    carduniima $p |- ( A e. B -> ( F : A --> ( om u. ran aleph ) ->
                     U. ( F " A ) e. ( om u. ran aleph ) ) ) $=
      ( vx wcel com cale crn cun wf cima cuni ccrd cfv wceq wfun ffun funimaexg
      cvv iscard3 sylan expcom wral wfn ffn fnima syl frn eqsstrd sseld syl6ibr
      cv ralrimiv carduni syl5 syli syl6ib ) ABEZAFGHIZCJZCAKZLZMNVBOZVBUSEUTUR
      VASEZVCUTURVDUTCPURVDAUSCQCABRUAUBUTDULZMNVEOZDVAUCVDVCUTVFDVAUTVEVAEVEUS
      EVFUTVAUSVEUTVACHZUSUTCAUDVAVGOAUSCUEACUFUGAUSCUHUIUJVETUKUMDVASUNUOUPVBT
      UQ $.

    $( If a mapping to cardinals has an infinite value, then the union of its
       image is an infinite cardinal.  Corollary 11.17 of [TakeutiZaring]
       p. 104.  (Contributed by NM, 4-Nov-2004.) $)
    cardinfima $p |- ( A e. B -> ( ( F : A --> ( om u. ran aleph ) /\
         E. x e. A ( F ` x ) e. ran aleph ) -> U. ( F " A ) e. ran aleph ) ) $=
      ( wcel cvv com cale crn cun wf cv cfv wa wi wss ccrd wceq isinfcard imp
      wrex cima cuni elex bicomi simplbi wfn ffn fnfvelrn fnima sylibrd elssuni
      eleq2d syl6 sylan sylan9ssr anasss a1i carduniima iscard3 syl6ibr adantrd
      ex jcad syl6ib exp4d rexlimdv expimpd syl ) BCEBFEZBGHIZJZDKZALZDMZVKEZAB
      UAZNDBUBZUCZVKEZOBCUDVJVMVQVTVJVMNVPVTABVJVMVNBEZVPVTOOVJVMWAVPVTVJVMWAVP
      NZNZGVSPZVSQMVSRZNVTVJWCWDWEWCWDOVJVMWAVPWDVPVMWANGVOVSVPGVOPZVOQMVORZWFW
      GNVPVOSUEUFVMDBUGZWAVOVSPZBVLDUHWHWAWIWHWAVOVREZWIWHWAVODIZEZWJWHWAWLBVND
      UIVCWHVRWKVOBDUJUMUKVOVRULUNTUOUPUQURVJVMWEWBVJVMVSVLEWEBFDUSVSUTVAVBVDVS
      SVEVFTVGVHVI $.
  $}

  ${
    $d x y z $.
    $( Aleph is an order isomorphism of the class of ordinal numbers onto the
       class of infinite cardinals.  Definition 10.27 of [TakeutiZaring]
       p. 90.  (Contributed by NM, 3-Aug-2004.) $)
    alephiso $p |- aleph Isom _E , _E ( On ,
                   { x | ( om C_ x /\ ( card ` x ) = x ) } ) $=
      ( vy vz con0 com cv wss ccrd cfv wceq cab cep cale wiso wbr wral mpbir2an
      wa wcel rgen2a wb wf1 wfo wf wi wfn crn alephfnon isinfcard bicomi abbi2i
      wf1o df-fo ax-mp aleph11 biimpd dff13 df-f1o alephord2 epel epelc 3bitr4g
      fof fvex df-isom ) DEAFZGVFHIVFJRZAKZLLMNDVHMULZBFZCFZLOZVJMIZVKMIZLOZUAZ
      CDPBDPVIDVHMUBZDVHMUCZVQDVHMUDZVMVNJZVJVKJZUEZCDPBDPVRVSVRMDUFMUGZVHJUHVG
      AWCVGVFWCSVFUIUJUKDVHMUMQZDVHMVCUNWBBCDVJDSVKDSRZVTWAVJVKUOUPTBCDVHMUQQWD
      DVHMURQVPBCDWEVJVKSVMVNSVLVOVJVKUSBCUTVMVNVKMVDVAVBTBCDVHLLMVEQ $.
  $}

  $( The class of all transfinite cardinal numbers (the range of the aleph
     function) is a proper class.  Proposition 10.26 of [TakeutiZaring] p. 90.
     (Contributed by NM, 11-Nov-2003.) $)
  alephprc $p |- -. ran aleph e. _V $=
    ( vx cale crn cvv wcel com cun cv ccrd cfv wceq cardprc neli cardnum eleq1i
    cab mtbi omex unexg mpan mto ) BCZDEZFUBGZDEZAHZIJUFKAPZDEUEUGDALMUGUDDANOQ
    FDEUCUERFUBDDSTUA $.

  $( The class of transfinite cardinals (the range of the aleph function) is a
     subclass of the class of ordinal numbers.  (Contributed by NM,
     11-Nov-2003.) $)
  alephsson $p |- ran aleph C_ On $=
    ( vx cale crn con0 cv wcel com wss ccrd cfv wa isinfcard cardon eleq1 mpbii
    wceq adantl sylbir ssriv ) ABCZDAEZTFGUAHZUAIJZUAPZKUADFZUALUDUEUBUDUCDFUEU
    AMUCUADNOQRS $.

  $( The union of the class of transfinite cardinals (the range of the aleph
     function) is the class of ordinal numbers.  (Contributed by NM,
     11-Nov-2003.) $)
  unialeph $p |- U. ran aleph = On $=
    ( cale crn cuni con0 wcel wceq cvv alephprc uniexb mtbi elex word alephsson
    mto wo wss ssorduni ax-mp ordeleqon mpbi mtp-or ) ABZCZDEZUCDFZUDUCGEZUBGEU
    FHUBIJUCDKNUCLZUDUEOUBDPUGMUBQRUCSTUA $.

  ${
    $d x y $.
    $( The aleph function is strictly monotone.  (Contributed by Mario
       Carneiro, 15-Mar-2013.) $)
    alephsmo $p |- Smo aleph $=
      ( vy vx con0 wss word cv cale cfv wcel wral wsmo ssid alephord2i ralrimiv
      ordon rgen wf w3a wi wfn crn alephfnon alephsson df-f issmo2 ax-mp mp3an
      mpbir2an ) CCDZCEZAFZGHBFZGHIZAULJZBCJZGKZCLOUNBCULCIUMAULUKULMNPCCGQZUIU
      JUORUPSUQGCTGUACDUBUCCCGUDUHBACCGUEUFUG $.
  $}

  $( The aleph function is a one-to-one mapping from the ordinals to the
     infinite cardinals.  (Contributed by Mario Carneiro, 15-Mar-2013.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  alephf1ALT $p |- aleph : On -1-1-> On $=
    ( vx con0 cale wf wsmo wf1 wfn cv cfv wcel wral alephfnon alephon a1i ffnfv
    rgen mpbir2an alephsmo smo11 mp2an ) BBCDZCEBBCFUACBGAHZCIBJZABKLUCABUCUBBJ
    UBMNPABBCOQRBBCST $.

  ${
    $d x y z w v $.  $d z w v H $.
    alephfplem.1 $e |- H = ( rec ( aleph , om ) |` om ) $.
    $( Lemma for ~ alephfp .  (Contributed by NM, 6-Nov-2004.) $)
    alephfplem1 $p |- ( H ` (/) ) e. ran aleph $=
      ( cfv cale crn com crdg cres cvv wcel wceq omex fr0g ax-mp fveq1i 3eqtr4i
      c0 aleph0 con0 wfn alephfnon 0elon fnfvelrn mp2an eqeltri ) QACZQDCZDEZQD
      FGFHZCZFUFUGFIJUJFKLFIDMNQAUIBORPDSTQSJUGUHJUAUBSQDUCUDUE $.

    $( Lemma for ~ alephfp .  (Contributed by NM, 6-Nov-2004.) $)
    alephfplem2 $p |- ( w e. om -> ( H ` suc w ) = ( aleph ` ( H ` w ) ) ) $=
      ( cv com wcel csuc cale crdg cres cfv frsuc fveq1i fveq2i 3eqtr4g ) ADZEF
      PGZHEIEJZKPRKZHKQBKPBKZHKEPHLQBRCMTSHPBRCMNO $.

    $( Lemma for ~ alephfp .  (Contributed by NM, 6-Nov-2004.) $)
    alephfplem3 $p |- ( v e. om -> ( H ` v ) e. ran aleph ) $=
      ( vw cv cfv cale crn wcel csuc wceq fveq2 eleq1d alephfplem1 com con0 wfn
      c0 alephfnon alephsson sseli fnfvelrn sylancr alephfplem2 syl5ibr finds1
      ) AEZBFZGHZIRBFZUIIDEZBFZUIIZUKJZBFZUIIZADUGRKUHUJUIUGRBLMUGUKKUHULUIUGUK
      BLMUGUNKUHUOUIUGUNBLMBCNUMUPUKOIZULGFZUIIZUMGPQULPIUSSUIPULTUAPULGUBUCUQU
      OURUIDBCUDMUEUF $.

    $( Lemma for ~ alephfp .  (Contributed by NM, 5-Nov-2004.) $)
    alephfplem4 $p |- U. ( H " om ) e. ran aleph $=
      ( vz com cale crn cun wf cv cfv wcel wrex cima cuni wss wfn wral mp2an c0
      cvv crdg cres frfnom fneq1i mpbir alephfplem3 ffnfv mpbir2an ssun2 peano1
      rgen fss alephfplem1 wceq fveq2 eleq1d rspcev wa wi omex cardinfima ax-mp
      ) DDEFZGZAHZCIZAJZVCKZCDLZADMNVCKZDVCAHZVCVDOVEVKADPZVHCDQVLEDUADUBZDPDEU
      CDAVMBUDUEVHCDCABUFUKCDVCAUGUHVCDUIDVCVDAULRSDKSAJZVCKZVIUJABUMVHVOCSDVFS
      UNVGVNVCVFSAUOUPUQRDTKVEVIURVJUSUTCDTAVAVBR $.

    $( The aleph function has a fixed point.  Similar to Proposition 11.18 of
       [TakeutiZaring] p. 104, except that we construct an actual example of a
       fixed point rather than just showing its existence.  See ~ alephfp2 for
       an abbreviated version just showing existence.  (Contributed by NM,
       6-Nov-2004.)  (Proof shortened by Mario Carneiro, 15-May-2015.) $)
    alephfp $p |- ( aleph ` U. ( H " om ) ) = U. ( H " om ) $=
      ( vz vv com cale crn wcel cv cfv wceq con0 wrex wss wa wi wfn syl mpbird
      wb cima cuni alephfplem4 ccrd isinfcard cardalephex biimpa sylbir alephle
      wn alephon onirri wfun crdg cres frfnom fneq1i mpbir fnfun mp2b alephsson
      eluniima alephfplem3 sseldi alephord2i csuc alephfplem2 peano2 mpan fnima
      fnfvelrn ax-mp syl6eleqr eqeltrrd elssuni sseld syld rexlimiv sylbi eleq2
      imbi12d mpbii mtoi anim12i word eloni onordi ordtri4 sylancl adantr eqeq2
      adantl eqcomd fveq2d rexlimiva ) AEUAZUBZFGZHZWQCIZFJZKZCLMZWQFJZWQKZABUC
      WSEWQNZWQUDJWQKZOXCWQUEXFXGXCCWQUFUGUHXBXECLWTLHZXBOZXEXDXAKZXIWQWTFXIWTW
      QXIWTWQKZWTXAKZXIXLWTXANZWTXAHZUJZOZXHXMXBXOWTUIXBXNXAXAHZXAWTUKZULXBWTWQ
      HZXAWQHZPXNXQPXSWTDIZAJZHZDEMZXTAEQZAUMXSYDTYEFEUNEUOZEQEFUPEAYFBUQURZEAU
      SDEWTAVBUTYCXTDEYAEHZYCXAYBFJZHZXTYHYBLHYCYJPYHWRLYBVADABVCVDWTYBVERYHYIW
      QXAYHYIWPHYIWQNYHYAVFZAJZYIWPDABVGYHYKEHZYLWPHYAVHYMYLAGZWPYEYMYLYNHYGEYK
      AVKVIYEWPYNKYGEAVJVLVMRVNYIWPVORVPVQVRVSXBXSXNXTXQWQXAWTVTWQXAXAVTWAWBWCW
      DXHXLXPTZXBXHWTWEXAWEYOWTWFXAXRWGWTXAWHWIWJSXBXKXLTXHWQXAWTWKWLSWMWNXBXEX
      JTXHWQXAXDWKWLSWOUT $.
  $}

  $( The aleph function has at least one fixed point.  Proposition 11.18 of
     [TakeutiZaring] p. 104.  See ~ alephfp for an actual example of a fixed
     point.  Compare the inequality ~ alephle that holds in general.  Note that
     if ` x ` is a fixed point, then ` aleph `` aleph `` aleph `` ` ...
     ` aleph `` x = x ` .  (Contributed by NM, 6-Nov-2004.)  (Revised by Mario
     Carneiro, 15-May-2015.) $)
  alephfp2 $p |- E. x e. On ( aleph ` x ) = x $=
    ( cale com crdg cres cima cuni con0 wcel wceq cv wrex alephsson alephfplem4
    cfv crn eqid sselii alephfp fveq2 id eqeq12d rspcev mp2an ) BCDCEZCFGZHIUFB
    OZUFJZAKZBOZUIJZAHLBPHUFMUEUEQZNRUEULSUKUHAUFHUIUFJZUJUGUIUFUIUFBTUMUAUBUCU
    D $.

  ${
    $d x y z w A $.
    $( An alternate way to express the value of the aleph function: it is the
       least infinite cardinal different from all values at smaller arguments.
       Definition of aleph in [Enderton] p. 212 and definition of aleph in
       [BellMachover] p. 490 .  (Contributed by NM, 16-Nov-2003.) $)
    alephval3 $p |- ( A e. On -> ( aleph ` A ) = |^| { x | ( ( card ` x ) = x
                   /\ om C_ x /\ A. y e. A -. x = ( aleph ` y ) ) } ) $=
      ( vz con0 wcel cale cfv cv ccrd wceq com wss wn wral w3a a1i ralrimiv wa
      wi cab cint alephcard alephgeom biimpi alephord2i elirr eleq2 mtbiri syl6
      con2i fvex fveq2 id eqeq12d sseq2 notbid ralbidv 3anbi123d elab syl3anbrc
      eqeq1 wrex cardalephex biimpac eleq1 alephord2 bicomd biimpcd simpr exp4c
      sylan9bbr jcad com3r imp4b reximdv2 syl5 imp dfrex2 sylib mpbir ex df-3an
      nan vex bitri notbii syl6ibr cardon mpbii 3ad2ant1 abssi oneqmini syl2anc
      ax-mp ) CEFZCGHZAIZJHZWRKZLWRMZWRBIZGHZKZNZBCOZPZAUAZFZDIZXHFZNZDWQOZWQXH
      UBKZWPWQJHZWQKZLWQMZWQXCKZNZBCOZXIXPWPCUCQWPXQCUDUEWPXSBCWPXBCFZXCWQFZXSX
      BCUFXRYBXRYBXCXCFXCUGWQXCXCUHUIUKUJRXGXPXQXTPAWQCGULWRWQKZWTXPXAXQXFXTYCW
      SXOWRWQWRWQJUMYCUNUOWRWQLUPYCXEXSBCYCXDXRWRWQXCVBUQURUSUTVAWPXLDWQWPXJWQF
      ZXJJHZXJKZLXJMZSZXJXCKZNZBCOZSZNZXLWPYDYMWPYDSZYMTYNYHSZYKNZTYOYIBCVCZYPY
      NYHYQYHYIBEVCZYNYQYGYFYRBXJVDVEYNYIYIBECWPYDXBEFZYIYAYISZYDYSWPYIYTTYDYSW
      PYIYTYDYSWPSZYISZYAYIUUBYDYAYIYDYBUUAYAXJXCWQVFUUAYAYBXBCVGVHVLVIUUBYITYD
      UUAYIVJQVMVKVNVOVPVQVRYIBCVSVTYNYHYKWDWAWBXKYLXKYFYGYKPZYLXGUUCAXJDWEWRXJ
      KZWTYFXAYGXFYKUUDWSYEWRXJWRXJJUMUUDUNUOWRXJLUPUUDXEYJBCUUDXDYIWRXJXCVBUQU
      RUSUTYFYGYKWCWFWGWHRXHEMXIXMSXNTXGAEWTXAWREFZXFWTWSEFUUEWRWIWSWREVFWJWKWL
      DWQXHWMWOWN $.
  $}

  ${
    $( The power set of an aleph is not strictly dominated by the successor
       aleph.  (The Generalized Continuum Hypothesis says they are
       equinumerous, see ~ gch3 or ~ gchaleph2 .)  The transposed form
       ~ alephsucpw cannot be proven without the AC, and is in fact equlvalent
       to it.  (Contributed by Mario Carneiro, 2-Feb-2013.) $)
    alephsucpw2 $p |- -. ~P ( aleph ` A ) ~< ( aleph ` suc A ) $=
      ( cale cfv cpw csdm wbr csuc fvex canth2 alephnbtwn2 mpto1 ) ABCZLDZEFMAG
      BCEFLABHIAMJK $.
  $}

  ${
    $d A a $.  $d B a $.  $d B x $.
    $( Power rule for cardinal arithmetic.  Theorem 11.21 of [TakeutiZaring]
       p. 106.  (Contributed by Mario Carneiro, 9-Mar-2013.)  (Revised by Mario
       Carneiro, 27-Apr-2015.) $)
    mappwen $p |- ( ( ( B e. dom card /\ om ~<_ B ) /\
      ( 2o ~<_ A /\ A ~<_ ~P B ) ) -> ( A ^m B ) ~~ ~P B ) $=
      ( ccrd cdm wcel com cdom wbr wa c2o cpw cmap domentr syl2anc mapdom1 con0
      co cen 2on entr simprr pw2eng ad2antrr syl cxp a1i simpll mapxpen syl3anc
      elexi enref infxpidm2 adantr mapen sylancr ensymd ad2antrl endomtr sbth )
      BCDZEZFBGHZIZJAGHZABKZGHZIZIZABLQZVEGHZVEVIGHZVIVERHVHVIJBLQZBLQZGHZVMVER
      HZVJVHAVLGHZVNVHVFVEVLRHZVPVCVDVFUAVAVQVBVGBUTUBUCZAVEVLMNAVLBOUDVHVMVLRH
      ZVLVERHVOVHVMJBBUEZLQZRHZWAVLRHZVSVHJPEZVAVAWBWDVHSUFVAVBVGUGZWEJBBPUTUTU
      HUIVHJJRHVTBRHZWCJJPSUJUKVCWFVGBULUMJJVTBUNUOVMWAVLTNVHVEVLVRUPVMVLVETNVI
      VMVEMNVHVQVLVIGHZVKVRVDWGVCVFJABOUQVEVLVIURNVIVEUSN $.
  $}

  ${
    $d f R $.  $d f A $.
    $( A finite totally ordered set has a unique order isomorphism to a finite
       ordinal.  (Contributed by Stefan O'Rear, 16-Nov-2014.)  (Proof shortened
       by Mario Carneiro, 26-Jun-2015.) $)
    finnisoeu $p |- ( ( R Or A /\ A e. Fin ) ->
        E! f f Isom _E , R ( ( card ` A ) , A ) ) $=
      ( wor cfn wcel wa ccrd cfv cep cv cvv adantl syl2anc wb cen wbr mpbid syl
      wiso wex wmo weu coi eqid oiexg cdm wwe simpr wofi oiiso wceq oien ensymd
      ficardid entr con0 com oion ficardom onomeneq isoeq4 isoeq1 sylc wemoiso2
      spcegv eu5 sylanbrc ) ABDZAEFZGZAHIZAJBCKZTZCUAZVNCUBZVNCUCVKABUDZLFZVLAJ
      BVQTZVOVJVRVIABVQEVQUEZUFMVKVQUGZAJBVQTZVSVKVJABUHZWBVIVJUIZABUJZABVQEVTU
      KNVKWAVLULZWBVSOVKWAVLPQZWFVKWAAPQZAVLPQWGVKVJWCWHWDWEABVQEVTUMNVKVLAVJVL
      APQVIAUOMUNWAAVLUPNVKWAUQFZVLURFZWGWFOVJWIVIABVQEVTUSMVJWJVIAUTMWAVLVANRW
      AAVLJBVQVBSRVNVSCVQLVLAJBVQVMVCVFVDVKWCVPWEVLAJBCVESVNCVGVH $.
  $}

  ${
    $d A a b c d e f g h i j k $.  $d B a b c d e f g h i j k $.
    $( Countability of a countable union of finite sets with a strict (not
       globally well) order fulfilling the choice role.  (Contributed by Stefan
       O'Rear, 16-Nov-2014.) $)
    iunfictbso $p |- ( ( A ~<_ om /\ A C_ Fin /\ B Or U. A ) ->
        U. A ~<_ om ) $=
      ( va vf vg vh com cdom wbr cfn c0 wceq cv wcel syl syl2anc cfv cep wiso
      wa vb vc vd ve vi vj wss cuni wor w3a wi omex breq1 mpbiri a1d wne wex n0
      0dom wfo csdm ne0i unieq syl6eq necon3i adantl cvv simpl1 reldom brrelexi
      uni0 0sdomg 3syl mpbird fodomr cxp cen ccrd cdm cio cif cmpt2 con0 omelon
      wb onenon ax-mp xpnum mp2an wf co wrex simplrr fof simprl ffvelrnd adantr
      wral elssuni wf1o cab simpll3 soss simpll2 sseldd finnisoeu iotacl iotaex
      weu sylc isoeq1 cbvabv elab2 isof1o f1of ffvelrnda wn ad2antrr ralrimivva
      sylib ifclda eqid fmpt2 eluni simprr foelrn ccnv simprrl ficardom ordelss
      word ordom sylancr f1ocnv fveq2 eqidd ifbieq12d expr mpd exlimdv iotabidv
      simprll simprrr eleqtrd fveq2d eleq2d isoeq4 isoeq5 bitrd fveq1d fvex vex
      eleq1 ifex ovmpt2 iftrue f1ocnvfv2 3eqtrrd rspceov syl3anc exp3a rexlimdv
      ex syl5bi ralrimiv sylanbrc fodomnum mpsyl xpomen domentr sylancl exlimiv
      foov expcom sylbi pm2.61ine ) AGHIZAJUGZAUHZBUIZUJZUVSGHIZUKZUVSKUVSKLZUW
      BUWAUWDUWBKGHIGULUSUVSKGHUMUNUOUVSKUPZCMZUVSNZCUQUWCCUVSURUWGUWCCUWAUWGUW
      BUWAUWGTZGAUAMZUTZUAUQZUWBUWHKAVAIZUVQUWKUWHUWLAKUPZUWGUWMUWAUWGUWEUWMUVS
      UWFVBAKUVSKAKLUVSKUHKAKVCVKVDVEOVFUWHUVQAVGNUWLUWMWEUVQUVRUVTUWGVHZAGHVIV
      JAVGVLVMVNUWNGAUAVOPUWHUWJUWBUAUWAUWGUWJUWBUWAUWGUWJTZTZUVSGGVPZHIZUWQGVQ
      IUWBUWQVRVSZNZUWPUWQUVSDEGGEMZDMZUWIQZVRQZNZUXAUXDUXCRBFMZSZFVTZQZUWFWAZW
      BZUTZUWRGUWSNZUXMUWTGWCNUXMWDGWFWGZUXNGGWHWIUWPUWQUVSUXKWJZUBMZUCMUDMUXKW
      KLUDGWLUCGWLZUBUVSWRUXLUWPUXJUVSNZEGWRDGWRUXOUWPUXRDEGGUWPUXBGNZUXAGNZTZT
      ZUXEUXIUWFUVSUYBUXETZUXCUVSUXIUYCUXCANZUXCUVSUGZUYBUYDUXEUYBGAUXBUWIUYBUW
      JGAUWIWJZUWAUWGUWJUYAWMGAUWIWNZOUWPUXSUXTWOWPZWQUXCAWSZOUYBUXDUXCUXAUXHUY
      BUXDUXCRBUXHSZUXDUXCUXHWTUXDUXCUXHWJUYBUXHUXGFXAZNZUYJUYBUXGFXIZUYLUYBUXC
      BUIZUXCJNUYMUYBUYEUVTUYNUYBUYDUYEUYHUYIOUVQUVRUVTUWOUYAXBUXCUVSBXCXJUYBAJ
      UXCUVQUVRUVTUWOUYAXDUYHXEUXCBFXFPUXGFXGOUXDUXCRBUWFSZUYJCUXHUYKUXGFXHUXDU
      XCRBUXHUWFXKUXGUYOFCUXDUXCRBUWFUXFXKXLXMXTUXDUXCRBUXHXNUXDUXCUXHXOVMXPXEU
      WPUWGUYAUXEXQUWAUWGUWJWOXRYAXSDEGGUXJUVSUXKUXKYBZYCXTUWPUXQUBUVSUXPUVSNUX
      PUEMZNZUYQANZTZUEUQUWPUXQUEUXPAYDUWPUYTUXQUEUWPUYTUXQUWPUYTTZUYQUFMZUWIQZ
      LZUFGWLZUXQVUAUWJUYSVUEUWAUWGUWJUYTWMUWPUYRUYSYEUFGAUYQUWIYFPVUAVUDUXQUFG
      VUAVUBGNZVUDUXQUWPUYTVUFVUDTZUXQUWPUYTVUGTZTZVUFUXPVUCVRQZVUCRBUXFSZFVTZY
      GZQZGNZUXPVUBVUNUXKWKZLUXQUWPUYTVUFVUDYHZVUIVUJGVUNVUIGYKVUJGNZVUJGUGYLVU
      IVUCJNZVURVUIAJVUCUVQUVRUVTUWOVUHXDVUIGAVUBUWIVUIUWJUYFUWAUWGUWJVUHWMUYGO
      VUQWPZXEZVUCYIOGVUJYJYMVUIVUCVUJUXPVUMVUIVUJVUCVULWTZVUCVUJVUMWTVUCVUJVUM
      WJVUIVUJVUCRBVULSZVVBVUIVULVUKFXAZNZVVCVUIVUKFXIZVVEVUIVUCBUIZVUSVVFVUIVU
      CUVSUGZUVTVVGVUIVUCANVVHVUTVUCAWSOUVQUVRUVTUWOVUHXBVUCUVSBXCXJVVAVUCBFXFP
      VUKFXGOVUJVUCRBUWFSZVVCCVULVVDVUKFXHVUJVUCRBVULUWFXKVUKVVIFCVUJVUCRBUWFUX
      FXKXLXMXTVUJVUCRBVULXNOZVUJVUCVULYNVUCVUJVUMXOVMVUIUXPUYQVUCUWPUYRUYSVUGU
      UBUWPUYTVUFVUDUUCUUDZWPZXEZVUIVUPVUNVUJNZVUNVULQZUWFWAZVVOUXPVUIVUFVUOVUP
      VVPLVUQVVMDEVUBVUNGGUXJVVPUXKUXAVUJNZUXAVULQZUWFWAUXBVUBLZUXEVVQUXIUWFVVR
      UWFVVSUXDVUJUXAVVSUXCVUCVRUXBVUBUWIYOZUUEZUUFVVSUXAUXHVULVVSUXGVUKFVVSUXG
      VUJUXCRBUXFSZVUKVVSUXDVUJLUXGVWBWEVWAUXDUXCVUJRBUXFUUGOVVSUXCVUCLVWBVUKWE
      VVTVUJUXCVUCRBUXFUUHOUUIUUAUUJVVSUWFYPYQUXAVUNLZVVQVVNVVRUWFVVOUWFUXAVUNV
      UJUUMUXAVUNVULYOVWCUWFYPYQUYPVVNVVOUWFVUNVULUUKCUULUUNUUOPVUIVVNVVPVVOLVV
      LVVNVVOUWFUUPOVUIVVBUXPVUCNVVOUXPLVVJVVKVUJVUCUXPVULUUQPUURUCUDGGVUBVUNUX
      PUXKUUSUUTYRUVAUVBYSUVCYTUVDUVEUCUDUBGGUVSUXKUVMUVFUWQUVSUXKUVGUVHUVIUVSU
      WQGUVJUVKYRYTYSUVNUVLUVOUVP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Axiom of Choice equivalents
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CHOICE $.

  $( Wff for an abbreviation of the axiom of choice. $)
  wac $a wff CHOICE $.

  ${
    $d f x $.
    $( The expression ` CHOICE ` will be used as a readable shorthand for any
       form of the axiom of choice; all concrete forms are long, cryptic, have
       dummy variables, or all three, making it useful to have a short name.
       Similar to the Axiom of Choice (first form) of [Enderton] p. 49.

       There is a slight problem with taking the exact form of ~ ax-ac as our
       definition, because the equivalence to more standard forms ( ~ dfac2 )
       requires the Axiom of Regularity, which we often try to avoid.  Thus, we
       take the first of the "textbook forms" as the definition and derive the
       form of ~ ax-ac itself as ~ dfac0 .  (Contributed by Mario Carneiro,
       22-Feb-2015.) $)
    df-ac $a |- ( CHOICE <-> A. x E. f ( f C_ x /\ f Fn dom x ) ) $.
  $}

  ${
    $d x y z w v u t h $.
    $( Equivalence of two versions of the Axiom of Choice ~ ax-ac .  The proof
       uses neither AC nor the Axiom of Regularity.  The right-hand side
       expresses our AC with the fewest number of different variables.
       (Contributed by NM, 5-Apr-2004.) $)
    aceq1 $p |- ( E. y A. z e. x A. w e. z E! v e. z E. u e. y
                      ( z e. u /\ v e. u ) <->
                  E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. x A. z ( E. x
           ( ( z e. w /\ w e. x ) /\ ( z e. x /\ x e. y ) ) <-> z = x ) ) ) $=
      ( vt vh wel wa cv wrex wreu wral wex weq wal wi eleq1 3bitr4i biidd bitri
      wb cbvralv anbi2d rexbidv ralbii anbi1d reueqd exbii 19.21v impexp bi2.04
      cbvreuv raleqbi1dv albii weu df-eu df-reu 19.42v an42 anass bitr3i df-rex
      eleq2 anbi12d cbvexv anbi2i bibi1i imbi2i df-ral nfv nfa1 nfex nfim cbval
      imbi1d alcom 3bitr4ri ) CFIZEFIZJZFBKZLZECKZMZDWENZCAKZNZBODFIZVTJZFWCLZC
      DKZMZGWMNZDWHNZBOCDIZDAIZJZWSCAIZABIZJJZAOZCAPZUCZCQZAOZRZDQCQZBOWIWPBHFI
      ZWAJZFWCLZEHKZMZDXMNZHWHNXJVTJZFWCLZCXMMZGXMNZHWHNWIWPXOXSHWHXOXNGXMNXSXN
      XNDGXMDGPXNUAUDXNXRGXMXLXQECXMECPZXKXPFWCXTWAVTXJEKWEFKZSUEUFUNUGUBUGWGXO
      CHWHWFXNDWEXMWDXLEWEXMCHPZWBXKFWCYBVTXJWAWEXMYASUHUFUIUOUDWOXSDHWHWNXRGWM
      XMWLXQCWMXMDHPZWKXPFWCYCWJXJVTWMXMYASUHUFUIUOUDTUJWPXIBXHCQZDQWRWORZDQXIW
      PYDYEDWRWQXGRZRZCQWRYFCQZRYDYEWRYFCUKXHYGCXHWQWRXGRRYGWQWRXGULWQWRXGUMUBU
      PWOYHWRGDIZWNRZGQYIXGRZGQWOYHYJYKGWNXGYIWQWLJZCUQYLXDUCZCQZAOWNXGYLCAURWL
      CWMUSXFYNAXEYMCXCYLXDWQXAWRWTJZJZJZAOWQYPAOZJXCYLWQYPAUTXBYQAXBWQXAJYOJYQ
      WQXAWRWTVAWQXAYOVBVCUJWLYRWQWLFBIZWKJZFOYRWKFWCVDYTYPFAFAPZYSXAWKYOYAWHWC
      SUUAWJWRVTWTYAWHWMVEYAWHWEVEVFVFVGUBVHTVIUPUJTVJUPWNGWMVKYFYKCGYFGVLYIXGC
      YICVLXFCAXECVMVNVOCGPWQYIXGWEGKWMSVQVPTVJTUPXHCDVRWODWHVKVSUJUB $.
  $}

  ${
    $d x y z w v u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The proof uses
       neither AC nor the Axiom of Regularity.  The right-hand side is our
       original ~ ax-ac .  (Contributed by NM, 5-Apr-2004.) $)
    aceq0 $p |- ( E. y A. z e. x A. w e. z E! v e. z E. u e. y
                      ( z e. u /\ v e. u ) <->
                  E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u
     ( E. t ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) ) $=
      ( wel wa cv wral wex weq wb wal wi elequ2 elequ1 anbi12d cbvexv wrex wreu
      equequ2 bibi2d anbi2d bibi1i syl6bb albidv anbi1d exbidv equequ1 bibi12d
      aceq1 cbvalv imbi2i 2albii exbii bitr4i ) CFHEFHIFBJUAECJZUBDUSKCAJKBLCDH
      ZDAHZIZVBCAHZABHZIZIZALZCAMZNZCOZALZPZDOCOZBLVBFDHZDGHZIZFGHZGBHZIZIZGLZF
      EMZNZFOZELZPZDOCOZBLABCDEFUMWGVMBWFVLCDWEVKVBWDVJEAEAMZWDVNVAIZFAHZVDIZIZ
      ALZFAMZNZFOVJWHWCWOFWHWCWAWNNWOWHWBWNWAEAFUCUDWAWMWNVTWLGAGAMZVPWIVSWKWPV
      OVAVNGADQUEWPVQWJVRVDGAFQGABRSSTUFUGUHWOVIFCFCMZWMVGWNVHWQWLVFAWQWIVBWKVE
      WQVNUTVAFCDRUIWQWJVCVDFCARUISUJFCAUKULUNUGTUOUPUQUR $.
  $}

  ${
    $d x y z w v u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The proof uses
       neither AC nor the Axiom of Regularity.  (Contributed by NM,
       5-Apr-2004.) $)
    aceq2 $p |- ( E. y A. z e. x A. w e. z E! v e. z E. u e. y
                     ( z e. u /\ v e. u ) <->
                  E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
                      ( z e. v /\ w e. v ) ) ) $=
      ( vt wel wa cv wrex wreu wral c0 wne wi wex bitri weq eleq2 df-ral 19.23v
      wal biidd cbvralv n0 anbi12d cbvrexv reubii eleq1 rexbidv cbvreuv imbi12i
      anbi2d 3bitr4i ralbii exbii ) CFHZEFHZIZFBJZKZECJZLZDVCMZCAJZMVCNOZCEHZDE
      HZIZEVAKZDVCLZPZCVFMBVEVMCVFVDGVCMZGCHZGQZVDPZVEVMVNVOVDPGUCVQVDGVCUAVOVD
      GUBRVDVDDGVCDGSVDUDUEVGVPVLVDGVCUFVLURDFHZIZFVAKZDVCLVDVKVTDVCVJVSEFVAEFS
      VHURVIVREJZFJZVCTWAWBDJZTUGUHUIVTVBDEVCDESZVSUTFVAWDVRUSURWCWAWBUJUNUKULR
      UMUOUPUQ $.
  $}

  ${
    $d x y z w v u t h g f $.  $d t h g F $.
    aceq3lem.1 $e |- F = ( w e. dom y |-> ( f ` { u | w y u } ) ) $.
    $( Lemma for ~ dfac3 .  (Contributed by NM, 2-Apr-2004.)  (Revised by Mario
       Carneiro, 26-Jun-2015.) $)
    aceq3lem $p |- ( A. x E. f A. z e. x ( z =/= (/) -> ( f ` z
                 ) e. z ) -> E. f ( f C_ y /\ f Fn dom y ) ) $=
      ( vg vh cv c0 wcel wi wex wss wfn wa wceq wbr wne cfv wal cdm crn cpw vex
      wral rnex pwex raleq exbidv spcv copab cmpt df-mpt eqtri eldm abn0 bitr4i
      cab brelrn abssi elpw2 mpbir neeq1 fveq2 eleq12d imbi12d rspcv syl5bi imp
      id ax-mp fvex breq2 cbvabv elab2 sylib syl5ibrcom ssopab2dv opabss syl6ss
      expimpd syl5eqss fnmpti cvv ssex adantr sseq1 fneq1 anbi12d mpcom sylancl
      spcegv exlimiv syl cbvexv ) CKZLUAZWSFKZUBZWSMZNZCAKZUHZFOZAUCZIKZBKZPZXI
      XJUDZQZRZIOZXAXJPZXAXLQZRZFOXHXDCXJUEZUFZUHZFOZXOXGYBAXTXSXJBUGZUIZUJXEXT
      SXFYAFXDCXEXTUKULUMYAXOFYAGXJPZGXLQZXOYAGDKZXLMZJKZYGEKZXJTZEVAZXAUBZSZRZ
      DJUNZXJGDXLYMUOYPHDJXLYMUPUQYAYPYGYIXJTZDJUNXJYAYOYQDJYAYHYNYQYAYHRZYQYNY
      GYMXJTZYRYMYLMZYSYAYHYTYHYLLUAZYAYTYHYKEOUUAEYGXJDUGZURYKEUSUTYLXTMZYAUUA
      YTNZNUUCYLXSPYKEXSYGYJXJUUBEUGVBVCYLXSYDVDVEXDUUDCYLXTWSYLSZWTUUAXCYTWSYL
      LVFUUEXBYMWSYLWSYLXAVGUUEVMVHVIVJVNVKVLYGWSXJTZYSCYMYLYLXAVOZWSYMYGXJVPYK
      UUFECYJWSYGXJVPVQVRVSYIYMYGXJVPVTWDWADJXJWBWCWEDXLYMGUUGHWFGWGMZYEYFRZXOY
      EUUHYFGXJYCWHWIXNUUIIGWGXIGSXKYEXMYFXIGXJWJXLXIGWKWLWOWMWNWPWQXNXRIFXIXAS
      XKXPXMXQXIXAXJWJXLXIXAWKWLWRVS $.
  $}

  ${
    $d f x y z w v u g h $.
    $( Equivalence of two versions of the Axiom of Choice.  The left-hand side
       is defined as the Axiom of Choice (first form) of [Enderton] p. 49.  The
       right-hand side is the Axiom of Choice of [TakeutiZaring] p. 83.  The
       proof does not depend on AC. (Contributed by NM, 24-Mar-2004.)  (Revised
       by Stefan O'Rear, 22-Feb-2015.) $)
    dfac3 $p |- ( CHOICE <->
             A. x E. f A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) ) $=
      ( vy vw vv vu cv wss cdm wfn wa wex wal cfv wcel wel vex wceq cab wac wne
      c0 wi wral df-ac copab cuni uniex xpex simpl elunii ancoms ssopab2i df-xp
      cxp jca sseqtr4i ssexi sseq2 dmeq fneq2d anbi12d exbidv spcv cima wb fndm
      csn eleq2 dmopab eleq2i weq elequ1 elab 19.42v n0 anbi2i 3bitrri syl6rbbr
      bitr4i syl adantl wfun fnfun funfvima3 sylan2 sylbid imp ibar abbi2dv wbr
      cvv imasng ax-mp anbi2d eqid brab abbii eqtri syl6reqr eleq2d mpbid exp32
      ad2antrl ralrimiv eximi alrimiv cmpt aceq3lem impbii bitri ) UACHZDHZIZXM
      XNJZKZLZCMZDNZBHZUCUBZYAXMOZYAPZUDZBAHZUEZCMZANZDCUFXTYIXTYHAXTXMEAQZFEQZ
      LZEFUGZIZXMYMJZKZLZCMZYHXSYRDYMYMYFYFUHZUPZYFYSARZYFUUAUIUJYMYJFHZYSPZLZE
      FUGYTYLUUDEFYLYJUUCYJYKUKYKYJUUCUUBEHZYFULUMUQUNEFYFYSUOURUSXNYMSZXRYQCUU
      FXOYNXQYPXNYMXMUTUUFXPYOXMXNYMVAVBVCVDVEYQYGCYQYEBYFYQBAQZYBYDYQUUGYBLZLY
      CYMYAVIVFZPZYDYQUUHUUJYQUUHYAXMJZPZUUJYPUUHUULVGZYNYPUUKYOSZUUMYOXMVHUUNU
      ULYAYOPZUUHUUKYOYAVJUUOYAYLFMZETZPUUGFBQZLZFMZUUHYOUUQYAYLEFVKVLUUPUUTEYA
      BRZEBVMZYLUUSFUVBYJUUGYKUUREBAVNUUEYAUUBVJVCZVDVOUUTUUGUURFMZLUUHUUGUURFV
      PYBUVDUUGFYAVQVRWAVSVTWBWCYPYNXMWDZUULUUJUDZYOXMWEUVEYNUVFYAXMYMWFUMWGWHW
      IUUGUUJYDVGYQYBUUGUUIYAYCUUGYAUUGGBQZLZGTZUUIUUGUVHGYAUUGUVGWJWKUUIYAGHZY
      MWLZGTZUVIYAWMPUUIUVLSUVAGYAWMYMWNWOUVKUVHGYLUUSUVHEFYAUVJYMUVAGRUVCFGVMU
      URUVGUUGFGBVNWPYMWQWRWSWTXAXBXEXCXDXFXGWBXHYIXSDADBEGCEXPUUEUVJXNWLGTXMOX
      IZUVMWQXJXHXKXL $.
  $}

  ${
    $d f x z y w v $.
    $( Equivalence of two versions of the Axiom of Choice.  The right-hand side
       is Axiom AC of [BellMachover] p. 488.  The proof does not depend on AC.
       (Contributed by NM, 24-Mar-2004.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    dfac4 $p |- ( CHOICE <->
        A. x E. f ( f Fn x /\ A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) ) ) $=
      ( vy vw cv c0 cfv wcel wi wral wex wal wfn wceq fveq1 eleq1d imbi2d cvv
      wa wac wne dfac3 ralbidv cbvexv cmpt fvex eqid fnmpti fveq2 fvmpt ralbiia
      anbi2i mpbiran crn csn cun fvrn0 rgenw fmpt mpbi vex rnex p0ex unex mp3an
      fex2 fneq1 anbi12d spcev sylbir exlimiv sylbi exsimpr impbii albii bitri
      wf ) UABFZGUBZVSCFZHZVSIZJZBAFZKZCLZAMWAWENZWFTZCLZAMABCUCWGWJAWGWJWGVTVS
      DFZHZVSIZJZBWEKZDLWJWFWOCDWAWKOZWDWNBWEWPWCWMVTWPWBWLVSVSWAWKPQRUDUEWOWJD
      WOEWEEFZWKHZUFZWENZVTVSWSHZVSIZJZBWEKZTZWJXEWTWOEWEWRWSWQWKUGWSUHZUIXDWOW
      TXCWNBWEVSWEIZXBWMVTXGXAWLVSEVSWRWLWEWSWQVSWKUJXFVSWKUGUKQRULUMUNWIXECWSW
      EWKUOZGUPZUQZWSVRZWESIXJSIWSSIWRXJIZEWEKXKXLEWEWKWQURUSEWEXJWRWSXFUTVAAVB
      XHXIWKDVBVCVDVEWEXJWSSSVGVFWAWSOZWHWTWFXDWEWAWSVHXMWDXCBWEXMWCXBVTXMWBXAV
      SVSWAWSPQRUDVIVJVKVLVMWHWFCVNVOVPVQ $.
  $}

  ${
    $d v w y g t $.
    $( Lemma for ~ dfac5 .  (Contributed by NM, 12-Apr-2004.) $)
    dfac5lem1 $p |- ( E! v v e. ( ( { w } X. w ) i^i y ) <->
                      E! g ( g e. w /\ <. w , g >. e. y ) ) $=
      ( vt cv csn cxp wcel weu cop wceq wa wex bitri anbi1i anbi12i ancom exbii
      3bitri cin elin elxp excom 19.41vv an32 eleq1 pm5.32i an4 anass vex opeq1
      elsn eqeq2d eleq1d anbi2d anbi12d ceqsexv bitr3i eubii euop2 ) CFZBFZGZVC
      HZAFZUAIZCJVBVCDFZKZLZVHVCIZVIVFIZMZMZDNZCJVMDJVGVOCVGVBVEIZVBVFIZMVBEFZV
      HKZLZVRVDIZVKMZMZENDNZVQMZVOVBVEVFUBVPWDVQVPWCDNENWDEDVBVDVCUCWCEDUDOPWEW
      CVQMZENZDNVOWCVQDEUEWGVNDWGVRVCLZVTVKVSVFIZMZMZMZENVNWFWLEWFVTVQMZWBMVTWI
      MZWHVKMZMZWLVTWBVQUFWMWNWBWOVTVQWIVBVSVFUGUHWAWHVKEVCUMPQWPVTWHMZWIVKMZMW
      HVTMZWJMWLVTWIWHVKUIWQWSWRWJVTWHRWIVKRQWHVTWJUJTTSWKVNEVCBUKZWHVTVJWJVMWH
      VSVIVBVRVCVHULZUNWHWIVLVKWHVSVIVFXAUOUPUQUROSUSTUTVMCDVCWTVAO $.
  $}

  ${
    $d f x z y w v u t h g $.  $d z w f g B $.  $d x y z w g A $.
    dfac5lem.1 $e |- A =
                    { u | ( u =/= (/) /\ E. t e. h u = ( { t } X. t ) ) } $.
    $( Lemma for ~ dfac5 .  (Contributed by NM, 12-Apr-2004.) $)
    dfac5lem2 $p |- ( <. w , g >. e. U. A <-> ( w e. h /\ g e. w ) ) $=
      ( cv cuni wcel wceq wrex wa wel wex exbii 3bitri anbi2i vex bitri cop wne
      c0 csn cxp cab unieqi eleq2i eluniab r19.42v bitr2i rexcom4 df-rex bitr3i
      anass ancom ne0i pm4.71i bitr4i snex xpex eleq2 opelxp elsn equcom anbi1i
      ceqsexv an12 elequ1 anbi12d ) AHZEHZUAZDIZJVMBHZUCUBZVOCHZUDZVQUEZKZCFHZL
      ZMZBUFZIZJZCFNZVMVOJZVPMZVTMZBOZMZCOZAFNZEANZMZVNWEVMDWDGUGUHWFWHWCMZBOWJ
      CWALZBOZWMWCBVMUIWQWRBWRWIWBMWQWIVTCWAUJWHVPWBUOUKPWSWKCWALWMWJCBWAULWKCW
      AUMUNQWMVQVKKZWGECNZMZMZCOWPWLXCCWLWGVMVSJZMWGWTXAMZMXCWKXDWGWKVTWHMZBOXD
      WJXFBWJVTWIMXFWIVTUPWHWIVTWHVPVOVMUQURRUSPWHXDBVSVRVQVQUTCSVAVOVSVMVBVGTR
      XDXEWGXDVKVRJZXAMXEVKVLVRVQVCXGWTXAXGVKVQKWTAVQVDACVETVFTRWGWTXAVHQPXBWPC
      VKASWTWGWNXAWOCAFVIVQVKVLVBVJVGTQ $.

    $( Lemma for ~ dfac5 .  (Contributed by NM, 12-Apr-2004.) $)
    dfac5lem3 $p |- ( ( { w } X. w ) e. A <-> ( w =/= (/) /\ w e. h ) ) $=
      ( cv csn cxp c0 wne wceq wrex wa wcel vex xpeq2 crn rneq snnz neeq1 eqeq1
      cab snex xpex rexbidv anbi12d elab eleq2i xp0 syl6eq ax-mp 3eqtr3g impbii
      rnxp rn0 necon3bii wex df-rex sneq xpeq1d eqtrd equcom bitri anbi2i ancom
      exbii elequ1 ceqsexv 3bitrri anbi12i 3bitr4i ) AGZHZVMIZBGZJKZVPCGZHZVRIZ
      LZCEGZMZNZBUCZOVOJKZVOVTLZCWBMZNZVODOVMJKZVMWBOZNWDWIBVOVNVMVMUDAPZUEVPVO
      LZVQWFWCWHVPVOJUAWMWAWGCWBVPVOVTUBUFUGUHDWEVOFUIWJWFWKWHVMJVOJVMJLZVOJLZW
      NVOVNJIJVMJVNQVNUJUKWOVORZJRVMJVOJSVNJKWPVMLVMWLTVNVMUOULZUPUMUNUQWHVRWBO
      ZWGNZCURVRVMLZWRNZCURWKWGCWBUSWSXACWSWRWTNXAWGWTWRWGVMVRLZWTWGXBWGWPVTRZV
      MVRVOVTSWQVSJKXCVRLVRCPTVSVRUOULUMXBVOVSVMIVTXBVNVSVMVMVRUTVAVMVRVSQVBUNA
      CVCVDVEWRWTVFVDVGWRWKCVMWLCAEVHVIVJVKVL $.

    ${
      dfac5lem.2 $e |- B = ( U. A i^i y ) $.
      dfac5lem.3 $e |- ( ph <-> A. x ( ( A. z e. x z =/= (/) /\
             A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
            E. y A. z e. x E! v v e. ( z i^i y ) ) ) $.
      $( Lemma for ~ dfac5 .  (Contributed by NM, 11-Apr-2004.) $)
      dfac5lem4 $p |- ( ph -> E. y A. z e. A E! v v e. ( z i^i y ) ) $=
        ( cv wral wceq wcel wex wa vg c0 wne cin weu csn cxp wrex cab vex neeq1
        wi weq eqeq1 rexbidv anbi12d elab simplbi eleq2s wel wn wal df-an elab2
        rgen simprbi sneq xpeq1d xpeq2 eqtrd cbvrexv sylib cop eleq2 elxp excom
        eqeq2d bitri syl6bb bi2anan9 eeanv syl6bbr elsn biimpac sylan2b adantrr
        opeq1 exlimiv sylan9req opth1 syl exlimivv syl6bi syl6 eqeq12 rexlimivw
        sylibrd ex rexlimdvw imp syl2an syl5bir necon1ad alrimdv syl6ibr rgen2a
        disj1 cvv cuni cpw uniex xpex pwex wss elssuni xpss12 syl2anc snex elpw
        snssi sylibr eleq1 syl5ibrcom rexlimiv adantl abssi ssexi eqeltri raleq
        raleqbi1dv exbidv imbi12d spcv sylbi mp2ani ) ADOZUBUCZDIPZYPEOZUCZYPYS
        UDUBQZULZEIPZDIPZFOZYPCOZUDRFUEZDIPZCSZYQDIYQYPGOZUBUCZUUJHOZUFZUULUGZQ
        ZHKOZUHZTZGUIZIYPUUSRYQYPUUNQZHUUPUHZUURYQUVATZGYPDUJZGDUMZUUKYQUUQUVAU
        UJYPUBUKUVDUUOUUTHUUPUUJYPUUNUNUOUPZUQURLUSVEUUBDEIYPIRZYSIRZTZYTBDUTZB
        EUTZVAULZBVBUUAUVHYTUVKBUVHUVKYPYSUVKVAUVIUVJTZUVHDEUMZUVIUVJVCUVFUVAYS
        UAOZUFZUVNUGZQZUAUUPUHZUVLUVMULZUVGUVFYQUVAUURUVBGYPIUVCUVELVDVFUVGYSUU
        NQZHUUPUHZUVRUVGYSUBUCZUWAUURUWBUWATGYSIEUJGEUMZUUKUWBUUQUWAUUJYSUBUKUW
        CUUOUVTHUUPUUJYSUUNUNUOUPLVDVFUVTUVQHUAUUPHUAUMZUUNUVPYSUWDUUNUVOUULUGU
        VPUWDUUMUVOUULUULUVNVGVHUULUVNUVOVIVJZVQVKVLUVAUVRUVSUVAUVQUVSUAUUPUUTU
        VQUVSULHUUPUUTUVQUVSUUTUVQTZUVLUUNUVPQZUVMUWFUVLUWDUWGUWFUVLBOZUUJUUEVM
        ZQZUUJUUMRZFHUTZTTZGSZUWHUUJUUFVMZQZUUJUVORZCUAUTZTTZGSZTZCSFSZUWDUWFUV
        LUWNFSZUWTCSZTUXBUUTUVIUXCUVQUVJUXDUUTUVIUWHUUNRZUXCYPUUNUWHVNUXEUWMFSG
        SUXCGFUWHUUMUULVOUWMGFVPVRVSUVQUVJUWHUVPRZUXDYSUVPUWHVNUXFUWSCSGSUXDGCU
        WHUVOUVNVOUWSGCVPVRVSVTUWNUWTFCWAWBUXAUWDFCUXAUULUUEVMZUVNUUFVMZQUWDUWN
        UWTUXGUWHUXHUWMUWHUXGQZGUWJUWKUXIUWLUWKUWJGHUMZUXIGUULWCUXJUWJUXIUXJUWI
        UXGUWHUUJUULUUEWGVQWDWEWFWHUWSUWHUXHQZGUWPUWQUXKUWRUWQUWPGUAUMZUXKGUVNW
        CUXLUWPUXKUXLUWOUXHUWHUUJUVNUUFWGVQWDWEWFWHWIUULUUEUVNUUFHUJZFUJWJWKWLW
        MUWEWNYPUUNYSUVPWOWQWRWPWSWTXAXBXCXDBYPYSXGXEXFAYQDUWHPZUUBEUWHPZDUWHPZ
        TZUUGDUWHPZCSZULZBVBYRUUDTZUUIULZNUXTUYBBIIUUSXHLUUSUUPUUPXIZUGZXJZUYDU
        UPUYCKUJZUUPUYFXKXLXMUURGUYEUUQUUJUYERZUUKUUOUYGHUUPHKUTZUYGUUOUUNUYERZ
        UYHUUNUYDXNZUYIUYHUUMUUPXNUULUYCXNUYJUULUUPXTUULUUPXOUUMUUPUULUYCXPXQUU
        NUYDUUMUULUULXRUXMXLXSYAUUJUUNUYEYBYCYDYEYFYGYHUWHIQZUXQUYAUXSUUIUYKUXN
        YRUXPUUDYQDUWHIYIUXOUUCDUWHIUUBEUWHIYIYJUPUYKUXRUUHCUUGDUWHIYIYKYLYMYNY
        O $.

      $( Lemma for ~ dfac5 .  (Contributed by NM, 12-Apr-2004.) $)
      dfac5lem5 $p |- ( ph ->
                           E. f A. w e. h ( w =/= (/) -> ( f ` w ) e. w ) ) $=
        ( vg cv wcel weu wa cin wral wex c0 wne cfv dfac5lem4 cop simpr a1i csn
        wi cxp wceq ineq1 eleq2d eubidv rspccv dfac5lem3 dfac5lem1 3imtr3g jcad
        cuni eleq2i elin dfac5lem2 anbi1i anass bitri 3bitri eubii euanv bitr2i
        syl6ib euex nfeu1 nfv simprbi simpld tz6.12 eleq1d biimparc exp32 mpcom
        nfim exlimi syl6 exp3acom23 ralrimiv cvv vex inex2 eqeltri fveq1 imbi2d
        ralbidv spcev syl exlimiv ) AFQZDQZCQZUAZRZFSZDIUBZCUCEQZUDUEZXGKQZUFZX
        GRZULZELQZUBZKUCZABCDEFGHIJLMNOUGXFXOCXFXHXGJUFZXGRZULZEXMUBZXOXFXREXMX
        FXHXGXMRZXQXFXHXTTZXGPQZUHZJRZPSZXQXFYAXTYBXGRZYCXBRZTZPSZTZYEXFYAXTYIY
        AXTULXFXHXTUIUJXFXGUKXGUMZIRWTYKXBUAZRZFSZYAYIXEYNDYKIXAYKUNZXDYMFYOXCY
        LWTXAYKXBUOUPUQUREGHILMUSCEFPUTVAVBYEXTYHTZPSYJYDYPPYDYCIVCZXBUAZRYCYQR
        ZYGTZYPJYRYCNVDYCYQXBVEYTXTYFTZYGTYPYSUUAYGEGHIPLMVFVGXTYFYGVHVIVJZVKXT
        YHPVLVMVNYDPUCYEXQYDPVOYDYEXQULZPYEXQPYDPVPXQPVQWEYFYDUUCYDYFYGYDXTYHUU
        BVRVSYFYDYEXQYDYETZXQYFUUDXPYBXGPXGJVTWAWBWCWDWFWDWGWHWIXNXSKJJYRWJNXBY
        QCWKWLWMXIJUNZXLXREXMUUEXKXQXHUUEXJXPXGXGXIJWNWAWOWPWQWRWSWR $.
    $}
  $}

  ${
    $d f x z y w v h u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The right-hand side
       is Theorem 6M(4) of [Enderton] p. 151 and asserts that given a family of
       mutually disjoint nonempty sets, a set exists containing exactly one
       member from each set in the family.  The proof does not depend on AC.
       (Contributed by NM, 11-Apr-2004.)  (Revised by Mario Carneiro,
       17-May-2015.) $)
    dfac5 $p |- ( CHOICE <-> A. x ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
          E. y A. z e. x E! v v e. ( z i^i y ) ) ) $=
      ( vf vt vh cv c0 wne wral cin wceq wi wa wcel wex wal weq wac weu wfn cfv
      vu dfac4 neeq1 cbvralv anbi2i r19.26 bitr4i pm3.35 ancoms ralimi sylbi wb
      crn elin wrex fvelrnb biimpac fveq2 id eleq12d neeq2 ineq2 eqeq1d imbi12d
      wel anbi12d rspcv eleq1 biimpar wn minel imim2d imp necon4ad sylan2 eqeq2
      eqcom syl6bb syl5ib ad2antrl mpd exp32 syl6com com14 rexlimdv exp3a com4t
      syl5 imp4b syl5bi sylan2br anassrs adantlr fnfvelrn anim12d syl6ibr com13
      ex expcom imp31 syl5ibrcom adantr impbid alrimdv fvex bibi2d albidv spcev
      df-eu sylibr syl6 ralimdva vex rnex eleq2d eubidv ralbidv exlimiv csn cxp
      alimi cab cuni eqid biid dfac5lem5 alrimiv dfac3 impbii ) UACIZJKZCAIZLZY
      NDIZKZYNYRMZJNZOZDYPLZCYPLZPZEIZYNBIZMZQZEUBZCYPLZBRZOZASZUAFIZYPUCZYRJKZ
      YRUUOUDZYRQZOZDYPLZPZFRZASUUNADFUFUVCUUMAUVBUUMFUVBUUEUUFYNUUOUQZMZQZEUBZ
      CYPLZUULUUPUVAYQUUDUVHUUPUVAYQUUDUVHOZUVAYQPZUUSDYPLZUUPUVIUVJUUTUUQPZDYP
      LZUVKUVJUVAUUQDYPLZPUVMYQUVNUVAYOUUQCDYPYNYRJUGUHUIUUTUUQDYPUJUKUVLUUSDYP
      UUQUUTUUSUUQUUSULUMUNUOUUPUVKUVIUUPUVKPZUUCUVGCYPUVOCAVIZPZUUCUVFUUFYNUUO
      UDZNZUPZESZUVGUVQUUCUVTEUVQUUCUVTUVQUUCPUVFUVSUVOUUCUVFUVSOZUVPUUPUVKUUCU
      WBUVKUUCPUUPUUSUUBPZDYPLZUWBUUSUUBDYPUJUVFECVIZUUFUVDQZPUUPUWDPUVSUUFYNUV
      DURUUPUWDUWEUWFUVSUWEUWFUUPUWDUVSUWEUWFUUPUWDUVSOZUWFUUPPGIZUUOUDZUUFNZGY
      PUSZUWEUWGUUPUWFUWKGYPUUFUUOUTVAUWEUWJUWGGYPUWDGAVIZUWJUWEUVSUWLUWDUWIUWH
      QZYNUWHKZYNUWHMZJNZOZPZUWJUWEUVSOOUWCUWRDUWHYPDGTZUUSUWMUUBUWQUWSUURUWIYR
      UWHYRUWHUUOVBUWSVCVDUWSYSUWNUUAUWPYRUWHYNVEUWSYTUWOJYRUWHYNVFVGVHVJVKUWRU
      WJUWEUVSUWRUWJUWEPZPCGTZUVSUWTUWRUWIYNQZUXAUWJUXBUWEUWIUUFYNVLVMUWRUXBUXA
      UWRUXBYNUWHUWMUWQUWNUXBVNZOUWMUWPUXCUWNUWMUWPUXCUWIUWHYNVOXBVPVQVRVQVSUWJ
      UXAUVSOUWRUWEUXAUVRUWINZUWJUVSYNUWHUUOVBUWJUXDUVRUUFNUVSUWIUUFUVRVTUVRUUF
      WAWBWCWDWEWFWGWHWIWLWJWKWMWNWOWPWQUVQUVSUVFOUUCUVQUVFUVSUVRUVEQZUUPUVKUVP
      UXEUVPUVKUUPUXEUVPUVKUUPUXEUVPUVKUUPPUVRYNQZUVRUVDQZPUXEUVPUVKUXFUUPUXGUU
      SUXFDYNYPDCTZUURUVRYRYNYRYNUUOVBUXHVCVDVKUUPUVPUXGYPYNUUOWRXCWSUVRYNUVDUR
      WTWJXAXDUUFUVRUVEVLXEXFXGXBXHUWAUVFEHTZUPZESZHRUVGUXKUWAHUVRYNUUOXIHIZUVR
      NZUXJUVTEUXMUXIUVSUVFUXLUVRUUFVTXJXKXLUVFEHXMXNXOXPXBWLWJWMUUKUVHBUVDUUOF
      XQXRUUGUVDNZUUJUVGCYPUXNUUIUVFEUXNUUHUVEUUFUUGUVDYNVFXSXTYAXLXOYBYEUOUUNU
      UTDUXLLFRZHSUAUUNUXOHUUNABCDEUEGUEIZJKUXPUWHYCUWHYDNGUXLUSPUEYFZUXQYGUUGM
      ZFHUXQYHUXRYHUUNYIYJYKHDFYLXNYM $.
  $}

  ${
    $d x z f y w v u g $.
    $( Our Axiom of Choice (in the form of ~ ac3 ) implies the Axiom of Choice
       (first form) of [Enderton] p. 49.  The proof uses neither AC nor the
       Axiom of Regularity.  See ~ dfac2 for the converse (which does use the
       Axiom of Regularity).  (Contributed by NM, 5-Apr-2004.)  (Revised by
       Mario Carneiro, 26-Jun-2015.) $)
    dfac2a $p |- ( A. x E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
                      ( z e. v /\ w e. v ) ) -> CHOICE ) $=
      ( vf vu cv wel wa wrex wi wral wex wal cfv wcel cuni uniex cvv c0 wne wac
      wreu crab cmpt riotauni riotacl eqeltrrd cab elequ2 elequ1 anbi1d rexbidv
      crio wceq anbi12d abbidv df-rab 3eqtr4g unieqd rabex fvmpt eleq1d syl5ibr
      eqid vex imim2d ralimia cpw wss ssrab2 elssuni syl5ss unissd elpw2 sylibr
      fmpti pwex fex2 mp3an fveq1 imbi2d ralbidv spcev syl exlimiv alimi dfac3
      wf ) CHZUAUBZCEIZDEIZJZEBHZKZDWKUDZLZCAHZMZBNZAOWLWKFHZPZWKQZLZCWTMZFNZAO
      UCXBXHAXAXHBXAWLWKGWTGEIZWNJZEWPKZDGHZUEZRZUFZPZWKQZLZCWTMZXHWSXRCWTCAIZW
      RXQWLWRXQXTWQDWKUEZRZWKQWRWQDWKUOYBWKWQDWKUGWQDWKUHUIXTXPYBWKGWKXNYBWTXOX
      LWKUPZXMYAYCDGIZXKJZDUJDCIZWQJZDUJXMYAYCYEYGDYCYDYFXKWQGCDUKYCXJWOEWPYCXI
      WMWNGCEULUMUNUQURXKDXLUSWQDWKUSUTVAXOVFZYAWQDWKCVGVBSVCVDVEVHVIXGXSFXOWTW
      TRZRZVJZXOWJWTTQYKTQXOTQGWTYKXNXOYHGAIZXNYJVKXNYKQYLXMYIYLXMXLYIXKDXLVLXL
      WTVMVNVOXNYJYIWTAVGZSSZVPVQVRYMYJYNVSWTYKXOTTVTWAXCXOUPZXFXRCWTYOXEXQWLYO
      XDXPWKWKXCXOWBVDWCWDWEWFWGWHACFWIVQ $.
  $}

  ${
    $d x y z w v u f g h $.
    $( Axiom of Choice (first form) of [Enderton] p. 49 implies of our Axiom of
       Choice (in the form of ~ ac3 ).  The proof does not make use of AC. Note
       that the Axiom of Regularity is used by the proof.  Specifically,
       ~ elirrv and ~ preleq that are referenced in the proof each make use of
       Regularity for their derivations.  (The reverse implication can be
       derived without using Regularity; see ~ dfac2a .)  TODO:  Fix label in
       comment, and put label changes into list at top of set.mm.  (Contributed
       by NM, 5-Apr-2004.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    dfac2 $p |- ( CHOICE <-> A. x E. y A. z e. x ( z =/= (/) ->
        E! w e. z E. v e. y ( z e. v /\ w e. v ) ) ) $=
      ( vf vu vg cv c0 wel wa wrex wi wex wcel wceq weq vex eleq2 wac wreu wral
      wne wal cfv dfac3 cpr cab nfra1 wmo rsp equid neeq1 anbi12d rspcev mpanr2
      eqeq1 fveq2 preq1d preq2 eqtr2d anim2i reximi syl prex anbi2d elab sylibr
      rexbidv prid2 fvex prid1 pm3.2i sylancl eleq1 spcev ex syl8 imp3a pm2.43d
      sylan2 df-rex eleq1d bitrd imbi12d rspccv wb wn elirrv mtbii con2i prel12
      ancom syl5rbbr adantrr pm5.32da preleq syl6bir eqeq2d biimparc syl6 exp4c
      sylan9bbr com13 com4r imp imp4a com3l rexlimiv sylbi exp3a exlimdv syl5bi
      imp4b expimpd alrimiv mo2icl jctird weu eu5 bitri syl6ibr ralrimi crn csn
      df-reu cun cpw rnex p0ex unex pwex ssun1 fvrn0 sselii elun2 prssi sylancr
      wss elpw syl5ibrcom adantld abssi ssexi rexeq reubidv imbi2d alimi dfac2a
      ralbidv exlimiv impbii ) UACIZJUDZCEKZDEKZLZEBIZMZDUUNUBZNZCAIZUCZBOZAUEZ
      UAUUOUUNFIZUFZUUNPZNZCUVCUCZFOZAUEUVFACFUGUVLUVEAUVKUVEFUVKUUOUUREGIZJUDZ
      HIZUVMUVGUFZUVMUHZQZLZGUVCMZHUIZMZDUUNUBZNZCUVCUCZUVEUVKUWDCUVCUVJCUVCUJU
      VKCAKZUUOUWCUVKUWFUUOLZDCKZUWBLZDOZUWIDUKZLZUWCUVKUWGUWJUWKUVKUWGUWJUVKUW
      FUUOUWGUWJNZUVKUWFUUOUVIUWMUVJCUVCULUVIUWGUWJUWGUVIUUPUVHEIZPZLZEUWAMZUWJ
      UWGUVHUUNUHZUWAPZUUNUWRPZUVHUWRPZLZUWQUWGUVNUWRUVQQZLZGUVCMZUWSUWGUVNGCRZ
      LZGUVCMZUXEUWFUUOCCRZUXHCUMUXGUUOUXILGUUNUVCUXFUVNUUOUXFUXIUVMUUNJUNUVMUU
      NUUNURUOUPUQUXGUXDGUVCUXFUXCUVNUXFUVQUVHUVMUHUWRUXFUVPUVHUVMUVMUUNUVGUSUT
      UVMUUNUVHVAVBVCVDVEUVTUXEHUWRUVHUUNVFUVOUWRQZUVSUXDGUVCUXJUVRUXCUVNUVOUWR
      UVQURVGVJVHVIUWTUXAUVHUUNCSZVKUVHUUNUUNUVGVLZVMVNUWPUXBEUWRUWAUWNUWRQUUPU
      WTUWOUXAUWNUWRUUNTUWNUWRUVHTUOUPVOUWIUVIUWQLDUVHUXLDIZUVHQZUWHUVIUWBUWQUX
      MUVHUUNVPUXNUURUWPEUWAUXNUUQUWOUUPUXMUVHUWNVPVGVJUOVQWBVRVSVTWAUVKUWIUXNN
      ZDUEUWKUVKUXODUVKUWHUWBUXNUWBUWNUWAPZUURLZEOUVKUWHLZUXNUUREUWAWCUXRUXQUXN
      EUVKUWHUXPUURUXNUXPUWHUVKUURUXNNZUXPUWHUVKUXSUXPUVNUWNUVQQZLZGUVCMZUWHUVK
      LZUXSNZUVTUYBHUWNESHERZUVSUYAGUVCUYEUVRUXTUVNUVOUWNUVQURVGVJVHUYAUYDGUVCU
      YCGAKZUYAUXSUYCUYFUVNUXTUXSUWHUVKUYFUVNUXTUXSNZNNUVKUYFUVNUWHUYGUVKUYFUVN
      UVPUVMPZUWHUYGNUVJUVNUYHNCUVMUVCCGRZUUOUVNUVIUYHUUNUVMJUNUYIUVIUVPUUNPUYH
      UYIUVHUVPUUNUUNUVMUVGUSZWDUUNUVMUVPTWEWFWGUXTUWHUYHUXSUXTUWHUYHUURUXNUXTU
      WHUYHLZUURLZUXMUVPQZUYILZUXNUXTUYLUYKUXMUUNUHUVQQZLUYNUXTUYKUYOUURUXTUWHU
      YOUURWHZUYHUWHUXTDCRZWIZUYPUYQUWHUYQDDKUWHDWJUXMUUNUXMTWKWLUYRUYOUXMUVQPZ
      UUNUVQPZLZUXTUURUXMUUNUVPUVMDSZUXKUVMUVGVLZGSZWMUURUUQUUPLUXTVUAUUQUUPWNU
      XTUUQUYSUUPUYTUWNUVQUXMTUWNUVQUUNTUOWOXDWBWPWQUXMUUNUVPUVMVUBUXKVUCVUDWRW
      SUYIUXNUYMUYIUVHUVPUXMUYJWTXAXBXCXEVSXFXGXHXIXJXKXLXEXOXMXNXPXQUWIDUVHXRV
      EXSUWCUWIDXTUWLUWBDUUNYGUWIDYAYBYCXLYDUVDUWEBUWAUWAUVGYEZJYFZYHZUVCYHZYIZ
      VUHVUGUVCVUEVUFUVGFSYJYKYLASYLYMUVTHVUIUVSUVOVUIPZGUVCUYFUVRVUJUVNUYFVUJU
      VRUVQVUIPZUYFUVQVUHYTZVUKUYFUVPVUHPUVMVUHPVULVUGVUHUVPVUGUVCYNUVGUVMYOYPU
      VMUVCVUGYQUVPUVMVUHYRYSUVQVUHUVPUVMVFUUAVIUVOUVQVUIVPUUBUUCXJUUDUUEUUSUWA
      QZUVBUWDCUVCVUMUVAUWCUUOVUMUUTUWBDUUNUUREUUSUWAUUFUUGUUHUUKVQVEUULUUIXKAB
      CDEUUJUUM $.
  $}

  ${
    $d x z f y w v u $.
    $( Equivalence of the Axiom of Choice (first form) of [Enderton] p. 49 and
       our Axiom of Choice (in the form of ~ ac2 ).  The proof does not depend
       AC on but does depend on the Axiom of Regularity.  (Contributed by Mario
       Carneiro, 17-May-2015.) $)
    dfac7 $p |- ( CHOICE <->
                  A. x E. y A. z e. x A. w e. z E! v e. z E. u e. y
                      ( z e. u /\ v e. u ) ) $=
      ( wac cv c0 wne wel wa wrex wreu wi wral wex wal dfac2 aceq2 albii bitr4i
      ) GCHZIJCEKDEKLEBHZMDUCNOCAHZPBQZARCFKEFKLFUDMEUCNDUCPCUEPBQZARABCDESUGUF
      AABCDEFTUAUB $.
  $}

  ${
    $d x y z w v u t $.
    $( Equivalence of two versions of the Axiom of Choice.  The proof uses the
       Axiom of Regularity.  The right-hand side is our original ~ ax-ac .
       (Contributed by Mario Carneiro, 17-May-2015.) $)
    dfac0 $p |- ( CHOICE <->
              A. x E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u
     ( E. t ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) ) $=
      ( wac wel wa cv wrex wreu wral wex wal weq wb wi dfac7 aceq0 albii bitri
      ) HCFIEFIJFBKLECKZMDUDNCAKNBOZAPCDIDAIJFDIDGIJFGIGBIJJGOFEQRFPEOSDPCPBOZA
      PABCDEFTUEUFAABCDEFGUAUBUC $.
  $}

  ${
    $d x y z w v u t $.
    $( Equivalence of two versions of the Axiom of Choice ~ ax-ac .  The proof
       uses the Axiom of Regularity.  The right-hand side expresses our AC with
       the fewest number of different variables.  (Contributed by Mario
       Carneiro, 17-May-2015.) $)
    dfac1 $p |- ( CHOICE <->
              A. x E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. x A. z
     ( E. x ( ( z e. w /\ w e. x ) /\ ( z e. x /\ x e. y ) ) <-> z = x ) ) ) $=
      ( vu vv wac wel wa cv wrex wreu wral wex wal weq wb wi dfac7 aceq1 albii
      bitri ) GCEHFEHIEBJKFCJZLDUCMCAJMBNZAOCDHDAHIZUECAHABHIIANCAPQCOANRDOCOBN
      ZAOABCDFESUDUFAABCDFETUAUB $.
  $}

  ${
    $d f g r x y z $.  $d f r w y z $.
    $( A proof of the equivalency of the Well Ordering Theorem ~ weth and the
       Axiom of Choice ~ ac7 .  (Contributed by Mario Carneiro, 5-Jan-2013.) $)
    dfac8 $p |- ( CHOICE <-> A. x E. r r We x ) $=
      ( vz vf vy wac cv c0 wcel wral wex wal wwe cvv vex wceq exbidv spcv mpsyl
      alrimiv wne cfv wi dfac3 ccrd cdm cpw pwex raleq dfac8a dfac8b cuni uniex
      syl weeq2 dfac8c impbii bitri ) FCGZHUAUSDGUBUSIUCZCEGZJZDKZELZAGZBGZMZBK
      ZALZECDUDVDVIVDVHAVDVEUEUFIZVHVENIVDUTCVEUGZJZDKZVJAOZVCVMEVKVEVNUHVAVKPV
      BVLDUTCVAVKUIQRCVENDUJSBVEUKUNTVIVCEVANIVIVAULZVFMZBKZVCEOZVHVQAVOVAVRUMV
      EVOPVGVPBVEVOVFUOQRCVANDBUPSTUQUR $.
  $}

  ${
    $d f g s t x $.
    $( Equivalence of the axiom of choice with a statement related to ~ ac9 ;
       definition AC3 of [Schechter] p. 139.  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    dfac9 $p |- ( CHOICE <-> A. f ( ( Fun f /\ (/) e/ ran f ) ->
            X_ x e. dom f ( f ` x ) =/= (/) ) ) $=
      ( vt vg vs cv c0 wne cfv wcel wi wral wex cixp vex wceq imbi12d cvv ax-mp
      wa wac wal wfun crn wnel cdm dfac3 rnex exbidv spcv cmpt wn df-nel biimpi
      raleq ad2antlr fvelrn adantlr eleq1 syl5ibcom necon3bd simpll sylan neeq1
      simplr fveq2 id eleq12d rspcva syl2anc ralrimiva wb dmex mptelixpg sylibr
      mpd ne0i syl ex exlimdv syl5com alrimiv csn cdif cid cres fnresi neldifsn
      wfn fnfun difexg resiexg funeq rnresi syl6eq eleq2d notbid syl5bb anbi12d
      rneq dmeq dmresi ixpeq1d fveq1 fvresi sylan9eq ixpeq2dva neeq1d mp2ani n0
      eqtrd elixp eldifsn imbi1i impexp bitri ralbii2 adantl sylbi eximi impbii
      cbvralv ) UACFZGHZYCDFZIZYCJZKZCEFZLZDMZEUBZBFZUCZGYMUDZUEZTZAYMUFZAFZYMI
      ZNZGHZKZBUBZECDUGYLUUDYLUUCBYLYHCYOLZDMZYQUUBYKUUFEYOYMBOZUHYIYOPYJUUEDYH
      CYIYOUOUIUJYQUUEUUBDYQUUEUUBYQUUETZAYRYTYEIZUKZUUAJZUUBUUHUUIYTJZAYRLZUUK
      UUHUULAYRUUHYSYRJZTZYTGHZUULYQUUNUUPUUEYQUUNTZGYOJZULZUUPYPUUSYNUUNYPUUSG
      YOUMZUNUPUUQUURYTGUUQYTYOJZYTGPUURYNUUNUVAYPYSYMUQZURYTGYOUSUTVAVPURUUOUV
      AUUEUUPUULKZUUHYNUUNUVAYNYPUUEVBUVBVCYQUUEUUNVEYHUVCCYTYOYCYTPZYDUUPYGUUL
      YCYTGVDUVDYFUUIYCYTYCYTYEVFUVDVGVHQVIVJVPVKYRRJUUKUUMVLYMUUGVMAYRUUIYTRVN
      SVOUUAUUJVQVRVSVTWAWBUUDYKEUUDAYIGWCZWDZYSNZGHZYKUUDWEUVFWFZUCZGUVFJZULZU
      VHUVIUVFWIUVJUVFWGUVFUVIWJSGYIWHUUCUVJUVLTZUVHKBUVIUVFRJZUVIRJYIRJUVNEOYI
      UVERWKSUVFRWLSYMUVIPZYQUVMUUBUVHUVOYNUVJYPUVLYMUVIWMYPUUSUVOUVLUUTUVOUURU
      VKUVOYOUVFGUVOYOUVIUDUVFYMUVIWTUVFWNWOWPWQWRWSUVOUUAUVGGUVOUUAAUVFYTNUVGU
      VOAYRUVFYTUVOYRUVIUFUVFYMUVIXAUVFXBWOXCUVOAUVFYTYSUVOYSUVFJZYTYSUVIIYSYSY
      MUVIXDUVFYSXEXFXGXKXHQUJXIUVHYEUVGJZDMYKDUVGXJUVQYJDUVQYEUVFWIZYSYEIZYSJZ
      AUVFLZTYJAUVFYSYEDOXLUWAYJUVRUWAYJUWAYSGHZUVTKZAYILYJUVTUWCAUVFYIUVPUVTKY
      SYIJZUWBTZUVTKUWDUWCKUVPUWEUVTYSYIGXMXNUWDUWBUVTXOXPXQUWCYHACYIYSYCPZUWBY
      DUVTYGYSYCGVDUWFUVSYFYSYCYSYCYEVFUWFVGVHQYBXPUNXRXSXTXSVRWBYAXP $.
  $}

  ${
    $d x y $.
    $( Axiom of Choice equivalent: the cardinality function measures every
       set.  (Contributed by Mario Carneiro, 6-May-2015.) $)
    dfac10 $p |- ( CHOICE <-> dom card = _V ) $=
      ( vx vy cv ccrd cdm wcel wal wwe wex cvv wceq wac ween albii eqv 3bitr4ri
      dfac8 ) ACZDEZFZAGRBCHBIZAGSJKLTUAARBMNASOABQP $.

    $( Axiom of Choice equivalent: every set is equinumerous to an ordinal.
       (Contributed by Stefan O'Rear, 17-Jan-2015.) $)
    dfac10c $p |- ( CHOICE <-> A. x E. y e. On y ~~ x ) $=
      ( wac ccrd cdm cvv wceq cv wcel wal cen wbr con0 wrex dfac10 isnum2 albii
      eqv 3bitri ) CDEZFGAHZTIZAJBHUAKLBMNZAJOATRUBUCABUAPQS $.

    $( Axiom of Choice equivalent: every set is equinumerous to an ordinal
       (quantifier-free short cryptic version alluded to in ~ df-ac ).
       (Contributed by Stefan O'Rear, 17-Jan-2015.) $)
    dfac10b $p |- ( CHOICE <-> ( ~~ " On ) = _V ) $=
      ( vy vx cv cen wbr con0 wrex wal cima wcel wac cvv vex elima bicomi albii
      wceq dfac10c eqv 3bitr4i ) ACBCZDEAFGZBHUADFIZJZBHKUCLQUBUDBUDUBAUADFBMNO
      PBARBUCST $.
  $}

  ${
    $d f g x y z $.  $d x A $.  $d x V $.
    $( A choice equivalent: every set has choice sets of every length.
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    acacni $p |- ( ( CHOICE /\ A e. V ) -> AC_ A = _V ) $=
      ( vx wac wcel wa wacn cvv ccrd cdm simpr vex simpl dfac10 sylib syl5eleqr
      cv wceq numacn sylc a1i 2thd eqrdv ) DABEZFZCAGZHUECQZUFEZUGHEZUEUDUGIJZE
      UHDUDKUEUGHUJCLZUEDUJHRDUDMNOPABUGSTUIUEUKUAUBUC $.

    $( A choice equivalent: every set has choice sets of every length.
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    dfacacn $p |- ( CHOICE <-> A. x AC_ x = _V ) $=
      ( vf vy vz vg wac cv wacn cvv wceq wal wcel vex alrimiv wfn c0 wi wral wa
      cfv acacni mpan2 wne wex csn cdif cuni difexg ax-mp acneq eqeq1d spcv wss
      wf uniex id syl5eleqr eldifi elssuni syl eldifsni rgen acni2 sylancl cmpt
      mptex simpr eldifsn imbi1i fveq2 eqid fvmpt eleq1d pm5.74i impexp 3bitr3i
      jca fvex ralbii2 sylib crn fvrn0 rgenw fmpt mpbi jctil fneq1 fveq1 imbi2d
      cun ffn ralbidv anbi12d spcegv mpsyl exlimiv 3syl dfac4 sylibr impbii ) F
      AGZHZIJZAKZFXCAFXAILXCAMXAIUAUBNXDBGZCGZOZDGZPUCZXHXETZXHLZQZDXFRZSZBUDZC
      KFXDXOCXDXFPUEZUFZHZIJZXQXFUGZEGZUNZXHYATZXHLZDXQRZSZEUDZXOXCXSAXQXFILXQI
      LCMZXFXPIUHUIXAXQJXBXRIXAXQUJUKULXSXTXRLXHXTUMZXISZDXQRYGXSXTIXRXFYHUOXSU
      PUQYJDXQXHXQLZYIXIYKXHXFLZYIXHXFXPURZXHXFUSUTXHXFPVAVQVBDXQXHEXTVCVDYFXOE
      AXFXAYATZVEZILYFYOXFOZXIXHYOTZXHLZQZDXFRZSZXOAXFYNYHVFYFYTYPYFYEYTYBYEVGY
      DYSDXQXFYKYRQYLXISZYRQYKYDQYLYSQYKUUBYRXHXFPVHVIYKYRYDYKYQYCXHYKYLYQYCJYM
      AXHYNYCXFYOXAXHYAVJYOVKZXHYAVRVLUTVMVNYLXIYRVOVPVSVTXFYAWAXPWJZYOUNZYPYNU
      UDLZAXFRUUEUUFAXFYAXAWBWCAXFUUDYNYOUUCWDWEXFUUDYOWKUIWFXNUUABYOIXEYOJZXGY
      PXMYTXFXEYOWGUUGXLYSDXFUUGXKYRXIUUGXJYQXHXHXEYOWHVMWIWLWMWNWOWPWQNCDBWRWS
      WT $.

    $( The axiom of choice holds iff every set has choice sequences as long as
       itself.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    dfac13 $p |- ( CHOICE <-> A. x x e. AC_ x ) $=
      ( vy vz wac wacn wcel wal cvv vex wceq acacni mpan2 syl5eleqr alrimiv cpw
      cv pwex id acneq wbr eleq12d spcv ccrd cdm csdm wi canth2 sdomdom acndom2
      cdom mp2b acnnum sylib numacn mpsyl syl 2thd eqrdv dfacacn sylibr impbii
      a1i ) DAPZVCEZFZAGZDVEADVCHVDAIZDVCHFVDHJVGVCHKLMNVFBPZEZHJZBGDVFVJBVFCVI
      HVFCPZVIFZVKHFZVFVKOZVNEZFZVLVEVPAVNVKCIZQVCVNJZVCVNVDVOVRRVCVNSUAUBVHHFV
      PVKUCUDFZVLBIVPVKVOFZVSVKVNUETVKVNUJTVPVTUFVKVQUGVKVNUHVNVKVNUIUKVKULUMVH
      HVKUNUOUPVMVFVQVBUQURNBUSUTVA $.
  $}

  ${
    $d m n y z A $.  $d x y z C $.  $d m n x y z G $.  $d m n y z ph $.
    $d x y z F $.  $d y z H $.
    dfac12.1 $e |- ( ph -> A e. On ) $.
    dfac12.3 $e |- ( ph -> F : ~P ( har ` ( R1 ` A ) ) -1-1-> On ) $.
    dfac12.4 $e |- G = recs ( ( x e. _V |-> ( y e. ( R1 ` dom x ) |->
      if ( dom x = U. dom x , ( ( suc U. ran U. ran x .o ( rank ` y ) ) +o
          ( ( x ` suc ( rank ` y ) ) ` y ) ) , ( F `
            ( ( `' OrdIso ( _E , ran ( x ` U. dom x ) ) o.
              ( x ` U. dom x ) ) " y ) ) ) ) ) ) $.
    ${
      dfac12.5 $e |- ( ph -> C e. On ) $.
      dfac12.h $e |- H =
        ( `' OrdIso ( _E , ran ( G ` U. C ) ) o. ( G ` U. C ) ) $.
      $( Lemma for ~ dfac12 .  (Contributed by Mario Carneiro, 29-May-2015.) $)
      dfac12lem1 $p |- ( ph -> ( G ` C ) = ( y e. ( R1 ` C ) |->
      if ( C = U. C , ( ( suc U. ran U. ( G " C ) .o ( rank ` y ) ) +o
          ( ( G ` suc ( rank ` y ) ) ` y ) ) , ( F ` ( H " y ) ) ) ) ) $=
        ( cfv cuni wceq crn con0 wcel syl cres cvv cv cdm cr1 csuc crnk comu co
        coa cep coi ccnv ccom cima cif cmpt tfr2 wfun wfn fnfun ax-mp resfunexg
        tfr1 sylancr dmeq fveq2d unieqd eqeq12d rneq df-ima syl6eqr rneqd suceq
        oveq1d fveq1 fveq1d oveq12d id fveq12d cnveqd coeq12d imaeq1d ifbieq12d
        oieq2 mpteq12dv eqid fvex mptex wss onss fnssres fndm mpteq1d wa adantr
        fvmpt ifbid rankr1ai ad2antlr simpr eleqtrd word eloni ordsucuniel 3syl
        wb ad2antrr mpbid fvres oveq2d ifeq1da wn uniexg wo orduniorsuc orcanai
        sucidg eleqtrrd eqtrd ifeq2da 3eqtrd mpteq2dva ) AEGNZGEUAZBUBCBUCZUDZU
        ENZYGYGOZPZYFQZOZQZOZUFZCUCZUGNZUHUIZYPYQUFZYFNZNZUJUIZYIYFNZQZUKULZUMZ
        UUCUNZYPUOZFNZUPZUQZUQZNZCYEUDZUENZUUNUUNOZPZGEUOZOZQZOZUFZYQUHUIZYPYSY
        ENZNZUJUIZUUPYENZQZUKULZUMZUVGUNZYPUOZFNZUPZUQZCEUENZEEOZPZUVCYPYSGNZNZ
        UJUIZHYPUOZFNZUPZUQZAERSZYDUUMPLEGUULKURTAYEUBSZUUMUVOPAGUSZUWFUWGGRUTZ
        UWHGUULKVDZRGVAVBLGERVCVEBYEUUKUVOUBUULYFYEPZCYHUUJUUOUVNUWKYGUUNUEYFYE
        VFZVGUWKYJUUQUUBUUIUVFUVMUWKYGUUNYIUUPUWLUWKYGUUNUWLVHZVIUWKYRUVCUUAUVE
        UJUWKYOUVBYQUHUWKYNUVAPYOUVBPUWKYMUUTUWKYLUUSUWKYKUURUWKYKYEQUURYFYEVJG
        EVKVLVHVMVHYNUVAVNTVOUWKYPYTUVDYSYFYEVPVQVRUWKUUHUVLFUWKUUGUVKYPUWKUUFU
        VJUUCUVGUWKUUEUVIUWKUUDUVHPUUEUVIPUWKUUCUVGUWKYIUUPYFYEUWKVSUWMVTZVMUUD
        UVHUKWETWAUWNWBWCVGWDWFUULWGCUUOUVNUUNUEWHWIWQTAUVOCUVPUVNUQUWEACUUOUVP
        UVNAUUNEUEAYEEUTZUUNEPZAUWIERWJZUWOUWJAUWFUWQLEWKTREGWLVEEYEWMTZVGWNACU
        VPUVNUWDAYPUVPSZWOZUVNUVRUVFUVMUPUVRUWAUVMUPUWDUWTUUQUVRUVFUVMUWTUUNEUU
        PUVQAUWPUWSUWRWPZUWTUUNEUXAVHZVIWRUWTUVRUVFUWAUVMUWTUVRWOZUVEUVTUVCUJUX
        CYPUVDUVSUXCYSESZUVDUVSPUXCYQUVQSZUXDUXCYQEUVQUWSYQESAUVRYPEWSWTUWTUVRX
        AXBAUXEUXDXGZUWSUVRAUWFEXCZUXFLEXDZYQEXEXFXHXIYSEGXJTVQXKXLUWTUVRUVMUWC
        UWAUWTUVRXMZWOZUVLUWBFUXJUVKHYPUXJUVKUVQGNZQZUKULZUMZUXKUNHUXJUVJUXNUVG
        UXKUXJUVIUXMUXJUVHUXLPUVIUXMPUXJUVGUXKUXJUVGUVQYENZUXKUXJUUPUVQYEUWTUUP
        UVQPUXIUXBWPVGUXJUVQESUXOUXKPUXJUVQUVQUFZEUXJUWFUVQUBSUVQUXPSAUWFUWSUXI
        LXHERXNUVQUBXRXFUWTUVREUXPPZUWTUWFUXGUVRUXQXOAUWFUWSLWPUXHEXPXFXQXSUVQE
        GXJTXTZVMUVHUXLUKWETWAUXRWBMVLWCVGYAYBYCXTYB $.

      dfac12.6 $e |- ( ph -> C C_ A ) $.
      dfac12.8 $e |- ( ph -> A. z e. C ( G ` z ) : ( R1 ` z ) -1-1-> On ) $.
      $( Lemma for ~ dfac12 .  (Contributed by Mario Carneiro, 29-May-2015.) $)
      dfac12lem2 $p |- ( ph -> ( G ` C ) : ( R1 ` C ) -1-1-> On ) $=
        ( cfv con0 wceq wcel cr1 wf1 cuni cima crn csuc cv crnk comu co coa cif
        cmpt wa cvv wss wfun wfn cdm cep coi ccnv ccom tfr1 fnfun ax-mp sylancr
        funimaexg uniexg rnexg 3syl cxp cpw wral f1f fssxp ssv xpss1 sstr mpan2
        wf fvex elpw sylibr ralimi syl wb onss fndm syl6sseqr funimass4 sspwuni
        mpbird rnss sylc ad2antrr ad2antlr eleqtrd word fveq2 f1eq1 f1eq2 bitrd
        rankon rspcv r1elwf rankidb ffvelrnd syl2anc char wf1o wwe eleqtrrd frn
        adantr f1of1 4syl cdom wbr cen sseldd endomtr iftrue eqeq12d adantl a1i
        ex adantlrr anbi1d fveq2d eleq1d chvarv adantlrl f1fveq syl12anc 3bitrd
        wi imbi12d iffalse elpwid sylib rnxpss syl6ss ssonuni suceloni rankr1ai
        omcl sylancl simpr eloni ordsucuniel mpbid oacl imassrn wiso rnex onuni
        wn sucidg orduniorsuc orcanai epweon wess ee10 eqid oiiso isof1o f1ocnv
        wo f1f1orn f1co harcl onordi oion mp1i oien f1oen ensym r1ord2 elharval
        ssdomg mpsyl sylanbrc ordelss sstrd syl5ss elpw2 ifclda c0 wne onsucuni
        nsuceq0 fnfvima syl3anc elssuni f1fn eleq1 anbi2d suceq fveq12d omopth2
        fnfvelrn syl222anc fveq1d eqeq2d ad2antll bitr3d biimpd expimpd impbid1
        id jca simplrl r1suc eqtrd simplrr f1imaeq pm2.61dan dom2lem dfac12lem1
        imaeq2 ) AFUAQZRFHQZUBZUYBRCUYBFFUCZSZHFUDZUCZUEZUCZUFZCUGZUHQZUIUJZUYL
        UYMUFZHQZQZUKUJZIUYLUDZGQZULZUMZUBZACDUYBRVUAUYFUYKDUGZUHQZUIUJVUDVUEUF
        ZHQZQZUKUJZIVUDUDZGQZULZAUYLUYBTZVUARTAVUMUNZUYFUYRUYTRVUNUYFUNZUYNRTZU
        YQRTUYRRTVUOUYKRTZUYMRTZVUPAVUQVUMUYFAUYJRTZVUQAUYIUOTZUYIRUPZVUSAUYGUO
        TZUYHUOTVUTAHUQZFRTZVVBHRURZVVCHBUOCBUGZUSZUAQVVGVVGUCZSVVFUEUCUEUCUFUY
        MUIUJUYLUYOVVFQQUKUJVVHVVFQZUEUTVAVBVVIVCUYLUDGQULUMUMLVDZRHVEVFZMHFRVH
        VGUYGUOVIUYHUOVJVKAUYIUORVLZUEZRAUYHVVLUPZUYIVVMUPAUYGVVLVMZUPZVVNAVVPV
        UDHQZVVOTZDFVNZAVUDUAQZRVVQUBZDFVNZVVSPVWAVVRDFVWAVVTRVVQWAVVQVVTRVLZUP
        ZVVRVVTRVVQVOVVTRVVQVPVWDVVQVVLUPZVVRVWDVWCVVLUPZVWEVVTUOUPVWFVVTVQVVTU
        ORVRVFVVQVWCVVLVSVTVVQVVLVUDHWBWCWDVKWEWFAVVCFHUSZUPVVPVVSWGVVKAFRVWGAV
        VDFRUPZMFWHWFZVVEVWGRSVVJRHWIVFWJDFVVOHWKVGWMUYGVVLWLUUAUYHVVLWNWFUORUU
        BUUCZUYIUOUUDWOUYJUUEWFZWPUYLXDZUYKUYMUUGUUHVUOUYOUAQZRUYLUYPVUOVWMRUYP
        UBZVWMRUYPWAVUOUYOFTZVWBVWNVUOUYMUYETZVWOVUOUYMFUYEVUMUYMFTAUYFUYLFUUFW
        QVUNUYFUUIWRVUOFWSZVWPVWOWGAVWQVUMUYFAVVDVWQMFUUJWFZWPUYMFUUKWFUULZAVWB
        VUMUYFPWPVWAVWNDUYOFVUDUYOSZVWAVVTRUYPUBZVWNVWTVVQUYPSVWAVXAWGVUDUYOHWT
        VVTRVVQUYPXAWFVWTVVTVWMSVXAVWNWGVUDUYOUAWTVVTVWMRUYPXBWFXCXEWOZVWMRUYPV
        OWFVUOUYLUARUDUCZTZUYLVWMTZVUMVXDAUYFUYLFXFWQUYLXGWFZXHUYNUYQUUMXIVUNUY
        FUURZUNZEUAQZXJQZVMZRUYSGAVXKRGWAZVUMVXGAVXKRGUBZVXLKVXKRGVOWFWPVXHUYSV
        XJUPUYSVXKTZVXHUYSIUEZVXJIUYLUUNVXHVXOUYEHQZUEZUTVAZUSZVXJVXHUYEUAQZVXS
        IUBZVXTVXSIWAVXOVXSUPVXHVXTVXSVXRVBZVXPVCZUBZVYAVXHVXQVXSVYBUBZVXTVXQVX
        PUBZVYDVXHVXSVXQUTUTVXRUUOZVXSVXQVXRXKVXQVXSVYBXKVYEVXHVXQUOTZVXQUTXLZV
        YGVXPUYEHWBUUPZVXHVXQRUPZRUTXLVYIVXHVXTRVXPUBZVXTRVXPWAVYKVXHUYEFTVWBVY
        LVXHUYEUYEUFZFVXHVVDUYERTZUYEVYMTAVVDVUMVXGMWPZFUUQZUYERUUSVKVUNUYFFVYM
        SZVUNVWQUYFVYQUVIAVWQVUMVWRXOFUUTWFUVAZXMZAVWBVUMVXGPWPVWAVYLDUYEFVUDUY
        ESZVWAVVTRVXPUBZVYLVYTVVQVXPSVWAWUAWGVUDUYEHWTVVTRVVQVXPXAWFVYTVVTVXTSW
        UAVYLWGVUDUYEUAWTVVTVXTRVXPXBWFXCXEWOZVXTRVXPVOVXTRVXPXNVKUVBVXQRUTUVCU
        VDZVXQUTVXRUOVXRUVEZUVFVGVXSVXQUTUTVXRUVGVXSVXQVXRUVHVXQVXSVYBXPXQVXHVY
        LVXTVXQVXPXKZVYFWUBVXTRVXPUVJZVXTVXQVXPXPVKVXTVXQVXSVYBVXPUVKXIIVYCSVYA
        VYDWGNVXTVXSIVYCXAVFWDZVXTVXSIVOVXTVXSIXNVKVXHVXJWSVXSVXJTZVXSVXJUPVXJV
        XIUVLUVMVXHVXSRTZVXSVXIXRXSZWUHVYHWUIVXHVYJVXQUTVXRUOWUDUVNUVOVXHVXSVXQ
        XTXSZVXQVXIXRXSZWUJVXHVYHVYIWUKVYJWUCVXQUTVXRUOWUDUVPVGVXHVXQVXTXTXSZVX
        TVXIXRXSZWULVXHVYLWUEVXTVXQXTXSWUMWUBWUFVXTVXQVXPUYEUAWBUVQVXTVXQUVRXQV
        XIUOTVXHVXTVXIUPZWUNEUAWBVXHERTZUYEETWUOAWUPVUMVXGJWPVXHFEUYEAFEUPVUMVX
        GOWPVYSYAUYEEUVSWOVXTVXIUOUWAUWBVXQVXTVXIYBXIVXSVXQVXIYBXIVXIVXSUVTUWCV
        XJVXSUWDVGUWEUWFUYSVXJVXIXJWBUWGWDZXHUWHYGAVUMVUDUYBTZUNZVUAVULSZUYLVUD
        SZWGZAWUSUNZUYFWVBWVCUYFUNZWUTUYRVUISZUYMVUESZUYQVUHSZUNZWVAUYFWUTWVEWG
        WVCUYFVUAUYRVULVUIUYFUYRUYTYCUYFVUIVUKYCYDYEWVDVUQUYKUWIUWJZVURUYQUYKTZ
        VUERTZVUHUYKTZWVEWVHWGAVUQWUSUYFVWKWPWVIWVDUYJUWLYFVURWVDVWLYFAVUMUYFWV
        JWURVUOUYIUYKUYQAUYIUYKUPZVUMUYFAVVAWVMVWJUYIUWKWFWPVUOUYPUEZUYIUYQVUOU
        YPUYGTZUYPUYHUPWVNUYIUPVUOVVEVWHVWOWVOVVEVUOVVJYFAVWHVUMUYFVWIWPVWSRFHU
        YOUWMUWNUYPUYGUWOUYPUYHWNVKVUOUYPVWMURZVXEUYQWVNTVUOVWNWVPVXBVWMRUYPUWP
        WFVXFVWMUYLUYPUXBXIYAYAZYHWVKWVDVUDXDYFAWURUYFWVLVUMVUOWVJYQAWURUNZUYFU
        NZWVLYQCDWVAVUOWVSWVJWVLWVAVUNWVRUYFWVAVUMWURAUYLVUDUYBUWQUWRZYIWVAUYQV
        UHUYKWVAUYLVUDUYPVUGWVAUYOVUFHWVAWVFUYOVUFSZUYLVUDUHWTZUYMVUEUWSZWFYJWV
        AUXKUWTZYKYRWVQYLYMUYKUYMUYQVUEVUHUXAUXCWVDWVHWVAWVDWVFWVGWVAWVDWVFUNZW
        VGWVAWWEUYQVUDUYPQZSZWVGWVAWWEWWFVUHUYQWWEVUDUYPVUGWWEUYOVUFHWVFWWAWVDW
        WCYEZYJUXDUXEWWEVWNVXEVUDVWMTWWGWVAWGWVDVWNWVFAVUMUYFVWNWURVXBYHXOWVDVX
        EWVFAVUMUYFVXEWURVXFYHXOWWEVUDVUFUAQZVWMWVCVUDWWITZUYFWVFWURWWJAVUMWURV
        UDVXCTWWJVUDFXFVUDXGWFUXFWPWWEUYOVUFUAWWHYJXMVWMRUYLVUDUYPYNYOUXGUXHUXI
        WVAWVFWVGWWBWWDUXLUXJYPWVCVXGUNZWUTUYTVUKSZUYSVUJSZWVAVXGWUTWWLWGWVCVXG
        VUAUYTVULVUKUYFUYRUYTYSUYFVUIVUKYSYDYEWWKVXMVXNVUJVXKTZWWLWWMWGAVXMWUSV
        XGKWPAVUMVXGVXNWURWUQYHAWURVXGWWNVUMVXHVXNYQWVRVXGUNZWWNYQCDWVAVXHWWOVX
        NWWNWVAVUNWVRVXGWVTYIWVAUYSVUJVXKUYLVUDIUYAYKYRWUQYLYMVXKRUYSVUJGYNYOWW
        KVYAUYLVXTUPVUDVXTUPWWMWVAWGAVUMVXGVYAWURWUGYHWWKUYLVXTWWKUYLUYBVXTVMZA
        VUMWURVXGUXMAVUMVXGUYBWWPSWURVXHUYBVYMUAQZWWPVXHFVYMUAVYRYJVXHVVDVYNWWQ
        WWPSVYOVYPUYEUXNVKUXOYHZWRYTWWKVUDVXTWWKVUDUYBWWPAVUMWURVXGUXPWWRWRYTVX
        TVXSUYLVUDIUXQYOYPUXRYGUXSAUYCVUBSUYDVUCWGABCEFGHIJKLMNUXTUYBRUYCVUBXAW
        FWM $.
    $}

    $( Lemma for ~ dfac12 .  (Contributed by Mario Carneiro, 29-May-2015.) $)
    dfac12lem3 $p |- ( ph -> ( R1 ` A ) e. dom card ) $=
      ( vn cr1 cfv wcel con0 wf1 wi wceq wb fveq2 syl ccrd cdm crn cvv wss fvex
      vm vz rnex wf ssid cv sseq1 f1eq1 f1eq2 bitrd imbi12d imbi2d wral r19.21v
      wa word eloni ad2antrl ordelss sylan simplrr sstrd pm5.5 ralbidva cep coi
      cuni ccnv ccom ad2antrr char cpw simplrl eqid simpr cbvralv dfac12lem2 ex
      sylib sylbid expr com23 expcom a2d syl5bi tfis3 mpcom mpi f1f frn onssnum
      3syl sylancr wf1o cen wbr f1f1orn f1oen ennum mpbird ) ADKLZUAUBZMZDFLZUC
      ZXHMZAXKUDMXKNUEZXLXJDFUFUIAXGNXJOZXGNXJUJXMADDUEZXNDUKDNMZAXOXNPZGAUGULZ
      DUEZXRKLZNXRFLZOZPZPZAJULZDUEZYEKLZNYEFLZOZPZPZAXQPUGJDXRYEQZYCYJAYLXSYFY
      BYIXRYEDUMYLYBXTNYHOZYIYLYAYHQYBYMRXRYEFSXTNYAYHUNTYLXTYGQYMYIRXRYEKSXTYG
      NYHUOTUPUQURXRDQZYCXQAYNXSXOYBXNXRDDUMYNYBXTNXJOZXNYNYAXJQYBYORXRDFSXTNYA
      XJUNTYNXTXGQYOXNRXRDKSXTXGNXJUOTUPUQURYKJXRUSAYJJXRUSZPXRNMZYDAYJJXRUTYQA
      YPYCAYQYPYCPAYQVAXSYPYBAYQXSYPYBPAYQXSVAZVAZYPYIJXRUSZYBYSYJYIJXRYSYEXRMZ
      VAZYFYJYIRUUBYEXRDYSXRVBZUUAYEXRUEYQUUCAXSXRVCVDXRYEVEVFAYQXSUUAVGVHYFYIV
      ITVJYSYTYBYSYTVAZBCUHDXREFXRVMFLZUCVKVLVNUUEVOZAXPYRYTGVPAXGVQLVRNEOYRYTH
      VPIAYQXSYTVSUUFVTAYQXSYTVGUUDYTUHULZKLZNUUGFLZOZUHXRUSYSYTWAYIUUJJUHXRYEU
      UGQZYIYGNUUIOZUUJUUKYHUUIQYIUULRYEUUGFSYGNYHUUIUNTUUKYGUUHQUULUUJRYEUUGKS
      YGUUHNUUIUOTUPWBWEWCWDWFWGWHWIWJWKWLWMWNZXGNXJWOXGNXJWPWRXKUDWQWSAXGXKXJW
      TZXGXKXAXBXIXLRAXNUUNUUMXGNXJXCTXGXKXJDKUFXDXGXKXEWRXF $.
  $}

  ${
    $d a b f x y z $.
    $( The axiom of choice holds iff every ordinal has a well-orderable
       powerset.  This version of ~ dfac12 does not assume the Axiom of
       Regularity.  (Contributed by Mario Carneiro, 29-May-2015.) $)
    dfac12r $p |- ( A. x e. On ~P x e. dom card <->
        U. ( R1 " On ) C_ dom card ) $=
      ( vy vz vf va vb cv wcel con0 cr1 cima cuni csuc cfv wceq crn comu co coa
      cmpt cpw ccrd cdm wral wss wrex rankwflemb wa char cen wbr wi pweq eleq1d
      harcl rspcv ax-mp cardid2 ensym wf1o wex bren cvv crnk cep coi ccnv crecs
      ccom cif simpr wf1 f1of1 adantr cardon onssi f1ss sylancl fveq2 suceq syl
      oveq2d fveq2d id fveq12d oveq12d imaeq2 ifeq12d cbvmptv dmeq eqeq12d rneq
      unieqd rneqd oveq1d fveq1 fveq1d oieq2 cnveqd coeq12d ifbieq12d mpteq12dv
      imaeq1d syl5eq recseq dfac12lem3 ex exlimiv sylbi imp r1suc adantl eleq2d
      4syl elpwi syl6bi ssnum ee12an rexlimdva ssrdv onwf sseli pwwf sylib ssel
      syl5bi syl5 ralrimiv impbii ) AGZUAZUBUCZHZAIUDZJIKLZYLUEZYNBYOYLBGZYOHYQ
      CGZMJNZHZCIUFYNYQYLHZCYQUGYNYTUUACIYNYRIHZUHZYRJNZYLHZYTYQUUDUEZUUAYNUUBU
      UEYNUUDUINZUAZYLHZUUHUBNZUUHUJUKUUHUUJUJUKZUUBUUEULZUUGIHYNUUIULUUDUOYMUU
      IAUUGIYJUUGOYKUUHYLYJUUGUMUNUPUQUUHURUUJUUHUSUUKUUHUUJDGZUTZDVAUULUUHUUJD
      VBUUNUULDUUNUUBUUEUUNUUBUHZEFYRUUMAVCBYJUCZJNZUUPUUPLZOZYJPZLZPZLZMZYQVDN
      ZQRZYQUVEMZYJNZNZSRZUURYJNZPZVEVFZVGZUVKVIZYQKZUUMNZVJZTZTZVHZUUNUUBVKUUO
      UUHUUJUUMVLZUUJIUEUUHIUUMVLUUNUWBUUBUUHUUJUUMVMVNUUJUUHVOVPUUHUUJIUUMVQVR
      UVTEVCFEGZUCZJNZUWDUWDLZOZUWCPZLZPZLZMZFGZVDNZQRZUWMUWNMZUWCNZNZSRZUWFUWC
      NZPZVEVFZVGZUWTVIZUWMKZUUMNZVJZTZTZOUWAUXIVHOAEVCUVSUXHYJUWCOZUVSFUUQUUSU
      VDUWNQRZUWMUWPYJNZNZSRZUVOUWMKZUUMNZVJZTUXHBFUUQUVRUXQYQUWMOZUUSUVJUXNUVQ
      UXPUXRUVFUXKUVIUXMSUXRUVEUWNUVDQYQUWMVDVSZWBUXRYQUWMUVHUXLUXRUVGUWPYJUXRU
      VEUWNOUVGUWPOUXSUVEUWNVTWAWCUXRWDWEWFUXRUVPUXOUUMYQUWMUVOWGWCWHWIUXJFUUQU
      XQUWEUXGUXJUUPUWDJYJUWCWJZWCUXJUUSUWGUXNUXPUWSUXFUXJUUPUWDUURUWFUXTUXJUUP
      UWDUXTWMZWKUXJUXKUWOUXMUWRSUXJUVDUWLUWNQUXJUVCUWKOUVDUWLOUXJUVBUWJUXJUVAU
      WIUXJUUTUWHYJUWCWLWMWNWMUVCUWKVTWAWOUXJUWMUXLUWQUWPYJUWCWPWQWFUXJUXOUXEUU
      MUXJUVOUXDUWMUXJUVNUXCUVKUWTUXJUVMUXBUXJUVLUXAOUVMUXBOUXJUVKUWTUXJUURUWFY
      JUWCUXJWDUYAWEZWNUVLUXAVEWRWAWSUYBWTXCWCXAXBXDWIUVTUXIXEUQXFXGXHXIXNXJUUC
      YTYQUUDUAZHUUFUUCYSUYCYQUUBYSUYCOYNYRXKXLXMYQUUDXOXPUUDYQXQXRXSYFXTYPYMAI
      YJIHZYKYOHZYPYMUYDYJYOHUYEIYOYJYAYBYJYCYDYOYLYKYEYGYHYI $.

    $( Equivalence of ~ dfac12 and ~ dfac12a , without using Regularity.
       (Contributed by Mario Carneiro, 21-May-2015.) $)
    dfac12k $p |- ( A. x e. On ~P x e. dom card <->
      A. y e. On ~P ( aleph ` y ) e. dom card ) $=
      ( cv cpw ccrd wcel con0 wral cfv wceq pweq eleq1d com wb wrex syl cfn cen
      wa wbr cdm cale wi alephon rspcv ax-mp ralrimivw wss omelon cardon ontri1
      wn mp2an cardidm cardalephex mpbii r19.29 biimparc rexlimivw syl5 syl5bir
      ex nnfi pwfi sylib finnum pm2.61d2 oncardid pwen ennum syl5ibcom ralrimiv
      3syl impbii ) ACZDZEUAZFZAGHZBCZUBIZDZVQFZBGHZVSWCBGWAGFVSWCUCVTUDVRWCAWA
      GVOWAJVPWBVQVOWAKLUEUFUGWDVRAGWDVOEIZDZVQFZVOGFZVRWDWEMFZWGWIULZMWEUHZWDW
      GMGFWEGFWKWJNUIVOUJMWEUKUMWKWEWAJZBGOZWDWGWKWEEIWEJWMVOUNBWEUOUPWDWMWGWDW
      MSWCWLSZBGOWGWCWLBGUQWNWGBGWLWGWCWLWFWBVQWEWAKLURUSPVBUTVAWIWFQFZWGWIWEQF
      WOWEVCWEVDVEWFVFPVGWHWEVORTWFVPRTWGVRNVOVHWEVOVIWFVPVJVMVKVLVN $.

    $( The axiom of choice holds iff every ordinal has a well-orderable
       powerset.  (Contributed by Mario Carneiro, 29-May-2015.) $)
    dfac12a $p |- ( CHOICE <-> A. x e. On ~P x e. dom card ) $=
      ( wac cr1 con0 cima cuni ccrd cdm wss cpw wcel wral cvv wceq eqss mpbiran
      cv ssv dfac10 unir1 sseq1i 3bitr4i dfac12r bitr4i ) BCDEFZGHZIZAQJUFKADLU
      FMNZMUFIZBUGUHUFMIUIUFRUFMOPSUEMUFTUAUBAUCUD $.

    $( The axiom of choice holds iff every aleph has a well-orderable
       powerset.  (Contributed by Mario Carneiro, 21-May-2015.) $)
    dfac12 $p |- ( CHOICE <-> A. x e. On ~P ( aleph ` x ) e. dom card ) $=
      ( vy wac cv cpw ccrd cdm wcel con0 wral cale cfv dfac12a dfac12k bitri )
      CBDEFGZHBIJADKLEPHAIJBMBANO $.
  $}

  ${
    $d v A $.  $d u v x y ph $.  $d ps x v $.  $d u v w x y z $.
    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, 1 => 2.  (Contributed by
       NM, 5-Apr-2004.) $)
    kmlem1 $p |- ( A. x ( ( A. z e. x z =/= (/) /\ A. z e. x A. w e. x ph ) ->
                 E. y A. z e. x ps ) -> A. x ( A. z e. x A. w e. x ph ->
                   E. y A. z e. x ( z =/= (/) -> ps ) ) ) $=
      ( vv vu cv c0 wne wral wa wex wi wal wceq raleq wcel ralimi2 crab anbi12d
      rabex raleqbi1dv exbidv imbi12d alrimiv elrabi imim1i imim12i neeq1 elrab
      vex spcv simprbi rgen jctil biimpri exp3a eximi alimi syl cbvalv sylib )
      EIZJKZECIZLZAFVGLZEVGLZMZBEVGLZDNZOZCPZAFGIZLZEVPLZVFBOZEVPLZDNZOZGPZVJVS
      EVGLZDNZOZCPVOVFEHIZJKZHVPUAZLZAFWILZEWILZMZBEWILZDNZOZGPWCVOWPGVNWPCWIWH
      HVPGUMUCVGWIQZVKWMVMWOWQVHWJVJWLVFEVGWIRVIWKEVGWIAFVGWIRUDUBWQVLWNDBEVGWI
      RUEUFUNUGWPWBGVRWMWOWAVRWLWJVQWKEVPWIVEWISZVEVPSZVQWKWHHVEVPUHAAFVPWIFIZW
      ISWTVPSAWHHWTVPUHUITUJTVFEWIWRWSVFWHVFHVEVPWGVEJUKULZUOUPUQWNVTDBVSEWIVPW
      RBOWSVFBWSVFMZWRBWRXBXAURUIUSTUTUJVAVBWBWFGCVPVGQZVRVJWAWEVQVIEVPVGAFVPVG
      RUDXCVTWDDVSEVPVGRUEUFVCVD $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 25-Mar-2004.) $)
    kmlem2 $p |- ( E. y A. z e. x ( ph -> E! w w e. ( z i^i y ) ) <->
        E. y ( -. y e. x /\ A. z e. x ( ph -> E! w w e. ( z i^i y ) ) ) ) $=
      ( vv vu cv cin wcel weu wi wral wex wn wa wceq eleq2d eubidv imbi2d ineq2
      ralbidv cbvexv vex uniex eleq2 notbid exbidv wal nalset alexn mpbir vtocl
      cuni spi csn cun indi elssuni ssneld disjsn syl6ibr impcom uneq2d syl5req
      c0 un0 syl6eq ralbidva wo snid olci elun sseld con3i biantrurd bitrd snex
      mpi unex eleq1 anbi12d spcev syl6bi exlimiv ax-mp sylbi exsimpr impbii )
      AEHZDHZCHZIZJZEKZLZDBHZMZCNZWLWQJZOZWRPZCNZWSAWJWKFHZIZJZEKZLZDWQMZFNXCWR
      XICFWLXDQZWPXHDWQXJWOXGAXJWNXFEXJWMXEWJWLXDWKUARSTUBUCXIXCFGHZWQUNZJZOZGN
      ZXIXCLZXKWLJZOZGNZXOCXLWQBUDUEWLXLQZXRXNGXTXQXMWLXLXKUFUGUHXSCXSCUIXQGUIC
      NOCGUJXQCGUKULUOUMXNXPGXNXIXDXKUPZUQZWQJZOZAWJWKYBIZJZEKZLZDWQMZPZXCXNXIY
      IYJXNXHYHDWQXNWKWQJZPZXGYGAYLXFYFEYLXEYEWJYLYEXEWKYAIZUQZXEWKXDYAURYLYNXE
      VFUQXEYLYMVFXEYKXNYMVFQZYKXNXKWKJOYOYKWKXLXKWKWQUSUTWKXKVAVBVCVDXEVGVHVER
      STVIXNYDYIYCXMYCXKYBJZXMYPXKXDJZXKYAJZVJYRYQXKGUDVKVLXKXDYAVMULYCYBXLXKYB
      WQUSVNVSVOVPVQXBYJCYBXDYAFUDXKVRVTWLYBQZXAYDWRYIYSWTYCWLYBWQWAUGYSWPYHDWQ
      YSWOYGAYSWNYFEYSWMYEWJWLYBWKUARSTUBWBWCWDWEWFWEWGXAWRCWHWI $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.  The
       right-hand side is part of the hypothesis of 4.  (Contributed by NM,
       25-Mar-2004.) $)
    kmlem3 $p |- ( ( z \ U. ( x \ { z } ) ) =/= (/) <->
        E. v e. z A. w e. x ( z =/= w -> -. v e. ( z i^i w ) ) ) $=
      ( cv cdif c0 wne wcel wn crab wrex wel cun wex anbi2i bitr3i bitri 3bitri
      wa csn cuni cin wi wral wo dfdif2 dfnul3 uneq2i unrab 3eqtr3i ianor eluni
      un0 anbi1i df-rex elin df-an eldifsn necom ancom anbi2ci anass an32 exbii
      wb 19.41v rexnal 3bitr2ri con1bii a1i rabbiia 3eqtri neeq1i rabn0 ) BEZAE
      ZVPUAFZUBZFZGHVPCEZHZDEZVPWAUCIZJUDZCVQUEZDVPKZGHWFDVPLVTWGGVTWCVSIZJZDVP
      KZWIDBMZJZUFZDVPKZWGDVPVSUGWJGNWJWLDVPKZNWJWNGWOWJDVPUHUIWJUNWIWLDVPUJUKW
      MWFDVPWMWFVFWKWMWHWKTZJWFWHWKULWFWPWPDCMZWAVRIZTZCOZWKTZWEJZCVQLZWFJWHWTW
      KCWCVRUMUOXCCAMZXBTZCOWSWKTZCOXAXBCVQUPXEXFCXEXDWBWKWQTZTZTZXFXHXBXDXHWBW
      DTXBWDXGWBWCVPWAUQPWBWDURQPXIWQWKTZWRTZXFXKXJXDWBTZTXLXGTXIWRXLXJWRXDWAVP
      HZTXLWAVQVPUSXMWBXDWAVPUTPRPXJXGXLWQWKVAVBXDWBXGVCSWQWKWRVDQQVEWSWKCVGSWE
      CVQVHVIVJQVKVLVMVNWFDVPVOR $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 26-Mar-2004.) $)
    kmlem4 $p |- ( ( w e. x /\ z =/= w ) ->
                    ( ( z \ U. ( x \ { z } ) ) i^i w ) = (/) ) $=
      ( vy vv wel cv wne wa wn csn cdif cuni wral cin c0 wceq wcel wi wal eldif
      simpr wex eluni notbii alnex con2b imnan eldifsn necom anbi2i bitri albii
      imbi1i 3bitr3i 3bitr2i sylib sylbi eleq1 neeq2 anbi12d notbid imbi12d spv
      eleq2 com12 syl5 ralrimiv disj sylibr ) CAFZBGZCGZHZIZDCFZJZDVLAGZVLKLZMZ
      LZNWAVMOPQVOVQDWADGZWARZEAFZVLEGZHZIZDEFZJZSZETZVOVQWCDBFZWBVTRZJZIZWKWBV
      LVTUAWOWNWKWLWNUBWNWHWEVSRZIZEUCZJWQJZETWKWMWREWBVSUDUEWQEUFWSWJEWHWPJSWP
      WISWSWJWHWPUGWHWPUHWPWGWIWPWDWEVLHZIWGWEVRVLUIWTWFWDWEVLUJUKULUNUOUMUPUQU
      RWKVOVQWJVOVQSECWEVMQZWGVOWIVQXAWDVKWFVNWEVMVRUSWEVMVLUTVAXAWHVPWEVMWBVEV
      BVCVDVFVGVHDWAVMVIVJ $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 25-Mar-2004.) $)
    kmlem5 $p |- ( ( w e. x /\ z =/= w ) ->
          ( ( z \ U. ( x \ { z } ) ) i^i ( w \ U. ( x \ { w } ) ) ) = (/) ) $=
      ( wel cv wne wa csn cdif cuni cin c0 wss wceq difss sslin kmlem4 syl5sseq
      ax-mp ss0b sylib ) CADBEZCEZFGZUBAEZUBHIJIZUCUEUCHIJZIZKZLMUILNUDUFUCKZUI
      LUHUCMUIUJMUCUGOUHUCUFPSABCQRUITUA $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 4 => 1.
       (Contributed by NM, 26-Mar-2004.) $)
    kmlem6 $p |- ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( ph -> A = (/) ) ) ->
           A. z e. x E. v e. z A. w e. x ( ph -> -. v e. A ) ) $=
      ( cv c0 wne wral wceq wi wa wcel wn wrex r19.26 wex wal ralimi n0 alrimiv
      biimpi ne0i necon2bi imim2i 19.29r df-rex sylibr syl2an sylbir ) CGZHIZCB
      GZJAFHKZLZDUNJZCUNJMUMUQMZCUNJAEGZFNZOZLZDUNJZEULPZCUNJUMUQCUNQURVDCUNUMU
      SULNZERZVCESZVDUQUMVFEULUAUCUQVCEUPVBDUNUOVAAUTFHFUSUDUEUFTUBVFVGMVEVCMER
      VDVEVCEUGVCEULUHUIUJTUK $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 4 => 1.
       (Contributed by NM, 26-Mar-2004.) $)
    kmlem7 $p |- ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
       -. E. z e. x A. v e. z E. w e. x ( z =/= w /\ v e. ( z i^i w ) ) ) $=
      ( cv c0 wne wral cin wceq wi wa wcel wn wrex kmlem6 ralinexa rexbii bitri
      rexnal ralbii ralnex sylib ) BEZFGBAEZHUDCEZGZUDUFIZFJKCUEHBUEHLUGDEUHMZN
      KCUEHZDUDOZBUEHZUGUILCUEOZDUDHZBUEONZUGABCDUHPULUNNZBUEHUOUKUPBUEUKUMNZDU
      DOUPUJUQDUDUGUICUEQRUMDUDTSUAUNBUEUBSUC $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4 1 <=> 4.  (Contributed by
       NM, 4-Apr-2004.) $)
    kmlem8 $p |- ( ( -. E. z e. u A. w e. z ps -> E. y A. z e. u ( z =/= (/)
                  -> E! w w e. ( z i^i y ) ) ) <-> ( E. z e. u A. w e. z ps \/
                 E. y ( -. y e. u /\ A. z e. u E! w w e. ( z i^i y ) ) ) ) $=
      ( cv wral wrex wn c0 wne cin wi wex wel wa wb sylbir ralimi syl wo ralnex
      wcel weu df-rex rexnal bitr3i exsimpl n0 sylibr biimt ralbi anbi2d exbidv
      kmlem2 syl6rbbr pm5.74i pm4.64 bitri ) ADCFZGZCEFZHZIZUTJKZDFUTBFLUCDUDZM
      ZCVBGZBNZMVDBEOIZVFCVBGZPZBNZMVCVMUAVDVIVMVDVECVBGZVIVMQVDVAIZCVBGVNVACVB
      UBVOVECVBVODCOZAIZPDNZVEVRVQDUTHVOVQDUTUEADUTUFUGVRVPDNVEVPVQDUHDUTUIUJRS
      RVNVMVJVHPZBNVIVNVLVSBVNVKVHVJVNVFVGQZCVBGVKVHQVEVTCVBVEVFUKSVFVGCVBULTUM
      UNVEEBCDUOUPTUQVCVMURUS $.
  $}

  ${
    $d x y z w v u t h g $.  $d y z w v h g A $.  $d h ph $.
    kmlem9.1 $e |- A = { u | E. t e. x u = ( t \ U. ( x \ { t } ) ) } $.
    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 25-Mar-2004.) $)
    kmlem9 $p |- A. z e. A A. w e. A ( z =/= w -> ( z i^i w ) = (/) ) $=
      ( vh cv wne cin c0 wceq wi wcel csn cdif wrex weq wa cuni vex eqeq1 elab2
      rexbidv difeq1 difeq2d unieqd eqtrd eqeq2d cbvrexv reeanv syl5ibr necon3d
      sneq bitri eqeq12 kmlem5 ineq12 eqeq1d exp3a syl5d com12 adantl rexlimivv
      sylbir syl2anb rgen2a ) BIZCIZJZVIVJKZLMZNZBCFVIFOVIEIZAIZVOPZQZUAZQZMZEV
      PRZVJHIZVPWCPZQZUAZQZMZHVPRZVNVJFOZDIZVTMZEVPRZWBDVIFBUBDBSWLWAEVPWKVIVTU
      CUEGUDWJVJVTMZEVPRZWIWMWODVJFCUBDCSWLWNEVPWKVJVTUCUEGUDWNWHEHVPEHSZVTWGVJ
      WPVTWCVSQWGVOWCVSUFWPVSWFWCWPVRWEWPVQWDVPVOWCUOUGUHUGUIZUJUKUPWBWITWAWHTZ
      HVPREVPRVNWAWHEHVPVPULWRVNEHVPVPWCVPOZWRVNNVOVPOWRWSVNWRVKVOWCJZWSVMWRVOW
      CVIVJWPBCSWRVTWGMWQVIVTVJWGUQUMUNWRWSWTVMWSWTTVMWRVTWGKZLMAEHURWRVLXALVIV
      TVJWGUSUTUMVAVBVCVDVEVFVGVH $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 25-Mar-2004.) $)
    kmlem10 $p |- ( A. h ( A. z e. h A. w e. h
                              ( z =/= w -> ( z i^i w ) = (/) ) ->
                         E. y A. z e. h ph ) -> E. y A. z e. A ph ) $=
      ( cv wne cin c0 wceq wi wral wex cdif raleq wal csn cuni wrex cab cvv vex
      kmlem9 abrexex eqeltri raleqbi1dv exbidv imbi12d spcv mpi ) DKZEKZLUPUQMN
      OPZEIKZQZDUSQZADUSQZCRZPZIUAUREHQZDHQZADHQZCRZBDEFGHJUHVDVFVHPIHHFKGKZBKZ
      VIUBSUCSZOGVJUDFUEUFJGFVJVKBUGUIUJUSHOZVAVFVCVHUTVEDUSHUREUSHTUKVLVBVGCAD
      USHTULUMUNUO $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 26-Mar-2004.) $)
    kmlem11 $p |- ( z e. x -> ( z i^i U. A ) = ( z \ U. ( x \ { z } ) ) ) $=
      ( cv wcel cuni cin csn cdif ciun wceq cvv vex eqtr4i c0 cun syl5eq unieqi
      wrex cab difexg ax-mp dfiun2 ineq2i iunin2 undif2 wss snssi ssequn1 sylib
      syl5req iuneq1d iunxun difeq1 sneq unieqd eqtrd ineq2d iunxsn uneq1i wral
      difeq2d eqtri wne eldifsni wa incom kmlem4 ex syl5 ralrimiv iuneq2 syl6eq
      syl iun0 uneq2d un0 indif ) BGZAGZHZWBEIZJZDWCWBDGZWCWGKZLZIZLZJZMZWBWCWB
      KZLZIZLZWFWBDWCWKMZJWMWEWRWBWECGWKNDWCUBCUCZIWREWSFUADCWCWKWGOHWKOHDPWGWJ
      OUDUEUFQUGDWCWBWKUHQWDWMWBWQJZRSZWQWDWMDWNWOSZWLMZXAWDDWCXBWLWDXBWNWCSZWC
      WNWCUIWDWNWCUJXDWCNWBWCUKWNWCULUMUNUOWDXCWTDWOWLMZSZXAXCDWNWLMZXESXFDWNWO
      WLUPXGWTXEDWBWLWTBPWGWBNZWKWQWBXHWKWBWJLWQWGWBWJUQXHWJWPWBXHWIWOXHWHWNWCW
      GWBURVEUSVEUTVAVBVCVFWDXERWTWDXEDWORMZRWDWLRNZDWOVDXEXINWDXJDWOWGWOHWGWBV
      GZWDXJWGWCWBVHWDXKXJWDXKVIWLWKWBJRWBWKVJADBVKTVLVMVNDWOWLRVOVQDWOVRVPVSTU
      TXAWTWQWTVTWBWPWAVFVPT $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 3 => 4.
       (Contributed by NM, 27-Mar-2004.) $)
    kmlem12 $p |- ( A. z e. x ( z \ U. ( x \ { z } ) ) =/= (/) ->
                    ( A. z e. A ( z =/= (/) -> E! v v e. ( z i^i y ) ) ->
        A. z e. x ( z =/= (/) -> E! v v e. ( z i^i ( y i^i U. A ) ) ) ) ) $=
      ( cv c0 wne cin wcel weu wi wral cdif cuni wceq wal csn cab raleqi df-ral
      wrex vex eqeq1 rexbidv elab imbi1i r19.23v bitr4i albii ralcom4 cvv ax-mp
      difexg neeq1 ineq1 eleq2d eubidv imbi12d ralbii 3bitri ralim sylbi difeq1
      ceqsalv 3bitr2i sneq difeq2d unieqd eqtrd neeq1d cbvralv in12 incom eqtri
      ineq1d imbi12i kmlem11 syl5req ax-1 syl6bi ralimia imim2i com12 syl5 ) CI
      ZJKZDIZWIBIZLZMZDNZOZCGPZFIZAIZWRUAZQZRZQZJKZFWSPZWKXCWLLZMZDNZFWSPZOZWIW
      SWIUAZQZRZQZJKZCWSPZWJWKWIWLGRZLLZMZDNZOZCWSPZWQXDXHOZFWSPZXJWQWPCEIZXCSZ
      FWSUEZEUBZPWIYHMZWPOZCTZYDWPCGYHHUCWPCYHUDYKWIXCSZWPOZFWSPZCTYMCTZFWSPYDY
      JYNCYJYLFWSUEZWPOYNYIYPWPYGYPEWICUFYEWISYFYLFWSYEWIXCUGUHUIUJYLWPFWSUKULU
      MYMFCWSUNYOYCFWSWPYCCXCWRUOMXCUOMFUFWRXBUOUQUPYLWJXDWOXHWIXCJURYLWNXGDYLW
      MXFWKWIXCWLUSUTVAVBVHVCVIVDXDXHFWSVEVFXJXPYBXJXPWKXNWLLZMZDNZCWSPZOXPYBOX
      EXPXIYTXDXOFCWSWRWISZXCXNJUUAXCWIXBQXNWRWIXBVGUUAXBXMWIUUAXAXLUUAWTXKWSWR
      WIVJVKVLVKVMZVNVOXHYSFCWSUUAXGYRDUUAXFYQWKUUAXCXNWLUUBVSUTVAVOVTYTYBXPYSY
      ACWSWIWSMZYSXTYAUUCYRXSDUUCYQXRWKUUCXRWIXQLZWLLZYQXRWLUUDLUUEWIWLXQVPWLUU
      DVQVRUUCUUDXNWLACEFGHWAVSWBUTVAXTWJWCWDWEWFVFWGWH $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4 1 <=> 4.  (Contributed by
       NM, 5-Apr-2004.) $)
    kmlem13 $p |- ( A. x ( ( A. z e. x z =/= (/) /\
           A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
         E. y A. z e. x E! v v e. ( z i^i y ) ) <->
          A. x ( -. E. z e. x A. v e. z E. w e. x
                     ( z =/= w /\ v e. ( z i^i w ) ) ->
               E. y A. z e. x ( z =/= (/) ->
                    E! v v e. ( z i^i y ) ) ) ) $=
      ( vh vg cv wral cin wceq wi wcel wex wal wrex c0 wne wa weu wn raleqbi1dv
      kmlem1 raleq exbidv imbi12d cbvalv kmlem10 ineq2 eleq2d eubidv imbi2d csn
      cbvexv cdif cuni kmlem3 ralinexa rexbii rexnal 3bitri ralbii ralnex bitri
      ralbidv kmlem12 vex inex1 spcev syl6 exlimdv com12 syl5bir alrimiv kmlem7
      sylbi syl imim1i wb biimt ralimi ralbi adantr pm5.74i sylibr alimi impbii
      ) CLZUAUBZCALZMZWLDLZUBZWLWPNZUAOPZDWNMZCWNMZUCZELZWLBLZNZQZEUDZCWNMZBRZP
      ZASZWQXCWRQZUCDWNTZEWLMZCWNTUEZWMXGPZCWNMZBRZPZASZXKXAXRPZASZXTWSXGABCDUG
      YBWSDJLZMZCYCMZXPCYCMZBRZPZJSZXTYAYHAJWNYCOZXAYEXRYGWTYDCWNYCWSDWNYCUHUFY
      JXQYFBXPCWNYCUHUIUJUKYIXSAYIXPCHMZBRZXSXPABCDFGHJIULYLWMXCWLKLZNZQZEUDZPZ
      CHMZKRZXSYKYRBKXDYMOZXPYQCHYTXGYPWMYTXFYOEYTXEYNXCXDYMWLUMUNUOUPVIURXOWLW
      NWLUQUSUTUSUAUBZCWNMZYSXRUUBXNUEZCWNMXOUUAUUCCWNUUAWQXLUEPDWNMZEWLTXMUEZE
      WLTUUCACDEVAUUDUUEEWLWQXLDWNVBVCXMEWLVDVEVFXNCWNVGVHUUBYSXRUUBYRXRKUUBYRW
      MXCWLYMHUTZNZNZQZEUDZPZCWNMZXRAKCEFGHIVJXQUULBUUGYMUUFKVKVLXDUUGOZXPUUKCW
      NUUMXGUUJWMUUMXFUUIEUUMXEUUHXCXDUUGWLUMUNUOUPVIVMVNVOVPVQVTWAVRVTWAXSXJAX
      SXBXRPXJXBXOXRACDEVSWBXBXIXRWOXIXRWCXAWOXHXQBWOXGXPWCZCWNMXHXQWCWMUUNCWNW
      MXGWDWEXGXPCWNWFWAUIWGWHWIWJWK $.
  $}

  ${
    $d x y z w v u $.  $d u ph $.
    kmlem14.1 $e |- ( ph <->
                ( z e. y -> ( ( v e. x /\ y =/= v ) /\ z e. v ) ) ) $.
    kmlem14.2 $e |- ( ps <-> ( z e. x -> ( ( v e. z /\ v e. y ) /\
                ( ( u e. z /\ u e. y ) -> u = v ) ) ) ) $.
    kmlem14.3 $e |- ( ch <->
                A. z e. x E! v v e. ( z i^i y ) ) $.
    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 5 <=> 4.
       (Contributed by NM, 4-Apr-2004.) $)
    kmlem14 $p |- ( E. z e. x A. v e. z E. w e. x
                   ( z =/= w /\ v e. ( z i^i w ) ) <->
                 E. y A. z E. v A. u ( y e. x /\ ph ) ) $=
      ( cv wcel wa wrex wel wex wal wi wne cin wral neeq1 ineq1 anbi12d rexbidv
      eleq2d raleqbi1dv cbvrexv df-rex eleq1 anbi2d cbvralv df-ral bitri anbi2i
      weq 19.28v neeq2 ineq2 imbi2i 19.37v bitr4i 19.42v 19.3v elin baibr anass
      syl6bb pm5.74i bitr2i exbii 3bitr2i albii 3bitri ) FMZGMZUAZHMZVQVRUBZNZO
      ZGDMZPZHVQUCZFWDPEMZVRUAZVTWGVRUBZNZOZGWDPZHWGUCZEWDPEDQZWMOZERWNAOZISZHR
      ZFSZERWFWMFEWDWEWLHVQWGFEURZWCWKGWDWTVSWHWBWJVQWGVRUDWTWAWIVTVQWGVRUEUHUF
      UGUIUJWMEWDUKWOWSEWOWNFEQZWHVQWINZOZGWDPZTZFSZOWNXEOZFSWSWMXFWNWMXDFWGUCX
      FWLXDHFWGHFURZWKXCGWDXHWJXBWHVTVQWIULUMUGUNXDFWGUOUPUQWNXEFUSXGWRFXGWNXAH
      DQZWGVTUAZVQWGVTUBZNZOZOZTZHRZOWNXOOZHRWRXEXPWNXEXAXNHRZTXPXDXRXAXDXMHWDP
      XRXCXMGHWDGHURZWHXJXBXLVRVTWGUTXSWIXKVQVRVTWGVAUHUFUJXMHWDUKUPVBXAXNHVCVD
      UQWNXOHVEXQWQHWQWPXQWPIVFAXOWNAXAXIXJOZFHQZOZTXOJXAYBXNXAYBXTXLOXNXAYAXLX
      TXLXAYAVQWGVTVGVHUMXIXJXLVIVJVKUPUQVLVMVNVOVNVMVP $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4, part of 5 <=> 4.
       (Contributed by NM, 4-Apr-2004.) $)
    kmlem15 $p |- ( ( -. y e. x /\ ch ) <->
                     A. z E. v A. u ( -. y e. x /\ ps ) ) $=
      ( wel wa wal wex cv wi bitri albii 19.28v wn cin wcel weu weq wsb nfv eu1
      wral elin clelsb3 equcom imbi12i bitr4i exbii ralbii df-ral 19.21v 19.37v
      anbi12i 3bitri anbi2i 19.42v bitr2i 3bitr2i ) EDLUAZCMVFBHNZGOZFNZMVFVHMZ
      FNVFBMHNZGOZFNCVIVFCGPZFPZEPZUBZUCZGUDZFDPZUIGFLGELMZHFLHELMZHGUEZQZMZHNZ
      GOZFVSUIZVIKVRWFFVSVRVQVQGHUFZGHUEZQZHNZMZGOWFVQGHVQHUGUHWLWEGWLVTWCHNZMW
      EVQVTWKWMVMVNVOUJWJWCHWHWAWIWBWHHPZVPUCWAHGVPUKWNVNVOUJRGHULUMSUTVTWCHTUN
      UORUPWGFDLZWFQZFNVIWFFVSUQVHWPFVHWOWEQZGOWPVGWQGVGWOWDQZHNWQBWRHJSWOWDHUR
      RUOWOWEGUSRSUNVAVBVFVHFTVJVLFVLVFVGMZGOVJVKWSGVFBHTUOVFVGGVCVDSVE $.

    $( Lemma for 5-quantifier AC of Kurt Maes, Th. 4 5 <=> 4.  (Contributed by
       NM, 4-Apr-2004.) $)
    kmlem16 $p |- ( ( E. z e. x A. v e. z E. w e. x
       ( z =/= w /\ v e. ( z i^i w ) ) \/ E. y ( -. y e. x /\ ch ) ) <->
       E. y A. z E. v A. u ( ( y e. x /\ ph ) \/ ( -. y e. x /\ ps ) ) ) $=
      ( cv wcel wa wn wex wo wal exbii wne wrex wral kmlem14 kmlem15 orbi12i wb
      cin 19.43 pm3.24 simpl sps exlimivv anim12i mto 19.33b ax-mp bitr2i albii
      exlimiv bitr3i 3bitr2i ) FMZGMZUAHMVCVDUHNOGDMZUBHVCUCFVEUBZEMVENZPZCOZEQ
      ZRVGAOZISZHQZFSZEQZVHBOZISZHQZFSZEQZRVNVSRZEQVKVPRISZHQZFSZEQVFVOVJVTABCD
      EFGHIJKLUDVIVSEABCDEFHIJKLUETUFVNVSEUIWAWDEWAVMVRRZFSZWDVMFQZVRFQZOZPWFWA
      UGWIVGVHOZVGUJZWGVGWHVHVLVGFHVKVGIVGAUKZULUMVQVHFHVPVHIVHBUKZULUMUNUOVMVR
      FUPUQWEWCFWCVLVQRZHQWEWBWNHVKIQZVPIQZOZPWBWNUGWQWJWKWOVGWPVHVKVGIWLUTVPVH
      IWMUTUNUOVKVPIUPUQTVLVQHUIURUSVATVB $.
  $}

  ${
    $d x y z w v u f t h $.
    $( Equivalence of the Axiom of Choice and Maes' AC ~ ackm .  The proof
       consists of lemmas ~ kmlem1 through ~ kmlem16 and this final theorem.
       AC is not used for the proof.  Note: bypassing the first step (i.e.
       replacing ~ dfac5 with ~ biid ) establishes the AC equivalence shown by
       Maes' writeup.  The left-hand-side AC shown here was chosen because it
       is shorter to display.  (Contributed by NM, 13-Apr-2004.)  (Revised by
       Mario Carneiro, 17-May-2015.) $)
    dfackm $p |- ( CHOICE <->
      A. x E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) ) $=
      ( vw vt vh cv wne wral wceq wi wa wex wal wel wn wrex bitri wac c0 cin wo
      wcel weu dfac5 csn cdif cuni cab kmlem13 kmlem8 albii df-ne bicomi anbi2i
      eqid anbi1i imbi2i biid kmlem16 ) UACIZUBJZCAIZKVCFIZJZVCVFUCZUBLMFVEKCVE
      KNDIZVCBIZUCUEDUFZCVEKZBOMAPZBAQZCBQZDAQZVJVILRZNZCDQZNZMZNVNRZCAQDCQDBQN
      ECQEBQNEIVILMNMZNUDEPDOCPBOZAPZABCFDUGVMVGVIVHUENFVESZDVCKCVESZWBVLNBOUDZ
      APZWEVMWGRVDVKMCVEKBOMZAPWIABCFDGHGIHIZVEWKUHUIUJUILHVESGUKZWLURULWJWHAWF
      BCDAUMUNTWHWDAWAWCVLABCFDEVTVPVJVIJZNZVSNVOVRWNVSVQWMVPWMVQVJVIUOUPUQUSUT
      WCVAVLVAVBUNTT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Cardinal number arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c +c $. $( Cardinal number addition $)

  $( Extend class definition to include cardinal number addition. $)
  ccda $a class +c $.

  ${
    $d x y $.
    $( Define cardinal number addition.  Definition of cardinal sum in
       [Mendelson] p. 258.  See ~ cdaval for its value and a description.
       (Contributed by NM, 24-Sep-2004.) $)
    df-cda $a |- +c = ( x e. _V , y e. _V |->
                   ( ( x X. { (/) } ) u. ( y X. { 1o } ) ) ) $.

    $( Cardinal number addition is a function.  (Contributed by Mario Carneiro,
       28-Apr-2015.) $)
    cdafn $p |- +c Fn ( _V X. _V ) $=
      ( vx vy cvv cv c0 csn cxp c1o cun ccda df-cda vex snex xpex unex fnmpt2i
      ) ABCCADZEFZGZBDZHFZGZIJABKSUBQRALEMNTUABLHMNOP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Value of cardinal addition.  Definition of cardinal sum in [Mendelson]
       p. 258.  For cardinal arithmetic, we follow Mendelson.  Rather than
       defining operations restricted to cardinal numbers, we use this disjoint
       union operation for addition, while cross product and set exponentiation
       stand in for cardinal multiplication and exponentiation.  Equinumerosity
       and dominance serve the roles of equality and ordering.  If we wanted
       to, we could easily convert our theorems to actual cardinal number
       operations via ~ carden , ~ carddom , and ~ cardsdom .  The advantage of
       Mendelson's approach is that we can directly use many equinumerosity
       theorems that we already have available.  (Contributed by NM,
       24-Sep-2004.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    cdaval $p |- ( ( A e. V /\ B e. W ) -> ( A +c B ) =
                    ( ( A X. { (/) } ) u. ( B X. { 1o } ) ) ) $=
      ( vx vy wcel cvv ccda csn cxp c1o cun wceq elex wa xpexg mpan2 cv xpeq1
      co c0 p0ex snex anim12i unexb uneq1d uneq2d df-cda ovmpt2g mpd3an3 syl2an
      sylib ) ACGAHGZBHGZABIUAAUBJZKZBLJZKZMZNZBDGACOBDOUNUOUTHGZVAUNUOPUQHGZUS
      HGZPVBUNVCUOVDUNUPHGVCUCAUPHHQRUOURHGVDLUDBURHHQRUEUQUSUFUMEFABHHESZUPKZF
      SZURKZMUTIUQVHMHVEANVFUQVHVEAUPTUGVGBNVHUSUQVGBURTUHEFUIUJUKUL $.
  $}

  $( Cardinal addition dominates union.  (Contributed by NM, 28-Sep-2004.) $)
  uncdadom $p |- ( ( A e. V /\ B e. W ) -> ( A u. B ) ~<_ ( A +c B ) ) $=
    ( wcel wa cun csn cxp c1o cdom wbr cen cvv xpsneng mpan2 ensym endom 3syl
    c0 ccda co 0ex con0 1on cin wceq xp01disj undom syl2an cdaval breqtrrd ) AC
    EZBDEZFABGZATHIZBJHIZGZABUAUBKUMAUPKLZBUQKLZUOURKLZUNUMUPAMLZAUPMLUSUMTNEVB
    UCATCNOPUPAQAUPRSUNUQBMLZBUQMLUTUNJUDEVCUEBJDUDOPUQBQBUQRSUSUTFUPUQUFTUGVAA
    BUHAUPBUQUIPUJABCDUKUL $.

  $( Cardinal addition is equinumerous to union for disjoint sets.
     (Contributed by NM, 5-Apr-2007.) $)
  cdaun $p |- ( ( A e. V /\ B e. W /\ ( A i^i B ) = (/) ) ->
    ( A +c B ) ~~ ( A u. B ) ) $=
    ( wcel cin c0 wceq w3a csn cxp c1o cun cen wbr wa cvv xpsneng mpan2 con0 co
    ccda cdaval 3adant3 0ex 1on anim12i xp01disj jctl unen syl2an 3impa eqbrtrd
    ) ACEZBDEZABFGHZIABUBUAZAGJKZBLJKZMZABMZNUNUOUQUTHUPABCDUCUDUNUOUPUTVANOZUN
    UOPURANOZUSBNOZPURUSFGHZUPPVBUPUNVCUOVDUNGQEVCUEAGCQRSUOLTEVDUFBLDTRSUGUPVE
    ABUHUIURAUSBUJUKULUM $.

  $( Cardinal addition of equinumerous sets.  Exercise 4.56(b) of [Mendelson]
     p. 258.  (Contributed by NM, 28-Sep-2004.)  (Revised by Mario Carneiro,
     29-Apr-2015.) $)
  cdaen $p |- ( ( A ~~ B /\ C ~~ D ) -> ( A +c C ) ~~ ( B +c D ) ) $=
    ( cen wbr wa c0 csn cxp c1o cvv wcel relen xpsneng sylancl entr con0 syl2an
    wceq cun ccda brrelexi 0ex brrelex2i ensymd mpdan syl2anc 1on xp01disj unen
    co cin mpanr12 cdaval 3brtr4d ) ABEFZCDEFZGAHIZJZCKIZJZUAZBUSJZDVAJZUAZACUB
    ULZBDUBULZEUQUTVDEFZVBVEEFZVCVFEFZURUQUTAEFZAVDEFZVIUQALMZHLMZVLABENUCZUDAH
    LLOPUQBVDEFVMUQVDBUQBLMZVOVDBEFABENUEZUDBHLLOPUFABVDQUGUTAVDQUHURVBCEFZCVEE
    FZVJURCLMZKRMZVSCDENUCZUICKLROPURDVEEFVTURVEDURDLMZWBVEDEFCDENUEZUIDKLROPUF
    CDVEQUGVBCVEQUHVIVJGUTVBUMHTVDVEUMHTVKACUJBDUJUTVDVBVEUKUNSUQVNWAVGVCTURVPW
    CACLLUOSUQVQWDVHVFTURVRWEBDLLUOSUP $.

  $( Cardinal addition is equinumerous to union for disjoint sets.
     (Contributed by Mario Carneiro, 29-Apr-2015.) $)
  cdaenun $p |- ( ( A ~~ B /\ C ~~ D /\ ( B i^i D ) = (/) ) ->
    ( A +c C ) ~~ ( B u. D ) ) $=
    ( cen wbr cin c0 wceq w3a ccda co cun cdaen 3adant3 wcel relen brrelex2i id
    cvv cdaun syl3an entr syl2anc ) ABEFZCDEFZBDGHIZJACKLZBDKLZEFZUIBDMZEFZUHUK
    EFUEUFUJUGABCDNOUEBTPUFDTPUGUGULABEQRCDEQRUGSBDTTUAUBUHUIUKUCUD $.

  $( Cardinal addition with cardinal one (which is the same as ordinal one).
     Used in proof of Theorem 6J of [Enderton] p. 143.  (Contributed by NM,
     28-Sep-2004.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
  cda1en $p |- ( ( A e. V /\ -. A e. A ) -> ( A +c 1o ) ~~ suc A ) $=
    ( wcel wn wa c1o ccda co csn cun csuc cen wbr cin wceq enrefg adantr ensn1g
    c0 ensymd simpr disjsn sylibr cdaenun syl3anc df-suc syl6breqr ) ABCZAACDZE
    ZAFGHZAAIZJZAKLUJAALMZFULLMZAULNSOZUKUMLMUHUNUIABPQUHUOUIUHULFABRTQUJUIUPUH
    UIUAAAUBUCAAFULUDUEAUFUG $.

  $( Adding and subtracting one gives back the original set.  Similar to
     ~ pncan for cardinalities.  (Contributed by Mario Carneiro,
     18-May-2015.) $)
  cda1dif $p |- ( B e. ( A +c 1o ) -> ( ( A +c 1o ) \ { B } ) ~~ A ) $=
    ( c1o ccda co wcel csn cdif c0 cen wbr cvv cxp 0ex con0 1on mpbir wceq wrel
    sylancl cop ovex a1i id cun wss df1o2 xpeq1i elexi xpsn eqtri eqsstr3i opex
    ssun2 snss cdm relxp cdafn fndm ax-mp releqi ovrcl simpld syl5eleqr difsnen
    wfn cdaval syl3anc difeq1d cin xp01disj mpbi difun2 difeq2i 3eqtr2i syl6eqr
    disj3 xpsneng eqbrtrd entr syl2anc ) BACDEZFZWBBGHZWBICUAZGZHZJKZWGAJKWDAJK
    WCWBLFZWCWEWBFWHWIWCACDUBUCWCUDWCWEAIGZMZCCGZMZUEZWBWEWNFWFWNUFWFWMWNWMWJWL
    MWFCWJWLUGUHICNCOPUIUJUKZWMWKUNULWEWNICUMUOQWCALFZCOFWBWNRWCWPCLFACBDDUPZSL
    LMZSLLUQWQWRDWRVFWQWRRURWRDUSUTVAQVBVCZPACLOVGTZVDBWELWBVEVHWCWGWKAJWCWGWNW
    FHZWKWCWBWNWFWTVIWKWKWMHZWNWMHXAWKWMVJIRWKXBRACVKWKWMVQVLWKWMVMWMWFWNWOVNVO
    VPWCWPILFWKAJKWSNAILLVRTVSWDWGAVTWA $.

  $( 1+1=2 for cardinal number addition, derived from ~ pm54.43 as promised.
     Theorem *110.643 of _Principia Mathematica_, vol.  II, p. 86, which adds
     the remark, "The above proposition is occasionally useful."  Whitehead and
     Russell define cardinal addition on collections of all sets equinumerous
     to 1 and 2 (which for us are proper classes unless we restrict them as in
     ~ karden ), but after applying definitions, our theorem is equivalent.
     The comment for ~ cdaval explains why we use ` ~~ ` instead of =.  See
     ~ pm110.643ALT for a shorter proof that doesn't use ~ pm54.43 .
     (Contributed by NM, 5-Apr-2007.)  (Proof modification is discouraged.) $)
  pm110.643 $p |- ( 1o +c 1o ) ~~ 2o $=
    ( c1o ccda co c0 csn cxp cun c2o cen con0 wcel wceq 1on cdaval cin xp01disj
    mp2an wbr wb xpsnen elexi 0ex pm54.43 mpbi eqbrtri ) AABCZADEFZAAEFZGZHIAJK
    ZUJUFUILMMAAJJNQUGUHODLZUIHIRZAAPUGAIRUHAIRUKULSADAJMUAZUBTAAUMUMTUGUHUCQUD
    UE $.

  $( Alternate proof of ~ pm110.643 .  (Contributed by Mario Carneiro,
     29-Apr-2015.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  pm110.643ALT $p |- ( 1o +c 1o ) ~~ 2o $=
    ( c1o ccda co csuc c2o cen con0 wcel wn wbr word onordi ordirr ax-mp cda1en
    1on mp2an df-2o breqtrri ) AABCZADZEFAGHAAHIZTUAFJPAKUBAPLAMNAGOQRS $.

  $( Cardinal addition with cardinal zero (the empty set).  Part (a1) of proof
     of Theorem 6J of [Enderton] p. 143.  (Contributed by NM, 27-Sep-2004.)
     (Revised by Mario Carneiro, 29-Apr-2015.) $)
  cda0en $p |- ( A e. V -> ( A +c (/) ) ~~ A ) $=
    ( wcel c0 ccda cun cen cvv cin wceq wbr 0ex in0 cdaun mp3an23 un0 syl6breq
    co ) ABCZADERZADFZAGSDHCADIDJTUAGKLAMADBHNOAPQ $.

  $( Two times a cardinal number.  Exercise 4.56(g) of [Mendelson] p. 258.
     (Contributed by NM, 27-Sep-2004.)  (Revised by Mario Carneiro,
     29-Apr-2015.) $)
  xp2cda $p |- ( A e. V -> ( A X. 2o ) = ( A +c A ) ) $=
    ( wcel ccda co csn cxp c1o cun c2o wceq cdaval anidms cpr df2o3 df-pr eqtri
    c0 xpeq2i xpundi syl6reqr ) ABCZAADEZARFZGAHFZGIZAJGZUBUCUFKAABBLMUGAUDUEIZ
    GUFJUHAJRHNUHORHPQSAUDUETQUA $.

  $( Commutative law for cardinal addition.  Exercise 4.56(c) of [Mendelson]
     p. 258.  (Contributed by NM, 24-Sep-2004.)  (Revised by Mario Carneiro,
     29-Apr-2015.) $)
  cdacomen $p |- ( A +c B ) ~~ ( B +c A ) $=
    ( cvv wcel wa ccda co cen wbr c1o csn cxp cun con0 xpsneng mpan2 ensym wceq
    c0 0ex 1on cin incom eqtri cdaenun mp3an3 syl2an cdaval ancoms uncom syl6eq
    xp01disj breqtrrd wn enref a1i wfn cdm cdafn fndm ax-mp ndmov ancom 3brtr4d
    sylnbi pm2.61i ) ACDZBCDZEZABFGZBAFGZHIVIVJAJKLZBSKLZMZVKHVGVLAHIZVMBHIZVJV
    NHIZVHVGJNDVOUAAJCNOPVHSCDVPTBSCCOPVOAVLHIZBVMHIZVQVPVLAQVMBQVRVSVLVMUBZSRV
    QVTVMVLUBSVLVMUCBAULUDAVLBVMUEUFUGUGVIVKVMVLMZVNVHVGVKWARBACCUHUIVMVLUJUKUM
    VIUNZSSVJVKHSSHIWBSTUOUPABCFFCCLZUQFURWCRUSWCFUTVAZVBVIVHVGEVKSRVGVHVCBACFW
    DVBVEVDVF $.

  $( Associative law for cardinal addition.  Exercise 4.56(c) of [Mendelson]
     p. 258.  (Contributed by NM, 26-Sep-2004.)  (Revised by Mario Carneiro,
     29-Apr-2015.) $)
  cdaassen $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
    ( ( A +c B ) +c C ) ~~ ( A +c ( B +c C ) ) ) $=
    ( wcel ccda co c0 cxp c1o cun cen wbr cin wceq cvv xpsneng sylancl w3a con0
    csn simp1 0ex ensymd simp2 snex xpexg 1on entr syl2anc xp01disj a1i cdaenun
    syl3anc simp3 indir xpeq1i xpindir 0xp 3eqtr3i uneq12i un0 3eqtri wa cdaval
    mpan2 xpeq1d xpundir syl6eq uneq2d unass syl6eqr sylan9eq 3impb breqtrrd
    ovex ) ADGZBEGZCFGZUAZABHIZCHIZAJUCZKZBWEKZLUCZKZMZCWHKZWHKZMZABCHIZHIZNWBW
    CWJNOZCWLNOWJWLPZJQZWDWMNOWBAWFNOBWINOWFWIPJQZWPWBWFAWBVSJRGZWFANOVSVTWAUDU
    EAJDRSTUFWBWIBWBWIWGNOZWGBNOZWIBNOWBWGRGZLUBGZXAWBVTWERGXCVSVTWAUGZJUHBWEER
    UITUJWGLRUBSTWBVTWTXBXEUEBJERSTWIWGBUKULUFWSWBAWGUMUNAWFBWIUOUPWBWLCWBWLWKN
    OZWKCNOZWLCNOWBWKRGZXDXFWBWAWHRGXHVSVTWAUQZLUHCWHFRUITUJWKLRUBSTWBWAXDXGXIU
    JCLFUBSTWLWKCUKULUFWRWBWQWFWLPZWIWLPZMJJMJWFWIWLURXJJXKJAWKUMWGWKPZWHKJWHKX
    KJXLJWHBCUMUSWGWKWHUTWHVAVBVCJVDVEUNWCWJCWLUOUPVSVTWAWOWMQVSVTWAVFZWOWFWNWH
    KZMZWMVSWNRGWOXOQBCHVRAWNDRVGVHXMXOWFWIWLMZMWMXMXNXPWFXMXNWGWKMZWHKXPXMWNXQ
    WHBCEFVGVIWGWKWHVJVKVLWFWIWLVMVNVOVPVQ $.

  $( Cardinal multiplication distributes over cardinal addition.  Theorem 6I(3)
     of [Enderton] p. 142.  (Contributed by NM, 26-Sep-2004.)  (Revised by
     Mario Carneiro, 29-Apr-2015.) $)
  xpcdaen $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
    ( A X. ( B +c C ) ) ~~ ( ( A X. B ) +c ( A X. C ) ) ) $=
    ( wcel cxp ccda co c0 csn c1o cun cen wbr cin wceq cvv ensymd w3a simp2 0ex
    enrefg 3ad2ant1 xpsneng sylancl xpen syl2anc con0 simp3 1on xp01disj xpeq2i
    xpindi xp0 3eqtr3i a1i cdaenun syl3anc cdaval xpeq2d xpundi syl6eq breqtrrd
    3adant1 ) ADGZBEGZCFGZUAZABHZACHZIJZABCIJZHZVJVMABKLHZHZACMLHZHZNZVOOVJVKVQ
    OPZVLVSOPZVQVSQZKRZVMVTOPVJAAOPZBVPOPWAVGVHWEVIADUDUEZVJVPBVJVHKSGVPBOPVGVH
    VIUBUCBKESUFUGTAABVPUHUIVJWECVROPWBWFVJVRCVJVIMUJGVRCOPVGVHVIUKULCMFUJUFUGT
    AACVRUHUIWDVJAVPVRQZHAKHWCKWGKABCUMUNAVPVRUOAUPUQURVKVQVLVSUSUTVJVOAVPVRNZH
    VTVJVNWHAVHVIVNWHRVGBCEFVAVFVBAVPVRVCVDVET $.

  $( Sum of exponents law for cardinal arithmetic.  Theorem 6I(4) of [Enderton]
     p. 142.  (Contributed by NM, 27-Sep-2004.)  (Revised by Mario Carneiro,
     29-Apr-2015.) $)
  mapcdaen $p |- ( ( A e. V /\ B e. W /\ C e. X ) ->
    ( A ^m ( B +c C ) ) ~~ ( ( A ^m B ) X. ( A ^m C ) ) ) $=
    ( wcel co cmap c0 csn cxp c1o cen wbr wceq cvv snex sylancl syl2anc w3a cun
    ccda cdaval 3adant1 oveq2d cin simp2 xpexg simp3 simp1 xp01disj a1i mapunen
    syl31anc eqbrtrd enrefg syl 0ex xpsneng mapen con0 1on xpen entr ) ADGZBEGZ
    CFGZUAZABCUCHZIHZABJKZLZIHZACMKZLZIHZLZNOVRABIHZACIHZLZNOZVKWANOVIVKAVMVPUB
    ZIHZVRNVIVJWCAIVGVHVJWCPVFBCEFUDUEUFVIVMQGZVPQGZVFVMVPUGJPZWDVRNOVIVGVLQGWE
    VFVGVHUHZJRBVLEQUISVIVHVOQGWFVFVGVHUJZMRCVOFQUISVFVGVHUKZWGVIBCULUMVMVPAQQD
    UNUOUPVIVNVSNOZVQVTNOZWBVIAANOZVMBNOZWKVIVFWMWJADUQURZVIVGJQGWNWHUSBJEQUTSA
    AVMBVATVIWMVPCNOZWLWOVIVHMVBGWPWIVCCMFVBUTSAAVPCVATVNVSVQVTVDTVKVRWAVET $.

  $( Sum of exponents law for cardinal arithmetic.  (Contributed by Mario
     Carneiro, 15-May-2015.) $)
  pwcdaen $p |- ( ( A e. V /\ B e. W ) ->
    ~P ( A +c B ) ~~ ( ~P A X. ~P B ) ) $=
    ( wcel wa ccda cpw c2o cmap cen wbr cxp ovex pw2en con0 2on mapcdaen pw2eng
    co mp3an1 wb xpen syl2an enen2 syl mpbird entr sylancr ) ACEZBDEZFZABGTZHZI
    UMJTZKLUOAHZBHZMZKLZUNURKLUMABGNOULUSUOIAJTZIBJTZMZKLZIPEUJUKVCQIABPCDRUAUL
    URVBKLZUSVCUBUJUPUTKLUQVAKLVDUKACSBDSUPUTUQVAUCUDURVBUOUEUFUGUNUOURUHUI $.

  ${
    $( Ordering law for cardinal addition.  Exercise 4.56(f) of [Mendelson]
       p. 258.  (Contributed by NM, 28-Sep-2004.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    cdadom1 $p |- ( A ~<_ B -> ( A +c C ) ~<_ ( B +c C ) ) $=
      ( cdom wbr cvv wcel ccda co wa csn cxp c1o cun snex mpan2 syl wceq reldom
      c0 xpdom1 xpexg cin xp01disj undom syl2an brrelexi cdaval sylan brrelex2i
      domrefg 3brtr4d wn simpr intnand wfn cdm cdafn fndm ax-mp ndmov ovex 0dom
      syl6eqbr pm2.61dan ) ABDEZCFGZACHIZBCHIZDEVFVGJATKZLZCMKZLZNZBVJLZVMNZVHV
      IDVFVKVODEZVMVMDEZVNVPDEZVGABVJTOUAVGVMFGZVRVGVLFGVTMOCVLFFUBPVMFUKQVQVRJ
      VOVMUCTRVSBCUDVKVOVMVMUEPUFVFAFGZVGVHVNRABDSUGACFFUHUIVFBFGVGVIVPRABDSUJB
      CFFUHUIULVFVGUMZJZVHTVIDWCWAVGJUMVHTRWCVGWAVFWBUNUOACFHHFFLZUPHUQWDRURWDH
      USUTVAQVIBCHVBVCVDVE $.

    $( Ordering law for cardinal addition.  Theorem 6L(a) of [Enderton]
       p. 149.  (Contributed by NM, 28-Sep-2004.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    cdadom2 $p |- ( A ~<_ B -> ( C +c A ) ~<_ ( C +c B ) ) $=
      ( cdom wbr ccda co cdadom1 wb cdacomen domen1 domen2 sylan9bb mp2an sylib
      cen ) ABDEACFGZBCFGZDEZCAFGZCBFGZDEZABCHQTPEZRUAPEZSUBIACJBCJUCSTRDEUDUBQ
      TRKRUATLMNO $.

    $( A set is dominated by its cardinal sum with another.  (Contributed by
       NM, 28-Sep-2004.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    cdadom3 $p |- ( ( A e. V /\ B e. W ) -> A ~<_ ( A +c B ) ) $=
      ( wcel wa cun cdom wbr ccda co cvv unexg ssun1 ssdomg ee10 uncdadom domtr
      wss syl2anc ) ACEBDEFZAABGZHIZUBABJKZHIAUDHIUAUBLEAUBSUCABCDMABNAUBLOPABC
      DQAUBUDRT $.
  $}

  $( Cross product dominates disjoint union for sets with cardinality greater
     than 1.  Similar to Proposition 10.36 of [TakeutiZaring] p. 93.
     (Contributed by Mario Carneiro, 18-May-2015.) $)
  cdaxpdom $p |- ( ( 1o ~< A /\ 1o ~< B ) -> ( A +c B ) ~<_ ( A X. B ) ) $=
    ( c1o csdm wbr c0 csn cxp cdom cen wcel relsdom brrelex2i syl2an wb xpsneng
    cvv sylancl sdomen2 syl wa ccda co cun wceq cdaval 0ex ibir unxpdom eqbrtrd
    con0 1on xpen domentr syl2anc ) CADEZCBDEZUAZABUBUCZAFGHZBCGHZHZIEVBABHZJEZ
    USVCIEURUSUTVAUDZVBIUPAQKZBQKZUSVEUEUQCADLMZCBDLMZABQQUFNUPCUTDEZCVADEZVEVB
    IEUQUPVJUPUTAJEZVJUPOUPVFFQKVLVHUGAFQQPRZUTACSTUHUQVKUQVABJEZVKUQOUQVGCUKKV
    NVIULBCQUKPRZVABCSTUHUTVAUINUJUPVLVNVDUQVMVOUTAVABUMNUSVBVCUNUO $.

  $( The cardinal sum of two finite sets is finite.  (Contributed by NM,
     22-Oct-2004.) $)
  cdafi $p |- ( ( A ~< om /\ B ~< om ) -> ( A +c B ) ~< om ) $=
    ( com csdm wbr c0 csn cxp c1o cvv wcel relsdom brrelexi syl2an con0 xpsneng
    cen wb sylancl sdomen1 wa ccda cun wceq cdaval 0elon syl ibir unfi2 eqbrtrd
    co 1on ) ACDEZBCDEZUAABUBUKZAFGHZBIGHZUCZCDUMAJKZBJKZUOURUDUNACDLMZBCDLMZAB
    JJUENUMUPCDEZUQCDEZURCDEUNUMVCUMUPAQEZVCUMRUMUSFOKVEVAUFAFJOPSUPACTUGUHUNVD
    UNUQBQEZVDUNRUNUTIOKVFVBULBIJOPSUQBCTUGUHUPUQUINUJ $.

  $( Any partition of omega into two pieces (which may be disjoint) contains an
     infinite subset.  (Contributed by Mario Carneiro, 11-Feb-2013.) $)
  cdainflem $p |- ( ( A u. B ) ~~ om -> ( A ~~ om \/ B ~~ om ) ) $=
    ( com cen wbr csdm wa wn wo cdom cvv wss ssdomg ee10 domentr mpancom anim1i
    bren2 sylibr ex cun unfi2 sdomnen syl con2i ianor wcel relen brrelexi ssun1
    ssun2 orim12d syl5bi mpd ) ABUAZCDEZACFEZBCFEZGZHZACDEZBCDEZIZUSUPUSUOCFEUP
    HABUBUOCUCUDUEUTUQHZURHZIUPVCUQURUFUPVDVAVEVBUPVDVAUPVDGACJEZVDGVAUPVFVDAUO
    JEZUPVFUPUOKUGZAUOLVGUOCDUHUIZABUJAUOKMNAUOCOPQACRSTUPVEVBUPVEGBCJEZVEGVBUP
    VJVEBUOJEZUPVJUPVHBUOLVKVIBAUKBUOKMNBUOCOPQBCRSTULUMUN $.

  ${
    $d A x y a $.
    $( A set is infinite iff the cardinal sum with itself is infinite.
       (Contributed by NM, 22-Oct-2004.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    cdainf $p |- ( om ~<_ A <-> om ~<_ ( A +c A ) ) $=
      ( vx com cdom wbr ccda cvv wcel syl2anc c0 wa cxp cen wss csn cin c1o cun
      wceq mpan2 co reldom brrelex2i cdadom3 domtr mpdan wne infn0 wfn cdm fndm
      cdafn ax-mp ndmov necon1ai simpld syl cv wex ovex domen indi simprr simpl
      cdaval sseqtrd df-ss sylib syl5eqr ensym ad2antrl eqbrtrd ex wo cdainflem
      snex xpexg ssdomg ee10 0ex xpsneng domentr domen1 syl5ibcom con0 1on jaod
      inss2 syl5 syld exlimdv syl5bi mpcom impbii ) CADEZCAAFUAZDEZWOAWPDEZWQWO
      AGHZWSWRCADUBUCZWTAAGGUDICAWPUEUFWSWQWOWQWPJUGZWSWPUHXAWSWSWSWSKWPJAAGFFG
      GLZUIFUJXBSULXBFUKUMUNUOUPUQWQCBURZMEZXCWPNZKZBUSWSWOBCWPAAFUTVAWSXFWOBWS
      XFXCAJOZLZPZXCAQOZLZPZRZCMEZWOWSXFXNWSXFKZXMXCCMXOXMXCXHXKRZPZXCXCXHXKVBX
      OXCXPNXQXCSXOXCWPXPWSXDXEVCXOWSWSWPXPSWSXFVDZXRAAGGVEIVFXCXPVGVHVIXDXCCME
      WSXECXCVJVKVLVMXNXICMEZXLCMEZVNWSWOXIXLVOWSXSWOXTWSXIADEZXSWOWSXIXHDEZXHA
      MEZYAWSXHGHZXIXHNYBWSXGGHYDJVPAXGGGVQTXCXHWHXIXHGVRVSWSJGHYCVTAJGGWATXIXH
      AWBIXICAWCWDWSXLADEZXTWOWSXLXKDEZXKAMEZYEWSXKGHZXLXKNYFWSXJGHYHQVPAXJGGVQ
      TXCXKWHXLXKGVRVSWSQWEHYGWFAQGWEWATXLXKAWBIXLCAWCWDWGWIWJWKWLWMWN $.
  $}

  $( An infinite set is equinumerous to itself added with one.  (Contributed by
     Mario Carneiro, 15-May-2015.) $)
  infcda1 $p |- ( om ~<_ A -> ( A +c 1o ) ~~ A ) $=
    ( com cdom wbr c1o ccda csn cxp cen cop cdif cvv wcel con0 wceq 1on sylancl
    co c0 0ex cun reldom brrelex2i cdaval df1o2 xpeq1i xpsn eqtr2i a1i difeq12d
    elexi difun2 xp01disj disj3 mpbi eqtr4i syl6eq cdadom3 domtr mpdan infdifsn
    cin syl eqbrtrrd ensymd xpsneng entr syl2anc ) BACDZAEFRZASGZHZIDVLAIDZVJAI
    DVIVLVJVIVJSEJZGZKZVLVJIVIVPVLEEGZHZUAZVRKZVLVIVJVSVOVRVIALMZENMZVJVSOBACUB
    UCZPAELNUDQVOVROVIVRVKVQHVOEVKVQUEUFSETENPUKUGUHUIUJVTVLVRKZVLVLVRULVLVRVBS
    OVLWDOAEUMVLVRUNUOUPUQVIBVJCDZVPVJIDVIAVJCDZWEVIWAWBWFWCPAELNURQBAVJUSUTVJV
    NVAVCVDVEVIWASLMVMWCTASLLVFQVJVLAVGVH $.

  $( The sum of a powerset with itself is equipotent to the successor
     powerset.  (Contributed by Mario Carneiro, 15-May-2015.) $)
  pwcda1 $p |- ( A e. V -> ( ~P A +c ~P A ) ~~ ~P ( A +c 1o ) ) $=
    ( wcel c1o ccda co cpw cxp cen con0 wbr 1on pwcdaen mpan2 c2o csn cpr pwpw0
    c0 cvv df1o2 pweqi df2o2 3eqtr4i xpeq2i wceq pwexg xp2cda syl syl5eq ensymd
    breqtrd ) ABCZADEFGZAGZUOEFZUMUNUODGZHZUPIUMDJCUNURIKLADBJMNUMURUOOHZUPUQOU
    OSPZGSUTQUQORDUTUAUBUCUDUEUMUOTCUSUPUFABUGUOTUHUIUJULUK $.

  $( If the natural numbers inject into ` A ` , then ` ~P A ` is idempotent
     under cardinal sum.  (Contributed by Mario Carneiro, 15-May-2015.) $)
  pwcdaidm $p |- ( om ~<_ A -> ( ~P A +c ~P A ) ~~ ~P A ) $=
    ( com cdom wbr cpw ccda co c1o cen cvv wcel reldom brrelex2i pwcda1 infcda1
    syl pwen entr syl2anc ) BACDZAEZUAFGZAHFGZEZIDZUDUAIDZUBUAIDTAJKUEBACLMAJNP
    TUCAIDUFAOUCAQPUBUDUARS $.

  $( If ` A ` is idempotent under cardinal sum and ` B ` is dominated by the
     power set of ` A ` , then so is the cardinal sum of ` A ` and ` B ` .
     (Contributed by Mario Carneiro, 15-May-2015.) $)
  cdalepw $p |- ( ( ( A +c A ) ~~ A /\ B ~<_ ~P A ) -> ( A +c B ) ~<_ ~P A ) $=
    ( ccda co cen wbr cpw cdom wa c1o cvv wcel csdm adantr 3syl cdadom2 syl2anc
    c0 domtr syl oveq1 breq1d wne relen brrelex2i canth2g sdomdom simpr cdadom1
    wceq syl2an pwcda1 domentr wb 0sdomg biimpar 0sdom1dom sylib pwdom cdacomen
    simpll reldom brrelexi adantl cda0en domen1 mpbird endomtr sylancr pm2.61ne
    ) AACDZAEFZBAGZHFZIZABCDZVMHFZRBCDZVMHFZARARUJVPVRVMHARBCUAUBVOARUCZIZVPAJC
    DZGZHFZWCVMHFZVQVOWDVTVOVPVMVMCDZHFZWFWCEFZWDVOAVMHFZVNWGVOAKLZAVMMFWIVLWJV
    NVKAEUDUENZAKUFAVMUGOVLVNUHZWIVPVMBCDZHFWMWFHFWGVNAVMBUIBVMVMPVPWMWFSUKQVOW
    JWHWKAKULTVPWFWCUMQNWAWBAHFZWEWAWBVKHFZVLWNWAJAHFZWOWARAMFZWPVOWQVTVOWJWQVT
    UNWKAKUOTUPAUQURJAAPTVLVNVTVAWBVKAUMQWBAUSTVPWCVMSQVOVRBRCDZEFWRVMHFZVSRBUT
    VOWSVNWLVOBKLZWRBEFWSVNUNVNWTVLBVMHVBVCVDBKVEWRBVMVFOVGVRWRVMVHVIVJ $.

  ${
    $d A x y z $.  $d B x y z $.
    $( The cardinal and ordinal sums are always equinumerous.  (Contributed by
       Mario Carneiro, 6-Feb-2013.)  (Revised by Mario Carneiro,
       30-May-2015.) $)
    onacda $p |- ( ( A e. On /\ B e. On ) -> ( A +o B ) ~~ ( A +c B ) ) $=
      ( vx con0 wcel wa ccda co coa cmpt crn cun cen wbr cin wceq enrefg adantr
      cv c0 simpr oacomf1olem ancoms simpld f1oeng syl2anc incom simprd cdaenun
      wf1o eqid syl5eq syl3anc oarec breqtrrd ensymd ) ADEZBDEZFZABGHZABIHZUSUT
      ACBACSIHJZKZLZVAMUSAAMNZBVCMNZAVCOZTPUTVDMNUQVEURADQRUSURBVCVBUJZVFUQURUA
      USVHVCAOZTPZURUQVHVJFCBAVBVBUKUBUCZUDBVCDVBUEUFUSVGVITAVCUGUSVHVJVKUHULAA
      BVCUIUMCABUNUOUP $.
  $}

  ${
    $d A x $.  $d B x $.
    $( The cardinal sum is equinumerous to an ordinal sum of the cardinals.
       (Contributed by Mario Carneiro, 6-Feb-2013.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    cardacda $p |- ( ( A e. dom card /\ B e. dom card ) ->
         ( A +c B ) ~~ ( ( card ` A ) +o ( card ` B ) ) ) $=
      ( ccrd cdm wcel wa cfv coa co ccda cen wbr con0 cardon onacda mp2an cdaen
      cardid2 syl2an entr sylancr ensymd ) ACDZEZBUCEZFZACGZBCGZHIZABJIZUFUIUGU
      HJIZKLZUKUJKLZUIUJKLUGMEUHMEULANBNUGUHOPUDUGAKLUHBKLUMUEARBRUGAUHBQSUIUKU
      JTUAUB $.
  $}

  $( The cardinal sum of two numerable sets is numerable.  (Contributed by
     Mario Carneiro, 29-Apr-2015.) $)
  cdanum $p |- ( ( A e. dom card /\ B e. dom card ) ->
                ( A +c B ) e. dom card ) $=
    ( ccrd cdm wcel wa cfv coa co con0 ccda cen wbr cardon oacl cardacda ensymd
    mp2an isnumi sylancr ) ACDZEBUAEFZACGZBCGZHIZJEZUEABKIZLMUGUAEUCJEUDJEUFANB
    NUCUDORUBUGUEABPQUEUGST $.

  $( The union of two numerable sets is numerable.  (Contributed by Mario
     Carneiro, 29-Apr-2015.) $)
  unnum $p |- ( ( A e. dom card /\ B e. dom card ) ->
                ( A u. B ) e. dom card ) $=
    ( ccrd cdm wcel wa ccda co cun cdom wbr cdanum uncdadom numdom syl2anc ) AC
    DZEBPEFABGHZPEABIZQJKRPEABLABPPMQRNO $.

  $( The cardinal and ordinal sums of finite ordinals are equal.  (Contributed
     by Paul Chapman, 11-Apr-2009.)  (Revised by Mario Carneiro,
     6-Feb-2013.) $)
  nnacda $p |- ( ( A e. om /\ B e. om ) ->
                 ( card ` ( A +c B ) ) = ( A +o B ) ) $=
    ( com wcel wa coa co ccrd cfv ccda cen wbr wceq con0 onacda syl2an carden2b
    nnon syl nnacl cardnn eqtr3d ) ACDZBCDZEZABFGZHIZABJGZHIZUFUEUFUHKLZUGUIMUC
    ANDBNDUJUDARBRABOPUFUHQSUEUFCDUGUFMABTUFUASUB $.

  ${
    $d A x $.  $d B x $.
    $( The cardinality of the union of disjoint, finite sets is the ordinal sum
       of their cardinalities.  (Contributed by Paul Chapman, 5-Jun-2009.)
       (Proof shortened by Mario Carneiro, 28-Apr-2015.) $)
    ficardun $p |- ( ( A e. Fin /\ B e. Fin /\ ( A i^i B ) = (/) )
               -> ( card ` ( A u. B ) ) = ( ( card ` A ) +o ( card ` B ) ) ) $=
      ( cfn wcel cin c0 wceq w3a ccrd cfv coa cen wbr finnum syl2an 3adant3 syl
      co com ficardom cun ccda cdm cardacda ensymd cdaun syl2anc carden2b nnacl
      entr wa cardnn eqtr3d ) ACDZBCDZABEFGZHZAIJZBIJZKRZIJZABUAZIJZUTUQUTVBLMZ
      VAVCGUQUTABUBRZLMVEVBLMVDUQVEUTUNUOVEUTLMZUPUNAIUCZDBVGDVFUOANBNABUDOPUEA
      BCCUFUTVEVBUJUGUTVBUHQUNUOVAUTGZUPUNURSDZUSSDZVHUOATBTVIVJUKUTSDVHURUSUIU
      TULQOPUM $.

    $( The cardinality of the union of finite sets is at most the ordinal sum
       of their cardinalities.  (Contributed by Mario Carneiro, 5-Feb-2013.) $)
    ficardun2 $p |- ( ( A e. Fin /\ B e. Fin )
        -> ( card ` ( A u. B ) ) C_ ( ( card ` A ) +o ( card ` B ) ) ) $=
      ( cfn wcel wa cun ccrd cfv coa co wss cdom wbr ccda finnum syl2an syl2anc
      syl com ficardom cen uncdadom cdm cardacda domentr unfi con0 nnacl onenon
      wb nnon 3syl carddom2 mpbird wceq cardnn sseqtrd ) ACDZBCDZEZABFZGHZAGHZB
      GHZIJZGHZVEUTVBVFKZVAVELMZUTVAABNJZLMVIVEUAMZVHABCCUBURAGUCZDBVKDVJUSAOBO
      ABUDPVAVIVEUEQUTVAVKDZVEVKDZVGVHUJUTVACDVLABUFVAORUTVESDZVEUGDVMURVCSDVDS
      DVNUSATBTVCVDUHPZVEUKVEUIULVAVEUMQUNUTVNVFVEUOVOVEUPRUQ $.
  $}

  ${
    $d B k m n $.  $d B k m x $.
    $( Lemma for ~ domtriom .  This is the equinumerosity version of the
       algebraic identity ` sum_ k e. n ( 2 ^ k ) = ( 2 ^ n ) - 1 ` .
       (Contributed by Mario Carneiro, 7-Feb-2013.) $)
    pwsdompw $p |- ( ( n e. om /\ A. k e. suc n ( B ` k ) ~~ ~P k ) ->
         U_ k e. n ( B ` k ) ~< ( B ` n ) ) $=
      ( com wcel cfv cpw cen wbr csdm wi c0 fveq2 breq12d syl adantl co syl2anc
      wceq ccrd vm cv csuc wral ciun suceq raleqdv iuneq1 imbi12d 0iun 0ex pweq
      sucid rspcv ax-mp canth2 ensym sdomentr sylancr syl5eqbr wa ssralv pm2.27
      wss sssucid ccda vex elelsuc mp2b cdaen c1o pwcda1 wn nnord ordirr cda1en
      word mpdan pwen entr syl2an sucex ensymd adantr ancoms nnfi pwfi isfinite
      cfn bitri sylib ensdomtr sylibr cdom cun iunsuc fvex iunex uncdadom mp2an
      cvv eqbrtri coa cdm sdomtr sylan2b finnum cardacda ficardom cardid2 simpl
      3syl syl21anc con0 wb cardon onenon cardsdomel cardidm eleq2i w3a nnaordr
      sylan biimpa syl31anc nnacl cardnn eleqtrrd cardsdomelir domsdomtr expcom
      sylsyld syld ex com23 finds1 imp ) CUBZDEBUBZAFZYSGZHIZBYRUCZUDZBYRYTUEZY
      RAFZJIZUUDUUGKUUBBLUCZUDZBLYTUEZLAFZJIZKUUBBUAUBZUCZUDZBUUMYTUEZUUMAFZJIZ
      KZUUBBUUNUCZUDZBUUNYTUEZUUNAFZJIZKCUAYRLSZUUDUUIUUGUULUVEUUBBUUCUUHYRLUFU
      GUVEUUEUUJUUFUUKJBYRLYTUHYRLAMNUIYRUUMSZUUDUUOUUGUURUVFUUBBUUCUUNYRUUMUFU
      GUVFUUEUUPUUFUUQJBYRUUMYTUHYRUUMAMNUIYRUUNSZUUDUVAUUGUVDUVGUUBBUUCUUTYRUU
      NUFUGUVGUUEUVBUUFUVCJBYRUUNYTUHYRUUNAMNUIUUIUUJLUUKJBYTUJUUIUUKLGZHIZLUUK
      JIZLUUHEUUIUVIKLUKUMUUBUVIBLUUHYSLSYTUUKUUAUVHHYSLAMYSLULNUNUOUVILUVHJIUV
      HUUKHIUVJLUKUPUUKUVHUQLUVHUUKURUSOUTUUMDEZUVAUUSUVDUVKUVAUUSUVDKUVKUVAVAZ
      UUSUURUVDUVAUUSUURKZUVKUVAUUOUVMUUNUUTVDUVAUUOKUUNVEUUBBUUNUUTVBUOUUOUURV
      COPUVLUUQUUQVFQZUVCHIZUURUVBUVNJIZUVDUVAUVKUVOUVAUVKVAZUVNUUNGZHIZUVRUVCH
      IZUVOUVAUVNUUMGZUWAVFQZHIZUWBUVRHIZUVSUVKUVAUUQUWAHIZUWEUWCUUMUUNEUUMUUTE
      UVAUWEKUUMUAVGZUMUUMUUNVHUUBUWEBUUMUUTYSUUMSYTUUQUUAUWAHYSUUMAMZYSUUMULNU
      NVIZUWHUUQUWAUUQUWAVJRUVKUWBUUMVKVFQZGZHIUWJUVRHIZUWDUUMDVLUVKUWIUUNHIZUW
      KUVKUUMUUMEVMZUWLUVKUUMVQUWMUUMVNUUMVOOUUMDVPVRUWIUUNVSOUWBUWJUVRVTRUVNUW
      BUVRVTWAUVAUVTUVKUVAUVCUVRUUNUUTEUVAUVCUVRHIZKUUNUUMUWFWBUMUUBUWNBUUNUUTY
      SUUNSYTUVCUUAUVRHYSUUNAMYSUUNULNUNUOWCWDUVNUVRUVCVTRWEUVLUUQWIEZUURUVPKUV
      AUVKUWOUVQUUQDJIZUWOUVAUWEUWADJIZUWPUVKUWHUVKUUMWIEZUWQUUMWFUWRUWAWIEUWQU
      UMWGUWAWHWJWKUUQUWADWLWAUUQWHZWMWEUURUWOUVPUURUWOVAZUVBUUPUUQVFQZWNIUXAUV
      NJIZUVPUVBUUPUUQWOZUXAWNBUUMYTUUQUWFUWGWPUUPXAEUUQXAEUXCUXAWNIBUUMYTUWFYS
      AWQWRUUMAWQUUPUUQXAXAWSWTXBUWTUXAUUQTFZUXDXCQZJIZUXEUVNHIZUXBUWTUXAUUPTFZ
      UXDXCQZHIZUXIUXEJIZUXFUWTUUPTXDZEZUUQUXLEZUXJUWTUUPWIEZUXMUWTUUPDJIZUXOUW
      OUURUWPUXPUWSUUPUUQDXEXFUUPWHWMZUUPXGZOUWOUXNUURUUQXGZPUUPUUQXHRUWTUXIUXE
      TFZEUXKUWTUXIUXEUXTUWTUXHDEZUXDDEZUYBUXHUXDEZUXIUXEEZUWTUXOUYAUXQUUPXIOUW
      OUYBUURUUQXIZPZUYFUWTUXHUXDJIZUYCUWTUXHUUPHIZUURUUQUXDHIZUYGUWTUXOUXMUYHU
      XQUXRUUPXJXLUURUWOXKUWOUYIUURUWOUXNUXDUUQHIUYIUXSUUQXJUXDUUQUQXLPUYHUURVA
      UXHUUQJIUYIUYGUXHUUPUUQWLUXHUUQUXDURYCXMUYGUXHUXDTFZEZUYCUXHXNEUXDUXLEZUY
      GUYKXOUUPXPUXDXNEUYLUUQXPUXDXQUOUXHUXDXRWTUYJUXDUXHUUQXSXTWJWKUYAUYBUYBYA
      UYCUYDUXHUXDUXDYBYDYEUWOUXTUXESZUURUWOUXEDEZUYMUWOUYBUYBUYNUYEUYEUXDUXDYF
      RUXEYGOPYHUXIUXEYIOUXAUXIUXEWLRUWOUXGUURUWOUVNUXEUWOUXNUXNUVNUXEHIUXSUXSU
      UQUUQXHRWCPUXAUXEUVNURRUVBUXAUVNYJUSYKOUVPUVOUVDUVBUVNUVCURYKYLYMYNYOYPYQ
      $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The union of two countable sets is countable.  (Contributed by FL,
       25-Aug-2006.)  (Proof shortened by Mario Carneiro, 30-Apr-2015.) $)
    unctb $p |- ( ( A ~<_ om /\ B ~<_ om ) -> ( A u. B ) ~<_ om ) $=
      ( com cdom wbr wa ccda cvv wcel reldom brrelexi syl2an domtr cxp wss omex
      co c2o ax-mp mp2an cun uncdadom cdadom1 cdadom2 cen xpex wceq xp2cda word
      ordom 2onn ordelss xpss2 eqsstr3i ssdomg xpomen domentr sylancl syl2anc
      mp2 ) ACDEZBCDEZFZABUAZABGQZDEZVECDEZVDCDEVAAHIBHIVFVBACDJKBCDJKABHHUBLVC
      VECCGQZDEZVHCDEZVGVAVECBGQZDEVKVHDEVIVBACBUCBCCUDVEVKVHMLVHCCNZDEZVLCUEEV
      JVLHIVHVLOVMCCPPUFVHCRNZVLCHIVNVHUGPCHUHSRCOZVNVLOCUIRCIVOUJUKCRULTRCCUMS
      UNVHVLHUOUTUPVHVLCUQTVEVHCMURVDVECMUS $.
  $}

  ${
    $( Absorption law for addition to an infinite cardinal.  (Contributed by
       NM, 30-Sep-2004.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    infcdaabs $p |- ( ( A e. dom card /\ om ~<_ A /\ B ~<_ A ) ->
      ( A +c B ) ~~ A ) $=
      ( ccrd cdm wcel com cdom wbr w3a ccda cen cxp cdadom2 3ad2ant3 wceq domtr
      co c2o syl2anc cvv simp1 xp2cda syl breqtrrd csdm 2onn sdomdom mp2b simp2
      nnsdom sylancr xpdom2g infxpidm2 3adant3 domentr reldom brrelexi cdadom3
      sbth ) ACDZEZFAGHZBAGHZIZABJQZAGHZAVEGHZVEAKHVDVEAALZGHZVHAKHZVFVDVEARLZG
      HVKVHGHZVIVDVEAAJQZVKGVCVAVEVMGHVBBAAMNVDVAVKVMOVAVBVCUAZAUTUBUCUDVDVARAG
      HZVLVNVDRFGHZVBVORFERFUEHVPUFRUJRFUGUHVAVBVCUIRFAPUKRAAUTULSVEVKVHPSVAVBV
      JVCAUMUNVEVHAUOSVDVABTEZVGVNVCVAVQVBBAGUPUQNABUTTURSVEAUSS $.

    $( An infinite set is equinumerous to its union with a smaller one.
       (Contributed by NM, 28-Sep-2004.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    infunabs $p |- ( ( A e. dom card /\ om ~<_ A /\ B ~<_ A ) ->
      ( A u. B ) ~~ A ) $=
      ( ccrd cdm wcel com cdom wbr w3a cun cen ccda cvv simp1 brrelexi 3ad2ant3
      co reldom uncdadom syl2anc infcdaabs domentr unexg ssun1 ssdomg ee10 sbth
      wss ) ACDZEZFAGHZBAGHZIZABJZAGHZAUNGHZUNAKHUMUNABLQZGHZUQAKHUOUMUJBMEZURU
      JUKULNZULUJUSUKBAGROPZABUIMSTABUAUNUQAUBTUMUNMEZAUNUHUPUMUJUSVBUTVAABUIMU
      CTABUDAUNMUEUFUNAUGT $.

    $( The sum of two cardinal numbers is their maximum, if one of them is
       infinite.  Proposition 10.41 of [TakeutiZaring] p. 95.  (Contributed by
       NM, 28-Sep-2004.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    infcda $p |- ( ( A e. dom card /\ B e. dom card /\ om ~<_ A ) ->
        ( A +c B ) ~~ ( A u. B ) ) $=
      ( ccrd cdm wcel com cdom wbr w3a ccda co cun cen wss unnum 3adant3 ssdomg
      ee10 domentr syl2anc ssun2 cdadom2 syl cdacomen sylancl simp3 ssun1 domtr
      infcdaabs syl3anc uncdadom sbth ) ACDZEZBUMEZFAGHZIZABJKZABLZGHZUSURGHZUR
      USMHUQURUSAJKZGHZVBUSMHZUTUQURAUSJKZGHZVEVBMHVCUQBUSGHZVFUQUSUMEZBUSNVGUN
      UOVHUPABOPZBAUABUSUMQRBUSAUBUCAUSUDURVEVBSUEUQVHFUSGHZAUSGHZVDVIUQUPVKVJU
      NUOUPUFUQVHAUSNVKVIABUGAUSUMQRZFAUSUHTVLUSAUIUJURVBUSSTUNUOVAUPABUMUMUKPU
      RUSULT $.

    $( The cardinality of an infinite set does not change after subtracting a
       strictly smaller one.  Example in [Enderton] p. 164.  (Contributed by
       NM, 22-Oct-2004.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    infdif $p |- ( ( A e. dom card /\ om ~<_ A /\ B ~< A ) ->
        ( A \ B ) ~~ A ) $=
      ( wcel com cdom wbr csdm cen wss ssdomg ee10 co cun sdomdom syl2anc domtr
      ccda wn syl wi ccrd cdm w3a cdif simp1 difss 3ad2ant3 numdom unnum undif1
      ssun1 ssnum sylancl uncdadom syl5eqbrr simp3 cdadom1 simp2 cdainf biimpri
      domrefg infcdaabs 3com23 3expia syl2im syld domen2 biimpcd sylcom domnsym
      ex mpdan syl56 mt2d wb domtri2 mpbird cdadom2 sylibr syl3anc domentr sbth
      ) AUAUBZCZDAEFZBAGFZUCZABUDZAEFZAWHEFZWHAHFWGWDWHAIZWIWDWEWFUEZABUFZWHAWC
      JKWGAWHWHQLZEFZWNWHHFZWJWGAWHBQLZEFZWQWNEFZWOWGAABMZEFZWTWQEFWRWGWTWCCZAW
      TIXAWGWDBWCCZXBWLWGWDBAEFZXCWLWFWDXDWEBANUGABUHOZABUIOABUKAWTWCJKWGWTWHBM
      ZWQEABUJWGWHWCCZXCXFWQEFWGWDWKXGWLWMAWHULUMZXEWHBWCWCUNOUOAWTWQPOZWGBWHEF
      ZWSWGXJWHBGFZRZWGXKWFWDWEWFUPXKWQBBQLZEFZWGABEFZWFRXKWHBEFXNWHBNWHBBUQSWG
      XNAXMEFZXOWGWRXNXPTXIWRXNXPAWQXMPVKSWGXPXMBHFZXOWGXPDXMEFZXQWGWEXPXRTWDWE
      WFURZWEXPXRDAXMPVKSWGXCXRDBEFZXQXEXTXRBUSUTXCBBEFZXTXQTBWCVAXCYAXTXQXCXTY
      AXQBBVBVCVDVLVEVFXQXPXOXMBAVGVHVIVFABVJVMVNWGXCXGXJXLVOXEXHBWHVPOVQBWHWHV
      RSAWQWNPOZWGXGDWHEFZWHWHEFZWPXHWGDWNEFZYCWGWEWOYEXSYBDAWNPOWHUSVSWGXGYDXH
      WHWCVASWHWHVBVTAWNWHWAOWHAWBO $.

    $( Cardinality ordering for an infinite set difference.  (Contributed by
       NM, 24-Mar-2007.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    infdif2 $p |- ( ( A e. dom card /\ B e. dom card /\ om ~<_ A ) ->
        ( ( A \ B ) ~<_ B <-> A ~<_ B ) ) $=
      ( ccrd cdm wcel com cdom wbr w3a cdif csdm wn wi domnsym cen simp3 infdif
      ensymd sdomentr syl2anc nsyl3 3expia 3adant2 con2d wb domtri2 3adant3 wss
      sylibrd simp1 difss ssdomg ee10 domtr ex syl impbid ) ACDZEZBUREZFAGHZIZA
      BJZBGHZABGHZVBVDBAKHZLZVEVBVFVDUSVAVFVDLZMUTUSVAVFVHVDBVCKHZUSVAVFIZVCBNV
      JVFAVCOHVIUSVAVFPVJVCAABQRBAVCSTUAUBUCUDUSUTVEVGUEVAABUFUGUIVBVCAGHZVEVDM
      VBUSVCAUHVKUSUTVAUJABUKVCAURULUMVKVEVDVCABUNUOUPUQ $.

    $( Dominance law for multiplication with an infinite cardinal.
       (Contributed by NM, 26-Mar-2006.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    infxpdom $p |- ( ( A e. dom card /\ om ~<_ A /\ B ~<_ A ) ->
      ( A X. B ) ~<_ A ) $=
      ( ccrd cdm wcel com wbr w3a cxp xpdom2g 3adant2 infxpidm2 3adant3 domentr
      cdom cen syl2anc ) ACDZEZFAOGZBAOGZHABIZAAIZOGZUCAPGZUBAOGSUAUDTBAARJKSTU
      EUAALMUBUCANQ $.

    $( Absorption law for multiplication with an infinite cardinal.
       (Contributed by NM, 30-Sep-2004.)  (Revised by Mario Carneiro,
       29-Apr-2015.) $)
    infxpabs $p |- ( ( ( A e. dom card /\ om ~<_ A ) /\
      ( B =/= (/) /\ B ~<_ A ) ) -> ( A X. B ) ~~ A ) $=
      ( ccrd cdm wcel com cdom wbr wa wne cxp cen infxpdom 3expa adantrl simpll
      c0 numdom ad2ant2rl simprl xpdom3 syl3anc sbth syl2anc ) ACDZEZFAGHZIZBQJ
      ZBAGHZIZIZABKZAGHZAUMGHZUMALHUHUJUNUIUFUGUJUNABMNOULUFBUEEZUIUOUFUGUKPUFU
      JUPUGUIABRSUHUIUJTABUEUEUAUBUMAUCUD $.

    $( The union of two sets that are strictly dominated by the infinite set
       ` X ` is also dominated by ` X ` .  This version of ~ infunsdom assumes
       additionally that ` A ` is the smaller of the two.  (Contributed by
       Mario Carneiro, 14-Dec-2013.)  (Revised by Mario Carneiro,
       3-May-2015.) $)
    infunsdom1 $p |- ( ( ( X e. dom card /\ om ~<_ X ) /\
      ( A ~<_ B /\ B ~< X ) ) -> ( A u. B ) ~< X ) $=
      ( ccrd cdm wcel com cdom wbr wa cun simprl domsdomtr sylan unfi2 sylancom
      csdm syl2anc cen adantr simpllr sdomdomtr wn wb con0 omelon onenon simpll
      ax-mp sdomdom ad2antll numdom domtri2 sylancr biimpar uncom simpr syl3anc
      infunabs syl5eqbr simplrr ensdomtr syldan pm2.61dan ) CDEZFZGCHIZJZABHIZB
      CQIZJZJZBGQIZABKZCQIZVLVMJVNGQIZVGVOVLVMAGQIZVPVLVIVMVQVHVIVJLZABGMNABOPV
      FVGVKVMUAVNGCUBRVLVMUCZGBHIZVOVLVTVSVLGVEFZBVEFZVTVSUDGUEFWAUFGUGUIVLVFBC
      HIZWBVFVGVKUHVJWCVHVIBCUJUKCBULRZGBUMUNUOVLVTJZVNBSIVJVOWEVNBAKZBSABUPWEW
      BVTVIWFBSIVLWBVTWDTVLVTUQVLVIVTVRTBAUSURUTVHVIVJVTVAVNBCVBRVCVD $.

    $( The union of two sets that are strictly dominated by the infinite set
       ` X ` is also strictly dominated by ` X ` .  (Contributed by Mario
       Carneiro, 3-May-2015.) $)
    infunsdom $p |- ( ( ( X e. dom card /\ om ~<_ X ) /\
      ( A ~< X /\ B ~< X ) ) -> ( A u. B ) ~< X ) $=
      ( ccrd cdm wcel com cdom wbr wa csdm sdomdom infunsdom1 anass1rs adantlrl
      cun sylan2 wn numdom syl2anc wb simpll ad2antll ad2antrl domtri2 syl5eqbr
      biimpar uncom adantlrr syldan pm2.61dan ) CDEZFZGCHIZJZACKIZBCKIZJZJZABKI
      ZABPZCKIZUTUSABHIZVBABLUOUQVCVBUPUOVCUQVBABCMNOQUSUTRZBAHIZVBUSVEVDUSBULF
      ZAULFZVEVDUAUSUMBCHIZVFUMUNURUBZUQVHUOUPBCLUCCBSTUSUMACHIZVGVIUPVJUOUQACL
      UDCASTBAUETUGUOUPVEVBUQUOVEUPVBUOVEUPJJVABAPCKABUHBACMUFNUIUJUK $.

    $( Absorption law for multiplication with an infinite cardinal.  Equivalent
       to Proposition 10.41 of [TakeutiZaring] p. 95.  (Contributed by NM,
       28-Sep-2004.)  (Revised by Mario Carneiro, 29-Apr-2015.) $)
    infxp $p |- ( ( ( A e. dom card /\ om ~<_ A ) /\
      ( B e. dom card /\ B =/= (/) ) ) -> ( A X. B ) ~~ ( A u. B ) ) $=
      ( ccrd wcel com cdom wbr wne cxp cun cen infxpabs infunabs adantrl ensymd
      wa c0 entr syl2anc ad2ant2r csdm sdomdom wi 3expa expr syl5 wn wb domtri2
      cdm xpcomeng adantr simplrl simplr domtr sylan infn0 ad3antlr simpr uncom
      syl22anc syl3anc syl5eqbr ex sylbird pm2.61d ) ACUJZDZEAFGZPZBVGDZBQHZPZP
      ZBAUAGZABIZABJZKGZVOBAFGZVNVRBAUBVJVLVSVRUCVKVJVLVSVRVJVLVSPPZVPAKGAVQKGV
      RABLVTVQAVJVSVQAKGZVLVHVIVSWAABMUDNOVPAVQRSUENUFVNVOUGZABFGZVRVHVKWCWBUHV
      IVLABUITVNWCVRVNWCPZVPBAIZKGZWEVQKGZVRVNWFWCVHVKWFVIVLABVGVGUKTULWDWEBKGZ
      BVQKGWGWDVKEBFGZAQHZWCWHVJVKVLWCUMZVNVIWCWIVHVIVMUNEABUOUPZVIWJVHVMWCAUQU
      RVNWCUSZBALVAWDVQBWDVQBAJZBKABUTWDVKWIWCWNBKGWKWLWMBAMVBVCOWEBVQRSVPWEVQR
      SVDVEVF $.
  $}

  ${
    $( A property of dominance over a powerset, and a main lemma for ~ gchac .
       Similar to Lemma 2.3 of [KanamoriPincus] p. 420.  (Contributed by Mario
       Carneiro, 15-May-2015.) $)
    pwcdadom $p |- ( ~P ( A +c A ) ~<_ ( A +c B ) -> ~P A ~<_ B ) $=
      ( ccda co cpw cdom wbr c1o csn cxp cen c0 cwdom wn cvv wcel ax-mp xpsneng
      wceq syl canthwdom wi wa 0elpw n0i dom0 mtbir wfn cdafn fndm ndmov breq2d
      cdm mtbiri con4i simpld 0ex sylancl endom domwdom wdomtr expcom 4syl mtoi
      cun wo wb pwcdaen syl2anc domen1 ibi cdaval breqtrd unxpwdom ord mpd con0
      simprd 1on domentr ) AACDZEZABCDZFGZAEZBHIJZFGZWFBKGZWEBFGWDWEALIJZMGZNWG
      WDWJWEAMGZAUAWDWIAKGZWIAFGWIAMGZWJWKUBWDAOPZLOPWLWDWNBOPZWNWOUCZWDWPNZWDW
      BLFGZWRWBLSZLWBPWSNWAUDWBLUEQWBUFUGWQWCLWBFABOCCOOJZUHCUMWTSUIWTCUJQUKULU
      NUOZUPZUQALOORURWIAUSWIAUTWJWMWKWEWIAVAVBVCVDWDWJWGWDWEWEJZWIWFVEZFGWJWGV
      FWDXCWCXDFWDXCWCFGZWDWBXCKGZWDXEVGWDWNWNXFXBXBAAOOVHVIWBXCWCVJTVKWDWPWCXD
      SXAABOOVLTVMWEWIWFVNTVOVPWDWOHVQPWHWDWNWOXAVRVSBHOVQRURWEWFBVTVI $.
  $}

  ${
    $d x y A $.
    $( Every infinite set has an equinumerous proper subset, proved without AC
       or Infinity.  Exercise 7 of [TakeutiZaring] p. 91.  See also
       ~ infpssALT .  (Contributed by NM, 23-Oct-2004.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    infpss $p |- ( om ~<_ A -> E. x ( x C. A /\ x ~~ A ) ) $=
      ( vy com cdom wbr cv wcel cen wa wex c0 wne infn0 n0 sylib csn cvv adantr
      wpss cdif reldom brrelex2i difexg syl simpr difsnpss infdifsn wceq psseq1
      jca breq1 anbi12d spcegv sylc exlimddv ) DBEFZCGZBHZAGZBTZUTBIFZJZAKZCUQB
      LMUSCKBNCBOPUQUSJZBURQZUAZRHZVGBTZVGBIFZJZVDUQVHUSUQBRHVHDBEUBUCBVFRUDUES
      VEVIVJVEUSVIUQUSUFURBUGPUQVJUSBURUHSUKVCVKAVGRUTVGUIVAVIVBVJUTVGBUJUTVGBI
      ULUMUNUOUP $.
  $}

  ${
    $d f x A $.  $d f x B $.
    $( An exponentiation law for infinite cardinals.  Similar to Lemma 6.2 of
       [Jech] p. 43.  Although this version of ~ infmap avoids the axiom of
       choice, it requires the powerset of an infinite set to be well-orderable
       and so is usually not applicable.  (Contributed by NM, 1-Oct-2004.)
       (Revised by Mario Carneiro, 30-Apr-2015.) $)
    infmap2 $p |- ( ( om ~<_ A /\ B ~<_ A /\ ( A ^m B ) e. dom card ) ->
                      ( A ^m B ) ~~ { x | ( x C_ A /\ x ~~ B ) } ) $=
      ( vf com cdom wbr cmap wcel wss cen wa cab c0 wceq cvv reldom syl syl2anc
      c1o co ccrd cdm w3a cv oveq2 breq2 anbi2d abbidv breq12d wne cxp brrelexi
      simpl2 brrelex2i xpcomeng simpl3 mapdom3 syl3anc numdom infxpabs syl22anc
      simpr simpl1 entr ssenen relen abid2 elmapi fssxp wfun ffun fundmen ensym
      wf vex 3syl fdm breqtrd jca ss2abi eqsstr3i ssdomg ee10 domentr cmpt ovex
      crn mptex rnex wrex wex wf1o ad2antll bren f1of adantl simplrl fss elmapg
      sylib wb ad2antrr mpbird wfo f1ofo eqcomd ex eximdv df-rex sylibr ss2abdv
      forn eqid rnmpt syl6sseqr mpsyl wral rgenw fnmpt mp1i dffn4 fodomnum sylc
      mpd wfn domtr sbth 3ad2ant1 map0e 1onn elexi enref csn df-sn df1o2 anbi2i
      en0 0ss sseq1 mpbiri pm4.71ri bitr4i 3eqtr4ri breqtrri syl6eqbr pm2.61ne
      abbii ) EBFGZCBFGZBCHUAZUBUCZIZUDZUUKAUEZBJZUUOCKGZLZAMZKGZBNHUAZUUPUUONK
      GZLZAMZKGCNCNOZUUKUVAUUSUVDKCNBHUFUVEUURUVCAUVEUUQUVBUUPCNUUOKUGUHUIUJUUN
      CNUKZLZUUKUUSFGZUUSUUKFGZUUTUVGUUKUUOCBULZJZUUQLZAMZFGZUVMUUSKGZUVHUVGUVM
      PIZUUKUVMJUVNUVGUVOUVPUVGUVJBKGZUVOUVGUVJBCULZKGZUVRBKGZUVQUVGCPIZBPIZUVS
      UVGUUJUWAUUIUUJUUMUVFUNZCBFQUMRZUVGUUJUWBUWCCBFQUORZCBPPUPSUVGBUULIZUUIUV
      FUUJUVTUVGUUMBUUKFGZUWFUUIUUJUUMUVFUQZUVGUWBUWAUVFUWGUWEUWDUUNUVFVCZBCPPU
      RUSUUKBUTSUUIUUJUUMUVFVDUWIUWCBCVAVBUVJUVRBVESAUVJBCVFRZUVMUUSKVGUMRUUKUU
      OUUKIZAMUVMAUUKVHUWKUVLAUWKCBUUOVOZUVLUUOBCVIUWLUVKUUQCBUUOVJUWLUUOUUOUCZ
      CKUWLUUOVKUWMUUOKGUUOUWMKGCBUUOVLUUOAVPVMUWMUUOVNVQCBUUOVRVSVTRWAWBUUKUVM
      PWCWDUWJUUKUVMUUSWESUVGUUSDUUKDUEZWHZWFZWHZFGZUWQUUKFGZUVIUWQPIUVGUUSUWQJ
      UWRUWPDUUKUWOBCHWGWIWJUVGUUSUUOUWOOZDUUKWKZAMUWQUVGUURUXAAUVGUURUXAUVGUUR
      LZUWNUUKIZUWTLZDWLZUXAUXBCUUOUWNWMZDWLZUXEUXBCUUOKGZUXGUUQUXHUVGUUPUUOCVN
      WNCUUODWOXAUXBUXFUXDDUXBUXFUXDUXBUXFLZUXCUWTUXIUXCCBUWNVOZUXICUUOUWNVOZUU
      PUXJUXFUXKUXBCUUOUWNWPWQUVGUUPUUQUXFWRCUUOBUWNWSSUVGUXCUXJXBZUURUXFUVGUWB
      UWAUXLUWEUWDBCUWNPPWTSXCXDUXIUWOUUOUXFUWOUUOOZUXBUXFCUUOUWNXEUXMCUUOUWNXF
      CUUOUWNXMRWQXGVTXHXIYEUWTDUUKXJXKXHXLDAUUKUWOUWPUWPXNZXOXPUUSUWQPWCXQUVGU
      UMUUKUWQUWPXEZUWSUWHUVGUWPUUKYFZUXOUWOPIZDUUKXRUXPUVGUXQDUUKUWNDVPWJXSDUU
      KUWOUWPPUXNXTYAUUKUWPYBXAUUKUWQUWPYCYDUUSUWQUUKYGSUUKUUSYHSUUNUVATUVDKUUN
      UWBUVATOUUIUUJUWBUUMEBFQUOYIBPYJRTTUVDKTTEYKYLYMNYNUUONOZAMTUVDANYOYPUVCU
      XRAUVCUUPUXRLUXRUVBUXRUUPUUOYRYQUXRUUPUXRUUPNBJBYSUUONBYTUUAUUBUUCUUHUUDU
      UEUUFUUG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The Ackermann bijection
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F a b c x y $.  $d G a b c x y $.  $d H a b c x y $.  $d A a b c x y $.
    $d B a b c x y $.
    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij2lem1 $p |- ( A e. om -> ~P A C_ ( ~P om i^i Fin ) ) $=
      ( va com wcel cpw cfn cin cv wa wss word ordom ordelss sspwb sylib sselda
      mpan nnfi elpwi ssfi syl2an elin sylanbrc ex ssrdv ) ACDZBAEZCEZFGZUFBHZU
      GDZUJUIDZUFUKIUJUHDUJFDZULUFUGUHUJUFACJZUGUHJCKUFUNLCAMQACNOPUFAFDUJAJUMU
      KARUJASAUJTUAUJUHFUBUCUDUE $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem1 $p |- ( -. A e. B -> ( B i^i suc A ) = ( B i^i A ) ) $=
      ( wcel wn csuc cin csn cun df-suc ineq2i indi eqtri c0 wceq disjsn uneq2d
      biimpri un0 syl6eq syl5eq ) ABCDZBAEZFZBAFZBAGZFZHZUDUCBAUEHZFUGUBUHBAIJB
      AUEKLUAUGUDMHUDUAUFMUDUFMNUABAOQPUDRST $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem2 $p |- ( A e. B -> ( B i^i suc A ) =
        ( { A } u. ( B i^i A ) ) ) $=
      ( wcel csuc cin csn cun df-suc ineq2i indi uncom 3eqtri wss snssi sseqin2
      wceq sylib uneq1d syl5eq ) ABCZBADZEZBAFZEZBAEZGZUCUEGUBBAUCGZEUEUDGUFUAU
      GBAHIBAUCJUEUDKLTUDUCUETUCBMUDUCPABNUCBOQRS $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem3 $p |- ( A e. om -> A e. ( ~P om i^i Fin ) ) $=
      ( com wcel cpw cfn cin wss word ordom ordelss mpan elpwg mpbird nnfi elin
      sylanbrc ) ABCZABDZCZAECAREFCQSABGZBHQTIBAJKABBLMANAREOP $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 19-Nov-2014.) $)
    ackbij1lem4 $p |- ( A e. om -> { A } e. ( ~P om i^i Fin ) ) $=
      ( com wcel csn cpw cfn cin snelpwi snfi a1i elin sylanbrc ) ABCZADZBEZCNF
      CZNOFGCABHPMAIJNOFKL $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 19-Nov-2014.) $)
    ackbij1lem5 $p |- ( A e. om -> ( card ` ~P suc A ) =
        ( ( card ` ~P A ) +o ( card ` ~P A ) ) ) $=
      ( va csuc cpw ccrd cfv coa co wceq com wcel cen wbr c2o cxp cmap cvv entr
      syl syl2anc cv suceq pweqd fveq2d pweq oveq12d eqeq12d ccda vex sucex csn
      pw2en cun df-suc oveq2i word cin c0 nnord orddisj snex 2onn elexi mapunen
      wi w3a ex mp3an 3syl ovex enref mapsnen xpen mp2an sylancl ensymi sylancr
      syl5eqbr pwex xp2cda ax-mp syl6breq nnfi pwfi sylib ficardid cdaen ensymd
      cfn carden2b ficardom nnacda eqtrd vtoclga ) BUAZCZDZEFZWODZEFZWTGHZIACZD
      ZEFZADZEFZXFGHZIBAJWOAIZWRXDXAXGXHWQXCEXHWPXBWOAUBUCUDXHWTXFWTXFGXHWSXEEW
      OAUEUDZXIUFUGWOJKZWRWTWTUHHZEFZXAXJWQXKLMZWRXLIXJWQWSWSUHHZLMXNXKLMXMXJWQ
      WSNOZXNLXJWQNWPPHZLMXPXOLMZWQXOLMWPWOBUIZUJULXJXPNWOPHZNOZLMXTXOLMXQXJXPN
      WOWOUKZUMZPHZXTLWPYBNPWOUNUOXJYCXSNYAPHZOZLMZYEXTLMZYCXTLMXJWOUPWOYAUQURI
      ZYFWOUSWOUTWOQKZYAQKZNQKZYHYFVEXRWOVANJVBVCZYIYJYKVFYHYFWOYANQQQVDVGVHVIX
      SXSLMYDNLMYGXSNWOPVJVKNWOYLXRVLXSXSYDNVMVNYCYEXTRVOVRXOXTWSXSLMNNLMXOXTLM
      WOXRULNYLVKWSXSNNVMVNVPXPXTXORVOWQXPXORVQWSQKXOXNIWOXRVSWSQVTWAWBXJXKXNXJ
      WTWSLMZYMXKXNLMXJWSWIKZYMXJWOWIKYNWOWCWOWDWEZWSWFSZYPWTWSWTWSWGTWHWQXNXKR
      TWQXKWJSXJWTJKZYQXLXAIXJYNYQYOWSWKSZYRWTWTWLTWMWN $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem6 $p |- ( ( A e. ( ~P om i^i Fin ) /\
          B e. ( ~P om i^i Fin ) ) ->
        ( A u. B ) e. ( ~P om i^i Fin ) ) $=
      ( com cpw cfn cin wcel cun wss inss1 sseli elpwi simpl simpr unssd syl2an
      wa wb inss2 unfi elpwg syl mpbird elin sylanbrc ) ACDZEFZGZBUGGZQZABHZUFG
      ZUKEGZUKUGGUJULUKCIZUHAUFGZBUFGZUNUIUGUFAUFEJZKUGUFBUQKUOACIZBCIZUNUPACLB
      CLURUSQABCURUSMURUSNOPPUJUMULUNRUHAEGBEGUMUIUGEAUFESZKUGEBUTKABTPZUKCEUAU
      BUCVAUKUFEUDUE $.

    ackbij.f $e |- F = ( x e. ( ~P om i^i Fin ) |->
        ( card ` U_ y e. x ( { y } X. ~P y ) ) ) $.
    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 21-Nov-2014.) $)
    ackbij1lem7 $p |- ( A e. ( ~P om i^i Fin ) -> ( F ` A ) =
        ( card ` U_ y e. A ( { y } X. ~P y ) ) ) $=
      ( cv csn cpw cxp ciun ccrd cfv com cfn cin wceq iuneq1 fveq2d fvex fvmpt
      ) ACBAFZBFZGUBHIZJZKLBCUCJZKLMHNODUACPUDUEKBUACUCQREUEKST $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 19-Nov-2014.) $)
    ackbij1lem8 $p |- ( A e. om -> ( F ` { A } ) = ( card ` ~P A ) ) $=
      ( va cv csn cfv cpw ccrd wceq com sneq fveq2d pweq eqeq12d wcel cxp cvv
      ciun cfn cin ackbij1lem4 ackbij1lem7 syl vex xpeq12d iunxsn pwex xpsnen2g
      fveq2i cen wbr mp2an carden2b ax-mp eqtri syl6eq vtoclga ) FGZHZDIZVAJZKI
      ZLCHZDIZCJZKIZLFCMVACLZVCVGVEVIVJVBVFDVACNOVJVDVHKVACPOQVAMRZVCBVBBGZHZVL
      JZSZUAZKIZVEVKVBMJUBUCRVCVQLVAUDABVBDEUEUFVQVBVDSZKIZVEVPVRKBVAVOVRFUGZVL
      VALVMVBVNVDVLVANVLVAPUHUIULVRVDUMUNZVSVELVATRVDTRWAVTVAVTUJVAVDTTUKUOVRVD
      UPUQURUSUT $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 19-Nov-2014.) $)
    ackbij1lem9 $p |- ( ( A e. ( ~P om i^i Fin ) /\ B e. ( ~P om i^i Fin ) /\
          ( A i^i B ) = (/) ) ->
        ( F ` ( A u. B ) ) = ( ( F ` A ) +o ( F ` B ) ) ) $=
      ( com cfn cin wcel wceq ciun ccrd cfv co cen wbr sseli syl2anc syl cpw c0
      w3a cun cv csn cxp coa ccda wral inss2 3ad2ant1 wa snfi inss1 elpwid con0
      wss onfin2 eqsstri syl6ss sselda pwfi sylib xpfi ralrimiva iunfi ficardid
      sylancr 3ad2ant2 cdaen djudisj 3ad2ant3 syl3anc iunxun syl6breqr carden2b
      cdaun entr ficardom nnacda eqtr3d ackbij1lem6 3adant3 ackbij1lem7 3eqtr4d
      oveqan12d ) CGUAZHIZJZDWIJZCDIUBKZUCZBCDUDZBUEZUFZWOUAZUGZLZMNZBCWRLZMNZB
      DWRLZMNZUHOZWNENZCENZDENZUHOZWMXBXDUIOZMNZWTXEWMXJWSPQZXKWTKWMXJXAXCUIOZP
      QZXMWSPQXLWMXBXAPQZXDXCPQZXNWMXAHJZXOWMCHJZWRHJZBCUJXQWJWKXRWLWIHCWHHUKZR
      ULWMXSBCWMWOCJUMZWPHJZWQHJZXSWOUNZYAWOHJZYCWMCHWOWMCGHWJWKCGURWLWJCGWIWHC
      WHHUOZRUPULGUQHIHUSUQHUKUTZVAVBWOVCZVDWPWQVEZVIVFBCWRVGSZXAVHTWMXCHJZXPWM
      DHJZXSBDUJYKWKWJYLWLWIHDXTRVJWMXSBDWMWODJUMZYBYCXSYDYMYEYCWMDHWOWMDGHWKWJ
      DGURWLWKDGWIWHDYFRUPVJYGVAVBYHVDYIVIVFBDWRVGSZXCVHTXBXAXDXCVKSWMXMXAXCUDZ
      WSPWMXQYKXAXCIUBKZXMYOPQYJYNWLWJYPWKBBCDWQWQVLVMXAXCHHVRVNBCDWRVOVPXJXMWS
      VSSXJWSVQTWMXBGJZXDGJZXKXEKWMXQYQYJXAVTTWMYKYRYNXCVTTXBXDWASWBWMWNWIJZXFW
      TKWJWKYSWLCDWCWDABWNEFWETWJWKXIXEKWLWJWKXGXBXHXDUHABCEFWEABDEFWEWGWDWF $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem10 $p |- F : ( ~P om i^i Fin ) --> om $=
      ( com cpw cfn cin cv csn cxp ciun ccrd cfv wcel wral inss2 sseli wel con0
      wa snfi inss1 elpwid onfin2 eqsstri syl6ss sselda pwfi sylib xpfi sylancr
      ralrimiva iunfi syl2anc ficardom syl fmpti ) AEFZGHZEBAIZBIZJZVBFZKZLZMNZ
      CDVAUTOZVFGOZVGEOVHVAGOVEGOZBVAPVIUTGVAUSGQRVHVJBVAVHBASUAZVCGOVDGOZVJVBU
      BVKVBGOVLVHVAGVBVHVAEGVHVAEUTUSVAUSGUCRUDETGHGUETGQUFUGUHVBUIUJVCVDUKULUM
      BVAVEUNUOVFUPUQUR $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem11 $p |- ( ( A e. ( ~P om i^i Fin ) /\ B C_ A ) ->
        B e. ( ~P om i^i Fin ) ) $=
      ( com cpw cfn cin wcel wss wa inss1 sseli elpwid sstr sylan2 cvv wb ssexg
      elpwg syl mpbird ancoms inss2 ssfi sylan elin sylanbrc ) CGHZIJZKZDCLZMDU
      KKZDIKZDULKUNUMUOUNUMMZUODGLZUMUNCGLURUMCGULUKCUKINOPDCGQRUQDSKUOURTDCULU
      ADGSUBUCUDUEUMCIKUNUPULICUKIUFOCDUGUHDUKIUIUJ $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem12 $p |- ( ( B e. ( ~P om i^i Fin ) /\ A C_ B ) ->
        ( F ` A ) C_ ( F ` B ) ) $=
      ( com cpw cfn cin wcel wss cfv cdif coa ackbij1lem11 ffvelrn sylancr wceq
      wa co ackbij1lem10 difssd syldan nnaword1 syl2anc cun disjdif ackbij1lem9
      wf c0 a1i syl3anc undif biimpi adantl fveq2d eqtr3d sseqtrd ) DGHIJZKZCDL
      ZTZCEMZVDDCNZEMZOUAZDEMZVCVDGKZVFGKZVDVGLVCUTGEUJZCUTKZVIABEFUBZABDCEFPZU
      TGCEQRVCVKVEUTKZVJVMVAVBVEDLVOVCDCUCABDVEEFPUDZUTGVEEQRVDVFUEUFVCCVEUGZEM
      ZVGVHVCVLVOCVEJUKSZVRVGSVNVPVSVCCDUHULABCVEEFUIUMVCVQDEVBVQDSZVAVBVTCDUNU
      OUPUQURUS $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem13 $p |- ( F ` (/) ) = (/) $=
      ( c0 cfv coa co wceq cun com wcel cpw cfn ackbij1lem10 peano1 f0cli ax-mp
      cin mp3an nna0 un0 fveq2i ackbij1lem3 ackbij1lem9 3eqtr2ri wb nnacan mpbi
      in0 ) ECFZUKGHZUKEGHZIZUKEIZUMUKEEJZCFZULUKKLZUMUKIKMNSZKECABCDOPQZUKUARU
      PECEUBUCEUSLZVAEESEIUQULIEKLZVAPEUDRZVCEUJABEECDUETUFURURVBUNUOUGUTUTPUKU
      KEUHTUI $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem14 $p |- ( A e. om -> ( F ` { A } ) = suc ( F ` A ) ) $=
      ( com wcel cfv cpw ccrd csuc wceq pweq fveq2d fveq2 suceq syl coa adantr
      c0 va vb csn ackbij1lem8 cv eqeq12d weq c1o df-1o pw0 fveq2i cardsn ax-mp
      cvv 0ex eqtri ackbij1lem13 3eqtr4i wa oveq2 adantl ackbij1lem5 cun df-suc
      equncomi cfn ackbij1lem4 ackbij1lem3 incom word nnord orddisj ackbij1lem9
      cin syl5eq syl3anc oveq1d eqtrd nnfi sylib ficardom ackbij1lem10 ffvelrni
      co pwfi nnasuc syl2anc eqtr4d 3eqtr4d ex finds ) CFGCUCDHCIZJHZCDHZKZABCD
      EUDUAUEZIZJHZWPDHZKZLTIZJHZTDHZKZLUBUEZIZJHZXEDHZKZLZXEKZIZJHZXKDHZKZLZWM
      WOLUAUBCWPTLZWRXBWTXDXQWQXAJWPTMNXQWSXCLWTXDLWPTDOWSXCPQUFUAUBUGZWRXGWTXI
      XRWQXFJWPXEMNXRWSXHLWTXILWPXEDOWSXHPQUFWPXKLZWRXMWTXOXSWQXLJWPXKMNXSWSXNL
      WTXOLWPXKDOWSXNPQUFWPCLZWRWMWTWOXTWQWLJWPCMNXTWSWNLWTWOLWPCDOWSWNPQUFUHTK
      ZXBXDUIXBTUCZJHZUHXAYBJUJUKTUNGYCUHLUOTUNULUMUPXCTLXDYALABDEUQXCTPUMURXEF
      GZXJXPYDXJUSZXGXGRWDZXGXIRWDZXMXOXJYFYGLYDXGXIXGRUTVAYDXMYFLXJXEVBSYEXOXG
      XHRWDZKZYGYEXNYHLXOYILYEXNXEUCZXEVCZDHZYHXKYKDXKXEYJXEVDVEUKYEYLYJDHZXHRW
      DZYHYEYJFIVFVNZGZXEYOGZYJXEVNZTLZYLYNLYDYPXJXEVGSYDYQXJXEVHSZYDYSXJYDYRXE
      YJVNZTYJXEVIYDXEVJUUATLXEVKXEVLQVOSABYJXEDEVMVPYEYMXGXHRYDYMXGLXJABXEDEUD
      SVQVRVOXNYHPQYEXGFGZXHFGZYGYILYEXFVFGZUUBYDUUDXJYDXEVFGUUDXEVSXEWEVTSXFWA
      QYEYQUUCYTYOFXEDABDEWBWCQXGXHWFWGWHWIWJWKVR $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem15 $p |- ( ( ( A e. ( ~P om i^i Fin ) /\
          B e. ( ~P om i^i Fin ) ) /\ ( c e. om /\ c e. A /\ -. c e. B ) ) ->
        -. ( F ` ( A i^i suc c ) ) = ( F ` ( B i^i suc c ) ) ) $=
      ( com cpw cin wcel wa csuc cfv wss syl wceq ackbij1lem12 syl2anc wpss cfn
      cv wn w3a simpr1 ackbij1lem3 simpr3 ackbij1lem1 syl6eqss csn ackbij1lem10
      inss2 con0 ffvelrni nnon onpsssuc 4syl ackbij1lem14 psseq2d mpbird simpll
      inss1 ackbij1lem11 sylancl cun ssun1 simpr2 ackbij1lem2 psssstrd sspsstrd
      syl5sseqr pssned necomd neneqd ) CHIUAJZKZDVOKZLZFUBZHKZVSCKZVSDKUCZUDZLZ
      CVSMZJZENZDWEJZENZWDWIWGWDWIWGWDWIVSENZWGWDVSVOKZWHVSOWIWJOWDVTWKVRVTWAWB
      UEZVSUFPZWDWHDVSJZVSWDWBWHWNQVRVTWAWBUGVSDUHPDVSULUIABWHVSEGRSWDWJVSUJZEN
      ZWGWDWJWPTWJWJMZTZWDWKWJHKWJUMKWRWMVOHVSEABEGUKUNWJUOWJUPUQWDWPWQWJWDVTWP
      WQQWLABVSEGURPUSUTWDWFVOKZWOWFOWPWGOWDVPWFCOWSVPVQWCVACWEVBABCWFEGVCVDWDW
      OCVSJZVEZWOWFWOWTVFWDWAWFXAQVRVTWAWBVGVSCVHPVKABWOWFEGRSVIVJVLVMVN $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem16 $p |- ( ( A e. ( ~P om i^i Fin ) /\ B e. ( ~P om i^i Fin ) )
        ->
        ( ( F ` A ) = ( F ` B ) -> A = B ) ) $=
      ( com cfn cin wcel cfv wceq wi wss syl c0 ineq2 fveq2d eqeq12d w3a va cpw
      vb cun cuni csuc inss1 sseli elpwid adantr adantl unssd inss2 unfi syl2an
      wa nnunifi syl2anc peano2 cv imbi12d imbi2d weq in0 eqtr4i csn coa simp13
      a1ii co 3simpa ackbij1lem2 3ad2ant2 ackbij1lem4 simprl ackbij1lem11 incom
      sylancl word nnord orddisj ssdisj sylancr syl5eq syl3anc 3ad2ant1 syl3an1
      ackbij1lem9 eqtrd 3ad2ant3 simprr 3eqtr3d wb ackbij1lem10 ffvelrni nnacan
      3adant3 mpbid uneq2 ad2antrr ad2antlr 3eqtr4d 3adant1 embantd 3exp eqcomd
      ex wn simp12r simp12l simp11 simp3 ackbij1lem15 syl23anc pm2.21dd pm2.61d
      simp2 ackbij1lem1 biimpd mpd biimprd com34 finds mpcom con0 omsson syl6ss
      a2d onsucuni unssad df-ss sylib unssbd 3imtr3d ) CGUBZHIZJZDYPJZUPZCCDUDZ
      UEZUFZIZEKZDUUBIZEKZLZUUCUUELZCEKZDEKZLCDLUUBGJZYSUUGUUHMZYSUUAGJZUUKYSYT
      GNYTHJZUUMYSCDGYQCGNYRYQCGYPYOCYOHUGZUHUIUJYRDGNYQYRDGYPYODUUOUHUIUKULZYQ
      CHJDHJUUNYRYPHCYOHUMZUHYPHDUUQUHCDUNUOYTUQURUUAUSOYSCUAUTZIZEKZDUURIZEKZL
      ZUUSUVALZMZMYSCPIZEKZDPIZEKZLZUVFUVHLZMZMYSCUCUTZIZEKZDUVMIZEKZLZUVNUVPLZ
      MZMYSCUVMUFZIZEKZDUWAIZEKZLZUWBUWDLZMZMYSUULMUAUCUUBUURPLZUVEUVLYSUWIUVCU
      VJUVDUVKUWIUUTUVGUVBUVIUWIUUSUVFEUURPCQZRUWIUVAUVHEUURPDQZRSUWIUUSUVFUVAU
      VHUWJUWKSVAVBUAUCVCZUVEUVTYSUWLUVCUVRUVDUVSUWLUUTUVOUVBUVQUWLUUSUVNEUURUV
      MCQZRUWLUVAUVPEUURUVMDQZRSUWLUUSUVNUVAUVPUWMUWNSVAVBUURUWALZUVEUWHYSUWOUV
      CUWFUVDUWGUWOUUTUWCUVBUWEUWOUUSUWBEUURUWACQZRUWOUVAUWDEUURUWADQZRSUWOUUSU
      WBUVAUWDUWPUWQSVAVBUURUUBLZUVEUULYSUWRUVCUUGUVDUUHUWRUUTUUDUVBUUFUWRUUSUU
      CEUURUUBCQZRUWRUVAUUEEUURUUBDQZRSUWRUUSUUCUVAUUEUWSUWTSVAVBYSUVJUVKUVFPUV
      HCVDDVDVEVIUVMGJZYSUVTUWHUXAYSUWFUVTUWGUXAYSUWFUVTUWGMZUXAYSUWFTZUVMDJZUX
      BUXCUVMCJZUXDUXBMUXCUXEUXDUXBUXCUXEUXDTZUVRUVSUWGUXFUVMVFZEKZUVOVGVJZUXHU
      VQVGVJZLZUVRUXFUWCUWEUXIUXJUXAYSUWFUXEUXDVHUXCUXAYSUPZUXEUXDUWCUXILUXAYSU
      WFVKZUXLUXEUXDTZUWCUXGUVNUDZEKZUXIUXEUXLUWCUXPLUXDUXEUWBUXOEUVMCVLZRVMUXL
      UXEUXPUXILZUXDUXLUXGYPJZUVNYPJZUXGUVNIZPLUXRUXAUXSYSUVMVNUJZUXLYQUVNCNUXT
      UXAYQYRVOCUVMUGABCUVNEFVPVRZUXLUYAUVNUXGIZPUXGUVNVQUXLUVNUVMNUVMUXGIPLZUY
      DPLCUVMUMUXAUYEYSUXAUVMVSUYEUVMVTUVMWAOUJZUVNUVMUXGWBWCWDABUXGUVNEFWHWEWF
      WIWGUXCUXLUXEUXDUWEUXJLUXMUXNUWEUXGUVPUDZEKZUXJUXDUXLUWEUYHLUXEUXDUWDUYGE
      UVMDVLZRWJUXLUXEUYHUXJLZUXDUXLUXSUVPYPJZUXGUVPIZPLUYJUYBUXLYRUVPDNUYKUXAY
      QYRWKDUVMUGABDUVPEFVPVRZUXLUYLUVPUXGIZPUXGUVPVQUXLUVPUVMNUYEUYNPLDUVMUMUY
      FUVPUVMUXGWBWCWDABUXGUVPEFWHWEWFWIWGWLUXCUXEUXKUVRWMZUXDUXAYSUYOUWFUXLUXH
      GJZUVOGJZUVQGJZUYOUXLUXSUYPUYBYPGUXGEABEFWNZWOOUXLUXTUYQUYCYPGUVNEUYSWOOU
      XLUYKUYRUYMYPGUVPEUYSWOOUXHUVOUVQWPWEWQWFWRUXEUXDUVSUWGMZUXCUXEUXDUPZUVSU
      WGVUAUVSUPUXOUYGUWBUWDUVSUXOUYGLVUAUVNUVPUXGWSUKUXEUWBUXOLUXDUVSUXQWTUXDU
      WDUYGLUXEUVSUYIXAXBXGXCXDXEUXCUXEXHZUXDUXBUXCVUBUXDTZUWEUWCLZUXBVUCUWCUWE
      UXAYSUWFVUBUXDVHXFVUCYRYQUXAUXDVUBVUDXHYQYRUXAUWFVUBUXDXIYQYRUXAUWFVUBUXD
      XJUXAYSUWFVUBUXDXKUXCVUBUXDXLUXCVUBUXDXQABDCEUCFXMXNXOXEXPUXCUXEUXDXHZUXB
      MUXCUXEVUEUXBUXCUXEVUETZUWFUXBUXAYSUWFUXEVUEVHVUFYQYRUXAUXEVUEUWFXHYQYRUX
      AUWFUXEVUEXJYQYRUXAUWFUXEVUEXIUXAYSUWFUXEVUEXKUXCUXEVUEXQUXCUXEVUEXLABCDE
      UCFXMXNXOXEUXCVUBVUEUXBUXCVUBVUETZUVRUVSUWGVUGUWFUVRUXAYSUWFVUBVUEVHVUBVU
      EUWFUVRMUXCVUBVUEUPZUWFUVRVUHUWCUVOUWEUVQVUHUWBUVNEVUBUWBUVNLVUEUVMCXRUJZ
      RVUHUWDUVPEVUEUWDUVPLVUBUVMDXRUKZRSXSXCXTVUBVUEUYTUXCVUHUWGUVSVUHUWBUVNUW
      DUVPVUIVUJSYAXCXDXEXPXPXEYBYHYCYDYSUUDUUIUUFUUJYSUUCCEYSCUUBNUUCCLYSCDUUB
      YSYTYENYTUUBNYSYTGYEUUPYFYGYTYIOZYJCUUBYKYLZRYSUUEDEYSDUUBNUUEDLYSCDUUBVU
      KYMDUUBYKYLZRSYSUUCCUUEDVULVUMSYN $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem17 $p |- F : ( ~P om i^i Fin ) -1-1-> om $=
      ( va vb com cpw cfn cin wf1 wf cv cfv wceq wral ackbij1lem10 ackbij1lem16
      weq wi rgen2a dff13 mpbir2an ) GHIJZGCKUDGCLEMZCNFMZCNOEFSTZFUDPEUDPABCDQ
      UGEFUDABUEUFCDRUAEFUDGCUBUC $.

    $( Lemma for ~ ackbij1 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1lem18 $p |- ( A e. ( ~P om i^i Fin ) -> E. b e. ( ~P om i^i Fin )
          ( F ` b ) = suc ( F ` A ) ) $=
      ( com cfn cin wcel cun cfv csuc wceq wss c0 wn sylancr syl coa va cpw csn
      cdif cint wrex difss ackbij1lem11 mpan2 con0 wne omsson sstri ominf inss2
      cv sseli difinf 0fin eleq1 necon3bi onint eldifad ackbij1lem4 ackbij1lem6
      mpbiri syl2anc co eldifbd disjsn sylibr ssdisj ackbij1lem9 syl3anc oveq2d
      ackbij1lem14 ackbij1lem10 ffvelrni ackbij1lem3 nnasuc incom disjdif eqtri
      a1i uncom wa wo onnmin mpan con2i adantl word ordom sselda eldif simplbi2
      ordelss orrd orcomd orel1 ex ssrdv undif sylib syl5eq fveq2d eqtr3d suceq
      sylc eqtrd 3eqtrd fveq2 eqeq1d rspcev ) CGUBZHIZJZCGCUDZUEZUDZXSUCZKZXPJZ
      YBDLZCDLZMZNZEUPZDLZYFNZEXPUFXQXTXPJZYAXPJZYCXQXTCOZYKCXSUGZABCXTDFUHUIZX
      QXSGJZYLXQXSGCXQXRUJOZXRPUKZXSXRJXRGUJGCUGULUMZXQXRHJZQZYRXQGHJQCHJUUAUNX
      PHCXOHUOUQGCURRYTXRPXRPNYTPHJUSXRPHUTVFVASXRVBRZVCZXSVDSZXTYAVEVGXQYDXTDL
      ZYADLZTVHZUUEXSDLZMZTVHZYFXQYKYLXTYAIPNZYDUUGNYOUUDXQYMCYAIPNZUUKYNXQXSCJ
      QUULXQXSGCUUBVICXSVJVKXTCYAVLRABXTYADFVMVNXQUUFUUIUUETXQYPUUFUUINUUCABXSD
      FVPSVOXQUUJUUEUUHTVHZMZYFXQUUEGJZUUHGJZUUJUUNNXQYKUUOYOXPGXTDABDFVQZVRSXQ
      XSXPJZUUPXQYPUURUUCXSVSSZXPGXSDUUQVRSUUEUUHVTVGXQUUMYENUUNYFNXQXTXSKZDLZU
      UMYEXQYKUURXTXSIZPNZUVAUUMNYOUUSUVCXQUVBXSXTIPXTXSWAXSCWBWCWDABXTXSDFVMVN
      XQUUTCDXQUUTXSXTKZCXTXSWEXQXSCOUVDCNXQUAXSCXQUAUPZXSJZUVECJZXQUVFWFZUVEXR
      JZQZUVIUVGWGZUVGUVFUVJXQUVIUVFYQUVIUVFQYSXRUVEWHWIWJWKUVHUVEGJZUVKXQXSGUV
      EXQGWLYPXSGOWMUUCGXSWQRWNUVLUVGUVIUVLUVGUVIUVIUVLUVGQUVEGCWOWPWRWSSUVIUVG
      WTXIXAXBXSCXCXDXEXFXGUUMYEXHSXJXKYJYGEYBXPYHYBNYIYDYFYHYBDXLXMXNVG $.

    $( The Ackermann bijection, part 1: each natural number can be uniquely
       coded in binary as a finite set of natural numbers and conversely.
       (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij1 $p |- F : ( ~P om i^i Fin ) -1-1-onto-> om $=
      ( va vb vc com cpw wceq cv wcel c0 csuc eleq1 cfv wrex ax-mp wb fvelrnb
      cfn cin wf1o wf1 crn ackbij1lem17 wf wss f1f frn mp2b peano1 ackbij1lem13
      ackbij1lem3 fveq2 eqeq1d rspcev mp2an wfn mpbir ackbij1lem18 adantl suceq
      wa eqeq2d rexbidv syl5ibcom rexlimdva 3imtr4g finds ssriv dff1o5 mpbir2an
      f1fn eqssi ) HIUAUBZHCUCVPHCUDZCUEZHJABCDUFZVRHVQVPHCUGVRHUHVSVPHCUIVPHCU
      JUKEHVRFKZVRLMVRLZEKZVRLZWBNZVRLZWCFEWBVTMVROVTWBVROZVTWDVROWFWAWBCPZMJZE
      VPQZMVPLZMCPZMJZWIMHLWJULMUNRABCDUMWHWLEMVPWBMJWGWKMWBMCUOUPUQURCVPUSZWAW
      ISVQWMVSVPHCVNRZEVPMCTRUTWBHLZGKZCPZWBJZGVPQZVTCPZWDJZFVPQZWCWEWOWRXBGVPW
      OWPVPLZVDWTWQNZJZFVPQZWRXBXCXFWOABWPCFDVAVBWRXEXAFVPWRXDWDWTWQWBVCVEVFVGV
      HWMWCWSSWNGVPWBCTRWMWEXBSWNFVPWDCTRVIVJVKVOVPHCVLVM $.

    $( The Ackermann bijection, part 1b: the bijection from ~ ackbij1 restricts
       naturally to the powers of particular naturals.  (Contributed by Stefan
       O'Rear, 18-Nov-2014.) $)
    ackbij1b $p |- ( A e. om -> ( F " ~P A ) = ( card ` ~P A ) ) $=
      ( va com wcel cpw cfv wn wceq cen wbr cfn cin wss cvv sylib ax-mp cima wo
      ccrd wpss ackbij2lem1 pwexg wf1 ackbij1lem17 f1imaeng mp3an1 syl2anc nnfi
      pwfi ficardid ensym 3syl entr csdm con0 onfin2 inss2 eqsstri ficardom syl
      wi sseldi php3 ex sdomnen syl6 mt2d cv wral csuc ackbij1lem3 ackbij1lem12
      wa fvex elpwi syl2an wb ackbij1lem10 peano1 f0cli nnord ordsucsssuc mp2an
      word csn ackbij1lem14 ackbij1lem8 eqtr3d adantr sseqtrd sucssel ralrimiva
      mpsyl wfun f1fun f1dm syl6sseqr funimass4 sylancr mpbird sspss orel1 sylc
      cdm ) CGHZDCIZUAZXJUCJZUDZKXMXKXLLZUBZXNXIXMXKXLMNZXIXKXJMNZXJXLMNZXPXIXJ
      GIOPZQZXJRHZXQCUEZCGUFXSGDUGZXTYAXQABDEUHZXSGXJDRUIUJUKXIXJOHZXLXJMNXRXIC
      OHYECULCUMSZXJUNXLXJUOUPXKXJXLUQUKXIXMXKXLURNZXPKXIXLOHZXMYGVEXIGOXLGUSOP
      OUTUSOVAVBXIYEXLGHYFXJVCVDVFYHXMYGXLXKVGVHVDXKXLVIVJVKXIXKXLQZXOXIYIFVLZD
      JZXLHZFXJVMZXIYLFXJYKRHXIYJXJHZVQZYKVNZXLQYLYJDVRYOYPCDJZVNZXLYOYKYQQZYPY
      RQZXICXSHYJCQYSYNCVOYJCVSABYJCDEVPVTYKWHZYQWHZYSYTWAYKGHUUAXSGYJDABDEWBZW
      CWDYKWETYQGHUUBXSGCDUUCWCWDYQWETYKYQWFWGSXIYRXLLYNXICWIDJYRXLABCDEWJABCDE
      WKWLWMWNYKXLRWOWQWPXIDWRZXJDXHZQYIYMWAYCUUDYDXSGDWSTXIXJXSUUEYBYCUUEXSLYD
      XSGDWTTXAFXJXLDXBXCXDXKXLXESXMXNXFXG $.

    ackbij.g $e |- G = ( x e. _V |-> ( y e. ~P dom x |->
          ( F ` ( x " y ) ) ) ) $.
    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij2lem2 $p |- ( A e. om -> ( rec ( G , (/) ) ` A ) :
        ( R1 ` A ) -1-1-onto-> ( card ` ( R1 ` A ) ) ) $=
      ( va cv cr1 cfv ccrd c0 wf1o wceq fveq2 fveq2d com wcel syl vb vc crdg wb
      csuc f1oeq123d f1o0 0ex f1oeq1 ax-mp r10 fveq2i card0 eqtri f1oeq23 mp2an
      rdg0 bitri mpbir cpw cres cima cmpt ccom cfn cin wf1 wss ackbij1lem17 a1i
      wa ficardom ackbij2lem1 f1ores syl2anc ackbij1b cen wbr ficardid carden2b
      r1fin pwen 4syl eqtrd f1oeq3 mpbid adantr f1opw adantl f1oco frsuc peano2
      cdm fvres fvex dmeq pweqd imaeq1 mpteq12dv dmex pwex mptex syl6eq 3eqtr3d
      cvv fvmpt f1odm mpteq1d eqid fnmpti f1ofn wf f1of ffvelrnda imaeq2 imaexg
      wfn fvco3 sylan 3eqtr4rd eqfnfvd con0 nnon r1suc bitrd mpbird ex finds )
      HIZJKZYJLKZYIEMUCZKZNMJKZYNLKZMYLKZNZUAIZJKZYSLKZYRYLKZNZYRUEZJKZUUDLKZUU
      CYLKZNZCJKZUUHLKZCYLKZNHUACYIMOZYJYNYKYOYMYPYIMYLPYIMJPZUUKYJYNLUULQUFYIY
      ROZYJYSYKYTYMUUAYIYRYLPYIYRJPZUUMYJYSLUUNQUFYIUUCOZYJUUDYKUUEYMUUFYIUUCYL
      PYIUUCJPZUUOYJUUDLUUPQUFYICOZYJUUHYKUUIYMUUJYICYLPYICJPZUUQYJUUHLUURQUFYQ
      MMMNZUGYQYNYOMNZUUSYPMOYQUUTUDMEUHUQYNYOYPMUIUJYNMOYOMOUUTUUSUDUKYOMLKMYN
      MLUKULUMUNYNMYOMMUOUPURUSYRRSZUUBUUGUVAUUBVKZUUGYSUTZUVCLKZDYTUTZVAZHUVCU
      UAYIVBZVCZVDZNZUVBUVEUVDUVFNZUVCUVEUVHNZUVJUVAUVKUUBUVAUVEDUVEVBZUVFNZUVK
      UVARUTVEVFZRDVGZUVEUVOVHZUVNUVPUVAABDFVIVJUVAYTRSZUVQUVAYSVESZUVRYRWAZYSV
      LTZYTVMTUVORUVEDVNVOUVAUVMUVDOUVNUVKUDUVAUVMUVELKZUVDUVAUVRUVMUWBOUWAABYT
      DFVPTUVAUVSYTYSVQVRUVEUVCVQVRUWBUVDOUVTYSVSYTYSWBUVEUVCVTWCWDUVMUVDUVEUVF
      WETWFWGUUBUVLUVAYSYTUUAHWHWIZUVCUVEUVDUVFUVHWJVOZUVBUUGUUDUUEUVINZUVJUVBU
      UFUVIOUUGUWEUDUVBUUFBUUAWMZUTZUUABIZVBZDKZVCZUVIUVAUUFUWKOUUBUVAUUCYLRVAZ
      KZYRUWLKZEKZUUFUWKMYREWKUVAUUCRSUWMUUFOYRWLUUCRYLWNTUVAUWOUUAEKZUWKUVAUWN
      UUAEYRRYLWNQUUAXESZUWPUWKOYRYLWOZAUUABAIZWMZUTZUWSUWHVBZDKZVCUWKXEEUWSUUA
      OZBUXAUXCUWGUWJUXDUWTUWFUWSUUAWPWQUXDUXBUWIDUWSUUAUWHWRQWSGBUWGUWJUWFUUAU
      WRWTXAXBXFUJXCXDWGUVBUWKBUVCUWJVCZUVIUVBBUWGUVCUWJUVBUWFYSUUBUWFYSOUVAYSY
      TUUAXGWIWQXHUVBUBUVCUXEUVIUXEUVCXQUVBBUVCUWJUXEUWIDWOUXEXIZXJVJUVBUVJUVIU
      VCXQUWDUVCUVDUVIXKTUVBUBIZUVCSZVKZUXGUVHKZUVFKZUUAUXGVBZDKZUXGUVIKZUXGUXE
      KZUXIUXKUXJDKZUXMUXIUXJUVESUXKUXPOUVBUVCUVEUXGUVHUVBUVLUVCUVEUVHXLZUWCUVC
      UVEUVHXMTZXNUXJUVEDWNTUXIUXJUXLDUXHUXJUXLOUVBHUXGUVGUXLUVCUVHYIUXGUUAXOUV
      HXIUWQUXLXESUWRUUAUXGXEXPUJXFWIQWDUVBUXQUXHUXNUXKOUXRUVCUVEUXGUVFUVHXRXSU
      XHUXOUXMOUVBBUXGUWJUXMUVCUXEUWHUXGOUWIUXLDUWHUXGUUAXOQUXFUXLDWOXFWIXTYAWD
      WDUUDUUEUUFUVIUITUVAUWEUVJUDZUUBUVAUUDUVCOZUUEUVDOUXSUVAYRYBSUXTYRYCYRYDT
      ZUVAUUDUVCLUYAQUUDUVCUUEUVDUVIUOVOWGYEYFYGYH $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij2lem3 $p |- ( A e. om -> ( rec ( G , (/) ) ` A ) C_
        ( rec ( G , (/) ) ` suc A ) ) $=
      ( wcel c0 cfv csuc cr1 cres cv wceq fveq2 fveq2d syl cima cpw va com crdg
      vb suceq reseq12d eqeq12d weq res0 r10 reseq2i 0ex rdg0 3eqtr4ri wfn ccrd
      vc wa wf1o peano2 ackbij2lem2 f1ofn adantr 4syl con0 nnon r1sssuc fnssres
      wss syl2anc r1suc eleq2d biimpa elpwid resima2 cmpt fvex resex dmeq pweqd
      cdm cvv imaeq1 mpteq12dv dmex pwex mptex fvmpt ax-mp fveq1i fndm eleqtrrd
      imaeq2 eqid syl5eq wtr r1tr a1i dftr4 sylib sselda 3eqtr4d adantlr fveq1d
      f1odm ad2antlr rdgsuc ad2antrr 3eqtr4rd fvres adantl finds resss syl6eqss
      eqfnfvd ex ) CUBHCEIUCZJZCKZXQJZCLJZMZXTUANZXQJZYCKZXQJZYCLJZMZOIXQJZIKZX
      QJZILJZMZOUDNZXQJZYNKZXQJZYNLJZMZOZYQYPKZXQJZYPLJZMZOZXRYBOUAUDCYCIOZYDYI
      YHYMYCIXQPUUFYFYKYGYLUUFYEYJXQYCIUEQYCILPUFUGUAUDUHZYDYOYHYSYCYNXQPUUGYFY
      QYGYRUUGYEYPXQYCYNUEQYCYNLPUFUGYCYPOZYDYQYHUUDYCYPXQPUUHYFUUBYGUUCUUHYEUU
      AXQYCYPUEQYCYPLPUFUGYCCOZYDXRYHYBYCCXQPUUIYFXTYGYAUUIYEXSXQYCCUEQYCCLPUFU
      GYKIMIYMYIYKUIYLIYKUJUKIEULUMUNYNUBHZYTUUEUUJYTURZUQUUCYQUUDUUJYQUUCUOZYT
      UUJUUCUUCUPJZYQUSZUULUUJYPUBHZUUNYNUTZABYPDEFGVARZUUCUUMYQVBRZVCUUJUUDUUC
      UOZYTUUJUUBUUALJZUOZUUCUUTVIZUUSUUJUUOUUAUBHUUTUUTUPJZUUBUSUVAUUPYPUTABUU
      ADEFGVAUUTUVCUUBVBVDUUJYPVEHZUVBUUJUUOUVDUUPYPVFRZYPVGRUUTUUCUUBVHVJVCUUK
      UQNZUUCHZURZUVFUUBJZUVFYOEJZJZUVFUUDJZUVFYQJZUVHUVFYSEJZJZUVFYQEJZJZUVKUV
      IUUJUVGUVOUVQOYTUUJUVGURZYSUVFSZDJZYQUVFSZDJZUVOUVQUVRUVSUWADUVRUVFYRVIUV
      SUWAOUVRUVFYRUUJUVGUVFYRTZHUUJUUCUWCUVFUUJYNVEHZUUCUWCOYNVFZYNVKRVLVMZVNY
      QUVFYRVORQUVRUVOUVFBYSWAZTZYSBNZSZDJZVPZJZUVTUVFUVNUWLYSWBHUVNUWLOYQYRYPX
      QVQZVRZAYSBANZWAZTZUWPUWISZDJZVPZUWLWBEUWPYSOZBUWRUWTUWHUWKUXBUWQUWGUWPYS
      VSVTUXBUWSUWJDUWPYSUWIWCQWDGBUWHUWKUWGYSUWOWEWFWGWHWIWJUVRUVFUWHHUWMUVTOU
      VRUVFUWCUWHUWFUUJUWHUWCOUVGUUJUWGYRUUJYSYRUOZUWGYROUUJUULYRUUCVIZUXCUURUU
      JUWDUXDUWEYNVGRUUCYRYQVHVJYRYSWKRVTVCWLBUVFUWKUVTUWHUWLBUQUHZUWJUVSDUWIUV
      FYSWMQUWLWNUVSDVQWHRWOUVRUVQUVFBYQWAZTZYQUWISZDJZVPZJZUWBUVFUVPUXJYQWBHUV
      PUXJOUWNAYQUXAUXJWBEUWPYQOZBUWRUWTUXGUXIUXLUWQUXFUWPYQVSVTUXLUWSUXHDUWPYQ
      UWIWCQWDGBUXGUXIUXFYQUWNWEWFWGWHWIWJUVRUVFUXGHUXKUWBOUVRUVFUUCTZUXGUUJUUC
      UXMUVFUUJUUCWPZUUCUXMVIUXNUUJYPWQWRUUCWSWTXAUUJUXGUXMOUVGUUJUXFUUCUUJUUNU
      XFUUCOUUQUUCUUMYQXERVTVCWLBUVFUXIUWBUXGUXJUXEUXHUWADUWIUVFYQWMQUXJWNUWADV
      QWHRWOXBXCYTUVKUVOOUUJUVGYTUVFUVJUVNYOYSEPXDXFUUJUVIUVQOYTUVGUUJUVFUUBUVP
      UUJUVDUUBUVPOUVEIYPEXGRXDXHXIUVGUVLUVIOUUKUVFUUCUUBXJXKUUJUVMUVKOYTUVGUUJ
      UVFYQUVJUUJUWDYQUVJOUWEIYNEXGRXDXHXIXOXPXLXTYAXMXN $.

    $( Lemma for ~ ackbij2 .  (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    ackbij2lem4 $p |- ( ( ( A e. om /\ B e. om ) /\ B C_ A ) ->
        ( rec ( G , (/) ) ` B ) C_ ( rec ( G , (/) ) ` A ) ) $=
      ( va vb c0 cfv cv wss wceq fveq2 sseq2d com wcel wa crdg csuc ackbij2lem3
      weq ssid a1i ad2antrr sstr2 syl5com findsg ) DFKUAZLZIMZUKLZNULULNZULJMZU
      KLZNZULUPUBZUKLZNZULCUKLZNIJCDUMDOUNULULUMDUKPQIJUDUNUQULUMUPUKPQUMUSOUNU
      TULUMUSUKPQUMCOUNVBULUMCUKPQUODRSZULUEUFUPRSZVCTDUPNZTUQUTNZURVAVDVFVCVEA
      BUPEFGHUCUGULUQUTUHUIUJ $.

    ackbij.h $e |- H = U. ( rec ( G , (/) ) " om ) $.
    $( The Ackermann bijection, part 2: hereditarily finite sets can be
       represented by recursive binary notation.  (Contributed by Stefan
       O'Rear, 18-Nov-2014.) $)
    ackbij2 $p |- H : U. ( R1 " om ) -1-1-onto-> om $=
      ( va vb cr1 com wf1o wf1 wceq cfv wss wa wcel syl vc cima cuni c0 crdg cv
      crn ciun wral fveq2 fvex fun11iun ccrd ackbij2lem2 f1of1 word ordom r1fin
      wo cfn ficardom ordelss sylancr f1ss syl2anc nnord ordtri2or2 ackbij2lem4
      syl2an wi ex ancoms orim12d mpd ralrimiva jca mprg rdgfun funiunfv eqcomd
      wfun wb f1eq1 mp2b cdm wlim r1funlim simpli f1eq2 bitr4i mpbir rnuni wrex
      wex eliun df-rex wfn funfn mpbi rdgdmlim limomss ax-mp fvelimab mp2an wfo
      f1ofo forn 3syl eqsstrd rneq sseq1d syl5ibcom rexlimiv sylbi exlimiv csuc
      sselda peano2 fnfvima mp3an12 cvv vex cardnn cdom wbr simpri sseli onssr1
      ssdomg mpsyl con0 onenon finnum carddom2 mpbird eqsstr3d sucssel eleqtrrd
      nnon 4syl eleq1 eleq2d anbi12d spcev impbii 3bitri dff1o5 mpbir2an f1oeq1
      eqriv eqtri ) KLUBUCZLEMZUULLDUDUEZLUBZUCZMZUUQUULLUUPNZUUPUGZLOUURILIUFZ
      KPZUHZLILUUTUUNPZUHZNZUVALUVCNZUVCJUFZUUNPZQZUVHUVCQZUSZJLUIZRUVEILIJLUVC
      UVHUVALUUTUVGUUNUJUUTUUNUKULUUTLSZUVFUVLUVMUVAUVAUMPZUVCNZUVNLQZUVFUVMUVA
      UVNUVCMUVOABUUTCDFGUNUVAUVNUVCUOTUVMLUPZUVNLSZUVPUQUVMUVAUTSUVRUUTURUVAVA
      TLUVNVBVCUVAUVNLUVCVDVEUVMUVKJLUVMUVGLSZRZUUTUVGQZUVGUUTQZUSZUVKUVMUUTUPU
      VGUPUWCUVSUUTVFUVGVFUUTUVGVGVIUVTUWAUVIUWBUVJUVSUVMUWAUVIVJUVSUVMRUWAUVIA
      BUVGUUTCDFGVHVKVLUVTUWBUVJABUUTUVGCDFGVHVKVMVNVOVPVQUURUULLUVDNZUVEUUNWAZ
      UUPUVDOUURUWDWBUDDVRZUWEUVDUUPILUUNVSVTUULLUUPUVDWCWDKWAZUVBUULOUVEUWDWBU
      WGKWEZWFZWGWHILKVSUVBUULLUVDWIWDWJWKUUSIUUOUUTUGZUHZLIUUOWLJUWKLUVGUWKSUV
      GUWJSZIUUOWMUUTUUOSZUWLRZIWNZUVSIUVGUUOUWJWOUWLIUUOWPUWOUVSUWNUVSIUWMUWJL
      UVGUWMUAUFZUUNPZUUTOZUALWMZUWJLQZUUNUUNWEZWQZLUXAQZUWMUWSWBUWEUXBUWFUUNWR
      WSZUXAWFUXCUDDWTUXAXAXBZUAUXALUUTUUNXCXDUWRUWTUALUWPLSZUWQUGZLQUWRUWTUXFU
      XGUWPKPZUMPZLUXFUXHUXIUWQMUXHUXIUWQXEUXGUXIOABUWPCDFGUNUXHUXIUWQXFUXHUXIU
      WQXGXHUXFUVQUXILSZUXILQUQUXFUXHUTSUXJUWPURUXHVATLUXIVBVCXIUWRUXGUWJLUWQUU
      TXJXKXLXMXNXQXOUVSUVGXPZUUNPZUUOSZUVGUXLUGZSZUWOUVSUXKLSZUXMUVGXRZUXBUXCU
      XPUXMUXDUXEUXALUUNUXKXSXTTUVSUVGUXKKPZUMPZUXNUVGYASUVSUXKUXSQZUVGUXSSJYBU
      VSUXPUXTUXQUXPUXKUXKUMPZUXSUXKYCUXPUYAUXSQZUXKUXRYDYEZUXRYASUXPUXKUXRQZUY
      CUXKKUKUXPUXKUWHSUYDLUWHUXKUWILUWHQUWGUWIWGYFUWHXAXBYGUXKYHTUXKUXRYAYIYJU
      XPUXKUMWEZSZUXRUYESZUYBUYCWBUXPUXKYKSUYFUXKYSUXKYLTUXPUXRUTSUYGUXKURUXRYM
      TUXKUXRYNVEYOYPTUVGUXSYAYQYJUVSUXPUXRUXSUXLMUXRUXSUXLXEUXNUXSOUXQABUXKCDF
      GUNUXRUXSUXLXFUXRUXSUXLXGYTYRUWNUXMUXORIUXLUXKUUNUKUUTUXLOZUWMUXMUWLUXOUU
      TUXLUUOUUAUYHUWJUXNUVGUUTUXLXJUUBUUCUUDVEUUEUUFUUJUUKUULLUUPUUGUUHEUUPOUU
      MUUQWBHUULLEUUPUUIXBWK $.
  $}

  ${
    $d a b c d e f $.
    $( The set of hereditarily finite sets is countable.  See ~ ackbij2 for an
       explicit bijection that works without Infinity.  See also ~ r1omALT .
       (Contributed by Stefan O'Rear, 18-Nov-2014.) $)
    r1om $p |- ( R1 ` om ) ~~ om $=
      ( va vc vd ve vf vb com cr1 cfv cima cuni cv ciun cvv cpw ccrd weq fveq2d
      cmpt cbvmptv wcel wlim wceq omex limom r1lim mp2an con0 wfun r1fnon fnfun
      cen wfn funiunfv mp2b eqtri cdm cfn cin csn cxp crdg wf1o wbr iuneq1 sneq
      c0 pweq xpeq12d cbviunv syl6eq dmeq pweqd imaeq1 mpteq12dv imaeq2 ackbij2
      eqid fvex eqeltrri f1oen ax-mp eqbrtri ) GHIZHGJKZGULWDAGALZHIMZWEGNUAGUB
      WDWGUCUDUEAGNUFUGHUHUMHUIWGWEUCUJUHHUKAGHUNUOUPZWEGBNCBLZUQZOZWICLZJZDGOU
      RUSZEDLZELZUTZWPOZVAZMZPIZSZIZSZSZVGVBGJKZVCWEGULVDAFXBXEXFDAWNXAFWFFLZUT
      ZXGOZVAZMZPIDAQZWTXKPXLWTEWFWSMXKEWOWFWSVEEFWFWSXJEFQWQXHWRXIWPXGVFWPXGVH
      VIVJVKRTBANXDFWFUQZOZWFXGJZXBIZSZBAQZXDCXNWFWLJZXBIZSXQXRCWKXCXNXTXRWJXMW
      IWFVLVMXRWMXSXBWIWFWLVNRVOCFXNXTXPCFQXSXOXBWLXGWFVPRTVKTXFVRVQWEGXFWDWENW
      HGHVSVTWAWBWC $.
  $}

  ${
    $d f x y z A $.  $d f x y B $.
    $( A set is countable iff its collection of finite intersections is
       countable.  (Contributed by Jeff Hankins, 24-Aug-2009.)  (Proof
       shortened by Mario Carneiro, 17-May-2015.) $)
    fictb $p |- ( A e. B -> ( A ~<_ om <-> ( fi ` A ) ~<_ om ) ) $=
      ( vf vy vx vz wcel com cdom wbr cfv wa cvv cpw cfn ccrd wss syl syl2anc
      cv cfi wf1 wex brdomi adantl wi reldom brrelex2i cin c0 csn cdif cdm cint
      cmpt wfo con0 omelon2 ad2antlr pwexg ad2antrr inex1g difss ssdomg crn cen
      ee10 cima wf1o f1f1orn f1opwfi f1oeng f1f frn sspwb sylib ssrin sylc ciun
      wf cxp weq sneq pweq xpeq12d cbviunv iuneq1 syl5eq fveq2d cbvmptv ackbij1
      sylancl domentr endomtr domtr ondomen eqid fodomnum ex exlimdv sylan2 mpd
      fifo fvex ssfii mpsyl impbid ) ABGZAHIJZAUAKZHIJZXHXIXKXHXILAHCTZUBZCUCZX
      KXIXNXHAHCUDUEXIXHHMGZXNXKUFAHIUGUHXHXOLZXMXKCXPXMXKXPXMLZXJANZOUIZUJUKZU
      LZIJZYAHIJZXKXQYAPUMGZYAXJDYADTZUNUOZUPZYBXQHUQGZYCYDXOYHXHXMURUSXQYAXSIJ
      ZXSHIJZYCXQXSMGZYAXSQYIXQXRMGZYKXHYLXOXMABUTVAXROMVBRZXSXTVCYAXSMVDVGXQXS
      XLVEZNZOUIZVFJZYPHIJZYJXQYKXSYPEXSXLETZVHUOZVIZYQYMXQAYNXLVIZUUAXMUUBXPAH
      XLVJUEAYNXLEVKRXSYPMYTVLSXQYPHNZOUIZIJZUUDHVFJZYRXQUUDMGZYPUUDQZUUEXQUUCM
      GZUUGXOUUIXHXMHMUTUSUUCOMVBRZXQYOUUCQZUUHXQYNHQZUUKXQAHXLVTZUULXMUUMXPAHX
      LVMUEAHXLVNRYNHVOVPYOUUCOVQRYPUUDMVDVRXQUUGUUDHEUUDCYSXLUKZXLNZWAZVSZPKZU
      OZVIUUFUUJDFUUSEDUUDUURFYEFTZUKZUUTNZWAZVSZPKEDWBZUUQUVDPUVEUUQFYSUVCVSUV
      DCFYSUUPUVCCFWBUUNUVAUUOUVBXLUUTWCXLUUTWDWEWFFYSYEUVCWGWHWIWJWKUUDHMUUSVL
      WLYPUUDHWMSXSYPHWNSYAXSHWOSZHYAWPSXHYGXOXMDAYFBYFWQXCVAYAXJYFWRVRUVFXJYAH
      WOSWSWTXAXBWSXHAXJIJZXKXIUFXJMGXHAXJQUVGAUAXDABXEAXJMVDXFUVGXKXIAXJHWOWSR
      XG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Cofinality (without Axiom of Choice)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u A $.
    $( A lemma used to simplify cofinality computations, showing the existence
       of the cardinal of an unbounded subset of a set ` A ` .  (Contributed by
       NM, 24-Apr-2004.) $)
    cflem $p |- ( A e. V -> E. x E. y ( x = ( card ` y )
                  /\ ( y C_ A /\ A. z e. A E. w e. y z C_ w ) ) ) $=
      ( wcel cv wss wrex wral wa wex ccrd cfv wceq ssid sseq2 rspcev mpan2 rgen
      sseq1 rexeq ralbidv anbi12d spcegv mp2ani fvex isseti mpbiran exbii excom
      19.41v bitr3i sylib ) EFGZBHZEIZCHZDHZIZDUQJZCEKZLZBMZAHUQNOZPZVDLZBMAMZU
      PEEIZVADEJZCEKZVEEQVKCEUSEGUSUSIZVKUSQVAVMDUSEUTUSUSRSTUAVDVJVLLBEFUQEPZU
      RVJVCVLUQEEUBVNVBVKCEVADUQEUCUDUEUFUGVEVHAMZBMVIVOVDBVOVGAMVDAVFUQNUHUIVG
      VDAUMUJUKVHBAULUNUO $.

    $( Value of the cofinality function.  Definition B of Saharon Shelah,
       _Cardinal Arithmetic_ (1994), p. xxx (Roman numeral 30).  The cofinality
       of an ordinal number ` A ` is the cardinality (size) of the smallest
       unbounded subset ` y ` of the ordinal number.  Unbounded means that for
       every member of ` A ` , there is a member of ` y ` that is at least as
       large.  Cofinality is a measure of how "reachable from below" an ordinal
       is.  (Contributed by NM, 1-Apr-2004.)  (Revised by Mario Carneiro,
       15-Sep-2013.) $)
    cfval $p |- ( A e. On -> ( cf ` A ) = |^| { x | E. y ( x = ( card ` y ) /\
                 ( y C_ A /\ A. z e. A E. w e. y z C_ w ) ) } ) $=
      ( vv con0 wcel cv ccrd cfv wceq wss wral wa wex cab cint cvv ccf intexab
      cflem sylib sseq2 raleq anbi12d anbi2d exbidv abbidv inteqd df-cf fvmptg
      wrex mpdan ) EGHZAIBIZJKLZUPEMZCIDIMDUPUMZCENZOZOZBPZAQZRZSHZETKVELUOVCAP
      VFABCDEGUBVCAUAUCFEUQUPFIZMZUSCVGNZOZOZBPZAQZRVEGSTVGELZVMVDVNVLVCAVNVKVB
      BVNVJVAUQVNVHURVIUTVGEUPUDUSCVGEUEUFUGUHUIUJFABCDUKULUN $.
  $}

  ${
    $d x y z w v $.
    $( Cofinality is a function on the class of ordinal numbers to the class of
       cardinal numbers.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
    cff $p |- cf : On --> On $=
      ( vx vy vz vw vv con0 cv ccrd cfv wceq wss wrex wral wa wex cab ccf df-cf
      cint wcel wne cardon eleq1 mpbiri adantr exlimiv abssi cflem abn0 oninton
      c0 sylibr sylancr fmpti ) AFFBGZCGZHIZJZUPAGZKDGEGKEUPLDUSMNZNZCOZBPZSZQA
      BCDERUSFTZVCFKVCUKUAZVDFTVBBFVAUOFTZCURVGUTURVGUQFTUPUBUOUQFUCUDUEUFUGVEV
      BBOVFBCDEUSFUHVBBUIULVCUJUMUN $.
  $}

  ${
    $d x y z w v A $.
    $( An upper bound on cofinality.  (Contributed by NM, 25-Apr-2004.)
       (Revised by Mario Carneiro, 15-Sep-2013.) $)
    cfub $p |- ( cf ` A ) C_
            |^| { x | E. y ( x = ( card ` y ) /\ ( y C_ A /\ A C_ U. y ) ) } $=
      ( vz vw con0 wcel ccf cfv cv ccrd wceq wss wa wex cab cint wral eximdv c0
      cuni wrex cfval dfss3 wi ssel onelon ex sylan9r onelss syl6 ancomsd eluni
      imdistand df-rex 3imtr4g ralimdv syl5bi imdistanda anim2d ss2abdv eqsstrd
      intss syl wn cdm cff fdmi eleq2i ndmfv sylnbir 0ss syl6eqss pm2.61i ) CFG
      ZCHIZAJBJZKILZVQCMZCVQUAZMZNZNZBOZAPZQZMVOVPVRVSDJZEJZMZEVQUBZDCRZNZNZBOZ
      APZQZWFABDECUCVOWEWOMWPWFMVOWDWNAVOWCWMBVOWBWLVRVOVSWAWKWAWGVTGZDCRVOVSNZ
      WKDCVTUDWRWQWJDCWRWGWHGZWHVQGZNZEOWTWINZEOWQWJWRXAXBEWRWTWSXBWRWTWSWIWRWT
      WHFGZWSWIUEVSWTWHCGZVOXCVQCWHUFVOXDXCCWHUGUHUIWHWGUJUKUNULSEWGVQUMWIEVQUO
      UPUQURUSUTSVAWEWOVCVDVBVOVEVPTWFVOCHVFZGVPTLXEFCFFHVGVHVICHVJVKWFVLVMVN
      $.

    $( Value of the cofinality function at a limit ordinal.  Part of Definition
       of cofinality of [Enderton] p. 257.  (Contributed by NM,
       26-Apr-2004.) $)
    cflm $p |- ( ( A e. B /\ Lim A ) -> ( cf ` A ) =
           |^| { x | E. y ( x = ( card ` y ) /\ ( y C_ A /\ A = U. y ) ) } ) $=
      ( vz vw vv wcel cvv cfv cv wceq wss cuni wa wex cab cint wrex wral ccf wi
      wlim ccrd elex limsuc biimpd sseq1 rexbidv rspcv vex sucssel ax-mp reximi
      csuc eluni2 sylibr syl6com syl9 ralrimdv dfss3 adantr uniss limuni sseq2d
      syl6ibr syl5ibr jctird eqss imdistanda anim2d eximdv ss2abdv intss adantl
      imp syl con0 limelon cfval sseqtr4d cfub eqimss anim2i eximi ss2abi sstri
      jctil sylan ) CDHCIHZCUCZCUAJZAKBKZUDJLZWMCMZCWMNZLZOZOZBPZAQZRZLZCDUEWJW
      KOZWLXBMZXBWLMZOXCXDXFXEXDXBWNWOEKZFKZMZFWMSZECTZOZOZBPZAQZRZWLWKXBXPMZWJ
      WKXOXAMXQWKXNWTAWKXMWSBWKXLWRWNWKWOXKWQWKWOOZXKCWPMZWPCMZOWQXRXKXSXTWKXKX
      SUBWOWKXKGKZWPHZGCTXSWKXKYBGCWKYACHZYAUOZCHZXKYBWKYCYECYAUFUGYEXKYDXHMZFW
      MSZYBXJYGEYDCXGYDLXIYFFWMXGYDXHUHUIUJYGYAXHHZFWMSYBYFYHFWMYAIHYFYHUBGUKYA
      XHIULUMUNFYAWMUPUQURUSUTGCWPVAVFVBWKWOXTWOXTWKWPCNZMWMCVCWKCYIWPCVDVEVGVP
      VHCWPVIVFVJVKVLVMXOXAVNVQVOXDCVRHWLXPLCIVSABEFCVTVQWAWLWNWOXSOZOZBPZAQZRZ
      XBABCWBXAYMMYNXBMWTYLAWSYKBWRYJWNWQXSWOCWPWCWDWDWEWFXAYMVNUMWGWHWLXBVIUQW
      I $.
  $}

  ${
    $d x y $.
    $( Value of the cofinality function at 0.  Exercise 2 of [TakeutiZaring]
       p. 102.  (Contributed by NM, 16-Apr-2004.) $)
    cf0 $p |- ( cf ` (/) ) = (/) $=
      ( vx vy c0 ccf cfv wss wceq cv ccrd cuni wex cab cint cfub csn ss0b bitri
      wa 0ss 0ex biantru bitr3i anbi2i ancom exbii eqeq2d ceqsexv eqeq2i eqtr4i
      fveq2 card0 abbii df-sn inteqi intsn eqtri sseqtri mpbi ) CDEZCFUSCGUSAHZ
      BHZIEZGZVACFZCVAJZFZRZRZBKZALZMZCABCNVKCOZMCVJVLVJUTCGZALVLVIVMAVIVACGZVC
      RZBKZVMVHVOBVHVCVNRVOVGVNVCVGVDVNVFVDVESUAVAPUBUCVCVNUDQUEVPUTCIEZGZVMVCV
      RBCTVNVBVQUTVACIUJUFUGVQCUTUKUHQQULACUMUIUNCTUOUPUQUSPUR $.
  $}

  ${
    $d x y z w v u A $.
    $( Cofinality is a cardinal number.  Proposition 11.11 of [TakeutiZaring]
       p. 103.  (Contributed by NM, 24-Apr-2004.)  (Revised by Mario Carneiro,
       15-Sep-2013.) $)
    cardcf $p |- ( card ` ( cf ` A ) ) = ( cf ` A ) $=
      ( vx vy vz vw vv con0 wcel ccf cfv ccrd wceq cv wss wa c0 fveq2 syl6eqelr
      wex cvv wrex wral cab cint cfval wne vex eqeq1 anbi1d exbidv elab cardidm
      syl6eq eqeq2 mpbird adantr exlimiv sylbi cardon ssriv fvex sylibr sylancr
      intex onint eqeltrd id eqeq12d vtoclga syl wn cdm cff fdmi eleq2i sylnbir
      ndmfv card0 3eqtr4a pm2.61i ) AGHZAIJZKJZWBLZWAWBBMZCMZKJZLZWFANDMEMNEWFU
      ADAUBOZOZCSZBUCZHWDWAWBWLUDZWLBCDEAUEZWAWLGNWLPUFZWMWLHFWLGFMZWLHZWPWPKJZ
      GWQWPWGLZWIOZCSZWRWPLZWKXABWPFUGWEWPLZWJWTCXCWHWSWIWEWPWGUHUIUJUKWTXBCWSX
      BWIWSXBWRWGLWSWRWGKJWGWPWGKQWFULUMWPWGWRUNUOUPUQURZWPUSRUTWAWMTHWOWAWMWBT
      WNAIVARWLVDVBWLVEVCVFXBWDFWBWLWPWBLZWRWCWPWBWPWBKQXEVGVHXDVIVJWAVKWBPLZWD
      WAAIVLZHXFXGGAGGIVMVNVOAIVQVPXFPKJPWCWBVRWBPKQXFVGVSVJVT $.

    $( Cofinality is bounded by the cardinality of its argument.  (Contributed
       by NM, 24-Apr-2004.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    cflecard $p |- ( cf ` A ) C_ ( card ` A ) $=
      ( vx vy vz vw con0 wcel ccf cfv ccrd wss cv wceq wrex wral wa cab anbi12d
      cint ssid wex cfval csn df-sn sseq2 rspcev mpan2 rgen pm3.2i fveq2 eqeq2d
      sseq1 rexeq ralbidv spcegv ss2abdv syl5eqss intss syl fvex intsn syl6sseq
      mpan2i eqsstrd wn cdm cff fdmi eleq2i ndmfv sylnbir 0ss syl6eqss pm2.61i
      c0 ) AFGZAHIZAJIZKVPVQBLZCLZJIZMZVTAKZDLZELZKZEVTNZDAOZPZPZCUAZBQZSZVRBCD
      EAUBVPWMVRUCZSZVRVPWNWLKWMWOKVPWNVSVRMZBQWLBVRUDVPWPWKBVPWPAAKZWFEANZDAOZ
      PZWKWQWSATWRDAWDAGWDWDKZWRWDTWFXAEWDAWEWDWDUEUFUGUHUIWJWPWTPCAFVTAMZWBWPW
      IWTXBWAVRVSVTAJUJUKXBWCWQWHWSVTAAULXBWGWRDAWFEVTAUMUNRRUOVCUPUQWNWLURUSVR
      AJUTVAVBVDVPVEVQVOVRVPAHVFZGVQVOMXCFAFFHVGVHVIAHVJVKVRVLVMVN $.

    $( Cofinality is bounded by its argument.  Exercise 1 of [TakeutiZaring]
       p. 102.  (Contributed by NM, 26-Apr-2004.)  (Revised by Mario Carneiro,
       15-Sep-2013.) $)
    cfle $p |- ( cf ` A ) C_ A $=
      ( con0 wcel ccf cfv wss ccrd cflecard cardonle syl5ss wn c0 cdm wceq fdmi
      cff eleq2i ndmfv sylnbir 0ss syl6eqss pm2.61i ) ABCZADEZAFUCUDAGEAAHAIJUC
      KUDLAUCADMZCUDLNUEBABBDPOQADRSATUAUB $.
  $}

  ${
    $d A f s w y z $.  $d A s x y z $.
    $( The cofinality of any set is an ordinal (although it only makes sense
       when ` A ` is an ordinal).  (Contributed by Mario Carneiro,
       9-Mar-2013.) $)
    cfon $p |- ( cf ` A ) e. On $=
      ( ccf cfv ccrd con0 cardcf cardon eqeltrri ) ABCZDCIEAFIGH $.
  $}

  ${
    $d A v w x y z $.
    $( Only the ordinal zero has cofinality zero.  (Contributed by NM,
       24-Apr-2004.)  (Revised by Mario Carneiro, 12-Feb-2013.) $)
    cfeq0 $p |- ( A e. On -> ( ( cf ` A ) = (/) <-> A = (/) ) ) $=
      ( vx vy vz vw vv con0 wcel ccf cfv c0 wceq cv ccrd wss wrex wral wa wex
      wb cab cint cfval eqeq1d vex eqeq1 anbi1d exbidv elab fveq2 cardidm eqeq2
      syl6eq mpbird adantr exlimiv sylbi cardon syl6eqelr ssriv onint0 0ex onss
      ax-mp w3a ancoms sylan 3adant2 3adant3r simp2 simp3 eqcom cdm cvv onssnum
      sstr mpan cardnueq0 syl syl5bb biimpa sseq1 rexeq ralbidv anbi12d wn rex0
      wne rgenw r19.2z mpan2 rexnal sylib necon4ai adantl 3expib exlimdv syl5bi
      syl21anc sylbid cf0 impbid1 ) AGHZAIJZKLZAKLZXCXEBMZCMZNJZLZXHAOZDMEMOZEX
      HPZDAQZRZRZCSZBUAZUBZKLZXFXCXDXSKBCDEAUCUDXTKXRHZXCXFXRGOXTYATFXRGFMZXRHZ
      YBYBNJZGYCYBXILZXORZCSZYDYBLZXQYGBYBFUEXGYBLZXPYFCYIXJYEXOXGYBXIUFUGUHUIY
      FYHCYEYHXOYEYHYDXILYEYDXINJXIYBXINUJXHUKUMYBXIYDULUNUOUPUQYBURUSUTXRVAVDY
      AKXILZXORZCSZXCXFXQYLBKVBXGKLZXPYKCYMXJYJXOXGKXIUFUGUHUIXCYKXFCXCYJXOXFXC
      YJXOVEXHGOZYJXOXFXCYJXKYNXNXCXKYNYJXCAGOZXKYNAVCXKYOYNXHAGVPVFVGVHVIXCYJX
      OVJXCYJXOVKYNYJRZXORKAOZXLEKPZDAQZRZXFYPXHKLZXOYTYNYJUUAYJXIKLZYNUUAKXIVL
      YNXHNVMHZUUBUUATXHVNHYNUUCCUEXHVNVOVQXHVRVSVTWAUUAXOYTUUAXKYQXNYSXHKAWBUU
      AXMYRDAXLEXHKWCWDWEWAVGYSXFYQYSAKAKWHZYRWFZDAPZYSWFUUDUUEDAQUUFUUEDAXLEWG
      WIUUEDAWJWKYRDAWLWMWNWOVSWSWPWQWRWRWTXFXDKIJKAKIUJXAUMXB $.
  $}

  ${
    $d x y z u w v A $.
    $( Value of the cofinality function at a successor ordinal.  Exercise 3 of
       [TakeutiZaring] p. 102.  (Contributed by NM, 23-Apr-2004.)  (Revised by
       Mario Carneiro, 12-Feb-2013.) $)
    cfsuc $p |- ( A e. On -> ( cf ` suc A ) = 1o ) $=
      ( vx vy vz vw vv con0 wcel cfv cv ccrd wceq wss wrex wral wa wex c1o wn
      c0 csuc ccf cab sucelon cfval sylbi csn cardsn eqcomd snidg elsuci onelss
      cint wo wi eqimss a1i jaod syl5 sseq2 rspcev ee12an ralrimiv ssun2 df-suc
      cun sseqtr4i jctil fveq2 eqeq2d sseq1 rexeq ralbidv anbi12d spcev syl2anc
      snex 1on elexi eqeq1 anbi1d exbidv elab sylibr el1o eqcom cdm cvv onssnum
      vex mpan cardnueq0 syl syl5bb biimpa rex0 nrex wne nsuceq0 r19.2z intnand
      wb mto mtbiri imnan mpbi suceloni onss sstr sylan2 ancoms adantrr 3adant2
      w3a simp2 simp3 jca31 3expib nexdv 0ex sylnibr adantr eleq1 adantl mtbird
      mtoi sylan2b ralrimiva cardon mpbiri exlimiv abssi oneqmini ax-mp eqtr4d
      ) AGHZAUAZUBIZBJZCJZKIZLZYTYQMZDJZEJZMZEYTNZDYQOZPZPZCQZBUCZUMZRYPYQGHZYR
      UUMLAUDBCDEYQUEUFYPRUULHZFJZUULHZSZFROZRUUMLZYPRUUALZUUIPZCQZUUOYPRAUGZKI
      ZLZUVDYQMZUUFEUVDNZDYQOZPZUVCYPUVERAGUHUIYPUVIUVGYPUVHDYQYPAUVDHUUDYQHZUU
      DAMZUVHAGUJUVKUUDAHZUUDALZUNYPUVLUUDAUKYPUVMUVLUVNAUUDULUVNUVLUOYPUUDAUPU
      QURUSUUFUVLEAUVDUUEAUUDUTVAVBVCUVDAUVDVFYQUVDAVDAVEVGVHUVBUVFUVJPCUVDAVQY
      TUVDLZUVAUVFUUIUVJUVOUUAUVERYTUVDKVIVJUVOUUCUVGUUHUVIYTUVDYQVKUVOUUGUVHDY
      QUUFEYTUVDVLVMVNVNVOVPUUKUVCBRRGVRVSYSRLZUUJUVBCUVPUUBUVAUUIYSRUUAVTWAWBW
      CWDYPUURFRUUPRHYPUUPTLZUURUUPWEYPUVQPUUQTUULHZYPUVRSUVQYPTUUALZUUIPZCQZUV
      RYPUVTCYPUVTYTGMZUVSPZUUIPZUWCUUISUOUWDSUWCUUHUUCUWCYTTLZUUHSUWBUVSUWEUVS
      UUATLZUWBUWETUUAWFUWBYTKWGHZUWFUWEXBYTWHHUWBUWGCWJYTWHWIWKYTWLWMWNWOUWEUU
      HUUFETNZDYQOZUWIUWHDYQNZUWHDYQUWHSUVKUUFEWPUQWQYQTWRUWIUWJAWSUWHDYQWTWKXC
      UWEUUGUWHDYQUUFEYTTVLVMXDWMXAUWCUUIXEXFYPUVSUUIUWDYPUVSUUIXNUWBUVSUUIYPUU
      IUWBUVSYPUUCUWBUUHUUCYPUWBYPUUCUUNUWBAXGUUNUUCYQGMUWBYQXHYTYQGXIXJXJXKXLX
      MYPUVSUUIXOYPUVSUUIXPXQXRYFXSUUKUWABTXTYSTLZUUJUVTCUWKUUBUVSUUIYSTUUAVTWA
      WBWCYAYBUVQUUQUVRXBYPUUPTUULYCYDYEYGYHUULGMUUOUUSPUUTUOUUKBGUUJYSGHZCUUBU
      WLUUIUUBUWLUUAGHYTYIYSUUAGYCYJYBYKYLFRUULYMYNVPYO $.
  $}

  ${
    $d A f s w y z $.  $d A s x y z $.
    $( There is always a map from ` ( cf `` A ) ` to ` A ` (this is a stronger
       condition than the definition, which only presupposes a map from some
       ` y ~~ ( cf `` A ) ` .  (Contributed by Mario Carneiro, 28-Feb-2013.) $)
    cff1 $p |- ( A e. On -> E. f ( f : ( cf ` A ) -1-1-> A /\
        A. z e. A E. w e. ( cf ` A ) z C_ ( f ` w ) ) ) $=
      ( vy vs vx con0 wcel ccf cfv cv ccrd wceq wss wrex wral wa wex cen wf1 c0
      cab cint cfval cardon eleq1 mpbiri adantr exlimiv abssi cflem abn0 sylibr
      wne onint sylancr eqeltrd fvex eqeq1 anbi1d exbidv elab sylib wf1o simplr
      onss sstr sylan2 ancoms ad2ant2r wbr cdm cvv vex onssnum mpan cardid2 syl
      adantl wb breq1 mpbird bren syl2anc w3a f1of1 f1ss adantlr 3adant1 wfo wi
      f1ofo foelrn biimpcd reximdv syl5com rexlimdva ralimdv impcom adantll jca
      sseq2 3expia eximdv mpd expl exlimdv ) CHIZCJKZELZMKZNZXKCOZALZFLZOZFXKPZ
      ACQZRZRZESZXJCDLZUAZXOBLYCKZOZBXJPZACQZRZDSZXIXJGLZXLNZXTRZESZGUCZIYBXIXJ
      YOUDZYOGEAFCUEXIYOHOYOUBUOZYPYOIYNGHYMYKHIZEYLYRXTYLYRXLHIXKUFYKXLHUGUHUI
      UJUKXIYNGSYQGEAFCHULYNGUMUNYOUPUQURYNYBGXJCJUSYKXJNZYMYAEYSYLXMXTYKXJXLUT
      VAVBVCVDXIYAYJEXIXMXTYJXIXMRZXTRZXJXKYCVEZDSZYJUUAXMXKHOZUUCXIXMXTVFXIXNU
      UDXMXSXNXIUUDXIXNCHOUUDCVGXKCHVHVIVJVKXMUUDRZXJXKTVLZUUCUUEUUFXLXKTVLZUUD
      UUGXMUUDXKMVMIZUUGXKVNIUUDUUHEVOXKVNVPVQXKVRVSVTXMUUFUUGWAUUDXJXLXKTWBUIW
      CXJXKDWDVDWEUUAUUBYIDYTXTUUBYIYTXTUUBWFYDYHXTUUBYDYTXNUUBYDXSUUBXNXJXKYCU
      AZYDXJXKYCWGUUIXNYDXJXKCYCWHVJVIWIWJXTUUBYHYTXSUUBYHXNUUBXSYHUUBXJXKYCWKZ
      XSYHWLXJXKYCWMUUJXRYGACUUJXQYGFXKUUJXPXKIRXPYENZBXJPXQYGBXJXKXPYCWNXQUUKY
      FBXJUUKXQYFXPYEXOXCWOWPWQWRWSVSWTXAWJXBXDXEXFXGXHXF $.
  $}

  ${
    $d A f s w z $.  $d A f s x y z $.  $d B b f x $.  $d B f w z $.
    $( If there is a cofinal map from ` B ` to ` A ` , then ` B ` is at least
       ` ( cf `` A ) ` .  This theorem and ~ cff1 motivate the picture of
       ` ( cf `` A ) ` as the greatest lower bound of the domain of cofinal
       maps into ` A ` .  (Contributed by Mario Carneiro, 28-Feb-2013.) $)
    cfflb $p |- ( ( A e. On /\ B e. On ) -> ( E. f ( f : B --> A /\
        A. z e. A E. w e. B z C_ ( f ` w ) ) -> ( cf ` A ) C_ B ) ) $=
      ( vs vx vy con0 wcel wa cv cfv wss wrex wral ccrd wceq 3ad2ant2 wbr sylan
      wf ccf crn frn adantr wfn ffn fnfvelrn sseq2 rspcev exp31 ralimdv imp jca
      rexlimdv wi fvex w3a wex cab cint cfval vex rnex fveq2 eqeq2d sseq1 rexeq
      ralbidv anbi12d spcev abid sylibr intss1 syl 3adant2 3expib sylibd vtocle
      eqsstrd sylan2 cardidm cdom cen cdm cvv sylan9ssr onssnum sylancr cardid2
      onss onenon dffn4 sylib fodomnum syl2im 3adant1 endomtr syl2anc wb cardon
      wfo ax-mp carddom2 mpbird cardonle sstrd syl5eqssr 3expa adantrr exlimdv
      ex ) CIJZDIJZKZDCELZUBZALZBLZXQMZNZBDOZACPZKZCUCMZDNZEXPYEYGXPYEKYFXQUDZQ
      MZDYEXPYHCNZXSFLZNZFYHOZACPZKZYFYINZYEYJYNXRYJYDDCXQUEZUFXRYDYNXRYCYMACXR
      YBYMBDXRXTDJZYBYMXRYRKYAYHJZYBYMXRXQDUGZYRYSDCXQUHZDXTXQUIUAYLYBFYAYHYKYA
      XSUJUKUAULUPUMUNUOXPYOKZYPUQGYIYHQURGLZYIRZUUBYFUUCNZYPUUDXPYOUUEUUDXPYOU
      SYFUUCHLZQMZRZUUFCNZYLFUUFOZACPZKZKZHUTZGVAZVBZUUCXPUUDYFUUPRZYOXNUUQXOGH
      AFCVCUFSUUDYOUUPUUCNZXPUUDYOKZUUCUUOJZUURUUSUUNUUTUUMUUSHYHXQEVDVEZUUFYHR
      ZUUHUUDUULYOUVBUUGYIUUCUUFYHQVFVGUVBUUIYJUUKYNUUFYHCVHUVBUUJYMACYLFUUFYHV
      IVJVKVKVLUUNGVMVNUUCUUOVOVPVQWAVRUUCYIYFUJVSVTWBXPXRYIDNZYDXNXOXRUVCXNXOX
      RUSZYIYIQMZDYHWCUVDUVEDQMZDUVDUVEUVFNZYIDWDTZUVDYIYHWETZYHDWDTZUVHUVDYHQW
      FZJZUVIUVDYHWGJYHINZUVLUVAXNXRUVMXOXRXNYHCIYQCWLWHVQYHWGWIWJYHWKVPXOXRUVJ
      XNXOXRUVJXODUVKJZXRDYHXQXCZUVJDWMZXRYTUVOUUADXQWNWODYHXQWPWQUNWRYIYHDWSWT
      XOXNUVGUVHXAZXRXOYIUVKJZUVNUVQYIIJUVRYHXBYIWMXDUVPYIDXEWJSXFXOXNUVFDNXRDX
      GSXHXIXJXKXHXMXL $.
  $}

  ${
    $d A w x y z $.
    $( Another expression for the cofinality function.  (Contributed by Mario
       Carneiro, 28-Feb-2013.) $)
    cfval2 $p |- ( A e. On -> ( cf ` A ) =
        |^|_ x e. { x e. ~P A | A. z e. A E. w e. x z C_ w } ( card ` x ) ) $=
      ( vy con0 wcel ccf cfv cv ccrd wceq wss wrex wral wa wex cab cint bitri
      cpw crab ciin cfval fvex dfiin2 df-rex rabid vex elpw anbi2ci exbii abbii
      anbi1i inteqi eqtr2i syl6eq ) DFGDHIEJAJZKIZLZURDMZBJCJMCURNBDOZPZPZAQZER
      ZSZAVBADUAZUBZUSUCZEABCDUDVJUTAVINZERZSVGAEVIUSURKUEUFVLVFVKVEEVKURVIGZUT
      PZAQVEUTAVIUGVNVDAVMVCUTVMURVHGZVBPVCVBAVHUHVOVAVBURDAUIUJUNTUKULTUMUOUPU
      Q $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( A simpler expression for the cofinality predicate, at a limit ordinal.
       (Contributed by Mario Carneiro, 28-Feb-2013.) $)
    coflim $p |- ( ( Lim A /\ B C_ A ) ->
      ( U. B = A <-> A. x e. A E. y e. B x C_ y ) ) $=
      ( wlim wss wa cuni wceq wrex wral wcel eleq2 biimprd wel eluni2 con0 word
      cv wi limord ssel2 ordelon syl2an expr onelss syl6 reximdvai syl5bi syl9r
      ralrimdv w3a uniss 3ad2ant2 uniss2 3ad2ant3 limuni 3ad2ant1 eqtr4d 3expia
      eqssd impbid ) CEZDCFZGZDHZCIZASZBSZFZBDJZACKZVEVGVKACVGVHCLZVHVFLZVEVKVG
      VNVMVFCVHMNVNABOZBDJVEVKBVHDPVEVOVJBDVEVIDLZVIQLZVOVJTVCVDVPVQVCCRVICLVQV
      DVPGCUADCVIUBCVIUCUDUEVIVHUFUGUHUIUJUKVCVDVLVGVCVDVLULZVFCHZCVRVFVSVDVCVF
      VSFVLDCUMUNVLVCVSVFFVDABCDUOUPVAVCVDCVSIVLCUQURUSUTVB $.
  $}

  ${
    $d A w x y z $.
    cflim3.1 $e |- A e. _V $.
    $( Another expression for the cofinality function.  (Contributed by Mario
       Carneiro, 28-Feb-2013.) $)
    cflim3 $p |- ( Lim A -> ( cf ` A ) =
        |^|_ x e. { x e. ~P A | U. x = A } ( card ` x ) ) $=
      ( vy vz vw wlim ccf cfv cv ccrd wceq wss wrex wa wex cab cint wcel syl5bb
      wral cuni crab ciin con0 word limord elon sylibr cfval fvex dfiin2 df-rex
      cpw ancom rabid elpw2 anbi1i coflim pm5.32da anbi2d exbidv abbidv syl5req
      syl inteqd eqtrd ) BGZBHIZDJAJZKIZLZVJBMZEJFJMFVJNEBUAZOZOZAPZDQZRZAVJUBB
      LZABUNZUCZVKUDZVHBUESZVIVSLVHBUFWDBUGBCUHUIDAEFBUJVEVHWCVLAWBNZDQZRVSADWB
      VKVJKUKULVHWFVRVHWEVQDWEVJWBSZVLOZAPVHVQVLAWBUMVHWHVPAWHVLWGOVHVPWGVLUOVH
      WGVOVLWGVJWASZVTOZVHVOVTAWAUPWJVMVTOVHVOWIVMVTVJBCUQURVHVMVTVNEFBVJUSUTTT
      VATVBTVCVFVDVG $.
  $}

  ${
    $d A s y $.  $d A w x y z $.  $d s t y $.
    cflim2.1 $e |- A e. _V $.
    $( The cofinality function is a limit ordinal iff its argument is.
       (Contributed by Mario Carneiro, 28-Feb-2013.)  (Revised by Mario
       Carneiro, 15-Sep-2013.) $)
    cflim2 $p |- ( Lim A <-> Lim ( cf ` A ) ) $=
      ( vy vt vs vx wlim ccf com wss wceq wcel wa wn cep wbr con0 wb c0 c1o cfv
      cv cuni cpw crab ccrd ciin wral rabid elpw2 w3a ccnv wrex wel word limord
      ordsson sstr expcom 3syl imp 3adant3 ssel2 eloni ordirr ssel com12 adantl
      mtod sylan simpl2 simpl3 sseq1d mtbird unissb sylnib nrexdv ontri1 ancoms
      wi mtand vex brcnv epel notbii syl6bbr a1i syl2and impl ralbidva rexbidva
      bitri syl mtbid cvv wfr wne wwe wor cfn epweon wess mpi weso cnvso adantr
      sylib csdm cen onssnum mpan cardid2 ensym nnsdom ensdomtr syl2an isfinite
      sylibr wofi syl2anc wefr ssid unieq uni0 syl6eq eqeq1 syl5ib nlim0 mtbiri
      cdm limeq syl6 cab fvex sseq2 bibi12d mpbiri rexlimivw wo fveq2 fri ordom
      necon2ad impcom 3adant2 syl22anc ordtri1 syl3an2b 3expb sylan2b ralrimiva
      cardon mp2b ssiin cflim3 cint dfiin2 cardlim ss2abi eleq1 abssi syl6eqelr
      sseqtr4d intex onint sylancr sseldi eqeltrd elab mpbid csuc ordzsl df-3or
      w3o orcom df-or 3bitri cf0 1n0 csn df1o2 unieqi 0ex unisn neeqtrri limuni
      eqtri necon3ai ax-mp cfsuc sylan9eqr rexlimiva jaoi con4d cff fdmi eleq2i
      ndmfv sylnbir pm2.21d pm2.61i impbii ) AGZAHUAZGZUXCIUXDJZUXEUXCICCUBZUCZ
      AKZCAUDZUEZUXGUFUAZUGZUXDUXCIUXLJZCUXKUHIUXMJUXCUXNCUXKUXGUXKLUXCUXGUXJLZ
      UXIMUXNUXICUXJUIUXCUXOUXIUXNUXOUXCUXGAJZUXIUXNUXGABUJUXCUXPUXIUKZUXLILZNZ
      UXNUXQUXRDUBZEUBZOULZPZNZDUXGUHZEUXGUMZUXQUXTUYAJZDUXGUHZEUXGUMZUYFUXQUYH
      EUXGUXQECUNZMZUXHUYAJZUYHUYKUYLAUYAJZUYKUYMUXGUYAJZUXQUXGQJZUYJUYNNUXCUXP
      UYOUXIUXCUXPUYOUXCAUOZAQJZUXPUYOVTAUPAUQUXPUYQUYOUXGAQURUSUTVAVBZUYOUYJMZ
      UYNEEUNZUYSUYAQLZUYAUOUYTNUXGQUYAVCUYAVDUYAVEUTUYJUYNUYTVTUYOUYNUYJUYTUXG
      UYAUYAVFVGVHVIVJUYKUXPUYMUYNUXCUXPUXIUYJVKUXGAUYAURVJWAUYKUXHAUYAUXCUXPUX
      IUYJVLVMVNDUXGUYAVOVPVQUXQUYOUYIUYFRUYRUYOUYHUYEEUXGUYSUYGUYDDUXGUYOUYJDC
      UNZUYGUYDRZUYOUYJVUAVUBUXTQLZVUCUXGQUYAVFUXGQUXTVFVUAVUDMZVUCVTUYOVUEUYGE
      DUNZNZUYDVUDVUAUYGVUGRUXTUYAVRVSUYCVUFUYCUYAUXTOPVUFUXTUYAODWBEWBWCEDWDWL
      WEWFWGWHWIWJWKWMWNUXQUXRMZUXGWOLZUXGUYBWPZUXGUXGJZUXGSWQZUYFVUIVUHCWBZWGV
      UHUXGUYBWRZVUJUXQUYOUXRVUNUYRUYOUXRMZUXGUYBWSZUXGWTLZVUNUYOVUPUXRUYOUXGOW
      SZVUPUYOUXGOWRZVURUYOQOWRVUSXAUXGQOXBXCUXGOXDWMUXGOXEXGXFVUOUXGIXHPZVUQUY
      OUXGUXLXIPZUXLIXHPVUTUXRUYOUXGUFYJLZUXLUXGXIPVVAVUIUYOVVBVUMUXGWOXJXKUXGX
      LUXLUXGXMUTUXLXNUXGUXLIXOXPUXGXQXRUXGUYBXSXTVJUXGUYBYAWMVUKVUHUXGYBWGUXQV
      ULUXRUXCUXIVULUXPUXIUXCVULUXIUXCUXGSUXIUXGSKZASKZUXCNZVVCUXHSKUXIVVDVVCUX
      HSUCSUXGSYCYDYEUXHASYFYGVVDUXCSGZYHASYKYIYLUUCUUDUUEXFEDUXGUXGWOUYBUUAUUF
      WAUXLQLZUXLUOZUXNUXSRZUXGUULZUXLVDIUOVVHVVIUUBIUXLUUGXKUUMXRUUHUUIUUJUUKC
      UXKUXLIUUNXRCABUUOZUVCUXCUXDIFUBZJZVVLGZRZFYMZLUXFUXERZUXCUXDVVLUXLKZCUXK
      UMZFYMZUUPZVVPUXCUXDUXMVWAVVKCFUXKUXLUXGUFYNUUQYEZUXCVVTVVPVWAVVSVVOFVVRV
      VOCUXKVVRVVOUXNUXLGZRUXGUURVVRVVMUXNVVNVWCVVLUXLIYOVVLUXLYKYPYQYRUUSUXCVV
      TQJVVTSWQZVWAVVTLVVSFQVVRVVLQLZCUXKVVRVWEVVGVVJVVLUXLQUUTYQYRUVAUXCVWAWOL
      VWDUXCVWAUXDWOVWBAHYNZUVBVVTUVDXRVVTUVEUVFUVGUVHVVOVVQFUXDVWFVVLUXDKVVMUX
      FVVNUXEVVLUXDIYOVVLUXDYKYPUVIXGUVJAQLZUXEUXCVTVWGUXCUXEVWGVVEVVDAVVLUVKZK
      ZFQUMZYSZUXENZVWGVVDVWJUXCUVNZVVEVWKVTZVWGUYPVWMAVDFAUVLXGVWMVWKUXCYSUXCV
      WKYSVWNVVDVWJUXCUVMVWKUXCUVOUXCVWKUVPUVQXGVVDVWLVWJVVDUXEVVFYHVVDUXDSKZUX
      EVVFRZVVDUXDSHUASASHYTUVRYEUXDSYKZWMYIVWIVWLFQVWEVWIMZUXETGZTTUCZWQVWSNTS
      VWTUVSVWTSUVTZUCSTVXAUWAUWBSUWCUWDUWGUWEVWSTVWTTUWFUWHUWIVWRUXDTKUXEVWSRV
      WIVWEUXDVWHHUATAVWHHYTVVLUWJUWKUXDTYKWMYIUWLUWMYLUWNVWGNZUXEUXCVXBUXEVVFY
      HVXBVWOVWPVWGAHYJZLVWOVXCQAQQHUWOUWPUWQAHUWRUWSVWQWMYIUWTUXAUXB $.
  $}

  $( Value of the cofinality function at omega (the set of natural numbers).
     Exercise 4 of [TakeutiZaring] p. 102.  (Contributed by NM, 23-Apr-2004.)
     (Proof shortened by Mario Carneiro, 11-Jun-2015.) $)
  cfom $p |- ( cf ` om ) = om $=
    ( com ccf cfv cfle wlim wss limom omex cflim2 mpbi limomss ax-mp eqssi ) AB
    CZAADNEZANFAEOGAHIJNKLM $.

  ${
    $d A x y $.
    cfss.1 $e |- A e. _V $.
    $( There is a cofinal subset of ` A ` of cardinality ` ( cf `` A ) ` .
       (Contributed by Mario Carneiro, 24-Jun-2013.) $)
    cfss $p |- ( Lim A -> E. x ( x C_ A /\ x ~~ ( cf ` A ) /\ U. x = A ) ) $=
      ( vy cv cuni wceq wcel cfv ccrd wex wss cen wbr wrex fvex con0 syl sylib
      wa wlim cpw crab ccf w3a cab ciin cflim3 cint dfiin2 c0 wne cardon mpbiri
      eleq1 rexlimivw abssi limuni eqcomd fveq2 biantrud unieq eqeq1d biantrurd
      bitr3d anbi1d bitr2d spcev df-rex rabid anbi1i exbii bitri sylibr rexbidv
      pwid eqeq1 abn0 onint sylancr syl5eqel eqeltrd simprl simpld elpwid simpl
      elab cdm cvv vex word limord ordsson sylan2 onssnum cardid2 ensymd simprr
      sstr syl2anc breqtrrd simprd 3jca ex eximdv mpd ) BUAZAEZXHFZBGZABUBZUCZH
      ZBUDIZXHJIZGZTZAKZXHBLZXHXNMNZXJUEZAKXGXPAXLOZXRXGXNDEZXOGZAXLOZDUFZHYBXG
      XNAXLXOUGZYFABCUHXGYGYFUIZYFADXLXOXHJPUJXGYFQLYFUKULZYHYFHYEDQYDYCQHZAXLY
      DYJXOQHXHUMYCXOQUOUNUPUQXGYEDKZYIXGBJIZXOGZAXLOZYKXGXHXKHZXJTZYMTZAKZYNXG
      BFZBGZYRXGBYSBURUSYQYTABCXHBGZYTYTYMTYQUUAYMYTUUAXOYLXHBJUTUSVAUUAYTYPYMU
      UAXJYTYPUUAXIYSBXHBVBVCUUAYOXJUUAYOBXKHBCVPXHBXKUOUNVDVEVFVGVHRYNXMYMTZAK
      YRYMAXLVIUUBYQAXMYPYMXJAXKVJZVKVLVMVNYEYNDYLBJPYCYLGYDYMAXLYCYLXOVQVOVHRY
      EDVRVNYFVSVTWAWBYEYBDXNBUDPYCXNGYDXPAXLYCXNXOVQVOWGSXPAXLVISXGXQYAAXGXQYA
      XGXQTZXSXTXJUUDXHBUUDYOXJUUDXMYPXGXMXPWCUUCSZWDWEZUUDXHXOXNMUUDXSXGXHXOMN
      UUFXGXQWFXSXGTZXOXHUUGXHJWHHZXOXHMNUUGXHWIHXHQLZUUHAWJXGXSBQLZUUIXGBWKUUJ
      BWLBWMRXHBQWSWNXHWIWOVTXHWPRWQWTXGXMXPWRXAUUDYOXJUUEXBXCXDXEXF $.
  $}

  ${
    $d A x $.  $d B x $.
    cfslb.1 $e |- A e. _V $.
    $( Any cofinal subset of ` A ` is at least as large as ` ( cf `` A ) ` .
       (Contributed by Mario Carneiro, 24-Jun-2013.) $)
    cfslb $p |- ( ( Lim A /\ B C_ A /\ U. B = A ) -> ( cf ` A ) ~<_ B ) $=
      ( vx wss cuni wceq cfv ccrd cdom wbr cvv wcel wex anbi12d sseq1d syl con0
      wa syl2anc wlim w3a ccf cen fvex cv cpw crab ciin wrex ssid ssex ad2antrr
      elpw2 sseq1 syl5bb unieq eqeq1d fveq2 mpcom rabid exbii bitri mpan2 iinss
      spcegv df-rex anbi1i sylibr cflim3 syl5ibr 3impib ssdomg mpsyl cdm adantl
      word limord ordsson sstr2 mpan9 onssnum cardid2 3adant3 domentr ) AUAZBAE
      ZBFZAGZUBZAUCHZBIHZJKZWLBUDKZWKBJKWLLMWJWKWLEZWMBIUEWFWGWIWOWGWISZWOWFDDU
      FZFZAGZDAUGZUHZWQIHZUIZWLEZWPXBWLEZDXAUJZXDWPWLWLEZXFWLUKWPXGSZWQWTMZWSSZ
      XESZDNZXFBLMZXHXLWGXMWIXGBACULZUMXKXHDBLWQBGZXJWPXEXGXOXIWGWSWIXIWQAEXOWG
      WQACUNWQBAUOUPXOWRWHAWQBUQUROXOXBWLWLWQBIUSPOVFUTXFWQXAMZXESZDNXLXEDXAVGX
      QXKDXPXJXEWSDWTVAVHVBVCVIVDDXAXBWLVEQWFWKXCWLDACVJPVKVLWKWLLVMVNWFWGWNWIW
      FWGSZBIVOMZWNXRXMBREZXSWGXMWFXNVPWFAREZWGXTWFAVQYAAVRAVSQBARVTWABLWBTBWCQ
      WDWKWLBWET $.

    $( Any subset of ` A ` smaller than its cofinality has union less than
       ` A ` .  (This is the contrapositive to ~ cfslb .)  (Contributed by
       Mario Carneiro, 24-Jun-2013.) $)
    cfslbn $p |- ( ( Lim A /\ B C_ A /\ B ~< ( cf ` A ) ) -> U. B e. A ) $=
      ( wlim wss ccf cfv csdm wbr cuni wcel wa wn wceq imp word con0 syl syl6
      wo uniss limuni sseq2d syl5ibr wb limord ordsson sstr2 ssorduni ordsseleq
      syl5com jctird mpbid ord w3a cdom cfslb domnsym 3expia syld con4d 3impia
      ) ADZBAEZBAFGZHIZBJZAKZVCVDLZVHVFVIVHMVGANZVFMZVIVHVJVIVGAEZVHVJTZVCVDVLV
      DVLVCVGAJZEBAUAVCAVNVGAUBUCUDOVCVDVLVMUEZVCVDVGPZAPZLVOVCVDVPVQVCVDBQEZVP
      VCAQEZVDVRVCVQVSAUFZAUGRBAQUHUKBUISVTULVGAUJSOUMUNVCVDVJVKVCVDVJUOVEBUPIV
      KABCUQVEBURRUSUTVAVB $.

    $d A x y $.  $d B x y $.
    $( Any small collection of small subsets of ` A ` cannot have union ` A ` ,
       where "small" means smaller than the cofinality.  This is a stronger
       version of ~ cfslb .  This is a common application of cofinality: under
       AC, ` ( aleph `` 1 ) ` is regular, so it is not a countable union of
       countable sets.  (Contributed by Mario Carneiro, 24-Jun-2013.) $)
    cfslb2n $p |- ( ( Lim A /\ A. x e. B ( x C_ A /\ x ~< ( cf ` A ) ) ) ->
        ( B ~< ( cf ` A ) -> U. B =/= A ) ) $=
      ( vy cv wss csdm wbr wa wral cuni wceq cdom wi con0 ralimdv imp wcel syl
      wlim ccf cfv csuc ciun wrex cab wn word limord ordsson sstr 3syl onsucuni
      expcom syl6 adantrd uniiun ss2iun syl5eqss cfslbn 3expib ordsucss sylsyld
      iunss sseq1 eqss simplbi2com syl6bi com3l sylc limsuc sylibd r19.29 eleq1
      syl6ibr biimparc rexlimivw ex abssdv vex uniex sucex dfiun2 eqeq1i 3expia
      cfslb syl5bi syldan cmpt crn eqid rnmpt wfo wfn fnmpti dffn4 mpbi relsdom
      cvv brrelexi breq1 foeq2 breq2 imbi12d ccrd cfon sdomdom ondomen fodomnum
      cdm sylancr vtoclg mpcom syl5eqbrr domtr sylan2 domnsym pm2.01da necon2ad
      mpi a1i 3syld ) BUAZAFZBGZYEBUBUCZHIZJZACKZJZCYGHIZCLZBYKYMBMZACYELZUDZUE
      ZBMZYGEFZYPMZACUFZEUGZNIZYLUHZYKYMYQGZYQBGZYNYROYDYJUUEYDYJYEYPGZACKZUUEY
      DYIUUGACYDYFUUGYHYDYFYEPGZUUGYDBUIZBPGZYFUUIOBUJZBUKYFUUKUUIYEBPULUOUMYEU
      NUPUQQUUHYMACYEUEYQACURACYEYPUSUTUPRYDYJUUFYDYJYPBGZACKUUFYDYIUUMACYDUUJY
      IYOBSZUUMUULYDYFYHUUNBYEDVAVBZYOBVCVDQACYPBVEVPRYNUUEUUFYRYNUUEBYQGZUUFYR
      OYMBYQVFYRUUFUUPYQBVGVHVIVJVKYDYJUUBBGZYRUUCOYKUUAEBYKYPBSZACKZUUAYSBSZOY
      DYJUUSYDYIUURACYDYIUUNUURUUOBYOVLVMQRUUSUUAUUTUUSUUAJUURYTJZACUFUUTUURYTA
      CVNUVAUUTACYTUUTUURYSYPBVOVQVRTVSTVTYRUUBLZBMZYDUUQJUUCYQUVBBAECYPYOYEAWA
      WBWCZWDWEYDUUQUVCUUCBUUBDWGWFWHWIUUCUUDOYKUUCYLUUCYLJYGCNIZUUDYLUUCUUBCNI
      UVEYLUUBACYPWJZWKZCNAECYPUVFUVFWLZWMYLCUVGUVFWNZUVGCNIZUVFCWOUVIACYPUVFUV
      DUVHWPCUVFWQWRCWTSYLUVIUVJOZCYGHWSXAYSYGHIZYSUVGUVFWNZUVGYSNIZOZOYLUVKOEC
      WTYSCMZUVLYLUVOUVKYSCYGHXBUVPUVMUVIUVNUVJYSCUVGUVFXCYSCUVGNXDXEXEUVLYSXFX
      KSZUVOUVLYGPSYSYGNIUVQBXGYSYGXHYGYSXIXLYSUVGUVFXJTXMXNYAXOYGUUBCXPXQYGCXR
      TXSYBYCXT $.
  $}

  ${
    $d f g s t v w x z A $.  $d f s t v w x y z B $.  $d v C $.  $d v w y K $.
    $d g s t v x z O $.
    cofsmo.1 $e |- C = { y e. B | A. w e. y ( f ` w ) e. ( f ` y ) } $.
    cofsmo.2 $e |- K = |^| { x e. B | z C_ ( f ` x ) } $.
    cofsmo.3 $e |- O = OrdIso ( _E , C ) $.
    $( Any cofinal map implies the existence of a strictly monotone cofinal map
       with a domain no larger than the original.  Proposition 11.7 of
       [TakeutiZaring] p. 101.  (Contributed by Mario Carneiro,
       20-Mar-2013.) $)
    cofsmo $p |- ( ( Ord A /\ B e. On ) ->
      ( E. f ( f : B --> A /\ A. z e. A E. w e. B z C_ ( f ` w ) ) ->
          E. x e. suc B E. g ( g : x --> A /\ Smo g /\
            A. z e. A E. v e. x z C_ ( g ` v ) ) ) ) $=
      ( con0 wcel wa cfv wss vt vs word wrex wral wsmo w3a wex csuc cdm wfo cep
      cv wf wiso wf1o cvv wwe crab ssrab2 eqsstri ssexg mpan onss syl5ss epweon
      wess ee10 oiiso syl2anc ad2antlr isof1o f1ofo 3syl fof fss sylancl simplr
      syl oion wb eloni smoiso2 syl2an biimpar simprd syl21anc smorndom syl3anc
      onsssuc mpbid adantrr vex oiexg coexg sylancr simprl fco ordsson ad2antrr
      ccom simpr simpl ffvelrn wfn ffn jca smoel2 sylan fveq2 eleq2d raleqbi1dv
      wceq weq eleq1d cbvralv syl5bb cbvrabv eqtri elrab2 simprbi rspccv adantr
      wi sylc ordtr1 ancomsd imp fvco3 3eltr4d ralrimivva issmo2 cint sseq2d ex
      wn ffvelrnd mpd sylancom ralbidv syl13anc wne rabn0 inteqi onint syl5eqel
      c0 sylan2br elrab adantl simpr2 eleq2i simp21 simp1l simp22 simp1r 3impib
      sylib simp3 ontr1 ontri1 simp23 simpl1 sstr anim12i rabid sylibr syl31anc
      onnmin expr sylbird con4d syl5bi 3expia ralrimiv expcom 3expib com13 syld
      sylanbrc com23 imp31 foelrn simpllr biimpcd syl6 sylibrd reximdva ralimdv
      eleq1 impr 3jca feq1 smoeq fveq1 rexbidv 3anbi123d spcegv 3anbi13d exbidv
      feq2 rexeq rspcev exlimdv ) FUCZGPQZRZGFIUMZUNZCUMZDUMZUXHSZTZDGUDZCFUEZR
      ZAUMZFJUMZUNZUXRUFZUXJEUMZUXRSZTZEUXQUDZCFUEZUGZJUHZAGUIZUDZIUXGUXPUYIUXG
      UXPRZLUJZUYHQZUYKFUXRUNZUXTUYCEUYKUDZCFUEZUGZJUHZUYIUXGUXIUYLUXOUXGUXIRZU
      YKGTZUYLUYRUYKGLUNZLUFZGUCZUYSUYRUYKHLUKZUYTUYRUYKHULULLUOZUYKHLUPVUCUXFV
      UDUXEUXIUXFHUQQZHULURZVUDHGTZUXFVUEHUXLBUMZUXHSZQZDVUHUEZBGUSZGMVUKBGUTVA
      ZHGPVBVCZUXFHPTZPULURVUFUXFHGPVUMGVDZVEZVFHPULVGVHHULLUQOVIVJVKZUYKHULULL
      VLUYKHLVMVNZVUCUYKHLUNZVUGUYTUYKHLVOZVUMUYKHGLVPVQVSZUYRUYKPQZUXFVUDVUAUX
      FVVCUXEUXIUXFVUEVVCVUNHULLUQOVTVSVKZUXEUXFUXIVRZVURVVCUXFRZVUDRVUCVUAVVFV
      UCVUARZVUDVVCUYKUCZVUOVVGVUDWAUXFUYKWBZVUQUYKHLWCWDWEWFWGZUXFVUBUXEUXIGWB
      VKUYKGLWHWIUYRVVCUXFUYSUYLWAVVDVVEUYKGWJVJWKWLUYJUXHLXAZUQQZUYKFVVKUNZVVK
      UFZUXJUYAVVKSZTZEUYKUDZCFUEZUGZUYQUYJUXHUQQLUQQZVVLIWMUXFVVTUXEUXPUXFVUEV
      VTVUNHULLUQOWNVSVKUXHLUQUQWOWPUYJVVMVVNVVRUYJUXIUYTVVMUXGUXIUXOWQUXGUXIUY
      TUXOVVBWLUYKGFUXHLWRZVJUXGUXIVVNUXOUYRVVMFPTZVVHUAUMZVVKSZUBUMZVVKSZQZUAV
      WEUEUBUYKUEZVVNUYRUXIUYTVVMUXGUXIXBVVBVWAVJUXEVWBUXFUXIFWSZWTUYRVVCVVHVVD
      VVIVSUYRVWGUBUAUYKVWEUYRVWEUYKQZVWCVWEQZRZRZVWCLSZUXHSZVWELSZUXHSZVWDVWFV
      WMVWPHQZVWNVWPQZVWOVWQQZUYRVUTVWJVWRVWLUYRVUCVUTVUSVVAVSVWJVWKXCUYKHVWELX
      DWDUYRLUYKXEZVUARVWLVWSUYRVXAVUAUYRVUCVUTVXAVUSVVAUYKHLXFVNVVJXGUYKVWEVWC
      LXHXIVWRUXQUXHSZVWQQZAVWPUEZVWSVWTYDVWRVWPGQVXDVXBUXJUXHSZQZAUXJUEZVXDCVW
      PGHVXFVXCAUXJVWPUXJVWPXMVXEVWQVXBUXJVWPUXHXJXKXLHVULVXGCGUSMVUKVXGBCGVUKV
      XBVUIQZAVUHUEBCXNZVXGVUJVXHDAVUHDAXNZUXLVXBVUIUXKUXQUXHXJZXOXPVXHVXFAVUHU
      XJVXIVUIVXEVXBVUHUXJUXHXJXKXLXQXRXSXTYAVXCVWTAVWNVWPUXQVWNXMVXBVWOVWQUXQV
      WNUXHXJXOYBVSYEVWMUYTVWCUYKQZVWDVWOXMUYRUYTVWLVVBYCZUYRVWLVXLUYRVVCVVHVWL
      VXLYDVVDVVIVVHVWKVWJVXLVWCVWEUYKYFYGVNYHUYKGVWCUXHLYIVJVWMUYTVWJVWFVWQXMV
      XMUYRVWJVWKWQUYKGVWEUXHLYIVJYJYKVVMVWBVVHVWHUGVVNUBUAUYKFVVKYLYHUUAWLUXGU
      XIUXOVVRUYRUXNVVQCFUYRUXNVVQUYRUXNRZKUYALSZXMZEUYKUDZVVQVXNVUCKHQZVXQUYRV
      UCUXNVUSYCUXGUXIUXNVXRUXGUXNUXIVXRUXGUXNKGQZUXJKUXHSZTZRZUXIVXRYDUXFUXNVY
      BYDUXEUXFUXNVYBUXFUXNRZKUXMDGUSZQZVYBUXNUXFVYDUUGUUBZVYEUXMDGUUCUXFVYDPTZ
      VYFVYEUXFVYDGPUXMDGUTVUPVEZVYGVYFRKVYDYMZVYDKUXJVXBTZAGUSZYMVYINVYKVYDVYJ
      UXMADGADXNVXBUXLUXJUXQUXKUXHXJYNXRUUDXSZVYDUUEUUFXIUUHZUXMVYADKGUXKKXMUXL
      VXTUXJUXKKUXHXJYNUUIUURYOUUJUXIVYBUXGVXRUXIVXSVYAUXGVXRYDUXGUXIVXSVYAUGZV
      XRUXGVYNRZVXSUXLVXTQZDKUEZVXRUXGUXIVXSVYAUUKVYOVYPDKUXGVYNUXKKQZVYPUXGVYN
      VYRUGZVYRVYPUXGVYNVYRUUSZVYRUXKVYIQZVYSVYPKVYIUXKVYLUULVYSVYPWUAVYSVYPYPZ
      VXTUXLTZWUAYPZVYSVXTPQUXLPQWUCWUBWAVYSGPKUXHVYSUXIVWBGPUXHUNUXGUXIVXSVYAV
      YRUUMVYSUXEVWBUXEUXFVYNVYRUUNVWIVSGFPUXHVPVJZUXGUXIVXSVYAVYRUUOZYQVYSGPUX
      KUXHWUEVYSUXFVYRVXSUXKGQZUXEUXFVYNVYRUUPZVYTWUFUXFVYRVXSWUGUXKKGUUTUUQZWI
      YQVXTUXLUVAVJVYSUXFVYRVXSVYAWUCWUDYDWUHVYTWUFUXGUXIVXSVYAVYRUVBUXFVYRVXSU
      GZVYAWUCWUDWUJVYAWUCRZRZVYGUXKVYDQZWUDWULUXFVYGUXFVYRVXSWUKUVCVYHVSWULWUG
      UXMRWUMWUJWUGWUKUXMWUIUXJVXTUXLUVDUVEUXMDGUVFUVGVYDUXKUVIVJUVJUVHUVKUVLUV
      MYRUVNUVOVUKVYQBKGHVUJVYPDVUHKVUHKXMVUIVXTUXLVUHKUXHXJXKXLMXTUVTUVPUVQUVR
      UVSUWAUWBEUYKHKLUWCVJVXNVXPVVPEUYKVXNUYAUYKQZRZVXPUXJVXOUXHSZTZVVPVXNVXPW
      UQYDZWUNUYRUXNUXFWURUXEUXFUXIUXNUWDVYCVYEWURVYMVYEVXPVXOVYDQZWUQVXPVYEWUS
      KVXOVYDUWJUWEWUSVXOGQWUQVYJWUQAVXOGVYDUXQVXOXMVXBWUPUXJUXQVXOUXHXJYNUXMVY
      JDAGVXJUXLVXBUXJVXKYNXRXTYAUWFVSYSYCWUOVVOWUPUXJVXNWUNUYTVVOWUPXMUYRUYTUX
      NWUNVVBWTUYKGUYAUXHLYIYSYNUWGUWHYRYOUWIUWKUWLUYPVVSJVVKUQUXRVVKXMZUYMVVMU
      XTVVNUYOVVRUYKFUXRVVKUWMUXRVVKUWNWUTUYNVVQCFWUTUYCVVPEUYKWUTUYBVVOUXJUYAU
      XRVVKUWOYNUWPYTUWQUWRYEUYGUYQAUYKUYHUXQUYKXMZUYFUYPJWVAUXSUYMUYEUYOUXTUXQ
      UYKFUXRUXAWVAUYDUYNCFUYCEUXQUYKUXBYTUWSUWTUXCVJYOUXD $.
  $}

  ${
    $d f g t w x y z A $.  $d f t y z F $.  $d f w x y z G $.
    cfsmolem.2 $e |- F = ( z e. _V |->
      ( ( g ` dom z ) u. U_ t e. dom z suc ( z ` t ) ) ) $.
    cfsmolem.3 $e |- G = ( recs ( F ) |` ( cf ` A ) ) $.
    $( Lemma for ~ cfsmo .  (Contributed by Mario Carneiro, 28-Feb-2013.) $)
    cfsmolem $p |- ( A e. On -> E. f ( f : ( cf ` A ) --> A /\ Smo f /\
        A. z e. A E. w e. ( cf ` A ) z C_ ( f ` w ) ) ) $=
      ( vx vy con0 wcel cfv wss wral wa wceq syl ccf wf1 wrex wex wsmo w3a cff1
      cv wf oneli 3ad2ant3 wi weq eleq1 3anbi3d fveq2 eleq1d imbi12d wel simpl1
      cfon simpl2 ontr1 ax-mp ancoms 3ad2antl3 syl3anc ralimdva crecs csuc ciun
      pm2.27 cun cres fveq1i fvres syl5eq cdm recsval cvv wfun wfn recsfnon vex
      fnfun resfunexg mp2an dmeq fveq2d fveq1 suceq iuneq12d uneq12d fvex sucex
      dmex iunex unex syl6eq onss fnssres sylancr iuneq1 iuneq2i cbviunv eqtr4i
      fvmpt fndm 3syl eqtrd 3ad2ant2 word eloni adantl 3ad2ant1 adantlr adantrl
      ad2antrr sylbid 3impia wb onelon ex syl2anc adantr ffnfv anassrs imp feq1
      eliun sseq2d rexbidv ralbidv spcev com12 3expia ralrimiv sylibr expcom
      mpd ffvelrnda 3adant3 ordsucss iunss syl6ibr suceloni syl6 iunonOLD simp1
      f1f wo onsseleq idd simpll simprr eqtr4d ralbidva biimpa sylanbrc biimpar
      wn eleq2 3adant1 ffvelrn eqeltrrd sylan2 onsssuc rexbidva syl6bbr 3adant2
      mpbird 3expa ralrimiva rexbiia syl6bb anbi12d cfflb syl21anc ontri1 mpbid
      expl pm2.21dd exp3acom23 3impib jaod 3adant1l ordunel eqeltrd 3impa tfis2
      a1i mpcom onssi fneq1i mpbiran onordi sucid eleq2d rspcev mpan2 syl6eleqr
      syld elun2 eleqtrrd 3eltr4d rgen issmo2 mp3an23 sseq12d syl5sseqr vtoclga
      sylc ssun1 sstr reximia ralimi ad2antlr fnex smoeq 3anbi123d exlimdv ) DM
      NZDUAOZDFUHZUBZAUHZBUHZUYDOZPZBUYCUCZADQZRZFUDUYCDEUHZUIZUYMUEZUYFUYGUYMO
      ZPZBUYCUCZADQZUFZEUDZABDFUGUYBUYLVUAFUYLUYBVUAUYLUYBRUYCDHUIZHUEZUYFUYGHO
      ZPZBUYCUCZADQZVUAUYEUYBVUBUYKUYEUYBRZKUHZHOZDNZKUYCQZVUBVUHVUKKUYCUYEUYBV
      UIUYCNZVUKVUIMNZUYEUYBVUMUFZVUKVUMUYEVUNUYBUYCVUIDVAZUJZUKVUOVUKULZUYEUYB
      LUHZUYCNZUFZVUSHOZDNZULZKLKLUMZVUOVVAVUKVVCVVEVUMVUTUYEUYBVUIVUSUYCUNUOVV
      EVUJVVBDVUIVUSHUPUQURVVDLVUIQZVURULVUNVUOVVFVUKVUOVVFVVCLVUIQZVUKVUOVVDVV
      CLVUIVUOLKUSZRUYEUYBVUTVVDVVCULUYEUYBVUMVVHUTUYEUYBVUMVVHVBVUMUYEVVHVUTUY
      BVVHVUMVUTUYCMNZVVHVUMRZVUTULVUPVUSVUIUYCVCVDZVEVFVVAVVCVLVGVHUYEUYBVUMVV
      GVUKULVUHVUMVVGVUKVUHVUMVVGUFZVUJVUIUYDOZLVUIVUSGVIZOZVJZVKZVMZDVUMVUHVUJ
      VVRSVVGVUMVUJVUIVVNOZVVRVUMVUJVUIVVNUYCVNZOVVSVUIHVVTJVOVUIUYCVVNVPVQZVUM
      VUNVVSVVRSZVUQVUNVVSVVNVUIVNZVRZUYDOZCVWDCUHZVWCOZVJZVKZVMZVVRVUNVVSVWCGO
      ZVWJVUIGVSVWCVTNZVWKVWJSVVNWAZVUIVTNVWLVVNMWBZVWMGWCZMVVNWEVDKWDZVVNVUIVT
      WFWGZAVWCUYFVRZUYDOZCVWRVWFUYFOZVJZVKZVMVWJVTGUYFVWCSZVWSVWEVXBVWIVXCVWRV
      WDUYDUYFVWCWHZWIVXCCVWRVWDVXAVWHVXDVXCVWTVWGSVXAVWHSVWFUYFVWCWJVWTVWGWKTW
      LWMIVWEVWIVWDUYDWNCVWDVWHVWCVWQWPVWGVWFVWCWNWOWQWRXGVDWSVUNVWCVUIWBZVWDVU
      ISZVWJVVRSVUNVWNVUIMPVXEVWOVUIWTMVUIVVNXAXBZVUIVWCXHVXFVWEVVMVWIVVQVWDVUI
      UYDUPVXFVWICVUIVWHVKZVVQCVWDVUIVWHXCVXHCVUIVWFVVNOZVJZVKZVVQCVUIVWHVXJCKU
      SVWGVXISVWHVXJSVWFVUIVVNVPVWGVXIWKTXDLCVUIVVPVXJLCUMVVOVXISVVPVXJSVUSVWFV
      VNUPVVOVXIWKTXEZXFWSWMXIXJZTXJZXKVVLDXLZVVMDNZVVQDNZVVRDNVUHVUMVXOVVGUYBV
      XOUYEDXMZXNXOVUHVUMVXPVVGUYEVUMVXPUYBUYEUYCDVUIUYDUYCDUYDUUJUUAXPUUBUYBVU
      MVVGVXQUYEUYBVUMVVGUFZVVQDPZVXQUYBVUMVVGVXTUYBVUMRZVVGVVPDPZLVUIQVXTVYAVV
      CVYBLVUIVYAVVHRZVVCVVODNZVYBVYCVVBVVODVVHVYAVVBVVOSZVVHVUMVYEUYBVVJVVBVUS
      VVTOZVVOVUSHVVTJVOVVJVUTVYFVVOSVVKVUSUYCVVNVPTVQZXQVEUQZUYBVYDVYBULZVUMVV
      HUYBVXOVYIVXRVVODUUCTXRXSVHLVUIVVPDUUDUUEXTVXSVXTVXQVVQDSZUUKZVXQVXSVVQMN
      ZUYBVXTVYKYAVXSVVPMNZLVUIQZVYLUYBVUMVVGVYNVYAVVCVYMLVUIVYCVVCVVOMNZVYMVYC
      VVCVYDVYOVYHUYBVYDVYOULVUMVVHUYBVYDVYODVVOYBZYCXRXSVVOUUFUUGVHXTLVUIVVPVW
      PVVOVUSVVNWNZWOUUHTUYBVUMVVGUUIVVQDUULYDVXSVXQVXQVYJVXSVXQUUMUYBVUMVVGVYJ
      VXQULZVUMVVGRZUYBVYRVYSVYJUYBVXQVYSVYJUYBRZVXQVYSVYTRZVUMVXQVUMVVGVYTUUNW
      UAUYCVUIPZVUMUVAZWUAUYBVUNVUIDUYMUIZVWFVUSUYMOZPZLVUIUCZCDQZRZEUDZWUBVYSV
      YJUYBUUOVUMVUNVVGVYTVUQXRWUAVUIDVWCUIZVWFVVOPZLVUIUCZCDQZWUJVYSWUKVYTVYSV
      XEVUSVWCOZDNZLVUIQZWUKVUMVXEVVGVUMVUNVXEVUQVXGTYEVUMVVGWUQVUMVVCWUPLVUIVU
      MVVHRZVVBWUODWURVVBVVOWUOVVHVUMVYEVYGVEVVHWUOVVOSZVUMVUSVUIVVNVPZXNUUPUQU
      UQUURLVUIDVWCYFUUSZYEVYSVYTWUNVYSWUKVYTWUNULWVAWUKVYJUYBWUNWUKVYJRZUYBRWU
      MCDWVBUYBVWFDNZWUMWUKVYJUYBWVCRZWUMWUKVYJWVDUFWUMVWFVVQNZVYJWVDWVEWUKVYJW
      VCWVEUYBVYJWVEWVCVVQDVWFUVBUUTXQUVCWUKWVDWUMWVEYAZVYJWVDWUKWVFWVDWUKRZWUM
      VWFVVPNZLVUIUCWVEWVGWULWVHLVUIWVDWUKVVHWULWVHYAZWVDWUKVVHRZRVWFMNZVYOWVIW
      VDWVKWVJDVWFYBYEUYBWVJVYOWVCWVJUYBVYDVYOWVJWUOVVODVVHWUSWUKWUTXNVUIDVUSVW
      CUVDUVEVYPUVFXPVWFVVOUVGYDYGUVHLVWFVUIVVPYJUVIVEUVJUVKUVLYGUVMUWATYHWUIWU
      KWUNREVWCVWQUYMVWCSZWUDWUKWUHWUNVUIDUYMVWCYIWVLWUGWUMCDWVLWUGVWFWUOPZLVUI
      UCWUMWVLWUFWVMLVUIWVLWUEWUOVWFVUSUYMVWCWJYKYLWVMWULLVUIVVHWUOVVOVWFWUTYKU
      VNUVOYMUVPYNYDUYBVUNRWUJWUBCLDVUIEUVQYHUVRVUMWUBWUCYAZVVGVYTVUMVVIVUNWVNV
      UPVUQUYCVUIUVSXBXRUVTUWBYCUWCYOUWDUWEXSYTUWFDVVMVVQUWGVGUWHYPUWIUXBYOUWKU
      WJUWLYPYQVUBHUYCWBZVULVWNUYCMPZWVOVWOUYCVUPUWMVWNWVPRVVTUYCWBWVOMUYCVVNXA
      UYCHVVTJUWNYRWGZKUYCDHYFUWOYRZXPUYEUYBVUCUYKVUHDMPZVUBVUCUYBWVSUYEDWTXNWV
      RWVSUYCXLZVVBVUJNZLVUIQZKUYCQZVUBVUCULUYCVUPUWPWWBKUYCVUMWWALVUIVVHVUMWWA
      VVJVVOVVSVVBVUJVVJVVOVVRVVSVVHVVOVVRNZVUMVVHVVOVVQNWWDVVHVVOVXKVVQVVHVVOV
      XJNZCVUIUCZVVOVXKNVVHVVOVVPNZWWFVVOVYQUWQWWEWWGCVUSVUICLUMZVXJVVPVVOWWHVX
      IVVOSVXJVVPSVWFVUSVVNUPVXIVVOWKTUWRUWSUWTCVVOVUIVXJYJYRVXLUXAVVOVVQVVMUXC
      TYEVVJVUNVWBVUMVUNVVHVUQXNVXMTUXDVYGVUMVUJVVSSVVHVWAXNUXEYSYQUXFVUBWVSWVT
      WWCUFVUCKLUYCDHUXGYOUXHUXLXPUYKVUGUYEUYBUYJVUFADUYIVUEBUYCUYGUYCNUYHVUDPZ
      UYIVUEULVVMVUJPWWIKUYGUYCKBUMVVMUYHVUJVUDVUIUYGUYDUPVUIUYGHUPUXIVUMVVRVVM
      VUJVVMVVQUXMVXNUXJUXKUYIWWIVUEUYFUYHVUDUXNYSTUXOUXPUXQUYTVUBVUCVUGUFEHWVO
      VVIHVTNWVQVUPUYCMHUXRWGUYMHSZUYNVUBUYOVUCUYSVUGUYCDUYMHYIUYMHUXSWWJUYRVUF
      ADWWJUYQVUEBUYCWWJUYPVUDUYFUYGUYMHWJYKYLYMUXTYNVGYSUYAYT $.
  $}

  ${
    $d A m f h w z $.  $d m f y h x g w s t z $.  $d m f x n g w s t z $.
    $( The map in ~ cff1 can be assumed to be a strictly monotone ordinal
       function without loss of generality.  (Contributed by Mario Carneiro,
       28-Feb-2013.) $)
    cfsmo $p |- ( A e. On -> E. f ( f : ( cf ` A ) --> A /\ Smo f /\
        A. z e. A E. w e. ( cf ` A ) z C_ ( f ` w ) ) ) $=
      ( vm vh vx vn cvv cv cdm cfv csuc ciun cun cmpt crecs wceq suceq syl cres
      ccf dmeq fveq2d fveq2 cbviunv fveq1 iuneq12d syl5eq uneq12d eqid cfsmolem
      cbvmptv ) ABECDFGIGJZKZFJZLZHUOHJZUNLZMZNZOZPZVCQCUBLUAZGAIVBAJZKZUPLZEVF
      EJZVELZMZNZOUNVERZUQVGVAVKVLUOVFUPUNVEUCZUDVLVAEUOVHUNLZMZNVKHEUOUTVOURVH
      RUSVNRUTVORURVHUNUEUSVNSTUFVLEUOVFVOVJVMVLVNVIRVOVJRVHUNVEUGVNVISTUHUIUJU
      MVDUKUL $.
  $}

  ${
    $d A f g h x z $.  $d A f g x y z $.  $d B f g h x z $.  $d B f g x y z $.
    $( Lemma for ~ cfcof , showing subset relation in one direction.
       (Contributed by Mario Carneiro, 9-Mar-2013.)  (Revised by Mario
       Carneiro, 26-Dec-2014.) $)
    cfcoflem $p |- ( ( A e. On /\ B e. On ) -> ( E. f ( f : B --> A /\ Smo f /\
        A. x e. A E. y e. B x C_ ( f ` y ) ) -> ( cf ` A ) C_ ( cf ` B ) ) ) $=
      ( vh vz vg con0 wcel cv wf cfv wss wrex wral wex wa wi com23 wsmo w3a ccf
      wf1 cff1 f1f ccom fco adantlr adantr r19.29 ffvelrn wfn ffn smoword exp32
      biimpd sylan syl7 expdimp 3imp2 sstr2 syl5com wb sseq2d adantll 3ad2antr1
      fvco3 expcom 3expia com4t imp exp3acom23 imp31 reximdva exp31 com34 imp3a
      sylibrd rexlimdv syl5 ralimdv impr coex wceq feq1 rexbidv ralbidv anbi12d
      vex fveq1 spcev syl2anc exp43 com24 3impia exlimiv com13 cfon cfflb mpan2
      syl sylan9r ) DIJZDCEKZLZXEUAZAKZBKZXEMZNZBDOZACPZUBZEQZDUCMZCFKZLZXHGKZX
      QMZNZGXPOZACPZRZFQZCIJZCUCMXPNZXDXPDHKZUDZXIXSYHMZNZGXPOZBDPZRZHQXOYESZBG
      DHUEYNYOHYIYMYOYIXPDYHLZYMYOSXPDYHUFXOYMYPYEXNYMYPYESSZEXFXGXMYQXFXGRZYPY
      MXMYEYRYPYMXMYEYRYPRZYMXMRZRXPCXEYHUGZLZXHXSUUAMZNZGXPOZACPZYEYSUUBYTXFYP
      UUBXGXPDCXEYHUHUIUJYSYMXMUUFYSYMRXLUUEACYSYMXLUUEYMXLRYLXKRZBDOYSUUEYLXKB
      DUKYSUUGUUEBDYSUUGXIDJZUUEYSYLXKUUHUUESZYSXKYLUUIYSXKUUHYLUUEYSXKUUHYLUUE
      SYSXKRZUUHRYKUUDGXPUUJUUHXSXPJZYKUUDSZUUJUUKUUHUULYSXKUUKUUHRZUULSUUMYKYS
      XKUUDUUKUUHYKYSXKUUDSZSYSUUKUUHYKUBZUUNYSUUORZXKXHYJXEMZNZUUDUUPXJUUQNZXK
      UURYSUUKUUHYKUUSYRYPUUKUUHYKUUSSZSYRUUHYPUUKRZUUTUVAYJDJZYRUUHUUTXPDXSYHU
      LXFXEDUMZXGUUHUVBUUTSSDCXEUNUVCXGRZUUHUVBUUTUVDUUHUVBRRYKUUSDXIYJXEUOUQUP
      URUSTUTVAXHXJUUQVBVCYSUUHUUKUUDUURVDZYKYPUUKUVEYRUVAUUCUUQXHXPDXSXEYHVHVE
      VFVGVSVIVJVKVLVMVNVOVPVQTVRTVTWAUTWBWCYDUUBUUFRFUUAXEYHEWJHWJWDXQUUAWEZXR
      UUBYCUUFXPCXQUUAWFUVFYBUUEACUVFYAUUDGXPUVFXTUUCXHXSXQUUAWKVEWGWHWIWLWMWNW
      OWPWQWRXBVLWQXBYFXPIJYEYGSDWSAGCXPFWTXAXC $.
  $}

  ${
    $d A f g s w x $.  $d A f g s w z $.  $d B f g h s w $.  $d B f g n t w $.
    $d B f g s w x y $.  $d C f g h s w $.  $d C f g t w $.  $d C f g s w z $.
    $d H h s w $.  $d n w y $.
    coftr.1 $e |- H = ( t e. C |->
      |^| { n e. B | ( g ` t ) C_ ( f ` n ) } ) $.
    $( If there is a cofinal map from ` B ` to ` A ` and another from ` C ` to
       ` A ` , then there is also a cofinal map from ` C ` to ` B ` .
       Proposition 11.9 of [TakeutiZaring] p. 102.  A limited form of
       transitivity for the "cof" relation.  This is really a lemma for
       ~ cfcof .  (Contributed by Mario Carneiro, 16-Mar-2013.) $)
    coftr $p |-
    ( E. f ( f : B --> A /\ Smo f /\ A. x e. A E. y e. B x C_ ( f ` y ) ) ->
      ( E. g ( g : C --> A /\ A. z e. A E. w e. C z C_ ( g ` w ) ) ->
          E. h ( h : C --> B /\ A. s e. B E. w e. C s C_ ( h ` w ) ) ) ) $=
      ( cv wss wa wi wcel wsmo cfv wrex wral w3a wex cvv cdm fdm dmex syl6eqelr
      wf crab cint cmpt wceq fveq2 sseq1d rabbidv inteqd cbvmptv eqtri syl5eqel
      vex mptexg syl ad2antrl wfn ffn smodm2 sylan 3adant3 adantr simpl3 simprl
      word simpl1 simpl2 ffvelrn 3ad2antl3 sseq1 rexbidv rspccv sylc wne ssrab2
      con0 ordsson syl5ss sseq2d rspcev rabn0 sylibr oninton syl2an eloni simpl
      intminss adantl ordtr2 imp syl22anc rexlimdvaa fmptd syl3anc syl5 expdimp
      c0 simprr syl2anc simpr jca elrab sstr2 smoword biimprd syl9r com23 imp4b
      expr syl5bi ralrimiv ssint fvmptg syl5ibrcom ex reximdvai ancoms syl32anc
      mpdd feq1 fveq1 ralbidv anbi12d spcegv 3impib exlimdv exlimiv ) GFIPZULZY
      SUAZAPZBPZYSUBZQZBGUCZAFUDZUEZHFJPZULZCPZDPZUUIUBZQZDHUCZCFUDZRZJUFHGKPZU
      LZNPZUULUURUBZQZDHUCZNGUDZRZKUFZSIUUHUUQUVFJUUHUUQUVFUUHUUQRZMUGTZHGMULZU
      UTUULMUBZQZDHUCZNGUDZUVFUUJUVHUUHUUPUUJHUGTZUVHUUJHUUIUHUGHFUUIUIUUIJVDUJ
      UKUVNMDHUUMLPZYSUBZQZLGUMZUNZUOZUGMEHEPZUUIUBZUVPQZLGUMZUNZUOUVTOEDHUWEUV
      SUWAUULUPZUWDUVRUWFUWCUVQLGUWFUWBUUMUVPUWAUULUUIUQURUSUTZVAVBZDHUVSUGVEVC
      VFVGUVGGVPZUUGUUJUVIUUHUWIUUQYTUUAUWIUUGYTYSGVHZUUAUWIGFYSVIZGYSVJVKVLVMZ
      YTUUAUUGUUQVNZUUHUUJUUPVOZUWIUUGUUJUEZDHUVSGMUWOUULHTZRZUWIUUMUUDQZBGUCZU
      VSGTZUWIUUGUUJUWPVQUWQUUGUUMFTZUWSUWIUUGUUJUWPVRUUJUWIUWPUXAUUGHFUULUUIVS
      VTUUFUWSAUUMFUUBUUMUPUUEUWRBGUUBUUMUUDWAWBWCWDUWIUWRUWTBGUWIUUCGTZUWRRZRZ
      UVSVPZUWIUVSUUCQZUXBUWTUXDUVSWGTZUXEUWIUVRWGQUVRXHWEZUXGUXCUWIUVRGWGUVQLG
      WFGWHWIUXCUVQLGUCUXHUVQUWRLUUCGUVOUUCUPUVPUUDUUMUVOUUCYSUQWJZWKUVQLGWLWMU
      VRWNWOUVSWPVFUWIUXCWQUXCUXFUWIUVQUWRLUUCGUXIWRWSUWIUXBUWRVOUXEUWIRUXFUXBR
      UWTUVSUUCGWTXAXBXCWDZUWHXDXEUVGUVLNGUVGUUTGTZUUTYSUBZUUMQZDHUCZUVLUVGUUPY
      TUXKUXNSUUHUUJUUPXIYTUUAUUGUUQVQZUUPYTUXKUXNYTUXKRUXLFTUUPUXNGFUUTYSVSUUO
      UXNCUXLFUUKUXLUPUUNUXMDHUUKUXLUUMWAWBWCXFXGXJUVGUWIUUGUUJUWJUUAUXKUXNUVLS
      ZSUWLUWMUWNUVGYTUWJUXOUWKVFYTUUAUUGUUQVRUWOUWJUUARZUXKUXPUXQUXKRZUWOUXPUX
      RUWORUXMUVKDHUXRUWOUWPUXMUVKSUXRUXMUWQUVKUXRUXMUWQUVKSUWQUWPUWTRZUXRUXMRZ
      UVKUWQUWPUWTUWOUWPXKUXJXLUXTUVKUXSUUTUVSQZUXTUUTUUCQZBUVRUDUYAUXTUYBBUVRU
      UCUVRTUXCUXTUYBUVQUWRLUUCGUXIXMUXRUXMUXBUWRUYBUXRUXBUXMUWRUYBSZUXQUXKUXBU
      XMUYCSUXMUWRUXLUUDQZUXQUXKUXBRRZUYBUXLUUMUUDXNUYEUYBUYDGUUTUUCYSXOXPXQXTX
      RXSYAYBBUUTUVRYCWMUXSUVJUVSUUTEUULUWEUVSHGMUWGOYDWJYEXFYFXRXGYGYHXTYIYJYB
      UVHUVIUVMUVFUVEUVIUVMRKMUGUURMUPZUUSUVIUVDUVMHGUURMYKUYFUVCUVLNGUYFUVBUVK
      DHUYFUVAUVJUUTUULUURMYLWJWBYMYNYOYPXEYFYQYR $.
  $}

  ${
    $d c f g h k r s t w x y z A $.  $d c f g h k r s t v w y z B $.
    $( If there is a cofinal map from ` A ` to ` B ` , then they have the same
       cofinality.  This was used as Definition 11.1 of [TakeutiZaring] p. 100,
       who defines an equivalence relation cof ` ( A , B ) ` and defines our
       ` cf ( B ) ` as the minimum ` B ` such that cof ` ( A , B ) ` .
       (Contributed by Mario Carneiro, 20-Mar-2013.) $)
    cfcof $p |- ( ( A e. On /\ B e. On ) -> ( E. f ( f : B --> A /\ Smo f /\
        A. z e. A E. w e. B z C_ ( f ` w ) ) -> ( cf ` A ) = ( cf ` B ) ) ) $=
      ( vh vr vt vg vs vc vk wcel wa cv cfv wss wrex wral wex vy vv vx con0 w3a
      wf wsmo ccf wceq cfcoflem imp wf1 cff1 f1f anim1i syl crab cint cmpt eqid
      eximi coftr syl5com csuc word wi eloni cfon cep coi cofsmo sylancl 3simpb
      onsuci oneli cfflb sylan2 syl5 onsssuc ibir ad2antlr sstrd exp31 rexlimdv
      wb syld sylan9 eqssd ex ) CUDMZDUDMZNZDCEOZUFWMUGAOBOWMPQBDRACSUEETZCUHPZ
      DUHPZUIWLWNNWOWPWLWNWOWPQABCDEUJUKWLWNWPWOQZWJWNWODFOZUFGOZHOZWRPZQHWORGD
      SNFTZWKWQWJWOCIOZUFZJOZWTXCPQHWORJCSZNZITZWNXBWJWOCXCULZXFNZITXHJHCIUMXJX
      GIXIXDXFWOCXCUNUOVAUPABJHUACDWOEIFUBUAWOUAOXCPUBOWMPQUBDUQURUSZGXKUTVBVCW
      KXBKOZDLOZUFZXMUGZWSXEXMPQJXLRGDSZUEZLTZKWOVDZRZWQWKDVEWOUDMZXBXTVFDVGCVH
      ZKUCGHJDWOXAUCOZWRPMHYCSUCWOUQZFLWSXLWRPQKWOUQURZYDVIVJZYDUTYEUTYFUTVKVLW
      KXRWQKXSWKXLXSMZXRWQWKYGNZXRNWPXLWOYHXRWPXLQZXRXNXPNZLTZYHYIXQYJLXNXOXPVM
      VAYGWKXLUDMZYKYIVFXSXLWOYBVNVOZGJDXLLVPVQVRUKYGXLWOQZWKXRYGYNYGYLYAYNYGWE
      YMYBXLWOVSVLVTWAWBWCWDWFWGUKWHWI $.
  $}

  ${
    $d A f x y $.
    $( The cofinality function is idempotent.  (Contributed by Mario Carneiro,
       7-Mar-2013.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    cfidm $p |- ( cf ` ( cf ` A ) ) = ( cf ` A ) $=
      ( vf vx vy con0 wcel ccf cfv wceq wss cfle a1i cv wf wsmo wrex w3a wex c0
      wral cfsmo wi cfon cfcoflem mpan2 mpd eqssd cf0 cdm cff fdmi eleq2i ndmfv
      wn sylnbir fveq2d 3eqtr4a pm2.61i ) AEFZAGHZGHZUTIUSVAUTVAUTJUSUTKLUSUTAB
      MZNVBOCMDMVBHJDUTPCATQBRZUTVAJZCDABUAUSUTEFVCVDUBAUCCDAUTBUDUEUFUGUSUNZSG
      HSVAUTUHVEUTSGUSAGUIZFUTSIVFEAEEGUJUKULAGUMUOZUPVGUQUR $.
  $}

  ${
    $d A f x y $.
    $( The cofinality of a limit aleph is the same as the cofinality of its
       argument, so if ` ( aleph `` A ) < A ` , then ` ( aleph `` A ) ` is
       singular.  Conversely, if ` ( aleph `` A ) ` is regular (i.e. weakly
       inaccessible), then ` ( aleph `` A ) = A ` , so ` A ` has to be rather
       large (see ~ alephfp ).  Proposition 11.13 of [TakeutiZaring] p. 103.
       (Contributed by Mario Carneiro, 9-Mar-2013.) $)
    alephsing $p |- ( Lim A -> ( cf ` ( aleph ` A ) ) = ( cf ` A ) ) $=
      ( vf vx vy cvv wcel cale cfv ccf wceq wa cv wsmo wrex wral con0 alephfnon
      wss sylancr c0 wlim w3a wex cres wfun wfn fnfun ax-mp simpl resfunexg crn
      wf limelon onss syl fnssres fvres adantl alephord2i imp eqeltrd ralrimiva
      sylan fnfvrnss syl2anc df-f sylanbrc cdm alephsmo fndm syl6eleqr alephlim
      smores ciun eleq2d eliun alephon onelssi reximi sylbi ralrimiv feq1 smoeq
      syl6bi fveq1 sylan9eq sseq2d rexbidva ralbidv 3anbi123d syl13anc wi cfcof
      spcegv mpd expcom wn cf0 fvprc fveq2d 3eqtr4a pm2.61d1 ) AUAZAEFZAGHZIHZA
      IHZJZXDXCXHXDXCKZAXEBLZULZXJMZCLZDLZXJHZRZDANZCXEOZUBZBUCZXHXIGAUDZEFZAXE
      YAULZYAMZXMXNGHZRZDANZCXEOZXTXIGUEZXDYBGPUFZYIQPGUGUHXDXCUIGAEUJSXIYAAUFZ
      YAUKXERZYCXIYJAPRZYKQXIAPFZYMAEUMZAUNUOPAGUPSZXIYKXNYAHZXEFZDAOYLYPXIYRDA
      XIYNXNAFZYRYOYNYSKYQYEXEYSYQYEJYNXNAGUQZURYNYSYEXEFXNAUSUTVAVCVBDAXEYAVDV
      EAXEYAVFVGXIGMAGVHZFYDVIXIAPUUAYOYJUUAPJQPGVJUHVKGAVMSXIYGCXEXIXMXEFXMDAY
      EVNZFZYGXIXEUUBXMDAEVLVOUUCXMYEFZDANYGDXMAYEVPUUDYFDAYEXMXNVQVRVSVTWDWAYB
      YCYDYHUBZXTXSUUEBYAEXJYAJZXKYCXLYDXRYHAXEXJYAWBXJYAWCUUFXQYGCXEUUFXPYFDAU
      UFYSKXOYEXMUUFYSXOYQYEXNXJYAWEYTWFWGWHWIWJWNUTWKXIXEPFYNXTXHWLAVQYOCDXEAB
      WMSWOWPXDWQZTIHTXFXGWRUUGXETIAGWSWTAIWSXAXB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Eight inequivalent definitions of finite set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F a b c d e f $.  $d R a b c d e f $.
    $( The range of a single-step monotone function from ` om ` into a
       partially ordered set is a chain.  (Contributed by Stefan O'Rear,
       3-Nov-2014.) $)
    sornom $p |- ( ( F Fn om /\ A. a e. om ( ( F ` a ) R ( F ` suc a ) \/
          ( F ` a ) = ( F ` suc a ) ) /\ R Po ran F ) -> R Or ran F ) $=
      ( vb vc vd ve com cv cfv wbr wceq wo weq wcel wa wrex wi fveq2 orbi12d wb
      wfn csuc wral crn wpo w3a w3o wor simp3 fvelrnb anbi12d 3ad2ant1 wss word
      reeanv nnord ordtri2or2 syl2an adantl vex eleq1 bi2anan9 anbi2d breqan12d
      sseq12 eqeqan12d imbi12d breq2d eqeq2d imbi2d eqid olci a1ii simpr2 suceq
      simplll fveq2d breq12d eqeq12d rspcva syl2anc simprr simprl fnfvelrn potr
      simpllr peano2 ad3antrrr syl13anc imp ancom2s orcd expr biimprcd orc syl6
      breq1 ex breq2 eqeq2 biimpd a1i 3adantr2 mpd findsg ancom1s impcom vtocl2
      jaod orim12d 3mix1 3mix2 jaoi 3mix3 eqcoms breq12 eqeq12 ancoms 3orbi123d
      a2d syl syl5ibcom rexlimdvva syl5bir sylbid ralrimivv df-so sylanbrc ) BH
      UBZCIZBJZYKUCZBJZAKZYLYNLZMZCHUDZBUEZAUFZUGZYTDIZEIZAKZDENZUUCUUBAKZUHZEY
      SUDDYSUDYSAUIYJYRYTUJUUAUUGDEYSYSUUAUUBYSOZUUCYSOZPZFIZBJZUUBLZFHQZGIZBJZ
      UUCLZGHQZPZUUGYJYRUUJUUSUAYTYJUUHUUNUUIUURFHUUBBUKGHUUCBUKULUMUUSUUMUUQPZ
      GHQFHQUUAUUGUUMUUQFGHHUPUUAUUTUUGFGHHUUAUUKHOZUUOHOZPZPZUULUUPAKZUULUUPLZ
      UUPUULAKZUHZUUTUUGUVDUVEUVFMZUVGUUPUULLZMZMZUVHUVDUUKUUOUNZUUOUUKUNZMZUVL
      UVCUVOUUAUVAUUKUOUUOUOUVOUVBUUKUQUUOUQUUKUUOURUSUTUVDUVMUVIUVNUVKUUAUUBHO
      ZUUCHOZPZPZUUBUUCUNZUUBBJZUUCBJZAKZUWAUWBLZMZRZRZUVDUVMUVIRZRDEUUKUUOFVAZ
      GVAZDFNZEGNZPZUVSUVDUWFUWHUWMUVRUVCUUAUWKUVPUVAUWLUVQUVBUUBUUKHVBUUCUUOHV
      BVCVDUWMUVTUVMUWEUVIUUBUUKUUCUUOVFUWMUWCUVEUWDUVFUWKUWLUWAUULUWBUUPAUUBUU
      KBSZUUCUUOBSZVEUWKUWLUWAUULUWBUUPUWNUWOVGTVHVHUUAUVRUVTUWEUVRUVTPUUAUWEUV
      QUVPUVTUUAUWERZUUAUWAUULAKZUWAUULLZMZRUUAUWAUWAAKZUWAUWALZMZRUUAUWAUUPAKZ
      UWAUUPLZMZRUUAUWAUUOUCZBJZAKZUWAUXGLZMZRUWPFGUUCUUBFDNZUWSUXBUUAUXKUWQUWT
      UWRUXAUXKUULUWAUWAAUUKUUBBSZVIUXKUULUWAUWAUXLVJTVKFGNZUWSUXEUUAUXMUWQUXCU
      WRUXDUXMUULUUPUWAAUUKUUOBSZVIUXMUULUUPUWAUXNVJTVKUUKUXFLZUWSUXJUUAUXOUWQU
      XHUWRUXIUXOUULUXGUWAAUUKUXFBSZVIUXOUULUXGUWAUXPVJTVKFENZUWSUWEUUAUXQUWQUW
      CUWRUWDUXQUULUWBUWAAUUKUUCBSZVIUXQUULUWBUWAUXRVJTVKUVPUUAUXBUXAUWTUWAVLVM
      VNUVBUVPPUUBUUOUNZPZUUAUXEUXJUXTUUAUXEUXJRZUXTUUAPZUUPUXGAKZUUPUXGLZMZUYA
      UYBUVBYRUYEUVBUVPUXSUUAVQUXTYJYRYTVOYQUYECUUOHCGNZYOUYCYPUYDUYFYLUUPYNUXG
      AYKUUOBSZUYFYMUXFBYKUUOVPVRZVSUYFYLUUPYNUXGUYGUYHVTTWAWBUXTYJYTUYEUYARYRU
      XTYJYTPZPZUYCUYAUYDUYJUYCUYAUYJUYCPUXCUXJUXDUYJUYCUXCUXJUYJUYCUXCPPUXHUXI
      UYJUXCUYCUXHUYJUXCUYCPZUXHUYJYTUWAYSOZUUPYSOZUXGYSOZUYKUXHRUXTYJYTWCUYJYJ
      UVPUYLUXTYJYTWDZUVBUVPUXSUYIWGHUUBBWEWBUYJYJUVBUYMUYOUVBUVPUXSUYIVQHUUOBW
      EWBUYJYJUXFHOZUYNUYOUVBUYPUVPUXSUYIUUOWHWIHUXFBWEWBYSUWAUUPUXGAWFWJWKWLWM
      WNUYCUXDUXJRUYJUYCUXDUXHUXJUXDUXHUYCUWAUUPUXGAWRWOUXHUXIWPWQUTXJWSUYDUYAR
      UYJUYDUXEUXJUYDUXCUXHUXDUXIUUPUXGUWAAWTUUPUXGUWAXATXBXCXJXDXEWSYAXFXGXHWN
      ZXIUUAUVBUVAUVNUVKRZUWGUUAUVBUVAPZPZUYRRDEUUOUUKUWJUWIDGNZEFNZPZUVSUYTUWF
      UYRVUCUVRUYSUUAVUAUVPUVBVUBUVQUVAUUBUUOHVBUUCUUKHVBVCVDVUCUVTUVNUWEUVKUUB
      UUOUUCUUKVFVUCUWCUVGUWDUVJVUAVUBUWAUUPUWBUULAUUBUUOBSZUUCUUKBSZVEVUAVUBUW
      AUUPUWBUULVUDVUEVGTVHVHUYQXIWLXKXEUVIUVHUVKUVEUVHUVFUVEUVFUVGXLUVFUVEUVGX
      MZXNUVGUVHUVJUVGUVEUVFXOUVHUULUUPVUFXPXNXNYBUUTUVEUUDUVFUUEUVGUUFUULUUBUU
      PUUCAXQUULUUBUUPUUCXRUUQUUMUVGUUFUAUUPUUCUULUUBAXQXSXTYCYDYEYFYGDEYSAYHYI
      $.
  $}

  $c Fin1a Fin2 Fin3 Fin4 Fin5 Fin6 Fin7 $.

  $( Extend class notation to include the class of Ia-finite sets. $)
  cfin1a $a class Fin1a $.

  $( Extend class notation to include the class of II-finite sets. $)
  cfin2 $a class Fin2 $.

  $( Extend class notation to include the class of IV-finite sets. $)
  cfin4 $a class Fin4 $.

  $( Extend class notation to include the class of III-finite sets. $)
  cfin3 $a class Fin3 $.

  $( Extend class notation to include the class of V-finite sets. $)
  cfin5 $a class Fin5 $.

  $( Extend class notation to include the class of VI-finite sets. $)
  cfin6 $a class Fin6 $.

  $( Extend class notation to include the class of VII-finite sets. $)
  cfin7 $a class Fin7 $.

  ${
    $d x y z w a b c d $.
    $( A set is Ia-finite iff it is not the union of two I-infinite sets.
       Equivalent to definition Ia of [Levy58] p. 2.  A I-infinite Ia-finite
       set is also known as an amorphous set.  This is the second of Levy's
       eight definitions of finite set.  Levy's I-finite is equivalent to our
       ~ df-fin and not repeated here.  These eight definitions are equivalent
       with Choice but strictly decreasing in strength in models where Choice
       fails; conversely, they provide a series of increasingly stronger
       notions of infiniteness.  (Contributed by Stefan O'Rear,
       12-Nov-2014.) $)
    df-fin1a $a |- Fin1a = { x |
      A. y e. ~P x ( y e. Fin \/ ( x \ y ) e. Fin ) } $.

    $( A set is II-finite (Tarski finite) iff every nonempty chain of subsets
       contains a maximum element.  Definition II of [Levy58] p. 2.
       (Contributed by Stefan O'Rear, 12-Nov-2014.) $)
    df-fin2 $a |- Fin2 = { x | A. y e. ~P ~P x ( ( y =/= (/) /\
      [C.] Or y ) -> U. y e. y ) } $.

    $( A set is IV-finite (Dedekind finite) iff it has no equinumerous proper
       subset.  Definition IV of [Levy58] p. 3.  (Contributed by Stefan O'Rear,
       12-Nov-2014.) $)
    df-fin4 $a |- Fin4 = { x | -. E. y ( y C. x /\ y ~~ x ) } $.

    $( A set is III-finite (weakly Dedekind finite) iff its power set is
       Dedekind finite.  Definition III of [Levy58] p. 2.  (Contributed by
       Stefan O'Rear, 12-Nov-2014.) $)
    df-fin3 $a |- Fin3 = { x | ~P x e. Fin4 } $.

    $( A set is V-finite iff it behaves finitely under ` +c ` .  Definition V
       of [Levy58] p. 3.  (Contributed by Stefan O'Rear, 12-Nov-2014.) $)
    df-fin5 $a |- Fin5 = { x | ( x = (/) \/ x ~< ( x +c x ) ) } $.

    $( A set is VI-finite iff it behaves finitely under ` X. ` .  Definition VI
       of [Levy58] p. 4.  (Contributed by Stefan O'Rear, 12-Nov-2014.) $)
    df-fin6 $a |- Fin6 = { x | ( x ~< 2o \/ x ~< ( x X. x ) ) } $.

    $( A set is VII-finite iff it cannot be infinitely well-ordered.
       Equivalent to definition VII of [Levy58] p. 4.  (Contributed by Stefan
       O'Rear, 12-Nov-2014.) $)
    df-fin7 $a |- Fin7 = { x | -. E. y e. ( On \ om ) x ~~ y } $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x X $.
    $( Definition of a Ia-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin1a $p |- ( A e. V -> ( A e. Fin1a <->
      A. y e. ~P A ( y e. Fin \/ ( A \ y ) e. Fin ) ) ) $=
      ( vx cv cfn wcel cdif cpw wral cfin1a wceq difeq1 eleq1d orbi2d raleqbidv
      wo pweq df-fin1a elab2g ) AEZFGZDEZUAHZFGZQZAUCIZJUBBUAHZFGZQZABIZJDBKCUC
      BLZUFUJAUGUKUCBRULUEUIUBULUDUHFUCBUAMNOPDAST $.

    $( Property of a Ia-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    fin1ai $p |- ( ( A e. Fin1a /\ X C_ A ) ->
      ( X e. Fin \/ ( A \ X ) e. Fin ) ) $=
      ( vx cfin1a wcel wss wa cpw cv cdif wo wral elpw2g biimpar isfin1a adantr
      cfn ibi wceq eleq1 difeq2 eleq1d orbi12d rspcv sylc ) ADEZBAFZGBAHZEZCIZQ
      EZAUJJZQEZKZCUHLZBQEZABJZQEZKZUFUIUGBADMNUFUOUGUFUOCADORPUNUSCBUHUJBSZUKU
      PUMURUJBQTUTULUQQUJBAUAUBUCUDUE $.

    $( Definition of a II-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin2 $p |- ( A e. V -> ( A e. Fin2 <-> A. y e. ~P ~P A ( ( y =/= (/) /\
      [C.] Or y ) -> U. y e. y ) ) ) $=
      ( vx cv c0 wne crpss wor wa cuni wcel wi cpw wral cfin2 wceq pweq raleqdv
      pweqd df-fin2 elab2g ) AEZFGUCHIJUCKUCLMZADEZNZNZOUDABNZNZODBPCUEBQZUDAUG
      UIUJUFUHUEBRTSDAUAUB $.

    $( Property of a II-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    fin2i $p |- ( ( ( A e. Fin2 /\ B C_ ~P A ) /\ ( B =/= (/) /\ [C.] Or B ) )
        -> U. B e. B ) $=
      ( vy cfin2 wcel cpw wss wa c0 wne crpss wor cuni cv wi wral cvv wb elpw2g
      pwexg syl biimpar isfin2 adantr wceq neeq1 soeq2 anbi12d unieq id eleq12d
      ibi imbi12d rspcv sylc imp ) ADEZBAFZGZHZBIJZBKLZHZBMZBEZUTBURFZEZCNZIJZV
      HKLZHZVHMZVHEZOZCVFPZVCVEOZUQVGUSUQURQEVGUSRADTBURQSUAUBUQVOUSUQVOCADUCUL
      UDVNVPCBVFVHBUEZVKVCVMVEVQVIVAVJVBVHBIUFVHBKUGUHVQVLVDVHBVHBUIVQUJUKUMUNU
      OUP $.

    $( Definition of a III-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin3 $p |- ( A e. Fin3 <-> ~P A e. Fin4 ) $=
      ( vx cfin3 wcel cv cpw cfin4 cab df-fin3 eleq2i cvv elex sylibr wceq pweq
      pwexb eleq1d elab3 bitri ) ACDABEZFZGDZBHZDAFZGDZCUCABIJUBUEBAUEUDKDAKDUD
      GLAPMTANUAUDGTAOQRS $.

    $( Definition of a IV-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin4 $p |- ( A e. V -> ( A e. Fin4 <->
      -. E. y ( y C. A /\ y ~~ A ) ) ) $=
      ( vx cv wpss cen wbr wa wex cfin4 wceq psseq2 breq2 anbi12d exbidv notbid
      wn df-fin4 elab2g ) AEZDEZFZUAUBGHZIZAJZRUABFZUABGHZIZAJZRDBKCUBBLZUFUJUK
      UEUIAUKUCUGUDUHUBBUAMUBBUAGNOPQDAST $.

    $( Infer that a set is IV-infinite.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    fin4i $p |- ( ( X C. A /\ X ~~ A ) -> -. A e. Fin4 ) $=
      ( vx cfin4 wcel cv cen wbr wa wex wn isfin4 ibi cvv relen brrelexi adantl
      wpss wceq psseq1 breq1 anbi12d spcegv mpcom nsyl3 ) ADEZCFZARZUGAGHZIZCJZ
      BARZBAGHZIZUFUKKCADLMBNEZUNUKUMUOULBAGOPQUJUNCBNUGBSUHULUIUMUGBATUGBAGUAU
      BUCUDUE $.

    $( Definition of a V-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin5 $p |- ( A e. Fin5 <-> ( A = (/) \/ A ~< ( A +c A ) ) ) $=
      ( vx cfin5 wcel cv c0 wceq ccda co csdm wbr wo cab df-fin5 eleq2i cvv 0ex
      id syl6eqel relsdom brrelexi eqeq1 oveq12d breq12d orbi12d elab3 bitri
      jaoi ) ACDABEZFGZUIUIUIHIZJKZLZBMZDAFGZAAAHIZJKZLZCUNABNOUMURBAUOAPDUQUOA
      FPUORQSAUPJTUAUHUIAGZUJUOULUQUIAFUBUSUIAUKUPJUSRZUSUIAUIAHUTUTUCUDUEUFUG
      $.

    $( Definition of a VI-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin6 $p |- ( A e. Fin6 <-> ( A ~< 2o \/ A ~< ( A X. A ) ) ) $=
      ( vx cfin6 wcel cv c2o wbr cxp wo cab df-fin6 eleq2i cvv relsdom brrelexi
      csdm jaoi wceq breq1 id xpeq12d breq12d orbi12d elab3 bitri ) ACDABEZFPGZ
      UFUFUFHZPGZIZBJZDAFPGZAAAHZPGZIZCUKABKLUJUOBAULAMDUNAFPNOAUMPNOQUFARZUGUL
      UIUNUFAFPSUPUFAUHUMPUPTZUPUFAUFAUQUQUAUBUCUDUE $.

    $( Definition of a VII-finite set.  (Contributed by Stefan O'Rear,
       16-May-2015.) $)
    isfin7 $p |- ( A e. V ->
      ( A e. Fin7 <-> -. E. y e. ( On \ om ) A ~~ y ) ) $=
      ( vx cv cen wbr con0 cdif wrex wn cfin7 wceq breq1 rexbidv notbid df-fin7
      com elab2g ) DEZAEZFGZAHRIZJZKBUAFGZAUCJZKDBLCTBMZUDUFUGUBUEAUCTBUAFNOPDA
      QS $.
  $}

  $( A set with less than two elements has 0 or 1.  (Contributed by Stefan
     O'Rear, 30-Oct-2014.) $)
  sdom2en01 $p |- ( A ~< 2o <-> ( A = (/) \/ A ~~ 1o ) ) $=
    ( c2o wbr cfn wcel c0 wceq c1o wo com con0 2onn sselii 1onn ccrd cfv eleq2i
    wb cardnn ax-mp csdm cen cdom onfin2 inss2 eqsstri sdomdom domfi sylancr id
    cin 0fin syl6eqel enfi mpbiri jaoi cpr df2o3 fvex elpr bitri a1i cdm finnum
    2on onenon cardsdom2 sylancl syl5bbr cardnueq0 syl eqeq2i carden2 pm5.21nii
    orbi12d 3bitr3d ) ABUACZADEZAFGZAHUBCZIZVQBDEABUCCVRJDBJKDUKDUDKDUEUFZLMABU
    GBAUHUIVSVRVTVSAFDVSUJULUMVTVRHDEZJDHWBNMZAHUNUOUPVRAOPZBEZWEFGZWEHGZIZVQWA
    WFWIRVRWFWEFHUQZEWIBWJWEURQWEFHAOUSUTVAVBWFWEBOPZEZVRVQWKBWEBJEWKBGLBSTQVRA
    OVCZEZBWMEZWLVQRAVDZBKEWOVEBVFTABVGVHVIVRWGVSWHVTVRWNWGVSRWPAVJVKWHWEHOPZGZ
    VRVTWQHWEHJEWQHGNHSTVLVRWNHWMEZWRVTRWPWCWSWDHVDTAHVMVHVIVOVPVN $.

  ${
    $d b c A $.  $d b c d G $.  $d b c M $.  $d b N $.  $d b c d ph $.
    infpssrlem.a $e |- ( ph -> B C_ A ) $.
    infpssrlem.c $e |- ( ph -> F : B -1-1-onto-> A ) $.
    infpssrlem.d $e |- ( ph -> C e. ( A \ B ) ) $.
    infpssrlem.e $e |- G = ( rec ( `' F , C ) |` om ) $.
    $( Lemma for ~ infpssr .  (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    infpssrlem1 $p |- ( ph -> ( G ` (/) ) = C ) $=
      ( c0 cfv ccnv crdg com cres fveq1i cdif wcel wceq fr0g syl syl5eq ) AKFLK
      EMZDNOPZLZDKFUEJQADBCRZSUFDTIDUGUDUAUBUC $.

    $( Lemma for ~ infpssr .  (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    infpssrlem2 $p |- ( M e. om -> ( G ` suc M ) = ( `' F ` ( G ` M ) ) ) $=
      ( com wcel csuc ccnv crdg cres cfv frsuc fveq1i fveq2i 3eqtr4g ) GLMGNZEO
      ZDPLQZRGUERZUDRUCFRGFRZUDRDGUDSUCFUEKTUGUFUDGFUEKTUAUB $.

    $( Lemma for ~ infpssr .  (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    infpssrlem3 $p |- ( ph -> G : om --> A ) $=
      ( vc vb com wfn cfv wcel c0 wceq fveq2 eleq1d cv wral wf ccnv crdg frfnom
      cres fneq1i mpbir a1i csuc infpssrlem1 eldifad eqeltrd wa wss adantr wf1o
      f1ocnv f1of 3syl ffvelrnda sseldd infpssrlem2 exp3a finds2 com12 ralrimiv
      syl5ibr ffnfv sylanbrc ) AFMNZKUAZFOZBPZKMUBMBFUCVLAVLEUDZDUEMUGZMNDVPUFM
      FVQJUHUIUJAVOKMVMMPAVOVOQFOZBPLUAZFOZBPZVSUKZFOZBPZAKLVMQRVNVRBVMQFSTVMVS
      RVNVTBVMVSFSTVMWBRVNWCBVMWBFSTAVRDBABCDEFGHIJULADBCIUMUNVSMPZAWAWDAWAUOZW
      DWEVTVPOZBPWFCBWGACBUPWAGUQABCVTVPACBEURBCVPURBCVPUCHCBEUSBCVPUTVAVBVCWEW
      CWGBABCDEFVSGHIJVDTVIVEVFVGVHKMBFVJVK $.

    $( Lemma for ~ infpssr .  (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    infpssrlem4 $p |- ( ( ph /\
      M e. om /\ N e. M ) -> ( G ` M ) =/= ( G ` N ) ) $=
      ( vb com wcel cfv wne wa wi wceq vc vd cv wral c0 fveq2 neeq1d raleqbi1dv
      csuc imbi2d ral0 a1i w3a ccnv wn wf1o f1ocnv f1of 3syl adantl infpssrlem3
      wf ffvelrnda ancoms eldifbd nelne2 syl2anc infpssrlem2 adantr infpssrlem1
      ffvelrnd 3netr4d 3adant3 neeq2d syl5ibr adantrd wrex simpr elnn 3ad2antl1
      peano2 simpl nnsuc nfv nfra1 nf3an nfan simpl3 word nnord ordsucelsuc syl
      wb mpbird adantrr rsp sylc wf1 ad2antlr adantll f1fveq syl12anc necon3bid
      f1of1 biimprd neeq12d adantlr sylibrd adantrl 3adantl3 expr eleq1 imbi12d
      mpd anbi2d mpbiri com3l rexlimd ex pm2.61ine ralrimiva cbvralv sylib 3exp
      a2d finds impcom rspccv 3impia ) AGNOZHGOZGFPZHFPZQZAYJRYLMUCZFPZQZMGUDZY
      KYNSYJAYRAUAUCZFPZYPQZMYSUDZSAUEFPZYPQZMUEUDZSAUBUCZFPZYPQZMUUFUDZSAUUFUI
      ZFPZYPQZMUUJUDZSAYRSUAUBGYSUETZUUBUUEAUUAUUDMYSUEUUNYTUUCYPYSUEFUFZUGUHUJ
      YSUUFTZUUBUUIAUUAUUHMYSUUFUUPYTUUGYPYSUUFFUFUGUHUJYSUUJTZUUBUUMAUUAUULMYS
      UUJUUQYTUUKYPYSUUJFUFUGUHUJYSGTZUUBYRAUUAYQMYSGUURYTYLYPYSGFUFUGUHUJUUEAU
      UDMUKULUUFNOZAUUIUUMUUSAUUIUUMUUSAUUIUMZUUKYTQZUAUUJUDUUMUUTUVAUAUUJUUTYS
      UUJOZRZUVASYSUEUUNUUTUVAUVBUUTUVAUUNUUKUUCQZUUSAUVDUUIUUSARZUUGEUNZPZDUUK
      UUCUVEUVGCODCOUOZUVGDQUVEBCUUGUVFABCUVFVBZUUSACBEUPZBCUVFUPZUVIJCBEUQZBCU
      VFURUSUTAUUSUUGBOZANBUUFFABCDEFIJKLVAZVCVDZVKAUVHUUSADBCKVEUTUVGDCVFVGUUS
      UUKUVGTZAABCDEFUUFIJKLVHZVIAUUCDTUUSABCDEFIJKLVJUTVLVMUUNYTUUCUUKUUOVNVOV
      PYSUEQZUVCUVAUVRUVCRZYSYOUIZTZMNVQZUVAUVSYSNOZUVRUWBUVCUWCUVRUUSAUVBUWCUU
      IUUSUVBRUVBUUJNOZUWCUUSUVBVRUUSUWDUVBUUFWAVIYSUUJVSVGVTUTUVRUVCWBMYSWCVGU
      VCUWBUVASUVRUVCUWAUVAMNUUTUVBMUUSAUUIMUUSMWDAMWDUUHMUUFWEWFUVBMWDWGUVAMWD
      UWAUVCYONOZUVAUWAUVCUWEUVASZSUUTUVTUUJOZRZUWEUUKUVTFPZQZSZSUUTUWGUWEUWJUU
      TUWGUWERZRZUUHUWJUWMUUIYOUUFOZUUHUUSAUUIUWLWHUUTUWGUWNUWEUUSAUWGUWNUUIUUS
      UWGRZUWNUWGUUSUWGVRUWOUUFWIZUWNUWGWMUUSUWPUWGUUFWJVIYOUUFWKWLWNVTWOUUHMUU
      FWPWQUUSAUWLUUHUWJSZUUIUVEUWEUWQUWGUVEUWERZUUHUVGYPUVFPZQZUWJUWRUWTUUHUWR
      UVGUWSUUGYPUWRBCUVFWRZUVMYPBOZUVGUWSTUUGYPTWMAUXAUUSUWEAUVJUVKUXAJUVLBCUV
      FXDUSWSUVEUVMUWEUVOVIAUWEUXBUUSANBYOFUVNVCWTBCUUGYPUVFXAXBXCXEUUSUWEUWJUW
      TWMAUUSUWERUUKUVGUWIUWSUUSUVPUWEUVQVIUWEUWIUWSTUUSABCDEFYOIJKLVHUTXFXGXHX
      IXJXNXKUWAUVCUWHUWFUWKUWAUVBUWGUUTYSUVTUUJXLXOUWAUVAUWJUWEUWAYTUWIUUKYSUV
      TFUFVNUJXMXPXQXRUTXNXSXTYAUVAUULUAMUUJYSYOTYTYPUUKYSYOFUFVNYBYCYDYEYFYGYQ
      YNMHGYOHTYPYMYLYOHFUFVNYHWLYI $.

    $( Lemma for ~ infpssr .  (Contributed by Stefan O'Rear, 30-Oct-2014.) $)
    infpssrlem5 $p |- ( ph -> ( A e. V -> om ~<_ A ) ) $=
      ( vb vc com wcel cv cfv wceq wral wa wf1 cdom wbr wf wi infpssrlem3 wo wn
      wne simpll simplrr simpr infpssrlem4 syl3anc necomd jaodan ex necon2bd wb
      simplrl word nnord ordtri3 syl2an adantl ralrimivva dff13 sylanbrc f1domg
      sylibrd syl5com ) ANBFUAZBGONBUBUCANBFUDLPZFQZMPZFQZRZVMVORZUEZMNSLNSVLAB
      CDEFHIJKUFAVSLMNNAVMNOZVONOZTZTZVQVMVOOZVOVMOZUGZUHZVRWCWFVNVPWCWFVNVPUIZ
      WCWDWHWEWCWDTZVPVNWIAWAWDVPVNUIAWBWDUJAVTWAWDUKWCWDULABCDEFVOVMHIJKUMUNUO
      WCWETAVTWEWHAWBWEUJAVTWAWEUTWCWEULABCDEFVMVOHIJKUMUNUPUQURWBVRWGUSZAVTVMV
      AVOVAWJWAVMVBVOVBVMVOVCVDVEVJVFLMNBFVGVHNBGFVIVK $.
  $}

  ${
    $d f y A $.  $d f y X $.
    $( Dedekind infinity implies existence of a denumerable subset: take a
       single point witnessing the proper subset relation and iterate the
       embedding.  (Contributed by Stefan O'Rear, 30-Oct-2014.)  (Revised by
       Mario Carneiro, 16-May-2015.) $)
    infpssr $p |- ( ( X C. A /\ X ~~ A ) -> om ~<_ A ) $=
      ( vy vf cv wcel wn wa wex wpss cen wbr com cdom pssnel adantr wi cdif cvv
      ex eldif wss pssss wf1o bren crn wfo wceq simpr f1ofo forn 3syl syl6eqelr
      vex rnex ccnv crdg cres simplr simpll eqid infpssrlem5 mpd exlimdv syl5bi
      syl5 imp3a sylbir exlimiv mpcom ) CEZAFVKBFGHZCIZBAJZBAKLZHZMANLZVNVMVOCB
      AOPVLVPVQQZCVLVKABRFZVRVKABUAVSVNVOVQVNBAUBZVSVOVQQZBAUCVSVTWAVOBADEZUDZD
      IVSVTHZVQBADUEWDWCVQDWDWCVQWDWCHZASFVQWEAWBUFZSWEWCBAWBUGWFAUHWDWCUIZBAWB
      UJBAWBUKULWBDUNUOUMWEABVKWBWBUPVKUQMURZSVSVTWCUSWGVSVTWCUTWHVAVBVCTVDVETV
      FVGVHVIVJ $.
  $}

  ${
    $d c f x A $.  $d c f x B $.
    $( Dedekind finite is a cardinal property.  (Contributed by Stefan O'Rear,
       30-Oct-2014.)  (Revised by Mario Carneiro, 16-May-2015.) $)
    fin4en1 $p |- ( A ~~ B -> ( A e. Fin4 -> B e. Fin4 ) ) $=
      ( vx vf cen wbr cfin4 wcel wi cv wpss wa wex wn wss wb syl2an syl2anc cvv
      cima ensym wf1o bren simpr wf1 f1of1 pssss ssid jctir f1imapss mpbird cdm
      imadmrn f1odm imaeq2d dff1o5 simprbi 3eqtr3a adantr psseq2d mpbid adantrr
      wceq crn vex f1imaen simprr entr f1oen3g mpan fin4i exlimdv con2d exlimiv
      ex sylbi relen brrelexi isfin4 syl sylibrd ) ABEFBAEFZAGHZBGHZIABUAWBWCCJ
      ZBKZWEBEFZLZCMZNZWDWBBADJZUBZDMWCWJIZBADUCWLWMDWLWIWCWLWHWCNZCWLWHWNWLWHL
      ZWKWETZAKZWPAEFZWNWLWFWQWGWLWFLZWPWKBTZKZWQWSXAWFWLWFUDWLBAWKUEZWEBOZBBOZ
      LXAWFPWFBAWKUFZWFXCXDWEBUGZBUHUIBAWEBWKUJQUKWSWTAWPWLWTAVCWFWLWKWKULZTWKV
      DZWTAWKUMWLXGBWKBAWKUNUOWLXBXHAVCBAWKUPUQURUSUTVAVBWOWPBEFZWBWRWOWPWEEFZW
      GXIWLWFXJWGWLXBXCXJWFXEXFBAWEWKCVEVFQVBWLWFWGVGWPWEBVHRWLWBWHWKSHWLWBDVEB
      AWKSVIVJUSWPBAVHRAWPVKRVOVLVMVNVPWBBSHWDWJPBAEVQVRCBSVSVTWAVT $.

    $( Dedekind finite sets have Dedekind finite subsets.  (Contributed by
       Stefan O'Rear, 30-Oct-2014.)  (Revised by Mario Carneiro, 16-May-2015.)
       (Revised by Mario Carneiro, 6-May-2015.) $)
    ssfin4 $p |- ( ( A e. Fin4 /\ B C_ A ) -> B e. Fin4 ) $=
      ( vx vc cfin4 wcel wss wa cv wpss cen wbr wex wn cun wceq simprr ad2antrl
      cin cvv simpll cdif pssss simpr difssd unssd pssnel adantl simpllr simprl
      sylan9ssr sseldd elndif wo ioran xchnxbir sylanbrc nelneq2 syl2anc sylnib
      elun eqcom exlimddv dfpss2 adantrr c0 difexg enrefg 3syl ssinss1 inssdif0
      syl sylib disjdif jctir unen syl21anc simplr undif breqtrd fin4i pm2.65da
      nexdv wb ssexg ancoms isfin4 mpbird ) AEFZBAGZHZBEFZCIZBJZWMBKLZHZCMNZWKW
      PCWKWPWIWIWJWPUAZWKWPHZWMABUBZOZAJZXAAKLWINWKWNXBWOWKWNHZXAAGXAAPZNZXBXCW
      MWTAWNWKWMBAWMBUCZWIWJUDUKXCABUEUFXCDIZBFZXGWMFZNZHZXEDWNXKDMWKDWMBUGUHXC
      XKHZAXAPZXDXLXGAFXGXAFZNZXMNXLBAXGWIWJWNXKUIXCXHXJUJULXLXJXGWTFZNZXOXCXHX
      JQXHXQXCXJXGBAUMRXIXPUNXJXQHXNXIXPUOXGWMWTVAUPUQXGAXAURUSAXAVBUTVCXAAVDUQ
      VEWSXABWTOZAKWSWOWTWTKLZWMWTSVFPZBWTSVFPZHXAXRKLWKWNWOQWSWIWTTFXSWRABEVGW
      TTVHVIWSXTYAWSWMASBGZXTWSWMBGZYBWNYCWKWOXFRWMABVJVLWMABVKVMBAVNVOWMBWTWTV
      PVQWSWJXRAPWIWJWPVRBAVSVMVTAXAWAUSWBWCWKBTFZWLWQWDWJWIYDBAEWEWFCBTWGVLWH
      $.

    $( A set dominated by a Dedekind finite set is Dedekind finite.
       (Contributed by Mario Carneiro, 16-May-2015.) $)
    domfin4 $p |- ( ( A e. Fin4 /\ B ~<_ A ) -> B e. Fin4 ) $=
      ( vx cfin4 wcel wbr wa cv cen wss wex domeng biimpa ensym ad2antrl ssfin4
      cdom ad2ant2rl fin4en1 sylc exlimddv ) ADEZBAQFZGZBCHZIFZUEAJZGZBDEZCUBUC
      UHCKCBADLMUDUHGUEBIFZUEDEZUIUFUJUDUGBUENOUBUGUKUCUFAUEPRUEBSTUA $.

    $( ` om ` is Dedekind infinite.  (Contributed by Stefan O'Rear,
       30-Oct-2014.)  (Proof shortened by Mario Carneiro, 16-May-2015.) $)
    ominf4 $p |- -. om e. Fin4 $=
      ( com cfin4 wcel id c0 csn cdif wpss cen wn peano1 difsnpss mpbi limenpsi
      wbr limom ensymd fin4i sylancr pm2.65i ) ABCZUAUADUAAEFGZAHZUBAIOUAJEACUC
      KEALMUAAUBABPNQAUBRST $.

    $( A set with a denumerable subset has a proper subset equinumerous to it,
       proved without AC or Infinity.  Unlike ~ infpss , it uses Replacement.
       (Contributed by Stefan O'Rear, 30-Oct-2014.)  (Revised by Mario
       Carneiro, 16-May-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    infpssALT $p |- ( om ~<_ A -> E. x ( x C. A /\ x ~~ A ) ) $=
      ( com cdom wbr cv wpss cen wa wex cfin4 ominf4 wn cvv wb reldom brrelex2i
      wcel isfin4 syl domfin4 expcom sylbird mt3i ) CBDEZAFZBGUFBHEIAJZCKRZLUEU
      GMZBKRZUHUEBNRUJUIOCBDPQABNSTUJUEUHBCUAUBUCUD $.
  $}

  ${
    $d x A $.
    $( Alternate definition of IV-finite sets: they lack a denumerable subset.
       (Contributed by Stefan O'Rear, 30-Oct-2014.)  (Revised by Mario
       Carneiro, 17-May-2015.) $)
    isfin4-2 $p |- ( A e. V -> ( A e. Fin4 <-> -. om ~<_ A ) ) $=
      ( vx wcel cfin4 cv wpss cen wbr wa wex wn com cdom isfin4 infpssr exlimiv
      infpss impbii notbii syl6bb ) ABDAEDCFZAGUBAHIJZCKZLMANIZLCABOUDUEUDUEUCU
      ECAUBPQCARSTUA $.
  $}

  $( Alternate definition of IV-finite sets: they are strictly dominated by
     their successors.  (Thus, the proper subset referred to in ~ isfin4 can be
     assumed to be only a singleton smaller than the original.)  (Contributed
     by Mario Carneiro, 18-May-2015.) $)
  isfin4-3 $p |- ( A e. Fin4 <-> A ~< ( A +c 1o ) ) $=
    ( cfin4 wcel c1o csdm wbr cdom cen wn con0 1on c0 csn cxp cvv wceq brrelexi
    sylancl mp1i syl ccda co cdadom3 mpan2 cop cun ssun1 relen cdaval syl5sseqr
    wpss 0lt1o elexi snid opelxpi mp2an elun2 eleqtrrd wne 1n0 opelxp2 necon3ai
    elsni ssnelpssd 0ex xpsneng entr mpancom fin4i syl2anc fin4en1 con2i brsdom
    mtod sylanbrc sdomnen infcda1 ensymd nsyl wb relsdom isfin4-2 mpbird impbii
    com ) ABCZAADUAUBZEFZWFAWGGFZAWGHFZIWHWFDJCZWIKADBJUCUDWJWFWJWFWGBCZWJALMZN
    ZWGUKWNWGHFZWLIWJWNWGLDUEZWJWNDDMZNZUFZWNWGWNWRUGWJAOCZWKWGWSPAWGHUHQZKADOJ
    UIRZUJWJWPWSWGWPWRCZWPWSCWJLDCDWQCXCULDDJKUMUNLDDWQUOUPWPWRWNUQSXBURDLUSWPW
    NCZIWJUTXDDLXDDWMCDLPLDAWMVADLVCTVBSVDWNAHFZWJWOWJWTLOCXEXAVEALOOVFRWNAWGVG
    VHWGWNVIVJAWGVKVNVLAWGVMVOWHWFWEAGFZIZWHWJXFAWGVPXFWGAAVQVRVSWHWTWFXGVTAWGE
    WAQAOWBTWCWD $.

  ${
    $d c v w x y z A $.  $d c v w x y z B $.  $d z ch $.  $d v ph $.  $d y V $.
    $d x ps $.  $d w th $.
    $( Lemma for ~ isfin2-2 .  The componentwise complement of a nonempty
       collection of sets is nonempty.  (Contributed by Stefan O'Rear,
       31-Oct-2014.)  (Revised by Mario Carneiro, 16-May-2015.) $)
    fin23lem7 $p |- ( ( A e. V /\ B C_ ~P A /\ B =/= (/) ) ->
      { x e. ~P A | ( A \ x ) e. B } =/= (/) ) $=
      ( vy wcel cpw wss c0 wne w3a cv cdif wrex crab wex wa n0 wceq simpr difss
      wb elpw2g ad2antrr mpbiri sselda elpwid dfss4 sylib eqeltrd difeq2 eleq1d
      rspcev syl2anc ex exlimdv syl5bi 3impia rabn0 sylibr ) BDFZCBGZHZCIJZKBAL
      ZMZCFZAVBNZVGAVBOIJVAVCVDVHVDELZCFZEPVAVCQZVHECRVKVJVHEVKVJVHVKVJQZBVIMZV
      BFZBVMMZCFZVHVLVNVMBHZBVIUAVAVNVQUBVCVJVMBDUCUDUEVLVOVICVLVIBHVOVISVLVIBV
      KCVBVIVAVCTUFUGVIBUHUIVKVJTUJVGVPAVMVBVEVMSVFVOCVEVMBUKULUMUNUOUPUQURVGAV
      BUSUT $.

    fin23lem11.1 $e |- ( z = ( A \ x ) -> ( ps <-> ch ) ) $.
    fin23lem11.2 $e |- ( w = ( A \ v ) -> ( ph <-> th ) ) $.
    fin23lem11.3 $e |- ( ( x C_ A /\ v C_ A ) -> ( ch <-> th ) ) $.
    $( Lemma for ~ isfin2-2 .  (Contributed by Stefan O'Rear, 31-Oct-2014.)
       (Revised by Mario Carneiro, 16-May-2015.) $)
    fin23lem11 $p |- ( B C_ ~P A -> ( E. x e. { c e. ~P A | ( A \ c ) e. B }
      A. w e. { c e. ~P A | ( A \ c ) e. B } -. ph ->
        E. z e. B A. v e. B -. ps ) ) $=
      ( wss wn cv cdif wcel wceq cpw crab wral wa wi difeq2 eleq1d elrab simp2r
      wrex w3a difss cvv wb ssun1 undif1 sseqtr4i simpl2r simpl2l unexg syl2anc
      cun ssexg sylancr elpw2g mpbiri simpl1 simpr sseldd elpwid dfss4 sylanbrc
      syl sylib eqeltrd simpl3 notbid rspcva simplrl adantlr 3adantl3 ralrimiva
      ssel2 mpbird ralbidv rspcev 3exp syl5bi rexlimdv ) JIUAZOZAPZGIKQZRZJSZKW
      JUBZUCZBPZHJUCZFJUJZEWPEQZWPSXAWJSZIXARZJSZUDZWKWQWTUEWOXDKXAWJWMXATWNXCJ
      WMXAIUFUGUHWKXEWQWTWKXEWQUKZXDCPZHJUCZWTWKXBXDWQUIXFXGHJXFHQZJSZUDZXGDPZX
      KIXIRZWPSZWQXLXKXMWJSZIXMRZJSZXNXKXOXMIOZIXIULXKIUMSZXOXRUNXKIXCXAVBZOXTU
      MSZXSIIXAVBXTIXAUOIXAUPUQXKXDXBYAXBXDWKWQXJURXBXDWKWQXJUSXCXAJWJUTVAIXTUM
      VCVDXMIUMVEVMVFXKXPXIJXKXIIOZXPXITXKXIIXKJWJXIWKXEWQXJVGXFXJVHZVIVJXIIVKV
      NYCVOWOXQKXMWJWMXMTWNXPJWMXMIUFUGUHVLWKXEWQXJVPWLXLGXMWPGQXMTADMVQVRVAWKX
      EXJXGXLUNWQWKXEUDXJUDZCDYDXAIOYBCDUNYDXAIWKXBXDXJVSVJYDXIIWKXJXIWJSXEJWJX
      IWCVTVJNVAVQWAWDWBWSXHFXCJFQXCTZWRXGHJYEBCLVQWEWFVAWGWHWI $.
  $}

  ${
    $d b c f m n w x y z A $.  $d c f m n w x z B $.  $d b V $.
    $( A II-finite set contains minimal elements for every nonempty chain.
       (Contributed by Mario Carneiro, 16-May-2015.) $)
    fin2i2 $p |- ( ( ( A e. Fin2 /\ B C_ ~P A ) /\ ( B =/= (/) /\ [C.] Or B ) )
        -> |^| B e. B ) $=
      ( vw vz vm vn vc cfin2 wcel wss wa c0 wne crpss wor cv wpss wn wral cdif
      cpw wrex cint crab simplr cuni simpll ssrab2 a1i simprl fin23lem7 syl3anc
      sorpsscmpl ad2antll fin2i syl22anc sorpssuni syl mpbird psseq2 pssdifcom2
      wb fin23lem11 sylc sorpssint mpbid ) AHIZBAUAZJZKZBLMZBNOZKZKZCPZDPZQZRCB
      SDBUBZBUCBIZVNVIEPZFPZQZRFAGPTBIZGVHUDZSEWDUBZVRVGVIVMUEZVNWEWDUFWDIZVNVG
      WDVHJZWDLMZWDNOZWGVGVIVMUGZWHVNWCGVHUHUIVNVGVIVKWIWKWFVJVKVLUJGABHUKULVLW
      JVJVKGABUMUNZAWDUOUPVNWJWEWGVBWLFEWDUQURUSWBVQVOAVTTZQVTAVOTZQEDFCABGVPWM
      VOUTWAWNVTUTVTVOAVAVCVDVLVRVSVBVJVKCDBVEUNVF $.

    $( ` Fin2 ` expressed in terms of minimal elements.  (Contributed by Stefan
       O'Rear, 2-Nov-2014.)  (Proof shortened by Mario Carneiro,
       16-May-2015.) $)
    isfin2-2 $p |- ( A e. V -> ( A e. Fin2 <-> A. y e. ~P ~P A
      ( ( y =/= (/) /\ [C.] Or y ) -> |^| y e. y ) ) ) $=
      ( vb vm vn vw vz vc wcel cv c0 wne crpss wor wa wi wral wss wpss cint cpw
      cfin2 elpwi fin2i2 sylan2 ralrimiva cuni w3a wrex cdif crab simp1r ssrab2
      ex wn cvv wb simp1l pwexg elpw2g mpbiri simp2 simp3l fin23lem7 sorpsscmpl
      3syl syl3anc adantl 3ad2ant3 jca wceq neeq1 soeq2 anbi12d eleq12d imbi12d
      inteq id rspcv syl3c sorpssint mpbird psseq1 pssdifcom1 fin23lem11 simp3r
      syl sylc sorpssuni mpbid 3exp ralrimdva isfin2 sylibrd impbid2 ) BCJZBUCJ
      ZAKZLMZWSNOZPZWSUAZWSJZQZABUBZUBZRZWRXEAXGWSXGJWRWSXFSZXEWSXFUDWRXIPXBXDB
      WSUEUOUFUGWQXHDKZLMZXJNOZPZXJUHXJJZQZDXGRWRWQXHXODXGXJXGJWQXJXFSZXHXOQXJX
      FUDWQXPPZXHXMXNXQXHXMUIZEKZFKZTZUPFXJREXJUJZXNXRXPGKZHKZTZUPGBIKUKXJJZIXF
      ULZRHYGUJZYBWQXPXHXMUMZXRYHYGUAZYGJZXRYGXGJZXHYGLMZYGNOZPZYKXRYLYGXFSZYFI
      XFUNXRWQXFUQJYLYPURWQXPXHXMUSZBCUTYGXFUQVAVGVBXQXHXMVCXRYMYNXRWQXPXKYMYQY
      IXQXHXKXLVDIBXJCVEVHXMXQYNXHXLYNXKIBXJVFVIVJZVKXEYOYKQAYGXGWSYGVLZXBYOXDY
      KYSWTYMXAYNWSYGLVMWSYGNVNVOYSXCYJWSYGWSYGVRYSVSVPVQVTWAXRYNYHYKURYRGHYGWB
      WHWCYEYABYDUKZXTTBXTUKZYDTHEGFBXJIXSYTXTWDYCUUAYDWDYDXTBWEWFWIXRXLYBXNURX
      QXHXKXLWGFEXJWJWHWKWLUFWMDBCWNWOWP $.

    $( A subset of a II-finite set is II-finite.  (Contributed by Stefan
       O'Rear, 2-Nov-2014.)  (Revised by Mario Carneiro, 16-May-2015.) $)
    ssfin2 $p |- ( ( A e. Fin2 /\ B C_ A ) -> B e. Fin2 ) $=
      ( vx cfin2 wcel wss wa cv c0 wne crpss wor cuni wi cpw wral simpll adantl
      elpwi cvv simplr sspwb sylib sstrd fin2i ex ralrimiva ssexg ancoms isfin2
      syl2anc wb syl mpbird ) ADEZBAFZGZBDEZCHZIJUSKLGZUSMUSEZNZCBOZOZPZUQVBCVD
      UQUSVDEZGZUOUSAOZFZVBUOUPVFQVGUSVCVHVFUSVCFUQUSVCSRVGUPVCVHFUOUPVFUABAUBU
      CUDUOVIGUTVAAUSUEUFUKUGUQBTEZURVEULUPUOVJBADUHUICBTUJUMUN $.

    $( II-finiteness is a cardinal property.  (Contributed by Mario Carneiro,
       18-May-2015.) $)
    enfin2i $p |- ( A ~~ B -> ( A e. Fin2 -> B e. Fin2 ) ) $=
      ( vx vf vy vw vz wcel cv wa cuni cpw wral wss cima wceq cvv imaeq2 eleq1d
      syl12anc cen wbr cfin2 c0 wne crpss wor wf1o wex bren elpwi crab wrex cab
      ciun imauni vex imaexg ax-mp dfiun2 eqtri rexrab eleq1 biimparc rexlimivw
      wi ccnv cdm cnvimass f1odm ad3antrrr syl5sseq cnvex elpw sylibr wfo f1ofo
      simprl sselda elpwid foimacnv syl2anc eqcomd simpr eqeltrrd eqeq2d rspcev
      anbi12d ex impbid2 syl5bb abbi1dv unieqd syl5eq simplr ssrab2 a1i simprrl
      n0 sylib exlimddv rabn0 wo elrab anbi12i simprrr adantr simprlr wf1 f1of1
      sorpssi wb simprll f1imass orbi12d mpbid ralrimivva sorpss fin2i syl22anc
      sylan2b cbvrabv elrab2 simprbi syl expr ralrimiva exlimiv sylbi brrelex2i
      sylan2 relen isfin2 sylibrd ) ABUAUBZAUCHZCIZUDUEZYQUFUGZJZYQKZYQHZVFZCBL
      ZLZMZBUCHZYOABDIZUHZDUIYPUUFVFZABDUJUUIUUJDUUIYPUUFUUIYPJZUUCCUUEYQUUEHUU
      KYQUUDNZUUCYQUUDUKUUKUULYTUUBUUKUULYTJZJZUUHUUHEIZOZYQHZEALZULZKZOZUUAYQU
      UNUVAFIZUUHGIZOZPZGUUSUMZFUNZKZUUAUVAGUUSUVDUOUVHGUUHUUSUPGFUUSUVDUUHQHUV
      DQHDUQZUUHUVCQURUSUTVAUUNUVGYQUUNUVFFYQUVFUVDYQHZUVEJZGUURUMZUUNUVBYQHZUU
      QUVJUVEGEUURUUOUVCPUUPUVDYQUUOUVCUUHRSZVBUUNUVLUVMUVKUVMGUURUVEUVMUVJUVBU
      VDYQVCVDVEUUNUVMUVLUUNUVMJZUUHVGZUVBOZUURHZUUHUVQOZYQHZUVBUVSPZUVLUVOUVQA
      NUVRUVOUUHVHZUVQAUUHUVBVIUUIUWBAPYPUUMUVMABUUHVJVKVLUVQAUVPQHUVQQHUUHUVIV
      MUVPUVBQURUSVNVOZUVOUVBUVSYQUVOUVSUVBUVOABUUHVPZUVBBNUVSUVBPUUIUWDYPUUMUV
      MABUUHVQVKUVOUVBBUUNYQUUDUVBUUKUULYTVRVSVTABUVBUUHWAWBWCZUUNUVMWDWEZUWEUV
      KUVTUWAJGUVQUURUVCUVQPZUVJUVTUVEUWAUWGUVDUVSYQUVCUVQUUHRZSUWGUVDUVSUVBUWH
      WFWHWGTWIWJWKWLWMWNUUNUUTUUSHZUVAYQHZUUNYPUUSUURNZUUSUDUEZUUSUFUGZUWIUUIY
      PUUMWOUWKUUNUUQEUURWPWQUUNUUQEUURUMZUWLUUNUVMUWNFUUNYRUVMFUIUUKUULYRYSWRF
      YQWSWTUVOUVRUVTUWNUWCUWFUUQUVTEUVQUURUUOUVQPUUPUVSYQUUOUVQUUHRSWGWBXAUUQE
      UURXBVOUUNUVCUVBNZUVBUVCNZXCZFUUSMGUUSMUWMUUNUWQGFUUSUUSUVCUUSHZUVBUUSHZJ
      UUNUVCUURHZUVJJZUVBUURHZUUHUVBOZYQHZJZJZUWQUWRUXAUWSUXEUUQUVJEUVCUURUVNXD
      UUQUXDEUVBUURUUOUVBPUUPUXCYQUUOUVBUUHRSXDXEUUNUXFJZUVDUXCNZUXCUVDNZXCZUWQ
      UXGYSUVJUXDUXJUUNYSUXFUUKUULYRYSXFXGUUNUWTUVJUXEXHUUNUXAUXBUXDXFYQUVDUXCX
      KTUXGUXHUWOUXIUWPUXGABUUHXIZUVCANZUVBANZUXHUWOXLUUIUXKYPUUMUXFABUUHXJVKZU
      XGUVCAUUNUWTUVJUXEXMVTZUXGUVBAUUNUXAUXBUXDWRVTZABUVCUVBUUHXNTUXGUXKUXMUXL
      UXIUWPXLUXNUXPUXOABUVBUVCUUHXNTXOXPYAXQGFUUSXRVOAUUSXSXTUWIUUTUURHUWJUVJU
      WJGUUTUURUUSUVCUUTPUVDUVAYQUVCUUTUUHRSUUQUVJEGUURUVNYBYCYDYEWEYFYKYGWIYHY
      IYOBQHUUGUUFXLABUAYLYJCBQYMYEYN $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d C x y $.  $d D x y $.
    $( Lemma for ~ fin23 .  In a class of ordinals, each element is fully
       identified by those of its predecessors which also belong to the class.
       (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem24 $p |- ( ( ( Ord A /\ B C_ A ) /\ ( C e. B /\ D e. B ) ) ->
      ( ( C i^i B ) = ( D i^i B ) <-> C = D ) ) $=
      ( word wa wcel cin wceq wne sseldd ordelord syl2anc simpr sylanbrc adantr
      wn elin ordirr syl wss wo simpll simplr simprl ordtri3 necon2abid simplrl
      wb simprr inss1 sseli nsyl nelne1 necomd simplrr ex sylbird necon4d ineq1
      jaodan impbid1 ) AEZBAUAZFZCBGZDBGZFZFZCBHZDBHZICDIVICDVJVKVICDJZCDGZDCGZ
      UBZVJVKJZVICEZDEZVOVLUIVIVCCAGVQVCVDVHUCZVIBACVCVDVHUDZVEVFVGUEKACLMZVIVC
      DAGVRVSVIBADVTVEVFVGUJKADLMZVQVRFVOCDCDUFUGMVIVOVPVIVMVPVNVIVMFZVKVJWCCVK
      GZCVJGZQVKVJJWCVMVFWDVIVMNVEVFVGVMUHCDBROWCCCGZWEWCVQWFQVIVQVMWAPCSTVJCCC
      BUKULUMCVKVJUNMUOVIVNFZDVJGZDVKGZQVPWGVNVGWHVIVNNVEVFVGVNUPDCBROWGDDGZWIW
      GVRWJQVIVRVNWBPDSTVKDDDBUKULUMDVJVKUNMVAUQURUSCDBUTVB $.

    $( In a chain of finite sets, dominance and subset coincide.  (Contributed
       by Stefan O'Rear, 8-Nov-2014.) $)
    fincssdom $p |- ( ( A e. Fin /\ B e. Fin /\ ( A C_ B \/ B C_ A ) ) ->
        ( A ~<_ B <-> A C_ B ) ) $=
      ( cfn wcel wss wo w3a cdom wn csdm wa wpss simpl1 simpr simpl3 orel1 sylc
      wbr dfpss3 sylanbrc php3 syl2anc domnsym con2i syl6 con4d ssdomg 3ad2ant2
      ex wi impbid ) ACDZBCDZABEZBAEZFZGZABHRZUNUQUNURUQUNIZBAJRZURIUQUSUTUQUSK
      ZULBALZUTULUMUPUSMVAUOUSVBVAUSUPUOUQUSNZULUMUPUSOUNUOPQVCBASTABUAUBUIURUT
      ABUCUDUEUFUMULUNURUJUPABCUGUHUK $.

    $( Lemma for ~ fin23 .  In a chain of finite sets, equinumerousity is
       equivalent to equality.  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem25 $p |- ( ( A e. Fin /\ B e. Fin /\ ( A C_ B \/ B C_ A ) ) ->
      ( A ~~ B <-> A = B ) ) $=
      ( cfn wcel wss cen wbr wceq wn wi wa wpss dfpss2 csdm php3 sdomnen syl ex
      syl5bir exp3a w3a adantl eqcom notbii anbi2i bitri ensym nsyl adantr jaod
      wo 3impia con4d eqeng 3ad2ant1 impbid ) ACDZBCDZABEZBAEZUKZUAZABFGZABHZVB
      VDVCUQURVAVDIZVCIZJZUQURKZUSVGUTVHUSVEVFURUSVEKZVFJUQVIABLZURVFABMURVJVFU
      RVJKABNGVFBAOABPQRSUBTVHUTVEVFUQUTVEKZVFJURVKBALZUQVFVLUTBAHZIZKVKBAMVNVE
      UTVMVDBAUCUDUEUFUQVLVFUQVLKBANGZVFABOVOBAFGVCBAPABUGUHQRSUITUJULUMUQURVDV
      CJVAABCUNUOUP $.
  $}

  ${
    $d i j a b c $.  $d S i j a b c $.  $d C a b c $.
    $( Lemma for ~ fin23lem22 .  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem26 $p |- ( ( ( S C_ om /\ -. S e. Fin ) /\ i e. om ) ->
      E. j e. S ( j i^i S ) ~~ i ) $=
      ( va vb cv com wcel wss cfn wn wa cin cen wbr wrex c0 wceq con0 syl breq2
      csuc rexbidv weq word ordom simpl 0fin eleq1 mpbiri necon3bi adantl tz7.5
      wne a1i syl3anc en0 incom eqeq1i bitri rexbii sylibr wi cdif cint simplrl
      omsson syl6ss ssdifssd simplr ssel2 onfin2 inss2 eqsstri peano2 sseldi ex
      adantlr ssfi mtod ssdif0 necon3bbii sylib ad2ant2lr onint syl2anc eldifad
      csn cun simprr cvv vex en2sn mp2an simprl sseldd nnord ordirr inss1 sseli
      wel nsyl disjsn ad2antrr unen syl22anc wb ordsuc adantrr w3a simp2 simpl1
      simpr eldifd onnmin ee12an con4d imp simp3 ordsucss sscond simpl2 ordelon
      intss sylan onmindif impbida df-suc eleq2i syl6bb expr elin 3bitr4g eqrdv
      pm5.32rd indir syl6eq snssi ineq1 breq1d df-ss uneq2d ad2antrl rexlimdvaa
      eqtrd 3brtr4d rspcev cbvrexv syl6ib finds2 impcom ) BFZGHAGIZAJHZKZLZCFZA
      MZUULNOZCAPZUUTUURQNOZCAPZUURDFZNOZCAPZUURUVCUBZNOZCAPZUUPBDUULQRUUSUVACA
      UULQUURNUAUCBDUDUUSUVDCAUULUVCUURNUAUCUULUVFRUUSUVGCAUULUVFUURNUAUCUUPAUU
      QMZQRZCAPZUVBUUPGUEZUUMAQUNZUVKUVLUUPUFUOUUMUUOUGUUOUVMUUMUUNAQAQRUUNQJHU
      HAQJUIUJUKULCGAUMUPUVAUVJCAUVAUURQRUVJUURUQUURUVIQUUQAURUSUTVAVBUVCGHZUUP
      UVEUVHVCUVNUUPLZUVEEFZAMZUVFNOZEAPZUVHUVOUVDUVSCAUVOUUQAHZUVDLZLZAUUQUBZV
      DZVEZAHUWEAMZUVFNOZUVSUWBUWEAUWCUWBUWDSIZUWDQUNZUWEUWDHUWBASUWCUWBAGSUVNU
      UMUUOUWAVFZVGVHVIUUPUVTUWIUVNUVDUUPUVTLZAUWCIZKUWIUWKUWLUUNUUMUUOUVTVJUWK
      UWCJHZUWLUUNVCUUMUVTUWMUUOUUMUVTLUUQGHZUWMAGUUQVKUWNGJUWCGSJMJVLSJVMVNUUQ
      VOVPTVRUWMUWLUUNUWCAVSVQTVTUWLUWDQAUWCWAWBWCWDUWDWEWFWGUWBUURUUQWHZWIZUVC
      UVCWHZWIZUWFUVFNUWBUVDUWOUWQNOZUURUWOMQRZUVCUWQMQRZUWPUWRNOUVOUVTUVDWJUWS
      UWBUUQWKHUVCWKHUWSCWLDWLUUQUVCWKWKWMWNUOUWBUUQUEZUWTUWBUWNUXBUWBAGUUQUWJU
      VOUVTUVDWOWPUUQWQTZUXBUUQUURHZKUWTUXBCCXAUXDUUQWRUURUUQUUQUUQAWSWTXBUURUU
      QXCVBTUVNUXAUUPUWAUVNDDXAKZUXAUVNUVCUEUXEUVCWQUVCWRTUVCUVCXCVBXDUURUVCUWO
      UWQXEXFUWBUWFUURUWOAMZWIZUWPUWBUWFUUQUWOWIZAMZUXGUWBEUWFUXIUWBUVPUWEHZUVP
      AHZLUVPUXHHZUXKLUVPUWFHUVPUXIHUWBUXKUXJUXLUVOUWAUXKUXJUXLXGUVOUWAUXKLZLZU
      XJUVPUWCHZUXLUXNUXKASIZUWCUEZUXJUXOXGUVOUWAUXKWJUXNAGSUVNUUMUUOUXMVFVGVHU
      VOUWAUXQUXKUWBUXBUXQUXCUUQXHWCXIUXKUXPUXQXJZUXJUXOUXRUXJUXOUXRUXOUXJUXRUW
      HUXOKZUVPUWDHZUXJKUXRASUWCUXKUXPUXQXKVIUXRUXSUXTUXRUXSLUVPAUWCUXKUXPUXQUX
      SXLUXRUXSXMXNVQUWDUVPXOXPXQXRUXRUXOLZAUVPUBZVDZVEZUWEUVPUYAUWDUYCIUYDUWEI
      UYAUYBUWCAUXRUXOUYBUWCIZUXRUXQUXOUYEVCUXKUXPUXQXSZUVPUWCXTTXRYAUWDUYCYDTU
      YAUXPUVPSHZUVPUYDHUXKUXPUXQUXOYBUXRUXQUXOUYGUYFUWCUVPYCYEAUVPYFWFWPYGUPUW
      CUXHUVPUUQYHYIYJYKYOUVPUWEAYLUVPUXHAYLYMYNUUQUWOAYPYQUVTUXGUWPRUVOUVDUVTU
      XFUWOUURUVTUWOAIUXFUWORUUQAYRUWOAUUAWCUUBUUCUUEUVFUWRRUWBUVCYHUOUUFUVRUWG
      EUWEAUVPUWERUVQUWFUVFNUVPUWEAYSYTUUGWFUUDUVRUVGECAECUDUVQUURUVFNUVPUUQAYS
      YTUUHUUIVQUUJUUK $.

    $( Lemma for ~ fin23lem22 .  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem23 $p |- ( ( ( S C_ om /\ -. S e. Fin ) /\ i e. om ) ->
      E! j e. S ( j i^i S ) ~~ i ) $=
      ( va com wss cfn wcel wa cv cin cen wbr wceq wral wo wb sseldd syl word
      wn wrex wi wreu fin23lem26 ensym entr sylan2 simpl simprl nnfi inss1 ssfi
      sylancl simprr nnord ordtri2or2 syl2an syl2anc orim12i fin23lem25 syl3anc
      ssrin ordom fin23lem24 mpanl1 bitrd syl5ib ralrimivva ad2antrr ineq1 reu4
      breq1d sylanbrc ) AEFZAGHUAZIBJZEHZICJZAKZVQLMZCAUBWADJZAKZVQLMZIZVSWBNZU
      CZDAOCAOZWACAUDABCUEVOWHVPVRVOWGCDAAWEVTWCLMZVOVSAHZWBAHZIZIZWFWDWAVQWCLM
      WIWCVQUFVTVQWCUGUHWMWIVTWCNZWFWMVTGHZWCGHZVTWCFZWCVTFZPZWIWNQWMVSEHZWOWMA
      EVSVOWLUIZVOWJWKUJRZWTVSGHVTVSFWOVSUKVSAULVSVTUMUNSWMWBEHZWPWMAEWBXAVOWJW
      KUORZXCWBGHWCWBFWPWBUKWBAULWBWCUMUNSWMVSWBFZWBVSFZPZWSWMWTXCXGXBXDWTVSTWB
      TXGXCVSUPWBUPVSWBUQURUSXEWQXFWRVSWBAVCWBVSAVCUTSVTWCVAVBETVOWLWNWFQVDEAVS
      WBVEVFVGVHVIVJWAWDCDAWFVTWCVQLVSWBAVKVMVLVN $.

    fin23lem22.b $e |- C = ( i e. om |-> ( iota_ j e. S ( j i^i S ) ~~ i ) ) $.
    $( Lemma for ~ fin23 but could be used elsewhere if we find a good name for
       it.  Explicit construction of a bijection (actually an isomorphism, see
       ~ fin23lem27 ) between an infinite subset of ` om ` and ` om ` itself.
       (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem22 $p |- ( ( S C_ om /\ -. S e. Fin ) -> C : om -1-1-onto-> S ) $=
      ( va com wss cfn wcel wa cv cin cen wbr ccrd cfv syl wceq wb wn crio wreu
      fin23lem23 riotacl simpll simpr sseldd nnfi ficardom cardnn eqcomd eqeq1d
      infi 4syl eqcom syl6bb ad2antrl cdm con0 simprr nnon onenon inss1 sylancl
      3syl ssnum carden2 syl2anc adantrr ineq1 breq1d riota2 3bitrd f1o2d ) BGH
      ZBIJUAZKZCFGBDLZBMZCLZNOZDBUBZFLZBMZPQZAEVRWAGJZKWBDBUCZWCBJBCDUDZWBDBUER
      VRWDBJZKZWDGJZWDIJWEIJWFGJWKBGWDVPVQWJUFVRWJUGUHWDUIWDBUNWEUJUOVRWGWJKZKZ
      WAWFSZWFWAPQZSZWEWANOZWDWCSZWGWOWQTVRWJWGWOWPWFSWQWGWAWPWFWGWPWAWAUKULUMW
      PWFUPUQURWNWEPUSZJZWAWTJZWQWRTWNWDWTJZWEWDHXAWNWLWDUTJXCWNBGWDVPVQWMUFVRW
      GWJVAZUHWDVBWDVCVFWDBVDWDWEVGVEWNWAUTJZXBWGXEVRWJWAVBURWAVCRWEWAVHVIWNWRW
      CWDSZWSWNWJWHWRXFTXDVRWGWHWJWIVJWBWRDBWDVSWDSVTWEWANVSWDBVKVLVMVIWCWDUPUQ
      VNVO $.

    $( The mapping constructed in ~ fin23lem22 is in fact an isomorphism.
       (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem27 $p |- ( ( S C_ om /\ -. S e. Fin ) ->
        C Isom _E , _E ( om , S ) ) $=
      ( va vb com wcel wa cep cv wbr cin cen wreu wceq breq1d syl2anc con0 wral
      wss cfn wn wor wpo wfo cfv wiso word wwe ordom ordwe weso mp2b sopo ax-mp
      wi a1i poss mpi adantr wf1o fin23lem22 f1ofo crio csdm wb nnsdomel adantl
      syl biimpd fin23lem23 adantrr ineq1 cbvreuv sylib nfv cbvriotav riotaprop
      simprd simprr ensymd sdomentr ensdomtr simpll omsson syl6ss simpld sseldd
      adantrl expr onsdominel 3expia 3syld simprl riotabidv fvmptg eleq12d epel
      breq2 sylibrd fvex epelc 3imtr4g ralrimivva soisoi syl22anc ) BHUBZBUCIUD
      ZJZHKUEZBKUFZHBAUGZFLZGLZKMZXOAUHZXPAUHZKMZURZGHUAFHUAHBKKAUIXLXKHUJHKUKX
      LULHUMHKUNUOZUSXIXMXJXIHKUFZXMXLYCYBHKUPUQBHKUTVAVBXKHBAVCXNABCDEVDHBAVEV
      KXKYAFGHHXKXOHIZXPHIZJZJZXOXPIZXRXSIZXQXTYGYHDLZBNZXOOMZDBVFZYKXPOMZDBVFZ
      IZYIYGYHXOXPVGMZYMBNZYOBNZVGMZYPYGYHYQYFYHYQVHXKXOXPVIVJVLXKYFYQYTXKYFYQJ
      JZYRXOOMZXOYSVGMZYTXKYFUUBYQYGYMBIZUUBYGCLZBNZXOOMZCBPZUUDUUBJYGYLDBPZUUH
      XKYDUUIYEBFDVMVNYLUUGDCBYJUUEQZYKUUFXOOYJUUEBVOZRZVPVQUUGUUBCBYMUUBCVRYLU
      UGDCBUULVSUUEYMQUUFYRXOOUUEYMBVORVTVKZWAVNUUAYQXPYSOMZUUCXKYFYQWBXKYFUUNY
      QYGYSXPYGYOBIZYSXPOMZYGUUFXPOMZCBPZUUOUUPJYGYNDBPZUURXKYEUUSYDBGDVMWKYNUU
      QDCBUUJYKUUFXPOUUKRZVPVQUUQUUPCBYOUUPCVRYNUUQDCBUUTVSUUEYOQUUFYSXPOUUEYOB
      VORVTVKZWAWCVNXOXPYSWDSYRXOYSWESWLYGYMTIZYOTIZYTYPURYGBTYMYGBHTXIXJYFWFWG
      WHZYGUUDUUBUUMWIZWJYGBTYOUVDYGUUOUUPUVAWIZWJUVBUVCYTYPYMYOBWMWNSWOYGXRYMX
      SYOYGYDUUDXRYMQXKYDYEWPUVECXOYKUUEOMZDBVFZYMHBAUUEXOQUVGYLDBUUEXOYKOXAWQE
      WRSYGYEUUOXSYOQXKYDYEWBUVFCXPUVHYOHBAUUEXPQUVGYNDBUUEXPYKOXAWQEWRSWSXBFGW
      TXRXSXPAXCXDXEXFFGHBKKAXGXH $.
  $}

  ${
    $d a b f g x A $.  $d a b f g x B $.
    isfin3ds.f $e |- F = { g | A. a e. ( ~P g ^m om )
     ( A. b e. om ( a ` suc b ) C_ ( a ` b ) -> |^| ran a e. ran a ) } $.
    $( Property of a III-finite set (descending sequence version).
       (Contributed by Mario Carneiro, 16-May-2015.) $)
    isfin3ds $p |- ( A e. V -> ( A e. F <-> A. f e. ( ~P A ^m om )
      ( A. x e. om ( f ` suc x ) C_ ( f ` x ) -> |^| ran f e. ran f ) ) ) $=
      ( cv csuc cfv wss com wral crn cint wcel cmap wceq wi cpw co suceq fveq2d
      fveq2 sseq12d cbvralv fveq1 ralbidv syl5bb inteqd eleq12d imbi12d raleqdv
      rneq pweq oveq1d elab2g ) HJZKZGJZLZUTVBLZMZHNOZVBPZQZVGRZUAZGDJZUBZNSUCZ
      OZAJZKZCJZLZVOVQLZMZANOZVQPZQZWBRZUAZCBUBZNSUCZOZDBEFVNWECVMOVKBTZWHVJWEG
      CVMVBVQTZVFWAVIWDVFVPVBLZVOVBLZMZANOWJWAVEWMHANUTVOTZVCWKVDWLWNVAVPVBUTVO
      UDUEUTVOVBUFUGUHWJWMVTANWJWKVRWLVSVPVBVQUIVOVBVQUIUGUJUKWJVHWCVGWBWJVGWBV
      BVQUPZULWOUMUNUHWIWECVMWGWIVLWFNSVKBUQURUOUKIUS $.

    $( A subset of a III-finite set is III-finite.  (Contributed by Stefan
       O'Rear, 4-Nov-2014.) $)
    ssfin3ds $p |- ( ( A e. F /\ B C_ A ) -> B e. F ) $=
      ( vx vf wcel wss cv cfv com wral cpw cmap co cvv adantr wa csuc crn pwexg
      cint wi simpr sspwb sylib mapss syl2anc isfin3ds ibi ssralv sylc wb ssexg
      ancoms syl mpbird ) ADJZBAKZUAZBDJZHLZUBILZMVEVFMKHNOVFUCZUEVGJUFZIBPZNQR
      ZOZVCVJAPZNQRZKZVHIVMOZVKVCVLSJZVIVLKZVNVAVPVBADUDTVCVBVQVAVBUGBAUHUIVIVL
      NSUJUKVAVOVBVAVOHAICDDEFGULUMTVHIVJVMUNUOVCBSJZVDVKUPVBVAVRBADUQURHBICDSE
      FGULUSUT $.

  $}

  ${
    $d c g i t u v x z $.  $d a b i u A $.  $d a b B $.  $d a t F $.  $d a V $.
    $d a b w x z P $.  $d a b i u v R $.  $d a b c i u v z U $.  $d a b f Z $.
    $d a b f g t x G $.
    fin23lem.a $e |- U = seqom ( ( i e. om , u e. _V |-> if ( ( ( t ` i ) i^i
      u ) = (/) , u , ( ( t ` i ) i^i u ) ) ) , U. ran t ) $.
    $( The beginning of the proof that every II-finite set (every chain of
       subsets has a maximal element) is III-finite (has no denumerable
       collection of subsets).

       This first section is dedicated to the construction of ` U ` and its
       intersection.  First, the value of ` U ` at a successor.  (Contributed
       by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem12 $p |- ( A e. om -> ( U ` suc A ) = if ( ( ( t ` A ) i^i
        ( U ` A ) ) = (/) , ( U ` A ) , ( ( t ` A ) i^i ( U ` A ) ) ) ) $=
      ( com wcel csuc cfv cvv cv cin c0 wceq cif cmpt2 co crn eqeq1d cuni fveq2
      seqomsuc fvex ineq1d ifbieq2d ineq2 ifbieq12d eqid inex2 ifex mpan2 eqtrd
      id ovmpt2 ) CGHZCIDJCCDJZEAGKELZBLZJZALZMZNOZVAVBPZQZRZCUSJZUQMZNOZUQVHPZ
      CVEDUSSUAFUCUPUQKHVFVJOCDUDZEACUQGKVDVJVEVGVAMZNOZVAVLPURCOZVCVMVBVLVAVNV
      BVLNVNUTVGVAURCUSUBUEZTVOUFVAUQOZVMVIVAVLUQVHVPVLVHNVAUQVGUGZTVPUNVQUHVEU
      IVIUQVHVKUQVGVKUJUKUOULUM $.

    $( Lemma for ~ fin23 .  Each step of ` U ` is a decrease.  (Contributed by
       Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem13 $p |- ( A e. om -> ( U ` suc A ) C_ ( U ` A ) ) $=
      ( com wcel csuc cfv cv cin c0 wceq cif fin23lem12 wss sseq1 ssid inss2
      keephyp syl6eqss ) CGHCIDJCBKJZCDJZLZMNZUDUEOZUDABCDEFPUFUDUDQUEUDQUGUDQU
      DUEUDUGUDRUEUGUDRUDSUCUDTUAUB $.

    $( Lemma for ~ fin23 . ` U ` will never evolve to an empty set if it did
       not start with one.  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem14 $p |- ( ( A e. om /\ U. ran t =/= (/) ) ->
        ( U ` A ) =/= (/) ) $=
      ( va vb com cv c0 wne cfv wi wceq fveq2 neeq1d imbi2d eqnetrd adantr wcel
      crn cuni csuc weq cvv vex rnex uniex cin cmpt2 seqom0g mp1i id fin23lem12
      cif wa iftrue simprr wn iffalse df-ne biimpri pm2.61ian imim2d finds imp
      ex ) CIUABJZUBZUCZKLZCDMZKLZVLGJZDMZKLZNVLKDMZKLZNVLHJZDMZKLZNVLVTUDZDMZK
      LZNVLVNNGHCVOKOZVQVSVLWFVPVRKVOKDPQRGHUEZVQWBVLWGVPWAKVOVTDPQRVOWCOZVQWEV
      LWHVPWDKVOWCDPQRVOCOZVQVNVLWIVPVMKVOCDPQRVLVRVKKVKUFUAVRVKOVLVJVIBUGUHUIE
      AIUFEJVIMAJZUJZKOWJWKUPUKDVKFULUMVLUNSVTIUAZWBWEVLWLWBWEWLWBUQZWDVTVIMWAU
      JZKOZWAWNUPZKWLWDWPOWBABVTDEFUOTWOWMWPKLWOWMUQWPWAKWOWPWAOWMWOWAWNURTWOWL
      WBUSSWOUTZWMUQWPWNKWQWPWNOWMWOWAWNVATWQWNKLZWMWRWQWNKVBVCTSVDSVHVEVFVG $.

    $( Lemma for ~ fin23 . ` U ` is a monotone function.  (Contributed by
       Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem15 $p |- ( ( ( A e. om /\ B e. om ) /\ B C_ A ) ->
        ( U ` A ) C_ ( U ` B ) ) $=
      ( vb va cv cfv wss csuc wceq fveq2 sseq1d weq com wcel wa ssid fin23lem13
      a1i wi ad2antrr sstr2 syl findsg ) HJZEKZDEKZLUKUKLZIJZEKZUKLZUMMZEKZUKLZ
      CEKZUKLHICDUIDNUJUKUKUIDEOPHIQUJUNUKUIUMEOPUIUPNUJUQUKUIUPEOPUICNUJUSUKUI
      CEOPULDRSZUKUAUCUMRSZUTTDUMLZTUQUNLZUOURUDVAVCUTVBABUMEFGUBUEUQUNUKUFUGUH
      $.

    $( Lemma for ~ fin23 . ` U ` ranges over the original set; in particular
       ` ran U ` is a set, although we do not assume here that ` U ` is.
       (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem16 $p |- U. ran U = U. ran t $=
      ( va vb crn cuni cv wss wcel cfv wceq com cvv c0 ax-mp peano1 mpan2 cmpt2
      unissb wrex wfn wb cin cif fnseqom fvelrnb wa 0ss fin23lem15 rnex seqom0g
      vex uniex syl6sseq sseq1 syl5ibcom rexlimiv sylbi fnfvelrn mp2an eqeltrri
      mprgbir elssuni eqssi ) CHZIZBJZHZIZVIVLKFJZVLKZFVHFVHVLUBVMVHLZGJZCMZVMN
      ZGOUCZVNCOUDZVOVSUEDAOPDJVJMAJZUFZQNWAWBUGUAZCVLEUHZGOVMCUIRVRVNGOVPOLZVQ
      VLKVRVNWEVQQCMZVLWEQOLZVQWFKZSWEWGUJQVPKWHVPUKABVPQCDEULTTVLPLWFVLNVKVJBU
      OUMUPWCCVLEUNRZUQVQVMVLURUSUTVAVEVLVHLVLVIKWFVLVHWIVTWGWFVHLWDSOQCVBVCVDV
      LVHVFRVG $.

    $( Lemma for ~ fin23 .  The first set in ` U ` to see an input set is
       either contained in it or disjoint from it.  (Contributed by Stefan
       O'Rear, 1-Nov-2014.) $)
    fin23lem19 $p |- ( A e. om -> ( ( U ` suc A ) C_ ( t ` A ) \/
      ( ( U ` suc A ) i^i ( t ` A ) ) = (/) ) ) $=
      ( com wcel csuc cfv cv cin c0 wceq wss wa wn wo cif fin23lem12 eqif sylib
      incom ineq2 eqeq1d biimparc syl5eq inss1 mpbiri adantl orim12i syl orcomd
      sseq1 ) CGHZCIDJZCBKJZLZMNZUPUQOZUOUQCDJZLZMNZUPVANZPZVCQZUPVBNZPZRZUSUTR
      UOUPVCVAVBSNVIABCDEFTVCUPVAVBUAUBVEUSVHUTVEURUQUPLZMUPUQUCVDVJMNVCVDVJVBM
      UPVAUQUDUEUFUGVGUTVFVGUTVBUQOUQVAUHUPVBUQUNUIUJUKULUM $.

    $( Lemma for ~ fin23 . ` X ` is either contained in or disjoint from all
       input sets.  (Contributed by Stefan O'Rear, 1-Nov-2014.) $)
    fin23lem20 $p |- ( A e. om -> ( |^| ran U C_ ( t ` A ) \/ ( |^| ran U i^i
        ( t ` A ) ) = (/) ) ) $=
      ( com wcel crn cint csuc cfv wss cv cin c0 wceq wo wfn cvv cif cmpt2 cuni
      fnseqom peano2 fnfvelrn sylancr intss1 fin23lem19 sstr2 ssdisj ex orim12d
      syl sylc ) CGHZDIZJZCKZDLZMZUTCBNZLZMZUTVCOPQZRURVCMZURVCOPQZRUPUTUQHZVAU
      PDGSUSGHVHEAGTENVBLANZOZPQVIVJUAUBDVBIUCFUDCUEGUSDUFUGUTUQUHUNABCDEFUIVAV
      DVFVEVGURUTVCUJVAVEVGURUTVCUKULUMUO $.

    fin23lem17.f $e |- F = { g | A. a e. ( ~P g ^m om )
      ( A. x e. om ( a ` suc x ) C_ ( a ` x ) -> |^| ran a e. ran a ) } $.
    $( Lemma for ~ fin23 .  By ?  Fin3DS ? , ` U ` achieves its minimum ( ` X `
       in the synopsis above, but we will not be assigning a symbol here).
       TODO:  Fix comment; math symbol Fin3DS does not exist.  (Contributed by
       Stefan O'Rear, 4-Nov-2014.)  (Revised by Mario Carneiro,
       17-May-2015.) $)
    fin23lem17 $p |- ( ( U. ran t e. F /\ t : om -1-1-> V ) ->
        |^| ran U e. ran U ) $=
      ( vc vb cv crn wcel com cfv wss cvv cuni wf1 wa cmap co csuc wral cint wi
      cpw wf wfn cin wceq cif cmpt2 fnseqom dffn3 mpbi pwuni fin23lem16 sseqtri
      c0 pweqi fss mp2an wb vex rnex uniex pwex f1f dmfex sylancr adantl elmapg
      mpbiri isfin3ds ibi adantr fin23lem13 rgen a1i fveq1 sseq12d ralbidv rneq
      inteqd eleq12d imbi12d rspcv syl3c ) CNZOZUAZGPZQHWMUBZUCZDWOUJZQUDUEZPZL
      NZUFZMNZRZXBXDRZSZLQUGZXDOZUHZXIPZUIZMWTUGZXCDRZXBDRZSZLQUGZDOZUHZXRPZWRX
      AQWSDUKZQXRDUKZXRWSSYADQULYBFBQTFNWMRBNZUMZVCUNYCYDUOUPDWOJUQQDURUSXRXRUA
      ZUJWSXRUTYEWOBCDFJVAVDVBQXRWSDVEVFWRWSTPQTPZXAYAVGWOWNWMCVHZVIVJVKWQYFWPW
      QWMTPQHWMUKYFYGQHWMVLQHTWMVMVNVOWSQDTTVPVNVQWPXMWQWPXMLWOMEGGIAKVRVSVTXQW
      RXPLQBCXBDFJWAWBWCXLXQXTUIMDWTXDDUNZXHXQXKXTYHXGXPLQYHXEXNXFXOXCXDDWDXBXD
      DWDWEWFYHXJXSXIXRYHXIXRXDDWGZWHYIWIWJWKWL $.

    $( Lemma for ~ fin23 . ` X ` is not empty.  We only need here that ` t `
       has at least one set in its range besides ` (/) ` ; the much stronger
       hypothesis here will serve as our induction hypothesis though.
       (Contributed by Stefan O'Rear, 1-Nov-2014.)  (Revised by Mario Carneiro,
       6-May-2015.) $)
    fin23lem21 $p |- ( ( U. ran t e. F /\ t : om -1-1-> V ) ->
        |^| ran U =/= (/) ) $=
      ( cv wcel com wa c0 wne wceq cvv cfn crn cuni wf1 cint fin23lem17 wi wrex
      cfv wfn wb cin cif cmpt2 fnseqom fvelrnb ax-mp id csn cdif cen wbr wn vex
      wf1o f1f1orn f1oen3g sylancr ominf wss ssdif0 snfi ssfi mpan enfi syl5ibr
      syl5bir necon3bd ee10 wex n0 eldifsn elssuni ssn0 sylan sylbi exlimiv syl
      fin23lem14 syl2anr neeq1 syl5ibcom rexlimdva syl5bi adantl mpd ) CLZUAZUB
      ZGMZNHWPUCZODUAZUDZXAMZXBPQZABCDEFGHIJKUEWTXCXDUFWSXCILZDUHZXBRZINUGZWTXD
      DNUIXCXHUJFBNSFLWPUHBLZUKZPRXIXJULUMDWRJUNINXBDUOUPWTXGXDINWTXENMZOXFPQZX
      GXDXKXKWRPQZXLWTXKUQWTWQPURZUSZPQZXMWTNWQUTVAZNTMZVBXPWTWPSMNWQWPVDXQCVCN
      HWPVENWQWPSVFVGVHXQXRXOPXOPRWQXNVIZXQXRWQXNVJXSXRXQWQTMZXNTMXSXTPVKXNWQVL
      VMNWQVNVOVPVQVRXPXEXOMZIVSXMIXOVTYAXMIYAXEWQMZXEPQZOXMXEWQPWAYBXEWRVIYCXM
      XEWQWBXEWRWCWDWEWFWEWGBCXEDFJWHWIXFXBPWJWKWLWMWNWO $.

    fin23lem.b $e |- P = { v e. om | |^| ran U C_ ( t ` v ) } $.
    fin23lem.c $e |- Q = ( w e. om |-> ( iota_ x e. P ( x i^i P ) ~~ w ) ) $.
    fin23lem.d $e |- R = ( w e. om |-> ( iota_ x e. ( om \ P )
        ( x i^i ( om \ P ) ) ~~ w ) ) $.
    fin23lem.e $e |- Z = if ( P e. Fin , ( t o. R ) ,
        ( ( z e. P |-> ( ( t ` z ) \ |^| ran U ) ) o. Q ) ) $.
    $( Lemma for ~ fin23 .  The residual is also one-to-one.  This preserves
       the induction invariant.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem28 $p |- ( t : om -1-1-> _V -> Z : om -1-1-> _V ) $=
      ( vb com cvv cv wf1 cfn wcel ccom wceq wa cfv crn cint cdif cmpt cif eqif
      wn mpbi wf1o wss difss ominf cun crab ssrab2 eqsstri undif unfi syl5eqelr
      wo mtoi fin23lem22 sylancr adantl f1of1 f1ss mpan2 3syl f1co syldan f1eq1
      ex syl5ibrcom impr wf weq wi wral fvex difexg ax-mp rgenw eqid fmpt fveq2
      difeq1d fvmpt ad2antrl ad2antll eqeq12d uneq2 sseq2d elrab2 simprbi sylib
      a1i syl5ib wb sseli f1fveq sylan2 sylibd sylbid ralrimivva dff13 sylanbrc
      anim12i syl mpan syl2an jaodan ) UCUDFUEZUFZGUGUHZNYDIUIZUJZUKZYFUSZNBGBU
      EZYDULZJUMUNZUOZUPZHUIZUJZUKZVLZUCUDNUFZNYFYGYPUQUJYSUAYFNYGYPURUTYEYIYTY
      RYEYFYHYTYEYFUKZYTYHUCUDYGUFZYEYFUCUCIUFZUUBUUAUCUCGUOZIVAZUCUUDIUFZUUCYF
      UUEYEYFUUDUCVBZUUDUGUHZUSUUEUCGVCZYFUUHUCUGUHZVDYFUUHUUJYFUUHUKUCGUUDVEZU
      GGUCVBZUUKUCUJGYMDUEZYDULZVBZDUCVFUCRUUODUCVGVHZGUCVIUTGUUDVJVKWDVMIUUDCA
      TVNVOVPUCUUDIVQUUFUUGUUCUUIUCUUDUCIVRVSVTUCUCUDYDIWAWBUCUDNYGWCWEWFYEYJYQ
      YTYEYJUKYTYQUCUDYPUFZYEGUDYOUFZUCGHUFZUUQYJYEGUDYOWGZOUEZYOULZUBUEZYOULZU
      JZOUBWHZWIZUBGWJOGWJUURUUTYEYNUDUHZBGWJUUTUVHBGYLUDUHUVHYKYDWKYLYMUDWLWMW
      NBGUDYNYOYOWOZWPUTXHYEUVGOUBGGYEUVAGUHZUVCGUHZUKZUKZUVEUVAYDULZYMUOZUVCYD
      ULZYMUOZUJZUVFUVMUVBUVOUVDUVQUVJUVBUVOUJYEUVKBUVAYNUVOGYOBOWHYLUVNYMYKUVA
      YDWQWRUVIUVNUDUHUVOUDUHUVAYDWKUVNYMUDWLWMWSWTUVKUVDUVQUJYEUVJBUVCYNUVQGYO
      BUBWHYLUVPYMYKUVCYDWQWRUVIUVPUDUHUVQUDUHUVCYDWKUVPYMUDWLWMWSXAXBUVMUVRUVN
      UVPUJZUVFUVRYMUVOVEZYMUVQVEZUJUVMUVSUVOUVQYMXCUVMUVTUVNUWAUVPUVMYMUVNVBZU
      VTUVNUJUVJUWBYEUVKUVJUVAUCUHZUWBUUOUWBDUVAUCGDOWHUUNUVNYMUUMUVAYDWQXDRXEX
      FWTYMUVNVIXGUVMYMUVPVBZUWAUVPUJUVKUWDYEUVJUVKUVCUCUHZUWDUUOUWDDUVCUCGDUBW
      HUUNUVPYMUUMUVCYDWQXDRXEXFXAYMUVPVIXGXBXIUVLYEUWCUWEUKUVSUVFXJUVJUWCUVKUW
      EGUCUVAUUPXKGUCUVCUUPXKXSUCUDUVAUVCYDXLXMXNXOXPOUBGUDYOXQXRUULYJUUSUUPUUL
      YJUKUCGHVAUUSHGCASVNUCGHVQXTYAUCGUDYOHWAYBUCUDNYPWCWEWFYCVS $.

    $( Lemma for ~ fin23 .  The residual is built from the same elements as the
       previous sequence.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem29 $p |- U. ran Z C_ U. ran t $=
      ( cfn wcel cv ccom cfv crn cint cdif cmpt cif wceq wa wn wo cuni wss eqif
      biimpi rneq unieqd rncoss unissi syl6eqss adantl unissb wrex cab abid a1i
      fvssunirn ssdifssd sseq1 syl5ibrcom sylbi eqid rnmpt eleq2s mprgbir sstri
      rexlimiv jaoi mp2b ) NGUBUCZFUDZIUEZBGBUDZWEUFZJUGUHZUIZUJZHUEZUKULZWDNWF
      ULZUMZWDUNZNWLULZUMZUOZNUGZUPZWEUGZUPZUQZUAWMWSWDNWFWLURUSWOXDWRWNXDWDWNX
      AWFUGZUPXCWNWTXENWFUTVAXEXBWEIVBVCVDVEWQXDWPWQXAWLUGZUPZXCWQWTXFNWLUTVAXG
      WKUGZUPZXCXFXHWKHVBVCXIXCUQOUDZXCUQZOXHOXHXCVFXKXJXJWJULZBGVGZOVHZXHXJXNU
      CXMXKXMOVIXLXKBGWGGUCZXKXLWJXCUQXOWHXCWIWHXCUQXOWEWGVKVJVLXJWJXCVMVNWAVOB
      OGWJWKWKVPVQVRVSVTVDVEWBWC $.

    $( Lemma for ~ fin23 .  The residual is disjoint from the common set.
       (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem30 $p |- ( Fun t -> ( U. ran Z i^i |^| ran U ) = (/) ) $=
      ( vb cfn wcel cv ccom cfv crn cint cdif cmpt cif wceq wa wn wfun cuni cin
      wo c0 wi eqif biimpi wral cdm wrex simpr com cen wbr crio funmpt2 sylancl
      wb funco elunirn syl dmcoss sseli fvco mpan adantl eleq2d incom crab wf1o
      wss wf difss ominf ssrab2 eqsstri undif mpbi unfi syl5eqelr mtoi ad2antrr
      cun ex fin23lem22 sylancr f1of fdm eleqtrd ffvelrnd eldifbd eleq2i sylnib
      eldifad fveq2 sseq2d elrab3 mtbid fin23lem20 orel1 sylc syl5eq disj sylib
      rsp sylbid syl5 rexlimdv ralrimiv sylibr rneq unieqd ineq1d syl5ibr exp3a
      eqeq1d impcom rncoss unissi cab wex eluniab eleq2 eldifn syl6bi rexlimivw
      exlimiv sylbi eqid rnmpt unieqi eleq2s mprgbir ssdisj mp2an a1d jaoi mp2b
      syl6eq ) NGUCUDZFUEZIUFZBGBUEUUQUGZJUHUIZUJZUKZHUFZULUMZUUPNUURUMZUNZUUPU
      OZNUVCUMZUNZUSZUUQUPZNUHZUQZUUTURZUTUMZVAZUAUVDUVJUUPNUURUVCVBVCUVFUVPUVI
      UVEUUPUVPUVEUUPUVKUVOUUPUVKUNZUVOUVEUURUHZUQZUUTURZUTUMZUVQOUEZUUTUDUOZOU
      VSVDUWAUVQUWCOUVSUVQUWBUVSUDZUWBUBUEZUURUGZUDZUBUURVEZVFZUWCUVQUURUPZUWDU
      WIVNUVQUVKIUPZUWJUUPUVKVGCVHAUEVHGUJZURCUEVIVJAUWLVKITVLZUUQIVOVMUBUWBUUR
      VPVQUVQUWGUWCUBUWHUWEUWHUDUWEIVEZUDZUVQUWGUWCVAZUWHUWNUWEUUQIVRVSUVQUWOUW
      PUVQUWOUNZUWGUWBUWEIUGZUUQUGZUDZUWCUWQUWFUWSUWBUWOUWFUWSUMZUVQUWKUWOUXAUW
      MUWEUUQIVTWAWBWCUWQUWCOUWSVDZUWTUWCVAUWQUWSUUTURZUTUMUXBUWQUXCUUTUWSURZUT
      UWSUUTWDUWQUUTUWSWGZUOUXEUXDUTUMZUSZUXFUWQUWRUUTDUEZUUQUGZWGZDVHWEZUDZUXE
      UWQUWRGUDUXLUWQUWRVHGUWQVHUWLUWEIUWQVHUWLIWFZVHUWLIWHZUWQUWLVHWGUWLUCUDZU
      OZUXMVHGWIUUPUXPUVKUWOUUPUXOVHUCUDZWJUUPUXOUXQUUPUXOUNVHGUWLWSZUCGVHWGUXR
      VHUMGUXKVHRUXJDVHWKWLGVHWMWNGUWLWOWPWTWQWRIUWLCATXAXBVHUWLIXCVQZUWQUWEUWN
      VHUVQUWOVGUWQUXNUWNVHUMUXSVHUWLIXDVQXEXFZXGGUXKUWRRXHXIUWQUWRVHUDZUXLUXEV
      NUWQUWRVHGUXTXJZUXJUXEDUWRVHUXHUWRUMUXIUWSUUTUXHUWRUUQXKXLXMVQXNUWQUYAUXG
      UYBEFUWRJLPXOVQUXEUXFXPXQXROUWSUUTXSXTUWCOUWSYAVQYBWTYCYDYBYEOUVSUUTXSYFU
      VEUVNUVTUTUVEUVMUVSUUTUVEUVLUVRNUURYGYHYIYLYJYKYMUVHUVPUVGUVHUVOUVKUVHUVN
      UVCUHZUQZUUTURZUTUVHUVMUYDUUTUVHUVLUYCNUVCYGYHYIUYDUVBUHZUQZWGUYGUUTURUTU
      MZUYEUTUMUYCUYFUVBHYNYOUYHUWCOUYGOUYGUUTXSUWCUWBUWEUVAUMZBGVFZUBYPZUQZUYG
      UWBUYLUDUWBUWEUDZUYJUNZUBYQUWCUYJUBUWBYRUYNUWCUBUYJUYMUWCUYIUYMUWCVABGUYI
      UYMUWBUVAUDUWCUWEUVAUWBYSUWBUUSUUTYTUUAUUBYMUUCUUDUYFUYKBUBGUVAUVBUVBUUEU
      UFUUGUUHUUIUYDUYGUUTUUJUUKUUOUULWBUUMUUN $.

    $( Lemma for ~ fin23 .  The residual is has a strictly smaller range than
       the previous sequence.  This will be iterated to build an unbounded
       chain.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem31 $p |- ( ( t : om -1-1-> V /\ G e. F /\
        U. ran t C_ G ) -> U. ran Z C. U. ran t ) $=
      ( com cv wf1 wcel crn cuni wss wpss wa ssfin3ds wne fin23lem29 a1i c0 wex
      cint fin23lem21 ancoms n0 sylib wn cdm wfn wceq cvv cfv cin cmpt2 fnseqom
      cif fndm ax-mp peano1 ne0i eqnetri dm0rn0 necon3bii mpbi intssuni sseqtri
      fin23lem16 sseli adantl wral wi wfun f1fun adantr fin23lem30 syl disj rsp
      con2d imp nelne1 syl2anc necomd exlimddv df-pss sylanbrc sylan2 3impb ) U
      DOFUEZUFZNMUGZXFUHUIZNUJZPUHUIZXIUKZXHXJULXGXIMUGZXLNXIKMQASUMXGXMULZXKXI
      UJZXKXIUNZXLXOXNABCDEFGHIJKLMPQRSTUAUBUCUOUPXNQUEZJUHZUSZUGZXPQXNXSUQUNZX
      TQURXMXGYAAEFJKLMOQRSUTVAQXSVBVCXNXTULZXIXKYBXQXIUGZXQXKUGZVDZXIXKUNXTYCX
      NXSXIXQXSXRUIZXIXRUQUNZXSYFUJJVEZUQUNYGYHUDUQJUDVFYHUDVGLEUDVHLUEXFVIEUEZ
      VJZUQVGYIYJVMVKJXIRVLUDJVNVOUQUDUGUDUQUNVPUDUQVQVOVRYHUQXRUQJVSVTWAXRWBVO
      EFJLRWDWCWEWFXNXTYEXNYDXTXNXTVDZQXKWGZYDYKWHXNXKXSVJUQVGZYLXNXFWIZYMXGYNX
      MUDOXFWJWKABCDEFGHIJKLMPQRSTUAUBUCWLWMQXKXSWNVCYKQXKWOWMWPWQXQXIXKWRWSWTX
      AXKXIXBXCXDXE $.

    $( Lemma for ~ fin23 .  Wrap the previous construction into a function to
       hide the hypotheses.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem32 $p |- ( G e. F -> E. f A. b
        ( ( b : om -1-1-> _V /\ U. ran b C_ G ) ->
        ( ( f ` b ) : om -1-1-> _V /\ U. ran ( f ` b ) C. U. ran b ) ) ) $=
      ( wcel com cvv cv wf1 crn cuni wss wa cfv wpss wi wal wex cmap fin23lem28
      cpw co cmpt ad2antrl simprl simpl simprr fin23lem31 syl3anc wceq wfn f1fn
      wb wf dffn3 sylib sspwuni biimpri ad2antll fss syl2anc pwexg adantr dmfex
      vex f1f sylancr elmapg mpbird syl fex fvmpt2 f1eq1 unieqd psseq1d anbi12d
      eqid rneq mpbir2and ex alrimiv ovex mptex nfmpt1 nfeq2 fveq1 rneqd imbi2d
      albid spcev sseq1d fveq2 psseq12d imbi12d cbvalv exbii sylibr ) ONUEZUFUG
      FUHZUIZXSUJZUKZOULZUMZUFUGXSKUHZUNZUIZYFUJZUKZYBUOZUMZUPZFUQZKURZUFUGRUHZ
      UIZYOUJZUKZOULZUMZUFUGYOYEUNZUIZUUAUJZUKZYRUOZUMZUPZRUQZKURXRYDUFUGXSFOVA
      ZUFUSVBZPVCZUNZUIZUULUJZUKZYBUOZUMZUPZFUQZYNXRUURFXRYDUUQXRYDUMZUUQUFUGPU
      IZPUJZUKZYBUOZXTUVAXRYCABCDEFGHIJLMNPQSTUAUBUCUDUTVDZUUTXTXRYCUVDXRXTYCVE
      XRYDVFXRXTYCVGABCDEFGHIJLMNOUGPQSTUAUBUCUDVHVIUUTUULPVJZUUQUVAUVDUMVMUUTX
      SUUJUEZPUGUEZUVFUUTUVGUFUUIXSVNZUUTUFYAXSVNZYAUUIULZUVIXTUVJXRYCXTXSUFVKU
      VJUFUGXSVLUFXSVOVPVDYCUVKXRXTUVKYCYAOVQVRVSUFYAUUIXSVTWAUUTUUIUGUEZUFUGUE
      ZUVGUVIVMXRUVLYDONWBWCXTUVMXRYCXTXSUGUEUFUGXSVNUVMFWEUFUGXSWFUFUGUGXSWDWG
      VDZUUIUFXSUGUGWHWAWIUUTUFUGPVNZUVMUVHUUTUVAUVOUVEUFUGPWFWJUVNUFUGUGPWKWAF
      UUJPUGUUKUUKWQWLWAUVFUUMUVAUUPUVDUFUGUULPWMUVFUUOUVCYBUVFUUNUVBUULPWRWNWO
      WPWJWSWTXAYMUUSKUUKFUUJPUUIUFUSXBXCYEUUKVJZYLUURFFYEUUKFUUJPXDXEUVPYKUUQY
      DUVPYGUUMYJUUPUVPYFUULVJYGUUMVMXSYEUUKXFZUFUGYFUULWMWJUVPYIUUOYBUVPYHUUNU
      VPYFUULUVQXGWNWOWPXHXIXJWJUUHYMKUUGYLRFYOXSVJZYTYDUUFYKUVRYPXTYSYCUFUGYOX
      SWMUVRYRYBOUVRYQYAYOXSWRWNZXKWPUVRUUBYGUUEYJUVRUUAYFVJUUBYGVMYOXSYEXLZUFU
      GUUAYFWMWJUVRUUDYIYRYBUVRUUCYHUVRUUAYFUVTXGWNUVSXMWPXNXOXPXQ $.
  $}

  ${
    $d a b c d e f g i j k l x y $.  $d a j A $.  $d a b c d e f g h i j x G $.
    $d a b B $.  $d a c e F $.  $d a b c d e j ph $.  $d a b c d e j Y $.
    fin23lem33.f $e |- F = { g | A. a e. ( ~P g ^m om )
      ( A. x e. om ( a ` suc x ) C_ ( a ` x ) -> |^| ran a e. ran a ) } $.
    $( Lemma for ~ fin23 .  Discharge hypotheses.  (Contributed by Stefan
       O'Rear, 2-Nov-2014.) $)
    fin23lem33 $p |- ( G e. F -> E. f A. b
        ( ( b : om -1-1-> _V /\ U. ran b C_ G ) ->
        ( ( f ` b ) : om -1-1-> _V /\ U. ran ( f ` b ) C. U. ran b ) ) ) $=
      ( vi vy vd vc com cv cfv cin c0 wceq cif eqid ve vj vk cvv cmpt2 crn cuni
      vl cseqom cint wss crab cen wbr crio cmpt cdif cfn wcel ccom fveq2 ineq1d
      eqeq1d ifbieq2d id ifbieq12d cbvmpt2v seqomeq12 sseq2d cbvrabv fin23lem32
      ineq2 mp2an ) AICJKUAUBUCMUDUBNZUANZOZUCNZPZQRZVQVRSZUEZVOUFUGZUIZUFUJZUH
      NZVOOZUKZUHMULZCMANZWHPCNZUMUNAWHUOUPZCMWIMWHUQZPWJUMUNAWLUOUPZWCBCLDEWHU
      RUSVOWMUTIWHINVOOWDUQUPWKUTSZFGWALKMUDLNZVOOZKNZPZQRZWQWRSZUEZRWBWBRWCXAW
      BUIRUBUCLKMUDVTWTWPVQPZQRZVQXBSVNWORZVSXCVRXBVQXDVRXBQXDVPWPVQVNWOVOVAVBZ
      VCXEVDVQWQRZXCWSVQXBWQWRXFXBWRQVQWQWPVLZVCXFVEXGVFVGWBTWAXAWBWBVHVMHWGWDJ
      NZVOOZUKUHJMWEXHRWFXIWDWEXHVOVAVIVJWKTWMTWNTVK $.

    fin23lem.f $e |- ( ph -> h : om -1-1-> _V ) $.
    fin23lem.g $e |- ( ph -> U. ran h C_ G ) $.
    fin23lem.h $e |- ( ph -> A. j ( ( j : om -1-1-> _V /\ U. ran j C_ G ) ->
        ( ( i ` j ) : om -1-1-> _V /\ U. ran ( i ` j ) C. U. ran j ) ) ) $.
    fin23lem.i $e |- Y = ( rec ( i , h ) |` om ) $.
    $( Lemma for ~ fin23 .  Establish induction invariants on ` Y ` which
       parameterizes our contradictory chain of subsets.  In this section,
       ` h ` is the hypothetically assumed family of subsets, ` g ` is the
       ground set, and ` i ` is the induction function constructed in the
       previous section.  (Contributed by Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem34 $p |- ( ( ph /\ A e. om ) -> ( ( Y ` A ) : om -1-1-> _V /\
        U. ran ( Y ` A ) C_ G ) ) $=
      ( com cvv cfv wceq vb wcel wf1 crn cuni wss wa cv wi c0 csuc wb fveq2 syl
      f1eq1 rneqd unieqd sseq1d anbi12d imbi2d crdg cres fveq1i vex ax-mp eqtri
      fr0g rneqi unieqi sseq1i anbi12i sylanbrc w3a wpss wal fvex rneq psseq12d
      imbi12d spcv imp pssss sstr sylan expcom anim2d ad2antll mpd frsuc fveq2i
      3adant1 3eqtr4g 3ad2ant1 mpbird 3exp a2d finds impcom ) CQUBAQRCJSZUCZWSU
      DZUEZIUFZUGZAQRKUHZJSZUCZXFUDZUEZIUFZUGZUIAQRUJJSZUCZXLUDZUEZIUFZUGZUIAQR
      UAUHZJSZUCZXSUDZUEZIUFZUGZUIAQRXRUKZJSZUCZYFUDZUEZIUFZUGZUIAXDUIKUACXEUJT
      ZXKXQAYLXGXMXJXPYLXFXLTXGXMULXEUJJUMZQRXFXLUOUNYLXIXOIYLXHXNYLXFXLYMUPUQU
      RUSUTXEXRTZXKYDAYNXGXTXJYCYNXFXSTXGXTULXEXRJUMZQRXFXSUOUNYNXIYBIYNXHYAYNX
      FXSYOUPUQURUSUTXEYETZXKYKAYPXGYGXJYJYPXFYFTXGYGULXEYEJUMZQRXFYFUOUNYPXIYI
      IYPXHYHYPXFYFYQUPUQURUSUTXECTZXKXDAYRXGWTXJXCYRXFWSTXGWTULXECJUMZQRXFWSUO
      UNYRXIXBIYRXHXAYRXFWSYSUPUQURUSUTAQREUHZUCZYTUDZUEZIUFZXQMNXMUUAXPUUDXLYT
      TXMUUAULXLUJFUHZYTVAQVBZSZYTUJJUUFPVCYTRUBUUGYTTEVDYTRUUEVGVEVFZQRXLYTUOV
      EXOUUCIXNUUBXLYTUUHVHVIVJVKVLXRQUBZAYDYKUUIAYDYKUUIAYDVMYKQRXSUUESZUCZUUJ
      UDZUEZIUFZUGZAYDUUOUUIAYDUGUUKUUMYBVNZUGZUUOAYDUUQAQRGUHZUCZUURUDZUEZIUFZ
      UGZQRUURUUESZUCZUVDUDZUEZUVAVNZUGZUIZGVOYDUUQUIZOUVJUVKGXSXRJVPUURXSTZUVC
      YDUVIUUQUVLUUSXTUVBYCQRUURXSUOUVLUVAYBIUVLUUTYAUURXSVQUQZURUSUVLUVEUUKUVH
      UUPUVLUVDUUJTUVEUUKULUURXSUUEUMZQRUVDUUJUOUNUVLUVGUUMUVAYBUVLUVFUULUVLUVD
      UUJUVNUPUQUVMVRUSVSVTUNWAYCUUQUUOUIAXTYCUUPUUNUUKUUPYCUUNUUPUUMYBUFYCUUNU
      UMYBWBUUMYBIWCWDWEWFWGWHWKUUIAYKUUOULZYDUUIYFUUJTZUVOUUIYEUUFSXRUUFSZUUES
      YFUUJYTXRUUEWIYEJUUFPVCXSUVQUUEXRJUUFPVCWJWLUVPYGUUKYJUUNQRYFUUJUOUVPYIUU
      MIUVPYHUULYFUUJVQUQURUSUNWMWNWOWPWQWR $.

    $( Lemma for ~ fin23 .  Strict order property of ` Y ` .  (Contributed by
       Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem35 $p |- ( ( ph /\ A e. om ) -> U. ran ( Y ` suc A ) C.
        U. ran ( Y ` A ) ) $=
      ( com wa cfv cvv wcel csuc crn cuni wpss wf1 wss fin23lem34 wal fvex wceq
      cv wi f1eq1 rneq unieqd sseq1d anbi12d wb fveq2 syl psseq12d imbi12d spcv
      rneqd adantr simprd crdg cres adantl fveq1i fveq2i 3eqtr4g psseq1d mpbird
      mpd frsuc ) ACQUAZRZCUBZJSZUCZUDZCJSZUCZUDZUEWDFULZSZUCZUDZWFUEZVSQTWHUFZ
      WKVSQTWDUFZWFIUGZRZWLWKRZABCDEFGHIJKLMNOPUHAWOWPUMZVRAQTGULZUFZWRUCZUDZIU
      GZRZQTWRWGSZUFZXDUCZUDZXAUEZRZUMZGUIWQOXJWQGWDCJUJWRWDUKZXCWOXIWPXKWSWMXB
      WNQTWRWDUNXKXAWFIXKWTWEWRWDUOUPZUQURXKXEWLXHWKXKXDWHUKXEWLUSWRWDWGUTZQTXD
      WHUNVAXKXGWJXAWFXKXFWIXKXDWHXMVEUPXLVBURVCVDVAVFVPVGVSWCWJWFVSWBWIVSWAWHV
      SVTWGEULZVHQVIZSZCXOSZWGSZWAWHVRXPXRUKAXNCWGVQVJVTJXOPVKWDXQWGCJXOPVKVLVM
      VEUPVNVO $.

    $( Lemma for ~ fin23 .  Weak order property of ` Y ` .  (Contributed by
       Stefan O'Rear, 2-Nov-2014.) $)
    fin23lem36 $p |- ( ( ( A e. om /\ B e. om ) /\ ( B C_ A /\ ph ) ) ->
        U. ran ( Y ` A ) C_ U. ran ( Y ` B ) ) $=
      ( wa wss wi vb com wcel cfv crn cuni csuc wceq fveq2 unieqd sseq1d imbi2d
      cv rneqd ssid a1ii wpss simprr simpll fin23lem35 syl2anc pssssd sstr2 syl
      expr a2d findsg impr ) CUBUCDUBUCZRDCSACKUDZUEZUFZDKUDZUEZUFZSZALUMZKUDZU
      EZUFZVOSZTAVOVOSZTAUAUMZKUDZUEZUFZVOSZTAWCUGZKUDZUEZUFZVOSZTAVPTLUACDVQDU
      HZWAWBAWMVTVOVOWMVSVNWMVRVMVQDKUIUNUJUKULVQWCUHZWAWGAWNVTWFVOWNVSWEWNVRWD
      VQWCKUIUNUJUKULVQWHUHZWAWLAWOVTWKVOWOVSWJWOVRWIVQWHKUIUNUJUKULVQCUHZWAVPA
      WPVTVLVOWPVSVKWPVRVJVQCKUIUNUJUKULVIAWBVOUOUPWCUBUCZVIRZDWCSZRAWGWLWRWSAW
      GWLTZWRWSARZRZWKWFSWTXBWKWFXBAWQWKWFUQWRWSAURWQVIXAUSABWCEFGHIJKLMNOPQUTV
      AVBWKWFVOVCVDVEVFVGVH $.

    $( Lemma for ~ fin23 .  The contradictory chain has no minimum.
       (Contributed by Stefan O'Rear, 2-Nov-2014.)  (Revised by Mario Carneiro,
       17-May-2015.) $)
    fin23lem38 $p |- ( ph -> -. |^| ran ( b e. om |->
          U. ran ( Y ` b ) ) e. ran ( b e. om |-> U. ran ( Y ` b ) ) ) $=
      ( vd com wceq wcel cv cfv crn cuni cmpt cint wrex wa wpss csuc wss peano2
      wn eqid fveq2 rneqd unieqd eqeq2d rspcev mpan2 wb fvex rnex uniex elrnmpt
      cvv ax-mp sylibr adantl intss1 fin23lem35 sspsstrd dfpss2 simprbi cbvmptv
      syl nrexdv ibi nsyl ) AKRKUAZIUBZUCZUDZUEZUCZUFZQUAZIUBZUCZUDZSZQRUGZWFWE
      TZAWKQRAWGRTZUHZWFWJUIZWKUMZWOWFWGUJZIUBZUCZUDZWJWOXAWETZWFXAUKWNXBAWNWRR
      TZXBWGULXCXAWCSZKRUGZXBXCXAXASZXEXAUNXDXFKWRRVTWRSZWCXAXAXGWBWTXGWAWSVTWR
      IUOUPUQURUSUTXAVFTXBXEVAWTWSWRIVBVCVDKRWCXAWDVFWDUNVEVGVHVPVIXAWEVJVPABWG
      CDEFGHIJLMNOPVKVLWPWFWJUKWQWFWJVMVNVPVQWMWLQRWJWFWDWEKQRWCWJVTWGSZWBWIXHW
      AWHVTWGIUOUPUQVOVEVRVS $.

    $( Lemma for ~ fin23 .  Thus, we have that ` g ` could not have been in
       ` F ` after all.  (Contributed by Stefan O'Rear, 4-Nov-2014.) $)
    fin23lem39 $p |- ( ph -> -. G e. F ) $=
      ( vc wcel com cfv cvv ve vd cv crn cuni cmpt cint fin23lem38 wa cmap csuc
      cpw co wss wral wi wf fin23lem34 simprd adantlr wb elpw2g ad2antlr mpbird
      wf1 eqid fmptd pwexg vex f1f dmfex sylancr elmapg syl2anr isfin3ds adantl
      syl ibi fin23lem35 pssssd wceq peano2 fveq2 rneqd unieqd fvex uniex fvmpt
      sseq12d ralrimiva adantr fveq1 ralbidv inteqd eleq12d imbi12d rspcv syl3c
      rnex rneq mtand ) AHGQZPRPUCZISZUDZUEZUFZUDZUGZXHQZABCDEFGHIJPKLMNOUHAXBU
      IZXGHULZRUJUMZQZUAUCZUKZUBUCZSZXOXQSZUNZUARUOZXQUDZUGZYBQZUPZUBXMUOZXPXGS
      ZXOXGSZUNZUARUOZXJXKXNRXLXGUQZXKPRXFXLXGXKXCRQZUIXFXLQZXFHUNZAYLYNXBAYLUI
      RTXDVEYNABXCCDEFGHIJKLMNOURUSUTXBYMYNVAAYLXFHGVBVCVDXGVFZVGXBXLTQRTQZXNYK
      VAAHGVHARTDUCZVEZYPLYRYQTQRTYQUQYPDVIRTYQVJRTTYQVKVLVQXLRXGTTVMVNVDXBYFAX
      BYFUAHUBCGGJBKVOVRVPAYJXBAYIUARAXORQZUIZYIXPISZUDZUEZXOISZUDZUEZUNZYTUUCU
      UFABXOCDEFGHIJKLMNOVSVTYSYIUUGVAAYSYGUUCYHUUFYSXPRQYGUUCWAXOWBPXPXFUUCRXG
      XCXPWAZXEUUBUUHXDUUAXCXPIWCWDWEYOUUBUUAXPIWFWSWGWHVQPXOXFUUFRXGXCXOWAZXEU
      UEUUIXDUUDXCXOIWCWDWEYOUUEUUDXOIWFWSWGWHWIVPVDWJWKYEYJXJUPUBXGXMXQXGWAZYA
      YJYDXJUUJXTYIUARUUJXRYGXSYHXPXQXGWLXOXQXGWLWIWMUUJYCXIYBXHUUJYBXHXQXGWTZW
      NUUKWOWPWQWRXA $.
  $}

  ${
    $d a b c d e f g x A $.  $d a b c e F $.
    fin23lem40.f $e |- F = { g | A. a e. ( ~P g ^m om )
      ( A. x e. om ( a ` suc x ) C_ ( a ` x ) -> |^| ran a e. ran a ) } $.
    $( Lemma for ~ fin23 . ` Fin2 ` sets satisfy the descending chain
       condition.  (Contributed by Stefan O'Rear, 3-Nov-2014.) $)
    fin23lem40 $p |- ( A e. Fin2 -> A e. F ) $=
      ( vb vf cfin2 wcel cv cfv wss com wral wa c0 wne crpss ad2antrl csuc cint
      crn wi cpw cmap co wf elmapi wor simpl frn cdm peano1 ne0i eqnetrd dm0rn0
      fdm mp1i necon3bii sylib ccnv wfn wbr wceq wpo ffn wpss sspss fvex brrpss
      brcnv bitri eqcom orbi12i biimpri sylbi ralimi ad2antll porpss cnvpo mpbi
      a1i sornom syl3anc cnvso sylibr fin2i2 syl22anc sylan2 ralrimiva isfin3ds
      wo expr mpbird ) BIJZBDJGKZUAZHKZLZWQWSLZMZGNOZWSUCZUBXDJZUDZHBUEZNUFUGZO
      WPXFHXHWSXHJWPNXGWSUHZXFWSXGNUIWPXIXCXEWPXIXCPZPZWPXDXGMZXDQRZXDSUJZXEWPX
      JUKXIXLWPXCNXGWSULTXIXMWPXCXIWSUMZQRXMXIXONQNXGWSURQNJNQRXIUNNQUOUSUPXOQX
      DQWSUQUTVATXKXDSVBZUJZXNXKWSNVCZXAWTXPVDZXAWTVEZWMZGNOZXDXPVFZXQXIXRWPXCN
      XGWSVGTXCYBWPXIXBYAGNXBWTXAVHZWTXAVEZWMZYAWTXAVIYAYFXSYDXTYEXSWTXASVDYDXA
      WTSWQWSVJZWRWSVJVLWTXAYGVKVMXAWTVNVOVPVQVRVSYCXKXDSVFYCXDVTXDSWAWBWCXPWSG
      WDWEXDSWFWGBXDWHWIWNWJWKGBHCDIEAFWLWO $.

    $( Lemma for ~ fin23 .  A set which satisfies the descending sequence
       condition must be III-finite.  (Contributed by Stefan O'Rear,
       2-Nov-2014.) $)
    fin23lem41 $p |- ( A e. F -> A e. Fin3 ) $=
      ( vb vd vc ve wcel com cv wf1 wa cvv crn cuni wss syl cpw cfin4 cfin3 wbr
      cdom wn wex brdomi cfv wpss wi wal fin23lem33 adantl crdg cres f1ss mpan2
      ssv ad2antrr wf f1f frn uniss 3syl unipw syl6sseq wceq rneq unieqd sseq1d
      f1eq1 anbi12d wb fveq2 rneqd psseq12d imbi12d cbvalv biimpi eqid exlimddv
      fin23lem39 pm2.01da exlimiv con2i pwexg isfin4-2 mpbird isfin3 sylibr ) B
      DKZBUAZUBKZBUCKWLWNLWMUEUDZUFZWOWLWOLWMGMZNZGUGWLUFZLWMGUHWRWSGWRWLWRWLOZ
      LPHMZNZXAQZRZBSZOZLPXAIMZUIZNZXHQZRZXDUJZOZUKZHULZWSIWLXOIUGWRAICDBEHFUMU
      NWTXOOACGIJDBXGWQUOLUPZEFWRLPWQNZWLXOWRWMPSXQWMUSLWMPWQUQURUTWRWQQZRZBSWL
      XOWRXSWMRZBWRLWMWQVAXRWMSXSXTSLWMWQVBLWMWQVCXRWMVDVEBVFVGUTXOLPJMZNZYAQZR
      ZBSZOZLPYAXGUIZNZYGQZRZYDUJZOZUKZJULZWTXOYNXNYMHJXAYAVHZXFYFXMYLYOXBYBXEY
      ELPXAYAVLYOXDYDBYOXCYCXAYAVIVJZVKVMYOXIYHXLYKYOXHYGVHXIYHVNXAYAXGVOZLPXHY
      GVLTYOXKYJXDYDYOXJYIYOXHYGYQVPVJYPVQVMVRVSVTUNXPWAWCWBWDWETWFWLWMPKWNWPVN
      BDWGWMPWHTWIBWJWK $.
  $}

  ${
    $d a b w x B $.  $d a b t G $.  $d a b x L $.  $d a b c s t u v w x y ph $.
    $d a b c d w x y A $.  $d a b c d w x y F $.  $d a b s t u v w x y S $.
    $d s t w x y J $.  $d a b s t x y K $.
    isf32lem.a $e |- ( ph -> F : om --> ~P G ) $.
    isf32lem.b $e |- ( ph -> A. x e. om ( F ` suc x ) C_ ( F ` x ) ) $.
    isf32lem.c $e |- ( ph -> -. |^| ran F e. ran F ) $.
    $( Lemma for ~ isfin3-2 .  Derive weak ordering property.  (Contributed by
       Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem1 $p |- ( ( ( A e. om /\ B e. om ) /\ ( B C_ A /\ ph ) ) ->
        ( F ` A ) C_ ( F ` B ) ) $=
      ( com wcel wa wss cfv cv wi wceq fveq2 sseq1d imbi2d va vb csuc ssid a1ii
      wral suceq fveq2d sseq12d rspcv syl5 ad2antrr sstr2 syl6 a2d findsg impr
      ) CJKDJKZLDCMACENZDENZMZAUAOZENZUTMZPAUTUTMZPAUBOZENZUTMZPAVFUCZENZUTMZPA
      VAPUAUBCDVBDQZVDVEAVLVCUTUTVBDERSTVBVFQZVDVHAVMVCVGUTVBVFERSTVBVIQZVDVKAV
      NVCVJUTVBVIERSTVBCQZVDVAAVOVCUSUTVBCERSTURAVEUTUDUEVFJKZURLDVFMZLZAVHVKVR
      AVJVGMZVHVKPVPAVSPURVQABOZUCZENZVTENZMZBJUFVPVSHWDVSBVFJVTVFQZWBVJWCVGWEW
      AVIEVTVFUGUHVTVFERUIUJUKULVJVGUTUMUNUOUPUQ $.

    $( Lemma for ~ isfin3-2 .  Non-minimum implies that there is always another
       decrease.  (Contributed by Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem2 $p |- ( ( ph /\ A e. om ) -> E. a e. om ( A e. a /\
        ( F ` suc a ) C. ( F ` a ) ) ) $=
      ( vb com wcel wa cv cfv wceq wi wss syl fveq2 vc vd csuc wn wrex wpss crn
      wral cint adantr wfn cpw wf ffn peano2 fnfvelrn syl2an intss1 wb ad2antrr
      fvelrnb simplrr ad3antlr simpr simplrl eqeq2d imbi2d eqid a1ii cvv sucexb
      elex sylibr adantl sucssel eleq2 suceq fveq2d eqeq12d imbi12d rspcv com23
      imp mpd eqtr3 expcom syl6 a2d findsg impr syl22anc simplll isf32lem1 word
      eqimss wo ad2antlr ad2antll ordtri2or2 syl2anc mpjaodan anassrs syl5ibcom
      nnord sseq2 rexlimdva sylbid ralrimiv ssint eqssd eqeltrd sseq12d cbvralv
      mtand rexnal sylib pm4.61 dfpss2 simplbi2 anim2d syl5bi ralimi rexim 3syl
      ) ACKLZMZCFNZLZYGUCZDOZYGDOZPZQZUDZFKUEZYHYJYKUFZMZFKUEZYFYMFKUHZUDYOYFYS
      DUGZUIZYTLZAUUBUDYEIUJYFYSMZUUACUCZDOZYTUUCUUAUUEUUCUUEYTLZUUAUUERYFUUFYS
      ADKUKZUUDKLZUUFYEAKEULZDUMUUGGKUUIDUNSZCUOZKUUDDUPUQUJZUUEYTURSUUCUUEJNZR
      ZJYTUHUUEUUARUUCUUNJYTUUCUUMYTLZUANZDOZUUMPZUAKUEZUUNAUUOUUSUSZYEYSAUUGUU
      TUUJUAKUUMDVASUTUUCUURUUNUAKUUCUUPKLZMUUEUUQRZUURUUNYFYSUVAUVBYFYSUVAMZMZ
      UUDUUPRZUVBUUPUUDRZUVDUVEMZUUEUUQPZUVBUVGUVAUUHUVEYSUVHYFYSUVAUVEVBYEUUHA
      UVCUVEUUKVCUVDUVEVDYFYSUVAUVEVEUVAUUHMUVEYSUVHYSUUEUUMDOZPZQYSUUEUUEPZQYS
      UUEUBNZDOZPZQYSUUEUVLUCZDOZPZQYSUVHQJUBUUPUUDUUMUUDPZUVJUVKYSUVRUVIUUEUUE
      UUMUUDDTVFVGUUMUVLPZUVJUVNYSUVSUVIUVMUUEUUMUVLDTVFVGUUMUVOPZUVJUVQYSUVTUV
      IUVPUUEUUMUVODTVFVGUUMUUPPZUVJUVHYSUWAUVIUUQUUEUUMUUPDTVFVGUUHYSUVKUUEVHV
      IUVLKLZUUHMZUUDUVLRZMZYSUVNUVQUWEYSUVPUVMPZUVNUVQQUWECUVLLZYSUWFQZUWCUWDU
      WGUWCCVJLZUWDUWGQUUHUWIUWBUUHUUDVJLUWIUUDKVLCVKVMVNCUVLVJVOSWCUWBUWGUWHQU
      UHUWDUWBYSUWGUWFYMUWGUWFQFUVLKYGUVLPZYHUWGYLUWFYGUVLCVPUWJYJUVPYKUVMUWJYI
      UVODYGUVLVQVRYGUVLDTVSVTWAWBUTWDUVNUWFUVQUUEUVPUVMWEWFWGWHWIWJWKUUEUUQWOS
      UVDUVFMUUHUVAUVFAUVBYEUUHAUVCUVFUUKVCYFYSUVAUVFVBUVDUVFVDAYEUVCUVFWLABUUD
      UUPDEGHIWMWKUVDUUDWNZUUPWNZUVEUVFWPYEUWKAUVCYEUUHUWKUUKUUDXDSWQUVAUWLYFYS
      UUPXDWRUUDUUPWSWTXAXBUUQUUMUUEXEXCXFXGXHJUUEYTXIVMXJUULXKXNYMFKXOVMYFYJYK
      RZFKUHZYNYQQZFKUHYOYRQAUWNYEABNZUCZDOZUWPDOZRZBKUHUWNHUWTUWMBFKUWPYGPZUWR
      YJUWSYKUXAUWQYIDUWPYGVQVRUWPYGDTXLXMXPUJUWMUWOFKYNYHYLUDZMUWMYQYHYLXQUWMU
      XBYPYHYPUWMUXBYJYKXRXSXTYAYBYNYQFKYCYDWD $.

    $( Lemma for ~ isfin3-2 .  Being a chain, difference sets are disjoint (one
       case).  (Contributed by Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem3 $p |- ( ( ( A e. om /\ B e. om ) /\ ( B e. A /\ ph ) ) ->
        ( ( ( F ` A ) \ ( F ` suc A ) ) i^i
          ( ( F ` B ) \ ( F ` suc B ) ) ) = (/) ) $=
      ( va com wcel wa cv cfv csuc cdif wn wral wss cin c0 eldifi simpll peano2
      wceq ad2antlr word nnord ad2antrr simprl ordsucss sylc isf32lem1 syl22anc
      simprr sseld elndif syl56 ralrimiv disj sylibr ) CKLZDKLZMZDCLZAMZMZJNZDE
      OZDPZEOZQZLRZJCEOZCPEOZQZSVQVMUAUBUFVHVNJVQVIVQLVIVOLVHVIVLLVNVIVOVPUCVHV
      OVLVIVHVCVKKLZVKCTZAVOVLTVCVDVGUDVDVRVCVGDUEUGVHCUHZVFVSVCVTVDVGCUIUJVEVF
      AUKDCULUMVEVFAUPABCVKEFGHIUNUOUQVIVLVJURUSUTJVQVMVAVB $.

    $( Lemma for ~ isfin3-2 .  Being a chain, difference sets are disjoint.
       (Contributed by Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem4 $p |- ( ( ( ph /\ A =/= B ) /\ ( A e. om /\ B e. om ) ) ->
        ( ( ( F ` A ) \ ( F ` suc A ) ) i^i
          ( ( F ` B ) \ ( F ` suc B ) ) ) = (/) ) $=
      ( wa com wcel cfv csuc cdif cin c0 wceq simplrr simplrl wne simpr simplll
      incom isf32lem3 syl5eq syl22anc wo simplr wn wb word nnord ordtri3 syl2an
      adantl necon2abid mpbird mpjaodan ) ACDUAZJZCKLZDKLZJZJZCDLZCEMCNEMOZDEMD
      NEMOZPZQRZDCLZVEVFJVCVBVFAVJVAVBVCVFSVAVBVCVFTVEVFUBAUTVDVFUCVCVBJVFAJJVI
      VHVGPQVGVHUDABDCEFGHIUEUFUGVEVKJVBVCVKAVJVAVBVCVKTVAVBVCVKSVEVKUBAUTVDVKU
      CABCDEFGHIUEUGVEVFVKUHZUTAUTVDUIVEVLCDVDCDRVLUJUKZVAVBCULDULVMVCCUMDUMCDU
      NUOUPUQURUS $.

    isf32lem.d $e |- S = { y e. om | ( F ` suc y ) C. ( F ` y ) } $.
    $( Lemma for ~ isfin3-2 .  There are infinite decrease points.
       (Contributed by Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem5 $p |- ( ph -> -. S e. Fin ) $=
      ( va vb wcel cv cfv wa com wrex wn con0 cfn csuc wpss isf32lem2 ralrimiva
      wral cuni wss crab ssrab2 eqsstri nnunifi mpan adantl elssuni nnon omsson
      wi sseldi ontri1 syl2anr syl5ib con2d impr eleq2i sylnib wceq suceq fveq2
      wb fveq2d psseq12d elrab3 ad2antrl mtbid imnan sylib nrexdv eleq1 rexbidv
      expr anbi1d notbid rspcev syl2anc rexnal ex mt2d ) ADUAMZKNZLNZMZWKUBZEOZ
      WKEOZUCZPZLQRZKQUFZAWRKQABWJEFLGHIUDUEAWIWSSZAWIPZWRSZKQRZWTXADUGZQMZXDWK
      MZWPPZLQRZSZXCWIXEADQUHWIXEDCNZUBZEOZXJEOZUCZCQUIZQJXNCQUJUKDULUMUNZXAXGL
      QXAWKQMZPZXFWPSZURXGSXAXQXFXSXAXQXFPPZWKXOMZWPXTWKDMZYAXAXQXFYBSXRYBXFYBW
      KXDUHZXRXFSZWKDUOXQWKTMXDTMYCYDVJXAWKUPXAQTXDUQXPUSWKXDUTVAVBVCVDDXOWKJVE
      VFXQYAWPVJXAXFXNWPCWKQXJWKVGZXLWNXMWOYEXKWMEXJWKVHVKXJWKEVIVLVMVNVOWAXFWP
      VPVQVRXBXIKXDQWJXDVGZWRXHYFWQXGLQYFWLXFWPWJXDWKVSWBVTWCWDWEWRKQWFVQWGWH
      $.

    isf32lem.e $e |- J = ( u e. om |-> ( iota_ v e. S ( v i^i S ) ~~ u ) ) $.
    isf32lem.f $e |- K = ( ( w e. S |-> ( ( F ` w ) \ ( F ` suc w ) ) ) o.
      J ) $.
    $( Lemma for ~ isfin3-2 .  Each K value is non-empty.  (Contributed by
       Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem6 $p |- ( ( ph /\ A e. om ) -> ( K ` A ) =/= (/) ) $=
      ( com cfv wcel wa csuc cdif c0 cv cmpt ccom fveq1i wceq wf1o wss cfn wpss
      wf crab ssrab2 eqsstri isf32lem5 fin23lem22 sylancr f1of syl fvco3 adantr
      wn sylan ffvelrn sylancom fveq2 suceq fveq2d difeq12d eqid cvv fvex ax-mp
      difexg fvmpt eqtrd syl5eq psseq12d elrab2 simprbi df-pss pssdifn0 eqnetrd
      wne sylib ) AGSUAZUBZGLTZGKTZITZWMUCZITZUDZUEWKWLGDHDUFZITZWRUCZITZUDZUGZ
      KUHZTZWQGLXDRUIWKXEWMXCTZWQASHKUOZWJXEXFUJASHKUKZXGAHSULZHUMUAVFZXHHCUFZU
      CZITZXKITZUNZCSUPSPXOCSUQURZABCHIJMNOPUSZKHFEQUTZVASHKVBZVCSHGXCKVDVGWKWM
      HUAZXFWQUJAWJXGXTWKXHXGWKXIXJXHXPAXJWJXQVEXRVAXSVCSHGKVHVIZDWMXBWQHXCWRWM
      UJZWSWNXAWPWRWMIVJYBWTWOIWRWMVKVLVMXCVNWNVOUAWQVOUAWMIVPWNWPVOVRVQVSVCVTW
      AWKWPWNULWPWNWHUBZWQUEWHWKWPWNUNZYCWKXTYDYAXTWMSUAYDXOYDCWMSHXKWMUJZXMWPX
      NWNYEXLWOIXKWMVKVLXKWMIVJWBPWCWDVCWPWNWEWIWPWNWFVCWG $.

    $( Lemma for ~ isfin3-2 .  Different K values are disjoint.  (Contributed
       by Stefan O'Rear, 5-Nov-2014.) $)
    isf32lem7 $p |- ( ( ( ph /\ A =/= B ) /\ ( A e. om /\ B e. om ) ) ->
        ( ( K ` A ) i^i ( K ` B ) ) = (/) ) $=
      ( com wne wa wcel cfv cin csuc cdif c0 cmpt ccom fveq1i wceq wf1o wss cfn
      cv wf wn wpss crab ssrab2 eqsstri isf32lem5 fin23lem22 sylancr f1of fvco3
      syl sylan ad2ant2r adantr simpl ffvelrn syl2an fveq2 fveq2d difeq12d eqid
      suceq fvex difexg ax-mp fvmpt eqtrd syl5eq ad2ant2rl simpr ineq12d simpll
      cvv simplr wf1 f1of1 f1fveq biimpd necon3d mpd sseldi isf32lem4 syl22anc
      wb ) AGHUAZUBZGTUCZHTUCZUBZUBZGMUDZHMUDZUEGLUDZJUDZXJUFZJUDZUGZHLUDZJUDZX
      OUFZJUDZUGZUEZUHXGXHXNXIXSXGXHGDIDUPZJUDZYAUFZJUDZUGZUIZLUJZUDZXNGMYGSUKX
      GYHXJYFUDZXNAXDYHYIULZXBXEATILUQZXDYJATILUMZYKAITUNIUOUCURYLICUPZUFJUDYMJ
      UDUSZCTUTTQYNCTVAVBZABCIJKNOPQVCLIFERVDVEZTILVFVHZTIGYFLVGVIVJXGXJIUCZYIX
      NULXCYKXDYRXFAYKXBYQVKZXDXEVLTIGLVMVNZDXJYEXNIYFYAXJULZYBXKYDXMYAXJJVOUUA
      YCXLJYAXJVSVPVQYFVRZXKWJUCXNWJUCXJJVTXKXMWJWAWBWCVHWDWEXGXIHYGUDZXSHMYGSU
      KXGUUCXOYFUDZXSAXEUUCUUDULZXBXDAYKXEUUEYQTIHYFLVGVIWFXGXOIUCZUUDXSULXCYKX
      EUUFXFYSXDXEWGTIHLVMVNZDXOYEXSIYFYAXOULZYBXPYDXRYAXOJVOUUHYCXQJYAXOVSVPVQ
      UUBXPWJUCXSWJUCXOJVTXPXRWJWAWBWCVHWDWEWHXGAXJXOUAZXJTUCXOTUCXTUHULAXBXFWI
      XGXBUUIAXBXFWKXGXJXOGHXGXJXOULZGHULZXCTILWLZXFUUJUUKXAAUULXBAYLUULYPTILWM
      VHVKTIGHLWNVIWOWPWQXGITXJYOYTWRXGITXOYOUUGWRABXJXOJKNOPWSWTWD $.

    $( Lemma for ~ isfin3-2 .  K sets are subsets of the base.  (Contributed by
       Stefan O'Rear, 6-Nov-2014.) $)
    isf32lem8 $p |- ( ( ph /\ A e. om ) -> ( K ` A ) C_ G ) $=
      ( com cfv wcel wa csuc cdif cv cmpt ccom fveq1i wf wceq wf1o wss cfn wpss
      crab ssrab2 eqsstri isf32lem5 fin23lem22 sylancr f1of syl fvco3 ffvelrnda
      sylan fveq2 suceq fveq2d difeq12d eqid cvv fvex difexg ax-mp fvmpt syl5eq
      wn eqtrd cpw adantr sseldi ffvelrnd elpwid ssdifssd eqsstrd ) AGSUAZUBZGL
      TZGKTZITZWIUCZITZUDZJWGWHGDHDUEZITZWNUCZITZUDZUFZKUGZTZWMGLWTRUHWGXAWIWST
      ZWMASHKUIZWFXAXBUJASHKUKZXCAHSULHUMUAVQXDHCUEZUCITXEITUNZCSUOSPXFCSUPUQZA
      BCHIJMNOPURKHFEQUSUTSHKVAVBZSHGWSKVCVEWGWIHUAXBWMUJASHGKXHVDZDWIWRWMHWSWN
      WIUJZWOWJWQWLWNWIIVFXJWPWKIWNWIVGVHVIWSVJWJVKUAWMVKUAWIIVLWJWLVKVMVNVOVBV
      RVPWGWJJWLWGWJJWGSJVSZWIIASXKIUIWFMVTWGHSWIXGXIWAWBWCWDWE $.

    isf32lem.g $e |- L = ( t e. G |->
      ( iota s ( s e. om /\ t e. ( K ` s ) ) ) ) $.
    $( Lemma for ~ isfin3-2 .  Construction of the onto function.  (Contributed
       by Stefan O'Rear, 5-Nov-2014.)  (Revised by Mario Carneiro,
       2-Oct-2015.) $)
    isf32lem9 $p |- ( ph -> L : G -onto-> om ) $=
      ( va vb com wf cv cfv wceq wrex wral wfo wcel wa cio weu cab ssab2 iotacl
      sseldi wn c0 iotanul peano1 syl6eqel pm2.61i a1i fmpti isf32lem6 n0 sylib
      wex wne isf32lem8 sselda anbi2d iotabidv iotaex fvmpt3i syl wi w3a simp1r
      eleq1 wal simpl1 simpr necomd simpl2 simpl3 isf32lem7 syl22anc disj1 syl6
      cin ex sp com23 3adant1r mpd necon4ad 3expia imp3a fveq2 anbi12d biimprcd
      eleq2d ancoms adantll impbid iota5 an32s eqtr2d jca eximdv df-rex syl6ibr
      ralrimiva dffo3 sylanbrc ) AJUDMUEZUBUFZUCUFZMUGZUHZUCJUIZUBUDUJJUDMUKXTA
      GJUDNUFZUDULZGUFZYFLUGZULZUMZNUNZMUAYLUDULZYHJULYKNUOZYMYNYKNUPUDYLYJNUDU
      QYKNURUSYNUTYLVAUDYKNVBVCVDVEVFVGVFAYEUBUDAYAUDULZUMZYBYALUGZULZUCVKZYEYP
      YQVAVLYSABCDEFYAHIJKLOPQRSTVHUCYQVIVJYPYSYBJULZYDUMZUCVKYEYPYRUUAUCYPYRUU
      AYPYRUMZYTYDYPYQJYBABCDEFYAHIJKLOPQRSTVMVNZUUBYCYGYBYIULZUMZNUNZYAUUBYTYC
      UUFUHUUCGYBYLUUFJMYHYBUHZYKUUENUUGYJUUDYGYHYBYIWCVOVPUAYKNVQVRVSAYRYOUUFY
      AUHAYRUMZUUENYAUDUUHYOUMZUUEYFYAUHZUUIYGUUDUUJUUHYOYGUUDUUJVTUUHYOYGWAZUU
      DYFYAUUKYRYFYAVLZUUDUTZVTZAYRYOYGWBAYOYGYRUUNVTYRAYOYGWAZUULYRUUMUUOUULYR
      UUMVTZUCWDZUUPUUOUULUUQUUOUULUMZYQYIWNVAUHZUUQUURAYAYFVLYOYGUUSAYOYGUULWE
      UURYFYAUUOUULWFWGAYOYGUULWHAYOYGUULWIABCDEFYAYFHIJKLOPQRSTWJWKUCYQYIWLVJW
      OUUPUCWPWMWQWRWSWTXAXBYRYOUUJUUEVTZAYOYRUUTUUJUUEYOYRUMUUJYGYOUUDYRYFYAUD
      WCUUJYIYQYBYFYALXCXFXDXEXGXHXIXJXKXLXMWOXNYDUCJXOXPWSXQUCUBJUDMXRXS $.

    $( Lemma for isfin3-2 .  Write in terms of weak dominance.  (Contributed by
       Stefan O'Rear, 6-Nov-2014.)  (Revised by Mario Carneiro,
       17-May-2015.) $)
    isf32lem10 $p |- ( ph -> ( G e. V -> om ~<_* G ) ) $=
      ( com wfo wcel cvv cwdom wbr isf32lem9 wf fof syl fex sylan fowdom expcom
      ex sylsyld ) AJUCMUDZJNUEZMUFUEZUCJUGUHZABCDEFGHIJKLMOPQRSTUAUBUIZAUTVAAJ
      UCMUJZUTVAAUSVDVCJUCMUKULJUCNMUMUNUQVAUSVBMUFUCJUOUPUR $.
  $}

  ${
    $d b c d e f g h k l F $.  $d a b c d f g h k l x G $.  $d f V $.
    $( Lemma for ~ isfin3-2 .  Remove hypotheses from ~ isf32lem10 .
       (Contributed by Stefan O'Rear, 17-May-2015.) $)
    isf32lem11 $p |- ( ( G e. V /\ ( F : om --> ~P G /\
        A. b e. om ( F ` suc b ) C_ ( F ` b ) /\ -. |^| ran F e. ran F ) ) ->
      om ~<_* G ) $=
      ( vc vd vh vg vf vk ve vl com cv csuc cfv wss wcel cmpt eqid cpw wral crn
      wf cint wn w3a cwdom wbr wpss crab cin cen crio cdif ccom cio simp1 suceq
      wa fveq2d fveq2 sseq12d cbvralv biimpi 3ad2ant2 simp3 psseq12d isf32lem10
      weq cbvrabv impcom ) MBUAAUDZDNZOZAPZVNAPZQZDMUBZAUCZUEVTRUFZUGZBCRMBUHUI
      WBEFGHIJKNZOZAPZWCAPZUJZKMUKZABIMHNWHULINUMUIHWHUNSZGWHGNZAPWJOAPUOSWIUPZ
      JBLNZMRJNWLWKPRUTLUQSZCLVMVSWAURVSVMENZOZAPZWNAPZQZEMUBZWAVSWSVRWRDEMDEVJ
      ZVPWPVQWQWTVOWOAVNWNUSVAVNWNAVBVCVDVEVFVMVSWAVGWGFNZOZAPZXAAPZUJKFMKFVJZW
      EXCWFXDXEWDXBAWCXAUSVAWCXAAVBVHVKWITWKTWMTVIVL $.

    isf32lem40.f $e |- F = { g | A. a e. ( ~P g ^m om )
      ( A. x e. om ( a ` suc x ) C_ ( a ` x ) -> |^| ran a e. ran a ) } $.
    $( Lemma for ~ isfin3-2 .  (Contributed by Stefan O'Rear, 6-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    isf32lem12 $p |- ( G e. V -> ( -. om ~<_* G -> G e. F ) ) $=
      ( vb vf wcel com cwdom wbr wn cv csuc cfv wral wi wa wss crn cint cmap co
      cpw wf elmapi isf32lem11 expcom 3expa impancom con1d exp31 com4t ralrimdv
      w3a syl isfin3ds sylibrd ) DEJZKDLMZNZHOZPIOZQVDVEQUAHKRZVEUBZUCVGJZSZIDU
      FZKUDUEZRDCJVAVCVIIVKVEVKJZVFVAVCVHVLKVJVEUGZVFVAVCVHSZSSVEVJKUHVMVFVAVNV
      MVFTZVATVHVBVOVHNZVAVBVMVFVPVAVBSVAVMVFVPUQVBVEDEHUIUJUKULUMUNURUOUPHDIBC
      EFAGUSUT $.
  $}

  $( One half of ~ isfin3-2 .  (Contributed by Mario Carneiro, 3-Jun-2015.) $)
  isfin32i $p |- ( A e. Fin3 -> -. om ~<_* A ) $=
    ( cfin3 wcel cpw cfin4 com wbr wn isfin3 cdom isfin4-2 ibi cvv csdm relwdom
    cwdom brrelexi canth2g sdomdom 3syl wdompwdom domtr syl2anc nsyl sylbi ) AB
    CADZECZFAPGZHAIUGFUFJGZUHUGUIHUFEKLUHFFDZJGZUJUFJGUIUHFMCFUJNGUKFAPOQFMRFUJ
    STFAUAFUJUFUBUCUDUE $.

  ${
    $d a b c f g x y A $.  $d a b f x y F $.  $d a b c x V $.  $d a b c x X $.
    $d x y G $.
    $( Lemma for ~ isfin3-3 .  (Contributed by Stefan O'Rear, 17-May-2015.) $)
    isf33lem $p |- Fin3 = { g | A. a e. ( ~P g ^m om )
      ( A. x e. om ( a ` suc x ) C_ ( a ` x ) -> |^| ran a e. ran a ) } $=
      ( vf vy vb cfin3 cv cfv wss com wral crn cint wcel wi cpw cmap co weq cab
      csuc cwdom wbr isfin32i fveq1 sseq12d ralbidv rneq inteqd eleq12d imbi12d
      cbvralv pweq oveq1d raleqdv syl5bb cbvabv isf32lem12 mpd abbii fin23lem41
      wn impbii eqriv ) DGAHZUBZCHZIZVFVHIZJZAKLZVHMZNZVMOZPZCBHZQZKRSZLZBUAZDH
      ZGOZWBWAOZWCKWBUCUDVCWDWBUEAEWAWBGFVTVGFHZIZVFWEIZJZAKLZWEMZNZWJOZPZFEHZQ
      ZKRSZLZBEVTWMFVSLZBETZWQVPWMCFVSCFTZVLWIVOWLWTVKWHAKWTVIWFVJWGVGVHWEUFVFV
      HWEUFUGUHWTVNWKVMWJWTVMWJVHWEUIZUJXAUKULUMZWSWMFVSWPWSVRWOKRVQWNUNUOUPUQU
      RUSUTAWBBWAFVTWRBXBVAVBVDVE $.

    $( Weakly Dedekind-infinite sets are exactly those which can be mapped onto
       ` om ` .  (Contributed by Stefan O'Rear, 6-Nov-2014.)  (Proof shortened
       by Mario Carneiro, 17-May-2015.) $)
    isfin3-2 $p |- ( A e. V -> ( A e. Fin3 <-> -. om ~<_* A ) ) $=
      ( vx vg va wcel cfin3 com cwdom wbr isfin32i isf33lem isf32lem12 impbid2
      wn ) ABFAGFHAIJOAKCDGABECDELMN $.

    $( Weakly Dedekind-infinite sets are exactly those with an ` om ` -indexed
       descending chain of subsets.  (Contributed by Stefan O'Rear,
       7-Nov-2014.) $)
    isfin3-3 $p |- ( A e. V -> ( A e. Fin3 <-> A. f e. ( ~P A ^m om )
      ( A. x e. om ( f ` suc x ) C_ ( f ` x ) -> |^| ran f e. ran f ) ) ) $=
      ( vg va vb cfin3 isf33lem isfin3ds ) ABCEHDFGGEFIJ $.

    $( Inference from ~ isfin3-3 .  (This is actually a bit stronger than
       ~ isfin3-3 because it does not assume ` F ` is a set and does not use
       the Axiom of Infinity either.)  (Contributed by Mario Carneiro,
       17-May-2015.) $)
    fin33i $p |- ( ( A e. Fin3 /\ F : om --> ~P A /\
      A. x e. om ( F ` suc x ) C_ ( F ` x ) ) -> |^| ran F e. ran F ) $=
      ( cfin3 wcel com cpw wf csuc cfv wss wral w3a crn cint cwdom wbr isfin32i
      cv wn 3ad2ant1 wi isf32lem11 3exp2 3imp mt3d ) BDEZFBGCHZASZICJUICJKAFLZM
      CNZOUKEZFBPQZUGUHUMTUJBRUAUGUHUJULTZUMUBUGUHUJUNUMCBDAUCUDUEUF $.
  $}

  ${
    $d a b c f g x y A $.  $d a b f y F $.  $d a b c x y V $.  $d a b c X $.
    $d y G $.
    $( Lemma for ~ compsscnv .  (Contributed by Mario Carneiro,
       17-May-2015.) $)
    compsscnvlem $p |- ( ( x e. ~P A /\ y = ( A \ x ) ) ->
      ( y e. ~P A /\ x = ( A \ y ) ) ) $=
      ( cv cpw wcel cdif wceq wa wss simpr difss syl6eqss vex elpw sylibr elpwi
      difeq2d adantr dfss4 sylib eqtr2d jca ) ADZCEZFZBDZCUDGZHZIZUGUEFZUDCUGGZ
      HUJUGCJUKUJUGUHCUFUIKZCUDLMUGCBNOPUJULCUHGZUDUJUGUHCUMRUJUDCJZUNUDHUFUOUI
      UDCQSUDCTUAUBUC $.

    compss.a $e |- F = ( x e. ~P A |-> ( A \ x ) ) $.
    $( Complementation on a power set lattice is an involution.  (Contributed
       by Mario Carneiro, 17-May-2015.) $)
    compsscnv $p |- `' F = F $=
      ( vy cv cpw wcel cdif wceq wa copab ccnv cnvopab cmpt difeq2 compsscnvlem
      cbvmptv df-mpt 3eqtr4i 3eqtri cnveqi impbii opabbii ) EFZBGZHAFZBUEIZJKZE
      ALZMUIAELZCMCUIEANCUJCAUFBUGIZOZEUFUHOUJDAEUFULUHUGUEBPREAUFUHSUAUBUMUGUF
      HUEULJKZAELCUKAEUFULSDUIUNAEUIUNEABQAEBQUCUDTT $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    isf34lem1 $p |- ( ( A e. V /\ X C_ A ) -> ( F ` X ) = ( A \ X ) ) $=
      ( va wcel wss wa cpw cdif cvv cfv wceq elpw2g biimpar cv difeq2 cmpt
      difexg adantr cbvmptv eqtri fvmptg syl2anc ) BDHZEBIZJEBKZHZBELZMHZECNUKO
      UGUJUHEBDPQUGULUHBEDUAUBGEBGRZLZUKUIMCUMEBSCAUIBARZLZTGUIUNTFAGUIUPUNUOUM
      BSUCUDUEUF $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    isf34lem2 $p |- ( A e. V -> F : ~P A --> ~P A ) $=
      ( wcel cpw cv cdif wss difss elpw2g mpbiri adantr fmptd ) BDFZABGZBAHZIZQ
      CPSQFZRQFPTSBJBRKSBDLMNEO $.

    $( Complementation is an antiautomorphism on power set lattices.
       (Contributed by Stefan O'Rear, 4-Nov-2014.)  (Proof shortened by Mario
       Carneiro, 17-May-2015.) $)
    compssiso $p |- ( A e. V -> F Isom [C.] , `' [C.] ( ~P A , ~P A ) ) $=
      ( va vb wcel cv crpss wbr cfv ccnv wb wral wfn cdif wpss wss wceq cpw cvv
      wf1o wiso difexg ralrimivw syl compsscnv fneq1i sylibr dff1o4 sylanbrc wa
      fnmpt elpwi ad2antll isf34lem1 ad2antrl psseq12d difss pssdifcom1 sylancl
      syldan dfss4 psseq1d 3bitrrd brrpss fvex 3bitr4g relrpss relbrcnv syl6bbr
      sylib vex ralrimivva df-isom ) BDHZBUAZVRCUCZFIZGIZJKZVTCLZWACLZJMZKZNZGV
      ROFVROVRVRJWECUDVQCVRPZCMZVRPZVSVQBAIZQZUBHZAVROWHVQWMAVRBWKDUEUFAVRWLCUB
      EUNUGZVQWHWJWNVRWICABCEUHUIUJVRVRCUKULVQWGFGVRVRVQVTVRHZWAVRHZUMZUMZWBWDW
      CJKZWFWRVTWARZWDWCRZWBWSWRXABWAQZBVTQZRZBXCQZWARZWTWRWDXBWCXCVQWQWABSZWDX
      BTWPXGVQWOWABUOUPZABCDWAEUQVCVQWQVTBSZWCXCTWOXIVQWPVTBUOURZABCDVTEUQVCUSW
      RXGXCBSXDXFNXHBVTUTWAXCBVAVBWRXEVTWAWRXIXEVTTXJVTBVDVMVEVFVTWAGVNVGWDWCVT
      CVHVGVIWCWDJVJVKVLVOFGVRVRJWECVPUL $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    isf34lem3 $p |- ( ( A e. V /\ X C_ ~P A ) -> ( F " ( F " X ) ) = X ) $=
      ( wcel cpw wss cima ccnv compsscnv imaeq1i wceq crpss wiso wf1o compssiso
      wa wf1 isof1o f1of1 3syl f1imacnv sylan syl5eqr ) BDGZEBHZIZSCCEJZJCKZUJJ
      ZEUKCUJABCFLMUGUHUHCTZUIULENUGUHUHOOKZCPUHUHCQUMABCDFRUHUHOUNCUAUHUHCUBUC
      UHUHECUDUEUF $.

    $( Express image under of the complementation isomorphism.  (Contributed by
       Stefan O'Rear, 5-Nov-2014.)  (Proof shortened by Mario Carneiro,
       17-May-2015.) $)
    compss $p |- ( F " G ) = { y e. ~P A | ( A \ y ) e. G } $=
      ( ccnv cima cv cdif wcel crab compsscnv imaeq1i cmpt difeq2 cbvmptv eqtri
      cpw mptpreima eqtr3i ) DGZEHDEHCBIZJZEKBCSZLUBDEACDFMNBUEUDEDDAUECAIZJZOB
      UEUDOFABUEUGUDUFUCCPQRTUA $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    isf34lem4 $p |- ( ( A e. V /\ ( X C_ ~P A /\ X =/= (/) ) ) ->
        ( F ` U. X ) = |^| ( F " X ) ) $=
      ( va vb vc wcel wss wa cv cdif wceq wn wi ad2antrr simpr ex cpw cuni crab
      c0 wne cfv cint cima sspwuni isf34lem1 sylan2b adantrr wral simprl eldifd
      simplrr elunii syl2anc mt3d expr ralrimiva n0 sselda elpwid dfss4 eqeltrd
      wex sylib difss elpw2g mpbiri difeq2 eleq1d eleq2 imbi12d syl mpid eldifi
      rspcv syl6 exlimdv syl5bi impr eluni adantlrr adantrl elndif ad2antrl jca
      wrex annim notbid rspcev rexnal con2d jcad impbid eldif vex 3bitr4g eqrdv
      elintrab eqtrd compss inteqi syl6eqr ) BDJZEBUAZKZEUDUEZLZLZEUBZCUFZBGMZN
      ZEJZGXHUCZUGZCEUHZUGXLXNBXMNZXSXGXIXNYAOZXJXIXGXMBKYBEBUIABCDXMFUJUKULXLH
      YAXSXLHMZBJZYCXMJZPZLZXQYCXOJZQZGXHUMZYCYAJYCXSJXLYGYJXLYGYJXLYGLZYIGXHYK
      XOXHJZXQYHYKYLXQLZLZYHYEXLYDYFYMUPYNYHPZYEYNYOLZYCXPJXQYEYPYCBXOYKYDYMYOX
      LYDYFUNRYNYOSUOYKYLXQYOUPYCXPEUQURTUSUTVATXLYJYDYFXGXIXJYJYDQZXJIMZEJZIVG
      XGXILZYQIEVBYTYSYQIYTYSYQYTYSLZYJYCBYRNZJZYDUUAYJBUUBNZEJZUUCUUAUUDYREUUA
      YRBKUUDYROUUAYRBYTEXHYRXGXISVCVDYRBVEVHYTYSSVFZUUAUUBXHJZYJUUEUUCQZQXGUUG
      XIYSXGUUGUUBBKBYRVIUUBBDVJVKZRYIUUHGUUBXHXOUUBOZXQUUEYHUUCUUJXPUUDEXOUUBB
      VLVMXOUUBYCVNVOZVSVPVQYCBYRVRVTTWAWBWCXLYEYJYEYCYRJZYSLZIVGXLYJPZIYCEWDXL
      UUMUUNIXLUUMUUNXLUUMLZYIPZGXHWJZUUNUUOUUGUUHPZUUQXGUUGXKUUMUUIRUUOUUEUUCP
      ZLUURUUOUUEUUSXLYSUUEUULXGXIYSUUEXJUUFWEWFUULUUSXLYSYCYRBWGWHWIUUEUUCWKVH
      UUPUURGUUBXHUUJYIUUHUUKWLWMURYIGXHWNVHTWAWBWOWPWQYCBXMWRXQGYCXHHWSXBWTXAX
      CXTXRAGBCEFXDXEXF $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    isf34lem5 $p |- ( ( A e. V /\ ( X C_ ~P A /\ X =/= (/) ) ) ->
        ( F ` |^| X ) = U. ( F " X ) ) $=
      ( wcel wss c0 wne wa cima cfv cint wceq adantr syl sylib ccnv crpss dfss1
      cpw cuni crn imassrn isf34lem2 frn syl5ss cdm cin simprl sseqtr4d eqnetrd
      wf fdm simprr imadisj necon3bii sylibr isf34lem4 syldan isf34lem3 adantrr
      jca inteqd eqtrd fveq2d compsscnv fveq1i wf1o compssiso isof1o sspwuni wb
      wiso elpw2g mpbird f1ocnvfv1 syl2anc syl5eqr eqtr3d ) BDGZEBUBZHZEIJZKZKZ
      CELZUCZCMZCMZENZCMWIWGWJWLCWGWJCWHLZNZWLWBWFWHWCHZWHIJZKWJWNOWGWOWPWGWHCU
      DZWCCEUEWGWCWCCUNZWQWCHWBWRWFABCDFUFPZWCWCCUGQUHZWGCUIZEUJZIJWPWGXBEIWGEX
      AHXBEOWGEWCXAWBWDWEUKWGWRXAWCOWSWCWCCUOQULEXAUARWBWDWEUPUMWHIXBICEUQURUSV
      DABCDWHFUTVAWGWMEWBWDWMEOWEABCDEFVBVCVEVFVGWGWKWJCSZMZWIWJXCCABCFVHVIWGWC
      WCCVJZWIWCGZXDWIOWBXEWFWBWCWCTTSZCVOXEABCDFVKWCWCTXGCVLQPWGXFWIBHZWGWOXHW
      TWHBVMRWBXFXHVNWFWIBDVPPVQWCWCWICVRVSVTWA $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    isf34lem7 $p |- ( ( A e. Fin3 /\ G : om --> ~P A /\
      A. y e. om ( G ` y ) C_ ( G ` suc y ) ) -> U. ran G e. ran G ) $=
      ( cfin3 wcel com wf cfv wss crn 3adant3 syl wceq syl2anc eqtrd c0 wne cpw
      cv csuc wral w3a cima cint wfn isf34lem2 adantr ffn imassrn wa frn syl5ss
      cuni ccom simp1 sylan cdif sscon simpr peano2 fvco3 syl2an simpll ffvelrn
      fco elpwid isf34lem1 adantll sseq12d syl5ibr ralimdva 3impia fin33i rnco2
      syl3anc inteqi 3eltr3g fnfvima wb simpl cdm cin incom adantl fdm sseqtr4d
      df-ss sylib syl5eq peano1 ne0i eqnetrd dm0rn0 necon3bii imadisj isf34lem5
      mp1i sylibr syl12anc isf34lem3 unieqd eleq12d mpbid ) CGHZICUAZEJZBUBZEKZ
      XJUCZEKZLZBIUDZUEZDEMZUFZUGZDKZDXRUFZHZXQUPZXQHZXPDXHUHZXRXHLZXSXRHYBXPXH
      XHDJZYEXGXIYGXOXGYGXIACDGFUIZUJZNXHXHDUKOXPXRDMZXHDXQULZXGXIYJXHLZXOXGXIU
      MZYGYLYIXHXHDUNOZNUOXPDEUQZMZUGZYPXSXRXPXGIXHYOJZXLYOKZXJYOKZLZBIUDZYQYPH
      XGXIXOURXGXIYRXOXGYGXIYRYHIXHXHDEVHUSNXGXIXOUUBYMXNUUABIXNUUAYMXJIHZUMZCX
      MUTZCXKUTZLXKXMCVAUUDYSUUEYTUUFUUDYSXMDKZUUEYMXIXLIHZYSUUGPUUCXGXIVBZXJVC
      ZIXHXLDEVDVEUUDXGXMCLUUGUUEPXGXIUUCVFZUUDXMCYMXIUUHXMXHHUUCUUIUUJIXHXLEVG
      VEVIACDGXMFVJQRUUDYTXKDKZUUFXIUUCYTUULPXGIXHXJDEVDVKUUDXGXKCLUULUUFPUUKUU
      DXKCXIUUCXKXHHXGIXHXJEVGVKVIACDGXKFVJQRVLVMVNVOBCYOVPVRYPXRDEVQZVSUUMVTXH
      XRDXSWAVRXGXIYBYDWBXOYMXTYCYAXQYMXTYAUPZYCYMXGYFXRSTZXTUUNPXGXIWCZYMXRYJX
      HYKYNUOYMDWDZXQWEZSTUUOYMUURXQSYMUURXQUUQWEZXQUUQXQWFYMXQUUQLUUSXQPYMXQXH
      UUQXIXQXHLZXGIXHEUNWGZYMYGUUQXHPYIXHXHDWHOWIXQUUQWJWKWLYMEWDZSTXQSTYMUVBI
      SXIUVBIPXGIXHEWHWGSIHISTYMWMISWNWTWOUVBSXQSEWPWQWKWOXRSUURSDXQWRWQXAACDGX
      RFWSXBYMYAXQYMXGUUTYAXQPUUPUVAACDGXQFXCQZXDRUVCXENXF $.

    $( Lemma for ~ isfin3-4 .  (Contributed by Stefan O'Rear, 7-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    isf34lem6 $p |- ( A e. V -> ( A e. Fin3 <-> A. f e. ( ~P A ^m om )
      ( A. y e. om ( f ` y ) C_ ( f ` suc y ) -> U. ran f e. ran f ) ) ) $=
      ( vg wcel cfv wss com wral crn cvv syl syl2anc wceq c0 wne cfin3 csuc cpw
      cv cuni wi cmap co wf elmapi isf34lem7 3expia ralrimiva cint ccom elmapex
      sylan2 cima simpld pwexb sylibr isf34lem2 fco wa wb elmapg mpbird sseq12d
      fveq1 ralbidv rneq rnco2 syl6eq unieqd eleq12d imbi12d rspccv syl5 adantr
      cdif sscon ffvelrnda elpwid isf34lem1 peano2 ffvelrn syl2an syl5ibr fvco3
      sylan sylibrd ralimdva wfn ffn imassrn frn fnfvima cdm cin incom sseqtr4d
      syl5ss fdm df-ss syl5eq peano1 ne0i mp1i eqnetrd dm0rn0 necon3bii imadisj
      sylib isf34lem4 syl12anc isf34lem3 inteqd eqtrd imim12d ralrimiv isfin3-3
      sylibd sylcom impbid2 ) CFIZCUAIZBUDZDUDZJZYGUBZYHJZKZBLMZYHNZUEZYNIZUFZD
      CUCZLUGUHZMZYFYQDYSYHYSIYFLYRYHUIZYQYHYRLUJYFUUAYMYPABCEYHGUKULUQUMYTYFYE
      YJHUDZJZYGUUBJZKZBLMZUUBNZUNZUUGIZUFZHYSMYTUUJHYSYTUUBYSIZYGEUUBUOZJZYJUU
      LJZKZBLMZEUUGURZUEZUUQIZUFZUUJUUKUULYSIZYTUUTUUKUVALYRUULUIZUUKYRYREUIZLY
      RUUBUIZUVBUUKCOIZUVCUUKYROIZUVEUUKUVFLOIZUUBYRLUPZUSCUTVAZACEOGVBPZUUBYRL
      UJZLYRYREUUBVCQUUKUVFUVGVDUVAUVBVEUVHYRLUULOOVFPVGYQUUTDUULYSYHUULRZYMUUP
      YPUUSUVLYLUUOBLUVLYIUUMYKUUNYGYHUULVIYJYHUULVIVHVJUVLYOUURYNUUQUVLYNUUQUV
      LYNUULNUUQYHUULVKEUUBVLVMZVNUVMVOVPVQVRUUKUUFUUPUUSUUIUUKUUEUUOBLUUKYGLIZ
      VDZUUEUUDEJZUUCEJZKZUUOUUEUVRUVOCUUDVTZCUUCVTZKUUCUUDCWAUVOUVPUVSUVQUVTUV
      OUVEUUDCKUVPUVSRUUKUVEUVNUVIVSZUVOUUDCUUKLYRYGUUBUVKWBWCACEOUUDGWDQUVOUVE
      UUCCKUVQUVTRUWAUVOUUCCUUKUVDYJLIZUUCYRIUVNUVKYGWEZLYRYJUUBWFWGWCACEOUUCGW
      DQVHWHUVOUUMUVPUUNUVQUUKUVDUVNUUMUVPRUVKLYRYGEUUBWIWJUUKUVDUWBUUNUVQRUVNU
      VKUWCLYRYJEUUBWIWGVHWKWLUUKUUSUUREJZEUUQURZIZUUIUUKEYRWMZUUQYRKZUUSUWFUFU
      UKUVCUWGUVJYRYREWNPUUKUUQENZYREUUGWOUUKUVCUWIYRKUVJYRYREWPPXBZUWGUWHUUSUW
      FYRUUQEUURWQULQUUKUWDUUHUWEUUGUUKUWDUWEUNZUUHUUKUVEUWHUUQSTZUWDUWKRUVIUWJ
      UUKEWRZUUGWSZSTUWLUUKUWNUUGSUUKUWNUUGUWMWSZUUGUWMUUGWTUUKUUGUWMKUWOUUGRUU
      KUUGYRUWMUUKUVDUUGYRKZUVKLYRUUBWPPZUUKUVCUWMYRRUVJYRYREXCPXAUUGUWMXDXMXEU
      UKUUBWRZSTUUGSTUUKUWRLSUUKUVDUWRLRUVKLYRUUBXCPSLILSTUUKXFLSXGXHXIUWRSUUGS
      UUBXJXKXMXIUUQSUWNSEUUGXLXKVAACEOUUQGXNXOUUKUWEUUGUUKUVEUWPUWEUUGRUVIUWQA
      CEOUUGGXPQZXQXRUWSVOYBXSYCXTBCHFYAWHYD $.
  $}

  ${
    $d f x y A $.  $d x G $.  $d x y V $.
    $( Inference from ~ isfin3-4 .  (Contributed by Mario Carneiro,
       17-May-2015.) $)
    fin34i $p |- ( ( A e. Fin3 /\ G : om --> ~P A /\
      A. x e. om ( G ` x ) C_ ( G ` suc x ) ) -> U. ran G e. ran G ) $=
      ( vy cpw cv cdif cmpt eqid isf34lem7 ) DABDBEBDFGHZCKIJ $.

    $( Weakly Dedekind-infinite sets are exactly those with an ` om ` -indexed
       ascending chain of subsets.  (Contributed by Stefan O'Rear,
       7-Nov-2014.)  (Proof shortened by Mario Carneiro, 17-May-2015.) $)
    isfin3-4 $p |- ( A e. V -> ( A e. Fin3 <-> A. f e. ( ~P A ^m om )
      ( A. x e. om ( f ` x ) C_ ( f ` suc x ) -> U. ran f e. ran f ) ) ) $=
      ( vy cpw cv cdif cmpt eqid isf34lem6 ) EABCEBFBEGHIZDLJK $.
  $}

  ${
    $d a b c d f g x y A $.  $d f x B $.  $d x V $.
    $( Every I-finite set is Ia-finite.  (Contributed by Stefan O'Rear,
       30-Oct-2014.)  (Revised by Mario Carneiro, 17-May-2015.) $)
    fin11a $p |- ( A e. Fin -> A e. Fin1a ) $=
      ( vx cfn wcel cfin1a cv cdif wo cpw wral wa wss elpwi ssfi orcd ralrimiva
      sylan2 isfin1a mpbird ) ACDZAEDBFZCDZAUAGCDZHZBAIZJTUDBUETUAUEDZKUBUCUFTU
      AALUBUAAMAUANQOPBACRS $.

    $( Ia-finiteness is a cardinal property.  (Contributed by Mario Carneiro,
       18-May-2015.) $)
    enfin1ai $p |- ( A ~~ B -> ( A e. Fin1a -> B e. Fin1a ) ) $=
      ( vf vx cen wbr cv cfin1a wcel wa cfn cdif wo wss ad2antrr syl wb cvv vex
      cima wf1o wex ensym bren sylib cpw wral elpwi simplr crn imassrn f1of frn
      wi wf syl5ss fin1ai syl2anc wf1 f1of1 a1i f1imaeng syl3anc enfi ccnv wfun
      simpr wceq df-f1 simprbi imadif 3syl wfo f1ofo foima difeq1d eqtrd difssd
      adantr dmfex sylancr difexg orbi12d mpbid sylan2 ralrimiva isfin1a mpbird
      eqbrtrrd ex exlimiv ) ABEFZBACGZUAZCUBZAHIZBHIZUNZWLBAEFWOABUCBACUDUEWNWR
      CWNWPWQWNWPJZWQDGZKIZBWTLZKIZMZDBUFZUGZWSXDDXEWTXEIWSWTBNZXDWTBUHWSXGJZWM
      WTTZKIZAXILZKIZMZXDXHWPXIANXMWNWPXGUIXHXIWMUJZAWMWTUKXHBAWMUOZXNANWNXOWPX
      GBAWMULZOBAWMUMPUPAXIUQURXHXJXAXLXCXHXIWTEFZXJXAQXHBAWMUSZXGWTRIZXQWNXRWP
      XGBAWMUTOZWSXGVGXSXHDSVABAWTWMRVBVCXIWTVDPXHXKXBEFXLXCQXHWMXBTZXKXBEXHYAW
      MBTZXILZXKXHXRWMVEVFZYAYCVHXTXRXOYDBAWMVIVJBWTWMVKVLXHYBAXIWNYBAVHZWPXGWN
      BAWMVMYEBAWMVNBAWMVOPOVPVQXHXRXBBNXBRIZYAXBEFXTXHBWTVRXHBRIZYFWSYGXGWSWMR
      IXOYGCSWNXOWPXPVSBARWMVTWAZVSBWTRWBPBAXBWMRVBVCWIXKXBVDPWCWDWEWFWSYGWQXFQ
      YHDBRWGPWHWJWKP $.

    $( A set is finite in the usual sense iff the power set of its power set is
       Dedekind finite.  (Contributed by Stefan O'Rear, 3-Nov-2014.)  (Revised
       by Mario Carneiro, 17-May-2015.) $)
    isfin1-2 $p |- ( A e. Fin <-> ~P ~P A e. Fin4 ) $=
      ( cfn wcel cvv cpw cfin4 elex pwexb bitri sylibr com cdom wbr ominf domfi
      wn pwfi expcom syl5bi mtoi fineqvlem ex impbid2 con2bid wb isfin4-2 sylbi
      bitr4d pm5.21nii ) ABCZADCZAEZEZFCZABGUNUMDCZUKUMFGUKULDCUOAHULHIZJUKUJKU
      MLMZPZUNUKUQUJUKUQUJPZUQUJKBCZNUJUMBCZUQUTUJULBCVAAQULQIVAUQUTUMKORSTUKUS
      UQADUAUBUCUDUKUOUNURUEUPUMDUFUGUHUI $.

    $( A set is I-finite iff every system of subsets contains a maximal
       subset.  Definition I of [Levy58] p. 2.  (Contributed by Stefan O'Rear,
       4-Nov-2014.)  (Proof shortened by Mario Carneiro, 17-May-2015.) $)
    isfin1-3 $p |- ( A e. V -> ( A e. Fin <-> `' [C.] Fr ~P A ) ) $=
      ( vc vb vd wcel cfn crpss wpo sylancr cv wbr wn cin wrex cvv wss wa elin
      c0 cpw ccnv wfr porpss cnvpo mpbi pwfi biimpi frfi wral inss2 pwexg ssexg
      wne 0fin 0elpw mpbir2an ax-mp fri mpanr12 sylan inss1 simpl sseldi ralnex
      ne0i csn cun sseli adantr snfi unfi sylancl simprbi elpwid snssi ad2antrl
      ex unssd vex snex unex elpw sylibr sylanbrc wpss wceq disjsn biimpri snnz
      disjpss ad2antll brcnv brrpss bitri breq1 rspcev syl2anc expr con1d ssrdv
      syl5bi impancom ssfi rexlimiva syl6 impbid2 ) ABFZAGFZAUAZHUBZUCZXIXJXKIZ
      XJGFZXLXJHIXMXJUDXJHUEUFXIXNAUGUHXJXKUIJXHXLCKZDKZXKLZMCGXJNZUJZDXROZXIXH
      XLXTXHXRPFZXLXTXHXRXJQZXJPFYAGXJUKZABULXRXJPUMJYAXLRYBXRTUNZXTYCTXRFZYDYE
      TGFTXJFUOAUPTGXJSUQXRTVFURDCXJXRPXKUSUTVAVRXSXIDXRXPXRFZXSRZXPGFZAXPQXIYG
      XRGXPGXJVBZYFXSVCVDYGEAXPYFEKZAFZXSYJXPFZXSXQCXROZMYFYKRZYLXQCXRVEYNYLYMY
      FYKYLMZYMYFYKYORZRZXPYJVGZVHZXRFZYSXPXKLZYMYQYSGFZYSXJFZYTYQYHYRGFUUBYFYH
      YPXRGXPYIVIVJYJVKXPYRVLVMYQYSAQUUCYQXPYRAYFXPAQYPYFXPAYFYHXPXJFXPGXJSVNVO
      VJYKYRAQYFYOYJAVPVQVSYSAXPYRDVTZYJWAWBZWCWDYSGXJSWEYQXPYSWFZUUAYOUUFYFYKY
      OXPYRNTWGZYRTUNUUFUUGYOXPYJWHWIYJEVTWJXPYRWKVMWLUUAXPYSHLUUFYSXPHUUEUUDWM
      XPYSUUEWNWOWDXQUUACYSXRXOYSXPXKWPWQWRWSWTXBXCXAXPAXDWRXEXFXG $.

    $( A set is I-finite iff every system of subsets contains a minimal
       subset.  (Contributed by Stefan O'Rear, 4-Nov-2014.)  (Revised by Mario
       Carneiro, 17-May-2015.) $)
    isfin1-4 $p |- ( A e. V -> ( A e. Fin <-> [C.] Fr ~P A ) ) $=
      ( vx wcel cfn cpw crpss ccnv isfin1-3 cv cdif cmpt wiso wb eqid compssiso
      wfr isofr syl bitr4d ) ABDZAEDAFZGHZQZUBGQZABIUAUBUBGUCCUBACJKLZMUEUDNCAU
      FBUFOPUBUBGUCUFRST $.

    $( Compact quantifier-free version of the standard definition ~ df-fin .
       (Contributed by Stefan O'Rear, 6-Jan-2015.) $)
    dffin1-5 $p |- Fin = ( ~~ " om ) $=
      ( vx vy cen wbr com wrex cab cfn cima ensymb rexbii df-fin dfima2 3eqtr4i
      cv abbii ) AOZBOZCDZBEFZAGRQCDZBEFZAGHCEITUBASUABEQRJKPABLBACEMN $.

    $( Every II-finite set (every chain of subsets has a maximal element) is
       III-finite (has no denumerable collection of subsets).  The proof here
       is the only one I could find, from
       ~ http://matwbn.icm.edu.pl/ksiazki/fm/fm6/fm619.pdf p.94 (writeup by
       Tarski, credited to Kuratowski).  Translated into English and modern
       notation, the proof proceeds as follows (variables renamed for
       uniqueness):

       Suppose for a contradiction that ` A ` is a set which is II-finite but
       not III-finite.

       For any countable sequence of distinct subsets ` T ` of ` A ` , we can
       form a decreasing sequence of non-empty subsets ` ( U `` T ) ` by taking
       finite intersections of initial segments of ` T ` while skipping over
       any element of ` T ` which would cause the intersection to be empty.

       By II-finiteness (as ~ fin2i2 ) this sequence contains its intersection,
       call it ` Y ` ; since by induction every subset in the sequence ` U ` is
       non-empty, the intersection must be non-empty.

       Suppose that an element ` X ` of ` T ` has non-empty intersection with
       ` Y ` .  Thus, said element has a non-empty intersection with the
       corresponding element of ` U ` , therefore it was used in the
       construction of ` U ` and all further elements of ` U ` are subsets of
       ` X ` , thus ` X ` contains the ` Y ` .  That is, all elements of ` X `
       either contain ` Y ` or are disjoint from it.

       Since there are only two cases, there must exist an infinite subset of
       ` T ` which uniformly either contain ` Y ` or are disjoint from it.  In
       the former case we can create an infinite set by subtracting ` Y ` from
       each element.  In either case, call the result ` Z ` ; this is an
       infinite set of subsets of ` A ` , each of which is disjoint from ` Y `
       and contained in the union of ` T ` ; the union of ` Z ` is strictly
       contained in the union of ` T ` , because only the latter is a superset
       of the non-empty set ` Y ` .

       The preceeding four steps may be iterated a countable number of times
       starting from the assumed denumerable set of subsets to produce a
       denumerable sequence ` B ` of the ` T ` sets from each stage.  Great
       caution is required to avoid ~ ax-dc here; in particular an effective
       version of the pigeonhole principle (for aleph-null pigeons and 2 holes)
       is required.  Since a denumerable set of subsets is assumed to exist, we
       can conclude ` om e. _V ` without the axiom.

       This ` B ` sequence is strictly decreasing, thus it has no minimum,
       contradicting the first assumption.  (Contributed by Stefan O'Rear,
       2-Nov-2014.)  (Proof shortened by Mario Carneiro, 17-May-2015.) $)
    fin23 $p |- ( A e. Fin2 -> A e. Fin3 ) $=
      ( vx vg va cfin3 isf33lem fin23lem40 ) BACEDBCDFG $.

    $( Every III-finite set is IV-finite.  (Contributed by Stefan O'Rear,
       30-Oct-2014.) $)
    fin34 $p |- ( A e. Fin3 -> A e. Fin4 ) $=
      ( cfin3 wcel cfin4 com cdom wbr wn cpw isfin3 isfin4-2 ibi csdm brrelex2i
      cvv reldom canth2g syl domsdomtr mpdan sdomdom nsyl sylbi mpbird ) ABCZAD
      CEAFGZHZUEAIZDCZUGAJUIEUHFGZUFUIUJHUHDKLUFEUHMGZUJUFAUHMGZUKUFAOCULEAFPNA
      OQREAUHSTEUHUARUBUCABKUD $.

    $( Alternate definition of V-finite which emphasizes the idempotent
       behavior of V-infinite sets.  (Contributed by Stefan O'Rear,
       30-Oct-2014.)  (Revised by Mario Carneiro, 17-May-2015.) $)
    isfin5-2 $p |- ( A e. V -> ( A e. Fin5 <-> -.
      ( A =/= (/) /\ A ~~ ( A +c A ) ) ) ) $=
      ( wcel c0 wceq ccda co csdm wbr wo wne wn cen cfin5 wa wb nne bicomi cdom
      a1i cdadom3 anidms brsdom baib syl orbi12d isfin5 ianor 3bitr4g ) ABCZADE
      ZAAAFGZHIZJADKZLZAULMIZLZJANCUNUPOLUJUKUOUMUQUKUOPUJUOUKADQRTUJAULSIZUMUQ
      PUJURAABBUAUBUMURUQAULUCUDUEUFAUGUNUPUHUI $.

    $( Every IV-finite set is V-finite: if we can pack two copies of the set
       into itself, we can certainly leave space.  (Contributed by Stefan
       O'Rear, 30-Oct-2014.)  (Proof shortened by Mario Carneiro,
       18-May-2015.) $)
    fin45 $p |- ( A e. Fin4 -> A e. Fin5 ) $=
      ( cfin4 wcel cfin5 c0 wne ccda co cen wbr wa c1o csdm cdom cvv adantl syl
      wn wb mpbird isfin4-3 simpl relen brrelexi 0sdomg 0sdom1dom sylib cdadom2
      domen2 domnsym con2i sylbi isfin5-2 ) ABCZADCAEFZAAAGHZIJZKZRZUNAALGHZMJZ
      USAUAURVAURUTANJZVARURVBUTUPNJZURLANJZVCUREAMJZVDURVEUOUOUQUBURAOCZVEUOSU
      QVFUOAUPIUCUDPAOUEQTAUFUGLAAUHQUQVBVCSUOAUPUTUIPTUTAUJQUKULABUMT $.

    $( Every V-finite set is VI-finite because multiplication dominates
       addition for cardinals.  (Contributed by Stefan O'Rear, 29-Oct-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    fin56 $p |- ( A e. Fin5 -> A e. Fin6 ) $=
      ( c0 wceq ccda co csdm wbr wo c2o cxp cfin5 wcel c1o cen cdom cfn cvv com
      cfin6 con0 orc sdom2en01 sylibr orcd wn wb cin onfin2 eqsstri 2onn sselii
      inss2 relsdom brrelexi fidomtri sylancr wa xp2cda adantr xpdom2g eqbrtrrd
      syl sylan sdomdomtr syldan ex sylbird orrd jaoi isfin5 isfin6 3imtr4i ) A
      BCZAAADEZFGZHAIFGZAAAJZFGZHZAKLASLVMVSVOVMVPVRVMVMAMNGZHVPVMVTUAAUBUCUDVO
      VPVRVOVPUEZIAOGZVRVOIPLAQLZWBWAUFRPIRTPUGPUHTPULUIUJUKAVNFUMUNZIAQUOUPVOW
      BVRVOWBVNVQOGVRVOWBUQAIJZVNVQOVOWEVNCZWBVOWCWFWDAQURVBUSVOWCWBWEVQOGWDIAA
      QUTVCVAAVNVQVDVEVFVGVHVIAVJAVKVL $.

    $( Every I-finite set is VII-finite.  (Contributed by Mario Carneiro,
       17-May-2015.) $)
    fin17 $p |- ( A e. Fin -> A e. Fin7 ) $=
      ( vb cfn wcel cfin7 cv cen wbr con0 com cdif wrex wn wa wi enfi sylan9bbr
      eldif onfin biimpd con3d impancom sylbi rexlimiv con2i isfin7 mpbird ) AC
      DZAEDABFZGHZBIJKZLZMULUHUJUHMZBUKUIUKDUIIDZUIJDZMZNUJUMOUIIJRUNUJUPUMUNUJ
      NZUHUOUQUHUOUJUHUICDUNUOAUIPUISQTUAUBUCUDUEBACUFUG $.

    $( Every VI-finite set is VII-finite.  (Contributed by Stefan O'Rear,
       29-Oct-2014.)  (Revised by Mario Carneiro, 17-May-2015.) $)
    fin67 $p |- ( A e. Fin6 -> A e. Fin7 ) $=
      ( vb wcel c2o csdm wbr cfn cdom com wss sylancr syl cen con0 wn ensym cvv
      wa word wb cfin6 cxp wo cfin7 isfin6 2onn ssid ssnnfi mp2an sdomdom domfi
      fin17 cv cdif wrex sdomnen cdm eldifi isnumi syl2an vex eldif ordom eloni
      ccrd ordtri1 biimpar sylbi ssdomg domen2 syl5ibr impcom infxpidm2 syl2anc
      mpsyl rexlimiva nsyl relsdom brrelexi isfin7 mpbird jaoi ) AUACADEFZAAAUB
      ZEFZUCAUDCZAUEWCWFWEWCAGCZWFWCDGCZADHFWGDICDDJWHUFDUGDDUHUIADUJDAUKKAULLW
      EWFABUMZMFZBNIUNZUOZOZWEAWDMFZWLAWDUPWJWNBWKWIWKCZWJRZWDAMFZWNWPAVEUQCZIA
      HFZWQWOWINCZWIAMFWRWJWINIURAWIPWIAUSUTWJWOWSWOWSWJIWIHFZWIQCWOIWIJZXABVAW
      OWTWIICOZRXBWINIVBWTXBXCWTISWISXBXCTVCWIVDIWIVFKVGVHIWIQVIVOAWIIVJVKVLAVM
      VNWDAPLVPVQWEAQCWFWMTAWDEVRVSBAQVTLWAWBVH $.
  $}

  ${
    $d x A $.
    $( A set is VII-finite iff it is non-well-orderable or finite.
       (Contributed by Mario Carneiro, 17-May-2015.) $)
    isfin7-2 $p |- ( A e. V -> ( A e. Fin7 <->
      ( A e. dom card -> A e. Fin ) ) ) $=
      ( vx wcel cfin7 ccrd cdm cfn wi cv cen wbr con0 cdif wrex wn isfin7 ensym
      com wa ibi isnum2 simprl enfi onfin sylan9bbr biimprd con3d impcom eldifd
      simprr sylanr2 ex reximdv2 com12 sylbi con1d syl5com eldifi isnumi syl2an
      jca rexlimiva con3i syl5ibr fin17 a1i jad impbid2 ) ABDZAEDZAFGDZAHDZIVKA
      CJZKLZCMSNZOZPZVLVMVKVRCAEQUAVLVMVQVLVNAKLZCMOZVMPZVQICAUBWAVTVQWAVSVOCMV
      PWAVNMDZVSTVNVPDZVOTZVSWAWBVOWDVNARWAWBVOTZTZWCVOWFVNMSWAWBVOUCWEWAVNSDZP
      WEWGVMWEVMWGVOVMVNHDWBWGAVNUDVNUEUFUGUHUIUJWAWBVOUKVBULUMUNUOUPUQURVJVLVM
      VKVLPVKVJVRVQVLVOVLCVPWCWBVSVLVOVNMSUSAVNRVNAUTVAVCVDCABQVEVMVKIVJAVFVGVH
      VI $.
  $}

  ${
    $( A well-orderable set is VII-finite iff it is I-finite.  Thus, even
       without choice, on the class of well-orderable sets all eight
       definitions of finite set coincide.  (Contributed by Mario Carneiro,
       18-May-2015.) $)
    fin71num $p |- ( A e. dom card -> ( A e. Fin7 <-> A e. Fin ) ) $=
      ( ccrd cdm wcel cfin7 cfn wi isfin7-2 biimt bitr4d ) ABCZDZAEDLAFDZGMAKHL
      MIJ $.
  $}

  $( Class form of ~ isfin7-2 .  (Contributed by Mario Carneiro,
     17-May-2015.) $)
  dffin7-2 $p |- Fin7 = ( Fin u. ( _V \ dom card ) ) $=
    ( vx cfin7 cfn cvv ccrd cdm cdif cun cv wcel wi wn wo wb vex isfin7-2 ax-mp
    imor elun orcom eldif mpbiran orbi1i 3bitri 3bitr4i eqriv ) ABCDEFZGZHZAIZU
    GJZUJCJZKZUKLZULMZUJBJZUJUIJZUKULRUJDJZUPUMNAOZUJDPQUQULUJUHJZMUTULMUOUJCUH
    SULUTTUTUNULUTURUNUSUJDUGUAUBUCUDUEUF $.

  $( Axiom of Choice equivalent: the VII-finite sets are the same as I-finite
     sets.  (Contributed by Mario Carneiro, 18-May-2015.) $)
  dfacfin7 $p |- ( CHOICE <-> Fin7 = Fin ) $=
    ( vx cvv ccrd cdm cdif cfn wss cun wac cfin7 ssequn2 dfac10 cv finnum ssriv
    wceq mpbi eqeq1i bitr4i ssv eqss mpbiran ssundif 3bitri dffin7-2 3bitr4i )
    BCDZEZFGZFUHHZFPIJFPUHFKIUGFHZBPZBUKGZUIIUGBPULLUKUGBFUGGUKUGPAFUGAMNOFUGKQ
    RSULUKBGUMUKTUKBUAUBBUGFUCUDJUJFUERUF $.

  ${
    $d a x $.  $d a A $.  $d a b S $.
    fin1a2lem.a $e |- S = ( x e. On |-> suc x ) $.
    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem1 $p |- ( A e. On -> ( S ` A ) = suc A ) $=
      ( va con0 wcel csuc cfv wceq suceloni cv suceq cbvmptv eqtri fvmptg mpdan
      cmpt ) BFGBHZFGBCISJBKEBELZHZSFFCTBMCAFALZHZREFUARDAEFUCUAUBTMNOPQ $.

    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem2 $p |- S : On -1-1-> On $=
      ( va vb con0 wf1 wf cv cfv wceq weq wi wral csuc suceloni wcel fin1a2lem1
      fmpti wa eqeqan12d suc11 bitrd biimpd rgen2a dff13 mpbir2an ) FFBGFFBHDIZ
      BJZEIZBJZKZDELZMZEFNDFNAFFAIZOBCUOPSUNDEFUHFQZUJFQZTZULUMURULUHOZUJOZKUMU
      PUQUIUSUKUTAUHBCRAUJBCRUAUHUJUBUCUDUEDEFFBUFUG $.
  $}

  ${
    $d a x $.  $d a f y A $.  $d a b y E $.  $d a b S $.
    fin1a2lem.b $e |- E = ( x e. om |-> ( 2o .o x ) ) $.
    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem3 $p |- ( A e. om -> ( E ` A ) = ( 2o .o A ) ) $=
      ( va c2o cv comu co com oveq2 cmpt cbvmptv eqtri ovex fvmpt ) EBFEGZHIZFB
      HIJCQBFHKCAJFAGZHIZLEJRLDAEJTRSQFHKMNFBHOP $.

    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem4 $p |- E : om -1-1-> om $=
      ( va vb com cv cfv wceq wral c2o comu co wcel fin1a2lem3 con0 c0 a1i nnon
      c1o wf1 wf weq wi 2onn nnmcl mpan fmpti wa eqeqan12d wb 2on adantr adantl
      csuc 0lt1o elelsuc ax-mp df-2o eleqtrri omcan syl31anc bitrd biimpd dff13
      rgen2a mpbir2an ) FFBUAFFBUBDGZBHZEGZBHZIZDEUCZUDZEFJDFJAFFKAGZLMZBCKFNVO
      FNVPFNUEKVOUFUGUHVNDEFVHFNZVJFNZUIZVLVMVSVLKVHLMZKVJLMZIZVMVQVRVIVTVKWAAV
      HBCOAVJBCOUJVSKPNZVHPNZVJPNZQKNZWBVMUKWCVSULRVQWDVRVHSUMVRWEVQVJSUNWFVSQT
      UOZKQTNQWGNUPQTUQURUSUTRKVHVJVAVBVCVDVFDEFFBVEVG $.

    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem5 $p |- ( A e. om -> ( A e. ran E <-> -. suc A e. ran E ) ) $=
      ( va com wcel c2o cv wceq wn wb ax-mp fvelrnb eqcom eqeq2d syl5bb rexbiia
      wrex bitri comu co csuc crn cfv wfn wf1 fin1a2lem4 f1fn fin1a2lem3 notbii
      nneob 3bitr4g ) BFGBHEIZUAUBZJZEFSZBUCZUOJZEFSZKBCUDZGZURVAGZKEBULVBUNCUE
      ZBJZEFSZUQCFUFZVBVFLFFCUGVGACDUHFFCUIMZEFBCNMVEUPEFVEBVDJUNFGZUPVDBOVIVDU
      OBAUNCDUJZPQRTVCUTVCVDURJZEFSZUTVGVCVLLVHEFURCNMVKUSEFVKURVDJVIUSVDUROVIV
      DUOURVJPQRTUKUM $.

    fin1a2lem.aa $e |- S = ( x e. On |-> suc x ) $.
    $( Lemma for ~ fin1a2 .  Establish that ` om ` can be broken into two
       equipollent pieces.  (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem6 $p |- ( S |` ran E ) : ran E -1-1-onto-> ( om \ ran E ) $=
      ( va vb wf1o com con0 wf1 mp2an wceq wb wrex wcel wa eleq1 c0 ax-mp wf cv
      crn cima cres cdif wss fin1a2lem2 fin1a2lem4 f1f frn omsson syl6ss f1ores
      mp2b cfv wn csuc sseli fin1a2lem1 eqeq1d rexbiia peano2 fin1a2lem5 biimpd
      syl mpcom jca notbid anbi12d syl5ibcom rexlimiv wne c2o peano1 fin1a2lem3
      comu co om0x eqtri wfun cdm f1dm eleqtrri fvelrn eqeltrri mpbiri necon3bi
      f1fun nnsuc sylan2 anbi1d simplr adantl mpbird syl6bi com12 simprr eqcomd
      impr ex reximdv2 mpd impbii bitri wfn fvelimab eldif 3bitr4i eqriv f1oeq3
      f1fn mpbi ) CUCZBXNUDZBXNUEZHZXNIXNUFZXPHZJJBKZXNJUGZXQABEUHZIICKZIICUAZY
      AACDUIZIICUJZYDXNIJIICUKZULUMUOZJJXNBUNLXOXRMXQXSNFXOXRGUBZBUPZFUBZMZGXNO
      ZYKIPZYKXNPZUQZQZYKXOPZYKXRPYMYIURZYKMZGXNOZYQYLYTGXNYIXNPZYJYSYKUUBYIJPY
      JYSMXNJYIYHUSAYIBEUTVFVAVBUUAYQYTYQGXNUUBYSIPZYSXNPZUQZQZYTYQUUBUUCUUEUUB
      YIIPZUUCXNIYIYCYDXNIUGYEYFYGUOUSZYIVCVFUUGUUBUUEUUHUUGUUBUUEAYICDVDZVEVGV
      HYTUUCYNUUEYPYSYKIRYTUUDYOYSYKXNRVIVJVKVLYQYKYSMZGIOZUUAYPYNYKSVMUUKYOYKS
      YKSMYOSXNPSCUPZSXNUULVNSVQVRZSSIPUULUUMMVOASCDVPTVNVSVTCWAZSCWBZPUULXNPYC
      UUNYEIICWITSIUUOVOYCUUOIMYEIICWCTWDSCWELWFYKSXNRWGWHGYKWJWKYQUUJYTGIXNYQU
      UGUUJQZUUBYTQYQUUPQZUUBYTYQUUGUUJUUBUUJYQUUGQZUUBUUJUURUUFUUGQZUUBUUJYQUU
      FUUGUUJYNUUCYPUUEYKYSIRUUJYOUUDYKYSXNRVIVJWLUUSUUBUUEUUCUUEUUGWMUUGUUBUUE
      NUUFUUIWNWOWPWQWTUUQYKYSYQUUGUUJWRWSVHXAXBXCXDXEBJXFZYAYRYMNXTUUTYBJJBXLT
      YHGJXNYKBXGLYKIXNXHXIXJXOXRXNXPXKTXM $.

    $( Lemma for ~ fin1a2 .  Split a III-infinite set in two pieces.
       (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem7 $p |- ( ( A e. V /\ A. y e. ~P A
      ( y e. Fin3 \/ ( A \ y ) e. Fin3 ) ) -> A e. Fin3 ) $=
      ( vf wcel cfin3 com wn wfo wb mp2b cima wss wceq cvv cv cdif wo cpw cwdom
      wral wbr wex c0 wne peano1 ne0i brwdomn0 wrex crn cdm cnvimass wf fof fdm
      ccnv syl syl5sseq vex dmfex sylancr elpw2g mpbird cres ccom wfun wf1 wf1o
      fin1a2lem4 f1cnv f1ofo fofun ax-mp resex cofunexg mp2an fores sylancl f1f
      frn foimacnv mpan2 foeq3 mpbid foco fowdom cnvexg imaexg isfin3-2 con2bii
      sylib fin1a2lem6 f1ocnv difss syl5sseqr syl2anc funcnvcnv imaeq2d fimacnv
      imadif 3syl difeq1d 3eqtr3rd difexg con2bid wa eleq1 difeq2 eleq1d notbid
      orbi12d ioran syl6bb rspcev syl12anc rexnal exlimiv sylbi con2i syl5ibr
      imp ) CFJZBUAZKJZCYHUBZKJZUCZBCUDZUFZCKJZYNYOYGLCUEUGZMYPYNYPCLIUAZNZIUHZ
      YNMZUILJLUIUJYPYSOUKLUIULILCUMPYRYTIYRYLMZBYMUNZYTYRYQVAZEUOZQZYMJZUUEKJZ
      MZCUUEUBZKJZMZUUBYRUUFUUECRZYRYQUPZUUECYQUUDUQZYRCLYQURZUUMCSCLYQUSZCLYQU
      TVBZVCYRCTJZUUFUULOYRYQTJZUUOUURIVDZUUPCLTYQVEVFZUUECTVGVBVHYRLUUEUEUGZUU
      HYREVAZYQUUEVIZVJZTJZUUELUVENZUVBUVCVKZUVDTJUVFUUDLUVCNZUVHLLEVLZUUDLUVCV
      MUVIAEGVNZLLEVOUUDLUVCVPPZUUDLUVCVQVRYQUUEUUTVSUVCUVDTVTWAYRUVIUUEUUDUVDN
      ZUVGUVLYRUUEYQUUEQZUVDNZUVMYRYQVKZUUEUUMRUVOCLYQVQZUUNUUEYQWBWCYRUVNUUDSZ
      UVOUVMOYRUUDLRZUVRUVJLLEURUVSUVKLLEWDLLEWEPCLUUDYQWFWGUVNUUDUUEUVDWHVBWIU
      UEUUDLUVCUVDWJVFUVETLUUEWKVFUUGUVBUUETJZUUGUVBMOUUSUUCTJUVTUUTYQTWLUUCUUD
      TWMPUUETWNVRWOWPYRLUUIUEUGZUUKYRUVCDUUDVIZVAZVJZYQUUIVIZVJZTJZUUILUWFNZUW
      AUWDVKZUWETJUWGLUUDUBZLUWDNZUWIUVIUWJUUDUWCNZUWKUVLUUDUWJUWBVMUWJUUDUWCVM
      UWLADEGHWQUUDUWJUWBWRUWJUUDUWCVPPUWJUUDLUVCUWCWJWAZUWJLUWDVQVRYQUUIUUTVSU
      WDUWETVTWAYRUWKUUIUWJUWENZUWHUWMYRUUIYQUUIQZUWENZUWNYRUVPUUIUUMRUWPUVQYRC
      UUIUUMCUUEWSUUQWTUUIYQWBXAYRUWOUWJSUWPUWNOYRYQUUCUWJQZQZYQUUCLQZUUEUBZQUW
      JUWOYRUWQUWTYQYRUVPUUCVAVKUWQUWTSUVQYQXBLUUDUUCXEXFXCYRUWJLRUWRUWJSLUUDWS
      CLUWJYQWFWGYRUWTUUIYQYRUWSCUUEYRUUOUWSCSUUPCLYQXDVBXGXCXHUWOUWJUUIUWEWHVB
      WIUUIUWJLUWDUWEWJVFUWFTLUUIWKVFYRUUJUWAYRUURUUITJUUJUWAMOUVACUUETXIUUITWN
      XFXJWIUUAUUHUUKXKZBUUEYMYHUUESZUUAUUGUUJUCZMUXAUXBYLUXCUXBYIUUGYKUUJYHUUE
      KXLUXBYJUUIKYHUUECXMXNXPXOUUGUUJXQXRXSXTYLBYMYAWPYBYCYDCFWNYEYF $.
  $}

  ${
    $d a b c d e f g h x y A $.  $d d e f g h B $.  $d c x V $.  $d b c d X $.
    $d e f g h x C $.
    $( Lemma for ~ fin1a2 .  Split a III-infinite set in two pieces.
       (Contributed by Stefan O'Rear, 7-Nov-2014.) $)
    fin1a2lem8 $p |- ( ( A e. V /\ A. x e. ~P A
      ( x e. Fin3 \/ ( A \ x ) e. Fin3 ) ) -> A e. Fin3 ) $=
      ( vy con0 cv csuc cmpt com c2o comu co eqid fin1a2lem7 ) DABDEDFZGHZDIJOK
      LHZCQMPMN $.

    $( Lemma for ~ fin1a2 .  In a chain of finite sets, initial segments are
       finite.  (Contributed by Stefan O'Rear, 8-Nov-2014.) $)
    fin1a2lem9 $p |- ( ( [C.] Or X /\ X C_ Fin /\ A e. om ) ->
        { b e. X | b ~<_ A } e. Fin ) $=
      ( vc vd cfn wss com wcel cv cdom wbr con0 3ad2ant3 ccrd cfv wa wb syl2anc
      finnum crpss wor w3a csuc crab cin onfin2 inss2 peano2 sseldi breq1 elrab
      eqsstri simprr cdm simpl2 simprl sseldd syl simpl3 carddom2 mpbird cardnn
      ex sseq2d cardon nnon onsssuc sylancr bitrd sylibd syl5bi wceq wo wi ssel
      elrabi anim12d imp 3ad2antl2 sorpssi cen carden2 syl2an adantr fin23lem25
      3ad2antl1 3expa biimpd sylbid fveq2 impbid1 syl2ani dom2d mpd domfi ) BUA
      UBZBFGZAHIZUCZAUDZFIZCJZAKLZCBUEZXAKLZXEFIWSWQXBWRWSHFXAHMFUFFUGMFUHUMZAU
      IZUJNWTXAHIZXFWSWQXIWRXHNWTDEXEXADJZOPZEJZOPZHXJXEIZXJBIZXJAKLZQZWTXKXAIZ
      XDXPCXJBXCXJAKUKULWTXQXKAOPZGZXRWTXQXTWTXQQZXTXPWTXOXPUNYAXJOUOZIZAYBIZXT
      XPRYAXJFIZYCYABFXJWQWRWSXQUPWTXOXPUQURXJTZUSYAAFIYDYAHFAXGWQWRWSXQUTUJATU
      SXJAVASVBVDWSWQXTXRRWRWSXTXKAGZXRWSXSAXKAVCVEWSXKMIAMIYGXRRXJVFAVGXKAVHVI
      VJNVKVLXNWTXOXLBIZXKXMVMZXJXLVMZRZXLXEIXDCXJBVQXDCXLBVQWTXOYHQZYKWTYLQZYI
      YJYMYEXLFIZQZXJXLGXLXJGVNZYIYJVOWRWQYLYOWSWRYLYOWRXOYEYHYNBFXJVPBFXLVPVRV
      SVTWQWRYLYPWSBXJXLWAWGYOYPQZYIXJXLWBLZYJYOYIYRRZYPYEYCXLYBIYSYNYFXLTXJXLW
      CWDWEYQYRYJYEYNYPYRYJRXJXLWFWHWIWJSXJXLOWKWLVDWMWNWOXAXEWPS $.

    $( Lemma for ~ fin1a2 .  A nonempty finite union of members of a chain is a
       member of the chain.  (Contributed by Stefan O'Rear, 8-Nov-2014.) $)
    fin1a2lem10 $p |- ( ( A =/= (/) /\ A e. Fin /\ [C.] Or A ) ->
        U. A e. A ) $=
      ( vc c0 wne wcel crpss wor cuni wi cv wtru cun wceq a1i neeq1 soeq2 unieq
      eleq12d imbi12d wa va vb cfn csn wn ax-1 necon1ad tru 2thd w3a unisn snid
      id vex eqeltri uneq1 uncom un0 eqtri syl6eq unieqd mpbiri a1d simpr ssun1
      adantl wss simpl2 soss mpsyl uniun uneq2i wo simprr elun1 ad2antll sselii
      ssun2 sorpssi syl12anc ssequn1 eleq1 syl5ibr sylbi impcom syl5eqel jaodan
      syl2anc expr embantd pm2.61dane 3exp com24 findcard2 com12 3imp ) ACDZAUC
      EZAFGZAHZAEZWRWQWSXAIZUAJZCDZXCFGZXCHZXCEZIZIZKUBJZCDZXJFGZXJHZXJEZIZIZXJ
      BJZUDZLZCDZXSFGZXSHZXSEZIZIWQXBIUAUBBAXCCMZXIKYEXHXCCYEXHUEUFUGKYEUHNUIXC
      XJMZXDXKXHXOXCXJCOYFXEXLXGXNXCXJFPYFXFXMXCXJXCXJQYFUMRSSXCXSMZXDXTXHYDXCX
      SCOYGXEYAXGYCXCXSFPYGXFYBXCXSXCXSQYGUMRSSXCAMZXDWQXHXBXCACOYHXEWSXGXAXCAF
      PYHXFWTXCAXCAQYHUMRSSUHXJUCEZYAXTXPYCYIYAXTXPYCIZYIYAXTUJZYJXJCXJCMZYJYKY
      LYCXPYLYCXRHZXREYMXQXRXQBUNZUKZXQYNULZUOYLYBYMXSXRYLXSXRYLXSCXRLZXRXJCXRU
      PYQXRCLXRCXRUQXRURUSUTZVAYRRVBVCVFYKXKTZXKXOYCYKXKVDYSXLXNYCXJXSVGYSYAXLX
      JXRVEYIYAXTXKVHXJXSFVIVJYKXKXNYCYKXKXNTZTZYBXMXQLZXSYBXMYMLUUBXJXRVKYMXQX
      MYOVLUSUUAXNXMXQVGZXQXMVGZVMZUUBXSEZYKXKXNVNUUAYAXMXSEZXQXSEZUUEYIYAXTYTV
      HXNUUGYKXKXMXJXRVOZVPUUHUUAXRXSXQXRXJVRYPVQZNXSXMXQVSVTXNUUCUUFUUDUUCXNUU
      FUUCUUBXQMZXNUUFIXMXQWAXNUUFUUKUUHUUHXNUUJNUUBXQXSWBWCWDWEXNUUDTUUBXQXMLZ
      XSXMXQUQUUDXNUULXSEZUUDUULXMMZXNUUMIXQXMWAXNUUMUUNUUGUUIUULXMXSWBWCWDWEWF
      WGWHWFWIWJWJWKWLWMWNWOWP $.

    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 8-Nov-2014.) $)
    fin1a2lem11 $p |- ( ( [C.] Or A /\ A C_ Fin ) -> ran ( b e. om |->
        U. { c e. A | c ~<_ b } ) = ( A u. { (/) } ) ) $=
      ( vd crpss cfn wss wa com cv cdom wbr crab cuni wceq c0 wcel sylibr simpr
      wo wor cmpt crn wrex cab csn cun eqid rnmpt uni0 syl6eq adantl 0ex elsnc2
      unieq olcd wne ssrab2 simplll simpllr fin1a2lem9 syl3anc soss fin1a2lem10
      simplr mpsyl sseldi orcd pm2.61dane orbi12d syl5ibrcom rexlimdva ccrd cfv
      eleq1 sselda ficardom syl cen ficardid ensym endom breq1 sylanbrc elssuni
      3syl wral simprr adantr domentr syl2anc wb simprl sseldd sorpssi syl12anc
      elrab fincssdom mpbid ex syl5bi ralrimiv unissb eqssd breq2 unieqd eqeq2d
      rabbidv rspcev elsn peano1 wi dom0 biimpi a1i 3imtr4g ssrdv uni0b sylancr
      eqcomd eqeq1 rexbidv jaod impbid elun syl6bbr abbi1dv syl5eq ) AEUAZAFGZH
      ZBICJZBJZKLZCAMZNZUBZUCDJZYPOZBIUDZDUEAPUFZUGZBDIYPYQYQUHUIYKYTDUUBYKYTYR
      AQZYRUUAQZTZYRUUBQYKYTUUEYKYSUUEBIYKYMIQZHZUUEYSYPAQZYPUUAQZTZUUGUUJYOPUU
      GYOPOZHZUUIUUHUULYPPOZUUIUUKUUMUUGUUKYPPNPYOPUOUJUKULYPPUMUNRUPUUGYOPUQZH
      ZUUHUUIUUOYOAYPYNCAURZUUOUUNYOFQZYOEUAZYPYOQUUGUUNSUUOYIYJUUFUUQYIYJUUFUU
      NUSZYIYJUUFUUNUTYKUUFUUNVEYMACVAVBYOAGUUOYIUURUUPUUSYOAEVCVFYOVDVBVGVHVIY
      SUUCUUHUUDUUIYRYPAVOYRYPUUAVOVJVKVLYKUUCYTUUDYKUUCYTYKUUCHZYRVMVNZIQZYRYL
      UVAKLZCAMZNZOZYTUUTYRFQZUVBYKAFYRYIYJSVPZYRVQVRUUTYRUVEUUTYRUVDQZYRUVEGUU
      TUUCYRUVAKLZUVIYKUUCSUUTUVAYRVSLZYRUVAVSLUVJUUTUVGUVKUVHYRVTVRZUVAYRWAYRU
      VAWBWFUVCUVJCYRAYLYRUVAKWCWQWDYRUVDWEVRUUTYMYRGZBUVDWGUVEYRGUUTUVMBUVDYMU
      VDQYMAQZYMUVAKLZHZUUTUVMUVCUVOCYMAYLYMUVAKWCWQUUTUVPUVMUUTUVPHZYMYRKLZUVM
      UVQUVOUVKUVRUUTUVNUVOWHUUTUVKUVPUVLWIYMUVAYRWJWKUVQYMFQUVGUVMYRYMGTZUVRUV
      MWLUVQAFYMYIYJUUCUVPUTUUTUVNUVOWMZWNUUTUVGUVPUVHWIUVQYIUVNUUCUVSYIYJUUCUV
      PUSUVTYKUUCUVPVEAYMYRWOWPYMYRWRVBWSWTXAXBBUVDYRXCRXDYSUVFBUVAIYMUVAOZYPUV
      EYRUWAYOUVDUWAYNUVCCAYMUVAYLKXEXHXFXGXIWKWTUUDYRPOZYKYTDPXJYKYTUWBPYPOZBI
      UDZYKPIQPYLPKLZCAMZNZOZUWDXKYKUWGPYKUWFUUAGUWGPOYKBUWFUUAYKUVNYMPKLZHZYMP
      OZYMUWFQYMUUAQUWJUWKXLYKUWIUWKUVNUWIUWKYMXMXNULXOUWEUWICYMAYLYMPKWCWQBPXJ
      XPXQUWFXRRXTUWCUWHBPIUWKYPUWGPUWKYOUWFUWKYNUWECAYMPYLKXEXHXFXGXIXSUWBYSUW
      CBIYRPYPYAYBVKXAYCYDYRAUUAYEYFYGYH $.

    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 8-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    fin1a2lem12 $p |- ( ( ( A C_ ~P B /\ [C.] Or A /\ -. U. A e. A ) /\
        ( A C_ Fin /\ A =/= (/) ) ) -> -. B e. Fin3 ) $=
      ( ve vf vd wss cuni wcel wn c0 wa cfin3 com cv cdom wbr crab cvv wceq id
      cpw crpss wor w3a cfn wne cmpt crn wf cfv csuc wral simpll1 adantr ssrab2
      simpr unissi sspwuni biimpi syl5ss syl wb elpw2g ad2antlr mpbird fmptd wi
      eqid vex sucex sssucid ssdomg mp2 domtr mpan2 a1i uniss mp1i pwexg adantl
      ss2rabi ssexd rabexg uniexg breq2 rabbidv unieqd fvmptg syl2anr ralrimiva
      3syl peano2 3sstr4d syl3anc csn cun fin1a2lem11 adantrr 3ad2antl2 simpll3
      fin34i wo simplrr ss0b bitri pw0 sseq2i sssn df-ne 0ex unisn snid eqeltri
      unieq eleq12d mpbiri orim2i syl5bi sylbi sylbir com12 con3d sylc sylanbrc
      ord ioran uniun uneq2i un0 3eqtri eleq1i elun elsnc2 orbi2i 3bitri notbid
      sylnibr syl5ibrcom mpd pm2.65da ) ABUAZFZAUBUCZAGZAHZIZUDZAUEFZAJUFZKZKZB
      LHZCMDNZCNZOPZDAQZGZUGZUHZGZUUSHZUUKUULKZUULMUUAUURUIENZUURUJZUVCUKZUURUJ
      ZFZEMULUVAUUKUULUPUVBCMUUQUUAUURUVBUUNMHZKZUUQUUAHZUUQBFZUVIUUBUVKUVBUUBU
      VHUUBUUCUUFUUJUULUMZUNUUBUUQUUDBUUPAUUODAUOUQUUBUUDBFABURUSUTVAUULUVJUVKV
      BUUKUVHUUQBLVCVDVEUURVHZVFUVBUVGEMUVBUVCMHZKZUUMUVCOPZDAQZGZUUMUVEOPZDAQZ
      GZUVDUVFUVQUVTFUVRUWAFUVOUVPUVSDAUVPUVSVGUUMAHUVPUVCUVEOPZUVSUVERHUVCUVEF
      UWBUVCEVIVJUVCVKUVCUVERVLVMUUMUVCUVEVNVOVPWAUVQUVTVQVRUVNUVNUVRRHZUVDUVRS
      UVBUVNTUVBARHZUVQRHUWCUVBAUUARUULUUARHUUKBLVSVTUVLWBZUVPDARWCUVQRWDWKCUVC
      UUQUVRMRUURUUNUVCSZUUPUVQUWFUUOUVPDAUUNUVCUUMOWEWFWGUVMWHWIUVNUVEMHUWARHZ
      UVFUWASUVBUVCWLUVBUWDUVTRHUWGUWEUVSDARWCUVTRWDWKCUVEUUQUWAMRUURUUNUVESZUU
      PUVTUWHUUOUVSDAUUNUVEUUMOWEWFWGUVMWHWIWMWJEBUURXAWNUVBUUSAJWOZWPZSZUVAIZU
      UKUWKUULUUCUUBUUJUWKUUFUUCUUHUWKUUIACDWQWRWSUNUVBUWLUWKUWJGZUWJHZIUVBUUEU
      UDJSZXBZUWNUVBUUFUWOIZUWPIUUBUUCUUFUUJUULWTZUVBUUIUUFUWQUUGUUHUUIUULXCUWR
      UUIUWOUUEUWOUUIUUEUWOAJUAZFZUUIUUEVGZUWTUUDJFUWOAJURUUDXDXEUWTAJSZAUWISZX
      BZUXAUWTAUWIFUXDUWSUWIAXFXGAJXHXEUUIUXBIUXDUUEAJXIUXDUXBUUEUXCUUEUXBUXCUU
      EUWIGZUWIHUXEJUWIJXJXKZJXJXLXMUXCUUDUXEAUWIAUWIXNUXCTXOXPXQYEXRXSXTYAYBYC
      UUEUWOYFYDUWNUUDUWJHUUEUUDUWIHZXBUWPUWMUUDUWJUWMUUDUXEWPUUDJWPUUDAUWIYGUX
      EJUUDUXFYHUUDYIYJYKUUDAUWIYLUXGUWOUUEUUDJXJYMYNYOYQUWKUVAUWNUWKUUTUWMUUSU
      WJUUSUWJXNUWKTXOYPYRYSYT $.

    $( Lemma for ~ fin1a2 .  (Contributed by Stefan O'Rear, 8-Nov-2014.)
       (Revised by Mario Carneiro, 17-May-2015.) $)
    fin1a2lem13 $p |- ( ( ( A C_ ~P B /\ [C.] Or A /\ -. U. A e. A ) /\
        ( -. C e. Fin /\ C e. A ) ) -> -. ( B \ C ) e. Fin2 ) $=
      ( vg vf vx ve vh wss wcel wa cdif cv c0 wceq wrex cvv elrnmpt sylibr wral
      cpw crpss wor cuni w3a cfn cfin2 cmpt crn wne simpr simpll1 elpwid ssdifd
      wn ssel2 sseq1 syl5ibrcom rexlimdva vex eqid ax-mp elpw 3imtr4g ssrdv syl
      simplrr difid eqcomi difeq1 eqeq2d rspcev mpan2 0ex ne0i 3syl simpll2 weq
      wb wo cbvrexv wi sorpssi ssdif orim12i sseq2 orbi12d expr rexlimdv syl5bi
      ralrimiv ralbidv sorpss fin2i syl22anc simpll3 cbvmptv adantl difexg mp2b
      ibi elssuni simplr sseqtrd adantll cun unss2 uncom eqtri ad2antrr simpllr
      undif1 a1i ssdif0 biimpi eqtrd uni0c sylib eqeq1 rspcva syl2anc ralrimiva
      ad2antlr unissb eqssd simpll eqeltrd ex mtod simplrl syl12anc orel1 undif
      sylc sseq12d ssun1 sstr mpan syl6bi syl5 mpd ad2antrl rexlimdvaa pm2.65da
      simprl ) ABUAZIZAUBUCZAUDZAJZUOZUEZCUFJUOZCAJZKZKZBCLZUGJZDADMZCLZUHZUIZU
      DZUVBJZUUPUURKZUURUVBUUQUAZIZUVBNUJZUVBUBUCZUVDUUPUURUKUVEUUGUVGUUGUUHUUK
      UUOUURULUUGEUVBUVFUUGEMZUUTOZDAPZUVJUUQIZUVJUVBJZUVJUVFJUUGUVKUVMDAUUGUUS
      AJZKZUVMUVKUUTUUQIUVPUUSBCUVPUUSBAUUFUUSUPUMUNUVJUUTUUQUQURUSUVJQJUVNUVLV
      SEUTZDAUUTUVJUVAQUVAVAZRVBZUVJUUQUVQVCVDVEVFUVEUUNNUVBJZUVHUULUUMUUNUURVG
      ZUUNNUUTOZDAPZUVTUUNNCCLZOZUWCUWDNCVHVIUWBUWEDCAUUSCOUUTUWDNUUSCCVJVKVLVM
      NQJUVTUWCVSVNDAUUTNUVAQUVRRVBSUVBNVOVPUVEUUHUVIUUGUUHUUKUUOUURVQZUUHFMZUV
      JIZUVJUWGIZVTZEUVBTZFUVBTUVIUUHUWKFUVBUWGUVBJZUWGUUTOZDAPZUUHUWKUWGQJZUWL
      UWNVSFUTZDAUUTUWGUVAQUVRRVBUWNUWGGMZCLZOZGAPUUHUWKUWMUWSDGADGVRUUTUWRUWGU
      USUWQCVJVKWAUUHUWSUWKGAUUHUWQAJZKZUWKUWSUWRUVJIZUVJUWRIZVTZEUVBTUXAUXDEUV
      BUVNUVLUXAUXDUVSUXAUVKUXDDAUUHUWTUVOUVKUXDWBUUHUWTUVOKKZUXDUVKUWRUUTIZUUT
      UWRIZVTZUXEUWQUUSIZUUSUWQIZVTUXHAUWQUUSWCUXIUXFUXJUXGUWQUUSCWDUUSUWQCWDWE
      VFUVKUXBUXFUXCUXGUVJUUTUWRWFUVJUUTUWRUQWGURWHWIWJWKUWSUWJUXDEUVBUWSUWHUXB
      UWIUXCUWGUWRUVJUQUWGUWRUVJWFWGWLURUSWJWJWKFEUVBWMSVFUUQUVBWNWOUVEUVDUUJUU
      GUUHUUKUUOUURWPZUVDUVCUVJCLZOZEAPZUVEUUJUVDUXNEAUXLUVCUVAUVBDEAUUTUXLUUSU
      VJCVJWQRXAUVEUXMUUJEAUVEUVJAJZUXMKZKZUUIUVJAUXQUUIUVJUXQHMZUVJIZHATUUIUVJ
      IUXQUXSHAUXQUXRAJZKZUXRCLZUXLIZUXSUXPUXTUYCUVEUXPUXTKZUYBUVCUXLUYDUYBUVBJ
      ZUYBUVCIUYDUYBUUTOZDAPZUYEUXTUYGUXPUXTUYBUYBOZUYGUYBVAUYFUYHDUXRADHVRUUTU
      YBUYBUUSUXRCVJVKVLVMWRUXRQJUYBQJUYEUYGVSHUTUXRCQWSDAUUTUYBUVAQUVRRWTSUYBU
      VBXBVFUXOUXMUXTXCXDXEUYCCUYBXFZCUXLXFZIZUYAUXSUYBUXLCXGUYAUYKUXRCXFZUVJIZ
      UXSUYAUYIUYLUYJUVJUYIUYLOUYAUYIUYBCXFUYLCUYBXHUXRCXLXIXMUYACUVJIZUYJUVJOU
      YAUVJCIZUOUYOUYNVTZUYNUYAUYOUUJUVEUUKUXPUXTUXKXJUYAUUNUXMUYOUUJWBUVEUUNUX
      PUXTUWAXJZUVEUXOUXMUXTVGUUNUXMKZUYOUUJUYRUYOKZUUICAUYSUUICUYSUWGCIZFATUUI
      CIUYSUYTFAUYSUWGAJZKZUWGCLZNOZUYTVUBVUCUVBJZUWQNOZGUVBTZVUDVUAVUEUYSVUAVU
      CUUTOZDAPZVUEVUAVUCVUCOZVUIVUCVAVUHVUJDUWGADFVRUUTVUCVUCUUSUWGCVJVKVLVMUW
      OVUCQJVUEVUIVSUWPUWGCQWSDAUUTVUCUVAQUVRRWTSWRVUBUVCNOVUGVUBUVCUXLNUUNUXMU
      YOVUAXKUYOUXLNOZUYRVUAUYOVUKUVJCXNXOYCXPGUVBXQXRVUFVUDGVUCUVBUWQVUCNXSXTY
      AUWGCXNSYBFACYDSUUNCUUIIUXMUYOCAXBXJYEUUNUXMUYOYFYGYHYAYIUYAUUHUXOUUNUYPU
      VEUUHUXPUXTUWFXJUVEUXOUXMUXTYJUYQAUVJCWCYKUYOUYNYLYNCUVJYMXRYOUXRUYLIUYMU
      XSUXRCYPUXRUYLUVJYQYRYSYTUUAYBHAUVJYDSUXOUVJUUIIUVEUXMUVJAXBUUBYEUVEUXOUX
      MUUEYGUUCYTYIUUD $.

    $( Weak theorem which skips Ia but has a trivial proof, needed to prove
       ~ fin1a2 .  (Contributed by Stefan O'Rear, 8-Nov-2014.)  (Revised by
       Mario Carneiro, 17-May-2015.) $)
    fin12 $p |- ( A e. Fin -> A e. Fin2 ) $=
      ( vb vc vd cfn wcel cfin2 cv c0 wne crpss wor wa cpw wral wn wrex wbr cvv
      vex cuni wi wpss ccnv wfr wss a1i isfin1-3 ad2antrr elpwi ad2antlr simprl
      syl22anc brcnv brrpss bitri notbii ralbii rexbii sylib sorpssuni ad2antll
      ibi fri wb mpbid ex ralrimiva isfin2 mpbird ) AEFZAGFBHZIJZVLKLZMZVLUAVLF
      ZUBZBANZNZOVKVQBVSVKVLVSFZMZVOVPWAVOMZCHZDHZUCZPZDVLOZCVLQZVPWBWDWCKUDZRZ
      PZDVLOZCVLQZWHWBVLSFZVRWIUEZVLVRUFZVMWMWNWBBTUGVKWOVTVOVKWOAEUHVCUIVTWPVK
      VOVLVRUJUKWAVMVNULCDVRVLSWIVDUMWLWGCVLWKWFDVLWJWEWJWCWDKRWEWDWCKDTZCTUNWC
      WDWQUOUPUQURUSUTVNWHVPVEWAVMDCVLVAVBVFVGVHBAEVIVJ $.

    $( An II-infinite set can have an I-infinite part broken off and remain
       II-infinite.  (Contributed by Stefan O'Rear, 8-Nov-2014.)  (Proof
       shortened by Mario Carneiro, 17-May-2015.) $)
    fin1a2s $p |- ( ( A e. V /\
      A. x e. ~P A ( x e. Fin \/ ( A \ x ) e. Fin2 ) ) -> A e. Fin2 ) $=
      ( vc wcel cv cfn cfin2 wo cpw wa wi wss cfin3 fin23 syl adantr wn simplrl
      wral cdif wne crpss wor cuni elpwi fin12 orim12i ralimi fin1a2lem8 sylan2
      c0 simprrr simprl ssralv idd w3a fin1a2lem13 ex 3expa adantll imp ancom2s
      adantlrl expr con4d jaod ralimdva syld impr dfss3 sylibr simprrl syl32anc
      fin1a2lem12 impancom an32s mt4d exp32 syl5 ralrimiv wb isfin2 mpbird ) BC
      EZAFZGEZBWFUAZHEZIZABJZTZKZBHEZDFZULUBZWOUCUDZKZWOUEWOEZLZDWKJZTZWMWTDXAW
      OXAEWOWKMZWMWTWOWKUFWMXCWRWSWMXCWRKZKBNEZWSWMXEXDWLWEWFNEZWHNEZIZAWKTXEWJ
      XHAWKWGXFWIXGWGWFHEXFWFUGWFOPWHOUHUIABCUJUKQWEXDWLWSRZXERZLWEXDKZXIWLXJXK
      XIWLXJXKXIWLKZKZXCWQXIWOGMZWPXJWEXCWRXLSXKWQXLWEXCWPWQUMQXKXIWLUNXMWGAWOT
      ZXNXKXIWLXOXKXIKZWLWJAWOTZXOXPXCWLXQLWEXCWRXISWJAWOWKUOPXPWJWGAWOXPWFWOEZ
      KZWGWGWIXSWGUPXSWGWIXPXRWGRZWIRZXPXTXRYAXPXTXRKZYAXDXIYBYALZWEXCWQXIYCWPX
      CWQXIYCXCWQXIUQYBYAWOBWFURUSUTVDVAVBVCVEVFVGVHVIVJAWOGVKVLXKWPXLWEXCWPWQV
      MQWOBVOVNVEVPVQVRVSVTWAWEWNXBWBWLDBCWCQWD $.

    $( Every Ia-finite set is II-finite.  Theorem 1 of [Levy58], p. 3.
       (Contributed by Stefan O'Rear, 8-Nov-2014.)  (Proof shortened by Mario
       Carneiro, 17-May-2015.) $)
    fin1a2 $p |- ( A e. Fin1a -> A e. Fin2 ) $=
      ( vb cfin1a wcel cv cfn cdif cfin2 wo cpw wral wss elpwi wa fin1ai orim2i
      fin12 syl sylan2 ralrimiva fin1a2s mpdan ) ACDZBEZFDZAUDGZHDZIZBAJZKAHDUC
      UHBUIUDUIDUCUDALZUHUDAMUCUJNUEUFFDZIUHAUDOUKUGUEUFQPRSTBACUAUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Hereditarily size-limited sets without Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y a b c $.  $d B x y a b c d $.  $d U a b c d $.
    ituni.u $e |- U = ( x e. _V |->
        ( rec ( ( y e. _V |-> U. y ) , x ) |` om ) ) $.
    $( Function value of iterated unions. _EDITORIAL_:  The iterated unions and
       order types of ordered sets are split out here because they could
       concievably be independently useful.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    itunifval $p |- ( A e. V -> ( U ` A ) =
          ( rec ( ( y e. _V |-> U. y ) , A ) |` om ) ) $=
      ( wcel cvv cfv cv cuni cmpt crdg com cres wceq elex rdgeq2 reseq1d wfun
      rdgfun omex resfunexg mp2an fvmpt syl ) CEGCHGCDIBHBJKLZCMZNOZPCEQACUGAJZ
      MZNOUIHDUJCPUKUHNUJCUGRSFUHTNHGUIHGCUGUAUBUHNHUCUDUEUF $.

    $( Functionality of the iterated union.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    itunifn $p |- ( A e. V -> ( U ` A ) Fn om ) $=
      ( wcel cfv com wfn cvv cuni cmpt crdg cres frfnom itunifval fneq1d mpbiri
      cv ) CEGZCDHZIJBKBTLMZCNIOZIJCUCPUAIUBUDABCDEFQRS $.

    $( A zero-fold iterated union.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    ituni0 $p |- ( A e. V -> ( ( U ` A ) ` (/) ) = A ) $=
      ( wcel c0 cfv cvv cv cuni cmpt crdg com cres itunifval fveq1d fr0g eqtrd
      ) CEGZHCDIZIHBJBKLMZCNOPZICUAHUBUDABCDEFQRCEUCST $.

    $( Successor iterated union.  (Contributed by Stefan O'Rear,
       11-Feb-2015.) $)
    itunisuc $p |- ( ( U ` A ) ` suc B ) = U. ( ( U ` A ) ` B ) $=
      ( va cvv wcel cfv cuni wceq com wa cv fveq1d unieqd wn c0 syl frsuc unieq
      csuc cmpt crdg cres fvex uniex fvmpt ax-mp syl6eq adantl itunifval adantr
      cbvmptv 3eqtr4d uni0 eqcomi cdm wfn itunifn eleq2d peano2b syl6bbr notbid
      fndm biimpar ndmfv 3eqtr4a pm2.61dan 0fv unieqi 3eqtr4ri fvprc pm2.61i )
      CHIZDUCZCEJZJZDVRJZKZLZVPDMIZWBVPWCNZVQBHBOZKZUDZCUEMUFZJZDWHJZKZVSWAWCWI
      WKLVPWCWIWJWGJZWKCDWGUAWJHIWLWKLDWHUGZGWJGOZKZWKHWGWNWJUBBGHWFWOWEWNUBUOW
      JWMUHUIUJUKULVPVSWILWCVPVQVRWHABCEHFUMZPUNWDVTWJVPVTWJLWCVPDVRWHWPPUNQUPV
      PWCRZNZSSKZVSWAWSSUQURWRVQVRUSZIZRZVSSLVPXBWQVPXAWCVPXAVQMIWCVPWTMVQVPVRM
      UTWTMLABCEHFVAMVRVFTZVBDVCVDVEVGVQVRVHTWRVTSWRDWTIZRZVTSLVPXEWQVPXDWCVPWT
      MDXCVBVEVGDVRVHTQVIVJVPRZVQSJZDSJZKZVSWAWSSXIXGUQXHSDVKVLVQVKVMXFVQVRSCEV
      NZPXFVTXHXFDVRSXJPQVIVO $.

    $( Each union iterate is a member of the transitive closure.  (Contributed
       by Stefan O'Rear, 11-Feb-2015.) $)
    itunitc1 $p |- ( ( U ` A ) ` B ) C_ ( TC ` A ) $=
      ( va vb vc cvv wcel cfv ctc wss cv wceq fveq2 com c0 sseq1d fveq1d ituni0
      sseq12d csuc weq vex tcid eqsstrd wi cuni itunisuc cpw wtr tctr pwtr mpbi
      ax-mp trss fvex elpw sspwuni 3imtr3i syl5eqss a1i wn cdm wfn itunifn fndm
      finds mp2b eleq2i ndmfv sylnbir 0ss syl6eqss pm2.61i vtoclg fvprc syl6eq
      0fv ) CJKZDCELZLZCMLZNZDGOZELZLZWGMLZNZWFGCJWGCPZWIWDWJWEWLDWHWCWGCEQUAWG
      CMQUCDRKZWKHOZWHLZWJNSWHLZWJNZIOZWHLZWJNZWRUDZWHLZWJNZWKHIDWNSPWOWPWJWNSW
      HQTHIUEWOWSWJWNWRWHQTWNXAPWOXBWJWNXAWHQTWNDPWOWIWJWNDWHQTWGJKZWQGUFZXDWPW
      GWJABWGEJFUBWGJUGUHUQWTXCUIWRRKWTXBWSUJZWJABWGWREFUKWSWJULZKZWSXGNZWTXFWJ
      NXGUMZXHXIUIWJUMXJWGUNWJUOUPXGWSURUQWSWJWRWHUSUTWSWJVAVBVCVDVJWMVEWISWJWM
      DWHVFZKWISPXKRDXDWHRVGXKRPXEABWGEJFVHRWHVIVKVLDWHVMVNWJVOVPVQVRWBVEZWDSWE
      XLWDDSLSXLDWCSCEVSUADWAVTWEVOVPVQ $.

    $( The union of all union iterates creates the transitive closure; compare
       ~ trcl .  (Contributed by Stefan O'Rear, 11-Feb-2015.) $)
    itunitc $p |- ( TC ` A ) = U. ran ( U ` A ) $=
      ( va vb vc cvv wcel ctc cfv crn cuni wceq cv fveq2 wss c0 com eqeq12d wtr
      rneqd unieqd vex ituni0 ax-mp fvssunirn eqsstr3i wrex wfn itunifn fnunirn
      dftr3 wb mp2b elssuni itunisuc syl6ss rexlimivw sylbi mprgbir wa wi tcmin
      csuc mp2an unissb fvelrnb itunitc1 a1i sseq1 syl5ibcom rexlimiv vtoclg wn
      eqssi rn0 unieqi uni0 eqtr2i fvprc 3eqtr4a pm2.61i ) CIJZCKLZCDLZMZNZOZFP
      ZKLZWKDLZMZNZOWJFCIWKCOZWLWFWOWIWKCKQWPWNWHWPWMWGWKCDQUCUDUAWLWOWKWORZWOU
      BZWLWORZWKSWMLZWOWKIJZWTWKOFUEZABWKDIEUFUGWMSUHUIWRGPZWORZGWOGWOUNXCWOJZX
      CHPZWMLZJZHTUJZXDXAWMTUKZXEXIUOXBABWKDIEULZHXCWMTUMUPXHXDHTXHXCXGNZWOXCXG
      UQXLXFVFZWMLWOABWKXFDEURWMXMUHUIUSUTVAVBXAWQWRVCWSVDXBWKWOIVEUGVGWOWLRXCW
      LRZGWNGWNWLVHXCWNJZXGXCOZHTUJZXNXAXJXOXQUOXBXKHTXCWMVIUPXPXNHTXFTJZXGWLRZ
      XPXNXSXRABWKXFDEVJVKXGXCWLVLVMVNVAVBVQVOWEVPZSSMZNZWFWIYBSNSYASVRVSVTWACK
      WBXTWHYAXTWGSCDWBUCUDWCWD $.

    $( Unwrap an iterated union from the "other end".  (Contributed by Stefan
       O'Rear, 11-Feb-2015.) $)
    ituniiun $p |- ( A e. V -> ( ( U ` A ) ` suc B ) =
          U_ a e. A ( ( U ` a ) ` B ) ) $=
      ( csuc cfv ciun wceq fveq2 eqeq12d com wcel c0 iuneq2d cuni cvv vb fveq1d
      vd vc cv iuneq1 suceq fveq2d weq uniiun itunisuc vex ituni0 ax-mp iuneq2i
      unieqi eqtri 3eqtr4i wi unieq wel iuncom4 eqtr2i syl6eq syl5eq finds iun0
      a1i eqcomi cdm peano2b wfn itunifn fndm mp2b eleq2i bitr4i sylnbi sylnbir
      wn ndmfv 3eqtr4a pm2.61i vtoclg ) DIZUAUEZEJZJZGWFDGUEZEJZJZKZLZWECEJZJZG
      CWKKZLUACFWFCLZWHWOWLWPWQWEWGWNWFCEMUBGWFCWKUFNDOPZWMUCUEZIZWGJZGWFWSWJJZ
      KZLQIZWGJZGWFQWJJZKZLUDUEZIZWGJZGWFXHWJJZKZLZXIIZWGJZGWFXIWJJZKZLZWMUCUDD
      WSQLZXAXEXCXGXSWTXDWGWSQUGUHXSGWFXBXFWSQWJMRNUCUDUIZXAXJXCXLXTWTXIWGWSXHU
      GUHXTGWFXBXKWSXHWJMRNWSXILZXAXOXCXQYAWTXNWGWSXIUGUHYAGWFXBXPWSXIWJMRNWSDL
      ZXAWHXCWLYBWTWEWGWSDUGUHYBGWFXBWKWSDWJMRNWFSZGWFWIKXEXGGWFUJXEQWGJZSYCABW
      FQEHUKYDWFWFTPZYDWFLUAULZABWFETHUMUNUPUQGWFXFWIABWIEWFHUMUOURXMXRUSXHOPXM
      XOXJSZXQABWFXIEHUKXMYGXLSZXQXJXLUTXQGWFXKSZKYHGWFXPYIXPYILGUAVAABWIXHEHUK
      VHUOGWFXKVBVCVDVEVHVFWRVTZQGWFQKZWHWLYKQGWFVGVIWRWEWGVJZPZWHQLWRWEOPYMDVK
      YLOWEYEWGOVLYLOLYFABWFETHVMOWGVNVOVPVQWEWGWAVRYJGWFWKQWRDWJVJZPWKQLYNODWI
      TPWJOVLYNOLGULABWIETHVMOWJVNVOVPDWJWAVSRWBWCWD $.
  $}

  ${
    $d H b $.  $d X b z $.  $d a b z $.
    hsmexlem7.h $e |- H = ( rec ( ( z e. _V |-> ( har ` ~P ( X X. z ) ) ) ,
            ( har ` ~P X ) ) |` om ) $.
    $( Lemma for ~ hsmex .  Properties of the recurrent sequence of ordinals.
       (Contributed by Stefan O'Rear, 14-Feb-2015.) $)
    hsmexlem7 $p |- ( H ` (/) ) = ( har ` ~P X ) $=
      ( c0 cfv cvv cxp cpw char cmpt crdg com cres fveq1i wcel wceq fvex fr0g
      cv ax-mp eqtri ) EBFEAGCATHIJFKZCIZJFZLMNZFZUEEBUFDOUEGPUGUEQUDJRUEGUCSUA
      UB $.

    $( Lemma for ~ hsmex .  Properties of the recurrent sequence of ordinals.
       (Contributed by Stefan O'Rear, 14-Feb-2015.) $)
    hsmexlem8 $p |- ( a e. om -> ( H ` suc a ) =
          ( har ` ~P ( X X. ( H ` a ) ) ) ) $=
      ( vb cv com wcel cfv cxp cpw char cvv csuc wceq fvex xpeq2 pweqd fveq2d
      frsucmpt2 mpan2 ) DGZHICUCBJZKZLZMJZNIUCOBJUGPUFMQAFCLMJUCCAGZKZLZMJUGCFG
      ZKZLZMJBNEUKUHPZUMUJMUNULUIUKUHCRSTUKUDPZUMUFMUOULUEUKUDCRSTUAUB $.

    $( Lemma for ~ hsmex .  Properties of the recurrent sequence of ordinals.
       (Contributed by Stefan O'Rear, 14-Feb-2015.) $)
    hsmexlem9 $p |- ( a e. om -> ( H ` a ) e. On ) $=
      ( vb cv com wcel c0 wceq csuc wrex cfv con0 fveq2 cpw char harcl syl6eqel
      wo nn0suc hsmexlem7 eqeltri cxp hsmexlem8 eleq1d syl5ibrcom rexlimiv jaoi
      syl ) DGZHIULJKZULFGZLZKZFHMZUAULBNZOIZFULUBUMUSUQUMURJBNZOULJBPUTCQZRNOA
      BCEUCVASUDTUPUSFHUNHIZUSUPUOBNZOIVBVCCUNBNUEQZRNOABCFEUFVDSTUPURVCOULUOBP
      UGUHUIUJUK $.
  $}

  ${
    $d O x y z a b c $.  $d I x y z a b c $.  $d A x y z $.
    hsmexlem.o $e |- O = OrdIso ( _E , A ) $.
    $( Lemma for ~ hsmex .  Bound the order type of a limited-cardinality set
       of ordinals.  (Contributed by Stefan O'Rear, 14-Feb-2015.)  (Revised by
       Mario Carneiro, 26-Jun-2015.) $)
    hsmexlem1 $p |- ( ( A C_ On /\ A ~<_* B ) -> dom O e. ( har ` ~P B ) ) $=
      ( con0 wss cwdom wbr wa wcel cpw cdom word cep cvv wb 3syl wf adantr syl
      cdm char cfv oicl cuni relwdom brrelexi adantl uniexg sucexg oif onsucuni
      csuc wsmo fss sylancr crn wceq oismo simpld ssorduni ordsuc sylib syl3anc
      smorndom ssexd elong mpbiri csdm canth2g sdomdom cen wf1o wiso wwe epweon
      wse simpl wess ee10 epse oiiso2 sylancl isof1o simprd mpbid f1oen2g endom
      f1oeq3 domwdom wdomtr sylancom wdompwdom domtr syl2anc elharval sylanbrc
      ) AEFZABGHZIZCUAZEJZXABKZLHZXAXCUBUCJWTXBXAMZANCDUDWTXAOJZXBXEPWTXAAUEZUM
      ZOWTAOJZXGOJXHOJWSXIWRABGUFUGUHZAOUIXGOUJQWTXAXHCRZCUNZXHMZXAXHFWTXAACRAX
      HFZXKANCDUKWRXNWSAULSXAAXHCUOUPWTXLCUQZAURZWRXLXPIWSACDUSSZUTWTXGMZXMWRXR
      WSAVASXGVBVCXAXHCVEVDVFZXAOVGTVHZWTXAXAKZLHZYAXCLHZXDWTXFXAYAVIHYBXSXAOVJ
      XAYAVKQWTXABGHZYCWRWSXAAGHZYDWTXAAVLHZXAALHYEWTXBXIXAACVMZYFXTXJWTXAXOCVM
      ZYGWTXAXONNCVNZYHWTANVOZANVQYIWTWRENVOYJWRWSVRVPAENVSVTAWAANCDWBWCXAXONNC
      WDTWTXPYHYGPWTXLXPXQWEXOAXACWITWFXAACEOWGVDXAAWHXAAWJQXAABWKWLXABWMTXAYAX
      CWNWOXCXAWPWQ $.
  $}

  ${
    $d a b c d e A $.  $d b c d e B $.  $d a b c d e C $.  $d b c d e F $.
    hsmexlem.f $e |- F = OrdIso ( _E , B ) $.
    hsmexlem.g $e |- G = OrdIso ( _E , U_ a e. A B ) $.
    $( Lemma for ~ hsmex .  Bound the order type of a union of sets of
       ordinals, each of limited order type.  Vaguely reminiscent of ~ unictb
       but use of order types allows to canonically choose the sub-bijections,
       removing the choice requirement.  (Contributed by Stefan O'Rear,
       14-Feb-2015.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    hsmexlem2 $p |- ( ( A e. _V /\ C e. On /\ A. a e. A ( B e. ~P On /\
              dom F e. C ) ) -> dom G e. ( har ` ~P ( A X. C ) ) ) $=
      ( vb vc ve vd wcel con0 wa cfv cv cep wceq wrex cvv cpw cdm wral w3a ciun
      wss cxp cwdom wbr char elpwi adantr ralimi iunss sylibr 3ad2ant3 c2nd csb
      c1st coi xpexg 3adant3 nfv nfra1 nfan rsp onelss imp adantrl wfo crn wsmo
      wi wf oismo syl ad2antrl simprd oif jctil dffo2 dffo3 simprbi 3syl 3impia
      ssrexv sylc 3exp sylan9r reximdai 3adant1 nfcv nfcsb1v nfoi nfeq2 csbeq1a
      nffv nfrex oieq2 syl5eq fveq1d eqeq2d rexbidv cbvrex syl6ib eliun cop vex
      op1std csbeq1d op2ndd fveq12d rexxp 3imtr4g wdomd hsmexlem1 syl2anc ) AUA
      MZCNMZBNUBMZDUCZCMZOZFAUDZUEZFABUFZNUGZYGACUHZUIUJEUCYIUBUKPMYEXSYHXTYEBN
      UGZFAUDYHYDYJFAYAYJYCBNULZUMUNFABNUOUPUQYFIJYGYIUAJQZURPZFYLUTPZBUSZRVAZP
      ZXSXTYIUAMYEACUANVBVCYFIQZYGMZYRYQSZJYITZYFYRBMZFATZYRKQZFLQZBUSZRVAZPZSZ
      KCTZLATZYSUUAYFUUCYRUUDDPZSZKCTZFATZUUKXTYEUUCUUOVNXSXTYEOUUBUUNFAXTYEFXT
      FVDYDFAVEVFYEFQZAMYDXTUUBUUNVNYDFAVGXTYDUUBUUNXTYDUUBUEYBCUGZUUMKYBTZUUNX
      TYDUUQUUBXTYCUUQYAXTYCUUQCYBVHVIVJVCXTYDUUBUURXTYDOZYBBDVKZUURIBUDZUUBUUR
      VNUUSYBBDVOZDVLBSZOUUTUUSUVCUVBUUSDVMZUVCYAUVDUVCOZXTYCYAYJUVEYKBDGVPVQVR
      VSBRDGVTWAYBBDWBUPUUTUVBUVAKIYBBDWCWDUURIBVGWEWFUUMKYBCWGWHWIWJWKWLUUNUUJ
      FLAUUNLVDUUIFKCFCWMFYRUUHFUUDUUGFUUFRFRWMFUUEBWNWOFUUDWMWRWPWSUUPUUESZUUM
      UUIKCUVFUULUUHYRUVFUUDDUUGUVFDBRVAZUUGGUVFBUUFSUVGUUGSFUUEBWQBUUFRWTVQXAX
      BXCXDXEXFFYRABXGYTUUIJLKACYLUUEUUDXHSZYQUUHYRUVHYMUUDYPUUGUVHYOUUFSYPUUGS
      UVHFYNUUEBUUEUUDYLLXIZKXIZXJXKYOUUFRWTVQUUEUUDYLUVIUVJXLXMXCXNXOVIXPYGYIE
      HXQXR $.

    $( Lemma for ~ hsmex .  Clear ` I ` hypothesis and extend previous result
       by dominance.  Note that this could be substantially strengthened, e.g.
       using the weak Hartogs function, but all we need here is that there be
       *some* dominating ordinal.  (Contributed by Stefan O'Rear,
       14-Feb-2015.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    hsmexlem3 $p |- ( ( ( A ~<_* D /\ C e. On ) /\ A. a e. A ( B e. ~P On /\
        dom F e. C ) ) -> dom G e. ( har ` ~P ( D X. C ) ) ) $=
      ( cwdom wbr con0 wcel wa cpw cdm cxp char cfv adantr wral wdomref xpwdomg
      wss cdom sylan2 wdompwdom harword 3syl cvv relwdom simplr simpr hsmexlem2
      brrelexi syl3anc sseldd ) ADJKZCLMZNZBLOMEPCMNGAUAZNZACQZOZRSZDCQZOZRSZFP
      ZUTVEVHUDZVAUTVCVFJKZVDVGUEKVJUSURCCJKVKLCUBADCCUCUFVCVFUGVDVGUHUITVBAUJM
      ZUSVAVIVEMUTVLVAURVLUSADJUKUOTTURUSVAULUTVAUMABCEFGHIUNUPUQ $.
  $}

  ${
    $d a c d e f H $.  $d e O $.  $d c d e f S $.  $d c d f U $.  $d a b z X $.
    $d a b c d e f x y z $.
    hsmexlem4.x $e |- X e. _V $.
    hsmexlem4.h $e |- H = ( rec ( ( z e. _V |-> ( har ` ~P ( X X. z ) ) ) ,
            ( har ` ~P X ) ) |` om ) $.
    hsmexlem4.u $e |- U = ( x e. _V |->
          ( rec ( ( y e. _V |-> U. y ) , x ) |` om ) ) $.
    hsmexlem4.s $e |- S = { a e. U. ( R1 " On ) |
          A. b e. ( TC ` { a } ) b ~<_ X } $.
    hsmexlem4.o $e |- O = OrdIso ( _E , ( rank " ( ( U ` d ) ` c ) ) ) $.
    $( Lemma for ~ hsmex .  The core induction, establishing bounds on the
       order types of iterated unions of the initial set.  (Contributed by
       Stefan O'Rear, 14-Feb-2015.) $)
    hsmexlem4 $p |- ( ( c e. om /\ d e. S ) -> dom O e. ( H ` c ) ) $=
      ( wcel cfv crnk ve vf cv com cdm wral c0 cima cep csuc wceq fveq2 imaeq2d
      coi oieq2 syl syl5eq dmeqd eleq12d ralbidv weq cpw char wss cwdom wbr crn
      con0 imassrn cr1 cuni wf rankf frn ax-mp cvv vex ituni0 imaeq2i wfun ffun
      sstri wdomimag mp2an cdom csn ctc sneq fveq2d raleqdv elrab2 simprbi snex
      wi tcid snid sselii breq1 rspcv domwdom 3syl wdomtr sylancr syl5eqbr eqid
      hsmexlem1 hsmexlem7 syl6eleqr rgen wa nfra1 nfv nfan ciun ituniiun imaiun
      eqtri dmeqi ad2antll hsmexlem9 ad2antrl crab ssrab2 eqsstri sseli r1elssi
      cxp sselda snssi tcss tcel mp1i sstrd ssralv mpan9 sylanbrc simpll fveq1d
      adantll eleq1d sylc fvex funimaex elpw mpbir ralrimiva hsmexlem3 syl21anc
      jctil syl5eqel hsmexlem8 eleqtrrd expr ralrimi expcom finds1 r19.21bi ) K
      UCZUDRGUEZUURFSZRZLDUVALDUFTUGLUCZESZSZUHZUIUNZUEZUGFSZRZLDUFTUAUCZUVCSZU
      HZUIUNZUEZUVJFSZRZLDUFZTUVJUJZUVCSZUHZUIUNZUEZUVRFSZRZLDUFZKUAUURUGUKZUVA
      UVILDUWFUUSUVGUUTUVHUWFGUVFUWFGTUURUVCSZUHZUIUNZUVFQUWFUWHUVEUKUWIUVFUKUW
      FUWGUVDTUURUGUVCULUMUWHUVEUIUOUPUQURUURUGFULUSUTKUAVAZUVAUVPLDUWJUUSUVNUU
      TUVOUWJGUVMUWJGUWIUVMQUWJUWHUVLUKUWIUVMUKUWJUWGUVKTUURUVJUVCULUMUWHUVLUIU
      OUPUQURUURUVJFULUSUTUURUVRUKZUVAUWDLDUWKUUSUWBUUTUWCUWKGUWAUWKGUWIUWAQUWK
      UWHUVTUKUWIUWAUKUWKUWGUVSTUURUVRUVCULUMUWHUVTUIUOUPUQURUURUVRFULUSUTUVILD
      UVBDRZUVGHVBVCSZUVHUWLUVEVHVDUVEHVEVFUVGUWMRUVETVGZVHTUVDVIVJVHUHVKZVHTVL
      ZUWNVHVDVMUWOVHTVNVOZWBUWLUVETUVBUHZHVEUVDUVBTUVBVPRZUVDUVBUKLVQZABUVBEVP
      OVRVOVSUWLUWRUVBVEVFZUVBHVEVFZUWRHVEVFTVTZUWSUXAUWPUXCVMUWOVHTWAVOZUWTUVB
      TVPWCWDUWLJUCZHWEVFZJUVBWFZWGSZUFZUVBHWEVFZUXBUWLUVBUWORZUXIUXFJIUCZWFZWG
      SZUFZUXIIUVBUWODILVAZUXFJUXNUXHUXPUXMUXGWGUXLUVBWHWIWJPWKWLZUVBUXHRUXIUXJ
      WNUXGUXHUVBUXGVPRUXGUXHVDUVBWMZUXGVPWOVOUVBUWTWPZWQUXFUXJJUVBUXHUXEUVBHWE
      WRWSVOUVBHWTXAZUWRUVBHXBXCXDUVEHUVFUVFXEXFXCCFHNXGXHXIUVQUVJUDRZUWEUVQUYA
      XJUWDLDUVQUYALUVPLDXKUYALXLXMUVQUYAUWLUWDUVQUYAUWLXJZXJZUWBHUVOYGVBVCSZUW
      CUYCUWBUBUVBTUVJUBUCZESZSZUHZXNZUIUNZUEZUYDUWAUYJUVTUYIUKUWAUYJUKUVTTUBUV
      BUYGXNZUHUYIUVSUYLTUWSUVSUYLUKUWTABUVBUVJEVPUBOXOVOVSUBTUVBUYGXPXQUVTUYIU
      IUOVOXRUYCUXBUVOVHRZUYHVHVBRZUYHUIUNZUEZUVORZXJZUBUVBUFUYKUYDRUWLUXBUVQUY
      AUXTXSUYAUYMUVQUWLCFHUANXTYAUYCUYRUBUVBUYCUYEUVBRZXJZUYQUYNUYTUYEDRZUVQUY
      QUYBUYSVUAUVQUWLUYSVUAUYAUWLUYSXJUYEUWORUXFJUYEWFZWGSZUFZVUAUWLUVBUWOUYEU
      WLUXKUVBUWOVDDUWOUVBDUXOIUWOYBUWOPUXOIUWOYCYDYEUVBYFUPYHUWLUXIUYSVUDUXQUY
      SVUCUXHVDUXIVUDWNUYSVUCUVBWGSZUXHUYSVUBUVBVDVUCVUEVDUYEUVBYIUVBVUBUWTYJUP
      UVBUXGRVUEUXHVDUYSUXSUXGUVBUXRYKYLYMUXFJVUCUXHYNUPYOUXOVUDIUYEUWODIUBVAZU
      XFJUXNVUCVUFUXMVUBWGUXLUYEWHWIWJPWKYPYSYSUVQUYBUYSYQUVPUYQLUYEDLUBVAZUVNU
      YPUVOVUGUVMUYOVUGUVLUYHUKUVMUYOUKVUGUVKUYGTVUGUVJUVCUYFUVBUYEEULYRUMUVLUY
      HUIUOUPURYTWSUUAUYNUYHVHVDUYHUWNVHTUYGVIUWQWBUYHVHUXCUYHVPRUXDTUYGUVJUYFU
      UBUUCVOUUDUUEUUIUUFUVBUYHUVOHUYOUYJUBUYOXEUYJXEUUGUUHUUJUYAUWCUYDUKUVQUWL
      CFHUANUUKYAUULUUMUUNUUOUUPUUQ $.

    $( Lemma for ~ hsmex .  Combining the above constraints, along with
       ~ itunitc and ~ tcrank , gives an effective constraint on the rank of
       ` S ` .  (Contributed by Stefan O'Rear, 14-Feb-2015.) $)
    hsmexlem5 $p |- ( d e. S -> ( rank ` d ) e.
          ( har ` ~P ( om X. U. ran H ) ) ) $=
      ( wcel com con0 crnk cfv cima ciun cep coi cdm crn cuni cxp cpw char cres
      cv cid ctc cr1 wceq cdom wbr csn wral ssrab2 eqsstri sseli tcrank syl wfn
      itunifn fniunfv itunitc syl6reqr imaeq2d imaiun a1i 3eqtrd dmresi syl6eqr
      crab word rankon syl6eqelr eloni oiid 3syl dmeqd eqtr4d cwdom wa cvv omex
      mp1i cmpt crdg frfnom fneq1i mpbir ax-mp fvex iunonOLD hsmexlem9 eqeltrri
      wdomref mprg fvssunirn eqid hsmexlem4 ancoms sseldi wss imassrn rankf frn
      wf sstri wfun ffun funimaex mp2b elpw jctil ralrimiva hsmexlem3 syl21anc
      eqeltrd ) LUNZDRZYFUAUBZKSUAKUNZYFEUBZUBZUCZUDZUEUFZUGZSFUHUIZUJUKULUBZYG
      YHUOYMUMZUGZYOYGYHYMYSYGYHUAYFUPUBZUCZUAKSYKUDZUCZYMYGYFUQTUCUIZRYHUUAURD
      UUDYFDJUNHUSUTJIUNZVAUPUBVBZIUUDVSUUDPUUFIUUDVCVDVEYFVFVGYGYTUUBUAYGUUBYJ
      UHUIZYTYGYJSVHUUBUUGURABYFEDOVIKSYJVJVGABYFEOVKVLVMUUCYMURYGKUASYKVNVOVPZ
      YMVQVRYGYNYRYGYMTRYMVTYNYRURYGYMYHTUUHYFWAWBYMWCYMWDWEWFWGYGSSWHUTZYPTRZY
      LTUKRZYLUEUFZUGZYPRZWIZKSVBYOYQRSWJRUUIYGWKWJSXCWLUUJYGISUUEFUBZUDZYPTFSV
      HZUUQYPURUURCWJHCUNUJUKULUBWMZHUKULUBZWNSUMZSVHUUTUUSWOSFUVANWPWQISFVJWRU
      UPTRUUQTRISISUUPWKUUEFWSWTCFHINXAXDXBVOYGUUOKSYGYISRZWIZUUNUUKUVCYIFUBZYP
      UUMFYIXEUVBYGUUMUVDRABCDEFUULHIJKLMNOPUULXFZXGXHXIUUKYLTXJYLUAUHZTUAYKXKU
      UDTUAXNZUVFTXJXLUUDTUAXMWRXOYLTUVGUAXPYLWJRXLUUDTUAXQUAYKYIYJWSXRXSXTWQYA
      YBSYLYPSUULYNKUVEYNXFYCYDYE $.

    $( Lemmr for ~ hsmex .  (Contributed by Stefan O'Rear, 14-Feb-2015.) $)
    hsmexlem6 $p |- S e. _V $=
      ( cr1 wcel con0 com crn cuni cxp cpw char cfv fvex cv crnk hsmexlem5 cima
      cdm cdom wbr csn ctc wral crab ssrab2 eqsstri sseli harcl wfn wceq r1fnon
      wb fndm ax-mp eleqtrri rankr1ag sylancl mpbird ssriv ssexi ) DUAFUBUCUDUE
      ZUFUGZRUGZVQRUHLDVRLUIZDSZVSVRSZVSUJUGVQSZABCDEFGHIJKLMNOPQUKVTVSRTULUCZS
      VQRUMZSWAWBVGDWCVSDJUIHUNUOJIUIUPUQUGURZIWCUSWCPWEIWCUTVAVBVQTWDVPVCRTVDW
      DTVEVFTRVHVIVJVSVQVKVLVMVNVO $.
  $}

  ${
    $d a b c d e f s x y z X $.
    $( The collection of hereditarily size-limited well-founded sets comprise a
       set.  The proof is that of Randall Holmes at
       ~ http://math.boisestate.edu/~~holmes/holmes/hereditary.pdf , with
       modifications to use Hartogs' theorem instead of the weak variant
       (inconsequentially weakening some intermediate results), and making the
       well-foundedness condition explicit to avoid a direct dependence on
       ~ ax-reg .  (Contributed by Stefan O'Rear, 14-Feb-2015.) $)
    hsmex $p |- ( X e. V -> { s e. U. ( R1 " On ) |
            A. x e. ( TC ` { s } ) x ~<_ X } e. _V ) $=
      ( va vb vc vd ve vf cv cdom cfv cuni cvv wceq cmpt crdg com cres wbr wral
      vy vz csn ctc cr1 con0 cima crab wcel ralbidv rabbidv eleq1d cxp cpw char
      breq2 crnk cep coi vex rdgeq2 unieq cbvmptv rdgeq1 ax-mp syl6eq hsmexlem6
      eqid reseq1d vtoclg ) AKZEKZLUAZADKUEUFMZUBZDUGUHUINZUJZOUKVMCLUAZAVPUBZD
      VRUJZOUKECBVNCPZVSWBOWCVQWADVRWCVOVTAVPVNCVMLURULUMUNFGHVSIOJOJKZNZQZIKZR
      ZSTZQZHOVNHKUOUPUQMQVNUPUQMRSTZUSUCKUDKWJMMUIUTVAZVNDAUCUDEVBWKVJIFOWIGOG
      KZNZQZFKZRZSTWGWPPZWHWQSWRWHWFWPRZWQWGWPWFVCWFWOPWSWQPJGOWEWNWDWMVDVEWPWF
      WOVFVGVHVKVEVSVJWLVJVIVL $.

    $( The set of hereditary size-limited sets, assuming ~ ax-reg .
       (Contributed by Stefan O'Rear, 11-Feb-2015.) $)
    hsmex2 $p |- ( X e. V -> { s | A. x e. ( TC ` { s } ) x ~<_ X } e. _V ) $=
      ( wcel cv cdom wbr csn ctc cfv wral cab cr1 con0 cima cuni crab cvv wceq
      unir1 rabeq ax-mp rabab eqtr2i hsmex syl5eqel ) CBEAFCGHADFIJKLZDMZUHDNOP
      QZRZSUKUHDSRZUIUJSTUKULTUAUHDUJSUBUCUHDUDUEABCDUFUG $.

    $( The set of hereditary size-limited sets, assuming ~ ax-reg , using
       strict comparison (an easy corrolary by separation).  (Contributed by
       Stefan O'Rear, 11-Feb-2015.) $)
    hsmex3 $p |- ( X e. V -> { s | A. x e. ( TC ` { s } ) x ~< X } e. _V ) $=
      ( wcel cv csdm wbr csn ctc cfv wral cab cdom wss cvv ralimi ss2abi hsmex2
      sdomdom ssexg sylancr ) CBEAFZCGHZADFIJKZLZDMZUCCNHZAUELZDMZOUJPEUGPEUFUI
      DUDUHAUEUCCTQRABCDSUGUJPUAUB $.
  $}


$(
###############################################################################
             ZFC (ZERMELO-FRAENKEL WITH CHOICE) SET THEORY
###############################################################################

  In this section we add the Axiom of Choice ~ ax-ac , as well as weaker forms
  such as the axiom of countable choice ~ ax-cc and dependent choice ~ ax-dc .
  We introduce these weaker forms so that theorems that do not need the full
  power of the axiom of choice, but need more than simple ZF, can use these
  intermediate axioms instead.

  The combination of the Zermel-Fraenkel axioms and the axiom of choice is
  often abbreviated as ZFC.  The axiom of choice is widely accepted, and ZFC is
  the most commonly-accepted fundamental set of axioms for mathematics.

  However, there have been and still are some lingering controversies about the
  Axiom of Choice.  The axiom of choice does not satisfy those who wish to have
  a constructive proof (e.g., it will not satify intuitionist logic).  Thus, we
  make it easy to identify which proofs depend on the axiom of choice or its
  weaker forms.

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZFC Set Theory - add Countable Choice and Dependent Choice
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Introduce the Axiom of Countable Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f n x z y $.
    $( The axiom of countable choice (CC), also known as the axiom of
       denumerable choice.  It is clearly a special case of ~ ac5 , but is weak
       enough that it can be proven using DC (see ~ axcc ).  It is, however,
       strictly stronger than ZF and cannot be proven in ZF. It states that any
       countable collection of non-empty sets must have a choice function.
       (Contributed by Mario Carneiro, 9-Feb-2013.) $)
    ax-cc $a |- ( x ~~ om ->
       E. f A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) ) $.
  $}

  ${
    $d A a f z $.  $d A k n $.  $d A f n s t $.  $d F f g $.  $d G g n $.
    $d K n s t $.  $d n z $.
    axcc2lem.1 $e |- K = ( n e. om |->
                       if ( ( F ` n ) = (/) , { (/) } , ( F ` n ) ) ) $.
    axcc2lem.2 $e |- A = ( n e. om |-> ( { n } X. ( K ` n ) ) ) $.
    axcc2lem.3 $e |- G = ( n e. om |-> ( 2nd ` ( f ` ( A ` n ) ) ) ) $.
    $( Lemma for ~ axcc2 .  (Contributed by Mario Carneiro, 8-Feb-2013.) $)
    axcc2lem $p |- E. g ( g Fn om /\ A. n e. om
                    ( ( F ` n ) =/= (/) -> ( g ` n ) e. ( F ` n ) ) ) $=
      ( vz c0 wne cfv wcel wi com wa cvv wceq vk va cv crn wral wex wfn wf1 cen
      wbr wf omex csn cxp snex fvex xpex fmptd ax-mp sneq fveq2 xpeq12d fvmpt3i
      a1i adantl eqeq2d fvmpt2 mpan2 adantr eqeq1d wb vex cif 0ex iftrue neeq1d
      snnz mpbiri wn iffalse df-ne biimpri eqnetrd pm2.61i p0ex ifex xp11 sneqr
      sylancr syl6bi sylbid rgen2a dff13 mpbir2an wf1o f1f1orn f1oen ensym 3syl
      cmpt rneqi cdm wfun dmmptg mprg eqeltri funmpt funrnex breq1 raleq exbidv
      mp2 imbi12d ax-cc vtocl mp2b c2nd fnmpti w3a xpnz biimpi fnfvelrn mpan id
      neeq1 eleq12d rspccv syl5 mpdi impcom eleq2d mpbid xp2nd 3adant3 3ad2ant1
      syl eqcomd ifnefalse 3ad2ant3 eqtrd 3eltr3d 3expia fnex mp2an fneq1 fveq1
      expcom ralrimiv eleq1d imbi2d ralbidv anbi12d spcev exlimiv ) KUCZLMZUUOB
      UCZNZUUOOZPZKAUDZUEZBUFZCUCZQUGZDUCZENZLMZUVFUVDNZUVGOZPZDQUEZRZCUFZQSAUH
      ZUVAQUIUJZUVCUVOQSAUKZUVFANZUAUCZANZTZUVFUVSTZPZUAQUEDQUEQSOZUVQULUWDDQUV
      FUMZUVFGNZUNZSAUWGSOZUWDUVFQOZRUWEUWFUVFUOUVFGUPUQZVDIURUSUWCDUAQUWIUVSQO
      ZRZUWAUVRUVSUMZUVSGNZUNZTZUWBUWLUVTUWOUVRUWKUVTUWOTUWIDUVSUWGUWOQAUWBUWEU
      WMUWFUWNUVFUVSUTUVFUVSGVAVBIUWJVCVEVFUWLUWPUWGUWOTZUWBUWLUVRUWGUWOUWIUVRU
      WGTZUWKUWIUWHUWRUWJDQUWGSAIVGVHZVIVJUWIUWQUWBPUWKUWIUWQUWEUWMTZUWFUWNTZRZ
      UWBUWIUWELMZUWFLMZUWQUXBVKUVFDVLZVQZUWIUXDUVGLTZLUMZUVGVMZLMZUXGUXJUXGUXJ
      UXHLMLVNVQUXGUXIUXHLUXGUXHUVGVOVPVRUXGVSZUXIUVGLUXGUXHUVGVTUVHUXKUVGLWAWB
      WCWDUWIUWFUXILUWIUXISOUWFUXITZUXGUXHUVGWEUVFEUPWFDQUXISGHVGVHZVPVRZUWEUWF
      UWMUWNWGWIUWTUWBUXAUVFUVSUXEWHVIWJVIWKWKWLDUAQSAWMWNUVOQUVAAWOQUVAUIUJUVP
      QSAWPQUVAAULWQQUVAWRWSUBUCZQUIUJZUUTKUXOUEZBUFZPUVPUVCPUBUVAUVADQUWGWTZUD
      ZSAUXSIXAUXSXBZSOUXSXCUXTSOUYAQSUWHUYAQTDQDQUWGSXDUWHUWIUWJVDXEULXFDQUWGX
      GSUXSXHXLXFUXOUVATZUXPUVPUXRUVCUXOUVAQUIXIUYBUXQUVBBUUTKUXOUVAXJXKXMUBKBX
      NXOXPUVBUVNBUVBFQUGZUVHUVFFNZUVGOZPZDQUEZUVNDQUVRUUQNZXQNZFUYHXQUPZJXRZUV
      BUYFDQUWIUVBUYFUWIUVBUVHUYEUWIUVBUVHXSZUYIUWFUYDUVGUWIUVBUYIUWFOZUVHUWIUV
      BRZUYHUWGOZUYMUYNUYHUVROZUYOUVBUWIUYPUVBUWIUVRLMZUYPUWIUVRUWGLUWSUWIUXCUX
      DUWGLMZUXFUXNUXCUXDRUYRUWEUWFXTYAWIWCUWIUVRUVAOZUVBUYQUYPPZAQUGUWIUYSDQUW
      GAUWJIXRQUVFAYBYCUUTUYTKUVRUVAUUOUVRTZUUPUYQUUSUYPUUOUVRLYEVUAUURUYHUUOUV
      RUUOUVRUUQVAVUAYDYFXMYGYHYIYJUWIUYPUYOVKUVBUWIUVRUWGUYHUWSYKVIYLUYHUWEUWF
      YMYPYNUYLUYDUYIUWIUVBUYDUYITZUVHUWIUYISOVUBUYJDQUYISFJVGVHYOYQUYLUWFUXIUV
      GUWIUVBUXLUVHUXMYOUVHUWIUXIUVGTUVBUVGLUXHUVGYRYSYTUUAUUBUUGUUHUVMUYCUYGRC
      FUYCUWDFSOUYKULQSFUUCUUDUVDFTZUVEUYCUVLUYGQUVDFUUEVUCUVKUYFDQVUCUVJUYEUVH
      VUCUVIUYDUVGUVFUVDFUUFUUIUUJUUKUULUUMWIUUNUS $.
  $}

  ${
    $d F f g m n $.  $d F f m n x $.
    $( A possibly more useful version of ax-cc using sequences instead of
       countable sets.  The Axiom of Infinity is needed to prove this, and
       indeed this implies the Axiom of Infinity.  (Contributed by Mario
       Carneiro, 8-Feb-2013.) $)
    axcc2 $p |- E. g ( g Fn om /\ A. n e. om
                    ( ( F ` n ) =/= (/) -> ( g ` n ) e. ( F ` n ) ) ) $=
      ( vm vf com cv csn cfv c0 wceq cif cmpt cxp c2nd nfcv fveq2 nffvmpt1 nffv
      cbvmpt eqeq1d ifbieq2d nfxp sneq xpeq12d fveq2d axcc2lem ) DFDGZHZUHDFUHC
      IZJKZJHZUJLZMZIZNZMZEABCDFUHUQIZEGZIZOIZMUNDBFUMBGZCIZJKZULVCLZBUMPDVEPUH
      VBKZUKVDUJVCULVFUJVCJUHVBCQZUAVGUBTDBFUPVBHZVBUNIZNBUPPDVHVIDVHPDFUMVBRUC
      VFUIVHUOVIUHVBUDUHVBUNQUETDBFVAVBUQIZUSIZOIBVAPDVKODOPDVJUSDUSPDFUPVBRSSV
      FUTVKOVFURVJUSUHVBUQQUFUFTUG $.
  $}

  ${
    $d F f g h k m $.  $d N f g h k m n $.
    axcc3.1 $e |- F e. _V $.
    axcc3.2 $e |- N ~~ om $.
    $( A possibly more useful version of ~ ax-cc using sequences ` F ( n ) `
       instead of countable sets.  The Axiom of Infinity is needed to prove
       this, and indeed this implies the Axiom of Infinity.  (Contributed by
       Mario Carneiro, 8-Feb-2013.)  (Revised by Mario Carneiro,
       26-Dec-2014.) $)
    axcc3 $p |- E. f ( f Fn N /\ A. n e. N
                    ( F =/= (/) -> ( f ` n ) e. F ) ) $=
      ( vh vg vm cv wfn c0 wne cfv wcel wi wa com cvv wceq vk wral wex cmpt cen
      wbr relen brrelexi mptexg mp2b wf1o bren mpbi ccnv ccom axcc2 w3a wf f1of
      fnfco sylan2 adantlr 3adant1 nfmpt1 nfeq2 nf3an ffvelrnda eleq12d imbi12d
      nfv fveq2 neeq1d rspcv syl 3ad2antl3 f1ocnv fvco3 syldan f1ocnvfv1 fveq2d
      sylan fveq1 fvmpt2 mpan2 sylan9eq 3adant2 3eqtrd 3adantl2 3ad2ant3 eleq1d
      eqid 3expa eleq2d bitr3d sylibd com23 3exp com34 imp32 3impia ralrimi vex
      ex coex fneq1 imbi2d ralbidv anbi12d spcev syl2anc exlimdv mpi vtocle ) A
      JZDKZCLMZBJZXNNZCOZPZBDUBZQZAUCZUABDCUDZDRUEUFZDSOYDSOFDRUEUGUHBDCSUIUJUA
      JZYDTZDRGJZUKZGUCZYCYEYJFDRGULUMYGYIYCGYGHJZRKZIJZYFYHUNZUOZNZLMZYMYKNZYP
      OZPZIRUBZQZHUCYIYCPZHIYOUPYGUUBUUCHYGUUBYIYCYGUUBYIUQZYKYHUOZDKZXPXQUUENZ
      COZPZBDUBZYCUUBYIUUFYGYLYIUUFUUAYIYLDRYHURZUUFDRYHUSZRDYKYHUTVAVBVCUUDUUI
      BDYGUUBYIBBYFYDBDCVDVEUUBBVJYIBVJVFYGUUBYIXQDOZUUIPZYGYLUUAYIUUNPYGYLYIUU
      AUUNYGYLYIUUAUUNPYGYLYIUQZUUMUUAUUIUUOUUMUUAUUIPUUOUUMQZUUAXQYHNZYONZLMZU
      UQYKNZUUROZPZUUIYIYGUUMUUAUVBPZYLYIUUMQZUUQROZUVCYIDRXQYHUULVGZYTUVBIUUQR
      YMUUQTZYQUUSYSUVAUVGYPUURLYMUUQYOVKZVLUVGYRUUTYPUURYMUUQYKVKUVHVHVIVMVNVO
      UUPUUSXPUVAUUHUUPUURCLYGYIUUMUURCTZYLYGYIUUMUVIYGYIUUMUQUURUUQYNNZYFNZXQY
      FNZCYIUUMUURUVKTZYGYIUUMUVEUVMUVFYIRDYNURZUVEUVMYIRDYNUKUVNDRYHVPRDYNUSVN
      RDUUQYFYNVQWAVRVCYIUUMUVKUVLTYGUVDUVJXQYFDRXQYHVSVTVCYGUUMUVLCTYIYGUUMUVL
      XQYDNZCXQYFYDWBUUMCSOUVOCTEBDCSYDYDWKWCWDWEWFWGWLWHZVLUUPUUGUUROUVAUUHUUP
      UUGUUTUURUUOUUKUUMUUGUUTTYIYGUUKYLUULWIDRXQYKYHVQWAWJUUPUURCUUGUVPWMWNVIW
      OXCWPWQWRWSWTXAYBUUFUUJQAUUEYKYHHXBGXBXDXNUUETZXOUUFYAUUJDXNUUEXEUVQXTUUI
      BDUVQXSUUHXPUVQXRUUGCXQXNUUEWBWJXFXGXHXIXJWQXKXLXKXLXM $.
  $}

  ${
    $d A f n x $.  $d N f n $.  $d f ph $.  $d ps x $.
    axcc4.1 $e |- A e. _V $.
    axcc4.2 $e |- N ~~ om $.
    axcc4.3 $e |- ( x = ( f ` n ) -> ( ph <-> ps ) ) $.
    $( A version of ~ axcc3 that uses wffs instead of classes.  (Contributed by
       Mario Carneiro, 7-Apr-2013.) $)
    axcc4 $p |- ( A. n e. N E. x e. A ph ->
                    E. f ( f : N --> A /\ A. n e. N ps ) ) $=
      ( wrex wral cv wfn wcel wi wa wex ralimi syl6 crab c0 wne cfv rabex axcc3
      rabn0 pm2.27 sylbir elrab syl6ib ral2imi simpl anim2d ffnfv syl6ibr simpr
      wf adantld jcad eximdv mpi ) ACDKZFGLZEMZGNZACDUAZUBUCZFMVEUDZVGOZPZFGLZQ
      ZERGDVEURZBFGLZQZEREFVGGACDHUEIUFVDVMVPEVDVMVNVOVDVMVFVIDOZFGLZQVNVDVLVRV
      FVDVLVQBQZFGLZVRVCVKVSFGVCVKVJVSVCVHVKVJPACDUGVHVJUHUIABCVIDJUJUKULZVSVQF
      GVQBUMSTUNFGDVEUOUPVDVLVOVFVDVLVTVOWAVSBFGVQBUQSTUSUTVAVB $.
  $}

  ${
    $d f g x y $.
    $( An ~ ax-cc equivalent: every set has choice sets of length ` om ` .
       (Contributed by Mario Carneiro, 31-Aug-2015.) $)
    acncc $p |- AC_ om = _V $=
      ( vx vy vg vf com wacn cvv cv wcel cfv wral wex cpw c0 cdif cmap co wb wa
      csn vex isacn mp2an wfn wne wi axcc2 wf elmapi ffvelrn eldifsni syl sylan
      omex id syl5com ralimdva adantld eximdv mpi mprgbir 2th eqriv ) AEFZGAHZV
      DIZVEGIZVFBHZCHZJVHDHZJZIZBEKZCLZDVEMZNTOZEPQZVGEGIVFVNDVQKRAUAZUNBEDCGGV
      EUBUCVJVQIZVIEUDZVKNUEZVLUFZBEKZSZCLVNCBVJUGVSWDVMCVSWCVMVTVSWBVLBEVSVHEI
      ZSWAWBVLVSEVPVJUHZWEWAVJVPEUIWFWESVKVPIWAEVPVHVJUJVKVONUKULUMWBUOUPUQURUS
      UTVAVRVBVC $.
  $}

  ${
    $d A f n x $.  $d N f n $.  $d f ph $.  $d ps x $.
    axcc4dom.1 $e |- A e. _V $.
    axcc4dom.2 $e |- ( x = ( f ` n ) -> ( ph <-> ps ) ) $.
    $( Relax the constraint on ~ axcc4 to dominance instead of equinumerosity.
       (Contributed by Mario Carneiro, 18-Jan-2014.) $)
    axcc4dom $p |- ( ( N ~<_ om /\ A. n e. N E. x e. A ph ) ->
                    E. f ( f : N --> A /\ A. n e. N ps ) ) $=
      ( com cdom wbr wral wf wa wex cen wi raleq breq1 wrex cv csdm brdom2 wcel
      wo cfn isfinite ac6sfi ex sylbir cif wceq feq2 anbi12d imbi12d omex enref
      exbidv elimhyp axcc4 dedth jaoi sylbi imp ) GJKLZACDUAZFGMZGDEUBZNZBFGMZO
      ZEPZVFGJUCLZGJQLZUFVHVMRZGJUDVNVPVOVNGUGUEZVPGUHVQVHVMABFCGDEIUIUJUKVOVPV
      GFVOGJULZMZVRDVINZBFVRMZOZEPZRGJGVRUMZVHVSVMWCVGFGVRSWDVLWBEWDVJVTVKWAGVR
      DVIUNBFGVRSUOUSUPABCDEFVRHVOVRJQLJJQLGJGVRJQTJVRJQTJUQURUTIVAVBVCVDVE $.
  $}

  ${
    $d A b c n $.  $d A m n y $.  $d B b c $.  $d C c k n $.  $d b j k n $.
    $d b n y $.  $d n z $.
    domtriomlem.1 $e |- A e. _V $.
    domtriomlem.2 $e |- B = { y | ( y C_ A /\ y ~~ ~P n ) } $.
    domtriomlem.3 $e |- C = ( n e. om |->
                              ( ( b ` n ) \ U_ k e. n ( b ` k ) ) ) $.
    $( Lemma for ~ domtriom .  (Contributed by Mario Carneiro, 9-Feb-2013.) $)
    domtriomlem $p |- ( -. A e. Fin -> om ~<_ A ) $=
      ( vc wcel cv com wral wex wbr wi wa cen vm vj cfn wn cfv cdom wfn wne wss
      c0 cpw cab cvv pwex simpl ss2abi df-pw sseqtr4i ssexi eqeltri enref axcc3
      omex nfv nfra1 nfan ccrd nnfi pwfi sylib ficardom isinf wceq breq2 anbi2d
      exbidv rspcv syl5 3syl finnum cardid2 entr expcom 4syl anim2d eximdv syld
      cdm neeq1i abn0 bitri syl6ibr com12 adantr rsp adantl mpdd ralrimi 3expib
      3adant2 mpi axcc2 w3a simp2 fvex sseq1 breq1 anbi12d elab2 simprbi ralimi
      ciun cdif weq pweq breq12d cbvralv csdm csuc peano2 omelon onelssi ssralv
      fveq2 pwsdompw ex eldifi syl6bi sseld imp sylanbrc wel nnord syl 3ad2ant3
      word eleq1 3impib pm2.21dd 3exp sdomdif syl5bi difss fvmpt2 mpan2 sylibrd
      syl6 neeq1d syl5com jca wf1 wf eleq2d simplbi com23 com13 ffnfv ordtri3or
      syl9 syl2an mpbidi cbviunv iuneq1 syl5eq difeq12d eleq12d rspccv 3ad2ant1
      w3o syl5ib ssiun2 3ad2ant2 eldifbd 3adant1 ax-1 ssiun2s eldifn 3imp 3jaoi
      a1d a1i 3expia mpid com3r exp3a ralrimd ralrimiv dff13 19.8a brdom sylibr
      exlimdv mpd exlimiv ) BUCLUDZFMZGMZUEZCLZFNOZGPZNBUFQZUWOUWQNUGZCUJUHZUWS
      RZFNOZSZGPUXAGFCNCAMZBUIZUXHUWPUKZTQZSZAULZUMIUXMBUKZBHUNUXMUXIAULUXNUXLU
      XIAUXIUXKUOUPABUQURUSUTNVCVAVBUWOUXGUWTGUWOUXCUXFUWTUWOUXFUWTUXCUWOUXFSZU
      WSFNUWOUXFFUWOFVDUXEFNVEVFUXOUWPNLZUXDUWSUWOUXPUXDRUXFUXPUWOUXDUXPUWOUXLA
      PZUXDUXPUWOUXIUXHUXJVGUEZTQZSZAPZUXQUXPUXJUCLZUXRNLZUWOUYARUXPUWPUCLUYBUW
      PVHUWPVIVJZUXJVKUWOUXIUXHUAMZTQZSZAPZUANOUYCUYAABUAVLUYHUYAUAUXRNUYEUXRVM
      ZUYGUXTAUYIUYFUXSUXIUYEUXRUXHTVNVOVPVQVRVSUXPUXTUXLAUXPUXSUXKUXIUXPUYBUXJ
      VGWHLUXRUXJTQZUXSUXKRUYDUXJVTUXJWAUXSUYJUXKUXHUXRUXJWBWCWDWEWFWGUXDUXMUJU
      HUXQCUXMUJIWIUXLAWJWKWLWMWNUXFUXPUXERUWOUXEFNWOWPWQWRWTWSWFXAUWTUXBGUWTKM
      ZNUGZUWPUYKUEZUWPDUEZLZFNOZSZKPZUXBUWTUYLUYNUJUHZUYORZFNOZSZKPUYRKFDXBUWT
      VUBUYQKUWTUYLVUAUYQUWTUYLVUAXCUYLUYPUWTUYLVUAXDUWTVUAUYPUYLUWTVUASZUYOFNU
      WTVUAFUWSFNVEZUYTFNVEVFVUCUXPUYSUYOUWTUXPUYSRVUAUWTUWRUXJTQZFNOZUXPUYSUWS
      VUEFNUWSUWRBUIZVUEUXLVUGVUESAUWRCUWPUWQXEZUXHUWRVMUXIVUGUXKVUEUXHUWRBXFUX
      HUWRUXJTXGXHIXIZXJXKUXPVUFUWREUWPEMZUWQUEZXLZXMZUJUHZUYSVUFVUKVUJUKZTQZEN
      OZUXPVUNVUEVUPFENFEXNZUWRVUKUXJVUOTUWPVUJUWQYDZUWPVUJXOXPXQUXPVUQVULUWRXR
      QZVUNUXPVUQVUPEUWPXSZOZVUTUXPVVANLVVANUIVUQVVBRUWPXTNVVAYAYBVUPEVVANYCVSU
      XPVVBVUTUWQEFYEYFWGVULUWRUUAUUGUUBUXPUYNVUMUJUXPVUMUMLUYNVUMVMVUMUWRVUHUW
      RVULUUCUSFNVUMUMDJUUDUUEZUUHUUFUUIWNVUAUXPUYTRUWTUYTFNWOWPWQWRWTUUJWSWFXA
      UWTUYQUXBKUWTUYLUYPUXBUWTUYLUYPXCZNBUYKUUKZKPZUXBVVDVVEVVFVVDNBUYKUULZVUJ
      UYKUEZUYMVMZEFXNZRZFNOZENOZVVEVVDUYLUYMBLZFNOZVVGUWTUYLUYPXDUWTUYPVVOUYLU
      WTUYPSVVNFNUWTUYPFVUDUYOFNVEZVFUWTUYPUXPVVNRUXPUYPUWTVVNUXPUYPUYOUWTVVNRU
      YPUXPUYOUYOFNWOZWMUXPUWTUYOVVNUXPUWTUWSUYOVVNRUWTUXPUWSUWSFNWOWMUXPUYOUYM
      UWRLZUWSVVNUXPUYOUYMVUMLZVVRUXPUYNVUMUYMVVCUUMZUYMUWRVULYGZYHUWSUWRBUYMUW
      SVUGVUEVUIUUNYIUUSWGUUOWGUUPYJWRWTFNBUYKUUQYKUYPUWTVVMUYLUYPVVLENUYPVUJNL
      ZVVKFNVVPVWBFVDUYPVWBUXPVVKVWBUXPSZVVIUYPVVJVWCVVIEFYLZVVJFEYLZUVIZUYPVVJ
      RZVWBVUJYPUWPYPVWFUXPVUJYMUWPYMVUJUWPUURUUTVWBUXPVVIVWFVWGRVWFVWBUXPVVIXC
      ZVWGVWDVWHVWGRVVJVWEVWDVWHUYPVVJVWDVWHUYPXCUYMVULLZVVJVWDVWHUYPVWIVWHUYPS
      ZUYMVUKLZVWDVWIVWHUYPVWKVWHUYPVVHVUKUBVUJUBMZUWQUEZXLZXMZLZVWKVWBUXPUYPVW
      PRVVIUYPVWBVWPUYPVVSFNOVWBVWPRUYPVVSFNVVPUXPUYOVVSUYPVVQVVTUVAZWRVVSVWPFV
      UJNVURUYMVVHVUMVWOUWPVUJUYKYDVURUWRVUKVULVWNVUSVURVULUBUWPVWMXLVWNEUBUWPV
      UKVWMVUJVWLUWQYDUVBUBUWPVUJVWMUVCUVDUVEUVFUVGYNWMUVHZVVIVWBVWPVWKRUXPVWPV
      VHVUKLVVIVWKVVHVUKVWNYGVVHUYMVUKYQUVJYOWGYJVWDVUKVULUYMEUWPVUKUVKYIVRYRVW
      HUYPVWIUDVWDVWJUYMUWRVULVWHUYPVVSUXPVWBUYPVVSRVVIUYPUXPVVSVWQWMUVLYJZUVMU
      VNYSYTVVJVWGVWHVVJUYPUVOUVTVWEVWHUYPVVJVWEVWHUYPXCUYMVWNLZVVJVWEVWHUYPVWT
      VWJVVSVWEVWTVWSVVSVVRVWEVWTVWAVWEUWRVWNUYMUBVUJVWMUWPUWRVWLUWPUWQYDUVPYIV
      RVRYRVWEVWHUYPVWTUDZVWHUYPVXARRVWEVWHUYPVWPVXAVWRVVIVWBVWPVXARUXPVVIVWPUY
      MVWOLVXAVVHUYMVWOYQUYMVUKVWNUVQYHYOWGUWAUVRYSYTUVSWMUWBUWCUWDUWEUWFUWGYOE
      FNBUYKUWHYKVVEKUWIYNNBKHUWJUWKWSUWLUWMUWNYN $.
  $}

  ${
    $d A b n y $.  $d b j k m n y $.
    domtriom.1 $e |- A e. _V $.
    $( Trichotomy of equinumerosity for ` om ` , proven using CC. Equivalently,
       all Dedekind-finite sets (as in ~ isfin4-2 ) are finite in the usual
       sense and conversely.  (Contributed by Mario Carneiro, 9-Feb-2013.) $)
    domtriom $p |- ( om ~<_ A <-> -. A ~< om ) $=
      ( vy vn vm vb vj vk com cdom wbr csdm wn domnsym cfn cfv ciun cdif fveq2
      cv wcel isfinite wss cpw cen wa cab cmpt eqid weq cbviunv iuneq1 difeq12d
      syl5eq cbvmptv domtriomlem sylnbir impbii ) IAJKZAILKZMIANUTAOUAUSAUBCACT
      ZAUCVADTZUDUEKUFCUGZEIETZFTZPZGVDGTZVEPZQZRZUHHDFBVCUIEDIVJVBVEPZHVBHTZVE
      PZQZREDUJZVFVKVIVNVDVBVESVOVIHVDVMQVNGHVDVHVMVGVLVESUKHVDVBVMULUNUMUOUPUQ
      UR $.
  $}

  ${
    $d A b n y $.  $d b j k m n y $.
    $( Under countable choice, the IV-finite sets (Dedekind-finite) coincide
       with I-finite (finite in the usual sense) sets.  (Contributed by Mario
       Carneiro, 16-May-2015.) $)
    fin41 $p |- Fin4 = Fin $=
      ( vx cfin4 cfn cv com csdm wbr cdom wn wcel vex domtriom con2bii isfinite
      cvv wb isfin4-2 ax-mp 3bitr4ri eqriv ) ABCADZEFGZEUAHGZIZUACJUABJZUCUBUAA
      KZLMUANUAOJUEUDPUFUAOQRST $.
  $}

  ${
    $d x y z w A $.
    dominf.1 $e |- A e. _V $.
    $( A nonempty set that is a subset of its union is infinite.  This version
       is proved from ~ ax-cc .  See ~ dominfac for a version proved from
       ~ ax-ac .  The axiom of Regularity is used for this proof, via
       ~ inf3lem6 , and its use is necessary: otherwise the set ` A = { A } `
       or ` A = { (/) , A } ` (where the second example even has nonempty
       well-founded part) provides a counterexample.  (Contributed by Mario
       Carneiro, 9-Feb-2013.) $)
    dominf $p |- ( ( A =/= (/) /\ A C_ U. A ) -> om ~<_ A ) $=
      ( vx vy vw cv c0 wne cuni wss wa com cdom wbr wi eqid csdm wn cfn wcel id
      wceq neeq1 unieq sseq12d anbi12d breq2 imbi12d cpw cvv cin crab cmpt crdg
      cres wf1 inf3lem6 vex pwex f1dom biimpi isfinite 3imtr3i domtriom 3imtr4i
      pwfi con3i 3syl vtocl ) CFZGHZVJVJIZJZKZLVJMNZOAGHZAAIZJZKZLAMNZOCABVJAUB
      ZVNVSVOVTWAVKVPVMVRVJAGUCWAVJAVLVQWAUAVJAUDUEUFVJALMUGUHVNLVJUIZDUJEFVJUK
      DFJEVJULUMZGUNLUOZUPLWBMNZVOCDEAAWDWCWCPWDPBBUQLWBWDVJCURZUSZUTWBLQNZRVJL
      QNZRWEVOWIWHVJSTZWBSTZWIWHWJWKVJVFVAVJVBWBVBVCVGWBWGVDVJWFVDVEVHVI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Introduce the Axiom of Dependent Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f n x y z $.
    $( Dependent Choice.  Axiom DC1 of [Schechter] p. 149.  This theorem is
       weaker than the Axiom of Choice but is stronger than Countable Choice.
       It shows the existence of a sequence whose values can only be shown to
       exist (but cannot be constructed explicitly) and also depend on earlier
       values in the sequence.  Dependent choice is equivalent to the statement
       that every (nonempty) pruned tree has a branch.  This axiom is redundant
       in ZFC; see ~ axdc .  But ZF+DC is strictly weaker than ZF+AC, so this
       axiom provides for theorems that do not need the full power of AC.
       (Contributed by Mario Carneiro, 25-Jan-2013.) $)
    ax-dc $a |- ( ( E. y E. z y x z /\ ran x C_ dom x ) ->
                  E. f A. n e. om ( f ` n ) x ( f ` suc n ) ) $.
  $}

  ${
    $d s t $.  $d s t x $.  $d f x $.  $d f n s t x $.
    $( The Axiom of Dependent Choice implies Infinity, the way we have stated
       it.  Thus, we have _Inf+AC_ implies _DC_ and _DC_ implies _Inf_, but
       _AC_ does not imply _Inf_.  (Contributed by Mario Carneiro,
       25-Jan-2013.) $)
    dcomex $p |- om e. _V $=
      ( vn vf vs vt vx cv cfv c1o cop csn wbr com wral wex wcel crn cdm wss syl
      wceq csuc cvv wa wi snex wb con0 1on elexi fvsn wfun snid dmsnop eleqtrri
      funsn funbrfvb mp2an mpbi breq12 spc2ev ax-mp breq 2exbidv mpbiri 3sstr4i
      ssid rnsnop rneq dmeq sseq12d pm5.5 syl2anc ralbidv exbidv bitrd ax-dc c0
      vtocl wne 1n0 df-br elsni fvex opth1 sylbi tz6.12i mpsyl vex breldm dfss3
      ralimi sylibr dmex ssex exlimiv ) AFZBFZGZWPUAZWQGZHHIZJZKZALMZBNZLUBOZCF
      ZDFZEFZKZDNCNZXIPZXIQZRZUCZWRWTXIKZALMZBNZUDZXEEXBXAUEXIXBTZXSXRXEXTXKXNX
      SXRUFXTXKXGXHXBKZDNCNZHHXBKZYBHXBGHTZYCHHHUGUHUIZYEUJXBUKHXBQZOYDYCUFHHYE
      YEUOHHJZYFHYEULHHYEUMZUNHHXBUPUQURYAYCCDHHYEYEXGHXHHXBUSUTVAXTXJYACDXGXHX
      IXBVBVCVDXTXNXBPZYFRYGYGYIYFYGVFHHYEVGYHVEXTXLYIXMYFXIXBVHXIXBVIVJVDXOXRV
      KVLXTXQXDBXTXPXCALWRWTXIXBVBVMVNVOECDBAVPVRXDXFBXDLWQQZRZXFXDWPYJOZALMYKX
      CYLALXCWPHWQKZYLHVQVSXCWRHTZYMVTXCWRWTIZXBOZYNWRWTXBWAYPYOXATYNYOXAWBWRWT
      HHWPWQWCWSWQWCWDSWEWPHWQWFWGWPHWQAWHYEWISWKALYJWJWLLYJWQBWHWMWNSWOVA $.
  $}

  ${
    $d A g h $.  $d A h x y $.  $d F g h $.  $d F h x y $.  $d G g k $.
    $d G k x y $.  $d R h k r x $.  $d r x y $.
    axdc2lem.1 $e |- A e. _V $.
    axdc2lem.2 $e |- R = { <. x , y >. | ( x e. A /\ y e. ( F ` x ) ) } $.
    axdc2lem.3 $e |- G = ( x e. om |-> ( h ` x ) ) $.
    $( Lemma for ~ axdc2 .  We construct a relation ` R ` based on ` F ` such
       that ` x R y ` iff ` y e. ( F `` x ) ` , and show that the "function"
       described by ~ ax-dc can be restricted so that it is a real function
       (since the stated properties only show that it is the superset of a
       function).  (Contributed by Mario Carneiro, 25-Jan-2013.)  (Revised by
       Mario Carneiro, 26-Jun-2015.) $)
    axdc2lem $p |- ( ( A =/= (/) /\ F : A --> ( ~P A \ { (/) } ) ) -> E. g
      ( g : om --> A /\ A. k e. om ( g ` suc k ) e. ( F ` ( g ` k ) ) ) ) $=
      ( c0 wa cfv com wex wcel wceq cvv vr wne cpw csn cdif wf cv csuc wbr wral
      cdm crn wss crab ffvelrn eldifsni sylib syl ralrimiva rabid2 sylibr copab
      n0 dmeqi cab 19.42v abbii dmopab df-rab eqtri syl6reqr neeq1d biimparc wi
      3eqtr4i eldifi elelpwi expcom expimpd exlimdv alrimiv rneqi rnopab sseq1i
      wal 3syl abss bitri sseqtr4d adantl cun cuni cxp fvrn0 ax-mp sseli anim2i
      elssuni ssopab2i df-xp 3sstr4i pwex difexg ssex p0ex unexg sylancl uniexg
      frn xpexg sylancr ssexg vex eldm exbii bitr2i dmeq syl5bb sseq12d anbi12d
      rneq ralbidv exbidv imbi12d ax-dc vtoclg mp2and simpr fveq2 suceq breq12d
      breq fveq2d rspccv fvex breldm syl6 ex eleq1 fveq1 adantll eleq2 ad2antrr
      imp wb mpbid fmptd impcom fvmpt peano2 fvmptg eleq2d brab simprbi syl6bir
      anbi2d ralimia adantr cmpt rgenw eqid fmpt mpbi dcomex rnex mp3an eqeltri
      unex fex2 feq1 eleq12d spcev syl2anc exlimiv sylc ) CMUBZCCUCZMUDZUEZHUFZ
      NZGUGZFUGZOZUWBUHZUWCOZDUIZGPUJZFQZUVTPCEUGZUFZUWEUWJOZUWBUWJOZHOZRZGPUJZ
      NZEQZUWADUKZMUBZDULZUWSUMZUWIUVTUWTUVPUVTUWSCMUVTCBUGZAUGZHOZRZBQZACUNZUW
      SUVTUXGACUJCUXHSUVTUXGACUVTUXDCRZNZUXEUVSRZUXGCUVSUXDHUOZUXKUXEMUBUXGUXEU
      VQMUPBUXEVCUQURUSUXGACUTVAUWSUXIUXFNZABVBZUKZUXHDUXNKVDUXMBQZAVEUXIUXGNZA
      VEUXOUXHUXPUXQAUXIUXFBVFVGUXMABVHUXGACVIVOVJVKZVLVMUVTUXBUVPUVTUXACUWSUVT
      UXMAQZUXCCRZVNZBWEZUXACUMZUVTUYABUVTUXMUXTAUVTUXIUXFUXTUXJUXKUXEUVQRZUXFU
      XTVNUXLUXEUVQUVRVPUXFUYDUXTUXCUXECVQVRWFVSVTWAUYCUXSBVEZCUMUYBUXAUYECUXAU
      XNULUYEDUXNKWBUXMABWCVJWDUXSBCWGWHVAUXRWIWJUWADTRZUWTUXBNZUWIVNZUWADCHULZ
      UVRWKZWLZWMZUMUYLTRZUYFUXNUXIUXCUYKRZNZABVBDUYLUXMUYOABUXFUYNUXIUXEUYKUXC
      UXEUYJRUXEUYKUMHUXDWNUXEUYJWRWOWPWQWSKABCUYKWTXAUWACTRUYKTRZUYMJUWAUYJTRZ
      UYPUWAUYITRZUVRTRUYQUWAUYIUVSUMZUYRUVTUYSUVPCUVSHXIWJUYIUVSUVQTRUVSTRCJXB
      UVQUVRTXCWOXDURXEUYIUVRTTXFXGUYJTXHURCUYKTTXJXKDUYLTXLXKUXDUXCUAUGZUIBQZA
      QZUYTULZUYTUKZUMZNZUWDUWFUYTUIZGPUJZFQZVNUYHUADTUYTDSZVUFUYGVUIUWIVUJVUBU
      WTVUEUXBVUBVUDMUBZVUJUWTVUKUXDVUDRZAQVUBAVUDVCVULVUAABUXDUYTAXMXNXOXPVUJV
      UDUWSMUYTDXQZVLXRVUJVUCUXAVUDUWSUYTDYAVUMXSXTVUJVUHUWHFVUJVUGUWGGPUWDUWFU
      YTDYLYBYCYDUAABFGYEYFURYGUVPUVTYHUWHUVTUWRVNFUWHUVTUWRUWHUVTNPCIUFZUWEIOZ
      UWBIOZHOZRZGPUJZUWRUVTUWHVUNUVTUWSCSZUWHVUNVNUXRVUTUWHVUNVUTUWHNZAPUXDUWC
      OZCIVVAUXDPRZNVVBUWSRZVVBCRZUWHVVCVVDVUTUWHVVCVVDUWHVVCVVBUXDUHZUWCOZDUIZ
      VVDUWGVVHGUXDPUWBUXDSZUWDVVBUWFVVGDUWBUXDUWCYIVVIUWEVVFUWCUWBUXDYJYMYKYNV
      VBVVGDUXDUWCYOVVFUWCYOYPYQUUDUUAVUTVVDVVEUUEUWHVVCUWSCVVBUUBUUCUUFLUUGYRU
      RUUHUWHVUSUVTUWGVURGPUWBPRZUWGVUPVUODUIZVURVVJVUPUWDVUOUWFDAUWBVVBUWDPIUX
      DUWBUWCYILUWBUWCYOUUIVVJUWEPRUWFTRVUOUWFSUWBUUJUWEUWCYOAUWEVVBUWFPTIUXDUW
      EUWCYILUUKXGYKVVKVUPCRZVURUXMVVLUXCVUQRZNVVLVURNABVUPVUODUWBIYOUWEIYOUXDV
      UPSZUXIVVLUXFVVMUXDVUPCYSVVNUXEVUQUXCUXDVUPHYIUULXTUXCVUOSVVMVURVVLUXCVUO
      VUQYSUUPKUUMUUNUUOUUQUURUWQVUNVUSNEIIAPVVBUUSZTLPUWCULZUVRWKZVVOUFZPTRVVQ
      TRVVOTRVVBVVQRZAPUJVVRVVSAPUWCUXDWNUUTAPVVQVVBVVOVVOUVAUVBUVCUVDVVPUVRUWC
      FXMUVEXEUVHPVVQVVOTTUVIUVFUVGUWJISZUWKVUNUWPVUSPCUWJIUVJVVTUWOVURGPVVTUWL
      VUOUWNVUQUWEUWJIYTVVTUWMVUPHUWBUWJIYTYMUVKYBXTUVLUVMYRUVNUVO $.
  $}

  ${
    $d A g h k $.  $d A h k s t x y $.  $d F g h k $.  $d F h k s t x y $.
    $d g h k n $.  $d h n x z $.  $d n x y $.
    axdc2.1 $e |- A e. _V $.
    $( An apparent strengthening of ~ ax-dc (but derived from it) which shows
       that there is a denumerable sequence ` g ` for any function that maps
       elements of a set ` A ` to nonempty subsets of ` A ` such that
       ` g ( x + 1 ) e. F ( g ( x ) ) ` for all ` x e. om ` .  The finitistic
       version of this can be proven by induction, but the infinite version
       requires this new axiom.  (Contributed by Mario Carneiro,
       25-Jan-2013.) $)
    axdc2 $p |- ( ( A =/= (/) /\ F : A --> ( ~P A \ { (/) } ) ) -> E. g
      ( g : om --> A /\ A. k e. om ( g ` suc k ) e. ( F ` ( g ` k ) ) ) ) $=
      ( vx vy vs vt vh vn cv wcel cfv wa copab com weq eleq1 fveq2 cmpt anbi12d
      wb adantr eleq2d sylan9bb cbvopabv cbvmptv axdc2lem ) FGAHLZAMZILZUJDNZMZ
      OZHIPBJCDKQKLZJLZNZUAEUOFLZAMZGLZUSDNZMZOHIFGHFRZIGRZOUKUTUNVCVDUKUTUCVEU
      JUSASUDVDUNULVBMVEVCVDUMVBULUJUSDTUEULVAVBSUFUBUGKFQURUSUQNUPUSUQTUHUI $.
  $}

  ${
    $d A n s $.
    axdc3lem.1 $e |- A e. _V $.
    axdc3lem.2 $e |- S = { s | E. n e. om ( s : suc n --> A /\
       ( s ` (/) ) = C /\ A. k e. n ( s ` suc k ) e. ( F ` ( s ` k ) ) ) } $.
    $( The class ` S ` of finite approximations to the DC sequence is a set.
       (We derive here the stronger statement that ` S ` is a subset of a
       specific set, namely ` ~P ( om X. A ) ` .)  (Unnecessary distinct
       variable restrictions were removed by David Abernethy, 18-Mar-2014.)
       (Contributed by Mario Carneiro, 27-Jan-2013.)  (Revised by Mario
       Carneiro, 18-Mar-2014.) $)
    axdc3lem $p |- S e. _V $=
      ( com cxp cpw dcomex xpex pwex cv csuc cfv wcel wss wf wceq wral w3a wrex
      c0 cab wa fssxp peano2 cvv con0 omelon2 ax-mp onelssi xpss1 3syl sylan9ss
      vex elpw sylibr ancoms 3ad2antr1 rexlimiva abssi eqsstri ssexi ) CJAKZLZV
      HJAMHNOCEPZQZAGPZUAZUFVLRBUBZDPZQVLRVOVLRFRSDVJUCZUDZEJUEZGUGVIIVRGVIVQVL
      VISZEJVJJSZVNVMVSVPVMVTVSVMVTUHVLVHTVSVMVTVLVKAKZVHVKAVLUIVTVKJSVKJTWAVHT
      VJUJJVKJUKSJULSMUMUNUOVKJAUPUQURVLVHGUSUTVAVBVCVDVEVFVG $.
  $}

  ${
    $d A g h $.  $d A n s $.  $d C g h k $.  $d C k n s $.  $d F g h $.
    $d F n s $.  $d G i j k m $.  $d S i j k m $.  $d S i k s $.
    $d S j m u v $.  $d S i x y $.  $d a b h j m u v $.  $d h i j k m $.
    $d h i k s $.  $d h i x y $.  $d s u v $.
    axdc3lem2.1 $e |- A e. _V $.
    axdc3lem2.2 $e |- S = { s | E. n e. om ( s : suc n --> A /\
       ( s ` (/) ) = C /\ A. k e. n ( s ` suc k ) e. ( F ` ( s ` k ) ) ) } $.
    axdc3lem2.3 $e |- G = ( x e. S |-> { y e. S |
                             ( dom y = suc dom x /\ ( y |` dom x ) = x ) } ) $.
    $( Lemma for ~ axdc3 .  We have constructed a "candidate set" ` S ` , which
       consists of all finite sequences ` s ` that satisfy our property of
       interest, namely ` s ( x + 1 ) e. F ( s ( x ) ) ` on its domain, but
       with the added constraint that ` s ( 0 ) = C ` .  These sets are
       possible "initial segments" of the _infinite_ sequence satisfying these
       constraints, but we can leverage the standard ~ ax-dc (with no initial
       condition) to select a sequence of ever-lengthening finite sequences,
       namely ` ( h `` n ) : m --> A ` (for some integer ` m ` ).  We let our
       "choice" function select a sequence whose domain is one more than the
       last one, and agrees with the previous one on its domain.  Thus, the
       application of vanilla ~ ax-dc yields a sequence of sequences whose
       domains increase without bound, and whose union is a function which has
       all the properties we want.  In this lemma, we show that given the
       sequence ` h ` , we can construct the sequence ` g ` that we are after.
       (Contributed by Mario Carneiro, 30-Jan-2013.) $)
    axdc3lem2 $p |- ( E. h ( h : om --> S /\
        A. k e. om ( h ` suc k ) e. ( G ` ( h ` k ) ) ) ->
      E. g ( g : om --> A /\ ( g ` (/) ) = C /\
        A. k e. om ( g ` suc k ) e. ( F ` ( g ` k ) ) ) ) $=
      ( com wcel wa wceq wi vj vm vi vu vv vb va cv wf csuc cfv wral c0 w3a wex
      crn wfun cdm wss wel fveq2 dmeqd eleq12d eleq2 sseq2d imbi12d anbi12d weq
      id peano1 ffvelrn mpan2 cab wrex nnord syl peano2 syl2anc 3ad2ant1 impcom
      word rexlimiva ss2abi eqsstri sseli fvex dmeq eleq2d eleq1d simpld adantr
      elab sylib ancoms adantrr fveq2d simprd ordsucelsuc 3syl cres crab eqeq1d
      suceq wb wo syl6 sseq1d biimprd com13 anim12d ex expcom ralrimdv ralrimiv
      a1d imp frn rexlimivw syl6ss sseld vex syl6ib wfn raleqbi1dv rspcv rspccv
      fvelrnb 3imp orcd 3exp com3r com23 sylan fnfvelrn funssfv syl3anc adantlr
      ssel mpd fveq1 cuni elequ2 fdm 0elsuc eleq1 biimprcd syl5com noel pm2.21i
      jctir rspcva adantrl eqeq2d reseq2d eqeq12d rabbidv axdc3lem rabex reseq1
      fvmpt elrab syl6bb simplbda bitr4d biimpd resss sseq1 mpbii elsuci pm2.27
      sstr2 jaoi finds2 ffun funeq ffn anim12i w3o ordtri3or adantl eqimss olcd
      3jaoi mpcom sseq12 orbi12d biimpcd rexlimiv rexlimdv syl6bi sylbid fununi
      exp4b com24 jcad syldan cop eldm2 eluni2 opeldm simprbi exp3acom23 syl5bi
      a1i elnn exlimdv rspcev ciun dmuni eleq2i eliun bitri sylibr impbid eqrdv
      rnuni iunss syl5eqss df-fn biimpri sylanbr syl21anc sylancl elssuni simp2
      abid df-f eqtrd nfv nfra1 nfan ad2antrr syl2an mpan9 biimpa syl9r 3adant2
      rsp sstr syl3c wtr ordtr trsuc 4syl simpl simpr mpbird ralrimi rnex uniex
      feq1 ralbidv 3anbi123d spcev exlimiv ) PEGUHZUIZHUHZUJZVUPUKZVURVUPUKZKUK
      ZQZHPULZRZPCFUHZUIZUMVVFUKZDSZVUSVVFUKZVURVVFUKZJUKZQZHPULZUNZFUOZGVVEPCV
      UPUPZUUAZUIZUMVVRUKZDSZVUSVVRUKZVURVVRUKZJUKZQZHPULZVVPVVEVVRUQZVVRURZPSZ
      VVRUPZCUSZVVSVUQVVDUAUHZVUPUKZUBUHZVUPUKZUSZUAVWNULZUBPULZVWGVVEVWQUBPVVE
      VWNPQZVWPUAVWNVWSVVEUAUBUTZVWPTZVWSVVERZVWNVWOURZQZVXAVWSVVEVXDVXARZVXEUM
      UMVUPUKZURZQZVWLUMQZVWMVXFUSZTZRZUCUHZVXMVUPUKZURZQZUAUCUTZVWMVXNUSZTZRZV
      XMUJZVYAVUPUKZURZQZVWLVYAQZVWMVYBUSZTZRZVVEUBUCVWNUMSZVXDVXHVXAVXKVYIVWNU
      MVXCVXGVYIVIVYIVWOVXFVWNUMVUPVAZVBVCVYIVWTVXIVWPVXJVWNUMVWLVDVYIVWOVXFVWM
      VYJVEVFVGUBUCVHZVXDVXPVXAVXSVYKVWNVXMVXCVXOVYKVIVYKVWOVXNVWNVXMVUPVAZVBVC
      VYKVWTVXQVWPVXRUBUCUAUUBVYKVWOVXNVWMVYLVEVFVGVWNVYASZVXDVYDVXAVYGVYMVWNVY
      AVXCVYCVYMVIVYMVWOVYBVWNVYAVUPVAZVBVCVYMVWTVYEVWPVYFVWNVYAVWLVDVYMVWOVYBV
      WMVYNVEVFVGVUQVXLVVDVUQVXHVXKVUQVXFEQZVXHVUQUMPQZVYOVJPEUMVUPVKVLVYOVXHVX
      GPQZVYOVXFUMLUHZURZQZVYSPQZRZLVMZQVXHVYQRZEWUCVXFEIUHZUJZCVYRUIZUMVYRUKZD
      SZVUSVYRUKZVURVYRUKZJUKZQZHWUEULZUNZIPVNZLVMZWUCNWUPWUBLWUOWUBIPWUOWUEPQZ
      WUBWUGWUIWURWUBTWUNWUGVYSWUFSZWURWUBWUFCVYRUUCZWURUMWUFQZWUFPQZWUSWUBTWUR
      WUEWAZWVAWUEVOZWUEUUDVPWUEVQWUSWUBWVAWVBRWUSVYTWVAWUAWVBVYSWUFUMVDVYSWUFP
      UUEVGUUFVRUUGVSVTWBWCWDZWEWUBWUDLVXFUMVUPWFZVYRVXFSZVYTVXHWUAVYQWVGVYSVXG
      UMVYRVXFWGZWHWVGVYSVXGPWVHWIVGWLWMWJVPZVXIVXJVWLUUHUUIUUJWKVXMPQZVVEVXTVY
      HTZWVJVVERVXNEQZVYBVXNKUKZQZWVKWVJVUQWVLVVDVUQWVJWVLPEVXMVUPVKWNWOWVJVVDW
      VNVUQVVCWVNHVXMPHUCVHZVUTVYBVVBWVMWVOVUSVYAVUPVURVXMXCWPWVOVVAVXNKVURVXMV
      UPVAWPVCUUKUULWVLWVNRZVXPVYDVXSVYGWVPVXPVYDWVPVXPVYAVXOUJZQZVYDWVLVXPWVRX
      DZWVNWVLVXOPQZVXOWAWVSWVLUMVXOQZWVTWVLVXNWUCQWWAWVTRZEWUCVXNWVEWEWUBWWBLV
      XNVXMVUPWFVYRVXNSZVYTWWAWUAWVTWWCVYSVXOUMVYRVXNWGZWHWWCVYSVXOPWWDWIVGWLWM
      WQVXOVOVXMVXOWRWSWKWVPVYCWVQVYAWVPVYCWVQSZVYBVXOWTZVXNSZWVLWVNVYBEQZWWEWW
      GRZWVLWVNVYBBUHZURZWVQSZWWJVXOWTZVXNSZRZBEXAZQWWHWWIRWVLWVMWWPVYBAVXNWWKA
      UHZURZUJZSZWWJWWRWTZWWQSZRZBEXAWWPEKWWQVXNSZWXCWWOBEWXDWWTWWLWXBWWNWXDWWS
      WVQWWKWXDWWRVXOSWWSWVQSWWQVXNWGZWWRVXOXCVPUUMWXDWXAWWMWWQVXNWXDWWRVXOWWJW
      XEUUNWXDVIUUOVGUUPOWWOBECDEHIJLMNUUQUURUUTWHWWOWWIBVYBEWWJVYBSZWWLWWEWWNW
      WGWXFWWKVYCWVQWWJVYBWGXBWXFWWMWWFVXNWWJVYBVXOUUSXBVGUVAUVBUVCZWJWHUVDUVEW
      VPWWGVXNVYBUSZVXSVYGTWVPWWEWWGWXGWQWWGWWFVYBUSWXHVYBVXOUVFWWFVXNVYBUVGUVH
      VYEVXSWXHVYFVYEVXQUAUCVHZXEVXSWXHVYFTZTZVWLVXMUVIVXQWXKWXIVXQVXSVXRWXJVXQ
      VXRUVJVWMVXNVYBUVKXFWXIWXJVXSWXIVYFWXHWXIVWMVXNVYBVWLVXMVUPVAXGXHXOUVLVPX
      IWSXJVRXKUVMXPZWQXLXMXNVUQVWRRZUDUHZUQZWXNUEUHZUSZWXPWXNUSZXEZUEVVQULZRZU
      DVVQULVWGWXMWYAUDVVQWXMWXNVVQQZWXOWXTVUQWYBWXOTVWRVUQWYBWXNVYRUQZLVMZQWXO
      VUQVVQWYDWXNVUQVVQEWYDPEVUPXQZEWUQWYDNWUPWYCLWUOWYCIPWUGWUIWYCWUNWUFCVYRU
      VNVSXRWCWDXSXTWYCWXOLWXNUDYAZVYRWXNUVOWLYBWKVUQVUPPYCZVWRWYBWXTTPEVUPUVPZ
      WYGVWRRWYBWXSUEVVQWYGVWRWYBWXPVVQQZWXSTTWYGWYIWYBVWRWXSWYGWYIUFUHZVUPUKZW
      XPSZUFPVNZWYBVWRWXSTZTUFPWXPVUPYGWYGWYBWYMWYNWYGWYBUGUHZVUPUKZWXNSZUGPVNZ
      WYMWYNTUGPWXNVUPYGWYRWYLWYNUFPWYQWYJPQZWYLWYNTZTUGPWYOPQZWYSWYQWYTXUAWYSW
      YQWYLWYNXUAWYSRZVWRWYQWYLRZWXSXUBVWRWYPWYKUSZWYKWYPUSZXEZXUCWXSTWYOWAZWYJ
      WAZRZXUBVWRXUFTZXUAXUGWYSXUHWYOVOWYJVOUVQXUIUGUFUTZUGUFVHZUFUGUTZUVRXUBXU
      JTZWYOWYJUVSXUKXUNXULXUMXUBVWRXUKXUFXUBVWRXUKXUFXUBVWRXUKUNXUDXUEXUBVWRXU
      KXUDWYSVWRXUKXUDTZTXUAWYSVWRVWMWYKUSZUAWYJULZXUOVWQXUQUBWYJPVWPXUPUAVWNWY
      JUBUFVHVWOWYKVWMVWNWYJVUPVAVEYDYEXUPXUDUAWYOWYJUAUGVHVWMWYPWYKVWLWYOVUPVA
      XGYFXFUVTYHYIYJYKXULXUJXUBXULXUFVWRXULWYPWYKSZXUFWYOWYJVUPVAXURXUDXUEWYPW
      YKUWAYIVPXOXOXUBVWRXUMXUFXUBVWRXUMXUFXUBVWRXUMUNXUEXUDXUBVWRXUMXUEXUAVWRX
      UMXUETZTWYSXUAVWRVWMWYPUSZUAWYOULZXUSVWQXVAUBWYOPVWPXUTUAVWNWYOUBUGVHVWOW
      YPVWMVWNWYOVUPVAVEYDYEXUTXUEUAWYJWYOUAUFVHVWMWYKWYPVWLWYJVUPVAXGYFXFWKYHU
      WBYJYKUWCVPUWDXUCXUFWXSXUCXUDWXQXUEWXRWYPWXNWYKWXPUWEWYLWYQXUEWXRXDWYKWXP
      WYPWXNUWEWNUWFUWGXFYLUWMYLUWHUWIUWJYLUWKUWNXPXMYMUWOXNVVQUDUEUWLVPUWPZVVE
      UBVWHPVVEVWNVWHQZVWSVUQXVCVWSTVVDXVCVWNWXNUWQZVVRQZUDUOVUQVWSUDVWNVVRUBYA
      ZUWRVUQXVEVWSUDXVEXVDWXPQZUEVVQVNVUQVWSUEXVDVVQUWSVUQXVGVWSUEVVQVUQXVGWYI
      VWSVUQXVGWYIRVWNWXPURZQZXVHPQZRVWSVUQXVGXVIWYIXVJXVGXVITVUQVWNWXNWXPXVFWY
      FUWTUXDVUQVVQWUCUSZWYIXVJTVUQVVQEWUCWYEWVEXSZXVKWYIWXPWUCQZXVJVVQWUCWXPYR
      XVMUMXVHQZXVJWUBXVNXVJRLWXPUEYALUEVHZVYTXVNWUAXVJXVOVYSXVHUMVYRWXPWGZWHXV
      OVYSXVHPXVPWIVGWLUXAXFVPXJVWNXVHUXEXFUXBUWIUXCUXFUXCWKVWSVVEXVCVXBVWNWXNU
      RZQZUDVVQVNZXVCVXBVXDXVSVXBVXDVXAWXLWJZVWSVUQVXDXVSTZVVDVUQVWSXWAVUQWYGVW
      SXWAWYHWYGVWSRVWOVVQQZXWAPVWNVUPYNXWBVXDXVSXVRVXDUDVWOVVQWXNVWOSXVQVXCVWN
      WXNVWOWGWHUXGXKVPYMWNWOYSXVCVWNUDVVQXVQUXHZQXVSVWHXWCVWNUDVVQUXIUXJUDVWNV
      VQXVQUXKUXLUXMXLUXNUXOVUQVWKVVDVUQVWJLVVQVYRUPZUXHZCLVVQUXPVUQXWDCUSZLVVQ
      ULXWECUSVUQXWFLVVQVUQVVQXWFLVMZUSZVYRVVQQZXWFTVUQVVQEXWGWYEEWUQXWGNWUPXWF
      LWUOXWFIPWUGWUIXWFWUNWUFCVYRXQVSXRWCWDXSXWHXWIVYRXWGQXWFVVQXWGVYRYRXWFLUY
      FYBVPXNLVVQXWDCUXQUXMUXRWKVWGVWIRVVRPYCZVWKVVSVVRPUXSVVSXWJVWKRPCVVRUYGUX
      TUYAUYBVVEVVTUMVXFUKZDVVEVWGVXFVVRUSZVXHVVTXWKSXVBVVEVXFVVQQZXWLVUQXWMVVD
      VUQWYGVYPXWMWYHVJPUMVUPYNUYCWKZVXFVVQUYDVPVUQVXHVVDWVIWKUMVVRVXFYOYPVVEXW
      MXWKDSZXWNVUQXWMXWOTZVVDVUQVVQWUILVMZUSZXWPVUQVVQEXWQWYEEWUQXWQNWUPWUILWU
      OWUIIPWUGWUIWUNUYEXRWCWDXSXWRXWMVXFXWQQXWOVVQXWQVXFYRWUIXWOLVXFWVFWVGWUHX
      WKDUMVYRVXFYTXBWLYBVPWKYSUYHVVEVWEHPVUQVVDHVUQHUYIVVCHPUYJUYKVVEVURPQZVWE
      VVEXWSRZVWEVUSVUTUKZVURVUTUKZJUKZQZXWTVVQEUSZVUTVVQQZVUSVUTURZQZXXDVUQXXE
      VVDXWSWYEUYLVUQXWSXXFVVDVUQWYGVUSPQZXXFXWSWYHVURVQZPVUSVUPYNUYMZYQVVEVXDU
      BPULZXWSXXHVVEVXDUBPVWSVVEVXDXVTXLXNXWSXXIXXLXXHTXXJVXDXXHUBVUSPVWNVUSSZV
      WNVUSVXCXXGXXMVIXXMVWOVUTVWNVUSVUPVAVBVCYEVPUYNZXXEXXFVUTVUSVYSQZWUMTZLVM
      ZQXXHXXDTZXXEVVQXXQVUTXXEEXXQUSVVQXXQUSEWUQXXQNWUPXXPLWUOXXPIPWUOWURXXPWU
      GWUNWURXXPTZWUIWUGWUNXXSWUGXXOWURWUNWUMWUGXXOWURWUNWUMTTZWUGXXORVUSWUFQZX
      XTWUGWUSXXOXYAWUTWUSXXOXYAVYSWUFVUSVDUYOYMWUNWURXYAWUMWURXYAHIUTZWUNWUMWU
      RXYBXYAWURWVCXYBXYAXDWVDVURWUEWRVPXHWUMHWUEUYRUYPXIVPXKUWNXPUYQVTWBWCWDVV
      QEXXQUYSVLXTXXPXXRLVUTVUSVUPWFZVYRVUTSZXXOXXHWUMXXDXYDVYSXXGVUSVYRVUTWGZW
      HXYDWUJXXAWULXXCVUSVYRVUTYTXYDWUKXXBJVURVYRVUTYTWPVCVFWLYBUYTXWTVWBXXASZV
      WCXXBSZVWEXXDXDXWTVWGVUTVVRUSZXXHXYFVVEVWGXWSXVBWKZVUQXWSXYHVVDVUQXWSRZXX
      FXYHXXKVUTVVQUYDVPYQZXXNVUSVVRVUTYOYPXWTVWGXYHVURXXGQZXYGXYIXYKXWTXXHXYLX
      XNVUQXWSXXHXYLTZVVDXYJXXGPQZXXGWAXXGVUAZXYMXYJUMXXGQZXYNXYJXXFXYPXYNRZXXK
      VUQXXFXYQTXWSVUQXXFVUTWUCQXYQVUQVVQWUCVUTXVLXTWUBXYQLVUTXYCXYDVYTXYPWUAXY
      NXYDVYSXXGUMXYEWHXYDVYSXXGPXYEWIVGWLYBWKYSWQXXGVOXXGVUBXYOXXHXYLXXGVURVUC
      XKVUDYQYSVURVVRVUTYOYPXYFXYGRZVWBXXAVWDXXCXYFXYGVUEXYRVWCXXBJXYFXYGVUFWPV
      CVRVUGXKVUHVVOVVSVWAVWFUNFVVRVVQVUPGYAVUIVUJVVFVVRSZVVGVVSVVIVWAVVNVWFPCV
      VFVVRVUKXYSVVHVVTDUMVVFVVRYTXBXYSVVMVWEHPXYSVVJVWBVVLVWDVUSVVFVVRYTXYSVVK
      VWCJVURVVFVVRYTWPVCVULVUMVUNYPVUO $.
  $}

  ${
    $d A m $.  $d A n s $.  $d B k m n $.  $d B k n s $.  $d C m $.
    $d C n s $.  $d F m $.  $d F n s $.
    axdc3lem3.1 $e |- A e. _V $.
    axdc3lem3.2 $e |- S = { s | E. n e. om ( s : suc n --> A /\
       ( s ` (/) ) = C /\ A. k e. n ( s ` suc k ) e. ( F ` ( s ` k ) ) ) } $.
    axdc3lem3.3 $e |- B e. _V $.
    $( Simple substitution lemma for ~ axdc3 .  (Contributed by Mario Carneiro,
       27-Jan-2013.) $)
    axdc3lem3 $p |- ( B e. S <-> E. m e. om ( B : suc m --> A /\
       ( B ` (/) ) = C /\ A. k e. m ( B ` suc k ) e. ( F ` ( B ` k ) ) ) ) $=
      ( wcel cv csuc wf c0 cfv wceq com wral w3a wrex eleq2i feq1 eqeq1d fveq2d
      cab fveq1 eleq12d ralbidv 3anbi123d rexbidv elab weq suceq feq2d 3anbi13d
      raleq cbvrexv 3bitri ) BDMBGNZOZAINZPZQVDRZCSZENZOZVDRZVHVDRZHRZMZEVBUAZU
      BZGTUCZIUHZMVCABPZQBRZCSZVIBRZVHBRZHRZMZEVBUAZUBZGTUCZFNZOZABPZVTWDEWHUAZ
      UBZFTUCDVQBKUDVPWGIBLVDBSZVOWFGTWMVEVRVGVTVNWEVCAVDBUEWMVFVSCQVDBUIUFWMVM
      WDEVBWMVJWAVLWCVIVDBUIWMVKWBHVHVDBUIUGUJUKULUMUNWFWLGFTGFUOZVRWJWEWKVTWNV
      CWIABVBWHUPUQWDEVBWHUSURUTVA $.
  $}

  ${
    $d A g h k $.  $d A k m n p x z $.  $d A h k s x $.  $d C g h k $.
    $d C k m n p z $.  $d C h k s $.  $d F g h k $.  $d F k m n p x z $.
    $d F h k s x $.  $d G h k $.  $d S h k s x $.  $d S k m x z $.
    $d S h x y $.  $d m x y z $.  $d n s x z $.
    axdc3lem4.1 $e |- A e. _V $.
    axdc3lem4.2 $e |- S = { s | E. n e. om ( s : suc n --> A /\
       ( s ` (/) ) = C /\ A. k e. n ( s ` suc k ) e. ( F ` ( s ` k ) ) ) } $.
    axdc3lem4.3 $e |- G = ( x e. S |-> { y e. S |
                             ( dom y = suc dom x /\ ( y |` dom x ) = x ) } ) $.
    $( Lemma for ~ axdc3 .  We have constructed a "candidate set" ` S ` , which
       consists of all finite sequences ` s ` that satisfy our property of
       interest, namely ` s ( x + 1 ) e. F ( s ( x ) ) ` on its domain, but
       with the added constraint that ` s ( 0 ) = C ` .  These sets are
       possible "initial segments" of the _infinite_ sequence satisfying these
       constraints, but we can leverage the standard ~ ax-dc (with no initial
       condition) to select a sequence of ever-lengthening finite sequences,
       namely ` ( h `` n ) : m --> A ` (for some integer ` m ` ).  We let our
       "choice" function select a sequence whose domain is one more than the
       last one, and agrees with the previous one on its domain.  Thus, the
       application of vanilla ~ ax-dc yields a sequence of sequences whose
       domains increase without bound, and whose union is a function which has
       all the properties we want.  In this lemma, we show that ` S ` is
       nonempty, and that ` G ` always maps to a nonempty subset of ` S ` , so
       that we can apply ~ axdc2 .  See ~ axdc3lem2 for the rest of the proof.
       (Contributed by Mario Carneiro, 27-Jan-2013.) $)
    axdc3lem4 $p |- ( ( C e. A /\ F : A --> ( ~P A \ { (/) } ) ) ->
                E. g ( g : om --> A /\ ( g ` (/) ) = C /\
                  A. k e. om ( g ` suc k ) e. ( F ` ( g ` k ) ) ) ) $=
      ( wcel c0 wa cfv wceq wi vh vm vz vp cpw csn cdif wf com cv csuc wral wex
      w3a wne cop wrex peano1 wss eqid fsng mpan mpbiri snssi fss syl2anc feq2i
      suc0 sylibr fvsng ral0 a1i 3jca suceq feq2d raleq 3anbi13d rspcev sylancr
      wb snex axdc3lem3 ne0i syl cdm cres ssrab2 axdc3lem wn vex ffvelrn sylan2
      crab elsnc necon3bbii sylib cun expcom 3syl 3ad2ant3 3ad2ant1 simplr word
      cin cvv adantr adantl mpbird nnord eleq2 disjsn df-suc a1d ancoms 3adant1
      3imp wfun syl5eq funssfv syl3anc eqeq1d biimpar 3adant2 nfv nf3an 3adant3
      ex impcom biimparc syl2an fveq2d eleq12d 3adant2l fveq2 eqtrd com3r 3impd
      3expib mpd com12 elpw2 mpbir simp2 sucid mpan2 eldifn bitri simp32 eldifi
      fvex n0 elelpwi peano2 dmex mp2an simpr snssd fdm eleq1 ordirr mtbid fun2
      syl21anc sneq uneq2d syl6eqr mpbid adantrd ffun funsn jctir dmsnop ineq2i
      ad2antlr funun ssun1 0elsuc eleq2d adantrl nfra1 elsuci ad2ant2lr adantlr
      rsp ordsucelsuc biimpa 3adant1r ssun2 eqeq2d snid eleqtrri syl6eqelr fvsn
      syl5reqr syl3an3 3expa 3adant1l biimprd jaoi imp3a ralrimi syl13anc 3coml
      wo unex 3exp exp3a sylcom com23 mpdi imp resundir wrel resdm incom eqeq1i
      frel wfn fnsn fnresdisj ax-mp 3bitr3ri uneq12d syl6eq uneq2i dmun 3eqtr4i
      jctil dmeq reseq1 anbi12d 3exp2 exlimdv mpan2d 3expd rexlimiv sylbi rabn0
      un0 rabex eldifd fmptd axdc2 axdc3lem2 ) DCOZCCUEZPUFZUGZIUHZQUIEUAUJZUHG
      UJZUKZVUJRVUKVUJRJROGUIULQUAUMZUICFUJZUHPVUNRDSVULVUNRVUKVUNRIROGUIULUNFU
      MVUEEPUOZEEUEZVUGUGZJUHVUMVUIVUEPDUPZUFZEOZVUOVUEUBUJZUKZCVUSUHZPVUSRDSZV
      ULVUSRVUKVUSRIROZGVVAULZUNZUBUIUQZVUTVUEPUIOZPUKZCVUSUHZVVDVVEGPULZUNZVVH
      URVUEVVKVVDVVLVUEVUGCVUSUHZVVKVUEVUGDUFZVUSUHZVVOCUSVVNVUEVVPVUSVUSSZVUSU
      TVVIVUEVVPVVQVTURPDUICVUSVAVBVCDCVDVUGVVOCVUSVEVFVVJVUGCVUSVHVGVIVVIVUEVV
      DURPDUICVJVBVVLVUEVVEGVKVLVMVVGVVMUBPUIVVAPSZVVCVVKVVFVVLVVDVVRVVBVVJCVUS
      VVAPVNVOVVEGVVAPVPVQVRVSCVUSDEGUBHIKLMVURWAWBVIEVUSWCWDVUIAEBUJZWEZAUJZWE
      ZUKZSZVVSVWBWFZVWASZQZBEWMZVUQJVUIVWAEOZQZVWHVUPVUGVWHVUPOZVWJVWKVWHEUSVW
      GBEWGVWHECDEGHIKLMWHZUUAUUBVLVWJVWHPUOZVWHVUGOZWIVWJVWGBEUQZVWMVWIVUIVWOV
      WIVVBCVWAUHZPVWARZDSZVULVWARZVUKVWARZIRZOZGVVAULZUNZUBUIUQVUIVWOTZCVWADEG
      UBHIKLMAWJZWBVXDVXEUBUIVXDVVAUIOZVXEVWPVWRVXCVXGVXETZVWRVXCVWPVXHVWRVXCVW
      PVXGVXEVXCVWPVXGUNZVUIVWRVWOVXIVUIVWPVWRVWOTVXCVWPVXGUUCVUIVWPQZVWRVXIVWO
      VXJUCUJZVVAVWARZIRZOZUCUMZVWRVXIVWOTTZVXJVXMVUHOZVXOVWPVUIVXLCOZVXQVWPVVA
      VVBOVXRVVAUBWJUUDVVBCVVAVWAWKUUECVUHVXLIWKWLZVXQVXMVUGOZWIZVXOVXMVUFVUGUU
      FVYAVXMPUOVXOVXTVXMPVXMPVXLIUUJWNWOUCVXMUUKUUGWPWDVUIVXOVXPTVWPVUIVXNVXPU
      CVUIVXNVWRVXIVWOVUIVXNVWRVXIUNZQZVWAVWBVXKUPZUFZWQZEOZVYFWEZVWCSZVYFVWBWF
      ZVWASZQZVWOVUIVYBVYGVUIVYBVWPVYGVXNVWRVXCVWPVXGUUHVUIVWPVYBVYGVUIVWPVYBVY
      GTVXJVXNVWRVXIVYGVXJVXNVXKCOZVWRVXIVYGTZTVXJVXQVXMVUFOZVXNVYMTVXSVXMVUFVU
      GUUIVXNVYOVYMVXKVXMCUULWRWSVXNVYMVWRVYNVXNVYMVWRQZVXIVYGVXIVXNVYPVYGVXIVX
      NVYPUNZUDUJZUKZCVYFUHZPVYFRZDSZVULVYFRZVUKVYFRZIRZOZGVYRULZUNZUDUIUQZVYGV
      YQVVBUIOZVVBUKZCVYFUHZWUBWUFGVVBULZWUIVXIVXNWUJVYPVXGVXCWUJVWPVVAUUMZWTXA
      VXIVXNVYPWULVWPVXGVXNVYPWULTZTZVXCVXGVWPWUPVXGVWPQZWUOVXNWUQVYMWULVWRWUQV
      YMWULWUQVYMQZVVBVWBUFZWQZCVYFUHZWULWURVWPWUSCVYEUHZVVBWUSXDPSZWVAVXGVWPVY
      MXBWURWUSVXKUFZVYEUHZWVDCUSWVBVWBXEOZVXKXEOZWVEVWAVXFUUNZUCWJZWVFWVGQWVEV
      YEVYESVYEUTVWBVXKXEXEVYEVAVCUUOWURVXKCWUQVYMUUPUUQWUSWVDCVYEVEVSWUQWVCVYM
      VWPVXGVWBVVBSZWVCVVBCVWAUURZVXGWVJQZVWBVVBOZWIWVCWVLVWBVWBOZWVMWVLVWBUIOZ
      VWBXCZWVNWIZWVLWVOWUJVXGWUJWVJWUNXFWVJWVOWUJVTVXGVWBVVBUIUUSXGXHZVWBXIZVW
      BUUTZWSZWVJWVNWVMVTVXGVWBVVBVWBXJXGUVAVVBVWBXKVIWLXFVVBWUSCVWAVYEUVBUVCWU
      RWUTWUKCVYFVWPWUTWUKSZVXGVYMVWPWVJWWBWVKWVJWUTVVBVVBUFZWQWUKWVJWUSWWCVVBV
      WBVVBUVDUVEVVBXLUVFWDUVNVOUVGYGUVHXMXNXOXPVXIVYPWUBVXNVXIVWRWUBVYMVXIWUBV
      WRVWPVXGWUBVWRVTZVXCVXGVWPWWDWUQWUAVWQDWUQVYFXQZVWAVYFUSZPVWBOZWUAVWQSWUQ
      VWAXQZVYEXQZQVWBVYEWEZXDZPSZWWEWUQWWHWWIVWPWWHVXGVVBCVWAUVIXGVWBVXKWVHWVI
      UVJUVKVWPVXGWVJWWLWVKWVLWWKVWBWUSXDZPWWJWUSVWBVWBVXKWVIUVLZUVMWVLWVQWWMPS
      ZWWAVWBVWBXKZVIXRWLVWAVYEUVOVFZWWFWUQVWAVYEUVPZVLWUQWWGPVVBOZVXGWWSVWPVXG
      VVAXCZWWSVVAXIZVVAUVQWDXFVWPWWGWWSVTVXGVWPVWBVVBPWVKUVRXGXHPVYFVWAXSXTYAX
      NXOYBUVSYCVYQWUFGVVBVXIVXNVYPGVXCVWPVXGGVXBGVVAUVTVWPGYDVXGGYDYEVXNGYDVYP
      GYDYEVXIVXNVUKVVBOZWUFTVYPWXBVXIVXNQWUFWXBVXIVXNWUFWXBVXCVWPVXGVXNWUFTZVX
      CWXBVWPVXGWXCTZTVXCWXBQZVWPWXDWXEVWPQZWXBWXDVXCWXBVWPXBWXBVXGWXFWXCWXBVUK
      VVAOZVUKVVASZUXDVXGWXFWXCTZTZVUKVVAUWAWXGWXJWXHVXGWXGWXIVXGWXGQZWXEVWPWXC
      WXKWXEVWPUNZWUFVXNWXLWUFVXBWXKWXEVXBVWPWXGVXCVXBVXGWXBVXCWXGVXBVXBGVVAUWD
      YHUWBYFWXKWXBVWPWUFVXBVTVXCWXKWXBVWPUNZWUCVWSWUEVXAWXKVWPWUCVWSSZWXBWXKVW
      PQZWWEWWFVULVWBOZWXNVXGVWPWWEWXGWWQUWCWWFWXOWWRVLWXKVULVVBOZWVJWXPVWPVXGW
      XGWXQVXGWWTWXGWXQVTWXAVUKVVAUWEWDUWFWVKWVJWXPWXQVWBVVBVULXJYIYJVULVYFVWAX
      SXTYCWXMWUDVWTIVXGWXBVWPWUDVWTSZWXGVXGWXBVWPUNZWWEWWFVUKVWBOZWXRVXGVWPWWE
      WXBWWQYCWWFWXSWWRVLWXBVWPWXTVXGVWPWXBWVJWXTWVKWVJWXTWXBVWBVVBVUKXJYIWLXOV
      UKVYFVWAXSXTZUWGYKYLYMXHXMYRWRWXHVXGWXIWXHVXGQZWXEVWPWXCWYBWXEVWPUNWUFVXN
      WYBWXBVWPWUFVXNVTVXCWYBWXBVWPUNZWUCVXKWUEVXMWYBVWPWUCVXKSZWXBWXHVXGVWPWYD
      WXHVXGVWPUNZWUCVULVYERZVXKWYEWWEVYEVYFUSZVULWWJOZWUCWYFSVXGVWPWWEWXHWWQXO
      WYGWYEVYEVWAUWHVLWXHVWPWYHVXGVWPWXHWVJWYHWVKWXHWVJQVULVWBWWJWXHVWBVULSZWV
      JWXHVULVVBVWBVUKVVAVNUWIYBZVWBWUSWWJVWBWVHUWJWWNUWKUWLWLYCVULVYFVYEXSXTVW
      PWXHVXGWVJWYFVXKSZWVKWXHVXGWVJUNWYIWYKWXHWVJWYIVXGWYJYCWYIVXKVWBVYERWYFVW
      BVXKWVHWVIUWMVWBVULVYEYNUWNWDUWOYOUWPYCWYCWUDVXLIWYCWUDVWTVXLVXGWXBVWPWXR
      WXHWYAUWQWYBWXBVWTVXLSZVWPWXHWYLVXGVUKVVAVWAYNXFXAYOYKYLYMUWRYRYGUWSWDYPY
      SYGWRYQUWTYTYFUXAWUHWULWUBWUMUNUDVVBUIVYRVVBSZVYTWULWUGWUMWUBWYMVYSWUKCVY
      FVYRVVBVNVOWUFGVYRVVBVPVQVRUXBCVYFDEGUDHIKLMVWAVYEVXFVYDWAUXEWBVIUXCUXFUX
      GUXHYQYGUXIUXJUXKVYCVYKVYIVYBVYKVUIVXIVXNVYKVWRVWPVXGVYKVXCVXGVWPVYKWUQVY
      JVWAVWBWFZVYEVWBWFZWQZVWAVWAVYEVWBUXLWUQWYPVWAPWQVWAWUQWYNVWAWYOPVWPWYNVW
      ASZVXGVWPVWAUXMWYQVVBCVWAUXQVWAUXNWDXGWUQWVOWYOPSZVWPVXGWVJWVOWVKWVRWLWVO
      WVQWYRWVOWVPWVQWVSWVTWDWUSVWBXDZPSZWWOWYRWVQWYSWWMPWUSVWBUXOUXPVYEWUSUXRW
      YTWYRVTVWBVXKWVHWVIUXSWUSVWBVYEUXTUYAWWPUYBWPWDUYCVWAUYSUYDXRXNXOWTXGVWBW
      WJWQVWBWUSWQVYHVWCWWJWUSVWBWWNUYEVWAVYEUYFVWBXLUYGUYHVWGVYLBVYFEVVSVYFSZV
      WDVYIVWFVYKXUAVVTVYHVWCVVSVYFUYIYAXUAVWEVYJVWAVVSVYFVWBUYJYAUYKVRVFUYLUYM
      XFYSYPUYNYPUYOYPXPYTUYPUYQYHVWGBEUYRVIVWNVWHPVWHPVWGBEVWLUYTWNWOVIVUANVUB
      EUAGJVWLVUCYJABCDEFUAGHIJKLMNVUDWD $.
  $}

  ${
    $d A g k $.  $d A k n s t x $.  $d A k n t x y $.  $d C g k $.
    $d C k n s t x $.  $d C k n t x y $.  $d F g k $.  $d F j k n s t x $.
    $d F j k n t x y $.
    axdc3.1 $e |- A e. _V $.
    $( Dependent Choice.  Axiom DC1 of [Schechter] p. 149, with the addition of
       an initial value ` C ` .  This theorem is weaker than the Axiom of
       Choice but is stronger than Countable Choice.  It shows the existence of
       a sequence whose values can only be shown to exist (but cannot be
       constructed explicitly) and also depend on earlier values in the
       sequence.  (Contributed by Mario Carneiro, 27-Jan-2013.) $)
    axdc3 $p |- ( ( C e. A /\ F : A --> ( ~P A \ { (/) } ) ) ->
                E. g ( g : om --> A /\ ( g ` (/) ) = C /\
                  A. k e. om ( g ` suc k ) e. ( F ` ( g ` k ) ) ) ) $=
      ( vx vy vn vt vj vs cv csuc c0 cfv wceq wcel wral com wf w3a wrex cab cdm
      cres wa crab cmpt fveq1 eqeq1d fveq2d eleq12d ralbidv suceq fveq2 cbvralv
      feq1 syl6bb 3anbi123d rexbidv cbvabv eqid axdc3lem4 ) GHABIMZNZAJMZUAZOVG
      PZBQZKMZNZVGPZVKVGPZEPZRZKVESZUBZITUCZJUDZCDIEGVTHMZUEGMZUEZNQWAWCUFWBQUG
      HVTUHUIZLFVSVFALMZUAZOWEPZBQZDMZNZWEPZWIWEPZEPZRZDVESZUBZITUCJLVGWEQZVRWP
      ITWQVHWFVJWHVQWOVFAVGWEURWQVIWGBOVGWEUJUKWQVQVLWEPZVKWEPZEPZRZKVESWOWQVPX
      AKVEWQVMWRVOWTVLVGWEUJWQVNWSEVKVGWEUJULUMUNXAWNKDVEVKWIQZWRWKWTWMXBVLWJWE
      VKWIUOULXBWSWLEVKWIWEUPULUMUQUSUTVAVBWDVCVD $.
  $}

  ${
    $d g h i k m n s t x z A $.  $d g h i k m z C $.  $d g h n s t x z F $.
    $d h i k m z G $.
    axdc4lem.1 $e |- A e. _V $.
    axdc4lem.2 $e |- G = ( n e. om , x e. A |-> ( { suc n } X. ( n F x ) ) ) $.
    $( Lemma for ~ axdc4 .  (Contributed by Mario Carneiro, 31-Jan-2013.)
       (Revised by Mario Carneiro, 16-Nov-2013.) $)
    axdc4lem $p |- ( ( C e. A /\ F : ( om X. A ) --> ( ~P A \ { (/) } ) ) ->
                E. g ( g : om --> A /\ ( g ` (/) ) = C /\
                  A. k e. om ( g ` suc k ) e. ( k F ( g ` k ) ) ) ) $=
      ( vz wcel com c0 wa cfv wceq wex wi c2nd vh vm vi vt vs cxp cpw csn wf cv
      cdif cop csuc wral co peano1 opelxpi mpan simp2 fovrn peano2 snssd eldifi
      w3a wss elpw2 xpss12 sylan2b syl2an snex ovex xpex elpw sylibr syl2anc wn
      eldifn wne elsnc necon3bbii vex sucex snnz xpnz biimpi 3syl eldifd 3expib
      sylbi ralrimivv fmpt2 sylib dcomex axdc3 ccom 2ndcof 3ad2ant1 adantl fex2
      cvv mp3an23 syl fvco3 mpan2 fveq2 3ad2ant2 eqtrd nfv opeq1 eqeq12d exbidv
      weq opeq2 eqeq2d spcegv imp df-ov simplr ffvelrn eleq1 syl6bi suceq sneqd
      opelxp2 oveq1 xpeq12d oveq2 xpeq2d ovmpt2 fveq2d eleq12d elxp com3l com12
      exlimiv op2nd syl6eq oveq2d ex fveq1 sylan9eqr nfra1 nf3an nfan 3ad2antr2
      op2ndg syl6eqr mpan9 rspcv eleq2 elsn biimpac adantrr eximi expcom cbvexv
      ad2antlr sylsyld syl8ib impancom finds2 ralrimiv rspccv 3impia simp21 rsp
      3adant2 simp3 3ad2antl3 3adant1 simpl simprr syl5eqr eleq2d sylan2 simpll
      syl5 biimprcd exp4c impcom sylbid 3imp syl121anc 3expia ralrimi 3jca feq1
      exlimivv eqeq1d ralbidv 3anbi123d sylc exlimdv adantr mpd ) CBLZMBUFZBUGZ
      NUHZUKZGUIZOMUWQUAUJZUIZNUXBPZNCULZQZEUJZUMZUXBPZUXGUXBPZHPZLZEMUNZVDZUAR
      ZMBDUJZUIZNUXPPZCQZUXHUXPPZUXGUXGUXPPZGUOZLZEMUNZVDZDRZUWPUXEUWQLZUWQUWQU
      GZUWSUKZHUIZUXOUXANMLZUWPUYGUPNCMBUQURUXAFUJZUMZUHZUYLAUJZGUOZUFZUYILZABU
      NFMUNUYJUXAUYRFAMBUXAUYLMLZUYOBLZUYRUXAUYSUYTVDZUYQUYHUWSVUAUYSUYPUWTLZUY
      QUYHLZUXAUYSUYTUSUYLUYOUWTMBGUTZUYSVUBOUYQUWQVEZVUCUYSUYNMVEZUYPUWRLZVUEV
      UBUYSUYMMUYLVAVBUYPUWRUWSVCVUGVUFUYPBVEVUEUYPBIVFUYNMUYPBVGVHVIUYQUWQUYNU
      YPUYMVJUYLUYOGVKZVLZVMVNVOVUAVUBUYPUWSLZVPZUYQUWSLZVPZVUDUYPUWRUWSVQVUKUY
      QNVRZVUMVUKUYPNVRZVUNVUJUYPNUYPNVUHVSVTUYNNVRZVUOVUNUYMUYLFWAWBWCVUPVUOOV
      UNUYNUYPWDWEURWIVULUYQNUYQNVUIVSVTVNWFWGWHWJFAMBUYQUYIHJWKWLUWQUXEUAEHMBW
      MIVLWNVIUWPUXOUYFSUXAUWPUXNUYFUAUWPUXNUYFUWPUXNOZTUXBWOZWTLZMBVURUIZNVURP
      ZCQZUXHVURPZUXGUXGVURPZGUOZLZEMUNZVDZUYFVUQVUTVUSUXNVUTUWPUXCUXFVUTUXMMMB
      UXBWPWQWRZVUTMWTLBWTLVUSWMIMBVURWTWTWSXAXBVUQVUTVVBVVGVVIUXNUWPVVAUXETPZC
      UXNVVAUXDTPZVVJUXCUXFVVAVVKQZUXMUXCUYKVVLUPMUWQNTUXBXCXDWQUXFUXCVVKVVJQUX
      MUXDUXETXEXFXGUYKUWPVVJCQUPNCMBUUFURUUAVUQVVFEMUWPUXNEUWPEXHUXCUXFUXMEUXC
      EXHUXFEXHUXLEMUUBUUCUUDUWPUXNUXGMLZVVFUWPUXNVVMVDUXJUXGKUJZULZQZKRZUXCVVM
      UXLVVFUWPUXNVVMVVQVUQUBUJZUXBPZVVRVVNULZQZKRZUBMUNVVMVVQSVUQVWBUBMVVRMLVU
      QVWBVWBUXDNVVNULZQZKRZUCUJZUXBPZVWFVVNULZQZKRZVWFUMZUXBPZVWKVVNULZQZKRZVU
      QUBUCVVRNQZVWAVWDKVWPVVSUXDVVTVWCVVRNUXBXEVVRNVVNXIXJXKUBUCXLZVWAVWIKVWQV
      VSVWGVVTVWHVVRVWFUXBXEVVRVWFVVNXIXJXKVVRVWKQZVWAVWNKVWRVVSVWLVVTVWMVVRVWK
      UXBXEVVRVWKVVNXIXJXKUWPUXCUXFVWEUXMUWPUXFVWEVWDUXFKCBVVNCQVWCUXEUXDVVNCNX
      MXNXOXPUUEVUQVWFMLZVWJVWOSZUXNVWSVWTSZUWPUXCUXMVXAUXFUXCVWSUXMVWTUXCVWSOZ
      UXMVWJVWLVWKUDUJZULZQZUDRZVWOVWJVXBUXMVXFVWIVXBUXMVXFSZSKVXBVWIVXGVXBVWIO
      ZVWGHPZVWKUHZVWFVVNGUOZUFZQZUXMVWLVXILZVXFVXHVXIVWFVVNHUOZVXLVWIVXIVXOQVX
      BVWIVXIVWHHPVXOVWGVWHHXEVWFVVNHXQUUGWRVXHVWSVVNBLZVXOVXLQUXCVWSVWIXRVXBVW
      GUWQLZVWIVXPMUWQVWFUXBXSVWIVXQVWHUWQLVXPVWGVWHUWQXTVWFVVNMBYDYAUUHFAVWFVV
      NMBUYQVXLHVXJVWFUYOGUOZUFFUCXLZUYNVXJUYPVXRVXSUYMVWKUYLVWFYBYCUYLVWFUYOGY
      EYFAKXLZVXRVXKVXJUYOVVNVWFGYGYHJVXJVXKVWKVJVWFVVNGVKVLYIVOXGVWSUXMVXNSUXC
      VWIUXLVXNEVWFMEUCXLZUXIVWLUXKVXIVYAUXHVWKUXBUXGVWFYBYJVYAUXJVWGHUXGVWFUXB
      XEYJYKUUIUUQVXMVXNVWLVXLLZVXFVXIVXLVWLUUJVYBVWLUEUJZVXCULZQZVYCVXJLZVXCVX
      KLZOOZUDRZUERVXFUEUDVWLVXJVXKYLVYIVXFUEVYHVXEUDVYEVYFVXEVYGVYFVYEVXEVYFVY
      DVXDVWLVYFVYCVWKQVYDVXDQUEVWKUUKVYCVWKVXCXIWIXNUULUUMUUNYOWIYAUURUUOYOYMV
      XEVWNUDKUDKXLVXDVWMVWLVXCVVNVWKXMXNUUPUUSUUTUVGWRYNUVAYNUVBVWBVVQUBUXGMUB
      EXLZVWAVVPKVYJVVSUXJVVTVVOVVRUXGUXBXEVVRUXGVVNXIXJXKUVCXBUVDUWPUXCUXFUXMV
      VMUVEUWPUXNVVMUVHUXNVVMUXLUWPUXMUXCVVMUXLUXFUXMVVMUXLUXLEMUVFXPUVIUVJVVQU
      XCVVMOZUXLVVFVVPVYKUXLVVFSZSKVVPVYKVYLVVPVYKOZUXLUXIUXHUHZUXGVVNGUOZUFZLZ
      VVFVYMUXKVYPUXIVYMUXKVVOHPZVYPVYMUXJVVOHVVPVYKUVKYJVYMVVMVXPVYRVYPQVVPUXC
      VVMUVLVVPVYKVXPVYKUXJUWQLZVVPVXPMUWQUXGUXBXSVVPVYSVVOUWQLVXPUXJVVOUWQXTUX
      GVVNMBYDYAUVQXPVVMVXPOVYRUXGVVNHUOVYPUXGVVNHXQFAUXGVVNMBUYQVYPHVYNUXGUYOG
      UOZUFFEXLZUYNVYNUYPVYTWUAUYMUXHUYLUXGYBYCUYLUXGUYOGYEYFVXTVYTVYOVYNUYOVVN
      UXGGYGYHJVYNVYOUXHVJUXGVVNGVKVLYIUVMVOXGUVNVVPVYKVYQVVFSVYQVVPVYKVVFVYQUX
      IVYDQZVYCVYNLZVXCVYOLZOZOZUDRUERVVPVYKVVFSSZUEUDUXIVYNVYOYLWUFWUGUEUDWUEW
      UBWUGWUDWUBWUGSWUCWUDWUBVVPVYKVVFWUBVVPOZVYKOZVVFWUDWUIVVCVXCVVEVYOWUIVVC
      VYDTPZVXCWUIVVCUXITPZWUJVYKVVCWUKQZWUHVVMUXCUXHMLWULUXGVAMUWQUXHTUXBXCUVO
      WRWUIUXIVYDTWUBVVPVYKUVPYJXGVYCVXCUEWAUDWAYPYQWUIVVDVVNUXGGWUIVVDVVOTPZVV
      NWUIVVDUXJTPZWUMVYKVVDWUNQWUHMUWQUXGTUXBXCWRWUIUXJVVOTWUBVVPVYKXRYJXGUXGV
      VNEWAKWAYPYQYRYKUVRUVSWRUVTUWHWIYMXPUWAYSYOUWBUWCUWDUWEUWFUYEVVHDVURWTUXP
      VURQZUXQVUTUXSVVBUYDVVGMBUXPVURUWGWUOUXRVVACNUXPVURYTUWIWUOUYCVVFEMWUOUXT
      VVCUYBVVEUXHUXPVURYTWUOUYAVVDUXGGUXGUXPVURYTYRYKUWJUWKXOUWLYSUWMUWNUWO $.
  $}

  ${
    $d A g k n x $.  $d C g k $.  $d F g k n x $.
    axdc4.1 $e |- A e. _V $.
    $( A more general version of ~ axdc3 that allows the function ` F ` to vary
       with ` k ` .  (Contributed by Mario Carneiro, 31-Jan-2013.) $)
    axdc4 $p |- ( ( C e. A /\ F : ( om X. A ) --> ( ~P A \ { (/) } ) ) ->
                E. g ( g : om --> A /\ ( g ` (/) ) = C /\
                  A. k e. om ( g ` suc k ) e. ( k F ( g ` k ) ) ) ) $=
      ( vx vn com cv csuc csn co cxp cmpt2 eqid axdc4lem ) GABCDHEHGIAHJZKLRGJE
      MNOZFSPQ $.
  $}

  ${
    $d A c f h $.  $d A f h i n y $.  $d A c h k $.  $d A f h w z $.
    $d F c h k $.  $d F h i k z $.  $d G g z $.  $d G i z $.  $d f g h x $.
    axcclem.1 $e |- A = ( x \ { (/) } ) $.
    axcclem.2 $e |- F = ( n e. om , y e. U. A |-> ( f ` n ) ) $.
    axcclem.3 $e |- G = ( w e. A |-> ( h ` suc ( `' f ` w ) ) ) $.
    $( Lemma for ~ axcc .  (Contributed by Mario Carneiro, 2-Feb-2013.)
       (Revised by Mario Carneiro, 16-Nov-2013.) $)
    axcclem $p |- ( x ~~ om ->
       E. g A. z e. x ( z =/= (/) -> ( g ` z ) e. z ) ) $=
      ( com c0 cfv wcel cvv wceq vk vc vi cv cen wbr wne wi wral wex cdom wn wa
      csdm cfn isfinite2 csn cdif eleq1i undif1 snfi unfi mpan2 syl5eqelr ssun1
      cun wss ssfi sylancl sylbi wb isfiniteg ax-mp sdomnen 3syl con2i sdomentr
      dcomex expcom mtod vex difss eqsstri ssdomg mp2 jctil sylibr entr mpancom
      bren2 ensym wf1o bren cuni wf csuc f1of peano1 ffvelrn eldifn eleq2s fvex
      co elsnc notbii bitr2i syl w3a cxp elunii sylan2 ffvelrnda difabs difeq1i
      neq0 cpw 3eqtr4i pwuni ssdif sseli ralrimivw ralrimiva fmpt2 sylib adantl
      eqsstr3i difexg eqeltri uniex axdc4 syl2anc exlimiv suceq fveq2d 3ad2ant3
      fveq2 imp 3adant1 3adant2 3ad2ant1 3simpb eximi ex elsn necon3bbii eleq2i
      mpcom eldif bitri biimpri sylan2br simpl wrex wfo f1ofo foelrn sylan ccnv
      id oveq12d eleq12d rspcv 3adant3 eqcom f1ocnvfv syl5bi eqcomd simpr eqidd
      ovmpt2 3eltr3d eleq1 mpbird fvmpt simp3 3eltr4d 3exp com3r 3expd rexlimiv
      com4r mpid imp3a impancom syl5 exp3a cmpt fvrn0 rgenw eqid fmpt mpbi rnex
      ralrimiv p0ex unex fex2 mp3an fveq1 eleq1d imbi2d ralbidv spcev exlimddv
      crn ) AUDZOUEUFZEOUEUFZOEUEUFZCUDZPUGZUXJGUDZQZUXJRZUHZCUXFUIZGUJZEUXFUEU
      FZUXGUXHUXGEUXFUKUFZEUXFUNUFZULZUMUXRUXGUYAUXSUXGUXTEOUNUFZUYBUXGUYBEUORZ
      UXFUORZUXGULZEUPUYCUXFPUQZURZUORZUYDEUYGUOLUSUYHUXFUYFVFZUORUXFUYIVGUYDUY
      HUYIUYGUYFVFZUOUXFUYFUTUYHUYFUORUYJUORPVAUYGUYFVBVCVDUXFUYFVEUYIUXFVHVIVJ
      UYDUXFOUNUFZUYEOSRUYDUYKVKVRUXFVLVMUXFOVNVJVOVPUXTUXGUYBEUXFOVQVSVTUXFSRZ
      EUXFVGUXSAWAZEUYGUXFLUXFUYFWBWCEUXFSWDWEWFEUXFWJWGEUXFOWHWIEOWKUXIOEFUDZW
      LZFUJUXQOEFWMUYOUXQFUYOOEWNZHUDZWOZUAUDZWPZUYQQZUYSUYSUYQQZJXCZRZUAOUIZUM
      ZUXQHUBUDZPUYNQZRZUBUJZUYOVUFHUJZUYOVUHERZVUJUYOOEUYNWOPORVULOEUYNWQZWROE
      PUYNWSVIZVULVUHUYFRZULZVUJVUPVUHUYGEVUHUXFUYFWTLXAVUPVUHPTZULVUJVUOVUQVUH
      PPUYNXBXDXEUBVUHXOXFWGXGVUIUYOVUKUHUBVUIUYOVUKVUIUYOUMZUYRPUYQQVUGTZVUEXH
      ZHUJZVUKVURVUGUYPRZOUYPXIUYPXPZUYFURZJWOZVVAUYOVUIVULVVBVUNVUGVUHEXJXKUYO
      VVEVUIUYOIUDZUYNQZVVDRZBUYPUIZIOUIVVEUYOVVIIOUYOVVFORUMVVGERZVVIUYOOEVVFU
      YNVUMXLVVJVVHBUYPEVVDVVGEEUYFURZVVDUYGUYFURUYGVVKEUXFUYFXMEUYGUYFLXNLXQEV
      VCVGVVKVVDVGEXREVVCUYFXSVMYFXTYAXGYBIBOUYPVVGVVDJMYCYDYEUYPVUGHUAJEEUYGSL
      UYLUYGSRUYMUXFUYFSYGVMYHZYIYJYKVUTVUFHUYRVUSVUEUUAUUBXGUUCYLUUGUYOVUFUMZU
      XKUXJKQZUXJRZUHZCUXFUIZUXQVVMVVPCUXFVVMUXJUXFRZUXKVVOVVRUXKUMUXJERZVVMVVO
      UXKVVRUXJUYFRZULZVVSVVTUXJPCPUUDUUEVVSVVRVWAUMZVVSUXJUYGRVWBEUYGUXJLUUFUX
      JUXFUYFUUHUUIUUJUUKUYOVVSVUFVVOUYOVVSUMZUYRVUEVVOVWCUYRUYOVUEVVOUHZUYOVVS
      UULVWCUXJUCUDZUYNQZTZUCOUUMZUYRUYOVWDUHUHZUYOOEUYNUUNVVSVWHOEUYNUUOUCOEUX
      JUYNUUPUUQVWGVWIUCOVWGUYRUYOVWEORZVWDVWGUYRUYOVWJVWDUYRUYOVWJXHZVUEVWGVVO
      VWKVUEVWGVVOVWKVUEVWGXHZUXJUYNUURZQZWPZUYQQZVWFVVNUXJVWLVWEWPZUYQQZVWEVWE
      UYQQZJXCZVWPVWFVWKVUEVWRVWTRZVWGVWKVUEVXAVWJUYRVUEVXAUHUYOVUDVXAUAVWEOUYS
      VWETZVUAVWRVUCVWTVXBUYTVWQUYQUYSVWEYMYNVXBUYSVWEVUBVWSJVXBUUSUYSVWEUYQYPU
      UTUVAUVBYOYQUVCVWLVWQVWOUYQVWLVWEVWNTZVWQVWOTVWKVWGVXCVUEVWKVWGUMVWNVWEVW
      KVWGVWNVWETZUYOVWJVWGVXDUHUYRVWGVWFUXJTUYOVWJUMVXDUXJVWFUVDOEVWEUXJUYNUVE
      UVFYRYQUVGYSVWEVWNYMXGYNVWKVUEVWTVWFTZVWGUYRVWJVXEUYOUYRVWJUMVWJVWSUYPRVX
      EUYRVWJUVHOUYPVWEUYQWSIBVWEVWSOUYPVVGVWFJVWFVVFVWEUYNYPBUDVWSTVWFUVIMVWEU
      YNXBUVJYKYSYTUVKVWLVVSVVNVWPTVWLVVSVWFERZVWKVUEVXFVWGUYOVWJVXFUYRUYOOEVWE
      UYNVUMXLYRYTVWGVWKVVSVXFVKVUEUXJVWFEUVLYOUVMDUXJDUDZVWMQZWPZUYQQZVWPEKVXG
      UXJTZVXIVWOUYQVXKVXHVWNTVXIVWOTVXGUXJVWMYPVXHVWNYMXGYNNVWOUYQXBUVNXGVWKVU
      EVWGUVOUVPUVQUVRUVSUWAUVTXGUWBUWCUWDUWEUWFUWNUXPVVQGKKDEVXJUWGZSNEUYQUXEZ
      UYFVFZVXLWOZESRVXNSRVXLSRVXJVXNRZDEUIVXOVXPDEUYQVXIUWHUWIDEVXNVXJVXLVXLUW
      JUWKUWLVVLVXMUYFUYQHWAUWMUWOUWPEVXNVXLSSUWQUWRYHUXLKTZUXOVVPCUXFVXQUXNVVO
      UXKVXQUXMVVNUXJUXJUXLKUWSUWTUXAUXBUXCXGUXDYLVJVO $.
  $}

  ${
    $d f t u v w x y z $.
    $( Although CC can be proven trivially using ~ ac5 , we prove it here using
       DC. (New usage is discouraged.)  (Contributed by Mario Carneiro,
       2-Feb-2013.) $)
    axcc $p |- ( x ~~ om ->
       E. f A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) ) $=
      ( vy vw vv vu vt cv c0 csn cdif com cuni cfv cmpt2 ccnv csuc cmpt eqid
      axcclem ) ADBEAIJKLZFCGHHDMUBNHIFIZOPZEUBEIUCQORGIOSZUBTUDTUETUA $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             ZFC Set Theory - add the Axiom of Choice
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Introduce the Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u t $.
    $( Axiom of Choice.  The Axiom of Choice (AC) is usually considered an
       extension of ZF set theory rather than a proper part of it.  It is
       sometimes considered philosophically controversial because it asserts
       the existence of a set without telling us what the set is.  ZF set
       theory that includes AC is called ZFC.

       The unpublished version given here says that given any set ` x ` , there
       exists a ` y ` that is a collection of unordered pairs, one pair for
       each non-empty member of ` x ` .  One entry in the pair is the member of
       ` x ` , and the other entry is some arbitrary member of that member of
       ` x ` .  See the rewritten version ~ ac3 for a more detailed
       explanation.  Theorem ~ ac2 shows an equivalent written compactly with
       restricted quantifiers.

       This version was specifically crafted to be short when expanded to
       primitives.  Kurt Maes' 5-quantifier version ~ ackm is slightly shorter
       when the biconditional of ~ ax-ac is expanded into implication and
       negation.  In ~ axac3 we allow the constant ` CHOICE ` to represent the
       Axiom of Choice; this simplifies the representation of theorems like
       ~ gchac (the Generalized Continuum Hypothesis implies the Axiom of
       Choice).

       Standard textbook versions of AC are derived as ~ ac8 , ~ ac5 , and
       ~ ac7 .  The Axiom of Regularity ~ ax-reg (among others) is used to
       derive our version from the standard ones; this reverse derivation is
       shown as theorem ~ dfac2 .  Equivalents to AC are the well-ordering
       theorem ~ weth and Zorn's lemma ~ zorn .  See ~ ac4 for comments about
       stronger versions of AC.

       In order to avoid uses of ~ ax-reg for derivation of AC equivalents, we
       provide ~ ax-ac2 (due to Kurt Maes), which is equivalent to the standard
       AC of textbooks.  The derivation of ~ ax-ac2 from ~ ax-ac is shown by
       theorem ~ axac2 , and the reverse derivation by ~ axac .  Therefore, new
       proofs should normally use ~ ax-ac2 instead.
       (New usage is discouraged.)  (Contributed by NM, 18-Jul-1996.) $)
    ax-ac $a |- E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u ( E. t
              ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) $.

    $( Axiom of Choice expressed with the fewest number of different
       variables.  The penultimate step shows the logical equivalence to
       ~ ax-ac .  (New usage is discouraged.)  (Contributed by NM,
       14-Aug-2003.) $)
    zfac $p |- E. x A. y A. z ( ( y e. z /\ z e. w ) -> E. w A. y ( E. w
              ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) $=
      ( vu vt vv wel wa wex weq wal elequ2 elequ1 anbi12d cbvexv syl6bb anbi1d
      wb wi ax-ac bibi2d anbi2d bibi1i albidv exbidv cbvalv imbi2i 2albii exbii
      equequ2 equequ1 bibi12d mpbi ) BCHZCDHZIZECHZCFHZIZEFHZFAHZIZIZFJZEGKZSZE
      LZGJZTZCLBLZAJUQUQBDHZDAHZIZIZDJZBDKZSZBLZDJZTZCLBLZAJDABCGEFUAVKWBAVJWAB
      CVIVTUQVHVSGDGDKZVHURUPIZEDHZVMIZIZDJZEDKZSZELVSWCVGWJEWCVGVEWISWJWCVFWIV
      EGDEUKUBVEWHWIVDWGFDFDKZUTWDVCWFWKUSUPURFDCMUCWKVAWEVBVMFDEMFDANOOPUDQUEW
      JVREBEBKZWHVPWIVQWLWGVODWLWDUQWFVNWLURUOUPEBCNRWLWEVLVMEBDNROUFEBDULUMUGQ
      PUHUIUJUN $.

    $( Axiom of Choice equivalent.  By using restricted quantifiers, we can
       express the Axiom of Choice with a single explicit conjunction.  (If you
       want to figure it out, the rewritten equivalent ~ ac3 is easier to
       understand.)  Note: ~ aceq0 shows the logical equivalence to ~ ax-ac .
       (New usage is discouraged.)  (Contributed by NM, 18-Jul-1996.) $)
    ac2 $p |- E. y A. z e. x A. w e. z E! v e. z E. u e. y
              ( z e. u /\ v e. u ) $=
      ( vt wel wa cv wrex wreu wral wex weq wb wal wi ax-ac aceq0 mpbir ) CFHEF
      HIFBJKECJZLDUBMCAJMBNCDHDAHIFDHDGHIFGHGBHIIGNFEOPFQENRDQCQBNABCDEFGSABCDE
      FGTUA $.
  $}

  ${
    $d x y z w v u $.
    $( Axiom of Choice using abbreviations.  The logical equivalence to ~ ax-ac
       can be established by chaining ~ aceq0 and ~ aceq2 .  A standard
       textbook version of AC is derived from this one in ~ dfac2a , and this
       version of AC is derived from the textbook version in ~ dfac2 .

       The following sketch will help you understand this version of the
       axiom.  Given any set ` x ` , the axiom says that there exists a ` y `
       that is a collection of unordered pairs, one pair for each non-empty
       member of ` x ` .  One entry in the pair is the member of ` x ` , and
       the other entry is some arbitrary member of that member of ` x ` .
       Using the Axiom of Regularity, we can show that ` y ` is really a set of
       _ordered_ pairs, very similar to the ordered pair construction
       ~ opthreg .  The key theorem for this (used in the proof of ~ dfac2 ) is
       ~ preleq .  With this modified definition of ordered pair, it can be
       seen that ` y ` is actually a choice function on the members of ` x ` .

       For example, suppose
       ` x = { { 1 , 2 } , { 1 , 3 } , { 2 , 3 , 4 } } ` .  Let us try
       ` y = { { { 1 , 2 } , 1 } , { { 1 , 3 } , 1 } , `
       ` { { 2 , 3 , 4 } , 2 } } ` .  For the member (of ` x ` )
       ` z = { 1 , 2 } ` , the only assignment to ` w ` and ` v ` that
       satisfies the axiom is ` w = 1 ` and ` v = { { 1 , 2 } , 1 } ` , so
       there is exactly one ` w ` as required.  We verify the other two members
       of ` x ` similarly.  Thus, ` y ` satisfies the axiom.  Using our
       modified ordered pair definition, we can say that ` y ` corresponds to
       the choice function ` { <. { 1 , 2 } , 1 >. , <. { 1 , 3 } , 1 >. , `
       ` <. { 2 , 3 , 4 } , 2 >. } ` .  Of course other choices for ` y ` will
       also satisfy the axiom, for example
       ` y = { { { 1 , 2 } , 2 } , { { 1 , 3 } , 1 } , `
       ` { { 2 , 3 , 4 } , 4 } } ` .  What AC tells us is that there exists at
       least one such ` y ` , but it doesn't tell us which one.

       (New usage is discouraged.)  (Contributed by NM, 19-Jul-1996.) $)
    ac3 $p |- E. y A. z e. x ( z =/= (/) -> E! w e. z E. v e. y
              ( z e. v /\ w e. v ) ) $=
      ( vu wel wa cv wrex wreu wral wex c0 wne wi ac2 aceq2 mpbi ) CFGEFGHFBIZJ
      ECIZKDUALCAIZLBMUANOCEGDEGHETJDUAKPCUBLBMABCDEFQABCDEFRS $.
  $}

  ${
    $d x y z v u $.
    $( In order to avoid uses of ~ ax-reg for derivation of AC equivalents, we
       provide ~ ax-ac2 , which is equivalent to the standard AC of textbooks.
       This appears to be the shortest known equivalent to the standard AC when
       expressed in terms of set theory primitives.  It was found by Kurt Maes
       as theorem ~ ackm .  We removed the leading quantifier to make it
       slightly shorter, since we have ~ ax-gen available.  The derivation of
       ~ ax-ac2 from ~ ax-ac is shown by theorem ~ axac2 , and the reverse
       derivation by ~ axac .  Note that we use ~ ax-reg to derive ~ ax-ac from
       ~ ax-ac2 , but not to derive ~ ax-ac2 from ~ ax-ac .  (Contributed by
       NM, 19-Dec-2016.) $)
    ax-ac2 $a |- E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) $.
  $}

  ${
    $d v w x y z $.
    $( This theorem asserts that the constant ` CHOICE ` is a theorem, thus
       eliminating it as a hypothesis while assuming ~ ax-ac2 as an axiom.
       (Contributed by Mario Carneiro, 6-May-2015.)  (Revised by NM,
       20-Dec-2016.)  (Proof modification is discouraged.) $)
    axac3 $p |- CHOICE $=
      ( vy vx vz vw vv wac wel weq wn wa wi wal wex ax-ac2 ax-gen dfackm mpbir
      wo ) FABGZCAGDBGADHIJCDGJKJSICBGDCGDAGJECGEAGJEDHKJKJRELDMCLAMZBLTBBACDEN
      OBACDEPQ $.
  $}

  ${
    $d x y z w v u f t h $.
    $( A remarkable equivalent to the Axiom of Choice that has only 5
       quantifiers (when expanded to ` e. ` , ` = ` primitives in prenex form),
       discovered and proved by Kurt Maes.  This establishes a new record,
       reducing from 6 to 5 the largest number of quantified variables needed
       by any ZFC axiom.  The ZF-equivalence to AC is shown by theorem
       ~ dfackm .  Maes found this version of AC in April, 2004 (replacing a
       longer version, also with 5 quantifiers, that he found in November,
       2003).  See Kurt Maes, "A 5-quantifier ( ` e. ` ,=)-expression
       ZF-equivalent to the Axiom of Choice"
       ( ~ http://arxiv.org/PS_cache/arxiv/pdf/0705/0705.3162v1.pdf ).

       The original FOM posts are:
       ~ http://www.cs.nyu.edu/pipermail/fom/2003-November/007631.html
       ~ http://www.cs.nyu.edu/pipermail/fom/2003-November/007641.html .
       (Contributed by NM, 29-Apr-2004.)  (Revised by Mario Carneiro,
       17-May-2015.)  (Proof modification is discouraged.) $)
    ackm $p |- A. x E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) $=
      ( wac cv wcel wceq wn wa wi wo wal wex axac3 dfackm mpbi ) FBGZAGZHZCGZSH
      DGZTHSUCIJKUBUCHKLKUAJUBTHUCUBHUCSHKEGZUBHUDSHKUDUCILKLKMENDOCNBOANPABCDE
      QR $.
  $}

  $(
     Maes expanded to primitives -  94 symbols
     A.  4
     e. 10
     -> 11
     -. 17
     (  11
     )  11
     =   2
     var occ 28
     vars 5

     -. A. y -. A. z -. A. v -. A. u ( ( y e. x -> -. ( z e. y -> -. ( -. ( v
     e. x -> y = v ) -> -. z e. v ) ) ) -> -. ( -. y e. x -> -. ( z e. x ->
     -. ( -. ( v e. z -> -. v e. y ) -> -. ( -. ( u e. z -> -. u e. y ) -> u
     = v ) ) ) ) )

     ax-ac expanded to primitives - 99 symbols

     A.  7
     e. 10
     -> 11
     -. 16
     (  11
     )  11
     =   2
     var occ 31
     vars 7

     -. A. y -. A. z A. w ( -. ( z e. w -> -. w e. x ) -> -. A. v -. A. u -.
     ( ( -. A. t ( -. ( u e. w -> -. w e. t ) -> ( u e. t -> -. t e. y ) ) ->
     u = v ) -> -. ( u = v -> -. A. t ( -. ( u e. w -> -. w e. t ) -> ( u e.
     t -> -. t e. y ) ) ) ) )
  $)

  ${
    $d x y z v u $.
    $( Derive ~ ax-ac2 from ~ ax-ac .  (Contributed by NM, 19-Dec-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    axac2 $p |- E. y A. z E. v A. u (
       ( y e. x /\ ( z e. y -> ( ( v e. x /\ -. y = v ) /\ z e. v ) ) ) \/
           ( -. y e. x /\ ( z e. x -> ( ( v e. z /\ v e. y ) /\
               ( ( u e. z /\ u e. y ) ->
                   u = v ) ) ) ) ) $=
      ( wel weq wn wa wi wo wal wex wac cv c0 wne wrex wreu wral dfac2a ac3 mpg
      dfackm mpbi spi ) BAFZCBFDAFBDGHICDFIJIUGHCAFDCFDBFIECFEBFIEDGJIJIKELDMCL
      BMZANUHALCOZPQCEFDEFIEBORDUISJCAOTBMNAABCDEUAABCDEUBUCABCDEUDUEUF $.
  $}

  ${
    $d x y z w v u t $.
    $( Derive ~ ax-ac from ~ ax-ac2 .  Note that ~ ax-reg is used by the
       proof.  (Contributed by NM, 19-Dec-2016.)
       (Proof modification is discouraged.) $)
    axac $p |- E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u ( E. t
              ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) $=
      ( wel wa wex weq wb wal wi wac axac3 dfac0 mpbi spi ) CDHDAHIFDHDGHIFGHGB
      HIIGJFEKLFMEJNDMCMBJZAOTAMPABCDEFGQRS $.
  $}

  ${
    axaci.1 $e |- ( CHOICE <-> A. x ph ) $.
    $( Apply a choice equivalent.  (Contributed by Mario Carneiro,
       17-May-2015.) $)
    axaci $p |- ph $=
      ( wac wal axac3 mpbi spi ) ABDABEFCGH $.
  $}

  ${
    $d f x y z A $.
    $( All sets are well-orderable under choice.  (Contributed by Mario
       Carneiro, 28-Apr-2015.) $)
    cardeqv $p |- dom card = _V $=
      ( wac ccrd cdm cvv wceq axac3 dfac10 mpbi ) ABCDEFGH $.

    $( All sets are well-orderable under choice.  (Contributed by Stefan
       O'Rear, 28-Feb-2015.) $)
    numth3 $p |- ( A e. V -> A e. dom card ) $=
      ( wcel cvv ccrd cdm elex cardeqv syl6eleqr ) ABCADEFABGHI $.

    numth.1 $e |- A e. _V $.
    $( Numeration theorem: any set is equinumerous to some ordinal (using AC).
       Theorem 10.3 of [TakeutiZaring] p. 84.  (Contributed by NM,
       20-Oct-2003.) $)
    numth2 $p |- E. x e. On x ~~ A $=
      ( ccrd cdm wcel cv cen wbr con0 wrex cvv numth3 ax-mp isnum2 mpbi ) BDEFZ
      AGBHIAJKBLFQCBLMNABOP $.

    $( Numeration theorem: every set can be put into one-to-one correspondence
       with some ordinal (using AC).  Theorem 10.3 of [TakeutiZaring] p. 84.
       (Contributed by NM, 10-Feb-1997.)  (Proof shortened by Mario Carneiro,
       8-Jan-2015.) $)
    numth $p |- E. x e. On E. f f : x -1-1-onto-> A $=
      ( cv cen wbr con0 wrex wf1o wex numth2 bren rexbii mpbi ) AEZBFGZAHIPBCEJ
      CKZAHIABDLQRAHPBCMNO $.
  $}

  ${
    $d x f $.
    $( An Axiom of Choice equivalent similar to the Axiom of Choice (first
       form) of [Enderton] p. 49.  (Contributed by NM, 29-Apr-2004.) $)
    ac7 $p |- E. f ( f C_ x /\ f Fn dom x ) $=
      ( cv wss cdm wfn wa wex df-ac axaci ) BCZACZDKLEFGBHAABIJ $.
  $}

  ${
    $d f x R $.
    $( An Axiom of Choice equivalent similar to the Axiom of Choice (first
       form) of [Enderton] p. 49.  (Contributed by NM, 23-Jul-2004.) $)
    ac7g $p |- ( R e. A -> E. f ( f C_ R /\ f Fn dom R ) ) $=
      ( vx cv wss cdm wfn wex wceq sseq2 dmeq fneq2d anbi12d exbidv ac7 vtoclg
      wa ) CEZDEZFZSTGZHZRZCISBFZSBGZHZRZCIDBATBJZUDUHCUIUAUEUCUGTBSKUIUBUFSTBL
      MNODCPQ $.
  $}

  ${
    $d x z f $.
    $( Equivalent of Axiom of Choice.  We do not insist that ` f ` be a
       function.  However, theorem ~ ac5 , derived from this one, shows that
       this form of the axiom does imply that at least one such set ` f ` whose
       existence we assert is in fact a function.  Axiom of Choice of
       [TakeutiZaring] p. 83.

       Takeuti and Zaring call this "weak choice" in contrast to "strong
       choice" ` E. F A. z ( z =/= (/) -> ( F `` z ) e. z ) ` , which asserts
       the existence of a universal choice function but requires second-order
       quantification on (proper) class variable ` F ` and thus cannot be
       expressed in our first-order formalization.  However, it has been shown
       that ZF plus strong choice is a conservative extension of ZF plus weak
       choice.  See Ulrich Felgner, "Comparison of the axioms of local and
       universal choice," _Fundamenta Mathematica_, 71, 43-62 (1971).

       Weak choice can be strengthened in a different direction to choose from
       a collection of proper classes; see ~ ac6s5 .  (Contributed by NM,
       21-Jul-1996.) $)
    ac4 $p |- E. f A. z e. x ( z =/= (/) -> ( f ` z ) e. z ) $=
      ( cv c0 wne cfv wcel wi wral wex dfac3 axaci ) BDZEFNCDGNHIBADJCKAABCLM
      $.
  $}

  ${
    $d x y f A $.
    ac4c.1 $e |- A e. _V $.
    $( Equivalent of Axiom of Choice (class version) (Contributed by NM,
       10-Feb-1997.) $)
    ac4c $p |- E. f A. x e. A ( x =/= (/) -> ( f ` x ) e. x ) $=
      ( vy cv c0 wne cfv wcel wi wral wex wceq raleq exbidv ac4 vtocl ) AFZGHSC
      FISJKZAEFZLZCMTABLZCMEBDUABNUBUCCTAUABOPEACQR $.
  $}

  ${
    $d f x y A $.
    ac5.1 $e |- A e. _V $.
    $( An Axiom of Choice equivalent: there exists a function ` f ` (called a
       choice function) with domain ` A ` that maps each nonempty member of the
       domain to an element of that member.  Axiom AC of [BellMachover]
       p. 488.  Note that the assertion that ` f ` be a function is not
       necessary; see ~ ac4 .  (Contributed by NM, 29-Aug-1999.) $)
    ac5 $p |- E. f ( f Fn A /\ A. x e. A ( x =/= (/) -> ( f ` x ) e. x ) ) $=
      ( vy cv wfn c0 wne cfv wcel wi wral wex wceq fneq2 raleq anbi12d exbidv
      wa dfac4 axaci vtocl ) CFZEFZGZAFZHIUGUDJUGKLZAUEMZTZCNZUDBGZUHABMZTZCNEB
      DUEBOZUJUNCUOUFULUIUMUEBUDPUHAUEBQRSUKEEACUAUBUC $.
  $}

  ${
    $d x f A $.
    ac5b.1 $e |- A e. _V $.
    $( Equivalent of Axiom of Choice.  (Contributed by NM, 31-Aug-1999.) $)
    ac5b $p |- ( A. x e. A x =/= (/) ->
               E. f ( f : A --> U. A /\ A. x e. A ( f ` x ) e. x ) ) $=
      ( cv c0 wne wral cuni ccrd cdm wcel wn wf cfv wa wex cvv uniex numth3
      mp1i neirr neeq1 rspccv mtoi ac5num syl2anc ) AEZFGZABHZBIZJKLZFBLZMBUKCE
      ZNUHUNOUHLABHPCQUKRLULUJBDSUKRTUAUJUMFFGZFUBUIUOAFBUHFFUCUDUEABCUFUG $.
  $}

  ${
    $d f g x z A $.  $d f g w x y z B $.  $d f g w z ph $.  $d g y ps $.
    $d g V $.
    ac6num.1 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( A version of ~ ac6 which takes the choice as a hypothesis.  (Contributed
       by Mario Carneiro, 27-Aug-2015.) $)
    ac6num $p |- ( ( A e. V /\ U_ x e. A { y e. B | ph } e. dom card /\
      A. x e. A E. y e. B ph ) -> E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      ( vg vz wcel wral cv wf cfv wa c0 wceq cvv crab ciun ccrd cdm w3a crn wex
      wrex cmpt cuni wn cab nfiu1 nfel1 wss ssiun2 ssexg expcom ralrimi dfiun2g
      syl5 syl eqid rnmpt unieqi syl6eqr id eqeltrrd 3ad2ant2 simp3 necom rabn0
      wne df-ne 3bitr3i ralbii ralnex bitri sylib wb 0ex elrnmpt sylnibr ac5num
      ax-mp syl2anc wfn ffn anim1i fveq2 eleq12d ralrnmpt anbi2d wsbc csb sseld
      syl5ib ralimia ad2antll nfv nfcsb1v nfel eleq1d cbvral nfcv cbvmpt simpl1
      csbeq1a fmpt simpl2 fex2 syl3anc ssrab2 sseli ralimi elrabsf simprbi feq1
      jca nfmpt1 nfeq2 sbcie fveq1 fvmpt2 mpan2 sylan9eq dfsbcq syl5bbr ralbida
      fvex anbi12d spcegv sylc ex syld exlimdv mpd ) EHLZCEADFUAZUBZUCUDZLZADFU
      HZCEMZUEZCEYSUIZUFZUUGUJZJNZOZKNZUUIPZUUKLZKUUGMZQZJUGZEFGNZOZBCEMZQZGUGZ
      UUEUUHUUALZRUUGLZUKUUPUUBYRUVBUUDUUBYTUUHUUAUUBYTUUKYSSZCEUHKULZUJZUUHUUB
      YSTLZCEMZYTUVFSUUBUVGCECYTUUACEYSUMZUNCNZELZYSYTUOZUUBUVGCEYSUPZUVLUUBUVG
      YSYTUUAUQURVAUSZCKEYSTUTVBUUGUVECKEYSUUFUUFVCZVDVEVFUUBVGVHVIUUERYSSZCEUH
      ZUVCUUEUUDUVQUKZYRUUBUUDVJUUDUVPUKZCEMUVRUUCUVSCEYSRVMRYSVMUUCUVSYSRVKADF
      VLRYSVNVOVPUVPCEVQVRVSRTLUVCUVQVTWACEYSRUUFTUVOWBWEWCKUUGJWDWFUUEUUOUVAJU
      UEUUOUUIUUGWGZYSUUIPZYSLZCEMZQZUVAUUOUVTUUNQUUEUWDUUJUVTUUNUUGUUHUUIWHWIU
      UEUUNUWCUVTUUEUVHUUNUWCVTUUBYRUVHUUDUVNVIUUMUWBCKEYSUUFTUVOUVDUULUWAUUKYS
      UUKYSUUIWJUVDVGWKWLVBWMWQUUEUWDUVAUUEUWDQZCEUWAUIZTLZEFUWFOZADUWAWNZCEMZQ
      ZUVAUWEEYTUWFOZYRUUBUWGUWECUUKUWAWOZYTLZKEMZUWLUWEUWAYTLZCEMZUWOUWCUWQUUE
      UVTUWBUWPCEUVKYSYTUWAUVMWPWRWSUWPUWNCKEUWPKWTCUWMYTCUUKUWAXAZUVIXBUVJUUKS
      UWAUWMYTCUUKUWAXHZXCXDVSKEYTUWMUWFCKEUWAUWMKUWAXEUWRUWSXFXIVSYRUUBUUDUWDX
      GYRUUBUUDUWDXJEYTUWFHUUAXKXLUWEUWHUWJUWEUWAFLZCEMZUWHUWCUXAUUEUVTUWBUWTCE
      YSFUWAADFXMXNXOWSCEFUWAUWFUWFVCZXIVSUWCUWJUUEUVTUWBUWICEUWBUWTUWIADUWAFDF
      XEXPXQXOWSXSUUTUWKGUWFTUUQUWFSZUURUWHUUSUWJEFUUQUWFXRUXCBUWICECUUQUWFCEUW
      AXTYABADUVJUUQPZWNZUXCUVKQZUWIABDUXDUVJUUQYJIYBUXFUXDUWASUXEUWIVTUXCUVKUX
      DUVJUWFPZUWAUVJUUQUWFYCUVKUWATLUXGUWASYSUUIYJCEUWATUWFUXBYDYEYFADUXDUWAYG
      VBYHYIYKYLYMYNYOYPYQ $.
  $}

  ${
    $d f x A $.  $d f x y B $.  $d f ph $.  $d y ps $.
    ac6.1 $e |- A e. _V $.
    ac6.2 $e |- B e. _V $.
    ac6.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Equivalent of Axiom of Choice.  This is useful for proving that there
       exists, for example, a sequence mapping natural numbers to members of a
       larger set ` B ` , where ` ph ` depends on ` x ` (the natural number)
       and ` y ` (to specify a member of ` B ` ).  A stronger version of this
       theorem, ~ ac6s , allows ` B ` to be a proper class.  (Contributed by
       NM, 18-Oct-1999.)  (Revised by Mario Carneiro, 27-Aug-2015.) $)
    ac6 $p |- ( A. x e. A E. y e. B ph ->
              E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      ( cvv wcel crab ciun ccrd cdm wrex wral cv wss wf rgenw iunss mpbir ssexi
      wa wex ssrab2 numth3 ax-mp ac6num mp3an12 ) EKLCEADFMZNZOPLZADFQCEREFGSUA
      BCERUFGUGHUNKLUOUNFIUNFTUMFTZCERUPCEADFUHUBCEUMFUCUDUEUNKUIUJABCDEFGKJUKU
      L $.
  $}

  ${
    $d A f x y z $.  $d B f y z $.
    ac6c4.1 $e |- A e. _V $.
    ac6c4.2 $e |- B e. _V $.
    $( Equivalent of Axiom of Choice. ` B ` is a collection ` B ( x ) ` of
       nonempty sets.  (Contributed by Mario Carneiro, 22-Mar-2013.) $)
    ac6c4 $p |- ( A. x e. A B =/= (/) ->
               E. f ( f Fn A /\ A. x e. A ( f ` x ) e. B ) ) $=
      ( vy vz c0 wne wral cv wcel wrex cfv wa wex nfv cbvral nfel2 csb ciun wfn
      wf nfcsb1v nfcv nfne weq csbeq1a neeq1d n0 nfre1 eleq2d rspce sylibr rspe
      eliun sylancom ex exlimd syl5bi ralimia sylbi iunex eleq1 ac6 ffn eleq12d
      fveq2 biimpri anim12i eximi 3syl ) CIJZABKZGLZAHLZCUAZMZGABCUBZNZHBKZBVTD
      LZUDZVQWCOZVRMZHBKZPZDQWCBUCZALZWCOZCMZABKZPZDQVOVRIJZHBKWBVNWOAHBVNHRAVR
      IAVQCUEZAIUFUGAHUHZCVRIAVQCUIZUJSWOWAHBWOVSGQVQBMZWAGVRUKWSVSWAGWSGRVSGVT
      ULWSVSWAWSVSVPVTMZWAWSVSPVPCMZABNWTXAVSAVQBAVPVRWPTWQCVRVPWRUMUNAVPBCUQUO
      VSGVTUPURUSUTVAVBVCVSWFHGBVTDEABCEFVDVPWEVRVEVFWHWNDWDWIWGWMBVTWCVGWMWGWL
      WFAHBWLHRAWEVRWPTWQWKWECVRWJVQWCVIWRVHSVJVKVLVM $.

    $( Equivalent of Axiom of Choice. ` B ` is a collection ` B ( x ) ` of
       nonempty sets.  Remark after Theorem 10.46 of [TakeutiZaring] p. 98.
       (Contributed by Mario Carneiro, 22-Mar-2013.) $)
    ac6c5 $p |- ( A. x e. A B =/= (/) -> E. f A. x e. A ( f ` x ) e. B ) $=
      ( c0 wne wral cv wfn cfv wcel wa wex ac6c4 exsimpr syl ) CGHABIDJZBKZAJSL
      CMABIZNDOUADOABCDEFPTUADQR $.

    $d A f x $.  $d B f $.
    $( An Axiom of Choice equivalent: the infinite Cartesian product of
       nonempty classes is nonempty.  Axiom of Choice (second form) of
       [Enderton] p. 55 and its converse.  (Contributed by Mario Carneiro,
       22-Mar-2013.) $)
    ac9 $p |- ( A. x e. A B =/= (/) <-> X_ x e. A B =/= (/) ) $=
      ( vf c0 wne wral cixp cv wfn cfv wcel wa wex ac6c4 n0 vex elixp bitr2i
      exbii sylib ixpn0 impbii ) CGHABIZABCJZGHZUFFKZBLAKUIMCNABIOZFPZUHABCFDEQ
      UHUIUGNZFPUKFUGRULUJFABCUIFSTUBUAUCABCUDUE $.
  $}

  ${
    $d x f z A $.  $d x y f z B $.  $d f z ph $.  $d y z ps $.
    ac6s.1 $e |- A e. _V $.
    ac6s.2 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Equivalent of Axiom of Choice.  Using the Boundedness Axiom ~ bnd2 , we
       derive this strong version of ~ ac6 that doesn't require ` B ` to be a
       set.  (Contributed by NM, 4-Feb-2004.) $)
    ac6s $p |- ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      ( vz wrex wral cv wss wa wex wf bnd2 vex ac6 anim2i fss expcom anim1d imp
      eximi eximdv exlimiv 3syl ) ADFKCELJMZFNZADUJKCELZOZJPUKEUJGMZQZBCELZOZGP
      ZOZJPEFUNQZUPOZGPZACDJEFHRUMUSJULURUKABCDEUJGHJSITUAUFUSVBJUKURVBUKUQVAGU
      KUOUTUPUOUKUTEUJFUNUBUCUDUGUEUHUI $.

    $( Equivalent of Axiom of Choice.  Contrapositive of ~ ac6s .  (Contributed
       by NM, 10-Jun-2007.) $)
    ac6n $p |- ( A. f ( f : A --> B -> E. x e. A ps ) ->
                E. x e. A A. y e. B ph ) $=
      ( cv wf wn wral wa wex wrex wi wal cfv bitri wceq notbid ac6s con3i albii
      dfrex2 imbi2i alinexa dfral2 rexbii rexnal 3imtr4i ) EFGJZKZBLZCEMZNGOZLZ
      ALZDFPZCEMZLZUNBCEPZQZGRZADFMZCEPZVAUQUSUOCDEFGHDJCJUMSUAABIUBUCUDVEUNUPL
      ZQZGRURVDVIGVCVHUNBCEUFUGUEUNUPGUHTVGUTLZCEPVBVFVJCEADFUIUJUTCEUKTUL $.

    $( Generalization of the Axiom of Choice to classes.  Slightly strengthened
       version of ~ ac6s3 .  (Contributed by NM, 29-Sep-2006.) $)
    ac6s2 $p |- ( A. x e. A E. y ph -> E. f ( f Fn A /\ A. x e. A ps ) ) $=
      ( wex wral cvv wrex cv wfn wa rexv ralbii wf ac6s ffn anim1i eximi sylbir
      syl ) ADIZCEJADKLZCEJZFMZENZBCEJZOZFIZUFUECEADPQUGEKUHRZUJOZFIULABCDEKFGH
      SUNUKFUMUIUJEKUHTUAUBUDUC $.

    $( Generalization of the Axiom of Choice to classes.  Theorem 10.46 of
       [TakeutiZaring] p. 97.  (Contributed by NM, 3-Nov-2004.) $)
    ac6s3 $p |- ( A. x e. A E. y ph -> E. f A. x e. A ps ) $=
      ( wex wral cv wfn wa ac6s2 exsimpr syl ) ADICEJFKELZBCEJZMFIRFIABCDEFGHNQ
      RFOP $.
  $}

  ${
    $d A f x z $.  $d B f x y z $.  $d f z ph $.  $d y z ps $.
    ac6sg.1 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( ~ ac6s with sethood as antecedent.  (Contributed by FL, 3-Aug-2009.) $)
    ac6sg $p |- ( A e. V -> ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) ) $=
      ( vz wrex cv wral wf wa wex wi wceq raleq feq2 anbi12d exbidv imbi12d vex
      ac6s vtoclg ) ADFKZCJLZMZUHFGLZNZBCUHMZOZGPZQUGCEMZEFUJNZBCEMZOZGPZQJEHUH
      ERZUIUOUNUSUGCUHESUTUMURGUTUKUPULUQUHEFUJTBCUHESUAUBUCABCDUHFGJUDIUEUF $.
  $}

  ${
    $d f x z A $.  $d x y f z B $.  $d f z ph $.  $d z ps $.
    ac6sf.1 $e |- F/ y ps $.
    ac6sf.2 $e |- A e. _V $.
    ac6sf.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Version of ~ ac6 with bound-variable hypothesis.  (Contributed by NM,
       2-Mar-2008.) $)
    ac6sf $p |- ( A. x e. A E. y e. B ph ->
                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      ( vz wrex wral wsb cv wf wa wex cbvrexsv ralbii cfv sbhypf ac6s sylbi ) A
      DFLZCEMADKNZKFLZCEMEFGOZPBCEMQGRUEUGCEADKFSTUFBCKEFGIABDKCOUHUAHJUBUCUD
      $.
  $}

  ${
    $d f x y A $.  $d f y B $.
    ac6s4.1 $e |- A e. _V $.
    $( Generalization of the Axiom of Choice to proper classes. ` B ` is a
       collection ` B ( x ) ` of nonempty, possible proper classes.
       (Contributed by NM, 29-Sep-2006.) $)
    ac6s4 $p |- ( A. x e. A B =/= (/) ->
               E. f ( f Fn A /\ A. x e. A ( f ` x ) e. B ) ) $=
      ( vy c0 wne wral cv wcel wex wfn cfv wa n0 ralbii eleq1 ac6s2 sylbi ) CGH
      ZABIFJZCKZFLZABIDJZBMAJUENZCKZABIODLUAUDABFCPQUCUGAFBDEUBUFCRST $.

    $( Generalization of the Axiom of Choice to proper classes. ` B ` is a
       collection ` B ( x ) ` of nonempty, possible proper classes.  Remark
       after Theorem 10.46 of [TakeutiZaring] p. 98.  (Contributed by NM,
       27-Mar-2006.) $)
    ac6s5 $p |- ( A. x e. A B =/= (/) -> E. f A. x e. A ( f ` x ) e. B ) $=
      ( c0 wne wral cv wfn cfv wcel wa wex ac6s4 exsimpr syl ) CFGABHDIZBJZAIRK
      CLABHZMDNTDNABCDEOSTDPQ $.
  $}

  ${
    $d x z y w v f $.
    $( An Axiom of Choice equivalent.  Given a family ` x ` of mutually
       disjoint nonempty sets, there exists a set ` y ` containing exactly one
       member from each set in the family.  Theorem 6M(4) of [Enderton]
       p. 151.  (Contributed by NM, 14-May-2004.) $)
    ac8 $p |- ( ( A. z e. x z =/= (/) /\
                   A. z e. x A. w e. x ( z =/= w -> ( z i^i w ) = (/) ) ) ->
               E. y A. z e. x E! v v e. ( z i^i y ) ) $=
      ( cv c0 wne wral cin wceq wi wa wcel weu wex dfac5 axaci ) CFZGHCAFZISDFZ
      HSUAJGKLDTICTIMEFSBFJNEOCTIBPLAABCDEQR $.
  $}

  ${
    $d f x A $.  $d f B $.
    ac9.1 $e |- A e. _V $.
    $( An Axiom of Choice equivalent: the infinite Cartesian product of
       nonempty classes is nonempty.  Axiom of Choice (second form) of
       [Enderton] p. 55 and its converse.  This is a stronger version of the
       axiom in Enderton, with no existence requirement for the family of
       classes ` B ( x ) ` (achieved via the Collection Principle ~ cp ).
       (Contributed by NM, 29-Sep-2006.) $)
    ac9s $p |- ( A. x e. A B =/= (/) <-> X_ x e. A B =/= (/) ) $=
      ( vf c0 wne wral cixp cv wfn cfv wcel wa wex ac6s4 n0 vex elixp exbii
      bitr2i sylib ixpn0 impbii ) CFGABHZABCIZFGZUEEJZBKAJUHLCMABHNZEOZUGABCEDP
      UGUHUFMZEOUJEUFQUKUIEABCUHERSTUAUBABCUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       AC equivalents:  well-ordering, Zorn's lemma
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.
    $( Any set is strictly dominated by some ordinal.  (Contributed by NM,
       22-Oct-2003.) $)
    numthcor $p |- ( A e. V -> E. x e. On A ~< x ) $=
      ( vy csdm wbr con0 wrex wceq breq1 rexbidv cpw cen vex pwex numth2 canth2
      cv ensym sdomentr sylancr reximi ax-mp vtoclg ) DRZARZEFZAGHZBUFEFZAGHDBC
      UEBIUGUIAGUEBUFEJKUFUELZMFZAGHUHAUJUEDNZOPUKUGAGUKUEUJEFUJUFMFUGUEULQUFUJ
      SUEUJUFTUAUBUCUD $.
  $}

  ${
    $d A f g y z $.  $d A h $.  $d A f x y z $.  $d w x y z $.
    $( Well-ordering theorem: any set ` A ` can be well-ordered.  This is an
       equivalent of the Axiom of Choice.  Theorem 6 of [Suppes] p. 242.  First
       proved by Ernst Zermelo (the "Z" in ZFC) in 1904.  (Contributed by Mario
       Carneiro, 5-Jan-2013.) $)
    weth $p |- ( A e. V -> E. x x We A ) $=
      ( vy cv wwe wex wceq weeq2 exbidv dfac8 axaci vtoclg ) DEZAEZFZAGZBOFZAGD
      BCNBHPRANBOIJQDDAKLM $.
  $}

  ${
    $d a b f g h r s t u v w x y z A $.  $d f h t B $.  $d a b f t u v y D $.
    $d a b f g h r s t u v x y z F $.  $d a b f g r s t u v w x y z R $.
    $d t v C $.  $d f h t G $.
    $( Generator function.  ` w ` is a well-ordering on ` A ` . $)
    zorn2lem.3 $e |- F =
      recs ( ( f e. _V |-> ( iota_ v e. C A. u e. C -. u w v ) ) ) $.
    $( Auxiliary sets. $)
    zorn2lem.4 $e |- C = { z e. A | A. g e. ran f g R z } $.
    zorn2lem.5 $e |- D = { z e. A | A. g e. ( F " x ) g R z } $.
    $( Lemma for ~ zorn2 .  (Contributed by NM, 3-Apr-1997.)  (Revised by Mario
       Carneiro, 9-May-2015.) $)
    zorn2lem1 $p |- ( ( x e. On /\ ( w We A /\ D =/= (/) ) ) ->
                   ( F ` x ) e. D ) $=
      ( cv con0 wcel wral cvv wwe c0 wne wa cfv wbr wn crio cres cmpt wceq tfr2
      adantr wfun wfn tfr1 fnfun ax-mp vex resfunexg mp2an crn crab cima df-ima
      rneq syl6eqr eleq2d imbi1d rabbidv 3eqtr4g riotaeqbidv eqid riotaex fvmpt
      ralbidv2 syl6eq wreu wss simprl ssrab2 eqsstri weso ad2antrl soex sylancl
      wor ssexg sylancr a1i simprr wereu syl13anc riotacl syl eqeltrd ) APZQRZF
      CPZUAZHUBUCZUDZUDZWQLUEZEPZDPWSUFUGZEHSZDHUHZHXCXDLWQUIZJTXFEGSZDGUHZUJZU
      EZXHWRXDXMUKXBWQLXLMULUMXITRZXMXHUKLUNZWQTRXNLQUOXOLXLMUPQLUQURAUSLWQTUTV
      AJXIXKXHTXLJPZXIUKZXJXGDGHXQKPZBPIUFZKXPVBZSZBFVCXSKLWQVDZSZBFVCZGHXQYAYC
      BFXQXSXSKXTYBXQXRXTRXRYBRXSXQXTYBXRXQXTXIVBYBXPXIVFLWQVEVGVHVIVPVJNOVKZXQ
      XFXFEGHXQXEGRXEHRXFXQGHXEYEVHVIVPVLXLVMXGDHVNVOURVQXCXGDHVRZXHHRXCWTHTRZH
      FVSZXAYFWRWTXAVTXCYHFTRZYGHYDFOYCBFWAWBZXCFWSWGZWSTRYIWTYKWRXAFWSWCWDCUSF
      WSTWEWFHFTWHWIYHXCYJWJWRWTXAWKDEFHWSTWLWMXGDHWNWOWP $.

    $( Lemma for ~ zorn2 .  (Contributed by NM, 3-Apr-1997.)  (Revised by Mario
       Carneiro, 9-May-2015.) $)
    zorn2lem2 $p |- ( ( x e. On /\ ( w We A /\ D =/= (/) ) ) ->
                   ( y e. x -> ( F ` y ) R ( F ` x ) ) ) $=
      ( cv con0 wcel wbr wwe c0 wne cfv cima wral zorn2lem1 wceq ralbidv elrab2
      wa breq2 simprbi syl wi wfn wss cvv wn crio cmpt tfr1 onss fnfvima 3expia
      sylancr adantr breq1 rspccv sylsyld ) AQZRSZGDQZUAIUBUCUKZUKZLQZVKMUDZJTZ
      LMVKUEZUFZBQZVKSZWAMUDZVSSZWCVQJTZVOVQISZVTACDEFGHIJKLMNOPUGWFVQGSVTVPCQZ
      JTZLVSUFVTCVQGIWGVQUHWHVRLVSWGVQVPJULUIPUJUMUNVLWBWDUOZVNVLMRUPZVKRUQZWIM
      KURFQEQVMTUSFHUFEHUTVANVBVKVCWJWKWBWDRVKMWAVDVEVFVGVRWELWCVSVPWCVQJVHVIVJ
      $.

    $( Lemma for ~ zorn2 .  (Contributed by NM, 3-Apr-1997.)  (Revised by Mario
       Carneiro, 9-May-2015.) $)
    zorn2lem3 $p |- ( ( R Po A /\ ( x e. On /\ ( w We A /\ D =/= (/) ) ) ) ->
                   ( y e. x -> -. ( F ` x ) = ( F ` y ) ) ) $=
      ( cv wcel wa wbr wpo con0 wwe c0 wne cfv wceq wn wi zorn2lem2 adantl cima
      wral crab ssrab2 zorn2lem1 sseldi breq1 biimprcd poirr nsyli com12 sylan2
      eqsstri syld ) GJUAZAQZUBRGDQUCIUDUESSZSBQZVGRZVIMUFZVGMUFZJTZVLVKUGZUHZV
      HVJVMUIVFABCDEFGHIJKLMNOPUJUKVHVFVLGRZVMVOUIVHIGVLILQCQJTLMVGULUMZCGUNGPV
      QCGUOVDACDEFGHIJKLMNOPUPUQVMVFVPSZVOVMVNVLVLJTZVRVNVSVMVLVKVLJURUSGVLJUTV
      AVBVCVE $.

    $( Lemma for ~ zorn2 .  (Contributed by NM, 3-Apr-1997.)  (Revised by Mario
       Carneiro, 9-May-2015.) $)
    zorn2lem4 $p |- ( ( R Po A /\ w We A ) -> E. x e. On D = (/) ) $=
      ( vy con0 cvv wcel wi wpo cv wwe wa c0 wceq wrex crn pm3.24 wne wal df-ne
      wn wral ralbii df-ral ralnex 3bitr3i wor weso adantr vex soex sylancl cfv
      wfn wb wbr crio cmpt tfr1 fvelrnb ax-mp nfv nfa1 nfan cima ssrab2 eqsstri
      crab zorn2lem1 sseldi eleq1 syl5ibcom exp32 com12 a2d spsd rexlimd syl5bi
      imp ssrdv ssexd ex adantl ccnv zorn2lem3 exp45 com23 imp4a alrimdv alimdv
      wfun r2al syl6ibr cres wss ssid tz7.48lem mpan cdm fnrel eqimssi relssres
      wrel fndm mp2an cnveqi funeqi sylib syl6 onprc funrnex df-rn eleq1i dfdm4
      eqtr3i 3imtr4g mtoi jcad syl5bir mt3i ) FIUAZFCUBZUCZUDZHUEUFZAQUGZLUHZRS
      ZYTUMZUDZYTUIYRUMZAUBZQSZHUEUJZTZAUKZYPUUBUUFAQUNYQUMZAQUNUUHUUCUUFUUIAQH
      UEULUOUUFAQUPYQAQUQURYPUUHYTUUAYOUUHYTTYMYOUUHYTYOUUHUDZYSFRUUJFYNUSZYNRS
      FRSYOUUKUUHFYNUTVACVBFYNRVCVDUUJPYSFPUBZYSSZUUDLVEZUULUFZAQUGZUUJUULFSZLQ
      VFZUUMUUPVGLJREUBDUBYNVHUMEGUNDGVIVJMVKZAQUULLVLVMUUJUUOUUQAQYOUUHAYOAVNU
      UGAVOVPUUQAVNYOUUHUUEUUOUUQTZTZYOUUGUVAAYOUUEUUFUUTUUEYOUUFUUTTUUEYOUUFUU
      TUUEYOUUFUDUDZUUNFSUUOUUQUVBHFUUNHKUBBUBIVHKLUUDVQUNZBFVTFOUVCBFVRVSABCDE
      FGHIJKLMNOWAWBUUNUULFWCWDWEWFWGWHWKWIWJWLWMWNWOYPUUHLWPZXCZUUAYPUUHUUNUUL
      LVEUFUMZPUUDUNAQUNZUVEYPUUHUUEUULUUDSZUDUVFTZPUKZAUKUVGYPUUGUVJAYPUUGUVIP
      YPUUGUUEUVHUVFYPUUEUUFUVHUVFTZYMYOUUEUUFUVKTZTYMUUEYOUVLYMUUEYOUUFUVKAPBC
      DEFGHIJKLMNOWQWRWSWKWGWTXAXBUVFAPQUUDXDXEUVGLQXFZWPZXCZUVEQQXGUVGUVOQXHAP
      QLUUSXIXJUVNUVDUVMLLXOZLXKZQXGUVMLUFUURUVPUUSQLXLVMUVQQUURUVQQUFUUSQLXPVM
      ZXMLQXNXQXRXSXTYAUVEYTQRSZYBUVEUVDXKZRSZUVDUHZRSZYTUVSUWAUVEUWCRUVDYCWFYS
      UVTRLYDYEQUWBRUVQQUWBUVRLYFYGYEYHYIYAYJYKYL $.

    ${
      $d x u v f t s r a b H $.
      $( Auxiliary set.  ` H ` is ` D ` with ` x ` substituted for ` y ` . $)
      zorn2lem.7 $e |- H = { z e. A | A. g e. ( F " y ) g R z } $.
      $( Lemma for ~ zorn2 .  (Contributed by NM, 4-Apr-1997.)  (Revised by
         Mario Carneiro, 9-May-2015.) $)
      zorn2lem5 $p |- ( ( ( w We A /\ x e. On ) /\ A. y e. x H =/= (/) ) ->
            ( F " x ) C_ A ) $=
        ( cv wcel vs wwe con0 wa c0 wne wral cima cfv wceq wrex wfun wfn cvv wn
        wbr crio cmpt tfr1 fnfun ax-mp fvelima mpan nfra1 nfan wi df-ral onelon
        nfv wal ssrab2 eqsstri zorn2lem1 sseldi eleq1 syl5ib sylani com12 exp43
        crab com3r imp a2d spsd syl5bi rexlimd syl5 ssrdv ) GDSZUBZASZUCTZUDZNU
        EUFZBWKUGZUDZUAMWKUHZGUASZWQTZBSZMUIZWRUJZBWKUKZWPWRGTZMULZWSXCMUCUMXEM
        KUNFSESWIUPUOFHUGEHUQUROUSUCMUTVABWRWKMVBVCWPXBXDBWKWMWOBWMBVIWNBWKVDVE
        XDBVIWMWOWTWKTZXBXDVFZVFZWOXFWNVFZBVJWMXHWNBWKVGWMXIXHBWMXFWNXGWJWLXFWN
        XGVFZVFWLXFWJXJWLXFWJWNXGXBWLXFUDZWJWNUDZUDXDXKXBWTUCTZXLXDWKWTVHXMXLUD
        ZXAGTXBXDXNNGXANLSCSJUPLMWTUHUGZCGVTGRXOCGVKVLBCDEFGHNJKLMOPRVMVNXAWRGV
        OVPVQVRVSWAWBWCWDWEWBWFWGWH $.

      $( Lemma for ~ zorn2 .  (Contributed by NM, 4-Apr-1997.)  (Revised by
         Mario Carneiro, 9-May-2015.) $)
      zorn2lem6 $p |- ( R Po A ->
   ( ( ( w We A /\ x e. On ) /\ A. y e. x H =/= (/) ) -> R Or ( F " x ) ) ) $=
        ( wa wi vs vr vb va wpo cv wwe con0 wcel wne wral cima wbr wceq w3o wor
        c0 wss zorn2lem5 poss syl com12 cfv wex wfn wfun cvv wn crio cmpt fnfun
        tfr1 wrex fvelima df-rex sylib ex anim12d an4 2exbii eeanv bitri sylibr
        mp2b neeq1i ralbii imaeq2 raleqdv rabbidv neeq1d rspccv sylbi anim12dan
        crab onelon word ordtri3or syl2an eqid zorn2lem2 adantll breq12 biimpcd
        eloni syl6 com23 adantrrl imp fveq2 eqeq12 syl5ib adantl adantlr ancoms
        wb adantrrr 3orim123d syl5 exp31 com4r syl6c exp4a com3r imp4b exlimdvv
        a2d ralrimivv a1i jcad df-so syl6ibr ) GJUEZGDUFZUGZAUFZUHUIZSZNUQUJZBY
        OUKZSZMYOULZJUEZUAUFZUBUFZJUMZUUCUUDUNZUUDUUCJUMZUOZUBUUAUKUAUUAUKZSUUA
        JUPYLYTUUBUUIYTYLUUBYTUUAGURYLUUBTABCDEFGHIJKLMNOPQRUSUUAGJUTVAVBYTUUIT
        YLYTUUHUAUBUUAUUAUUCUUAUIZUUDUUAUIZSZUCUFZYOUIZUDUFZYOUIZSZUUMMVCZUUCUN
        ZUUOMVCZUUDUNZSZSZUDVDUCVDZYTUUHUULUUNUUSSZUCVDZUUPUVASZUDVDZSZUVDMUHVE
        MVFZUULUVITMKVGFUFEUFYMUMVHFHUKEHVIVJOVLUHMVKUVJUUJUVFUUKUVHUVJUUJUVFUV
        JUUJSUUSUCYOVMUVFUCUUCYOMVNUUSUCYOVOVPVQUVJUUKUVHUVJUUKSUVAUDYOVMUVHUDU
        UDYOMVNUVAUDYOVOVPVQVRWDUVDUVEUVGSZUDVDUCVDUVIUVCUVKUCUDUUNUUPUUSUVAVSV
        TUVEUVGUCUDWAWBWCYTUVCUUHUCUDYQYSUUQUVBUUHYSUUQLUFCUFJUMZLMUUMULZUKZCGW
        NZUQUJZUVLLMUUOULZUKZCGWNZUQUJZSZTZYQUUQUVBUUHTZTYSUVLLMBUFZULZUKZCGWNZ
        UQUJZBYOUKZUWBYRUWHBYONUWGUQRWEWFUWIUUNUVPUUPUVTUWHUVPBUUMYOUWDUUMUNZUW
        GUVOUQUWJUWFUVNCGUWJUVLLUWEUVMUWDUUMMWGWHWIWJWKUWHUVTBUUOYOUWDUUOUNZUWG
        UVSUQUWKUWFUVRCGUWKUVLLUWEUVQUWDUUOMWGWHWIWJWKVRWLYQUUQUWAUWCYNYPUUQUWA
        UWCTZTYPUUQYNUWLYPUUQYNUWAUWCYPUUQUUMUHUIZUUOUHUIZSZUWOYNUWASZUWCTYPUUQ
        UWOYPUUNUWMUUPUWNYOUUMWOYOUUOWOWMVQZUWQUWOUWPUVBUWOUUHUWOUWPUVBUWOUUHTU
        WOUUMUUOUIZUUMUUOUNZUUOUUMUIZUOZUWOUWPSZUVBSZUUHUWMUUMWPUUOWPUXAUWNUUMX
        DUUOXDUUMUUOWQWRUXCUWRUUEUWSUUFUWTUUGUXBUVBUWRUUETZUWOYNUVTUVBUXDTUVPUW
        OYNUVTSZSZUWRUVBUUEUXFUWRUURUUTJUMZUVBUUETUWNUXEUWRUXGTUWMUDUCCDEFGHUVS
        JKLMOPUVSWSWTXAUVBUXGUUEUURUUCUUTUUDJXBXCXEXFXGXHUVBUWSUUFTUXBUWSUURUUT
        UNUVBUUFUUMUUOMXIUURUUCUUTUUDXJXKXLUXBUVBUWTUUGTZUWOYNUVPUVBUXHTUVTUWOY
        NUVPSZSZUWTUVBUUGUXJUWTUUTUURJUMZUVBUUGTUWMUXIUWTUXKTUWNUCUDCDEFGHUVOJK
        LMOPUVOWSWTXMUVBUXKUUGUVAUUSUXKUUGXOUUTUUDUURUUCJXBXNXCXEXFXPXHXQXRXSXT
        YAYBYCXHYFXRYDYEXRYGYHYIUAUBUUAJYJYK $.

      $( Lemma for ~ zorn2 .  (Contributed by NM, 6-Apr-1997.)  (Revised by
         Mario Carneiro, 9-May-2015.) $)
      zorn2lem7 $p |- ( ( A e. dom card /\ R Po A /\
      A. s ( ( s C_ A /\ R Or s ) -> E. a e. A A. r e. s ( r R a \/ r = a ) ) )
                  -> E. a e. A A. b e. A -. a R b ) $=
        ( ccrd cdm wcel wpo cv wss wor wa wbr weq wo wral wrex wal wwe wex ween
        wi wn c0 wceq con0 zorn2lem4 cima imaeq2 raleqdv rabbidv 3eqtr4g eqeq1d
        crab onminex df-ne ralbii anbi2i rexbii sylibr zorn2lem5 zorn2lem6 jcad
        wne a1i wfn wfun cvv crio cmpt tfr1 fnfun vex funimaex mp2b sseq1 soeq2
        anbi12d raleq rexbidv imbi12d spcv sylan9 adantld imp noel sseld 3anass
        potr sylan2br exp3acom23 breq1 biimprcd adantl jaod exp42 sylan9r com24
        w3a com23 imp31 a2d ralimdv2 cbvralv breq2 ralbidv elrab wb eleq2 sylbi
        eqeq1i syl5bbr biimpd expdimp syl5bi exp32 com34 mtoi exp4a com4r imp3a
        ex pm2.43a com4l ralrimdv exp3a reximdvai com12 imp32 exp45 imp4a com3l
        adantr mpd rexlimiv 3syl adantlr pm2.43i expcom exlimiv 3impib ) GUCUDU
        EZGJUFZOUGZGUHZUVBJUIZUJZPUGZQUGZJUKZPQULZUMZPUVBUNZQGUOZUTZOUPZUVGRUGZ
        JUKZVAZRGUNZQGUOZUUTGDUGZUQZDURUVAUVNUJZUVSUTZGDUSUWAUWCDUWBUWAUVSUWBUW
        AUJZUVSUVAUWAUWDUVSUTZUVNUVAUWAUJIVBVCZAVDUOZUWFNVBWBZBAUGZUNZUJZAVDUOZ
        UWEACDEFGHIJKLMSTUAVEUWGUWFNVBVCZVAZBUWIUNZUJZAVDUOUWLUWFUWMABABULZINVB
        UWQLUGZCUGZJUKZLMUWIVFZUNZCGVLZUWTLMBUGZVFZUNZCGVLINUWQUXBUXFCGUWQUWTLU
        XAUXEUWIUXDMVGVHVIUAUBVJVKVMUWKUWPAVDUWJUWOUWFUWHUWNBUWINVBVNVOVPVQVRUW
        KUWEAVDUWDUWIVDUEZUWKUVSUWDUXGUWFUWJUVSUWBUWAUXGUWFUWJUVSUTZUTUWBUWFUWA
        UXGUJZUXHUWBUWFUXIUWJUVSUWBUWFUXIUWJUJZUJZUJUVJPUXAUNZQGUOZUVSUWBUXKUXM
        UWBUXJUXMUWFUVAUXJUXAGUHZUXAJUIZUJZUVNUXMUVAUXJUXNUXOUXJUXNUTUVAABCDEFG
        HIJKLMNSTUAUBVSZWCABCDEFGHIJKLMNSTUAUBVTWAUVMUXPUXMUTOUXAMVDWDMWEUXAWFU
        EMKWFFUGEUGUVTUKVAFHUNEHWGWHSWIVDMWJMUWIAWKWLWMUVBUXAVCZUVEUXPUVLUXMUXR
        UVCUXNUVDUXOUVBUXAGWNUVBUXAJWOWPUXRUVKUXLQGUVJPUVBUXAWQWRWSWTXAXBXCUWBU
        WFUXJUXMUVSUTZUVAUWFUXJUXSUTZUTUVNUWFUVAUXTUWFUVAUXJUXSUWFUVAUXJUJZUJZU
        XLUVRQGUYBUVGGUEZUXLUVRUYBUYCUXLUJUVQRGUYBUYCUXLUVOGUEZUVQUTUYDUYBUYCUX
        LUVQUYDUWFUYAUYCUXLUVQUTZUTZUWFUYDUYAUYFUTUWFUYDUYAUYDUYFUWFUYDUYAUYDUY
        FUTUTUWFUYDUJZUYAUYCUYDUYEUYGUYAUYCUYDUYEUYGUYAUYCUYDUJZUXLUVQUYGUYAUYH
        UJZUJUXLUJUVPUVOVBUEZUVOXDUYGUYIUXLUVPUYJUTUYGUYIUVPUXLUYJUYGUYIUVPUXLU
        YJUTUYIUVPUJZUXLUVFUVOJUKZPUXAUNZUYGUYJUYKUVJUYLPUXAUXAUYKUVFUXAUEZUVJU
        YLUYAUYHUVPUYNUVJUYLUTZUTZUYAUVPUYHUYPUYAUYNUYHUVPUYOUXJUYNUVFGUEZUVAUY
        HUVPUYOUTUTUXJUXAGUVFUXQXEUVAUYQUYHUVPUYOUVAUYQUYHUJZUJZUVPUJUVHUYLUVIU
        YSUVPUVHUYLUTUYSUVHUVPUYLUYRUVAUYQUYCUYDXQUVHUVPUJUYLUTUYQUYCUYDXFGUVFU
        VGUVOJXGXHXIXCUVPUVIUYLUTUYSUVIUYLUVPUVFUVGUVOJXJXKXLXMXNXOXPXRXSXTYAUY
        MUWRUVOJUKZLUXAUNZUYGUYJUYLUYTPLUXAUVFUWRUVOJXJYBUWFUYDVUAUYJUWFUYDVUAU
        JZUYJVUBUVOUXCUEZUWFUYJUXBVUACUVOGCRULUWTUYTLUXAUWSUVOUWRJYCYDYEUWFUXCV
        BVCVUCUYJYFIUXCVBUAYIUXCVBUVOYGYHYJYKYLYMXOYNYOXSYPXNYQYOYTYRUUAYSUUBYS
        UUCUUDUUEYNUUFUUKUUGUULUUHXRYLUUIUUJUUMUUNUUOUUPUUQUURYHUUS $.
    $}

  $}

  ${
    $d x y z w v u f g h t s r q a b c d j k m n R $.
    $d x y z w v u f g h t s r q a b c d j k m n A $.
    $( Zorn's Lemma of [Monk1] p. 117.  This version of ~ zorn2 avoids the
       Axiom of Choice by assuming that ` A ` is well-orderable.  (Contributed
       by NM, 6-Apr-1997.)  (Revised by Mario Carneiro, 9-May-2015.) $)
    zorn2g $p |- ( ( A e. dom card /\ R Po A /\
      A. w ( ( w C_ A /\ R Or w ) -> E. x e. A A. z e. w ( z R x \/ z = x ) ) )
                  -> E. x e. A A. y e. A -. x R y ) $=
      ( vr vq vm vk vv vd vs vh vg vn cv wbr wral crab vu vt crn cvv crio crecs
      wn cmpt cima wceq weq breq1 notbid cbvralv breq2 ralbidv syl5bb cbvriotav
      rneq raleqdv rabbidv riotaeqbidv syl5eq cbvmptv recseq ax-mp cbvrabv eqid
      zorn2lem7 ) UAUBGHIJEHQZKQZFRZHLQZUCZSZKETZMQZGQZFRZMNUDOQZPQZVJRZUGZOVLH
      NQZUCZSZKETZSZPWGUEZUHZUFZUAQUISGETZFLMWKVSMWKUBQUISGETZDCABWJLUDJQZIQZVJ
      RZUGZJVPSZIVPUEZUHZUJWKWTUFUJNLUDWIWSNLUKZWIWQJWGSZIWGUEWSWHXBPIWGWHWNWAV
      JRZUGZJWGSPIUKZXBWCXDOJWGOJUKWBXCVTWNWAVJULUMUNXEXDWQJWGXEXCWPWAWOWNVJUOU
      MUPUQURXAXBWRIWGVPXAWFVOKEXAVLHWEVNWDVMUSUTVAZXAWQJWGVPXFUTVBVCVDWJWTVEVF
      VOVSMVNSZKGEVOVQVKFRZMVNSKGUKZXGVLXHHMVNVJVQVKFULUNXIXHVSMVNVKVRVQFUOUPUQ
      VGWLVHWMVHVI $.

    $( Zorn's Lemma.  If the union of every chain (with respect to inclusion)
       in a set belongs to the set, then the set contains a maximal element.
       Theorem 6M of [Enderton] p. 151.  This version of ~ zorn avoids the
       Axiom of Choice by assuming that ` A ` is well-orderable.  (Contributed
       by NM, 12-Aug-2004.)  (Revised by Mario Carneiro, 9-May-2015.) $)
    zorng $p |- ( ( A e. dom card /\ A. z ( ( z C_ A /\ [C.] Or z ) ->
       U. z e. A ) ) -> E. x e. A A. y e. A -. x C. y ) $=
      ( vu wcel cv wss crpss wa wi wal wbr wn wral wrex wpss wceq wo sylib ccrd
      cdm wor cuni risset eqimss2 unissb vex brrpss orbi1i bitr4i ralbii sylibr
      sspss reximi sylbi imim2i alimi porpss zorn2g mp3an2 sylan2 notbii rexbii
      wpo ) DUAUBFZCGZDHVGIUCJZVGUDZDFZKZCLZJAGZBGZIMZNZBDOZADPZVMVNQZNZBDOZADP
      VLVFVHEGZVMIMZWBVMRZSZEVGOZADPZKZCLZVRVKWHCVJWGVHVJVMVIRZADPWGAVIDUEWJWFA
      DWJWBVMHZEVGOZWFWJVIVMHWLVIVMUFEVGVMUGTWEWKEVGWEWBVMQZWDSWKWCWMWDWBVMAUHU
      IUJWBVMUNUKULUMUOUPUQURVFDIVEWIVRDUSABECDIUTVAVBVQWAADVPVTBDVOVSVMVNBUHUI
      VCULVDT $.

    $( Variant of Zorn's lemma ~ zorng in which ` (/) ` , the union of the
       empty chain, is not required to be an element of ` A ` .  (Contributed
       by Jeff Madsen, 5-Jan-2011.)  (Revised by Mario Carneiro,
       9-May-2015.) $)
    zornn0g $p |- ( ( A e. dom card /\ A =/= (/) /\ A. z ( ( z C_ A /\
      z =/= (/) /\ [C.] Or z ) -> U. z e. A ) )
                                  -> E. x e. A A. y e. A -. x C. y ) $=
      ( vw wcel c0 wne cv wss crpss wor w3a cuni wi wral wrex wa ax-mp wceq cdm
      ccrd wal wpss wn csn cun simp2 simp1 snfi finnum unnum sylancl cdif uncom
      cfn sseq2i ssundif bitri difss soss wb ssdif0 uni0b biimpri eleq1d sylbir
      imbi2d cvv vex sseq1 neeq1 soeq2 3anbi123d unieq imbi12d spcv com12 3expa
      difexg an32s unidif0 eleq1i elun1 sylbi syl6 0ex snid elun2 a1ii pm2.61ne
      sylan2 sylanb alrimiv 3ad2ant3 zorng syl2anc ssun1 ssralv reximi wo rexun
      simpr psseq1 0pss syl6bb notbid nne ralbidv rexsn biimpar sylan2b rexeqdv
      eqsn mpbird jaodan ) DUBUAZFZDGHZCIZDJZXTGHZXTKLZMZXTNZDFZOZCUCZMZXSAIZBI
      ZUDZUEZBDGUFZUGZPZAYOQZYMBDPZADQZXRXSYHUHYIYOXQFZEIZYOJZUUAKLZRZUUANZYOFZ
      OZEUCZYQYIXRYNXQFZYTXRXSYHUIYNUPFUUIGUJYNUKSDYNULUMYHXRUUHXSYHUUGEUUDYHUU
      FUUBUUAYNUNZDJZUUCYHUUFOZUUBUUAYNDUGZJUUKYOUUMUUADYNUOUQUUAYNDURUSUUCUUKU
      UJKLZUULUUJUUAJUUCUUNOUUAYNUTUUJUUAKVASUUKUUNRZUULYHGYOFZOUUJGUUJGTZUUFUU
      PYHUUQUUAYNJZUUFUUPVBUUAYNVCUURUUEGYOUUEGTUURUUAVDVEVFVGVHUUOUUJGHZRYHUUJ
      NZDFZUUFUUKUUSUUNYHUVAOZUUKUUSUUNUVBYHUUKUUSUUNMZUVAYGUVCUVAOCUUJUUAVIFUU
      JVIFEVJUUAYNVIVTSXTUUJTZYDUVCYFUVAUVDYAUUKYBUUSYCUUNXTUUJDVKXTUUJGVLXTUUJ
      KVMVNUVDYEUUTDXTUUJVOVFVPVQVRVSWAUVAUUEDFUUFUUTUUEDUUAWBWCUUEDYNWDWEWFUUO
      YHUUPGYNFUUPGWGWHGYNDWISWJWKWLWMVRWNWOABEYOWPWQYQXSYRAYOQZYSYPYRAYODYOJYP
      YRODYNWRYMBDYOWSSWTUVEXSYSYRAYNQZXAYSYRADYNXBXSYSYSUVFXSYSXCXSUVFRZYSUVFX
      SUVFXCUVGYRADYNUVFXSYKGTZBDPZDYNTZYRUVIAGWGYJGTZYMUVHBDUVKYMYKGHZUEUVHUVK
      YLUVLUVKYLGYKUDUVLYJGYKXDYKXEXFXGYKGXHXFXIXJXSUVJUVIBDGXNXKXLXMXOXPXLWLWQ
      $.
  $}

  ${
    $d w x y z A $.  $d w x y z R $.
    zornn0.1 $e |- A e. _V $.
    $( Zorn's Lemma of [Monk1] p. 117.  This theorem is equivalent to the Axiom
       of Choice and states that every partially ordered set ` A ` (with an
       ordering relation ` R ` ) in which every totally ordered subset has an
       upper bound, contains at least one maximal element.  The main proof
       consists of lemmas ~ zorn2lem1 through ~ zorn2lem7 ; this final piece
       mainly changes bound variables to eliminate the hypotheses of
       ~ zorn2lem7 .  (Contributed by NM, 6-Apr-1997.)  (Revised by Mario
       Carneiro, 9-May-2015.) $)
    zorn2 $p |- ( ( R Po A /\
      A. w ( ( w C_ A /\ R Or w ) -> E. x e. A A. z e. w ( z R x \/ z = x ) ) )
                  -> E. x e. A A. y e. A -. x R y ) $=
      ( ccrd cdm wcel wpo cv wss wor wa wbr weq wral wrex cvv wal numth3 zorn2g
      wo wi wn ax-mp mp3an1 ) EHIJZEFKDLZEMUJFNOCLALZFPCAQUDCUJRAESUEDUAUKBLFPU
      FBERAESETJUIGETUBUGABCDEFUCUH $.

    $( Zorn's Lemma.  If the union of every chain (with respect to inclusion)
       in a set belongs to the set, then the set contains a maximal element.
       This theorem is equivalent to the Axiom of Choice.  Theorem 6M of
       [Enderton] p. 151.  See ~ zorn2 for a version with general partial
       orderings.  (Contributed by NM, 12-Aug-2004.) $)
    zorn $p |- ( A. z ( ( z C_ A /\ [C.] Or z ) -> U. z e. A ) ->
                E. x e. A A. y e. A -. x C. y ) $=
      ( ccrd cdm wcel cv wss crpss wor wa cuni wi wal wpss wn wral cvv numth3
      wrex ax-mp zorng mpan ) DFGHZCIZDJUGKLMUGNDHOCPAIBIQRBDSADUBDTHUFEDTUAUCA
      BCDUDUE $.

    $( Variant of Zorn's lemma ~ zorn in which ` (/) ` , the union of the empty
       chain, is not required to be an element of ` A ` .  (Contributed by Jeff
       Madsen, 5-Jan-2011.) $)
    zornn0 $p |- ( ( A =/= (/) /\ A. z ( ( z C_ A /\ z =/= (/) /\
      [C.] Or z ) -> U. z e. A ) ) -> E. x e. A A. y e. A -. x C. y ) $=
      ( ccrd cdm wcel c0 wne cv wss crpss wor w3a cuni wi wal wpss cvv wn ax-mp
      wral wrex numth3 zornn0g mp3an1 ) DFGHZDIJCKZDLUIIJUIMNOUIPDHQCRAKBKSUABD
      UCADUDDTHUHEDTUEUBABCDUFUG $.
  $}

  ${
    $d a x y z C $.  $d x y D $.  $d a f u v w x y z G $.  $d a f u w y z ph $.
    $d a f u w x y z A $.  $d a f u w x y z B $.  $d x z F $.
    ttukeylem.1 $e |- ( ph ->
      F : ( card ` ( U. A \ B ) ) -1-1-onto-> ( U. A \ B ) ) $.
    ttukeylem.2 $e |- ( ph -> B e. A ) $.
    ttukeylem.3 $e |- ( ph -> A. x ( x e. A <-> ( ~P x i^i Fin ) C_ A ) ) $.
    $( Lemma for ~ ttukey .  Expand out the property of being an element of a
       property of finite character.  (Contributed by Mario Carneiro,
       15-May-2015.) $)
    ttukeylem1 $p |- ( ph -> ( C e. A <-> ( ~P C i^i Fin ) C_ A ) ) $=
      ( cvv wcel cpw cfn cin wss cdom cun ccrd ssexg wb wi elex a1i wa wbr cuni
      cdif ssun1 undif1 sseqtr4i cfv wfo fvex wf1o f1ofo syl fornex mpsyl unexg
      id syl2anc sylancr uniexb sylibr syl2anr infpwfidom reldom brrelexi ex cv
      3syl wal wceq eleq1 pweq ineq1d sseq1d bibi12d spcgv syl5com pm5.21ndd )
      AEJKZECKZELZMNZCOZWCWBUAAECUBUCAWFWBAWFUDWEJKZEWEPUEWBWFWFCJKZWGAWFUTACUF
      ZJKZWHAWIWIDUGZDQZOWLJKZWJWIWIDQWLWIDUHWIDUIUJAWKJKZDCKWMWKRUKZJKAWOWKFUL
      ZWNWKRUMAWOWKFUNWPGWOWKFUOUPWOWKJFUQURHWKDJCUSVAWIWLJSVBCVCVDWECJSVEEVFEW
      EPVGVHVKVIABVJZCKZWQLZMNZCOZTZBVLWBWCWFTZIXBXCBEJWQEVMZWRWCXAWFWQECVNXDWT
      WECXDWSWDMWQEVOVPVQVRVSVTWA $.

    $( Lemma for ~ ttukey .  A property of finite character is closed under
       subsets.  (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukeylem2 $p |- ( ( ph /\ ( C e. A /\ D C_ C ) ) -> D e. A ) $=
      ( wcel wss wa cpw cfn cin wi wb ttukeylem1 adantr simpr sspwb sylib ssrin
      sstr2 3syl 3imtr4d impancom impr ) AECKZFELZFCKZAUKUJULAUKMZENZOPZCLZFNZO
      PZCLZUJULUMUQUNLZURUOLUPUSQUMUKUTAUKUAFEUBUCUQUNOUDURUOCUEUFAUJUPRUKABCDE
      GHIJSTAULUSRUKABCDFGHIJSTUGUHUI $.

    ttukeylem.4 $e |- G = recs ( ( z e. _V |-> if ( dom z = U. dom z ,
      if ( dom z = (/) , B , U. ran z ) , ( ( z ` U. dom z ) u.
      if ( ( ( z ` U. dom z ) u. { ( F ` U. dom z ) } ) e. A ,
        { ( F ` U. dom z ) } , (/) ) ) ) ) ) $.
    $( Lemma for ~ ttukey .  (Contributed by Mario Carneiro, 11-May-2015.) $)
    ttukeylem3 $p |- ( ( ph /\ C e. On ) -> ( G ` C ) = if ( C = U. C ,
      if ( C = (/) , B , U. ( G " C ) ) , ( ( G ` U. C ) u. if ( ( ( G ` U. C )
         u. { ( F ` U. C ) } ) e. A , { ( F ` U. C ) } , (/) ) ) ) ) $=
      ( con0 wcel cfv cvv wceq c0 cif cun wa cres cv cdm cuni crn csn cmpt cima
      tfr2 adantl eqidd simpr dmeqd wfn tfr1 onss ad2antlr fnssres sylancr fndm
      wss syl eqtrd unieqd eqeq12d eqeq1d rneqd df-ima syl6eqr ifbieq2d fveq12d
      fveq2d sneqd uneq12d eleq1d ifbieq12d wn csuc onuni ad3antlr sucidg eloni
      word wo orduniorsuc orcanai eleqtrrd fvres ifbid ifeq2da wfun fnfun ax-mp
      uneq1d resfunexg elex funimaexg mpan uniexg ifcl syl2an fvex snex sylancl
      0ex ifex unex fvmptd ) AFMNZUAZFHOZHFUBZCPCUCZUDZXOUEZQZXORQZEXNUFZUEZSZX
      PXNOZYBXPGOZUGZTZDNZYDRSZTZSZUHZOZFFUEZQZFRQZEHFUIZUEZSZYLHOZYRYLGOZUGZTZ
      DNZYTRSZTZSZXJXLYKQAFHYJLUJUKXKCXMYIUUEPYJPXKYJULXKXNXMQZUAZYIYMYQYLXMOZU
      UHYTTZDNZYTRSZTZSUUEUUGXQYMYAYHYQUULUUGXOFXPYLUUGXOXMUDZFUUGXNXMXKUUFUMZU
      NUUGXMFUOZUUMFQUUGHMUOZFMVBZUUOHYJLUPZXJUUQAUUFFUQURMFHUSUTFXMVAVCVDZUUGX
      OFUUSVEZVFUUGXRYNXTYPEUUGXOFRUUSVGUUGXSYOUUGXSXMUFYOUUGXNXMUUNVHHFVIVJVEV
      KUUGYBUUHYGUUKUUGXPYLXNXMUUNUUTVLZUUGYFUUJYDRYTRUUGYEUUIDUUGYBUUHYDYTUVAU
      UGYCYSUUGXPYLGUUTVMVNZVOVPUVBUUGRULVQVOVQUUGYMUULUUDYQUUGYMVRZUAZUUHYRUUK
      UUCUVDYLFNUUHYRQUVDYLYLVSZFUVDYLMNZYLUVENXJUVFAUUFUVCFVTWAYLMWBVCUUGYMFUV
      EQZUUGFWDZYMUVGWEXJUVHAUUFFWCURFWFVCWGWHYLFHWIVCZUVDUUJUUBYTRUVDUUIUUADUV
      DUUHYRYTUVIWOVPWJVOWKVDXKHWLZXJXMPNUUPUVJUURMHWMWNZAXJUMHFMWPUTXKYQPNZUUD
      PNUUEPNAEPNZYPPNZUVLXJAEDNUVMJEDWQVCXJYOPNZUVNUVJXJUVOUVKHFMWRWSYOPWTVCYN
      EYPPXAXBYRUUCYLHXCUUBYTRYSXDXFXGXHYMYQUUDPXAXEXIVD $.

    $( Lemma for ~ ttukey .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukeylem4 $p |- ( ph -> ( G ` (/) ) = B ) $=
      ( c0 cfv cuni wceq cif cun wcel iftrue ax-mp cima 0elon ttukeylem3 eqcomi
      csn con0 mpan2 uni0 eqid eqtri syl6eq ) ALGMZLLNZOZLLOZEGLUANZPZUMGMZURUM
      FMUEZQDRUSLPQZPZEALUFRULVAOUBABCDELFGHIJKUCUGVAUQEUNVAUQOUMLUHUDUNUQUTSTU
      OUQEOLUIUOEUPSTUJUK $.

    $( Lemma for ~ ttukey .  The ` G ` function forms a (transfinitely long)
       chain of inclusions.  (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukeylem5 $p |- ( ( ph /\ ( C e. On /\ D e. On /\ C C_ D ) ) ->
      ( G ` C ) C_ ( G ` D ) ) $=
      ( va con0 wcel wss cfv wi wceq vy wa cv sseq2 fveq2 sseq2d imbi12d imbi2d
      wral r19.21v wo simpllr simplr onsseleq syl2anc cuni cima cif csn cun wfn
      wb c0 cvv cdm crn cmpt tfr1 a1i syl simprr fnfvima syl3anc elssuni wn n0i
      onss iffalse 3syl sseqtr4d adantr csuc uniex sucid word eloni orduniorsuc
      vex orcanai syl5eleqr simplrl rspcv syl3c ssun1 syl6ss simplll ttukeylem3
      ifbothda expr eqimss jaod sylbid expcom a2d syl5bi tfis3 exp3acom3r 3imp2
      ex ) AFOPZGOPZFGQZFIRZGIRZQZXKAXJXLXOSZAXJUBZFUAUCZQZXMXRIRZQZSZSZXQFNUCZ
      QZXMYDIRZQZSZSZXQXPSUANGXRYDTZYBYHXQYJXSYEYAYGXRYDFUDYJXTYFXMXRYDIUEUFUGU
      HXRGTZYBXPXQYKXSXLYAXOXRGFUDYKXTXNXMXRGIUEUFUGUHYINXRUIXQYHNXRUIZSXROPZYC
      XQYHNXRUJYMXQYLYBXQYMYLYBSXQYMUBZYLYBYNYLUBZXSFXRPZFXRTZUKZYAYOXJYMXSYRVB
      AXJYMYLULXQYMYLUMFXRUNUOYOYPYAYQYNYLYPYAYNYLYPUBZUBZXMXRXRUPZTZXRVCTZEIXR
      UQZUPZURZUUAIRZUUGUUAHRUSZUTDPUUHVCURZUTZURZXTUUBXMUUFQZXMUUJQXMUUKQYTUUF
      UUJUUFUUKXMUDUUJUUKXMUDYTUULUUBYTXMUUEUUFYTXMUUDPZXMUUEQYTIOVAZXROQZYPUUM
      UUNYTICVDCUCZVEZUUQUPZTUUQVCTEUUPVFUPURUURUUPRZUUSUURHRUSZUTDPUUTVCURUTUR
      VGMVHVIYTYMUUOXQYMYSUMZXRVQVJYNYLYPVKZOXRIFVLVMXMUUDVNVJYTYPUUCVOUUFUUETU
      VBXRFVPUUCEUUEVRVSVTWAYTUUBVOZUBZXMUUGUUJUVDUUAXRPYLFUUAQZXMUUGQZUVDUUAUU
      AWBZXRUUAXRUAWHWCWDYTUUBXRUVGTZYTYMXRWEUUBUVHUKUVAXRWFXRWGVSWIWJYNYLYPUVC
      WKUVDYPUVEYTYPUVCUVBWAFXRVNVJYHUVEUVFSNUUAXRYDUUATZYEUVEYGUVFYDUUAFUDUVIY
      FUUGXMYDUUAIUEUFUGWLWMUUGUUIWNWOWRYTAYMXTUUKTAXJYMYSWPUVAABCDEXRHIJKLMWQU
      OVTWSYQYASYOYQXMXTTYAFXRIUEXMXTWTVJVIXAXBXIXCXDXEXFXGXH $.

    $( Lemma for ~ ttukey .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukeylem6 $p |- ( ( ph /\ C e. suc ( card ` ( U. A \ B ) ) ) ->
      ( G ` C ) e. A ) $=
      ( vu con0 wcel cfv wa wi wceq c0 vy va vw vf cuni cdif ccrd cardon onsuci
      vv csuc onelon sylan cv eleq1 fveq2 eleq1d imbi12d imbi2d wral r19.21v wb
      a1i word wss onordi ordelss sselda biimt syl ralbidva cima cif csn simprl
      cun onssi sseldi ttukeylem3 syldan ad3antrrr wn cpw cfn cin wf wrex inss2
      wex simpr ciun inss1 elpwid wfn wfun cvv cdm crn cmpt tfr1 fnfun funiunfv
      mp2b syl6sseqr dfss3 eliun ralbii bitri eleq2d ac6sfi syl2anc wne simp-4l
      sylib simprrl adantr frn onss sstrd wfo adantrr ffn dffn4 fofi dm0rn0 fdm
      eqeq1d syl5bbr sseldd simplrr ad2antrr rspcv sylc ad2antrl vex ttukeylem2
      expr ex ifclda uneq2 necon3bid biimpar syl3anc ffvelrn adantl rnex simprr
      ordunifi ssonunii fnfvelrn elssuni ttukeylem5 syl13anc sseld anassrs impr
      ralimdva expimpd sylibr syl12anc mpanr2 mpdan pm2.61ne exlimdv ttukeylem1
      0ss mpd ssrdv mpbird un0 syl5eqr uniex sucid wo eloni orduniorsuc orcanai
      3syl syl5eleqr ifbothda eqeltrd sylbird com23 a2i sylbi tfis3 imp3a mpcom
      ) FNOZAFDUEEUFZUGPZUKZOZQFHPZDOZAUWLNOZUWMUWIUWPAUWKUWJUHUIZVCUWLFULUMUWI
      AUWMUWOAUAUNZUWLOZUWRHPZDOZRZRZAUBUNZUWLOZUXDHPZDOZRZRZAUWMUWORZRUAUBFUWR
      UXDSZUXBUXHAUXKUWSUXEUXAUXGUWRUXDUWLUOUXKUWTUXFDUWRUXDHUPUQURUSUWRFSZUXBU
      XJAUXLUWSUWMUXAUWOUWRFUWLUOUXLUWTUWNDUWRFHUPUQURUSUXIUBUWRUTZUXCRUWRNOZUX
      MAUXHUBUWRUTZRUXCAUXHUBUWRVAAUXOUXBAUWSUXOUXAAUWSUXOUXARAUWSQZUXOUXGUBUWR
      UTZUXAUXPUXGUXHUBUWRUXPUXDUWROQUXEUXGUXHVBUXPUWRUWLUXDAUWLVDZUWSUWRUWLVEU
      XRAUWLUWQVFVCUWLUWRVGUMVHUXEUXGVIVJVKAUWSUXQUXAAUWSUXQQZQZUWTUWRUWRUEZSZU
      WRTSZEHUWRVLUEZVMZUYAHPZUYFUYAGPVNZVPZDOZUYGTVMZVPZVMZDAUXSUXNUWTUYLSUXTU
      WLNUWRUWLUWQVQAUWSUXQVOVRZABCDEUWRGHIJKLVSVTUXTUYBUYEUYKDUXTUYBQZUYCEUYDD
      AEDOZUXSUYBUYCJWAUYNUYDDOZUYCWBUYNUYPUYDWCZWDWEZDVEZUYNUCUYRDUYNUCUNZUYRO
      ZUYTDOZUYNVUAQZUYTUWRUDUNZWFZMUNZVUFVUDPZHPZOZMUYTUTZQZUDWIZVUBVUCUYTWDOZ
      VUFUJUNZHPZOZUJUWRWGZMUYTUTZVULVUCUYRWDUYTUYQWDWHUYNVUAWJZVRZVUCUYTUJUWRV
      UOWKZVEZVURVUCUYTUYDVVAVUCUYTUYDVUCUYRUYQUYTUYQWDWLVUSVRWMHNWNHWOVVAUYDSH
      CWPCUNZWQZVVDUEZSVVDTSEVVCWRUEVMVVEVVCPZVVFVVEGPVNZVPDOVVGTVMVPVMWSLWTNHX
      AUJUWRHXBXCXDVVBVUFVVAOZMUYTUTVURMUYTVVAXEVVHVUQMUYTUJVUFUWRVUOXFXGXHXNVU
      PVUIMUJUYTUWRUDVUNVUGSVUOVUHVUFVUNVUGHUPXIXJXKVUCVUKVUBUDUYNVUAVUKVUBUYNV
      UAVUKQZQZVUBTDOZUYTTUYTTDUOVVJUYTTXLZQZAVUDWRZUEZHPZDOZUYTVVPVEZVUBAUXSUY
      BVVIVVLXMVVMVVOUWROUXQVVQVVMVVNUWRVVOVVMVUEVVNUWRVEZVVJVUEVVLUYNVUAVUEVUJ
      XOZXPZUYTUWRVUDXQZVJZVVMVVNNVEZVVNWDOZVVNTXLZVVOVVNOVVMVVNUWRNVWCVVMUXNUW
      RNVEZUXTUXNUYBVVIVVLUYMWAUWRXRZVJXSVVMVUMUYTVVNVUDXTZVWEVVJVUMVVLUYNVUAVU
      MVUKVUTYAXPVVMVUDUYTWNZVWIVVMVUEVWJVWAUYTUWRVUDYBZVJUYTVUDYCXNUYTVVNVUDYD
      XKVVJVWFVVLVVJVVNTUYTTVVNTSVUDWQZTSVVJUYTTSVUDYEVVJVWLUYTTVVJVUEVWLUYTSVV
      TUYTUWRVUDYFVJYGYHUUAUUBVVNUUHUUCYIUYNUXQVVIVVLAUWSUXQUYBYJYKUXGVVQUBVVOU
      WRUXDVVOSUXFVVPDUXDVVOHUPUQYLYMVVMVUFVVPOZMUYTUTZVVRVVJVWNVVLUYNVUAVUKVWN
      VUCVUEVUJVWNVUCVUEQVUIVWMMUYTVUCVUEVUFUYTOZVUIVWMRVUCVUEVWOQZQZVUHVVPVUFV
      WQAVUGNOVVONOZVUGVVOVEZVUHVVPVEAUXSUYBVUAVWPXMVWQUWRNVUGVWQUXNVWGUXTUXNUY
      BVUAVWPUYMWAVWHVJZVWPVUGUWROVUCUYTUWRVUFVUDUUDUUEYIVWQVWDVWRVWQVVNUWRNVUE
      VVSVUCVWOVWBYNVWTXSVVNVUDUDYOUUFUUIVJVWQVUGVVNOZVWSVWQVWJVWOVXAVUEVWJVUCV
      WOVWKYNVUCVUEVWOUUGUYTVUFVUDUUJXKVUGVVNUUKVJABCDEVUGVVOGHIJKLUULUUMUUNUUO
      UUQUURUUPXPMUYTVVPXEUUSABDEVVPUYTGIJKYPUUTAVVKUXSUYBVVIAUYOVVKJAUYOTEVEVV
      KEUVFABDEETGIJKYPUVAUVBWAUVCYQUVDUVGYRUVHAUYPUYSVBUXSUYBABDEUYDGIJKUVEYKU
      VIXPYSUYIUYIUYFDOZUYKDOUXTUYBWBZQZUYGTUYGUYJSUYHUYKDUYGUYJUYFYTUQTUYJSZUY
      FUYKDVXEUYFUYFTVPUYKUYFUVJTUYJUYFYTUVKUQVXDUYIWJVXDVXBUYIWBVXDUYAUWROUXQV
      XBVXDUYAUYAUKZUWRUYAUWRUAYOUVLUVMUXTUYBUWRVXFSZUXTUXNUWRVDUYBVXGUVNUYMUWR
      UVOUWRUVPUVRUVQUVSAUWSUXQVXCYJUXGVXBUBUYAUWRUXDUYASUXFUYFDUXDUYAHUPUQYLYM
      XPUVTYSUWAYQUWBYRUWCUWDUWEVCUWFUWGUWH $.

    $( Lemma for ~ ttukey .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukeylem7 $p |- ( ph -> E. x e. A ( B C_ x /\ A. y e. A -. x C. y ) ) $=
      ( cfv wcel wss wn wa c0 wceq syl va cuni cdif ccrd cv wpss wral wrex csuc
      fvex sucid ttukeylem6 mpan2 ttukeylem4 con0 w3a cardon 3pm3.2i ttukeylem5
      0elon 0ss eqsstr3d wi simprr cun ssun1 undif1 sseqtr4i ccnv simpl wf wf1o
      f1ocnv f1of adantr eldifi ad2antll simprll elunii syl2anc eldifn ffvelrnd
      3syl eldifd onelon sylancr suceloni a1i word onordi ordsucss syl13anc csn
      mpsyl cif ssun2 eloni ordunisuc fveq2d f1ocnvfv2 eqtr2d vex elsnc ordelss
      sylibr eqsstrd simprlr sstrd eqeltrrd ttukeylem2 syl12anc iftrue eleqtrrd
      snssd unssd sseldi cima ttukeylem3 syldan wne sucidg ordirr nelne1 neneqd
      neeqtrrd eqtrd sseldd expr ssrdv syl5ss eqssd npss ralrimiva sseq2 psseq1
      iffalse notbid ralbidv anbi12d rspcev ) AEUBZFUCZUDMZHMZENZFUUDOZUUDCUEZU
      FZPZCEUGZFBUEZOZUUKUUGUFZPZCEUGZQZBEUHAUUCUUCUINUUEUUCUUBUDUJUKABDEFUUCGH
      IJKLULUMAFRHMZUUDABDEFGHIJKLUNARUONZUUCUONZRUUCOZUPUUQUUDOUURUUSUUTUTUUBU
      QZUUCVAURABDEFRUUCGHIJKLUSUMVBZAUUICEAUUGENZQUUDUUGOZUUDUUGSZVCUUIAUVCUVD
      UVEAUVCUVDQZQZUUDUUGAUVCUVDVDUVGUUGUUGFUCZFVEZUUDUUGUUGFVEUVIUUGFVFUUGFVG
      VHUVGUVHFUUDUVGUAUVHUUDAUVFUAUEZUVHNZUVJUUDNAUVFUVKQZQZUVJGVIZMZUIZHMZUUD
      UVJUVMAUVPUONZUUSUVPUUCOZUVQUUDOAUVLVJZUVMUVOUONZUVRUVMUUSUVOUUCNZUWAUVAU
      VMUUBUUCUVJUVNAUUBUUCUVNVKZUVLAUUCUUBGVLZUUBUUCUVNVLUWCIUUCUUBGVMUUBUUCUV
      NVNWCVOUVMUVJUUAFUVMUVJUUGNZUVCUVJUUANUVKUWEAUVFUVJUUGFVPVQZAUVCUVDUVKVRZ
      UVJUUGEVSVTUVKUVJFNPAUVFUVJUUGFWAVQWDZWBZUUCUVOWEWFZUVOWGTZUUSUVMUVAWHZUU
      CWIZUVMUWBUVSUUCUVAWJZUWIUVOUUCWKWNABDEFUVPUUCGHIJKLUSWLUVMUVJUVPUBZHMZUW
      PUWOGMZWMZVEZENZUWRRWOZVEZUVQUVMUXAUXBUVJUXAUWPWPUVMUVJUWRUXAUVMUVJUWQSUV
      JUWRNUVMUWQUVOGMZUVJUVMUWOUVOGUVMUVOWIZUWOUVOSUVMUWAUXDUWJUVOWQTZUVOWRTZW
      SUVMUWDUVJUUBNUXCUVJSAUWDUVLIVOUWHUUCUUBUVJGWTVTXAZUVJUWQUAXBXCXEUVMUWTUX
      AUWRSUVMAUVCUWSUUGOUWTUVTUWGUVMUWPUWRUUGUVMUWPUUDUUGUVMUWPUVOHMZUUDUVMUWO
      UVOHUXFWSUVMAUWAUUSUVOUUCOZUXHUUDOUVTUWJUWLUVMUWMUWBUXIUWNUWIUUCUVOXDWFAB
      DEFUVOUUCGHIJKLUSWLXFAUVCUVDUVKXGXHUVMUWQUUGUVMUVJUWQUUGUXGUWFXIXNXOABEFU
      UGUWSGIJKXJXKUWTUWRRXLTXMXPUVMUVQUVPUWOSZUVPRSFHUVPXQUBWOZUXBWOZUXBAUVLUV
      RUVQUXLSUWKABDEFUVPGHIJKLXRXSUVMUXJPUXLUXBSUVMUVPUWOUVMUVPUVOUWOUVMUVOUVP
      NZUVOUVONPZUVPUVOXTUVMUWBUXMUWIUVOUUCYATUVMUXDUXNUXEUVOYBTUVOUVPUVOYCVTUX
      FYEYDUXJUXKUXBYPTYFXMYGYHYIAUUFUVFUVBVOXOYJYKYHUUDUUGYLXEYMUUPUUFUUJQBUUD
      EUUKUUDSZUULUUFUUOUUJUUKUUDFYNUXOUUNUUICEUXOUUMUUHUUKUUDUUGYOYQYRYSYTXK
      $.
  $}

  ${
    $d f w x y z A $.  $d f w x y z B $.
    $( The Teichm&uuml;ller-Tukey Lemma ~ ttukey with a slightly stronger
       conclusion: we can set up the maximal element of ` A ` so that it also
       contains some given ` B e. A ` as a subset.  (Contributed by Mario
       Carneiro, 15-May-2015.) $)
    ttukey2g $p |- ( ( U. A e. dom card /\ B e. A /\
      A. x ( x e. A <-> ( ~P x i^i Fin ) C_ A ) )
        -> E. x e. A ( B C_ x /\ A. y e. A -. x C. y ) ) $=
      ( vf vz vw cuni ccrd cdm wcel cv wss wa cfv cvv wceq c0 cif cun cpw wb wn
      cfn cin wal wpss wral wrex cdif difss ssnum mpan2 wf1o wex cen wbr isnum3
      wi bren bitri w3a crn csn cmpt crecs simp1 simp2 simp3 dmeq unieqd eqeq1d
      eqeq12d rneq ifbieq2d fveq12d fveq2d sneqd uneq12d eleq1d eqidd ifbieq12d
      id cbvmptv recseq ax-mp ttukeylem7 3expib exlimiv sylbi syl 3impib ) CHZI
      JZKZDCKZALZCKWQUAUDUECMUBAUFZDWQMWQBLUGUCBCUHNACUIZWOWMDUJZWNKZWPWRNWSUSZ
      WOWTWMMXAWMDUKWMWTULUMXAWTIOZWTELZUNZEUOZXBXAXCWTUPUQXFWTURXCWTEUTVAXEXBE
      XEWPWRWSXEWPWRVBABFCDXDGPGLZJZXHHZQZXHRQZDXGVCZHZSZXIXGOZXOXIXDOZVDZTZCKZ
      XQRSZTZSZVEZVFZXEWPWRVGXEWPWRVHXEWPWRVIYCFPFLZJZYFHZQZYFRQZDYEVCZHZSZYGYE
      OZYMYGXDOZVDZTZCKZYORSZTZSZVEZQYDUUAVFQGFPYBYTXGYEQZXJYHXNYAYLYSUUBXHYFXI
      YGXGYEVJZUUBXHYFUUCVKZVMUUBXKYIXMYKDUUBXHYFRUUCVLUUBXLYJXGYEVNVKVOUUBXOYM
      XTYRUUBXIYGXGYEUUBWCUUDVPZUUBXSYQXQRYORUUBXRYPCUUBXOYMXQYOUUEUUBXPYNUUBXI
      YGXDUUDVQVRZVSVTUUFUUBRWAWBVSWBWDYCUUAWEWFWGWHWIWJWKWL $.

    $( The Teichm&uuml;ller-Tukey Lemma ~ ttukey stated with the "choice" as an
       antecedent (the hypothesis ` U. A e. dom card ` says that ` U. A ` is
       well-orderable).  (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukeyg $p |- ( ( U. A e. dom card /\ A =/= (/) /\
      A. x ( x e. A <-> ( ~P x i^i Fin ) C_ A ) )
        -> E. x e. A A. y e. A -. x C. y ) $=
      ( vz cuni ccrd cdm wcel c0 wne cv cpw cfn cin wss wb wal wpss wn wrex wex
      wral wi n0 w3a wa ttukey2g simpr reximi syl 3exp exlimdv syl5bi 3imp ) CE
      FGHZCIJZAKZCHUQLMNCOPAQZUQBKRSBCUBZACTZUPDKZCHZDUAUOURUTUCZDCUDUOVBVCDUOV
      BURUTUOVBURUEVAUQOZUSUFZACTUTABCVAUGVEUSACVDUSUHUIUJUKULUMUN $.
  $}

  ${
    $d x y A $.
    ttukey.1 $e |- A e. _V $.
    $( The Teichm&uuml;ller-Tukey Lemma, an Axiom of Choice equivalent.  If
       ` A ` is a nonempty collection of finite character, then ` A ` has a
       maximal element with respect to inclusion.  Here "finite character"
       means that ` x e. A ` iff every finite subset of ` x ` is in ` A ` .
       (Contributed by Mario Carneiro, 15-May-2015.) $)
    ttukey $p |- ( ( A =/= (/) /\ A. x ( x e. A <-> ( ~P x i^i Fin ) C_ A ) )
       -> E. x e. A A. y e. A -. x C. y ) $=
      ( cuni ccrd cdm wcel c0 wne cv cpw cfn cin wss wb wal wpss wn cvv ttukeyg
      wral wrex uniex numth3 ax-mp mp3an1 ) CEZFGHZCIJAKZCHUJLMNCOPAQUJBKRSBCUB
      ACUCUHTHUICDUDUHTUEUFABCUAUG $.
  $}

  ${
    $d F w y z $.  $d K w y z $.  $d g w y $.  $d s w y $.  $d w x y z $.
    axdclem.1 $e |- F = ( rec ( ( y e. _V |->
                            ( g ` { z | y x z } ) ) , s ) |` om ) $.
    $( Lemma for ~ axdc .  (Contributed by Mario Carneiro, 25-Jan-2013.) $)
    axdclem $p |- ( ( A. y e. ~P dom x ( y =/= (/) -> ( g ` y ) e. y )
      /\ ran x C_ dom x /\ E. z ( F ` K ) x z ) ->
      ( K e. om -> ( F ` K ) x ( F ` suc K ) ) ) $=
      ( vw cv c0 cfv wcel wi wss wbr cab fvex wceq nfcv wne cdm cpw crn wex w3a
      wral csuc com brelrn abssi sstr mpan dmex elpw2 sylibr neeq1 syl6bb eleq2
      vex abn0 breq2 cbvabv eleq2i syl6bbr fveq2 breq2d bitrd imbi12d rspcv syl
      elab com12 3imp cvv breq1 abbidv fveq2d frsucmpt mpan2 syl5ibrcom ) BJZKU
      AZWBDJZLZWBMZNZBAJZUBZUCZUGZWHUDZWIOZFELZCJZWHPZCUEZUFWNFUHELZWHPFUIMZWNW
      PCQZWDLZWHPZWKWMWQXBWMWKWQXBNZWMWTWJMZWKXCNWMWTWIOZXDWTWLOWMXEWPCWLWNWOWH
      FERCUTUJUKWTWLWIULUMWTWIWHAUTUNUOUPWGXCBWTWJWBWTSZWCWQWFXBXFWCWTKUAWQWBWT
      KUQWPCVAURXFWFWNWEWHPZXBXFWFWEWNIJZWHPZIQZMZXGXFWFWEWTMXKWBWTWEUSXJWTWEXI
      WPICXHWOWNWHVBVCVDVEXIXGIWEWBWDRXHWEWNWHVBVLURXFWEXAWNWHWBWTWDVFVGVHVIVJV
      KVMVNWSWRXAWNWHWSXAVOMWRXASWTWDRBGJZFWBWOWHPZCQZWDLXAEVOBXLTBFTBXATHWBWNS
      ZXNWTWDXOXMWPCWBWNWOWHVPVQVRVSVTVGWA $.
  $}

  ${
    $d F f n $.  $d F k n y z $.  $d f g n x $.  $d g k n s y $.
    $d g k n x y z $.
    axdclem2.1 $e |- F = ( rec ( ( y e. _V |->
                             ( g ` { z | y x z } ) ) , s ) |` om ) $.
    $( Lemma for ~ axdc .  Using the full Axiom of Choice, we can construct a
       choice function ` g ` on ` ~P dom x ` .  From this, we can build a
       sequence ` F ` starting at any value ` s e. dom x ` by repeatedly
       applying ` g ` to the set ` ( F `` x ) ` (where ` x ` is the value from
       the previous iteration).  (Contributed by Mario Carneiro,
       25-Jan-2013.) $)
    axdclem2 $p |- ( E. z s x z -> ( ran x C_ dom x ->
       E. f A. n e. om ( f ` n ) x ( f ` suc n ) ) ) $=
      ( cv c0 cfv wcel wi wral wex wbr com cvv wceq vk wne cdm cpw crn wss csuc
      vex dmex pwex ac4c w3a wf wfn cab cmpt crdg frfnom fneq1i mpbir a1i fveq2
      cres suceq fveq2d breq12d fveq1i ax-mp eqtri breq1i biimpri eximi axdclem
      fr0g peano1 mpi syl3an3 3com23 fvex brelrn ssel syl5 eldm syl6ib ad2antll
      wa peano2 3expia com3r syld 3adantr2 ex finds2 com12 breldm syl6 ralrimiv
      ffnfv sylanbrc omex fex2 syl3anc fveq1 ralbidv spcegv sylc 3exp exlimiv
      imp ) BJZKUBXJEJZLXJMNBAJZUCZUDZOZEPHJZCJZXLQZCPZXLUEZXMUFZFJZDJZLZYBUGZY
      CLZXLQZFROZDPZNNZBXNEXMXLAUHUIZUJUKXOYJEXOXSYAYIXOXSYAULZGSMZYBGLZYEGLZXL
      QZFROZYIYLRXMGUMZRSMZXMSMZYMYLGRUNZYNXMMZFROYRUUAYLUUABSXJXQXLQCUOXKLUPZX
      PUQRVCZRUNXPUUCURRGUUDIUSUTVAYLUUBFRYLYBRMZYPUUBUUEYLYPYPKGLZKUGZGLZXLQZU
      AJZGLZUUJUGZGLZXLQZUUMUULUGZGLZXLQZYLFUAYBKTZYNUUFYOUUHXLYBKGVBUURYEUUGGY
      BKVDVEVFYBUUJTZYNUUKYOUUMXLYBUUJGVBUUSYEUULGYBUUJVDVEVFYBUULTZYNUUMYOUUPX
      LYBUULGVBUUTYEUUOGYBUULVDVEVFXOYAXSUUIXSXOYAUUFXQXLQZCPZUUIXRUVACUVAXRUUF
      XPXQXLUUFKUUDLZXPKGUUDIVGXPSMUVCXPTHUHXPSUUCVNVHVIVJVKVLXOYAUVBULKRMUUIVO
      ABCEGKHIVMVPVQVRUUJRMZYLUUNUUQNZUVDXOYAUVEXSUVDXOYAWFZWFUUNUUMXQXLQCPZUUQ
      YAUUNUVGNUVDXOYAUUNUUMXMMZUVGUUNUUMXTMYAUVHUUKUUMXLUUJGVSUULGVSZVTXTXMUUM
      WAWBCUUMXLUVIWCWDWEUVDUVFUVGUUQNUVFUVGUVDUUQXOYAUVGUVDUUQNUVDUULRMXOYAUVG
      ULUUQUUJWGABCEGUULHIVMWBWHWIXIWJWKWLWMWNZYNYOXLYBGVSYEGVSWOWPWQFRXMGWRWSY
      SYLWTVAYTYLYKVARXMGSSXAXBYLYPFRUVJWQYHYQDGSYCGTZYGYPFRUVKYDYNYFYOXLYBYCGX
      CYEYCGXCVFXDXEXFXGXHVH $.
  $}

  ${
    $d f n x y z v g u w $.
    $( This theorem derives ~ ax-dc using ~ ax-ac and ~ ax-inf .  Thus, _AC_
       implies _DC_, but not vice-versa (so that ZFC is strictly stronger than
       ZF+DC).  (New usage is discouraged.)  (Contributed by Mario Carneiro,
       25-Jan-2013.) $)
    axdc $p |- ( ( E. y E. z y x z /\ ran x C_ dom x ) ->
       E. f A. n e. om ( f ` n ) x ( f ` suc n ) ) $=
      ( vv vg vu vw cv wbr wex cfv com cvv cab cmpt crdg cres wceq crn cdm csuc
      wss wral wi breq2 cbvabv breq1 abbidv syl5eq fveq2d cbvmptv rdgeq1 reseq1
      weq mp2b axdclem2 exlimiv imp ) BJZCJZAJZKCLZBLVCUAVCUBUDZEJZDJZMVFUCVGMV
      CKENUEDLZVDVEVHUFBAFCDGEHOHJZIJZVCKZIPZGJZMZQZVARZNSZBVOFOFJZVBVCKZCPZVMM
      ZQZTVPWBVARZTVQWCNSTHFOVNWAHFUPZVLVTVMWDVLVIVBVCKZCPVTVKWEICVJVBVIVCUGUHW
      DWEVSCVIVRVBVCUIUJUKULUMVAVOWBUNVPWCNUOUQURUSUT $.
  $}

  ${
    $d f F $.  $d f A $.  $d f B $.
    fodom.1 $e |- A e. _V $.
    $( An onto function implies dominance of domain over range.  Lemma 10.20 of
       [Kunen] p. 30.  This theorem uses the Axiom of Choice ~ ac7g .  AC is
       not needed for finite sets - see ~ fodomfi .  See also ~ fodomnum .
       (Contributed by NM, 23-Jul-2004.) $)
    fodom $p |- ( F : A -onto-> B -> B ~<_ A ) $=
      ( cvv wcel ccrd cdm wfo cdom wbr wi numth3 fodomnum mp2b ) AEFAGHFABCIBAJ
      KLDAEMABCNO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( An onto function implies dominance of domain over range.  (Contributed
       by NM, 23-Jul-2004.) $)
    fodomg $p |- ( A e. C -> ( F : A -onto-> B -> B ~<_ A ) ) $=
      ( vx cv wfo cdom wbr wi wceq foeq2 breq2 imbi12d vex fodom vtoclg ) EFZBD
      GZBRHIZJABDGZBAHIZJEACRAKSUATUBRABDLRABHMNRBDEOPQ $.
  $}

  ${
    $d f g z A $.  $d f g z B $.
    $( Equivalence of an onto mapping and dominance for a non-empty set.
       Proposition 10.35 of [TakeutiZaring] p. 93.  (Contributed by NM,
       29-Jul-2004.) $)
    fodomb $p |- ( ( A =/= (/) /\ E. f f : A -onto-> B ) <->
                 ( (/) ~< B /\ B ~<_ A ) ) $=
      ( c0 wne cv wfo wa csdm wbr cdom wceq syl eqeq1d wb cvv wcel mpcom 0sdomg
      adantl wex cdm wf fof fdm crn dm0rn0 forn syl5bb bitr3d necon3bid biimpac
      vex dmex syl6eqelr fornex mpbird ex fodomg a1i jcad exlimdv imp sdomdomtr
      wi reldom brrelex2i mpbid fodomr jca impbii ) ADEZABCFZGZCUAZHDBIJZBAKJZH
      ZVLVOVRVLVNVRCVLVNVPVQVLVNVPVLVNHVPBDEZVNVLVSVNADBDVNVMUBZDLZADLBDLZVNVTA
      DVNABVMUCVTALABVMUDABVMUEMZNWAVMUFZDLVNWBVMUGVNWDBDABVMUHNUIUJUKULVNVPVSO
      ZVLVNBPQZWEAPQZVNWFVNAVTPWCVMCUMUNUOZABPVMUPRBPSMTUQURVNVQVEVLWGVNVQWHABP
      VMUSRUTVAVBVCVRVLVOVRDAIJZVLDBAVDVRWGWIVLOVQWGVPBAKVFVGTAPSMVHABCVIVJVK
      $.
  $}

  $( When assuming AC, weak and usual dominance coincide.  It is not known if
     this is an AC equivalent.  (Contributed by Stefan O'Rear, 11-Feb-2015.)
     (Revised by Mario Carneiro, 5-May-2015.) $)
  wdomac $p |- ( X ~<_* Y <-> X ~<_ Y ) $=
    ( cwdom wbr cvv wcel cdom relwdom brrelex2i reldom ccrd cdm numth3 wdomnumr
    wb syl pm5.21nii ) ABCDZBEFZABGDZABCHIABGJISBKLFRTOBEMABNPQ $.

  ${
    $d f x y A $.  $d f x y B $.
    brdom3.2 $e |- B e. _V $.
    $( Equivalence to a dominance relation.  (Contributed by NM,
       27-Mar-2007.) $)
    brdom3 $p |- ( A ~<_ B <-> E. f ( A. x E* y x f y /\
                 A. x e. A E. y e. B y f x ) ) $=
      ( cdom wbr cv wmo wal wa wex c0 wceq cvv wcel syl wrel wss wrex wfo wo wn
      wral wi csdm wb reldom brrelexi 0sdomg df-ne syl6bb biimpar fodomr ancoms
      wne syldan pm5.6 mpbi cop noel df-br nex exmo mtp-or ax-gen rzal 0ex breq
      mtbir mobidv albidv rexbidv ralbidv anbi12d spcev sylancr fofun dffun6 wf
      wfun simprbi dffo4 jca eximi jaoi cxp cin cdm wfn inss1 ssbri moimi alimi
      relxp relin2 ax-mp mpbiran sylibr funfn sylib biimpri anim12i df-fo inex1
      crn rninxp vex dmex fodom inss2 dmss dmxpss sstri ssdomg domtr mpan2 3syl
      mp2 exlimiv impbii ) CDGHZAIZBIZEIZHZBJZAKZYEYDYFHZBDUAZACUEZLZEMZYCCNOZD
      CYFUBZEMZUCZYNYCYOUDZLYQUFYCYRUFYCYSNCUGHZYQYCYTYSYCYTCNUQZYSYCCPQYTUUAUH
      CDGUIUJCPUKRCNULUMUNYTYCYQDCEUOUPURYCYOYQUSUTYOYNYQYOYDYENHZBJZAKZYEYDNHZ
      BDUAZACUEZYNUUCAUUBBMUUCUUBBUUBYDYEVAZNQUUHVBYDYENVCVKVDUUBBVEVFVGUUFACVH
      YMUUDUUGLENVIYFNOZYIUUDYLUUGUUIYHUUCAUUIYGUUBBYDYEYFNVJVLVMUUIYKUUFACUUIY
      JUUEBDYEYDYFNVJVNVOVPVQVRYPYMEYPYIYLYPYFWBZYIDCYFVSUUJYFSYIABYFVTWCRYPDCY
      FWAYLBADCYFWDWCWEWFWGRYMYCEYMYFDCWHZWIZWJZCUULUBZCUUMGHZYCYMUULUUMWKZUULX
      GCOZLUUNYIUUPYLUUQYIUULWBZUUPYIYDYEUULHZBJZAKZUURYHUUTAUUSYGBUULYFYDYEYFU
      UKWLWMWNWOUURUULSZUVAUUKSUVBDCWPYFUUKWQWRABUULVTWSWTUULXAXBUUQYLBADCYFXHX
      CXDUUMCUULXEWTUUMCUULUULYFUUKEXIXFXJXKUUOUUMDGHZYCDPQUUMDTUVCFUUMUUKWJZDU
      ULUUKTUUMUVDTYFUUKXLUULUUKXMWRDCXNXOUUMDPXPXTCUUMDXQXRXSYAYB $.

    $( An equivalence to a dominance relation.  (Contributed by NM,
       29-Mar-2007.) $)
    brdom5 $p |- ( A ~<_ B <->
  E. f ( A. x e. B E* y x f y /\ A. x e. A E. y e. B y f x ) ) $=
      ( cdom wbr cv wmo wral wa wex cdm wrel wcel wss ax-mp sylibr cvv wrex wal
      brdom3 alral anim1i eximi sylbi cxp cin wfo wfn crn wceq wfun dmss dmxpss
      inss2 sstri sseli inss1 ssbri moimi relxp relin2 jctil dffun7 funfn sylib
      imim12i ralimi2 rninxp biimpri anim12i df-fo vex inex1 fodom ssdomg domtr
      dmex mp2 mpan2 3syl exlimiv impbii ) CDGHZAIZBIZEIZHZBJZADKZWHWGWIHBDUAAC
      KZLZEMZWFWKAUBZWMLZEMWOABCDEFUCWQWNEWPWLWMWKADUDUEUFUGWNWFEWNWIDCUHZUIZNZ
      CWSUJZCWTGHZWFWNWSWTUKZWSULCUMZLXAWLXCWMXDWLWSUNZXCWLWSOZWGWHWSHZBJZAWTKZ
      LXEWLXIXFWKXHADWTWGWTPWGDPWKXHWTDWGWTWRNZDWSWRQWTXJQWIWRUQWSWRUORDCUPURZU
      SXGWJBWSWIWGWHWIWRUTVAVBVIVJWROXFDCVCWIWRVDRVEABWSVFSWSVGVHXDWMBADCWIVKVL
      VMWTCWSVNSWTCWSWSWIWREVOVPVTVQXBWTDGHZWFDTPWTDQXLFXKWTDTVRWACWTDVSWBWCWDW
      E $.

    $( An equivalence to a dominance relation.  (Contributed by NM,
       28-Mar-2007.)  (Revised by NM, 16-Jun-2017.) $)
    brdom4 $p |- ( A ~<_ B <->
           E. f ( A. x e. B E* y e. A x f y /\ A. x e. A E. y e. B y f x ) ) $=
      ( cdom wbr cv wrmo wral wa wex wmo wal syl cdm wcel wss ax-mp wrex brdom3
      mormo alimi alral anim1i eximi sylbi cxp cin wfo wfn wceq wfun wrel inss2
      crn dmss dmxpss sstri sseli rnss rnxpss inss1 ssbri anim12i moimi 3imtr4i
      df-rmo imim12i ralimi2 relxp relin2 jctil dffun9 sylibr funfn sylib df-fo
      rninxp biimpri vex inex1 dmex fodom cvv ssdomg mp2 sylancl exlimiv impbii
      domtr ) CDGHZAIZBIZEIZHZBCJZADKZWOWNWPHBDUAACKZLZEMZWMWQBNZAOZWTLZEMXBABC
      DEFUBXEXAEXDWSWTXDWRAOWSXCWRAWQBCUCUDWRADUEPUFUGUHXAWMEXACWPDCUIZUJZQZGHZ
      XHDGHZWMXAXHCXGUKZXIXAXGXHULZXGUQZCUMZLXKWSXLWTXNWSXGUNZXLWSXGUOZWNWOXGHZ
      BXMJZAXHKZLXOWSXSXPWRXRADXHWNXHRWNDRWRXRXHDWNXHXFQZDXGXFSZXHXTSWPXFUPZXGX
      FURTDCUSUTZVAWOCRZWQLZBNWOXMRZXQLZBNWRXRYGYEBYFYDXQWQXMCWOXMXFUQZCYAXMYHS
      YBXGXFVBTDCVCUTVAXGWPWNWOWPXFVDVEVFVGWQBCVIXQBXMVIVHVJVKXFUOXPDCVLWPXFVMT
      VNABXGVOVPXGVQVRXNWTBADCWPVTWAVFXHCXGVSVPXHCXGXGWPXFEWBWCWDWEPDWFRXHDSXJF
      YCXHDWFWGWHCXHDWLWIWJWK $.
  $}

  ${
    $d f g x y A v w z $.  $d f g x y B v w z $.
    brdom7disj.1 $e |- A e. _V $.
    brdom7disj.2 $e |- B e. _V $.
    brdom7disj.3 $e |- ( A i^i B ) = (/) $.
    $( An equivalence to a dominance relation for disjoint sets.  (Contributed
       by NM, 29-Mar-2007.)  (Revised by NM, 16-Jun-2017.) $)
    brdom7disj $p |- ( A ~<_ B <-> E. f ( A. x e. B E* y e. A { x , y } e. f
        /\ A. x e. A E. y e. B { y , x } e. f ) ) $=
      ( vv vz vw wbr cv wral wrex wa cpr wcel wceq cab cdom wrmo wex brdom4 cop
      vg weq wb wne cin incom eqtri disjne mp3an1 vex opthpr syl equcom anbi12i
      c0 syl6rbb df-br a1i anbi12d rexbidva rexbidv rexcom zfpair2 eqeq1 anbi1d
      2rexbidv elab bitr4i adantr breq1 breq2 ceqsrex2v rmobidva ralbiia ancoms
      bitrd eqcom ancom 3bitr4g bicomi syl5bb csn snex simpl ss2abi df-sn ssexi
      sseqtr4i ab2rexex2 eleq2 rmobidv ralbidv spcev exlimiv copab preq1 eleq1d
      syl2anbr preq2 eqid brab rmobii ralbii rexbii cvv cuni uniex prid1 elunii
      df-opab mpan adantl prid2 eqeltrri abexex eqeltri breq impbii bitri ) CDU
      ALAMZBMZUFMZLZBCUBZADNZYFYEYGLZBDOZACNZPZUFUCZYEYFQZEMZRZBCUBZADNZYFYEQZY
      QRZBDOZACNZPZEUCZABCDUFGUDYOUUFYNUUFUFYJYPIMZJMZKMZQZSZUUHUUIUEYGRZPZJDOK
      COZITZRZBCUBZADNZUUAUUORZBDOZACNZUUFYMUUQYIADYEDRZUUPYHBCUVBYFCRZPUUPJAUG
      ZKBUGZPZUUHUUIYGLZPZKCOZJDOZYHUVBUUPUVJUHUVCUVBUVJYPUUJSZUULPZKCOZJDOZUUP
      UVBUVIUVMJDUVBUVHUVLKCUVBUUICRZPZUVFUVKUVGUULUVPUVKAJUGZBKUGZPZUVFUVPYEUU
      IUIZUVKUVSUHDCUJZUTSZUVBUVOUVTUWACDUJUTDCUKHULZDCYEUUIUMUNYEYFUUHUUIAUOZB
      UOZJUOZKUOZUPUQUVQUVDUVRUVEAJURBKURUSVAUVGUULUHUVPUUHUUIYGVBZVCVDVEVFUVNU
      VLJDOKCOZUUPUVLJKDCVGUUNUWIIYPABVHUUGYPSZUUMUVLKJCDUWJUUKUVKUULUUGYPUUJVI
      VJVKVLVMVAVNUVGYEUUIYGLYHJKYEYFDCUUHYEUUIYGVOUUIYFYEYGVPVQWAVRVSUUTYLACYE
      CRZUUSYKBDUWKYFDRZPUUSKAUGZJBUGZPZUVGPZJDOZKCOZYKUWKUUSUWRUHUWLUUSUUAUUJS
      ZUULPZJDOZKCOZUWKUWRUUNUXBIUUABAVHUUGUUASZUUMUWTKJCDUXCUUKUWSUULUUGUUAUUJ
      VIVJVKVLUWKUXAUWQKCUWKUWTUWPJDUWKUUHDRZPZUWSUWOUULUVGUXEUUJUUASZUWNUWMPZU
      WSUWOUXEUUHYEUIZUXFUXGUHUXDUWKUXHUWBUXDUWKUXHUWCDCUUHYEUMUNVTUUHUUIYFYEUW
      FUWGUWEUWDUPUQUUAUUJWBUWMUWNWCWDUULUVGUHUXEUVGUULUWHWEVCVDVEVFWFVNUVGUUHY
      EYGLYKKJYEYFCDUUIYEUUHYGVPUUHYFYEYGVOVQWAVEVSUUEUURUVAPEUUOUUMKJICDFGUUMI
      TZUUJWGZUUJWHUXIUUKITUXJUUMUUKIUUKUULWIWJIUUJWKWMWLWNYQUUOSZYTUURUUDUVAUX
      KYSUUQADUXKYRUUPBCYQUUOYPWOWPWQUXKUUCUUTACUXKUUBUUSBDYQUUOUUAWOVFWQVDWRXC
      WSUUEYOEYTYEYFUUIUUHQZYQRZKJWTZLZBCUBZADNZYFYEUXNLZBDOZACNZYOUUDUXPYSADUX
      OYRBCUXMYEUUHQZYQRYRKJYEYFUXNUWDUWEUWMUXLUYAYQUUIYEUUHXAXBUWNUYAYPYQUUHYF
      YEXDXBUXNXEZXFXGXHUXSUUCACUXRUUBBDUXMYFUUHQZYQRUUBKJYFYEUXNUWEUWDUVEUXLUY
      CYQUUIYFUUHXAXBUVDUYCUUAYQUUHYEYFXDXBUYBXFXIXHYNUXQUXTPUFUXNUXNUUGUUIUUHU
      EZSZUXMPZJUCZKUCITXJUXMKJIXOUYGKIYQXKZYQEUOXLZUYFUUIUYHRZJUXMUYJUYEUUIUXL
      RUXMUYJUUIUUHUWGXMUUIUXLYQXNXPXQWSUYFJIUYHUYIUXMUUHUYHRZUYEUUHUXLRUXMUYKU
      UIUUHUWFXRUUHUXLYQXNXPXQUYFITUYEITZUYDWGUYLXJIUYDWKUYDWHXSUYFUYEIUYEUXMWI
      WJWLXTXTYAYGUXNSZYJUXQYMUXTUYMYIUXPADUYMYHUXOBCYEYFYGUXNYBWPWQUYMYLUXSACU
      YMYKUXRBDYFYEYGUXNYBVFWQVDWRXCWSYCYD $.

    $( An equivalence to a dominance relation for disjoint sets.  (Contributed
       by NM, 5-Apr-2007.) $)
    brdom6disj $p |- ( A ~<_ B <-> E. f ( A. x e. B E* y
      { x , y } e. f /\ A. x e. A E. y e. B { y , x } e. f ) ) $=
      ( vv vz vw wbr cv wral wrex wa cpr wcel wceq cab vg wmo wex brdom5 cop wi
      cdom wal zfpair2 eqeq1 anbi1d anbi2i syl6bbr 2rexbidv elab weq wne wb cin
      df-br c0 incom eqtri disjne mp3an1 vex opthpr breq12 biimprd syl6bi imp3a
      syl ex adantrd rexlimdvv syl5bi alrimiv moim ralimia ancoms eqcom 3bitr4g
      ancom bicomi anbi12d rexbidva rexbidv syl5bb adantr breq2 breq1 ceqsrex2v
      a1i bitrd ralbiia biimpri csn simpl ss2abi df-sn sseqtr4i ssexi ab2rexex2
      snex eleq2 mobidv ralbidv spcev syl2an copab preq1 eleq1d preq2 eqid brab
      exlimiv mobii ralbii rexbii cvv cuni uniex prid1 elunii mpan adantl prid2
      df-opab eqeltrri abexex eqeltri breq syl2anbr impbii bitri ) CDUGLAMZBMZU
      AMZLZBUBZADNZYQYPYRLZBDOZACNZPZUAUCZYPYQQZEMZRZBUBZADNZYQYPQZUUHRZBDOZACN
      ZPZEUCZABCDUAGUDUUFUUQUUEUUQUAUUAUUGIMZJMZKMZQZSZUUSUUTUEYRRZPZJDOKCOZITZ
      RZBUBZADNZUULUVFRZBDOZACNZUUQUUDYTUVHADYPDRZUVGYSUFZBUHYTUVHUFUVMUVNBUVGU
      UGUVASZUUSUUTYRLZPZJDOKCOZUVMYSUVEUVRIUUGABUIUURUUGSZUVDUVQKJCDUVSUVDUVOU
      VCPUVQUVSUVBUVOUVCUURUUGUVAUJUKUVPUVCUVOUUSUUTYRUTZULUMUNUOUVMUVQYSKJCDUV
      MUUTCRZUVQYSUFZUUSDRZUVMUWAUWBUVMUWAPZUVOUVPYSUWDUVOAJUPBKUPPZUVPYSUFUWDY
      PUUTUQZUVOUWEURDCUSZVASZUVMUWAUWFUWGCDUSVADCVBHVCZDCYPUUTVDVEYPYQUUSUUTAV
      FZBVFZJVFZKVFZVGVLUWEYSUVPYPUUSYQUUTYRVHVIVJVKVMVNVOVPVQUVGYSBVRVLVSUVLUU
      DUVKUUCACYPCRZUVJUUBBDUWNYQDRZPUVJKAUPZJBUPZPZUVPPZJDOZKCOZUUBUWNUVJUXAUR
      UWOUVJUULUVASZUVCPZJDOZKCOZUWNUXAUVEUXEIUULBAUIUURUULSZUVDUXCKJCDUXFUVBUX
      BUVCUURUULUVAUJUKUNUOUWNUXDUWTKCUWNUXCUWSJDUWNUWCPZUXBUWRUVCUVPUXGUVAUULS
      ZUWQUWPPZUXBUWRUXGUUSYPUQZUXHUXIURUWCUWNUXJUWHUWCUWNUXJUWIDCUUSYPVDVEVTUU
      SUUTYQYPUWLUWMUWKUWJVGVLUULUVAWAUWPUWQWCWBUVCUVPURUXGUVPUVCUVTWDWMWEWFWGW
      HWIUVPUUSYPYRLUUBKJYPYQCDUUTYPUUSYRWJUUSYQYPYRWKWLWNWFWOWPUUPUVIUVLPEUVFU
      VDKJICDFGUVDITZUVAWQZUVAXDUXKUVBITUXLUVDUVBIUVBUVCWRWSIUVAWTXAXBXCUUHUVFS
      ZUUKUVIUUOUVLUXMUUJUVHADUXMUUIUVGBUUHUVFUUGXEXFXGUXMUUNUVKACUXMUUMUVJBDUU
      HUVFUULXEWGXGWEXHXIXPUUPUUFEUUKYPYQUUTUUSQZUUHRZKJXJZLZBUBZADNZYQYPUXPLZB
      DOZACNZUUFUUOUXRUUJADUXQUUIBUXOYPUUSQZUUHRUUIKJYPYQUXPUWJUWKUWPUXNUYCUUHU
      UTYPUUSXKXLUWQUYCUUGUUHUUSYQYPXMXLUXPXNZXOXQXRUYAUUNACUXTUUMBDUXOYQUUSQZU
      UHRUUMKJYQYPUXPUWKUWJKBUPUXNUYEUUHUUTYQUUSXKXLJAUPUYEUULUUHUUSYPYQXMXLUYD
      XOXSXRUUEUXSUYBPUAUXPUXPUURUUTUUSUEZSZUXOPZJUCZKUCITXTUXOKJIYHUYIKIUUHYAZ
      UUHEVFYBZUYHUUTUYJRZJUXOUYLUYGUUTUXNRUXOUYLUUTUUSUWMYCUUTUXNUUHYDYEYFXPUY
      HJIUYJUYKUXOUUSUYJRZUYGUUSUXNRUXOUYMUUTUUSUWLYGUUSUXNUUHYDYEYFUYHITUYGITZ
      UYFWQUYNXTIUYFWTUYFXDYIUYHUYGIUYGUXOWRWSXBYJYJYKYRUXPSZUUAUXSUUDUYBUYOYTU
      XRADUYOYSUXQBYPYQYRUXPYLXFXGUYOUUCUYAACUYOUUBUXTBDYQYPYRUXPYLWGXGWEXHYMXP
      YNYO $.
  $}

  $( Once we allow AC, the "strongest" definition of finite set becomes
     equivalent to the "weakest" and the entire hierarchy collapses.
     (Contributed by Stefan O'Rear, 29-Oct-2014.) $)
  fin71ac $p |- Fin7 = Fin $=
    ( wac cfin7 cfn wceq axac3 dfacfin7 mpbi ) ABCDEFG $.

  $( An image of a function under a set is dominated by the set.  Proposition
     10.34 of [TakeutiZaring] p. 92.  (Contributed by NM, 23-Jul-2004.) $)
  imadomg $p |- ( A e. B -> ( Fun F -> ( F " A ) ~<_ A ) ) $=
    ( wcel wfun cima cres cdm cdom wbr wa crn df-ima cvv resfunexg dmexg funres
    wfo syl expcom funforn sylib adantr fodomg syl5eqbr wss dmres inss1 eqsstri
    sylc cin ssdomg mpi domtr sylan2 syld ) ABDZCEZCAFZCAGZHZIJZUSAIJZURUQVBURU
    QKZUSUTLZVAICAMVDVANDZVAVEUTRZVEVAIJVDUTNDVFCABOUTNPSURVGUQURUTEVGACQUTUAUB
    UCVAVENUTUDUJUETVBUQVCUQVBVAAIJZVCUQVAAUFVHVAACHZUKACAUGAVIUHUIVAABULUMUSVA
    AUNUOTUP $.

  $( The range of a function is dominated by its domain.  (Contributed by NM,
     1-Sep-2004.) $)
  fnrndomg $p |- ( A e. B -> ( F Fn A -> ran F ~<_ A ) ) $=
    ( wfn crn wfo wcel cdom wbr dffn4 fodomg syl5bi ) CADACEZCFABGMAHIACJAMBCKL
    $.

  ${
    $d f g x y z A $.  $d f g y z B $.  $d f g x y z C $.  $d f y z T $.
    $d f ph $.
    iunfo.1 $e |- T = U_ x e. A ( { x } X. B ) $.
    $( Existence of an onto function from a disjoint union to a union.
       (Contributed by Mario Carneiro, 24-Jun-2013.)  (Revised by Mario
       Carneiro, 18-Jan-2014.) $)
    iunfo $p |- ( 2nd |` T ) : T -onto-> U_ x e. A B $=
      ( vy vz ciun c2nd wfo wfn wceq cvv wss mp2an cv cfv wrex wcel eliun fo2nd
      cres crn wf fof ffn mp2b ssv fnssres cima df-ima eleq2i bitri xp2nd eleq1
      csn cxp syl5ib reximdv syl5bi impcom rexlimiva nfiu1 nfcxfr nfv nfrex cop
      ssiun2 adantr simpr vex snid opelxp mpbiran sylibr sseldd syl6eleqr op2nd
      wa fveq2 eqeq1d rspcev sylancl ex rexlimi impbii wb fvelimab eqriv eqtr3i
      3bitr4i df-fo mpbir2an ) DABCHZIDUBZJWODKZWOUCZWNLIMKZDMNZWPMMIJMMIUDWRUA
      MMIUEMMIUFUGZDUHZMDIUIOIDUJZWQWNIDUKFXBWNGPZIQZFPZLZGDRZXECSZABRZXEXBSZXE
      WNSXGXIXFXIGDXFXCDSZXIXKXCAPZUPZCUQZSZABRZXFXIXKXCABXNHZSXPDXQXCEULAXCBXN
      TUMXFXOXHABXOXDCSXFXHXCXMCUNXDXECUOURUSUTVAVBXHXGABXFAGDADXQEABXNVCVDXFAV
      EVFXLBSZXHXGXRXHVSZXLXEVGZDSXTIQZXELZXGXSXTXQDXSXNXQXTXRXNXQNXHABXNVHVIXS
      XHXTXNSZXRXHVJYCXLXMSXHXLAVKZVLXLXEXMCVMVNVOVPEVQXLXEYDFVKVRXFYBGXTDXCXTL
      XDYAXEXCXTIVTWAWBWCWDWEWFWRWSXJXGWGWTXAGMDXEIWHOAXEBCTWKWIWJDWNWOWLWM $.

    iundomg.2 $e |- ( ph -> U_ x e. A ( C ^m B ) e. AC_ A ) $.
    iundomg.3 $e |- ( ph -> A. x e. A B ~<_ C ) $.
    $( An upper bound for the cardinality of a disjoint indexed union, with
       explicit choice principles. ` B ` depends on ` x ` and should be thought
       of as ` B ( x ) ` .  (Contributed by Mario Carneiro, 1-Sep-2015.) $)
    iundom2g $p |- ( ph -> T ~<_ ( A X. C ) ) $=
      ( vy vg cfv wf1 wral wa wcel wb cvv syl wceq vf vz cmap co ciun cv wf csb
      wex cxp cdom wbr wacn wrex brdomi adantl reldom brrelex2i brrelexi elmapg
      f1f syl2anc syl5ibr wss ssiun2 adantr sseld syld eximdv mpd df-rex sylibr
      ancrd ralimiaa nfv nfiu1 nfcv nfcsb1v nff1 nfrex weq csbeq1a f1eq2 cbvral
      rexbidv sylib f1eq1 acni3 fveq2 bitrd c0 wn wne df-ne acnrcl wi rexlimivw
      r19.2z expcom xpexg ee12an syl5bir 0xp 0ex eqeltri syl6eqel pm2.61d2 c1st
      xpeq1 c2nd cop csn eleq2i eliun bitri r19.29 xp1st ad2antll elsni eqeltrd
      simpl fveq2d fveq1d ad2antrl xp2nd ffvelrnd opelxpi rexlimiva syl5bi fvex
      ex opth simpr eqeq2d djussxp eqsstri simprl sseldi simpll csbeq1d eleqtrd
      rspc sylc nfel2 eqcomd rexlimi imp adantrr ralrimiv eleq12d rspccva sylan
      adantrl eleqtrrd f1fveq bitr3d simprr xpopth syl5bb dom2d syl5com adantld
      syl12anc pm5.32da exlimdv ) ACBCEDUCUDZUEZUAUFZUGZBJUFZDUHZEUVJUVHLZMZJCN
      ZOZUAUIZFCEUJZUKULZAUVGCUMPZUVKEKUFZMZKUVGUNZJCNZUVPHADEUVTMZKUVGUNZBCNZU
      WCADEUKULZBCNZUWFIUWGUWEBCBUFZCPZUWGOZUVTUVGPZUWDOZKUIZUWEUWKUWDKUIZUWNUW
      GUWOUWJDEKUOUPUWKUWDUWMKUWKUWDUWLUWKUWDUVTUVFPZUWLUWDUWPUWKDEUVTUGZDEUVTV
      AUWGUWPUWQQZUWJUWGERPZDRPUWRDEUKUQURZDEUKUQUSEDUVTRRUTVBUPVCUWKUVFUVGUVTU
      WJUVFUVGVDUWGBCUVFVEVFVGVHVMVIVJUWDKUVGVKVLVNSUWEUWBBJCUWEJVOUWABKUVGBCUV
      FVPBUVKEUVTBUVTVQBUVJDVRZBEVQZVSVTBJWAZUWDUWAKUVGUXCDUVKTZUWDUWAQBUVJDWBZ
      DUVKEUVTWCSWEWDWFUWAUVMJKCUAUVGUVKEUVTUVLWGWHVBAUVOUVRUAAUVNUVRUVIUVNDEUW
      IUVHLZMZBCNZAUVRUXGUVMBJCUXGJVOBUVKEUVLBUVLVQUXAUXBVSUXCUXGDEUVLMZUVMUXCU
      XFUVLTUXGUXIQUWIUVJUVHWIDEUXFUVLWGSUXCUXDUXIUVMQUXEDUVKEUVLWCSWJWDAUVQRPZ
      UXHUVRACWKTZUXJUXKWLCWKWMZAUXJCWKWNACRPZUXLUWSUXJAUVSUXMHCUVGWOSAUWHUXLUW
      SWPIUXLUWHUWSUXLUWHOUWGBCUNUWSUWGBCWRUWGUWSBCUWTWQSWSSCERRWTXAXBUXKUVQWKE
      UJZRCWKEXIUXNWKREXCXDXEXFXGUXHJUBFUVQUVJXHLZUVJXJLZUXOUVHLZLZXKZUBUFZXHLZ
      UXTXJLZUYAUVHLZLZXKZRUVJFPZUVJUWIXLZDUJZPZBCUNZUXHUXSUVQPZUYFUVJBCUYHUEZP
      UYJFUYLUVJGXMBUVJCUYHXNXOZUXHUYJUYKUXHUYJOZUXGUYIOZBCUNZUYKUXGUYIBCXPZUYO
      UYKBCUWJUYOOZUXOCPZUXREPUYKUYRUXOUWICUYRUXOUYGPZUXOUWITUYIUYTUWJUXGUVJUYG
      DXQXRUXOUWIXSSZUWJUYOYAXTUYRUXRUXPUXFLEUYRUXPUXQUXFUYRUXOUWIUVHVUAYBYCUYR
      DEUXPUXFUXGDEUXFUGUWJUYIDEUXFVAYDUYIUXPDPUWJUXGUVJUYGDYEXRZYFXTUXOUXRCEYG
      VBYHSYKYIUXHUYFUXTFPZOZUXSUYETZJUBWAZQVUEUXOUYATZUXRUYDTZOZUXHVUDOZVUFUXO
      UXRUYAUYDUVJXHYJUXPUXQYJYLVUJVUIVUGUXPUYBTZOZVUFVUJVUGVUHVUKVUJVUGOZUXRUY
      BUXQLZTZVUHVUKVUMVUNUYDUXRVUMUYBUXQUYCVUMUXOUYAUVHVUJVUGYMZYBYCYNVUMBUXOD
      UHZEUXQMZUXPVUQPZUYBVUQPVUOVUKQVUMUYSUXHVURVUMUVJCRUJZPZUYSVUJVVAVUGVUJFV
      UTUVJFUYLVUTGBCDYOYPZUXHUYFVUCYQYRZVFUVJCRXQSUXHVUDVUGYSUXGVURBUXOCBVUQEU
      XQBUXQVQBUXODVRZUXBVSUWIUXOTZUXGDEUXQMZVURVVEUXFUXQTUXGVVFQUWIUXOUVHWIDEU
      XFUXQWGSVVEDVUQTZVVFVURQBUXODWBZDVUQEUXQWCSWJUUBUUCVUJVUSVUGUXHUYFVUSVUCU
      XHUYFVUSUYFUYJUXHVUSUYMUXHUYJVUSUYNUYPVUSUYQUYOVUSBCBUXPVUQVVDUUDUWJUYOVU
      SUYRUXPDVUQVUBUYRVVEVVGUYRUXOUWIVUAUUEVVHSUUAYKUUFSYKYIZUUGUUHVFVUMUYBBUY
      ADUHZVUQVUJUYBVVJPZVUGUXHVUCVVKUYFUXHVUSJFNVUCVVKUXHVUSJFVVIUUIVUSVVKJUXT
      FVUFUXPUYBVUQVVJUVJUXTXJWIVUFBUXOUYADUVJUXTXHWIYTUUJUUKUULUUMVFVUMBUXOUYA
      DVUPYTUUNVUQEUXPUYBUXQUUOUVCUUPUVDVUJVVAUXTVUTPVULVUFQVVCVUJFVUTUXTVVBUXH
      UYFVUCUUQYRUVJUXTCRCRUURVBWJUUSYKUUTUVAXBUVBUVEVJ $.

    iundomg.4 $e |- ( ph -> ( A X. C ) e. AC_ U_ x e. A B ) $.
    $( An upper bound for the cardinality of an indexed union, with explicit
       choice principles. ` B ` depends on ` x ` and should be thought of as
       ` B ( x ) ` .  (Contributed by Mario Carneiro, 1-Sep-2015.) $)
    iundomg $p |- ( ph -> U_ x e. A B ~<_ ( A X. C ) ) $=
      ( ciun cdom wbr cxp wacn wcel c2nd cres wfo iundom2g iunfo fodomacn domtr
      acndom2 sylc ee10 syl2anc ) ABCDKZFLMZFCENZLMZUHUJLMAFUHOZPZFUHQFRZSUIAUK
      UJULPUMABCDEFGHITZJUHFUJUDUEBCDFGUAFUHUNUBUFUOUHFUJUCUG $.
  $}

  ${
    $d x A $.  $d x B $.
    $( An upper bound for the cardinality of an indexed union. ` C ` depends on
       ` x ` and should be thought of as ` C ( x ) ` .  (Contributed by NM,
       26-Mar-2006.) $)
    iundom $p |- ( ( A e. V /\ A. x e. A C ~<_ B ) ->
        U_ x e. A C ~<_ ( A X. B ) ) $=
      ( wcel cdom wbr wral wa cxp ciun cmap wacn cvv iunexg numth3 numacn sylc
      reldom cv csn eqid co ccrd simpl ovex rgenw sylancl simpr brrelexi ralimi
      cdm syl sylan2 iundom2g brrelex2i 3syl iundomg ) BEFZDCGHZABIZJZABDCABAUA
      UBDKLZVDUCZVCUTABCDMUDZLZUEUMZFZVGBNFUTVBUFZVCVGOFZVIVCUTVFOFZABIVKVJVLAB
      CDMUGUHABVFEOPUIVGOQUNBEVGRSZUTVBUJZVCABDLZOFZBCKZVHFZVQVONFVBUTDOFZABIVP
      VAVSABDCGTUKULABDEOPUOVCVDVQGHVQOFVRVCABDCVDVEVMVNUPVDVQGTUQVQOQURVOOVQRS
      US $.

    $( An upper bound for the cardinality of a union.  Theorem 10.47 of
       [TakeutiZaring] p. 98.  (Contributed by NM, 25-Mar-2006.)  (Proof
       shortened by Mario Carneiro, 1-Sep-2015.) $)
    unidom $p |- ( ( A e. V /\ A. x e. A x ~<_ B ) -> U. A ~<_ ( A X. B ) ) $=
      ( wcel cv cdom wbr wral wa cuni ciun cxp uniiun iundom syl5eqbr ) BDEAFZC
      GHABIJBKABQLBCMGABNABCQDOP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    uniimadom.1 $e |- A e. _V $.
    uniimadom.2 $e |- B e. _V $.
    $( An upper bound for the cardinality of the union of an image.  Theorem
       10.48 of [TakeutiZaring] p. 99.  (Contributed by NM, 25-Mar-2006.) $)
    uniimadom $p |- ( ( Fun F /\ A. x e. A ( F ` x ) ~<_ B ) ->
                 U. ( F " A ) ~<_ ( A X. B ) ) $=
      ( vy wfun cv cdom wbr wral cxp cvv wcel adantr wi wrex syl syl2anc cfv wa
      cima cuni funimaex wceq fvelima ex breq1 biimpd reximi r19.36av com23 imp
      syl6 ralrimiv unidom imadomg ax-mp xpdom1 domtr ) DHZAIDUAZCJKZABLZUBZDBU
      CZUDZVGCMZJKZVIBCMZJKZVHVKJKVFVGNOZGIZCJKZGVGLVJVBVMVEDBEUEPVFVOGVGVBVEVN
      VGOZVOQVBVPVEVOVBVPVCVNUFZABRZVEVOQZVBVPVRAVNBDUGUHVRVDVOQZABRVSVQVTABVQV
      DVOVCVNCJUIUJUKVDVOABULSUOUMUNUPGVGCNUQTVBVLVEVBVGBJKZVLBNOVBWAQEBNDURUSV
      GBCFUTSPVHVIVKVAT $.
  $}

  ${
    $d x z A $.  $d x y z B $.  $d y z F $.
    uniimadomf.1 $e |- F/_ x F $.
    uniimadomf.2 $e |- A e. _V $.
    uniimadomf.3 $e |- B e. _V $.
    $( An upper bound for the cardinality of the union of an image.  Theorem
       10.48 of [TakeutiZaring] p. 99.  This version of ~ uniimadom uses a
       bound-variable hypothesis in place of a distinct variable condition.
       (Contributed by NM, 26-Mar-2006.) $)
    uniimadomf $p |- ( ( Fun F /\ A. x e. A ( F ` x ) ~<_ B ) ->
                 U. ( F " A ) ~<_ ( A X. B ) ) $=
      ( vz cv cfv cdom wbr wral wfun cima cuni cxp nfv nfcv nffv nfbr weq fveq2
      breq1d cbvral uniimadom sylan2b ) AIZDJZCKLZABMDNHIZDJZCKLZHBMDBOPBCQKLUJ
      UMAHBUJHRAULCKAUKDEAUKSTAKSACSUAAHUBUIULCKUHUKDUCUDUEHBCDFGUFUG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cardinal number theorems using Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.
    cardval.1 $e |- A e. _V $.
    $( The value of the cardinal number function.  Definition 10.4 of
       [TakeutiZaring] p. 85.  See ~ cardval2 for a simpler version of its
       value.  (Contributed by NM, 21-Oct-2003.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    cardval $p |- ( card ` A ) = |^| { x e. On | x ~~ A } $=
      ( cvv wcel ccrd cdm cfv cen wbr con0 crab cint wceq numth3 cardval3 mp2b
      cv ) BDEBFGEBFHARBIJAKLMNCBDOABPQ $.

    $( Any set is equinumerous to its cardinal number.  Proposition 10.5 of
       [TakeutiZaring] p. 85.  (Contributed by NM, 22-Oct-2003.)  (Revised by
       Mario Carneiro, 28-Apr-2015.) $)
    cardid $p |- ( card ` A ) ~~ A $=
      ( cvv wcel ccrd cdm cfv cen wbr numth3 cardid2 mp2b ) ACDAEFDAEGAHIBACJAK
      L $.
  $}

  $( Any set is equinumerous to its cardinal number.  Closed theorem form of
     ~ cardid .  (Contributed by David Moews, 1-May-2017.) $)
  cardidg $p |- ( A e. B -> ( card ` A ) ~~ A ) $=
    ( wcel cvv ccrd cfv cen wbr elex cdm cardeqv eleq2i cardid2 sylbir syl ) AB
    CADCZAEFAGHZABIPAEJZCQRDAKLAMNO $.

  ${
    cardidd.1 $e |- ( ph -> A e. B ) $.
    $( Any set is equinumerous to its cardinal number.  Deduction form of
       ~ cardid .  (Contributed by David Moews, 1-May-2017.) $)
    cardidd $p |- ( ph -> ( card ` A ) ~~ A ) $=
      ( wcel ccrd cfv cen wbr cardidg syl ) ABCEBFGBHIDBCJK $.
  $}

  ${
    $d x y $.
    $( The cardinality function is a function with domain the well-orderable
       sets.  Assuming AC, this is the universe.  (Contributed by Mario
       Carneiro, 6-Jun-2013.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    cardf $p |- card : _V --> On $=
      ( vy vx cv cen wbr con0 wrex cab ccrd wf cvv cardf2 cdm fdmi eqtr3i feq2i
      cardeqv mpbi ) ACBCDEAFGBHZFIJKFIJBALZSKFIIMSKSFITNQOPR $.
  $}

  $( Two sets are equinumerous iff their cardinal numbers are equal.  This
     important theorem expresses the essential concept behind "cardinality" or
     "size."  This theorem appears as Proposition 10.10 of [TakeutiZaring]
     p. 85, Theorem 7P of [Enderton] p. 197, and Theorem 9 of [Suppes] p. 242
     (among others).  The Axiom of Choice is required for its proof.

     The theory of cardinality can also be developed without AC by introducing
     "card" as a primitive notion and stating this theorem as an axiom, as is
     done with the axiom for cardinal numbers in [Suppes] p. 111.  Finally, if
     we allow the Axiom of Regularity, we can avoid AC by defining the cardinal
     number of a set as the set of all sets equinumerous to it and having the
     least possible rank (see ~ karden ).  (Contributed by NM, 22-Oct-2003.) $)
  carden $p |- ( ( A e. C /\ B e. D ) ->
               ( ( card ` A ) = ( card ` B ) <-> A ~~ B ) ) $=
    ( wcel wa ccrd cfv wceq cen wbr numth3 ad2antrr cardid2 ensym 3syl ad2antlr
    cdm simpr cardidd eqbrtrd entr syl2anc ex carden2b impbid1 ) ACEZBDEZFZAGHZ
    BGHZIZABJKZUIULUMUIULFZAUJJKZUJBJKUMUNAGRZEZUJAJKUOUGUQUHULACLMANUJAOPUNUJU
    KBJUIULSUNBUPUHBUPEUGULBDLQTUAAUJBUBUCUDABUEUF $.

  $( Only the empty set has cardinality zero.  (Contributed by NM,
     23-Apr-2004.) $)
  cardeq0 $p |- ( A e. V -> ( ( card ` A ) = (/) <-> A = (/) ) ) $=
    ( wcel ccrd cfv c0 cen wbr cvv wb 0ex carden mpan2 card0 eqeq2i en0 3bitr3g
    wceq ) ABCZADEZFDEZRZAFGHZTFRAFRSFICUBUCJKAFBILMUAFTNOAPQ $.

  ${
    unsnen.1 $e |- A e. _V $.
    unsnen.2 $e |- B e. _V $.
    $( Equinumerosity of a set with a new element added.  (Contributed by NM,
       7-Nov-2008.) $)
    unsnen $p |- ( -. B e. A -> ( A u. { B } ) ~~ suc ( card ` A ) ) $=
      ( wcel wn csn cun ccrd cfv csuc cen cin wceq wbr disjsn word cardon cvv
      c0 onordi orddisj ax-mp cardid ensymi fvex en2sn mp2an unen mpanl12 mpan2
      wa sylbir df-suc syl6breqr ) BAEFZABGZHZAIJZUSGZHZUSKLUPAUQMTNZURVALOZABP
      VBUSUTMTNZVCUSQVDUSARUAUSUBUCAUSLOUQUTLOZVBVDULVCUSAACUDUEBSEUSSEVEDAIUFB
      USSSUGUHAUSUQUTUIUJUKUMUSUNUO $.
  $}

  $( Two sets have the dominance relationship iff their cardinalities have the
     subset relationship.  Equation i of [Quine] p. 232.  (Contributed by NM,
     22-Oct-2003.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
  carddom $p |- ( ( A e. V /\ B e. W ) ->
               ( ( card ` A ) C_ ( card ` B ) <-> A ~<_ B ) ) $=
    ( wcel ccrd cdm cfv wss cdom wbr wb numth3 carddom2 syl2an ) ACEAFGZEBPEAFH
    BFHIABJKLBDEACMBDMABNO $.

  $( Two sets have the strict dominance relationship iff their cardinalities
     have the membership relationship.  Corollary 19.7(2) of [Eisenberg]
     p. 310.  (Contributed by NM, 22-Oct-2003.)  (Revised by Mario Carneiro,
     30-Apr-2015.) $)
  cardsdom $p |- ( ( A e. V /\ B e. W ) ->
               ( ( card ` A ) e. ( card ` B ) <-> A ~< B ) ) $=
    ( wcel ccrd cdm cfv csdm wbr wb numth3 cardsdom2 syl2an ) ACEAFGZEBOEAFHBFH
    EABIJKBDEACLBDLABMN $.

  $( Trichotomy law for dominance and strict dominance.  This theorem is
     equivalent to the Axiom of Choice.  (Contributed by NM, 4-Jan-2004.)
     (Revised by Mario Carneiro, 30-Apr-2015.) $)
  domtri $p |- ( ( A e. V /\ B e. W ) -> ( A ~<_ B <-> -. B ~< A ) ) $=
    ( wcel ccrd cdm cdom wbr csdm wn wb numth3 domtri2 syl2an ) ACEAFGZEBPEABHI
    BAJIKLBDEACMBDMABNO $.

  $( Trichotomy of equinumerosity and strict dominance.  This theorem is
     equivalent to the Axiom of Choice.  Theorem 8 of [Suppes] p. 242.
     (Contributed by NM, 4-Jan-2004.) $)
  entric $p |- ( ( A e. V /\ B e. W ) -> ( A ~< B \/ A ~~ B \/ B ~< A ) ) $=
    ( wcel wa csdm wbr cen wo wn cdom domtri biimprd brdom2 syl6ib con1d df-3or
    w3o orrd sylibr ) ACEBDEFZABGHZABIHZJZBAGHZJUCUDUFSUBUEUFUBUFUEUBUFKZABLHZU
    EUBUHUGABCDMNABOPQTUCUDUFRUA $.

  $( Trichotomy of dominance and strict dominance.  (Contributed by NM,
     4-Jan-2004.) $)
  entri2 $p |- ( ( A e. V /\ B e. W ) -> ( A ~<_ B \/ B ~< A ) ) $=
    ( wcel wa csdm wbr cen w3o cdom entric brdom2 orbi1i df-3or bitr4i sylibr
    wo ) ACEBDEFABGHZABIHZBAGHZJZABKHZUARZABCDLUDSTRZUARUBUCUEUAABMNSTUAOPQ $.

  $( Trichotomy of dominance.  This theorem is equivalent to the Axiom of
     Choice.  Part of Proposition 4.42(d) of [Mendelson] p. 275.  (Contributed
     by NM, 4-Jan-2004.) $)
  entri3 $p |- ( ( A e. V /\ B e. W ) -> ( A ~<_ B \/ B ~<_ A ) ) $=
    ( wcel wa cdom wbr csdm wo entri2 sdomdom orim2i syl ) ACEBDEFABGHZBAIHZJOB
    AGHZJABCDKPQOBALMN $.

  $( A set strictly dominates iff its cardinal strictly dominates.
     (Contributed by NM, 30-Oct-2003.) $)
  sdomsdomcard $p |- ( A ~< B <-> A ~< ( card ` B ) ) $=
    ( csdm wbr ccrd cfv cen cvv wcel cdm relsdom brrelex2i numth3 cardid2 ensym
    4syl sdomentr mpdan sdomsdomcardi impbii ) ABCDZABEFZCDZUABUBGDZUCUABHIBEJI
    UBBGDUDABCKLBHMBNUBBOPABUBQRABST $.

  $( Cantor's theorem in terms of cardinals.  This theorem tells us that no
     matter how largei a cardinal number is, there is a still larger cardinal
     number.  Theorem 18.12 of [Monk1] p. 133.  (Contributed by NM,
     5-Nov-2003.) $)
  canth3 $p |- ( A e. V -> ( card ` A ) e. ( card ` ~P A ) ) $=
    ( wcel ccrd cfv cpw csdm wbr canth2g cvv wb pwexg cardsdom mpdan mpbird ) A
    BCZADEAFZDECZAQGHZABIPQJCRSKABLAQBJMNO $.

  ${
    $d A x $.
    $( The cross product of an infinite set with itself is idempotent.  This
       theorem (which is an AC equivalent) provides the basis for infinite
       cardinal arithmetic.  Proposition 10.40 of [TakeutiZaring] p. 95.  This
       proof follows as a corollary of ~ infxpen .  (Contributed by NM,
       17-Sep-2004.)  (Revised by Mario Carneiro, 9-Mar-2013.) $)
    infxpidm $p |- ( om ~<_ A -> ( A X. A ) ~~ A ) $=
      ( ccrd cdm wcel com wbr cxp cen cvv reldom brrelex2i numth3 syl infxpidm2
      cdom mpancom ) ABCDZEAOFZAAGAHFRAIDQEAOJKAILMANP $.
  $}

  ${
    $d x y z A $.
    $( The collection of ordinal numbers dominated by a set is an ordinal
       number.  (In general, not all collections of ordinal numbers are
       ordinal.)  Theorem 56 of [Suppes] p. 227.  This theorem can be proved
       (with a longer proof) without the Axiom of Choice; see ~ hartogs .
       (Contributed by NM, 7-Nov-2003.)
       (Proof modification is discouraged.) $)
    ondomon $p |- ( A e. V -> { x e. On | x ~<_ A } e. On ) $=
      ( vy vz wcel cv cdom wbr con0 crab word wss wa wi wal cvv imp breq1 ccrd
      wtr onelon vex onelss ssdomg mpsyl domtr anim2i anassrs sylan exp31 com12
      jca imp3a elrab 3imtr4g gen2 dftr2 mpbir ssrab2 ordon trssord wb cpw csdm
      wral elex canth2g domsdomtr sylan2 expcom ralrimivw syl ss2rab sylibr cfv
      mp3an wceq pwexg numth3 cardval2 3syl fvex syl6eqelr ssexg syl2anc mpbiri
      cdm elong ) BCFZAGZBHIZAJKZJFZWMLZWMUAZWMJMJLWOWPDGZEGZFZWRWMFZNWQWMFZOZE
      PDPXBDEWSWTXAWSWRJFZWRBHIZNWQJFZWQBHIZNZWTXAWSXCXDXGXCWSXDXGOXCWSXDXGXCWS
      NZXEWQWRHIZNXDXGXHXEXIWRWQUBWRQFXHWQWRMZXIEUCXCWSXJWRWQUDRWQWRQUEUFUMXEXI
      XDXGXIXDNXFXEWQWRBUGUHUIUJUKULUNWLXDAWRJWKWRBHSUOWLXFAWQJWKWQBHSUOUPRUQDE
      WMURUSWLAJUTVAWMJVBVQWJWMQFZWNWOVCWJWMWKBVDZVEIZAJKZMZXNQFXKWJWLXMOZAJVFZ
      XOWJBQFZXQBCVGXRXPAJWLXRXMXRWLBXLVEIXMBQVHWKBXLVIVJVKVLVMWLXMAJVNVOWJXNXL
      TVPZQWJXLQFXLTWHFXSXNVRBCVSXLQVTAXLWAWBXLTWCWDWMXNQWEWFWMQWIVMWG $.
  $}

  ${
    $d x y A $.  $d y V $.
    $( The smallest ordinal that strictly dominates a set is a cardinal.
       (Contributed by NM, 28-Oct-2003.)  (Revised by Mario Carneiro,
       20-Sep-2014.) $)
    cardmin $p |- ( A e. V -> ( card ` |^| { x e. On | A ~< x } ) =
                      |^| { x e. On | A ~< x } ) $=
      ( vy wcel cv csdm wbr con0 crab cint wral ccrd cfv wceq wrex syl cvv nfcv
      breq2 numthcor onintrab2 sylib cdom wa wn wi onelon ex onnminsb wb domtri
      syli vex mpan sylibrd nfrab1 nfint nfbr onminsb jctird domsdomtr ralrimiv
      syl6 iscard sylanbrc ) BCEZBAFZGHZAIJZKZIEZDFZVKGHZDVKLVKMNVKOVGVIAIPZVLA
      BCUAZVIAUBUCZVGVNDVKVGVMVKEZVMBUDHZBVKGHZUEVNVGVRVSVTVGVRBVMGHZUFZVSVRVGV
      MIEZWBVGVLVRWCUGVQVLVRWCVKVMUHUIQVIWAAVMVHVMBGTUJUMVMREVGVSWBUKDUNVMBRCUL
      UOUPVGVOVTVPVIVTAABVKGABSAGSAVJVIAIUQURUSVHVKBGTUTQVAVMBVKVBVDVCDVKVEVF
      $.
  $}

  ${
    $d A x $.  $d V x $.
    $( A set is finite iff its cardinal is a natural number.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    ficard $p |- ( A e. V -> ( A e. Fin <-> ( card ` A ) e. om ) ) $=
      ( vx wcel cfn ccrd cfv com cv cen wrex isfi wa wceq carden wi cardnn eqtr
      wbr adantl expcom eleq1a syld sylbird rexlimdva syl5bi eqcomd mpbid ancld
      syl ex breq2 rspcev sylibr syl6 impbid ) ABDZAEDZAFGZHDZURACIZJSZCHKZUQUT
      CALZUQVBUTCHUQVAHDZMVBUSVAFGZNZUTAVABHOVEVGUTPUQVEVGUSVANZUTVEVFVANZVGVHP
      VAQVGVIVHUSVFVARUAUJVAHUSUBUCTUDUEUFUQUTUTAUSJSZMZURUQUTVJUQUTVJUQUTMUSUS
      FGZNZVJUTVMUQUTVLUSUSQUGTAUSBHOUHUKUIVKVCURVBVJCUSHVAUSAJULUMVDUNUOUP $.
  $}

  $( Equivalence between two infiniteness criteria for sets.  (Contributed by
     David Moews, 1-May-2017.) $)
  infinf $p |- ( A e. B -> ( -. A e. Fin <-> om ~<_ A ) ) $=
    ( wcel com cdom wbr csdm wn cfn cvv wb omex domtri isfinite notbii syl6rbbr
    mpan ) ABCZDAEFZADGFZHZAICZHDJCRSUAKLDAJBMQUBTANOP $.

  ${
    $d F x $.
    unirnfdomd.1 $e |- ( ph -> F : T --> Fin ) $.
    unirnfdomd.2 $e |- ( ph -> -. T e. Fin ) $.
    unirnfdomd.3 $e |- ( ph -> T e. V ) $.
    $( The union of the range of a function from an infinite set into the class
       of finite sets is dominated by its domain.  Deduction form.
       (Contributed by David Moews, 1-May-2017.) $)
    unirnfdomd $p |- ( ph -> U. ran F ~<_ T ) $=
      ( vx crn cxp cdom wbr com cvv wcel wral cfn syl syl2anc domtr cuni cen cv
      wfn ffn fnex rnexg wss frn dfss3 sylib csdm isfinite sdomdom sylbi ralimi
      wf 3syl unidom fnrndomg sylc omex xpdom1 wn infinf mpbid xpdom2g infxpidm
      wb domentr ) ACIZUAZBBJZKLZVMBUBLZVLBKLAVLBMJZKLZVPVMKLZVNAVLVKMJZKLZVSVP
      KLZVQAVKNOZHUCZMKLZHVKPZVTACNOZWBACBUDZBDOZWFABQCUQZWGEBQCUERZGBDCUFSCNUG
      RAWIWCQOZHVKPZWEEWIVKQUHWLBQCUIHVKQUJUKWKWDHVKWKWCMULLWDWCUMWCMUNUOUPURHV
      KMNUSSAVKBKLZWAAWHWGWMGWJBDCUTVAVKBMVBVCRVLVSVPTSAWHMBKLZVRGABQOVDZWNFAWH
      WOWNVIGBDVERVFZMBBDVGSVLVPVMTSAWNVOWPBVHRVLVMBVJS $.
  $}

  ${
    konigth.1 $e |- A e. _V $.
    konigth.2 $e |- S = U_ i e. A ( M ` i ) $.
    konigth.3 $e |- P = X_ i e. A ( N ` i ) $.
    ${
      $d A a e f i $.  $d D a e $.  $d E a i $.  $d M a f $.  $d N a e f $.
      $d P a e f $.  $d S a e f $.
      konigth.4 $e |- D = ( i e. A |-> ( a e. ( M ` i ) |->
        ( ( f ` a ) ` i ) ) ) $.
      konigth.5 $e |- E = ( i e. A |-> ( e ` i ) ) $.
      $( Lemma for ~ konigth .  (Contributed by Mario Carneiro,
         22-Feb-2013.) $)
      konigthlem $p |- ( A. i e. A ( M ` i ) ~< ( N ` i ) -> S ~< P ) $=
        ( cfv c0 wcel cvv cv csdm wbr wral wn wfo wex crn cdif wne wa cdom fvex
        wfn cmpt eqid fnmpti wceq mptex fvmpt2 fneq1d mpbiri fnrndomg domsdomtr
        mpan2 mpsyl sylan sdomdif syl ralimiaa difss ssexi ac6c5 wi cixp eldifi
        equid eleq1d syl5ibr ralimia jctil eqeltri sylibr syl6eleqr wrex foelrn
        elixp expcom ciun eleq2i eliun bitri nfra1 nfv nfan w3a ad2antrl fveq1d
        fveq1 sylan9eq eqcomd eqtr3d fnfvelrn adantl eqeltrd 3adant1 simp3l rsp
        simp1 eldifn syl6 sylc pm2.21dd 3expia exp3a rexlimd syl5bi ex rexlimdv
        com23 syl9r mt2i exlimiv 3syl nexdv 0dom mpan 0sdom sylib ralimi neeq1i
        mpd rgenw ixpexg ax-mp ac9 3bitr4i wb iunex domtri mp2an biimpri fodomr
        syl2an mtand notnotrd ) GUAZIQZUUGJQZUBUCZGAUDZDCUBUCZUUKUULUEZDCFUAZUF
        ZFUGZUUKUUOFUUKUUIUUGBQZUHZUIZRUJZGAUDUUGEUAZQZUUSSZGAUDZEUGUUOUEZUUJUU
        TGAUUGASZUUJUKUURUUIUBUCZUUTUVFUURUUHULUCZUUJUVGUUHTSUVFUUQUUHUNZUVHUUG
        IUMZUVFUVIKUUHUUGKUAZUUNQZQZUOZUUHUNKUUHUVMUVNUUGUVLUMZUVNUPZUQUVFUUHUU
        QUVNUVFUVNTSUUQUVNURKUUHUVMUVJUSGAUVNTBOUTVEZVAVBZUUHTUUQVCVFUURUUHUUIV
        DVGUURUUIVHVIVJGAUUSELUUSUUIUUGJUMZUUIUURVKVLVMUVDUVEEUVDUUOUUNUUNURZFV
        QUVDHCSZUUOUVTUEZVNUVDHGAUUIVOZCUVDHAUNZUUGHQZUUISZGAUDZUKHUWCSUVDUWGUW
        DUVCUWFGAUVCUWFUVFUVBUUISUVBUUIUURVPUVFUWEUVBUUIUVFUVBTSUWEUVBURZUUGUVA
        UMZGAUVBTHPUTVEZVRVSVTGAUVBHUWIPUQWAGAUUIHHGAUVBUOTPGAUVBLUSWBWGWCNWDUW
        AUUOHUVLURZKDWEZUVDUWBUUOUWAUWLKDCHUUNWFWHUVDUWKUWBKDUVDUWKUVKDSZUWBUVD
        UWKUWMUWBVNUWMUVKUUHSZGAWEZUVDUWKUKZUWBUWMUVKGAUUHWIZSUWODUWQUVKMWJGUVK
        AUUHWKWLUWPUWNUWBGAUVDUWKGUVCGAWMUWKGWNWOUWBGWNUWPUVFUWNUWBUVDUWKUVFUWN
        UKZUWBUVDUWKUWRWPZUVBUURSZUWBUWKUWRUWTUVDUWKUWRUKZUVBUVKUUQQZUURUXAUWEU
        VBUXBUVFUWHUWKUWNUWJWQUWKUWRUWEUVMUXBUUGHUVLWSUWRUXBUVMUVFUWNUXBUVKUVNQ
        ZUVMUVFUVKUUQUVNUVQWRUWNUVMTSUXCUVMURUVOKUUHUVMTUVNUVPUTVEWTXAWTXBUWRUX
        BUURSZUWKUVFUVIUWNUXDUVRUUHUVKUUQXCVGXDXEXFUWSUVDUVFUWTUEZUVDUWKUWRXIUV
        DUWKUVFUWNXGUVDUVFUVCUXEUVCGAXHUVBUUIUURXJXKXLXMXNXOXPXQXRXTXSYAYLYBYCY
        DYEUUKRCUBUCZCDULUCZUUPUUMUUKUUIRUJZGAUDZUXFUUJUXHGAUUJRUUIUBUCZUXHRUUH
        ULUCUUJUXJUUHUVJYFRUUHUUIVDYGUUIUVSYHYIYJCRUJUWCRUJUXFUXICUWCRNYKCCUWCT
        NUUITSZGAUDUWCTSUXKGAUVSYMGAUUITYNYOWBZYHGAUUILUVSYPYQWCUXGUUMCTSDTSUXG
        UUMYRUXLDUWQTMGAUUHLUVJYSWBCDTTYTUUAUUBDCFUUCUUDUUEUUF $.
    $}
    $d A a e f i $.  $d A a e i j $.  $d M a b e f $.  $d N a e f $.
    $d P a e f $.  $d S a e f $.  $d b e f i $.
    $( Konig's Theorem.  If ` m ( i ) ~< n ( i ) ` for all ` i e. A ` , then
       ` sum_ i e. A m ( i ) ~< prod_ i e. A n ( i ) ` , where the sums and
       products stand in for disjoint union and infinite cartesian product.
       The version here is proven with regular unions rather than disjoint
       unions for convenience, but the version with disjoint unions is clearly
       a special case of this version.  The Axiom of Choice is needed for this
       proof, but it contains AC as a simple corollary (letting
       ` m ( i ) = (/) ` , this theorem says that an infinite cartesian product
       of nonempty sets is nonempty), so this is an AC equivalent.  Theorem
       11.26 of [TakeutiZaring] p. 107.  (Contributed by Mario Carneiro,
       22-Feb-2013.) $)
    konigth $p |- ( A. i e. A ( M ` i ) ~< ( N ` i ) -> S ~< P ) $=
      ( vb vf ve vj va cv cfv cmpt weq fveq2 cbvmptv fveq1d mpteq2i konigthlem
      ) ADAJDOZEPZUDJOZKOZPZPZQZQBCLKDMAMOZLOZPZQEFNGHIDAUJNUEUDNOZUGPZPZQJNUEU
      IUPJNRUDUHUOUFUNUGSUATUBMDAUMUDULPUKUDULSTUC $.
  $}

  $( The power set of an aleph dominates the successor aleph.  (The Generalized
     Continuum Hypothesis says they are equinumerous, see ~ gch3 or
     ~ gchaleph2 .)  (Contributed by NM, 27-Aug-2005.) $)
  alephsucpw $p |- ( aleph ` suc A ) ~<_ ~P ( aleph ` A ) $=
    ( csuc cale cfv cpw cdom wbr csdm wn alephsucpw2 cvv wcel fvex domtri mp2an
    wb pwex mpbir ) ABZCDZACDZEZFGZUBTHGIZAJTKLUBKLUCUDPSCMUAACMQTUBKKNOR $.

  $( The set exponentiation of 2 to the aleph-zero has cardinality of at least
     aleph-one.  (If we were to assume the Continuum Hypothesis, their
     cardinalities would be the same.)  (Contributed by NM, 7-Jul-2004.) $)
  aleph1 $p |- ( aleph ` 1o ) ~<_ ( 2o ^m ( aleph ` (/) ) ) $=
    ( c1o cale cfv c0 csuc c2o cmap co cdom df-1o fveq2i cpw wbr alephsucpw cen
    wb fvex pw2en domen2 ax-mp mpbi eqbrtri ) ABCDEZBCZFDBCZGHZIAUCBJKUDUELZIMZ
    UDUFIMZDNUGUFOMUHUIPUEDBQRUGUFUDSTUAUB $.

  ${
    $d x y z w A $.
    $( An alternate way to express the value of the aleph function for nonzero
       arguments.  Theorem 64 of [Suppes] p. 229.  (Contributed by NM,
       15-Nov-2003.) $)
    alephval2 $p |- ( ( A e. On /\ (/) e. A ) -> ( aleph ` A ) =
                    |^| { x e. On | A. y e. A ( aleph ` y ) ~< x } ) $=
      ( vz con0 wcel wa cale cfv csdm wbr wral wceq ccrd com cdom wi cvv wss wb
      c0 cv crab wn alephordi ralrimiv alephon jctil breq2 ralbidv elrab sylibr
      cint adantr cardsdomelir alephcard eqcomi eleq2s wo omex vex entri3 mp2an
      carddom cardom sseq1i bitr3i wrex cardidm cardalephex alephord ancoms cen
      mpbii cardid sdomen1 ax-mp breq1 syl5rbbr sylan9bb breq1d sdomirr sdomen2
      fveq2 rspcv syl5bbr mtbiri nsyli com12 adantl sylbird exp31 rexlimdv syl5
      syl5bi wne ne0i onelon alephgeom ssdomg sylbi domtr sylan2 domnsym r19.2z
      syl expr ex syl2im rexnal syl6ib expimpd a1d com3r jaod mpi simprbi con3i
      syl56 ssrab2 oneqmini syl2anc ) CEFZUACFZGZCHIZBUBZHIZAUBZJKZBCLZAEUCZFZD
      UBZYLFZUDZDYFLZYFYLUMMZYCYMYDYCYFEFZYHYFJKZBCLZGYMYCUUAYSYCYTBCYGCUEUFCUG
      UHYKUUAAYFEYIYFMYJYTBCYIYFYHJUIUJUKULUNYEYPDYFYNYFFYNYFJKZYEYHYNJKZBCLZUD
      ZYPUUBYNYFNIZYFYNYFUOUUFYFCUPUQURYEOYNPKZYNOPKZUSZUUBUUEQZORFZYNRFZUUIUTD
      VAZOYNRRVBVCYEUUGUUJUUHYCUUGUUJQYDUUGOYNNIZSZYCUUJUUGONIZUUNSZUUOUUKUULUU
      QUUGTUTUUMOYNRRVDVCUUPOUUNVEVFVGUUOUUNYIHIZMZAEVHZYCUUJUUOUUNNIUUNMUUTYNV
      IAUUNVJVNYCUUSUUJAEYCYIEFZUUSUUJYCUVAGZUUSGUUBYICFZUUEUVBUVCUURYFJKZUUSUU
      BUVAYCUVCUVDTYICVKVLUUBUUNYFJKZUUSUVDUUNYNVMKZUVEUUBTYNUUMVOZUUNYNYFVPVQU
      UNUURYFJVRVSVTUUSUVCUUEQUVBUVCUUSUUEUVCUUDUURYNJKZUUSUUCUVHBYICYGYIMYHUUR
      YNJYGYIHWDWAWEUUSUVHUURUURJKZUURWBUVHUURUUNJKZUUSUVIUVFUVJUVHTUVGUUNYNUUR
      WCVQUUNUURUURJUIWFWGWHWIWJWKWLWMWNWOUNUUHUUBYEUUEUUHYEUUEQUUBUUHYCYDUUEYD
      UUHYCGZUUEYDUVKUUCUDZBCVHZUUEYDCUAWPZUVKUVLBCLZUVMCUAWQUVKUVLBCUUHYCYGCFZ
      UVLYCUVPGUUHYGEFZUVLCYGWRUUHUVQGYNYHPKZUVLUVQUUHOYHPKZUVRUVQOYHSZUVSYGWSY
      HEFUVTUVSQYGUGOYHEWTVQXAYNOYHXBXCYNYHXDXFXCXGUFUVNUVOUVMUVLBCXEXHXIUUCBCX
      JXKWIXLXMXNXOXPYOUUDYOYNEFUUDYKUUDAYNEYIYNMYJUUCBCYIYNYHJUIUJUKXQXRXSUFYL
      ESYMYQGYRQYKAEXTDYFYLYAVQYB $.
  $}

  ${
    $d x y z w A $.
    dominfac.1 $e |- A e. _V $.
    $( A nonempty set that is a subset of its union is infinite.  This version
       is proved from ~ ax-ac .  See ~ dominf for a version proved from
       ~ ax-cc .  (Contributed by NM, 25-Mar-2007.) $)
    dominfac $p |- ( ( A =/= (/) /\ A C_ U. A ) -> om ~<_ A ) $=
      ( vx vy vw cv c0 wne cuni wss wa com cdom wbr wi cvv eqid csdm wn wcel id
      wceq neeq1 unieq sseq12d anbi12d breq2 imbi12d cpw cin crab cmpt crdg wf1
      cres inf3lem6 vex pwex f1dom pwfi biimpi isfinite 3imtr3i con3i wb domtri
      cfn omex mp2an 3imtr4i 3syl vtocl ) CFZGHZVMVMIZJZKZLVMMNZOAGHZAAIZJZKZLA
      MNZOCABVMAUBZVQWBVRWCWDVNVSVPWAVMAGUCWDVMAVOVTWDUAVMAUDUEUFVMALMUGUHVQLVM
      UIZDPEFVMUJDFJEVMUKULZGUMLUOZUNLWEMNZVRCDEAAWGWFWFQWGQBBUPLWEWGVMCUQZURZU
      SWELRNZSZVMLRNZSZWHVRWMWKVMVGTZWEVGTZWMWKWOWPVMUTVAVMVBWEVBVCVDLPTZWEPTWH
      WLVEVHWJLWEPPVFVIWQVMPTVRWNVEVHWILVMPPVFVIVJVKVL $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Cardinal number arithmetic using Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g x y z A $.  $d f g y z B $.
    $( The countable union of countable sets is countable (indexed union
       version of ~ unictb ).  (Contributed by Mario Carneiro, 18-Jan-2014.) $)
    iunctb $p |- ( ( A ~<_ om /\ A. x e. A B ~<_ om ) ->
                 U_ x e. A B ~<_ om ) $=
      ( com cdom wbr wral wa ciun cxp cmap wacn wcel cvv reldom brrelexi iunexg
      cv sylancl sylc csn eqid co simpl adantr ovex rgenw acncc syl6eleqr simpr
      acndom omex xpdom1g sylancr xpomen domentr ccrd ralimi syl2an con0 omelon
      cen cdm onenon ax-mp numacn ee10 acndom2 iundomg domtr syl2anc ) BDEFZCDE
      FZABGZHZABCIZBDJZEFVQDEFZVPDEFVOABCDABARUACJIZVSUBVOVLABDCKUCZIZDLZMWABLM
      VLVNUDZVOWANWBVOBNMZVTNMZABGWANMVLWDVNBDEOPZUEWEABDCKUFUGABVTNNQSUHUIBDWA
      UKTVLVNUJVOVRDVPLZMZVQWGMVOVQDDJZEFZWIDVBFVRVODNMVLWJULWCBDDNUMUNUOVQWIDU
      PSZVOVPNMZDUQVCMZWHVLWDCNMZABGWLVNWFVMWNABCDEOPURABCNNQUSDUTMWMVADVDVEVPN
      DVFVGVPVQDVHTVIWKVPVQDVJVK $.
  $}

  ${
    $d x A $.
    $( The countable union of countable sets is countable.  Theorem 6Q of
       [Enderton] p. 159.  See ~ iunctb for indexed union version.
       (Contributed by NM, 26-Mar-2006.) $)
    unictb $p |- ( ( A ~<_ om /\ A. x e. A x ~<_ om ) -> U. A ~<_ om ) $=
      ( com cdom wbr cv wral wa cuni ciun uniiun iunctb syl5eqbr ) BCDEAFZCDEAB
      GHBIABNJCDABKABNLM $.
  $}

  ${
    $d x z w A $.  $d x z w B $.
    $( An exponentiation law for infinite cardinals.  Similar to Lemma 6.2 of
       [Jech] p. 43.  (Contributed by NM, 1-Oct-2004.)  (Proof shortened by
       Mario Carneiro, 30-Apr-2015.) $)
    infmap $p |- ( ( om ~<_ A /\ B ~<_ A ) ->
                      ( A ^m B ) ~~ { x | ( x C_ A /\ x ~~ B ) } ) $=
      ( com cdom wbr cmap co ccrd cdm wcel cv wss cen cab cvv ovex numth3 ax-mp
      wa infmap2 mp3an3 ) DBEFCBEFBCGHZIJKZUCALZBMUECNFTAONFUCPKUDBCGQUCPRSABCU
      AUB $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The sum of two alephs is their maximum.  Equation 6.1 of [Jech] p. 42.
       (Contributed by NM, 29-Sep-2004.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    alephadd $p |- ( ( aleph ` A ) +c ( aleph ` B ) ) ~~
                   ( ( aleph ` A ) u. ( aleph ` B ) ) $=
      ( con0 wcel cale cfv ccda co cun cen wbr wn cvv wa wceq cdm ax-mp cxp com
      c0 ovex wfn alephfnon fndm eleq2i notbii csn c1o 0ex cdaval mp2an 3eqtr2i
      xpundi 0xp ndmfv oveqan12d adantr adantl uneq12d un0 syl6eq 3eqtr4a eqeng
      syl2anbr mpsyl ex wss alephgeom cdom wi fvex ssdomg alephon onenon infcda
      ccrd mp3an12 syl sylbi cdacomen entr sylancr uncom syl6breq pm2.61ii ) AC
      DZBCDZAEFZBEFZGHZWHWIIZJKZWFLZWGLZWLWJMDWMWNNWJWKOZWLWHWIGUAWMAEPZDZLZBWP
      DZLZWOWNWQWFWPCAECUBWPCOUCCEUDQZUEUFWSWGWPCBXAUEUFWRWTNZTTGHZTWJWKXCTTUGZ
      RTUHUGZRIZTXDXEIZRTTMDZXHXCXFOUIUITTMMUJUKTXDXEUMXGUNULWRWTWHTWITGAEUOZBE
      UOZUPXBWKTTITXBWHTWITWRWHTOWTXIUQWTWITOWRXJURUSTUTVAVBVDWJWKMVCVEVFWFSWHV
      GZWLAVHXKSWHVIKZWLWHMDXKXLVJAEVKSWHMVLQWHVPPZDZWIXMDZXLWLWHCDXNAVMWHVNQZW
      ICDXOBVMWIVNQZWHWIVOVQVRVSWGSWIVGZWLBVHXRSWIVIKZWLWIMDXRXSVJBEVKSWIMVLQXS
      WJWIWHIZWKJXSWJWIWHGHZJKYAXTJKZWJXTJKWHWIVTXOXNXSYBXQXPWIWHVOVQWJYAXTWAWB
      WIWHWCWDVRVSWE $.

    $( The product of two alephs is their maximum.  Equation 6.1 of [Jech]
       p. 42.  (Contributed by NM, 29-Sep-2004.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    alephmul $p |- ( ( A e. On /\ B e. On ) ->
  ( ( aleph ` A ) X. ( aleph ` B ) ) ~~ ( ( aleph ` A ) u. ( aleph ` B ) ) ) $=
      ( con0 wcel cale cfv com cdom wbr wa wss alephgeom cvv ssdomg ax-mp sylbi
      wi fvex alephon onenon ccrd cdm c0 wne cxp cun cen jctil infn0 syl syl2an
      infxp ) ACDZAEFZUAUBZDZGUNHIZJBEFZUODZURUCUDZJUNURUEUNURUFUGIBCDZUMUQUPUM
      GUNKZUQALUNMDVBUQQAERGUNMNOPUNCDUPASUNTOUHVAUTUSVAGURKZUTBLVCGURHIZUTURMD
      VCVDQBERGURMNOURUIUJPURCDUSBSURTOUHUNURULUK $.

    $( An exponentiation law for alephs.  Lemma 6.1 of [Jech] p. 42.
       (Contributed by NM, 29-Sep-2004.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    alephexp1 $p |- ( ( ( A e. On /\ B e. On ) /\ A C_ B ) ->
  ( ( aleph ` A ) ^m ( aleph ` B ) ) ~~ ( 2o ^m ( aleph ` B ) ) ) $=
      ( con0 wcel wa wss cale cfv cmap co cen wbr c2o com cdom cvv sylib ssdomg
      fvex ax-mp cpw ccrd alephon onenon mp1i simplr alephgeom mpsyl word ordom
      cdm 2onn ordelss mp2an simpll syl5ss alephord3 wi syl6bi imp csdm sdomdom
      canth2 domtr sylancl mappwen syl22anc wb pw2en enen2 ) ACDZBCDZEZABFZEZAG
      HZBGHZIJZVQUAZKLZVRMVQIJZKLZVOVQUBUKDZNVQOLZMVPOLZVPVSOLZVTVQCDWCVOBUCVQU
      DUEVQPDZVONVQFZWDBGSZVOVLWHVKVLVNUFBUGQNVQPRUHVPPDVOMVPFWEAGSVOMNVPNUIMND
      MNFUJULNMUMUNVOVKNVPFVKVLVNUOAUGQUPMVPPRUHVOVPVQOLZVQVSOLZWFVMVNWJVMVNVPV
      QFZWJABUQWGWLWJURWIVPVQPRTUSUTVQVSVALWKVQWIVCVQVSVBTVPVQVSVDVEVPVQVFVGVSW
      AKLVTWBVHVQWIVIVSWAVRVJTQ $.
  $}

  ${
    $d x A $.
    $( An alternate representation of a successor aleph.  Compare ~ alephsuc
       and ~ alephsuc2 .  Equality can be obtained by taking the ` card ` of
       the right-hand side then using ~ alephcard and ~ carden .  (Contributed
       by NM, 23-Oct-2004.) $)
    alephsuc3 $p |- ( A e. On ->
               ( aleph ` suc A ) ~~ { x e. On | x ~~ ( aleph ` A ) } ) $=
      ( con0 wcel cale cfv cen wbr crab cdif cdom csdm wceq ccrd alephon onenon
      ax-mp a1i com cvv cv csuc alephsuc2 alephcard cardval2 eqtr3i difeq12d wn
      cdm wa difrab wb bren2 rabbiia eqtr4i syl6req wss sucelon alephgeom bitri
      mp1i wi fvex ssdomg sylbi alephordilem1 infdif syl3anc eqbrtrd ensymd ) B
      CDZAUAZBEFZGHZACIZBUBZEFZVKVOVQVMJZVQGVKVRVLVMKHZACIZVLVMLHZACIZJZVOVKVQV
      TVMWBABUCVMWBMVKVMNFZVMWBBUDVMNUIZDZWDWBMVMCDWFBOVMPQAVMUEQUFRUGWCVSWAUHU
      JZACIVOVSWAACUKVNWGACVNWGULVLCDVLVMUMRUNUOUPVKVQWEDZSVQKHZVMVQLHVRVQGHVQC
      DWHVKVPOVQPVAVKSVQUQZWIVKVPCDWJBURVPUSUTVQTDWJWIVBVPEVCSVQTVDQVEBVFVQVMVG
      VHVIVJ $.

    $( An expression equinumerous to 2 to an aleph power.  The proof equates
       the two laws for cardinal exponentiation ~ alephexp1 (which works if the
       base is less than or equal to the exponent) and ~ infmap (which works if
       the exponent is less than or equal to the base).  They can be equated
       only when the base is equal to the exponent, and this is the result.
       (Contributed by NM, 23-Oct-2004.) $)
    alephexp2 $p |- ( A e. On -> ( 2o ^m ( aleph ` A ) ) ~~
          { x | ( x C_ ( aleph ` A ) /\ x ~~ ( aleph ` A ) ) } ) $=
      ( con0 wcel cale cfv cmap co cv wss cen wbr wa cab c2o com cdom cvv ax-mp
      sylancl alephgeom wi fvex ssdomg sylbi domrefg wb pm3.2 pm2.43i alephexp1
      infmap ssid enen1 syl mpbid ) BCDZBEFZUQGHZAIZUQJUSUQKLMANZKLZOUQGHZUTKLZ
      UPPUQQLZUQUQQLZVAUPPUQJZVDBUAUQRDZVFVDUBBEUCZPUQRUDSUEVGVEVHUQRUFSAUQUQUK
      TUPURVBKLZVAVCUGUPUPUPMZBBJVIUPVJUPUPUHUIBULBBUJTURVBUTUMUNUO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Cofinality using Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A f x y $.  $d A f y z $.
    $( A successor aleph is regular.  Theorem 11.15 of [TakeutiZaring] p. 103.
       (Contributed by Mario Carneiro, 9-Mar-2013.) $)
    alephreg $p |- ( cf ` ( aleph ` suc A ) ) = ( aleph ` suc A ) $=
      ( vf vx vy vz con0 wcel cale cfv ccf wceq csdm wbr wa cdom cv wss syl2anc
      wral cvv csuc alephordilem1 cxp wf1 wrex wex alephon cff1 ax-mp ciun fvex
      wn sucex iunex wf ad2antrr simplr wb oneli ffvelrn onelon sylancr onsssuc
      sylan2 anassrs rexbidva eliun syl6bbr ancoms ralbidva dfss3 biimpa ssdomg
      f1f mpsyl simprl suceloni wlim alephislim limsuc sylbi syl ccrd alephcard
      iscard simprbi vtoclri alephsucdom syl5ibr sylbid expdimp ralrimiv iundom
      breq1 syl5 domtr expcom exlimdv mpi cen com alephgeom infxpen mpan xpdom1
      syl6 domentr sylsyld imp domnsym ex mt2d wo cfon onsseleq mpbii mp2an ori
      cfle c0 cf0 cdm alephfnon fndm eleq2i sucelon bitr4i ndmfv sylnbir fveq2d
      wfn 3eqtr4a pm2.61i ) AFGZAUAZHIZJIZYPKZYNYQYPGZULYRYNYSAHIZYPLMZAUBYNYSU
      UAULZYNYSNZYPYTOMZUUBUUCYPYQYTUCZOMZUUEYTOMZUUDUUCYQYPBPZUDZCPZDPZUUHIZQZ
      DYQUEZCYPSZNZBUFZUUFYPFGZUUQYOUGZCDYPBUHUIUUCUUPUUFBUUPUUCUUFUUPUUCNZYPDY
      QUULUAZUJZOMZUVBUUEOMZUUFUVBTGUUTYPUVBQZUVCDYQUVAYPJUKZUULUUKUUHUKUMUNUUT
      YQYPUUHUOZUUOUVEUUIUVGUUOUUCYQYPUUHVNUPZUUIUUOUUCUQUVGUUOUVEUVGUUOUUJUVBG
      ZCYPSUVEUVGUUNUVICYPUUJYPGUVGUUJFGZUUNUVIURZYPUUJUUSUSUVJUVGUVKUVJUVGNZUU
      NUUJUVAGZDYQUEUVIUVLUUMUVMDYQUVJUVGUUKYQGZUUMUVMURZUVGUVNNZUVJUULFGZUVOUV
      PUURUULYPGZUVQUUSYQYPUUKUUHUTZYPUULVAVBUUJUULVCVDVEVFDUUJYQUVAVGVHVIVDVJC
      YPUVBVKVHVLRYPUVBTVMVOUUTYNUVGUVDUUPYNYSVPUVHYNUVGNZYQTGUVAYTOMZDYQSUVDUV
      FUVTUWADYQYNUVGUVNUWAUVPUVRYNUWAUVSYNUVRUVAYPGZUWAYNYOFGZUVRUWBURZAVQUWCY
      PVRUWDYOVSYPUULVTWAWBUWBUWAYNUVAYPLMZEPZYPLMZUWEEUVAYPUWFUVAYPLWNYPWCIYPK
      ZUWGEYPSZYOWDUWHUURUWIEYPWEWFUIZWGUVAAWHWIWJWOWKWLDYQYTUVATWMVBRYPUVBUUEW
      PRWQWRWSYNYSUUGYNYTYTUCZYTWTMZYSUUEUWKOMZUUGYNXAYTQZUWLAXBYTFGUWNUWLAUGYT
      XCXDWAYNYSYQYTOMZUWMYSUWOYNYQYPLMZUWGUWPEYQYPUWFYQYPLWNUWJWGYQAWHWIYQYTYT
      AHUKXEXFUWMUWLUUGUUEUWKYTXGWQXHXIYPUUEYTWPRYPYTXJWBXKXLYSYRYQFGZUURYSYRXM
      ZYPXNUUSUWQUURNYQYPQUWRYPXSYQYPXOXPXQXRWBYNULZXTJIXTYQYPYAUWSYPXTJYNYOHYB
      ZGZYPXTKUXAUWCYNUWTFYOHFYKUWTFKYCFHYDUIYEAYFYGYOHYHYIZYJUXBYLYM $.
  $}

  ${
    $d A f w y z $.  $d A f x y z $.  $d H x $.  $d f s x y $.
    pwcfsdom.1 $e |- H = ( y e. ( cf ` ( aleph ` A ) ) |->
       ( har ` ( f ` y ) ) ) $.
    $( A corollary of Konig's Theorem ~ konigth .  Theorem 11.28 of
       [TakeutiZaring] p. 108.  (Contributed by Mario Carneiro,
       20-Mar-2013.) $)
    pwcfsdom $p |- ( aleph ` A ) ~<
       ( ( aleph ` A ) ^m ( cf ` ( aleph ` A ) ) ) $=
      ( vx con0 wcel cale cfv ccf csdm wbr c0 wceq cvv wa com c2o wss cmap csuc
      vz vw co cv wrex wlim w3o onzsl biimpi aleph0 fveq2i 3eqtr4i fveq2 fveq2d
      cfom 3eqtr4a cdom cpw cen fvex canth2 pw2en sdomentr mp2an alephon omelon
      alephgeom 2onn onelss mp2 sstr mpan sylbi mpsyl mapdom1 sdomdomtr sylancr
      ssdomg syl oveq2 breq2d syl5ibrcom syl5 alephreg rexlimivw wi wf wsmo w3a
      wral wex cfsmo cixp limelon ciun crn cab wfn fnrnfv unieqd dfiun2 syl6eqr
      cuni ffn ad2antrl fnfvelrn sylan sseq2 rspcev ex rexlimdva ralimdv adantl
      imp wb alephislim frn adantr coflim syl2an mpbird char ffvelrn oneli ccrd
      eqtr3d simprbi ax-mp elharval mpan2 3syl ralrimiva eqid eleq2i c1o syl6eq
      wn cmpt harcard iscard domrefg biimpri breq1 rspccv harcl fvmptg eqbrtrrd
      konigth alephlim eleq2d eliun alephcard cardsdomelir sylbir domnsym con2i
      ovex ontri1 sylibr alephord2i ontr2 syl2anr exp31 rexlimdv syl5bi sylan9r
      sylbid cbvmptv eqtri fmptd ss2ixp ixpconst adantrr syl2anc expcom 3adant2
      syl6sseq exlimiv mp2b a1i 3jaod mpd cdm alephfnon ndmfv wne 1n0 1on elexi
      fndm 0sdom mpbir id cf0 oveq12d 0ex map0e breq12d mpbiri sylnbir pm2.61i
      ) BGHZBIJZUXEUXEKJZUAUEZLMZUXDBNOZBFUFZUBZOZFGUGZBPHBUHQZUIZUXHUXDUXOFBUJ
      UKUXDUXIUXHUXMUXNUXIUXFUXEOZUXDUXHUXINIJZKJZUXQUXFUXERKJRUXRUXQUQUXQRKULU
      MULUNUXIUXEUXQKBNIUOZUPUXSURUXDUXHUXPUXEUXEUXEUAUEZLMZUXDUXESUXEUAUEZLMZU
      YBUXTUSMZUYAUXEUXEUTZLMUYEUYBVAMUYCUXEBIVBZVCUXEUYFVDUXEUYEUYBVEVFUXDSUXE
      USMZUYDUXEGHZUXDSUXETZUYGBVGZUXDRUXETZUYIBVISRTZUYKUYIRGHSRHUYLVHVJRSVKVL
      SRUXEVMVNVOSUXEGVTVPSUXEUXEVQWAUXEUYBUXTVRVSUXPUXGUXTUXELUXFUXEUXEUAWBWCW
      DZWEUXMUXPUXDUXHUXLUXPFGUXLUXKIJZKJUYNUXFUXEUXJWFUXLUXEUYNKBUXKIUOZUPUYOU
      RWGUYMWEUXNUXHWHZUXDUYHUXFUXECUFZWIZUYQWJZUCUFZUDUFZUYQJZTZUDUXFUGZUCUXEW
      LZWKZCWMUYPUYJUCUDUXECWNVUFUYPCUYRVUEUYPUYSUXNUYRVUEQZUXHUXNVUGQUXEFUXFUX
      JDJZWOZLMZVUIUXGUSMZUXHUXNUXDVUGVUJBPWPZUXDVUGQZFUXFUXJUYQJZWQZUXEVUILVUM
      UYQWRZXEZVUOUXEUYRVUQVUOOUXDVUEUYRVUQAUFZVUNOFUXFUGAWSZXEZVUOUYRUYQUXFWTZ
      VUQVUTOUXFUXEUYQXFZVVAVUPVUSFAUXFUYQXAXBWAFAUXFVUNUXJUYQVBZXCXDXGVUMVUQUX
      EOZUYTVURTZAVUPUGZUCUXEWLZVUGVVGUXDUYRVUEVVGUYRVUDVVFUCUXEUYRVUCVVFUDUXFU
      YRVUAUXFHZQZVUCVVFVVIVUBVUPHZVUCVVFUYRVVAVVHVVJVVBUXFVUAUYQXHXIVVEVUCAVUB
      VUPVURVUBUYTXJXKXIXLXMXNXPXOUXDUXEUHZVUPUXETZVVDVVGXQVUGUXDVVKBXRUKUYRVVL
      VUEUXFUXEUYQXSXTUCAUXEVUPYAYBYCYHUYRVUOVUILMZUXDVUEUYRVUNVUHLMZFUXFWLVVMU
      YRVVNFUXFUYRUXJUXFHZQZVVNVUNVUNYDJZLMZVVPVUNUXEHZVUNGHZVVRUXFUXEUXJUYQYEZ
      UXEVUNUYJYFVURVVQLMZAVVQWLZVVTVUNVVQHZVVRVVQYGJVVQOZVWCVUNUUAVWEVVQGHZVWC
      AVVQUUBYIYJVVTVUNVUNUSMZVWDVUNPHVWGVVCVUNPUUCYJVWDVVTVWGQVUNVUNYKUUDYLVWB
      VVRAVUNVVQVURVUNVVQLUUEUUFVPYMVVOVVNVVRXQUYRVVOVUHVVQVUNLVVOVWFVUHVVQOVUN
      UUGZAUXJVURUYQJZYDJZVVQUXFGDVURUXJOVWIVUNYDVURUXJUYQUOUPZEUUHYLWCXOYCYNUX
      FVUIVUOFUYQDUXEKVBZVUOYOVUIYOUUJWAXGUUIXIUXNUYRVUKVUEUXGPHUXNUYRQZVUIUXGT
      ZVUKUXEUXFUAUUSVWMUXFUXEDWIZVUHUXETZFUXFWLZVWNVWMFUXFVVQUXEDVWMVVOVVQUXEH
      ZUYRVVOVVSUXNVWRUYRVVOVVSVWAXLUXNVVSVUNABVURIJZWQZHZVWRUXNUXEVWTVUNABPUUK
      UULUXNUXDVXAVWRWHVULVXAVUNVWSHZABUGUXDVWRAVUNBVWSUUMUXDVXBVWRABUXDVURBHZV
      XBVWRVXBVVQVWSTZVWSUXEHZVWRUXDVXCQVXBVUNVWSLMZVXDVXBVUNVWSYGJZHVXFVXGVWSV
      UNVURUUNYPVUNVWSUUOUUPVXFVWSVVQHZYSZVXDVXHVXFVXHVWSVUNUSMZVXFYSVXHVWSGHZV
      XJVUNVWSYKYIVWSVUNUUQWAUURVWFVXKVXDVXIXQVWHVURVGVVQVWSUUTVFUVAWAUXDVXCVXE
      VURBUVBXPVWFUYHVXDVXEQVWRWHVWHUYJVVQVWSUXEUVCVFUVDUVEUVFUVGWAUVIUVHXPDAUX
      FVWJYTFUXFVVQYTEAFUXFVWJVVQVWKUVJUVKUVLVWOVWPFUXFUYHVWOVVOQVUHUXEHVWPUYJU
      XFUXEUXJDYEUXEVUHVKVPYNVWQVUIFUXFUXEWOUXGFUXFVUHUXEUVMFUXFUXEVWLUYFUVNUVS
      YMVUIUXGPVTVPUVOUXEVUIUXGVRUVPUVQUVRUVTUWAUWBUWCUWDUXDBIUWEZHZUXHVXLGBIGW
      TVXLGOUWFGIUWLYJYPVXMYSUXENOZUXHBIUWGVXNUXHNYQLMZVXOYQNUWHUWIYQYQGUWJUWKU
      WMUWNVXNUXENUXGYQLVXNUWOZVXNUXGNNUAUEZYQVXNUXENUXFNUAVXPVXNUXFNKJNUXENKUO
      UWPYRUWQNPHVXQYQOUWRNPUWSYJYRUWTUXAWAUXBUXC $.
  $}

  ${
    $d x y z A $.  $d x B $.
    cfpwsdom.1 $e |- B e. _V $.
    $( A corollary of Konig's Theorem ~ konigth .  Theorem 11.29 of
       [TakeutiZaring] p. 108.  (Contributed by Mario Carneiro,
       20-Mar-2013.) $)
    cfpwsdom $p |- ( 2o ~<_ B ->
        ( aleph ` A ) ~< ( cf ` ( card ` ( B ^m ( aleph ` A ) ) ) ) ) $=
      ( con0 wcel cdom wbr cale cfv cmap co ccf csdm cen wceq com cvv ax-mp c1o
      c0 vx vy vz c2o ccrd wi wa cxp ovex cardid ensymi cv wrex crn wn cpw fvex
      canth2 pw2en sdomentr mp2an mapdom1 sdomdomtr sylancr cfn ficard isfinite
      wb sdomdom sylbi sylbir wss alephgeom alephon ssdomg domtr syl2an domnsym
      syl expcom con2d cardidm cun wo iscard3 elun df-or 3bitri syl56 alephfnon
      mpbi wfn fvelrnb syl6ib char cmpt pwcfsdom id fveq2 oveq12d breq12d mpbii
      eqid rexlimivw syl6 imp ensdomtr enref mapen mapxpen mp3an sylancl xpdom2
      entri biimpi infxpen domentr csuc nsuceq0 dom0 nemtbir df-2o breq1i breq2
      syl5bb biimpcd adantld mtoi mapdom2 expl com12 mt2d domtri biimpri ex cdm
      nsyl2 1onn syl6eq fveq2d eleq2i ndmfv sylnbir wne elexi 0sdom mpbir oveq2
      fndm 1n0 map0e cardnn df-1o fveq2i 0elon cfsuc eqtri mpbiri a1d pm2.61i )
      ADEZUDBFGZAHIZBUVCJKZUEIZLIZMGZUFZUVAUVBUVGUVAUVBUGZUVFUVCFGZUVGUVIUVJUVD
      BUVCUVFUHZJKZMGZUVIUVDUVEUVFJKZMGZUVNUVLNGUVMUVIUVDUVENGUVEUVNMGZUVOUVEUV
      DUVDBUVCJUIZUJZUKUVAUVBUVPUVAUVBUAULZHIZUVEOZUADUMZUVPUVAUVBUVEHUNZEZUWBU
      VBUVCUVDMGZUVAUVEPEZUOZUWDUVBUVCUDUVCJKZMGZUWHUVDFGUWEUVCUVCUPZMGUWJUWHNG
      UWIUVCAHUQZURUVCUWKUSUVCUWJUWHUTVAUDBUVCVBUVCUWHUVDVCVDUVAUWFUWEUWFUVAUWE
      UOZUWFUVAUGUVDUVCFGZUWLUWFUVDPFGZPUVCFGZUWMUVAUWFUVDVEEZUWNUVDQEUWPUWFVHU
      VQUVDQVFRUWPUVDPMGUWNUVDVGUVDPVIVJVKUVAPUVCVLZUWOAVMZUVCDEZUWQUWOUFAVNZPU
      VCDVORVJUVDPUVCVPVQUVDUVCVRVSVTWAUVEUEIUVEOZUWGUWDUFZUVDWBUXAUVEPUWCWCEUW
      FUWDWDUXBUVEWEUVEPUWCWFUWFUWDWGWHWKWIHDWLZUWDUWBVHWJUADUVEHWMRWNUWAUVPUAD
      UWAUVTUVTUVTLIZJKZMGUVPUBUVSUCUBUXDUBULUCULIWOIWPZUXFXCWQUWAUVTUVEUXEUVNM
      UWAWRZUWAUVTUVEUXDUVFJUXGUVTUVELWSWTXAXBXDXEXFUVDUVEUVNXGVDUVNUVDUVFJKZUV
      LUVEUVDNGUVFUVFNGUVNUXHNGUVRUVFUVELUQZXHUVEUVDUVFUVFXIVABQEZUWSUVFQEZUXHU
      VLNGCUWTUXIBUVCUVFQDQXJXKXNUVDUVNUVLUTXLUVJUVIUVMUOZUVJUVAUVBUXLUVJUVAUGZ
      UVBUGUVLUVDFGZUXLUXMUVKUVCFGZUVKTOZBTOZUGZUOUXNUVBUVJUVKUVCUVCUHZFGUXSUVC
      NGZUXOUVAUVFUVCUVCUWKXMUVAUWSUWQUXTUWTUVAUWQUWRXOUVCXPVDUVKUXSUVCXQVQUVBU
      XRSXRZTFGZUYBUYATSXSUYAXTYAUVBUXQUYBUXPUXQUVBUYBUVBUYABFGUXQUYBUDUYABFYBY
      CBTUYAFYDYEYFYGYHUVKUVCBYIVQUVLUVDVRVSYJYKYLUVJUVGUOZUXKUVCQEUVJUYCVHUXIU
      WKUVFUVCQQYMVAYNYQYOUVAUOUVCTOZUVHUVAAHYPZEUYDUYEDAUXCUYEDOWJDHUUIRUUAAHU
      UBUUCUYDUVGUVBUYDUVGTSMGZUYFSTUUDUUJSSPYRUUEUUFUUGUYDUVCTUVFSMUYDWRUYDUVF
      SLIZSUYDUVESLUYDUVESUEIZSUYDUVDSUEUYDUVDBTJKZSUVCTBJUUHUXJUYISOCBQUUKRYSY
      TSPEUYHSOYRSUULRYSYTUYGTXRZLIZSSUYJLUUMUUNTDEUYKSOUUOTUUPRUUQYSXAUURUUSVS
      UUT $.
  $}

  ${
    $d A x $.  $d B x $.  $d f x y $.  $d f y z $.
    $( From ~ canth2 , we know that ` ( aleph `` 0 ) < ( 2 ^ om ) ` , but we
       cannot prove that ` ( 2 ^ om ) = ( aleph `` 1 ) ` (this is the Continuum
       Hypothesis), nor can we prove that it is less than any bound whatsoever
       (i.e. the statement ` ( aleph `` A ) < ( 2 ^ om ) ` is consistent for
       any ordinal ` A ` ).  However, we can prove that ` ( 2 ^ om ) ` is not
       equal to ` ( aleph `` om ) ` , nor ` ( aleph `` ( aleph `` om ) ) ` , on
       cofinality grounds, because by Konig's Theorem ~ konigth (in the form of
       ~ cfpwsdom ), ` ( 2 ^ om ) ` has uncountable cofinality, which
       eliminates limit alephs like ` ( aleph `` om ) ` .  (The first limit
       aleph that is _not_ eliminated is ` ( aleph `` ( aleph `` 1 ) ) ` ,
       which has cofinality ` ( aleph `` 1 ) ` .)  (Contributed by Mario
       Carneiro, 21-Mar-2013.) $)
    alephom $p |- ( card ` ( 2o ^m om ) ) =/= ( aleph ` om ) $=
      ( com csdm wbr wn c2o cmap co ccrd cfv cale wne sdomirr wceq ccf cvv wcel
      c0 cdom aleph0 ax-mp 2onn elexi domrefg cfpwsdom a1i oveq2i fveq2i eqeq1i
      mp2b biimpri fveq2d wlim limom alephsing cfom eqtri syl6eq mpbii necon3bi
      breq12d ) AABCZDEAFGZHIZAJIZKALVAVCVDVCVDMZQJIZEVFFGZHIZNIZBCZVAEOPEERCVJ
      EAUAUBZEOUCQEVKUDUIVEVFAVIABVFAMVESUEVEVIVDNIZAVEVHVDNVHVDMVEVHVCVDVGVBHV
      FAEFSUFUGUHUJUKVLANIZAAULVLVMMUMAUNTUOUPUQUTURUST $.
  $}

  ${
    $d x y $.
    $( The beth function is strictly monotone.  This function is not strictly
       the beth function, but rather beth_A is the same as
       ` ( card `` ( R1 `` ( om +o A ) ) ) ` , since conventionally we start
       counting at the first infinite level, and ignore the finite levels.
       (Contributed by Mario Carneiro, 6-Jun-2013.)  (Revised by Mario
       Carneiro, 2-Jun-2015.) $)
    smobeth $p |- Smo ( card o. R1 ) $=
      ( vy vx ccrd cr1 cdm con0 wfn crn wss wfun ax-mp r1fnon mpbi cep wcel cfv
      wf wa wb sylan ccom ccnv cima cv cen wbr wrex cab cardf2 ffun fnfun funco
      mp2an funfn cres rnco resss rnss frn sstri eqsstri df-f mpbir2an dmco wtr
      feq2i word wwe wral elpreima simplbi onelon simprbi adantr r1ord2 syl2anc
      imp ssnum sylanbrc rgen2 dftr5 mpbir cnvimass cvv dffn2 fdmi sseqtri wess
      epweon mp2 df-ord csdm r1sdom cardsdom2 mpbird wceq fvco2 sylancr 3eltr4d
      wi ex adantl issmo ) ABCDUAZDUBCEZUCZXDEZFXDQZXFFXDQXHXDXGGZXDHZFIXDJZXIC
      JZDJZXKAUDZBUDZUEUFAFUGBUHZFCQZXLBAUIZXPFCUJKDFGZXMLFDUKKCDULUMXDUNMXJCDH
      ZUOZHZFCDUPYBCHZFYACIYBYCICXTUQYACURKXQYCFIXRXPFCUSKUTVAXGFXDVBVCXGXFFXDC
      DVDZVFMXFVGXFVEZXFNVHZYEXNXFOZAXOVIBXFVIYGBAXFXOXOXFOZXNXOOZRZXNFOZXNDPZX
      EOZYGYHXOFOZYIYKYHYNXODPZXEOZXSYHYNYPRSLFXOXEDVJKZVKZXOXNVLTZYJYPYLYOIZYM
      YHYPYIYHYNYPYQVMVNZYHYNYIYTYRYNYIYTXNXOVOVQTYOYLVRVPZXSYGYKYMRSLFXNXEDVJK
      VSVTBAXFWAWBXFFIFNVHYFXFDEFDXEWCFWDDXSFWDDQLFDWEMWFWGWIXFFNWHWJXFWKVCYHYI
      XNXDPZXOXDPZOZWTYGYHYIUUEYJYLCPZYOCPZUUCUUDYJUUFUUGOZYLYOWLUFZYHYNYIUUIYR
      XOXNWMTYJYMYPUUHUUISUUBUUAYLYOWNVPWOYJXSYKUUCUUFWPLYSFCDXNWQWRYJXSYNUUDUU
      GWPLYHYNYIYRVNFCDXOWQWRWSXAXBYDXC $.
  $}

$( I decided to comment out the Card class for now.  We have too many
   definitions, and this one doesn't really buy us much. $)

$(
  @c Card @. @( Class of all cardinal numbers @)

  @( Extend class definition to include the class of all cardinal numbers. @)
  ccdn @a class Card @.

  @( Define the class of all cardinal numbers.  The notation "Card" is used
     in Exercise 5(G) of [JustWeese] p. 174.  It should not be confused with
     the lower-case "card" for the cardinal number function ~ df-card .  @)
  df-cardn @a |- Card = ( om u. ran aleph ) @.

  @( Membership in the class of cardinal numbers. @)
  elcard @p |- ( A e. Card <-> ( card ` A ) = A ) @=
    ( ccdn wcel com cale crn cun ccrd cfv wceq df-cardn eleq2i iscard3 bitr4i )
    ABCADEFGZCAHIAJBOAKLAMN @.
    @( [31-Dec-2004] @) @( [23-Sep-2004] @)

  @( The cardinality of a set is a cardinal number. @)
  cardel @p |- ( card ` A ) e. Card @=
    ( ccrd cfv ccdn wcel wceq cardidm elcard mpbir ) ABCZDEJBCJFAGJHI @.
    @( [16-Jan-2005] @) @( [23-Sep-2004] @)

  @( A natural number is a cardinal number. @)
  nncard @p |- ( A e. om -> A e. Card ) @=
    ( com wcel ccrd cfv wceq ccdn cardnn elcard sylibr ) ABCADEAFAGCAHAIJ @.
    @( [16-Jan-2005] @) @( [23-Sep-2004] @)

  @( An alternate definition of the class of all cardinal numbers. @)
  cardnum2 @p |- Card = { x | ( card ` x ) = x } @=
    ( ccdn com cale crn cun cv ccrd cfv wceq cab df-cardn wcel iscard3 bicomi
    abbi2i eqcomi eqtr4i ) BCDEFZAGZHITJZAKZLSUBUAASUATSMTNOPQR @.
    @( [25-Jan-2005] @) @( [23-Sep-2004] @)

  @( The class of cardinal numbers is a proper class.  Exercise 5(G)(b) of
     [JustWeese] p. 174. @)
  cardnprc @p |- -. Card e. _V @=
    ( vx ccdn cvv wcel cv ccrd cfv wceq cab cardprc cardnum2 eleq1i mtbir ) BCD
    AEZFGNHAIZCDAJBOCAKLM @.
    @( [25-Jan-2005] @) @( [23-Sep-2004] @)

  @( The class of transfinite cardinals (the range of the aleph function) is a
     proper class. @)
  alephprc2 @p |- -. ran aleph e. _V @=
    ( cale crn cvv wcel com cun ccdn cardnprc df-cardn eleq1i mtbi omex wa
    unexb biimpi mpan mto ) ABZCDZERFZCDZGCDUAHGTCIJKECDZSUALUBSMUAERNOPQ @.
    @( [19-Feb-2005] @) @( [23-Sep-2004] @)
$)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
         ZFC Axioms with no distinct variable requirements
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $( A lemma for proving conditionless ZFC axioms.  (Contributed by NM,
     1-Jan-2002.) $)
  nd1 $p |- ( A. x x = y -> -. A. x y e. z ) $=
    ( weq wal wel elirrv wsb stdpc4 nfnth elequ1 sbie sylib mto ax10o mtoi ) AB
    DAEBCFZAEQBEZRCCFZCGZRQBCHSQBCIQSBCSBTJBCCKLMNQABOP $.

  $( A lemma for proving conditionless ZFC axioms.  (Contributed by NM,
     1-Jan-2002.) $)
  nd2 $p |- ( A. x x = y -> -. A. x z e. y ) $=
    ( weq wal wel elirrv wsb stdpc4 nfnth elequ2 sbie sylib mto ax10o mtoi ) AB
    DAECBFZAEQBEZRCCFZCGZRQBCHSQBCIQSBCSBTJBCCKLMNQABOP $.

  $( A lemma for proving conditionless ZFC axioms.  (Contributed by NM,
     2-Jan-2002.) $)
  nd3 $p |- ( A. x x = y -> -. A. z x e. y ) $=
    ( weq wal wel wn elirrv elequ2 mtbii sps sp nsyl ) ABDZAEABFZOCENOGANAAFOAH
    ABAIJKOCLM $.

  $( A lemma for proving conditionless ZFC axioms.  (Contributed by NM,
     2-Jan-2002.) $)
  nd4 $p |- ( A. x x = y -> -. A. z y e. x ) $=
    ( wel wal wn nd3 aecoms ) BADCEFBABACGH $.

  ${
    $d x v w $.  $d y v w $.  $d z v w $.
    $( A version of the Axiom of Extensionality with no distinct variable
       conditions.  (Contributed by NM, 14-Aug-2003.) $)
    axextnd $p |- E. x ( ( x e. y <-> x e. z ) -> y = z ) $=
      ( vw wel wb weq wal wex wi wn nfnae wnfc nfcvf nfcrd elequ1 syl6 a9e nfae
      cv wa nfan adantr adantl nfbid bibi12d a1i cbvald axext3 syl6bir 19.8a ex
      ax-8 sps eximd mpi a1d equcomi pm2.61ii 19.35ri ) ABEZACEZFZBCGZAABGZAHZA
      CGZAHZVCAHZVDAIZJZVFKZVHKZVKVLVMUAZVIVDVJVNVIDBEZDCEZFZDHVDVNVQVCDAVLVMAA
      BALACALUBVNVOVPAVNADBTZVLAVRMVMABNUCOVNADCTZVMAVSMVLACNUDOUEDAGZVQVCFJVNV
      TVOVAVPVBDABPDACPUFUGUHBCDUIUJVDAUKQULVFVJVIVFVGAIVJACRVFVGVDAABASVEVGVDJ
      AABCUMUNUOUPUQVHVJVIVHVEAIVJABRVHVEVDAACASVGVEVDJAVGVECBGVDACBUMCBURQUNUO
      UPUQUSUT $.
  $}

  ${
    $d x z w v $.  $d x y w v $.  $d w ph $.
    $( Lemma for the Axiom of Replacement with no distinct variable
       conditions.  (Contributed by NM, 2-Jan-2002.) $)
    axrepndlem1 $p |- ( -. A. y y = z -> E. x ( E. y A. z ( ph -> z = y ) ->
                 A. z ( z e. x <-> E. x ( x e. y /\ A. y ph ) ) ) ) $=
      ( vw weq wal wi wex wel wa wb nfnae a1i nfcvd nfeqd imbi12d cbvald exbid
      cv wn wsb axrep2 wnf nfs1v nfcvf2 nfimd sbequ12r equequ1 nfvd nfcrd nfald
      nfand nfexd nfbid elequ1 adantl nfcvf nfan1 albid anbi2d bibi12d ex mpbii
      exbidv ) CDFCGUAZADEUBZECFZHZEGZCIZEBJZBCJZVGCGZKZBIZLZEGZHZBIADCFZHZDGZC
      IZDBJZVMACGZKZBIZLZDGZHZBIVGBCEUCVFVSWJBCDBMZVFVKWCVRWIVFVJWBCCDCMZVFVIWA
      EDCDDMZVFVGVHDVGDUDVFADEUENZVFDETZCTZVFDWOOCDUFZPUGEDFZVIWALHVFWRVGAVHVTA
      EDUHZEDCUIQNRSVFVQWHEDWMVFVLVPDVFVLDUJVFVODBWKVFVMVNDVFDBWPWQUKVFVGDCWLWN
      ULUMUNUOVFWRVQWHLVFWRKZVLWDVPWGWRVLWDLVFEDBUPUQWTVOWFBWTVNWEVMWTVGACVFWRC
      WLVFCWODTVFCWOOCDURPUSWRVGALVFWSUQUTVAVEVBVCRQSVD $.
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.  $d w ph $.
    $( Lemma for the Axiom of Replacement with no distinct variable
       conditions.  (Contributed by NM, 2-Jan-2002.)  (Proof shortened by Mario
       Carneiro, 6-Dec-2016.) $)
    axrepndlem2 $p |- ( ( ( -. A. x x = y /\ -. A. x x = z ) /\ -. A. y y = z )
                 -> E. x ( E. y A. z ( ph -> z = y ) ->
                     A. z ( z e. x <-> E. x ( x e. y /\ A. y ph ) ) ) ) $=
      ( vw weq wal wn wa wi wex wel wb nfnae nfan cv wnfc adantl adantr nfeqd
      wsb axrepndlem1 wnf nfs1v nfcvf nfimd nfald nfexd nfcvd nfeld nfand nfbid
      a1i nfv nfcvf2 nfan1 sbequ12r imbi1d albid exbid elequ2 elequ1 anbi12d ex
      cbvexd bibi12d imbi12d syl5ib imp ) BCFBGHZBDFBGHZIZCDFCGHZADCFZJZDGZCKZD
      BLZBCLZACGZIZBKZMZDGZJZBKZVMABEUAZVNJZDGZCKZDELZECLZWGCGZIZEKZMZDGZJZEKVL
      WFWGECDUBVLWRWEEBVJVKBBCBNBDBNOZVLWJWQBVLWIBCVJVKCBCCNBDCNOZVLWHBDVJVKDBC
      DNBDDNOZVLWGVNBWGBUCVLABEUDUMZVLBDPZCPZVKBXCQVJBDUERZVJBXDQVKBCUESZTUFUGU
      HVLWPBDXAVLWKWOBVLBXCEPZXEVLBXGUIZUJVLWNBEVLEUNVLWLWMBVLBXGXDXHXFUJVLWGBC
      WTXBUGUKZUHULUGUFVLEBFZWRWEMVLXJIZWJVQWQWDXKWIVPCVLXJCWTVLCXGBPZVLCXGUIVJ
      CXLQVKBCUOSTUPZXKWHVODVLXJDXAVLDXGXLVLDXGUIVKDXLQVJBDUORTUPZXJWHVOMVLXJWG
      AVNAEBUQZURRUSUTXKWPWCDXNXKWKVRWOWBXJWKVRMVLEBDVARVLWOWBMXJVLWNWAEBWSXIVL
      XJWNWAMXKWLVSWMVTXJWLVSMVLEBCVBRXKWGACXMXJWGAMVLXORUSVCVDVESVFUSVGVDVEVHV
      I $.
  $}

  $( A version of the Axiom of Replacement with no distinct variable
     conditions.  (Contributed by NM, 2-Jan-2002.) $)
  axrepnd $p |- E. x ( E. y A. z ( ph -> z = y ) ->
               A. z ( A. y z e. x <-> E. x ( A. z x e. y /\ A. y ph ) ) ) $=
    ( weq wal wi wex wa wn nfnae nfan cv wnfc nfcvf2 nfae intnanrd nexd 2falsed
    aecoms wel wb axrepndlem2 nfcvf adantl ad2antrr nfeld nfrd impbid1 ad2antlr
    sp anbi1d exbid bibi12d albid imbi2d mpbid exp31 nd2 nd3 alrimi a1d syl nd4
    19.8a nd1 pm2.61iii ) BCEBFZBDEBFZCDECFZADCEGDFCHZDBUAZCFZBCUAZDFZACFZIZBHZ
    UBZDFZGZBHZVHJZVIJZVJJZWBWCWDIZWEIZVKVLVNVPIZBHZUBZDFZGZBHWBABCDUCWGWLWABWF
    WEBWCWDBBCBKBDBKLCDBKLZWGWKVTVKWGWJVSDWFWEDWCWDDBCDKBDDKLCDDKLWGVLVMWIVRWGV
    LVMWGVLCWGCDMZBMZWECWNNWFCDUDUEWCCWONWDWEBCOUFUGUHVLCUKUIWGWHVQBWMWGVNVOVPW
    GVNVOWGVNDWGDWOCMZWDDWONWCWEBDOUJWEDWPNWFCDOUEUGUHVNDUKUIULUMUNUOUPUMUQURVH
    WAWBVHVTVKVHVSDBCDPVHVMVRVMJCBCBDUSTVHVQBBCBPVHVOVPBCDUTQRSVAVBWABVEZVCVIWA
    WBVIVTVKVIVSDBDDPVIVMVRBDCVDVIVQBBDBPVIVOVPVOJZDBDBCVFTQRSVAVBWQVCVJWAWBVJV
    TVKVJVSDCDDPVJVMVRCDBVFVJVQBCDBPVJVOVPWRDCDCBUSTQRSVAVBWQVCVG $.

  ${
    $d x y w $.  $d x z w $.
    $( Lemma for the Axiom of Union with no distinct variable conditions.
       (Contributed by NM, 2-Jan-2002.) $)
    axunndlem1 $p |- E. x A. y ( E. x ( y e. x /\ x e. z ) -> y e. x ) $=
      ( vw weq wal wel wa wi wn cv en2lp elequ2 anbi2d mtbii nexdv nfnae exbidv
      wex sps pm2.21d a5i 19.8a syl zfun nfvd nfcvf nfcrd nfand nfexd wb elequ1
      nfimd anbi1d imbi12d a1i cbvald mpbii pm2.61i ) BCEZBFZBAGZACGZHZASZVBIZB
      FZASZVAVGVHUTVFBVAVEVBVAVDAUTVDJBUTVBABGZHVDBKAKLUTVIVCVBBCAMNOTPUAUBVGAU
      CUDVAJZDAGZVCHZASZVKIZDFZASVHADCUEVJVOVGAVJVNVFDBBCBQVJVMVKBVJVLBABCAQVJV
      KVCBVJVKBUFZVJBACKBCUGUHUIUJVPUMDBEZVNVFUKIVJVQVMVEVKVBVQVLVDAVQVKVBVCDBA
      ULZUNRVRUOUPUQRURUS $.
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A version of the Axiom of Union with no distinct variable conditions.
       (Contributed by NM, 2-Jan-2002.) $)
    axunnd $p |- E. x A. y ( E. x ( y e. x /\ x e. z ) -> y e. x ) $=
      ( vw weq wal wel wa wex wi wn nfnae nfan cv wnfc nfcvf adantr nfcvd nfae
      wb axunndlem1 nfv nfeld adantl nfand nfexd nfimd nfald nfcvf2 nfeqd nfan1
      elequ2 elequ1 anbi12d a1i cbvexd imbi12d albid ex mpbii elirrv mtbiri sps
      intnanrd nexd pm2.21d alrimi 19.8a syl intnand pm2.61ii ) ABEZAFZACEZAFZB
      AGZACGZHZAIZVPJZBFZAIZVMKZVOKZWBWCWDHZBDGZDCGZHZDIZWFJZBFZDIWBDBCUAWEWKWA
      DAWCWDAABALACALMZWEWJABWCWDBABBLACBLMZWEWIWFAWEWHADWEDUBWEWFWGAWEABNZDNZW
      CAWNOWDABPQWEAWORZUCZWEAWOCNZWPWDAWROWCACPUDUCUEZUFWQUGUHWEDAEZWKWATWEWTH
      ZWJVTBWEWTBWMWEBWOANZWEBWORWCBXBOWDABUIQUJUKXAWIVSWFVPWEWIVSTWTWEWHVRDAWL
      WSWTWHVRTJWEWTWFVPWGVQDABULZDACUMUNUOUPQWTWFVPTWEXCUDUQURUSUPUTUSVMWAWBVM
      VTBABBSVMVSVPVMVRAABASVLVRKZAVLVPVQVLVPBBGBVAABBULVBVDVCVEVFVGWAAVHZVIVOW
      AWBVOVTBACBSVOVSVPVOVRAACASVNXDAVNVQVPVNVQCCGCVAACCUMVBVJVCVEVFVGXEVIVK
      $.
  $}

  $( Lemma for the Axiom of Power Sets with no distinct variable conditions.
     (Contributed by NM, 4-Jan-2002.) $)
  axpowndlem1 $p |- ( A. x x = y -> ( -. x = y ->
             E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) $=
    ( weq wn wel wex wal wi pm2.24 sps ) ABDZLEABFCGACFBHIAHBAFIBHAGZIALMJK $.

  ${
    $d x w $.  $d z y w $.
    $( Lemma for the Axiom of Power Sets with no distinct variable conditions.
       (Contributed by NM, 4-Jan-2002.)  (Proof shortened by Mario Carneiro,
       6-Dec-2016.) $)
    axpowndlem2 $p |- ( -. A. x x = y -> ( -. A. x x = z -> ( -. x = y ->
         E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) ) $=
      ( vw weq wal wn wel wi nfnae nfan cv nfcvd wnfc adantr nfeqd adantl wb ex
      wex wa zfpow 19.8a imim12i alimi imim1i eximi mp1i ax-gen nfcvf nfv nfeld
      sp nfnd nfexd nfald nfimd equequ1 notbid nfcvf2 nfan1 exbid albid imbi12d
      elequ1 cbvald elequ2 cbvexd mpbii 19.21bi ) ABEZAFGZACEAFGZVKGZABHZCTZACH
      ZBFZIZAFZBAHZIZBFZATZIZVLVMUAZWEAWFDBEZGZDBHZCTZDCHZBFZIZDFZBDHZIZBFZDTZI
      ZDFWEAFWSDWIWKIZDFZWOIZBFZDTWRWHDBCUBXCWQDXBWPBWNXAWOWMWTDWIWJWLWKWICUCWK
      BUMUDUEUFUEUGUHUIWFWSWEDAVLVMAABAJACAJKZWFWHWRAWFWGAWFADLZBLZWFAXEMZVLAXF
      NVMABUJOZPUNWFWQADWFDUKZWFWPABVLVMBABBJACBJKZWFWNWOAWFWMADXIWFWJWLAWFWIAC
      VLVMCABCJACCJKZWFAXEXFXGXHULUOWFWKABXJWFAXECLZXGVMAXLNVLACUJQULUPUQZUPWFA
      XFXEXHXGULUQUPZUOUQWFDAEZWSWERWFXOUAZWHVNWRWDXOWHVNRWFXOWGVKDABURUSQWFWRW
      DRXOWFWQWCDAXDXNWFXOWQWCRXPWPWBBWFXOBXJWFBXEALZWFBXEMVLBXQNVMABUTOPVAZXPW
      NVTWOWAWFWNVTRXOWFWMVSDAXDXMWFXOWMVSRXPWJVPWLVRXPWIVOCWFXOCXKWFCXEXQWFCXE
      MVMCXQNVLACUTQPVAXOWIVORWFDABVEQVBXPWKVQBXRXOWKVQRWFDACVEQVCVDSVFOXOWOWAR
      WFDABVGQVDVCSVHOVDSVFVIVJS $.
  $}

  ${
    $d x w $.  $d y z w $.
    $( Lemma for the Axiom of Power Sets with no distinct variable conditions.
       (Contributed by NM, 4-Jan-2002.)  (Revised by Mario Carneiro,
       10-Dec-2016.) $)
    axpowndlem3 $p |- ( -. x = y ->
               E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) $=
      ( vw cv wceq wal wn wcel wex wi c0 nfnae nfeld wb exbid adantl nfae alnex
      wa axpowndlem2 axpowndlem1 csn p0ex eleq2 imbi2d albidv spcev snid mpbiri
      0ex eleq1 mpg neq0 imbi1i albii exbii mpbir nfcvf2 nfcvd nfexd nfnd nfimd
      con1bii dveeq2 imdistani nfa1 elequ2 sps syl notbid elequ1 imbi12d cbvald
      ex mpbii ax10o aecoms 3imtr3g nd3 pm2.21d jad spsd imim1d alimd syl5 a1dd
      eximd pm2.61d2 pm2.61ii ) AEZBEZFZAGZWKCEZFAGZWMHZWKWLIZCJZWKWOIBGZKZAGZW
      LWKIZKZBGZAJZKZABCUAABCUBZWPWNXGWPWNHZXFWQXIWRAJZHZXCKZBGZAJZWPXFXIWKDEZI
      ZAJZHZXOWKIZKZDGZAJZXNYBXOLFZXSKZDGZAJZYCXOLUCZIZKZYFDYEYIDGAYGUDWKYGFZYD
      YIDYJXSYHYCWKYGXOUEUFUGUHYCYHLYGILUKUIXOLYGULUJUMYAYEAXTYDDXRYCXSYCXQAXOU
      NVDUOUPUQURXIYAXMAABAMZXIXTXLDBABBMXIXRXSBXIXQBXIXPBAYKXIBWKXOABUSZXIBXOU
      TZNVAVBXIBXOWKYMYLNVCXIXOWLFZXTXLOXIYNTZXRXKXSXCYOXQXJYOXIYNAGZTXQXJOZXIY
      NYPABDVEVFYPYQXIYPXPWRAYNAVGYNXPWROADBAVHVIPQVJVKYNXSXCOXIDBAVLQVMVOVNPVP
      WPXMXEAACARWPXLXDBACBRWPXBXKXCWPXAXKAWPWSWTXKWPWRHZCGZYRAGZWSHXKYSYTKCAYR
      CAVQVRWRCSWRASVSWPWTXKACBVTWAWBWCWDWEWHWFWGXHWIWJ $.
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( Lemma for the Axiom of Power Sets with no distinct variable conditions.
       (Contributed by NM, 4-Jan-2002.)  (Proof shortened by Mario Carneiro,
       10-Dec-2016.) $)
    axpowndlem4 $p |- ( -. A. y y = x -> ( -. A. y y = z -> ( -. x = y
      -> E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) ) $=
      ( vw weq wal wn wel wi nfnae nfan cv wnfc adantr nfcvd nfeqd nfeld adantl
      wex wb axpowndlem3 ax-gen nfcvf nfnd nfv nfexd nfald nfimd equequ2 notbid
      wa nfcvf2 nfan1 elequ2 exbid biidd cbvald imbi12d albid elequ1 ex 19.21bi
      a1i mpbii ) BAEBFGZBCEBFGZABEZGZABHZCSZACHZBFZIZAFZBAHZIZBFZASZIZVEVFUKZV
      SBVTADEZGZADHZCSZVKDFZIZAFZDAHZIZDFZASZIZDFVSBFWLDADCUAUBVTWLVSDBVEVFBBAB
      JBCBJKZVTWBWKBVTWABVTBALZDLZVEBWNMVFBAUCNZVTBWOOZPUDVTWJBAVEVFABAAJBCAJKZ
      VTWIBDVTDUEZVTWGWHBVTWFBAWRVTWDWEBVTWCBCVEVFCBACJBCCJKZVTBWNWOWPWQQUFVTVK
      BDWSVTBWNCLZWPVFBXAMVEBCUCRQZUGUHUGVTBWOWNWQWPQUHZUGUFUHVTDBEZWLVSTVTXDUK
      ZWBVHWKVRXDWBVHTVTXDWAVGDBAUIUJRVTWKVRTXDVTWJVQAWRVTWIVPDBWMXCVTXDWIVPTXE
      WGVNWHVOXEWFVMAVTXDAWRVTAWOBLZVTAWOOVEAXFMVFBAULNPUMXEWDVJWEVLXEWCVICVTXD
      CWTVTCWOXFVTCWOOVFCXFMVEBCULRPUMXDWCVITVTDBAUNRUOVTWEVLTXDVTVKVKDBWMXBXDV
      KVKTIVTXDVKUPVCUQNURUSXDWHVOTVTDBAUTRURVAUQUONURVAUQVDVBVA $.
  $}

  ${
    $d x w $.  $d y w $.
    $( A version of the Axiom of Power Sets with no distinct variable
       conditions.  (Contributed by NM, 4-Jan-2002.) $)
    axpownd $p |- ( -. x = y ->
               E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) $=
      ( vw weq wal wn wel wex wi axpowndlem4 axpowndlem1 aecoms a1d wa cv 19.8a
      wb syl alnex nfnae nfae nfan el nfcvf2 nfcvd nfeld elequ2 a1i mpbii df-ex
      cbvexd sylib adantr biidd dral1 3bitr3g nd2 mtt bitrd dral2 mtbid pm2.21d
      adantl alrimi ex pm2.61i pm2.61ii ) BAEBFBCEBFZABEZGZABHZCIZACHBFZJZAFZBA
      HZJZBFZAIZJZABCKWAABABCLZMVJAFZVIWAJWCWAVIWBNWCGZVIWAWDVIOZVTVKWEVSVTWEVR
      BWDVIBABBUAZBCBUBUCWEVPVQWEVLBIZGZAFZVPWDWIGZVIWDWGAIZWJWDWGWKWDADHZDIWGA
      DUDWDWLVLDBWFWDBAPDPZABUEWDBWMUFUGDBEWLVLRJWDDBAUHUIULUJWGAQSWGAUKUMUNVIW
      IVPRWDWHVOBCAVIWHVMGZVOVIVLGZBFWOCFWHWNWOWOBCVIWOUOUPVLBTVLCTUQVIVNGWNVOR
      BCAURVNVMUSSUTVAVDVBVCVEVSAQSNVFVGVH $.
  $}

$(
  @{
    @d x z @.  @d y z @.
    axpowndNEWlem1 @p  |- ( A. x x = y ->
        ( ( A. x x = y -> E. z A. x ( E. z z e. y -> x e. z ) )
         -> E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) ) @=
      ( weq wal wel wex wi cv csn c0 wceq wn wcel wa en2lp vex snid biantru
      mtbir snnzOLD a1bi mtbi neq0 imbi1i albii bicomi snex eqeq1 notbid eleq1
    imbi12d spcv sylbi mto hbae wb elequ2 sps exbidv imbi1d albidh mtbii nexdv
     pm2.21d a2i com12 ) ABDZAEZCBFZCGZACFZHZAEZCGZHVIABFCGVLBEHAEBAFHBEAGZVIVO
      VPVIVOVPVIVNCVICAFZCGZVLHZAEZVNVTCIZJZKLZMZWBWANZHZWEWFWEWEWAWBNZOWBWAPWG
      WEWACQZRSTWDWEWAWHUAUBUCVTAIZKLZMZVLHZAEZWFWMVTWLVSAWKVRVLCWIUDUEUFUGWLWF
      AWBWAUHWIWBLZWKWDVLWEWNWJWCWIWBKUIUJWIWBWAUKULUMUNUOVIVSVMAABAUPVIVRVKVLV
      IVQVJCVHVQVJUQAABCURUSUTVAVBVCVDVEVFVG @.
  @}

  @{
    @d x w @.  @d y w @.
   axpowndNEW @p  |- ( ( A. x x = y -> E. z A. x ( E. z z e. y -> x e. z ) ) ->
               E. x A. y ( A. x ( E. z x e. y -> A. y x e. z ) -> y e. x ) ) @=
?@.
  @}
$)

  $( Lemma for the Axiom of Regularity with no distinct variable conditions.
     (Contributed by NM, 3-Jan-2002.) $)
  axregndlem1 $p |- ( A. x x = z -> ( x e. y ->
               E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) ) $=
    ( wel wex weq wal wn wi wa 19.8a nfae elirrv elequ1 mtbii sps alrimi anim2i
    pm2.21d expcom eximd syl5 ) ABDZUCAEACFZAGZUCCADZCBDHZIZCGZJZAEUCAKUEUCUJAA
    CALUCUEUJUEUIUCUEUHCACCLUEUFUGUDUFHAUDAADUFAMACANOPSQRTUAUB $.

  ${
    $d x w $.  $d z y w $.
    $( Lemma for the Axiom of Regularity with no distinct variable conditions.
       (Contributed by NM, 3-Jan-2002.)  (Proof shortened by Mario Carneiro,
       10-Dec-2016.) $)
    axregndlem2 $p |- ( x e. y ->
                 E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) $=
      ( vw weq wal wel wn wi wa wex nfnae nfan cv nfcvd wnfc nfcvf nfeld wb ex
      axreg2 ax-gen adantr nfv adantl nfnd nfimd nfald nfand nfexd simpr eleq1d
      nfcvf2 nfeqd nfan1 eleq2d imbi1d albid anbi12d cbvexd cbvald mpbii elirrv
      imbi12d 19.21bi elequ2 mtbii sps pm2.21d axregndlem1 pm2.61ii ) ABEZAFZAC
      EAFZABGZVOCAGZCBGZHZIZCFZJZAKZIZVMHZVNHZWCWDWEJZWCAWFDBGZWGCDGZVRIZCFZJZD
      KZIZDFWCAFWMDDBCUAUBWFWMWCDAWDWEAABALACALMZWFWGWLAWFADNZBNZWFAWOOZWDAWPPW
      EABQUCZRZWFWKADWFDUDWFWGWJAWSWFWIACWDWECABCLACCLMZWFWHVRAWFACNZWOWEAXAPWD
      ACQUEZWQRWFVQAWFAXAWPXBWRRUFUGUHUIZUJUGWFDAEZWMWCSWFXDJZWGVOWLWBXEWOANZWP
      WFXDUKZULZWFWLWBSXDWFWKWADAWNXCWFXDWKWASXEWGVOWJVTXHXEWIVSCWFXDCWTWFCWOXF
      WFCWOOWECXFPWDACUMUEUNUOXEWHVPVRXEWOXFXAXGUPUQURUSTUTUCVDTVAVBVETVMVOWBVL
      VOHAVLAAGVOAVCABAVFVGVHVIABCVJVK $.
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A version of the Axiom of Regularity with no distinct variable
       conditions.  (Contributed by NM, 3-Jan-2002.) $)
    axregnd $p |- ( x e. y ->
                 E. x ( x e. y /\ A. z ( z e. x -> -. z e. y ) ) ) $=
      ( vw weq wal wel wn wi wa wex axregndlem2 nfnae nfan cv wnfc nfcvf adantr
      nfcrd elequ1 adantl nfnd nfimd wb notbid imbi12d a1i cbvald anbi2d syl5ib
      exbid ex axregndlem1 aecoms 19.8a nfae elirrv elequ2 mtbii sps a1d anim2i
      a5i expcom eximd syl5 pm2.61ii ) CAECFZCBEZCFZABGZVKCAGZCBGZHZIZCFZJZAKZI
      ZVHHZVJHZVSVKVKDAGZDBGZHZIZDFZJZAKVTWAJZVRABDLWHWGVQAVTWAACAAMCBAMNWHWFVP
      VKWHWEVODCVTWACCACMCBCMNWHWBWDCWHCDAOZVTCWIPWACAQRSWHWCCWHCDBOZWACWJPVTCB
      QUASUBUCDCEZWEVOUDIWHWKWBVLWDVNDCATWKWCVMDCBTUEUFUGUHUIUKUJULVSACABCUMUNV
      KVKAKVJVRVKAUOVJVKVQACBAUPVKVJVQVJVPVKVIVOCVJVNVLVIVNCVICCGVMCUQCBCURUSUT
      VAVCVBVDVEVFVG $.
  $}

  ${
    $d x w $.  $d z y w $.
    $( Lemma for the Axiom of Infinity with no distinct variable conditions.
       (New usage is discouraged.)  (Contributed by NM, 5-Jan-2002.) $)
    axinfndlem1 $p |- ( A. x y e. z -> E. x ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) ) $=
      ( vw weq wal wel wa wex wi wn nfnae nfan cv wnfc nfcvf adantr nfcvd nfeld
      adantl zfinf nfand nfexd nfimd nfald wb simpr eleq2d nfcvf2 elequ2 anbi2d
      nfeqd nfan1 exbid imbi12d albid anbi12d cbvexd mpbii a1d pm2.21d pm2.61ii
      ex nd1 nd2 ) ABEAFZACEAFZBCGZAFZBAGZVJVHCAGZHZCIZJZBFZHZAIZJZVFKZVGKZVRVS
      VTHZVQVIWABDGZWBVHCDGZHZCIZJZBFZHZDIVQDBCUAWAWHVPDAVSVTAABALACALMWAWBWGAW
      AABNZDNZVSAWIOVTABPQZWAAWJRZSZWAWFABVSVTBABBLACBLMZWAWBWEAWMWAWDACVSVTCAB
      CLACCLMZWAVHWCAWAAWICNZWKVTAWPOVSACPTZSWAAWPWJWQWLSUBUCUDUEUBWADAEZWHVPUF
      WAWRHZWBVJWGVOWSWJANZWIWAWRUGUHZWSWFVNBWAWRBWNWABWJWTWABWJRVSBWTOVTABUIQU
      LUMWSWBVJWEVMXAWSWDVLCWAWRCWOWACWJWTWACWJRVTCWTOVSACUITULUMWRWDVLUFWAWRWC
      VKVHDACUJUKTUNUOUPUQVCURUSUTVCVFVIVQABCVDVAVGVIVQACBVEVAVB $.
  $}

  ${
    $d x w $.  $d y w $.  $d z w $.
    $( A version of the Axiom of Infinity with no distinct variable
       conditions.  (New usage is discouraged.)  (Contributed by NM,
       5-Jan-2002.) $)
    axinfnd $p |- E. x ( y e. z -> ( y e. x /\
                 A. y ( y e. x -> E. z ( y e. z /\ z e. x ) ) ) ) $=
      ( vw wel wa wex wi wal weq wn nfnae nfan cv nfcvd wnfc nfeld adantr wb ex
      axinfndlem1 ax-gen nfcvf adantl nfald nfand nfexd nfimd nfeqd nfan1 simpr
      nfcvf2 eleq1d albid anbi1d exbid imbi12d cbvald anbi12d mpbii 19.21bi nd1
      aecoms pm2.21d nd3 pm2.61ii 19.35ri ) BCEZBAEZVIVHCAEZFZCGZHZBIZFZABAJBIZ
      BCJBIZVHAIZVOAGZHZVPKZVQKZVTWAWBFZVTBWCDCEZAIZDAEZWFWDVJFZCGZHZDIZFZAGZHZ
      DIVTBIWMDADCUAUBWCWMVTDBWAWBBBABLBCBLMZWCWEWLBWCWDBAWAWBABAALBCALMZWCBDNZ
      CNZWCBWPOZWBBWQPWABCUCUDZQZUEWCWKBAWOWCWFWJBWCBWPANZWRWABXAPWBBAUCRZQZWCW
      IBDWAWBDBADLBCDLMWCWFWHBXCWCWGBCWAWBCBACLBCCLMZWCWDVJBWTWCBWQXAWSXBQUFUGU
      HZUEUFUGUHWCDBJZWMVTSWCXFFZWEVRWLVSXGWDVHAWCXFAWOWCAWPBNZWCAWPOWAAXHPWBBA
      ULRUIUJZXGWPXHWQWCXFUKZUMZUNXGWKVOAXIXGWFVIWJVNXGWPXHXAXJUMZWCWJVNSXFWCWI
      VMDBWNXEWCXFWIVMSXGWFVIWHVLXLXGWGVKCWCXFCXDWCCWPXHWCCWPOWBCXHPWABCULUDUIU
      JXGWDVHVJXKUOUPUQTURRUSUPUQTURUTVATVPVRVSVRKABABCVBVCVDVQVRVSBCAVEVDVFVG
      $.
  $}

  $( Lemma for the Axiom of Choice with no distinct variable conditions.
     (Contributed by NM, 3-Jan-2002.) $)
  axacndlem1 $p |- ( A. x x = y ->
            E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y ( E. w
          ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) ) $=
    ( weq wal wel wa wex wb nfae simpl alimi nd1 pm2.21d syl5 alrimi 19.8a syl
    wi ) ABEAFZBCGZCDGZHZAFZUDBDGDAGHHDIBDEJBFDIZTZCFZBFZUIAIUAUHBABBKUAUGCABCK
    UEUBAFZUAUFUDUBAUBUCLMUAUJUFABCNOPQQUIARS $.

  $( Lemma for the Axiom of Choice with no distinct variable conditions.
     (Contributed by NM, 3-Jan-2002.) $)
  axacndlem2 $p |- ( A. x x = z ->
            E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y ( E. w
          ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) ) $=
    ( weq wal wel wa wex wb nfae simpr alimi nd1 pm2.21d syl5 alrimi 19.8a syl
    wi ) ACEAFZBCGZCDGZHZAFZUDBDGDAGHHDIBDEJBFDIZTZCFZBFZUIAIUAUHBACBKUAUGCACCK
    UEUCAFZUAUFUDUCAUBUCLMUAUJUFACDNOPQQUIARS $.

  $( Lemma for the Axiom of Choice with no distinct variable conditions.
     (Contributed by NM, 3-Jan-2002.) $)
  axacndlem3 $p |- ( A. y y = z ->
            E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y ( E. w
          ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) ) $=
    ( weq wal wel wa wex wb nfae simpl alimi nd3 pm2.21d syl5 alrimi a5i 19.8a
    wi syl ) BCEZBFZBCGZCDGZHZAFZUFBDGDAGHHDIBDEJBFDIZTZCFZBFZUKAIUBUJBUCUICBCC
    KUGUDAFZUCUHUFUDAUDUELMUCULUHBCANOPQRUKASUA $.

  ${
    $d x v $.  $d y z w v $.
    $( Lemma for the Axiom of Choice with no distinct variable conditions.
       (New usage is discouraged.)  (Contributed by NM, 8-Jan-2002.)  (Proof
       shortened by Mario Carneiro, 10-Dec-2016.) $)
    axacndlem4 $p |- E. x A. y A. z ( A. x ( y e. z /\ z e. w ) ->
              E. w A. y ( E. w ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) )
                     <-> y = w ) ) $=
      ( vv weq wal wel wa wex wb wi wn nfnae nf3an cv wnfc nfeld nfcvd nfeqd sp
      w3a nfcvf 3ad2ant2 3ad2ant1 3ad2ant3 nfand nfexd nfbid nfald nfimd nfcvf2
      zfac nfan1 nfrd adantr impbid1 simpr eleq2d anbi2d exbid albid imbi12d ex
      bibi1d cbvexd mpbii 3exp axacndlem2 axacndlem1 nfae alimi nd2 syl5 alrimi
      pm2.21d 19.8a syl pm2.61iii ) ACFAGZABFAGZADFAGZBCHZCDHZIZAGZWEBDHZDAHZIZ
      IZDJZBDFZKZBGZDJZLZCGZBGZAJZVTMZWAMZWBMZWSWTXAXBUBZWEWEWGDEHZIZIZDJZWLKZB
      GZDJZLZCGZBGZEJWSEBCDUMXCXMWREAWTXAXBAACANABANADANOXCXLABWTXAXBBACBNABBNA
      DBNOZXCXKACWTXAXBCACCNABCNADCNOZXCWEXJAXCWCWDAXCABPZCPZXAWTAXPQXBABUCUDZW
      TXAAXQQXBACUCUEZRXCAXQDPZXSXBWTAXTQXAADUCUFZRUGZXCXIADWTXAXBDACDNABDNADDN
      OZXCXHABXNXCXGWLAXCXFADYCXCWEXEAYBXCWGXDAXCAXPXTXRYARXCAXTEPZYAXCAYDSRUGU
      GUHXCAXPXTXRYATUIUJUHUKUJUJXCEAFZXMWRKXCYEIZXLWQBXCYEBXNXCBYDAPZXCBYDSXAW
      TBYGQXBABULUDTUNZYFXKWPCXCYECXOXCCYDYGXCCYDSWTXACYGQXBACULUETUNYFWEWFXJWO
      YFWEWFXCWEWFLYEXCWEAYBUOUPWEAUAUQYFXIWNDXCYEDYCXCDYDYGXCDYDSXBWTDYGQXAADU
      LUFTUNZYFXHWMBYHYFXGWKWLYFXFWJDYIYFXEWIWEYFXDWHWGYFYDYGXTXCYEURUSUTUTVAVE
      VBVAVCVBVBVDVFVGVHABCDVIABCDVJWBWRWSWBWQBADBVKWBWPCADCVKWFWDAGZWBWOWEWDAW
      CWDURVLWBYJWOADCVMVPVNVOVOWRAVQVRVS $.
  $}

  ${
    $d x v $.  $d y v $.  $d z w v $.
    $( Lemma for the Axiom of Choice with no distinct variable conditions.
       (New usage is discouraged.)  (Contributed by NM, 3-Jan-2002.)  (Proof
       shortened by Mario Carneiro, 10-Dec-2016.) $)
    axacndlem5 $p |- E. x A. y A. z ( A. x ( y e. z /\ z e. w ) ->
              E. w A. y ( E. w ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) )
                     <-> y = w ) ) $=
      ( vv weq wal wel wa wex wb wn nfnae nf3an cv nfcvd wnfc nfcvf nfeld nfeqd
      wi w3a axacndlem4 3ad2ant1 3ad2ant3 nfand nfald nfv 3ad2ant2 nfexd nfcvf2
      nfbid nfimd nfan1 simpr eleq1d anbi1d albid anbi12d eqeq1d bibi12d cbvald
      exbid adantr imbi12d mpbii 3exp axacndlem3 axacndlem1 aecoms en2lp elequ2
      ex nfae anbi2d mtbii sps pm2.21d spsd alrimi a5i 19.8a syl pm2.61iii ) BC
      FBGZBAFBGZBDFZBGZBCHZCDHZIZAGZWKBDHZDAHZIZIZDJZWGKZBGZDJZUAZCGZBGZAJZWELZ
      WFLZWHLZXDXEXFXGUBZECHZWJIZAGZXJEDHZWNIZIZDJZEDFZKZEGZDJZUAZCGZEGZAJXDAEC
      DUCXHYBXCAXEXFXGABCAMBAAMBDAMNZXHYAXBEBXEXFXGBBCBMBABMBDBMNZXHXTBCXEXFXGC
      BCCMBACMBDCMNZXHXKXSBXHXJBAYCXHXIWJBXHBEOZCOZXHBYFPZXEXFBYGQXGBCRUDZSXHBY
      GDOZYIXGXEBYJQXFBDRUEZSUFZUGXHXRBDXEXFXGDBCDMBADMBDDMNZXHXQBEXHEUHXHXOXPB
      XHXNBDYMXHXJXMBYLXHXLWNBXHBYFYJYHYKSXHBYJAOZYKXFXEBYNQXGBARUISUFUFUJXHBYF
      YJYHYKTULZUGUJUMUGXHEBFZYAXBKXHYPIZXTXACXHYPCYEXHCYFBOZXHCYFPXEXFCYRQXGBC
      UKUDTUNYQXKWLXSWTYQXJWKAXHYPAYCXHAYFYRXHAYFPXFXEAYRQXGBAUKUITUNYQXIWIWJYQ
      YFYRYGXHYPUOZUPUQZURXHXSWTKYPXHXRWSDYMXHXQWREBYDYOXHYPXQWRKYQXOWQXPWGYQXN
      WPDXHYPDYMXHDYFYRXHDYFPXGXEDYRQXFBDUKUETUNYQXJWKXMWOYTYQXLWMWNYQYFYRYJYSU
      PUQUSVCYQYFYRYJYSUTVAVMVBVCVDVEURVMVBVCVFVGABCDVHXDABABCDVIVJWHXCXDWGXBBW
      HXACBDCVNWHWKWTAWHWKWTWGWKLBWGWICBHZIWKYRYGVKWGUUAWJWIBDCVLVOVPVQVRVSVTWA
      XCAWBWCWD $.
  $}

  ${
    $d x v $.  $d y v $.  $d z v $.  $d w v $.
    $( A version of the Axiom of Choice with no distinct variable conditions.
       (New usage is discouraged.)  (Contributed by NM, 3-Jan-2002.)  (Proof
       shortened by Mario Carneiro, 10-Dec-2016.) $)
    axacnd $p |- E. x A. y A. z ( A. x ( y e. z /\ z e. w ) -> E. w A. y
       ( E. w ( ( y e. z /\ z e. w ) /\ ( y e. w /\ w e. x ) ) <-> y = w ) ) $=
      ( vv weq wal wel wa wex wb wn nfnae nf3an cv wnfc nfcvf nfcvd nfeld nfeqd
      axacndlem5 3ad2ant2 3ad2ant3 nfand nfald 3ad2ant1 nfexd nfbid nfimd nfan1
      w3a nfcvf2 simpr eleq2d eleq1d anbi12d albid anbi1d bibi1d imbi12d cbvald
      wi exbid ex mpbii 3exp axacndlem2 aecoms axacndlem3 nfae nd3 pm2.21d syl5
      alimi a5i alrimi 19.8a syl pm2.61iii ) CAFCGZCBFCGZCDFZCGZBCHZCDHZIZAGZWF
      BDHZDAHZIZIZDJZBDFZKZBGZDJZVBZCGZBGZAJZVTLZWALZWCLZWTXAXBXCUKZBEHZEDHZIZA
      GZXGWJIZDJZWMKZBGZDJZVBZEGZBGZAJWTABEDUAXDXPWSAXAXBXCACAAMCBAMCDAMNZXDXOW
      RBXAXBXCBCABMCBBMCDBMNZXDXNWQECXAXBXCCCACMCBCMCDCMNXDXHXMCXDXGCAXQXDXEXFC
      XDCBOZEOZXBXACXSPXCCBQUBZXDCXTRZSXDCXTDOZYBXCXACYCPXBCDQUCZSUDZUEXDXLCDXA
      XBXCDCADMCBDMCDDMNZXDXKCBXRXDXJWMCXDXICDYFXDXGWJCYEXDWHWICXDCXSYCYAYDSXDC
      YCAOZYDXAXBCYGPXCCAQUFSUDUDUGXDCXSYCYAYDTUHUEUGUIXDECFZXNWQKXDYHIZXHWGXMW
      PYIXGWFAXDYHAXQXDAXTCOZXDAXTRXAXBAYJPXCCAULUFTUJYIXEWDXFWEYIXTYJXSXDYHUMZ
      UNYIXTYJYCYKUOUPZUQYIXLWODXDYHDYFXDDXTYJXDDXTRXCXADYJPXBCDULUCTUJZYIXKWNB
      XDYHBXRXDBXTYJXDBXTRXBXABYJPXCCBULUBTUJYIXJWLWMYIXIWKDYMYIXGWFWJYLURVCUSU
      QVCUTVDVAUQVCVEVFWTACABCDVGVHWTBCABCDVIVHWCWSWTWCWRBCDBVJWBWQCWGWEAGZWCWP
      WFWEAWDWEUMVNWCYNWPCDAVKVLVMVOVPWSAVQVRVS $.
  $}

  ${
    $d x y z w v u t $.
    $( Axiom of Extensionality ~ ax-ext , reproved from conditionless ZFC
       version and predicate calculus.  (Contributed by NM, 15-Aug-2003.)
       (Proof modification is discouraged.) $)
    zfcndext $p |- ( A. z ( z e. x <-> z e. y ) -> x = y ) $=
      ( cv wcel wb wceq axextnd 19.36aiv ) CDZADZEJBDZEFKLGCCABHI $.

    $( Axiom of Replacement ~ ax-rep , reproved from conditionless ZFC axioms.
       (Contributed by NM, 15-Aug-2003.)
       (Proof modification is discouraged.) $)
    zfcndrep $p |- ( A. w E. y A. z ( A. y ph -> z = y ) ->
                     E. y A. z ( z e. y <-> E. w ( w e. x /\ A. y ph ) ) ) $=
      ( wal cv wceq wi wex wcel wa wb nfe1 nfv nfa1 nfex nfbi 19.3 exbii elequ2
      nfan nfal anbi1d exbidv bibi2d albidv imbi2d axrepnd anbi1i bibi12i albii
      nfim imbi2i mpbi chvar 19.35i anbi2i a1i bibi12d cbvex sylib ) ACFZDGZCGZ
      HIDFZCJZEFVDEGZKZVHBGZKZVCCFZLZEJZMZDFZEJVDVEKZVKVCLZEJZMZDFZCJVGVPEVGVIV
      HVEKZVLLZEJZMZDFZIZEJZVGVPIZEJCBWICEVGVPCVFCNVOCDVIVNCVICOZVMCEVKVLCVKCOV
      CCPUBQRUCZUMQVEVJHZWGWIEWLWFVPVGWLWEVODWLWDVNVIWLWCVMEWLWBVKVLCBEUAUDUEUF
      UGUHUEVGVICFZWBDFZVLLZEJZMZDFZIZEJWHVCECDUIWSWGEWRWFVGWQWEDWMVIWPWDVICWJS
      WOWCEWNWBVLWBDWBDOSUJTUKULUNTUOUPUQVPWAECWKVTEDVQVSEVQEOVRENRUCVHVEHZVOVT
      DWTVIVQVNVSECDUAVNVSMWTVMVREVLVCVKVCCACPSURTUSUTUGVAVB $.

    $( Axiom of Union ~ ax-un , reproved from conditionless ZFC axioms.
       (Contributed by NM, 15-Aug-2003.)
       (Proof modification is discouraged.) $)
    zfcndun $p |- E. y A. z ( E. w ( z e. w /\ w e. x ) -> z e. y ) $=
      ( cv wcel wa wex wi axunnd wceq elequ2 elequ1 anbi12d cbvexv imbi1i albii
      wal exbii mpbir ) CEZDEZFZUBAEZFZGZDHZUABEZFZIZCRZBHUIUHUDFZGZBHZUIIZCRZB
      HBCAJUKUPBUJUOCUGUNUIUFUMDBUBUHKUCUIUEULDBCLDBAMNOPQST $.

    $( Axiom of Power Sets ~ ax-pow , reproved from conditionless ZFC axioms.
       The proof uses the "Axiom of Twoness," ~ dtru .  (Contributed by NM,
       15-Aug-2003.)  (Proof modification is discouraged.) $)
    zfcndpow $p |- E. y A. z ( A. w ( w e. z -> w e. x ) -> z e. y ) $=
      ( cv wcel wi wal wceq wn dtru exnal mpbir nfe1 axpownd albii imbi1i exbii
      wex elequ1 exlimi ax-mp 19.9v nfv 19.3 imbi12i mpbi imbi12d cbvalv ) DEZC
      EZFZUJAEZFZGZDHZUKBEZFZGZCHZBSUQUKFZUQUMFZGZBHZURGZCHZBSZVAASZVBCHZGZBHZU
      RGZCHZBSZVGUQUKIZJZBSZVNVQVOBHJBCKVOBLMVPVNBVMBNBCAOUAUBVMVFBVLVECVKVDURV
      JVCBVHVAVIVBVAAUCVBCVBCUDUEUFPQPRUGUTVFBUSVECUPVDURUOVCDBUJUQIULVAUNVBDBC
      TDBATUHUIQPRM $.

    $( Axiom of Regularity ~ ax-reg , reproved from conditionless ZFC axioms.
       (Contributed by NM, 15-Aug-2003.)
       (Proof modification is discouraged.) $)
    zfcndreg $p |- ( E. y y e. x ->
                 E. y ( y e. x /\ A. z ( z e. y -> -. z e. x ) ) ) $=
      ( cv wcel wn wi wal wa wex nfe1 axregnd exlimi ) BDZADZEZPCDZNEQOEFGCHIZB
      JBRBKBACLM $.

    $( Axiom of Infinity ~ ax-inf , reproved from conditionless ZFC axioms.
       Since we have already reproved Extensionality, Replacement, and Power
       Sets above, we are justified in referencing theorem ~ el in the proof.
       (New usage is discouraged.)  (Proof modification is discouraged.)
       (Contributed by NM, 15-Aug-2003.) $)
    zfcndinf $p |- E. y ( x e. y /\
                 A. z ( z e. y -> E. w ( z e. w /\ w e. y ) ) ) $=
      ( cv wcel wa wex wal nfv nfe1 nfim nfal nfan nfex axinfnd 19.37aiv elequ1
      wi el exlimi ax-mp wceq anbi1d exbidv imbi12d cbvalv anbi2i exbii mpbir )
      AEZBEZFZCEZULFZUNDEZFZUPULFZGZDHZSZCIZGZBHUMUMUKUPFZURGZDHZSZAIZGZBHZVDDH
      VJADTVDVJDVIDBUMVHDUMDJZVGDAUMVFDVKVEDKLMNOVDVIBBADPQUAUBVCVIBVBVHUMVAVGC
      AUNUKUCZUOUMUTVFCABRVLUSVEDVLUQVDURCADRUDUEUFUGUHUIUJ $.

    $( Axiom of Choice ~ ax-ac , reproved from conditionless ZFC axioms.
       (Contributed by NM, 15-Aug-2003.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    zfcndac $p |- E. y A. z A. w ( ( z e. w /\ w e. x ) -> E. v A. u ( E. t
              ( ( u e. w /\ w e. t ) /\ ( u e. t /\ t e. y ) ) <-> u = v ) ) $=
      ( cv wcel wa wex wceq wb wal wi 2albii exbii elequ2 elequ1 anbi12d axacnd
      19.3 imbi1i mpbi equequ2 bibi2d anbi2d cbvexv bibi1i syl6bb albidv anbi1d
      nfv exbidv equequ1 bibi12d cbvalv imbi2i mpbir ) CHZDHZIZVAAHZIZJZFHZVAIZ
      VAGHZIZJZVFVHIZVHBHZIZJZJZGKZVFEHZLZMZFNZEKZOZDNCNZBKVEVEUTVCIZVCVLIZJZJZ
      AKZUTVCLZMZCNZAKZOZDNCNZBKZVEBNZWLOZDNCNZBKWOBCDAUAWRWNBWQWMCDWPVEWLVEBVE
      BUMUBUCPQUDWCWNBWBWMCDWAWLVEVTWKEAVQVCLZVTVGVDJZVFVCIZWEJZJZAKZVFVCLZMZFN
      WKWSVSXFFWSVSVPXEMXFWSVRXEVPEAFUEUFVPXDXEVOXCGAVHVCLZVJWTVNXBXGVIVDVGGADR
      UGXGVKXAVMWEGAFRGABSTTUHUIUJUKXFWJFCVFUTLZXDWHXEWIXHXCWGAXHWTVEXBWFXHVGVB
      VDFCDSULXHXAWDWEFCASULTUNFCAUOUPUQUJUHURPQUS $.
  $}

$(
  @{
    @d x y z w @.
    zfcndpowNEW @p  |- E. x A. y ( A. x ( x e. y -> x e. z ) -> y e. x ) @=
     ( wel wi wal wex weq wa wb zfcndrep hbae 19.9rOLD equid a1bi albii exbii
       bitri
      imbi1i mpbir 19.37 mpbi ax-gen biantru bibi2i bicomi bi2 sylbi alimi
      eximi syl axpowndNEW ax-mp 19.9rvOLD ax-17 19.3rOLD imbi12i )
      ABDZACDZEZAFZBADZE
      ZBFZAGURCGZUSBFZEZAFZVBEZBFZAGZABHZAFZCBDZCGZUSEZAFZCGZEVKVMUSVNAAHZBFZIZ
      CGZJZAFZCGZVRVMWDEZCGZVMWEEWGVSVLEZAFZBGZWDEZCGVSCBAKWFWKCVMWJWDVMVMBGWJV
      MBABBLMVMWIBVLWHAVSVLANZOPQRSQTVMWDCABCLUAUBWDVQCWCVPAWCUSVOJZVPWMWCVOWBU
      SVNWACVTVNVSBWLUCUDQUEUFUSVOUGUHUIUJUKABCULUMVDVJAVCVIBVAVHVBUTVGAURVEUSV
      FURCUNUSBUSBUOUPUQPSPQT @.
  @}
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 The Generalized Continuum Hypothesis
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Sets satisfying the Generalized Continuum Hypothesis
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GCH $.

  $( Extend class notation to include the collection of sets that satisfy the
     GCH. $)
  cgch $a class GCH $.

  ${
    $d x y $.
    $( Define the collection of "GCH-sets", or sets for which the generalized
       continuum hypothesis holds.  In this language the generalized continuum
       hypothesis can be expressed as ` GCH = _V ` .  A set ` x ` satisfies the
       generalized continuum hypothesis if it is finite or there is no set
       ` y ` strictly between ` x ` and its powerset in cardinality.  The
       continuum hypothesis is equivalent to ` om e. GCH ` .  (Contributed by
       Mario Carneiro, 15-May-2015.) $)
    df-gch $a |- GCH = ( Fin u. { x | A. y -. ( x ~< y /\ y ~< ~P x ) } ) $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Elementhood in the collection of GCH-sets.  (Contributed by Mario
       Carneiro, 15-May-2015.) $)
    elgch $p |- ( A e. V -> ( A e. GCH <-> ( A e. Fin \/
      A. x -. ( A ~< x /\ x ~< ~P A ) ) ) ) $=
      ( vy cgch wcel cfn cv csdm wbr cpw wa wn wal cab cun df-gch eleq2i elun
      wo bitri wceq breq1 pweq breq2d anbi12d notbid albidv elabg orbi2d syl5bb
      ) BEFZBGFZBDHZAHZIJZUOUNKZIJZLZMZANZDOZFZTZBCFZUMBUOIJZUOBKZIJZLZMZANZTUL
      BGVBPZFVDEVLBDAQRBGVBSUAVEVCVKUMVAVKDBCUNBUBZUTVJAVMUSVIVMUPVFURVHUNBUOIU
      CVMUQVGUOIUNBUDUEUFUGUHUIUJUK $.

    $( A finite set is a GCH-set.  (Contributed by Mario Carneiro,
       15-May-2015.) $)
    fingch $p |- Fin C_ GCH $=
      ( vx vy cfn cv csdm wbr cpw wa wn wal cab cun cgch ssun1 df-gch sseqtr4i
      ) CCADZBDZEFRQGEFHIBJAKZLMCSNABOP $.

    $( The only GCH-sets which have other sets between it and its power set are
       finite sets.  (Contributed by Mario Carneiro, 15-May-2015.) $)
    gchi $p |- ( ( A e. GCH /\ A ~< B /\ B ~< ~P A ) -> A e. Fin ) $=
      ( vx cgch wcel csdm wbr cpw cfn wa cv wal wex cvv relsdom brrelexi adantl
      wn wceq breq2 breq1 anbi12d spcegv mpcom df-ex sylib elgch ibi orcomd ord
      wo syl5 3impib ) ADEZABFGZBAHZFGZAIEZUOUQJZACKZFGZUTUPFGZJZRCLZRZUNURUSVC
      CMZVEBNEZUSVFUQVGUOBUPFOPQVCUSCBNUTBSVAUOVBUQUTBAFTUTBUPFUAUBUCUDVCCUEUFU
      NVDURUNURVDUNURVDUKCADUGUHUIUJULUM $.

    $( If ` A <_ B < ~P A ` , and ` A ` is an infinite GCH-set, then ` A = B `
       in cardinality.  (Contributed by Mario Carneiro, 15-May-2015.) $)
    gchen1 $p |- ( ( ( A e. GCH /\ -. A e. Fin ) /\ ( A ~<_ B /\ B ~< ~P A ) )
      -> A ~~ B ) $=
      ( cgch wcel cfn wn wa cdom wbr cpw csdm simprl gchi 3com23 3expia con3and
      cen an32s adantrl bren2 sylanbrc ) ACDZAEDZFZGZABHIZBAJKIZGGUFABKIZFZABQI
      UEUFUGLUEUGUIUFUBUGUDUIUBUGGUHUCUBUGUHUCUBUHUGUCABMNOPRSABTUA $.

    $( If ` A < B <_ ~P A ` , and ` A ` is an infinite GCH-set, then
       ` B = ~P A ` in cardinality.  (Contributed by Mario Carneiro,
       15-May-2015.) $)
    gchen2 $p |- ( ( ( A e. GCH /\ -. A e. Fin ) /\ ( A ~< B /\ B ~<_ ~P A ) )
      -> B ~~ ~P A ) $=
      ( cgch wcel cfn wn csdm wbr cpw cdom cen simprr gchi 3expia con3and an32s
      wa adantrr bren2 sylanbrc ) ACDZAEDZFZQZABGHZBAIZJHZQQUGBUFGHZFZBUFKHUDUE
      UGLUDUEUIUGUAUEUCUIUAUEQUHUBUAUEUHUBABMNOPRBUFST $.

    $( If ` A <_ B <_ ~P A ` , and ` A ` is an infinite GCH-set, then either
       ` A = B ` or ` B = ~P A ` in cardinality.  (Contributed by Mario
       Carneiro, 15-May-2015.) $)
    gchor $p |- ( ( ( A e. GCH /\ -. A e. Fin ) /\ ( A ~<_ B /\ B ~<_ ~P A ) )
      -> ( A ~~ B \/ B ~~ ~P A ) ) $=
      ( cgch wcel cfn wn wa cdom wbr cpw csdm cen wo simprr brdom2 sylib gchen1
      wi expr adantrr orim1d mpd ) ACDAEDFGZABHIZBAJZHIZGGZBUEKIZBUELIZMZABLIZU
      IMUGUFUJUCUDUFNBUEOPUGUHUKUIUCUDUHUKRUFUCUDUHUKABQSTUAUB $.

    $( The property of being a GCH-set is a cardinal invariant.  (Contributed
       by Mario Carneiro, 15-May-2015.) $)
    engch $p |- ( A ~~ B -> ( A e. GCH <-> B e. GCH ) ) $=
      ( vx cen wbr cfn wcel cv csdm cpw wa wn wal wo cgch syl cvv relen elgch
      wb enfi sdomen1 sdomen2 anbi12d notbid orbi12d brrelexi brrelex2i 3bitr4d
      pwen albidv ) ABDEZAFGZACHZIEZUNAJZIEZKZLZCMZNZBFGZBUNIEZUNBJZIEZKZLZCMZN
      ZAOGZBOGZULUMVBUTVHABUAULUSVGCULURVFULUOVCUQVEABUNUBULUPVDDEUQVETABUJUPVD
      UNUCPUDUEUKUFULAQGVJVATABDRUGCAQSPULBQGVKVITABDRUHCBQSPUI $.
  $}

  $( Under certain conditions, a GCH-set can demonstrate trichotomy of
     dominance.  Lemma for ~ gchac .  (Contributed by Mario Carneiro,
     15-May-2015.) $)
  gchdomtri $p |- ( ( A e. GCH /\ ( A +c A ) ~~ A /\ B ~<_ ~P A ) ->
    ( A ~<_ B \/ B ~<_ A ) ) $=
    ( cgch wcel ccda co cen wbr cpw cdom wo wa wn sdomdom cvv wb adantr cdadom3
    csdm syl2anc w3a cfn con3i reldom brrelexi 3ad2ant3 fidomtri2 sylan syl5ibr
    orrd simp1 simpr cdalepw 3adant1 gchor syl22anc cdacomen domentr syl5ibrcom
    sylancl domen2 imp olcd simpl1 canth2g 3syl simpl2 pwen enen2 adantl mpbird
    syl endom pwcdadom domtr orcd jaodan syldan pm2.61dan ) ACDZAAEFZAGHZBAIZJH
    ZUAZAUBDZABJHZBAJHZKZWEWFLZWGWHWGMWHWJABSHZMZWKWGABNUCWEBODZWFWHWLPWDVTWMWB
    BWCJUDUEUFZBAOUGUHUIUJWEWFMZAABEFZGHZWPWCGHZKZWIWEWOLVTWOAWPJHZWPWCJHZWSWEV
    TWOVTWBWDUKZQWEWOULWEWTWOWEVTWMWTXBWNABCORTQWEXAWOWBWDXAVTABUMUNQAWPUOUPWEW
    QWIWRWEWQLWHWGWEWQWHWEWHWQBWPJHZWEBBAEFZJHZXDWPGHXCWEWMVTXEWNXBBAOCRTBAUQBX
    DWPURUTAWPBVAUSVBVCWEWRLZWGWHXFAWCJHZWCBJHZWGXFVTAWCSHXGVTWBWDWRVDACVEAWCNV
    FXFWAIZWPGHZXIWPJHXHXFXJXIWCGHZXFWBXKVTWBWDWRVGWAAVHVLWRXJXKPWEWPWCXIVIVJVK
    XIWPVMABVNVFAWCBVOTVPVQVRVS $.

  ${
    $d u y B $.  $d a b r s t u v w x y z F $.  $d a b n r s t u v w x y z X $.
    $d r u w x y z M $.  $d r u w x y z N $.  $d a b n r s t u v w x y z ph $.
    $d a r s t w x z A $.  $d r u w x y z R $.  $d r u w x y z Y $.
    $d r u x y z S $.
    fpwwe2.1 $e |- W = { <. x , r >. | ( ( x C_ A /\ r C_ ( x X. x ) ) /\
      ( r We x /\ A. y e. x [. ( `' r " { y } ) / u ].
        ( u F ( r i^i ( u X. u ) ) ) = y ) ) } $.
    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 3-Jun-2015.) $)
    fpwwe2cbv $p |- W = { <. a , s >. | ( ( a C_ A /\ s C_ ( a X. a ) ) /\
      ( s We a /\ A. z e. a [. ( `' s " { z } ) / v ].
        ( v F ( s i^i ( v X. v ) ) ) = z ) ) } $=
      ( cv wss cxp wa wwe wceq wsbc weq cin co ccnv csn cima copab simpl sseq1d
      wral simpr xpeq12d sseq12d anbi12d weeq2 weeq1 sylan9bb id ineq2d oveq12d
      eqeq1d cbvsbcv sneq imaeq2d dfsbcq syl eqeq2 sbcbidv bitrd syl5bb cbvralv
      wb cnveqd imaeq1d ineq1d oveq2d raleqbidv cbvopabv eqtri ) HAMZFNZJMZVSVS
      OZNZPZVSWAQZEMZWAWFWFOZUAZGUBZBMZRZEWAUCZWJUDZUEZSZBVSUIZPZPZAJUFKMZFNZIM
      ZWSWSOZNZPZWSXAQZDMZXAXFXFOZUAZGUBZCMZRZDXAUCZXJUDZUEZSZCWSUIZPZPZKIUFLWR
      XRAJKIAKTZJITZPZWDXDWQXQYAVTWTWCXCYAVSWSFXSXTUGZUHYAWAXAWBXBXSXTUJZYAVSWS
      VSWSYBYBUKULUMYAWEXEWPXPXSWEWSWAQXTXEVSWSWAUNWSWAXAUOUPWPXFWAXGUAZGUBZXJR
      ZDWLXMUEZSZCVSUIYAXPWOYHBCVSWOYEWJRZDWNSZBCTZYHWKYIEDWNEDTZWIYEWJYLWFXFWH
      YDGYLUQZYLWGXGWAYLWFXFWFXFYMYMUKURUSUTVAYKYJYIDYGSZYHYKWNYGRYJYNVKYKWMXMW
      LWJXJVBVCYIDWNYGVDVEYKYIYFDYGWJXJYEVFVGVHVIVJYAYHXOCVSWSYBYAYHYFDXNSZXOYA
      YGXNRYHYOVKYAWLXLXMYAWAXAYCVLVMYFDYGXNVDVEYAYFXKDXNYAYEXIXJYAYDXHXFGYAWAX
      AXGYCVNVOUTVGVHVPVIUMUMVQVR $.

    $d a b n r s t u v w x y z W $.
    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    fpwwe2lem1 $p |- W C_ ( ~P A X. ~P ( A X. A ) ) $=
      ( cv wss cxp wa wwe cin copab cpw wcel vex elpw sylibr wceq ccnv csn cima
      wsbc wral simpll simplr xpss12 syl2anc sstrd jca ssopab2i df-xp 3sstr4i
      co ) AIZDJZGIZUQUQKZJZLUQUSMCIZUSVBVBKNEUPBIZUACUSUBVCUCUDUEBUQUFLZLZAGOU
      QDPZQZUSDDKZPZQZLZAGOFVFVIKVEVKAGVEVGVJVEURVGURVAVDUGZUQDARSTVEUSVHJVJVEU
      SUTVHURVAVDUHVEURURUTVHJVLVLUQDUQDUIUJUKUSVHGRSTULUMHAGVFVIUNUO $.

    fpwwe2.2 $e |- ( ph -> A e. _V ) $.
    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 19-May-2015.) $)
    fpwwe2lem2 $p |- ( ph -> ( X W R <-> ( ( X C_ A /\ R C_ ( X X. X ) ) /\
      ( R We X /\ A. y e. X [. ( `' R " { y } ) / u ].
        ( u F ( R i^i ( u X. u ) ) ) = y ) ) ) ) $=
      ( wss cxp wa wwe cv wceq cvv wcel wbr cin co ccnv csn cima wsbc wral wrel
      relopabi brrelex12 sylan adantr simprll ssexd xpexg syl2anc simprlr simpl
      a1i jca sseq1d simpr xpeq12d sseq12d anbi12d weeq2 sylan9bb ineq1d oveq2d
      weeq1 eqeq1d sbcbidv wb cnveqd dfsbcq syl bitrd raleqbidv brabga pm5.21nd
      imaeq1d ) AIFHUAZIEMZFIINZMZOZIFPZDQZFWIWINZUBZGUCZCQZRZDFUDZWMUEZUFZUGZC
      IUHZOZOZISTZFSTZOZAHUIZWCXDXEABQZEMZJQZXFXFNZMZOZXFXHPZWIXHWJUBZGUCZWMRZD
      XHUDZWPUFZUGZCXFUHZOZOZBJHKUJUTIFHUKULAXAOZXBXCYBIESAESTXALUMAWDWFWTUNUOZ
      YBFWESYBXBXBWESTYCYCIISSUPUQAWDWFWTURUOVAYAXABJIFHSSXFIRZXHFRZOZXKWGXTWTY
      FXGWDXJWFYFXFIEYDYEUSZVBYFXHFXIWEYDYEVCZYFXFIXFIYGYGVDVEVFYFXLWHXSWSYDXLI
      XHPYEWHXFIXHVGIXHFVKVHYFXRWRCXFIYGYFXRWNDXQUGZWRYFXOWNDXQYFXNWLWMYFXMWKWI
      GYFXHFWJYHVIVJVLVMYFXQWQRYIWRVNYFXPWOWPYFXHFYHVOWBWNDXQWQVPVQVRVSVFVFKVTW
      A $.

    ${
      fpwwe2lem4.4 $e |- ( ph -> X W R ) $.
      $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 19-May-2015.) $)
      fpwwe2lem3 $p |- ( ( ph /\ B e. X ) -> ( ( `' R " { B } ) F
        ( R i^i ( ( `' R " { B } ) X. ( `' R " { B } ) ) ) ) = B ) $=
        ( wcel wa cv wceq wss cvv cxp cin co ccnv csn cima wsbc wral fpwwe2lem2
        wwe wbr mpbid simprd eqeq2 sbcbidv wb sneq imaeq2d dfsbcq bitrd rspccva
        syl sylan cdm cnvimass relopabi brrelex2i dmexg 3syl sylancr id xpeq12d
        ssexg ineq2d oveq12d eqeq1d sbcieg adantr ) AFJOZPDQZGVTVTUAZUBZHUCZFRZ
        DGUDZFUEZUFZUGZWGGWGWGUAZUBZHUCZFRZAWCCQZRZDWEWMUEZUFZUGZCJUHZVSWHAJGUJ
        ZWRAJESGJJUASPZWSWRPZAJGIUKZWTXAPNABCDEGHIJKLMUIULUMUMWQWHCFJWMFRZWQWDD
        WPUGZWHXCWNWDDWPWMFWCUNUOXCWPWGRXDWHUPXCWOWFWEWMFUQURWDDWPWGUSVBUTVAVCA
        WHWLUPZVSAWGTOZXEAWGGVDZSXGTOZXFGWFVEAXBGTOXHNJGIBQZESKQZXIXIUASPXIXJUJ
        VTXJWAUBHUCWMRDXJUDWOUFUGCXIUHPPBKILVFVGGTVHVIWGXGTVMVJWDWLDWGTVTWGRZWC
        WKFXKVTWGWBWJHXKVKZXKWAWIGXKVTWGVTWGXLXLVLVNVOVPVQVBVRUL $.
    $}

    fpwwe2.3 $e |- ( ( ph /\ ( x C_ A /\ r C_ ( x X. x ) /\ r We x ) ) ->
      ( x F r ) e. A ) $.
    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    fpwwe2lem5 $p |- ( ( ph /\ ( X C_ A /\ R C_ ( X X. X ) /\ R We X ) ) ->
      ( X F R ) e. A ) $=
      ( cvv wcel wa wss wwe w3a co cxp adantr simpr1 ssexd xpexg syl2anc simpr2
      cv wi wceq sseq1 xpeq12 anidms sseq2d weeq2 3anbi123d anbi2d oveq1 eleq1d
      jca imbi12d weeq1 3anbi23d oveq2 vtocl2g mpcom ) INOZFNOZPAIEQZFIIUAZQZIF
      RZSZPZIFGTZEOZVNVGVHVNIENAENOVMLUBAVIVKVLUCUDZVNFVJNVNVGVGVJNOVQVQIINNUEU
      FAVIVKVLUGUDUTABUHZEQZJUHZVRVRUAZQZVRVTRZSZPZVRVTGTZEOZUIAVIVTVJQZIVTRZSZ
      PZIVTGTZEOZUIVNVPUIBJIFNNVRIUJZWEWKWGWMWNWDWJAWNVSVIWBWHWCWIVRIEUKWNWAVJV
      TWNWAVJUJVRIVRIULUMUNVRIVTUOUPUQWNWFWLEVRIVTGURUSVAVTFUJZWKVNWMVPWOWJVMAW
      OWHVKWIVLVIVTFVJUKIVTFVBVCUQWOWLVOEVTFIGVDUSVAMVEVF $.

    ${
      fpwwe2lem9.x $e |- ( ph -> X W R ) $.
      fpwwe2lem9.y $e |- ( ph -> Y W S ) $.
      fpwwe2lem9.m $e |- M = OrdIso ( R , X ) $.
      fpwwe2lem9.n $e |- N = OrdIso ( S , Y ) $.
      ${
        fpwwe2lem7.1 $e |- ( ph -> B e. dom M ) $.
        fpwwe2lem7.2 $e |- ( ph -> B e. dom N ) $.
        fpwwe2lem7.3 $e |- ( ph -> ( M |` B ) = ( N |` B ) ) $.
        $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro,
           18-May-2015.) $)
        fpwwe2lem6 $p |- ( ( ph /\ C R ( M ` B ) ) ->
          ( C e. X /\ C e. Y /\ ( `' M ` C ) = ( `' N ` C ) ) ) $=
          ( cfv wbr wa wcel ccnv wceq cxp wss wwe cv cin co csn cima fpwwe2lem2
          wsbc wral mpbid simpld simprd ssbrd brxp simplbi syl6 imp crn imassrn
          cdm wf1o wfo cep wiso cvv relopabi brrelexi syl syl2anc adantr isof1o
          oiiso f1ofo forn 3syl syl5sseq f1ocnvfv2 simpr eqbrtrd wb f1ocnv f1of
          wf ffvelrnd isorel syl12anc mpbird epelg elpreima mpbir2and imacnvcnv
          wfn ffn syl6eleq cres rneqd df-ima 3eqtr4g eleqtrd sseldd cnveqd wfun
          dff1o3 simprbi funcnvres 3eqtr3d fveq1d fvres 3jca ) AGFKUGZHUHZUIZGN
          UJZGOUJGKUKZUGZGLUKZUGZULAYEYGAYEGYDNNUMZUHZYGAHYLGYDANEUNZHYLUNZAYNY
          OUIZNHUOZDUPZHYRYRUMZUQJURCUPZULDHUKYTUSZUTVBCNVCZUIZANHMUHZYPUUCUITA
          BCDEHJMNPQRVAVDZVEVFVGYMYGYDNUJGYDNNVHVIVJVKZYFLFUTZOGYFLVLZUUGOLFVMY
          FLVNZOLVOZUUIOLVPZUUHOULYFUUIOVQILVRZUUJAUULYEAOVSUJZOIUOZUULAOIMUHZU
          UMUAOIMBUPZEUNPUPZUUPUUPUMUNUIUUPUUQUOYRUUQYSUQJURYTULDUUQUKUUAUTVBCU
          UPVCUIUIBPMQVTZWAWBAUUNYRIYSUQJURYTULDIUKUUAUTVBCOVCZAOEUNIOOUMUNUIZU
          UNUUSUIZAUUOUUTUVAUIUAABCDEIJMOPQRVAVDVFVEOILVSUCWFWCWDUUIOVQILWEWBZU
          UIOLWGUUIOLWHWIWJYFGKFUTZUUGYFGYHUKFUTZUVCYFGUVDUJZYGYIFUJZUUFYFYIFVQ
          UHZUVFYFUVGYIKUGZYDHUHZYFUVHGYDHYFKVNZNKVOZYGUVHGULYFUVJNVQHKVRZUVKAU
          VLYEANVSUJZYQUVLAUUDUVMTNHMUURWAWBAYQUUBAYPUUCUUEVFVENHKVSUBWFWCWDZUV
          JNVQHKWEWBZUUFUVJNGKWKWCAYEWLWMYFUVLYIUVJUJFUVJUJZUVGUVIWNUVNYFNUVJGY
          HYFUVKNUVJYHVONUVJYHWQZUVOUVJNKWONUVJYHWPWIZUUFWRAUVPYEUDWDZUVJNYIFVQ
          HKWSWTXAYFUVPUVGUVFWNUVSYIFUVJXBWBVDYFUVQYHNXFUVEYGUVFUIWNUVRNUVJYHXG
          NGFYHXCWIXDKFXEXHZYFKFXIZVLLFXIZVLUVCUUGYFUWAUWBAUWAUWBULYEUFWDZXJKFX
          KLFXKXLXMZXNYFGYHUVCXIZUGZGYJUUGXIZUGZYIYKYFGUWEUWGYFUWAUKZUWBUKZUWEU
          WGYFUWAUWBUWCXOYFUVKYHXPZUWIUWEULUVOUVKUVJNKVPUWKUVJNKXQXRFKXSWIYFUUJ
          YJXPZUWJUWGULUVBUUJUUKUWLUUIOLXQXRFLXSWIXTYAYFGUVCUJUWFYIULUVTGUVCYHY
          BWBYFGUUGUJUWHYKULUWDGUUGYJYBWBXTYC $.

        $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro,
           18-May-2015.) $)
        fpwwe2lem7 $p |- ( ( ph /\ C R ( M ` B ) ) -> ( C S ( N ` B ) /\
          ( D R ( M ` B ) -> ( C R D <-> C S D ) ) ) ) $=
          ( cfv wbr wa wb wi ccnv cdm wf1o wcel wceq cep cvv wwe cv wss cxp cin
          wiso csn cima wsbc wral relopabi brrelexi syl fpwwe2lem2 mpbid simprd
          simpld oiiso syl2anc adantr isof1o fpwwe2lem6 simp2d f1ocnvfv2 simp3d
          simp1d simpr eqbrtrd f1ocnv f1of 3syl ffvelrnd isorel syl12anc mpbird
          co eqbrtrrd adantrr adantrl breq12d isocnv ssbrd brxp simplbi 3bitr4d
          wf imp expr jca ) AGFLUHZIUIZUJZGFMUHZJUIHXIIUIZGHIUIZGHJUIZUKZULXKGM
          UMZUHZMUHZGXLJXKMUNZPMUOZGPUPZXSGUQXKXTPURJMVEZYAAYCXJAPUSUPZPJUTZYCA
          PJNUIZYDUBPJNBVAZEVBQVAZYGYGVCVBUJYGYHUTDVAZYHYIYIVCZVDKWOCVAZUQDYHUM
          YKVFZVGVHCYGVIUJUJBQNRVJZVKVLAYEYIJYJVDKWOYKUQDJUMYLVGVHCPVIZAPEVBJPP
          VCVBUJZYEYNUJZAYFYOYPUJUBABCDEJKNPQRSVMVNVOVPPJMUSUDVQVRZVSZXTPURJMVT
          VLZXKGOUPZYBGLUMZUHZXRUQZABCDEFGIJKLMNOPQRSTUAUBUCUDUEUFUGWAZWBZXTPGM
          WCVRXKXRFURUIZXSXLJUIZXKUUBXRFURXKYTYBUUCUUDWDZXKUUBFURUIZUUBLUHZXIIU
          IZXKUUJGXIIXKLUNZOLUOZYTUUJGUQXKUULOURILVEZUUMAUUNXJAOUSUPZOIUTZUUNAO
          INUIZUUOUAOINYMVKVLAUUPYIIYJVDKWOYKUQDIUMYLVGVHCOVIZAOEVBZIOOVCZVBZUJ
          ZUUPUURUJZAUUQUVBUVCUJUAABCDEIKNOQRSVMVNZVOVPOILUSUCVQVRZVSZUULOURILV
          TVLZXKYTYBUUCUUDWEZUULOGLWCVRAXJWFWGXKUUNUUBUULUPFUULUPZUUIUUKUKUVFXK
          OUULGUUAXKUUMOUULUUAUOOUULUUAXEUVGUULOLWHOUULUUAWIWJUVHWKAUVIXJUEVSUU
          LOUUBFURILWLWMWNWPXKYCXRXTUPFXTUPZUUFUUGUKYRXKPXTGXQXKYAPXTXQUOPXTXQX
          EYSXTPMWHPXTXQWIWJUUEWKAUVJXJUFVSXTPXRFURJMWLWMVNWPAXJXMXPAXJXMUJZUJZ
          UUBHUUAUHZURUIZXRHXQUHZURUIZXNXOUVLUUBXRUVMUVOURAXJUUCXMUUHWQAXMUVMUV
          OUQZXJAXMUJZHOUPZHPUPZUVQABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGWAZWDWRWSUV
          LOUULIURUUAVEZYTUVSXNUVNUKUVLUUNUWBAUUNUVKUVEVSUULOURILWTVLAXJYTXMUVH
          WQAXMUVSXJUVRHXIUUTUIZUVSAXMUWCAIUUTHXIAUUSUVAAUVBUVCUVDVPVOXAXFUWCUV
          SXIOUPHXIOOXBXCVLWROUULGHIURUUAWLWMUVLPXTJURXQVEZYBUVTXOUVPUKUVLYCUWD
          AYCUVKYQVSXTPURJMWTVLAXJYBXMUUEWQAXMUVTXJUVRUVSUVTUVQUWAWBWRPXTGHJURX
          QWLWMXDXGXH $.
      $}

      fpwwe2lem9.s $e |- ( ph -> dom M C_ dom N ) $.
      $( Lemma for ~ fpwwe2 .  Show by induction that the two isometries ` M `
         and ` N ` agree on their common domain.  (Contributed by Mario
         Carneiro, 15-May-2015.) $)
      fpwwe2lem8 $p |- ( ph -> M = ( N |` dom M ) ) $=
        ( vw vz cdm cres wf wfn oif ffn mp1i wss fnssres syl2anc cv wcel wa cfv
        wceq con0 word oicl ordelon mpan wi eleq1 fveq2 eqeq12d imbi12d r19.21v
        imbi2d a1i ordelss sylan sselda pm2.27 syl ralimdva adantr sstrd eqfnfv
        wral wb fvres ralbiia syl6bb ccnv csn cima cxp cin wbr cvv ad2antrr wwe
        co w3a simpll simplr fpwwe2lem7 simpld eqcomd impbida fvex vex eliniseg
        simpr ax-mp 3bitr4g eqrdv wrel inss2 relxp relss mp2 cop anbi12d simprd
        impr sylan2b pm5.32da brinxp2 df-br df-3an 3bitr3i xpeq12d ineq2d eqtrd
        eqrelrdv oveq12d ffvelrni adantl fpwwe2lem3 3eqtr3d ex sylbird syld a2i
        com23 sylbi tfis2 com3l mpdi imp eqtr4d eqfnfvd ) AUCIUEZIJUUGUFZUUGLIU
        GIUUGUHZALFITUIZUUGLIUJUKZAJJUEZUHZUUGUULULZUUHUUGUHUULMJUGUUMAMGJUAUIZ
        UULMJUJUKZUBUULUUGJUMUNAUCUOZUUGUPZUQZUUQIURZUUQJURZUUQUUHURZAUURUUTUVA
        USZAUURUUQUTUPZUVCUUGVAZUURUVDLFITVBZUUGUUQVCVDUVDAUURUVCAUURUVCVEZVEZA
        CUOZUUGUPZUVIIURZUVIJURZUSZVEZVEZUCCUUQUVIUSZUVGUVNAUVPUURUVJUVCUVMUUQU
        VIUUGVFUVPUUTUVKUVAUVLUUQUVIIVGUUQUVIJVGVHVIVKUVOCUUQWBZUVHVEUVDUVQAUVN
        CUUQWBZVEUVHAUVNCUUQVJAUVRUVGAUURUVRUVCAUURUVRUVCVEUUSUVRUVMCUUQWBZUVCU
        USUVNUVMCUUQUUSUVIUUQUPZUQUVJUVNUVMVEUUSUUQUUGUVIAUVEUURUUQUUGULZUVEAUV
        FVLUUGUUQVMVNZVOUVJUVMVPVQVRUUSUVSIUUQUFZJUUQUFZUSZUVCUUSUWEUVIUWCURZUV
        IUWDURZUSZCUUQWBZUVSUUSUWCUUQUHZUWDUUQUHZUWEUWIWCUUSUUIUWAUWJAUUIUURUUK
        VSUWBUUGUUQIUMUNUUSUUMUUQUULULUWKAUUMUURUUPVSUUSUUQUUGUULUWBAUUNUURUBVS
        VTUULUUQJUMUNCUUQUWCUWDWAUNUWHUVMCUUQUVTUWFUVKUWGUVLUVIUUQIWDUVIUUQJWDV
        HWEWFUUSUWEUVCUUSUWEUQZFWGUUTWHWIZFUWMUWMWJZWKZHWPZGWGUVAWHWIZGUWQUWQWJ
        ZWKZHWPZUUTUVAUWLUWMUWQUWOUWSHUWLCUWMUWQUWLUVIUUTFWLZUVIUVAGWLZUVIUWMUP
        ZUVIUWQUPZUWLUXAUXBUWLUXAUQZUXBUDUOZUUTFWLZUVIUXFFWLZUVIUXFGWLZWCZVEZUW
        LBCDEUUQUVIUXFFGHIJKLMNOAEWMUPUURUWEPWNZUWLABUOZEULNUOZUXMUXMWJULUXMUXN
        WOWQUXMUXNHWPEUPAUURUWEWRZQVNZALFKWLUURUWERWNZAMGKWLUURUWESWNZTUAAUURUW
        EWSZUUSUUQUULUPZUWEAUUGUULUUQUBVOZVSZUUSUWEXGZWTZXAUWLUXBUQUXAUXFUVAGWL
        UXIUXHWCVEUWLBCDEUUQUVIUXFGFHJIKMLNOUXLUXPUXRUXQUATUYBUXSUWLUWCUWDUYCXB
        WTXAXCUUTWMUPZUXCUXAWCUUQIXDZFUUTUVIWMCXEZXFZXHUVAWMUPUXDUXBWCUUQJXDGUV
        AUVIWMUYGXFXHXIXJZUWLUWOGUWNWKZUWSUWLCUDUWOUYJUWOUWNULUWNXKZUWOXKFUWNXL
        UWMUWMXMZUWOUWNXNXOUYJUWNULUYKUYJXKGUWNXLUYLUYJUWNXNXOUWLUXCUXFUWMUPZUQ
        ZUXHUQZUYNUXIUQZUVIUXFXPZUWOUPZUYQUYJUPZUWLUYNUXHUXIUYNUWLUXAUXGUQZUXJU
        YEUYNUYTWCUYFUYEUXCUXAUYMUXGUYHFUUTUXFWMUDXEXFXQXHUWLUXAUXGUXJUXEUXBUXK
        UYDXRXSXTYAUVIUXFUWOWLUXCUYMUXHWQUYRUYOUVIUXFUWMUWMFYBUVIUXFUWOYCUXCUYM
        UXHYDYEUVIUXFUYJWLUXCUYMUXIWQUYSUYPUVIUXFUWMUWMGYBUVIUXFUYJYCUXCUYMUXIY
        DYEXIYIUWLUWNUWRGUWLUWMUWQUWMUWQUYIUYIYFYGYHYJUWLAUUTLUPZUWPUUTUSUXOUUS
        VUAUWEUURVUAAUUGLUUQIUUJYKYLVSABCDEUUTFHKLNOPRYMUNUWLAUVAMUPZUWTUVAUSUX
        OUUSVUBUWEUUSUXTVUBUYAUULMUUQJUUOYKVQVSABCDEUVAGHKMNOPSYMUNYNYOYPYQYOYS
        YRYTVLUUAUUBUUCUUDUURUVBUVAUSAUUQUUGJWDYLUUEUUF $.

      $( Lemma for ~ fpwwe2 .  Given two well-orders ` <. X , R >. ` and
         ` <. Y , S >. ` of parts of ` A ` , one is an initial segment of the
         other.  (The ` O C_ P ` hypothesis is in order to break the symmetry
         of ` X ` and ` Y ` .)  (Contributed by Mario Carneiro,
         15-May-2015.) $)
      fpwwe2lem9 $p |- ( ph -> ( X C_ Y /\ R = ( S i^i ( Y X. X ) ) ) ) $=
        ( wss cxp cin wceq cdm cima cres crn wf1o wfo cep wiso cvv wcel wwe wbr
        cv wa ccnv csn wsbc wral relopabi brrelexi syl fpwwe2lem2 simprd simpld
        co mpbid oiiso syl2anc isof1o f1ofo forn fpwwe2lem8 rneqd eqtr3d df-ima
        3syl syl6eqr imassrn syl5sseq eqsstrd wrel relxp relss ee10 inss2 jctir
        mp2 cop ssbrd syl6ib w3a brinxp2 df-3an bitri cfv simprll simprr isocnv
        brxp adantr simprlr sseldd isorel syl12anc fvex epelc sylib cnveqd wfun
        wb wfn f1ofn fnfun funcnvres eqtrd eleqtrd fvres f1of ffvelrnd eqeltrrd
        fveq1d wf word wi oicl ordtr1 elpreima mpbir2and imacnvcnv eleqtrrd jca
        ax-mp ex df-br syl5bi breq12d sylan eqidd isores3 syl3anc simprl sselda
        3bitr4d adantrr biantrurd syl6bbr pm5.21ndd 3bitr3g eqrelrdv2 mpancom
        bitrd ) ALMUCZFGMLUDZUEZUFZALJIUGZUHZMALJUVBUIZUJZUVCAIUJZLUVEAUVBLIUKZ
        UVBLIULUVFLUFAUVBLUMFIUNZUVGALUOUPZLFUQZUVHALFKURZUVIRLFKBUSZEUCNUSZUVL
        UVLUDUCUTUVLUVMUQDUSZUVMUVNUVNUDZUEHVKCUSZUFDUVMVAUVPVBZUHVCCUVLVDUTUTB
        NKOVEZVFVGAUVJUVNFUVOUEHVKUVPUFDFVAUVQUHVCCLVDZALEUCZFLLUDZUCZUTZUVJUVS
        UTZAUVKUWCUWDUTRABCDEFHKLNOPVHVLZVIVJLFIUOTVMVNZUVBLUMFIVOVGUVBLIVPUVBL
        IVQWBAIUVDABCDEFGHIJKLMNOPQRSTUAUBVRZVSVTJUVBWAWCZAJUJZUVCMJUVBWDAJUGZM
        JUKZUWJMJULUWIMUFAUWJMUMGJUNZUWKAMUOUPZMGUQZUWLAMGKURZUWMSMGKUVRVFVGAUW
        NUVNGUVOUEHVKUVPUFDGVAUVQUHVCCMVDZAMEUCGMMUDUCUTZUWNUWPUTZAUWOUWQUWRUTS
        ABCDEGHKMNOPVHVLVIVJMGJUOUAVMVNZUWJMUMGJVOVGUWJMJVPUWJMJVQWBWEWFZFWGZUU
        TWGZUTAUVAAUXAUXBAUWBUWAWGUXAAUVTUWBAUWCUWDUWEVJVIZLLWHFUWAWIWJUUTUUSUC
        UUSWGUXBGUUSWKMLWHUUTUUSWIWMWLABCFUUTAUVLUVPFURZUVLUVPUUTURZUVLUVPWNZFU
        PUXFUUTUPAUVLLUPZUVPLUPZUTZUXDUXEAUXDUVLUVPUWAURUXIAFUWAUVLUVPUXCWOUVLU
        VPLLXEWPUXEUVLMUPZUXHUTZUVLUVPGURZUTZAUXIUXEUXJUXHUXLWQUXMUVLUVPMLGWRUX
        JUXHUXLWSWTZAUXMUXIAUXMUTZUXGUXHUXOUVLJVAZVAUVBUHZLUXOUVLUXQUPZUXJUVLUX
        PXAZUVBUPZAUXJUXHUXLXBZUXOUXSUVPUXPXAZUPZUYBUVBUPZUXTUXOUXSUYBUMURZUYCU
        XOUXLUYEAUXKUXLXCUXOMUWJGUMUXPUNZUXJUVPMUPUXLUYEXPAUYFUXMAUWLUYFUWSUWJM
        UMGJXDVGXFZUYAUXOLMUVPAUURUXMUWTXFAUXJUXHUXLXGZXHMUWJUVLUVPGUMUXPXIXJVL
        UXSUYBUVPUXPXKXLXMUXOUVPIVAZXAZUYBUVBUXOUYJUVPUXPUVCUIZXAZUYBUXOUVPUYIU
        YKUXOUYIUVDVAZUYKUXOIUVDAIUVDUFZUXMUWGXFXNUXOUXPMXQZUXPXOUYMUYKUFUXOUYF
        MUWJUXPUKUYOUYGMUWJGUMUXPVOMUWJUXPXRWBZMUXPXSUVBJXTWBYAYGUXOUVPUVCUPZUY
        LUYBUFUXOUVPLUVCUYHALUVCUFZUXMUWHXFZYBUVPUVCUXPYCVGYAUXOLUVBUVPUYIALUVB
        UYIYHZUXMALUVBFUMUYIUNZLUVBUYIUKUYTAUVHVUAUWFUVBLUMFIXDVGZLUVBFUMUYIVOL
        UVBUYIYDWBXFUYHYEYFUVBYIUYCUYDUTUXTYJLFITYKUXSUYBUVBYLYRVNUXOUYOUXRUXJU
        XTUTXPUYPMUVLUVBUXPYMVGYNUXOLUVCUXQUYSJUVBYOWCYPUYHYQYSUUAAUXIUXDUXEXPA
        UXIUTZUXDUXLUXEVUCUVLUYIXAZUYJUMURZUVLUYMXAZUVPUYMXAZUMURZUXDUXLVUCVUDV
        UFUYJVUGUMVUCUVLUYIUYMVUCIUVDAUYNUXIUWGXFXNZYGVUCUVPUYIUYMVUIYGUUBAVUAU
        XIUXDVUEXPVUBLUVBUVLUVPFUMUYIXIUUCVUCUVCUVBGUMUYMUNZUVLUVCUPUYQUXLVUHXP
        AVUJUXIAUVBUVCUMGUVDUNZVUJAUWLUVBUWJUCUVCUVCUFVUKUWSUBAUVCUUDUWJMUMGJUV
        BUVCUUEUUFUVBUVCUMGUVDXDVGXFVUCUVLLUVCAUXGUXHUUGAUYRUXIUWHXFZYBVUCUVPLU
        VCAUXGUXHXCZVULYBUVCUVBUVLUVPGUMUYMXIXJUUIVUCUXLUXMUXEVUCUXKUXLVUCUXJUX
        HAUXGUXJUXHALMUVLUWTUUHUUJVUMYQUUKUXNUULUUQYSUUMUVLUVPFYTUVLUVPUUTYTUUN
        UUOUUPYQ $.
    $}

    ${
      fpwwe2lem10.4 $e |- ( ph -> X W R ) $.
      fpwwe2lem10.6 $e |- ( ph -> Y W S ) $.
      $( Lemma for ~ fpwwe2 .  Given two well-orders ` <. X , R >. ` and
         ` <. Y , S >. ` of parts of ` A ` , one is an initial segment of the
         other.  (Contributed by Mario Carneiro, 15-May-2015.) $)
      fpwwe2lem10 $p |- ( ph -> ( ( X C_ Y /\ R = ( S i^i ( Y X. X ) ) ) \/
                                ( Y C_ X /\ S = ( R i^i ( X X. Y ) ) ) ) ) $=
        ( wss wa adantr coi cdm wo cxp cin wceq word eqid oicl ordtri2or2 mp2an
        cvv wcel cv wwe w3a co adantlr wbr simpr fpwwe2lem9 ex orim12d mpi ) AJ
        FUAZUBZKGUAZUBZRZVHVFRZUCZJKRFGKJUDUEUFSZKJRGFJKUDUEUFSZUCVFUGVHUGVKJFV
        EVEUHZUIKGVGVGUHZUIVFVHUJUKAVIVLVJVMAVIVLAVISBCDEFGHVEVGIJKLMAEULUMZVIN
        TABUNZERLUNZVQVQUDRVQVRUOUPZVQVRHUQEUMZVIOURAJFIUSZVIPTAKGIUSZVIQTVNVOA
        VIUTVAVBAVJVMAVJSBCDEGFHVGVEIKJLMAVPVJNTAVSVTVJOURAWBVJQTAWAVJPTVOVNAVJ
        UTVAVBVCVD $.
    $}

    fpwwe2.4 $e |- X = U. dom W $.
    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    fpwwe2lem11 $p |- ( ph -> W : dom W --> ~P ( X X. X ) ) $=
      ( vw vs wss cv wa wceq cin vt cdm wfn crn cxp cpw wf wfun wrel wbr wi wal
      wwe co ccnv csn cima wsbc wral relopabi simprr fpwwe2lem2 simprbda simprd
      a1i adantrl adantr df-ss sylib adantrr eqtr2d cvv wcel w3a adantlr simprl
      eqtrd fpwwe2lem10 mpjaodan alrimiv alrimivv dffun2 sylanbrc funfn wex vex
      elrn cuni releldmi adantl elssuni syl syl6sseqr xpss12 syl2anc sstrd elpw
      ex syl6ibr exlimdv syl5bi ssrdv df-f ) AGGUBZUCZGUDZHHUEZUFZPXDXHGUGAGUHZ
      XEAGUIZNQZOQZGUJZXKUAQZGUJZRZXLXNSZUKZUAULZOULNULXIXJABQZEPZIQZXTXTUEPZRX
      TYBUMZDQZYBYEYEUEZTFUNCQZSDYBUOYGUPZUQURCXTUSRRBIGJUTZVEAXSNOAXRUAAXPXQAX
      PRZXKXKPZXLXNXKXKUEZTZSZRZXQYKXNXLYLTZSZRZYJYORZXLYMXNYJYKYNVAYSXNYLPZYMX
      NSYJYTYOAXOYTXMAXORXKEPZYTAXOUUAYTRXKXNUMYEXNYFTFUNYGSDXNUOYHUQURCXKUSRAB
      CDEXNFGXKIJKVBVCVDVFVGXNYLVHVIVQYJYRRZXNYPXLYJYKYQVAUUBXLYLPZYPXLSYJUUCYR
      AXMUUCXOAXMRZUUAUUCAXMUUAUUCRXKXLUMYEXLYFTFUNYGSDXLUOYHUQURCXKUSRABCDEXLF
      GXKIJKVBVCVDZVJVGXLYLVHVIVKYJBCDEXLXNFGXKXKIJAEVLVMXPKVGAYAYCYDVNXTYBFUNE
      VMXPLVOAXMXOVPAXMXOVAVRVSWRVTWANOUAGWBWCGWDVIAOXFXHXLXFVMXMNWEAXLXHVMZNXL
      GOWFZWGAXMUUFNAXMXLXGPZUUFAXMUUHUUDXLYLXGUUEUUDXKHPZUUIYLXGPUUDXKXDWHZHUU
      DXKXDVMZXKUUJPXMUUKAXKXLGYIWIWJXKXDWKWLMWMZUULXKHXKHWNWOWPWRXLXGUUGWQWSWT
      XAXBXDXHGXCWC $.

    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 18-May-2015.) $)
    fpwwe2lem12 $p |- ( ph -> X e. dom W ) $=
      ( va vw wbr wcel wss wa cvv vs vn vv vz vt vb cuni cdm cxp wwe cv co wceq
      cin ccnv cima wsbc wral cpw wex vex eldm fpwwe2lem2 simpld elpw sylibr ex
      exlimdv syl5bi ssrdv sspwuni sylib simprd releldmi adantl elssuni syl2anc
      elrn syl jca wfr weq w3o c0 wne wn wrex wal wel eleq2i eluni2 bitri inss2
      a1i simplrr simprr inss1 simprl sseldi cop df-br adantr ad2antrr syl12anc
      wi wb ssbrd brxp simplbi brinxp2 breqd mpbird sylanbrc sseldd syl6eqss wo
      mpd w3a mpjaodan expr syl5bir rexlimdv alrimiv anbi12i bitr4i wor simplrl
      exp32 weso solin relelrni 3orim123d adantrr ad2antrl ssexd eliniseg ax-mp
      idd imp wrel crn csn simprbda syl5eqss relopabi syl6sseqr xpss12 sstrd n0
      ssel2 inex2 simplbda ad2ant2r wefr inelcm syl22anc ralnex simprll simp-4l
      fri simprlr mpbid syl3anbrc elin breq1 adantlr fpwwe2lem10 mtod ralrimiva
      rspcev reximdv2 expimpd df-fr eeanv ad2antll exlimdvv rexlimdvv ralrimivv
      reeanv exp31 dfwe2 fpwwe2cbv simpr fpwwe2lem3 anasss cnvimass xpexg dmexg
      ssexg sylancr id olc syl6 elequ1 biimprd jaodan impr jctird syl6ibr ancld
      a1d brin syl6bb sylibrd com24 sylan2 breq2 imbi12d ceqsalv impbid 3bitr4g
      eqrdv sylan9eqr xpeq12d ineq2d relxp mp2 anbi12d adantrl sylan2b pm5.32da
      relss orc df-3an 3bitr3i eqrelrdv eqtrd oveq12d eqeq1d ralrimiv mpbir2and
      sbcied ) AHGUUAZUGZGPZHGUHZQAUYOHERZUYNHHUIZRZSHUYNUJZDUKZUYNVUAVUAUIZUNZ
      FULZCUKZUMZDUYNUOVUEUUBZUPZUQZCHURZSAUYQUYSAHUYPUGZEMAUYPEUSZRVUKERANUYPV
      ULNUKZUYPQZVUMUAUKZGPZUAUTZAVUMVULQZUAVUMGNVAZVBZAVUPVURUAAVUPVURAVUPSZVU
      MERZVURVVAVVBVUOVUMVUMUIZRZAVUPVVBVVDSZVUMVUOUJZVUAVUOVUBUNFULVUEUMDVUOUO
      VUGUPZUQCVUMURZSZABCDEVUOFGVUMIJKVCZUUCZVDVUMEVUSVEVFVGVHVIVJUYPEVKVLUUDZ
      AUYMUYRUSZRUYSAUAUYMVVMVUOUYMQZVUPNUTAVUOVVMQZNVUOGUAVAZVRAVUPVVONAVUPVVO
      VVAVUOUYRRVVOVVAVUOVVCUYRVVAVVBVVDVVKVMZVVAVUMHRZVVRVVCUYRRVVAVUMVUKHVVAV
      UNVUMVUKRVUPVUNAVUMVUOGBUKZERZIUKZVVSVVSUIRZSVVSVWAUJZVUAVWAVUBUNFULVUEUM
      DVWAUOVUGUPUQCVVSURSSBIGJUUEZVNVOVUMUYPVPVSMUUFZVWEVUMHVUMHUUGVQUUHVUOUYR
      VVPVEVFVGVHVIVJUYMUYRVKVLZVTAUYTVUJAHUYNWAZVUEOUKZUYNPZCOWBZVWHVUEUYNPZWC
      ZOHURCHURUYTAUBUKZHRZVWMWDWEZSVWHUCUKZUYNPZWFZOVWMURZUCVWMWGZXEZUBWHVWGAV
      XAUBAVWNVWOVWTVWOCUBWIZCUTAVWNSZVWTCVWMUUIVXCVXBVWTCAVWNVXBVWTAVWNVXBSZSZ
      CNWIZNUYPWGZVWTVXEVUEHQZVXGVXDVXHAVWMHVUEUUJVOVXHVUEVUKQVXGHVUKVUEMWJNVUE
      UYPWKWLZVLVXEVXFVWTNUYPVUNVUQVXEVXFVWTXEZVUTVXEVUPVXJUAVXEVUPVXFVWTVXEVUP
      VXFSZSZUDUKZVWPVUOPZWFUDVWMVUMUNZURZUCVXOWGZVWTVXLVXOTQZVUMVUOWAZVXOVUMRZ
      VXOWDWEZVXQVXRVXLVUMVWMVUSUUKWNVXLVVFVXSAVUPVVFVXDVXFVVAVVFVVHAVUPVVEVVIV
      VJUULVDZUUMVUMVUOUUNVSVXTVXLVWMVUMWMZWNVXLVXBVXFVYAAVWNVXBVXKWOVXEVUPVXFW
      PVUEVWMVUMUUOVQUCUDVUMVXOTVUOUUTUUPVXLVXPVWSUCVXOVWMVXLVWPVXOQZVXPSZUCUBW
      IZVWSSVXLVYESZVYFVWSVYGVXOVWMVWPVWMVUMWQVXLVYDVXPWRZWSVYGVWROVWMVYGOUBWIZ
      SZVWQVXNUDVXOWGZVYJVXPVYKWFVXLVYDVXPVYIWOVXNUDVXOUUQVLVWQVWHVWPWTZUEUKZQZ
      UEUYMWGZVYJVYKVWQVYLUYNQVYOVWHVWPUYNXAUEVYLUYMWKWLVYJVYNVYKUEUYMVYMUYMQZU
      FUKZVYMGPZUFUTZVYJVYNVYKXEZUFVYMGUEVAVRZVYJVYRVYTUFVYGVYIVYRVYTVYNVWHVWPV
      YMPZVYGVYIVYRSZSVYKVWHVWPVYMXAVYGWUCWUBVYKVYGWUCWUBSZSZVUMVYQRZVUOVYMVYQV
      UMUIZUNZUMZSZVYKVYQVUMRZVYMVUOVUMVYQUIZUNZUMZSZWUEWUJSZVWHVXOQZVWHVWPVUOP
      ZVYKWUPVYIONWIZWUQWUEVYIWUJVYGVYIVYRWUBUURZXBWUPVWHVWPVVCPZWUSWUPWURWVAWU
      PWURVWHVWPWUHPZWUPOUFWIZUCNWIZWUBWVBWUEWVCWUJWUEVWHVWPVYQVYQUIZPZWVCWUEWU
      BWVFVYGWUCWUBWPWUEVYMWVEVWHVWPWUEAVUPVYRVYMWVERZAVXDVXKVYEWUDUUSZVXLVUPVY
      EWUDVXEVUPVXFWRXCZVYGVYIVYRWUBUVAZAVUPVYRSZSZVYQERZWVGWVLWVMWVGSZVYQVYMUJ
      ZVUAVYMVUBUNFULVUEUMDVYMUOVUGUPUQCVYQURZSZWVLVYRWVNWVQSZAVUPVYRWPZAVYRWVR
      XFWVKABCDEVYMFGVYQIJKVCXBUVBZVDVMZXDXGXQWVFWVCUCUFWIVWHVWPVYQVYQXHXIVSZXB
      VYGWVDWUDWUJVYGVXOVUMVWPVYCVYHWSXCVYGWUCWUBWUJWOVWHVWPVYQVUMVYMXJUVCWUPVU
      OWUHVWHVWPWUEWUFWUIWPXKXLZWUPVUOVVCVWHVWPWUEVVDWUJWUEAVUPVVDWVHWVIVVQVQXB
      XGXQWVAWUSWVDVWHVWPVUMVUMXHXIVSVWHVWMVUMUVDZXMWWCVXNWURUDVWHVXOVXMVWHVWPV
      UOUVEUVJZVQWUEWUOSZWUQWURVYKWWFVYIWUSWUQWUEVYIWUOWUTXBWWFVYQVUMVWHWUEWUKW
      UNWRWUEWVCWUOWWBXBXNWWDXMWWFWUBWURVYGWUCWUBWUOWOWWFVYMVUOVWHVWPWWFVYMWUMV
      UOWUEWUKWUNWPVUOWULWQZXOXGXQWWEVQWUEAVUPVYRWUJWUOXPZWVHWVIWVJWVLBCDEVUOVY
      MFGVUMVYQIJAETQZWVKKXBAVVTVWBVWCXRVVSVWAFULEQWVKLUVFAVUPVYRWRWVSUVGZXDXSX
      TYAXTVHVIYBVIUVHUVIVTVGUVKXQYHVHVIYBXQXTVHVIUVLYCUBUCOHUYNUVMVFAVWLCOHHVX
      HVWHHQZSZVXFWVCSZUFUYPWGNUYPWGZAVWLWWLVXGWVCUFUYPWGZSWWNVXHVXGWWKWWOVXIWW
      KVWHVUKQWWOHVUKVWHMWJUFVWHUYPWKWLYDVXFWVCNUFUYPUYPUVSYEAWWMVWLNUFUYPUYPVU
      NVYQUYPQZSZWVKUEUTUAUTZAWWMVWLXEZWWQVUQVYRUEUTZSWWRVUNVUQWWPWWTVUTUEVYQGU
      FVAVBYDVUPVYRUAUEUVNYEAWVKWWSUAUEAWVKWWMVWLWVLWWMSZWUJVWLWUOWXAWUJSZVUEVW
      HVYMPZVWJVWHVUEVYMPZWCZVWLWXBVYQVYMYFZCUFWIWVCWXEWXBWVOWXFWVLWVOWWMWUJWVL
      WVOWVPWVLWVNWVQWVTVMVDXCVYQVYMYIVSWXBVUMVYQVUEWXAWUFWUIWRWVLVXFWVCWUJYGXN
      WVLVXFWVCWUJWOVYQVUEVWHVYMYJXDWXBWXCVWIVWJVWJWXDVWKWXBVYMUYNVUEVWHWXBVYPV
      YMUYNRWVLVYPWWMWUJVYRVYPAVUPVYQVYMGVWDYKUVOXCVYMUYMVPVSZXGWXBVWJYRWXBVYMU
      YNVWHVUEWXGXGYLXQWXAWUOSZVUEVWHVUOPZVWJVWHVUEVUOPZWCZVWLWXHVUMVUOYFZVXFWU
      SWXKWXHVVFWXLWVLVVFWWMWUOAVUPVVFVYRVYBYMXCVUMVUOYIVSWVLVXFWVCWUOYGWXHVYQV
      UMVWHWXAWUKWUNWRWVLVXFWVCWUOWOXNVUMVUEVWHVUOYJXDWXHWXIVWIVWJVWJWXJVWKWXHV
      UOUYNVUEVWHWXHVVNVUOUYNRZWVLVVNWWMWUOVUPVVNAVYRVUMVUOGVWDYKZYNXCVUOUYMVPZ
      VSZXGWXHVWJYRWXHVUOUYNVWHVUEWXPXGYLXQWVLWWHWWMWWJXBXSUVTUVPVIUVQVIUVRCOHU
      YNUWAXMAVUICHVXHVXGAVUIVXIAVXFVUINUYPVUNVUQAVXFVUIXEZVUTAVUPWXQUAAVUPVXFV
      UIAVXKSZVUIVVGVUOVVGVVGUIZUNZFULZVUEUMZAVUPVXFWYBVVAUDOUFEVUEVUOFGVUMUEBC
      OUFDEFGUEIUDJUWBAWWIVUPKXBAVUPUWCUWDUWEWXRVUFWYBDVUHTWXRVUHUYNUHZRWYCTQZV
      UHTQUYNVUGUWFWXRUYNTQZWYDAWYEVXKAUYNUYRTAHTQZWYFUYRTQAHETKVVLYOZWYGHHTTUW
      GVQVWFYOXBUYNTUWHVSVUHWYCTUWIUWJWXRVUAVUHUMZSZVUDWYAVUEWYIVUAVVGVUCWXTFWY
      HWXRVUAVUHVVGWYHUWKWXRUDVUHVVGWXRVXMVUEUYNPZVXMVUEVUOPZVXMVUHQZVXMVVGQZWX
      RWYJWYKWXROCWBZVXMVWHUYNPZVXMVWHVUOPZXEZXEZOWHWYJWYKXEZWXRWYROWXRWYNWYQWY
      NWXRWXJWYNXPZWYQWYNWXJUWLWYOVXMVWHWTZVYMQZUEUYMWGZWXRWYTSZWYPWYOXUAUYNQXU
      CVXMVWHUYNXAUEXUAUYMWKWLXUDXUBWYPUEUYMVYPVYSXUDXUBWYPXEZWUAXUDVYRXUEUFWXR
      WYTVYRXUEXEZAVUPVXFWYTXUFXEVVAVYRWYTVXFXUEAVUPVYRWYTVXFXUEXEXEWVLWYTVXFXU
      EXUBVXMVWHVYMPZWVLWYTVXFSZSZWYPVXMVWHVYMXAXUIWUJXUGWYPXEWUOXUIWUJSZXUGXUG
      VXMVWHWUGPZSZWYPXUJXUGXUKXUJXUGUDUFWIZWUSSXUKXUJXUGXUMWUSXUJXUGVXMVWHWVEP
      ZXUMXUJVYMWVEVXMVWHWVLWVGXUHWUJWWAXCXGXUNXUMWVCVXMVWHVYQVYQXHXIUWMXUIWUSW
      UJWVLWYTVXFWUSWVLWXJVXFWUSXEZWYNWVLWXJSZWUSVXFXUPVWHVUEVVCPZWUSWVLWXJXUQW
      VLVUOVVCVWHVUEAVUPVVDVYRVVQYMXGYSXUQWUSVXFVWHVUEVUMVUMXHXIVSUXAWYNXUOWVLW
      YNWUSVXFOCNUWNUWOVOUWPUWQXBUWRVXMVWHVYQVUMXHUWSUWTXUJWYPVXMVWHWUHPXULXUJV
      UOWUHVXMVWHXUIWUFWUIWPXKVXMVWHVYMWUGUXBUXCUXDXUIWUOSZVYMVUOVXMVWHXURVYMWU
      MVUOXUIWUKWUNWPWWGXOXGWVLWWHXUHWWJXBXSYAYHXTUXEUWQYSVHVIYBVIZUXFVGYCWYQWY
      SOVUECVAZWYNWYOWYJWYPWYKVWHVUEVXMUYNUXGVWHVUEVXMVUOUXGUXHUXIVLWXRVUOUYNVX
      MVUEWXRVVNWXMVUPVVNAVXFWXNYNWXOVSZXGUXJVUETQZWYLWYJXFXUTUYNVUEVXMTUDVAZYP
      YQXVBWYMWYKXFXUTVUOVUEVXMTXVCYPZYQUXKUXLUXMZWYIVUCUYNWXSUNZWXTWYIVUBWXSUY
      NWYIVUAVVGVUAVVGXVEXVEUXNUXOWXRXVFWXTUMWYHWXRUDOXVFWXTXVFWXSRWXSYTZXVFYTU
      YNWXSWMVVGVVGUXPZXVFWXSUYBUXQWXTWXSRXVGWXTYTVUOWXSWMXVHWXTWXSUYBUXQWXRWYM
      VWHVVGQZSZWYOSZXVJWYPSZXUAXVFQZXUAWXTQZWXRXVJWYOWYPXVJWXRWYKWXJSZWYOWYPXF
      XVBXVJXVOXFXUTXVBWYMWYKXVIWXJXVDVUOVUEVWHTOVAYPUXRYQWXRXVOSZWYOWYPWXRWXJW
      YQWYKWXJWXRWYTWYQWXJWYNUYCXUSUXFUXSXVPVUOUYNVXMVWHWXRWXMXVOXVAXBXGUXJUXTU
      YAVXMVWHXVFPWYMXVIWYOXRXVMXVKVXMVWHVVGVVGUYNXJVXMVWHXVFXAWYMXVIWYOUYDUYEV
      XMVWHWXTPWYMXVIWYPXRXVNXVLVXMVWHVVGVVGVUOXJVXMVWHWXTXAWYMXVIWYPUYDUYEUXKU
      YFXBUYGUYHUYIUYLXLYHVHVIYBVIUYJVTABCDEUYNFGHIJKVCUYKHUYNGVWDVNVS $.

    $( Lemma for ~ fpwwe2 .  (Contributed by Mario Carneiro, 18-May-2015.) $)
    fpwwe2lem13 $p |- ( ph -> ( X F ( W ` X ) ) e. X ) $=
      ( wcel wa wss wbr wceq cvv c0 vz va vb vs cfv co wn csn cun ssun2 cdm cxp
      cuni wwe cv cin ccnv cima wsbc wral adantr w3a adantlr fpwwe2lem12 cpw wb
      3syl mpbid fpwwe2lem2 simpld simprd unssd ssun1 mp2an a1i jca wfr w3o wne
      xpss12 wrex ad2antrr ssbrd brxp simplbi syl6 mtod nsyl brun syl6bb notbid
      wi wo ioran bitri sylanbrc simpr sylib mpd ralsn mpbird ex uncom syl6sseq
      vex syl idd simprbi adantl syl5bi ad3antrrr sylibr ssbri cnvimass sylancr
      elun elsni simplr eliniseg ax-mp xpeq12d ineq2d indir incom syl5ss disjsn
      sylan9eqr syl5eq xpeq2d xp0 syl6eq eqtrd oveq12d eqeq1d sbcied cres eqtri
      un0 crn uneq12d wf wfun fpwwe2lem11 ffun funfvbrb fpwwe2lem5 syldan snssd
      3jca syl6ss wal cdif ssdif0 simpllr ovex breq2 rexsn simplrr sssn raleqdv
      neneqd ord breq1 rexeqbidv syl5bir mp1i wefr simplrl ssundif fri syl22anc
      difexg eldifn pm2.21d syl5 jaod con3d jctird undif1 sseqtr4i ralun ssralv
      ralimdv mpsyl eldifi expimpd reximdv2 pm2.61dne alrimiv df-fr anbi12i wor
      jctild solin sylan 3orim123d ancomd 3mix3 3mix1 eqtr3 syl2an 3mix2 ccased
      weso ralrimivv dfwe2 fpwwe2cbv fpwwe2lem3 xpexg sylancl unexg dmexg ssexg
      fvex snex nelne2 syl2anc necon3ai biorf orcom bitr4i syl6rbb 3bitr4g inxp
      id eqrdv dmss dmxpid ssneldd uneq2d eqcomd eleq1d rnss df-rn rnxpid sseld
      3sstr3g sylbid ndmima sneqd imaeq2d cnvxp reseq1i ssid xpssres rneqi snnz
      df-ima cnvun imaeq1i imaundir eqtr3i 3eqtr4g df-ss xpindi 3eqtr3g sylan2b
      rnxp jaodan ralrimiva mpbir2and relopabi releldmi syl6sseqr snss pm2.18da
      elssuni ) AHHGUEZFUFZHNZAVVJUGZOZVVIUHZHPVVJVVLVVMHVVMUIZHVVMHUJZVVLVVNGU
      KZUMZHVVLVVNVVHHVVMULZUIZGQZVVNVVPNVVNVVQPVVLVVTVVNEPZVVSVVNVVNULZPZOZVVN
      VVSUNZDUOZVVSVWFVWFULZUPZFUFZCUOZRZDVVSUQZVWJUHZURZUSZCVVNUTZOZVVLVWAVWCV
      VLHVVMEVVLHEPZVVHHHULZPZVVLVWRVWTOZHVVHUNZVWFVVHVWGUPFUFVWJRDVVHUQZVWMURZ
      USCHUTZOZVVLHVVHGQZVXAVXFOVVLHVVPNZVXGVVLBCDEFGHIJAESNVVKKVAZABUOZEPZIUOZ
      VXJVXJULPZVXJVXLUNZVBVXJVXLFUFENVVKLVCZMVDZVVLVVPVWSVEZGUUAGUUBVXHVXGVFVV
      LBCDEFGHIJVXIVXOMUUCVVPVXQGUUDHGUUEVGVHZVVLBCDEVVHFGHIJVXIVIVHZVJZVJZVVLV
      VIEAVVKVWRVWTVXBVBVVIENVVLVWRVWTVXBVYAVVLVWRVWTVXTVKZVVLVXBVXEVVLVXAVXFVX
      SVKVJZUUIABCDEVVHFGHIJKLUUFUUGUUHVLVVLVVHVVRVWBVVLVVHVWSVWBVYBHVVNPZVYDVW
      SVWBPHVVMVMZVYEHVVNHVVNVTVNUUJVVRVWBPZVVLVYDVVMVVNPVYFVYEVVOHVVNVVMVVNVTV
      NVOVLVPVVLVWEVWPVVLVVNVVSVQZVXJVWJVVSQZVXJVWJRZVWJVXJVVSQZVRZCVVNUTBVVNUT
      VWEVVLVXJVVNPZVXJTVSZOZUAUOZVWJVVSQZUGZUAVXJUTZCVXJWAZWLZBUUKVYGVVLVYTBVV
      LVYNVYSVVLVYNOZVYSVXJVVMUULZTWUBTRVXJVVMPZWUAVYSVXJVVMUUMWUAWUCVYSWUAWUCO
      ZVYSVVIVWJVVSQZUGZCVVMWAZWUDVVIVVIVVHQZUGZVVIVVIVVRQZUGZWUGWUDWUHVVJAVVKV
      YNWUCUUNZWUDWUHVVIVVIVWSQZVVJWUDVVHVWSVVIVVIVVLVWTVYNWUCVYBWBWCWUMVVJVVJV
      VIVVIHHWDWEWFWGWUDVVJWUJWULWUJVVJVVIVVMNVVIVVIHVVMWDWEWHWUGWUHWUJWMZUGZWU
      IWUKOWUFWUOCVVIHVVHFUUOZVWJVVIRZWUEWUNWUQWUEVVIVVIVVSQWUNVWJVVIVVIVVSUUPV
      VIVVIVVHVVRWIWJWKUUQWUHWUJWNWOWPWUDVYRWUFCVXJVVMWUDVXJTRZUGVXJVVMRZWUDVXJ
      TVVLVYLVYMWUCUURUVAWUDWURWUSWUDWUCWURWUSWMWUAWUCWQVXJVVIUUSWRUVBWSZWUDVYR
      VYQUAVVMUTZWUFWUDVYQUAVXJVVMWUTUUTVYQWUFUAVVIWUPVYOVVIRZVYPWUEVYOVVIVWJVV
      SUVCZWKWTWJUVDXAXBUVEWUAWUBTVSZVYSWUAWVDOZVYOVWJVVHQZUGZUAWUBUTZCWUBWAZVY
      SWVEWUBSNZHVVHVQZWUBHPZWVDWVIVXJSNWVJWVEBXEVXJVVMSUVLUVFVVLWVKVYNWVDVVLVX
      BWVKVYCHVVHUVGXFWBWVEVXJVVMHUIZPWVLWVEVXJVVNWVMVVLVYLVYMWVDUVHHVVMXCXDVXJ
      VVMHUVIWRWUAWVDWQCUAHWUBSVVHUVJUVKWVEWVHVYRCWUBVXJWVEVWJWUBNZWVHVWJVXJNZV
      YROWVEWVNOZWVHVYRWVOWVPWVHVYQUAWUBUTZWVAOZVYRWVPWVHWVQWVAWVPWVGVYQUAWUBWV
      PVYPWVFVYPWVFVYOVWJVVRQZWMZWVPWVFVYOVWJVVHVVRWIZWVPWVFWVFWVSWVPWVFXGWVSVW
      JVVMNZWVPWVFWVSVYOHNWWBVYOVWJHVVMWDXHZWVPWWBWVFWVNWWBUGWVEVWJVXJVVMUVMXIZ
      UVNUVOUVPXJUVQUWCWVPVVIVWJVVHQZUGZVVIVWJVVRQZUGZWVAWVPWWEVVJVVLVVKVYNWVDW
      VNAVVKWQXKWVPWWEVVIVWJVWSQZVVJWVPVVHVWSVVIVWJVVLVWTVYNWVDWVNVYBXKWCWWIVVJ
      VWJHNZVVIVWJHHWDWEWFWGWVPWWBWWGWWDWWGVVJWWBVVIVWJHVVMWDXHWHWVAWWEWWGWMZUG
      ZWWFWWHOVYQWWLUAVVIWUPWVBVYPWWKWVBVYPWUEWWKWVCVVIVWJVVHVVRWIWJWKWTWWEWWGW
      NWOWPUVRVXJWUBVVMUIZPWVRVYQUAWWMUTVYRVXJVXJVVMUIWWMVXJVVMVMVXJVVMUVSUVTVY
      QUAWUBVVMUWAVYQUAVXJWWMUWBUWDWFWVNWVOWVEVWJVXJVVMUWEXIUWMUWFUWGWSXBUWHXBU
      WIBCUAVVNVVSUWJXLVVLVYKBCVVNVVNVXJVVNNZVWJVVNNZOVXJHNZVXJVVMNZWMZWWJWWBWM
      ZOVVLVYKWWNWWRWWOWWSVXJHVVMXPVWJHVVMXPZUWKVVLWWPWWJWWQWWBVYKVVLWWPWWJOZVY
      KVVLWXAOZVXJVWJVVHQZVYIVWJVXJVVHQZVRZVYKVVLHVVHUWLZWXAWXEVVLVXBWXFVYCHVVH
      UXDXFHVXJVWJVVHUWNUWOWXBWXCVYHVYIVYIWXDVYJWXBVVHVVSVXJVWJVVHVVSPWXBVVHVVR
      VMVOZWCWXBVYIXGWXBVVHVVSVWJVXJWXGWCUWPWSXBVVLWWQWWJOZVYKVVLWXHOZVWJVXJVVR
      QZVYJVYKWXIWWJWWQOWXJWXIWWQWWJVVLWXHWQUWQVWJVXJHVVMWDXLVVRVVSVWJVXJVVRVVH
      UJZXMVYJVYHVYIUWRVGXBVVLWWPWWBOZVYKVVLWXLOZVXJVWJVVRQZVYHVYKWXMWXLWXNVVLW
      XLWQVXJVWJHVVMWDXLVVRVVSVXJVWJWXKXMVYHVYIVYJUWSVGXBWWQWWBOZVYKWLVVLWXOVYI
      VYKWWQVXJVVIRWUQVYIWWBVXJVVIXQVWJVVIXQZVXJVWJVVIUWTUXAVYIVYHVYJUXBXFVOUXC
      XJUXEBCVVNVVSUXFWPVVLVWOCVVNWWOVVLWWSVWOWWTVVLWWJVWOWWBVVLWWJOZVWOVXDVVHV
      XDVXDULZUPZFUFZVWJRZVVLUBUAUCEVWJVVHFGHUDBCUAUCDEFGUDIUBJUXGVXIVXRUXHWXQV
      WKWYADVWNSVVLVWNSNZWWJVVLVWNVVSUKZPWYCSNZWYBVVSVWMXNVVLVVSSNZWYDVVLVVHSNV
      VRSNZWYEHGUXNVVLVXHVVMSNWYFVXPVVIUXOHVVMVVPSUXIUXJVVHVVRSSUXKXOVVSSUXLXFV
      WNWYCSUXMXOZVAWXQVWFVWNRZOZVWIWXTVWJWYIVWFVXDVWHWXSFWYHWXQVWFVWNVXDWYHUYE
      ZWXQUAVWNVXDWXQVYPWVFVYOVWNNZVYOVXDNZWXQWVFWVSWVFWMZVYPWXQVWJVVIVSZWVSUGW
      VFWYMVFWXQWWJVVKWYNVVLWWJWQAVVKWWJXRZVWJVVIHUXPUXQWVSVWJVVIWVSWWBWUQWWCWX
      PXFUXRWVSWVFUXSVGWYMWVTVYPWVSWVFUXTWWAUYAUYBVWJSNZWYKVYPVFCXEZVVSVWJVYOSU
      AXEZXSXTWYPWYLWVFVFWYQVVHVWJVYOSWYRXSXTUYCUYFYGZWYIVWHVVSWXRUPZWXSWYIVWGW
      XRVVSWYIVWFVXDVWFVXDWYSWYSYAYBWXQWYTWXSRWYHWXQWYTWXSTUIZWXSWXQWYTWXSVVRWX
      RUPZUIXUAVVHVVRWXRYCWXQXUBTWXSWXQXUBHVXDUPZVVMVXDUPZULZTHVVMVXDVXDUYDWXQX
      UEXUCTULTWXQXUDTXUCWXQXUDVXDVVMUPZTVVMVXDYDWXQVVIVXDNUGXUFTRWXQVXDHVVIWXQ
      VXDVVHUKZHVVHVWMXNWXQXUGVWSUKZHWXQVWTXUGXUHPVVLVWTWWJVYBVAVVHVWSUYGXFHUYH
      XDYEWYOUYIVXDVVIYFXLYHYIXUCYJYKYHUYJYHWXSYRYKVAYLYMYNYOXAVVLWWBOZVWOVVIVW
      JRZXUIVWJVVIWWBWUQVVLWXPXIZUYKXUIVWKXUJDVWNSVVLWYBWWBWYGVAXUIWYHOZVWIVVIV
      WJXULVWFHVWHVVHFWYHXUIVWFVWNHWYJXUIVXDVVRUQZVWMURZUIZTHUIZVWNHXUIVXDTXUNH
      XUIVWJVXCUKZNZUGVXDTRXUIXURVVJAVVKWWBXRZXUIXURVVIXUQNVVJXUIVWJVVIXUQXUKUY
      LXUIXUQHVVIXUIVVHYSZVWSYSZXUQHXUIVWTXUTXVAPVVLVWTWWBVYBVAZVVHVWSUYMXFVVHU
      YNHUYOUYQUYPUYRWGVWJVXCUYSXFXUIXUNXUMVVMURZHXUIVWMVVMXUMXUIVWJVVIXUKUYTVU
      AXVCXUMVVMYPZYSZHXUMVVMVUHXVEVVMHULZYSZHXVDXVFXVDXVFVVMYPZXVFXUMXVFVVMHVV
      MVUBVUCVVMVVMPXVHXVFRVVMVUDVVMHVVMVUEXTYQVUFVVMTVSXVGHRVVIWUPVUGVVMHVURXT
      YQYQYKYTVWNVXCXUMUIZVWMURXUOVWLXVIVWMVVHVVRVUIVUJVXCXUMVWMVUKYQHTUIHXUPHY
      RHTXCVULVUMYGZXULVWHVVSVWSUPZVVHXULVWGVWSVVSXULVWFHVWFHXVJXVJYAYBXUIXVKVV
      HRWYHXUIXVKVVHTUIZVVHXUIXVKVVHVWSUPZVVRVWSUPZUIXVLVVHVVRVWSYCXUIXVMVVHXVN
      TXUIVWTXVMVVHRXVBVVHVWSVUNWRXUIHVVMHUPZULHTULXVNTXUIXVOTHXUIXVOHVVMUPZTVV
      MHYDXUIVVKXVPTRXUSHVVIYFXLYHYIHVVMHVUOHYJVUPYTYHVVHYRYKVAYLYMYNYOXAVUSVUQ
      VUTVPAVVTVWDVWQOVFVVKABCDEVVSFGVVNIJKVIVAVVAVVNVVSGVXKVXMOVXNVWFVXLVWGUPF
      UFVWJRDVXLUQVWMURUSCVXJUTOOBIGJVVBVVCVVNVVPVVGVGMVVDYEVVIHWUPVVEXLVVF $.

    $( Given any function ` F ` from well-orderings of subsets of ` A ` to
       ` A ` , there is a unique well-ordered subset ` <. X , ( W `` X ) >. `
       which "agrees" with ` F ` in the sense that each initial segment maps to
       its upper bound, and such that the entire set maps to an element of the
       set (so that it cannot be extended without losing the well-ordering).
       This theorem can be used to prove ~ dfac8a .  Theorem 1.1 of
       [KanamoriPincus] p. 415.  (Contributed by Mario Carneiro,
       18-May-2015.) $)
    fpwwe2 $p |- ( ph ->
      ( ( Y W R /\ ( Y F R ) e. Y ) <-> ( Y = X /\ R = ( W ` X ) ) ) ) $=
      ( wcel wa wceq wss cin vw vz wbr co cfv cdm wfun cxp cpw fpwwe2lem11 ffun
      wb wf syl funbrfv2b simprbda adantrr cuni elssuni syl6sseqr wi simpl cdif
      a1i c0 simplrr wne wral wrex cvv wfr adantr wwe ccnv csn cima fpwwe2lem12
      cv wn wsbc funfvbrb mpbid fpwwe2lem2 ad2antrr simpld difexg simprd difssd
      ssexd wefr fri expr syl21anc ssdif0 indif1 eqeq1i disj vex eliniseg ax-mp
      notbii ralbii bitri 3bitr2i cnvimass dmxpid syl6sseq syl5ss dfss1 syl5bbr
      sylib sseq1d rexbidv eldifn ad2antrl eleq1 notbid syl5ibrcom con2d simprr
      dmss imp breqd eldifi simpr brxp sylanbrc brin rbaib bitrd biimpa simplbi
      ad3antrrr ssbrd sylibr ex eqssd df-ss eqtrd jca syl6 mtod wor weso sselda
      sylbird wo sotric ioran syl6bb syl12anc mpbir2and ssrdv in32 ineq1d inss2
      eqtr3d xpss1 3eqtr3a xpeq12d oveq12d fpwwe2lem3 mpdan eqneltrd rexlimdvaa
      ineq2d sylbid necon4ad mpd w3a adantlr simprl fpwwe2lem10 mpjaod eqbrtrrd
      syld funbrfv sylc eqcomd fpwwe2lem13 breq12 oveq12 eleq12d anbi12d impbid
      ) AJFHUCZJFGUDZJPZQZJIRZFIHUEZRZQZAUWIUWMAUWIQZUWJUWLUWNJIUWNJHUFZPZJISZA
      UWFUWPUWHAUWFUWPJHUEFRZAHUGZUWFUWPUWRQULAUWOIIUHZUIZHUMUWSABCDEGHIKLMNOUJ
      UWOUXAHUKUNZJFHUOUNUPUQUWPJUWOURIJUWOUSOUTUNZUWNIJSZUWKFJIUHTRZQZUXDUWQFU
      WKIJUHZTZRZQZUXFUXDVAUWNUXDUXEVBVDUWNUXJUXDUWNUXJQZIJVCZVERZUXDUXKUWHUXMA
      UWFUWHUXJVFUXKUWHUXLVEUXKUXLVEVGZUAVRZUBVRZUWKUCZVSZUAUXLVHZUBUXLVIZUWHVS
      ZUXKUXLVJPZIUWKVKZUXLISZUXNUXTVAUXKIVJPUYBUXKIEVJUWNEVJPZUXJAUYEUWIMVLZVL
      ZUXKIESZUWKUWTSZUXKUYHUYIQZIUWKVMZDVRZUWKUYLUYLUHZTGUDCVRZRDUWKVNZUYNVOZV
      PVTCIVHZQZAUYJUYRQZUWIUXJAIUWKHUCZUYSAIUWOPZUYTABCDEGHIKLMNOVQAUWSVUAUYTU
      LUXBIHWAUNWBZABCDEUWKGHIKLMWCWBWDZWEZWEWIIJVJWFUNUXKUYKUYCUXKUYKUYQUXKUYJ
      UYRVUCWGWEZIUWKWJUNUXKIJWHUYBUYCQUYDUXNUXTUBUAIUXLVJUWKWKWLWMUXKUXTUYOUXP
      VOZVPZJSZUBUXLVIUYAUXKUXSVUHUBUXLUXSIVUGTZJSZUXKVUHVUJVUIJVCZVERUXLVUGTZV
      ERZUXSVUIJWNVULVUKVEIVUGJWOWPVUMUXOVUGPZVSZUAUXLVHUXSUAUXLVUGWQVUOUXRUAUX
      LVUNUXQUXPVJPVUNUXQULUBWRUWKUXPUXOVJUAWRWSWTZXAXBXCXDUXKVUIVUGJUXKVUGISVU
      IVUGRUXKVUGUWKUFZIUWKVUFXEUXKVUQUWTUFZIUXKUYIVUQVURSUXKUYHUYIVUDWGUWKUWTY
      AUNIXFXGXHVUGIXIXKXLXJXMUXKVUHUYAUBUXLUXKUXPUXLPZVUHQZQZUWGUXPJVVAUWGVUGU
      WKVUGVUGUHZTZGUDZUXPVVAJVUGFVVCGVVAJVUGVVAUAJVUGVVAUXOJPZVUNVVAVVEQZUXQVU
      NVVFUXQUXOUXPRZVSZUXPUXOUWKUCZVSZVVAVVEVVHVVAVVGVVEVVAVVEVSVVGUXPJPZVSZVU
      SVVLUXKVUHUXPIJXNXOZVVGVVEVVKUXOUXPJXPXQXRXSYBVVFVVIVVKVVAVVLVVEVVMVLVVFV
      VIUXPUXOFUCZVVKVVFVVNUXPUXOUXHUCZVVIVVFFUXHUXPUXOUXKUXIVUTVVEUWNUWQUXIXTW
      DYCVVFUXPUXOUXGUCZVVOVVIULVVFUXPIPZVVEVVPVVAVVQVVEVUSVVQUXKVUHUXPIJYDXOZV
      LZVVAVVEYEUXPUXOIJYFYGVVOVVIVVPUXPUXOUWKUXGYHYIUNYJVVFVVNUXPUXOJJUHZUCZVV
      KVVFFVVTUXPUXOUWNFVVTSZUXJVUTVVEUWNJESZVWBUWNVWCVWBQZJFVMUYLFUYMTGUDUYNRD
      FVNUYPVPVTCJVHQZAUWFVWDVWEQZUWHAUWFVWFABCDEFGHJKLMWCYKUQWEWGZYMYNVWAVVKVV
      EUXPUXOJJYFYLUUAUUFUUBVVFIUWKUUCZUXOIPZVVQUXQVVHVVJQZULVVFUYKVWHUXKUYKVUT
      VVEVUEWDIUWKUUDUNVVAJIUXOUWNUWQUXJVUTUXCWDZUUEVVSVWHVWIVVQQQUXQVVGVVIUUGV
      SVWJIUXOUXPUWKUUHVVGVVIUUIUUJUUKUULVUPYOYPUUMUXKVUSVUHXTYQZVVAFUWKVVTTZVV
      CVVAUXHVVTTZVWMUXGTZFVWMUWKUXGVVTUUNVVAFVVTTZVWNFVVAFUXHVVTUWNUWQUXIVUTVF
      UUOVVAVWBVWPFRUWNVWBUXJVUTVWGWDFVVTYRXKUUQVVAVWMUXGSVWOVWMRVVAVWMVVTUXGUW
      KVVTUUPVVAUWQVVTUXGSVWKJIJUURUNXHVWMUXGYRXKUUSVVAVVTVVBUWKVVAJVUGJVUGVWLV
      WLUUTUVFYSUVAVVAVVQVVDUXPRVVRVVABCDEUXPUWKGHIKLUXKUYEVUTUYGVLUWNUYTUXJVUT
      AUYTUWIVUBVLZWDUVBUVCYSVVMUVDUVEUVGUVPUVHUVIIJWNYOYPUWNBCDEUWKFGHIJKLUYFA
      BVRZESKVRZVWRVWRUHSVWRVWSVMUVJVWRVWSGUDEPUWINUVKVWQAUWFUWHUVLZUVMUVNYQZUW
      NUWKFUWNUWSIFHUCUWKFRAUWSUWIUXBVLUWNJIFHVXAVWTUVOIFHUVQUVRUVSYTYPAUWIUWMU
      YTIUWKGUDZIPZQAUYTVXCVUBABCDEGHIKLMNOUVTYTUWMUWFUYTUWHVXCJIFUWKHUWAUWMUWG
      VXBJIJIFUWKGUWBUWJUWLVBUWCUWDXRUWE $.
  $}

  ${
    $d a r s x A $.  $d a r s u v x y z F $.  $d r u x y ph $.  $d r u x y R $.
    $d r u x y X $.  $d r u x y Y $.
    fpwwe.1 $e |- W = { <. x , r >. | ( ( x C_ A /\ r C_ ( x X. x ) ) /\
      ( r We x /\ A. y e. x ( F ` ( `' r " { y } ) ) = y ) ) } $.
    $( Lemma for ~ fpwwe .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    fpwwecbv $p |- W = { <. a , s >. | ( ( a C_ A /\ s C_ ( a X. a ) ) /\
      ( s We a /\ A. z e. a ( F ` ( `' s " { z } ) ) = z ) ) } $=
      ( cv wss wa wwe cima cfv wceq wral weq anbi12d cxp csn copab simpl sseq1d
      ccnv simpr xpeq12d sseq12d weeq2 weeq1 sylan9bb imaeq2d fveq2d id eqeq12d
      sneq cbvralv cnveqd imaeq1d eqeq1d raleqbidv syl5bb cbvopabv eqtri ) FAKZ
      DLZHKZVFVFUAZLZMZVFVHNZVHUFZBKZUBZOZEPZVNQZBVFRZMZMZAHUCIKZDLZGKZWBWBUAZL
      ZMZWBWDNZWDUFZCKZUBZOZEPZWJQZCWBRZMZMZIGUCJWAWQAHIGAISZHGSZMZVKWGVTWPWTVG
      WCVJWFWTVFWBDWRWSUDZUEWTVHWDVIWEWRWSUGZWTVFWBVFWBXAXAUHUITWTVLWHVSWOWRVLW
      BVHNWSWHVFWBVHUJWBVHWDUKULVSVMWKOZEPZWJQZCVFRWTWOVRXEBCVFBCSZVQXDVNWJXFVP
      XCEXFVOWKVMVNWJUQUMUNXFUOUPURWTXEWNCVFWBXAWTXDWMWJWTXCWLEWTVMWIWKWTVHWDXB
      USUTUNVAVBVCTTVDVE $.

    $d r u x y W $.
    fpwwe.2 $e |- ( ph -> A e. _V ) $.
    $( Lemma for ~ fpwwe .  (Contributed by Mario Carneiro, 15-May-2015.) $)
    fpwwelem $p |- ( ph -> ( X W R <-> ( ( X C_ A /\ R C_ ( X X. X ) ) /\
      ( R We X /\ A. y e. X ( F ` ( `' R " { y } ) ) = y ) ) ) ) $=
      ( wss cxp wa wwe cv wceq cvv wcel anbi12d wbr ccnv csn cima cfv wral wrel
      relopabi brrelex12 sylan adantr simprll ssexd xpexg syl2anc simprlr simpl
      a1i jca sseq1d simpr xpeq12d sseq12d weeq2 sylan9bb cnveqd imaeq1d fveq2d
      weeq1 eqeq1d raleqbidv brabga pm5.21nd ) AHEGUAZHDLZEHHMZLZNZHEOZEUBZCPZU
      CZUDZFUEZWAQZCHUFZNZNZHRSZERSZNZAGUGZVNWKWLABPZDLZIPZWMWMMZLZNZWMWOOZWOUB
      ZWBUDZFUEZWAQZCWMUFZNZNZBIGJUHURHEGUIUJAWHNZWIWJXGHDRADRSWHKUKAVOVQWGULUM
      ZXGEVPRXGWIWIVPRSXHXHHHRRUNUOAVOVQWGUPUMUSXFWHBIHEGRRWMHQZWOEQZNZWRVRXEWG
      XKWNVOWQVQXKWMHDXIXJUQZUTXKWOEWPVPXIXJVAZXKWMHWMHXLXLVBVCTXKWSVSXDWFXIWSH
      WOOXJVSWMHWOVDHWOEVIVEXKXCWECWMHXLXKXBWDWAXKXAWCFXKWTVTWBXKWOEXMVFVGVHVJV
      KTTJVLVM $.

    fpwwe.3 $e |- ( ( ph /\ x e. ( ~P A i^i dom card ) ) -> ( F ` x ) e. A ) $.
    fpwwe.4 $e |- X = U. dom W $.
    $( Given any function ` F ` from the powerset of ` A ` to ` A ` , ~ canth2
       gives that the function is not injective, but we can say rather more
       than that.  There is a unique well-ordered subset
       ` <. X , ( W `` X ) >. ` which "agrees" with ` F ` in the sense that
       each initial segment maps to its upper bound, and such that the entire
       set maps to an element of the set (so that it cannot be extended without
       losing the well-ordering).  This theorem can be used to prove
       ~ dfac8a .  Theorem 1.1 of [KanamoriPincus] p. 415.  (Contributed by
       Mario Carneiro, 18-May-2015.) $)
    fpwwe $p |- ( ph ->
      ( ( Y W R /\ ( F ` Y ) e. Y ) <-> ( Y = X /\ R = ( W ` X ) ) ) ) $=
      ( cfv wcel wa c1st wceq cvv vu wbr ccom co cop df-ov wfn fo1st fofn ax-mp
      wfo opex fvco2 mp2an wrel cv wss cxp wwe ccnv csn cima relopabi brrelex12
      eqtri wral mpan op1stg syl fveq2d syl5eq eleq1d pm5.32i copab wsbc cnvexg
      cin vex imaexg mp2b inex1 fveq2 eqeq1d sbcie ralbii anbi2i opabbii eqtr4i
      algrflem w3a cpw ccrd simp1 elpw sylibr 19.8a 3ad2ant3 ween elin sylanbrc
      cdm wex sylan2 syl5eqel fpwwe2 syl5bbr ) IEGUBZIFOZIPZQXGIEFRUCZUDZIPZQAI
      HSEHGOSQXGXLXIXGXKXHIXGXKIEUEZROZFOZXHXKXMXJOZXOIEXJUFRTUGZXMTPXPXOSTTRUK
      XQUHTTRUIUJIEULTFRXMUMUNVEXGXNIFXGITPETPQZXNISGUOXGXRBUPZDUQZJUPZXSXSURUQ
      ZQZXSYAUSZYAUTZCUPZVAZVBZFOZYFSZCXSVFZQZQZBJGKVCIEGVDVGIETTVHVIVJVKVLVMAB
      CUADEXJGHIJGYMBJVNYCYDUAUPZYAYNYNURZVQZXJUDZYFSZUAYHVOZCXSVFZQZQZBJVNKUUB
      YMBJUUAYLYCYTYKYDYSYJCXSYRYJUAYHYATPYETPYHTPJVRZYATVPYEYGTVSVTYNYHSZYQYIY
      FUUDYQYNFOYIYNYPFUAVRYAYOUUCWAWIYNYHFWBVKWCWDWEWFWFWGWHLAXTYBYDWJZQXSYAXJ
      UDXSFOZDXSYAFBVRZUUCWIUUEAXSDWKZWLXAZVQPZUUFDPUUEXSUUHPZXSUUIPZUUJUUEXTUU
      KXTYBYDWMXSDUUGWNWOUUEYDJXBZUULYDXTUUMYBYDJWPWQXSJWRWOXSUUHUUIWSWTMXCXDNX
      EXF $.
  $}

  ${
    $d r x y A $.  $d r x y B $.  $d r x y D $.  $d r x y F $.  $d r x y V $.
    $d y C $.  $d r x y W $.
    canth4.1 $e |- W = { <. x , r >. | ( ( x C_ A /\ r C_ ( x X. x ) ) /\
      ( r We x /\ A. y e. x ( F ` ( `' r " { y } ) ) = y ) ) } $.
    canth4.2 $e |- B = U. dom W $.
    canth4.3 $e |- C = ( `' ( W ` B ) " { ( F ` B ) } ) $.
    $( An "effective" form of Cantor's theorem ~ canth .  For any function
       ` F ` from the powerset of ` A ` to ` A ` , there are two definable sets
       ` B ` and ` C ` which witness non-injectivity of ` F ` .  Corollary 1.3
       of [KanamoriPincus] p. 416.  (Contributed by Mario Carneiro,
       18-May-2015.) $)
    canth4 $p |- ( ( A e. V /\ F : D --> A /\ ( ~P A i^i dom card ) C_ D ) ->
      ( B C_ A /\ C C. B /\ ( F ` B ) = ( F ` C ) ) ) $=
      ( wcel wss cfv wceq wa simpld simprd wf cpw ccrd cdm cin w3a wpss cxp wwe
      ccnv cv csn cima wral wbr eqid pm3.2i elex 3ad2ant1 simpl2 simp3 ffvelrnd
      cvv sselda fpwwe mpbiri fpwwelem mpbid cnvimass eqsstri dmss syl syl6sseq
      dmxpid syl5ss wor wn weso sonr syl2anc eleq2i fvex eliniseg ax-mp sylnibr
      wb bitri ssnelpssd sneq imaeq2d syl6eqr fveq2d id eqeq12d rspcv sylc 3jca
      eqcomd ) CHNZFCGUAZCUBUCUDUEZFOZUFZDCOZEDUGDGPZEGPZQXCXDDIPZDDUHZOZXCXDXI
      RZDXGUIZXGUJZBUKZULZUMZGPZXMQZBDUNZRZXCDXGIUOZXJXSRXCXTXEDNZXCXTYARDDQZXG
      XGQZRYBYCDUPXGUPUQXCABCXGGIDDJKWSWTCVCNXBCHURUSZXCAUKZXANZRFCYEGWSWTXBYFU
      TXCXAFYEWSWTXBVAVDVBLVEVFZSXCABCXGGIDJKYDVGVHZSZSXCEDXEXCEXGUDZDEXLXEULZU
      MZYJMXGYKVIVJXCYJXHUDZDXCXIYJYMOXCXDXIYITXGXHVKVLDVNVMVOXCXTYAYGTZXCXEXEX
      GUOZXEENZXCDXGVPZYAYOVQXCXKYQXCXKXRXCXJXSYHTZSDXGVRVLYNDXEXGVSVTYPXEYLNZY
      OEYLXEMWAXEVCNYSYOWFDGWBZXGXEXEVCYTWCWDWGWEWHXCXFXEXCYAXRXFXEQZYNXCXKXRYR
      TXQUUABXEDXMXEQZXPXFXMXEUUBXOEGUUBXOYLEUUBXNYKXLXMXEWIWJMWKWLUUBWMWNWOWPW
      RWQ $.

    $( Lemma for ~ canthnum .  (Contributed by Mario Carneiro, 19-May-2015.) $)
    canthnumlem $p |- ( A e. V -> -. F : ( ~P A i^i dom card ) -1-1-> A ) $=
      ( wcel wceq wa cfv wss wb adantr cv cpw ccrd cdm cin wf1 wpss wf w3a ssid
      f1f canth4 mp3an3 sylan2 simp3d simpr simp1d elpw2g wwe wex ccnv csn cima
      mpbird wral cxp wbr eqid pm3.2i cvv elex ffvelrnda mpbiri simpld fpwwelem
      syl fpwwe mpbid simprd fvex weeq1 ween sylibr elin sylanbrc simp2d pssssd
      spcev sstrd ssnum syl2anc f1fveq syl12anc pssned necomd neneqd pm2.65da )
      CGMZCUAZUBUCZUDZCFUEZDENZWQXAOZDFPZEFPNZXBXCDCQZEDUFZXEXAWQWTCFUGZXFXGXEU
      HZWTCFUJZWQXHWTWTQXIWTUIABCDEWTFGHIJKLUKULUMZUNXCXADWTMZEWTMZXEXBRWQXAUOZ
      XCDWRMZDWSMZXLXCXOXFXCXFXGXEXKUPZWQXOXFRXADCGUQSVCXCDITZURZIUSZXPXCDDHPZU
      RZXTXCYBYAUTBTZVAVBFPYCNBDVDZXCXFYADDVEQOZYBYDOZXCDYAHVFZYEYFOXCYGXDDMZXC
      YGYHODDNZYAYANZOYIYJDVGYAVGVHXCABCYAFHDDIJWQCVIMXACGVJSZXCWTCATFXCXAXHXNX
      JVOVKKVPVLVMXCABCYAFHDIJYKVNVQVRVMXSYBIYADHVSDXRYAVTWGVODIWAWBZDWRWSWCWDX
      CEWRMZEWSMZXMXCYMECQZXCEDCXCEDXCXFXGXEXKWEZWFZXQWHWQYMYORXAECGUQSVCXCXPED
      QYNYLYQDEWIWJEWRWSWCWDWTCDEFWKWLVQXCDEXCEDXCEDYPWMWNWOWP $.
  $}

  ${
    $d a f r s x y z $.  $d a f r s x z A $.  $d a f s z V $.
    $( The set of well-orderable subsets of a set ` A ` strictly dominates
       ` A ` .  A stronger form of ~ canth2 .  Corollary 1.4(a) of
       [KanamoriPincus] p. 417.  (Contributed by Mario Carneiro,
       19-May-2015.) $)
    canthnum $p |- ( A e. V -> A ~< ( ~P A i^i dom card ) ) $=
      ( vx vf va vz vr vy vs wcel cdm cdom wbr cfn cvv wss cv wa cfv eqid pwexg
      cpw ccrd cin cen csdm inex1g infpwfidom 3syl syl finnum ssriv sslin ax-mp
      wn ssdomg ee10 domtr syl2anc wf1o wex wf1 cxp wwe ccnv csn cima wceq wral
      copab cuni fpwwecbv canthnumlem f1of1 nsyl nexdv ensym bren sylib brsdom
      sylanbrc ) ABJZAAUBZUCKZUDZLMZAWEUEMZUOAWEUFMWBAWCNUDZLMZWHWELMZWFWBWCOJZ
      WHOJWIABUAZWCNOUGAUHUIWBWEOJZWHWEPZWJWBWKWMWLWCWDOUGUJNWDPWNCNWDCQZUKULNW
      DWCUMUNWHWEOUPUQAWHWEURUSWBWEADQZUTZDVAZWGWBWQDWBWEAWPVBWQEFAWOAPGQZWOWOV
      CPRWOWSVDWSVEHQZVFVGWPSWTVHHWOVIRRCGVJZKVKZXBXASVEXBWPSVFVGZWPBXAICHFAWPX
      AIGEXATVLXBTXCTVMWEAWPVNVOVPWGWEAUEMWRAWEVQWEADVRVSVOAWEVTWA $.
  $}

  ${
    $d r u x y B $.  $d r x C $.  $d f r u v w x y O $.  $d f r u v w x y V $.
    $d a f r s v w x y z $.  $d a f r s u v w x y A $.  $d r u x y F $.
    $d r u x y W $.
    canthwe.1 $e |- O = { <. x , r >. |
      ( x C_ A /\ r C_ ( x X. x ) /\ r We x ) } $.
    ${
      canthwe.2 $e |- W = { <. x , r >. | ( ( x C_ A /\ r C_ ( x X. x ) ) /\
      ( r We x /\ A. y e. x [. ( `' r " { y } ) / u ].
        ( u F ( r i^i ( u X. u ) ) ) = y ) ) } $.
      canthwe.3 $e |- B = U. dom W $.
      canthwe.4 $e |- C = ( `' ( W ` B ) " { ( B F ( W ` B ) ) } ) $.
      $( Lemma for ~ canthnum .  (Contributed by Mario Carneiro,
         31-May-2015.) $)
      canthwelem $p |- ( A e. V -> -. F : O -1-1-> A ) $=
        ( wcel wa wceq cvv wss wf1 cfv co wbr ccnv cima eqid pm3.2i elex adantr
        csn cv cxp wwe w3a cop df-ov f1f ad2antlr copab opabid sylibr syl6eleqr
        simpr ffvelrnd syl5eqel fpwwe2 mpbiri simprd cin xpeq12i ineq2i oveq12i
        wf simpld fpwwe2lem3 mpdan syl5eq 3eqtr3g cnvimass wsbc wral fpwwe2lem2
        wb cdm mpbid dmss syl dmxpss syl6ss syl5ss syl5eqss sstrd a1i wess sylc
        inss2 weinxp sylib fvex cnvex imaexg ax-mp eqeltri inex1 sseq1d xpeq12d
        simpl sseq12d weeq2 weeq1 sylan9bb 3anbi123d opelopaba ssexd opelopabga
        syl3anbrc syl2anc f1fveq syl12anc opth1 eleqtrrd syl6eleq ovex eliniseg
        mpbir3and wor wn weso sonr pm2.65da ) DIPZHDGUAZEEJUBZGUCZYOYNUDZYLYMQZ
        YOYNUEZYOUKZUFZPZYPYQYOFYTYQYOEFYQEYNJUDZYOEPZYQUUBUUCQEERZYNYNRZQUUDUU
        EEUGYNUGUHYQABCDYNGJEEKMYLDSPYMDIUIUJZYQAULZDTZKULZUUGUUGUMZTZUUGUUIUNZ
        UOZQZUUGUUIGUCUUGUUIUPZGUBDUUGUUIGUQUUNHDUUOGYMHDGVNYLUUMHDGURUSUUNUUOU
        UMAKUTZHUUNUUMUUOUUPPYQUUMVDUUMAKVAVBLVCVEVFNVGVHZVIZYQFYNFFUMZVJZUPZEY
        NUPZRZFERYQUVAGUBZUVBGUBZRZUVCYQFUUTGUCZYOUVDUVEYQUVGYTYNYTYTUMZVJZGUCZ
        YOFYTUUTUVIGOUUSUVHYNFYTFYTOOVKVLVMYQUUCUVJYORUURYQABCDYOYNGJEKMUUFYQUU
        BUUCUUQVOZVPVQVRFUUTGUQEYNGUQVSYQYMUVAHPUVBHPUVFUVCWDYLYMVDYQUVAUUPHYQF
        DTZUUTUUSTZFUUTUNZUVAUUPPYQFEDYQFYTEOYQYTYNWEZEYNYSVTYQUVOEEUMZWEZEYQYN
        UVPTZUVOUVQTYQEDTZUVRYQUVSUVRQZEYNUNZCULZYNUWBUWBUMVJGUCBULZRCYRUWCUKUF
        WABEWBZQZYQUUBUVTUWEQUVKYQABCDYNGJEKMUUFWCWFZVOZVIZYNUVPWGWHEEWIWJWKWLZ
        YQUVSUVRUWGVOZWMUVMYQYNUUSWQWNYQFYNUNZUVNYQFETUWAUWKUWIYQUWAUWDYQUVTUWE
        UWFVIVOZFEYNWOWPFYNWRWSUUMUVLUVMUVNUOAKFUUTFYTSOYRSPYTSPYNEJWTZXAYRYSSX
        BXCXDZYNUUSUWMXEZUUGFRZUUIUUTRZQZUUHUVLUUKUVMUULUVNUWRUUGFDUWPUWQXHZXFU
        WRUUIUUTUUJUUSUWPUWQVDUWRUUGFUUGFUWSUWSXGXIUWPUULFUUIUNUWQUVNUUGFUUIXJF
        UUIUUTXKXLXMXNXQLVCYQUVBUUPHYQUVBUUPPZUVSUVRUWAUWJUWHUWLYQESPYNSPZUWTUV
        SUVRUWAUOZWDYQEDSUUFUWJXOUXAYQUWMWNUUMUXBAKEYNSSUUGERZUUIYNRZQZUUHUVSUU
        KUVRUULUWAUXEUUGEDUXCUXDXHZXFUXEUUIYNUUJUVPUXCUXDVDUXEUUGEUUGEUXFUXFXGX
        IUXCUULEUUIUNUXDUWAUUGEUUIXJEUUIYNXKXLXMXPXRYFLVCHDUVAUVBGXSXTWFFUUTEYN
        UWNUWOYAWHYBOYCYQUUCUUAYPWDUURYNYOYOEEYNGYDYEWHWFYQEYNYGZUUCYPYHYQUWAUX
        GUWLEYNYIWHUUREYOYNYJXRYK $.
    $}

    $( The set of well-orders of a set ` A ` strictly dominates ` A ` .  A
       stronger form of ~ canth2 .  Corollary 1.4(b) of [KanamoriPincus]
       p. 417.  (Contributed by Mario Carneiro, 31-May-2015.) $)
    canthwe $p |- ( A e. V -> A ~< O ) $=
      ( vv vf wcel wbr cvv cxp wss cv wwe wa csn c0 wceq eqid vu vy vw va vs vz
      cdom cen wn csdm cpw w3a copab simp1 vex elpw sylibr simp2 xpss12 syl2anc
      sstrd jca ssopab2i df-xp 3sstr4i pwexg xpexg anidms syl ssexg sylancr cop
      simpr snssd 0ss a1i wrel rel0 noel df-br mtbir wesn mpbiri mp1i 0ex simpl
      sseq1d xpeq12d sseq12d weeq2 weeq1 sylan9bb 3anbi123d opelopaba syl3anbrc
      snex syl6eleqr ex wb opth2 mpbiran2 sneqbg ax-mp bitri a1ii dom2d mpd wex
      wf1o wf1 cin ccnv cima wsbc wral cdm cuni fpwwe2cbv canthwelem f1of1 nsyl
      co cfv nexdv ensym bren sylib brsdom sylanbrc ) BDIZBCUGJZBCUHJZUIBCUJJYJ
      CKIZYKYJCBUKZBBLZUKZLZMYQKIZYMANZBMZENZYSYSLZMZYSUUAOZULZAEUMZYSYNIZUUAYP
      IZPZAEUMCYQUUEUUIAEUUEUUGUUHUUEYTUUGYTUUCUUDUNZYSBAUOUPUQUUEUUAYOMUUHUUEU
      UAUUBYOYTUUCUUDURUUEYTYTUUBYOMUUJUUJYSBYSBUSUTVAUUAYOEUOUPUQVBVCFAEYNYPVD
      VEYJYNKIYPKIZYRBDVFYJYOKIZUUKYJUULBBDDVGVHYOKVFVIYNYPKKVGUTCYQKVJVKYJUAGB
      CUANZQZRVLZGNZQZRVLZKYJUUMBIZUUOCIYJUUSPZUUOUUFCUUTUUNBMZRUUNUUNLZMZUUNRO
      ZUUOUUFIUUTUUMBYJUUSVMVNUVCUUTUVBVOVPRVQZUVDUUTVRUVEUVDUUMUUMRJZUIUVFUUMU
      UMVLZRIUVGVSUUMUUMRVTWAUUMRWBWCWDUUEUVAUVCUVDULAEUUNRUUMWPWEYSUUNSZUUARSZ
      PZYTUVAUUCUVCUUDUVDUVJYSUUNBUVHUVIWFZWGUVJUUARUUBUVBUVHUVIVMUVJYSUUNYSUUN
      UVKUVKWHWIUVHUUDUUNUUAOUVIUVDYSUUNUUAWJUUNUUARWKWLWMWNWOFWQWRYJUUSUUPBIPU
      UOUURSZUUMUUPSZWSUVLUUNUUQSZUVMUVLUVNRRSRTUUNRUUQRUUPWPWEWTXAUUMKIUVNUVMW
      SUAUOUUMUUPKXBXCXDXEXFXGYJCBHNZXIZHXHZYLYJUVPHYJCBUVOXJUVPAUBUCBUDNZBMUEN
      ZUVRUVRLMPUVRUVSOUUPUVSUUPUUPLXKUVOYBUFNZSGUVSXLUVTQXMXNUFUVRXOPPUDUEUMZX
      PXQZUWBUWAYCZXLUWBUWCUVOYBQXMZUVOCDUWAEFUDUFUBUCGBUVOUWAEUEAUWATXRUWBTUWD
      TXSCBUVOXTYAYDYLCBUHJUVQBCYECBHYFYGYABCYHYI $.
  $}

  ${
    $d x A $.
    $( Lemma for ~ canthp1 .  (Contributed by Mario Carneiro, 18-May-2015.) $)
    canthp1lem1 $p |- ( 1o ~< A -> ( A +c 2o ) ~<_ ~P A ) $=
      ( vx c1o csdm wbr c2o ccda co cxp cdom cpw wcel c0 wceq sylib csn cen cvv
      syl syl2anc 1sdom2 cdaxpdom mpan2 cv wn wex sdom0 breq2 mtbiri con2i neq0
      cdif relsdom brrelex2i adantr enrefg cpr df2o2 pwpw0 eqtr4i 0ex vex en2sn
      mp2an pwen ax-mp eqbrtri xpen sylancl snex pwex cun uncom wss simpr snssd
      undif syl5eq difexg canth2g domunsn 3syl eqbrtrrd xpdom1g sylancr endomtr
      pwcdaen ensymd domentr cin a1i incom disjdif eqtri cdaun syl3anc exlimddv
      wa breqtrd domtr ) CADEZAFGHZAFIZJEZXCAKZJEZXBXEJEXACFDEXDUAAFUBUCXABUDZA
      LZXFBXAAMNZUEXHBUFXIXAXIXACMDECUGAMCDUHUIUJBAUKOXAXHWRZXCAXGPZULZXKGHZKZJ
      EZXNXEQEZXFXJXCXLKZXKKZIZJEZXSXNQEXOXJXCAXRIZQEZYAXSJEZXTXJAAQEZFXRQEYBXJ
      ARLZYDXAYEXHCADUMUNUOZARUPSFMPZKZXRQFMYGUQYHURUSUTYGXKQEZYHXRQEMRLXGRLYIV
      ABVBMXGRRVCVDYGXKVEVFVGAAFXRVHVIXJXRRLAXQJEYCXKXGVJZVKXJXLXKVLZAXQJXJYKXK
      XLVLZAXLXKVMXJXKAVNYLANXJXGAXAXHVOVPXKAVQOVRZXJXLRLZXLXQDEYKXQJEXJYEYNYFA
      XKRVSSZXLRVTXLXQXGWAWBWCAXQXRRWDWEXCYAXSWFTXJXNXSXJYNXKRLZXNXSQEYOYJXLXKR
      RWGVIWHXCXSXNWITXJXMAQEXPXJXMYKAQXJYNYPXLXKWJZMNZXMYKQEYOYPXJYJWKYRXJYQXK
      XLWJMXLXKWLXKAWMWNWKXLXKRRWOWPYMWSXMAVESXCXNXEWITWQXBXCXEWTT $.
  $}

  ${
    $d r x y A $.  $d r x y B $.  $d r x y H $.  $d r x y ph $.  $d r x y W $.
    canthp1lem2.1 $e |- ( ph -> 1o ~< A ) $.
    canthp1lem2.2 $e |- ( ph -> F : ~P A -1-1-onto-> ( A +c 1o ) ) $.
    canthp1lem2.3 $e |- ( ph ->
      G : ( ( A +c 1o ) \ { ( F ` A ) } ) -1-1-onto-> A ) $.
    canthp1lem2.4 $e |- H = ( ( G o. F ) o.
      ( x e. ~P A |-> if ( x = A , (/) , x ) ) ) $.
    canthp1lem2.5 $e |- W = { <. x , r >. | ( ( x C_ A /\ r C_ ( x X. x ) ) /\
      ( r We x /\ A. y e. x ( H ` ( `' r " { y } ) ) = y ) ) } $.
    canthp1lem2.6 $e |- B = U. dom W $.
    $( Lemma for ~ canthp1 .  (Contributed by Mario Carneiro, 18-May-2015.) $)
    canthp1lem2 $p |- -. ph $=
      ( c1o wcel syl wceq ccda co cpw cen wbr wf1o csdm relsdom brrelex2i pwexg
      cvv f1oeng syl2anc ensym wn c2o cdom cfn wpss com canth2g sdomen2 sdomnen
      wb mpbid ccrd cdm con0 omelon onenon ax-mp wss cfv ccnv csn cima cin ccom
      wf w3a cdif cres cv c0 cif cmpt wfun wfo dff1o3 simprbi f1ofo wfn fnresdm
      f1ofn foeq1 4syl mpbird fvex f1osng sylancl fnressn f1oeq1 resdif syl3anc
      cop pwidg f1oco sylibr wne a1i eldifsn sylanbrc eqid pssned fveq1i elpw2g
      wa fvco3 3eqtr3d adantr ifcl sylancr eqeq1 ifbieq2d fvmptg neneqd iffalse
      id fveq2d fvres mpd wwe cxp simpld 2onn cun df-2o 1onn mto cdaval neneqad
      resco 0elpw sdom0 breq2 mtbii necon2ai ad2antrr simplr simpr ifclda fmptd
      f1of fco crn frn cores syl6eqr feq1d inss1 canth4 simp1d wi simp2d necomd
      simp3d 3eqtr3g pssssd sstrd pssne sspsstr sylan eqtrd anim12i 3eqtr4d wf1
      sylan9eq f1of1 f1fveq syl12anc ex necon3ad npss sylib wral pm3.2i ffvelrn
      wex sseli syl2an fpwwe mpbiri fpwwelem simprd weeq1 ween eqeltrrd domtri2
      spcev infcda1 syl6bir syl6 mt3d nnsdom cdafi isfinite csuc sseqtr4i xpss1
      sssucid unss2 mp1i ssun2 elexi sucid eleqtrri opelxpi mp2an sselii wo 1n0
      snid neii opelxp2 elsni word nnord ordirr mp2b opelxp1 pm3.2ni elun mtbir
      ssnelpss mp2ani psseq12d php3 canthp1lem1 sdomdomtr pm2.65i ) ADQUAUBZDUC
      ZUDUEZAVUBVUAUDUEZVUCAVUBUKRZVUBVUAFUFZVUDADUKRZVUEAQDUGUEZVUGKQDUGUHUISZ
      DUKUJSLVUBVUAUKFULUMZVUBVUAUNSAVUAVUBUGUEZVUCUOAVUADUPUAUBZUGUEZVULVUBUQU
      EZVUKAVULURRZVUAVULUSZVUMAVULUTUGUEZVUOADUTUGUEZUPUTUGUEZVUQAVURDVUAUDUEZ
      ADVUAUGUEZVUTUOADVUBUGUEZVVAAVUGVVBVUIDUKVASAVUDVVBVVAVDVUJVUBVUADVBSVEDV
      UAVCSAVURUOZVUADUDUEZVUTAVVCUTDUQUEZVVDAUTVFVGZRZDVVFRVVEVVCVDUTVHRVVGVIU
      TVJVKAEDVVFAEDVLZEDTZAVVHEIVMZVNZEHVMZVOVPZEUSZVVLVVMHVMZTZAVUGVUBDHVSZVU
      BVVFVQZVUBVLZVVHVVNVVPVTVUIAVUBDGFVRZVUBDVOZWAZWBZBVUBBWCZDTZWDVWDWEZWFZV
      RZVSZVVQAVWBDVWCVSZVUBVWBVWGVSZVWIAVWBDVWCUFZVWJAVWBDGFVWBWBZVRZUFZVWLAVU
      ADFVMZVOZWAZDGUFVWBVWRVWMUFZVWOMAFVNWGZVUBVUAFVUBWBZWHZVWAVWQFVWAWBZWHZVW
      SAVUFVWTLVUFVUBVUAFWHZVWTVUBVUAFWIWJSAVXBVXEAVUFVXELVUBVUAFWKSAVUFFVUBWLZ
      VXAFTVXBVXEVDLVUBVUAFWNZVUBFWMVUBVUAVXAFWOWPWQAVWAVWQVXCUFZVXDAVXHVWAVWQD
      VWPXEVOZUFZAVUGVWPUKRVXJVUIDFWRDVWPUKUKWSWTAVXCVXITZVXHVXJVDAVXFDVUBRZVXK
      AVUFVXFLVXGSAVUGVXLVUIDUKXFSVUBDFXAUMVWAVWQVXCVXIXBSWQVWAVWQVXCWKSVUBVWAV
      UAVWQFXCXDVWBVWRDGVWMXGUMVWCVWNTVWLVWOVDGFVWBUUBVWBDVWCVWNXBVKXHZVWBDVWCU
      UMSABVUBVWFVWBVWGAVWDVUBRZXQZVWEWDVWDVWBVXOVWEXQZWDVUBRZWDDXIZWDVWBRVXQVX
      PDUUCZXJAVXRVXNVWEAVUHVXRKVUHWDDWDDTQWDUGUEVUHQUUDWDDQUGUUEUUFUUGSUUHWDVU
      BDXKXLVXOVWEUOZXQZVXNVWDDXIVWDVWBRAVXNVXTUUIVYAVWDDVXOVXTUUJUUAVWDVUBDXKX
      LUUKVWGXMZUULZVUBVWBDVWCVWGUUNUMAVUBDVWHHAVWHVVTVWGVRZHAVWGUUOVWBVLZVWHVY
      DTAVWKVYEVYCVUBVWBVWGUUPSVVTVWGVWBUUQSNUURUUSVEZVVSAVUBVVFUUTZXJBCDEVVMVU
      BHUKIJOPVVMXMUVAXDZUVBZAEDUSZUOZVVHVVIUVCAEVVMXIVYKAVVMEAVVMEAVVHVVNVVPVY
      HUVDZXNUVEAVYJEVVMAVYJEVVMTZAVYJXQZEVWCVMZVVMVWCVMZTZVYMVYNEVVTVMZVVMVVTV
      MZVYOVYPVYNEVWGVMZVVTVMZVVMVWGVMZVVTVMZVYRVYSAWUAWUCTVYJAEVYDVMZVVMVYDVMZ
      WUAWUCAVVLVVOWUDWUEAVVHVVNVVPVYHUVFEHVYDNXOVVMHVYDNXOUVGAVWKEVUBRZWUDWUAT
      VYCAWUFVVHVYIAVUGWUFVVHVDVUIEDUKXPSWQZVUBVWBEVVTVWGXRUMAVWKVVMVUBRZWUEWUC
      TVYCAWUHVVMDVLZAVVMEDAVVMEVYLUVHZVYIUVIAVUGWUHWUIVDVUIVVMDUKXPSWQZVUBVWBV
      VMVVTVWGXRUMXSXTVYNVYTEVVTAVYJVYTVVIWDEWEZEAWUFWULVUBRZVYTWULTWUGAVXQWUFW
      UMVXSWUGVVIWDEVUBYAYBBEVWFWULVUBVUBVWGVWDETZVWEVVIVWDEWDVWDEDYCWUNYHYDVYB
      YEUMVYJVVIUOWULETVYJEDEDUVJZYFVVIWDEYGSUVQYIVYNWUBVVMVVTVYNWUBVVMDTZWDVVM
      WEZVVMAWUBWUQTZVYJAWUHWUQVUBRZWURWUKAVXQWUHWUSVXSWUKWUPWDVVMVUBYAYBBVVMVW
      FWUQVUBVUBVWGVWDVVMTZVWEWUPVWDVVMWDVWDVVMDYCWUTYHYDVYBYEUMXTVYNWUPUOWUQVV
      MTVYNVVMDVYNVVMDAVVMEVLVYJVVMDUSWUJVVMEDUVKUVLXNZYFWUPWDVVMYGSUVMYIXSVYNE
      VWBRZVYOVYRTVYNWUFEDXIZXQWVBAWUFVYJWVCWUGWUOUVNEVUBDXKXHZEVWBVVTYJSVYNVVM
      VWBRZVYPVYSTVYNWUHVVMDXIWVEAWUHVYJWUKXTWVAVVMVUBDXKXLZVVMVWBVVTYJSUVOVYNV
      WBDVWCUVPZWVBWVEVYQVYMVDAWVGVYJAVWLWVGVXMVWBDVWCUVRSXTWVDWVFVWBDEVVMVWCUV
      SUVTVEUWAUWBYKEDUWCUWDYKAEJWCZYLZJUWHZEVVFRAEVVJYLZWVJAWVKVVKCWCZVOVPHVMW
      VLTCEUWEZAVVHVVJEEYMVLXQZWVKWVMXQZAEVVJIUEZWVNWVOXQAWVPVVLERZAWVPWVQXQEET
      ZVVJVVJTZXQWVRWVSEXMVVJXMUWFABCDVVJHIEEJOVUIAVVQVXNVWDHVMDRVWDVVRRVYFVVRV
      UBVWDVYGUWIVUBDVWDHUWGUWJPUWKUWLYNABCDVVJHIEJOVUIUWMVEUWNYNWVIWVKJVVJEIWR
      EWVHVVJUWOUWSSEJUWPXHUWQUTDUWRYBDUWTUXAVUADUNUXBUXCUPUTRZVUSYOUPUXDVKDUPU
      XEWTVULUXFXHAVUPDWDVOZYMZQQVOZYMZYPZWWBUPWWCYMZYPZUSZAWWEWWGVLZWWHWWDWWFV
      LZWWIAQUPVLWWJQQUXGZUPQUXJYQUXHQUPWWCUXIVKWWDWWFWWBUXKUXLWWIQQXEZWWGRWWLW
      WERZUOWWHWWFWWGWWLWWFWWBUXMQUPRQWWCRWWLWWFRQWWKUPQQUTYRUXNZUXOYQUXPQWWNUY
      BQQUPWWCUXQUXRUXSWWMWWLWWBRZWWLWWDRZUXTWWOWWPWWOQWDTZQWDUYAUYCWWOQWWARWWQ
      QQDWWAUYDQWDUYESYSWWPQQRZQUTRZQUYFWWRUOYRQUYGQUYHUYIQQQWWCUYJYSUYKWWLWWBW
      WDUYLUYMWWEWWGWWLUYNUYOSAVUAWWEVULWWGAVUGWWSVUAWWETVUIYRDQUKUTYTWTAVUGWVT
      VULWWGTVUIYODUPUKUTYTWTUYPWQVULVUAUYQUMAVUHVUNKDUYRSVUAVULVUBUYSUMVUAVUBV
      CSUYT $.
  $}

  ${
    $d a f g r s w x y z A $.
    $( A slightly stronger form of Cantor's theorem:  For ` 1 < n ` ,
       ` n + 1 < 2 ^ n ` .  Corollary 1.6 of [KanamoriPincus] p. 417.
       (Contributed by Mario Carneiro, 18-May-2015.) $)
    canthp1 $p |- ( 1o ~< A -> ( A +c 1o ) ~< ~P A ) $=
      ( vf vg vx va vs vz vw c1o csdm wbr cdom cen c2o wfal cv wa wcel wceq c0
      vy vr ccda co cpw wn 1sdom2 sdomdom cdadom2 canthp1lem1 domtr sylancr fal
      mp2b wf1o wex ensym bren sylib cfv csn cdif wf f1of cvv relsdom brrelex2i
      pwidg syl ffvelrn syl2anr cda1dif wss cxp wwe ccnv cima ccom cif cmpt cdm
      wral copab cuni simpll simplr simpr eqeq1 id ifbieq2d cbvmptv coeq2i eqid
      fpwwecbv canthp1lem2 pm2.21i exlimddv exlimdv syl5 mtoi brsdom sylanbrc
      ex ) IAJKZAIUCUDZAUEZLKZXEXFMKZUFXEXFJKXDXEANUCUDZLKZXIXFLKXGINJKINLKXJUG
      INUHINAUIUNAUJXEXIXFUKULXDXHOUMXHXFXEBPZUOZBUPZXDOXHXFXEMKXMXEXFUQXFXEBUR
      USXDXLOBXDXLOXDXLQZXEAXKUTZVAVBZACPZUOZOCXNXPAMKZXRCUPXNXOXERZXSXLXFXEXKV
      CAXFRZXTXDXFXEXKVDXDAVERYAIAJVFVGAVEVHVIXFXEAXKVJVKAXOVLVIXPACURUSXNXRQZO
      YBDUAAEPZAVMFPZYCYCVNVMQYCYDVOYDVPGPZVAVQXQXKVRZHXFHPZASZTYGVSZVTZVRZUTYE
      SGYCWBQQEFWCZWAWDZXKXQYKYLUBXDXLXRWEXDXLXRWFXNXRWGYJDXFDPZASZTYNVSZVTYFHD
      XFYIYPYGYNSZYHYOYGYNTYGYNAWHYQWIWJWKWLEGUAAYKYLUBFDYLWMWNYMWMWOWPWQXCWRWS
      WTXEXFXAXB $.
  $}

  ${
    $d a f g r s w x y z A $.
    $( The exclusion of finite sets from consideration in ~ df-gch is
       necessary, because otherwise finite sets larger than a singleton would
       violate the GCH property.  (Contributed by Mario Carneiro,
       10-Jun-2015.) $)
    finngch $p |- ( ( A e. Fin /\ 1o ~< A ) ->
        ( A ~< ( A +c 1o ) /\ ( A +c 1o ) ~< ~P A ) ) $=
      ( cfn wcel c1o ccda csdm wbr cpw cfin4 cfin2 cfin3 fin12 fin23 fin34 3syl
      co isfin4-3 sylib canthp1 anim12i ) ABCZAADEPZFGZDAFGUBAHFGUAAICZUCUAAJCA
      KCUDALAMANOAQRAST $.
  $}

  $( An infinite GCH-set is idempotent under cardinal successor.  (Contributed
     by Mario Carneiro, 18-May-2015.) $)
  gchcda1 $p |- ( ( A e. GCH /\ -. A e. Fin ) -> ( A +c 1o ) ~~ A ) $=
    ( cgch wcel cfn wn wa c1o ccda co cdom wbr cpw csdm cen com 1onn a1i sylan2
    mp1i syl cdadom3 simpr wb nnfi fidomtri2 wi domfi ex sylbird canthp1 gchen1
    mt3d jca mpdan ensymd ) ABCZADCZEZFZAAGHIZUSAUTJKZUTALMKZFAUTNKUSVAVBURUPGO
    CZVAVCURPQAGBOUARUSGAMKZVBUSVDUQUPURUBUSVDEZAGJKZUQURUPGDCZVFVEUCVCVGURPGUD
    ZSAGBUERUSVGVFUQUFVCVGUSPVHSVGVFUQGAUGUHTUIULAUJTUMAUTUKUNUO $.

  $( An infinite GCH-set is Dedekind-infinite.  (Contributed by Mario Carneiro,
     31-May-2015.) $)
  gchinf $p |- ( ( A e. GCH /\ -. A e. Fin ) -> om ~<_ A ) $=
    ( cgch wcel cfn wn wa c1o ccda co cen wbr com gchcda1 ensymd cfin4 isfin4-2
    cdom wb adantr csdm isfin4-3 sdomnen sylbi syl6bir mt4d ) ABCZADCEZFZAAGHIZ
    JKZLAQKZUHUIAAMNUHUKEZAOCZUJEZUFUMULRUGABPSUMAUITKUNAUAAUIUBUCUDUE $.

  ${
    $d n r w x z $.  $d n y z D $.  $d a b s v y F $.  $d w y G $.  $d w y K $.
    $d a b r s v x y z H $.  $d a b n r s v x z ph $.  $d n z ps $.  $d s R $.
    $d a n r s x y z A $.  $d a b s v W $.  $d a b s v Z $.  $d a s Y $.
    pwfseqlem4.g $e |- ( ph -> G : ~P A -1-1-> U_ n e. om ( A ^m n ) ) $.
    pwfseqlem4.x $e |- ( ph -> X C_ A ) $.
    pwfseqlem4.h $e |- ( ph -> H : om -1-1-onto-> X ) $.
    pwfseqlem4.ps $e |- ( ps <->
      ( ( x C_ A /\ r C_ ( x X. x ) /\ r We x ) /\ om ~<_ x ) ) $.
    pwfseqlem4.k $e |- ( ( ph /\ ps ) ->
      K : U_ n e. om ( x ^m n ) -1-1-> x ) $.
    pwfseqlem4.d $e |- D = ( G ` { w e. x |
      ( ( `' K ` w ) e. ran G /\ -. w e. ( `' G ` ( `' K ` w ) ) ) } ) $.
    $( Lemma for ~ pwfseq .  Derive a contradiction by diagonalization.
       (Contributed by Mario Carneiro, 31-May-2015.) $)
    pwfseqlem1 $p |- ( ( ph /\ ps ) ->
        D e. ( U_ n e. om ( A ^m n ) \ U_ n e. om ( x ^m n ) ) ) $=
      ( wa wcel vy com cv cmap co ciun ccnv cfv crn crab cpw wf1 adantr f1f syl
      wn wf wss ssrab2 cxp wwe w3a cdom wbr simprl1 sylan2b syl5ss rabex sylibr
      vex elpw ffvelrnd syl5eqel wb pm5.19 ffvelrn sylancom wf1o wceq f1ocnvfv1
      f1f1orn wfn f1fn fnfvelrn syl2anc eqeltrd eleq1d id fveq2d eleq12d notbid
      fveq2 anbi12d cbvrabv elrab2 anass bitr4i baib syl6eq eqtrd bitrd ex mtoi
      eleq2d eldifd ) ABSZFGUBEGUCZUDUEUFZGUBCUCZXGUDUEUFZXFFDUCZJUGZUHZHUIZTZX
      KXMHUGZUHZTZUPZSZDXIUJZHUHZXHRXFEUKZXHYAHXFYCXHHULZYCXHHUQAYDBMUMZYCXHHUN
      UOXFYAEURYAYCTZXFYAXIEXTDXIUSBAXIEURZLUCZXIXIUTURZXIYHVAZVBUBXIVCVDZSYGPY
      GYIYJYKAVEVFVGYAEXTDXICVJVHVKVIZVLVMXFFXJTZFJUHZYATZYOUPZVNZYOVOXFYMYQXFY
      MSZYOYNYNXLUHZXPUHZTZUPZYPYRYNXITZYSXNTZYOUUBVNXFYMXJXIJUQZUUCYRXJXIJULZU
      UEXFUUFYMQUMZXJXIJUNUOXJXIFJVPVQYRYSFXNXFYMXJJUIZJVRZYSFVSYRUUFUUIUUGXJXI
      JWAUOXJUUHFJVTVQZXFFXNTYMXFFYBXNRXFHYCWBZYFYBXNTXFYDUUKYEYCXHHWCUOYLYCYAH
      WDWEVMUMWFYOUUCUUDSZUUBYOUUCUUDUUBSZSUULUUBSUAUCZXLUHZXNTZUUNUUOXPUHZTZUP
      ZSZUUMUAYNXIYAUUNYNVSZUUPUUDUUSUUBUVAUUOYSXNUUNYNXLWLZWGUVAUURUUAUVAUUNYN
      UUQYTUVAWHUVAUUOYSXPUVBWIWJWKWMXTUUTDUAXIXKUUNVSZXOUUPXSUUSUVCXMUUOXNXKUU
      NXLWLZWGUVCXRUURUVCXKUUNXQUUQUVCWHUVCXMUUOXPUVDWIWJWKWMWNWOUUCUUDUUBWPWQW
      RWEYRUUAYOYRYTYAYNYRYTYBXPUHZYAYRYSYBXPYRYSFYBUUJRWSWIXFUVEYAVSZYMXFYCXNH
      VRZYFUVFXFYDUVGYEYCXHHWAUOYLYCXNYAHVTWEUMWTXDWKXAXBXCXE $.

    pwfseqlem4.f $e |- F = ( x e. _V , r e. _V |-> if ( x e. Fin ,
      ( H ` ( card ` x ) ) , ( D ` |^| { z e. om | -. ( D ` z ) e. x } ) ) ) $.
    $( Lemma for ~ pwfseq .  (Contributed by Mario Carneiro, 18-Nov-2014.) $)
    pwfseqlem2 $p |- ( ( Y e. Fin /\ R e. _V ) ->
        ( Y F R ) = ( H ` ( card ` Y ) ) ) $=
      ( va vs cv co ccrd cfv wceq cfn cvv oveq1 fveq2 fveq2d eqeq12d oveq2 nfcv
      eqeq1d wcel com crab cint cif cmpt2 nfmpt21 nfcxfr nfov nfeq1 nfmpt22 vex
      wn fvex ifex ovmpt4g mp3an iftrue syl5eq adantr vtocl2gaf vtocl2ga ) UDUF
      ZUEUFZJUGZWBUHUIZLUIZUJZOWCJUGZOUHUIZLUIZUJOHJUGZWJUJUDUEOHUKULWBOUJZWDWH
      WFWJWBOWCJUMWLWEWILWBOUHUNUOUPWCHUJWHWKWJWCHOJUQUSCUFZPUFZJUGZWMUHUIZLUIZ
      UJZWBWNJUGZWFUJWGCPWBWCUKULCWBURZPWBURZPWCURZCWSWFCWBWNJWTCJCPULULWMUKUTZ
      WQDUFGUIWMUTVLDVAVBVCZGUIZVDZVEZUCCPULULXFVFVGCWNURVHVIPWDWFPWBWCJXAPJXGU
      CCPULULXFVJVGXBVHVIWMWBUJZWOWSWQWFWMWBWNJUMXHWPWELWMWBUHUNUOUPWNWCUJWSWDW
      FWNWCWBJUQUSXCWRWNULUTZXCWOXFWQWMULUTXIXFULUTWOXFUJCVKPVKXCWQXEWPLVMXDGVM
      VNCPULULXFJULUCVOVPXCWQXEVQVRVSVTWA $.

    $( Lemma for ~ pwfseq .  Using the construction ` D ` from ~ pwfseqlem1 ,
       produce a function ` F ` that maps any well-ordered infinite set to an
       element outside the set.  (Contributed by Mario Carneiro,
       31-May-2015.) $)
    pwfseqlem3 $p |- ( ( ph /\ ps ) -> ( x F r ) e. ( A \ x ) ) $=
      ( vy wa cv co cfv wcel com crab cint cdif cfn ccrd cif cvv wceq fvex ifex
      wn vex ovmpt4g mp3an csdm wbr cdom wss cxp wwe w3a simprbi adantl domnsym
      syl isfinite sylnibr iffalse syl5eq cmap ciun wrex pwfseqlem1 eldif sylib
      simpld eliun wf elmapi ad2antll wral ssiun2 ad2antrl simprd ssneldd elmap
      adantr wfn ffn ffnfv baib 3syl syl5bb mtbid con0 nnon ssrab2 omsson sstri
      wb wne word ordom simprl ordelss sylancr rexnal sylibr ssrexv rabn0 onint
      sylc sseldi ontri1 syl2anc ssintrab syl2an imbi2d con34b syl6bbr pm5.74da
      c0 wi bi2.04 syl6bb elnn pm2.27 expcom a2d fveq2 eleq1d notbid rexlimddv
      sylbid ralimdv2 syl5bi sylbird ffvelrnd cbvrabv elrab2 eldifd eqeltrd
      mt3d ) ABUCZCUDZNUDZIUEZDUDZGUFZUUMUGZUSZDUHUIZUJZGUFZFUUMUKZUULUUOUUMULU
      GZUUMUMUFZKUFZUVBUNZUVBUUMUOUGUUNUOUGUVGUOUGUUOUVGUPCUTZNUTUVDUVFUVBUVEKU
      QUVAGUQURCNUOUOUVGIUOUAVAVBUULUVDUSUVGUVBUPUULUUMUHVCVDZUVDUULUHUUMVEVDZU
      VIUSBUVJABUUMFVFUUNUUMUUMVGVFUUMUUNVHVIUVJRVJVKUHUUMVLVMUUMVNVOUVDUVFUVBV
      PVMVQUULGFHUDZVRUEZUGZUVBUVCUGHUHUULGHUHUVLVSZUGZUVMHUHVTUULUVOGHUHUUMUVK
      VRUEZVSZUGUSZUULGUVNUVQUKUGUVOUVRUCABCEFGHJKLMNOPQRSTWAGUVNUVQWBWCZWDHGUH
      UVLWEWCUULUVKUHUGZUVMUCZUCZUVBFUUMUWBUVKFUVAGUVMUVKFGWFZUULUVTGFUVKWGWHZU
      WBUVAUVKUGZUURDUVKWIZUWBGUVPUGZUWFUWBUVPUVQGUVTUVPUVQVFUULUVMHUHUVPWJWKUU
      LUVRUWAUULUVOUVRUVSWLWOWMUWGUVKUUMGWFZUWBUWFUUMUVKGUVHHUTWNUWBUWCGUVKWPZU
      WHUWFXHUWDUVKFGWQUWHUWIUWFDUVKUUMGWRWSWTXAXBZUWBUWEUSZUVKUVAVFZUWFUWBUVKX
      CUGZUVAXCUGUWLUWKXHUVTUWMUULUVMUVKXDZWKUWBUUTXCUVAUUTUHXCUUSDUHXEXFXGZUWB
      UUTXCVFUUTYJXIZUVAUUTUGZUWOUWBUUSDUHVTZUWPUWBUVKUHVFZUUSDUVKVTZUWRUWBUHXJ
      UVTUWSXKUULUVTUVMXLUHUVKXMXNUWBUWFUSUWTUWJUURDUVKXOXPUUSDUVKUHXQXTUUSDUHX
      RXPUUTXSXNZYAUVKUVAYBYCUWLUUSUVKUUPVFZYKZDUHWIUWBUWFUUSDUVKUHYDUWBUXCUURD
      UHUVKUVTUUPUHUGZUXCYKZUUPUVKUGZUURYKZYKUULUVMUVTUXEUXFUXDUURYKZYKZUXGUVTU
      XEUXDUXGYKUXIUVTUXDUXCUXGUVTUXDUCZUXCUUSUXFUSZYKUXGUXJUXBUXKUUSUVTUWMUUPX
      CUGUXBUXKXHUXDUWNUUPXDUVKUUPYBYEYFUXFUURYGYHYIUXDUXFUURYLYMUVTUXFUXHUURUX
      FUVTUXHUURYKZUXFUVTUCUXDUXLUUPUVKYNUXDUURYOVMYPYQUUBWKUUCUUDUUEUUKUUFUWBU
      WQUVBUUMUGZUSZUXAUWQUVAUHUGUXNUBUDZGUFZUUMUGZUSZUXNUBUVAUHUUTUXOUVAUPZUXQ
      UXMUXSUXPUVBUUMUXOUVAGYRYSYTUUSUXRDUBUHUUPUXOUPZUURUXQUXTUUQUXPUUMUUPUXOG
      YRYSYTUUGUUHVJVMUUIUUAUUJ $.

    $( Lemma for ~ pwfseqlem4 .  (Contributed by Mario Carneiro,
       7-Jun-2016.) $)
    pwfseqlem4a $p |- ( ( ph /\ ( a C_ A /\ s C_ ( a X. a ) /\ s We a ) ) ->
      ( a F s ) e. A ) $=
      ( cv wss cxp wwe w3a wa com csdm wbr co wcel cfn isfinite wi ccrd cfv cvv
      wceq vex pwfseqlem2 sylancl wf wf1o f1of syl fss syl2anc ficardom ffvelrn
      simpr syl2an eqeltrd ex adantr syl5bir wn cdom cdm wb omelon onenon ax-mp
      con0 wex simpr3 19.8a ween sylibr domtri2 sylancr cdif nfv nfcv crab cint
      cif cmpt2 nfmpt22 nfcxfr nfov nfel1 nfim weq sseq1 3anbi23d anbi1d anbi2d
      weeq1 oveq2 eleq1d imbi12d nfmpt21 xpeq12 anidms sseq2d 3anbi123d anbi12d
      weeq2 breq2 syl5bb oveq1 eleq12d pwfseqlem3 chvar eldifad sylbird pm2.61d
      difeq2 expr ) APUDZFUEZNUDZYMYMUFZUEZYMYOUGZUHZUIZYMUJUKULZYMYOIUMZFUNZUU
      AYMUOUNZYTUUCYMUPAUUDUUCUQYSAUUDUUCAUUDUIZUUBYMURUSZKUSZFUUEUUDYOUTUNUUBU
      UGVAAUUDVMNVBABCDEFGYOHIJKLMYMOQRSTUAUBUCVCVDAUJFKVEZUUFUJUNUUGFUNUUDAUJM
      KVEZMFUEUUHAUJMKVFUUISUJMKVGVHRUJMFKVIVJYMVKUJFUUFKVLVNVOVPVQVRYTUUAVSZUJ
      YMVTULZUUCYTUJURWAZUNZYMUULUNZUUKUUJWBUJWFUNUUMWCUJWDWEYTYRNWGZUUNYTYRUUO
      AYNYQYRWHYRNWIVHYMNWJWKUJYMWLWMAYSUUKUUCAYSUUKUIZUIZUUBFYMAYNOUDZYPUEZYMU
      URUGZUHZUUKUIZUIZYMUURIUMZFYMWNZUNZUQZUUQUUBUVEUNZUQONUUQUVHOUUQOWOOUUBUV
      EOYMYOIOYMWPOICOUTUTCUDZUOUNUVIURUSKUSDUDGUSUVIUNVSDUJWQWRGUSWSZWTZUCCOUT
      UTUVJXAXBOYOWPXCXDXEONXFZUVCUUQUVFUVHUVLUVBUUPAUVLUVAYSUUKUVLUUSYQUUTYRYN
      UURYOYPXGYMUURYOXKXHXIXJUVLUVDUUBUVEUURYOYMIXLXMXNABUIZUVIUURIUMZFUVIWNZU
      NZUQUVGCPUVCUVFCUVCCWOCUVDUVECYMUURICYMWPCIUVKUCCOUTUTUVJXOXBCUURWPXCXDXE
      CPXFZUVMUVCUVPUVFUVQBUVBABUVIFUEZUURUVIUVIUFZUEZUVIUURUGZUHZUJUVIVTULZUIU
      VQUVBTUVQUWBUVAUWCUUKUVQUVRYNUVTUUSUWAUUTUVIYMFXGUVQUVSYPUURUVQUVSYPVAUVI
      YMUVIYMXPXQXRUVIYMUURYAXSUVIYMUJVTYBXTYCXJUVQUVNUVDUVOUVEUVIYMUURIYDUVIYM
      FYKYEXNABCDEFGHIJKLMOQRSTUAUBUCYFYGYGYHYLYIYJ $.

    pwfseqlem4.w $e |- W = { <. a , s >. |
    ( ( a C_ A /\ s C_ ( a X. a ) ) /\ ( s We a /\ A. b e. a
      [. ( `' s " { b } ) / v ]. ( v F ( s i^i ( v X. v ) ) ) = b ) ) } $.
    pwfseqlem4.z $e |- Z = U. dom W $.
    $( Lemma for ~ pwfseq .  Derive a final contradiction from the function
       ` F ` in ~ pwfseqlem3 .  Applying ~ fpwwe2 to it, we get a certain
       maximal well-ordered subset ` Z ` , but the defining property
       ` ( Z F ( W `` Z ) ) e. Z ` contradicts our assumption on ` F ` , so we
       are reduced to the case of ` Z ` finite.  This too is a contradiction,
       though, because ` Z ` and its preimage under ` ( W `` Z ) ` are distinct
       sets of the same cardinality and in a subset relation, which is
       impossible for finite sets.  (Contributed by Mario Carneiro,
       31-May-2015.) $)
    pwfseqlem4 $p |- -. ph $=
      ( ccrd cfv wbr ccnv csn cima wcel co cfn cvv wceq com csdm wa eqid pm3.2i
      cpw cmap ciun wf1 omex ovex iunex f1dmex sylancl pwexb sylibr pwfseqlem4a
      cv fpwwe2 mpbiri simprd wss cxp wwe cin wsbc wral simpld fpwwe2lem2 mpbid
      wi ssexd w3a sseq1 id xpeq12d sseq2d weeq2 3anbi123d anbi2d 3expa adantrr
      syl pm4.71i syl6bbr oveq1 eleq12d breq1 imbi12d fvex weeq1 3anbi23d oveq2
      eleq1d imbi1d wn cdom cdm wb con0 omelon onenon ax-mp wex simpr3 cdif nfv
      19.8a nfcv nfcxfr nfov nfel1 nfim weq sylbird pwfseqlem2 syl2anc ficardom
      chvar finnum ween domtri2 sylancr crab cint nfmpt22 anbi1d nfmpt21 xpeq12
      cif cmpt2 anidms breq2 anbi12d syl5bb pwfseqlem3 eldifbd expr con4d vtocl
      difeq2 vtoclg mpcom mpd isfinite eqeltrrd fpwwe2lem3 cnvimass dmss dmxpss
      mpdan syl6ss syl5ss ssfi inex1 eqtr3d wf1o f1fveq syl12anc eqcomd carden2
      cen f1of1 wpss dfpss2 baib php3 sdomnen mt4d eleqtrrd eliniseg sylib weso
      ex wor sonr pm2.65i ) APUJUKZLUKZUWSPNUKZULZAUWSUWTUMZUWSUNZUOZUPZUXAAUWS
      PUXDAPUWTJUQZUWSPAPURUPZUWTUSUPUXFUWSUTAPVAVBULZUXGAUXFPUPZUXHAPUWTNULZUX
      IAUXJUXIVCPPUTZUWTUWTUTZVCUXKUXLPVDUWTVDVEASTFGUWTJNPPQUHAGVFZUSUPZGUSUPA
      UXMIVAGIVRZVGUQZVHZKVIUXQUSUPUXNUAIVAUXPVJGUXOVGVKVLUXMUXQUSKVMVNGVOVPZAB
      CDEGHIJKLMOQRSUAUBUCUDUEUFUGVQUIVSVTZWAZPUSUPAUXIUXHWKZAPGUSUXRAPGWBZUWTP
      PWCZWBZAUYBUYDVCZPUWTWDZFVRZUWTUYGUYGWCWEJUQTVRZUTFUXBUYHUNUOWFTPWGZVCZAU
      XJUYEUYJVCZAUXJUXIUXSWHZASTFGUWTJNPQUHUXRWIWJZWHZWHWLASVRZGWBZUWTUYOUYOWC
      ZWBZUYOUWTWDZWMZVCZUYOUWTJUQZUYOUPZUYOVAVBULZWKZWKZAUYAWKSPUSUYOPUTZVUAAV
      UEUYAVUGVUAAUYBUYDUYFWMZVCAVUGUYTVUHAVUGUYPUYBUYRUYDUYSUYFUYOPGWNVUGUYQUY
      CUWTVUGUYOPUYOPVUGWOZVUIWPWQUYOPUWTWRWSWTAVUHAUYKVUHUYMUYEUYFVUHUYIUYBUYD
      UYFVUHVUHWOXAXBXCXDXEVUGVUCUXIVUDUXHVUGVUBUXFUYOPUYOPUWTJXFVUIXGUYOPVAVBX
      HXIXIAUYPQVRZUYQWBZUYOVUJWDZWMZVCZUYOVUJJUQZUYOUPZVUDWKZWKVUFQUWTPNXJZVUJ
      UWTUTZVUNVUAVUQVUEVUSVUMUYTAVUSVUKUYRVULUYSUYPVUJUWTUYQWNUYOVUJUWTXKXLWTV
      USVUPVUCVUDVUSVUOVUBUYOVUJUWTUYOJXMXNXOXIVUNVUDVUPVUNVUDXPZVAUYOXQULZVUPX
      PZVUNVAUJXRZUPZUYOVVCUPZVVAVUTXSVAXTUPVVDYAVAYBYCVUNVULQYDZVVEVUNVULVVFAU
      YPVUKVULYEVULQYHXCUYOQUUAVPVAUYOUUBUUCAVUMVVAVVBAVUMVVAVCZVCZVUOGUYOAUYPR
      VRZUYQWBZUYOVVIWDZWMZVVAVCZVCZUYOVVIJUQZGUYOYFZUPZWKZVVHVUOVVPUPZWKRQVVHV
      VSRVVHRYGRVUOVVPRUYOVUJJRUYOYIRJCRUSUSCVRZURUPVVTUJUKLUKDVRHUKVVTUPXPDVAU
      UDUUEHUKUUJZUUKZUGCRUSUSVWAUUFYJRVUJYIYKYLYMRQYNZVVNVVHVVQVVSVWCVVMVVGAVW
      CVVLVUMVVAVWCVVJVUKVVKVULUYPVVIVUJUYQWNUYOVVIVUJXKXLUUGWTVWCVVOVUOVVPVVIV
      UJUYOJXMXNXIABVCZVVTVVIJUQZGVVTYFZUPZWKVVRCSVVNVVQCVVNCYGCVVOVVPCUYOVVIJC
      UYOYICJVWBUGCRUSUSVWAUUHYJCVVIYIYKYLYMCSYNZVWDVVNVWGVVQVWHBVVMABVVTGWBZVV
      IVVTVVTWCZWBZVVTVVIWDZWMZVAVVTXQULZVCVWHVVMUDVWHVWMVVLVWNVVAVWHVWIUYPVWKV
      VJVWLVVKVVTUYOGWNVWHVWJUYQVVIVWHVWJUYQUTVVTUYOVVTUYOUUIUULWQVVTUYOVVIWRWS
      VVTUYOVAXQUUMUUNUUOWTVWHVWEVVOVWFVVPVVTUYOVVIJXFVVTUYOGUVAXGXIABCDEGHIJKL
      MORUAUBUCUDUEUFUGUUPYSYSUUQUURYOUUSUUTUVBUVCUVDPUVEVPZVURABCDEGHUWTIJKLMO
      PRUAUBUCUDUEUFUGYPVNUXTUVFZAUXDPUWBULZUXDPUTZAUXDUJUKZUWRUTZVWQAUWRVWSAUW
      SVWSLUKZUTZUWRVWSUTZAUXDUWTUXDUXDWCZWEZJUQZUWSVXAAUWSPUPZVXFUWSUTVWPASTFG
      UWSUWTJNPQUHUXRUYLUVGUVKAUXDURUPZVXEUSUPVXFVXAUTAUXGUXDPWBZVXHVWOAUXDUWTX
      RZPUWTUXCUVHAVXJUYCXRZPAUYDVXJVXKWBAUYBUYDUYNWAUWTUYCUVIXCPPUVJUVLUVMZPUX
      DUVNYQZUWTVXDVURUVOABCDEGHVXEIJKLMOUXDRUAUBUCUDUEUFUGYPVNUVPAVAOLVIZUWRVA
      UPZVWSVAUPZVXBVXCXSAVAOLUVQVXNUCVAOLUWCXCAUXGVXOVWOPYRXCAVXHVXPVXMUXDYRXC
      VAOUWRVWSLUVRUVSWJUVTAUXDVVCUPZPVVCUPZVWTVWQXSAVXHVXQVXMUXDYTXCAUXGVXRVWO
      PYTXCUXDPUWAYQWJAVWRXPZUXDPUWDZVWQXPZAVXIVXTVXSXSVXLVXTVXIVXSUXDPUWEUWFXC
      AUXGVXTVYAWKVWOUXGVXTVYAUXGVXTVCUXDPVBULVYAPUXDUWGUXDPUWHXCUWNXCYOUWIUWJU
      WSUSUPUXEUXAXSUWRLXJZUWTUWSUWSUSVYBUWKYCUWLAPUWTUWOZVXGUXAXPAUYFVYCAUYFUY
      IAUYEUYJUYMWAWHPUWTUWMXCVWPPUWSUWTUWPYQUWQ $.
  $}

  ${
    $d a b c d i j m n s w z G $.  $d a b c d j m r s t w z H $.  $d f k x P $.
    $d a b c d f i j k m n r s t u v w x y z $.  $d a b k n r s t w x y z ph $.
    $d a b c d i j m n s w z K $.  $d b N $.  $d k n x y z ps $.  $d n y S $.
    $d a b c d n r s t w z A $.  $d b u v x y O $.
    pwfseqlem5.g $e |- ( ph -> G : ~P A -1-1-> U_ n e. om ( A ^m n ) ) $.
    pwfseqlem5.x $e |- ( ph -> X C_ A ) $.
    pwfseqlem5.h $e |- ( ph -> H : om -1-1-onto-> X ) $.
    pwfseqlem5.ps $e |- ( ps <->
      ( ( t C_ A /\ r C_ ( t X. t ) /\ r We t ) /\ om ~<_ t ) ) $.
    pwfseqlem5.n $e |- ( ph -> A. b e. ( har ` ~P A ) ( om C_ b ->
      ( N ` b ) : ( b X. b ) -1-1-onto-> b ) ) $.
    pwfseqlem5.o $e |- O = OrdIso ( r , t ) $.
    pwfseqlem5.t $e |- T =
      ( u e. dom O , v e. dom O |-> <. ( O ` u ) , ( O ` v ) >. ) $.
    pwfseqlem5.p $e |- P = ( ( O o. ( N ` dom O ) ) o. `' T ) $.
    pwfseqlem5.s $e |- S = seqom ( ( k e. _V , f e. _V |->
      ( x e. ( t ^m suc k ) |-> ( ( f ` ( x |` k ) ) P ( x ` k ) ) ) ) ,
      { <. (/) , ( O ` (/) ) >. } ) $.
    pwfseqlem5.q $e |- Q = ( y e. U_ n e. om ( t ^m n ) |->
      <. dom y , ( ( S ` dom y ) ` y ) >. ) $.
    pwfseqlem5.i $e |- I = ( x e. om , y e. t |-> <. ( O ` x ) , y >. ) $.
    pwfseqlem5.k $e |- K = ( ( P o. I ) o. Q ) $.
    $( Lemma for ~ pwfseq .  Although in some ways ~ pwfseqlem4 is the "main"
       part of the proof, one last aspect which makes up a remark in the
       original text is by far the hardest part to formalize.  The main proof
       relies on the existence of an injection ` K ` from the set of finite
       sequences on an infinite set ` x ` to ` x ` .  Now this alone would not
       be difficult to prove; this is mostly the claim of ~ fseqen .  However,
       what is needed for the proof is a _canonical_ injection on these sets,
       so we have to start from scratch pulling together explicit bijections
       from the lemmas.

       If one attempts such a program, it will mostly go through, but there is
       one key step which is inherently nonconstructive, namely the proof of
       ~ infxpen .  The resolution is not obvious, but it turns out that
       reversing an infinite ordinal's Cantor normal form absorbs all the
       non-leading terms ( ~ cnfcom3c ), which can be used to construct a
       pairing function explicitly using properties of the ordinal exponential
       ( ~ infxpenc ).  (Contributed by Mario Carneiro, 31-May-2015.) $)
    pwfseqlem5 $p |- -. ph $=
      ( vz vi vw vc vd vj vm vs va cv ccnv cfv crn wcel wn wa crab cvv cfn ccrd
      com cint cif cmpt2 wss cxp wwe cin wceq csn cima wsbc wral copab cdm cuni
      cmap ciun ccom wf1 wf1o cep wiso vex w3a cdom wbr simprl3 sylan2b sylancr
      co oiiso isof1o syl cpw char wi con0 oion ax-mp a1i oien adantr omex ovex
      cen sylibr syl2anc wb onenon mp1i f1oeq1 f1oco cop wf feqmptd mpbid xpf1o
      cmpt f1of1 cres f1co c0 eqid iunex f1dmex sylancl pwexb simprl1 sylc csdm
      ssdomg canth2g sdomdom 3syl domtr endomtr elharval sylanbrc cardom simprr
      ensymd omelon carddom2 mpbird syl5eqssr cardonle sstrd sseq2 fveq2 xpeq12
      domentr anidms f1oeq2 f1oeq3 3bitrd imbi12d rspcv syl3c f1ssres feqresmpt
      f1of f1ocnv f1f1orn cid mptresid f1oi mpbiri f1f xpss1 4syl peano1 sseldd
      frn f1ss ffvelrnd fseqenlem2 f1eq1 fpwwe2cbv pwfseqlem4 ) ABGUQURUSHURVFZ
      SVGVHZPVIVJUWQUWRPVGVHVJVKVLURGVFZVMPVHZOGUCVNVNUWSVOVJUWSVPVHQVHUQVFUWTV
      HUWSVJVKUQVQVMVRUWTVHVSVTZPQSUTVFZHWAVAVFZUXBUXBWBWAVLUXBUXCWCVBVFZUXCUXD
      UXDWBWDUXAXGVCVFZWEVBUXCVGUXEWFWGWHVCUXBWIVLVLUTVAWJZUBUXFWKWLZVDUCVEUDUE
      UFUGUHABVLZOVQUWSOVFZWMXGWNZUWSIRWOZJWOZWPZUXJUWSSWPZUXHVQUWSWBZUWSUXKWPZ
      UXJUXOJWPUXMUXHUWSUWSWBZUWSIWPZUXOUXQRWPZUXPUXHUXQUWSIWQZUXRUXHUXQUWSUAUA
      WKZTVHZWOZLVGZWOZWQZUXTUXHUYAUYAWBZUWSUYCWQZUXQUYGUYDWQZUYFUXHUYAUWSUAWQZ
      UYGUYAUYBWQZUYHUXHUYAUWSWRUCVFZUAWSZUYJUXHUWSVNVJZUWSUYLWCZUYMGWTZBAUWSHW
      AZUYLUXQWAZUYOXAZVQUWSXBXCZVLZUYOUHUYQUYRUYOUYTAXDXEZUWSUYLUAVNUJXHXFUYAU
      WSWRUYLUAXIXJZUXHUYAHXKZXLVHZVJZVQUDVFZWAZVUGVUGWBZVUGVUGTVHZWQZXMZUDVUEW
      IZVQUYAWAZUYKUXHUYAXNVJZUYAVUDXBXCZVUFVUOUXHUYNVUOUYPUWSUYLUAVNUJXOXPZXQZ
      UXHUYAUWSYBXCZUWSVUDXBXCZVUPUXHUYNUYOVUSUYPVUBUWSUYLUAVNUJXRXFZUXHUWSHXBX
      CZHVUDXBXCZVUTUXHHVNVJZUYQVVBUXHVUDVNVJZVVDUXHVUDOVQHUXIWMXGZWNZPWPZVVGVN
      VJVVEAVVHBUEXSOVQVVFXTHUXIWMYAUUAVUDVVGVNPUUBUUCHUUDYCZBAVUAUYQUHUYQUYRUY
      OUYTAUUEXEUWSHVNUUHUUFUXHVVDHVUDUUGXCVVCVVIHVNUUIHVUDUUJUUKUWSHVUDUULYDUY
      AUWSVUDUUMYDVUDUYAUUNUUOAVUMBUIXSUXHVQUYAVPVHZUYAUXHVQVQVPVHZVVJUUPUXHVVK
      VVJWAZVQUYAXBXCZUXHUYTUWSUYAYBXCVVMBAVUAUYTUHAUYSUYTUUQXEUXHUYAUWSVVAUURV
      QUWSUYAUVHYDUXHVQVPWKZVJZUYAVVNVJZVVLVVMYEVQXNVJVVOUUSVQYFXPVUOVVPUXHVUQU
      YAYFYGVQUYAUUTXFUVAUVBUXHVUOVVJUYAWAVURUYAUVCXJUVDZVULVUNUYKXMUDUYAVUEVUG
      UYAWEZVUHVUNVUKUYKVUGUYAVQUVEVVRVUKVUIVUGUYBWQZUYGVUGUYBWQZUYKVVRVUJUYBWE
      VUKVVSYEVUGUYATUVFVUIVUGVUJUYBYHXJVVRVUIUYGWEZVVSVVTYEVVRVWAVUGUYAVUGUYAU
      VGUVIVUIUYGVUGUYBUVJXJVUGUYAUYGUYBUVKUVLUVMUVNUVOUYGUYAUWSUAUYBYIYDUXHUYG
      UXQLWQZUYIUXHUYGUXQFEUYAUYAFVFUAVHZEVFUAVHZYJVTZWQZVWBUXHFEUYAUWSUYAUWSVW
      CVWDUXHUYJUYAUWSFUYAVWCYOZWQZVUCUXHUAVWGWEUYJVWHYEUXHFUYAUWSUAUXHUYJUYAUW
      SUAYKVUCUYAUWSUAUVRXJZYLUYAUWSUAVWGYHXJYMUXHUYJUYAUWSEUYAVWDYOZWQZVUCUXHU
      AVWJWEUYJVWKYEUXHEUYAUWSUAVWIYLUYAUWSUAVWJYHXJYMYNLVWEWEVWBVWFYEUKUYGUXQL
      VWEYHXPYCUYGUXQLUVSXJUXQUYGUWSUYCUYDYIYDIUYEWEUXTUYFYEULUXQUWSIUYEYHXPYCZ
      UXQUWSIYPXJUXHUXOUAVQYQZVIZUWSWBZRWPZVWOUXQWAZUXSUXHUXOVWORWQZVWPUXHUXOVW
      OCDVQUWSCVFUAVHZDVFZYJVTZWQZVWRUXHCDVQVWNUWSUWSVWSVWTUXHVQVWNVWMWQZVQVWNC
      VQVWSYOZWQZUXHVQUWSVWMWPZVXCUXHUYAUWSUAWPZVUNVXFUXHUYJVXGVUCUYAUWSUAYPXJV
      VQUYAUWSVQUAUVPYDZVQUWSVWMUVTXJUXHVWMVXDWEVXCVXEYEUXHCUYAUWSVQUAVWIVVQUVQ
      VQVWNVWMVXDYHXJYMDUWSVWTYOZUWAUWSYQZWEZUWSUWSVXIWQZUXHDUWSUWBVXKVXLUWSUWS
      VXJWQUWSUWCUWSUWSVXIVXJYHUWDYGYNRVXAWEVWRVXBYEUOUXOVWORVXAYHXPYCUXOVWORYP
      XJUXHVXFVQUWSVWMYKVWNUWSWAVWQVXHVQUWSVWMUWEVQUWSVWMUWJVWNUWSUWSUWFUWGUXOV
      WOUXQRUWKYDUXOUXQUWSIRYRYDUXHCDUWSYSUAVHMONIKJVNUYNUXHUYPXQUXHUYAUWSYSUAV
      WIUXHVQUYAYSVVQYSVQVJUXHUWHXQUWIUWLVWLUMUNUWMUXJUXOUWSUXKJYRYDSUXLWEUXNUX
      MYEUPUXJUWSSUXLUWNXPYCUWTYTUXAYTUTVCUDUSVBHUXAUXFVDVAVEUXFYTUWOUXGYTUWP
      $.
  $}

  ${
    $d b f g h k m n p r s t u w x y z A $.
    $( The powerset of a Dedekind-infinite set does not inject into the set of
       finite sequences.  The proof is due to Halbeisen and Shelah.
       Proposition 1.7 of [KanamoriPincus] p. 418.  (Contributed by Mario
       Carneiro, 31-May-2015.) $)
    pwfseq $p |- ( om ~<_ A -> -. ~P A ~<_ U_ n e. om ( A ^m n ) ) $=
      ( vt vh vb vm vg vx vy vk com cv cmap co wss wa wf1o cfv wceq eqid vu cvv
      vr vz vs vp vf vw wcel cdom wbr cpw wn reldom brrelex2i cen wex domeng wi
      ciun bren cxp char wral con0 harcl infxpenc2 wf1 wwe w3a coi cdm ccom cop
      ax-mp cmpt2 ccnv csuc cres cmpt c0 cseqom simpr oveq2 cbviunv f1eq3 sylib
      csn wb simpllr simplll simplr sseq2 fveq2 f1oeq1 syl xpeq12 anidms f1oeq2
      biid f1oeq3 3bitrd imbi12d cbvralv mpteq1 pwfseqlem5 imnani nexdv nsyl ex
      brdomi exlimdv mpi exlimiv sylbi imp syl6bi mpcom ) AUBUIZKAUJUKZAULZBKAB
      LZMNZUTZUJUKZUMZKAUJUNUOXSXTKCLZUPUKZYGAOZPZCUQYFCKAUBURYJYFCYHYIYFYHKYGD
      LZQZDUQYIYFUSZKYGDVAYLYMDYLYIYFYLYIPZKELZOZYOYOVBZYOYOFLZRZQZUSZEYAVCRZVD
      ZFUQZYFUUBVEUIUUDYAVFUUBFEVGVOYNUUCYFFYNUUCYFYNUUCPZYAYDGLZVHZGUQYEUUEUUG
      GUUEUUGUUEUUGPZUALZAOUCLZUUIUUIVBOUUIUUJVIVJKUUIUJUKPZHIUDUEUAAUUIUUJVKZU
      ULVLZYRRVMUEUDUUMUUMUELUULRUDLUULRVNVPZVQVMZIBKUUIYBMNZUTZILZVLZUURUUSUFU
      GUBUBHUUIUFLZVRMNHLZUUTVSUGLRUUTUVARUUONVTVPWAWAUULRVNWHWBZRRVNZVTZUVBUUN
      UGUFJUUFYKHIKUUIUVAUULRUURVNVPZUUOUVEVMUVDVMZYRUULYGUCUHUUHUUGYAJKAJLZMNZ
      UTZUUFVHZUUEUUGWCYDUVISUUGUVJWIBJKYCUVHYBUVGAMWDWEYDUVIYAUUFWFVOWGYLYIUUC
      UUGWJYLYIUUCUUGWKUUKWTUUHUUCKUHLZOZUVKUVKVBZUVKUVKYRRZQZUSZUHUUBVDYNUUCUU
      GWLUUAUVPEUHUUBYOUVKSZYPUVLYTUVOYOUVKKWMUVQYTYQYOUVNQZUVMYOUVNQZUVOUVQYSU
      VNSYTUVRWIYOUVKYRWNYQYOYSUVNWOWPUVQYQUVMSZUVRUVSWIUVQUVTYOUVKYOUVKWQWRYQU
      VMYOUVNWSWPYOUVKUVMUVNXAXBXCXDWGUULTUUNTUUOTUVBTUUQJKUUIUVGMNZUTZSUVDIUWB
      UVCVTSBJKUUPUWAYBUVGUUIMWDWEIUUQUWBUVCXEVOUVETUVFTXFXGXHYAYDGXKXIXJXLXMXJ
      XNXOXPXNXQXR $.

    $( The powerset of a Dedekind-infinite set does not inject into its cross
       product with itself.  (Contributed by Mario Carneiro, 31-May-2015.) $)
    pwxpndom2 $p |- ( om ~<_ A -> -. ~P A ~<_ ( A +c ( A X. A ) ) ) $=
      ( vn vx com cdom wbr co cv cmap c1o c2o cen c0 wceq cvv wcel ensym wn syl
      wss cpw cxp ccda ciun pwfseq wi cun cin reldom brrelex2i oveq1 id breq12d
      csn df1o2 oveq2i vex 0ex mapsnen eqbrtri vtoclg 3syl map2xp wa cdm elmapi
      fdm adantr csuc 1onn elexi sucid df-2o eleqtrri 1on onirri nelneq2 adantl
      wf mp2an eqeq1d mtbiri pm2.65i elin mtbir a1i eq0rdv cdaenun syl3anc omex
      ovex iunex oveq2 ssiun2s ax-mp 2onn unssi ssdomg mp2 endomtr domtr expcom
      sylancl mtod ) DAEFZAUAZAAAUBZUCGZEFZXFBDABHZIGZUDZEFZABUEXEXHXLEFZXIXMUF
      XEXHAJIGZAKIGZUGZLFZXQXLEFZXNXEAXOLFZXGXPLFZXOXPUHZMNXRXEAOPZXOALFZXTDAEU
      IUJZCHZJIGZYFLFYDCAOYFANZYGXOYFALYFAJIUKYHULUMYGYFMUNZIGYFLJYIYFIUOUPYFMC
      UQURUSUTVAXOAQVBXEYCXPXGLFYAYEAOVCXPXGQVBXECYBYFYBPZRXEYJYFXOPZYFXPPZVDZY
      MYFVEZJNZYKYOYLYKJAYFVSYOYFAJVFJAYFVGSVHYMYOKJNZJKPJJPRYPRJJVIKJJDVJVKVLV
      MVNJVOVPJKJVQVTYMYNKJYLYNKNZYKYLKAYFVSYQYFAKVFKAYFVGSVRWAWBWCYFXOXPWDWEWF
      WGAXOXGXPWHWIXLOPXQXLTXSBDXKWJAXJIWKWLXOXPXLJDPXOXLTVJBDXKJXOXJJAIWMWNWOK
      DPXPXLTWPBDXKKXPXJKAIWMWNWOWQXQXLOWRWSXHXQXLWTXCXIXNXMXFXHXLXAXBSXD $.
  $}

  $( The powerset of a Dedekind-infinite set does not inject into its cross
     product with itself.  (Contributed by Mario Carneiro, 31-May-2015.) $)
  pwxpndom $p |- ( om ~<_ A -> -. ~P A ~<_ ( A X. A ) ) $=
    ( com cdom wbr cpw cxp ccda co pwxpndom2 wi cen wcel reldom brrelex2i xpexg
    cvv syl2anc cdadom3 cdacomen domentr sylancl domtr expcom syl mtod ) BACDZA
    EZAAFZCDZUGAUHGHZCDZAIUFUHUJCDZUIUKJUFUHUHAGHZCDZUMUJKDULUFUHPLZAPLZUNUFUPU
    PUOBACMNZUQAAPPOQUQUHAPPRQUHASUHUMUJTUAUIULUKUGUHUJUBUCUDUE $.

  $( The powerset of a Dedekind-infinite set does not inject into its cardinal
     sum with itself.  (Contributed by Mario Carneiro, 31-May-2015.) $)
  pwcdandom $p |- ( om ~<_ A -> -. ~P A ~<_ ( A +c A ) ) $=
    ( com cdom wbr cpw ccda co cxp pwxpndom2 wi c1o cen c0 csn df1o2 xpeq2i cvv
    wcel domtr syl2anc reldom brrelex2i 0ex xpsneng sylancl syl5eqbr ensymd wss
    omex word ordom 1onn ordelss ssdomg mp2 mpan xpdom2g endomtr cdadom2 expcom
    mp2an 3syl mtod ) BACDZAEZAAFGZCDZVEAAAHZFGZCDZAIVDAVHCDZVFVICDZVGVJJVDAAKH
    ZLDVMVHCDZVKVDVMAVDVMAMNZHZALKVOAOPVDAQRZMQRVPALDBACUAUBZUCAMQQUDUEUFUGVDVQ
    KACDZVNVRKBCDZVDVSBQRKBUHZVTUIBUJKBRWAUKULBKUMVAKBQUNUOKBASUPKAAQUQTAVMVHUR
    TAVHAUSVGVLVJVEVFVISUTVBVC $.

  $( An infinite GCH-set is idempotent under cardinal sum.  Part of Lemma 2.2
     of [KanamoriPincus] p. 419.  (Contributed by Mario Carneiro,
     31-May-2015.) $)
  gchcdaidm $p |- ( ( A e. GCH /\ -. A e. Fin ) -> ( A +c A ) ~~ A ) $=
    ( cgch wcel cfn wn wa ccda co cdom wbr cpw csdm cen cdadom3 syl2anc canth2g
    simpl adantr sdomdom syl cdadom1 cdadom2 domtr c1o pwcda1 gchcda1 pwen entr
    domentr com gchinf pwcdandom ensym endom nsyl brsdom sylanbrc gchen1 ensymd
    jca mpdan ) ABCZADCEZFZAAAGHZVDAVEIJZVEAKZLJZFAVEMJVDVFVHVDVBVBVFVBVCQZVIAA
    BBNOVDVEVGIJZVEVGMJZEVHVDVEVGVGGHZIJZVLVGMJZVJVDAVGIJZVMVDAVGLJZVOVBVPVCABP
    RAVGSTVOVEVGAGHZIJVQVLIJVMAVGAUAAVGVGUBVEVQVLUCOTVDVLAUDGHZKZMJZVSVGMJZVNVB
    VTVCABUERVDVRAMJWAAUFVRAUGTVLVSVGUHOVEVLVGUIOVDVGVEIJZVKVDUJAIJWBEAUKAULTVK
    VGVEMJWBVEVGUMVGVEUNTUOVEVGUPUQUTAVEURVAUS $.

  $( An infinite GCH-set is idempotent under cardinal product.  Part of Lemma
     2.2 of [KanamoriPincus] p. 419.  (Contributed by Mario Carneiro,
     31-May-2015.) $)
  gchxpidm $p |- ( ( A e. GCH /\ -. A e. Fin ) -> ( A X. A ) ~~ A ) $=
    ( cgch wcel cfn wn wa cxp cdom wbr cpw csdm cen c0 cvv ensymd adantr syldan
    c1o syl2anc syl csn 0ex a1i xpsneng sylan2 df1o2 wne wceq syl6eqel necon3bi
    id 0fin adantl wb 0sdomg mpbird 0sdom1dom syl5eqbrr xpdom2g endomtr canth2g
    sylib sdomdom xpdom1g pwexg domtr ccda co simpl pwcdaen gchcdaidm pwen entr
    domentr com gchinf pwxpndom ensym endom nsyl brsdom sylanbrc gchen1 mpdan
    jca ) ABCZADCZEZFZAAAGZWIAWJHIZWJAJZKIZFAWJLIWIWKWMWIAAMUAZGZLIWOWJHIZWKWIW
    OAWHWFMNCZWOALIWQWHUBUCAMBNUDUEOWFWHWNAHIWPWIWNRAHUFWIMAKIZRAHIWIWRAMUGZWHW
    SWFWGAMAMUHZAMDWTUKULUIUJUMWFWRWSUNWHABUOPUPAUQVBURWNAABUSQAWOWJUTSWIWJWLHI
    ZWJWLLIZEWMWIWJWLWLGZHIZXCWLLIZXAWIWJWLAGZHIZXFXCHIZXDWFWHAWLHIZXGWIAWLKIZX
    IWFXJWHABVAPAWLVCTZAWLABVDQWIWLNCZXIXHWFXLWHABVEPXKAWLWLNUSSWJXFXCVFSWIXCAA
    VGVHZJZLIXNWLLIZXEWIXNXCWFWHWFXNXCLIWFWHVIAABBVJQOWIXMALIXOAVKXMAVLTXCXNWLV
    MSWJXCWLVNSWIWLWJHIZXBWIVOAHIXPEAVPAVQTXBWLWJLIXPWJWLVRWLWJVSTVTWJWLWAWBWEA
    WJWCWDO $.

  $( A relationship between dominance over the powerset and strict dominance
     when the sets involved are infinite GCH-sets.  Proposition 3.1 of
     [KanamoriPincus] p. 421.  (Contributed by Mario Carneiro, 31-May-2015.) $)
  gchpwdom $p |- ( ( om ~<_ A /\ A e. GCH /\ B e. GCH ) ->
      ( A ~< B <-> ~P A ~<_ B ) ) $=
    ( com cdom wbr cgch wcel csdm cpw ccda co cen cvv cdadom3 syl2anc entr 3syl
    syl cfn wn w3a wa simpl2 pwexg simpl3 domen2 syl5ibrcom cdacomen mpan ensym
    endom domsdomtr 3ad2antl1 sdomnsym isfinite sylnibr gchcdaidm pwen pwcdadom
    wb domen1 wi canth2g sdomdomtr gchi 3expia 3ad2antl2 simpl1 domnsym pm2.21d
    ex syl5bi 3syld syl5 sylbird domentr sylancl sdomdom adantl cdadom1 cdadom2
    pwdom domtr c1o pwcda1 gchcda1 gchor syl22anc mpjaod reldom brrelexi sylbir
    wo pwexb mpancom impbid1 ) CADEZAFGZBFGZUAZABHEZAIZBDEZWTXAXCWTXAUBZBXBBJKZ
    LEZXCXEBIZLEZXDXCXFXBXEDEZXDXBMGZWSXIXDWRXJWQWRWSXAUCAFUDRZWQWRWSXAUEZXBBMF
    NOBXEXBUFUGXHXGBXBJKZDEZXDXCXHXMXGLEZXGXMLEXNXMXELEZXHXOBXBUHZXMXEXGPUIXMXG
    UJXGXMUKQXDXNBBJKZIZXMDEZXCXDXRBLEZXSXGLEXTXNUTXDWSBSGZTZYAXLXDBCHEZYBXDCBH
    EZYDTWQWRXAYEWSCABULUMCBUNRBUOUPZBUQOXRBURXSXGXMVAQXTXGXBDEZXDXCBXBUSXDYGBX
    BHEZASGZXCXDWSBXGHEZYGYHVBXLBFVCZYJYGYHBXGXBVDVKQWRWQXAYHYIVBWSWRXAYHYIABVE
    VFVGYIACHEZXDXCAUOXDYLXCXDWQYLTWQWRWSXAVHCAVIRVJVLVMVNVOVNXDWSYCBXEDEZXEXGD
    EZXFXHWMXLYFXDBXMDEZXPYMXDWSXJYOXLXKBXBFMNOXQBXMXEVPVQXDXEXGXGJKZDEZYPXGLEZ
    YNXDXEXGBJKZDEZYSYPDEZYQXDABDEZXBXGDEYTXAUUBWTABVRVSABWBXBXGBVTQXDYJBXGDEUU
    AXDWSYJXLYKRBXGVRBXGXGWAQXEYSYPWCOXDYPBWDJKZIZLEZUUDXGLEZYRXDWSUUEXLBFWERXD
    UUCBLEZUUFXDWSYCUUGXLYFBWFOUUCBURRYPUUDXGPOXEYPXGVPOBXEWGWHWIVKAXBHEZXCXAXC
    XJUUHXBBDWJWKXJAMGUUHAWNAMVCWLRAXBBVDWOWP $.


  $( If ` ( aleph `` A ) ` is a GCH-set and its powerset is well-orderable,
     then the successor aleph ` ( aleph `` suc A ) ` is equinumerous to the
     powerset of ` ( aleph `` A ) ` .  (Contributed by Mario Carneiro,
     15-May-2015.) $)
  gchaleph $p |- ( ( A e. On /\ ( aleph ` A ) e. GCH /\
    ~P ( aleph ` A ) e. dom card ) ->
    ( aleph ` suc A ) ~~ ~P ( aleph ` A ) ) $=
    ( con0 wcel cale cfv cgch cpw ccrd cdm w3a csuc cdom wbr csdm wn wb domtri2
    com cvv syl2anc cen alephsucpw2 alephon onenon ax-mp sylancr mpbiri cfn wss
    simp3 simp1 alephgeom sylib ssdomg mpsyl domnsym syl isfinite sylnibr simp2
    fvex wi alephordilem1 3ad2ant1 gchi 3expia mtod sylancl mpbird sbth ) ABCZA
    DEZFCZVLGZHIZCZJZAKZDEZVNLMZVNVSLMZVSVNUAMVQVTVNVSNMOZAUBVQVSVOCZVPVTWBPVSB
    CWCVRUCVSUDUEZVKVMVPUJZVSVNQUFUGVQWAVSVNNMZOZVQWFVLUHCZVQVLRNMZWHVQRVLLMZWI
    OVLSCVQRVLUIZWJADVAVQVKWKVKVMVPUKAULUMRVLSUNUORVLUPUQVLURUSVQVMVLVSNMZWFWHV
    BVKVMVPUTVKVMWLVPAVCVDVMWLWFWHVLVSVEVFTVGVQVPWCWAWGPWEWDVNVSQVHVIVSVNVJT $.

  $( If ` ( aleph `` A ) ` and ` ( aleph `` suc A ) ` are GCH-sets, then the
     successor aleph ` ( aleph `` suc A ) ` is equinumerous to the powerset of
     ` ( aleph `` A ) ` .  (Contributed by Mario Carneiro, 31-May-2015.) $)
  gchaleph2 $p |- ( ( A e. On /\ ( aleph ` A ) e. GCH /\
    ( aleph ` suc A ) e. GCH ) ->
    ( aleph ` suc A ) ~~ ~P ( aleph ` A ) ) $=
    ( con0 wcel cale cfv cgch csuc cpw ccrd cdm cen wbr char cdom harcl alephon
    w3a csdm onenon com harsdom wb wss simp1 alephgeom sylib ssdomg mpsyl simp2
    mp2b wceq alephsuc simp3 eqeltrrd gchpwdom syl3anc ondomen sylancr gchaleph
    syl mpbii syld3an3 ) ABCZADEZFCZAGDEZFCZVDHZIJZCZVFVHKLVCVEVGQZVDMEZBCVHVLN
    LZVJVDOVKVDVLRLZVMVDBCZVDVICVNAPZVDSVDUAUJVKTVDNLZVEVLFCVNVMUBVOVKTVDUCZVQV
    PVKVCVRVCVEVGUDZAUEUFTVDBUGUHVCVEVGUIVKVFVLFVKVCVFVLUKVSAULUTVCVEVGUMUNVDVL
    UOUPVAVLVHUQURAUSVB $.

  ${
    $d x A $.
    $( If ` A + ~~ ~P A ` , then ` A ` is a GCH-set.  The much simpler converse
       to ~ gchhar .  (Contributed by Mario Carneiro, 2-Jun-2015.) $)
    hargch $p |- ( ( har ` A ) ~~ ~P A -> A e. GCH ) $=
      ( vx char cfv cpw cen wbr cgch wcel cfn cv csdm wa cdom ccrd con0 syl cvv
      wn wb wal wo wi cdm harcl sdomdom ondomen sylancr ax-mp cardsdom2 sylancl
      onenon ibir harcard syl6eleq elharval simprbi cardid2 domen1 3syl domnsym
      mpbid con2i sdomen2 notbid imnan sylib alrimiv olcd relen brrelex2i pwexb
      syl5ib sylibr elgch mpbird ) ACDZAEZFGZAHIZAJIZABKZLGZWBVRLGZMSZBUAZUBZVS
      WFWAVSWEBVSWCWDSZUCWEWCWBVQLGZSVSWHWIWCWIWBANGZWCSWIWBODZANGZWJWIWKVQIZWL
      WIWKVQODZVQWIWKWNIZWIWBOUDZIZVQWPIZWOWITWIVQPIZWBVQNGWQAUEZWBVQUFVQWBUGUH
      ZWSWRWTVQULUIWBVQUJUKUMAUNUOWMWKPIWLAWKUPUQQWIWQWKWBFGWLWJTXAWBURWKWBAUSU
      TVBWBAVAQVCVSWIWDVQVRWBVDVEVMWCWDVFVGVHVIVSARIZVTWGTVSVRRIXBVQVRFVJVKAVLV
      NBARVOQVP $.

    $( If ` ( aleph `` suc A ) ` is equinumerous to the powerset of
       ` ( aleph `` A ) ` , then ` ( aleph `` A ) ` is a GCH-set.  (Contributed
       by Mario Carneiro, 15-May-2015.) $)
    alephgch $p |- ( ( aleph ` suc A ) ~~ ~P ( aleph ` A ) ->
      ( aleph ` A ) e. GCH ) $=
      ( vx csuc cale cfv cpw cen wbr cfn wcel cv csdm wa wn wo cgch alephnbtwn2
      wal sdomen2 cvv anbi2d mtbii alrimiv olcd wb fvex elgch ax-mp sylibr ) AC
      DEZADEZFZGHZUKIJZUKBKZLHZUOULLHZMZNZBRZOZUKPJZUMUTUNUMUSBUMUPUOUJLHZMURAU
      OQUMVCUQUPUJULUOSUAUBUCUDUKTJVBVAUEADUFBUKTUGUHUI $.
  $}

  $( It is sufficient to require that all alephs are GCH-sets to ensure the
     full generalized continuum hypothesis.  (The proof uses the Axiom of
     Regularity.)  (Contributed by Mario Carneiro, 15-May-2015.) $)
  gch2 $p |- ( GCH = _V <-> ran aleph C_ GCH ) $=
    ( vx cgch cvv wceq cale wss wcel ccrd cfv com mpbi a1i cen wbr wac fnfvelrn
    con0 alephfnon sylancr sseldd crn ssv sseq2 mpbiri cun cardidm iscard3 elun
    cv wo wi cfn fingch nnfi sseldi ssel jaod mpi cdm vex cpw wral csuc alephon
    wb wa simpr simpl suceloni adantl gchaleph2 syl3anc isnumi ralrimiva dfac12
    sylibr dfac10 sylib syl5eleqr cardid2 engch 3syl mpbid 2thd eqrdv impbii
    wfn ) BCDZEUAZBFZWHWJWICFWIUBBCWIUCUDWJABCWJAUIZBGZWKCGZWJWKHIZBGZWLWJWNJGZ
    WNWIGZUJZWOWNJWIUEGZWRWNHIWNDWSWKUFWNUGKWNJWIUHKWJWPWOWQWPWOUKWJWPULBWNUMWN
    UNUOLWIBWNUPUQURWJWKHUSZGWNWKMNWOWLVEWJWKCWTAUTZWJOWTCDWJWKEIZVAZWTGZAQVBOW
    JXDAQWJWKQGZVFZWKVCZEIZQGXHXCMNZXDXGVDXFXEXBBGXHBGXIWJXEVGZXFWIBXBWJXEVHZXF
    EQWGZXEXBWIGRXJQWKEPSTXFWIBXHXKXFXLXGQGZXHWIGRXEXMWJWKVIVJQXGEPSTWKVKVLXHXC
    VMSVNAVOVPVQVRVSWKVTWNWKWAWBWCWMWJXALWDWEWF $.

  $( An equivalent formulation of the generalized continuum hypothesis.
     (Contributed by Mario Carneiro, 15-May-2015.) $)
  gch3 $p |- ( GCH = _V <->
    A. x e. On ( aleph ` suc x ) ~~ ~P ( aleph ` x ) ) $=
    ( cgch cvv wceq cv csuc cale cfv cpw cen con0 wral wcel syl5eleqr alephfnon
    wbr wa fvex mpbiran sylibr simpr simpl gchaleph2 syl3anc ralrimiva alephgch
    crn wss wf ralimi wfn ffnfv df-f sylib gch2 impbii ) BCDZAEZFZGHZURGHZIJPZA
    KLZUQVBAKUQURKMZQZVDVABMZUTBMVBUQVDUAVEVACBURGRUQVDUBZNVEUTCBUSGRVGNURUCUDU
    EVCGUGBUHZUQVCKBGUIZVHVCVFAKLZVIVBVFAKURUFUJVIGKUKZVJOAKBGULSTVIVKVHOKBGUMS
    UNUOTUP $.

  ${
    $d x A $.
    $( The equivalence of two versions of the Generalized Continuum
       Hypothesis.  The right-hand side is the standard version in the
       literature.  The left-hand side is a version devised by Kannan Nambiar,
       which he calls the Axiom of Combinatorial Sets.  For the notation and
       motivation behind this axiom, see his paper, "Derivation of Continuum
       Hypothesis from Axiom of Combinatorial Sets," available at
       ~ http://www.e-atheneum.net/science/derivation&#95;ch.pdf .  The
       equivalence of the two sides provides a negative answer to Open Problem
       2 in
       ~ http://www.e-atheneum.net/science/open&#95;problem&#95;print.pdf .
       The key idea in the proof below is to equate both sides of ~ alephexp2
       to the successor aleph using ~ enen2 .  (Contributed by NM,
       1-Oct-2004.) $)
    gch-kn $p |- ( A e. On -> ( ( aleph ` suc A ) ~~
                { x | ( x C_ ( aleph ` A ) /\ x ~~ ( aleph ` A ) ) } <->
                ( aleph ` suc A ) ~~ ( 2o ^m ( aleph ` A ) ) ) ) $=
      ( con0 wcel csuc cale cfv c2o co cen wbr cv wss wa cab wb alephexp2 enen2
      cmap syl bicomd ) BCDZBEFGZHBFGZSIZJKZUCALZUDMUGUDJKNAOZJKZUBUEUHJKUFUIPA
      BQUEUHUCRTUA $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Derivation of the Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    gchaclem.1 $e |- ( ph -> om ~<_ A ) $.
    gchaclem.3 $e |- ( ph -> ~P C e. GCH ) $.
    gchaclem.4 $e |- ( ph ->
      ( A ~<_ C /\ ( B ~<_ ~P C -> ~P A ~<_ B ) ) ) $.
    $( Lemma for ~ gchac (obsolete, used in Sierpi&#324;ski's proof).
       (Contributed by Mario Carneiro, 15-May-2015.) $)
    gchaclem $p |- ( ph ->
      ( A ~<_ ~P C /\ ( B ~<_ ~P ~P C -> ~P A ~<_ B ) ) ) $=
      ( cpw cdom wbr wi cvv wcel syl 3syl domtr syl2anc adantr com ex brrelex2i
      simpld csdm reldom canth2g sdomdom wo wa cgch ccda cen pwcdaidm gchdomtri
      co simpr syl3anc pwdom simprd jaod syld jca ) ABDHZIJZCVBHIJZBHZCIJZKABDI
      JZDVBIJZVCAVGCVBIJZVFKZGUBZADLMZDVBUCJVHAVGVLVKBDIUDUANDLUEDVBUFOBDVBPQAV
      DVBCIJZVIUGZVFAVDVNAVDUHZVBUIMZVBVBUJUNVBUKJZVDVNAVPVDFRVOSDIJZVQAVRVDASB
      IJVGVREVKSBDPQRDULNAVDUOVBCUMUPTAVMVFVIAVGVEVBIJZVMVFKVKBDUQVSVMVFVEVBCPT
      OAVGVJGURUSUTVA $.
  $}

  $( A "local" form of ~ gchac .  If ` A ` and ` ~P A ` are GCH-sets, then the
     Hartogs number of ` A ` is ` ~P A ` (so ` ~P A ` and a fortiori ` A ` are
     well-orderable).  The proof is due to Specker.  Theorem 2.1 of
     [KanamoriPincus] p. 419.  (Contributed by Mario Carneiro, 31-May-2015.) $)
  gchhar $p |- ( ( om ~<_ A /\ A e. GCH /\ ~P A e. GCH ) ->
      ( har ` A ) ~~ ~P A ) $=
    ( com cdom wbr cgch wcel cpw cen ccda con0 cdadom3 csdm sylancl cvv syl2anc
    co wn syl entr domentr w3a char cfv harcl sylancr domnsym 3ad2ant1 isfinite
    simp3 cfn sylnibr pwfi sylnib ovex canth2 pwcdaen pwexg cwdom simp2 harwdom
    wdompwdom 3syl xpdom2g xpexg ensymd enrefg gchxpidm cdaen gchcdaidm endomtr
    cxp pwen sdomdomtr gchen1 syl22anc cdacomen domen2 syl5ibrcom mtoi sylanbrc
    harndom brsdom canth2g sdomdom cdadom1 4syl cdadom2 domtr gchen2 endom sbth
    pwcdadom ) BACDZAEFZAGZEFZUAZAUBUCZWOCDZWOWRCDZWRWOHDWQWRWRWOIPZCDZXAWOHDWS
    WQWRJFZWPXBAUDZWMWNWPUIZWRWOJEKUEWQWOXAWQWOWOWRIPZHDZXFXAHDWOXAHDWQWPWOUJFZ
    QZWOXFCDZXFWOGZLDZXGXEWQAUJFZXHWQABLDZXMWMWNXNQWPBAUFUGAUHUKZAULUMZWQWPXCXJ
    XEXDWOWREJKMWQXFXFGZLDXQXKCDZXLXFWOWRIUNUOWQXQXKWRGZVKZHDZXTXKCDZXRWQWPXCYA
    XEXDWOWREJUPMWQXTXKAAVKZGZGZVKZCDZYFXKHDZYBWQXKNFZXSYECDZYGWQWPYIXEWOEUQRWQ
    WNWRYDURDYJWMWNWPUSZEAUTWRYDVAVBXSYEXKNVCOWQYFWOYDIPZGZHDYMXKHDZYHWQYMYFWQW
    PYDNFZYMYFHDXEWQYCNFZYOWQWNWNYPYKYKAAEEVDOYCNUQRWOYDENUPOVEWQYLWOHDZYNWQYLW
    OWOIPZHDZYRWOHDZYQWQWOWOHDZYDWOHDZYSWQWPUUAXEWOEVFRWQYCAHDZUUBWQWNXMQZUUCYK
    XOAVGOYCAVLRWOWOYDWOVHOWQWPXIYTXEXPWOVIOZYLYRWOSOYLWOVLRYFYMXKSOXTYFXKTOXQX
    TXKVJOXFXQXKVMUEWOXFVNVOWOWRVPWOXFXASMVEWRXAWOTOZWQAAIPZGZAWRIPZHDZUUHUUICD
    WTWQUUHWOHDZWOUUIHDUUJWQUUGAHDZUUKWQWNUUDUULYKXOAVIOUUGAVLRWQUUIWOWQWNUUDAU
    UILDZUUIWOCDZUUIWOHDYKXOWQAUUICDZAUUIHDZQUUMWQWNXCUUOYKXDAWREJKMWQUUPWRACDZ
    AWAWQUUQUUPWRUUICDZWQWRWRAIPZCDZUUSUUIHDUURWQXCWNUUTXDYKWRAJEKUEWRAVPWRUUSU
    UITMAUUIWRVQVRVSAUUIWBVTWQUUIYRCDZYTUUNWQUUIXFCDZXFYRCDZUVAWQWNAWOLDAWOCDUV
    BYKAEWCAWOWDAWOWRWEWFWQWSUVCUUFWRWOWOWGRUUIXFYRWHOUUEUUIYRWOTOAUUIWIVOVEUUH
    WOUUISOUUHUUIWJAWRWLVBWRWOWKO $.

  $( A "local" form of ~ gchac .  If ` A ` and ` ~P A ` are GCH-sets, then
     ` ~P A ` is well-orderable.  The proof is due to Specker.  Theorem 2.1 of
     [KanamoriPincus] p. 419.  (Contributed by Mario Carneiro, 15-May-2015.) $)
  gchacg $p |- ( ( om ~<_ A /\ A e. GCH /\ ~P A e. GCH ) ->
      ~P A e. dom card ) $=
    ( com cdom wbr cgch wcel cpw w3a char cfv con0 cen ccrd harcl gchhar isnumi
    cdm sylancr ) BACDAEFAGZEFHAIJZKFTSLDSMQFANAOTSPR $.

  $( The Generalized Continuum Hypothesis implies the Axiom of Choice.  The
     original proof is due to Sierpi&#324;ski (1947); we use a refinement of
     Sierpi&#324;ski's result due to Specker.  (Contributed by Mario Carneiro,
     15-May-2015.) $)
  gchac $p |- ( GCH = _V -> CHOICE ) $=
    ( vx cgch cvv wceq ccrd cdm wac wcel com cun wss cpw cdom wbr vex syl5eleqr
    cv omex a1i sylancl unex ssun2 ssdomg id pwex gchacg syl3anc canth2 sdomdom
    mp2 csdm ax-mp numdom ssun1 ssnum 2thd eqrdv dfac10 sylibr ) BCDZEFZCDGUTAV
    ACUTAQZVAHZVBCHZUTVBIJZVAHZVBVEKVCUTVELZVAHZVEVGMNZVFUTIVEMNZVEBHVGBHVHVJUT
    VECHIVEKVJVBIAOZRUAZIVBUBIVECUCUJSUTVECBVLUTUDZPUTVGCBVEVLUEVMPVEUFUGVEVGUK
    NVIVEVLUHVEVGUIULVGVEUMTVBIUNVEVBUOTVDUTVKSUPUQURUS $.


$(
###############################################################################
             TG (TARSKI-GROTHENDIECK) SET THEORY
###############################################################################

Here we introduce Tarski-Grothendieck (TG) set theory,
named after mathematicians Alfred Tarski and Alexander Grothendieck.
TG theory extends ZFC with the TG Axiom ~ ax-groth , which
states that for every set ` x ` there is an
inaccessible cardinal ` y ` such that ` y ` is not in ` x ` .
The addition of this axiom to ZFC set theory provides a framework for
category theory, thus for all practical purposes giving us a complete
foundation for "all of mathematics."

We first introduce the concept of inaccessibles, including
Weakly and strongly inaccessible cardinals
( ~ df-wina and ~ df-ina respectively),
Tarski's classes ( ~ df-tsk ), and a Grothendieck's universe ( ~ df-gru ).
We then introduce the Tarski's axiom ~ ax-groth and prove
various properties from that.
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Inaccessibles
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Weakly and strongly inaccessible cardinals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c InaccW $. $( Weakly inaccessible $)
  $c Inacc $. $( Strongly inaccessible $)

  $( The class of weak inaccessibles. $)
  cwina $a class InaccW $.

  $( The class of strong inaccessibles. $)
  cina $a class Inacc $.

  ${
    $d A x y z $.
    $( An ordinal is weakly inaccessible iff it is a regular limit cardinal.
       Note that our definition allows ` om ` as a weakly inacessible
       cardinal.  (Contributed by Mario Carneiro, 22-Jun-2013.) $)
    df-wina $a |- InaccW = { x | ( x =/= (/) /\ ( cf ` x ) = x /\
      A. y e. x E. z e. x y ~< z ) } $.

    $( An ordinal is strongly inaccessible iff it is a regular strong limit
       cardinal, which is to say that it dominates the powersets of every
       smaller ordinal.  (Contributed by Mario Carneiro, 22-Jun-2013.) $)
    df-ina $a |- Inacc = { x | ( x =/= (/) /\ ( cf ` x ) = x /\
      A. y e. x ~P y ~< x ) } $.
  $}

  ${
    $d A x y z $.
    $( Conditions of weak inaccessibility.  (Contributed by Mario Carneiro,
       22-Jun-2013.) $)
    elwina $p |- ( A e. InaccW <-> ( A =/= (/) /\ ( cf ` A ) = A /\
        A. x e. A E. y e. A x ~< y ) ) $=
      ( vz cwina wcel cvv c0 wne ccf cfv wceq csdm wbr wrex wral w3a elex fvex
      cv eleq1 mpbii 3ad2ant2 neeq1 wb fveq2 mpancom rexeq raleqbi1dv 3anbi123d
      eqeq12 df-wina elab2g pm5.21nii ) CEFCGFZCHIZCJKZCLZATBTMNZBCOZACPZQZCERU
      RUPUOVAURUQGFUOCJSUQCGUAUBUCDTZHIZVCJKZVCLZUSBVCOZAVCPZQVBDCEGVCCLZVDUPVF
      URVHVAVCCHUDVEUQLVIVFURUEVCCJUFVEUQVCCUKUGVGUTAVCCUSBVCCUHUIUJDABULUMUN
      $.

    $( Conditions of strong inaccessibility.  (Contributed by Mario Carneiro,
       22-Jun-2013.) $)
    elina $p |- ( A e. Inacc <-> ( A =/= (/) /\ ( cf ` A ) = A /\
      A. x e. A ~P x ~< A ) ) $=
      ( vy cina wcel cvv c0 wne ccf cfv wceq cv cpw csdm wbr wral w3a elex fvex
      eleq1 mpbii 3ad2ant2 neeq1 wb fveq2 eqeq12 mpancom breq2 3anbi123d df-ina
      raleqbi1dv elab2g pm5.21nii ) BDEBFEZBGHZBIJZBKZALMZBNOZABPZQZBDRUQUOUNUT
      UQUPFEUNBISUPBFTUAUBCLZGHZVBIJZVBKZURVBNOZAVBPZQVACBDFVBBKZVCUOVEUQVGUTVB
      BGUCVDUPKVHVEUQUDVBBIUEVDUPVBBUFUGVFUSAVBBVBBURNUHUKUICAUJULUM $.
  $}

  ${
    $d A x y $.
    $( A weakly inaccessible cardinal is an ordinal.  (Contributed by Mario
       Carneiro, 29-May-2014.) $)
    winaon $p |- ( A e. InaccW -> A e. On ) $=
      ( vx vy cwina wcel c0 wne ccf cfv wceq csdm wbr wrex wral w3a con0 elwina
      cv cfon eleq1 mpbii 3ad2ant2 sylbi ) ADEAFGZAHIZAJZBRCRKLCAMBANZOAPEZBCAQ
      UFUDUHUGUFUEPEUHASUEAPTUAUBUC $.

    $( Lemma for ~ inawina .  (Contributed by Mario Carneiro, 8-Jun-2014.) $)
    inawinalem $p |- ( A e. On ->
        ( A. x e. A ~P x ~< A -> A. x e. A E. y e. A x ~< y ) ) $=
      ( con0 wcel cv cpw csdm wbr wrex cen cdom sdomdom ccrd cdm ondomen isnum2
      wa sylib mpd sylan2 ensdomtr ad2ant2l wi sdomel ad2ant2r vex canth2 ensym
      sdomentr sylancr ad2antlr jca expcom reximdv2 ex ralimdv ) CDEZAFZGZCHIZU
      SBFZHIZBCJZACURVAVDURVARZVBUTKIZBDJZVDVAURUTCLIZVGUTCMURVHRUTNOEVGCUTPBUT
      QSUAVEVFVCBDCVBDEZVFRZVEVBCEZVCRVJVERZVKVCVLVBCHIZVKVFVAVMVIURVBUTCUBUCVI
      URVMVKUDVFVAVBCUEUFTVFVCVIVEVFUSUTHIUTVBKIVCUSAUGUHVBUTUIUSUTVBUJUKULUMUN
      UOTUPUQ $.

    $( Every strongly inaccessible cardinal is weakly inaccessible.
       (Contributed by Mario Carneiro, 29-May-2014.) $)
    inawina $p |- ( A e. Inacc -> A e. InaccW ) $=
      ( vx vy c0 wne ccf cfv wceq cv cpw csdm wbr wral w3a wrex cina wcel cwina
      con0 idd cfon eleq1 mpbii inawinalem 3anim123d mpcom elina elwina 3imtr4i
      3ad2ant2 ) ADEZAFGZAHZBIZJAKLBAMZNZUKUMUNCIKLCAOBAMZNZAPQARQASQZUPURUMUKU
      SUOUMULSQUSAUAULASUBUCUJUSUKUKUMUMUOUQUSUKTUSUMTBCAUDUEUFBAUGBCAUHUI $.
  $}

  ${
    $( ` om ` is a strongly inaccessible cardinal.  (Many definitions of
       "inaccessible" explicitly disallow ` om ` as an inaccessible cardinal,
       but this choice allows us to reuse our results for inaccessibles for
       ` om ` .)  (Contributed by Mario Carneiro, 29-May-2014.) $)
    omina $p |- om e. Inacc $=
      ( vx com cina wcel c0 wne ccf cfv wceq cv cpw csdm wral peano1 ne0i ax-mp
      wbr cfom cfn sylib nnfi pwfi isfinite rgen elina mpbir3an ) BCDBEFZBGHBIA
      JZKZBLQZABMEBDUGNBEOPRUJABUHBDZUISDZUJUKUHSDULUHUAUHUBTUIUCTUDABUEUF $.
  $}

  ${
    $d A x y $.
    $( A weakly inaccessible cardinal is a cardinal.  (Contributed by Mario
       Carneiro, 29-May-2014.) $)
    winacard $p |- ( A e. InaccW -> ( card ` A ) = A ) $=
      ( vx vy cwina wcel c0 wne ccf cfv wceq csdm wbr wrex wral w3a ccrd elwina
      cv cardcf fveq2 id 3eqtr3a 3ad2ant2 sylbi ) ADEAFGZAHIZAJZBRCRKLCAMBANZOA
      PIZAJZBCAQUGUEUJUHUGUFPIUFUIAASUFAPTUGUAUBUCUD $.
  $}

  ${
    $d A w x y z $.
    $( A weakly inaccessible cardinal is infinite.  (Contributed by Mario
       Carneiro, 29-May-2014.) $)
    winainflem $p |- ( ( A =/= (/) /\ A e. On /\
        A. x e. A E. y e. A x ~< y ) -> om C_ A ) $=
      ( vz vw c0 con0 wcel cv csdm wbr wrex w3a com wss wn wceq wa eleq2 syl wo
      wne wral csuc nn0suc simp1 necon2bi vex sucid mpbiri adantl breq1 rexbidv
      wi breq2 cbvrexv syl6bb rspcv cdom cvv biimpa 3ad2antl2 wb suceloni eleq1
      nnon biimparc 3adant3 onelon simpl1 onsssuc syl2anc mpbird ssdomg domnsym
      sylan mpsyl nrexdv 3expia pm2.65d simp3 nsyl rexlimiva jaoi word 3ad2ant2
      con2i ordom eloni ordtri1 sylancr ) CFUBZCGHZAIZBIZJKZBCLZACUCZMZNCOZCNHZ
      PZXAWSXACFQZCDIZUDZQZDNLZUAWSPZDCUEXCXHXGWSCFWLWMWRUFUGXFXHDNXDNHZXFRZWRW
      SXJWRXDEIZJKZECLZXJXDCHZWRXMUNXFXNXIXFXNXDXEHXDDUHZUICXEXDSUJUKWQXMAXDCWN
      XDQZWQXDWOJKZBCLXMXPWPXQBCWNXDWOJULUMXQXLBECWOXKXDJUOUPUQURTXIXFWRXMPXIXF
      WRMZXLECXRXKCHZRZXKXDUSKZXLPXDUTHXTXKXDOZYAXOXTYBXKXEHZXFXIXSYCWRXFXSYCCX
      EXKSVAVBXTXKGHZXDGHZYBYCVCXRWMXSYDXIXFWMWRXIXEGHZXFWMXIYEYFXDVFZXDVDTXFWM
      YFCXEGVEVGVPVHCXKVIVPXTXIYEXIXFWRXSVJYGTXKXDVKVLVMXKXDUTVNVQXKXDVOTVRVSVT
      WLWMWRWAWBWCWDTWGWSNWECWEZWTXBVCWHWMWLYHWRCWIWFNCWJWKVM $.

    $( A weakly inaccessible cardinal is infinite.  (Contributed by Mario
       Carneiro, 29-May-2014.) $)
    winainf $p |- ( A e. InaccW -> om C_ A ) $=
      ( vx vy cwina wcel wne ccf cfv wceq csdm wbr wrex wral w3a com wss elwina
      c0 cv con0 cfon eleq1 mpbii winainflem syl3an2 sylbi ) ADEARFZAGHZAIZBSCS
      JKCALBAMZNOAPZBCAQUIUGATEZUJUKUIUHTEULAUAUHATUBUCBCAUDUEUF $.

    $( A weakly inaccessible cardinal is a limit ordinal.  (Contributed by
       Mario Carneiro, 29-May-2014.) $)
    winalim $p |- ( A e. InaccW -> Lim A ) $=
      ( cwina wcel com wss wlim winainf ccrd cfv wceq wb winacard cardlim sseq2
      limeq bibi12d mpbii syl mpbid ) ABCZDAEZAFZAGTAHIZAJZUAUBKZALUDDUCEZUCFZK
      UEAMUDUFUAUGUBUCADNUCAOPQRS $.

    $( A nontrivial weakly inaccessible cardinal is a limit aleph.
       (Contributed by Mario Carneiro, 29-May-2014.) $)
    winalim2 $p |- ( ( A e. InaccW /\ A =/= om ) ->
      E. x ( ( aleph ` x ) = A /\ Lim x ) ) $=
      ( vy vw vz wcel com wne wa cv cale cfv wceq con0 wrex wex c0 wn csdm wbr
      cwina wlim ccrd winacard wss winainf cardalephex syl adantr df-rex simprr
      wb mpbid eqcomd csuc cvv w3o simprl onzsl sylib simplr aleph0 syl6eq eqtr
      fveq2 sylan2 ex necon3ad sylc pm2.21d wral suceloni sucid alephord2i ee10
      vex ad2antrl simplrr ad2antll eqtrd eleqtrrd ccf elwina simp3bi ad3antrrr
      rexbidv rspcva syl2anc expr wi iscard simprbi rsp 3syl breq2d alephnbtwn2
      breq1 sylibd pm3.21 mtoi syl6 imp nrexdv pm2.65d simpr a1i mpd jca eximdv
      3jaod syl5bi ) BUAFZBGHZIZBAJZKLZMZANOZXPBMZXOUBZIZAPZXLXRXMXLBUCLBMZXRBU
      DZXLGBUEYCXRULBUFABUGUHUMUIXRXONFZXQIZAPXNYBXQANUJXNYFYAAXNYFYAXNYFIZXSXT
      YGBXPXNYEXQUKZUNYGXOQMZXOCJZUOZMZCNOZXOUPFZXTIZUQZXTYGYEYPXNYEXQURCXOUSUT
      YGYIXTYMYOYGYIXTYGXQXMYIRYHXLXMYFVAXQYIBGXQYIBGMZYIXQXPGMYQYIXPQKLGXOQKVE
      VBVCBXPGVDVFVGVHVIVJYGYMXTYGYLCNYGYJNFZIYLYJKLZDJZSTZDBOZYGYRYLUUBYGYRYLI
      ZIZYSBFEJZYTSTZDBOZEBVKZUUBUUDYSYKKLZBYRYSUUIFZYGYLYRYKNFYJYKFUUJYJVLYJCV
      PVMYJYKVNVOVQUUDBXPUUIXNYEXQUUCVRYLXPUUIMYGYRXOYKKVEVSVTZWAXLUUHXMYFUUCXL
      BQHBWBLBMUUHEDBWCWDWEUUGUUBEYSBUUEYSMUUFUUADBUUEYSYTSWQWFWGWHWIYGYRYLUUBR
      UUDUUADBUUDYTBFZUUARZUUDUULYTUUISTZUUMUUDUULYTBSTZUUNXLUULUUOWJZXMYFUUCXL
      YCUUODBVKZUUPYDYCBNFUUQDBWKWLUUODBWMWNWEUUDBUUIYTSUUKWOWRUUNUUAUUAUUNIYJY
      TWPUUNUUAWSWTXAXBXCWIXDXCVJYOXTWJYGYNXTXEXFXJXGXHVGXIXKXG $.
  $}

  ${
    $d A x $.  $d A y z $.
    $( A nontrivial weakly inaccessible cardinal is a fixed point of the aleph
       function.  (Contributed by Mario Carneiro, 29-May-2014.) $)
    winafp $p |- ( ( A e. InaccW /\ A =/= om ) -> ( aleph ` A ) = A ) $=
      ( vx vy vz cwina wcel com wne wa cale cfv wceq wlim winalim2 cvv ad2antll
      cv ccf fveq2d eqtr3d wss con0 vex limelon mpan alephle syl simprl sseqtrd
      alephsing csdm wbr wrex wral elwina simp2bi ad2antrr cfle syl6eqssr eqssd
      c0 exlimddv ) AEFZAGHZIZBQZJKZALZVFMZIZAJKZALBBANVEVJIZVGVKAVLVFAJVLVFAVL
      VFVGAVIVFVGUAZVEVHVIVFUBFZVMVFOFVIVNBUCVFOUDUEVFUFUGPVEVHVIUHZUIVLAVFRKZV
      FVLARKZVPAVLVGRKZVQVPVLVGARVOSVIVRVPLVEVHVFUJPTVCVQALZVDVJVCAVAHVSCQDQUKU
      LDAUMCAUNCDAUOUPUQTVFURUSUTSVOTVB $.
  $}

  ${
    winafp.1 $e |- A e. InaccW $.
    winafp.2 $e |- A =/= om $.
    $( This theorem, which states that a nontrivial inaccessible cardinal is
       its own aleph number, is stated here in inference form, where the
       assumptions are in the hypotheses rather than an antecedent.  Often, we
       use ~ dedth to turn this type of statement into the closed form
       statement ~ winafp , but in this case, since it is consistent with ZFC
       that there are no nontrivial inaccessible cardinals, it is not possible
       to prove ~ winafp using this theorem and ~ dedth , in ZFC. (You can
       prove this if you use ~ ax-groth , though.)  (Contributed by Mario
       Carneiro, 28-May-2014.) $)
    winafpi $p |- ( aleph ` A ) = A $=
      ( cwina wcel com wne cale cfv wceq winafp mp2an ) ADEAFGAHIAJBCAKL $.
  $}

  ${
    $d x y z $.
    $( Assuming the GCH, weakly and strongly inaccessible cardinals coincide.
       Theorem 11.20 of [TakeutiZaring] p. 106.  (Contributed by Mario
       Carneiro, 5-Jun-2015.) $)
    gchina $p |- ( GCH = _V -> InaccW = Inacc ) $=
      ( vx vy vz cgch cvv wceq cwina cina cv wcel wa cfv csdm wbr wral w3a cdom
      wi com syl simpr c0 wne ccf wrex cpw idd cfn pwfi isfinite winainf ssdomg
      wss mpd sdomdomtr expcom syl5bi ad3antlr a1dd wn wb vex simplll syl5eleqr
      simprr gchinf syl2anc gchpwdom syl3anc ccrd winacard con0 iscard ad2antlr
      simprbi r19.21bi domsdomtr adantrr sylbid expr pm2.61d rexlimdva ralimdva
      3anim123d elwina elina 3imtr4g ex inawina impbid1 eqrdv ) DEFZAGHWLAIZGJZ
      WMHJZWLWNWOWLWNKZWNWOWLWNUAWPWMUBUCZWMUDLWMFZBIZCIZMNZCWMUEZBWMOZPWQWRWSU
      FZWMMNZBWMOZPWNWOWPWQWQWRWRXCXFWPWQUGWPWRUGWPXBXEBWMWPWSWMJZKZXAXECWMXHWT
      WMJZKZWSUHJZXAXERZXJXKXEXAWNXKXERWLXGXIXKXDUHJZWNXEWSUIXMXDSMNZWNXEXDUJWN
      SWMQNZXNXERWNSWMUMXOWMUKSWMGULUNXNXOXEXDSWMUOUPTUQUQURUSXHXIXKUTZXLXHXIXP
      KZKZXAXDWTQNZXEXRSWSQNZWSDJZWTDJXAXSVAXRYAXPXTXRWSEDBVBWLWNXGXQVCZVDZXHXI
      XPVEWSVFVGYCXRWTEDCVBYBVDWSWTVHVIXHXIXSXERZXPXJWTWMMNZYDXHYECWMWNYECWMOZW
      LXGWNWMVJLWMFZYFWMVKYGWMVLJYFCWMVMVOTVNVPXSYEXEXDWTWMVQUPTVRVSVTWAWBWCWDB
      CWMWEBWMWFWGUNWHWMWIWJWK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Weak universes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c WUni $. $( The class of weak universes. $)
  $c wUniCl $. $( The class of weak universes. $)

  $( Extend class definition to include the class of all weak universes. $)
  cwun $a class WUni $.

  $( Extend class definition to include the map whose value is the smallest
     weak universe. $)
  cwunm $a class wUniCl $.

  ${
    $d x y A $.  $d y B $.  $d u x y U $.
    $( The class of all weak universes.  A weak universe is a nonempty
       transitive class closed under union, pairing, and powerset.  The
       advantage of a weak universe over a Grothendieck universe is that weak
       universes satisfy the analogue ~ uniwun of ~ grothtsk in ZFC.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    df-wun $a |- WUni = { u | ( Tr u /\ u =/= (/) /\
      A. x e. u ( U. x e. u /\ ~P x e. u /\ A. y e. u { x , y } e. u ) ) } $.

    $( A function that maps a set ` x ` to the smallest weak universe that
       contains the elements of the set.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    df-wunc $a |- wUniCl = ( x e. _V |-> |^| { u e. WUni | x C_ u } ) $.

    $( Properties of a weak universe.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    iswun $p |- ( U e. V -> ( U e. WUni <-> ( Tr U /\ U =/= (/) /\
      A. x e. U ( U. x e. U /\ ~P x e. U /\ A. y e. U { x , y } e. U ) ) ) ) $=
      ( vu cv wtr wne cuni wcel cpw cpr wral w3a cwun wceq raleqbi1dv 3anbi123d
      c0 eleq2 treq neeq1 df-wun elab2g ) EFZGZUESHZAFZIZUEJZUHKZUEJZUHBFLZUEJZ
      BUEMZNZAUEMZNCGZCSHZUICJZUKCJZUMCJZBCMZNZACMZNECODUECPZUFURUGUSUQVEUECUAU
      ECSUBUPVDAUECVFUJUTULVAUOVCUECUITUECUKTUNVBBUECUECUMTQRQRABEUCUD $.

    $( A weak universe is transitive.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    wuntr $p |- ( U e. WUni -> Tr U ) $=
      ( vx vy cwun wcel wtr c0 wne cv cuni cpw cpr wral w3a iswun ibi simp1d )
      ADEZAFZAGHZBIZJAEUAKAEUACILAECAMNBAMZRSTUBNBCADOPQ $.

    wununi.1 $e |- ( ph -> U e. WUni ) $.
    wununi.2 $e |- ( ph -> A e. U ) $.
    $( A weak universe is closed under union.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    wununi $p |- ( ph -> U. A e. U ) $=
      ( vx vy wcel cv cuni wral cwun cpw cpr w3a wtr c0 wne iswun ibi 3syl wceq
      simp3d simp1 ralimi unieq eleq1d rspcv sylc ) ABCHFIZJZCHZFCKZBJZCHZEACLH
      ZULUJMCHZUJGINCHGCKZOZFCKZUMDUPCPZCQRZUTUPVAVBUTOFGCLSTUCUSULFCULUQURUDUE
      UAULUOFBCUJBUBUKUNCUJBUFUGUHUI $.

    $( A weak universe is closed under powerset.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wunpw $p |- ( ph -> ~P A e. U ) $=
      ( vx vy wcel cv cpw wral cwun cuni cpr w3a wtr c0 wne iswun ibi 3syl wceq
      simp3d simp2 ralimi pweq eleq1d rspcv sylc ) ABCHFIZJZCHZFCKZBJZCHZEACLHZ
      UJMCHZULUJGINCHGCKZOZFCKZUMDUPCPZCQRZUTUPVAVBUTOFGCLSTUCUSULFCUQULURUDUEU
      AULUOFBCUJBUBUKUNCUJBUFUGUHUI $.

    $( The elements of a weak universe are also subsets of it.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wunelss $p |- ( ph -> A C_ U ) $=
      ( wtr wcel wss cwun wuntr syl trss sylc ) ACFZBCGBCHACIGNDCJKECBLM $.

    ${
      wunpr.3 $e |- ( ph -> B e. U ) $.
      $( A weak universe is closed under pairing.  (Contributed by Mario
         Carneiro, 2-Jan-2017.) $)
      wunpr $p |- ( ph -> { A , B } e. U ) $=
        ( vx vy wcel cv cpr wral cwun cuni cpw w3a wtr wceq eleq1d c0 wne iswun
        ibi simp3d simp3 ralimi 3syl preq1 preq2 rspc2va syl21anc ) ABDJCDJHKZI
        KZLZDJZIDMZHDMZBCLZDJZFGADNJZUMODJZUMPDJZUQQZHDMZUREVADRZDUAUBZVEVAVFVG
        VEQHIDNUCUDUEVDUQHDVBVCUQUFUGUHUPUTBUNLZDJHIBCDDUMBSUOVHDUMBUNUITUNCSVH
        USDUNCBUJTUKUL $.

      $( A weak universe is closed under binary union.  (Contributed by Mario
         Carneiro, 2-Jan-2017.) $)
      wunun $p |- ( ph -> ( A u. B ) e. U ) $=
        ( cpr cuni cun wcel wceq uniprg syl2anc wunpr wununi eqeltrrd ) ABCHZIZ
        BCJZDABDKCDKSTLFGBCDDMNARDEABCDEFGOPQ $.

      wuntp.3 $e |- ( ph -> C e. U ) $.
      $( A weak universe is closed under unordered triple.  (Contributed by
         Mario Carneiro, 2-Jan-2017.) $)
      wuntp $p |- ( ph -> { A , B , C } e. U ) $=
        ( ctp csn cpr cun tpass dfsn2 wunpr syl5eqel wunun ) ABCDJBKZCDLZMEBCDN
        ASTEFASBBLEBOABBEFGGPQACDEFHIPRQ $.
    $}

    ${
      wunss.3 $e |- ( ph -> B C_ A ) $.
      $( A weak universe is closed under subsets.  (Contributed by Mario
         Carneiro, 2-Jan-2017.) $)
      wunss $p |- ( ph -> B e. U ) $=
        ( cpw wunpw wunelss wcel wss wb elpw2g syl mpbird sseldd ) ABHZDCARDEAB
        DEFIJACRKZCBLZGABDKSTMFCBDNOPQ $.
    $}

    $( A weak universe is closed under intersections.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wunin $p |- ( ph -> ( A i^i B ) e. U ) $=
      ( cin wss inss1 a1i wunss ) ABBCGZDEFLBHABCIJK $.

    $( A weak universe is closed under set difference.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wundif $p |- ( ph -> ( A \ B ) e. U ) $=
      ( cdif difssd wunss ) ABBCGDEFABCHI $.

    $( A weak universe is closed under intersections.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wunint $p |- ( ( ph /\ A =/= (/) ) -> |^| A e. U ) $=
      ( c0 wne wa cuni cint cwun wcel adantr wununi wss intssuni adantl wunss )
      ABFGZHBIZBJZCACKLSDMATCLSABCDENMSUATOABPQR $.

    $( A weak universe is closed under singletons.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wunsn $p |- ( ph -> { A } e. U ) $=
      ( csn cpr dfsn2 wunpr syl5eqel ) ABFBBGCBHABBCDEEIJ $.

    $( A weak universe is closed under successors.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wunsuc $p |- ( ph -> suc A e. U ) $=
      ( csuc csn cun df-suc wunsn wunun syl5eqel ) ABFBBGZHCBIABMCDEABCDEJKL $.
  $}

  ${
    $d x y z A $.  $d x y z ph $.  $d x y z U $.
    wun0.1 $e |- ( ph -> U e. WUni ) $.
    $( A weak universe contains the empty set.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    wun0 $p |- ( ph -> (/) e. U ) $=
      ( vx vy cv wcel wne wex cwun wtr cuni cpw cpr wral w3a iswun ibi simp2d
      c0 syl n0 sylib wa adantr simpr wss 0ss a1i wunss exlimddv ) ADFZBGZTBGDA
      BTHZUMDIABJGZUNCUOBKZUNULLBGULMBGULEFNBGEBOPDBOZUOUPUNUQPDEBJQRSUADBUBUCA
      UMUDZULTBAUOUMCUEAUMUFTULUGURULUHUIUJUK $.

    $( A weak universe is infinite, because it contains all the finite levels
       of the cumulative hierarchy.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    wunr1om $p |- ( ph -> ( R1 " om ) C_ U ) $=
      ( vy vx cr1 com cima cv wcel cfv wceq wrex wi wfun con0 fveq2 eleq1d syl
      c0 wfn r1fnon fnfun ax-mp fvelima mpan csuc r10 wun0 syl5eqel wa cpw cwun
      adantr simpr wunpw nnon r1suc syl5ibr exp3a finds2 eleq1 imbi2d syl5ibcom
      rexlimiv com12 ssrdv ) ADFGHZBDIZVHJZAVIBJZVJEIZFKZVILZEGMZAVKNZFOZVJVOFP
      UAVQUBPFUCUDEVIGFUEUFVNVPEGVLGJAVMBJZNVNVPVRTFKZBJVIFKZBJZVIUGZFKZBJZAEDV
      LTLVMVSBVLTFQRVLVILVMVTBVLVIFQRVLWBLVMWCBVLWBFQRAVSTBUHABCUIUJVIGJZAWAWDA
      WAUKZWDWEVTULZBJWFVTBABUMJWACUNAWAUOUPWEWCWGBWEVIPJWCWGLVIUQVIURSRUSUTVAV
      NVRVKAVMVIBVBVCVDVESVFVG $.

    $( A weak universe contains all the finite ordinals, and hence is
       infinite.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    wunom $p |- ( ph -> om C_ U ) $=
      ( vx com cv wcel wa cr1 cfv cwun adantr cima wss wral wunr1om wfun cdm wb
      r1funlim simpli simpri limomss ax-mp funimass4 mp2an sylib r19.21bi simpr
      wlim sseldi onssr1 syl wunss ex ssrdv ) ADEBADFZEGZUQBGAURHZUQIJZUQBABKGU
      RCLAUTBGZDEAIEMBNZVADEOZABCPIQZEIRZNZVBVCSVDVEUJZTUAVGVFVDVGTUBVEUCUDZDEB
      IUEUFUGUHUSUQVEGUQUTNUSEVEUQVHAURUIUKUQULUMUNUOUP $.

    ${
      wunfi.2 $e |- ( ph -> A C_ U ) $.
      wunfi.3 $e |- ( ph -> A e. Fin ) $.
      $( A weak universe contains all finite sets with elements drawn from the
         universe.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
      wunfi $p |- ( ph -> A e. U ) $=
        ( vx vy vz wss wcel cfn wi cv c0 wceq sseq1 eleq1 imbi12d imbi2d imim1i
        csn cun wun0 a1d sstr mpan wa cwun adantr simprr simprl unssbd vex snss
        ssun1 sylibr wunsn wunun exp32 a2d syl5 a2i a1i findcard2 mpcom mpd ) A
        BCJZBCKZEBLKAVHVIMZFAGNZCJZVKCKZMZMAOCJZOCKZMZMAHNZCJZVRCKZMZMZAVRINZUB
        ZUCZCJZWECKZMZMZAVJMGHIBVKOPZVNVQAWJVLVOVMVPVKOCQVKOCRSTVKVRPZVNWAAWKVL
        VSVMVTVKVRCQVKVRCRSTVKWEPZVNWHAWLVLWFVMWGVKWECQVKWECRSTVKBPZVNVJAWMVLVH
        VMVIVKBCQVKBCRSTAVPVOACDUDUEWBWIMVRLKAWAWHWAWFVTMAWHWFVSVTVRWEJWFVSVRWD
        UPVRWECUFUGUAAWFVTWGAWFVTWGAWFVTUHZUHZVRWDCACUIKWNDUJZAWFVTUKWOWCCWPWOW
        DCJWCCKWOVRWDCAWFVTULUMWCCIUNUOUQURUSUTVAVBVCVDVEVFVG $.
    $}

    wunop.2 $e |- ( ph -> A e. U ) $.
    ${
      wunop.3 $e |- ( ph -> B e. U ) $.
      $( A weak universe is closed under ordered pairs.  (Contributed by Mario
         Carneiro, 2-Jan-2017.) $)
      wunop $p |- ( ph -> <. A , B >. e. U ) $=
        ( cop csn cpr wcel wceq dfopg syl2anc wunsn wunpr eqeltrd ) ABCHZBIZBCJ
        ZJZDABDKCDKRUALFGBCDDMNASTDEABDEFOABCDEFGPPQ $.

      ${
        wunot.3 $e |- ( ph -> C e. U ) $.
        $( A weak universe is closed under ordered triples.  (Contributed by
           Mario Carneiro, 2-Jan-2017.) $)
        wunot $p |- ( ph -> <. A , B , C >. e. U ) $=
          ( cotp cop df-ot wunop syl5eqel ) ABCDJBCKZDKEBCDLAODEFABCEFGHMIMN $.
      $}

      $( A weak universe is closed under cartesian products.  (Contributed by
         Mario Carneiro, 2-Jan-2017.) $)
      wunxp $p |- ( ph -> ( A X. B ) e. U ) $=
        ( cun cpw cxp wunun wunpw wss xpsspw a1i wunss ) ABCHZIZIZBCJZDEARDEAQD
        EABCDEFGKLLTSMABCNOP $.

      $( A weak universe is closed under partial mappings.  (Contributed by
         Mario Carneiro, 2-Jan-2017.) $)
      wunpm $p |- ( ph -> ( A ^pm B ) e. U ) $=
        ( cxp cpw cpm co wunxp wunpw wss pmsspw a1i wunss ) ACBHZIZBCJKZDEARDEA
        CBDEGFLMTSNABCOPQ $.

      $( A weak universe is closed under mappings.  (Contributed by Mario
         Carneiro, 2-Jan-2017.) $)
      wunmap $p |- ( ph -> ( A ^m B ) e. U ) $=
        ( cpm co cmap wunpm wss mapsspm a1i wunss ) ABCHIZBCJIZDEABCDEFGKQPLABC
        MNO $.

      wunf.3 $e |- ( ph -> F : A --> B ) $.
      $( A weak universe is closed under functions with known domain and
         codomain.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
      wunf $p |- ( ph -> F e. U ) $=
        ( cmap co wunmap wunelss wcel wf wb elmapg syl2anc mpbird sseldd ) ACBJ
        KZDEAUADFACBDFHGLMAEUANZBCEOZIACDNBDNUBUCPHGCBEDDQRST $.
    $}

    $( A weak universe is closed under the domain operator.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wundm $p |- ( ph -> dom A e. U ) $=
      ( cuni cdm wununi wss crn cun ssun1 dmrnssfld sstri a1i wunss ) ABFZFZBGZ
      CDAQCDABCDEHHSRIASSBJZKRSTLBMNOP $.

    $( A weak universe is closed under the range operator.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wunrn $p |- ( ph -> ran A e. U ) $=
      ( cuni crn wununi wss cdm cun ssun2 dmrnssfld sstri a1i wunss ) ABFZFZBGZ
      CDAQCDABCDEHHSRIASBJZSKRSTLBMNOP $.

    $( A weak universe is closed under the converse operator.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wuncnv $p |- ( ph -> `' A e. U ) $=
      ( crn cdm cxp ccnv wunrn wundm wunxp wss cnvssrndm a1i wunss ) ABFZBGZHZB
      IZCDAQRCDABCDEJABCDEKLTSMABNOP $.

    $( A weak universe is closed under restrictions.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    wunres $p |- ( ph -> ( A |` B ) e. U ) $=
      ( cres wss resss a1i wunss ) ABBCGZDEFLBHABCIJK $.

    $( A weak universe is closed under the function value operator.
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    wunfv $p |- ( ph -> ( A ` B ) e. U ) $=
      ( crn cuni cfv wunrn wununi wss fvssunirn a1i wunss ) ABGZHZCBIZDEAPDEABD
      EFJKRQLABCMNO $.

    ${
      wunco.3 $e |- ( ph -> B e. U ) $.
      $( A weak universe is closed under composition.  (Contributed by Mario
         Carneiro, 12-Jan-2017.) $)
      wunco $p |- ( ph -> ( A o. B ) e. U ) $=
        ( ccom cdm crn cxp wundm wss dmcoss a1i wunss wunrn rncoss wunxp wrel
        relco relssdmrn mp1i ) ABCHZIZUDJZKZUDDEAUEUFDEACIZUEDEACDEGLUEUHMABCNO
        PABJZUFDEABDEFQUFUIMABCROPSUDTUDUGMABCUAUDUBUCP $.
    $}

    $( A weak universe is closed under transposition.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    wuntpos $p |- ( ph -> tpos A e. U ) $=
      ( cdm ccnv c0 csn cun crn ctpos wundm wuncnv wun0 wunsn wunun wunrn wunxp
      cxp wss tposssxp a1i wunss ) ABFZGZHIZJZBKZTZBLZCDAUHUICDAUFUGCDAUECDABCD
      EMNAHCDACDOPQABCDERSUKUJUAABUBUCUD $.
  $}

  ${
    $d u x y A $.
    $( The intersection of a collection of weak universes is a weak universe.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    intwun $p |- ( ( A C_ WUni /\ A =/= (/) ) -> |^| A e. WUni ) $=
      ( vx vy vu cwun wss c0 wne wa wcel wtr cv w3a sselda syl ralrimiva elint2
      wral sylibr adantlr cint cuni cpw cpr simpl wuntr trint 0ex intss1 adantl
      wun0 ne0i an32s wununi vex uniex wunpw pwex wunpr prex cvv wb simpr intex
      3jca sylib iswun mpbir3and ) AEFZAGHZIZAUAZEJZVLKZVLGHZBLZUBZVLJZVPUCZVLJ
      ZVPCLZUDZVLJZCVLRZMZBVLRZVKDLZKZDARVNVKWHDAVKWGAJZIZWGEJZWHVKAEWGVIVJUENZ
      WGUFOPDAUGOVKGVLJZVOVKGWGJZDARWMVKWNDAWJWGWLUKPDGAUHQSVLGULOVKWEBVLVKVPVL
      JZIZVRVTWDWPVQWGJZDARVRWPWQDAWPWIIZVPWGVKWIWKWOWLTZVKWIWOVPWGJZWJVLWGVPWI
      VLWGFZVKWGAUIZUJNUMZUNPDVQAVPBUOZUPQSWPVSWGJZDARVTWPXEDAWRVPWGWSXCUQPDVSA
      VPXDURQSWPWCCVLWPWAVLJZIZWBWGJZDARWCXGXHDAXGWIIVPWAWGWPWIWKXFWSTWPWIWTXFX
      CTWPWIXFWAWGJWRVLWGWAWIXAWPXBUJNUMUSPDWBAVPWAUTQSPVEPVKVLVAJZVMVNVOWFMVBV
      KVJXIVIVJVCAVDVFBCVLVAVGOVH $.
  $}

  ${
    $d x y A $.  $d x y V $.
    $( Each limit stage in the cumulative hierarchy is a weak universe.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    r1limwun $p |- ( ( A e. V /\ Lim A ) -> ( R1 ` A ) e. WUni ) $=
      ( vx vy wcel wa cr1 cfv c0 cv cuni wral w3a con0 ax-mp adantl crnk adantr
      wb syl2anc wlim wtr wne cpw cpr cwun r1tr a1i cdm wss limelon wceq r1fnon
      wfn fndm syl6eleqr onssr1 0ellim sseldd ne0i rankuni word rankon orduniss
      syl eloni mp2b rankr1ai wi onuni ontr2 sylancr mp2and syl5eqel cima uniwf
      r1elwf sylib rankr1ag mpbird r1pwcl biimpa csuc ad2antlr rankprb ad3antlr
      cun limord ordunel syl3anc limsuc mpbid eqeltrd prwf ralrimiva 3jca iswun
      cvv fvex syl3anbrc ) ABEZAUAZFZAGHZUBZXDIUCZCJZKZXDEZXGUDXDEZXGDJZUEZXDEZ
      DXDLZMZCXDLZXDUFEZXEXCAUGUHXCIXDEXFXCAXDIXCAGUIZEZAXDUJXCANXRABUKZGNUNXRN
      ULUMNGUOOUPZAUQVEXBIAEXAAURPUSXDIUTVEXCXOCXDXCXGXDEZFZXIXJXNYCXIXHQHZAEZY
      CYDXGQHZKZAXGVAYCYGYFUJZYFAEZYGAEZYHYCYFNEZYFVBYHXGVCZYFVFYFVDVGUHYBYIXCX
      GAVHPZYCYGNEZANEZYHYIFYJVIYKYNYLYFVJOXCYOYBXTRYGYFAVKVLVMVNYCXHGNVOKZEZXS
      XIYESYCXGYPEZYQYBYRXCXGAVQZPXGVPVRXCXSYBYARZXHAVSTVTXCYBXJXBYBXJSXAXGAWAP
      WBYCXMDXDYCXKXDEZFZXMXLQHZAEZUUBUUCYFXKQHZWGZWCZAUUBYRXKYPEZUUCUUGULYBYRX
      CUUAYSWDZUUAUUHYCXKAVQPZXGXKWETUUBUUFAEZUUGAEZUUBAVBZYIUUEAEZUUKXBUUMXAYB
      UUAAWHWFYCYIUUAYMRUUAUUNYCXKAVHPAYFUUEWIWJXBUUKUULSXAYBUUAAUUFWKWFWLWMUUB
      XLYPEZXSXMUUDSUUBYRUUHUUOUUIUUJXGXKWNTYCXSUUAYTRXLAVSTVTWOWPWOXDWREXQXEXF
      XPMSAGWSCDXDWRWQOWT $.

    $( The weak universes in the cumulative hierarchy are exactly the limit
       ordinals.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    r1wunlim $p |- ( A e. V -> ( ( R1 ` A ) e. WUni <-> Lim A ) ) $=
      ( vx wcel cr1 cfv cwun wlim wa c0 wceq csuc con0 wn syl sucidg r1ord sylc
      ad2antrl sylanbrc word cv wrex wo cdm simpr wun0 elfvdm r1fnon fndm ax-mp
      wfn syl6eleq eloni n0i fveq2 r10 syl6eq nsyl cima suceloni r1elwf wfelirr
      cuni 3syl cpw simprr fveq2d r1suc eqtrd simplr adantr eleqtrrd rexlimdvaa
      wunpw eqeltrd mtod ioran dflim3 r1limwun impbida ) ABDZAEFZGDZAHZWBWDIZAU
      AZAJKZACUBZLZKZCMUCZUDNZWEWFAMDZWGWFAEUEZMWFJWCDZAWODWFWCWBWDUFUGZJAEUHOE
      MULWOMKUIMEUJUKUMZAUNOWFWHNWLNWMWFWCJKZWHWFWPWSNWQWCJUOOWHWCJEFJAJEUPUQUR
      USWFWLWCWCDZWFWCALZEFDZWCEMUTVDDWTNWFXAMDZAXADZXBWFWNXCWRAVAOWFWNXDWRAMPO
      AXAQRWCXAVBWCVCVEWFWKWTCMWFWIMDZWKIZIZWCWIEFZVFZWCXGWCWJEFZXIXGAWJEWFXEWK
      VGZVHXEXJXIKWFWKWIVISVJXGXHWCWBWDXFVKXGWNWIADXHWCDWFWNXFWRVLXGWIWJAXEWIWJ
      DWFWKWIMPSXKVMWIAQRVOVPVNVQWHWLVRTCAVSTABVTWA $.
  $}

  ${
    $d a u v w x y z $.  $d a b m n w A $.  $d a b m n U $.  $d a b m n V $.
    $d b i k m n u v w F $.
    wunex2.f $e |- F = ( rec ( ( z e. _V |-> ( ( z u. U. z ) u.
      U_ x e. z ( { ~P x , U. x } u.
        ran ( y e. z |-> { x , y } ) ) ) ) , ( A u. 1o ) ) |` om ) $.
    wunex2.u $e |- U = U. ran F $.
    $( Construct a weak universe from a given set.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wunex2 $p |- ( A e. V -> ( U e. WUni /\ A C_ U ) ) $=
      ( vm vu vv wcel wss cv cfv com cvv cun wa va vb vw vn vk vi cwun wtr cuni
      c0 wne cpw cpr wral w3a wrex crn eleq2i wfn wb cmpt ciun crdg cres frfnom
      fneq1i mpbir fnunirn ax-mp bitri csuc elssuni ad2antll ssun2 ssun1 syl6ss
      c1o sstri wceq simprl fvex uniex unex prex mptex rnex iunex unieq uneq12d
      weq pweq preq12d preq2 cbvmptv preq1 mpteq2dv syl5eq rneqd cbviunv mpteq1
      id uneq2d iuneq12d frsucmpt2 sylancl sseqtr4d fvssunirn rexlimdvaa syl5bi
      sseqtr4i ralrimiv dftr3 sylibr con0 1on unexg mpan2 fveq1i fr0g syl6eqssr
      syl unssbd 1n0 ssn0 ssiun2s syl5sseqr sstrd unssad vex pwex syl2anc fveq2
      prss sseq2d vtoclga findsg sseldd wi imbi12d eqeltri simprd simplrl ordom
      simpld word ordunel mp3an1 ssid a1i suceq fveq2d sseq12d ad2antrr syl5com
      sstr2 simplrr biantrud bicomd eleq1 anbi2d sseq1 anbi12d sseq1d expl sylc
      chvarv simprr eqid elrnmpt1s 3jca wfun omex resfunexg mp2an syl3anbrc jca
      rdgfun iswun ) DGMZEUGMZDENUVSEUHZEUJUKZUAOZUIZEMZUWCULZEMZUWCUBOZUMZEMZU
      BEUNZUOZUAEUNZUVTUVSUWCENZUAEUNUWAUVSUWNUAEUWCEMZUWCJOZFPZMZJQUPZUVSUWNUW
      OUWCFUQZUIZMZUWSEUXAUWCIURFQUSZUXBUWSUTUXCCRCOZUXDUIZSZAUXDAOZULZUXGUIZUM
      ZBUXDUXGBOZUMZVAZUQZSZVBZSZVAZDVQSZVCZQVDZQUSUXSUXRVEQFUYAHVFVGZJUWCFQVHV
      IVJZUVSUWRUWNJQUVSUWPQMZUWRTTZUWCUWPVKZFPZEUYEUWCUWQUWQUIZSZKUWQKOZULZUYJ
      UIZUMZLUWQUYJLOZUMZVAZUQZSZVBZSZUYGUYEUWCUYHUYTUWRUWCUYHNUVSUYDUWCUWQVLVM
      UYHUYIUYTUYHUWQVNUYIUYSVOZVRVPUYEUYDUYTRMZUYGUYTVSZUVSUYDUWRVTUYIUYSUWQUY
      HUWPFWAZUWQVUDWBWCKUWQUYRVUDUYMUYQUYKUYLWDZUYPLUWQUYOVUDWEWFWCWGWCZCUCUXS
      UWPUXQUYTUCOZVUGUIZSZKVUGUYMLVUGUYOVAZUQZSZVBZSZFRHUCCWJZVUIUXFVUMUXPVUOV
      UGUXDVUHUXEVUOXAZVUGUXDWHWIVUOVUMAVUGUXJBVUGUXLVAZUQZSZVBUXPKAVUGVULVUSKA
      WJZUYMUXJVUKVURVUTUYKUXHUYLUXIUYJUXGWKUYJUXGWHWLVUTVUJVUQVUTVUJBVUGUYJUXK
      UMZVAVUQLBVUGUYOVVAUYNUXKUYJWMWNVUTBVUGVVAUXLUYJUXGUXKWOWPWQWRWIWSVUOAVUG
      UXDVUSUXOVUPVUOVURUXNUXJVUOVUQUXMBVUGUXDUXLWTWRXBXCWQWIZVUGUWQVSZVUIUYIVU
      MUYSVVCVUGUWQVUHUYHVVCXAZVUGUWQWHWIVVCKVUGUWQVULUYRVVDVVCVUKUYQUYMVVCVUJU
      YPLVUGUWQUYOWTWRXBXCWIXDZXEZXFUYGUXAEFUYFXGIXJZVPXHXIXKUAEXLXMUVSVQENVQUJ
      UKUWBUVSDVQEUVSUXSUJFPZEUVSUXSRMZVVHUXSVSUVSVQXNMVVIXODVQGXNXPXQVVIVVHUJU
      YAPUXSUJFUYAHXRUXSRUXRXSWQYAVVHUXAEFUJXGIXJXTZYBYCVQEYDXEUVSUWLUAEUWOUWSU
      VSUWLUYCUVSUWRUWLJQUYEUWEUWGUWKUYEUWGUWEUYEUWFUWDUMZENUWGUWETUYEVVKLUWQUW
      CUYNUMZVAZUQZEUYEVVKVVNSZUYSEUWRVVOUYSNUVSUYDKUWQUYRUWCVVOKUAWJZUYMVVKUYQ
      VVNVVPUYKUWFUYLUWDUYJUWCWKUYJUWCWHWLZVVPUYPVVMVVPLUWQUYOVVLUYJUWCUYNWOZWP
      WRWIYEVMUYEUYSUYGEUYEUYTUYSUYGUYSUYIVNVVFYFVVGVPYGYHUWFUWDEUWCUAYIZYJUWCV
      VSWBYMXMZUUAUYEUWGUWEVVTUUDUYEUWJUBEUWHEMZUWHUDOZFPZMZUDQUPZUYEUWJVWAUWHU
      XAMZVWEEUXAUWHIURUXCVWFVWEUTUYBUDUWHFQVHVIVJUYEVWDUWJUDQUYEVWBQMZVWDTZTZL
      UWPVWBSZFPZVVLVAZUQZEUWIVWIVVKVWMEVWIVVKVWMSZKVWKUYMLVWKUYOVAZUQZSZVBZEVW
      IUWCVWKMVWNVWRNVWIUWQVWKUWCVWIVWJQMZUYDUWQVWKNZVWIUYDVWGVWSUVSUYDUWRVWHUU
      BZUYEVWGVWDVTZQUUEUYDVWGVWSUUCQUWPVWBUUFUUGYKZVXAVWSUYDTUWPVWJNVWTUWPVWBV
      OUWQUEOZFPZNZUWQUWQNZUWQUFOZFPZNZUWQVXHVKZFPZNZVWTUEUFVWJUWPUEJWJVXEUWQUW
      QVXDUWPFYLYNZUEUFWJVXEVXIUWQVXDVXHFYLYNZVXDVXKVSVXEVXLUWQVXDVXKFYLYNZVXDV
      WJVSVXEVWKUWQVXDVWJFYLYNVXGUYDUWQUUHUUIZVXHQMZUYDTZUWPVXHNZTZVXIVXLNZVXJV
      XMVXRVYBUYDVXTUWQUYGNVYBJVXHQJUFWJZUWQVXIUYGVXLUWPVXHFYLVYCUYFVXKFUWPVXHU
      UJUUKUULUYDUYTUWQUYGUWQUYIUYTUWQUYHVOVUAVRUYDVUBVUCVUFVVEXQYFYOUUMUWQVXIV
      XLUUOUUNZYPXQYKUVSUYDUWRVWHUUPYQKVWKVWQUWCVWNVVPUYMVVKVWPVWMVVQVVPVWOVWLV
      VPLVWKUYOVVLVVRWPWRWIYEYAVWIVWRVWJVKZFPZEVWIVWKVWKUIZSZVWRSZVWRVYFVWRVYHV
      NVWIVWSVYIRMVYFVYIVSVXCVYHVWRVWKVYGVWJFWAZVWKVYJWBWCKVWKVWQVYJUYMVWPVUEVW
      OLVWKUYOVYJWEWFWCWGWCCUCUXSVWJUXQVYIVUNFRHVVBVUGVWKVSZVUIVYHVUMVWRVYKVUGV
      WKVUHVYGVYKXAZVUGVWKWHWIVYKKVUGVWKVULVWQVYLVYKVUKVWPUYMVYKVUJVWOLVUGVWKUY
      OWTWRXBXCWIXDXEYFVYFUXAEFVYEXGIXJVPYGYBVWIUWHVWKMUWIRMUWIVWMMVWIVWCVWKUWH
      VWIVWSVWGVWCVWKNZVXCVXBVWGVWBVXHNZTZVWCVXINZYRVWGVYMYRUFVWJQVXHVWJVSZVYOV
      WGVYPVYMVYQVWGVYOVYQVYNVWGVYQVWJVWBVXHVWBUWPVNVYQXAYFUUQUURVYQVXIVWKVWCVX
      HVWJFYLYNYSVXRVWGVYNVYPVYAVXJYRVXRVWGTZVYNTZVYPYRJUDJUDWJZVYAVYSVXJVYPVYT
      VXSVYRVXTVYNVYTUYDVWGVXRUWPVWBQUUSUUTUWPVWBVXHUVAUVBVYTUWQVWCVXIUWPVWBFYL
      UVCYSVXFVXGVXJVXMVXJUEUFVXHUWPVXNVXOVXPVXOVXQVYDYPUVFUVDYOUVEUYEVWGVWDUVG
      YQUWCUWHWDLVWKVVLUWIUWHVWLRVWLUVHUYNUWHUWCWMUVIXEYQXHXIXKUVJXHXIXKERMUVTU
      WAUWBUWMUOUTEUXARIUWTFFUYARHUXTUVKQRMUYARMUXSUXRUVQUVLUXTQRUVMUVNYTWFWBYT
      UAUBERUVRVIUVOUVSDVQEVVJYHUVP $.
  $}

  ${
    $d u x y z $.  $d u A $.
    $( Construct a weak universe from a given set.  See also ~ wunex2 .
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    wunex $p |- ( A e. V -> E. u e. WUni A C_ u ) $=
      ( vz vx vy wcel cvv cv cuni cun cpw cpr cmpt crn ciun c1o cwun wss eqid
      crdg com cres wa wrex wunex2 sseq2 rspcev syl ) BCGDHDIZUJJKEUJEIZLUKJMFU
      JUKFIMNOKPKNBQKUAUBUCZOJZRGBUMSZUDBAIZSZARUEEFDBUMULCULTUMTUFUPUNAUMRUOUM
      BUGUHUI $.

    $( Every set is contained in a weak universe.  This is the analogue of
       ~ grothtsk , but it is provable in ZFC without the Tarski-Grothendieck
       axiom.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    uniwun $p |- U. WUni = _V $=
      ( vx vu cwun cuni cvv wceq cv wcel eqv csn wss wrex snex wunex eluni2 vex
      ax-mp snss rexbii bitri mpbir mpgbir ) CDZEFAGZUCHZAAUCIUEUDJZBGZKZBCLZUF
      EHUIUDMBUFENQUEUDUGHZBCLUIBUDCOUJUHBCUDUGAPRSTUAUB $.

    wunex3.u $e |- U = ( R1 ` ( ( rank ` A ) +o om ) ) $.
    $( Construct a weak universe from a given set.  This version of ~ wunex has
       a simpler proof, but requires the axiom of regularity.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wunex3 $p |- ( A e. V -> ( U e. WUni /\ A C_ U ) ) $=
      ( wcel wss cwun crnk cfv cr1 r1rankid com coa co con0 rankon omelon mp2an
      oacl wlim c0 peano1 wb oaord1 mpbi r1ord2 sseqtr4i syl6ss wa limom pm3.2i
      mp2 oalimcl r1limwun eqeltri jctil ) ACEZABFBGEUQAAHIZJIZBACKUSURLMNZJIZB
      UTOEZURUTEZUSVAFUROEZLOEZVBAPZQURLSRZUALEZVCUBVDVEVHVCUCVFQURLUDRUEURUTUF
      ULDUGUHBVAGDVBUTTZVAGEVGVDVELTZUIVIVFVEVJQUJUKURLOUMRUTOUNRUOUP $.
  $}

  ${
    $d u v w x y z $.  $d m n u v w x y A $.  $d u U $.  $d m n u v x y V $.
    $d m n u v w F $.
    $( Value of the weak universe closure operator.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wuncval $p |- ( A e. V -> ( wUniCl ` A ) = |^| { u e. WUni | A C_ u } ) $=
      ( vx wcel cvv cv wss cwun crab cint cwunm cfv wceq elex c0 wne wrex wunex
      rabn0 sylibr intex sylib sseq1 rabbidv inteqd df-wunc fvmptg syl2anc ) BC
      EZBFEBAGZHZAIJZKZFEZBLMUNNBCOUJUMPQZUOUJULAIRUPABCSULAITUAUMUBUCDBDGZUKHZ
      AIJZKUNFFLUQBNZUSUMUTURULAIUQBUKUDUEUFDAUGUHUI $.

    $( The weak universe closure of a set contains the set.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wuncid $p |- ( A e. V -> A C_ ( wUniCl ` A ) ) $=
      ( vu wcel cv wss cwun crab cint cwunm cfv ssintub wuncval syl5sseqr ) ABD
      ACEFCGHIAAJKCAGLCABMN $.

    $( The weak universe closure of a set is a weak universe.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    wunccl $p |- ( A e. V -> ( wUniCl ` A ) e. WUni ) $=
      ( vu wcel cwunm cfv cv wss cwun crab cint wuncval c0 wne wrex wunex rabn0
      ssrab2 sylibr intwun sylancr eqeltrd ) ABDZAEFACGHZCIJZKZICABLUCUEIHUEMNZ
      UFIDUDCIRUCUDCIOUGCABPUDCIQSUETUAUB $.

    $( The weak universe closure is a subset of any other weak universe
       containing the set.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    wuncss $p |- ( ( U e. WUni /\ A C_ U ) -> ( wUniCl ` A ) C_ U ) $=
      ( vu cwun wcel wss wa cwunm cfv cv crab cint cvv ssexg ancoms wuncval syl
      wceq sseq2 intminss eqsstrd ) BDEZABFZGZAHIZACJZFZCDKLZBUDAMEZUEUHRUCUBUI
      ABDNOCAMPQUGUCCBDUFBASTUA $.

    $( The weak universe closure is idempotent.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    wuncidm $p |- ( A e. V -> ( wUniCl ` ( wUniCl ` A ) ) = ( wUniCl ` A ) ) $=
      ( wcel cwunm cfv cwun wss wunccl ssid wuncss sylancl wuncid syl eqssd ) A
      BCZADEZDEZPOPFCZPPGQPGABHZPIPPJKORPQGSPFLMN $.

    wuncval2.f $e |- F = ( rec ( ( z e. _V |-> ( ( z u. U. z ) u.
      U_ x e. z ( { ~P x , U. x } u.
        ran ( y e. z |-> { x , y } ) ) ) ) , ( A u. 1o ) ) |` om ) $.
    wuncval2.u $e |- U = U. ran F $.
    $( Our earlier expression for a containing weak universe is in fact the
       weak universe closure.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    wuncval2 $p |- ( A e. V -> ( wUniCl ` A ) = U ) $=
      ( vm vu vv wcel cfv wss com cv cuni cun c0 vn vw cwunm cwun wunex2 wuncss
      wa syl ciun crn wfn wceq cvv cpw cpr cmpt crdg cres frfnom fneq1i fniunfv
      c1o mpbir ax-mp eqtr4i wral csuc fveq2 sseq1d weq con0 unexg mpan2 fveq1i
      1on fr0g syl5eq wuncid csn df1o2 wunccl wun0 snssd syl5eqss unssd eqsstrd
      wi simplr fvex uniex unex prex mptex iunex id unieq uneq12d preq12d preq1
      rnex pweq mpteq2dv rneqd cbviunv cbvmptv mpteq1 uneq2d iuneq12d frsucmpt2
      preq2 sylancl simpr ad3antrrr sselda ralrimiva unissb sylibr wunpw wununi
      wunelss prssi syl2anc wf adantr wunpr fmptd frn iunss expcom finds2 com12
      eqid ex ralrimiv eqssd ) DGMZDUCNZEYPEUDMDEOUGYQEOABCDEFGHIUEDEUFUHYPEJPJ
      QZFNZUIZYQEFUJRZYTIFPUKZYTUUAULUUBCUMCQZUUCRZSZAUUCAQZUNZUUFRZUOZBUUCUUFB
      QZUOZUPZUJZSZUIZSZUPZDVBSZUQPURZPUKUURUUQUSPFUUSHUTVCJPFVAVDVEYPYSYQOZJPV
      FYTYQOYPUUTJPYRPMYPUUTUUTTFNZYQOUAQZFNZYQOZUVBVGZFNZYQOZYPJUAYRTULYSUVAYQ
      YRTFVHVIJUAVJYSUVCYQYRUVBFVHVIYRUVEULYSUVFYQYRUVEFVHVIYPUVAUURYQYPUURUMMZ
      UVAUURULYPVBVKMUVHVODVBGVKVLVMUVHUVATUUSNUURTFUUSHVNUURUMUUQVPVQUHYPDVBYQ
      DGVRYPVBTVSYQVTYPTYQYPYQDGWAZWBWCWDWEWFYPUVBPMZUVDUVGWGYPUVJUGZUVDUVGUVKU
      VDUGZUVFUVCUVCRZSZKUVCKQZUNZUVORZUOZLUVCUVOLQZUOZUPZUJZSZUIZSZYQUVLUVJUWE
      UMMUVFUWEULYPUVJUVDWHUVNUWDUVCUVMUVBFWIZUVCUWFWJWKKUVCUWCUWFUVRUWBUVPUVQW
      LUWALUVCUVTUWFWMWTWKWNWKCUBUURUVBUUPUWEUBQZUWGRZSZKUWGUVRLUWGUVTUPZUJZSZU
      IZSFUMHUBCVJZUWIUUEUWMUUOUWNUWGUUCUWHUUDUWNWOZUWGUUCWPWQUWNUWMAUWGUUILUWG
      UUFUVSUOZUPZUJZSZUIUUOKAUWGUWLUWSKAVJZUVRUUIUWKUWRUWTUVPUUGUVQUUHUVOUUFXA
      UVOUUFWPWRUWTUWJUWQUWTLUWGUVTUWPUVOUUFUVSWSXBXCWQXDUWNAUWGUUCUWSUUNUWOUWN
      UWRUUMUUIUWNUWQUULUWNUWQBUWGUUKUPUULLBUWGUWPUUKUVSUUJUUFXJXEBUWGUUCUUKXFV
      QXCXGXHVQWQUWGUVCULZUWIUVNUWMUWDUXAUWGUVCUWHUVMUXAWOZUWGUVCWPWQUXAKUWGUVC
      UWLUWCUXBUXAUWKUWBUVRUXAUWJUWALUWGUVCUVTXFXCXGXHWQXIXKUVLUVNUWDYQUVLUVCUV
      MYQUVKUVDXLZUVLUVOYQOZKUVCVFUVMYQOUVLUXDKUVCUVLUVOUVCMZUGZUVOYQYPYQUDMZUV
      JUVDUXEUVIXMZUVLUVCYQUVOUXCXNZXTXOKUVCYQXPXQWEUVLUWCYQOZKUVCVFUWDYQOUVLUX
      JKUVCUXFUVRUWBYQUXFUVPYQMUVQYQMUVRYQOUXFUVOYQUXHUXIXRUXFUVOYQUXHUXIXSUVPU
      VQYQYAYBUXFUVCYQUWAYCUWBYQOUXFLUVCUVTYQUWAUXFUVSUVCMZUGUVOUVSYQUXFUXGUXKU
      XHYDUXFUVOYQMUXKUXIYDUXFUVCYQUVSUVKUVDUXEWHXNYEUWAYLYFUVCYQUWAYGUHWEXOKUV
      CUWCYQYHXQWEWFYMYIYJYKYNJPYSYQYHXQWDYO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Tarski's classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Tarski $. $( The class of Tarski's classes. $)

  $( Extend class definition to include the class of all Tarski's classes. $)
  ctsk $a class Tarski $.

  ${
    $d y z w $.
    $( The class of all Tarski's classes.  Tarski's classes is a phrase coined
       by Grzegorz Bancerek in his article "Tarski's Classes and Ranks" Journal
       of Formalized Mathematics.  Vol 1 no 3 May-August 1990.  A Tarski's
       class is a set whose existence is ensured by Tarski's axiom A (see
       ~ ax-groth and the equivalent axioms).  Axiom A was first presented in
       Tarski's article:  "&Uuml;ber unerreichbare Kardinalzahlen".  Tarski had
       invented the axiom A to enable ZFC to manage inaccessible cardinals.
       Later Grothendieck invented the concept of Grothendieck's universes and
       showed they were equal to transitive Tarski's classes.  (Contributed by
       FL, 30-Dec-2010.) $)
    df-tsk $a |- Tarski = { y | ( A. z e. y ( ~P z C_ y
      /\ E. w e. y ~P z C_ w ) /\ A. z e. ~P y ( z ~~ y \/ z e. y ) ) } $.
  $}

  ${
    $d A x $.  $d T w x y z $.
    $( Properties of a Tarski's class.  (Contributed by FL, 30-Dec-2010.) $)
    eltskg $p |- ( T e. V -> ( T e. Tarski <-> ( A. z e. T ( ~P z C_ T
      /\ E. w e. T ~P z C_ w ) /\ A. z e. ~P T ( z ~~ T \/ z e. T ) ) ) ) $=
      ( vy cv cpw wss wrex wa wral cen wbr wcel ctsk wceq sseq2 rexeq anbi12d
      wo raleqbi1dv pweq breq2 eleq2 orbi12d raleqbidv df-tsk elab2g ) AFZGZEFZ
      HZUJBFHZBUKIZJZAUKKZUIUKLMZUIUKNZTZAUKGZKZJUJCHZUMBCIZJZACKZUICLMZUICNZTZ
      ACGZKZJECODUKCPZUPVEVAVJUOVDAUKCVKULVBUNVCUKCUJQUMBUKCRSUAVKUSVHAUTVIUKCU
      BVKUQVFURVGUKCUILUCUKCUIUDUEUFSEABUGUH $.

    $( Properties of a Tarski's class.  (Contributed by FL, 30-Dec-2010.)
       (Revised by Mario Carneiro, 20-Sep-2014.) $)
    eltsk2g $p |- ( T e. V -> ( T e. Tarski <-> ( A. z e. T ( ~P z C_ T
      /\ ~P z e. T ) /\ A. z e. ~P T ( z ~~ T \/ z e. T ) ) ) ) $=
      ( vw wcel ctsk cv cpw wss wrex wa wral cen wbr wo eltskg nfra1 weq r19.26
      wi pweq rspccva adantlr vex pwex elpw ssel syl5bir syl rexlimdva ralimdaa
      sseq1d 3imtr4i ssid sseq2 rspcev mpan2 anim2i ralimi impbii anbi1i syl6bb
      imdistani ) BCEBFEAGZHZBIZVEDGZIZDBJZKZABLZVDBMNVDBEZOABHLZKVFVEBEZKZABLZ
      VMKADBCPVKVPVMVKVPVFABLZVIABLZKVQVNABLZKVKVPVQVRVSVQVIVNABVFABQVQVLKZVHVN
      DBVTVGBEZKVGHZBIZVHVNTVQWAWCVLVFWCAVGBADRVEWBBVDVGUAULUBUCVHVEWBEWCVNVEVG
      VDAUDUEUFWBBVEUGUHUIUJUKVCVFVIABSVFVNABSUMVOVJABVNVIVFVNVEVEIZVIVEUNVHWDD
      VEBVGVEVEUOUPUQURUSUTVAVB $.

    $( 1st axiom of a Tarski's class.  The subsets of an element of a Tarski's
       class belong to the class.  (Contributed by FL, 30-Dec-2010.)  (Proof
       shortened by Mario Carneiro, 20-Sep-2014.) $)
    tskpwss $p |- ( ( T e. Tarski /\ A e. T ) -> ~P A C_ T ) $=
      ( vx vy ctsk wcel cv cpw wss wral wrex wa cen wbr eltskg ibi simpld simpl
      wo ralimi syl wceq pweq sseq1d rspccva sylan ) BEFZCGZHZBIZCBJZABFAHZBIZU
      GUJUIDGIDBKZLZCBJZUKUGUPUHBMNUHBFSCBHJZUGUPUQLCDBEOPQUOUJCBUJUNRTUAUJUMCA
      BUHAUBUIULBUHAUCUDUEUF $.

    $( 2nd axiom of a Tarski's class.  The powerset of an element of a Tarski's
       class belongs to the class.  (Contributed by FL, 30-Dec-2010.)  (Proof
       shortened by Mario Carneiro, 20-Sep-2014.) $)
    tskpw $p |- ( ( T e. Tarski /\ A e. T ) -> ~P A e. T ) $=
      ( vx ctsk wcel cv cpw wral wss wa cen wbr eltsk2g ibi simpld simpr ralimi
      wo syl wceq pweq eleq1d rspccva sylan ) BDEZCFZGZBEZCBHZABEAGZBEZUEUGBIZU
      HJZCBHZUIUEUNUFBKLUFBERCBGHZUEUNUOJCBDMNOUMUHCBULUHPQSUHUKCABUFATUGUJBUFA
      UAUBUCUD $.

    $( 3rd axiom of a Tarski's class.  A subset of a Tarski's class is either
       equipotent to the class or an element of the class.  (Contributed by FL,
       30-Dec-2010.)  (Revised by Mario Carneiro, 20-Sep-2014.) $)
    tsken $p |- ( ( T e. Tarski /\ A C_ T ) -> ( A ~~ T \/ A e. T ) ) $=
      ( vx vy ctsk wcel wss cpw cen wbr wo elpw2g biimpar cv wral wa eltskg ibi
      wrex simprd wceq breq1 eleq1 orbi12d rspccva sylan syldan ) BEFZABGZABHZF
      ZABIJZABFZKZUHUKUIABELMUHCNZBIJZUOBFZKZCUJOZUKUNUHUOHZBGUTDNGDBSPCBOZUSUH
      VAUSPCDBEQRTURUNCAUJUOAUAUPULUQUMUOABIUBUOABUCUDUEUFUG $.
  $}

  $( The empty set is a (transitive) Tarski's class.  (Contributed by FL,
     30-Dec-2010.) $)
  0tsk $p |- (/) e. Tarski $=
    ( vx c0 ctsk wcel cv cpw wss wa wral cen wbr wo ral0 wceq elsni enref breq1
    csn 0ex cvv mpbiri orcd syl pw0 eleq2s rgen wb eltsk2g ax-mp mpbir2an ) BCD
    ZAEZFZBGUMBDHZABIZULBJKZULBDZLZABFZIZUNAMURAUSURULBRZUSULVADULBNZURULBOVBUP
    UQVBUPBBJKBSPULBBJQUAUBUCUDUEUFBTDUKUOUTHUGSABTUHUIUJ $.

  $( An element of a Tarski's class is strictly dominated by the class.  JFM
     CLASSES2 th. 1 (Contributed by FL, 22-Feb-2011.)  (Revised by Mario
     Carneiro, 18-Jun-2013.) $)
  tsksdom $p |- ( ( T e. Tarski /\ A e. T ) -> A ~< T ) $=
    ( ctsk wcel wa cpw csdm wbr cdom canth2g adantl wss simpl tskpwss sdomdomtr
    ssdomg sylc syl2anc ) BCDZABDZEZAAFZGHZUBBIHZABGHTUCSABJKUASUBBLUDSTMABNUBB
    CPQAUBBOR $.

  $( A part of a Tarski's class strictly dominated by the class is an element
     of the class.  JFM CLASSES2 th. 2.  (Contributed by FL, 22-Feb-2011.)
     (Proof shortened by Mario Carneiro, 20-Sep-2014.) $)
  tskssel $p |- ( ( T e. Tarski /\ A C_ T /\ A ~< T ) -> A e. T ) $=
    ( ctsk wcel wss csdm wbr w3a cen wn sdomnen 3ad2ant3 tsken 3adant3 ord mpd
    wo ) BCDZABEZABFGZHZABIGZJZABDZTRUCSABKLUAUBUDRSUBUDQTABMNOP $.

  $( The subsets of an element of a Tarski's class belong to the class.
     (Contributed by FL, 30-Dec-2010.)  (Revised by Mario Carneiro,
     18-Jun-2013.) $)
  tskss $p |- ( ( T e. Tarski /\ A e. T /\ B C_ A ) -> B e. T ) $=
    ( ctsk wcel wss wa cpw wb elpw2g adantl tskpwss sseld sylbird 3impia ) CDEZ
    ACEZBAFZBCEZPQGZRBAHZEZSQUBRIPBACJKTUACBACLMNO $.

  $( The intersection of two elements of a Tarski's class belongs to the
     class.  (Contributed by FL, 30-Dec-2010.)  (Proof shortened by Mario
     Carneiro, 20-Sep-2014.) $)
  tskin $p |- ( ( T e. Tarski /\ A e. T ) -> ( A i^i B ) e. T ) $=
    ( ctsk wcel cin wss inss1 tskss mp3an3 ) CDEACEABFZAGKCEABHAKCIJ $.

  $( A singleton of an element of a Tarski's class belongs to the class.  JFM
     CLASSES2 th. 2 (partly) (Contributed by FL, 22-Feb-2011.)  (Revised by
     Mario Carneiro, 18-Jun-2013.) $)
  tsksn $p |- ( ( T e. Tarski /\ A e. T ) -> { A } e. T ) $=
    ( ctsk wcel cpw csn tskpw wss snsspw tskss mp3an3 syldan ) BCDZABDAEZBDZAFZ
    BDZABGMOPNHQAINPBJKL $.

  $( A transitive element of a Tarski's class is a part of the class.  JFM
     CLASSES2 th. 8 (Contributed by FL, 22-Feb-2011.)  (Revised by Mario
     Carneiro, 20-Sep-2014.) $)
  tsktrss $p |- ( ( T e. Tarski /\ Tr A /\ A e. T ) -> A C_ T ) $=
    ( ctsk wcel wtr w3a cpw wss simp2 dftr4 sylib tskpwss 3adant2 sstrd ) BCDZA
    EZABDZFZAAGZBRPASHOPQIAJKOQSBHPABLMN $.

  $( If an element of a Tarski's class is an ordinal number, its successor is
     an element of the class.  JFM CLASSES2 th. 6 (partly).  (Contributed by
     FL, 22-Feb-2011.)  (Proof shortened by Mario Carneiro, 20-Sep-2014.) $)
  tsksuc $p |- ( ( T e. Tarski /\ A e. On /\ A e. T ) -> suc A e. T ) $=
    ( ctsk wcel con0 w3a cpw csuc wss simp1 tskpw cuni word wceq eloni 3ad2ant2
    3adant2 ordunisuc eqimss 3syl sspwuni sylibr tskss syl3anc ) BCDZAEDZABDZFZ
    UEAGZBDZAHZUIIZUKBDUEUFUGJUEUGUJUFABKQUHUKLZAIZULUHAMZUMANUNUFUEUOUGAOPARUM
    ASTUKAUAUBUIUKBUCUD $.

  ${
    $d T x $.
    $( A non-empty Tarski's class contains the empty set.  (Contributed by FL,
       30-Dec-2010.)  (Revised by Mario Carneiro, 18-Jun-2013.) $)
    tsk0 $p |- ( ( T e. Tarski /\ T =/= (/) ) -> (/) e. T ) $=
      ( vx c0 wne ctsk wcel cv wex wi wss 0ss tskss mp3an3 expcom exlimiv sylbi
      n0 impcom ) ACDZAEFZCAFZSBGZAFZBHTUAIZBAQUCUDBTUCUATUCCUBJUAUBKUBCALMNOPR
      $.
  $}

  $( One is an element of a non-empty Tarski's class.  (Contributed by FL,
     22-Feb-2011.) $)
  tsk1 $p |- ( ( T e. Tarski /\ T =/= (/) ) -> 1o e. T ) $=
    ( ctsk wcel c0 wne wa c1o csn df1o2 tsk0 tsksn syldan syl5eqel ) ABCZADEZFG
    DHZAINODACPACAJDAKLM $.

  $( Two is an element of a non-empty Tarski's class.  (Contributed by FL,
     22-Feb-2011.)  (Proof shortened by Mario Carneiro, 20-Sep-2014.) $)
  tsk2 $p |- ( ( T e. Tarski /\ T =/= (/) ) -> 2o e. T ) $=
    ( ctsk wcel c0 wne c1o c2o tsk1 wa csuc df-2o con0 1on tsksuc mp3an2 syldan
    syl5eqel ) ABCZADEFACZGACAHRSIGFJZAKRFLCSTACMFANOQP $.

  $( If a Tarski's class is not empty, it has more than two elements.
     (Contributed by FL, 22-Feb-2011.) $)
  2domtsk $p |- ( ( T e. Tarski /\ T =/= (/) ) -> 2o ~< T ) $=
    ( ctsk wcel c0 wne c2o csdm wbr tsk2 tsksdom syldan ) ABCADEFACFAGHAIFAJK
    $.

  ${
    $d T x y $.
    $( A nonempty Tarski's class is infinite, because it contains all the
       finite levels of the cumulative hierarchy.  (This proof does not use
       ~ ax-inf .)  (Contributed by Mario Carneiro, 24-Jun-2013.) $)
    tskr1om $p |- ( ( T e. Tarski /\ T =/= (/) ) -> ( R1 " om ) C_ T ) $=
      ( vy vx ctsk wcel c0 wne wa cr1 com cima cv cfv wceq wrex wi fveq2 eleq1d
      con0 syl wfun wfn r1fnon fnfun ax-mp fvelima mpan csuc r10 syl5eqel tskpw
      tsk0 cpw nnon r1suc syl5ibr exp3a adantrd finds2 eleq1 syl5ibcom rexlimiv
      imbi2d com12 ssrdv ) ADEZAFGZHZBIJKZABLZVIEZVHVJAEZVKCLZIMZVJNZCJOZVHVLPZ
      IUAZVKVPISUBVRUCSIUDUECVJJIUFUGVOVQCJVMJEVHVNAEZPVOVQVSFIMZAEVJIMZAEZVJUH
      ZIMZAEZVHCBVMFNVNVTAVMFIQRVMVJNVNWAAVMVJIQRVMWCNVNWDAVMWCIQRVHVTFAUIAULUJ
      VJJEZVFWBWEPVGWFVFWBWEVFWBHWEWFWAUMZAEWAAUKWFWDWGAWFVJSEWDWGNVJUNVJUOTRUP
      UQURUSVOVSVLVHVNVJAUTVCVAVBTVDVE $.

    $( A nonempty Tarski's class contains the whole finite cumulative
       hierarchy.  (This proof does not use ~ ax-inf .)  (Contributed by NM,
       22-Feb-2011.) $)
    tskr1om2 $p |- ( ( T e. Tarski /\ T =/= (/) ) -> U. ( R1 " om ) C_ T ) $=
      ( vy vx ctsk wcel c0 wne wa cr1 com cima cuni cv wrex eluni2 wss wtr con0
      wi syld cfv wceq wfun wfn r1fnon fnfun ax-mp fvelima mpan r1tr treq mpbii
      rexlimivw trss 3syl adantl tskr1om sseld 3exp adantr imp rexlimdva syl5bi
      tskss ssrdv ) ADEZAFGZHZBIJKZLZABMZVJEVKCMZEZCVINVHVKAEZCVKVIOVHVMVNCVIVH
      VLVIEZHVMVKVLPZVNVOVMVPSZVHVOVKIUAZVLUBZBJNZVLQZVQIUCZVOVTIRUDWBUERIUFUGB
      VLJIUHUIVSWABJVSVRQWAVKUJVRVLUKULUMVLVKUNUOUPVHVOVPVNSZVHVOVLAEZWCVHVIAVL
      AUQURVFWDWCSVGVFWDVPVNVLVKAVDUSUTTVATVBVCVE $.
  $}

  $( A nonempty Tarski's class is infinite.  (Contributed by FL,
     22-Feb-2011.) $)
  tskinf $p |- ( ( T e. Tarski /\ T =/= (/) ) -> om ~<_ T ) $=
    ( ctsk wcel wne com cr1 cima cen wbr cdom con0 cvv wf1 wss r111 omsson omex
    c0 wa f1imaen mp2an ensymi simpl tskr1om ssdomg sylc endomtr sylancr ) ABCZ
    ARDZSZEFEGZHIULAJIZEAJIULEKLFMEKNULEHIOPKLEFQTUAUBUKUIULANUMUIUJUCAUDULABUE
    UFEULAUGUH $.

  $( If ` A ` and ` B ` are members of a Tarski's class, their unordered pair
     is also an element of the class.  JFM CLASSES2 th. 3 (partly).
     (Contributed by FL, 22-Feb-2011.)  (Proof shortened by Mario Carneiro,
     20-Jun-2013.) $)
  tskpr $p |- ( ( T e. Tarski /\ A e. T /\ B e. T )
    -> { A , B } e. T ) $=
    ( ctsk wcel w3a cpr wss csdm wbr simp1 prssi 3adant1 com cdom prfi isfinite
    wa cfn mpbi c0 ne0i tskinf sylan2 sdomdomtr sylancr 3adant3 tskssel syl3anc
    wne ) CDEZACEZBCEZFUKABGZCHZUNCIJZUNCEUKULUMKULUMUOUKABCLMUKULUPUMUKULRUNNI
    JZNCOJZUPUNSEUQABPUNQTULUKCUAUJURCAUBCUCUDUNNCUEUFUGUNCUHUI $.

  $( If ` A ` and ` B ` are members of a Tarski's class, their ordered pair is
     also an element of the class.  JFM CLASSES2 th. 4.  (Contributed by FL,
     22-Feb-2011.) $)
  tskop $p |- ( ( T e. Tarski /\ A e. T /\ B e. T )
    -> <. A , B >. e. T ) $=
    ( ctsk wcel w3a cop csn cpr dfopg 3adant1 simp1 tsksn 3adant3 tskpr syl3anc
    wceq eqeltrd ) CDEZACEZBCEZFZABGZAHZABIZIZCTUAUCUFQSABCCJKUBSUDCEZUECEUFCES
    TUALSTUGUAACMNABCOUDUECOPR $.

  ${
    $d A x y z $.  $d B x y z $.  $d T x y z $.
    $( A cross product of two parts of a Tarski's class is a part of the
       class.  (Contributed by FL, 22-Feb-2011.)  (Proof shortened by Mario
       Carneiro, 20-Jun-2013.) $)
    tskxpss $p |- ( ( T e. Tarski /\ A C_ T /\ B C_ T )
    -> ( A X. B ) C_ T ) $=
      ( vz vx vy ctsk wcel wss cxp wa cv cop wceq wrex elxp2 w3a tskop eleq1a
      wi syl 3expib rexlimdvv syl5bi ssrdv xpss12 sstr expcom syl2im 3impib ) C
      GHZACIZBCIZABJZCIZUKCCJZCIZULUMKUNUPIZUOUKDUPCDLZUPHUSELZFLZMZNZFCOECOUKU
      SCHZEFUSCCPUKVCVDEFCCUKUTCHZVACHZVCVDTZUKVEVFQVBCHVGUTVACRVBCUSSUAUBUCUDU
      EACBCUFURUQUOUNUPCUGUHUIUJ $.
  $}

  ${
    $d T x y $.
    $( A Tarski's class is well-orderable.  (Contributed by Mario Carneiro,
       20-Jun-2013.) $)
    tskwe2 $p |- ( T e. Tarski -> T e. dom card ) $=
      ( vy ctsk wcel cv csdm wbr cpw crab wss ccrd wral elpwi tskssel 3exp syl5
      cdm wi ralrimiv rabss sylibr tskwe mpdan ) ACDZBEZAFGZBAHZIAJZAKQDUDUFUEA
      DZRZBUGLUHUDUJBUGUEUGDUEAJZUDUJUEAMUDUKUFUIUEANOPSUFBUGATUABACUBUC $.
  $}

  ${
    $d A t z $.
    $( The intersection of a collection of Tarski's classes is a Tarski's
       class.  (Contributed by FL, 17-Apr-2011.)  (Proof shortened by Mario
       Carneiro, 20-Sep-2014.) $)
    inttsk $p |- ( ( A C_ Tarski /\ A =/= (/) ) -> |^| A e. Tarski ) $=
      ( vz vt ctsk wss wa wcel cv cpw wral cen wbr syl2anc ralrimiva sylibr vex
      wo wn cdom cvv c0 wne cint simpll sselda elinti imp adantll tskpwss ssint
      tskpw pwex elint2 jca elpwi wrex rexnal simpr intex sylib ad2antrr simplr
      ssdomg intss1 ad2antrl mpsyl simprr simplll simprl sseldd sstrd tsken ord
      sylc mt3d ensymd domentr sbth rexlimdvaa syl5bir con1d syl6ibr wb eltsk2g
      orrd sylan2 syl mpbir2and ) ADEZAUAUBZFZAUCZDGZBHZIZWLEZWOWLGZFZBWLJZWNWL
      KLZWNWLGZQZBWLIZJZWKWRBWLWKXAFZWPWQXEWOCHZEZCAJWPXEXGCAXEXFAGZFZXFDGZWNXF
      GZXGXEADXFWIWJXAUDUEZXAXHXKWKXAXHXKWNAXFUFUGUHZWNXFUIMNCWOAUJOXEWOXFGZCAJ
      WQXEXNCAXIXJXKXNXLXMWNXFUKMNCWOAWNBPZULUMOUNNWKXBBXCWNXCGWKWNWLEZXBWNWLUO
      WKXPFZWTXAXQWTRXKCAJZXAXQXRWTXRRXKRZCAUPXQWTXKCAUQXQXSWTCAXQXHXSFZFZWNWLS
      LZWLWNSLZWTYAWLTGZXPYBWKYDXPXTWKWJYDWIWJURAUSUTZVAWKXPXTVBZWNWLTVCVNYAWLX
      FSLZXFWNKLYCXFTGYAWLXFEZYGCPXHYHXQXSXFAVDVEZWLXFTVCVFYAWNXFYAWNXFKLZXKXQX
      HXSVGYAYJXKYAXJWNXFEYJXKQYAADXFWIWJXPXTVHXQXHXSVIVJYAWNWLXFYFYIVKWNXFVLMV
      MVOVPWLXFWNVQMWNWLVRMVSVTWACWNAXOUMWBWEWFNWKYDWMWSXDFWCYEBWLTWDWGWH $.
  $}

  ${
    $d A w x y z $.
    $( ` ( R1 `` A ) ` for ` A ` a strongly inaccessible cardinal is equipotent
       to ` A ` .  (Contributed by Mario Carneiro, 6-Jun-2013.) $)
    inar1 $p |- ( A e. Inacc -> ( R1 ` A ) ~~ A ) $=
      ( vx vy vz wcel cr1 cfv cdom wbr con0 wceq syl syl2anc wral wa csdm wi c0
      cvv wss vw cina cen cxp cv ciun cwina inawina winaon winalim r1lim onelon
      wlim sylan csuc eleq1 fveq2 breq1d imbi12d weq ne0i 0sdomg syl5ibr breq1i
      wne r10 syl6ibr 3syl wtr word eloni ordtr trsuc ex adantl ccrd r1suc fvex
      cpw cardid ensymi pwen ax-mp syl6eqbr wb winacard eleq2d cardsdom sylancr
      bitr3d ccf elina simp3bi pweq rspccv sylbird ensdomtr syl2an expr imim12d
      imp cun vex mpan nfcv nfiu1 nfbr iunex ssiun2 mpsyl endomtr vtoclgaf rgen
      ssdomg iundom mp2an mp2 domtr com domentr eqbrtrd ad2antlr wn wf wrex wfn
      sylibr eleq1d ralimdva impr sseq2d syl5bi ad2antrl sylibd wo iunonOLD a1i
      mprg onelss mpd ssun2 xpdom2 xpdom1 limomss syl6ss infxpidm eleq1a ordirr
      unex ssun1 nsyli ad2ant2r simpll ccom cres limord elon cardf r1fnon dffn2
      wex mpbi fco fssres ffn simpr simplll ontr1 syl12anc biimpd embantd fvres
      onss fvco3 eqtrd sylibrd ffnfv sylanbrc eleq2 biimpa eliun cardon onelssi
      reximdva syl5 expdimp ralrimiv wfun resfunexg fveq1 rexbidv ralbidv spcev
      ffun feq1 anbi12d ee12an cfflb syld simp2bi sseq1d ontri1 ordequn sylancl
      mt2d eqcom mtord sylc sylsyld iunss unssd cif iuneq1 uneq12d 0elon elimel
      id elexi onun2i dedth adantr onsseleq orcomd ord iscard simprbi domsdomtr
      mpbid breq1 exp43 com4l tfinds2 imp3a mpcom sdomdom ralrimiva winainf cdm
      infxpen fdmi syl6eleqr onssr1 sbth ) AUBEZAFGZAHIZAVUEHIZVUEAUCIVUDVUEAAU
      DZHIVUHAUCIZVUFVUDVUEBABUEZFGZUFZVUHHVUDAJEZAUMZVUEVULKVUDAUGEZVUMAUHZAUI
      ZLZVUDVUOVUNVUPAUJLBAJUKMVUDVUMVUKAHIZBANVULVUHHIVURVUDVUSBAVUDVUJAEZOZVU
      KAPIZVUSVUJJEZVVAVVBVUDVUMVUTVVCVURAVUJULUNVVCVUDVUTVVBVUTVVBQRAEZRFGZAPI
      ZQZCUEZAEZVVHFGZAPIZQZVVHUOZAEZVVMFGZAPIZQZVUDBCVUJRKZVUTVVDVVBVVFVUJRAUP
      VVRVUKVVEAPVUJRFUQURUSBCUTZVUTVVIVVBVVKVUJVVHAUPVVSVUKVVJAPVUJVVHFUQURUSV
      UJVVMKZVUTVVNVVBVVPVUJVVMAUPVVTVUKVVOAPVUJVVMFUQURUSVUDVUOVUMVVGVUPVUQVUM
      VVDRAPIZVVFVVDVWAVUMARVEZARVAAJVBVCVVERAPVFVDVGVHVVHJEZVUDVVLVVQQVWCVUDOV
      VNVVIVVKVVPVUDVVNVVIQZVWCVUDVUMAVIZVWDVURVUMAVJZVWEAVKZAVLLVWEVVNVVIAVVHV
      MVNVHVOVWCVUDVVKVVPVWCVVOVVJVPGZVSZUCIVWIAPIZVVPVUDVVKOVWCVVOVVJVSZVWIUCV
      VHVQVVJVWHUCIZVWKVWIUCIVWHVVJVVJVVHFVRZVTWAZVVJVWHWBWCWDVUDVVKVWJVUDVVKVW
      HAEZVWJVUDVUOVWOVVKWEVUPVUOVWHAVPGZEZVWOVVKVUOVWPAVWHAWFZWGVUOVVJSEZVUMVW
      QVVKWEZVWMVUQVVJASJWHZWIWJLVUDDUEZVSZAPIZDANZVWOVWJQVUDVWBAWKGZAKZVXEDAWL
      ZWMVXDVWJDVWHAVXBVWHKVXCVWIAPVXBVWHWNURWOLWPXAVVOVWIAWQWRWSWTVNVUTVUJUMZV
      UDVVLCVUJNZVVBVUTVXIVUDVXJVVBVUTVXIOZVUDVXJOZOZVUKVUJCVUJVWHUFZXBZHIZVXOA
      PIZVVBVXIVXPVUTVXLVXIVUKDVUJVXBFGZUFZVXOHVUJSEZVXIVUKVXSKBXCZDVUJSUKXDVXI
      VXSVUJVXNUDZHIZVYBVXOHIZVXSVXOHIVXTVXRVXNHIZDVUJNVYCVYAVYEDVUJVVJVXNHIZVY
      ECVXBVUJCVXBXECVXRVXNHCVXRXECHXECVUJVWHXFXGCDUTVVJVXRVXNHVVHVXBFUQURVVHVU
      JEZVWLVWHVXNHIZVYFVWNVXNSEVYGVWHVXNTVYHCVUJVWHVYAVVJVPVRZXHZCVUJVWHXIVWHV
      XNSXNXJVVJVWHVXNXKWIXLXMDVUJVXNVXRSXOXPVXIVYBVXOVXOUDZHIZVYKVXOUCIZVYDVYB
      VUJVXOUDZHIZVYNVYKHIZVYLVXNVXOHIZVYOVXOSEZVXNVXOTVYQVUJVXNVYAVYJUUIZVXNVU
      JUUAVXNVXOSXNXQVXNVXOVUJVYAUUBWCVUJVXOHIZVYPVYRVUJVXOTVYTVYSVUJVXNUUJZVUJ
      VXOSXNXQVUJVXOVXOVYSUUCWCVYBVYNVYKXRXPVXIXSVXOHIZVYMVYRVXIXSVXOTWUBVYSVXI
      XSVUJVXOVUJUUDWUAUUEXSVXOSXNXJVXOUUFLVYBVYKVXOXTWIVXSVYBVXOXRWIYAYBVXMVXO
      AEZVXQVXMVXOAKZYCWUCVXMWUDAVUJKZAVXNKZVUTVUDWUEYCZVXIVXJVUTVUDWUGVUTWUEAA
      EZVUDVUJAAUUGVUDVUMVWFWUHYCVURVWGAUUHVHUUKXAUULVXMWUFVUTVUTVXIVXLUUMZVXMW
      UFAVUJTZVUTYCZVXMWUFVXFVUJTZWUJVXMWUFVUJAUAUEZYDZVXBVVHWUMGZTZCVUJYEZDANZ
      OZUAUVAZWULVXMVUJAVPFUUNZVUJUUOZYDZWUFVXBVVHWVBGZTZCVUJYEZDANZWUTVXMWVBVU
      JYFZWVDAEZCVUJNZWVCVXMVVCVUJJWVBYDZWVHVXIVVCVUTVXLVXIVUJVJZVVCVUJUUPVUJVY
      AUUQYGZYBZVVCJJWVAYDZVUJJTWVKSJVPYDJSFYDZWVOUURFJYFWVPUUSJFUUTUVBZJSJVPFU
      VCXPZVUJUVMJJVUJWVAUVDWIVUJJWVBUVEVHVXKVUDVXJWVJVXKVUDOZVVLWVICVUJWVSVYGO
      ZVVLVWOWVIWVTVVIVVKVWOWVTVUMVYGVUTVVIVUDVUMVXKVYGVURYBZWVSVYGUVFVUTVXIVUD
      VYGUVGVUMVYGVUTOVVIVVHVUJAUVHXAUVIWVTVVKVWOWVTVWQVVKVWOWVTVWSVUMVWTVWMWWA
      VXAWIWVTVWPAVWHVUDVWPAKZVXKVYGVUDVUOWWBVUPVWRLZYBWGWJUVJUVKZWVTWVDVWHAWVS
      VVCVYGWVDVWHKVXIVVCVUTVUDWVMYBVVCVYGOZWVDVVHWVAGZVWHVYGWVDWWFKVVCVVHVUJWV
      AUVLVOWWEWVPVWCWWFVWHKWVQVUJVVHULJSVVHVPFUVNWIUVOZUNYHUVPYIYJCVUJAWVBUVQU
      VRVXMVVCWUFWVGQWVNVVCWUFWVGVVCWUFOWVFDAVVCWUFVXBAEZWVFWUFWWHOVXBVXNEZVVCW
      VFWUFWWHWWIAVXNVXBUVSUVTWWIVXBVWHEZCVUJYEVVCWVFCVXBVUJVWHUWAVVCWWJWVECVUJ
      WWJWVEWWEVXBVWHTVWHVXBVVJUWBZUWCWWEWVDVWHVXBWWGYKVCUWDYLUWEUWFUWGVNLWUSWV
      CWVGOUAWVBWVAUWHZVXTWVBSEWVOWWLWVRJJWVAUWNWCVYAWVAVUJSUWIXPWUMWVBKZWUNWVC
      WURWVGVUJAWUMWVBUWOWWMWUQWVFDAWWMWUPWVECVUJWWMWUOWVDVXBVVHWUMWVBUWJYKUWKU
      WLUWPUWMUWQVXMVUMVVCWUTWULQVUDVUMVXKVXJVURYMZWVNDCAVUJUAUWRMUWSVUDWULWUJW
      EVXKVXJVUDVXFAVUJVUDVWBVXGVXEVXHUWTUXAYMYNVXMVUMVVCWUJWUKWEWWNWVNAVUJUXBM
      YNUXEVXMVVCVXNJEZWUDWUEWUFYOZQWVNVWHJEZWWOCVUJCVUJVWHVYAVYIYPWWQVYGWWKYQY
      RWUDAVXOKZVVCWWOOWWPVXOAUXFVVCWVLVXNVJWWRWWPQWWOVUJVKVXNVKAVUJVXNUXCWRYLU
      XDUXGVXMWUDWUCVXMWUCWUDVXMVXOATZWUCWUDYOZVXMVUJVXNAVXMVUMVUTVUJATWWNWUIAV
      UJYSUXHVXMVWHATZCVUJNZVXNATVXKVUDVXJWXBWVSVVLWXACVUJWVTVUMVVLVWOWXAWWAWWD
      AVWHYSUXIYIYJCVUJVWHAUXJYGUXKVXKVXOJEZVUMWWSWWTWEVXLVXIWXCVUTVXIVVCWXCWVM
      VVCWXCVVCVUJRUXLZCWXDVWHUFZXBZJEVUJRVUJWXDKZVXOWXFJWXGVUJWXDVXNWXEWXGUXQC
      VUJWXDVWHUXMUXNYHWXDWXEVUJRJUXOUXPZWWQWXEJECWXDCWXDVWHWXDJWXHUXRVYIYPWWQV
      VHWXDEWWKYQYRUXSUXTLVOVUDVUMVXJVURUYAVXOAUYBWRUYHUYCUYDYTVXMWWBVXBAPIZDAN
      ZWUCVXQQVUDWWBVXKVXJWWCYMWWBVUMWXJDAUYEUYFWXIVXQDVXOAVXBVXOAPUYIWOVHYTVUK
      VXOAUYGMUYJUYKUYLUYMUYNVUKAUYOLUYPBAAVUKJXOMYAVUDVUMXSATZVUIVURVUDVUOWXKV
      UPAUYQLAUYSMVUEVUHAXTMVUESEVUDAVUETZVUGAFVRVUDVUOAFUYRZEWXLVUPVUOAJWXMVUQ
      JSFWVQUYTVUAAVUBVHAVUESXNXJVUEAVUCM $.
  $}

  ${
    $( The set of hereditarily finite sets is countable.  This is a short proof
       as a consequence of ~ inar1 , which requires AC. See ~ r1om for a direct
       proof not requiring AC. (Contributed by Mario Carneiro, 27-May-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    r1omALT $p |- ( R1 ` om ) ~~ om $=
      ( com cina wcel cr1 cfv cen wbr omina inar1 ax-mp ) ABCADEAFGHAIJ $.
  $}

  ${
    $d A w x y z $.
    $( Any set must be at least as large as the cofinality of its rank, because
       the ranks of the elements of ` A ` form a cofinal map into
       ` ( rank `` A ) ` .  (Contributed by Mario Carneiro, 27-May-2013.) $)
    rankcf $p |- -. A ~< ( cf ` ( rank ` A ) ) $=
      ( vx vy vw vz crnk cfv c0 wceq con0 wrex wcel ccf csdm wbr fveq2 cdom c1o
      wa syl cv csuc cvv wlim w3o wn rankon onzsl mpbi cf0 syl6eq breq2d mtbiri
      sdom0 cfsuc sylan9eqr wne nsuceq0 neeq1 mpbiri cr1 cdm 0elon r1fnon ax-mp
      wfn fndm eleqtrri rankonid necon3i cima rankvaln necon1ai breq2 0sdom1dom
      cuni vex 0sdom bitr3i vtoclbg mpbird adantl eqbrtrd rexlimiva domnsym csn
      wb cab wss nlim0 limeq con4i r1elssi sselda ranksnb rankelb limsuc sylibd
      wi imp eqeltrd eleq1a rexlimdva abssdv ciun snex dfiun2 iunid eqtr3i snwf
      fveq2i abrexexg eleq1 sseq1 r1elss rankuni2b syl5eqr abrexco unieqi eqtri
      3syl fvex syl6req cfslb mpd3an23 fveq2d breq12 mpdan rexeq abbidv mpancom
      imbi12d cmpt crn eqid rnmpt ccrd wfo cfon sdomdom ondomen fnmpti fodomnum
      sylancr dffn4 ee10 syl5eqbrr vtoclg domtr ee12an pm2.01d 3jaoi ) AFGZHIZU
      UMBUAZUBZIZBJKZUUMUCLZUUMUDZSZUEZAUUMMGZNOZUFZUUMJLUVBAUGBUUMUHUIUUNUVEUU
      RUVAUUNUVDAHNOAUNUUNUVCHANUUNUVCHMGHUUMHMPUJUKULUMUURUVCAQOZUVEUUQUVFBJUU
      OJLZUUQSUVCRAQUUQUVGUVCUUPMGRUUMUUPMPUUOUOUPUUQRAQOZUVGUUQUUMHUQZUVHUUQUV
      IUUPHUQUUOURUUMUUPHUSUTUVIUVHAHUQZAHUUMHAHIUUMHFGZHAHFPHVAVBZLUVKHIHJUVLV
      CVAJVFUVLJIVDJVAVGVEVHHVIUIUKVJUVIAVAJVKVPZLZUVHUVJWGUVNUUMHAVLZVMRCUAZQO
      ZUVPHUQZUVHUVJCAUVMUVPARQVNUVPAHUSUVQHUVPNOUVRUVPVOUVPCVQVRVSVTTWATWBWCWD
      UVCAWEZTUUTUVEUUSUUTUVDUUTUVCDUAZUUOWFZFGZIZBAKZDWHZQOZUVDUWEAQOZUVEUUTUW
      EUUMWIUWEVPZUUMIZUWFUUTUWDDUUMUUTUWCUVTUUMLZBAUUTUUOALZSZUWBUUMLUWCUWJWSU
      WLUWBUUOFGZUBZUUMUWLUUOUVMLZUWBUWNIUUTAUVMUUOUUTUVNAUVMWIUVNUUTUVNUFUUNUU
      TUFUVOUUNUUTHUDWJUUMHWKUMTWLZAWMZTWNUUOWOTUUTUWKUWNUUMLZUUTUWKUWMUUMLZUWR
      UUTUVNUWKUWSWSUWPUUOAWPTUUMUWMWQWRWTXAUWBUUMUVTXBTXCXDUUTUVNUWIUWPUVNUUME
      UVPUWAIZBAKZCWHZEUAZFGZXEZUWHUVNUUMUXBVPZFGZUXEUXFAFBAUWAXEUXFABCAUWAUUOX
      FZXGBAXHXIXKUVNUXBUVMLZUXGUXEIUVNUXIUXBUVMWIZUVNUXACUVMUVNUWTUVPUVMLZBAUV
      NUWKSUWOUWAUVMLUWTUXKWSUVNAUVMUUOUWQWNUUOXJUWAUVMUVPXBYAXCXDUVNUXBUCLUXIU
      XJWGBCAUWAUVMXLUXCUVMLUXCUVMWIUXIUXJEUXBUCUXCUXBUVMXMUXCUXBUVMXNUXCEVQXOV
      TTWAEUXBXPTXQUXEUVTUXDIEUXBKDWHZVPUWHEDUXBUXDUXCFYBXGUXLUWEDECBAUWAUXDUWB
      UXHUXCUWAFPXRXSXTYCTUUMUWEAFYBYDYEUUTUVNUVDUWGWSZUWPUVPUVPFGZMGZNOZUWCBUV
      PKZDWHZUVPQOZWSUXMCAUVMUVPAIZUXPUVDUXSUWGUXTUXOUVCIUXPUVDWGUXTUXNUUMMUVPA
      FPYFUVPAUXOUVCNYGYHUXRUWEIUXTUXSUWGWGUXTUXQUWDDUWCBUVPAYIYJUXRUWEUVPAQYGY
      KYLUXPUXRBUVPUWBYMZYNZUVPQBDUVPUWBUYAUYAYOZYPUXPUVPYQVBLZUVPUYBUYAYRZUYBU
      VPQOUXPUXOJLUVPUXOQOUYDUXNYSUVPUXOYTUXOUVPUUAUUDUYAUVPVFUYEBUVPUWBUYAUWAF
      YBUYCUUBUVPUYAUUEUIUVPUYBUYAUUCUUFUUGUUHTUWFUWGSUVFUVEUVCUWEAUUIUVSTUUJUU
      KWBUULVE $.
  $}

  ${
    $d A w x y z $.
    $( ` ( R1 `` A ) ` for ` A ` a strongly inaccessible cardinal is a Tarski's
       class.  (Contributed by Mario Carneiro, 8-Jun-2013.) $)
    inatsk $p |- ( A e. Inacc -> ( R1 ` A ) e. Tarski ) $=
      ( vx vy wcel cr1 cfv wss wa wral wbr wo con0 wceq syl sylbid imp csdm cvv
      wi wb cina cpw cen ctsk cwina inawina wrex ciun wlim winaon winalim r1lim
      cv syl2anc eleq2d eliun syl6bb csuc onelon sylan r1pw limsuc r1ord2 sseld
      rexlimdva cuni elssuni r1tr2 syl6ss ralrimiva crnk r1suc rankr1ai syl6bir
      jca fvex elsuc sylib orcomd cdom wn elpwi ad2antlr ssdomg mpsyl ccf fveq2
      rankcf c0 wne elina simp2bi sylan9eqr breq2d mtbii sdomentr expcom adantr
      inar1 mtod adantlr bren2 sylanbrc ex cima cdm r1elwf wfn r1fnon syl6eleqr
      fndm ax-mp rankr1ag biimprd orim12d mpd eltsk2g ) AUADZBUMZUBZAEFZGZXTYAD
      ZHZBYAIZXSYAUCJZXSYADZKZBYAUBZIZYAUDDZXRYDBYAXRYGHZYBYCYLYCYBXRYGYCXRAUED
      ZYGYCSAUFZYMYGXSCUMZEFZDZCAUGZYCYMYGXSCAYPUHZDYRYMYAYSXSYMALDZAUIZYAYSMAU
      JZAUKZCALULUNUOCXSAYPUPUQYMYQYCCAYMYOADZHZYQXTYOURZEFZDZYCUUEYOLDZYQUUHTY
      MYTUUDUUIUUBAYOUSUTXSYOVANUUEUUGYAXTYMUUDUUGYAGZYMUUDUUFADZUUJYMUUAUUDUUK
      TUUCAYOVBNYMYTUUKUUJSUUBUUFAVCNOPVDOVEONPZYCXTYAVFYAXTYAVGAVHVINUULVOVJXR
      YHBYIXRXSYIDZHZXSVKFZAMZUUOADZKYHUUNUUQUUPUUNUUOAURZDZUUQUUPKXRUUMUUSXRUU
      MXSUUREFZDZUUSXRYTUVAUUMTXRYMYTYNUUBNZYTUUTYIXSAVLUONZXSUURVMVNPUUOAXSVKV
      PVQVRVSUUNUUPYFUUQYGUUNUUPYFUUNUUPHZXSYAVTJZXSYAQJZWAZYFYARDZUVDXSYAGZUVE
      AEVPZUUMUVIXRUUPXSYAWBWCXSYARWDWEXRUUPUVGUUMXRUUPHZUVFXSAQJZUVKXSUUOWFFZQ
      JUVLXSWHUVKUVMAXSQUUPXRUVMAWFFZAUUOAWFWGXRAWIWJUVNAMXTAQJBAIBAWKWLWMWNWOX
      RUVFUVLSZUUPXRYAAUCJZUVOAWSUVFUVPUVLXSYAAWPWQNWRWTXAXSYAXBXCXDUUNYGUUQUUN
      XSELXEVFDZAEXFZDZYGUUQTXRUUMUVQXRUUMUVAUVQUVCXSUURXGVNPXRUVSUUMXRALUVRUVB
      ELXHUVRLMXILEXKXLXJWRXSAXMUNXNXOXPVJUVHYKYEYJHTUVJBYARXQXLXC $.
  $}

  $( The set of hereditarily finite sets is a Tarski's class.  (The
     Tarski-Grothendieck Axiom is not needed for this theorem.)  (Contributed
     by Mario Carneiro, 28-May-2013.) $)
  r1omtsk $p |- ( R1 ` om ) e. Tarski $=
    ( com cina wcel cr1 cfv ctsk omina inatsk ax-mp ) ABCADEFCGAHI $.

  ${
    $d T x y $.  $d A x $.
    $( A Tarski's class contains all ordinals smaller than it.  (Contributed by
       Mario Carneiro, 8-Jun-2013.) $)
    tskord $p |- ( ( T e. Tarski /\ A e. On /\ A ~< T ) -> A e. T ) $=
      ( vx vy con0 wcel csdm wbr cv wa wceq breq1 anbi2d eleq1 imbi12d wral wss
      wi syld imp ctsk simplrl onelss ssdomg adantlr simplrr domsdomtr ralimdva
      cdom syl2anc pm2.27 dfss3 tskssel 3exp syl5bir com23 adantl 3impib 3com12
      ex tfis3 ) AEFZBUAFZABGHZABFZVBVCVDVEVCCIZBGHZJZVFBFZRVCDIZBGHZJZVJBFZRZV
      CVDJZVERCDAVFVJKZVHVLVIVMVPVGVKVCVFVJBGLMVFVJBNOVFAKZVHVOVIVEVQVGVDVCVFAB
      GLMVFABNOVFEFZVHVNDVFPZVIVRVHVSVIRVRVHJZVSVMDVFPZVIVTVNVMDVFVTVJVFFZJZVCV
      KVNVMRVRVCVGWBUBWCVJVFUIHZVGVKVRWBWDVHVRWBWDVRWBVJVFQWDVFVJUCVJVFEUDSTUEV
      RVCVGWBUFVJVFBUGUJVLVMUKUJUHVHWAVIRZVRVCVGWEVCWAVGVIWAVFBQZVCVGVIRDVFBULV
      CWFVGVIVFBUMUNUOUPTUQSUTUPVAURUS $.
  $}

  ${
    $d T w x y z $.
    $( An even more direct relationship than ~ r1tskina to get an inacessible
       cardinal out of a Tarski's class: the size of any nonempty Tarski's
       class is an inaccessible cardinal.  (Contributed by Mario Carneiro,
       9-Jun-2013.) $)
    tskcard $p |- ( ( T e. Tarski /\ T =/= (/) ) -> ( card ` T ) e. Inacc ) $=
      ( vx vz vy ctsk wcel c0 wa ccrd cfv ccf wceq cv csdm wbr cmap cdom adantr
      wss syl2anc vw wne cpw wral cina cardeq0 necon3bid biimpar cale con0 crab
      wn co cint char cmpt eqid pwcfsdom com vex pwex canth2 simpl cardon oneli
      cen adantl cardsdomelir tskord syl3anc tskpwss syldan ssdomg sylc cardidg
      tskpw ensymd domentr sdomdomtr sylancr ralrimiva wrex wi inawinalem ax-mp
      winainflem mp3an2 sylan2 cardidm cardaleph sylancl fveq2d oveq12d breq12d
      mpbiri w3a simp1 simp3 cxp wf fvex elmap fssxp sylbi ssrdv cfle sstr mpan
      ex tskxpss 3exp com23 mpd sstr2 syl2im simp2 wfn cvv ffn fndmeng ensdomtr
      mpdi syl2an tskssel 3expia imp domnsym syl mt2d wo cfon onsseli ori elina
      mpbi syl3anbrc ) AEFZAGUBZHZAIJZGUBZYTKJZYTLZBMZUCZYTNOZBYTUDZYTUEFYQUUAY
      RYQYTGAGAEUFUGUHZYSUUBYTFZULUUCYSUUIYTYTUUBPUMZNOZYSUUKYTUUDUIJSBUJUKUNZU
      IJZUUMUUMKJZPUMZNOCUULUACUUNCMUAMJUOJUPZUUPUQURYSYTUUMUUJUUONYSUSYTSZYTIJ
      YTLYTUUMLYSUUAUUGUUQUUHYQUUGYRYQUUFBYTYQUUDYTFZHZUUEUUEUCZNOUUTYTQOZUUFUU
      EUUDBUTVAVBUUSUUTAQOZAYTVFOZUVAUUSYQUUTASZUVBYQUURVCZYQUURUUDAFZUVDUUSYQU
      UDUJFZUUDANOZUVFUVEUURUVGYQYTUUDAVDZVEVGUURUVHYQUUDAVHVGUUDAVIVJZYQUVFUUE
      AFUVDUUDAVPUUEAVKVLVLUUTAEVMVNYQUVCUURYQYTAAEVOVQZRUUTAYTVRTUUEUUTYTVSVTW
      ARZUUGUUAUUDDMNODYTWBBYTUDZUUQYTUJFZUUGUVMWCUVIBDYTWDWEUUAUVNUVMUUQUVIBDY
      TWFWGWHTAWIBYTWJWKZYSYTUUMUUBUUNPUVOYSYTUUMKUVOWLWMWNWOYQUUIUUKULZWCYRYQU
      UIUVPYQUUIHZUUJYTQOZUVPUVQUUJAQOZUVCUVRYQUUIUUJASZUVSUVQBUUJAYQUUIUUDUUJF
      ZUVFYQUUIUWAWPZYQUUDASZUVHUVFYQUUIUWAWQZUWBUWAYQUWCYQUUIUWAWRZUWDUWAUUDUU
      BYTWSZSZYQUWFASZUWCUWAUUBYTUUDWTZUWGYTUUBUUDAIXAYTKXAZXBZUUBYTUUDXCXDYQYT
      ASZUWHYQBYTAYQUURUVFUVJXIXEYQUWLUUBASZUWHUUBYTSZUWLUWMYTXFZUUBYTAXGXHYQUW
      MUWLUWHYQUWMUWLUWHUUBYTAXJXKXLYBXMUUDUWFAXNXOVNUWBUWAUUIUVHUWEYQUUIUWAXPU
      WAUUDUUBVFOUUBANOUVHUUIUWAUUBUUDUWAUWIUUBUUDVFOZUWKUWIUUDUUBXQUUBXRFUWPUU
      BYTUUDXSUWJUUBXRUUDXTWKXDVQUUBAVHUUDUUBAYAYCTUUDAYDVJYEXEYQUVTUVSUUJAEVMY
      FVLYQUVCUUIUVKRUUJAYTVRTUUJYTYGYHXIRYIUUIUUCUWNUUIUUCYJUWOUUBYTYTYKUVIYLY
      OYMYHUVLBYTYNYP $.
  $}

  ${
    $d A x $.
    $( There is a direct relationship between transitive Tarski's classes and
       inacessible cardinals: the Tarski's classes that occur in the cumulative
       hierarchy are exactly at the strongly inaccessible cardinals.
       (Contributed by Mario Carneiro, 8-Jun-2013.) $)
    r1tskina $p |- ( A e. On ->
        ( ( R1 ` A ) e. Tarski <-> ( A = (/) \/ A e. Inacc ) ) ) $=
      ( vx con0 wcel cr1 cfv ctsk c0 wceq cina wo wa wn wne ccrd cen wbr simplr
      syl2anc csdm df-ne simpll crnk csuc cima cuni onwf sseli eqid rankr1c syl
      mpbii simpld cdm wfn r1fnon fndm ax-mp eleq2i rankonid bitr3i fveq2 sylbi
      neleqtrd adantl wss onssr1 sylbir tsken sylan2 ord mt3d carden2b cv simpl
      wral adantr sselda tsksdom ensymd sdomentr iscard sylanbrc eqtr3d on0eln0
      ralrimiva r10 biimpar r1sdom syldan syl5eqbrr 0sdom sylib adantlr tskcard
      fvex eqeltrrd ex syl5bir orrd syl6eq 0tsk syl6eqel inatsk jaoi impbid1 )
      ACDZAEFZGDZAHIZAJDZKZXGXIXLXGXILZXJXKXJMAHNZXMXKAHUAXMXNXKXMXNLZXHOFZAJXO
      AOFZXPAXOAXHPQZXQXPIXOXIXGXRXGXIXNRZXGXIXNUBXIXGLZXRAXHDZXGYAMXIXGAUCFZEF
      ZXHAXGAYCDMZAYBUDEFDZXGAECUEUFZDZYDYELZCYFAUGUHYGYBYBIYHYBUIAYBUJULUKUMXG
      YBAIZYCXHIXGAEUNZDZYIYJCAECUOYJCIUPCEUQURUSZAUTVAYBAEVBVCVDVEXTXRYAXGXIAX
      HVFZXRYAKXGYKYMYLAVGVHZAXHVIVJVKVLZSAXHVMUKXMXQAIZXNXMXGBVNZATQZBAVPYPXGX
      IVOXMYRBAXMYQADZLZYQXHTQZXHAPQZYRYTXIYQXHDUUAXGXIYSRZXMAXHYQXGYMXIYNVQVRY
      QXHVSSYTXIXGUUBUUCXGXIYSUBXTAXHYOVTSYQXHAWASWFBAWBWCVQWDXOXIXHHNZXPJDXSXG
      XNUUDXIXGXNLZHXHTQUUDUUEHHEFZXHTWGXGXNHADZUUFXHTQXGUUGXNAWEWHAHWIWJWKXHAE
      WPWLWMWNXHWOSWQWRWSWTWRXJXIXKXJXHHGXJXHUUFHAHEVBWGXAXBXCAXDXEXF $.
  $}

  ${
    $d A f x y z $.  $d T f x y z $.
    $( The union of an element of a transitive Tarski's class is in the set.
       (Contributed by Mario Carneiro, 22-Jun-2013.) $)
    tskuni $p |- ( ( T e. Tarski /\ Tr T /\ A e. T ) -> U. A e. T ) $=
      ( vf vz vx vy wcel cen wbr cv wa wceq wrex csdm adantr syl2anc syl wss wi
      cdom ctsk wtr w3a cuni ccrd cfv wf1o wex cima cab wne ccf tsksdom cardidg
      wn ensymd sdomentr cmpt crn eqid rnmpt cdm cardon sdomdom ondomen sylancr
      wfo con0 adantl wfn cvv imaexg ax-mp fnmpti dffn4 mpbi fodomnum syl5eqbrr
      vex ee10 domsdomtr sylancom adantll mpdan cina c0 ne0i tskcard sylan2 cpw
      wral elina simp2bi breqtrrd 3adant2 wlim cwina inawina winalim 3syl eqeq1
      rexbidv elab imassrn f1ofo syl5sseq ad2antlr f1of1 elssuni f1imaen syl2an
      forn wf1 simpl1 trss 3adant1 sselda adantlr ensdomtr sseq1 breq1 biimprcd
      imp anbi12d rexlimdva syl5bi ralrimiv fvex cfslb2n dfiun2 ralrimivw iunss
      mpd ciun sylibr wf fof 3ad2ant2 3ad2ant1 expcom foelrn eluni2 nfiu1 nfel2
      ex nfv ssiun2 ffn simp3 fnfvima syl3anc sseldd 3exp rexlimd syl6 rexlimdv
      eleq1a sylsyld ssrdv eqssd syl5eqr necon3ai pm2.01da nexdv entr bren mtod
      sylib wo uniss df-tr biimpi sylan9ss syld tsken 3impb ord ) BUAGZBUBZABGZ
      UCZAUDZBHIZUOUWBBGZUWAUWCUWBBUEUFZCJZUGZCUHZUWAUWGCUWAUWGUWAUWGKZDJZUWFEJ
      ZUIZLZEAMZDUJZUDZUWEUKZUWGUOUWIUWOUWEULUFZNIZUWQUWAUWSUWGUVRUVTUWSUVSUVRU
      VTKZUWOUWEUWRNUWTAUWENIZUWOUWENIZUWTABNIBUWEHIZUXAABUMUVRUXCUVTUVRUWEBBUA
      UNUPZOABUWEUQPUVTUXAUXBUVRUVTUXAUWOATIUXBUVTUXAKZUWOEAUWLURZUSZATEDAUWLUX
      FUXFUTZVAUXEAUEVBGZAUXGUXFVGZUXGATIUXAUXIUVTUXAUWEVHGAUWETIUXIBVCAUWEVDUW
      EAVEVFVIUXFAVJUXJEAUWLUXFUWFVKGUWLVKGCVSUWFUWKVKVLVMZUXHVNAUXFVOVPAUXGUXF
      VQVTVRUWOAUWEWAWBWCWDUWTUWEWEGZUWRUWELZUVTUVRBWFUKUXLBAWGBWHWIZUXLUWEWFUK
      UXMUWKWJUWENIEUWEWKEUWEWLWMZQWNWOOUWIUWEWPZFJZUWERZUXQUWRNIZKZFUWOWKUWSUW
      QSUWIUXLUWEWQGUXPUWAUXLUWGUVRUVTUXLUVSUXNWOOZUWEWRUWEWSWTUWIUXTFUWOUXQUWO
      GUXQUWLLZEAMZUWIUXTUWNUYCDUXQFVSUWJUXQLUWMUYBEAUWJUXQUWLXAXBXCUWIUYBUXTEA
      UWIUWKAGZKZUWLUWERZUWLUWRNIZUYBUXTSUWGUYFUWAUYDUWGUWFUSZUWLUWEUWFUWKXDUWG
      UWBUWEUWFVGZUYHUWELUWBUWEUWFXEZUWBUWEUWFXLQXFZXGUYEUWLUWEUWRNUYEUWLUWKHIZ
      UWKUWENIZUWLUWENIUWGUYDUYLUWAUWGUWBUWEUWFXMUWKUWBRZUYLUYDUWBUWEUWFXHUWKAX
      IZUWBUWEUWKUWFEVSXJXKWCUWAUYDUYMUWGUWAUYDKZUWKBNIZUXCUYMUYPUVRUWKBGUYQUVR
      UVSUVTUYDXNZUWAABUWKUVSUVTABRZUVRUVSUVTUYSBAXOZYCXPXQUWKBUMPUYPUVRUXCUYRU
      XDQUWKBUWEUQPXRUWLUWKUWEXSPUWIUXMUYDUWIUXLUXMUYAUXOQOWNUYBUXTUYFUYGKUYBUX
      RUYFUXSUYGUXQUWLUWEXTUXQUWLUWRNYAYDYBPYEYFYGFUWEUWOBUEYHYIPYMUWGUWPUWEUWG
      UWPEAUWLYNZUWEEDAUWLUXKYJUWGVUAUWEUWGUYFEAWKVUAUWERUWGUYFEAUYKYKEAUWLUWEY
      LYOUWGFUWEVUAUWGUYIUXQUWEGZUXQVUAGZSUYJUYIUWBUWEUWFYPZVUBUXQUWJUWFUFZLZDU
      WBMZVUCUWBUWEUWFYQUYIVUBVUGDUWBUWEUXQUWFUUAUUEVUDVUFVUCDUWBVUDUWJUWBGZVUE
      VUAGZVUFVUCSVUHUWJUWKGZEAMVUDVUIEUWJAUUBVUDVUJVUIEAVUDEUUFEVUEVUAEAUWLUUC
      UUDVUDUYDVUJVUIVUDUYDVUJUCZUWLVUAVUEUYDVUDUWLVUARVUJEAUWLUUGYRVUKUWFUWBVJ
      ZUYNVUJVUEUWLGVUDUYDVULVUJUWBUWEUWFUUHYSUYDVUDUYNVUJUYOYRVUDUYDVUJUUIUWBU
      WKUWFUWJUUJUUKUULUUMUUNYFVUEVUAUXQUUQUUOUUPUURQUUSUUTUVAUVBQUVCUVDUVRUVSU
      WCUWHSUVTUWCUVRUWHUWCUVRKUWBUWEHIZUWHUVRUWCUXCVUMUXDUWBBUWEUVEWIUWBUWECUV
      FUVHYTYSUVGUWAUWCUWDUVRUVSUVTUWCUWDUVIZUVSUVTKUVRUWBBRZVUNUVSUVTVUOUVSUVT
      UYSVUOUYTUYSUVSVUOUYSUVSUWBBUDZBABUVJUVSVUPBRBUVKUVLUVMYTUVNYCUWBBUVOWIUV
      PUVQYM $.

    $( A nonempty transitive Tarski's class is a weak universe.  (Contributed
       by Mario Carneiro, 2-Jan-2017.) $)
    tskwun $p |- ( ( T e. Tarski /\ Tr T /\ T =/= (/) ) -> T e. WUni ) $=
      ( vx vy ctsk wcel wtr c0 wne w3a cwun cv cuni cpw cpr wral simp2 simp3 wi
      3ad2ant1 ralrimiva tskuni 3expa 3adantl3 tskpw 3ad2antl1 tskpr 3exp imp31
      wa 3jca wb iswun mpbir3and ) ADEZAFZAGHZIZAJEZUOUPBKZLAEZUSMAEZUSCKZNAEZC
      AOZIZBAOZUNUOUPPUNUOUPQUQVEBAUQUSAEZUIZUTVAVDUNUOVGUTUPUNUOVGUTUSAUAUBUCU
      NUOVGVAUPUSAUDUEVHVCCAUQVGVBAEZVCUNUOVGVIVCRRUPUNVGVIVCUSVBAUFUGSUHTUJTUN
      UOURUOUPVFIUKUPBCADULSUM $.
  $}

  $( The intersection of an element of a transitive Tarski's class is an
     element of the class.  (Contributed by FL, 17-Apr-2011.)  (Revised by
     Mario Carneiro, 20-Sep-2014.) $)
  tskint $p |- ( ( ( T e. Tarski /\ Tr T ) /\ A e. T /\ A =/= (/) ) ->
    |^| A e. T ) $=
    ( ctsk wcel wtr wa c0 wne w3a cuni wss simp1l tskuni 3expa 3adant3 intssuni
    cint 3ad2ant3 tskss syl3anc ) BCDZBEZFZABDZAGHZIUAAJZBDZAQZUFKZUHBDUAUBUDUE
    LUCUDUGUEUAUBUDUGABMNOUEUCUIUDAPRUFUHBST $.

  $( The union of two elements of a transitive Tarski's class is in the set.
     (Contributed by Mario Carneiro, 20-Sep-2014.) $)
  tskun $p |- ( ( ( T e. Tarski /\ Tr T ) /\ A e. T /\ B e. T ) ->
    ( A u. B ) e. T ) $=
    ( ctsk wcel wtr wa w3a cpr cuni cun wceq uniprg 3adant1 simp1l simp1r tskpr
    3adant1r tskuni syl3anc eqeltrrd ) CDEZCFZGZACEZBCEZHZABIZJZABKZCUEUFUIUJLU
    DABCCMNUGUBUCUHCEZUICEUBUCUEUFOUBUCUEUFPUBUEUFUKUCABCQRUHCSTUA $.

  $( The cross product of two elements of a transitive Tarski's class is an
     element of the class.  JFM CLASSES2 th. 67 (partly).  (Contributed by FL,
     15-Apr-2011.)  (Proof shortened by Mario Carneiro, 20-Sep-2014.) $)
  tskxp $p |- ( ( ( T e. Tarski /\ Tr T ) /\ A e. T /\ B e. T )
  -> ( A X. B ) e. T ) $=
    ( ctsk wcel wtr wa w3a cwun c0 ne0i tskwun 3expa sylan2 3adant3 simp2 simp3
    wne wunxp ) CDEZCFZGZACEZBCEZHABCUBUCCIEZUDUCUBCJRZUECAKTUAUFUECLMNOUBUCUDP
    UBUCUDQS $.

  $( Set exponentiation is an element of a transitive Tarski's class.  JFM
     CLASSES2 th. 67 (partly).  (Contributed by FL, 15-Apr-2011.)  (Proof
     shortened by Mario Carneiro, 20-Sep-2014.) $)
  tskmap $p |- ( ( ( T e. Tarski /\ Tr T ) /\ A e. T /\ B e. T )
  -> ( A ^m B ) e. T ) $=
    ( ctsk wcel wtr wa w3a cwun c0 ne0i tskwun 3expa sylan2 3adant3 simp2 simp3
    wne wunmap ) CDEZCFZGZACEZBCEZHABCUBUCCIEZUDUCUBCJRZUECAKTUAUFUECLMNOUBUCUD
    PUBUCUDQS $.

  ${
    $d A y $.  $d T y $.
    $( A transitive Tarski's class is closed under small unions.  (Contributed
       by Mario Carneiro, 22-Jun-2013.) $)
    tskurn $p |- ( ( ( T e. Tarski /\ Tr T ) /\ A e. T /\ F : A --> T )
    -> U. ran F e. T ) $=
      ( ctsk wcel wtr wa wf w3a crn cuni simp1l simp1r wss wbr 3ad2ant3 syl2anc
      csdm sylc syl3anc frn cdom ccrd cdm wfo tskwe2 syl simp2 trss ssnum dffn4
      wfn ffn sylib fodomnum tsksdom domsdomtr tskssel tskuni ) BDEZBFZGZABEZAB
      CHZIZUTVACJZBEZVFKBEUTVAVCVDLZUTVAVCVDMZVEUTVFBNZVFBROZVGVHVDVBVJVCABCUAP
      VEVFAUBOZABROZVKVEAUCUDZEZAVFCUEZVLVEBVNEZABNZVOVEUTVQVHBUFUGVEVAVCVRVIVB
      VCVDUHZBAUISBAUJQVDVBVPVCVDCAULVPABCUMACUKUNPAVFCUOSVEUTVCVMVHVSABUPQVFAB
      UQQVFBURTVFBUST $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Grothendieck's universes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Univ $. $( The class of all Grothendieck's universes. $)

  $( Extend class notation to include the class of all Grothendieck's
     universes. $)
  cgru $a class Univ $.

  ${
    $d u x y $.
    $( A Grothendieck's universe is a set that is closed with respect to all
       the operations that are common in set theory: pairs, powersets, unions,
       intersections, cross products etc.  Grothendieck and alii,
       S&eacute;minaire de G&eacute;om&eacute;trie Alg&eacute;brique 4,
       Expos&eacute; I, p. 185.  It was designed to give a precise meaning to
       the concepts of categories of sets, groups...  (Contributed by Mario
       Carneiro, 9-Jun-2013.) $)
    df-gru $a |- Univ = { u | ( Tr u /\ A. x e. u ( ~P x e. u /\
      A. y e. u { x , y } e. u /\ A. y e. ( u ^m x ) U. ran y e. u ) ) } $.
  $}

  ${
    $d U u x y $.
    $( Properties of a Grothendieck's universe.  (Contributed by Mario
       Carneiro, 9-Jun-2013.) $)
    elgrug $p |- ( U e. V ->
      ( U e. Univ <-> ( Tr U /\ A. x e. U ( ~P x e. U /\
        A. y e. U { x , y } e. U /\ A. y e. ( U ^m x ) U. ran y e. U ) ) ) ) $=
      ( vu cv wtr cpw wcel cpr wral crn cuni cmap co w3a cgru eleq2 raleqbi1dv
      wa wceq treq oveq1 raleqbidv 3anbi123d anbi12d df-gru elab2g ) EFZGZAFZHZ
      UIIZUKBFZJZUIIZBUIKZUNLMZUIIZBUIUKNOZKZPZAUIKZTCGZULCIZUOCIZBCKZURCIZBCUK
      NOZKZPZACKZTECQDUICUAZUJVDVCVLUICUBVBVKAUICVMUMVEUQVGVAVJUICULRUPVFBUICUI
      CUORSVMUSVHBUTVIUICUKNUCUICURRUDUESUFABEUGUH $.
  $}

  ${
    $d U x y z $.  $d A u x y z $.  $d B y $.  $d F x y z $.
    $( A Grothendieck's universe is transitive.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    grutr $p |- ( U e. Univ -> Tr U ) $=
      ( vx vy cgru wcel wtr cv cpw cpr wral crn cuni cmap w3a elgrug ibi simpld
      co wa ) ADEZAFZBGZHAEUBCGZIAECAJUCKLAECAUBMRJNBAJZTUAUDSBCADOPQ $.

    $( A Grothendieck's universe is transitive, so each element is a subset of
       the universe.  (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruelss $p |- ( ( U e. Univ /\ A e. U ) -> A C_ U ) $=
      ( cgru wcel wtr wss grutr trss imp sylan ) BCDBEZABDZABFZBGKLMBAHIJ $.

    $( A Grothendieck's universe contains the powerset of each of its members.
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    grupw $p |- ( ( U e. Univ /\ A e. U ) -> ~P A e. U ) $=
      ( vy vx cgru wcel cpw cv cpr wral crn cuni cmap co w3a wi wtr elgrug ibi
      wa simprd simp1 ralimi wceq pweq eleq1d rspccv 3syl imp ) BEFZABFZAGZBFZU
      JCHZGZBFZUNDHZIBFDBJZUQKLBFDBUNMNJZOZCBJZUPCBJUKUMPUJBQZVAUJVBVATCDBERSUA
      UTUPCBUPURUSUBUCUPUMCABUNAUDUOULBUNAUEUFUGUHUI $.

    $( Any subset of an element of a Grothendieck's universe is also an
       element.  (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruss $p |- ( ( U e. Univ /\ A e. U /\ B C_ A ) -> B e. U ) $=
      ( cgru wcel wss wa cpw wb elpw2g adantl grupw gruelss syldan sseld 3impia
      sylbird ) CDEZACEZBAFZBCEZRSGZTBAHZEZUASUDTIRBACJKUBUCCBRSUCCEUCCFACLUCCM
      NOQP $.

    ${
      $d B x $.
      $( A Grothendieck's universe contains pairs derived from its elements.
         (Contributed by Mario Carneiro, 9-Jun-2013.) $)
      grupr $p |- ( ( U e. Univ /\ A e. U /\ B e. U ) -> { A , B } e. U ) $=
        ( vx vy cgru wcel cpr cv wral wi cpw crn cuni cmap co w3a eleq1d rspccv
        wceq wtr wa elgrug ibi simprd preq2 3ad2ant2 com12 ralimdv syl5com syl6
        preq1 com23 3imp ) CFGZACGZBCGZABHZCGZUOUQUPUSUOUQDIZBHZCGZDCJZUPUSKUOU
        TLCGZUTEIZHZCGZECJZVEMNCGECUTOPJZQZDCJZUQVCUOCUAZVKUOVLVKUBDECFUCUDUEUQ
        VJVBDCVJUQVBVHVDUQVBKVIVGVBEBCVEBTVFVACVEBUTUFRSUGUHUIUJVBUSDACUTATVAUR
        CUTABULRSUKUMUN $.
    $}

    $( A Grothendieck's universe contains the range of any function which takes
       values in the universe (see ~ gruiun for a more intuitive version).
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruurn $p |- ( ( U e. Univ /\ A e. U /\ F : A --> U ) -> U. ran F e. U ) $=
      ( vx vy cgru wcel wf crn cuni wa cmap co elmapg wi cpw wral wceq rspccv
      cv cpr w3a wtr elgrug ibi simprd rneq unieqd eleq1d 3ad2ant3 ralimi oveq2
      eleq2d imbi1d 3syl imp sylbird 3impia ) BFGZABGZABCHZCIZJZBGZUSUTKVACBALM
      ZGZVDBACFBNUSUTVFVDOZUSDTZPBGZVHETZUABGEBQZVJIZJZBGZEBVHLMZQZUBZDBQZCVOGZ
      VDOZDBQUTVGOUSBUCZVRUSWAVRKDEBFUDUEUFVQVTDBVPVIVTVKVNVDECVOVJCRZVMVCBWBVL
      VBVJCUGUHUISUJUKVTVGDABVHARZVSVFVDWCVOVECVHABLULUMUNSUOUPUQUR $.

    $( If ` B ( x ) ` is a family of elements of ` U ` and the index set ` A `
       is an element of ` U ` , then the indexed union ` U_ x e. A B ` is also
       an element of ` U ` , where ` U ` is a Grothendieck's universe.
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruiun $p |- ( ( U e. Univ /\ A e. U /\ A. x e. A B e. U )
        -> U_ x e. A B e. U ) $=
      ( vy cgru wcel wral ciun wa cmpt crn cuni wf wfn wss eqid fnmpt cv wrex
      cab rnmpt r19.29 eleq1 biimparc rexlimivw syl ex abssdv syl5eqss sylanbrc
      wceq df-f gruurn 3expia syl5com dfiun3g eleq1d sylibrd com12 3impia ) DFG
      ZBDGZCDGZABHZABCIZDGZVEVBVCJZVGVEVHABCKZLZMZDGZVGVEBDVINZVHVLVEVIBOVJDPVM
      ABCVIDVIQZRVEVJESZCULZABTZEUADAEBCVIVNUBVEVQEDVEVQVODGZVEVQJVDVPJZABTVRVD
      VPABUCVSVRABVPVRVDVOCDUDUEUFUGUHUIUJBDVIUMUKVBVCVMVLBDVIUNUOUPVEVFVKDABCD
      UQURUSUTVA $.

    $( A Grothendieck's universe contains unions of its elements.  (Contributed
       by Mario Carneiro, 17-Jun-2013.) $)
    gruuni $p |- ( ( U e. Univ /\ A e. U ) -> U. A e. U ) $=
      ( vx cgru wcel wa cuni cv ciun uniiun wral wss gruelss dfss3 sylib gruiun
      mpd3an3 syl5eqel ) BDEZABEZFZAGCACHZIZBCAJSTUBBECAKZUCBEUAABLUDABMCABNOCA
      UBBPQR $.

    $( A Grothendieck's universe contains the range of any function which takes
       values in the universe (see ~ gruiun for a more intuitive version).
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    grurn $p |- ( ( U e. Univ /\ A e. U /\ F : A --> U ) -> ran F e. U ) $=
      ( cgru wcel wf w3a crn cpw wss simp1 gruurn grupw syl2anc pwuni a1i gruss
      cuni syl3anc ) BDEZABEZABCFZGZTCHZRZIZBEZUDUFJZUDBETUAUBKZUCTUEBEUGUIABCL
      UEBMNUHUCUDOPUFUDBQS $.

    $( A Grothendieck's universe contains image sets drawn from its members.
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruima $p |- ( ( U e. Univ /\ Fun F /\ ( F " A ) C_ U ) ->
        ( A e. U -> ( F " A ) e. U ) ) $=
      ( cgru wcel wfun cima wss w3a wa cdm cin cres wrel wceq simpl2 wf syl3anc
      crn 3syl funrel resres resdm reseq1d syl5eqr rneqd df-ima syl6reqr simpl1
      simpr inss2 a1i gruss wfn wfo funforn fof sylbi fssres sylancl ffn simpl3
      inss1 eqsstr3d df-f sylanbrc grurn eqeltrd ex ) BDEZCFZCAGZBHZIZABEZVLBEV
      NVOJZVLCCKZALZMZSZBVPVKCNZVLVTOVJVKVMVOPZCUAWAVTCAMZSVLWAVSWCWAVSCVQMZAMW
      CCVQAUBWAWDCACUCUDUEUFCAUGUHTZVPVJVRBEZVRBVSQZVTBEVJVKVMVOUIZVPVJVOVRAHZW
      FWHVNVOUJWIVPVQAUKULAVRBUMRVPVSVRUNZVTBHWGVPVKVRCSZVSQZWJWBVKVQWKCQZVRVQH
      WLVKVQWKCUOWMCUPVQWKCUQURVQAVCVQWKVRCUSUTVRWKVSVATVPVTVLBWEVJVKVMVOVBVDVR
      BVSVEVFVRBVSVGRVHVI $.

    $( Any element of an element of a Grothendieck's universe is also an
       element of the universe.  (Contributed by Mario Carneiro,
       9-Jun-2013.) $)
    gruel $p |- ( ( U e. Univ /\ A e. U /\ B e. A ) -> B e. U ) $=
      ( cgru wcel wa gruelss sseld 3impia ) CDEZACEZBAEBCEJKFACBACGHI $.

    $( A Grothendieck's universe contains the singletons of its elements.
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    grusn $p |- ( ( U e. Univ /\ A e. U ) -> { A } e. U ) $=
      ( cgru wcel wa csn cpr dfsn2 grupr 3anidm23 syl5eqel ) BCDZABDZEAFAAGZBAH
      LMNBDAABIJK $.

    $( A Grothendieck's universe contains ordered pairs of its elements.
       (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    gruop $p |- ( ( U e. Univ /\ A e. U /\ B e. U ) -> <. A , B >. e. U ) $=
      ( cgru wcel w3a cop csn dfopg 3adant1 simp1 grusn 3adant3 syl3anc eqeltrd
      cpr wceq grupr ) CDEZACEZBCEZFZABGZAHZABPZPZCTUAUCUFQSABCCIJUBSUDCEZUECEU
      FCESTUAKSTUGUAACLMABCRUDUECRNO $.

    ${
      $d B x $.
      $( A Grothendieck's universe contains binary unions of its elements.
         (Contributed by Mario Carneiro, 9-Jun-2013.) $)
      gruun $p |- ( ( U e. Univ /\ A e. U /\ B e. U ) -> ( A u. B ) e. U ) $=
        ( vx cgru wcel w3a cun cv ciun cuni uniiun wceq uniprg 3adant1 syl5reqr
        cpr wral simp1 eleq1a grupr wa wo vex elpr jaao syl5bi ralrimiv syl3anc
        gruiun eqeltrd ) CEFZACFZBCFZGZABHZDABQZDIZJZCUOUSUQKZUPDUQLUMUNUTUPMUL
        ABCCNOPUOULUQCFURCFZDUQRZUSCFULUMUNSABCUAUMUNVBULUMUNUBZVADUQURUQFURAMZ
        URBMZUCVCVAURABDUDUEUMVDVAUNVEACURTBCURTUFUGUHODUQURCUJUIUK $.
    $}

    $( A Grothendieck's universe contains binary cartesian products of its
       elements.  (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruxp $p |- ( ( U e. Univ /\ A e. U /\ B e. U ) -> ( A X. B ) e. U ) $=
      ( cgru wcel w3a cun cxp gruun cpw grupw wss xpsspw gruss mp3an3 3ad2antl1
      syldan mpdan ) CDEZACEZBCEZFABGZCEZABHZCEZABCISTUCUEUASUCUBJZCEZUEUBCKSUG
      UFJZCEZUEUFCKSUIUDUHLUEABMUHUDCNOQQPR $.

    $( A Grothendieck's universe contains all powers of its elements.
       (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    grumap $p |- ( ( U e. Univ /\ A e. U /\ B e. U ) -> ( A ^m B ) e. U ) $=
      ( cgru wcel w3a cxp cpw cmap wss simp1 gruxp 3com23 grupw syl2anc mapsspw
      co a1i gruss syl3anc ) CDEZACEZBCEZFZUABAGZHZCEZABIQZUFJZUHCEUAUBUCKZUDUA
      UECEZUGUJUAUCUBUKBACLMUECNOUIUDABPRUFUHCST $.

    $( A Grothendieck's universe contains indexed cartesian products of its
       elements.  (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruixp $p |- ( ( U e. Univ /\ A e. U /\ A. x e. A B e. U )
        -> X_ x e. A B e. U ) $=
      ( cgru wcel wral w3a ciun cmap cixp wss simp1 gruiun simp2 grumap syl3anc
      co ixpssmapg 3ad2ant3 gruss ) DEFZBDFZCDFABGZHZUBABCIZBJRZDFZABCKZUGLZUID
      FUBUCUDMZUEUBUFDFUCUHUKABCDNUBUCUDOUFBDPQUDUBUJUCABCDSTUGUIDUAQ $.

    $( A Grothendieck's universe contains indexed intersections of its
       elements.  (Contributed by Mario Carneiro, 9-Jun-2013.) $)
    gruiin $p |- ( ( U e. Univ /\ E. x e. A B e. U ) -> |^|_ x e. A B e. U ) $=
      ( cgru wcel wrex ciin nfv nfii1 nfel1 wss iinss2 gruss syl3an3 3exp com23
      cv rexlimd imp ) DEFZCDFZABGABCHZDFZUAUBUDABUAAIAUCDABCJKUAUBARBFZUDUAUBU
      EUDUEUAUBUCCLUDABCMCUCDNOPQST $.

    $( A Grothendieck's universe contains all functions on its elements.
       (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    gruf $p |- ( ( U e. Univ /\ A e. U /\ F : A --> U ) -> F e. U ) $=
      ( vx cgru wcel wf w3a cv cfv cop cmpt simp3 feqmptd fvex fnasrn syl6eq wa
      crn simpl1 gruel 3expa 3adantl3 ffvelrn gruop syl3anc eqid fmptd syld3an3
      3ad2antl3 grurn eqeltrd ) BEFZABFZABCGZHZCDADIZUQCJZKZLZSZBUPCDAURLVAUPDA
      BCUMUNUOMNDAURUQCOPQUMUNUOABUTGVABFUPDAUSBUTUPUQAFZRUMUQBFZURBFZUSBFUMUNU
      OVBTUMUNVBVCUOUMUNVBVCAUQBUAUBUCUOUMVBVDUNABUQCUDUJUQURBUEUFUTUGUHABUTUKU
      IUL $.

    $( A Grothendieck's universe contains all subsets of itself that are
       equipotent to an element of the universe.  (Contributed by Mario
       Carneiro, 9-Jun-2013.) $)
    gruen $p |- ( ( U e. Univ /\ A C_ U /\ ( B e. U /\ B ~~ A ) )
        -> A e. U ) $=
      ( vy cgru wcel wss cen wbr wa wi cv wf1o wex bren wfo f1ofo w3a crn wf
      wceq simp3l syl fof fss sylan grurn syl3an3 eqeltrrd 3expia exp3a exlimdv
      forn syl5 com3r expdimp syl7bi imp3a ancoms 3impia ) CEFZACGZBCFZBAHIZJZA
      CFZVBVAVEVFKVBVAJZVCVDVFVDBADLZMZDNZVGVCVFBADOVBVAVCVJVFKVAVCJZVJVBVFVKVI
      VBVFKZDVIBAVHPZVKVLBAVHQVKVMVBVFVAVCVMVBJZVFVAVCVNRZVHSZACVOVMVPAUAVAVCVM
      VBUBBAVHUMUCVNVAVCBCVHTZVPCFVMBAVHTVBVQBAVHUDBACVHUEUFBCVHUGUHUIUJUKUNULU
      OUPUQURUSUT $.

    $( A nonempty Grothendieck's universe is a weak universe.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    gruwun $p |- ( ( U e. Univ /\ U =/= (/) ) -> U e. WUni ) $=
      ( vx vy cgru wcel c0 wne wa cwun wtr cuni cpw cpr wral w3a adantr adantlr
      cv grutr ralrimiva simpr gruuni grupw grupr 3expa adantllr 3jca mpbir3and
      wb iswun ) ADEZAFGZHZAIEZAJZULBRZKAEZUPLAEZUPCRZMAEZCANZOZBANZUKUOULASPUK
      ULUAUMVBBAUMUPAEZHZUQURVAUKVDUQULUPAUBQUKVDURULUPAUCQVEUTCAUKVDUSAEZUTULU
      KVDVFUTUPUSAUDUEUFTUGTUKUNUOULVCOUIULBCADUJPUH $.
  $}

  ${
    $d u x y A $.
    $( The intersection of a family of universes is a universe.  (Contributed
       by Mario Carneiro, 9-Jun-2013.) $)
    intgru $p |- ( ( A C_ Univ /\ A =/= (/) ) -> |^| A e. Univ ) $=
      ( vx vy vu cgru wss wa cvv wcel wtr wral sylbi ral2imi vex elint2 3imtr4g
      cv adantlr wi 3expia c0 wne cint cpw cpr crn cuni cmap co w3a simpr intex
      sylib dfss3 grutr ralimi trint syl adantr grupw ex pwex imp r19.26 sylbir
      grupr prex sylan2b ralrimiv wf wb elmapg mpan2 ad2antlr intss1 fss sylan2
      ralrimiva gruurn syl5 uniex syl6ibr sylbid sylanb elgrug biimpar syl12anc
      rnex 3jca ) AEFZAUAUBZGZAUCZHIZWMJZBQZUDZWMIZWPCQZUEZWMIZCWMKZWSUFZUGZWMI
      ZCWMWPUHUIZKZUJZBWMKZWMEIZWLWKWNWJWKUKAULZUMWJWOWKWJDQZJZDAKZWOWJXLEIZDAK
      ZXNDAEUNZXOXMDAXLUOUPLDAUQURUSWJXPWKXIXQXPWKGZXHBWMXRWPWMIZGZWRXBXGXPXSWR
      WKXPXSWRXPWPXLIZDAKZWQXLIZDAKXSWRXOYAYCDAXOYAYCWPXLUTVAMDWPABNZOZDWQAWPYD
      VBOPVCRXPXSXBWKXPXSGZXACWMXSXPYBWSWMIZXASYEXPYBGZWSXLIZDAKZWTXLIZDAKZYGXA
      YHXOYAGZDAKZYJYLSXOYADAVDZYMYIYKDAXOYAYIYKWPWSXLVFTMVEDWSACNZODWTAWPWSVGO
      PVHVIRXTXECXFXTWSXFIZWPWMWSVJZXEWKYQYRVKZXPXSWKWNYSXKWNWPHIYSYDWMWPWSHHVL
      VMLVNXPXSYRXESWKYFYRXDXLIZDAKZXEYRWPXLWSVJZDAKZYFUUAYRUUBDAXLAIYRWMXLFUUB
      XLAVOWPWMXLWSVPVQVRXSXPYBUUCUUASZYEYHYNUUDYOYMUUBYTDAXOYAUUBYTWPXLWSVSTMV
      EVHVTDXDAXCWSYPWHWAOWBRWCVIWIVRWDWNXJWOXIGBCWMHWEWFWG $.

    $d u U $.
    $( The intersection of a universe with a class that acts like a universe is
       another universe.  (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    ingru $p |- ( ( Tr A /\ A. x e. A ( ~P x e. A /\
          A. y e. A { x , y } e. A /\ A. y ( y : x --> A -> U. ran y e. A ) ) )
        -> ( U e. Univ -> ( U i^i A ) e. Univ ) ) $=
      ( vu cgru wcel wtr cv wral wi w3a wa wss ssralv elin simplbi2 ral2imi cvv
      ax-mp cpw cpr wf crn cuni wal cin wceq ineq1 eleq1d imbi2d cmap co elgrug
      ibi trin ex inss1 inss2 syl2im im2anan9 vex mapss mp2an inex1 elmap mpan2
      fss sylbi imim1i alimi df-ral sylibr 3impa df-3an 3imtr4g syl6ibr vtoclga
      syl wb com12 ) DFGCHZAIZUAZCGZWCBIZUBZCGZBCJZWCCWFUCZWFUDUEZCGZKZBUFZLZAC
      JZMZDCUGZFGZWQEIZCUGZFGZKWQWSKEDFWTDUHZXBWSWQXCXAWRFWTDCUIUJUKWTFGZWQXAHZ
      WDXAGZWGXAGZBXAJZWKXAGZBXAWCULUMZJZLZAXAJZMZXBXDWTHZWDWTGZWGWTGZBWTJZWKWT
      GZBWTWCULUMZJZLZAWTJZMZWQXNKXDYDABWTFUNUOXOWBXEYCWPXMXOWBXEWTCUPUQYCYBAXA
      JZWPWOAXAJZXMXAWTNZYCYEKWTCURZYBAXAWTOTXACNZWPYFKWTCUSZWOAXACOTYBWOXLAXAY
      BWEWIMZWNMZXFXHMZXKMZWOXLXPXRYAYLYNKXPXRMYKYMYAWNXKXPWEXFXRWIXHXFXPWEWDWT
      CPQXRXQBXAJZWIWHBXAJZXHYGXRYOKYHXQBXAWTOTYIWIYPKYJWHBXACOTXQWHXGBXAXGXQWH
      WGWTCPQRUTVAYAXSBXJJZWNWLBXJJZXKXJXTNZYAYQKWTSGYGYSEVBZYHXAWTWCSVCVDXSBXJ
      XTOTWNWFXJGZWLKZBUFYRWMUUBBUUAWJWLUUAWCXAWFUCZWJXAWCWFWTCYTVEZAVBVFUUCYIW
      JYJWCXACWFVHVGVIVJVKWLBXJVLVMXSWLXIBXJXIXSWLWKWTCPQRUTVAVNWEWIWNVOXFXHXKV
      OVPRUTVAVSXASGXBXNVTUUDABXASUNTVQVRWA $.

    $( The wellfounded part of a universe is another universe.  (Contributed by
       Mario Carneiro, 17-Jun-2013.) $)
    wfgru $p |- ( U e. Univ -> ( U i^i U. ( R1 " On ) ) e. Univ ) $=
      ( vx vy cr1 con0 cima cuni wtr cv cpw wcel cpr wral wf crn wi wal w3a wss
      cgru cin dftr3 r1elssi mprgbir pwwf biimpi prwf ralrimiva frn rnex r1elss
      vex uniwf bitr3i sylib ax-gen a1i 3jca rgen ingru mp2an ) DEFGZHZBIZJVBKZ
      VDCIZLVBKZCVBMZVDVBVFNZVFOZGVBKZPZCQZRZBVBMATKAVBUATKPVCVDVBSBVBBVBUBVDUC
      UDVNBVBVDVBKZVEVHVMVOVEVDUEUFVOVGCVBVDVFUGUHVMVOVLCVIVJVBSZVKVDVBVFUIVPVJ
      VBKVKVJVFCULUJUKVJUMUNUOUPUQURUSBCVBAUTVA $.

    $d B x y $.  $d U x y $.
    $( Each ordinal that is comparable with an element of the universe is in
       the universe.  (Contributed by Mario Carneiro, 10-Jun-2013.) $)
    grudomon $p |- ( ( U e. Univ /\ A e. On /\ ( B e. U /\ A ~<_ B ) ) ->
        A e. U ) $=
      ( vx vy wcel cdom wbr wa con0 wi wceq breq1 eleq1 imbi12d imbi2d wral cvv
      cv wss cgru r19.21v w3a simpl1 vex onelss ssdomg mpsyl sylan simplr domtr
      imp syl2anc pm2.27 syl ralimdva dfss3 cen wb domeng 3ad2ant3 biimpa gruss
      wex simpl2 3expia 3adant1 adantr ensym anim12d ancomsd eximdv 3com23 3exp
      a1i gruen exlimdv sylsyld syl5bir syld ex com23 3expib syl5bi tfis3 com3l
      mpd a2d impr 3impia ) CUAFZBCFZABGHZIZAJFZACFZWKWNWOWPWKWLWMWOWPKWOWKWLIZ
      WMWPWQDSZBGHZWRCFZKZKZWQESZBGHZXCCFZKZKZWQWMWPKZKDEAWRXCLZXAXFWQXIWSXDWTX
      EWRXCBGMWRXCCNOPWRALZXAXHWQXJWSWMWTWPWRABGMWRACNOPXGEWRQWQXFEWRQZKWRJFZXB
      WQXFEWRUBXLWQXKXAXLWKWLXKXAKXLWKWLUCZWSXKWTXMWSXKWTKXMWSIZXKXEEWRQZWTXNXF
      XEEWRXNXCWRFZIZXDXFXEKXQXCWRGHZWSXDXNXLXPXRXLWKWLWSUDWRRFXLXPIXCWRTZXRDUE
      XLXPXSWRXCUFULXCWRRUGUHUIXMWSXPUJXCWRBUKUMXDXEUNUOUPXOWRCTZXNWTEWRCUQXNWR
      XCURHZXCBTZIZEVDZXTWTKZXMWSYDWLXLWSYDUSWKEWRBCUTVAVBXNWKYDXEXCWRURHZIZEVD
      YEXLWKWLWSVEXNYCYGEXNYBYAYGXNYBXEYAYFXMYBXEKZWSWKWLYHXLWKWLYBXEBXCCVCVFVG
      VHYAYFKXNWRXCVIVOVJVKVLWKYGYEEWKYGXTWTWKXTYGWTWRXCCVPVMVNVQVRWGVSVTWAWBWC
      WHWDWEWFWIWJVM $.
  $}

  ${
    $d A x y $.  $d U x y $.
    gruina.1 $e |- A = ( U i^i On ) $.
    $( If a Grothendieck's universe ` U ` is nonempty, then the height of the
       ordinals in ` U ` is a strongly inaccessible cardinal.  (Contributed by
       Mario Carneiro, 17-Jun-2013.) $)
    gruina $p |- ( ( U e. Univ /\ U =/= (/) ) -> A e. Inacc ) $=
      ( vx vy wcel c0 wne wa cfv wceq csdm wbr con0 wss syl adantr sylc sylancr
      cen cgru ccf cv cpw wral cina wex wi n0 cin gruss mp3an3 0elon jctir elin
      0ss sylibr syl6eleqr ne0i expcom exlimiv sylbi impcom wn word cvv wtr cep
      wwe grutr tron trin sylancl inss2 epweon wess mp2 a1i df-ord inex1g elon2
      sylanbrc syl5eqel eloni ordirr biimpri mtod ccrd cuni cab cint wlim inss1
      com wrex eqsstri sseli cdom canth2 cardid ensymi grupw syldan endom ax-mp
      pwex cardon grudomon mp3an2 mpanr2 onelss ssdomg endomtr sdomdomtr sylan2
      vex ralrimiva inawinalem winainflem syl3anc wb sdomtr cardlim sseq2 limeq
      iscard bibi12d mpbii mpbid cflm syl2anc eleq1 mpbiri abssi fvex syl6eqelr
      intex onint eqeltrd eqeq1 anbi1d exbidv elab sylib simp2rr simp1l simp2rl
      w3a syl6ss 3ad2ant3 simp2l syl6eqbr gruen syl112anc gruuni exlimdv mpd wo
      3exp cfon cfle onsseleq mpan ord elina syl3anbrc ) BUAFZBGHZIZAGHZAUBJZAK
      ZDUCZUDZALMZDAUEZAUFFUVHUVGUVJUVHUVMBFZDUGUVGUVJUHZDBUIUVQUVRDUVGUVQUVJUV
      GUVQIZGAFUVJUVSGBNUJZAUVSGBFZGNFZIGUVTFUVSUWAUWBUVGUVQGUVMOUWAUVMUPUVMGBU
      KULUMUNGBNUOUQCURAGUSPUTVAVBVCZUVIANFZUVKAFZVDUVLUVGUWDUVHUVGAUVTNCUVGUVT
      VEZUVTVFFUVTNFUVGUVTVGZUVTVHVIZUWFUVGBVGNVGUWGBVJVKBNVLVMUWHUVGUVTNONVHVI
      UWHBNVNVOUVTNVHVPVQVRUVTVSWBBNUAVTUVTWAWBWCZQZUVIUWEABFZUVIUWDUWKVDUWJUWD
      UWKAAFZUWDAVEUWLVDAWDAWEPUWKUWDUWLUWKUWDIZAUVTAAUVTFUWMABNUOWFCURUTWGPUVI
      UVKEUCZWHJZKZUWNAOZAUWNWIZKZIZIZEUGZUWEUWKUHZUVIUVKUVMUWOKZUWTIZEUGZDWJZF
      UXBUVIUVKUXGWKZUXGUVIUWDAWLZUVKUXHKUWJUVIWNAOZUXIUVIUVJUWDUVMUWNLMEAWODAU
      EZUXJUWCUWJUVGUXKUVHUVGUWDUVPUXKUWIUVGUVODAUVMAFZUVGUVQUVOABUVMAUVTBCBNWM
      WPZWQUVSUVNUVNUDZLMUXNAWRMZUVOUVNUVMDXPZXFZWSUVSUXNUXNWHJZTMUXRAWRMZUXOUX
      RUXNUXNUVNUXQXFWTZXAUVSUWDUXRAOZUXSUVGUWDUVQUWIQUVGUVQUXNBFZUYAUVGUVQUVNB
      FUYBUVMBXBUVNBXBXCUVGUYBIZUWDUXRAFZUYAUVGUWDUYBUWIQUYCUXRBFZUXRNFZUYDUVGU
      YBUXRUXNWRMZUYEUXRUXNTMUYGUXTUXRUXNXDXEUVGUYFUYBUYGIUYEUXNXGZUXRUXNBXHXIX
      JUYHUYEUYFIZUXRUVTAUXRUVTFUYIUXRBNUOWFCURVMAUXRXKRXCUXRANXLRUXNUXRAXMSUVN
      UXNAXNSXOZXQZDEAXRRQDEAXSXTUVGUXJUXIYAZUVHUVGAWHJZAKZUYLUVGUWDUVMALMZDAUE
      UYNUWIUVGUYODAUVGUXLIUVMUVNLMUVOUYOUVMUXPWSUYJUVMUVNAYBSXQDAYFWBUYNWNUYMO
      ZUYMWLZYAUYLAYCUYNUYPUXJUYQUXIUYMAWNYDUYMAYEYGYHPQYIDEANYJYKZUVIUXGNOUXGG
      HZUXHUXGFUXFDNUXEUVMNFZEUXDUYTUWTUXDUYTUWONFUWNXGUVMUWONYLYMQVAYNUVIUXHVF
      FUYSUVIUXHUVKVFUYRAUBYOZYPUXGYQUQUXGYRSYSUXFUXBDUVKVUAUVMUVKKZUXEUXAEVUBU
      XDUWPUWTUVMUVKUWOYTUUAUUBUUCUUDUVIUXAUXCEUVIUXAUWEUWKUVIUXAUWEUUHZAUWRBUW
      QUWSUWPUVIUWEUUEVUCUVGUWNBFZUWRBFUVGUVHUXAUWEUUFZVUCUVGUWNBOUVKBFZUVKUWNT
      MVUDVUEVUCUWNABUWQUWSUWPUVIUWEUUGUXMUUIUWEUVIVUFUXAABUVKUXMWQUUJVUCUVKUWO
      UWNTUVIUWPUWTUWEUUKUWNEXPWTUULUWNUVKBUUMUUNUWNBUUOYKYSUUSUUPUUQWGUWDUWEUV
      LUVKNFZUWDUWEUVLUURZAUUTVUGUWDIUVKAOVUHAUVAUVKAUVBYHUVCUVDRUVGUVPUVHUYKQD
      AUVEUVF $.

    $( A characterization of Grothendieck's universes, part 1.  (Contributed by
       Mario Carneiro, 23-Jun-2013.) $)
    grur1a $p |- ( U e. Univ -> ( R1 ` A ) C_ U ) $=
      ( vx vy wcel cr1 cfv wss c0 wceq wi con0 fveq2 3syl wa sseli eleq1 eleq1d
      wral cin inss1 eqsstri sseq2 mpbii ss0 r10 syl6eq 0ss syl6eqss a1i wne cv
      cgru ciun cina cwina gruina inawina wlim winalim r1lim syl2anc inss2 csuc
      winaon imbi12d simpr elelsuc word wb syl sylan2 eloni ordsucelsuc syl5ibr
      ne0i mpd cpw grupw ex adantr r1suc biimprcd syl6 com23 com4r ontr1 pm2.27
      embantd exp3a com3r sylc imp ralimdva gruiun 3expia syld cvv mpan biimprd
      sylan9r exp32 com34 tfinds2 impcom gruelss syldan ralrimiva iunss eqsstrd
      vex sylibr pm2.61dne ) BUNFZAGHZBIZBJBJKZXQLXOXRAJIZAJKZXQXRABIXSABMUAZBC
      BMUBUCZBJAUDUEAUFXTXPJBXTXPJGHZJAJGNUGUHBUIUJOUKXOBJULZXQXOYDPZXPDADUMZGH
      ZUOZBYEAUPFZAUQFZXPYHKZABCURZAUSZYJAMFZAUTYKAVFZAVADAMVBVCOXOYHBIZYDXOYGB
      IZDATYPXOYQDAXOYFAFZYGBFZYQYRXOYSYRYFMFZXOYSLAMYFAYAMCBMVDUCQYTXOYRYSYRYS
      LJAFZJBFZLZEUMZAFZUUDGHZBFZLZUUDVEZAFZUUIGHZBFZLXODEYFJKZYRUUAYSUUBYFJARU
      UMYGJBUUMYGYCJYFJGNUGUHSVGYFUUDKZYRUUEYSUUGYFUUDARUUNYGUUFBYFUUDGNSVGYFUU
      IKZYRUUJYSUULYFUUIARUUOYGUUKBYFUUIGNSVGUUCXOABJYBQUKXOUUHUUJUUDMFZUULXOUU
      JUUHUUPUULLZXOUUJUUHUUQLXOUUJPZUUEUUGUUQUURUUJUUEXOUUJVHUUJUUEUURUUIAVEFZ
      UUIAVIUURYNAVJUUEUUSVKUUJXOYDYNUUJUUIBFYDABUUIYBQBUUIVQVLYEYIYJYNYLYMYOOZ
      VMAVNUUDAVOOVPVRUURUUGUUFVSZBFZUUQXOUUGUVBLUUJXOUUGUVBUUFBVTWAWBUUPUULUVB
      UUPUUKUVABUUDWCSWDWEWJWAWFWGYFUTZXOYRUUHEYFTZYSUVCXOYRUVDYSLXOYRPZUVDEYFU
      UFUOZBFZUVCYSUVEUVDUUGEYFTZUVGUVEUUHUUGEYFUVEUUDYFFZUUHUUGLZUVEYRYNUVIUVJ
      LXOYRVHYRXOYDYNYRYFBFZYDABYFYBQZBYFVQVLUUTVMYNUVIYRUVJYNUVIYRUVJYNUVIYRPU
      UEUVJUUDYFAWHUUEUUGWIWEWKWLWMWNWOYRXOUVKUVHUVGLUVLXOUVKUVHUVGEYFUUFBWPWQV
      MWRUVCYSUVGUVCYGUVFBYFWSFUVCYGUVFKDXLEYFWSVBWTSXAXBXCXDXEWLVRXFYGBXGXHXID
      AYGBXJXMWBXKWAXN $.

    $( A characterization of Grothendieck's universes, part 2.  (Contributed by
       Mario Carneiro, 24-Jun-2013.) $)
    grur1 $p |- ( ( U e. Univ /\ U e. U. ( R1 " On ) ) -> U = ( R1 ` A ) ) $=
      ( vy vx wcel cr1 con0 wa cfv wss wn crnk wceq wi syl cvv ad2ant2r wbr ccf
      cgru cima cuni cv wrex wex nss fveq2 eqeq1d rspcev ex ad2antrl ctc simplr
      simprl r1elssi sseld sylc tcrank eleq2d wtr gruelss grutr vex tcmin ax-mp
      adantr syl2anc wfun wf rankf ffun fvelima ssrexv syl2im sylbid simprr cdm
      mpan wo wb cina cwina c0 wne ne0i gruina sylan2 inawina winaon wfn r1fnon
      3syl fndm syl6eleqr rankr1ag mtbid w3o rankon word eloni ordtri3or syl2an
      sylancr 3orass sylib ord mpd mpjaod exlimdv syl5bi cdom ad2antll cpw csdm
      simpll wral elina eqtrd rankcf fvex domtri mp2an mpbir syl6eqbrr grudomon
      simp2bi syl112anc cin elin biimpri ordirr adantl pm2.21dd rexlimdvaa syld
      pm2.18d grur1a eqssd ) BUAFZBGHUBUCZFZIZBAGJZUUCBUUDKZUUCUUELZDUDZMJZANZD
      BUEZUUEUUFEUDZBFZUUKUUDFZLZIZEUFUUCUUJEBUUDUGUUCUUOUUJEUUCUUOUUJUUCUUOIZU
      UKMJZANZUUJAUUQFZUULUURUUJOUUCUUNUULUURUUJUUIUURDUUKBUUGUUKNUUHUUQAUUGUUK
      MUHUIUJUKULUUPUUSAMUUKUMJZUBZFZUUJUUPUUQUVAAUUPUUKUUAFZUUQUVANUUPUUBUULUV
      CYTUUBUUOUNUUCUULUUNUOUUBBUUAUUKBUPUQURZUUKUSPUTYTUULUVBUUJOUUBUUNYTUULIZ
      UUTBKZUVBUUIDUUTUEZUUJUVEUUKBKZBVAZUVFUUKBVBYTUVIUULBVCVGUUKQFUVHUVIIUVFO
      EVDUUKBQVEVFVHMVIZUVBUVGUUAHMVJUVJVKUUAHMVLVFDAUUTMVMVSUUIDUUTBVNVORVPUUP
      UUQAFZLZUURUUSVTZUUPUUMUVKUUCUULUUNVQUUPUVCAGVRZFZUUMUVKWAUVDYTUULUVOUUBU
      UNUVEAHUVNUVEAWBFZAWCFZAHFZUULYTBWDWEZUVPBUUKWFABCWGZWHAWIZAWJZWMZGHWKUVN
      HNWLHGWNVFWORUUKAWPVHWQYTUULUVLUVMOUUBUUNUVEUVKUVMUVEUVKUURUUSWRZUVKUVMVT
      UVEUUQHFZUVRUWDUUKWSUWCUWEUUQWTAWTZUWDUVRUUQXAAXAZUUQAXBXCXDUVKUURUUSXEXF
      XGRXHXIUKXJXKUUCUUIUUEDBUUCUUGBFZUUIIZIZABFZUVRUUEUWJYTUVRUWHAUUGXLSUWKYT
      UUBUWIXPUWJUVPUVQUVRYTUWHUVPUUBUUIUWHYTUVSUVPBUUGWFUVTWHRZUWAUWBWMZUUCUWH
      UUIUOUWJAUUHTJZUUGXLUWJUWNATJZAUUIUWNUWONUUCUWHUUHATUHXMUWJUVPUWOANZUWLUV
      PAWDWEUWPUUKXNAXOSEAXQEAXRYGPXSUWNUUGXLSZUUGUWNXOSLZUUGXTUWNQFUUGQFUWQUWR
      WAUUHTYADVDUWNUUGQQYBYCYDYEAUUGBYFYHUWMUWKUVRIZAAFZUUEUWSABHYIZAAUXAFUWSA
      BHYJYKCWOUVRUWTLZUWKUVRUWFUXBUWGAYLPYMYNVHYOYPYQYTUUDBKUUBABCYRVGYS $.
  $}

  ${
    $d T x y $.
    $( Grothendieck's universes are the same as transitive Tarski's classes,
       part one: a transitive Tarski class is a universe.  (The hard work is in
       ~ tskuni .)  (Contributed by Mario Carneiro, 17-Jun-2013.) $)
    grutsk1 $p |- ( ( T e. Tarski /\ Tr T ) -> T e. Univ ) $=
      ( vx vy ctsk wcel wtr wa cgru cv cpw cpr wral crn cuni cmap w3a ralrimiva
      co adantlr wb simpr tskpw tskpr 3expa wf elmapg tskurn 3expia sylbid 3jca
      ralrimiv elgrug adantr mpbir2and ) ADEZAFZGZAHEZUPBIZJAEZUSCIZKAEZCALZVAM
      NAEZCAUSORZLZPZBALZUOUPUAUQVGBAUQUSAEZGZUTVCVFUOVIUTUPUSAUBSUOVIVCUPUOVIG
      VBCAUOVIVAAEVBUSVAAUCUDQSVJVDCVEVJVAVEEZUSAVAUEZVDUOVIVKVLTUPAUSVADAUFSUQ
      VIVLVDUSAVAUGUHUIUKUJQUOURUPVHGTUPBCADULUMUN $.
  $}

  ${
    $d x y z $.
    $( Grothendieck's universes are the same as transitive Tarski's classes.
       (The proof in the forward direction requires Foundation.)  (Contributed
       by Mario Carneiro, 24-Jun-2013.) $)
    grutsk $p |- Univ = { x e. Tarski | Tr x } $=
      ( vy cgru cv wtr ctsk crab wcel wa c0 wceq 0tsk eleq1 mpbiri a1i wne con0
      wi cin cr1 cfv cima cuni cvv vex unir1 eleqtrri grur1 mpan2 adantr gruina
      eqid cina inatsk syl eqeltrd ex pm2.61dne grutr grutsk1 impbii treq elrab
      jca bitr4i eqriv ) BCADZEZAFGZBDZCHZVJFHZVJEZIZVJVIHVKVNVKVLVMVKVLVJJVJJK
      ZVLRVKVOVLJFHLVJJFMNOVKVJJPZVLVKVPIZVJVJQSZTUAZFVKVJVSKZVPVKVJTQUBUCZHVTV
      JUDWABUEUFUGVRVJVRULZUHUIUJVQVRUMHVSFHVRVJWBUKVRUNUOUPUQURVJUSVDVJUTVAVHV
      MAVJFVGVJVBVCVEVF $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
          ZFC Set Theory plus the Tarski-Grothendieck Axiom
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Introduce the Tarski-Grothendieck Axiom
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u f $.
    $( The Tarski-Grothendieck Axiom.  For every set ` x ` there is an
       inaccessible cardinal ` y ` such that ` y ` is not in ` x ` .  The
       addition of this axiom to ZFC set theory provides a framework for
       category theory, thus for all practical purposes giving us a complete
       foundation for "all of mathematics."  This version of the axiom is used
       by the Mizar project
       ( ~ http://www.mizar.org/JFM/Axiomatics/tarski.html ).  Unlike the ZFC
       axioms, this axiom is very long when expressed in terms of primitive
       symbols - see ~ grothprim .  An open problem is finding a shorter
       equivalent.  (Contributed by NM, 18-Mar-2007.) $)
    ax-groth $a |- E. y ( x e. y /\ A. z e. y ( A. w ( w C_ z -> w e. y ) /\
                       E. w e. y A. v ( v C_ z -> v e. w ) ) /\
                     A. z ( z C_ y -> ( z ~~ y \/ z e. y ) ) ) $.

    $( The Tarski-Grothendieck axiom using abbreviations.  (Contributed by NM,
       22-Jun-2009.) $)
    axgroth5 $p |- E. y ( x e. y /\ A. z e. y ( ~P z C_ y
             /\ E. w e. y ~P z C_ w ) /\ A. z e. ~P y ( z ~~ y \/ z e. y ) ) $=
      ( vv wel cv cpw wss wrex wa wral cen wbr wo w3a wex wi wal pwss biid wcel
      ax-groth rexbii ralbii df-ral vex elpw imbi1i albii bitri 3anbi123i exbii
      anbi12i mpbir ) ABFZCGZHZBGZIZURDGZIZDUSJZKZCUSLZUQUSMNCBFOZCUSHZLZPZBQUP
      VAUQIDBFRDSZEGUQIEDFRESZDUSJZKZCUSLZUQUSIZVFRZCSZPZBQABCDEUCVIVRBUPUPVEVN
      VHVQUPUAVDVMCUSUTVJVCVLDUQUSTVBVKDUSEUQVATUDUNUEVHUQVGUBZVFRZCSVQVFCVGUFV
      TVPCVSVOVFUQUSCUGUHUIUJUKULUMUO $.

    $( Alternate version of the Tarski-Grothendieck Axiom.  (Contributed by NM,
       18-Mar-2007.) $)
    axgroth2 $p |- E. y ( x e. y /\ A. z e. y ( A. w ( w C_ z -> w e. y ) /\
                       E. w e. y A. v ( v C_ z -> v e. w ) ) /\
                     A. z ( z C_ y -> ( y ~<_ z \/ z e. y ) ) ) $=
      ( wel cv wss wi wal wrex wa wral cdom wbr wo w3a wex cen cvv ax-groth vex
      wcel ssdomg ax-mp biantrurd sbthb syl6bb orbi1d pm5.74i albii exbii mpbir
      3anbi3i ) ABFZDGCGZHDBFIDJEGUPHEDFIEJDBGZKLCUQMZUPUQHZUQUPNOZCBFZPZIZCJZQ
      ZBRUOURUSUPUQSOZVAPZIZCJZQZBRABCDEUAVEVJBVDVIUOURVCVHCUSVBVGUSUTVFVAUSUTU
      PUQNOZUTLVFUSVKUTUQTUCUSVKIBUBUPUQTUDUEUFUPUQUGUHUIUJUKUNULUM $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Derive the Power Set, Infinity and Choice Axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Derive the Axiom of Power Sets ~ ax-pow from the Tarski-Grothendieck
       axiom ~ ax-groth .  That it follows is mentioned by Bob Solovay at
       ~ http://www.cs.nyu.edu/pipermail/fom/2008-March/012783.html .  Note
       that ~ ax-pow is not used by the proof.  (Contributed by G&eacute;rard
       Lang, 22-Jun-2009.) $)
    grothpw $p |- E. y A. z ( A. w ( w e. z -> w e. x ) -> z e. y ) $=
      ( cv cpw cvv wcel wel wi wal wex wss wrex wa wral wceq pweq exlimiv bitri
      cen wbr w3a axgroth5 simpl ralimi sseq1d rspccv syl anim2i 3adant3 pm3.35
      vex ssex 3syl ax-mp pwidg eleq2d spcegv mpd elex impbii elpw2 pwss imbi1i
      wo dfss2 albii exbii mpbi ) AEZFZGHZDCIDAIJDKZCBIZJZCKZBLZABIZCEZFZBEZMZW
      ADEMDWBNZOZCWBPZVTWBUAUBVOVFCWBFZPZUCZBLVMABCDUDWIVMBWIVSVSVLWBMZJZOZWJVM
      VSWFWLWHWFWKVSWFWCCWBPWKWEWCCWBWCWDUEUFWCWJCVKWBVTVKQWAVLWBVTVKRUGUHUIUJU
      KVSWJULVLWBBUMZUNUOSUPVMVLWGHZBLZVRVMWOVMVLVLFZHZWOVLGUQWNWQBVLGWBVLQWGWP
      VLWBVLRURUSUTWNVMBVLWGVASVBWNVQBWNWJVQVLWBWMVCWJVTVKMZVOJZCKVQCVKWBVDWSVP
      CWRVNVODVTVKVGVEVHTTVITVJ $.

    $( Derive the Axiom of Power Sets from the Tarski-Grothendieck axiom
       ~ ax-groth .  Note that ~ ax-pow is not used by the proof.  Use ~ axpweq
       to obtain ~ ax-pow .  (Contributed by G&eacute;rard Lang,
       22-Jun-2009.) $)
    grothpwex $p |- ~P x e. _V $=
      ( vy vz vw cv wcel cpw wss wrex wa wral cen wbr wo w3a wex axgroth5 simpl
      cvv wi ralimi weq pweq sseq1d rspccv syl anim2i 3adant3 ssex 3syl exlimiv
      pm3.35 vex ax-mp ) AEZBEZFZCEZGZUPHZUSDEHDUPIZJZCUPKZURUPLMURUPFNCUPGKZOZ
      BPUOGZSFZABCDQVEVGBVEUQUQVFUPHZTZJZVHVGUQVCVJVDVCVIUQVCUTCUPKVIVBUTCUPUTV
      ARUAUTVHCUOUPCAUBUSVFUPURUOUCUDUEUFUGUHUQVHULVFUPBUMUIUJUKUN $.

    $( The Tarski-Grothendieck axiom using abbreviations.  This version is
       called Tarski's axiom: given a set ` x ` , there exists a set ` y `
       containing ` x ` , the subsets of the members of ` y ` , the power sets
       of the members of ` y ` , and the subsets of ` y ` of cardinality less
       than that of ` y ` .  (Contributed by NM, 21-Jun-2009.) $)
    axgroth6 $p |- E. y ( x e. y /\ A. z e. y ( ~P z C_ y /\ ~P z e. y )
                   /\ A. z e. ~P y ( z ~< y -> z e. y ) ) $=
      ( vw vv wel cv cpw wss wcel wa wral wbr wi w3a wex wb wceq pweq sylbi cen
      csdm wrex axgroth5 biid sseq1d cbvralv ssid sseq2 rspcev mpan2 rspccv wal
      wo pwss vex pwex sseq1 imbi12d spcv syl6 rexlimdv impbid2 ralbidv pm5.32i
      eleq1 r19.26 3bitr4i elpw wn cdom impexp cvv ssdomg pm4.71i imbi1i brsdom
      ax-mp bitri imbi2i 3bitr4ri pm5.74ri pm4.64 ralbiia 3anbi123i exbii mpbir
      syl6bb ) ABFZCGZHZBGZIZWKWLJZKCWLLZWJWLUBMZCBFZNZCWLHZLZOZBPWIWMWKDGZIZDW
      LUCZKCWLLZWJWLUAMZWQUNZCWSLZOZBPABCDUDXAXIBWIWIWOXEWTXHWIUEWMCWLLZWNCWLLZ
      KXJXDCWLLZKWOXEXJXKXLXJEGZHZWLIZEWLLZXKXLQWMXOCEWLWJXMRWKXNWLWJXMSUFUGXPW
      NXDCWLXPWNXDWNWKWKIZXDWKUHXCXQDWKWLXBWKWKUIUJUKXPXCWNDWLXPDBFXBHZWLIZXCWN
      NZXOXSEXBWLXMXBRXNXRWLXMXBSUFULXSXMXBIZEBFZNZEUMXTEXBWLUOYCXTEWKWJCUPZUQX
      MWKRYAXCYBWNXMWKXBURXMWKWLVFUSUTTVAVBVCVDTVEWMWNCWLVGWMXDCWLVGVHWRXGCWSWJ
      WSJWJWLIZWRXGQWJWLYDVIYEWRXFVJZWQNZXGYEWRYGYEWJWLVKMZKZYGNYEYHYGNZNYEYGNY
      EWRNYEYHYGVLYEYIYGYEYHWLVMJYEYHNBUPWJWLVMVNVRVOVPWRYJYEWRYHYFKZWQNYJWPYKW
      QWJWLVQVPYHYFWQVLVSVTWAWBXFWQWCWHTWDWEWFWG $.

    $( The Tarski-Grothendieck Axiom implies the Axiom of Infinity (in the form
       of ~ omex ).  Note that our proof depends on neither the Axiom of
       Infinity nor Regularity.  (Contributed by Mario Carneiro,
       19-Apr-2013.) $)
    grothomex $p |- om e. _V $=
      ( vy vz vx vw com cr1 cvv wcel con0 wss mp2an c0 cv cpw wral wa wi eleq1d
      wceq cfv cima cres wf1 wf1o r111 omsson f1ores f1of1 ax-mp wex wel anbi1d
      0ex eleq1 exbidv csdm wbr w3a axgroth6 simpr ralimi anim2i 3adant3 eximii
      vtocl wrex wfn wb r1fnon fvelimab csuc weq r10 eleq1i biimpri adantr pweq
      fveq2 rspccv nnon r1suc syl biimprcd com3r adantld finds2 biimpd rexlimiv
      syl6 syl9 sylbi com12 ssrdv vex ssex exlimiv f1dmex ) EFEUAZFEUBZUCZWRGHZ
      EGHEWRWSUDZWTIGFUCEIJZXBUEUFIGEFUGKEWRWSUHUILAMZHZBMZNZXDHZBXDOZPZAUJZXAC
      AUKZXIPZAUJXKCLUMCMZLSZXMXJAXOXLXEXIXNLXDUNULUOXLXGXDJZXHPZBXDOZXFXDUPUQB
      AUKQBXDNOZURXMACABUSXLXRXMXSXRXIXLXQXHBXDXPXHUTVAVBVCVDVEXJXAAXJWRXDJXAXJ
      DWRXDDMZWRHZXJDAUKZYAXNFTZXTSZCEVFZXJYBQZFIVGXCYAYEVHVIUFCIEXTFVJKYDYFCEX
      NEHXJYCXDHZYDYBYGLFTZXDHZXTFTZXDHZXTVKZFTZXDHZXJCDXOYCYHXDXNLFVRRCDVLYCYJ
      XDXNXTFVRRXNYLSYCYMXDXNYLFVRRXEYIXIYIXEYHLXDVMVNVOVPXTEHZXIYKYNQXEXIYKYOY
      NXIYKYJNZXDHZYOYNQXHYQBYJXDXFYJSXGYPXDXFYJVQRVSYOYNYQYOYMYPXDYOXTIHYMYPSX
      TVTXTWAWBRWCWIWDWEWFYDYGYBYCXTXDUNWGWJWHWKWLWMWRXDAWNWOWBWPUIEWRGWSWQK $.

    $( The Tarski-Grothendieck Axiom implies the Axiom of Choice (in the form
       of ~ cardeqv ).  This can be put in a more conventional form via ~ ween
       and ~ dfac8 .  Note that the mere existence of strongly inaccessible
       cardinals doesn't imply AC, but rather the particular form of the
       Tarski-Grothendieck axiom (see
       ~ http://www.cs.nyu.edu/pipermail/fom/2008-March/012783.html ).
       (Contributed by Mario Carneiro, 19-Apr-2013.) $)
    grothac $p |- dom card = _V $=
      ( vy vu vx ccrd cdm cvv cv wcel cpw wss wa wral csdm wbr wi w3a vex ax-mp
      cdom syl2im wex axgroth6 crab weq pweq sseq1d eleq1d anbi12d rspcva rabss
      simpld biimpri canth2 sdomdom ssdomg sylancr numdom expcom 3impia exlimiv
      domtr tskwe mpan 2th eqriv ) ADEZFAGZVFHZVGFHVGBGZHZCGZIZVIJZVLVIHZKZCVIL
      ZVKVIMNZVKVIHOCVIIZLZPZBUAVHABCUBVTVHBVJVPVSVHVJVPKZVGIZVIJZVSVQCVRUCVIJZ
      VHWAWCWBVIHZVOWCWEKCVGVICAUDZVMWCVNWEWFVLWBVIVKVGUEZUFWFVLWBVIWGUGUHUIUKW
      DVSVQCVRVIUJULWCVGVISNZWDVIVFHZVHWCVGWBSNZWBVISNZWHVGWBMNWJVGAQZUMVGWBUNR
      VIFHZWCWKOBQZWBVIFUORVGWBVIVAUPWMWDWIWNCVIFVBVCWIWHVHVIVGUQURTTUSUTRWLVDV
      E $.

    $( Alternate version of the Tarski-Grothendieck Axiom. ~ ax-cc is used to
       derive this version.  (Contributed by NM, 26-Mar-2007.) $)
    axgroth3 $p |- E. y ( x e. y /\ A. z e. y ( A. w ( w C_ z -> w e. y ) /\
                       E. w e. y A. v ( v C_ z -> v e. w ) ) /\
                     A. z ( z C_ y -> ( ( y \ z ) ~<_ z \/ z e. y ) ) ) $=
      ( wel cv wss wi wal wrex wa wral cdom wbr wo w3a wex wb wcel axgroth2 weq
      cdif cuni sseq1 elequ1 imbi12d spv mpi reximi eluni2 sylibr adantl ralimi
      ssid dfss3 com c0 wne ne0i vex dominf sylan ccrd cdm cvv grothac eleqtrri
      infdif2 mp3an12 orbi1d imbi2d albidv sylan2 pm5.32i df-3an 3bitr4i exbii
      syl mpbir ) ABFZDGCGZHDBFIDJZEGZWBHZEDFZIZEJZDBGZKZLZCWIMZWBWIHZWIWBUCWBN
      OZCBFZPZIZCJZQZBRWAWLWMWIWBNOZWOPZIZCJZQZBRABCDEUAWSXDBWAWLLZWRLXEXCLWSXD
      XEWRXCWLWAWIWIUDZHZWRXCSWLWBXFTZCWIMXGWKXHCWIWJXHWCWJCDFZDWIKXHWHXIDWIWHW
      BWBHZXIWBUOWGXJXIIECECUBWEXJWFXIWDWBWBUEECDUFUGUHUIUJDWBWIUKULUMUNCWIXFUP
      ULWAXGLZWQXBCXKWPXAWMXKWNWTWOXKUQWINOZWNWTSZWAWIURUSXGXLWIAGUTWIBVAZVBVCW
      IVDVEZTWBXOTXLXMWIVFXOXNVGVHWBVFXOCVAVGVHWIWBVIVJVSVKVLVMVNVOWAWLWRVPWAWL
      XCVPVQVRVT $.

    $( Alternate version of the Tarski-Grothendieck Axiom. ~ ax-ac is used to
       derive this version.  (Contributed by NM, 16-Apr-2007.) $)
    axgroth4 $p |- E. y ( x e. y /\ A. z e. y E. v e. y A. w ( w C_ z ->
    w e. ( y i^i v ) ) /\ A. z ( z C_ y -> ( ( y \ z ) ~<_ z \/ z e. y ) ) ) $=
      ( vu wel cv wss wi wal wrex wa wral cdif w3a wex weq anbi2i 3bitr2i sseq1
      cdom wbr wo cin wcel axgroth3 elequ2 imbi2d albidv cbvrexv r19.42v elequ1
      imbi12d cbvalv 19.26 pm4.76 elin imbi2i bitr4i albii rexbii 3anbi2i exbii
      ralbii mpbi ) ABGZDHZCHZIZDBGZJZDKZFHZVIIZFDGZJZFKZDBHZLZMZCVSNZVIVSIVSVI
      OVIUBUCCBGUDJCKZPZBQVGVJVHVSEHZUEUFZJZDKZEVSLZCVSNZWCPZBQABCDFUGWDWKBWBWJ
      VGWCWAWICVSWAVMVOFEGZJZFKZEVSLZMVMWNMZEVSLWIVTWOVMVRWNDEVSDERZVQWMFWQVPWL
      VODEFUHUIUJUKSVMWNEVSULWPWHEVSWPVMVJDEGZJZDKZMVLWSMZDKWHWNWTVMWMWSFDFDRVO
      VJWLWRVNVHVIUAFDEUMUNUOSVLWSDUPXAWGDXAVJVKWRMZJWGVJVKWRUQWFXBVJVHVSWEURUS
      UTVATVBTVEVCVDVF $.
  $}

  ${
    $d x y z w v u t h g f n m k j $.
    $( Lemma for ~ grothprim .  Expand the membership of an unordered pair into
       primitives.  (Contributed by NM, 29-Mar-2007.) $)
    grothprimlem $p |- ( { u , v } e. w <-> E. g ( g e. w /\ A. h
      ( h e. g <-> ( h = u \/ h = v ) ) ) ) $=
      ( cv cpr wcel weq wo cab wel wb wal wa wex dfpr2 eleq1i clabel bitri ) CF
      ZBFZGZAFZHECIEBIJZEKZUDHDALEDLUEMENODPUCUFUDEUAUBQRUEEDUDST $.

    $( The Tarski-Grothendieck Axiom ~ ax-groth expanded into set theory
       primitives using 163 symbols (allowing the defined symbols ` /\ ` ,
       ` \/ ` , ` <-> ` , and ` E. ` ).  An open problem is whether a shorter
       equivalent exists (when expanded to primitives).  (Contributed by NM,
       16-Apr-2007.) $)
    grothprim $p |- E. y ( x e. y /\ A. z ( ( z e. y -> E. v ( v e. y /\
       A. w ( A. u ( u e. w -> u e. z ) -> ( w e. y /\ w e. v ) ) ) ) /\ E. w
      ( ( w e. z -> w e. y ) -> ( A. v ( ( v e. z -> E. t A. u ( E. g ( g e. w
      /\ A. h ( h e. g <-> ( h = v \/ h = u ) ) ) -> u = t ) ) /\ ( v e. y ->
      ( v e. z \/ E. u ( u e. z /\ E. g ( g e. w /\ A. h ( h e. g <-> ( h = u
      \/ h = v ) ) ) ) ) ) ) \/ z e. y ) ) ) ) $=
      ( wel cv wcel wi wal wrex wral wo wex wa bitri wss cin cdif cdom axgroth4
      wbr w3a weq wb 3anass dfss2 imbi12i albii rexbii df-rex ralbii df-ral cpr
      elin wmo cvv vex difexg ax-mp incom disjdif eqtri brdom6disj orbi1i 19.44
      c0 nfv bitr4i 19.35 grothprimlem mobii wn eldif pm5.6 anbi12i 19.26 exbii
      mo2 imbi2i anbi2i mpbi ) ABJZDKZCKZUAZWHBKZEKZUBLZMZDNZEWKOZCWKPZWIWKUAZW
      KWIUCZWIUDUFZCBJZQZMZCNZUGZBRWGXAEBJZFDJFCJZMFNZDBJZDEJSZMZDNZSERZMZDCJXI
      MZECJZHDJZIHJZIEUHZIFUHZQUIINSHRZFGUHMFNGRZMZXFXPXGXQXRXTXSQUIINSHRZSFRZQ
      MZSENZXAQZMZDRZSCNZSZBRABCDEUEXEYLBXEWGWQXDSZSYLWGWQXDUJYMYKWGYMXNCNZYJCN
      ZSYKWQYNXDYOWQXMCWKPYNWPXMCWKWPXLEWKOXMWOXLEWKWNXKDWJXHWMXJFWHWIUKWHWKWLU
      SULUMUNXLEWKUOTUPXMCWKUQTXCYJCXCXOWLFKZURWHLZFUTZEWIPZYPWLURWHLZFWIOZEWSP
      ZSZXAQZMZDRZYJXCXODNZUUDDRZMUUFWRUUGXBUUHDWIWKUKXBUUCDRZXAQUUHWTUUIXAEFWS
      WIDWKVALWSVALBVBWKWIVAVCVDCVBWSWIUBWIWSUBVKWSWIVEWIWKVFVGVHVIUUCXADXADVLV
      JVMULXOUUDDVNVMUUEYIDUUDYHXOUUCYGXAUUCYCENZYFENZSYGYSUUJUUBUUKYSYBEWIPUUJ
      YRYBEWIYRYAFUTYBYQYAFDFEHIVOVPYAFGYAGVLWCTUPYBEWIUQTUUBWLWSLZUUAMZENUUKUU
      AEWSUQUUMYFEUUMXFXPVQSZYEMYFUULUUNUUAYEWLWKWIVRUUAYDFWIOYEYTYDFWIDEFHIVOU
      NYDFWIUOTULXFXPYEVSTUMTVTYCYFEWAVMVIWDWBTUMVTXNYJCWAVMWETWBWF $.
  $}

  ${
    $d T w x y z $.
    $( The Tarski-Grothendieck Axiom, using abbreviations.  (Contributed by
       Mario Carneiro, 28-May-2013.) $)
    grothtsk $p |- U. Tarski = _V $=
      ( vw vx vy vz ctsk cuni cvv cv wcel wa wex cpw wss wrex wral cen wo mpbir
      wbr vex w3a axgroth5 wb eltskg ax-mp anbi2i 3anass bitr4i exbii eluni 2th
      eqriv ) AEFZGAHZUMIZUNGIUOUNBHZIZUPEIZJZBKZUTUQCHZLZUPMVBDHMDUPNJCUPOZVAU
      PPSVAUPIQCUPLOZUAZBKABCDUBUSVEBUSUQVCVDJZJVEURVFUQUPGIURVFUCBTCDUPGUDUEUF
      UQVCVDUGUHUIRBUNEUJRATUKUL $.
  $}

  ${
    $d w x y z $.
    $( An equivalent to the Tarski-Grothendieck Axiom: there is a proper class
       of inaccessible cardinals.  (Contributed by Mario Carneiro,
       9-Jun-2013.) $)
    inaprc $p |- Inacc e/ _V $=
      ( vx vy vz vw cina cvv cuni con0 cv wcel ssriv wrex ctsk eluni2 wa sylan2
      wss ccrd adantl wb wnel wceq word cwina inawina syl ssorduni ordsson mp2b
      winaon vex grothtsk eleqtrri mpbi cfv c0 wne ne0i tskcard wbr tsksdom cdm
      tskwe2 adantr cardsdomel mpbid eleq2 rspcev syl2anc rexlimdvaa mpi sylibr
      csdm eqssi ssonprc ax-mp mpbir ) EFUAZEGZHUBZVSHEHQZVSUCVSHQAEHAIZEJWBUDJ
      WBHJWBUEWBUJUFKZEUGVSUHUIBHVSBIZHJZWDCIZJZCELZWDVSJWEWDDIZJZDMLZWHWDMGZJW
      KWDFWLBUKULUMDWDMNUNWEWJWHDMWEWIMJZWJOZOZWIRUOZEJZWDWPJZWHWNWQWEWJWMWIUPU
      QWQWIWDURWIUSPSWOWDWIVMUTZWRWNWSWEWDWIVASWNWEWIRVBJZWSWRTWMWTWJWIVCVDWDWI
      VEPVFWGWRCWPEWFWPWDVGVHVIVJVKCWDENVLKVNWAVRVTTWCEVOVPVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Tarski map function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c tarskiMap $.
  $( A function whose value is the smallest Tarski's class
     containing a particular set. $)

  $( Extend class definition to include the map whose value is the smallest
     Tarski's class. $)
  ctskm $a class tarskiMap $.

  ${
    $d x y $.
    $( A function that maps a set ` x ` to the smallest Tarski's class that
       contains the set.  (Contributed by FL, 30-Dec-2010.) $)
    df-tskm $a |- tarskiMap = ( x e. _V |-> |^| { y e. Tarski | x e. y } ) $.
  $}

  ${
    $d A x y $.
    $( Value of our tarski map.  (Contributed by FL, 30-Dec-2010.)  (Revised by
       Mario Carneiro, 20-Sep-2014.) $)
    tskmval $p |- ( A e. V ->
      ( tarskiMap ` A ) = |^| { x e. Tarski | A e. x } ) $=
      ( vy wcel cvv ctsk crab cint ctskm wceq elex wrex cuni grothtsk syl6eleqr
      cv cfv eluni2 sylib intexrab eleq1 rabbidv inteqd df-tskm fvmptg syl2anc
      ) BCEZBFEBAQZEZAGHZIZFEZBJRULKBCLZUHUJAGMZUMUHBGNZEUOUHBFUPUNOPABGSTUJAGU
      ATDBDQZUIEZAGHZIULFFJUQBKZUSUKUTURUJAGUQBUIUBUCUDDAUEUFUG $.

    $( The set ` A ` is an element of the smallest Tarski's class that contains
       ` A ` .  CLASSES1 th. 5.  (Contributed by FL, 30-Dec-2010.)  (Proof
       shortened by Mario Carneiro, 21-Sep-2014.) $)
    tskmid $p |- ( A e. V -> A e. ( tarskiMap ` A ) ) $=
      ( vx wcel cv ctsk crab cint ctskm cfv wi wral id elintrabg mpbiri tskmval
      rgenw eleqtrrd ) ABDZAACEDZCFGHZAIJSAUADTTKZCFLUBCFTMQTCAFBNOCABPR $.

    $( A Tarski's class that contains ` A ` is a Tarski's class.  (Contributed
       by FL, 17-Apr-2011.)  (Proof shortened by Mario Carneiro,
       21-Sep-2014.) $)
    tskmcl $p |- ( tarskiMap ` A ) e. Tarski $=
      ( vx cvv wcel ctskm cfv ctsk cv crab cint tskmval wss c0 ssrab2 wrex cuni
      wne id grothtsk syl6eleqr eluni2 sylib rabn0 sylibr sylancr eqeltrd fvprc
      inttsk wn 0tsk syl6eqel pm2.61i ) ACDZAEFZGDUMUNABHDZBGIZJZGBACKUMUPGLUPM
      QZUQGDUOBGNUMUOBGOZURUMAGPZDUSUMACUTUMRSTBAGUAUBUOBGUCUDUPUHUEUFUMUIUNMGA
      EUGUJUKUL $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( Being a part of ` ( tarskiMap `` A ) ` .  (Contributed by FL,
       17-Apr-2011.)  (Proof shortened by Mario Carneiro, 20-Sep-2014.) $)
    sstskm $p |- ( A e. V -> ( B C_ ( tarskiMap ` A ) <->
      A. x e. Tarski ( A e. x -> B C_ x ) ) ) $=
      ( wcel ctskm cfv wss cv ctsk cab cint wral crab tskmval df-rab inteqi wal
      wa wi syl6eq sseq2d impexp albii ssintab df-ral 3bitr4i syl6bb ) BDEZCBFG
      ZHCAIZJEZBUKEZSZAKZLZHZUMCUKHZTZAJMZUIUJUPCUIUJUMAJNZLUPABDOVAUOUMAJPQUAU
      BUNURTZARULUSTZARUQUTVBVCAULUMURUCUDUNACUEUSAJUFUGUH $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d V y $.  $d W y $.
    $( Belonging to ` ( tarskiMap `` A ) ` .  (Contributed by FL,
       17-Apr-2011.)  (Proof shortened by Mario Carneiro, 21-Sep-2014.) $)
    eltskm $p |- ( A e. V -> ( B e. ( tarskiMap ` A ) <->
      A. x e. Tarski ( A e. x -> B e. x ) ) ) $=
      ( wcel ctskm cfv cv ctsk crab cint wi wral tskmval eleq2d cvv elex tskmid
      a1i eleq2 tskmcl wceq imbi12d rspcv ax-mp syl5com syl6 wb elintrabg bitrd
      pm5.21ndd ) BDEZCBFGZEZCBAHZEZAIJKZEZUPCUOEZLZAIMZULUMUQCABDNOULCPEZURVAU
      RVBLULCUQQSULVAUNVBULBUMEZVAUNBDRUMIEVAVCUNLZLBUAUTVDAUMIUOUMUBUPVCUSUNUO
      UMBTUOUMCTUCUDUEUFCUMQUGVBURVAUHLULUPACIPUISUKUJ $.
  $}

$( End of set.mm $)

$( The work below may eventually be broken off as a separate
   module, dedekind.mm. $)

$(
###############################################################################
                     REAL AND COMPLEX NUMBERS
###############################################################################

This section derives the basics of real and complex numbers.
We first construct and axiomitize real and complex numbers
(e.g., ~ ax-resscn ).
After that
we derive their basic properties,
various operations like addition ( ~ df-add ) and sine ( ~ df-sin ),
and subsets such as the integers ( ~ df-z ) and natural numbers ( ~ df-nn ).
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
       Construction and axiomatization of real and complex numbers
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Dedekind-cut construction of real and complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)

  $c N. $. $( Set of positive integers $)

  $c +N $. $( Positive integer addition $)
  $c .N $. $( Positive integer multiplication $)
  $c <N $. $( Positive integer ordering relation $)

  $c +pQ $. $( Positive pre-fraction addition $)
  $c .pQ $. $( Positive pre-fraction multiplication $)
  $c <pQ $. $( Positive pre-fraction ordering relation $)

  $c ~Q $. $( Equivalence relation to construct positive fractions $)
  $c Q. $. $( Set of positive fractions $)
  $c 1Q $. $( Positive fraction constant 1 $)
  $c /Q $. $( Positive fraction equivalence class $)
  $c +Q $. $( Positive fraction addition $)
  $c .Q $. $( Positive fraction multiplication $)
  $c *Q $. $( Positive fraction reciprocal $)
  $c <Q $. $( Positive fraction ordering relation $)

  $c P. $. $( Set of positive reals $)
  $c 1P $. $( Positive real constant 1 $)
  $c +P. $. $( Positive real addition $)
  $c .P. $. $( Positive real multiplication $)
  $c <P $. $( Positive real ordering relation $)

  $c +pR $. $( Signed real pre-addition $)
  $c .pR $. $( Signed real pre-multiplication $)

  $c ~R $. $( Equivalence relation to construct signed reals $)
  $c R. $. $( Set of signed reals $)
  $c 0R $. $( Signed real constant 0 $)
  $c 1R $. $( Signed real constant 1 $)
  $c -1R $. $( Signed real constant minus 1 $)
  $c +R $. $( Signed real addition $)
  $c .R $. $( Signed real multiplication $)
  $c <R $. $( Signed real ordering relation $)
  $c <RR $. $( 'Less than' relation (restricted to non-extended reals) $)

  $c CC $. $( The set of complex numbers (blackboard bold C) $)
  $c RR $. $( The set of real numbers (blackboard bold R) $)
  $c 0 $. $( The real number 0. $)
  $c 1 $. $( The real number 1. $)
  $c _i $. $( Letter i (the imaginary unit = square root of -1) $)
  $c + $. $( Plus (addition) symbol $)
  $c x. $. $( Multiplication symbol (center dot) $)

  $( Extend class notation with new sets (constants) used for positive
     integers: $)

  $( The set of positive integers, which is the set of natural numbers ` om `
     with 0 removed.

     _Note:  This is the start of the Dedekind-cut construction of real and_
     _complex numbers.  The last lemma of the construction is_ ~ mulcnsrec .
     _The actual set of Dedekind cuts is defined by_ ~ df-np . $)
  cnpi $a class N. $.
  $( Positive integer addition. $)
  cpli $a class +N $.
  $( Positive integer multiplication. $)
  cmi $a class .N $.
  $( Positive integer ordering relation. $)
  clti $a class <N $.

  $( Extend class notation with new sets (constants) used in construction of
    positive fractions: $)

  $( Positive pre-fraction addition. $)
  cplpq $a class +pQ $.
  $( Positive pre-fraction multiplication. $)
  cmpq $a class .pQ $.
  $( Positive pre-fraction ordering relation. $)
  cltpq $a class <pQ $.
  $( Equivalence class used to construct positive fractions. $)
  ceq $a class ~Q $.
  $( Set of positive fractions. $)
  cnq $a class Q. $.
  $( The positive fraction constant 1. $)
  c1q $a class 1Q $.
  $( Positive fraction equivalence class. $)
  cerq $a class /Q $.
  $( Positive fraction addition. $)
  cplq $a class +Q $.
  $( Positive fraction multiplication. $)
  cmq $a class .Q $.
  $( Positive fraction reciprocal operation. $)
  crq $a class *Q $.
  $( Positive fraction ordering relation. $)
  cltq $a class <Q $.

  $( Extend class notation with new sets (constants) used in construction of
    positive real numbers: $)

  $( Set of positive reals. $)
  cnp $a class P. $.
  $( Positive real constant 1. $)
  c1p $a class 1P $.
  $( Positive real addition. $)
  cpp $a class +P. $.
  $( Positive real multiplication. $)
  cmp $a class .P. $.
  $( Positive real ordering relation. $)
  cltp $a class <P $.

  $( Extend class notation with new sets (constants) used in construction of
    signed real numbers: $)

  $( Signed real pre-addition. $)
  cplpr $a class +pR $.
  $( Signed real pre-multiplication. $)
  cmpr $a class .pR $.
  $( Equivalence class used to construct signed reals. $)
  cer $a class ~R $.
  $( Set of signed reals. $)
  cnr $a class R. $.
  $( The signed real constant 0. $)
  c0r $a class 0R $.
  $( The signed real constant 1. $)
  c1r $a class 1R $.
  $( The signed real constant -1. $)
  cm1r $a class -1R $.
  $( Signed real addition. $)
  cplr $a class +R $.
  $( Signed real multiplication. $)
  cmr $a class .R $.
  $( Signed real ordering relation. $)
  cltr $a class <R $.

  $( Define the class of positive integers.  This is a "temporary" set used in
     the construction of complex numbers ~ df-c , and is intended to be used
     only by the construction.  (Contributed by NM, 15-Aug-1995.)
     (New usage is discouraged.) $)
  df-ni $a |- N. = ( om \ { (/) } ) $.

  $( Define addition on positive integers.  This is a "temporary" set used in
     the construction of complex numbers ~ df-c , and is intended to be used
     only by the construction.  (Contributed by NM, 26-Aug-1995.)
     (New usage is discouraged.) $)
  df-pli $a |- +N = ( +o |` ( N. X. N. ) ) $.

  $( Define multiplication on positive integers.  This is a "temporary" set
     used in the construction of complex numbers ~ df-c , and is intended to be
     used only by the construction.  (Contributed by NM, 26-Aug-1995.)
     (New usage is discouraged.) $)
  df-mi $a |- .N = ( .o |` ( N. X. N. ) ) $.

  $( Define 'less than' on positive integers.  This is a "temporary" set used
     in the construction of complex numbers ~ df-c , and is intended to be used
     only by the construction.  (Contributed by NM, 6-Feb-1996.)
     (New usage is discouraged.) $)
  df-lti $a |- <N = ( _E i^i ( N. X. N. ) ) $.

  $( Membership in the class of positive integers.  (Contributed by NM,
     15-Aug-1995.)  (New usage is discouraged.) $)
  elni $p |- ( A e. N. <-> ( A e. om /\ A =/= (/) ) ) $=
    ( cnpi wcel com c0 csn cdif wne wa df-ni eleq2i eldifsn bitri ) ABCADEFGZCA
    DCAEHIBNAJKADELM $.

  $( Membership in the class of positive integers.  (Contributed by NM,
     27-Nov-1995.)  (New usage is discouraged.) $)
  elni2 $p |- ( A e. N. <-> ( A e. om /\ (/) e. A ) ) $=
    ( cnpi wcel com c0 wne wa elni word wb nnord ord0eln0 syl pm5.32i bitr4i )
    ABCADCZAEFZGPEACZGAHPRQPAIRQJAKALMNO $.

  $( A positive integer is a natural number.  (Contributed by NM,
     15-Aug-1995.)  (New usage is discouraged.) $)
  pinn $p |- ( A e. N. -> A e. om ) $=
    ( cnpi com c0 csn cdif df-ni difss eqsstri sseli ) BCABCDEZFCGCKHIJ $.

  $( A positive integer is an ordinal number.  (Contributed by NM,
     23-Mar-1996.)  (New usage is discouraged.) $)
  pion $p |- ( A e. N. -> A e. On ) $=
    ( cnpi wcel com con0 pinn nnon syl ) ABCADCAECAFAGH $.

  $( A positive integer is ordinal.  (Contributed by NM, 29-Jan-1996.)
     (New usage is discouraged.) $)
  piord $p |- ( A e. N. -> Ord A ) $=
    ( cnpi wcel com word pinn nnord syl ) ABCADCAEAFAGH $.

  $( The class of positive integers is a set.  (Contributed by NM,
     15-Aug-1995.)  (New usage is discouraged.) $)
  niex $p |- N. e. _V $=
    ( cnpi com omex c0 csn cdif df-ni difss eqsstri ssexi ) ABCABDEZFBGBKHIJ $.

  $( The empty set is not a positive integer.  (Contributed by NM,
     26-Aug-1995.)  (New usage is discouraged.) $)
  0npi $p |- -. (/) e. N. $=
    ( c0 wceq cnpi wcel wn eqid com wne elni simprbi necon2bi ax-mp ) AABACDZEA
    FMAAMAGDAAHAIJKL $.

  $( Ordinal 'one' is a positive integer.  (Contributed by NM, 29-Oct-1995.)
     (New usage is discouraged.) $)
  1pi $p |- 1o e. N. $=
    ( c1o cnpi wcel com c0 wne 1onn 1n0 elni mpbir2an ) ABCADCAEFGHAIJ $.

  $( Positive integer addition in terms of ordinal addition.  (Contributed by
     NM, 27-Aug-1995.)  (New usage is discouraged.) $)
  addpiord $p |- ( ( A e. N. /\ B e. N. ) -> ( A +N B ) = ( A +o B ) ) $=
    ( cnpi wcel wa cop cxp cpli co coa wceq opelxpi cres cfv fvres df-ov df-pli
    fveq1i eqtri 3eqtr4g syl ) ACDBCDEABFZCCGZDZABHIZABJIZKABCCLUDUBJUCMZNZUBJN
    UEUFUBUCJOUEUBHNUHABHPUBHUGQRSABJPTUA $.

  $( Positive integer multiplication in terms of ordinal multiplication.
     (Contributed by NM, 27-Aug-1995.)  (New usage is discouraged.) $)
  mulpiord $p |- ( ( A e. N. /\ B e. N. ) -> ( A .N B ) = ( A .o B ) ) $=
    ( cnpi wcel wa cop cxp cmi co comu wceq opelxpi cres cfv fvres df-ov fveq1i
    df-mi eqtri 3eqtr4g syl ) ACDBCDEABFZCCGZDZABHIZABJIZKABCCLUDUBJUCMZNZUBJNU
    EUFUBUCJOUEUBHNUHABHPUBHUGRQSABJPTUA $.

  $( 1 is an identity element for multiplication on positive integers.
     (Contributed by NM, 4-Mar-1996.)  (Revised by Mario Carneiro,
     17-Nov-2014.)  (New usage is discouraged.) $)
  mulidpi $p |- ( A e. N. -> ( A .N 1o ) = A ) $=
    ( cnpi wcel c1o cmi co comu wceq 1pi mulpiord mpan2 com pinn nnm1 syl eqtrd
    ) ABCZADEFZADGFZAQDBCRSHIADJKQALCSAHAMANOP $.

  $( Positive integer 'less than' in terms of ordinal membership.  (Contributed
     by NM, 6-Feb-1996.)  (Revised by Mario Carneiro, 28-Apr-2015.)
     (New usage is discouraged.) $)
  ltpiord $p |- ( ( A e. N. /\ B e. N. ) -> ( A <N B <-> A e. B ) ) $=
    ( clti wbr cep cnpi cxp cin wcel wa df-lti breqi brinxp epelg adantl bitr3d
    wb syl5bb ) ABCDABEFFGHZDZAFIZBFIZJZABIZABCSKLUCABEDZTUDABFFEMUBUEUDQUAABFN
    OPR $.

  $( Positive integer 'less than' is a strict ordering.  (Contributed by NM,
     8-Feb-1996.)  (Proof shortened by Mario Carneiro, 10-Jul-2014.)
     (New usage is discouraged.) $)
  ltsopi $p |- <N Or N. $=
    ( cnpi clti wor cep con0 wss com c0 csn cdif df-ni difss omsson eqsstri wwe
    sstri epweon weso ax-mp soss mp2 cxp cin wceq wb df-lti soeq1 soinxp bitr4i
    mpbir ) ABCZADCZAEFEDCZULAGHIZJZEKUOGEGUNLMPNEDOUMQEDRSAEDTUAUKADAAUBUCZCZU
    LBUPUDUKUQUEUFABUPUGSADUHUIUJ $.

  $( Positive integer 'less than' is a relation on positive integers.
     (Contributed by NM, 8-Feb-1996.)  (New usage is discouraged.) $)
  ltrelpi $p |- <N C_ ( N. X. N. ) $=
    ( clti cep cnpi cxp cin df-lti inss2 eqsstri ) ABCCDZEIFBIGH $.

  $( Domain of addition on positive integers.  (Contributed by NM,
     26-Aug-1995.)  (New usage is discouraged.) $)
  dmaddpi $p |- dom +N = ( N. X. N. ) $=
    ( coa cnpi cxp cres cdm con0 cin cpli dmres wfn wceq fnoa fndm ax-mp ineq2i
    eqtri df-pli dmeqi wss com wa c0 csn df-ni difss eqsstri omsson sstri anidm
    cdif mpbir xpss12 dfss mpbi 3eqtr4i ) ABBCZDZEZUPFFCZGZHEUPURUPAEZGUTAUPIVA
    USUPAUSJVAUSKLUSAMNOPHUQQRUPUSSZUPUTKBFSZVCUAZVBVDVCBTFBTUBUCZUJTUDTVEUEUFU
    GUHVCUIUKBFBFULNUPUSUMUNUO $.

  $( Domain of multiplication on positive integers.  (Contributed by NM,
     26-Aug-1995.)  (New usage is discouraged.) $)
  dmmulpi $p |- dom .N = ( N. X. N. ) $=
    ( comu cnpi cxp cres cdm con0 cin cmi dmres wfn wceq fnom fndm ax-mp ineq2i
    eqtri df-mi dmeqi wss com wa c0 cdif df-ni difss eqsstri omsson sstri anidm
    csn mpbir xpss12 dfss mpbi 3eqtr4i ) ABBCZDZEZUPFFCZGZHEUPURUPAEZGUTAUPIVAU
    SUPAUSJVAUSKLUSAMNOPHUQQRUPUSSZUPUTKBFSZVCUAZVBVDVCBTFBTUBUJZUCTUDTVEUEUFUG
    UHVCUIUKBFBFULNUPUSUMUNUO $.

  $( Closure of addition of positive integers.  (Contributed by NM,
     18-Oct-1995.)  (New usage is discouraged.) $)
  addclpi $p |- ( ( A e. N. /\ B e. N. ) -> ( A +N B ) e. N. ) $=
    ( cnpi wcel wa cpli co coa addpiord com pinn wne nnacl sylan2 elni2 nnaordi
    c0 wi ne0i syl6 expcom imp32 sylan2b elni sylanbrc sylan eqeltrd ) ACDZBCDZ
    EABFGABHGZCABIUHAJDZUIUJCDZAKUKUIEUJJDZUJQLZULUIUKBJDZUMBKABMNUIUKUOQBDZEUN
    BOUKUOUPUNUOUKUPUNRUOUKEUPAQHGZUJDUNQBAPUJUQSTUAUBUCUJUDUEUFUG $.

  $( Closure of multiplication of positive integers.  (Contributed by NM,
     18-Oct-1995.)  (New usage is discouraged.) $)
  mulclpi $p |- ( ( A e. N. /\ B e. N. ) -> ( A .N B ) e. N. ) $=
    ( cnpi wcel wa cmi co comu mulpiord com wne pinn nnmcl syl2an elni2 simprbi
    c0 adantl wi adantr nnmordi syl21anc mpd ne0i syl elni sylanbrc eqeltrd ) A
    CDZBCDZEZABFGABHGZCABIUKULJDZULQKZULCDUIAJDZBJDZUMUJALZBLZABMNUKAQHGZULDZUN
    UKQBDZUTUJVAUIUJUPVABOPRUKUPUOQADZVAUTSUJUPUIURRUIUOUJUQTUIVBUJUIUOVBAOPTQB
    AUAUBUCULUSUDUEULUFUGUH $.

  $( Addition of positive integers is commutative.  (Contributed by NM,
     27-Aug-1995.)  (New usage is discouraged.) $)
  addcompi $p |- ( A +N B ) = ( B +N A ) $=
    ( cnpi wcel wa cpli wceq coa com pinn nnacom syl2an addpiord ancoms 3eqtr4d
    co dmaddpi ndmovcom pm2.61i ) ACDZBCDZEZABFPZBAFPZGUBABHPZBAHPZUCUDTAIDBIDU
    EUFGUAAJBJABKLABMUATUDUFGBAMNOABCFQRS $.

  $( Addition of positive integers is associative.  (Contributed by NM,
     27-Aug-1995.)  (New usage is discouraged.) $)
  addasspi $p |- ( ( A +N B ) +N C ) = ( A +N ( B +N C ) ) $=
    ( cnpi wcel w3a cpli co wceq coa com pinn nnaass syl3an wa addclpi addpiord
    sylan oveq1d eqtrd adantr 3impa sylan2 oveq2d adantl 3impb 3eqtr4d ndmovass
    dmaddpi 0npi pm2.61i ) ADEZBDEZCDEZFZABGHZCGHZABCGHZGHZIUOABJHZCJHZABCJHZJH
    ZUQUSULAKEUMBKEUNCKEVAVCIALBLCLABCMNULUMUNUQVAIULUMOZUNOUQUPCJHZVAVDUPDEUNU
    QVEIABPUPCQRVDVEVAIUNVDUPUTCJABQSUATUBULUMUNUSVCIULUMUNOZOUSAURJHZVCVFULURD
    EUSVGIBCPAURQUCVFVGVCIULVFURVBAJBCQUDUETUFUGABCDGUIUJUHUK $.

  $( Multiplication of positive integers is commutative.  (Contributed by NM,
     21-Sep-1995.)  (New usage is discouraged.) $)
  mulcompi $p |- ( A .N B ) = ( B .N A ) $=
    ( cnpi wcel wa cmi wceq comu com pinn nnmcom syl2an mulpiord ancoms 3eqtr4d
    co dmmulpi ndmovcom pm2.61i ) ACDZBCDZEZABFPZBAFPZGUBABHPZBAHPZUCUDTAIDBIDU
    EUFGUAAJBJABKLABMUATUDUFGBAMNOABCFQRS $.

  $( Multiplication of positive integers is associative.  (Contributed by NM,
     21-Sep-1995.)  (New usage is discouraged.) $)
  mulasspi $p |- ( ( A .N B ) .N C ) = ( A .N ( B .N C ) ) $=
    ( cnpi wcel w3a cmi co wceq comu com pinn nnmass syl3an wa mulclpi mulpiord
    sylan oveq1d eqtrd adantr 3impa sylan2 oveq2d adantl 3impb 3eqtr4d ndmovass
    dmmulpi 0npi pm2.61i ) ADEZBDEZCDEZFZABGHZCGHZABCGHZGHZIUOABJHZCJHZABCJHZJH
    ZUQUSULAKEUMBKEUNCKEVAVCIALBLCLABCMNULUMUNUQVAIULUMOZUNOUQUPCJHZVAVDUPDEUNU
    QVEIABPUPCQRVDVEVAIUNVDUPUTCJABQSUATUBULUMUNUSVCIULUMUNOZOUSAURJHZVCVFULURD
    EUSVGIBCPAURQUCVFVGVCIULVFURVBAJBCQUDUETUFUGABCDGUIUJUHUK $.

  $( Multiplication of positive integers is distributive.  (Contributed by NM,
     21-Sep-1995.)  (New usage is discouraged.) $)
  distrpi $p |- ( A .N ( B +N C ) ) = ( ( A .N B ) +N ( A .N C ) ) $=
    ( cnpi wcel w3a cpli co cmi wceq coa comu pinn nndi mulpiord addpiord eqtrd
    com wa mulclpi syl3an addclpi sylan2 oveq2d adantl syl2an oveqan12d 3eqtr4d
    3impb 3impdi dmaddpi 0npi dmmulpi ndmovdistr pm2.61i ) ADEZBDEZCDEZFZABCGHZ
    IHZABIHZACIHZGHZJUSABCKHZLHZABLHZACLHZKHZVAVDUPAREUQBREURCREVFVIJAMBMCMABCN
    UAUPUQURVAVFJUPUQURSZSVAAUTLHZVFVJUPUTDEVAVKJBCUBAUTOUCVJVKVFJUPVJUTVEALBCP
    UDUEQUIUPUQURVDVIJUPUQSZUPURSZSVDVBVCKHZVIVLVBDEVCDEVDVNJVMABTACTVBVCPUFVLV
    MVBVGVCVHKABOACOUGQUJUHABCDGIUKULUMUNUO $.

  $( Addition cancellation law for positive integers.  (Contributed by Mario
     Carneiro, 8-May-2013.)  (New usage is discouraged.) $)
  addcanpi $p |- ( ( A e. N. /\ B e. N. ) ->
                 ( ( A +N B ) = ( A +N C ) <-> B = C ) ) $=
    ( cnpi wcel wa cpli co wceq wi addclpi syl5ib imp dmaddpi 0npi coa addpiord
    eleq1 com pinn ndmovrcl simpr 3syl adantr adantlr eqeq12d w3a nnacan biimpd
    syl3an 3expa sylbid sylan2 exp32 imp4b pm2.43i ex oveq2 impbid1 ) ADEZBDEZF
    ZABGHZACGHZIZBCIZVBVEVFVBVEFVFVBVEVBVEVFVBVEVBVEVFJZVEVBFZVBCDEZVGVHVDDEZUT
    VIFVIVEVBVJVBVCDEVEVJABKVCVDDRLMACDGNOUAUTVIUBUCVBVIFZVEABPHZACPHZIZVFVKVCV
    LVDVMVBVCVLIVIABQUDUTVIVDVMIVAACQUEUFUTVAVIVNVFJZUTASEZVABSEZVICSEZVOATBTCT
    VPVQVRUGVNVFABCUHUIUJUKULUMUNUOUPUQBCAGURUS $.

  $( Multiplication cancellation law for positive integers.  (Contributed by
     NM, 4-Feb-1996.)  (Revised by Mario Carneiro, 10-May-2013.)
     (New usage is discouraged.) $)
  mulcanpi $p |- ( ( A e. N. /\ B e. N. ) ->
                 ( ( A .N B ) = ( A .N C ) <-> B = C ) ) $=
    ( cnpi wcel wa cmi co wceq wi mulclpi eleq1 syl5ib comu mulpiord com sylan2
    pinn ex pm2.43i imp dmmulpi 0npi ndmovrcl simpr 3syl adantr adantlr eqeq12d
    w3a elni2 simprbi nnmcan biimpd syl3an com4r imp31 sylbid exp32 imp4b oveq2
    c0 3exp impbid1 ) ADEZBDEZFZABGHZACGHZIZBCIZVGVJVKVGVJFVKVGVJVGVJVKVGVJVGVJ
    VKJZVJVGFZVGCDEZVLVMVIDEZVEVNFVNVJVGVOVGVHDEVJVOABKVHVIDLMUAACDGUBUCUDVEVNU
    EUFVGVNFZVJABNHZACNHZIZVKVPVHVQVIVRVGVHVQIVNABOUGVEVNVIVRIVFACOUHUIVEVFVNVS
    VKJZVEVFVNVTJJVEVFVNVEVTVEVFVNVEVTJZVEAPEZVFBPEZVNCPEZWAARBRCRWBWCWDUJZVEVT
    VEWEVBAEZVTVEWBWFAUKULWEWFFVSVKABCUMUNQSUOVCUPTUQURQUSUTTSBCAGVAVD $.

  $( There is no identity element for addition on positive integers.
     (Contributed by NM, 28-Nov-1995.)  (New usage is discouraged.) $)
  addnidpi $p |- ( A e. N. -> -. ( A +N B ) = A ) $=
    ( cnpi wcel wa cpli co wceq wn wi coa com pinn c0 elni2 nnaordi nna0 eleq1d
    con2d eqeq1d word nnord ordirr eleq2 notbid syl5ibrcom sylbid adantl expcom
    syl syld imp32 sylan2b sylan addpiord mtbird dmaddpi ndmov 0npi eleq1 mtbii
    a1d syl6bi pm2.61i ) ACDZBCDZEZVEABFGZAHZIZJVGVJVEVGVIABKGZAHZVEALDZVFVLIZA
    MVFVMBLDZNBDZEVNBOVMVOVPVNVOVMVPVNJVOVMEVPANKGZVKDZVNNBAPVMVRVNJVOVMVRAVKDZ
    VNVMVQAVKAQRVMVLVSVMVSIVLAADZIZVMAUAWAAUBAUCUJVLVSVTVKAAUDUEUFSUGUHUKUIULUM
    UNVGVHVKAABUOTUPVBVGIZVIVEWBVINAHZVEIWBVHNAABCFUQURTWCNCDVEUSNACUTVAVCSVD
    $.

  ${
    $d x A $.  $d x B $.
    $( Ordering on positive integers in terms of existence of sum.
       (Contributed by NM, 15-Mar-1996.)  (Revised by Mario Carneiro,
       14-Jun-2013.)  (New usage is discouraged.) $)
    ltexpi $p |- ( ( A e. N. /\ B e. N. ) ->
               ( A <N B <-> E. x e. N. ( A +N x ) = B ) ) $=
      ( cnpi wcel wa c0 cv coa wceq com wrex clti wbr cpli pinn nnaordex syl2an
      co wb ltpiord addpiord eqeq1d pm5.32da elni2 anbi1i anass syl6bb rexbidv2
      bitri adantr 3bitr4d ) BDEZCDEZFBCEZGAHZEZBUPISZCJZFZAKLZBCMNBUPOSZCJZADL
      ZUMBKECKEUOVATUNBPCPABCQRBCUAUMVDVATUNUMVCUTADKUMUPDEZVCFVEUSFZUPKEZUTFZU
      MVEVCUSUMVEFVBURCBUPUBUCUDVFVGUQFZUSFVHVEVIUSUPUEUFVGUQUSUGUJUHUIUKUL $.
  $}

  $( Ordering property of addition for positive integers.  (Contributed by NM,
     7-Mar-1996.)  (New usage is discouraged.) $)
  ltapi $p |- ( C e. N. -> ( A <N B <-> ( C +N A ) <N ( C +N B ) ) ) $=
    ( clti cnpi cpli dmaddpi wcel wbr co wb coa com pinn ltpiord adantr addclpi
    wa wceq addpiord ltrelpi nnaord syl3an syl2an adantl eleq12d anandis ancoms
    0npi 3expa bitrd 3bitr4d 3impa ndmovord ) ABCDEFGUAUIAEHZBEHZCEHZABDIZCAFJZ
    CBFJZDIZKUOUPRZUQRABHZCALJZCBLJZHZURVAUOUPUQVCVFKZUOAMHUPBMHUQCMHVGANBNCNAB
    CUBUCUJVBURVCKUQABOPUQVBVAVFKZUQUOUPVHUQUORZUQUPRZRZVAUSUTHZVFVIUSEHUTEHVAV
    LKVJCAQCBQUSUTOUDVKUSVDUTVEVIUSVDSVJCATPVJUTVESVICBTUEUFUKUGUHULUMUN $.

  $( Ordering property of multiplication for positive integers.  (Contributed
     by NM, 8-Feb-1996.)  (New usage is discouraged.) $)
  ltmpi $p |- ( C e. N. -> ( A <N B <-> ( C .N A ) <N ( C .N B ) ) ) $=
    ( clti cnpi cmi wcel wbr co wb wa comu com pinn syl2an ltpiord mulclpi wceq
    adantr mulpiord dmmulpi ltrelpi 0npi wi c0 elni2 w3a nnmord sylan9bbr 3exp1
    iba imp4b syl5bi adantl eleq12d bitrd anandis ancoms 3bitr4d 3impa ndmovord
    imp ) ABCDEFUAUBUCAEGZBEGZCEGZABDHZCAFIZCBFIZDHZJVCVDKZVEKABGZCALIZCBLIZGZV
    FVIVJVEVKVNJZVCAMGZBMGZVEVOUDVDANBNVECMGZUECGZKVPVQKVOCUFVPVQVRVSVOVPVQVRVS
    VOVSVKVKVSKVPVQVRUGVNVSVKUKABCUHUIUJULUMOVBVJVFVKJVEABPSVEVJVIVNJZVEVCVDVTV
    EVCKZVEVDKZKZVIVGVHGZVNWAVGEGVHEGVIWDJWBCAQCBQVGVHPOWCVGVLVHVMWAVGVLRWBCATS
    WBVHVMRWACBTUNUOUPUQURUSUTVA $.

  $( One is less than two (one plus one).  (Contributed by NM, 13-Mar-1996.)
     (New usage is discouraged.) $)
  1lt2pi $p |- 1o <N ( 1o +N 1o ) $=
    ( c1o cpli co clti wbr wcel coa c0 com wceq 1onn nna0 ax-mp 0lt1o wb peano1
    nnaord cnpi 1pi mp2an mp3an mpbi eqeltrri addpiord eleqtrri addclpi ltpiord
    mpbir ) AAABCZDEZAUIFZAAAGCZUIAHGCZAULAIFZUMAJKALMHAFZUMULFZNHIFUNUNUOUPOPK
    KHAAQUAUBUCARFZUQUIULJSSAAUDTUEUQUIRFZUJUKOSUQUQURSSAAUFTAUIUGTUH $.

  $( No positive integer is less than one.  (Contributed by NM, 23-Mar-1996.)
     (New usage is discouraged.) $)
  nlt1pi $p |- -. A <N 1o $=
    ( cnpi wcel c1o clti wbr wn c0 wne com elni simprbi wceq wa noel wo ltpiord
    wb 1pi mpan2 csuc df-1o eleq2i elsucg syl5bb biimpa ord mpi ex necon3ad mpd
    bitrd ltrelpi brel simpld con3i pm2.61i ) ABCZADEFZGZURAHIZUTURAJCVAAKLURUS
    AHURUSAHMZURUSNZAHCZGVBAOVCVDVBURUSVDVBPZURUSADCZVEURDBCZUSVFRSADQTVFAHUAZC
    URVEDVHAUBUCAHBUDUEULUFUGUHUIUJUKUSURUSURVGADBBEUMUNUOUPUQ $.

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    indpi.1 $e |- ( x = 1o -> ( ph <-> ps ) ) $.
    indpi.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    indpi.3 $e |- ( x = ( y +N 1o ) -> ( ph <-> th ) ) $.
    indpi.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    indpi.5 $e |- ps $.
    $( Induction hypothesis. $)
    indpi.6 $e |- ( y e. N. -> ( ch -> th ) ) $.
    $( Principle of Finite Induction on positive integers.  (Contributed by NM,
       23-Mar-1996.)  (New usage is discouraged.) $)
    indpi $p |- ( A e. N. -> ta ) $=
      ( cnpi wcel c1o clti wi wa wceq wbr cv 1pi elexi eqvinc mpbiri eqcoms a1i
      gencl com wss pinn c0 elni2 csuc word nnord ordsucss df-1o sseq1i syl6ibr
      syl imp sylbi 1onn eleq1 breq2 anbi12d imbi12d wne peano2b syl6bbr syl5ib
      adantrd wb ltpiord mpan biimpa eleq2 wo elsuci ne0i 0lt1o mpbii jaoi syl5
      syl6bi jcad elni simpr cpli co addclpi mpan2 coa addpiord con0 pion eqtrd
      oa1suc eqeq2d eleq1d syl5ibr pm2.43d biimprd anim12d impbid imbi1d adantr
      biimparc syl6bir com12 pm5.74d bitrd a1ii pm5.32i simplbi2 imim1d ltrelpi
      ex brel ibi jao mpi syl6com imp3a cvv sucssel ax-mp sylbir sylan2 adantlr
      0ex syl9r findsg mpanl2 syl2anc exp3a pm2.43i wn nlt1pi wor ltsopi sotric
      mtbii notnotrd mpjaod ) HOPZHQUAZEQHRUBZUUJESUUIEQHAEFUCZQUAZQHUAFUULHFQH
      QOUDUEZUFLUUMABMIUGZUJUHUIUUIUUKESUUIUUIUUKEUUIHUKPZQHULZUUIUUKTZESZHUMUU
      IUUPUNHPZTUUQHUOUUPUUTUUQUUPUUTUNUPZHULZUUQUUPHUQUUTUVBSHURUNHUSVCQUVAHUT
      VAVBVDVEUUPQUKPZUUQUUSVFUULOPZQUULRUBZTZASZQOPZQQRUBZTZBSGUCZOPZQUVKRUBZT
      ZCSZUVLQUVKUPZRUBZTZDSZUUSFGHQUUMUVFUVJABUUMUVDUVHUVEUVIUULQOVGUULQQRVHVI
      IVJUULUVKUAZUVFUVNACUVTUVDUVLUVEUVMUULUVKOVGUULUVKQRVHVIJVJUULUVPUAZUVGUV
      RASUVSUWAUVFUVRAUWAUVFUVRUWAUVFUVLUVQUWAUVFUVKUKPZUVKUNVKZTUVLUWAUVFUWBUW
      CUWAUVDUWBUVEUVDUULUKPZUWAUWBUULUMUWAUWDUVPUKPUWBUULUVPUKVGUVKVLVMVNVOUVF
      QUULPZUWAUWCUVDUVEUWEUVHUVDUVEUWEVPUDQUULVQVRVSUWAUWEQUVPPZUWCUULUVPQVTUW
      FQUVKPZQUVKUAZWAZUWCQUVKWBZUWGUWCUWHUVKQWCUWHUNUVKPZUWCUWHUNQPUWKWDQUVKUN
      VTWEUVKUNWCVCWFVCWHWGWIUVKWJVBUVFUVEUWAUVQUVDUVEWKUULUVPQRVHZVNWIUWAUVLUV
      DUVQUVEUWAUVLUVDUWAUVLUVLUVDSUVLUVDUWAUVLTZUVKQWLWMZOPZUVLUVHUWOUDUVKQWNW
      OUWMUULUWNOUVLUULUWNUAZUWAUVLUWNUVPUULUVLUWNUVKQWPWMZUVPUVLUVHUWNUWQUAUDU
      VKQWQWOUVLUVKWRPUWQUVPUAUVKWSUVKXAVCWTXBZXKXCXDYAXEUWAUVEUVQUWLXFXGXHXIUW
      AUVRADUVRUWAADVPZUVLUWAUWSSUVQUVLUWAUWPUWSUWRKXLXJXMXNXOUULHUAZUVFUURAEUW
      TUVDUUIUVEUUKUULHOVGUULHQRVHVILVJUVCUVJBMXPUWBQUVKULZUVOUVSSUVCUVOUVRCUWB
      UXATDUVOUVLUVQCUVLUVOUWGCSZUVQCSUVLUWGUVNCUVNUVLUWGUVLUVMUWGUVHUVLUVMUWGV
      PUDQUVKVQVRXQXRXSUVQUWFUXBCUVQUWFUVQUVHUVPOPTUVQUWFVPQUVPOORXTYBQUVPVQVCY
      CUWFUWIUXBCUWJUXBUWHCSUWICSACUUMUWHFUULUVKFQUVKUUNUFJUUOUJUWGCUWHYDYEWGWG
      YFYGUXAUWBUWKCDSZUXAUVAUVKULZUWKQUVAUVKUTVAUNYHPUXDUWKSYNUNUVKYHYIYJVEUWB
      UWKTUVLUXCUVKUONYKYLYOYMYPYQYRYSYTUUIUUJUUKWAZUUIHQRUBZUXEUUAZHUUBUUIUVHU
      XFUXGVPZUDORUUCUUIUVHTUXHUUDOHQRUUEVRWOUUFUUGUUH $.
  $}

  ${
    $d x y z w v u f $.
    $( Define pre-addition on positive fractions.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended to
       be used only by the construction.  This "pre-addition" operation works
       directly with ordered pairs of integers.  The actual positive fraction
       addition ` +Q ` ( ~ df-plq ) works with the equivalence classes of these
       ordered pairs determined by the equivalence relation ` ~Q `
       ( ~ df-enq ).  (Analogous remarks apply to the other "pre-" operations
       in the complex number construction that follows.)  From Proposition
       9-2.3 of [Gleason] p. 117.  (Contributed by NM, 28-Aug-1995.)
       (New usage is discouraged.) $)
    df-plpq $a |- +pQ = ( x e. ( N. X. N. ) , y e. ( N. X. N. ) |->
      <. ( ( ( 1st ` x ) .N ( 2nd ` y ) ) +N
           ( ( 1st ` y ) .N ( 2nd ` x ) ) ) ,
           ( ( 2nd ` x ) .N ( 2nd ` y ) ) >. ) $.

    $( Define pre-multiplication on positive fractions.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  From Proposition 9-2.4 of
       [Gleason] p. 119.  (Contributed by NM, 28-Aug-1995.)
       (New usage is discouraged.) $)
    df-mpq $a |- .pQ = ( x e. ( N. X. N. ) , y e. ( N. X. N. ) |->
        <. ( ( 1st ` x ) .N ( 1st ` y ) ) ,
           ( ( 2nd ` x ) .N ( 2nd ` y ) ) >. ) $.

    $( Define pre-ordering relation on positive fractions.  This is a
       "temporary" set used in the construction of complex numbers ~ df-c , and
       is intended to be used only by the construction.  Similar to Definition
       5 of [Suppes] p. 162.  (Contributed by NM, 28-Aug-1995.)
       (New usage is discouraged.) $)
    df-ltpq $a |- <pQ = { <. x , y >. |
      ( ( x e. ( N. X. N. ) /\ y e. ( N. X. N. ) ) /\
        ( ( 1st ` x ) .N ( 2nd ` y ) ) <N ( ( 1st ` y ) .N ( 2nd ` x ) ) ) } $.

    $( Define equivalence relation for positive fractions.  This is a
       "temporary" set used in the construction of complex numbers ~ df-c , and
       is intended to be used only by the construction.  From Proposition 9-2.1
       of [Gleason] p. 117.  (Contributed by NM, 27-Aug-1995.)
       (New usage is discouraged.) $)
    df-enq $a |- ~Q = { <. x , y >. | ( ( x e. ( N. X. N. ) /\
                   y e. ( N. X. N. ) ) /\ E. z E. w E. v E. u
                   ( ( x = <. z , w >. /\ y = <. v , u >. ) /\
                   ( z .N u ) = ( w .N v ) ) ) } $.

    $( Define class of positive fractions.  This is a "temporary" set used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.  From Proposition 9-2.2 of [Gleason] p. 117.
       (Contributed by NM, 16-Aug-1995.)  (New usage is discouraged.) $)
    df-nq $a |- Q. = { x e. ( N. X. N. ) | A. y e. ( N. X. N. )
      ( x ~Q y -> -. ( 2nd ` y ) <N ( 2nd ` x ) ) } $.

    $( Define a convenience function that "reduces" a fraction to lowest
       terms.  Note that in this form, it is not obviously a function; we prove
       this in ~ nqerf .  (Contributed by NM, 27-Aug-1995.)
       (New usage is discouraged.) $)
    df-erq $a |- /Q = ( ~Q i^i ( ( N. X. N. ) X. Q. ) ) $.

    $( Define addition on positive fractions.  This is a "temporary" set used
       in the construction of complex numbers ~ df-c , and is intended to be
       used only by the construction.  From Proposition 9-2.3 of [Gleason]
       p. 117.  (Contributed by NM, 24-Aug-1995.)
       (New usage is discouraged.) $)
    df-plq $a |- +Q = ( ( /Q o. +pQ ) |` ( Q. X. Q. ) ) $.

    $( Define multiplication on positive fractions.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended to
       be used only by the construction.  From Proposition 9-2.4 of [Gleason]
       p. 119.  (Contributed by NM, 24-Aug-1995.)
       (New usage is discouraged.) $)
    df-mq $a |- .Q = ( ( /Q o. .pQ ) |` ( Q. X. Q. ) ) $.

    $( Define positive fraction constant 1.  This is a "temporary" set used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.  From Proposition 9-2.2 of [Gleason] p. 117.
       (Contributed by NM, 29-Oct-1995.)  (New usage is discouraged.) $)
    df-1nq $a |- 1Q = <. 1o , 1o >. $.

    $( Define reciprocal on positive fractions.  It means the same thing as one
       divided by the argument (although we don't define full division since we
       will never need it).  This is a "temporary" set used in the construction
       of complex numbers ~ df-c , and is intended to be used only by the
       construction.  From Proposition 9-2.5 of [Gleason] p. 119, who uses an
       asterisk to denote this unary operation.  (Contributed by NM,
       6-Mar-1996.)  (New usage is discouraged.) $)
    df-rq $a |- *Q = ( `' .Q " { 1Q } ) $.

    $( Define ordering relation on positive fractions.  This is a "temporary"
       set used in the construction of complex numbers ~ df-c , and is intended
       to be used only by the construction.  Similar to Definition 5 of
       [Suppes] p. 162.  (Contributed by NM, 13-Feb-1996.)
       (New usage is discouraged.) $)
    df-ltnq $a |- <Q = ( <pQ i^i ( Q. X. Q. ) ) $.

  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.
    $( Equivalence relation for positive fractions in terms of positive
       integers.  (Contributed by NM, 27-Aug-1995.)
       (New usage is discouraged.) $)
    enqbreq $p |- ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. ) ) ->
          ( <. A , B >. ~Q <. C , D >. <-> ( A .N D ) = ( B .N C ) ) ) $=
      ( vx vy vz vw vv vu cmi ceq cnpi df-enq ecopoveq ) EFGHIJABCDKLMEFGHIJNO
      $.
  $}

  ${
    $( Equivalence relation for positive fractions in terms of positive
       integers.  (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    enqbreq2 $p |- ( ( A e. ( N. X. N. ) /\ B e. ( N. X. N. ) ) ->
          ( A ~Q B <-> ( ( 1st ` A ) .N ( 2nd ` B ) ) =
                       ( ( 1st ` B ) .N ( 2nd ` A ) ) ) ) $=
      ( cnpi cxp wcel wa ceq wbr c1st cfv c2nd cop cmi co wceq 1st2nd2 wb xp1st
      xp2nd jca breqan12d enqbreq syl2an mulcompi eqeq2i a1i 3bitrd ) ACCDZEZBU
      HEZFZABGHAIJZAKJZLZBIJZBKJZLZGHZULUPMNZUMUOMNZOZUSUOUMMNZOZUIUJAUNBUQGACC
      PBCCPUAUIULCEZUMCEZFUOCEZUPCEZFURVAQUJUIVDVEACCRACCSTUJVFVGBCCRBCCSTULUMU
      OUPUBUCVAVCQUKUTVBUSUMUOUDUEUFUG $.
  $}

  ${
    $d x y z w v u $.
    $( The equivalence relation for positive fractions is an equivalence
       relation.  Proposition 9-2.1 of [Gleason] p. 117.  (Contributed by NM,
       27-Aug-1995.)  (Revised by Mario Carneiro, 6-Jul-2015.)
       (New usage is discouraged.) $)
    enqer $p |- ~Q Er ( N. X. N. ) $=
      ( vx vy vz vw vv vu cmi ceq cnpi df-enq cv mulcompi mulclpi mulasspi wcel
      wa co wceq mulcanpi biimpd ecopover ) ABCDEFGHIABCDEFJAKZBKZLUBUCMUBUCCKZ
      NUBIOUCIOPUBUCGQUBUDGQRUCUDRUBUCUDSTUA $.
  $}

  ${
    $d x y z w v u $.
    $( The equivalence relation for positive fractions exists.  (Contributed by
       NM, 3-Sep-1995.)  (New usage is discouraged.) $)
    enqex $p |- ~Q e. _V $=
      ( vx vy vz vw vv vu ceq cnpi cxp niex xpex cv wcel wa cop wceq cmi co wex
      copab df-enq opabssxp eqsstri ssexi ) GHHIZUEIZUEUEHHJJKZUGKGALZUEMBLZUEM
      NUHCLZDLZOPUIELZFLZOPNUJUMQRUKULQRPNFSESDSCSZNABTUFABCDEFUAUNABUEUEUBUCUD
      $.
  $}

  ${
    $d x y $.
    $( The class of positive fractions exists.  (Contributed by NM,
       16-Aug-1995.)  (Revised by Mario Carneiro, 27-Apr-2013.)
       (New usage is discouraged.) $)
    nqex $p |- Q. e. _V $=
      ( vy vx cnq cv ceq wbr c2nd cfv clti wn cnpi cxp wral crab cvv df-nq niex
      wi xpex rabex eqeltri ) CADZBDZEFUCGHUBGHIFJRBKKLZMZAUDNOABPUEAUDKKQQSTUA
      $.

    $( The empty set is not a positive fraction.  (Contributed by NM,
       24-Aug-1995.)  (Revised by Mario Carneiro, 27-Apr-2013.)
       (New usage is discouraged.) $)
    0nnq $p |- -. (/) e. Q. $=
      ( vy vx c0 cnq wcel cnpi cxp 0nelxp cv ceq wbr c2nd cfv clti wn wral crab
      wi df-nq ssrab2 eqsstri sseli mto ) CDECFFGZEFFHDUDCDAIZBIZJKUFLMUELMNKOR
      BUDPZAUDQUDABSUGAUDTUAUBUC $.

    $( Each positive fraction is an ordered pair of positive integers (the
       numerator and denominator, in "lowest terms".  (Contributed by Mario
       Carneiro, 28-Apr-2013.)  (New usage is discouraged.) $)
    elpqn $p |- ( A e. Q. -> A e. ( N. X. N. ) ) $=
      ( vy vx cnq cnpi cxp cv ceq wbr c2nd cfv clti wn wral crab ssrab2 eqsstri
      wi df-nq sseli ) DEEFZADBGZCGZHIUCJKUBJKLIMRCUANZBUAOUABCSUDBUAPQT $.

    $( Positive fraction 'less than' is a relation on positive fractions.
       (Contributed by NM, 14-Feb-1996.)  (Revised by Mario Carneiro,
       27-Apr-2013.)  (New usage is discouraged.) $)
    ltrelnq $p |- <Q C_ ( Q. X. Q. ) $=
      ( cltq cltpq cnq cxp cin df-ltnq inss2 eqsstri ) ABCCDZEIFBIGH $.
  $}

  ${
    $d A x y $.
    $( The representatives of positive integers as positive fractions.
       (Contributed by NM, 29-Oct-1995.)  (Revised by Mario Carneiro,
       6-May-2013.)  (New usage is discouraged.) $)
    pinq $p |- ( A e. N. -> <. A , 1o >. e. Q. ) $=
      ( vx vy cnpi wcel c1o cv ceq wbr c2nd cfv clti wn wral 1pi mpan2 cvv wceq
      wi breq2d cop cxp crab opelxpi nlt1pi elexi op2ndg mtbiri ralrimivw breq1
      cnq a1d fveq2 notbid imbi12d ralbidv elrab sylanbrc df-nq syl6eleqr ) ADE
      ZAFUAZBGZCGZHIZVDJKZVCJKZLIZMZSZCDDUBZNZBVKUCZUKVAVBVKEZVBVDHIZVFVBJKZLIZ
      MZSZCVKNZVBVMEVAFDEVNOAFDDUDPVAVSCVKVAVRVOVAVQVFFLIVFUEVAVPFVFLVAFQEVPFRF
      DOUFAFDQUGPTUHULUIVLVTBVBVKVCVBRZVJVSCVKWAVEVOVIVRVCVBVDHUJWAVHVQWAVGVPVF
      LVCVBJUMTUNUOUPUQURBCUSUT $.
  $}

  ${
    $d x y $.
    $( The positive fraction 'one'.  (Contributed by NM, 29-Oct-1995.)
       (Revised by Mario Carneiro, 28-Apr-2013.)
       (New usage is discouraged.) $)
    1nq $p |- 1Q e. Q. $=
      ( c1q c1o cop cnq df-1nq cnpi wcel 1pi pinq ax-mp eqeltri ) ABBCZDEBFGLDG
      HBIJK $.
  $}

  ${
    $d A a b x y $.  $d B b x y $.  $d a b c d m x z $.  $d m x y z $.
    $( There is a unique element of ` Q. ` equivalent to each element of
       ` N. X. N. ` .  (Contributed by Mario Carneiro, 28-Apr-2013.)
       (New usage is discouraged.) $)
    nqereu $p |- ( A e. ( N. X. N. ) -> E! x e. Q. x ~Q A ) $=
      ( vy va vb vm vd vz cnpi wcel ceq wbr cnq wrex wa wi wral wceq clti wn vc
      cxp cv weq wreu cop elxp2 wel con0 csuc pion suceloni syl vex sucid eleq2
      rspcev sylancl adantl elequ2 imbi1d 2ralbidv breq2d rexbidv imbi2d elequ1
      opeq1 opeq2 imbi12d cbvral2v ralbii c2nd cfv rexnal pm4.63 ltpiord ancoms
      xp2nd sylan2 adantll anbi2d syl5bb rexbidva syl5bbr w3a c1st xp1st rspccv
      wb ralbidv eleq1 syl6 imp syl5 mpdi 1st2nd2 3ad2ant2 mpbird wer enqer a1i
      simpr simpl ertr4d ex reximdv syl5com 3expia com23 imp3a rexlimdva syl6bi
      3imp com3r com13 cmi mulcompi enqbreq anidms mpbiri opelxpi op2ndd notbid
      co breq1 elrab2 com12 rsp breq2 elpqn fveq2 breq1d rspcva syl2an ad2antrr
      simprbi ad2antlr syl2anc mpbid jca df-nq simplbi2 expcom sylsyld pm2.61d2
      a1dd ralrimivv sylbir tfis2 rexlimdv syl5ibrcom rexlimivv anbi12d syl2anr
      mpd sylbi wo ersym rabeq2i wor ltsopi sotric mpan notnot syl6bbr ord mt3d
      oveq2d syl5eq breqan12d bitrd biimpa eqtrd mulcanpi opeq12d rgen2a vtoclg
      id 3eqtr4d reu4 sylanbrc ) BIIUBZJZAUCZBKLZAMNZUWECUCZBKLZOZACUDZPZCMQAMQ
      ZUWEAMUEUWCBDUCZEUCZUFZRZEINDINUWFDEBIIUGUWPUWFDEIIUWMIJZUWNIJZOZUWFUWPUW
      DUWOKLZAMNZUWSECUHZCUINZUXAUWRUXCUWQUWRUWNUJZUIJZUWNUXDJZUXCUWRUWNUIJUXEU
      WNUKUWNULUMUWNEUNZUOUXBUXFCUXDUIUWGUXDUWNUPUQURUSUWSUXBUXACUIUWGUIJZUWSUX
      BUXAPZUXHUWQUWRUXIUXHUWQUXIEIQZUWRUXIPUXHUXJDIQZUWQUXJPUXKEFUHZUXAPZEIQDI
      QZCFCFUDZUXIUXMDEIIUXOUXBUXLUXACFEUTVAVBUXNFUWGQZUXKPUXHUXPGFUHZUWDUAUCZG
      UCZUFZKLZAMNZPZGIQUAIQZFUWGQZUXKUYDUXNFUWGUYCUXMUXQUWDUWMUXSUFZKLZAMNZPUA
      GDEIIUADUDZUYBUYHUXQUYIUYAUYGAMUYIUXTUYFUWDKUXRUWMUXSVGVCVDVEGEUDZUXQUXLU
      YHUXAGEFVFUYJUYGUWTAMUYJUYFUWOUWDKUXSUWNUWMVHVCVDVIVJVKUYEUXIDEIIUYEUWOHU
      CZKLZUYKVLVMZUWNSLZTZPZHUWBQZUWSUXIPUWSUYQTZUYEUXIUWSUYRUYLUYMUWNJZOZHUWB
      NZUYEUXIPUYRUYPTZHUWBNUWSVUAUYPHUWBVNUWSVUBUYTHUWBVUBUYLUYNOUWSUYKUWBJZOZ
      UYTUYLUYNVOVUDUYNUYSUYLUWRVUCUYNUYSWIZUWQVUCUWRUYMIJZVUEUYKIIVRZVUFUWRVUE
      UYMUWNVPVQVSVTWAWBWCWDUYEUXBVUAUXAUYEUXBVUAUXAPUYEUXBOZUYTUXAHUWBVUHVUCOZ
      UYLUYSUXAVUIUYSUYLUXAVUHVUCUYSUYLUXAPVUHVUCUYSWEZUWDUYKKLZAMNZUYLUXAVUJVU
      LUWDUYKWFVMZUYMUFZKLZAMNZVUHVUCUYSVUPVUHVUCVUFUYSVUPPZVUGVUCVUMIJZVUHVUFV
      UQPZUYKIIWGUYEUXBVURVUSPZUYEUXBGEUHZUYBPZGIQZUAIQZVUTUYDVVDFUWNUWGFEUDZUY
      CVVBUAGIIVVEUXQVVAUYBFEGUTVAVBWHVVDVURVVAUWDVUMUXSUFZKLZAMNZPZGIQZVUSVVCV
      VJUAVUMIUXRVUMRZVVBVVIGIVVKUYBVVHVVAVVKUYAVVGAMVVKUXTVVFUWDKUXRVUMUXSVGVC
      VDVEWJWHVVIVUQGUYMIUXSUYMRZVVAUYSVVHVUPUXSUYMUWNWKVVLVVGVUOAMVVLVVFVUNUWD
      KUXSUYMVUMVHVCVDVIWHWLWLWMWNWOXMVUCVUHVULVUPWIUYSVUCVUKVUOAMVUCUYKVUNUWDK
      UYKIIWPVCVDWQWRUYLVUKUWTAMUYLVUKUWTUYLVUKOZUWDUYKUWOKUWBUWBKWSZVVMWTXAUYL
      VUKXBUYLVUKXCXDXEXFXGXHXIXJXKXEXNXLXOUYQUWSUXAUXBUWSUYQUXAUWSUWOUWOKLZUYQ
      UWOMJZUXAUWSVVOUWMUWNXPYDUWNUWMXPYDRZUWMUWNXQUWSVVOVVQWIUWMUWNUWMUWNXRXSX
      TUWSUWOUWBJZUYQVVPPUWMUWNIIYAVVPVVRUYQUWGUYKKLZUYMUWGVLVMZSLZTZPZHUWBQZUY
      QCUWOUWBMUWGUWORZVWCUYPHUWBVWEVVSUYLVWBUYOUWGUWOUYKKYEVWEVWAUYNVWEVVTUWNU
      YMSUWMUWNUWGDUNUXGYBVCYCVIWJCHUUAZYFUUBUMVVPVVOUXAUWTVVOAUWOMUWDUWOUWOKYE
      UQUUCUUDYGUUFUUEUUGUUHXAUUIUXJDIYHUMUXIEIYHWLXJYGUUJUUOUWPUWEUWTAMBUWOUWD
      KYIVDUUKUULUUPUWDUWMKLZUWGUWMKLZOZUWJPZCMQAMQUWLDBUWBUWMBRZVWJUWKACMMVWKV
      WIUWIUWJVWKVWGUWEVWHUWHUWMBUWDKYIUWMBUWGKYIUUMVAVBVWJACMVWIUWDUWGKLZUWDMJ
      ZUWGMJZOZUWJVWIUWDUWMUWGKUWBVVNVWIWTXAVWGVWHXCVWGVWHXBXDVWOVWLUWJVWOVWLOZ
      UWDWFVMZUWDVLVMZUFZUWGWFVMZVVTUFZUWDUWGVWPVWQVWTVWRVVTVWPVWRVWQXPYDZVWRVW
      TXPYDZRZVWQVWTRZVWPVXBVWQVVTXPYDZVXCVWPVXBVWQVWRXPYDVXFVWRVWQXQVWPVWRVVTV
      WQXPVWPVWRVVTRZVVTVWRSLZVWOVWLVXHTZVWNUWGUWBJZVUKUYMVWRSLZTZPZHUWBQZVWLVX
      IPZVWMUWGYJZVWMUWDUWBJZVXNVWDVXNCUWDUWBMCAUDZVWCVXMHUWBVXRVVSVUKVWBVXLUWG
      UWDUYKKYEVXRVWAVXKVXRVVTVWRUYMSUWGUWDVLYKVCYCVIWJVWFYFYPVXMVXOHUWGUWBHCUD
      ZVUKVWLVXLVXIUYKUWGUWDKYIVXSVXKVXHVXSUYMVVTVWRSUYKUWGVLYKYLYCVIYMUUNWMVWP
      VXGVXHVWPVWRVVTSLZTZVXGVXHUUQZVWOVWLVYAVWLUWGUWDKLZVWOVYAVWLUWDUWGKUWBVVN
      VWLWTXAVWLUVRUURVWMVXQVWDVYCVYAPZVWNUWDYJZVWNVXJVWDVWDCMUWBVWFUUSYPVWCVYD
      HUWDUWBHAUDZVVSVYCVWBVYAUYKUWDUWGKYIVYFVWAVXTVYFUYMVWRVVTSUYKUWDVLYKYLYCV
      IYMYNWNWMVWPVWRIJZVVTIJZVYAVYBWIVWMVYGVWNVWLVWMVXQVYGVYEUWDIIVRZUMYOVWNVY
      HVWMVWLVWNVXJVYHVXPUWGIIVRZUMYQVYGVYHOZVYAVYBTZTVYBVYKVXTVYLISUUTVYKVXTVY
      LWIUVAIVWRVVTSUVBUVCYCVYBUVDUVEYRYSUVFUVGZUVHUVIVWOVWLVXFVXCRZVWMVXQVXJVW
      LVYNWIVWNVYEVXPVXQVXJOVWLVWSVXAKLZVYNVXQVXJUWDVWSUWGVXAKUWDIIWPZUWGIIWPZU
      VJVXQVWQIJZVYGOVWTIJZVYHOVYOVYNWIVXJVXQVYRVYGUWDIIWGZVYIYTVXJVYSVYHUWGIIW
      GVYJYTVWQVWRVWTVVTXRYNUVKYNUVLUVMVWPVXQVXDVXEWIZVWMVXQVWNVWLVYEYOZVXQVYGV
      YRWUAVYIVYTVWRVWQVWTUVNYRUMYSVYMUVOVWPVXQUWDVWSRWUBVYPUMVWPVXJUWGVXARVWNV
      XJVWMVWLVXPYQVYQUMUVSXEWNUVPUVQUWEUWHACMUWDUWGBKYEUVTUWA $.
  $}

  ${
    $d x y $.
    $( Corollary of ~ nqereu : the function ` /Q ` is actually a function.
       (Contributed by Mario Carneiro, 6-May-2013.)
       (New usage is discouraged.) $)
    nqerf $p |- /Q : ( N. X. N. ) --> Q. $=
      ( vx vy cnpi cxp cnq cerq crn wss cdm wceq cv wbr wmo cvv ceq df-erq wcel
      wa ax-mp mpbir2an wf wfn wfun wrel wal cin inss2 eqsstri xpss sstri mpbir
      df-rel wi wreu nqereu weu df-reu eumo sylbi syl moanimv simpld simprd wer
      brel enqer a1i inss1 ssbri ersym jca32 moimi ax-gen dffun6 c1q c0 wne 1nq
      dmss ne0i dmxp mp2b sseqtri wex wrex reurex simpll simplr simpr w3a breqi
      brinxp2 bitri syl3anbrc ex reximdva rexex syl56 mpd vex eldm sylibr ssriv
      eqssi df-fn rnss rnxpss df-f ) CCDZEFUAFXIUBZFGZEHXJFUCZFIZXIJXLFUDZAKZBK
      ZFLZBMZAUEXNFNNDZHFXIEDZXSFOXTUFZXTPOXTUGUHZXIEUIUJFULUKXRAXOXIQZXPEQZXPX
      OOLZRZRZBMZXRYHYCYFBMZUMYCYEBEUNZYIBXOUOZYJYFBUPYIYEBEUQYFBURUSUTYCYFBVAU
      KXQYGBXQYCYDYEXQYCYDXOXPXIEFYBVEZVBXQYCYDYLVCXQXOXPOXIXIOVDZXQVFVGFOXOXPF
      YAOPOXTVHUHVIVJVKVLSVMABFVNTXMXIXMXTIZXIFXTHZXMYNHYBFXTVSSVOEQEVPVQYNXIJV
      REVOVTXIEWAWBWCAXIXMYCXQBWDZXOXMQYCYJYPYKYJYEBEWEYCXQBEWEYPYEBEWFYCYEXQBE
      YCYDRZYEXQYQYERZYCYDXOXPOLZXQYCYDYEWGYCYDYEWHYRXPXOOXIYMYRVFVGYQYEWIVJXQX
      OXPYALYCYDYSWJXOXPFYAPWKXOXPXIEOWLWMWNWOWPXQBEWQWRWSBXOFAWTXAXBXCXDFXIXET
      XKXTGZEYOXKYTHYBFXTXFSXIEXGUJXIEFXHT $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Corollary of ~ nqereu : closure of ` /Q ` .  (Contributed by Mario
       Carneiro, 6-May-2013.)  (New usage is discouraged.) $)
    nqercl $p |- ( A e. ( N. X. N. ) -> ( /Q ` A ) e. Q. ) $=
      ( cnpi cxp cnq cerq nqerf ffvelrni ) BBCDAEFG $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Any member of ` ( N. X. N. ) ` relates to the representative of its
       equivalence class.  (Contributed by Mario Carneiro, 6-May-2013.)
       (New usage is discouraged.) $)
    nqerrel $p |- ( A e. ( N. X. N. ) -> A ~Q ( /Q ` A ) ) $=
      ( cnpi cxp wcel cerq cfv wbr ceq wceq eqid wfn wb cnq nqerf ax-mp fnbrfvb
      wf ffn mpan mpbii cin df-erq inss1 eqsstri ssbri syl ) ABBCZDZAAEFZEGZAUI
      HGUHUIUIIZUJUIJEUGKZUHUKUJLUGMEQULNUGMEROUGAUIEPSTEHAUIEHUGMCZUAHUBHUMUCU
      DUEUF $.
  $}

  ${
    $d A a $.
    $( Corollary of ~ nqereu : the function ` /Q ` acts as the identity on
       members of ` Q. ` .  (Contributed by Mario Carneiro, 6-May-2013.)
       (New usage is discouraged.) $)
    nqerid $p |- ( A e. Q. -> ( /Q ` A ) = A ) $=
      ( cerq wfun cnq wcel wbr cfv wceq cnpi cxp nqerf ffun ax-mp ceq elpqn wer
      wf id enqer a1i erref cin w3a breqi brinxp2 bitri syl3anbrc funbrfv mpsyl
      df-erq ) BCZADEZAABFZABGAHIIJZDBQUKKUNDBLMULAUNEZULAANFZUMAOZULRULANUNUNN
      PULSTUQUAUMAANUNDJUBZFUOULUPUCAABURUJUDAAUNDNUEUFUGAABUHUI $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Corollary of ~ nqereu : if two fractions are both reduced and
       equivalent, then they are equal.  (Contributed by Mario Carneiro,
       6-May-2013.)  (New usage is discouraged.) $)
    enqeq $p |- ( ( A e. Q. /\ B e. Q. /\ A ~Q B ) -> A = B ) $=
      ( vx cnq wcel ceq wbr w3a wa cv wmo wceq 3simpa wrmo cnpi cxp eleq1 breq1
      wreu anbi12d elpqn 3ad2ant2 nqereu reurmo df-rmo sylib 3simpb simp2 enqer
      3syl wer a1i erref jca moi syl112anc ) ADEZBDEZABFGZHZUQURICJZDEZVABFGZIZ
      CKZUQUSIZURBBFGZIZABLUQURUSMUTVCCDNZVEUTBOOPZEZVCCDSVIURUQVKUSBUAUBZCBUCV
      CCDUDUJVCCDUEUFUQURUSUGUTURVGUQURUSUHUTBFVJVJFUKUTUIULVLUMUNVDVFVHCABDDVA
      ALVBUQVCUSVAADQVAABFRTVABLVBURVCVGVABDQVABBFRTUOUP $.
  $}

  ${
    $d p q r s x y $.
    $( The function ` /Q ` acts as a substitute for equivalence classes, and it
       satisfies the fundamental requirement for equivalence representatives:
       the representatives are equal iff the members are equivalent.
       (Contributed by Mario Carneiro, 6-May-2013.)  (Revised by Mario
       Carneiro, 12-Aug-2015.)  (New usage is discouraged.) $)
    nqereq $p |- ( ( A e. ( N. X. N. ) /\ B e. ( N. X. N. ) ) ->
      ( A ~Q B <-> ( /Q ` A ) = ( /Q ` B ) ) ) $=
      ( cnpi cxp wcel wa ceq wbr cerq cfv wceq w3a cnq nqercl 3ad2ant1 3ad2ant2
      wer enqer a1i nqerrel simp3 ertr3d syl3anc 3expia adantr breqtrd ad2antrl
      ertrd enqeq simprr ertr4d expr impbid ) ACCDZEZBUNEZFABGHZAIJZBIJZKZUOUPU
      QUTUOUPUQLZURMEZUSMEZURUSGHUTUOUPVBUQANOUPUOVCUQBNPVAURBUSGUNUNGQZVARSZVA
      URABGUNVEUOUPAURGHZUQATZOUOUPUQUAUBUPUOBUSGHZUQBTZPUHURUSUIUCUDUOUPUTUQUO
      UPUTFZFZAUSBGUNVDVKRSVKAURUSGUOVFVJVGUEUOUPUTUJUFUPVHUOUTVIUGUKULUM $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C y z $.  $d D y z $.
    $( Addition of positive fractions in terms of positive integers.
       (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    addpipq2 $p |- ( ( A e. ( N. X. N. ) /\ B e. ( N. X. N. ) ) ->
      ( A +pQ B ) = <. ( ( ( 1st ` A ) .N ( 2nd ` B ) ) +N
                         ( ( 1st ` B ) .N ( 2nd ` A ) ) ) ,
                         ( ( 2nd ` A ) .N ( 2nd ` B ) ) >. ) $=
      ( vx vy cnpi cxp cv c1st cfv c2nd cmi cpli cop wceq oveq1d oveq2d oveq12d
      co fveq2 opeq12d cplpq df-plpq opex ovmpt2 ) CDABEEFZUECGZHIZDGZJIZKRZUHH
      IZUFJIZKRZLRZULUIKRZMAHIZBJIZKRZBHIZAJIZKRZLRZUTUQKRZMUAUPUIKRZUKUTKRZLRZ
      UTUIKRZMUFANZUNVFUOVGVHUJVDUMVELVHUGUPUIKUFAHSOVHULUTUKKUFAJSZPQVHULUTUIK
      VIOTUHBNZVFVBVGVCVJVDURVEVALVJUIUQUPKUHBJSZPVJUKUSUTKUHBHSOQVJUIUQUTKVKPT
      CDUBVBVCUCUD $.

    $( Addition of positive fractions in terms of positive integers.
       (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    addpipq $p |- ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. ) ) ->
          ( <. A , B >. +pQ <. C , D >. ) =
            <. ( ( A .N D ) +N ( C .N B ) ) , ( B .N D ) >. ) $=
      ( cnpi wcel wa cop cplpq c1st cfv c2nd cmi cpli cxp opelxpi op1stg op2ndg
      co oveqan12d wceq addpipq2 syl2an oveqan12rd oveq12d opeq12d eqtrd ) AEFB
      EFGZCEFDEFGZGZABHZCDHZISZUKJKZULLKZMSZULJKZUKLKZMSZNSZURUOMSZHZADMSZCBMSZ
      NSZBDMSZHUHUKEEOZFULVGFUMVBUAUIABEEPCDEEPUKULUBUCUJUTVEVAVFUJUPVCUSVDNUHU
      IUNAUODMABEEQCDEERZTUIUHUQCURBMCDEEQABEERZUDUEUHUIURBUODMVIVHTUFUG $.

    $( Addition of positive fractions in terms of positive integers.
       (Contributed by NM, 28-Aug-1995.)  (Revised by Mario Carneiro,
       26-Dec-2014.)  (New usage is discouraged.) $)
    addpqnq $p |- ( ( A e. Q. /\ B e. Q. ) ->
        ( A +Q B ) = ( /Q ` ( A +pQ B ) ) ) $=
      ( vx vy cnq wcel cop cplq cfv cplpq cerq co cxp wceq opelxpi cnpi cv c1st
      c2nd cmi wa ccom cres df-plq fveq1i a1i syl wfn cpli df-plpq opex fnmpt2i
      fvres elpqn syl2an fvco2 sylancr 3eqtrd df-ov fveq2i 3eqtr4g ) AEFZBEFZUA
      ZABGZHIZVEJIZKIZABHLABJLZKIVDVFVEKJUBZEEMZUCZIZVEVJIZVHVFVMNVDVEHVLUDUEUF
      VDVEVKFVMVNNABEEOVEVKVJUMUGVDJPPMZVOMZUHVEVPFZVNVHNCDVOVOCQZRIDQZSIZTLVSR
      IVRSIZTLUILZWAVTTLZGJCDUJWBWCUKULVBAVOFBVOFVQVCAUNBUNABVOVOOUOVPKJVEUPUQU
      RABHUSVIVGKABJUSUTVA $.

    $( Multiplication of positive fractions in terms of positive integers.
       (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    mulpipq2 $p |- ( ( A e. ( N. X. N. ) /\ B e. ( N. X. N. ) ) ->
      ( A .pQ B ) = <. ( ( 1st ` A ) .N ( 1st ` B ) ) ,
                       ( ( 2nd ` A ) .N ( 2nd ` B ) ) >. ) $=
      ( vx vy cnpi cxp cv c1st cfv cmi c2nd cop cmpq wceq oveq1d opeq12d oveq2d
      co fveq2 df-mpq opex ovmpt2 ) CDABEEFZUCCGZHIZDGZHIZJRZUDKIZUFKIZJRZLAHIZ
      BHIZJRZAKIZBKIZJRZLMULUGJRZUOUJJRZLUDANZUHURUKUSUTUEULUGJUDAHSOUTUIUOUJJU
      DAKSOPUFBNZURUNUSUQVAUGUMULJUFBHSQVAUJUPUOJUFBKSQPCDTUNUQUAUB $.

    $( Multiplication of positive fractions in terms of positive integers.
       (Contributed by NM, 28-Aug-1995.)  (Revised by Mario Carneiro,
       8-May-2013.)  (New usage is discouraged.) $)
    mulpipq $p |- ( ( ( A e. N. /\ B e. N. ) /\ ( C e. N. /\ D e. N. ) ) ->
          ( <. A , B >. .pQ <. C , D >. ) = <. ( A .N C ) , ( B .N D ) >. ) $=
      ( cnpi wcel wa cop cmpq co c1st cfv cmi c2nd cxp opelxpi op1stg oveqan12d
      wceq op2ndg mulpipq2 syl2an opeq12d eqtrd ) AEFBEFGZCEFDEFGZGZABHZCDHZIJZ
      UHKLZUIKLZMJZUHNLZUINLZMJZHZACMJZBDMJZHUEUHEEOZFUIUTFUJUQSUFABEEPCDEEPUHU
      IUAUBUGUMURUPUSUEUFUKAULCMABEEQCDEEQRUEUFUNBUODMABEETCDEETRUCUD $.

    $( Multiplication of positive fractions in terms of positive integers.
       (Contributed by NM, 28-Aug-1995.)  (Revised by Mario Carneiro,
       26-Dec-2014.)  (New usage is discouraged.) $)
    mulpqnq $p |- ( ( A e. Q. /\ B e. Q. ) ->
        ( A .Q B ) = ( /Q ` ( A .pQ B ) ) ) $=
      ( vx vy cnq wcel cop cmq cfv cmpq cerq co cxp wceq opelxpi cnpi c1st c2nd
      cv cmi ccom cres df-mq fveq1i a1i fvres syl wfn df-mpq opex fnmpt2i elpqn
      wa syl2an fvco2 sylancr 3eqtrd df-ov fveq2i 3eqtr4g ) AEFZBEFZUMZABGZHIZV
      DJIZKIZABHLABJLZKIVCVEVDKJUAZEEMZUBZIZVDVIIZVGVEVLNVCVDHVKUCUDUEVCVDVJFVL
      VMNABEEOVDVJVIUFUGVCJPPMZVNMZUHVDVOFZVMVGNCDVNVNCSZQIDSZQITLZVQRIVRRITLZG
      JCDUIVSVTUJUKVAAVNFBVNFVPVBAULBULABVNVNOUNVOKJVDUOUPUQABHURVHVFKABJURUSUT
      $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d C x y $.  $d D x y $.
    $( Ordering of positive fractions in terms of positive integers.
       (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    ordpipq $p |- ( <. A , B >. <pQ <. C , D >. <->
                          ( A .N D ) <N ( C .N B ) ) $=
      ( vx vy wbr cnpi wcel wa cmi clti c1st cfv c2nd wceq fveq2 sylbi sylan9eq
      co cop cltpq cxp cv opex anbi1d opelxp op1stg adantr oveq1d op2ndg oveq2d
      eleq1 breq12d bitrd anbi2d adantl df-ltpq brab simpr ltrelpi brel dmmulpi
      pm5.32da 0npi ndmovrcl anim12i opelxpi ad2ant2rl simprl syl2anc jca ancri
      simplr 3syl impbii bitri ) ABUAZCDUAZUBGVRHHUCZIZVSVTIZJZADKTZCBKTZLGZJZW
      FEUDZVTIZFUDZVTIZJZWHMNZWJONZKTZWJMNZWHONZKTZLGZJZWAWKJZAWNKTZWPBKTZLGZJZ
      WGEFVRVSUBABUECDUEWHVRPZWTXAWSJXEXFWLXAWSXFWIWAWKWHVRVTUMUFUFXFXAWSXDXFXA
      JZWOXBWRXCLXGWMAWNKXFXAWMVRMNZAWHVRMQWAXHAPZWKWAAHIZBHIZJZXIABHHUGZABHHUH
      RUISUJXGWQBWPKXFXAWQVRONZBWHVROQWAXNBPZWKWAXLXOXMABHHUKRUISULUNVDUOWJVSPZ
      XEWCXDJWGXPXAWCXDXPWKWBWAWJVSVTUMUPUFXPWCXDWFXPWCJZXBWDXCWELXQWNDAKXPWCWN
      VSONZDWJVSOQWBXRDPZWAWBCHIZDHIZJZXSCDHHUGZCDHHUKRUQSULXQWPCBKXPWCWPVSMNZC
      WJVSMQWBYDCPZWAWBYBYEYCCDHHUHRUQSUJUNVDUOEFURUSWGWFWCWFUTWFWCWFWDHIZWEHIZ
      JXJYAJZXTXKJZJZWCWDWEHHLVAVBYFYHYGYIADHKVCVEVFCBHKVCVEVFVGYJWAWBXJXKWAYAX
      TABHHVHVIYJXTYAWBYHXTXKVJXJYAYIVNCDHHVHVKVLVOVMVPVQ $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Ordering of positive fractions in terms of positive integers.
       (Contributed by NM, 13-Feb-1996.)  (Revised by Mario Carneiro,
       28-Apr-2013.)  (New usage is discouraged.) $)
    ordpinq $p |- ( ( A e. Q. /\ B e. Q. ) ->
        ( A <Q B <-> ( ( 1st ` A ) .N ( 2nd ` B ) ) <N
                      ( ( 1st ` B ) .N ( 2nd ` A ) ) ) ) $=
      ( cnq wcel wa cltpq wbr cltq c1st cfv c2nd cmi co cxp cop cnpi wceq elpqn
      1st2nd sylancr clti cin brinxp df-ltnq breqi syl6bbr wrel relxp breqan12d
      ordpipq syl6bb bitr3d ) ACDZBCDZEZABFGZABHGZAIJZBKJZLMBIJZAKJZLMUAGZUOUPA
      BFCCNUBZGUQABCCFUCABHVCUDUEUFUOUPURVAOZUTUSOZFGVBUMUNAVDBVEFUMPPNZUGZAVFD
      AVDQPPUHZARAVFSTUNVGBVFDBVEQVHBRBVFSTUIURVAUTUSUJUKUL $.
  $}

  ${
    $d A x y z $.  $d B y z $.
    $( Closure of addition on positive fractions.  (Contributed by NM,
       29-Aug-1995.)  (Revised by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    addpqf $p |- +pQ : ( ( N. X. N. ) X. ( N. X. N. ) ) --> ( N. X. N. ) $=
      ( vx vy cv c1st cfv c2nd cmi co cpli cop cnpi wcel wral cplpq xp1st xp2nd
      cxp mulclpi syl2an syl2anc wf syl2anr addclpi opelxpi rgen2a df-plpq mpbi
      wa fmpt2 ) ACZDEZBCZFEZGHZULDEZUJFEZGHZIHZUPUMGHZJZKKQZLZBVAMAVAMVAVAQVAN
      UAVBABVAUJVALZULVALZUHZURKLZUSKLZVBVEUNKLZUQKLZVFVCUKKLUMKLZVHVDUJKKOULKK
      PZUKUMRSVDUOKLUPKLZVIVCULKKOUJKKPZUOUPRUBUNUQUCTVCVLVJVGVDVMVKUPUMRSURUSK
      KUDTUEABVAVAUTVANABUFUIUG $.

    $( Closure of addition on positive fractions.  (Contributed by NM,
       29-Aug-1995.)  (Revised by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    addclnq $p |- ( ( A e. Q. /\ B e. Q. ) -> ( A +Q B ) e. Q. ) $=
      ( cnq wcel wa cplq co cplpq cerq cfv addpqnq cnpi cxp elpqn addpqf syl2an
      fovcl nqercl syl eqeltrd ) ACDZBCDZEZABFGABHGZIJZCABKUCUDLLMZDZUECDUAAUFD
      BUFDUGUBANBNABUFUFUFHOQPUDRST $.

    $( Closure of multiplication on positive fractions.  (Contributed by NM,
       29-Aug-1995.)  (Revised by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    mulpqf $p |- .pQ : ( ( N. X. N. ) X. ( N. X. N. ) ) --> ( N. X. N. ) $=
      ( vx vy cv c1st cfv cmi co c2nd cop cnpi cxp wcel wral cmpq wf wa mulclpi
      xp1st syl2an xp2nd opelxpi syl2anc rgen2a df-mpq fmpt2 mpbi ) ACZDEZBCZDE
      ZFGZUGHEZUIHEZFGZIZJJKZLZBUPMAUPMUPUPKUPNOUQABUPUGUPLZUIUPLZPUKJLZUNJLZUQ
      URUHJLUJJLUTUSUGJJRUIJJRUHUJQSURULJLUMJLVAUSUGJJTUIJJTULUMQSUKUNJJUAUBUCA
      BUPUPUOUPNABUDUEUF $.

    $( Closure of multiplication on positive fractions.  (Contributed by NM,
       29-Aug-1995.)  (Revised by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    mulclnq $p |- ( ( A e. Q. /\ B e. Q. ) -> ( A .Q B ) e. Q. ) $=
      ( cnq wcel wa cmq co cmpq cerq cfv mulpqnq cnpi elpqn mulpqf fovcl syl2an
      cxp nqercl syl eqeltrd ) ACDZBCDZEZABFGABHGZIJZCABKUCUDLLQZDZUECDUAAUFDBU
      FDUGUBAMBMABUFUFUFHNOPUDRST $.
  $}

  ${
    $d w x y z $.
    $( Domain of addition on positive fractions.  (Contributed by NM,
       24-Aug-1995.)  (Revised by Mario Carneiro, 10-Jul-2014.)
       (New usage is discouraged.) $)
    addnqf $p |- +Q : ( Q. X. Q. ) --> Q. $=
      ( vx cnq cxp cplq wf cerq cplpq ccom cres cnpi wss nqerf addpqf fco mp2an
      cv elpqn ssriv xpss12 fssres df-plq feq1i mpbir ) BBCZBDEUDBFGHZUDIZEZJJC
      ZUHCZBUEEZUDUIKZUGUHBFEUIUHGEUJLMUIUHBFGNOBUHKZULUKABUHAPQRZUMBUHBUHSOUIB
      UDUETOUDBDUFUAUBUC $.

    $( Domain of multiplication on positive fractions.  (Contributed by NM,
       24-Aug-1995.)  (Revised by Mario Carneiro, 10-Jul-2014.)
       (New usage is discouraged.) $)
    mulnqf $p |- .Q : ( Q. X. Q. ) --> Q. $=
      ( vx cnq cxp cmq wf cerq cmpq ccom cres cnpi wss nqerf mulpqf mp2an elpqn
      fco cv ssriv xpss12 fssres df-mq feq1i mpbir ) BBCZBDEUDBFGHZUDIZEZJJCZUH
      CZBUEEZUDUIKZUGUHBFEUIUHGEUJLMUIUHBFGPNBUHKZULUKABUHAQORZUMBUHBUHSNUIBUDU
      ETNUDBDUFUAUBUC $.
  $}

  $( Addition of positive fractions is commutative.  (Contributed by NM,
     30-Aug-1995.)  (Revised by Mario Carneiro, 28-Apr-2013.)
     (New usage is discouraged.) $)
  addcompq $p |- ( A +pQ B ) = ( B +pQ A ) $=
    ( cnpi cxp wcel cplpq wceq c1st cfv c2nd cmi cpli addcompi mulcompi opeq12i
    wa co cop addpipq2 ancoms 3eqtr4a addpqf fdmi ndmovcom pm2.61i ) ACCDZEZBUF
    EZPZABFQZBAFQZGUIAHIBJIZKQZBHIAJIZKQZLQZUNULKQZRUOUMLQZULUNKQZRZUJUKUPURUQU
    SUMUOMUNULNOABSUHUGUKUTGBASTUAABUFFUFUFDUFFUBUCUDUE $.

  $( Addition of positive fractions is commutative.  (Contributed by NM,
     30-Aug-1995.)  (Revised by Mario Carneiro, 28-Apr-2013.)
     (New usage is discouraged.) $)
  addcomnq $p |- ( A +Q B ) = ( B +Q A ) $=
    ( cnq wcel wa cplq co wceq cplpq cfv addcompq fveq2i addpqnq ancoms 3eqtr4a
    cerq cxp addnqf fdmi ndmovcom pm2.61i ) ACDZBCDZEZABFGZBAFGZHUDABIGZPJBAIGZ
    PJZUEUFUGUHPABKLABMUCUBUFUIHBAMNOABCFCCQCFRSTUA $.

  $( Multiplication of positive fractions is commutative.  (Contributed by NM,
     31-Aug-1995.)  (Revised by Mario Carneiro, 28-Apr-2013.)
     (New usage is discouraged.) $)
  mulcompq $p |- ( A .pQ B ) = ( B .pQ A ) $=
    ( cnpi cxp wcel wa cmpq co wceq c1st cfv cmi c2nd mulcompi opeq12i mulpipq2
    cop ancoms 3eqtr4a mulpqf fdmi ndmovcom pm2.61i ) ACCDZEZBUDEZFZABGHZBAGHZI
    UGAJKZBJKZLHZAMKZBMKZLHZQUKUJLHZUNUMLHZQZUHUIULUPUOUQUJUKNUMUNNOABPUFUEUIUR
    IBAPRSABUDGUDUDDUDGTUAUBUC $.

  $( Multiplication of positive fractions is commutative.  (Contributed by NM,
     31-Aug-1995.)  (Revised by Mario Carneiro, 28-Apr-2013.)
     (New usage is discouraged.) $)
  mulcomnq $p |- ( A .Q B ) = ( B .Q A ) $=
    ( cnq wcel wa cmq wceq cmpq cerq cfv mulcompq fveq2i mulpqnq ancoms 3eqtr4a
    co cxp mulnqf fdmi ndmovcom pm2.61i ) ACDZBCDZEZABFPZBAFPZGUDABHPZIJBAHPZIJ
    ZUEUFUGUHIABKLABMUCUBUFUIGBAMNOABCFCCQCFRSTUA $.

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( Lemma for ~ adderpq .  (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    adderpqlem $p |- ( ( A e. ( N. X. N. ) /\ B e. ( N. X. N. ) /\
        C e. ( N. X. N. ) ) ->
      ( A ~Q B <-> ( A +pQ C ) ~Q ( B +pQ C ) ) ) $=
      ( vx vy cnpi wcel c1st cfv c2nd cmi co cpli wceq mulclpi syl2anc mulcompi
      fvex mulasspi eqtri vz cxp w3a cop cplpq wb xp1st 3ad2ant1 xp2nd 3ad2ant3
      ceq wbr addclpi 3ad2ant2 enqbreq syl22anc 3adant2 3adant1 breq12d 3adant3
      addpipq2 enqbreq2 mulcanpi cv caov4 oveq12i addcompi ovex distrpi caovdir
      3eqtr4i 3eqtrri oveq1i oveq2i eqeq12i addcanpi syl5rbbr 3bitr2d 3bitr4rd
      ) AFFUBZGZBVTGZCVTGZUCZAHIZCJIZKLZCHIZAJIZKLZMLZWIWFKLZUDZBHIZWFKLZWHBJIZ
      KLZMLZWPWFKLZUDZUKULZWKWSKLZWLWRKLZNZACUELZBCUELZUKULABUKULZWDWKFGZWLFGZW
      RFGZWSFGZXAXDUFWDWGFGZWJFGZXHWDWEFGZWFFGZXLWAWBXNWCAFFUGUHZWCWAXOWBCFFUIU
      JZWEWFOPWDWHFGZWIFGZXMWCWAXRWBCFFUGUJZWAWBXSWCAFFUIUHZWHWIOPWGWJUMPWDXSXO
      XIYAXQWIWFOPZWDWOFGZWQFGZXJWDWNFGZXOYCWBWAYEWCBFFUGUNXQWNWFOPWDXRWPFGZYDX
      TWBWAYFWCBFFUIUNZWHWPOPZWOWQUMPWDYFXOXKYGXQWPWFOPWKWLWRWSUOUPWDXEWMXFWTUK
      WAWCXEWMNWBACVAUQWBWCXFWTNWABCVAURUSWDXGWEWPKLZWNWIKLZNZWFWFKLZYIKLZYLYJK
      LZNZXDWAWBXGYKUFWCABVBUTWDYLFGZYIFGZYOYKUFWDXOXOYPXQXQWFWFOPZWDXNYFYQXPYG
      WEWPOPZYLYIYJVCPXDWLWQKLZYMMLZYTYNMLZNZWDYOUUAXBUUBXCYMYTMLWGWSKLZWJWSKLZ
      MLUUAXBYMUUDYTUUEMYMYIYLKLUUDYLYIQDEUAWEWPWFWFKAHRBJRZCJRZDVDZEVDZQZUUHUU
      IUAVDZSZUUGVETYTWIWHKLZWFWPKLZKLUUEDEUAWIWFWHWPKAJRUUGCHRUUJUULUUFVEUUMWJ
      UUNWSKWIWHQWFWPQVFTVFYTYMVGDEUAWGWJWSMKWEWFKVHWHWIKVHWPWFKVHUUJUUHUUIUUKV
      IVJVKYTWLWOKLZMLUUOYTMLUUBXCYTUUOVGYNUUOYTMYNWFWFYJKLZKLZUUOWFWFYJSUUQWLW
      NKLZWFKLZUUOUUQUUPWFKLUUSWFUUPQUUPUURWFKUURWIWFWNKLZKLUUTWIKLUUPWIWFWNSWI
      UUTQWFWNWISVLVMTWLWNWFSTTVNWLWOWQVIVKVOWDYTFGZYMFGZUUCYOUFWDXIYDUVAYBYHWL
      WQOPWDYPYQUVBYRYSYLYIOPYTYMYNVPPVQVRVS $.

    $( Lemma for ~ mulerpq .  (Contributed by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    mulerpqlem $p |- ( ( A e. ( N. X. N. ) /\ B e. ( N. X. N. ) /\
        C e. ( N. X. N. ) ) ->
      ( A ~Q B <-> ( A .pQ C ) ~Q ( B .pQ C ) ) ) $=
      ( vx vy vz cnpi wcel c1st cfv cmi co c2nd ceq wb mulclpi syl2anc mulcompi
      wceq fvex cxp w3a cop cmpq xp1st 3ad2ant1 3ad2ant3 xp2nd 3ad2ant2 enqbreq
      syl22anc mulpipq2 3adant2 3adant1 breq12d enqbreq2 3adant3 mulcanpi caov4
      wbr cv mulasspi eqtri 3eqtri eqeq12i a1i 3bitr2d 3bitr4rd ) AGGUAZHZBVIHZ
      CVIHZUBZAIJZCIJZKLZAMJZCMJZKLZUCZBIJZVOKLZBMJZVRKLZUCZNUTZVPWDKLZVSWBKLZS
      ZACUDLZBCUDLZNUTABNUTZVMVPGHZVSGHZWBGHZWDGHZWFWIOVMVNGHZVOGHZWMVJVKWQVLAG
      GUEUFZVLVJWRVKCGGUEUGZVNVOPQVMVQGHZVRGHZWNVJVKXAVLAGGUHUFVLVJXBVKCGGUHUGZ
      VQVRPQVMWAGHZWRWOVKVJXDVLBGGUEUIWTWAVOPQVMWCGHZXBWPVKVJXEVLBGGUHUIZXCWCVR
      PQVPVSWBWDUJUKVMWJVTWKWENVJVLWJVTSVKACULUMVKVLWKWESVJBCULUNUOVMWLVNWCKLZW
      AVQKLZSZVOVRKLZXGKLZXJXHKLZSZWIVJVKWLXIOVLABUPUQVMXJGHZXGGHZXMXIOVMWRXBXN
      WTXCVOVRPQVMWQXEXOWSXFVNWCPQXJXGXHURQXMWIOVMXKWGXLWHXKXGXJKLWGXJXGRDEFVNW
      CVOVRKAITBMTCITZDVAZEVAZRZXQXRFVAVBZCMTZUSVCXLXHXJKLWBVSKLWHXJXHRDEFWAVQV
      OVRKBITAMTXPXSXTYAUSWBVSRVDVEVFVGVH $.
  $}

  $( Addition is compatible with the equivalence relation.  (Contributed by
     Mario Carneiro, 8-May-2013.)  (New usage is discouraged.) $)
  adderpq $p |- ( ( /Q ` A ) +Q ( /Q ` B ) ) = ( /Q ` ( A +pQ B ) ) $=
    ( cnpi cxp wcel cerq cfv cplq co cplpq wceq cnq ceq wbr wb syl mpbid addpqf
    wn c0 wa nqercl addpqnq syl2an wer enqer nqerrel adantr wi elpqn adderpqlem
    a1i mpd imp adantl mpan9 addcompq 3brtr3g ertrd fovcl nqereq syl2anc eqtr4d
    3exp 0nnq nqerf fdmi eleq2i ndmfv sylnbir eleq1d mtbiri con4i anim12i con3i
    cdm addnqf ndmov 0nelxp mtbir pm2.61i ) ACCDZEZBWBEZUAZAFGZBFGZHIZABJIZFGZK
    WEWHWFWGJIZFGZWJWCWFLEZWGLEZWHWLKWDAUBZBUBZWFWGUCUDWEWIWKMNZWJWLKZWEWIWFBJI
    ZWKMWBWBMUEWEUFULWEAWFMNZWIWSMNZWCWTWDAUGUHWCWDWTXAOZWCWFWBEZWDXBUIWCWMXCWO
    WFUJPZWCXCWDXBAWFBUKVDUMUNQWEBWFJIZWGWFJIZWSWKMWEBWGMNZXEXFMNZWDXGWCBUGUOWC
    XCWDXGXHOZXDWDWGWBEZXCXIUIWDWNXJWPWGUJPZWDXJXCXIBWGWFUKVDUMUPQBWFUQWGWFUQUR
    USWEWIWBEWKWBEZWQWROABWBWBWBJRUTWCXCXJXLWDXDXKWFWGWBWBWBJRUTUDWIWKVAVBQVCWE
    SZWHTWJXMWMWNUAZSWHTKXNWEWMWCWNWDWCWMWCSZWMTLEZVEXOWFTLWCAFVPZEWFTKXQWBAWBL
    FVFVGZVHAFVIVJVKVLVMWDWNWDSZWNXPVEXSWGTLWDBXQEWGTKXQWBBXRVHBFVIVJVKVLVMVNVO
    WFWGLHLLDLHVQVGVRPXMWIXQEZSWJTKXMXTTXQEZYATWBECCVSXQWBTXRVHVTXMWITXQABWBJWB
    WBDWBJRVGVRVKVLWIFVIPVCWA $.

  $( Multiplication is compatible with the equivalence relation.  (Contributed
     by Mario Carneiro, 8-May-2013.)  (New usage is discouraged.) $)
  mulerpq $p |- ( ( /Q ` A ) .Q ( /Q ` B ) ) = ( /Q ` ( A .pQ B ) ) $=
    ( cnpi cxp wcel cerq cfv cmq co cmpq wceq cnq ceq wbr wb mpbid mulpqf wn c0
    syl wa nqercl mulpqnq syl2an wer enqer nqerrel adantr elpqn mulerpqlem 3exp
    a1i mpd imp adantl mpan9 mulcompq 3brtr3g ertrd fovcl nqereq syl2anc eqtr4d
    0nnq cdm nqerf fdmi eleq2i ndmfv sylnbir eleq1d mtbiri con4i anim12i mulnqf
    wi con3i ndmov 0nelxp mtbir pm2.61i ) ACCDZEZBWBEZUAZAFGZBFGZHIZABJIZFGZKWE
    WHWFWGJIZFGZWJWCWFLEZWGLEZWHWLKWDAUBZBUBZWFWGUCUDWEWIWKMNZWJWLKZWEWIWFBJIZW
    KMWBWBMUEWEUFULWEAWFMNZWIWSMNZWCWTWDAUGUHWCWDWTXAOZWCWFWBEZWDXBVPWCWMXCWOWF
    UITZWCXCWDXBAWFBUJUKUMUNPWEBWFJIZWGWFJIZWSWKMWEBWGMNZXEXFMNZWDXGWCBUGUOWCXC
    WDXGXHOZXDWDWGWBEZXCXIVPWDWNXJWPWGUITZWDXJXCXIBWGWFUJUKUMUPPBWFUQWGWFUQURUS
    WEWIWBEWKWBEZWQWROABWBWBWBJQUTWCXCXJXLWDXDXKWFWGWBWBWBJQUTUDWIWKVAVBPVCWERZ
    WHSWJXMWMWNUAZRWHSKXNWEWMWCWNWDWCWMWCRZWMSLEZVDXOWFSLWCAFVEZEWFSKXQWBAWBLFV
    FVGZVHAFVIVJVKVLVMWDWNWDRZWNXPVDXSWGSLWDBXQEWGSKXQWBBXRVHBFVIVJVKVLVMVNVQWF
    WGLHLLDLHVOVGVRTXMWIXQEZRWJSKXMXTSXQEZYASWBECCVSXQWBSXRVHVTXMWISXQABWBJWBWB
    DWBJQVGVRVKVLWIFVITVCWA $.

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( Addition of positive fractions is associative.  (Contributed by NM,
       2-Sep-1995.)  (Revised by Mario Carneiro, 28-Apr-2013.)
       (New usage is discouraged.) $)
    addassnq $p |- ( ( A +Q B ) +Q C ) = ( A +Q ( B +Q C ) ) $=
      ( vx cnq wcel cplq wceq cplpq cerq cfv c2nd cmi cpli cop cnpi syl2anc syl
      co mulclpi vy vz w3a c1st addasspi ovex fvex cv mulcompi distrpi mulasspi
      caovdir oveq1i eqtri caov32 oveq2i oveq12i 3eqtr4i opeq12i elpqn 3ad2ant1
      cxp 3ad2ant2 addpipq2 relxp 3ad2ant3 1st2nd sylancr oveq12d xp1st addclpi
      wrel xp2nd addpipq syl22anc eqtrd 3eqtr4a adderpq 3eqtr4g addpqnq 3adant3
      fveq2d nqerid eqcomd 3adant1 3eqtr4d addnqf fdmi 0nnq ndmovass pm2.61i )
      AEFZBEFZCEFZUCZABGSZCGSZABCGSZGSZHWOABISZJKZCJKZGSZAJKZBCISZJKZGSZWQWSWOW
      TCISZJKAXEISZJKXCXGWOXHXIJWOAUDKZBLKZMSZBUDKZALKZMSZNSZCLKZMSZCUDKZXNXKMS
      ZMSZNSZXTXQMSZOZXJXKXQMSZMSZXMXQMSZXSXKMSZNSZXNMSZNSZXNYEMSZOZXHXIYBYKYCY
      LYFXOXQMSZNSZYANSYFYNYANSZNSYBYKYFYNYAUEXRYOYANXRXLXQMSZYNNSYODUAUBXLXOXQ
      NMXJXKMUFXMXNMUFCLUGZDUHZUAUHZUIZYSYTUBUHZUJZULYQYFYNNXJXKXQUKUMUNUMYJYPY
      FNYJYGXNMSZYHXNMSZNSYPDUAUBYGYHXNNMXMXQMUFXSXKMUFALUGZUUAUUCULUUDYNUUEYAN
      DUAUBXMXQXNMBUDUGYRUUFUUAYSYTUUBUKUOUUEXSXKXNMSZMSYAXSXKXNUKUUGXTXSMXKXNU
      IUPUNUQUNUPURXNXKXQUKUSWOXHXPXTOZXSXQOZISZYDWOWTUUHCUUIIWOAPPVBZFZBUUKFZW
      TUUHHWLWMUULWNAUTVAZWMWLUUMWNBUTVCZABVDQWOUUKVLZCUUKFZCUUIHPPVEZWNWLUUQWM
      CUTVFZCUUKVGVHVIWOXPPFZXTPFZXSPFZXQPFZUUJYDHWOXLPFZXOPFZUUTWOXJPFZXKPFZUV
      DWOUULUVFUUNAPPVJRZWOUUMUVGUUOBPPVMRZXJXKTQWOXMPFZXNPFZUVEWOUUMUVJUUOBPPV
      JRZWOUULUVKUUNAPPVMRZXMXNTQXLXOVKQWOUVKUVGUVAUVMUVIXNXKTQWOUUQUVBUUSCPPVJ
      RZWOUUQUVCUUSCPPVMRZXPXTXSXQVNVOVPWOXIXJXNOZYIYEOZISZYMWOAUVPXEUVQIWOUUPU
      ULAUVPHUURUUNAUUKVGVHWOUUMUUQXEUVQHUUOUUSBCVDQVIWOUVFUVKYIPFZYEPFZUVRYMHU
      VHUVMWOYGPFZYHPFZUVSWOUVJUVCUWAUVLUVOXMXQTQWOUVBUVGUWBUVNUVIXSXKTQYGYHVKQ
      WOUVGUVCUVTUVIUVOXKXQTQXJXNYIYEVNVOVPVQWBWTCVRAXEVRVSWOWPXACXBGWLWMWPXAHW
      NABVTWAWNWLCXBHWMWNXBCCWCWDVFVIWOAXDWRXFGWLWMAXDHWNWLXDAAWCWDVAWMWNWRXFHW
      LBCVTWEVIWFABCEGEEVBEGWGWHWIWJWK $.

    $( Multiplication of positive fractions is associative.  (Contributed by
       NM, 1-Sep-1995.)  (Revised by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    mulassnq $p |- ( ( A .Q B ) .Q C ) = ( A .Q ( B .Q C ) ) $=
      ( cnq wcel cmq co wceq cmpq cerq cfv c1st cmi cop syl2anc oveq12d mulclpi
      c2nd cnpi syl w3a mulasspi opeq12i elpqn 3ad2ant1 3ad2ant2 mulpipq2 relxp
      cxp wrel 3ad2ant3 1st2nd sylancr xp1st xp2nd mulpipq eqtrd 3eqtr4a fveq2d
      mulerpq 3eqtr4g mulpqnq 3adant3 nqerid eqcomd 3adant1 3eqtr4d mulnqf fdmi
      syl22anc 0nnq ndmovass pm2.61i ) ADEZBDEZCDEZUAZABFGZCFGZABCFGZFGZHVQABIG
      ZJKZCJKZFGZAJKZBCIGZJKZFGZVSWAVQWBCIGZJKAWGIGZJKWEWIVQWJWKJVQALKZBLKZMGZC
      LKZMGZARKZBRKZMGZCRKZMGZNZWLWMWOMGZMGZWQWRWTMGZMGZNZWJWKWPXDXAXFWLWMWOUBW
      QWRWTUBUCVQWJWNWSNZWOWTNZIGZXBVQWBXHCXIIVQASSUIZEZBXKEZWBXHHVNVOXLVPAUDUE
      ZVOVNXMVPBUDUFZABUGOVQXKUJZCXKEZCXIHSSUHZVPVNXQVOCUDUKZCXKULUMPVQWNSEZWSS
      EZWOSEZWTSEZXJXBHVQWLSEZWMSEZXTVQXLYDXNASSUNTZVQXMYEXOBSSUNTZWLWMQOVQWQSE
      ZWRSEZYAVQXLYHXNASSUOTZVQXMYIXOBSSUOTZWQWRQOVQXQYBXSCSSUNTZVQXQYCXSCSSUOT
      ZWNWSWOWTUPVJUQVQWKWLWQNZXCXENZIGZXGVQAYNWGYOIVQXPXLAYNHXRXNAXKULUMVQXMXQ
      WGYOHXOXSBCUGOPVQYDYHXCSEZXESEZYPXGHYFYJVQYEYBYQYGYLWMWOQOVQYIYCYRYKYMWRW
      TQOWLWQXCXEUPVJUQURUSWBCUTAWGUTVAVQVRWCCWDFVNVOVRWCHVPABVBVCVPVNCWDHVOVPW
      DCCVDVEUKPVQAWFVTWHFVNVOAWFHVPVNWFAAVDVEUEVOVPVTWHHVNBCVBVFPVGABCDFDDUIDF
      VHVIVKVLVM $.
  $}

  ${
    $d A b c $.  $d B b c $.  $d C c $.
    $( Lemma for distributive law: cancellation of common factor.  (Contributed
       by NM, 2-Sep-1995.)  (Revised by Mario Carneiro, 8-May-2013.)
       (New usage is discouraged.) $)
    mulcanenq $p |- ( ( A e. N. /\ B e. N. /\ C e. N. ) ->
      <. ( A .N B ) , ( A .N C ) >. ~Q <. B , C >. ) $=
      ( vb vc cnpi wcel cmi co cop ceq wbr wa cv wi wceq oveq2 breq12d mulasspi
      imbi2d opeq1d opeq1 opeq2d w3a mulcompi oveq2i 3eqtr4i wb mulclpi 3adant3
      opeq2 3adant2 3simpc enqbreq syl21anc mpbiri 3expb expcom vtocl2ga impcom
      3impb ) AFGZBFGZCFGZABHIZACHIZJZBCJZKLZVCVDMVBVIVBADNZHIZAENZHIZJZVJVLJZK
      LZOVBVEVMJZBVLJZKLZOVBVIODEBCFFVJBPZVPVSVBVTVNVQVOVRKVTVKVEVMVJBAHQUAVJBV
      LUBRTVLCPZVSVIVBWAVQVGVRVHKWAVMVFVEVLCAHQUCVLCBUKRTVBVJFGZVLFGZMZVPVBWBWC
      VPVBWBWCUDZVPVKVLHIZVMVJHIZPZAVJVLHIZHIAVLVJHIZHIWFWGWIWJAHVJVLUEUFAVJVLS
      AVLVJSUGWEVKFGZVMFGZWDVPWHUHVBWBWKWCAVJUIUJVBWCWLWBAVLUIULVBWBWCUMVKVMVJV
      LUNUOUPUQURUSUTVA $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( Multiplication of positive fractions is distributive.  (Contributed by
       NM, 2-Sep-1995.)  (Revised by Mario Carneiro, 28-Apr-2013.)
       (New usage is discouraged.) $)
    distrnq $p |- ( A .Q ( B +Q C ) ) = ( ( A .Q B ) +Q ( A .Q C ) ) $=
      ( cnq wcel cplq co cmq wceq cerq cfv cplpq cmpq c1st cmi c2nd cop mulclpi
      cnpi syl2anc vx vy w3a ceq wbr cpli mulcompi oveq1i fvex mulasspi caov411
      vz eqtri oveq12i distrpi 3eqtr2i caov12 oveq2i opeq12i cxp elpqn 3ad2ant1
      xp2nd xp1st 3ad2ant2 3ad2ant3 addclpi mulcanenq syl3anc syl5eqbr mulpipq2
      cv syl oveq12d addpipq syl22anc eqtrd wrel relxp sylancr addpipq2 mulpipq
      1st2nd 3brtr4d wb mulpqf fovcl addpqf nqereq mpbid eqcomd mulerpq adderpq
      3eqtr4g nqerid addpqnq 3adant1 mulpqnq 3adant3 3adant2 addnqf fdmi mulnqf
      3eqtr4d 0nnq ndmovdistr pm2.61i ) ADEZBDEZCDEZUCZABCFGZHGZABHGZACHGZFGZIX
      KAJKZBCLGZJKZHGZABMGZJKZACMGZJKZFGZXMXPXKAXRMGZJKZYAYCLGZJKZXTYEXKYIYGXKY
      HYFUDUEZYIYGIZXKANKZBNKZOGZAPKZCPKZOGZOGZYLCNKZOGZYOBPKZOGZOGZUFGZUUBYQOG
      ZQZYLYMYPOGZYSUUAOGZUFGZOGZYOUUAYPOGZOGZQZYHYFUDXKUUFYOUUJOGZYOUULOGZQZUU
      MUDUUDUUNUUEUUOUUDYOYLOGZUUGOGZUUQUUHOGZUFGUUQUUIOGUUNYRUURUUCUUSUFYRYMYL
      OGZYQOGUURYNUUTYQOYLYMUGUHUAUBULYMYLYOYPOBNUIANUIZAPUIZUAVLZUBVLZUGZUVCUV
      DULVLUJZCPUIZUKUMUUCYSYLOGZUUBOGUUSYTUVHUUBOYLYSUGUHUAUBULYSYLYOUUAOCNUIU
      VAUVBUVEUVFBPUIZUKUMUNUUQUUGUUHUOYOYLUUIUJUPUUEYOUUAYQOGZOGUUOYOUUAYQUJUV
      JUULYOOUAUBULUUAYOYPOUVIUVBUVGUVEUVFUQURUMUSXKYOSEZUUJSEZUULSEZUUPUUMUDUE
      XKASSUTZEZUVKXHXIUVOXJAVAVBZASSVCVMZXKYLSEZUUISEZUVLXKUVOUVRUVPASSVDVMZXK
      UUGSEZUUHSEZUVSXKYMSEZYPSEZUWAXKBUVNEZUWCXIXHUWEXJBVAVEZBSSVDVMZXKCUVNEZU
      WDXJXHUWHXICVAVFZCSSVCVMZYMYPRTXKYSSEZUUASEZUWBXKUWHUWKUWICSSVDVMZXKUWEUW
      LUWFBSSVCVMZYSUUARTUUGUUHVGTZYLUUIRTXKUVKUUKSEZUVMUVQXKUWLUWDUWPUWNUWJUUA
      YPRTZYOUUKRTYOUUJUULVHVIVJXKYHYNUUBQZYTYQQZLGZUUFXKYAUWRYCUWSLXKUVOUWEYAU
      WRIUVPUWFABVKTXKUVOUWHYCUWSIUVPUWIACVKTVNXKYNSEZUUBSEZYTSEZYQSEZUWTUUFIXK
      UVRUWCUXAUVTUWGYLYMRTXKUVKUWLUXBUVQUWNYOUUARTXKUVRUWKUXCUVTUWMYLYSRTXKUVK
      UWDUXDUVQUWJYOYPRTYNUUBYTYQVOVPVQXKYFYLYOQZUUIUUKQZMGZUUMXKAUXEXRUXFMXKUV
      NVRUVOAUXEISSVSUVPAUVNWCVTXKUWEUWHXRUXFIUWFUWIBCWATVNXKUVRUVKUVSUWPUXGUUM
      IUVTUVQUWOUWQYLYOUUIUUKWBVPVQWDXKYHUVNEZYFUVNEZYJYKWEXKYAUVNEZYCUVNEZUXHX
      KUVOUWEUXJUVPUWFABUVNUVNUVNMWFWGTXKUVOUWHUXKUVPUWIACUVNUVNUVNMWFWGTYAYCUV
      NUVNUVNLWHWGTXKUVOXRUVNEZUXIUVPXKUWEUWHUXLUWFUWIBCUVNUVNUVNLWHWGTAXRUVNUV
      NUVNMWFWGTYHYFWITWJWKAXRWLYAYCWMWNXKAXQXLXSHXHXIAXQIXJXHXQAAWOWKVBXIXJXLX
      SIXHBCWPWQVNXKXNYBXOYDFXHXIXNYBIXJABWRWSXHXJXOYDIXIACWRWTVNXDABCDFHDDUTZD
      FXAXBXEUXMDHXCXBXFXG $.
  $}

  $( The equivalence class of ratio 1.  (Contributed by NM, 4-Mar-1996.)
     (Revised by Mario Carneiro, 28-Apr-2013.)  (New usage is discouraged.) $)
  1nqenq $p |- ( A e. N. -> 1Q ~Q <. A , A >. ) $=
    ( cnpi wcel cop c1q ceq cxp wer enqer a1i c1o cmi mulidpi opeq12d mulcanenq
    co wbr 1pi mp3an23 df-1nq syl6breqr eqbrtrrd ersym ) ABCZAADZEFBBGZUFFHUDIJ
    UDAKLPZUGDZUEEFUDUGAUGAAMZUINUDUHKKDZEFUDKBCZUKUHUJFQRRAKKOSTUAUBUC $.

  ${
    $d x y A $.
    $( Multiplication identity element for positive fractions.  (Contributed by
       NM, 3-Mar-1996.)  (Revised by Mario Carneiro, 28-Apr-2013.)
       (New usage is discouraged.) $)
    mulidnq $p |- ( A e. Q. -> ( A .Q 1Q ) = A ) $=
      ( cnq wcel c1q cmq co cmpq cerq cfv wceq 1nq mulpqnq cop c1o cmi cnpi a1i
      syl mulidpi 3eqtrd mpan2 c1st c2nd wrel relxp elpqn 1st2nd sylancr df-1nq
      cxp oveq12d xp1st xp2nd 1pi mulpipq syl22anc opeq12d eqtr4d fveq2d nqerid
      ) ABCZADEFZADGFZHIZAHIAVADBCVBVDJKADLUAVAVCAHVAVCAUBIZAUCIZMZAVAVCVGNNMZG
      FZVENOFZVFNOFZMZVGVAAVGDVHGVAPPUJZUDAVMCZAVGJPPUEAUFZAVMUGUHZDVHJVAUIQUKV
      AVEPCZVFPCZNPCZVSVIVLJVAVNVQVOAPPULZRVAVNVRVOAPPUMZRVSVAUNQZWBVEVFNNUOUPV
      AVNVLVGJVOVNVJVEVKVFVNVQVJVEJVTVESRVNVRVKVFJWAVFSRUQRTVPURUSAUTT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d r s t x y $.
    $( Relationship between reciprocal and multiplication on positive
       fractions.  (Contributed by NM, 6-Mar-1996.)  (Revised by Mario
       Carneiro, 28-Apr-2015.)  (New usage is discouraged.) $)
    recmulnq $p |- ( A e. Q. ->
      ( ( *Q ` A ) = B <-> ( A .Q B ) = 1Q ) ) $=
      ( vx vy cnq wcel cvv crq cfv wceq cmq co c1q wa 1nq syl cv cop cerq cnpi
      vr vs vt fvex a1i eleq1 syl5ibcom wi id syl6eqel cxp mulnqf fdmi ndmovrcl
      0nnq simprd elex wb oveq1 eqeq1d oveq2 wex weu c2nd c1st cmpq nqerid wrel
      cmi relxp elpqn 1st2nd sylancr fveq2d eqtr3d oveq1d mulerpq xp1st mulpipq
      syl6eq xp2nd syl22anc opeq2i ax-mp ceq wbr mulclpi syl2anc 1nqenq opelxpi
      mulcompi nqereq mpbid syl5reqr 3eqtrd spcev wmo mulcomnq mulassnq mulidnq
      caovmo eu5 mpbiran2 sylibr copab wtru wss ccnv cima cnvimass df-rq eqcomi
      csn cdm 3sstr4i relss mp2 eleq2i wf wfn fniniseg mp2b ancom mpbiri simpld
      ffn 2thd pm5.32i df-ov eqeq1i anbi1i 3bitr2ri bitri 3bitri opabbi2dv trud
      fvopab3g ex pm5.21ndd ) AEFZBGFZAHIZBJZABKLZMJZYTUUBGFZUUCUUAUUFYTAHUDUEU
      UBBGUFUGUUEUUAUHYTUUEBEFZUUAUUEYTUUGUUEUUDEFYTUUGNUUEUUDMEUUEUIOUJABEKEEU
      KZEKULUMZUOUNPUPBEUQPUEYTUUAUUCUUEURCQZDQZKLZMJZAUUKKLZMJUUECDABEGHUUJAJU
      ULUUNMUUJAUUKKUSUTUUKBJUUNUUDMUUKBAKVAUTUUJEFZUUMDVBZUUMDVCZUUOUUJUUJVDIZ
      UUJVEIZRZSIZKLZMJZUUPUUOUVBUUSUURRZUUTVFLZSIZUUSUURVILZUVGRZSIZMUUOUVBUVD
      SIZUVAKLUVFUUOUUJUVJUVAKUUOUUJSIUUJUVJUUJVGUUOUUJUVDSUUOTTUKZVHUUJUVKFZUU
      JUVDJTTVJUUJVKZUUJUVKVLVMVNVOVPUVDUUTVQVTUUOUVEUVHSUUOUVEUVGUURUUSVILZRZU
      VHUUOUUSTFZUURTFZUVQUVPUVEUVOJUUOUVLUVPUVMUUJTTVRPZUUOUVLUVQUVMUUJTTWAPZU
      VSUVRUUSUURUURUUSVSWBUVNUVGUVGUURUUSWKWCVTVNUUOMMSIZUVIMEFZUVTMJOMVGWDUUO
      MUVHWEWFZUVTUVIJZUUOUVGTFZUWBUUOUVPUVQUWDUVRUVSUUSUURWGWHZUVGWIPUUOMUVKFZ
      UVHUVKFZUWBUWCURUWAUWFOMVKWDUUOUWDUWDUWGUWEUWEUVGUVGTTWJWHMUVHWLVMWMWNWOU
      UMUVCDUVAUUTSUDUUKUVAJUULUVBMUUKUVAUUJKVAUTWPPUUQUUPUUMDWQUAUBUCDUUJMEKOU
      UIUOUAQZUBQZWRUWHUWIUCQWSUWHWTXAUUMDXBXCXDHUUOUUMNZCDXEJXFUWJCDHHUUHXGUUH
      VHHVHKXHMXMZXIZKXNZHUUHKUWKXJXKUWMUUHUUIXLXOEEVJHUUHXPXQUUJUUKRZHFZUWJURX
      FUWOUWNUWLFZUWNUUHFZUWNKIZMJZNZUWJHUWLUWNXKXRUUHEKXSKUUHXTUWPUWTURULUUHEK
      YFUUHMUWNKYAYBUWTUWSUWQNZUWJUWQUWSYCUWJUUMUUONUUMUWQNUXAUUOUUMYCUUMUWQUUO
      UUMUWQUUOUUMUUOUUKEFZNZUWQUUMUULEFZUXCUUMUXDUWAOUULMEUFYDUUJUUKEKUUIUOUNP
      ZUUJUUKEEWJPUUMUUOUXBUXEYEYGYHUUMUWSUWQUULUWRMUUJUUKKYIYJYKYLYMYNUEYOYPYQ
      YRYS $.
  $}

  $( A positive fraction times its reciprocal is 1.  (Contributed by NM,
     6-Mar-1996.)  (Revised by Mario Carneiro, 8-May-2013.)
     (New usage is discouraged.) $)
  recidnq $p |- ( A e. Q. -> ( A .Q ( *Q ` A ) ) = 1Q ) $=
    ( cnq wcel crq cfv wceq cmq co c1q eqid recmulnq mpbii ) ABCADEZMFAMGHIFMJA
    MKL $.

  $( Closure law for positive fraction reciprocal.  (Contributed by NM,
     6-Mar-1996.)  (Revised by Mario Carneiro, 8-May-2013.)
     (New usage is discouraged.) $)
  recclnq $p |- ( A e. Q. -> ( *Q ` A ) e. Q. ) $=
    ( cnq wcel crq cfv cmq co c1q recidnq 1nq syl6eqel cxp mulnqf fdmi ndmovrcl
    wa 0nnq syl simprd ) ABCZTADEZBCZTAUAFGZBCTUBPTUCHBAIJKAUABFBBLBFMNQORS $.

  ${
    $d A x $.
    $( Reciprocal of reciprocal of positive fraction.  (Contributed by NM,
       26-Apr-1996.)  (Revised by Mario Carneiro, 29-Apr-2013.)
       (New usage is discouraged.) $)
    recrecnq $p |- ( A e. Q. -> ( *Q ` ( *Q ` A ) ) = A ) $=
      ( vx cv crq cfv wceq cnq fveq2 fveq2d id eqeq12d wcel cmq co c1q mulcomnq
      recidnq syl5eq wb recclnq recmulnq syl mpbird vtoclga ) BCZDEZDEZUEFZADEZ
      DEZAFBAGUEAFZUGUJUEAUKUFUIDUEADHIUKJKUEGLZUHUFUEMNZOFZULUMUEUFMNOUFUEPUEQ
      RULUFGLUHUNSUETUFUEUAUBUCUD $.
  $}

  ${
    $d x y $.
    $( Domain of reciprocal on positive fractions.  (Contributed by Mario
       Carneiro, 6-Mar-1996.)  (Revised by Mario Carneiro, 10-Jul-2014.)
       (New usage is discouraged.) $)
    dmrecnq $p |- dom *Q = Q. $=
      ( crq cdm cnq cxp wss cmq ccnv c1q csn cima df-rq cnvimass eqsstri mulnqf
      vx fdmi sseqtri dmss wcel cfv ax-mp dmxpid wbr wceq recclnq opelxpi mpdan
      cv cop co df-ov recidnq syl5eqr wf wfn wa ffn fniniseg sylanbrc syl6eleqr
      wb mp2b df-br sylibr vex fvex breldm syl ssriv eqssi ) ABZCVKCCDZBZCAVLEV
      KVMEAFBZVLAFGHIZJZVNKFVOLMVLCFNPQAVLRUACUBQOCVKOUHZCSZVQVQATZAUCZVQVKSVRV
      QVSUIZASVTVRWAVPAVRWAVLSZWAFTZHUDZWAVPSZVRVSCSWBVQUEVQVSCCUFUGVRWCVQVSFUJ
      HVQVSFUKVQULUMVLCFUNFVLUOWEWBWDUPVANVLCFUQVLHWAFURVBUSKUTVQVSAVCVDVQVSAOV
      EVQAVFVGVHVIVJ $.
  $}

  ${
    $d r s t x y z $.
    $( 'Less than' is a strict ordering on positive fractions.  (Contributed by
       NM, 19-Feb-1996.)  (Revised by Mario Carneiro, 4-May-2013.)
       (New usage is discouraged.) $)
    ltsonq $p |- <Q Or Q. $=
      ( vr vs vt cnq cltq cv wcel wa c1st cfv c2nd cmi co clti wbr cnpi ordpinq
      wb syl fvex vx vy vz wceq wo wn elpqn adantr xp1st adantl mulclpi syl2anc
      cxp xp2nd wor ltsopi sotric mpan fveq2 eqcomd oveq12d ceq enqbreq2 syl2an
      3expia sylbird impbid2 ancoms orbi12d notbid 3bitr4d w3a 3adant3 3ad2ant3
      enqeq ltmpi 3syl bitrd 3adant1 3ad2ant1 anbi12d mulcompi mulasspi breq12i
      caov13 ltrelpi syl5eqbrr sylan2b syl6bi 3adant2 3ad2ant2 sylibrd isso2i
      sotri ) UAUBUCDEUAFZDGZUBFZDGZHZWOIJZWQKJZLMZWQIJZWOKJZLMZNOZXBXEUDZXEXBN
      OZUEZUFZWOWQEOZWOWQUDZWQWOEOZUEZUFWSXBPGZXEPGZXFXJRZWSWTPGZXAPGZXOWSWOPPU
      MZGZXRWPYAWRWOUGZUHZWOPPUISWSWQXTGZXSWRYDWPWQUGZUJZWQPPUNZSWTXAUKULWSXCPG
      ZXDPGZXPWSYDYHYFWQPPUISWSYAYIYCWOPPUNZSXCXDUKULPNUOXOXPHXQUPPXBXENUQURULW
      OWQQZWSXNXIWSXLXGXMXHWSXLXGXLWTXCXAXDLWOWQIUSXLXDXAWOWQKUSUTVAWSXGWOWQVBO
      ZXLWPYAYDYLXGRWRYBYEWOWQVCVDWPWRYLXLWOWQVOVEVFVGWRWPXMXHRWQWOQVHVIVJVKWPW
      RUCFZDGZVLZXKWQYMEOZHZXAWTYMKJZLMZLMZXAYMIJZXDLMZLMZNOZWOYMEOZYOYQYRXBLMZ
      YRXELMZNOZXDXCYRLMZLMZXDUUAXALMZLMZNOZHUUDYOXKUUHYPUUMYOXKXFUUHWPWRXKXFRY
      NYKVMYOYMXTGZYRPGXFUUHRYNWPUUNWRYMUGVNYMPPUNXBXEYRVPVQVRYOYPUUIUUKNOZUUMW
      RYNYPUUORWPWQYMQVSYOYAYIUUOUUMRWPWRYAYNYBVTYJUUIUUKXDVPVQVRWAUUMUUHUUGUUC
      NOZUUDUUJUUGUULUUCNABCXDXCYRLWOKTZWQITYMKTZAFZBFZWBZUUSUUTCFWCZWEABCXDUUA
      XALUUQYMITWQKTZUVAUVBWEWDUUHUUPHYTUUFUUCNABCYRWTXALUURWOITUVCUVAUVBWEUUFU
      UGUUCNPUPWFWNWGWHWIYOUUEYSUUBNOZUUDWPYNUUEUVDRWRWOYMQWJYOYDXSUVDUUDRWRWPY
      DYNYEWKYGYSUUBXAVPVQVRWLWM $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( Compatibility of ordering on equivalent fractions.  (Contributed by
       Mario Carneiro, 9-May-2013.)  (New usage is discouraged.) $)
    lterpq $p |- ( A <pQ B <-> ( /Q ` A ) <Q ( /Q ` B ) ) $=
      ( vx vy cltpq wbr cnpi wcel wa cerq cfv c1st c2nd cmi co clti cnq wb fvex
      syl vz cxp cltq cv copab df-ltpq opabssxp eqsstri brel ltrelnq elpqn fdmi
      nqerf 0nelxp ndmfvrcl anim12i syl2an xp1st xp2nd mulclpi ltmpi nqercl cop
      ordpinq 1st2nd2 breqan12d ordpipq 3syl wceq mulcompi a1i nqerrel enqbreq2
      syl6bb mpdan mpbid eqcomd oveqan12d mulasspi caov411 eqtri 3eqtr4g 3bitrd
      ceq breq12d 3bitr4rd pm5.21nii ) ABEFZAGGUBZHZBWIHZIZAJKZBJKZUCFZABWIWIEE
      CUDZWIHDUDZWIHIWPLKWQMKNOWQLKWPMKNOPFZICDUEWIWIUBCDUFWRCDWIWIUGUHUIWOWMQH
      ZWNQHZIWLWMWNQQUCUJUIWSWMWIHZWNWIHZWLWTWMUKZWNUKZXAWJXBWKAWIJWIQJUMULZGGU
      NZUOBWIJXEXFUOUPUQTWLWMLKZWNMKZNOZWNLKZWMMKZNOZPFZALKZBMKZNOZXINOZXPXLNOZ
      PFZWOWHWLXPGHZXMXSRWJXNGHXOGHXTWKAGGURBGGUSXNXOUTUQXIXLXPVATWJWSWTWOXMRWK
      AVBZBVBZWMWNVDUQWLWHXPBLKZAMKZNOZPFZXIXPNOZXIYENOZPFZXSWLWHXNYDVCZYCXOVCZ
      EFYFWJWKAYJBYKEAGGVEBGGVEVFXNYDYCXOVGVNWLXIGHZYFYIRWJXGGHZXHGHZYLWKWJWSXA
      YMYAXCWMGGURVHWKWTXBYNYBXDWNGGUSVHXGXHUTUQXPYEXIVATWLYGXQYHXRPYGXQVIWLXIX
      PVJVKWLXGYDNOZYCXHNOZNOZXNXKNOZXJXONOZNOZYHXRWJWKYOYRYPYSNWJYRYOWJAWMWDFZ
      YRYOVIZAVLWJXAUUAUUBRWJWSXAYAXCTAWMVMVOVPVQWKBWNWDFZYPYSVIZBVLWKXBUUCUUDR
      WKWTXBYBXDTBWNVMVOVPVRYHYEXINOYQXIYEVJCDUAYCYDXGXHNBLSAMSWMLSWPWQVJZWPWQU
      AUDVSZWNMSVTWAXRXLXPNOYTXPXLVJCDUAXJXKXNXONWNLSWMMSALSUUEUUFBMSVTWAWBWEWC
      WFWG $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( Ordering property of addition for positive fractions.  Proposition
       9-2.6(ii) of [Gleason] p. 120.  (Contributed by NM, 6-Mar-1996.)
       (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    ltanq $p |- ( C e. Q. ->
      ( A <Q B <-> ( C +Q A ) <Q ( C +Q B ) ) ) $=
      ( cltq cnq wcel wbr c1st cfv c2nd cmi clti cpli cnpi syl2anc syl mulcompi
      vx co fvex vy vz cplq cxp addnqf fdmi ltrelnq 0nnq w3a wb ordpinq 3adant3
      cplpq cltpq cop elpqn 3ad2ant3 3ad2ant1 addpipq2 3ad2ant2 breq12d addpqnq
      wceq cerq ancoms 3adant2 3adant1 lterpq syl6bbr xp2nd mulclpi ltmpi xp1st
      ltapi bitrd mulasspi caov411 eqtri oveq2i distrpi 3eqtr2i oveq12i breq12i
      cv syl6bb ordpipq 3bitr4rd ndmovord ) ABCDEUCEEUDEUCUEUFUGUHAEFZBEFZCEFZU
      IZABDGZAHIZBJIZKSZBHIZAJIZKSZLGZCAUCSZCBUCSZDGZWIWJWMWTUJWKABUKULWLCAUMSZ
      CBUMSZUNGZCHIZWRKSZWNCJIZKSZMSZXIWRKSZUOZXGWOKSZWQXIKSZMSZXIWOKSZUOZUNGZX
      CWTWLXDXMXEXRUNWLCNNUDZFZAXTFZXDXMVCWKWIYAWJCUPUQZWIWJYBWKAUPURZCAUSOWLYA
      BXTFZXEXRVCYCWJWIYEWKBUPUTZCBUSOVAWLXCXDVDIZXEVDIZDGXFWLXAYGXBYHDWIWKXAYG
      VCZWJWKWIYICAVBVEVFWJWKXBYHVCZWIWKWJYJCBVBVEVGVAXDXEVHVIWLWTXKXQKSZXPXLKS
      ZLGZXSWLWTXQXHKSZXIXIKSZWPKSZMSZYNYOWSKSZMSZLGZYMWLWTYPYRLGZYTWLYONFZWTUU
      AUJWLXINFZUUCUUBWLYAUUCYCCNNVJPZUUDXIXIVKOWPWSYOVLPWLYNNFZUUAYTUJWLXQNFZX
      HNFZUUEWLUUCWONFZUUFUUDWLYEUUHYFBNNVJPXIWOVKOWLXGNFZWRNFZUUGWLYAUUIYCCNNV
      MPWLYBUUJYDANNVJPXGWRVKOXQXHVKOYPYRYNVNPVOYQYKYSYLLYQYNXQXJKSZMSXQXKKSYKY
      PUUKYNMYPWPYOKSUUKYOWPQRUAUBWNWOXIXIKAHTBJTZCJTZRWDZUAWDZQZUUNUUOUBWDVPZU
      UMVQVRVSXQXHXJVTXQXKQWAYSXLXNKSZXLXOKSZMSXLXPKSYLYNUURYRUUSMYNXHXQKSUURXQ
      XHQRUAUBXGWRXIWOKCHTAJTZUUMUUPUUQUULVQVRYRWSYOKSUUSYOWSQRUAUBWQWRXIXIKBHT
      UUTUUMUUPUUQUUMVQVRWBXLXNXOVTXLXPQWAWCWEXKXLXPXQWFVIWGVOWH $.

    $( Ordering property of multiplication for positive fractions.  Proposition
       9-2.6(iii) of [Gleason] p. 120.  (Contributed by NM, 6-Mar-1996.)
       (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    ltmnq $p |- ( C e. Q. ->
      ( A <Q B <-> ( C .Q A ) <Q ( C .Q B ) ) ) $=
      ( vx vy vz cltq cnq cmq wcel c1st cfv c2nd cmi co clti wbr cnpi fvex wceq
      cxp mulnqf fdmi ltrelnq 0nnq w3a cmpq cltpq wb elpqn 3ad2ant3 xp1st xp2nd
      cop syl mulclpi syl2anc ltmpi cv mulcompi mulasspi breq12i syl6bb ordpipq
      syl6bbr 3ad2ant1 mulpipq2 3ad2ant2 breq12d bitr4d ordpinq 3adant3 mulpqnq
      caov4 cerq ancoms 3adant2 3adant1 lterpq 3bitr4d ndmovord ) ABCGHIHHUAHIU
      BUCUDUEAHJZBHJZCHJZUFZAKLZBMLZNOZBKLZAMLZNOZPQZCAUGOZCBUGOZUHQZABGQZCAIOZ
      CBIOZGQZWEWLCKLZWFNOZCMLZWJNOZUNZWTWINOZXBWGNOZUNZUHQZWOWEWLXAXFNOZXEXCNO
      ZPQZXHWEWLWTXBNOZWHNOZXLWKNOZPQZXKWEXLRJZWLXOUIWEWTRJZXBRJZXPWECRRUAZJZXQ
      WDWBXTWCCUJUKZCRRULUOWEXTXRYACRRUMUOWTXBUPUQWHWKXLURUOXMXIXNXJPDEFWTXBWFW
      GNCKSZCMSZAKSDUSZEUSZUTZYDYEFUSVAZBMSVNDEFWTXBWIWJNYBYCBKSYFYGAMSVNVBVCXA
      XCXEXFVDVEWEWMXDWNXGUHWEXTAXSJZWMXDTYAWBWCYHWDAUJVFCAVGUQWEXTBXSJZWNXGTYA
      WCWBYIWDBUJVHCBVGUQVIVJWBWCWPWLUIWDABVKVLWEWSWMVOLZWNVOLZGQWOWEWQYJWRYKGW
      BWDWQYJTZWCWDWBYLCAVMVPVQWCWDWRYKTZWBWDWCYMCBVMVPVRVIWMWNVSVEVTWA $.
  $}

  $( One is less than two (one plus one).  (Contributed by NM, 13-Mar-1996.)
     (Revised by Mario Carneiro, 10-May-2013.)  (New usage is discouraged.) $)
  1lt2nq $p |- 1Q <Q ( 1Q +Q 1Q ) $=
    ( c1q cerq cfv cplpq co cltq cltpq wbr c1o cop cpli cmi clti wcel 1pi ax-mp
    wceq 3brtr4i df-1nq 1nq cplq 1lt2pi mulidpi addclpi ordpipq oveq12i addpipq
    cnpi mp2an mpbir mp4an opeq12i 3eqtri lterpq mpbi cnq nqerid eqcomi addpqnq
    ) ABCZAADEZBCZAAAUAEZFAVAGHUTVBFHIIJZIIKEZIJZAVAGVDVFGHIILEZVEILEZMHIVEVGVH
    MUBIUHNZVGIQOIUCPZVEUHNZVHVEQVIVIVKOOIIUDUIVEUCPRIIVEIUEUJSVAVDVDDEZVGVGKEZ
    VGJZVFAVDAVDDSSUFVIVIVIVIVLVNQOOOOIIIIUGUKVMVEVGIVGIVGIKVJVJUFVJULUMRAVAUNU
    OUTAAUPNZUTAQTAUQPURVOVOVCVBQTTAAUSUIR $.

  ${
    $d A x y $.  $d B y $.  $d r s t x y $.
    $( The sum of two fractions is greater than one of them.  (Contributed by
       NM, 14-Mar-1996.)  (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    ltaddnq $p |- ( ( A e. Q. /\ B e. Q. ) -> A <Q ( A +Q B ) ) $=
      ( vx vy vr vs vt cv cplq co cltq wbr cnq wceq wcel c1q cmq ltanq addcomnq
      vex id oveq1 breq12d oveq2 breq2d wa 1lt2nq ltmnq mulidnq distrnq oveq12d
      mpbii syl5eq 3brtr3d syl5ib imp addassnq caov12 wb adantl mpbird vtocl2ga
      3brtr3g ) CHZVDDHZIJZKLZAAVEIJZKLAABIJZKLCDABMMVDANZVDAVFVHKVJUAVDAVEIUBU
      CVEBNVHVIAKVEBAIUDUEVDMOZVEMOZUFZVGVEVDIJZVEVFIJZKLZVMVFVDVEVEIJZIJZVNVOK
      VKVLVFVRKLZVLVEVQKLVKVSVLVEPQJZVEPPIJZQJZVEVQKVLPWAKLVTWBKLUGPWAVEUHULVEU
      IZVLWBVTVTIJVQVEPPUJVLVTVEVTVEIWCWCUKUMUNVEVQVDRUOUPVDVESEFGVDVEVEICTDTZW
      DEHZFHZSWEWFGHUQURVCVLVGVPUSVKVDVFVERUTVAVB $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( Ordering on positive fractions in terms of existence of sum.  Definition
       in Proposition 9-2.6 of [Gleason] p. 119.  (Contributed by NM,
       24-Apr-1996.)  (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    ltexnq $p |- ( B e. Q. -> ( A <Q B <-> E. x ( A +Q x ) = B ) ) $=
      ( vy cnq wcel cltq wbr cplq co wceq wa cfv cmi adantr mulclpi syl2anc cop
      cnpi cerq vz cv wex ltrelnq brel c1st c2nd clti ordpinq cpli wb cxp elpqn
      wrex xp1st syl adantl xp2nd ltexpi cplpq wrel relxp 1st2nd sylancr oveq1d
      ad2antrr simpr addpipq syl22anc eqtrd oveq2 fvex mulcompi mulasspi caov12
      distrpi oveq12i eqtr2i oveq2i 3eqtr4g eqcomi a1i opeq12d eqeq2d syl5ibcom
      eqtri fveq2 adderpq nqerid syl5eqr ceq mulcanenq syl3anc ad2antlr opelxpi
      nqereq mpbid eqeq12d syl5ib syld eqeq1d spcev syl6 rexlimdva sylbid mpcom
      breqtrrd eleq1 biimparc addnqf fdmi 0nnq ndmovrcl ltaddnq 3syl breqtrd ex
      exlimdv impbid2 ) CEFZBCGHZBAUBZIJZCKZAUCZBEFZXTLZYAYEBCEEGUDUEYGYABUFMZC
      UGMZNJZCUFMZBUGMZNJZUHHZYEBCUIYGYNYJDUBZUJJZYMKZDSUNZYEYGYJSFZYMSFZYNYRUK
      YGYHSFZYISFZYSYGBSSULZFZUUAYFUUDXTBUMZOZBSSUOUPZYGCUUCFZUUBXTUUHYFCUMZUQZ
      CSSURUPZYHYIPQYGYKSFZYLSFZYTYGUUHUULUUJCSSUOUPZYGUUDUUMUUFBSSURUPZYKYLPQD
      YJYMUSQYGYQYEDSYGYOSFZLZYQBYOYLYINJZRZTMZIJZCKZYEUUQYQBUUSUTJZYLYLNJZYKNJ
      ZUVDYINJZRZKZUVBUUQUVCYHUURNJZYOYLNJZUJJZYLUURNJZRZKYQUVHUUQUVCYHYLRZUUSU
      TJZUVMUUQBUVNUUSUTUUQUUCVAZUUDBUVNKSSVBZYFUUDXTUUPUUEVFBUUCVCVDVEUUQUUAUU
      MUUPUURSFZUVOUVMKYGUUAUUPUUGOYGUUMUUPUUOOYGUUPVGYGUVRUUPYGUUMUUBUVRUUOUUK
      YLYIPQOYHYLYOUURVHVIVJYQUVMUVGUVCYQUVKUVEUVLUVFYQYLYPNJZYLYMNJZUVKUVEYPYM
      YLNVKUVSYLYJNJZYLYONJZUJJUVKYLYJYOVPUWAUVIUWBUVJUJADUAYLYHYINBUGVLBUFVLCU
      GVLYBYOVMYBYOUAUBVNVOYLYOVMVQVRUVEYLYLYKNJZNJUVTYLYLYKVNUWCYMYLNYLYKVMVSW
      FVTUVLUVFKYQUVFUVLYLYLYIVNWAWBWCWDWEUVHUVCTMZUVGTMZKUUQUVBUVCUVGTWGUUQUWD
      UVAUWECUUQUWDBTMZUUTIJUVABUUSWHUUQUWFBUUTIYFUWFBKXTUUPBWIVFVEWJUUQUWECTMZ
      CUUQUVGCWKHZUWEUWGKZUUQUVGYKYIRZCWKUUQUVDSFZUULUUBUVGUWJWKHYGUWKUUPYGUUMU
      UMUWKUUOUUOYLYLPQOZYGUULUUPUUNOZYGUUBUUPUUKOZUVDYKYIWLWMUUQUVPUUHCUWJKUVQ
      XTUUHYFUUPUUIWNZCUUCVCVDXGUUQUVGUUCFZUUHUWHUWIUKUUQUVESFZUVFSFZUWPUUQUWKU
      ULUWQUWLUWMUVDYKPQUUQUWKUUBUWRUWLUWNUVDYIPQUVEUVFSSWOQUWOUVGCWPQWQXTUWGCK
      YFUUPCWIWNVJWRWSWTYDUVBAUUTUUSTVLYBUUTKYCUVACYBUUTBIVKXAXBXCXDXEXEXFXTYDY
      AAXTYDYAXTYDLZBYCCGUWSYCEFZYFYBEFLBYCGHYDUWTXTYCCEXHXIBYBEIEEULEIXJXKXLXM
      BYBXNXOXTYDVGXPXQXRXS $.
  $}

  ${
    $d A x $.
    $( One-half of any positive fraction exists.  Lemma for Proposition
       9-2.6(i) of [Gleason] p. 120.  (Contributed by NM, 16-Mar-1996.)
       (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    halfnq $p |- ( A e. Q. -> E. x ( x +Q x ) = A ) $=
      ( cnq wcel c1q cplq co crq cfv cmq wceq distrnq 1nq addclnq oveq1i oveq2i
      cv eqtr3i mulidnq 3eqtr3i wex mp2an recidnq ax-mp eqtri mulassnq mulcomnq
      oveq12i recclnq syl2anc mp2b syl5eq ovex oveq12 anidms eqeq1d spcev syl )
      BCDZBEEFGZHIZJGZVBFGZBKZAQZVEFGZBKZAUAUSVCBEJGZBBVAVAFGZJGVCVHBVAVALVIEBJ
      UTVIJGZVAJGZUTVAJGZVIEVJUTVAJVJVLVLFGUTUTVAVALVLEVLEFUTCDZVLEKECDZVNVMMME
      ENUBZUTUCUDZVPUHUEOVIVLJGZVIEJGZVKVIVLEVIJVPPVIUTJGZVAJGVQVKVIUTVAUFVSVJV
      AJVIUTUGORVMVICDZVRVIKVOVMVACDZWAVTUTUIZWBVAVANUJVISUKTVPTPRBSULVGVDAVBBV
      AJUMVEVBKZVFVCBWCVFVCKVEVBVEVBFUNUOUPUQUR $.
  $}

  ${
    $d x A $.
    $( The is no smallest positive fraction.  (Contributed by NM,
       26-Apr-1996.)  (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    nsmallnq $p |- ( A e. Q. -> E. x x <Q A ) $=
      ( cnq wcel cv cplq co wceq wex cltq wbr halfnq eleq1a wa addnqf fdmi 0nnq
      cxp ndmovrcl ltaddnq syl syl6 breq2 mpbidi eximdv mpd ) BCDZAEZUHFGZBHZAI
      UHBJKZAIABLUGUJUKAUJUHUIJKZUKUGUGUJUICDZULBCUIMUMUHCDZUNNULUHUHCFCCRCFOPQ
      SUHUHTUAUBUIBUHJUCUDUEUF $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( There exists a number between any two positive fractions.  Proposition
       9-2.6(i) of [Gleason] p. 120.  (Contributed by NM, 17-Mar-1996.)
       (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    ltbtwnnq $p |- ( A <Q B <-> E. x ( A <Q x /\ x <Q B ) ) $=
      ( vy vz cltq wbr cv wa wex cnq wcel ltrelnq brel simprd cplq co simpld ex
      wceq ltexnq eleq1 biimparc cxp addnqf fdmi 0nnq ndmovrcl nsmallnq ltaddnq
      syl2an ltanq biimpa sylan simplr breqtrd ovex breq2 breq1 anbi12d syl2anc
      syl spcev exlimdv syl5 mpd sylbid mpcom ltsonq sotri exlimiv impbii ) BCF
      GZBAHZFGZVNCFGZIZAJZCKLZVMVRVMBKLZVSBCKKFMNOVSVMBDHZPQZCTZDJVRDBCUAVSWCVR
      DVSWCVRVSWCIZWAKLZVRWDVTWEWDWBKLZVTWEIWCWFVSWBCKUBUCBWAKPKKUDKPUEUFUGUHVB
      ZOWEEHZWAFGZEJWDVREWAUIWDWIVREWDWIVRWDWIIZBBWHPQZFGZWKCFGZVRWDVTWHKLZWLWI
      WDVTWEWGRZWIWNWEWHWAKKFMNRBWHUJUKWJWKWBCFWDVTWIWKWBFGZWOVTWIWPWHWABULUMUN
      VSWCWIUOUPVQWLWMIAWKBWHPUQVNWKTVOWLVPWMVNWKBFURVNWKCFUSUTVCVASVDVEVFSVDVG
      VHVQVMABVNCFKVIMVJVKVL $.
  $}

  ${
    $d A x y $.  $d B y $.
    $( Ordering property of reciprocal for positive fractions.  Proposition
       9-2.6(iv) of [Gleason] p. 120.  (Contributed by NM, 9-Mar-1996.)
       (Revised by Mario Carneiro, 10-May-2013.)
       (New usage is discouraged.) $)
    ltrnq $p |- ( A <Q B <-> ( *Q ` B ) <Q ( *Q ` A ) ) $=
      ( vx vy cltq wbr cnq wcel wa crq cfv ltrelnq brel syl wb wceq co mulcomnq
      cmq c1q dmrecnq 0nnq ndmfvrcl anim12ci cv breq1 fveq2 breq2d breq2 breq1d
      bibi12d recclnq mulclnq syl2an ltmnq 3eqtr2i recidnq oveq2d syl5eq oveq2i
      mulassnq mulidnq sylan9eq eqtri sylan9eqr breq12d vtocl2ga pm5.21nii
      bitrd ) ABEFZAGHZBGHZIZBJKZAJKZEFZABGGELMVPVNGHZVOGHZIVMVNVOGGELMVQVLVRVK
      BGJUAUBUCAGJUAUBUCUDNCUEZDUEZEFZVTJKZVSJKZEFZOAVTEFZWBVOEFZOVJVPOCDABGGVS
      APZWAWEWDWFVSAVTEUFWGWCVOWBEVSAJUGUHUKVTBPZWEVJWFVPVTBAEUIWHWBVNVOEVTBJUG
      UJUKVSGHZVTGHZIZWAWCWBSQZVSSQZWLVTSQZEFZWDWKWLGHZWAWOOWIWCGHZWBGHZWPWJVSU
      LZVTULZWCWBUMUNVSVTWLUONWKWMWBWNWCEWKWMWBVSWCSQZSQZWBWMVSWLSQXAWBSQXBWLVS
      RVSWCWBVAXAWBRUPWIWJXBWBTSQZWBWIXATWBSVSUQURWJWRXCWBPWTWBVBNVCUSWKWNWCVTW
      BSQZSQZWCWNWCWBVTSQZSQXEWCWBVTVAXFXDWCSWBVTRUTVDWJWIXEWCTSQZWCWJXDTWCSVTU
      QURWIWQXGWCPWSWCVBNVEUSVFVIVGVH $.
  $}

  ${
    $d A x y $.  $d B y $.
    $( For any fraction, there is an integer that is greater than it.  This is
       also known as the "archimedean property".  (Contributed by Mario
       Carneiro, 10-May-2013.)  (New usage is discouraged.) $)
    archnq $p |- ( A e. Q. -> E. x e. N. A <Q <. x , 1o >. ) $=
      ( cnq wcel c1st cfv c1o cpli cnpi cop cltq wbr wrex syl 1pi cmi clti wceq
      co syl2anc cv cxp elpqn xp1st addclpi sylancl c2nd wn xp2nd mulclpi oveq2
      wa eqeq1d rspcev mp2an ltexpi mpbiri nlt1pi wb ltmpi mulidpi breq2d bitrd
      eqid mtbii ltsopi ltrelpi sotri3 syl3anc ordpinq mpdan elexi op2nd oveq2i
      pinq ovex syl5eq op1st oveq1i a1i breq12d mpbird opeq1 ) BCDZBEFZGHSZIDZB
      WFGJZKLZBAUAZGJZKLZAIMWDWEIDZGIDZWGWDBIIUBDZWMBUCZBIIUDNZOWEGUEUFZWDWIWEW
      FBUGFZPSZQLZWDWTIDZWEWFQLZWTWFQLZUHXAWDWGWSIDZXBWRWDWOXEWPBIIUINWFWSUJTWD
      WMWGXCWQWRWMWGULXCWEWJHSZWFRZAIMZWNWFWFRZXHOWFVDXGXIAGIWJGRXFWFWFWJGWEHUK
      UMUNUOAWEWFUPUQTWDWSGQLZXDWSURWDXJWTWFGPSZQLZXDWDWGXJXLUSWRWSGWFUTNWDXKWF
      WTQWDWGXKWFRWRWFVANVBVCVEWEWFWTQIVFVGVHVIWDWIWEWHUGFZPSZWHEFZWSPSZQLZXAWD
      WHCDZWIXQUSWDWGXRWRWFVONBWHVJVKWDXNWEXPWTQWDXNWEGPSZWEXMGWEPWFGWEGHVPZGIO
      VLZVMVNWDWMXSWERWQWEVANVQXPWTRWDXOWFWSPWFGXTYAVRVSVTWAVCWBWLWIAWFIWJWFRWK
      WHBKWJWFGWCVBUNT $.
  $}

  ${
    $d x y z $.
    $( Define the set of positive reals.  A "Dedekind cut" is a partition of
       the positive rational numbers into two classes such that all the numbers
       of one class are less than all the numbers of the other.  A positive
       real is defined as the lower class of a Dedekind cut.  Definition 9-3.1
       of [Gleason] p. 121.  (Note:  This is a "temporary" definition used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.)  (Contributed by NM, 31-Oct-1995.)
       (New usage is discouraged.) $)
    df-np $a |- P. = { x | ( ( (/) C. x /\ x C. Q. ) /\
         A. y e. x ( A. z ( z <Q y -> z e. x ) /\ E. z e. x y <Q z ) ) } $.
  $}

  $( Define the positive real constant 1.  This is a "temporary" set used in
     the construction of complex numbers ~ df-c , and is intended to be used
     only by the construction.  Definition of [Gleason] p. 122.  (Contributed
     by NM, 13-Mar-1996.)  (New usage is discouraged.) $)
  df-1p $a |- 1P = { x | x <Q 1Q } $.

  ${
    $d x y z w v u $.
    $( Define addition on positive reals.  This is a "temporary" set used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.  From Proposition 9-3.5 of [Gleason] p. 123.
       (Contributed by NM, 18-Nov-1995.)  (New usage is discouraged.) $)
    df-plp $a |- +P. = ( x e. P. , y e. P. |->
                   { w | E. v e. x E. u e. y w = ( v +Q u ) } ) $.

    $( Define multiplication on positive reals.  This is a "temporary" set used
       in the construction of complex numbers ~ df-c , and is intended to be
       used only by the construction.  From Proposition 9-3.7 of [Gleason]
       p. 124.  (Contributed by NM, 18-Nov-1995.)
       (New usage is discouraged.) $)
    df-mp $a |- .P. = ( x e. P. , y e. P. |->
                   { w | E. v e. x E. u e. y w = ( v .Q u ) } ) $.

    $( Define ordering on positive reals.  This is a "temporary" set used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.  From Proposition 9-3.2 of [Gleason] p. 122.
       (Contributed by NM, 14-Feb-1996.)  (New usage is discouraged.) $)
    df-ltp $a |- <P = { <. x , y >. | ( ( x e. P. /\ y e. P. ) /\
                 x C. y ) } $.
  $}

  ${
    $d x y z $.
    $( The class of positive reals is a set.  (Contributed by NM,
       31-Oct-1995.)  (New usage is discouraged.) $)
    npex $p |- P. e. _V $=
      ( vx vz vy cnp cnq cpw nqex pwex c0 cv wpss wa cltq wbr wel wal wrex wral
      wi cab wss pssss ad2antlr ss2abi df-np df-pw 3sstr4i ssexi ) DEFZEGHIAJZK
      ZUJEKZLBJZCJZMNBAOSBPUNUMMNBUJQLCUJRZLZATUJEUAZATDUIUPUQAULUQUKUOUJEUBUCU
      DACBUEAEUFUGUH $.

  $}

  ${
    $d x y z A $.
    $( Membership in positive reals.  (Contributed by NM, 16-Feb-1996.)
       (New usage is discouraged.) $)
    elnp $p |- ( A e. P. <-> ( ( (/) C. A /\ A C. Q. ) /\
       A. x e. A ( A. y ( y <Q x -> y e. A ) /\ E. y e. A x <Q y ) ) ) $=
      ( vz cnp wcel cvv c0 wpss cnq wa cv cltq wbr wal wrex wral elex anbi12d
      wi wss pssss nqex ssex syl ad2antlr wceq psseq2 psseq1 eleq2 imbi2d rexeq
      albidv raleqbi1dv df-np elab2g pm5.21nii ) CEFCGFZHCIZCJIZKZBLZALZMNZVBCF
      ZTZBOZVCVBMNZBCPZKZACQZKZCERUTURUSVKUTCJUAURCJUBCJUCUDUEUFHDLZIZVMJIZKZVD
      VBVMFZTZBOZVHBVMPZKZAVMQZKVLDCEGVMCUGZVPVAWBVKWCVNUSVOUTVMCHUHVMCJUISWAVJ
      AVMCWCVSVGVTVIWCVRVFBWCVQVEVDVMCVBUJUKUMVHBVMCULSUNSDABUOUPUQ $.
  $}

  ${
    $d x y z A $.
    $( Membership in positive reals.  (Contributed by Mario Carneiro,
       11-May-2013.)  (New usage is discouraged.) $)
    elnpi $p |- ( A e. P. <-> ( ( A e. _V /\ (/) C. A /\ A C. Q. ) /\
       A. x e. A ( A. y ( y <Q x -> y e. A ) /\ E. y e. A x <Q y ) ) ) $=
      ( vz cnp wcel cvv c0 wpss cnq w3a cv cltq wbr wi wal wrex wa wral anbi12d
      elex simpl1 wceq psseq2 psseq1 eleq2 imbi2d albidv rexeq raleqbi1dv df-np
      wel elab2g id 3expib 3simpc impbid1 anbi1d bitrd pm5.21nii ) CEFZCGFZVBHC
      IZCJIZKZBLZALZMNZVFCFZOZBPZVGVFMNZBCQZRZACSZRZCEUAVBVCVDVOUBVBVAVCVDRZVOR
      ZVPHDLZIZVSJIZRZVHBDULZOZBPZVLBVSQZRZAVSSZRVRDCEGVSCUCZWBVQWHVOWIVTVCWAVD
      VSCHUDVSCJUETWGVNAVSCWIWEVKWFVMWIWDVJBWIWCVIVHVSCVFUFUGUHVLBVSCUITUJTDABU
      KUMVBVQVEVOVBVQVEVBVCVDVEVEUNUOVBVCVDUPUQURUSUT $.
  $}

  ${
    $d x y A $.
    $( A positive real is not empty.  (Contributed by NM, 15-May-1996.)
       (Revised by Mario Carneiro, 11-May-2013.)
       (New usage is discouraged.) $)
    prn0 $p |- ( A e. P. -> A =/= (/) ) $=
      ( vy vx cnp wcel c0 wpss wne cvv cnq w3a cv cltq wbr wi wal wrex wa elnpi
      wral simpl2 sylbi 0pss sylib ) ADEZFAGZAFHUEAIEZUFAJGZKBLZCLZMNUIAEOBPUJU
      IMNBAQRCATZRUFCBASUGUFUHUKUAUBAUCUD $.

    $( A positive real is a subset of the positive fractions.  (Contributed by
       NM, 29-Feb-1996.)  (Revised by Mario Carneiro, 11-May-2013.)
       (New usage is discouraged.) $)
    prpssnq $p |- ( A e. P. -> A C. Q. ) $=
      ( vy vx cnp wcel cvv c0 wpss cnq w3a cv cltq wbr wi wal wrex elnpi simpl3
      wa wral sylbi ) ADEAFEZGAHZAIHZJBKZCKZLMUEAENBOUFUELMBAPSCATZSUDCBAQUBUCU
      DUGRUA $.
  $}

  $( A positive real is a set of positive fractions.  (Contributed by NM,
     13-Mar-1996.)  (Revised by Mario Carneiro, 11-May-2013.)
     (New usage is discouraged.) $)
  elprnq $p |- ( ( A e. P. /\ B e. A ) -> B e. Q. ) $=
    ( cnp wcel cnq prpssnq pssssd sselda ) ACDZAEBIAEAFGH $.

  $( The empty set is not a positive real.  (Contributed by NM, 15-Nov-1995.)
     (New usage is discouraged.) $)
  0npr $p |- -. (/) e. P. $=
    ( c0 wceq cnp wcel wn eqid prn0 necon2bi ax-mp ) AABACDZEAFJAAAGHI $.

  ${
    $d x y A $.  $d x y B $.  $d y C $.
    $( A positive real is closed downwards under the positive fractions.
       Definition 9-3.1 (ii) of [Gleason] p. 121.  (Contributed by NM,
       25-Feb-1996.)  (Revised by Mario Carneiro, 11-May-2013.)
       (New usage is discouraged.) $)
    prcdnq $p |- ( ( A e. P. /\ B e. A ) -> ( C <Q B -> C e. A ) ) $=
      ( vx vy cnp wcel wa cltq wbr wi cvv cnq cxp wrel wceq eleq1 anbi2d wpss
      cv wss ltrelnq relxp relss mp2 brrelexi breq2 anbi12d imbi1d imbi12d wrex
      breq1 wal c0 w3a elnpi simprbi r19.21bi simpld 19.21bi imp vtocl2g sylan2
      wral adantll pm2.43i ex ) AFGZBAGZHZCBIJZCAGZVJVKHZVLVIVKVMVLKZVHVKVICLGV
      NCBIIMMNZUAVOOIOUBMMUCIVOUDUEUFVHDTZAGZHZETZVPIJZHZVSAGZKVJVSBIJZHZWBKVND
      EBCALVPBPZWAWDWBWEVRVJVTWCWEVQVIVHVPBAQRVPBVSIUGUHUIVSCPZWDVMWBVLWFWCVKVJ
      VSCBIULRVSCAQUJVRVTWBVRVTWBKZEVRWGEUMZVPVSIJEAUKZVHWHWIHZDAVHALGUNASAMSUO
      WJDAVDDEAUPUQURUSUTVAVBVCVEVFVG $.
  $}

  $( A positive fraction not in a positive real is an upper bound.  Remark (1)
     of [Gleason] p. 122.  (Contributed by NM, 25-Feb-1996.)
     (New usage is discouraged.) $)
  prub $p |- ( ( ( A e. P. /\ B e. A ) /\ C e. Q. ) ->
             ( -. C e. A -> B <Q C ) ) $=
    ( cnp wcel wa cnq wn wceq cltq wo wi eleq1 biimpcd adantl prcdnq jaod con3d
    wbr adantr wb elprnq wor ltsonq sotric mpan sylan sylibrd ) ADEZBAEZFZCGEZF
    CAEZHZBCIZCBJSZKZHZBCJSZUKUNURLULUKUQUMUKUOUMUPUJUOUMLUIUOUJUMBCAMNOABCPQRT
    UKBGEZULUSURUAZABUBGJUCUTULFVAUDGBCJUEUFUGUH $.

  ${
    $d x y A $.  $d x y B $.
    $( A positive real has no largest member.  Definition 9-3.1(iii) of
       [Gleason] p. 121.  (Contributed by NM, 9-Mar-1996.)  (Revised by Mario
       Carneiro, 11-May-2013.)  (New usage is discouraged.) $)
    prnmax $p |- ( ( A e. P. /\ B e. A ) -> E. x e. A B <Q x ) $=
      ( vy cnp wcel cv cltq wbr wrex wa wceq eleq1 anbi2d breq1 rexbidv imbi12d
      wi wal wpss cvv cnq w3a wral elnpi simprbi r19.21bi simprd vtoclg anabsi7
      c0 ) BEFZCBFZCAGZHIZABJZULDGZBFZKZUQUNHIZABJZRULUMKZUPRDCBUQCLZUSVBVAUPVC
      URUMULUQCBMNVCUTUOABUQCUNHOPQUSUNUQHIUNBFRASZVAULVDVAKZDBULBUAFUKBTBUBTUC
      VEDBUDDABUEUFUGUHUIUJ $.
  $}

  ${
    $d A x y $.
    $( A simplifying observation, and an indication of why any attempt to
       develop a theory of the real numbers without the Axiom of Infinity is
       doomed to failure: since every member of ` P. ` is an infinite set, the
       negation of Infinity implies that ` P. ` , and hence ` RR ` , is empty.
       (Note that this proof, which used the fact that Dedekind cuts have no
       maximum, could just as well have used that they have no minimum, since
       they are downward-closed by ~ prcdnq and ~ nsmallnq ).  (Contributed by
       Mario Carneiro, 11-May-2013.)  (Revised by Mario Carneiro,
       16-Nov-2014.)  (New usage is discouraged.) $)
    npomex $p |- ( A e. P. -> om e. _V ) $=
      ( vx vy cnp wcel cfn cvv wne com wn elex cv cltq wbr wrex wral wor adantr
      cnq sylib prnmax ralrimiva wa c0 wss prpssnq pssssd ltsonq soss ee10 prn0
      simpr fimax2g syl3anc ralnex rexbii rexnal bitri ex nelne1 syl2anc necomd
      mt2d fineqv necon1abii ) ADEZFGHIGEZVFGFVFAGEAFEZJGFHADKVFVHBLZCLMNZCAOZB
      APZVFVKBACAVIUAUBVFVHVLJZVFVHUCZVJJCAPZBAOZVMVNAMQZVHAUDHZVPVFVQVHVFASUES
      MQVQVFASAUFUGUHASMUIUJRVFVHULVFVRVHAUKRBCAMUMUNVPVKJZBAOVMVOVSBAVJCAUOUPV
      KBAUQURTUSVCAGFUTVAVBVGFGVDVET $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A positive real has no largest member.  Addition version.  (Contributed
       by NM, 7-Apr-1996.)  (Revised by Mario Carneiro, 11-May-2013.)
       (New usage is discouraged.) $)
    prnmadd $p |- ( ( A e. P. /\ B e. A ) -> E. x ( B +Q x ) e. A ) $=
      ( vy cnp wcel wa cv cltq wbr wrex cplq wex prnmax wceq cnq ltrelnq simprd
      co brel ltexnq biimpcd mpd eleq1a eximdv syl5 rexlimiv syl ) BEFCBFGCDHZI
      JZDBKCAHLSZBFZAMZDBCNUJUMDBUJUKUIOZAMZUIBFZUMUJUIPFZUOUJCPFUQCUIPPIQTRUQU
      JUOACUIUAUBUCUPUNULAUIBUKUDUEUFUGUH $.
  $}

  ${
    $d x y $.
    $( Positive real 'less than' is a relation on positive reals.  (Contributed
       by NM, 14-Feb-1996.)  (New usage is discouraged.) $)
    ltrelpr $p |- <P C_ ( P. X. P. ) $=
      ( vx vy cltp cv cnp wcel wa wpss copab cxp df-ltp opabssxp eqsstri ) CADZ
      EFBDZEFGNOHZGABIEEJABKPABEELM $.
  $}

  ${
    $d x y z f g h A $.  $d x y z f g h B $.  $d x y z w v u f g h G $.
    $d f g F $.  $d f g h C $.  $d g h D $.
    genp.1 $e |- F = ( w e. P. , v e. P. |->
                    { x | E. y e. w E. z e. v x = ( y G z ) } ) $.
    genp.2 $e |- ( ( y e. Q. /\ z e. Q. ) -> ( y G z ) e. Q. ) $.
    $( Value of general operation (addition or multiplication) on positive
       reals.  (Contributed by NM, 10-Mar-1996.)  (Revised by Mario Carneiro,
       17-Nov-2014.)  (New usage is discouraged.) $)
    genpv $p |- ( ( A e. P. /\ B e. P. ) -> ( A F B ) =
               { f | E. g e. A E. h e. B f = ( g G h ) } ) $=
      ( cnp wcel cv wceq wrex cnq wa cab oveq1 rexeq abbidv eqeq12d rexbidv cvv
      co oveq2 wss wi elprnq eleq1 syl5ibrcom syl2an an4s rexlimdvva nqex ssexg
      abssdv sylancl weq ovmpt2g vtocl2ga eqeq1 2rexbidv eqeq2d cbvrex2v syl6bb
      mpd3an3 cbvabv syl6eq ) FOPGOPUAFGKUIZAQZBQZCQZLUIZRZCGSZBFSZAUBZHQZIQZJQ
      ZLUIZRZJGSIFSZHUBWCWDKUIZVSCWDSZBWCSZAUBZRZFWDKUIZWJBFSZAUBZRVNWBRHIFGOOW
      CFRZWIWNWLWPWCFWDKUCWQWKWOAWJBWCFUDUEUFWDGRZWNVNWPWBWDGFKUJWRWOWAAWRWJVTB
      FVSCWDGUDUGUEUFWCOPZWDOPZWLUHPZWMWSWTUAZWLTUKTUHPXAXBWKATXBVSVOTPZBCWCWDW
      SVPWCPZWTVQWDPZVSXCULZWSXDUAVPTPZVQTPZXFWTXEUAWCVPUMWDVQUMXGXHUAXCVSVRTPN
      VOVRTUNUOUPUQURVAUSWLTUHUTVBDEWCWDOOVSCEQZSZBDQZSZAUBWLKXJBWCSZAUBUHDHVCX
      LXMAXJBXKWCUDUEEIVCZXMWKAXNXJWJBWCVSCXIWDUDUGUEMVDVKVEWAWHAHAHVCZWAWCVRRZ
      CGSBFSWHXOVSXPBCFGVOWCVRVFVGXPWGWCWDVQLUIZRBCIJFGBIVCVRXQWCVPWDVQLUCVHCJV
      CXQWFWCVQWEWDLUJVHVIVJVLVM $.

    $( Membership in value of general operation (addition or multiplication) on
       positive reals.  (Contributed by NM, 13-Mar-1996.)  (Revised by Mario
       Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
    genpelv $p |- ( ( A e. P. /\ B e. P. ) -> ( C e. ( A F B ) <->
               E. g e. A E. h e. B C = ( g G h ) ) ) $=
      ( vf cnp wcel cv wceq wrex wa co cab genpv eleq2d ovex syl6eqel rexlimivw
      cvv id eqeq1 2rexbidv elab3 syl6bb ) FPQGPQUAZHFGKUBZQHORZIRZJRZLUBZSZJGT
      IFTZOUCZQHUTSZJGTZIFTZUOUPVCHABCDEFGOIJKLMNUDUEVBVFOHVEHUIQZIFVDVGJGVDHUT
      UIVDUJURUSLUFUGUHUHUQHSVAVDIJFGUQHUTUKULUMUN $.

    $( Pre-closure law for general operation on positive reals.  (Contributed
       by NM, 10-Mar-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    genpprecl $p |- ( ( A e. P. /\ B e. P. ) -> ( ( C e. A /\ D e. B ) ->
                  ( C G D ) e. ( A F B ) ) ) $=
      ( vg vh wcel wa co cnp cv wceq wrex eqid rspceov mp3an3 genpelv syl5ibr )
      HFPZIGPZQHIKRZFGJRPFSPGSPQUJNTOTKRUAOGUBNFUBZUHUIUJUJUAUKUJUCNOFGHIUJKUDU
      EABCDEFGUJNOJKLMUFUG $.

    $( Domain of general operation on positive reals.  (Contributed by NM,
       18-Nov-1995.)  (Revised by Mario Carneiro, 17-Nov-2014.)
       (New usage is discouraged.) $)
    genpdm $p |- dom F = ( P. X. P. ) $=
      ( cv co wceq wrex cvv wcel cnp wral wa cnq elprnq cab wi eleq1 syl5ibrcom
      cxp wfn cdm wss syl2an an4s rexlimdvva abssdv ssexg sylancl rgen2a fnmpt2
      nqex fndm mp2b ) AJZBJZCJZGKZLZCEJZMBDJZMZAUAZNOZEPQDPQFPPUEZUFFUGVJLVIDE
      PVFPOZVEPOZRZVHSUHSNOVIVMVGASVMVDUTSOZBCVFVEVKVAVFOZVLVBVEOZVDVNUBZVKVORV
      ASOZVBSOZVQVLVPRVFVATVEVBTVRVSRVNVDVCSOIUTVCSUCUDUIUJUKULUQVHSNUMUNUODEPP
      VHFNHUPVJFURUS $.

    $( The result of an operation on positive reals is not empty.  (Contributed
       by NM, 28-Feb-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    genpn0 $p |- ( ( A e. P. /\ B e. P. ) -> (/) C. ( A F B ) ) $=
      ( vf vg cnp wcel wa cv wex c0 wne co wpss prn0 n0 sylib anim12i genpprecl
      wi ne0i 0pss sylibr syl6 exp3acom23 exlimdv com23 imp3a mpd ) FNOZGNOZPZL
      QZFOZLRZMQZGOZMRZPSFGHUAZUBZURVCUSVFURFSTVCFUCLFUDUEUSGSTVFGUCMGUDUEUFUTV
      CVFVHUTVBVFVHUHLUTVFVBVHUTVEVBVHUHMUTVBVEVHUTVBVEPVAVDIUAZVGOZVHABCDEFGVA
      VDHIJKUGVJVGSTVHVGVIUIVGUJUKULUMUNUOUNUPUQ $.

    $( The result of an operation on positive reals is a subset of the positive
       fractions.  (Contributed by NM, 18-Nov-1995.)  (Revised by Mario
       Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
    genpss $p |- ( ( A e. P. /\ B e. P. ) -> ( A F B ) C_ Q. ) $=
      ( vf vg vh cnp wcel wa co cnq cv wceq wrex genpelv elprnq im2anan9 caovcl
      wi ex syl6 eleq1a rexlimdvv sylbid ssrdv ) FOPZGOPZQZLFGHRZSUPLTZUQPURMTZ
      NTZIRZUAZNGUBMFUBURSPZABCDEFGURMNHIJKUCUPVBVCMNFGUPUSFPZUTGPZQZVASPZVBVCU
      GUPVFUSSPZUTSPZQVGUNVDVHUOVEVIUNVDVHFUSUDUHUOVEVIGUTUDUHUEBCUSUTSIKUFUIVA
      SURUJUIUKULUM $.

    ${
      $d w v A $.  $d w v B $.  $d w v F $.
      genpnnp.3 $e |- ( z e. Q. -> ( x <Q y <-> ( z G x ) <Q ( z G y ) ) ) $.
      genpnnp.4 $e |- ( x G y ) = ( y G x ) $.
      $( The result of an operation on positive reals is different from the set
         of positive fractions.  (Contributed by NM, 29-Feb-1996.)  (Revised by
         Mario Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
      genpnnp $p |- ( ( A e. P. /\ B e. P. ) -> -. ( A F B ) = Q. ) $=
        ( vf vg wcel wa cnq wn wi cnp cv wex co wceq prpssnq pssnel syl anim12i
        wpss eeanv sylibr wrex wral cltq wbr prub im2anan9 elprnq anim1i ltsonq
        wor so2nr mpan ad2antrr wb simpr simpl ancoms vex caovord3 anbi2d sylan
        mtbid con2d syl2an syld com24 imp32 ralrimivv ralnex ralbii bitri sylib
        ex an4s adantr mtbird expcom caovcl eleq2 biimprcd con3d ad2ant2r com12
        genpelv exlimdvv mpd ) FUAPZGUAPZQZDUBZRPZXBFPSZQZEUBZRPZXFGPSZQZQZEUCD
        UCZFGHUDZRUEZSZXAXEDUCZXIEUCZQXKWSXOWTXPWSFRUJXOFUFDFRUGUHWTGRUJXPGUFEG
        RUGUHUIXEXIDEUKULXAXJXNDEXJXAXNXJXAXBXFIUDZXLPZSZXNXCXGXDXHXAXSTZXDXHQZ
        XCXGQZXTXAYAYBQZXSXAYCQZXRXQNUBZOUBZIUDUEZOGUMZNFUMZYDYGSZOGUNZNFUNZYIS
        ZYDYJNOFGXAYAYBYEFPZYFGPZQZYJTXAYPYBYAYJXAYPYBYAYJTZTZWSYNWTYOYRWSYNQZW
        TYOQZQYBYQYSXCYTXGYQYSXCQZYTXGQZQYAYEXBUOUPZYFXFUOUPZQZYJUUAXDUUCUUBXHU
        UDFYEXBUQGYFXFUQURUUAYERPZXCQZYFRPZXGQZUUEYJTUUBYSUUFXCFYEUSUTYTUUHXGGY
        FUSUTUUGUUIQZYGUUEUUJYGUUESUUJYGQUUCXBYEUOUPZQZUUEUUGUULSZUUIYGRUOVBUUG
        UUMVARYEXBUOVCVDVEUUJXGUUFQZYGUULUUEVFUUIUUGUUNUUIXGUUGUUFUUHXGVGUUFXCV
        HUIVIUUNYGQUUKUUDUUCABCXBXFYEYFUORIDVJEVJLNVJMOVJVKVLVMVNWEVOVPVQWFWEWF
        WEVRVSVTYLYHSZNFUNYMYKUUONFYGOGWAWBYHNFWAWCWDXAXRYIVFYCABCDEFGXQNOHIJKW
        PWGWHWIVIWFXCXGXSXNTZXDXHYBXQRPZUUPBCXBXFRIKWJUUQXMXRXMXRUUQXLRXQWKWLWM
        UHWNVQWOWQWR $.
    $}

    ${
      $d F h $.
      genpcd.2 $e |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g G h ) -> x e. ( A F B ) ) ) $.
      $( Downward closure of an operation on positive reals.  (Contributed by
         NM, 13-Mar-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
         (New usage is discouraged.) $)
      genpcd $p |- ( ( A e. P. /\ B e. P. ) -> ( f e. ( A F B ) ->
                   ( x <Q f -> x e. ( A F B ) ) ) ) $=
        ( wcel wa cv cltq wi cnp wbr co cnq ltrelnq brel simpld wceq wb genpelv
        wrex adantr breq2 biimpd sylan9r an4s impancom rexlimdvv sylbid ex syl5
        exp31 com34 pm2.43d com23 ) FUAPZGUAPZQZARZHRZSUBZVJFGKUCZPZVIVLPZVHVKV
        MVNTVHVKVMVKVNVKVIUDPZVHVMVKVNTZTZVKVOVJUDPVIVJUDUDSUEUFUGVHVOVQVHVOQZV
        MVJIRZJRZLUCZUHZJGUKIFUKZVPVHVMWCUIVOABCDEFGVJIJKLMNUJULVRWBVPIJFGVHVSF
        PZVTGPZQVOWBVPTZVFWDVGWEVOWFTVFWDQVGWEQQZVOWBVPWBVKVIWASUBZWGVOQVNWBVKW
        HVJWAVISUMUNOUOVBUPUQURUSUTVAVCVDVE $.
    $}

    ${
      $d x y h F $.
      genpnmax.2 $e |- ( v e. Q. ->
                       ( z <Q w <-> ( v G z ) <Q ( v G w ) ) ) $.
      genpnmax.3 $e |- ( z G w ) = ( w G z ) $.
      $( An operation on positive reals has no largest member.  (Contributed by
         NM, 10-Mar-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
         (New usage is discouraged.) $)
      genpnmax $p |- ( ( A e. P. /\ B e. P. ) -> ( f e. ( A F B ) ->
                     E. x e. ( A F B ) f <Q x ) ) $=
        ( vg vh wcel wa cv cltq cnp co wceq wbr genpelv prnmax adantr genpprecl
        wrex wi exp4b com34 imp32 cnq elprnq vex caovord2 biimpd adantl anim12d
        syl breq2 rspcev syl6 adantlr exp3a rexlimdv an4s breq1 rexbidv syl5ibr
        mpd exp3acom3r rexlimdvv sylbid ) FUAQZGUAQZRZHSZFGIUBZQVSOSZPSZJUBZUCZ
        PGUIOFUIVSASZTUDZAVTUIZABCDEFGVSOPIJKLUEVRWDWGOPFGWDVRWAFQZWBGQZRZWGVRW
        JRWGWDWCWETUDZAVTUIZVPWHVQWIWLVPWHRZVQWIRZRZWABSZTUDZBFUIZWLWMWRWNBFWAU
        FUGWOWQWLBFWOWPFQZWQWLVPWNWSWQRZWLUJWHVPWNRZWTWPWBJUBZVTQZWCXBTUDZRWLXA
        WSXCWQXDVPVQWIWSXCUJVPVQWSWIXCVPVQWSWIXCABCDEFGWPWBIJKLUHUKULUMWNWQXDUJ
        ZVPWNWBUNQZXEGWBUOXFWQXDCDEWAWPWBTUNJOUPBUPMPUPNUQURVAUSUTWKXDAXBVTWEXB
        WCTVBVCVDVEVFVGVLVHWDWFWKAVTVSWCWETVIVJVKVMVNVO $.
    $}

    ${
      $d w v A $.  $d w v B $.  $d x y w v h F $.
      genpcl.3 $e |- ( h e. Q. ->
                      ( f <Q g <-> ( h G f ) <Q ( h G g ) ) ) $.
      genpcl.4 $e |- ( x G y ) = ( y G x ) $.
      genpcl.5 $e |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g G h ) -> x e. ( A F B ) ) ) $.
      $( Closure of an operation on reals.  (Contributed by NM, 13-Mar-1996.)
         (Revised by Mario Carneiro, 17-Nov-2014.)
         (New usage is discouraged.) $)
      genpcl $p |- ( ( A e. P. /\ B e. P. ) -> ( A F B ) e. P. ) $=
        ( wcel cnq cv cnp wa c0 co wpss cltq wbr wi wal wrex wral genpn0 wss wn
        wceq genpss vex caovord genpnnp dfpss2 sylanbrc genpcd alrimdv genpnmax
        caovcom jcad ralrimiv jca31 elnp sylibr ) FUARGUARUBZUCFGKUDZUEZVLSUEZU
        BATZHTZUFUGVOVLRUHZAUIZVPVOUFUGAVLUJZUBZHVLUKZUBVLUARVKVMVNWAABCDEFGKLM
        NULVKVLSUMVLSUOUNVNABCDEFGKLMNUPABCDEFGKLMNHIJVOBTCTZUFSLAUQBUQOURPUSVL
        SUTVAVKVTHVLVKVPVLRZVRVSVKWCVQAABCDEFGHIJKLMNQVBVCABCDEFGHKLMNHIJWBDTZE
        TUFSLCUQZDUQZOURABWBWDLWEWFPVEVDVFVGVHHAVLVIVJ $.
    $}

    ${
      $d x y z w v u f g h t $.  $d x f g h t A $.  $d x f g h t B $.
      $d x y z f g h t C $.  $d x y z h t F $.  $d t G $.
      genpass.4 $e |- dom F = ( P. X. P. ) $.
      genpass.5 $e |- ( ( f e. P. /\ g e. P. ) -> ( f F g ) e. P. ) $.
      genpass.6 $e |- ( ( f G g ) G h ) = ( f G ( g G h ) ) $.
      $( Associativity of an operation on reals.  (Contributed by NM,
         18-Mar-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
         (New usage is discouraged.) $)
      genpass $p |- ( ( A F B ) F C ) = ( A F ( B F C ) ) $=
        ( vt wrex cnp wcel w3a co wceq wex genpelv 3adant1 anbi1d exbidv df-rex
        cv wa wb ovex isseti biantrur 19.41v bitr4i rexcom4 bitri oveq2 syl6eqr
        rexbii eqeq2d pm5.32i r19.41v bitr3i exbii 3bitri 3bitr4g caovcl sylan2
        rexbidv 3impb sylan 3impa 3adant3 oveq1 3bitr4ri 3bitr4rd 0npr ndmovass
        bitrd eqrdv pm2.61i ) FUAUBZGUAUBZHUAUBZUCZFGLUDZHLUDZFGHLUDZLUDZUEWJAW
        LWNWJAULZIULZSULZMUDZUEZSWMTZIFTZWOWPJULZMUDZKULZMUDZUEZKHTZJGTZIFTZWOW
        NUBZWOWLUBZWJWTXHIFWJWQWMUBZWSUMZSUFWQXBXDMUDZUEZKHTZJGTZWSUMZSUFZWTXHW
        JXMXRSWJXLXQWSWHWIXLXQUNWGABCDEGHWQJKLMNOUGUHUIUJWSSWMUKXHXOXFUMZKHTZSU
        FZJGTYAJGTZSUFXSXGYBJGXGXTSUFZKHTYBXFYDKHXFXOSUFZXFUMYDYEXFSXNXBXDMUOUP
        UQXOXFSURUSVDXTKSHUTVAVDYAJSGUTYCXRSYCXPWSUMZJGTXRYAYFJGYAXOWSUMZKHTYFY
        GXTKHXOWSXFXOWRXEWOXOWRWPXNMUDXEWQXNWPMVBRVCVEVFVDXOWSKHVGVHVDXPWSJGVGV
        AVIVJVKVNWGWHWIXJXAUNZWHWIUMWGWMUAUBYHIJGHUALQVLABCDEFWMWOISLMNOUGVMVOW
        JXKWOWQXDMUDZUEZKHTZSWKTZXIWGWHWIXKYLUNZWGWHUMWKUAUBWIYMIJFGUALQVLABCDE
        WKHWOSKLMNOUGVPVQWJWQWKUBZYKUMZSUFWQXCUEZJGTZIFTZYKUMZSUFZYLXIWJYOYSSWJ
        YNYRYKWGWHYNYRUNWIABCDEFGWQIJLMNOUGVRUIUJYKSWKUKXIYPYKUMZJGTZSUFZIFTUUB
        IFTZSUFYTXHUUCIFXHUUASUFZJGTUUCXGUUEJGYPXGUMZSUFYPSUFZXGUMUUEXGYPXGSURU
        UAUUFSYPYKXGYPYJXFKHYPYIXEWOWQXCXDMVSVEVNVFVIUUGXGSXCWPXBMUOUPUQVTVDUUA
        JSGUTVAVDUUBISFUTUUDYSSUUDYQYKUMZIFTYSUUBUUHIFYPYKJGVGVDYQYKIFVGVAVIVJV
        KWDWAWEFGHUALPWBWCWF $.
    $}

  $}

  ${
    $d x y z f g h A $.  $d x y z f g h B $.  $d x y z w v u f g h $.
    $( Value of addition on positive reals.  (Contributed by NM, 28-Feb-1996.)
       (New usage is discouraged.) $)
    plpv $p |- ( ( A e. P. /\ B e. P. ) -> ( A +P. B ) =
             { x | E. y e. A E. z e. B x = ( y +Q z ) } ) $=
      ( vf vg vh vu vv cpp cplq df-plp cv addclnq genpv ) FGHIJDEABCKLIJFGHMGNH
      NOP $.

    $( Value of multiplication on positive reals.  (Contributed by NM,
       28-Feb-1996.)  (New usage is discouraged.) $)
    mpv $p |- ( ( A e. P. /\ B e. P. ) -> ( A .P. B ) =
             { x | E. y e. A E. z e. B x = ( y .Q z ) } ) $=
      ( vf vg vh vu vv cmp cmq df-mp cv mulclnq genpv ) FGHIJDEABCKLIJFGHMGNHNO
      P $.

    $( Domain of addition on positive reals.  (Contributed by NM,
       18-Nov-1995.)  (New usage is discouraged.) $)
    dmplp $p |- dom +P. = ( P. X. P. ) $=
      ( vz vu vv vx vy cpp cplq df-plp cv addclnq genpdm ) ABCDEFGDEABCHBICIJK
      $.

    $( Domain of multiplication on positive reals.  (Contributed by NM,
       18-Nov-1995.)  (New usage is discouraged.) $)
    dmmp $p |- dom .P. = ( P. X. P. ) $=
      ( vz vu vv vx vy cmp cmq df-mp cv mulclnq genpdm ) ABCDEFGDEABCHBICIJK $.

  $}

  ${
    $d A x y z $.
    $( The canonical embedding of the rationals into the reals.  (Contributed
       by Mario Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
    nqpr $p |- ( A e. Q. -> { x | x <Q A } e. P. ) $=
      ( vz vy cnq wcel c0 cv cltq wbr wa wi wex sylibr ltrelnq ltsonq breq1 jca
      wpss vex cab wal wrex wral cnp wne nsmallnq abn0 0pss wss wn simpld abssi
      brel soirri elabg mtbiri ancli ssnelpss mpsyl sotri expcom adantl syl6ibr
      elab alrimiv ltbtwnnq anbi2i biimpri ancomd eximi sylbi sylan2b ralrimiva
      df-rex elnp sylanbrc ) BEFZGAHZBIJZAUAZSZWAESZKCHZDHZIJZWDWAFZLZCUBZWEWDI
      JZCWAUCZKZDWAUDWAUEFVRWBWCVRWAGUFZWBVRVTAMWMABUGVTAUHNWAUINWAEUJVRVRBWAFZ
      UKZKWCVTAEVTVSEFVRVSBEEIOUNULUMVRWOVRWNBBIJZBIEPOUOVTWPABEVSBBIQUPUQURWAE
      BUSUTRVRWLDWAWEWAFVRWEBIJZWLVTWQAWEDTVSWEBIQVEVRWQKZWIWKWRWHCWRWFWDBIJZWG
      WQWFWSLVRWFWQWSWDWEBIEPOVAVBVCVTWSAWDCTVSWDBIQVEZVDVFWRWGWJKZCMZWKWQXBVRW
      QWJWSKZCMXBCWEBVGXCXACXCWJWGWJWGKXCWGWSWJWTVHVIVJVKVLVCWJCWAVONRVMVNDCWAV
      PVQ $.
  $}

  $( The positive real number 'one'.  (Contributed by NM, 13-Mar-1996.)
     (Revised by Mario Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
  1pr $p |- 1P e. P. $=
    ( vx c1p cv c1q cltq wbr cab cnp df-1p cnq wcel 1nq nqpr ax-mp eqeltri ) BA
    CDEFAGZHAIDJKPHKLADMNO $.

  ${
    $d x y z w $.  $d y z w g $.  $d y z w h $.
    $( Lemma to prove downward closure in positive real addition.  Part of
       proof of Proposition 9-3.5 of [Gleason] p. 123.  (Contributed by NM,
       13-Mar-1996.)  (New usage is discouraged.) $)
    addclprlem1 $p |- ( ( ( A e. P. /\ g e. A ) /\ x e. Q. ) ->
   ( x <Q ( g +Q h ) -> ( ( x .Q ( *Q ` ( g +Q h ) ) ) .Q g ) e. A ) ) $=
      ( vy vz vw wcel cv wa cnq co cltq wbr crq cfv cmq ltmnq ovex c1q cnp cplq
      wb elprnq ltrnq mulcomnq caovord2 sylan9bbr syl5bb recidnq oveq1d mulidnq
      vex syl5eq sylan9eqr breq2d bitrd sylan wi prcdnq adantr sylbid ) BUAHCIZ
      BHJZAIZKHZJVEVCDIUBLZMNZVEVGOPZQLZVCQLZVCMNZVKBHZVDVCKHZVFVHVLUCBVCUDVNVF
      JZVHVKVEVEOPZQLZVCQLZMNZVLVHVIVPMNZVOVSVEVGUEVFVTVJVQMNVNVSVIVPVEREFGVJVQ
      VCMKQVEVIQSVEVPQSEIZFIZGIRCUMWAWBUFUGUHUIVOVRVCVKMVFVNVRTVCQLZVCVFVQTVCQV
      EUJUKVNWCVCTQLVCTVCUFVCULUNUOUPUQURVDVLVMUSVFBVCVKUTVAVB $.
  $}

  ${
    $d x y z w v u g h $.  $d x y z A $.  $d x y z B $.
    $( Lemma to prove downward closure in positive real addition.  Part of
       proof of Proposition 9-3.5 of [Gleason] p. 123.  (Contributed by NM,
       13-Mar-1996.)  (New usage is discouraged.) $)
    addclprlem2 $p |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g +Q h ) -> x e. ( A +P. B ) ) ) $=
      ( vy vz vw wcel cv wa cnq cplq co cltq crq cmq wi simpl c1q vv cnp breq2i
      wbr cfv addclprlem1 adantlr addcomnq fveq2i oveq2i oveq1i 3imtr4g adantll
      cpp eleq1i jcad anim12i df-plp addclnq genpprecl 3syl syld distrnq eqtr3i
      mulassnq mulcomnq wceq elprnq recidnq syl5eq oveq2d mulidnq eleq1d sylibd
      sylan9eq ) BUBIZDJZBIZKZCUBIZEJZCIZKZKZAJZLIZKZWEVQWAMNZOUDZWEWHPUEZQNZVQ
      QNZWKWAQNZMNZBCUNNZIZWEWOIWGWIWLBIZWMCIZKZWPWGWIWQWRVSWFWIWQRWCABDEUFUGWC
      WFWIWRRVSWCWFKWEWAVQMNZOUDWEWTPUEZQNZWAQNZCIWIWRACEDUFWHWTWEOVQWAUHZUCWMX
      CCWKXBWAQWJXAWEQWHWTPXDUIUJUKUOULUMUPWGWDVPVTKWSWPRWDWFSVSVPWCVTVPVRSVTWB
      SUQAFGHUABCWLWMUNMHUAAFGURFJGJUSUTVAVBWGWNWEWOWGWNWEWJWHQNZQNZWEWKWHQNWNX
      FWKVQWAVCWEWJWHVEVDWDWFXFWETQNWEWDXETWEQWDXEWHWJQNZTWJWHVFWDVQLIZWALIZKWH
      LIXGTVGVSXHWCXIBVQVHCWAVHUQVQWAUSWHVIVAVJVKWEVLVOVJVMVN $.
  $}

  ${
    $d x y z w v u f g h $.  $d x y z w v f g h A $.  $d x y z w v f g h B $.
    $( Closure of addition on positive reals.  First statement of Proposition
       9-3.5 of [Gleason] p. 123.  (Contributed by NM, 13-Mar-1996.)
       (New usage is discouraged.) $)
    addclpr $p |- ( ( A e. P. /\ B e. P. ) -> ( A +P. B ) e. P. ) $=
      ( vx vy vz vw vv vf vg vh cpp cplq df-plp cv addclnq addcomnq addclprlem2
      ltanq genpcl ) CDEFGABHIJKLFGCDEMDNZENOHNINJNRCNTPCABIJQS $.
  $}

  ${
    $d x y z w v u g h $.  $d x y z A $.  $d x y z B $.
    $( Lemma to prove downward closure in positive real multiplication.  Part
       of proof of Proposition 9-3.7 of [Gleason] p. 124.  (Contributed by NM,
       14-Mar-1996.)  (New usage is discouraged.) $)
    mulclprlem $p |- ( ( ( ( A e. P. /\ g e. A ) /\
                       ( B e. P. /\ h e. B ) ) /\ x e. Q. ) ->
                       ( x <Q ( g .Q h ) -> x e. ( A .P. B ) ) ) $=
      ( vy vz vw wcel cv wa cnq cmq co cltq wbr wi wb c1q syl5eq vv cnp crq cfv
      cmp elprnq recclnq vex ovex ltmnq fvex mulcomnq caovord2 mulassnq recidnq
      adantl oveq2d mulidnq sylan9eqr breq2d bitrd syl2an prcdnq adantr mulclnq
      syl sylbid df-mp genpprecl exp4b com34 imp32 adantlr syld sylan9eq eleq1d
      sylan sylibd ) BUBIZDJZBIZKZCUBIZEJZCIZKZKZAJZLIZKWHVTWDMNZOPZWHWDUCUDZMN
      ZWDMNZBCUENZIZWHWOIZWGWKWPQWIWGWKWMBIZWPWGWKWMVTOPZWRWBVTLIZWDLIZWKWSRWFB
      VTUFCWDUFZWTXAKZWKWMWJWLMNZOPZWSXCWLLIZWKXERXAXFWTWDUGUPFGHWHWJWLOLMAUHVT
      WDMUIFJZGJZHJUJWDUCUKXGXHULUMVFXCXDVTWMOXAWTXDVTSMNZVTXAXDVTWDWLMNZMNXIVT
      WDWLUNXAXJSVTMWDUOZUQTVTURUSUTVAVBWBWSWRQWFBVTWMVCVDVGVSWFWRWPQZWAVSWCWEX
      LVSWCWRWEWPVSWCWRWEWPAFGHUABCWMWDUEMHUAAFGVHXGXHVEVIVJVKVLVMVNVDWGXAWIWPW
      QRWFXAWBXBUPXAWIKWNWHWOXAWIWNWHSMNZWHXAWNWHWLWDMNZMNXMWHWLWDUNXAXNSWHMXAX
      NXJSWLWDULXKTUQTWHURVOVPVQVR $.
  $}

  ${
    $d x y z w v u f g h $.  $d x y z w v f g h A $.  $d x y z w v f g h B $.
    $d x y z w A $.  $d x y z w B $.
    $( Closure of multiplication on positive reals.  First statement of
       Proposition 9-3.7 of [Gleason] p. 124.  (Contributed by NM,
       13-Mar-1996.)  (New usage is discouraged.) $)
    mulclpr $p |- ( ( A e. P. /\ B e. P. ) -> ( A .P. B ) e. P. ) $=
      ( vx vy vz vw vv vf vg vh cmp cmq df-mp mulclnq ltmnq mulcomnq mulclprlem
      cv genpcl ) CDEFGABHIJKLFGCDEMDRZERNHRIRJROCRTPCABIJQS $.
  $}

  ${
    $d f g h v w x y z $.  $d f g h x y z A $.  $d f g h x y z B $.
    $d f g h x y z C $.
    $( Addition of positive reals is commutative.  Proposition 9-3.5(ii) of
       [Gleason] p. 123.  (Contributed by NM, 19-Nov-1995.)
       (New usage is discouraged.) $)
    addcompr $p |- ( A +P. B ) = ( B +P. A ) $=
      ( vx vz vy cnp wcel wa cpp co wceq cv cplq wrex cab plpv addcomnq 2rexbii
      eqeq2i rexcom bitri abbii syl6eq ancoms eqtr4d dmplp ndmovcom pm2.61i ) A
      FGZBFGZHZABIJZBAIJZKUKULCLZDLZELZMJZKZEBNDANZCOZUMCDEABPUJUIUMUTKUJUIHUMU
      NUPUOMJZKZDANEBNZCOUTCEDBAPVCUSCVCURDANEBNUSVBUREDBAVAUQUNUPUOQSRUREDBATU
      AUBUCUDUEABFIUFUGUH $.

    $( Addition of positive reals is associative.  Proposition 9-3.5(i) of
       [Gleason] p. 123.  (Contributed by NM, 18-Mar-1996.)
       (New usage is discouraged.) $)
    addasspr $p |- ( ( A +P. B ) +P. C ) = ( A +P. ( B +P. C ) ) $=
      ( vx vy vz vw vv vf vg vh cplq df-plp cv addclnq addclpr addassnq genpass
      cpp dmplp ) DEFGHABCIJKSLGHDEFMENFNOTINZJNZPUAUBKNQR $.

    $( Multiplication of positive reals is commutative.  Proposition 9-3.7(ii)
       of [Gleason] p. 124.  (Contributed by NM, 19-Nov-1995.)
       (New usage is discouraged.) $)
    mulcompr $p |- ( A .P. B ) = ( B .P. A ) $=
      ( vx vz vy cnp wcel wa cmp co wceq cv cmq cab mpv mulcomnq eqeq2i 2rexbii
      wrex rexcom bitri abbii syl6eq ancoms eqtr4d dmmp ndmovcom pm2.61i ) AFGZ
      BFGZHZABIJZBAIJZKUKULCLZDLZELZMJZKZEBSDASZCNZUMCDEABOUJUIUMUTKUJUIHUMUNUP
      UOMJZKZDASEBSZCNUTCEDBAOVCUSCVCURDASEBSUSVBUREDBAVAUQUNUPUOPQRUREDBATUAUB
      UCUDUEABFIUFUGUH $.

    $( Multiplication of positive reals is associative.  Proposition 9-3.7(i)
       of [Gleason] p. 124.  (Contributed by NM, 18-Mar-1996.)
       (New usage is discouraged.) $)
    mulasspr $p |- ( ( A .P. B ) .P. C ) = ( A .P. ( B .P. C ) ) $=
      ( vx vy vz vw vv vf vg vh cmp df-mp mulclnq dmmp mulclpr mulassnq genpass
      cmq cv ) DEFGHABCIJKLSGHDEFMETFTNOITZJTZPUAUBKTQR $.
  $}

  ${
    $d x y z w v u f g h A $.  $d x y z w v u f g h B $.
    $d x y z w v u f g h C $.
    $( Lemma for distributive law for positive reals.  (Contributed by NM,
       1-May-1996.)  (Revised by Mario Carneiro, 13-Jun-2013.)
       (New usage is discouraged.) $)
    distrlem1pr $p |- ( ( A e. P. /\ B e. P. /\ C e. P. ) ->
       ( A .P. ( B +P. C ) ) C_ ( ( A .P. B ) +P. ( A .P. C ) ) ) $=
      ( vw vx vv vf vg vh vy vz cnp wcel cpp co cmp cv cmq wceq wa wrex addclpr
      w3a df-mp mulclnq genpelv sylan2 3impb cplq df-plp addclnq 3adant1 adantr
      wb wi simprr simpr eqeq2d biimpac distrnq syl6eq mulclpr 3adant3 ad2antrr
      syl2an 3adant2 simpll genpprecl impl adantlrr simplr imp syl22anc eqeltrd
      oveq2 exp32 rexlimdvv sylbid com34 imp3a ssrdv ) ALMZBLMZCLMZUCZDABCNOZPO
      ZABPOZACPOZNOZWEDQZWGMZWKEQZFQZROZSZFWFUAEAUAZWKWJMZWBWCWDWLWQUNZWCWDTWBW
      FLMWSBCUBGHIJKAWFWKEFPRJKGHIUDZHQZIQZUEZUFUGUHWEWPWREFAWFWEWMAMZWNWFMZWPW
      RUOWEXDWPXEWRWEXDWPXEWRUOWEXDWPTZTZXEWNJQZKQZUIOZSZKCUAJBUAZWRWEXEXLUNZXF
      WCWDXMWBGHIDEBCWNJKNUIDEGHIUJZXAXBUKZUFULUMXGXKWRJKBCXGXHBMZXICMZTZXKWRXG
      XRXKTZTZWKWMXHROZWMXIROZUIOZWJXGWPXKWKYCSXSWEXDWPUPXRXKUQWPXKTWKWMXJROZYC
      XKWPWKYDSXKWOYDWKWNXJWMRVOURUSWMXHXIUTVAVEXTWHLMZWILMZYAWHMZYBWIMZYCWJMZW
      EYEXFXSWBWCYEWDABVBVCVDWEYFXFXSWBWDYFWCACVBVFVDXSXGXPYGXPXQXKVGWEXDXPYGWP
      WEXDXPYGWBWCXDXPTYGUOWDGHIJKABWMXHPRWTXCVHVCVIVJUGXSXGXQYHXPXQXKVKWEXDXQY
      HWPWEXDXQYHWBWDXDXQTYHUOWCGHIJKACWMXIPRWTXCVHVFVIVJUGYEYFTYGYHTYIGHIDEWHW
      IYAYBNUIXNXOVHVLVMVNVPVQVRVPVSVTVQVRWA $.

    $( Lemma for distributive law for positive reals.  (Contributed by NM,
       2-May-1996.)  (Revised by Mario Carneiro, 14-Jun-2013.)
       (New usage is discouraged.) $)
    distrlem4pr $p |- ( ( ( A e. P. /\ B e. P. /\ C e. P. ) /\
         ( ( x e. A /\ y e. B ) /\ ( f e. A /\ z e. C ) ) ) ->
         ( ( x .Q y ) +Q ( f .Q z ) ) e. ( A .P. ( B +P. C ) ) ) $=
      ( vw vv vu vg vh wcel cv wa cltq cmq co cplq cnq cnp w3a wb simpl2 elprnq
      wbr cpp simprlr syl2anc simp1 simprl syl2an simpl3 simprrr ltmnq mulcomnq
      cmp vex caovord2 mulclnq ovex ltanq addcomnq syl sylan9bb syl12anc simpl1
      wi addclpr 3adant1 adantr mulclpr distrnq simprrl df-plp addclnq syl22anc
      genpprecl df-mp syl5eqelr prcdnq sylbid simpll sylan9bbr syl21anc simprll
      imp wo weq wor ltsonq sotrieq mpan oveq2d syl5eq eleq1d syl5ibcom sylbird
      wn oveq1 ecase3d ) DUAMZEUAMZFUAMZUBZANZDMZBNZEMZOZGNZDMZCNZFMZOZOZOZXFXK
      PUFZXKXFPUFZXFXHQRZXKXMQRZSRZDEFUGRZUQRZMZXQXRYBXKXHQRZYASRZPUFZYEXQXHTMZ
      XKTMZXMTMZXRYHUCXQXCXIYIXBXCXDXPUDZXEXGXIXOUHZEXHUEUIZXEXBXLYJXPXBXCXDUJZ
      XJXLXNUKDXKUEULZXQXDXNYKXBXCXDXPUMZXEXJXLXNUNZFXMUEUIZYIXRXTYFPUFZYJYKOZY
      HHIJXFXKXHPTQAURZGURZHNZINZJNZUOZBURUUDUUEUPZUSUUAYATMYTYHUCXKXMUTHIJXTYF
      YAPTSXFXHQVAXKXHQVAUUDUUEUUFVBXKXMQVAUUDUUEVCUSVDVEVFXQYDUAMZYGYDMYHYEVHX
      QXBYCUAMZUUIXBXCXDXPVGZXEUUJXPXCXDUUJXBEFVIVJVKZDYCVLUIZXQYGXKXHXMSRZQRZY
      DXKXHXMVMXQXBUUJXLUUNYCMZUUOYDMZUUKUULXEXJXLXNVNXQXCXDXIXNUUPYLYQYMYRXCXD
      OXIXNOUUPHKLJIEFXHXMUGSJIHKLVOKNZLNZVPVRWGVQZXBUUJOZXLUUPOUUQHKLJIDYCXKUU
      NUQQJIHKLVSZUURUUSUTZVRWGVQVTYDYGYBWAUIWBXQXSYBXTXFXMQRZSRZPUFZYEXQXFTMZY
      IYKXSUVFUCXEXBXGUVGXPYOXGXIXOWCDXFUEULZYNYSYKXSYAUVDPUFZUVGYIOZUVFHIJXKXF
      XMPTQUUCUUBUUGCURUUHUSUVJXTTMUVIUVFUCXFXHUTYAUVDXTVBVDWDWEXQUUIUVEYDMUVFY
      EVHUUMXQUVEXFUUNQRZYDXFXHXMVMZXQXBUUJXGUUPUVKYDMZUUKUULXEXGXIXOWFUUTUVAXG
      UUPOUVMHKLJIDYCXFUUNUQQUVBUVCVRWGVQZVTYDUVEYBWAUIWBXQXRXSWHWSZAGWIZYEXQUV
      GYJUVPUVOUCZUVHYPTPWJUVGYJOUVQWKTXFXKPWLWMUIXQUVMUVPYEUVNUVPUVKYBYDUVPUVK
      UVEYBUVLUVPUVDYAXTSXFXKXMQWTWNWOWPWQWRXA $.

    $( Lemma for distributive law for positive reals.  (Contributed by NM,
       2-May-1996.)  (Revised by Mario Carneiro, 14-Jun-2013.)
       (New usage is discouraged.) $)
    distrlem5pr $p |- ( ( A e. P. /\ B e. P. /\ C e. P. ) ->
       ( ( A .P. B ) +P. ( A .P. C ) ) C_ ( A .P. ( B +P. C ) ) ) $=
      ( vw vv vu vf vg vh vx vy vz cnp wcel cmp co cv wrex wa wi w3a wb mulclpr
      cpp cplq 3adant3 3adant2 df-plp addclnq genpelv syl2anc cmq df-mp mulclnq
      wceq anbi2d distrlem4pr oveq12 eqeq2d eleq1 syl6bi syl5ibrcom exp4b com3l
      imp com23 rexlimivv rexlimdvv com3r sylbid imp3a ssrdv ) AMNZBMNZCMNZUAZD
      ABOPZACOPZUDPZABCUDPOPZVPDQZVSNZWAEQZFQZUEPZUOZFVRREVQRZWAVTNZVPVQMNZVRMN
      ZWBWGUBVMVNWIVOABUCUFVMVOWJVNACUCUGGHIJKVQVRWAEFUDUEJKGHIUHHQZIQZUIUJUKVP
      WFWHEFVQVRVPWCVQNZWDVRNZSWMWDGQZLQZULPZUOZLCRGARZSWFWHTZVPWNWSWMVMVOWNWSU
      BVNJHIDEACWDGLOULDEJHIUMWKWLUNZUJUGUPVPWMWSWTVPWMWCJQZKQZULPZUOZKBRJARZWS
      WTTVMVNWMXFUBVOGHIDEABWCJKOULDEGHIUMXAUJUFXFWSVPWTXFWRVPWTTZGLACXEWOANWPC
      NSZWRXGTZTJKABXBANXCBNSZXHXEXIXJXHXEWRXGVPXJXHSZXEWRSZWTVPXKXLWFWHVPXKSWH
      XLWFSXDWQUEPZVTNZJKLABCGUQXLWFWHXNUBZXLWFWAXMUOXOXLWEXMWAWCXDWDWQUEURUSWA
      XMVTUTVAVEVBVCVDVCVFVGVHVIVJVKVJVHVJVL $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    $( Multiplication of positive reals is distributive.  Proposition
       9-3.7(iii) of [Gleason] p. 124.  (Contributed by NM, 2-May-1996.)
       (New usage is discouraged.) $)
    distrpr $p |- ( A .P. ( B +P. C ) ) = ( ( A .P. B ) +P. ( A .P. C ) ) $=
      ( cnp wcel w3a cpp cmp wceq distrlem1pr distrlem5pr eqssd dmplp 0npr dmmp
      co ndmovdistr pm2.61i ) ADEBDECDEFZABCGPHPZABHPACHPGPZISTUAABCJABCKLABCDG
      HMNOQR $.
  $}

  ${
    $d x y z w v u f g A $.
    $( 1 is an identity element for positive real multiplication.  Theorem
       9-3.7(iv) of [Gleason] p. 124.  (Contributed by NM, 2-Apr-1996.)
       (New usage is discouraged.) $)
    1idpr $p |- ( A e. P. -> ( A .P. 1P ) = A ) $=
      ( vx vf vg vw vu vv vy vz wcel c1p co cv cmq wrex cltq wbr wa cnq c1q cnp
      cmp wceq wex df-rex 19.42v elprnq breq1 df-1p abeq2i ltmnq mulidnq breq2d
      wb bitrd syl5rbb sylan9bbr sylan pm5.32rd exbidv syl5rbbr syl5bb rexbidva
      ex 1pr df-mp mulclnq genpelv mpan2 prnmax wi crq cfv ltrelnq vex mulcomnq
      brel fvex caov12 recidnq oveq2d syl5eq sylan9eqr eqcomd ovex oveq2 eqeq2d
      mulassnq spcev 3syl a1i ancld reximia syl prcdnq adantrd rexlimdva impbid
      3bitr4d eqrdv ) AUAJZBAKUBLZAXABMZCMZDMZNLZUCZDKOZCAOZXCXDPQZXGDUDZRZCAOZ
      XCXBJZXCAJZXAXHXLCAXHXEKJZXGRZDUDZXAXDAJZRZXLXGDKUEXLXJXGRZDUDXTXRXJXGDUF
      XTYAXQDXTXGXJXPXTXGXJXPUNZXTXDSJZXGYBAXDUGXGXJXFXDPQZYCXPXCXFXDPUHXPXETPQ
      ZYCYDYEDKDUIUJYCYEXFXDTNLZPQYDXETXDUKYCYFXDXFPXDULUMUOUPUQURVDUSUTVAVBVCX
      AKUAJXNXIUNVEEFGHIAKXCCDUBNHIEFGVFFMGMVGVHVIXAXOXMXAXOXMXAXORXJCAOXMCAXCV
      JXJXLCAXSXJXKXJXKVKXSXJXCSJZYCRZXCXDXCXDVLVMZNLZNLZUCZXKXCXDSSPVNVQYHYKXC
      YCYGYKXCTNLZXCYCYKXCXDYINLZNLYMHIEXDXCYINCVOBVOXDVLVRHMZIMZVPYOYPEMWHVSYC
      YNTXCNXDVTWAWBXCULWCWDXGYLDYJXCYINWEXEYJUCXFYKXCXEYJXDNWFWGWIWJWKWLWMWNVD
      XAXLXOCAXTXJXOXKAXDXCWOWPWQWRWSWT $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Positive real 'less than' in terms of proper subset.  (Contributed by
       NM, 20-Feb-1996.)  (New usage is discouraged.) $)
    ltprord $p |- ( ( A e. P. /\ B e. P. ) -> ( A <P B <-> A C. B ) ) $=
      ( vx vy cnp wcel wa cltp wbr wpss wceq eleq1 anbi1d psseq1 anbi12d anbi2d
      cv psseq2 df-ltp brabg bianabs ) AEFZBEFZGZABHIABJZCQZEFZDQZEFZGZUFUHJZGU
      BUIGZAUHJZGUDUEGCDABEEHUFAKZUJULUKUMUNUGUBUIUFAELMUFAUHNOUHBKZULUDUMUEUOU
      IUCUBUHBELPUHBAROCDSTUA $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Proper subset is a linear ordering on positive reals.  Part of
       Proposition 9-3.3 of [Gleason] p. 122.  (Contributed by NM,
       25-Feb-1996.)  (New usage is discouraged.) $)
    psslinpr $p |- ( ( A e. P. /\ B e. P. ) ->
                ( A C. B \/ A = B \/ B C. A ) ) $=
      ( vx vy cnp wcel wa wpss wceq wo w3o cv wn wex wal cltq wss sspss orbi2i
      wi wbr cnq elprnq prub sylan2 prcdnq adantl exp43 com3r imp imp4a alrimdv
      syld com23 exlimdv xchnxbi dfss2 bitr3i 3imtr4g orrd df-3or orordir eqcom
      nss or32 bitr4i 3bitri sylibr ) AEFZBEFZGZABHZABIZJZBAHZBAIZJZJZVLVMVOKZV
      KVNVQVKCLZAFZVTBFMZGZCNZDLZBFZWEAFZTZDOZVNMVQVKWCWICVKWCWHDVKWFWCWGVKWFWA
      WBWGVIVJWFWAWBWGTZTZTVJWFVIWKVJWFVIWAWJVJWFGZVIWAGZGWBWEVTPUAZWGWMWLVTUBF
      WBWNTAVTUCBWEVTUDUEWMWNWGTWLAVTWEUFUGUMUHUIUJUKUNULUOABQWDVNCABVDABRUPVQB
      AQWIBARDBAUQURUSUTVSVNVOJVLVOJVMJZVRVLVMVOVAVLVMVOVEWOVNVOVMJZJVRVLVOVMVB
      VQWPVNVPVMVOBAVCSSVFVGVH $.
  $}

  ${
    $d x y z $.
    $( Positive real 'less than' is a strict ordering.  Part of Proposition
       9-3.3 of [Gleason] p. 122.  (Contributed by NM, 25-Feb-1996.)
       (New usage is discouraged.) $)
    ltsopr $p |- <P Or P. $=
      ( vx vy vz cnp cltp cv wcel wbr wn wa pssirr ltprord mtbiri anidms w3a wi
      wpss psstr wb w3o 3adant3 3adant1 anbi12d 3adant2 imbi12d mpbiri psslinpr
      weq biidd ancoms 3orbi123d mpbird issoi ) ABCDEAFZDGZUNUNEHZIUOUOJUPUNUNQ
      UNKUNUNLMNUOBFZDGZCFZDGZOZUNUQEHZUQUSEHZJZUNUSEHZPUNUQQZUQUSQZJZUNUSQZPUN
      UQUSRVAVDVHVEVIVAVBVFVCVGUOURVBVFSUTUNUQLZUAURUTVCVGSUOUQUSLUBUCUOUTVEVIS
      URUNUSLUDUEUFUOURJZVBABUHZUQUNEHZTVFVLUQUNQZTUNUQUGVKVBVFVLVLVMVNVJVKVLUI
      URUOVMVNSUQUNLUJUKULUM $.
  $}

  ${
    $d A b w x y z $.  $d B b x $.  $d b v w x y z $.
    prlem934.1 $e |- B e. _V $.
    $( Lemma 9-3.4 of [Gleason] p. 122.  (Contributed by NM, 25-Mar-1996.)
       (Revised by Mario Carneiro, 11-May-2013.)
       (New usage is discouraged.) $)
    prlem934 $p |- ( A e. P. -> E. x e. A -. ( x +Q B ) e. A ) $=
      ( vy wcel cv cplq co cnq wi wceq eleq1d wa cmq c1o cltq wbr syl2anc c1q
      vb vw vz vv cnp wral wn wrex c0 wne prn0 r19.2z ex syl prpssnq pssssd cxp
      sseld addnqf fdmi 0nnq ndmovrcl simprd syl6com com12 oveq2 ralbidv notbid
      rexlimivw imbi2d wss wpss dfpss2 sylib adantr w3a 3ad2ant1 wex simpl1 crq
      n0 cfv simprl simpl2 recclnq mulclnq archnq sylan2 simpll2 simplrl simprr
      cop cnpi wb ltmnq vex fvex mulcomnq mulassnq caov12 breq12i syl6bb oveq2d
      recidnq mulidnq sylan9eq breq1d bitrd syl21anc pinq sylan simpll1 simplrr
      biimpa elprnq ltaddnq addcomnq syl6breq ltsonq ltrelnq sotri simpll3 cpli
      opeq1 df-1nq syl6eqr oveq1d syl5eq oveq1 rspccva biimpar syl2an 1nq cplpq
      cerq cmi 1pi mpan2 mulidpi mpd 3impb 3simpa addassnq opex distrnq caovdir
      elexi addpqnq sylancl oveq2i addpipq mpanr12 oveq12d opeq12d eqtrd fveq2d
      mp1i addclpi nqerid 3syl 3eqtrd adantl 3eqtr3rd syl5ib exp3a expimpd syl5
      a1i a2d indpi imp syl13anc prcdnq rexlimddv expr exlimdv ssrdv eqssd mtod
      3expia expcom vtoclga 3syld pm2.01d rexnal sylibr ) BUEFZAGZCHIZBFZABUFZU
      GZUWJUGABUHUWGUWKUWGUWKUWJABUHZCJFZUWLUWGBUIUJZUWKUWMKBUKZUWOUWKUWMUWJABU
      LUMUNUWMUWGUWNUWJUWGUWNKABUWGUWJUWIJFZUWNUWGBJUWIUWGBJBUOZUPZURUWQUWHJFUW
      NUWHCJHJJUQJHUSUTVAVBVCVDVIVEUWNUWGUWLUWGUWHUAGZHIZBFZABUFZUGZKUWGUWLKUAC
      JUWTCLZUXDUWLUWGUXEUXCUWKUXEUXBUWJABUXEUXAUWIBUWTCUWHHVFMVGVHVJUWGUWTJFZU
      XDUWGUXFNUXCBJLZUWGUXGUGZUXFUWGBJVKZUXHUWGBJVLUXIUXHNUWRBJVMVNVCVOUWGUXFU
      XCUXGUWGUXFUXCVPZBJUWGUXFUXIUXCUWSVQUXJUBJBUXJUBGZJFZUXKBFZUXJUXLNZEGZBFZ
      EVRZUXMUXNUWGUXQUWGUXFUXCUXLVSUWGUWOUXQUWPEBWAVNUNUXNUXPUXMEUXJUXLUXPUXMU
      XJUXLUXPNZNZUXKUWTVTWBZOIZUCGZPWLZQRZUXMUCWMUXSUXLUXFUYDUCWMUHZUXJUXLUXPW
      CUWGUXFUXCUXRWDUXFUXLUXTJFZUYEUWTWEUXLUYFNUYAJFUYEUXKUXTWFUCUYAWGUNWHSUXS
      UYBWMFZUYDNZNZUXKUXOUYCUWTOIZHIZQRZUXMUYIUXKUYJQRZUYJUYKQRZUYLUYIUXFUXLUY
      DUYMUWGUXFUXCUXRUYHWIZUXJUXLUXPUYHWJUXSUYGUYDWKUXFUXLNZUYDUYMUYPUYDUXKUWT
      UXTOIZOIZUYJQRZUYMUXFUYDUYSWNUXLUXFUYDUWTUYAOIZUWTUYCOIZQRUYSUYAUYCUWTWOU
      YTUYRVUAUYJQUDAEUWTUXKUXTOUAWPZUBWPUWTVTWQUDGZUWHWRZVUCUWHUXOWSWTUWTUYCWR
      XAXBVOUYPUYRUXKUYJQUXFUXLUYRUXKTOIUXKUXFUYQTUXKOUWTXDXCUXKXEXFXGXHXNXIUYI
      UYJJFZUXOJFZUYNUYIUYGUXFVUEUXSUYGUYDWCZUYOUYGUYCJFZUXFVUEUYBXJZUYCUWTWFXK
      SUYIUWGUXPVUFUWGUXFUXCUXRUYHXLZUXJUXLUXPUYHXMZBUXOXOSVUEVUFNUYJUYJUXOHIUY
      KQUYJUXOXPUYJUXOXQXRSUXKUYJUYKQJXSXTYASUYIUWGUYKBFZUYLUXMKVUJUYIUYGUXFUXC
      UXPVULVUGUYOUWGUXFUXCUXRUYHYBVUKUYGUXFUXCUXPVPZVULVUMUXOUXKPWLZUWTOIZHIZB
      FZKVUMUXOTUWTOIZHIZBFZKVUMVULKZVUMUXOUYBPYCIZPWLZUWTOIZHIZBFZKVVAUBUCUYBU
      XKPLZVUQVUTVUMVVGVUPVUSBVVGVUOVURUXOHVVGVUNTUWTOVVGVUNPPWLZTUXKPPYDYEYFYG
      XCMVJUXKUYBLZVUQVULVUMVVIVUPUYKBVVIVUOUYJUXOHVVIVUNUYCUWTOUXKUYBPYDYGXCMV
      JZUXKVVBLZVUQVVFVUMVVKVUPVVEBVVKVUOVVDUXOHVVKVUNVVCUWTOUXKVVBPYDYGXCMVJVV
      JUXFUXCUXPVUTUXFVURUWTLZUXOUWTHIZBFZVUTUXCUXPNUXFVURUWTTOIUWTTUWTWRUWTXEY
      HZUXBVVNAUXOBUWHUXOLUXAVVMBUWHUXOUWTHYIMYJVVLVUTVVNVVLVUSVVMBVURUWTUXOHVF
      MYKYLUUAUYGVUMVULVVFVUMUXFUXCNUYGVULVVFKZUXFUXCUXPUUBUYGUXFUXCVVPUYGUXFNZ
      UXCVULVVFUXCVULNUYKUWTHIZBFZVVQVVFUXBVVSAUYKBUWHUYKLUXAVVRBUWHUYKUWTHYIMY
      JVVQVVRVVEBVVQVVRUXOUYJUWTHIZHIVVEUXOUYJUWTUUCVVQVVTVVDUXOHVVQUYCTHIZUWTO
      IZUYJVURHIZVVDVVTVWBVWCLVVQUDAEUYCTUWTHOUYBPUUDTJYMUUGVUBVUDVUCUWHUXOUUEU
      UFUVHVVQVWAVVCUWTOUYGVWAVVCLUXFUYGVWAUYCTYNIZYOWBZVVCYOWBZVVCUYGVUHTJFVWA
      VWELVUIYMUYCTUUHUUIUYGVWDVVCYOUYGVWDUYBPYPIZPPYPIZYCIZVWHWLZVVCUYGVWDUYCV
      VHYNIZVWJTVVHUYCYNYEUUJUYGPWMFZVWKVWJLZYQUYGVWLNVWLVWLVWMYQYQUYBPPPUUKUUL
      YRYHUYGVWIVVBVWHPUYGVWGUYBVWHPYCUYBYSVWLVWHPLUYGYQPYSUUQZUUMVWNUUNUUOUUPU
      YGVVBWMFZVVCJFVWFVVCLUYGVWLVWOYQUYBPUURYRVVBXJVVCUUSUUTUVAVOYGVVQVURUWTUY
      JHUXFVVLUYGVVOUVBXCUVCXCYHMUVDUVEUVFUVGUVIUVJUVKUVLBUYKUXKUVMSYTUVNUVOUVP
      YTUMUVQUVRUVTUVSUWAUWBVEUWCUWDUWJABUWEUWF $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    $( The sum of two positive reals is greater than one of them.  Proposition
       9-3.5(iii) of [Gleason] p. 123.  (Contributed by NM, 26-Mar-1996.)
       (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    ltaddpr $p |- ( ( A e. P. /\ B e. P. ) -> A <P ( A +P. B ) ) $=
      ( vy vx vz vw vv cnp wcel wa cpp co wbr cv wn wi cplq adantr cnq mpd cltp
      wpss wex c0 wne prn0 n0 sylib adantl wss addclpr df-plp addclnq genpprecl
      wceq wal imp cltq elprnq addnqf fdmi 0nnq ndmovrcl ltaddnq prcdnq syl2anc
      3syl exp32 com23 alrimdv dfss2 syl6ibr wrex prlem934 eleq2 biimprcd con3d
      cxp vex syl6 exp3a com34 rexlimdv dfpss2 exlimdv wb ltprord syldan mpbird
      jcad ) AHIZBHIZJZAABKLZUAMZAWNUBZWMCNZBIZCUCZWPWLWSWKWLBUDUEWSBUFCBUGUHUI
      WMWRWPCWMWRAWNUJZAWNUOZOZJWPWMWRWTXBWMWRDNZAIZXCWNIZPZDUPWTWMWRXFDWMXDWRX
      EWMXDWRXEWMXDWRJZJWNHIZXCWQQLZWNIZXEWMXHXGABUKZRWMXGXJDCEFGABXCWQKQFGDCEU
      LWQENUMUNZUQXHXJJZXCXIURMZXEXMXISIXCSIWQSIJXNWNXIUSXCWQSQSSVRSQUTVAVBVCXC
      WQVDVGWNXIXCVETVFVHVIVJDAWNVKVLWMXIAIZOZDAVMZWRXBPZWKXQWLDAWQCVSVNRWMXPXR
      DAWMXDWRXPXBWMXDWRXPXBPZWMXGXJXSXLXJXAXOXAXOXJAWNXIVOVPVQVTWAWBWCTWJAWNWD
      VLWETWKWLXHWOWPWFXKAWNWGWHWI $.
  $}

  $( The sum of two positive reals is greater than one of them.  (Contributed
     by NM, 13-May-1996.)  (New usage is discouraged.) $)
  ltaddpr2 $p |- ( C e. P. -> ( ( A +P. B ) = C -> A <P C ) ) $=
    ( cpp co wceq cnp wcel cltp eleq1 dmplp 0npr ndmovrcl syl6bir ltaddpr breq2
    wbr wa syl5ib syld com12 ) ABDEZCFZCGHZACIQZUCUDAGHBGHRZUEUCUDUBGHUFUBCGJAB
    GDKLMNUFAUBIQUCUEABOUBCAIPSTUA $.

  ${
    $d x y z w v f g h A $.  $d x y z w v B $.  $d x z w v f g h C $.
    $d x y z w v u f g h $.
    ltexprlem.1 $e |- C = { x | E. y ( -. y e. A /\ ( y +Q x ) e. B ) } $.
    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 3-Apr-1996.)  (New usage is discouraged.) $)
    ltexprlem1 $p |- ( B e. P. -> ( A C. B -> C =/= (/) ) ) $=
      ( cnp wcel wpss cv wn cplq co wa wex c0 wne pssnel prnmadd anim2i syl5 n0
      19.42v sylibr exp32 com3l imp3a eximdv abeq2i exbii excom 3bitr4i syl6ibr
      ) DGHZCDIZBJZCHKZUPAJZLMDHZNZAOZBOZEPQZUOUPDHZUQNZBOUNVBBCDRUNVEVABUNVDUQ
      VAUQUNVDVAUQUNVDVAUQUNVDNZNUQUSAOZNVAVFVGUQADUPSTUQUSAUCUDUEUFUGUHUAUREHZ
      AOUTBOZAOVCVBVHVIAVIAEFUIUJAEUBUTBAUKULUM $.

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 3-Apr-1996.)  (New usage is discouraged.) $)
    ltexprlem2 $p |- ( B e. P. -> C C. Q. ) $=
      ( cnp wcel cnq cv wn cplq co wa wex abeq2i elprnq cxp cltq wbr addnqf syl
      fdmi 0nnq ndmovrcl ltaddnq ancoms addcomnq syl6breq prcdnq mpd ex adantld
      syl5 exlimdv syl5bi ssrdv prpssnq sspsstrd ) DGHZEDIUTAEDAJZEHBJZCHKZVBVA
      LMZDHZNZBOZUTVADHZVGAEFPUTVFVHBUTVEVHVCUTVEVHUTVENZVBIHZVAIHZNZVHVIVDIHVL
      DVDQVBVAILIIRILUAUCUDUEUBVLVAVDSTVIVHVLVAVAVBLMZVDSVKVJVAVMSTVAVBUFUGVAVB
      UHUIDVDVAUJUNUKULUMUOUPUQDURUS $.

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 6-Apr-1996.)  (New usage is discouraged.) $)
    ltexprlem3 $p |- ( B e. P. ->
                  ( x e. C -> A. z ( z <Q x -> z e. C ) ) ) $=
      ( cnp wcel cv cltq wbr wi wa wn cplq co wex cnq wb elprnq cxp addnqf fdmi
      0nnq ndmovrcl simpld 3syl prcdnq sylbid impancom anim2d eximdv abeq2i vex
      ltanq weq oveq2 eleq1d anbi2d exbidv elab2 3imtr4g ex com23 alrimdv ) EHI
      ZAJZFIZCJZVHKLZVJFIZMCVGVKVIVLVGVKVIVLMVGVKNZBJZDIOZVNVHPQZEIZNZBRZVOVNVJ
      PQZEIZNZBRZVIVLVMVRWBBVMVQWAVOVGVQVKWAVGVQNZVKVTVPKLZWAWDVPSIZVNSIZVKWETE
      VPUAWFWGVHSIVNVHSPSSUBSPUCUDUEUFUGVJVHVNUPUHEVPVTUIUJUKULUMVSAFGUNVSWCAVJ
      FCUOACUQZVRWBBWHVQWAVOWHVPVTEVHVJVNPURUSUTVAGVBVCVDVEVF $.

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 6-Apr-1996.)  (New usage is discouraged.) $)
    ltexprlem4 $p |- ( B e. P. ->
                  ( x e. C -> E. z ( z e. C /\ x <Q z ) ) ) $=
      ( vw wcel cv cplq wa wex cltq wbr wceq cnq ltrelnq exbii sylibr cnp wn co
      wrex prnmax df-rex sylib brel simpld cxp addnqf fdmi ndmovrcl syl ltaddnq
      ltsonq sotri sylan mpancom simprd ltexnq biimpd mpcom eqcom anim2i 19.41v
      0nnq ancri an12 eximi excom ovex eleq1 breq2 anbi12d ltanq ndmovordi 3syl
      ceqsexv sylbi an12s 19.42v ex eximdv abeq2i vex oveq2 eleq1d anbi2d elab2
      exbidv anbi1i anass 3bitr2i bitr4i 3imtr4g ) EUAIZBJZDIUBZWRAJZKUCZEIZLZB
      MZWSWRCJZKUCZEIZWTXENOZLZLZCMZBMZWTFIXEFIZXHLZCMZWQXCXKBWQXCXKWQXCLWSXICM
      ZLZXKWSWQXBXQWQXBLZXPWSXRHJZEIZXAXSNOZLZHMZXSXFPZYBLZHMZCMZXPXRYAHEUDYCHE
      XAUEYAHEUFUGYCYECMZHMYGYBYHHYBYDCMZYBLZYHYBXTYIYALZLYJYAYKXTYAYIYAXFXSPZC
      MZYIYAWRXSNOZYMWRQIZWTQILZYAYNYAXAQIZYPYAYQXSQIZXAXSQQNRUHUIWRWTQKQQUJQKU
      KULZVGUMUNYPWRXANOYAYNWRWTUOWRXAXSNQUPRUQURUSYRYNYMYNYOYRWRXSQQNRUHUTYRYN
      YMCWRXSVAVBVCUNYDYLCXSXFVDSTVHVEYIXTYAVITYDYBCVFTVJYECHVKTYFXICYFXGXAXFNO
      ZLZXIYBUUAHXFWRXEKVLYDXTXGYAYTXSXFEVMXSXFXANVNVOVSYTXHXGWTXEWRNQKYSRVGWTX
      EWRVPVQVEVTVJVRVEWAWSXICWBTWCWDXDAFGWEXOXJBMZCMXLXNUUBCXNWSXGLZBMZXHLUUCX
      HLZBMUUBXMUUDXHXDUUDAXEFCWFWTXEPZXCUUCBUUFXBXGWSUUFXAXFEWTXEWRKWGWHWIWKGW
      JWLUUCXHBVFUUEXJBWSXGXHWMSWNSXJBCVKWOWP $.

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 6-Apr-1996.)  (New usage is discouraged.) $)
    ltexprlem5 $p |- ( ( B e. P. /\ A C. B ) -> C e. P. ) $=
      ( vz cnp wcel wpss wa c0 cnq cv cltq wbr wi wal syl6ibr adantr ltexprlem1
      wrex wral wne 0pss imp ltexprlem2 ltexprlem3 wex ltexprlem4 jcad ralrimiv
      df-rex jca31 elnp sylibr ) DHIZCDJZKZLEJZEMJZKGNZANZOPVBEIZQGRZVCVBOPZGEU
      BZKZAEUCZKEHIUSUTVAVIUQURUTUQURELUDUTABCDEFUAEUESUFUQVAURABCDEFUGTUQVIURU
      QVHAEUQVCEIZVEVGABGCDEFUHUQVJVDVFKGUIVGABGCDEFUJVFGEUMSUKULTUNAGEUOUP $.

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 8-Apr-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    ltexprlem6 $p |- ( ( ( A e. P. /\ B e. P. ) /\ A C. B ) ->
                     ( A +P. C ) C_ B ) $=
      ( vz vw vg vh cnp wcel co wa cv cplq wi cltq cnq vex vf wpss cpp wss wceq
      vv vu wrex ltexprlem5 df-plp addclnq genpelv sylan2 wex abeq2i wbr elprnq
      wb wn cxp addnqf fdmi 0nnq ndmovrcl simpld syl prub simprd ltanq addcomnq
      caovord2 3syl prcdnq sylbid adantl exp32 com34 imp4b exlimdv syl5bi exp31
      syld com23 imp43 eleq1 biimparc sylan rexlimdvv adantrr ssrdv anassrs ) C
      KLZDKLZCDUBZCEUCMZDUDWLWMWNNZNZGWODWQGOZWOLZWRHOZAOZPMZUEZAEUHHCUHZWRDLZW
      PWLEKLWSXDURABCDEFUIUAIJGBCEWRHAUCPGBUAIJUJIOJOUKULUMWLWMXDXEQWNWLWMNZXCX
      EHACEXFWTCLZXAELZNZXCXEXFXINXBDLZXCXEWLWMXGXHXJWLXGWMXHXJQZWLXGWMXKXHBOZC
      LUSZXLXAPMZDLZNZBUNZWLXGNZWMNZXJXQAEFUOXSXPXJBXRWMXMXOXJXRWMXOXMXJXRWMXOX
      MXJQXRWMXONZNXMWTXLRUPZXJXTXRXLSLZXMYAQXTXNSLZYBDXNUQZYCYBXASLZXLXASPSSUT
      SPVAVBVCVDZVEVFCWTXLVGUMXTYAXJQXRXTYAXBXNRUPZXJXTYCYEYAYGURYDYCYBYEYFVHGU
      FUGWTXLXARSPHTBTWRUFOZUGOVIATWRYHVJVKVLDXNXBVMVNVOWBVPVQVRVSVTWAWCWDXCXEX
      JWRXBDWEWFWGWAWHWIVNWJWK $.

    $( Lemma for Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by
       NM, 8-Apr-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    ltexprlem7 $p |- ( ( ( A e. P. /\ B e. P. ) /\ A C. B ) ->
                     B C_ ( A +P. C ) ) $=
      ( vw vv vz vf cnp wcel wa co cv wi wb exp3a cplq cnq vg vh cpp ltexprlem5
      wpss cltp wbr ltaddpr addclpr ltprord syldan mpbid pssssd sseld a1d com4r
      wex prnmadd elprnq cxp addnqf fdmi 0nnq ndmovrcl syl simpld wrex prlem934
      vex adantr wceq cltq prub ltexnq adantl sylibd ad2ant2r addcomnq addassnq
      wn ex caov32 oveq1 syl5eq eleq1d biimpar ovex eleq1 notbid anbi12d abeq2i
      spcev sylibr sylan2 df-plp addclnq genpprecl sylan2i exp4d imp42 ad2antrl
      exp32 exlimdv syl6d rexlimddv com14 syld com4t pm2.61i syl5 com34 pm2.43d
      mpd imp31 ssrdv ) CKLZDKLZMCDUEZMGDCEUCNZXPXQXRGOZDLZXTXSLZPZXPXQXRYCPXPX
      QXRXQYCXPXQXRXQYCPZXQXRMEKLZXPYDABCDEFUDXTCLZXPYEYDPPYFXPYEYDXPYEMZXQYAYF
      YBYGYAYFYBPZPXQYGYHYAYGCXSXTYGCXSYGCXSUFUGZCXSUEZCEUHXPYEXSKLYIYJQCEUICXS
      UJUKULUMUNUOUOUPRYFVTZXPYEYDXQYAYKYGYBXQYAXTHOZSNZDLZHUQZYKYGYBPPZXQYAYOH
      DXTURWAXQYNYPHXQYNYPXQYNMZXTTLZYPYQYRYLTLZYQYMTLYRYSMDYMUSXTYLTSTTUTTSVAV
      BVCVDVEVFYNYRYPPXQYGYRYKYNYBYGIOZYLSNZCLZVTZYRYKYNYBPZPPICXPUUCICVGYEICYL
      HVIZVHVJYGYTCLZUUCMMZYRYKYTAOZSNZXTVKZAUQZUUDXPUUFYRYKUUKPZPYEUUCXPUUFMZY
      RUULUUMYRMYKYTXTVLUGZUUKCYTXTVMYRUUNUUKQUUMAYTXTVNVOVPWAVQUUGUUJUUDAUUGUU
      JYNYBUUGUUJYNMZMUUIXSLZYBYGUUFUUCUUOUUPYGUUFUUCUUOUUPUUCUUOMYGUUFUUHELZUU
      PUUOUUCUUAUUHSNZDLZUUQUUJUUSYNUUJUURYMDUUJUURUUIYLSNYMJUAUBYTYLUUHSIVIUUE
      AVIJOZUAOZVRUUTUVAUBOVSWBUUIXTYLSWCWDWEWFUUCUUSMZBOZCLZVTZUVCUUHSNZDLZMZB
      UQZUUQUVHUVBBUUAYTYLSWGUVCUUAVKZUVEUUCUVGUUSUVJUVDUUBUVCUUACWHWIUVJUVFUUR
      DUVCUUAUUHSWCWEWJWLUVIAEFWKWMWNIJHAGCEYTUUHUCSAGIJHWOUUTYLWPWQWRWSWTUUJUU
      PYBQUUGYNUUIXTXSWHXAULXBXCXDXEXFVOXMWAXCXGXHRXIXJRXKXLXNXO $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Proposition 9-3.5(iv) of [Gleason] p. 123.  (Contributed by NM,
       13-May-1996.)  (Revised by Mario Carneiro, 14-Jun-2013.)
       (New usage is discouraged.) $)
    ltexpri $p |- ( A <P B -> E. x e. P. ( A +P. x ) = B ) $=
      ( vw vy vz cnp wcel wa cltp wbr cv cpp wceq wrex ltrelpr cplq wex oveq2
      co brel wpss ltprord wn eleq1d anbi2d exbidv cbvabv ltexprlem5 ltexprlem6
      cab adantll ltexprlem7 eqssd eqeq1d rspcev syl2anc ex sylbid mpcom ) BGHZ
      CGHZIZBCJKZBALZMTZCNZAGOZBCGGJPUAVCVDBCUBZVHBCUCVCVIVHVCVIIZDLZBHUDZVKELZ
      QTZCHZIZDRZEUKZGHZBVRMTZCNZVHVBVIVSVAFDBCVRVQVLVKFLZQTZCHZIZDREFVMWBNZVPW
      EDWFVOWDVLWFVNWCCVMWBVKQSUEUFUGUHZUIULVJVTCFDBCVRWGUJFDBCVRWGUMUNVGWAAVRG
      VEVRNVFVTCVEVRBMSUOUPUQURUSUT $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Lemma for Proposition 9-3.5(v) of [Gleason] p. 123.  (Contributed by NM,
       8-Apr-1996.)  (New usage is discouraged.) $)
    ltaprlem $p |- ( C e. P. -> ( A <P B ->
                    ( C +P. A ) <P ( C +P. B ) ) ) $=
      ( vx cnp wcel cltp wbr cpp co ltrelpr brel simpld cv wceq wrex wa ltexpri
      wi exp3a addclpr ltaddpr addasspr oveq2 syl5eq breq2d syl5 com3r rexlimiv
      syl5ib syl sylan2i pm2.43b ) CEFZABGHZCAIJZCBIJZGHZUOUNUOURUOUOUNAEFZURUO
      USBEFABEEGKLMUOADNZIJZBOZDEPUNUSQZURSZDABRVBVDDEVBVCUTEFZURVCUPEFZVBVEURS
      CAUAVBVFVEURVFVEQUPUPUTIJZGHVBURUPUTUBVBVGUQUPGVBVGCVAIJUQCAUTUCVABCIUDUE
      UFUJTUGUHUIUKULTUM $.
  $}

  $( Ordering property of addition.  Proposition 9-3.5(v) of [Gleason] p. 123.
     (Contributed by NM, 8-Apr-1996.)  (New usage is discouraged.) $)
  ltapr $p |- ( C e. P. -> ( A <P B <-> ( C +P. A ) <P ( C +P. B ) ) ) $=
    ( cltp cnp cpp ltrelpr wcel wbr co wb wa ltaprlem adantr wceq ltsopr sotric
    wi wn wo dmplp 0npr olc mpan adantl addclpr anim12dan sylancr 3imtr3d con4d
    wor syl5 df-or syl6ib com23 soirri oveq2 breq2d mtbiri pm2.21d impbid 3impb
    pm2.61d2 3com13 ndmovord ) ABCDEFUAGUBCEHZBEHZAEHZABDIZCAFJZCBFJZDIZKZVFVGV
    HVMVFVGVHLZLZVIVLVFVIVLRVNABCMNVOBAOZVLVIRVOVLVPSZVIVOVLVPVITZVQVIRVLVKVJOZ
    VLTZVOVRVLVSUCVOVRVTVOBADIZVKVJDIZVRSZVTSZVFWAWBRVNBACMNVNWAWCKZVFEDUKZVNWE
    PEBADQUDUEVOWFVKEHZVJEHZLWBWDKPVFVGWGVHWHCBUFCAUFUGEVKVJDQUHUIUJULVPVIUMUNU
    OVPVLVIVPVLVJVJDIVJDEPGUPVPVKVJVJDBACFUQURUSUTVCVAVBVDVE $.

  $( Addition cancellation law for positive reals.  Proposition 9-3.5(vi) of
     [Gleason] p. 123.  (Contributed by NM, 9-Apr-1996.)
     (New usage is discouraged.) $)
  addcanpr $p |- ( ( A e. P. /\ B e. P. ) ->
                 ( ( A +P. B ) = ( A +P. C ) -> B = C ) ) $=
    ( cnp wcel wa cpp co wceq wi addclpr cltp wbr wo wn wb ltapr ltsopr sotrieq
    mpan eleq1 dmplp 0npr ndmovrcl syl6bi syl5com orbi12d ad2antrr wor ad2ant2l
    notbid syl2an 3bitr4d exbiri syld pm2.43d ) ADEZBDEZFZABGHZACGHZIZBCIZUSVBU
    QCDEZFZVBVCJUSUTDEZVBVEABKZVBVFVADEZVEUTVADUAACDGUBUCUDUEUFUSVEVCVBUSVEFBCL
    MZCBLMZNZOZUTVALMZVAUTLMZNZOZVCVBUQVLVPPURVEUQVKVOUQVIVMVJVNBCAQCBAQUGUKUHU
    RVDVCVLPZUQUQDLUIZURVDFVQRDBCLSTUJUSVFVHVBVPPZVEVGACKVRVFVHFVSRDUTVALSTULUM
    UNUOUP $.

  ${
    $d x y z b A $.  $d x b B $.  $d b u v w x y z $.
    $( Lemma 9-3.6 of [Gleason] p. 124.  (Contributed by NM, 26-Apr-1996.)
       (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    prlem936 $p |- ( ( A e. P. /\ 1Q <Q B ) ->
                   E. x e. A -. ( x .Q B ) e. A ) $=
      ( vy vz cnq wcel c1q cltq wbr wa cv cmq co wi wceq adantr cplq syl wb cnp
      vb vu vw vv wn wrex ltrelnq brel simprd adantl breq2 anbi2d eleq1d notbid
      oveq2 rexbidv imbi12d wex c0 prn0 n0 sylib elprnq ad2ant2r mulidnq simplr
      wne ltmnq biimpa syl2anc eqbrtrrd ad2antlr mulclnq mpbid simplll prlem934
      ltexnq vex simprr eleq1 biimparc sylan cxp addnqf fdmi 0nnq ndmovrcl prub
      addclnq syl21anc ad2antrr crq cfv recclnq sylan2 ancoms mulassnq mulcomnq
      oveq2i eqtri recidnq oveq2d syl5eq breq1d bitrd adantll mulnqf ltanq ovex
      sylan9eq simpld distrnq caovdir caov12 sylan9eqr eqtr4i a1i breq2d bitr4d
      oveq12d adantrr addcomnq breq12i syl6bb ad2antrl caov411 adantrl syl22anc
      fvex oveq1 3bitr3d sylibd prcdnq impancom con3d ex com23 mpdd exlimddv
      reximdva mpd expr rspcev pm2.61d vtoclg mpcom ) CFGZBUAGZHCIJZKZALZCMNZBG
      ZUFZABUGZUUJUUHUUIUUJHFGZUUHHCFFIUHUIUJUKUUIHUBLZIJZKZUULUURMNZBGZUFZABUG
      ZOUUKUUPOUBCFUURCPZUUTUUKUVDUUPUVEUUSUUJUUIUURCHIULUMUVEUVCUUOABUVEUVBUUN
      UVEUVAUUMBUURCUULMUPUNUOUQURUUTDLZBGZUVDDUUIUVGDUSZUUSUUIBUTVHUVHBVADBVBV
      CQUUTUVGKUVFUURMNZBGZUVDUUTUVGUVJUVDUUTUVGUVJKZKZUVFELZRNZUVIPZUVDEUVLUVF
      UVIIJZUVOEUSZUVLUVFHMNZUVFUVIIUVLUVFFGZUVRUVFPUUIUVGUVSUUSUVJBUVFVDVEZUVF
      VFSUVLUVSUUSUVRUVIIJZUVTUUIUUSUVKVGUVSUUSUWAHUURUVFVIVJVKVLUVLUVIFGZUVPUV
      QTUVLUVSUURFGZUWBUVTUUSUWCUUIUVKUUSUUQUWCHUURFFIUHUIUJVMZUVFUURVNVKEUVFUV
      IVRSVOUVLUVOKZUULUVMRNZBGZUFZABUGZUVDUWEUUIUWIUUIUUSUVKUVOVPZABUVMEVSZVQS
      UWEUWHUVCABUWEUULBGZKZUWHUWFUVAIJZUVCUWMUWHUVNUWFIJZUWNUWMUUIUVNBGZUWFFGZ
      UWHUWOOUWEUUIUWLUWJQZUWEUWPUWLUVLUVJUVOUWPUUTUVGUVJVTUVOUWPUVJUVNUVIBWAWB
      WCZQUWMUULFGZUVMFGZUWQUWEUUIUWLUWTUWJBUULVDWCZUWEUXAUWLUWEUUIUWPUXAUWJUWS
      UUIUWPKUVNFGZUXABUVNVDUXCUVSUXAUVFUVMFRFFWDZFRWEWFWGWHUJSVKQZUULUVMWJVKBU
      VNUWFWIWKUWMUVAFGZUVSUXAUVOUWOUWNTUWMUWTUWCUXFUXBUVLUWCUVOUWLUWDWLUULUURV
      NVKUVLUVSUVOUWLUVTWLUXEUVLUVOUWLVGUXFUVSKZUXAUVOKKUVFUULIJZUWFUVNUULUVFWM
      WNZMNZMNZIJZUWOUWNUXGUXAUXHUXLTUVOUXGUXAKUXHUVMUVMUXIMNZUULMNZIJZUXLUVSUX
      AUXHUXOTUXFUVSUXAKZUXHUXMUVFMNZUXNIJZUXOUXPUXMFGZUXHUXRTUXAUVSUXSUVSUXAUX
      IFGUXSUVFWOUVMUXIVNWPWQUVFUULUXMVISUXPUXQUVMUXNIUXPUXQUVMUVFUXIMNZMNZUVMU
      XQUVMUXIUVFMNZMNUYAUVMUXIUVFWRUYBUXTUVMMUXIUVFWSWTXAUVSUXAUYAUVMHMNUVMUVS
      UXTHUVMMUVFXBZXCUVMVFXKXDXEXFXGUXGUXOUXLTUXAUXGUXOUWFUULUXNRNZIJZUXLUXFUX
      OUYETZUVSUXFUWTUYFUXFUWTUWCUULUURFMUXDFMXHWFWGWHXLZUVMUXNUULXISQUXGUXKUYD
      UWFIUXGUXKUVFUXJMNZUVMUXJMNZRNUYDUCUDUEUVFUVMUXJRMDVSZUWKUULUXIMXJUCLZUDL
      ZWSZUYKUYLUELZXMXNUXGUYHUULUYIUXNRUXGUYHUULUXTMNZUULUCUDUEUVFUULUXIMUYJAV
      SZUVFWMYJZUYMUYKUYLUYNWRZXOUVSUXFUYOUULHMNZUULUVSUXTHUULMUYCXCUXFUWTUYSUU
      LPUYGUULVFSXPXDUYIUXNPUXGUYIUVMUXIUULMNZMNUXNUXJUYTUVMMUULUXIWSWTUVMUXIUU
      LWRXQXRYAXDXSXTQXFYBUXAUXHUWOTUXGUVOUXAUXHUVMUVFRNZUVMUULRNZIJUWOUVFUULUV
      MXIVUAUVNVUBUWFIUVMUVFYCUVMUULYCYDYEYFUXGUVOUXLUWNTUXAUXGUVOKUXKUVAUWFIUV
      OUXGUXKUVIUXJMNZUVAUVNUVIUXJMYKUXGVUCUVAUXTMNZUVAUCUDUEUVFUURUULUXIMUYJUB
      VSUYPUYMUYRUYQYGUVSUXFVUDUVAHMNUVAUVSUXTHUVAMUYCXCUVAVFXPXDXPXSYHYLYIYMUW
      MUUIUWHUWNUVCOOUWRUUIUWNUWHUVCUUIUWNUWHUVCOUUIUWNKUVBUWGUUIUVBUWNUWGBUVAU
      WFYNYOYPYQYRSYSUUAUUBYTUUCUVGUVJUFZUVDOUUTUVGVUEUVDUVCVUEAUVFBUULUVFPZUVB
      UVJVUFUVAUVIBUULUVFUURMYKUNUOUUDYQUKUUEYTUUFUUG $.
  $}

  ${
    $d x y z w v u f g A $.  $d x z w v u f g B $.
    reclempr.1 $e |- B = { x | E. y ( x <Q y /\ -. ( *Q ` y ) e. A ) } $.
    $( Lemma for Proposition 9-3.7 of [Gleason] p. 124.  (Contributed by NM,
       30-Apr-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    reclem2pr $p |- ( A e. P. -> B e. P. ) $=
      ( vz wcel c0 cnq wa cltq wbr wn wex crq cfv syl eleq1d sylibr jca wpss cv
      cnp wi wal wrex wral prpssnq pssnel recclnq nsmallnq adantr notbid anbi2d
      wne recrecnq fvex wceq breq2 fveq2 anbi12d spcev syl6bir vex breq1 anbi1d
      exbidv elab2 syl6ibr exp3acom23 imp eximdv mpd exlimiv 3syl 0pss wss prn0
      n0 wb elprnq pm2.43i dmrecnq ndmfvrcl ltrnq prcdnq syl5bi alrimiv exanali
      0nnq abeq2i bitri con2bii sylib eximi ex exlimdv nss 3imtr4g ltrelnq brel
      simpld sylbi ssriv jctil dfpss3 ltsonq sotri anim1d com12 cab nfe1 nfcxfr
      nfab nfrex 19.8a adantll simpll expcom ltbtwnnq df-rex impcom exlimi rgen
      nfv jctir elnp ) CUCGZHDUAZDIUAZJZFUBZAUBZKLZYLDGZUDZFUEZYMYLKLZFDUFZJZAD
      UGZJDUCGYHYKUUAYHYIYJYHDHUOZYIYHCIUAYMIGZYMCGZMZJZANUUBCUHACIUIUUFUUBAUUF
      YOFNZUUBUUFYLYMOPZKLZFNZUUGUUCUUJUUEUUCUUHIGZUUJYMUJFUUHUKQULUUFUUIYOFUUC
      UUEUUIYOUDUUCUUIUUEYOUUCUUIUUEJZYLBUBZKLZUUMOPZCGZMZJZBNZYOUUCUULUUIUUHOP
      ZCGZMZJZUUSUUCUVBUUEUUIUUCUVAUUDUUCUUTYMCYMUPRUMUNUURUVCBUUHYMOUQUUMUUHUR
      ZUUNUUIUUQUVBUUMUUHYLKUSUVDUUPUVAUVDUUOUUTCUUMUUHOUTRUMVAVBVCYMUUMKLZUUQJ
      ZBNZUUSAYLDFVDYMYLURZUVFUURBUVHUVEUUNUUQYMYLUUMKVEVFVGEVHZVIVJVKVLVMFDVSS
      VNVODVPSYHDIVQZIDVQMZJYJYHUVKUVJYHCHUOZUVKCVRYHYLCGZFNUUCYMDGZMZJZANZUVLU
      VKYHUVMUVQFYHUVMUVQYHUVMJZYHUUHCGZJZANZUVQUVRUWAUVRUVRYHYLOPZOPZCGZJZUWAU
      VRYLIGZUWEUVRVTCYLWAUWFUWDUVMYHUWFUWCYLCYLUPRUNQUVTUWEAUWBYLOUQYMUWBURZUV
      SUWDYHUWGUUHUWCCYMUWBOUTRUNVBVCWBUVTUVPAUVTUUCUVOUVTUUKUUCCUUHWAYMIOWCWJW
      DQUVTUVEUUPUDZBUEZUVOUVTUWHBUVEUUOUUHKLUVTUUPYMUUMWECUUHUUOWFWGWHUVNUWIUV
      NUVGUWIMUVGADEWKZUVEUUPBWIWLWMWNTWOQWPWQFCVSAIDWRWSVMADIUVNUVGUUCUWJUVFUU
      CBUVEUUCUUQUVEUUCUUMIGYMUUMIIKWTXAXBULVNXCXDXEDIXFSTYTADUVNYQYSUVNYPFYNUV
      NYOYNUVGUUSUVNYOYNUVFUURBYNUVEUUNUUQYNUVEUUNYLYMUUMKIXGWTXHWPXIVLUWJUVIWS
      XJWHUVNUVGYSUWJUVFYSBYRBFDBDUVGAXKEUVGBAUVFBXLXNXMYRBYEXOUUQUVEYSUUQYRUUN
      JZFNYOYRJZFNUVEYSUUQUWKUWLFUWKUUQUWLUWKUUQJYOYRUUNUUQYOYRUURUUSYOUURBXPUV
      ISXQYRUUNUUQXRTXSVLFYMUUMXTYRFDYAWSYBYCXCTYDYFAFDYGS $.

    $( Lemma for Proposition 9-3.7(v) of [Gleason] p. 124.  (Contributed by NM,
       30-Apr-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    reclem3pr $p |- ( A e. P. -> 1P C_ ( A .P. B ) ) $=
      ( vw vv vz wcel co cv c1q cltq wbr wa crq cfv cmq cnq wceq vu cnp c1p cmp
      vf vg df-1p abeq2i wrex ltrnq mulcomnq recclnq mulidnq mp2b recidnq ax-mp
      wn 1nq 3eqtr3i breq1i prlem936 sylan2b prnmax ad2ant2r w3a elprnq 3adant3
      bitri simp1r ltrelnq brel simpld syl simp3 simp2r fvex ltmnq vex caovord2
      wb syl5bb adantl biimpd syl5eqr oveqan12d mulassnq caov4 3eqtr3g recmulnq
      mulclnq sylan mpbird eleq1d notbid biimprd anim12d wex ovex breq2 anbi12d
      fveq2 spcev breq1 anbi1d exbidv elab2 sylibr imp syl22anc simprd 3ad2ant3
      syl6 syl5reqr oveq1d sylan9eqr syl2anc oveq2 eqeq2d rspcev 3expia reximdv
      reclem2pr df-mp genpelv mpdan ad2antrr sylibrd mpd rexlimddv syl5bi ssrdv
      ex ) CUBIZFUCCDUDJZFKZUCIYOLMNZYMYOYNIZYPFUCFUGUHYMYPYQYMYPOZGKZYOPQZRJZC
      IZUQZYQGCYPYMLYTMNZUUCGCUIYPLPQZYTMNUUDYOLUJUUELYTMUUELRJZLUUERJZUUELUUEL
      UKLSIZUUESIUUFUUETURLULUUEUMUNUUHUUGLTURLUOUPUSUTVHGCYTVAVBYRYSCIZUUCOZOZ
      YSHKZMNZHCUIZYQYMUUIUUNYPUUCHCYSVCVDUUKUUNYOUULAKZRJZTZADUIZHCUIZYQUUKUUM
      UURHCYRUUJUUMUURYRUUJUUMVEZUULPQZYORJZDIZYOUULUVBRJZTZUURUUTYSSIZYOSIZUUM
      UUCUVCYRUUJUVFUUMYMUUIUVFYPUUCCYSVFVDVGUUTYPUVGYMYPUUJUUMVIYPUVGUUHYOLSSM
      VJVKVLVMZYRUUJUUMVNYRUUIUUCUUMVOUVFUVGOZUUMUUCOZUVCUVIUVJUVBYSPQZYORJZMNZ
      UVLPQZCIZUQZOZUVCUVIUUMUVMUUCUVPUVIUUMUVMUVGUUMUVMVTUVFUUMUVAUVKMNUVGUVMY
      SUULUJABUAUVAUVKYOMSRUULPVPYSPVPZUUOBKZUAKZVQFVRZUUOUVSUKZVSWAWBWCUVIUVPU
      UCUVIUVOUUBUVIUVNUUACUVIUVNUUATZUVLUUARJZLTZUVIUVKYSRJZYOYTRJZRJLLRJZUWDL
      UVFUVGUWFLUWGLRUVFUWFYSUVKRJLYSUVKUKYSUOWDYOUOWEABUAUVKYSYOYTRUVRGVRUWAUW
      BUUOUVSUVTWFYOPVPWGUUHUWHLTURLUMUPWHUVIUVLSIZUWCUWEVTUVFUVKSIUVGUWIYSULUV
      KYOWJWKUVLUUAWIVMWLWMWNWOWPUVQUVBUVSMNZUVSPQZCIZUQZOZBWQZUVCUWNUVQBUVLUVK
      YORWRUVSUVLTZUWJUVMUWMUVPUVSUVLUVBMWSUWPUWLUVOUWPUWKUVNCUVSUVLPXAWMWNWTXB
      UUOUVSMNZUWMOZBWQUWOAUVBDUVAYORWRUUOUVBTZUWRUWNBUWSUWQUWJUWMUUOUVBUVSMXCX
      DXEEXFXGXLXHXIUUTUULSIZUVGUVEUUMYRUWTUUJUUMUVFUWTYSUULSSMVJVKXJXKUVHUVGUW
      TYOLYORJZUVDUVGUXAYOLRJYOYOLUKYOUMXMUWTUVDUULUVARJZYORJUXAUULUVAYOWFUWTUX
      BLYORUULUOXNXMXOXPUUQUVEAUVBDUWSUUPUVDYOUUOUVBUULRXQXRXSXPXTYAYMYQUUSVTZY
      PUUJYMDUBIUXCABCDEYBUAUEUFBFCDYOHAUDRBFUAUEUFYCUEKUFKWJYDYEYFYGYHYIYLYJYK
      $.

    $( Lemma for Proposition 9-3.7(v) of [Gleason] p. 124.  (Contributed by NM,
       30-Apr-1996.)  (New usage is discouraged.) $)
    reclem4pr $p |- ( A e. P. -> ( A .P. B ) = 1P ) $=
      ( vw vz vf vg wcel co c1p cv c1q cltq wbr cmq wi wa cnq cnp cmp wceq wrex
      vu wb reclem2pr df-mp mulclnq genpelv mpdan crq cfv wn wex abeq2i ltrelnq
      brel simprd elprnq syl biimpd adantr recclnq prub sylan2 mulcomnq recidnq
      ltmnq breq12d bitrd adantl sylibd anim12d ltsonq sotri syl6 exp4b pm2.43d
      syl5 imp3a exlimdv syl5bi breq1 biimprcd expimpd rexlimdvv sylbid syl6ibr
      a1i df-1p ssrdv reclem3pr eqssd ) CUAJZCDUBKZLWOFWPLWOFMZWPJZWQNOPZWQLJWO
      WRWQGMZAMZQKZUCZADUDGCUDZWSWODUAJWRXDUFABCDEUGUEHIBFCDWQGAUBQBFUEHIUHHMIM
      UIUJUKWOXCWSGACDWOWTCJZXADJZXCWSRZWOXESZXFXBNOPZXGXFXABMZOPZXJULUMZCJUNZS
      ZBUOZXHXIXOADEUPXHXNXIBXHXKXMXIXHXKXMXIRZXKXJTJZXHXKXPRXKXATJXQXAXJTTOUQU
      RUSXHXQXKXMXIXHXQSZXNXBWTXJQKZOPZXSNOPZSXIXRXKXTXMYAXHXKXTRXQXHXKXTXHWTTJ
      XKXTUFCWTUTXAXJWTVIVAVBVCXRXMWTXLOPZYAXQXHXLTJXMYBRXJVDCWTXLVEVFXQYBYAUFX
      HXQYBXJWTQKZXJXLQKZOPYAWTXLXJVIXQYCXSYDNOYCXSUCXQXJWTVGWJXJVHVJVKVLVMVNXB
      XSNOTVOUQVPVQVRVTVSWAWBWCXCWSXIWQXBNOWDWEVQWFWGWHWSFLFWKUPWIWLABCDEWMWN
      $.

  $}

  ${
    $d x y z w A $.
    $( The reciprocal of a positive real exists.  Part of Proposition 9-3.7(v)
       of [Gleason] p. 124.  (Contributed by NM, 15-May-1996.)  (Revised by
       Mario Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
    recexpr $p |- ( A e. P. -> E. x e. P. ( A .P. x ) = 1P ) $=
      ( vz vy vw cnp wcel cv cltq wbr crq cfv wn wa wex cab cmp co c1p wceq
      wrex breq1 anbi1d exbidv cbvabv reclem2pr reclem4pr eqeq1d rspcev syl2anc
      oveq2 ) BFGCHZDHZIJZUMKLBGMZNZDOZCPZFGBURQRZSTZBAHZQRZSTZAFUAEDBURUQEHZUM
      IJZUONZDOCEULVDTZUPVFDVGUNVEUOULVDUMIUBUCUDUEZUFEDBURVHUGVCUTAURFVAURTVBU
      SSVAURBQUKUHUIUJ $.
  $}

  ${
    $d x y z A $.
    $( The union of a non-empty, bounded set of positive reals is a positive
       real.  Part of Proposition 9-3.3 of [Gleason] p. 122.  (Contributed by
       NM, 19-May-1996.)  (Revised by Mario Carneiro, 12-Jun-2013.)
       (New usage is discouraged.) $)
    suplem1pr $p |- ( ( A =/= (/) /\
        E. x e. P. A. y e. A y <P x ) -> U. A e. P. ) $=
      ( vz c0 wne cv cltp wbr wral cnp wrex wa wpss cnq wcel wi wss sylibr ex
      cuni cltq wal ltrelpr brel simpld ralimi dfss3 rexlimivw adantl ssel prn0
      n0 0pss elssuni psssstr syl2an expcom sylcom exlimdv syl5bi prpssnq pssss
      ltprord syl6bi mpcom unissb sspsstr syl2im rexlimdva anim12d prcdnq com3r
      wex sylan9 reximdvai eluni2 3imtr4g com23 alrimdv eluni prnmax imp ssrexv
      syl6 syl expimpd jcad ralrimiv elnp sylanbrc ) CEFZBGZAGZHIZBCJZAKLZMZECU
      AZNZWSONZMZWMWNUBIZWMWSPZQZBUCZWNWMUBIZBWSLZMZAWSJZWSKPCKRZWRXBWQXKWLWPXK
      AKWPWMKPZBCJXKWOXLBCWOXLWNKPZWMWNKKHUDUEZUFUGBCKUHSUIUJZXKWLWTWQXAWLDGZCP
      ZDVNXKWTDCUMXKXQWTDXKXQXPKPZWTCKXPUKZXRXQWTXREXPNZXPWSRZWTXQXRXPEFXTXPULX
      PUNSXPCUOZEXPWSUPUQURUSUTVAXKWPXAAKXKXMMWNONZWPWSWNRZXAXMYCXKWNVBUJWPWMWN
      RZBCJYDWOYEBCXLXMMZWOYEXNYFWOWMWNNYEWMWNVDWMWNVCVEVFUGBCWNVGSYDYCXAWSWNOV
      HURVIVJVKVFWRXKXJXOXKXIAWSXKWNWSPZXFXHXKYGXEBXKXCYGXDXKXCYGXDQXKXCMZWNXPP
      ZDCLWMXPPZDCLYGXDYHYIYJDCXKXQXRXCYIYJQXSXRYIXCYJXRYIXCYJQXPWNWMVLTVMVOVPD
      WNCVQDWMCVQVRTVSVTYGYIXQMZDVNXKXHDWNCWAXKYKXHDXKYIXQXHXKYIMXQXGBXPLZXHXKY
      IXQYLQXKXQYIYLXKXQXRYIYLQXSXRYIYLBXPWNWBTWEVSWCXQYAYLXHQYBXGBXPWSWDWFUSWG
      UTVAWHWIWFABWSWJWK $.

    $( The union of a set of positive reals (if a positive real) is its
       supremum (the least upper bound).  Part of Proposition 9-3.3 of
       [Gleason] p. 122.  (Contributed by NM, 19-May-1996.)  (Revised by Mario
       Carneiro, 12-Jun-2013.)  (New usage is discouraged.) $)
    suplem2pr $p |- ( A C_ P. -> ( ( y e. A -> -. U. A <P y ) /\
           ( y <P U. A -> E. z e. A y <P z ) ) ) $=
      ( cnp wss cv cltp wbr wi wcel wn ltrelpr brel wa wral wb weq wpss ltprord
      wo cuni wrex simpld ralnex ssel2 ltsopr sotric mpan con2bid ancoms orbi2d
      wor sspss equcom orbi2i orcom 3bitri syl6bbr sylan an32s ralbidva syl5bbr
      bitr3d unissb ssnpss biimpd mpcom nsyl syl6bi ex syl5 pm2.43d elssuni syl
      con4d jctil ) CDEZAFZCUAZGHZVRBFZGHZBCUBZIZVRCJZVSVRGHZKIVQVTWCVTVRDJZVQW
      DVTWGVSDJZVRVSDDGLMZUCVQWGWDVQWGNZWCVTWJWCKZVSVREZVTKWJWKWAVREZBCOZWLWKWB
      KZBCOWJWNWBBCUDWJWOWMBCVQWACJZWGWOWMPZVQWPNWADJZWGWQCDWAUEWRWGNZABQZWAVRG
      HZTZWOWMWGWRXBWOPWGWRNZWBXBDGULXCWBXBKPUFDVRWAGUGUHUIUJWSXBWTWAVRRZTZWMWS
      XAXDWTWAVRSUKWMXDBAQZTXDWTTXEWAVRUMXFWTXDBAUNUOXDWTUPUQURVCUSUTVAVBBCVRVD
      URWLVRVSRZVTVSVRVEWGWHNZVTXGWIXHVTXGVRVSSVFVGVHVIVOVJVKVLWEVSVRRZWFWEVRVS
      EXIKVRCVMVRVSVEVNWHWGNZWFXIVSVRDDGLMXJWFXIVSVRSVFVGVHVP $.

    $( The union of a non-empty, bounded set of positive reals has a supremum.
       Part of Proposition 9-3.3 of [Gleason] p. 122.  (Contributed by NM,
       19-May-1996.)  (New usage is discouraged.) $)
    supexpr $p |- ( ( A =/= (/) /\ E. x e. P. A. y e. A y <P x ) ->
       E. x e. P. ( A. y e. A -. x <P y /\
           A. y e. P. ( y <P x -> E. z e. A y <P z ) ) ) $=
      ( c0 wne cv cltp wbr wral cnp wrex wa cuni wn wi suplem1pr simpld ralbidv
      wcel ltrelpr brel ralimi dfss3 sylibr rexlimivw adantl suplem2pr ralrimiv
      wss simprd ralrimivw jca breq1 notbid breq2 imbi1d anbi12d rspcev syl2anc
      syl wceq ) DEFZBGZAGZHIZBDJZAKLZMZDNZKTVJVDHIZOZBDJZVDVJHIZVDCGHICDLZPZBK
      JZMZVEVDHIZOZBDJZVFVOPZBKJZMZAKLABDQVIDKUJZVRVHWEVCVGWEAKVGVDKTZBDJWEVFWF
      BDVFWFVEKTVDVEKKHUAUBRUCBDKUDUEUFUGWEVMVQWEVLBDWEVDDTVLPZVPBCDUHZRUIWEVPB
      KWEWGVPWHUKULUMVAWDVRAVJKVEVJVBZWAVMWCVQWIVTVLBDWIVSVKVEVJVDHUNUOSWIWBVPB
      KWIVFVNVOVEVJVDHUPUQSURUSUT $.
  $}

  ${
    $d x y z w v u f $.
    $( Define pre-addition on signed reals.  This is a "temporary" set used in
       the construction of complex numbers ~ df-c , and is intended to be used
       only by the construction.  From Proposition 9-4.1 of [Gleason] p. 126.
       (Contributed by NM, 3-Sep-1995.)  (New usage is discouraged.) $)
    df-plpr $a |- +pR = { <. <. x , y >. , z >. | ( ( x e. ( P. X. P. ) /\
         y e. ( P. X. P. ) ) /\ E. w E. v E. u E. f ( ( x = <. w , v >. /\
         y = <. u , f >. ) /\ z = <. ( w +P. u ) , ( v +P. f ) >. ) ) } $.

    $( Define pre-multiplication on signed reals.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended to
       be used only by the construction.  From Proposition 9-4.1 of [Gleason]
       p. 126.  (Contributed by NM, 3-Sep-1995.)
       (New usage is discouraged.) $)
    df-mpr $a |- .pR = { <. <. x , y >. , z >. | ( ( x e. ( P. X. P. ) /\
         y e. ( P. X. P. ) ) /\ E. w E. v E. u E. f ( ( x = <. w , v >. /\
         y = <. u , f >. ) /\ z = <. ( ( w .P. u ) +P. ( v .P. f ) ) ,
           ( ( w .P. f ) +P. ( v .P. u ) ) >. ) ) } $.

    $( Define equivalence relation for signed reals.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended to
       be used only by the construction.  From Proposition 9-4.1 of [Gleason]
       p. 126.  (Contributed by NM, 25-Jul-1995.)
       (New usage is discouraged.) $)
    df-enr $a |- ~R = { <. x , y >. | ( ( x e. ( P. X. P. ) /\
                   y e. ( P. X. P. ) ) /\ E. z E. w E. v E. u
                   ( ( x = <. z , w >. /\ y = <. v , u >. ) /\
                   ( z +P. u ) = ( w +P. v ) ) ) } $.

    $( Define class of signed reals.  This is a "temporary" set used in the
       construction of complex numbers ~ df-c , and is intended to be used only
       by the construction.  From Proposition 9-4.2 of [Gleason] p. 126.
       (Contributed by NM, 25-Jul-1995.)  (New usage is discouraged.) $)
    df-nr $a |- R. = ( ( P. X. P. ) /. ~R ) $.

    $( Define addition on signed reals.  This is a "temporary" set used in the
       construction of complex numbers ~ df-c , and is intended to be used only
       by the construction.  From Proposition 9-4.3 of [Gleason] p. 126.
       (Contributed by NM, 25-Aug-1995.)  (New usage is discouraged.) $)
    df-plr $a |- +R = { <. <. x , y >. , z >. | ( ( x e. R. /\ y e. R. ) /\
      E. w E. v E. u E. f (
         ( x = [ <. w , v >. ] ~R /\ y = [ <. u , f >. ] ~R ) /\
               z = [ ( <. w , v >. +pR <. u , f >. ) ] ~R ) ) } $.

    $( Define multiplication on signed reals.  This is a "temporary" set used
       in the construction of complex numbers ~ df-c , and is intended to be
       used only by the construction.  From Proposition 9-4.3 of [Gleason]
       p. 126.  (Contributed by NM, 25-Aug-1995.)
       (New usage is discouraged.) $)
    df-mr $a |- .R = { <. <. x , y >. , z >. | ( ( x e. R. /\ y e. R. ) /\
      E. w E. v E. u E. f (
         ( x = [ <. w , v >. ] ~R /\ y = [ <. u , f >. ] ~R ) /\
               z = [ ( <. w , v >. .pR <. u , f >. ) ] ~R ) ) } $.

    $( Define ordering relation on signed reals.  This is a "temporary" set
       used in the construction of complex numbers ~ df-c , and is intended to
       be used only by the construction.  From Proposition 9-4.4 of [Gleason]
       p. 127.  (Contributed by NM, 14-Feb-1996.)
       (New usage is discouraged.) $)
    df-ltr $a |- <R = { <. x , y >. | ( ( x e. R. /\ y e. R. ) /\
       E. z E. w E. v E. u
       ( ( x = [ <. z , w >. ] ~R /\ y = [ <. v , u >. ] ~R ) /\
                ( z +P. u ) <P ( w +P. v ) ) ) } $.

    $( Define signed real constant 0.  This is a "temporary" set used in the
       construction of complex numbers ~ df-c , and is intended to be used only
       by the construction.  From Proposition 9-4.2 of [Gleason] p. 126.
       (Contributed by NM, 9-Aug-1995.)  (New usage is discouraged.) $)
    df-0r $a |- 0R = [ <. 1P , 1P >. ] ~R $.

    $( Define signed real constant 1.  This is a "temporary" set used in the
       construction of complex numbers ~ df-c , and is intended to be used only
       by the construction.  From Proposition 9-4.2 of [Gleason] p. 126.
       (Contributed by NM, 9-Aug-1995.)  (New usage is discouraged.) $)
    df-1r $a |- 1R = [ <. ( 1P +P. 1P ) , 1P >. ] ~R $.

    $( Define signed real constant -1.  This is a "temporary" set used in the
       construction of complex numbers ~ df-c , and is intended to be used only
       by the construction.  (Contributed by NM, 9-Aug-1995.)
       (New usage is discouraged.) $)
    df-m1r $a |- -1R = [ <. 1P , ( 1P +P. 1P ) >. ] ~R $.

  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u D $.
    $( Equivalence relation for signed reals in terms of positive reals.
       (Contributed by NM, 3-Sep-1995.)  (New usage is discouraged.) $)
    enrbreq $p |- ( ( ( A e. P. /\ B e. P. ) /\
                     ( C e. P. /\ D e. P. ) ) ->
          ( <. A , B >. ~R <. C , D >. <-> ( A +P. D ) = ( B +P. C ) ) ) $=
      ( vx vy vz vw vv vu cpp cer cnp df-enr ecopoveq ) EFGHIJABCDKLMEFGHIJNO
      $.
  $}

  ${
    $d x y z w v u $.
    $( The equivalence relation for signed reals is an equivalence relation.
       Proposition 9-4.1 of [Gleason] p. 126.  (Contributed by NM,
       3-Sep-1995.)  (Revised by Mario Carneiro, 6-Jul-2015.)
       (New usage is discouraged.) $)
    enrer $p |- ~R Er ( P. X. P. ) $=
      ( vx vy vz vw vv vu cpp cer cnp df-enr addcompr addclpr addasspr addcanpr
      cv ecopover ) ABCDEFGHIABCDEFJAOZBOZKQRLQRCOZMQRSNP $.
  $}

  $( Equivalence class equality of positive fractions in terms of positive
     integers.  (Contributed by NM, 29-Nov-1995.)
     (New usage is discouraged.) $)
  enreceq $p |- ( ( ( A e. P. /\ B e. P. ) /\ ( C e. P. /\ D e. P. ) ) ->
                ( [ <. A , B >. ] ~R = [ <. C , D >. ] ~R <->
                ( A +P. D ) = ( B +P. C ) ) ) $=
    ( cnp wcel wa cop cer wbr cec wceq cpp co cxp wer enrer a1i opelxpi adantr
    erth enrbreq bitr3d ) AEFBEFGZCEFDEFGZGZABHZCDHZIJUGIKUHIKLADMNBCMNLUFUGUHI
    EEOZUIIPUFQRUDUGUIFUEABEESTUAABCDUBUC $.

  ${
    $d x y z w v u $.
    $( The equivalence relation for signed reals exists.  (Contributed by NM,
       25-Jul-1995.)  (New usage is discouraged.) $)
    enrex $p |- ~R e. _V $=
      ( vx vy vz vw vv vu cer cnp cxp npex xpex cv wcel wa cop cpp co wex copab
      wceq df-enr opabssxp eqsstri ssexi ) GHHIZUEIZUEUEHHJJKZUGKGALZUEMBLZUEMN
      UHCLZDLZOTUIELZFLZOTNUJUMPQUKULPQTNFRERDRCRZNABSUFABCDEFUAUNABUEUEUBUCUD
      $.
  $}

  ${
    $d x y z w v u $.
    $( Signed real 'less than' is a relation on signed reals.  (Contributed by
       NM, 14-Feb-1996.)  (New usage is discouraged.) $)
    ltrelsr $p |- <R C_ ( R. X. R. ) $=
      ( vx vy vz vw vv vu cltr cv cnr wcel wa cop cer cec wceq cpp cltp wbr wex
      co copab cxp df-ltr opabssxp eqsstri ) GAHZIJBHZIJKUFCHZDHZLMNOUGEHZFHZLM
      NOKUHUKPTUIUJPTQRKFSESDSCSZKABUAIIUBABCDEFUCULABIIUDUE $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z D $.  $d x y z F $.
    $d x y z G $.  $d x y z R $.  $d x y z S $.
    $( Lemma showing compatibility of addition.  (Contributed by NM,
       3-Sep-1995.)  (New usage is discouraged.) $)
    addcmpblnr $p |- ( ( ( ( A e. P. /\ B e. P. ) /\ ( C e. P. /\ D e. P. ) )
               /\ ( ( F e. P. /\ G e. P. ) /\ ( R e. P. /\ S e. P. ) ) ) ->
                ( ( ( A +P. D ) = ( B +P. C ) /\ ( F +P. S ) = ( G +P. R ) ) ->
     <. ( A +P. F ) , ( B +P. G ) >. ~R <. ( C +P. R ) , ( D +P. S ) >. ) ) $=
      ( cpp co wceq wa cop cnp wcel addclpr anim12i an4s addcompr addasspr cer
      wbr oveq12 wb enrbreq syl oveq1i 3eqtr3i oveq2i 3eqtr4i eqeq12i syl5ibr
      syl6bb ) ADIJZBCIJZKGFIJZHEIJZKLAGIJZBHIJZMCEIJZDFIJZMUAUBZANOZBNOZLZCNOZ
      DNOZLZLGNOZHNOZLZENOZFNOZLZLLZUNUPIJZUOUQIJZKZUNUOUPUQIUCVOVBURVAIJZUSUTI
      JZKZVRVOURNOZUSNOZLZUTNOZVANOZLZLZVBWAUDVEVKVHVNWHVEVKLWDVHVNLWGVCVIVDVJW
      DVCVILWBVDVJLWCAGPBHPQRVFVLVGVMWGVFVLLWEVGVMLWFCEPDFPQRQRURUSUTVAUEUFVSVP
      VTVQAGVAIJZIJADUPIJZIJVSVPWIWJAIGDIJZFIJDGIJZFIJWIWJWKWLFIGDSUGGDFTDGFTUH
      UIAGVATADUPTUJBHUTIJZIJBCUQIJZIJVTVQWMWNBIHCIJZEIJCHIJZEIJWMWNWOWPEIHCSUG
      HCETCHETUHUIBHUTTBCUQTUJUKUMUL $.

    $( Lemma used in lemma showing compatibility of multiplication.
       (Contributed by NM, 4-Sep-1995.)  (New usage is discouraged.) $)
    mulcmpblnrlem $p |- ( ( ( A +P. D ) = ( B +P. C ) /\
                            ( F +P. S ) = ( G +P. R ) ) ->
                    ( ( D .P. F ) +P. ( ( ( A .P. F ) +P. ( B .P. G ) ) +P.
                            ( ( C .P. S ) +P. ( D .P. R ) ) ) ) =
                    ( ( D .P. F ) +P. ( ( ( A .P. G ) +P. ( B .P. F ) ) +P.
                            ( ( C .P. R ) +P. ( D .P. S ) ) ) ) ) $=
      ( vx vy vz cpp co cmp distrpr mulcompr oveq12i 3eqtr3g addasspr ovex wceq
      oveq1 3eqtr4i oveq1d oveq2 oveq2d syl5eq sylan9eq addcompr caov32 syl6eqr
      wa cv caov12 sylan9eqr syl6eq eqtr4d caov13 caov4 oveq2i caov42 ) ADLMZBC
      LMZUAZGFLMZHELMZUAZULZDGNMZAGNMZCFNMZLMZBHNMZDENMZLMZLMZLMZVIAHNMZDFNMZLM
      ZBGNMZCENMZLMZLMZLMZVIVJVMLMVKVNLMLMZLMVIVRWALMWBVSLMLMZLMVHVOVLVILMZLMZV
      IVTLMZWCLMZVQWEVHWIVOCHNMZWCLMZLMZWKVHWHWMVOLVHVJVILMZVKLMZWAWLWBLMZLMZWH
      WMVDVGWPWACGNMZLMZVKLMZWRVDWOWTVKLVDVBGNMZVCGNMZWOWTVBVCGNUBGVBNMGANMZGDN
      MZLMXBWOGADOVBGPVJXDVIXELAGPDGPQUCGVCNMGBNMZGCNMZLMXCWTGBCOVCGPWAXFWSXGLB
      GPCGPQUCRUDVGXAWAWSVKLMZLMWRWAWSVKSVGXHWQWALVGCVENMCVFNMXHWQVEVFCNUECGFOC
      HEORUFUGUHIJKVJVIVKLAGNTZDGNTZCFNTZIUMZJUMZUIZXLXMKUMSZUJIJKWAWLWBLBGNTZC
      HNTZCENTZXNXOUNRUFVHWKVOWLLMZWCLMWNVHWJXSWCLVHVRVIVSLMZLMZVMWLLMZVNLMZWJX
      SVGVDYAVRDHNMZLMZVNLMZYCVGYAVRYDVNLMZLMYFVGXTYGVRLVGDVENMDVFNMXTYGVEVFDNU
      EDGFODHEORUFVRYDVNSUKVDYEYBVNLVDVBHNMZVCHNMZYEYBVBVCHNUBHVBNMHANMZHDNMZLM
      YHYEHADOVBHPVRYJYDYKLAHPDHPQUCHVCNMHBNMZHCNMZLMYIYBHBCOVCHPVMYLWLYMLBHPCH
      PQUCRUDUOIJKVRVIVSLAHNTZXJDFNTZXNXOUNIJKVMWLVNLBHNTZXQDENTZXNXOUJRUDVOWLW
      CSUPUQIJKVOVLVILVMVNLTVJVKLTXJXNXOURVIVTWCSRVPWFVILIJKVJVKVMVNLXIXKYPXNXO
      YQUSUTWDWGVILIJKVRVSWAWBLYNYOXPXNXOXRVAUTR $.

    $( Lemma showing compatibility of multiplication.  (Contributed by NM,
       5-Sep-1995.)  (New usage is discouraged.) $)
    mulcmpblnr $p |- ( ( ( ( A e. P. /\ B e. P. ) /\ ( C e. P. /\ D e. P. ) )
               /\ ( ( F e. P. /\ G e. P. ) /\ ( R e. P. /\ S e. P. ) ) ) ->
                ( ( ( A +P. D ) = ( B +P. C ) /\ ( F +P. S ) = ( G +P. R ) ) ->
    <. ( ( A .P. F ) +P. ( B .P. G ) ) , ( ( A .P. G ) +P. ( B .P. F ) ) >. ~R
 <. ( ( C .P. R ) +P. ( D .P. S ) ) , ( ( C .P. S ) +P. ( D .P. R ) ) >. ) ) $=
      ( cnp wcel wa cpp co wceq cmp cop wi mulclpr addclpr syl2an cer ad2ant2lr
      wbr rnlem anim12i sylbi mulcmpblnrlem addcanpr expcom imp3a syl ad2ant2rl
      syl5 enrbreq sylibrd an42s an4s exp4b mpdi imp ) AIJZBIJZKZEIJZFIJZKZCIJZ
      DIJZKZGIJZHIJZKZADLMBCLMNGFLMHELMNKZAGOMZBHOMZLMZAHOMZBGOMZLMZPCEOMZDFOMZ
      LMZCFOMZDEOMZLMZPUAUCZQZVCVFKZVIVLKZWGWHWIDGOMZIJZWGVHVJWKVGVKDGRUBWHWIWK
      VMWFVCVIVFVLWKVMKZWFQZVCVLVIVFWMVCVLKZVPIJZVSIJZKZWBIJZWEIJZKZWMVIVFKZWNV
      AVJKZVBVKKZKZVAVKKZVBVJKZKZKWQVAVBVJVKUDXDWOXGWPXBVNIJVOIJWOXCAGRBHRVNVOS
      TXEVQIJVRIJWPXFAHRBGRVQVRSTUEUFXAVGVDKZVHVEKZKZVGVEKZVHVDKZKZKWTVGVHVDVEU
      DXJWRXMWSXHVTIJWAIJWRXICERDFRVTWASTXKWCIJWDIJWSXLCFRDERWCWDSTUEUFWQWTKWLV
      PWELMZVSWBLMZNZWFWOWSWLXPQZWPWRWOWSKXNIJZXQVPWESXRWKVMXPWKXRVMXPQVMWJXNLM
      WJXOLMNWKXRKXPABCDEFGHUGWJXNXOUHUMUIUJUKULVPVSWBWEUNUOTUPUQURUSUTUP $.
  $}

  ${
    $d x y z w v u t s f g h a b c d A $.
    $d x y z w v u t s f g h a b c d B $.
    $d x y z w v u t s f g h a b c d C $.
    $d x y z w v u t s f g h a b c d D $.
    $( Addition of signed reals in terms of positive reals.  (Contributed by
       NM, 3-Sep-1995.)  (Revised by Mario Carneiro, 12-Aug-2015.)
       (New usage is discouraged.) $)
    addsrpr $p |- ( ( ( A e. P. /\ B e. P. ) /\
                     ( C e. P. /\ D e. P. ) ) ->
                ( [ <. A , B >. ] ~R +R [ <. C , D >. ] ~R ) =
                   [ <. ( A +P. C ) , ( B +P. D ) >. ] ~R ) $=
      ( vz vu vw vv va vd vb vc vf cv cpp co wceq weq wa oveq12 vg vs vh vt cnr
      vx vy cplpr cplr cer cnp cop opex enrex enrer df-enr wb eqeqan12d df-plpr
      an42s opeq12 syl2an an4s df-plr df-nr addcmpblnr ovec ) ENZFNZOPZGNZHNZOP
      ZQZINZJNZOPZKNZLNZOPZQZUANZUBNZOPZUCNZUDNZOPZQZUFUGEGHFUDABCDUHUIUEUJUKMU
      AUCACOPZBDOPZULZVKVIOPZVLMNZOPZULZVOWBOPZVRWEOPZULZVSWFOPZVPWCOPZULZUBIKL
      JWIWJUMWPWQUMWSWTUMUNUOUFUGEGHFUPEIRZFJRZGKRZHLRZVNWAUQXBXCSXDXESVJVQVMVT
      VHVOVIVPOTVKVRVLVSOTURUTEUARZFUBRZGUCRZHUDRZVNWHUQXFXGSXHXISVJWDVMWGVHWBV
      IWCOTVKWEVLWFOTURUTUFUGEGHFMUSGIRZFUARZHKRZMUCRZWOWRQZXJXKSWLWPQWNWQQXNXL
      XMSVKVOVIWBOTVLVRWMWEOTWLWNWPWQVAVBVCGLRZFUDRZHJRZMUBRZWOXAQZXOXPSWLWSQWN
      WTQXSXQXRSVKVSVIWFOTVLVPWMWCOTWLWNWSWTVAVBVCVKAQZVICQZVLBQZWMDQZWOWKQZXTY
      ASWLWIQWNWJQYDYBYCSVKAVICOTVLBWMDOTWLWNWIWJVAVBVCUFUGEIKLJVDVEVOVRVSVPWFW
      CWBWEVFVG $.

    $( Multiplication of signed reals in terms of positive reals.  (Contributed
       by NM, 3-Sep-1995.)  (Revised by Mario Carneiro, 12-Aug-2015.)
       (New usage is discouraged.) $)
    mulsrpr $p |- ( ( ( A e. P. /\ B e. P. ) /\
                     ( C e. P. /\ D e. P. ) ) ->
                ( [ <. A , B >. ] ~R .R [ <. C , D >. ] ~R ) =
                   [ <. ( ( A .P. C ) +P. ( B .P. D ) ) ,
                              ( ( A .P. D ) +P. ( B .P. C ) ) >. ] ~R ) $=
      ( vz vu vw vv va vd vb cv cpp co wceq cmp weq wa oveq12 oveqan12d vc cmpr
      vg vs vh vt vx vy vf cmr cnr cer cnp opex enrex enrer df-enr wb eqeqan12d
      cop an42s df-mpr an4s opeq12d df-mr df-nr mulcmpblnr ovec ) ELZFLZMNZGLZH
      LZMNZOZILZJLZMNZKLZUALZMNZOZUCLZUDLZMNZUELZUFLZMNZOZUGUHEGHFUFABCDUBUJUKU
      LUMUIUCUEACPNZBDPNZMNZADPNZBCPNZMNZUTVLVJPNZVMUILZPNZMNZVLWQPNZVMVJPNZMNZ
      UTVPWCPNZVSWFPNZMNZVPWFPNZVSWCPNZMNZUTVTWGPNZVQWDPNZMNZVTWDPNZVQWGPNZMNZU
      TUDIKUAJWLWOUNXEXHUNXKXNUNUOUPUGUHEGHFUQEIQZFJQZGKQZHUAQZVOWBURXOXPRXQXRR
      VKVRVNWAVIVPVJVQMSVLVSVMVTMSUSVAEUCQZFUDQZGUEQZHUFQZVOWIURXSXTRYAYBRVKWEV
      NWHVIWCVJWDMSVLWFVMWGMSUSVAUGUHEGHFUIVBGIQZHKQZRFUCQZUIUEQZRRWSXEXBXHYCYE
      YDYFWSXEOYCYERYDYFRWPXCWRXDMVLVPVJWCPSVMVSWQWFPSTVCYCYFYDYEXBXHOYCYFRYDYE
      RWTXFXAXGMVLVPWQWFPSVMVSVJWCPSTVAVDGUAQZHJQZRFUFQZUIUDQZRRWSXKXBXNYGYIYHY
      JWSXKOYGYIRYHYJRWPXIWRXJMVLVTVJWGPSVMVQWQWDPSTVCYGYJYHYIXBXNOYGYJRYHYIRWT
      XLXAXMMVLVTWQWDPSVMVQVJWGPSTVAVDVLAOZVMBOZRVJCOZWQDOZRRWSWLXBWOYKYMYLYNWS
      WLOYKYMRYLYNRWPWJWRWKMVLAVJCPSVMBWQDPSTVCYKYNYLYMXBWOOYKYNRYLYMRWTWMXAWNM
      VLAWQDPSVMBVJCPSTVAVDUGUHEIKUAJVEVFVPVSVTVQWGWDWCWFVGVH $.
  $}

  ${
    $d A x y z w v u f $.  $d B x y z w v u f $.  $d C x y z w v u f $.
    $d D x y z w v u f $.
    $( Ordering of signed reals in terms of positive reals.  (Contributed by
       NM, 20-Feb-1996.)  (Revised by Mario Carneiro, 12-Aug-2015.)
       (New usage is discouraged.) $)
    ltsrpr $p |- ( [ <. A , B >. ] ~R <R [ <. C , D >. ] ~R <->
                          ( A +P. D ) <P ( B +P. C ) ) $=
      ( vz vx vy cpp cer cnp cltp wceq cv co wcel wa cop cec addasspr ovex cltr
      vu vw vv vf cnr enrex cxp wer enrer erdm ax-mp df-nr ltrelsr ltrelpr 0npr
      cdm dmplp wbr df-ltr addclpr ad2ant2lr anim12ci an4s enreceq eqcom syl6bb
      wb bi2anan9 oveq12 addcompr oveq1i 3eqtr3i oveq2i 3eqtr4i syl6bi caovord3
      3eqtr4g ltapr ee12an brecop brecop2 ) ABCDHIUAJUFKUGJJUHZIUIIUQWCLUJWCIUK
      ULUMUNUOUPUREMZUBMZHNZUCMZUDMZHNZKUSZADHNZBCHNZKUSZFGEUCUDUBABCDIJUFUAUGU
      JUMFGEUCUDUBUTWDJOZWGJOZPZAJOZBJOZPZPZWHJOZWEJOZPZCJOZDJOZPZPZPZWLJOZWIJO
      ZPZWDWGQIRABQIRLZWHWEQIRCDQIRLZPZWFWLHNZWIWKHNZLZWJWMVHWPXCWSXFXKWPXCPXJW
      SXFPXIWOXAXJWNXBWGWHVAVBWRXDXIWQXEBCVAVBVCVDXHXNWDBHNZWGAHNZLZWECHNZWHDHN
      ZLZPZXQWTXLXTXGXMYCWDWGABVEXGXMYBYALYCWHWECDVEYBYAVFVGVIYDXRYAHNZXSYBHNZX
      OXPXRXSYAYBHVJWDWEWLHNZHNWDBYAHNZHNXOYEYGYHWDHWEBHNZCHNBWEHNZCHNYGYHYIYJC
      HWEBVKVLWEBCSBWECSVMVNWDWEWLSWDBYASVOWGWHWKHNZHNWGAYBHNZHNXPYFYKYLWGHWHAH
      NZDHNAWHHNZDHNYKYLYMYNDHWHAVKVLWHADSAWHDSVMVNWGWHWKSWGAYBSVOVRVPFGUEWFWLW
      IWKKJHWDWEHTBCHTFMZGMZUEMVSWGWHHTYOYPVKADHTVQVTWAWB $.
  $}

  $( Greater than zero in terms of positive reals.  (Contributed by NM,
     13-May-1996.)  (New usage is discouraged.) $)
  gt0srpr $p |- ( 0R <R [ <. A , B >. ] ~R <-> B <P A ) $=
    ( c1p cop cer cec cltr wbr cpp co cltp c0r ltsrpr df-0r breq1i cnp wcel 1pr
    wb ltapr ax-mp 3bitr4i ) CCDEFZABDEFZGHCBIJCAIJKHZLUDGHBAKHZCCABMLUCUDGNOCP
    QUFUESRBACTUAUB $.

  $( The empty set is not a signed real.  (Contributed by NM, 25-Aug-1995.)
     (Revised by Mario Carneiro, 10-Jul-2014.)  (New usage is discouraged.) $)
  0nsr $p |- -. (/) e. R. $=
    ( c0 wceq cnr wcel eqid wne cnp cxp cer cqs cdm wer enrer erdm ax-mp elqsn0
    wn mpan df-nr eleq2s necon2bi ) AABACDZQAEUBAAAAFZAGGHZIJZCIKUDBZAUEDUCUDIL
    UFMUDINOUDAIPRSTUAO $.

  $( The constant ` 0R ` is a signed real.  (Contributed by NM, 9-Aug-1995.)
     (New usage is discouraged.) $)
  0r $p |- 0R e. R. $=
    ( c1p cop cer cec cnp cxp cqs c0r cnr 1pr opelxpi mp2an enrex ecelqsi ax-mp
    wcel df-0r df-nr 3eltr4i ) AABZCDZEEFZCGZHITUBPZUAUCPAEPZUEUDJJAAEEKLUBTCMN
    OQRS $.

  $( The constant ` 1R ` is a signed real.  (Contributed by NM, 9-Aug-1995.)
     (New usage is discouraged.) $)
  1sr $p |- 1R e. R. $=
    ( c1p cpp co cop cer cec cnp cxp cqs c1r cnr wcel 1pr addclpr mp2an opelxpi
    enrex ecelqsi ax-mp df-1r df-nr 3eltr4i ) AABCZADZEFZGGHZEIZJKUDUFLZUEUGLUC
    GLZAGLZUHUJUJUIMMAANOMUCAGGPOUFUDEQRSTUAUB $.

  $( The constant ` -1R ` is a signed real.  (Contributed by NM, 9-Aug-1995.)
     (New usage is discouraged.) $)
  m1r $p |- -1R e. R. $=
    ( c1p cpp cop cer cec cnp cxp cqs cm1r cnr wcel addclpr mp2an opelxpi enrex
    co 1pr ecelqsi ax-mp df-m1r df-nr 3eltr4i ) AAABPZCZDEZFFGZDHZIJUDUFKZUEUGK
    AFKZUCFKZUHQUIUIUJQQAALMAUCFFNMUFUDDORSTUAUB $.

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Closure of addition on signed reals.  (Contributed by NM, 25-Jul-1995.)
       (New usage is discouraged.) $)
    addclsr $p |- ( ( A e. R. /\ B e. R. ) -> ( A +R B ) e. R. ) $=
      ( vx vy vz vw cnr wcel wa cplr co cnp cer cop cec df-nr wceq eleq1d cpp
      cv cxp cqs oveq1 oveq2 addsrpr addclpr anim12i an4s opelxpi enrex ecelqsi
      3syl eqeltrd 2ecoptocl syl6eleqr ) AGHBGHIABJKZLLUAZMUBZGCTZDTZNMOZETZFTZ
      NMOZJKZURHAVDJKZURHUPURHCDEFABLLMGPVAAQVEVFURVAAVDJUCRVDBQVFUPURVDBAJUDRU
      SLHZUTLHZIVBLHZVCLHZIIZVEUSVBSKZUTVCSKZNZMOZURUSUTVBVCUEVKVLLHZVMLHZIZVNU
      QHVOURHVGVIVHVJVRVGVIIVPVHVJIVQUSVBUFUTVCUFUGUHVLVMLLUIUQVNMUJUKULUMUNPUO
      $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Closure of multiplication on signed reals.  (Contributed by NM,
       10-Aug-1995.)  (New usage is discouraged.) $)
    mulclsr $p |- ( ( A e. R. /\ B e. R. ) -> ( A .R B ) e. R. ) $=
      ( vx vy vz vw cnr wcel wa cmr co cnp cer cop cec df-nr wceq cmp mulclpr
      cv cxp cqs oveq1 eleq1d oveq2 cpp mulsrpr addclpr syl2an an4s jca opelxpi
      an42s enrex ecelqsi 3syl eqeltrd 2ecoptocl syl6eleqr ) AGHBGHIABJKZLLUAZM
      UBZGCTZDTZNMOZETZFTZNMOZJKZVBHAVHJKZVBHUTVBHCDEFABLLMGPVEAQVIVJVBVEAVHJUC
      UDVHBQVJUTVBVHBAJUEUDVCLHZVDLHZIVFLHZVGLHZIIZVIVCVFRKZVDVGRKZUFKZVCVGRKZV
      DVFRKZUFKZNZMOZVBVCVDVFVGUGVOVRLHZWALHZIWBVAHWCVBHVOWDWEVKVMVLVNWDVKVMIVP
      LHVQLHWDVLVNIVCVFSVDVGSVPVQUHUIUJVKVNVLVMWEVKVNIVSLHVTLHWEVLVMIVCVGSVDVFS
      VSVTUHUIUMUKVRWALLULVAWBMUNUOUPUQURPUS $.
  $}

  ${
    $d x y z w v u f $.
    $( Domain of addition on signed reals.  (Contributed by NM, 25-Aug-1995.)
       (New usage is discouraged.) $)
    dmaddsr $p |- dom +R = ( R. X. R. ) $=
      ( vx vy vw vv vu vf vz cplr cdm cnr cxp cv wcel wa cop cer cec wceq cplpr
      wex co coprab df-plr dmeqi dmoprabss eqsstri 0nsr addclsr oprssdm eqssi )
      HIZJJKZUKALZJMBLZJMNUMCLDLOZPQRUNELFLOZPQRNGLUOUPSUAPQRNFTETDTCTZNABGUBZI
      ULHURABGCDEFUCUDUQABGJJUEUFABJHUGUMUNUHUIUJ $.
  $}

  ${
    $d x y z w v u f $.
    $( Domain of multiplication on signed reals.  (Contributed by NM,
       25-Aug-1995.)  (New usage is discouraged.) $)
    dmmulsr $p |- dom .R = ( R. X. R. ) $=
      ( vx vy vw vv vu vf vz cmr cdm cnr cxp cv wcel cop cer cec wceq cmpr wex
      wa co coprab df-mr dmeqi dmoprabss eqsstri 0nsr mulclsr oprssdm eqssi ) H
      IZJJKZUKALZJMBLZJMTUMCLDLNZOPQUNELFLNZOPQTGLUOUPRUAOPQTFSESDSCSZTABGUBZIU
      LHURABGCDEFUCUDUQABGJJUEUFABJHUGUMUNUHUIUJ $.
  $}

  ${
    $d f g h u v w x y z A $.  $d u v w z B $.  $d u v w x y z C $.
    $( Addition of signed reals is commutative.  (Contributed by NM,
       31-Aug-1995.)  (Revised by Mario Carneiro, 28-Apr-2015.)
       (New usage is discouraged.) $)
    addcomsr $p |- ( A +R B ) = ( B +R A ) $=
      ( vx vy vz vw cnr wcel wa cplr co wceq cpp cer cnp df-nr addsrpr addcompr
      cv ecovcom dmaddsr ndmovcom pm2.61i ) AGHBGHIABJKBAJKLCDEFABGCSZESZMKJNOD
      SZFSZMKUEUDMKUGUFMKPUDUFUEUGQUEUGUDUFQUDUERUFUGRTABGJUAUBUC $.

    $( Addition of signed reals is associative.  (Contributed by NM,
       2-Sep-1995.)  (Revised by Mario Carneiro, 28-Apr-2015.)
       (New usage is discouraged.) $)
    addasssr $p |- ( ( A +R B ) +R C ) = ( A +R ( B +R C ) ) $=
      ( vx vy vz vw vv vu cnr wcel cplr co cv cpp cnp addsrpr addclpr anim12i
      wa w3a wceq cer df-nr an4s addasspr ecovass dmaddsr 0nsr ndmovass pm2.61i
      ) AJKBJKCJKUAABLMCLMABCLMLMUBDEFGHIABCJLGNZINZOMZUCPDNZFNZOMZENZULOMZUQHN
      ZOMUSUMOMUOUPUTOMZOMURUNOMVAUDUOURUPULQUPULUTUMQUQUSUTUMQUOURVAUNQUOPKZUP
      PKZURPKZULPKZUQPKZUSPKZTVBVCTVFVDVETVGUOUPRURULRSUEVCUTPKZVEUMPKZVAPKZUNP
      KZTVCVHTVJVEVITVKUPUTRULUMRSUEUOUPUTUFURULUMUFUGABCJLUHUIUJUK $.

    $( Multiplication of signed reals is commutative.  (Contributed by NM,
       31-Aug-1995.)  (Revised by Mario Carneiro, 28-Apr-2015.)
       (New usage is discouraged.) $)
    mulcomsr $p |- ( A .R B ) = ( B .R A ) $=
      ( vx vy vz vw cnr wcel wa cmr co wceq cv cmp cpp cer cnp mulsrpr mulcompr
      oveq12i df-nr addcompr eqtri ecovcom dmmulsr ndmovcom pm2.61i ) AGHBGHIAB
      JKBAJKLCDEFABGCMZEMZNKZDMZFMZNKZOKJPQUHULNKZUKUINKZOKZUIUHNKZULUKNKZOKUIU
      KNKZULUHNKZOKZUAUHUKUIULRUIULUHUKRUJUQUMUROUHUISUKULSTUPUTUSOKVAUNUTUOUSO
      UHULSUKUISTUTUSUBUCUDABGJUEUFUG $.

    $( Multiplication of signed reals is associative.  (Contributed by NM,
       2-Sep-1995.)  (Revised by Mario Carneiro, 28-Apr-2015.)
       (New usage is discouraged.) $)
    mulasssr $p |- ( ( A .R B ) .R C ) = ( A .R ( B .R C ) ) $=
      ( vx vy vz cnr wcel cmr co cmp cpp cnp mulsrpr mulclpr addclpr syl2an vex
      cv wa vw vv vu vf vg vh w3a wceq cer df-nr an4s mulcompr distrpr mulasspr
      an42s addcompr addasspr caovlem2 ecovass dmmulsr 0nsr ndmovass pm2.61i
      jca ) AGHBGHCGHUGABIJCIJABCIJIJUHDEFUAUBUCABCGIFSZUCSZKJZUASZUBSZKJZLJZUI
      MDSZVEKJZESZVHKJZLJZVLVHKJZVNVEKJZLJZVPVIKJVSVFKJLJVPVFKJVSVIKJLJVLVEVIKJ
      ZVHVFKJZLJZKJVNVKKJLJVLVKKJVNWBKJLJWBUJVLVNVEVHNVEVHVIVFNVPVSVIVFNVLVNWBV
      KNVLMHZVNMHZTVEMHZVHMHZTZTVPMHZVSMHZWCWEWDWFWHWCWETVMMHVOMHWHWDWFTVLVEOVN
      VHOVMVOPQUKWCWFWDWEWIWCWFTVQMHVRMHWIWDWETVLVHOVNVEOVQVRPQUOVDWGVIMHZVFMHZ
      TTWBMHZVKMHZWEWJWFWKWLWEWJTVTMHWAMHWLWFWKTVEVIOVHVFOVTWAPQUKWEWKWFWJWMWEW
      KTVGMHVJMHWMWFWJTVEVFOVHVIOVGVJPQUOVDUDUEUFVLVNVEVHVFLKVIDRZERZFRZUDSZUES
      ZULZWQWRUFSZUMZUARZUBRZWQWRWTUNZUCRZWQWRUPZWQWRWTUQZURUDUEUFVLVNVEVHVILKV
      FWNWOWPWSXAXBXEXDXCXFXGURUSABCGIUTVAVBVC $.

    $( Multiplication of signed reals is distributive.  (Contributed by NM,
       2-Sep-1995.)  (Revised by Mario Carneiro, 28-Apr-2015.)
       (New usage is discouraged.) $)
    distrsr $p |- ( A .R ( B +R C ) ) = ( ( A .R B ) +R ( A .R C ) ) $=
      ( vf vg cnr wcel cplr co cmr cnp cv cpp wa addclpr mulclpr syl2an distrpr
      cmp ovex vx vy vz vw vv vu vh w3a wceq df-nr addsrpr mulsrpr anim12i an4s
      cer an42s jca oveq12i addcompr addasspr caov4 ecovdi dmaddsr 0nsr dmmulsr
      eqtri ndmovdistr pm2.61i ) AFGBFGCFGUHABCHIJIABJIACJIHIUIUAUBUCUDUEUFABCF
      HUOKJUALZUCLZUELZMIZSIZUBLZUDLZUFLZMIZSIZMIZVIVQSIZVNVLSIZMIZVIVJSIZVNVOS
      IZMIZVIVKSIZVNVPSIZMIZMIZVIVOSIZVNVJSIZMIZVIVPSIZVNVKSIZMIZMIZVLVQWEWLWHW
      OUJVJVOVKVPUKVIVNVLVQULVIVNVJVOULVIVNVKVPULWEWLWHWOUKVJKGZVKKGZVOKGZVPKGZ
      VLKGZVQKGZNWQWRNXAWSWTNXBVJVKOVOVPOUMUNVIKGZVNKGZNZWQWSNNWEKGZWLKGZXCWQXD
      WSXFXCWQNWCKGWDKGXFXDWSNVIVJPVNVOPWCWDOQUNXCWSXDWQXGXCWSNWJKGWKKGXGXDWQNV
      IVOPVNVJPWJWKOQUPUQXEWRWTNNWHKGZWOKGZXCWRXDWTXHXCWRNWFKGWGKGXHXDWTNVIVKPV
      NVPPWFWGOQUNXCWTXDWRXIXCWTNWMKGWNKGXIXDWRNVIVPPVNVKPWMWNOQUPUQVSWCWFMIZWD
      WGMIZMIWIVMXJVRXKMVIVJVKRVNVOVPRURDEUGWCWFWDWGMVIVJSTVIVKSTVNVOSTDLZELZUS
      ZXLXMUGLUTZVNVPSTVAVFWBWJWMMIZWKWNMIZMIWPVTXPWAXQMVIVOVPRVNVJVKRURDEUGWJW
      MWKWNMVIVOSTVIVPSTVNVJSTXNXOVNVKSTVAVFVBABCFHJVCVDVEVGVH $.
  $}

  $( Minus one plus one is zero for signed reals.  (Contributed by NM,
     5-May-1996.)  (New usage is discouraged.) $)
  m1p1sr $p |- ( -1R +R 1R ) = 0R $=
    ( cm1r c1r cplr co c1p cpp cop cer cec c0r df-m1r cnp wcel wceq 1pr addclpr
    df-1r mp2an mp4an eqtr4i oveq12i df-0r addsrpr addasspr oveq2i wb enreceq
    mpbir ) ABCDEEEFDZGHIZUIEGHIZCDZJAUJBUKCKQUAJEEGHIZULUBULEUIFDZUIEFDZGHIZUM
    ELMZUILMZURUQULUPNOUQUQUROOEEPRZUSOEUIUIEUCSUMUPNZEUOFDEUNFDNZUOUNEFEEEUDUE
    UQUQUNLMZUOLMZUTVAUFOOUQURVBOUSEUIPRURUQVCUSOUIEPREEUNUOUGSUHTTT $.

  $( Minus one times minus one is plus one for signed reals.  (Contributed by
     NM, 14-May-1996.)  (New usage is discouraged.) $)
  m1m1sr $p |- ( -1R .R -1R ) = 1R $=
    ( cm1r cmr c1p cpp cop cer cec c1r df-m1r oveq12i cmp cnp wcel wceq addclpr
    co 1pr mp2an eqtr4i mulclpr df-1r mulsrpr mp4an addasspr 1idpr ax-mp oveq1i
    distrpr mulcompr oveq2i wb enreceq mpbir ) AABPCCCDPZEFGZUOBPZHAUOAUOBIIJHU
    NCEFGZUPUAUPCCKPZUNUNKPZDPZCUNKPZUNCKPZDPZEFGZUQCLMZUNLMZVEVFUPVDNQVEVEVFQQ
    CCORZQVGCUNCUNUBUCUQVDNZUNVCDPZCUTDPZNZVICCVCDPZDPVJCCVCUDUTVLCDURCUSVCDVEU
    RCNQCUEUFUSVBVBDPVCUNCCUHVAVBVBDCUNUIUGSJUJSVFVEUTLMZVCLMZVHVKUKVGQURLMZUSL
    MZVMVEVEVOQQCCTRVFVFVPVGVGUNUNTRURUSORVALMZVBLMZVNVEVFVQQVGCUNTRVFVEVRVGQUN
    CTRVAVBORUNCUTVCULUCUMSSS $.

  ${
    $d x y z w v u f g h $.
    $( Signed real 'less than' is a strict ordering.  (Contributed by NM,
       19-Feb-1996.)  (New usage is discouraged.) $)
    ltsosr $p |- <R Or R. $=
      ( vf vg vh vx vy vw cltr cv cer wbr wceq wo wb cnp cpp co cltp wcel vex
      wa vz vv vu cnr cop cec wn df-nr breq1 eqeq1 breq2 orbi12d notbid bibi12d
      eqeq2 ltsrpr addclpr wor ltsopr sotric mpan syl2an an42s enreceq addcompr
      breq12i bitri a1i bitr4d syl5bb 2ecoptocl wi anbi1d imbi12d imbi1d anbi2d
      anbi12d ovex ltapr caovord2 addasspr syl6bb bi2anan9r ltrelpr sotri dmplp
      0npr ndmovordi caov12 3imtr4i syl6bi ad2ant2l 3adant2 3ecoptocl isso2i
      syl ) ABCUDGDHZEHZUEIUFZUAHZFHZUEIUFZGJZWSXBKZXBWSGJZLZUGZMAHZXBGJZXHXBKZ
      XBXHGJZLZUGZMXHBHZGJZXHXNKZXNXHGJZLZUGZMDEUAFXHXNNNIUDUHWSXHKZXCXIXGXMWSX
      HXBGUIZXTXFXLXTXDXJXEXKWSXHXBUJWSXHXBGUKULUMUNXBXNKZXIXOXMXSXBXNXHGUKZYBX
      LXRYBXJXPXKXQXBXNXHUOXBXNXHGUIULUMUNXCWQXAOPZWRWTOPZQJZWQNRZWRNRZTZWTNRZX
      ANRZTZTZXGWQWRWTXAUPZYMYFYDYEKZYEYDQJZLZUGZXGYGYKYHYJYFYRMZYGYKTYDNRZYENR
      ZYSYHYJTWQXAUQWRWTUQNQURYTUUATYSUSNYDYEQUTVAVBVCYMXFYQYMXDYOXEYPWQWRWTXAV
      DXEYPMYMXEWTWROPZXAWQOPZQJYPWTXAWQWRUPUUBYEUUCYDQWTWRVEXAWQVEVFVGVHULUMVI
      VJVKXCXBUBHZUCHZUEIUFZGJZTZWSUUFGJZVLZXIUUGTZXHUUFGJZVLXOXNUUFGJZTZUULVLX
      OXNCHZGJZTZXHUUOGJZVLDEUAFUBUCXHXNUUONIUDUHXTUUHUUKUUIUULXTXCXIUUGYAVMWSX
      HUUFGUIVNYBUUKUUNUULYBXIXOUUGUUMYCXBXNUUFGUIVQVOUUFUUOKZUUNUUQUULUURUUSUU
      MUUPXOUUFUUOXNGUKVPUUFUUOXHGUKVNYIUUDNRZUUENRZTUUJYLYHUVAUUJYGUUTYHUVATUU
      HWQXAUUEOPOPZWRWTUUEOPZOPZQJZUVDWRXAUUDOPZOPZQJZTZUUIUVAXCUVEYHUUGUVHXCYF
      UVAUVEYNUVAYFYDUUEOPZYEUUEOPZQJUVEABCYDYEUUEQNOWQXAOVRWRWTOVRXHXNUUOVSUCS
      ZXHXNVEZVTUVJUVBUVKUVDQWQXAUUEWAWRWTUUEWAVFWBVJUUGUVCUVFQJYHUVHWTXAUUDUUE
      UPUVCUVFWRVSVJWCUVIUVBUVGQJZUUIUVBUVDUVGQNUSWDWEXAWQUUEOPZOPZXAWRUUDOPZOP
      ZQJUVOUVQQJUVNUUIUVOUVQXAQNOWFWDWGUVOUVQXAVSWHUVBUVPUVGUVRQABCWQXAUUEODSF
      SZUVLUVMXHXNUUOWAZWIABCWRXAUUDOESUVSUBSUVMUVTWIVFWQWRUUDUUEUPWJWPWKWLWMWN
      WO $.
  $}

  $( 0 is less than 1 for signed reals.  (Contributed by NM, 26-Mar-1996.)
     (New usage is discouraged.) $)
  0lt1sr $p |- 0R <R 1R $=
    ( c1p cop cer cec cpp co c0r c1r cltr wbr cltp cnp wcel 1pr addclpr ltaddpr
    mp2an addcompr breqtrri ltsrpr mpbir df-0r df-1r 3brtr4i ) AABCDZAAEFZABCDZ
    GHIUEUGIJUFAUFEFZKJUFUFAEFZUHKUFLMZALMZUFUIKJUKUKUJNNAAOQNUFAPQAUFRSAAUFATU
    AUBUCUD $.

  $( 1 and 0 are distinct for signed reals.  (Contributed by NM, 26-Mar-1996.)
     (New usage is discouraged.) $)
  1ne0sr $p |- -. 1R = 0R $=
    ( c1r c0r wceq cltr wbr cnr wor wcel wn ltsosr 1sr sonr mp2an 0lt1sr mpbiri
    breq1 mto ) ABCZAADEZFDGAFHSIJKFADLMRSBADENABADPOQ $.

  ${
    $d x y z w v $.  $d x y A $.
    $( The signed real number 0 is an identity element for addition of signed
       reals.  (Contributed by NM, 10-Apr-1996.)
       (New usage is discouraged.) $)
    0idsr $p |- ( A e. R. -> ( A +R 0R ) = A ) $=
      ( vx vy vz vw vv cv cop cer cec c0r cplr co wceq cnp wcel wa c1p cpp 1pr
      df-nr oveq1 id eqeq12d df-0r oveq2i addsrpr mpanr12 addclpr mpan2 anim12i
      cnr vex elexi addcompr addasspr caov12 enreceq mpbiri mpdan eqtr4d syl5eq
      ecoptocl ) BGZCGZHIJZKLMZVFNAKLMZANBCAOOIULUAVFANZVGVHVFAVFAKLUBVIUCUDVDO
      PZVEOPZQZVGVFRRHIJZLMZVFKVMVFLUEUFVLVNVDRSMZVERSMZHIJZVFVLROPZVRVNVQNTTVD
      VERRUGUHVLVOOPZVPOPZQZVFVQNZVJVSVKVTVJVRVSTVDRUIUJVKVRVTTVERUIUJUKVLWAQWB
      VDVPSMVEVOSMNDEFVDVERSBUMCUMROTUNDGZEGZUOWCWDFGUPUQVDVEVOVPURUSUTVAVBVC
      $.
  $}

  ${
    $d x y A $.  $d x y z w v $.
    $( 1 is an identity element for multiplication.  (Contributed by NM,
       2-May-1996.)  (New usage is discouraged.) $)
    1idsr $p |- ( A e. R. -> ( A .R 1R ) = A ) $=
      ( vx vy cop cer cec c1r cmr wceq cnp wcel c1p cpp cmp 1pr addclpr mulclpr
      cv co mpan2 vz vw vv df-nr oveq1 id eqeq12d wa df-1r oveq2i mp2an mulsrpr
      cnr mpanr12 distrpr 1idpr oveq1d syl5req oveqan12d addasspr ovex addcompr
      syl5eq vex caov12 3eqtr3g wb syl2an anim12i syldan anidms mpbird ecoptocl
      enreceq eqtr4d ) BRZCRZDEFZGHSZVRIAGHSZAIBCAJJEUMUDVRAIZVSVTVRAVRAGHUEWAU
      FUGVPJKZVQJKZUHZVSVRLLMSZLDEFZHSZVRGWFVRHUIUJWDWGVPWENSZVQLNSZMSZVPLNSZVQ
      WENSZMSZDEFZVRWDWEJKZLJKZWGWNIWPWPWOOOLLPUKZOVPVQWELULUNWDVRWNIZVPWMMSZVQ
      WJMSZIZWDVPWKMSZWLMSWHVQWIMSZMSWSWTWBWCXBWHWLXCMWBWHWKWKMSXBVPLLUOWBWKVPW
      KMVPUPUQURWCWLWIWIMSXCVQLLUOWCWIVQWIMVQUPUQVCUSVPWKWLUTUAUBUCWHVQWIMVPWEN
      VACVDVQLNVAUARZUBRZVBXDXEUCRUTVEVFWDWRXAVGZWDWDWJJKZWMJKZUHXFWDXGWDXHWBWH
      JKZWIJKZXGWCWBWOXIWQVPWEQTWCWPXJOVQLQTWHWIPVHWBWKJKZWLJKZXHWCWBWPXKOVPLQT
      WCWOXLWQVQWEQTWKWLPVHVIVPVQWJWMVNVJVKVLVOVCVM $.
  $}

  ${
    $d x y A $.
    $( A signed real times 0 is 0.  (Contributed by NM, 10-Apr-1996.)
       (New usage is discouraged.) $)
    00sr $p |- ( A e. R. -> ( A .R 0R ) = 0R ) $=
      ( vx vy cv cop cer cec c0r cmr co wceq cnp wa c1p cmp cpp mpanr12 mulclpr
      wcel 1pr cnr df-nr oveq1 eqeq1d mulsrpr mpan2 addclpr syl2an anim12i eqid
      enreceq mpbiri sylan anidms eqtrd df-0r oveq2i 3eqtr4g ecoptocl ) BDZCDZE
      FGZHIJZHKAHIJZHKBCALLFUAUBVBAKVCVDHVBAHIUCUDUTLSZVALSZMZVBNNEFGZIJZVHVCHV
      GVIUTNOJZVANOJZPJZVLEFGZVHVGNLSZVNVIVMKTTUTVANNUEQVGVMVHKZVGVGMZVNVNVOTTV
      PVLLSZVQMZVNVNMZVOVGVQVGVQVEVJLSZVKLSZVQVFVEVNVTTUTNRUFVFVNWATVANRUFVJVKU
      GUHZWBUIVRVSMVOVLNPJZWCKWCUJVLVLNNUKULUMQUNUOHVHVBIUPUQUPURUS $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f $.
    $( Ordering property of addition.  (Contributed by NM, 10-May-1996.)
       (New usage is discouraged.) $)
    ltasr $p |- ( C e. R. -> ( A <R B <-> ( C +R A ) <R ( C +R B ) ) ) $=
      ( vx vy cltr cnr cplr wcel wbr co wb cv cop cer cec cnp wceq cpp vex 0nsr
      vz vw vv vu dmaddsr ltrelsr df-nr oveq1 breq12d bibi2d breq1 oveq2 breq1d
      vf bibi12d breq2 breq2d w3a addclpr 3ad2ant1 cltp ltapr addcompr addasspr
      wa ltsrpr caov4 caov42 eqtri breq12i bitri 3bitr4g addsrpr 3adant3 bitr4d
      syl 3adant2 3ecoptocl 3coml ndmovord ) ABCFGHUFUGUACGIAGIBGIABFJZCAHKZCBH
      KZFJZLZDMZEMZNOPZUBMZUCMZNOPZFJZUDMZUEMZNOPZWIHKZWPWLHKZFJZLWMCWIHKZCWLHK
      ZFJZLAWLFJZWCXAFJZLWFUDUEDEUBUCCABQOGUHWPCRZWSXBWMXEWQWTWRXAFWPCWIHUIWPCW
      LHUIUJUKWIARZWMXCXBXDWIAWLFULXFWTWCXAFWIACHUMUNUPWLBRZXCWBXDWEWLBAFUQXGXA
      WDWCFWLBCHUMURUPWNQIWOQIVFZWGQIWHQIVFZWJQIWKQIVFZUSZWMWNWGSKZWOWHSKZNOPZW
      NWJSKZWOWKSKZNOPZFJZWSXKWNWOSKZQIZWMXRLXHXIXTXJWNWOUTVAXTWGWKSKZWHWJSKZVB
      JXSYASKZXSYBSKZVBJZWMXRYAYBXSVCWGWHWJWKVGXRXLXPSKZXMXOSKZVBJYEXLXMXOXPVGY
      FYCYGYDVBEUBUOWNWGWOWKSUDTZDTUETZWHWJVDWHWJUOMZVEUCTVHYGXOXMSKYDXMXOVDDUC
      UOWNWJWOWHSYHUBTYIWGWKVDWGWKYJVEETVIVJVKVLVMVQXKWQXNWRXQFXHXIWQXNRXJWNWOW
      GWHVNVOXHXJWRXQRXIWNWOWJWKVNVRUJVPVSVTWA $.
  $}

  $( A signed real plus its negative is zero.  (Contributed by NM,
     14-May-1996.)  (New usage is discouraged.) $)
  pn0sr $p |- ( A e. R. -> ( A +R ( A .R -1R ) ) = 0R ) $=
    ( cnr wcel c1r cmr co cm1r cplr 1idsr oveq1d distrsr m1p1sr oveq2i addcomsr
    c0r 3eqtr3i 00sr syl5eqr eqtr3d ) ABCZADEFZAGEFZHFZAUBHFOTUAAUBHAIJTUCAOEFZ
    OAGDHFZEFUBUAHFUDUCAGDKUEOAELMUBUANPAQRS $.

  ${
    $d x A $.
    $( Existence of negative signed real.  Part of Proposition 9-4.3 of
       [Gleason] p. 126.  (Contributed by NM, 2-May-1996.)
       (New usage is discouraged.) $)
    negexsr $p |- ( A e. R. -> E. x e. R. ( A +R x ) = 0R ) $=
      ( cnr wcel cm1r cmr co cplr c0r wceq cv wrex m1r mpan2 pn0sr oveq2 eqeq1d
      mulclsr rspcev syl2anc ) BCDZBEFGZCDZBUBHGZIJZBAKZHGZIJZACLUAECDUCMBERNBO
      UHUEAUBCUFUBJUGUDIUFUBBHPQST $.
  $}

  ${
    $d x y z A $.  $d x y z w v u f $.
    $( The reciprocal of a positive signed real exists.  Part of Proposition
       9-4.3 of [Gleason] p. 126.  (Contributed by NM, 15-May-1996.)
       (New usage is discouraged.) $)
    recexsrlem $p |- ( 0R <R A -> E. x e. R. ( A .R x ) = 1R ) $=
      ( vw vv vu cnr wcel c0r cv cmr co c1r wceq cer cnp cpp wa cmp c1p 1pr wbr
      vy vz vf cltr wrex ltrelsr brel simprd cop cec df-nr breq2 eqeq1d rexbidv
      wi oveq1 imbi12d cltp gt0srpr ltexpri sylbi recexpr addclpr mpan2 ecopqsi
      enrex sylancl ad2antlr jctir anim2i adantr mulsrpr syl eqcomd vex distrpr
      mulcompr caovdir oveq2 syl5eq sylan9eqr oveq1d ovex elexi addcompr caov32
      addasspr syl6eq oveq1i eqtri oveq2i caov12 3eqtr4g wb sylan2 syl2an an32s
      mulclpr anassrs jca mp2an pm3.2i enreceq syl5ibr imp eqtrd syl6eqr rspcev
      df-1r syl2anc exp43 rexlimdv syl5 ecoptocl mpcom ) BFGZHBUEUAZBAIZJKZLMZA
      FUFZXRHFGXQHBFFUEUGUHUIHUBIZUCIZUJNUKZUEUAZYEXSJKZLMZAFUFZUPXRYBUPUBUCBOO
      NFULYEBMZYFXRYIYBYEBHUEUMYJYHYAAFYJYGXTLYEBXSJUQUNUOURYFYDCIZPKZYCMZCOUFZ
      YCOGZYDOGZQZYIYFYDYCUSUAYNYCYDUTCYDYCVAVBYQYMYICOYKOGYKDIZRKZSMZDOUFYQYMY
      IUPZDYKVCYQYTUUADOYQYROGZYTYMYIYQUUBQZYTYMQZQZYRSPKZSUJNUKZFGZYEUUGJKZLMZ
      YIUUBUUHYQUUDUUBUUFOGZSOGZUUHUUBUULUUKTYRSVDVEZTOUUFSNFVGULVFVHVIUUEUUISS
      PKZSUJNUKZLUUEUUIYCUUFRKZYDSRKZPKZYCSRKZYDUUFRKZPKZUJNUKZUUOUUEYQUUKUULQZ
      QZUUIUVBMUUCUVDUUDUUBUVCYQUUBUUKUULUUMTVJVKVLYCYDUUFSVMVNUUCUUDUVBUUOMZUU
      DUVEUUCUURSPKZUVAUUNPKZMZUUDYCYRRKZUUSUUQPKZPKZSPKZYDYRRKZUVJPKZUUNPKZUVF
      UVGUUDUVLUVNSPKZSPKUVOUUDUVKUVPSPUUDUVKUVMSPKZUVJPKUVPUUDUVIUVQUVJPYMYTUV
      IYLYRRKZUVQYMUVRUVIYLYCYRRUQVOYTUVRUVMYSPKUVQEUDAYDYKYRPRUCVPCVPDVPEIZUDI
      ZVRUVSUVTXSVQVSYSSUVMPVTWAWBWCEUDAUVMSUVJPYDYRRWDZSOTWEUUSUUQPWDUVSUVTWFZ
      UVSUVTXSWHZWGWIWCUVNSSWHWIUURUVKSPUURUVIUUSPKZUUQPKUVKUUPUWDUUQPYCYRSVQWJ
      UVIUUSUUQWHWKWJUVAUVNUUNPUVAUUSUVMUUQPKZPKUVNUUTUWEUUSPYDYRSVQWLEUDAUUSUV
      MUUQPYCSRWDUWAYDSRWDUWBUWCWMWKWJWNUUCUUROGZUVAOGZQUUNOGZUULQUVEUVHWOUUCUW
      FUWGYOUUBYPUWFYOUUBQUUPOGZUUQOGZUWFYPUUBYOUUKUWIUUMYCUUFWSWPYPUULUWJTYDSW
      SVEUUPUUQVDWQWRYOYPUUBUWGYOUUSOGZUUTOGZUWGYPUUBQYOUULUWKTYCSWSVEUUBYPUUKU
      WLUUMYDUUFWSWPUUSUUTVDWQWTXAUWHUULUULUULUWHTTSSVDXBTXCUURUVAUUNSXDVHXEXFX
      GXJXHYHUUJAUUGFXSUUGMYGUUILXSUUGYEJVTUNXIXKXLXMXNXMXNXOXP $.
  $}

  $( The sum of two positive signed reals is positive.  (Contributed by NM,
     14-May-1996.)  (New usage is discouraged.) $)
  addgt0sr $p |- ( ( 0R <R A /\ 0R <R B ) -> 0R <R ( A +R B ) ) $=
    ( c0r cltr wbr cplr co wcel wb ltrelsr brel simprd ltasr 0idsr breq1d bitrd
    cnr syl biimpa ltsosr sotri syldan ) CADEZCBDEZAABFGZDEZCUEDEUCUDUFUCAQHZUD
    UFIUCCQHUGCAQQDJKLUGUDACFGZUEDEUFCBAMUGUHAUEDANOPRSCAUEDQTJUAUB $.

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w v u f g h $.
    $( The product of two positive signed reals is positive.  (Contributed by
       NM, 13-May-1996.)  (New usage is discouraged.) $)
    mulgt0sr $p |- ( ( 0R <R A /\ 0R <R B ) -> 0R <R ( A .R B ) ) $=
      ( vv vf vg vh cnr wcel wa c0r cltr wbr co cv wi cnp wceq cmp cpp ovex cmr
      vx vy vz vw vu ltrelsr brel simprd anim12i cop cer cec df-nr breq2 anbi1d
      oveq1 breq2d imbi12d anbi2d gt0srpr anbi12i simprr mulclpr addclpr syl2an
      cltp an4s wrex ltexpri oveq12 oveq1d distrpr syl5eqr vex mulcompr caovdir
      oveq12i addcompr addasspr 3eqtr4i caov12 3eqtr4g oveqan12rd eqtr3d eqtr3i
      oveq2 caov4 caov32 oveq2i addcanpr syl5 eqcom ltaddpr2 syl5bi adantl syld
      3eqtr3g sylan a1d exp4a com34 rexlimdv expl com24 rexlimiv syl2im syl2anc
      imp com12 mulsrpr syl6bb sylibrd 2ecoptocl mpcom ) AGHZBGHZIJAKLZJBKLZIZJ
      ABUAMZKLZXRXPXSXQXRJGHZXPJAGGKUGUHUIXSYCXQJBGGKUGUHUIUJJUBNZUCNZUKULUMZKL
      ZJUDNZUENZUKULUMZKLZIZJYFYJUAMZKLZOXRYKIZJAYJUAMZKLZOXTYBOUBUCUDUEABPPULG
      UNYFAQZYLYOYNYQYRYGXRYKYFAJKUOUPYRYMYPJKYFAYJUAUQURUSYJBQZYOXTYQYBYSYKXSX
      RYJBJKUOUTYSYPYAJKYJBAUAWGURUSYLYEYDVGLZYIYHVGLZIZYDPHZYEPHZIZYHPHZYIPHZI
      IZYNYGYTYKUUAYDYEVAYHYIVAVBUUHUUBYDYIRMZYEYHRMZSMZYDYHRMZYEYIRMZSMZVGLZYN
      UUHUUGUUNPHZUUBUUOOUUEUUFUUGVCUUCUUFUUDUUGUUPUUCUUFIUULPHUUMPHUUPUUDUUGIY
      DYHVDYEYIVDUULUUMVEVFVHUUBUUGUUPIZUUOYTUUAUUQUUOOZYTYECNZSMZYDQZCPVIUUAYI
      UFNZSMZYHQZUFPVIZUURCYEYDVJUFYIYHVJUVAUVEUUROCPUUSPHZUUQUVEUVAUUOUVFUUGUU
      PUVEUVAUUOOZOUVFUUGIZUUPIZUVDUVGUFPUVIUVBPHZUVAUVDUUOUVIUVJUVAUVDUUOUVIUV
      AUVDIZUUOOZUVJUVHUUSYIRMZPHZUUPUVLUUSYIVDUVNUUPIZUVKUUNUUKUUSUVBRMZSMZQZU
      UOUVKUVMUUNSMZUVMUVQSMZQUVOUVRUVKUULUUMUVMSMZSMZUVMUUJUVPSMZSMZUUISMZUVSU
      VTUVKUUTUVCRMZUWASMUWBUWEUVKUWFUULUWASUUTYDUVCYHRVKVLUVDUVAUWFUWDUWAUUISU
      VDUUMYEUVBRMZSMZUVMUVPSMZSMZUUJUWISMUWFUWDUVDUWHUUJUWISUVDUWHYEUVCRMUUJYE
      YIUVBVMUVCYHYERWGVNVLUUTYIRMZUUTUVBRMZSMUWAUWGUVPSMZSMUWFUWJUWKUWAUWLUWMS
      DEFYEUUSYISRUCVOZCVOZUEVODNZENZVPZUWPUWQFNZVMZVQZDEFYEUUSUVBSRUWNUWOUFVOU
      WRUWTVQVRUUTYIUVBVMDEFUUMUWGUVMUVPSYEYIRTYEUVBRTUUSYIRTZUWPUWQVSZUWPUWQUW
      SVTZUUSUVBRTZWHWADEFUVMUUJUVPSUXBYEYHRTUXEUXCUXDWBWCUVAUWAUWKUUIUXAUUTYDY
      IRUQVNWDWEUUNUVMSMUWBUVSUULUUMUVMVTUUNUVMVSWFUVMUUISMUWCSMUVMUUIUWCSMZSMU
      WEUVTUVMUUIUWCVTDEFUVMUWCUUISUXBUUJUVPSTYDYIRTUXCUXDWIUVQUXFUVMSUUIUUJUVP
      VTWJWAWRUVMUUNUVQWKWLUUPUVRUUOOUVNUVRUVQUUNQUUPUUOUUNUVQWMUUKUVPUUNWNWOWP
      WQWSWTXAXBXCXDXEXFXGXIXJXHUUHYNJUUNUUKUKULUMZKLUUOUUHYMUXGJKYDYEYHYIXKURU
      UNUUKVAXLXMWOXNXO $.
  $}

  ${
    $d x y z A $.
    $( The square of a nonzero signed real is positive.  (Contributed by NM,
       14-May-1996.)  (New usage is discouraged.) $)
    sqgt0sr $p |- ( ( A e. R. /\ A =/= 0R ) -> 0R <R ( A .R A ) ) $=
      ( cnr wcel c0r cmr co cltr wbr wceq wb mpan2 cm1r cplr mulclsr syl syl5eq
      wa anidms c1r mulasssr wne wo wn wor ltsosr sotrieq mpan necon2abid ltasr
      0r m1r addcomsr pn0sr 0idsr breq12d bitrd mulgt0sr syl6bi mulcomsr oveq1i
      3eqtr3i m1m1sr oveq2i eqtri 3eqtr4i breq2d sylibd wi a1i jaod sylbird imp
      1idsr ) ABCZADUAZDAAEFZGHZVNVOADGHZDAGHZUBZVQVNVTADVNDBCZADIVTUCJZUJBGUDV
      NWAQWBUEBADGUFUGKUHVNVRVQVSVNVRDALEFZWCEFZGHZVQVNVRDWCGHZWEVNVRWCAMFZWCDM
      FZGHZWFVNWCBCZVRWIJVNLBCWJUKALNKZADWCUIOVNWGDWHWCGVNWGAWCMFDWCAULAUMPVNWJ
      WHWCIWKWCUNOUOUPWFWEWCWCUQRURVNWDVPDGVNWDVPSEFZVPALWCEFZEFAASEFZEFWDWLWMW
      NAEWMALLEFZEFZWNLAEFZLEFWCLEFWMWPWQWCLELAUSUTLALTALLTVAWOSAEVBVCVDVCALWCT
      AASTVEVNWLVPIZVNVNQVPBCWRAANVPVMORPVFVGVSVQVHVNVSVQAAUQRVIVJVKVL $.

    $( The reciprocal of a nonzero signed real exists.  Part of Proposition
       9-4.3 of [Gleason] p. 126.  (Contributed by NM, 15-May-1996.)
       (New usage is discouraged.) $)
    recexsr $p |- ( ( A e. R. /\ A =/= 0R ) -> E. x e. R. ( A .R x ) = 1R ) $=
      ( vy cnr wcel c0r wne cmr co cltr wbr cv c1r wceq wrex sqgt0sr recexsrlem
      wa mulclsr mulasssr eqeq1i oveq2 eqeq1d sylan2b sylan exp31 rexlimdv syl5
      rspcev imp syldan ) BDEZBFGFBBHIZJKZBALZHIZMNZADOZBPULUNURUNUMCLZHIZMNZCD
      OULURCUMQULVAURCDULUSDEZVAURULVBRBUSHIZDEZVAURBUSSVAVDBVCHIZMNZURUTVEMBBU
      STUAUQVFAVCDUOVCNUPVEMUOVCBHUBUCUIUDUEUFUGUHUJUK $.
  $}

  ${
    mappsrpr.2 $e |- C e. R. $.
    $( Mapping from positive signed reals to positive reals.  (Contributed by
       NM, 17-May-1996.)  (Revised by Mario Carneiro, 15-Jun-2013.)
       (New usage is discouraged.) $)
    mappsrpr $p |- ( ( C +R -1R ) <R ( C +R [ <. A , 1P >. ] ~R ) <->
                     A e. P. ) $=
      ( cm1r c1p cop cer cec cltr wbr cpp co cltp cplr cnp df-m1r breq1i simprd
      wcel 1pr ltsrpr bitri cnr wb ltasr ax-mp ltrelpr brel dmplp 0npr ndmovrcl
      syl addclpr mp2an ltaddpr mpan impbii 3bitr3i ) DAEFGHZIJZEEKLZVAAKLZMJZB
      DNLBUSNLIJZAOSZUTEVAFGHZUSIJVCDVFUSIPQEVAAEUAUBBUCSUTVDUDCDUSBUEUFVCVEVCV
      BOSZVEVCVAOSZVGVAVBOOMUGUHRVGVHVEVAAOKUIUJUKRULVHVEVCEOSZVIVHTTEEUMUNVAAU
      OUPUQUR $.
  $}

  ${
    ltpsrpr.3 $e |- C e. R. $.
    $( Mapping of order from positive signed reals to positive reals.
       (Contributed by NM, 17-May-1996.)  (Revised by Mario Carneiro,
       15-Jun-2013.)  (New usage is discouraged.) $)
    ltpsrpr $p |- ( ( C +R [ <. A , 1P >. ] ~R ) <R
           ( C +R [ <. B , 1P >. ] ~R ) <-> A <P B ) $=
      ( c1p cop cer cec cplr co cltr wbr cltp cnr wcel ltasr ax-mp cpp addcompr
      wb breq1i ltsrpr cnp 1pr ltapr 3bitr4i bitr3i ) CAEFGHZIJCBEFGHZIJKLZUHUI
      KLZABMLZCNOUKUJTDUHUICPQAERJZEBRJZMLEARJZUNMLZUKULUMUOUNMAESUAAEBEUBEUCOU
      LUPTUDABEUEQUFUG $.
  $}

  ${
    $d x y z A $.  $d x y z C $.
    map2psrpr.2 $e |- C e. R. $.
    $( Equivalence for positive signed real.  (Contributed by NM,
       17-May-1996.)  (Revised by Mario Carneiro, 15-Jun-2013.)
       (New usage is discouraged.) $)
    map2psrpr $p |- ( ( C +R -1R ) <R A <->
            E. x e. P. ( C +R [ <. x , 1P >. ] ~R ) = A ) $=
      ( cm1r cplr co cltr wbr c1p cer wceq cnp wrex cnr wcel wb c0r cpp cltp vy
      vz cv cop cec ltrelsr brel simprd cmr ltasr ax-mp pn0sr addasssr addcomsr
      oveq1i 3eqtr3i 0idsr syl5eq breq2d syl5bb m1r mulclsr mp2an addclsr df-nr
      mpan breq2 eqeq2 rexbidv imbi12d df-m1r breq1i addasspr breq2i ltsrpr 1pr
      wi ltapr 3bitr4i bitri ltexpri sylbi enreceq mpanl2 eqeq1i syl6bbr ancoms
      wa addcompr rexbidva syl5ibr ecoptocl syl oveq2 sylan9eqr ex reximdv syld
      sylbird mpcom mappsrpr syl5bbr biimpac rexlimiva impbii ) CEFGZBHIZCAUCZJ
      UDKUEZFGZBLZAMNZBOPZXGXLXGXFOPXMXFBOOHUFUGUHXMXGECEUIGZBFGZHIZXLXPXFCXOFG
      ZHIZXMXGCOPZXPXRQDEXOCUJUKXMXQBXFHXMXQBRFGZBCXNFGZBFGRBFGXQXTYARBFXSYARLD
      CULUKUOCXNBUMRBUNUPBUQURZUSUTXMXPXIXOLZAMNZXLXMXOOPZXPYDVQZXNOPZXMYEXSEOP
      YGDVACEVBVCXNBVDVFEUAUCZUBUCZUDKUEZHIZXIYJLZAMNZVQYFUAUBXOMMKOVEYJXOLZYKX
      PYMYDYJXOEHVGYNYLYCAMYJXOXIVHVIVJYKYMYHMPYIMPWHZYIXHSGZJYHSGZLZAMNZYKYIYQ
      TIZYSYKJJJSGZUDKUEZYJHIZYTEUUBYJHVKVLJYISGZUUAYHSGZTIUUDJYQSGZTIZUUCYTUUE
      UUFUUDTJJYHVMVNJUUAYHYIVOJMPZYTUUGQVPYIYQJVRUKVSVTAYIYQWAWBYOYLYRAMXHMPZY
      OYLYRQUUIYOWHYLXHYISGZYQLZYRUUIUUHYOYLUUKQVPXHJYHYIWCWDYPUUJYQYIXHWIWEWFW
      GWJWKWLWMXMYCXKAMXMYCXKYCXMXJXQBXIXOCFWNYBWOWPWQWRWSWTXKXGAMXKUUIXGUUIXFX
      JHIXKXGXHCDXAXJBXFHVGXBXCXDXE $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    supsrlem.1 $e |- B = { w | ( C +R [ <. w , 1P >. ] ~R ) e. A } $.
    supsrlem.2 $e |- C e. R. $.
    $( Lemma for supremum theorem.  (Contributed by NM, 21-May-1996.)  (Revised
       by Mario Carneiro, 15-Jun-2013.)  (New usage is discouraged.) $)
    supsrlem $p |- ( ( C e. A /\ E. x e. R. A. y e. A y <R x ) ->
       E. x e. R. ( A. y e. A -. x <R y /\
            A. y e. R. ( y <R x -> E. z e. A y <R z ) ) ) $=
      ( wcel cltr wbr cnr wrex wa wi cnp c1p wceq cm1r vv vu cv wral cltp wn c0
      wne c0r cplr co 0idsr simpl eqeltrd cop cer cec 1pr elexi opeq1 eceq1 syl
      mp1i df-0r syl6eqr oveq2d eleq1d elab2 sylibr ne0i breq1 rspccv 0lt1sr wb
      c1r m1r ltasr ax-mp mpbi m1p1sr 3brtr3i breqtri ltsosr ltrelsr sotri mpan
      map2psrpr sylib syl6 breq2 ralbidv abeq2i ltpsrpr syl6ib ralrimiv syl6bir
      syl5bi reximdv syld rexlimivw impcom supexpr syl2anc mappsrpr brel sylbir
      com12 simprd adantl wex sylanbr rexex df-ral 19.29 syl5bb syl5bbr imbi12d
      wal eleq1 notbid biimpac exlimiv sylanb expcom 3syl impancom pm2.01d expr
      ex r19.29 biimprd vex syl6bb rspcev rexlimiva rexbidv syl5ib imim12d a1dd
      imp3a sylan2b sotri2 mp3an3 syl5 ad2antrr pm2.61d adantlr anim12d anbi12d
      exp3acom23 imbi1d ee12an rexlimdva mpd ) GEJZBUCZAUCZKLZBEUDZAMNZOZUAUCZD
      UCZUELZUFZDFUDZUVCUVBUELZUVCUBUCZUELZUBFNZPZDQUDZOZUAQNZUUQUUPKLZUFZBEUDZ
      UURUUPCUCZKLZCENZPZBMUDZOZAMNZUVAFUGUHZUVGDFUDZUAQNZUVNUVARFJZUWEUVAGUIUJ
      UKZEJZUWHUVAUWIGEGMJZUWIGSZUVAIGULZVCUUOUUTUMUNGUVCRUOZUPUQZUJUKZEJZUWJDR
      FRQURUSUVCRSZUWPUWIEUWRUWOUIGUJUWRUWORRUOZUPUQZUIUWRUWNUWSSUWOUWTSUVCRRUT
      UWNUWSUPVAVBVDVEVFVGHVHVIFRVJVBUUTUUOUWGUUSUUOUWGPAMUUSUUOGUVBRUOUPUQUJUK
      ZUUQSZUAQNZUWGUUSUUOGUUQKLZUXCUURUXDBGEUUPGUUQKVKVLUXDGTUJUKZUUQKLZUXCUXE
      GKLZUXDUXFUXEUWIGKTUIKLZUXEUWIKLZTUIUJUKZTVOUJUKZTUIKUIVOKLZUXJUXKKLZVMTM
      JZUXLUXMVNVPUIVOTVQVRVSUXNUXJTSVPTULVRVTWAUWKUXHUXIVNITUIGVQVRVSUWKUWLIUW
      MVRWBZUXEGUUQKMWCWDWEWFUAUUQGIWGWHWIUUSUXBUWFUAQUXBUUSUWFUXBUUSUUPUXAKLZB
      EUDZUWFUXBUXPUURBEUXAUUQUUPKWJWKUXQUVGDFUVCFJZUWQUXQUVGUWQDFHWLZUXQUWQUWP
      UXAKLZUVGUXPUXTBUWPEUUPUWPUXAKVKVLUVCUVBGIWMZWNWQWOWPXGWRWSWTXAUADUBFXBXC
      UVAUVMUWDUAQUVAUVBQJZOZUXAMJZUVMUXAUUPKLZUFZBEUDZUXPUVTPZBMUDZOZUWDUYBUYD
      UVAUYBUXEMJZUYDUYBUXEUXAKLZUYKUYDOUVBGIXDZUXEUXAMMKWDXEXFXHXIUYCUVFUYGUVL
      UYIUYBUVFUYGPUVAUYBUVFUYGUYBUVFOUYFBEUYBUVFUUPEJZUYFUYBUVFUYNOZOUYEUYBUYE
      UYOUYFUYBUYEOZUVFUYNUYFUYPUWPUUPSZDQNZUYQDXJZUVFUYNUYFPZPUYPUXEUUPKLZUYRU
      YBUYLUYEVUAUYMUXEUXAUUPKMWCWDWEXKDUUPGIWGZWHUYQDQXLUVFUYSUYTUVFUXRUVEPZDX
      RZUYSUYTUVEDFXMVUDUYSOVUCUYQOZDXJUYTVUCUYQDXNVUEUYTDUYQVUCUYTUYQUXRUYNUVE
      UYFUXRUWQUYQUYNUXSUWPUUPEXSXOUYQUVDUYEUVDUXAUWPKLUYQUYEUVBUVCGIWMUWPUUPUX
      AKWJXPXTXQYAYBVBYCYDYEYTYFYGYHWOYIXIUUOUYBUVLUYIPUUTUUOUYBOZUVLUYIVUFUVLO
      ZUYHBMVUGVUAUUPMJZUYHPZVUGVUAUYHVUHUVLVUAUYHPVUFUVLVUAUYHVUAUVLUYRUYHVUBU
      VLUYROUVKUYQOZDQNUYHUVKUYQDQYJVUJUYHDQUYQUVKUYHUYQUXPUVGUVJUVTUYQUVGUXPUV
      GUXTUYQUXPUYAUWPUUPUXAKVKXPYKUVJUWPUVRKLZCENZUYQUVTUVIVULUBFUVHFJGUVHRUOZ
      UPUQZUJUKZEJZUVIVULUWQVUPDUVHFUBYLUVCUVHSZUWPVUOEVUQUWOVUNGUJVUQUWNVUMSUW
      OVUNSUVCUVHRUTUWNVUMUPVAVBVFVGHVHVUKUVICVUOEUVRVUOSVUKUWPVUOKLUVIUVRVUOUW
      PKWJUVCUVHGIWMYMYNYCYOUYQVUKUVSCEUWPUUPUVRKVKYPYQYRXAWTVBUUAYIXIYSUUOVUAU
      FZVUIPUYBUVLUUOVUHVURUYHVUHVUROUUPGKLZUUOUYHVUHVURUXGVUSUXOUUPUXEGKMWCWDU
      UBUUCUUOVUSUVTUXPUUOVUSUVTUVSVUSCGEUVRGUUPKWJYNYIYSUUDUUJUUEUUFWOYIUUGUUH
      UWCUYJAUXAMUUQUXASZUVQUYGUWBUYIVUTUVPUYFBEVUTUVOUYEUUQUXAUUPKVKXTWKVUTUWA
      UYHBMVUTUURUXPUVTUUQUXAUUPKWJUUKWKUUIYNUULUUMUUN $.
  $}

  ${
    $d x y z w v u A $.
    $( A non-empty, bounded set of signed reals has a supremum.  (Cotributed by
       Mario Carneiro, 15-Jun-2013.)  (Contributed by NM, 21-May-1996.)
       (Revised by Mario Carneiro, 15-Jun-2013.)
       (New usage is discouraged.) $)
    supsr $p |- ( ( A =/= (/) /\ E. x e. R. A. y e. A y <R x ) ->
       E. x e. R. ( A. y e. A -. x <R y /\
            A. y e. R. ( y <R x -> E. z e. A y <R z ) ) ) $=
      ( vu vw vv cv cltr wbr wral cnr wrex wi wa wcel c1r wceq c1p cer c0 wn n0
      wne wex wss ltrelsr simpld ralimi dfss3 sylibr sseld rexlimivw impcom cif
      brel eleq1 anbi1d imbi1d cop cec cplr co opeq1 eceq1 oveq2d eleq1d cbvabv
      cab syl 1sr elimel supsrlem dedth mpcom ex exlimiv sylbi imp ) DUAUDZBHZA
      HZIJZBDKZALMZWBWAIJUBBDKWCWACHIJCDMNBLKOALMZVTEHZDPZEUEWEWFNZEDUCWHWIEWHW
      EWFWGLPZWHWEOZWFWEWHWJWDWHWJNALWDDLWGWDWALPZBDKDLUFWCWLBDWCWLWBLPWAWBLLIU
      GUPUHUIBDLUJUKULUMUNWJWKWFNWJWGQUOZDPZWEOZWFNWGQWGWMRZWKWOWFWPWHWNWEWGWMD
      UQURUSABCFDWMGHZSUTZTVAZVBVCZDPZGVIWMXAWMFHZSUTZTVAZVBVCZDPGFWQXBRZWTXEDX
      FWSXDWMVBXFWRXCRWSXDRWQXBSVDWRXCTVEVJVFVGVHWGQLVKVLVMVNVOVPVQVRVS $.
  $}

  $( Class of complex numbers. $)
  cc $a class CC $.
  $( Class of real numbers. $)
  cr $a class RR $.
  $( Extend class notation to include the complex number 0. $)
  cc0 $a class 0 $.
  $( Extend class notation to include the complex number 1. $)
  c1 $a class 1 $.
  $( Extend class notation to include the complex number i. $)
  ci $a class _i $.
  $( Addition on complex numbers. $)
  caddc $a class + $.
  $( 'Less than' predicate (defined over real subset of complex numbers). $)
  cltrr $a class <RR $.
  $( Multiplication on complex numbers.  The token ` x. ` is a center dot. $)
  cmul $a class x. $.

  $( Define the set of complex numbers.  The 23 axioms for complex numbers
     start at ~ axresscn .  (Contributed by NM, 22-Feb-1996.)
     (New usage is discouraged.) $)
  df-c $a |- CC = ( R. X. R. ) $.

  $( Define the complex number 0.  (Contributed by NM, 22-Feb-1996.)
     (New usage is discouraged.) $)
  df-0 $a |- 0 = <. 0R , 0R >. $.

  $( Define the complex number 1.  (Contributed by NM, 22-Feb-1996.)
     (New usage is discouraged.) $)
  df-1 $a |- 1 = <. 1R , 0R >. $.

  $( Define the complex number ` _i ` (the imaginary unit).  (Contributed by
     NM, 22-Feb-1996.)  (New usage is discouraged.) $)
  df-i $a |- _i = <. 0R , 1R >. $.

  ${
    $d x y $.
    $( Define the set of real numbers.  (Contributed by NM, 22-Feb-1996.)
       (New usage is discouraged.) $)
    df-r $a |- RR = ( R. X. { 0R } ) $.
  $}

  ${
    $d x y z w v u f $.
    $( Define addition over complex numbers.  (Contributed by NM,
       28-May-1995.)  (New usage is discouraged.) $)
    df-add $a |- + = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. CC ) /\
                  E. w E. v E. u E. f ( ( x = <. w , v >. /\ y = <. u , f >. )
                  /\ z = <. ( w +R u ) , ( v +R f ) >. ) ) } $.

    $( Define multiplication over complex numbers.  (Contributed by NM,
       9-Aug-1995.)  (New usage is discouraged.) $)
    df-mul $a |- x. = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. CC ) /\
               E. w E. v E. u E. f ( ( x = <. w , v >. /\ y = <. u , f >. )
                  /\ z = <. ( ( w .R u ) +R ( -1R .R ( v .R f ) ) ) ,
                  ( ( v .R u ) +R ( w .R f ) ) >. ) ) } $.

    $( Define 'less than' on the real subset of complex numbers.  Proofs should
       typically use ` < ` instead; see ~ df-ltxr .  (Contributed by NM,
       22-Feb-1996.)  (New usage is discouraged.) $)
    df-lt $a |- <RR = { <. x , y >. | ( ( x e. RR /\ y e. RR ) /\
     E. z E. w ( ( x = <. z , 0R >. /\ y = <. w , 0R >. ) /\ z <R w ) ) } $.
  $}

  $( Ordered pair membership in the class of complex numbers.  (Contributed by
     NM, 14-May-1996.)  (New usage is discouraged.) $)
  opelcn $p |- ( <. A , B >. e. CC <-> ( A e. R. /\ B e. R. ) ) $=
    ( cop cc wcel cnr cxp wa df-c eleq2i opelxp bitri ) ABCZDEMFFGZEAFEBFEHDNMI
    JABFFKL $.

  $( Ordered pair membership in class of real subset of complex numbers.
     (Contributed by NM, 22-Feb-1996.)  (New usage is discouraged.) $)
  opelreal $p |- ( <. A , 0R >. e. RR <-> A e. R. ) $=
    ( c0r cop cr wcel cnr wceq eqid csn cxp wa eleq2i opelxp elexi elsnc anbi2i
    df-r 0r 3bitri mpbiran2 ) ABCZDEZAFEZBBGZBHUBUAFBIZJZEUCBUEEZKUCUDKDUFUAQLA
    BFUEMUGUDUCBBBFRNOPST $.

  ${
    $d x y A $.
    $( Membership in class of real numbers.  (Contributed by NM, 31-Mar-1996.)
       (New usage is discouraged.) $)
    elreal $p |- ( A e. RR <-> E. x e. R. <. x , 0R >. = A ) $=
      ( vy cr wcel cnr c0r csn cxp cv cop wceq wrex eleq2i elxp2 0r elexi opeq2
      df-r bitri eqeq2d rexsn eqcom rexbii ) BDEBFGHZIZEZAJZGKZBLZAFMZDUFBSNUGB
      UHCJZKZLZCUEMZAFMUKACBFUEOUOUJAFUOBUILZUJUNUPCGGFPQULGLUMUIBULGUHRUAUBBUI
      UCTUDTT $.
  $}

  ${
    $( Ordered pair membership in the class of complex numbers.  (Contributed
       by Mario Carneiro, 15-Jun-2013.)  (New usage is discouraged.) $)
    elreal2 $p |- ( A e. RR <->
        ( ( 1st ` A ) e. R. /\ A = <. ( 1st ` A ) , 0R >. ) ) $=
      ( cr wcel cnr c0r csn cxp c1st cfv wceq wa df-r eleq2i xp1st c2nd 1st2nd2
      cop xp2nd elsni syl opeq2d eqtrd jca eleq1 0r snid opelxp mpbiran2 syl6bb
      elexi biimparc impbii bitri ) ABCADEFZGZCZAHIZDCZAUQEQZJZKZBUOALMUPVAUPUR
      UTADUNNUPAUQAOIZQUSADUNPUPVBEUQUPVBUNCVBEJADUNRVBESTUAUBUCUTUPURUTUPUSUOC
      ZURAUSUOUDVCUREUNCEEDUEUJUFUQEDUNUGUHUIUKULUM $.
  $}

  $( The empty set is not a complex number.  Note: do not use this after the
     real number axioms are developed, since it is a construction-dependent
     property.  (Contributed by NM, 2-May-1996.)
     (New usage is discouraged.) $)
  0ncn $p |- -. (/) e. CC $=
    ( c0 cc wcel cnr cxp 0nelxp df-c eleq2i mtbir ) ABCADDEZCDDFBJAGHI $.

  ${
    $d x y z w $.
    $( 'Less than' is a relation on real numbers.  (Contributed by NM,
       22-Feb-1996.)  (New usage is discouraged.) $)
    ltrelre $p |- <RR C_ ( RR X. RR ) $=
      ( vx vy vz vw cltrr cv cr wcel wa c0r cop wceq wbr wex copab cxp opabssxp
      cltr df-lt eqsstri ) EAFZGHBFZGHIUACFZJKLUBDFZJKLIUCUDRMIDNCNZIABOGGPABCD
      SUEABGGQT $.
  $}

  ${
    $d x y z w v u f A $.  $d x y z w v u f B $.  $d x y z w v u f C $.
    $d x y z w v u f D $.
    $( Addition of complex numbers in terms of signed reals.  (Contributed by
       NM, 28-May-1995.)  (New usage is discouraged.) $)
    addcnsr $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
           ( <. A , B >. + <. C , D >. ) = <. ( A +R C ) , ( B +R D ) >. ) $=
      ( vx vy vz vw vv vu vf cv cplr co cop wceq wa cc wcel wex caddc cnr oveq1
      opex opeq12 syl2an oveq2 sylan9eq coprab cxp df-add eleq2i anbi12i anbi1i
      df-c oprabbii eqtri ov3 ) EFGHIJABCDHLZJLZMNZILZKLZMNZOZACMNZBDMNZOZKUAUB
      VFVGUDUSAPZVBBPZQUTCPZVCDPZQVEAUTMNZBVCMNZOZVHVIVAVMPVDVNPVEVOPVJUSAUTMUC
      VBBVCMUCVAVDVMVNUEUFVKVMVFPVNVGPVOVHPVLUTCAMUGVCDBMUGVMVNVFVGUEUFUHUAELZR
      SZFLZRSZQZVPUSVBOPVRUTVCOPQGLVEPQKTJTITHTZQZEFGUIVPUBUBUJZSZVRWCSZQZWAQZE
      FGUIEFGHIJKUKWBWGEFGVTWFWAVQWDVSWERWCVPUOULRWCVRUOULUMUNUPUQUR $.

    $( Multiplication of complex numbers in terms of signed reals.
       (Contributed by NM, 9-Aug-1995.)  (New usage is discouraged.) $)
    mulcnsr $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
               ( <. A , B >. x. <. C , D >. ) =
                   <. ( ( A .R C ) +R ( -1R .R ( B .R D ) ) ) ,
                          ( ( B .R C ) +R ( A .R D ) ) >. ) $=
      ( vx vy vz vw vv vu vf cv cmr co cm1r cplr cop wceq wa oveq1 cmul opeq12d
      cnr opex oveq2d oveqan12d oveqan12rd oveq2 sylan9eq cc wcel coprab df-mul
      wex cxp df-c eleq2i anbi12i anbi1i oprabbii eqtri ov3 ) EFGHIJABCDHLZJLZM
      NZOILZKLZMNZMNZPNZVFVDMNZVCVGMNZPNZQZACMNZOBDMNZMNZPNZBCMNZADMNZPNZQZKUAU
      CVRWAUDVCARZVFBRZSZVDCRZVGDRZSZVNAVDMNZOBVGMNZMNZPNZBVDMNZAVGMNZPNZQWBWEV
      JWLVMWOWCWDVEWIVIWKPVCAVDMTWDVHWJOMVFBVGMTUEUFWDWCVKWMVLWNPVFBVDMTVCAVGMT
      UGUBWHWLVRWOWAWFWGWIVOWKVQPVDCAMUHWGWJVPOMVGDBMUHUEUFWFWGWMVSWNVTPVDCBMUH
      VGDAMUHUFUBUIUAELZUJUKZFLZUJUKZSZWPVCVFQRWRVDVGQRSGLVNRSKUNJUNIUNHUNZSZEF
      GULWPUCUCUOZUKZWRXCUKZSZXASZEFGULEFGHIJKUMXBXGEFGWTXFXAWQXDWSXEUJXCWPUPUQ
      UJXCWRUPUQURUSUTVAVB $.

  $}

  ${
    eqresr.1 $e |- A e. _V $.
    $( Equality of real numbers in terms of intermediate signed reals.
       (Contributed by NM, 10-May-1996.)  (New usage is discouraged.) $)
    eqresr $p |- ( <. A , 0R >. = <. B , 0R >. <-> A = B ) $=
      ( c0r cop wceq eqid cnr 0r elexi opth mpbiran2 ) ADEBDEFABFDDFDGADBDCDHIJ
      KL $.
  $}

  $( Addition of real numbers in terms of intermediate signed reals.
     (Contributed by NM, 10-May-1996.)  (New usage is discouraged.) $)
  addresr $p |- ( ( A e. R. /\ B e. R. ) ->
           ( <. A , 0R >. + <. B , 0R >. ) = <. ( A +R B ) , 0R >. ) $=
    ( cnr wcel wa c0r cop caddc co cplr wceq 0r addcnsr an4s 0idsr ax-mp opeq2i
    mpanr12 syl6eq ) ACDZBCDZEZAFGBFGHIZABJIZFFJIZGZUDFGUBFCDZUGUCUFKZLLTUGUAUG
    UHAFBFMNRUEFUDUGUEFKLFOPQS $.

  $( Multiplication of real numbers in terms of intermediate signed reals.
     (Contributed by NM, 10-May-1996.)  (New usage is discouraged.) $)
  mulresr $p |- ( ( A e. R. /\ B e. R. ) ->
         ( <. A , 0R >. x. <. B , 0R >. ) = <. ( A .R B ) , 0R >. ) $=
    ( cnr wcel wa c0r cop cmul co cmr cm1r cplr wceq mulcnsr ax-mp oveq2i 0idsr
    0r 00sr syl5eq an4s mpanr12 m1r eqtri mulclsr syl oveqan12rd syl6eq opeq12d
    mulcomsr eqtrd ) ACDZBCDZEZAFGBFGHIZABJIZKFFJIZJIZLIZFBJIZAFJIZLIZGZUPFGUNF
    CDZVDUOVCMZRRULVDUMVDVEAFBFNUAUBUNUSUPVBFUNUSUPFLIZUPURFUPLURKFJIZFUQFKJVDU
    QFMRFSOPKCDVGFMUCKSOUDPUNUPCDVFUPMABUEUPQUFTUNVBFFLIZFUMULUTFVAFLUMUTBFJIFF
    BUJBSTASUGVDVHFMRFQOUHUIUK $.

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Ordering of real subset of complex numbers in terms of signed reals.
       (Contributed by NM, 22-Feb-1996.)  (New usage is discouraged.) $)
    ltresr $p |- ( <. A , 0R >. <RR <. B , 0R >. <-> A <R B ) $=
      ( vz vw vx vy c0r cop cltrr wbr cnr wcel wa cltr cr wceq wex anbi1d eqcom
      cv ltrelre brel opelreal anbi12i sylib ltrelsr opex eleq1 2exbidv anbi12d
      wb eqeq1 anbi2d df-lt brab baib eqresr 3bitr4i opth2 bitr4i anbi1i 2exbii
      vex syl6bb syl2anbr breq12 copsex2g bitrd pm5.21nii ) AGHZBGHZIJZAKLZBKLZ
      MZABNJZVLVJOLZVKOLZMZVOVJVKOOIUAUBVQVMVRVNAUCZBUCZUDUEABKKNUFUBVOVLABHCTZ
      DTZHPZWBWCNJZMZDQCQZVPVMVQVRVLWGUKVNVTWAVSVLVJWBGHZPZVKWCGHZPZMZWEMZDQCQZ
      WGVLVSWNETZOLZFTZOLZMZWOWHPZWQWJPZMZWEMZDQCQZMVQWRMZWIXAMZWEMZDQCQZMVSWNM
      EFVJVKIAGUGBGUGWOVJPZWSXEXDXHXIWPVQWRWOVJOUHRXIXCXGCDXIXBXFWEXIWTWIXAWOVJ
      WHULRRUIUJWQVKPZXEVSXHWNXJWRVRVQWQVKOUHUMXJXGWMCDXJXFWLWEXJXAWKWIWQVKWJUL
      UMRUIUJEFCDUNUOUPWMWFCDWLWDWEWLAWBPZBWCPZMWDWIXKWKXLWHVJPWBAPWIXKWBACVCZU
      QVJWHSAWBSURWJVKPWCBPWKXLWCBDVCZUQVKWJSBWCSURUDABWBWCXMXNUSUTVAVBVDVEWEVP
      CDABKKWBAWCBNVFVGVHVI $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Ordering of real subset of complex numbers in terms of signed reals.
       (Contributed by NM, 22-Feb-1996.)  (New usage is discouraged.) $)
    ltresr2 $p |- ( ( A e. RR /\ B e. RR ) ->
        ( A <RR B <-> ( 1st ` A ) <R ( 1st ` B ) ) ) $=
      ( cr wcel wa wbr c1st cfv c0r cop cltr cnr wceq elreal2 simprbi breqan12d
      cltrr ltresr syl6bb ) ACDZBCDZEABQFAGHZIJZBGHZIJZQFUBUDKFTUAAUCBUEQTUBLDA
      UCMANOUAUDLDBUEMBNOPUBUDRS $.
  $}

  $( Technical trick to permit reuse of previous lemmas to prove arithmetic
     operation laws in ` CC ` from those in ` R. ` .  The trick involves
     ~ qsid , which shows that the coset of the converse epsilon relation
     (which is not an equivalence relation) acts as an identity divisor for the
     quotient set operation.  This lets us "pretend" that ` CC ` is a quotient
     set, even though it is not (compare ~ df-c ), and allows us to reuse some
     of the equivalence class lemmas we developed for the transition from
     positive reals to signed reals, etc.  (Contributed by NM, 13-Aug-1995.)
     (New usage is discouraged.) $)
  dfcnqs $p |- CC = ( ( R. X. R. ) /. `' _E ) $=
    ( cc cnr cxp cep ccnv cqs df-c qsid eqtr4i ) ABBCZJDEFGJHI $.

  $( Technical trick to permit re-use of some equivalence class lemmas for
     operation laws.  See ~ dfcnqs and ~ mulcnsrec .  (Contributed by NM,
     13-Aug-1995.)  (New usage is discouraged.) $)
  addcnsrec $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
                 ( [ <. A , B >. ] `' _E + [ <. C , D >. ] `' _E ) =
                   [ <. ( A +R C ) , ( B +R D ) >. ] `' _E ) $=
    ( cnr wcel wa cop caddc cplr cep ccnv cec addcnsr opex ecid oveq12i 3eqtr4g
    co ) AEFBEFGCEFDEFGGABHZCDHZISACJSZBDJSZHZTKLZMZUAUEMZISUDUEMABCDNUFTUGUAIT
    ABOPUACDOPQUDUBUCOPR $.

  $( Technical trick to permit re-use of some equivalence class lemmas for
     operation laws.  The trick involves ~ ecid , which shows that the coset of
     the converse epsilon relation (which is not an equivalence relation)
     leaves a set unchanged.  See also ~ dfcnqs .

     _Note:  This is the last lemma (from which the axioms will be derived) in_
     _the construction of real and complex numbers.  The construction starts_
     _at_ ~ cnpi .  (Contributed by NM, 13-Aug-1995.)
     (New usage is discouraged.) $)
  mulcnsrec $p |- ( ( ( A e. R. /\ B e. R. ) /\ ( C e. R. /\ D e. R. ) ) ->
               ( [ <. A , B >. ] `' _E x. [ <. C , D >. ] `' _E ) =
                    [ <. ( ( A .R C ) +R ( -1R .R ( B .R D ) ) ) ,
                          ( ( B .R C ) +R ( A .R D ) ) >. ] `' _E ) $=
    ( cnr wcel wa cop cmul cmr cm1r cplr cep ccnv cec mulcnsr opex ecid oveq12i
    co 3eqtr4g ) AEFBEFGCEFDEFGGABHZCDHZITACJTKBDJTJTLTZBCJTADJTLTZHZUBMNZOZUCU
    GOZITUFUGOABCDPUHUBUIUCIUBABQRUCCDQRSUFUDUEQRUA $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Final derivation of real and complex number postulates
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u f $.
    $( Addition is an operation on the complex numbers.  This theorem can be
       used as an alternate axiom for complex numbers in place of the less
       specific ~ axaddcl .  This construction-dependent theorem should not be
       referenced directly; instead, use ~ ax-addf .  (Contributed by NM,
       8-Feb-2005.)  (New usage is discouraged.) $)
    axaddf $p |- + : ( CC X. CC ) --> CC $=
      ( vx vy vw vv vu vf vz cc cxp caddc cv co wcel wral wceq cop cplr wex cnr
      wa wf wfn wfun cdm coprab wmo moeq mosubop anass 2exbii bitri mobii mpbir
      19.42vv moani funoprab df-add funeqi dmeqi dmoprabss eqsstri oveq1 eleq1d
      0ncn df-c oveq2 addcnsr addclsr anim12i opelxpi eqeltrd 2optocl syl6eleqr
      an4s syl oprssdm eqssi df-fn mpbir2an rgen2a ffnov ) HHIZHJUAJWBUBZAKZBKZ
      JLZHMZBHNAHNWCJUCZJUDZWBOWHWDHMWEHMTZWDCKZDKZPOZWEEKZFKZPOZTGKZWKWNQLZWLW
      OQLPZOZTZFRERZDRCRZTZABGUEZUCXDABGXCWJGXCGUFWMWPWTTZFRERZTZDRCRZGUFXGGCDW
      DWTGEFWEGWSUGUHUHXCXIGXBXHCDXBWMXFTZFRERXHXAXJEFWMWPWTUIUJWMXFEFUNUKUJULU
      MUOUPJXEABGCDEFUQZURUMWIWBWIXEUDWBJXEXKUSXCABGHHUTVAABHJVDWJWFSSIZHWQWKPZ
      WLWNPZJLZXLMWDXNJLZXLMWFXLMGCDEWDWESSHVEXMWDOXOXPXLXMWDXNJVBVCXNWEOXPWFXL
      XNWEWDJVFVCWQSMZWKSMZTWLSMZWNSMZTTZXOWQWLQLZWRPZXLWQWKWLWNVGYAYBSMZWRSMZT
      ZYCXLMXQXSXRXTYFXQXSTYDXRXTTYEWQWLVHWKWNVHVIVNYBWRSSVJVOVKVLVEVMZVPVQJWBV
      RVSWGABHYGVTABHHHJWAVS $.

    $( Multiplication is an operation on the complex numbers.  This theorem can
       be used as an alternate axiom for complex numbers in place of the less
       specific ~ axmulcl .  This construction-dependent theorem should not be
       referenced directly; instead, use ~ ax-mulf .  (Contributed by NM,
       8-Feb-2005.)  (New usage is discouraged.) $)
    axmulf $p |- x. : ( CC X. CC ) --> CC $=
      ( vx vy vw vv vu vf vz cc cmul cv co wcel wceq wa cop cmr wex cnr mulclsr
      cm1r cxp wf wfn wral wfun cdm cplr coprab wmo moeq mosubop 2exbii 19.42vv
      anass bitri mobii mpbir moani funoprab df-mul funeqi dmeqi dmoprabss 0ncn
      eqsstri df-c oveq1 eleq1d mulcnsr m1r sylancr addclsr syl2an an4s syl2anr
      oveq2 an42s opelxpi syl2anc eqeltrd 2optocl syl6eleqr oprssdm eqssi df-fn
      mpbir2an rgen2a ffnov ) HHUAZHIUBIWIUCZAJZBJZIKZHLZBHUDAHUDWJIUEZIUFZWIMW
      OWKHLWLHLNZWKCJZDJZOMZWLEJZFJZOMZNGJZWRXAPKZTWSXBPKPKUGKWSXAPKWRXBPKUGKOZ
      MZNZFQEQZDQCQZNZABGUHZUEXKABGXJWQGXJGUIWTXCXGNZFQEQZNZDQCQZGUIXNGCDWKXGGE
      FWLGXFUJUKUKXJXPGXIXOCDXIWTXMNZFQEQXOXHXQEFWTXCXGUNULWTXMEFUMUOULUPUQURUS
      IXLABGCDEFUTZVAUQWPWIWPXLUFWIIXLXRVBXJABGHHVCVEABHIVDWQWMRRUAZHXDWROZWSXA
      OZIKZXSLWKYAIKZXSLWMXSLGCDEWKWLRRHVFXTWKMYBYCXSXTWKYAIVGVHYAWLMYCWMXSYAWL
      WKIVPVHXDRLZWRRLZNWSRLZXARLZNNZYBXDWSPKZTXEPKZUGKZWRWSPKZXDXAPKZUGKZOZXSX
      DWRWSXAVIYHYKRLZYNRLZYOXSLYDYFYEYGYPYDYFNYIRLYJRLZYPYEYGNZXDWSSYSTRLXERLY
      RVJWRXASTXESVKYIYJVLVMVNYDYGYEYFYQYEYFNYLRLYMRLYQYDYGNWRWSSXDXASYLYMVLVOV
      QYKYNRRVRVSVTWAVFWBZWCWDIWIWEWFWNABHYTWGABHHHIWHWF $.
  $}

  $( The complex numbers form a set.  This axiom is redundant in the presence
     of the other axioms (see ~ cnexALT ), but the proof requires the axiom of
     replacement, while the derivation from the construction here does not.
     Thus, we can avoid ~ ax-rep in later theorems by invoking the axiom
     ~ ax-cnex instead of ~ cnexALT .  (Contributed by Mario Carneiro,
     17-Nov-2014.)  (New usage is discouraged.) $)
  axcnex $p |- CC e. _V $=
    ( cc cnr cxp cvv df-c cnp cer cqs df-nr cpw npex xpex pwex wss wtru wer a1i
    enrer qsss eqeltri trud ssexi ) ABBCDEBBBFFCZGHZDIUDUCJZUCFFKKLMUDUENOUCGUC
    GPORQSUAUBTZUFLT $.

  $( The real numbers are a subset of the complex numbers.  Axiom 1 of 22 for
     real and complex numbers, derived from ZF set theory.  This
     construction-dependent theorem should not be referenced directly; instead,
     use ~ ax-resscn .  (Contributed by NM, 1-Mar-1995.)  (Proof shortened by
     Andrew Salmon, 12-Aug-2011.)  (New usage is discouraged.) $)
  axresscn $p |- RR C_ CC $=
    ( cnr c0r csn cxp cr cc wcel wss 0r snssi xpss2 mp2b df-r df-c 3sstr4i ) AB
    CZDZAADZEFBAGPAHQRHIBAJPAAKLMNO $.

  $( 1 is a complex number.  Axiom 2 of 22 for real and complex numbers,
     derived from ZF set theory.  This construction-dependent theorem should
     not be referenced directly; instead, use ~ ax-1cn .  (Contributed by NM,
     12-Apr-2007.)  (New usage is discouraged.) $)
  ax1cn $p |- 1 e. CC $=
    ( cr cc c1 axresscn c1r c0r cop df-1 wcel cnr opelreal mpbir eqeltri sselii
    1sr ) ABCDCEFGZAHPAIEJIOEKLMN $.

  $( ` _i ` is a complex number.  Axiom 3 of 22 for real and complex numbers,
     derived from ZF set theory.  This construction-dependent theorem should
     not be referenced directly; instead, use ~ ax-icn .  (Contributed by NM,
     23-Feb-1996.)  (New usage is discouraged.) $)
  axicn $p |- _i e. CC $=
    ( ci cc wcel c0r cnr c1r 0r 1sr cop wa df-i eleq1i opelcn bitri mpbir2an )
    ABCZDECZFECZGHPDFIZBCQRJASBKLDFMNO $.

  ${
    $d x y A $.  $d x y B $.
    $( Closure law for addition of complex numbers.  Axiom 4 of 22 for real and
       complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly, nor
       should the proven axiom ~ ax-addcl be used later.  Instead, in most
       cases use ~ addcl .  (Contributed by NM, 14-Jun-1995.)
       (New usage is discouraged.) $)
    axaddcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) e. CC ) $=
      ( cc caddc axaddf fovcl ) ABCCCDEF $.

    $( Closure law for addition in the real subfield of complex numbers.  Axiom
       5 of 22 for real and complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly, nor
       should the proven axiom ~ ax-addrcl be used later.  Instead, in most
       cases use ~ readdcl .  (Contributed by NM, 31-Mar-1996.)
       (New usage is discouraged.) $)
    axaddrcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A + B ) e. RR ) $=
      ( vx vy cv c0r cop caddc co cr wcel cnr elreal wceq oveq1 eleq1d oveq2 wa
      cplr addresr addclsr opelreal sylibr eqeltrd 2gencl ) CEZFGZDEZFGZHIZJKAU
      IHIZJKABHIZJKCDUGUIABLJCAMDBMUGANUJUKJUGAUIHOPUIBNUKULJUIBAHQPUFLKUHLKRZU
      JUFUHSIZFGZJUFUHTUMUNLKUOJKUFUHUAUNUBUCUDUE $.

    $( Closure law for multiplication of complex numbers.  Axiom 6 of 22 for
       real and complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly, nor
       should the proven axiom ~ ax-mulcl be used later.  Instead, in most
       cases use ~ mulcl .  (Contributed by NM, 10-Aug-1995.)
       (New usage is discouraged.) $)
    axmulcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) e. CC ) $=
      ( cc cmul axmulf fovcl ) ABCCCDEF $.

    $( Closure law for multiplication in the real subfield of complex numbers.
       Axiom 7 of 22 for real and complex numbers, derived from ZF set theory.
       This construction-dependent theorem should not be referenced directly,
       nor should the proven axiom ~ ax-mulrcl be used later.  Instead, in most
       cases use ~ remulcl .  (New usage is discouraged.)  (Contributed by NM,
       31-Mar-1996.) $)
    axmulrcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A x. B ) e. RR ) $=
      ( vx vy cv c0r cop cmul co cr wcel cnr elreal wceq oveq1 eleq1d oveq2 cmr
      wa mulresr mulclsr opelreal sylibr eqeltrd 2gencl ) CEZFGZDEZFGZHIZJKAUIH
      IZJKABHIZJKCDUGUIABLJCAMDBMUGANUJUKJUGAUIHOPUIBNUKULJUIBAHQPUFLKUHLKSZUJU
      FUHRIZFGZJUFUHTUMUNLKUOJKUFUHUAUNUBUCUDUE $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Multiplication of complex numbers is commutative.  Axiom 8 of 22 for
       real and complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly, nor
       should the proven axiom ~ ax-mulcom be used later.  Instead, use
       ~ mulcom .  (Contributed by NM, 31-Aug-1995.)
       (New usage is discouraged.) $)
    axmulcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) = ( B x. A ) ) $=
      ( vx vy vz vw cc cv cmr co cm1r cplr cmul cep ccnv cnr mulcnsrec mulcomsr
      dfcnqs oveq12i oveq2i addcomsr eqtri ecovcom ) CDEFABGCHZEHZIJZKDHZFHZIJZ
      IJZLJMNOPUHUFIJZUEUIIJZLJZUFUEIJZKUIUHIJZIJZLJUIUEIJZUFUHIJZLJZSUEUHUFUIQ
      UFUIUEUHQUGUOUKUQLUEUFRUJUPKIUHUIRUATUNUSURLJUTULUSUMURLUHUFRUEUIRTUSURUB
      UCUD $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $( Addition of complex numbers is associative.  This theorem transfers the
       associative laws for the real and imaginary signed real components of
       complex number pairs, to complex number addition itself.  Axiom 9 of 22
       for real and complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly, nor
       should the proven axiom ~ ax-addass be used later.  Instead, use
       ~ addass .  (Contributed by NM, 2-Sep-1995.)
       (New usage is discouraged.) $)
    axaddass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A + B ) + C ) = ( A + ( B + C ) ) ) $=
      ( vx vy vz vw vv vu cv cplr co cnr addcnsrec wcel wa addclsr anim12i an4s
      addasssr cc caddc cep ccnv dfcnqs ecovass ) DEFGHIABCUAUBGJZIJZKLZUCUDMDJ
      ZFJZKLZEJZUGKLZULHJZKLUNUHKLUJUKUOKLZKLUMUIKLUPUEUJUMUKUGNUKUGUOUHNULUNUO
      UHNUJUMUPUINUJMOZUKMOZUMMOZUGMOZULMOZUNMOZPUQURPVAUSUTPVBUJUKQUMUGQRSURUO
      MOZUTUHMOZUPMOZUIMOZPURVCPVEUTVDPVFUKUOQUGUHQRSUJUKUOTUMUGUHTUF $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    $( Multiplication of complex numbers is associative.  Axiom 10 of 22 for
       real and complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly;
       instead, use ~ ax-mulass .  (Contributed by NM, 3-Sep-1995.)
       (New usage is discouraged.) $)
    axmulass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) ) $=
      ( vf vg vh cv cmr co cplr cnr cm1r wcel mulclsr ovex distrsr oveq2i eqtri
      wa vex vx vy vz vw vv vu cc cmul cep dfcnqs mulcnsrec m1r sylancr addclsr
      ccnv syl2an an4s syl2anr an42s jca addcomsr addasssr caov42 oveq12i elexi
      mulcomsr mulasssr caovdilem caov12 3eqtr4ri ecovass ) UAUBUCUDUEUFABCUGUH
      UDGZUEGZHIZUCGZUFGZHIZJIZUIUOKUAGZVOHIZLUBGZVLHIZHIZJIZWAVOHIZVSVLHIZJIZW
      DVMHIZLWGVPHIZHIZJIZWGVMHIZWDVPHIZJIZVSVOVMHIZLVLVPHIZHIZJIZHIZLWAVRHIZHI
      ZJIZWAWRHIZVSVRHIZJIZWRUJVSWAVOVLUKVOVLVMVPUKWDWGVMVPUKVSWAWRVRUKVSKMZWAK
      MZSVOKMZVLKMZSZSWDKMZWGKMZXFXHXGXIXKXFXHSVTKMWCKMZXKXGXISZVSVONXNLKMZWBKM
      XMULWAVLNLWBNUMVTWCUNUPUQXFXIXGXHXLXGXHSWEKMWFKMXLXFXISWAVONVSVLNWEWFUNUR
      USUTXJVMKMZVPKMZSSWRKMZVRKMZXHXPXIXQXRXHXPSWOKMWQKMZXRXIXQSZVOVMNYAXOWPKM
      XTULVLVPNLWPNUMWOWQUNUPUQXHXQXIXPXSXIXPSVNKMVQKMXSXHXQSVLVMNVOVPNVNVQUNUR
      USUTVSWOHIZVSWQHIZJIZLWAVNHIZHIZLWAVQHIZHIZJIZJIYBYFJIZYHYCJIZJIXBWKDEFYB
      YCYFYHJVSWOHOVSWQHOLYEHODGZEGZVAZYLYMFGZVBZLYGHOVCWSYDXAYIJVSWOWQPXALYEYG
      JIZHIYIWTYQLHWAVNVQPQLYEYGPRVDWHYJWJYKJWHYBLWBVMHIZHIZJIYJDEFVSLVOWBJHVMU
      ATZLKULVEZUCTZYLYMVFZYLYMYOPZWAVLHOZUETZYLYMYOVGZVHYSYFYBJYRYELHWAVLVMVGQ
      QRWJLYGVSWPHIZJIZHIZYKWIUUILHDEFWAVSVOVLJHVPUBTZYTUUBUUCUUDUDTZUFTZUUGVHQ
      UUJYHLUUHHIZJIYKLYGUUHPUUNYCYHJDEFLVSWPHUUAYTVLVPHOZUUCUUGVIQRRVDVJWAWOHI
      ZWAWQHIZJIZVSVNHIZVSVQHIZJIZJIUUPUUSJIZUUTUUQJIZJIXEWNDEFUUPUUQUUSUUTJWAW
      OHOWAWQHOVSVNHOYNYPVSVQHOVCXCUURXDUVAJWAWOWQPVSVNVQPVDWLUVBWMUVCJDEFWAVSV
      OVLJHVMUUKYTUUBUUCUUDUULUUFUUGVHWMUUTLWBVPHIZHIZJIUVCDEFVSLVOWBJHVPYTUUAU
      UBUUCUUDUUEUUMUUGVHUVEUUQUUTJUVELWAWPHIZHIUUQUVDUVFLHWAVLVPVGQDEFLWAWPHUU
      AUUKUUOUUCUUGVIRQRVDVJVK $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.  $d x y z w v u C $.
    $d x y z w v u f g h $.
    $( Distributive law for complex numbers.  Axiom 11 of 22 for real and
       complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly, nor
       should the proven axiom ~ ax-distr be used later.  Instead, use
       ~ adddi .  (Contributed by NM, 2-Sep-1995.)
       (New usage is discouraged.) $)
    axdistr $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) ) $=
      ( vf vg vh cnr cv cplr co cmr cm1r mulcnsrec wcel wa addclsr an4s mulclsr
      distrsr ovex vx vy vz vw vv vu cc caddc cep ccnv dfcnqs addcnsrec anim12i
      cmul m1r sylancr syl2an syl2anr an42s jca eqtri oveq12i addcomsr addasssr
      oveq2i caov4 ecovdi ) UAUBUCUDUEUFABCUGUHUIUJGUNUAHZUCHZUEHZIJZKJZLUBHZUD
      HZUFHZIJZKJZKJZIJZVMVKKJZVHVPKJZIJZVHVIKJZLVMVNKJZKJZIJZVHVJKJZLVMVOKJZKJ
      ZIJZIJZVMVIKJZVHVNKJZIJZVMVJKJZVHVOKJZIJZIJZVKVPWFWNWJWQUKVIVNVJVOULVHVMV
      KVPMVHVMVIVNMVHVMVJVOMWFWNWJWQULVIGNZVJGNZVNGNZVOGNZVKGNZVPGNZOWSWTOXCXAX
      BOXDVIVJPVNVOPUMQVHGNZVMGNZOZWSXAOOWFGNZWNGNZXEWSXFXAXHXEWSOWCGNWEGNZXHXF
      XAOZVHVIRXKLGNZWDGNXJUOVMVNRLWDRUPWCWEPUQQXEXAXFWSXIXFWSOWLGNWMGNXIXEXAOV
      MVIRVHVNRWLWMPURUSUTXGWTXBOOWJGNZWQGNZXEWTXFXBXMXEWTOWGGNWIGNZXMXFXBOZVHV
      JRXPXLWHGNXOUOVMVORLWHRUPWGWIPUQQXEXBXFWTXNXFWTOWOGNWPGNXNXEXBOVMVJRVHVOR
      WOWPPURUSUTVSWCWGIJZWEWIIJZIJWKVLXQVRXRIVHVIVJSVRLWDWHIJZKJXRVQXSLKVMVNVO
      SVELWDWHSVAVBDEFWCWGWEWIIVHVIKTVHVJKTLWDKTDHZEHZVCZXTYAFHVDZLWHKTVFVAWBWL
      WOIJZWMWPIJZIJWRVTYDWAYEIVMVIVJSVHVNVOSVBDEFWLWOWMWPIVMVIKTVMVJKTVHVNKTYB
      YCVHVOKTVFVAVG $.
  $}

  $( i-squared equals -1 (expressed as i-squared plus 1 is 0).  Axiom 12 of 22
     for real and complex numbers, derived from ZF set theory.  This
     construction-dependent theorem should not be referenced directly; instead,
     use ~ ax-i2m1 .  (Contributed by NM, 5-May-1996.)
     (New usage is discouraged.) $)
  axi2m1 $p |- ( ( _i x. _i ) + 1 ) = 0 $=
    ( c0r c1r cop cmul co caddc ci cm1r cplr cmr cnr wcel wceq 0r 1sr ax-mp m1r
    1idsr eqtri oveq12i c1 cc0 mulcnsr mp4an 00sr oveq2i addcomsr 0idsr opeq12i
    3eqtri oveq1i addresr mp2an m1p1sr opeq1i df-i df-1 df-0 3eqtr4i ) ABCZUTDE
    ZBACZFEZAACZGGDEZUAFEUBVCHACZVBFEZHBIEZACZVDVAVFVBFVAAAJEZHBBJEZJEZIEZBAJEZ
    ABJEZIEZCZVFAKLZBKLZVRVSVAVQMNONOABABUCUDVMHVPAVMAHIEHAIEZHVJAVLHIVRVJAMNAU
    EPVLHBJEZHVKBHJVSVKBMOBRPUFHKLZWAHMQHRPSTAHUGWBVTHMQHUHPUJVPAAIEZAVNAVOAIVS
    VNAMOBUEPVRVOAMNARPTVRWCAMNAUHPSUISUKWBVSVGVIMQOHBULUMVHAAUNUOUJVEVAUAVBFGU
    TGUTDUPUPTUQTURUS $.

  $( 1 and 0 are distinct.  Axiom 13 of 22 for real and complex numbers,
     derived from ZF set theory.  This construction-dependent theorem should
     not be referenced directly; instead, use ~ ax-1ne0 .  (Contributed by NM,
     19-Mar-1996.)  (New usage is discouraged.) $)
  ax1ne0 $p |- 1 =/= 0 $=
    ( c1 cc0 wceq c1r c0r cop 1ne0sr cnr 1sr elexi mtbir df-1 df-0 eqeq12i neir
    eqresr ) ABABCDEFZEEFZCZSDECGDEDHIJPKAQBRLMNKO $.

  ${
    $d A x y $.
    $( ` 1 ` is an identity element for real multiplication.  Axiom 14 of 22
       for real and complex numbers, derived from ZF set theory.  Weakened from
       the original axiom in the form of statement in ~ mulid1 , based on ideas
       by Eric Schmidt.  This construction-dependent theorem should not be
       referenced directly; instead, use ~ ax-1rid .  (Contributed by Scott
       Fenton, 3-Jan-2013.)  (New usage is discouraged.) $)
    ax1rid $p |- ( A e. RR -> ( A x. 1 ) = A ) $=
      ( vx vy cv cop c1 cmul co wceq cnr c0r csn cr df-r oveq1 id eqeq12d elsni
      wcel c1r df-1 oveq2i cmr 1sr mpan2 1idsr opeq1d eqtrd syl5eq opeq2 oveq1d
      mulresr syl5ibr impcom sylan2 optocl ) BDZCDZEZFGHZUSIZAFGHZAIBCAJKLZMNUS
      AIZUTVBUSAUSAFGOVDPQURVCSUQJSZURKIZVAURKRVFVEVAVEVAVFUQKEZFGHZVGIVEVHVGTK
      EZGHZVGFVIVGGUAUBVEVJUQTUCHZKEZVGVETJSVJVLIUDUQTULUEVEVKUQKUQUFUGUHUIVFUT
      VHUSVGVFUSVGFGURKUQUJZUKVMQUMUNUOUP $.
  $}

  ${
    $d x y A $.  $d x y z $.
    $( Existence of negative of real number.  Axiom 15 of 22 for real and
       complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly;
       instead, use ~ ax-rnegex .  (Contributed by NM, 15-May-1996.)
       (New usage is discouraged.) $)
    axrnegex $p |- ( A e. RR -> E. x e. RR ( A + x ) = 0 ) $=
      ( cr wcel c1st cfv cm1r cmr co c0r cop caddc cc0 wceq cv wrex cnr elreal2
      simplbi syl2anc mulclsr sylancl opelreal sylibr cplr simprbi oveq1d pn0sr
      m1r addresr opeq1d df-0 syl6eqr syl 3eqtrd oveq2 eqeq1d rspcev ) BCDZBEFZ
      GHIZJKZCDZBVBLIZMNZBAOZLIZMNZACPUSVAQDZVCUSUTQDZGQDVIUSVJBUTJKZNZBRZSZUIU
      TGUAUBZVAUCUDUSVDVKVBLIZUTVAUEIZJKZMUSBVKVBLUSVJVLVMUFUGUSVJVIVPVRNVNVOUT
      VAUJTUSVJVRMNVNVJVRJJKMVJVQJJUTUHUKULUMUNUOVHVEAVBCVFVBNVGVDMVFVBBLUPUQUR
      T $.
  $}

  ${
    $d x y A $.  $d x y z $.
    $( Existence of reciprocal of nonzero real number.  Axiom 16 of 22 for real
       and complex numbers, derived from ZF set theory.  This
       construction-dependent theorem should not be referenced directly;
       instead, use ~ ax-rrecex .  (Contributed by NM, 15-May-1996.)
       (New usage is discouraged.) $)
    axrrecex $p |- ( ( A e. RR /\ A =/= 0 ) -> E. x e. RR ( A x. x ) = 1 ) $=
      ( vy vz cr wcel cc0 wne cv cmul co c1 wceq wrex c0r cop cnr bitri eqeq1d
      wa wi wex elreal df-rex neeq1 oveq1 rexbidv imbi12d df-0 eqeq2i necon3bii
      vex eqresr cmr recexsr ex opelreal anbi1i mulresr df-1 ovex syl6bb syl5bb
      c1r pm5.32da oveq2 rspcev syl6bir exp3a rexlimdv syld syl5bi gencl imp )
      BEFZBGHZBAIZJKZLMZAENZCIZOPZGHZWBVQJKZLMZAENZUAVPVTUAWAQFZVOCWBBVOWBBMZCQ
      NWGWHTCUBCBUCWHCQUDRWHWCVPWFVTWBBGUEWHWEVSAEWHWDVRLWBBVQJUFSUGUHWCWAOHZWG
      WFWBGWAOWBGMWBOOPZMWAOMGWJWBUIUJWAOCULUMRUKWGWIWADIZUNKZVDMZDQNZWFWGWIWND
      WAUOUPWGWMWFDQWGWKQFZWMWFWGWOWMTZWKOPZEFZWBWQJKZLMZTZWFXAWOWTTWGWPWRWOWTW
      KUQURWGWOWTWMWGWOTZWTWLOPZLMZWMXBWSXCLWAWKUSSXDXCVDOPZMWMLXEXCUTUJWLVDWAW
      KUNVAUMRVBVEVCWEWTAWQEVQWQMWDWSLVQWQWBJVFSVGVHVIVJVKVLVMVN $.
  $}

  ${
    $d x y z w A $.
    $( A complex number can be expressed in terms of two reals.  Definition
       10-1.1(v) of [Gleason] p. 130.  Axiom 17 of 22 for real and complex
       numbers, derived from ZF set theory.  This construction-dependent
       theorem should not be referenced directly; instead, use ~ ax-cnre .
       (Contributed by NM, 13-May-1996.)  (New usage is discouraged.) $)
    axcnre $p |- ( A e. CC ->
                      E. x e. RR E. y e. RR A = ( x + ( _i x. y ) ) ) $=
      ( cv cop cmul co caddc wceq cr cnr wcel wa c0r cplr c1r cmr cm1r syl5eq
      0r vz vw ci wrex cc df-c eqeq1 2rexbidv wex opelreal anbi12i biimpri df-i
      oveq1i 1sr mulcnsr mpanl12 mpan2 mulcomsr oveq1d ax-mp oveq2i eqtri 0idsr
      00sr m1r syl6eq 1idsr eqtrd opeq12d oveq2d adantl addcnsr mpanl2 addcomsr
      mpanr1 opeq12 syl2an 3eqtrrd eleq1 bi2anan9 oveq1 sylan9eq eqeq2d anbi12d
      opex oveq2 spc2ev syl2anc r2ex sylibr optocl ) UADZUBDZEZADZUCBDZFGZHGZIZ
      BJUDAJUDZCWSIZBJUDAJUDUAUBCKKUEUFWOCIWTXBABJJWOCWSUGUHWMKLZWNKLZMZWPJLZWQ
      JLZMZWTMZBUIAUIZXAXEWMNEZJLZWNNEZJLZMZWOXKUCXMFGZHGZIZXJXOXEXLXCXNXDWMUJW
      NUJUKULXEXQXKNWNEZHGZWMNOGZNWNOGZEZWOXDXQXTIXCXDXPXSXKHXDXPNPEZXMFGZXSUCY
      DXMFUMUNXDYENWNQGZRPNQGZQGZOGZPWNQGZNNQGZOGZEZXSXDNKLZYEYMIZTYNPKLZXDYNMY
      OTUONPWNNUPUQURXDYINYLWNXDYINYHOGZNXDYFNYHOXDYFWNNQGNNWNUSWNVESUTYQNNOGZN
      YHNNOYHRNQGZNYGNRQYPYGNIUOPVEVAVBRKLYSNIVFRVEVAVCVBYNYRNITNVDVAVCVGXDYLWN
      YKOGZWNXDYJWNYKOXDYJWNPQGWNPWNUSWNVHSUTXDYTWNNOGZWNYKNWNOYNYKNITNVEVAVBWN
      VDZSVIVJVISVKVLXCYNXDXTYCIZTXCYNYNXDMUUCTWMNNWNVMVNVPXCYAWMIYBWNIYCWOIXDW
      MVDXDYBUUAWNNWNVOUUBSYAYBWMWNVQVRVSXIXOXRMABXKXMWMNWFWNNWFWPXKIZWQXMIZMZX
      HXOWTXRUUDXFXLUUEXGXNWPXKJVTWQXMJVTWAUUFWSXQWOUUDUUEWSXKWRHGXQWPXKWRHWBUU
      EWRXPXKHWQXMUCFWGVKWCWDWEWHWIWTABJJWJWKWL $.
  $}

  ${
    $d x y A $.  $d y B $.
    $( Ordering on reals satisfies strict trichotomy.  Axiom 18 of 22 for real
       and complex numbers, derived from ZF set theory.  Note:  The more
       general version for extended reals is ~ axlttri .  This
       construction-dependent theorem should not be referenced directly;
       instead, use ~ ax-pre-lttri .  (Contributed by NM, 19-May-1996.)
       (Revised by Mario Carneiro, 16-Jun-2013.)
       (New usage is discouraged.) $)
    axpre-lttri $p |- ( ( A e. RR /\ B e. RR ) ->
                  ( A <RR B <-> -. ( A = B \/ B <RR A ) ) ) $=
      ( vx vy cv c0r cop cltrr wbr wceq wo wn wb cnr elreal breq1 breq2 orbi12d
      notbid cltr cr eqeq1 bibi12d eqeq2 wcel wor ltsosr sotric mpan ltresr vex
      wa eqresr orbi12i notbii 3bitr4g 2gencl ) CEZFGZDEZFGZHIZUSVAJZVAUSHIZKZL
      ZMAVAHIZAVAJZVAAHIZKZLZMABHIZABJZBAHIZKZLZMCDUSVAABNUACAODBOUSAJZVBVGVFVK
      USAVAHPVQVEVJVQVCVHVDVIUSAVAUBUSAVAHQRSUCVABJZVGVLVKVPVABAHQVRVJVOVRVHVMV
      IVNVABAUDVABAHPRSUCURNUEUTNUEULZURUTTIZURUTJZUTURTIZKZLZVBVFNTUFVSVTWDMUG
      NURUTTUHUIURUTUJVEWCVCWAVDWBURUTCUKUMUTURUJUNUOUPUQ $.

  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.
    $( Ordering on reals is transitive.  Axiom 19 of 22 for real and complex
       numbers, derived from ZF set theory.  Note:  The more general version
       for extended reals is ~ axlttrn .  This construction-dependent theorem
       should not be referenced directly; instead, use ~ ax-pre-lttrn .
       (Contributed by NM, 19-May-1996.)  (Revised by Mario Carneiro,
       16-Jun-2013.)  (New usage is discouraged.) $)
    axpre-lttrn $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( ( A <RR B /\ B <RR C ) -> A <RR C ) ) $=
      ( vx vy vz cv c0r cop cltrr wbr wa cnr elreal wceq breq1 breq2 wcel cltr
      wi anbi1d imbi12d anbi12d imbi1d anbi2d w3a ltresr ltsosr ltrelsr syl2anb
      cr sotri sylibr a1i 3gencl ) DGZHIZEGZHIZJKZUSFGZHIZJKZLZUQVBJKZTZAUSJKZV
      CLZAVBJKZTABJKZBVBJKZLZVITVJBCJKZLZACJKZTDEFUQUSVBAMUKBCDANEBNFCNUQAOZVDV
      HVEVIVPUTVGVCUQAUSJPUAUQAVBJPUBUSBOZVHVLVIVQVGVJVCVKUSBAJQUSBVBJPUCUDVBCO
      ZVLVNVIVOVRVKVMVJVBCBJQUEVBCAJQUBVFUPMRURMRVAMRUFVDUPVASKZVEUTUPURSKURVAS
      KVSVCUPURUGURVAUGUPURVASMUHUIULUJUPVAUGUMUNUO $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Ordering property of addition on reals.  Axiom 20 of 22 for real and
       complex numbers, derived from ZF set theory.  Note:  The more general
       version for extended reals is ~ axltadd .  This construction-dependent
       theorem should not be referenced directly; instead, use
       ~ ax-pre-ltadd .  (Contributed by NM, 11-May-1996.)
       (New usage is discouraged.) $)
    axpre-ltadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( A <RR B -> ( C + A ) <RR ( C + B ) ) ) $=
      ( vx vy vz cr wcel cltrr wbr caddc co cv c0r cop wb cnr elreal wceq wa
      w3a breq1 oveq2 breq1d bibi12d breq2 breq2d oveq1 breq12d cltr cplr ltasr
      bibi2d adantr ltresr addresr breqan12d anandis syl6bb ancoms 3impa 3gencl
      a1i 3bitr4d biimpd ) AGHBGHCGHUAABIJZCAKLZCBKLZIJZDMZNOZEMZNOZIJZFMZNOZVK
      KLZVPVMKLZIJZPZAVMIJZVPAKLZVRIJZPVFWBVPBKLZIJZPVFVIPDEFVKVMVPAQGBCDAREBRF
      CRVKASZVNWAVSWCVKAVMIUBWFVQWBVRIVKAVPKUCUDUEVMBSZWAVFWCWEVMBAIUFWGVRWDWBI
      VMBVPKUCUGUEVPCSZWEVIVFWHWBVGWDVHIVPCAKUHVPCBKUHUIUMVJQHZVLQHZVOQHZVTWKWI
      WJTZVTWKWLTZVJVLUJJZVOVJUKLZVOVLUKLZUJJZVNVSWKWNWQPWLVJVLVOULUNVNWNPWMVJV
      LUOVCWMVSWONOZWPNOZIJZWQWKWIWJVSWTPWKWITWKWJTVQWRVRWSIVOVJUPVOVLUPUQURWOW
      PUOUSVDUTVAVBVE $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The product of two positive reals is positive.  Axiom 21 of 22 for real
       and complex numbers, derived from ZF set theory.  Note:  The more
       general version for extended reals is ~ axmulgt0 .  This
       construction-dependent theorem should not be referenced directly;
       instead, use ~ ax-pre-mulgt0 .  (Contributed by NM, 13-May-1996.)
       (New usage is discouraged.) $)
    axpre-mulgt0 $p |- ( ( A e. RR /\ B e. RR ) ->
                  ( ( 0 <RR A /\ 0 <RR B ) -> 0 <RR ( A x. B ) ) ) $=
      ( vx vy cc0 cv c0r cop cltrr wbr wa cmul cnr elreal wceq cltr df-0 ltresr
      co wi cr breq2 anbi1d oveq1 breq2d imbi12d anbi2d oveq2 wcel breq1i bitri
      cmr mulgt0sr syl2anb a1i mulresr breq12d syl6bb syl5ibr 2gencl ) ECFZGHZI
      JZEDFZGHZIJZKZEVBVELSZIJZTEAIJZVFKZEAVELSZIJZTVJEBIJZKZEABLSZIJZTCDVBVEAB
      MUACANDBNVBAOZVGVKVIVMVRVCVJVFVBAEIUBUCVRVHVLEIVBAVELUDUEUFVEBOZVKVOVMVQV
      SVFVNVJVEBEIUBUGVSVLVPEIVEBALUHUEUFVGVIVAMUIVDMUIKZGVAVDULSZPJZVCGVAPJZGV
      DPJZWBVFVCGGHZVBIJWCEWEVBIQUJGVARUKVFWEVEIJWDEWEVEIQUJGVDRUKVAVDUMUNVTVIW
      EWAGHZIJWBVTEWEVHWFIEWEOVTQUOVAVDUPUQGWARURUSUT $.
  $}

  ${
    $d x y z w v u A $.  $d x y z B $.
    $( A non-empty, bounded-above set of reals has a supremum.  Axiom 22 of 22
       for real and complex numbers, derived from ZF set theory.  Note:  The
       more general version with ordering on extended reals is ~ axsup .  This
       construction-dependent theorem should not be referenced directly;
       instead, use ~ ax-pre-sup .  (Contributed by NM, 19-May-1996.)  (Revised
       by Mario Carneiro, 16-Jun-2013.)  (New usage is discouraged.) $)
    axpre-sup $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR
                    A. y e. A y <RR x ) -> E. x e. RR ( A. y e. A -. x <RR y /\
                    A. y e. RR ( y <RR x -> E. z e. A y <RR z ) ) ) $=
      ( vw vv vu cr cltrr wbr wral wrex wi wa cltr c1st cnr wcel wceq cvv c0 cv
      wss wne wn cfv c0r cop elreal2 simplbi adantl wfn wb wfo wf fo1st fof ffn
      cima mp2b fvelimab mp2an r19.29 ssel2 ltresr2 breq1 sylan9bb biimpd exp31
      ssv imp4b ancomsd an32s rexlimdva syl5 exp3a syl7bi impr adantlr ralrimiv
      syl expr breq2 ralbidv rspcev ee12an wex n0 fnfvima mp3an12 exlimiv sylbi
      ne0i notbid rspccv syl5com simprbi breq2d ltresr syl6bb sylibrd ralrimdva
      supsr ex ad2antrr breq1d rexbidv imbi12d com3l sylbid adantr sylan2 com4r
      exbiri imp reximdvai syl5bi expcom com23 rexlimdv syl6d ralrimdv opelreal
      biimpri imbi1d anbi12d syl2and 3syld 3impia ) DHUCZDUAUDZBUBZAUBZIJZBDKZA
      HLZYMYLIJZUEZBDKZYNYLCUBZIJZCDLZMZBHKZNZAHLZYJYKNZYPEUBZFUBZOJZEPDUSZKZFQ
      LZUUIUUHOJZUEZEUUKKZUUJUUHGUBZOJZGUUKLZMZEQKZNZFQLZUUFUUGYOUUMAHUUGYMHRZN
      YMPUFZQRZYOUUHUVEOJZEUUKKZUUMUVDUVFUUGUVDUVFYMUVEUGUHSYMUIUJUKUUGUVDYOUVH
      UUGUVDYONZNUVGEUUKYJUVIUUHUUKRZUVGMZYKYJUVDYOUVKUVJYLPUFZUUHSZBDLZYJUVDNZ
      YOUVGPTULZDTUCZUVJUVNUMTTPUNTTPUOUVPUPTTPUQTTPURUTZDVJZBTDUUHPVAVBUVOYOUV
      NUVGYOUVNNYNUVMNZBDLUVOUVGYNUVMBDVCUVOUVTUVGBDYJYLDRZUVDUVTUVGMYJUWANZUVD
      NUVMYNUVGUWBUVDUVMYNUVGUWBYLHRZUVDUVMYNUVGMZMMDHYLVDZUWCUVDUVMUWDUWCUVDNZ
      UVMNYNUVGUWFYNUVLUVEOJUVMUVGYLYMVEUVLUUHUVEOVFVGVHVIWAVKVLVMVNVOVPVQVRVSV
      TWBUULUVHFUVEQUUIUVESUUJUVGEUUKUUIUVEUUHOWCWDWEWFVNYKUUMUVCMZYJYKUUKUAUDZ
      UWGYKUWABWGUWHBDWHUWAUWHBUWAUVLUUKRZUWHUVPUVQUWAUWIUVRUVSTDPYLWIWJZUUKUVL
      WMWAWKWLUWHUUMUVCFEGUUKXCXDWAUKUUGUVBUUFFQUUGUUIQRZNZUUPUUIUGUHZYLIJZUEZB
      DKZUVAYLUWMIJZUUBMZBHKZUUFYJUUPUWPMYKUWKYJUUPUWOBDUWBUUPUUIUVLOJZUEZUWOUW
      AUUPUXAMYJUWAUWIUUPUXAUWJUUOUXAEUVLUUKUUHUVLSZUUNUWTUUHUVLUUIOWCWNWOWPUKU
      WBUWNUWTUWBUWCUWNUWTUMUWEUWCUWNUWMUVLUGUHZIJUWTUWCYLUXCUWMIUWCUVLQRZYLUXC
      SZYLUIZWQZWRUUIUVLWSWTWAWNXAXBXEUWLUVAUWRBHYJUVAUWCUWRMMYKUWKUWCYJUVAUWRU
      WCYJUVAUWRMUWCYJNZUWQUVAUUBUXHUWQUVAUVLUUQOJZGUUKLZUUBUWCUWQUVAUXJMZMYJUW
      CUWQUVLUUIOJZUXKUWCUWQUXCUWMIJUXLUWCYLUXCUWMIUXGXFUVLUUIWSWTUVAUWCUXLUXJU
      WCUXDUVAUXLUXJMZUWCUXDUXEUXFUJUUTUXMEUVLQUXBUUJUXLUUSUXJUUHUVLUUIOVFUXBUU
      RUXIGUUKUUHUVLUUQOVFXGXHWOVOXIXJXKUXHUXIUUBGUUKUXHUXIUUQUUKRZUUBUXIUXHUXN
      UUBMUXNYTPUFZUUQSZCDLZUXIUXHNZUUBUVPUVQUXNUXQUMUVRUVSCTDUUQPVAVBUXRUXPUUA
      CDUXIUXHYTDRZUXPUUAMMUXHUXSUXPUXIUUAUWCYJUXSUXPUXIUUAMMUWCYJUXSNZNZUXPUUA
      UXIUYAUUAUVLUXOOJZUXPUXIUXTUWCYTHRUUAUYBUMDHYTVDYLYTVEXLUXOUUQUVLOWCVGXNW
      BXMXOXPXQXRXSXTYAXSXDXIXEYBUWLUWMHRZUWPUWSNZUUFMUWKUYCUUGUYCUWKUUIYCYDUKU
      YCUYDUUFUUEUYDAUWMHYMUWMSZYSUWPUUDUWSUYEYRUWOBDUYEYQUWNYMUWMYLIVFWNWDUYEU
      UCUWRBHUYEYNUWQUUBYMUWMYLIWCYEWDYFWEXDWAYGVNYHYI $.
  $}

  ${
    wuncn.1 $e |- ( ph -> U e. WUni ) $.
    wuncn.2 $e |- ( ph -> om e. U ) $.
    $( A weak universe containing ` om ` contains the complex number
       construction.  This theorem is construction-dependent in the literal
       sense, but will also be satisfied by any other reasonable implementation
       of the complex numbers.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    wuncn $p |- ( ph -> CC e. U ) $=
      ( vx cnr cxp cnp cer cpw cnq com syl5eqel wunxp wss ssriv a1i wunss wunpw
      cnpi cc df-c cqs df-nr c0 csn cdif df-ni wundif elpqn wcel prpssnq pssssd
      cv vex elpw sylibr wer enrer qsss ) AUAFFGBUBAFFBCAFHHGZIUCZBUDAVAJVBBCAV
      ABCAHHBCAKJZHBCAKBCATTGZKBCATTBCATLUEUFZUGBUHALVEBCDUIMZVFNKVDOAEKVDEUNZU
      JPQRSHVCOAEHVCVGHUKZVGKOVGVCUKVHVGKVGULUMVGKEUOUPUQPQRZVINSAVAIVAIURAUSQU
      TRMZVJNM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Real and complex number postulates restated as axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The complex numbers form a set.  This axiom is redundant - see ~ cnexALT -
     but we provide this axiom because the justification theorem ~ axcnex does
     not use ~ ax-rep even though the redundancy proof does.  Proofs should
     normally use ~ cnex instead.  (New usage is discouraged.)  (Contributed by
     NM, 1-Mar-1995.) $)
  ax-cnex $a |- CC e. _V $.

  $( The real numbers are a subset of the complex numbers.  Axiom 1 of 22 for
     real and complex numbers, justified by theorem ~ axresscn .  (Contributed
     by NM, 1-Mar-1995.) $)
  ax-resscn $a |- RR C_ CC $.

  $( 1 is a complex number.  Axiom 2 of 22 for real and complex numbers,
     justified by theorem ~ ax1cn .  (Contributed by NM, 1-Mar-1995.) $)
  ax-1cn $a |- 1 e. CC $.

  $( ` _i ` is a complex number.  Axiom 3 of 22 for real and complex numbers,
     justified by theorem ~ axicn .  (Contributed by NM, 1-Mar-1995.) $)
  ax-icn $a |- _i e. CC $.

  $( Closure law for addition of complex numbers.  Axiom 4 of 22 for real and
     complex numbers, justified by theorem ~ axaddcl .  Proofs should normally
     use ~ addcl instead, which asserts the same thing but follows our naming
     conventions for closures.  (New usage is discouraged.)  (Contributed by
     NM, 22-Nov-1994.) $)
  ax-addcl $a |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) e. CC ) $.

  $( Closure law for addition in the real subfield of complex numbers.  Axiom 6
     of 23 for real and complex numbers, justified by theorem ~ axaddrcl .
     Proofs should normally use ~ readdcl instead.
     (New usage is discouraged.)  (Contributed by NM, 22-Nov-1994.) $)
  ax-addrcl $a |- ( ( A e. RR /\ B e. RR ) -> ( A + B ) e. RR ) $.

  $( Closure law for multiplication of complex numbers.  Axiom 6 of 22 for real
     and complex numbers, justified by theorem ~ axmulcl .  Proofs should
     normally use ~ mulcl instead.  (New usage is discouraged.)  (Contributed
     by NM, 22-Nov-1994.) $)
  ax-mulcl $a |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) e. CC ) $.

  $( Closure law for multiplication in the real subfield of complex numbers.
     Axiom 7 of 22 for real and complex numbers, justified by theorem
     ~ axmulrcl .  Proofs should normally use ~ remulcl instead.
     (New usage is discouraged.)  (Contributed by NM, 22-Nov-1994.) $)
  ax-mulrcl $a |- ( ( A e. RR /\ B e. RR ) -> ( A x. B ) e. RR ) $.

  $( Multiplication of complex numbers is commutative.  Axiom 8 of 22 for real
     and complex numbers, justified by theorem ~ axmulcom .  Proofs should
     normally use ~ mulcom instead.  (New usage is discouraged.)  (Contributed
     by NM, 22-Nov-1994.) $)
  ax-mulcom $a |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) = ( B x. A ) ) $.

  $( Addition of complex numbers is associative.  Axiom 9 of 22 for real and
     complex numbers, justified by theorem ~ axaddass .  Proofs should normally
     use ~ addass instead.  (New usage is discouraged.)  (Contributed by NM,
     22-Nov-1994.) $)
  ax-addass $a |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A + B ) + C ) = ( A + ( B + C ) ) ) $.

  $( Multiplication of complex numbers is associative.  Axiom 10 of 22 for real
     and complex numbers, justified by theorem ~ axmulass .  Proofs should
     normally use ~ mulass instead.  (New usage is discouraged.)  (Contributed
     by NM, 22-Nov-1994.) $)
  ax-mulass $a |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) ) $.

  $( Distributive law for complex numbers.  Axiom 11 of 22 for real and complex
     numbers, justified by theorem ~ axdistr .  Proofs should normally use
     ~ adddi instead.  (New usage is discouraged.)  (Contributed by NM,
     22-Nov-1994.) $)
  ax-distr $a |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
              ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) ) $.

  $( i-squared equals -1 (expressed as i-squared plus 1 is 0).  Axiom 12 of 22
     for real and complex numbers, justified by theorem ~ axi2m1 .
     (Contributed by NM, 29-Jan-1995.) $)
  ax-i2m1 $a |- ( ( _i x. _i ) + 1 ) = 0 $.

  $( 1 and 0 are distinct.  Axiom 13 of 22 for real and complex numbers,
     justified by theorem ~ ax1ne0 .  (Contributed by NM, 29-Jan-1995.) $)
  ax-1ne0 $a |- 1 =/= 0 $.

  $( ` 1 ` is an identity element for real multiplication.  Axiom 14 of 22 for
     real and complex numbers, justified by theorem ~ ax1rid .  Weakened from
     the original axiom in the form of statement in ~ mulid1 , based on ideas
     by Eric Schmidt.  (Contributed by NM, 29-Jan-1995.) $)
  ax-1rid $a |- ( A e. RR -> ( A x. 1 ) = A ) $.

  ${
    $d x A $.
    $( Existence of negative of real number.  Axiom 15 of 22 for real and
       complex numbers, justified by theorem ~ axrnegex .  (Contributed by Eric
       Schmidt, 21-May-2007.) $)
    ax-rnegex $a |- ( A e. RR -> E. x e. RR ( A + x ) = 0 ) $.

    $( Existence of reciprocal of nonzero real number.  Axiom 16 of 22 for real
       and complex numbers, justified by theorem ~ axrrecex .  (Contributed by
       Eric Schmidt, 11-Apr-2007.) $)
    ax-rrecex $a |- ( ( A e. RR /\ A =/= 0 ) -> E. x e. RR ( A x. x ) = 1 ) $.
  $}

  ${
    $d x y A $.
    $( A complex number can be expressed in terms of two reals.  Definition
       10-1.1(v) of [Gleason] p. 130.  Axiom 17 of 22 for real and complex
       numbers, justified by theorem ~ axcnre .  For naming consistency, use
       ~ cnre for new proofs.  (New usage is discouraged.)  (Contributed by NM,
       9-May-1999.) $)
    ax-cnre $a |- ( A e. CC ->
                      E. x e. RR E. y e. RR A = ( x + ( _i x. y ) ) ) $.
  $}

  $( Ordering on reals satisfies strict trichotomy.  Axiom 18 of 22 for real
     and complex numbers, justified by theorem ~ axpre-lttri .  Note:  The more
     general version for extended reals is ~ axlttri .  Normally new proofs
     would use ~ xrlttri .  (New usage is discouraged.)  (Contributed by NM,
     13-Oct-2005.) $)
  ax-pre-lttri $a |- ( ( A e. RR /\ B e. RR ) ->
                ( A <RR B <-> -. ( A = B \/ B <RR A ) ) ) $.

  $( Ordering on reals is transitive.  Axiom 19 of 22 for real and complex
     numbers, justified by theorem ~ axpre-lttrn .  Note:  The more general
     version for extended reals is ~ axlttrn .  Normally new proofs would use
     ~ lttr .  (New usage is discouraged.)  (Contributed by NM,
     13-Oct-2005.) $)
  ax-pre-lttrn $a |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A <RR B /\ B <RR C ) -> A <RR C ) ) $.

  $( Ordering property of addition on reals.  Axiom 20 of 22 for real and
     complex numbers, justified by theorem ~ axpre-ltadd .  Normally new proofs
     would use ~ axltadd .  (New usage is discouraged.)  (Contributed by NM,
     13-Oct-2005.) $)
  ax-pre-ltadd $a |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <RR B -> ( C + A ) <RR ( C + B ) ) ) $.

  $( The product of two positive reals is positive.  Axiom 21 of 22 for real
     and complex numbers, justified by theorem ~ axpre-mulgt0 .  Normally new
     proofs would use ~ axmulgt0 .  (New usage is discouraged.)  (Contributed
     by NM, 13-Oct-2005.) $)
  ax-pre-mulgt0 $a |- ( ( A e. RR /\ B e. RR ) ->
                ( ( 0 <RR A /\ 0 <RR B ) -> 0 <RR ( A x. B ) ) ) $.

  ${
    $d x y z A $.
    $( A non-empty, bounded-above set of reals has a supremum.  Axiom 22 of 22
       for real and complex numbers, justified by theorem ~ axpre-sup .  Note:
       Normally new proofs would use ~ axsup .  (New usage is discouraged.)
       (Contributed by NM, 13-Oct-2005.) $)
    ax-pre-sup $a |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR
                    A. y e. A y <RR x ) -> E. x e. RR ( A. y e. A -. x <RR y /\
                    A. y e. RR ( y <RR x -> E. z e. A y <RR z ) ) ) $.
  $}

  $( Addition is an operation on the complex numbers.  This deprecated axiom is
     provided for historical compatibility but is not a bona fide axiom for
     complex numbers (independent of set theory) since it cannot be interpreted
     as a first- or second-order statement (see
     ~ http://us.metamath.org/downloads/schmidt-cnaxioms.pdf ). .  It may be
     deleted in the future and should be avoided for new theorems.  Instead,
     the less specific ~ addcl should be used.  Note that uses of ~ ax-addf can
     be eliminated by using the defined operation
     ` ( x e. CC , y e. CC |-> ( x + y ) ) ` in place of ` + ` , from which
     this axiom (with the defined operation in place of ` + ` ) follows as a
     theorem.

     This axiom is justified by theorem ~ axaddf .
     (New usage is discouraged.)  (Contributed by NM, 19-Oct-2004.) $)
  ax-addf $a |- + : ( CC X. CC ) --> CC $.

  $( Multiplication is an operation on the complex numbers.  This deprecated
     axiom is provided for historical compatibility but is not a bona fide
     axiom for complex numbers (independent of set theory) since it cannot be
     interpreted as a first- or second-order statement (see
     ~ http://us.metamath.org/downloads/schmidt-cnaxioms.pdf ). .  It may be
     deleted in the future and should be avoided for new theorems.  Instead,
     the less specific ~ ax-mulcl should be used.  Note that uses of ~ ax-mulf
     can be eliminated by using the defined operation
     ` ( x e. CC , y e. CC |-> ( x x. y ) ) ` in place of ` x. ` , from which
     this axiom (with the defined operation in place of ` x. ` ) follows as a
     theorem.

     This axiom is justified by theorem ~ axmulf .
     (New usage is discouraged.)  (Contributed by NM, 19-Oct-2004.) $)
  ax-mulf $a |- x. : ( CC X. CC ) --> CC $.


$( --old location  <- (suppresses following header from Statement List)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                       Real and complex numbers
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$( Use set.mm as our foundation. $)
$( $[ set.mm $] $)

$( Include your favorite construction of reals here. $)
$( $[ dedekind.mm $] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Derive the basic properties from the field axioms
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Some deductions from the field axioms for complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Alias for ~ ax-cnex .  See also ~ cnexALT .  (Contributed by Mario
     Carneiro, 17-Nov-2014.) $)
  cnex $p |- CC e. _V $=
    ( ax-cnex ) A $.

  $( Alias for ~ ax-addcl , for naming consistency with ~ addcli .  Use this
     theorem instead of ~ ax-addcl or ~ axaddcl .  (Contributed by NM,
     10-Mar-2008.) $)
  addcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) e. CC ) $=
    ( ax-addcl ) ABC $.

  $( Alias for ~ ax-addrcl , for naming consistency with ~ readdcli .
     (Contributed by NM, 10-Mar-2008.) $)
  readdcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A + B ) e. RR ) $=
    ( ax-addrcl ) ABC $.

  $( Alias for ~ ax-mulcl , for naming consistency with ~ mulcli .
     (Contributed by NM, 10-Mar-2008.) $)
  mulcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) e. CC ) $=
    ( ax-mulcl ) ABC $.

  $( Alias for ~ ax-mulrcl , for naming consistency with ~ remulcli .
     (Contributed by NM, 10-Mar-2008.) $)
  remulcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A x. B ) e. RR ) $=
    ( ax-mulrcl ) ABC $.

  $( Alias for ~ ax-mulcom , for naming consistency with ~ mulcomi .
     (Contributed by NM, 10-Mar-2008.) $)
  mulcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A x. B ) = ( B x. A ) ) $=
    ( ax-mulcom ) ABC $.

  $( Alias for ~ ax-addass , for naming consistency with ~ addassi .
     (Contributed by NM, 10-Mar-2008.) $)
  addass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A + B ) + C ) = ( A + ( B + C ) ) ) $=
    ( ax-addass ) ABCD $.

  $( Alias for ~ ax-mulass , for naming consistency with ~ mulassi .
     (Contributed by NM, 10-Mar-2008.) $)
  mulass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) ) $=
    ( ax-mulass ) ABCD $.

  $( Alias for ~ ax-distr , for naming consistency with ~ adddii .
     (Contributed by NM, 10-Mar-2008.) $)
  adddi $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) ) $=
    ( ax-distr ) ABCD $.

  $( A real number is a complex number.  (Contributed by NM, 10-Aug-1999.) $)
  recn $p |- ( A e. RR -> A e. CC ) $=
    ( cr cc ax-resscn sseli ) BCADE $.

  $( The real numbers form a set.  See also ~ reexALT .  (Contributed by Mario
     Carneiro, 17-Nov-2014.) $)
  reex $p |- RR e. _V $=
    ( cr cc cnex ax-resscn ssexi ) ABCDE $.

  $( Hypothesis for weak deduction theorem to eliminate ` A =/= 0 ` .
     (Contributed by NM, 15-May-1999.) $)
  elimne0 $p |- if ( A =/= 0 , A , 1 ) =/= 0 $=
    ( cc0 wne c1 cif neeq1 ax-1ne0 elimhyp ) ABCZIADEZBCDBCADAJBFDJBFGH $.

  $( Distributive law for complex numbers.  (Contributed by NM,
     10-Oct-2004.) $)
  adddir $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
              ( ( A + B ) x. C ) = ( ( A x. C ) + ( B x. C ) ) ) $=
    ( cc wcel w3a caddc co cmul adddi 3coml wa addcl mulcom sylan 3impa 3adant2
    wceq 3adant1 oveq12d 3eqtr4d ) ADEZBDEZCDEZFZCABGHZIHZCAIHZCBIHZGHZUFCIHZAC
    IHZBCIHZGHUDUBUCUGUJRCABJKUBUCUDUKUGRZUBUCLUFDEUDUNABMUFCNOPUEULUHUMUIGUBUD
    ULUHRUCACNQUCUDUMUIRUBBCNSTUA $.

  $( 0 is a complex number.  See also ~ 0cnALT .  (Contributed by NM,
     19-Feb-2005.) $)
  0cn $p |- 0 e. CC $=
    ( ci cmul co c1 caddc cc0 cc ax-i2m1 wcel ax-icn mulcl mp2an addcl eqeltrri
    ax-1cn ) AABCZDECZFGHPGIZDGIQGIAGIZSRJJAAKLOPDMLN $.

  $( 0 is a set.  Common special case.  (Contributed by David A. Wheeler,
     7-Jul-2016.) $)
  c0ex $p |- 0 e. _V $=
    ( cc0 cc 0cn elexi ) ABCD $.

  $( 1 is a set.  Common special case.  (Contributed by David A. Wheeler,
     7-Jul-2016.) $)
  1ex $p |- 1 e. _V $=
    ( c1 cc ax-1cn elexi ) ABCD $.

  ${
    $d A x y $.
    $( Alias for ~ ax-cnre , for naming consistency.  (Contributed by Mario
       Carneiro, 3-Jan-2013.) $)
    cnre $p |- ( A e. CC -> E. x e. RR E. y e. RR A = ( x + ( _i x. y ) ) ) $=
      ( ax-cnre ) ABCD $.
  $}

  ${
    $d A x y $.
    $( ` 1 ` is an identity element for multiplication.  Based on ideas by Eric
       Schmidt.  (Contributed by Scott Fenton, 3-Jan-2013.) $)
    mulid1 $p |- ( A e. CC -> ( A x. 1 ) = A ) $=
      ( vx vy cc wcel cv ci cmul co caddc wceq cr wrex c1 ax-icn ax-1cn ax-1rid
      recn syl eqtrd cnre wa sylancr adddir mp3an3 syl2an mulass mp3an13 oveq2d
      mulcl oveqan12d oveq1 id eqeq12d syl5ibrcom rexlimivv ) ADEABFZGCFZHIZJIZ
      KZCLMBLMANHIZAKZBCAUAVAVCBCLLUQLEZURLEZUBZVCVAUTNHIZUTKVFVGUQNHIZUSNHIZJI
      ZUTVDUQDEZUSDEZVGVJKZVEUQRVEGDEZURDEZVLOURRZGURUJUCVKVLNDEZVMPUQUSNUDUEUF
      VDVEVHUQVIUSJUQQVEVIGURNHIZHIZUSVEVOVIVSKZVPVNVOVQVTOPGURNUGUHSVEVRURGHUR
      QUITUKTVAVBVGAUTAUTNHULVAUMUNUOUPS $.
  $}

  $( Identity law for multiplication.  Note: see ~ mulid1 for commuted
     version.  (Contributed by NM, 8-Oct-1999.) $)
  mulid2 $p |- ( A e. CC -> ( 1 x. A ) = A ) $=
    ( cc wcel c1 cmul co wceq ax-1cn mulcom mpan mulid1 eqtrd ) ABCZDAEFZADEFZA
    DBCMNOGHDAIJAKL $.

  ${
    $d A a b c d x y z $.

    $( ` 1 ` is a real number.  This used to be one of our postulates for
       complex numbers, but Eric Schmidt discovered that it could be derived
       from a weaker postulate, ~ ax-1cn , by exploiting properties of the
       imaginary unit ` _i ` .  (Contributed by Eric Schmidt, 11-Apr-2007.)
       (Revised by Scott Fenton, 3-Jan-2013.) $)
    1re $p |- 1 e. RR $=
      ( vx vy vz va vb vc vd cv wne cr wrex cc0 c1 wcel cmul co wceq neeq1 wa
      wi ci caddc ax-1ne0 cc ax-1cn ax-mp biimpcd 0cn neeq2 reximdv syl6mpi mpi
      cnre wo wn ioran df-ne con2bii anbi12i bitr4i id oveq2 oveqan12d necon1ai
      sylbi rspc2ev ad2ant2r ad2ant2l jaod syl5 rexlimdvva rexlimivv mp2b eqtr3
      3expia ex necon3d rspcev expcom syl6 com23 adantld adantrd a1dd pm2.61ine
      ax-rrecex remulcl adantlr eleq1 syl5ibcom rexlimdva mpd rexlimiva ) AHZBH
      ZIZBJKAJKZCHZLIZCJKZMJNZMLIZDHZUAEHZOPZUBPZFHZUAGHZOPZUBPZIZGJKZFJKZEJKZD
      JKZWQUCXBMXFQZEJKZDJKZXOMUDNXRUEDEMUMUFXBXQXNDJXBXPXMEJXBXPXFLIZLXJQZGJKZ
      FJKZXMXPXBXSMXFLRUGLUDNYBUHFGLUMUFXSYAXLFJXSXTXKGJXTXSXKLXJXFUIUGUJUJUKUJ
      UJULXMWQDEJJXCJNZXDJNZSZXKWQFGJJXKXCXGIZXDXHIZUNZYEXGJNZXHJNZSSZWQYHXFXJY
      HUOZXCXGQZXDXHQZSZXFXJQYLYFUOZYGUOZSYOYFYGUPYMYPYNYQYFYMXCXGUQURYGYNXDXHU
      QURUSUTYMYNXCXGXEXIUBYMVAXDXHUAOVBVCVEVDYKYFWQYGYCYIYFWQTYDYJYCYIYFWQWPYF
      XCWOIABXCXGJJWNXCWORWOXGXCUIVFVOVGYDYJYGWQTYCYIYDYJYGWQWPYGXDWOIABXDXHJJW
      NXDWORWOXHXDUIVFVOVHVIVJVKVLVMWPWTABJJWNJNZWOJNZSZWPWTTZTWNLWNLQZYSUUAYRU
      UBWPYSWTUUBWPWOLIZYSWTTUUBWOLWNWOUUBWOLQWNWOQWNWOLVNVPVQYSUUCWTWSUUCCWOJW
      RWOLRVRVSVTWAWBWNLIZYTWTWPUUDYRWTYSYRUUDWTWSUUDCWNJWRWNLRVRVSWCWDWEVLWSXA
      CJWRJNZWSSZWRWNOPZMQZAJKXAAWRWFUUFUUHXAAJUUFYRSUUGJNZUUHXAUUEYRUUIWSWRWNW
      GWHUUGMJWIWJWKWLWMVM $.
  $}

  $( ` 0 ` is a real number.  See also ~ 0reALT .  (Contributed by Eric
     Schmidt, 21-May-2007.)  (Revised by Scott Fenton, 3-Jan-2013.) $)
  0re $p |- 0 e. RR $=
    ( vx c1 cr wcel cv caddc cc0 wceq wrex 1re ax-rnegex readdcl mpan syl5ibcom
    co eleq1 rexlimiv mp2b ) BCDZBAEZFOZGHZACIGCDZJABKUBUCACTCDZUACDZUBUCSUDUEJ
    BTLMUAGCPNQR $.

  ${
    axi.1 $e |- A e. CC $.
    $( Identity law for multiplication.  (Contributed by NM, 14-Feb-1995.) $)
    mulid1i $p |- ( A x. 1 ) = A $=
      ( cc wcel c1 cmul co wceq mulid1 ax-mp ) ACDAEFGAHBAIJ $.

    $( Identity law for multiplication.  (Contributed by NM, 14-Feb-1995.) $)
    mulid2i $p |- ( 1 x. A ) = A $=
      ( cc wcel c1 cmul co wceq mulid2 ax-mp ) ACDEAFGAHBAIJ $.

    axi.2 $e |- B e. CC $.
    $( Closure law for addition.  (Contributed by NM, 23-Nov-1994.) $)
    addcli $p |- ( A + B ) e. CC $=
      ( cc wcel caddc co addcl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( Closure law for multiplication.  (Contributed by NM, 23-Nov-1994.) $)
    mulcli $p |- ( A x. B ) e. CC $=
      ( cc wcel cmul co mulcl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( Commutative law for multiplication.  (Contributed by NM,
       23-Nov-1994.) $)
    mulcomi $p |- ( A x. B ) = ( B x. A ) $=
      ( cc wcel cmul co wceq mulcom mp2an ) AEFBEFABGHBAGHICDABJK $.

    ${
      mulcomli.3 $e |- ( A x. B ) = C $.
      $( Commutative law for multiplication.  (Contributed by NM,
         23-Nov-1994.) $)
      mulcomli $p |- ( B x. A ) = C $=
        ( cmul co mulcomi eqtri ) BAGHABGHCBAEDIFJ $.
    $}

    axi.3 $e |- C e. CC $.
    $( Associative law for addition.  (Contributed by NM, 23-Nov-1994.) $)
    addassi $p |- ( ( A + B ) + C ) = ( A + ( B + C ) ) $=
      ( cc wcel caddc co wceq addass mp3an ) AGHBGHCGHABIJCIJABCIJIJKDEFABCLM
      $.

    $( Associative law for multiplication.  (Contributed by NM,
       23-Nov-1994.) $)
    mulassi $p |- ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) $=
      ( cc wcel cmul co wceq mulass mp3an ) AGHBGHCGHABIJCIJABCIJIJKDEFABCLM $.

    $( Distributive law.  (Contributed by NM, 23-Nov-1994.) $)
    adddii $p |- ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) $=
      ( cc wcel caddc co cmul wceq adddi mp3an ) AGHBGHCGHABCIJKJABKJACKJIJLDEF
      ABCMN $.

    $( Distributive law.  (Contributed by NM, 16-Feb-1995.) $)
    adddiri $p |- ( ( A + B ) x. C ) = ( ( A x. C ) + ( B x. C ) ) $=
      ( cc wcel caddc co cmul wceq adddir mp3an ) AGHBGHCGHABIJCKJACKJBCKJIJLDE
      FABCMN $.
  $}

  ${
    recni.1 $e |- A e. RR $.
    $( A real number is a complex number.  (Contributed by NM, 1-Mar-1995.) $)
    recni $p |- A e. CC $=
      ( cr cc ax-resscn sselii ) CDAEBF $.

    axri.2 $e |- B e. RR $.
    $( Closure law for addition of reals.  (Contributed by NM, 17-Jan-1997.) $)
    readdcli $p |- ( A + B ) e. RR $=
      ( cr wcel caddc co readdcl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( Closure law for multiplication of reals.  (Contributed by NM,
       17-Jan-1997.) $)
    remulcli $p |- ( A x. B ) e. RR $=
      ( cr wcel cmul co remulcl mp2an ) AEFBEFABGHEFCDABIJ $.
  $}

  ${
    addcld.1 $e |- ( ph -> A e. CC ) $.
    $( Identity law for multiplication.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulid1d $p |- ( ph -> ( A x. 1 ) = A ) $=
      ( cc wcel c1 cmul co wceq mulid1 syl ) ABDEBFGHBICBJK $.

    $( Identity law for multiplication.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulid2d $p |- ( ph -> ( 1 x. A ) = A ) $=
      ( cc wcel c1 cmul co wceq mulid2 syl ) ABDEFBGHBICBJK $.

    addcld.2 $e |- ( ph -> B e. CC ) $.
    $( Closure law for addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    addcld $p |- ( ph -> ( A + B ) e. CC ) $=
      ( cc wcel caddc co addcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure law for multiplication.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulcld $p |- ( ph -> ( A x. B ) e. CC ) $=
      ( cc wcel cmul co mulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Commutative law for multiplication.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulcomd $p |- ( ph -> ( A x. B ) = ( B x. A ) ) $=
      ( cc wcel cmul co wceq mulcom syl2anc ) ABFGCFGBCHICBHIJDEBCKL $.

    addassd.3 $e |- ( ph -> C e. CC ) $.
    $( Associative law for addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    addassd $p |- ( ph -> ( ( A + B ) + C ) = ( A + ( B + C ) ) ) $=
      ( cc wcel caddc co wceq addass syl3anc ) ABHICHIDHIBCJKDJKBCDJKJKLEFGBCDM
      N $.

    $( Associative law for multiplication.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulassd $p |- ( ph -> ( ( A x. B ) x. C ) = ( A x. ( B x. C ) ) ) $=
      ( cc wcel cmul co wceq mulass syl3anc ) ABHICHIDHIBCJKDJKBCDJKJKLEFGBCDMN
      $.

    $( Distributive law.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    adddid $p |- ( ph -> ( A x. ( B + C ) ) = ( ( A x. B ) + ( A x. C ) ) ) $=
      ( cc wcel caddc co cmul wceq adddi syl3anc ) ABHICHIDHIBCDJKLKBCLKBDLKJKM
      EFGBCDNO $.

    $( Distributive law.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    adddird $p |- ( ph -> ( ( A + B ) x. C ) = ( ( A x. C ) + ( B x. C ) ) ) $=
      ( cc wcel caddc co cmul wceq adddir syl3anc ) ABHICHIDHIBCJKDLKBDLKCDLKJK
      MEFGBCDNO $.
  $}

  ${
    recnd.1 $e |- ( ph -> A e. RR ) $.
    $( Deduction from real number to complex number.  (Contributed by NM,
       26-Oct-1999.) $)
    recnd $p |- ( ph -> A e. CC ) $=
      ( cr wcel cc recn syl ) ABDEBFECBGH $.

    readdcld.2 $e |- ( ph -> B e. RR ) $.
    $( Closure law for addition of reals.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    readdcld $p |- ( ph -> ( A + B ) e. RR ) $=
      ( cr wcel caddc co readdcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure law for multiplication of reals.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    remulcld $p |- ( ph -> ( A x. B ) e. RR ) $=
      ( cr wcel cmul co remulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Infinity and the extended real number system
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c <_ $. $( 'Less than or equal to' relation. $)
  $c +oo $. $( Plus infinity $)
  $c -oo $. $( Minus infinity $)
  $c RR* $. $( The set of extended reals $)
  $c < $. $( 'Less than' relation (over extended reals) $)

  $( Plus infinity. $)
  cpnf $a class +oo $.
  $( Minus infinity. $)
  cmnf $a class -oo $.
  $( The set of extended reals (includes plus and minus infinity). $)
  cxr $a class RR* $.
  $( 'Less than' predicate (extended to include the extended reals). $)
  clt $a class < $.
  $( Extend wff notation to include the 'less than or equal to' relation. $)
  cle $a class <_ $.

  $( Define plus infinity.  Note that the definition is arbitrary, requiring
     only that ` +oo ` be a set not in ` RR ` and different from ` -oo `
     ( ~ df-mnf ).  We use ` ~P U. CC ` to make it independent of the
     construction of ` CC ` , and Cantor's Theorem will show that it is
     different from any member of ` CC ` and therefore ` RR ` .  See ~ pnfnre ,
     ~ mnfnre , and ~ pnfnemnf .

     A simpler possibility is to define ` +oo ` as ` CC ` and ` -oo ` as
     ` { CC } ` , but that approach requires the Axiom of Regularity to show
     that ` +oo ` and ` -oo ` are different from each other and from all
     members of ` RR ` .  (Contributed by NM, 13-Oct-2005.)
     (New usage is discouraged.) $)
  df-pnf $a |- +oo = ~P U. CC $.

  $( Define minus infinity as the power set of plus infinity.  Note that the
     definition is arbitrary, requiring only that ` -oo ` be a set not in
     ` RR ` and different from ` +oo ` (see ~ mnfnre and ~ pnfnemnf ).
     (Contributed by NM, 13-Oct-2005.)  (New usage is discouraged.) $)
  df-mnf $a |- -oo = ~P +oo $.

  $( Define the set of extended reals that includes plus and minus infinity.
     Definition 12-3.1 of [Gleason] p. 173.  (Contributed by NM,
     13-Oct-2005.) $)
  df-xr $a |- RR* = ( RR u. { +oo , -oo } ) $.

  ${
    $d x y $.
    $( Define 'less than' on the set of extended reals.  Definition 12-3.1 of
       [Gleason] p. 173.  Note that in our postulates for complex numbers,
       ` <RR ` is primitive and not necessarily a relation on ` RR ` .
       (Contributed by NM, 13-Oct-2005.) $)
    df-ltxr $a |- < = ( { <. x , y >. | ( x e. RR /\ y e. RR /\ x <RR y ) }
      u. ( ( ( RR u. { -oo } ) X. { +oo } ) u. ( { -oo } X. RR ) ) ) $.
  $}

  $( Define 'less than or equal to' on the extended real subset of complex
     numbers.  Theorem ~ leloe relates it to 'less than' for reals.
     (Contributed by NM, 13-Oct-2005.) $)
  df-le $a |- <_ = ( ( RR* X. RR* ) \ `' < ) $.

  $( Plus infinity is not a real number.  (Contributed by NM, 13-Oct-2005.) $)
  pnfnre $p |- +oo e/ RR $=
    ( cpnf cr wcel cc cuni cpw pwuninel df-pnf eleq1i mtbir recn mto nelir ) AB
    ABCADCZNDEFZDCDGAODHIJAKLM $.

  $( Minus infinity is not a real number.  (Contributed by NM, 13-Oct-2005.) $)
  mnfnre $p |- -oo e/ RR $=
    ( cmnf cr wcel cc cuni cpw 2pwuninel df-mnf df-pnf pweqi eqtri eleq1i mtbir
    cpnf recn mto nelir ) ABABCADCZRDEFZFZDCDGATDANFTHNSIJKLMAOPQ $.

  $( The standard reals are a subset of the extended reals.  (Contributed by
     NM, 14-Oct-2005.) $)
  ressxr $p |- RR C_ RR* $=
    ( cr cpnf cmnf cpr cun cxr ssun1 df-xr sseqtr4i ) AABCDZEFAJGHI $.

  $( A standard real is an extended real.  (Contributed by NM, 14-Oct-2005.) $)
  rexr $p |- ( A e. RR -> A e. RR* ) $=
    ( cr cxr ressxr sseli ) BCADE $.

  $( Zero is an extended real.  (Contributed by Mario Carneiro,
     15-Jun-2014.) $)
  0xr $p |- 0 e. RR* $=
    ( cr cxr cc0 ressxr 0re sselii ) ABCDEF $.

  $( No (finite) real equals plus infinity.  (Contributed by NM, 14-Oct-2005.)
     (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  renepnf $p |- ( A e. RR -> A =/= +oo ) $=
    ( cr wcel cpnf wceq pnfnre neli eleq1 mtbiri necon2ai ) ABCZADADEKDBCDBFGAD
    BHIJ $.

  $( No real equals minus infinity.  (Contributed by NM, 14-Oct-2005.)  (Proof
     shortened by Andrew Salmon, 19-Nov-2011.) $)
  renemnf $p |- ( A e. RR -> A =/= -oo ) $=
    ( cr wcel cmnf wceq mnfnre neli eleq1 mtbiri necon2ai ) ABCZADADEKDBCDBFGAD
    BHIJ $.

  ${
    rexrd.1 $e |- ( ph -> A e. RR ) $.
    $( A standard real is an extended real.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    rexrd $p |- ( ph -> A e. RR* ) $=
      ( cr cxr ressxr sseldi ) ADEBFCG $.

    $( No (finite) real equals plus infinity.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    renepnfd $p |- ( ph -> A =/= +oo ) $=
      ( cr wcel cpnf wne renepnf syl ) ABDEBFGCBHI $.

    $( No real equals minus infinity.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    renemnfd $p |- ( ph -> A =/= -oo ) $=
      ( cr wcel cmnf wne renemnf syl ) ABDEBFGCBHI $.
  $}

  ${
    rexri.1 $e |- A e. RR $.
    $( A standard real is an extended real (inference form.)  (Contributed by
       David Moews, 28-Feb-2017.) $)
    rexri $p |- A e. RR* $=
      ( cr wcel cxr rexr ax-mp ) ACDAEDBAFG $.
  $}

  $( The reals and the infinities are disjoint.  (Contributed by NM,
     25-Oct-2005.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  renfdisj $p |- ( RR i^i { +oo , -oo } ) = (/) $=
    ( vx cr cpnf cmnf cpr cin c0 wceq cv wcel wn disj vex elpr renepnf necon2bi
    wo renemnf jaoi sylbi con2i mprgbir ) BCDEZFGHAIZUCJZKABABUCLUEUDBJZUEUDCHZ
    UDDHZQUFKZUDCDAMNUGUIUHUFUDCUDOPUFUDDUDRPSTUAUB $.

  ${
    $d x y $.
    $( 'Less than' is a relation on extended reals.  (Contributed by Mario
       Carneiro, 28-Apr-2015.) $)
    ltrelxr $p |- < C_ ( RR* X. RR* ) $=
      ( vx vy cv wcel copab cmnf csn cun cpnf cxp cxr eqsstri wss ressxr xpss12
      cr wa mp2an sstri unssi clt cltrr wbr w3a df-ltxr df-3an opabbii opabssxp
      cpr snsspr2 ssun2 df-xr sseqtr4i snsspr1 ) UAACZPDZBCZPDZUOUQUBUCZUDZABEZ
      PFGZHZIGZJZVBPJZHZHKKJZABUEVAVGVHVAPPJZVHVAUPURQUSQZABEVIUTVJABUPURUSUFUG
      USABPPUHLPKMZVKVIVHMNNPKPKORSVEVFVHVCKMVDKMVEVHMPVBKNVBIFUIZKIFUJVLPVLHKV
      LPUKULUMZSZTVDVLKIFUNVMSVCKVDKORVBKMVKVFVHMVNNVBKPKORTTL $.
  $}

  $( 'Less than' is a relation.  (Contributed by NM, 14-Oct-2005.) $)
  ltrel $p |- Rel < $=
    ( clt cxr cxp wss wrel ltrelxr relxp relss mp2 ) ABBCZDJEAEFBBGAJHI $.

  $( 'Less than or equal' is a relation on extended reals.  (Contributed by
     Mario Carneiro, 28-Apr-2015.) $)
  lerelxr $p |- <_ C_ ( RR* X. RR* ) $=
    ( cle cxr cxp clt ccnv cdif df-le difss eqsstri ) ABBCZDEZFJGJKHI $.

  $( 'Less or equal to' is a relation.  (Contributed by FL, 2-Aug-2009.)
     (Revised by Mario Carneiro, 28-Apr-2015.) $)
  lerel $p |- Rel <_ $=
    ( cle cxr cxp wss wrel lerelxr relxp relss mp2 ) ABBCZDJEAEFBBGAJHI $.

  $( 'Less than or equal to' expressed in terms of 'less than', for extended
     reals.  (Contributed by NM, 14-Oct-2005.) $)
  xrlenlt $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A <_ B <-> -. B < A ) ) $=
    ( cxr wcel wa cle wbr cop clt ccnv wn df-br cxp wb opelxpi cdif df-le eldif
    eleq2i bitri baib syl syl5bb opelcnvg syl6rbbr notbid bitr4d ) ACDBCDEZABFG
    ZABHZIJZDZKZBAIGZKUIUJFDZUHUMABFLUHUJCCMZDZUOUMNABCCOUOUQUMUOUJUPUKPZDUQUME
    FURUJQSUJUPUKRTUAUBUCUHUNULUHULBAHIDUNABCCIUDBAILUEUFUG $.

  $( 'Less than' expressed in terms of 'less than or equal to', for extended
     reals.  (Contributed by NM, 6-Feb-2007.) $)
  xrltnle $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B <-> -. B <_ A ) ) $=
    ( cxr wcel clt wbr cle wn wb wa xrlenlt con2bid ancoms ) BCDZACDZABEFZBAGFZ
    HINOJQPBAKLM $.

  ${
    $d x A $.
    $( The three (non-exclusive) possibilities implied by a subset of extended
       reals.  (Contributed by NM, 25-Oct-2005.)  (Proof shortened by Andrew
       Salmon, 19-Nov-2011.) $)
    ssxr $p |- ( A C_ RR* -> ( A C_ RR \/ +oo e. A \/ -oo e. A ) ) $=
      ( cr cpnf cmnf cpr cun wss wcel wo cxr w3o wn cin c0 wceq csn disjsn cdif
      wa sseq2i df-pr ineq2i indi anbi12i biimpri pm4.56 3imtr3i syl5eq reldisj
      eqtri un00 renfdisj disj3 mpbi difun2 eqtr4i syl6bbr syl5ib 3orrot df-3or
      orrd df-xr bitri 3imtr4i ) ABCDEZFZGZCAHZDAHZIZABGZIZAJGVKVHVIKZVGVJVKVJL
      ZAVEMZNOZVGVKVNVOACPZMZADPZMZFZNVOAVQVSFZMWAVEWBACDUAUBAVQVSUCUJVHLZVILZS
      ZVRNOZVTNOZSZVNWANOWHWEWFWCWGWDACQADQUDUEVHVIUFVRVTUKUGUHVGVPAVFVERZGVKAV
      EVFUIBWIABBVERZWIBVEMNOBWJOULBVEUMUNBVEUOUPTUQURVAJVFAVBTVMVHVIVKKVLVKVHV
      IUSVHVIVKUTVCVD $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The standard less-than ` <RR ` and the extended real less-than ` < ` are
       identical when restricted to the non-extended reals ` RR ` .
       (Contributed by NM, 13-Oct-2005.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    ltxrlt $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> A <RR B ) ) $=
      ( vx vy cr wcel wa clt wbr cv cltrr cmnf csn cun cpnf cxp wn wo syl sylbi
      w3a copab brun brxp wceq elsni pnfnre neli simpr eleq1 syl5ib mtoi adantl
      wb mnfnre simpl adantr con2i wi biimt df-ltxr equncomi breqi df-or 3bitri
      jaoi syl6rbbr breq12 df-3an opabbii brab2ga baibr bitr4d ) AEFZBEFZGZABHI
      ZABCJZEFZDJZEFZVRVTKIZUAZCDUBZIZABKIZVPABELMZNZOMZPZWGEPZNZIZQZVQWEUNWMVP
      WMABWJIZABWKIZRVPQZABWJWKUCWOWQWPWOAWHFZBWIFZGWQABWHWIUDWSWQWRWSBOUEZWQBO
      UFWTVPOEFZOEUGUHVPVOWTXAVNVOUIBOEUJUKULSUMTWPAWGFZVOGWQABWGEUDXBWQVOXBALU
      EZWQALUFXCVPLEFZLEUOUHVPVNXCXDVNVOUPALEUJUKULSUQTVFTURWNWEWNWEUSZVQWNWEUT
      VQABWLWDNZIWMWERXEABHXFHWDWLCDVAVBVCABWLWDUCWMWEVDVEVGSWEVPWFWBWFCDABEEWD
      VRAVTBKVHWCVSWAGWBGCDVSWAWBVIVJVKVLVM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Restate the ordering postulates with extended real "less than"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Ordering on reals satisfies strict trichotomy.  Axiom 18 of 22 for real
     and complex numbers, derived from ZF set theory.  (This restates
     ~ ax-pre-lttri with ordering on the extended reals.)  (Contributed by NM,
     13-Oct-2005.) $)
  axlttri $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A < B <-> -. ( A = B \/ B < A ) ) ) $=
    ( cr wcel wa cltrr wbr wceq wo clt ax-pre-lttri ltxrlt ancoms orbi2d notbid
    wn wb 3bitr4d ) ACDZBCDZEZABFGABHZBAFGZIZPABJGUBBAJGZIZPABKABLUAUFUDUAUEUCU
    BTSUEUCQBALMNOR $.

  $( Ordering on reals is transitive.  Axiom 19 of 22 for real and complex
     numbers, derived from ZF set theory.  This restates ~ ax-pre-lttrn with
     ordering on the extended reals.  New proofs should use ~ lttr instead for
     naming consistency.  (New usage is discouraged.)  (Contributed by NM,
     13-Oct-2005.) $)
  axlttrn $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A < B /\ B < C ) -> A < C ) ) $=
    ( cr wcel w3a cltrr wbr wa clt ax-pre-lttrn 3adant3 3adant1 anbi12d 3adant2
    wb ltxrlt 3imtr4d ) ADEZBDEZCDEZFZABGHZBCGHZIACGHZABJHZBCJHZIACJHZABCKUBUFU
    CUGUDSTUFUCPUAABQLTUAUGUDPSBCQMNSUAUHUEPTACQOR $.

  $( Ordering property of addition on reals.  Axiom 20 of 22 for real and
     complex numbers, derived from ZF set theory.  (This restates
     ~ ax-pre-ltadd with ordering on the extended reals.)  (Contributed by NM,
     13-Oct-2005.) $)
  axltadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B -> ( C + A ) < ( C + B ) ) ) $=
    ( cr wcel w3a cltrr wbr caddc co clt ax-pre-ltadd wb ltxrlt 3adant3 readdcl
    wa syl2an 3impdi 3coml 3imtr4d ) ADEZBDEZCDEZFABGHZCAIJZCBIJZGHZABKHZUFUGKH
    ZABCLUBUCUIUEMUDABNOUDUBUCUJUHMZUDUBUCUKUDUBQUFDEUGDEUKUDUCQCAPCBPUFUGNRSTU
    A $.

  $( The product of two positive reals is positive.  Axiom 21 of 22 for real
     and complex numbers, derived from ZF set theory.  (This restates
     ~ ax-pre-mulgt0 with ordering on the extended reals.)  (Contributed by NM,
     13-Oct-2005.) $)
  axmulgt0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( ( 0 < A /\ 0 < B ) -> 0 < ( A x. B ) ) ) $=
    ( cr wcel wa cc0 cltrr wbr cmul co clt ax-pre-mulgt0 wb 0re ltxrlt bi2anan9
    mpan remulcl sylancr 3imtr4d ) ACDZBCDZEZFAGHZFBGHZEFABIJZGHZFAKHZFBKHZEFUF
    KHZABLUAUHUDUBUIUEFCDZUAUHUDMNFAOQUKUBUIUEMNFBOQPUCUKUFCDUJUGMNABRFUFOST $.

  ${
    $d x y z A $.
    $( A non-empty, bounded-above set of reals has a supremum.  Axiom 22 of 22
       for real and complex numbers, derived from ZF set theory.  (This
       restates ~ ax-pre-sup with ordering on the extended reals.)
       (Contributed by NM, 13-Oct-2005.) $)
    axsup $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y < x ) ->
                E. x e. RR ( A. y e. A -. x < y /\
                A. y e. RR ( y < x -> E. z e. A y < z ) ) ) $=
      ( cr cv clt wbr wral wrex wa cltrr wb wcel ltxrlt sylan ralbidva rexbidva
      an32s ancoms wss c0 wne wn ax-pre-sup 3expia ssel2 adantr adantll adantlr
      wi notbid imbi12d anbi12d 3imtr4d 3impia ) DEUAZDUBUCZBFZAFZGHZBDIZAEJZUT
      USGHZUDZBDIZVAUSCFZGHZCDJZUKZBEIZKZAEJZUQURKUSUTLHZBDIZAEJZUTUSLHZUDZBDIZ
      VNUSVGLHZCDJZUKZBEIZKZAEJZVCVMUQURVPWEABCDUEUFUQVCVPMURUQVBVOAEUQUTENZKZV
      AVNBDUQUSDNZWFVAVNMZUQWHKZUSENZWFWIDEUSUGZUSUTOZPSQRUHUQVMWEMURUQVLWDAEWG
      VFVSVKWCWGVEVRBDWGWHKVDVQUQWHWFVDVQMZWJWKWFWNWLWFWKWNUTUSOTPSULQWGVJWBBEW
      GWKKVAVNVIWAWFWKWIUQWKWFWIWMTUIUQWKVIWAMWFUQWKKVHVTCDUQVGDNZWKVHVTMZUQWOK
      VGENZWKWPDEVGUGWKWQWPUSVGOTPSRUJUMQUNRUHUOUP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordering on reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Alias for ~ axlttrn , for naming consistency with ~ lttri .  New proofs
     should generally use this instead of ~ ax-pre-lttrn .  (Contributed by NM,
     10-Mar-2008.) $)
  lttr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A < B /\ B < C ) -> A < C ) ) $=
    ( axlttrn ) ABCD $.

  $( The product of two positive numbers is positive.  (Contributed by NM,
     10-Mar-2008.) $)
  mulgt0 $p |- ( ( ( A e. RR /\ 0 < A ) /\
                ( B e. RR /\ 0 < B ) ) -> 0 < ( A x. B ) ) $=
    ( cr wcel cc0 clt wbr cmul co wa axmulgt0 imp an4s ) ACDZBCDZEAFGZEBFGZEABH
    IFGZNOJPQJRABKLM $.

  $( 'Less than or equal to' expressed in terms of 'less than'.  (Contributed
     by NM, 13-May-1999.) $)
  lenlt $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B <-> -. B < A ) ) $=
    ( cr wcel cxr cle wbr clt wn wb rexr xrlenlt syl2an ) ACDAEDBEDABFGBAHGIJBC
    DAKBKABLM $.

  $( 'Less than' expressed in terms of 'less than or equal to'.  (Contributed
     by NM, 11-Jul-2005.) $)
  ltnle $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> -. B <_ A ) ) $=
    ( cr wcel wa cle wbr clt wn wb lenlt ancoms con2bid ) ACDZBCDZEBAFGZABHGZON
    PQIJBAKLM $.

  ${
    $d x y z $.
    $( 'Less than' is a strict ordering.  (Contributed by NM, 19-Jan-1997.) $)
    ltso $p |- < Or RR $=
      ( vx vy vz cr clt cv axlttri lttr isso2i ) ABCDEAFZBFZGJKCFHI $.
  $}

  $( Consequence of trichotomy.  (Contributed by NM, 9-Oct-1999.) $)
  lttri2 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A =/= B <-> ( A < B \/ B < A ) ) ) $=
    ( cr wcel wa clt wbr wo wceq wn wor wb ltso sotrieq mpan bicomd necon1abid
    ) ACDBCDEZABFGBAFGHZABRABIZSJZCFKRTUALMCABFNOPQ $.

  $( Trichotomy law for 'less than'.  (Contributed by NM, 5-May-1999.) $)
  lttri3 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A = B <-> ( -. A < B /\ -. B < A ) ) ) $=
    ( cr clt wor wcel wa wceq wbr wn wb ltso sotrieq2 mpan ) CDEACFBCFGABHABDIJ
    BADIJGKLCABDMN $.

  $( Trichotomy law for 'less than'.  (Contributed by NM, 20-Sep-2007.)  (Proof
     shortened by Andrew Salmon, 19-Nov-2011.) $)
  lttri4 $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B \/ A = B \/ B < A ) ) $=
    ( cr clt wor wcel wa wbr wceq w3o ltso solin mpan ) CDEACFBCFGABDHABIBADHJK
    CABDLM $.

  $( Trichotomy law.  (Contributed by NM, 14-May-1999.) $)
  letri3 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A = B <-> ( A <_ B /\ B <_ A ) ) ) $=
    ( cr wcel wa wceq clt wbr wn cle lttri3 ancom syl6bbr ancoms anbi12d bitr4d
    lenlt wb ) ACDZBCDZEZABFZBAGHIZABGHIZEZABJHZBAJHZEUAUBUDUCEUEABKUCUDLMUAUFU
    CUGUDABQTSUGUDRBAQNOP $.

  $( 'Less than or equal to' expressed in terms of 'less than' or 'equals'.
     (Contributed by NM, 13-May-1999.) $)
  leloe $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A <_ B <-> ( A < B \/ A = B ) ) ) $=
    ( cr wcel wa cle wbr clt wn wceq wo lenlt eqcom orbi1i orcom axlttri ancoms
    bitri wb con2bid syl5rbbr bitrd ) ACDZBCDZEZABFGBAHGZIZABHGZABJZKZABLUJBAJZ
    UHKZUEUGULUIUHKUJUKUIUHBAMNUIUHORUEUFULUDUCUFULISBAPQTUAUB $.

  $( Equality in terms of 'less than or equal to', 'less than'.  (Contributed
     by NM, 7-Apr-2001.) $)
  eqlelt $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A = B <-> ( A <_ B /\ -. A < B ) ) ) $=
    ( cr wcel wa wceq cle wbr clt wn letri3 wb lenlt ancoms anbi2d bitrd ) ACDZ
    BCDZEZABFABGHZBAGHZETABIHJZEABKSUAUBTRQUAUBLBAMNOP $.

  $( 'Less than' implies 'less than or equal to'.  (Contributed by NM,
     25-Aug-1999.) $)
  ltle $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A < B -> A <_ B ) ) $=
    ( clt wbr cle cr wcel wa wceq wo orc leloe syl5ibr ) ABCDZABEDAFGBFGHNABIZJ
    NOKABLM $.

  $( 'Less than or equal to' implies 'less than' is not 'equals'.  (Contributed
     by NM, 27-Jul-1999.) $)
  leltne $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                ( A < B <-> B =/= A ) ) $=
    ( cr wcel cle wbr clt wne wb wa wceq wn wi lttri3 simpl syl6bi adantr leloe
    wo biimpa ord impbid necon2abid necom syl6bbr 3impa ) ACDZBCDZABEFZABGFZBAH
    ZIUGUHJZUIJZUJABHUKUMUJABUMABKZUJLZULUNUOMUIULUNUOBAGFLZJUOABNUOUPOPQUMUJUN
    ULUIUJUNSABRTUAUBUCBAUDUEUF $.

  $( Transitive law.  (Contributed by NM, 23-May-1999.) $)
  lelttr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A <_ B /\ B < C ) -> A < C ) ) $=
    ( cr wcel w3a cle wbr clt wceq wo wi leloe 3adant3 lttr exp3a breq1 biimprd
    wb a1i jaod sylbid imp3a ) ADEZBDEZCDEZFZABGHZBCIHZACIHZUGUHABIHZABJZKZUIUJ
    LZUDUEUHUMSUFABMNUGUKUNULUGUKUIUJABCOPULUNLUGULUJUIABCIQRTUAUBUC $.

  $( Transitive law.  (Contributed by NM, 25-Aug-1999.) $)
  ltletr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A < B /\ B <_ C ) -> A < C ) ) $=
    ( cr wcel w3a clt wbr cle wceq wo wi wb leloe 3adant1 lttr exp3acom23 breq2
    biimpd a1i jaod sylbid com23 imp3a ) ADEZBDEZCDEZFZABGHZBCIHZACGHZUHUJUIUKU
    HUJBCGHZBCJZKZUIUKLZUFUGUJUNMUEBCNOUHULUOUMUHUIULUKABCPQUMUOLUHUMUIUKBCAGRS
    TUAUBUCUD $.

  $( Transitive law.  (Contributed by NM, 12-Nov-1999.) $)
  letr $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
             ( ( A <_ B /\ B <_ C ) -> A <_ C ) ) $=
    ( cr wcel w3a cle wbr wa clt wceq wo wb leloe 3adant1 adantr lelttr wi ltle
    3adant2 syld expdimp breq2 biimpcd adantl jaod sylbid expimpd ) ADEZBDEZCDE
    ZFZABGHZBCGHZACGHZULUMIZUNBCJHZBCKZLZUOULUNUSMZUMUJUKUTUIBCNOPUPUQUOURULUMU
    QUOULUMUQIACJHZUOABCQUIUKVAUORUJACSTUAUBUMURUORULURUMUOBCAGUCUDUEUFUGUH $.

  $( 'Less than' is irreflexive.  (Contributed by NM, 18-Aug-1999.) $)
  ltnr $p |- ( A e. RR -> -. A < A ) $=
    ( cr clt wor wcel wbr wn ltso sonr mpan ) BCDABEAACFGHBACIJ $.

  $( 'Less than or equal to' is reflexive.  (Contributed by NM,
     18-Aug-1999.) $)
  leid $p |- ( A e. RR -> A <_ A ) $=
    ( cr wcel cle wbr wa clt wceq wo eqid olci leloe mpbiri anidms ) ABCZAADEZO
    OFPAAGEZAAHZIRQAJKAALMN $.

  $( 'Less than' implies not equal.  (Contributed by NM, 9-Oct-1999.)  (Revised
     by Mario Carneiro, 16-Sep-2015.) $)
  ltne $p |- ( ( A e. RR /\ A < B ) -> B =/= A ) $=
    ( cr wcel clt wbr wne wn wceq ltnr breq2 notbid syl5ibrcom necon2ad imp ) A
    CDZABEFZBAGPQBAPQHBAIZAAEFZHAJRQSBAAEKLMNO $.

  $( 'Less than' implies not equal.  (Contributed by NM, 9-Oct-1999.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  ltneOLD $p |- ( ( A e. RR /\ B e. RR /\ A < B ) -> B =/= A ) $=
    ( cr wcel clt wbr wne ltne 3adant2 ) ACDABEFBAGBCDABHI $.

  $( 'Less than' is not symmetric.  (Contributed by NM, 8-Jan-2002.) $)
  ltnsym $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B -> -. B < A ) ) $=
    ( cr wcel wa clt wbr wceq wo wn axlttri pm2.46 syl6bi ) ACDBCDEABFGABHZBAFG
    ZIJOJABKNOLM $.

  $( 'Less than' is antisymmetric and irreflexive.  (Contributed by NM,
     13-Aug-2005.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  ltnsym2 $p |- ( ( A e. RR /\ B e. RR ) -> -. ( A < B /\ B < A ) ) $=
    ( cr clt wor wcel wa wbr wn ltso so2nr mpan ) CDEACFBCFGABDHBADHGIJCABDKL
    $.

  $( Trichotomy law.  (Contributed by NM, 18-Aug-1999.)  (Proof shortened by
     Andrew Salmon, 19-Nov-2011.) $)
  letric $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B \/ B <_ A ) ) $=
    ( cr wcel cle wbr wo wa wn clt ltnle ltle sylbird orrd ancoms ) BCDZACDZABE
    FZBAEFZGPQHZRSTRIBAJFSBAKBALMNO $.

  $( 'Less than' expressed in terms of 'less than or equal to'.  (Contributed
     by NM, 27-Oct-1999.) $)
  ltlen $p |- ( ( A e. RR /\ B e. RR ) ->
               ( A < B <-> ( A <_ B /\ B =/= A ) ) ) $=
    ( cr wcel wa clt wbr cle wne ltle ltneOLD 3expia jcad wceq wo wi leloe ax-1
    wn df-ne pm2.24 eqcoms syl5bi jaoi syl6bi imp3a impbid ) ACDZBCDZEZABFGZABH
    GZBAIZEUJUKULUMABJUHUIUKUMABKLMUJULUMUKUJULUKABNZOUMUKPZABQUKUOUNUKUMRUMBAN
    ZSZUNUKBATUQUKPBAUPUKUAUBUCUDUEUFUG $.

  $( Equality implies 'less than or equal to'.  (Contributed by NM,
     4-Apr-2005.) $)
  eqle $p |- ( ( A e. RR /\ A = B ) -> A <_ B ) $=
    ( cr wcel cle wbr wceq leid breq2 biimpac sylan ) ACDAAEFZABGZABEFZAHMLNABA
    EIJK $.

  $( Addition to both sides of 'less than'.  (Contributed by NM, 12-Nov-1999.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  ltadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( C + A ) < ( C + B ) ) ) $=
    ( cr wcel w3a clt wbr caddc co axltadd wceq wo wn wi oveq2 readdcld axlttri
    wb syl2anc a1i 3com12 orim12d con3d simp3 simp1 simp2 3imtr4d impbid ) ADEZ
    BDEZCDEZFZABGHZCAIJZCBIJZGHZABCKUMUOUPLZUPUOGHZMZNZABLZBAGHZMZNZUQUNUMVDUTU
    MVBURVCUSVBUROUMABCIPUAUKUJULVCUSOBACKUBUCUDUMUODEUPDEUQVASUMCAUJUKULUEZUJU
    KULUFZQUMCBVFUJUKULUGZQUOUPRTUMUJUKUNVESVGVHABRTUHUI $.

  $( A nonzero nonnegative number is positive.  (Contributed by NM,
     20-Nov-2007.) $)
  ne0gt0 $p |- ( ( A e. RR /\ 0 <_ A ) -> ( A =/= 0 <-> 0 < A ) ) $=
    ( cr wcel cc0 cle wbr wa wne clt wo wb 0re lttri2 mpan2 adantr lenlt biimpa
    wn mpan biorf syl bitr4d ) ABCZDAEFZGZADHZADIFZDAIFZJZUHUCUFUIKZUDUCDBCZUJL
    ADMNOUEUGRZUHUIKUCUDULUKUCUDULKLDAPSQUGUHTUAUB $.

  ${
    lecase.1 $e |- ( ph -> A e. RR ) $.
    lecase.2 $e |- ( ph -> B e. RR ) $.
    lecase.3 $e |- ( ( ph /\ A <_ B ) -> ps ) $.
    lecase.4 $e |- ( ( ph /\ B <_ A ) -> ps ) $.
    $( Ordering elimination by cases.  (Contributed by NM, 6-Jul-2007.) $)
    lecasei $p |- ( ph -> ps ) $=
      ( cle wbr cr wcel wo letric syl2anc mpjaodan ) ACDIJZBDCIJZGHACKLDKLQRMEF
      CDNOP $.
  $}

  $( Trichotomy law.  (Contributed by NM, 4-Apr-2005.) $)
  lelttric $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B \/ B < A ) ) $=
    ( cr wcel wa cle wbr clt wo wn pm2.1 lenlt orbi1d mpbiri ) ACDBCDEZABFGZBAH
    GZIQJZQIQKOPRQABLMN $.

  ${
    ltlecasei.1 $e |- ( ( ph /\ A < B ) -> ps ) $.
    ltlecasei.2 $e |- ( ( ph /\ B <_ A ) -> ps ) $.
    ltlecasei.3 $e |- ( ph -> A e. RR ) $.
    ltlecasei.4 $e |- ( ph -> B e. RR ) $.
    $( Ordering elimination by cases.  (Contributed by NM, 1-Jul-2007.)  (Proof
       shortened by Mario Carneiro, 27-May-2016.) $)
    ltlecasei $p |- ( ph -> ps ) $=
      ( cle wbr clt cr wcel wo lelttric syl2anc mpjaodan ) ADCIJZBCDKJZFEADLMCL
      MRSNHGDCOPQ $.
  $}

  ${
    lt.1 $e |- A e. RR $.
    $( 'Less than' is irreflexive.  (Contributed by NM, 18-Aug-1999.) $)
    ltnri $p |- -. A < A $=
      ( cr wcel clt wbr wn ltnr ax-mp ) ACDAAEFGBAHI $.

    $( Equality implies 'less than or equal to'.  (Contributed by NM,
       23-May-1999.)  (Revised by Alexander van der Vekens, 20-Mar-2018.) $)
    eqlei $p |- ( A = B -> A <_ B ) $=
      ( cr wcel wceq cle wbr wi eleq1a ax-mp eqcoms wa letri3 mpan simpl syl6bi
      wb mpcom ) BDEZABFZABGHZTBAADEZBAFTICADBJKLTUAUBBAGHZMZUBUCTUAUERCABNOUBU
      DPQS $.

    $( Equality implies 'less than or equal to'.  (Contributed by Alexander van
       der Vekens, 20-Mar-2018.) $)
    eqlei2 $p |- ( B = A -> B <_ A ) $=
      ( cr wcel wceq cle wbr wi eleq1a ax-mp wa eqcom letri3 mpan syl5bb syl6bi
      wb simpr mpcom ) BDEZBAFZBAGHZADEZUBUAICADBJKUAUBABGHZUCLZUCUBABFZUAUFBAM
      UDUAUGUFRCABNOPUEUCSQT $.

    ${
      ltneii.2 $e |- A < B $.
      $( 'Less than' implies not equal.  (Contributed by Mario Carneiro,
         30-Sep-2013.) $)
      gtneii $p |- B =/= A $=
        ( cr wcel clt wbr wne ltne mp2an ) AEFABGHBAICDABJK $.

      $( 'Greater than' implies not equal.  (Contributed by Mario Carneiro,
         16-Sep-2015.) $)
      ltneii $p |- A =/= B $=
        ( gtneii necomi ) BAABCDEF $.
    $}

    lt.2 $e |- B e. RR $.
    $( Consequence of trichotomy.  (Contributed by NM, 19-Jan-1997.) $)
    lttri2i $p |- ( A =/= B <-> ( A < B \/ B < A ) ) $=
      ( cr wcel wne clt wbr wo wb lttri2 mp2an ) AEFBEFABGABHIBAHIJKCDABLM $.

    $( Consequence of trichotomy.  (Contributed by NM, 14-May-1999.) $)
    lttri3i $p |- ( A = B <-> ( -. A < B /\ -. B < A ) ) $=
      ( cr wcel wceq clt wbr wn wa wb lttri3 mp2an ) AEFBEFABGABHIJBAHIJKLCDABM
      N $.

    $( Consequence of trichotomy.  (Contributed by NM, 14-May-1999.) $)
    letri3i $p |- ( A = B <-> ( A <_ B /\ B <_ A ) ) $=
      ( cr wcel wceq cle wbr wa wb letri3 mp2an ) AEFBEFABGABHIBAHIJKCDABLM $.

    $( 'Less than or equal to' in terms of 'less than'.  (Contributed by NM,
       14-May-1999.) $)
    leloei $p |- ( A <_ B <-> ( A < B \/ A = B ) ) $=
      ( cr wcel cle wbr clt wceq wo wb leloe mp2an ) AEFBEFABGHABIHABJKLCDABMN
      $.

    $( 'Less than' expressed in terms of 'less than or equal to'.  (Contributed
       by NM, 27-Oct-1999.) $)
    ltleni $p |- ( A < B <-> ( A <_ B /\ B =/= A ) ) $=
      ( cr wcel clt wbr cle wne wa wb ltlen mp2an ) AEFBEFABGHABIHBAJKLCDABMN
      $.

    $( 'Less than' is not symmetric.  (Contributed by NM, 6-May-1999.) $)
    ltnsymi $p |- ( A < B -> -. B < A ) $=
      ( cr wcel clt wbr wn wi ltnsym mp2an ) AEFBEFABGHBAGHIJCDABKL $.

    $( 'Less than or equal to' in terms of 'less than'.  (Contributed by NM,
       24-May-1999.) $)
    lenlti $p |- ( A <_ B <-> -. B < A ) $=
      ( cr wcel cle wbr clt wn wb lenlt mp2an ) AEFBEFABGHBAIHJKCDABLM $.

    $( 'Less than' in terms of 'less than or equal to'.  (Contributed by NM,
       11-Jul-2005.) $)
    ltnlei $p |- ( A < B <-> -. B <_ A ) $=
      ( cle wbr clt lenlti con2bii ) BAEFABGFBADCHI $.

    $( 'Less than' implies 'less than or equal to'.  (Contributed by NM,
       14-May-1999.) $)
    ltlei $p |- ( A < B -> A <_ B ) $=
      ( cr wcel clt wbr cle wi ltle mp2an ) AEFBEFABGHABIHJCDABKL $.

    ${
      ltlei.1 $e |- A < B $.
      $( 'Less than' implies 'less than or equal to' (inference).  (Contributed
         by NM, 22-Aug-1999.) $)
      ltleii $p |- A <_ B $=
        ( clt wbr cle ltlei ax-mp ) ABFGABHGEABCDIJ $.
    $}

    $( 'Less than' implies not equal.  (Contributed by NM, 28-Jul-1999.) $)
    ltnei $p |- ( A < B -> B =/= A ) $=
      ( cr wcel clt wbr wne ltneOLD mp3an12 ) AEFBEFABGHBAICDABJK $.

    $( Trichotomy law for 'less than or equal to'.  (Contributed by NM,
       2-Aug-1999.) $)
    letrii $p |- ( A <_ B \/ B <_ A ) $=
      ( cle wbr wn clt ltnlei ltlei sylbir orri ) ABEFZBAEFZMGBAHFNBADCIBADCJKL
      $.

    ${
      lt.3 $e |- C e. RR $.
      $( 'Less than' is transitive.  Theorem I.17 of [Apostol] p. 20.
         (Contributed by NM, 14-May-1999.) $)
      lttri $p |- ( ( A < B /\ B < C ) -> A < C ) $=
        ( cr wcel clt wbr wa wi lttr mp3an ) AGHBGHCGHABIJBCIJKACIJLDEFABCMN $.

      $( 'Less than or equal to', 'less than' transitive law.  (Contributed by
         NM, 14-May-1999.) $)
      lelttri $p |- ( ( A <_ B /\ B < C ) -> A < C ) $=
        ( cr wcel cle wbr clt wa wi lelttr mp3an ) AGHBGHCGHABIJBCKJLACKJMDEFAB
        CNO $.

      $( 'Less than', 'less than or equal to' transitive law.  (Contributed by
         NM, 14-May-1999.) $)
      ltletri $p |- ( ( A < B /\ B <_ C ) -> A < C ) $=
        ( cr wcel clt wbr cle wa wi ltletr mp3an ) AGHBGHCGHABIJBCKJLACIJMDEFAB
        CNO $.

      $( 'Less than or equal to' is transitive.  (Contributed by NM,
         14-May-1999.) $)
      letri $p |- ( ( A <_ B /\ B <_ C ) -> A <_ C ) $=
        ( cr wcel cle wbr wa wi letr mp3an ) AGHBGHCGHABIJBCIJKACIJLDEFABCMN $.

      $( Extended trichotomy law for 'less than or equal to'.  (Contributed by
         NM, 14-Aug-2000.) $)
      le2tri3i $p |- ( ( A <_ B /\ B <_ C /\ C <_ A ) <->
                      ( A = B /\ B = C /\ C = A ) ) $=
        ( cle wbr wceq wa letri letri3i biimpri sylan2 3impb 3comr eqcomd sylan
        w3a eqlei 3impa 3jca 3anim123i impbii ) ABGHZBCGHZCAGHZSZABIZBCIZCAIZSU
        HUIUJUKUEUFUGUIUFUGJUEBAGHZUIBCAEFDKUIUEULJABDELMNOUFUGUEUJUFUGUEUJUGUE
        JUFCBGHZUJCABFDEKUJUFUMJBCEFLMNOPUEUFUGUKUEUFJACGHZUGUKABCDEFKUNUGJZACA
        CIUOACDFLMQRUAUBUIUEUJUFUKUGABDTBCETCAFTUCUD $.

      $( Addition to both sides of 'less than'.  (Contributed by NM,
         21-Jan-1997.)  (Proof shortened by Paul Chapman, 27-Jan-2008.) $)
      ltadd2i $p |- ( A < B <-> ( C + A ) < ( C + B ) ) $=
        ( clt wbr caddc co cr wcel wi axltadd mp3an cle wn wceq wo leloei oveq2
        orim12i readdcli 3imtr4i lenlti 3imtr3i con4i impbii ) ABGHZCAIJZCBIJZG
        HZAKLZBKLZCKLZUIULMDEFABCNOUIULBAPHZUKUJPHZUIQULQBAGHZBARZSUKUJGHZUKUJR
        ZSUPUQURUTUSVAUNUMUOURUTMEDFBACNOBACIUAUBBAEDTUKUJCBFEUCZCAFDUCZTUDBAED
        UEUKUJVBVCUEUFUGUH $.
    $}

    $( The product of two positive numbers is positive.  (Contributed by NM,
       16-May-1999.) $)
    mulgt0i $p |- ( ( 0 < A /\ 0 < B ) -> 0 < ( A x. B ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co wi axmulgt0 mp2an ) AEFBEFGAHIGBHIJGABKL
      HIMCDABNO $.

    mulgt0i.3 $e |- 0 < A $.
    mulgt0i.4 $e |- 0 < B $.
    $( The product of two positive numbers is positive.  (Contributed by NM,
       18-May-1999.) $)
    mulgt0ii $p |- 0 < ( A x. B ) $=
      ( cc0 clt wbr cmul co mulgt0i mp2an ) GAHIGBHIGABJKHIEFABCDLM $.
  $}

  ${
    ltd.1 $e |- ( ph -> A e. RR ) $.
    $( 'Less than' is irreflexive.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    ltnrd $p |- ( ph -> -. A < A ) $=
      ( cr wcel clt wbr wn ltnr syl ) ABDEBBFGHCBIJ $.

    ${
      ltned.2 $e |- ( ph -> A < B ) $.
      $( 'Less than' implies not equal.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      gtned $p |- ( ph -> B =/= A ) $=
        ( cr wcel clt wbr wne ltne syl2anc ) ABFGBCHICBJDEBCKL $.

      $( 'Greater than' implies not equal.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      ltned $p |- ( ph -> A =/= B ) $=
        ( gtned necomd ) ACBABCDEFG $.
    $}

    ${
      ne0gt0d.2 $e |- ( ph -> 0 <_ A ) $.
      ne0gt0d.3 $e |- ( ph -> A =/= 0 ) $.
      $( A nonzero nonnegative number is positive.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      ne0gt0d $p |- ( ph -> 0 < A ) $=
        ( cc0 wne clt wbr cr wcel cle wb ne0gt0 syl2anc mpbid ) ABFGZFBHIZEABJK
        FBLIQRMCDBNOP $.
    $}

    ltd.2 $e |- ( ph -> B e. RR ) $.
    $( Ordering on reals satisfies strict trichotomy.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    lttrid $p |- ( ph -> ( A < B <-> -. ( A = B \/ B < A ) ) ) $=
      ( cr wcel clt wbr wceq wo wn wb axlttri syl2anc ) ABFGCFGBCHIBCJCBHIKLMDE
      BCNO $.

    $( Consequence of trichotomy.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    lttri2d $p |- ( ph -> ( A =/= B <-> ( A < B \/ B < A ) ) ) $=
      ( cr wcel wne clt wbr wo wb lttri2 syl2anc ) ABFGCFGBCHBCIJCBIJKLDEBCMN
      $.

    $( Consequence of trichotomy.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    lttri3d $p |- ( ph -> ( A = B <-> ( -. A < B /\ -. B < A ) ) ) $=
      ( cr wcel wceq clt wbr wn wa wb lttri3 syl2anc ) ABFGCFGBCHBCIJKCBIJKLMDE
      BCNO $.

    $( Trichotomy law for 'less than'.  (Contributed by NM, 20-Sep-2007.)
       (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
    lttri4d $p |- ( ph -> ( A < B \/ A = B \/ B < A ) ) $=
      ( cr wcel clt wbr wceq w3o lttri4 syl2anc ) ABFGCFGBCHIBCJCBHIKDEBCLM $.

    $( Consequence of trichotomy.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    letri3d $p |- ( ph -> ( A = B <-> ( A <_ B /\ B <_ A ) ) ) $=
      ( cr wcel wceq cle wbr wa wb letri3 syl2anc ) ABFGCFGBCHBCIJCBIJKLDEBCMN
      $.

    $( 'Less than or equal to' in terms of 'less than'.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    leloed $p |- ( ph -> ( A <_ B <-> ( A < B \/ A = B ) ) ) $=
      ( cr wcel cle wbr clt wceq wo wb leloe syl2anc ) ABFGCFGBCHIBCJIBCKLMDEBC
      NO $.

    $( Equality in terms of 'less than or equal to', 'less than'.  (Contributed
       by NM, 7-Apr-2001.) $)
    eqleltd $p |- ( ph -> ( A = B <-> ( A <_ B /\ -. A < B ) ) ) $=
      ( cr wcel wceq cle wbr clt wn wa wb eqlelt syl2anc ) ABFGCFGBCHBCIJBCKJLM
      NDEBCOP $.

    $( 'Less than' expressed in terms of 'less than or equal to'.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    ltlend $p |- ( ph -> ( A < B <-> ( A <_ B /\ B =/= A ) ) ) $=
      ( cr wcel clt wbr cle wne wa wb ltlen syl2anc ) ABFGCFGBCHIBCJICBKLMDEBCN
      O $.

    $( 'Less than or equal to' in terms of 'less than'.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    lenltd $p |- ( ph -> ( A <_ B <-> -. B < A ) ) $=
      ( cr wcel cle wbr clt wn wb lenlt syl2anc ) ABFGCFGBCHICBJIKLDEBCMN $.

    $( 'Less than' in terms of 'less than or equal to'.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    ltnled $p |- ( ph -> ( A < B <-> -. B <_ A ) ) $=
      ( cr wcel clt wbr cle wn wb ltnle syl2anc ) ABFGCFGBCHICBJIKLDEBCMN $.

    ${
      ltled.1 $e |- ( ph -> A < B ) $.
      $( 'Less than' implies 'less than or equal to'.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      ltled $p |- ( ph -> A <_ B ) $=
        ( clt wbr cle cr wcel wi ltle syl2anc mpd ) ABCGHZBCIHZFABJKCJKPQLDEBCM
        NO $.

      $( 'Less than' implies 'less than or equal to'.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      ltnsymd $p |- ( ph -> -. B < A ) $=
        ( cle wbr clt wn ltled lenltd mpbid ) ABCGHCBIHJABCDEFKABCDELM $.
    $}

    $( Trichotomy law for 'less than or equal to'.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    letrid $p |- ( ph -> ( A <_ B \/ B <_ A ) ) $=
      ( cr wcel cle wbr wo letric syl2anc ) ABFGCFGBCHICBHIJDEBCKL $.

    ${
      leltned.3 $e |- ( ph -> A <_ B ) $.
      $( 'Less than or equal to' implies 'less than' is not 'equals'.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      leltned $p |- ( ph -> ( A < B <-> B =/= A ) ) $=
        ( cr wcel cle wbr clt wne wb leltne syl3anc ) ABGHCGHBCIJBCKJCBLMDEFBCN
        O $.
    $}

    ${
      mulgt0d.3 $e |- ( ph -> 0 < A ) $.
      mulgt0d.4 $e |- ( ph -> 0 < B ) $.
      $( The product of two positive numbers is positive.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      mulgt0d $p |- ( ph -> 0 < ( A x. B ) ) $=
        ( cr wcel cc0 clt wbr cmul co mulgt0 syl22anc ) ABHIJBKLCHIJCKLJBCMNKLD
        FEGBCOP $.
    $}

    letrd.3 $e |- ( ph -> C e. RR ) $.
    $( Addition to both sides of 'less than'.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    ltadd2d $p |- ( ph -> ( A < B <-> ( C + A ) < ( C + B ) ) ) $=
      ( cr wcel clt wbr caddc co wb ltadd2 syl3anc ) ABHICHIDHIBCJKDBLMDCLMJKNE
      FGBCDOP $.

    ${
      letrd.4 $e |- ( ph -> A <_ B ) $.
      letrd.5 $e |- ( ph -> B <_ C ) $.
      $( Transitive law deduction for 'less than or equal to'.  (Contributed by
         NM, 20-May-2005.) $)
      letrd $p |- ( ph -> A <_ C ) $=
        ( cle wbr cr wcel wa wi letr syl3anc mp2and ) ABCJKZCDJKZBDJKZHIABLMCLM
        DLMSTNUAOEFGBCDPQR $.
    $}

    ${
      lelttrd.4 $e |- ( ph -> A <_ B ) $.
      lelttrd.5 $e |- ( ph -> B < C ) $.
      $( Transitive law deduction for 'less than or equal to', 'less than'.
         (Contributed by NM, 8-Jan-2006.) $)
      lelttrd $p |- ( ph -> A < C ) $=
        ( cle wbr clt cr wcel wa wi lelttr syl3anc mp2and ) ABCJKZCDLKZBDLKZHIA
        BMNCMNDMNTUAOUBPEFGBCDQRS $.
    $}

    ${
      ltletrd.4 $e |- ( ph -> A < B ) $.
      $( Addition to both sides of 'less than'.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      ltadd2dd $p |- ( ph -> ( C + A ) < ( C + B ) ) $=
        ( clt wbr caddc co ltadd2d mpbid ) ABCIJDBKLDCKLIJHABCDEFGMN $.

      ltletrd.5 $e |- ( ph -> B <_ C ) $.
      $( Transitive law deduction for 'less than', 'less than or equal to'.
         (Contributed by NM, 9-Jan-2006.) $)
      ltletrd $p |- ( ph -> A < C ) $=
        ( clt wbr cle cr wcel wa wi ltletr syl3anc mp2and ) ABCJKZCDLKZBDJKZHIA
        BMNCMNDMNTUAOUBPEFGBCDQRS $.
    $}

    ${
      lttrd.4 $e |- ( ph -> A < B ) $.
      lttrd.5 $e |- ( ph -> B < C ) $.
      $( Transitive law deduction for 'less than'.  (Contributed by NM,
         9-Jan-2006.) $)
      lttrd $p |- ( ph -> A < C ) $=
        ( clt wbr cr wcel wa wi lttr syl3anc mp2and ) ABCJKZCDJKZBDJKZHIABLMCLM
        DLMSTNUAOEFGBCDPQR $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Initial properties of the complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Commutative/associative law for multiplication.  (Contributed by NM,
     30-Apr-2005.) $)
  mul12 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A x. ( B x. C ) ) = ( B x. ( A x. C ) ) ) $=
    ( cc wcel w3a cmul co wceq wa mulcom oveq1d 3adant3 mulass 3com12 3eqtr3d )
    ADEZBDEZCDEZFABGHZCGHZBAGHZCGHZABCGHGHBACGHGHZQRUAUCISQRJTUBCGABKLMABCNRQSU
    CUDIBACNOP $.

  $( Commutative/associative law.  (Contributed by NM, 8-Oct-1999.) $)
  mul32 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A x. B ) x. C ) = ( ( A x. C ) x. B ) ) $=
    ( cc wcel w3a cmul co wceq wa mulcom oveq2d 3adant1 mulass 3com23 3eqtr4d )
    ADEZBDEZCDEZFABCGHZGHZACBGHZGHZABGHCGHACGHBGHZRSUAUCIQRSJTUBAGBCKLMABCNQSRU
    DUCIACBNOP $.

  $( Commutative/associative law.  (Contributed by Scott Fenton,
     3-Jan-2013.) $)
  mul31 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A x. B ) x. C ) = ( ( C x. B ) x. A ) ) $=
    ( cc wcel cmul co wceq wa mulcom oveq2d 3adant1 mulass mulcl ancoms mulcomd
    w3a simp1 3eqtr4d ) ADEZBDEZCDEZQZABCFGZFGZACBFGZFGZABFGCFGUFAFGUAUBUEUGHTU
    AUBIUDUFAFBCJKLABCMUCUFAUAUBUFDEZTUBUAUHCBNOLTUAUBRPS $.

  $( Rearrangement of 4 factors.  (Contributed by NM, 8-Oct-1999.) $)
  mul4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A x. B ) x. ( C x. D ) ) =
                 ( ( A x. C ) x. ( B x. D ) ) ) $=
    ( cc wcel wa cmul co wceq w3a mul32 oveq1d 3expa adantrr mulcl mulass 3expb
    sylan an4s 3eqtr3d ) AEFZBEFZGZCEFZDEFZGZGABHIZCHIZDHIZACHIZBHIZDHIZUHCDHIH
    IZUKBDHIHIZUDUEUJUMJZUFUBUCUEUPUBUCUEKUIULDHABCLMNOUDUHEFZUGUJUNJZABPUQUEUF
    URUHCDQRSUBUEUCUFUMUOJZUBUEGUKEFZUCUFGUSACPUTUCUFUSUKBDQRSTUA $.

  $( A simple product of sums expansion.  (Contributed by NM, 21-Feb-2005.) $)
  muladd11 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( 1 + A ) x. ( 1 + B ) ) =
                 ( ( 1 + A ) + ( B + ( A x. B ) ) ) ) $=
    ( cc wcel wa c1 caddc cmul wceq ax-1cn addcl mpan adddi mp3an2 sylan adantr
    co mulid1d adddir eqtrd mp3an1 mulid2 adantl oveq1d oveq12d ) ACDZBCDZEZFAG
    QZFBGQHQZUIFHQZUIBHQZGQZUIBABHQZGQZGQUFUICDZUGUJUMIZFCDZUFUPJFAKLZUPURUGUQJ
    UIFBMNOUHUKUIULUOGUFUKUIIUGUFUIUSRPUHULFBHQZUNGQZUOURUFUGULVAIJFABSUAUHUTBU
    NGUGUTBIUFBUBUCUDTUET $.

  $( Two times a number.  (Contributed by NM, 18-May-1999.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  1p1times $p |- ( A e. CC -> ( ( 1 + 1 ) x. A ) = ( A + A ) ) $=
    ( cc wcel c1 caddc co cmul ax-1cn a1i id adddird mulid2 oveq12d eqtrd ) ABC
    ZDDEFAGFDAGFZPEFAAEFODDADBCOHIZQOJKOPAPAEALZRMN $.

  $( A theorem for complex numbers analogous the second Peano postulate
     ~ peano2nn .  (Contributed by NM, 17-Aug-2005.) $)
  peano2cn $p |- ( A e. CC -> ( A + 1 ) e. CC ) $=
    ( cc wcel c1 caddc co ax-1cn addcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( A theorem for reals analogous the second Peano postulate ~ peano2nn .
     (Contributed by NM, 5-Jul-2005.) $)
  peano2re $p |- ( A e. RR -> ( A + 1 ) e. RR ) $=
    ( cr wcel c1 caddc co 1re readdcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( Cancellation law for addition over the reals.  (Contributed by Scott
     Fenton, 3-Jan-2013.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  readdcan $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( C + A ) = ( C + B ) <-> A = B ) ) $=
    ( cr wcel w3a clt wbr wn wa caddc co wceq ltadd2 notbid simp2 simp1 lttri3d
    simp3 readdcld ltadd2d anbi12d 3bitr4rd ) ADEZBDEZCDEZFZABGHZIZBAGHZIZJCAKL
    ZCBKLZGHZIZUMULGHZIZJABMULUMMUGUIUOUKUQUGUHUNABCNOUGUJUPUGBACUDUEUFPZUDUEUF
    QZUDUEUFSZUAOUBUGABUSURRUGULUMUGCAUTUSTUGCBUTURTRUC $.

  ${
    $d c y $.
    $( ` 0 ` is its own additive identity.  (Contributed by Scott Fenton,
       3-Jan-2013.) $)
    00id $p |- ( 0 + 0 ) = 0 $=
      ( vc vy cc0 cr wcel cv caddc co wceq 0re wa cmul c1 cc 0cn syl2anc eqtr3d
      recnd oveq1d remulcl wrex ax-rnegex oveq2 eqeq1d biimpd adantld ax-rrecex
      wi wne adantlr simplll simprl mulass mp3an3 oveq1 mulid2i syl6eq ad2antll
      simpllr mpan2 ad2antrl adddir mp3an1 sylancr addass eqtr2d sylan2 readdcl
      sylancl readdcan mp3an2 mpbid rexlimddv expcom pm2.61ine rexlimiva mp2b
      wb ) CDEZCAFZGHZCIZADUACCGHZCIZJACUBWBWDADVTDEZWBKZWDUHVTCVTCIZWBWDWEWGWB
      WDWGWAWCCVTCCGUCUDUEUFWFVTCUIZWDWFWHKZVTBFZLHZMIZWDBDWEWHWLBDUAWBBVTUGUJW
      IWJDEZWLKZKZVTWJCLHZLHZCGHZWCCWOWQCCGWOWKCLHZWQCWOVTNEZWJNEZWSWQIZWOVTWEW
      BWHWNUKZRZWOWJWIWMWLULZRWTXACNEZXBOVTWJCUMUNPWLWSCIWIWMWLWSMCLHCWKMCLUOCO
      UPUQURQSWOCWPLHZWRGHZXGCGHZIZWRCIZWOXIXGWQGHZCGHZXHWOXGXLCGWOWAWPLHZXGXLW
      OWACWPLWEWBWHWNUSSWOWTWPNEZXNXLIZXDWOWPWMWPDEZWIWLWMVSXQJWJCTUTZVAZRXFWTX
      OXPOCVTWPVBVCPQSWOXGNEZWQNEZXMXHIZWOXGWMXGDEZWIWLWMVSXQYCJXRCWPTVDVAZRWOW
      QWOWEXQWQDEZXCXSVTWPTZPRXTYAXFYBOXGWQCVEUNPVFWOWRDEZYCXJXKVRZWOWEWMYGXCXE
      WEWMKYEVSYGWMWEXQYEXRYFVGJWQCVHVIPYDYGVSYCYHJWRCXGVJVKPVLQVMVNVOVPVQ $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( Lemma for ~ mul02 .  If any real does not produce ` 0 ` when multiplied
       by ` 0 ` , then any complex is equal to double itself.  (Contributed by
       Scott Fenton, 3-Jan-2013.) $)
    mul02lem1 $p |- ( ( ( A e. RR /\ ( 0 x. A ) =/= 0 ) /\ B e. CC ) ->
                       B = ( B + B ) ) $=
      ( vy cr wcel cc0 cmul co wne wa cc c1 wceq caddc recnd mulcld 0cn syl2anc
      mp3an3 eqtrd cv wrex 0re remulcl mpan ax-rrecex adantr 00id oveq2i eqcomi
      sylan simprl simplll simplr mul32 mul31 simprr oveq1d mulid2 ad2antlr syl
      adddi mp3an23 oveq12d 3eqtr3a rexlimddv ) ADEZFAGHZFIZJZBKEZJZVHCUAZGHZLM
      ZBBBNHZMCDVJVOCDUBZVKVGVHDEZVIVQFDEVGVRUCFAUDUECVHUFUKUGVLVMDEZVOJZJZVMAG
      HZBGHZFGHZWCFFNHZGHZBVPWFWDWEFWCGUHUIUJWAWDWBFGHZBGHZBWAWBKEZVKWDWHMZWAVM
      AWAVMVLVSVOULOZWAAVGVIVKVTUMOZPZVJVKVTUNZWIVKFKEZWJQWBBFUOSRWAWHLBGHZBWAW
      GLBGWAWGVNLWAVMKEZAKEZWGVNMZWKWLWQWRWOWSQVMAFUPSRVLVSVOUQTURVKWPBMVJVTBUS
      UTTTZWAWFWDWDNHZVPWAWCKEZWFXAMZWAWBBWMWNPXBWOWOXCQQWCFFVBVCVAWAWDBWDBNWTW
      TVDTVEVF $.
  $}

  $( Lemma for ~ mul02 .  Zero times a real is zero.  (Contributed by Scott
     Fenton, 3-Jan-2013.) $)
  mul02lem2 $p |- ( A e. RR -> ( 0 x. A ) = 0 ) $=
    ( cr wcel c1 cc0 cmul co wceq ax-1ne0 wa caddc ci cc ax-1cn mul02lem1 mpan2
    wne ax-icn ax-i2m1 0re eqcomd oveq2d mulcli addassi oveq1i eqtr3i eqtr4i wb
    00id 3eqtr3g 1re readdcan mp3an sylib ex necon1d mpi ) ABCZDEQEAFGZEHIURUSE
    DEURUSEQZDEHZURUTJZEDKGZEEKGZHZVAVBLLFGZDDKGZKGZVFDKGZVCVDVBVGDVFKVBDVGVBDM
    CDVGHNADOPUAUBVIDKGVHVCVFDDLLRRUCNNUDVIEDKSUEUFVIEVDSUIUGUJDBCEBCZVJVEVAUHU
    KTTDEEULUMUNUOUPUQ $.

  ${
    $d A x y $.
    $( Multiplication by ` 0 ` .  Theorem I.6 of [Apostol] p. 18.  Based on
       ideas by Eric Schmidt.  (Contributed by NM, 10-Aug-1999.)  (Revised by
       Scott Fenton, 3-Jan-2013.) $)
    mul02 $p |- ( A e. CC -> ( 0 x. A ) = 0 ) $=
      ( vx vy cc wcel cv ci cmul co caddc wceq cr wrex cc0 cnre recn ax-icn 0cn
      mul02lem2 ax-mp wa mulcl sylancr adddi mp3an1 syl2an mul12 mp3an12 oveq2d
      syl eqtrd oveqan12d oveq2 eqeq1d syl5ibrcom rexlimivv 0re eqtr3i syl6eq )
      ADEABFZGCFZHIZJIZKZCLMBLMNAHIZNKZBCAOVDVFBCLLUTLEZVALEZUAZVFVDNVCHIZNKVIV
      JNGNHIZJIZNVIVJNUTHIZNVBHIZJIZVLVGUTDEZVBDEZVJVOKZVHUTPVHGDEZVADEZVQQVAPZ
      GVAUBUCNDEZVPVQVRRNUTVBUDUEUFVGVHVMNVNVKJUTSVHVNGNVAHIZHIZVKVHVTVNWDKZWAW
      BVSVTWERQNGVAUGUHUJVHWCNGHVASUIUKULUKZNNHIZVLNNVCKZCLMBLMZWGVLKZWBWIRBCNO
      TWHWJBCLLVIWJWHVJVLKWFWHWGVJVLNVCNHUMUNUOUPTNLEWGNKUQNSTURUSVDVEVJNAVCNHU
      MUNUOUPUJ $.
  $}

  $( Multiplication by ` 0 ` .  Theorem I.6 of [Apostol] p. 18.  (Contributed
     by NM, 15-May-1999.)  (Revised by Scott Fenton, 3-Jan-2013.) $)
  mul01 $p |- ( A e. CC -> ( A x. 0 ) = 0 ) $=
    ( cc wcel cc0 cmul co wceq 0cn mulcom mpan2 mul02 eqtrd ) ABCZADEFZDAEFZDMD
    BCNOGHADIJAKL $.

  ${
    $d A c x $.
    $( ` 0 ` is an additive identity.  This used to be one of our complex
       number axioms, until it was found to be dependent on the others.  Based
       on ideas by Eric Schmidt.  (Contributed by Scott Fenton, 3-Jan-2013.)
       (Proof shortened by Mario Carneiro, 27-May-2016.) $)
    addid1 $p |- ( A e. CC -> ( A + 0 ) = A ) $=
      ( vc vx c1 cr wcel caddc co cc0 wceq cc 1re wa ci ax-1cn mul01 eqtr3i 0re
      cmul a1i cv wrex ax-rnegex wne ax-1ne0 oveq2 eqeq1d biimpcd ax-icn mulcli
      wi 0cn adddii mulid1i ax-mp ax-i2m1 eqtr4i oveq12i eqeq12i addassi oveq2i
      eqtri oveq1i 00id eqcomi wb readdcan mp3an 3bitri sylib necon3d ax-rrecex
      syl6 mpi sylan2 simpr simplrl recnd mulcld simplll adddid addassd simpllr
      oveq1d eqtr3d 3eqtr4a readdcld syl3anc mpbid oveq2d mul31 simplrr mulid2d
      3eqtrd syl oveq12d 3eqtr3d exp42 rexlimdv mpd rexlimiva mp2b ) DEFZDBUAZG
      HZIJZBEUBAKFZAIGHZAJZUKZLBDUCXFXJBEXDEFZXFMZXDCUAZSHZDJZCEUBZXJXFXKXDIUDZ
      XPXFDIUDXQUEXFXDIDIXFXDIJZDIGHZIJZDIJZXRXFXTXRXEXSIXDIDGUFUGUHXTNNSHZYBSH
      ZXSSHZYCISHZJZYAXSIYCSUFYFYCYBDGHZGHZIJIDGHZIIGHZJZYAYDYHYEIYDYCDSHZYEGHY
      HYCDIYBYBNNUIUIUJZYMUJZOULUMYLYCYEYGGYCYNUNYEIYGYCKFYEIJYNYCPUOZUPUQURVBY
      OUSYHYIIYJYCYBGHZDGHYHYIYCYBDYNYMOUTYPIDGYCYBDSHZGHZYPIYQYBYCGYBYMUNVAYBY
      GSHZYRIYBYBDYMYMOUMYSYBISHZIYGIYBSUPVAYBKFYTIJYMYBPUOVBQQVCQYJIVDVEUSXCIE
      FZUUAYKYAVFLRRDIIVGVHVIVJVMVKVNCXDVLVOXLXOXJCEXLXMEFZXOXGXIXLUUBXOMZMZXGM
      ZAXMSHZXDSHZUUFISHZGHZUUGXHAUUEUUFXDIGHZSHUUIUUGUUEUUFXDIUUEAXMUUDXGVPZUU
      EXMXLUUBXOXGVQVRZVSZUUEXDXKXFUUCXGVTZVRZIKFUUEULTZWAUUEUUJXDUUFSUUEDUUJGH
      ZXEJZUUJXDJZUUEYJIUUQXEVDUUEXEIGHUUQYJUUEDXDIDKFUUEOTUUOUUPWBUUEXEIIGXKXF
      UUCXGWCZWDWEUUTWFUUEUUJEFXKXCUURUUSVFUUEXDIUUNUUAUUERTWGUUNXCUUELTUUJXDDV
      GWHWIWJWEUUEUUGAUUHIGUUEUUGXNASHZDASHAUUEXGXMKFXDKFUUGUVAJUUKUULUUOAXMXDW
      KWHUUEXNDASXLUUBXOXGWLWDUUEAUUKWMWNZUUEUUFKFUUHIJUUMUUFPWOWPUVBWQWRWSWTXA
      XB $.
  $}

  ${
    $d A x a b c d $.
    $( Existence of the negative of a complex number.  (Contributed by Eric
       Schmidt, 21-May-2007.)  (Revised by Scott Fenton, 3-Jan-2013.)  (Proof
       shortened by Mario Carneiro, 27-May-2016.) $)
    cnegex $p |- ( A e. CC -> E. x e. CC ( A + x ) = 0 ) $=
      ( va vb vc vd cc wcel cv ci cmul co caddc wceq cr wrex cc0 recnd eqtr3d
      wa cnre ax-rnegex anim12i reeanv sylibr ax-icn a1i simplrr mulcld simplrl
      addcld simplll simpllr adddid simprr oveq2d mul01 ax-mp syl6eq addid1 syl
      addassd 3eqtrd oveq1d simprl oveq2 eqeq1d rspcev syl2anc rexlimdvva oveq1
      ex mpd rexbidv syl5ibrcom rexlimivv ) BGHBCIZJDIZKLZMLZNZDOPCOPBAIZMLZQNZ
      AGPZCDBUAWAWECDOOVQOHZVROHZTZWEWAVTWBMLZQNZAGPZWHVQEIZMLZQNZVRFIZMLZQNZTZ
      FOPEOPZWKWHWNEOPZWQFOPZTWSWFWTWGXAEVQUBFVRUBUCWNWQEFOOUDUEWHWRWKEFOOWHWLO
      HZWOOHZTZTZWRWKXEWRTZJWOKLZWLMLZGHVTXHMLZQNZWKXFXGWLXFJWOJGHZXFUFUGZXFWOW
      HXBXCWRUHRZUIZXFWLWHXBXCWRUJRZUKXFWMXIQXFVTXGMLZWLMLWMXIXFXPVQWLMXFXPVQVS
      XGMLZMLVQQMLZVQXFVQVSXGXFVQWFWGXDWRULRZXFJVRXLXFVRWFWGXDWRUMRZUIZXNVBXFXQ
      QVQMXFJWPKLZXQQXFJVRWOXLXTXMUNXFYBJQKLZQXFWPQJKXEWNWQUOUPXKYCQNUFJUQURUSS
      UPXFVQGHXRVQNXSVQUTVAVCVDXFVTXGWLXFVQVSXSYAUKXNXOVBSXEWNWQVESWJXJAXHGWBXH
      NWIXIQWBXHVTMVFVGVHVIVLVJVMWAWDWJAGWAWCWIQBVTWBMVKVGVNVOVPVA $.
  $}

  ${
    $d A x $.
    $( Existence of a left inverse for addition.  (Contributed by Scott Fenton,
       3-Jan-2013.) $)
    cnegex2 $p |- ( A e. CC -> E. x e. CC ( x + A ) = 0 ) $=
      ( cc wcel ci cmul co caddc cc0 wceq cv wrex ax-icn mulcli mulcl c1 mulid2
      mpan oveq2d ax-i2m1 oveq1i ax-1cn adddir mul02 eqtr3d oveq1 eqeq1d rspcev
      mp3an12 3eqtr3a syl2anc ) BCDZEEFGZBFGZCDZUNBHGZIJZAKZBHGZIJZACLUMCDZULUO
      EEMMNZUMBORULUNPBFGZHGZUPIULVCBUNHBQSULUMPHGZBFGZIBFGVDIVEIBFTUAVAPCDULVF
      VDJVBUBUMPBUCUIBUDUJUEUTUQAUNCURUNJUSUPIURUNBHUFUGUHUK $.
  $}

  ${
    $d x y A $.  $d x B $.  $d x C $.
    $( ` 0 ` is a left identity for addition.  This used to be one of our
       complex number axioms, until it was discovered that it was dependent on
       the others.  Based on ideas by Eric Schmidt.  (Contributed by Scott
       Fenton, 3-Jan-2013.) $)
    addid2 $p |- ( A e. CC -> ( 0 + A ) = A ) $=
      ( vx vy cc wcel cv caddc co cc0 wceq cnegex wrex ad2antrl w3a 0cn mp3an12
      wa addass oveq2d 3eqtr3rd adantr 3ad2ant3 00id oveq1i simp1 simp2l simp3l
      addassd simp2r oveq1d simp3r addid1 3ad2ant1 eqtr3d syl5eq exp3a rexlimdv
      3expia mpd rexlimddv ) ADEZABFZGHZIJZIAGHZAJZBDBAKVAVBDEZVDQZQZVBCFZGHZIJ
      ZCDLZVFVGVMVAVDCVBKMVIVLVFCDVIVJDEZVLVFVAVHVNVLQZVFVAVHVONZIIGHZVJGHZIIVJ
      GHZGHZAVEVOVAVRVTJZVHVNWAVLIDEZWBVNWAOOIIVJRPUAUBVPVRVSAVQIVJGUCUDVPAIGHZ
      VSAVPVCVJGHAVKGHVSWCVPAVBVJVAVHVOUEVAVGVDVOUFVAVHVNVLUGUHVPVCIVJGVAVGVDVO
      UIUJVPVKIAGVAVHVNVLUKSTVAVHWCAJVOAULUMUNZUOVPVSAIGWDSTURUPUQUSUT $.

    $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18.
       (Contributed by NM, 22-Nov-1994.)  (Proof shortened by Mario Carneiro,
       27-May-2016.) $)
    addcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                   ( ( A + B ) = ( A + C ) <-> B = C ) ) $=
      ( vx cc wcel w3a cv caddc co cc0 wceq wb wa oveq1d addassd addid2 3eqtr3d
      oveq2 syl wrex cnegex2 3ad2ant1 simprr simprl simpl1 simpl2 simpl3 syl5ib
      eqeq12d impbid1 rexlimddv ) AEFZBEFZCEFZGZDHZAIJZKLZABIJZACIJZLZBCLZMDEUM
      UNUSDEUAUODAUBUCUPUQEFZUSNZNZVBVCVBUQUTIJZUQVAIJZLVFVCUTVAUQISVFVGBVHCVFU
      RBIJKBIJZVGBVFURKBIUPVDUSUDZOVFUQABUPVDUSUEZUMUNUOVEUFZUMUNUOVEUGZPVFUNVI
      BLVMBQTRVFURCIJKCIJZVHCVFURKCIVJOVFUQACVKVLUMUNUOVEUHZPVFUOVNCLVOCQTRUJUI
      BCAISUKUL $.

    $( Cancellation law for addition.  (Contributed by NM, 30-Jul-2004.)
       (Revised by Scott Fenton, 3-Jan-2013.) $)
    addcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                    ( ( A + C ) = ( B + C ) <-> A = B ) ) $=
      ( vx cc wcel w3a cv caddc co cc0 wb wa oveq1 addassd oveq2d addid1 3eqtrd
      wceq syl wrex cnegex 3ad2ant3 simpl1 simpl3 simprl simprr eqeq12d impbid1
      simpl2 syl5ib rexlimddv ) AEFZBEFZCEFZGZCDHZIJZKSZACIJZBCIJZSZABSZLDEUOUM
      USDEUAUNDCUBUCUPUQEFZUSMZMZVBVCVBUTUQIJZVAUQIJZSVFVCUTVAUQINVFVGAVHBVFVGA
      URIJAKIJZAVFACUQUMUNUOVEUDZUMUNUOVEUEZUPVDUSUFZOVFURKAIUPVDUSUGZPVFUMVIAS
      VJAQTRVFVHBURIJBKIJZBVFBCUQUMUNUOVEUJZVKVLOVFURKBIVMPVFUNVNBSVOBQTRUHUKAB
      CINUIUL $.
  $}

  $( Addition commutes.  This used to be one of our complex number axioms,
     until it was found to be dependent on the others.  Based on ideas by Eric
     Schmidt.  (Contributed by Scott Fenton, 3-Jan-2013.) $)
  addcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) = ( B + A ) ) $=
    ( cc wcel wa caddc co wceq c1 cmul ax-1cn a1i addcld simpl 1p1times addassd
    simpr wb syl3anc mpbid adddid syl oveqan12d 3eqtr3rd 3eqtr4d addcan2 addcan
    3eqtr3d ) ACDZBCDZEZAABFGZFGZABAFGZFGZHZULUNHZUKAAFGZBFGZULAFGZUMUOUKUSBFGZ
    UTBFGZHZUSUTHZUKURBBFGZFGZULULFGZVAVBUKIIFGZULJGZVHAJGZVHBJGZFGVGVFUKVHABUK
    IIICDUKKLZVLMUIUJNZUIUJQZUAUKULCDZVIVGHUKABVMVNMZULOUBUIUJVJURVKVEFAOBOUCUD
    UKURBBUKAAVMVMMZVNVNPUKULABVPVMVNPUEUKUSCDUTCDUJVCVDRUKURBVQVNMUKULAVPVMMVN
    USUTBUFSTUKAABVMVMVNPUKABAVMVNVMPUHUKUIVOUNCDUPUQRVMVPUKBAVNVMMAULUNUGST $.

  ${
    mul.1 $e |- A e. CC $.
    $( ` 0 ` is an additive identity.  (Contributed by NM, 23-Nov-1994.)
       (Revised by Scott Fenton, 3-Jan-2013.) $)
    addid1i $p |- ( A + 0 ) = A $=
      ( cc wcel cc0 caddc co wceq addid1 ax-mp ) ACDAEFGAHBAIJ $.

    $( ` 0 ` is a left identity for addition.  (Contributed by Mario Carneiro,
       3-Jan-2013.) $)
    addid2i $p |- ( 0 + A ) = A $=
      ( cc wcel cc0 caddc co wceq addid2 ax-mp ) ACDEAFGAHBAIJ $.

    $( Multiplication by 0.  Theorem I.6 of [Apostol] p. 18.  (Contributed by
       NM, 23-Nov-1994.) $)
    mul02i $p |- ( 0 x. A ) = 0 $=
      ( cc wcel cc0 cmul co wceq mul02 ax-mp ) ACDEAFGEHBAIJ $.

    $( Multiplication by ` 0 ` .  Theorem I.6 of [Apostol] p. 18.  (Contributed
       by NM, 23-Nov-1994.)  (Revised by Scott Fenton, 3-Jan-2013.) $)
    mul01i $p |- ( A x. 0 ) = 0 $=
      ( cc wcel cc0 cmul co wceq mul01 ax-mp ) ACDAEFGEHBAIJ $.

    mul.2 $e |- B e. CC $.
    $( Addition commutes.  Based on ideas by Eric Schmidt.  (Contributed by
       Scott Fenton, 3-Jan-2013.) $)
    addcomi $p |- ( A + B ) = ( B + A ) $=
      ( cc wcel caddc co wceq addcom mp2an ) AEFBEFABGHBAGHICDABJK $.

    ${
      addcomli.2 $e |- ( A + B ) = C $.
      $( Addition commutes.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
      addcomli $p |- ( B + A ) = C $=
        ( caddc co addcomi eqtri ) BAGHABGHCBAEDIFJ $.
    $}

    mul.3 $e |- C e. CC $.
    $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18.
       (Contributed by NM, 27-Oct-1999.)  (Revised by Scott Fenton,
       3-Jan-2013.) $)
    addcani $p |- ( ( A + B ) = ( A + C ) <-> B = C ) $=
      ( cc wcel caddc co wceq wb addcan mp3an ) AGHBGHCGHABIJACIJKBCKLDEFABCMN
      $.

    $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18.
       (Contributed by NM, 14-May-2003.)  (Revised by Scott Fenton,
       3-Jan-2013.) $)
    addcan2i $p |- ( ( A + C ) = ( B + C ) <-> A = B ) $=
      ( cc wcel caddc co wceq wb addcan2 mp3an ) AGHBGHCGHACIJBCIJKABKLDEFABCMN
      $.

    $( Commutative/associative law that swaps the first two factors in a triple
       product.  (Contributed by NM, 11-May-1999.)  (Proof shortened by Andrew
       Salmon, 19-Nov-2011.) $)
    mul12i $p |- ( A x. ( B x. C ) ) = ( B x. ( A x. C ) ) $=
      ( cc wcel cmul co wceq mul12 mp3an ) AGHBGHCGHABCIJIJBACIJIJKDEFABCLM $.

    $( Commutative/associative law that swaps the last two factors in a triple
       product.  (Contributed by NM, 11-May-1999.) $)
    mul32i $p |- ( ( A x. B ) x. C ) = ( ( A x. C ) x. B ) $=
      ( cc wcel cmul co wceq mul32 mp3an ) AGHBGHCGHABIJCIJACIJBIJKDEFABCLM $.

    mul4.4 $e |- D e. CC $.
    $( Rearrangement of 4 factors.  (Contributed by NM, 16-Feb-1995.) $)
    mul4i $p |- ( ( A x. B ) x. ( C x. D ) ) =
               ( ( A x. C ) x. ( B x. D ) ) $=
      ( cc wcel cmul co wceq mul4 mp4an ) AIJBIJCIJDIJABKLCDKLKLACKLBDKLKLMEFGH
      ABCDNO $.
  $}

  ${
    muld.1 $e |- ( ph -> A e. CC ) $.
    $( Multiplication by 0.  Theorem I.6 of [Apostol] p. 18.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    mul02d $p |- ( ph -> ( 0 x. A ) = 0 ) $=
      ( cc wcel cc0 cmul co wceq mul02 syl ) ABDEFBGHFICBJK $.

    $( Multiplication by ` 0 ` .  Theorem I.6 of [Apostol] p. 18.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    mul01d $p |- ( ph -> ( A x. 0 ) = 0 ) $=
      ( cc wcel cc0 cmul co wceq mul01 syl ) ABDEBFGHFICBJK $.

    $( ` 0 ` is an additive identity.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    addid1d $p |- ( ph -> ( A + 0 ) = A ) $=
      ( cc wcel cc0 caddc co wceq addid1 syl ) ABDEBFGHBICBJK $.

    $( ` 0 ` is a left identity for addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    addid2d $p |- ( ph -> ( 0 + A ) = A ) $=
      ( cc wcel cc0 caddc co wceq addid2 syl ) ABDEFBGHBICBJK $.

    addcomd.2 $e |- ( ph -> B e. CC ) $.
    $( Addition commutes.  Based on ideas by Eric Schmidt.  (Contributed by
       Scott Fenton, 3-Jan-2013.)  (Revised by Mario Carneiro, 27-May-2016.) $)
    addcomd $p |- ( ph -> ( A + B ) = ( B + A ) ) $=
      ( caddc co wceq c1 cmul cc wcel ax-1cn addcld 1p1times addassd wb syl3anc
      syl mpbid a1i adddid oveq12d 3eqtr3rd 3eqtr4d addcan2 3eqtr3d addcan ) AB
      BCFGZFGZBCBFGZFGZHZUIUKHZABBFGZCFGZUIBFGZUJULAUPCFGZUQCFGZHZUPUQHZAUOCCFG
      ZFGZUIUIFGZURUSAIIFGZUIJGZVEBJGZVECJGZFGVDVCAVEBCAIIIKLAMUAZVINDEUBAUIKLZ
      VFVDHABCDENZUIOSAVGUOVHVBFABKLZVGUOHDBOSACKLZVHVBHECOSUCUDAUOCCABBDDNZEEP
      AUIBCVKDEPUEAUPKLUQKLVMUTVAQAUOCVNENAUIBVKDNEUPUQCUFRTABBCDDEPABCBDEDPUGA
      VLVJUKKLUMUNQDVKACBEDNBUIUKUHRT $.

    addcand.3 $e |- ( ph -> C e. CC ) $.
    $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    addcand $p |- ( ph -> ( ( A + B ) = ( A + C ) <-> B = C ) ) $=
      ( cc wcel caddc co wceq wb addcan syl3anc ) ABHICHIDHIBCJKBDJKLCDLMEFGBCD
      NO $.

    $( Cancellation law for addition.  Theorem I.1 of [Apostol] p. 18.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    addcan2d $p |- ( ph -> ( ( A + C ) = ( B + C ) <-> A = B ) ) $=
      ( cc wcel caddc co wceq wb addcan2 syl3anc ) ABHICHIDHIBDJKCDJKLBCLMEFGBC
      DNO $.

    ${
      addcanad.4 $e |- ( ph -> ( A + B ) = ( A + C ) ) $.
      $( Cancelling a term on the left-hand side of a sum in an equality.
         Consequence of ~ addcand .  (Contributed by David Moews,
         28-Feb-2017.) $)
      addcanad $p |- ( ph -> B = C ) $=
        ( caddc co wceq addcand mpbid ) ABCIJBDIJKCDKHABCDEFGLM $.
    $}

    ${
      addcan2ad.4 $e |- ( ph -> ( A + C ) = ( B + C ) ) $.
      $( Cancelling a term on the right-hand side of a sum in an equality.
         Consequence of ~ addcan2d .  (Contributed by David Moews,
         28-Feb-2017.) $)
      addcan2ad $p |- ( ph -> A = B ) $=
        ( caddc co wceq addcan2d mpbid ) ABDIJCDIJKBCKHABCDEFGLM $.
    $}

    ${
      addneintrd.4 $e |- ( ph -> B =/= C ) $.
      $( Introducing a term on the left-hand side of a sum in a negated
         equality.  Contrapositive of ~ addcanad .  Consequence of ~ addcand .
         (Contributed by David Moews, 28-Feb-2017.) $)
      addneintrd $p |- ( ph -> ( A + B ) =/= ( A + C ) ) $=
        ( caddc co wne addcand necon3bid mpbird ) ABCIJZBDIJZKCDKHAOPCDABCDEFGL
        MN $.
    $}

    ${
      addneintr2d.4 $e |- ( ph -> A =/= B ) $.
      $( Introducing a term on the right-hand side of a sum in a negated
         equality.  Contrapositive of ~ addcan2ad .  Consequence of
         ~ addcan2d .  (Contributed by David Moews, 28-Feb-2017.) $)
      addneintr2d $p |- ( ph -> ( A + C ) =/= ( B + C ) ) $=
        ( caddc co wne addcan2d necon3bid mpbird ) ABDIJZCDIJZKBCKHAOPBCABCDEFG
        LMN $.
    $}

    $( Commutative/associative law that swaps the first two factors in a triple
       product.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    mul12d $p |- ( ph -> ( A x. ( B x. C ) ) = ( B x. ( A x. C ) ) ) $=
      ( cc wcel cmul co wceq mul12 syl3anc ) ABHICHIDHIBCDJKJKCBDJKJKLEFGBCDMN
      $.

    $( Commutative/associative law that swaps the last two factors in a triple
       product.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    mul32d $p |- ( ph -> ( ( A x. B ) x. C ) = ( ( A x. C ) x. B ) ) $=
      ( cc wcel cmul co wceq mul32 syl3anc ) ABHICHIDHIBCJKDJKBDJKCJKLEFGBCDMN
      $.

    $( Commutative/associative law.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mul31d $p |- ( ph -> ( ( A x. B ) x. C ) = ( ( C x. B ) x. A ) ) $=
      ( cc wcel cmul co wceq mul31 syl3anc ) ABHICHIDHIBCJKDJKDCJKBJKLEFGBCDMN
      $.

    mul4d.4 $e |- ( ph -> D e. CC ) $.
    $( Rearrangement of 4 factors.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mul4d $p |- ( ph -> ( ( A x. B ) x. ( C x. D ) ) =
                        ( ( A x. C ) x. ( B x. D ) ) ) $=
      ( cc wcel cmul co wceq mul4 syl22anc ) ABJKCJKDJKEJKBCLMDELMLMBDLMCELMLMN
      FGHIBCDEOP $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
             Real and complex numbers - basic operations
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Addition
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Commutative/associative law that swaps the first two terms in a triple
     sum.  (Contributed by NM, 11-May-2004.) $)
  add12 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A + ( B + C ) ) = ( B + ( A + C ) ) ) $=
    ( cc wcel w3a caddc co wceq wa addcom oveq1d 3adant3 addass 3com12 3eqtr3d
    ) ADEZBDEZCDEZFABGHZCGHZBAGHZCGHZABCGHGHBACGHGHZQRUAUCISQRJTUBCGABKLMABCNRQ
    SUCUDIBACNOP $.

  $( Commutative/associative law that swaps the last two terms in a triple
     sum.  (Contributed by NM, 13-Nov-1999.) $)
  add32 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A + B ) + C ) = ( ( A + C ) + B ) ) $=
    ( cc wcel w3a caddc co wceq wa addcom oveq2d 3adant1 addass 3com23 3eqtr4d
    ) ADEZBDEZCDEZFABCGHZGHZACBGHZGHZABGHCGHACGHBGHZRSUAUCIQRSJTUBAGBCKLMABCNQS
    RUDUCIACBNOP $.

  $( Rearrangement of 4 terms in a sum.  (Contributed by NM, 13-Nov-1999.)
     (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  add4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( B + D ) ) ) $=
    ( cc wcel wa caddc wceq add12 3expb oveq2d adantll addcl addass sylan2 an4s
    co 3expa 3eqtr4d ) AEFZBEFZGZCEFZDEFZGZGABCDHRZHRZHRZACBDHRZHRZHRZABHRUGHRZ
    ACHRUJHRZUBUFUIULIUAUBUFGUHUKAHUBUDUEUHUKIBCDJKLMUFUCUGEFZUMUIIZCDNUAUBUOUP
    ABUGOSPUAUDUBUEUNULIZUBUEGUAUDGUJEFZUQBDNUAUDURUQACUJOSPQT $.

  $( Rearrangement of 4 terms in a sum.  (Contributed by NM, 12-May-2005.) $)
  add42 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( D + B ) ) ) $=
    ( cc wcel wa caddc co add4 wceq addcom ad2ant2l oveq2d eqtrd ) AEFZBEFZGCEF
    ZDEFZGGZABHICDHIHIACHIZBDHIZHIUADBHIZHIABCDJTUBUCUAHQSUBUCKPRBDLMNO $.

  ${
    add.1 $e |- A e. CC $.
    add.2 $e |- B e. CC $.
    add.3 $e |- C e. CC $.
    $( Commutative/associative law that swaps the first two terms in a triple
       sum.  (Contributed by NM, 21-Jan-1997.) $)
    add12i $p |- ( A + ( B + C ) ) = ( B + ( A + C ) ) $=
      ( cc wcel caddc co wceq add12 mp3an ) AGHBGHCGHABCIJIJBACIJIJKDEFABCLM $.

    $( Commutative/associative law that swaps the last two terms in a triple
       sum.  (Contributed by NM, 21-Jan-1997.) $)
    add32i $p |- ( ( A + B ) + C ) = ( ( A + C ) + B ) $=
      ( cc wcel caddc co wceq add32 mp3an ) AGHBGHCGHABIJCIJACIJBIJKDEFABCLM $.

    add4.4 $e |- D e. CC $.
    $( Rearrangement of 4 terms in a sum.  (Contributed by NM, 9-May-1999.) $)
    add4i $p |- ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( B + D ) ) $=
      ( cc wcel caddc co wceq add4 mp4an ) AIJBIJCIJDIJABKLCDKLKLACKLBDKLKLMEFG
      HABCDNO $.

    $( Rearrangement of 4 terms in a sum.  (Contributed by NM, 22-Aug-1999.) $)
    add42i $p |- ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( D + B ) ) $=
      ( caddc co add4i addcomi oveq2i eqtri ) ABIJCDIJIJACIJZBDIJZIJODBIJZIJABC
      DEFGHKPQOIBDFHLMN $.
  $}

  ${
    addd.1 $e |- ( ph -> A e. CC ) $.
    addd.2 $e |- ( ph -> B e. CC ) $.
    addd.3 $e |- ( ph -> C e. CC ) $.
    $( Commutative/associative law that swaps the first two terms in a triple
       sum.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    add12d $p |- ( ph -> ( A + ( B + C ) ) = ( B + ( A + C ) ) ) $=
      ( cc wcel caddc co wceq add12 syl3anc ) ABHICHIDHIBCDJKJKCBDJKJKLEFGBCDMN
      $.

    $( Commutative/associative law that swaps the last two terms in a triple
       sum.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    add32d $p |- ( ph -> ( ( A + B ) + C ) = ( ( A + C ) + B ) ) $=
      ( cc wcel caddc co wceq add32 syl3anc ) ABHICHIDHIBCJKDJKBDJKCJKLEFGBCDMN
      $.

    add4d.4 $e |- ( ph -> D e. CC ) $.
    $( Rearrangement of 4 terms in a sum.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    add4d $p |- ( ph ->
      ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( B + D ) ) ) $=
      ( cc wcel caddc co wceq add4 syl22anc ) ABJKCJKDJKEJKBCLMDELMLMBDLMCELMLM
      NFGHIBCDEOP $.

    $( Rearrangement of 4 terms in a sum.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    add42d $p |- ( ph ->
      ( ( A + B ) + ( C + D ) ) = ( ( A + C ) + ( D + B ) ) ) $=
      ( cc wcel caddc co wceq add42 syl22anc ) ABJKCJKDJKEJKBCLMDELMLMBDLMECLML
      MNFGHIBCDEOP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Subtraction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare symbols needed for some defined terms. $)
  $c - $. $( Subtraction (binary minus). $)
  $c -u $. $( Unary minus sign. $)

  $( Extend class notation to include subtraction. $)
  cmin $a class - $.

  $( Extend class notation to include unary minus.  The symbol ` -u ` is not a
     class by itself but part of a compound class definition.  We do this
     rather than making it a formal function since it is so commonly used.
     Note:  We use different symbols for unary minus ( ` -u ` ) and subtraction
     ~ cmin ( ` - ` ) to prevent syntax ambiguity.  For example, looking at the
     syntax definition ~ co , if we used the same symbol
     then " ` ( - A - B ) ` " could mean either " ` - A ` " minus " ` B ` ", or
     it could represent the (meaningless) operation of
     classes " ` - ` " and " ` - B ` " connected with "operation" " ` A ` ".
     On the other hand, " ` ( -u A - B ) ` " is unambiguous. $)
  cneg $a class -u A $.

  ${
    $d x y z $.
    $( Define subtraction.  Theorem ~ subval shows its value (and describes how
       this definition works), theorem ~ subaddi relates it to addition, and
       theorems ~ subcli and ~ resubcli prove its closure laws.  (Contributed
       by NM, 26-Nov-1994.) $)
    df-sub $a |- - = ( x e. CC , y e. CC |->
                   ( iota_ z e. CC ( y + z ) = x ) ) $.
  $}

  $( Define the negative of a number (unary minus).  We use different symbols
     for unary minus ( ` -u ` ) and subtraction ( ` - ` ) to prevent syntax
     ambiguity.  See ~ cneg for a discussion of this.  (Contributed by NM,
     10-Feb-1995.) $)
  df-neg $a |- -u A = ( 0 - A ) $.

  $( 0 is a complex number.  (Proved without referencing ~ ax-1cn .  Compare
     ~ 0cn .)  (Contributed by NM, 19-Feb-2005.)  (Revised by Mario Carneiro,
     27-May-2016.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  0cnALT $p |- 0 e. CC $=
    ( vx ci cv caddc co cc0 wceq wrex wcel ax-icn cnegex ax-mp addcl mpan eleq1
    cc syl5ibcom rexlimiv ) BACZDEZFGZAPHZFPIZBPIZUBJABKLUAUCAPSPIZTPIZUAUCUDUE
    UFJBSMNTFPOQRL $.

  ${
    $d x y A $.  $d x y B $.
    $( Existential uniqueness of negatives.  Theorem I.2 of [Apostol] p. 18.
       (Contributed by NM, 22-Nov-1994.)  (Proof shortened by Mario Carneiro,
       27-May-2016.) $)
    negeu $p |- ( ( A e. CC /\ B e. CC ) -> E! x e. CC ( A + x ) = B ) $=
      ( vy cc wcel wa cv caddc co wceq wreu wrex cnegex adantr wral simpl simpr
      cc0 wb addcl syl2anr simplrr oveq1d simplll simplrl simpllr eqeq2d addcld
      addassd addid2d 3eqtr3rd addcand bitrd ralrimiva reu6i syl2anc rexlimddv
      ) BEFZCEFZGZBDHZIJZSKZBAHZIJZCKZAELZDEUSVDDEMUTDBNOVAVBEFZVDGZGZVBCIJZEFZ
      VGVEVLKZTZAEPVHVJVIUTVMVAVIVDQUSUTRVBCUAUBVKVOAEVKVEEFZGZVGVFBVLIJZKVNVQC
      VRVFVQVCCIJSCIJVRCVQVCSCIVAVIVDVPUCUDVQBVBCUSUTVJVPUEZVAVIVDVPUFZUSUTVJVP
      UGZUJVQCWAUKULUHVQBVEVLVSVKVPRVQVBCVTWAUIUMUNUOVGAEVLUPUQUR $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( Value of subtraction, which is the (unique) element ` x ` such that
       ` B + x = A ` .  (Contributed by NM, 4-Aug-2007.)  (Revised by Mario
       Carneiro, 2-Nov-2013.) $)
    subval $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( A - B ) = ( iota_ x e. CC ( B + x ) = A ) ) $=
      ( vy vz cc cv caddc co wceq crio cmin eqeq2 riotabidv oveq1 eqeq1d df-sub
      riotaex ovmpt2 ) DEBCFFEGZAGZHIZDGZJZAFKCUAHIZBJZAFKLUBBJZAFKUCBJUDUGAFUC
      BUBMNTCJZUGUFAFUHUBUEBTCUAHOPNDEAQUFAFRS $.
  $}

  $( Equality theorem for negatives.  (Contributed by NM, 10-Feb-1995.) $)
  negeq $p |- ( A = B -> -u A = -u B ) $=
    ( wceq cc0 cmin co cneg oveq2 df-neg 3eqtr4g ) ABCDAEFDBEFAGBGABDEHAIBIJ $.

  ${
    negeqi.1 $e |- A = B $.
    $( Equality inference for negatives.  (Contributed by NM, 14-Feb-1995.) $)
    negeqi $p |- -u A = -u B $=
      ( wceq cneg negeq ax-mp ) ABDAEBEDCABFG $.
  $}

  ${
    negeqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for negatives.  (Contributed by NM, 14-May-1999.) $)
    negeqd $p |- ( ph -> -u A = -u B ) $=
      ( wceq cneg negeq syl ) ABCEBFCFEDBCGH $.
  $}

  ${
    $d y z A $.  $d y ph $.  $d x y z $.
    nfnegd.1 $e |- ( ph -> F/_ x A ) $.
    $( Deduction version of ~ nfneg .  (Contributed by NM, 29-Feb-2008.)
       (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nfnegd $p |- ( ph -> F/_ x -u A ) $=
      ( cneg cc0 cmin co df-neg nfcvd nfovd nfcxfrd ) ABCEFCGHCIABFCGABFJABGJDK
      L $.
  $}

  ${
    $d y A $.  $d x y $.
    nfneg.1 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for the negative of a complex number.
       (Contributed by NM, 12-Jun-2005.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nfneg $p |- F/_ x -u A $=
      ( cneg wnfc wtru a1i nfnegd trud ) ABDEFABABEFCGHI $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d x y z $.
    $( Move class substitution in and out of the negative of a number.
       (Contributed by NM, 1-Mar-2008.)  (Proof shortened by Andrew Salmon,
       22-Oct-2011.) $)
    csbnegg $p |- ( A e. V -> [_ A / x ]_ -u B = -u [_ A / x ]_ B ) $=
      ( wcel cc0 cmin co csb cneg csbov2g df-neg csbeq2i 3eqtr4g ) BDEABFCGHZIF
      ABCIZGHABCJZIPJABFCGDKABQOCLMPLN $.
  $}

  $( A negative is a set.  (Contributed by NM, 4-Apr-2005.) $)
  negex $p |- -u A e. _V $=
    ( cneg cc0 cmin co cvv df-neg ovex eqeltri ) ABCADEFAGCADHI $.

  ${
    $d x A $.  $d x B $.
    $( Closure law for subtraction.  (Contributed by NM, 10-May-1999.)
       (Revised by Mario Carneiro, 21-Dec-2013.) $)
    subcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A - B ) e. CC ) $=
      ( vx cc wcel wa cmin co cv caddc wceq crio subval wreu ancoms riotacl syl
      negeu eqeltrd ) ADEZBDEZFZABGHBCIJHAKZCDLZDCABMUBUCCDNZUDDEUATUECBAROUCCD
      PQS $.
  $}

  $( Closure law for negative.  (Contributed by NM, 6-Aug-2003.) $)
  negcl $p |- ( A e. CC -> -u A e. CC ) $=
    ( cc wcel cneg cc0 cmin co df-neg 0cn subcl mpan syl5eqel ) ABCZADEAFGZBAHE
    BCMNBCIEAJKL $.

  ${
    $d x y z $.
    $( Subtraction is an operation on the complex numbers.  (Contributed by NM,
       4-Aug-2007.)  (Revised by Mario Carneiro, 16-Nov-2013.) $)
    subf $p |- - : ( CC X. CC ) --> CC $=
      ( vy vz vx cv caddc co wceq cc crio wcel wral cxp cmin wf wa subval subcl
      eqeltrrd rgen2a df-sub fmpt2 mpbi ) ADZBDEFCDZGBHIZHJZAHKCHKHHLHMNUFCAHUD
      HJUCHJOUDUCMFUEHBUDUCPUDUCQRSCAHHUEHMCABTUAUB $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Relationship between subtraction and addition.  (Contributed by NM,
       20-Jan-1997.)  (Revised by Mario Carneiro, 21-Dec-2013.) $)
    subadd $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A - B ) = C <-> ( B + C ) = A ) ) $=
      ( vx cc wcel w3a cmin co wceq cv caddc crio wb subval eqeq1d 3adant3 wreu
      wa negeu oveq2 riota2 sylan2 3impb 3com13 bitr4d ) AEFZBEFZCEFZGABHIZCJZB
      DKZLIZAJZDEMZCJZBCLIZAJZUGUHUKUPNUIUGUHSUJUOCDABOPQUIUHUGURUPNZUIUHUGUSUH
      UGSUIUNDERUSDBATUNURDECULCJUMUQAULCBLUAPUBUCUDUEUF $.
  $}

  $( Relationship between subtraction and addition.  (Contributed by Scott
     Fenton, 5-Jul-2013.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  subadd2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
            ( ( A - B ) = C <-> ( C + B ) = A ) ) $=
    ( cc wcel w3a cmin co wceq caddc subadd simp2 simp3 addcomd eqeq1d bitrd )
    ADEZBDEZCDEZFZABGHCIBCJHZAICBJHZAIABCKTUAUBATBCQRSLQRSMNOP $.

  $( Swap subtrahend and result of subtraction.  (Contributed by NM,
     14-Dec-2007.) $)
  subsub23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) = C <-> ( A - C ) = B ) ) $=
    ( cc wcel caddc co wceq cmin addcom 3adant1 eqeq1d subadd wb 3com23 3bitr4d
    w3a ) ADEZBDEZCDEZQZBCFGZAHCBFGZAHZABIGCHACIGBHZUAUBUCASTUBUCHRBCJKLABCMRTS
    UEUDNACBMOP $.

  $( Cancellation law for subtraction.  (Contributed by NM, 10-May-2004.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  pncan $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) - B ) = A ) $=
    ( cc wcel wa caddc co cmin wceq simpr simpl addcomd wb addcl subadd syl3anc
    mpbird ) ACDZBCDZEZABFGZBHGAIZBAFGUAIZTBARSJZRSKZLTUACDSRUBUCMABNUDUEUABAOP
    Q $.

  $( Cancellation law for subtraction.  (Contributed by NM, 17-Apr-2005.) $)
  pncan2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) - A ) = B ) $=
    ( cc wcel caddc co cmin wceq wa addcom oveq1d pncan eqtr3d ancoms ) BCDZACD
    ZABEFZAGFZBHOPIZBAEFZAGFRBSTQAGBAJKBALMN $.

  $( Subtraction and addition of equals.  (Contributed by NM, 14-Mar-2005.) $)
  pncan3 $p |- ( ( A e. CC /\ B e. CC ) -> ( A + ( B - A ) ) = B ) $=
    ( cc wcel wa cmin co wceq caddc eqid simpr simpl subcl ancoms syl3anc mpbii
    wb subadd ) ACDZBCDZEZBAFGZUBHZAUBIGBHZUBJUATSUBCDZUCUDQSTKSTLTSUEBAMNBAUBR
    OP $.

  $( Cancellation law for subtraction.  (Contributed by NM, 10-May-2004.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  npcan $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A - B ) + B ) = A ) $=
    ( cc wcel wa cmin co caddc subcl simpr addcomd wceq pncan3 ancoms eqtrd ) A
    CDZBCDZEZABFGZBHGBSHGZARSBABIPQJKQPTALBAMNO $.

  $( Associative-type law for addition and subtraction.  (Contributed by NM,
     6-Aug-2003.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  addsubass $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                   ( ( A + B ) - C ) = ( A + ( B - C ) ) ) $=
    ( cc wcel cmin co caddc simp1 subcl 3adant1 simp3 addassd wceq npcan oveq2d
    w3a eqtrd oveq1d addcld pncan syl2anc eqtr3d ) ADEZBDEZCDEZQZABCFGZHGZCHGZC
    FGZABHGZCFGUIUGUJULCFUGUJAUHCHGZHGULUGAUHCUDUEUFIZUEUFUHDEUDBCJKZUDUEUFLZMU
    GUMBAHUEUFUMBNUDBCOKPRSUGUIDEUFUKUINUGAUHUNUOTUPUICUAUBUC $.

  $( Law for addition and subtraction.  (Contributed by NM, 19-Aug-2001.)
     (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
  addsub $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A + B ) - C ) = ( ( A - C ) + B ) ) $=
    ( cc wcel w3a caddc co cmin wa addcom oveq1d 3adant3 addsubass 3com12 subcl
    wceq sylan2 3impb 3eqtrd ) ADEZBDEZCDEZFABGHZCIHZBAGHZCIHZBACIHZGHZUHBGHZUA
    UBUEUGQUCUAUBJUDUFCIABKLMUBUAUCUGUIQBACNOUBUAUCUIUJQZUBUAUCUKUAUCJUBUHDEUKA
    CPBUHKRSOT $.

  $( Commutative/associative law for addition and subtraction.  (Contributed by
     NM, 1-Feb-2007.) $)
  subadd23 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A - B ) + C ) = ( A + ( C - B ) ) ) $=
    ( cc wcel cmin co caddc wceq w3a addsub addsubass eqtr3d 3com23 ) ADEZCDEZB
    DEZABFGCHGZACBFGHGZIOPQJACHGBFGRSACBKACBLMN $.

  $( Commutative/associative law for addition and subtraction.  (Contributed by
     NM, 8-Feb-2005.) $)
  addsub12 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A + ( B - C ) ) = ( B + ( A - C ) ) ) $=
    ( cc wcel cmin co caddc w3a subadd23 subcl addcom sylan 3impa eqtr3d 3com23
    wceq wa ) ADEZCDEZBDEZABCFGHGZBACFGZHGZQSTUAIUCBHGZUBUDACBJSTUAUEUDQZSTRUCD
    EUAUFACKUCBLMNOP $.

  $( Law for subtraction and addition.  (Contributed by NM, 20-Nov-2005.) $)
  2addsub $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
                 ( ( ( A + B ) + C ) - D ) = ( ( ( A + C ) - D ) + B ) ) $=
    ( cc wcel wa caddc co cmin wceq add32 3expa oveq1d addcl addsub 3expb sylan
    adantrr an4s eqtrd ) AEFZBEFZGZCEFZDEFZGGZABHICHIZDJIACHIZBHIZDJIZUIDJIBHIZ
    UGUHUJDJUDUEUHUJKZUFUBUCUEUMABCLMSNUBUEUCUFUKULKZUBUEGUIEFZUCUFGUNACOUOUCUF
    UNUIBDPQRTUA $.

  $( Relation between sums and differences.  (Contributed by Jeff Madsen,
     17-Jun-2010.) $)
  addsubeq4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
                    ( ( A + B ) = ( C + D ) <-> ( C - A ) = ( B - D ) ) ) $=
    ( cc wcel wa cmin co wceq caddc eqcom subcl ancoms subadd 3expa an4s syl5bb
    wb sylan addcom adantl oveq1d addsubass 3com12 eqtrd adantlr addcl 3bitr2rd
    eqeq1d 3expb sylan2 ) AEFZBEFZGZCEFZDEFZGZGZCAHIZBDHIZJZDUTKIZBJZCDKIZAHIZB
    JZABKIVEJZVBVAUTJZUSVDUTVALUMUPUNUQVIVDSZUMUPGUTEFZUNUQGZVJUPUMVKCAMNVLVKVJ
    UNUQVKVJBDUTOPNTQRUSVFVCBUMURVFVCJUNUMURGZVFDCKIZAHIZVCVMVEVNAHURVEVNJUMCDU
    AUBUCURUMVOVCJZUPUQUMVPUQUPUMVPDCAUDUEPNUFUGUJURUOVEEFZVGVHSZCDUHVQUOVRVQUM
    UNVRVEABOUKNULUI $.

  $( Subtraction of a number from itself.  (Contributed by NM, 8-Oct-1999.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  subid $p |- ( A e. CC -> ( A - A ) = 0 ) $=
    ( cc wcel cc0 caddc co cmin addid1 oveq1d wceq 0cn pncan2 mpan2 eqtr3d ) AB
    CZADEFZAGFZAAGFDOPAAGAHIODBCQDJKADLMN $.

  $( Identity law for subtraction.  (Contributed by NM, 9-May-2004.)  (Revised
     by Mario Carneiro, 27-May-2016.) $)
  subid1 $p |- ( A e. CC -> ( A - 0 ) = A ) $=
    ( cc wcel cc0 caddc co cmin addid1 oveq1d wceq 0cn pncan mpan2 eqtr3d ) ABC
    ZADEFZDGFZADGFAOPADGAHIODBCQAJKADLMN $.

  $( Cancellation law for subtraction.  (Contributed by NM, 8-Feb-2005.) $)
  npncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) + ( B - C ) ) = ( A - C ) ) $=
    ( cc wcel w3a cmin co caddc wceq subcl 3adant3 addsubass syld3an1 wa oveq1d
    npcan eqtr3d ) ADEZBDEZCDEZFABGHZBIHZCGHZUBBCGHIHZACGHZUBDEZTSUAUDUEJSTUGUA
    ABKLUBBCMNSTUDUFJUASTOUCACGABQPLR $.

  $( Cancellation law for subtraction.  (Contributed by NM, 1-Sep-2005.) $)
  nppcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( ( A - B ) + C ) + B ) = ( A + C ) ) $=
    ( cc wcel w3a cmin co caddc subcl 3adant3 simp3 simp2 add32d wceq wa oveq1d
    npcan eqtrd ) ADEZBDEZCDEZFZABGHZCIHBIHUDBIHZCIHZACIHZUCUDCBTUAUDDEUBABJKTU
    AUBLTUAUBMNTUAUFUGOUBTUAPUEACIABRQKS $.

  $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
     14-Sep-2015.) $)
  nppcan3 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) + ( C + B ) ) = ( A + C ) ) $=
    ( cc wcel w3a cmin co caddc subcl 3adant3 simp3 simp2 addassd nppcan eqtr3d
    ) ADEZBDEZCDEZFZABGHZCIHBIHUACBIHIHACIHTUACBQRUADESABJKQRSLQRSMNABCOP $.

  $( Cancellation law for subtraction.  (Contributed by NM, 8-Feb-2005.) $)
  subcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - C ) = ( B - C ) <-> A = B ) ) $=
    ( cc wcel w3a cmin co wceq caddc wb simp1 simp3 subcl 3adant1 subadd2 npcan
    syl3anc eqeq1d eqcom syl6bb bitrd ) ADEZBDEZCDEZFZACGHBCGHZIZUGCJHZAIZABIZU
    FUCUEUGDEZUHUJKUCUDUELUCUDUEMUDUEULUCBCNOACUGPRUFUJBAIUKUFUIBAUDUEUIBIUCBCQ
    OSBATUAUB $.

  $( If the difference between two numbers is zero, they are equal.
     (Contributed by NM, 16-Nov-1999.) $)
  subeq0 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A - B ) = 0 <-> A = B ) ) $=
    ( cc wcel wa cmin co wceq cc0 subid adantl eqeq2d subcan2 3anidm23 bitr3d
    wb ) ACDZBCDZEZABFGZBBFGZHZTIHABHZSUAITRUAIHQBJKLQRUBUCPABBMNO $.

  $( Cancellation law for subtraction.  (Contributed by Scott Fenton,
     21-Jun-2013.) $)
  npncan2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A - B ) + ( B - A ) ) = 0 ) $=
    ( cc wcel wa cmin co caddc cc0 wceq npncan 3anidm13 subid adantr eqtrd ) AC
    DZBCDZEABFGBAFGHGZAAFGZIPQRSJABAKLPSIJQAMNO $.

  $( Law for double subtraction.  (Contributed by NM, 30-Jun-2005.)  (Revised
     by Mario Carneiro, 27-May-2016.) $)
  subsub2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( A - ( B - C ) ) = ( A + ( C - B ) ) ) $=
    ( cc wcel w3a cmin co caddc wceq cc0 subcl 3adant1 simp1 simp3 simp2 add12d
    syl2anc npncan2 oveq2d addid1d 3eqtrd wb addcld subadd syl3anc mpbird ) ADE
    ZBDEZCDEZFZABCGHZGHACBGHZIHZJZULUNIHZAJZUKUPAULUMIHZIHAKIHAUKULAUMUIUJULDEZ
    UHBCLMZUHUIUJNZUKUJUIUMDEUHUIUJOUHUIUJPCBLRZQUKURKAIUIUJURKJUHBCSMTUKAVAUAU
    BUKUHUSUNDEUOUQUCVAUTUKAUMVAVBUDAULUNUEUFUG $.

  $( Cancellation law for subtraction.  (Contributed by NM, 21-Jun-2005.)
     (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  nncan $p |- ( ( A e. CC /\ B e. CC ) -> ( A - ( A - B ) ) = B ) $=
    ( cc wcel wa cmin co caddc wceq subsub2 3anidm12 pncan3 eqtrd ) ACDZBCDZEAA
    BFGFGZABAFGHGZBNOPQIAABJKABLM $.

  $( Law for double subtraction.  (Contributed by NM, 13-May-2004.) $)
  subsub $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( A - ( B - C ) ) = ( ( A - B ) + C ) ) $=
    ( cc wcel w3a cmin caddc subsub2 wceq addsubass addsub eqtr3d 3com23 eqtrd
    co ) ADEZBDEZCDEZFABCGPGPACBGPHPZABGPCHPZABCIQSRTUAJQSRFACHPBGPTUAACBKACBLM
    NO $.

  $( Cancellation law for subtraction.  (Contributed by NM, 29-Sep-2005.) $)
  nppcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - ( B + C ) ) + C ) = ( A - B ) ) $=
    ( cc wcel w3a caddc co cmin wceq addcl 3adant1 subsub syld3an2 pncan oveq2d
    eqtr3d ) ADEZBDEZCDEZFZABCGHZCIHZIHZAUBIHCGHZABIHRUBDEZSTUDUEJSTUFRBCKLAUBC
    MNUAUCBAISTUCBJRBCOLPQ $.

  $( Law for double subtraction.  (Contributed by NM, 27-Jul-2005.) $)
  subsub3 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( A - ( B - C ) ) = ( ( A + C ) - B ) ) $=
    ( cc wcel w3a cmin co caddc subsub2 wceq addsubass 3com23 eqtr4d ) ADEZBDEZ
    CDEZFABCGHGHACBGHIHZACIHBGHZABCJOQPSRKACBLMN $.

  $( Law for double subtraction.  (Contributed by NM, 19-Aug-2005.)  (Revised
     by Mario Carneiro, 27-May-2016.) $)
  subsub4 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A - B ) - C ) = ( A - ( B + C ) ) ) $=
    ( cc wcel w3a cmin co caddc wceq nppcan2 wb simp1 simp2 subcl syl2anc simp3
    addcld subadd2 syl3anc mpbird ) ADEZBDEZCDEZFZABGHZCGHABCIHZGHZJZUHCIHUFJZA
    BCKUEUFDEZUDUHDEZUIUJLUEUBUCUKUBUCUDMZUBUCUDNZABOPUBUCUDQZUEUBUGDEULUMUEBCU
    NUORAUGOPUFCUHSTUA $.

  $( Swap the second and third terms in a double subtraction.  (Contributed by
     NM, 19-Aug-2005.) $)
  sub32 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                  ( ( A - B ) - C ) = ( ( A - C ) - B ) ) $=
    ( cc wcel w3a caddc cmin wceq addcom 3adant1 oveq2d subsub4 3com23 3eqtr4d
    co ) ADEZBDEZCDEZFZABCGPZHPACBGPZHPZABHPCHPACHPBHPZTUAUBAHRSUAUBIQBCJKLABCM
    QSRUDUCIACBMNO $.

  $( Cancellation law for subtraction.  (Contributed by NM, 4-Sep-2005.) $)
  nnncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - ( B - C ) ) - C ) = ( A - B ) ) $=
    ( cc wcel cmin co caddc wceq subcl 3adant1 subsub4 syld3an2 wa npcan oveq2d
    w3a eqtrd ) ADEZBDEZCDEZQABCFGZFGCFGZAUBCHGZFGZABFGZSUBDEZTUAUCUEITUAUGSBCJ
    KAUBCLMTUAUEUFISTUANUDBAFBCOPKR $.

  $( Cancellation law for subtraction.  (Contributed by NM, 8-Feb-2005.)
     (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  nnncan1 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) - ( A - C ) ) = ( C - B ) ) $=
    ( cc wcel w3a cmin co wceq subcl 3adant2 sub32 syld3an3 nncan oveq1d eqtrd
    ) ADEZBDEZCDEZFZABGHACGHZGHZAUAGHZBGHZCBGHQRSUADEZUBUDIQSUERACJKABUALMTUCCB
    GQSUCCIRACNKOP $.

  $( Cancellation law for subtraction.  (Contributed by NM, 1-Oct-2005.) $)
  nnncan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - C ) - ( B - C ) ) = ( A - B ) ) $=
    ( cc wcel w3a cmin co wceq subcl 3adant1 sub32 syld3an2 nnncan eqtr3d ) ADE
    ZBDEZCDEZFABCGHZGHCGHZACGHSGHZABGHPSDEZQRTUAIQRUBPBCJKASCLMABCNO $.

  $( Cancellation law for subtraction.  (Contributed by Scott Fenton,
     23-Jun-2013.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  npncan3 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
    ( ( A - B ) + ( C - A ) ) = ( C - B ) ) $=
    ( cc wcel w3a cmin co caddc simp1 subcl ancoms 3adant2 simp2 addsub syl3anc
    wceq pncan3 oveq1d eqtr3d ) ADEZBDEZCDEZFZACAGHZIHZBGHZABGHUEIHZCBGHUDUAUED
    EZUBUGUHQUAUBUCJUAUCUIUBUCUAUICAKLMUAUBUCNAUEBOPUDUFCBGUAUCUFCQUBACRMST $.

  $( Cancellation law for mixed addition and subtraction.  (Contributed by NM,
     4-Mar-2005.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  pnpcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) - ( A + C ) ) = ( B - C ) ) $=
    ( cc wcel w3a caddc co cmin simp1 simp2 addcld simp3 subsub4 syl3anc pncan2
    wceq 3adant3 oveq1d eqtr3d ) ADEZBDEZCDEZFZABGHZAIHZCIHZUEACGHIHZBCIHUDUEDE
    UAUCUGUHQUDABUAUBUCJZUAUBUCKLUIUAUBUCMUEACNOUDUFBCIUAUBUFBQUCABPRST $.

  $( Cancellation law for mixed addition and subtraction.  (Contributed by
     Scott Fenton, 9-Jun-2006.) $)
  pnpcan2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A + C ) - ( B + C ) ) = ( A - B ) ) $=
    ( cc wcel w3a caddc co cmin wceq addcom 3adant2 3adant1 oveq12d 3coml eqtrd
    pnpcan ) ADEZBDEZCDEZFZACGHZBCGHZIHCAGHZCBGHZIHZABIHZUAUBUDUCUEIRTUBUDJSACK
    LSTUCUEJRBCKMNTRSUFUGJCABQOP $.

  $( Cancellation law for mixed addition and subtraction.  (Contributed by NM,
     30-Jun-2005.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  pnncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) - ( A - C ) ) = ( B + C ) ) $=
    ( cc wcel caddc co cmin wceq simp1 simp2 addcld simp3 subsub syl3anc pncan2
    w3a 3adant3 oveq1d eqtrd ) ADEZBDEZCDEZQZABFGZACHGHGZUEAHGZCFGZBCFGUDUEDEUA
    UCUFUHIUDABUAUBUCJZUAUBUCKLUIUAUBUCMUEACNOUDUGBCFUAUBUGBIUCABPRST $.

  $( Cancellation law for mixed addition and subtraction.  (Contributed by NM,
     30-Jun-2005.) $)
  ppncan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A + B ) + ( C - B ) ) = ( A + C ) ) $=
    ( cc wcel w3a caddc co cmin wceq addcom 3adant3 oveq1d addcl subsub2 pnncan
    syld3an1 3com12 3eqtr3d ) ADEZBDEZCDEZFZABGHZBCIHZIHZBAGHZUEIHZUDCBIHGHZACG
    HZUCUDUGUEITUAUDUGJUBABKLMUDDEZUATUBUFUIJTUAUKUBABNLUDBCOQUATUBUHUJJBACPRS
    $.

  $( Rearrangement of 4 terms in a mixed addition and subtraction.
     (Contributed by NM, 4-Mar-2005.) $)
  addsub4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A + B ) - ( C + D ) ) = ( ( A - C ) + ( B - D ) ) ) $=
    ( cc wcel caddc cmin wceq simpll simplr simprl addsub syl3anc oveq1d addcld
    wa co simprr subsub4 subcl ad2ant2r addsubass 3eqtr3d ) AEFZBEFZQZCEFZDEFZQ
    ZQZABGRZCHRZDHRZACHRZBGRZDHRZULCDGRHRZUOBDHRGRZUKUMUPDHUKUEUFUHUMUPIUEUFUJJ
    ZUEUFUJKZUGUHUILZABCMNOUKULEFUHUIUNURIUKABUTVAPVBUGUHUISZULCDTNUKUOEFZUFUIU
    QUSIUEUHVDUFUIACUAUBVAVCUOBDUCNUD $.

  $( Rearrangement of 4 terms in a mixed addition and subtraction.
     (Contributed by NM, 24-Aug-2006.) $)
  subadd4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A - B ) - ( C - D ) ) = ( ( A + D ) - ( B + C ) ) ) $=
    ( cc wcel wa cmin caddc wceq subcl subsub2 3expb sylan addsub4 an42s eqtr4d
    co ) AEFZBEFZGZCEFZDEFZGZGABHRZCDHRHRZUEDCHRIRZADIRBCIRHRZUAUEEFZUDUFUGJZAB
    KUIUBUCUJUECDLMNSUCTUBUHUGJADBCOPQ $.

  $( Rearrangement of 4 terms in a subtraction.  (Contributed by NM,
     23-Nov-2007.) $)
  sub4 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
              ( ( A - B ) - ( C - D ) ) = ( ( A - C ) - ( B - D ) ) ) $=
    ( cc wcel wa caddc cmin wceq addcom ad2ant2lr oveq2d subadd4 an4s 3eqtr4d
    co ) AEFZBEFZGCEFZDEFZGGZADHQZBCHQZIQUCCBHQZIQZABIQCDIQIQACIQBDIQIQZUBUDUEU
    CISTUDUEJRUABCKLMABCDNRTSUAUGUFJACBDNOP $.

  $( Minus 0 equals 0.  (Contributed by NM, 17-Jan-1997.) $)
  neg0 $p |- -u 0 = 0 $=
    ( cc0 cneg cmin co df-neg cc wcel wceq 0cn subid ax-mp eqtri ) ABAACDZAAEAF
    GMAHIAJKL $.

  $( Addition of a number and its negative.  (Contributed by NM,
     14-Mar-2005.) $)
  negid $p |- ( A e. CC -> ( A + -u A ) = 0 ) $=
    ( cc wcel cneg caddc co cc0 cmin df-neg oveq2i wceq 0cn pncan3 mpan2 syl5eq
    ) ABCZAADZEFAGAHFZEFZGQRAEAIJPGBCSGKLAGMNO $.

  $( Relationship between subtraction and negative.  Theorem I.3 of [Apostol]
     p. 18.  (Contributed by NM, 21-Jan-1997.)  (Proof shortened by Mario
     Carneiro, 27-May-2016.) $)
  negsub $p |- ( ( A e. CC /\ B e. CC ) -> ( A + -u B ) = ( A - B ) ) $=
    ( cc wcel wa cneg caddc co cc0 cmin wceq df-neg oveq2i a1i addsubass mp3an2
    0cn simpl addid1d oveq1d 3eqtr2d ) ACDZBCDZEZABFZGHZAIBJHZGHZAIGHZBJHZABJHU
    FUHKUDUEUGAGBLMNUBICDUCUJUHKQAIBOPUDUIABJUDAUBUCRSTUA $.

  $( Relationship between subtraction and negative.  (Contributed by NM,
     10-May-2004.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  subneg $p |- ( ( A e. CC /\ B e. CC ) -> ( A - -u B ) = ( A + B ) ) $=
    ( cc wcel wa cneg cmin co cc0 caddc df-neg oveq2i wceq subsub mp3an2 syl5eq
    0cn subid1 adantr oveq1d eqtrd ) ACDZBCDZEZABFZGHZAIGHZBJHZABJHUDUFAIBGHZGH
    ZUHUEUIAGBKLUBICDUCUJUHMQAIBNOPUDUGABJUBUGAMUCARSTUA $.

  $( A number is equal to the negative of its negative.  Theorem I.4 of
     [Apostol] p. 18.  (Contributed by NM, 12-Jan-2002.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  negneg $p |- ( A e. CC -> -u -u A = A ) $=
    ( cc wcel cneg cc0 caddc co cmin df-neg wceq 0cn subneg syl5eq addid2 eqtrd
    mpan ) ABCZADZDZEAFGZAQSERHGZTRIEBCQUATJKEALPMANO $.

  $( Negative is one-to-one.  (Contributed by NM, 8-Feb-2005.)  (Revised by
     Mario Carneiro, 27-May-2016.) $)
  neg11 $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A = -u B <-> A = B ) ) $=
    ( cc wcel wa cneg wceq negeq negneg eqeqan12d syl5ib impbid1 ) ACDZBCDZEZAF
    ZBFZGZABGZRPFZQFZGOSPQHMNTAUABAIBIJKABHL $.

  $( Negative contraposition law.  (Contributed by NM, 9-May-2004.) $)
  negcon1 $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A = B <-> -u B = A ) ) $=
    ( cc wcel wa cneg wceq negcl neg11 sylan negneg adantr eqeq1d bitr3d syl6bb
    wb eqcom ) ACDZBCDZEZAFZBGZABFZGZUCAGTUAFZUCGZUBUDRUACDSUFUBPAHUABIJTUEAUCR
    UEAGSAKLMNAUCQO $.

  $( Negative contraposition law.  (Contributed by NM, 14-Nov-2004.) $)
  negcon2 $p |- ( ( A e. CC /\ B e. CC ) -> ( A = -u B <-> B = -u A ) ) $=
    ( cc wcel wa cneg wceq negcon1 eqcom syl6rbbr syl6bb ) ACDBCDEZABFZGZAFZBGZ
    BOGLPMAGNABHAMIJOBIK $.

  $( A number is zero iff its negative is zero.  (Contributed by NM,
     12-Jul-2005.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  negeq0 $p |- ( A e. CC -> ( A = 0 <-> -u A = 0 ) ) $=
    ( cneg cc0 wceq cc wcel neg0 eqeq2i wb 0cn neg11 mpan2 syl5rbbr ) ABZCDNCBZ
    DZAEFZACDZOCNGHQCEFPRIJACKLM $.

  $( Cancellation law for subtraction.  (Contributed by NM, 8-Feb-2005.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  subcan $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( A - B ) = ( A - C ) <-> B = C ) ) $=
    ( cc wcel w3a caddc co wceq cmin simp2 simp1 addcomd eqeq1d simp3 addsubeq4
    wb syl22anc addcan 3bitr3d ) ADEZBDEZCDEZFZBAGHZACGHZIZABGHZUFIABJHACJHIZBC
    IUDUEUHUFUDBAUAUBUCKZUAUBUCLZMNUDUBUAUAUCUGUIQUJUKUKUAUBUCOBAACPRABCST $.

  $( Distribution of negative over subtraction.  (Contributed by NM,
     15-Nov-2004.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  negsubdi $p |- ( ( A e. CC /\ B e. CC ) -> -u ( A - B ) = ( -u A + B ) ) $=
    ( cc wcel wa cc0 cmin co caddc cneg 0cn subsub mp3an1 df-neg oveq1i 3eqtr4g
    wceq ) ACDZBCDZEFABGHZGHZFAGHZBIHZTJAJZBIHFCDRSUAUCQKFABLMTNUDUBBIANOP $.

  $( Distribution of negative over addition.  (Contributed by NM,
     10-May-2004.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  negdi $p |- ( ( A e. CC /\ B e. CC ) ->
                 -u ( A + B ) = ( -u A + -u B ) ) $=
    ( cc wcel wa cneg cmin co caddc subneg negeqd negcl negsubdi sylan2 eqtr3d
    wceq ) ACDZBCDZEZABFZGHZFZABIHZFAFTIHZSUAUCABJKRQTCDUBUDPBLATMNO $.

  $( Distribution of negative over addition.  (Contributed by NM,
     1-Jan-2006.) $)
  negdi2 $p |- ( ( A e. CC /\ B e. CC ) ->
                 -u ( A + B ) = ( -u A - B ) ) $=
    ( cc wcel wa caddc co cneg cmin negdi wceq negcl negsub sylan eqtrd ) ACDZB
    CDZEABFGHAHZBHFGZRBIGZABJPRCDQSTKALRBMNO $.

  $( Distribution of negative over subtraction.  (Contributed by NM,
     4-Oct-1999.) $)
  negsubdi2 $p |- ( ( A e. CC /\ B e. CC ) -> -u ( A - B ) = ( B - A ) ) $=
    ( cc wcel wa cmin cneg caddc negsubdi wceq negcl addcom sylan negsub ancoms
    co 3eqtrd ) ACDZBCDZEABFPGAGZBHPZBTHPZBAFPZABIRTCDSUAUBJAKTBLMSRUBUCJBANOQ
    $.

  $( Relationship between subtraction and negative.  (Contributed by Paul
     Chapman, 8-Oct-2007.) $)
  neg2sub $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A - -u B ) = ( B - A ) ) $=
    ( cc wcel wa cneg cmin co caddc wceq negcl sylan negsubdi negsubdi2 3eqtr2d
    subneg ) ACDZBCDZEAFZBFGHZSBIHZABGHFBAGHQSCDRTUAJAKSBPLABMABNO $.

  ${
    $d x A $.
    renegcl.1 $e |- A e. RR $.
    $( Closure law for negative of reals.  (Note: this inference proof style
       and the deduction theorem usage in ~ renegcl is deprecated, but is
       retained for its demonstration value.)  (Contributed by NM,
       17-Jan-1997.)  (Proof shortened by Andrew Salmon, 22-Oct-2011.) $)
    renegcli $p |- -u A e. RR $=
      ( vx cr wcel cv caddc co cc0 wceq wrex cneg ax-rnegex cc recn cmin df-neg
      wb eqeq1i 0cn recni subadd mp3an12 syl5bb eleq1a sylbird rexlimiv mp2b
      syl ) ADEACFZGHIJZCDKALZDEZBCAMUKUMCDUJDEZUKULUJJZUMUNUJNEZUOUKRUJOUOIAPH
      ZUJJZUPUKULUQUJAQSINEANEUPURUKRTABUAIAUJUBUCUDUIUJDULUEUFUGUH $.

    resubcl.2 $e |- B e. RR $.
    $( Closure law for subtraction of reals.  (Contributed by NM,
       17-Jan-1997.)  (Revised by Mario Carneiro, 27-May-2016.) $)
    resubcli $p |- ( A - B ) e. RR $=
      ( cneg caddc co cmin cr cc wcel wceq recni negsub mp2an renegcli readdcli
      eqeltrri ) ABEZFGZABHGZIAJKBJKTUALACMBDMABNOASCBDPQR $.
  $}

  $( Closure law for negative of reals.  The weak deduction theorem ~ dedth is
     used to convert hypothesis of the inference (deduction) form of this
     theorem, ~ renegcli , to an antecedent.  (Contributed by NM,
     20-Jan-1997.)  (Proof modification is discouraged.) $)
  renegcl $p |- ( A e. RR -> -u A e. RR ) $=
    ( cr wcel cneg c1 cif wceq negeq eleq1d 1re elimel renegcli dedth ) ABCZADZ
    BCNAEFZDZBCAEAPGOQBAPHIPAEBJKLM $.

  $( Closure law for subtraction of reals.  (Contributed by NM,
     20-Jan-1997.) $)
  resubcl $p |- ( ( A e. RR /\ B e. RR ) -> ( A - B ) e. RR ) $=
    ( cr wcel wa cneg caddc cmin wceq recn negsub syl2an renegcl readdcl sylan2
    co cc eqeltrrd ) ACDZBCDZEABFZGPZABHPZCSAQDBQDUBUCITAJBJABKLTSUACDUBCDBMAUA
    NOR $.

  $( The negative of a real is real.  (Contributed by NM, 11-Aug-1999.)
     (Revised by Mario Carneiro, 14-Jul-2014.) $)
  negreb $p |- ( A e. CC -> ( -u A e. RR <-> A e. RR ) ) $=
    ( cc wcel cneg cr renegcl negneg eleq1d syl5ib impbid1 ) ABCZADZECZAECZMLDZ
    ECKNLFKOAEAGHIAFJ $.

  $( "Reverse" second Peano postulate analog for reals.  (Contributed by NM,
     6-Feb-2007.) $)
  peano2rem $p |- ( N e. RR -> ( N - 1 ) e. RR ) $=
    ( cr wcel c1 cmin co 1re resubcl mpan2 ) ABCDBCADEFBCGADHI $.

  ${
    negidi.1 $e |- A e. CC $.
    $( Closure law for negative.  (Contributed by NM, 26-Nov-1994.) $)
    negcli $p |- -u A e. CC $=
      ( cc wcel cneg negcl ax-mp ) ACDAECDBAFG $.

    $( Addition of a number and its negative.  (Contributed by NM,
       26-Nov-1994.) $)
    negidi $p |- ( A + -u A ) = 0 $=
      ( cc wcel cneg caddc co cc0 wceq negid ax-mp ) ACDAAEFGHIBAJK $.

    $( A number is equal to the negative of its negative.  Theorem I.4 of
       [Apostol] p. 18.  (Contributed by NM, 8-Feb-1995.)  (Proof shortened by
       Andrew Salmon, 22-Oct-2011.) $)
    negnegi $p |- -u -u A = A $=
      ( cc wcel cneg wceq negneg ax-mp ) ACDAEEAFBAGH $.

    $( Subtraction of a number from itself.  (Contributed by NM,
       26-Nov-1994.) $)
    subidi $p |- ( A - A ) = 0 $=
      ( cc wcel cmin co cc0 wceq subid ax-mp ) ACDAAEFGHBAIJ $.

    $( Identity law for subtraction.  (Contributed by NM, 29-May-1999.) $)
    subid1i $p |- ( A - 0 ) = A $=
      ( cc wcel cc0 cmin co wceq subid1 ax-mp ) ACDAEFGAHBAIJ $.

    $( A number is nonzero iff its negative is nonzero.  (Contributed by NM,
       10-Aug-1999.) $)
    negne0bi $p |- ( A =/= 0 <-> -u A =/= 0 ) $=
      ( cc0 cneg cc wcel wceq wb negeq0 ax-mp necon3bii ) ACADZCAEFACGLCGHBAIJK
      $.

    $( The negative of a real is real.  (Contributed by NM, 11-Aug-1999.) $)
    negrebi $p |- ( -u A e. RR <-> A e. RR ) $=
      ( cc wcel cneg cr wb negreb ax-mp ) ACDAEFDAFDGBAHI $.

    ${
      negne0i.2 $e |- A =/= 0 $.
      $( The negative of a nonzero number is nonzero.  (Contributed by NM,
         30-Jul-2004.) $)
      negne0i $p |- -u A =/= 0 $=
        ( cc0 wne cneg negne0bi mpbi ) ADEAFDECABGH $.
    $}

    pncan3i.2 $e |- B e. CC $.
    $( Closure law for subtraction.  (Contributed by NM, 26-Nov-1994.)
       (Revised by Mario Carneiro, 21-Dec-2013.) $)
    subcli $p |- ( A - B ) e. CC $=
      ( cc wcel cmin co subcl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( Subtraction and addition of equals.  (Contributed by NM,
       26-Nov-1994.) $)
    pncan3i $p |- ( A + ( B - A ) ) = B $=
      ( cc wcel cmin co caddc wceq pncan3 mp2an ) AEFBEFABAGHIHBJCDABKL $.

    $( Relationship between subtraction and negative.  Theorem I.3 of [Apostol]
       p. 18.  (Contributed by NM, 26-Nov-1994.)  (Proof shortened by Andrew
       Salmon, 22-Oct-2011.) $)
    negsubi $p |- ( A + -u B ) = ( A - B ) $=
      ( cc wcel cneg caddc co cmin wceq negsub mp2an ) AEFBEFABGHIABJIKCDABLM
      $.

    $( Relationship between subtraction and negative.  (Contributed by NM,
       1-Dec-2005.) $)
    subnegi $p |- ( A - -u B ) = ( A + B ) $=
      ( cc wcel cneg cmin co caddc wceq subneg mp2an ) AEFBEFABGHIABJIKCDABLM
      $.

    $( If the difference between two numbers is zero, they are equal.
       (Contributed by NM, 8-May-1999.) $)
    subeq0i $p |- ( ( A - B ) = 0 <-> A = B ) $=
      ( cc wcel cmin co cc0 wceq wb subeq0 mp2an ) AEFBEFABGHIJABJKCDABLM $.

    $( Negative is one-to-one.  (Contributed by NM, 1-Aug-1999.) $)
    neg11i $p |- ( -u A = -u B <-> A = B ) $=
      ( cc wcel cneg wceq wb neg11 mp2an ) AEFBEFAGBGHABHICDABJK $.

    $( Negative contraposition law.  (Contributed by NM, 25-Aug-1999.) $)
    negcon1i $p |- ( -u A = B <-> -u B = A ) $=
      ( cc wcel cneg wceq wb negcon1 mp2an ) AEFBEFAGBHBGAHICDABJK $.

    $( Negative contraposition law.  (Contributed by NM, 25-Aug-1999.) $)
    negcon2i $p |- ( A = -u B <-> B = -u A ) $=
      ( cc wcel cneg wceq wb negcon2 mp2an ) AEFBEFABGHBAGHICDABJK $.

    $( Distribution of negative over addition.  (Contributed by NM,
       28-Jul-1999.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
    negdii $p |- -u ( A + B ) = ( -u A + -u B ) $=
      ( caddc co cneg wceq cc0 addcli negidi oveq12i eqtri negcli add4i 3eqtr2i
      00id addcani mpbi ) ABEFZTGZEFZTAGZBGZEFZEFZHUAUEHUBIAUCEFZBUDEFZEFZUFTAB
      CDJZKUIIIEFIUGIUHIEACKBDKLQMAUCBUDCACNZDBDNZOPTUAUEUJTUJNUCUDUKULJRS $.

    $( Distribution of negative over subtraction.  (Contributed by NM,
       6-Aug-1999.) $)
    negsubdii $p |- -u ( A - B ) = ( -u A + B ) $=
      ( cneg caddc co cmin negcli negdii negsubi negeqi negnegi oveq2i 3eqtr3i
      ) ABEZFGZEAEZPEZFGABHGZERBFGAPCBDIJQTABCDKLSBRFBDMNO $.

    $( Distribution of negative over subtraction.  (Contributed by NM,
       1-Oct-1999.) $)
    negsubdi2i $p |- -u ( A - B ) = ( B - A ) $=
      ( cmin co cneg caddc negsubdii negcli negsubi addcomli eqtri ) ABEFGAGZBH
      FBAEFZABCDIBNODACJBADCKLM $.

    subadd.3 $e |- C e. CC $.
    $( Relationship between subtraction and addition.  (Contributed by NM,
       26-Nov-1994.)  (Revised by Mario Carneiro, 21-Dec-2013.) $)
    subaddi $p |- ( ( A - B ) = C <-> ( B + C ) = A ) $=
      ( cc wcel cmin co wceq caddc wb subadd mp3an ) AGHBGHCGHABIJCKBCLJAKMDEFA
      BCNO $.

    $( Relationship between subtraction and addition.  (Contributed by NM,
       15-Dec-2006.) $)
    subadd2i $p |- ( ( A - B ) = C <-> ( C + B ) = A ) $=
      ( cc wcel cmin co wceq caddc wb subadd2 mp3an ) AGHBGHCGHABIJCKCBLJAKMDEF
      ABCNO $.

    ${
      subaddri.4 $e |- ( B + C ) = A $.
      $( Relationship between subtraction and addition.  (Contributed by NM,
         16-Dec-2006.) $)
      subaddrii $p |- ( A - B ) = C $=
        ( cmin co wceq caddc subaddi mpbir ) ABHICJBCKIAJGABCDEFLM $.
    $}

    $( Swap subtrahend and result of subtraction.  (Contributed by NM,
       7-Oct-1999.) $)
    subsub23i $p |- ( ( A - B ) = C <-> ( A - C ) = B ) $=
      ( cc wcel cmin co wceq wb subsub23 mp3an ) AGHBGHCGHABIJCKACIJBKLDEFABCMN
      $.

    $( Associative-type law for subtraction and addition.  (Contributed by NM,
       16-Sep-1999.) $)
    addsubassi $p |- ( ( A + B ) - C ) = ( A + ( B - C ) ) $=
      ( cc wcel caddc co cmin wceq addsubass mp3an ) AGHBGHCGHABIJCKJABCKJIJLDE
      FABCMN $.

    $( Law for subtraction and addition.  (Contributed by NM, 6-Aug-2003.) $)
    addsubi $p |- ( ( A + B ) - C ) = ( ( A - C ) + B ) $=
      ( cc wcel caddc co cmin wceq addsub mp3an ) AGHBGHCGHABIJCKJACKJBIJLDEFAB
      CMN $.

    $( Cancellation law for subtraction.  (Contributed by NM, 8-Feb-2005.) $)
    subcani $p |- ( ( A - B ) = ( A - C ) <-> B = C ) $=
      ( cc wcel cmin co wceq wb subcan mp3an ) AGHBGHCGHABIJACIJKBCKLDEFABCMN
      $.

    $( Cancellation law for subtraction.  (Contributed by NM, 8-Feb-2005.) $)
    subcan2i $p |- ( ( A - C ) = ( B - C ) <-> A = B ) $=
      ( cc wcel cmin co wceq wb subcan2 mp3an ) AGHBGHCGHACIJBCIJKABKLDEFABCMN
      $.

    $( Cancellation law for mixed addition and subtraction.  (Contributed by
       NM, 14-Jan-2006.) $)
    pnncani $p |- ( ( A + B ) - ( A - C ) ) = ( B + C ) $=
      ( cc wcel caddc co cmin wceq pnncan mp3an ) AGHBGHCGHABIJACKJKJBCIJLDEFAB
      CMN $.

    addsub4i.4 $e |- D e. CC $.
    $( Rearrangement of 4 terms in a mixed addition and subtraction.
       (Contributed by NM, 17-Oct-1999.) $)
    addsub4i $p |- ( ( A + B ) - ( C + D ) ) =
                 ( ( A - C ) + ( B - D ) ) $=
      ( cc wcel caddc co cmin wceq addsub4 mp4an ) AIJBIJCIJDIJABKLCDKLMLACMLBD
      MLKLNEFGHABCDOP $.
  $}

  $( 0 is a real number.  (Contributed by NM, 19-Feb-2005.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  0reALT $p |- 0 e. RR $=
    ( c1 cmin co cc0 cr ax-1cn subidi 1re resubcli eqeltrri ) AABCDEAFGAAHHIJ
    $.

  ${
    negidd.1 $e |- ( ph -> A e. CC ) $.
    $( Closure law for negative.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    negcld $p |- ( ph -> -u A e. CC ) $=
      ( cc wcel cneg negcl syl ) ABDEBFDECBGH $.

    $( Subtraction of a number from itself.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subidd $p |- ( ph -> ( A - A ) = 0 ) $=
      ( cc wcel cmin co cc0 wceq subid syl ) ABDEBBFGHICBJK $.

    $( Identity law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subid1d $p |- ( ph -> ( A - 0 ) = A ) $=
      ( cc wcel cc0 cmin co wceq subid1 syl ) ABDEBFGHBICBJK $.

    $( Addition of a number and its negative.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    negidd $p |- ( ph -> ( A + -u A ) = 0 ) $=
      ( cc wcel cneg caddc co cc0 wceq negid syl ) ABDEBBFGHIJCBKL $.

    $( A number is equal to the negative of its negative.  Theorem I.4 of
       [Apostol] p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    negnegd $p |- ( ph -> -u -u A = A ) $=
      ( cc wcel cneg wceq negneg syl ) ABDEBFFBGCBHI $.

    $( A number is zero iff its negative is zero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    negeq0d $p |- ( ph -> ( A = 0 <-> -u A = 0 ) ) $=
      ( cc wcel cc0 wceq cneg wb negeq0 syl ) ABDEBFGBHFGICBJK $.

    $( A number is nonzero iff its negative is nonzero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    negne0bd $p |- ( ph -> ( A =/= 0 <-> -u A =/= 0 ) ) $=
      ( cc0 cneg negeq0d necon3bid ) ABDBEDABCFG $.

    ${
      negcon1d.2 $e |- ( ph -> B e. CC ) $.
      $( Contraposition law for unary minus.  Deduction form of ~ negcon1 .
         (Contributed by David Moews, 28-Feb-2017.) $)
      negcon1d $p |- ( ph -> ( -u A = B <-> -u B = A ) ) $=
        ( cc wcel cneg wceq wb negcon1 syl2anc ) ABFGCFGBHCICHBIJDEBCKL $.
    $}

    ${
      negcon1ad.2 $e |- ( ph -> -u A = B ) $.
      $( Contraposition law for unary minus.  One-way deduction form of
         ~ negcon1 .  (Contributed by David Moews, 28-Feb-2017.) $)
      negcon1ad $p |- ( ph -> -u B = A ) $=
        ( cneg wceq cc negcld eqeltrrd negcon1d mpbid ) ABFZCGCFBGEABCDAMCHEABD
        IJKL $.
    $}

    ${
      neg11ad.2 $e |- ( ph -> B e. CC ) $.
      $( The negatives of two complex numbers are equal iff they are equal.
         Deduction form of ~ neg11 .  Generalization of ~ neg11d .
         (Contributed by David Moews, 28-Feb-2017.) $)
      neg11ad $p |- ( ph -> ( -u A = -u B <-> A = B ) ) $=
        ( cc wcel cneg wceq wb neg11 syl2anc ) ABFGCFGBHCHIBCIJDEBCKL $.
    $}

    ${
      negned.2 $e |- ( ph -> B e. CC ) $.
      negned.3 $e |- ( ph -> A =/= B ) $.
      $( If two complex numbers are unequal, so are their negatives.
         Contrapositive of ~ neg11d .  (Contributed by David Moews,
         28-Feb-2017.) $)
      negned $p |- ( ph -> -u A =/= -u B ) $=
        ( cneg wne neg11ad necon3bid mpbird ) ABGZCGZHBCHFALMBCABCDEIJK $.
    $}

    ${
      negne0d.2 $e |- ( ph -> A =/= 0 ) $.
      $( The negative of a nonzero number is nonzero.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      negne0d $p |- ( ph -> -u A =/= 0 ) $=
        ( cc0 wne cneg negne0bd mpbid ) ABEFBGEFDABCHI $.
    $}

    ${
      negrebd.2 $e |- ( ph -> -u A e. RR ) $.
      $( The negative of a real is real.  (Contributed by Mario Carneiro,
         28-May-2016.) $)
      negrebd $p |- ( ph -> A e. RR ) $=
        ( cneg cr wcel cc wb negreb syl mpbid ) ABEFGZBFGZDABHGMNICBJKL $.
    $}

    pncand.2 $e |- ( ph -> B e. CC ) $.
    $( Closure law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subcld $p |- ( ph -> ( A - B ) e. CC ) $=
      ( cc wcel cmin co subcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    pncand $p |- ( ph -> ( ( A + B ) - B ) = A ) $=
      ( cc wcel caddc co cmin wceq pncan syl2anc ) ABFGCFGBCHICJIBKDEBCLM $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    pncan2d $p |- ( ph -> ( ( A + B ) - A ) = B ) $=
      ( cc wcel caddc co cmin wceq pncan2 syl2anc ) ABFGCFGBCHIBJICKDEBCLM $.

    $( Subtraction and addition of equals.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    pncan3d $p |- ( ph -> ( A + ( B - A ) ) = B ) $=
      ( cc wcel cmin co caddc wceq pncan3 syl2anc ) ABFGCFGBCBHIJICKDEBCLM $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    npcand $p |- ( ph -> ( ( A - B ) + B ) = A ) $=
      ( cc wcel cmin co caddc wceq npcan syl2anc ) ABFGCFGBCHICJIBKDEBCLM $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nncand $p |- ( ph -> ( A - ( A - B ) ) = B ) $=
      ( cc wcel cmin co wceq nncan syl2anc ) ABFGCFGBBCHIHICJDEBCKL $.

    $( Relationship between subtraction and negative.  Theorem I.3 of [Apostol]
       p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    negsubd $p |- ( ph -> ( A + -u B ) = ( A - B ) ) $=
      ( cc wcel cneg caddc co cmin wceq negsub syl2anc ) ABFGCFGBCHIJBCKJLDEBCM
      N $.

    $( Relationship between subtraction and negative.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    subnegd $p |- ( ph -> ( A - -u B ) = ( A + B ) ) $=
      ( cc wcel cneg cmin co caddc wceq subneg syl2anc ) ABFGCFGBCHIJBCKJLDEBCM
      N $.

    ${
      subeq0d.3 $e |- ( ph -> ( A - B ) = 0 ) $.
      $( If the difference between two numbers is zero, they are equal.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      subeq0d $p |- ( ph -> A = B ) $=
        ( cmin co cc0 wceq cc wcel wb subeq0 syl2anc mpbid ) ABCGHIJZBCJZFABKLC
        KLQRMDEBCNOP $.
    $}

    ${
      subne0d.3 $e |- ( ph -> A =/= B ) $.
      $( Two unequal numbers have nonzero difference.  (Contributed by Mario
         Carneiro, 1-Jan-2017.) $)
      subne0d $p |- ( ph -> ( A - B ) =/= 0 ) $=
        ( cmin co cc0 wne cc wcel wceq wb subeq0 syl2anc necon3bid mpbird ) ABC
        GHZIJBCJFASIBCABKLCKLSIMBCMNDEBCOPQR $.
    $}

    ${
      $( The difference of two complex numbers is zero iff they are equal.
         Deduction form of ~ subeq0 .  Generalization of ~ subeq0d .
         (Contributed by David Moews, 28-Feb-2017.) $)
      subeq0ad $p |- ( ph -> ( ( A - B ) = 0 <-> A = B ) ) $=
        ( cc wcel cmin co cc0 wceq wb subeq0 syl2anc ) ABFGCFGBCHIJKBCKLDEBCMN
        $.
    $}

    ${
      subne0ad.3 $e |- ( ph -> ( A - B ) =/= 0 ) $.
      $( If the difference of two complex numbers is nonzero, they are
         unequal.  Converse of ~ subne0d .  Contrapositive of ~ subeq0bd .
         (Contributed by David Moews, 28-Feb-2017.) $)
      subne0ad $p |- ( ph -> A =/= B ) $=
        ( cmin co cc0 wne subeq0ad necon3bid mpbid ) ABCGHZIJBCJFANIBCABCDEKLM
        $.
    $}

    ${
      neg11d.3 $e |- ( ph -> -u A = -u B ) $.
      $( If the difference between two numbers is zero, they are equal.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      neg11d $p |- ( ph -> A = B ) $=
        ( cneg wceq neg11ad mpbid ) ABGCGHBCHFABCDEIJ $.
    $}

    $( Distribution of negative over addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    negdid $p |- ( ph -> -u ( A + B ) = ( -u A + -u B ) ) $=
      ( cc wcel caddc co cneg wceq negdi syl2anc ) ABFGCFGBCHIJBJCJHIKDEBCLM $.

    $( Distribution of negative over addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    negdi2d $p |- ( ph -> -u ( A + B ) = ( -u A - B ) ) $=
      ( cc wcel caddc co cneg cmin wceq negdi2 syl2anc ) ABFGCFGBCHIJBJCKILDEBC
      MN $.

    $( Distribution of negative over subtraction.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    negsubdid $p |- ( ph -> -u ( A - B ) = ( -u A + B ) ) $=
      ( cc wcel cmin co cneg caddc wceq negsubdi syl2anc ) ABFGCFGBCHIJBJCKILDE
      BCMN $.

    $( Distribution of negative over subtraction.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    negsubdi2d $p |- ( ph -> -u ( A - B ) = ( B - A ) ) $=
      ( cc wcel cmin co cneg wceq negsubdi2 syl2anc ) ABFGCFGBCHIJCBHIKDEBCLM
      $.

    $( Relationship between subtraction and negative.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    neg2subd $p |- ( ph -> ( -u A - -u B ) = ( B - A ) ) $=
      ( cc wcel cneg cmin co wceq neg2sub syl2anc ) ABFGCFGBHCHIJCBIJKDEBCLM $.

    subaddd.3 $e |- ( ph -> C e. CC ) $.
    $( Relationship between subtraction and addition.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    subaddd $p |- ( ph -> ( ( A - B ) = C <-> ( B + C ) = A ) ) $=
      ( cc wcel cmin co wceq caddc wb subadd syl3anc ) ABHICHIDHIBCJKDLCDMKBLNE
      FGBCDOP $.

    $( Relationship between subtraction and addition.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    subadd2d $p |- ( ph -> ( ( A - B ) = C <-> ( C + B ) = A ) ) $=
      ( cc wcel cmin co wceq caddc wb subadd2 syl3anc ) ABHICHIDHIBCJKDLDCMKBLN
      EFGBCDOP $.

    $( Associative-type law for subtraction and addition.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    addsubassd $p |- ( ph -> ( ( A + B ) - C ) = ( A + ( B - C ) ) ) $=
      ( cc wcel caddc co cmin wceq addsubass syl3anc ) ABHICHIDHIBCJKDLKBCDLKJK
      MEFGBCDNO $.

    $( Law for subtraction and addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    addsubd $p |- ( ph -> ( ( A + B ) - C ) = ( ( A - C ) + B ) ) $=
      ( cc wcel caddc co cmin wceq addsub syl3anc ) ABHICHIDHIBCJKDLKBDLKCJKMEF
      GBCDNO $.

    $( Commutative/associative law for addition and subtraction.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    subadd23d $p |- ( ph -> ( ( A - B ) + C ) = ( A + ( C - B ) ) ) $=
      ( cc wcel cmin co caddc wceq subadd23 syl3anc ) ABHICHIDHIBCJKDLKBDCJKLKM
      EFGBCDNO $.

    $( Commutative/associative law for addition and subtraction.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    addsub12d $p |- ( ph -> ( A + ( B - C ) ) = ( B + ( A - C ) ) ) $=
      ( cc wcel cmin co caddc wceq addsub12 syl3anc ) ABHICHIDHIBCDJKLKCBDJKLKM
      EFGBCDNO $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    npncand $p |- ( ph -> ( ( A - B ) + ( B - C ) ) = ( A - C ) ) $=
      ( cc wcel cmin co caddc wceq npncan syl3anc ) ABHICHIDHIBCJKCDJKLKBDJKMEF
      GBCDNO $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nppcand $p |- ( ph -> ( ( ( A - B ) + C ) + B ) = ( A + C ) ) $=
      ( cc wcel cmin co caddc wceq nppcan syl3anc ) ABHICHIDHIBCJKDLKCLKBDLKMEF
      GBCDNO $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nppcan2d $p |- ( ph -> ( ( A - ( B + C ) ) + C ) = ( A - B ) ) $=
      ( cc wcel caddc co cmin wceq nppcan2 syl3anc ) ABHICHIDHIBCDJKLKDJKBCLKME
      FGBCDNO $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nppcan3d $p |- ( ph -> ( ( A - B ) + ( C + B ) ) = ( A + C ) ) $=
      ( cc wcel cmin co caddc wceq nppcan3 syl3anc ) ABHICHIDHIBCJKDCLKLKBDLKME
      FGBCDNO $.

    $( Law for double subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subsubd $p |- ( ph -> ( A - ( B - C ) ) = ( ( A - B ) + C ) ) $=
      ( cc wcel cmin co caddc wceq subsub syl3anc ) ABHICHIDHIBCDJKJKBCJKDLKMEF
      GBCDNO $.

    $( Law for double subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subsub2d $p |- ( ph -> ( A - ( B - C ) ) = ( A + ( C - B ) ) ) $=
      ( cc wcel cmin co caddc wceq subsub2 syl3anc ) ABHICHIDHIBCDJKJKBDCJKLKME
      FGBCDNO $.

    $( Law for double subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subsub3d $p |- ( ph -> ( A - ( B - C ) ) = ( ( A + C ) - B ) ) $=
      ( cc wcel cmin co caddc wceq subsub3 syl3anc ) ABHICHIDHIBCDJKJKBDLKCJKME
      FGBCDNO $.

    $( Law for double subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subsub4d $p |- ( ph -> ( ( A - B ) - C ) = ( A - ( B + C ) ) ) $=
      ( cc wcel cmin co caddc wceq subsub4 syl3anc ) ABHICHIDHIBCJKDJKBCDLKJKME
      FGBCDNO $.

    $( Swap the second and third terms in a double subtraction.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    sub32d $p |- ( ph -> ( ( A - B ) - C ) = ( ( A - C ) - B ) ) $=
      ( cc wcel cmin co wceq sub32 syl3anc ) ABHICHIDHIBCJKDJKBDJKCJKLEFGBCDMN
      $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnncand $p |- ( ph -> ( ( A - ( B - C ) ) - C ) = ( A - B ) ) $=
      ( cc wcel cmin co wceq nnncan syl3anc ) ABHICHIDHIBCDJKJKDJKBCJKLEFGBCDMN
      $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnncan1d $p |- ( ph -> ( ( A - B ) - ( A - C ) ) = ( C - B ) ) $=
      ( cc wcel cmin co wceq nnncan1 syl3anc ) ABHICHIDHIBCJKBDJKJKDCJKLEFGBCDM
      N $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnncan2d $p |- ( ph -> ( ( A - C ) - ( B - C ) ) = ( A - B ) ) $=
      ( cc wcel cmin co wceq nnncan2 syl3anc ) ABHICHIDHIBDJKCDJKJKBCJKLEFGBCDM
      N $.

    $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    npncan3d $p |- ( ph -> ( ( A - B ) + ( C - A ) ) = ( C - B ) ) $=
      ( cc wcel cmin co caddc wceq npncan3 syl3anc ) ABHICHIDHIBCJKDBJKLKDCJKME
      FGBCDNO $.

    $( Cancellation law for mixed addition and subtraction.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    pnpcand $p |- ( ph -> ( ( A + B ) - ( A + C ) ) = ( B - C ) ) $=
      ( cc wcel caddc co cmin wceq pnpcan syl3anc ) ABHICHIDHIBCJKBDJKLKCDLKMEF
      GBCDNO $.

    $( Cancellation law for mixed addition and subtraction.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    pnpcan2d $p |- ( ph -> ( ( A + C ) - ( B + C ) ) = ( A - B ) ) $=
      ( cc wcel caddc co cmin wceq pnpcan2 syl3anc ) ABHICHIDHIBDJKCDJKLKBCLKME
      FGBCDNO $.

    $( Cancellation law for mixed addition and subtraction.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    pnncand $p |- ( ph -> ( ( A + B ) - ( A - C ) ) = ( B + C ) ) $=
      ( cc wcel caddc co cmin wceq pnncan syl3anc ) ABHICHIDHIBCJKBDLKLKCDJKMEF
      GBCDNO $.

    $( Cancellation law for mixed addition and subtraction.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    ppncand $p |- ( ph -> ( ( A + B ) + ( C - B ) ) = ( A + C ) ) $=
      ( cc wcel caddc co cmin wceq ppncan syl3anc ) ABHICHIDHIBCJKDCLKJKBDJKMEF
      GBCDNO $.

    ${
      subcand.4 $e |- ( ph -> ( A - B ) = ( A - C ) ) $.
      $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      subcand $p |- ( ph -> B = C ) $=
        ( cmin co wceq cc wcel wb subcan syl3anc mpbid ) ABCIJBDIJKZCDKZHABLMCL
        MDLMRSNEFGBCDOPQ $.
    $}

    ${
      subcan2d.4 $e |- ( ph -> ( A - C ) = ( B - C ) ) $.
      $( Cancellation law for subtraction.  (Contributed by Mario Carneiro,
         22-Sep-2016.) $)
      subcan2d $p |- ( ph -> A = B ) $=
        ( cmin co wceq cc wcel wb subcan2 syl3anc mpbid ) ABDIJCDIJKZBCKZHABLMC
        LMDLMRSNEFGBCDOPQ $.
    $}

    $( Cancellation law for subtraction.  Deduction form of ~ subcan .
       Generalization of ~ subcand .  (Contributed by David Moews,
       28-Feb-2017.) $)
    subcanad $p |- ( ph -> ( ( A - B ) = ( A - C ) <-> B = C ) ) $=
      ( cc wcel cmin co wceq wb subcan syl3anc ) ABHICHIDHIBCJKBDJKLCDLMEFGBCDN
      O $.

    ${
      subneintrd.4 $e |- ( ph -> B =/= C ) $.
      $( Introducing subtraction on both sides of a statement of nonequality.
         Contrapositive of ~ subcand .  (Contributed by David Moews,
         28-Feb-2017.) $)
      subneintrd $p |- ( ph -> ( A - B ) =/= ( A - C ) ) $=
        ( cmin co wne subcanad necon3bid mpbird ) ABCIJZBDIJZKCDKHAOPCDABCDEFGL
        MN $.
    $}

    ${
      $( Cancellation law for subtraction.  Deduction form of ~ subcan2 .
         Generalization of ~ subcan2d .  (Contributed by David Moews,
         28-Feb-2017.) $)
      subcan2ad $p |- ( ph -> ( ( A - C ) = ( B - C ) <-> A = B ) ) $=
        ( cc wcel cmin co wceq wb subcan2 syl3anc ) ABHICHIDHIBDJKCDJKLBCLMEFGB
        CDNO $.
    $}

    ${
      subneintr2d.4 $e |- ( ph -> A =/= B ) $.
      $( Introducing subtraction on both sides of a statement of nonequality.
         Contrapositive of ~ subcan2d .  (Contributed by David Moews,
         28-Feb-2017.) $)
      subneintr2d $p |- ( ph -> ( A - C ) =/= ( B - C ) ) $=
        ( cmin co wne subcan2ad necon3bid mpbird ) ABDIJZCDIJZKBCKHAOPBCABCDEFG
        LMN $.
    $}

    addsub4d.4 $e |- ( ph -> D e. CC ) $.
    $( Rearrangement of 4 terms in a mixed addition and subtraction.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    addsub4d $p |- ( ph ->
                ( ( A + B ) - ( C + D ) ) = ( ( A - C ) + ( B - D ) ) ) $=
      ( cc wcel caddc co cmin wceq addsub4 syl22anc ) ABJKCJKDJKEJKBCLMDELMNMBD
      NMCENMLMOFGHIBCDEPQ $.

    $( Rearrangement of 4 terms in a mixed addition and subtraction.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    subadd4d $p |- ( ph ->
                ( ( A - B ) - ( C - D ) ) = ( ( A + D ) - ( B + C ) ) ) $=
      ( cc wcel cmin co caddc wceq subadd4 syl22anc ) ABJKCJKDJKEJKBCLMDELMLMBE
      NMCDNMLMOFGHIBCDEPQ $.

    $( Rearrangement of 4 terms in a subtraction.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    sub4d $p |- ( ph ->
                ( ( A - B ) - ( C - D ) ) = ( ( A - C ) - ( B - D ) ) ) $=
      ( cc wcel cmin co wceq sub4 syl22anc ) ABJKCJKDJKEJKBCLMDELMLMBDLMCELMLMN
      FGHIBCDEOP $.

    $( Law for subtraction and addition.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    2addsubd $p |- ( ph ->
      ( ( ( A + B ) + C ) - D ) = ( ( ( A + C ) - D ) + B ) ) $=
      ( cc wcel caddc co cmin wceq 2addsub syl22anc ) ABJKCJKDJKEJKBCLMDLMENMBD
      LMENMCLMOFGHIBCDEPQ $.

    $( Relation between sums and differences.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    addsubeq4d $p |- ( ph ->
        ( ( A + B ) = ( C + D ) <-> ( C - A ) = ( B - D ) ) ) $=
      ( cc wcel caddc co wceq cmin wb addsubeq4 syl22anc ) ABJKCJKDJKEJKBCLMDEL
      MNDBOMCEOMNPFGHIBCDEQR $.
  $}

  ${
    subeq0bd.1 $e |- ( ph -> A e. CC ) $.
    subeq0bd.2 $e |- ( ph -> A = B ) $.
    $( If two complex numbers are equal, their difference is zero.  Consequence
       of ~ subeq0ad .  Converse of ~ subeq0d .  Contrapositive of
       ~ subne0ad .  (Contributed by David Moews, 28-Feb-2017.) $)
    subeq0bd $p |- ( ph -> ( A - B ) = 0 ) $=
      ( cmin co cc0 wceq cc eqeltrrd subeq0ad mpbird ) ABCFGHIBCIEABCDABCJEDKLM
      $.
  $}

  ${
    renegcld.1 $e |- ( ph -> A e. RR ) $.
    $( Closure law for negative of reals.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    renegcld $p |- ( ph -> -u A e. RR ) $=
      ( cr wcel cneg renegcl syl ) ABDEBFDECBGH $.

    resubcld.2 $e |- ( ph -> B e. RR ) $.
    $( Closure law for subtraction of reals.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    resubcld $p |- ( ph -> ( A - B ) e. RR ) $=
      ( cr wcel cmin co resubcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Multiplication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Product of two sums.  (Contributed by NM, 14-Jan-2006.)  (Proof shortened
     by Andrew Salmon, 19-Nov-2011.) $)
  muladd $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
               ( ( A + B ) x. ( C + D ) ) =
       ( ( ( A x. C ) + ( D x. B ) ) + ( ( A x. D ) + ( C x. B ) ) ) ) $=
    ( cc wcel wa caddc co cmul wceq addcl 3expa adantrl oveq12d mulcl ad2ant2lr
    adddir syl2an ad2ant2l adddi adantrr ad2ant2r anandirs add32d mulcom oveq2d
    3expb sylan ad2ant2rl addassd ancoms 3eqtr3d an4s 3eqtrd ) AEFZBEFZGZCEFZDE
    FZGZGZABHIZCDHIJIZVCCJIZVCDJIZHIZACJIZBCJIZHIZADJIZBDJIZHIZHIZVHDBJIZHIZVKC
    BJIZHIHIZURVCEFZVAVDVGKZABLVSUSUTVTVCCDUAUHUIVBVEVJVFVMHURUSVEVJKZUTUPUQUSW
    AABCRMUBURUTVFVMKZUSUPUQUTWBABDRMNOVBVNVHVMHIZVIHIVPVKHIZVQHIVRVBVHVIVMUPUS
    VHEFZUQUTACPZUCZUQUSVIEFUPUTBCPQURUTVMEFZUSUPUQUTWHUPUTGVKEFZVLEFZWHUQUTGZA
    DPZBDPZVKVLLSUDNUEVBWCWDVIVQHVBVHVKHIZVLHIWNVOHIWCWDVBVLVOWNHUQUTVLVOKUPUSB
    DUFTUGVBVHVKVLWGUPUTWIUQUSWLUJZUQUTWJUPUSWMTUKVBVHVKVOWGWOUQUTVOEFZUPUSUTUQ
    WPDBPULZTUEUMUQUSVIVQKUPUTBCUFQOVBVPVKVQUPUSUQUTVPEFZUPUSGWEWPWRWKWFWQVHVOL
    SUNWOUQUSVQEFZUPUTUSUQWSCBPULQUKUOUO $.

  $( Distribution of multiplication over subtraction.  Theorem I.5 of [Apostol]
     p. 18.  (Contributed by NM, 18-Nov-2004.) $)
  subdi $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( A x. ( B - C ) ) = ( ( A x. B ) - ( A x. C ) ) ) $=
    ( cc wcel w3a cmul cmin wceq caddc simp1 simp3 3adant1 adddid pncan3 ancoms
    co subcl oveq2d mulcl eqtr3d 3adant3 3adant2 wa sylan2 3impb subaddd mpbird
    eqcomd ) ADEZBDEZCDEZFZABGQZACGQZHQZABCHQZGQZUMUPURIUOURJQZUNIUMACUQJQZGQUS
    UNUMACUQUJUKULKUJUKULLUKULUQDEZUJBCRZMNUMUTBAGUKULUTBIZUJULUKVCCBOPMSUAUMUN
    UOURUJUKUNDEULABTUBUJULUODEUKACTUCUJUKULURDEZUKULUDUJVAVDVBAUQTUEUFUGUHUI
    $.

  $( Distribution of multiplication over subtraction.  Theorem I.5 of [Apostol]
     p. 18.  (Contributed by NM, 30-Dec-2005.) $)
  subdir $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
               ( ( A - B ) x. C ) = ( ( A x. C ) - ( B x. C ) ) ) $=
    ( cc wcel cmin co cmul wceq subdi 3coml wa subcl mulcom sylan 3impa 3adant2
    w3a 3adant1 oveq12d 3eqtr4d ) ADEZBDEZCDEZRZCABFGZHGZCAHGZCBHGZFGZUFCHGZACH
    GZBCHGZFGUDUBUCUGUJICABJKUBUCUDUKUGIZUBUCLUFDEUDUNABMUFCNOPUEULUHUMUIFUBUDU
    LUHIUCACNQUCUDUMUIIUBBCNSTUA $.

  $( The imaginary unit ` _i ` is not zero.  (Contributed by NM,
     6-May-1999.) $)
  ine0 $p |- _i =/= 0 $=
    ( ci cc0 wceq c1 ax-1ne0 neii caddc cmul oveq2 ax-icn mul01i syl6req oveq1d
    co ax-1cn addid2i ax-i2m1 3eqtr3g mto neir ) ABABCZDBCDBEFUABDGNAAHNZDGNDBU
    ABUBDGUAUBABHNBABAHIAJKLMDOPQRST $.

  $( Product with negative is negative of product.  Theorem I.12 of [Apostol]
     p. 18.  (Contributed by NM, 14-May-1999.)  (Proof shortened by Mario
     Carneiro, 27-May-2016.) $)
  mulneg1 $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( -u A x. B ) = -u ( A x. B ) ) $=
    ( cc wcel wa cmin co cmul cneg wceq subdir mp3an1 simpr mul02d oveq1d eqtrd
    cc0 0cn df-neg oveq1i 3eqtr4g ) ACDZBCDZEZQAFGZBHGZQABHGZFGZAIZBHGUGIUDUFQB
    HGZUGFGZUHQCDUBUCUFUKJRQABKLUDUJQUGFUDBUBUCMNOPUIUEBHASTUGSUA $.

  $( The product with a negative is the negative of the product.  (Contributed
     by NM, 30-Jul-2004.) $)
  mulneg2 $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( A x. -u B ) = -u ( A x. B ) ) $=
    ( cc wcel wa cneg cmul co mulneg1 ancoms negcl mulcom sylan2 negeqd 3eqtr4d
    wceq ) ACDZBCDZEZBFZAGHZBAGHZFZATGHZABGHZFRQUAUCPBAIJRQTCDUDUAPBKATLMSUEUBA
    BLNO $.

  $( Swap the negative sign in a product.  (Contributed by NM, 30-Jul-2004.) $)
  mulneg12 $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( -u A x. B ) = ( A x. -u B ) ) $=
    ( cc wcel wa cneg cmul co mulneg1 mulneg2 eqtr4d ) ACDBCDEAFBGHABGHFABFGHAB
    IABJK $.

  $( Product of two negatives.  Theorem I.12 of [Apostol] p. 18.  (Contributed
     by NM, 30-Jul-2004.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  mul2neg $p |- ( ( A e. CC /\ B e. CC ) -> ( -u A x. -u B ) = ( A x. B ) ) $=
    ( cc wcel wa cneg cmul co negcl mulneg12 sylan2 negneg adantl oveq2d eqtrd
    wceq ) ACDZBCDZEZAFBFZGHZATFZGHZABGHRQTCDUAUCPBIATJKSUBBAGRUBBPQBLMNO $.

  $( Convert a subtraction to addition using multiplication by a negative.
     (Contributed by NM, 2-Feb-2007.) $)
  submul2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( A - ( B x. C ) ) = ( A + ( B x. -u C ) ) ) $=
    ( cc wcel cmul co cmin cneg caddc wceq wa adantl oveq2d mulcl negsub sylan2
    mulneg2 eqtr2d 3impb ) ADEZBDEZCDEZABCFGZHGZABCIFGZJGZKUAUBUCLZLZUGAUDIZJGZ
    UEUIUFUJAJUHUFUJKUABCRMNUHUAUDDEUKUEKBCOAUDPQST $.

  $( Product with minus one is negative.  (Contributed by NM, 16-Nov-1999.) $)
  mulm1 $p |- ( A e. CC -> ( -u 1 x. A ) = -u A ) $=
    ( cc wcel c1 cneg cmul co wceq ax-1cn mulneg1 mpan mulid2 negeqd eqtrd ) AB
    CZDEAFGZDAFGZEZAEDBCOPRHIDAJKOQAALMN $.

  $( Product of two differences.  (Contributed by NM, 14-Jan-2006.) $)
  mulsub $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
               ( ( A - B ) x. ( C - D ) ) =
       ( ( ( A x. C ) + ( D x. B ) ) - ( ( A x. D ) + ( C x. B ) ) ) ) $=
    ( cc wcel wa cneg caddc cmul cmin negsub oveqan12d wceq negcl mulneg2 mulcl
    co ancoms syl2an muladd sylanr2 sylanl2 mul2neg oveq2d negdi eqtr4d ancom2s
    ad2ant2l an42s oveq12d addcl an4s negsubd 3eqtrd eqtr3d ) AEFZBEFZGZCEFZDEF
    ZGZGZABHZIRZCDHZIRZJRZABKRZCDKRZJRACJRZDBJRZIRZADJRZCBJRZIRZKRZUSVBVEVIVGVJ
    JABLCDLMVCVHVKVFVDJRZIRZAVFJRZCVDJRZIRZIRZVMVPHZIRVQURUQVDEFZVBVHWCNZBOVAUQ
    WEGUTVFEFWFDOAVDCVFUAUBUCVCVSVMWBWDIURVAVSVMNUQUTURVAGZVRVLVKIVAURVRVLNDBUD
    SUEUIUQVAURUTWBWDNZUQVAGZUTURWHWIUTURGZGWBVNHZVOHZIRZWDWIWJVTWKWAWLIADPCBPM
    WIVNEFZVOEFZWDWMNWJADQZCBQZVNVOUFTUGUHUJUKVCVMVPUQUTURVAVMEFZUQUTGVKEFVLEFZ
    WRWGACQVAURWSDBQSVKVLULTUMUQVAURUTVPEFZWIWNWOWTURUTGWPUTURWOWQSVNVOULTUJUNU
    OUP $.

  $( Swap the order of subtraction in a multiplication.  (Contributed by Scott
     Fenton, 24-Jun-2013.) $)
  mulsub2 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
    ( ( A - B ) x. ( C - D ) ) = ( ( B - A ) x. ( D - C ) ) ) $=
    ( cc wcel wa cmin co cneg cmul wceq subcl syl2an negsubdi2 oveqan12d eqtr3d
    mul2neg ) AEFBEFGZCEFDEFGZGABHIZJZCDHIZJZKIZUAUCKIZBAHIZDCHIZKISUAEFUCEFUEU
    FLTABMCDMUAUCRNSTUBUGUDUHKABOCDOPQ $.

  ${
    mulm1.1 $e |- A e. CC $.
    $( Product with minus one is negative.  (Contributed by NM,
       31-Jul-1999.) $)
    mulm1i $p |- ( -u 1 x. A ) = -u A $=
      ( cc wcel c1 cneg cmul co wceq mulm1 ax-mp ) ACDEFAGHAFIBAJK $.

    mulneg.2 $e |- B e. CC $.
    $( Product with negative is negative of product.  Theorem I.12 of [Apostol]
       p. 18.  (Contributed by NM, 10-Feb-1995.)  (Revised by Mario Carneiro,
       27-May-2016.) $)
    mulneg1i $p |- ( -u A x. B ) = -u ( A x. B ) $=
      ( cc wcel cneg cmul co wceq mulneg1 mp2an ) AEFBEFAGBHIABHIGJCDABKL $.

    $( Product with negative is negative of product.  (Contributed by NM,
       31-Jul-1999.)  (Revised by Mario Carneiro, 27-May-2016.) $)
    mulneg2i $p |- ( A x. -u B ) = -u ( A x. B ) $=
      ( cc wcel cneg cmul co wceq mulneg2 mp2an ) AEFBEFABGHIABHIGJCDABKL $.

    $( Product of two negatives.  Theorem I.12 of [Apostol] p. 18.
       (Contributed by NM, 14-Feb-1995.)  (Revised by Mario Carneiro,
       27-May-2016.) $)
    mul2negi $p |- ( -u A x. -u B ) = ( A x. B ) $=
      ( cc wcel cneg cmul co wceq mul2neg mp2an ) AEFBEFAGBGHIABHIJCDABKL $.

    subdi.3 $e |- C e. CC $.
    $( Distribution of multiplication over subtraction.  Theorem I.5 of
       [Apostol] p. 18.  (Contributed by NM, 26-Nov-1994.) $)
    subdii $p |- ( A x. ( B - C ) ) = ( ( A x. B ) - ( A x. C ) ) $=
      ( cc wcel cmin co cmul wceq subdi mp3an ) AGHBGHCGHABCIJKJABKJACKJIJLDEFA
      BCMN $.

    $( Distribution of multiplication over subtraction.  Theorem I.5 of
       [Apostol] p. 18.  (Contributed by NM, 8-May-1999.) $)
    subdiri $p |- ( ( A - B ) x. C ) = ( ( A x. C ) - ( B x. C ) ) $=
      ( cc wcel cmin co cmul wceq subdir mp3an ) AGHBGHCGHABIJCKJACKJBCKJIJLDEF
      ABCMN $.

    muladdi.4 $e |- D e. CC $.
    $( Product of two sums.  (Contributed by NM, 17-May-1999.) $)
    muladdi $p |- ( ( A + B ) x. ( C + D ) ) =
        ( ( ( A x. C ) + ( D x. B ) ) + ( ( A x. D ) + ( C x. B ) ) ) $=
      ( cc wcel caddc co cmul wceq muladd mp4an ) AIJBIJCIJDIJABKLCDKLMLACMLDBM
      LKLADMLCBMLKLKLNEFGHABCDOP $.
  $}

  ${
    mulm1d.1 $e |- ( ph -> A e. CC ) $.
    $( Product with minus one is negative.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulm1d $p |- ( ph -> ( -u 1 x. A ) = -u A ) $=
      ( cc wcel c1 cneg cmul co wceq mulm1 syl ) ABDEFGBHIBGJCBKL $.

    mulnegd.2 $e |- ( ph -> B e. CC ) $.
    $( Product with negative is negative of product.  Theorem I.12 of [Apostol]
       p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    mulneg1d $p |- ( ph -> ( -u A x. B ) = -u ( A x. B ) ) $=
      ( cc wcel cneg cmul co wceq mulneg1 syl2anc ) ABFGCFGBHCIJBCIJHKDEBCLM $.

    $( Product with negative is negative of product.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    mulneg2d $p |- ( ph -> ( A x. -u B ) = -u ( A x. B ) ) $=
      ( cc wcel cneg cmul co wceq mulneg2 syl2anc ) ABFGCFGBCHIJBCIJHKDEBCLM $.

    $( Product of two negatives.  Theorem I.12 of [Apostol] p. 18.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    mul2negd $p |- ( ph -> ( -u A x. -u B ) = ( A x. B ) ) $=
      ( cc wcel cneg cmul co wceq mul2neg syl2anc ) ABFGCFGBHCHIJBCIJKDEBCLM $.

    subdid.3 $e |- ( ph -> C e. CC ) $.
    $( Distribution of multiplication over subtraction.  Theorem I.5 of
       [Apostol] p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    subdid $p |- ( ph -> ( A x. ( B - C ) ) = ( ( A x. B ) - ( A x. C ) ) ) $=
      ( cc wcel cmin co cmul wceq subdi syl3anc ) ABHICHIDHIBCDJKLKBCLKBDLKJKME
      FGBCDNO $.

    $( Distribution of multiplication over subtraction.  Theorem I.5 of
       [Apostol] p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    subdird $p |- ( ph -> ( ( A - B ) x. C ) = ( ( A x. C ) - ( B x. C ) ) ) $=
      ( cc wcel cmin co cmul wceq subdir syl3anc ) ABHICHIDHIBCJKDLKBDLKCDLKJKM
      EFGBCDNO $.

    muladdd.4 $e |- ( ph -> D e. CC ) $.
    $( Product of two sums.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    muladdd $p |- ( ph -> ( ( A + B ) x. ( C + D ) ) =
        ( ( ( A x. C ) + ( D x. B ) ) + ( ( A x. D ) + ( C x. B ) ) ) ) $=
      ( cc wcel caddc co cmul wceq muladd syl22anc ) ABJKCJKDJKEJKBCLMDELMNMBDN
      MECNMLMBENMDCNMLMLMOFGHIBCDEPQ $.

    $( Product of two differences.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    mulsubd $p |- ( ph -> ( ( A - B ) x. ( C - D ) ) =
         ( ( ( A x. C ) + ( D x. B ) ) - ( ( A x. D ) + ( C x. B ) ) ) ) $=
      ( cc wcel cmin co cmul caddc wceq mulsub syl22anc ) ABJKCJKDJKEJKBCLMDELM
      NMBDNMECNMOMBENMDCNMOMLMPFGHIBCDEQR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordering on reals (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Positive implies nonzero.  (Contributed by NM, 3-Oct-1999.)  (Proof
     shortened by Mario Carneiro, 27-May-2016.) $)
  gt0ne0 $p |- ( ( A e. RR /\ 0 < A ) -> A =/= 0 ) $=
    ( cr wcel cc0 clt wbr wne 0re a1i ltne sylan ) ABCZDBCZDAEFADGMLHIDAJK $.

  $( A number which is less than zero is not zero.  (Contributed by Stefan
     O'Rear, 13-Sep-2014.) $)
  lt0ne0 $p |- ( ( A e. RR /\ A < 0 ) -> A =/= 0 ) $=
    ( cr wcel cc0 clt wbr wa ltne necomd ) ABCADEFGDAADHI $.

  $( Addition to both sides of 'less than'.  (Contributed by NM, 12-Nov-1999.)
     (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  ltadd1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( A + C ) < ( B + C ) ) ) $=
    ( cr wcel w3a clt wbr caddc co ltadd2 simp3 recnd simp1 addcomd simp2 bitrd
    breq12d ) ADEZBDEZCDEZFZABGHCAIJZCBIJZGHACIJZBCIJZGHABCKUBUCUEUDUFGUBCAUBCS
    TUALMZUBASTUANMOUBCBUGUBBSTUAPMORQ $.

  $( Addition to both sides of 'less than or equal to'.  (Contributed by NM,
     18-Oct-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  leadd1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( A + C ) <_ ( B + C ) ) ) $=
    ( cr w3a clt wbr wn caddc co cle wb ltadd1 3com12 notbid simp1 simp2 lenltd
    wcel readdcld simp3 3bitr4d ) ADSZBDSZCDSZEZBAFGZHBCIJZACIJZFGZHABKGUIUHKGU
    FUGUJUDUCUEUGUJLBACMNOUFABUCUDUEPZUCUDUEQZRUFUIUHUFACUKUCUDUEUAZTUFBCULUMTR
    UB $.

  $( Addition to both sides of 'less than or equal to'.  (Contributed by NM,
     26-Oct-1999.) $)
  leadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( C + A ) <_ ( C + B ) ) ) $=
    ( cr wcel w3a cle wbr caddc co leadd1 simp1 recnd simp3 addcomd simp2 bitrd
    breq12d ) ADEZBDEZCDEZFZABGHACIJZBCIJZGHCAIJZCBIJZGHABCKUBUCUEUDUFGUBACUBAS
    TUALMUBCSTUANMZOUBBCUBBSTUAPMUGORQ $.

  $( 'Less than' relationship between subtraction and addition.  (Contributed
     by NM, 21-Jan-1997.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  ltsubadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( ( A - B ) < C <-> A < ( C + B ) ) ) $=
    ( cr wcel w3a co clt wbr caddc wb simp1 simp2 resubcld simp3 ltadd1 syl3anc
    cmin recnd npcand breq1d bitrd ) ADEZBDEZCDEZFZABRGZCHIZUGBJGZCBJGZHIZAUJHI
    UFUGDEUEUDUHUKKUFABUCUDUELZUCUDUEMZNUCUDUEOUMUGCBPQUFUIAUJHUFABUFAULSUFBUMS
    TUAUB $.

  $( 'Less than' relationship between subtraction and addition.  (Contributed
     by NM, 21-Jan-1997.) $)
  ltsubadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) < C <-> A < ( B + C ) ) ) $=
    ( cr wcel w3a cmin clt wbr caddc ltsubadd simp2 recnd addcomd breq2d bitr4d
    co simp3 ) ADEZBDEZCDEZFZABGQCHIACBJQZHIABCJQZHIABCKUBUDUCAHUBBCUBBSTUALMUB
    CSTUARMNOP $.

  $( 'Less than or equal to' relationship between subtraction and addition.
     (Contributed by NM, 17-Nov-2004.)  (Proof shortened by Mario Carneiro,
     27-May-2016.) $)
  lesubadd $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) <_ C <-> A <_ ( C + B ) ) ) $=
    ( cr wcel w3a co cle wbr caddc wb simp1 simp2 resubcld simp3 leadd1 syl3anc
    cmin recnd npcand breq1d bitrd ) ADEZBDEZCDEZFZABRGZCHIZUGBJGZCBJGZHIZAUJHI
    UFUGDEUEUDUHUKKUFABUCUDUELZUCUDUEMZNUCUDUEOUMUGCBPQUFUIAUJHUFABUFAULSUFBUMS
    TUAUB $.

  $( 'Less than or equal to' relationship between subtraction and addition.
     (Contributed by NM, 10-Aug-1999.) $)
  lesubadd2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) <_ C <-> A <_ ( B + C ) ) ) $=
    ( cr wcel w3a cmin cle wbr caddc lesubadd simp2 recnd addcomd breq2d bitr4d
    co simp3 ) ADEZBDEZCDEZFZABGQCHIACBJQZHIABCJQZHIABCKUBUDUCAHUBBCUBBSTUALMUB
    CSTUARMNOP $.

  $( 'Less than' relationship between addition and subtraction.  (Contributed
     by NM, 17-Nov-2004.) $)
  ltaddsub $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) < C <-> A < ( C - B ) ) ) $=
    ( cr wcel w3a caddc co clt wbr cmin cle wn wb lesubadd 3com13 resubcl lenlt
    wa sylan 3impa readdcl sylan2 3impb 3coml 3bitr3rd con4bid ) ADEZBDEZCDEZFZ
    ABGHZCIJZACBKHZIJZUKUNALJZCULLJZUOMZUMMZUJUIUHUPUQNCBAOPUJUIUHUPURNZUJUIUHU
    TUJUISUNDEUHUTCBQUNARTUAPUJUHUIUQUSNZUJUHUIVAUHUISUJULDEVAABUBCULRUCUDUEUFU
    G $.

  $( 'Less than' relationship between addition and subtraction.  (Contributed
     by NM, 17-Nov-2004.) $)
  ltaddsub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) < C <-> B < ( C - A ) ) ) $=
    ( cr wcel w3a caddc co clt wbr cmin wceq cc addcom syl2an 3adant3 breq1d wb
    recn ltaddsub 3com12 bitrd ) ADEZBDEZCDEZFZABGHZCIJBAGHZCIJZBCAKHIJZUFUGUHC
    IUCUDUGUHLZUEUCAMEBMEUKUDASBSABNOPQUDUCUEUIUJRBACTUAUB $.

  $( 'Less than or equal to' relationship between addition and subtraction.
     (Contributed by NM, 6-Apr-2005.) $)
  leaddsub $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) <_ C <-> A <_ ( C - B ) ) ) $=
    ( cr wcel w3a caddc co cle wbr cmin clt wn wb ltsubadd 3com13 resubcl ltnle
    wa sylan 3impa readdcl sylan2 3impb 3coml 3bitr3rd con4bid ) ADEZBDEZCDEZFZ
    ABGHZCIJZACBKHZIJZUKUNALJZCULLJZUOMZUMMZUJUIUHUPUQNCBAOPUJUIUHUPURNZUJUIUHU
    TUJUISUNDEUHUTCBQUNARTUAPUJUHUIUQUSNZUJUHUIVAUHUISUJULDEVAABUBCULRUCUDUEUFU
    G $.

  $( 'Less than or equal to' relationship between and addition and
     subtraction.  (Contributed by NM, 6-Apr-2005.) $)
  leaddsub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A + B ) <_ C <-> B <_ ( C - A ) ) ) $=
    ( cr wcel w3a caddc co cle wbr cmin wceq cc addcom syl2an 3adant3 breq1d wb
    recn leaddsub 3com12 bitrd ) ADEZBDEZCDEZFZABGHZCIJBAGHZCIJZBCAKHIJZUFUGUHC
    IUCUDUGUHLZUEUCAMEBMEUKUDASBSABNOPQUDUCUEUIUJRBACTUAUB $.

  $( Swap subtrahends in an inequality.  (Contributed by NM, 29-Sep-2005.) $)
  suble $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) <_ C <-> ( A - C ) <_ B ) ) $=
    ( cr wcel w3a cmin co cle wbr caddc lesubadd wb lesubadd2 3com23 bitr4d ) A
    DEZBDEZCDEZFABGHCIJACBKHIJZACGHBIJZABCLQSRUATMACBNOP $.

  $( Swap subtrahends in an inequality.  (Contributed by NM, 29-Sep-2005.)
     (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  lesub $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( A <_ ( B - C ) <-> C <_ ( B - A ) ) ) $=
    ( cr wcel cmin co cle wbr wb w3a caddc leaddsub leaddsub2 bitr3d 3com23 ) A
    DEZCDEZBDEZABCFGHIZCBAFGHIZJQRSKACLGBHITUAACBMACBNOP $.

  $( 'Less than' relationship between subtraction and addition.  (Contributed
     by NM, 4-Oct-1999.) $)
  ltsub23 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( ( A - B ) < C <-> ( A - C ) < B ) ) $=
    ( cr wcel w3a cmin co clt wbr caddc ltsubadd wb ltsubadd2 3com23 bitr4d ) A
    DEZBDEZCDEZFABGHCIJACBKHIJZACGHBIJZABCLQSRUATMACBNOP $.

  $( 'Less than' relationship between subtraction and addition.  (Contributed
     by NM, 17-Nov-2004.) $)
  ltsub13 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                   ( A < ( B - C ) <-> C < ( B - A ) ) ) $=
    ( cr wcel cmin co clt wbr wb w3a caddc ltaddsub ltaddsub2 bitr3d 3com23 ) A
    DEZCDEZBDEZABCFGHIZCBAFGHIZJQRSKACLGBHITUAACBMACBNOP $.

  $( Adding both sides of two 'less than or equal to' relations.  (Contributed
     by NM, 17-Apr-2005.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  le2add $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A <_ C /\ B <_ D ) -> ( A + B ) <_ ( C + D ) ) ) $=
    ( cr wcel wa cle wbr caddc co wb simpll simprl simplr leadd1 syl3anc simprr
    leadd2 readdcld anbi12d wi letr sylbid ) AEFZBEFZGZCEFZDEFZGZGZACHIZBDHIZGA
    BJKZCBJKZHIZUOCDJKZHIZGZUNUQHIZUKULUPUMURUKUEUHUFULUPLUEUFUJMZUGUHUINZUEUFU
    JOZACBPQUKUFUIUHUMURLVCUGUHUIRZVBBDCSQUAUKUNEFUOEFUQEFUSUTUBUKABVAVCTUKCBVB
    VCTUKCDVBVDTUNUOUQUCQUD $.

  $( Adding both sides of two orderings.  (Contributed by NM, 23-Dec-2007.) $)
  ltleadd $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A < C /\ B <_ D ) -> ( A + B ) < ( C + D ) ) ) $=
    ( cr wcel wa clt wbr caddc co wb ltadd1 3com23 3expa adantrr leadd2 readdcl
    cle 3expb adantll anbi12d wi adantr ancoms ad2ant2lr adantl ltletr syl3anc
    sylbid ) AEFZBEFZGZCEFZDEFZGZGZACHIZBDSIZGABJKZCBJKZHIZVACDJKZSIZGZUTVCHIZU
    QURVBUSVDUMUNURVBLZUOUKULUNVGUKUNULVGACBMNOPULUPUSVDLZUKULUNUOVHULUOUNVHBDC
    QNTUAUBUQUTEFZVAEFZVCEFZVEVFUCUMVIUPABRUDULUNVJUKUOUNULVJCBRUEUFUPVKUMCDRUG
    UTVAVCUHUIUJ $.

  $( Adding both sides of two orderings.  (Contributed by NM, 15-Aug-2008.) $)
  leltadd $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A <_ C /\ B < D ) -> ( A + B ) < ( C + D ) ) ) $=
    ( cr wcel wa cle wbr caddc co wi ltleadd ancomsd cc wceq recn addcom syl2an
    clt ancom2s ancom1s breqan12d sylibrd ) AEFZBEFZGZCEFZDEFZGZGACHIZBDTIZGZBA
    JKZDCJKZTIZABJKZCDJKZTIUFUEUJUMUPLZUFUEGZUIUHUSUTUIUHGGULUKUPBADCMNUAUBUGUJ
    UQUNURUOTUEAOFBOFUQUNPUFAQBQABRSUHCOFDOFURUOPUICQDQCDRSUCUD $.

  $( Adding both sides of two 'less than' relations.  Theorem I.25 of [Apostol]
     p. 20.  (Contributed by NM, 15-Aug-1999.)  (Proof shortened by Mario
     Carneiro, 27-May-2016.) $)
  lt2add $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A < C /\ B < D ) -> ( A + B ) < ( C + D ) ) ) $=
    ( cr wcel wa clt wbr cle caddc co wi ltle ad2ant2r leltadd syland ) AEFZBEF
    ZGCEFZDEFZGGACHIZACJIZBDHIABKLCDKLHIRTUBUCMSUAACNOABCDPQ $.

  $( The sum of 2 positive numbers is positive.  (Contributed by NM,
     1-Jun-2005.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  addgt0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < A /\ 0 < B ) ) ->
                0 < ( A + B ) ) $=
    ( cr wcel wa cc0 clt wbr caddc co 00id wi 0re lt2add mpanl12 imp syl5eqbrr
    ) ACDBCDEZFAGHFBGHEZEFFFIJZABIJZGKRSTUAGHZFCDZUCRSUBLMMFFABNOPQ $.

  $( The sum of nonnegative and positive numbers is positive.  (Contributed by
     NM, 28-Dec-2005.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  addgegt0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 0 < B ) ) ->
                  0 < ( A + B ) ) $=
    ( cr wcel wa cc0 cle wbr clt caddc co 00id wi 0re leltadd mpanl12 syl5eqbrr
    imp ) ACDBCDEZFAGHFBIHEZEFFFJKZABJKZILSTUAUBIHZFCDZUDSTUCMNNFFABOPRQ $.

  $( The sum of nonnegative and positive numbers is positive.  (Contributed by
     NM, 28-Dec-2005.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  addgtge0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < A /\ 0 <_ B ) ) ->
                  0 < ( A + B ) ) $=
    ( cr wcel wa cc0 clt wbr cle caddc co 00id wi 0re ltleadd mpanl12 syl5eqbrr
    imp ) ACDBCDEZFAGHFBIHEZEFFFJKZABJKZGLSTUAUBGHZFCDZUDSTUCMNNFFABOPRQ $.

  $( The sum of 2 nonnegative numbers is nonnegative.  (Contributed by NM,
     17-Mar-2005.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  addge0 $p |- ( ( ( A e. RR /\ B e. RR ) /\
               ( 0 <_ A /\ 0 <_ B ) ) -> 0 <_ ( A + B ) ) $=
    ( cr wcel wa cc0 cle wbr caddc co 00id wi 0re le2add mpanl12 imp syl5eqbrr
    ) ACDBCDEZFAGHFBGHEZEFFFIJZABIJZGKRSTUAGHZFCDZUCRSUBLMMFFABNOPQ $.

  $( Adding a positive number to another number increases it.  (Contributed by
     NM, 17-Nov-2004.) $)
  ltaddpos $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 < A <-> B < ( B + A ) ) ) $=
    ( cr wcel wa cc0 clt wbr caddc co wb ltadd2 mp3an1 wceq recn addid1d adantl
    0re breq1d bitrd ) ACDZBCDZEZFAGHZBFIJZBAIJZGHZBUFGHFCDUAUBUDUGKRFABLMUCUEB
    UFGUBUEBNUAUBBBOPQST $.

  $( Adding a positive number to another number increases it.  (Contributed by
     NM, 8-Apr-2005.) $)
  ltaddpos2 $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 < A <-> B < ( A + B ) ) ) $=
    ( cr wcel wa cc0 clt wbr caddc co ltaddpos wceq addcom syl2an breq2d bitr4d
    cc recn ) ACDZBCDZEZFAGHBBAIJZGHBABIJZGHABKUAUCUBBGSAQDBQDUCUBLTARBRABMNOP
    $.

  $( Subtracting a positive number from another number decreases it.
     (Contributed by NM, 17-Nov-2004.)  (Proof shortened by Andrew Salmon,
     19-Nov-2011.) $)
  ltsubpos $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 < A <-> ( B - A ) < B ) ) $=
    ( cr wcel wa cc0 clt wbr caddc co cmin ltaddpos wb ltsubadd 3anidm13 ancoms
    bitr4d ) ACDZBCDZEFAGHBBAIJGHZBAKJBGHZABLSRUATMZSRUBBABNOPQ $.

  $( Comparison of two numbers whose difference is positive.  (Contributed by
     NM, 17-Nov-2004.) $)
  posdif $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> 0 < ( B - A ) ) ) $=
    ( cr wcel wa cc0 cmin co clt caddc wb resubcl ancoms simpl ltaddpos syl2anc
    wbr cc wceq recn pncan3 syl2an breq2d bitr2d ) ACDZBCDZEZFBAGHZIQZAAUHJHZIQ
    ZABIQUGUHCDZUEUIUKKUFUEULBALMUEUFNUHAOPUGUJBAIUEARDBRDUJBSUFATBTABUAUBUCUD
    $.

  $( Subtraction from both sides of 'less than or equal to'.  (Contributed by
     NM, 13-May-2004.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  lesub1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( A - C ) <_ ( B - C ) ) ) $=
    ( cr wcel w3a cmin co cle caddc simp1 simp3 simp2 resubcld lesubadd syl3anc
    wbr wb recnd npcand breq2d bitr2d ) ADEZBDEZCDEZFZACGHBCGHZIQZAUGCJHZIQZABI
    QUFUCUEUGDEUHUJRUCUDUEKUCUDUELZUFBCUCUDUEMZUKNACUGOPUFUIBAIUFBCUFBULSUFCUKS
    TUAUB $.

  $( Subtraction of both sides of 'less than or equal to'.  (Contributed by NM,
     29-Sep-2005.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  lesub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A <_ B <-> ( C - B ) <_ ( C - A ) ) ) $=
    ( cr wcel w3a cle wbr cmin co caddc leadd2 wb simp3 simp1 readdcld lesubadd
    simp2 syl3anc recnd addsubd breq1d 3bitr2d resubcld leaddsub bitrd ) ADEZBD
    EZCDEZFZABGHZCBIJZAKJZCGHZULCAIJGHZUJUKCAKJZCBKJGHZUPBIJZCGHZUNABCLUJUPDEUH
    UIUSUQMUJCAUGUHUINZUGUHUIOZPUGUHUIRZUTUPBCQSUJURUMCGUJCABUJCUTTUJAVATUJBVBT
    UAUBUCUJULDEUGUIUNUOMUJCBUTVBUDVAUTULACUESUF $.

  $( Subtraction from both sides of 'less than'.  (Contributed by FL,
     3-Jan-2008.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  ltsub1 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( A - C ) < ( B - C ) ) ) $=
    ( cr wcel w3a cle wbr wn cmin co wb lesub1 3com12 notbid simp1 simp2 ltnled
    clt resubcld simp3 3bitr4d ) ADEZBDEZCDEZFZBAGHZIBCJKZACJKZGHZIABSHUIUHSHUF
    UGUJUDUCUEUGUJLBACMNOUFABUCUDUEPZUCUDUEQZRUFUIUHUFACUKUCUDUEUAZTUFBCULUMTRU
    B $.

  $( Subtraction of both sides of 'less than'.  (Contributed by NM,
     29-Sep-2005.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  ltsub2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( A < B <-> ( C - B ) < ( C - A ) ) ) $=
    ( cr wcel w3a cle wbr wn cmin co wb lesub2 3com12 notbid simp1 simp2 ltnled
    clt resubcld simp3 3bitr4d ) ADEZBDEZCDEZFZBAGHZICAJKZCBJKZGHZIABSHUIUHSHUF
    UGUJUDUCUEUGUJLBACMNOUFABUCUDUEPZUCUDUEQZRUFUIUHUFCBUCUDUEUAZULTUFCAUMUKTRU
    B $.

  $( Subtracting both sides of two 'less than' relations.  (Contributed by
     Mario Carneiro, 14-Apr-2016.) $)
  lt2sub $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A < C /\ D < B ) -> ( A - B ) < ( C - D ) ) ) $=
    ( cr wcel wa clt wbr cmin simpll simprl simplr ltsub1 syl3anc simprr ltsub2
    co wb resubcl anbi12d wi adantr resubcld adantl lttr sylbid ) AEFZBEFZGZCEF
    ZDEFZGZGZACHIZDBHIZGABJRZCBJRZHIZURCDJRZHIZGZUQUTHIZUNUOUSUPVAUNUHUKUIUOUSS
    UHUIUMKUJUKULLZUHUIUMMZACBNOUNULUIUKUPVASUJUKULPVEVDDBCQOUAUNUQEFZUREFUTEFZ
    VBVCUBUJVFUMABTUCUNCBVDVEUDUMVGUJCDTUEUQURUTUFOUG $.

  $( Subtracting both sides of two 'less than or equal to' relations.
     (Contributed by Mario Carneiro, 14-Apr-2016.) $)
  le2sub $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
                ( ( A <_ C /\ D <_ B ) -> ( A - B ) <_ ( C - D ) ) ) $=
    ( cr wcel wa cle wbr cmin simpll simprl simplr lesub1 syl3anc simprr lesub2
    co wb resubcl anbi12d wi adantr resubcld adantl letr sylbid ) AEFZBEFZGZCEF
    ZDEFZGZGZACHIZDBHIZGABJRZCBJRZHIZURCDJRZHIZGZUQUTHIZUNUOUSUPVAUNUHUKUIUOUSS
    UHUIUMKUJUKULLZUHUIUMMZACBNOUNULUIUKUPVASUJUKULPVEVDDBCQOUAUNUQEFZUREFUTEFZ
    VBVCUBUJVFUMABTUCUNCBVDVEUDUMVGUJCDTUEUQURUTUFOUG $.

  $( Negative of both sides of 'less than'.  Theorem I.23 of [Apostol] p. 20.
     (Contributed by NM, 27-Aug-1999.)  (Proof shortened by Mario Carneiro,
     27-May-2016.) $)
  ltneg $p |- ( ( A e. RR /\ B e. RR ) -> ( A < B <-> -u B < -u A ) ) $=
    ( cr wcel wa clt wbr cc0 cmin cneg 0re ltsub2 mp3an3 df-neg breq12i syl6bbr
    co wb ) ACDZBCDZEABFGZHBIQZHAIQZFGZBJZAJZFGSTHCDUAUDRKABHLMUEUBUFUCFBNANOP
    $.

  $( Contraposition of negative in 'less than'.  (Contributed by NM,
     8-Nov-2004.) $)
  ltnegcon1 $p |- ( ( A e. RR /\ B e. RR ) -> ( -u A < B <-> -u B < A ) ) $=
    ( cr wcel wa cneg clt wbr wb renegcl ltneg sylan simpl recnd negnegd breq2d
    bitrd ) ACDZBCDZEZAFZBGHZBFZUAFZGHZUCAGHRUACDSUBUEIAJUABKLTUDAUCGTATARSMNOP
    Q $.

  $( Contraposition of negative in 'less than'.  (Contributed by Mario
     Carneiro, 25-Feb-2015.) $)
  ltnegcon2 $p |- ( ( A e. RR /\ B e. RR ) -> ( A < -u B <-> B < -u A ) ) $=
    ( cr wcel wa cneg clt wbr wb renegcl ltneg sylan2 simpr recnd negnegd bitrd
    breq1d ) ACDZBCDZEZABFZGHZUAFZAFZGHZBUDGHSRUACDUBUEIBJAUAKLTUCBUDGTBTBRSMNO
    QP $.

  $( Negative of both sides of 'less than or equal to'.  (Contributed by NM,
     12-Sep-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  leneg $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ B <-> -u B <_ -u A ) ) $=
    ( cr wcel wa cle wbr cc0 cmin cneg 0re lesub2 mp3an3 df-neg breq12i syl6bbr
    co wb ) ACDZBCDZEABFGZHBIQZHAIQZFGZBJZAJZFGSTHCDUAUDRKABHLMUEUBUFUCFBNANOP
    $.

  $( Contraposition of negative in 'less than or equal to'.  (Contributed by
     NM, 10-May-2004.) $)
  lenegcon1 $p |- ( ( A e. RR /\ B e. RR ) -> ( -u A <_ B <-> -u B <_ A ) ) $=
    ( cr wcel wa cneg cle wbr wb renegcl leneg sylan recn negnegd breq2d adantr
    bitrd ) ACDZBCDZEAFZBGHZBFZTFZGHZUBAGHZRTCDSUAUDIAJTBKLRUDUEISRUCAUBGRAAMNO
    PQ $.

  $( Contraposition of negative in 'less than or equal to'.  (Contributed by
     NM, 8-Oct-2005.) $)
  lenegcon2 $p |- ( ( A e. RR /\ B e. RR ) -> ( A <_ -u B <-> B <_ -u A ) ) $=
    ( cr wcel wa cneg cle wbr wb renegcl sylan2 wceq recn negnegd adantl breq1d
    leneg bitrd ) ACDZBCDZEZABFZGHZUBFZAFZGHZBUEGHTSUBCDUCUFIBJAUBQKUAUDBUEGTUD
    BLSTBBMNOPR $.

  $( Comparison of a number and its negative to zero.  Theorem I.23 of
     [Apostol] p. 20.  (Contributed by NM, 14-May-1999.) $)
  lt0neg1 $p |- ( A e. RR -> ( A < 0 <-> 0 < -u A ) ) $=
    ( cr wcel cc0 clt wbr cneg wb 0re ltneg mpan2 neg0 breq1i syl6bb ) ABCZADEF
    ZDGZAGZEFZDREFODBCPSHIADJKQDRELMN $.

  $( Comparison of a number and its negative to zero.  (Contributed by NM,
     10-May-2004.) $)
  lt0neg2 $p |- ( A e. RR -> ( 0 < A <-> -u A < 0 ) ) $=
    ( cr wcel cc0 clt wbr cneg wb 0re ltneg mpan neg0 breq2i syl6bb ) ABCZDAEFZ
    AGZDGZEFZQDEFDBCOPSHIDAJKRDQELMN $.

  $( Comparison of a number and its negative to zero.  (Contributed by NM,
     10-May-2004.) $)
  le0neg1 $p |- ( A e. RR -> ( A <_ 0 <-> 0 <_ -u A ) ) $=
    ( cr wcel cc0 cle wbr cneg wb 0re leneg mpan2 neg0 breq1i syl6bb ) ABCZADEF
    ZDGZAGZEFZDREFODBCPSHIADJKQDRELMN $.

  $( Comparison of a number and its negative to zero.  (Contributed by NM,
     24-Aug-1999.) $)
  le0neg2 $p |- ( A e. RR -> ( 0 <_ A <-> -u A <_ 0 ) ) $=
    ( cr wcel cc0 cle wbr cneg wb 0re leneg mpan neg0 breq2i syl6bb ) ABCZDAEFZ
    AGZDGZEFZQDEFDBCOPSHIDAJKRDQELMN $.

  $( A number is less than or equal to itself plus a nonnegative number.
     (Contributed by NM, 21-Feb-2005.) $)
  addge01 $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 <_ B <-> A <_ ( A + B ) ) ) $=
    ( cr wcel wa cc0 cle wbr caddc co wb leadd2 mp3an1 ancoms wceq recn addid1d
    0re adantr breq1d bitrd ) ACDZBCDZEZFBGHZAFIJZABIJZGHZAUGGHUCUBUEUHKZFCDUCU
    BUIRFBALMNUDUFAUGGUBUFAOUCUBAAPQSTUA $.

  $( A number is less than or equal to itself plus a nonnegative number.
     (Contributed by NM, 27-Jul-2005.) $)
  addge02 $p |- ( ( A e. RR /\ B e. RR ) -> ( 0 <_ B <-> A <_ ( B + A ) ) ) $=
    ( cr wcel wa cc0 cle wbr caddc co addge01 cc wceq recn addcom syl2an breq2d
    bitrd ) ACDZBCDZEZFBGHAABIJZGHABAIJZGHABKUAUBUCAGSALDBLDUBUCMTANBNABOPQR $.

  $( Two nonnegative numbers are zero iff their sum is zero.  (Contributed by
     Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
     27-May-2016.) $)
  add20 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) )
                        -> ( ( A + B ) = 0 <-> ( A = 0 /\ B = 0 ) ) ) $=
    ( cr wcel cc0 cle wbr wa caddc wceq simpllr simplrl simplll addge02 syl2anc
    co wb mpbid simpr breqtrd simplrr 0re a1i letri3d mpbir2and oveq2d 3eqtr3rd
    recnd addid1d jca ex oveq12 00id syl6eq impbid1 ) ACDZEAFGZHZBCDZEBFGZHZHZA
    BIPZEJZAEJZBEJZHZVBVDVGVBVDHZVEVFVHVCAEIPEAVHBEAIVHVFBEFGUTVHBVCEFVHUQBVCFG
    ZUPUQVAVDKVHUSUPUQVIQURUSUTVDLZUPUQVAVDMZBANORVBVDSZTURUSUTVDUAVHBEVJECDVHU
    BUCUDUEZUFVLVHAVHAVKUHUIUGVMUJUKVGVCEEIPEAEBEIULUMUNUO $.

  $( Nonnegative subtraction.  (Contributed by NM, 14-Mar-2005.)  (Proof
     shortened by Mario Carneiro, 27-May-2016.) $)
  subge0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( 0 <_ ( A - B ) <-> B <_ A ) ) $=
    ( cr wcel wa cc0 caddc co cle wbr cmin 0re a1i simpr simpl leaddsub syl3anc
    wb recnd addid2d breq1d bitr3d ) ACDZBCDZEZFBGHZAIJZFABKHIJZBAIJUEFCDZUDUCU
    GUHRUIUELMUCUDNZUCUDOFBAPQUEUFBAIUEBUEBUJSTUAUB $.

  $( Nonpositive subtraction.  (Contributed by NM, 20-Mar-2008.)  (Proof
     shortened by Mario Carneiro, 27-May-2016.) $)
  suble0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( ( A - B ) <_ 0 <-> A <_ B ) ) $=
    ( cr wcel wa cmin co cc0 cle wbr wb suble mp3an3 simpl recnd subid1d breq1d
    0re bitrd ) ACDZBCDZEZABFGHIJZAHFGZBIJZABIJTUAHCDUCUEKRABHLMUBUDABIUBAUBATU
    ANOPQS $.

  $( Nonnegative subtraction.  (Contributed by NM, 27-Jul-2005.) $)
  subge02 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( 0 <_ B <-> ( A - B ) <_ A ) ) $=
    ( cr wcel wa cc0 cle wbr caddc co cmin addge01 wb lesubadd 3anidm13 bitr4d
    ) ACDZBCDZEFBGHAABIJGHZABKJAGHZABLQRTSMABANOP $.

  $( Lemma to show a nonnegative number is zero.  (Contributed by NM,
     8-Oct-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  lesub0 $p |- ( ( A e. RR /\ B e. RR ) ->
                ( ( 0 <_ A /\ B <_ ( B - A ) ) <-> A = 0 ) ) $=
    ( cr wcel wa cc0 wceq cle wbr co wb 0re a1i letri3 sylan2 ancom simpr simpl
    cmin lesub2 syl3anc recnd subid1d breq1d bitrd ancoms anbi2d syl5bb bitr2d
    ) ACDZBCDZEZAFGZAFHIZFAHIZEZUOBBASJZHIZEZUKUJFCDZUMUPKUTUKLMAFNOUPUOUNEULUS
    UNUOPULUNURUOUKUJUNURKUKUJEZUNBFSJZUQHIZURVAUJUTUKUNVCKUKUJQUTVALMUKUJRZAFB
    TUAVAVBBUQHVABVABVDUBUCUDUEUFUGUHUI $.

  $( The product of two nonnegative numbers is nonnegative.  (Contributed by
     NM, 8-Oct-1999.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  mulge0 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\
                ( B e. RR /\ 0 <_ B ) ) -> 0 <_ ( A x. B ) ) $=
    ( cr wcel cc0 cle wbr cmul co wa clt wceq wo 0re a1i leloed recnd syl5breqr
    an4s breq2d simpl simpr anbi12d simpll simplr remulcld mulgt0 ltled ex leid
    ax-mp mul02d oveq1 syl5ibcom adantrd mul01d oveq2 adantld ccased sylbid imp
    ) ACDZBCDZEAFGZEBFGZEABHIZFGZVBVCJZVDVEJZVGVHVIEAKGZEALZMZEBKGZEBLZMZJVGVHV
    DVLVEVOVHEAECDZVHNOZVBVCUAZPVHEBVQVBVCUBZPUCVHVJVMVKVNVGVHVJVMJZVGVHVTJZEVF
    VPWANOWAABVBVCVTUDVBVCVTUEUFVBVJVCVMEVFKGABUGSUHUIVHVKVGVMVHEEBHIZFGVKVGVHE
    EWBFVPEEFGNEUJUKZVHBVHBVSQULRVKWBVFEFEABHUMTUNUOVHVNVGVJVHEAEHIZFGVNVGVHEEW
    DFWCVHAVHAVRQUPRVNWDVFEFEBAHUQTUNZURVHVNVGVKWEURUSUTVAS $.

  $( The product of two nonnegative numbers is nonnegative.  (Contributed by
     NM, 8-Oct-1999.)  (Revised by Mario Carneiro, 27-May-2016.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  mulge0OLD $p |- ( ( ( A e. RR /\ B e. RR ) /\
                ( 0 <_ A /\ 0 <_ B ) ) -> 0 <_ ( A x. B ) ) $=
    ( cr wcel cc0 cle wbr cmul co mulge0 an4s ) ACDEAFGBCDEBFGEABHIFGABJK $.

  $( The product of two negative numbers is positive.  (Contributed by Jeffrey
     Hankins, 8-Jun-2009.) $)
  mullt0 $p |- ( ( ( A e. RR /\ A < 0 ) /\ ( B e. RR /\ B < 0 ) )
               -> 0 < ( A x. B ) ) $=
    ( cr wcel cc0 clt wbr wa cneg cmul renegcl adantr lt0neg1 biimpa jca mulgt0
    co syl2an cc recn wceq mul2neg ad2ant2r breqtrd ) ACDZAEFGZHZBCDZBEFGZHZHEA
    IZBIZJQZABJQZFUGUKCDZEUKFGZHULCDZEULFGZHEUMFGUJUGUOUPUEUOUFAKLUEUFUPAMNOUJU
    QURUHUQUIBKLUHUIURBMNOUKULPRUEUHUMUNUAZUFUIUEASDBSDUSUHATBTABUBRUCUD $.

  $( A nonzero square is positive.  Theorem I.20 of [Apostol] p. 20.
     (Contributed by NM, 6-May-1999.)  (Proof shortened by Mario Carneiro,
     27-May-2016.) $)
  msqgt0 $p |- ( ( A e. RR /\ A =/= 0 ) -> 0 < ( A x. A ) ) $=
    ( cr wcel cc0 wne clt wbr wo cmul co id 0re lttri2d biimpa wa mullt0 anidms
    a1i mulgt0 jaodan syldan ) ABCZADEZADFGZDAFGZHZDAAIJFGZUBUCUFUBADUBKDBCUBLR
    MNUBUDUGUEUBUDOUGAAPQUBUEOUGAASQTUA $.

  $( A square is nonnegative.  (Contributed by NM, 23-May-2007.)  (Revised by
     Mario Carneiro, 27-May-2016.) $)
  msqge0 $p |- ( A e. RR -> 0 <_ ( A x. A ) ) $=
    ( cr wcel cc0 cmul co cle wbr oveq12 anidms 0cn mul01i syl6eq breq2d wne wa
    wceq 0re a1i simpl remulcld msqgt0 ltled leid mp1i pm2.61ne ) ABCZDAAEFZGHD
    DGHZADADQZUHDDGUJUHDDEFZDUJUHUKQADADEIJDKLMNUGADOZPZDUHDBCZUMRSUMAAUGULTZUO
    UAAUBUCUNUIUGRDUDUEUF $.

  $( 0 is less than 1.  Theorem I.21 of [Apostol] p. 20.  (Contributed by NM,
     17-Jan-1997.) $)
  0lt1 $p |- 0 < 1 $=
    ( cc0 c1 cmul co clt wcel wne wbr 1re ax-1ne0 msqgt0 ax-1cn mulid1i breqtri
    cr mp2an ) ABBCDZBEBOFBAGAQEHIJBKPBLMN $.

  $( 0 is less than or equal to 1.  (Contributed by Mario Carneiro,
     29-Apr-2015.) $)
  0le1 $p |- 0 <_ 1 $=
    ( cc0 c1 0re 1re 0lt1 ltleii ) ABCDEF $.

  ${
    $d x B $.  $d x y C $.  $d x y D $.  $d x y M $.  $d x y N $.  $d x y ph $.
    $d x y S $.
    ltord.1 $e |- ( x = y -> A = B ) $.
    ltord.2 $e |- ( x = C -> A = M ) $.
    ltord.3 $e |- ( x = D -> A = N ) $.
    ltord.4 $e |- S C_ RR $.
    ltord.5 $e |- ( ( ph /\ x e. S ) -> A e. RR ) $.
    ${
      ltord.6 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x < y -> A < B ) ) $.
      $( Lemma for ~ ltord1 .  (Contributed by Mario Carneiro, 14-Jun-2014.) $)
      ltordlem $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) ->
                        ( C < D -> M < N ) ) $=
        ( clt wbr wi wceq cv wral wcel wa ralrimivva breq1 breq1d imbi12d breq2
        eqeq1 eqeq1d chvarv breq2d rspc2v mpan9 ) ABUAZCUAZQRZDEQRZSZCHUBBHUBFH
        UCGHUCUDFGQRZIJQRZSZAUTBCHHPUEUTVCFUQQRZIEQRZSBCFGHHUPFTZURVDUSVEUPFUQQ
        UFVFDIEQLUGUHUQGTZVDVAVEVBUQGFQUIVGEJIQUPGTZDJTZSVGEJTZSBCUPUQTZVHVGVIV
        JUPUQGUJVKDEJKUKUHMULUMUHUNUO $.

      $( Infer an ordering relation from a proof in only one direction.
         (Contributed by Mario Carneiro, 14-Jun-2014.) $)
      ltord1 $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) -> ( C < D <-> M < N ) ) $=
        ( wcel clt wceq cr wa wbr ltordlem wo wn wi eqeq1 eqeq1d imbi12d vtoclg
        cv ad2antrl ancom2s orim12d con3d wb ralrimiva eleq1d rspccva anim12dan
        wral sylan axlttri syl sseli syl2an adantl 3imtr4d impbid ) AFHQZGHQZUA
        ZUAZFGRUBZIJRUBZABCDEFGHIJKLMNOPUCVMIJSZJIRUBZUDZUEZFGSZGFRUBZUDZUEZVOV
        NVMWBVRVMVTVPWAVQVJVTVPUFZAVKBUKZGSZDJSZUFWDBFHWEFSZWFVTWGVPWEFGUGWHDIJ
        LUHUIMUJULAVKVJWAVQUFABCDEGFHJIKMLNOPUCUMUNUOVMITQZJTQZUAVOVSUPAVJWIVKW
        JADTQZBHVAZVJWIAWKBHOUQZWKWIBFHWHDITLURUSVBAWLVKWJWMWKWJBGHWFDJTMURUSVB
        UTIJVCVDVLVNWCUPZAVJFTQGTQWNVKHTFNVEHTGNVEFGVCVFVGVHVI $.

      $( Infer an ordering relation from a proof in only one direction.
         (Contributed by Mario Carneiro, 14-Jun-2014.) $)
      leord1 $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) ->
                     ( C <_ D <-> M <_ N ) ) $=
        ( wcel wa wbr cr clt wn cle wb ltord1 ancom2s notbid sseli lenlt syl2an
        adantl wral ralrimiva wceq eleq1d rspccva sylan adantrr adantrl 3bitr4d
        cv lenltd ) AFHQZGHQZRZRZGFUASZUBZJIUASZUBFGUCSZIJUCSVFVGVIAVDVCVGVIUDA
        BCDEGFHJIKMLNOPUEUFUGVEVJVHUDZAVCFTQGTQVKVDHTFNUHHTGNUHFGUIUJUKVFIJAVCI
        TQZVDADTQZBHULZVCVLAVMBHOUMZVMVLBFHBVAZFUNDITLUOUPUQURAVDJTQZVCAVNVDVQV
        OVMVQBGHVPGUNDJTMUOUPUQUSVBUT $.

      $( Infer an ordering relation from a proof in only one direction.
         (Contributed by Mario Carneiro, 14-Jun-2014.) $)
      eqord1 $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) -> ( C = D <-> M = N ) ) $=
        ( wcel wa cle cr wbr wceq leord1 wb ancom2s anbi12d sseli letri3 syl2an
        adantl wral ralrimiva cv eleq1d rspccva adantrr adantrl letri3d 3bitr4d
        sylan ) AFHQZGHQZRZRZFGSUAZGFSUAZRZIJSUAZJISUAZRFGUBZIJUBVDVEVHVFVIABCD
        EFGHIJKLMNOPUCAVBVAVFVIUDABCDEGFHJIKMLNOPUCUEUFVCVJVGUDZAVAFTQGTQVKVBHT
        FNUGHTGNUGFGUHUIUJVDIJAVAITQZVBADTQZBHUKZVAVLAVMBHOULZVMVLBFHBUMZFUBDIT
        LUNUOUTUPAVBJTQZVAAVNVBVQVOVMVQBGHVPGUBDJTMUNUOUTUQURUS $.
    $}

    ltord2.6 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x < y -> B < A ) ) $.
    $( Infer an ordering relation from a proof in only one direction.
       (Contributed by Mario Carneiro, 14-Jun-2014.) $)
    ltord2 $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) -> ( C < D <-> N < M ) ) $=
      ( wcel clt wbr cr cneg wceq negeqd renegcld wral ralrimiva eleq1d rspccva
      wa cv wb sylan adantrl adantrr ltneg syl2anc sylibd ltord1 bitr4d ) AFHQZ
      GHQZUIUIZFGRSIUAZJUAZRSZJIRSZABCDUAZEUAZFGHVCVDBUJZCUJZUBZDEKUCVIFUBZDILU
      CVIGUBZDJMUCNAVIHQZUIDOUDAVNVJHQZUIUIZVIVJRSEDRSZVGVHRSZPVPETQZDTQZVQVRUK
      AVOVSVNAVTBHUEZVOVSAVTBHOUFZVTVSBVJHVKDETKUGUHULUMAVNVTVOOUNEDUOUPUQURVBJ
      TQZITQZVFVEUKAVAWCUTAWAVAWCWBVTWCBGHVMDJTMUGUHULUMAUTWDVAAWAUTWDWBVTWDBFH
      VLDITLUGUHULUNJIUOUPUS $.

    $( Infer an ordering relation from a proof in only one direction.
       (Contributed by Mario Carneiro, 14-Jun-2014.) $)
    leord2 $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) -> ( C <_ D <-> N <_ M ) ) $=
      ( wcel wa wbr cr cle cneg cv wceq negeqd renegcld clt wb ralrimiva eleq1d
      rspccva sylan adantrl adantrr ltneg syl2anc sylibd leord1 leneg bitr4d
      wral ) AFHQZGHQZRRZFGUASIUBZJUBZUASZJIUASZABCDUBZEUBZFGHVEVFBUCZCUCZUDZDE
      KUEVKFUDZDILUEVKGUDZDJMUENAVKHQZRDOUFAVPVLHQZRRZVKVLUGSEDUGSZVIVJUGSZPVRE
      TQZDTQZVSVTUHAVQWAVPAWBBHVAZVQWAAWBBHOUIZWBWABVLHVMDETKUJUKULUMAVPWBVQOUN
      EDUOUPUQURVDJTQZITQZVHVGUHAVCWEVBAWCVCWEWDWBWEBGHVODJTMUJUKULUMAVBWFVCAWC
      VBWFWDWBWFBFHVNDITLUJUKULUNJIUSUPUT $.

    $( Infer an ordering relation from a proof in only one direction.
       (Contributed by Mario Carneiro, 14-Jun-2014.) $)
    eqord2 $p |- ( ( ph /\ ( C e. S /\ D e. S ) ) -> ( C = D <-> M = N ) ) $=
      ( wcel wa wceq cr cneg cv negeqd renegcld clt wb ralrimiva eleq1d rspccva
      wbr sylan adantrl adantrr ltneg syl2anc sylibd eqord1 recnd neg11ad bitrd
      wral ) AFHQZGHQZRRZFGSIUAZJUAZSIJSABCDUAZEUAZFGHVEVFBUBZCUBZSZDEKUCVIFSZD
      ILUCVIGSZDJMUCNAVIHQZRDOUDAVNVJHQZRRZVIVJUEUJEDUEUJZVGVHUEUJZPVPETQZDTQZV
      QVRUFAVOVSVNAVTBHVAZVOVSAVTBHOUGZVTVSBVJHVKDETKUHUIUKULAVNVTVOOUMEDUNUOUP
      UQVDIJVDIAVBITQZVCAWAVBWCWBVTWCBFHVLDITLUHUIUKUMURVDJAVCJTQZVBAWAVCWDWBVT
      WDBGHVMDJTMUHUIUKULURUSUT $.
  $}

  ${
    $d w x y z ph $.  $d w x y z S $.  $d x y ps $.  $d w z ch $.
    wlogle.1 $e |- ( ( z = x /\ w = y ) -> ( ps <-> ch ) ) $.
    wlogle.2 $e |- ( ( z = y /\ w = x ) -> ( ps <-> th ) ) $.
    wlogle.3 $e |- ( ph -> S C_ RR ) $.
    ${
      wloglei.4 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ x <_ y ) ) -> th ) $.
      wloglei.5 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ x <_ y ) ) -> ch ) $.
      $( Form of ~ wlogle where both sides of the equivalence are proven rather
         than showing that they are equivalent to each other.  (Contributed by
         Mario Carneiro, 9-Mar-2015.) $)
      wloglei $p |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ch ) $=
        ( cv wcel wa cle vex weq cr wss adantr simprr sseldd simprl wi bi2anan9
        wbr eleq1 anbi2d wb breq12 ancoms anbi12d imbi12d syl5bb equcom syl2anb
        ancom bicomd w3a df-3an sylan2br anassrs vtocl2 lecasei ) AEOZIPZFOZIPZ
        QZQZCVJVHVMIUAVJAIUAUBVLLUCZAVIVKUDUEVMIUAVHVNAVIVKUFUEAGOZIPZHOZIPZQZQ
        ZVQVORUIZQZBUGZVMVJVHRUIZQZCUGGHVHVJESFSGETZHFTZQZWBWEBCWHVTVMWAWDWHVSV
        LAWFVPVIWGVRVKVOVHIUJVQVJIUJUHUKWGWFWAWDULVQVJVOVHRUMUNUOJUPVMVHVJRUIZQ
        ZDUGWCFEVOVQGSHSFGTZEHTZQZWJWBDBWMVMVTWIWAWMVLVSAVLVKVIQWMVSVIVKUTWKVKV
        PWLVIVRVJVOIUJVHVQIUJUHUQUKWLWKWIWAULVHVQVJVORUMUNUOWMBDWKGFTHETBDULWLF
        GUREHURKUSVAUPAVLWIDVLWIQZAVIVKWIVBZDVIVKWIVCZMVDVEVFVFAVLWICWNAWOCWPNV
        DVEVG $.
    $}

    wlogle.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( ch <-> th ) ) $.
    wlogle.5 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ x <_ y ) ) -> ch ) $.
    $( If the predicate ` ch ( x , y ) ` is symmetric under interchange of
       ` x , y ` , then "without loss of generality" we can assume that
       ` x <_ y ` .  (Contributed by Mario Carneiro, 18-Aug-2014.)  (Revised by
       Mario Carneiro, 11-Sep-2014.) $)
    wlogle $p |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ch ) $=
      ( cv wcel cle wbr w3a wa wb 3adantr3 mpbid wloglei ) ABCDEFGHIJKLAEOZIPZF
      OZIPZUEUGQRZSTCDNAUFUHCDUAUIMUBUCNUD $.
  $}

  ${
    lt_2.1 $e |- A e. RR $.
    $( 'Less than or equal to' is reflexive.  (Contributed by NM,
       18-Aug-1999.) $)
    leidi $p |- A <_ A $=
      ( cr wcel cle wbr leid ax-mp ) ACDAAEFBAGH $.

    $( Positive means nonzero (useful for ordering theorems involving
       division).  (Contributed by NM, 16-Sep-1999.) $)
    gt0ne0i $p |- ( 0 < A -> A =/= 0 ) $=
      ( cc0 0re ltnei ) CADBE $.

    ${
      gt0ne0i.2 $e |- 0 < A $.
      $( Positive implies nonzero.  (Contributed by NM, 15-May-1999.) $)
      gt0ne0ii $p |- A =/= 0 $=
        ( cc0 clt wbr wne gt0ne0i ax-mp ) DAEFADGCABHI $.
    $}

    $( A nonzero square is positive.  Theorem I.20 of [Apostol] p. 20.
       (Contributed by NM, 17-Jan-1997.)  (Revised by Mario Carneiro,
       27-May-2016.) $)
    msqgt0i $p |- ( A =/= 0 -> 0 < ( A x. A ) ) $=
      ( cr wcel cc0 wne cmul co clt wbr msqgt0 mpan ) ACDAEFEAAGHIJBAKL $.

    $( A square is nonnegative.  (Contributed by NM, 14-May-1999.)  (Proof
       shortened by Andrew Salmon, 19-Nov-2011.) $)
    msqge0i $p |- 0 <_ ( A x. A ) $=
      ( cr wcel cc0 cmul co cle wbr msqge0 ax-mp ) ACDEAAFGHIBAJK $.

    lt_2.2 $e |- B e. RR $.
    $( Addition of 2 positive numbers is positive.  (Contributed by NM,
       16-May-1999.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
    addgt0i $p |- ( ( 0 < A /\ 0 < B ) -> 0 < ( A + B ) ) $=
      ( cr wcel cc0 clt wbr wa caddc co addgt0 mpanl12 ) AEFBEFGAHIGBHIJGABKLHI
      CDABMN $.

    $( Addition of 2 nonnegative numbers is nonnegative.  (Contributed by NM,
       28-May-1999.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
    addge0i $p |- ( ( 0 <_ A /\ 0 <_ B ) -> 0 <_ ( A + B ) ) $=
      ( cr wcel cc0 cle wbr wa caddc co addge0 mpanl12 ) AEFBEFGAHIGBHIJGABKLHI
      CDABMN $.

    $( Addition of nonnegative and positive numbers is positive.  (Contributed
       by NM, 25-Sep-1999.)  (Revised by Mario Carneiro, 27-May-2016.) $)
    addgegt0i $p |- ( ( 0 <_ A /\ 0 < B ) -> 0 < ( A + B ) ) $=
      ( cr wcel cc0 cle wbr clt wa caddc co addgegt0 mpanl12 ) AEFBEFGAHIGBJIKG
      ABLMJICDABNO $.

    ${
      addgt0i.3 $e |- 0 < A $.
      addgt0i.4 $e |- 0 < B $.
      $( Addition of 2 positive numbers is positive.  (Contributed by NM,
         18-May-1999.) $)
      addgt0ii $p |- 0 < ( A + B ) $=
        ( cc0 clt wbr caddc co addgt0i mp2an ) GAHIGBHIGABJKHIEFABCDLM $.
    $}

    $( Two nonnegative numbers are zero iff their sum is zero.  (Contributed by
       NM, 28-Jul-1999.) $)
    add20i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
      ( ( A + B ) = 0 <-> ( A = 0 /\ B = 0 ) ) ) $=
      ( cr wcel cc0 cle wbr wa caddc co wceq wb add20 an4s mpanl12 ) AEFZBEFZGA
      HIZGBHIZJABKLGMAGMBGMJNZCDRTSUAUBABOPQ $.

    $( Negative of both sides of 'less than'.  Theorem I.23 of [Apostol]
       p. 20.  (Contributed by NM, 21-Jan-1997.) $)
    ltnegi $p |- ( A < B <-> -u B < -u A ) $=
      ( cr wcel clt wbr cneg wb ltneg mp2an ) AEFBEFABGHBIAIGHJCDABKL $.

    $( Negative of both sides of 'less than or equal to'.  (Contributed by NM,
       1-Aug-1999.) $)
    lenegi $p |- ( A <_ B <-> -u B <_ -u A ) $=
      ( cr wcel cle wbr cneg wb leneg mp2an ) AEFBEFABGHBIAIGHJCDABKL $.

    $( Contraposition of negative in 'less than'.  (Contributed by NM,
       14-May-1999.) $)
    ltnegcon2i $p |- ( A < -u B <-> B < -u A ) $=
      ( cr wcel cneg clt wbr wb ltnegcon2 mp2an ) AEFBEFABGHIBAGHIJCDABKL $.

    $( The product of two nonnegative numbers is nonnegative.  (Contributed by
       NM, 30-Jul-1999.) $)
    mulge0i $p |- ( ( 0 <_ A /\ 0 <_ B ) -> 0 <_ ( A x. B ) ) $=
      ( cr wcel cc0 cle wbr wa cmul co mulge0 an4s mpanl12 ) AEFZBEFZGAHIZGBHIZ
      JGABKLHIZCDPRQSTABMNO $.

    $( Lemma to show a nonnegative number is zero.  (Contributed by NM,
       8-Oct-1999.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
    lesub0i $p |- ( ( 0 <_ A /\ B <_ ( B - A ) ) <-> A = 0 ) $=
      ( cr wcel cc0 cle wbr cmin co wa wceq wb lesub0 mp2an ) AEFBEFGAHIBBAJKHI
      LAGMNCDABOP $.

    $( Adding a positive number to another number increases it.  (Contributed
       by NM, 25-Aug-1999.) $)
    ltaddposi $p |- ( 0 < A <-> B < ( B + A ) ) $=
      ( cr wcel cc0 clt wbr caddc co wb ltaddpos mp2an ) AEFBEFGAHIBBAJKHILCDAB
      MN $.

    $( Comparison of two numbers whose difference is positive.  (Contributed by
       NM, 19-Aug-2001.) $)
    posdifi $p |- ( A < B <-> 0 < ( B - A ) ) $=
      ( cr wcel clt wbr cc0 cmin co wb posdif mp2an ) AEFBEFABGHIBAJKGHLCDABMN
      $.

    $( Contraposition of negative in 'less than'.  (Contributed by NM,
       14-May-1999.) $)
    ltnegcon1i $p |- ( -u A < B <-> -u B < A ) $=
      ( cr wcel cneg clt wbr wb ltnegcon1 mp2an ) AEFBEFAGBHIBGAHIJCDABKL $.

    $( Contraposition of negative in 'less than or equal to'.  (Contributed by
       NM, 6-Apr-2005.) $)
    lenegcon1i $p |- ( -u A <_ B <-> -u B <_ A ) $=
      ( cr wcel cneg cle wbr wb lenegcon1 mp2an ) AEFBEFAGBHIBGAHIJCDABKL $.

    $( Nonnegative subtraction.  (Contributed by NM, 13-Aug-2000.) $)
    subge0i $p |- ( 0 <_ ( A - B ) <-> B <_ A ) $=
      ( cr wcel cc0 cmin co cle wbr wb subge0 mp2an ) AEFBEFGABHIJKBAJKLCDABMN
      $.

    lt_2.3 $e |- C e. RR $.
    $( Addition to both sides of 'less than'.  Theorem I.18 of [Apostol]
       p. 20.  (Contributed by NM, 21-Jan-1997.) $)
    ltadd1i $p |- ( A < B <-> ( A + C ) < ( B + C ) ) $=
      ( cr wcel clt wbr caddc co wb ltadd1 mp3an ) AGHBGHCGHABIJACKLBCKLIJMDEFA
      BCNO $.

    $( Addition to both sides of 'less than or equal to'.  (Contributed by NM,
       11-Aug-1999.) $)
    leadd1i $p |- ( A <_ B <-> ( A + C ) <_ ( B + C ) ) $=
      ( cr wcel cle wbr caddc co wb leadd1 mp3an ) AGHBGHCGHABIJACKLBCKLIJMDEFA
      BCNO $.

    $( Addition to both sides of 'less than or equal to'.  (Contributed by NM,
       11-Aug-1999.) $)
    leadd2i $p |- ( A <_ B <-> ( C + A ) <_ ( C + B ) ) $=
      ( cr wcel cle wbr caddc co wb leadd2 mp3an ) AGHBGHCGHABIJCAKLCBKLIJMDEFA
      BCNO $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by NM, 21-Jan-1997.)  (Proof shortened by Andrew Salmon,
       19-Nov-2011.) $)
    ltsubaddi $p |- ( ( A - B ) < C <-> A < ( C + B ) ) $=
      ( cr wcel cmin co clt wbr caddc wb ltsubadd mp3an ) AGHBGHCGHABIJCKLACBMJ
      KLNDEFABCOP $.

    $( 'Less than or equal to' relationship between subtraction and addition.
       (Contributed by NM, 30-Sep-1999.)  (Proof shortened by Andrew Salmon,
       19-Nov-2011.) $)
    lesubaddi $p |- ( ( A - B ) <_ C <-> A <_ ( C + B ) ) $=
      ( cr wcel cmin co cle wbr caddc wb lesubadd mp3an ) AGHBGHCGHABIJCKLACBMJ
      KLNDEFABCOP $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by NM, 21-Jan-1997.) $)
    ltsubadd2i $p |- ( ( A - B ) < C <-> A < ( B + C ) ) $=
      ( cr wcel cmin co clt wbr caddc wb ltsubadd2 mp3an ) AGHBGHCGHABIJCKLABCM
      JKLNDEFABCOP $.

    $( 'Less than or equal to' relationship between subtraction and addition.
       (Contributed by NM, 3-Aug-1999.) $)
    lesubadd2i $p |- ( ( A - B ) <_ C <-> A <_ ( B + C ) ) $=
      ( cr wcel cmin co cle wbr caddc wb lesubadd2 mp3an ) AGHBGHCGHABIJCKLABCM
      JKLNDEFABCOP $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by NM, 14-May-1999.) $)
    ltaddsubi $p |- ( ( A + B ) < C <-> A < ( C - B ) ) $=
      ( cr wcel caddc co clt wbr cmin wb ltaddsub mp3an ) AGHBGHCGHABIJCKLACBMJ
      KLNDEFABCOP $.

    lt.4 $e |- D e. RR $.
    $( Adding both side of two inequalities.  Theorem I.25 of [Apostol] p. 20.
       (Contributed by NM, 14-May-1999.) $)
    lt2addi $p |- ( ( A < C /\ B < D ) -> ( A + B ) < ( C + D ) ) $=
      ( cr wcel clt wbr wa caddc co wi lt2add mp4an ) AIJBIJCIJDIJACKLBDKLMABNO
      CDNOKLPEFGHABCDQR $.

    $( Adding both side of two inequalities.  (Contributed by NM,
       16-Sep-1999.) $)
    le2addi $p |- ( ( A <_ C /\ B <_ D ) -> ( A + B ) <_ ( C + D ) ) $=
      ( cr wcel cle wbr wa caddc co wi le2add mp4an ) AIJBIJCIJDIJACKLBDKLMABNO
      CDNOKLPEFGHABCDQR $.
  $}

  ${
    gt0ne0d.1 $e |- ( ph -> 0 < A ) $.
    $( Positive implies nonzero.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    gt0ne0d $p |- ( ph -> A =/= 0 ) $=
      ( cc0 cr wcel clt wbr wne 0re ltne sylancr ) ADEFDBGHBDIJCDBKL $.
  $}

  ${
    lt0ne0d.1 $e |- ( ph -> A < 0 ) $.
    $( Something less than zero is not zero.  Deduction form.  (Contributed by
       David Moews, 28-Feb-2017.) $)
    lt0ne0d $p |- ( ph -> A =/= 0 ) $=
      ( cc0 clt wbr wne wceq 0re ltnri breq1 mtbiri necon2ai syl ) ABDEFZBDGCOB
      DBDHODDEFDIJBDDEKLMN $.
  $}

  ${
    leidd.1 $e |- ( ph -> A e. RR ) $.
    $( 'Less than or equal to' is reflexive.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    leidd $p |- ( ph -> A <_ A ) $=
      ( cr wcel cle wbr leid syl ) ABDEBBFGCBHI $.

    ${
      msqgt0d.2 $e |- ( ph -> A =/= 0 ) $.
      $( A nonzero square is positive.  Theorem I.20 of [Apostol] p. 20.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      msqgt0d $p |- ( ph -> 0 < ( A x. A ) ) $=
        ( cr wcel cc0 wne cmul co clt wbr msqgt0 syl2anc ) ABEFBGHGBBIJKLCDBMN
        $.
    $}

    $( A square is nonnegative.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    msqge0d $p |- ( ph -> 0 <_ ( A x. A ) ) $=
      ( cr wcel cc0 cmul co cle wbr msqge0 syl ) ABDEFBBGHIJCBKL $.

    $( Comparison of a number and its negative to zero.  Theorem I.23 of
       [Apostol] p. 20.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    lt0neg1d $p |- ( ph -> ( A < 0 <-> 0 < -u A ) ) $=
      ( cr wcel cc0 clt wbr cneg wb lt0neg1 syl ) ABDEBFGHFBIGHJCBKL $.

    $( Comparison of a number and its negative to zero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    lt0neg2d $p |- ( ph -> ( 0 < A <-> -u A < 0 ) ) $=
      ( cr wcel cc0 clt wbr cneg wb lt0neg2 syl ) ABDEFBGHBIFGHJCBKL $.

    $( Comparison of a number and its negative to zero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    le0neg1d $p |- ( ph -> ( A <_ 0 <-> 0 <_ -u A ) ) $=
      ( cr wcel cc0 cle wbr cneg wb le0neg1 syl ) ABDEBFGHFBIGHJCBKL $.

    $( Comparison of a number and its negative to zero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    le0neg2d $p |- ( ph -> ( 0 <_ A <-> -u A <_ 0 ) ) $=
      ( cr wcel cc0 cle wbr cneg wb le0neg2 syl ) ABDEFBGHBIFGHJCBKL $.

    ltnegd.2 $e |- ( ph -> B e. RR ) $.
    ${
      addgegt0d.3 $e |- ( ph -> 0 <_ A ) $.
      addgegt0d.4 $e |- ( ph -> 0 < B ) $.
      $( Addition of nonnegative and positive numbers is positive.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      addgegt0d $p |- ( ph -> 0 < ( A + B ) ) $=
        ( cr wcel cc0 cle wbr clt caddc co addgegt0 syl22anc ) ABHICHIJBKLJCMLJ
        BCNOMLDEFGBCPQ $.
    $}

    ${
      addgt0d.3 $e |- ( ph -> 0 < A ) $.
      addgt0d.4 $e |- ( ph -> 0 < B ) $.
      $( Addition of 2 positive numbers is positive.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      addgt0d $p |- ( ph -> 0 < ( A + B ) ) $=
        ( cc0 cr wcel 0re a1i ltled addgegt0d ) ABCDEAHBHIJAKLDFMGN $.
    $}

    ${
      addge0d.3 $e |- ( ph -> 0 <_ A ) $.
      addge0d.4 $e |- ( ph -> 0 <_ B ) $.
      $( Addition of 2 nonnegative numbers is nonnegative.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      addge0d $p |- ( ph -> 0 <_ ( A + B ) ) $=
        ( cr wcel cc0 cle wbr caddc co addge0 syl22anc ) ABHICHIJBKLJCKLJBCMNKL
        DEFGBCOP $.

      $( The product of two nonnegative numbers is nonnegative.  (Contributed
         by Mario Carneiro, 27-May-2016.) $)
      mulge0d $p |- ( ph -> 0 <_ ( A x. B ) ) $=
        ( cr wcel cc0 cle wbr cmul co mulge0 syl22anc ) ABHIJBKLCHIJCKLJBCMNKLD
        FEGBCOP $.
    $}

    $( Negative of both sides of 'less than'.  Theorem I.23 of [Apostol]
       p. 20.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    ltnegd $p |- ( ph -> ( A < B <-> -u B < -u A ) ) $=
      ( cr wcel clt wbr cneg wb ltneg syl2anc ) ABFGCFGBCHICJBJHIKDEBCLM $.

    $( Negative of both sides of 'less than or equal to'.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    lenegd $p |- ( ph -> ( A <_ B <-> -u B <_ -u A ) ) $=
      ( cr wcel cle wbr cneg wb leneg syl2anc ) ABFGCFGBCHICJBJHIKDEBCLM $.

    ${
      ltnegcon1d.3 $e |- ( ph -> -u A < B ) $.
      $( Contraposition of negative in 'less than'.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      ltnegcon1d $p |- ( ph -> -u B < A ) $=
        ( cneg clt wbr cr wcel wb ltnegcon1 syl2anc mpbid ) ABGCHIZCGBHIZFABJKC
        JKPQLDEBCMNO $.
    $}

    ${
      ltnegcon2d.3 $e |- ( ph -> A < -u B ) $.
      $( Contraposition of negative in 'less than'.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      ltnegcon2d $p |- ( ph -> B < -u A ) $=
        ( cneg clt wbr cr wcel wb ltnegcon2 syl2anc mpbid ) ABCGHIZCBGHIZFABJKC
        JKPQLDEBCMNO $.

    $}

    ${
      lenegcon1d.3 $e |- ( ph -> -u A <_ B ) $.
      $( Contraposition of negative in 'less than or equal to'.  (Contributed
         by Mario Carneiro, 27-May-2016.) $)
      lenegcon1d $p |- ( ph -> -u B <_ A ) $=
        ( cneg cle wbr cr wcel wb lenegcon1 syl2anc mpbid ) ABGCHIZCGBHIZFABJKC
        JKPQLDEBCMNO $.

    $}

    ${
      lenegcon2d.3 $e |- ( ph -> A <_ -u B ) $.
      $( Contraposition of negative in 'less than or equal to'.  (Contributed
         by Mario Carneiro, 27-May-2016.) $)
      lenegcon2d $p |- ( ph -> B <_ -u A ) $=
        ( cneg cle wbr cr wcel wb lenegcon2 syl2anc mpbid ) ABCGHIZCBGHIZFABJKC
        JKPQLDEBCMNO $.
    $}

    $( Adding a positive number to another number increases it.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    ltaddposd $p |- ( ph -> ( 0 < A <-> B < ( B + A ) ) ) $=
      ( cr wcel cc0 clt wbr caddc co wb ltaddpos syl2anc ) ABFGCFGHBIJCCBKLIJMD
      EBCNO $.

    $( Adding a positive number to another number increases it.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    ltaddpos2d $p |- ( ph -> ( 0 < A <-> B < ( A + B ) ) ) $=
      ( cr wcel cc0 clt wbr caddc co wb ltaddpos2 syl2anc ) ABFGCFGHBIJCBCKLIJM
      DEBCNO $.

    $( Subtracting a positive number from another number decreases it.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    ltsubposd $p |- ( ph -> ( 0 < A <-> ( B - A ) < B ) ) $=
      ( cr wcel cc0 clt wbr cmin co wb ltsubpos syl2anc ) ABFGCFGHBIJCBKLCIJMDE
      BCNO $.

    $( Comparison of two numbers whose difference is positive.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    posdifd $p |- ( ph -> ( A < B <-> 0 < ( B - A ) ) ) $=
      ( cr wcel clt wbr cc0 cmin co wb posdif syl2anc ) ABFGCFGBCHIJCBKLHIMDEBC
      NO $.

    $( A number is less than or equal to itself plus a nonnegative number.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    addge01d $p |- ( ph -> ( 0 <_ B <-> A <_ ( A + B ) ) ) $=
      ( cr wcel cc0 cle wbr caddc co wb addge01 syl2anc ) ABFGCFGHCIJBBCKLIJMDE
      BCNO $.

    $( A number is less than or equal to itself plus a nonnegative number.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    addge02d $p |- ( ph -> ( 0 <_ B <-> A <_ ( B + A ) ) ) $=
      ( cr wcel cc0 cle wbr caddc co wb addge02 syl2anc ) ABFGCFGHCIJBCBKLIJMDE
      BCNO $.

    $( Nonnegative subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subge0d $p |- ( ph -> ( 0 <_ ( A - B ) <-> B <_ A ) ) $=
      ( cr wcel cc0 cmin co cle wbr wb subge0 syl2anc ) ABFGCFGHBCIJKLCBKLMDEBC
      NO $.

    $( Nonpositive subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    suble0d $p |- ( ph -> ( ( A - B ) <_ 0 <-> A <_ B ) ) $=
      ( cr wcel cmin co cc0 cle wbr wb suble0 syl2anc ) ABFGCFGBCHIJKLBCKLMDEBC
      NO $.

    $( Nonnegative subtraction.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    subge02d $p |- ( ph -> ( 0 <_ B <-> ( A - B ) <_ A ) ) $=
      ( cr wcel cc0 cle wbr cmin co wb subge02 syl2anc ) ABFGCFGHCIJBCKLBIJMDEB
      CNO $.

    ltadd1d.3 $e |- ( ph -> C e. RR ) $.
    $( Addition to both sides of 'less than'.  Theorem I.18 of [Apostol]
       p. 20.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    ltadd1d $p |- ( ph -> ( A < B <-> ( A + C ) < ( B + C ) ) ) $=
      ( cr wcel clt wbr caddc co wb ltadd1 syl3anc ) ABHICHIDHIBCJKBDLMCDLMJKNE
      FGBCDOP $.

    $( Addition to both sides of 'less than or equal to'.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    leadd1d $p |- ( ph -> ( A <_ B <-> ( A + C ) <_ ( B + C ) ) ) $=
      ( cr wcel cle wbr caddc co wb leadd1 syl3anc ) ABHICHIDHIBCJKBDLMCDLMJKNE
      FGBCDOP $.

    $( Addition to both sides of 'less than or equal to'.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    leadd2d $p |- ( ph -> ( A <_ B <-> ( C + A ) <_ ( C + B ) ) ) $=
      ( cr wcel cle wbr caddc co wb leadd2 syl3anc ) ABHICHIDHIBCJKDBLMDCLMJKNE
      FGBCDOP $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    ltsubaddd $p |- ( ph -> ( ( A - B ) < C <-> A < ( C + B ) ) ) $=
      ( cr wcel cmin co clt wbr caddc wb ltsubadd syl3anc ) ABHICHIDHIBCJKDLMBD
      CNKLMOEFGBCDPQ $.

    $( 'Less than or equal to' relationship between subtraction and addition.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    lesubaddd $p |- ( ph -> ( ( A - B ) <_ C <-> A <_ ( C + B ) ) ) $=
      ( cr wcel cmin co cle wbr caddc wb lesubadd syl3anc ) ABHICHIDHIBCJKDLMBD
      CNKLMOEFGBCDPQ $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    ltsubadd2d $p |- ( ph -> ( ( A - B ) < C <-> A < ( B + C ) ) ) $=
      ( cr wcel cmin co clt wbr caddc wb ltsubadd2 syl3anc ) ABHICHIDHIBCJKDLMB
      CDNKLMOEFGBCDPQ $.

    $( 'Less than or equal to' relationship between subtraction and addition.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    lesubadd2d $p |- ( ph -> ( ( A - B ) <_ C <-> A <_ ( B + C ) ) ) $=
      ( cr wcel cmin co cle wbr caddc wb lesubadd2 syl3anc ) ABHICHIDHIBCJKDLMB
      CDNKLMOEFGBCDPQ $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    ltaddsubd $p |- ( ph -> ( ( A + B ) < C <-> A < ( C - B ) ) ) $=
      ( cr wcel caddc co clt wbr cmin wb ltaddsub syl3anc ) ABHICHIDHIBCJKDLMBD
      CNKLMOEFGBCDPQ $.

    $( 'Less than' relationship between subtraction and addition.  (Contributed
       by Mario Carneiro, 29-Dec-2016.) $)
    ltaddsub2d $p |- ( ph -> ( ( A + B ) < C <-> B < ( C - A ) ) ) $=
      ( cr wcel caddc co clt wbr cmin wb ltaddsub2 syl3anc ) ABHICHIDHIBCJKDLMC
      DBNKLMOEFGBCDPQ $.

    $( 'Less than or equal to' relationship between and addition and
       subtraction.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    leaddsub2d $p |- ( ph -> ( ( A + B ) <_ C <-> B <_ ( C - A ) ) ) $=
      ( cr wcel caddc co cle wbr cmin wb leaddsub2 syl3anc ) ABHICHIDHIBCJKDLMC
      DBNKLMOEFGBCDPQ $.

    ${
      subled.4 $e |- ( ph -> ( A - B ) <_ C ) $.
      $( Swap subtrahends in an inequality.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      subled $p |- ( ph -> ( A - C ) <_ B ) $=
        ( cmin co cle wbr cr wcel wb suble syl3anc mpbid ) ABCIJDKLZBDIJCKLZHAB
        MNCMNDMNSTOEFGBCDPQR $.
    $}

    ${
      lesubd.4 $e |- ( ph -> A <_ ( B - C ) ) $.
      $( Swap subtrahends in an inequality.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      lesubd $p |- ( ph -> C <_ ( B - A ) ) $=
        ( cmin co cle wbr cr wcel wb lesub syl3anc mpbid ) ABCDIJKLZDCBIJKLZHAB
        MNCMNDMNSTOEFGBCDPQR $.
    $}

    ${
      ltsub23d.4 $e |- ( ph -> ( A - B ) < C ) $.
      $( 'Less than' relationship between subtraction and addition.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      ltsub23d $p |- ( ph -> ( A - C ) < B ) $=
        ( cmin co clt wbr cr wcel wb ltsub23 syl3anc mpbid ) ABCIJDKLZBDIJCKLZH
        ABMNCMNDMNSTOEFGBCDPQR $.
    $}

    ${
      ltsub13d.4 $e |- ( ph -> A < ( B - C ) ) $.
      $( 'Less than' relationship between subtraction and addition.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      ltsub13d $p |- ( ph -> C < ( B - A ) ) $=
        ( cmin co clt wbr cr wcel wb ltsub13 syl3anc mpbid ) ABCDIJKLZDCBIJKLZH
        ABMNCMNDMNSTOEFGBCDPQR $.
    $}

    $( Subtraction from both sides of 'less than or equal to'.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    lesub1d $p |- ( ph -> ( A <_ B <-> ( A - C ) <_ ( B - C ) ) ) $=
      ( cr wcel cle wbr cmin co wb lesub1 syl3anc ) ABHICHIDHIBCJKBDLMCDLMJKNEF
      GBCDOP $.

    $( Subtraction of both sides of 'less than or equal to'.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    lesub2d $p |- ( ph -> ( A <_ B <-> ( C - B ) <_ ( C - A ) ) ) $=
      ( cr wcel cle wbr cmin co wb lesub2 syl3anc ) ABHICHIDHIBCJKDCLMDBLMJKNEF
      GBCDOP $.

    $( Subtraction from both sides of 'less than'.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    ltsub1d $p |- ( ph -> ( A < B <-> ( A - C ) < ( B - C ) ) ) $=
      ( cr wcel clt wbr cmin co wb ltsub1 syl3anc ) ABHICHIDHIBCJKBDLMCDLMJKNEF
      GBCDOP $.

    $( Subtraction of both sides of 'less than'.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    ltsub2d $p |- ( ph -> ( A < B <-> ( C - B ) < ( C - A ) ) ) $=
      ( cr wcel clt wbr cmin co wb ltsub2 syl3anc ) ABHICHIDHIBCJKDCLMDBLMJKNEF
      GBCDOP $.

    ${
      ltadd1dd.4 $e |- ( ph -> A < B ) $.
      $( Addition to both sides of 'less than'.  Theorem I.18 of [Apostol]
         p. 20.  (Contributed by Mario Carneiro, 30-May-2016.) $)
      ltadd1dd $p |- ( ph -> ( A + C ) < ( B + C ) ) $=
        ( clt wbr caddc co ltadd1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.

      $( Subtraction from both sides of 'less than'.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      ltsub1dd $p |- ( ph -> ( A - C ) < ( B - C ) ) $=
        ( clt wbr cmin co ltsub1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.

      $( Subtraction of both sides of 'less than'.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      ltsub2dd $p |- ( ph -> ( C - B ) < ( C - A ) ) $=
        ( clt wbr cmin co ltsub2d mpbid ) ABCIJDCKLDBKLIJHABCDEFGMN $.
    $}

    ${
      leadd1dd.4 $e |- ( ph -> A <_ B ) $.
      $( Addition to both sides of 'less than or equal to'.  (Contributed by
         Mario Carneiro, 30-May-2016.) $)
      leadd1dd $p |- ( ph -> ( A + C ) <_ ( B + C ) ) $=
        ( cle wbr caddc co leadd1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.

      $( Addition to both sides of 'less than or equal to'.  (Contributed by
         Mario Carneiro, 30-May-2016.) $)
      leadd2dd $p |- ( ph -> ( C + A ) <_ ( C + B ) ) $=
        ( cle wbr caddc co leadd2d mpbid ) ABCIJDBKLDCKLIJHABCDEFGMN $.

      $( Subtraction from both sides of 'less than or equal to'.  (Contributed
         by Mario Carneiro, 30-May-2016.) $)
      lesub1dd $p |- ( ph -> ( A - C ) <_ ( B - C ) ) $=
        ( cle wbr cmin co lesub1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.

      $( Subtraction of both sides of 'less than or equal to'.  (Contributed by
         Mario Carneiro, 30-May-2016.) $)
      lesub2dd $p |- ( ph -> ( C - B ) <_ ( C - A ) ) $=
        ( cle wbr cmin co lesub2d mpbid ) ABCIJDCKLDBKLIJHABCDEFGMN $.
    $}

    lt2addd.4 $e |- ( ph -> D e. RR ) $.
    ${
      le2addd.5 $e |- ( ph -> A <_ C ) $.
      le2addd.6 $e |- ( ph -> B <_ D ) $.
      $( Adding both side of two inequalities.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      le2addd $p |- ( ph -> ( A + B ) <_ ( C + D ) ) $=
        ( cle wbr caddc co cr wcel wa wi le2add syl22anc mp2and ) ABDLMZCELMZBC
        NODENOLMZJKABPQCPQDPQEPQUCUDRUESFGHIBCDETUAUB $.

      $( Subtracting both sides of two 'less than or equal to' relations.
         (Contributed by Mario Carneiro, 27-May-2016.) $)
      le2subd $p |- ( ph -> ( A - D ) <_ ( C - B ) ) $=
        ( cle wbr cmin co cr wcel wa wi le2sub syl22anc mp2and ) ABDLMZCELMZBEN
        ODCNOLMZJKABPQEPQDPQCPQUCUDRUESFIHGBEDCTUAUB $.
    $}

    ${
      ltleaddd.5 $e |- ( ph -> A < C ) $.
      ltleaddd.6 $e |- ( ph -> B <_ D ) $.
      $( Adding both sides of two orderings.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      ltleaddd $p |- ( ph -> ( A + B ) < ( C + D ) ) $=
        ( clt wbr cle caddc co cr wcel wa wi ltleadd syl22anc mp2and ) ABDLMZCE
        NMZBCOPDEOPLMZJKABQRCQRDQREQRUDUESUFTFGHIBCDEUAUBUC $.
    $}

    ${
      leltaddd.5 $e |- ( ph -> A <_ C ) $.
      leltaddd.6 $e |- ( ph -> B < D ) $.
      $( Adding both sides of two orderings.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      leltaddd $p |- ( ph -> ( A + B ) < ( C + D ) ) $=
        ( cle wbr clt caddc co cr wcel wa wi leltadd syl22anc mp2and ) ABDLMZCE
        NMZBCOPDEOPNMZJKABQRCQRDQREQRUDUESUFTFGHIBCDEUAUBUC $.
    $}

    ${
      lt2addd.5 $e |- ( ph -> A < C ) $.
      lt2addd.6 $e |- ( ph -> B < D ) $.
      $( Adding both side of two inequalities.  Theorem I.25 of [Apostol]
         p. 20.  (Contributed by Mario Carneiro, 27-May-2016.) $)
      lt2addd $p |- ( ph -> ( A + B ) < ( C + D ) ) $=
        ( ltled ltleaddd ) ABCDEFGHIJACEGIKLM $.

      $( Subtracting both sides of two 'less than' relations.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      lt2subd $p |- ( ph -> ( A - D ) < ( C - B ) ) $=
        ( clt wbr cmin co cr wcel wa wi lt2sub syl22anc mp2and ) ABDLMZCELMZBEN
        ODCNOLMZJKABPQEPQDPQCPQUCUDRUESFIHGBEDCTUAUB $.
    $}
  $}

  $( ` 1 <_ 1 ` .  Common special case.  (Contributed by David A. Wheeler,
     16-Jul-2016.) $)
  1le1 $p |- 1 <_ 1 $=
    ( c1 1re leidi ) ABC $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Reciprocals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( ` _i ` times itself is minus 1.  (Contributed by NM, 6-May-1999.)  (Proof
     shortened by Andrew Salmon, 19-Nov-2011.) $)
  ixi $p |- ( _i x. _i ) = -u 1 $=
    ( c1 cneg cc0 cmin co ci cmul df-neg caddc ax-i2m1 0cn ax-1cn ax-icn mulcli
    wceq subadd2i mpbir eqtr2i ) ABCADEZFFGEZAHSTOTAIECOJCATKLFFMMNPQR $.

  $( Lemma for ~ recex .  (Contributed by Eric Schmidt, 23-May-2007.) $)
  recextlem1 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + ( _i x. B ) ) x.
      ( A - ( _i x. B ) ) ) = ( ( A x. A ) + ( B x. B ) ) ) $=
    ( cc wcel wa ci cmul caddc cmin cneg ax-icn mulcl adantl sylan2 subdid wceq
    co eqtrd anidms oveq12d simpl subcl adddird mulcom c1 oveq1i mulm1d syl5req
    mpan ixi mul4 mpanl12 eqtr4d adantr negcld npncand subneg syl2an 3eqtrd ) A
    CDZBCDZEZAFBGQZHQAVCIQZGQAVDGQZVCVDGQZHQAAGQZAVCGQZIQZVHBBGQZJZIQZHQZVGVJHQ
    ZVBAVCVDUTVAUAZVAVCCDZUTFCDZVAVPKFBLUIZMZVAUTVPVDCDVRAVCUBNUCVBVEVIVFVLHVBA
    AVCVOVOVSOVBVFVCAGQZVCVCGQZIQVLVBVCAVCVSVOVSOVBVHVTVKWAIVAUTVPVHVTPVRAVCUDN
    VAVKWAPZUTVAWBVAVAEZVKFFGQZVJGQZWAWCWEUEJZVJGQVKWDWFVJGUJUFWCVJBBLZUGUHVQVQ
    WCWEWAPKKFFBBUKULRSMTUMTVBVMVGVKIQZVNVBVGVHVKUTVGCDZVAUTWIAALSZUNVAUTVPVHCD
    VRAVCLNVAVKCDZUTVAWKWCVJWGUOSMUPUTWIVJCDZWHVNPVAWJVAWLWGSVGVJUQURRUS $.

  $( Lemma for ~ recex .  (Contributed by Eric Schmidt, 23-May-2007.) $)
  recextlem2 $p |- ( ( A e. RR /\ B e. RR /\ ( A + ( _i x. B ) ) =/= 0 ) ->
                        ( ( A x. A ) + ( B x. B ) ) =/= 0 ) $=
    ( cr wcel ci cmul co caddc cc0 wne clt wbr wa wceq syl6eq sylan2 cle anidms
    remulcl anim12i w3a wo wn ax-icn mul01i oveq12 00id necon3ai neorian sylibr
    oveq2 adantr msqgt0 msqge0 addgtge0 syl2anc anassrs addgegt0 jaodan gt0ne0d
    an32s 3impa ) ACDZBCDZAEBFGZHGZIJZUAAAFGZBBFGZHGZVCVDVGIVJKLZVGVCVDMZAIJZBI
    JZUBZVKVGAINZBINZMZUCVOVRVFIVRVFIIHGZIVQVPVEINVFVSNVQVEEIFGIBIEFUKEUDUEOAIV
    EIHUFPUGOUHAIBIUIUJVLVMVKVNVLVMMVHCDZVICDZMZIVHKLZIVIQLZMZVKVLWBVMVCVTVDWAV
    CVTAASRVDWABBSRTZULVCVMVDWEVCVMMWCVDWDAUMBUNTVAVHVIUOUPVLVNMWBIVHQLZIVIKLZM
    ZVKVLWBVNWFULVCVDVNWIVCWGVDVNMWHAUNBUMTUQVHVIURUPUSPVBUT $.

  ${
    $d x y a b A $.
    $( Existence of reciprocal of nonzero complex number.  (Contributed by Eric
       Schmidt, 22-May-2007.) $)
    recex $p |- ( ( A e. CC /\ A =/= 0 ) -> E. x e. CC ( A x. x ) = 1 ) $=
      ( va vb vy cc wcel cc0 wne cv cmul co c1 wceq wrex ci cr wi wa adantr mpd
      caddc cnre recextlem2 3expia remulcl anidms readdcl syl2an ax-rrecex recn
      sylan cmin ax-icn mulcl mpan subcl sylan2 addcl mulassd recextlem1 oveq1d
      simpr eqtr3d id sylan9eq oveq2 eqeq1d syl2anc exp31 syl5 rexlimdv ex syld
      rspcev wb neeq1 adantl oveq1 rexbidv 3imtr4d rexlimivv syl imp ) BFGZBHIZ
      BAJZKLZMNZAFOZWEBCJZPDJZKLZUBLZNZDQOCQOWFWJRZCDBUCWOWPCDQQWKQGZWLQGZSZWOW
      PWSWOSWNHIZWNWGKLZMNZAFOZWFWJWSWTXCRWOWSWTWKWKKLZWLWLKLZUBLZHIZXCWQWRWTXG
      WKWLUDUEWSXGXCWSXGSXFEJZKLZMNZEQOZXCWSXFQGZXGXKWQXDQGZXEQGZXLWRWQXMWKWKUF
      UGWRXNWLWLUFUGXDXEUHUIEXFUJULWSXKXCRZXGWQWKFGZWLFGZXOWRWKUKWLUKXPXQSZXJXC
      EQXHQGXHFGZXRXJXCRXHUKXRXSXJXCXRXSSZXJSWKWMUMLZXHKLZFGZWNYBKLZMNZXCXTYCXJ
      XRYAFGZXSYCXQXPWMFGZYFPFGXQYGUNPWLUOUPZWKWMUQURZYAXHUOULTXTXJYDXIMXTWNYAK
      LZXHKLYDXIXTWNYAXHXRWNFGZXSXQXPYGYKYHWKWMUSURTXRYFXSYITXRXSVCUTXTYJXFXHKX
      RYJXFNXSWKWLVATVBVDXJVEVFXBYEAYBFWGYBNXAYDMWGYBWNKVGVHVOVIVJVKVLUITUAVMVN
      TWOWFWTVPWSBWNHVQVRWOWJXCVPWSWOWIXBAFWOWHXAMBWNWGKVSVHVTVRWAVMWBWCWD $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.
    mulcand.1 $e |- ( ph -> A e. CC ) $.
    mulcand.2 $e |- ( ph -> B e. CC ) $.
    mulcand.3 $e |- ( ph -> C e. CC ) $.
    mulcand.4 $e |- ( ph -> C =/= 0 ) $.
    $( Cancellation law for multiplication.  Theorem I.7 of [Apostol] p. 18.
       (Contributed by NM, 26-Jan-1995.)  (Revised by Mario Carneiro,
       27-May-2016.) $)
    mulcand $p |- ( ph -> ( ( C x. A ) = ( C x. B ) <-> A = B ) ) $=
      ( vx cmul co wceq c1 cc wcel wa oveq2 adantr oveq1d mulassd cv wi cc0 wne
      wrex recex syl2anc simprl mulcomd eqtrd mulid2d 3eqtr3d eqeq12d rexlimddv
      simprr syl5ib impbid1 ) ADBJKZDCJKZLZBCLZADIUAZJKZMLZUTVAUBINADNOZDUCUDVD
      INUEGHIDUFUGUTVBURJKZVBUSJKZLAVBNOZVDPZPZVAURUSVBJQVJVFBVGCVJVBDJKZBJKMBJ
      KVFBVJVKMBJVJVKVCMVJVBDAVHVDUHZAVEVIGRZUIAVHVDUOUJZSVJVBDBVLVMABNOVIERZTV
      JBVOUKULVJVKCJKMCJKVGCVJVKMCJVNSVJVBDCVLVMACNOVIFRZTVJCVPUKULUMUPUNBCDJQU
      Q $.

    $( Cancellation law for multiplication.  Theorem I.7 of [Apostol] p. 18.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    mulcan2d $p |- ( ph -> ( ( A x. C ) = ( B x. C ) <-> A = B ) ) $=
      ( cmul co wceq mulcomd eqeq12d mulcand bitrd ) ABDIJZCDIJZKDBIJZDCIJZKBCK
      APRQSABDEGLACDFGLMABCDEFGHNO $.
  $}

  ${
    mulcanad.1 $e |- ( ph -> A e. CC ) $.
    mulcanad.2 $e |- ( ph -> B e. CC ) $.
    mulcanad.3 $e |- ( ph -> C e. CC ) $.
    mulcanad.4 $e |- ( ph -> C =/= 0 ) $.
    ${
      mulcanad.5 $e |- ( ph -> ( C x. A ) = ( C x. B ) ) $.
      $( Cancellation of a nonzero factor on the left in an equation.  One-way
         deduction form of ~ mulcand .  (Contributed by David Moews,
         28-Feb-2017.) $)
      mulcanad $p |- ( ph -> A = B ) $=
        ( cmul co wceq mulcand mpbid ) ADBJKDCJKLBCLIABCDEFGHMN $.
    $}

    ${
      mulcan2ad.5 $e |- ( ph -> ( A x. C ) = ( B x. C ) ) $.
      $( Cancellation of a nonzero factor on the right in an equation.  One-way
         deduction form of ~ mulcan2d .  (Contributed by David Moews,
         28-Feb-2017.) $)
      mulcan2ad $p |- ( ph -> A = B ) $=
        ( cmul co wceq mulcan2d mpbid ) ABDJKCDJKLBCLIABCDEFGHMN $.
    $}
  $}

  $( Cancellation law for multiplication (full theorem form).  Theorem I.7 of
     [Apostol] p. 18.  (Contributed by NM, 29-Jan-1995.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  mulcan $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
                 ( ( C x. A ) = ( C x. B ) <-> A = B ) ) $=
    ( cc wcel cc0 wne wa w3a simp1 simp2 simp3l simp3r mulcand ) ADEZBDEZCDEZCF
    GZHZIABCOPSJOPSKOPQRLOPQRMN $.

  $( Cancellation law for multiplication.  (Contributed by NM, 21-Jan-2005.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  mulcan2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
                 ( ( A x. C ) = ( B x. C ) <-> A = B ) ) $=
    ( cc wcel cc0 wne wa w3a simp1 simp2 simp3l simp3r mulcan2d ) ADEZBDEZCDEZC
    FGZHZIABCOPSJOPSKOPQRLOPQRMN $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    mulcan.1 $e |- A e. CC $.
    mulcan.2 $e |- B e. CC $.
    mulcan.3 $e |- C e. CC $.
    mulcan.4 $e |- C =/= 0 $.
    $( Cancellation law for multiplication.  Theorem I.7 of [Apostol] p. 18.
       (Contributed by NM, 26-Jan-1995.) $)
    mulcani $p |- ( ( C x. A ) = ( C x. B ) <-> A = B ) $=
      ( cc wcel cc0 wne wa cmul co wceq wb pm3.2i mulcan mp3an ) AHIBHICHIZCJKZ
      LCAMNCBMNOABOPDETUAFGQABCRS $.
  $}

  $( If a product is zero, one of its factors must be zero.  Theorem I.11 of
     [Apostol] p. 18.  (Contributed by NM, 9-Oct-1999.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  mul0or $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( ( A x. B ) = 0 <-> ( A = 0 \/ B = 0 ) ) ) $=
    ( cc wcel wa cmul co cc0 wo wne simpr adantr mul02d eqeq2d simpl 0cn eqeq1d
    wceq a1i syl5ibrcom mulcan2d bitr3d biimpd impancom necon1bd orrd ex mul01d
    oveq1 oveq2 jaod impbid ) ACDZBCDZEZABFGZHRZAHRZBHRZIZUOUQUTUOUQEZURUSVAURB
    HUOBHJZUQURUOVBEZUQURVCUPHBFGZRUQURVCVDHUPVCBUOUNVBUMUNKZLZMNVCAHBUOUMVBUMU
    NOZLHCDVCPSVFUOVBKUAUBUCUDUEUFUGUOURUQUSUOUQURVDHRUOBVEMURUPVDHAHBFUIQTUOUQ
    USAHFGZHRUOAVGUHUSUPVHHBHAFUJQTUKUL $.

  $( The product of two nonzero numbers is nonzero.  (Contributed by NM,
     1-Aug-2004.)  (Proof shortened by Andrew Salmon, 19-Nov-2011.) $)
  mulne0b $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A =/= 0 /\ B =/= 0 ) <->
               ( A x. B ) =/= 0 ) ) $=
    ( cc wcel wa cmul co cc0 wne wceq wo wn mul0or necon3abid neanior syl6rbbr
    ) ACDBCDEZABFGZHIAHJBHJKZLAHIBHIEQSRHABMNAHBHOP $.

  $( The product of two nonzero numbers is nonzero.  (Contributed by NM,
     30-Dec-2007.) $)
  mulne0 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
               ( A x. B ) =/= 0 ) $=
    ( cc wcel cc0 wne cmul co wa mulne0b biimpa an4s ) ACDZBCDZAEFZBEFZABGHEFZM
    NIOPIQABJKL $.

  ${
    muln0.1 $e |- A e. CC $.
    muln0.2 $e |- B e. CC $.
    muln0.3 $e |- A =/= 0 $.
    muln0.4 $e |- B =/= 0 $.
    $( The product of two nonzero numbers is nonzero.  (Contributed by NM,
       15-Feb-1995.) $)
    mulne0i $p |- ( A x. B ) =/= 0 $=
      ( cc wcel cc0 wne cmul co mulne0 mp4an ) AGHAIJBGHBIJABKLIJCEDFABMN $.
  $}

  $( Property of numbers whose product equals their sum.  Equation 5 of
     [Kreyszig] p. 12.  (Contributed by NM, 13-Nov-2006.) $)
  muleqadd $p |- ( ( A e. CC /\ B e. CC ) ->
             ( ( A x. B ) = ( A + B ) <-> ( ( A - 1 ) x. ( B - 1 ) ) = 1 ) ) $=
    ( cc wcel wa c1 cmin co cmul wceq caddc ax-1cn mulsub mpanr2 mpanl2 mulid1i
    cc0 oveq2i a1i mulid1 oveqan12d oveq12d addsub mp3an2 syl2anc 3eqtrd eqeq1d
    mulcl addcl addid2i eqeq2i subcld 0cn addcan2 mp3an23 syl syl5rbbr subeq0ad
    wb 3bitr2rd ) ACDZBCDZEZAFGHBFGHIHZFJABIHZABKHZGHZFKHZFJZVGQJZVEVFJVCVDVHFV
    CVDVEFFIHZKHZAFIHZBFIHZKHZGHZVEFKHZVFGHZVHVAFCDZVBVDVPJZLVAVSEVBVSVTLAFBFMN
    OVCVLVQVOVFGVLVQJVCVKFVEKFLPRSVAVBVMAVNBKATBTUAUBVCVECDZVFCDZVRVHJZABUHZABU
    IZWAVSWBWCLVEFVFUCUDUEUFUGVIVHQFKHZJZVCVJWFFVHFLUJUKVCVGCDZWGVJUSZVCVEVFWDW
    EULWHQCDVSWIUMLVGQFUNUOUPUQVCVEVFWDWEURUT $.

  ${
    $d x y A $.  $d x y B $.
    $( Existential uniqueness of reciprocals.  Theorem I.8 of [Apostol] p. 18.
       (Contributed by NM, 29-Jan-1995.)  (Revised by Mario Carneiro,
       17-Feb-2014.) $)
    receu $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                  E! x e. CC ( B x. x ) = A ) $=
      ( vy cc wcel cc0 w3a cv cmul co wceq wrex wa wi wral 3adant1 oveq2 eqeq1d
      c1 wreu recex simprl simpll mulcld oveq1 ad2antll mulassd mulid2d 3eqtr3d
      simplr rspcev syl2anc rexlimdvaa 3adant3 eqtr3 mulcan syl5ib 3expa expcom
      wne mpd ralrimivv reu4 sylanbrc ) BEFZCEFZCGVAZHZCAIZJKZBLZAEMZVLCDIZJKZB
      LZNZVJVNLZOZDEPAEPVLAEUAVIVOTLZDEMZVMVGVHWAVFDCUBQVFVGWAVMOVHVFVGNZVTVMDE
      WBVNEFZVTNZNZVNBJKZEFCWFJKZBLZVMWEVNBWBWCVTUCZVFVGWDUDZUEWEVOBJKZTBJKZWGB
      VTWKWLLWBWCVOTBJUFUGWECVNBVFVGWDUKWIWJUHWEBWJUIUJVLWHAWFEVJWFLVKWGBVJWFCJ
      RSULUMUNUOVBVIVSADEEVGVHVJEFZWCNZVSOVFWNVGVHNZVSWMWCWOVSVQVKVOLWMWCWOHVRV
      KVOBUPVJVNCUQURUSUTQVCVLVPADEVRVKVOBVJVNCJRSVDVE $.
  $}

  ${
    $d x y $.
    $( Multiplication maps nonzero complex numbers to nonzero complex numbers.
       (Contributed by Steve Rodriguez, 23-Feb-2007.) $)
    mulnzcnopr $p |- ( x. |` ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) ) :
                             ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) -->
                             ( CC \ { 0 } ) $=
      ( vx vy cc cc0 csn cdif cxp cmul wf wfn cv co wcel wss wa ffnov mp2an wne
      wral eldifsn cres ax-mulf mpbi simpli difss xpss12 fnssres ovres ad2ant2r
      mulcl mulne0 jca syl2anb sylibr eqeltrd rgen2a mpbir2an ) CDEZFZUSGZUSHUT
      UAZIVAUTJZAKZBKZVALZUSMZBUSSAUSSHCCGZJZUTVGNZVBVHVCVDHLZCMZBCSACSZVGCHIVH
      VLOUBABCCCHPUCUDUSCNZVMVICURUEZVNUSCUSCUFQVGUTHUGQVFABUSVCUSMZVDUSMZOZVEV
      JUSVCVDUSUSHUHVQVKVJDRZOZVJUSMVOVCCMZVCDRZOZVDCMZVDDRZOZVSVPVCCDTVDCDTWBW
      EOVKVRVTWCVKWAWDVCVDUJUIVCVDUKULUMVJCDTUNUOUPABUSUSUSVAPUQ $.
  $}

  ${
    mul0or.1 $e |- A e. CC $.
    $( A number is zero iff its square is zero (where square is represented
       using multiplication).  (Contributed by NM, 28-Jul-1999.) $)
    msq0i $p |- ( ( A x. A ) = 0 <-> A = 0 ) $=
      ( cmul co cc0 wceq wo cc wcel wb mul0or mp2an oridm bitri ) AACDEFZAEFZPG
      ZPAHIZROQJBBAAKLPMN $.

    mul0or.2 $e |- B e. CC $.
    $( If a product is zero, one of its factors must be zero.  Theorem I.11 of
       [Apostol] p. 18.  (Contributed by NM, 7-Oct-1999.) $)
    mul0ori $p |- ( ( A x. B ) = 0 <-> ( A = 0 \/ B = 0 ) ) $=
      ( cc wcel cmul co cc0 wceq wo wb mul0or mp2an ) AEFBEFABGHIJAIJBIJKLCDABM
      N $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    msq0d.1 $e |- ( ph -> A e. CC ) $.
    $( A number is zero iff its square is zero (where square is represented
       using multiplication).  (Contributed by Mario Carneiro, 27-May-2016.) $)
    msq0d $p |- ( ph -> ( ( A x. A ) = 0 <-> A = 0 ) ) $=
      ( cmul co cc0 wceq wo cc wcel wb mul0or syl2anc oridm syl6bb ) ABBDEFGZBF
      GZQHZQABIJZSPRKCCBBLMQNO $.

    mul0ord.2 $e |- ( ph -> B e. CC ) $.
    $( If a product is zero, one of its factors must be zero.  Theorem I.11 of
       [Apostol] p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    mul0ord $p |- ( ph -> ( ( A x. B ) = 0 <-> ( A = 0 \/ B = 0 ) ) ) $=
      ( cc wcel cmul co cc0 wceq wo wb mul0or syl2anc ) ABFGCFGBCHIJKBJKCJKLMDE
      BCNO $.

    $( The product of two nonzero numbers is nonzero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    mulne0bd $p |- ( ph -> ( ( A =/= 0 /\ B =/= 0 ) <-> ( A x. B ) =/= 0 ) ) $=
      ( cc wcel cc0 wne wa cmul co wb mulne0b syl2anc ) ABFGCFGBHICHIJBCKLHIMDE
      BCNO $.

    mulne0d.3 $e |- ( ph -> A =/= 0 ) $.
    mulne0d.4 $e |- ( ph -> B =/= 0 ) $.
    $( The product of two nonzero numbers is nonzero.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    mulne0d $p |- ( ph -> ( A x. B ) =/= 0 ) $=
      ( cc0 wne cmul co mulne0bd mpbi2and ) ABHICHIBCJKHIFGABCDELM $.
  $}

  ${
    mulne0bad.1 $e |- ( ph -> A e. CC ) $.
    mulne0bad.2 $e |- ( ph -> B e. CC ) $.
    mulne0bad.3 $e |- ( ph -> ( A x. B ) =/= 0 ) $.
    $( A factor of a nonzero complex number is nonzero.  Partial converse of
       ~ mulne0d and consequence of ~ mulne0bd .  (Contributed by David Moews,
       28-Feb-2017.) $)
    mulne0bad $p |- ( ph -> A =/= 0 ) $=
      ( cc0 wne wa cmul co mulne0bd mpbird simpld ) ABGHZCGHZAOPIBCJKGHFABCDELM
      N $.

    $( A factor of a nonzero complex number is nonzero.  Partial converse of
       ~ mulne0d and consequence of ~ mulne0bd .  (Contributed by David Moews,
       28-Feb-2017.) $)
    mulne0bbd $p |- ( ph -> B =/= 0 ) $=
      ( cc0 wne wa cmul co mulne0bd mpbird simprd ) ABGHZCGHZAOPIBCJKGHFABCDELM
      N $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Division
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend class notation to include division. $)
  cdiv $a class / $.

  ${
    $d x y z $.
    $( Define division.  Theorem ~ divmuli relates it to multiplication, and
       ~ divcli and ~ redivcli prove its closure laws.  (Contributed by NM,
       2-Feb-1995.)  (Revised by Mario Carneiro, 1-Apr-2014.)
       (New usage is discouraged.) $)
    df-div $a |- / = ( x e. CC , y e. ( CC \ { 0 } ) |->
                   ( iota_ z e. CC ( y x. z ) = x ) ) $.
  $}

  ${
    $d x y z $.
    $( You can't divide by zero, because division explicitly excludes zero from
       the domain of the function.  Thus, by the definition of function value,
       it evaluates to the empty set.  (This theorem is for information only
       and normally is not referenced by other proofs.  To be meaningful, it
       assumes that ` (/) ` is not a complex number, which depends on the
       particular complex number construction that is used.)  (Contributed by
       Mario Carneiro, 1-Apr-2014.)  (New usage is discouraged.) $)
    1div0 $p |- ( 1 / 0 ) = (/) $=
      ( vx vy vz cdiv cdm cc cc0 csn cdif wceq c1 wcel wa wn co c0 cv cmul crio
      cxp df-div riotaex dmmpt2 wne eldifsni adantl necon2bi ax-mp ndmovg mp2an
      eqid ) DEFFGHIZTJKFLZGULLZMZNZKGDOPJABFULBQCQROAQJZCFSDABCUAUQCFUBUCGGJUP
      GUKUOGGUNGGUDUMGFGUEUFUGUHKGFULDUIUJ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y C $.
    $( Value of division: the (unique) element ` x ` such that
       ` ( B x. x ) = A ` .  This is meaningful only when ` B ` is nonzero.
       (Contributed by NM, 8-May-1999.)  (Revised by Mario Carneiro,
       17-Feb-2014.) $)
    divval $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                   ( A / B ) = ( iota_ x e. CC ( B x. x ) = A ) ) $=
      ( vz vy cc wcel cc0 wne cdiv co cmul wceq crio csn cdif eldifsn riotabidv
      cv wa eqeq2 oveq1 eqeq1d df-div riotaex ovmpt2 sylan2br 3impb ) BFGZCFGZC
      HIZBCJKCASZLKZBMZAFNZMZUJUKTUICFHOPZGUPCFHQDEBCFUQESZULLKZDSZMZAFNUOJUSBM
      ZAFNUTBMVAVBAFUTBUSUARURCMZVBUNAFVCUSUMBURCULLUBUCRDEAUDUNAFUEUFUGUH $.

    $( Relationship between division and multiplication.  (Contributed by NM,
       2-Aug-2004.)  (Revised by Mario Carneiro, 17-Feb-2014.) $)
    divmul $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
                 -> ( ( A / C ) = B <-> ( C x. B ) = A ) ) $=
      ( vx cc wcel cc0 wne wa w3a cdiv co wceq cv cmul crio divval 3expb eqeq1d
      3adant2 wreu wb simp2 receu oveq2 riota2 syl2anc bitr4d ) AEFZBEFZCEFZCGH
      ZIZJZACKLZBMCDNZOLZAMZDEPZBMZCBOLZAMZUNUOUSBUIUMUOUSMZUJUIUKULVCDACQRTSUN
      UJURDEUAZVBUTUBUIUJUMUCUIUMVDUJUIUKULVDDACUDRTURVBDEBUPBMUQVAAUPBCOUESUFU
      GUH $.
  $}

  $( Relationship between division and multiplication.  (Contributed by NM,
     7-Feb-2006.) $)
  divmul2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
              -> ( ( A / C ) = B <-> A = ( C x. B ) ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co wceq cmul divmul eqcom syl6bb ) ADEBDECDEC
    FGHIACJKBLCBMKZALAQLABCNQAOP $.

  $( Relationship between division and multiplication.  (Contributed by NM,
     13-Feb-2006.) $)
  divmul3 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
              -> ( ( A / C ) = B <-> A = ( B x. C ) ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co wceq divmul2 mulcom adantrr 3adant1 eqeq2d
    cmul bitr4d ) ADEZBDEZCDEZCFGZHZIZACJKBLACBRKZLABCRKZLABCMUEUGUFAUAUDUGUFLZ
    TUAUBUHUCBCNOPQS $.

  ${
    $d x A $.  $d x B $.
    $( Closure law for division.  (Contributed by NM, 21-Jul-2001.)  (Proof
       shortened by Mario Carneiro, 17-Feb-2014.) $)
    divcl $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) -> ( A / B ) e. CC ) $=
      ( vx cc wcel cc0 wne w3a cdiv co cmul wceq crio divval wreu receu riotacl
      cv syl eqeltrd ) ADEBDEBFGHZABIJBCRKJALZCDMZDCABNUAUBCDOUCDECABPUBCDQST
      $.
  $}

  $( Closure law for reciprocal.  (Contributed by NM, 30-Apr-2005.) $)
  reccl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 1 / A ) e. CC ) $=
    ( c1 cc wcel cc0 wne cdiv co ax-1cn divcl mp3an1 ) BCDACDAEFBAGHCDIBAJK $.

  $( A cancellation law for division.  (Contributed by NM, 3-Feb-2004.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  divcan2 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                 ( B x. ( A / B ) ) = A ) $=
    ( cc wcel cc0 wne w3a cdiv co wceq cmul eqid wa simp1 3simpc divmul syl3anc
    wb divcl mpbii ) ACDZBCDZBEFZGZABHIZUEJZBUEKIAJZUELUDUAUECDUBUCMUFUGRUAUBUC
    NABSUAUBUCOAUEBPQT $.

  $( A cancellation law for division.  (Contributed by NM, 5-Jun-2004.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  divcan1 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 )
        -> ( ( A / B ) x. B ) = A ) $=
    ( cc wcel cc0 wne w3a cdiv co cmul divcl simp2 mulcomd divcan2 eqtrd ) ACDZ
    BCDZBEFZGZABHIZBJIBTJIASTBABKPQRLMABNO $.

  $( A ratio is zero iff the numerator is zero.  (Contributed by NM,
     20-Apr-2006.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  diveq0 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
               ( ( A / B ) = 0 <-> A = 0 ) ) $=
    ( cc wcel cc0 wne w3a cdiv co wceq cmul wa wb simp1 0cn a1i divmul2 syl3anc
    3simpc simp2 mul01d eqeq2d bitrd ) ACDZBCDZBEFZGZABHIEJZABEKIZJZAEJUGUDECDZ
    UEUFLUHUJMUDUEUFNUKUGOPUDUEUFSAEBQRUGUIEAUGBUDUEUFTUAUBUC $.

  $( The ratio of nonzero numbers is nonzero.  (Contributed by NM,
     2-Aug-2004.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  divne0b $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                  ( A =/= 0 <-> ( A / B ) =/= 0 ) ) $=
    ( cc wcel cc0 wne w3a cdiv co wceq diveq0 bicomd necon3bid ) ACDBCDBEFGZAEA
    BHIZENOEJAEJABKLM $.

  $( The ratio of nonzero numbers is nonzero.  (Contributed by NM,
     28-Dec-2007.) $)
  divne0 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                  ( A / B ) =/= 0 ) $=
    ( cc wcel cc0 wne wa cdiv co wb divne0b 3expb biimpa an32s ) ACDZBCDZBEFZGZ
    AEFZABHIEFZORGSTOPQSTJABKLMN $.

  $( The reciprocal of a nonzero number is nonzero.  (Contributed by NM,
     9-Feb-2006.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  recne0 $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 1 / A ) =/= 0 ) $=
    ( c1 cc wcel cc0 wne wa cdiv co ax-1cn ax-1ne0 divne0 mpanl12 ) BCDBEFACDAE
    FGBAHIEFJKBALM $.

  $( Multiplication of a number and its reciprocal.  (Contributed by NM,
     25-Oct-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  recid $p |- ( ( A e. CC /\ A =/= 0 ) -> ( A x. ( 1 / A ) ) = 1 ) $=
    ( c1 cc wcel cc0 wne cdiv co cmul wceq ax-1cn divcan2 mp3an1 ) BCDACDAEFABA
    GHIHBJKBALM $.

  $( Multiplication of a number and its reciprocal.  (Contributed by NM,
     22-Jun-2006.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  recid2 $p |- ( ( A e. CC /\ A =/= 0 ) -> ( ( 1 / A ) x. A ) = 1 ) $=
    ( c1 cc wcel cc0 wne cdiv co cmul wceq ax-1cn divcan1 mp3an1 ) BCDACDAEFBAG
    HAIHBJKBALM $.

  $( Relationship between division and reciprocal.  Theorem I.9 of [Apostol]
     p. 18.  (Contributed by NM, 2-Aug-2004.)  (Revised by Mario Carneiro,
     27-May-2016.) $)
  divrec $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                ( A / B ) = ( A x. ( 1 / B ) ) ) $=
    ( cc wcel cc0 wne w3a cdiv co c1 cmul wceq simp2 simp1 reccl 3adant1 mul12d
    recid oveq2d mulid1d 3eqtrd wa wb mulcld 3simpc divmul syl3anc mpbird ) ACD
    ZBCDZBEFZGZABHIAJBHIZKIZLZBUNKIZALZULUPABUMKIZKIAJKIAULBAUMUIUJUKMUIUJUKNZU
    JUKUMCDUIBOPZQULURJAKUJUKURJLUIBRPSULAUSTUAULUIUNCDUJUKUBUOUQUCUSULAUMUSUTU
    DUIUJUKUEAUNBUFUGUH $.

  $( Relationship between division and reciprocal.  (Contributed by NM,
     7-Feb-2006.) $)
  divrec2 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                ( A / B ) = ( ( 1 / B ) x. A ) ) $=
    ( cc wcel cc0 wne w3a cdiv co cmul divrec simp1 reccl 3adant1 mulcomd eqtrd
    c1 ) ACDZBCDZBEFZGZABHIAQBHIZJIUBAJIABKUAAUBRSTLSTUBCDRBMNOP $.

  $( An associative law for division.  (Contributed by NM, 2-Aug-2004.) $)
  divass $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
                ( ( A x. B ) / C ) = ( A x. ( B / C ) ) ) $=
    ( cc wcel cc0 wne wa cmul co c1 cdiv wceq reccl mulass syl3an3 mulcl divrec
    w3a syl3anc 3adant3 simp3l simp3r simp2 oveq2d 3eqtr4d ) ADEZBDEZCDEZCFGZHZ
    SZABIJZKCLJZIJZABUNIJZIJZUMCLJZABCLJZIJUKUGUHUNDEUOUQMCNABUNOPULUMDEZUIUJUR
    UOMUGUHUTUKABQUAUGUHUIUJUBZUGUHUIUJUCZUMCRTULUSUPAIULUHUIUJUSUPMUGUHUKUDVAV
    BBCRTUEUF $.

  $( A commutative/associative law for division.  (Contributed by NM,
     2-Aug-2004.) $)
  div23 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
            -> ( ( A x. B ) / C ) = ( ( A / C ) x. B ) ) $=
    ( cc wcel cc0 wne wa w3a cmul cdiv wceq mulcom oveq1d 3adant3 divass 3com12
    co simp2 divcl 3expb 3adant2 mulcomd 3eqtrd ) ADEZBDEZCDEZCFGZHZIZABJRZCKRZ
    BAJRZCKRZBACKRZJRZUOBJRUEUFULUNLUIUEUFHUKUMCKABMNOUFUEUIUNUPLBACPQUJBUOUEUF
    UISUEUIUODEZUFUEUGUHUQACTUAUBUCUD $.

  $( A commutative/associative law for division.  (Contributed by Mario
     Carneiro, 27-May-2016.) $)
  div32 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ C e. CC )
            -> ( ( A / B ) x. C ) = ( A x. ( C / B ) ) ) $=
    ( cc wcel cc0 wne wa cdiv co cmul wceq w3a div23 divass eqtr3d 3com23 ) ADE
    ZCDEZBDEBFGHZABIJCKJZACBIJKJZLRSTMACKJBIJUAUBACBNACBOPQ $.

  $( A commutative/associative law for division.  (Contributed by NM,
     22-Apr-2005.) $)
  div13 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ C e. CC )
            -> ( ( A / B ) x. C ) = ( ( C / B ) x. A ) ) $=
    ( cc wcel cc0 wne wa w3a cmul co cdiv wceq mulcom oveq1d div23 3com23 3coml
    3adant2 3eqtr3d ) ADEZBDEBFGHZCDEZIACJKZBLKZCAJKZBLKZABLKCJKZCBLKAJKZUAUCUE
    UGMUBUAUCHUDUFBLACNOSUAUCUBUEUHMACBPQUCUAUBUGUIMCABPRT $.

  $( A commutative/associative law for division.  (Contributed by NM,
     30-Apr-2005.) $)
  div12 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
            -> ( A x. ( B / C ) ) = ( B x. ( A / C ) ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co cmul divcl 3expb mulcom sylan2 3impb div13
    wceq 3comr sylan 3impa 3com23 3eqtrd ) ADEZBDEZCDEZCFGZHZIABCJKZLKZUJALKZAC
    JKZBLKZBUMLKZUEUFUIUKULSZUFUIHUEUJDEZUPUFUGUHUQBCMNAUJOPQUFUIUEULUNSBCARTUE
    UIUFUNUOSZUEUIUFURUEUIHUMDEZUFURUEUGUHUSACMNUMBOUAUBUCUD $.

  $( Distribution of division over addition.  (Contributed by NM,
     31-Jul-2004.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  divdir $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
               -> ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) ) $=
    ( cc wcel cc0 wne wa caddc co c1 cdiv cmul simp1 simp2 reccl divrec syl3anc
    w3a wceq 3ad2ant3 adddird addcld simp3l simp3r oveq12d 3eqtr4d ) ADEZBDEZCD
    EZCFGZHZSZABIJZKCLJZMJZAUOMJZBUOMJZIJUNCLJZACLJZBCLJZIJUMABUOUHUIULNZUHUIUL
    OZULUHUODEUICPUAUBUMUNDEUJUKUSUPTUMABVBVCUCUHUIUJUKUDZUHUIUJUKUEZUNCQRUMUTU
    QVAURIUMUHUJUKUTUQTVBVDVEACQRUMUIUJUKVAURTVCVDVEBCQRUFUG $.

  $( A cancellation law for division.  (Contributed by NM, 3-Feb-2004.)  (Proof
     shortened by Mario Carneiro, 27-May-2016.) $)
  divcan3 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                 ( ( B x. A ) / B ) = A ) $=
    ( cc wcel cc0 wne w3a cmul co cdiv wceq wa simp2 simp1 mulcld 3simpc divmul
    eqid wb syl3anc mpbiri ) ACDZBCDZBEFZGZBAHIZBJIAKZUFUFKZUFRUEUFCDUBUCUDLUGU
    HSUEBAUBUCUDMUBUCUDNZOUIUBUCUDPUFABQTUA $.

  $( A cancellation law for division.  (Contributed by NM, 8-Feb-2005.) $)
  divcan4 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                 ( ( A x. B ) / B ) = A ) $=
    ( cc wcel cc0 wne w3a cmul co cdiv wceq mulcom 3adant3 oveq1d divcan3 eqtrd
    ) ACDZBCDZBEFZGZABHIZBJIBAHIZBJIATUAUBBJQRUAUBKSABLMNABOP $.

  $( One-to-one relationship for division.  (Contributed by NM, 20-Apr-2006.)
     (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  div11 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
               ( ( A / C ) = ( B / C ) <-> A = B ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co cmul wceq simp1 simp3l divcl syl3anc simp2
    simp3r divcan2 mulcand eqeq12d bitr3d ) ADEZBDEZCDEZCFGZHZIZCACJKZLKZCBCJKZ
    LKZMUJULMABMUIUJULCUIUDUFUGUJDEUDUEUHNZUDUEUFUGOZUDUEUFUGSZACPQUIUEUFUGULDE
    UDUEUHRZUOUPBCPQUOUPUAUIUKAUMBUIUDUFUGUKAMUNUOUPACTQUIUEUFUGUMBMUQUOUPBCTQU
    BUC $.

  $( A number divided by itself is one.  (Contributed by NM, 1-Aug-2004.) $)
  divid $p |- ( ( A e. CC /\ A =/= 0 ) -> ( A / A ) = 1 ) $=
    ( cc wcel cc0 wne wa cdiv co c1 cmul wceq divrec 3anidm12 recid eqtrd ) ABC
    ZADEZFAAGHZAIAGHJHZIPQRSKAALMANO $.

  $( Division into zero is zero.  (Contributed by NM, 14-Mar-2005.) $)
  div0 $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 0 / A ) = 0 ) $=
    ( cc wcel cc0 wne wa cdiv co wceq simpl mul01d wb 0cn divmul mp3an12 mpbird
    cmul ) ABCZADEZFZDAGHDIZADQHDIZTARSJKDBCZUCTUAUBLMMDDANOP $.

  $( A number divided by 1 is itself.  (Contributed by NM, 9-Jan-2002.)  (Proof
     shortened by Mario Carneiro, 27-May-2016.) $)
  div1 $p |- ( A e. CC -> ( A / 1 ) = A ) $=
    ( cc wcel c1 cdiv co wceq mulid2 wb cc0 wne wa ax-1cn ax-1ne0 pm3.2i divmul
    cmul mp3an3 anidms mpbird ) ABCZADEFAGZDAQFAGZAHUAUBUCIZUAUADBCZDJKZLUDUEUF
    MNOAADPRST $.

  $( Equality in terms of unit ratio.  (Contributed by Stefan O'Rear,
     27-Aug-2015.) $)
  diveq1 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
      ( ( A / B ) = 1 <-> A = B ) ) $=
    ( cc wcel cc0 wne w3a cdiv co c1 wceq cmul wb wa ax-1cn divmul2 3impb simp2
    mp3an2 mulid1d eqeq2d bitrd ) ACDZBCDZBEFZGZABHIJKZABJLIZKZABKUCUDUEUGUIMZU
    CJCDUDUENUJOAJBPSQUFUHBAUFBUCUDUERTUAUB $.

  $( Move negative sign inside of a division.  (Contributed by NM,
     17-Sep-2004.) $)
  divneg $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                -u ( A / B ) = ( -u A / B ) ) $=
    ( cc wcel cc0 wne w3a cneg c1 cdiv co cmul wceq wa reccl sylan2 3impb negcl
    mulneg1 divrec syl3an1 negeqd 3eqtr4rd ) ACDZBCDZBEFZGZAHZIBJKZLKZAUILKZHZU
    HBJKZABJKZHUDUEUFUJULMZUEUFNUDUICDUOBOAUISPQUDUHCDUEUFUMUJMARUHBTUAUGUNUKAB
    TUBUC $.

  $( Distribution of division over subtraction.  (Contributed by NM,
     4-Mar-2005.) $)
  divsubdir $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) )
               -> ( ( A - B ) / C ) = ( ( A / C ) - ( B / C ) ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co cneg caddc cmin negcl eqtr3d 3expb 3adant1
    wceq divcl divdir syl3an2 negsub oveq1d 3adant3 divneg 3adant2 negsubd
    oveq2d ) ADEZBDEZCDEZCFGZHZIZACJKZBLZCJKZMKZABNKZCJKZUPBCJKZNKZUOAUQMKZCJKZ
    USVAUKUJUQDEUNVEUSSBOAUQCUAUBUJUKVEVASUNUJUKHVDUTCJABUCUDUEPUOUPVBLZMKUSVCU
    OVFURUPMUKUNVFURSZUJUKULUMVGBCUFQRUIUOUPVBUJUNUPDEZUKUJULUMVHACTQUGUKUNVBDE
    ZUJUKULUMVIBCTQRUHPP $.

  $( A number is equal to the reciprocal of its reciprocal.  Theorem I.10 of
     [Apostol] p. 18.  (Contributed by NM, 26-Sep-1999.)  (Proof shortened by
     Mario Carneiro, 27-May-2016.) $)
  recrec $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 1 / ( 1 / A ) ) = A ) $=
    ( cc wcel cc0 wne wa c1 cdiv co wceq cmul recid2 wb ax-1cn a1i simpl recne0
    reccl divmul syl112anc mpbird ) ABCZADEZFZGGAHIZHIAJZUEAKIGJZALUDGBCZUBUEBC
    UEDEUFUGMUHUDNOUBUCPARAQGAUESTUA $.

  $( Reciprocal is one-to-one.  (Contributed by NM, 16-Sep-1999.)  (Revised by
     Mario Carneiro, 27-May-2016.) $)
  rec11 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) )
                  -> ( ( 1 / A ) = ( 1 / B ) <-> A = B ) ) $=
    ( cc wcel cc0 wne wa c1 cdiv co wceq cmul wb ax-1cn a1i reccl adantl divmul
    simpl syl3anc simpll simprl simprr divrec eqeq1d diveq1 3bitr2d ) ACDZAEFZG
    ZBCDZBEFZGZGZHAIJHBIJZKZAUOLJZHKZABIJZHKZABKZUNHCDZUOCDZUJUPURMVBUNNOUMVCUJ
    BPQUJUMSHUOARTUNUSUQHUNUHUKULUSUQKUHUIUMUAZUJUKULUBZUJUKULUCZABUDTUEUNUHUKU
    LUTVAMVDVEVFABUFTUG $.

  $( Mutual reciprocals.  (Contributed by Paul Chapman, 18-Oct-2007.) $)
  rec11r $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) )
                  -> ( ( 1 / A ) = B <-> ( 1 / B ) = A ) ) $=
    ( cc wcel cc0 wne wa c1 cdiv co wceq wb ax-1cn simprl simpll simplr divmul2
    cmul a1i syl112anc simprr divmul3 bitr4d ) ACDZAEFZGZBCDZBEFZGZGZHAIJBKZHAB
    RJKZHBIJAKZUJHCDZUGUDUEUKULLUNUJMSZUFUGUHNZUDUEUIOZUDUEUIPHBAQTUJUNUDUGUHUM
    ULLUOUQUPUFUGUHUAHABUBTUC $.

  $( Multiplication of two ratios.  Theorem I.14 of [Apostol] p. 18.
     (Contributed by NM, 1-Aug-2004.) $)
  divmuldiv $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) )
               -> ( ( A / C ) x. ( B / D ) ) = ( ( A x. B ) / ( C x. D ) ) ) $=
    ( cc wcel cc0 wne wa cdiv co cmul wceq 3anass divcl mulcl 3adantr1 3adantl1
    w3a syl2an ad2ant2r mulne0 divcan3 syl3anc simp2 jca mul4 divcan2 oveqan12d
    eqtr3d oveq1d syl2anbr an4s ) AEFZCEFZCGHZIZBEFZDEFZDGHZIZACJKZBDJKZLKZABLK
    ZCDLKZJKZMZUNUQIUNUOUPSZURUSUTSZVHURVAIUNUOUPNURUSUTNVIVJIZVFVDLKZVFJKZVDVG
    VKVDEFZVFEFZVFGHZVMVDMVIVBEFZVCEFZVNVJACOZBDOZVBVCPTUOUPVJVOUNUQUSUTVOURUOU
    SVOUPUTCDPUAQRUOUPVJVPUNUQUSUTVPURCDUBQRVDVFUCUDVKVLVEVFJVKCVBLKZDVCLKZLKZV
    LVEVIUOVQIUSVRIWCVLMVJVIUOVQUNUOUPUEVSUFVJUSVRURUSUTUEVTUFCVBDVCUGTVIVJWAAW
    BBLACUHBDUHUIUJUKUJULUM $.

  $( Division of two ratios.  Theorem I.15 of [Apostol] p. 18.  (Contributed by
     NM, 2-Aug-2004.) $)
  divdivdiv $p |- ( ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) ) /\
                  ( ( C e. CC /\ C =/= 0 ) /\ ( D e. CC /\ D =/= 0 ) ) )
                -> ( ( A / B ) / ( C / D ) ) = ( ( A x. D ) / ( B x. C ) ) ) $=
    ( cc wcel cc0 wa cdiv co cmul wceq divcl syl3anc mulcomd divmuldiv eqtrd c1
    wne mulcld simprrl simprll simprlr simplrl simplrr syl22anc simprrr mulne0d
    simpll simplr simprl oveq2d simprr divid syl2anc mulassd mulid2d 3eqtr3d wb
    oveq1d eqtr3d mulne0 ad2ant2lr divne0 adantl divmul syl112anc mpbird ) AEFZ
    BEFZBGSZHZHZCEFZCGSZHZDEFZDGSZHZHZHZABIJZCDIJZIJADKJZBCKJZIJZLZWCWFKJZWBLZW
    AWCDCIJZWBKJZKJZWHWBWAWKWFWCKWAWKWBWJKJZWFWAWJWBWAVQVNVOWJEFVMVPVQVRUAZVMVN
    VOVSUBZVMVNVOVSUCZDCMNZWAVIVJVKWBEFZVIVLVTUIZVIVJVKVTUDZVIVJVKVTUEABMNZOWAV
    IVQVLVPWMWFLWSWNVIVLVTUJVMVPVSUKZADBCPUFQULWAWCWJKJZWBKJRWBKJWLWBWAXCRWBKWA
    XCCDKJZDCKJZIJZRWAVNVQVSVPXCXFLWOWNVMVPVSUMXBCDDCPUFWAXFXEXEIJZRWAXDXEXEIWA
    CDWOWNOUTWAXEEFXEGSXGRLWADCWNWOTWADCWNWOVMVPVQVRUGZWPUHXEUNUOQQUTWAWCWJWBWA
    VNVQVRWCEFZWOWNXHCDMNZWQXAUPWAWBXAUQURVAWAWRWFEFZXIWCGSZWGWIUSXAWAWDEFWEEFW
    EGSZXKWAADWSWNTWABCWTWOTVLVPXMVIVSBCVBVCWDWEMNXJVTXLVMCDVDVEWBWFWCVFVGVH $.

  $( Cancellation of common factor in a ratio.  (Contributed by NM,
     9-Jan-2006.) $)
  divcan5 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\
       ( C e. CC /\ C =/= 0 ) ) -> ( ( C x. A ) / ( C x. B ) ) = ( A / B ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co cmul c1 divid oveq1d 3ad2ant3 simp3l simp1
    wceq simp3 simp2 divmuldiv syl22anc divcl 3expb mulid2d 3adant3 3eqtr3d ) A
    DEZBDEZBFGZHZCDEZCFGZHZIZCCJKZABJKZLKZMURLKZCALKCBLKJKZURUOUIUSUTSULUOUQMUR
    LCNOPUPUMUIUOULUSVASUIULUMUNQUIULUORUIULUOTUIULUOUACACBUBUCUIULUTURSUOUIULH
    URUIUJUKURDEABUDUEUFUGUH $.

  $( Swap the denominators in the product of two ratios.  (Contributed by NM,
     3-May-2005.) $)
  divmul13 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) )
                -> ( ( A / C ) x. ( B / D ) ) = ( ( B / C ) x. ( A / D ) ) ) $=
    ( cc wcel wa cc0 wne cmul co cdiv wceq mulcom adantr oveq1d ancom1s 3eqtr4d
    divmuldiv ) AEFZBEFZGZCEFCHIGDEFDHIGGZGZABJKZCDJKZLKBAJKZUFLKZACLKBDLKJKBCL
    KADLKJKZUDUEUGUFLUBUEUGMUCABNOPABCDSUATUCUIUHMBACDSQR $.

  $( Swap the numerators in the product of two ratios.  (Contributed by NM,
     3-May-2005.) $)
  divmul24 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) )
                -> ( ( A / C ) x. ( B / D ) ) = ( ( A / D ) x. ( B / C ) ) ) $=
    ( cc wcel wa cc0 wne cmul cdiv wceq mulcom ad2ant2r adantl oveq2d divmuldiv
    co ancom2s 3eqtr4d ) AEFBEFGZCEFZCHIZGZDEFZDHIZGZGZGZABJRZCDJRZKRUJDCJRZKRZ
    ACKRBDKRJRADKRBCKRJRZUIUKULUJKUHUKULLZUAUBUEUOUCUFCDMNOPABCDQUAUGUDUNUMLABD
    CQST $.

  $( Cross-multiply in an equality of ratios.  (Contributed by Mario Carneiro,
     23-Feb-2014.) $)
  divmuleq $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 ) /\
                     ( D e. CC /\ D =/= 0 ) ) ) ->
                   ( ( A / C ) = ( B / D ) <-> ( A x. D ) = ( B x. C ) ) ) $=
    ( cc wcel wa cc0 wne cdiv co cmul wceq divcl 3expb ad2ant2r mulassd divcan1
    ad2ant2l oveq1d wb mulne0 jca adantl mulcan2 syl3anc simprll simprrl eqtr3d
    mulcl mulcomd oveq2d 3eqtr2d eqeq12d bitr3d ) AEFZBEFZGZCEFZCHIZGZDEFZDHIZG
    ZGZGZACJKZCDLKZLKZBDJKZVHLKZMZVGVJMZADLKZBCLKZMVFVGEFZVJEFZVHEFZVHHIZGZVLVM
    UAUPVAVPUQVDUPUSUTVPACNOPZUQVDVQUPVAUQVBVCVQBDNOSZVEVTURVEVRVSUSVBVRUTVCCDU
    JPCDUBUCUDVGVJVHUEUFVFVIVNVKVOVFVGCLKZDLKVIVNVFVGCDWAURUSUTVDUGZURVAVBVCUHZ
    QVFWCADLUPVAWCAMZUQVDUPUSUTWFACROPTUIVFVKVJDCLKZLKVJDLKZCLKVOVFVHWGVJLVFCDW
    DWEUKULVFVJDCWBWEWDQVFWHBCLUQVDWHBMZUPVAUQVBVCWIBDROSTUMUNUO $.

  $( The reciprocal of a ratio.  (Contributed by NM, 3-Aug-2004.) $)
  recdiv $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                ( 1 / ( A / B ) ) = ( B / A ) ) $=
    ( cc wcel cc0 wne wa c1 cdiv co cmul wceq ax-1cn div1 oveq1i ax-1ne0 pm3.2i
    ax-mp divdivdiv mulid2 mpanl12 syl5eqr oveqan12rd ad2ant2r eqtrd ) ACDZAEFZ
    GBCDZBEFZGGZHABIJZIJZHBKJZHAKJZIJZBAIJZUJULHHIJZUKIJZUOUQHUKIHCDZUQHLMHNROU
    SUSHEFZGUJURUOLMUSUTMPQHHABSUAUBUFUHUOUPLUGUIUHUFUMBUNAIBTATUCUDUE $.

  $( Cancellation of inverted fractions.  (Contributed by NM, 28-Dec-2007.) $)
  divcan6 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
         ( ( A / B ) x. ( B / A ) ) = 1 ) $=
    ( cc wcel cc0 wne wa cdiv co c1 cmul recdiv oveq2d wceq divcl 3expb adantlr
    divne0 recid syl2anc eqtr3d ) ACDZAEFZGBCDZBEFZGZGZABHIZJUHHIZKIZUHBAHIZKIJ
    UGUIUKUHKABLMUGUHCDZUHEFUJJNUBUFULUCUBUDUEULABOPQABRUHSTUA $.

  $( Swap denominators in a division.  (Contributed by NM, 2-Aug-2004.) $)
  divdiv32 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 )
      /\ ( C e. CC /\ C =/= 0 ) ) -> ( ( A / B ) / C ) = ( ( A / C ) / B ) ) $=
    ( cc wcel cc0 wne wa w3a c1 cdiv cmul wceq reccl div23 syl3an2 divrec 3expb
    co 3adant3 oveq1d divcl syl3an1 3impa 3com23 3eqtr4d ) ADEZBDEZBFGZHZCDEZCF
    GZHZIZAJBKSZLSZCKSZACKSZUOLSZABKSZCKSURBKSZUJUGUODEUMUQUSMBNAUOCOPUNUTUPCKU
    GUJUTUPMZUMUGUHUIVBABQRTUAUGUMUJVAUSMZUGUMUJVCUGUMHZUHUIVCVDURDEZUHUIVCUGUK
    ULVEACUBRURBQUCRUDUEUF $.

  $( Cancel equal divisors in a division.  (Contributed by Jeff Hankins,
     29-Sep-2013.) $)
  divcan7 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\
    ( C e. CC /\ C =/= 0 ) ) -> ( ( A / C ) / ( B / C ) ) = ( A / B ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co cmul wceq divdivdiv 3impdir mulcom adantrr
    3adant2 oveq1d divcan5 3eqtrd ) ADEZBDEBFGHZCDEZCFGZHZIZACJKBCJKJKZACLKZCBL
    KZJKZCALKZUJJKABJKUBUFUCUHUKMACBCNOUGUIULUJJUBUFUIULMZUCUBUDUMUEACPQRSABCTU
    A $.

  $( Cancellation law for division and multiplication.  (Contributed by Scott
     Fenton, 7-Jun-2013.)  (Proof shortened by Fan Zheng, 3-Jul-2016.) $)
  dmdcan $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) /\
         C e. CC ) ->
         ( ( A / B ) x. ( C / A ) ) = ( C / B ) ) $=
    ( cc wcel cc0 wne wa w3a cdiv co cmul wceq simp1l simp3 simp1r divcl simp2l
    syl3anc simp2r div23 syl112anc divcan2 oveq1d eqtr3d ) ADEZAFGZHZBDEZBFGZHZ
    CDEZIZACAJKZLKZBJKZABJKUNLKZCBJKUMUFUNDEZUIUJUPUQMUFUGUKULNZUMULUFUGURUHUKU
    LOZUSUFUGUKULPZCAQSUHUIUJULRUHUIUJULTAUNBUAUBUMUOCBJUMULUFUGUOCMUTUSVACAUCS
    UDUE $.

  $( Division into a fraction.  (Contributed by NM, 31-Dec-2007.) $)
  divdiv1 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\
       ( C e. CC /\ C =/= 0 ) ) -> ( ( A / B ) / C ) = ( A / ( B x. C ) ) ) $=
    ( cc wcel cc0 wne wa cdiv co c1 cmul ax-1cn ax-1ne0 pm3.2i divdivdiv mpanr2
    w3a wceq 3impa div1 oveq2d ad2antrl 3adant1 mulid1 oveq1d 3ad2ant1 3eqtr3d
    ) ADEZBDEBFGHZCDEZCFGZHZRABIJZCKIJZIJZAKLJZBCLJZIJZUNCIJZAURIJZUIUJUMUPUSSZ
    UIUJHUMKDEZKFGZHVBVCVDMNOABCKPQTUJUMUPUTSZUIUKVEUJULUKUOCUNICUAUBUCUDUIUJUS
    VASUMUIUQAURIAUEUFUGUH $.

  $( Division by a fraction.  (Contributed by NM, 27-Dec-2008.) $)
  divdiv2 $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ ( C e. CC /\ C =/= 0 )
              ) -> ( A / ( B / C ) ) = ( ( A x. C ) / B ) ) $=
    ( cc wcel cc0 wne wa c1 cdiv co cmul ax-1cn ax-1ne0 pm3.2i divdivdiv mpanl2
    w3a wceq 3impb div1 3ad2ant1 oveq1d mulid2 ad2antrl 3adant3 oveq2d 3eqtr3d
    ) ADEZBDEZBFGZHZCDECFGHZRZAIJKZBCJKZJKZACLKZIBLKZJKZAUPJKURBJKUIULUMUQUTSZU
    IIDEZIFGZHULUMHVAVBVCMNOAIBCPQTUNUOAUPJUIULUOASUMAUAUBUCUNUSBURJUIULUSBSZUM
    UJVDUIUKBUDUEUFUGUH $.

  $( Division into a reciprocal.  (Contributed by NM, 19-Oct-2007.) $)
  recdiv2 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                ( ( 1 / A ) / B ) = ( 1 / ( A x. B ) ) ) $=
    ( c1 cc wcel cc0 wne wa cdiv co cmul wceq ax-1cn divdiv1 mp3an1 ) CDEADEAFG
    HBDEBFGHCAIJBIJCABKJIJLMCABNO $.

  $( Cancellation in a double division.  (Contributed by Mario Carneiro,
     26-Apr-2015.) $)
  ddcan $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
                ( A / ( A / B ) ) = B ) $=
    ( cc wcel cc0 wne wa cdiv co wceq cmul simpll simprl simprr divcan1 syl3anc
    wb divcl divne0 divmul syl112anc mpbird ) ACDZAEFZGZBCDZBEFZGZGZAABHIZHIBJZ
    UJBKIAJZUIUCUFUGULUCUDUHLZUEUFUGMZUEUFUGNZABOPUIUCUFUJCDZUJEFUKULQUMUNUIUCU
    FUGUPUMUNUOABRPABSABUJTUAUB $.

  $( Addition of two ratios.  Theorem I.13 of [Apostol] p. 18.  (Contributed by
     NM, 1-Aug-2004.)  (Revised by Mario Carneiro, 2-May-2016.) $)
  divadddiv $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) ) ->
  ( ( A / C ) + ( B / D ) ) = ( ( ( A x. D ) + ( B x. C ) ) / ( C x. D ) ) ) $=
    ( cc wcel wa cc0 wne cmul co caddc cdiv wceq mulcl ad2ant2r syl3anc mulcomd
    oveq12d divcan5 adantrl ad2ant2lr mulne0 adantl divdir simpll simprr simpld
    adantrr jca simprll simprl eqtrd simplr oveq1d eqtr2d ) AEFZBEFZGZCEFZCHIZG
    ZDEFZDHIZGZGZGZADJKZBCJKZLKCDJKZMKZVHVJMKZVIVJMKZLKZACMKZBDMKZLKVGVHEFZVIEF
    ZVJEFZVJHIZGZVKVNNUSVEVQVBUQVCVQURVDADOPUAURVBVRUQVEURUTVRVABCOUIUBVFWAUSVF
    VSVTUTVCVSVAVDCDOPCDUCUJUDVHVIVJUEQVGVLVOVMVPLVGVLDAJKZDCJKZMKZVOVGVHWBVJWC
    MVGADUQURVFUFZVGVCVDUSVBVEUGZUHZRVGCDUSUTVAVEUKZWGRSVGUQVBVEWDVONWEUSVBVEUL
    ZWFACDTQUMVGVMCBJKZVJMKZVPVGVIWJVJMVGBCUQURVFUNZWHRUOVGURVEVBWKVPNWLWFWIBDC
    TQUMSUP $.

  $( Subtraction of two ratios.  (Contributed by Scott Fenton, 22-Apr-2014.)
     (Revised by Mario Carneiro, 2-May-2016.) $)
  divsubdiv $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( C e. CC /\ C =/= 0 )
                    /\ ( D e. CC /\ D =/= 0 ) ) ) ->
  ( ( A / C ) - ( B / D ) ) = ( ( ( A x. D ) - ( B x. C ) ) / ( C x. D ) ) ) $=
    ( cc wcel wa cc0 wne cmul co cneg caddc cdiv cmin wceq syl3anc oveq2d divcl
    eqtr3d negcl divadddiv sylanl2 simplr simprrl simprrr divneg simpll simprll
    simprlr negsubd mulneg1d mulcld eqtrd oveq1d ) AEFZBEFZGZCEFZCHIZGZDEFZDHIZ
    GZGZGZADJKZBLZCJKZMKZCDJKZNKZACNKZBDNKZOKZVGBCJKZOKZVKNKVFVMVHDNKZMKZVLVOUQ
    UPVHEFVEVSVLPBUAAVHCDUBUCVFVMVNLZMKVSVOVFVTVRVMMVFUQVBVCVTVRPUPUQVEUDZURVAV
    BVCUEZURVAVBVCUFZBDUGQRVFVMVNVFUPUSUTVMEFUPUQVEUHZURUSUTVDUIZURUSUTVDUJACSQ
    VFUQVBVCVNEFWAWBWCBDSQUKTTVFVJVQVKNVFVJVGVPLZMKVQVFVIWFVGMVFBCWAWEULRVFVGVP
    VFADWDWBUMVFBCWAWEUMUKUNUOT $.

  $( Two numbers whose reciprocals sum to 1 are called "conjugates" and satisfy
     this relationship.  Equation 5 of [Kreyszig] p. 12.  (Contributed by NM,
     12-Nov-2006.) $)
  conjmul $p |- ( ( ( P e. CC /\ P =/= 0 ) /\ ( Q e. CC /\ Q =/= 0 ) ) ->
      ( ( ( 1 / P ) + ( 1 / Q ) ) = 1 <-> ( ( P - 1 ) x. ( Q - 1 ) ) = 1 ) ) $=
    ( cc wcel cc0 wne wa cmul co cdiv caddc wceq cmin reccl adantr recid 3eqtrd
    c1 adantl ad2ant2r simpll simprl mul32d oveq1d mulid2 mulassd oveq2d mulid1
    ad2antrl ad2antrr oveq12d mulcl adddid addcom 3eqtr4d mulid1d eqeq12d addcl
    syl2an mulne0 ax-1cn mulcan mp3an2 syl12anc eqcom muleqadd syl5bb 3bitr3d
    wb ) ACDZAEFZGZBCDZBEFZGZGZABHIZRAJIZRBJIZKIZHIZVQRHIZLZABKIZVQLZVTRLZARMIB
    RMIHIRLZVPWAWDWBVQVPVQVRHIZVQVSHIZKIBAKIZWAWDVPWHBWIAKVPWHAVRHIZBHIZRBHIZBV
    PABVRVJVKVOUAZVLVMVNUBZVLVRCDZVOANZOZUCVLWLWMLVOVLWKRBHAPUDOVMWMBLVLVNBUEUI
    QVPWIABVSHIZHIZARHIZAVPABVSWNWOVOVSCDZVLBNZSZUFVOWTXALVLVOWSRAHBPUGSVJXAALV
    KVOAUHUJQUKVPVQVRVSVJVMVQCDZVKVNABULZTZWRXDUMVJVMWDWJLVKVNABUNTUOVJVMWBVQLV
    KVNVJVMGZVQXFUPTUQVPVTCDZXEVQEFZWCWFVIZVLWPXBXIVOWQXCVRVSURUSXGABUTXIRCDXEX
    JGXKVAVTRVQVBVCVDVJVMWEWGVIVKVNWEVQWDLXHWGWDVQVEABVFVGTVH $.

  ${
    $d x A $.
    $( Closure law for reciprocal.  (Contributed by NM, 30-Apr-2005.)  (Revised
       by Mario Carneiro, 27-May-2016.) $)
    rereccl $p |- ( ( A e. RR /\ A =/= 0 ) -> ( 1 / A ) e. RR ) $=
      ( vx cr wcel cc0 wne wa cv c1 cdiv co wceq wrex ax-rrecex eqcom cc ax-1cn
      cmul wb recnd simpr simpll simplr divmul syl112anc syl5bb rexbidva mpbird
      a1i risset sylibr ) ACDZAEFZGZBHZIAJKZLZBCMZUPCDUNURAUORKILZBCMBANUNUQUSB
      CUQUPUOLZUNUOCDZGZUSUOUPOVBIPDZUOPDAPDUMUTUSSVCVBQUIVBUOUNVAUATVBAULUMVAU
      BTULUMVAUCIUOAUDUEUFUGUHBUPCUJUK $.
  $}

  $( Closure law for division of reals.  (Contributed by NM, 27-Sep-1999.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  redivcl $p |- ( ( A e. RR /\ B e. RR /\ B =/= 0 ) -> ( A / B ) e. RR ) $=
    ( cr wcel cc0 wne w3a cdiv co c1 cmul wceq simp1 recnd simp2 divrec syl3anc
    cc simp3 rereccl 3adant1 remulcld eqeltrd ) ACDZBCDZBEFZGZABHIZAJBHIZKIZCUG
    ARDBRDUFUHUJLUGAUDUEUFMZNUGBUDUEUFONUDUEUFSABPQUGAUIUKUEUFUICDUDBTUAUBUC $.

  $( A number equal to its negative is zero.  (Contributed by NM,
     12-Jul-2005.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  eqneg $p |- ( A e. CC -> ( A = -u A <-> A = 0 ) ) $=
    ( cc wcel c1 caddc cmul cc0 wceq cneg 1p1times negid ax-1cn addcli syl6reqr
    co mul01i eqeq12d a1i 1re 0lt1 0cn readdcli addgt0ii gt0ne0ii mulcand negcl
    id wne addcand 3bitr3rd ) ABCZDDEOZAFOZULGFOZHAAEOZAAIZEOZHAGHAUPHUKUMUOUNU
    QAJUKUQGUNAKULDDLLMZPNQUKAGULUKUGZGBCUKUARULBCUKURRULGUHUKULDDSSUBDDSSTTUCU
    DRUEUKAAUPUSUSAUFUIUJ $.

  ${
    eqnegd.1 $e |- ( ph -> A e. CC ) $.
    $( A complex number equals its negative iff it is zero.  Deduction form of
       ~ eqneg .  (Contributed by David Moews, 28-Feb-2017.) $)
    eqnegd $p |- ( ph -> ( A = -u A <-> A = 0 ) ) $=
      ( cc wcel cneg wceq cc0 wb eqneg syl ) ABDEBBFGBHGICBJK $.
  $}

  ${
    eqnegad.1 $e |- ( ph -> A e. CC ) $.
    eqnegad.2 $e |- ( ph -> A = -u A ) $.
    $( If a complex number equals its own negative, it is zero.  One-way
       deduction form of ~ eqneg .  (Contributed by David Moews,
       28-Feb-2017.) $)
    eqnegad $p |- ( ph -> A = 0 ) $=
      ( cneg wceq cc0 eqnegd mpbid ) ABBEFBGFDABCHI $.
  $}

  $( Quotient of two negatives.  (Contributed by Paul Chapman, 10-Nov-2012.) $)
  div2neg $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                  ( -u A / -u B ) = ( A / B ) ) $=
    ( cc wcel cc0 wne w3a cneg cdiv co wceq cmul negcl 3ad2ant2 simp1 syl112anc
    c1 3adant1 eqtrd 3ad2ant1 simp2 divneg syld3an1 negeqd eqtr3d oveq2d ax-1cn
    simp3 div12 divid negcli mulcom mpan2 negeq0 necon3bid biimpa divmul mpbird
    mulm1 wb divcl ) ACDZBCDZBEFZGZAHZBHZIJABIJZKZVGVHLJZVFKZVEVJAVGBIJZLJZVFVE
    VGCDZVBVCVDVJVMKVCVBVNVDBMNZVBVCVDOVBVCVDUAZVBVCVDUHVGABUIPVEVMAQHZLJZVFVEV
    LVQALVEBBIJZHZVLVQVCVCVBVDVTVLKVPBBUBUCVEVSQVCVDVSQKVBBUJRUDUEUFVBVCVRVFKVD
    VBVRVQALJZVFVBVQCDVRWAKQUGUKAVQULUMAUSSTSSVEVFCDZVHCDVNVGEFZVIVKUTVBVCWBVDA
    MTABVAVOVCVDWCVBVCVDWCVCBEVGEBUNUOUPRVFVHVGUQPUR $.

  $( Move negative sign inside of a division.  (Contributed by Mario Carneiro,
     15-Sep-2014.) $)
  divneg2 $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                   -u ( A / B ) = ( A / -u B ) ) $=
    ( cc wcel cc0 wne w3a cdiv co cneg divneg wceq negcl div2neg syl3an1 negneg
    3ad2ant1 oveq1d 3eqtr2d ) ACDZBCDZBEFZGZABHIJAJZBHIZUDJZBJZHIZAUGHIABKTUDCD
    UAUBUHUELAMUDBNOUCUFAUGHTUAUFALUBAPQRS $.

  ${
    divclz.1 $e |- A e. CC $.
    $( Closure law for reciprocal.  (Contributed by NM, 30-Apr-2005.) $)
    recclzi $p |- ( A =/= 0 -> ( 1 / A ) e. CC ) $=
      ( cc wcel cc0 wne c1 cdiv co reccl mpan ) ACDAEFGAHICDBAJK $.

    $( The reciprocal of a nonzero number is nonzero.  (Contributed by NM,
       14-May-1999.) $)
    recne0zi $p |- ( A =/= 0 -> ( 1 / A ) =/= 0 ) $=
      ( cc wcel cc0 wne c1 cdiv co recne0 mpan ) ACDAEFGAHIEFBAJK $.

    $( Multiplication of a number and its reciprocal.  (Contributed by NM,
       14-May-1999.) $)
    recidzi $p |- ( A =/= 0 -> ( A x. ( 1 / A ) ) = 1 ) $=
      ( cc wcel cc0 wne c1 cdiv co cmul wceq recid mpan ) ACDAEFAGAHIJIGKBALM
      $.

    $( A number divided by 1 is itself.  (Contributed by NM, 9-Jan-2002.) $)
    div1i $p |- ( A / 1 ) = A $=
      ( cc wcel c1 cdiv co wceq div1 ax-mp ) ACDAEFGAHBAIJ $.

    $( A number equal to its negative is zero.  (Contributed by NM,
       29-May-1999.) $)
    eqnegi $p |- ( A = -u A <-> A = 0 ) $=
      ( cc wcel cneg wceq cc0 wb eqneg ax-mp ) ACDAAEFAGFHBAIJ $.

    ${
      reccl.2 $e |- A =/= 0 $.
      $( Closure law for reciprocal.  (Contributed by NM, 30-Apr-2005.) $)
      reccli $p |- ( 1 / A ) e. CC $=
        ( cc0 wne c1 cdiv co cc wcel recclzi ax-mp ) ADEFAGHIJCABKL $.

      $( Multiplication of a number and its reciprocal.  (Contributed by NM,
         9-Feb-1995.) $)
      recidi $p |- ( A x. ( 1 / A ) ) = 1 $=
        ( cc0 wne c1 cdiv co cmul wceq recidzi ax-mp ) ADEAFAGHIHFJCABKL $.

      $( A number is equal to the reciprocal of its reciprocal.  Theorem I.10
         of [Apostol] p. 18.  (Contributed by NM, 9-Feb-1995.) $)
      recreci $p |- ( 1 / ( 1 / A ) ) = A $=
        ( cc wcel cc0 wne c1 cdiv co wceq recrec mp2an ) ADEAFGHHAIJIJAKBCALM
        $.

      $( A number divided by itself is one.  (Contributed by NM,
         9-Feb-1995.) $)
      dividi $p |- ( A / A ) = 1 $=
        ( cc wcel cc0 wne cdiv co c1 wceq divid mp2an ) ADEAFGAAHIJKBCALM $.

      $( Division into zero is zero.  (Contributed by NM, 12-Aug-1999.) $)
      div0i $p |- ( 0 / A ) = 0 $=
        ( cc wcel cc0 wne cdiv co wceq div0 mp2an ) ADEAFGFAHIFJBCAKL $.
    $}

    divclz.2 $e |- B e. CC $.
    $( Closure law for division.  (Contributed by NM, 7-May-1999.)  (Revised by
       Mario Carneiro, 17-Feb-2014.) $)
    divclzi $p |- ( B =/= 0 -> ( A / B ) e. CC ) $=
      ( cc wcel cc0 wne cdiv co divcl mp3an12 ) AEFBEFBGHABIJEFCDABKL $.

    $( A cancellation law for division.  (Contributed by NM, 2-Oct-1999.) $)
    divcan1zi $p |- ( B =/= 0 -> ( ( A / B ) x. B ) = A ) $=
      ( cc wcel cc0 wne cdiv co cmul wceq divcan1 mp3an12 ) AEFBEFBGHABIJBKJALC
      DABMN $.

    $( A cancellation law for division.  (Contributed by NM, 10-Aug-1999.) $)
    divcan2zi $p |- ( B =/= 0 -> ( B x. ( A / B ) ) = A ) $=
      ( cc wcel cc0 wne cdiv co cmul wceq divcan2 mp3an12 ) AEFBEFBGHBABIJKJALC
      DABMN $.

    $( Relationship between division and reciprocal.  Theorem I.9 of [Apostol]
       p. 18.  (Contributed by NM, 11-Oct-1999.) $)
    divreczi $p |- ( B =/= 0 -> ( A / B ) = ( A x. ( 1 / B ) ) ) $=
      ( cc wcel cc0 wne cdiv co c1 cmul wceq divrec mp3an12 ) AEFBEFBGHABIJAKBI
      JLJMCDABNO $.

    $( A cancellation law for division.  (Eliminates a hypothesis of ~ divcan3i
       with the weak deduction theorem.)  (Contributed by NM, 3-Feb-2004.) $)
    divcan3zi $p |- ( B =/= 0 -> ( ( B x. A ) / B ) = A ) $=
      ( cc wcel cc0 wne cmul co cdiv wceq divcan3 mp3an12 ) AEFBEFBGHBAIJBKJALC
      DABMN $.

    $( A cancellation law for division.  (Contributed by NM, 12-Oct-1999.) $)
    divcan4zi $p |- ( B =/= 0 -> ( ( A x. B ) / B ) = A ) $=
      ( cc wcel cc0 wne cmul co cdiv wceq divcan4 mp3an12 ) AEFBEFBGHABIJBKJALC
      DABMN $.

    $( Reciprocal is one-to-one.  (Contributed by NM, 16-Sep-1999.) $)
    rec11i $p |- ( ( A =/= 0 /\ B =/= 0 ) ->
               ( ( 1 / A ) = ( 1 / B ) <-> A = B ) ) $=
      ( cc wcel cc0 wne wa c1 cdiv co wceq wb rec11 an4s mpanl12 ) AEFZBEFZAGHZ
      BGHZIJAKLJBKLMABMNZCDRTSUAUBABOPQ $.

    ${
      divcl.3 $e |- B =/= 0 $.
      $( Closure law for division.  (Contributed by NM, 2-Feb-1995.)  (Revised
         by Mario Carneiro, 17-Feb-2014.) $)
      divcli $p |- ( A / B ) e. CC $=
        ( cc0 wne cdiv co cc wcel divclzi ax-mp ) BFGABHIJKEABCDLM $.

      $( A cancellation law for division.  (Contributed by NM, 9-Feb-1995.) $)
      divcan2i $p |- ( B x. ( A / B ) ) = A $=
        ( cc0 wne cdiv co cmul wceq divcan2zi ax-mp ) BFGBABHIJIAKEABCDLM $.

      $( A cancellation law for division.  (Contributed by NM, 18-May-1999.) $)
      divcan1i $p |- ( ( A / B ) x. B ) = A $=
        ( cdiv co divcli divcan2i mulcomli ) BABFGADABCDEHABCDEIJ $.

      $( Relationship between division and reciprocal.  Theorem I.9 of
         [Apostol] p. 18.  (Contributed by NM, 9-Feb-1995.) $)
      divreci $p |- ( A / B ) = ( A x. ( 1 / B ) ) $=
        ( cc0 wne cdiv co c1 cmul wceq divreczi ax-mp ) BFGABHIAJBHIKILEABCDMN
        $.

      $( A cancellation law for division.  (Contributed by NM, 16-Feb-1995.) $)
      divcan3i $p |- ( ( B x. A ) / B ) = A $=
        ( cc0 wne cmul co cdiv wceq divcan3zi ax-mp ) BFGBAHIBJIAKEABCDLM $.

      $( A cancellation law for division.  (Contributed by NM, 18-May-1999.) $)
      divcan4i $p |- ( ( A x. B ) / B ) = A $=
        ( cc0 wne cmul co cdiv wceq divcan4zi ax-mp ) BFGABHIBJIAKEABCDLM $.
    $}

    ${
      divneq0.3 $e |- A =/= 0 $.
      divneq0.4 $e |- B =/= 0 $.
      $( The ratio of nonzero numbers is nonzero.  (Contributed by NM,
         9-Feb-1995.) $)
      divne0i $p |- ( A / B ) =/= 0 $=
        ( cc wcel cc0 wne cdiv co divne0 mp4an ) AGHAIJBGHBIJABKLIJCEDFABMN $.

      $( Reciprocal is one-to-one.  (Contributed by NM, 16-Sep-1999.) $)
      rec11ii $p |- ( ( 1 / A ) = ( 1 / B ) <-> A = B ) $=
        ( cc0 wne c1 cdiv co wceq wb rec11i mp2an ) AGHBGHIAJKIBJKLABLMEFABCDNO
        $.
    $}

    divmulz.3 $e |- C e. CC $.
    $( An associative law for division.  (Contributed by NM, 12-Aug-1999.) $)
    divasszi $p |- ( C =/= 0 -> ( ( A x. B ) / C ) = ( A x. ( B / C ) ) ) $=
      ( cc wcel cc0 wne cmul co cdiv wceq wa divass mp3an12 mpan ) CGHZCIJZABKL
      CMLABCMLKLNZFAGHBGHSTOUADEABCPQR $.

    $( Relationship between division and multiplication.  (Contributed by NM,
       8-May-1999.)  (Revised by Mario Carneiro, 17-Feb-2014.) $)
    divmulzi $p |- ( B =/= 0 -> ( ( A / B ) = C <-> ( B x. C ) = A ) ) $=
      ( cc wcel cc0 wne cdiv co wceq cmul wb wa divmul mp3an12 mpan ) BGHZBIJZA
      BKLCMBCNLAMOZEAGHCGHTUAPUBDFACBQRS $.

    $( Distribution of division over addition.  (Contributed by NM,
       31-Jul-2004.) $)
    divdirzi $p |- ( C =/= 0 ->
                    ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) ) $=
      ( cc wcel cc0 wne caddc co cdiv wceq wa divdir mp3an12 mpan ) CGHZCIJZABK
      LCMLACMLBCMLKLNZFAGHBGHSTOUADEABCPQR $.

    $( Swap denominators in a division.  (Contributed by NM, 15-Sep-1999.) $)
    divdiv23zi $p |- ( ( B =/= 0 /\ C =/= 0 ) ->
                ( ( A / B ) / C ) = ( ( A / C ) / B ) ) $=
      ( cc wcel cc0 wne cdiv co wceq wa divdiv32 mp3an1 mpanr1 mpanl1 ) BGHZBIJ
      ZCIJZABKLCKLACKLBKLMZESTNZCGHZUAUBFAGHUCUDUANUBDABCOPQR $.

    ${
      divmul.4 $e |- B =/= 0 $.
      $( Relationship between division and multiplication.  (Contributed by NM,
         2-Feb-1995.)  (Revised by Mario Carneiro, 17-Feb-2014.) $)
      divmuli $p |- ( ( A / B ) = C <-> ( B x. C ) = A ) $=
        ( cc0 wne cdiv co wceq cmul wb divmulzi ax-mp ) BHIABJKCLBCMKALNGABCDEF
        OP $.

      divdiv23.5 $e |- C =/= 0 $.
      $( Swap denominators in a division.  (Contributed by NM, 15-Sep-1999.) $)
      divdiv32i $p |- ( ( A / B ) / C ) = ( ( A / C ) / B ) $=
        ( cc0 wne cdiv co wceq divdiv23zi mp2an ) BIJCIJABKLCKLACKLBKLMGHABCDEF
        NO $.
    $}

    ${
      divass.4 $e |- C =/= 0 $.
      $( An associative law for division.  (Contributed by NM, 15-Feb-1995.) $)
      divassi $p |- ( ( A x. B ) / C ) = ( A x. ( B / C ) ) $=
        ( cc0 wne cmul co cdiv wceq divasszi ax-mp ) CHIABJKCLKABCLKJKMGABCDEFN
        O $.

      $( Distribution of division over addition.  (Contributed by NM,
         16-Feb-1995.) $)
      divdiri $p |- ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) $=
        ( cc0 wne caddc co cdiv wceq divdirzi ax-mp ) CHIABJKCLKACLKBCLKJKMGABC
        DEFNO $.

      $( A commutative/associative law for division.  (Contributed by NM,
         3-Sep-1999.) $)
      div23i $p |- ( ( A x. B ) / C ) = ( ( A / C ) x. B ) $=
        ( cc wcel cc0 wne wa cmul co cdiv wceq pm3.2i div23 mp3an ) AHIBHICHIZC
        JKZLABMNCONACONBMNPDETUAFGQABCRS $.

      $( One-to-one relationship for division.  (Contributed by NM,
         20-Aug-2001.) $)
      div11i $p |- ( ( A / C ) = ( B / C ) <-> A = B ) $=
        ( cc wcel cc0 wne wa cdiv co wceq wb pm3.2i div11 mp3an ) AHIBHICHIZCJK
        ZLACMNBCMNOABOPDETUAFGQABCRS $.
    $}

    divmuldiv.4 $e |- D e. CC $.
    divmuldiv.5 $e |- B =/= 0 $.
    divmuldiv.6 $e |- D =/= 0 $.
    $( Multiplication of two ratios.  Theorem I.14 of [Apostol] p. 18.
       (Contributed by NM, 16-Feb-1995.) $)
    divmuldivi $p |- ( ( A / B ) x. ( C / D ) ) =
                      ( ( A x. C ) / ( B x. D ) ) $=
      ( cc wcel cc0 wne wa cdiv co cmul wceq pm3.2i divmuldiv mp4an ) AKLCKLBKL
      ZBMNZODKLZDMNZOABPQCDPQRQACRQBDRQPQSEGUCUDFITUEUFHJTACBDUAUB $.

    $( Swap denominators of two ratios.  (Contributed by NM, 6-Aug-1999.) $)
    divmul13i $p |- ( ( A / B ) x. ( C / D ) ) =
                   ( ( C / B ) x. ( A / D ) ) $=
      ( cmul co cdiv mulcomi oveq1i divmuldivi 3eqtr4ri ) CAKLZBDKLZMLACKLZSMLC
      BMLADMLKLABMLCDMLKLRTSMCAGENOCBADGFEHIJPABCDEFGHIJPQ $.

    $( Addition of two ratios.  Theorem I.13 of [Apostol] p. 18.  (Contributed
       by NM, 21-Feb-1995.) $)
    divadddivi $p |- ( ( A / B ) + ( C / D ) ) =
                      ( ( ( A x. D ) + ( C x. B ) ) / ( B x. D ) ) $=
      ( cc wcel cc0 wne wa cdiv co caddc cmul pm3.2i wceq divadddiv mp4an ) AKL
      CKLBKLZBMNZODKLZDMNZOABPQCDPQRQADSQCBSQRQBDSQPQUAEGUDUEFITUFUGHJTACBDUBUC
      $.

    divdivdiv.7 $e |- C =/= 0 $.
    $( Division of two ratios.  Theorem I.15 of [Apostol] p. 18.  (Contributed
       by NM, 22-Feb-1995.) $)
    divdivdivi $p |- ( ( A / B ) / ( C / D ) )
                        = ( ( A x. D ) / ( B x. C ) ) $=
      ( cc wcel cc0 wne wa cdiv co cmul pm3.2i wceq divdivdiv mp4an ) ALMBLMZBN
      OZPCLMZCNOZPDLMZDNOZPABQRCDQRQRADSRBCSRQRUAEUDUEFITUFUGGKTUHUIHJTABCDUBUC
      $.
  $}

  ${
    $d x y B $.
    redivcl.1 $e |- A e. RR $.
    $( Closure law for reciprocal.  (Contributed by NM, 30-Apr-2005.) $)
    rerecclzi $p |- ( A =/= 0 -> ( 1 / A ) e. RR ) $=
      ( cr wcel cc0 wne c1 cdiv co rereccl mpan ) ACDAEFGAHICDBAJK $.

    ${
      rereccl.2 $e |- A =/= 0 $.
      $( Closure law for reciprocal.  (Contributed by NM, 30-Apr-2005.) $)
      rereccli $p |- ( 1 / A ) e. RR $=
        ( cc0 wne c1 cdiv co cr wcel rerecclzi ax-mp ) ADEFAGHIJCABKL $.
    $}

    redivcl.2 $e |- B e. RR $.
    $( Closure law for division of reals.  (Contributed by NM, 9-May-1999.) $)
    redivclzi $p |- ( B =/= 0 -> ( A / B ) e. RR ) $=
      ( cr wcel cc0 wne cdiv co redivcl mp3an12 ) AEFBEFBGHABIJEFCDABKL $.

    redivcl.3 $e |- B =/= 0 $.
    $( Closure law for division of reals.  (Contributed by NM, 9-May-1999.) $)
    redivcli $p |- ( A / B ) e. RR $=
      ( cc0 wne cdiv co cr wcel redivclzi ax-mp ) BFGABHIJKEABCDLM $.
  $}

  ${
    div1d.1 $e |- ( ph -> A e. CC ) $.
    $( A number divided by 1 is itself.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    div1d $p |- ( ph -> ( A / 1 ) = A ) $=
      ( cc wcel c1 cdiv co wceq div1 syl ) ABDEBFGHBICBJK $.

    ${
      reccld.2 $e |- ( ph -> A =/= 0 ) $.
      $( Closure law for reciprocal.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      reccld $p |- ( ph -> ( 1 / A ) e. CC ) $=
        ( cc wcel cc0 wne c1 cdiv co reccl syl2anc ) ABEFBGHIBJKEFCDBLM $.

      $( The reciprocal of a nonzero number is nonzero.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      recne0d $p |- ( ph -> ( 1 / A ) =/= 0 ) $=
        ( cc wcel cc0 wne c1 cdiv co recne0 syl2anc ) ABEFBGHIBJKGHCDBLM $.

      $( Multiplication of a number and its reciprocal.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      recidd $p |- ( ph -> ( A x. ( 1 / A ) ) = 1 ) $=
        ( cc wcel cc0 wne c1 cdiv co cmul wceq recid syl2anc ) ABEFBGHBIBJKLKIM
        CDBNO $.

      $( Multiplication of a number and its reciprocal.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      recid2d $p |- ( ph -> ( ( 1 / A ) x. A ) = 1 ) $=
        ( cc wcel cc0 wne c1 cdiv co cmul wceq recid2 syl2anc ) ABEFBGHIBJKBLKI
        MCDBNO $.

      $( A number is equal to the reciprocal of its reciprocal.  (Contributed
         by Mario Carneiro, 27-May-2016.) $)
      recrecd $p |- ( ph -> ( 1 / ( 1 / A ) ) = A ) $=
        ( cc wcel cc0 wne c1 cdiv co wceq recrec syl2anc ) ABEFBGHIIBJKJKBLCDBM
        N $.

      $( A number divided by itself is one.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      dividd $p |- ( ph -> ( A / A ) = 1 ) $=
        ( cc wcel cc0 wne cdiv co c1 wceq divid syl2anc ) ABEFBGHBBIJKLCDBMN $.

      $( Division into zero is zero.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      div0d $p |- ( ph -> ( 0 / A ) = 0 ) $=
        ( cc wcel cc0 wne cdiv co wceq div0 syl2anc ) ABEFBGHGBIJGKCDBLM $.
    $}

    divcld.2 $e |- ( ph -> B e. CC ) $.
    ${
      divcld.3 $e |- ( ph -> B =/= 0 ) $.
      $( Closure law for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcld $p |- ( ph -> ( A / B ) e. CC ) $=
        ( cc wcel cc0 wne cdiv co divcl syl3anc ) ABGHCGHCIJBCKLGHDEFBCMN $.

      $( A cancellation law for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcan1d $p |- ( ph -> ( ( A / B ) x. B ) = A ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq divcan1 syl3anc ) ABGHCGHCIJBCKLCML
        BNDEFBCOP $.

      $( A cancellation law for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcan2d $p |- ( ph -> ( B x. ( A / B ) ) = A ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq divcan2 syl3anc ) ABGHCGHCIJCBCKLML
        BNDEFBCOP $.

      $( Relationship between division and reciprocal.  Theorem I.9 of
         [Apostol] p. 18.  (Contributed by Mario Carneiro, 27-May-2016.) $)
      divrecd $p |- ( ph -> ( A / B ) = ( A x. ( 1 / B ) ) ) $=
        ( cc wcel cc0 wne cdiv co c1 cmul wceq divrec syl3anc ) ABGHCGHCIJBCKLB
        MCKLNLODEFBCPQ $.

      $( Relationship between division and reciprocal.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divrec2d $p |- ( ph -> ( A / B ) = ( ( 1 / B ) x. A ) ) $=
        ( cc wcel cc0 wne cdiv co c1 cmul wceq divrec2 syl3anc ) ABGHCGHCIJBCKL
        MCKLBNLODEFBCPQ $.

      $( A cancellation law for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcan3d $p |- ( ph -> ( ( B x. A ) / B ) = A ) $=
        ( cc wcel cc0 wne cmul co cdiv wceq divcan3 syl3anc ) ABGHCGHCIJCBKLCML
        BNDEFBCOP $.

      $( A cancellation law for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcan4d $p |- ( ph -> ( ( A x. B ) / B ) = A ) $=
        ( cc wcel cc0 wne cmul co cdiv wceq divcan4 syl3anc ) ABGHCGHCIJBCKLCML
        BNDEFBCOP $.

      ${
        diveq0d.4 $e |- ( ph -> ( A / B ) = 0 ) $.
        $( A ratio is zero iff the numerator is zero.  (Contributed by Mario
           Carneiro, 27-May-2016.) $)
        diveq0d $p |- ( ph -> A = 0 ) $=
          ( cdiv co cc0 wceq cc wcel wne wb diveq0 syl3anc mpbid ) ABCHIJKZBJKZ
          GABLMCLMCJNSTODEFBCPQR $.
      $}

      ${
        diveq1d.4 $e |- ( ph -> ( A / B ) = 1 ) $.
        $( Equality in terms of unit ratio.  (Contributed by Mario Carneiro,
           27-May-2016.) $)
        diveq1d $p |- ( ph -> A = B ) $=
          ( cdiv co c1 wceq cc wcel cc0 wne wb diveq1 syl3anc mpbid ) ABCHIJKZB
          CKZGABLMCLMCNOTUAPDEFBCQRS $.
      $}

      $( The quotient of two complex numbers is one iff they are equal.
         Deduction form of ~ diveq1 .  Generalization of ~ diveq1d .
         (Contributed by David Moews, 28-Feb-2017.) $)
      diveq1ad $p |- ( ph -> ( ( A / B ) = 1 <-> A = B ) ) $=
        ( cc wcel cc0 wne cdiv co c1 wceq wb diveq1 syl3anc ) ABGHCGHCIJBCKLMNB
        CNODEFBCPQ $.

      $( A fraction of complex numbers is zero iff its numerator is.  Deduction
         form of ~ diveq0 .  (Contributed by David Moews, 28-Feb-2017.) $)
      diveq0ad $p |- ( ph -> ( ( A / B ) = 0 <-> A = 0 ) ) $=
        ( cc wcel cc0 wne cdiv co wceq wb diveq0 syl3anc ) ABGHCGHCIJBCKLIMBIMN
        DEFBCOP $.

      ${
        divne1d.4 $e |- ( ph -> A =/= B ) $.
        $( If two complex numbers are unequal, their quotient is not one.
           Contrapositive of ~ diveq1d .  (Contributed by David Moews,
           28-Feb-2017.) $)
        divne1d $p |- ( ph -> ( A / B ) =/= 1 ) $=
          ( cdiv co c1 wne diveq1ad necon3bid mpbird ) ABCHIZJKBCKGAOJBCABCDEFL
          MN $.
      $}

      $( A ratio is zero iff the numerator is zero.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divne0bd $p |- ( ph -> ( A =/= 0 <-> ( A / B ) =/= 0 ) ) $=
        ( cc wcel cc0 wne cdiv co wb divne0b syl3anc ) ABGHCGHCIJBIJBCKLIJMDEFB
        CNO $.

      $( Move negative sign inside of a division.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divnegd $p |- ( ph -> -u ( A / B ) = ( -u A / B ) ) $=
        ( cc wcel cc0 wne cdiv co cneg wceq divneg syl3anc ) ABGHCGHCIJBCKLMBMC
        KLNDEFBCOP $.

      $( Move negative sign inside of a division.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divneg2d $p |- ( ph -> -u ( A / B ) = ( A / -u B ) ) $=
        ( cc wcel cc0 wne cdiv co cneg wceq divneg2 syl3anc ) ABGHCGHCIJBCKLMBC
        MKLNDEFBCOP $.

      $( Quotient of two negatives.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      div2negd $p |- ( ph -> ( -u A / -u B ) = ( A / B ) ) $=
        ( cc wcel cc0 wne cneg cdiv co wceq div2neg syl3anc ) ABGHCGHCIJBKCKLMB
        CLMNDEFBCOP $.
    $}

    ${
      divne0d.3 $e |- ( ph -> A =/= 0 ) $.
      divne0d.4 $e |- ( ph -> B =/= 0 ) $.
      $( The ratio of nonzero numbers is nonzero.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divne0d $p |- ( ph -> ( A / B ) =/= 0 ) $=
        ( cc wcel cc0 wne cdiv co divne0 syl22anc ) ABHIBJKCHICJKBCLMJKDFEGBCNO
        $.

      $( The reciprocal of a ratio.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      recdivd $p |- ( ph -> ( 1 / ( A / B ) ) = ( B / A ) ) $=
        ( cc wcel cc0 wne c1 cdiv co wceq recdiv syl22anc ) ABHIBJKCHICJKLBCMNM
        NCBMNODFEGBCPQ $.

      $( Division into a reciprocal.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      recdiv2d $p |- ( ph -> ( ( 1 / A ) / B ) = ( 1 / ( A x. B ) ) ) $=
        ( cc wcel cc0 wne c1 cdiv co cmul wceq recdiv2 syl22anc ) ABHIBJKCHICJK
        LBMNCMNLBCONMNPDFEGBCQR $.

      $( Cancellation of inverted fractions.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcan6d $p |- ( ph -> ( ( A / B ) x. ( B / A ) ) = 1 ) $=
        ( cc wcel cc0 wne cdiv co cmul c1 wceq divcan6 syl22anc ) ABHIBJKCHICJK
        BCLMCBLMNMOPDFEGBCQR $.

      $( Cancellation in a double division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      ddcand $p |- ( ph -> ( A / ( A / B ) ) = B ) $=
        ( cc wcel cc0 wne cdiv co wceq ddcan syl22anc ) ABHIBJKCHICJKBBCLMLMCND
        FEGBCOP $.

      rec11d.5 $e |- ( ph -> ( 1 / A ) = ( 1 / B ) ) $.
      $( Reciprocal is one-to-one.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      rec11d $p |- ( ph -> A = B ) $=
        ( c1 cdiv co wceq cc wcel cc0 wne wb rec11 syl22anc mpbid ) AIBJKICJKLZ
        BCLZHABMNBOPCMNCOPUAUBQDFEGBCRST $.
    $}

    divmuld.3 $e |- ( ph -> C e. CC ) $.
    ${
      divmuld.4 $e |- ( ph -> B =/= 0 ) $.
      $( Relationship between division and multiplication.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      divmuld $p |- ( ph -> ( ( A / B ) = C <-> ( B x. C ) = A ) ) $=
        ( cc wcel cc0 wne cdiv co wceq cmul wb divmul syl112anc ) ABIJDIJCIJCKL
        BCMNDOCDPNBOQEGFHBDCRS $.

      $( A commutative/associative law for division.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      div32d $p |- ( ph -> ( ( A / B ) x. C ) = ( A x. ( C / B ) ) ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq div32 syl121anc ) ABIJCIJCKLDIJBCMN
        DONBDCMNONPEFHGBCDQR $.

      $( A commutative/associative law for division.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      div13d $p |- ( ph -> ( ( A / B ) x. C ) = ( ( C / B ) x. A ) ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq div13 syl121anc ) ABIJCIJCKLDIJBCMN
        DONDCMNBONPEFHGBCDQR $.

      divdiv23d.5 $e |- ( ph -> C =/= 0 ) $.
      $( Swap denominators in a division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divdiv32d $p |- ( ph -> ( ( A / B ) / C ) = ( ( A / C ) / B ) ) $=
        ( cc wcel cc0 wne cdiv co wceq divdiv32 syl122anc ) ABJKCJKCLMDJKDLMBCN
        ODNOBDNOCNOPEFHGIBCDQR $.

      $( Cancellation of common factor in a ratio.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divcan5d $p |- ( ph -> ( ( C x. A ) / ( C x. B ) ) = ( A / B ) ) $=
        ( cc wcel cc0 wne cmul co cdiv wceq divcan5 syl122anc ) ABJKCJKCLMDJKDL
        MDBNODCNOPOBCPOQEFHGIBCDRS $.

      $( Cancellation of common factor in a ratio.  (Contributed by Mario
         Carneiro, 1-Jan-2017.) $)
      divcan5rd $p |- ( ph -> ( ( A x. C ) / ( B x. C ) ) = ( A / B ) ) $=
        ( cmul co cdiv mulcomd oveq12d divcan5d eqtrd ) ABDJKZCDJKZLKDBJKZDCJKZ
        LKBCLKAQSRTLABDEGMACDFGMNABCDEFGHIOP $.

      $( Cancel equal divisors in a division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divcan7d $p |- ( ph -> ( ( A / C ) / ( B / C ) ) = ( A / B ) ) $=
        ( cc wcel cc0 wne cdiv co wceq divcan7 syl122anc ) ABJKCJKCLMDJKDLMBDNO
        CDNONOBCNOPEFHGIBCDQR $.

      $( Cancellation law for division and multiplication.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      dmdcand $p |- ( ph -> ( ( B / C ) x. ( A / B ) ) = ( A / C ) ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq dmdcan syl221anc ) ACJKCLMDJKDLMBJK
        CDNOBCNOPOBDNOQFHGIECDBRS $.

      $( Cancellation law for division and multiplication.  (Contributed by
         David Moews, 28-Feb-2017.) $)
      dmdcan2d $p |- ( ph -> ( ( A / B ) x. ( B / C ) ) = ( A / C ) ) $=
        ( cdiv co cmul divcld mulcomd dmdcand eqtrd ) ABCJKZCDJKZLKRQLKBDJKAQRA
        BCEFHMACDFGIMNABCDEFGHIOP $.

      $( Division into a fraction.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divdiv1d $p |- ( ph -> ( ( A / B ) / C ) = ( A / ( B x. C ) ) ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq divdiv1 syl122anc ) ABJKCJKCLMDJKDL
        MBCNODNOBCDPONOQEFHGIBCDRS $.

      $( Division by a fraction.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divdiv2d $p |- ( ph -> ( A / ( B / C ) ) = ( ( A x. C ) / B ) ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq divdiv2 syl122anc ) ABJKCJKCLMDJKDL
        MBCDNONOBDPOCNOQEFHGIBCDRS $.
    $}

    ${
      divassd.4 $e |- ( ph -> C =/= 0 ) $.
      $( Relationship between division and multiplication.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      divmul2d $p |- ( ph -> ( ( A / C ) = B <-> A = ( C x. B ) ) ) $=
        ( cc wcel cc0 wne cdiv co wceq cmul wb divmul2 syl112anc ) ABIJCIJDIJDK
        LBDMNCOBDCPNOQEFGHBCDRS $.

      $( Relationship between division and multiplication.  (Contributed by
         Mario Carneiro, 27-May-2016.) $)
      divmul3d $p |- ( ph -> ( ( A / C ) = B <-> A = ( B x. C ) ) ) $=
        ( cc wcel cc0 wne cdiv co wceq cmul wb divmul3 syl112anc ) ABIJCIJDIJDK
        LBDMNCOBCDPNOQEFGHBCDRS $.

      $( An associative law for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      divassd $p |- ( ph -> ( ( A x. B ) / C ) = ( A x. ( B / C ) ) ) $=
        ( cc wcel cc0 wne cmul co cdiv wceq divass syl112anc ) ABIJCIJDIJDKLBCM
        NDONBCDONMNPEFGHBCDQR $.

      $( A commutative/associative law for division.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      div12d $p |- ( ph -> ( A x. ( B / C ) ) = ( B x. ( A / C ) ) ) $=
        ( cc wcel cc0 wne cdiv co cmul wceq div12 syl112anc ) ABIJCIJDIJDKLBCDM
        NONCBDMNONPEFGHBCDQR $.

      $( A commutative/associative law for division.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      div23d $p |- ( ph -> ( ( A x. B ) / C ) = ( ( A / C ) x. B ) ) $=
        ( cc wcel cc0 wne cmul co cdiv wceq div23 syl112anc ) ABIJCIJDIJDKLBCMN
        DONBDONCMNPEFGHBCDQR $.

      $( Distribution of division over addition.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divdird $p |- ( ph -> ( ( A + B ) / C ) = ( ( A / C ) + ( B / C ) ) ) $=
        ( cc wcel cc0 wne caddc co cdiv wceq divdir syl112anc ) ABIJCIJDIJDKLBC
        MNDONBDONCDONMNPEFGHBCDQR $.

      $( Distribution of division over subtraction.  (Contributed by Mario
         Carneiro, 27-May-2016.) $)
      divsubdird $p |- ( ph ->
          ( ( A - B ) / C ) = ( ( A / C ) - ( B / C ) ) ) $=
        ( cc wcel cc0 wne cmin co cdiv wceq divsubdir syl112anc ) ABIJCIJDIJDKL
        BCMNDONBDONCDONMNPEFGHBCDQR $.

      div11d.5 $e |- ( ph -> ( A / C ) = ( B / C ) ) $.
      $( One-to-one relationship for division.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      div11d $p |- ( ph -> A = B ) $=
        ( cdiv co wceq cc wcel cc0 wne wb div11 syl112anc mpbid ) ABDJKCDJKLZBC
        LZIABMNCMNDMNDOPUAUBQEFGHBCDRST $.
    $}

    divmuldivd.4 $e |- ( ph -> D e. CC ) $.
    divmuldivd.5 $e |- ( ph -> B =/= 0 ) $.
    divmuldivd.6 $e |- ( ph -> D =/= 0 ) $.
    $( Multiplication of two ratios.  Theorem I.14 of [Apostol] p. 18.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    divmuldivd $p |- ( ph -> ( ( A / B ) x. ( C / D ) ) =
                             ( ( A x. C ) / ( B x. D ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co cmul jca wceq divmuldiv syl22anc ) ABLMDLMCL
      MZCNOZPELMZENOZPBCQRDEQRSRBDSRCESRQRUAFHAUDUEGJTAUFUGIKTBDCEUBUC $.

    $( Swap denominators of two ratios.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    divmul13d $p |- ( ph -> ( ( A / B ) x. ( C / D ) ) =
                            ( ( C / B ) x. ( A / D ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co cmul jca wceq divmul13 syl22anc ) ABLMDLMCLM
      ZCNOZPELMZENOZPBCQRDEQRSRDCQRBEQRSRUAFHAUDUEGJTAUFUGIKTBDCEUBUC $.

    $( Swap the numerators in the product of two ratios.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    divmul24d $p |- ( ph -> ( ( A / B ) x. ( C / D ) ) =
                           ( ( A / D ) x. ( C / B ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co cmul jca wceq divmul24 syl22anc ) ABLMDLMCLM
      ZCNOZPELMZENOZPBCQRDEQRSRBEQRDCQRSRUAFHAUDUEGJTAUFUGIKTBDCEUBUC $.

    $( Addition of two ratios.  Theorem I.13 of [Apostol] p. 18.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    divadddivd $p |- ( ph -> ( ( A / B ) + ( C / D ) ) =
                      ( ( ( A x. D ) + ( C x. B ) ) / ( B x. D ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co caddc cmul wceq jca divadddiv syl22anc ) ABL
      MDLMCLMZCNOZPELMZENOZPBCQRDEQRSRBETRDCTRSRCETRQRUAFHAUEUFGJUBAUGUHIKUBBDC
      EUCUD $.

    $( Subtraction of two ratios.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    divsubdivd $p |- ( ph -> ( ( A / B ) - ( C / D ) ) =
                       ( ( ( A x. D ) - ( C x. B ) ) / ( B x. D ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co cmin cmul wceq jca divsubdiv syl22anc ) ABLM
      DLMCLMZCNOZPELMZENOZPBCQRDEQRSRBETRDCTRSRCETRQRUAFHAUEUFGJUBAUGUHIKUBBDCE
      UCUD $.

    $( Cross-multiply in an equality of ratios.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    divmuleqd $p |- ( ph ->
        ( ( A / B ) = ( C / D ) <-> ( A x. D ) = ( C x. B ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co wceq cmul wb jca divmuleq syl22anc ) ABLMDLM
      CLMZCNOZPELMZENOZPBCQRDEQRSBETRDCTRSUAFHAUEUFGJUBAUGUHIKUBBDCEUCUD $.

    divdivdivd.7 $e |- ( ph -> C =/= 0 ) $.
    $( Division of two ratios.  Theorem I.15 of [Apostol] p. 18.  (Contributed
       by Mario Carneiro, 27-May-2016.) $)
    divdivdivd $p |- ( ph -> ( ( A / B ) / ( C / D ) )
                        = ( ( A x. D ) / ( B x. C ) ) ) $=
      ( cc wcel cc0 wne wa cdiv co jca cmul wceq divdivdiv syl22anc ) ABMNCMNZC
      OPZQDMNZDOPZQEMNZEOPZQBCRSDERSRSBEUASCDUASRSUBFAUEUFGJTAUGUHHLTAUIUJIKTBC
      DEUCUD $.
  $}

  ${
    diveq1bd.1 $e |- ( ph -> B e. CC ) $.
    diveq1bd.2 $e |- ( ph -> B =/= 0 ) $.
    diveq1bd.3 $e |- ( ph -> A = B ) $.
    $( If two complex numbers are equal, their quotient is one.  One-way
       deduction form of ~ diveq1 .  Converse of ~ diveq1d .  (Contributed by
       David Moews, 28-Feb-2017.) $)
    diveq1bd $p |- ( ph -> ( A / B ) = 1 ) $=
      ( cdiv co c1 wceq cc eqeltrd diveq1ad mpbird ) ABCGHIJBCJFABCABCKFDLDEMN
      $.
  $}

  $( Swap the order of subtraction in a division.  (Contributed by Scott
     Fenton, 24-Jun-2013.) $)
  div2sub $p |- ( ( ( A e. CC /\ B e. CC ) /\
    ( C e. CC /\ D e. CC /\ C =/= D ) ) ->
    ( ( A - B ) / ( C - D ) ) = ( ( B - A ) / ( D - C ) ) ) $=
    ( cc wcel wa wne w3a cmin cneg cdiv cc0 wceq subcl 3adant3 subeq0 necon3bid
    co negsubdi2 biimp3ar jca div2neg 3expb syl2an oveqan12d eqtr3d ) AEFBEFGZC
    EFZDEFZCDHZIZGABJSZKZCDJSZKZLSZUMUOLSZBAJSZDCJSZLSUHUMEFZUOEFZUOMHZGUQURNZU
    LABOULVBVCUIUJVBUKCDOPUIUJVCUKUIUJGUOMCDCDQRUAUBVAVBVCVDUMUOUCUDUEUHULUNUSU
    PUTLABTUIUJUPUTNUKCDTPUFUG $.

  ${
    div2subd.1 $e |- ( ph -> A e. CC ) $.
    div2subd.2 $e |- ( ph -> B e. CC ) $.
    div2subd.3 $e |- ( ph -> C e. CC ) $.
    div2subd.4 $e |- ( ph -> D e. CC ) $.
    div2subd.5 $e |- ( ph -> C =/= D ) $.
    $( Swap subtrahend and minuend inside the numerator and denominator of a
       fraction.  Deduction form of ~ div2sub .  (Contributed by David Moews,
       28-Feb-2017.) $)
    div2subd $p |- ( ph -> ( ( A - B ) / ( C - D ) ) =
                           ( ( B - A ) / ( D - C ) ) ) $=
      ( cc wcel wne cmin co cdiv wceq div2sub syl23anc ) ABKLCKLDKLEKLDEMBCNODE
      NOPOCBNOEDNOPOQFGHIJBCDERS $.
  $}

  ${
    $d x y B $.
    redivcld.1 $e |- ( ph -> A e. RR ) $.
    ${
      rereccld.2 $e |- ( ph -> A =/= 0 ) $.
      $( Closure law for reciprocal.  (Contributed by Mario Carneiro,
         27-May-2016.) $)
      rereccld $p |- ( ph -> ( 1 / A ) e. RR ) $=
        ( cr wcel cc0 wne c1 cdiv co rereccl syl2anc ) ABEFBGHIBJKEFCDBLM $.
    $}

    redivcld.2 $e |- ( ph -> B e. RR ) $.
    redivcld.3 $e |- ( ph -> B =/= 0 ) $.
    $( Closure law for division of reals.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    redivcld $p |- ( ph -> ( A / B ) e. RR ) $=
      ( cr wcel cc0 wne cdiv co redivcl syl3anc ) ABGHCGHCIJBCKLGHDEFBCMN $.
  $}

  $( Subtraction of reciprocals.  (Contributed by Scott Fenton, 9-Jul-2015.) $)
  subrec $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
    ( ( 1 / A ) - ( 1 / B ) ) = ( ( B - A ) / ( A x. B ) ) ) $=
    ( cc wcel cc0 wne wa c1 cdiv co cmin ax-1cn a1i simpll simprl simplr simprr
    cmul divsubdivd mulid2d oveq12d oveq1d eqtrd ) ACDZAEFZGZBCDZBEFZGZGZHAIJHB
    IJKJHBRJZHARJZKJZABRJZIJBAKJZUNIJUJHAHBHCDUJLMZUDUEUINZUPUFUGUHOZUDUEUIPUFU
    GUHQSUJUMUOUNIUJUKBULAKUJBURTUJAUQTUAUBUC $.

  ${
    subreci.1 $e |- A e. CC $.
    subreci.2 $e |- B e. CC $.
    subreci.3 $e |- A =/= 0 $.
    subreci.4 $e |- B =/= 0 $.
    $( Subtraction of reciprocals.  (Contributed by Scott Fenton,
       9-Jan-2017.) $)
    subreci $p |- ( ( 1 / A ) - ( 1 / B ) ) = ( ( B - A ) / ( A x. B ) ) $=
      ( cc wcel cc0 wne c1 cdiv co cmin cmul wceq subrec mp4an ) AGHAIJBGHBIJKA
      LMKBLMNMBANMABOMLMPCEDFABQR $.
  $}

  ${
    subrecd.1 $e |- ( ph -> A e. CC ) $.
    subrecd.2 $e |- ( ph -> B e. CC ) $.
    subrecd.3 $e |- ( ph -> A =/= 0 ) $.
    subrecd.4 $e |- ( ph -> B =/= 0 ) $.
    $( Subtraction of reciprocals.  (Contributed by Scott Fenton,
       9-Jan-2017.) $)
    subrecd $p |- ( ph ->
      ( ( 1 / A ) - ( 1 / B ) ) = ( ( B - A ) / ( A x. B ) ) ) $=
      ( cc wcel cc0 wne c1 cdiv co cmin cmul wceq subrec syl22anc ) ABHIBJKCHIC
      JKLBMNLCMNONCBONBCPNMNQDFEGBCRS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordering on reals (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Hypothesis for weak deduction theorem to eliminate ` 0 < A ` .
     (Contributed by NM, 15-May-1999.) $)
  elimgt0 $p |- 0 < if ( 0 < A , A , 1 ) $=
    ( cc0 clt wbr c1 cif breq2 0lt1 elimhyp ) BACDZBJAEFZCDBECDAEAKBCGEKBCGHI
    $.

  $( Hypothesis for weak deduction theorem to eliminate ` 0 <_ A ` .
     (Contributed by NM, 30-Jul-1999.) $)
  elimge0 $p |- 0 <_ if ( 0 <_ A , A , 0 ) $=
    ( cc0 cle wbr cif breq2 0re leidi elimhyp ) BACDZBJABEZCDBBCDABAKBCFBKBCFBG
    HI $.

  $( A number is less than itself plus 1.  (Contributed by NM, 20-Aug-2001.) $)
  ltp1 $p |- ( A e. RR -> A < ( A + 1 ) ) $=
    ( c1 cr wcel caddc co clt wbr 1re wa cc0 0lt1 ltaddpos mpbii mpan ) BCDZACD
    ZAABEFGHZIPQJKBGHRLBAMNO $.

  $( A number is less than or equal to itself plus 1.  (Contributed by NM,
     5-Jan-2006.) $)
  lep1 $p |- ( A e. RR -> A <_ ( A + 1 ) ) $=
    ( cr wcel c1 caddc co clt wbr cle ltp1 wi peano2re ltle mpdan mpd ) ABCZAAD
    EFZGHZAQIHZAJPQBCRSKALAQMNO $.

  $( A number minus 1 is less than itself.  (Contributed by NM, 9-Apr-2006.) $)
  ltm1 $p |- ( A e. RR -> ( A - 1 ) < A ) $=
    ( cr wcel c1 cmin co cc0 clt wbr 0lt1 wb 0re 1re mp3an12 mpbii recn subid1d
    ltsub2 breqtrd ) ABCZADEFZAGEFZAHTGDHIZUAUBHIZJGBCDBCTUCUDKLMGDARNOTAAPQS
    $.

  $( A number minus 1 is less than or equal to itself.  (Contributed by Mario
     Carneiro, 2-Oct-2015.) $)
  lem1 $p |- ( A e. RR -> ( A - 1 ) <_ A ) $=
    ( cr wcel c1 cmin co clt wbr cle ltm1 wi peano2rem ltle mpancom mpd ) ABCZA
    DEFZAGHZQAIHZAJQBCPRSKALQAMNO $.

  $( A transitive property of 'less than or equal' and plus 1.  (Contributed by
     NM, 5-Aug-2005.) $)
  letrp1 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) -> A <_ ( B + 1 ) ) $=
    ( cr wcel cle wbr w3a c1 caddc co clt wa adantl peano2re ancli lelttr 3expb
    ltp1 wi sylan2 mpan2d 3impia ltle 3adant3 mpd ) ACDZBCDZABEFZGABHIJZKFZAUIE
    FZUFUGUHUJUFUGLUHBUIKFZUJUGULUFBRMUGUFUGUICDZLUHULLUJSZUGUMBNZOUFUGUMUNABUI
    PQTUAUBUFUGUJUKSZUHUGUFUMUPUOAUIUCTUDUE $.

  $( A transitive property of plus 1 and 'less than or equal'.  (Contributed by
     NM, 16-Aug-2005.) $)
  p1le $p |- ( ( A e. RR /\ B e. RR /\ ( A + 1 ) <_ B ) -> A <_ B ) $=
    ( cr wcel c1 caddc co cle wa lep1 adantr wi peano2re ancli letr 3expa sylan
    wbr mpand 3impia ) ACDZBCDZAEFGZBHRZABHRZUAUBIAUCHRZUDUEUAUFUBAJKUAUAUCCDZI
    UBUFUDIUELZUAUGAMNUAUGUBUHAUCBOPQST $.

  $( The reciprocal of a positive number is positive.  Exercise 4 of [Apostol]
     p. 21.  (Contributed by NM, 25-Aug-1999.)  (Revised by Mario Carneiro,
     27-May-2016.) $)
  recgt0 $p |- ( ( A e. RR /\ 0 < A ) -> 0 < ( 1 / A ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co wceq wn 0re cneg cmul rereccld lt0neg1d
    1re adantr mpbird wo simpl recnd gt0ne0 recne0d necomd neneqd ltnsymi ax-mp
    0lt1 simpll wne renegcld simpr mpbid simplr mulgt0d reccld mulneg1d recid2d
    cc negeqd eqtrd breqtrd a1i ex mtoi ioran sylanbrc wb axlttri sylancr ) ABC
    ZDAEFZGZDHAIJZEFZDVPKZVPDEFZUALZVOVRLVSLVTVODVPVOVPDVOAVOAVMVNUBZUCZAUDZUEU
    FUGVOVSHDEFZDHEFWDLUJDHMRUHUIVOVSWDVOVSGZWDDHNZEFWEDVPNZAOJZWFEWEWGAWEVPWEA
    VMVNVSUKZVOADULVSWCSZPUMWIWEVSDWGEFVOVSUNWEVPVOVPBCZVSVOAWAWCPZSQUOVMVNVSUP
    UQWEWHVPAOJZNWFWEVPAWEAVOAVACVSWBSZWJURWNUSWEWMHWEAWNWJUTVBVCVDWEHHBCWERVEQ
    TVFVGVRVSVHVIVODBCWKVQVTVJMWLDVPVKVLT $.

  $( Infer that a multiplicand is positive from a nonnegative muliplier and
     positive product.  (Contributed by NM, 24-Apr-2005.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  prodgt0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 0 < ( A x. B ) ) )
                 -> 0 < B ) $=
    ( cr wcel wa cc0 cle wbr cmul co clt wceq wo wi 0re simpl cdiv recnd breq2d
    a1i leloed c1 simpll simplr remulcld simprl rereccld simprr recgt0 ad2ant2r
    gt0ne0d mulgt0d divrecd cc simpr adantr divcan3d eqtr3d breqtrd exp32 ltnri
    mul02d mtbiri pm2.21d oveq1 imbi1d syl5ibcom jaod sylbid imp32 ) ACDZBCDZEZ
    FAGHZFABIJZKHZFBKHZVMVNFAKHZFALZMVPVQNZVMFAFCDVMOTVKVLPUAVMVRVTVSVMVRVPVQVM
    VRVPEZEZFVOUBAQJZIJZBKWBVOWCWBABVKVLWAUCZVKVLWAUDUEZWBAWEWBAVMVRVPUFUKZUGVM
    VRVPUHVKVRFWCKHVLVPAUIUJULWBVOAQJWDBWBVOAWBVOWFRWBAWERZWGUMWBBAVMBUNDWAVMBV
    KVLUORZUPWHWGUQURUSUTVMFFBIJZKHZVQNVSVTVMWKVQVMWKFFKHFOVAVMWJFFKVMBWIVBSVCV
    DVSWKVPVQVSWJVOFKFABIVESVFVGVHVIVJ $.

  $( Infer that a multiplier is positive from a nonnegative muliplicand and
     positive product.  (Contributed by NM, 24-Apr-2005.) $)
  prodgt02 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ B /\ 0 < ( A x. B ) ) )
                 -> 0 < A ) $=
    ( cr wcel wa cc0 cle wbr cmul co clt cc wceq mulcom syl2an breq2d biimpd wi
    recn prodgt0 ex ancoms sylan2d imp ) ACDZBCDZEZFBGHZFABIJZKHZEFAKHZUGUJFBAI
    JZKHZUHUKUGUJUMUGUIULFKUEALDBLDUIULMUFASBSABNOPQUFUEUHUMEZUKRUFUEEUNUKBATUA
    UBUCUD $.

  $( Infer that a multiplicand is nonnegative from a positive muliplier and
     nonnegative product.  (Contributed by NM, 2-Jul-2005.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  prodge0 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < A /\ 0 <_ ( A x. B ) ) )
                 -> 0 <_ B ) $=
    ( cr wcel wa cc0 clt wbr cmul co cle wn cneg simpll renegcld recnd lt0neg1d
    simplr 3imtr4d lenltd simprl simprr mulgt0d mulneg2d breqtrd remulcld con3d
    expr 0re a1i impr ) ACDZBCDZEZFAGHZFABIJZKHZFBKHZUNUOEZUPFGHZLBFGHZLUQURUSV
    AUTUSFBMZGHZFUPMZGHZVAUTUNUOVCVEUNUOVCEZEZFAVBIJVDGVGAVBULUMVFNZVGBULUMVFRZ
    OUNUOVCUAUNUOVCUBUCVGABVGAVHPVGBVIPUDUEUHUSBULUMUORZQUSUPUSABULUMUONVJUFZQS
    UGUSFUPFCDUSUIUJZVKTUSFBVLVJTSUK $.

  $( Infer that a multiplier is nonnegative from a positive muliplicand and
     nonnegative product.  (Contributed by NM, 2-Jul-2005.) $)
  prodge02 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 < B /\ 0 <_ ( A x. B ) ) )
                 -> 0 <_ A ) $=
    ( cr wcel wa cc0 clt wbr cmul co cle cc wceq mulcom syl2an breq2d biimpd wi
    recn prodge0 ex ancoms sylan2d imp ) ACDZBCDZEZFBGHZFABIJZKHZEFAKHZUGUJFBAI
    JZKHZUHUKUGUJUMUGUIULFKUEALDBLDUIULMUFASBSABNOPQUFUEUHUMEZUKRUFUEEUNUKBATUA
    UBUCUD $.

  $( Lemma for ~ ltmul1 .  Multiplication of both sides of 'less than' by a
     positive number.  Theorem I.19 of [Apostol] p. 20.  (Contributed by NM,
     15-May-1999.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  ltmul1a $p |- ( ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) /\ A < B )
      -> ( A x. C ) < ( B x. C ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co simpl2 simpl1 resubcld simpl3l posdifd
    cmin recnd remulcld simpr mpbid simpl3r mulgt0d subdird breqtrd mpbird ) AD
    EZBDEZCDEZFCGHZIZJZABGHZIZACKLZBCKLZGHFUQUPRLZGHUOFBARLZCKLURGUOUSCUOBAUHUI
    ULUNMZUHUIULUNNZOUJUKUHUIUNPZUOUNFUSGHUMUNUAUOABVAUTQUBUJUKUHUIUNUCUDUOBACU
    OBUTSUOAVASUOCVBSUEUFUOUPUQUOACVAVBTUOBCUTVBTQUG $.

  $( Multiplication of both sides of 'less than' by a positive number.  Theorem
     I.19 of [Apostol] p. 20.  (Contributed by NM, 13-Feb-2005.)  (Revised by
     Mario Carneiro, 27-May-2016.) $)
  ltmul1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
               -> ( A < B <-> ( A x. C ) < ( B x. C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co ltmul1a ex wceq wo wn remulcld lttrid
    wi oveq1 a1i 3com12 orim12d con3d simp1 simp3l simp2 3imtr4d impbid ) ADEZB
    DEZCDEZFCGHZIZJZABGHZACKLZBCKLZGHZUPUQUTABCMNUPURUSOZUSURGHZPZQABOZBAGHZPZQ
    UTUQUPVFVCUPVDVAVEVBVDVATUPABCKUAUBULUKUOVEVBTULUKUOJVEVBBACMNUCUDUEUPURUSU
    PACUKULUOUFZUKULUMUNUGZRUPBCUKULUOUHZVHRSUPABVGVISUIUJ $.

  $( Multiplication of both sides of 'less than' by a positive number.  Theorem
     I.19 of [Apostol] p. 20.  (Contributed by NM, 13-Feb-2005.) $)
  ltmul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co ltmul1 wb cc recn mulcom sylan 3adant2
    wceq 3adant1 breq12d syl3an3 3adant3r bitrd ) ADEZBDEZCDEZFCGHZIJABGHACKLZB
    CKLZGHZCAKLZCBKLZGHZABCMUFUGUHULUONZUIUHUFUGCOEZUPCPUFUGUQJUJUMUKUNGUFUQUJU
    MTZUGUFAOEUQURAPACQRSUGUQUKUNTZUFUGBOEUQUSBPBCQRUAUBUCUDUE $.

  $( Multiplication of both sides of 'less than or equal to' by a positive
     number.  (Contributed by NM, 21-Feb-2005.) $)
  lemul1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                -> ( A <_ B <-> ( A x. C ) <_ ( B x. C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a wceq wo cmul co cle ltmul1 cc wb recn remulcl
    wne adantr gt0ne0 jca mulcan2 syl3an bicomd orbi12d 3adant3 3adant2 3adant1
    leloe leloed 3adant3r 3bitr4d ) ADEZBDEZCDEZFCGHZIZJZABGHZABKZLZACMNZBCMNZG
    HZVEVFKZLZABOHZVEVFOHZVAVBVGVCVHABCPVAVHVCUPAQEUQBQEUTCQEZCFUAZIVHVCRASBSUT
    VLVMURVLUSCSUBCUCUDABCUEUFUGUHUPUQVJVDRUTABULUIUPUQURVKVIRUSUPUQURJVEVFUPUR
    VEDEUQACTUJUQURVFDEUPBCTUKUMUNUO $.

  $( Multiplication of both sides of 'less than or equal to' by a positive
     number.  (Contributed by NM, 16-Mar-2005.) $)
  lemul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
               -> ( A <_ B <-> ( C x. A ) <_ ( C x. B ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cle cmul co lemul1 wb wceq recn mulcom syl2an
    cc 3adant2 3adant1 breq12d 3adant3r bitrd ) ADEZBDEZCDEZFCGHZIJABKHACLMZBCL
    MZKHZCALMZCBLMZKHZABCNUFUGUHULUOOUIUFUGUHJUJUMUKUNKUFUHUJUMPZUGUFATECTEZUPU
    HAQCQZACRSUAUGUHUKUNPZUFUGBTEUQUSUHBQURBCRSUBUCUDUE $.

  $( Multiplication of both sides of 'less than or equal to' by a nonnegative
     number.  (Contributed by NM, 21-Feb-2005.) $)
  lemul1a $p |- ( ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 <_ C ) ) /\
                 A <_ B ) -> ( A x. C ) <_ ( B x. C ) ) $=
    ( cr wcel cc0 cle wbr wa w3a cmul co clt wceq 0re com12 recn mul01d oveq2
    wi wo leloe mpan pm5.32i lemul1 biimpd 3expia leidi breqan12d mpbiri syl5ib
    wb breq12d a1dd adantl jaodan sylbi 3impia imp ) ADEZBDEZCDEZFCGHZIZJABGHZA
    CKLZBCKLZGHZUTVAVDVEVHTZVDUTVAIZVIVDVBFCMHZFCNZUAZIVJVITZVBVCVMFDEVBVCVMULO
    FCUBUCUDVBVKVNVLVJVBVKIZVIUTVAVOVIUTVAVOJVEVHABCUEUFUGPVLVNVBVLVJVHVEVJAFKL
    ZBFKLZGHZVLVHVJVRFFGHFOUHUTVAVPFVQFGUTAAQRVABBQRUIUJVLVPVFVQVGGFCAKSFCBKSUM
    UKUNUOUPUQPURUS $.

  $( Multiplication of both sides of 'less than or equal to' by a nonnegative
     number.  (Contributed by Paul Chapman, 7-Sep-2007.) $)
  lemul2a $p |- ( ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 <_ C ) ) /\
                      A <_ B ) -> ( C x. A ) <_ ( C x. B ) ) $=
    ( cr wcel cc0 cle wbr wa cmul co lemul1a wceq cc recn mulcom syl2an adantrr
    w3a adantr 3adant2 3adant1 3brtr3d ) ADEZBDEZCDEZFCGHZIZSZABGHZIACJKZBCJKZC
    AJKZCBJKZGABCLUIUKUMMZUJUDUHUOUEUDUFUOUGUDANECNEZUOUFAOCOZACPQRUATUIULUNMZU
    JUEUHURUDUEUFURUGUEBNEUPURUFBOUQBCPQRUBTUC $.

  $( Comparison of product of two positive numbers.  (Contributed by NM,
     30-Dec-2005.) $)
  ltmul12a $p |- ( ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ A < B ) ) /\
               ( ( C e. RR /\ D e. RR ) /\ ( 0 <_ C /\ C < D ) ) ) ->
                 ( A x. C ) < ( B x. D ) ) $=
    ( cr wcel cc0 cle wbr clt cmul simpllr ad2ant2l imp ad2ant2r lelttr remulcl
    wa co wi simplll simpll simprl jca ltle adantrl lemul1a syl31anc wb simplrl
    simplrr 0re mp3an1 adantlr ltmul2 syl112anc biimpa anasss ad2ant2lr syl3anc
    adantrrl adantr mp2and an4s ) AEFZBEFZRZCEFZDEFZRZGAHIZABJIZRZGCHIZCDJIZRZA
    CKSZBDKSZJIZVGVJRZVMVPRZRZVQBCKSZHIZWCVRJIZVSWBVEVFVHVNRZABHIZWDVEVFVJWAUAV
    EVFVJWALVJVPWFVGVMVJVPRVHVNVHVIVPUBVJVNVOUCUDMVGVMWGVJVPVGVLWGVKVGVLWGABUEN
    UFOABCUGUHVTVMVOWEVNVTVMVOWEVTVMRZVOWEWHVHVIVFGBJIZVOWEUIVGVHVIVMUJVGVHVIVM
    UKVEVFVJVMLVGVMWIVJVGVMWIGEFVEVFVMWITULGABPUMNUNCDBUOUPUQURVAVTWDWERVSTZWAV
    TVQEFZWCEFZVREFZWJVEVHWKVFVIACQOVFVHWLVEVIBCQUSVFVIWMVEVHBDQMVQWCVRPUTVBVCV
    D $.

  $( Comparison of product of two nonnegative numbers.  (Contributed by NM,
     22-Feb-2008.) $)
  lemul12b $p |- ( ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR ) /\
       ( C e. RR /\ ( D e. RR /\ 0 <_ D ) ) ) -> ( ( A <_ B /\ C <_ D ) ->
                 ( A x. C ) <_ ( B x. D ) ) ) $=
    ( cr wcel cc0 cle wbr wa cmul co wi w3a lemul2a ex adantlr remulcl ad2ant2r
    3comr 3expb adantrrr lemul1a 3expa adantllr adantrl anim12d ancomsd adantrr
    ad2ant2rl ad2ant2l letr syl3anc syld ) AEFZGAHIZJZBEFZJZCEFZDEFZGDHIZJZJZJZ
    ABHIZCDHIZJACKLZADKLZHIZVIBDKLZHIZJZVHVKHIZVEVGVFVMVEVGVJVFVLUQVDVGVJMZURUQ
    UTVAVOVBUQUTVAVOUTVAUQVOUTVAUQNVGVJCDAOPTUAUBQUSVCVFVLMZUTUOURVCVPUPUOURVCV
    PUOURVCNVFVLABDUCPUDUEUFUGUHVEVHEFZVIEFZVKEFZVMVNMUQUTVQURVCUOUTVQUPACRQSUQ
    VCVRURUTUOVAVRUPVBADRSUJURVCVSUQUTURVAVSVBBDRUIUKVHVIVKULUMUN $.

  $( Comparison of product of two nonnegative numbers.  (Contributed by NM,
     22-Feb-2008.) $)
  lemul12a $p |- ( ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR ) /\
       ( ( C e. RR /\ 0 <_ C ) /\ D e. RR ) ) -> ( ( A <_ B /\ C <_ D ) ->
                 ( A x. C ) <_ ( B x. D ) ) ) $=
    ( cr wcel cc0 cle wbr wa cmul co simpll ad2antlr simplrr wi 0re letr mp3an1
    exp4b com23 imp41 ad2ant2l jca jca32 simpr lemul12b sylc ex ) AEFGAHIJBEFJZ
    CEFZGCHIZJZDEFZJZJZABHIZCDHIZJZACKLBDKLHIZUPUSJZUJUKUNGDHIZJZJJUSUTVAUJUKVC
    UJUOUSMUOUKUJUSUKULUNMNVAUNVBUJUMUNUSOUOURVBUJUQUKULUNURVBUKUNULURVBPUKUNUL
    URVBGEFUKUNULURJVBPQGCDRSTUAUBUCUDUEUPUSUFABCDUGUHUI $.

  $( The product of two numbers greater than 1 is greater than 1.  (Contributed
     by NM, 13-Feb-2005.) $)
  mulgt1 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 1 < A /\ 1 < B ) ) ->
                1 < ( A x. B ) ) $=
    ( cr wcel wa c1 clt wbr cmul co wi a1i cc0 0lt1 1re lttr adantr mp3an1 syld
    simpl 0re mp3an12 mpani w3a ltmul2 biimpd exp32 impcom imp3a ax-1rid breq1d
    wceq sylibd jcad remulcl syldan imp ) ACDZBCDZEZFAGHZFBGHZEZFABIJZGHZUTVCVA
    AVDGHZEZVEUTVCVAVFVCVAKUTVAVBTLUTVCAFIJZVDGHZVFUTVAVBVIUTVAMAGHZVBVIKZURVAV
    JKUSURMFGHZVAVJNMCDFCDZURVLVAEVJKUAOMFAPUBUCQUSURVJVKKUSURVJVKVMUSURVJEZVKO
    VMUSVNUDVBVIFBAUEUFRUGUHSUIUTVHAVDGURVHAULUSAUJQUKUMUNURUSVDCDZVGVEKZABUOVM
    URVOVPOFAVDPRUPSUQ $.

  $( Multiplication by a number greater than 1.  (Contributed by NM,
     24-Dec-2005.) $)
  ltmulgt11 $p |- ( ( A e. RR /\ B e. RR /\ 0 < A ) ->
                ( 1 < B <-> A < ( A x. B ) ) ) $=
    ( cr wcel cc0 clt wbr w3a c1 cmul co wb 1re ltmul2 mp3an1 3impb 3com12 wceq
    wa ax-1rid 3ad2ant1 breq1d bitrd ) ACDZBCDZEAFGZHZIBFGZAIJKZABJKZFGZAUJFGUE
    UDUFUHUKLZUEUDUFULICDUEUDUFSULMIBANOPQUGUIAUJFUDUEUIARUFATUAUBUC $.

  $( Multiplication by a number greater than 1.  (Contributed by NM,
     24-Dec-2005.) $)
  ltmulgt12 $p |- ( ( A e. RR /\ B e. RR /\ 0 < A ) ->
                ( 1 < B <-> A < ( B x. A ) ) ) $=
    ( cr wcel cc0 clt wbr w3a c1 cmul ltmulgt11 wceq recn mulcom syl2an 3adant3
    co cc breq2d bitrd ) ACDZBCDZEAFGZHZIBFGAABJQZFGABAJQZFGABKUDUEUFAFUAUBUEUF
    LZUCUAARDBRDUGUBAMBMABNOPST $.

  $( Multiplication by a number greater than or equal to 1.  (Contributed by
     NM, 17-Dec-2005.) $)
  lemulge11 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 1 <_ B ) ) ->
                A <_ ( A x. B ) ) $=
    ( cr wcel wa cc0 cle wbr c1 cmul co wceq ax-1rid ad2antrr simpll simprl jca
    simplr 1re 0le1 pm3.2i jctil jca31 leid simprr lemul12a sylc eqbrtrrd ) ACD
    ZBCDZEZFAGHZIBGHZEZEZAIJKZAABJKZGUIUPALUJUNAMNUOUIULEZUIEICDZFIGHZEZUJEZEAA
    GHZUMEUPUQGHUOURUIVBUOUIULUIUJUNOZUKULUMPQVDUOUJVAUIUJUNRUSUTSTUAUBUCUOVCUM
    UIVCUJUNAUDNUKULUMUEQAAIBUFUGUH $.

  $( Multiplication by a number greater than or equal to 1.  (Contributed by
     Paul Chapman, 21-Mar-2011.) $)
  lemulge12 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ 1 <_ B ) ) ->
                    A <_ ( B x. A ) ) $=
    ( cr wcel wa cc0 cle wbr c1 cmul co lemulge11 wb cc wceq recn mulcom syl2an
    breq2d adantr mpbid ) ACDZBCDZEZFAGHIBGHEZEAABJKZGHZABAJKZGHZABLUDUGUIMUEUD
    UFUHAGUBANDBNDUFUHOUCAPBPABQRSTUA $.

  $( Division of both sides of 'less than' by a positive number.  (Contributed
     by NM, 10-Oct-2004.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  ltdiv1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
               ( A < B <-> ( A / C ) < ( B / C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a c1 cdiv co wb simp1 simp2 simp3l recnd divrecd
    cmul simp3r gt0ne0d rereccld recgt0 3ad2ant3 ltmul1 syl112anc breq12d
    bitr4d ) ADEZBDEZCDEZFCGHZIZJZABGHZAKCLMZTMZBUQTMZGHZACLMZBCLMZGHUOUJUKUQDE
    FUQGHZUPUTNUJUKUNOZUJUKUNPZUOCUJUKULUMQZUOCUJUKULUMUAUBZUCUNUJVCUKCUDUEABUQ
    UFUGUOVAURVBUSGUOACUOAVDRUOCVFRZVGSUOBCUOBVERVHVGSUHUI $.

  $( Division of both sides of a less than or equal to relation by a positive
     number.  (Contributed by NM, 18-Nov-2004.) $)
  lediv1 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
               ( A <_ B <-> ( A / C ) <_ ( B / C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a wn cdiv co cle ltdiv1 3adant1 redivcl syld3an3
    wb 3expb 3com12 notbid lenlt 3adant3 wne gt0ne0 3adant2 lenltd 3bitr4d ) AD
    EZBDEZCDEZFCGHZIZJZBAGHZKZBCLMZACLMZGHZKABNHZUSURNHUOUPUTUKUJUNUPUTSBACOUAU
    BUJUKVAUQSUNABUCUDUOUSURUJUNUSDEZUKUJULUMVBUJULUMCFUEZVBULUMVCUJCUFZPACQRTU
    GUKUNURDEZUJUKULUMVEUKULUMVCVEULUMVCUKVDPBCQRTPUHUI $.

  $( Division of a positive number by a positive number.  (Contributed by NM,
     28-Sep-2005.) $)
  gt0div $p |- ( ( A e. RR /\ B e. RR /\ 0 < B ) ->
               ( 0 < A <-> 0 < ( A / B ) ) ) $=
    ( cr wcel cc0 clt wbr w3a cdiv co wb wa 0re ltdiv1 mp3an1 3impb wceq gt0ne0
    wne cc recn div0 sylan syldan breq1d 3adant1 bitrd ) ACDZBCDZEBFGZHEAFGZEBI
    JZABIJZFGZEUMFGZUHUIUJUKUNKZECDUHUIUJLZUPMEABNOPUIUJUNUOKUHUQULEUMFUIUJBESZ
    ULEQZBRUIBTDURUSBUABUBUCUDUEUFUG $.

  $( Division of a nonnegative number by a positive number.  (Contributed by
     NM, 28-Sep-2005.) $)
  ge0div $p |- ( ( A e. RR /\ B e. RR /\ 0 < B ) ->
               ( 0 <_ A <-> 0 <_ ( A / B ) ) ) $=
    ( cr wcel cc0 clt wbr w3a cle cdiv co wb 0re lediv1 mp3an1 3impb wne gt0ne0
    wa wceq cc recn div0 sylan syldan breq1d 3adant1 bitrd ) ACDZBCDZEBFGZHEAIG
    ZEBJKZABJKZIGZEUNIGZUIUJUKULUOLZECDUIUJUKSZUQMEABNOPUJUKUOUPLUIURUMEUNIUJUK
    BEQZUMETZBRUJBUADUSUTBUBBUCUDUEUFUGUH $.

  $( The ratio of two positive numbers is positive.  (Contributed by NM,
     12-Oct-1999.) $)
  divgt0 $p |- ( ( ( A e. RR /\ 0 < A ) /\
             ( B e. RR /\ 0 < B ) ) -> 0 < ( A / B ) ) $=
    ( cr wcel cc0 clt wbr cdiv co wi w3a gt0div biimpd 3exp com34 com23 imp43 )
    ACDZEAFGZBCDZEBFGZEABHIFGZRTSUAUBJRTUASUBRTUASUBJRTUAKSUBABLMNOPQ $.

  $( The ratio of nonnegative and positive numbers is nonnegative.
     (Contributed by NM, 27-Sep-1999.) $)
  divge0 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\
             ( B e. RR /\ 0 < B ) ) -> 0 <_ ( A / B ) ) $=
    ( cr wcel cc0 cle wbr clt cdiv co w3a ge0div biimpd 3exp com34 com23 imp43
    wi ) ACDZEAFGZBCDZEBHGZEABIJFGZSUATUBUCRSUAUBTUCSUAUBTUCRSUAUBKTUCABLMNOPQ
    $.

  $( 'Less than' relationship between division and multiplication.
     (Contributed by NM, 12-Oct-1999.)  (Proof shortened by Mario Carneiro,
     27-May-2016.) $)
  ltmuldiv $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                -> ( ( A x. C ) < B <-> A < ( B / C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co cdiv wb simp1 simp3l remulcld syld3an1
    ltdiv1 recnd simp3r gt0ne0d divcan4d breq1d bitrd ) ADEZBDEZCDEZFCGHZIZJZAC
    KLZBGHZULCMLZBCMLZGHZAUOGHULDEUGUFUJUMUPNUKACUFUGUJOZUFUGUHUIPZQULBCSRUKUNA
    UOGUKACUKAUQTUKCURTUKCUFUGUHUIUAUBUCUDUE $.

  $( 'Less than' relationship between division and multiplication.
     (Contributed by NM, 18-Nov-2004.) $)
  ltmuldiv2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                   -> ( ( C x. A ) < B <-> A < ( B / C ) ) ) $=
    ( cr wcel cc0 clt wbr wa cmul co cdiv wceq cc mulcom syl2an adantrr 3adant2
    w3a recn breq1d ltmuldiv bitr3d ) ADEZBDEZCDEZFCGHZIZSZACJKZBGHCAJKZBGHABCL
    KGHUIUJUKBGUDUHUJUKMZUEUDUFULUGUDANECNEULUFATCTACOPQRUAABCUBUC $.

  $( 'Less than' relationship between division and multiplication.
     (Contributed by NM, 18-Nov-2004.) $)
  ltdivmul $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
              -> ( ( A / C ) < B <-> A < ( C x. B ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co cdiv wb remulcl ancoms adantrr 3adant1
    cc recn ltdiv1 syld3an2 wceq adantr ad2antrl gt0ne0 adantl divcan3d breq2d
    wne bitr2d ) ADEZBDEZCDEZFCGHZIZJZACBKLZGHZACMLZURCMLZGHZUTBGHULURDEZUMUPUS
    VBNUMUPVCULUMUNVCUOUNUMVCCBOPQRAURCUAUBUQVABUTGUMUPVABUCULUMUPIBCUMBSEUPBTU
    DUNCSEUMUOCTUEUPCFUJUMCUFUGUHRUIUK $.

  $( 'Less than or equal to' relationship between division and multiplication.
     (Contributed by NM, 9-Dec-2005.) $)
  ledivmul $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                  ( ( A / C ) <_ B <-> A <_ ( C x. B ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co cdiv wb remulcl ancoms 3adant1 cc recn
    cle adantrr lediv1 syld3an2 wceq adantr ad2antrl wne gt0ne0 adantl divcan3d
    breq2d bitr2d ) ADEZBDEZCDEZFCGHZIZJZACBKLZTHZACMLZUSCMLZTHZVABTHUMUSDEZUNU
    QUTVCNUNUQVDUMUNUOVDUPUOUNVDCBOPUAQAUSCUBUCURVBBVATUNUQVBBUDUMUNUQIBCUNBREU
    QBSUEUOCREUNUPCSUFUQCFUGUNCUHUIUJQUKUL $.

  $( 'Less than or equal to' relationship between division and multiplication.
     (Contributed by NM, 9-Dec-2005.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ledivmulOLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < B ) ->
                  ( ( A / B ) <_ C <-> A <_ ( B x. C ) ) ) $=
    ( cr wcel w3a cc0 clt wbr wa cmul co cle cdiv wb simp1 3adant1 wi cc recn
    remulcl simp2 3jca simpl1 simpl2 simp3 id anim12i lediv1 syl3anc sylan wceq
    wne gt0ne0 ex adantr divcan3 3com12 3expia syl2an syld imp breq2d bitr2d )
    ADEZBDEZCDEZFZGBHIZJZABCKLZMIZABNLZVKBNLZMIZVMCMIVHVEVKDEZVFFZVIVLVOOZVHVEV
    PVFVEVFVGPVFVGVPVEBCUAQVEVFVGUBUCVQVIJVEVPVFVIJVRVEVPVFVIUDVEVPVFVIUEVQVFVI
    VIVEVPVFUFVIUGUHAVKBUIUJUKVJVNCVMMVHVIVNCULZVFVGVIVSRVEVFVGJVIBGUMZVSVFVIVT
    RVGVFVIVTBUNUOUPVFBSEZCSEZVTVSRVGBTCTWAWBVTVSWBWAVTVSCBUQURUSUTVAQVBVCVD $.

  $( 'Less than' relationship between division and multiplication.
     (Contributed by NM, 24-Feb-2005.) $)
  ltdivmul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) )
                 -> ( ( A / C ) < B <-> A < ( B x. C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cdiv co cmul ltdivmul wceq recn mulcom adantrr
    cc syl2an 3adant1 breq2d bitr4d ) ADEZBDEZCDEZFCGHZIZJZACKLBGHACBMLZGHABCML
    ZGHABCNUIUKUJAGUEUHUKUJOZUDUEUFULUGUEBSECSEULUFBPCPBCQTRUAUBUC $.

  $( 'Less than' relationship between division and multiplication.
     (Contributed by NM, 8-Jan-2006.) $)
  lt2mul2div $p |- ( ( ( A e. RR /\ ( B e. RR /\ 0 < B ) )
                   /\ ( C e. RR /\ ( D e. RR /\ 0 < D ) ) ) ->
                    ( ( A x. B ) < ( C x. D ) <-> ( A / D ) < ( C / B ) ) ) $=
    ( cr wcel cc0 clt wbr wa cmul co cdiv wceq recn adantl adantr jca syl3anc
    cc mulcom syl2an oveq1d wne ad2antll ad2antrl gt0ne0 eqtrd adantrrr adantll
    divass breq2d wb simpll remulcl adantrr simplr ltmuldiv simpl redivcl 3expb
    sylan2 ancoms ad2ant2lr simprr ltdivmul 3bitr4d ) AEFZBEFZGBHIZJZJZCEFZDEFZ
    GDHIZJZJZJZACDKLZBMLZHIZADCBMLZKLZHIZABKLVSHIZADMLWBHIZVRVTWCAHVKVQVTWCNZVH
    VKVMVNWGVOVKVMVNJZJZVTDCKLZBMLZWCWHVTWKNVKWHVSWJBMVMCTFZDTFZVSWJNVNCOZDOZCD
    UAUBUCPWIWMWLBTFZBGUDZJZWKWCNVNWMVKVMWOUEVMWLVKVNWNUFVKWRWHVKWPWQVIWPVJBOQB
    UGZRQDCBUKSUHUIUJULVRVHVSEFZVKWEWAUMVHVKVQUNZVQWTVLVMVNWTVOCDUOUPPVHVKVQUQA
    VSBURSVRVHWBEFZVPWFWDUMXAVKVMXBVHVPVMVKXBVKVMVIWQJXBVKVIWQVIVJUSWSRVMVIWQXB
    CBUTVAVBVCVDVLVMVPVEAWBDVFSVG $.

  $( 'Less than or equal to' relationship between division and multiplication.
     (Contributed by NM, 9-Dec-2005.) $)
  ledivmul2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                  ( ( A / C ) <_ B <-> A <_ ( B x. C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cdiv cle cmul ledivmul wceq recn mulcom syl2an
    co cc adantrr 3adant1 breq2d bitr4d ) ADEZBDEZCDEZFCGHZIZJZACKSBLHACBMSZLHA
    BCMSZLHABCNUJULUKALUFUIULUKOZUEUFUGUMUHUFBTECTEUMUGBPCPBCQRUAUBUCUD $.

  $( 'Less than or equal to' relationship between division and multiplication.
     (Contributed by NM, 9-Dec-2005.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ledivmul2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\ 0 < B ) ->
                  ( ( A / B ) <_ C <-> A <_ ( C x. B ) ) ) $=
    ( cr wcel w3a cc0 clt wbr wa cdiv co cle cmul wb simpl1 simpl3 simp2 recn
    cc anim12i ledivmul syl3anc wceq mulcom syl2an 3adant1 adantr breq2d bitrd
    id ) ADEZBDEZCDEZFZGBHIZJZABKLCMIZABCNLZMIZACBNLZMIUQULUNUMUPJURUTOULUMUNUP
    PULUMUNUPQUOUMUPUPULUMUNRUPUKUAACBUBUCUQUSVAAMUOUSVAUDZUPUMUNVBULUMBTECTEVB
    UNBSCSBCUEUFUGUHUIUJ $.

  $( 'Less than or equal' relationship between division and multiplication.
     (Contributed by NM, 10-Mar-2006.) $)
  lemuldiv $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                  ( ( A x. C ) <_ B <-> A <_ ( B / C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cdiv co wn cmul cle wb ltdivmul2 3com12 lenltd
    3adant1 notbid simp1 gt0ne0 redivcl syld3an3 3expb remulcl 3adant2 3adant3r
    wne simp2 3bitr4rd ) ADEZBDEZCDEZFCGHZIZJZBCKLZAGHZMBACNLZGHZMZAUSOHVABOHZU
    RUTVBUNUMUQUTVBPBACQRUAURAUSUMUNUQUBUNUQUSDEZUMUNUOUPVEUNUOUPCFUJZVEUOUPVFU
    NCUCTBCUDUEUFTSUMUNUOVDVCPUPUMUNUOJVABUMUOVADEUNACUGUHUMUNUOUKSUIUL $.

  $( 'Less than or equal' relationship between division and multiplication.
     (Contributed by NM, 10-Mar-2006.) $)
  lemuldiv2 $p |- ( ( A e. RR /\ B e. RR /\ ( C e. RR /\ 0 < C ) ) ->
                      ( ( C x. A ) <_ B <-> A <_ ( B / C ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cmul co cle cdiv wceq cc mulcom syl2an adantrr
    recn 3adant2 breq1d lemuldiv bitr3d ) ADEZBDEZCDEZFCGHZIZJZACKLZBMHCAKLZBMH
    ABCNLMHUJUKULBMUEUIUKULOZUFUEUGUMUHUEAPECPEUMUGATCTACQRSUAUBABCUCUD $.

  $( The reciprocal of both sides of 'less than'.  (Contributed by NM,
     26-Sep-1999.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  ltrec $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( A < B <-> ( 1 / B ) < ( 1 / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co cmul wb 1re a1i simprl simpll syl112anc
    simplr recnd ltmuldiv mulid2d breq1d gt0ne0d divrecd breq2d rereccld simprr
    3bitr3d ltdivmul bitr4d ) ACDZEAFGZHZBCDZEBFGZHZHZABFGZIBIAJKZLKZFGZIBJKUTF
    GZURIALKZBFGZIBAJKZFGZUSVBURICDZUOULUMVEVGMVHURNOZUNUOUPPZULUMUQQZULUMUQSZI
    BAUARURVDABFURAURAVKTZUBUCURVFVAIFURBAURBVJTVMURAVLUDZUEUFUIURVHUTCDUOUPVCV
    BMVIURAVKVNUGVJUNUOUPUHIUTBUJRUK $.

  $( The reciprocal of both sides of 'less than or equal to'.  (Contributed by
     NM, 3-Oct-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  lerec $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( A <_ B <-> ( 1 / B ) <_ ( 1 / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa wn c1 co cle wb ltrec ancoms notbid lenltd gt0ne0d
    cdiv rereccld simpll simprl simprr simplr 3bitr4d ) ACDZEAFGZHZBCDZEBFGZHZH
    ZBAFGZIJASKZJBSKZFGZIABLGUOUNLGULUMUPUKUHUMUPMBANOPULABUFUGUKUAZUHUIUJUBZQU
    LUOUNULBURULBUHUIUJUCRTULAUQULAUFUGUKUDRTQUE $.

  $( Lemma for ~ lt2msq .  (Contributed by Mario Carneiro, 27-May-2016.) $)
  lt2msq1 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR /\ A < B ) ->
                  ( A x. A ) < ( B x. B ) ) $=
    ( cr wcel cc0 cle wbr wa clt w3a co simp1l remulcld simp2 simp1 simp3 ltled
    cmul lemul1a lelttrd syl31anc wb 0re a1i simp1r ltmul2 syl112anc mpbid ) AC
    DZEAFGZHZBCDZABIGZJZAARKZBARKZBBRKZUNAAUIUJULUMLZURMUNBAUKULUMNZURMUNBBUSUS
    MUNUIULUKABFGUOUPFGURUSUKULUMOUNABURUSUKULUMPZQABASUAUNUMUPUQIGZUTUNUIULULE
    BIGUMVAUBURUSUSUNEABECDUNUCUDURUSUIUJULUMUEUTTABBUFUGUHT $.

  $( Two nonnegative numbers compare the same as their squares.  (Contributed
     by Roy F. Longton, 8-Aug-2005.)  (Revised by Mario Carneiro,
     27-May-2016.) $)
  lt2msq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
                  ( A < B <-> ( A x. A ) < ( B x. B ) ) ) $=
    ( cr wcel cc0 cle wbr wa cmul co wi lt2msq1 3expia adantrr wceq wo remulcld
    clt wn lttrid oveq12d a1i ancoms orim12d con3d simpll simprl 3imtr4d impbid
    id ) ACDZEAFGZHZBCDZEBFGZHZHZABRGZAAIJZBBIJZRGZUMUNURVAKUOUMUNURVAABLMNUQUS
    UTOZUTUSRGZPZSABOZBARGZPZSVAURUQVGVDUQVEVBVFVCVEVBKUQVEABABIVEUJZVHUAUBUPUM
    VFVCKZUPUKVIULUPUKVFVCBALMNUCUDUEUQUSUTUQAAUKULUPUFZVJQUQBBUMUNUOUGZVKQTUQA
    BVJVKTUHUI $.

  $( Division of a positive number by both sides of 'less than'.  (Contributed
     by NM, 27-Apr-2005.) $)
  ltdiv2 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
    ( C e. RR /\ 0 < C ) ) -> ( A < B <-> ( C / B ) < ( C / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a c1 cdiv co wb 3adant3 cmul wne cc recn adantr
    ltrec gt0ne0 rereccl syldan ltmul2 syl3an2 syl3an1 jca divrec 3expb 3adant2
    wceq breq12d syl3an 3coml bitr4d 3com12 bitrd ) ADEZFAGHZIZBDEZFBGHZIZCDEZF
    CGHZIZJABGHZKBLMZKALMZGHZCBLMZCALMZGHZVAVDVHVKNVGABUAOVDVAVGVKVNNVDVAVGJVKC
    VIPMZCVJPMZGHZVNVDVIDEZVAVGVKVQNZVBVCBFQZVRBUBZBUCUDVAVRVJDEZVGVSUSUTAFQZWB
    AUBZAUCUDVIVJCUEUFUGVGVDVAVNVQNZVGCREZVDBREZVTIZVAAREZWCIZWEVEWFVFCSTVDWGVT
    VBWGVCBSTWAUHVAWIWCUSWIUTASTWDUHWFWHWJJVLVOVMVPGWFWHVLVOULZWJWFWGVTWKCBUIUJ
    OWFWJVMVPULZWHWFWIWCWLCAUIUJUKUMUNUOUPUQUR $.

  $( Division of a positive number by both sides of 'less than'.  (Contributed
     by NM, 27-Apr-2005.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  ltdiv2OLD $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
      ( 0 < A /\ 0 < B /\ 0 < C ) ) -> ( A < B <-> ( C / B ) < ( C / A ) ) ) $=
    ( cr wcel w3a cc0 clt wbr wa cdiv co wb an6 ltdiv2 sylbi ) ADEZBDEZCDEZFGAH
    IZGBHIZGCHIZFJQTJRUAJSUBJFABHICBKLCAKLHIMQRSTUAUBNABCOP $.

  $( Reciprocal swap in a 'less than' relation.  (Contributed by NM,
     24-Feb-2005.) $)
  ltrec1 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( ( 1 / A ) < B <-> ( 1 / B ) < A ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co wb wne gt0ne0 rereccl syldan recgt0 jca
    ltrec sylan wceq cc recn recrec adantr breq2d bitrd ) ACDZEAFGZHZBCDEBFGHZH
    ZIAJKZBFGZIBJKZIUMJKZFGZUOAFGUJUMCDZEUMFGZHUKUNUQLUJURUSUHUIAEMZURANZAOPAQR
    UMBSTULUPAUOFUJUPAUAZUKUHUIUTVBVAUHAUBDUTVBAUCAUDTPUEUFUG $.

  $( Reciprocal swap in a 'less than or equal to' relation.  (Contributed by
     NM, 24-Feb-2005.) $)
  lerec2 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) ->
              ( A <_ ( 1 / B ) <-> B <_ ( 1 / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co cle wb wne gt0ne0 rereccl syldan recgt0
    jca lerec sylan2 wceq cc recn recrec sylan adantl breq1d bitrd ) ACDEAFGHZB
    CDZEBFGZHZHZAIBJKZLGZIUOJKZIAJKZLGZBURLGUMUJUOCDZEUOFGZHUPUSMUMUTVAUKULBENZ
    UTBOZBPQBRSAUOTUAUNUQBURLUMUQBUBZUJUKULVBVDVCUKBUCDVBVDBUDBUEUFQUGUHUI $.

  $( Invert ratios of positive numbers and swap their ordering.  (Contributed
     by NM, 9-Jan-2006.) $)
  ledivdiv $p |- ( ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) ) /\
                      ( ( C e. RR /\ 0 < C ) /\ ( D e. RR /\ 0 < D ) ) ) ->
                  ( ( A / B ) <_ ( C / D ) <-> ( D / C ) <_ ( B / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa cdiv co cle wne gt0ne0 jca syl2an cc recn adantr
    c1 wb simpl redivcl 3expb sylan2 adantlr divgt0 lerec wceq breqan12rd bitrd
    recdiv ) AEFZGAHIZJZBEFZGBHIZJZJZCEFZGCHIZJZDEFZGDHIZJZJZJABKLZCDKLZMIZUAVI
    KLZUAVHKLZMIZDCKLZBAKLZMIUTVHEFZGVHHIZJVIEFZGVIHIZJVJVMUBVGUTVPVQUNUSVPUOUS
    UNUQBGNZJVPUSUQVTUQURUCBOZPUNUQVTVPABUDUEUFUGABUHPVGVRVSVAVFVRVBVFVAVDDGNZJ
    VRVFVDWBVDVEUCDOZPVAVDWBVRCDUDUEUFUGCDUHPVHVIUIQVGUTVKVNVLVOMVCCRFZCGNZJDRF
    ZWBJVKVNUJVFVCWDWEVAWDVBCSTCOPVFWFWBVDWFVEDSTWCPCDUMQUPARFZAGNZJBRFZVTJVLVO
    UJUSUPWGWHUNWGUOASTAOPUSWIVTUQWIURBSTWAPABUMQUKUL $.

  $( Division of a positive number by both sides of 'less than or equal to'.
     (Contributed by NM, 10-Jan-2006.) $)
  lediv2 $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
       ( C e. RR /\ 0 < C ) ) -> ( A <_ B <-> ( C / B ) <_ ( C / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa w3a c1 cdiv co cle cmul wb wne gt0ne0 cc recn wceq
    rereccl syldan 3ad2ant2 simp3l simp3r lemul2 syl112anc lerec 3adant3 adantr
    3ad2ant1 jca divrec 3expb syl2an 3adant2 breq12d 3coml 3adant3r 3bitr4d ) A
    DEZFAGHZIZBDEZFBGHZIZCDEZFCGHZIZJZKBLMZKALMZNHZCVLOMZCVMOMZNHZABNHZCBLMZCAL
    MZNHZVKVLDEZVMDEZVHVIVNVQPVGVDWBVJVEVFBFQZWBBRZBUBUCUDVDVGWCVJVBVCAFQZWCARZ
    AUBUCULVDVGVHVIUEVDVGVHVIUFVLVMCUGUHVDVGVRVNPVJABUIUJVDVGVHWAVQPZVIVHVDVGWH
    VHVDVGJVSVOVTVPNVHVGVSVOUAZVDVHCSEZBSEZWDIWIVGCTZVGWKWDVEWKVFBTUKWEUMWJWKWD
    WICBUNUOUPUQVHVDVTVPUAZVGVHWJASEZWFIWMVDWLVDWNWFVBWNVCATUKWGUMWJWNWFWMCAUNU
    OUPUJURUSUTVA $.

  $( Swap denominator with other side of 'less than'.  (Contributed by NM,
     3-Oct-1999.) $)
  ltdiv23 $p |- ( ( A e. RR /\ ( B e. RR /\ 0 < B ) /\ ( C e. RR /\ 0 < C ) )
              -> ( ( A / B ) < C <-> ( A / C ) < B ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cdiv co cmul wb wne gt0ne0 jca 3expb cc recn
    simpl redivcl sylan2 3adant3 simp3 simp2 ltmul1 3adant3r wceq adantr adantl
    syl3anc ad2antrl breq1d remulcl ancoms adantrr 3adant1 ltdiv1 syl2an breq2d
    divcan1d syld3an2 divcan3 bitrd 3adant2r 3bitrd ) ADEZBDEZFBGHZIZCDEZFCGHZI
    ZJZABKLZCGHZVPBMLZCBMLZGHZAVSGHZACKLZBGHZVHVKVLVQVTNZVMVHVKVLJVPDEZVLVKWDVH
    VKWEVLVKVHVIBFOZIWEVKVIWFVIVJUABPZQVHVIWFWEABUBRUCUDVHVKVLUEVHVKVLUFVPCBUGU
    LUHVOVRAVSGVHVKVRAUIVNVHVKIABVHASEVKATUJVIBSEZVHVJBTZUMVKWFVHWGUKVBUDUNVHVI
    VNWAWCNVJVHVIVNJZWAWBVSCKLZGHZWCVHVSDEZVIVNWAWLNVIVNWMVHVIVLWMVMVLVIWMCBUOU
    PUQURAVSCUSVCWJWKBWBGVIVNWKBUIZVHVIWHCSEZCFOZIWNVNWIVNWOWPVLWOVMCTUJCPQWHWO
    WPWNBCVDRUTURVAVEVFVG $.

  $( Swap denominator with other side of 'less than or equal to'.  (Contributed
     by NM, 30-May-2005.) $)
  lediv23 $p |- ( ( A e. RR /\ ( B e. RR /\ 0 < B ) /\ ( C e. RR /\ 0 < C ) )
              -> ( ( A / B ) <_ C <-> ( A / C ) <_ B ) ) $=
    ( cr wcel cc0 clt wbr wa w3a cdiv co cle cmul wb wne gt0ne0 jca cc recn
    simpl redivcl 3expb sylan2 3adant3 simp3 simp2 lemul1 syl3anc 3adant3r wceq
    adantr ad2antrl adantl breq1d remulcl ancoms adantrr 3adant1 lediv1 divcan3
    divcan1d syld3an2 syl2an breq2d bitrd 3adant2r 3bitrd ) ADEZBDEZFBGHZIZCDEZ
    FCGHZIZJZABKLZCMHZVQBNLZCBNLZMHZAVTMHZACKLZBMHZVIVLVMVRWAOZVNVIVLVMJVQDEZVM
    VLWEVIVLWFVMVLVIVJBFPZIWFVLVJWGVJVKUABQZRVIVJWGWFABUBUCUDUEVIVLVMUFVIVLVMUG
    VQCBUHUIUJVPVSAVTMVIVLVSAUKVOVIVLIABVIASEVLATULVJBSEZVIVKBTZUMVLWGVIWHUNVBU
    EUOVIVJVOWBWDOVKVIVJVOJZWBWCVTCKLZMHZWDVIVTDEZVJVOWBWMOVJVOWNVIVJVMWNVNVMVJ
    WNCBUPUQURUSAVTCUTVCWKWLBWCMVJVOWLBUKZVIVJWICSEZCFPZIWOVOWJVOWPWQVMWPVNCTUL
    CQRWIWPWQWOBCVAUCVDUSVEVFVGVH $.

  $( Comparison of ratio of two nonnegative numbers.  (Contributed by NM,
     31-Dec-2005.) $)
  lediv12a $p |- ( ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ A <_ B ) ) /\
               ( ( C e. RR /\ D e. RR ) /\ ( 0 < C /\ C <_ D ) ) ) ->
                 ( A / D ) <_ ( B / C ) ) $=
    ( cr wcel wa cc0 cle wbr clt c1 cdiv co cmul jca cc recn adantl adantlr 0re
    simplr wi ltletr mp3an1 imp gt0ne0d rereccld gt0ne0 rereccl syldan ad2ant2r
    wne recgt0 syl2anc ltle sylancr mpd simprr wb id lerec syl12anc mpbid jca31
    simplll simplrl simpllr simprll simprrl simprlr jca32 simplrr lemul12a sylc
    simprrr sylan2 ad2antlr divrecd ad2antrl adantrrr adantrlr adantll 3brtr4d
    wceq adantr ) AEFZBEFZGZHAIJZABIJZGZGZCEFZDEFZGZHCKJZCDIJZGZGZGALDMNZONZBLC
    MNZONZADMNZBCMNZIWTWMXAEFZXCEFZGZHXAIJZXAXCIJZGZGZXBXDIJZWTXGXHXLWTDWNWOWSU
    BZWTDWPWSHDKJZHEFZWNWOWSXPUCUAHCDUDUEUFZUGZUHZWNWQXHWOWRWNWQCHUMZXHCUIZCUJU
    KULWTXJXKWTHXAKJZXJWTWOXPYCXOXRDUNUOWTXQXGYCXJUCUAXTHXAUPUQURWTWRXKWPWQWRUS
    WTWNWQGZWOXPWRXKUTWNWQYDWOWRYDVAULXOXRCDVBVCVDPVEWMXMGZWGWJGWHGZXGXJGZXHGGW
    KXKGXNYEYFYGXHYEWGWJWHWGWHWLXMVFWIWJWKXMVGWGWHWLXMVHVEYEXGXJWMXGXHXLVIWMXIX
    JXKVJPWMXGXHXLVKVLYEWKXKWIWJWKXMVMWMXIXJXKVPPABXAXCVNVOVQWIWTXEXBWEZWLWGWTY
    HWHWGWTGADWGAQFWTARWFWTDQFZWGWOYIWNWSDRVRSWTDHUMWGXSSVSTTWIWTXFXDWEZWLWHWTY
    JWGWHWNWSYJWOWHWNWQYJWRWHYDGBCWHBQFYDBRWFWNCQFWHWQCRVTYDYAWHYBSVSWAWBWCTWD
    $.

  $( Division of both sides of 'less than or equal to' into a nonnegative
     number.  (Contributed by Paul Chapman, 7-Sep-2007.) $)
  lediv2a $p |- ( ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
                     ( C e. RR /\ 0 <_ C ) ) /\
                   A <_ B ) -> ( C / B ) <_ ( C / A ) ) $=
    ( cr wcel cc0 clt wbr wa cle w3a cdiv co pm3.2 pm2.43i adantr anim2i ancoms
    leid jca ad2antlr 3adantl2 ad2ant2r simplr anim1i 3adantl3 lediv12a syl2anc
    id ) ADEZFAGHZIZBDEZFBGHZIZCDEZFCJHZIZKABJHZIUPUPIZUQCCJHZIZIZUJUMIZUKUSIZI
    ZCBLMCALMJHULURUSVCUOURVCULUSURUTVBUPUTUQUPUTUPUPNOPUQUPVBUPVAUQCSQRTUAUBUL
    UOUSVFURULUOIZUSIVDVEVGVDUSUJUMVDUKUNVDUIUCPVGUKUSUJUKUOUDUETUFCCABUGUH $.

  $( The reciprocal of a positive number less than 1 is greater than 1.
     (Contributed by NM, 23-Feb-2005.) $)
  reclt1 $p |- ( ( A e. RR /\ 0 < A ) -> ( A < 1 <-> 1 < ( 1 / A ) ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co wb 1re 0lt1 ltrec mpanr12 ax-1cn breq1i
    div1i syl6bb ) ABCDAEFGZAHEFZHHIJZHAIJZEFZHUCEFTHBCDHEFUAUDKLMAHNOUBHUCEHPR
    QS $.

  $( The reciprocal of a positive number greater than 1 is less than 1.
     (Contributed by NM, 28-Dec-2005.) $)
  recgt1 $p |- ( ( A e. RR /\ 0 < A ) -> ( 1 < A <-> ( 1 / A ) < 1 ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co wb 1re 0lt1 ltrec mpanl12 ax-1cn breq2i
    div1i syl6bb ) ABCDAEFGZHAEFZHAIJZHHIJZEFZUBHEFHBCDHEFTUAUDKLMHANOUCHUBEHPR
    QS $.

  $( The reciprocal of a number greater than 1 is positive and less than 1.
     (Contributed by NM, 23-Feb-2005.) $)
  recgt1i $p |- ( ( A e. RR /\ 1 < A ) ->
               ( 0 < ( 1 / A ) /\ ( 1 / A ) < 1 ) ) $=
    ( cr wcel c1 clt wbr wa cc0 cdiv co 0lt1 wi 0re 1re mp3an12 mpani imdistani
    lttr recgt0 syl recgt1 biimpa sylancom jca ) ABCZDAEFZGZHDAIJZEFZUHDEFZUGUE
    HAEFZGZUIUEUFUKUEHDEFZUFUKKHBCDBCUEUMUFGUKLMNHDAROPQZASTUEUFULUJUNULUFUJAUA
    UBUCUD $.

  $( Construct a number less than 1 from any nonnegative number.  (Contributed
     by NM, 30-Dec-2005.) $)
  recp1lt1 $p |- ( ( A e. RR /\ 0 <_ A ) -> ( A / ( 1 + A ) ) < 1 ) $=
    ( cr wcel cc0 cle wbr wa c1 caddc co cdiv clt cmul ltp1 cc wceq recn adantr
    1re recnd ax-1cn addcom sylancl breqtrd readdcl mpan addgtge0 mpanr1 mpanl1
    0lt1 gt0ne0d divcan1d mulid2d 3brtr4d simpl redivcld ltmul1 mp3an2 syl12anc
    wb mpbird ) ABCZDAEFZGZAHAIJZKJZHLFZVFVEMJZHVEMJZLFZVDAVEVHVILVBAVELFVCVBAA
    HIJZVELANVBAOCZHOCVKVEPAQZUAAHUBUCUDRVDAVEVBVLVCVMRVDVEVBVEBCZVCHBCZVBVNSHA
    UEUFZRZTVDVEVOVBVCDVELFZSVOVBGDHLFVCVRUJHAUGUHUIZUKZULVBVIVEPVCVBVEVBVEVPTU
    MRUNVDVFBCZVNVRVGVJUTZVDAVEVBVCUOVQVTUPVQVSWAVOVNVRGWBSVFHVEUQURUSVA $.

  $( Given a positive number ` A ` , construct a new positive number less than
     both ` A ` and 1.  (Contributed by NM, 28-Dec-2005.) $)
  recreclt $p |- ( ( A e. RR /\ 0 < A ) ->
        ( ( 1 / ( 1 + ( 1 / A ) ) ) < 1 /\ ( 1 / ( 1 + ( 1 / A ) ) ) < A ) ) $=
    ( cr wcel cc0 clt wbr wa c1 cdiv co caddc recgt0 1re ltaddpos sylancl mpbid
    wb sylancr 0lt1 cc wne gt0ne0 rereccl syldan readdcl 0re lttr mp3an12 mpani
    wi syl mpd recgt1 syl2anc mpbii wceq recnd ax-1cn addcom simpl simpr ltrec1
    breqtrd syl22anc jca ) ABCZDAEFZGZHHHAIJZKJZIJZHEFZVKAEFZVHHVJEFZVLVHDVIEFZ
    VNALVHVIBCZHBCZVOVNQVFVGADUAVPAUBAUCUDZMVIHNOPZVHVJBCZDVJEFZVNVLQVHVQVPVTMV
    RHVIUERZVHVNWAVSVHDHEFZVNWASVHVTWCVNGWAUJZWBDBCVQVTWDUFMDHVJUGUHUKUIULZVJUM
    UNPVHVIVJEFZVMVHVIVIHKJZVJEVHWCVIWGEFZSVHVQVPWCWHQMVRHVINRUOVHVITCHTCWGVJUP
    VHVIVRUQURVIHUSOVCVHVFVGVTWAWFVMQVFVGUTVFVGVAWBWEAVJVBVDPVE $.

  $( The square function on nonnegative reals is monotonic.  (Contributed by
     NM, 3-Aug-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  le2msq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( A <_ B <-> ( A x. A ) <_ ( B x. B ) ) ) $=
    ( cr wcel cc0 cle wbr wa clt cmul lt2msq ancoms notbid simpll simprl lenltd
    wn co wb remulcld 3bitr4d ) ACDZEAFGZHZBCDZEBFGZHZHZBAIGZQBBJRZAAJRZIGZQABF
    GUKUJFGUHUIULUGUDUIULSBAKLMUHABUBUCUGNZUDUEUFOZPUHUKUJUHAAUMUMTUHBBUNUNTPUA
    $.

  $( The square of a nonnegative number is a one-to-one function.  (Contributed
     by NM, 29-Jul-1999.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  msq11 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( ( A x. A ) = ( B x. B ) <-> A = B ) ) $=
    ( cr wcel cc0 cle wbr cmul wceq le2msq ancoms anbi12d simpll simprl letri3d
    wa co wb remulcld 3bitr4rd ) ACDZEAFGZPZBCDZEBFGZPZPZABFGZBAFGZPAAHQZBBHQZF
    GZUKUJFGZPABIUJUKIUGUHULUIUMABJUFUCUIUMRBAJKLUGABUAUBUFMZUCUDUENZOUGUJUKUGA
    AUNUNSUGBBUOUOSOT $.

  $( Less-than-or-equal-to and division relation.  (Lemma for computing upper
     bounds of products.  The "+ 1" prevents division by zero.)  (Contributed
     by NM, 28-Sep-2005.) $)
  ledivp1 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
                  ( ( A / ( B + 1 ) ) x. B ) <_ A ) $=
    ( cr wcel cc0 cle wbr wa c1 caddc cdiv cmul simprl peano2re ad2antrl simpll
    co clt jca cc wne ltp1 wi 0re lelttr mp3an1 mpdan mpan2d imp gt0ne0d adantl
    redivcld adantr divge0 sylan2 lep1 lemul2a syl31anc ad2antrr recnd divcan1d
    recn breqtrd ) ACDZEAFGZHZBCDZEBFGZHZHZABIJQZKQZBLQZVLVKLQZAFVJVGVKCDZVLCDZ
    EVLFGZHBVKFGZVMVNFGVFVGVHMVGVOVFVHBNZOZVJVPVQVJAVKVDVEVIPVTVIVKEUAVFVIVKVGV
    HEVKRGZVGVHBVKRGZWABUBVGVOVHWBHWAUCZVSECDVGVOWCUDEBVKUEUFUGUHUIZUJUKZULVIVF
    VOWAHVQVIVOWAVGVOVHVSUMWDSAVKUNUOSVGVRVFVHBUPOBVKVLUQURVJAVKVDATDVEVIAVBUSV
    GVKTDVFVHVGVKVSUTOWEVAVC $.

  ${
    $d x A $.
    $( If a nonnegative number is less than any positive number, it is zero.
       (Contributed by NM, 11-Feb-2006.) $)
    squeeze0 $p |- ( ( A e. RR /\ 0 <_ A /\ A. x e. RR ( 0 < x -> A < x ) ) ->
                   A = 0 ) $=
      ( cr wcel cc0 cle wbr cv clt wi wral wceq wo 0re leloe mpan breq2 imbi12d
      wb rspcv ltnr pm2.21d com12 imim2i com13 ax-1 eqcoms a1i jaod sylbid 3imp
      syl5d ) BCDZEBFGZEAHZIGZBUOIGZJZACKZBELZUMUNEBIGZEBLZMZUSUTJZECDUMUNVCSNE
      BOPUMVAVDVBUMUSVABBIGZJZVAUTURVFABCUOBLUPVAUQVEUOBEIQUOBBIQRTVFVAUMUTVEUM
      UTJVAUMVEUTUMVEUTBUAUBUCUDUEULVBVDJUMVDBEUTUSUFUGUHUIUJUK $.
  $}

  ${
    ltplus1.1 $e |- A e. RR $.
    $( A number is less than itself plus 1.  (Contributed by NM,
       20-Aug-2001.) $)
    ltp1i $p |- A < ( A + 1 ) $=
      ( cr wcel c1 caddc co clt wbr ltp1 ax-mp ) ACDAAEFGHIBAJK $.

    $( The reciprocal of a positive number is positive.  Exercise 4 of
       [Apostol] p. 21.  (Contributed by NM, 15-May-1999.) $)
    recgt0i $p |- ( 0 < A -> 0 < ( 1 / A ) ) $=
      ( cr wcel cc0 clt wbr c1 cdiv co recgt0 mpan ) ACDEAFGEHAIJFGBAKL $.

    ${
      recgt0i.2 $e |- 0 < A $.
      $( The reciprocal of a positive number is positive.  Exercise 4 of
         [Apostol] p. 21.  (Contributed by NM, 15-May-1999.) $)
      recgt0ii $p |- 0 < ( 1 / A ) $=
        ( cc0 c1 cdiv co clt wbr wn recni 0re 1re ax-mp cneg cmul cr wb lt0neg1
        wcel wceq ax-1cn ax-1ne0 gt0ne0ii divne0i nesymi 0lt1 rereccli renegcli
        wo ltnsymi mulgt0i mpan2 mulneg1i recidi mulcomli negeqi eqtri syl6breq
        3imtr4i mto pm3.2ni axlttri mp2an mpbir ) DEAFGZHIZDVFUAZVFDHIZUJJZVHVI
        VFDEAUBABKZUCABCUDZUEUFVIEDHIZDEHIVMJUGDELMUKNDVFOZHIZDEOZHIZVIVMVODVNA
        PGZVPHVODAHIDVRHICVNAVFABVLUHZUIBULUMVRVFAPGZOVPVFAVFVSKZVKUNVTEAVFEVKW
        AAVKVLUOUPUQURUSVFQTZVIVORVSVFSNEQTVMVQRMESNUTVAVBDQTWBVGVJRLVSDVFVCVDV
        E $.
    $}

    prodgt0.2 $e |- B e. RR $.
    $( Infer that a multiplicand is positive from a nonnegative muliplier and
       positive product.  (Contributed by NM, 15-May-1999.) $)
    prodgt0i $p |- ( ( 0 <_ A /\ 0 < ( A x. B ) ) -> 0 < B ) $=
      ( cr wcel cc0 cle wbr cmul co clt wa prodgt0 mpanl12 ) AEFBEFGAHIGABJKLIM
      GBLICDABNO $.

    $( Infer that a multiplicand is nonnegative from a positive muliplier and
       nonnegative product.  (Contributed by NM, 2-Jul-2005.) $)
    prodge0i $p |- ( ( 0 < A /\ 0 <_ ( A x. B ) ) -> 0 <_ B ) $=
      ( cr wcel cc0 clt wbr cmul co cle wa prodge0 mpanl12 ) AEFBEFGAHIGABJKLIM
      GBLICDABNO $.

    $( The ratio of two positive numbers is positive.  (Contributed by NM,
       16-May-1999.) $)
    divgt0i $p |- ( ( 0 < A /\ 0 < B ) -> 0 < ( A / B ) ) $=
      ( cr wcel cc0 clt wbr cdiv co wa divgt0 mpanr1 mpanl1 ) AEFZGAHIZGBHIZGAB
      JKHIZCPQLBEFRSDABMNO $.

    $( The ratio of nonnegative and positive numbers is nonnegative.
       (Contributed by NM, 12-Aug-1999.) $)
    divge0i $p |- ( ( 0 <_ A /\ 0 < B ) -> 0 <_ ( A / B ) ) $=
      ( cr wcel cc0 cle wbr clt cdiv co wa divge0 mpanr1 mpanl1 ) AEFZGAHIZGBJI
      ZGABKLHIZCQRMBEFSTDABNOP $.

    $( The reciprocal of both sides of 'less than'.  (Contributed by NM,
       15-Sep-1999.) $)
    ltreci $p |- ( ( 0 < A /\ 0 < B ) ->
                ( A < B <-> ( 1 / B ) < ( 1 / A ) ) ) $=
      ( cr wcel cc0 clt wbr c1 cdiv co wb wa ltrec mpanr1 mpanl1 ) AEFZGAHIZGBH
      IZABHIJBKLJAKLHIMZCRSNBEFTUADABOPQ $.

    $( The reciprocal of both sides of 'less than or equal to'.  (Contributed
       by NM, 16-Sep-1999.) $)
    lereci $p |- ( ( 0 < A /\ 0 < B ) ->
                ( A <_ B <-> ( 1 / B ) <_ ( 1 / A ) ) ) $=
      ( cr wcel cc0 clt wbr cle c1 cdiv co wb wa lerec mpanr1 mpanl1 ) AEFZGAHI
      ZGBHIZABJIKBLMKALMJINZCSTOBEFUAUBDABPQR $.

    $( The square function on nonnegative reals is strictly monotonic.
       (Contributed by NM, 3-Aug-1999.) $)
    lt2msqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( A < B <-> ( A x. A ) < ( B x. B ) ) ) $=
      ( cr wcel cc0 cle wbr clt cmul co wb wa lt2msq mpanr1 mpanl1 ) AEFZGAHIZG
      BHIZABJIAAKLBBKLJIMZCRSNBEFTUADABOPQ $.

    $( The square function on nonnegative reals is monotonic.  (Contributed by
       NM, 2-Aug-1999.) $)
    le2msqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( A <_ B <-> ( A x. A ) <_ ( B x. B ) ) ) $=
      ( cr wcel cc0 cle wbr cmul co wb wa le2msq mpanr1 mpanl1 ) AEFZGAHIZGBHIZ
      ABHIAAJKBBJKHILZCQRMBEFSTDABNOP $.

    $( The square of a nonnegative number is a one-to-one function.
       (Contributed by NM, 29-Jul-1999.) $)
    msq11i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
                ( ( A x. A ) = ( B x. B ) <-> A = B ) ) $=
      ( cr wcel cc0 cle wbr cmul co wceq wb wa msq11 mpanr1 mpanl1 ) AEFZGAHIZG
      BHIZAAJKBBJKLABLMZCRSNBEFTUADABOPQ $.

    ${
      divgt0i2.3 $e |- 0 < B $.
      $( The ratio of two positive numbers is positive.  (Contributed by NM,
         16-May-1999.) $)
      divgt0i2i $p |- ( 0 < A -> 0 < ( A / B ) ) $=
        ( cc0 clt wbr cdiv co divgt0i mpan2 ) FAGHFBGHFABIJGHEABCDKL $.
    $}

    ${
      ltreci.3 $e |- 0 < A $.
      ltreci.4 $e |- 0 < B $.
      $( The reciprocal of both sides of 'less than'.  (Contributed by NM,
         15-Sep-1999.) $)
      ltrecii $p |- ( A < B <-> ( 1 / B ) < ( 1 / A ) ) $=
        ( cc0 clt wbr c1 cdiv co wb ltreci mp2an ) GAHIGBHIABHIJBKLJAKLHIMEFABC
        DNO $.

      $( The ratio of two positive numbers is positive.  (Contributed by NM,
         18-May-1999.) $)
      divgt0ii $p |- 0 < ( A / B ) $=
        ( cc0 clt wbr cdiv co divgt0i2i ax-mp ) GAHIGABJKHIEABCDFLM $.
    $}

    ltmul1.3 $e |- C e. RR $.
    $( Multiplication of both sides of 'less than' by a positive number.
       Theorem I.19 of [Apostol] p. 20.  (Contributed by NM, 16-May-1999.) $)
    ltmul1i $p |- ( 0 < C -> ( A < B <-> ( A x. C ) < ( B x. C ) ) ) $=
      ( cr wcel cc0 clt wbr cmul co wb wa ltmul1 mp3an12 mpan ) CGHZICJKZABJKAC
      LMBCLMJKNZFAGHBGHSTOUADEABCPQR $.

    $( Division of both sides of 'less than' by a positive number.
       (Contributed by NM, 16-May-1999.) $)
    ltdiv1i $p |- ( 0 < C -> ( A < B <-> ( A / C ) < ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr cdiv co wb wa ltdiv1 mp3an12 mpan ) CGHZICJKZABJKAC
      LMBCLMJKNZFAGHBGHSTOUADEABCPQR $.

    $( 'Less than' relationship between division and multiplication.
       (Contributed by NM, 12-Oct-1999.) $)
    ltmuldivi $p |- ( 0 < C -> ( ( A x. C ) < B <-> A < ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr cmul co cdiv wb wa ltmuldiv mp3an12 mpan ) CGHZICJK
      ZACLMBJKABCNMJKOZFAGHBGHTUAPUBDEABCQRS $.

    $( Multiplication of both sides of 'less than' by a positive number.
       Theorem I.19 of [Apostol] p. 20.  (Contributed by NM, 16-May-1999.) $)
    ltmul2i $p |- ( 0 < C -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
      ( cr wcel cc0 clt wbr cmul co wb wa ltmul2 mp3an12 mpan ) CGHZICJKZABJKCA
      LMCBLMJKNZFAGHBGHSTOUADEABCPQR $.

    $( Multiplication of both sides of 'less than or equal to' by a positive
       number.  (Contributed by NM, 2-Aug-1999.) $)
    lemul1i $p |- ( 0 < C -> ( A <_ B <-> ( A x. C ) <_ ( B x. C ) ) ) $=
      ( cr wcel cc0 clt wbr cle cmul co wb wa lemul1 mp3an12 mpan ) CGHZICJKZAB
      LKACMNBCMNLKOZFAGHBGHTUAPUBDEABCQRS $.

    $( Multiplication of both sides of 'less than or equal to' by a positive
       number.  (Contributed by NM, 1-Aug-1999.) $)
    lemul2i $p |- ( 0 < C -> ( A <_ B <-> ( C x. A ) <_ ( C x. B ) ) ) $=
      ( cr wcel cc0 clt wbr cle cmul co wb wa lemul2 mp3an12 mpan ) CGHZICJKZAB
      LKCAMNCBMNLKOZFAGHBGHTUAPUBDEABCQRS $.

    $( Swap denominator with other side of 'less than'.  (Contributed by NM,
       26-Sep-1999.) $)
    ltdiv23i $p |- ( ( 0 < B /\ 0 < C ) ->
                ( ( A / B ) < C <-> ( A / C ) < B ) ) $=
      ( cc0 clt wbr cr wcel cdiv co wb wa ltdiv23 mp3an1 mpanl1 mpanr1 ) GBHIZC
      JKZGCHIZABLMCHIACLMBHINZFBJKZTUAUBOZUCEAJKUDTOUEUCDABCPQRS $.

    $( Less-than-or-equal-to and division relation.  (Lemma for computing upper
       bounds of products.  The "+ 1" prevents division by zero.)  (Contributed
       by NM, 17-Sep-2005.) $)
    ledivp1i $p |- ( ( 0 <_ A /\ 0 <_ C /\ A <_ ( B / ( C + 1 ) ) ) ->
                  ( A x. C ) <_ B ) $=
      ( cc0 cle wbr c1 co w3a cmul cr wcel wa mpan2 clt syl recni cdiv readdcli
      caddc 1re ltp1i ltleii lemul2a mp3an12 3ad2ant1 wi 0re lelttri wb gt0ne0i
      mpan wne redivclzi lemul1 mp3an1 ex mpani mpcom biimpd imp wceq divcan1zi
      3syl adantr breqtrd 3adant1 remulcli letri syl2anc ) GAHIZGCHIZABCJUCKZUA
      KZHIZLACMKZAVPMKZHIZVTBHIZVSBHIVNVOWAVRANOZVNWADCNOZVPNOZWCVNPZWAFCJFUDUB
      ZWDWEWFLCVPHIWACVPFWGCFUEZUFCVPAUGQUHUOUIVOVRWBVNVOVRPVTVQVPMKZBHVOVRVTWI
      HIZVOGVPRIZVRWJUJVOCVPRIWKWHGCVPUKFWGULQZWKVRWJVQNOZWKVRWJUMZWKVPGUPZWMVP
      WGUNZBVPEWGUQSWMWEWKWNWGWMWEWKPZWNWCWMWQWNDAVQVPURUSUTVAVBVCSVDVOWIBVEZVR
      VOWKWOWRWLWPBVPBETVPWGTVFVGVHVIVJVSVTBACDFVKAVPDWGVKEVLVM $.

    $( Less-than and division relation.  (Lemma for computing upper bounds of
       products.  The "+ 1" prevents division by zero.)  (Contributed by NM,
       17-Sep-2005.) $)
    ltdivp1i $p |- ( ( 0 <_ A /\ 0 <_ C /\ A < ( B / ( C + 1 ) ) ) ->
                  ( A x. C ) < B ) $=
      ( cc0 cle wbr c1 co clt w3a cmul cr wcel wa mpan2 lelttri syl caddc ltp1i
      cdiv 1re readdcli ltleii lemul2a mp3an12 mpan 3ad2ant1 wi 0re wne gt0ne0i
      wb redivclzi ltmul1 mp3an1 mpanr1 mpancom biimpd imp wceq recni divcan1zi
      3syl adantr breqtrd 3adant1 remulcli syl2anc ) GAHIZGCHIZABCJUAKZUCKZLIZM
      ACNKZAVNNKZHIZVRBLIZVQBLIVLVMVSVPAOPZVLVSDCOPZVNOPZWAVLQZVSFCJFUDUEZWBWCW
      DMCVNHIVSCVNFWECFUBZUFCVNAUGRUHUIUJVMVPVTVLVMVPQVRVOVNNKZBLVMVPVRWGLIZVMG
      VNLIZVPWHUKVMCVNLIWIWFGCVNULFWESRZWIVPWHVOOPZWIVPWHUOZWIVNGUMZWKVNWEUNZBV
      NEWEUPTWKWCWIWLWEWAWKWCWIQWLDAVOVNUQURUSUTVATVBVMWGBVCZVPVMWIWMWOWJWNBVNB
      EVDVNWEVDVEVFVGVHVIVQVRBACDFVJAVNDWEVJESVK $.

    ${
      ltdiv23i.4 $e |- 0 < B $.
      ltdiv23i.5 $e |- 0 < C $.
      $( Swap denominator with other side of 'less than'.  (Contributed by NM,
         26-Sep-1999.) $)
      ltdiv23ii $p |- ( ( A / B ) < C <-> ( A / C ) < B ) $=
        ( cc0 clt wbr cdiv co wb ltdiv23i mp2an ) IBJKICJKABLMCJKACLMBJKNGHABCD
        EFOP $.
    $}

    ${
      ltmul1i.4 $e |- 0 < C $.
      $( Multiplication of both sides of 'less than' by a positive number.
         Theorem I.19 of [Apostol] p. 20.  (Contributed by NM, 16-May-1999.)
         (Proof shortened by Paul Chapman, 25-Jan-2008.) $)
      ltmul1ii $p |- ( A < B <-> ( A x. C ) < ( B x. C ) ) $=
        ( cc0 clt wbr cmul co wb ltmul1i ax-mp ) HCIJABIJACKLBCKLIJMGABCDEFNO
        $.

      $( Division of both sides of 'less than' by a positive number.
         (Contributed by NM, 16-May-1999.) $)
      ltdiv1ii $p |- ( A < B <-> ( A / C ) < ( B / C ) ) $=
        ( cc0 clt wbr cdiv co wb ltdiv1i ax-mp ) HCIJABIJACKLBCKLIJMGABCDEFNO
        $.
    $}
  $}

  ${
    ltp1d.1 $e |- ( ph -> A e. RR ) $.
    $( A number is less than itself plus 1.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    ltp1d $p |- ( ph -> A < ( A + 1 ) ) $=
      ( cr wcel c1 caddc co clt wbr ltp1 syl ) ABDEBBFGHIJCBKL $.

    $( A number is less than or equal to itself plus 1.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    lep1d $p |- ( ph -> A <_ ( A + 1 ) ) $=
      ( cr wcel c1 caddc co cle wbr lep1 syl ) ABDEBBFGHIJCBKL $.

    $( A number minus 1 is less than itself.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    ltm1d $p |- ( ph -> ( A - 1 ) < A ) $=
      ( cr wcel c1 cmin co clt wbr ltm1 syl ) ABDEBFGHBIJCBKL $.

    $( A number minus 1 is less than or equal to itself.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    lem1d $p |- ( ph -> ( A - 1 ) <_ A ) $=
      ( cr wcel c1 cmin co cle wbr lem1 syl ) ABDEBFGHBIJCBKL $.

    ${
      recgt0d.2 $e |- ( ph -> 0 < A ) $.
      $( The reciprocal of a positive number is positive.  Exercise 4 of
         [Apostol] p. 21.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      recgt0d $p |- ( ph -> 0 < ( 1 / A ) ) $=
        ( cr wcel cc0 clt wbr c1 cdiv co recgt0 syl2anc ) ABEFGBHIGJBKLHICDBMN
        $.
    $}

    divgt0d.2 $e |- ( ph -> B e. RR ) $.
    ${
      divgt0d.3 $e |- ( ph -> 0 < A ) $.
      divgt0d.4 $e |- ( ph -> 0 < B ) $.
      $( The ratio of two positive numbers is positive.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      divgt0d $p |- ( ph -> 0 < ( A / B ) ) $=
        ( cr wcel cc0 clt wbr cdiv co divgt0 syl22anc ) ABHIJBKLCHIJCKLJBCMNKLD
        FEGBCOP $.
    $}

    ${
      mulgt1d.3 $e |- ( ph -> 1 < A ) $.
      mulgt1d.4 $e |- ( ph -> 1 < B ) $.
      $( The product of two numbers greater than 1 is greater than 1.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      mulgt1d $p |- ( ph -> 1 < ( A x. B ) ) $=
        ( cr wcel c1 clt wbr cmul co mulgt1 syl22anc ) ABHICHIJBKLJCKLJBCMNKLDE
        FGBCOP $.
    $}

    ${
      lemulge11d.3 $e |- ( ph -> 0 <_ A ) $.
      lemulge11d.4 $e |- ( ph -> 1 <_ B ) $.
      $( Multiplication by a number greater than or equal to 1.  (Contributed
         by Mario Carneiro, 28-May-2016.) $)
      lemulge11d $p |- ( ph -> A <_ ( A x. B ) ) $=
        ( cr wcel cc0 cle wbr c1 cmul co lemulge11 syl22anc ) ABHICHIJBKLMCKLBB
        CNOKLDEFGBCPQ $.

      $( Multiplication by a number greater than or equal to 1.  (Contributed
         by Mario Carneiro, 28-May-2016.) $)
      lemulge12d $p |- ( ph -> A <_ ( B x. A ) ) $=
        ( cr wcel cc0 cle wbr c1 cmul co lemulge12 syl22anc ) ABHICHIJBKLMCKLBC
        BNOKLDEFGBCPQ $.
    $}

    lemul1ad.3 $e |- ( ph -> C e. RR ) $.
    ${
      lemul1ad.4 $e |- ( ph -> 0 <_ C ) $.
      lemul1ad.5 $e |- ( ph -> A <_ B ) $.
      $( The square of a nonnegative number is a one-to-one function.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      lemul1ad $p |- ( ph -> ( A x. C ) <_ ( B x. C ) ) $=
        ( cr wcel cc0 cle wbr wa cmul co jca lemul1a syl31anc ) ABJKCJKDJKZLDMN
        ZOBCMNBDPQCDPQMNEFAUAUBGHRIBCDST $.

      $( The square of a nonnegative number is a one-to-one function.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      lemul2ad $p |- ( ph -> ( C x. A ) <_ ( C x. B ) ) $=
        ( cr wcel cc0 cle wbr wa cmul co jca lemul2a syl31anc ) ABJKCJKDJKZLDMN
        ZOBCMNDBPQDCPQMNEFAUAUBGHRIBCDST $.
    $}

    ltmul12ad.3 $e |- ( ph -> D e. RR ) $.
    ${
      ltmul12ad.4 $e |- ( ph -> 0 <_ A ) $.
      ltmul12ad.5 $e |- ( ph -> A < B ) $.
      ltmul12ad.6 $e |- ( ph -> 0 <_ C ) $.
      ltmul12ad.7 $e |- ( ph -> C < D ) $.
      $( The square of a nonnegative number is a one-to-one function.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      ltmul12ad $p |- ( ph -> ( A x. C ) < ( B x. D ) ) $=
        ( cr wcel wa cc0 wbr clt jca cle cmul co ltmul12a syl22anc ) ABNOZCNOZP
        QBUARZBCSRZPDNOZENOZPQDUARZDESRZPBDUBUCCEUBUCSRAUFUGFGTAUHUIJKTAUJUKHIT
        AULUMLMTBCDEUDUE $.
    $}

    ${
      lemul12ad.4 $e |- ( ph -> 0 <_ A ) $.
      lemul12ad.5 $e |- ( ph -> 0 <_ C ) $.
      lemul12ad.6 $e |- ( ph -> A <_ B ) $.
      lemul12ad.7 $e |- ( ph -> C <_ D ) $.
      $( The square of a nonnegative number is a one-to-one function.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      lemul12ad $p |- ( ph -> ( A x. C ) <_ ( B x. D ) ) $=
        ( cle wbr cmul co cr wcel wa cc0 wi jca lemul12a syl22anc mp2and ) ABCN
        OZDENOZBDPQCEPQNOZLMABRSZUABNOZTCRSDRSZUADNOZTERSUGUHTUIUBAUJUKFJUCGAUL
        UMHKUCIBCDEUDUEUF $.
    $}

    ${
      lemul12bd.4 $e |- ( ph -> 0 <_ A ) $.
      lemul12bd.5 $e |- ( ph -> 0 <_ D ) $.
      lemul12bd.6 $e |- ( ph -> A <_ B ) $.
      lemul12bd.7 $e |- ( ph -> C <_ D ) $.
      $( The square of a nonnegative number is a one-to-one function.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      lemul12bd $p |- ( ph -> ( A x. C ) <_ ( B x. D ) ) $=
        ( cle wbr cmul co cr wcel wa cc0 wi jca lemul12b syl22anc mp2and ) ABCN
        OZDENOZBDPQCEPQNOZLMABRSZUABNOZTCRSDRSERSZUAENOZTUGUHTUIUBAUJUKFJUCGHAU
        LUMIKUCBCDEUDUEUF $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Completeness Axiom and Suprema
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.
    $( A finite set of real numbers has a maximum.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    fimaxre $p |- ( ( A C_ RR /\ A e. Fin /\ A =/= (/) )
                                            -> E. x e. A A. y e. A y <_ x ) $=
      ( cr wss cfn wcel c0 wne cv clt wbr wi wral wrex wor wa ssel weq wo leloe
      w3a cle ltso mpi fimaxg syl3an1 anim12d imp wb ancoms equcom orbi2i orcom
      soss neor 3bitri syl6bb biimprd syl anassrs ralimdva reximdva 3ad2ant1
      mpd ) CDEZCFGZCHIZUBAJZBJZIVJVIKLZMZBCNZACOZVJVIUCLZBCNZACOZVFCKPZVGVHVNV
      FDKPVRUDCDKUOUEABCKUFUGVFVGVNVQMVHVFVMVPACVFVICGZQVLVOBCVFVSVJCGZVLVOMZVF
      VSVTQZQVIDGZVJDGZQZWAVFWBWEVFVSWCVTWDCDVIRCDVJRUHUIWEVOVLWEVOVKBASZTZVLWD
      WCVOWGUJVJVIUAUKWGVKABSZTWHVKTVLWFWHVKBAULUMVKWHUNVKVIVJUPUQURUSUTVAVBVCV
      DVE $.
  $}

  ${
    $d A x y $.
    $( A nonempty finite set of real numbers has a maximum.  (Contributed by
       Jeff Madsen, 27-May-2011.)  (Revised by Mario Carneiro, 13-Feb-2014.) $)
    fimaxre2 $p |- ( ( A C_ RR /\ A e. Fin ) ->
                     E. x e. RR A. y e. A y <_ x ) $=
      ( cr wss cfn wcel wa cv cle wbr wral wrex c0 wceq wi cc0 0re rzal breq2
      ralbidv rspcev sylancr a1i fimaxre 3expia ssrexv adantr syld pm2.61dne
      wne ) CDEZCFGZHZBIZAIZJKZBCLZADMZCNCNOZUSPUNUTQDGUOQJKZBCLZUSRVABCSURVBAQ
      DUPQOUQVABCUPQUOJTUAUBUCUDUNCNUKZURACMZUSULUMVCVDABCUEUFULVDUSPUMURACDUGU
      HUIUJ $.
  $}

  ${
    $d w x y z A $.  $d w x z B $.
    $( A nonempty finite set of real numbers has a maximum (image set
       version).  (Contributed by Mario Carneiro, 13-Feb-2014.) $)
    fimaxre3 $p |- ( ( A e. Fin /\ A. y e. A B e. RR )
                                      -> E. x e. RR A. y e. A B <_ x ) $=
      ( vw vz cfn wcel cr wral wa cv cle wbr wceq wrex syl wb wi wal cab r19.29
      eleq1 biimparc rexlimivw ex abssdv abrexfi fimaxre2 syl2anr r19.23v albii
      wss ralcom4 eqeq1 rexbidv ralab 3bitr4i breq1 ceqsalg ralimi ralbi adantl
      nfv syl5bbr mpbid ) CGHZDIHZBCJZKELZALZMNZEFLZDOZBCPZFUAZJZAIPZDVKMNZBCJZ
      AIPZVIVPIUMVPGHVRVGVIVOFIVIVOVMIHZVIVOKVHVNKZBCPWBVHVNBCUBWCWBBCVNWBVHVMD
      IUCUDUEQUFUGBFCDUHAEVPUIUJVIVRWARVGVIVQVTAIVQVJDOZVLSZETZBCJZVIVTWEBCJZET
      WDBCPZVLSZETWGVQWHWJEWDVLBCUKULWEBECUNVOWIVLEFVMVJOVNWDBCVMVJDUOUPUQURVIW
      FVSRZBCJWGVTRVHWKBCVLVSEDIVSEVDVJDVKMUSUTVAWFVSBCVBQVEUPVCVF $.
  $}

  ${
    $d w x y z v S $.  $d w y A $.
    $( If a set of reals contains a lower bound, it contains a unique lower
       bound.  (Contributed by NM, 9-Oct-2005.) $)
    lbreu $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                E! x e. S A. y e. S x <_ y ) $=
      ( vw cr wss cv cle wbr wral wrex wa weq wi wreu wcel breq2 im2anan9r ssel
      rspcv anim12d impcom letri3 syl exbiri com23 syld ralrimivv anim2i ancoms
      wb com3r breq1 ralbidv reu4 sylibr ) CEFZAGZBGZHIZBCJZACKZLVBVADGZUSHIZBC
      JZLZADMZNZDCJACJZLZVAACOVBUQVJUQVIVBUQVHADCCURCPZVCCPZLZVFUQVGVMVFURVCHIZ
      VCURHIZLZUQVGNVLVAVNVKVEVOUTVNBVCCUSVCURHQTVDVOBURCUSURVCHQTRVMUQVPVGVMUQ
      VGVPVMUQLUREPZVCEPZLZVGVPUKUQVMVSUQVKVQVLVRCEURSCEVCSUAUBURVCUCUDUEUFUGUL
      UHUIUJVAVEADCVGUTVDBCURVCUSHUMUNUOUP $.

    $( If a set of reals contains a lower bound, it contains a unique lower
       bound that belongs to the set.  (Contributed by NM, 9-Oct-2005.)
       (Revised by Mario Carneiro, 24-Dec-2016.) $)
    lbcl $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                ( iota_ x e. S A. y e. S x <_ y ) e. S ) $=
      ( cr wss cv cle wbr wral wrex wa wreu crio wcel lbreu riotacl syl ) CDEAF
      BFGHBCIZACJKRACLRACMCNABCORACPQ $.

    $( If a set of reals contains a lower bound, the lower bound is less than
       or equal to all members of the set.  (Contributed by NM, 9-Oct-2005.)
       (Proof shortened by Mario Carneiro, 24-Dec-2016.) $)
    lble $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y /\ A e. S ) ->
                ( iota_ x e. S A. y e. S x <_ y ) <_ A ) $=
      ( cr wss cv cle wbr wral wrex wcel crio wa wreu lbreu nfcv nfriota1 nfral
      nfbr eqid wceq nfra1 nfriota nfeq2 breq1 ralbid riotaprop syl simprd rspc
      breq2 mpan9 3impa ) DEFZAGZBGZHIZBDJZADKZCDLZUSADMZCHIZUOUTNZVBUQHIZBDJZV
      AVCVDVBDLZVFVDUSADOVGVFNABDPUSVFADVBVEABDADQAVBUQHUSADRAHQAUQQTSVBUAUPVBU
      BURVEBDBUPVBUSBADURBDUCBDQUDZUEUPVBUQHUFUGUHUIUJVEVCBCDBVBCHVHBHQBCQTUQCV
      BHULUKUMUN $.

    $( If a set of reals contains a lower bound, the lower bound is its
       infimum.  (Contributed by NM, 9-Oct-2005.)  (Revised by Mario Carneiro,
       16-Jun-2013.) $)
    lbinfm $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                 sup ( S , RR , `' < ) = ( iota_ x e. S A. y e. S x <_ y ) ) $=
      ( vz cr wss cv cle wbr wral wrex wa crio clt wor wcel adantr wn wb cvv wi
      ccnv ltso cnvso mpbi a1i lbcl ssel mpd lble 3expa ssel2 lenltd mpbid elex
      adantlr syl vex brcnvg sylancl notbid mpbird supmax ) CEFZAGBGHIBCJZACKZL
      ZDECVEACMZNUBZEVIOZVGENOVJUCENUDUEUFVGVHCPZVHEPZABCUGZVDVKVLUAVFCEVHUHQUI
      ZVMVGDGZCPZLZVHVOVIIZRZVOVHNIZRZVQVHVOHIZWAVDVFVPWBABVOCUJUKVQVHVOVGVLVPV
      NQVDVPVOEPVFCEVOULUPUMUNVGVSWASVPVGVRVTVGVHTPZVOTPVRVTSVGVKWCVMVHCUOUQDUR
      VHVOTTNUSUTVAQVBVC $.

    $( If a set of reals contains a lower bound, it contains its infimum.
       (Contributed by NM, 11-Oct-2005.) $)
    lbinfmcl $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y ) ->
                 sup ( S , RR , `' < ) e. S ) $=
      ( cr wss cv cle wbr wral wrex wa clt ccnv csup crio lbinfm lbcl eqeltrd )
      CDEAFBFGHBCIZACJKCDLMNSACOCABCPABCQR $.

    $( If a set of reals contains a lower bound, its infmimum is less than or
       equal to all members of the set.  (Contributed by NM, 11-Oct-2005.) $)
    lbinfmle $p |- ( ( S C_ RR /\ E. x e. S A. y e. S x <_ y /\ A e. S ) ->
                sup ( S , RR , `' < ) <_ A ) $=
      ( cr wss cv cle wbr wral wrex wcel w3a ccnv csup crio wceq lbinfm 3adant3
      clt lble eqbrtrd ) DEFZAGBGHIBDJZADKZCDLZMDETNOZUDADPZCHUCUEUGUHQUFABDRSA
      BCDUAUB $.
  $}

  ${
    $d x y z w v u t A $.
    $( A non-empty, bounded-above set of reals has a supremum.  Stronger
       version of completeness axiom (it has a slightly weaker antecedent).
       (Contributed by NM, 19-Jan-1997.) $)
    sup2 $p |- ( ( A C_ RR /\ A =/= (/) /\
                  E. x e. RR A. y e. A ( y < x \/ y = x ) ) ->
               E. x e. RR ( A. y e. A -. x < y /\
                  A. y e. RR ( y < x -> E. z e. A y < z ) ) ) $=
      ( cr cv clt wbr wceq wral wrex w3a wi wa wcel wex c1 caddc adantr imp wss
      c0 wne wo wn peano2re a1i ssel ltp1 ancli lttr 3expb sylan2 sylan2i exp4b
      co com34 pm2.43d breq1 syl5ibrcom adantl jaod syl6 com23 ralimdv2 expimpd
      ex a2d jcad ovex eleq1 breq2 ralbidv anbi12d exlimdv cbvexv syl6ib df-rex
      spcev 3imtr4g imdistani df-3an 3imtr4i axsup syl ) DEUAZDUBUCZBFZAFZGHZWH
      WIIZUDZBDJZAEKZLZWFWGWJBDJZAEKZLZWIWHGHUEBDJWJWHCFZGHZCDKMBEJNAEKWFWGNZWN
      NXAWQNWOWRXAWNWQWFWNWQMWGWFWIEOZWMNZAPZXBWPNZAPZWNWQWFXDWSEOZWTBDJZNZCPZX
      FWFXCXJAWFXCWIQRUPZEOZWHXKGHZBDJZNZXJWFXCXLXNXCXLMWFXBXLWMWIUFZSUGWFXBWMX
      NWFXBNZWLXMBDDXQWHDOZWLXMWFXBXRWLXMMZMWFXRXBXSWFXRWHEOZXBXSMDEWHUHXTXBXSX
      TXBNZWJXMWKXTXBWJXMMZXTXBYBXTXBWJXBXMXTXBWJXBXMXBYAWJWIXKGHZXMWIUIZXBXTXB
      XLNWJYCNXMMZXBXLXPUJXTXBXLYEWHWIXKUKULUMUNUOUQURTXBWKXMMXTXBXMWKYCYDWHWIX
      KGUSUTVAVBVGVCVDTVHVEVFVIXIXOCXKWIQRVJWSXKIZXGXLXHXNWSXKEVKYFWTXMBDWSXKWH
      GVLVMVNVSVCVOXIXECAWSWIIZXGXBXHWPWSWIEVKYGWTWJBDWSWIWHGVLVMVNVPVQWMAEVRWP
      AEVRVTSWAWFWGWNWBWFWGWQWBWCABCDWDWE $.

    $( A version of the completeness axiom for reals.  (Contributed by NM,
       12-Oct-2004.) $)
    sup3 $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                  E. x e. RR ( A. y e. A -. x < y /\
                  A. y e. RR ( y < x -> E. z e. A y < z ) ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a clt weq wo wa wcel 3anass expcom
      wn wi ssel leloe syl9 imp31 ralbidva rexbidva anbi2d pm5.32i 3bitr4i sup2
      wb sylbi ) DEFZDGHZBIZAIZJKZBDLZAEMZNZUPUQURUSOKZBAPQZBDLZAEMZNZUSUROKUBB
      DLVDURCIOKCDMUCBELRAEMUPUQVBRZRUPUQVGRZRVCVHUPVIVJUPVBVGUQUPVAVFAEUPUSESZ
      RUTVEBDUPVKURDSZUTVEUNZUPVLURESZVKVMDEURUDVNVKVMURUSUEUAUFUGUHUIUJUKUPUQV
      BTUPUQVGTULABCDUMUO $.

    $( Lemma for ~ infm3 .  (Contributed by NM, 14-Jun-2005.) $)
    infm3lem $p |- ( x e. RR -> E. y e. RR x = -u y ) $=
      ( cv wcel cneg wceq wrex renegcl recn negnegd eqcomd negeq eqeq2d syl2anc
      cr rspcev ) ACZODZQEZODQSEZFZQBCZEZFZBOGQHRTQRQQIJKUDUABSOUBSFUCTQUBSLMPN
      $.

    $( The completeness axiom for reals in terms of infimum: a non-empty,
       bounded-below set of reals has an infimum.  (This theorem is the dual of
       ~ sup3 .)  (Contributed by NM, 14-Jun-2005.) $)
    infm3 $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                  E. x e. RR ( A. y e. A -. y < x /\
                  A. y e. RR ( x < y -> E. z e. A z < y ) ) ) $=
      ( vu vv vw vt cr cv cle wbr wral wrex clt wi wa wcel wal df-ral wss c0 wn
      wne cneg crab wex ssel pm4.71rd exbidv df-rex renegcl eleq1 rexxfr bitr3i
      infm3lem syl6bb n0 rabn0 3bitr4g imbi1d impexp albidv wceq imbi12d ralxfr
      breq2 rexbidv breq1 imbi2d negeq eleq1d elrab imbi1i bitri albii 3bitr4ri
      ralbidv wb leneg ancoms syl5bbr rexbiia bitr4i anbi12d ssrab2 sup3 mp3an1
      ralbidva syl6bi notbid adantrd syl5bb ltneg rexrab anbi2d rexbidva adantl
      sylibrd 3impib ) DIUAZDUBUDZAJZBJZKLZBDMZAINZXDXCOLZUCZBDMZXCXDOLZCJZXDOL
      ZCDNZPZBIMZQZAINZXAXBXGQZEJZFJZOLZUCZFGJZUEZDRZGIUFZMZYAXTOLZYAHJZOLZHYGN
      ZPZFIMZQZEINZXRXAXSYGUBUDZYAXTKLZFYGMZEINZQYPXAXBYQXGYTXAYADRZFUGZYFGINZX
      BYQXAUUBYAIRZUUAQZFUGZUUCXAUUAUUEFXAUUAUUDDIYAUHUIUJUUFUUAFINUUCUUAFIUKUU
      AYFFGYEIIYDULFGUPYAYEDUMUNUOUQFDURYFGIUSUTXAXGYAUEZDRZXCUUGKLZPZFIMZAINZY
      TXAXFUUKAIXAXDDRZXEPZBSXDIRZUUNPZBSZXFUUKXAUUNUUPBXAUUNUUOUUMQZXEPUUPXAUU
      MUURXEXAUUMUUODIXDUHUIZVAUUOUUMXEVBUQVCXEBDTUUKUUNBIMUUQUUNUUJBFUUGIIYAUL
      ZBFUPZXDUUGVDZUUMUUHXEUUIXDUUGDUMZXDUUGXCKVGVEVFUUNBITUOUTVHUULUUHXTUEZUU
      GKLZPZFIMZEINYTUUKUVGAEUVDIIXTULZAEUPZXCUVDVDZUUJUVFFIUVJUUIUVEUUHXCUVDUU
      GKVIVJVRUNYSUVGEIYSUUHYRPZFIMZXTIRZUVGYAYGRZYRPZFSUUDUVKPZFSYSUVLUVOUVPFU
      VOUUDUUHQZYRPUVPUVNUVQYRYFUUHGYAIYDYAVDYEUUGDYDYAVKVLVMZVNUUDUUHYRVBVOVPY
      RFYGTUVKFITVQUVMUVKUVFFIUVMUUDQZYRUVEUUHUUDUVMYRUVEVSYAXTVTWAVJWIWBWCWDUQ
      WEYGIUAYQYTYPYFGIWFEFHYGWGWHWJXAXRUUHUUGXCOLZUCZPZFIMZXCUUGOLZYJUEZDRZUWE
      UUGOLZQZHINZPZFIMZQZAINZYPXAXQUWLAIXAXJUWCXPUWKXAUUMXIPZBSUUOUWNPZBSZXJUW
      CXAUWNUWOBXAUWNUURXIPUWOXAUUMUURXIUUSVAUUOUUMXIVBUQVCXIBDTUWCUWNBIMUWPUWN
      UWBBFUUGIIUUTUVAUVBUUMUUHXIUWAUVCUVBXHUVTXDUUGXCOVIWKVEVFUWNBITUOUTXPUWDX
      LUUGOLZCDNZPZFIMXAUWKXOUWSBFUUGIIUUTUVAUVBXKUWDXNUWRXDUUGXCOVGUVBXMUWQCDX
      DUUGXLOVGVHVEVFXAUWSUWJFIXAUWRUWIUWDXAXLDRZUWQQZCUGXLIRZUXAQZCUGZUWRUWIXA
      UXAUXCCXAUXAUXBXAUWTUXBUWQDIXLUHWLUIUJUWQCDUKUWIUXACINUXDUXAUWHCHUWEIIYJU
      LCHUPXLUWEVDUWTUWFUWQUWGXLUWEDUMXLUWEUUGOVIWEUNUXACIUKUOUTVJVRWMWEVHUWMUU
      HUUGUVDOLZUCZPZFIMZUVDUUGOLZUWIPZFIMZQZEINYPUWLUXLAEUVDIIUVHUVIUVJUWCUXHU
      WKUXKUVJUWBUXGFIUVJUWAUXFUUHUVJUVTUXEXCUVDUUGOVGWKVJVRUVJUWJUXJFIUVJUWDUX
      IUWIXCUVDUUGOVIVAVRWEUNYOUXLEIUVMYHUXHYNUXKYHUUHYCPZFIMZUVMUXHUVNYCPZFSUU
      DUXMPZFSYHUXNUXOUXPFUXOUVQYCPUXPUVNUVQYCUVRVNUUDUUHYCVBVOVPYCFYGTUXMFITVQ
      UVMUXMUXGFIUVSYCUXFUUHUVSYBUXEXTYAWNWKVJWIWBUVMYMUXJFIUVSYIUXIYLUWIUUDUVM
      YIUXIVSYAXTWNWAUUDYLUWIVSUVMYLUWFYKQZHINUUDUWIYFUWFYKHGIYDYJVDYEUWEDYDYJV
      KVLWOUUDUXQUWHHIUUDYJIRQYKUWGUWFYAYJWNWPWQWMWRVEWIWEWCWDUQWSWT $.

    $( Closure of supremum of a non-empty bounded set of reals.  (Contributed
       by NM, 12-Oct-2004.) $)
    suprcl $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                  sup ( A , RR , < ) e. RR ) $=
      ( vz cr wss c0 wne cv cle wbr wral wrex w3a clt wor ltso a1i sup3 supcl )
      CEFCGHBIAIJKBCLAEMNZABDECOEOPUAQRABDCST $.

    $( A member of a non-empty bounded set of reals is less than or equal to
       the set's upper bound.  (Contributed by NM, 12-Oct-2004.) $)
    suprub $p |- ( ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x )
                 /\ B e. A ) -> B <_ sup ( A , RR , < ) ) $=
      ( vz cr wss c0 wne cv cle wbr wral wrex w3a wcel wa clt csup wn ltso sup3
      wor a1i supub imp simp1 sselda suprcl adantr lenltd mpbird ) CFGZCHIZBJAJ
      KLBCMAFNZOZDCPZQZDCFRSZKLUSDRLTZUPUQUTUPABEFCDRFRUCUPUAUDABECUBUEUFURDUSU
      PCFDUMUNUOUGUHUPUSFPUQABCUIUJUKUL $.
  $}

  ${
    $d A w x y $.  $d A w z $.  $d B w z $.
    $( The supremum of a non-empty bounded set of reals is the least upper
       bound.  (Contributed by NM, 15-Nov-2004.)  (Revised by Mario Carneiro,
       6-Sep-2014.) $)
    suprlub $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                      E. x e. RR A. y e. A y <_ x ) /\ B e. RR ) ->
                    ( B < sup ( A , RR , < ) <-> E. z e. A B < z ) ) $=
      ( vw cr wss c0 wne cv cle wbr wral wrex w3a wcel wa clt csup wor ltso a1i
      sup3 simp1 suplub2 breq2 cbvrexv syl6bb ) DGHZDIJZBKAKLMBDNAGOZPZEGQREDGS
      TSMEFKZSMZFDOECKZSMZCDOUMABFGDESGSUAUMUBUCABFDUDUJUKULUEUFUOUQFCDUNUPESUG
      UHUI $.

    $( An upper bound is not less than the supremum of a non-empty bounded set
       of reals.  (Contributed by NM, 15-Nov-2004.)  (Revised by Mario
       Carneiro, 6-Sep-2014.) $)
    suprnub $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                      E. x e. RR A. y e. A y <_ x ) /\ B e. RR ) ->
                    ( -. B < sup ( A , RR , < ) <-> A. z e. A -. B < z ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a wcel wa clt csup wn suprlub
      notbid ralnex syl6bbr ) DFGDHIBJAJKLBDMAFNOEFPQZEDFRSRLZTECJRLZCDNZTUGTCD
      MUEUFUHABCDEUAUBUGCDUCUD $.

    $( The supremum of a non-empty bounded set of reals is less than or equal
       to an upper bound.  (Contributed by NM, 18-Mar-2005.)  (Revised by Mario
       Carneiro, 6-Sep-2014.) $)
    suprleub $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                       E. x e. RR A. y e. A y <_ x ) /\ B e. RR ) ->
                  ( sup ( A , RR , < ) <_ B <-> A. z e. A z <_ B ) ) $=
      ( vw cr wss c0 wne cv cle wbr wral wrex w3a wcel wa clt wn suprnub suprcl
      wb lenlt sylan simpl1 sselda simplr lenltd ralbidva 3bitr4d breq1 cbvralv
      csup syl6bb ) DGHZDIJZBKAKLMBDNAGOZPZEGQZRZDGSUNZELMZFKZELMZFDNZCKZELMZCD
      NVAEVBSMTZEVDSMTZFDNVCVFABFDEUAUSVBGQUTVCVIUCABDUBVBEUDUEVAVEVJFDVAVDDQZR
      VDEVADGVDUPUQURUTUFUGUSUTVKUHUIUJUKVEVHFCDVDVGELULUMUO $.
  $}

  ${
    $d A b v w x z $.  $d B b v w x y z $.  $d C b w x $.  $d ph b w $.
    supmul1.1 $e |- C = { z | E. v e. B z = ( A x. v ) } $.
    supmul1.2 $e |- ( ph <-> ( ( A e. RR /\ 0 <_ A /\ A. x e. B 0 <_ x ) /\
        ( B C_ RR /\ B =/= (/) /\ E. x e. RR A. y e. B y <_ x ) ) ) $.
    $( The supremum function distributes over multiplication, in the sense that
       ` A x. ( sup B ) = sup ( A x. B ) ` , where ` A x. B ` is shorthand for
       ` { A x. b | b e. B } ` and is defined as ` C ` below.  This is the
       simple version, with only one set argument; see ~ supmul for the more
       general case with two set arguments.  (Contributed by Mario Carneiro,
       5-Jul-2013.) $)
    supmul1 $p |- ( ph ->
      ( A x. sup ( B , RR , < ) ) = sup ( C , RR , < ) ) $=
      ( vw vb cr clt cle wbr wa wcel cc0 adantr csup cmul co wceq wral wrex vex
      wn cv oveq2 eqeq2d cbvrexv eqeq1 rexbidv syl5bb elab2 wss wne simpr sylbi
      c0 w3a simp1d sselda suprcl syl simpl1 simpl2 jca suprub lemul2a syl31anc
      sylan breq1 syl5ibrcom rexlimdva syl5bi ralrimiv wb remulcld eleq1a ssrdv
      wi wex simpr2 isseti rgenw r19.2z sylancl exbii n0 rexcom4 3bitr4i sylibr
      ovex breq2 ralbidv rspcev syl2anc 3jca suprleub mpbird 0re simpl3 rspccva
      cdiv a1i letrd ex exlimdv mpd imp mulge0d anim1i lelttr prodgt02 syl22anc
      syl3anc ltdivmul syl112anc gt0ne0d redivcld suprlub mpbid simplrr adantlr
      rspe adantl eqbrtrrd mpdan expr mpi ad2antrr lenltd mtbird nrexdv eqleltd
      pm2.65da eqcomd ) AHMNUAZFGMNUAZUBUCZAYTUUBUDYTUUBOPZYTUUBNPZUHZQAUUCUUEA
      UUCKUIZUUBOPZKHUEZAUUGKHUUFHRZUUFFLUIZUBUCZUDZLGUFZAUUGDUIZFEUIZUBUCZUDZE
      GUFZUUMDUUFHKUGUURUUNUUKUDZLGUFUUNUUFUDZUUMUUQUUSELGUUOUUJUDUUPUUKUUNUUOU
      UJFUBUJUKULUUTUUSUULLGUUNUUFUUKUMUNUOIUPZAUULUUGLGAUUJGRZQZUUGUULUUKUUBOP
      ZUVCUUJMRZUUAMRZFMRZSFOPZQZUUJUUAOPZUVDAGMUUJAGMUQZGVAURZCUIBUIZOPCGUEBMU
      FZAUVGUVHSUVMOPZBGUEZVBZUVKUVLUVNVBZQZUVRJUVQUVRUSUTZVCVDZAUVFUVBAUVRUVFU
      VTBCGVEVFZTZAUVIUVBAUVGUVHAUVSUVGJUVGUVHUVPUVRVGUTZAUVSUVHJUVGUVHUVPUVRVH
      UTZVITAUVRUVBUVJUVTBCGUUJVJVMZUUJUUAFVKVLUUFUUKUUBOVNVOVPVQVRZAHMUQZHVAUR
      ZUUFUVMOPZKHUEZBMUFZVBZUUBMRZUUCUUHVSAUWHUWIUWLAKHMUUIUUMAUUFMRZUVAAUULUW
      OLGUVCUUKMRZUULUWOWCUVCFUUJAUVGUVBUWDTZUWAVTZUUKMUUFWAVFVPVQZWBAUULKWDZLG
      UFZUWIAUVLUWTLGUEUXAAUVSUVLJUVQUVKUVLUVNWEUTZUWTLGKUUKFUUJUBWOWFZWGUWTLGW
      HWIUUIKWDZUUMKWDUWIUXAUUIUUMKUVAWJKHWKZUULLKGWLWMWNZAUWNUUHUWLAFUUAUWDUWB
      VTZUWGUWKUUHBUUBMUVMUUBUDUWJUUGKHUVMUUBUUFOWPWQWRWSWTZUXGBKKHUUBXAWSXBAUU
      DYTFXFUCZUUJNPZLGUFZAUUDQZUXIUUANPZUXKUXLUXMUUDAUUDUSUXLYTMRZUVFUVGSFNPZU
      XMUUDVSAUXNUUDAUWMUXNUXHBKHVEVFZTZAUVFUUDUWBTZAUVGUUDUWDTZUXLUVGUVFSUUAOP
      ZSUUBNPZUXOUXSUXRAUXTUUDAUVLUXTUXBUVLUVBLWDAUXTLGWKAUVBUXTLAUVBUXTUVCSUUJ
      UUASMRZUVCXCXGUWAUWCAUVPUVBSUUJOPZAUVSUVPJUVGUVHUVPUVRXDUTUVOUYCBUUJGUVMU
      UJSOWPXEVMZUWFXHXIXJVQXKTUXLSYTOPZUUDQZUYAAUYEUUDAUWIUYEUXFUWIUXDAUYEUXEA
      UUIUYEKAUUIUYEAUUIQZSUUFYTUYBUYGXCXGAUUIUWOUWSXLAUXNUUIUXPTAUUISUUFOPZUUI
      UUMAUYHUVAAUULUYHLGUVCUYHUULSUUKOPUVCFUUJUWQUWAAUVHUVBUWETUYDXMUUFUUKSOWP
      VOVPVQXLAUWMUUIUUFYTOPZUXHBKHUUFVJVMZXHXIXJVQXKXNAUYFUYAWCZUUDAUYBUXNUWNU
      YKUYBAXCXGUXPUXGSYTUUBXOXRTXKFUUAXPXQZYTUUAFXSXTXBUXLUVRUXIMRUXMUXKVSAUVR
      UUDUVTTUXLYTFUXQUXSUXLFUYLYAYBBCLGUXIYCWSYDUXLUXJLGUXLUVBQZUXJYTUUKNPZUYM
      UUKYTOPZUYNUHAUVBUYOUUDUVCUWTUYOUXCUVCUULUYOKAUVBUULUYOAUVBUULQZQZUUIUYOU
      YPUUIAUYPUUMUUIUULLGYGUVAWNYHUYQUUIQUUFUUKYTOAUVBUULUUIYEAUUIUYIUYPUYJYFY
      IYJYKXJYLYFUYMUUKYTAUVBUWPUUDUWRYFAUXNUUDUVBUXPYMZYNYDUYMUXNUVEUVGUXOUXJU
      YNVSUYRAUVBUVEUUDUWAYFAUVGUUDUVBUWDYMUXLUXOUVBUYLTYTUUJFXSXTYOYPYRVIAYTUU
      BUXPUXGYQXBYS $.
  $}

  ${
    $d A a b v x y w z $.  $d B a b v x y w z $.  $d C a x w $.
    $d ph a b w z $.
    supmul.1 $e |- C = { z | E. v e. A E. b e. B z = ( v x. b ) } $.
    supmul.2 $e |- ( ph <-> ( ( A. x e. A 0 <_ x /\ A. x e. B 0 <_ x ) /\
        ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) /\
        ( B C_ RR /\ B =/= (/) /\ E. x e. RR A. y e. B y <_ x ) ) ) $.
    $( Lemma for ~ supmul .  (Contributed by Mario Carneiro, 5-Jul-2013.) $)
    supmullem1 $p |- ( ph -> A. w e. C
        w <_ ( sup ( A , RR , < ) x. sup ( B , RR , < ) ) ) $=
      ( va cv cr cle wbr wcel wrex cc0 clt csup cmul wceq vex weq oveq1 rexbidv
      co eqeq2d cbvrexv eqeq1 2rexbidv syl5bb elab2 wa wss wne wral w3a simp2bi
      wi c0 simp1d sselda adantrr suprcl syl adantr simp3bi adantrl sylbi breq2
      simp1l rspccv simp1r suprub sylan lemul12ad breq1 biimprcd syl6 rexlimdvv
      imp ex syl5bi ralrimiv ) AENZGOUAUBZHOUAUBZUCUIZPQZEIWHIRWHMNZJNZUCUIZUDZ
      JHSMGSZAWLDNZFNZWNUCUIZUDZJHSZFGSZWQDWHIEUEXCWRWOUDZJHSZMGSDEUFZWQXBXEFMG
      FMUFZXAXDJHXGWTWOWRWSWMWNUCUGUJUHUKXFXDWPMJGHWRWHWOULUMUNKUOAWPWLMJGHAWMG
      RZWNHRZUPZWOWKPQZWPWLVBAXJXKAXJUPWMWIWNWJAXHWMORXIAGOWMAGOUQZGVCURZCNBNZP
      QZCGUSBOSZATXNPQZBGUSZXQBHUSZUPZXLXMXPUTZHOUQZHVCURZXOCHUSBOSZUTZLVAZVDVE
      VFAWIORZXJAYAYGYFBCGVGVHVIAXIWNORXHAHOWNAYBYCYDAXTYAYELVJZVDVEVKAWJORZXJA
      YEYIYHBCHVGVHVIAXHTWMPQZXIAXHYJAXRXHYJVBAXTYAYEUTZXRLXRXSYAYEVNVLXQYJBWMG
      XNWMTPVMVOVHWDVFAXITWNPQZXHAXIYLAXSXIYLVBAYKXSLXRXSYAYEVPVLXQYLBWNHXNWNTP
      VMVOVHWDVKAXHWMWIPQZXIAYAXHYMYFBCGWMVQVRVFAXIWNWJPQZXHAYEXIYNYHBCHWNVQVRV
      KVSWEWPWLXKWHWOWKPVTWAWBWCWFWG $.

    $( Lemma for ~ supmul .  (Contributed by Mario Carneiro, 5-Jul-2013.) $)
    supmullem2 $p |- ( ph ->
        ( C C_ RR /\ C =/= (/) /\ E. x e. RR A. w e. C w <_ x ) ) $=
      ( va cr cv cle wral wrex wcel wceq wss c0 wne wbr cmul vex eqeq2d rexbidv
      co oveq1 cbvrexv eqeq1 2rexbidv syl5bb elab2 wa wi cc0 w3a simp2bi simp1d
      sseld simp3bi anim12d remulcl syl6 eleq1a rexlimdvv syl5bi ssrdv wex ovex
      simp2d isseti rgenw r19.2z sylancl rexcom4 sylib ralrimivw n0 exbii bitri
      syl2anc sylibr clt csup suprcl syl remulcld supmullem1 breq2 ralbidv 3jca
      rspcev ) AINUAIUBUCZEOZBOZPUDZEIQZBNRZAEINWQISZWQMOZJOZUEUIZTZJHRZMGRZAWQ
      NSZDOZFOZXDUEUIZTZJHRZFGRZXHDWQIEUFXOXJXETZJHRZMGRXJWQTZXHXNXQFMGXKXCTZXM
      XPJHXSXLXEXJXKXCXDUEUJUGUHUKXRXPXFMJGHXJWQXEULUMUNKUOZAXFXIMJGHAXCGSZXDHS
      ZUPZXENSZXFXIUQAYCXCNSZXDNSZUPYDAYAYEYBYFAGNXCAGNUAZGUBUCZCOWRPUDZCGQBNRZ
      AURWRPUDZBGQYKBHQUPZYGYHYJUSZHNUAZHUBUCZYICHQBNRZUSZLUTZVAVBAHNXDAYNYOYPA
      YLYMYQLVCZVAVBVDXCXDVEVFXENWQVGVFVHVIVJAXHEVKZWPAXGEVKZMGRZYTAYHUUAMGQUUB
      AYGYHYJYRVMAUUAMGAXFEVKZJHRZUUAAYOUUCJHQUUDAYNYOYPYSVMUUCJHEXEXCXDUEVLVNV
      OUUCJHVPVQXFJEHVRVSVTUUAMGVPWDXGMEGVRVSWPXBEVKYTEIWAXBXHEXTWBWCWEAGNWFWGZ
      HNWFWGZUEUIZNSWQUUGPUDZEIQZXAAUUEUUFAYMUUENSYRBCGWHWIAYQUUFNSYSBCHWHWIWJA
      BCDEFGHIJKLWKWTUUIBUUGNWRUUGTWSUUHEIWRUUGWQPWLWMWOWDWN $.

    $( The supremum function distributes over multiplication, in the sense that
       ` ( sup A ) x. ( sup B ) = sup ( A x. B ) ` , where ` A x. B ` is
       shorthand for ` { a x. b | a e. A , b e. B } ` and is defined as ` C `
       below.  We made use of this in our definition of multiplication in the
       Dedekind cut construction of the reals (see ~ df-mp ).  (Contributed by
       Mario Carneiro, 5-Jul-2013.)  (Revised by Mario Carneiro,
       6-Sep-2014.) $)
    supmul $p |- ( ph ->
      ( sup ( A , RR , < ) x. sup ( B , RR , < ) ) = sup ( C , RR , < ) ) $=
      ( va vw cr wceq cle wbr wrex wcel wral clt csup cmul co cv cab wss c0 wne
      w3a cc0 wa simp2bi suprcl syl simp3bi cc mulcom syl2an syl2anc wex simp2d
      n0 sylib 0re a1i simp1d sselda adantr wi simp1r sylbi breq2 rspccv suprub
      recn imp sylan letrd exlimddv simp1l eqid biid supmul1 syl31anc eqtrd vex
      eqeq1 rexbidv elab rspe oveq1 eqeq2d cbvrexv 2rexbidv syl5bb elab2 sylibr
      ex supmullem2 sylan9r syl5bi ralrimiv wb remulcld eleq1a rexlimdva abssdv
      adantlr ovex isseti r19.2z sylancl rexcom4 cbvexv ralbidv rspcev suprleub
      rgenw abn0 mpbird eqbrtrd breq1 syl5ibrcom supmullem1 letri3d mpbir2and )
      AFNUAUBZGNUAUBZUCUDZHNUAUBZOYJYKPQYKYJPQZAYJDUEZYILUEZUCUDZOZLFRZDUFZNUAU
      BZYKPAYJYIYHUCUDZYSAYHNSZYINSZYJYTOZAFNUGZFUHUIZCUEBUEZPQZCFTBNRZUJZUUAAU
      KUUFPQZBFTZUUJBGTZULZUUIGNUGZGUHUIZUUGCGTBNRZUJZKUMZBCFUNUOZAUUQUUBAUUMUU
      IUUQKUPZBCGUNUOZUUAYHUQSYIUQSZUUCUUBYHVPYIVPZYHYIURUSUTAUUBUKYIPQZUUKUUIY
      TYSOUVAAIUEZGSZUVDIAUUOUVFIVAAUUNUUOUUPUUTVBZIGVCVDAUVFULZUKUVEYIUKNSUVHV
      EVFAGNUVEAUUNUUOUUPUUTVGVHZAUUBUVFUVAVIAUVFUKUVEPQZAUULUVFUVJVJAUUMUUIUUQ
      UJZUULKUUKUULUUIUUQVKVLZUUJUVJBUVEGUUFUVEUKPVMVNUOVQAUUQUVFUVEYIPQUUTBCGU
      VEVOVRVSVTAUVKUUKKUUKUULUUIUUQWAVLZUURUUBUVDUUKUJUUIULZBCDLYIFYRYRWBUVNWC
      WDWEWFAYSYKPQZMUEZYKPQZMYRTZAUVQMYRUVPYRSUVPYOOZLFRZAUVQYQUVTDUVPMWGZYMUV
      POZYPUVSLFYMUVPYOWHWIWJAUVSUVQLFAYNFSZULZUVQUVSYOYKPQUWDYOYNYIUCUDZYKPUWD
      UUBYNNSZYOUWEOZAUUBUWCUVAVIZAFNYNAUUDUUEUUHUURVGVHZUUBUVBYNUQSUWGUWFUVCYN
      VPYIYNURUSUTUWDUWEYMYNUVEUCUDZOZIGRZDUFZNUAUBZYKPUWDUWFUKYNPQZUULUUQUWEUW
      NOUWIAUWCUWOAUUKUWCUWOVJUVMUUJUWOBYNFUUFYNUKPVMVNUOVQAUULUWCUVLVIAUUQUWCU
      UTVIUWFUWOUULUJUUQULZBCDIYNGUWMUWMWBUWPWCWDWEUWDUWNYKPQZUVQMUWMTZUWDUVQMU
      WMUVPUWMSUVPUWJOZIGRZUWDUVQUWLUWTDUVPUWAUWBUWKUWSIGYMUVPUWJWHZWIZWJUWCUWT
      UVPHSZAUVQUWCUWTUXCUWCUWTULUWTLFRZUXCUWTLFWKYMEUEZUVEUCUDZOZIGRZEFRZUXDDU
      VPHUWAUXIUWLLFRUWBUXDUXHUWLELFUXEYNOZUXGUWKIGUXJUXFUWJYMUXEYNUVEUCWLWMWIW
      NUWBUWKUWSLIFGUXAWOWPJWQWRWSAHNUGHUHUIUVPUUFPQZMHTBNRUJZUXCUVQVJABCDMEFGH
      IJKWTZUXLUXCUVQBMHUVPVOWSUOXAXBXCZUWDUWMNUGUWMUHUIZUXKMUWMTZBNRZYKNSZUWQU
      WRXDUWDUWLDNUWDUWKYMNSZIGUWDUVFULZUWJNSUWKUXSVJUXTYNUVEUWDUWFUVFUWIVIAUVF
      UVENSUWCUVIXIXEUWJNYMXFUOXGXHAUXOUWCAUWLDVAZUXOAUWTMVAZUYAAUWSMVAZIGRZUYB
      AUUOUYCIGTUYDUVGUYCIGMUWJYNUVEUCXJXKXSUYCIGXLXMUWSIMGXNVDUWLUWTDMUXBXOWRU
      WLDXTWRVIUWDUXRUWRUXQAUXRUWCAUXLUXRUXMBMHUNUOZVIZUXNUXPUWRBYKNUUFYKOZUXKU
      VQMUWMUUFYKUVPPVMZXPXQUTUYFBMMUWMYKXRWEYAYBYBUVPYOYKPYCYDXGXBXCZAYRNUGYRU
      HUIZUXKMYRTZBNRZUXRUVOUVRXDAYQDNAYPUXSLFUWDYONSYPUXSVJUWDYIYNUWHUWIXEYONY
      MXFUOXGXHAYQDVAZUYJAYPDVAZLFRZUYMAUUEUYNLFTUYOAUUDUUEUUHUURVBUYNLFDYOYIYN
      UCXJXKXSUYNLFXLXMYPLDFXNVDYQDXTWRAUXRUVRUYLUYEUYIUYKUVRBYKNUYGUXKUVQMYRUY
      HXPXQUTUYEBMMYRYKXRWEYAYBAYLUVPYJPQMHTZABCDMEFGHIJKYEAUXLYJNSYLUYPXDUXMAY
      HYIUUSUVAXEZBMMHYJXRUTYAAYJYKUYQUYEYFYG $.
  $}

  ${
    $d x y z A $.
    sup3i.1 $e |- ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) $.
    $( A version of the completeness axiom for reals.  (Contributed by NM,
       23-Aug-1999.) $)
    sup3ii $p |- E. x e. RR ( A. y e. A -. x < y /\
                  A. y e. RR ( y < x -> E. z e. A y < z ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a clt wn wi wa sup3 ax-mp ) DFGDHI
      BJZAJZKLBDMAFNOUCUBPLQBDMUBUCPLUBCJPLCDNRBFMSAFNEABCDTUA $.

    $( Closure of supremum of a non-empty bounded set of reals.  (Contributed
       by NM, 12-Sep-1999.) $)
    suprclii $p |- sup ( A , RR , < ) e. RR $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a clt csup wcel suprcl ax-mp ) CEF
      CGHBIAIJKBCLAEMNCEOPEQDABCRS $.

    $( A member of a non-empty bounded set of reals is less than or equal to
       the set's upper bound.  (Contributed by NM, 12-Sep-1999.) $)
    suprubii $p |- ( B e. A -> B <_ sup ( A , RR , < ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a wcel clt csup suprub mpan ) CFGC
      HIBJAJKLBCMAFNODCPDCFQRKLEABCDST $.

    $d z B $.
    $( The supremum of a non-empty bounded set of reals is the least upper
       bound.  (Contributed by NM, 15-Oct-2004.)  (Revised by Mario Carneiro,
       6-Sep-2014.) $)
    suprlubii $p |- ( B e. RR ->
      ( B < sup ( A , RR , < ) <-> E. z e. A B < z ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a wcel clt csup wb suprlub mpan )
      DGHDIJBKAKLMBDNAGOPEGQEDGRSRMECKRMCDOTFABCDEUAUB $.

    $( An upper bound is not less than the supremum of a non-empty bounded set
       of reals.  (Contributed by NM, 15-Oct-2004.)  (Revised by Mario
       Carneiro, 6-Sep-2014.) $)
    suprnubii $p |- ( B e. RR ->
      ( -. B < sup ( A , RR , < ) <-> A. z e. A -. B < z ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a wcel clt csup wn wb suprnub mpan
      ) DGHDIJBKAKLMBDNAGOPEGQEDGRSRMTECKRMTCDNUAFABCDEUBUC $.

    $( The supremum of a non-empty bounded set of reals is less than or equal
       to an upper bound.  (Contributed by NM, 18-Mar-2005.)  (Revised by Mario
       Carneiro, 6-Sep-2014.) $)
    suprleubii $p |- ( B e. RR ->
      ( sup ( A , RR , < ) <_ B <-> A. z e. A z <_ B ) ) $=
      ( cr wss c0 wne cv cle wbr wral wrex w3a wcel clt csup wb suprleub mpan )
      DGHDIJBKAKLMBDNAGOPEGQDGRSELMCKELMCDNTFABCDEUAUB $.
  $}

  ${
    $d x y z $.  $d z A $.  $d y z ph $.  $d x z ps $.
    riotaneg.1 $e |- ( x = -u y -> ( ph <-> ps ) ) $.
    $( The negative of the unique real such that ` ph ` .  (Contributed by NM,
       13-Jun-2005.) $)
    riotaneg $p |- ( E! x e. RR ph ->
                ( iota_ x e. RR ph ) = -u ( iota_ y e. RR ps ) ) $=
      ( wtru cr wreu crio cneg wceq tru nfriota1 nfneg wcel renegcl adantl recn
      cv cc wa simpr renegcld negeq wb negcon2 syl2an reuhyp riotaxfrd mpan ) F
      ACGHACGIBDGIZJZKLFABCDGDSZJZULDUKBDGMNUMGOZUNGOFUMPQFUKGOZUAUKFUPUBUCEUMU
      KUDCSZGOZUQUNKZDGHFCDUNUQJZGUQPURUQTOUMTOUSUMUTKUEUOUQRUMRUQUMUFUGUHQUIUJ
      $.
  $}

  ${
    $d x y z $.  $d y z F $.
    negiso.1 $e |- F = ( x e. RR |-> -u x ) $.
    $( Negation is an order anti-isomorphism of the real numbers, which is its
       own inverse.  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    negiso $p |- ( F Isom < , `' < ( RR , RR ) /\ `' F = F ) $=
      ( vz vy cr clt ccnv wceq cv wbr cfv wb wral cneg cmpt wa wtru wcel negeq
      wiso wf1o simpr renegcld recn negcon2 syl2an adantl f1ocnv2d simpli ltneg
      cc trud negex brcnv syl6bbr fvmpt breqan12d bitr4d rgen2a df-isom cbvmptv
      mpbir2an simpri 3eqtr4i pm3.2i ) FFGGHZBUAZBHZBIVHFFBUBZDJZEJZGKZVKBLZVLB
      LZVGKZMZEFNDFNVJVIEFVLOZPZIZVJVTQRAEFFAJZOZVRBCRWAFSZQWARWCUCUDRVLFSZQVLR
      WDUCUDWCWDQWAVRIVLWBIMZRWCWAULSVLULSWEWDWAUEVLUEWAVLUFUGUHUIUMZUJVQDEFVKF
      SZWDQZVMVKOZVRVGKZVPWHVMVRWIGKWJVKVLUKWIVRGVKUNZVLUNZUOUPWGWDVNWIVOVRVGAV
      KWBWIFBWAVKTCWKUQAVLWBVRFBWAVLTCWLUQURUSUTDEFFGVGBVAVCVSAFWBPVIBEAFVRWBVL
      WATVBVJVTWFVDCVEVF $.
  $}

  ${
    $d x y z w v u t A $.  $d x y z B $.
    $( The infimum (expressed as supremum with converse 'less-than') of a set
       of reals ` A ` .  (Contributed by NM, 9-Oct-2005.) $)
    dfinfmr $p |- ( A C_ RR -> sup ( A , RR , `' < ) = U. { x e. RR |
        ( A. y e. A x <_ y /\ A. y e. RR ( x < y -> E. z e. A z < y ) ) } ) $=
      ( cr wss clt cv wbr wn wral wrex wi wa crab cuni wcel wb vex brcnv df-sup
      ccnv csup ssel2 lenlt notbii syl6rbbr sylan2 ancoms an32s ralbidva rexbii
      cle imbi12i ralbii a1i anbi12d rabbidva unieqd syl5eq ) DEFZDEGUBZUCAHZBH
      ZVBIZJZBDKZVDVCVBIZVDCHZVBIZCDLZMZBEKZNZAEOZPVCVDUMIZBDKZVCVDGIZVIVDGIZCD
      LZMZBEKZNZAEOZPABCDEVBUAVAVOWDVAVNWCAEVAVCEQZNZVGVQVMWBWFVFVPBDVAVDDQZWEV
      FVPRZWEVAWGNZWHWIWEVDEQZWHDEVDUDWEWJNVPVDVCGIZJVFVCVDUEVEWKVCVDGASZBSZTUF
      UGUHUIUJUKVMWBRWFVLWABEVHVRVKVTVDVCGWMWLTVJVSCDVDVIGWMCSTULUNUOUPUQURUSUT
      $.

    $( The infimum (expressed as supremum with converse 'less-than') of a set
       of reals ` A ` is the negative of the supremum of the negatives of its
       elements.  The antecedent ensures that ` A ` is nonempty and has a lower
       bound.  (Contributed by NM, 14-Jun-2005.)  (Proof shortened by Mario
       Carneiro, 24-Dec-2016.) $)
    infmsup $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                   sup ( A , RR , `' < ) =
                 -u sup ( { z e. RR | -u z e. A } , RR , < ) ) $=
      ( vw cr cv wbr wral wrex clt ccnv csup cneg wcel wor mpbi vex brcnv wiso
      wss c0 wne cle w3a crab ltso cnvso a1i wn wi notbii ralbii rexbii imbi12i
      wa infm3 anbi12i sylibr supcl recnd negnegd cmpt cima eqid mptpreima wceq
      cfv negiso simpri imaeq1i eqtr3i supeq1i simpli isocnv ax-mp isoeq1 simp1
      wb supiso syl5eq negeq negex fvmpt syl eqtr2d negeqd eqtr3d ) DFUAZDUBUCZ
      AGZBGZUDHBDIAFJZUEZDFKLZMZNZNWPCGZNZDOCFUFZFKMZNWNWPWNWPWNABEFDWOFWOPZWNF
      KPXBUGFKUHQUIZWNWLWKKHZUJZBDIZWKWLKHZEGZWLKHZEDJZUKZBFIZUPZAFJWKWLWOHZUJZ
      BDIZWLWKWOHZWLXHWOHZEDJZUKZBFIZUPZAFJABEDUQYBXMAFXPXFYAXLXOXEBDXNXDWKWLKA
      RZBRZSULUMXTXKBFXQXGXSXJWLWKKYDYCSXRXIEDWLXHKYDERSUNUOUMURUNUSZUTZVAVBWNW
      QXAWNXAWPCFWSVCZVHZWQWNXAYGDVDZFKMYHFWTYIKYGLZDVDWTYICFWSDYGYGVEZVFYJYGDF
      FKWOYGTZYJYGVGZCYGYKVIZVJZVKVLVMWNABEFFDWOKYGFFWOKYGTZWNFFWOKYJTZYPYLYQYL
      YMYNVNFFKWOYGVOVPYMYQYPVSYOFFWOKYGYJVQVPQUIWIWJWMVRYEXCVTWAWNWPFOYHWQVGYF
      CWPWSWQFYGWRWPWBYKWPWCWDWEWFWGWH $.

    $( Closure of infimum of a non-empty bounded set of reals.  (Contributed by
       NM, 8-Oct-2005.) $)
    infmrcl $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                  sup ( A , RR , `' < ) e. RR ) $=
      ( vv vw vz cr wss c0 wne cv cle wbr wral wrex clt cneg wcel wa wceq ssel2
      w3a ccnv csup crab infmsup wex n0 ssel renegcl syl6 recnd negnegd eqeltrd
      simpr ex jcad negeq eleq1d elrab sylbir exlimdv imp sylan2b 3adant3 breq2
      wi rspcva adantll wb lenegcon2 adantrr adantr mpbid exp31 syl5bi ralrimdv
      ne0i ralbidv rspcev ee12an rexlimiv 3ad2ant3 ssrab2 suprcl mp3an1 syl2anc
      com23 renegcld ) CGHZCIJZAKZBKZLMZBCNZAGOZUBZCGPUCUDDKZQZCRZDGUEZGPUDZQGA
      BDCUFWQXBWQXAIJZEKZFKZLMZEXANZFGOZXBGRZWJWKXCWPWKWJXECRZFUGZXCFCUHWJXKXCW
      JXJXCFWJXJXEQZGRZXLQZCRZSZXCWJXJXMXOWJXJXEGRXMCGXEUIXEUJUKWJXJXOWJXJSZXNX
      ECXQXEXQXECGXEUAULUMWJXJUOUNUPUQXPXLXARXCWTXODXLGWRXLTWSXNCWRXLURUSUTXAXL
      VRVAUKVBVCVDVEWPWJXHWKWOXHAGWLGRZWLQZGRWOXDXSLMZEXANZXHWLUJXRWOXTEXAXRXDX
      ARZWOXTYBXDGRZXDQZCRZSZXRWOXTVGWTYEDXDGWRXDTWSYDCWRXDURUSUTXRYFWOXTXRYFSZ
      WOSWLYDLMZXTYFWOYHXRYEWOYHYCWNYHBYDCWMYDWLLVFVHVIVIYGYHXTVJZWOXRYCYIYEWLX
      DVKVLVMVNVOVPWHVQXGYAFXSGXEXSTXFXTEXAXEXSXDLVFVSVTWAWBWCXAGHXCXHXIWTDGWDF
      EXAWEWFWGWIUN $.
  $}

  ${
    $d w x y A $.  $d w z A $.  $d w z B $.
    $( Any lower bound of a nonempty set of real numbers is less than or equal
       to its infimum.  (Contributed by Jeff Hankins, 1-Sep-2013.)  (Revised by
       Mario Carneiro, 6-Sep-2014.) $)
    infmrgelb $p |- ( ( ( A C_ RR /\ A =/= (/) /\
                        E. x e. RR A. y e. A x <_ y ) /\ B e. RR ) ->
                      ( B <_ sup ( A , RR , `' < ) <-> A. z e. A B <_ z ) ) $=
      ( vw cr cv cle wbr wral wrex wcel wa clt wn wor vex brcnv notbid wss ccnv
      c0 wne w3a csup ltso cnvso mpbi a1i wi infm3 notbii ralbii rexbii imbi12i
      anbi12i sylibr simp1 suplub2 ralnex syl6bbr wb simpr infmrcl adantr lenlt
      brcnvg bitr4d syl2anc simpl1 sselda ralbidva 3bitr4d breq2 cbvralv syl6bb
      ) DGUAZDUCUDZAHZBHZIJBDKAGLZUEZEGMZNZEDGOUBZUFZIJZEFHZIJZFDKZECHZIJZCDKWE
      EWGWFJZPZEWIWFJZPZFDKZWHWKWEWOWPFDLZPWRWEWNWSWCABFGDEWFGWFQZWCGOQWTUGGOUH
      UIUJWCWAVTOJZPZBDKZVTWAOJZWIWAOJZFDLZUKZBGKZNZAGLVTWAWFJZPZBDKZWAVTWFJZWA
      WIWFJZFDLZUKZBGKZNZAGLABFDULXRXIAGXLXCXQXHXKXBBDXJXAVTWAOARZBRZSUMUNXPXGB
      GXMXDXOXFWAVTOXTXSSXNXEFDWAWIOXTFRSUOUPUNUQUOURVRVSWBUSUTTWPFDVAVBWEWDWGG
      MZWHWOVCWCWDVDZWCYAWDABDVEVFWDYANZWHWGEOJZPWOEWGVGYCWNYDEWGGGOVHTVIVJWEWJ
      WQFDWEWIDMZNWDWIGMZWJWQVCWEWDYEYBVFWEDGWIVRVSWBWDVKVLWDYFNZWJWIEOJZPWQEWI
      VGYGWPYHEWIGGOVHTVIVJVMVNWJWMFCDWIWLEIVOVPVQ $.
  $}

  ${
    $d x y z B $.
    $( If a nonempty set of real numbers has a lower bound, its infimum is less
       than or equal to any of its elements.  (Contributed by Jeff Hankins,
       15-Sep-2013.) $)
    infmrlb $p |- ( ( B C_ RR /\ E. x e. RR A. y e. B x <_ y /\ A e. B ) ->
                      sup ( B , RR , `' < ) <_ A ) $=
      ( vz cr cv cle wbr wral wrex wcel clt wn wor wi wa syl3anc vex brcnv ccnv
      wss w3a csup simp3 ltso cnvso mpbi a1i c0 simp1 ne0i 3ad2ant3 simp2 infm3
      wne notbii ralbii rexbii imbi12i anbi12i sylibr supub mpd infmrcl 3adant2
      ssel2 lenltd wb brcnvg syl2anc notbid bitr4d mpbird ) DFUBZAGZBGZHIBDJAFK
      ZCDLZUCZDFMUAZUDZCHIZWBCWAIZNZVTVSWEVOVRVSUEZVTABEFDCWAFWAOZVTFMOWGUFFMUG
      UHUIVTVQVPMIZNZBDJZVPVQMIZEGZVQMIZEDKZPZBFJZQZAFKZVPVQWAIZNZBDJZVQVPWAIZV
      QWLWAIZEDKZPZBFJZQZAFKVTVODUJUPZVRWRVOVRVSUKZVSVOXHVRDCULUMZVOVRVSUNZABED
      UORXGWQAFXAWJXFWPWTWIBDWSWHVPVQMASZBSZTUQURXEWOBFXBWKXDWNVQVPMXMXLTXCWMED
      VQWLMXMESTUSUTURVAUSVBVCVDVTWCCWBMIZNWEVTWBCVTVOXHVRWBFLZXIXJXKABDVERZVOV
      SCFLVRDFCVGVFVHVTWDXNVTXOVSWDXNVIXPWFWBCFDMVJVKVLVMVN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Imaginary and complex number properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The imaginary unit ` _i ` is not a real number.  (Contributed by NM,
     6-May-1999.) $)
  inelr $p |- -. _i e. RR $=
    ( ci cr wcel cc0 wceq ine0 neii cmul co clt wbr wn c1 0re 1re ltnsymi ax-mp
    0lt1 caddc cneg ixi renegcli eqeltri ltadd1i ax-1cn addid2i ax-i2m1 breq12i
    bitri mtbir wne msqgt0 ex necon1bd mpi mto ) ABCZADEZADFGUQDAAHIZJKZLURUTMD
    JKZDMJKVALRDMNOPQUTDMSIZUSMSIZJKVADUSMNUSMTBUAMOUBUCOUDVBMVCDJMUEUFUGUHUIUJ
    UQUTADUQADUKUTAULUMUNUOUP $.

  $( A real number times the imaginary unit is real only if the number is 0.
     (Contributed by NM, 28-May-1999.)  (Revised by Mario Carneiro,
     27-May-2016.) $)
  rimul $p |- ( ( A e. RR /\ ( _i x. A ) e. RR ) -> A = 0 ) $=
    ( cr wcel ci cmul co wa wn cc0 wceq inelr cdiv cc ax-icn simpll recnd simpr
    wne a1i divcan4d simplr redivcld eqeltrrd ex necon1bd mpi ) ABCZDAEFZBCZGZD
    BCZHAIJKUJUKAIUJAIRZUKUJULGZUHALFDBUMDADMCUMNSUMAUGUIULOZPUJULQZTUMUHAUGUIU
    LUAUNUOUBUCUDUEUF $.

  $( The representation of complex numbers in terms of real and imaginary parts
     is unique.  Proposition 10-1.3 of [Gleason] p. 130.  (Contributed by NM,
     9-May-1999.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  cru $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) ) ->
      ( ( A + ( _i x. B ) ) = ( C + ( _i x. D ) ) <-> ( A = C /\ B = D ) ) ) $=
    ( cr wcel wa ci cmul co caddc wceq simplrl simplll cmin cc0 mulcld resubcld
    recnd subeq0d simpr cc ax-icn a1i simpllr simplrr addsubeq4d subdid eqeltrd
    mpbid eqtr4d rimul syl2anc oveq2d oveq1d subidd 3eqtrd eqcomd jca ex oveq12
    oveq2 sylan2 impbid1 ) AEFZBEFZGZCEFZDEFZGZGZAHBIJZKJCHDIJZKJLZACLZBDLZGZVK
    VNVQVKVNGZVOVPVRCAVRCAVRCVGVHVIVNMZSZVRAVEVFVJVNNZSZVRCAOJZVLVMOJZVMVMOJPVR
    VNWCWDLVKVNUAVRAVLCVMWBVRHBHUBFVRUCUDZVRBVEVFVJVNUEZSZQVTVRHDWEVRDVGVHVIVNU
    FZSZQZUGUJZVRVLVMVMOVRBDHIVRBDWGWIVRBDOJZEFHWLIJZEFWLPLVRBDWFWHRVRWMWCEVRWM
    WDWCVRHBDWEWGWIUHWKUKVRCAVSWARUIWLULUMTZUNUOVRVMWJUPUQTURWNUSUTVPVOVLVMLVNB
    DHIVBACVLVMKVAVCVD $.

  $( The real representation of complex numbers is nonzero iff one of its terms
     is nonzero.  (Contributed by NM, 29-Apr-2005.)  (Proof shortened by Mario
     Carneiro, 27-May-2016.) $)
  crne0 $p |- ( ( A e. RR /\ B e. RR ) ->
    ( ( A =/= 0 \/ B =/= 0 ) <-> ( A + ( _i x. B ) ) =/= 0 ) ) $=
    ( cr wcel wa ci cmul co caddc cc0 wne wceq wn wo ax-icn mul01i oveq2i eqtri
    00id 0re eqeq2i wb cru mpanr12 syl5bbr necon3abid neorian syl6rbbr ) ACDBCD
    EZAFBGHIHZJKAJLBJLEZMAJKBJKNUIUKUJJUJJLUJJFJGHZIHZLZUIUKUMJUJUMJJIHJULJJIFO
    PQSRUAUIJCDZUOUNUKUBTTABJJUCUDUEUFAJBJUGUH $.

  ${
    $d x y z w A $.
    $( The real part of a complex number is unique.  Proposition 10-1.3 of
       [Gleason] p. 130.  (Contributed by NM, 9-May-1999.)  (Proof shortened by
       Mario Carneiro, 27-May-2016.) $)
    creur $p |- ( A e. CC -> E! x e. RR E. y e. RR A = ( x + ( _i x. y ) ) ) $=
      ( vz vw cc wcel cv ci cmul co caddc wceq cr wrex wreu cnre wa wb wral cru
      ancoms eqcom ancom 3bitr4g anassrs rexbidva biidd ceqsrexv ad2antlr bitrd
      ralrimiva reu6i syldan eqeq1 rexbidv reubidv syl5ibrcom rexlimivv syl ) C
      FGCDHZIEHZJKLKZMZENODNOCAHZIBHZJKLKZMZBNOZANPZDECQVDVJDENNVANGZVBNGZRZVJV
      DVCVGMZBNOZANPZVKVLVOVEVAMZSZANTVPVMVRANVMVENGZRZVOVFVBMZVQRZBNOZVQVTVNWB
      BNVMVSVFNGZVNWBSVMVSWDRZRVGVCMZVQWARZVNWBWEVMWFWGSVEVFVAVBUAUBVCVGUCWAVQU
      DUEUFUGVLWCVQSVKVSVQVQBVBNWAVQUHUIUJUKULVOANVAUMUNVDVIVOANVDVHVNBNCVCVGUO
      UPUQURUSUT $.

    $( The imaginary part of a complex number is unique.  Proposition 10-1.3 of
       [Gleason] p. 130.  (Contributed by NM, 9-May-1999.)  (Proof shortened by
       Mario Carneiro, 27-May-2016.) $)
    creui $p |- ( A e. CC -> E! y e. RR E. x e. RR A = ( x + ( _i x. y ) ) ) $=
      ( vz vw cc wcel cv ci cmul co caddc wceq cr wrex wreu cnre wa wb wral cru
      simpr eqcom ancoms syl5bb anass1rs rexbidva biidd ceqsrexv ad2antrr bitrd
      ralrimiva reu6i syl2anc eqeq1 rexbidv reubidv syl5ibrcom rexlimivv syl )
      CFGCDHZIEHZJKLKZMZENODNOCAHZIBHZJKLKZMZANOZBNPZDECQVDVJDENNVANGZVBNGZRZVJ
      VDVCVGMZANOZBNPZVMVLVOVFVBMZSZBNTVPVKVLUBVMVRBNVMVFNGZRZVOVEVAMZVQRZANOZV
      QVTVNWBANVMVENGZVSVNWBSVNVGVCMZVMWDVSRZRWBVCVGUCWFVMWEWBSVEVFVAVBUAUDUEUF
      UGVKWCVQSVLVSVQVQAVANWAVQUHUIUJUKULVOBNVBUMUNVDVIVOBNVDVHVNANCVCVGUOUPUQU
      RUSUT $.
  $}

  ${
    $d x y z A $.
    $( The complex conjugate of a complex number is unique.  (Contributed by
       Mario Carneiro, 6-Nov-2013.) $)
    cju $p |- ( A e. CC -> E! x e. CC
               ( ( A + x ) e. RR /\ ( _i x. ( A - x ) ) e. RR ) ) $=
      ( vy vz cc wcel cv caddc co cr ci cmin cmul wrex wceq ax-icn oveq2d oveq2
      wa eleq1d wi wral wreu cnre recn mulcl sylancr subcl syl2an adantr adantl
      ppncand readdcl anidms eqeltrd pnncand a1i adddid eqtr4d addcld mulass c1
      mp3an12 syl cneg ixi 1re renegcli eqeltri readdcld remulcl anbi12d rspcev
      simpr syl12anc rexbidv syl5ibrcom rexlimivv an4 cc0 resubcl pnpcan syl5ib
      ancoms adantrl adantrr subdid nnncan1 3com23 eqtr3d anim12d subeq0 biimpd
      oveq1 3expb rimul 3syld syl5bi ralrimivva reu4 sylanbrc ) BEFZBAGZHIZJFZK
      BXCLIZMIZJFZSZAENZXIBCGZHIZJFZKBXKLIZMIZJFZSZSZXCXKOZUAZCEUBAEUBXIAEUCXBB
      XKKDGZMIZHIZOZDJNCJNXJCDBUDYDXJCDJJXKJFZYAJFZSZXJYDYCXCHIZJFZKYCXCLIZMIZJ
      FZSZAENZYGXKYBLIZEFZYCYOHIZJFZKYCYOLIZMIZJFZYNYEXKEFZYBEFZYPYFXKUEZYFKEFZ
      YAEFZUUCPYAUEZKYAUFUGZXKYBUHUIYGYQXKXKHIZJYGXKYBXKYEUUBYFUUDUJZYFUUCYEUUH
      UKZUUJULYEUUIJFZYFYEUULXKXKUMUNUJUOYGYTKKMIZYAYAHIZMIZJYGYTKKUUNMIZMIZUUO
      YGYSUUPKMYGYSYBYBHIUUPYGXKYBYBUUJUUKUUKUPYGKYAYAUUEYGPUQYFUUFYEUUGUKZUURU
      RUSQYGUUNEFZUUOUUQOZYGYAYAUURUURUTUUEUUEUUSUUTPPKKUUNVAVCVDUSYGUUMJFUUNJF
      UUOJFUUMVBVEJVFVBVGVHVIYGYAYAYEYFVNZUVAVJUUMUUNVKUGUOYMYRUUASAYOEXCYOOZYI
      YRYLUUAUVBYHYQJXCYOYCHRTUVBYKYTJUVBYJYSKMXCYOYCLRQTVLVMVOYDXIYMAEYDXEYIXH
      YLYDXDYHJBYCXCHWNTYDXGYKJYDXFYJKMBYCXCLWNQTVLVPVQVRVDXBXTACEEXRXEXMSZXHXP
      SZSZXBXCEFZUUBSZSZXSXEXHXMXPVSUVHUVEXCXKLIZJFZKUVIMIZJFZSZUVIVTOZXSUVHUVC
      UVJUVDUVLUVCXDXLLIZJFUVHUVJXDXLWAUVHUVOUVIJXBUVFUUBUVOUVIOBXCXKWBWOTWCUVD
      XOXGLIZJFZUVHUVLXPXHUVQXOXGWAWDUVHUVPUVKJUVHKXNXFLIZMIUVPUVKUVHKXNXFUUEUV
      HPUQXBUUBXNEFUVFBXKUHWEXBUVFXFEFUUBBXCUHWFWGUVHUVRUVIKMXBUVFUUBUVRUVIOZXB
      UUBUVFUVSBXKXCWHWIWOQWJTWCWKUVMUVNUAUVHUVIWPUQUVGUVNXSUAXBUVGUVNXSXCXKWLW
      MUKWQWRWSXIXQACEXSXEXMXHXPXSXDXLJXCXKBHRTXSXGXOJXSXFXNKMXCXKBLRQTVLWTXA
      $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Function operation analogue theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x V $.
    $( Function analog of ~ subeq0 .  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    ofsubeq0 $p |- ( ( A e. V /\ F : A --> CC /\ G : A --> CC ) ->
                     ( ( F oF - G ) = ( A X. { 0 } ) <-> F = G ) ) $=
      ( vx wcel cc wf cmin cfv cc0 wceq wral wfn ffn syl eqidd c0ex ffvelrnda
      co w3a cv cof csn cxp wa simp2 simp3 simp1 inidm fvconst2 adantl subeq0ad
      ofval eqeq12d bitrd ralbidva wb offn fconst ax-mp sylancl syl2anc 3bitr4d
      eqfnfv ) ADFZAGBHZAGCHZUAZEUBZBCIUCTZJZVJAKUDZUEZJZLZEAMZVJBJZVJCJZLZEAMZ
      VKVNLZBCLZVIVPVTEAVIVJAFZUFZVPVRVSITZKLVTWEVLWFVOKVIAAVRVSIABCDDVJVIVGBAN
      ZVFVGVHUGZAGBOPZVIVHCANZVFVGVHUHZAGCOPZVFVGVHUIZWMAUJZWEVRQWEVSQUNWDVOKLV
      IAKVJRUKULUOWEVRVSVIAGVJBWHSVIAGVJCWKSUMUPUQVIVKANVNANZWBVQURVIAAIABCDDWI
      WLWMWMWNUSAVMVNHWOAKRUTAVMVNOVAEAVKVNVEVBVIWGWJWCWAURWIWLEABCVEVCVD $.

    $( Function analog of ~ negsub .  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    ofnegsub $p |- ( ( A e. V /\ F : A --> CC /\ G : A --> CC ) ->
      ( F oF + ( ( A X. { -u 1 } ) oF x. G ) ) = ( F oF - G ) ) $=
      ( vx wcel cc wf cfv cneg caddc c1 cmul cof co cmin wfn ffn syl offn simp1
      w3a cv csn cxp simp2 ax-1cn negcli fnconstg mp1i simp3 inidm wa eqidd a1i
      ofc1 ffvelrnda mulm1d eqtrd negsubd ofval eqtr4d offveq ) ADFZAGBHZAGCHZU
      BZEAEUCZBIZVHCIZJZKBALJZUDUEZCMNOZBCPNOZDVDVEVFUAZVGVEBAQVDVEVFUFZAGBRSZV
      GAAMAVMCDDVLGFZVMAQVGLUGUHZAVLGUIUJVGVFCAQVDVEVFUKZAGCRSZVPVPAULZTVGAAPAB
      CDDVRWBVPVPWCTVGVHAFUMZVIUNZWDVHVNIVLVJMOVKVGAVLVJMCDGVHVPVSVGVTUOWBWDVJU
      NZUPWDVJVGAGVHCWAUQZURUSWDVIVKKOVIVJPOVHVOIWDVIVJVGAGVHBVQUQWGUTVGAAVIVJP
      ABCDDVHVRWBVPVPWCWEWFVAVBVC $.

    $( Function analog of ~ subge0 .  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    ofsubge0 $p |- ( ( A e. V /\ F : A --> RR /\ G : A --> RR ) ->
                     ( ( A X. { 0 } ) oR <_ ( F oF - G ) <-> G oR <_ F ) ) $=
      ( vx wcel cr wf cc0 cfv cmin co cle wbr wral ffvelrnda cc wfn ffn syl w3a
      cv csn cxp cof cofr simp2 simp3 subge0d ralbidva 0cn fnconstg simp1 inidm
      wa mp1i offn wceq c0ex fvconst2 adantl eqidd ofval ofrfval 3bitr4d ) ADFZ
      AGBHZAGCHZUAZIEUBZBJZVJCJZKLZMNZEAOVLVKMNZEAOAIUCUDZBCKUELZMUFZNCBVRNVIVN
      VOEAVIVJAFZUOZVKVLVIAGVJBVFVGVHUGZPVIAGVJCVFVGVHUHZPUIUJVIEAAIVMMAVPVQDDI
      QFVPARVIUKAIQULUPVIAAKABCDDVIVGBARWAAGBSTZVIVHCARWBAGCSTZVFVGVHUMZWEAUNZU
      QWEWEWFVSVJVPJIURVIAIVJUSUTVAVIAAVKVLKABCDDVJWCWDWEWEWFVTVKVBZVTVLVBZVCVD
      VIEAAVLVKMACBDDWDWCWEWEWFWHWGVDVE $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
        Integer sets
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Natural numbers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c NN $. $( The set of positive integers (blackboard bold N). $)

  $( Extend class notation to include the class of positive integers. $)
  cn $a class NN $.

  $( The natural numbers of analysis start at one (unlike the ordinal natural
     numbers, i.e. the members of the set ` om ` , ~ df-om , which start at
     zero).  This is the convention used by most analysis books, and it is
     often convenient in proofs because we don't have to worry about division
     by zero.  See ~ nnind for the principle of mathematical induction.  See
     ~ dfnn2 for a slight variant.  See ~ df-n0 for the set of nonnegative
     integers ` NN0 ` starting at zero.  See ~ dfn2 for ` NN ` defined in terms
     of ` NN0 ` .

     This is a technical definition that helps us avoid the Axiom of Infinity
     in certain proofs.  For a more conventional and intuitive definition ("the
     smallest set of reals containing ` 1 ` as well as the successor of every
     member") see ~ dfnn3 .  (Contributed by NM, 10-Jan-1997.) $)
  df-nn $a |- NN = ( rec ( ( x e. _V |-> ( x + 1 ) ) , 1 ) " om ) $.

  $( The set of natural numbers exists.  (Contributed by NM, 3-Oct-1999.)
     (Revised by Mario Carneiro, 3-May-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  nnexALT $p |- NN e. _V $=
    ( vx cn cvv cv c1 caddc cmpt crdg com cima df-nn wfun wcel rdgfun funimaexg
    co omex mp2an eqeltri ) BACADEFPGZEHZIJZCAKUALICMUBCMETNQUAICORS $.

  ${
    $d n x y z A $.
    $( Peano's inductive postulate.  Theorem I.36 (principle of mathematical
       induction) of [Apostol] p. 34.  (Contributed by NM, 10-Jan-1997.)
       (Revised by Mario Carneiro, 17-Nov-2014.) $)
    peano5nni $p |- ( ( 1 e. A /\ A. x e. A ( x + 1 ) e. A ) -> NN C_ A ) $=
      ( vn vy vz c1 wcel cv caddc co wral wa cvv com c0 wceq fveq2 eleq1d oveq1
      cfv cn cmpt crdg cres crn cima df-nn df-ima eqtri wss wfn frfnom a1i csuc
      wf cc ax-1cn fr0g ax-mp simpl syl5eqel wi ad2antlr wb ovex eqid frsucmpt2
      rspccv mpan2 adantl sylibrd expcom finds2 com12 ralrimiv sylanbrc frn syl
      ffnfv syl5eqss ) FBGZAHZFIJZBGZABKZLZUACMCHZFIJZUBZFUCZNUDZUEZBUAWJNUFWLC
      UGWJNUHUIWFNBWKUOZWLBUJWFWKNUKZDHZWKTZBGZDNKWMWNWFFWIULUMWFWQDNWONGWFWQWQ
      OWKTZBGEHZWKTZBGZWSUNZWKTZBGZWFDEWOOPWPWRBWOOWKQRWOWSPWPWTBWOWSWKQRWOXBPW
      PXCBWOXBWKQRWFWRFBFUPGWRFPUQFUPWIURUSWAWEUTVAWFWSNGZXAXDVBWFXELXAWTFIJZBG
      ZXDWEXAXGVBWAXEWDXGAWTBWBWTPWCXFBWBWTFISRVHVCXEXDXGVDWFXEXCXFBXEXFMGXCXFP
      WTFIVECDFWSWHXFWOFIJWKMWKVFWOWGFISWOWTFISVGVIRVJVKVLVMVNVODNBWKVSVPNBWKVQ
      VRVT $.
  $}

  $( The natural numbers are a subset of the reals.  (Contributed by NM,
     10-Jan-1997.)  (Revised by Mario Carneiro, 16-Jun-2013.) $)
  nnssre $p |- NN C_ RR $=
    ( vx c1 cr wcel cv caddc co wral cn wss 1re peano2re rgen peano5nni mp2an )
    BCDAEZBFGCDZACHICJKQACPLMACNO $.

  $( The natural numbers are a subset of the complex numbers.  (Contributed by
     NM, 2-Aug-2004.) $)
  nnsscn $p |- NN C_ CC $=
    ( cn cr cc nnssre ax-resscn sstri ) ABCDEF $.

  $( The set of natural numbers exists.  (Contributed by NM, 3-Oct-1999.)
     (Revised by Mario Carneiro, 17-Nov-2014.) $)
  nnex $p |- NN e. _V $=
    ( cn cc cnex nnsscn ssexi ) ABCDE $.

  $( A natural number is a real number.  (Contributed by NM, 18-Aug-1999.) $)
  nnre $p |- ( A e. NN -> A e. RR ) $=
    ( cn cr nnssre sseli ) BCADE $.

  $( A natural number is a complex number.  (Contributed by NM,
     18-Aug-1999.) $)
  nncn $p |- ( A e. NN -> A e. CC ) $=
    ( cn cc nnsscn sseli ) BCADE $.

  ${
    nnre.1 $e |- A e. NN $.
    $( A natural number is a real number.  (Contributed by NM, 18-Aug-1999.) $)
    nnrei $p |- A e. RR $=
      ( cn wcel cr nnre ax-mp ) ACDAEDBAFG $.

    $( A natural number is a complex number.  (Contributed by NM,
       18-Aug-1999.) $)
    nncni $p |- A e. CC $=
      ( nnrei recni ) AABCD $.
  $}

  ${
    $d x y z A $.
    $( Peano postulate: 1 is a natural number.  (Contributed by NM,
       11-Jan-1997.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    1nn $p |- 1 e. NN $=
      ( vx c1 cvv cv caddc co cmpt crdg com cres crn cn cfv wcel wceq 1ex ax-mp
      c0 fr0g wfn frfnom peano1 fnfvelrn mp2an eqeltrri cima df-nn df-ima eqtri
      eleqtrri ) BACADBEFGZBHZIJZKZLRUMMZBUNBCNUOBOPBCUKSQUMITRINUOUNNBUKUAUBIR
      UMUCUDUELULIUFUNAUGULIUHUIUJ $.

    $( Peano postulate: a successor of a natural number is a natural number.
       (Contributed by NM, 11-Jan-1997.)  (Revised by Mario Carneiro,
       17-Nov-2014.) $)
    peano2nn $p |- ( A e. NN -> ( A + 1 ) e. NN ) $=
      ( vx vy vz c1 caddc co cn wcel cvv cmpt crdg com cres crn wceq wrex oveq1
      cv cfv wfn frfnom fvelrnb ax-mp csuc ovex frsucmpt2 mpan2 peano2 fnfvelrn
      wb eqid sylancr df-nn df-ima syl6eleqr eqeltrrd eleq1d syl5ibcom rexlimiv
      cima eqtri sylbi eleq2s ) AEFGZHIZABJBSZEFGZKZELZMNZOZHAVLIZCSZVKTZAPZCMQ
      ZVFVKMUAZVMVQUKEVIUBZCMAVKUCUDVPVFCMVNMIZVOEFGZHIVPVFVTVNUEZVKTZWAHVTWAJI
      WCWAPVOEFUFBDEVNVHWADSZEFGVKJVKULWDVGEFRWDVOEFRUGUHVTWCVLHVTVRWBMIWCVLIVS
      VNUIMWBVKUJUMHVJMVAVLBUNVJMUOVBZUPUQVPWAVEHVOAEFRURUSUTVCWEVD $.

    $( Alternate definition of the set of natural numbers.  This was our
       original definition, before the current ~ df-nn replaced it.  This
       definition requires the axiom of infinity to ensure it has the
       properties we expect.  (Contributed by Jeff Hankins, 12-Sep-2013.)
       (Revised by Mario Carneiro, 3-May-2014.) $)
    dfnn2 $p |- NN = |^| { x | ( 1 e. x /\ A. y e. x ( y + 1 ) e. x ) } $=
      ( vz cn c1 cv wcel caddc co wral wa cab cint wss wi elintab wal wceq rgen
      eleq2 1ex simpl mpgbir oveq1 eleq1d rspccv adantl a2i alimi vex peano5nni
      ovex 3imtr4i mp2an 1nn peano2nn nnex raleqbi1dv anbi12d elab intss1 ax-mp
      mpbir2an eqssi ) DEAFZGZBFZEHIZVEGZBVEJZKZALZMZEVMGZCFZEHIZVMGZCVMJDVMNVN
      VKVFOAVKAEUAPVFVJUBUCVQCVMVKVOVEGZOZAQVKVPVEGZOZAQVOVMGVQVSWAAVKVRVTVJVRV
      TOVFVIVTBVOVEVGVORVHVPVEVGVOEHUDUEUFUGUHUIVKAVOCUJPVKAVPVOEHULPUMSCVMUKUN
      DVLGZVMDNWBEDGZVHDGZBDJZUOWDBDVGUPSVKWCWEKADUQVEDRVFWCVJWEVEDETVIWDBVEDVE
      DVHTURUSUTVCDVLVAVBVD $.

    $( Alternate definition of the set of natural numbers.  Definition of
       positive integers in [Apostol] p. 22.  (Contributed by NM,
       3-Jul-2005.) $)
    dfnn3 $p |- NN =
               |^| { x | ( x C_ RR /\ 1 e. x /\ A. y e. x ( y + 1 ) e. x ) } $=
      ( vz cv cr wss c1 wcel caddc wral wa cab cint cn eleq2 raleqbi1dv anbi12d
      wceq dfnn2 pm3.2i co w3a wb eqeq2i sylbir nnssre eqsstr3i peano2nn intabs
      1nn rgen 3anass abbii inteqi 3eqtr4ri ) ADZEFZGUPHZBDZGIUAZUPHZBUPJZKZKZA
      LZMVCALMUQURVBUBZALZMNVCGCDZHZUTVHHZBVHJZKZGNHZUTNHZBNJZKZACEUPVHRURVIVBV
      KUPVHGOVAVJBUPVHUPVHUTOPQUPVLCLMZRUPNRZVCVPUCNVQUPCBSZUDVRURVMVBVOUPNGOVA
      VNBUPNUPNUTOPQUEVQEFVPVQNEVSUFUGVMVOUJVNBNUSUHUKTTUIVGVEVFVDAUQURVBULUMUN
      ABSUO $.
  $}

  ${
    nnred.1 $e |- ( ph -> A e. NN ) $.
    $( A natural number is a real number.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnred $p |- ( ph -> A e. RR ) $=
      ( cn cr nnssre sseldi ) ADEBFCG $.

    $( A natural number is a complex number.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nncnd $p |- ( ph -> A e. CC ) $=
      ( cn cc nnsscn sseldi ) ADEBFCG $.

    $( Peano postulate: a successor of a natural number is a natural number.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    peano2nnd $p |- ( ph -> ( A + 1 ) e. NN ) $=
      ( cn wcel c1 caddc co peano2nn syl ) ABDEBFGHDECBIJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Principle of mathematical induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Substitutions. $)
    nnind.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nnind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nnind.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nnind.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    nnind.5 $e |- ps $.
    $( Induction hypothesis. $)
    nnind.6 $e |- ( y e. NN -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction (inference schema).  The first four
       hypotheses give us the substitution instances we need; the last two are
       the basis and the induction hypothesis.  See ~ nnaddcl for an example of
       its use.  See ~ nn0ind for induction on nonnegative integers and
       ~ uzind , ~ uzind4 for induction on an arbitrary set of upper integers.
       See ~ indstr for strong induction.  See also ~ nnindALT .  (Contributed
       by NM, 10-Jan-1997.)  (Revised by Mario Carneiro, 16-Jun-2013.) $)
    nnind $p |- ( A e. NN -> ta ) $=
      ( cn wcel crab wa c1 elrab cv caddc wral wss 1nn mpbir2an elrabi peano2nn
      co a1d anim12d 3imtr4g mpcom rgen peano5nni mp2an sseli sylib simprd ) HO
      PZUTEUTHAFOQZPUTEROVAHSVAPZGUAZSUBUIZVAPZGVAUCOVAUDVBSOPBUEMABFSOITUFVEGV
      AVCOPZVCVAPZVEAFVCOUGVFVFCRVDOPZDRVGVEVFVFVHCDVFVHVFVCUHUJNUKACFVCOJTADFV
      DOKTULUMUNGVAUOUPUQAEFHOLTURUS $.
  $}

  ${
    $d x y $.  $d x A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.
    $d y ph $.
    $( Induction hypothesis. $)
    nnindALT.6 $e |- ( y e. NN -> ( ch -> th ) ) $.
    $( Basis. $)
    nnindALT.5 $e |- ps $.
    $( Substitutions. $)
    nnindALT.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nnindALT.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nnindALT.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nnindALT.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Principle of Mathematical Induction (inference schema).  The last four
       hypotheses give us the substitution instances we need; the first two are
       the induction hypothesis and the basis.

       This ALT version of ~ nnind has a different hypothesis order.  It may be
       easier to use with the metamath program's Proof Assistant, because
       "MM-PA> assign last" will be applied to the substitution instances
       first.  We may eventually use this one as the official version.  You may
       use either version.  After the proof is complete, the ALT version can be
       changed to the non-ALT version with "MM-PA> minimize nnind /allow".
       (Contributed by NM, 7-Dec-2005.) $)
    nnindALT $p |- ( A e. NN -> ta ) $=
      ( nnind ) ABCDEFGHKLMNJIO $.
  $}

  ${
    $d x y A $.
    $( Every natural number is one or a successor.  (Contributed by Mario
       Carneiro, 16-May-2014.) $)
    nn1m1nn $p |- ( A e. NN -> ( A = 1 \/ ( A - 1 ) e. NN ) ) $=
      ( vx vy cv c1 wceq cmin co cn wcel wo cc caddc orc ax-1cn a1i eqeq1 oveq1
      eleq1d orbi12d 2thd nncn pncan sylancl id eqeltrd olcd a1d nnind ) BDZEFZ
      UJEGHZIJZKZELJZCDZEFZUPEGHZIJZKZUPEMHZEFZVAEGHZIJZKZAEFZAEGHZIJZKBCAUKUNU
      OUKUMNUOUKOPUAUJUPFZUKUQUMUSUJUPEQVIULURIUJUPEGRSTUJVAFZUKVBUMVDUJVAEQVJU
      LVCIUJVAEGRSTUJAFZUKVFUMVHUJAEQVKULVGIUJAEGRSTOUPIJZVEUTVLVDVBVLVCUPIVLUP
      LJUOVCUPFUPUBOUPEUCUDVLUEUFUGUHUI $.
  $}

  ${
    $d x y z $.  $d x y z A $.  $d x ps $.  $d x ch $.  $d x z th $.
    $d y z ph $.
    $( Substitutions. $)
    nn1suc.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nn1suc.3 $e |- ( x = ( y + 1 ) -> ( ph <-> ch ) ) $.
    nn1suc.4 $e |- ( x = A -> ( ph <-> th ) ) $.
    $( Hypothesis showing it holds for 1. $)
    nn1suc.5 $e |- ps $.
    $( Hypothesis showing it holds for a successor. $)
    nn1suc.6 $e |- ( y e. NN -> ch ) $.
    $( If a statement holds for 1 and also holds for a successor, it holds for
       all natural numbers.  The first three hypotheses give us the
       substitution instances we need; the last two show that it holds for 1
       and for a successor.  (Contributed by NM, 11-Oct-2004.)  (Revised by
       Mario Carneiro, 16-May-2014.) $)
    nn1suc $p |- ( A e. NN -> th ) $=
      ( cn wcel c1 wceq co wsbc wb caddc cmin 1ex sbcie mpbir 1nn mpbiri sbcieg
      wi eleq1 syl dfsbcq bitr3d a1i cv ovex oveq1 syl5bbr vtoclga ax-1cn npcan
      cc nncn sylancl bitrd syl5ib nn1m1nn mpjaod ) GMNZGOPZDGOUAQZMNZVIDUHVHVI
      DAEORZVLBKABEOUBHUCUDVIAEGRZDVLVIVHVMDSVIVHOMNUEGOMUIUFADEGMJUGZUJAEGOUKU
      LUFUMVKAEVJOTQZRZVHDCVPFVJMCAEFUNZOTQZRZVQVJPZVPACEVRVQOTUOIUCVTVRVOPVSVP
      SVQVJOTUPAEVRVOUKUJUQLURVHVPVMDVHVOGPZVPVMSVHGVANOVANWAGVBUSGOUTVCAEVOGUK
      UJVNVDVEGVFVG $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Closure of addition of natural numbers, proved by induction on the
       second addend.  (Contributed by NM, 12-Jan-1997.) $)
    nnaddcl $p |- ( ( A e. NN /\ B e. NN ) -> ( A + B ) e. NN ) $=
      ( vx vy cn wcel caddc co cv wi c1 wceq oveq2 eleq1d imbi2d peano2nn wa cc
      nncn ax-1cn addass mp3an3 syl2an syl5ib expcom a2d nnind impcom ) BEFAEFZ
      ABGHZEFZUIACIZGHZEFZJUIAKGHZEFZJUIADIZGHZEFZJUIAUQKGHZGHZEFZJUIUKJCDBULKL
      ZUNUPUIVCUMUOEULKAGMNOULUQLZUNUSUIVDUMUREULUQAGMNOULUTLZUNVBUIVEUMVAEULUT
      AGMNOULBLZUNUKUIVFUMUJEULBAGMNOAPUQEFZUIUSVBUIVGUSVBJUSURKGHZEFUIVGQZVBUR
      PVIVHVAEUIARFZUQRFZVHVALZVGASUQSVJVKKRFVLTAUQKUAUBUCNUDUEUFUGUH $.

    $( Closure of multiplication of natural numbers.  (Contributed by NM,
       12-Jan-1997.) $)
    nnmulcl $p |- ( ( A e. NN /\ B e. NN ) -> ( A x. B ) e. NN ) $=
      ( vx vy cn wcel cmul co cv wi c1 caddc wceq oveq2 eleq1d imbi2d cc mulid1
      nncn wa biimprd nnaddcl ancoms ax-1cn mp3an3 oveq2d adantr syl2an syl5ibr
      mpcom adddi eqtrd exp4b pm2.43b a2d nnind impcom ) BEFAEFZABGHZEFZURACIZG
      HZEFZJURAKGHZEFZJURADIZGHZEFZJURAVFKLHZGHZEFZJURUTJCDBVAKMZVCVEURVLVBVDEV
      AKAGNOPVAVFMZVCVHURVMVBVGEVAVFAGNOPVAVIMZVCVKURVNVBVJEVAVIAGNOPVABMZVCUTU
      RVOVBUSEVABAGNOPAQFZURVEASZVPVEURVPVDAEARZOUAUJVFEFZURVHVKVSURVHVKJURVSUR
      VHVKURVHTVKURVSTZVGALHZEFZVHURWBVGAUBUCVTVJWAEURVPVFQFZVJWAMVSVQVFSVPWCTV
      JVGVDLHZWAVPWCKQFVJWDMUDAVFKUKUEVPWDWAMWCVPVDAVGLVRUFUGULUHOUIUMUNUOUPUQ
      $.
  $}

  ${
    nnmulcli.1 $e |- A e. NN $.
    nnmulcli.2 $e |- B e. NN $.
    $( Closure of multiplication of natural numbers.  (Contributed by Mario
       Carneiro, 18-Feb-2014.) $)
    nnmulcli $p |- ( A x. B ) e. NN $=
      ( cn wcel cmul co nnmulcl mp2an ) AEFBEFABGHEFCDABIJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( There exists a natural number greater than or equal to any two others.
       (Contributed by NM, 18-Aug-1999.) $)
    nn2ge $p |- ( ( A e. NN /\ B e. NN ) ->
                E. x e. NN ( A <_ x /\ B <_ x ) ) $=
      ( cn wcel wa cv cle wbr wrex cr nnre adantr leid sylan wceq breq2 anbi12d
      rspcev syldan adantl biantrud biimpa adantll anim1i adantlr lecasei ) BDE
      ZCDEZFBAGZHIZCUJHIZFZADJZBCUHBKEZUIBLZMUICKEZUHCLZUAUIBCHIZUNUHUIUSUSCCHI
      ZFZUNUIUQUSVAURUQUSVAUQUTUSCNUBUCOUMVAACDUJCPUKUSULUTUJCBHQUJCCHQRSTUDUHC
      BHIZUNUIUHVBBBHIZVBFZUNUHUOVBVDUPUOVCVBBNUEOUMVDABDUJBPUKVCULVBUJBBHQUJBC
      HQRSTUFUG $.
  $}

  ${
    $d x y A $.
    $( A natural number is one or greater.  (Contributed by NM,
       25-Aug-1999.) $)
    nnge1 $p |- ( A e. NN -> 1 <_ A ) $=
      ( vx vy c1 cv cle wbr caddc co breq2 wcel cr wi cc0 clt wn 0re 1re lenlt
      wb 1le1 cn nnre recn addid1d breq2d 0lt1 axltadd mp3an12 wa readdcl mpan2
      mpi peano2re mp3an3 syl2anc mpand con3d sylancr 3imtr4d sylbird syl nnind
      lttr ) DBEZFGDDFGDCEZFGZDVFDHIZFGZDAFGBCAVEDDFJVEVFDFJVEVHDFJVEADFJUAVFUB
      KVFLKZVGVIMVFUCVJVGDVFNHIZFGZVIVJVKVFDFVJVFVFUDUEUFVJVKDOGZPZVHDOGZPZVLVI
      VJVOVMVJVKVHOGZVOVMVJNDOGZVQUGNLKZDLKZVJVRVQMQRNDVFUHUIUMVJVKLKZVHLKZVQVO
      UJVMMZVJVSWAQVFNUKULZVFUNZWAWBVTWCRVKVHDVDUOUPUQURVJVTWAVLVNTRWDDVKSUSVJV
      TWBVIVPTRWEDVHSUSUTVAVBVC $.
  $}

  $( A natural number is greater than one iff it is not equal to one.
     (Contributed by NM, 7-Oct-2004.) $)
  nngt1ne1 $p |- ( A e. NN -> ( 1 < A <-> A =/= 1 ) ) $=
    ( cn wcel cr c1 cle wbr clt wne wb nnre nnge1 1re leltne mp3an1 syl2anc ) A
    BCADCZEAFGZEAHGAEIJZAKALEDCQRSMEANOP $.

  $( A natural number is less than or equal to one iff it is equal to one.
     (Contributed by NM, 3-Apr-2005.) $)
  nnle1eq1 $p |- ( A e. NN -> ( A <_ 1 <-> A = 1 ) ) $=
    ( cn wcel c1 cle wbr wa wceq nnge1 biantrud cr wb 1re letri3 sylancl bitr4d
    nnre ) ABCZADEFZSDAEFZGZADHZRTSAIJRAKCDKCUBUALAQMADNOP $.

  $( A natural number is positive.  (Contributed by NM, 26-Sep-1999.) $)
  nngt0 $p |- ( A e. NN -> 0 < A ) $=
    ( cn wcel cr c1 cle wbr cc0 clt nnre nnge1 0lt1 wa wi 0re 1re mp3an12 mpani
    ltletr sylc ) ABCADCZEAFGZHAIGZAJAKUAHEIGZUBUCLHDCEDCUAUDUBMUCNOPHEASQRT $.

  $( A natural number is not less than one.  (Contributed by NM, 18-Jan-2004.)
     (Revised by Mario Carneiro, 27-May-2016.) $)
  nnnlt1 $p |- ( A e. NN -> -. A < 1 ) $=
    ( cn wcel c1 cle wbr clt wn nnge1 cr wb 1re nnre lenlt sylancr mpbid ) ABCZ
    DAEFZADGFHZAIQDJCAJCRSKLAMDANOP $.

  $( Zero is not a natural number.  (Contributed by NM, 25-Aug-1999.) $)
  0nnn $p |- -. 0 e. NN $=
    ( cc0 cn wcel c1 clt wbr 0lt1 nnnlt1 mt2 ) ABCADEFGAHI $.

  $( A natural number is nonzero.  (Contributed by NM, 27-Sep-1999.) $)
  nnne0 $p |- ( A e. NN -> A =/= 0 ) $=
    ( cn wcel cc0 wceq 0nnn eleq1 mtbiri necon2ai ) ABCZADADEJDBCFADBGHI $.

  ${
    nngt0.1 $e |- A e. NN $.
    $( A natural number is positive (inference version).  (Contributed by NM,
       17-Sep-1999.) $)
    nngt0i $p |- 0 < A $=
      ( cn wcel cc0 clt wbr nngt0 ax-mp ) ACDEAFGBAHI $.

    $( A natural number is nonzero (inference version).  (Contributed by NM,
       25-Aug-1999.) $)
    nnne0i $p |- A =/= 0 $=
      ( nnrei nngt0i gt0ne0ii ) AABCABDE $.
  $}

  $( The quotient of a real and a natural number is real.  (Contributed by NM,
     28-Nov-2008.) $)
  nndivre $p |- ( ( A e. RR /\ N e. NN ) -> ( A / N ) e. RR ) $=
    ( cn wcel cr cc0 wne wa cdiv co nnre nnne0 jca redivcl 3expb sylan2 ) BCDZA
    EDZBEDZBFGZHABIJEDZQSTBKBLMRSTUAABNOP $.

  $( The reciprocal of a natural number is real.  (Contributed by NM,
     8-Feb-2008.) $)
  nnrecre $p |- ( N e. NN -> ( 1 / N ) e. RR ) $=
    ( c1 cr wcel cn cdiv co 1re nndivre mpan ) BCDAEDBAFGCDHBAIJ $.

  $( The reciprocal of a natural number is positive.  (Contributed by NM,
     25-Aug-1999.) $)
  nnrecgt0 $p |- ( A e. NN -> 0 < ( 1 / A ) ) $=
    ( cn wcel c1 cle wbr cc0 cdiv co clt nnge1 0lt1 cr wa wi 0re ltletr mp3an12
    nnre 1re recgt0 ex syld syl mpani mpd ) ABCZDAEFZGDAHIJFZAKUGGDJFZUHUILUGAM
    CZUJUHNZUIOASUKULGAJFZUIGMCDMCUKULUMOPTGDAQRUKUMUIAUAUBUCUDUEUF $.

  ${
    $d z A $.  $d x y z B $.
    $( Subtraction of natural numbers.  (Contributed by NM, 20-Aug-2001.)
       (Revised by Mario Carneiro, 16-May-2014.) $)
    nnsub $p |- ( ( A e. NN /\ B e. NN ) -> ( A < B <-> ( B - A ) e. NN ) ) $=
      ( vz vx cn wcel clt wbr cmin co wi wral wceq breq2 eleq1d imbi12d ralbidv
      c1 oveq1 cr vy wa cv caddc nnnlt1 pm2.21d rgen breq1 oveq2 cbvralv adantr
      cc nncn ax-1cn pncan sylancl simpl eqeltrd syl5ibrcom a1dd rspcv nnre 1re
      ltsubadd mp3an2 syl2anr subsub3 mp3an3 syl2an biimpd syl9r nn1m1nn adantl
      wb wo mpjaod ralrimdva syl5bi nnind rspcva sylan2 cc0 nngt0 posdif impbid
      syl5ibr ) AEFZBEFZUBZABGHZBAIJZEFZWHWGCUCZBGHZBWMIJZEFZKZCELZWJWLKZWMDUCZ
      GHZWTWMIJZEFZKZCELWMRGHZRWMIJZEFZKZCELWMUAUCZGHZXIWMIJZEFZKZCELZWMXIRUDJZ
      GHZXOWMIJZEFZKZCELZWRDUABWTRMZXDXHCEYAXAXEXCXGWTRWMGNYAXBXFEWTRWMISOPQWTX
      IMZXDXMCEYBXAXJXCXLWTXIWMGNYBXBXKEWTXIWMISOPQWTXOMZXDXSCEYCXAXPXCXRWTXOWM
      GNYCXBXQEWTXOWMISOPQWTBMZXDWQCEYDXAWNXCWPWTBWMGNYDXBWOEWTBWMISOPQXHCEWMEF
      ZXEXGWMUEUFUGXNWTXIGHZXIWTIJZEFZKZDELZXIEFZXTXMYICDEWMWTMZXJYFXLYHWMWTXIG
      UHYLXKYGEWMWTXIIUIOPUJYKYJXSCEYKYEUBZWMRMZYJXSKWMRIJZEFZYMYNXSYJYMYNXRXPY
      MXRYNXORIJZEFYMYQXIEYMXIULFZRULFZYQXIMYKYRYEXIUMZUKUNXIRUOUPYKYEUQURYNXQY
      QEWMRXOIUIOUSUTUTYPYJYOXIGHZXIYOIJZEFZKZYMXSYIUUDDYOEWTYOMZYFUUAYHUUCWTYO
      XIGUHUUEYGUUBEWTYOXIIUIOPVAYMUUDXSYMUUAXPUUCXRYEWMTFZXITFZUUAXPVNZYKWMVBX
      IVBUUFRTFUUGUUHVCWMRXIVDVEVFYMUUBXQEYKYRWMULFZUUBXQMZYEYTWMUMYRUUIYSUUJUN
      XIWMRVGVHVIOPVJVKYEYNYPVOYKWMVLVMVPVQVRVSWQWSCAEWMAMZWNWJWPWLWMABGUHUUKWO
      WKEWMABIUIOPVTWAWLWJWIWBWKGHZWKWCWGATFBTFWJUULVNWHAVBBVBABWDVIWFWE $.

    nnsub.1 $e |- A e. NN $.
    nnsub.2 $e |- B e. NN $.
    $( Subtraction of natural numbers.  (Contributed by NM, 19-Aug-2001.) $)
    nnsubi $p |- ( A < B <-> ( B - A ) e. NN ) $=
      ( cn wcel clt wbr cmin co wb nnsub mp2an ) AEFBEFABGHBAIJEFKCDABLM $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Two ways to express " ` A ` divides ` B ` " for natural numbers.
       (Contributed by NM, 3-Feb-2004.)  (Proof shortened by Mario Carneiro,
       16-May-2014.) $)
    nndiv $p |- ( ( A e. NN /\ B e. NN ) ->
                ( E. x e. NN ( A x. x ) = B <-> ( B / A ) e. NN ) ) $=
      ( cdiv co cn wcel cv wceq wrex cmul risset eqcom ad2antlr ad2antrr adantl
      wa cc nncn cc0 wne nnne0 divmuld syl5bb rexbidva syl5rbb ) CBDEZFGAHZUGIZ
      AFJBFGZCFGZQZBUHKECIZAFJAUGFLULUIUMAFUIUGUHIULUHFGZQZUMUHUGMUOCBUHUKCRGUJ
      UNCSNUJBRGUKUNBSOUNUHRGULUHSPUJBTUAUKUNBUBOUCUDUEUF $.
  $}

  $( Transitive property of divisibility: if ` A ` divides ` B ` and ` B `
     divides ` C ` , then ` A ` divides ` C ` .  Typically, ` C ` would be an
     integer, although the theorem holds for complex ` C ` .  (Contributed by
     NM, 3-May-2005.) $)
  nndivtr $p |- ( ( ( A e. NN /\ B e. NN /\ C e. CC ) /\
               ( ( B / A ) e. NN /\ ( C / B ) e. NN ) ) -> ( C / A ) e. NN ) $=
    ( cn wcel cc w3a cdiv co wa cmul nnmulcl c1 cc0 wne wceq 3ad2ant2 nnne0 jca
    nncn 3ad2ant1 divmul24 syl22anc dividd oveq1d sylan2 ancoms mulid2d 3adant2
    simp3 divcl 3expb 3eqtrd eleq1d syl5ib imp ) ADEZBDEZCFEZGZBAHIZDECBHIZDEJZ
    CAHIZDEZVCVAVBKIZDEUTVEVAVBLUTVFVDDUTVFBBHIZVDKIZMVDKIZVDUTBFEZUSAFEZANOZJZ
    VJBNOZJZVFVHPURUQVJUSBTZQUQURUSUJUQURVMUSUQVKVLATARSZUAURUQVOUSURVJVNVPBRZS
    QBCABUBUCURUQVHVIPUSURVGMVDKURBVPVRUDUEQUQUSVIVDPURUQUSJVDUSUQVDFEZUQUSVMVS
    VQUSVKVLVSCAUKULUFUGUHUIUMUNUOUP $.

  ${
    nnge1d.1 $e |- ( ph -> A e. NN ) $.
    $( A natural number is one or greater.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnge1d $p |- ( ph -> 1 <_ A ) $=
      ( cn wcel c1 cle wbr nnge1 syl ) ABDEFBGHCBIJ $.

    $( A natural number is positive.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nngt0d $p |- ( ph -> 0 < A ) $=
      ( cn wcel cc0 clt wbr nngt0 syl ) ABDEFBGHCBIJ $.

    $( A natural number is nonzero.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnne0d $p |- ( ph -> A =/= 0 ) $=
      ( cn wcel cc0 wne nnne0 syl ) ABDEBFGCBHI $.

    $( The reciprocal of a natural number is real.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    nnrecred $p |- ( ph -> ( 1 / A ) e. RR ) $=
      ( cn wcel c1 cdiv co cr nnrecre syl ) ABDEFBGHIECBJK $.

    nnmulcld.2 $e |- ( ph -> B e. NN ) $.
    $( Closure of addition of natural numbers.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nnaddcld $p |- ( ph -> ( A + B ) e. NN ) $=
      ( cn wcel caddc co nnaddcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure of multiplication of natural numbers.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    nnmulcld $p |- ( ph -> ( A x. B ) e. NN ) $=
      ( cn wcel cmul co nnmulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

  ${
    nndivred.1 $e |- ( ph -> A e. RR ) $.
    nndivred.2 $e |- ( ph -> B e. NN ) $.
    $( A natural number is one or greater.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nndivred $p |- ( ph -> ( A / B ) e. RR ) $=
      ( cr wcel cn cdiv co nndivre syl2anc ) ABFGCHGBCIJFGDEBCKL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Decimal representation of numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Note that the numbers 0 and 1 are constants defined as primitives of the
  complex number axiom system (see ~ df-0 and ~ df-1 ).

  Only the digits 0 through 9 ( ~ df-0 through ~ df-9 ) and the
  number 10 ( ~ df-10 ) are explicitly defined.

  We will later define the decimal constructor ~ df-dec ,
  which will allow us to easily express larger integers in base 10.
  See ~ deccl and the theorems that follow it.  See also ~ 4001prm (4001 is
  prime) and the proof of ~ bpos .  Note that
  the decimal constructor builds on the definitions in this section.

  Integers can also be exhibited
  as sums of powers of 10 or as some other expression built from operations
  on the numbers 0 through 10.  For example, the prime number 823541 can be
  expressed as ` ( 7 ^ 7 ) - 2 ` .  Decimals can be expressed as ratios of
  integers, as in ~ cos2bnd .

  Most abstract math rarely requires numbers larger than 4.  Even in Wiles'
  proof of Fermat's Last Theorem, the largest number used appears to be 12.

$)

  $c 2 $. $( The decimal number 2 $)
  $c 3 $. $( The decimal number 3 $)
  $c 4 $. $( The decimal number 4 $)
  $c 5 $. $( The decimal number 5 $)
  $c 6 $. $( The decimal number 6 $)
  $c 7 $. $( The decimal number 7 $)
  $c 8 $. $( The decimal number 8 $)
  $c 9 $. $( The decimal number 9 $)
  $c 10 $. $( The decimal number 10 $)

  $( Extend class notation to include the number 2. $)
  c2 $a class 2 $.
  $( Extend class notation to include the number 3. $)
  c3 $a class 3 $.
  $( Extend class notation to include the number 4. $)
  c4 $a class 4 $.
  $( Extend class notation to include the number 5. $)
  c5 $a class 5 $.
  $( Extend class notation to include the number 6. $)
  c6 $a class 6 $.
  $( Extend class notation to include the number 7. $)
  c7 $a class 7 $.
  $( Extend class notation to include the number 8. $)
  c8 $a class 8 $.
  $( Extend class notation to include the number 9. $)
  c9 $a class 9 $.
  $( Extend class notation to include the number 10. $)
  c10 $a class 10 $.

  $( Define the number 2.  (Contributed by NM, 27-May-1999.) $)
  df-2 $a |- 2 = ( 1 + 1 ) $.

  $( Define the number 3.  (Contributed by NM, 27-May-1999.) $)
  df-3 $a |- 3 = ( 2 + 1 ) $.
  $( Define the number 4.  (Contributed by NM, 27-May-1999.) $)
  df-4 $a |- 4 = ( 3 + 1 ) $.
  $( Define the number 5.  (Contributed by NM, 27-May-1999.) $)
  df-5 $a |- 5 = ( 4 + 1 ) $.
  $( Define the number 6.  (Contributed by NM, 27-May-1999.) $)
  df-6 $a |- 6 = ( 5 + 1 ) $.
  $( Define the number 7.  (Contributed by NM, 27-May-1999.) $)
  df-7 $a |- 7 = ( 6 + 1 ) $.
  $( Define the number 8.  (Contributed by NM, 27-May-1999.) $)
  df-8 $a |- 8 = ( 7 + 1 ) $.
  $( Define the number 9.  (Contributed by NM, 27-May-1999.) $)
  df-9 $a |- 9 = ( 8 + 1 ) $.
  $( Define the number 10.  See remarks under ~ df-2 .  (Contributed by NM,
     5-Feb-2007.) $)
  df-10 $a |- 10 = ( 9 + 1 ) $.

  $( -1 is a complex number.  Common special case.  (Contributed by David A.
     Wheeler, 7-Jul-2016.) $)
  neg1cn $p |- -u 1 e. CC $=
    ( c1 ax-1cn negcli ) ABC $.

  $( ` ( 1 - 1 ) = 0 ` .  Common special case.  (Contributed by David A.
     Wheeler, 7-Jul-2016.) $)
  1m1e0 $p |- ( 1 - 1 ) = 0 $=
    ( c1 ax-1cn subidi ) ABC $.

  $( The number 2 is real.  (Contributed by NM, 27-May-1999.) $)
  2re $p |- 2 e. RR $=
    ( c2 c1 caddc co cr df-2 1re readdcli eqeltri ) ABBCDEFBBGGHI $.

  $( The number 2 is a complex number.  (Contributed by NM, 30-Jul-2004.) $)
  2cn $p |- 2 e. CC $=
    ( c2 2re recni ) ABC $.

  $( The number 3 is real.  (Contributed by NM, 27-May-1999.) $)
  3re $p |- 3 e. RR $=
    ( c3 c2 c1 caddc co cr df-3 2re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 3 is a complex number.  (Contributed by FL, 17-Oct-2010.) $)
  3cn $p |- 3 e. CC $=
    ( c3 3re recni ) ABC $.

  $( The number 4 is real.  (Contributed by NM, 27-May-1999.) $)
  4re $p |- 4 e. RR $=
    ( c4 c3 c1 caddc co cr df-4 3re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 4 is a complex number.  (Contributed by David A. Wheeler,
     7-Jul-2016.) $)
  4cn $p |- 4 e. CC $=
    ( c4 4re recni ) ABC $.

  $( The number 5 is real.  (Contributed by NM, 27-May-1999.) $)
  5re $p |- 5 e. RR $=
    ( c5 c4 c1 caddc co cr df-5 4re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 6 is real.  (Contributed by NM, 27-May-1999.) $)
  6re $p |- 6 e. RR $=
    ( c6 c5 c1 caddc co cr df-6 5re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 7 is real.  (Contributed by NM, 27-May-1999.) $)
  7re $p |- 7 e. RR $=
    ( c7 c6 c1 caddc co cr df-7 6re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 8 is real.  (Contributed by NM, 27-May-1999.) $)
  8re $p |- 8 e. RR $=
    ( c8 c7 c1 caddc co cr df-8 7re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 9 is real.  (Contributed by NM, 27-May-1999.) $)
  9re $p |- 9 e. RR $=
    ( c9 c8 c1 caddc co cr df-9 8re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( The number 10 is real.  (Contributed by NM, 5-Feb-2007.) $)
  10re $p |- 10 e. RR $=
    ( c10 c9 c1 caddc co cr df-10 9re 1re readdcli eqeltri ) ABCDEFGBCHIJK $.

  $( Zero is nonnegative.  (Contributed by David A. Wheeler, 7-Jul-2016.) $)
  0le0 $p |- 0 <_ 0 $=
    ( cc0 0re leidi ) ABC $.

  $( The number 2 is positive.  (Contributed by NM, 27-May-1999.) $)
  2pos $p |- 0 < 2 $=
    ( cc0 c1 caddc co c2 clt 1re 0lt1 addgt0ii df-2 breqtrri ) ABBCDEFBBGGHHIJK
    $.

  $( The number 2 is nonzero.  (Contributed by NM, 9-Nov-2007.) $)
  2ne0 $p |- 2 =/= 0 $=
    ( c2 2re 2pos gt0ne0ii ) ABCD $.

  $( The number 3 is positive.  (Contributed by NM, 27-May-1999.) $)
  3pos $p |- 0 < 3 $=
    ( cc0 c2 c1 caddc co c3 clt 2re 1re 2pos 0lt1 addgt0ii df-3 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 3 is nonzero.  (Contributed by FL, 17-Oct-2010.)  (Proof
     shortened by Andrew Salmon, 7-May-2011.) $)
  3ne0 $p |- 3 =/= 0 $=
    ( c3 3re 3pos gt0ne0ii ) ABCD $.

  $( The number 4 is positive.  (Contributed by NM, 27-May-1999.) $)
  4pos $p |- 0 < 4 $=
    ( cc0 c3 c1 caddc co c4 clt 3re 1re 3pos 0lt1 addgt0ii df-4 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 5 is positive.  (Contributed by NM, 27-May-1999.) $)
  5pos $p |- 0 < 5 $=
    ( cc0 c4 c1 caddc co c5 clt 4re 1re 4pos 0lt1 addgt0ii df-5 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 6 is positive.  (Contributed by NM, 27-May-1999.) $)
  6pos $p |- 0 < 6 $=
    ( cc0 c5 c1 caddc co c6 clt 5re 1re 5pos 0lt1 addgt0ii df-6 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 7 is positive.  (Contributed by NM, 27-May-1999.) $)
  7pos $p |- 0 < 7 $=
    ( cc0 c6 c1 caddc co c7 clt 6re 1re 6pos 0lt1 addgt0ii df-7 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 8 is positive.  (Contributed by NM, 27-May-1999.) $)
  8pos $p |- 0 < 8 $=
    ( cc0 c7 c1 caddc co c8 clt 7re 1re 7pos 0lt1 addgt0ii df-8 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 9 is positive.  (Contributed by NM, 27-May-1999.) $)
  9pos $p |- 0 < 9 $=
    ( cc0 c8 c1 caddc co c9 clt 8re 1re 8pos 0lt1 addgt0ii df-9 breqtrri ) ABCD
    EFGBCHIJKLMN $.

  $( The number 10 is positive.  (Contributed by NM, 5-Feb-2007.) $)
  10pos $p |- 0 < 10 $=
    ( cc0 c9 c1 caddc co c10 clt 9re 1re 9pos 0lt1 addgt0ii df-10 breqtrri ) AB
    CDEFGBCHIJKLMN $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Some properties of specific numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  This includes adding two pairs of values 1..10
  (where the right is less than the left)
  and where the left is less than the right for the values 1..10.

$)

  $( Zero plus one equals one.  (Contributed by David A. Wheeler,
     7-Jul-2016.) $)
  0p1e1 $p |- ( 0 + 1 ) = 1 $=
    ( c1 ax-1cn addid2i ) ABC $.

  $( One plus one equals two.  (Contributed by NM, 1-Apr-2008.) $)
  1p1e2 $p |- ( 1 + 1 ) = 2 $=
    ( c2 c1 caddc co df-2 eqcomi ) ABBCDEF $.

  $( Prove that 2 - 1 = 1.  The result is on the right-hand-side to be
     consistent with similar proofs like ~ 4p4e8 .  (Contributed by David A.
     Wheeler, 4-Jan-2017.) $)
  2m1e1 $p |- ( 2 - 1 ) = 1 $=
    ( c2 c1 2cn ax-1cn 1p1e2 subaddrii ) ABBCDDEF $.

  $( 3 - 1 = 2.  (Contributed by FL, 17-Oct-2010.)  (Revised by NM,
     10-Dec-2017.) $)
  3m1e2 $p |- ( 3 - 1 ) = 2 $=
    ( c3 c1 c2 3cn ax-1cn 2cn caddc co addcomi df-3 eqtr4i subaddrii ) ABCDEFBC
    GHCBGHABCEFIJKL $.

  $( ` 2 ` equals ` 3 ` minus ` 1 ` .  (Contributed by FL, 17-Oct-2010.)
     Obsolete version of ~ 3m1e2 as of 10-Dec-2017.
     (New usage is discouraged.)  (Proof modification is discouraged.) $)
  3m1e2OLD $p |- 2 = ( 3 - 1 ) $=
    ( c3 c1 cmin co 3cn ax-1cn 2cn caddc addcomi df-3 eqtr4i subaddrii eqcomi
    c2 ) ABCDNABNEFGBNHDNBHDABNFGIJKLM $.

  $( Two plus two equals four.  For more information, see "2+2=4 Trivia" on the
     Metamath Proof Explorer Home Page:
     ~ http://us.metamath.org/mpeuni/mmset.html#trivia .  (Contributed by NM,
     27-May-1999.) $)
  2p2e4 $p |- ( 2 + 2 ) = 4 $=
    ( c2 caddc co c1 c4 df-2 oveq2i c3 df-4 oveq1i ax-1cn addassi 3eqtri eqtr4i
    df-3 2cn ) AABCADDBCZBCZEAQABFGEHDBCADBCZDBCRIHSDBOJADDPKKLMN $.

  $( Two times a number.  (Contributed by NM, 10-Oct-2004.)  (Revised by Mario
     Carneiro, 27-May-2016.) $)
  2times $p |- ( A e. CC -> ( 2 x. A ) = ( A + A ) ) $=
    ( cc wcel c2 cmul co c1 caddc df-2 oveq1i ax-1cn a1i adddird syl5eq oveq12d
    id mulid2 eqtrd ) ABCZDAEFZGAEFZUAHFZAAHFSTGGHFZAEFUBDUCAEIJSGGAGBCSKLZUDSP
    MNSUAAUAAHAQZUEOR $.

  $( A number times 2.  (Contributed by NM, 16-Oct-2007.) $)
  times2 $p |- ( A e. CC -> ( A x. 2 ) = ( A + A ) ) $=
    ( cc wcel c2 cmul co caddc wceq 2cn mulcom mpan2 2times eqtrd ) ABCZADEFZDA
    EFZAAGFNDBCOPHIADJKALM $.

  ${
    2times.1 $e |- A e. CC $.
    $( Two times a number.  (Contributed by NM, 1-Aug-1999.) $)
    2timesi $p |- ( 2 x. A ) = ( A + A ) $=
      ( cc wcel c2 cmul co caddc wceq 2times ax-mp ) ACDEAFGAAHGIBAJK $.

    $( A number times 2.  (Contributed by NM, 11-May-2004.) $)
    times2i $p |- ( A x. 2 ) = ( A + A ) $=
      ( cc wcel c2 cmul co caddc wceq times2 ax-mp ) ACDAEFGAAHGIBAJK $.
  $}

  $( 2 + 1 = 3.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  2p1e3 $p |- ( 2 + 1 ) = 3 $=
    ( c3 c2 c1 caddc co df-3 eqcomi ) ABCDEFG $.

  $( 3 + 1 = 4.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  3p1e4 $p |- ( 3 + 1 ) = 4 $=
    ( c4 c3 c1 caddc co df-4 eqcomi ) ABCDEFG $.

  $( 4 + 1 = 5.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  4p1e5 $p |- ( 4 + 1 ) = 5 $=
    ( c5 c4 c1 caddc co df-5 eqcomi ) ABCDEFG $.

  $( 5 + 1 = 6.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  5p1e6 $p |- ( 5 + 1 ) = 6 $=
    ( c6 c5 c1 caddc co df-6 eqcomi ) ABCDEFG $.

  $( 6 + 1 = 7.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  6p1e7 $p |- ( 6 + 1 ) = 7 $=
    ( c7 c6 c1 caddc co df-7 eqcomi ) ABCDEFG $.

  $( 7 + 1 = 8.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  7p1e8 $p |- ( 7 + 1 ) = 8 $=
    ( c8 c7 c1 caddc co df-8 eqcomi ) ABCDEFG $.

  $( 8 + 1 = 9.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  8p1e9 $p |- ( 8 + 1 ) = 9 $=
    ( c9 c8 c1 caddc co df-9 eqcomi ) ABCDEFG $.

  $( 9 + 1 = 10.  (Contributed by Mario Carneiro, 18-Apr-2015.) $)
  9p1e10 $p |- ( 9 + 1 ) = 10 $=
    ( c10 c9 c1 caddc co df-10 eqcomi ) ABCDEFG $.

  $( 3 + 2 = 5.  (Contributed by NM, 11-May-2004.) $)
  3p2e5 $p |- ( 3 + 2 ) = 5 $=
    ( c3 c2 caddc co c4 c1 c5 df-2 oveq2i 3cn ax-1cn addassi eqtr4i df-4 oveq1i
    df-5 ) ABCDZEFCDZGQAFCDZFCDZRQAFFCDZCDTBUAACHIAFFJKKLMESFCNOMPM $.

  $( 3 + 3 = 6.  (Contributed by NM, 11-May-2004.) $)
  3p3e6 $p |- ( 3 + 3 ) = 6 $=
    ( c3 caddc co c2 c1 c6 df-3 oveq2i 3cn 2cn ax-1cn addassi eqtr4i df-6 3p2e5
    c5 oveq1i ) AABCZADBCZEBCZFRADEBCZBCTAUAABGHADEIJKLMFPEBCTNSPEBOQMM $.

  $( 4 + 2 = 6.  (Contributed by NM, 11-May-2004.) $)
  4p2e6 $p |- ( 4 + 2 ) = 6 $=
    ( c4 c2 caddc co c5 c1 c6 df-2 oveq2i 4cn ax-1cn addassi eqtr4i df-5 oveq1i
    df-6 ) ABCDZEFCDZGQAFCDZFCDZRQAFFCDZCDTBUAACHIAFFJKKLMESFCNOMPM $.

  $( 4 + 3 = 7.  (Contributed by NM, 11-May-2004.) $)
  4p3e7 $p |- ( 4 + 3 ) = 7 $=
    ( c4 c3 caddc co c2 c1 c7 df-3 oveq2i 4cn 2cn ax-1cn addassi eqtr4i c6 df-7
    4p2e6 oveq1i ) ABCDZAECDZFCDZGSAEFCDZCDUABUBACHIAEFJKLMNGOFCDUAPTOFCQRNN $.

  $( 4 + 4 = 8.  (Contributed by NM, 11-May-2004.) $)
  4p4e8 $p |- ( 4 + 4 ) = 8 $=
    ( c4 caddc co c3 c1 c8 df-4 oveq2i 4cn 3cn ax-1cn addassi eqtr4i df-8 4p3e7
    c7 oveq1i ) AABCZADBCZEBCZFRADEBCZBCTAUAABGHADEIJKLMFPEBCTNSPEBOQMM $.

  $( 5 + 2 = 7.  (Contributed by NM, 11-May-2004.) $)
  5p2e7 $p |- ( 5 + 2 ) = 7 $=
    ( c5 c2 caddc co c6 c1 c7 df-2 oveq2i 5re ax-1cn addassi eqtr4i df-6 oveq1i
    recni df-7 ) ABCDZEFCDZGRAFCDZFCDZSRAFFCDZCDUABUBACHIAFFAJPKKLMETFCNOMQM $.

  $( 5 + 3 = 8.  (Contributed by NM, 11-May-2004.) $)
  5p3e8 $p |- ( 5 + 3 ) = 8 $=
    ( c5 c3 caddc co c2 c1 df-3 oveq2i 5re recni 2cn ax-1cn addassi eqtr4i df-8
    c8 c7 5p2e7 oveq1i ) ABCDZAECDZFCDZPTAEFCDZCDUBBUCACGHAEFAIJKLMNPQFCDUBOUAQ
    FCRSNN $.

  $( 5 + 4 = 9.  (Contributed by NM, 11-May-2004.) $)
  5p4e9 $p |- ( 5 + 4 ) = 9 $=
    ( c5 c4 caddc co c3 c1 df-4 oveq2i 5re recni 3cn ax-1cn addassi eqtr4i df-9
    c9 c8 5p3e8 oveq1i ) ABCDZAECDZFCDZPTAEFCDZCDUBBUCACGHAEFAIJKLMNPQFCDUBOUAQ
    FCRSNN $.

  $( 5 + 5 = 10.  (Contributed by NM, 5-Feb-2007.) $)
  5p5e10 $p |- ( 5 + 5 ) = 10 $=
    ( c5 caddc co c4 c1 c10 oveq2i 5re recni 4cn ax-1cn addassi eqtr4i c9 df-10
    df-5 5p4e9 oveq1i ) AABCZADBCZEBCZFSADEBCZBCUAAUBABPGADEAHIJKLMFNEBCUAOTNEB
    QRMM $.

  $( 6 + 2 = 8.  (Contributed by NM, 11-May-2004.) $)
  6p2e8 $p |- ( 6 + 2 ) = 8 $=
    ( c6 c2 caddc co c7 c1 c8 df-2 oveq2i 6re ax-1cn addassi eqtr4i df-7 oveq1i
    recni df-8 ) ABCDZEFCDZGRAFCDZFCDZSRAFFCDZCDUABUBACHIAFFAJPKKLMETFCNOMQM $.

  $( 6 + 3 = 9.  (Contributed by NM, 11-May-2004.) $)
  6p3e9 $p |- ( 6 + 3 ) = 9 $=
    ( c6 c3 caddc co c2 c1 df-3 oveq2i 6re recni 2cn ax-1cn addassi eqtr4i df-9
    c9 c8 6p2e8 oveq1i ) ABCDZAECDZFCDZPTAEFCDZCDUBBUCACGHAEFAIJKLMNPQFCDUBOUAQ
    FCRSNN $.

  $( 6 + 4 = 10.  (Contributed by NM, 5-Feb-2007.) $)
  6p4e10 $p |- ( 6 + 4 ) = 10 $=
    ( c6 c4 caddc co c3 c1 c10 oveq2i 6re recni 3cn ax-1cn addassi eqtr4i df-10
    df-4 c9 6p3e9 oveq1i ) ABCDZAECDZFCDZGTAEFCDZCDUBBUCACPHAEFAIJKLMNGQFCDUBOU
    AQFCRSNN $.

  $( 7 + 2 = 9.  (Contributed by NM, 11-May-2004.) $)
  7p2e9 $p |- ( 7 + 2 ) = 9 $=
    ( c7 c2 caddc co c8 c1 c9 df-2 oveq2i 7re ax-1cn addassi eqtr4i df-8 oveq1i
    recni df-9 ) ABCDZEFCDZGRAFCDZFCDZSRAFFCDZCDUABUBACHIAFFAJPKKLMETFCNOMQM $.

  $( 7 + 3 = 10.  (Contributed by NM, 5-Feb-2007.) $)
  7p3e10 $p |- ( 7 + 3 ) = 10 $=
    ( c7 c3 caddc co c2 c1 c10 oveq2i 7re recni 2cn ax-1cn addassi eqtr4i df-10
    df-3 c9 7p2e9 oveq1i ) ABCDZAECDZFCDZGTAEFCDZCDUBBUCACPHAEFAIJKLMNGQFCDUBOU
    AQFCRSNN $.

  $( 8 + 2 = 10.  (Contributed by NM, 5-Feb-2007.) $)
  8p2e10 $p |- ( 8 + 2 ) = 10 $=
    ( c8 c2 caddc co c9 c1 c10 df-2 oveq2i 8re recni ax-1cn addassi eqtr4i df-9
    oveq1i df-10 ) ABCDZEFCDZGRAFCDZFCDZSRAFFCDZCDUABUBACHIAFFAJKLLMNETFCOPNQN
    $.

  $( 1 times 1 equals 1.  (Contributed by David A. Wheeler, 7-Jul-2016.) $)
  1t1e1 $p |- ( 1 x. 1 ) = 1 $=
    ( c1 ax-1cn mulid1i ) ABC $.

  $( 2 times 2 equals 4.  (Contributed by NM, 1-Aug-1999.) $)
  2t2e4 $p |- ( 2 x. 2 ) = 4 $=
    ( c2 cmul co caddc c4 2cn 2timesi 2p2e4 eqtri ) AABCAADCEAFGHI $.

  $( 3 times 2 equals 6.  (Contributed by NM, 2-Aug-2004.) $)
  3t2e6 $p |- ( 3 x. 2 ) = 6 $=
    ( c3 c2 cmul co caddc c6 3cn times2i 3p3e6 eqtri ) ABCDAAEDFAGHIJ $.

  $( 3 times 3 equals 9.  (Contributed by NM, 11-May-2004.) $)
  3t3e9 $p |- ( 3 x. 3 ) = 9 $=
    ( c3 cmul co c2 c1 caddc c9 df-3 oveq2i 3cn 2cn ax-1cn adddii 3t2e6 mulid1i
    c6 oveq12i eqtri 6p3e9 ) AABCADEFCZBCZGATABHIUAPAFCZGUAADBCZAEBCZFCUBADEJKL
    MUCPUDAFNAJOQRSRR $.

  $( 4 times 2 equals 8.  (Contributed by NM, 2-Aug-2004.) $)
  4t2e8 $p |- ( 4 x. 2 ) = 8 $=
    ( c4 c2 cmul co caddc c8 4cn times2i 4p4e8 eqtri ) ABCDAAEDFAGHIJ $.

  $( 5 times 2 equals 10.  (Contributed by NM, 5-Feb-2007.) $)
  5t2e10 $p |- ( 5 x. 2 ) = 10 $=
    ( c5 c2 cmul co caddc c10 5re recni times2i 5p5e10 eqtri ) ABCDAAEDFAAGHIJK
    $.

  $( One half of four is two.  (Contributed by NM, 3-Sep-1999.) $)
  4d2e2 $p |- ( 4 / 2 ) = 2 $=
    ( c4 c2 cdiv co wceq cmul 2t2e4 4cn 2cn 2ne0 divmuli mpbir ) ABCDBEBBFDAEGA
    BBHIIJKL $.

  $( 2 is a natural number.  (Contributed by NM, 20-Aug-2001.) $)
  2nn $p |- 2 e. NN $=
    ( c2 c1 caddc co cn df-2 wcel 1nn peano2nn ax-mp eqeltri ) ABBCDZEFBEGLEGHB
    IJK $.

  $( 3 is a natural number.  (Contributed by NM, 8-Jan-2006.) $)
  3nn $p |- 3 e. NN $=
    ( c3 c2 c1 caddc co cn df-3 wcel 2nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 4 is a natural number.  (Contributed by NM, 8-Jan-2006.) $)
  4nn $p |- 4 e. NN $=
    ( c4 c3 c1 caddc co cn df-4 wcel 3nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 5 is a natural number.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  5nn $p |- 5 e. NN $=
    ( c5 c4 c1 caddc co cn df-5 wcel 4nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 6 is a natural number.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  6nn $p |- 6 e. NN $=
    ( c6 c5 c1 caddc co cn df-6 wcel 5nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 7 is a natural number.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  7nn $p |- 7 e. NN $=
    ( c7 c6 c1 caddc co cn df-7 wcel 6nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 8 is a natural number.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  8nn $p |- 8 e. NN $=
    ( c8 c7 c1 caddc co cn df-8 wcel 7nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 9 is a natural number.  (Contributed by NM, 21-Oct-2012.) $)
  9nn $p |- 9 e. NN $=
    ( c9 c8 c1 caddc co cn df-9 wcel 8nn peano2nn ax-mp eqeltri ) ABCDEZFGBFHMF
    HIBJKL $.

  $( 10 is a natural number.  (Contributed by NM, 8-Nov-2012.) $)
  10nn $p |- 10 e. NN $=
    ( c10 c9 c1 caddc co cn df-10 wcel 9nn peano2nn ax-mp eqeltri ) ABCDEZFGBFH
    MFHIBJKL $.

  $( 1 is less than 2.  (Contributed by NM, 24-Feb-2005.) $)
  1lt2 $p |- 1 < 2 $=
    ( c1 caddc co c2 clt 1re ltp1i df-2 breqtrri ) AAABCDEAFGHI $.

  $( 2 is less than 3.  (Contributed by NM, 26-Sep-2010.) $)
  2lt3 $p |- 2 < 3 $=
    ( c2 c1 caddc co c3 clt 2re ltp1i df-3 breqtrri ) AABCDEFAGHIJ $.

  $( 1 is less than 3.  (Contributed by NM, 26-Sep-2010.) $)
  1lt3 $p |- 1 < 3 $=
    ( c1 c2 clt wbr c3 1lt2 2lt3 1re 2re 3re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 3 is less than 4.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  3lt4 $p |- 3 < 4 $=
    ( c3 c1 caddc co c4 clt 3re ltp1i df-4 breqtrri ) AABCDEFAGHIJ $.

  $( 2 is less than 4.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  2lt4 $p |- 2 < 4 $=
    ( c2 c3 clt wbr c4 2lt3 3lt4 2re 3re 4re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 1 is less than 4.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  1lt4 $p |- 1 < 4 $=
    ( c1 c2 clt wbr c4 1lt2 2lt4 1re 2re 4re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 4 is less than 5.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  4lt5 $p |- 4 < 5 $=
    ( c4 c1 caddc co c5 clt 4re ltp1i df-5 breqtrri ) AABCDEFAGHIJ $.

  $( 3 is less than 5.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  3lt5 $p |- 3 < 5 $=
    ( c3 c4 clt wbr c5 3lt4 4lt5 3re 4re 5re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 2 is less than 5.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  2lt5 $p |- 2 < 5 $=
    ( c2 c4 clt wbr c5 2lt4 4lt5 2re 4re 5re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 1 is less than 5.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  1lt5 $p |- 1 < 5 $=
    ( c1 c4 clt wbr c5 1lt4 4lt5 1re 4re 5re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 5 is less than 6.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  5lt6 $p |- 5 < 6 $=
    ( c5 c1 caddc co c6 clt 5re ltp1i df-6 breqtrri ) AABCDEFAGHIJ $.

  $( 4 is less than 6.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  4lt6 $p |- 4 < 6 $=
    ( c4 c5 clt wbr c6 4lt5 5lt6 4re 5re 6re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 3 is less than 6.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  3lt6 $p |- 3 < 6 $=
    ( c3 c4 clt wbr c6 3lt4 4lt6 3re 4re 6re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 2 is less than 6.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  2lt6 $p |- 2 < 6 $=
    ( c2 c3 clt wbr c6 2lt3 3lt6 2re 3re 6re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 1 is less than 6.  (Contributed by NM, 19-Oct-2012.) $)
  1lt6 $p |- 1 < 6 $=
    ( c1 c2 clt wbr c6 1lt2 2lt6 1re 2re 6re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 6 is less than 7.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  6lt7 $p |- 6 < 7 $=
    ( c6 c1 caddc co c7 clt 6re ltp1i df-7 breqtrri ) AABCDEFAGHIJ $.

  $( 5 is less than 7.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  5lt7 $p |- 5 < 7 $=
    ( c5 c6 clt wbr c7 5lt6 6lt7 5re 6re 7re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 4 is less than 7.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  4lt7 $p |- 4 < 7 $=
    ( c4 c5 clt wbr c7 4lt5 5lt7 4re 5re 7re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 3 is less than 7.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  3lt7 $p |- 3 < 7 $=
    ( c3 c4 clt wbr c7 3lt4 4lt7 3re 4re 7re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 2 is less than 7.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  2lt7 $p |- 2 < 7 $=
    ( c2 c3 clt wbr c7 2lt3 3lt7 2re 3re 7re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 1 is less than 7.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  1lt7 $p |- 1 < 7 $=
    ( c1 c2 clt wbr c7 1lt2 2lt7 1re 2re 7re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 7 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  7lt8 $p |- 7 < 8 $=
    ( c7 c1 caddc co c8 clt 7re ltp1i df-8 breqtrri ) AABCDEFAGHIJ $.

  $( 6 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  6lt8 $p |- 6 < 8 $=
    ( c6 c7 clt wbr c8 6lt7 7lt8 6re 7re 8re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 5 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  5lt8 $p |- 5 < 8 $=
    ( c5 c6 clt wbr c8 5lt6 6lt8 5re 6re 8re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 4 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  4lt8 $p |- 4 < 8 $=
    ( c4 c5 clt wbr c8 4lt5 5lt8 4re 5re 8re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 3 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  3lt8 $p |- 3 < 8 $=
    ( c3 c4 clt wbr c8 3lt4 4lt8 3re 4re 8re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 2 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  2lt8 $p |- 2 < 8 $=
    ( c2 c3 clt wbr c8 2lt3 3lt8 2re 3re 8re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 1 is less than 8.  (Contributed by Mario Carneiro, 15-Sep-2013.) $)
  1lt8 $p |- 1 < 8 $=
    ( c1 c2 clt wbr c8 1lt2 2lt8 1re 2re 8re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 8 is less than 9.  (Contributed by Mario Carneiro, 19-Feb-2014.) $)
  8lt9 $p |- 8 < 9 $=
    ( c8 c1 caddc co c9 clt 8re ltp1i df-9 breqtrri ) AABCDEFAGHIJ $.

  $( 7 is less than 9.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
  7lt9 $p |- 7 < 9 $=
    ( c7 c8 clt wbr c9 7lt8 8lt9 7re 8re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 6 is less than 9.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
  6lt9 $p |- 6 < 9 $=
    ( c6 c7 clt wbr c9 6lt7 7lt9 6re 7re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 5 is less than 9.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
  5lt9 $p |- 5 < 9 $=
    ( c5 c6 clt wbr c9 5lt6 6lt9 5re 6re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 4 is less than 9.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
  4lt9 $p |- 4 < 9 $=
    ( c4 c5 clt wbr c9 4lt5 5lt9 4re 5re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 3 is less than 9.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
  3lt9 $p |- 3 < 9 $=
    ( c3 c4 clt wbr c9 3lt4 4lt9 3re 4re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 2 is less than 9.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
  2lt9 $p |- 2 < 9 $=
    ( c2 c3 clt wbr c9 2lt3 3lt9 2re 3re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 1 is less than 9.  (Contributed by NM, 19-Oct-2012.)  (Revised by Mario
     Carneiro, 9-Mar-2015.) $)
  1lt9 $p |- 1 < 9 $=
    ( c1 c2 clt wbr c9 1lt2 2lt9 1re 2re 9re lttri mp2an ) ABCDBECDAECDFGABEHIJ
    KL $.

  $( 9 is less than 10.  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
  9lt10 $p |- 9 < 10 $=
    ( c9 c1 caddc co c10 clt 9re ltp1i df-10 breqtrri ) AABCDEFAGHIJ $.

  $( 8 is less than 10.  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
  8lt10 $p |- 8 < 10 $=
    ( c8 c9 clt wbr c10 8lt9 9lt10 8re 9re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 7 is less than 10.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
  7lt10 $p |- 7 < 10 $=
    ( c7 c8 clt wbr c10 7lt8 8lt10 7re 8re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 6 is less than 10.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
  6lt10 $p |- 6 < 10 $=
    ( c6 c7 clt wbr c10 6lt7 7lt10 6re 7re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 5 is less than 10.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
  5lt10 $p |- 5 < 10 $=
    ( c5 c6 clt wbr c10 5lt6 6lt10 5re 6re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 4 is less than 10.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
  4lt10 $p |- 4 < 10 $=
    ( c4 c5 clt wbr c10 4lt5 5lt10 4re 5re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 3 is less than 10.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
  3lt10 $p |- 3 < 10 $=
    ( c3 c4 clt wbr c10 3lt4 4lt10 3re 4re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 2 is less than 10.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
  2lt10 $p |- 2 < 10 $=
    ( c2 c3 clt wbr c10 2lt3 3lt10 2re 3re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 1 is less than 10.  (Contributed by NM, 7-Nov-2012.)  (Revised by Mario
     Carneiro, 9-Mar-2015.) $)
  1lt10 $p |- 1 < 10 $=
    ( c1 c2 clt wbr c10 1lt2 2lt10 1re 2re 10re lttri mp2an ) ABCDBECDAECDFGABE
    HIJKL $.

  $( 1 is not equal to 2.  (Contributed by NM, 19-Oct-2012.) $)
  1ne2 $p |- 1 =/= 2 $=
    ( c1 c2 1re 1lt2 ltneii ) ABCDE $.

  $( One-half is greater than zero.  (Contributed by NM, 24-Feb-2005.) $)
  halfgt0 $p |- 0 < ( 1 / 2 ) $=
    ( c2 2re 2pos recgt0ii ) ABCD $.

  $( One-half is less than one.  (Contributed by NM, 24-Feb-2005.) $)
  halflt1 $p |- ( 1 / 2 ) < 1 $=
    ( c1 cdiv co clt wbr ax-1cn div1i 1lt2 eqbrtri 1re 0lt1 2pos ltdiv23ii mpbi
    c2 2re ) AABCZODEAOBCADEQAODAFGHIAAOJJPKLMN $.

  $( Prove that 1 - 1/2 = 1/2.  (Contributed by David A. Wheeler,
     4-Jan-2017.) $)
  1mhlfehlf $p |- ( 1 - ( 1 / 2 ) ) = ( 1 / 2 ) $=
    ( c2 c1 cmin co cdiv cc wcel cc0 wne wceq 2cn ax-1cn pm3.2i divsubdir mp3an
    wa 2ne0 2m1e1 oveq1i dividi 3eqtr3ri ) ABCDZAEDZAAEDZBAEDZCDZUEBUECDAFGZBFG
    UGAHIZPUCUFJKLUGUHKQMABANOUBBAERSUDBUECAKQTSUA $.

  $( An eighth of four thirds is a sixth.  (Contributed by Paul Chapman,
     24-Nov-2007.) $)
  8th4div3 $p |- ( ( 1 / 8 ) x. ( 4 / 3 ) ) = ( 1 / 6 ) $=
    ( c1 c8 cdiv co c4 c3 cmul c6 ax-1cn 8re recni 4cn gt0ne0ii c2 eqtr3i eqtri
    3cn 2cn cc wcel divmuldivi mulcomi mul32i 4t2e8 oveq1i mulassi 3t2e6 oveq2i
    8pos 3ne0 oveq12i cc0 wne wceq 6re 6pos 4re 4pos wa divcan5 mp3an1 mp4an )
    ABCDEFCDGDZEAGDZEHGDZCDZAHCDZVCAEGDZBFGDZCDVFABEFIBJKLQBJUIMUJUAVHVDVIVECAE
    ILUBVIEFNGDZGDZVEEFGDNGDZVIVKENGDZFGDVLVIENFLRQUCVMBFGUDUEOEFNLQRUFOVJHEGUG
    UHPUKPHSTZHULUMZESTZEULUMZVFVGUNZHUOKHUOUPMLEUQURMASTVNVOUSVPVQUSVRIAHEUTVA
    VBP $.

  $( One half plus or minus one sixth.  (Contributed by Paul Chapman,
     17-Jan-2008.) $)
  halfpm6th $p |- ( ( ( 1 / 2 ) - ( 1 / 6 ) ) = ( 1 / 3 ) /\
                       ( ( 1 / 2 ) + ( 1 / 6 ) ) = ( 2 / 3 ) ) $=
    ( c1 c2 cdiv co c6 cmin wceq caddc cmul 3cn ax-1cn 2cn 3ne0 2ne0 divmuldivi
    c3 oveq1i mulid1i 3t2e6 oveq12i dividi rereccli recni mulid2i eqtri 3eqtr3i
    2re cc wcel cc0 wne 6re gt0ne0ii pm3.2i divsubdir mp3an 3m1e2 oveq2i reccli
    wa 6pos 3eqtr2i c4 divdiri df-4 3eqtr4ri 2t2e4 divcli ) ABCDZAECDZFDZAPCDZG
    VIVJHDZBPCDZGVKPECDZVJFDZPAFDZECDZVLVIVOVJFPPCDZVIIDZPAIDZPBIDZCDVIVOPPABJJ
    KLMNOVTAVIIDVIVSAVIIPJMUAQVIVIBUGNUBUCUDUEWAPWBECPJRSTUFZQPUHUIAUHUIEUHUIZE
    UJUKZUTVRVPGJKWDWEEULUCZEULVAUMZUNPAEUOUPVRBECDABIDZWBCDZVLVQBECUQQWHBWBECB
    LUDSTVLBBCDZIDVLAIDWIVLWJAVLIBLNUAZURAPBBKJLLMNOVLPJMUSRUFVBVBVMVCECDZBBIDZ
    WBCDZVNPAHDZECDVOVJHDWLVMPAEJKWFWGVDVCWOECVEQVIVOVJHWCQVFWMVCWBECVGSTVNWJID
    VNAIDWNVNWJAVNIWKURBPBBLJLLMNOVNBPLJMVHRUFVBUN $.

  $( Closure of half of a number (frequently used special case).  (Contributed
     by NM, 1-Jan-2006.) $)
  halfcl $p |- ( A e. CC -> ( A / 2 ) e. CC ) $=
    ( cc wcel c2 cc0 wne cdiv co 2cn 2ne0 divcl mp3an23 ) ABCDBCDEFADGHBCIJADKL
    $.

  $( Real closure of half.  (Contributed by NM, 1-Jan-2006.) $)
  rehalfcl $p |- ( A e. RR -> ( A / 2 ) e. RR ) $=
    ( cr wcel c2 cc0 wne cdiv co 2re 2ne0 redivcl mp3an23 ) ABCDBCDEFADGHBCIJAD
    KL $.

  $( Half of a number is zero iff the number is zero.  (Contributed by NM,
     20-Apr-2006.) $)
  half0 $p |- ( A e. CC -> ( ( A / 2 ) = 0 <-> A = 0 ) ) $=
    ( cc wcel c2 cc0 wne cdiv co wceq wb 2cn 2ne0 diveq0 mp3an23 ) ABCDBCDEFADG
    HEIAEIJKLADMN $.

  $( Two halves make a whole.  (Contributed by NM, 11-Apr-2005.) $)
  2halves $p |- ( A e. CC -> ( ( A / 2 ) + ( A / 2 ) ) = A ) $=
    ( cc wcel c2 cmul co cdiv caddc 2times oveq1d cc0 wne wceq 2cn 2ne0 divcan3
    mp3an23 wa pm3.2i divdir mp3an3 anidms 3eqtr3rd ) ABCZDAEFZDGFZAAHFZDGFZAAD
    GFZUIHFZUDUEUGDGAIJUDDBCZDKLZUFAMNOADPQUDUHUJMZUDUDUKULRUMUKULNOSAADTUAUBUC
    $.

  $( A number is positive iff its half is positive.  (Contributed by NM,
     10-Apr-2005.) $)
  halfpos2 $p |- ( A e. RR -> ( 0 < A <-> 0 < ( A / 2 ) ) ) $=
    ( cr wcel c2 cc0 clt wbr cdiv co wb 2re 2pos gt0div mp3an23 ) ABCDBCEDFGEAF
    GEADHIFGJKLADMN $.

  $( A positive number is greater than its half.  (Contributed by NM,
     28-Oct-2004.)  (Proof shortened by Mario Carneiro, 27-May-2016.) $)
  halfpos $p |- ( A e. RR -> ( 0 < A <-> ( A / 2 ) < A ) ) $=
    ( cr wcel cc0 clt c2 cdiv co caddc halfpos2 rehalfcl ltaddposd cc wceq recn
    wbr 2halves syl breq2d 3bitrd ) ABCZDAEPDAFGHZEPUBUBUBIHZEPUBAEPAJUAUBUBAKZ
    UDLUAUCAUBEUAAMCUCANAOAQRST $.

  $( A number is nonnegative iff its half is nonnegative.  (Contributed by NM,
     9-Dec-2005.) $)
  halfnneg2 $p |- ( A e. RR -> ( 0 <_ A <-> 0 <_ ( A / 2 ) ) ) $=
    ( cr wcel c2 cc0 clt wbr cle cdiv co wb 2re 2pos ge0div mp3an23 ) ABCDBCEDF
    GEAHGEADIJHGKLMADNO $.

  $( Closure of half-sum and half-difference.  (Contributed by Paul Chapman,
     12-Oct-2007.) $)
  halfaddsubcl $p |- ( ( A e. CC /\ B e. CC ) -> ( ( ( A + B ) / 2 ) e. CC /\
                         ( ( A - B ) / 2 ) e. CC ) ) $=
    ( cc wcel wa caddc co c2 cdiv cmin addcl halfcl syl subcl jca ) ACDBCDEZABF
    GZHIGCDZABJGZHIGCDZPQCDRABKQLMPSCDTABNSLMO $.

  $( Sum and difference of half-sum and half-difference.  (Contributed by Paul
     Chapman, 12-Oct-2007.) $)
  halfaddsub $p |- ( ( A e. CC /\ B e. CC ) ->
                      ( ( ( ( A + B ) / 2 ) + ( ( A - B ) / 2 ) ) = A /\
                        ( ( ( A + B ) / 2 ) - ( ( A - B ) / 2 ) ) = B ) ) $=
    ( cc wcel wa caddc cdiv cmin wceq cmul 2times adantr eqtr4d oveq1d 2cn 2ne0
    co c2 mp3an3 syl2anc ppncan 3anidm13 addcl subcl cc0 pm3.2i divcan3 mp3an23
    wne divdir 3eqtr3d pnncan 3anidm23 adantl divsubdir jca ) ACDZBCDZEZABFQZRG
    QZABHQZRGQZFQZAIVAVCHQZBIUSUTVBFQZRGQZRAJQZRGQZVDAUSVFVHRGUSVFAAFQZVHUQURVF
    VJIABAUAUBUQVHVJIURAKLMNUSUTCDZVBCDZVGVDIZABUCZABUDZVKVLRCDZRUEUIZEZVMVPVQO
    PUFZUTVBRUJSTUQVIAIZURUQVPVQVTOPARUGUHLUKUSUTVBHQZRGQZRBJQZRGQZVEBUSWAWCRGU
    SWABBFQZWCUQURWAWEIABBULUMURWCWEIUQBKUNMNUSVKVLWBVEIZVNVOVKVLVRWFVSUTVBRUOS
    TURWDBIZUQURVPVQWGOPBRUGUHUNUKUP $.

  $( TODO - use this to reduce:
  Statement "lt2add" is directly referenced in the proofs of 9 statements:
    2climnn 2climnn0 climaddlem3 climmullem5 climcaui ser1f0i
  MM> sh us 2halves
  Statement "2halves" is directly referenced in the proofs of 10 statements:
    2climnn 2climnn0 climmullem5 climcaui caucvgi ser1f0i
  MM>
  $)
  $( A sum is less than the whole if each term is less than half.  (Contributed
     by NM, 13-Dec-2006.) $)
  lt2halves $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                ( ( A < ( C / 2 ) /\ B < ( C / 2 ) ) -> ( A + B ) < C ) ) $=
    ( cr wcel w3a c2 co clt wbr wa caddc wi 3simpa rehalfcl jca 3ad2ant3 lt2add
    cdiv syl2anc wb cc wceq recn 2halves syl breq2d sylibd ) ADEZBDEZCDEZFZACGS
    HZIJBUMIJKZABLHZUMUMLHZIJZUOCIJZULUIUJKUMDEZUSKZUNUQMUIUJUKNUKUIUTUJUKUSUSC
    OZVAPQABUMUMRTUKUIUQURUAUJUKUPCUOIUKCUBEUPCUCCUDCUEUFUGQUH $.

  $( Sum is less than product for numbers greater than 2.  (Contributed by
     Stefan Allan, 24-Sep-2010.) $)
  addltmul $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 2 < A /\ 2 < B ) )
              -> ( A + B ) < ( A x. B ) ) $=
    ( cr wcel wa c2 clt wbr caddc co cmul c1 cmin 2re 1re ltsub1 syl2an remulcl
    wb cc mp3an13 2m1e1 breq1i syl6bb bi2anan9 wi peano2rem mulgt1 ex wceq recn
    sylbid ax-1cn mulsub mpanl2 mpanr2 breq2d 1t1e1 oveq2i breq2i mpan2 readdcl
    remulcli sylancl ltaddsub2 mp3an2 syl2anc syl5rbbr ltadd1 ax-1rid oveqan12d
    mp3an3 breq1d bitr3d 3bitrd sylibd imp ) ACDZBCDZEZFAGHZFBGHZEZABIJZABKJZGH
    ZVTWCLALMJZBLMJZKJZGHZWFVTWCLWGGHZLWHGHZEZWJVRWAWKVSWBWLVRWAFLMJZWGGHZWKFCD
    ZVRLCDZWAWOSNOFALPUAWNLWGGUBUCUDVSWBWNWHGHZWLWPVSWQWBWRSNOFBLPUAWNLWHGUBUCU
    DUEVRWGCDZWHCDZWMWJUFVSAUGBUGWSWTEWMWJWGWHUHUIQULVTWJLWELLKJZIJZALKJZBLKJZI
    JZMJZGHZXELIJZWELIJZGHZWFVTWIXFLGVRATDZBTDZWIXFUJZVSAUKBUKXKXLLTDZXMUMXKXNX
    LXNEXMUMALBLUNUOUPQUQXJXHXBGHZVTXGXBXIXHGXALWEIURUSUTVTXECDZXBCDZXOXGSZVRXC
    CDZXDCDZXPVSVRWQXSOALRVAVSWQXTOBLRVAXCXDVBQZVTWECDZXACDXQABRZLLOOVCWEXAVBVD
    XPWQXQXROXELXBVEVFVGVHVTXEWEGHZXJWFVTXPYBYDXJSZYAYCXPYBWQYEOXEWELVIVLVGVTXE
    WDWEGVRVSXCAXDBIAVJBVJVKVMVNVOVPVQ $.

  ${
    $d x y $.
    $( There is no smallest positive real number.  (Contributed by NM,
       28-Oct-2004.) $)
    nominpos $p |- -. E. x e. RR ( 0 < x /\
                   -. E. y e. RR ( 0 < y /\ y < x ) ) $=
      ( cc0 cv clt wbr wa cr wrex wn wcel wi c2 cdiv co rehalfcl divgt0 mpanr12
      2re 2pos halfpos biimpd jcad wceq breq2 breq1 anbi12d rspcev ee12an sylib
      ex iman nrex ) CADZEFZCBDZEFZUPUNEFZGZBHIZJGZAHUNHKZUOUTLVAJVBUNMNOZHKUOC
      VCEFZVCUNEFZGZUTUNPVBUOVDVEVBUOVDVBUOGMHKCMEFVDSTUNMQRUKVBUOVEUNUAUBUCUSV
      FBVCHUPVCUDUQVDURVEUPVCCEUEUPVCUNEUFUGUHUIUOUTULUJUM $.
  $}

  $( Ordering property for average.  (Contributed by Mario Carneiro,
     28-May-2014.) $)
  avglt1 $p |- ( ( A e. RR /\ B e. RR ) ->
                 ( A < B <-> A < ( ( A + B ) / 2 ) ) ) $=
    ( cr wcel wa clt wbr caddc co c2 cmul cdiv wb ltadd2 3anidm13 cc wceq simpl
    recnd times2 syl breq1d cc0 readdcl 2re pm3.2i a1i ltmuldiv syl3anc 3bitr2d
    2pos ) ACDZBCDZEZABFGZAAHIZABHIZFGZAJKIZUQFGZAUQJLIFGZULUMUOURMABANOUNUSUPU
    QFUNAPDUSUPQUNAULUMRZSATUAUBUNULUQCDJCDZUCJFGZEZUTVAMVBABUDVEUNVCVDUEUKUFUG
    AUQJUHUIUJ $.

  $( Ordering property for average.  (Contributed by Mario Carneiro,
     28-May-2014.) $)
  avglt2 $p |- ( ( A e. RR /\ B e. RR ) ->
                 ( A < B <-> ( ( A + B ) / 2 ) < B ) ) $=
    ( cr wcel wa caddc co c2 cmul clt wbr cdiv cc simpr recnd 2times syl breq2d
    wceq wb cc0 readdcl 2re 2pos pm3.2i a1i ltdivmul syl3anc 3anidm23 3bitr4rd
    ltadd1 ) ACDZBCDZEZABFGZHBIGZJKZUOBBFGZJKZUOHLGBJKZABJKZUNUPURUOJUNBMDUPURS
    UNBULUMNZOBPQRUNUOCDUMHCDZUAHJKZEZUTUQTABUBVBVEUNVCVDUCUDUEUFUOBHUGUHULUMVA
    USTABBUKUIUJ $.

  $( Ordering property for average.  (Contributed by Mario Carneiro,
     28-May-2014.) $)
  avgle1 $p |- ( ( A e. RR /\ B e. RR ) ->
                 ( A <_ B <-> A <_ ( ( A + B ) / 2 ) ) ) $=
    ( cr wcel wa clt wbr wn caddc co c2 cdiv cle wb avglt2 ancoms cc wceq lenlt
    recn addcom syl2an oveq1d breq1d bitr4d notbid readdcl rehalfcl syl 3bitr4d
    syldan ) ACDZBCDZEZBAFGZHABIJZKLJZAFGZHZABMGAUQMGZUNUOURUNUOBAIJZKLJZAFGZUR
    UMULUOVCNBAOPUNUQVBAFUNUPVAKLULAQDBQDUPVARUMATBTABUAUBUCUDUEUFABSULUMUQCDZU
    TUSNUNUPCDVDABUGUPUHUIAUQSUKUJ $.

  $( Ordering property for average.  (Contributed by Jeff Hankins,
     15-Sep-2013.)  (Revised by Mario Carneiro, 28-May-2014.) $)
  avgle2 $p |- ( ( A e. RR /\ B e. RR ) ->
                 ( A <_ B <-> ( ( A + B ) / 2 ) <_ B ) ) $=
    ( cr wcel wa clt wbr wn caddc co c2 cdiv cle wb avglt1 ancoms cc wceq lenlt
    recn addcom syl2an oveq1d breq2d bitr4d notbid readdcl rehalfcl syl 3bitr4d
    sylancom ) ACDZBCDZEZBAFGZHBABIJZKLJZFGZHZABMGUQBMGZUNUOURUNUOBBAIJZKLJZFGZ
    URUMULUOVCNBAOPUNUQVBBFUNUPVAKLULAQDBQDUPVARUMATBTABUAUBUCUDUEUFABSULUMUQCD
    ZUTUSNUNUPCDVDABUGUPUHUIUQBSUKUJ $.

  $( The average of two numbers is less than or equal to at least one of them.
     (Contributed by NM, 9-Dec-2005.)  (Revised by Mario Carneiro,
     28-May-2014.) $)
  avgle $p |- ( ( A e. RR /\ B e. RR ) ->
               ( ( ( A + B ) / 2 ) <_ A \/ ( ( A + B ) / 2 ) <_ B ) ) $=
    ( cr wcel wa cle wo caddc co c2 cdiv letric orcomd wb avgle2 ancoms cc wceq
    wbr recn addcom syl2an oveq1d breq1d bitr4d orbi12d mpbid ) ACDZBCDZEZBAFSZ
    ABFSZGABHIZJKIZAFSZUNBFSZGUJULUKABLMUJUKUOULUPUJUKBAHIZJKIZAFSZUOUIUHUKUSNB
    AOPUJUNURAFUJUMUQJKUHAQDBQDUMUQRUIATBTABUAUBUCUDUEABOUFUG $.

  ${
    2timesd.1 $e |- ( ph -> A e. CC ) $.
    $( Two times a number.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    2timesd $p |- ( ph -> ( 2 x. A ) = ( A + A ) ) $=
      ( cc wcel c2 cmul co caddc wceq 2times syl ) ABDEFBGHBBIHJCBKL $.

    $( A number times 2.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    times2d $p |- ( ph -> ( A x. 2 ) = ( A + A ) ) $=
      ( cc wcel c2 cmul co caddc wceq times2 syl ) ABDEBFGHBBIHJCBKL $.

    $( Closure of half of a number (frequently used special case).
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    halfcld $p |- ( ph -> ( A / 2 ) e. CC ) $=
      ( cc wcel c2 cdiv co halfcl syl ) ABDEBFGHDECBIJ $.

    $( Two halves make a whole.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    2halvesd $p |- ( ph -> ( ( A / 2 ) + ( A / 2 ) ) = A ) $=
      ( cc wcel c2 cdiv co caddc wceq 2halves syl ) ABDEBFGHZMIHBJCBKL $.
  $}

  ${
    rehalfcld.1 $e |- ( ph -> A e. RR ) $.
    $( Real closure of half.  (Contributed by Mario Carneiro, 27-May-2016.) $)
    rehalfcld $p |- ( ph -> ( A / 2 ) e. RR ) $=
      ( cr wcel c2 cdiv co rehalfcl syl ) ABDEBFGHDECBIJ $.

    lt2halvesd.2 $e |- ( ph -> B e. RR ) $.
    lt2halvesd.3 $e |- ( ph -> C e. RR ) $.
    lt2halvesd.4 $e |- ( ph -> A < ( C / 2 ) ) $.
    lt2halvesd.5 $e |- ( ph -> B < ( C / 2 ) ) $.
    $( A sum is less than the whole if each term is less than half.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    lt2halvesd $p |- ( ph -> ( A + B ) < C ) $=
      ( c2 cdiv co clt wbr caddc cr wcel wa wi lt2halves syl3anc mp2and ) ABDJK
      LZMNZCUCMNZBCOLDMNZHIABPQCPQDPQUDUERUFSEFGBCDTUAUB $.
  $}

  ${
    rehalfcli.1 $e |- A e. RR $.
    $( Half a real number is real.  Inference form.  (Contributed by David
       Moews, 28-Feb-2017.) $)
    rehalfcli $p |- ( A / 2 ) e. RR $=
      ( cr wcel c2 cdiv co rehalfcl ax-mp ) ACDAEFGCDBAHI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The Archimedean property
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( The set of natural numbers is unbounded above.  Theorem I.28 of
       [Apostol] p. 26.  (Contributed by NM, 21-Jan-1997.) $)
    nnunb $p |- -. E. x e. RR A. y e. NN ( y < x \/ y = x ) $=
      ( vz cv clt wbr wceq cn wral cr wrex wn wi wa wcel wal wex c1 cmin c0 1re
      wo pm3.24 co peano2rem ltm1 ovex eleq1 breq1 rexbidv imbi12d spcv pm2.43d
      syl7 syl5 df-rex syl6ib com12 caddc wb nnre ltsubadd mp3an2 sylan2 exbidv
      pm5.32da peano2nn breq2 anbi12d spcev sylan exlimiv syl6bi df-ral alinexa
      syld bitr2i con1bii 3imtr4g anim2d mtoi nrex wss wne nnssre 1nn n0i ax-mp
      neir sup2 mp3an12 mto ) BDZADZEFZWMWNGUBBHIAJKZWNWMEFZLZBHIZWOWMCDZEFZCHK
      ZMZBJIZNZAJKZXEAJWNJOZXEWSWSLZNWSUCXGXDXHWSXGWMJOZXCMZBPZWMHOZWQNZBQZXDXH
      XGXKWTHOZWNRSUDZWTEFZNZCQZXNXKXGXSXKXGXQCHKZXSXKXGXTXGXPJOZXKXGXTMWNUEXGX
      PWNEFZXKYAXTWNUFXJYAYBXTMZMBXPWNRSUGWMXPGZXIYAXCYCWMXPJUHYDWOYBXBXTWMXPWN
      EUIYDXAXQCHWMXPWTEUIUJUKUKULUNUOUMXQCHUPUQURXGXSXOWNWTRUSUDZEFZNZCQXNXGXR
      YGCXGXOXQYFXOXGWTJOZXQYFUTZWTVAXGRJOYHYIUAWNRWTVBVCVDVFVEYGXNCXOYEHOZYFXN
      WTVGXMYJYFNBYEWTRUSUGWMYEGXLYJWQYFWMYEHUHWMYEWNEVHVIVJVKVLVMVPXCBJVNXNWSW
      SXLWRMBPXNLWRBHVNXLWQBVOVQVRVSVTWAWBHJWCHTWDWPXFWEHTRHOHTGLWFHRWGWHWIABCH
      WJWKWL $.
  $}

  ${
    $d n y A $.
    $( Archimedean property of real numbers.  For any real number, there is an
       integer greater than it.  Theorem I.29 of [Apostol] p. 26.  (Contributed
       by NM, 21-Jan-1997.) $)
    arch $p |- ( A e. RR -> E. n e. NN A < n ) $=
      ( vy cv clt wbr cn wrex cr wceq breq1 rexbidv wo wral wn nnunb mpbir wcel
      ralnex rexnal wa wb nnre axlttri sylan2 equcom orbi1i orcom notbii syl6bb
      bitri biimprd reximdva syl5bir ralimia ax-mp vtoclri ) CDZBDZEFZBGHZAUSEF
      ZBGHCAIURAJUTVBBGURAUSEKLUSUREFZUSURJZMZBGNZOZCINZVACINVHVFCIHOCBPVFCISQV
      GVACIVGVEOZBGHURIRZVAVEBGTVJVIUTBGVJUSGRZUAZUTVIVLUTURUSJZVCMZOZVIVKVJUSI
      RUTVOUBUSUCURUSUDUEVNVEVNVDVCMVEVMVDVCCBUFUGVDVCUHUKUIUJULUMUNUOUPUQ $.
  $}

  ${
    $d n A $.
    $( There exists a natural number whose reciprocal is less than a given
       positive real.  Exercise 3 of [Apostol] p. 28.  (Contributed by NM,
       8-Nov-2004.) $)
    nnrecl $p |- ( ( A e. RR /\ 0 < A ) -> E. n e. NN ( 1 / n ) < A ) $=
      ( cr wcel cc0 clt wbr wa c1 cdiv co cv cn simpl gt0ne0 rereccld wb adantr
      wrex jca arch recgt0 nnre nngt0 ltrec syl2an cc recn recrecd breq2d bitrd
      syl rexbidva mpbid ) ACDZEAFGZHZIAJKZBLZFGZBMSZIUSJKZAFGZBMSUQURCDZVAUQAU
      OUPNAOZPZURBUAULUQUTVCBMUQUSMDZHUTVBIURJKZFGZVCUQVDEURFGZHUSCDZEUSFGZHUTV
      IQVGUQVDVJVFAUBTVGVKVLUSUCUSUDTURUSUEUFUQVIVCQVGUQVHAVBFUQAUOAUGDUPAUHRVE
      UIUJRUKUMUN $.
  $}

  ${
    $d x A $.  $d x k $.
    $( A bounded real sequence ` A ( k ) ` is less than or equal to at least
       one of its indices.  (Contributed by NM, 18-Jan-2008.) $)
    bndndx $p |- ( E. x e. RR A. k e. NN ( A e. RR /\ A <_ x ) ->
                  E. k e. NN A <_ k ) $=
      ( cr wcel cv cle wbr wa cn wral wrex wi clt arch nnre lelttr ltle 3adant2
      w3a syld exp5o com3l imp4b com23 sylan2 reximdva r19.35 sylib rexlimiv
      mpd ) BDEZBAFZGHZIZCJKZBCFZGHZCJLZADUMDEZUOURMZCJLZUPUSMUTUMUQNHZCJLVBUMC
      OUTVCVACJUQJEUTUQDEZVCVAMUQPUTVDIUOVCURUTVDULUNVCURMZULUTVDUNVEMULUTVDUNV
      CURULUTVDTUNVCIBUQNHZURBUMUQQULVDVFURMUTBUQRSUAUBUCUDUEUFUGUKUOURCJUHUIUJ
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Nonnegative integers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c NN0 $. $( The set of nonnegative integers (blackboard bold N_0). $)

  $( Extend class notation to include the class of nonnegative integers. $)
  cn0 $a class NN0 $.

  $( Define the set of nonnegative integers.  (Contributed by Raph Levien,
     10-Dec-2002.) $)
  df-n0 $a |- NN0 = ( NN u. { 0 } ) $.

  $( Nonnegative integers expressed in terms of naturals and zero.
     (Contributed by Raph Levien, 10-Dec-2002.) $)
  elnn0 $p |- ( A e. NN0 <-> ( A e. NN \/ A = 0 ) ) $=
    ( cn0 wcel cn cc0 csn cun wceq df-n0 eleq2i elun c0ex elsnc2 orbi2i 3bitri
    wo ) ABCADEFZGZCADCZAQCZPSAEHZPBRAIJADQKTUASAELMNO $.

  $( Positive naturals are a subset of nonnegative integers.  (Contributed by
     Raph Levien, 10-Dec-2002.) $)
  nnssnn0 $p |- NN C_ NN0 $=
    ( cn cc0 csn cun cn0 ssun1 df-n0 sseqtr4i ) AABCZDEAIFGH $.

  $( Nonnegative integers are a subset of the reals.  (Contributed by Raph
     Levien, 10-Dec-2002.) $)
  nn0ssre $p |- NN0 C_ RR $=
    ( cn0 cn cc0 csn cun cr df-n0 nnssre wcel wss 0re snssi ax-mp unssi eqsstri
    ) ABCDZEFGBPFHCFIPFJKCFLMNO $.

  $( Nonnegative integers are a subset of the complex numbers.)  (Contributed
     by NM, 9-May-2004.) $)
  nn0sscn $p |- NN0 C_ CC $=
    ( cn0 cr cc nn0ssre ax-resscn sstri ) ABCDEF $.

  $( The set of nonnegative integers exists.  (Contributed by NM,
     18-Jul-2004.) $)
  nn0ex $p |- NN0 e. _V $=
    ( cn0 cn cc0 csn cun cvv df-n0 nnex snex unex eqeltri ) ABCDZEFGBLHCIJK $.

  $( A natural number is a nonnegative integer.  (Contributed by NM,
     9-May-2004.) $)
  nnnn0 $p |- ( A e. NN -> A e. NN0 ) $=
    ( cn cn0 nnssnn0 sseli ) BCADE $.

  ${
    nnnn0.1 $e |- N e. NN $.
    $( A natural number is a nonnegative integer.  (Contributed by NM,
       20-Jun-2005.) $)
    nnnn0i $p |- N e. NN0 $=
      ( cn wcel cn0 nnnn0 ax-mp ) ACDAEDBAFG $.
  $}

  $( A nonnegative integer is a real number.  (Contributed by NM,
     9-May-2004.) $)
  nn0re $p |- ( A e. NN0 -> A e. RR ) $=
    ( cn0 cr nn0ssre sseli ) BCADE $.

  $( A nonnegative integer is a complex number.  (Contributed by NM,
     9-May-2004.) $)
  nn0cn $p |- ( A e. NN0 -> A e. CC ) $=
    ( cn0 cc nn0sscn sseli ) BCADE $.

  ${
    nn0re.1 $e |- A e. NN0 $.
    $( A nonnegative integer is a real number.  (Contributed by NM,
       14-May-2003.) $)
    nn0rei $p |- A e. RR $=
      ( cn0 cr nn0ssre sselii ) CDAEBF $.

    $( A nonnegative integer is a complex number.  (Contributed by NM,
       14-May-2003.) $)
    nn0cni $p |- A e. CC $=
      ( nn0rei recni ) AABCD $.
  $}

  $( The set of natural numbers (positive integers) defined in terms of
     nonnegative integers.  (Contributed by NM, 23-Sep-2007.)  (Proof shortened
     by Mario Carneiro, 13-Feb-2013.) $)
  dfn2 $p |- NN = ( NN0 \ { 0 } ) $=
    ( cn0 cc0 csn cdif cn cun df-n0 difeq1i difun2 wcel wceq 0nnn difsn 3eqtrri
    wn ax-mp ) ABCZDEQFZQDEQDZEARQGHEQIBEJOSEKLBEMPN $.

  $( The natural number property expressed in terms of difference from zero.
     (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
  elnnne0 $p |- ( N e. NN <-> ( N e. NN0 /\ N =/= 0 ) ) $=
    ( cn wcel cn0 cc0 csn cdif wne wa dfn2 eleq2i eldifsn bitri ) ABCADEFGZCADC
    AEHIBNAJKADELM $.

  $( 0 is a nonnegative integer.  (Contributed by Raph Levien, 10-Dec-2002.) $)
  0nn0 $p |- 0 e. NN0 $=
    ( cc0 wceq cn0 wcel eqid cn wo elnn0 biimpri olcs ax-mp ) AABZACDZAEAFDZLMM
    NLGAHIJK $.

  $( 1 is a nonnegative integer.  (Contributed by Raph Levien, 10-Dec-2002.) $)
  1nn0 $p |- 1 e. NN0 $=
    ( c1 1nn nnnn0i ) ABC $.

  $( 2 is a nonnegative integer.  (Contributed by Raph Levien, 10-Dec-2002.) $)
  2nn0 $p |- 2 e. NN0 $=
    ( c2 2nn nnnn0i ) ABC $.

  $( 3 is a nonnegative integer.  (Contributed by Mario Carneiro,
     18-Feb-2014.) $)
  3nn0 $p |- 3 e. NN0 $=
    ( c3 3nn nnnn0i ) ABC $.

  $( 4 is a nonnegative integer.  (Contributed by Mario Carneiro,
     18-Feb-2014.) $)
  4nn0 $p |- 4 e. NN0 $=
    ( c4 4nn nnnn0i ) ABC $.

  $( 5 is a nonnegative integer.  (Contributed by Mario Carneiro,
     19-Apr-2015.) $)
  5nn0 $p |- 5 e. NN0 $=
    ( c5 5nn nnnn0i ) ABC $.

  $( 6 is a nonnegative integer.  (Contributed by Mario Carneiro,
     19-Apr-2015.) $)
  6nn0 $p |- 6 e. NN0 $=
    ( c6 6nn nnnn0i ) ABC $.

  $( 7 is a nonnegative integer.  (Contributed by Mario Carneiro,
     19-Apr-2015.) $)
  7nn0 $p |- 7 e. NN0 $=
    ( c7 7nn nnnn0i ) ABC $.

  $( 8 is a nonnegative integer.  (Contributed by Mario Carneiro,
     19-Apr-2015.) $)
  8nn0 $p |- 8 e. NN0 $=
    ( c8 8nn nnnn0i ) ABC $.

  $( 9 is a nonnegative integer.  (Contributed by Mario Carneiro,
     19-Apr-2015.) $)
  9nn0 $p |- 9 e. NN0 $=
    ( c9 9nn nnnn0i ) ABC $.

  $( 10 is a nonnegative integer.  (Contributed by Mario Carneiro,
     19-Apr-2015.) $)
  10nn0 $p |- 10 e. NN0 $=
    ( c10 10nn nnnn0i ) ABC $.

  $( A nonnegative integer is greater than or equal to zero.  (Contributed by
     NM, 9-May-2004.)  (Revised by Mario Carneiro, 16-May-2014.) $)
  nn0ge0 $p |- ( N e. NN0 -> 0 <_ N ) $=
    ( cn0 wcel cc0 cle wbr wceq wo cn elnn0 nngt0 id eqcomd orim12i sylbi cr wb
    clt 0re nn0re leloe sylancr mpbird ) ABCZDAEFZDARFZDAGZHZUDAICZADGZHUHAJUIU
    FUJUGAKUJADUJLMNOUDDPCAPCUEUHQSATDAUAUBUC $.

  $( A nonnegative integer is not less than zero.  (Contributed by NM,
     9-May-2004.)  (Revised by Mario Carneiro, 27-May-2016.) $)
  nn0nlt0 $p |- ( A e. NN0 -> -. A < 0 ) $=
    ( cn0 wcel cc0 cle wbr clt wn nn0ge0 cr wb 0re nn0re lenlt sylancr mpbid )
    ABCZDAEFZADGFHZAIQDJCAJCRSKLAMDANOP $.

  ${
    nn0ge0.1 $e |- N e. NN0 $.
    $( Nonnegative integers are nonnegative.  (Contributed by Raph Levien,
       10-Dec-2002.) $)
    nn0ge0i $p |- 0 <_ N $=
      ( cn0 wcel cc0 cle wbr nn0ge0 ax-mp ) ACDEAFGBAHI $.
  $}

  $( A nonnegative integer is less than or equal to zero iff it is equal to
     zero.  (Contributed by NM, 9-Dec-2005.) $)
  nn0le0eq0 $p |- ( N e. NN0 -> ( N <_ 0 <-> N = 0 ) ) $=
    ( cn0 wcel cc0 cle wbr wa nn0ge0 biantrud cr wb nn0re letri3 sylancl bitr4d
    wceq 0re ) ABCZADEFZSDAEFZGZADPZRTSAHIRAJCDJCUBUAKALQADMNO $.

  $( A natural number plus a nonnegative integer is a natural number.
     (Contributed by NM, 20-Apr-2005.)  (Proof shortened by Mario Carneiro,
     16-May-2014.) $)
  nnnn0addcl $p |- ( ( M e. NN /\ N e. NN0 ) -> ( M + N ) e. NN ) $=
    ( cn0 wcel cn cc0 wceq wo caddc co elnn0 nnaddcl wa oveq2 addid1d sylan9eqr
    nncn simpl eqeltrd jaodan sylan2b ) BCDAEDZBEDZBFGZHABIJZEDZBKUBUCUFUDABLUB
    UDMUEAEUDUBUEAFIJABFAINUBAAQOPUBUDRSTUA $.

  $( A nonnegative integer plus a natural number is a natural number.
     (Contributed by NM, 22-Dec-2005.) $)
  nn0nnaddcl $p |- ( ( M e. NN0 /\ N e. NN ) -> ( M + N ) e. NN ) $=
    ( cn wcel cn0 caddc co wa wceq nncn nn0cn addcom syl2an nnnn0addcl eqeltrrd
    cc ancoms ) BCDZAEDZABFGZCDRSHBAFGZTCRBPDAPDUATISBJAKBALMBANOQ $.

  ${
    un0addcl.1 $e |- ( ph -> S C_ CC ) $.
    un0addcl.2 $e |- T = ( S u. { 0 } ) $.
    ${
      un0addcl.3 $e |- ( ( ph /\ ( M e. S /\ N e. S ) ) -> ( M + N ) e. S ) $.
      $( If ` S ` is closed under addition, then so is ` S u. { 0 } ` .
         (Contributed by Mario Carneiro, 17-Jul-2014.) $)
      un0addcl $p |- ( ( ph /\ ( M e. T /\ N e. T ) ) -> ( M + N ) e. T ) $=
        ( wcel caddc co cc0 wo wa eleq2i elun bitri cc sselda a1i csn cun ssun1
        sseqtr4i sseldi expr addid2d wss eqeltrd elsni oveq1d eleq1d syl5ibrcom
        wi impancom jaodan sylan2b 0cn snssd unssd syl5eqss addid1d oveq2d jaod
        simpr syl5bi impr ) ADCIZECIZDEJKZCIZVIEBIZELUAZIZMZAVHNZVKVIEBVMUBZIVO
        CVQEGOEBVMPQVPVLVKVNVHADBIZDVMIZMZVLVKUNZVHDVQIVTCVQDGODBVMPQAVRWAVSAVR
        VLVKAVRVLNNBCVJBVQCBVMUCGUDZHUEUFAVLVSVKAVLNZVKVSLEJKZCIWCWDECWCEABREFS
        UGABCEBCUHAWBTSUIVSVJWDCVSDLEJDLUJUKULUMUOUPUQVPVKVNDLJKZCIVPWEDCVPDACR
        DACVQRGABVMRFALRLRIAURTUSUTVASVBAVHVEUIVNVJWECVNELDJELUJVCULUMVDVFVG $.
    $}

    un0mulcl.3 $e |- ( ( ph /\ ( M e. S /\ N e. S ) ) -> ( M x. N ) e. S ) $.
    $( If ` S ` is closed under multiplication, then so is ` S u. { 0 } ` .
       (Contributed by Mario Carneiro, 17-Jul-2014.) $)
    un0mulcl $p |- ( ( ph /\ ( M e. T /\ N e. T ) ) -> ( M x. N ) e. T ) $=
      ( wcel cmul co cc0 wo wa eleq2i elun bitri sseqtr4i cc sselda csn wi expr
      cun ssun1 sseldi mul02d wss ssun2 c0ex mpbir syl6eqel elsni oveq1d eleq1d
      snss syl5ibrcom impancom jaodan sylan2b 0cn a1i snssd unssd mul01d oveq2d
      syl5eqss jaod syl5bi impr ) ADCIZECIZDEJKZCIZVLEBIZELUAZIZMZAVKNZVNVLEBVP
      UDZIVRCVTEGOEBVPPQVSVOVNVQVKADBIZDVPIZMZVOVNUBZVKDVTIWCCVTDGODBVPPQAWAWDW
      BAWAVOVNAWAVONNBCVMBVTCBVPUEGRHUFUCAVOWBVNAVONZVNWBLEJKZCIWEWFLCWEEABSEFT
      UGLCIVPCUHVPVTCVPBUIGRLCUJUPUKZULWBVMWFCWBDLEJDLUMUNUOUQURUSUTVSVNVQDLJKZ
      CIVSWHLCVSDACSDACVTSGABVPSFALSLSIAVAVBVCVDVGTVEWGULVQVMWHCVQELDJELUMVFUOU
      QVHVIVJ $.
  $}

  $( Closure of addition of nonnegative integers.  (Contributed by Raph Levien,
     10-Dec-2002.)  (Proof shortened by Mario Carneiro, 17-Jul-2014.) $)
  nn0addcl $p |- ( ( M e. NN0 /\ N e. NN0 ) -> ( M + N ) e. NN0 ) $=
    ( cn cc wss cn0 wcel wa caddc co nnsscn df-n0 nnaddcl adantl un0addcl mpan
    id ) CDEZAFGBFGHABIJZFGKRCFABRQLACGBCGHSCGRABMNOP $.

  $( Closure of multiplication of nonnegative integers.  (Contributed by NM,
     22-Jul-2004.)  (Proof shortened by Mario Carneiro, 17-Jul-2014.) $)
  nn0mulcl $p |- ( ( M e. NN0 /\ N e. NN0 ) -> ( M x. N ) e. NN0 ) $=
    ( cn cc wss cn0 wcel wa cmul co nnsscn df-n0 nnmulcl adantl un0mulcl mpan
    id ) CDEZAFGBFGHABIJZFGKRCFABRQLACGBCGHSCGRABMNOP $.

  ${
    nn0addcl.1 $e |- M e. NN0 $.
    nn0addcl.2 $e |- N e. NN0 $.
    $( Closure of addition of nonnegative integers, inference form.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0addcli $p |- ( M + N ) e. NN0 $=
      ( cn0 wcel caddc co nn0addcl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( Closure of multiplication of nonnegative integers, inference form.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0mulcli $p |- ( M x. N ) e. NN0 $=
      ( cn0 wcel cmul co nn0mulcl mp2an ) AEFBEFABGHEFCDABIJ $.
  $}

  $( A nonnegative integer plus 1 is a natural number.  (Contributed by Raph
     Levien, 30-Jun-2006.)  (Revised by Mario Carneiro, 16-May-2014.) $)
  nn0p1nn $p |- ( N e. NN0 -> ( N + 1 ) e. NN ) $=
    ( cn0 wcel c1 cn caddc co 1nn nn0nnaddcl mpan2 ) ABCDECADFGECHADIJ $.

  $( Second Peano postulate for nonnegative integers.  (Contributed by NM,
     9-May-2004.) $)
  peano2nn0 $p |- ( N e. NN0 -> ( N + 1 ) e. NN0 ) $=
    ( cn0 wcel c1 caddc co 1nn0 nn0addcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( A natural number minus 1 is a nonnegative integer.  (Contributed by Jason
     Orendorff, 24-Jan-2007.)  (Revised by Mario Carneiro, 16-May-2014.) $)
  nnm1nn0 $p |- ( N e. NN -> ( N - 1 ) e. NN0 ) $=
    ( cn wcel c1 cmin co cc0 wceq wo cn0 nn1m1nn oveq1 syl6eq orim1i syl orcomd
    1m1e0 elnn0 sylibr ) ABCZADEFZBCZUAGHZIUAJCTUCUBTADHZUBIUCUBIAKUDUCUBUDUADD
    EFGADDELQMNOPUARS $.

  $( The nonnegative integer property expressed in terms of natural numbers.
     (Contributed by NM, 10-May-2004.)  (Proof shortened by Mario Carneiro,
     16-May-2014.) $)
  elnn0nn $p |- ( N e. NN0 <-> ( N e. CC /\ ( N + 1 ) e. NN ) ) $=
    ( cn0 wcel cc c1 caddc co cn nn0cn nn0p1nn jca cmin wceq simpl ax-1cn pncan
    wa sylancl nnm1nn0 adantl eqeltrrd impbii ) ABCZADCZAEFGZHCZQZUCUDUFAIAJKUG
    UEELGZABUGUDEDCUHAMUDUFNOAEPRUFUHBCUDUESTUAUB $.

  $( The natural number property expressed in terms of nonnegative integers.
     (Contributed by NM, 10-May-2004.) $)
  elnnnn0 $p |- ( N e. NN <-> ( N e. CC /\ ( N - 1 ) e. NN0 ) ) $=
    ( cn wcel cc c1 cmin co cn0 nncn caddc wceq ax-1cn npcan mpan2 eleq1d subcl
    wa biantrurd bitr3d elnn0nn syl6bbr biadan2 ) ABCZADCZAEFGZHCZAIUDUCUEDCZUE
    EJGZBCZQZUFUDUIUCUJUDUHABUDEDCZUHAKLAEMNOUDUGUIUDUKUGLAEPNRSUETUAUB $.

  $( The natural number property expressed in terms of nonnegative integers.
     (Contributed by NM, 1-Sep-2005.) $)
  elnnnn0b $p |- ( N e. NN <-> ( N e. NN0 /\ 0 < N ) ) $=
    ( cn wcel cn0 cc0 clt wbr wa nnnn0 nngt0 jca wceq wo elnn0 ax-1 breq2 ltnri
    wi 0re pm2.21i syl6bi jaoi sylbi imp impbii ) ABCZADCZEAFGZHUFUGUHAIAJKUGUH
    UFUGUFAELZMUHUFRZANUFUJUIUFUHOUIUHEEFGZUFAEEFPUKUFESQTUAUBUCUDUE $.

  $( The natural number property expressed in terms of nonnegative integers.
     (Contributed by NM, 10-Jan-2006.) $)
  elnnnn0c $p |- ( N e. NN <-> ( N e. NN0 /\ 1 <_ N ) ) $=
    ( cn wcel cn0 c1 cle wbr wa nnnn0 nnge1 jca cc0 clt 0lt1 cr wi nn0re ltletr
    0re 1re mp3an12 syl mpani imdistani elnnnn0b sylibr impbii ) ABCZADCZEAFGZH
    ZUHUIUJAIAJKUKUILAMGZHUHUIUJULUILEMGZUJULNUIAOCZUMUJHULPZAQLOCEOCUNUOSTLEAR
    UAUBUCUDAUEUFUG $.

  $( A number is less than or equal to itself plus a nonnegative integer.
     (Contributed by NM, 10-Mar-2005.) $)
  nn0addge1 $p |- ( ( A e. RR /\ N e. NN0 ) -> A <_ ( A + N ) ) $=
    ( cn0 wcel cr cc0 cle wbr wa caddc co nn0re nn0ge0 jca addge01 3expb sylan2
    biimp3a ) BCDZAEDZBEDZFBGHZIAABJKGHZSUAUBBLBMNTUAUBUCTUAUBUCABORPQ $.

  $( A number is less than or equal to itself plus a nonnegative integer.
     (Contributed by NM, 10-Mar-2005.) $)
  nn0addge2 $p |- ( ( A e. RR /\ N e. NN0 ) -> A <_ ( N + A ) ) $=
    ( cn0 wcel cr cc0 cle wbr wa caddc co nn0re nn0ge0 jca addge02 3expb sylan2
    biimp3a ) BCDZAEDZBEDZFBGHZIABAJKGHZSUAUBBLBMNTUAUBUCTUAUBUCABORPQ $.

  ${
    nn0addge1.1 $e |- A e. RR $.
    nn0addge1.2 $e |- N e. NN0 $.
    $( A number is less than or equal to itself plus a nonnegative integer.
       (Contributed by NM, 10-Mar-2005.) $)
    nn0addge1i $p |- A <_ ( A + N ) $=
      ( cr wcel cn0 caddc co cle wbr nn0addge1 mp2an ) AEFBGFAABHIJKCDABLM $.

    $( A number is less than or equal to itself plus a nonnegative integer.
       (Contributed by NM, 10-Mar-2005.) $)
    nn0addge2i $p |- A <_ ( N + A ) $=
      ( cr wcel cn0 caddc co cle wbr nn0addge2 mp2an ) AEFBGFABAHIJKCDABLM $.
  $}

  $( Subtraction of nonnegative integers.  (Contributed by NM, 9-May-2004.)
     (Proof shortened by Mario Carneiro, 16-May-2014.) $)
  nn0sub $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M <_ N <-> ( N - M ) e. NN0 ) ) $=
    ( cn0 wcel wbr cmin co cn cc0 wo clt cr wb nn0re elnn0 nngt0 eleq1d bibi12d
    wceq syl5ibr wa leloe syl2an wi nnsub ex nncn subid1d id eqeltrd 2thd breq1
    cle oveq2 jaoi sylbi nn0nlt0 pm2.21d posdif sylancl impbid breq2 syl5ibrcom
    0re oveq1 jaod syl5bi cc nn0cn subeq0 syl2anr eqcom syl6rbb orbi12d syl6bbr
    imp bitrd ) ACDZBCDZUAZABUMEZBAFGZHDZWBISZJZWBCDVTWAABKEZABSZJZWEVRALDZBLDW
    AWHMVSANZBNABUBUCVTWFWCWGWDVRVSWFWCMZVSBHDZBISZJVRWKBOVRWLWKWMVRAHDZAISZJWL
    WKUDZAOWNWPWOWNWLWKABUEUFWLWKWOIBKEZBIFGZHDZMWLWQWSBPWLWRBHWLBBUGUHWLUIUJUK
    WOWFWQWCWSAIBKULWOWBWRHAIBFUNQRTUOUPVRWKWMAIKEZIAFGZHDZMVRWTXBVRWTXBAUQURXB
    WTVRIXAKEZXAPVRWIILDWTXCMWJVDAIUSUTTVAWMWFWTWCXBBIAKVBWMWBXAHBIAFVEQRVCVFVG
    VPVTWDBASZWGVSBVHDAVHDWDXDMVRBVIAVIBAVJVKBAVLVMVNVQWBOVO $.

  ${
    nn0le2x.1 $e |- N e. NN0 $.
    $( A nonnegative integer is less than or equal to twice itself.
       (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0le2xi $p |- N <_ ( 2 x. N ) $=
      ( caddc co c2 cmul cle nn0rei nn0addge1i nn0cni 2timesi breqtrri ) AAACDE
      AFDGAAABHBIAABJKL $.
  $}

  ${
    nn0lele2x.1 $e |- M e. NN0 $.
    nn0lele2x.2 $e |- N e. NN0 $.
    $( 'Less than or equal to' implies 'less than or equal to twice' for
       nonnegative integers.  (Contributed by Raph Levien, 10-Dec-2002.) $)
    nn0lele2xi $p |- ( N <_ M -> N <_ ( 2 x. M ) ) $=
      ( cle wbr c2 cmul co nn0le2xi nn0rei 2re remulcli letri mpan2 ) BAEFAGAHI
      ZEFBPEFACJBAPBDKACKZGALQMNO $.
  $}

  $( Two ways to write the support of a function on ` NN0 ` .  (Contributed by
     Mario Carneiro, 29-Dec-2014.) $)
  nn0supp $p |- ( F : I --> NN0 ->
    ( `' F " ( _V \ { 0 } ) ) = ( `' F " NN ) ) $=
    ( cn0 wf ccnv cn cima cvv cc0 csn cdif dfn2 invdif eqtr4i imaeq2i wfun wceq
    cin ffun inpreima syl wss cdm cnvimass fimacnv syl5sseq sseqin2 sylib eqtrd
    fdm eqtr4d syl5req ) BCADZAEZFGUNCHIJZKZRZGZUNUPGZFUQUNFCUOKUQLCUOMNOUMURUN
    CGZUSRZUSUMAPURVAQBCASCUPATUAUMUSUTUBVAUSQUMAUCZUSUTAUPUDUMVBBUTBCAUJBCAUEU
    KUFUSUTUGUHUIUL $.

  ${
    nnnn0d.1 $e |- ( ph -> A e. NN ) $.
    $( A natural number is a nonnegative integer.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    nnnn0d $p |- ( ph -> A e. NN0 ) $=
      ( cn cn0 nnssnn0 sseldi ) ADEBFCG $.
  $}

  ${
    nn0red.1 $e |- ( ph -> A e. NN0 ) $.
    $( A nonnegative integer is a real number.  (Contributed by Mario Carneiro,
       27-May-2016.) $)
    nn0red $p |- ( ph -> A e. RR ) $=
      ( cn0 cr nn0ssre sseldi ) ADEBFCG $.

    $( A nonnegative integer is a complex number.  (Contributed by Mario
       Carneiro, 27-May-2016.) $)
    nn0cnd $p |- ( ph -> A e. CC ) $=
      ( nn0red recnd ) ABABCDE $.

    $( A nonnegative integer is greater than or equal to zero.  (Contributed by
       Mario Carneiro, 27-May-2016.) $)
    nn0ge0d $p |- ( ph -> 0 <_ A ) $=
      ( cn0 wcel cc0 cle wbr nn0ge0 syl ) ABDEFBGHCBIJ $.

    nn0addcld.2 $e |- ( ph -> B e. NN0 ) $.
    $( Closure of addition of nonnegative integers, inference form.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    nn0addcld $p |- ( ph -> ( A + B ) e. NN0 ) $=
      ( cn0 wcel caddc co nn0addcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure of multiplication of nonnegative integers, inference form.
       (Contributed by Mario Carneiro, 27-May-2016.) $)
    nn0mulcld $p |- ( ph -> ( A x. B ) e. NN0 ) $=
      ( cn0 wcel cmul co nn0mulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

  $( A nonnegative integer which is neither 0 nor 1 is greater than or equal to
     2.  (Contributed by Alexander van der Vekens, 6-Dec-2017.) $)
  nn0n0n1ge2 $p |- ( ( N e. NN0 /\ N =/= 0 /\ N =/= 1 ) -> 2 <_ N ) $=
    ( cn0 wcel cc0 wne c1 w3a c2 cle wbr cmin co wceq caddc 3ad2ant1 cn elnnne0
    wa nnm1nn0 syl nn0cn ax-1cn a1i subsub4d 1p1e2 oveq2i syl6req 3simpa sylibr
    cc subeq0ad biimpd necon3d imp 3adant2 sylanbrc eqeltrd wb 2nn0 jctl nn0sub
    mpbird ) ABCZADEZAFEZGZHAIJZAHKLZBCZVFVHAFKLZFKLZBVCVDVHVKMVEVCVKAFFNLZKLVH
    VCAFFAUAZFUJCVCUBUCZVNUDVLHAKUEUFUGOVFVJPCZVKBCVFVJBCZVJDEZVOVFAPCZVPVFVCVD
    RVRVCVDVEUHAQUIASTVCVEVQVDVCVEVQVCVJDAFVCVJDMAFMVCAFVMVNUKULUMUNUOVJQUPVJST
    UQVFHBCZVCRZVGVIURVCVDVTVEVCVSUSUTOHAVATVB $.

  $( A nonnegative integer is neither 0 nor 1 if and only if it is is greater
     than or equal to 2.  (Contributed by Alexander van der Vekens,
     17-Jan-2018.) $)
  nn0n0n1ge2b $p |- ( N e. NN0 -> ( ( N =/= 0 /\ N =/= 1 ) <-> 2 <_ N ) ) $=
    ( cn0 wcel cc0 wne c1 wa c2 cle wbr nn0n0n1ge2 wn wceq nne clt breq1 mpbiri
    wo a1d cr 3expib ianor orbi12i bitri wi 2pos 1lt2 impcom wb nn0re 2re jctir
    jaoi adantr ltnle syl mpbid ex syl5bi impcon4bid ) ABCZADEZAFEZGZHAIJZVAVBV
    CVEAKUAVDLZADMZAFMZRZVAVELZVFVBLZVCLZRVIVBVCUBVKVGVLVHADNAFNUCUDVAVIVJVAVIG
    ZAHOJZVJVIVAVNVGVAVNUEVHVGVNVAVGVNDHOJUFADHOPQSVHVNVAVHVNFHOJUGAFHOPQSUMUHV
    MATCZHTCZGZVNVJUIVAVQVIVAVOVPAUJUKULUNAHUOUPUQURUSUT $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Integers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ZZ $. $( The set of integers (blackboard bold Z). $)

  $( Extend class notation to include the class of integers. $)
  cz $a class ZZ $.

  $( Define the set of integers, which are the positive and negative natural
     numbers together with zero.  Definition of integers in [Apostol] p. 22.
     The letter Z abbreviates the German word Zahlen meaning "numbers."
     (Contributed by NM, 8-Jan-2002.) $)
  df-z $a |- ZZ = { n e. RR | ( n = 0 \/ n e. NN \/ -u n e. NN ) } $.

  ${
    $d x N $.
    $( Membership in the set of integers.  (Contributed by NM, 8-Jan-2002.) $)
    elz $p |- ( N e. ZZ <->
              ( N e. RR /\ ( N = 0 \/ N e. NN \/ -u N e. NN ) ) ) $=
      ( vx cv cc0 wceq cn wcel cneg w3o cr cz eqeq1 eleq1 eleq1d 3orbi123d df-z
      negeq elrab2 ) BCZDEZSFGZSHZFGZIADEZAFGZAHZFGZIBAJKSAEZTUDUAUEUCUGSADLSAF
      MUHUBUFFSAQNOBPR $.
  $}

  $( The negative of a natural number is an integer.  (Contributed by NM,
     12-Jan-2002.) $)
  nnnegz $p |- ( N e. NN -> -u N e. ZZ ) $=
    ( cn wcel cneg cr cc0 wceq w3o cz nnre renegcld wo cc negneg eleq1d biimprd
    nncn mpcom olcd df-3or sylibr elz sylanbrc ) ABCZADZECUEFGZUEBCZUEDZBCZHZUE
    ICUDAAJKUDUFUGLZUILUJUDUIUKAMCZUDUIAQULUIUDULUHABANOPRSUFUGUITUAUEUBUC $.

  $( An integer is a real.  (Contributed by NM, 8-Jan-2002.) $)
  zre $p |- ( N e. ZZ -> N e. RR ) $=
    ( cz wcel cr cc0 wceq cn cneg w3o elz simplbi ) ABCADCAEFAGCAHGCIAJK $.

  $( An integer is a complex number.  (Contributed by NM, 9-May-2004.) $)
  zcn $p |- ( N e. ZZ -> N e. CC ) $=
    ( cz wcel zre recnd ) ABCAADE $.

  ${
    zre.1 $e |- A e. ZZ $.
    $( An integer is a real number.  (Contributed by NM, 14-Jul-2005.) $)
    zrei $p |- A e. RR $=
      ( cz wcel cr zre ax-mp ) ACDAEDBAFG $.
  $}

  $( The integers are a subset of the reals.  (Contributed by NM,
     2-Aug-2004.) $)
  zssre $p |- ZZ C_ RR $=
    ( vx cz cr cv zre ssriv ) ABCADEF $.

  $( The integers are a subset of the complex numbers.  (Contributed by NM,
     2-Aug-2004.) $)
  zsscn $p |- ZZ C_ CC $=
    ( vx cz cc cv zcn ssriv ) ABCADEF $.

  $( The set of integers exists.  See also ~ zexALT .  (Contributed by NM,
     30-Jul-2004.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  zex $p |- ZZ e. _V $=
    ( cz cc cnex zsscn ssexi ) ABCDE $.

  $( Natural number property expressed in terms of integers.  (Contributed by
     NM, 8-Jan-2002.) $)
  elnnz $p |- ( N e. NN <-> ( N e. ZZ /\ 0 < N ) ) $=
    ( cn wcel cr cneg cc0 wceq wo wa clt wbr cz orc nngt0 jca31 wi wn w3o bitri
    nnre idd lt0neg2 renegcl 0re ltnsym sylancl sylbid nsyl gt0ne0 neneqd ioran
    imp sylanbrc pm2.21d jaod ex com23 imp31 impbii 3orrot 3orass anbi2i anbi1i
    elz bitr4i ) ABCZADCZVFAEZBCZAFGZHZHZIZFAJKZIZALCZVNIVFVOVFVGVLVNATVFVKMANO
    VGVLVNVFVGVNVLVFVGVNVLVFPVGVNIZVFVFVKVQVFUAVQVKVFVQVIQVJQVKQVQFVHJKZVIVGVNV
    RQZVGVNVHFJKZVSAUBVGVHDCFDCVTVSPAUCUDVHFUEUFUGULVHNUHVQAFAUIUJVIVJUKUMUNUOU
    PUQURUSVPVMVNVPVGVJVFVIRZIVMAVDWAVLVGWAVFVIVJRVLVJVFVIUTVFVIVJVASVBSVCVE $.

  $( Zero is an integer.  (Contributed by NM, 12-Jan-2002.) $)
  0z $p |- 0 e. ZZ $=
    ( cc0 cz wcel cr wceq cn cneg w3o 0re eqid 3mix1i elz mpbir2an ) ABCADCAAEZ
    AFCZAGFCZHINOPAJKALM $.

  $( Nonnegative integer property expressed in terms of integers.  (Contributed
     by NM, 9-May-2004.) $)
  elnn0z $p |- ( N e. NN0 <-> ( N e. ZZ /\ 0 <_ N ) ) $=
    ( cn0 wcel cn cc0 wceq wo cz clt wbr wa cle elnn0 elnnz eqcom orbi12i id 0z
    eleq1 cr mpbii jaoi orc impbii anbi1i ordir 0re zre sylancr pm5.32i 3bitr4i
    wb leloe 3bitri ) ABCADCZAEFZGAHCZEAIJZKZEAFZGZUQEALJZKZAMUOUSUPUTANAEOPUQU
    TGZURUTGZKUQVEKVAVCVDUQVEVDUQUQUQUTUQQUTEHCUQREAHSUAUBUQUTUCUDUEUQURUTUFUQV
    BVEUQETCATCVBVEULUGAUHEAUMUIUJUKUN $.

  $( Integer property expressed in terms nonnegative integers and natural
     numbers.  (Contributed by NM, 10-May-2004.) $)
  elznn0nn $p |- ( N e. ZZ <-> ( N e. NN0 \/ ( N e. RR /\ -u N e. NN ) ) ) $=
    ( cz wcel cr cc0 wceq cn cneg w3o wa cn0 wo elz andi df-3or anbi2i pm4.71ri
    nn0re elnn0 bitri orcom orbi1i 3bitr4i ) ABCADCZAEFZAGCZAHGCZIZJZAKCZUDUGJZ
    LZAMUDUEUFLZUGLZJUDUMJZUKLUIULUDUMUGNUHUNUDUEUFUGOPUJUOUKUJUDUJJUOUJUDARQUJ
    UMUDUJUFUELUMASUFUEUATPTUBUCT $.

  $( Integer property expressed in terms of nonnegative integers.  (Contributed
     by NM, 9-May-2004.) $)
  elznn0 $p |- ( N e. ZZ <-> ( N e. RR /\ ( N e. NN0 \/ -u N e. NN0 ) ) ) $=
    ( cz wcel cr cc0 wceq cn cneg w3o wa cn0 wo elz wb elnn0 a1i recn 0cn bitri
    cc negcon1 sylancl eqeq1i eqcom syl6bb orbi2d syl5bb orbi12d 3orass orordir
    neg0 orcom 3bitrri syl6rbb pm5.32i ) ABCADCZAEFZAGCZAHZGCZIZJUPAKCZUSKCZLZJ
    AMUPVAVDUPVDURUQLZUTUQLZLZVAUPVBVEVCVFVBVENUPAOPVCUTUSEFZLUPVFUSOUPVHUQUTUP
    VHEHZAFZUQUPATCETCVHVJNAQRAEUAUBVJEAFUQVIEAUKUCEAUDSUEUFUGUHVAUQURUTLZLVKUQ
    LVGUQURUTUIUQVKULURUTUQUJUMUNUOS $.

  $( Integer property expressed in terms natural numbers and nonnegative
     integers.  (Contributed by NM, 12-Jul-2005.) $)
  elznn $p |- ( N e. ZZ <-> ( N e. RR /\ ( N e. NN \/ -u N e. NN0 ) ) ) $=
    ( cz wcel cr cc0 wceq cn cneg w3o wa cn0 wo elz recn negeq0d elnn0 syl6rbbr
    orbi2d 3orrot bitri 3orass pm5.32i ) ABCADCZAEFZAGCZAHZGCZIZJUCUEUFKCZLZJAM
    UCUHUJUCUJUEUGUDLZLZUHUCUIUKUEUCUKUGUFEFZLUIUCUDUMUGUCAANORUFPQRUHUEUGUDIUL
    UDUEUGSUEUGUDUATQUBT $.

  ${
    $d x y z N $.
    $( Membership in the set of integers.  Commonly used in constructions of
       the integers as equivalence classes under subtraction of the natural
       numbers.  (Contributed by Mario Carneiro, 16-May-2014.) $)
    elz2 $p |- ( N e. ZZ <-> E. x e. NN E. y e. NN N = ( x - y ) ) $=
      ( wcel cr cn0 cneg wo wa cv cmin co wceq cn c1 1nn ax-1cn sylancr syl2an
      cc wrex elznn0 caddc nn0p1nn adantl a1i recn adantr pncan sylancl rspceov
      eqcomd syl3anc negsub simpr nnnn0addcl eqeltrrd nncan jaodan nnre resubcl
      cz cle wbr letric syl2anr wb nnnn0 nn0sub negsubdi2 eleq1d bitr4d orbi12d
      nncn mpbid jca eleq1 negeq anbi12d syl5ibrcom rexlimivv impbii bitri ) CV
      BDCEDZCFDZCGZFDZHZIZCAJZBJZKLZMZBNUAANUAZCUBWIWNWDWEWNWGWDWEIZCOUCLZNDZON
      DZCWPOKLZMWNWEWQWDCUDUEWRWOPUFWOWSCWOCTDZOTDZWSCMWDWTWECUGZUHQCOUIUJULABN
      NWPOCKUKUMWDWGIZWROCKLZNDCOXDKLZMWNWRXCPUFXCOWFUCLZXDNXCXAWTXFXDMQWDWTWGX
      BUHZOCUNRXCWRWGXFNDPWDWGUOOWFUPRUQXCXECXCXAWTXECMQXGOCURRULABNNOXDCKUKUMU
      SWMWIABNNWJNDZWKNDZIZWIWMWLEDZWLFDZWLGZFDZHZIXJXKXOXHWJEDZWKEDZXKXIWJUTZW
      KUTZWJWKVASXJWKWJVCVDZWJWKVCVDZHZXOXIXQXPYBXHXSXRWKWJVEVFXJXTXLYAXNXIWKFD
      ZWJFDZXTXLVGXHWKVHZWJVHZWKWJVIVFXJYAWKWJKLZFDZXNXHYDYCYAYHVGXIYFYEWJWKVIS
      XJXMYGFXHWJTDWKTDXMYGMXIWJVNWKVNWJWKVJSVKVLVMVOVPWMWDXKWHXOCWLEVQWMWEXLWG
      XNCWLFVQWMWFXMFCWLVRVKVMVSVTWAWBWC $.

    $( Alternative definition of the integers, based on ~ elz2 .  (Contributed
       by Mario Carneiro, 16-May-2014.) $)
    dfz2 $p |- ZZ = ( - " ( NN X. NN ) ) $=
      ( vx vy vz cz cmin cn cxp cima cv wcel co wceq wrex elz2 cc wfn wb nnsscn
      wss mp2an wf subf ffn ax-mp xpss12 ovelimab bitr4i eqriv ) ADEFFGZHZAIZDJ
      UKBICIEKLCFMBFMZUKUJJZBCUKNEOOGZPZUIUNSZUMULQUNOEUAUOUBUNOEUCUDFOSZUQUPRR
      FOFOUETBCUNFFUKEUFTUGUH $.
  $}

  $( The set of integers exists.  (Contributed by NM, 30-Jul-2004.)  (Revised
     by Mario Carneiro, 16-May-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  zexALT $p |- ZZ e. _V $=
    ( cz cmin cn cxp cima cvv dfz2 cc wfun wcel subf ffun nnexALT xpex funimaex
    wf mp2b eqeltri ) ABCCDZEZFGHHDZHBPBITFJKUAHBLBSCCMMNOQR $.

  $( Natural numbers are a subset of integers.  (Contributed by NM,
     9-Jan-2002.) $)
  nnssz $p |- NN C_ ZZ $=
    ( vx cn cz cv wcel cc0 clt wbr elnnz simplbi ssriv ) ABCADZBELCEFLGHLIJK $.

  $( Nonnegative integers are a subset of the integers.  (Contributed by NM,
     9-May-2004.) $)
  nn0ssz $p |- NN0 C_ ZZ $=
    ( cn0 cn cc0 csn cun cz df-n0 nnssz wcel wss c0ex snss mpbi unssi eqsstri
    0z ) ABCDZEFGBQFHCFIQFJPCFKLMNO $.

  $( A natural number is an integer.  (Contributed by NM, 9-May-2004.) $)
  nnz $p |- ( N e. NN -> N e. ZZ ) $=
    ( cn cz nnssz sseli ) BCADE $.

  $( A nonnegative integer is an integer.  (Contributed by NM, 9-May-2004.) $)
  nn0z $p |- ( N e. NN0 -> N e. ZZ ) $=
    ( cn0 cz nn0ssz sseli ) BCADE $.

  ${
    nnzi.1 $e |- N e. NN $.
    $( A natural number is an integer.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    nnzi $p |- N e. ZZ $=
      ( cn cz nnssz sselii ) CDAEBF $.
  $}

  ${
    nn0zi.1 $e |- N e. NN0 $.
    $( A nonnegative integer is an integer.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    nn0zi $p |- N e. ZZ $=
      ( cn0 cz nn0ssz sselii ) CDAEBF $.
  $}

  $( Natural number property expressed in terms of integers.  (Contributed by
     NM, 10-May-2004.)  (Proof shortened by Mario Carneiro, 16-May-2014.) $)
  elnnz1 $p |- ( N e. NN <-> ( N e. ZZ /\ 1 <_ N ) ) $=
    ( cn wcel cz c1 cle wbr wa nnz nnge1 jca cc0 clt 0lt1 cr zre 0re 1re ltletr
    wi mp3an12 syl mpani imdistani elnnz sylibr impbii ) ABCZADCZEAFGZHZUHUIUJA
    IAJKUKUILAMGZHUHUIUJULUILEMGZUJULNUIAOCZUMUJHULTZAPLOCEOCUNUOQRLEASUAUBUCUD
    AUEUFUG $.

  $( An integer is not a natural number iff it is less than one.  (Contributed
     by NM, 13-Jul-2005.) $)
  znnnlt1 $p |- ( N e. ZZ -> ( -. N e. NN <-> N < 1 ) ) $=
    ( cz wcel cn wn c1 cle wbr clt elnnz1 baib notbid cr zre 1re sylancl bitr4d
    wb ltnle ) ABCZADCZEFAGHZEZAFIHZTUAUBUATUBAJKLTAMCFMCUDUCRANOAFSPQ $.

  $( Natural numbers expressed as a subset of integers.  (Contributed by NM,
     3-Oct-2004.) $)
  nnzrab $p |- NN = { x e. ZZ | 1 <_ x } $=
    ( cn cv cz wcel c1 cle wbr wa cab crab elnnz1 abbi2i df-rab eqtr4i ) BACZDE
    FPGHZIZAJQADKRABPLMQADNO $.

  $( Nonnegative integers expressed as a subset of integers.  (Contributed by
     NM, 3-Oct-2004.) $)
  nn0zrab $p |- NN0 = { x e. ZZ | 0 <_ x } $=
    ( cn0 cv cz wcel cc0 cle wbr wa cab crab elnn0z abbi2i df-rab eqtr4i ) BACZ
    DEFPGHZIZAJQADKRABPLMQADNO $.

  $( One is an integer.  (Contributed by NM, 10-May-2004.) $)
  1z $p |- 1 e. ZZ $=
    ( c1 1nn nnzi ) ABC $.

  $( Two is an integer.  (Contributed by NM, 10-May-2004.) $)
  2z $p |- 2 e. ZZ $=
    ( c2 2nn nnzi ) ABC $.

  $( Closure law for negative integers.  (Contributed by NM, 9-May-2004.) $)
  znegcl $p |- ( N e. ZZ -> -u N e. ZZ ) $=
    ( cz wcel cr cc0 wceq cn cneg w3o elz negeq neg0 syl6eq syl6eqel nnnegz nnz
    wa 0z 3jaoi adantl sylbi ) ABCADCZAEFZAGCZAHZGCZIZQUEBCZAJUGUHUBUCUHUDUFUCU
    EEBUCUEEHEAEKLMRNAOUEPSTUA $.

  $( A number is an integer iff its negative is.  (Contributed by Stefan
     O'Rear, 13-Sep-2014.) $)
  znegclb $p |- ( A e. CC -> ( A e. ZZ <-> -u A e. ZZ ) ) $=
    ( cc wcel cz cneg znegcl negneg eleq1d syl5ib impbid2 ) ABCZADCZAEZDCZAFNME
    ZDCKLMFKOADAGHIJ $.

  $( The negative of a nonnegative integer is an integer.  (Contributed by NM,
     9-May-2004.) $)
  nn0negz $p |- ( N e. NN0 -> -u N e. ZZ ) $=
    ( cn0 wcel cz cneg nn0z znegcl syl ) ABCADCAEDCAFAGH $.

  ${
    nn0negzi.1 $e |- N e. NN0 $.
    $( The negative of a nonnegative integer is an integer.  (Contributed by
       Mario Carneiro, 18-Feb-2014.) $)
    nn0negzi $p |- -u N e. ZZ $=
      ( cn0 wcel cneg cz nn0negz ax-mp ) ACDAEFDBAGH $.
  $}

  ${
    $d u v w x y z M $.  $d w x y z N $.
    $( Closure of addition of integers.  (Contributed by NM, 9-May-2004.)
       (Proof shortened by Mario Carneiro, 16-May-2014.) $)
    zaddcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M + N ) e. ZZ ) $=
      ( vx vy vz vw vu vv cz wcel cv cmin co wceq cn wrex caddc wa cc nncn elz2
      reeanv nnaddcl adantr adantl anim12i addsub4 syl2an eqcomd rspceov sylibr
      syl3anc oveq12 eleq1d syl5ibrcom rexlimdvva syl5bir rexlimivv syl2anb
      sylbir ) AIJACKZDKZLMZNZDOPZCOPZBEKZFKZLMZNZFOPZEOPZABQMZIJZBIJCDAUAEFBUA
      VFVLRVEVKRZEOPCOPVNVEVKCEOOUBVOVNCEOOVOVDVJRZFOPDOPVAOJZVGOJZRZVNVDVJDFOO
      UBVSVPVNDFOOVSVBOJZVHOJZRZRZVNVPVCVIQMZIJZWCWDGKHKLMNHOPGOPZWEWCVAVGQMZOJ
      ZVBVHQMZOJZWDWGWILMZNWFVSWHWBVAVGUCUDWBWJVSVBVHUCUEWCWKWDVSVASJZVGSJZRVBS
      JZVHSJZRWKWDNWBVQWLVRWMVATVGTUFVTWNWAWOVBTVHTUFVAVGVBVHUGUHUIGHOOWGWIWDLU
      JULGHWDUAUKVPVMWDIAVCBVIQUMUNUOUPUQURUTUS $.
  $}

  $( Second Peano postulate generalized to integers.  (Contributed by NM,
     13-Feb-2005.) $)
  peano2z $p |- ( N e. ZZ -> ( N + 1 ) e. ZZ ) $=
    ( cz wcel c1 caddc co 1z zaddcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( Closure of subtraction of integers.  (Contributed by NM, 11-May-2004.) $)
  zsubcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M - N ) e. ZZ ) $=
    ( cz wcel wa cneg caddc co cmin wceq zcn negsub syl2an znegcl zaddcl sylan2
    cc eqeltrrd ) ACDZBCDZEABFZGHZABIHZCSAQDBQDUBUCJTAKBKABLMTSUACDUBCDBNAUAOPR
    $.

  $( "Reverse" second Peano postulate for integers.  (Contributed by NM,
     12-Sep-2005.) $)
  peano2zm $p |- ( N e. ZZ -> ( N - 1 ) e. ZZ ) $=
    ( cz wcel c1 cmin co 1z zsubcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( Reverse closure law for addition of integers.  (Contributed by NM,
     11-May-2004.) $)
  zrevaddcl $p |- ( N e. ZZ ->
                   ( ( M e. CC /\ ( M + N ) e. ZZ ) <-> M e. ZZ ) ) $=
    ( cz wcel cc caddc co wa cmin zcn pncan sylan2 ancoms adantr zsubcl adantlr
    wceq eqeltrrd ex wi zaddcl expcom impbid pm5.32da pm4.71ri syl6bbr ) BCDZAE
    DZABFGZCDZHUHACDZHUKUGUHUJUKUGUHHZUJUKULUJUKULUJHUIBIGZACULUMAQZUJUHUGUNUGU
    HBEDUNBJABKLMNUGUJUMCDZUHUJUGUOUIBOMPRSUGUKUJTUHUKUGUJABUAUBNUCUDUKUHAJUEUF
    $.

  $( The positive difference of unequal integers is a natural number.
     (Generalization of ~ nnsub .)  (Contributed by NM, 11-May-2004.) $)
  znnsub $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M < N <-> ( N - M ) e. NN ) ) $=
    ( cz wcel wa clt wbr cmin co cn cr wb posdif syl2an zsubcl ancoms biantrurd
    cc0 zre bitrd elnnz syl6bbr ) ACDZBCDZEZABFGZBAHIZCDZRUGFGZEZUGJDUEUFUIUJUC
    AKDBKDUFUILUDASBSABMNUEUHUIUDUCUHBAOPQTUGUAUB $.

  $( The nonnegative difference of integers is a nonnegative integer.
     (Generalization of ~ nn0sub .)  (Contributed by NM, 14-Jul-2005.) $)
  znn0sub $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                ( M <_ N <-> ( N - M ) e. NN0 ) ) $=
    ( cz wcel wa cle wbr co cc0 cn0 wb cr subge0 syl2an zsubcl biantrurd bitr3d
    cmin zre ancoms elnn0z syl6bbr ) ACDZBCDZEABFGZBARHZCDZIUFFGZEZUFJDUDUCUEUI
    KUDUCEZUHUEUIUDBLDALDUHUEKUCBSASBAMNUJUGUHBAOPQTUFUAUB $.

  $( Closure of multiplication of integers.  (Contributed by NM,
     30-Jul-2004.) $)
  zmulcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M x. N ) e. ZZ ) $=
    ( cz wcel cr cn0 cneg wo wa cmul co elznn0 nn0mulcl jctild cc syl2an eleq1d
    wceq syl5ib syl6 wi orcd a1i remulcl mulneg1 olc mulneg2 mul2neg orc ccased
    recn syl6ibr imp an4s syl2anb ) ACDAEDZAFDZAGZFDZHZIBEDZBFDZBGZFDZHZIABJKZC
    DZBCDALBLUPVAUTVEVGUPVAIZUTVEIZVGVHVIVFEDZVFFDZVFGZFDZHZIZVGVHUQVBUSVDVOVHU
    QVBIZVNVJVPVNUAVHVPVKVMABMUBUCABUDZNVHUSVBIZVNVJVHVRVMVNVRURBJKZFDVHVMURBMV
    HVSVLFUPAODZBODZVSVLRVAAUKZBUKZABUEPQSVMVKUFZTVQNVHUQVDIZVNVJVHWEVMVNWEAVCJ
    KZFDVHVMAVCMVHWFVLFUPVTWAWFVLRVAWBWCABUGPQSWDTVQNVHUSVDIZVNVJVHWGVKVNWGURVC
    JKZFDVHVKURVCMVHWHVFFUPVTWAWHVFRVAWBWCABUHPQSVKVMUITVQNUJVFLULUMUNUO $.

  $( Integer ordering relation.  (Contributed by NM, 10-May-2004.)  (Proof
     shortened by Mario Carneiro, 16-May-2014.) $)
  zltp1le $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M < N <-> ( M + 1 ) <_ N ) ) $=
    ( cz wcel wa clt wbr c1 caddc co cle cmin cn wi nnge1 a1i znnsub cr wb zre
    1re leaddsub2 mp3an2 syl2an 3imtr4d adantr ltp1d peano2re syl adantl ltletr
    syl3anc mpand impbid ) ACDZBCDZEZABFGZAHIJZBKGZUQBALJZMDZHVAKGZURUTVBVCNUQV
    AOPABQUOARDZBRDZUTVCSZUPATZBTZVDHRDVEVFUAAHBUBUCUDUEUQAUSFGZUTURUQAUOVDUPVG
    UFZUGUQVDUSRDZVEVIUTEURNVJUQVDVKVJAUHUIUPVEUOVHUJAUSBUKULUMUN $.

  $( Integer ordering relation.  (Contributed by NM, 10-May-2004.) $)
  zleltp1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M <_ N <-> M < ( N + 1 ) ) ) $=
    ( cz wcel wa cle wbr c1 caddc co clt cr wb zre leadd1 mp3an3 syl2an peano2z
    1re zltp1le sylan2 bitr4d ) ACDZBCDZEABFGZAHIJBHIJZFGZAUFKGZUCALDZBLDZUEUGM
    ZUDANBNUIUJHLDUKSABHOPQUDUCUFCDUHUGMBRAUFTUAUB $.

  $( Integer ordering relation.  (Contributed by NM, 13-Nov-2004.) $)
  zlem1lt $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M <_ N <-> ( M - 1 ) < N ) ) $=
    ( cz wcel wa c1 cmin co clt wbr caddc cle wb peano2zm zltp1le sylan wceq cc
    zcn ax-1cn npcan sylancl adantr breq1d bitr2d ) ACDZBCDZEZAFGHZBIJZUIFKHZBL
    JZABLJUFUICDUGUJULMANUIBOPUHUKABLUFUKAQZUGUFARDFRDUMASTAFUAUBUCUDUE $.

  $( Integer ordering relation.  (Contributed by NM, 13-Nov-2004.) $)
  zltlem1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M < N <-> M <_ ( N - 1 ) ) ) $=
    ( cz wcel wa c1 cmin co cle wbr caddc clt wb peano2zm zleltp1 sylan2 cc zcn
    wceq ax-1cn npcan sylancl adantl breq2d bitr2d ) ACDZBCDZEZABFGHZIJZAUIFKHZ
    LJZABLJUGUFUICDUJULMBNAUIOPUHUKBALUGUKBSZUFUGBQDFQDUMBRTBFUAUBUCUDUE $.

  $( Natural number ordering relation.  (Contributed by NM, 13-Aug-2001.)
     (Proof shortened by Mario Carneiro, 16-May-2014.) $)
  nnleltp1 $p |- ( ( A e. NN /\ B e. NN ) ->
                ( A <_ B <-> A < ( B + 1 ) ) ) $=
    ( cn wcel cz cle wbr c1 caddc co clt wb nnz zleltp1 syl2an ) ACDAEDBEDABFGA
    BHIJKGLBCDAMBMABNO $.

  $( Natural number ordering relation.  (Contributed by NM, 19-Aug-2001.) $)
  nnltp1le $p |- ( ( A e. NN /\ B e. NN ) ->
                ( A < B <-> ( A + 1 ) <_ B ) ) $=
    ( cn wcel cz clt wbr c1 caddc co cle wb nnz zltp1le syl2an ) ACDAEDBEDABFGA
    HIJBKGLBCDAMBMABNO $.

  $( Closure of addition of natural numbers minus one.  (Contributed by NM,
     6-Aug-2003.)  (Proof shortened by Mario Carneiro, 16-May-2014.) $)
  nnaddm1cl $p |- ( ( A e. NN /\ B e. NN ) -> ( ( A + B ) - 1 ) e. NN ) $=
    ( cn wcel wa caddc co c1 cmin wceq nncn ax-1cn addsub mp3an3 syl2an nnm1nn0
    cc cn0 nn0nnaddcl sylan eqeltrd ) ACDZBCDZEABFGHIGZAHIGZBFGZCUBAQDZBQDZUDUF
    JZUCAKBKUGUHHQDUILABHMNOUBUERDUCUFCDAPUEBSTUA $.

  $( Nonnegative integer ordering relation.  (Contributed by Raph Levien,
     10-Dec-2002.)  (Proof shortened by Mario Carneiro, 16-May-2014.) $)
  nn0ltp1le $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M < N <-> ( M + 1 ) <_ N ) ) $=
    ( cn0 wcel cz clt wbr c1 caddc co cle wb nn0z zltp1le syl2an ) ACDAEDBEDABF
    GAHIJBKGLBCDAMBMABNO $.

  $( Nonnegative integer ordering relation.  (Contributed by Raph Levien,
     10-Apr-2004.) $)
  nn0leltp1 $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M <_ N <-> M < ( N + 1 ) ) ) $=
    ( cn0 wcel cz cle wbr c1 caddc co clt wb nn0z zleltp1 syl2an ) ACDAEDBEDABF
    GABHIJKGLBCDAMBMABNO $.

  $( Nonnegative integer ordering relation.  (Contributed by NM, 10-May-2004.)
     (Proof shortened by Mario Carneiro, 16-May-2014.) $)
  nn0ltlem1 $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                ( M < N <-> M <_ ( N - 1 ) ) ) $=
    ( cn0 wcel cz clt wbr c1 cmin co cle wb nn0z zltlem1 syl2an ) ACDAEDBEDABFG
    ABHIJKGLBCDAMBMABNO $.

  $( Subtraction of nonnegative integers.  (Contributed by NM, 4-Sep-2005.) $)
  nn0sub2 $p |- ( ( M e. NN0 /\ N e. NN0 /\ M <_ N ) -> ( N - M ) e. NN0 ) $=
    ( cn0 wcel cle wbr cmin co nn0sub biimp3a ) ACDBCDABEFBAGHCDABIJ $.

  $( A nonnegative integer less than ` 1 ` is ` 0 ` .  (Contributed by Paul
     Chapman, 22-Jun-2011.) $)
  nn0lt10b $p |- ( N e. NN0 -> ( N < 1 <-> N = 0 ) ) $=
    ( cn0 wcel cc0 wceq cle wbr wa c1 clt cr wb nn0re 0re letri3 mpan2 biantrud
    syl nn0ge0 cz nn0z caddc co 0z zleltp1 0p1e1 breq2i syl6bb 3bitr2rd ) ABCZA
    DEZADFGZDAFGZHZULAIJGZUJAKCZUKUNLZAMUPDKCUQNADOPRUJUMULASQUJATCZULUOLAUAURU
    LADIUBUCZJGZUOURDTCULUTLUDADUEPUSIAJUFUGUHRUI $.

  $( Nonnegative integer ordering relation.  (Contributed by NM,
     21-Jun-2005.) $)
  nn0lem1lt $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                   ( M <_ N <-> ( M - 1 ) < N ) ) $=
    ( cn0 wcel cz cle wbr c1 cmin co clt wb nn0z zlem1lt syl2an ) ACDAEDBEDABFG
    AHIJBKGLBCDAMBMABNO $.

  $( Natural number ordering relation.  (Contributed by NM, 21-Jun-2005.) $)
  nnlem1lt $p |- ( ( M e. NN /\ N e. NN ) -> ( M <_ N <-> ( M - 1 ) < N ) ) $=
    ( cn wcel cz cle wbr c1 cmin co clt wb nnz zlem1lt syl2an ) ACDAEDBEDABFGAH
    IJBKGLBCDAMBMABNO $.

  $( Natural number ordering relation.  (Contributed by NM, 21-Jun-2005.) $)
  nnltlem1 $p |- ( ( M e. NN /\ N e. NN ) -> ( M < N <-> M <_ ( N - 1 ) ) ) $=
    ( cn wcel cz clt wbr c1 cmin co cle wb nnz zltlem1 syl2an ) ACDAEDBEDABFGAB
    HIJKGLBCDAMBMABNO $.

  ${
    $d k M $.  $d k N $.
    $( Two ways to express " ` M ` divides ` N ` .  (Contributed by NM,
       3-Oct-2008.) $)
    zdiv $p |- ( ( M e. NN /\ N e. ZZ )
                -> ( E. k e. ZZ ( M x. k ) = N <-> ( N / M ) e. ZZ ) ) $=
      ( cn wcel cz wa cc0 wne cv cmul co wceq wrex cdiv wb nnne0 cc wi zcn nncn
      adantr divcan3 3coml 3expa sylan2 3adantl2 oveq1 sylan9req eqeltrrd exp31
      w3a simplr rexlimdv divcan2 3com12 eqeq1d rspcev expcom syl impbid 3expia
      oveq2 syl2an mpd ) BDEZCFEZGBHIZBAJZKLZCMZAFNZCBOLZFEZPZVFVHVGBQUBVFBREZC
      REZVHVOSVGBUACTVPVQVHVOVPVQVHULZVLVNVRVKVNAFVRVIFEZVKVNVRVSGZVKGVIVMFVTVK
      VIVJBOLZVMVPVHVSWAVIMZVQVSVPVHGVIREZWBVITVPVHWCWBWCVPVHWBVIBUCUDUEUFUGVJC
      BOUHUIVRVSVKUMUJUKUNVRBVMKLZCMZVNVLSVQVPVHWECBUOUPVNWEVLVKWEAVMFVIVMMVJWD
      CVIVMBKVCUQURUSUTVAVBVDVE $.
  $}

  $( Property of divisibility: if ` D ` divides ` A ` and ` B ` then it divides
     ` A + B ` .  (Contributed by NM, 3-Oct-2008.) $)
  zdivadd $p |- ( ( ( D e. NN /\ A e. ZZ /\ B e. ZZ ) /\
       ( ( A / D ) e. ZZ /\ ( B / D ) e. ZZ ) ) -> ( ( A + B ) / D ) e. ZZ ) $=
    ( cn wcel cz w3a cdiv co wa caddc wceq cc cc0 wne zcn nncn nnne0 jca divdir
    syl3an 3comr adantr zaddcl adantl eqeltrd ) CDEZAFEZBFEZGZACHIZFEBCHIZFEJZJ
    ABKICHIZUKULKIZFUJUNUOLZUMUHUIUGUPUHAMEUIBMEUGCMEZCNOZJUPAPBPUGUQURCQCRSABC
    TUAUBUCUMUOFEUJUKULUDUEUF $.

  $( Property of divisibility: if ` D ` divides ` A ` then it divides
     ` B x. A ` .  (Contributed by NM, 3-Oct-2008.) $)
  zdivmul $p |- ( ( ( D e. NN /\ A e. ZZ /\ B e. ZZ ) /\
       ( A / D ) e. ZZ ) -> ( ( B x. A ) / D ) e. ZZ ) $=
    ( cn wcel cz w3a cdiv co wa cmul wceq cc cc0 wne zcn 3ad2ant2 3ad2ant1 nncn
    nnne0 jca 3ad2ant3 divass syl3anc 3comr adantr zmulcl 3ad2antl3 eqeltrd ) C
    DEZAFEZBFEZGZACHIZFEZJBAKICHIZBUNKIZFUMUPUQLZUOUKULUJURUKULUJGBMEZAMEZCMEZC
    NOZJZURULUKUSUJBPQUKULUTUJAPRUJUKVCULUJVAVBCSCTUAUBBACUCUDUEUFULUJUOUQFEUKB
    UNUGUHUI $.

  ${
    $d k M $.  $d k N $.
    $( An extensionality-like property for integer ordering.  (Contributed by
       NM, 29-Oct-2005.) $)
    zextle $p |- ( ( M e. ZZ /\ N e. ZZ /\ A. k e. ZZ ( k <_ M <-> k <_ N ) )
                  -> M = N ) $=
      ( cz wcel cv cle wbr wb wral wceq wa zre leidd adantr breq1 bibi12d mpbid
      rspcva cr adantlr mpbird adantll jca ex letri3 syl2an sylibrd 3impia ) BD
      EZCDEZAFZBGHZULCGHZIZADJZBCKZUJUKLZUPBCGHZCBGHZLZUQURUPVAURUPLUSUTUJUPUSU
      KUJUPLBBGHZUSUJVBUPUJBBMZNOUOVBUSIABDULBKUMVBUNUSULBBGPULBCGPQSRUAUKUPUTU
      JUKUPLUTCCGHZUKVDUPUKCCMZNOUOUTVDIACDULCKUMUTUNVDULCBGPULCCGPQSUBUCUDUEUJ
      BTECTEUQVAIUKVCVEBCUFUGUHUI $.

    $( An extensionality-like property for integer ordering.  (Contributed by
       NM, 29-Oct-2005.) $)
    zextlt $p |- ( ( M e. ZZ /\ N e. ZZ /\ A. k e. ZZ ( k < M <-> k < N ) )
                  -> M = N ) $=
      ( cz wcel clt wbr wb wral wceq wa c1 cmin cle zltlem1 peano2zm syl2an zcn
      co cc cv adantrr adantrl bibi12d ancoms ralbidva wi zextle 3expia subcan2
      ax-1cn mp3an3 sylibd sylbid 3impia ) BDEZCDEZAUAZBFGZURCFGZHZADIZBCJZUPUQ
      KZVBURBLMSZNGZURCLMSZNGZHZADIZVCVDVAVIADURDEZVDVAVIHVKVDKUSVFUTVHVKUPUSVF
      HUQURBOUBVKUQUTVHHUPURCOUCUDUEUFVDVJVEVGJZVCUPVEDEZVGDEZVJVLUGUQBPCPVMVNV
      JVLAVEVGUHUIQUPBTEZCTEZVLVCHZUQBRCRVOVPLTEVQUKBCLUJULQUMUNUO $.
  $}

  $( The reciprocal of a number greater than 1 is not an integer.  (Contributed
     by NM, 3-May-2005.) $)
  recnz $p |- ( ( A e. RR /\ 1 < A ) -> -. ( 1 / A ) e. ZZ ) $=
    ( cr wcel c1 clt wbr wa cdiv co cz cc0 recgt1i simprd wn simpld caddc wb 0z
    cle 1re zltp1le mpan 0p1e1 breq1i syl6bb syl5ibcom wne 0lt1 wi lttr mp3an12
    0re mpani imdistani gt0ne0 syl rereccl syldan lenlt sylancr sylibd mt2d ) A
    BCZDAEFZGZDAHIZJCZVFDEFZVEKVFEFZVHALZMVEVGDVFSFZVHNZVEVIVGVKVEVIVHVJOVGVIKD
    PIZVFSFZVKKJCVGVIVNQRKVFUAUBVMDVFSUCUDUEUFVEDBCZVFBCZVKVLQTVCVDAKUGZVPVEVCK
    AEFZGVQVCVDVRVCKDEFZVDVRUHKBCVOVCVSVDGVRUIULTKDAUJUKUMUNAUOUPAUQURDVFUSUTVA
    VB $.

  $( A number between an integer and its successor is not an integer.
     (Contributed by NM, 3-May-2005.) $)
  btwnnz $p |- ( ( A e. ZZ /\ A < B /\ B < ( A + 1 ) ) -> -. B e. ZZ ) $=
    ( cz wcel clt wbr c1 caddc co wn wa cle zltp1le cr wb peano2z zre syl lenlt
    syl2an bitrd biimpd impancom con2d 3impia ) ACDZABEFZBAGHIZEFZBCDZJUFUGKUJU
    IUFUJUGUIJZUFUJKZUGUKULUGUHBLFZUKABMUFUHNDZBNDUMUKOUJUFUHCDUNAPUHQRBQUHBSTU
    AUBUCUDUE $.

  $( A larger number does not divide a smaller natural number.  (Contributed by
     NM, 3-May-2005.) $)
  gtndiv $p |- ( ( A e. RR /\ B e. NN /\ B < A ) -> -. ( B / A ) e. ZZ ) $=
    ( cr wcel cn clt wbr w3a cc0 cdiv co c1 caddc cz wn nnre 3ad2ant2 wa mp3an1
    wb simp1 nngt0 adantl 0re lttr sylan ancoms mpand 3impia divgt0d simp3 cmul
    wi 1re ltdivmul2 mp3an2 syl12anc mulid2d breq2d 3ad2ant1 bitrd mpbird 0p1e1
    recn syl6breqr 0z btwnnz syl2anc ) ACDZBEDZBAFGZHZIBAJKZFGZVMILMKZFGZVMNDOZ
    VLBAVJVIBCDZVKBPZQZVIVJVKUAZVJVIIBFGZVKBUBZQVIVJVKIAFGZVIVJRWBVKWDVJWBVIWCU
    CVJVIWBVKRWDUMZVJVRVIWEVSICDVRVIWEUDIBAUESUFUGUHUIZUJVLVMLVOFVLVMLFGZVKVIVJ
    VKUKVLWGBLAULKZFGZVKVLVRVIWDWGWITZVTWAWFVRLCDVIWDRWJUNBLAUOUPUQVIVJWIVKTVKV
    IWHABFVIAAVDURUSUTVAVBVCVEINDVNVPVQVFIVMVGSVH $.

  $( One-half is not an integer.  (Contributed by NM, 31-Jul-2004.) $)
  halfnz $p |- -. ( 1 / 2 ) e. ZZ $=
    ( c2 cr wcel c1 clt wbr cdiv co cz wn 2re 1lt2 recnz mp2an ) ABCDAEFDAGHICJ
    KLAMN $.

  ${
    $d w x y z A $.
    $( The supremum of a bounded-above set of integers is a member of the set.
       (Contributed by Paul Chapman, 21-Mar-2011.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    suprzcl $p |- ( ( A C_ ZZ /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                    sup ( A , RR , < ) e. A ) $=
      ( vz vw cz wss cv cle wbr wral cr clt c1 wcel wb syl wa adantr syl3anl1
      c0 wne wrex w3a csup cmin zssre sstr mpan2 suprcl syl3an1 ltm1d peano2rem
      suprlub mpdan mpbid caddc simpl1 sselda sseldi simprl sseldd zre peano2re
      co suprub adantlr simprr 1re a1i ltsubaddd lelttrd zleltp1 syl2anc mpbird
      ralrimiva suprleub syldan adantrr letri3d mpbir2and eqeltrd rexlimddv
      wceq ) CFGZCUAUBZBHAHIJBCKALUCZUDZCLMUEZNUFVEZDHZMJZWICODCWHWJWIMJZWLDCUC
      ZWHWIWECLGZWFWGWILOZWEFLGWOUGCFLUHUIZABCUJZUKZULWEWOWFWGWMWNPZWQWOWFWGUDZ
      WJLOZWTXAWPXBWRWIUMQABDCWJUNUOUKUPWHWKCOZWLRZRZWIWKCXEWIWKWDWIWKIJZWKWIIJ
      ZXEXFEHZWKIJZECKZXEXIECXEXHCOZRZXIXHWKNUQVEZMJZXLXHWIXMXLFLXHUGXECFXHWEWF
      WGXDURZUSZUTXEWPXKWHWPXDWSSZSXEXMLOZXKXEWKLOZXRXEWKFOZXSXECFWKXOWHXCWLVAZ
      VBZWKVCQZWKVDQSWHXKXHWIIJZXDWEWOWFWGXKYDWQABCXHVFTVGXEWIXMMJZXKXEWLYEWHXC
      WLVHXEWINWKXQNLOXEVIVJYCVKUPSVLXLXHFOXTXIXNPXPXEXTXKYBSXHWKVMVNVOVPWHXDXS
      XFXJPZYCWEWOWFWGXSYFWQABECWKVQTVRVOWHXCXGWLWEWOWFWGXCXGWQABCWKVFTVSXEWIWK
      XQYCVTWAYAWBWC $.
  $}

  ${
    $d x A $.
    $( Two ways to express " ` A ` is a prime number (or 1)."  See also
       ~ isprm .  (Contributed by NM, 4-May-2005.) $)
    prime $p |- ( A e. NN -> (
                 A. x e. NN ( ( A / x ) e. NN -> ( x = 1 \/ x = A ) ) <->
          A. x e. NN ( ( 1 < x /\ x <_ A /\ ( A / x ) e. NN ) -> x = A ) ) ) $=
      ( cn wcel cv cdiv co c1 wceq wo wi clt wbr cle w3a wa wb wn cr nnre sylan
      wne bi2.04 impexp imbi2i 3bitr4ri nngt1ne1 adantl anbi1d cz gtndiv 3expia
      neor nnz con2d lenlt syl2an sylibrd ancoms pm4.71rd anbi2d 3anass syl6bbr
      syl5 bitr3d imbi1d syl5bb ralbidva ) BCDZBAEZFGZCDZVJHIVJBIZJZKZHVJLMZVJB
      NMZVLOZVMKZACVOVJHUBZVLPZVMKZVIVJCDZPZVSVTVLVMKKVLVTVMKZKWBVOVTVLVMUCVTVL
      VMUDVNWEVLVMVJHUMUEUFWDWAVRVMWDVPVLPZWAVRWDVPVTVLWCVPVTQVIVJUGUHUIWDWFVPV
      QVLPZPVRWDVLWGVPWDVLVQVLVKUJDZWDVQVKUNWCVIWHVQKWCVIPZWHBVJLMZRZVQWIWJWHWC
      VJSDZVIWJWHRZKVJTZWLVIWJWMVJBUKULUAUOWCWLBSDVQWKQVIWNBTVJBUPUQURUSVDUTVAV
      PVQVLVBVCVEVFVGVH $.
  $}

  $( The square of a nonzero integer is a natural number.  (Contributed by NM,
     2-Aug-2004.) $)
  msqznn $p |- ( ( A e. ZZ /\ A =/= 0 ) -> ( A x. A ) e. NN ) $=
    ( cz wcel cc0 wne wa co clt wbr cn zmulcl anidms adantr cr zre msqgt0 sylan
    cmul elnnz sylanbrc ) ABCZADEZFAARGZBCZDUCHIZUCJCUAUDUBUAUDAAKLMUAANCUBUEAO
    APQUCST $.

  $( No even integer equals an odd integer (i.e. no integer can be both even
     and odd).  Exercise 10(a) of [Apostol] p. 28.  (Contributed by NM,
     31-Jul-2004.)  (Proof shortened by Mario Carneiro, 18-May-2014.) $)
  zneo $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
             ( 2 x. A ) =/= ( ( 2 x. B ) + 1 ) ) $=
    ( cz wcel wa c2 cmul co c1 caddc cdiv wne wceq cc 2cn zcn mulcl sylancr a1i
    cmin halfnz adantr adantl ax-1cn subaddd subdid oveq1d zsubcl 2ne0 divcan3d
    syl cc0 eqtr3d eqeltrd oveq1 eleq1d syl5ibcom sylbird necon3bd mpi necomd
    wn ) ACDZBCDZEZFBGHZIJHZFAGHZVEIFKHZCDZVBVGVHLUAVEVJVGVHVEVGVHMVHVFTHZIMZVJ
    VEVHVFIVEFNDZANDZVHNDOVCVNVDAPUBZFAQRVEVMBNDZVFNDOVDVPVCBPUCZFBQRINDVEUDSUE
    VEVKFKHZCDVLVJVEVRABTHZCVEFVSGHZFKHVRVSVEVTVKFKVEFABVMVEOSZVOVQUFUGVEVSFVEV
    SCDVSNDABUHZVSPUKWAFULLVEUISUJUMWBUNVLVRVICVKIFKUOUPUQURUSUTVA $.

  ${
    $d j k N $.
    $( A natural number is even or odd but not both.  (Contributed by NM,
       1-Jan-2006.)  (Proof shortened by Mario Carneiro, 18-May-2014.) $)
    nneo $p |- ( N e. NN ->
                ( ( N / 2 ) e. NN <-> -. ( ( N + 1 ) / 2 ) e. NN ) ) $=
      ( vj vk cn wcel c2 cdiv co c1 caddc cmul wceq cc 2cn 2ne0 oveq1d wo oveq1
      eleq1d orbi12d wn nncn peano2cn syl a1i cc0 wne divcan2d eqtr4d cz syl2an
      nnz zneo expcom necon2bd syl5com cv df-2 oveq1i dividi eqtr3i 1nn eqeltri
      orci peano2nn ax-1cn addass mp3an23 oveq2i syl6eqr wa pm3.2i divdir eqtrd
      syl6eq syl5ibr orim2d orcom syl6ib nnind ord impbid ) ADEZAFGHZDEZAIJHZFG
      HZDEZUAZWCFWGKHZFWDKHZIJHZLWEWIWCWJWFWLWCWFFWCAMEWFMEAUBZAUCUDFMEZWCNUEZF
      UFUGZWCOUEZUHWCWKAIJWCAFWMWOWQUHPUIWEWHWJWLWHWEWJWLUGZWHWGUJEWDUJEWRWEWGU
      LWDULWGWDUMUKUNUOUPWCWHWEBUQZIJHZFGHZDEZWSFGHZDEZQIIJHZFGHZDEZIFGHZDEZQCU
      QZIJHZFGHZDEZXJFGHZDEZQZXKIJHZFGHZDEZXMQZWHWEQBCAWSILZXBXGXDXIYAXAXFDYAWT
      XEFGWSIIJRPSYAXCXHDWSIFGRSTWSXJLZXBXMXDXOYBXAXLDYBWTXKFGWSXJIJRPSYBXCXNDW
      SXJFGRSTWSXKLZXBXSXDXMYCXAXRDYCWTXQFGWSXKIJRPSYCXCXLDWSXKFGRSTWSALZXBWHXD
      WEYDXAWGDYDWTWFFGWSAIJRPSYDXCWDDWSAFGRSTXGXIXFIDFFGHZXFIFXEFGURUSFNOUTZVA
      VBVCVDXJDEZXPXMXSQXTYGXOXSXMXOXSYGXNIJHZDEXNVEYGXRYHDYGXJMEZXRYHLXJUBYIXR
      XJFJHZFGHZYHYIXQYJFGYIXQXJXEJHZYJYIIMEZYMXQYLLVFVFXJIIVGVHFXEXJJURVIVJPYI
      YKXNYEJHZYHYIWNWNWPVKYKYNLNWNWPNOVLXJFFVMVHYEIXNJYFVIVOVNUDSVPVQXMXSVRVSV
      TWAWB $.

    nneo.1 $e |- N e. NN $.
    $( A natural number is even or odd but not both.  (Contributed by NM,
       20-Aug-2001.) $)
    nneoi $p |- ( ( N / 2 ) e. NN <-> -. ( ( N + 1 ) / 2 ) e. NN ) $=
      ( cn wcel c2 cdiv co c1 caddc wn wb nneo ax-mp ) ACDAEFGCDAHIGEFGCDJKBALM
      $.
  $}

  $( An integer is even or odd.  (Contributed by NM, 1-Jan-2006.) $)
  zeo $p |- ( N e. ZZ -> ( ( N / 2 ) e. ZZ \/ ( ( N + 1 ) / 2 ) e. ZZ ) ) $=
    ( cz wcel c2 cdiv co c1 caddc cc0 wceq cn cneg wn 2cn 2ne0 mp3an23 syl cmin
    cc ax-1cn cr w3o wa wi oveq1 div0i 0z eqeltri syl6eqel pm2.24d adantl con3i
    elz nnz nneo biimprd con1d syl56 recn divneg eleq1d syl6bir halfcld negnegd
    nnnegz sylibd adantr con3d peano2zm negsubdi2i 2m1e1 eqtr2i subcli negcon2i
    wne mpbi oveq2i negcl addsubass negdi mpan2 3eqtr4a oveq1d pm3.2i divsubdir
    peano2cn dividi eqcomi syl6reqr 3eqtr4d syl5ib znegcl syl6 peano2re sylan9r
    recnd syl5 syld 3jaodan sylbi orrd ) ABCZADEFZBCZAGHFZDEFZBCZXBAUACZAIJZAKC
    ZALZKCZUBUCXDMZXGUDZAUMXHXIXNXJXLXIXNXHXIXDXGXIXCIDEFZBAIDEUEXOIBDNOUFUGUHU
    IUJUKXJXNXHXMXCKCZMXJXFKCZXGXPXDXCUNULXJXQXPXJXPXQMAUOUPUQXFUNURUKXHXLUCZXM
    XKDEFZKCZMZXGXRXTXDXHXTXDUDXLXHXTXCLZLZBCZXDXHXTYBKCYDXHYBXSKXHASCZYBXSJZAU
    SZYEDSCZDIVOZYFNOADUTPQVAYBVEVBXHYCXCBXHXCXHAYGVCVDVAVFVGVHXLYAXKGHFZDEFZKC
    ZXHXGXLYLXTXLXTYLMXKUOUPUQYLYKBCZXHXGYKUNXHYMXFLZLZBCZXGXHYMYNBCZYPYMYKGRFZ
    BCXHYQYKVIXHYRYNBXHYEYRYNJYGYEYJDRFZDEFZXELZDEFZYRYNYEYSUUADEYEXKGDRFZHFZXK
    GLZHFZYSUUAUUCUUEXKHGUUCLZJUUCUUEJUUGDGRFGGDTNVJVKVLGUUCTGDTNVMVNVPVQYEXKSC
    ZYSUUDJZAVRZUUHGSCZYHUUITNXKGDVSPQYEUUKUUAUUFJTAGVTWAWBWCYEYTYKDDEFZRFZYRYE
    YJSCZYTUUMJZYEUUHUUNUUJXKWFQUUNYHYHYIUCUUONYHYINOWDYJDDWEPQGUULYKRUULGDNOWG
    WHVQWIYEXESCZYNUUBJZAWFUUPYHYIUUQNOXEDUTPQWJQVAWKYNWLWMXHYOXFBXHXFXHXEXHXEA
    WNWPVCVDVAVFWQWOWRWSWTXA $.

  $( An integer is even or odd but not both.  (Contributed by Mario Carneiro,
     12-Sep-2015.) $)
  zeo2 $p |- ( N e. ZZ ->
              ( ( N / 2 ) e. ZZ <-> -. ( ( N + 1 ) / 2 ) e. ZZ ) ) $=
    ( cz wcel c2 cdiv co c1 caddc wn cmul wceq zcn peano2cn syl 2cn a1i cc0 wne
    cc divcan2d 2ne0 oveq1d eqtr4d expcom necon2bd syl5com zeo ord con1d impbid
    zneo ) ABCZADEFZBCZAGHFZDEFZBCZIZULDUPJFZDUMJFZGHFZKUNURULUSUOVAULUODULASCU
    OSCALZAMNDSCULOPZDQRULUAPZTULUTAGHULADVBVCVDTUBUCUNUQUSVAUQUNUSVARUPUMUKUDU
    EUFULUNUQULUNUQAUGUHUIUJ $.

  ${
    $d x A $.  $d x B $.
    $( Second Peano postulate for upper integers.  (Contributed by NM,
       3-Oct-2004.) $)
    peano2uz2 $p |- ( ( A e. ZZ /\ B e. { x e. ZZ | A <_ x } ) ->
                             ( B + 1 ) e. { x e. ZZ | A <_ x } ) $=
      ( cz wcel cle wbr wa c1 caddc co cv crab peano2z ad2antrl cr wi zre breq2
      elrab lep1 adantl peano2re ancli letr 3expb sylan2 mpan2d syl2an impr jca
      anbi2i 3imtr4i ) BDEZCDEZBCFGZHZHZCIJKZDEZBUSFGZHUNCBALZFGZADMZEZHUSVDEUR
      UTVAUOUTUNUPCNOUNUOUPVAUNBPEZCPEZUPVAQUOBRCRVFVGHUPCUSFGZVAVGVHVFCUAUBVGV
      FVGUSPEZHUPVHHVAQZVGVICUCUDVFVGVIVJBCUSUEUFUGUHUIUJUKVEUQUNVCUPACDVBCBFST
      ULVCVAAUSDVBUSBFSTUM $.
  $}

  ${
    $d k n x A $.  $d k n x N $.
    ${
      peano5uz.1 $e |- N e. ZZ $.
      $( Peano's inductive postulate for upper integers.  (Contributed by NM,
         6-Jul-2005.)  (Revised by Mario Carneiro, 3-May-2014.) $)
      peano5uzi $p |- ( ( N e. A /\ A. x e. A ( x + 1 ) e. A ) ->
                    { k e. ZZ | N <_ k } C_ A ) $=
        ( vn wcel c1 caddc co wa cz cc wceq ax-1cn cn wi oveq1 eleq1d imbi2d cv
        wral cle wbr crab breq2 elrab cmin ad2antrl ax-mp subcli sylancl subsub
        zcn npcan mp3an23 syl cn0 wb znn0sub mpan biimpa adantl nn0p1nn eqeltrd
        simpl pncan3i syl5eqel rspccv ad2antll adantr add32 sylibd ex a2d nnind
        nncn sylc eqeltrrd syl5bi ssrdv ) DBGZAUAZHIJZBGZABUBZKZFDCUAZUCUDZCLUE
        ZBFUAZWJGWKLGZDWKUCUDZKZWGWKBGZWIWMCWKLWHWKDUCUFUGWGWNWOWGWNKZWKDHUHJZU
        HJZWQIJZWKBWPWKMGZWQMGZWSWKNWLWTWGWMWKUNUIZDHDLGZDMGZEDUNUJZOUKZWKWQUOU
        LWPWRPGWGWSBGZWPWRWKDUHJZHIJZPWPWTWRXINZXBWTXDHMGZXJXEOWKDHUMUPUQWPXHUR
        GZXIPGWNXLWGWLWMXLXCWLWMXLUSEDWKUTVAVBVCXHVDUQVEWGWNVFWGWHWQIJZBGZQWGHW
        QIJZBGZQWGWKWQIJZBGZQWGWKHIJZWQIJZBGZQWGXGQCFWRWHHNZXNXPWGYBXMXOBWHHWQI
        RSTWHWKNZXNXRWGYCXMXQBWHWKWQIRSTWHXSNZXNYAWGYDXMXTBWHXSWQIRSTWHWRNZXNXG
        WGYEXMWSBWHWRWQIRSTWGXODBHDOXEVGWBWFVFVHWKPGZWGXRYAYFWGXRYAQYFWGKZXRXQH
        IJZBGZYAWFXRYIQYFWBWEYIAXQBWCXQNWDYHBWCXQHIRSVIVJYGYHXTBYGWTYHXTNZYFWTW
        GWKVQVKWTXAXKYJXFOWKWQHVLUPUQSVMVNVOVPVRVSVNVTWA $.
    $}

    $( Peano's inductive postulate for upper integers.  (Contributed by NM,
       6-Jul-2005.)  (Revised by Mario Carneiro, 25-Jul-2013.) $)
    peano5uzti $p |- ( N e. ZZ -> ( ( N e. A /\ A. x e. A ( x + 1 ) e. A )
                          -> { k e. ZZ | N <_ k } C_ A ) ) $=
      ( cz wcel cv c1 caddc co wral wa cle wbr crab wss wi cif wceq eleq1 breq1
      anbi1d rabbidv sseq1d imbi12d 1z elimel peano5uzi dedth ) DEFZDBFZAGHIJBF
      ABKZLZDCGZMNZCEOZBPZQUJDHRZBFZULLZURUNMNZCEOZBPZQDHDURSZUMUTUQVCVDUKUSULD
      URBTUBVDUPVBBVDUOVACEDURUNMUAUCUDUEABCURDHEUFUGUHUI $.
  $}

  ${
    $d x y z w v u m N $.
    dfuz.1 $e |- N e. ZZ $.
    $( An expression for the upper integers that start at ` N ` that is
       analogous to ~ df-nn for natural numbers.  (Contributed by NM,
       6-Jul-2005.)  (Proof shortened by Mario Carneiro, 3-May-2014.) $)
    dfuzi $p |- { z e. ZZ | N <_ z } =
               |^| { x | ( N e. x /\ A. y e. x ( y + 1 ) e. x ) } $=
      ( cv cle wbr cz crab wcel c1 caddc co wral wa cab wss mpbir2an eleq2 cint
      ssintab peano5uzi mpgbir zrei leidi breq2 elrab peano2uz2 mpan rgen rabex
      wi zex wceq raleqbi1dv anbi12d elab intss1 ax-mp eqssi ) DCFZGHZCIJZDAFZK
      ZBFZLMNZVEKZBVEOZPZAQZUAZVDVMRVKVDVERUMAVKAVDUBBVECDEUCUDVDVLKZVMVDRVNDVD
      KZVHVDKZBVDOZVODIKZDDGHZEDDEUEUFVCVSCDIVBDDGUGUHSVPBVDVRVGVDKVPECDVGUIUJU
      KVKVOVQPAVDVCCIUNULVEVDUOVFVOVJVQVEVDDTVIVPBVEVDVEVDVHTUPUQURSVDVLUSUTVA
      $.
  $}

  ${
    $d j z w N $.  $d j z ps $.  $d j z ch $.  $d j z th $.  $d j z ta $.
    $d k w ph $.  $d j k z w M $.
    $( Substitutions. $)
    uzind.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind.6 $e |- ( ( M e. ZZ /\ k e. ZZ /\ M <_ k ) -> ( ch -> th ) ) $.
    $( Induction on the upper integers that start at ` M ` .  The first four
       hypotheses give us the substitution instances we need; the last two are
       the basis and the induction hypothesis.  (Contributed by NM,
       5-Jul-2005.) $)
    uzind $p |- ( ( M e. ZZ /\ N e. ZZ /\ M <_ N ) -> ta ) $=
      ( cz wcel cle wbr wa vw w3a cv crab c1 caddc wral wss zre leidd jca ancli
      co wceq breq2 anbi12d elrab sylibr wi peano2z a1i adantrd clt ltp1 adantl
      cr peano2re lelttr 3expb sylan2 mpan2d ltle syld syl2an expimpd 3exp jcad
      imp4d 3imtr4g ralrimiv peano5uzti mp2and sseld 3imtr3g 3impib simprd ) HP
      QZIPQZHIRSZUBZWIEWJWHWIETZWGWHWIWHWKTZWGIHUAUCZRSZUAPUDZQIHFUCZRSZATZFPUD
      ZQWHWITWLWGWOWSIWGHWSQZGUCZUEUFUMZWSQZGWSUGWOWSUHWGWGHHRSZBTZTWTWGXEWGXDB
      WGHHUIZUJNUKULWRXEFHPWPHUNWQXDABWPHHRUOJUPUQURWGXCGWSWGXAPQZHXARSZCTZTZXB
      PQZHXBRSZDTZTXAWSQXCWGXJXKXMWGXGXKXIXGXKUSWGXAUTVAVBWGXJXLDWGXGXIXLWGXGTX
      HXLCWGHVFQZXAVFQZXHXLUSXGXFXAUIXNXOTZXHHXBVCSZXLXPXHXAXBVCSZXQXOXRXNXAVDV
      EXOXNXOXBVFQZTXHXRTXQUSZXOXSXAVGZULXNXOXSXTHXAXBVHVIVJVKXOXNXSXQXLUSYAHXB
      VLVJVMVNVBVOWGXGXHCDWGXGXHCDUSOVPVRVQVQWRXIFXAPWPXAUNWQXHACWPXAHRUOKUPUQW
      RXMFXBPWPXBUNWQXLADWPXBHRUOLUPUQVSVTGWSUAHWAWBWCWNWIUAIPWMIHRUOUQWRWKFIPW
      PIUNWQWIAEWPIHRUOMUPUQWDWEWFWF $.
  $}

  ${
    $d j z w N $.  $d j z ps $.  $d j z ch $.  $d j z th $.  $d j z ta $.
    $d k w ph $.  $d j k z w M $.
    $( Substitutions. $)
    uzind2.1 $e |- ( j = ( M + 1 ) -> ( ph <-> ps ) ) $.
    uzind2.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind2.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind2.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind2.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind2.6 $e |- ( ( M e. ZZ /\ k e. ZZ /\ M < k ) -> ( ch -> th ) ) $.
    $( Induction on the upper integers that start _after_ an integer ` M ` .
       The first four hypotheses give us the substitution instances we need;
       the last two are the basis and the induction hypothesis.  (Contributed
       by NM, 25-Jul-2005.) $)
    uzind2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ M < N ) -> ta ) $=
      ( cz wcel wbr wi wceq clt wa c1 caddc co zltp1le peano2z cv imbi2d 3expia
      cle a1i w3a sylbird ex com3l imp 3adant1 a2d uzind 3exp syl com34 pm2.43a
      sylbid 3impia ) HPQZIPQZHIUARZEVGVHUBVIHUCUDUEZIUKRZEHIUFVGVHVKESZVHVGVLV
      GVHVKVGEVGVJPQZVHVKVGESZSSHUGVMVHVKVNVGASVGBSZVGCSVGDSVNFGVJIFUHZVJTABVGJ
      UIVPGUHZTACVGKUIVPVQUCUDUETADVGLUIVPITAEVGMUIVOVMNULVMVQPQZVJVQUKRZUMVGCD
      VRVSVGCDSZSZVMVRVSWAVGVRVSVTVGVRVSVTSVGVRUBVSHVQUARZVTHVQUFVGVRWBVTOUJUNU
      OUPUQURUSUTVAVBVCVDUQVEVF $.
  $}

  ${
    $d j k N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.  $d m ph $.
    $d j m k M $.
    $( Substitutions. $)
    uzind3.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind3.2 $e |- ( j = m -> ( ph <-> ch ) ) $.
    uzind3.3 $e |- ( j = ( m + 1 ) -> ( ph <-> th ) ) $.
    uzind3.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind3.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind3.6 $e |- ( ( M e. ZZ /\ m e. { k e. ZZ | M <_ k } ) ->
                   ( ch -> th ) ) $.
    $( Induction on the upper integers that start at an integer ` M ` .  The
       first four hypotheses give us the substitution instances we need, and
       the last two are the basis and the induction hypothesis.  (Contributed
       by NM, 26-Jul-2005.) $)
    uzind3 $p |- ( ( M e. ZZ /\ N e. { k e. ZZ | M <_ k } ) -> ta ) $=
      ( cle wbr cz wcel cv wa breq2 elrab wi sylan2br 3impb uzind 3expb sylan2b
      crab ) JIGUAZQRZGSUKZTISTZJSTZIJQRZUBEUMUQGJSULJIQUCUDUOUPUQEABCDEFHIJKLM
      NOUOHUAZSTZIURQRZCDUEZUSUTUBUOURUNTVAUMUTGURSULURIQUCUDPUFUGUHUIUJ $.
  $}

  ${
    $d x z w A $.  $d x z ps $.  $d x z ch $.  $d x z th $.  $d x z ta $.
    $d y w ph $.  $d x y z w B $.
    $( Substitutions. $)
    uzindOLD.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    uzindOLD.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    uzindOLD.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    uzindOLD.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzindOLD.5 $e |- ps $.
    $( Induction hypothesis. $)
    uzindOLD.6 $e |- ( ( ( y e. ZZ /\ B e. ZZ ) /\ B <_ y ) ->
                     ( ch -> th ) ) $.
    $( Induction on the upper integers that start at an integer ` B ` .  The
       first four hypotheses give us the substitution instances we need; the
       last two are the basis and the induction hypothesis.

       _Warning:  The HTML proof page is 3/4 megabyte in size.  An attempt to
       shorten it is on my to-do list.  Anyone is welcome to try_.
       (Contributed by NM, 11-May-2004.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    uzindOLD $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ B <_ A ) -> ta ) $=
      ( wcel c1 co caddc wceq vz vw cz wa cle wbr cmin cr wb zre subge0 resubcl
      cc0 0re 1re leadd1 mp3an13 syl ax-1cn addid2i breq1i syl6bb bitr3d syl2an
      wi zsubcl peano2z cn elnnz1 cv wsbc wex ovex isseti nfv nfsbc1v nfth nfbi
      eleq1 nfim sbceq1a adantr oveq1 oveq1d subidi oveq1i cc zcn addid2 syl5eq
      sylan9eq eqtr sylan2 ex exlimi ax-mp adantld pm5.74d imbi12d eeanv eqeq12
      syl5ibr bi2bian9 sylibd sylbir mp2an imbi2d subcl mpan2 addcl sylan npcan
      syl6 sylancl dfsbcq pm5.74i syl5bbr a1i simpr add32 eqtrd peano2cn addsub
      syl3anc pncan 3eqtr3d anasss pm5.74da a1ii nnz peano2zm peano2rem readdcl
      a1d zaddcl adantl recn subsub mp3an3 imim12d lesub1 anidms subid sylancom
      syl6eq 3eqtrd breq12d bitrd biimpar an32s sylanb jca31 anbi1d anbi12d mpi
      breq2 biimpd nncn sylibrd a2d nnind pm2.43a com23 mpcom sylbid imp ) HUCP
      ZIUCPZUDZIHUEUFZEUVIUVJQHIUGRZQSRZUEUFZEUVGHUHPZIUHPZUVJUVMUIUVHHUJIUJZUV
      NUVOUDZUMUVKUEUFZUVJUVMHIUKUVQUVRUMQSRZUVLUEUFZUVMUVQUVKUHPZUVRUVTUIZHIUL
      UMUHPUWAQUHPUWBUNUOUMUVKQUPUQURUVSQUVLUEQUSUTZVAVBVCVDUVLUCPZUVIUVMEVEUVI
      UVKUCPUWDHIVFUVKVGURUWDUVMUVIEUVMUWDUVIEVEZUWDUVMUWDUWEVEZUWDUVMUDUVLVHPU
      WFUVLVIUAVJZUCPZUVIAFUWGQUGRZISRZVKZVEZVEZQUCPZUVIBVEZVEUBVJZUCPZUVICGUWP
      QUGRZISRZVKZVEZVEUWPQSRZUCPZUVIDGUXBQUGRZISRZQUGRZVKZVEZVEZUWFUAUBUVLUWGQ
      TZUWHUWNUWLUWOUWGQUCVSUXJUVIUWKBUXJUVHUWKBUIZUVGUXJUVHUXKFVJZUWJTZFVLZUXJ
      UVHUDZUXKVEZFUWJUWIISVMVNZUXMUXPFUXOUXKFUXOFVOUWKBFAFUWJVPZBFNVQVRVTUXMUX
      OUXKUXMUXOUDZAUWKBUXMAUWKUIZUXOAFUWJWAZWBUXSUXLITZABUIUXOUXMUWJITUYBUXJUV
      HUWJQQUGRZISRZIUXJUWIUYCISUWGQQUGWCWDUVHUYDUMISRZIUYCUMISQUSWEWFUVHIWGPZU
      YEITIWHZIWIURWJWKUXLUWJIWLWMJURVCWNWOWPWNWQWRWSUWGUWPTZUWHUWQUWLUXAUWGUWP
      UCVSUYHUWKUWTUVIUXNGVJZUWSTZGVLZUYHUWKUWTUIZVEZUXQGUWSUWRISVMVNZUXNUYKUDU
      XMUYJUDZGVLZFVLUYMUXMUYJFGWTUYPUYMFUYHUYLFUYHFVOUWKUWTFUXRUWTFVOVRVTUYOUY
      MGUYHUYLGUYHGVOUWKUWTGUWKGVOCGUWSVPZVRVTUYOUYHACUIZUYLUYOUYHUXLUYITZUYRUY
      HUYSUYOUWJUWSTUYHUWIUWRISUWGUWPQUGWCWDUXLUWJUYIUWSXAXBKXMUXMAUWKUYJCUWTUY
      ACGUWSWAZXCXDWOWOXEXFXGWSUWMUWHUVIAFUWJQUGRZQSRZVKZVEZVEUWGUXBTZUXIUWHVUD
      UWLUWHUVIVUCUWKUWHUVIVUBUWJTZVUCUWKUIUWHUVHVUFUVGUWHUVHVUFUWHUWGWGPZUYFVU
      FUVHUWGWHUYGVUGUYFUDUWJWGPZQWGPZVUFVUGUWIWGPZUYFVUHVUGVUIVUJUSUWGQXHXIUWI
      IXJXKUSUWJQXLXNVDWNWQAFVUBUWJXOXMWRXPVUEUWHUXCVUDUXHUWGUXBUCVSVUEVUCUXGUV
      IUXLVUBTZFVLZUYIUXFTZGVLZVUEVUCUXGUIZVEZFVUBVUAQSVMVNGUXFUXEQUGVMVNVULVUN
      UDVUKVUMUDZGVLZFVLVUPVUKVUMFGWTVURVUPFVUEVUOFVUEFVOVUCUXGFAFVUBVPUXGFVOVR
      VTVUQVUPGVUEVUOGVUEGVOVUCUXGGVUCGVODGUXFVPVRVTVUQVUEADUIZVUOVUQVUEUXLUYIQ
      SRZTZVUSVUEVVAVUQVUBUXFQSRZTZVUEVUAUXFQSVUEUWJUXEQUGVUEUWIUXDISUWGUXBQUGW
      CWDWDWDVUMVUKVUTVVBTVVAVVCUIUYIUXFQSWCUXLVUBVUTVVBXAWMXBLXMVUKAVUCVUMDUXG
      AFVUBWADGUXFWAXCXDWOWOXEXFXGWSXQUWGUVLTZUWHUWDUWLUWEUWGUVLUCVSVVDUVIUWKEU
      XNVVDUVIUDZUWKEUIZVEZUXQUXMVVGFVVEVVFFVVEFVOUWKEFUXREFVOVRVTUXMVVEVVFUXMV
      VEUDZAUWKEUXMUXTVVEUYAWBVVHUXLHTZAEUIUXMVVDUVIVVIUXMVVDUDUVIUXLUVLQUGRZIS
      RZHVVDUXMUWJVVKTUXLVVKTVVDUWIVVJISUWGUVLQUGWCWDUXLUWJVVKWLWMUVGHWGPZUYFVV
      KHTUVHHWHUYGVVLUYFUDZUVLISRZQUGRZHQSRZQUGRZVVKHVVMVVNVVPQUGVVMVVNUVKISRZQ
      SRZVVPVVMUVKWGPZVUIUYFVVNVVSTHIXHZVUIVVMUSXRZVVLUYFXSZUVKQIXTYDVVMVVRHQSH
      IXLWDYAWDVVMUVLWGPZUYFVUIVVOVVKTVVMVVTVWDVWAUVKYBURVWCVWBUVLIQYCYDVVLVVQH
      TZUYFVVLVUIVWEUSHQYEXIWBYFVDWKYGMURVCWNWOWPYHWSUWNUVIBNYIUWPVHPZUXCUWQUXA
      UXHVWFUWQUXCUWPYJZYNVWFUVIUWTUXGVWFUVHUWTUXGVEZUVGVWFUVHVWHVWFUVHUDZUWTDG
      UWSVKZUXGUYKVWIUWTVWJVEZVEZUYNUYJVWLGVWIVWKGVWIGVOUWTVWJGUYQDGUWSVPVTVTUY
      JUYIUCPZUVHUDZIUYIUEUFZUDZCDVEZVEVWLOUYJVWIVWPVWQVWKVWIVWPUYJUWSUCPZUVHUD
      ZIUWSUEUFZUDVWIVWRUVHVWTVWFUWQUVHVWRVWGUWQUWRUCPUVHVWRUWPYKUWRIYOXKXKVWFU
      VHXSVWFUWQQUWPUEUFZUDUVHVWTUWPVIUWQUVHVXAVWTUWQUVHUDVWTVXAUWQUWPUHPZUVOVW
      TVXAUIUVHUWPUJUVPVXBUVOUDZVWTIIQUGRZUGRZUWSVXDUGRZUEUFZVXAVXCUVOUWSUHPZVX
      DUHPZVWTVXGUIVXBUVOXSVXBUWRUHPUVOVXHUWPYLUWRIYMXKUVOVXIVXBIYLYPIUWSVXDUUA
      YDVXBUWPWGPZUYFVXGVXAUIUVOUWPYQIYQVXJUYFUDZVXEQVXFUWPUEUYFVXEQTVXJUYFVXEI
      IUGRZQSRZQUYFVXEVXMTZUYFUYFVUIVXNUSIIQYRYSUUBUYFVXMUVSQUYFVXLUMQSIUUCWDUW
      CUUEYAYPVXKVXFUWSIUGRZQSRZUWRQSRZUWPVXJUYFUWSWGPZVXFVXPTZVXJUWRWGPZUYFVXR
      VXJVUIVXTUSUWPQXHXIZUWRIXJXKVXRUYFVUIVXSUSUWSIQYRYSUUDVXKVXOUWRQSVXJVXTUY
      FVXOUWRTVYAUWRIYEXKWDVXJVXQUWPTZUYFVXJVUIVYBUSUWPQXLXIWBUUFUUGVDUUHVDUUIU
      UJUUKUULUYJVWNVWSVWOVWTUYJVWMVWRUVHUYIUWSUCVSUUMUYIUWSIUEUUPUUNXBUYJVWQVW
      KUYJCUWTDVWJUYTDGUWSWAWSUUQYTUUOWOWPVWIUXFUWSTZUXGVWJUIVWFVXJUYFVYCUVHUWP
      UURUYGVXKUXFUXDQUGRZISRZUWSVXJUXDWGPZUYFUXFVYETZVXJUXBWGPVUIVYFUWPYBUSUXB
      QXHXNVYFUYFVUIVYGUSUXDIQYCYSXKVXJVYEUWSTUYFVXJVYDUWRISVXJUXDUWPQUGVXJVUIU
      XDUWPTUSUWPQYEXIWDWDWBYAVDDGUXFUWSXOURUUSWNWQUUTYTUVAXEWNUVBUVCUVDUVEUVF
      $.
  $}

  ${
    $d x z A $.  $d x ps $.  $d x ch $.  $d x th $.  $d x ta $.  $d y ph $.
    $d x y z B $.
    $( Substitutions. $)
    uzind3OLD.1 $e |- ( x = B -> ( ph <-> ps ) ) $.
    uzind3OLD.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    uzind3OLD.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    uzind3OLD.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind3OLD.5 $e |- ps $.
    $( Induction hypothesis. $)
    uzind3OLD.6 $e |- ( ( B e. ZZ /\ y e. { z e. ZZ | B <_ z } ) ->
                   ( ch -> th ) ) $.
    $( Induction on the set of upper integers that starts at ` B ` .  The first
       four hypotheses give us the substitution instances we need, and the last
       two are the basis and the induction hypothesis.  (Contributed by NM,
       9-Nov-2004.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    uzind3OLD $p |- ( ( B e. ZZ /\ A e. { z e. ZZ | B <_ z } ) -> ta ) $=
      ( cle wbr cz wcel cv crab wa breq2 elrab wi sylan2br an12s anassrs anasss
      uzindOLD sylan2b ) IJHUAZQRZHSUBZTJSTZISTZJIQRZUCEUNURHISUMIJQUDUEUQUPURE
      UQUPUREABCDEFGIJKLMNOGUAZSTZUPJUSQRZCDUFZUPUTVAVBUTVAUCUPUSUOTVBUNVAHUSSU
      MUSJQUDUEPUGUHUIUKUJUHUL $.
  $}

  ${
    $d x y $.  $d A x $.  $d ps x $.  $d ch x $.  $d th x $.  $d ta x $.
    $d ph y $.
    nn0ind.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    nn0ind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nn0ind.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nn0ind.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    nn0ind.5 $e |- ps $.
    nn0ind.6 $e |- ( y e. NN0 -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers.  The first four hypotheses give us the substitution instances
       we need; the last two are the basis and the induction hypothesis.
       (Contributed by NM, 13-May-2004.) $)
    nn0ind $p |- ( A e. NN0 -> ta ) $=
      ( cn0 wcel cz cc0 cle wbr wa elnn0z 0z a1i cv sylbir 3adant1 uzind mp3an1
      wi sylbi ) HOPHQPZRHSTZUAEHUBRQPZULUMEUCABCDEFGRHIJKLBUNMUDGUEZQPZRUOSTZC
      DUJZUNUPUQUAUOOPURUOUBNUFUGUHUIUK $.
  $}

  ${
    $d x y $.  $d A x $.  $d ps x $.  $d ch x $.  $d th x $.  $d ta x $.
    $d ph y $.
    nn0indALT.6 $e |- ( y e. NN0 -> ( ch -> th ) ) $.
    nn0indALT.5 $e |- ps $.
    nn0indALT.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    nn0indALT.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nn0indALT.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nn0indALT.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers.  The last four hypotheses give us the substitution instances
       we need; the first two are the basis and the induction hypothesis.
       Either ~ nn0ind or ~ nn0indALT may be used; see comment for ~ nnind .
       (Contributed by NM, 28-Nov-2005.) $)
    nn0indALT $p |- ( A e. NN0 -> ta ) $=
      ( nn0ind ) ABCDEFGHKLMNJIO $.
  $}

  ${
    $d K x $.  $d M x y $.  $d N x y $.  $d ch x $.  $d ph y $.  $d ps x $.
    $d ta x $.  $d th x $.
    fzind.1 $e |- ( x = M -> ( ph <-> ps ) ) $.
    fzind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    fzind.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    fzind.4 $e |- ( x = K -> ( ph <-> ta ) ) $.
    fzind.5 $e |- ( ( M e. ZZ /\ N e. ZZ /\ M <_ N ) -> ps ) $.
    fzind.6 $e |- ( ( ( M e. ZZ /\ N e. ZZ ) /\
                      ( y e. ZZ /\ M <_ y /\ y < N ) ) -> ( ch -> th ) ) $.
    $( Induction on the integers from ` M ` to ` N ` inclusive .  The first
       four hypotheses give us the substitution instances we need; the last two
       are the basis and the induction hypothesis.  (Contributed by Paul
       Chapman, 31-Mar-2011.) $)
    fzind $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\
                    ( K e. ZZ /\ M <_ K /\ K <_ N ) ) -> ta ) $=
      ( cle wbr wa wi cz wcel w3a cv c1 caddc co breq1 anbi2d imbi12d 3expib cr
      wceq zre p1le 3expia syl2an imdistanda imim1d 3ad2ant2 wb zltp1le adantlr
      clt expcom pm5.32d adantl 3expa com12 sylbird ex com23 exp3a 3impib imp3a
      a2d syld uzind 3expb 3impia impcom ) HUAUBZIHQRZHJQRZUCZIUAUBZJUAUBZSZEWE
      WFWGEWBWCWDWFWGETZTWBWCSZWFWDWIWFWJWDWITZWFWBWCWKWFWBWCUCZWGWDEWLWGWDEWGF
      UDZJQRZSZATWGIJQRZSZBTWGGUDZJQRZSZCTZWGWRUEUFUGZJQRZSZDTZWGWDSZETFGIHWMIU
      MZWOWQABXGWNWPWGWMIJQUHUIKUJWMWRUMZWOWTACXHWNWSWGWMWRJQUHUILUJWMXBUMZWOXD
      ADXIWNXCWGWMXBJQUHUIMUJWMHUMZWOXFAEXJWNWDWGWMHJQUHUINUJWFWGWPBOUKWFWRUAUB
      ZIWRQRZUCZXAXDCTZXEXKWFXAXNTXLXKXDWTCXKWGXCWSXKWRULUBZJULUBZXCWSTWGWRUNJU
      NXOXPXCWSWRJUOUPUQURUSUTXMXDCDXMWGXCCDTZXMXCWGXQWFXKXLXCWGXQTZTWFXKXLSZXC
      XRWFWGXSXCSZXQWFWGXTXQTWHXTXSWRJVDRZSZXQWGYBXTVAWFWGXSYAXCXSWGYAXCVAZXKWG
      YCXLWRJVBVCVEVFVGYBWHXQXKXLYAWHXQTWHXKXLYAUCXQPVEVHVIVJVKVLVMVNVLVOVPVQVR
      VMVLVSVEVLVTVOWA $.
  $}

  ${
    $d K x $.  $d M x y $.  $d N x y $.  $d ch x $.  $d ph y $.  $d ps x $.
    $d ta x $.  $d th x $.
    fnn0ind.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    fnn0ind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    fnn0ind.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    fnn0ind.4 $e |- ( x = K -> ( ph <-> ta ) ) $.
    fnn0ind.5 $e |- ( N e. NN0 -> ps ) $.
    fnn0ind.6 $e |- ( ( N e. NN0 /\ y e. NN0 /\ y < N ) -> ( ch -> th ) ) $.
    $( Induction on the integers from ` 0 ` to ` N ` inclusive .  The first
       four hypotheses give us the substitution instances we need; the last two
       are the basis and the induction hypothesis.  (Contributed by Paul
       Chapman, 31-Mar-2011.) $)
    fnn0ind $p |- ( ( N e. NN0 /\ K e. NN0 /\ K <_ N ) -> ta ) $=
      ( wcel wbr wa cc0 wi cn0 cle cz elnn0z w3a nn0z 0z sylbir 3adant1 clt zre
      cv cr 0re lelttr ltle 3adant2 mp3an1 syl2an ex com23 3impib impcom anbi1i
      syld 3expb syl2anbr expcom 3impa exp3a mpd fzind mpanl1 syl5 3expa sylanb
      adantll 3impb ) IUAPZHUAPZHIUBQZEVTWARVSEVTHUCPZSHUBQZRWAVSETZHUDWBWCWAWD
      VSIUCPZWBWCWAUEZEIUFWEWFESUCPZWEWFEUGABCDEFGHSIJKLMWESIUBQZBWGWEWHRZVSBIU
      DZNUHUIWEGULZUCPZSWKUBQZWKIUJQZUEZCDTZWGWEWORWHWPWOWEWHWLWMWNWEWHTWLWEWMW
      NRZWHWLWEWQWHTZWLWKUMPZIUMPZWRWEWKUKIUKSUMPZWSWTWRUNXAWSWTUEWQSIUJQZWHSWK
      IUOXAWTXBWHTWSSIUPUQVEURUSUTVAVBVCWOWEWHWPTWOWEWHWPWLWMWNWIWPTWIWLWMRZWNR
      ZWPWIVSWKUAPZWNRWPXDWJXEXCWNWKUDVDVSXEWNWPOVFVGVHVIVJVCVKVQVLVMVHVNVOVPVC
      VR $.
  $}

  ${
    $d x y z $.  $d A x z $.  $d ps x z $.  $d ch x z $.  $d th x z $.
    $d ta x z $.  $d ph y z $.
    nn0ind-raph.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    nn0ind-raph.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nn0ind-raph.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nn0ind-raph.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    nn0ind-raph.5 $e |- ps $.
    nn0ind-raph.6 $e |- ( y e. NN0 -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers.  The first four hypotheses give us the substitution instances
       we need; the last two are the basis and the induction hypothesis.  Raph
       Levien remarks:  "This seems a bit painful.  I wonder if an explicit
       substitution version would be easier."  (Contributed by Raph Levien,
       10-Apr-2004.) $)
    nn0ind-raph $p |- ( A e. NN0 -> ta ) $=
      ( vz wcel cc0 wceq c1 wi cn0 cn wo elnn0 wsb wsbc dfsbcq2 cv sbhypf caddc
      nfv co nfsbc1v 1ex c0ex wa 0nn0 eleq1a ax-mp mpbiri eqeq2 syl6bir pm5.74d
      wb mpbii com12 vtocle sylc adantr oveq1 0p1e1 syl6eq eqeq2d imp mpbird ex
      sbceq1a mpbid vtoclef nnnn0 syl nnind bicomd sylan9bb sylbird eqcoms jaoi
      eqeq1 sylbi ) HUAPHUBPZHQRZUCEHUDWJEWKAFOUEAFSUFZCDEOGHAFOSUGACFOGUHZCFUK
      JUIADFOWMSUJULZDFUKKUIAEFOHEFUKLUIWLFSAFSUMUNFUHZSRZAWLWPATGQUOWMQRZWPAWQ
      WPUPADWQDWPWQWMUAPZCDQUAPWQWRTUQQUAWMURUSWQCTFQUOWQWOQRZCWQWSATWSCTWSABMI
      UTWQWSACWQWSWOWMRACVDWMQWOVAJVBVCVEVFVGNVHVIWQWPADVDZWQWPWOWNRWTWQWNSWOWQ
      WNQSUJULSWMQSUJVJVKVLVMKVBVNVOVPVGAFSVQVRVSWMUBPWRCDTWMVTNWAWBEQHQHRZETZF
      QXBFUKUOWSXAWOHRZEWOQHWHWSXCEWSXCUPBEMWSBAXCEWSABIWCLWDVEVPWEVSWFWGWI $.
  $}

  ${
    $d A x $.  $d ch x $.  $d et x $.  $d ph y $.  $d ps x $.  $d ta x $.
    $d th x $.  $d x y ze $.
    zindd.1 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    zindd.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    zindd.3 $e |- ( x = ( y + 1 ) -> ( ph <-> ta ) ) $.
    zindd.4 $e |- ( x = -u y -> ( ph <-> th ) ) $.
    zindd.5 $e |- ( x = A -> ( ph <-> et ) ) $.
    zindd.6 $e |- ( ze -> ps ) $.
    zindd.7 $e |- ( ze -> ( y e. NN0 -> ( ch -> ta ) ) ) $.
    zindd.8 $e |- ( ze -> ( y e. NN -> ( ch -> th ) ) ) $.
    $( Principle of Mathematical Induction on all integers, deduction version.
       The first five hypotheses give the substitutions; the last three are the
       basis, the induction, and the extension to negative numbers.
       (Contributed by Paul Chapman, 17-Apr-2009.)  (Proof shortened by Mario
       Carneiro, 4-Jan-2017.) $)
    zindd $p |- ( ze -> ( A e. ZZ -> et ) ) $=
      ( cz wcel wral wi cv cneg cn0 cn wo cr znegcl elznn0nn sylib simpr orim2i
      wa syl zcn negnegd eleq1d orbi2d mpbid cc0 wceq imbi2d c1 caddc com12 a2d
      co nn0ind nnnn0 mpdd jaod syl5 ralrimiv wb sylan9eqr eqcomd bicomd rspcdv
      negeq rspccv 3syl ) GDISUAZAHSUAJSTFUBGDISIUCZSTZWDUDZUETZWDUFTZUGZGDWEWG
      WFUDZUFTZUGZWIWEWGWFUHTZWKUNZUGZWLWEWFSTWOWDUIWFUJUKWNWKWGWMWKULUMUOWEWKW
      HWGWEWJWDUFWEWDWDUPUQURUSUTGWGDWHWGGDGAUBZGBUBZGCUBZGEUBZGDUBHIWFHUCZVAVB
      ABGKVCZWTWDVBACGLVCZWTWDVDVEVHVBAEGMVCZWTWFVBZADGNVCPWDUETZGCEGXECEUBQVFV
      GZVIVFGWHCDWHGCWHXEWRWDVJWPWQWRWSWRHIWDXAXBXCXBPXFVIUOVFRVKVLVMVNWCAHSWTS
      TZWCAXGDAIWTUDZSWTUIXGWDXHVBZUNZADXJXDADVOXJWFWTXIXGWFXHUDWTWDXHVTXGWTWTU
      PUQVPVQNUOVRVSVFVNAFHJSOWAWB $.
  $}

  ${
    $d x z A $.  $d y A $.
    $( Any real number can be sandwiched between two integers.  Exercise 2 of
       [Apostol] p. 28.  (Contributed by NM, 10-Nov-2004.) $)
    btwnz $p |- ( A e. RR -> ( E. x e. ZZ x < A /\ E. y e. ZZ A < y ) ) $=
      ( vz cr wcel cv clt wbr cz wrex cneg cn renegcl arch wa wb nnre ltnegcon1
      syl ex pm5.32d nnnegz breq1 rspcev sylan syl6bi exp3a rexlimdv mpd anim1i
      syl5 nnz reximi2 jca ) CEFZAGZCHIZAJKZCBGZHIZBJKZUPCLZDGZHIZDMKZUSUPVCEFV
      FCNVCDOTUPVEUSDMUPVDMFZVEUSUPVGVEPVGVDLZCHIZPUSUPVGVEVIVGVDEFZUPVEVIQZVDR
      UPVJVKCVDSUAULUBVGVHJFVIUSVDUCURVIAVHJUQVHCHUDUEUFUGUHUIUJUPVABMKVBCBOVAV
      ABMJUTMFUTJFVAUTUMUKUNTUO $.
  $}

  ${
    nn0zd.1 $e |- ( ph -> A e. NN0 ) $.
    $( A natural number is an integer.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    nn0zd $p |- ( ph -> A e. ZZ ) $=
      ( cn0 cz nn0ssz sseldi ) ADEBFCG $.
  $}

  ${
    nnzd.1 $e |- ( ph -> A e. NN ) $.
    $( A nonnegative integer is an integer.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    nnzd $p |- ( ph -> A e. ZZ ) $=
      ( nnnn0d nn0zd ) ABABCDE $.
  $}

  ${
    zred.1 $e |- ( ph -> A e. ZZ ) $.
    $( An integer is a real number.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    zred $p |- ( ph -> A e. RR ) $=
      ( cz cr zssre sseldi ) ADEBFCG $.

    $( An integer is a complex number.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    zcnd $p |- ( ph -> A e. CC ) $=
      ( zred recnd ) ABABCDE $.

    $( Closure law for negative integers.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    znegcld $p |- ( ph -> -u A e. ZZ ) $=
      ( cz wcel cneg znegcl syl ) ABDEBFDECBGH $.

    $( Deduction from second Peano postulate generalized to integers.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    peano2zd $p |- ( ph -> ( A + 1 ) e. ZZ ) $=
      ( cz wcel c1 caddc co peano2z syl ) ABDEBFGHDECBIJ $.

    zaddcld.1 $e |- ( ph -> B e. ZZ ) $.
    $( Closure of addition of integers.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    zaddcld $p |- ( ph -> ( A + B ) e. ZZ ) $=
      ( cz wcel caddc co zaddcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure of subtraction of integers.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    zsubcld $p |- ( ph -> ( A - B ) e. ZZ ) $=
      ( cz wcel cmin co zsubcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure of multiplication of integers.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    zmulcld $p |- ( ph -> ( A x. B ) e. ZZ ) $=
      ( cz wcel cmul co zmulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                               Decimal arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ; $.
  $( Constant used for decimal constructor. $)
  cdc $a class ; A B $.

  $( Define the "decimal constructor", which is used to build up "decimal
     integers" or "numeric terms" in base 10.  For example,
     ` ( ; ; ; 1 0 0 0 + ; ; ; 2 0 0 0 ) = ; ; ; 3 0 0 0 ` ~ 1kp2ke3k .
     (Contributed by Mario Carneiro, 17-Apr-2015.) $)
  df-dec $a |- ; A B = ( ( 10 x. A ) + B ) $.

  $( A decimal number is a set.  (Contributed by Mario Carneiro,
     17-Apr-2015.) $)
  decex $p |- ; A B e. _V $=
    ( cdc c10 cmul co caddc cvv df-dec ovex eqeltri ) ABCDAEFZBGFHABILBGJK $.

  $( Equality theorem for the decimal constructor.  (Contributed by Mario
     Carneiro, 17-Apr-2015.) $)
  deceq1 $p |- ( A = B -> ; A C = ; B C ) $=
    ( wceq c10 cmul co caddc cdc oveq2 oveq1d df-dec 3eqtr4g ) ABDZEAFGZCHGEBFG
    ZCHGACIBCINOPCHABEFJKACLBCLM $.

  $( Equality theorem for the decimal constructor.  (Contributed by Mario
     Carneiro, 17-Apr-2015.) $)
  deceq2 $p |- ( A = B -> ; C A = ; C B ) $=
    ( wceq c10 cmul co caddc cdc oveq2 df-dec 3eqtr4g ) ABDECFGZAHGMBHGCAICBIAB
    MHJCAKCBKL $.

  ${
    deceq1i.1 $e |- A = B $.
    $( Equality theorem for the decimal constructor.  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    deceq1i $p |- ; A C = ; B C $=
      ( wceq cdc deceq1 ax-mp ) ABEACFBCFEDABCGH $.

    $( Equality theorem for the decimal constructor.  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    deceq2i $p |- ; C A = ; C B $=
      ( wceq cdc deceq2 ax-mp ) ABECAFCBFEDABCGH $.

    deceq12i.2 $e |- C = D $.
    $( Equality theorem for the decimal constructor.  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    deceq12i $p |- ; A C = ; B D $=
      ( cdc deceq1i deceq2i eqtri ) ACGBCGBDGABCEHCDBFIJ $.
  $}

  ${
    numnncl.1 $e |- T e. NN0 $.
    numnncl.2 $e |- A e. NN0 $.
    ${
      numnncl.3 $e |- B e. NN $.
      $( Closure for a numeral (with units place).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      numnncl $p |- ( ( T x. A ) + B ) e. NN $=
        ( cmul co cn0 wcel cn caddc nn0mulcli nn0nnaddcl mp2an ) CAGHZIJBKJPBLH
        KJCADEMFPBNO $.
    $}

    $( Add a zero in the units place.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    num0u $p |- ( T x. A ) = ( ( T x. A ) + 0 ) $=
      ( cmul co cc0 caddc nn0mulcli nn0cni addid1i eqcomi ) BAEFZGHFMMMBACDIJKL
      $.

    $( Add a zero in the higher places.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    num0h $p |- A = ( ( T x. 0 ) + A ) $=
      ( cc0 cmul co caddc nn0cni mul01i oveq1i addid2i eqtr2i ) BEFGZAHGEAHGANE
      AHBBCIJKAADILM $.

    numcl.2 $e |- B e. NN0 $.
    $( Closure for a decimal integer (with units place).  (Contributed by Mario
       Carneiro, 18-Feb-2014.) $)
    numcl $p |- ( ( T x. A ) + B ) e. NN0 $=
      ( cmul co nn0mulcli nn0addcli ) CAGHBCADEIFJ $.

    numsuc.4 $e |- ( B + 1 ) = C $.
    numsuc.5 $e |- N = ( ( T x. A ) + B ) $.
    $( The successor of a decimal integer (no carry).  (Contributed by Mario
       Carneiro, 18-Feb-2014.) $)
    numsuc $p |- ( N + 1 ) = ( ( T x. A ) + C ) $=
      ( c1 caddc co cmul oveq1i nn0mulcli nn0cni ax-1cn addassi oveq2i 3eqtri )
      EKLMDANMZBLMZKLMUBBKLMZLMUBCLMEUCKLJOUBBKUBDAFGPQBHQRSUDCUBLITUA $.
  $}

  ${
    decnncl.1 $e |- A e. NN0 $.
    decnncl.2 $e |- B e. NN $.
    $( Closure for a numeral.  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    decnncl $p |- ; A B e. NN $=
      ( cdc c10 cmul co caddc cn df-dec 10nn0 numnncl eqeltri ) ABEFAGHBIHJABKA
      BFLCDMN $.
  $}

  ${
    deccl.1 $e |- A e. NN0 $.
    deccl.2 $e |- B e. NN0 $.
    $( Closure for a numeral.  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    deccl $p |- ; A B e. NN0 $=
      ( cdc c10 cmul co caddc cn0 df-dec 10nn0 numcl eqeltri ) ABEFAGHBIHJABKAB
      FLCDMN $.
  $}

  ${
    dec0u.1 $e |- A e. NN0 $.
    $( Add a zero in the units place.  (Contributed by Mario Carneiro,
       17-Apr-2015.) $)
    dec0u $p |- ( 10 x. A ) = ; A 0 $=
      ( c10 cmul co cc0 caddc cdc 10nn0 num0u df-dec eqtr4i ) CADEZMFGEAFHACIBJ
      AFKL $.

    $( Add a zero in the higher places.  (Contributed by Mario Carneiro,
       17-Apr-2015.) $)
    dec0h $p |- A = ; 0 A $=
      ( c10 cc0 cmul co caddc cdc 10nn0 num0h df-dec eqtr4i ) ACDEFAGFDAHACIBJD
      AKL $.
  $}

  ${
    numnncl2.1 $e |- T e. NN $.
    numnncl2.2 $e |- A e. NN $.
    $( Closure for a decimal integer (zero units place).  (Contributed by Mario
       Carneiro, 9-Mar-2015.) $)
    numnncl2 $p |- ( ( T x. A ) + 0 ) e. NN $=
      ( cmul co cc0 caddc cn nnmulcli nncni addid1i eqeltri ) BAEFZGHFNINNBACDJ
      ZKLOM $.
  $}

  ${
    decnncl2.1 $e |- A e. NN $.
    $( Closure for a decimal integer (zero units place).  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    decnncl2 $p |- ; A 0 e. NN $=
      ( cc0 cdc c10 cmul co caddc cn df-dec 10nn numnncl2 eqeltri ) ACDEAFGCHGI
      ACJAEKBLM $.
  $}

  ${
    numlt.1 $e |- T e. NN $.
    numlt.2 $e |- A e. NN0 $.
    numlt.3 $e |- B e. NN0 $.
    ${
      numlt.4 $e |- C e. NN $.
      numlt.5 $e |- B < C $.
      $( Comparing two decimal integers (equal higher places).  (Contributed by
         Mario Carneiro, 18-Feb-2014.) $)
      numlt $p |- ( ( T x. A ) + B ) < ( ( T x. A ) + C ) $=
        ( clt wbr cmul co caddc nn0rei nnrei nnnn0i nn0mulcli ltadd2i mpbi ) BC
        JKDALMZBNMUACNMJKIBCUABGOCHPUADADEQFROST $.
    $}

    numltc.3 $e |- C e. NN0 $.
    numltc.4 $e |- D e. NN0 $.
    numltc.5 $e |- C < T $.
    numltc.6 $e |- A < B $.
    $( Comparing two decimal integers (unequal higher places).  (Contributed by
       Mario Carneiro, 18-Feb-2014.) $)
    numltc $p |- ( ( T x. A ) + C ) < ( ( T x. B ) + D ) $=
      ( cmul co caddc clt wbr cle nn0rei wcel numlt nnrei ax-1cn adddii mulid1i
      c1 recni oveq2i eqtri breqtrri cn0 wb nn0ltp1le mp2an cc0 nngt0i peano2re
      mpbi cr ax-mp lemul2i remulcli readdcli ltletri nn0addge1i ) EAMNZCONZEBM
      NZPQZVHVHDONZRQVGVJPQVGEAUFONZMNZPQVLVHRQZVIVGVFEONZVLPACEEFGIFKUAVLVFEUF
      MNZONVNEAUFEEFUBZUGZAAGSZUGUCUDVOEVFOEVQUEUHUIUJVKBRQZVMABPQZVSLAUKTBUKTV
      TVSULGHABUMUNURUOEPQVSVMULEFUPVKBEAUSTVKUSTVRAUQUTZBHSZVPVAUTURVGVLVHVFCE
      AVPVRVBCISVCZEVKVPWAVBEBVPWBVBZVDUNVHDWDJVEVGVHVJWCWDVHDWDDJSVCVDUN $.
  $}

  ${
    declt.1 $e |- A e. NN0 $.
    declt.2 $e |- B e. NN0 $.
    ${
      declt.3 $e |- C e. NN $.
      declt.4 $e |- B < C $.
      $( Comparing two decimal integers (equal higher places).  (Contributed by
         Mario Carneiro, 17-Apr-2015.) $)
      declt $p |- ; A B < ; A C $=
        ( c10 cmul co caddc cdc clt 10nn numlt df-dec 3brtr4i ) HAIJZBKJRCKJABL
        ACLMABCHNDEFGOABPACPQ $.
    $}

    ${
      decltc.3 $e |- C e. NN0 $.
      decltc.4 $e |- D e. NN0 $.
      decltc.5 $e |- C < 10 $.
      decltc.6 $e |- A < B $.
      $( Comparing two decimal integers (unequal higher places).  (Contributed
         by Mario Carneiro, 18-Feb-2014.) $)
      decltc $p |- ; A C < ; B D $=
        ( c10 cmul co caddc cdc clt 10nn numltc df-dec 3brtr4i ) KALMCNMKBLMDNM
        ACOBDOPABCDKQEFGHIJRACSBDST $.
    $}

    decsuc.3 $e |- ( B + 1 ) = C $.
    decsuc.4 $e |- N = ; A B $.
    $( The successor of a decimal integer (no carry).  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    decsuc $p |- ( N + 1 ) = ; A C $=
      ( c1 caddc co c10 cmul cdc 10nn0 df-dec eqtri numsuc eqtr4i ) DIJKLAMKZCJ
      KACNABCLDOEFGDABNTBJKHABPQRACPS $.
  $}

  ${
    numlti.1 $e |- T e. NN $.
    numlti.2 $e |- A e. NN $.
    numlti.3 $e |- B e. NN0 $.
    numlti.4 $e |- C e. NN0 $.
    numlti.5 $e |- C < T $.
    $( Comparing a digit to a decimal integer.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    numlti $p |- C < ( ( T x. A ) + B ) $=
      ( cc0 cmul co caddc clt nnnn0i num0h 0nn0 nngt0i numltc eqbrtri ) CDJKLCM
      LDAKLBMLNCDDEOHPJACBDEQAFOHGIAFRST $.
  $}

  ${
    declti.1 $e |- A e. NN $.
    declti.2 $e |- B e. NN0 $.
    declti.3 $e |- C e. NN0 $.
    declti.4 $e |- C < 10 $.
    $( Comparing a digit to a decimal integer.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    declti $p |- C < ; A B $=
      ( c10 cmul co caddc cdc clt 10nn numlti df-dec breqtrri ) CHAIJBKJABLMABC
      HNDEFGOABPQ $.
  $}

  ${
    numsucc.1 $e |- Y e. NN0 $.
    numsucc.2 $e |- T = ( Y + 1 ) $.
    numsucc.3 $e |- A e. NN0 $.
    numsucc.4 $e |- ( A + 1 ) = B $.
    numsucc.5 $e |- N = ( ( T x. A ) + Y ) $.
    $( The successor of a decimal integer (with carry).  (Contributed by Mario
       Carneiro, 18-Feb-2014.) $)
    numsucc $p |- ( N + 1 ) = ( ( T x. B ) + 0 ) $=
      ( c1 caddc co cmul cc0 cn0 1nn0 nn0addcli nn0cni oveq2i 3eqtr4ri eqeltrri
      eqeltri mulid1i ax-1cn adddii eqcomi numsuc num0u 3eqtri ) DKLMZCAKLMZNMZ
      CBNMZUNOLMCANMZCKNMZLMUOCLMUMUKUPCUOLCCCEKLMZPGEKFQRUCZSZUDTCAKUSAHSUEUFA
      ECCDURHFCUQGUGJUHUAULBCNITBCURULBPIAKHQRUBUIUJ $.
  $}

  ${
    decsucc.1 $e |- A e. NN0 $.
    decsucc.2 $e |- ( A + 1 ) = B $.
    decsucc.3 $e |- N = ; A 9 $.
    $( The successor of a decimal integer (with carry).  (Contributed by Mario
       Carneiro, 18-Feb-2014.) $)
    decsucc $p |- ( N + 1 ) = ; B 0 $=
      ( c1 caddc co c10 cmul cc0 cdc c9 9nn0 df-10 df-dec eqtri numsucc eqtr4i
      ) CGHIJBKILHIBLMABJCNOPDECANMJAKINHIFANQRSBLQT $.
  $}

  $( The successor of zero.  (Contributed by Mario Carneiro, 18-Feb-2014.) $)
  1e0p1 $p |- 1 = ( 0 + 1 ) $=
    ( cc0 c1 caddc co 0p1e1 eqcomi ) ABCDBEF $.

  $( Ten plus an integer.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  dec10p $p |- ( 10 + A ) = ; 1 A $=
    ( c1 cdc c10 cmul co caddc df-dec 10nn nncni mulid1i oveq1i eqtr2i ) BACDBE
    FZAGFDAGFBAHNDAGDDIJKLM $.

  $( The decimal form of 10.  NB:  In our presentations of large numbers later
     on, we will use our symbol for 10 at the highest digits when advantageous,
     because we can use this theorem to convert back to "long form" (where each
     digit is in the range 0-9) with no extra effort.  However, we _cannot_ do
     this for lower digits while maintaining the ease of use of the decimal
     system, since it requires nontrivial number knowledge (more than just
     equality theorems) to convert back.  (Contributed by Mario Carneiro,
     18-Feb-2014.) $)
  dec10 $p |- 10 = ; 1 0 $=
    ( c10 cc0 caddc co c1 cdc 10nn nncni addid1i dec10p eqtr3i ) ABCDAEBFAAGHIB
    JK $.

  ${
    numma.1 $e |- T e. NN0 $.
    numma.2 $e |- A e. NN0 $.
    numma.3 $e |- B e. NN0 $.
    numma.4 $e |- C e. NN0 $.
    numma.5 $e |- D e. NN0 $.
    numma.6 $e |- M = ( ( T x. A ) + B ) $.
    numma.7 $e |- N = ( ( T x. C ) + D ) $.
    ${
      numma.8 $e |- P e. NN0 $.
      numma.9 $e |- ( ( A x. P ) + C ) = E $.
      numma.10 $e |- ( ( B x. P ) + D ) = F $.
      $( Perform a multiply-add of two decimal integers ` M ` and ` N ` against
         a fixed multiplicand ` P ` (no carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      numma $p |- ( ( M x. P ) + N ) = ( ( T x. E ) + F ) $=
        ( cmul caddc oveq1i oveq12i nn0cni mulcli adddii mulassi eqtr4i adddiri
        co add4i oveq2i 3eqtr2i ) IEUAUKZJUBUKFAUAUKZBUBUKZEUAUKZFCUAUKZDUBUKZU
        BUKZFAEUAUKZCUBUKZUAUKZBEUAUKZDUBUKZUBUKZFGUAUKZHUBUKUOURJUTUBIUQEUAPUC
        QUDVGUPEUAUKZUSUBUKZVFUBUKZVAVDVJVFUBVDFVBUAUKZUSUBUKVJFVBCFKUEZAEALUEZ
        ERUEZUFCNUEZUGVIVLUSUBFAEVMVNVOUHUCUIUCVAVIVEUBUKZUTUBUKVKURVQUTUBUPBEF
        AVMVNUFZBMUEZVOUJUCVIUSVEDUPEVRVOUFFCVMVPUFBEVSVOUFDOUEULUIUIVDVHVFHUBV
        CGFUASUMTUDUN $.
    $}

    ${
      nummac.8 $e |- P e. NN0 $.
      nummac.9 $e |- F e. NN0 $.
      nummac.10 $e |- G e. NN0 $.
      nummac.11 $e |- ( ( A x. P ) + ( C + G ) ) = E $.
      nummac.12 $e |- ( ( B x. P ) + D ) = ( ( T x. G ) + F ) $.
      $( Perform a multiply-add of two decimal integers ` M ` and ` N ` against
         a fixed multiplicand ` P ` (with carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      nummac $p |- ( ( M x. P ) + N ) = ( ( T x. E ) + F ) $=
        ( cmin co cmul caddc nn0cni mulcli addassi eqtri addcli eqeltrri subdii
        oveq1i wceq subadd2i mpbir eqcomi numma wcel npcan mp2an subcli 3eqtr4i
        cc eqtr3i ) FGIUDUEZUFUEZFIUFUEZHUGUEZUGUEFGUFUEZVJUDUEZVKUGUEZJEUFUEKU
        GUEVLHUGUEZVIVMVKUGFGIFLUHZAEUFUEZCUGUEZIUGUEZGVFVSVQCIUGUEUGUEGVQCIAEA
        MUHESUHUIZCOUHZIUAUHZUJUBUKZVRIVQCVTWAULZWBULUMZWBUNUOABCDEFVHVKJKLMNOP
        QRSVHVRVHVRUPVSGUPWCGIVRWEWBWDUQURUSUCUTVMVJUGUEZHUGUEVOVNWFVLHUGVLVFVA
        VJVFVAWFVLUPFGVPWEUIZFIVPWBUIZVLVJVBVCUOVMVJHVLVJWGWHVDWHHTUHUJVGVE $.
    $}

    ${
      numma2c.8 $e |- P e. NN0 $.
      numma2c.9 $e |- F e. NN0 $.
      numma2c.10 $e |- G e. NN0 $.
      numma2c.11 $e |- ( ( P x. A ) + ( C + G ) ) = E $.
      numma2c.12 $e |- ( ( P x. B ) + D ) = ( ( T x. G ) + F ) $.
      $( Perform a multiply-add of two decimal integers ` M ` and ` N ` against
         a fixed multiplicand ` P ` (with carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      numma2c $p |- ( ( P x. M ) + N ) = ( ( T x. E ) + F ) $=
        ( cmul co caddc nn0cni cn0 numcl eqeltri mulcomi oveq1i eqtri nummac )
        EJUDUEZKUFUEJEUDUEZKUFUEFGUDUEHUFUEUOUPKUFEJESUGZJJFAUDUEBUFUEUHQABFLMN
        UIUJUGUKULABCDEFGHIJKLMNOPQRSTUAAEUDUEZCIUFUEZUFUEEAUDUEZUSUFUEGURUTUSU
        FAEAMUGUQUKULUBUMBEUDUEZDUFUEEBUDUEZDUFUEFIUDUEHUFUEVAVBDUFBEBNUGUQUKUL
        UCUMUNUM $.
    $}

    ${
      numadd.8 $e |- ( A + C ) = E $.
      numadd.9 $e |- ( B + D ) = F $.
      $( Add two decimal integers ` M ` and ` N ` (no carry).  (Contributed by
         Mario Carneiro, 18-Feb-2014.) $)
      numadd $p |- ( M + N ) = ( ( T x. E ) + F ) $=
        ( co caddc c1 cmul numcl eqeltri nn0cni mulid1i oveq1i 1nn0 eqtri numma
        cn0 eqtr3i ) HUAUBSZITSHITSEFUBSGTSUMHITHHHEAUBSBTSUKOABEJKLUCUDUEUFUGA
        BCDUAEFGHIJKLMNOPUHAUAUBSZCTSACTSFUNACTAAKUEUFUGQUIBUAUBSZDTSBDTSGUOBDT
        BBLUEUFUGRUIUJUL $.
    $}

    ${
      numaddc.8 $e |- F e. NN0 $.
      numaddc.9 $e |- ( ( A + C ) + 1 ) = E $.
      numaddc.10 $e |- ( B + D ) = ( ( T x. 1 ) + F ) $.
      $( Add two decimal integers ` M ` and ` N ` (with carry).  (Contributed
         by Mario Carneiro, 18-Feb-2014.) $)
      numaddc $p |- ( M + N ) = ( ( T x. E ) + F ) $=
        ( co c1 cmul caddc cn0 numcl eqeltri nn0cni mulid1i oveq1i 1nn0 addassi
        ax-1cn 3eqtr2i eqtri nummac eqtr3i ) HUAUBTZIUCTHIUCTEFUBTGUCTUQHIUCHHH
        EAUBTBUCTUDOABEJKLUEUFUGUHUIABCDUAEFGUAHIJKLMNOPUJQUJAUAUBTZCUAUCTZUCTA
        USUCTACUCTUAUCTFURAUSUCAAKUGZUHUIACUAUTCMUGULUKRUMBUAUBTZDUCTBDUCTEUAUB
        TGUCTVABDUCBBLUGUHUISUNUOUP $.
    $}
  $}

  ${
    nummul1c.1 $e |- T e. NN0 $.
    nummul1c.2 $e |- P e. NN0 $.
    nummul1c.3 $e |- A e. NN0 $.
    nummul1c.4 $e |- B e. NN0 $.
    nummul1c.5 $e |- N = ( ( T x. A ) + B ) $.
    nummul1c.6 $e |- D e. NN0 $.
    nummul1c.7 $e |- E e. NN0 $.
    ${
      nummul1c.8 $e |- ( ( A x. P ) + E ) = C $.
      nummul1c.9 $e |- ( B x. P ) = ( ( T x. E ) + D ) $.
      $( The product of a decimal integer with a number.  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      nummul1c $p |- ( N x. P ) = ( ( T x. C ) + D ) $=
        ( co cc0 caddc cmul cn0 numcl eqeltri num0u num0h nn0cni addid2i oveq2i
        0nn0 eqtri eqtr3i nummac ) HEUARZUNSTRFCUARDTREHHFAUARBTRUBMABFIKLUCUDJ
        UEABSSEFCDGHSIKLUJUJMSFIUJUFJNOAEUARZSGTRZTRUOGTRCUPGUOTGGOUGUHUIPUKBEU
        ARZUQSTRFGUARDTREBLJUEQULUMUK $.
    $}

    ${
      nummul2c.7 $e |- ( ( P x. A ) + E ) = C $.
      nummul2c.8 $e |- ( P x. B ) = ( ( T x. E ) + D ) $.
      $( The product of a decimal integer with a number (with carry).
         (Contributed by Mario Carneiro, 18-Feb-2014.) $)
      nummul2c $p |- ( P x. N ) = ( ( T x. C ) + D ) $=
        ( cmul co caddc cn0 numcl eqeltri nn0cni oveq1i eqtri mulcomli nummul1c
        mulcomi ) HEFCRSDTSHHFARSBTSUAMABFIKLUBUCUDEJUDZABCDEFGHIJKLMNOAERSZGTS
        EARSZGTSCUKULGTAEAKUDUJUIUEPUFEBFGRSDTSUJBLUDQUGUHUG $.
    $}
  $}

  ${
    decma.1 $e |- A e. NN0 $.
    decma.2 $e |- B e. NN0 $.
    decma.3 $e |- C e. NN0 $.
    decma.4 $e |- D e. NN0 $.
    decma.5 $e |- M = ; A B $.
    decma.6 $e |- N = ; C D $.
    ${
      decma.7 $e |- P e. NN0 $.
      decma.8 $e |- ( ( A x. P ) + C ) = E $.
      decma.9 $e |- ( ( B x. P ) + D ) = F $.
      $( Perform a multiply-add of two numerals ` M ` and ` N ` against a fixed
         multiplicand ` P ` (no carry).  (Contributed by Mario Carneiro,
         18-Feb-2014.) $)
      decma $p |- ( ( M x. P ) + N ) = ; E F $=
        ( cmul co caddc c10 cdc 10nn0 df-dec eqtri numma eqtr4i ) HESTIUATUBFST
        GUATFGUCABCDEUBFGHIUDJKLMHABUCUBASTBUATNABUEUFICDUCUBCSTDUATOCDUEUFPQRU
        GFGUEUH $.
    $}

    ${
      decmac.7 $e |- P e. NN0 $.
      decmac.8 $e |- F e. NN0 $.
      decmac.9 $e |- G e. NN0 $.
      decmac.10 $e |- ( ( A x. P ) + ( C + G ) ) = E $.
      decmac.11 $e |- ( ( B x. P ) + D ) = ; G F $.
      $( Perform a multiply-add of two numerals ` M ` and ` N ` against a fixed
         multiplicand ` P ` (with carry).  (Contributed by Mario Carneiro,
         18-Feb-2014.) $)
      decmac $p |- ( ( M x. P ) + N ) = ; E F $=
        ( cmul co caddc c10 cdc 10nn0 df-dec eqtri nummac eqtr4i ) IEUBUCJUDUCU
        EFUBUCGUDUCFGUFABCDEUEFGHIJUGKLMNIABUFUEAUBUCBUDUCOABUHUIJCDUFUECUBUCDU
        DUCPCDUHUIQRSTBEUBUCDUDUCHGUFUEHUBUCGUDUCUAHGUHUIUJFGUHUK $.
    $}

    ${
      decma2c.7 $e |- P e. NN0 $.
      decma2c.8 $e |- F e. NN0 $.
      decma2c.9 $e |- G e. NN0 $.
      decma2c.10 $e |- ( ( P x. A ) + ( C + G ) ) = E $.
      decma2c.11 $e |- ( ( P x. B ) + D ) = ; G F $.
      $( Perform a multiply-add of two numerals ` M ` and ` N ` against a fixed
         multiplicand ` P ` (with carry).  (Contributed by Mario Carneiro,
         18-Feb-2014.) $)
      decma2c $p |- ( ( P x. M ) + N ) = ; E F $=
        ( cmul co caddc c10 cdc 10nn0 df-dec eqtri numma2c eqtr4i ) EIUBUCJUDUC
        UEFUBUCGUDUCFGUFABCDEUEFGHIJUGKLMNIABUFUEAUBUCBUDUCOABUHUIJCDUFUECUBUCD
        UDUCPCDUHUIQRSTEBUBUCDUDUCHGUFUEHUBUCGUDUCUAHGUHUIUJFGUHUK $.
    $}

    ${
      decadd.7 $e |- ( A + C ) = E $.
      decadd.8 $e |- ( B + D ) = F $.
      $( Add two numerals ` M ` and ` N ` (no carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      decadd $p |- ( M + N ) = ; E F $=
        ( caddc co c10 cmul cdc 10nn0 df-dec eqtri numadd eqtr4i ) GHQRSETRFQRE
        FUAABCDSEFGHUBIJKLGABUASATRBQRMABUCUDHCDUASCTRDQRNCDUCUDOPUEEFUCUF $.
    $}

    decaddc.8 $e |- ( ( A + C ) + 1 ) = E $.
    ${
      decaddc.7 $e |- F e. NN0 $.
      decaddc.9 $e |- ( B + D ) = ; 1 F $.
      $( Add two numerals ` M ` and ` N ` (with carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      decaddc $p |- ( M + N ) = ; E F $=
        ( caddc co c10 cmul cdc 10nn0 df-dec eqtri c1 numaddc eqtr4i ) GHRSTEUA
        SFRSEFUBABCDTEFGHUCIJKLGABUBTAUASBRSMABUDUEHCDUBTCUASDRSNCDUDUEPOBDRSUF
        FUBTUFUASFRSQUFFUDUEUGEFUDUH $.
    $}

    decaddc2.9 $e |- ( B + D ) = 10 $.
    $( Add two numerals ` M ` and ` N ` (with carry).  (Contributed by Mario
       Carneiro, 18-Feb-2014.) $)
    decaddc2 $p |- ( M + N ) = ; E 0 $=
      ( cc0 0nn0 caddc co c10 c1 cdc dec10 eqtri decaddc ) ABCDEPFGHIJKLMNQBDRS
      TUAPUBOUCUDUE $.
  $}

  ${
    decaddi.1 $e |- A e. NN0 $.
    decaddi.2 $e |- B e. NN0 $.
    decaddi.3 $e |- N e. NN0 $.
    decaddi.4 $e |- M = ; A B $.
    ${
      decaddi.5 $e |- ( B + N ) = C $.
      $( Add two numerals ` M ` and ` N ` (no carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      decaddi $p |- ( M + N ) = ; A C $=
        ( cc0 0nn0 dec0h nn0cni addid1i decadd ) ABKEACDEFGLHIEHMAAFNOJP $.
    $}

    decaddci.5 $e |- ( A + 1 ) = D $.
    ${
      decaddci.6 $e |- C e. NN0 $.
      decaddci.7 $e |- ( B + N ) = ; 1 C $.
      $( Add two numerals ` M ` and ` N ` (no carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      decaddci $p |- ( M + N ) = ; D C $=
        ( cc0 0nn0 dec0h caddc co c1 nn0cni addid1i oveq1i eqtri decaddc ) ABNF
        DCEFGHOIJFIPANQRZSQRASQRDUEASQAAGTUAUBKUCLMUD $.
    $}

    ${
      decaddci2.6 $e |- ( B + N ) = 10 $.
      $( Add two numerals ` M ` and ` N ` (no carry).  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      decaddci2 $p |- ( M + N ) = ; D 0 $=
        ( cc0 0nn0 caddc co c10 c1 cdc dec10 eqtri decaddci ) ABLCDEFGHIJMBENOP
        QLRKSTUA $.
    $}
  $}

  ${
    decmul1c.1 $e |- P e. NN0 $.
    decmul1c.2 $e |- A e. NN0 $.
    decmul1c.3 $e |- B e. NN0 $.
    decmul1c.4 $e |- N = ; A B $.
    decmul1c.5 $e |- D e. NN0 $.
    decmul1c.6 $e |- E e. NN0 $.
    ${
      decmul1c.7 $e |- ( ( A x. P ) + E ) = C $.
      decmul1c.8 $e |- ( B x. P ) = ; E D $.
      $( The product of a numeral with a number.  (Contributed by Mario
         Carneiro, 18-Feb-2014.) $)
      decmul1c $p |- ( N x. P ) = ; C D $=
        ( cmul co c10 caddc cdc 10nn0 df-dec eqtri nummul1c eqtr4i ) GEPQRCPQDS
        QCDTABCDERFGUAHIJGABTRAPQBSQKABUBUCLMNBEPQFDTRFPQDSQOFDUBUCUDCDUBUE $.
    $}

    decmul2c.7 $e |- ( ( P x. A ) + E ) = C $.
    decmul2c.8 $e |- ( P x. B ) = ; E D $.
    $( The product of a numeral with a number (with carry).  (Contributed by
       Mario Carneiro, 18-Feb-2014.) $)
    decmul2c $p |- ( P x. N ) = ; C D $=
      ( cmul co c10 caddc cdc 10nn0 df-dec eqtri nummul2c eqtr4i ) EGPQRCPQDSQC
      DTABCDERFGUAHIJGABTRAPQBSQKABUBUCLMNEBPQFDTRFPQDSQOFDUBUCUDCDUBUE $.
  $}

  ${
    6p5lem.1 $e |- A e. NN0 $.
    6p5lem.2 $e |- D e. NN0 $.
    6p5lem.3 $e |- E e. NN0 $.
    6p5lem.4 $e |- B = ( D + 1 ) $.
    6p5lem.5 $e |- C = ( E + 1 ) $.
    6p5lem.6 $e |- ( A + D ) = ; 1 E $.
    $( Lemma for ~ 6p5e11 and related theorems.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    6p5lem $p |- ( A + B ) = ; 1 C $=
      ( caddc co c1 cdc oveq2i nn0cni ax-1cn addassi 1nn0 eqcomi decsuc 3eqtr2i
      ) ABLMADNLMZLMADLMZNLMNCOBUDALIPADNAFQDGQRSNECUETHCENLMJUAKUBUC $.
  $}

  $( 6 + 5 = 11.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6p5e11 $p |- ( 6 + 5 ) = ; 1 1 $=
    ( c6 c5 c1 c4 cc0 6nn0 4nn0 0nn0 df-5 1e0p1 caddc co c10 6p4e10 dec10 eqtri
    cdc 6p5lem ) ABCDEFGHIJADKLMCEQNOPR $.

  $( 6 + 6 = 12.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6p6e12 $p |- ( 6 + 6 ) = ; 1 2 $=
    ( c6 c2 c5 c1 6nn0 5nn0 1nn0 df-6 df-2 6p5e11 6p5lem ) AABCDEFGHIJK $.

  $( 7 + 4 = 11.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7p4e11 $p |- ( 7 + 4 ) = ; 1 1 $=
    ( c7 c4 c1 c3 cc0 7nn0 3nn0 0nn0 df-4 1e0p1 caddc co c10 7p3e10 dec10 eqtri
    cdc 6p5lem ) ABCDEFGHIJADKLMCEQNOPR $.

  $( 7 + 5 = 12.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7p5e12 $p |- ( 7 + 5 ) = ; 1 2 $=
    ( c7 c5 c2 c4 c1 7nn0 4nn0 1nn0 df-5 df-2 7p4e11 6p5lem ) ABCDEFGHIJKL $.

  $( 7 + 6 = 13.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7p6e13 $p |- ( 7 + 6 ) = ; 1 3 $=
    ( c7 c6 c3 c5 c2 7nn0 5nn0 2nn0 df-6 df-3 7p5e12 6p5lem ) ABCDEFGHIJKL $.

  $( 7 + 7 = 14.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7p7e14 $p |- ( 7 + 7 ) = ; 1 4 $=
    ( c7 c4 c6 c3 7nn0 6nn0 3nn0 df-7 df-4 7p6e13 6p5lem ) AABCDEFGHIJK $.

  $( 8 + 3 = 11.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8p3e11 $p |- ( 8 + 3 ) = ; 1 1 $=
    ( c8 c3 c1 c2 cc0 8nn0 2nn0 0nn0 df-3 1e0p1 caddc co c10 8p2e10 dec10 eqtri
    cdc 6p5lem ) ABCDEFGHIJADKLMCEQNOPR $.

  $( 8 + 4 = 12.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8p4e12 $p |- ( 8 + 4 ) = ; 1 2 $=
    ( c8 c4 c2 c3 c1 8nn0 3nn0 1nn0 df-4 df-2 8p3e11 6p5lem ) ABCDEFGHIJKL $.

  $( 8 + 5 = 13.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8p5e13 $p |- ( 8 + 5 ) = ; 1 3 $=
    ( c8 c5 c3 c4 c2 8nn0 4nn0 2nn0 df-5 df-3 8p4e12 6p5lem ) ABCDEFGHIJKL $.

  $( 8 + 6 = 14.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8p6e14 $p |- ( 8 + 6 ) = ; 1 4 $=
    ( c8 c6 c4 c5 c3 8nn0 5nn0 3nn0 df-6 df-4 8p5e13 6p5lem ) ABCDEFGHIJKL $.

  $( 8 + 7 = 15.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8p7e15 $p |- ( 8 + 7 ) = ; 1 5 $=
    ( c8 c7 c5 c6 c4 8nn0 6nn0 4nn0 df-7 df-5 8p6e14 6p5lem ) ABCDEFGHIJKL $.

  $( 8 + 8 = 16.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8p8e16 $p |- ( 8 + 8 ) = ; 1 6 $=
    ( c8 c6 c7 c5 8nn0 7nn0 5nn0 df-8 df-6 8p7e15 6p5lem ) AABCDEFGHIJK $.

  $( 9 + 2 = 11.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p2e11 $p |- ( 9 + 2 ) = ; 1 1 $=
    ( c9 c2 c1 cc0 9nn0 1nn0 0nn0 df-2 1e0p1 caddc co df-10 dec10 eqtr3i 6p5lem
    c10 cdc ) ABCCDEFGHIPACJKCDQLMNO $.

  $( 9 + 3 = 12.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p3e12 $p |- ( 9 + 3 ) = ; 1 2 $=
    ( c9 c3 c2 c1 9nn0 2nn0 1nn0 df-3 df-2 9p2e11 6p5lem ) ABCCDEFGHIJK $.

  $( 9 + 4 = 13.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p4e13 $p |- ( 9 + 4 ) = ; 1 3 $=
    ( c9 c4 c3 c2 9nn0 3nn0 2nn0 df-4 df-3 9p3e12 6p5lem ) ABCCDEFGHIJK $.

  $( 9 + 5 = 14.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p5e14 $p |- ( 9 + 5 ) = ; 1 4 $=
    ( c9 c5 c4 c3 9nn0 4nn0 3nn0 df-5 df-4 9p4e13 6p5lem ) ABCCDEFGHIJK $.

  $( 9 + 6 = 15.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p6e15 $p |- ( 9 + 6 ) = ; 1 5 $=
    ( c9 c6 c5 c4 9nn0 5nn0 4nn0 df-6 df-5 9p5e14 6p5lem ) ABCCDEFGHIJK $.

  $( 9 + 7 = 16.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p7e16 $p |- ( 9 + 7 ) = ; 1 6 $=
    ( c9 c7 c6 c5 9nn0 6nn0 5nn0 df-7 df-6 9p6e15 6p5lem ) ABCCDEFGHIJK $.

  $( 9 + 8 = 17.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p8e17 $p |- ( 9 + 8 ) = ; 1 7 $=
    ( c9 c8 c7 c6 9nn0 7nn0 6nn0 df-8 df-7 9p7e16 6p5lem ) ABCCDEFGHIJK $.

  $( 9 + 9 = 18.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9p9e18 $p |- ( 9 + 9 ) = ; 1 8 $=
    ( c9 c8 c7 9nn0 8nn0 7nn0 df-9 df-8 9p8e17 6p5lem ) AABBCDEFGHIJ $.

  $( 10 + 10 = 20.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  10p10e20 $p |- ( 10 + 10 ) = ; 2 0 $=
    ( c1 cc0 c2 c10 1nn0 0nn0 dec10 1p1e2 00id decadd ) ABABCBDDEFEFGGHIJ $.

  ${
    4t3lem.1 $e |- A e. NN0 $.
    4t3lem.2 $e |- B e. NN0 $.
    4t3lem.3 $e |- C = ( B + 1 ) $.
    4t3lem.4 $e |- ( A x. B ) = D $.
    4t3lem.5 $e |- ( D + A ) = E $.
    $( Lemma for ~ 4t3e12 and related theorems.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    4t3lem $p |- ( A x. C ) = E $=
      ( cmul co c1 caddc oveq2i nn0cni ax-1cn adddii mulid1i eqtri oveq12i ) AC
      KLABMNLZKLZECUBAKHOUCDANLZEUCABKLZAMKLZNLUDABMAFPZBGPQRUEDUFANIAUGSUATJTT
      $.
  $}

  $( 4 times 3 equals 12.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  4t3e12 $p |- ( 4 x. 3 ) = ; 1 2 $=
    ( c4 c2 c3 c8 c1 cdc 4nn0 2nn0 df-3 4t2e8 8p4e12 4t3lem ) ABCDEBFGHIJKL $.

  $( 4 times 4 equals 16.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  4t4e16 $p |- ( 4 x. 4 ) = ; 1 6 $=
    ( c4 c3 c1 c2 cdc c6 4nn0 3nn0 df-4 4t3e12 1nn0 2nn0 4cn 2cn 4p2e6 addcomli
    eqid decaddi 4t3lem ) ABACDEZCFEGHIJCDFTAKLGTQADFMNOPRS $.

  $( 5 times 3 equals 15.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  5t3e15 $p |- ( 5 x. 3 ) = ; 1 5 $=
    ( c5 c2 c3 c10 c1 cdc 5nn0 2nn0 df-3 5t2e10 dec10p 4t3lem ) ABCDEAFGHIJAKL
    $.

  $( 5 times 4 equals 20.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  5t4e20 $p |- ( 5 x. 4 ) = ; 2 0 $=
    ( c5 c3 c4 c1 cdc c2 5nn0 3nn0 df-4 5t3e15 1nn0 eqid 1p1e2 5p5e10 decaddci2
    cc0 4t3lem ) ABCDAEZFPEGHIJDAFRAKGGRLMNOQ $.

  $( 5 times 5 equals 25.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  5t5e25 $p |- ( 5 x. 5 ) = ; 2 5 $=
    ( c5 c4 c10 c2 cmul cdc 5nn0 4nn0 df-5 cc0 5t4e20 dec0u eqtr4i caddc df-dec
    co 2nn0 eqcomi 4t3lem ) ABACDEPZDAFZGHIABEPDJFTKDQLMUATANPDAORS $.

  $( 6 times 2 equals 12.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6t2e12 $p |- ( 6 x. 2 ) = ; 1 2 $=
    ( c6 c2 cmul co caddc c1 cdc 6nn nncni times2i 6p6e12 eqtri ) ABCDAAEDFBGAA
    HIJKL $.

  $( 6 times 3 equals 18.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6t3e18 $p |- ( 6 x. 3 ) = ; 1 8 $=
    ( c6 c2 c3 c1 cdc 6nn0 2nn0 df-3 6t2e12 1nn0 eqid nn0cni 2cn 6p2e8 addcomli
    c8 decaddi 4t3lem ) ABCDBEZDPEFGHIDBPSAJGFSKABPAFLMNOQR $.

  $( 6 times 4 equals 24.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6t4e24 $p |- ( 6 x. 4 ) = ; 2 4 $=
    ( c6 c3 c4 c1 c8 cdc 6nn0 3nn0 df-4 6t3e18 1nn0 8nn0 eqid 1p1e2 4nn0 8p6e14
    c2 decaddci 4t3lem ) ABCDEFZQCFGHIJDECQTAKLGTMNOPRS $.

  $( 6 times 5 equals 30.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6t5e30 $p |- ( 6 x. 5 ) = ; 3 0 $=
    ( c6 c4 c5 c2 cdc c3 cc0 6nn0 4nn0 df-5 6t4e24 2nn0 2p1e3 c10 nn0cni 6p4e10
    eqid addcomli decaddci2 4t3lem ) ABCDBEZFGEHIJKDBFUAALIHUAQMABNAHOBIOPRST
    $.

  $( 6 times 6 equals 36.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  6t6e36 $p |- ( 6 x. 6 ) = ; 3 6 $=
    ( c6 c5 c10 c3 cmul cdc 6nn0 5nn0 df-6 cc0 6t5e30 dec0u eqtr4i caddc df-dec
    co 3nn0 eqcomi 4t3lem ) ABACDEPZDAFZGHIABEPDJFTKDQLMUATANPDAORS $.

  $( 7 times 2 equals 14.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7t2e14 $p |- ( 7 x. 2 ) = ; 1 4 $=
    ( c7 c2 cmul co caddc c1 c4 cdc 7nn nncni times2i 7p7e14 eqtri ) ABCDAAEDFG
    HAAIJKLM $.

  $( 7 times 3 equals 21.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7t3e21 $p |- ( 7 x. 3 ) = ; 2 1 $=
    ( c7 c2 c3 c1 c4 7nn0 2nn0 df-3 7t2e14 1nn0 4nn0 eqid 1p1e2 nn0cni addcomli
    cdc 7p4e11 decaddci 4t3lem ) ABCDEPZBDPFGHIDEDBTAJKFTLMJAEDDPAFNEKNQORS $.

  $( 7 times 4 equals 28.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7t4e28 $p |- ( 7 x. 4 ) = ; 2 8 $=
    ( c7 c3 c4 c2 c1 cdc c8 7nn0 3nn0 df-4 7t3e21 2nn0 1nn0 nn0cni ax-1cn 7p1e8
    eqid addcomli decaddi 4t3lem ) ABCDEFZDGFHIJKDEGUAALMHUAQAEGAHNOPRST $.

  $( 7 times 5 equals 35.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7t5e35 $p |- ( 7 x. 5 ) = ; 3 5 $=
    ( c7 c4 c5 c2 c8 cdc 7nn0 4nn0 df-5 7t4e28 2nn0 8nn0 eqid 2p1e3 5nn0 8p7e15
    c3 decaddci 4t3lem ) ABCDEFZQCFGHIJDECQTAKLGTMNOPRS $.

  $( 7 times 6 equals 42.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7t6e42 $p |- ( 7 x. 6 ) = ; 4 2 $=
    ( c7 c5 c6 c3 cdc c4 c2 7nn0 5nn0 df-6 7t5e35 3nn0 eqid 3p1e4 nn0cni 7p5e12
    2nn0 c1 addcomli decaddci 4t3lem ) ABCDBEZFGEHIJKDBGFUBALIHUBMNQABRGEAHOBIO
    PSTUA $.

  $( 7 times 7 equals 49.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  7t7e49 $p |- ( 7 x. 7 ) = ; 4 9 $=
    ( c7 c6 c4 c2 c9 7nn0 6nn0 df-7 7t6e42 4nn0 2nn0 eqid nn0cni 7p2e9 addcomli
    cdc 2cn decaddi 4t3lem ) ABACDPZCEPFGHICDETAJKFTLADEAFMQNORS $.

  $( 8 times 2 equals 16.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t2e16 $p |- ( 8 x. 2 ) = ; 1 6 $=
    ( c8 c2 cmul co caddc c1 c6 cdc 8nn nncni times2i 8p8e16 eqtri ) ABCDAAEDFG
    HAAIJKLM $.

  $( 8 times 3 equals 24.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t3e24 $p |- ( 8 x. 3 ) = ; 2 4 $=
    ( c8 c2 c3 c1 c6 cdc 8nn0 2nn0 df-3 8t2e16 1nn0 6nn0 eqid 1p1e2 4nn0 nn0cni
    c4 8p6e14 addcomli decaddci 4t3lem ) ABCDEFZBQFGHIJDEQBUBAKLGUBMNOAEDQFAGPE
    LPRSTUA $.

  $( 8 times 4 equals 32.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t4e32 $p |- ( 8 x. 4 ) = ; 3 2 $=
    ( c8 c3 c4 c2 8nn0 3nn0 df-4 8t3e24 2nn0 4nn0 eqid 2p1e3 c1 nn0cni addcomli
    cdc 8p4e12 decaddci 4t3lem ) ABCDCPZBDPEFGHDCDBTAIJETKLIACMDPAENCJNQORS $.

  $( 8 times 5 equals 40.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t5e40 $p |- ( 8 x. 5 ) = ; 4 0 $=
    ( c8 c4 c5 c3 cdc cc0 8nn0 4nn0 df-5 8t4e32 3nn0 2nn0 eqid 3p1e4 c10 nn0cni
    c2 2cn 8p2e10 addcomli decaddci2 4t3lem ) ABCDQEZBFEGHIJDQBUCAKLGUCMNAQOAGP
    RSTUAUB $.

  $( 8 times 6 equals 48.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t6e48 $p |- ( 8 x. 6 ) = ; 4 8 $=
    ( c8 c5 c6 c10 c4 cmul co cdc 8nn0 5nn0 df-6 8t5e40 4nn0 dec0u eqtr4i caddc
    cc0 df-dec eqcomi 4t3lem ) ABCDEFGZEAHZIJKABFGEQHUALEMNOUBUAAPGEARST $.

  $( 8 times 7 equals 56.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t7e56 $p |- ( 8 x. 7 ) = ; 5 6 $=
    ( c8 c6 c7 c4 cdc c5 8nn0 6nn0 df-7 8t6e48 4nn0 eqid 8p8e16 decaddci 4t3lem
    4p1e5 ) ABCDAEZFBEGHIJDABFQAKGGQLPHMNO $.

  $( 8 times 8 equals 64.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  8t8e64 $p |- ( 8 x. 8 ) = ; 6 4 $=
    ( c8 c7 c5 c6 cdc c4 8nn0 7nn0 df-8 8t7e56 5nn0 6nn0 eqid 5p1e6 4nn0 nn0cni
    c1 8p6e14 addcomli decaddci 4t3lem ) ABACDEZDFEGHIJCDFDUBAKLGUBMNOADQFEAGPD
    LPRSTUA $.

  $( 9 times 2 equals 18.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t2e18 $p |- ( 9 x. 2 ) = ; 1 8 $=
    ( c9 c2 cmul co caddc c1 c8 cdc 9nn nncni times2i 9p9e18 eqtri ) ABCDAAEDFG
    HAAIJKLM $.

  $( 9 times 3 equals 27.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t3e27 $p |- ( 9 x. 3 ) = ; 2 7 $=
    ( c9 c2 c3 c1 c8 cdc 9nn0 2nn0 df-3 9t2e18 1nn0 8nn0 eqid 1p1e2 7nn0 nn0cni
    c7 9p8e17 addcomli decaddci 4t3lem ) ABCDEFZBQFGHIJDEQBUBAKLGUBMNOAEDQFAGPE
    LPRSTUA $.

  $( 9 times 4 equals 36.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t4e36 $p |- ( 9 x. 4 ) = ; 3 6 $=
    ( c9 c3 c4 c2 c7 cdc 9nn0 3nn0 df-4 9t3e27 2nn0 7nn0 eqid 2p1e3 6nn0 nn0cni
    c6 c1 9p7e16 addcomli decaddci 4t3lem ) ABCDEFZBQFGHIJDEQBUCAKLGUCMNOAERQFA
    GPELPSTUAUB $.

  $( 9 times 5 equals 45.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t5e45 $p |- ( 9 x. 5 ) = ; 4 5 $=
    ( c9 c4 c5 c3 c6 cdc 9nn0 4nn0 df-5 9t4e36 3nn0 6nn0 eqid 3p1e4 5nn0 nn0cni
    c1 9p6e15 addcomli decaddci 4t3lem ) ABCDEFZBCFGHIJDECBUBAKLGUBMNOAEQCFAGPE
    LPRSTUA $.

  $( 9 times 6 equals 54.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t6e54 $p |- ( 9 x. 6 ) = ; 5 4 $=
    ( c9 c5 c6 cdc 9nn0 5nn0 df-6 9t5e45 4nn0 eqid 4p1e5 nn0cni 9p5e14 addcomli
    c4 c1 decaddci 4t3lem ) ABCOBDZBODEFGHOBOBSAIFESJKIABPODAELBFLMNQR $.

  $( 9 times 7 equals 63.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t7e63 $p |- ( 9 x. 7 ) = ; 6 3 $=
    ( c9 c6 c7 c5 c4 cdc 9nn0 6nn0 df-7 9t6e54 5nn0 4nn0 eqid 5p1e6 3nn0 nn0cni
    c3 c1 9p4e13 addcomli decaddci 4t3lem ) ABCDEFZBQFGHIJDEQBUCAKLGUCMNOAERQFA
    GPELPSTUAUB $.

  $( 9 times 8 equals 72.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t8e72 $p |- ( 9 x. 8 ) = ; 7 2 $=
    ( c9 c7 c8 c6 c3 cdc 9nn0 7nn0 df-8 9t7e63 6nn0 3nn0 eqid 6p1e7 2nn0 nn0cni
    c2 c1 3cn 9p3e12 addcomli decaddci 4t3lem ) ABCDEFZBQFGHIJDEQBUDAKLGUDMNOAE
    RQFAGPSTUAUBUC $.

  $( 9 times 9 equals 81.  (Contributed by Mario Carneiro, 19-Apr-2015.) $)
  9t9e81 $p |- ( 9 x. 9 ) = ; 8 1 $=
    ( c9 c8 c7 c2 cdc c1 9nn0 8nn0 df-9 9t8e72 7nn0 2nn0 eqid 7p1e8 1nn0 nn0cni
    2cn 9p2e11 addcomli decaddci 4t3lem ) ABACDEZBFEGHIJCDFBUBAKLGUBMNOADFFEAGP
    QRSTUA $.

  ${
    decbin.1 $e |- A e. NN0 $.
    $( Decompose base 4 into base 2.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    decbin0 $p |- ( 4 x. A ) = ( 2 x. ( 2 x. A ) ) $=
      ( c2 cmul co c4 2t2e4 oveq1i 2cn nn0cni mulassi eqtr3i ) CCDEZADEFADECCAD
      EDEMFADGHCCAIIABJKL $.

    $( Decompose base 4 into base 2.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    decbin2 $p |- ( ( 4 x. A ) + 2 ) = ( 2 x. ( ( 2 x. A ) + 1 ) ) $=
      ( c2 cmul co caddc 2cn mulid1i oveq2i nn0cni mulcli ax-1cn adddii decbin0
      c1 c4 oveq1i 3eqtr4ri ) CCADEZDEZCODEZFETCFECSOFEDEPADEZCFEUACTFCGHICSOGC
      AGABJKLMUBTCFABNQR $.

    $( Decompose base 4 into base 2.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    decbin3 $p |- ( ( 4 x. A ) + 3 ) = ( ( 2 x. ( ( 2 x. A ) + 1 ) ) + 1 ) $=
      ( c2 cmul co c1 caddc c4 c3 4nn0 2nn0 2p1e3 decbin2 eqcomi numsuc ) CCADE
      FGEDEZFGEHADEZIGEACIHPJBKLQCGEPABMNON $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Upper partititions of integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ZZ>= $. $( ` ZZ ` with greater-than-or-equal-to subscript. $)

  $( Extend class notation with the upper integer function.
     Read " ` ZZ>= `` M ` " as "the set of integers greater than or equal to
     ` M ` ." $)
  cuz $a class ZZ>= $.

  ${
    $d j k y N $.  $d k M $.
    $( Define a function whose value at ` j ` is the semi-infinite set of
       contiguous integers starting at ` j ` , which we will also call the
       upper integers starting at ` j ` .  Read " ` ZZ>= `` M ` " as "the set
       of integers greater than or equal to ` M ` ."  See ~ uzval for its
       value, ~ uzssz for its relationship to ` ZZ ` , ~ nnuz and ~ nn0uz for
       its relationships to ` NN ` and ` NN0 ` , and ~ eluz1 and ~ eluz2 for
       its membership relations.  (Contributed by NM, 5-Sep-2005.) $)
    df-uz $a |- ZZ>= = ( j e. ZZ |-> { k e. ZZ | j <_ k } ) $.

    $( The value of the upper integers function.  (Contributed by NM,
       5-Sep-2005.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    uzval $p |- ( N e. ZZ -> ( ZZ>= ` N ) = { k e. ZZ | N <_ k } ) $=
      ( vj cv cle wbr cz crab cuz wceq breq1 rabbidv df-uz zex rabex fvmpt ) CB
      CDZADZEFZAGHBREFZAGHGIQBJSTAGQBREKLCAMTAGNOP $.

    $( The domain and range of the upper integers function.  (Contributed by
       Scott Fenton, 8-Aug-2013.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    uzf $p |- ZZ>= : ZZ --> ~P ZZ $=
      ( vj vk cv cle wbr cz crab cpw wcel wral cuz wss ssrab2 elpw2 mpbir rgenw
      wf zex df-uz fmpt mpbi ) ACBCDEZBFGZFHZIZAFJFUDKQUEAFUEUCFLUBBFMUCFRNOPAF
      UDUCKABSTUA $.

    $( Membership in the set of upper integers starting at ` M ` .
       (Contributed by NM, 5-Sep-2005.) $)
    eluz1 $p |- ( M e. ZZ ->
           ( N e. ( ZZ>= ` M ) <-> ( N e. ZZ /\ M <_ N ) ) ) $=
      ( vk cz wcel cuz cfv cv cle wbr crab wa uzval eleq2d breq2 elrab syl6bb )
      ADEZBAFGZEBACHZIJZCDKZEBDEABIJZLRSUBBCAMNUAUCCBDTBAIOPQ $.

    $( Implication of membership in a set of upper integers.  (Contributed by
       NM, 6-Sep-2005.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    eluzel2 $p |- ( N e. ( ZZ>= ` M ) -> M e. ZZ ) $=
      ( cuz cfv wcel cdm cz elfvdm cpw uzf fdmi syl6eleq ) BACDEACFGBACHGGICJKL
      $.

    $( Membership in a set of upper integers.  We use the fact that a
       function's value (under our function value definition) is empty outside
       of its domain to show ` M e. ZZ ` .  (Contributed by NM, 5-Sep-2005.)
       (Revised by Mario Carneiro, 3-Nov-2013.) $)
    eluz2 $p |- ( N e. ( ZZ>= ` M ) <-> ( M e. ZZ /\ N e. ZZ /\ M <_ N ) ) $=
      ( cuz cfv wcel cz cle wbr w3a eluzel2 simp1 wa eluz1 bitrd 3anass syl6bbr
      ibar pm5.21nii ) BACDEZAFEZTBFEZABGHZIZABJTUAUBKTSTUAUBLZLZUCTSUDUEABMTUD
      QNTUAUBOPR $.
  $}

  ${
    eluz.1 $e |- M e. ZZ $.
    $( Membership in a set of upper integers.  (Contributed by NM,
       5-Sep-2005.) $)
    eluz1i $p |- ( N e. ( ZZ>= ` M ) <-> ( N e. ZZ /\ M <_ N ) ) $=
      ( cz wcel cuz cfv cle wbr wa wb eluz1 ax-mp ) ADEBAFGEBDEABHIJKCABLM $.
  $}

  $( A member of a set of upper integers is an integer.  (Contributed by NM,
     6-Sep-2005.) $)
  eluzelz $p |- ( N e. ( ZZ>= ` M ) -> N e. ZZ ) $=
    ( cuz cfv wcel cz cle wbr eluz2 simp2bi ) BACDEAFEBFEABGHABIJ $.

  $( A member of a set of upper integers is a real.  (Contributed by Mario
     Carneiro, 31-Aug-2013.) $)
  eluzelre $p |- ( N e. ( ZZ>= ` M ) -> N e. RR ) $=
    ( cuz cfv wcel eluzelz zred ) BACDEBABFG $.

  $( Implication of membership in a set of upper integers.  (Contributed by NM,
     6-Sep-2005.) $)
  eluzle $p |- ( N e. ( ZZ>= ` M ) -> M <_ N ) $=
    ( cuz cfv wcel cz cle wbr eluz2 simp3bi ) BACDEAFEBFEABGHABIJ $.

  $( Membership in a set of upper integers.  (Contributed by NM,
     2-Oct-2005.) $)
  eluz $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
         ( N e. ( ZZ>= ` M ) <-> M <_ N ) ) $=
    ( cz wcel cuz cfv cle wbr eluz1 baibd ) ACDBAEFDBCDABGHABIJ $.

  $( Membership of the least member in a set of upper integers.  (Contributed
     by NM, 2-Sep-2005.) $)
  uzid $p |- ( M e. ZZ -> M e. ( ZZ>= ` M ) ) $=
    ( cz wcel cuz cfv cle wbr wa zre leidd ancli eluz1 mpbird ) ABCZAADECNAAFGZ
    HNONAAIJKAALM $.

  ${
    $d k M $.
    $( The upper integers are all nonempty.  (Contributed by Mario Carneiro,
       16-Jan-2014.) $)
    uzn0 $p |- ( M e. ran ZZ>= -> M =/= (/) ) $=
      ( vk cuz crn wcel cv cfv wceq cz wrex c0 wne cpw wfn uzf ffn fvelrnb mp2b
      wf wb uzid ne0i syl neeq1 syl5ibcom rexlimiv sylbi ) ACDEZBFZCGZAHZBIJZAK
      LZIIMZCSCINUHULTOIUNCPBIACQRUKUMBIUIIEZUJKLZUKUMUOUIUJEUPUIUAUJUIUBUCUJAK
      UDUEUFUG $.
  $}

  $( Transitive law for sets of upper integers.  (Contributed by NM,
     20-Sep-2005.) $)
  uztrn $p |- ( ( M e. ( ZZ>= ` K ) /\ K e. ( ZZ>= ` N ) ) ->
              M e. ( ZZ>= ` N ) ) $=
    ( cuz cfv wcel wa cz cle wbr eluzel2 adantl eluzelz adantr eluzle wi cr zre
    letr syl3an syl3anc mp2and eluz2 syl3anbrc ) BADEFZACDEZFZGZCHFZBHFZCBIJZBU
    FFUGUIUECAKLZUEUJUGABMNZUHCAIJZABIJZUKUGUNUECAOLUEUOUGABONUHUIAHFZUJUNUOGUK
    PZULUGUPUECAMLUMUICQFUPAQFUJBQFUQCRARBRCABSTUAUBCBUCUD $.

  ${
    uztrn2.1 $e |- Z = ( ZZ>= ` K ) $.
    $( Transitive law for sets of upper integers.  (Contributed by Mario
       Carneiro, 26-Dec-2013.) $)
    uztrn2 $p |- ( ( N e. Z /\ M e. ( ZZ>= ` N ) ) -> M e. Z ) $=
      ( wcel cuz cfv wa eleq2i uztrn ancoms sylanb syl6eleqr ) CDFZBCGHFZIBAGHZ
      DOCQFZPBQFZDQCEJPRSCBAKLMEN $.
  $}

  $( Contraposition law for upper integers.  (Contributed by NM,
     28-Nov-2005.) $)
  uzneg $p |- ( N e. ( ZZ>= ` M ) -> -u M e. ( ZZ>= ` -u N ) ) $=
    ( cuz cfv wcel cneg cle wbr eluzle cz wb eluzel2 eluzelz zre syl2an syl2anc
    cr leneg mpbid znegcl eluz mpbird ) BACDEZAFZBFZCDEZUEUDGHZUCABGHZUGABIUCAJ
    EZBJEZUHUGKZABLZABMZUIAQEBQEUKUJANBNABROPSUCUJUIUFUGKZUMULUJUEJEUDJEUNUIBTA
    TUEUDUAOPUB $.

  ${
    $d j k y M $.  $d k N $.
    $( A set of upper integers is a subset of all integers.  (Contributed by
       NM, 2-Sep-2005.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    uzssz $p |- ( ZZ>= ` M ) C_ ZZ $=
      ( cuz cdm wcel cfv cz wss cpw uzf ffvelrni elpwid fdmi eleq2s wn c0 ndmfv
      0ss syl6eqss pm2.61i ) ABCZDZABEZFGZUCAFTAFDUBFFFHZABIJKFUDBILMUANUBOFABP
      FQRS $.

    $( Subset relationship for two sets of upper integers.  (Contributed by NM,
       5-Sep-2005.) $)
    uzss $p |- ( N e. ( ZZ>= ` M ) ->
               ( ZZ>= ` N ) C_ ( ZZ>= ` M ) ) $=
      ( vk cuz cfv wcel cv cz cle wbr wa eluzle adantr wi eluzel2 cr zre wb syl
      eluz1 eluzelz jca letr syl3an 3expa sylan mpand imdistanda 3imtr4d ssrdv
      ) BADEZFZCBDEZUKULCGZHFZBUNIJZKZUOAUNIJZKZUNUMFZUNUKFZULUOUPURULUOKABIJZU
      PURULVBUOABLMULAHFZBHFZKUOVBUPKURNZULVCVDABOZABUAZUBVCVDUOVEVCAPFVDBPFUOU
      NPFVEAQBQUNQABUNUCUDUEUFUGUHULVDUTUQRVGBUNTSULVCVAUSRVFAUNTSUIUJ $.
  $}

  $( Totality of the ordering relation on integers, stated in terms of upper
     integers.  (Contributed by NM, 6-Jul-2005.)  (Revised by Mario Carneiro,
     25-Jun-2013.) $)
  uztric $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
      ( N e. ( ZZ>= ` M ) \/ M e. ( ZZ>= ` N ) ) ) $=
    ( cz wcel wa cuz cfv wo cle wbr cr zre letric syl2an eluz wb ancoms orbi12d
    mpbird ) ACDZBCDZEZBAFGDZABFGDZHABIJZBAIJZHZTAKDBKDUGUAALBLABMNUBUCUEUDUFAB
    OUATUDUFPBAOQRS $.

  $( The upper integers function is one-to-one.  (Contributed by NM,
     12-Dec-2005.) $)
  uz11 $p |- ( M e. ZZ ->
                ( ( ZZ>= ` M ) = ( ZZ>= ` N ) <-> M = N ) ) $=
    ( cz wcel cuz cfv wceq wa eleq2 eluzel2 syl6bi mpan9 cle wbr syl5ibr eluzle
    uzid syl6 cr zre syl5ib anim12d impl ancoms anassrs wb letri3 syl2an mpbird
    adantlr mpdan ex fveq2 impbid1 ) ACDZAEFZBEFZGZABGZUOURUSUOURHZBCDZUSUOAUPD
    ZURVAAQZURVBAUQDZVAUPUQAIZBAJKLUTVAHUSABMNZBAMNZHZUOURVAVHURVAHUOVHURVAUOVH
    URVAVFUOVGURVABUPDZVFVAVIURBUQDBQUPUQBIOABPRURUOVDVGUOVBURVDVCVEUABAPRUBUCU
    DUEUOVAUSVHUFZURUOASDBSDVJVAATBTABUGUHUJUIUKULABEUMUN $.

  $( Membership in the next set of upper integers.  (Contributed by NM,
     12-Sep-2005.) $)
  eluzp1m1 $p |- ( ( M e. ZZ /\
             N e. ( ZZ>= ` ( M + 1 ) ) ) -> ( N - 1 ) e. ( ZZ>= ` M ) ) $=
    ( cz wcel c1 caddc co cuz cfv cmin cle wbr wa peano2zm ad2antrl cr wb eluz1
    zre 1re leaddsub mp3an2 syl2an biimpa anasss jca ex peano2z syl 3imtr4d imp
    ) ACDZBAEFGZHIDZBEJGZAHIDZULBCDZUMBKLZMZUOCDZAUOKLZMZUNUPULUSVBULUSMUTVAUQU
    TULURBNOULUQURVAULUQMURVAULAPDZBPDZURVAQZUQASBSVCEPDVDVETAEBUAUBUCUDUEUFUGU
    LUMCDUNUSQAUHUMBRUIAUORUJUK $.

  $( Strict ordering implied by membership in the next set of upper integers.
     (Contributed by NM, 12-Sep-2005.) $)
  eluzp1l $p |- ( ( M e. ZZ /\
             N e. ( ZZ>= ` ( M + 1 ) ) ) -> M < N ) $=
    ( cz wcel c1 caddc cuz cfv clt wbr cle eluzle adantl eluzelz zltp1le sylan2
    co wa wb mpbird ) ACDZBAEFQZGHDZRABIJZUBBKJZUCUEUAUBBLMUCUABCDUDUESUBBNABOP
    T $.

  $( Membership in the next set of upper integers.  (Contributed by NM,
     5-Oct-2005.) $)
  eluzp1p1 $p |- ( N e. ( ZZ>= ` M ) ->
                       ( N + 1 ) e. ( ZZ>= ` ( M + 1 ) ) ) $=
    ( cz wcel cle wbr w3a c1 caddc co cuz cfv peano2z 3ad2ant1 3ad2ant2 zre 1re
    cr wb eluz2 leadd1 mp3an3 syl2an biimp3a 3jca 3imtr4i ) ACDZBCDZABEFZGZAHIJ
    ZCDZBHIJZCDZUKUMEFZGBAKLDUMUKKLDUJULUNUOUGUHULUIAMNUHUGUNUIBMOUGUHUIUOUGARD
    ZBRDZUIUOSZUHAPBPUPUQHRDURQABHUAUBUCUDUEABTUKUMTUF $.

  ${
    eluzaddi.1 $e |- M e. ZZ $.
    eluzaddi.2 $e |- K e. ZZ $.
    $( Membership in a later set of upper integers.  (Contributed by Paul
       Chapman, 22-Nov-2007.) $)
    eluzaddi $p |- ( N e. ( ZZ>= ` M )
          -> ( N + K ) e. ( ZZ>= ` ( M + K ) ) ) $=
      ( cuz cfv wcel caddc co cz cle wbr eluzelz zaddcl sylancl wa eluz1i zrei
      cr wb zre leadd1 mp3an13 syl biimpa sylbi mp2an sylanbrc ) CBFGHZCAIJZKHZ
      BAIJZUKLMZUKUMFGHUJCKHZAKHZULBCNECAOPUJUOBCLMZQUNBCDRUOUQUNUOCTHZUQUNUAZC
      UBBTHURATHUSBDSAESBCAUCUDUEUFUGUMUKBKHUPUMKHDEBAOUHRUI $.

    $( Membership in an earlier set of upper integers.  (Contributed by Paul
       Chapman, 22-Nov-2007.) $)
    eluzsubi $p |- ( N e. ( ZZ>= ` ( M + K ) )
         -> ( N - K ) e. ( ZZ>= ` M ) ) $=
      ( caddc co cuz cfv wcel cmin cz cle eluzelz zsubcl sylancl eluz1i cr zrei
      wbr wa zaddcl mp2an wb zre leaddsub mp3an12 syl biimpa sylbi sylanbrc ) C
      BAFGZHIJZCAKGZLJZBUNMTZUNBHIJUMCLJZALJZUOULCNECAOPUMUQULCMTZUAUPULCBLJURU
      LLJDEBAUBUCQUQUSUPUQCRJZUSUPUDZCUEBRJARJUTVABDSAESBACUFUGUHUIUJBUNDQUK $.
  $}

  $( Membership in a later set of upper integers.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  eluzadd $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ ) ->
                                      ( N + K ) e. ( ZZ>= ` ( M + K ) ) ) $=
    ( cuz cfv wcel cz caddc co eluzel2 wa wi cc0 cif eleq2d fveq2d oveq2 elimel
    wceq 0z fveq2 oveq1 imbi12d eleq12d imbi2d eluzaddi dedth2h com12 mpand imp
    ) CBDEZFZAGFZCAHIZBAHIZDEZFZULBGFZUMUQBCJURUMKULUQURUMULUQLCURBMNZDEZFZUNUS
    AHIZDEZFZLVACUMAMNZHIZUSVEHIZDEZFZLBAMMBUSSZULVAUQVDVJUKUTCBUSDUAOVJUPVCUNV
    JUOVBDBUSAHUBPOUCAVESZVDVIVAVKUNVFVCVHAVECHQVKVBVGDAVEUSHQPUDUEVEUSCBMGTRAM
    GTRUFUGUHUIUJ $.

  $( Membership in an earlier set of upper integers.  (Contributed by Jeff
     Madsen, 2-Sep-2009.) $)
  eluzsub $p |- ( ( M e. ZZ /\ K e. ZZ /\ N e. ( ZZ>= ` ( M + K ) ) )
                                          -> ( N - K ) e. ( ZZ>= ` M ) ) $=
    ( cz wcel caddc co cuz cfv cmin wi cc0 cif wceq fveq2d eleq2d imbi12d oveq2
    0z elimel oveq1 fveq2 eleq1d eluzsubi dedth2h 3impia ) BDEZADEZCBAFGZHIZEZC
    AJGZBHIZEZUGUHUKUNKCUGBLMZAFGZHIZEZULUOHIZEZKCUOUHALMZFGZHIZEZCVAJGZUSEZKBA
    LLBUONZUKURUNUTVGUJUQCVGUIUPHBUOAFUAOPVGUMUSULBUOHUBPQAVANZURVDUTVFVHUQVCCV
    HUPVBHAVAUOFROPVHULVEUSAVACJRUCQVAUOCBLDSTALDSTUDUEUF $.

  $( Choices for an element of an upper interval of integers.  (Contributed by
     Jeff Madsen, 2-Sep-2009.) $)
  uzm1 $p |- ( N e. ( ZZ>= ` M ) -> ( N = M \/ ( N - 1 ) e. ( ZZ>= ` M ) ) ) $=
    ( cuz cfv wcel wceq c1 cmin co cle wbr w3a eluzel2 a1d eluzelz peano2zm syl
    wn cz clt wne df-ne eluzle wa zred eluzelre ltlend biimprd mpand syl5bir wb
    zltlem1 syl2anc sylibd 3jcad eluz2 syl6ibr orrd ) BACDZEZBAFZBGHIZUSEZUTVAR
    ZASEZVBSEZAVBJKZLVCUTVDVEVFVGUTVEVDABMZNUTVFVDUTBSEZVFABOZBPQNUTVDABTKZVGVD
    BAUAZUTVKBAUBUTABJKZVLVKABUCUTVKVMVLUDUTABUTAVHUEABUFUGUHUIUJUTVEVIVKVGUKVH
    VJABULUMUNUOAVBUPUQUR $.

  $( The nonnegative difference of integers is a nonnegative integer.
     (Contributed by NM, 4-Sep-2005.) $)
  uznn0sub $p |- ( N e. ( ZZ>= ` M ) -> ( N - M ) e. NN0 ) $=
    ( cuz cfv wcel cz cle wbr w3a cmin co cn0 eluz2 znn0sub biimp3a sylbi ) BAC
    DEAFEZBFEZABGHZIBAJKLEZABMQRSTABNOP $.

  $( Intersection of two upper intervals of integers.  (Contributed by Mario
     Carneiro, 24-Dec-2013.) $)
  uzin $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
    ( ( ZZ>= ` M ) i^i ( ZZ>= ` N ) ) = ( ZZ>= ` if ( M <_ N , N , M ) ) ) $=
    ( cz wcel wa cuz cfv wo cle wbr wceq wss uzss sylib eluzle fveq2d eqtr4d cr
    syl zre cin cif uztric sseqin2 iftrue eluzel2 eluzelz letri3 syl2an syl2anc
    df-ss biantrurd bitr4d biimprcd eqeq1d sylibrd com12 iffalse pm2.61d1 jaoi
    wb ) ACDZBCDZEBAFGZDZABFGZDZHVDVFUAZABIJZBAUBZFGZKZABUCVEVLVGVEVHVFVKVEVFVD
    LVHVFKABMVFVDUDNVEVJBFVEVIVJBKABOVIBAUEZSPQVGVHVDVKVGVDVFLVHVDKBAMVDVFUKNVG
    VJAFVGVIVJAKZVIVGVNVIVGBAKZVNVGVOVIVGVOBAIJZVIEZVIVGVCVBVOVQVAZBAUFBAUGVCBR
    DARDVRVBBTATBAUHUIUJVGVPVIBAOULUMUNVIVJBAVMUOUPUQVIBAURUSPQUTS $.

  $( Choices for an element of an upper interval of integers.  (Contributed by
     Jeff Madsen, 2-Sep-2009.) $)
  uzp1 $p |- ( N e. ( ZZ>= ` M ) -> ( N = M \/ N e. ( ZZ>= ` ( M + 1 ) ) ) ) $=
    ( cuz cfv wcel wceq c1 cmin co wo caddc uzm1 eluzp1p1 cc eluzelz zcnd npcan
    ax-1cn sylancl eleq1d syl5ib orim2d mpd ) BACDZEZBAFZBGHIZUDEZJUFBAGKICDZEZ
    JABLUEUHUJUFUHUGGKIZUIEUEUJAUGMUEUKBUIUEBNEGNEUKBFUEBABOPRBGQSTUAUBUC $.

  $( Nonnegative integers expressed as a set of upper integers.  (Contributed
     by NM, 2-Sep-2005.) $)
  nn0uz $p |- NN0 = ( ZZ>= ` 0 ) $=
    ( vk cn0 cc0 cv cle wbr cz crab cuz nn0zrab wcel wceq 0z uzval ax-mp eqtr4i
    cfv ) BCADEFAGHZCIQZAJCGKSRLMACNOP $.

  $( Natural numbers expressed as a set of upper integers.  (Contributed by NM,
     2-Sep-2005.) $)
  nnuz $p |- NN = ( ZZ>= ` 1 ) $=
    ( vk cn c1 cv cle wbr cz crab cuz cfv nnzrab wcel wceq uzval ax-mp eqtr4i
    1z ) BCADEFAGHZCIJZAKCGLSRMQACNOP $.

  $( A natural number expressed as a member of a set of upper integers.
     (Contributed by NM, 6-Jun-2006.) $)
  elnnuz $p |- ( N e. NN <-> N e. ( ZZ>= ` 1 ) ) $=
    ( cn c1 cuz cfv nnuz eleq2i ) BCDEAFG $.

  $( A nonnegative integer expressed as a member a set of upper integers.
     (Contributed by NM, 6-Jun-2006.) $)
  elnn0uz $p |- ( N e. NN0 <-> N e. ( ZZ>= ` 0 ) ) $=
    ( cn0 cc0 cuz cfv nn0uz eleq2i ) BCDEAFG $.

  $( The upper integers starting from a natural are a subset of the naturals.
     (Contributed by Scott Fenton, 29-Jun-2013.) $)
  uznnssnn $p |- ( N e. NN -> ( ZZ>= ` N ) C_ NN ) $=
    ( cn wcel cuz cfv c1 wss elnnuz uzss sylbi nnuz syl6sseqr ) ABCZADEZFDEZBMA
    OCNOGAHFAIJKL $.

  ${
    $d m n M $.
    $( Restricted universal quantification in a set of upper integers.
       (Contributed by NM, 9-Sep-2005.) $)
    raluz $p |- ( M e. ZZ -> ( A. n e. ( ZZ>= ` M ) ph <->
               A. n e. ZZ ( M <_ n -> ph ) ) ) $=
      ( cz wcel cv cle wbr wi cuz cfv wa eluz1 imbi1d impexp syl6bb ralbidv2 )
      CDEZACBFZGHZAIZBCJKZDRSUBEZAISDEZTLZAIUDUAIRUCUEACSMNUDTAOPQ $.

    $( Restricted universal quantification in a set of upper integers.
       (Contributed by NM, 9-Sep-2005.) $)
    raluz2 $p |- ( A. n e. ( ZZ>= ` M ) ph <->
               ( M e. ZZ -> A. n e. ZZ ( M <_ n -> ph ) ) ) $=
      ( cuz cfv wral cz wcel cv cle wbr wi w3a eluz2 3anass bitri imbi1i impexp
      wa imbi2i bi2.04 ralbii2 r19.21v ) ABCDEZFCGHZCBIZJKZALZLZBGFUEUHBGFLAUIB
      UDGUFUDHZALUEUFGHZUGSZSZALZUKUILZUJUMAUJUEUKUGMUMCUFNUEUKUGOPQUNUEUKUHLZL
      ZUOUNUEULALZLUQUEULARURUPUEUKUGARTPUEUKUHUAPPUBUEUHBGUCP $.

    $( Restricted existential quantification in a set of upper integers.
       (Contributed by NM, 9-Sep-2005.) $)
    rexuz $p |- ( M e. ZZ -> ( E. n e. ( ZZ>= ` M ) ph <->
               E. n e. ZZ ( M <_ n /\ ph ) ) ) $=
      ( cz wcel cv cle wbr wa cuz cfv eluz1 anbi1d anass syl6bb rexbidv2 ) CDEZ
      ACBFZGHZAIZBCJKZDQRUAEZAIRDEZSIZAIUCTIQUBUDACRLMUCSANOP $.

    $( Restricted existential quantification in a set of upper integers.
       (Contributed by NM, 9-Sep-2005.) $)
    rexuz2 $p |- ( E. n e. ( ZZ>= ` M ) ph <->
               ( M e. ZZ /\ E. n e. ZZ ( M <_ n /\ ph ) ) ) $=
      ( cuz cfv wrex cz wcel cv cle wbr wa eluz2 df-3an bitri anbi1i anass an12
      w3a rexbii2 r19.42v ) ABCDEZFCGHZCBIZJKZALZLZBGFUCUFBGFLAUGBUBGUDUBHZALUC
      UDGHZLZUELZALZUIUGLZUHUKAUHUCUIUESUKCUDMUCUIUENOPULUJUFLZUMUJUEAQUNUCUIUF
      LLUMUCUIUFQUCUIUFROOOTUCUFBGUAO $.

    $( Double existential quantification in a set of upper integers.
       (Contributed by NM, 3-Nov-2005.) $)
    2rexuz $p |- ( E. m E. n e. ( ZZ>= ` m ) ph <->
                  E. m e. ZZ E. n e. ZZ ( m <_ n /\ ph ) ) $=
      ( cv cuz cfv wrex wex cz wcel cle wbr wa rexuz2 exbii df-rex bitr4i ) ACB
      DZEFGZBHRIJRCDKLAMCIGZMZBHTBIGSUABACRNOTBIPQ $.
  $}

  $( Second Peano postulate for a set of upper integers.  (Contributed by NM,
     7-Sep-2005.) $)
  peano2uz $p |- ( N e. ( ZZ>= ` M ) ->
                 ( N + 1 ) e. ( ZZ>= ` M ) ) $=
    ( cz wcel cle wbr w3a c1 caddc co cuz cfv simp1 peano2z 3ad2ant2 zre letrp1
    cr syl3an2 eluz2 syl3an1 3jca 3imtr4i ) ACDZBCDZABEFZGZUDBHIJZCDZAUHEFZGBAK
    LZDUHUKDUGUDUIUJUDUEUFMUEUDUIUFBNOUDARDZUEUFUJAPUEULBRDUFUJBPABQSUAUBABTAUH
    TUC $.

  ${
    peano2uzs.1 $e |- Z = ( ZZ>= ` M ) $.
    $( Second Peano postulate for a set of upper integers.  (Contributed by
       Mario Carneiro, 26-Dec-2013.) $)
    peano2uzs $p |- ( N e. Z -> ( N + 1 ) e. Z ) $=
      ( c1 caddc co wcel cuz cfv peano2uz syl6eleqr eleq2s ) BEFGZCHBAIJZCBOHNO
      CABKDLDM $.
  $}

  $( Reversed second Peano axiom for upper integers.  (Contributed by NM,
     2-Jan-2006.) $)
  peano2uzr $p |- ( ( M e. ZZ /\
             N e. ( ZZ>= ` ( M + 1 ) ) ) -> N e. ( ZZ>= ` M ) ) $=
    ( cz wcel c1 caddc co cuz wa cmin wceq cc eluzelz zcnd ax-1cn npcan sylancl
    cfv adantl eluzp1m1 peano2uz syl eqeltrrd ) ACDZBAEFGZHRDZIZBEJGZEFGZBAHRZU
    FUIBKZUDUFBLDELDUKUFBUEBMNOBEPQSUGUHUJDUIUJDABTAUHUAUBUC $.

  ${
    $d j K $.  $d j k M $.  $d j k N $.
    $( Addition closure law for a set of upper integers.  (Contributed by NM,
       4-Jun-2006.) $)
    uzaddcl $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. NN0 ) ->
                   ( N + K ) e. ( ZZ>= ` M ) ) $=
      ( vj vk cn0 wcel cuz caddc co cv wi cc0 c1 wa wceq cc eleq1d oveq2 imbi2d
      eluzelz zcnd ax-1cn addass mp3an3 syl2anr adantr peano2uz adantl eqeltrrd
      cfv nn0cn exp31 a2d addid1d ibir nn0indALT impcom ) AFGCBHUKZGZCAIJZUSGZU
      TCDKZIJZUSGZLUTCMIJZUSGZLUTCEKZIJZUSGZLUTCVHNIJZIJZUSGZLUTVBLDEAVHFGZUTVJ
      VMVNUTVJVMVNUTOZVJOVINIJZVLUSVOVPVLPZVJUTCQGZVHQGZVQVNUTCBCUAUBZVHULVRVSN
      QGVQUCCVHNUDUEUFUGVJVPUSGVOBVIUHUIUJUMUNUTVGUTVFCUSUTCVTUORUPVCMPZVEVGUTW
      AVDVFUSVCMCISRTVCVHPZVEVJUTWBVDVIUSVCVHCISRTVCVKPZVEVMUTWCVDVLUSVCVKCISRT
      VCAPZVEVBUTWDVDVAUSVCACISRTUQUR $.
  $}

  ${
    $d j m N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.  $d k ph $.
    $d j k m M $.
    $( Substitutions. $)
    uzind4.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind4.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind4.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind4.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind4.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind4.6 $e |- ( k e. ( ZZ>= ` M ) -> ( ch -> th ) ) $.
    $( Induction on the set of upper integers that starts at an integer
       ` M ` .  The first four hypotheses give us the substitution instances we
       need, and the last two are the basis and the induction hypothesis.
       (Contributed by NM, 7-Sep-2005.) $)
    uzind4 $p |- ( N e. ( ZZ>= ` M ) -> ta ) $=
      ( vm wcel cz cle wbr cuz cfv cv crab eluzel2 eluzelz breq2 elrab sylanbrc
      eluzle wa wi w3a eluz2 biimpri 3expb sylan2b syl uzind3 syl2anc ) IHUAUBZ
      QZHRQZIHPUCZSTZPRUDZQZEHIUEVBIRQHISTZVGHIUFHIUJVEVHPIRVDIHSUGUHUIABCDEFPG
      HIJKLMNVCGUCZVFQZUKVIVAQZCDULVJVCVIRQZHVISTZUKVKVEVMPVIRVDVIHSUGUHVCVLVMV
      KVKVCVLVMUMHVIUNUOUPUQOURUSUT $.
  $}

  ${
    $d j N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.  $d k ph $.
    $d j k M $.
    $( Basis. $)
    uzind4ALT.5 $e |- ( M e. ZZ -> ps ) $.
    $( Induction hypothesis. $)
    uzind4ALT.6 $e |- ( k e. ( ZZ>= ` M ) -> ( ch -> th ) ) $.
    $( Substitutions. $)
    uzind4ALT.1 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind4ALT.2 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind4ALT.3 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind4ALT.4 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Induction on the set of upper integers that starts at an integer
       ` M ` .  The last four hypotheses give us the substitution instances we
       need; the first two are the basis and the induction hypothesis.  Either
       ~ uzind4 or ~ uzind4ALT may be used; see comment for ~ nnind .
       (Contributed by NM, 7-Sep-2005.) $)
    uzind4ALT $p |- ( N e. ( ZZ>= ` M ) -> ta ) $=
      ( uzind4 ) ABCDEFGHILMNOJKP $.
  $}

  ${
    $d m k j M $.  $d j N $.  $d j m ph $.
    $( Basis. $)
    uzind4s.1 $e |- ( M e. ZZ -> [. M / k ]. ph ) $.
    $( Induction hypothesis. $)
    uzind4s.2 $e |- ( k e. ( ZZ>= ` M )
         -> ( ph -> [. ( k + 1 ) / k ]. ph ) ) $.
    $( Induction on the set of upper integers that starts at an integer ` M ` ,
       using explicit substitution.  The hypotheses are the basis and the
       induction hypothesis.  (Contributed by NM, 4-Nov-2005.) $)
    uzind4s $p |- ( N e. ( ZZ>= ` M ) -> [. N / k ]. ph ) $=
      ( vj vm wsb wsbc cv c1 caddc co dfsbcq2 sbequ wcel wi nfim imbi12d cuz wb
      cfv nfv nfs1v nfsbc1v weq eleq1 sbequ12 wceq oveq1 dfsbcq chvar uzind4
      syl ) ABGIABCJABHIZABHKZLMNZJZABDJGHCDABGCOAGHBPABGUROABGDOEBKZCUAUCZQZAA
      BUTLMNZJZRZRUQVAQZUPUSRZRBHVFVGBVFBUDUPUSBABHUEABURUFSSBHUGZVBVFVEVGUTUQV
      AUHVHAUPVDUSABHUIVHVCURUJVDUSUBUTUQLMUKABVCURULUOTTFUMUN $.
  $}

  ${
    $d k m n M $.  $d m N $.  $d k m n ph $.  $d j k m n $.
    $( Basis. $)
    uzind4s2.1 $e |- ( M e. ZZ -> [. M / j ]. ph ) $.
    $( Induction hypothesis. $)
    uzind4s2.2 $e |- ( k e. ( ZZ>= ` M ) ->
                     ( [. k / j ]. ph -> [. ( k + 1 ) / j ]. ph ) ) $.
    $( Induction on the set of upper integers that starts at an integer ` M ` ,
       using explicit substitution.  The hypotheses are the basis and the
       induction hypothesis.  Use this instead of ~ uzind4s when ` j ` and
       ` k ` must be distinct in ` [. ( k + 1 ) / j ]. ph ` .  (Contributed by
       NM, 16-Nov-2005.) $)
    uzind4s2 $p |- ( N e. ( ZZ>= ` M ) -> [. N / j ]. ph ) $=
      ( vm vn cv wsbc c1 caddc co dfsbcq wi cuz cfv weq wceq wb imbi12d vtoclga
      oveq1 syl uzind4 ) ABHJZKABDKABIJZKZABUHLMNZKZABEKHIDEABUGDOABUGUHOABUGUJ
      OABUGEOFABCJZKZABULLMNZKZPUIUKPCUHDQRCISZUMUIUOUKABULUHOUPUNUJTUOUKUAULUH
      LMUDABUNUJOUEUBGUCUF $.
  $}

  ${
    $d j m N $.  $d j ps $.  $d j ch $.  $d j th $.  $d j ta $.  $d k ph $.
    $d j k m M $.
    $( Lower bound. $)
    uzind4i.1 $e |- M e. ZZ $.
    $( Substitutions. $)
    uzind4i.2 $e |- ( j = M -> ( ph <-> ps ) ) $.
    uzind4i.3 $e |- ( j = k -> ( ph <-> ch ) ) $.
    uzind4i.4 $e |- ( j = ( k + 1 ) -> ( ph <-> th ) ) $.
    uzind4i.5 $e |- ( j = N -> ( ph <-> ta ) ) $.
    $( Basis. $)
    uzind4i.6 $e |- ps $.
    $( Induction hypothesis. $)
    uzind4i.7 $e |- ( k e. ( ZZ>= ` M ) -> ( ch -> th ) ) $.
    $( Induction on the upper integers that start at ` M ` .  The first
       hypothesis specifies the lower bound, the next four give us the
       substitution instances we need, and the last two are the basis and the
       induction hypothesis.  (Contributed by NM, 4-Sep-2005.) $)
    uzind4i $p |- ( N e. ( ZZ>= ` M ) -> ta ) $=
      ( cz wcel a1i uzind4 ) ABCDEFGHIKLMNBHQROSPT $.
  $}

  ${
    $d h t n m M $.  $d h j t k m n S $.
    $( Well-ordering principle: any non-empty subset of a set of upper integers
       has the least element.  (Contributed by NM, 8-Oct-2005.) $)
    uzwo $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) ) ->
               E. j e. S A. k e. S j <_ k ) $=
      ( vt vn wa cv cle wbr wral wn wcel wceq wi breq1 ralbidv imbi2d cz wb cuz
      vh vm cfv wss c0 wne wrex wal c1 caddc co ssel eluzle ralrimiv adantr a1i
      syl6 uzssz mpan2 eluzelz rspcev expcom con3rr3 ssel2 cr zre letri3 syl2an
      clt zleltp1 peano2re syl ltnle bitrd ancoms anbi2d sylan2 eleq1a ad2antll
      sstr sylbird exp3a con1 com23 exp32 com34 ralimdva sylan9r pm2.43d sylani
      ex expl a2d uzind4 adantl sylcom adantrd pm2.61i alrimdv syl6ibr necon1ad
      imp41 eq0 imp breq2 cbvralv rexbii sylib ) ADUAUDZUEZAUFUGZGBHZEHZIJZEAKZ
      BAUHZXMCHZIJZCAKZBAUHXKXLXQXKXQAUFXKXQLZFHZAMZLZFUIAUFNXKYAYDFXKYAYDYBXJM
      ZXKYAGZYDOYEYFYBXNIJZEAKZYDYFUBHZXNIJZEAKZOYFDXNIJZEAKZOZYFUCHZXNIJZEAKZO
      YFYOUJUKULZXNIJZEAKZOYFYHOUBUCDYBYIDNZYKYMYFUUAYJYLEAYIDXNIPQRYIYONZYKYQY
      FUUBYJYPEAYIYOXNIPQRYIYRNZYKYTYFUUCYJYSEAYIYRXNIPQRYIYBNZYKYHYFUUDYJYGEAY
      IYBXNIPQRYNDSMXKYMYAXKYLEAXKXNAMZXNXJMYLAXJXNUMDXNUNURUOUPUQYOXJMZYFYQYTX
      KUUFASUEZYAYQYTOZXKXJSUEUUGDUSAXJSWAUTUUFYOSMZUUGYAGUUHODYOVAUUIUUGYAUUHU
      UIUUGGZYAGYQYTYAYQYOAMZLZUUJUUHYQUUKXQUUKYQXQXPYQBYOAXMYONXOYPEAXMYOXNIPQ
      VBVCVDUUJUULUUHUUJUULGYPYSEAUUIUUGUULUUEYPYSOZUUIUUGUUEUULUUMUUIUUGUUEUUL
      UUMOUUIUUGUUEGZGZYPUULYSUUOYPYSLZUUKOUULYSOUUOYPUUPUUKUUOYPUUPGZYOXNNZUUK
      UUNUUIXNSMZUURUUQTASXNVEUUIUUSGZUURYPXNYOIJZGZUUQUUIYOVFMZXNVFMZUURUVBTUU
      SYOVGZXNVGZYOXNVHVIUUTUVAUUPYPUUSUUIUVAUUPTUUSUUIGUVAXNYRVJJZUUPXNYOVKUUS
      UVDYRVFMZUVGUUPTUUIUVFUUIUVCUVHUVEYOVLVMXNYRVNVIVOVPVQVOVRUUEUURUUKOUUIUU
      GXNAYOVSVTWBWCYSUUKWDURWEWFWGXCWHWLWIWJWMVMWKWNWOYAYHYDOXKYHYCXQYCYHXQXPY
      HBYBAXMYBNXOYGEAXMYBXNIPQVBVCVDWPWQYELXKYDYAXKYCYEAXJYBUMVDWRWSWLWTFAXDXA
      XBXEXPXTBAXOXSECAXNXRXMIXFXGXHXI $.

    $( Well-ordering principle: any non-empty subset of the upper integers has
       the least element.  (Contributed by NM, 8-Oct-2005.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uzwoOLD $p |- ( ( S C_ ( ZZ>= ` M ) /\ -. S = (/) ) ->
               E. j e. S A. k e. S j <_ k ) $=
      ( vt vn wceq wn wa cv cle wbr wral wcel wi breq1 ralbidv imbi2d cz wb cuz
      vh vm cfv wss c0 wrex wal c1 caddc ssel eluzle syl6 ralrimiv adantr uzssz
      co a1i mpan2 eluzelz rspcev expcom con3rr3 ssel2 cr zre letri3 syl2an clt
      sstr zleltp1 peano2re syl ltnle bitrd ancoms anbi2d sylan2 eleq1a sylbird
      ad2antll exp3a con1 com23 exp32 com34 imp41 ralimdva sylan9r pm2.43d expl
      sylani a2d uzind4 adantl sylcom adantrd pm2.61i alrimdv eq0 syl6ibr con1d
      ex imp breq2 cbvralv rexbii sylib ) ADUAUDZUEZAUFGZHZIBJZEJZKLZEAMZBAUGZX
      MCJZKLZCAMZBAUGXJXLXQXJXQXKXJXQHZFJZANZHZFUHXKXJYAYDFXJYAYDYBXINZXJYAIZYD
      OYEYFYBXNKLZEAMZYDYFUBJZXNKLZEAMZOYFDXNKLZEAMZOZYFUCJZXNKLZEAMZOYFYOUIUJU
      QZXNKLZEAMZOYFYHOUBUCDYBYIDGZYKYMYFUUAYJYLEAYIDXNKPQRYIYOGZYKYQYFUUBYJYPE
      AYIYOXNKPQRYIYRGZYKYTYFUUCYJYSEAYIYRXNKPQRYIYBGZYKYHYFUUDYJYGEAYIYBXNKPQR
      YNDSNXJYMYAXJYLEAXJXNANZXNXINYLAXIXNUKDXNULUMUNUOURYOXINZYFYQYTXJUUFASUEZ
      YAYQYTOZXJXISUEUUGDUPAXISVJUSUUFYOSNZUUGYAIUUHODYOUTUUIUUGYAUUHUUIUUGIZYA
      IYQYTYAYQYOANZHZUUJUUHYQUUKXQUUKYQXQXPYQBYOAXMYOGXOYPEAXMYOXNKPQVAVBVCUUJ
      UULUUHUUJUULIYPYSEAUUIUUGUULUUEYPYSOZUUIUUGUUEUULUUMUUIUUGUUEUULUUMOUUIUU
      GUUEIZIZYPUULYSUUOYPYSHZUUKOUULYSOUUOYPUUPUUKUUOYPUUPIZYOXNGZUUKUUNUUIXNS
      NZUURUUQTASXNVDUUIUUSIZUURYPXNYOKLZIZUUQUUIYOVENZXNVENZUURUVBTUUSYOVFZXNV
      FZYOXNVGVHUUTUVAUUPYPUUSUUIUVAUUPTUUSUUIIUVAXNYRVILZUUPXNYOVKUUSUVDYRVENZ
      UVGUUPTUUIUVFUUIUVCUVHUVEYOVLVMXNYRVNVHVOVPVQVOVRUUEUURUUKOUUIUUGXNAYOVSW
      AVTWBYSUUKWCUMWDWEWFWGWHXCWIWJWKVMWLWMWNYAYHYDOXJYHYCXQYCYHXQXPYHBYBAXMYB
      GXOYGEAXMYBXNKPQVAVBVCWOWPYEHXJYDYAXJYCYEAXIYBUKVCWQWRXCWSFAWTXAXBXDXPXTB
      AXOXSECAXNXRXMKXEXFXGXH $.

    $( Well-ordering principle: any non-empty subset of upper integers has a
       unique least element.  (Contributed by NM, 8-Oct-2005.) $)
    uzwo2 $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) ) ->
               E! j e. S A. k e. S j <_ k ) $=
      ( cuz cfv wss c0 wne cv cle wbr wral wrex wreu uzwo cr cz uzssz zssre
      sstri sstr mpan2 lbreu sylan syldan ) ADEFZGZAHIBJCJKLCAMZBANZUIBAOZABCDP
      UHAQGZUJUKUHUGQGULUGRQDSTUAAUGQUBUCBCAUDUEUF $.
  $}

  ${
    $d x y A $.
    $( Well-ordering principle: any non-empty set of natural numbers has a
       least element.  Theorem I.37 (well-ordering principle) of [Apostol]
       p. 34.  (Contributed by NM, 17-Aug-2001.) $)
    nnwo $p |- ( ( A C_ NN /\ A =/= (/) ) -> E. x e. A A. y e. A x <_ y ) $=
      ( cn wss c1 cuz cfv c0 wne cv cle wbr wral wrex nnuz sseq2i uzwo sylanb )
      CDECFGHZECIJAKBKLMBCNACODTCPQCABFRS $.
  $}

  ${
    $d x y z w v $.  $d w v z A $.
    nnwof.1 $e |- F/_ x A $.
    nnwof.2 $e |- F/_ y A $.
    $( Well-ordering principle: any non-empty set of natural numbers has a
       least element.  This version allows ` x ` and ` y ` to be present in
       ` A ` as long as they are effectively not free.  (Contributed by NM,
       17-Aug-2001.)  (Revised by Mario Carneiro, 15-Oct-2016.) $)
    nnwof $p |- ( ( A C_ NN /\ A =/= (/) ) -> E. x e. A A. y e. A x <_ y ) $=
      ( vw vv cn wss c0 wne wa cv cle wbr wral wrex nnwo nfcv nfv nfral ralbidv
      weq breq1 breq2 cbvralf syl6bb cbvrexf sylib ) CHICJKLFMZGMZNOZGCPZFCQAMZ
      BMZNOZBCPZACQFGCRUMUQFACFCSDULAGCDULATUAUQFTFAUCZUMUNUKNOZGCPUQURULUSGCUJ
      UNUKNUDUBUSUPGBCGCSEUSBTUPGTUKUOUNNUEUFUGUHUI $.
  $}

  ${
    $d x y z $.  $d y z ph $.  $d x ps $.
    nnwos.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Well-ordering principle: any non-empty set of natural numbers has a
       least element (schema form).  (Contributed by NM, 17-Aug-2001.) $)
    nnwos $p |- ( E. x e. NN ph ->
                  E. x e. NN ( ph /\ A. y e. NN ( ps -> x <_ y ) ) ) $=
      ( cn crab wa cv wral wrex bitr3i wcel wex wal df-rex df-ral bitri exbii
      wi wss c0 wne cle wbr nfrab1 nfcv nnwof ssrab2 biantrur rabn0 rabid elrab
      imbi1i impexp albii anbi12i anbi2i anass bitr4i 3bitri 3imtr3i ) ACFGZFUA
      ZVCUBUCZHZCIZDIZUDUEZDVCJZCVCKZACFKZABVITZDFJZHZCFKZCDVCACFUFDVCUGUHVFVEV
      LVDVEACFUIUJACFUKLVKVGVCMZVJHZCNVGFMZAHZVHFMZVMTZDOZHZCNZVPVJCVCPVRWDCVQV
      TVJWCACFULVJVHVCMZVITZDOWCVIDVCQWGWBDWGWABHZVITWBWFWHVIABCVHFEUMUNWABVIUO
      RUPRUQSWEVSVOHZCNVPWDWICWDVTVNHWIVNWCVTVMDFQURVSAVNUSLSVOCFPUTVAVB $.
  $}

  ${
    $d x y $.  $d y ph $.  $d x ps $.
    $( Substitutions. $)
    indstr.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Induction hypothesis. $)
    indstr.2 $e |- ( x e. NN -> ( A. y e. NN ( y < x -> ps ) -> ph ) ) $.
    $( Strong Mathematical Induction for positive integers (inference schema).
       (Contributed by NM, 17-Aug-2001.) $)
    indstr $p |- ( x e. NN -> ph ) $=
      ( cn wral wn wrex cv cle wbr wi wa wcel pm3.24 clt cr nnre syl2an syl6bbr
      wb lenlt imbi2d con34b ralbidva sylbid anim2d syl6ib mtoi nrex weq notbid
      ancom nnwos mto dfral2 mpbir rspec ) ACGACGHAIZCGJZIVBVABIZCKZDKZLMZNZDGH
      ZOZCGJVICGVDGPZVIAVAOZAQVJVIVAAOVKVJVHAVAVJVHVEVDRMZBNZDGHAVJVGVMDGVJVEGP
      ZOZVGVCVLIZNVMVOVFVPVCVJVDSPVESPVFVPUCVNVDTVETVDVEUDUAUEVLBUFUBUGFUHUIVAA
      UOUJUKULVAVCCDCDUMABEUNUPUQACGURUSUT $.
  $}

  $( Membership in a nonegative set of upper integers implies membership in
     ` NN0 ` .  (Contributed by Paul Chapman, 22-Jun-2011.) $)
  eluznn0 $p |- ( ( N e. NN0 /\ M e. ( ZZ>= ` N ) ) -> M e. NN0 ) $=
    ( cc0 cn0 nn0uz uztrn2 ) CABDEF $.

  $( Two ways to say "an integer greater than or equal to 2."  (Contributed by
     Paul Chapman, 23-Nov-2012.) $)
  eluz2b1 $p |- ( N e. ( ZZ>= ` 2 ) <-> ( N e. ZZ /\ 1 < N ) ) $=
    ( c2 cuz cfv wcel cz cle wbr wa c1 clt 2z eluz1i caddc co zltp1le mpan df-2
    wb 1z breq1i syl6bbr pm5.32i bitr4i ) ABCDEAFEZBAGHZIUEJAKHZIBALMUEUGUFUEUG
    JJNOZAGHZUFJFEUEUGUISTJAPQBUHAGRUAUBUCUD $.

  $( Two ways to say "an integer greater than or equal to 2."  (Contributed by
     Paul Chapman, 23-Nov-2012.) $)
  eluz2b2 $p |- ( N e. ( ZZ>= ` 2 ) <-> ( N e. NN /\ 1 < N ) ) $=
    ( c2 cuz cfv wcel cz c1 clt wbr wa cn eluz2b1 cle cr 1re zre ltle imdistani
    wi sylancr elnnz1 sylibr simpr jca nnz anim1i impbii bitri ) ABCDEAFEZGAHIZ
    JZAKEZUJJZALUKUMUKULUJUKUIGAMIZJULUIUJUNUIGNEANEUJUNSOAPGAQTRAUAUBUIUJUCUDU
    LUIUJAUEUFUGUH $.

  $( Two ways to say "an integer greater than or equal to 2."  (Contributed by
     Paul Chapman, 23-Nov-2012.) $)
  eluz2b3 $p |- ( N e. ( ZZ>= ` 2 ) <-> ( N e. NN /\ N =/= 1 ) ) $=
    ( c2 cuz cfv wcel cn c1 clt wbr wa wne eluz2b2 nngt1ne1 pm5.32i bitri ) ABC
    DEAFEZGAHIZJPAGKZJALPQRAMNO $.

  $( One less than an integer greater than or equal to 2 is a positive
     integer.  (Contributed by Paul Chapman, 17-Nov-2012.) $)
  uz2m1nn $p |- ( N e. ( ZZ>= ` 2 ) -> ( N - 1 ) e. NN ) $=
    ( c2 cuz cfv wcel cz c1 clt wbr wa cmin co cn eluz2b1 wb znnsub mpan biimpa
    1z sylbi ) ABCDEAFEZGAHIZJAGKLMEZANUAUBUCGFEUAUBUCOSGAPQRT $.

  $( 1 is not in ` ( ZZ>= `` 2 ) ` .  (Contributed by Paul Chapman,
     21-Nov-2012.) $)
  1nuz2 $p |- -. 1 e. ( ZZ>= ` 2 ) $=
    ( c1 c2 cuz cfv wcel wne neirr cn eluz2b3 simprbi mto ) ABCDEZAAFZAGLAHEMAI
    JK $.

  $( A positive integer is either 1 or greater than or equal to 2.
     (Contributed by Paul Chapman, 17-Nov-2012.) $)
  elnn1uz2 $p |- ( N e. NN <-> ( N = 1 \/ N e. ( ZZ>= ` 2 ) ) ) $=
    ( c1 wceq c2 cuz cfv wcel wo cn wne wa eluz2b3 orbi2i exmidne ordi mpbiran2
    wi 1nn eleq1 mpbiri pm2.621 ax-mp olc impbii 3bitrri ) ABCZADEFGZHUFAIGZABJ
    ZKZHZUFUHHZUHUGUJUFALMUKULUFUIHABNUFUHUIOPULUHUFUHQULUHQUFUHBIGRABISTUFUHUA
    UBUHUFUCUDUE $.

  $( Closure of multiplication of integers greater than or equal to 2.
     (Contributed by Paul Chapman, 26-Oct-2012.) $)
  uz2mulcl $p |- ( ( M e. ( ZZ>= ` 2 ) /\ N e. ( ZZ>= ` 2 ) ) ->
                   ( M x. N ) e. ( ZZ>= ` 2 ) ) $=
    ( c2 cuz cfv wcel wa cmul co cz c1 clt wbr eluzelz syl2an cr eluz2b1 anim1i
    zre sylbi zmulcl mulgt1 an4s sylanbrc ) ACDEZFZBUEFZGABHIZJFZKUHLMZUHUEFUFA
    JFZBJFZUIUGCANCBNABUAOUFAPFZKALMZGZBPFZKBLMZGZUJUGUFUKUNGUOAQUKUMUNASRTUGUL
    UQGURBQULUPUQBSRTUMUPUNUQUJABUBUCOUHQUD $.

  ${
    $d ph y $.  $d ps x $.  $d x y $.
    indstr2.1 $e |- ( x = 1 -> ( ph <-> ch ) ) $.
    indstr2.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    indstr2.3 $e |- ch $.
    indstr2.4 $e |- ( x e. ( ZZ>= ` 2 ) ->
                      ( A. y e. NN ( y < x -> ps ) -> ph ) ) $.
    $( Strong Mathematical Induction for positive integers (inference schema).
       The first two hypotheses give us the substitution instances we need; the
       last two are the basis and the induction hypothesis.  (Contributed by
       Paul Chapman, 21-Nov-2012.) $)
    indstr2 $p |- ( x e. NN -> ph ) $=
      ( cv cn wcel c1 wceq c2 cuz clt wbr wi wb cfv wral elnn1uz2 nnnlt1 adantl
      wo wa wn breq2 adantr mtbird pm2.21d ralrimiva pm5.5 syl bitrd jaoi sylbi
      mpbiri indstr ) ABDEGDJZKLVAMNZVAOPUALZUFEJZVAQRZBSZEKUBZASZVAUCVBVHVCVBV
      HCHVBVHACVBVGVHATVBVFEKVBVDKLZUGZVEBVJVEVDMQRZVIVKUHVBVDUDUEVBVEVKTVIVAMV
      DQUIUJUKULUMVGAUNUOFUPUSIUQURUT $.
  $}

  ${
    $d j k M $.
    uzinfm.1 $e |- M e. ZZ $.
    $( Extract the lower bound of a set of upper integers as its infimum.  Note
       that the " ` ``' < ` " argument turns supremum into infimum (for which
       we do not currently have a separate notation).  (Contributed by NM,
       7-Oct-2005.) $)
    uzinfmi $p |- sup ( ( ZZ>= ` M ) , RR , `' < ) = M $=
      ( vj vk cuz cfv cr clt ccnv csup cv cle wbr wral crio wss wceq wcel mp2an
      cz wrex uzssz zssre sstri uzid ax-mp eluzle rgen breq1 rspcev lbinfm wreu
      ralbidv wb lbreu riota2 mpbi eqtri ) AEFZGHIJZCKZDKZLMZDUSNZCUSOZAUSGPZVD
      CUSUAZUTVEQUSTGAUBUCUDZAUSRZAVBLMZDUSNZVGATRVIBAUEUFZVJDUSAVBUGUHZVDVKCAU
      SVAAQVCVJDUSVAAVBLUIUMZUJSZCDUSUKSVKVEAQZVMVIVDCUSULZVKVPUNVLVFVGVQVHVOCD
      USUOSVDVKCUSAVNUPSUQUR $.
  $}

  $( The infimum of the set of natural numbers is one.  Note
     that " ` ``' < ` " turns sup into inf.  (Contributed by NM,
     16-Jun-2005.) $)
  nninfm $p |- sup ( NN , RR , `' < ) = 1 $=
    ( cn cr clt ccnv csup c1 cuz cfv nnuz supeq1i 1z uzinfmi eqtri ) ABCDZEFGHZ
    BNEFBAONIJFKLM $.

  $( The infimum of the set of nonnegative integers is zero.  Note
     that " ` ``' < ` " turns sup into inf.  (Contributed by NM,
     16-Jun-2005.) $)
  nn0infm $p |- sup ( NN0 , RR , `' < ) = 0 $=
    ( cn0 cr clt ccnv csup cc0 cuz cfv nn0uz supeq1i 0z uzinfmi eqtri ) ABCDZEF
    GHZBNEFBAONIJFKLM $.

  ${
    $d j k S $.  $d k A $.
    $( The infimum of a subset of a set of upper integers is less than or equal
       to all members of the subset.  Note that the " ` ``' < ` " argument
       turns supremum into infimum (for which we do not currently have a
       separate notation).  (Contributed by NM, 11-Oct-2005.) $)
    infmssuzle $p |- ( ( S C_ ( ZZ>= ` M ) /\ A e. S ) ->
                sup ( S , RR , `' < ) <_ A ) $=
      ( vj vk cuz cfv wss wcel cv cle wbr wral wrex cr clt ccnv csup c0 wne cz
      ne0i uzwo sylan2 uzssz zssre sstri mpan2 lbinfmle 3com23 syl3an1 mpd3an3
      sstr ) BCFGZHZABIZDJEJKLEBMDBNZBOPQRAKLZUPUOBSTUQBAUBBDECUCUDUOBOHZUPUQUR
      UOUNOHUSUNUAOCUEUFUGBUNOUMUHUSUQUPURDEABUIUJUKUL $.

    $( The infimum of a subset of a set of upper integers belongs to the
       subset.  (Contributed by NM, 11-Oct-2005.) $)
    infmssuzcl $p |- ( ( S C_ ( ZZ>= ` M ) /\ S =/= (/) ) ->
                  sup ( S , RR , `' < ) e. S ) $=
      ( vj vk cuz cfv wss c0 wne wa cr cv cle wbr wral wrex clt ccnv csup wcel
      cz uzssz zssre sstri sstr mpan2 adantr uzwo lbinfmcl syl2anc ) ABEFZGZAHI
      ZJAKGZCLDLMNDAOCAPAKQRSATULUNUMULUKKGUNUKUAKBUBUCUDAUKKUEUFUGACDBUHCDAUIU
      J $.
  $}

  ${
    $d A a b x y z $.
    $( The image under negation of a bounded-above set of reals is bounded
       below.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    ublbneg $p |- ( E. x e. RR A. y e. A y <_ x ->
                    E. x e. RR A. y e. { z e. RR | -u z e. A } x <_ y ) $=
      ( vb va cv cle wbr wral cr wrex cneg wcel crab breq1 cbvralv wceq ralbidv
      rexbii breq2 cbvrexv bitri renegcl wa wi elrabi negeq eleq1d elrab3 mpcom
      biimpd rspcv adantl wb lenegcon1 sylan2 sylibrd ralrimdva rspcev rexlimiv
      syl ee12an sylbir ) BGZAGZHIZBDJZAKLZEGZFGZHIZEDJZFKLZVFVEHIZBCGZMZDNZCKO
      ZJZAKLZVNVEVKHIZBDJZFKLVIVMWCFKVLWBEBDVJVEVKHPQTWCVHFAKVKVFRWBVGBDVKVFVEH
      UASUBUCVMWAFKVKKNZVKMZKNVMWEVEHIZBVSJZWAVKUDWDVMWFBVSWDVEVSNZUEVMVEMZVKHI
      ZWFWHVMWJUFZWDWHWIDNZWKVEKNZWHWLVRCVEKUGZWMWHWLVRWLCVEKVPVERVQWIDVPVEUHUI
      UJULUKVLWJEWIDVJWIVKHPUMVBUNWHWDWMWFWJUOWNVKVEUPUQURUSVTWGAWEKVFWERVOWFBV
      SVFWEVEHPSUTVCVAVD $.
  $}

  ${
    $d A w z $.
    $( Two ways to express the image under negation of a set of integers.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    eqreznegel $p |- ( A C_ ZZ ->
                       { z e. RR | -u z e. A } = { z e. ZZ | -u z e. A } ) $=
      ( vw cz wss cv cneg wcel cr crab wa wi ssel cc recn caddc cc0 negid elrab
      co 0z syl6eqel pm4.71i zrevaddcl syl5bb syl5ib syl6 com23 imp3a simpr a1i
      jcad zre anim1i impbid1 weq negeq eleq1d 3bitr4g eqrdv ) BDEZCAFZGZBHZAIJ
      ZVDADJZVACFZIHZVGGZBHZKZVGDHZVJKZVGVEHVGVFHVAVKVMVAVKVLVJVAVHVJVLVAVJVHVL
      VAVJVIDHZVHVLLBDVIMVHVGNHZVNVLVGOVOVOVGVIPTZDHZKVNVLVOVQVOVPQDVGRUAUBUCVG
      VIUDUEUFUGUHUIVKVJLVAVHVJUJUKULVLVHVJVGUMUNUOVDVJAVGIACUPVCVIBVBVGUQURZSV
      DVJAVGDVRSUSUT $.
  $}

  ${
    $d A w x y z $.
    $( The image under negation of a nonempty set of reals is nonempty.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    negn0 $p |- ( ( A C_ RR /\ A =/= (/) ) ->
                  { z e. RR | -u z e. A } =/= (/) ) $=
      ( vx vy cr wss c0 wne cv cneg wcel crab wex n0 ssel wb renegcl wceq negeq
      eleq1d elrab3 syl recn negnegd bitrd biimprd elex2 syl6ibr exlimdv syl5bi
      syli syl6 imp ) BEFZBGHZAIZJZBKZAELZGHZUOCIZBKZCMUNUTCBNUNVBUTCUNVBDIUSKD
      MZUTUNVBVAJZUSKZVCVBUNVAEKZVEBEVAOVFVEVBVFVEVDJZBKZVBVFVDEKVEVHPVAQURVHAV
      DEUPVDRUQVGBUPVDSTUAUBVFVGVABVFVAVAUCUDTUEUFUKDVDUSUGULDUSNUHUIUJUM $.

    $( The supremum of a bounded-above set of reals is the negation of the
       supremum of that set's image under negation.  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    supminf $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
      sup ( A , RR , < ) = -u sup ( { z e. RR | -u z e. A } , RR , `' < ) ) $=
      ( vw cr wss c0 wne cv cle cneg wcel clt csup wceq syl2an wb eleq1d recn
      wbr wral wrex w3a crab ccnv wa negn0 ublbneg ssrab2 infmsup mp3an1 elrabi
      3impa adantl ssel2 negeq elrab3 renegcl syl negnegd 3bitrd eqrdav supeq1d
      3ad2ant1 negeqd eqtrd infmrcl suprcl cc negcon2 syl2anc mpbid ) DFGZDHIZB
      JZAJZKUABDUBAFUCZUDZCJZLZDMZCFUEZFNUFOZDFNOZLZPZWEWDLPZVSWDEJZLZWCMZEFUEZ
      FNOZLZWFVNVOVRWDWNPZVNVOUGZWCHIZVQVPKUABWCUBAFUCZWOVRCDUHZABCDUIZWCFGZWQW
      RWOWBCFUJZABEWCUKULQUNVSWMWEVNVOWMWEPVRVNFWLDNVNAWLDFVQWLMZVQFMZVNWKEVQFU
      MUODFVQUPXDXCVQDMZRVNXDXCVQLZWCMZXFLZDMZXEWKXGEVQFWIVQPWJXFWCWIVQUQSURXDX
      FFMXGXIRVQUSWBXICXFFVTXFPWAXHDVTXFUQSURUTXDXHVQDXDVQVQTVASVBUOVCVDVEVFVGV
      SWDFMZWEFMZWGWHRZVNVOVRXJWPWQWRXJVRWSWTXAWQWRXJXBABWCVHULQUNABDVIXJWDVJMW
      EVJMXLXKWDTWETWDWEVKQVLVM $.

    $( If a set of reals is bounded below, it is bounded below by an integer.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    lbzbi $p |- ( A C_ RR -> ( E. x e. RR A. y e. A x <_ y <->
                               E. x e. ZZ A. y e. A x <_ y ) ) $=
      ( vz cr wss cv cle wbr wral wrex cz wcel wi wa clt w3a expdimp com23 ex
      nfv nfre1 btwnz simpld ssel2 zre ltletr ltle 3adant2 syl3an1 exp3a 3expia
      syld syl5 imp ralrimiv ralim syl anasss expcom imdistand weq breq1 rspcev
      ralbidv syl6 ancomsd rexlimdv mpdi rexlimd zssre ssrexv ax-mp impbid1 ) C
      EFZAGZBGZHIZBCJZAEKZVSALKZVOVSWAAEVOAUAVSALUBVOVSVPEMZWAVOVSWBWANVOVSOZWB
      DGZVPPIZDLKZWAWBWFVPWDPIDLKDDVPUCUDWBWCWFWANZWBVOVSWGWBVOOZVSOWEWADLWHVSW
      DLMZWEWANZWHWIVSWJWHWEWIVSOZWAWHWEWKWANWHWEOZWKWIWDVQHIZBCJZOWAWLWIVSWNWH
      WEWIVSWNNZNWHWIWEWOWIWHWEWONZWIWBVOWPWIWBOZVOOZWEWOWRWEOZVRWMNZBCJWOWSWTB
      CWRWEVQCMZWTNWRXAWEWTWQVOXAWEWTNZVOXAOVQEMZWQXBCEVQUEWIWBXCXBWIWBXCQWEVRW
      MWIWDEMZWBXCWEVROZWMNWDUFXDWBXCQXEWDVQPIZWMWDVPVQUGXDXCXFWMNWBWDVQUHUIUMU
      JUKULUNRSUOUPVRWMBCUQURTUSUTSUOVAVSWNAWDLADVBVRWMBCVPWDVQHVCVEVDVFTSVGRVH
      USUTVITSVJLEFWAVTNVKVSALEVLVMVN $.
  $}

  ${
    $d m n w x y z A $.  $d n x B $.  $d x y M $.  $d x Z $.
    $( Any nonempty bounded subset of integers has a supremum in the set.  (The
       proof does not use ~ ax-pre-sup .)  (Contributed by Mario Carneiro,
       21-Apr-2015.) $)
    zsupss $p |- ( ( A C_ ZZ /\ A =/= (/) /\ E. x e. ZZ A. y e. A y <_ x ) ->
                    E. x e. A ( A. y e. A -. x < y /\
                      A. y e. B ( y < x -> E. z e. A y < z ) ) ) $=
      ( vm vn vw cz cv cle wbr wral wrex clt wa wceq wcel cneg zred c0 wn breq1
      wss wne wi cbvralv breq2 ralbidv syl5bb cbvrexv crab cr ccnv csup cuz cfv
      simp1rl znegcld simp2 simp3 simp1rr rspcv sylc lenegcon1d eluz2 syl3anbrc
      w3a rabssdv wex n0 ssel2 zcnd negnegd simpr eqeltrd eleq1d rspcev syl2anc
      negeq exlimdv imp sylan2b adantr sylibr infmssuzcl cbvrabv elrab2 simprbi
      ex rabn0 ssrab2 sseldi simpll sselda elrab sylanbrc infmssuzle lenegcon2d
      lenltd mpbid ralrimiva ralrimivw notbid imbi1d syl12anc rexlimdvaa syl5bi
      syl anbi12d 3impia ) DIUDZDUAUEZBJZAJZKLZBDMZAINZXOXNOLZUBZBDMZXNXOOLZXNC
      JZOLZCDNZUFZBEMZPZADNZXRFJZGJZKLZFDMZGINXLXMPZYIXQYMAGIXQYJXOKLZFDMXOYKQZ
      YMXPYOBFDXNYJXOKUCUGYPYOYLFDXOYKYJKUHUIUJUKYNYMYIGIYNYKIRZYMPZPZHJZSZDRZH
      IULZUMOUNUOZSZDRZUUEXNOLZUBZBDMZXNUUEOLZYEUFZBEMZYIYSUUDUUCRZUUFYSUUCYKSZ
      UPUQZUDZUUCUAUEZUUMYSUUBHIUUOYSYTIRZUUBVHZUUNIRZUURUUNYTKLYTUUORUUSYKYQYM
      YNUURUUBURZUSYSUURUUBUTZUUSYTYKUUSYTUVBTUUSYKUVATUUSUUBYMUUAYKKLZYSUURUUB
      VAYQYMYNUURUUBVBYLUVCFUUADYJUUAYKKUCVCVDVEUUNYTVFVGVIZYSUUBHINZUUQYNUVEYR
      XMXLYKDRZGVJZUVEGDVKXLUVGUVEXLUVFUVEGXLUVFUVEXLUVFPZUUTUUNSZDRZUVEUVHYKDI
      YKVLZUSUVHUVIYKDUVHYKUVHYKUVKVMVNXLUVFVOVPUUBUVJHUUNIYTUUNQUUAUVIDYTUUNVT
      VQVRVSWJWAWBWCWDUUBHIWKWEUUCUUNWFVSZUUMUUDIRUUFUUNDRZUUFGUUDIUUCYKUUDQUUN
      UUEDYKUUDVTVQUUBUVMHGIYTYKQUUAUUNDYTYKVTVQWGWHWIXIZYSUUHBDYSXNDRZPZXNUUEK
      LUUHUVPUUDXNUVPUUDUVPUUCIUUDUUBHIWLYSUUMUVOUVLWDWMZTUVPXNYSDIXNXLXMYRWNWO
      ZTZUVPUUPXNSZUUCRZUUDUVTKLYSUUPUVOUVDWDUVPUVTIRUVTSZDRZUWAUVPXNUVRUSUVPUW
      BXNDUVPXNUVPXNUVRVMVNYSUVOVOVPUUBUWCHUVTIYTUVTQUUAUWBDYTUVTVTVQWPWQUVTUUC
      UUNWRVSWSUVPXNUUEUVSUVPUUEUVPUUDUVQUSTWTXAXBYSUUKBEYSUUFUUKUVNUUFUUJYEYDU
      UJCUUEDYCUUEXNOUHVRWJXIXCYHUUIUULPAUUEDXOUUEQZYAUUIYGUULUWDXTUUHBDUWDXSUU
      GXOUUEXNOUCXDUIUWDYFUUKBEUWDYBUUJYEXOUUEXNOUHXEUIXJVRXFXGXHXK $.

    $( The supremum of a bounded-above set of integers is a member of the set.
       (This version of ~ suprzcl avoids ~ ax-pre-sup .)  (Contributed by Mario
       Carneiro, 21-Apr-2015.)  (Revised by Mario Carneiro, 24-Dec-2016.) $)
    suprzcl2 $p |- ( ( A C_ ZZ /\ A =/= (/) /\ E. x e. ZZ A. y e. A y <_ x ) ->
                    sup ( A , RR , < ) e. A ) $=
      ( vz cz wss c0 wne cv cle wbr wral wrex w3a clt wi cr wa wcel wtru zsupss
      wn csup wceq ssel2 zred wor ltso eqsup trud 3expib simpr eleq1 syl5ibrcom
      a1i syl syld rexlimdva 3ad2ant1 mpd ) CEFZCGHZBIZAIZJKBCLAEMZNVDVCOKUBBCL
      ZVCVDOKVCDIOKDCMPBQLZRZACMZCQOUCZCSZABDCQUAVAVBVIVKPVEVAVHVKACVAVDCSZRZVH
      VJVDUDZVKVMVDQSZVHVNPVMVDCEVDUEUFVOVFVGVNVOVFVGNVNPTBDQCVDOQOUGTUHUOUIUJU
      KUPVMVKVNVLVAVLULVJVDCUMUNUQURUSUT $.

    $( The supremum of a bounded-above set of integers is greater than any
       member of the set.  (Contributed by Mario Carneiro, 21-Apr-2015.) $)
    suprzub $p |- ( ( A C_ ZZ /\ E. x e. ZZ A. y e. A y <_ x /\ B e. A ) ->
                    B <_ sup ( A , RR , < ) ) $=
      ( vz cz wss cv cle wbr wral wrex wcel w3a cr clt csup wn syl3anc sseldd
      simp3 wor ltso a1i wi wa simp1 zssre syl6ss c0 wne ne0i syl zsupss ssrexv
      simp2 sylc supub mpd suprzcl2 lenltd mpbird ) CFGZBHZAHZIJBCKAFLZDCMZNZDC
      OPQZIJVIDPJRZVHVGVJVCVFVGUAZVHABEOCDPOPUBVHUCUDVHCOGVEVDPJRBCKVDVEPJVDEHP
      JECLUEBOKUFZACLZVLAOLVHCFOVCVFVGUGZUHUIZVHVCCUJUKZVFVMVNVHVGVPVKCDULUMZVC
      VFVGUPZABECOUNSVLACOUOUQURUSVHDVIVHCODVOVKTVHCOVIVOVHVCVPVFVICMVNVQVRABCU
      TSTVAVB $.

    uzsupss.1 $e |- Z = ( ZZ>= ` M ) $.
    $( Any bounded subset of upper integers has a supremum.  (Contributed by
       Mario Carneiro, 22-Jul-2014.)  (Revised by Mario Carneiro,
       21-Apr-2015.) $)
    uzsupss $p |- ( ( M e. ZZ /\ A C_ Z /\ E. x e. ZZ A. y e. A y <_ x ) ->
                    E. x e. Z ( A. y e. A -. x < y /\
                      A. y e. Z ( y < x -> E. z e. A y < z ) ) ) $=
      ( cz wcel wss cv cle wbr wral wrex clt wn wi wa c0 w3a cuz cfv simpl1 syl
      wceq uzid syl6eleqr simpr raleqdv mpbiri eluzle wb eluzel2 eluzelz cr zre
      ral0 lenlt syl2an syl2anc mpbid eleq2s pm2.21d breq1 notbid ralbidv breq2
      a1i imbi1d anbi12d rspcev syl12anc wne simpl2 uzssz eqsstri syl6ss simpl3
      rgen zsupss syl3anc ssrexv sylc pm2.61dane ) EHIZDFJZBKZAKZLMBDNAHOZUAZWI
      WHPMZQZBDNZWHWIPMZWHCKPMCDOZRZBFNZSZAFOZDTWKDTUFZSZEFIEWHPMZQZBDNZWHEPMZW
      PRZBFNZWTXBEEUBUCZFXBWFEXIIWFWGWJXAUDEUGUEGUHXBXEXDBTNXDBURXBXDBDTWKXAUIU
      JUKXHXBXGBFWHFIXFWPXFQZWHXIFWHXIIZEWHLMZXJEWHULXKWFWHHIZXLXJUMZEWHUNEWHUO
      WFEUPIWHUPIXNXMEUQWHUQEWHUSUTVAVBGVCVDVTVIWSXEXHSAEFWIEUFZWNXEWRXHXOWMXDB
      DXOWLXCWIEWHPVEVFVGXOWQXGBFXOWOXFWPWIEWHPVHVJVGVKVLVMWKDTVNZSZWGWSADOZWTW
      FWGWJXPVOZXQDHJXPWJXRXQDFHXSFXIHGEVPVQVRWKXPUIWFWGWJXPVSABCDFWAWBWSADFWCW
      DWE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Well-ordering principle for bounded-below sets of integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d n x y z A $.  $d n x y z B $.
    $( Well-ordering principle: any non-empty subset of upper integers has a
       unique least element.  This generalization of ~ uzwo2 allows the lower
       bound ` B ` to be any real number.  See also ~ nnwo and ~ nnwos .
       (Contributed by NM, 12-Nov-2004.)  (Proof shortened by Mario Carneiro,
       2-Oct-2015.) $)
    uzwo3 $p |- ( ( B e. RR /\ ( A C_ { z e. ZZ | B <_ z } /\ A =/= (/) ) )
                  -> E! x e. A A. y e. A x <_ y ) $=
      ( vn cr wcel cv cle wbr cz wss wa cneg wral cn adantr syl2anc ralrimiva
      crab c0 wne clt wreu wrex renegcl arch syl ccnv csup wceq cuz cfv simplrl
      wi nnnegz zred simprl simpll nnred simplrr ltnegcon1d simprr ltletrd eluz
      ltled wb mpbird expr rabss sylibr sstrd infmssuzcl infmssuzle sylan breq2
      adantlr rspcv sylc uzssz zssre sstri syl6ss letri3d mpbir2and breq1 eqreu
      sseldd ralbidv syl3anc rexlimddv ) EGHZDECIZJKZCLUAZMZDUBUCZNZNZEOZFIZUDK
      ZAIZBIZJKZBDPZADUEZFQWTXAGHZXCFQUFWMXIWSEUGRXAFUHUIWTXBQHZXCNZNZDGUDUJUKZ
      DHZXMXEJKZBDPZXGXDXMULZUPZADPXHXLDXBOZUMUNZMZWRXNXLDWPXTWMWQWRXKUOWMXKWPX
      TMZWSWMXKNZWOWNXTHZUPZCLPYBYCYECLYCWNLHZWOYDYCYFWONZNZYDXSWNJKZYHXSWNYHXS
      YHXJXSLHZWMXJXCYGUOZXBUQUIZURZYHWNYCYFWOUSZURZYHXSEWNYMWMXKYGUTZYOYHEXBYP
      YHXBYKVAWMXJXCYGVBVCYCYFWOVDVEVGYHYJYFYDYIVHYLYNXSWNVFSVIVJTWOCLXTVKVLVRV
      MZWMWQWRXKVBDXSVNSZXLXOBDXLYAXEDHXOYQXEDXSVOVPTXLXRADXLXDDHZXGXQXLYSXGNZN
      ZXQXDXMJKZXMXDJKZUUAXNXGUUBXLXNYTYRRXLYSXGVDXFUUBBXMDXEXMXDJVQVSVTUUAYAYS
      UUCXLYAYTYQRXLYSXGUSZXDDXSVOSUUAXDXMUUADGXDXLDGMYTXLDXTGYQXTLGXSWAWBWCWDZ
      RUUDWIXLXMGHYTXLDGXMUUEYRWIRWEWFVJTXGXPADXMXQXFXOBDXDXMXEJWGWJWHWKWL $.

    $( There is a unique smallest integer greater than or equal to a given real
       number.  (Contributed by NM, 12-Nov-2004.)  (Revised by Mario Carneiro,
       13-Jun-2014.) $)
    zmin $p |- ( A e. RR ->
                 E! x e. ZZ ( A <_ x /\ A. y e. ZZ ( A <_ y -> x <_ y ) ) ) $=
      ( vz vn cr wcel cv cle wbr cz crab wral wreu wi wa wrex cn wss breq2 arch
      c0 wne clt nnssz ssrexv mpsyl zre ltle sylan2 reximdva mpd sylibr cbvrabv
      rabn0 eqimssi uzwo3 mpanr1 mpdan elrab ralrab anbi12i anass bitri 3bitr4i
      weu eubii df-reu sylib ) CFGZAHZBHZIJZBCDHZIJZDKLZMZAVPNZCVKIJZCVLIJZVMOB
      KMZPZAKNZVJVPUBUCZVRVJVODKQZWDVJCVNUDJZDKQZWERKSVJWFDRQWGUECDUAWFDRKUFUGV
      JWFVODKVNKGVJVNFGWFVOOVNUHCVNUIUJUKULVODKUOUMVJVPCEHZIJZEKLZSWDVRVPWJVOWI
      DEKVNWHCITUNUPABEVPCUQURUSVKVPGZVQPZAVFVKKGZWBPZAVFVRWCWLWNAWLWMVSPZWAPWN
      WKWOVQWAVOVSDVKKVNVKCITUTVOVTVMBDKVNVLCITVAVBWMVSWAVCVDVGVQAVPVHWBAKVHVEV
      I $.
  $}

  ${
    $d x y z w A $.
    $( There is a unique largest integer less than or equal to a given real
       number.  (Contributed by NM, 15-Nov-2004.) $)
    zmax $p |- ( A e. RR ->
               E! x e. ZZ ( x <_ A /\ A. y e. ZZ ( y <_ A -> y <_ x ) ) ) $=
      ( vz vw cr wcel cneg cv cle wbr wi cz wral wa wreu wb znegcl wceq imbi12d
      renegcl zmin syl leneg sylan ancoms breq1 rspcv lenegcon1 adantrr adantrl
      zre sylan2 biimpd com23 syld com13 ralrimdv breq2 exbiri anbi12d reubidva
      ex impbid zcn negcon2 syl2an reuhyp imbi2d ralbidv reuxfr syl6rbbr mpbid
      cc ) CFGZCHZDIZJKZVPEIZJKZVQVSJKZLZEMNZOZDMPZAIZCJKZBIZCJKZWHWFJKZLZBMNZO
      ZAMPZVOVPFGWECUADEVPUBUCVOWNVPWFHZJKZVTWOVSJKZLZEMNZOZAMPWEVOWMWTAMVOWFMG
      ZOZWGWPWLWSXAVOWGWPQZXAWFFGZVOXCWFULZWFCUDUEUFXBWLWSXBWLWREMVSMGZWLXBWRXF
      WLVSHZCJKZXGWFJKZLZXBWRLXFXGMGWLXJLVSRWKXJBXGMWHXGSWIXHWJXIWHXGCJUGWHXGWF
      JUGTUHUCXFXBXJWRXFXBXJWRLXFXBOXJWRXFVSFGZXBXJWRQVSULXKXBOXHVTXIWQXKVOXHVT
      QXAVSCUIUJXKXAXIWQQZVOXAXKXDXLXEVSWFUIUMUKTUEUNVCUOUPUQURXBWSWKBMWHMGZWSX
      BWKXMWSVPWHHZJKZWOXNJKZLZXBWKLXMXNMGWSXQLWHRWRXQEXNMVSXNSVTXOWQXPVSXNVPJU
      SVSXNWOJUSTUHUCXMXBXQWKXMXBWKXQXMWHFGZXBWKXQQWHULXRXBOWIXOWJXPXRVOWIXOQXA
      WHCUDUJXRXAWJXPQZVOXAXRXDXSXEWHWFUDUMUKTUEUTUOUPUQURVDVAVBWDWTDAWOMWFRDAW
      OVQHZMVQRVQMGVQVNGWFVNGVQWOSZWFXTSQXAVQVEWFVEVQWFVFVGVHYAVRWPWCWSVQWOVPJU
      SYAWBWREMYAWAWQVTVQWOVSJUGVIVJVAVKVLVM $.
  $}

  ${
    $d x y z A $.
    $( There is a unique integer between a real number and the number plus
       one.  Exercise 5 of [Apostol] p. 28.  (Contributed by NM,
       13-Nov-2004.) $)
    zbtwnre $p |- ( A e. RR -> E! x e. ZZ ( A <_ x /\ x < ( A + 1 ) ) ) $=
      ( vy cr wcel cv cle wbr wi cz wa wreu c1 co clt wb zre syl sylan2 zlem1lt
      wral caddc zmin cmin peano2rem ltletr syl3an1 3expa adantlr sylibrd exp4b
      com23 ralrimdv wn ltnrd peano2zm mpdan mtbird ad2antrr ancoms adantr wceq
      lenlt breq2 imbi12d rspcv imp sylbird ex impbid 1re ltsubadd mp3an2 sylan
      mt3d bitr3d anbi2d reubidva mpbid ) BDEZBAFZGHZBCFZGHZWAWCGHZIZCJUAZKZAJL
      WBWABMUBNOHZKZAJLACBUCVTWHWJAJVTWAJEZKWGWIWBWKVTWGWIPWKVTKZWAMUDNZBOHZWGW
      IWLWNWGWLWNWFCJWLWCJEZWNWFWLWOWNWDWEWLWOKWNWDKZWMWCOHZWEWOWLWCDEZWPWQIZWC
      QWKVTWRWSWKWMDEZVTWRWSWKWADEZWTWAQZWAUERZWMBWCUFUGUHSWKWOWEWQPVTWAWCTUIUJ
      UKULUMWLWGWNWLWGKZWNWAWMGHZWKXEUNVTWGWKXEWMWMOHZWKWMXCUOWKWMJEZXEXFPWAUPZ
      WAWMTUQURUSXDWNUNZBWMGHZXEWLXJXIPZWGVTWKXKWKVTWTXKXCBWMVCSUTVAWKWGXJXEIZV
      TWKWGXLWKXGWGXLIXHWFXLCWMJWCWMVBWDXJWEXEWCWMBGVDWCWMWAGVDVEVFRVGUIVHVOVIV
      JWKXAVTWNWIPZXBXAMDEVTXMVKWAMBVLVMVNVPUTVQVRVS $.
  $}

  ${
    $d x y z A $.
    $( There is a unique greatest integer less than or equal to a real number.
       Exercise 4 of [Apostol] p. 28.  (Contributed by NM, 15-Nov-2004.) $)
    rebtwnz $p |- ( A e. RR -> E! x e. ZZ ( x <_ A /\ A < ( x + 1 ) ) ) $=
      ( vy cr wcel cneg cv cle wbr c1 caddc co clt wa cz wreu znegcl cc wceq wb
      renegcl zbtwnre syl zcn negcon2 syl2an reuhyp breq2 anbi12d reuxfr ancoms
      breq1 zre leneg peano2rem ltneg sylan 1re ltsubadd mp3an2 ax-1cn negsubdi
      cmin sylancl adantr breq2d 3bitr3d sylan2 bicomd reubidva syl5bb mpbid
      recn ) BDEZBFZCGZHIZVPVOJKLZMIZNZCOPZAGZBHIZBWBJKLMIZNZAOPZVNVODEWABUACVO
      UBUCWAVOWBFZHIZWGVRMIZNZAOPVNWFVTWJCAWGOWBQCAWGVPFZOVPQVPOEVPREWBREVPWGSZ
      WBWKSTWBOEZVPUDWBUDVPWBUEUFUGWLVQWHVSWIVPWGVOHUHVPWGVRMULUIUJVNWJWEAOVNWM
      NWEWJWMVNWBDEZWEWJTWBUMVNWNNZWCWHWDWIWNVNWCWHTWBBUNUKWOBJVCLZWBMIZWGWPFZM
      IZWDWIVNWPDEWNWQWSTBUOWPWBUPUQVNJDEWNWQWDTURBJWBUSUTWOWRVRWGMVNWRVRSZWNVN
      BREJREWTBVMVABJVBVDVEVFVGUIVHVIVJVKVL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Rational numbers (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c QQ $. $( The set of rational numbers (blackboard bold Q). $)

  $( Extend class notation to include the class of rationals. $)
  cq $a class QQ $.

  $( Define the set of rational numbers.  Based on definition of rationals in
     [Apostol] p. 22.  See ~ elq for the relation "is rational."  (Contributed
     by NM, 8-Jan-2002.) $)
  df-q $a |- QQ = ( / " ( ZZ X. NN ) ) $.

  ${
    $d x y z A $.
    $( Membership in the set of rationals.  (Contributed by NM, 8-Jan-2002.)
       (Revised by Mario Carneiro, 28-Jan-2014.) $)
    elq $p |- ( A e. QQ <-> E. x e. ZZ E. y e. NN A = ( x / y ) ) $=
      ( vz cq wcel cdiv cz cn cxp cima cv co wceq wrex df-q cc cc0 wss mp2an wb
      eleq2i csn cdif wfn cmul crio df-div riotaex fnmpt2i zsscn wne nncn nnne0
      eldifsn sylanbrc ssriv xpss12 ovelimab bitri ) CEFCGHIJZKZFZCALZBLZGMNBIO
      AHOZEVBCPUBGQQRUCUDZJZUEVAVHSZVCVFUAABQVGVEDLUFMVDNZDQUGGABDUHVJDQUIUJHQS
      IVGSVIUKAIVGVDIFVDQFVDRULVDVGFVDUMVDUNVDQRUOUPUQHQIVGURTABVHHICGUSTUT $.

    $( If ` A ` is rational, then some integer multiple of it is an integer.
       (Contributed by NM, 7-Nov-2008.)  (Revised by Mario Carneiro,
       22-Jul-2014.) $)
    qmulz $p |- ( A e. QQ -> E. x e. NN ( A x. x ) e. ZZ ) $=
      ( vy cq wcel cv cdiv co wceq cn wrex cz elq rexcom wa cc zcn adantr sylbi
      cmul adantl nncn cc0 nnne0 divcan1d simpr eqeltrd oveq1 eleq1d syl5ibrcom
      wne rexlimdva reximia ) BDEBCFZAFZGHZIZAJKCLKZBUOTHZLEZAJKZCABMURUQCLKZAJ
      KVAUQCALJNVBUTAJUOJEZUQUTCLVCUNLEZOZUTUQUPUOTHZLEVEVFUNLVEUNUOVDUNPEVCUNQ
      UAVCUOPEVDUOUBRVCUOUCUKVDUOUDRUEVCVDUFUGUQUSVFLBUPUOTUHUIUJULUMSS $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The ratio of an integer and a natural number is a rational number.
       (Contributed by NM, 12-Jan-2002.) $)
    znq $p |- ( ( A e. ZZ /\ B e. NN ) -> ( A / B ) e. QQ ) $=
      ( vx vy cz wcel cn wa cdiv co cv wceq wrex eqid rspceov mp3an3 elq sylibr
      cq ) AEFZBGFZHABIJZCKDKIJLDGMCEMZUBSFTUAUBUBLUCUBNCDEGABUBIOPCDUBQR $.
  $}

  ${
    $d x y A $.
    $( A rational number is a real number.  (Contributed by NM,
       14-Nov-2002.) $)
    qre $p |- ( A e. QQ -> A e. RR ) $=
      ( vx vy cq wcel cv cdiv co wceq cn wrex cz cr elq cc0 wne zre nnre nnne0
      wa jca redivcl 3expb syl2an eleq1 syl5ibrcom rexlimivv sylbi ) ADEABFZCFZ
      GHZIZCJKBLKAMEZBCANULUMBCLJUILEZUJJEZTUMULUKMEZUNUIMEZUJMEZUJOPZTUPUOUIQU
      OURUSUJRUJSUAUQURUSUPUIUJUBUCUDAUKMUEUFUGUH $.

    $( An integer is a rational number.  (Contributed by NM, 9-Jan-2002.) $)
    zq $p |- ( A e. ZZ -> A e. QQ ) $=
      ( vx vy cv wceq cz wrex cdiv co cn wcel cq c1 div1d eqeq2d eqcom syl6rbbr
      zcn 1nn oveq2 rspcev mpan syl6bi reximia risset elq 3imtr4i ) BDZAEZBFGAU
      HCDZHIZEZCJGZBFGAFKALKUIUMBFUHFKZUIAUHMHIZEZUMUNUPAUHEUIUNUOUHAUNUHUHRNOU
      HAPQMJKUPUMSULUPCMJUJMEUKUOAUJMUHHTOUAUBUCUDBAFUEBCAUFUG $.
  $}

  $( The integers are a subset of the rationals.  (Contributed by NM,
     9-Jan-2002.) $)
  zssq $p |- ZZ C_ QQ $=
    ( vx cz cq cv zq ssriv ) ABCADEF $.

  $( The nonnegative integers are a subset of the rationals.  (Contributed by
     NM, 31-Jul-2004.) $)
  nn0ssq $p |- NN0 C_ QQ $=
    ( cn0 cz cq nn0ssz zssq sstri ) ABCDEF $.

  $( The natural numbers are a subset of the rationals.  (Contributed by NM,
     31-Jul-2004.) $)
  nnssq $p |- NN C_ QQ $=
    ( cn cz cq nnssz zssq sstri ) ABCDEF $.

  $( The rationals are a subset of the reals.  (Contributed by NM,
     9-Jan-2002.) $)
  qssre $p |- QQ C_ RR $=
    ( vx cq cr cv qre ssriv ) ABCADEF $.

  $( The rationals are a subset of the complex numbers.  (Contributed by NM,
     2-Aug-2004.) $)
  qsscn $p |- QQ C_ CC $=
    ( cq cr cc qssre ax-resscn sstri ) ABCDEF $.

  $( The set of rational numbers exists.  See also ~ qexALT .  (Contributed by
     NM, 30-Jul-2004.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
  qex $p |- QQ e. _V $=
    ( cq cc cnex qsscn ssexi ) ABCDE $.

  $( A natural number is rational.  (Contributed by NM, 17-Nov-2004.) $)
  nnq $p |- ( A e. NN -> A e. QQ ) $=
    ( cn cq nnssq sseli ) BCADE $.

  $( A rational number is a complex number.  (Contributed by NM,
     2-Aug-2004.) $)
  qcn $p |- ( A e. QQ -> A e. CC ) $=
    ( cq cc qsscn sseli ) BCADE $.

  ${
    $d w x y z $.
    $( The set of rational numbers exists.  (Contributed by NM, 30-Jul-2004.)
       (Revised by Mario Carneiro, 16-Jun-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    qexALT $p |- QQ e. _V $=
      ( vy vz vx cq cz cn cv cdiv co cmpt2 crn cvv wcel wceq wrex elq eqid ovex
      elrnmpt2 bitr4i eqriv zexALT nnexALT mpt2ex rnex eqeltri ) DABEFAGZBGZHIZ
      JZKZLCDUKCGZDMULUINBFOAEOULUKMABULPABEFUIULUJUJQUGUHHRSTUAUJABEFUIUBUCUDU
      EUF $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    $( Closure of addition of rationals.  (Contributed by NM, 1-Aug-2004.) $)
    qaddcl $p |- ( ( A e. QQ /\ B e. QQ ) -> ( A + B ) e. QQ ) $=
      ( vx vy vz vw vu vv cq wcel cv cdiv co wceq cn wrex cz caddc wa cc elq wi
      cmul zmulcl sylan2 ad2ant2rl simpl adantl syl2anr zaddcld adantr ad2ant2l
      nnz nnmulcl oveq12 cc0 wne zcn anim12i nncn nnne0 jca divadddiv sylan9eqr
      syl2an an4s w3a rspceov sylibr syl3anc exp43 rexlimivv rexlimdvv syl2anb
      imp ) AIJACKZDKZLMZNZDOPCQPZBEKZFKZLMZNZFOPEQPZABRMZIJZBIJCDAUAEFBUAVTWEW
      GVTWDWGEFQOVSWAQJZWBOJZSZWDWGUBUBCDQOVPQJZVQOJZSZVSWJWDWGWMWJVSWDWGWMWJSZ
      VSWDSZSVPWBUCMZWAVQUCMZRMZQJZVQWBUCMZOJZWFWRWTLMZNZWGWNWSWOWNWPWQWKWIWPQJ
      ZWLWHWIWKWBQJXDWBUMVPWBUDUEUFWJWHVQQJZWQQJWMWHWIUGWLXEWKVQUMUHWAVQUDUIUJU
      KWNXAWOWLWIXAWKWHVQWBUNULUKWOWNWFVRWCRMZXBAVRBWCRUOWKWHWLWIXFXBNZWKWHSVPT
      JZWATJZSVQTJZVQUPUQZSZWBTJZWBUPUQZSZSXGWLWISWKXHWHXIVPURWAURUSWLXLWIXOWLX
      JXKVQUTVQVAVBWIXMXNWBUTWBVAVBUSVPWAVQWBVCVEVFVDWSXAXCVGWFGKHKLMNHOPGQPWGG
      HQOWRWTWFLVHGHWFUAVIVJVFVKVLVMVOVN $.

    $( Closure law for the negative of a rational.  (Contributed by NM,
       2-Aug-2004.)  (Revised by Mario Carneiro, 15-Sep-2014.) $)
    qnegcl $p |- ( A e. QQ -> -u A e. QQ ) $=
      ( vx vy cq wcel cv cdiv co wceq cn wrex cz cneg elq wa cc zcn adantr nncn
      adantl cc0 wne nnne0 divnegd znegcl sylan eqeltrd negeq eleq1d syl5ibrcom
      znq rexlimivv sylbi ) ADEABFZCFZGHZIZCJKBLKAMZDEZBCANUQUSBCLJUNLEZUOJEZOZ
      USUQUPMZDEVBVCUNMZUOGHZDVBUNUOUTUNPEVAUNQRVAUOPEUTUOSTVAUOUAUBUTUOUCTUDUT
      VDLEVAVEDEUNUEVDUOUKUFUGUQURVCDAUPUHUIUJULUM $.

    $( Closure of multiplication of rationals.  (Contributed by NM,
       1-Aug-2004.) $)
    qmulcl $p |- ( ( A e. QQ /\ B e. QQ ) -> ( A x. B ) e. QQ ) $=
      ( vx vy vz vw vv vu cq wcel cv cdiv co wceq cn wrex cz cmul wa cc nnmulcl
      elq zmulcl anim12i an4s adantr oveq12 cc0 wne zcn ad2ant2r nncn nnne0 jca
      ad2ant2l divmuldiv syl2anc sylan9eqr rspceov 3expa sylibr exp43 rexlimivv
      wi rexlimdvv imp syl2anb ) AIJACKZDKZLMZNZDOPCQPZBEKZFKZLMZNZFOPEQPZABRMZ
      IJZBIJCDAUBEFBUBVLVQVSVLVPVSEFQOVKVMQJZVNOJZSZVPVSVDVDCDQOVHQJZVIOJZSZVKW
      BVPVSWEWBVKVPVSWEWBSZVKVPSZSVHVMRMZQJZVIVNRMZOJZSZVRWHWJLMZNZVSWFWLWGWCVT
      WDWAWLWCVTSWIWDWASWKVHVMUCVIVNUAUDUEUFWGWFVRVJVORMZWMAVJBVORUGWFVHTJZVMTJ
      ZSZVITJZVIUHUIZSZVNTJZVNUHUIZSZSZWOWMNWCVTWRWDWAWCWPVTWQVHUJVMUJUDUKWDWAX
      EWCVTWDXAWAXDWDWSWTVIULVIUMUNWAXBXCVNULVNUMUNUDUOVHVMVIVNUPUQURWLWNSVRGKH
      KLMNHOPGQPZVSWIWKWNXFGHQOWHWJVRLUSUTGHVRUBVAUQUEVBVCVEVFVG $.
  $}

  $( Closure of subtraction of rationals.  (Contributed by NM, 2-Aug-2004.) $)
  qsubcl $p |- ( ( A e. QQ /\ B e. QQ ) -> ( A - B ) e. QQ ) $=
    ( cq wcel wa cneg caddc co cmin wceq qcn negsub syl2an qnegcl qaddcl sylan2
    cc eqeltrrd ) ACDZBCDZEABFZGHZABIHZCSAQDBQDUBUCJTAKBKABLMTSUACDUBCDBNAUAOPR
    $.

  ${
    $d x y z w A $.
    $( Closure of reciprocal of rationals.  (Contributed by NM, 3-Aug-2004.) $)
    qreccl $p |- ( ( A e. QQ /\ A =/= 0 ) -> ( 1 / A ) e. QQ ) $=
      ( vx vy vz vw cq wcel cc0 wne c1 cdiv co cv wceq cn wrex cz wi wa adantlr
      elq cmul nnne0 ancli neeq1 cc zcn nncn anim12i divne0b 3expa sylan bicomd
      wb sylan9bbr nnz zmulcl sylan2 adantr msqznn jca oveq2 divid oveq1d simpl
      simpll simpr divdivdiv syl22anc eqtr3d anass1rs sylan9eqr an32s ex sylbid
      an4s anasss rspceov sylibr syl8 rexlimivv sylbi imp ) AFGZAHIZJAKLZFGZWDA
      BMZCMZKLZNZCOPBQPWEWGRZBCAUAWKWLBCQOWHQGZWIOGZSZWKWEWHWIUBLZQGZWHWHUBLZOG
      ZSZWFWPWRKLZNZSZWGWNWMWNWIHIZSWKWEXCRZRZWNXDWIUCUDWMWNXDXFWOXDSZWKXEXGWKS
      ZWEWHHIZXCWKWEWJHIZXGXIAWJHUEXGXIXJWOWHUFGZWIUFGZSZXDXIXJUNZWMXKWNXLWHUGW
      IUHUIZXKXLXDXNWHWIUJUKULUMUOXHXIXCXHXISWTXBXGXIWTWKWOXIWTXDWOXISWQWSWOWQX
      IWNWMWIQGWQWIUPWHWIUQURUSWMXIWSWNWHUTTVATTXGXIWKXBWKXGXISWFJWJKLZXAAWJJKV
      BWOXIXDXPXANZWOXMXIXDSXQXOXKXIXLXDXQXKXISZXLXDSZSZWHWHKLZWJKLZXPXAXTYAJWJ
      KXRYAJNXSWHVCUSVDXTXKXRXRXSYBXANXKXIXSVFXRXSVEZYCXRXSVGWHWHWHWIVHVIVJVPUL
      VKVLVMVAVNVOVNVQURXCWFDMEMKLNEOPDQPZWGWQWSXBYDDEQOWPWRWFKVRUKDEWFUAVSVTWA
      WBWC $.
  $}

  ${
    $d x y z w A $.
    $( Closure of division of rationals.  (Contributed by NM, 3-Aug-2004.) $)
    qdivcl $p |- ( ( A e. QQ /\ B e. QQ /\ B =/= 0 ) -> ( A / B ) e. QQ ) $=
      ( cq wcel cc0 wne w3a cdiv co c1 cmul cc wceq qcn id divrec syl3an qreccl
      wa qmulcl sylan2 3impb eqeltrd ) ACDZBCDZBEFZGABHIZAJBHIZKIZCUDALDUEBLDUF
      UFUGUIMANBNUFOABPQUDUEUFUICDZUEUFSUDUHCDUJBRAUHTUAUBUC $.
  $}

  $( Reverse closure law for addition of rationals.  (Contributed by NM,
     2-Aug-2004.) $)
  qrevaddcl $p |- ( B e. QQ ->
                   ( ( A e. CC /\ ( A + B ) e. QQ ) <-> A e. QQ ) ) $=
    ( cq wcel cc caddc co wa cmin qcn pncan sylan2 ancoms adantr qsubcl adantlr
    wceq eqeltrrd ex wi qaddcl expcom impbid pm5.32da pm4.71ri syl6bbr ) BCDZAE
    DZABFGZCDZHUHACDZHUKUGUHUJUKUGUHHZUJUKULUJUKULUJHUIBIGZACULUMAQZUJUHUGUNUGU
    HBEDUNBJABKLMNUGUJUMCDZUHUJUGUOUIBOMPRSUGUKUJTUHUKUGUJABUAUBNUCUDUKUHAJUEUF
    $.

  $( The reciprocal of a natural number is rational.  (Contributed by NM,
     17-Nov-2004.) $)
  nnrecq $p |- ( A e. NN -> ( 1 / A ) e. QQ ) $=
    ( c1 cz wcel cn cdiv co cq 1z znq mpan ) BCDAEDBAFGHDIBAJK $.

  $( The sum of an irrational number and a rational number is irrational.
     (Contributed by NM, 7-Nov-2008.) $)
  irradd $p |- ( ( A e. ( RR \ QQ ) /\ B e. QQ )
                -> ( A + B ) e. ( RR \ QQ ) ) $=
    ( cr cq cdif wcel wa caddc co wn eldif qre readdcl sylan2 adantlr wi qsubcl
    cmin expcom cc adantl wceq qcn pncan syl2an eleq1d sylibd con3d com23 imp31
    recn ex jca sylanb sylibr ) ACDEZFZBDFZGABHIZCFZUSDFZJZGZUSUPFUQACFZADFZJZG
    ZURVCACDKVGURGUTVBVDURUTVFURVDBCFUTBLABMNOVDVFURVBVDURVFVBVDURVFVBPVDURGZVA
    VEVHVAUSBRIZDFZVEURVAVJPVDVAURVJUSBQSUAVHVIADVDATFBTFVIAUBURAUKBUCABUDUEUFU
    GUHULUIUJUMUNUSCDKUO $.

  $( The product of an irrational with a nonzero rational is irrational.
     (Contributed by NM, 7-Nov-2008.) $)
  irrmul $p |- ( ( A e. ( RR \ QQ ) /\ B e. QQ /\ B =/= 0 )
                -> ( A x. B ) e. ( RR \ QQ ) ) $=
    ( cr cq cdif wcel cc0 wne w3a co wn wa eldif qre remulcl sylan2 wi 3expb cc
    cmul ad2ant2r cdiv qdivcl expcom adantl wceq divcan4 syl3an1 syl3an2 eleq1d
    qcn recn sylibd con3d ex com23 imp31 jca 3impb syl3an1b sylibr ) ACDEZFZBDF
    ZBGHZIABTJZCFZVFDFZKZLZVFVBFVCACFZADFZKZLZVDVEVJACDMVNVDVEVJVNVDVELZLVGVIVK
    VDVGVMVEVDVKBCFVGBNABOPUAVKVMVOVIVKVOVMVIVKVOVMVIQVKVOLZVHVLVPVHVFBUBJZDFZV
    LVOVHVRQVKVHVOVRVHVDVEVRVFBUCRUDUEVPVQADVKVDVEVQAUFZVDVKBSFZVEVSBUKVKASFVTV
    EVSAULABUGUHUIRUJUMUNUOUPUQURUSUTVFCDMVA $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Existence of the set of complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F k n x y $.  $d T n y $.
    rpnnen1.1 $e |- T = { n e. ZZ | ( n / k ) < x } $.
    rpnnen1.2 $e |- F = ( x e. RR |->
        ( k e. NN |-> ( sup ( T , RR , < ) / k ) ) ) $.
    $( Lemma for ~ rpnnen1 .  (Contributed by Mario Carneiro, 12-May-2013.) $)
    rpnnen1lem1 $p |- ( x e. RR -> ( F ` x ) e. ( QQ ^m NN ) ) $=
      ( vy cv cr wcel cn clt co cq cz wa wbr c0 wrex cfv csup cdiv cmpt nnexALT
      cmap cvv wceq mptex fvmpt2 mpan2 crab ssrab2 eqsstri wss wne cle wral a1i
      wf cmul nnre remulcl ancoms sylan2 btwnz simpld syl cc0 zre adantl simpll
      nngt0 jca ad2antlr ltdivmul syl3anc rexbidva mpbird sylibr neeq1i rabeq2i
      wb rabn0 syl2anc ltle sylbid impr sylan2b ralrimiva breq2 ralbidv suprzcl
      wi rspcev sseldi znq sylancom eqid fmptd qexALT elmap eqeltrd ) AIZJKZXDE
      UAZCLBJMUBZCIZUCNZUDZOLUFNZXEXJUGKXFXJUHCLXIUEUIAJXJUGEGUJUKXELOXJUTXJXKK
      XECLXIOXJXEXHLKZXGPKXIOKXEXLQZBPXGBDIZXHUCNXDMRZDPULZPFXODPUMUNZXMBPUOZBS
      UPZXNHIZUQRZDBURZHJTZXGBKXRXMXQUSXMXPSUPZXSXMXODPTZYDXMYEXNXHXDVANZMRZDPT
      ZXMYFJKZYHXLXEXHJKZYIXHVBZYJXEYIXHXDVCZVDVEZYIYHYFXNMRDPTDDYFVFVGVHXMXOYG
      DPXMXNPKZQZXNJKZXEYJVIXHMRZQZXOYGWCYNYPXMXNVJVKZXEXLYNVLZXLYRXEYNXLYJYQYK
      XHVMVNVOXNXDXHVPVQZVRVSXODPWDVTBXPSFWAVTXMYIXNYFUQRZDBURZYCYMXMUUBDBXNBKX
      MYNXOQUUBXODBPFWBXMYNXOUUBYOXOYGUUBUUAYOYPYIYGUUBWNYSYOYJXEYIXLYJXEYNYKVO
      YTYLWEXNYFWFWEWGWHWIWJYBUUCHYFJXTYFUHYAUUBDBXTYFXNUQWKWLWOWEHDBWMVQWPXGXH
      WQWRXJWSWTOLXJXAUEXBVTXC $.

    $( Lemma for ~ rpnnen1 .  (Contributed by Mario Carneiro, 12-May-2013.) $)
    rpnnen1lem2 $p |- ( ( x e. RR /\ k e. NN ) -> sup ( T , RR , < ) e. ZZ ) $=
      ( vy cv cr wcel wa cz clt co wbr c0 cle wrex syl2anc cn csup cdiv eqsstri
      crab ssrab2 wss wne wral a1i cmul nnre remulcl ancoms sylan2 btwnz simpld
      syl cc0 wb zre adantl simpll nngt0 jca ad2antlr ltdivmul syl3anc rexbidva
      mpbird rabn0 sylibr neeq1i rabeq2i wi ltle sylbid sylan2b ralrimiva breq2
      impr wceq ralbidv rspcev suprzcl sseldi ) AIZJKZCIZUAKZLZBMBJNUBZBDIZWIUC
      OWGNPZDMUEZMFWNDMUFUDZWKBMUGZBQUHZWMHIZRPZDBUIZHJSZWLBKWQWKWPUJWKWOQUHZWR
      WKWNDMSZXCWKXDWMWIWGUKOZNPZDMSZWKXEJKZXGWJWHWIJKZXHWIULZXIWHXHWIWGUMZUNUO
      ZXHXGXEWMNPDMSDDXEUPUQURWKWNXFDMWKWMMKZLZWMJKZWHXIUSWINPZLZWNXFUTXMXOWKWM
      VAVBZWHWJXMVCZWJXQWHXMWJXIXPXJWIVDVEVFWMWGWIVGVHZVIVJWNDMVKVLBWOQFVMVLWKX
      HWMXERPZDBUIZXBXLWKYADBWMBKWKXMWNLYAWNDBMFVNWKXMWNYAXNWNXFYAXTXNXOXHXFYAV
      OXRXNXIWHXHWJXIWHXMXJVFXSXKTWMXEVPTVQWAVRVSXAYBHXEJWSXEWBWTYADBWSXEWMRVTW
      CWDTHDBWEVHWF $.

    $( Lemma for ~ rpnnen1 .  (Contributed by Mario Carneiro, 12-May-2013.) $)
    rpnnen1lem3 $p |- ( x e. RR -> A. n e. ran ( F ` x ) n <_ x ) $=
      ( vy cv cr wcel cle wbr wral cn wa clt co cvv cz cfv csup cdiv cmpt mptex
      crn wceq nnexALT fvmpt2 fveq1d ovex eqid sylan9eq cmul rabeq2i cc0 wb zre
      mpan2 adantl simpll nnre jca ad2antlr ltdivmul syl3anc wi remulcl syl2anc
      nngt0 ltle sylbid impr sylan2b ralrimiva wss wne wrex crab ssrab2 eqsstri
      c0 zssre sstri a1i ancoms sylan2 simpld syl rexbidva mpbird sylibr neeq1i
      btwnz rabn0 breq2 ralbidv rspcev suprleub syl31anc rpnnen1lem2 zred simpl
      ledivmul eqbrtrd cq wf wfn rpnnen1lem1 qexALT elmap sylib ffn breq1 ralrn
      cmap 3syl ) AIZJKZDIZXRLMZDXREUAZUFNZCIZYBUAZXRLMZCONZXSYFCOXSYDOKZPZYEBJ
      QUBZYDUCRZXRLXSYHYEYDCOYKUDZUAZYKXSYDYBYLXSYLSKYBYLUGCOYKUHUEAJYLSEGUIUSU
      JYHYKSKYMYKUGYJYDUCUKCOYKSYLYLULUIUSUMYIYKXRLMZYJYDXRUNRZLMZYIYPXTYOLMZDB
      NZYIYQDBXTBKYIXTTKZXTYDUCRXRQMZPYQYTDBTFUOYIYSYTYQYIYSPZYTXTYOQMZYQUUAXTJ
      KZXSYDJKZUPYDQMZPZYTUUBUQYSUUCYIXTURUTZXSYHYSVAZYHUUFXSYSYHUUDUUEYDVBZYDV
      JVCZVDXTXRYDVEVFZUUAUUCYOJKZUUBYQVGUUGUUAUUDXSUULYHUUDXSYSUUIVDUUHYDXRVHZ
      VIXTYOVKVIVLVMVNVOZYIBJVPZBWBVQZXTHIZLMZDBNZHJVRZUULYPYRUQUUOYIBTJBYTDTVS
      ZTFYTDTVTWAWCWDWEYIUVAWBVQZUUPYIYTDTVRZUVBYIUVCUUBDTVRZYIUULUVDYHXSUUDUUL
      UUIUUDXSUULUUMWFWGZUULUVDYOXTQMDTVRDDYOWNWHWIYIYTUUBDTUUKWJWKYTDTWOWLBUVA
      WBFWMWLYIUULYRUUTUVEUUNUUSYRHYOJUUQYOUGUURYQDBUUQYOXTLWPWQWRVIUVEHDDBYOWS
      WTWKYIYJJKXSUUFYNYPUQYIYJABCDEFGXAXBXSYHXCYHUUFXSUUJUTYJXRYDXDVFWKXEVOXSO
      XFYBXGZYBOXHYCYGUQXSYBXFOXPRKUVFABCDEFGXIXFOYBXJUHXKXLOXFYBXMYAYFDCOYBXTY
      EXRLXNXOXQWK $.

    $( Lemma for ~ rpnnen1 .  (Contributed by Mario Carneiro, 12-May-2013.) $)
    rpnnen1lem4 $p |- ( x e. RR -> sup ( ran ( F ` x ) , RR , < ) e. RR ) $=
      ( vy cv cr wcel c0 wne cle wbr wral cn cq sylib syl cfv crn wss wrex csup
      clt wf cmap co rpnnen1lem1 qexALT nnexALT elmap frn qssre syl6ss cdm ne0i
      c1 1nn ax-mp fdm neeq1d mpbiri dm0rn0 necon3bii rpnnen1lem3 breq2 ralbidv
      weq rspcev mpdan suprcl syl3anc ) AIZJKZVOEUAZUBZJUCZVRLMZDIZHIZNOZDVRPZH
      JUDZVRJUFUEJKVPQRVQUGZVSVPVQRQUHUIKWFABCDEFGUJRQVQUKULUMSZWFVRRJQRVQUNUOU
      PTVPWFVTWGWFVQUQZLMZVTWFWIQLMZUSQKWJUTQUSURVAWFWHQLQRVQVBVCVDWHLVRLVQVEVF
      STVPWAVONOZDVRPZWEABCDEFGVGWDWLHVOJHAVJWCWKDVRWBVOWANVHVIVKVLHDVRVMVN $.

    $( Lemma for ~ rpnnen1 .  (Contributed by Mario Carneiro, 12-May-2013.) $)
    rpnnen1lem5 $p |- ( x e. RR -> sup ( ran ( F ` x ) , RR , < ) = x ) $=
      ( vy cr wcel clt wceq cle wbr c0 cn cq co wa cz cv cfv crn wn rpnnen1lem3
      csup wral wss wne wrex wb cmap rpnnen1lem1 qexALT nnexALT elmap sylib frn
      wf qssre syl6ss syl cdm 1nn ne0i ax-mp fdm neeq1d mpbiri dm0rn0 necon3bii
      breq2 ralbidv rspcev mpdan suprleub syl31anc mpbird cmin cdiv rpnnen1lem4
      c1 id resubcl adantr posdif mpancom biimpa gt0ne0d rereccld arch ex caddc
      cc0 w3a rpnnen1lem2 zred 3adant3 ltp1d wi jca nnre ltrec1 syl2an ad2antrr
      nngt0 nnrecre adantl simpll ltaddsub2d wfn ffn fnfvelrn sylan sseldd 3jca
      suprub syl2anc leadd1dd readdcld readdcl simpl lelttr syl3anc mpd adantlr
      exp3a sylbird sylbid peano2zd oveq1 breq1d a1i ad2antlr sylibr cvv fvmpt2
      cc mpan2 syld elrab2 biimpri crab ssrab2 eqsstri zssre sstri cmul remulcl
      ancoms sylan2 btwnz simpld zre ltdivmul rexbidva neeq1i rabeq2i ltle impr
      rabn0 sylan2b ralrimiva syldan zcnd ax-1cn nncn nnne0 divdir mptex fveq1d
      cmpt ovex eqid sylan9eq oveq1d eqtr4d 3imtr3d exp31 com4l com14 3imp mt2d
      lenltd rexlimdv3a pm2.01d eqlelt mpbir2and ) AUAZIJZUWIEUBZUCZIKUFZUWILZU
      WMUWIMNZUWMUWIKNZUDZUWJUWODUAZUWIMNZDUWLUGZABCDEFGUEZUWJUWLIUHZUWLOUIZUWR
      HUAZMNZDUWLUGZHIUJZUWJUWOUWTUKUWJPQUWKUSZUXBUWJUWKQPULRJUXHABCDEFGUMQPUWK
      UNUOUPUQZUXHUWLQIPQUWKURUTVAVBZUWJUXHUXCUXIUXHUWKVCZOUIZUXCUXHUXLPOUIZWBP
      JUXMVDPWBVEVFUXHUXKPOPQUWKVGVHVIUXKOUWLOUWKVJVKUQVBZUWJUWTUXGUXAUXFUWTHUW
      IIUXDUWILUXEUWSDUWLUXDUWIUWRMVLVMVNVOZUWJWCHDDUWLUWIVPVQVRUWJUWPUWJUWPWBU
      WIUWMVSRZVTRZCUAZKNZCPUJZUWQUWJUWPUXTUWJUWPSZUXQIJUXTUYAUXPUWJUXPIJZUWPUW
      JUWMIJZUYBABCDEFGWAZUWIUWMWDVOWEZUYAUXPUWJUWPWNUXPKNZUYCUWJUWPUYFUKUYDUWM
      UWIWFWGWHZWIWJUXQCWKVBWLUWJUXSUWQCPUWJUXRPJZUXSWOZUWPBIKUFZUYJWBWMRZKNZUY
      IUYJUWJUYHUYJIJUXSUWJUYHSZUYJABCDEFGWPZWQZWRWSUWJUYHUXSUWPUYLUDZWTUWPUYHU
      XSUWJUYPUWJUWPUYHUXSUYPUWJUWPUYHUXSUYPWTUYAUYHSZUXSUXRUWKUBZWBUXRVTRZWMRZ
      UWIKNZUYPUYQUXSUYSUXPKNZVUAUYAUYBUYFSUXRIJZWNUXRKNZSZUXSVUBUKUYHUYAUYBUYF
      UYEUYGXAUYHVUCVUDUXRXBZUXRXFXAZUXPUXRXCXDUYQVUBUWMUYSWMRZUWIKNZVUAUYQUWMU
      YSUWIUWJUYCUWPUYHUYDXEUYHUYSIJZUYAUXRXGZXHUWJUWPUYHXIXJUWJUYHVUIVUAWTZUWP
      UYMUYTVUHMNZVULUYMUYRUWMUYSUYMUWLIUYRUWJUXBUYHUXJWEUWJUWKPXKZUYHUYRUWLJZU
      WJUXHVUNUXIPQUWKXLVBPUXRUWKXMXNZXOZUWJUYCUYHUYDWEUYHVUJUWJVUKXHZUYMUXBUXC
      UXGWOZVUOUYRUWMMNUWJVUSUYHUWJUXBUXCUXGUXJUXNUXOXPWEVUPHDUWLUYRXQXRXSUYMUY
      TIJZVUHIJZUWJVUMVULWTUYMUYRUYSVUQVURXTUWJUYCVUJVVAUYHUYDVUKUWMUYSYAXDUWJU
      YHYBVUTVVAUWJWOVUMVUIVUAUYTVUHUWIYCYGYDYEYFYHYIUWJUYHVUAUYPWTUWPUYMUYKUXR
      VTRZUWIKNZUYKUYJMNZVUAUYPUYMVVCVVDUYMVVCUYKBJZVVDUYMUYKTJZVVCVVEUYMUYJUYN
      YJZVVEVVFVVCSUWRUXRVTRZUWIKNZVVCDUYKTBUWRUYKLVVHVVBUWIKUWRUYKUXRVTYKYLFUU
      AUUBXNUYMBIUHZBOUIZUXEDBUGZHIUJZWOVVEVVDUYMVVJVVKVVMVVJUYMBTIBVVIDTUUCZTF
      VVIDTUUDUUEUUFUUGYMUYMVVNOUIZVVKUYMVVIDTUJZVVOUYMVVPUWRUXRUWIUUHRZKNZDTUJ
      ZUYMVVQIJZVVSUYHUWJVUCVVTVUFVUCUWJVVTUXRUWIUUIZUUJUUKZVVTVVSVVQUWRKNDTUJD
      DVVQUULUUMVBUYMVVIVVRDTUYMUWRTJZSZUWRIJZUWJVUEVVIVVRUKVWCVWEUYMUWRUUNXHZU
      WJUYHVWCXIZUYHVUEUWJVWCVUGYNUWRUWIUXRUUOYDZUUPVRVVIDTUVAYOBVVNOFUUQYOUYMV
      VTUWRVVQMNZDBUGZVVMVWBUYMVWIDBUWRBJUYMVWCVVISVWIVVIDBTFUURUYMVWCVVIVWIVWD
      VVIVVRVWIVWHVWDVWEVVTVVRVWIWTVWFVWDVUCUWJVVTUYHVUCUWJVWCVUFYNVWGVWAXRUWRV
      VQUUSXRYIUUTUVBUVCVVLVWJHVVQIUXDVVQLUXEVWIDBUXDVVQUWRMVLVMVNXRXPHDBUYKXQX
      NUVDWLUYMVVBUYTUWIKUYMVVBUYJUXRVTRZUYSWMRZUYTUYMUYJYRJWBYRJZUXRYRJZUXRWNU
      IZSZVVBVWLLUYMUYJUYNUVEVWMUYMUVFYMUYHVWPUWJUYHVWNVWOUXRUVGUXRUVHXAXHUYJWB
      UXRUVIYDUYMUYRVWKUYSWMUWJUYHUYRUXRCPVWKUVLZUBZVWKUWJUXRUWKVWQUWJVWQYPJUWK
      VWQLCPVWKUOUVJAIVWQYPEGYQYSUVKUYHVWKYPJVWRVWKLUYJUXRVTUVMCPVWKYPVWQVWQUVN
      YQYSUVOUVPUVQYLUYMUYKUYJUYMUYKVVGWQUYOUWDUVRYFYTUVSUVTUWAUWBUWCUWEYTUWFUY
      CUWJUWNUWOUWQSUKUYDUWMUWIUWGWGUWH $.

    $( One half of ~ rpnnen , where we show an injection from the real numbers
       to sequences of rational numbers.  Specifically, we map a real number
       ` x ` to the sequence ` ( F `` x ) : NN --> QQ ` such that
       ` ( ( F `` x ) `` k ) ` is the largest rational number with denominator
       ` k ` that is strictly less than ` x ` .  In this manner, we get a
       monotonically increasing sequence that converges to ` x ` , and since
       each sequence converges to a unique real number, this mapping from reals
       to sequences of rational numbers is injective.  (Contributed by Mario
       Carneiro, 13-May-2013.)  (Revised by Mario Carneiro, 16-Jun-2013.) $)
    rpnnen1 $p |- RR ~<_ ( QQ ^m NN ) $=
      ( vy cq cn cmap cvv wcel cr cv cfv wceq crn clt csup cdom wbr rpnnen1lem1
      co ovex wa rneq supeq1d rpnnen1lem5 fveq2 rneqd eqeq12d vtoclga eqeqan12d
      id syl5ib impbid1 dom2 ax-mp ) IJKUDZLMNUTUAUBIJKUEAHNUTAOZEPZHOZEPZLABCD
      EFGUCVANMZVCNMZUFZVBVDQZVAVCQZVHVBRZNSTZVDRZNSTZQVGVIVHNVJVLSVBVDUGUHVEVF
      VKVAVMVCABCDEFGUIZVKVAQVMVCQAVCNVIVKVMVAVCVINVJVLSVIVBVDVAVCEUJZUKUHVIUOU
      LVNUMUNUPVOUQURUS $.
  $}

  ${
    $d j k m n x y $.
    $( The set of real numbers exists.  (Contributed by NM, 30-Jul-2004.)
       (Revised by Mario Carneiro, 23-Aug-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    reexALT $p |- RR e. _V $=
      ( vx vm vk vn vy vj cr cn co cdom wbr cdiv clt crab csup cmpt wceq breq1d
      cv cz cq cmap wcel oveq1 cbvrabv oveq2 rabbidv supeq1d id oveq12d cbvmptv
      cvv breq2 oveq1d mpteq2dv syl5eq rpnnen1 reldom brrelexi ax-mp ) GUAHUBIZ
      JKGULUCABSZCSZLIZASZMKZBTNZCDEGFHVBFSZLIZESZMKZBTNZGMOZVHLIZPZPVFDSZVCLIZ
      VEMKBDTVBVPQVDVQVEMVBVPVCLUDRUEEAGVOCHVGGMOZVCLIZPZVJVEQZVOCHVDVJMKZBTNZG
      MOZVCLIZPVTFCHVNWEVHVCQZVMWDVHVCLWFGVLWCMWFVKWBBTWFVIVDVJMVHVCVBLUFRUGUHW
      FUIUJUKWACHWEVSWAWDVRVCLWAGWCVGMWAWBVFBTVJVEVDMUMUGUHUNUOUPUKUQGVAJURUSUT
      $.
  $}

  ${
    $d F u v w z $.  $d x y u v w z $.
    cnref1o.1 $e |- F = ( x e. RR , y e. RR |-> ( x + ( _i x. y ) ) ) $.
    $( There is a natural one-to-one mapping from ` ( RR X. RR ) ` to ` CC ` ,
       where we map ` <. x , y >. ` to ` ( x + ( _i x. y ) ) ` .  In our
       construction of the complex numbers, this is in fact our _definition_ of
       ` CC ` (see ~ df-c ), but in the axiomatic treatment we can only show
       that there is the expected mapping between these two sets.  (Contributed
       by Mario Carneiro, 16-Jun-2013.)  (Revised by Mario Carneiro,
       17-Feb-2014.) $)
    cnref1o $p |- F : ( RR X. RR ) -1-1-onto-> CC $=
      ( vz vw vu vv cr cc cv cfv wceq wcel ci cmul co caddc wa wrex cxp wf1 wfo
      wf1o wf wi wral wfn ovex fnmpt2i c1st c2nd cop 1st2nd2 fveq2d df-ov xp1st
      syl6eqr xp2nd oveq1 oveq2 oveq2d ovmpt2 syl2anc eqtrd recnd mulcl sylancr
      ax-icn addcld eqeltrd rgen ffnfv mpbir2an wb jca cru syl2an fveq2 oveq12d
      eqeq12d vtoclga eqeqan12d fvex opth syl6bb 3bitr4d biimpd rgen2a 2rexbiia
      dff13 cnre eqeq2d sylibr rexxp dffo3 df-f1o ) IIUAZJCUDWRJCUBZWRJCUCZWSWR
      JCUEZEKZCLZFKZCLZMZXBXDMZUFZFWRUGEWRUGXACWRUHXCJNZEWRUGABIIAKZOBKZPQZRQZC
      DXJXLRUIUJXIEWRXBWRNZXCXBUKLZOXBULLZPQZRQZJXNXCXOXPCQZXRXNXCXOXPUMZCLXSXN
      XBXTCXBIIUNZUOXOXPCUPURXNXOINZXPINZXSXRMXBIIUQZXBIIUSZABXOXPIIXMXRCXOXLRQ
      XJXOXLRUTXKXPMXLXQXORXKXPOPVAVBDXOXQRUIVCVDVEZXNXOXQXNXOYDVFXNOJNXPJNXQJN
      VIXNXPYEVFOXPVGVHVJVKVLEWRJCVMVNZXHEFWRXNXDWRNZSZXFXGYIXRXDUKLZOXDULLZPQZ
      RQZMZXOYJMXPYKMSZXFXGXNYBYCSYJINZYKINZSYNYOVOYHXNYBYCYDYEVPYHYPYQXDIIUQXD
      IIUSVPXOXPYJYKVQVRXNYHXCXRXEYMYFXCXRMXEYMMEXDWRXGXCXEXRYMXBXDCVSXGXOYJXQY
      LRXBXDUKVSXGXPYKOPXBXDULVSVBVTWAYFWBWCYIXGXTYJYKUMZMYOXNYHXBXTXDYRYAXDIIU
      NWCXOXPYJYKXBUKWDXBULWDWEWFWGWHWIEFWRJCWKVNWTXAXDXCMZEWRTZFJUGYGYTFJXDJNZ
      XDGKZHKZCQZMZHITGITZYTUUAXDUUBOUUCPQZRQZMZHITGITUUFGHXDWLUUEUUIGHIIUUBINU
      UCINSUUDUUHXDABUUBUUCIIXMUUHCUUBXLRQXJUUBXLRUTXKUUCMXLUUGUUBRXKUUCOPVAVBD
      UUBUUGRUIVCWMWJWNYSUUEEGHIIXBUUBUUCUMZMZXCUUDXDUUKXCUUJCLUUDXBUUJCVSUUBUU
      CCUPURWMWOWNVLEFWRJCWPVNWRJCWQVN $.
  $}

  ${
    $d x y $.
    $( The set of complex numbers exists.  See also ~ ax-cnex .  (Contributed
       by NM, 30-Jul-2004.)  (Revised by Mario Carneiro, 16-Jun-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cnexALT $p |- CC e. _V $=
      ( vx vy cr cxp cvv wcel cc cv ci cmul co caddc wfo reexALT xpex wf1o eqid
      cmpt2 cnref1o f1ofo ax-mp fornex mp2 ) CCDZEFUDGABCCAHIBHJKLKRZMZGEFCCNNO
      UDGUEPUFABUEUEQSUDGUETUAUDGEUEUBUC $.
  $}

  $( The set of extended reals exists.  (Contributed by NM, 24-Dec-2006.) $)
  xrex $p |- RR* e. _V $=
    ( cxr cr cpnf cmnf cpr cun cvv df-xr reex prex unex eqeltri ) ABCDEZFGHBMIC
    DJKL $.

  $( The addition operation is a set.  (Contributed by NM, 19-Oct-2004.)
     (Revised by Mario Carneiro, 17-Nov-2014.) $)
  addex $p |- + e. _V $=
    ( cc cxp caddc wf cvv wcel ax-addf cnex xpex fex2 mp3an ) AABZACDLEFAEFCEFG
    AAHHIHLACEEJK $.

  $( The multiplication operation is a set.  (Contributed by NM, 19-Oct-2004.)
     (Revised by Mario Carneiro, 17-Nov-2014.) $)
  mulex $p |- x. e. _V $=
    ( cc cxp cmul wf cvv wcel ax-mulf cnex xpex fex2 mp3an ) AABZACDLEFAEFCEFGA
    AHHIHLACEEJK $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Order sets
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Positive reals (as a subset of complex numbers)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RR+ $. $( The set of positive reals (blackboard bold R^+). $)

  $( Extend class notation to include the class of positive reals. $)
  crp $a class RR+ $.

  $( Define the set of positive reals.  Definition of positive numbers in
     [Apostol] p. 20.  (Contributed by NM, 27-Oct-2007.) $)
  df-rp $a |- RR+ = { x e. RR | 0 < x } $.

  ${
    $d x A $.
    $( Membership in the set of positive reals.  (Contributed by NM,
       27-Oct-2007.) $)
    elrp $p |- ( A e. RR+ <-> ( A e. RR /\ 0 < A ) ) $=
      ( vx cc0 cv clt wbr cr crp breq2 df-rp elrab2 ) CBDZEFCAEFBAGHLACEIBJK $.
  $}

  ${
    elrpi.1 $e |- A e. RR $.
    elrpi.2 $e |- 0 < A $.
    $( Membership in the set of positive reals.  (Contributed by NM,
       23-Feb-2008.) $)
    elrpii $p |- A e. RR+ $=
      ( crp wcel cr cc0 clt wbr elrp mpbir2an ) ADEAFEGAHIBCAJK $.
  $}

  $( 1 is a positive real.  (Contributed by Jeffrey Hankins, 23-Nov-2008.) $)
  1rp $p |- 1 e. RR+ $=
    ( c1 1re 0lt1 elrpii ) ABCD $.

  $( 2 is a positive real.  (Contributed by Mario Carneiro, 28-May-2016.) $)
  2rp $p |- 2 e. RR+ $=
    ( c2 2re 2pos elrpii ) ABCD $.

  $( A positive real is a real.  (Contributed by NM, 27-Oct-2007.) $)
  rpre $p |- ( A e. RR+ -> A e. RR ) $=
    ( vx crp cr cc0 cv clt wbr crab df-rp ssrab2 eqsstri sseli ) CDACEBFGHZBDID
    BJNBDKLM $.

  $( A positive real is an extended real.  (Contributed by Mario Carneiro,
     21-Aug-2015.) $)
  rpxr $p |- ( A e. RR+ -> A e. RR* ) $=
    ( crp wcel rpre rexrd ) ABCAADE $.

  $( A positive real is a complex number.  (Contributed by NM, 11-Nov-2008.) $)
  rpcn $p |- ( A e. RR+ -> A e. CC ) $=
    ( crp wcel rpre recnd ) ABCAADE $.

  $( A natural number is a positive real.  (Contributed by NM, 28-Nov-2008.) $)
  nnrp $p |- ( A e. NN -> A e. RR+ ) $=
    ( cn wcel cr cc0 clt wbr crp nnre nngt0 elrp sylanbrc ) ABCADCEAFGAHCAIAJAK
    L $.

  $( The positive reals are a subset of the reals.  (Contributed by NM,
     24-Feb-2008.) $)
  rpssre $p |- RR+ C_ RR $=
    ( vx crp cr cv rpre ssriv ) ABCADEF $.

  $( A positive real is greater than zero.  (Contributed by FL,
     27-Dec-2007.) $)
  rpgt0 $p |- ( A e. RR+ -> 0 < A ) $=
    ( crp wcel cr cc0 clt wbr elrp simprbi ) ABCADCEAFGAHI $.

  $( A positive real is greater than or equal to zero.  (Contributed by NM,
     22-Feb-2008.) $)
  rpge0 $p |- ( A e. RR+ -> 0 <_ A ) $=
    ( crp wcel cr cc0 clt wbr cle rpre rpgt0 wi 0re ltle mpan sylc ) ABCADCZEAF
    GZEAHGZAIAJEDCPQRKLEAMNO $.

  $( A positive real is a positive real number.  (Contributed by NM,
     11-Nov-2008.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
  rpregt0 $p |- ( A e. RR+ -> ( A e. RR /\ 0 < A ) ) $=
    ( crp wcel cr cc0 clt wbr wa elrp biimpi ) ABCADCEAFGHAIJ $.

  $( A positive real is a nonnegative real number.  (Contributed by Mario
     Carneiro, 31-Jan-2014.) $)
  rprege0 $p |- ( A e. RR+ -> ( A e. RR /\ 0 <_ A ) ) $=
    ( crp wcel cr cc0 cle wbr rpre rpge0 jca ) ABCADCEAFGAHAIJ $.

  $( A positive real is nonzero.  (Contributed by NM, 18-Jul-2008.) $)
  rpne0 $p |- ( A e. RR+ -> A =/= 0 ) $=
    ( crp wcel cr cc0 clt wbr wa wne rpregt0 gt0ne0 syl ) ABCADCEAFGHAEIAJAKL
    $.

  $( A positive real is a nonzero real number.  (Contributed by NM,
     11-Nov-2008.) $)
  rprene0 $p |- ( A e. RR+ -> ( A e. RR /\ A =/= 0 ) ) $=
    ( crp wcel cr cc0 wne rpre rpne0 jca ) ABCADCAEFAGAHI $.

  $( A positive real is a nonzero complex number.  (Contributed by NM,
     11-Nov-2008.) $)
  rpcnne0 $p |- ( A e. RR+ -> ( A e. CC /\ A =/= 0 ) ) $=
    ( crp wcel cc cc0 wne rpcn rpne0 jca ) ABCADCAEFAGAHI $.

  $( Quantification over positive reals.  (Contributed by NM, 12-Feb-2008.) $)
  ralrp $p |- ( A. x e. RR+ ph <-> A. x e. RR ( 0 < x -> ph ) ) $=
    ( cc0 cv clt wbr wi crp cr wcel wa elrp imbi1i impexp bitri ralbii2 ) ACBDZ
    EFZAGZBHIQHJZAGQIJZRKZAGUASGTUBAQLMUARANOP $.

  $( Quantification over positive reals.  (Contributed by Mario Carneiro,
     21-May-2014.) $)
  rexrp $p |- ( E. x e. RR+ ph <-> E. x e. RR ( 0 < x /\ ph ) ) $=
    ( cc0 cv clt wbr wa crp cr wcel elrp anbi1i anass bitri rexbii2 ) ACBDZEFZA
    GZBHIPHJZAGPIJZQGZAGTRGSUAAPKLTQAMNO $.

  $( Closure law for addition of positive reals.  Part of Axiom 7 of [Apostol]
     p. 20.  (Contributed by NM, 27-Oct-2007.) $)
  rpaddcl $p |- ( ( A e. RR+ /\ B e. RR+ ) -> ( A + B ) e. RR+ ) $=
    ( crp wcel wa caddc co cr cc0 clt wbr rpre readdcl syl2an elrp an4s syl2anb
    addgt0 sylanbrc ) ACDZBCDZEABFGZHDZIUBJKZUBCDTAHDZBHDZUCUAALBLABMNTUEIAJKZE
    UFIBJKZEUDUAAOBOUEUFUGUHUDABRPQUBOS $.

  $( Closure law for multiplication of positive reals.  Part of Axiom 7 of
     [Apostol] p. 20.  (Contributed by NM, 27-Oct-2007.) $)
  rpmulcl $p |- ( ( A e. RR+ /\ B e. RR+ ) -> ( A x. B ) e. RR+ ) $=
    ( crp wcel wa cmul co cc0 clt wbr rpre remulcl syl2an elrp syl2anb sylanbrc
    cr mulgt0 ) ACDZBCDZEABFGZQDZHUAIJZUACDSAQDZBQDZUBTAKBKABLMSUDHAIJEUEHBIJEU
    CTANBNABROUANP $.

  $( Closure law for division of positive reals.  (Contributed by FL,
     27-Dec-2007.) $)
  rpdivcl $p |- ( ( A e. RR+ /\ B e. RR+ ) -> ( A / B ) e. RR+ ) $=
    ( crp wcel wa cdiv co cr cc0 clt wbr rpre rprene0 redivcl 3expb syl2an elrp
    wne divgt0 syl2anb sylanbrc ) ACDZBCDZEABFGZHDZIUDJKZUDCDUBAHDZBHDZBIRZEUEU
    CALBMUGUHUIUEABNOPUBUGIAJKEUHIBJKEUFUCAQBQABSTUDQUA $.

  $( Closure law for reciprocation of positive reals.  (Contributed by Jeffrey
     Hankins, 23-Nov-2008.) $)
  rpreccl $p |- ( A e. RR+ -> ( 1 / A ) e. RR+ ) $=
    ( c1 crp wcel cdiv co 1rp rpdivcl mpan ) BCDACDBAEFCDGBAHI $.

  $( Closure law for half of a positive real.  (Contributed by Mario Carneiro,
     31-Jan-2014.) $)
  rphalfcl $p |- ( A e. RR+ -> ( A / 2 ) e. RR+ ) $=
    ( crp wcel c2 cdiv co 2rp rpdivcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( A number greater or equal to a positive real is positive real.
     (Contributed by Mario Carneiro, 28-May-2016.) $)
  rpgecl $p |- ( ( A e. RR+ /\ B e. RR /\ A <_ B ) -> B e. RR+ ) $=
    ( crp wcel cr cle wbr w3a cc0 clt simp2 0re a1i rpre 3ad2ant1 rpgt0 ltletrd
    simp3 elrp sylanbrc ) ACDZBEDZABFGZHZUBIBJGBCDUAUBUCKZUDIABIEDUDLMUAUBAEDUC
    ANOUEUAUBIAJGUCAPOUAUBUCRQBST $.

  $( Half of a positive real is less than the original number.  (Contributed by
     Mario Carneiro, 21-May-2014.) $)
  rphalflt $p |- ( A e. RR+ -> ( A / 2 ) < A ) $=
    ( crp wcel cr cc0 clt wbr wa c2 cdiv co elrp halfpos biimpa sylbi ) ABCADCZ
    EAFGZHAIJKAFGZALPQRAMNO $.

  $( Closure law for division of a real by a positive real.  (Contributed by
     NM, 10-Nov-2008.) $)
  rerpdivcl $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A / B ) e. RR ) $=
    ( crp wcel cr cc0 wne wa cdiv co rprene0 redivcl 3expb sylan2 ) BCDAEDZBEDZ
    BFGZHABIJEDZBKOPQRABLMN $.

  $( A nonnegative number plus one is a positive number.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  ge0p1rp $p |- ( ( A e. RR /\ 0 <_ A ) -> ( A + 1 ) e. RR+ ) $=
    ( cr cc0 cle wbr wa c1 caddc co clt crp peano2re adantr 0re a1i simpl simpr
    wcel ltp1 lelttrd elrp sylanbrc ) ABRZCADEZFZAGHIZBRZCUFJEUFKRUCUGUDALMZUEC
    AUFCBRUENOUCUDPUHUCUDQUCAUFJEUDASMTUFUAUB $.

  $( Either a nonzero real or its negation is a positive real, but not both.
     Axiom 8 of [Apostol] p. 20.  (Contributed by NM, 7-Nov-2008.) $)
  rpneg $p |- ( ( A e. RR /\ A =/= 0 ) -> ( A e. RR+ <-> -. -u A e. RR+ ) ) $=
    ( cr wcel cc0 wne wa clt wbr cneg wn crp wo wi 0re mpan imp adantr wb bitrd
    elrp ltle olcd renegcl pm2.24d ltlen biimprd exp3acom23 jaod jctild impbid2
    cle simpl lenlt lt0neg1 notbid orbi2d ianor syl6bbr notbii 3bitr4g ) ABCZAD
    EZFZVADAGHZFZAIZBCZDVFGHZFZJZAKCVFKCZJVCVEVGJZVHJZLZVJVCVEVLDAUKHZLZVNVCVEV
    PVEVOVLVAVDVODBCZVAVDVOMNDAUAOPUBVCVPVDVAVCVLVDVOVAVLVDMVBVAVGVDAUCUDQVAVBV
    OVDMVAVOVBVDVAVDVOVBFZVQVAVDVRRNDAUEOUFUGPUHVAVBULUIUJVCVOVMVLVAVOVMRVBVAVO
    ADGHZJZVMVQVAVOVTRNDAUMOVAVSVHAUNUOSQUPSVGVHUQURATVKVIVFTUSUT $.

  $( Zero is not a positive real.  Axiom 9 of [Apostol] p. 20.  (Contributed by
     NM, 27-Oct-2007.) $)
  0nrp $p |- -. 0 e. RR+ $=
    ( cc0 crp wcel clt wbr 0re ltnri rpgt0 mto ) ABCAADEAFGAHI $.

  $( Subtracting a positive real from another number decreases it.
     (Contributed by FL, 27-Dec-2007.) $)
  ltsubrp $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A - B ) < A ) $=
    ( crp wcel cr cc0 clt wbr wa cmin co elrp wi ltsubpos biimpd expcom sylan2b
    imp32 ) BCDAEDZBEDZFBGHZIABJKAGHZBLSTUAUBTSUAUBMTSIUAUBBANOPRQ $.

  $( Adding a positive number to another number increases it.  (Contributed by
     FL, 27-Dec-2007.) $)
  ltaddrp $p |- ( ( A e. RR /\ B e. RR+ ) -> A < ( A + B ) ) $=
    ( crp wcel cr cc0 clt wbr wa caddc co elrp wi ltaddpos biimpd imp32 sylan2b
    expcom ) BCDAEDZBEDZFBGHZIAABJKGHZBLSTUAUBTSUAUBMTSIUAUBBANORPQ $.

  $( Two ways to say one number is less than another.  (Contributed by Mario
     Carneiro, 21-May-2014.) $)
  difrp $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A < B <-> ( B - A ) e. RR+ ) ) $=
    ( cr wcel wa clt wbr cc0 cmin co crp posdif wb resubcl ancoms elrp baib syl
    bitr4d ) ACDZBCDZEZABFGHBAIJZFGZUCKDZABLUBUCCDZUEUDMUATUFBANOUEUFUDUCPQRS
    $.

  ${
    elrpd.1 $e |- ( ph -> A e. RR ) $.
    elrpd.2 $e |- ( ph -> 0 < A ) $.
    $( Membership in the set of positive reals.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    elrpd $p |- ( ph -> A e. RR+ ) $=
      ( cr wcel cc0 clt wbr crp elrp sylanbrc ) ABEFGBHIBJFCDBKL $.
  $}

  ${
    nnrpd.1 $e |- ( ph -> A e. NN ) $.
    $( A natural number is a positive real.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    nnrpd $p |- ( ph -> A e. RR+ ) $=
      ( cn wcel crp nnrp syl ) ABDEBFECBGH $.
  $}

  ${
    rpred.1 $e |- ( ph -> A e. RR+ ) $.
    $( A positive real is a real.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    rpred $p |- ( ph -> A e. RR ) $=
      ( crp cr rpssre sseldi ) ADEBFCG $.

    $( A positive real is an extended real.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    rpxrd $p |- ( ph -> A e. RR* ) $=
      ( rpred rexrd ) ABABCDE $.

    $( A positive real is a complex number.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    rpcnd $p |- ( ph -> A e. CC ) $=
      ( rpred recnd ) ABABCDE $.

    $( A positive real is greater than zero.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    rpgt0d $p |- ( ph -> 0 < A ) $=
      ( crp wcel cc0 clt wbr rpgt0 syl ) ABDEFBGHCBIJ $.

    $( A positive real is greater than or equal to zero.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rpge0d $p |- ( ph -> 0 <_ A ) $=
      ( crp wcel cc0 cle wbr rpge0 syl ) ABDEFBGHCBIJ $.

    $( A positive real is nonzero.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    rpne0d $p |- ( ph -> A =/= 0 ) $=
      ( crp wcel cc0 wne rpne0 syl ) ABDEBFGCBHI $.

    $( A positive real is real and greater than zero.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rpregt0d $p |- ( ph -> ( A e. RR /\ 0 < A ) ) $=
      ( cr wcel cc0 clt wbr rpred rpgt0d jca ) ABDEFBGHABCIABCJK $.

    $( A positive real is real and greater or equal to zero.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    rprege0d $p |- ( ph -> ( A e. RR /\ 0 <_ A ) ) $=
      ( cr wcel cc0 cle wbr rpred rpge0d jca ) ABDEFBGHABCIABCJK $.

    $( A positive real is a nonzero real number.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rprene0d $p |- ( ph -> ( A e. RR /\ A =/= 0 ) ) $=
      ( cr wcel cc0 wne rpred rpne0d jca ) ABDEBFGABCHABCIJ $.

    $( A positive real is a nonzero complex number.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rpcnne0d $p |- ( ph -> ( A e. CC /\ A =/= 0 ) ) $=
      ( cc wcel cc0 wne rpcnd rpne0d jca ) ABDEBFGABCHABCIJ $.

    $( Closure law for reciprocation of positive reals.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rpreccld $p |- ( ph -> ( 1 / A ) e. RR+ ) $=
      ( crp wcel c1 cdiv co rpreccl syl ) ABDEFBGHDECBIJ $.

    $( Closure law for reciprocation of positive reals.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rprecred $p |- ( ph -> ( 1 / A ) e. RR ) $=
      ( c1 cdiv co rpreccld rpred ) ADBEFABCGH $.

    $( Closure law for half of a positive real.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rphalfcld $p |- ( ph -> ( A / 2 ) e. RR+ ) $=
      ( crp wcel c2 cdiv co rphalfcl syl ) ABDEBFGHDECBIJ $.

    $( The reciprocal of a positive number less than 1 is greater than 1.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    reclt1d $p |- ( ph -> ( A < 1 <-> 1 < ( 1 / A ) ) ) $=
      ( cr wcel cc0 clt wbr wa c1 cdiv co wb rpregt0d reclt1 syl ) ABDEFBGHIBJG
      HJJBKLGHMABCNBOP $.

    $( The reciprocal of a positive number greater than 1 is less than 1.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    recgt1d $p |- ( ph -> ( 1 < A <-> ( 1 / A ) < 1 ) ) $=
      ( cr wcel cc0 clt wbr wa c1 cdiv co wb rpregt0d recgt1 syl ) ABDEFBGHIJBG
      HJBKLJGHMABCNBOP $.

    rpaddcld.1 $e |- ( ph -> B e. RR+ ) $.
    $( Closure law for addition of positive reals.  Part of Axiom 7 of
       [Apostol] p. 20.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    rpaddcld $p |- ( ph -> ( A + B ) e. RR+ ) $=
      ( crp wcel caddc co rpaddcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure law for multiplication of positive reals.  Part of Axiom 7 of
       [Apostol] p. 20.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    rpmulcld $p |- ( ph -> ( A x. B ) e. RR+ ) $=
      ( crp wcel cmul co rpmulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure law for division of positive reals.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rpdivcld $p |- ( ph -> ( A / B ) e. RR+ ) $=
      ( crp wcel cdiv co rpdivcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( The reciprocal of both sides of 'less than'.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    ltrecd $p |- ( ph -> ( A < B <-> ( 1 / B ) < ( 1 / A ) ) ) $=
      ( cr wcel cc0 clt wbr wa c1 cdiv co wb rpregt0d ltrec syl2anc ) ABFGHBIJK
      CFGHCIJKBCIJLCMNLBMNIJOABDPACEPBCQR $.

    $( The reciprocal of both sides of 'less than or equal to'.  (Contributed
       by Mario Carneiro, 28-May-2016.) $)
    lerecd $p |- ( ph -> ( A <_ B <-> ( 1 / B ) <_ ( 1 / A ) ) ) $=
      ( cr wcel cc0 clt wbr wa cle c1 cdiv co wb rpregt0d lerec syl2anc ) ABFGH
      BIJKCFGHCIJKBCLJMCNOMBNOLJPABDQACEQBCRS $.

    ${
      ltrec1d.2 $e |- ( ph -> ( 1 / A ) < B ) $.
      $( Reciprocal swap in a 'less than' relation.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      ltrec1d $p |- ( ph -> ( 1 / B ) < A ) $=
        ( c1 cdiv co clt wbr cr wcel cc0 wa wb rpregt0d ltrec1 syl2anc mpbid )
        AGBHICJKZGCHIBJKZFABLMNBJKOCLMNCJKOUAUBPABDQACEQBCRST $.
    $}

    ${
      lerec2d.2 $e |- ( ph -> A <_ ( 1 / B ) ) $.
      $( Reciprocal swap in a 'less than or equal to' relation.  (Contributed
         by Mario Carneiro, 28-May-2016.) $)
      lerec2d $p |- ( ph -> B <_ ( 1 / A ) ) $=
        ( c1 cdiv co cle wbr cr wcel cc0 clt wa wb rpregt0d lerec2 syl2anc
        mpbid ) ABGCHIJKZCGBHIJKZFABLMNBOKPCLMNCOKPUBUCQABDRACERBCSTUA $.
    $}

    ${
      lediv2ad.3 $e |- ( ph -> C e. RR ) $.
      lediv2ad.4 $e |- ( ph -> 0 <_ C ) $.
      lediv2ad.5 $e |- ( ph -> A <_ B ) $.
      $( Division of both sides of 'less than or equal to' into a nonnegative
         number.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      lediv2ad $p |- ( ph -> ( C / B ) <_ ( C / A ) ) $=
        ( cr wcel cc0 clt wbr wa cle cdiv co rpregt0d jca lediv2a syl31anc ) AB
        JKLBMNOCJKLCMNODJKZLDPNZOBCPNDCQRDBQRPNABESACFSAUCUDGHTIBCDUAUB $.
    $}

    ltdiv2d.3 $e |- ( ph -> C e. RR+ ) $.
    $( Division of a positive number by both sides of 'less than'.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltdiv2d $p |- ( ph -> ( A < B <-> ( C / B ) < ( C / A ) ) ) $=
      ( cr wcel cc0 clt wbr wa cdiv co wb rpregt0d ltdiv2 syl3anc ) ABHIJBKLMCH
      IJCKLMDHIJDKLMBCKLDCNODBNOKLPABEQACFQADGQBCDRS $.

    $( Division of a positive number by both sides of 'less than or equal to'.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    lediv2d $p |- ( ph -> ( A <_ B <-> ( C / B ) <_ ( C / A ) ) ) $=
      ( cr wcel cc0 clt wbr wa cle cdiv co wb rpregt0d lediv2 syl3anc ) ABHIJBK
      LMCHIJCKLMDHIJDKLMBCNLDCOPDBOPNLQABERACFRADGRBCDST $.

    ledivdivd.4 $e |- ( ph -> D e. RR+ ) $.
    ${
      ledivdivd.5 $e |- ( ph -> ( A / B ) <_ ( C / D ) ) $.
      $( Invert ratios of positive numbers and swap their ordering.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      ledivdivd $p |- ( ph -> ( D / C ) <_ ( B / A ) ) $=
        ( cdiv co cle wbr cr wcel cc0 clt wa rpregt0d ledivdiv syl22anc mpbid
        wb ) ABCKLDEKLMNZEDKLCBKLMNZJABOPQBRNSCOPQCRNSDOPQDRNSEOPQERNSUEUFUDABF
        TACGTADHTAEITBCDEUAUBUC $.
    $}
  $}

  ${
    rpgecld.1 $e |- ( ph -> A e. RR ) $.
    ${
      ge0p1rp.2 $e |- ( ph -> 0 <_ A ) $.
      $( A nonnegative number plus one is a positive number.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      ge0p1rpd $p |- ( ph -> ( A + 1 ) e. RR+ ) $=
        ( cr wcel cc0 cle wbr c1 caddc co crp ge0p1rp syl2anc ) ABEFGBHIBJKLMFC
        DBNO $.
    $}

    rpgecld.2 $e |- ( ph -> B e. RR+ ) $.
    $( Closure law for division of a real by a positive real.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    rerpdivcld $p |- ( ph -> ( A / B ) e. RR ) $=
      ( cr wcel crp cdiv co rerpdivcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.

    $( Subtracting a positive real from another number decreases it.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltsubrpd $p |- ( ph -> ( A - B ) < A ) $=
      ( cr wcel crp cmin co clt wbr ltsubrp syl2anc ) ABFGCHGBCIJBKLDEBCMN $.

    $( Adding a positive number to another number increases it.  (Contributed
       by Mario Carneiro, 28-May-2016.) $)
    ltaddrpd $p |- ( ph -> A < ( A + B ) ) $=
      ( cr wcel crp caddc co clt wbr ltaddrp syl2anc ) ABFGCHGBBCIJKLDEBCMN $.

    $( Adding a positive number to another number increases it.  (Contributed
       by Mario Carneiro, 28-May-2016.) $)
    ltaddrp2d $p |- ( ph -> A < ( B + A ) ) $=
      ( caddc co clt ltaddrpd recnd rpcnd addcomd breqtrd ) ABBCFGCBFGHABCDEIAB
      CABDJACEKLM $.

    $( Multiplication by a number greater than 1.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    ltmulgt11d $p |- ( ph -> ( 1 < A <-> B < ( B x. A ) ) ) $=
      ( cr wcel cc0 clt wbr c1 cmul co wb rpred rpgt0d ltmulgt11 syl3anc ) ACFG
      BFGHCIJKBIJCCBLMIJNACEODACEPCBQR $.

    $( Multiplication by a number greater than 1.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    ltmulgt12d $p |- ( ph -> ( 1 < A <-> B < ( A x. B ) ) ) $=
      ( cr wcel cc0 clt wbr c1 cmul co wb rpred rpgt0d ltmulgt12 syl3anc ) ACFG
      BFGHCIJKBIJCBCLMIJNACEODACEPCBQR $.

    $( Division of a positive number by a positive number.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    gt0divd $p |- ( ph -> ( 0 < A <-> 0 < ( A / B ) ) ) $=
      ( cr wcel cc0 clt wbr cdiv co wb rpred rpgt0d gt0div syl3anc ) ABFGCFGHCI
      JHBIJHBCKLIJMDACENACEOBCPQ $.

    $( Division of a nonnegative number by a positive number.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    ge0divd $p |- ( ph -> ( 0 <_ A <-> 0 <_ ( A / B ) ) ) $=
      ( cr wcel cc0 clt wbr cle cdiv co wb rpred rpgt0d ge0div syl3anc ) ABFGCF
      GHCIJHBKJHBCLMKJNDACEOACEPBCQR $.

    ${
      rpgecld.3 $e |- ( ph -> B <_ A ) $.
      $( A number greater or equal to a positive real is positive real.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      rpgecld $p |- ( ph -> A e. RR+ ) $=
        ( crp wcel cr cle wbr rpgecl syl3anc ) ACGHBIHCBJKBGHEDFCBLM $.
    $}

    divge0d.3 $e |- ( ph -> 0 <_ A ) $.
    $( The ratio of nonnegative and positive numbers is nonnegative.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    divge0d $p |- ( ph -> 0 <_ ( A / B ) ) $=
      ( cr wcel cc0 cle wbr clt wa cdiv co rpregt0d divge0 syl21anc ) ABGHIBJKC
      GHICLKMIBCNOJKDFACEPBCQR $.
  $}

  ${
    ltmul1d.1 $e |- ( ph -> A e. RR ) $.
    ltmul1d.2 $e |- ( ph -> B e. RR ) $.
    ltmul1d.3 $e |- ( ph -> C e. RR+ ) $.
    $( The ratio of nonnegative and positive numbers is nonnegative.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltmul1d $p |- ( ph -> ( A < B <-> ( A x. C ) < ( B x. C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co wb rpregt0d ltmul1 syl3anc ) ABHICHIDHIJ
      DKLMBCKLBDNOCDNOKLPEFADGQBCDRS $.

    $( Multiplication of both sides of 'less than' by a positive number.
       Theorem I.19 of [Apostol] p. 20.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    ltmul2d $p |- ( ph -> ( A < B <-> ( C x. A ) < ( C x. B ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co wb rpregt0d ltmul2 syl3anc ) ABHICHIDHIJ
      DKLMBCKLDBNODCNOKLPEFADGQBCDRS $.

    $( Multiplication of both sides of 'less than or equal to' by a positive
       number.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    lemul1d $p |- ( ph -> ( A <_ B <-> ( A x. C ) <_ ( B x. C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cle cmul co wb rpregt0d lemul1 syl3anc ) ABHICHI
      DHIJDKLMBCNLBDOPCDOPNLQEFADGRBCDST $.

    $( Multiplication of both sides of 'less than or equal to' by a positive
       number.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    lemul2d $p |- ( ph -> ( A <_ B <-> ( C x. A ) <_ ( C x. B ) ) ) $=
      ( cr wcel cc0 clt wbr wa cle cmul co wb rpregt0d lemul2 syl3anc ) ABHICHI
      DHIJDKLMBCNLDBOPDCOPNLQEFADGRBCDST $.

    $( Division of both sides of 'less than' by a positive number.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltdiv1d $p |- ( ph -> ( A < B <-> ( A / C ) < ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cdiv co wb rpregt0d ltdiv1 syl3anc ) ABHICHIDHIJ
      DKLMBCKLBDNOCDNOKLPEFADGQBCDRS $.

    $( Division of both sides of a less than or equal to relation by a positive
       number.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    lediv1d $p |- ( ph -> ( A <_ B <-> ( A / C ) <_ ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cle cdiv co wb rpregt0d lediv1 syl3anc ) ABHICHI
      DHIJDKLMBCNLBDOPCDOPNLQEFADGRBCDST $.

    $( 'Less than' relationship between division and multiplication.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltmuldivd $p |- ( ph -> ( ( A x. C ) < B <-> A < ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co cdiv wb rpregt0d ltmuldiv syl3anc ) ABHI
      CHIDHIJDKLMBDNOCKLBCDPOKLQEFADGRBCDST $.

    $( 'Less than' relationship between division and multiplication.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltmuldiv2d $p |- ( ph -> ( ( C x. A ) < B <-> A < ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co cdiv wb rpregt0d ltmuldiv2 syl3anc ) ABH
      ICHIDHIJDKLMDBNOCKLBCDPOKLQEFADGRBCDST $.

    $( 'Less than or equal to' relationship between division and
       multiplication.  (Contributed by Mario Carneiro, 30-May-2016.) $)
    lemuldivd $p |- ( ph -> ( ( A x. C ) <_ B <-> A <_ ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co cle cdiv wb rpregt0d lemuldiv syl3anc )
      ABHICHIDHIJDKLMBDNOCPLBCDQOPLREFADGSBCDTUA $.

    $( 'Less than or equal to' relationship between division and
       multiplication.  (Contributed by Mario Carneiro, 30-May-2016.) $)
    lemuldiv2d $p |- ( ph -> ( ( C x. A ) <_ B <-> A <_ ( B / C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co cle cdiv wb rpregt0d lemuldiv2 syl3anc )
      ABHICHIDHIJDKLMDBNOCPLBCDQOPLREFADGSBCDTUA $.

    $( 'Less than' relationship between division and multiplication.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltdivmuld $p |- ( ph -> ( ( A / C ) < B <-> A < ( C x. B ) ) ) $=
      ( cr wcel cc0 clt wbr wa cdiv co cmul wb rpregt0d ltdivmul syl3anc ) ABHI
      CHIDHIJDKLMBDNOCKLBDCPOKLQEFADGRBCDST $.

    $( 'Less than' relationship between division and multiplication.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltdivmul2d $p |- ( ph -> ( ( A / C ) < B <-> A < ( B x. C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cdiv co cmul wb rpregt0d ltdivmul2 syl3anc ) ABH
      ICHIDHIJDKLMBDNOCKLBCDPOKLQEFADGRBCDST $.

    $( 'Less than or equal to' relationship between division and
       multiplication.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    ledivmuld $p |- ( ph -> ( ( A / C ) <_ B <-> A <_ ( C x. B ) ) ) $=
      ( cr wcel cc0 clt wbr wa cdiv co cle cmul wb rpregt0d ledivmul syl3anc )
      ABHICHIDHIJDKLMBDNOCPLBDCQOPLREFADGSBCDTUA $.

    $( 'Less than or equal to' relationship between division and
       multiplication.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    ledivmul2d $p |- ( ph -> ( ( A / C ) <_ B <-> A <_ ( B x. C ) ) ) $=
      ( cr wcel cc0 clt wbr wa cdiv co cle cmul wb rpregt0d ledivmul2 syl3anc )
      ABHICHIDHIJDKLMBDNOCPLBCDQOPLREFADGSBCDTUA $.

    ${
      ltdiv1dd.4 $e |- ( ph -> A < B ) $.
      $( The ratio of nonnegative and positive numbers is nonnegative.
         (Contributed by Mario Carneiro, 30-May-2016.) $)
      ltmul1dd $p |- ( ph -> ( A x. C ) < ( B x. C ) ) $=
        ( clt wbr cmul co ltmul1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.

      $( Multiplication of both sides of 'less than' by a positive number.
         Theorem I.19 of [Apostol] p. 20.  (Contributed by Mario Carneiro,
         30-May-2016.) $)
      ltmul2dd $p |- ( ph -> ( C x. A ) < ( C x. B ) ) $=
        ( clt wbr cmul co ltmul2d mpbid ) ABCIJDBKLDCKLIJHABCDEFGMN $.

      $( Division of both sides of 'less than' by a positive number.
         (Contributed by Mario Carneiro, 30-May-2016.) $)
      ltdiv1dd $p |- ( ph -> ( A / C ) < ( B / C ) ) $=
        ( clt wbr cdiv co ltdiv1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.
    $}

    ${
      lediv1dd.4 $e |- ( ph -> A <_ B ) $.
      $( Division of both sides of a less than or equal to relation by a
         positive number.  (Contributed by Mario Carneiro, 30-May-2016.) $)
      lediv1dd $p |- ( ph -> ( A / C ) <_ ( B / C ) ) $=
        ( cle wbr cdiv co lediv1d mpbid ) ABCIJBDKLCDKLIJHABCDEFGMN $.
    $}

    ${
      lediv12ad.4 $e |- ( ph -> D e. RR ) $.
      lediv12ad.5 $e |- ( ph -> 0 <_ A ) $.
      lediv12ad.6 $e |- ( ph -> A <_ B ) $.
      lediv12ad.7 $e |- ( ph -> C <_ D ) $.
      $( Comparison of ratio of two nonnegative numbers.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      lediv12ad $p |- ( ph -> ( A / D ) <_ ( B / C ) ) $=
        ( cr wcel wa cc0 cle wbr cdiv jca clt co rpred rpgt0d lediv12a syl22anc
        ) ABMNZCMNZOPBQRZBCQRZODMNZEMNZOPDUARZDEQRZOBESUBCDSUBQRAUGUHFGTAUIUJJK
        TAUKULADHUCITAUMUNADHUDLTBCDEUEUF $.
    $}
  $}

  ${
    ltdiv23d.1 $e |- ( ph -> A e. RR ) $.
    ltdiv23d.2 $e |- ( ph -> B e. RR+ ) $.
    ltdiv23d.3 $e |- ( ph -> C e. RR+ ) $.
    ${
      ltdiv23d.4 $e |- ( ph -> ( A / B ) < C ) $.
      $( Swap denominator with other side of 'less than'.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      ltdiv23d $p |- ( ph -> ( A / C ) < B ) $=
        ( cdiv co clt wbr cr wcel cc0 wa wb rpregt0d ltdiv23 syl3anc mpbid ) AB
        CIJDKLZBDIJCKLZHABMNCMNOCKLPDMNODKLPUBUCQEACFRADGRBCDSTUA $.
    $}

    ${
      lediv23d.4 $e |- ( ph -> ( A / B ) <_ C ) $.
      $( Swap denominator with other side of 'less than or equal to'.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      lediv23d $p |- ( ph -> ( A / C ) <_ B ) $=
        ( cdiv co cle wbr cr wcel cc0 clt wa wb rpregt0d lediv23 syl3anc mpbid
        ) ABCIJDKLZBDIJCKLZHABMNCMNOCPLQDMNODPLQUCUDREACFSADGSBCDTUAUB $.
    $}
  $}

  ${
    lt2mul2divd.1 $e |- ( ph -> A e. RR ) $.
    lt2mul2divd.2 $e |- ( ph -> B e. RR+ ) $.
    lt2mul2divd.3 $e |- ( ph -> C e. RR ) $.
    lt2mul2divd.4 $e |- ( ph -> D e. RR+ ) $.
    $( The ratio of nonnegative and positive numbers is nonnegative.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    lt2mul2divd $p |- ( ph ->
      ( ( A x. B ) < ( C x. D ) <-> ( A / D ) < ( C / B ) ) ) $=
      ( cr wcel cc0 clt wbr wa cmul co cdiv wb rpregt0d lt2mul2div syl22anc ) A
      BJKCJKLCMNODJKEJKLEMNOBCPQDEPQMNBERQDCRQMNSFACGTHAEITBCDEUAUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Infinity and the extended real number system (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)
  $c -e $. $( the negative of an extended real number. $)
  $c +e $. $( Addition of extended real numbers. $)
  $c *e $. $( Multiplication of extended real numbers. $)

  $( Extend class notation to include the negative of an extended real. $)
  cxne $a class -e A $.

  $( Extend class notation to include addition of extended reals. $)
  cxad $a class +e $.

  $( Extend class notation to include multiplication of extended reals. $)
  cxmu $a class *e $.

  $( Define the negative of an extended real number.  (Contributed by FL,
     26-Dec-2011.) $)
  df-xneg $a |- -e A = if ( A = +oo , -oo , if ( A = -oo , +oo , -u A ) ) $.

  ${
    $d x y $.
    $( Define addition over extended real numbers.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    df-xadd $a |- +e = ( x e. RR* , y e. RR* |-> if ( x = +oo ,
            if ( y = -oo , 0 , +oo ) , if ( x = -oo ,
            if ( y = +oo , 0 , -oo ) , if ( y = +oo , +oo ,
                 if ( y = -oo , -oo , ( x + y ) ) ) ) ) ) $.

    $( Define multiplication over extended real numbers.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    df-xmul $a |- *e = ( x e. RR* , y e. RR* |-> if ( ( x = 0 \/ y = 0 ) , 0 ,
            if ( ( ( ( 0 < y /\ x = +oo ) \/ ( y < 0 /\ x = -oo ) ) \/
                   ( ( 0 < x /\ y = +oo ) \/ ( x < 0 /\ y = -oo ) ) ) , +oo ,
            if ( ( ( ( 0 < y /\ x = -oo ) \/ ( y < 0 /\ x = +oo ) ) \/
                   ( ( 0 < x /\ y = -oo ) \/ ( x < 0 /\ y = +oo ) ) ) , -oo ,
                 ( x x. y ) ) ) ) ) $.
  $}

  $( Plus infinity belongs to the set of extended reals.  (Contributed by NM,
     13-Oct-2005.)  (Proof shortened by Anthony Hart, 29-Aug-2011.) $)
  pnfxr $p |- +oo e. RR* $=
    ( cpnf cr cmnf cpr cun cxr ssun2 cc cuni cpw df-pnf cnex uniex pwex eqeltri
    cvv prid1 sselii df-xr eleqtrri ) ABACDZEZFUAUBAUABGACAHIZJPKUCHLMNOQRST $.

  $( Minus infinity belongs to the set of extended reals.  (Contributed by NM,
     13-Oct-2005.)  (Proof shortened by Anthony Hart, 29-Aug-2011.)  (Proof
     shortened by Andrew Salmon, 19-Nov-2011.) $)
  mnfxr $p |- -oo e. RR* $=
    ( cmnf cr cpnf cpr cun cxr wcel cpw cvv df-mnf pnfxr elexi pwex prid2 elun2
    eqeltri ax-mp df-xr eleqtrri ) ABCADZEZFATGAUAGCAACHIJCCFKLMPNATBOQRS $.

  ${
    $d x y A $.  $d x y B $.
    $( The 'less than' binary relation on the set of extended reals.
       Definition 12-3.1 of [Gleason] p. 173.  (Contributed by NM,
       14-Oct-2005.) $)
    ltxr $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B <->
              ( ( ( ( A e. RR /\ B e. RR ) /\ A <RR B ) \/
                   ( A = -oo /\ B = +oo ) ) \/ ( ( A e. RR /\ B = +oo )
                  \/ ( A = -oo /\ B e. RR ) ) ) ) ) $=
      ( vx vy cxr wcel wa cv cr cltrr wbr cmnf csn cun cpnf cxp wceq clt syl5bb
      wo w3a copab breq12 df-3an opabbii brab2ga a1i brun brxp elun orcom bitri
      wb elsncg orbi1d bi2anan9 andir syl6bb anbi1d orbi12d orass df-ltxr breqi
      adantr 3bitr4g ) AEFZBEFZGZABCHZIFZDHZIFZVIVKJKZUAZCDUBZKZABILMZNZOMZPZVQ
      IPZNZKZTZAIFZBIFZGABJKZGZALQZBOQZGZWEWJGZWIWFGZTZTZTABRKZWHWKTWNTVHVPWHWC
      WOVPWHUMVHVMWGCDABIIVOVIAVKBJUCVNVJVLGVMGCDVJVLVMUDUEUFUGWCABVTKZABWAKZTZ
      VHWOABVTWAUHVHWSWKWLTZWMTWOVHWQWTWRWMWQAVRFZBVSFZGZVHWTABVRVSUIVHXCWIWETZ
      WJGWTVFXAXDVGXBWJXAAVQFZWETZVFXDXAWEXETXFAIVQUJWEXEUKULVFXEWIWEALEUNZUOSB
      OEUNUPWIWEWJUQURSWRXEWFGZVHWMABVQIUIVFXHWMUMVGVFXEWIWFXGUSVDSUTWKWLWMVAUR
      SUTWPABVOWBNZKWDABRXICDVBVCABVOWBUHULWHWKWNVAVE $.
  $}

  $( Membership in the set of extended reals.  (Contributed by NM,
     14-Oct-2005.) $)
  elxr $p |- ( A e. RR* <-> ( A e. RR \/ A = +oo \/ A = -oo ) ) $=
    ( cxr wcel cr cpnf cmnf cpr cun wo wceq df-xr eleq2i elun pnfxr elexi mnfxr
    w3o elpr2 orbi2i 3orass bitr4i 3bitri ) ABCADEFGZHZCADCZAUCCZIZUEAEJZAFJZQZ
    BUDAKLADUCMUGUEUHUIIZIUJUFUKUEAEFEBNOFBPORSUEUHUITUAUB $.

  $( Plus and minus infinity are distinguished elements of ` RR* ` .
     (Contributed by NM, 14-Oct-2005.) $)
  pnfnemnf $p |- +oo =/= -oo $=
    ( cpnf cpw cmnf cxr wcel wne pnfxr pwne ax-mp necomi df-mnf neeqtrri ) AABZ
    CMAADEMAFGADHIJKL $.

  $( An extended real other than minus infinity is real or positive infinite.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xrnemnf $p |- ( ( A e. RR* /\ A =/= -oo ) <-> ( A e. RR \/ A = +oo ) ) $=
    ( cr wcel cpnf wceq wo cmnf wn cxr wne pm5.61 w3o elxr df-3or bitri anbi12i
    wa df-ne renemnf pnfnemnf neeq1 mpbiri jaoi neneqd pm4.71i 3bitr4i ) ABCZAD
    EZFZAGEZFZUJHZQUIULQAICZAGJZQUIUIUJKUMUKUNULUMUGUHUJLUKAMUGUHUJNOAGRPUIULUI
    AGUGUNUHASUHUNDGJTADGUAUBUCUDUEUF $.

  $( An extended real other than plus infinity is real or negative infinite.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xrnepnf $p |- ( ( A e. RR* /\ A =/= +oo ) <-> ( A e. RR \/ A = -oo ) ) $=
    ( cr wcel cmnf wceq wo cpnf wn wa cxr wne pm5.61 w3o elxr df-3or or32 df-ne
    3bitri anbi12i renepnf pnfnemnf necomi neeq1 mpbiri neneqd pm4.71i 3bitr4i
    jaoi ) ABCZADEZFZAGEZFZULHZIUKUNIAJCZAGKZIUKUKULLUOUMUPUNUOUIULUJMUIULFUJFU
    MANUIULUJOUIULUJPRAGQSUKUNUKAGUIUPUJATUJUPDGKGDUAUBADGUCUDUHUEUFUG $.

  $( The extended real 'less than' is irreflexive.  (Contributed by NM,
     14-Oct-2005.) $)
  xrltnr $p |- ( A e. RR* -> -. A < A ) $=
    ( cxr wcel cr cpnf wceq cmnf clt wbr wa cltrr neli intnanr pnfnemnf pm3.2ni
    wo intnan wb pnfxr ltxr w3o elxr ltnr pnfnre neii mp2an mtbir breq12 anidms
    wn mtbiri mnfnre nesymi mnfxr 3jaoi sylbi ) ABCADCZAEFZAGFZUAAAHIZUJZAUBUQV
    AURUSAUCURUTEEHIZVBEDCZVCJZEEKIZJZEGFZEEFZJZPZVCVHJZVGVCJZPZPZVJVMVFVIVDVEV
    CVCEDUDLZQMVGVHEGNUEMOVKVLVCVHVOMVCVGVOQOOEBCZVPVBVNRSSEETUFUGURUTVBRAEAEHU
    HUIUKUSUTGGHIZVQGDCZVRJZGGKIZJZGGFZGEFZJZPZVRWCJZWBVRJZPZPZWEWHWAWDVSVTVRVR
    GDULLZQMWCWBEGNUMQOWFWGVRWCWJMVRWBWJQOOGBCZWKVQWIRUNUNGGTUFUGUSUTVQRAGAGHUH
    UIUKUOUP $.

  $( Any (finite) real is less than plus infinity.  (Contributed by NM,
     14-Oct-2005.) $)
  ltpnf $p |- ( A e. RR -> A < +oo ) $=
    ( cr wcel cpnf clt wbr wa cltrr cmnf wceq wo eqid orc mpan2 olcd rexr pnfxr
    cxr wb ltxr sylancl mpbird ) ABCZADEFZUCDBCZGADHFGAIJZDDJZGKZUCUGGZUFUEGZKZ
    KZUCUKUHUCUGUKDLUIUJMNOUCARCDRCUDULSAPQADTUAUB $.

  $( Minus infinity is less than any (finite) real.  (Contributed by NM,
     14-Oct-2005.) $)
  mnflt $p |- ( A e. RR -> -oo < A ) $=
    ( cr wcel cmnf clt wbr wa cltrr wceq cpnf wo eqid olc mpan olcd cxr wb rexr
    mnfxr ltxr sylancr mpbird ) ABCZDAEFZDBCZUCGDAHFGDDIZAJIZGKZUEUGGZUFUCGZKZK
    ZUCUKUHUFUCUKDLUJUIMNOUCDPCAPCUDULQSARDATUAUB $.

  $( Minus infinity is less than plus infinity.  (Contributed by NM,
     14-Oct-2005.) $)
  mnfltpnf $p |- -oo < +oo $=
    ( cmnf cpnf clt wbr cr wcel wa cltrr wceq wo eqid olc mp2an cxr mnfxr pnfxr
    orci wb ltxr mpbir ) ABCDZAEFZBEFZGABHDGZAAIZBBIZGZJZUBUFGUEUCGJZJZUHUIUEUF
    UHAKBKUGUDLMQANFBNFUAUJROPABSMT $.

  $( Minus infinity is less than an extended real that is either real or plus
     infinity.  (Contributed by NM, 2-Feb-2006.) $)
  mnfltxr $p |- ( ( A e. RR \/ A = +oo ) -> -oo < A ) $=
    ( cr wcel cmnf clt wbr cpnf wceq mnflt mnfltpnf breq2 mpbiri jaoi ) ABCDAEF
    ZAGHZAIONDGEFJAGDEKLM $.

  $( No extended real is greater than plus infinity.  (Contributed by NM,
     15-Oct-2005.) $)
  pnfnlt $p |- ( A e. RR* -> -. +oo < A ) $=
    ( cxr wcel cpnf clt wbr cr wa cltrr cmnf wceq wo neli intnanr pnfnemnf neii
    pnfnre pm3.2ni wb pnfxr ltxr mpan mtbiri ) ABCZDAEFZDGCZAGCZHZDAIFZHZDJKZAD
    KZHZLZUFULHZUKUGHZLZLZUNUQUJUMUHUIUFUGDGQMZNNUKULDJOPZNRUOUPUFULUSNUKUGUTNR
    RDBCUDUEURSTDAUAUBUC $.

  $( No extended real is less than minus infinity.  (Contributed by NM,
     15-Oct-2005.) $)
  nltmnf $p |- ( A e. RR* -> -. A < -oo ) $=
    ( cxr wcel cmnf clt wbr cr wa cltrr wceq cpnf wo mnfnre neli intnan intnanr
    pnfnemnf nesymi pm3.2ni wb mnfxr ltxr mpan2 mtbiri ) ABCZADEFZAGCZDGCZHZADI
    FZHZADJZDKJZHZLZUGUMHZULUHHZLZLZUOURUKUNUIUJUHUGDGMNZOPUMULKDQRZOSUPUQUMUGV
    AOUHULUTOSSUEDBCUFUSTUAADUBUCUD $.

  $( Plus infinity is an upper bound for extended reals.  (Contributed by NM,
     30-Jan-2006.) $)
  pnfge $p |- ( A e. RR* -> A <_ +oo ) $=
    ( cxr wcel cpnf cle wbr clt wn pnfnlt wb pnfxr xrlenlt mpan2 mpbird ) ABCZA
    DEFZDAGFHZAIODBCPQJKADLMN $.

  $( If a number is a nonnegative integer or positive infinity, it is greater
     than or equal to 0.  (Contributed by Alexander van der Vekens,
     6-Jan-2018.) $)
  nn0pnfge0 $p |- ( ( N e. NN0 \/ N = +oo ) -> 0 <_ N ) $=
    ( cn0 wcel cc0 cle wbr cpnf wceq nn0ge0 cxr pnfge ax-mp breq2 mpbiri jaoi
    0xr ) ABCDAEFZAGHZAIRQDGEFZDJCSPDKLAGDEMNO $.

  $( Minus infinity is less than or equal to any extended real.  (Contributed
     by NM, 19-Jan-2006.) $)
  mnfle $p |- ( A e. RR* -> -oo <_ A ) $=
    ( cxr wcel cmnf cle wbr clt wn nltmnf wb mnfxr xrlenlt mpan mpbird ) ABCZDA
    EFZADGFHZAIDBCOPQJKDALMN $.

  $( Ordering on the extended reals is not symmetric.  (Contributed by NM,
     15-Oct-2005.) $)
  xrltnsym $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A < B -> -. B < A ) ) $=
    ( cxr wcel cr cpnf wceq cmnf clt wbr wn pnfnlt syl adantr adantl mtbird a1d
    wa wb pm2.21d wi elxr ltnsym rexr breq1 nltmnf breq2 3jaodan sylan2br mnfxr
    w3o ax-mp breq12 mtbiri ancoms xrltnr 3jaoian syl2anb ) ACDZAEDZAFGZAHGZUKB
    EDZBFGZBHGZUKZABIJZBAIJZKZUAZBCDZAUBBUBZUTVFVJVAVBUTVCVJVDVEABUCUTVDRZVIVGV
    MVHFAIJZUTVNKZVDUTUSVOAUDZALMNVDVHVNSUTBFAIUEOPQUTVERZVGVIVQVGAHIJZUTVRKZVE
    UTUSVSVPAUFMNVEVGVRSUTBHAIUGOPTUHVFVAVKVJVLVAVKRZVGVIVTVGFBIJZVKWAKVABLOVAV
    GWASVKAFBIUENPTUIVBVCVJVDVEVBVCRZVIVGWBVHBHIJZVCWCKZVBVCVKWDBUDBUFMOVBVHWCS
    VCAHBIUGNPQVBVDRVIVGVDVBVIVDVBRVHFHIJZHCDZWEKUJHLULBFAHIUMUNUOQVBVERZVGVIWG
    VGHHIJZWFWHKUJHUPULAHBHIUMUNTUHUQUR $.

  $( 'Less than' is antisymmetric and irreflexive for extended reals.
     (Contributed by NM, 6-Feb-2007.) $)
  xrltnsym2 $p |- ( ( A e. RR* /\ B e. RR* ) -> -. ( A < B /\ B < A ) ) $=
    ( cxr wcel wa clt wbr wn wi xrltnsym imnan sylib ) ACDBCDEABFGZBAFGZHIMNEHA
    BJMNKL $.

  $( Ordering on the extended reals satisfies strict trichotomy.  New proofs
     should generally use this instead of ~ ax-pre-lttri or ~ axlttri .
     (Contributed by NM, 14-Oct-2005.) $)
  xrlttri $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A < B <-> -. ( A = B \/ B < A ) ) ) $=
    ( wcel wa wceq clt wbr wn wi adantr wb adantl cpnf cmnf mpbird pm2.24d olcd
    breq2 a1d 3jaodan cxr wo xrltnr mtbid xrltnsym ancoms jaod w3o elxr axlttri
    ex cr biimprd con1d ltpnf mnflt breq1 eqtr3 mnfltpnf breq12 3jaoian syl2anb
    orcd mpbiri impbid con2bid ) AUACZBUACZDZABEZBAFGZUBZABFGZVIVLVMHZVIVJVNVKV
    GVJVNIVHVGVJVNVGVJDAAFGZVMVGVOHVJAUCJVJVOVMKVGABAFRLUDUKJVHVGVKVNIBAUEUFUGV
    GAULCZAMEZANEZUHBULCZBMEZBNEZUHZVNVLIZVHAUIBUIVPWBWCVQVRVPVSWCVTWAVPVSDZVLV
    MWDVMVLHABUJUMUNVPVTDZVMVLWEVMAMFGZVPWFVTAUOJVTVMWFKVPBMAFRLOPVPWADZVLVNWGV
    KVJWGVKNAFGZVPWHWAAUPJWAVKWHKVPBNAFUQLOQSTVQVSWCVTWAVQVSDZVLVNWIVKVJWIVKBMF
    GZVSWJVQBUOLVQVKWJKVSAMBFRJOQSVQVTDZVLVNWKVJVKABMURVCSVQWADZVLVNWLVKVJWAVQV
    KWAVQDVKNMFGZUSBNAMFUTVDUFQSTVRVSWCVTWAVRVSDZVMVLWNVMNBFGZVSWOVRBUPLVRVMWOK
    VSANBFUQJOPVRVTDZVMVLWPVMWMUSANBMFUTVDPVRWADZVLVNWQVJVKABNURVCSTVAVBVEVF $.

  $( Ordering on the extended reals is transitive.  (Contributed by NM,
     15-Oct-2005.) $)
  xrlttr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A < B /\ B < C ) -> A < C ) ) $=
    ( cxr wcel cr cpnf wceq cmnf w3o clt wbr wa wn adantr adantl mtbird pm2.21d
    wb adantlr wi elxr lttr 3expa an32s pnfnlt syl breq1 adantll adantld nltmnf
    rexr breq2 adantrd 3jaodan sylan2b ltpnf mpbird a1d anasss adantrr mnfltpnf
    mnflt breq12 mpbiri 3jaoian 3impb syl3an3b syl3an1b ) ADEZAFEZAGHZAIHZJZBDE
    ZCDEZABKLZBCKLZMZACKLZUAZAUBVPVNVOCFEZCGHZCIHZJZWACUBVNVOWEWAVKVOWEMWAVLVMV
    KVOWEWAVKVOMZWBWAWCWDVKWBVOWAVOVKWBMZBFEZBGHZBIHZJWABUBWGWHWAWIWJVKWHWBWAVK
    WHWBWAABCUCUDUEWGWIMVRVTVQWBWIVRVTUAVKWBWIMZVRVTWKVRGCKLZWBWLNZWIWBVPWMCULC
    UFUGOWIVRWLSWBBGCKUHPQRUIUJWGWJMVQVTVRVKWJVQVTUAWBVKWJMZVQVTWNVQAIKLZVKWONZ
    WJVKVJWPAULAUKUGOWJVQWOSVKBIAKUMPQRTUNUOUPUEWFWCMVTVSVKWCVTVOVKWCMVTAGKLZVK
    WQWCAUQOWCVTWQSVKCGAKUMPURTUSVOWDWAVKVOWDMZVRVTVQWRVRVTWRVRBIKLZVOWSNWDBUKO
    WDVRWSSVOCIBKUMPQRUJZUIUOUTVLVOWAWEVLVOMZVQVTVRXAVQVTXAVQGBKLZVOXBNVLBUFPVL
    VQXBSVOAGBKUHOQRUNVAVMVOWEWAVMVOMWBWAWCWDVMWBWAVOVMWBMZVTVSXCVTICKLZWBXDVMC
    VCPVMVTXDSWBAICKUHOURUSTVMWCWAVOVMWCMZVTVSXEVTIGKLVBAICGKVDVEUSTVOWDWAVMWTU
    IUOUTVFVGVHVI $.

  ${
    $d x y z A $.
    $( 'Less than' is a strict ordering on the extended reals.  (Contributed by
       NM, 15-Oct-2005.) $)
    xrltso $p |- < Or RR* $=
      ( vx vy vz cxr clt cv xrlttri xrlttr isso2i ) ABCDEAFZBFZGJKCFHI $.
  $}

  $( Trichotomy law for 'less than' for extended reals.  (Contributed by NM,
     10-Dec-2007.) $)
  xrlttri2 $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A =/= B <-> ( A < B \/ B < A ) ) ) $=
    ( cxr wcel wa clt wbr wo wceq wn wor xrltso sotrieq mpan bicomd necon1abid
    wb ) ACDBCDEZABFGBAFGHZABRABIZSJZCFKRTUAQLCABFMNOP $.

  $( Trichotomy law for 'less than' for extended reals.  (Contributed by NM,
     9-Feb-2006.) $)
  xrlttri3 $p |- ( ( A e. RR* /\ B e. RR* ) ->
                ( A = B <-> ( -. A < B /\ -. B < A ) ) ) $=
    ( cxr clt wor wcel wa wceq wbr wn wb xrltso sotrieq2 mpan ) CDEACFBCFGABHAB
    DIJBADIJGKLCABDMN $.

  $( 'Less than or equal' expressed in terms of 'less than' or 'equals', for
     extended reals.  (Contributed by NM, 19-Jan-2006.) $)
  xrleloe $p |- ( ( A e. RR* /\ B e. RR* ) ->
               ( A <_ B <-> ( A < B \/ A = B ) ) ) $=
    ( cxr wcel wa cle wbr clt wn wo xrlenlt eqcom orbi1i orcom bitri wb xrlttri
    wceq ancoms con2bid syl5rbbr bitrd ) ACDZBCDZEZABFGBAHGZIZABHGZABRZJZABKUJB
    ARZUHJZUEUGULUIUHJUJUKUIUHBALMUIUHNOUEUFULUDUCUFULIPBAQSTUAUB $.

  $( 'Less than or equal to' implies 'less than' is not 'equals', for extended
     reals.  (Contributed by NM, 9-Feb-2006.) $)
  xrleltne $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
                ( A < B <-> B =/= A ) ) $=
    ( cxr wcel cle wbr clt wne wb wa wceq wn wi xrlttri3 simpl syl6bi adantr wo
    xrleloe biimpa ord impbid necon2abid necom syl6bbr 3impa ) ACDZBCDZABEFZABG
    FZBAHZIUGUHJZUIJZUJABHUKUMUJABUMABKZUJLZULUNUOMUIULUNUOBAGFLZJUOABNUOUPOPQU
    MUJUNULUIUJUNRABSTUAUBUCBAUDUEUF $.

  $( 'Less than' expressed in terms of 'less than or equal to'.  (Contributed
     by Mario Carneiro, 6-Nov-2015.) $)
  xrltlen $p |- ( ( A e. RR* /\ B e. RR* ) ->
               ( A < B <-> ( A <_ B /\ B =/= A ) ) ) $=
    ( cxr wcel wa clt wbr wn wceq cle wne wo xrlttri ioran ancom syl6bb xrlenlt
    bitri wb nesym a1i anbi12d bitr4d ) ACDBCDEZABFGZBAFGZHZABIZHZEZABJGZBAKZEU
    DUEUHUFLHZUJABMUMUIUGEUJUHUFNUIUGORPUDUKUGULUIABQULUISUDBATUAUBUC $.

  ${
    $d x y $.
    $( Alternative definition of 'less than or equal to' in terms of 'less
       than'.  (Contributed by Mario Carneiro, 6-Nov-2015.) $)
    dfle2 $p |- <_ = ( < u. ( _I |` RR* ) ) $=
      ( vx vy cle clt cid cxr cres cun lerel cxp wss wrel ltrelxr wf1o wbr wcel
      wf cv brel wo f1oi f1of fssxp mp2b unssi relxp mp2 wa lerelxr weq xrleloe
      relss resieq orbi2d bitr4d brun syl6bbr pm5.21nii eqbrriv ) ABCDEFGZHZIVA
      FFJZKVBLVALDUTVBMFFUTNFFUTQUTVBKFUAFFUTUBFFUTUCUDUEZFFUFVAVBULUGARZBRZCOZ
      VDFPVEFPUHZVDVEVAOZVDVEFFCUISVDVEFFVAVCSVGVFVDVEDOZVDVEUTOZTZVHVGVFVIABUJ
      ZTVKVDVEUKVGVJVLVIFVDVEUMUNUOVDVEDUTUPUQURUS $.

    $( Alternative definition of 'less than' in terms of 'less than or equal
       to'.  (Contributed by Mario Carneiro, 6-Nov-2015.) $)
    dflt2 $p |- < = ( <_ \ _I ) $=
      ( vx vy clt cle cid cdif ltrel wss wrel difss lerel relss mp2 cv wbr wcel
      cxr wa brel weq ltrelxr cxp lerelxr wn wne xrltlen equcom vex ideq bitr4i
      sstri necon3abii anbi2i syl6bb brdif syl6bbr pm5.21nii eqbrriv ) ABCDEFZG
      USDHDIUSIDEJZKUSDLMANZBNZCOZVAQPVBQPRZVAVBUSOZVAVBQQCUASVAVBQQUSUSDQQUBUT
      UCUKSVDVCVAVBDOZVAVBEOZUDZRZVEVDVCVFVBVAUEZRVIVAVBUFVJVHVFVGVBVABATABTVGB
      AUGVAVBBUHUIUJULUMUNVAVBDEUOUPUQUR $.
  $}

  $( 'Less than' implies 'less than or equal' for extended reals.  (Contributed
     by NM, 19-Jan-2006.) $)
  xrltle $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B -> A <_ B ) ) $=
    ( clt wbr cle cxr wcel wa wceq wo orc xrleloe syl5ibr ) ABCDZABEDAFGBFGHNAB
    IZJNOKABLM $.

  $( 'Less than or equal to' is reflexive for extended reals.  (Contributed by
     NM, 7-Feb-2007.) $)
  xrleid $p |- ( A e. RR* -> A <_ A ) $=
    ( cxr wcel cle wbr wa clt wceq wo eqid olci xrleloe mpbiri anidms ) ABCZAAD
    EZOOFPAAGEZAAHZIRQAJKAALMN $.

  $( Trichotomy law for extended reals.  (Contributed by NM, 7-Feb-2007.) $)
  xrletri $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A <_ B \/ B <_ A ) ) $=
    ( cxr wcel wa cle wbr wn clt wb xrltnle ancoms wi xrltle sylbird orrd ) ACD
    ZBCDZEZABFGZBAFGZSTHZBAIGZUARQUCUBJBAKLRQUCUAMBANLOP $.

  $( Trichotomy law for extended reals.  (Contributed by FL, 2-Aug-2009.) $)
  xrletri3 $p |- ( ( A e. RR* /\ B e. RR* ) ->
                   ( A = B <-> ( A <_ B /\ B <_ A ) ) ) $=
    ( cxr wcel wa wceq clt wbr wn cle xrlttri3 ancom syl6bbr xrlenlt wb anbi12d
    ancoms bitr4d ) ACDZBCDZEZABFZBAGHIZABGHIZEZABJHZBAJHZEUAUBUDUCEUEABKUCUDLM
    UAUFUCUGUDABNTSUGUDOBANQPR $.

  $( Transitive law for ordering on extended reals.  (Contributed by NM,
     19-Jan-2006.) $)
  xrlelttr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A <_ B /\ B < C ) -> A < C ) ) $=
    ( cxr wcel w3a cle wbr clt wceq wo wi wb xrleloe 3adant3 xrlttr exp3a breq1
    biimprd a1i jaod sylbid imp3a ) ADEZBDEZCDEZFZABGHZBCIHZACIHZUGUHABIHZABJZK
    ZUIUJLZUDUEUHUMMUFABNOUGUKUNULUGUKUIUJABCPQULUNLUGULUJUIABCIRSTUAUBUC $.

  $( Transitive law for ordering on extended reals.  (Contributed by NM,
     19-Jan-2006.) $)
  xrltletr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A < B /\ B <_ C ) -> A < C ) ) $=
    ( cxr wcel w3a clt wbr cle wo wi wb xrleloe 3adant1 xrlttr exp3acom23 breq2
    wceq biimpd a1i jaod sylbid com23 imp3a ) ADEZBDEZCDEZFZABGHZBCIHZACGHZUHUJ
    UIUKUHUJBCGHZBCRZJZUIUKKZUFUGUJUNLUEBCMNUHULUOUMUHUIULUKABCOPUMUOKUHUMUIUKB
    CAGQSTUAUBUCUD $.

  $( Transitive law for ordering on extended reals.  (Contributed by NM,
     9-Feb-2006.) $)
  xrletr $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
             ( ( A <_ B /\ B <_ C ) -> A <_ C ) ) $=
    ( cxr wcel w3a cle wbr wa clt wceq wo wb xrleloe 3adant1 adantr xrlelttr wi
    xrltle 3adant2 syld expdimp breq2 biimpcd adantl jaod sylbid expimpd ) ADEZ
    BDEZCDEZFZABGHZBCGHZACGHZULUMIZUNBCJHZBCKZLZUOULUNUSMZUMUJUKUTUIBCNOPUPUQUO
    URULUMUQUOULUMUQIACJHZUOABCQUIUKVAUORUJACSTUAUBUMURUORULURUMUOBCAGUCUDUEUFU
    GUH $.

  ${
    xrlttrd.1 $e |- ( ph -> A e. RR* ) $.
    xrlttrd.2 $e |- ( ph -> B e. RR* ) $.
    xrlttrd.3 $e |- ( ph -> C e. RR* ) $.
    ${
      xrlttrd.4 $e |- ( ph -> A < B ) $.
      xrlttrd.5 $e |- ( ph -> B < C ) $.
      $( Transitive law for ordering on extended reals.  (Contributed by Mario
         Carneiro, 23-Aug-2015.) $)
      xrlttrd $p |- ( ph -> A < C ) $=
        ( clt wbr cxr wcel wa wi xrlttr syl3anc mp2and ) ABCJKZCDJKZBDJKZHIABLM
        CLMDLMSTNUAOEFGBCDPQR $.
    $}

    ${
      xrlelttrd.4 $e |- ( ph -> A <_ B ) $.
      xrlelttrd.5 $e |- ( ph -> B < C ) $.
      $( Transitive law for ordering on extended reals.  (Contributed by Mario
         Carneiro, 23-Aug-2015.) $)
      xrlelttrd $p |- ( ph -> A < C ) $=
        ( cle wbr clt cxr wcel wa wi xrlelttr syl3anc mp2and ) ABCJKZCDLKZBDLKZ
        HIABMNCMNDMNTUAOUBPEFGBCDQRS $.
    $}

    ${
      xrltletrd.4 $e |- ( ph -> A < B ) $.
      xrltletrd.5 $e |- ( ph -> B <_ C ) $.
      $( Transitive law for ordering on extended reals.  (Contributed by Mario
         Carneiro, 23-Aug-2015.) $)
      xrltletrd $p |- ( ph -> A < C ) $=
        ( clt wbr cle cxr wcel wa wi xrltletr syl3anc mp2and ) ABCJKZCDLKZBDJKZ
        HIABMNCMNDMNTUAOUBPEFGBCDQRS $.
    $}

    ${
      xrletrd.4 $e |- ( ph -> A <_ B ) $.
      xrletrd.5 $e |- ( ph -> B <_ C ) $.
      $( Transitive law for ordering on extended reals.  (Contributed by Mario
         Carneiro, 23-Aug-2015.) $)
      xrletrd $p |- ( ph -> A <_ C ) $=
        ( cle wbr cxr wcel wa wi xrletr syl3anc mp2and ) ABCJKZCDJKZBDJKZHIABLM
        CLMDLMSTNUAOEFGBCDPQR $.
    $}
  $}

  $( 'Less than' implies not equal for extended reals.  (Contributed by NM,
     20-Jan-2006.) $)
  xrltne $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) -> B =/= A ) $=
    ( cxr wcel clt wbr w3a wne wo wa orc wor wceq wn wb sotrieq mpan necon2abid
    xrltso syl5ib 3impia necomd ) ACDZBCDZABEFZGABUCUDUEABHZUEUEBAEFZIZUCUDJZUF
    UEUGKUIUHABCELUIABMUHNOSCABEPQRTUAUB $.

  $( An extended real is not less than plus infinity iff they are equal.
     (Contributed by NM, 30-Jan-2006.) $)
  nltpnft $p |- ( A e. RR* -> ( A = +oo <-> -. A < +oo ) ) $=
    ( cxr wcel cpnf wceq clt wbr wn pnfxr xrltnr ax-mp breq1 mtbiri wo pnfge wb
    cle xrleloe mpan2 mpbid ord impbid2 ) ABCZADEZADFGZHUDUEDDFGZDBCZUFHIDJKADD
    FLMUCUEUDUCADQGZUEUDNZAOUCUGUHUIPIADRSTUAUB $.

  $( An extended real is not greater than minus infinity iff they are equal.
     (Contributed by NM, 2-Feb-2006.) $)
  ngtmnft $p |- ( A e. RR* -> ( A = -oo <-> -. -oo < A ) ) $=
    ( cxr wcel cmnf wceq clt wbr wn mnfxr xrltnr ax-mp breq2 mtbiri wo mnfle wb
    cle xrleloe mpan mpbid ord eqcom syl6ib impbid2 ) ABCZADEZDAFGZHZUFUGDDFGZD
    BCZUIHIDJKADDFLMUEUHDAEZUFUEUGUKUEDAQGZUGUKNZAOUJUEULUMPIDARSTUADAUBUCUD $.

  $( An extended real is real iff it is strictly bounded by infinities.
     (Contributed by NM, 2-Feb-2006.) $)
  xrrebnd $p |- ( A e. RR* -> ( A e. RR <-> ( -oo < A /\ A < +oo ) ) ) $=
    ( cxr wcel cr cmnf clt wbr cpnf wa mnflt ltpnf wceq nltpnft ngtmnft orbi12d
    jca wo wn ianor orcom bitr2i syl6bb con2bid w3o elxr biimpi bitri sylib ord
    3orass sylbid impbid2 ) ABCZADCZEAFGZAHFGZIZUNUOUPAJAKPUMUQAHLZAELZQZRUNUMU
    TUQUMUTUPRZUORZQZUQRZUMURVAUSVBAMANOVDVBVAQVCUOUPSVBVATUAUBUCUMUTUNUMUNURUS
    UDZUTUNQZUMVEAUEUFVEUNUTQVFUNURUSUJUNUTTUGUHUIUKUL $.

  $( A way of proving that an extended real is real.  (Contributed by NM,
     9-Mar-2006.) $)
  xrre $p |- ( ( ( A e. RR* /\ B e. RR ) /\ ( -oo < A /\ A <_ B ) ) ->
              A e. RR ) $=
    ( cxr wcel cr wa cmnf clt wbr cle cpnf simprl ltpnf adantl wi rexr xrlelttr
    pnfxr mp3an3 sylan2 mpan2d imp adantrl wb xrrebnd ad2antrr mpbir2and ) ACDZ
    BEDZFZGAHIZABJIZFZFAEDZUKAKHIZUJUKULLUJULUOUKUJULUOUJULBKHIZUOUIUPUHBMNUIUH
    BCDZULUPFUOOZBPUHUQKCDURRABKQSTUAUBUCUHUNUKUOFUDUIUMAUEUFUG $.

  $( An extended real between two others is real.  (Contributed by NM,
     6-Feb-2007.) $)
  xrre2 $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
              ( A < B /\ B < C ) ) -> B e. RR ) $=
    ( cxr wcel w3a clt wbr wa cr cmnf wi cle mnfle adantr mnfxr xrlelttr mp3an1
    cpnf mpand 3adant3 pnfge adantl pnfxr mp3an3 mpan2d 3adant1 anim12d xrrebnd
    xrltletr wb 3ad2ant2 sylibrd imp ) ADEZBDEZCDEZFZABGHZBCGHZIZBJEZURVAKBGHZB
    SGHZIZVBURUSVCUTVDUOUPUSVCLUQUOUPIKAMHZUSVCUOVFUPANOKDEUOUPVFUSIVCLPKABQRTU
    AUPUQUTVDLUOUPUQIUTCSMHZVDUQVGUPCUBUCUPUQSDEUTVGIVDLUDBCSUJUEUFUGUHUPUOVBVE
    UKUQBUIULUMUN $.

  $( A way of proving that an extended real is real.  (Contributed by FL,
     29-May-2014.) $)
  xrre3 $p |- ( ( ( A e. RR* /\ B e. RR ) /\ ( B <_ A /\ A < +oo ) )
      -> A e. RR ) $=
    ( cxr wcel cr wa cle wbr cpnf clt cmnf mnflt adantl wi mnfxr a1i rexr simpl
    xrltletr syl3anc mpand imp adantrr simprr wb xrrebnd ad2antrr mpbir2and ) A
    CDZBEDZFZBAGHZAIJHZFZFAEDZKAJHZUMUKULUPUMUKULUPUKKBJHZULUPUJUQUIBLMUKKCDZBC
    DZUIUQULFUPNURUKOPUJUSUIBQMUIUJRKBASTUAUBUCUKULUMUDUIUOUPUMFUEUJUNAUFUGUH
    $.

  $( A nonnegative extended real is greater than negative infinity.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  ge0gtmnf $p |- ( ( A e. RR* /\ 0 <_ A ) -> -oo < A ) $=
    ( cxr wcel cmnf cc0 clt wbr cle cr 0re mnflt ax-mp wa wi mnfxr 0xr xrltletr
    mp3an12 imp mpanr1 ) ABCZDEFGZEAHGZDAFGZEICUBJEKLUAUBUCMZUDDBCEBCUAUEUDNOPD
    EAQRST $.

  $( A nonnegative extended real is greater than negative infinity.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  ge0nemnf $p |- ( ( A e. RR* /\ 0 <_ A ) -> A =/= -oo ) $=
    ( cxr wcel cc0 cle wbr cmnf clt wne ge0gtmnf wceq ngtmnft adantr necon2abid
    wa wn wb mpbid ) ABCZDAEFZOZGAHFZAGIAJUAUBAGSAGKUBPQTALMNR $.

  $( A nonnegative extended real that is less than a real bound is real.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xrrege0 $p |- ( ( ( A e. RR* /\ B e. RR ) /\ ( 0 <_ A /\ A <_ B ) ) ->
              A e. RR ) $=
    ( cxr wcel cr cc0 cle wbr cmnf clt ge0gtmnf ad2ant2r simprr jca xrre syldan
    wa ) ACDZBEDZQZFAGHZABGHZQZIAJHZUBQAEDTUCQUDUBRUAUDSUBAKLTUAUBMNABOP $.

  $( An extended real is less than or equal to the maximum of it and another.
     (Contributed by NM, 7-Feb-2007.) $)
  xrmax1 $p |- ( ( A e. RR* /\ B e. RR* ) -> A <_ if ( A <_ B , B , A ) ) $=
    ( cxr wcel cle wbr wn xrleid iffalse breq2d syl5ibrcom id breqtrrd pm2.61d2
    cif iftrue adantr ) ACDZAABEFZBAOZEFZBCDRSUARUASGZAAEFAHUBTAAESBAIJKSABTESL
    SBAPMNQ $.

  $( An extended real is less than or equal to the maximum of it and another.
     (Contributed by NM, 7-Feb-2007.) $)
  xrmax2 $p |- ( ( A e. RR* /\ B e. RR* ) -> B <_ if ( A <_ B , B , A ) ) $=
    ( cxr wcel wa cle wbr cif xrleid ad2antlr iftrue adantl breqtrrd wn xrletri
    wceq orcanai iffalse pm2.61dan ) ACDZBCDZEZABFGZBUCBAHZFGUBUCEBBUDFUABBFGTU
    CBIJUCUDBPUBUCBAKLMUBUCNZEBAUDFUBUCBAFGABOQUEUDAPUBUCBARLMS $.

  $( The minimum of two extended reals is less than or equal to one of them.
     (Contributed by NM, 7-Feb-2007.) $)
  xrmin1 $p |- ( ( A e. RR* /\ B e. RR* ) -> if ( A <_ B , A , B ) <_ A ) $=
    ( cxr wcel wa cle wbr wceq iftrue adantl xrleid ad2antrr eqbrtrd wn iffalse
    cif xrletri orcanai pm2.61dan ) ACDZBCDZEZABFGZUCABPZAFGUBUCEUDAAFUCUDAHUBU
    CABIJTAAFGUAUCAKLMUBUCNZEUDBAFUEUDBHUBUCABOJUBUCBAFGABQRMS $.

  $( The minimum of two extended reals is less than or equal to one of them.
     (Contributed by NM, 7-Feb-2007.) $)
  xrmin2 $p |- ( ( A e. RR* /\ B e. RR* ) -> if ( A <_ B , A , B ) <_ B ) $=
    ( cxr wcel cle wbr cif wn xrleid iffalse breq1d syl5ibrcom eqbrtrd pm2.61d2
    iftrue id adantl ) BCDZABEFZABGZBEFZACDRSUARUASHZBBEFBIUBTBBESABJKLSTABESAB
    OSPMNQ $.

  $( The maximum of two extended reals is equal to the first if the first is
     bigger.  (Contributed by Mario Carneiro, 25-Mar-2015.) $)
  xrmaxeq $p |- ( ( A e. RR* /\ B e. RR* /\ B <_ A ) ->
    if ( A <_ B , B , A ) = A ) $=
    ( cxr wcel cle wbr w3a cif wceq wa wb xrletri3 ancoms biimpar anassrs 3impa
    ifeq1da ifid syl6eq ) ACDZBCDZBAEFZGABEFZBAHZUCAAHZATUAUBUDUEITUAJZUBJUCBAA
    UFUBUCBAIZUFUGUBUCJZUATUGUHKBALMNOQPUCARS $.

  $( The minimum of two extended reals is equal to the second if the first is
     bigger.  (Contributed by Mario Carneiro, 25-Mar-2015.) $)
  xrmineq $p |- ( ( A e. RR* /\ B e. RR* /\ B <_ A ) ->
    if ( A <_ B , A , B ) = B ) $=
    ( cxr wcel cle wbr w3a cif ifid wceq wa wb xrletri3 biimpar anassrs ifeq1da
    ancoms 3impa syl5reqr ) ACDZBCDZBAEFZGBABEFZBBHZUCABHZUCBITUAUBUDUEJTUAKZUB
    KUCBABUFUBUCBAJZUFUGUBUCKZUATUGUHLBAMQNOPRS $.

  $( Two ways of saying the maximum of two extended reals is less than a
     third.  (Contributed by NM, 7-Feb-2007.) $)
  xrmaxlt $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
               ( if ( A <_ B , B , A ) < C <-> ( A < C /\ B < C ) ) ) $=
    ( cxr wcel w3a cle wbr cif clt xrmax1 3adant3 ifcl ancoms xrlelttr syld3an2
    wa wi mpand breq1 xrmax2 simp2 simp3 syl3anc jcad ifboth impbid1 ) ADEZBDEZ
    CDEZFZABGHZBAIZCJHZACJHZBCJHZQUKUNUOUPUKAUMGHZUNUOUHUIUQUJABKLUHUMDEZUIUJUQ
    UNQUORUHUIURUJUIUHURULBADMNLZAUMCOPSUKBUMGHZUNUPUHUIUTUJABUALUKUIURUJUTUNQU
    PRUHUIUJUBUSUHUIUJUCBUMCOUDSUEUPUOUNULUPUOUNBABUMCJTAUMCJTUFNUG $.

  $( Two ways of saying an extended real is less than the minimum of two
     others.  (Contributed by NM, 7-Feb-2007.) $)
  xrltmin $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
               ( A < if ( B <_ C , B , C ) <-> ( A < B /\ A < C ) ) ) $=
    ( cxr wcel w3a cle wbr cif clt wa xrmin1 3adant1 wi simp1 ifcl simp2 mpan2d
    xrltletr breq2 syl3anc xrmin2 syld3an2 jcad ifboth impbid1 ) ADEZBDEZCDEZFZ
    ABCGHZBCIZJHZABJHZACJHZKUJUMUNUOUJUMULBGHZUNUHUIUPUGBCLMUJUGULDEZUHUMUPKUNN
    UGUHUIOUHUIUQUGUKBCDPMZUGUHUIQAULBSUARUJUMULCGHZUOUHUIUSUGBCUBMUGUQUHUIUMUS
    KUONURAULCSUCRUDUKUNUOUMBCBULAJTCULAJTUEUF $.

  $( Two ways of saying the maximum of two numbers is less than or equal to a
     third.  (Contributed by Mario Carneiro, 18-Jun-2014.) $)
  xrmaxle $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
                  ( if ( A <_ B , B , A ) <_ C <-> ( A <_ C /\ B <_ C ) ) ) $=
    ( cxr wcel w3a cle wbr cif wa xrmax1 3adant3 wi ifcl ancoms xrletr syld3an2
    mpand xrmax2 breq1 simp2 simp3 syl3anc jcad ifboth impbid1 ) ADEZBDEZCDEZFZ
    ABGHZBAIZCGHZACGHZBCGHZJUJUMUNUOUJAULGHZUMUNUGUHUPUIABKLUGULDEZUHUIUPUMJUNM
    UGUHUQUIUHUGUQUKBADNOLZAULCPQRUJBULGHZUMUOUGUHUSUIABSLUJUHUQUIUSUMJUOMUGUHU
    IUAURUGUHUIUBBULCPUCRUDUOUNUMUKUOUNUMBABULCGTAULCGTUEOUF $.

  $( Two ways of saying a number is less than or equal to the minimum of two
     others.  (Contributed by Mario Carneiro, 18-Jun-2014.) $)
  xrlemin $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
                  ( A <_ if ( B <_ C , B , C ) <-> ( A <_ B /\ A <_ C ) ) ) $=
    ( cxr wcel w3a cle wbr wa xrmin1 3adant1 wi simp1 ifcl simp2 xrletr syl3anc
    cif mpan2d breq2 xrmin2 syld3an2 jcad ifboth impbid1 ) ADEZBDEZCDEZFZABCGHZ
    BCRZGHZABGHZACGHZIUIULUMUNUIULUKBGHZUMUGUHUOUFBCJKUIUFUKDEZUGULUOIUMLUFUGUH
    MUGUHUPUFUJBCDNKZUFUGUHOAUKBPQSUIULUKCGHZUNUGUHURUFBCUAKUFUPUGUHULURIUNLUQA
    UKCPUBSUCUJUMUNULBCBUKAGTCUKAGTUDUE $.

  $( A number is less than or equal to the maximum of it and another.  See also
     ~ max1ALT .  (Contributed by NM, 3-Apr-2005.) $)
  max1 $p |- ( ( A e. RR /\ B e. RR ) -> A <_ if ( A <_ B , B , A ) ) $=
    ( cr wcel cxr cle wbr cif rexr xrmax1 syl2an ) ACDAEDBEDAABFGBAHFGBCDAIBIAB
    JK $.

  $( A number is less than or equal to the maximum of it and another.  This
     version of ~ max1 omits the ` B e. RR ` antecedent.  Although it doesn't
     exploit undefined behavior, it is still considered poor style, and the use
     of ~ max1 is preferred.  (Proof modification is discouraged.)
     (New usage is discouraged.)  (Contributed by NM, 3-Apr-2005.) $)
  max1ALT $p |- ( A e. RR -> A <_ if ( A <_ B , B , A ) ) $=
    ( cr wcel cle wbr cif wn iffalse breq2d syl5ibrcom iftrue breqtrrd pm2.61d2
    leid id ) ACDZABEFZARBAGZEFZQTRHZAAEFAOUASAAERBAIJKRABSERPRBALMN $.

  $( A number is less than or equal to the maximum of it and another.
     (Contributed by NM, 3-Apr-2005.) $)
  max2 $p |- ( ( A e. RR /\ B e. RR ) -> B <_ if ( A <_ B , B , A ) ) $=
    ( cr wcel cxr cle wbr cif rexr xrmax2 syl2an ) ACDAEDBEDBABFGBAHFGBCDAIBIAB
    JK $.

  $( The minimum of two numbers is less than or equal to the first.
     (Contributed by NM, 3-Aug-2007.) $)
  min1 $p |- ( ( A e. RR /\ B e. RR ) -> if ( A <_ B , A , B ) <_ A ) $=
    ( cr wcel cxr cle wbr cif rexr xrmin1 syl2an ) ACDAEDBEDABFGABHAFGBCDAIBIAB
    JK $.

  $( The minimum of two numbers is less than or equal to the second.
     (Contributed by NM, 3-Aug-2007.) $)
  min2 $p |- ( ( A e. RR /\ B e. RR ) -> if ( A <_ B , A , B ) <_ B ) $=
    ( cr wcel cxr cle wbr cif rexr xrmin2 syl2an ) ACDAEDBEDABFGABHBFGBCDAIBIAB
    JK $.

  $( Two ways of saying the maximum of two numbers is less than or equal to a
     third.  (Contributed by NM, 29-Sep-2005.) $)
  maxle $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( if ( A <_ B , B , A ) <_ C <-> ( A <_ C /\ B <_ C ) ) ) $=
    ( cr wcel cxr cle wbr cif wa wb rexr xrmaxle syl3an ) ADEAFEBDEBFECDECFEABG
    HBAICGHACGHBCGHJKALBLCLABCMN $.

  $( Two ways of saying a number is less than or equal to the minimum of two
     others.  (Contributed by NM, 3-Aug-2007.) $)
  lemin $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( A <_ if ( B <_ C , B , C ) <-> ( A <_ B /\ A <_ C ) ) ) $=
    ( cr wcel cxr cle wbr cif wa wb rexr xrlemin syl3an ) ADEAFEBDEBFECDECFEABC
    GHBCIGHABGHACGHJKALBLCLABCMN $.

  $( Two ways of saying the maximum of two numbers is less than a third.
     (Contributed by NM, 3-Aug-2007.) $)
  maxlt $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( if ( A <_ B , B , A ) < C <-> ( A < C /\ B < C ) ) ) $=
    ( cr wcel cxr cle wbr cif clt wa wb rexr xrmaxlt syl3an ) ADEAFEBDEBFECDECF
    EABGHBAICJHACJHBCJHKLAMBMCMABCNO $.

  $( Two ways of saying a number is less than the minimum of two others.
     (Contributed by NM, 1-Sep-2006.) $)
  ltmin $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
               ( A < if ( B <_ C , B , C ) <-> ( A < B /\ A < C ) ) ) $=
    ( cr wcel cxr cle wbr cif clt wa wb rexr xrltmin syl3an ) ADEAFEBDEBFECDECF
    EABCGHBCIJHABJHACJHKLAMBMCMABCNO $.

  $( Decompose a real number into positive and negative parts.  (Contributed by
     Mario Carneiro, 6-Aug-2014.) $)
  max0sub $p |- ( A e. RR ->
    ( if ( 0 <_ A , A , 0 ) - if ( 0 <_ -u A , -u A , 0 ) ) = A ) $=
    ( cr wcel cc0 cle wbr cif cneg cmin co wceq a1i wa iftrue cxr adantr biimpa
    0xr xrmaxeq syl3anc id adantl renegcl rexrd le0neg2 oveq12d cc recn subid1d
    0re eqtrd rexr simpr le0neg1 syl df-neg negnegd syl5eqr lecasei ) ABCZDAEFZ
    ADGZDAHZEFZVCDGZIJZAKDADBCUTUJLUTUAUTVAMZVFADIJAVGVBAVEDIVAVBAKUTVAADNUBVGD
    OCZVCOCVCDEFZVEDKVHVGRLVGVCUTVCBCVAAUCPUDUTVAVIAUEQDVCSTUFVGAUTAUGCZVAAUHZP
    UIUKUTADEFZMZVFDVCIJZAVMVBDVEVCIVMVHAOCZVLVBDKVHVMRLUTVOVLAULPUTVLUMDASTVMV
    DVEVCKUTVLVDAUNQVDVCDNUOUFVMVNVCHAVCUPVMAUTVJVLVKPUQURUKUS $.

  $( An if statement transforms an implication into an inequality of terms.
     (Contributed by Mario Carneiro, 31-Aug-2014.) $)
  ifle $p |- ( ( ( A e. RR /\ B e. RR /\ B <_ A ) /\ ( ph -> ps ) ) ->
    if ( ph , A , B ) <_ if ( ps , A , B ) ) $=
    ( cr wcel cle wbr w3a wi wa cif simpll1 leidd wceq iftrue adantl imp breq2
    id adantll syl 3brtr4d wn iffalse simpll3 simpll2 syl2anc eqbrtrd pm2.61dan
    ifboth ) CEFZDEFZDCGHZIZABJZKZAACDLZBCDLZGHUQAKZCCURUSGUTCULUMUNUPAMNAURCOU
    QACDPQUTBUSCOUPABUOUPABUPTRUABCDPUBUCUQAUDZKZURDUSGVAURDOUQACDUEQVBUNDDGHZD
    USGHZULUMUNUPVAUFVBDULUMUNUPVAUGNBUNVCVDCDCUSDGSDUSDGSUKUHUIUJ $.

  ${
    $d k M $.  $d k N $.
    $( There exists an integer greater than or equal to any two others.
       (Contributed by NM, 28-Aug-2005.) $)
    z2ge $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                E. k e. ZZ ( M <_ k /\ N <_ k ) ) $=
      ( cz wcel wa cle wbr cif cv wrex ifcl ancoms cr zre max1 jca syl2an breq2
      max2 wceq anbi12d rspcev syl2anc ) BDEZCDEZFBCGHZCBIZDEZBUHGHZCUHGHZFZBAJ
      ZGHZCUMGHZFZADKUFUEUIUGCBDLMUEBNEZCNEZULUFBOCOUQURFUJUKBCPBCTQRUPULAUHDUM
      UHUAUNUJUOUKUMUHBGSUMUHCGSUBUCUD $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The rational numbers are dense in ` RR ` : any two real numbers have a
       rational between them.  Exercise 6 of [Apostol] p. 28.  (Contributed by
       NM, 18-Nov-2004.)  (Proof shortened by Mario Carneiro, 13-Jun-2014.) $)
    qbtwnre $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
                  E. x e. QQ ( A < x /\ x < B ) ) $=
      ( vy vz cr wcel clt wbr cv wa cq wrex c1 co cmin wi cz recnd wb cn posdif
      cdiv cc0 resubcl nnrecl sylan ex ancoms sylbid cmul cle caddc wreu adantl
      nnre simplr remulcld peano2rem syl zbtwnre 3syl znq an32 ad2antrl adantrr
      reurex simpll zre ad2antll ltletr syl3anc subdid breq2d resubcld ltdivmul
      1re a1i nngt0 syl112anc ltsub13 3bitr4rd anbi1d ancom syl6bb ltmuldiv2 cc
      3imtr3d wceq ax-1cn npcan sylancl bitr4d biimpd syl5bi breq2 breq1 rspcev
      anim12d anbi12d ee12an exp3a expr rexlimdv mpd rexlimdva syld 3impia ) BF
      GZCFGZBCHIZBAJZHIZXLCHIZKZALMZXIXJKZXKNDJZUCOCBPOZHIZDUAMZXPXQXKUDXSHIZYA
      BCUBXJXIYBYAQXJXIKZYBYAYCXSFGZYBYACBUEXSDUFUGUHUIUJXQXTXPDUAXQXRUAGZKZXRC
      UKOZNPOZEJZULIZYIYHNUMOZHIZKZERMZXTXPQZYFYHFGZYMERUNYNYFYGFGZYPYFXRCYEXRF
      GZXQXRUPZUOXIXJYEUQURZYGUSUTZEYHVAYMERVGVBYFYMYOERXQYEYIRGZYMYOQXQYEUUBKZ
      KZYMXTXPUUDYIXRUCOZLGZYMXTKZBUUEHIZUUECHIZKZXPUUCUUFXQUUBYEUUFYIXRVCUIUOU
      UGYJXTKZYLKUUDUUJYJYLXTVDUUDUUKUUHYLUUIUUDXRBUKOZYHHIZYJKZUULYIHIZUUKUUHU
      UDUULFGZYPYIFGZUUNUUOQUUDXRBYEYRXQUUBYSVEZXIXJUUCVHZURZXQYEYPUUBUUAVFUUBU
      UQXQYEYIVIVJZUULYHYIVKVLUUDUUNXTYJKUUKUUDUUMXTYJUUDNXRXSUKOZHIZNYGUULPOZH
      IZXTUUMUUDUVBUVDNHUUDXRCBUUDXRUURSUUDCXIXJUUCUQZSUUDBUUSSVMVNUUDNFGZYDYRU
      DXRHIZXTUVCTUVGUUDVQVRZUUDCBUVFUUSVOUURYEUVHXQUUBXRVSVEZNXSXRVPVTUUDUUPYQ
      UVGUUMUVETUUTXQYEYQUUBYTVFZUVIUULYGNWAVLWBWCXTYJWDWEUUDXIUUQYRUVHUUOUUHTU
      USUVAUURUVJBYIXRWFVTWHUUDYLUUIUUDYLYIYGHIZUUIUUDYKYGYIHUUDYGWGGNWGGYKYGWI
      UUDYGUVKSWJYGNWKWLVNUUDUUQXJYRUVHUUIUVLTUVAUVFUURUVJYICXRVPVTWMWNWSWOXOUU
      JAUUELXLUUEWIXMUUHXNUUIXLUUEBHWPXLUUECHWQWTWRXAXBXCXDXEXFXGXH $.

    $( The rational numbers are dense in ` RR* ` : any two extended real
       numbers have a rational between them.  (Contributed by NM, 6-Feb-2007.)
       (Proof shortened by Mario Carneiro, 23-Aug-2015.) $)
    qbtwnxr $p |- ( ( A e. RR* /\ B e. RR* /\ A < B )
                   -> E. x e. QQ ( A < x /\ x < B ) ) $=
      ( wcel clt wbr wa cq wrex cr cpnf wceq qbtwnre c1 adantr adantl a1d breq2
      cmnf breq1 cxr cv w3o wi elxr 3expia caddc co simpl peano2re ltp1 syl3anc
      qre syl simplr breqtrrd anim2d reximdva mpd rexr wb nltmnf pm2.21d sylbid
      ltpnf sylan 3jaodan sylan2b pnfnlt cmin peano2rem simpr ltm1 simpll mnflt
      wn eqbrtrd anim1d 1re ax-mp mpbiri cz 1z anbi12d rspcev mpan syl2an 3mix3
      zq sylibr 3jaoian sylanb 3impia ) BUADZCUADZBCEFZBAUBZEFZWQCEFZGZAHIZWNBJ
      DZBKLZBSLZUCZWOWPXAUDZBUEZXBWOXFXCXDWOXBCJDZCKLZCSLZUCZXFCUEZXBXHXFXIXJXB
      XHWPXAABCMUFXBXIGZXAWPXMWRWQBNUGUHZEFZGZAHIZXAXMXBXNJDZBXNEFZXQXBXIUIXBXR
      XIBUJOXBXSXIBUKOABXNMULXMXPWTAHXMWQHDZGZXOWSWRYAWSXOYAWQKCEXTWQKEFZXMXTWQ
      JDZYBWQUMZWQVEUNPXBXIXTUOUPQUQURUSQXBWNXJXFBUTWNXJGZWPBSEFZXAXJWPYFVAWNCS
      BERPYEYFXAWNYFVPXJBVBOVCVDZVFVGVHXCWOGZWPKCEFZXAXCWPYIVAWOBKCETOYHYIXAWOY
      IVPXCCVIPVCVDWOXDXKXFXLXDXHXFXIXJXDXHGZXAWPYJCNVJUHZWQEFZWSGZAHIZXAYJYKJD
      ZXHYKCEFZYNXHYOXDCVKPXDXHVLXHYPXDCVMPAYKCMULYJYMWTAHYJXTGZYLWRWSYQWRYLYQB
      SWQEXDXHXTVNYQYCSWQEFXTYCYJYDPWQVOUNVQQVRURUSQXDXIGXAWPXDBNEFZNCEFZXAXIXD
      YRSNEFZNJDZYTVSNVOVTBSNETWAXIYSNKEFZUUAUUBVSNVEVTCKNERWANHDZYRYSGZXANWBDU
      UCWCNWIVTWTUUDANHWQNLWRYRWSYSWQNBERWQNCETWDWEWFWGQXDWNXJXFXDXEWNXDXBXCWHX
      GWJYGVFVGVHWKWLWM $.
  $}

  ${
    $d x A $.
    $( If a nonnegative real is less than any positive rational, it is zero.
       (Contributed by NM, 6-Feb-2007.) $)
    qsqueeze $p |- ( ( A e. RR /\ 0 <_ A /\ A. x e. QQ ( 0 < x -> A < x ) ) ->
                   A = 0 ) $=
      ( cr wcel cc0 cle wbr cv clt wi cq wral w3a wceq wn wa wrex wb 0re ltnle
      mpan qbtwnre mp3an1 qre ltnsym con2d sylan2 anim2d reximdva syld rexanali
      ex sylbird syl6ib con4d imp 3adant2 letri3 mpan2 rbaibd 3adant3 mpbird )
      BCDZEBFGZEAHZIGZBVEIGZJAKLZMBENZBEFGZVCVHVJVDVCVHVJVCVJVHVCVJOZVFVGOZPZAK
      QZVHOVCVKEBIGZVNECDZVCVOVKRSEBTUAVCVOVFVEBIGZPZAKQZVNVCVOVSVPVCVOVSSAEBUB
      UCULVCVRVMAKVCVEKDZPVQVLVFVTVCVECDZVQVLJVEUDVCWAPVGVQBVEUEUFUGUHUIUJUMVFV
      GAKUKUNUOUPUQVCVDVIVJRVHVCVIVJVDVCVPVIVJVDPRSBEURUSUTVAVB $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Lemma for ~ qextlt and qextle .  (Contributed by Mario Carneiro,
       3-Oct-2014.) $)
    qextltlem $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B ->
      E. x e. QQ ( -. ( x < A <-> x < B ) /\ -. ( x <_ A <-> x <_ B ) ) ) ) $=
      ( cxr wcel wa clt wbr cv cq wrex wb wn cle syl2anc xrltle 2thd nbbn sylib
      wi qbtwnxr 3expia simprl simplll rexrd ad2antlr xrltnle mpbid mtod simprr
      qre simpllr mpd jca ex reximdva syld ) BDEZCDEZFZBCGHZBAIZGHZVBCGHZFZAJKZ
      VBBGHZVDLMZVBBNHZVBCNHZLMZFZAJKURUSVAVFABCUAUBUTVEVLAJUTVBJEZFZVEVLVNVEFZ
      VHVKVOVGMZVDLVHVOVPVDVOVGVIVOVCVIMZVNVCVDUCVOURVBDEZVCVQLURUSVMVEUDZVMVRU
      TVEVMVBVBUKUEUFZBVBUGOUHZVOVRURVGVITVTVSVBBPOUIVNVCVDUJZQVGVDRSVOVQVJLVKV
      OVQVJWAVOVDVJWBVOVRUSVDVJTVTURUSVMVEULVBCPOUMQVIVJRSUNUOUPUQ $.

    $( An extensionality-like property for extended real ordering.
       (Contributed by Mario Carneiro, 3-Oct-2014.) $)
    qextlt $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A = B <->
      A. x e. QQ ( x < A <-> x < B ) ) ) $=
      ( cxr wcel wa wceq cv clt wbr wb cq wral wn wrex cle qextltlem simpl syl6
      reximi breq2 ralrimivw wne wo xrlttri2 wi bicom sylnib ancoms jaod sylbid
      rexnal syl6ib necon4ad impbid2 ) BDEZCDEZFZBCGZAHZBIJZUTCIJZKZALMZUSVCALB
      CUTIUAUBURVDBCURBCUCZVCNZALOZVDNURVEBCIJZCBIJZUDVGBCUEURVHVGVIURVHVFUTBPJ
      ZUTCPJZKNZFZALOVGABCQVMVFALVFVLRTSUQUPVIVGUFUQUPFVIVBVAKZNZVKVJKNZFZALOVG
      ACBQVQVFALVQVNVCVOVPRVBVAUGUHTSUIUJUKVCALULUMUNUO $.

    $( An extensionality-like property for extended real ordering.
       (Contributed by Mario Carneiro, 3-Oct-2014.) $)
    qextle $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A = B <->
      A. x e. QQ ( x <_ A <-> x <_ B ) ) ) $=
      ( cxr wcel wa wceq cv cle wbr wb cq wral wn wrex clt qextltlem simpr syl6
      reximi breq2 ralrimivw wne wo xrlttri2 wi bicom sylnib ancoms jaod sylbid
      rexnal syl6ib necon4ad impbid2 ) BDEZCDEZFZBCGZAHZBIJZUTCIJZKZALMZUSVCALB
      CUTIUAUBURVDBCURBCUCZVCNZALOZVDNURVEBCPJZCBPJZUDVGBCUEURVHVGVIURVHUTBPJZU
      TCPJZKNZVFFZALOVGABCQVMVFALVLVFRTSUQUPVIVGUFUQUPFVIVKVJKNZVBVAKZNZFZALOVG
      ACBQVQVFALVQVOVCVNVPRVBVAUGUHTSUIUJUKVCALULUMUNUO $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Show that ` A ` is less than ` B ` by showing that there is no positive
       bound on the difference.  (Contributed by Mario Carneiro,
       12-Jun-2014.) $)
    xralrple $p |- ( ( A e. RR* /\ B e. RR ) ->
                   ( A <_ B <-> A. x e. RR+ A <_ ( B + x ) ) ) $=
      ( vy cxr wcel cr wa cle wbr caddc co crp adantl mpbid rexrd wn cq syl2anc
      clt cv wral cc0 rpge0 simplr rpre addge01d simpll readdcld xrletr syl3anc
      mpan2d ralrimdva wrex rexr simpl qbtwnxr 3expia cmin simprrl qre ad2antrl
      wi wb difrp simprrr xrltnle recnd pncan3d breq2d mtbird wceq oveq2 notbid
      rspcev rexnal sylib rexlimdvaa syld con2d xrlenlt sylan2 sylibrd impbid )
      BEFZCGFZHZBCIJZBCAUAZKLZIJZAMUBZWGWHWKAMWGWIMFZHZWHCWJIJZWKWNUCWIIJZWOWMW
      PWGWIUDNWNCWIWEWFWMUEZWMWIGFWGWIUFNZUGOWNWECEFZWJEFWHWOHWKVCWEWFWMUHWNCWQ
      PWNWJWNCWIWQWRUIPBCWJUJUKULUMWGWLCBTJZQZWHWGWTWLWGWTCDUAZTJZXBBTJZHZDRUNZ
      WLQZWGWSWEWTXFVCWFWSWECUOZNWEWFUPWSWEWTXFDCBUQURSWGXEXGDRWGXBRFZXEHZHZWKQ
      ZAMUNZXGXKXBCUSLZMFZBCXNKLZIJZQZXMXKXCXOWGXIXCXDUTXKWFXBGFZXCXOVDWEWFXJUE
      ZXIXSWGXEXBVAVBZCXBVESOXKXQBXBIJZXKXDYBQZWGXIXCXDVFXKXBEFWEXDYCVDXKXBYAPW
      EWFXJUHXBBVGSOXKXPXBBIXKCXBXKCXTVHXKXBYAVHVIVJVKXLXRAXNMWIXNVLZWKXQYDWJXP
      BIWIXNCKVMVJVNVOSWKAMVPVQVRVSVTWFWEWSWHXAVDXHBCWAWBWCWD $.

    $( Show that ` A ` is less than ` B ` by showing that there is no positive
       bound on the difference.  (Contributed by Mario Carneiro,
       12-Jun-2014.) $)
    alrple $p |- ( ( A e. RR /\ B e. RR ) ->
                   ( A <_ B <-> A. x e. RR+ A <_ ( B + x ) ) ) $=
      ( cr wcel cxr cle wbr cv caddc co crp wral wb rexr xralrple sylan ) BDEBF
      ECDEBCGHBCAIJKGHALMNBOABCPQ $.
  $}

  $( Equality of two extended numbers with ` -e ` in front of them.
     (Contributed by FL, 26-Dec-2011.)  (Proof shortened by Mario Carneiro,
     20-Aug-2015.) $)
  xnegeq $p |- ( A = B -> -e A = -e B ) $=
    ( wceq cpnf cmnf cneg cif cxne eqeq1 negeq ifbieq2d df-xneg 3eqtr4g ) ABCZA
    DCZEAECZDAFZGZGBDCZEBECZDBFZGZGAHBHNOSRUBEABDINPTQUADABEIABJKKALBLM $.

  $( A negative extended real exists as a set.  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xnegex $p |- -e A e. _V $=
    ( cxne cpnf wceq cmnf cneg cif cvv df-xneg cxr mnfxr elexi pnfxr negex ifex
    eqeltri ) ABACDZEAEDZCAFZGZGHAIQETEJKLRCSCJMLANOOP $.

  $( Minus ` +oo ` .  Remark of [BourbakiTop1] p.  IV.15.  (Contributed by FL,
     26-Dec-2011.) $)
  xnegpnf $p |- -e +oo = -oo $=
    ( cpnf cxne wceq cmnf cneg cif df-xneg eqid iftrue ax-mp eqtri ) ABAACZDADC
    AAEFZFZDAGLNDCAHLDMIJK $.

  $( Minus ` -oo ` .  Remark of [BourbakiTop1] p.  IV.15.  (Contributed by FL,
     26-Dec-2011.)  (Revised by Mario Carneiro, 20-Aug-2015.) $)
  xnegmnf $p |- -e -oo = +oo $=
    ( cmnf cxne cpnf wceq cneg cif df-xneg pnfnemnf necomi ifnefalse ax-mp eqid
    wne iftrue 3eqtri ) ABACDAAADZCAEZFZFZRCAGACMSRDCAHIACARJKPRCDALPCQNKO $.

  $( Minus a real number.  Remark [BourbakiTop1] p.  IV.15.  (Contributed by
     FL, 26-Dec-2011.)  (Proof shortened by Mario Carneiro, 20-Aug-2015.) $)
  rexneg $p |- ( A e. RR -> -e A = -u A ) $=
    ( cr wcel cxne cpnf wceq cmnf cif df-xneg wne renepnf ifnefalse syl renemnf
    cneg eqtrd syl5eq ) ABCZADAEFGAGFEAOZHZHZSAIRUATSRAEJUATFAKAEGTLMRAGJTSFANA
    GESLMPQ $.

  $( The negative of zero.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xneg0 $p |- -e 0 = 0 $=
    ( cc0 cxne cneg cr wcel wceq 0re rexneg ax-mp neg0 eqtri ) ABZACZAADELMFGAH
    IJK $.

  $( Closure of extended real negative.  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xnegcl $p |- ( A e. RR* -> -e A e. RR* ) $=
    ( cxr wcel cr cpnf wceq cmnf w3o cxne elxr cneg rexneg renegcl rexrd xnegeq
    eqeltrd xnegpnf mnfxr eqeltri syl6eqel xnegmnf pnfxr 3jaoi sylbi ) ABCADCZA
    EFZAGFZHAIZBCZAJUEUIUFUGUEUHUEUHAKDALAMPNUFUHEIZBAEOUJGBQRSTUGUHGIZBAGOUKEB
    UAUBSTUCUD $.

  $( Extended real version of ~ negneg .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xnegneg $p |- ( A e. RR* -> -e -e A = A ) $=
    ( cxr wcel cpnf wceq cmnf w3o cxne elxr cneg rexneg renegcl xnegmnf xnegpnf
    cr xnegeq syl syl6eq id 3eqtr4a recn negnegd 3eqtrd 3jaoi sylbi ) ABCAOCZAD
    EZAFEZGAHZHZAEZAIUFUKUGUHUFUJAJZHZULJZAUFUIULEUJUMEAKUIULPQUFULOCUMUNEALULK
    QUFAAUAUBUCUGFHZDUJAMUGUIFEUJUOEUGUIDHZFADPNRUIFPQUGSTUHUPFUJANUHUIDEUJUPEU
    HUIUODAFPMRUIDPQUHSTUDUE $.

  $( Extended real version of ~ neg11 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xneg11 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( -e A = -e B <-> A = B ) ) $=
    ( cxr wcel wa cxne wceq xnegeq xnegneg eqeqan12d syl5ib impbid1 ) ACDZBCDZE
    ZAFZBFZGZABGZRPFZQFZGOSPQHMNTAUABAIBIJKABHL $.

  $( Forward direction of ~ xltneg .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xltnegi $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) -> -e B < -e A ) $=
    ( cxr wcel clt wbr cxne cr cpnf wceq cmnf w3o wa wi elxr cneg syl adantr wn
    sylbid rexneg breqan12rd bitr4d biimpd xnegeq xnegpnf syl6eq adantl renegcl
    ltneg eqeltrd mnflt eqbrtrd a1d simpr breq2d nltmnf pm2.21d 3jaodan sylan2b
    rexr expimpd simpl breq1d pnfnlt breq1 anbi2d ltpnf mnfltpnf syl6eqbr breq2
    mnfxr ax-mp pm2.21i syl6bi imp 3jaoian sylanb xnegmnf syl5ibr 3jaoi 3impib
    sylbi ) ACDZBCDZABEFZBGZAGZEFZWDAHDZAIJZAKJZLWEWFMZWINZAOWJWNWKWLWJWEWFWIWE
    WJBHDZBIJZBKJZLZWFWINZBOZWJWOWSWPWQWJWOMZWFWIXAWFBPZAPZEFWIABUJWOWJWGXBWHXC
    EBUAZAUAZUBUCUDWJWPMZWIWFXFWGKWHEWPWGKJZWJWPWGIGKBIUEUFUGZUHWJKWHEFZWPWJWHH
    DXIWJWHXCHXEAUIUKWHULQRUMUNWJWQMZWFAKEFZWIXJBKAEWJWQUOUPXJXKWIWJXKSZWQWJWDX
    LAVAAUQQRURTUSUTVBWKWEWFWIWKWEMZWFIBEFZWIXMAIBEWKWEVCVDXMXNWIWEXNSWKBVEUHUR
    TVBWLWMWEKBEFZMZWIWLWFXOWEAKBEVFVGXPWIWLWGIEFZWEWRXOXQWTWOXOXQWPWQWOXOMWGHD
    ZXQWOXRXOWOWGXBHXDBUIUKRWGVHQWPXOMWGKIEWPXGXOXHRVIVJWQXOXQWQXOKKEFZXQBKKEVK
    XSXQKCDXSSVLKUQVMVNVOVPVQVRWLWHIWGEWLWHKGIAKUEVSUGUPVTTWAWCWB $.

  $( Extended real version of ~ ltneg .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xltneg $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A < B <-> -e B < -e A ) ) $=
    ( cxr wcel wa clt xltnegi 3expia wi xnegcl syl2anr xnegneg breqan12d sylibd
    wbr cxne impbid ) ACDZBCDZEZABFOZBPZAPZFOZRSUAUDABGHTUDUCPZUBPZFOZUASUBCDZU
    CCDZUDUGIRBJAJUHUIUDUGUBUCGHKRSUEAUFBFALBLMNQ $.

  $( Extended real version of ~ leneg .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xleneg $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A <_ B <-> -e B <_ -e A ) ) $=
    ( cxr wcel wa clt wbr wn cle wb xltneg ancoms notbid xrlenlt xnegcl syl2anr
    cxne 3bitr4d ) ACDZBCDZEZBAFGZHAQZBQZFGZHZABIGUDUCIGZUAUBUETSUBUEJBAKLMABNT
    UDCDUCCDUGUFJSBOAOUDUCNPR $.

  $( Extended real version of ~ lt0neg1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xlt0neg1 $p |- ( A e. RR* -> ( A < 0 <-> 0 < -e A ) ) $=
    ( cxr wcel cc0 clt wbr cxne wb 0xr xltneg mpan2 xneg0 breq1i syl6bb ) ABCZA
    DEFZDGZAGZEFZDREFODBCPSHIADJKQDRELMN $.

  $( Extended real version of ~ lt0neg2 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xlt0neg2 $p |- ( A e. RR* -> ( 0 < A <-> -e A < 0 ) ) $=
    ( cxr wcel cc0 clt wbr cxne wb 0xr xltneg mpan xneg0 breq2i syl6bb ) ABCZDA
    EFZAGZDGZEFZQDEFDBCOPSHIDAJKRDQELMN $.

  $( Extended real version of ~ le0neg1 .  (Contributed by Mario Carneiro,
     9-Sep-2015.) $)
  xle0neg1 $p |- ( A e. RR* -> ( A <_ 0 <-> 0 <_ -e A ) ) $=
    ( cxr wcel cc0 cle wbr cxne wb 0xr xleneg mpan2 xneg0 breq1i syl6bb ) ABCZA
    DEFZDGZAGZEFZDREFODBCPSHIADJKQDRELMN $.

  $( Extended real version of ~ le0neg2 .  (Contributed by Mario Carneiro,
     9-Sep-2015.) $)
  xle0neg2 $p |- ( A e. RR* -> ( 0 <_ A <-> -e A <_ 0 ) ) $=
    ( cxr wcel cc0 cle wbr cxne wb 0xr xleneg mpan xneg0 breq2i syl6bb ) ABCZDA
    EFZAGZDGZEFZQDEFDBCOPSHIDAJKRDQELMN $.

  ${
    $d x y A $.  $d x y B $.
    $( Value of the extended real addition operation.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xaddval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A +e B ) = if ( A = +oo ,
            if ( B = -oo , 0 , +oo ) , if ( A = -oo ,
            if ( B = +oo , 0 , -oo ) , if ( B = +oo , +oo ,
                 if ( B = -oo , -oo , ( A + B ) ) ) ) ) ) $=
      ( vx vy cxr cv cpnf wceq cc0 cif caddc co eqeq1d ifbid ifbieq2d ifbieq12d
      cmnf c0ex elexi ifex cxad wa simpl simpr df-xadd pnfxr mnfxr ovex ovmpt2a
      oveq12 ) CDABEECFZGHZDFZQHZIGJZUKQHZUMGHZIQJZUQGUNQUKUMKLZJZJZJZJAGHZBQHZ
      IGJZAQHZBGHZIQJZVGGVDQABKLZJZJZJZJUAUKAHZUMBHZUBZULVCUOVBVEVLVOUKAGVMVNUC
      ZMVOUNVDIGVOUMBQVMVNUDZMZNVOUPVFURVAVHVKVOUKAQVPMVOUQVGIQVOUMBGVQMZNVOUQV
      GUTVJGVSVOUNVDUSVIQVRUKAUMBKUJOOPPCDUEVCVEVLVDIGRGEUFSZTVFVHVKVGIQRQEUGSZ
      TVGGVJVTVDQVIWAABKUHTTTTUI $.

    $( The extended real addition operation is closed in extended reals.
       (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    xaddf $p |- +e : ( RR* X. RR* ) --> RR* $=
      ( vx vy cv cpnf wceq cmnf cc0 cif cxr wcel wral cxad wa 0xr wn cr anassrs
      a1i wo ifclda caddc co cxp pnfxr keepel mnfxr ioran w3o elxr 3orass bitri
      wf biimpi ord con1d imp sylan2br readdcl syl2an rexrd an32s df-xadd fmpt2
      rgen2a mpbi ) ACZDEZBCZFEZGDHZVFFEZVHDEZGFHZVLDVIFVFVHUAUBZHZHZHZHZIJZBIK
      AIKIIUCILULVSABIVFIJZVHIJZMZVGVJVQIVJIJWBVGMVIGDINUDUERWBVGOZMZVKVMVPIVMI
      JWDVKMVLGFINUFUERWBWCVKOZVPIJZVTWCWEMZWAWFVTWGMZWAMZVLDVOIDIJWIVLMUDRWIVL
      OZMZVIFVNIFIJWKVIMUFRWIWJVIOZVNIJZWHWAWJWLMZWMWHWAWNMZMVNWHVFPJZVHPJZVNPJ
      WOWGVTVGVKSZOZWPVGVKUGVTWSWPVTWPWRVTWPWRVTWPWRSZVTWPVGVKUHWTVFUIWPVGVKUJU
      KUMUNUOUPUQWNWAVLVISZOZWQVLVIUGWAXBWQWAWQXAWAWQXAWAWQXASZWAWQVLVIUHXCVHUI
      WQVLVIUJUKUMUNUOUPUQVFVHURUSUTQQTTVAQTTVDABIIVRILABVBVCVE $.

    $( Value of the extended real multiplication operation.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    xmulval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A *e B ) =
            if ( ( A = 0 \/ B = 0 ) , 0 ,
            if ( ( ( ( 0 < B /\ A = +oo ) \/ ( B < 0 /\ A = -oo ) ) \/
                   ( ( 0 < A /\ B = +oo ) \/ ( A < 0 /\ B = -oo ) ) ) , +oo ,
            if ( ( ( ( 0 < B /\ A = -oo ) \/ ( B < 0 /\ A = +oo ) ) \/
                   ( ( 0 < A /\ B = -oo ) \/ ( A < 0 /\ B = +oo ) ) ) , -oo ,
                 ( A x. B ) ) ) ) ) $=
      ( vx vy cxr cc0 wceq wo clt wbr cpnf cmnf cmul cif eqeq1d orbi12d anbi12d
      wa ifbieq2d ifex cv co cxmu simpl simpr breq2d breq1d oveq12 df-xmul c0ex
      pnfxr elexi mnfxr ovex ovmpt2a ) CDABEECUAZFGZDUAZFGZHZFFURIJZUPKGZRZURFI
      JZUPLGZRZHZFUPIJZURKGZRZUPFIJZURLGZRZHZHZKVAVERZVDVBRZHZVHVLRZVKVIRZHZHZL
      UPURMUBZNZNZNAFGZBFGZHZFFBIJZAKGZRZBFIJZALGZRZHZFAIJZBKGZRZAFIJZBLGZRZHZH
      ZKWIWMRZWLWJRZHZWPWTRZWSWQRZHZHZLABMUBZNZNZNUCUPAGZURBGZRZUTWHWEXMFXPUQWF
      USWGXPUPAFXNXOUDZOXPURBFXNXOUEZOPXPVOXCWDXLKXPVGWOVNXBXPVCWKVFWNXPVAWIVBW
      JXPURBFIXRUFZXPUPAKXQOZQXPVDWLVEWMXPURBFIXRUGZXPUPALXQOZQPXPVJWRVMXAXPVHW
      PVIWQXPUPAFIXQUFZXPURBKXROZQXPVKWSVLWTXPUPAFIXQUGZXPURBLXROZQPPXPWBXJWCXK
      LXPVRXFWAXIXPVPXDVQXEXPVAWIVEWMXSYBQXPVDWLVBWJYAXTQPXPVSXGVTXHXPVHWPVLWTY
      CYFQXPVKWSVIWQYEYDQPPUPAURBMUHSSSCDUIWHFXMUJXCKXLKEUKULXJLXKLEUMULABMUNTT
      TUO $.
  $}

  $( Addition of positive infinity on the right.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xaddpnf1 $p |- ( ( A e. RR* /\ A =/= -oo ) -> ( A +e +oo ) = +oo ) $=
    ( cxr wcel cmnf wne cpnf cxad co cc0 cif caddc pnfxr xaddval mpan2 pnfnemnf
    wceq ifnefalse mp1i eqid syl6eq iftrue ax-mp ifeq12d ifid sylan9eq ) ABCZAD
    EZAFGHZAFPZFDPZIFJZADPFFPZIDJZULFUJDAFKHJZJZJZJZFUFFBCUHUQPLAFMNUGUQUIFFJFU
    GUIUKFUPFFDEUKFPUGOFDIFQRUGUPUOFADUMUOQULUOFPFSULFUNUAUBTUCUIFUDTUE $.

  $( Addition of positive infinity on the left.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xaddpnf2 $p |- ( ( A e. RR* /\ A =/= -oo ) -> ( +oo +e A ) = +oo ) $=
    ( cxr wcel cmnf wne cpnf cxad co wceq cc0 cif caddc pnfxr xaddval mpan eqid
    iftrue ax-mp ifnefalse syl5eq sylan9eq ) ABCZADEZFAGHZFFIZADIZJFKZFDIAFIZJD
    KUHFUFDFALHKKKZKZFFBCUBUDUJIMFANOUCUJUGFUEUJUGIFPUEUGUIQRADJFSTUA $.

  $( Addition of negative infinity on the right.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xaddmnf1 $p |- ( ( A e. RR* /\ A =/= +oo ) -> ( A +e -oo ) = -oo ) $=
    ( cxr wcel cpnf wne cmnf cxad co wceq cc0 cif caddc mnfxr xaddval ifnefalse
    mpan2 pnfnemnf necomi ax-mp eqtri eqid iftrue ifeq12 mp2an syl6eq sylan9eq
    ifid ) ABCZADEZAFGHZADIFFIZJDKZAFIZFDIZJFKZUNDUKFAFLHZKZKZKZKZFUHFBCUJUTIMA
    FNPUIUTUSFADULUSOUSUMFFKZFUOFIZURFIUSVAIFDEZVBDFQRZFDJFOSURUQFVCURUQIVDFDDU
    QOSUKUQFIFUAUKFUPUBSTUMUOFURFUCUDUMFUGTUEUF $.

  $( Addition of negative infinity on the left.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xaddmnf2 $p |- ( ( A e. RR* /\ A =/= +oo ) -> ( -oo +e A ) = -oo ) $=
    ( cxr wcel cpnf wne cmnf cxad co wceq cc0 caddc mnfxr xaddval mpan pnfnemnf
    cif necomi ifnefalse ax-mp eqid iftrue eqtri syl5eq sylan9eq ) ABCZADEZFAGH
    ZFDIAFIZJDPZFFIZADIZJFPZUKDUHFFAKHPPZPZPZFFBCUEUGUOILFAMNUFUOULFUOUNULFDEUO
    UNIDFOQFDUIUNRSUJUNULIFTUJULUMUASUBADJFRUCUD $.

  $( Addition of positive and negative infinity.  This is often taken to be a
     "null" value or out of the domain, but we define it (somewhat arbitrarily)
     to be zero so that the resulting function is total, which simplifies
     proofs.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  pnfaddmnf $p |- ( +oo +e -oo ) = 0 $=
    ( cpnf cmnf cxad wceq cc0 cif caddc cxr wcel pnfxr mnfxr xaddval mp2an eqid
    co iftrue ax-mp 3eqtri ) ABCOZAADZBBDZEAFZABDBADZEBFUCAUABABGOFFFZFZUBEAHIB
    HISUEDJKABLMTUEUBDANTUBUDPQUAUBEDBNUAEAPQR $.

  $( Addition of negative and positive infinity.  This is often taken to be a
     "null" value or out of the domain, but we define it (somewhat arbitrarily)
     to be zero so that the resulting function is total, which simplifies
     proofs.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  mnfaddpnf $p |- ( -oo +e +oo ) = 0 $=
    ( cmnf cpnf cxad wceq cc0 cif caddc wcel mnfxr pnfxr xaddval mp2an pnfnemnf
    co cxr wne ax-mp eqid iftrue eqtri necomi ifnefalse ) ABCNZABDBADZEBFZAADZB
    BDZEAFZUGBUDAABGNFFZFZFZEAOHBOHUCUKDIJABKLUKUJEABPUKUJDBAMUAABUEUJUBQUJUHEU
    FUJUHDARUFUHUISQUGUHEDBRUGEASQTTT $.

  $( The extended real addition operation when both arguments are real.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  rexadd $p |- ( ( A e. RR /\ B e. RR ) -> ( A +e B ) = ( A + B ) ) $=
    ( cr wcel wa cxad cpnf wceq cmnf cc0 cif cxr rexr wne renepnf ifnefalse syl
    co renemnf eqtrd caddc xaddval syl2an sylan9eq ) ACDZBCDZEABFRZAGHBIHZJGKZA
    IHBGHZJIKZUJGUHIABUARZKZKZKZKZULUEALDBLDUGUPHUFAMBMABUBUCUEUFUPUNULUEUPUOUN
    UEAGNUPUOHAOAGUIUOPQUEAINUOUNHASAIUKUNPQTUFUNUMULUFBGNUNUMHBOBGGUMPQUFBINUM
    ULHBSBIIULPQTUDT $.

  $( Extended real subtraction when both arguments are real.  (Contributed by
     Mario Carneiro, 23-Aug-2015.) $)
  rexsub $p |- ( ( A e. RR /\ B e. RR ) -> ( A +e -e B ) = ( A - B ) ) $=
    ( cr wcel wa cxne cxad co cneg caddc cmin wceq rexneg adantl oveq2d renegcl
    rexadd sylan2 cc recn negsub syl2an 3eqtrd ) ACDZBCDZEZABFZGHABIZGHZAUHJHZA
    BKHZUFUGUHAGUEUGUHLUDBMNOUEUDUHCDUIUJLBPAUHQRUDASDBSDUJUKLUEATBTABUAUBUC $.

  $( Closure of extended real addition in the subset ` RR* / { -oo } ` .
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xaddnemnf $p |- ( ( ( A e. RR* /\ A =/= -oo ) /\
                      ( B e. RR* /\ B =/= -oo ) ) -> ( A +e B ) =/= -oo ) $=
    ( cxr wcel cmnf wne wa cr cpnf wceq wo cxad co xrnemnf caddc rexadd readdcl
    pnfnemnf a1i eqnetrd eqeltrd renemnfd oveq2 rexr renemnf xaddpnf1 sylan9eqr
    syl2anc jaodan sylan2b oveq1 xaddpnf2 sylan9eq jaoian sylanb ) ACDZAEFZGAHD
    ZAIJZKBCDBEFGZABLMZEFZANURUTVBUSUTURBHDZBIJZKVBBNURVCVBVDURVCGZVAVEVAABOMHA
    BPABQUAUBURVDGZVAIEVDURVAAILMZIBIALUCURUPUQVGIJAUDAUEAUFUHUGIEFZVFRSTUIUJUS
    UTGZVAIEUSUTVAIBLMIAIBLUKBULUMVHVIRSTUNUO $.

  $( Closure of extended real addition in the subset ` RR* / { +oo } ` .
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xaddnepnf $p |- ( ( ( A e. RR* /\ A =/= +oo ) /\
                      ( B e. RR* /\ B =/= +oo ) ) -> ( A +e B ) =/= +oo ) $=
    ( cxr wcel cpnf wne wa cr cmnf wceq wo cxad co xrnepnf caddc rexadd readdcl
    eqeltrd a1i eqnetrd renepnfd oveq2 rexr renepnf xaddmnf1 sylan9eqr pnfnemnf
    syl2anc necomi jaodan sylan2b oveq1 xaddmnf2 sylan9eq jaoian sylanb ) ACDZA
    EFZGAHDZAIJZKBCDBEFGZABLMZEFZANUSVAVCUTVAUSBHDZBIJZKVCBNUSVDVCVEUSVDGZVBVFV
    BABOMHABPABQRUAUSVEGZVBIEVEUSVBAILMZIBIALUBUSUQURVHIJAUCAUDAUEUHUFIEFZVGEIU
    GUIZSTUJUKUTVAGZVBIEUTVAVBIBLMIAIBLULBUMUNVIVKVJSTUOUP $.

  $( Extended real version of ~ negid .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xnegid $p |- ( A e. RR* -> ( A +e -e A ) = 0 ) $=
    ( cxr wcel cr cpnf wceq cmnf w3o cxne cxad co cc0 elxr cneg caddc rexneg id
    xnegeq syl6eq oveq12d oveq2d renegcl rexadd negidd 3eqtrd xnegpnf pnfaddmnf
    mpdan recn xnegmnf mnfaddpnf 3jaoi sylbi ) ABCADCZAEFZAGFZHAAIZJKZLFZAMUNUS
    UOUPUNURAANZJKZAUTOKZLUNUQUTAJAPUAUNUTDCVAVBFAUBAUTUCUHUNAAUIUDUEUOUREGJKLU
    OAEUQGJUOQUOUQEIGAERUFSTUGSUPURGEJKLUPAGUQEJUPQUPUQGIEAGRUJSTUKSULUM $.

  $( The extended real addition operation is closed in extended reals.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xaddcl $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A +e B ) e. RR* ) $=
    ( cxr cxad xaddf fovcl ) ABCCCDEF $.

  $( The extended real addition operation is commutative.  (Contributed by NM,
     26-Dec-2011.) $)
  xaddcom $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A +e B ) = ( B +e A ) ) $=
    ( cxr wcel cr cpnf wceq cmnf w3o cxad co elxr 3eqtr4d wne syl2anc sylan9eqr
    wa eqtr4d oveq2d oveq1d caddc recn addcom syl2an rexadd ancoms rexr renemnf
    oveq2 xaddpnf1 oveq1 xaddpnf2 renepnf xaddmnf1 xaddmnf2 3jaodan sylan2b cc0
    cc pnfaddmnf mnfaddpnf eqtr4i simpr 3eqtr4a pm2.61dane adantl simpl 3jaoian
    sylanb ) ACDZAEDZAFGZAHGZIBCDZABJKZBAJKZGZALVKVNVQVLVMVNVKBEDZBFGZBHGZIVQBL
    VKVRVQVSVTVKVRQABUAKZBAUAKZVOVPVKAUSDBUSDWAWBGVRAUBBUBABUCUDABUEVRVKVPWBGBA
    UEUFMVKVSQVOFVPVSVKVOAFJKZFBFAJUIVKVJAHNZWCFGAUGZAUHZAUJOPVSVKVPFAJKZFBFAJU
    KVKVJWDWGFGWEWFAULOPRVKVTQVOHVPVTVKVOAHJKZHBHAJUIVKVJAFNZWHHGWEAUMZAUNOPVTV
    KVPHAJKZHBHAJUKVKVJWIWKHGWEWJAUOOPRUPUQVLVNQZFBJKZBFJKZVOVPVNWMWNGZVLVNWOBH
    VNVTQZFHJKZHFJKZWMWNWQURWRUTVAVBWPBHFJVNVTVCZSWPBHFJWSTVDVNBHNQWMFWNBULBUJR
    VEVFWLAFBJVLVNVGZTWLAFBJWTSMVMVNQZHBJKZBHJKZVOVPVNXBXCGZVMVNXDBFVNVSQZWRWQX
    BXCWRURWQVAUTVBXEBFHJVNVSVCZSXEBFHJXFTVDVNBFNQXBHXCBUOBUNRVEVFXAAHBJVMVNVGZ
    TXAAHBJXGSMVHVI $.

  $( Extended real version of ~ addid1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xaddid1 $p |- ( A e. RR* -> ( A +e 0 ) = A ) $=
    ( cxr wcel cr cpnf wceq cmnf w3o cc0 cxad co elxr 0re wne ax-mp mp2an oveq1
    0xr id 3eqtr4a caddc rexadd mpan2 addid1d renemnf xaddpnf2 renepnf xaddmnf2
    recn eqtrd 3jaoi sylbi ) ABCADCZAEFZAGFZHAIJKZAFZALUMUQUNUOUMUPAIUAKZAUMIDC
    ZUPURFMAIUBUCUMAAUIUDUJUNEIJKZEUPAIBCZIGNZUTEFRUSVBMIUEOIUFPAEIJQUNSTUOGIJK
    ZGUPAVAIENZVCGFRUSVDMIUGOIUHPAGIJQUOSTUKUL $.

  $( Extended real version of ~ addid2 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xaddid2 $p |- ( A e. RR* -> ( 0 +e A ) = A ) $=
    ( cxr wcel cc0 cxad co wceq 0xr xaddcom mpan xaddid1 eqtrd ) ABCZDAEFZADEFZ
    ADBCMNOGHDAIJAKL $.

  $( Extended real version of ~ xnegdi .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xnegdi $p |- ( ( A e. RR* /\ B e. RR* ) ->
    -e ( A +e B ) = ( -e A +e -e B ) ) $=
    ( wcel cr cpnf wceq cmnf cxad co cxne syl xnegeq xnegpnf wne syl2anc syl6eq
    wa oveq2d 3eqtr4a cc0 cxr w3o elxr caddc cneg cc recn syl2an readdcl rexneg
    negdi renegcl rexadd 3eqtr4d oveqan12d oveq2 rexr renemnf sylan9eqr eqeltrd
    xaddpnf1 renepnf xaddmnf1 xnegmnf 3jaodan sylan2b xneg0 pnfaddmnf mnfaddpnf
    adantl xaddpnf2 xnegcl adantr xnegneg eqeq1d syl5ib imp xaddmnf2 pm2.61dane
    simpr necon3d simpl oveq1d 3jaoian sylanb ) AUACZADCZAEFZAGFZUBBUACZABHIZJZ
    AJZBJZHIZFZAUCWGWJWPWHWIWJWGBDCZBEFZBGFZUBWPBUCWGWQWPWRWSWGWQQZABUDIZJZAUEZ
    BUEZHIZWLWOWTXAUEZXCXDUDIZXBXEWGAUFCBUFCXFXGFWQAUGBUGABUKUHWTXADCXBXFFABUIX
    AUJKWGXCDCXDDCXEXGFWQAULZBULXCXDUMUHUNWTWKXAFWLXBFABUMWKXALKWGWQWMXCWNXDHAU
    JZBUJUOUNWGWRQZEJZGWLWOMXJWKEFWLXKFWRWGWKAEHIZEBEAHUPWGWFAGNXLEFAUQZAURAVAO
    USWKELKWRWGWOWMGHIZGWRWNGWMHWRWNXKGBELMPZRWGWMDCZXNGFZWGWMXCDXIXHUTZXPWMUAC
    ZWMENXQWMUQZWMVBWMVCOKUSSWGWSQZGJZEWLWOVDYAWKGFWLYBFWSWGWKAGHIZGBGAHUPWGWFA
    ENYCGFXMAVBAVCOUSWKGLKWSWGWOWMEHIZEWSWNEWMHWSWNYBEBGLVDPZRWGXPYDEFZXRXPXSWM
    GNYFXTWMURWMVAOKUSSVEVFWHWJQZEBHIZJZGWNHIZWLWOWJYIYJFZWHWJYKBGWJWSQZTJZTYIY
    JVGYLYHTFYIYMFYLYHEGHIZTYLBGEHWJWSVTRVHPYHTLKYLYJGEHIZTYLWNEGHWSWNEFZWJYEVJ
    RVIPSWJBGNZQZXKGYIYJMYRYHEFYIXKFBVKYHELKYRWNUACZWNENZYJGFWJYSYQBVLZVMWJYQYT
    WJWNEBGYPWNJZGFWJWSYPUUBXKGWNELMPWJUUBBGBVNZVOVPWAVQWNVROSVSVJYGWKYHFWLYIFY
    GAEBHWHWJWBWCWKYHLKYGWMGWNHYGWMXKGWHWMXKFWJAELVMMPWCUNWIWJQZGBHIZJZEWNHIZWL
    WOWJUUFUUGFZWIWJUUHBEWJWRQZYMTUUFUUGVGUUIUUETFUUFYMFUUIUUEYOTUUIBEGHWJWRVTR
    VIPUUETLKUUIUUGYNTUUIWNGEHWRWNGFZWJXOVJRVHPSWJBENZQZYBEUUFUUGVDUULUUEGFUUFY
    BFBVRUUEGLKUULYSWNGNZUUGEFWJYSUUKUUAVMWJUUKUUMWJWNGBEUUJUUBEFWJWRUUJUUBYBEW
    NGLVDPWJUUBBEUUCVOVPWAVQWNVKOSVSVJUUDWKUUEFWLUUFFUUDAGBHWIWJWBWCWKUUELKUUDW
    MEWNHUUDWMYBEWIWMYBFWJAGLVMVDPWCUNWDWE $.

  $( Associativity of extended real addition.  The correct condition here is
     "it is not the case that both ` +oo ` and ` -oo ` appear as one of
     ` A , B , C ` , i.e. ` -. { +oo , -oo } C_ { A , B , C } ` ", but this
     condition is difficult to work with, so we break the theorem into two
     parts: this one, where ` -oo ` is not present in ` A , B , C ` , and
     ~ xaddass2 , where ` +oo ` is not present.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xaddass $p |- ( ( ( A e. RR* /\ A =/= -oo ) /\ ( B e. RR* /\ B =/= -oo ) /\
  ( C e. RR* /\ C =/= -oo ) ) -> ( ( A +e B ) +e C ) = ( A +e ( B +e C ) ) ) $=
    ( cxr wcel cmnf wne wa cr cxad wceq cpnf caddc rexadd 3eqtr4d adantr oveq1d
    co syl2anc sylan9eqr w3a cc recn addass syl3an 3expa readdcl sylan2 anassrs
    sylan adantll oveq2d oveq2 simp1l simp2l xaddcl xaddnemnf xaddpnf1 3ad2ant1
    3adant3 eqtr4d 3ad2ant2 adantlr wo simp3 xrnemnf mpjaodan xaddpnf2 3ad2ant3
    sylib oveq1 simpl2 simpl3 syl simpl2l simpl3l simpr eqtrd simp1 ) ADEZAFGZH
    ZBDEZBFGZHZCDEZCFGZHZUAZAIEZABJRZCJRZABCJRZJRZKZALKZWIWJHZBIEZWOBLKZWIWJWRW
    OWIWJWRHZHCIEZWOCLKZWTXAWOWIWTXAHZABMRZCJRZABCMRZJRZWLWNXCXDCMRZAXFMRZXEXGW
    JWRXAXHXIKZWJAUBEWRBUBEXACUBEXJAUCBUCCUCABCUDUEUFWTXDIEXAXEXHKABUGXDCNUJWJW
    RXAXGXIKZWRXAHWJXFIEXKBCUGAXFNUHUIOXCWKXDCJWTWKXDKXAABNPQXCWMXFAJWRXAWMXFKW
    JBCNUKULOUKWIXBWOWTWIXBHZWLALJRZWNXLWLLXMXBWIWLWKLJRZLCLWKJUMWIWKDEZWKFGZXN
    LKWIVTWCXOVTWAWEWHUNWBWCWDWHUOABUPSWBWEXPWHABUQUTWKURSTWIXMLKZXBWBWEXQWHAUR
    USZPVAXLWMLAJXBWIWMBLJRZLCLBJUMWEWBXSLKWHBURVBTULVAVCWIXAXBVDZWTWIWHXTWBWEW
    HVECVFVJPVGUIWIWSWOWJWIWSHZLCJRZXMWLWNWIYBXMKWSWIYBLXMWHWBYBLKZWECVHZVIZXRV
    APYAWKLCJWSWIWKXMLBLAJUMXRTQYAWMLAJWSWIWMYBLBLCJVKYETULOVCWQWEWRWSVDWBWEWHW
    JVLBVFVJVGWIWPHZYBLWMJRZWLWNYFYBLYGYFWHYCWBWEWHWPVMZYDVNYFWMDEZWMFGZYGLKYFW
    CWFYIWCWDWBWHWPVOWFWGWBWEWPVPBCUPSYFWEWHYJWBWEWHWPVLZYHBCUQSWMVHSVAYFWKLCJY
    FWKLBJRZLYFALBJWIWPVQZQYFWEYLLKYKBVHVNVRQYFALWMJYMQOWIWBWJWPVDWBWEWHVSAVFVJ
    VG $.

  $( Associativity of extended real addition.  See ~ xaddass for notes on the
     hypotheses.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xaddass2 $p |- ( ( ( A e. RR* /\ A =/= +oo ) /\ ( B e. RR* /\ B =/= +oo ) /\
  ( C e. RR* /\ C =/= +oo ) ) -> ( ( A +e B ) +e C ) = ( A +e ( B +e C ) ) ) $=
    ( cxr wcel cpnf wne wa cxad cxne wceq cmnf xnegcl syl xneg11 xnegdi syl2anc
    co wb xaddcl w3a simp1l simp1r sylancl necon3bid mpbird xnegpnf a1i neeqtrd
    pnfxr simp2l simp2r simp3l simp3r xaddass syl222anc oveq1d oveq2d 3eqtr4d
    mpbid ) ADEZAFGZHZBDEZBFGZHZCDEZCFGZHZUAZABIRZCIRZJZABCIRZIRZJZKZVLVOKZVJVK
    JZCJZIRZAJZVNJZIRZVMVPVJWBBJZIRZVTIRZWBWEVTIRZIRZWAWDVJWBDEZWBLGWEDEZWELGVT
    DEZVTLGWGWIKVJVAWJVAVBVFVIUBZAMNVJWBFJZLVJWBWNGVBVAVBVFVIUCVJWBWNAFVJVAFDEZ
    WBWNKAFKSWMUJAFOUDUEUFWNLKVJUGUHZUIVJVDWKVCVDVEVIUKZBMNVJWEWNLVJWEWNGVEVCVD
    VEVIULVJWEWNBFVJVDWOWEWNKBFKSWQUJBFOUDUEUFWPUIVJVGWLVCVFVGVHUMZCMNVJVTWNLVJ
    VTWNGVHVCVFVGVHUNVJVTWNCFVJVGWOVTWNKCFKSWRUJCFOUDUEUFWPUIWBWEVTUOUPVJVSWFVT
    IVJVAVDVSWFKWMWQABPQUQVJWCWHWBIVJVDVGWCWHKWQWRBCPQURUSVJVKDEZVGVMWAKVJVAVDW
    SWMWQABTQZWRVKCPQVJVAVNDEZVPWDKWMVJVDVGXAWQWRBCTQZAVNPQUSVJVLDEZVODEZVQVRSV
    JWSVGXCWTWRVKCTQVJVAXAXDWMXBAVNTQVLVOOQUT $.

  $( Extended real version of ~ pncan .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xpncan $p |- ( ( A e. RR* /\ B e. RR ) -> ( ( A +e B ) +e -e B ) = A ) $=
    ( cxr wcel cr wa cxad co wceq adantl oveq2d cmnf ad2antlr cpnf rexr syl2anc
    wne syl cc0 eqtrd cxne cneg rexneg renegcl renepnf xaddmnf2 oveq1 sylan9eqr
    oveq1d simpr 3eqtr4d simpll renemnf xaddass syl222anc simplr rexadd xaddid1
    caddc recnd negidd ad2antrr pm2.61dane ) ACDZBEDZFZABGHZBUAZGHVGBUBZGHZAVFV
    HVIVGGVEVHVIIVDBUCJKVFVJAIALVFALIZFZLVIGHZLVJAVLVIEDZVMLIZVEVNVDVKBUDZMVNVI
    CDZVINQVOVIOZVIUEVIUFPRVLVGLVIGVKVFVGLBGHZLALBGUGVEVSLIZVDVEBCDZBNQVTBOZBUE
    BUFPJUHUIVFVKUJUKVFALQZFZVJABVIGHZGHZAWDVDWCWABLQZVQVILQZVJWFIVDVEWCULVFWCU
    JVEWAVDWCWBMVEWGVDWCBUMMWDVNVQVEVNVDWCVPMZVRRWDVNWHWIVIUMRABVIUNUOWDWFASGHZ
    AWDWESAGWDWEBVIUSHZSWDVEVNWEWKIVDVEWCUPZWIBVIUQPWDBWDBWLUTVATKVDWJAIVEWCAUR
    VBTTVCT $.

  $( Extended real version of ~ npcan .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xnpcan $p |- ( ( A e. RR* /\ B e. RR ) -> ( ( A +e -e B ) +e B ) = A ) $=
    ( cxr wcel cr wa cxne cxad wceq rexr xnegneg syl adantl oveq2d cneg renegcl
    co rexneg eqeltrd xpncan sylan2 eqtr3d ) ACDZBEDZFZABGZHQZUFGZHQZUGBHQAUEUH
    BUGHUDUHBIZUCUDBCDUJBJBKLMNUDUCUFEDUIAIUDUFBOEBRBPSAUFTUAUB $.

  $( Extended real version of ~ leadd1 ; note that the converse implication is
     not true, unlike the real version (for example ` 0 < 1 ` but
     ` ( 1 +e +oo ) <_ ( 0 +e +oo ) ` ).  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xleadd1a $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ A <_ B ) ->
    ( A +e C ) <_ ( B +e C ) ) $=
    ( cxr wcel cle wbr wa cpnf wceq cmnf cxad co adantr syl2anc ad2antrr simplr
    syl wne adantlr w3a w3o simpl3 elxr sylib simpl1 simpl2 caddc simplrr simpr
    cr simplrl simpllr leadd1dd rexadd 3brtr4d xaddcl pnfge oveq1 rexr xaddpnf2
    renemnf ad2antrl sylan9eqr breqtrrd xrleid mnfle eqbrtrd xrletri3 mpbir2and
    oveq1d breqtrd 3jaodan mpdan anassrs renepnf xaddmnf2 adantl xaddpnf1 sylan
    wb oveq2d eqtrd pm2.61dane xaddmnf1 ) ADEZBDEZCDEZUAZABFGZHZCUKEZCIJZCKJZUB
    ZACLMZBCLMZFGZWKWHWOWFWGWHWJUCZCUDUEWKWLWRWMWNWKWLHZAUKEZAIJZAKJZUBZWRWKXDW
    LWKWFXDWFWGWHWJUFZAUDUENWTXAWRXBXCWKWLXAWRWKWLXAHZHZBUKEZBIJZBKJZUBZWRWKXKX
    FWKWGXKWFWGWHWJUGZBUDUENXGXHWRXIXJXGXHHZACUHMZBCUHMZWPWQFXMABCWKWLXAXHUIZXG
    XHUJZWKWLXAXHULZWIWJXFXHUMUNXMXAWLWPXNJXPXRACUOOXMXHWLWQXOJXQXRBCUOOUPXGXIH
    ZWPIWQFXSWPDEZWPIFGZWKXTXFXIWKWFWHXTXEWSACUQOZPWPURZRXIXGWQICLMZIBICLUSWLYD
    IJZWKXAWLWHCKSYECUTZCVBCVAOVCVDVEWKXJWRXFWKXJHZWPWPWQFYGXTWPWPFGZWKXTXJYBNW
    PVFZRYGABCLYGABJZWJBAFGZWIWJXJQYGBKAFWKXJUJYGWFKAFGWKWFXJXENAVGRVHWKYJWJYKH
    WAZXJWKWFWGYLXEXLABVIOZNVJVKVLZTVMVNVOWKXBWRWLWKXBHZWPWPWQFYOXTYHWKXTXBYBNY
    IRYOABCLYOYJWJYKWIWJXBQYOBIAFWKBIFGZXBWKWGYPXLBURRNWKXBUJVEWKYLXBYMNVJVKVLZ
    TWTXCHZWPKWQFXCWTWPKCLMZKAKCLUSWLYSKJZWKWLWHCISYTYFCVPCVQOVRVDYRWQDEZKWQFGZ
    WKUUAWLXCWKWGWHUUAXLWSBCUQOZPWQVGZRVHVMVNWKWMHZWRBKWKXJWRWMYNTUUEBKSZHZWPIW
    QFUUGXTYAWKXTWMUUFYBPYCRUUGWQBILMZIUUGCIBLWKWMUUFQWBUUEWGUUFUUHIJWKWGWMXLNB
    VSVTWCVEWDWKWNHZWRAIWKXBWRWNYQTUUIAISZHZWPKWQFUUKWPAKLMZKUUKCKALWKWNUUJQWBU
    UIWFUUJUULKJWKWFWNXENAWEVTWCUUKUUAUUBWKUUAWNUUJUUCPUUDRVHWDVMVN $.

  $( Commuted form of ~ xleadd1a .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xleadd2a $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ A <_ B ) ->
    ( C +e A ) <_ ( C +e B ) ) $=
    ( cxr wcel w3a cle wbr wa cxad xleadd1a wceq xaddcom 3adant2 adantr 3adant1
    co 3brtr3d ) ADEZBDEZCDEZFZABGHZIACJQZBCJQZCAJQZCBJQZGABCKUBUDUFLZUCSUAUHTA
    CMNOUBUEUGLZUCTUAUISBCMPOR $.

  $( Weakened version of ~ xleadd1a under which the reverse implication is
     true.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xleadd1 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR ) ->
                  ( A <_ B <-> ( A +e C ) <_ ( B +e C ) ) ) $=
    ( cxr wcel cr w3a cle wbr cxad co rexr xleadd1a syl3an3 xaddcl syl2anc wceq
    wi ex xpncan cxne simp1 3ad2ant3 xnegcl syl syl3anc 3adant2 3adant1 breq12d
    simp2 sylibd impbid ) ADEZBDEZCFEZGZABHIZACJKZBCJKZHIZUOUMUNCDEZUQUTRCLZUMU
    NVAGUQUTABCMSNUPUTURCUAZJKZUSVCJKZHIZUQUPURDEZUSDEZVCDEZUTVFRUPUMVAVGUMUNUO
    UBUOUMVAUNVBUCZACOPUPUNVAVHUMUNUOUJVJBCOPUPVAVIVJCUDUEVGVHVIGUTVFURUSVCMSUF
    UPVDAVEBHUMUOVDAQUNACTUGUNUOVEBQUMBCTUHUIUKUL $.

  $( Extended real version of ~ ltadd1 .  (Contributed by Mario Carneiro,
     23-Aug-2015.) $)
  xltadd1 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR ) ->
                  ( A < B <-> ( A +e C ) < ( B +e C ) ) ) $=
    ( cxr wcel cr w3a cle wbr wn co clt wb xleadd1 3com12 notbid xrltnle xaddcl
    cxad syl2anc 3adant3 simp1 rexr 3ad2ant3 simp2 3bitr4d ) ADEZBDEZCFEZGZBAHI
    ZJZBCSKZACSKZHIZJZABLIZUNUMLIZUJUKUOUHUGUIUKUOMBACNOPUGUHUQULMUIABQUAUJUNDE
    ZUMDEZURUPMUJUGCDEZUSUGUHUIUBUIUGVAUHCUCUDZACRTUJUHVAUTUGUHUIUEVBBCRTUNUMQT
    UF $.

  $( Extended real version of ~ ltadd2 .  (Contributed by Mario Carneiro,
     23-Aug-2015.) $)
  xltadd2 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR ) ->
                  ( A < B <-> ( C +e A ) < ( C +e B ) ) ) $=
    ( cxr wcel cr w3a clt wbr cxad co xltadd1 rexr wceq xaddcom 3adant2 3adant1
    wb breq12d syl3an3 bitrd ) ADEZBDEZCFEZGABHIACJKZBCJKZHIZCAJKZCBJKZHIZABCLU
    DUBUCCDEZUGUJRCMUBUCUKGUEUHUFUIHUBUKUEUHNUCACOPUCUKUFUINUBBCOQSTUA $.

  $( The sum of nonnegative extended reals is nonnegative.  (Contributed by
     Mario Carneiro, 21-Aug-2015.) $)
  xaddge0 $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( 0 <_ A /\ 0 <_ B ) ) ->
                  0 <_ ( A +e B ) ) $=
    ( cxr wcel wa cc0 cle wbr cxad co 0xr a1i simplr xaddcl adantr wceq xaddid2
    simprr syl simpll simprl xleadd1a syl31anc eqbrtrrd xrletrd ) ACDZBCDZEZFAG
    HZFBGHZEZEZFBABIJZFCDZULKLZUFUGUKMZUHUMCDUKABNOUHUIUJRULFBIJZBUMGULUGUQBPUP
    BQSULUNUFUGUIUQUMGHUOUFUGUKTUPUHUIUJUAFABUBUCUDUE $.

  $( Extended real version of ~ le2add .  (Contributed by Mario Carneiro,
     23-Aug-2015.) $)
  xle2add $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) ) ->
     ( ( A <_ C /\ B <_ D ) -> ( A +e B ) <_ ( C +e D ) ) ) $=
    ( cxr wcel wa cle wbr cxad simpll simprl simplr w3a xleadd1a syl3anc xaddcl
    co wi ex simprr xleadd2a adantr syl2anc adantl xrletr syl2and ) AEFZBEFZGZC
    EFZDEFZGZGZACHIZABJRZCBJRZHIZBDHIZUQCDJRZHIZUPUTHIZUNUHUKUIUOURSUHUIUMKUJUK
    ULLZUHUIUMMZUHUKUINUOURACBOTPUNUIULUKUSVASVDUJUKULUAVCUIULUKNUSVABDCUBTPUNU
    PEFZUQEFZUTEFZURVAGVBSUJVEUMABQUCUNUKUIVFVCVDCBQUDUMVGUJCDQUEUPUQUTUFPUG $.

  $( Extended real version of ~ lt2add .  Note that ~ ltleadd , which has
     weaker assumptions, is not true for the extended reals (since
     ` 0 + +oo < 1 + +oo ` fails).  (Contributed by Mario Carneiro,
     23-Aug-2015.) $)
  xlt2add $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) ) ->
     ( ( A < C /\ B < D ) -> ( A +e B ) < ( C +e D ) ) ) $=
    ( cxr wcel wa clt wbr cxad co cpnf wceq cmnf adantr wb mpbid wne necon2abid
    syl w3a cr simp1l elxr sylib simp2r xaddcl 3ad2ant1 syl2anc 3ad2ant2 simp3r
    w3o simp1r simprl xltadd2 syl3anc simp3l simp2l xltadd1 xrlttrd anassrs a1i
    simprr pnfxr cle pnfge xrltletrd nltpnft xaddnepnf mpbird oveq2 mnfxr mnfle
    syl22anc xrlelttrd ngtmnft xaddpnf1 sylan9eqr breqtrrd adantlr a1d necon4bd
    wn imp 3jaodan mpdan oveq1 xaddmnf2 xaddnemnf eqbrtrd 3expia ) AEFZBEFZGZCE
    FZDEFZGZACHIZBDHIZGZABJKZCDJKZHIZWNWQWTUAZAUBFZALMZANMZULZXCXDWLXHWLWMWQWTU
    CZAUDUEXDXEXCXFXGXDXEGZDUBFZDLMZDNMZULZXCXDXNXEXDWPXNWNWOWPWTUFZDUDUEOXJXKX
    CXLXMXDXEXKXCXDXEXKGZGZXAADJKZXBXDXAEFZXPWNWQXSWTABUGUHZOXDXREFZXPXDWLWPYAX
    IXOADUGUIOXDXBEFZXPWQWNYBWTCDUGUJZOXQWSXAXRHIZXDWSXPWNWQWRWSUKZOXQWMWPXEWSY
    DPXDWMXPWLWMWQWTUMZOXDWPXPXOOXDXEXKUNBDAUOUPQXQWRXRXBHIZXDWRXPWNWQWRWSUQZOX
    QWLWOXKWRYGPXDWLXPXIOXDWOXPWNWOWPWTURZOXDXEXKVCACDUSUPQUTVAXDXLXCXEXDXLGXAL
    XBHXDXALHIZXLXDYJXALRZXDWLALRZWMBLRZYKXIXDALHIZYLXDACLXIYILEFXDVDVBZYHXDWOC
    LVEIYICVFTVGXDWLYNYLPXIWLYNALAVHSTQZYFXDBLHIZYMXDBDLYFXOYOYEXDWPDLVEIXODVFT
    VGXDWMYQYMPYFWMYQBLBVHSTQZABVIVNXDXSYJYKPXTXSYJXALXAVHSTVJOXLXDXBCLJKZLDLCJ
    VKXDWOCNRZYSLMYIXDNCHIZYTXDNACNEFXDVLVBZXIYIXDWLNAVEIXIAVMTYHVOXDWOUUAYTPYI
    WOUUACNCVPSTQZCVQUIVRVSVTXDXMXCXEXDXMXCXDXCDNXDDNRZXCWCZXDNDHIZUUDXDNBDUUBY
    FXOXDWMNBVEIYFBVMTYEVOXDWPUUFUUDPXOWPUUFDNDVPSTQZWAWBWDVTWEWFXDXFXCXDXCALXD
    YLUUEYPWAWBWDXDXGGXANXBHXGXDXANBJKZNANBJWGXDWMYMUUHNMYFYRBWHUIVRXDNXBHIZXGX
    DUUIXBNRZXDWOYTWPUUDUUJYIUUCXOUUGCDWIVNXDYBUUIUUJPYCYBUUIXBNXBVPSTVJOWJWEWF
    WK $.

  $( Extended real version of ~ subge0 .  (Contributed by Mario Carneiro,
     24-Aug-2015.) $)
  xsubge0 $p |- ( ( A e. RR* /\ B e. RR* ) ->
      ( 0 <_ ( A +e -e B ) <-> B <_ A ) ) $=
    ( cxr wcel cpnf wceq cmnf cc0 cxne cxad co cle wbr 0xr adantl breq2d syl6eq
    wb wa syl5breqr cr w3o elxr rexr xnegcl xaddcl sylan2 simpr xleadd1 syl3anc
    a1i xaddid2 syl xnpcan breq12d bitrd pnfxr xrletri3 mpan2 wne clt 0re mnflt
    wn ax-mp mnfxr xrltnle mp2an mpbi xaddmnf1 ex necon4ad 0le0 oveq1 pnfaddmnf
    mtbiri impbid1 pnfge biantrurd 3bitr4d adantr xnegeq oveq2d breq1 mnfaddpnf
    xnegpnf xaddpnf1 pm2.61dane mnfle 2thd xnegmnf 3jaodan sylan2b ) BCDZACDZBU
    ADZBEFZBGFZUBHABIZJKZLMZBALMZRZBUCWOWPXCWQWRWOWPSZXAHBJKZWTBJKZLMZXBXDHCDZW
    TCDZWPXAXGRXHXDNUKWPWOWNXIBUDZWNWOWSCDXIBUEAWSUFUGUGWOWPUHHWTBUIUJXDXEBXFAL
    XDWNXEBFWPWNWOXJOBULUMABUNUOUPWOWQSZHAGJKZLMZEALMZXAXBWOXMXNRWQWOAEFZAELMZX
    NSZXMXNWOECDXOXQRUQAEURUSWOXMXOWOXMAEWOAEUTZXMVDWOXRSZXMHGLMZGHVAMZXTVDZHUA
    DYAVBHVCVEGCDXHYAYBRVFNGHVGVHVIXSXLGHLAVJPVPVKVLXOHHXLLVMXOXLEGJKHAEGJVNVOQ
    TVQWOXPXNAVRVSVTWAXKWTXLHLXKWSGAJWQWSGFWOWQWSEIGBEWBWFQOWCPWQXBXNRWOBEALWDO
    VTWOWRSZHAEJKZLMZGALMZXAXBWOYEYFRWRWOYEYFWOYEAGWOAGFZSHHYDLVMYGYDHFWOYGYDGE
    JKHAGEJVNWEQOTWOAGUTSHEYDLXHHELMNHVRVEAWGTWHAWIWJWAYCWTYDHLYCWSEAJWRWSEFWOW
    RWSGIEBGWBWKQOWCPWRXBYFRWOBGALWDOVTWLWM $.

  $( Extended real version of ~ posdif .  (Contributed by Mario Carneiro,
     24-Aug-2015.) $)
  xposdif $p |- ( ( A e. RR* /\ B e. RR* ) ->
      ( A < B <-> 0 < ( B +e -e A ) ) ) $=
    ( cxr wcel wa cxne cxad co cc0 clt wbr wb xnegcl xaddcl sylan2 xlt0neg1 cle
    wn xrltnle wceq syl xsubge0 notbid 0xr sylancl 3bitr4d xnegdi oveq2d adantl
    xnegneg xaddcom sylan 3eqtrd breq2d 3bitr3d ) ACDZBCDZEZABFZGHZIJKZIUTFZJKZ
    ABJKZIBAFZGHZJKURUTCDZVAVCLUQUPUSCDZVGBMZAUSNOZUTPUAURIUTQKZRZBAQKZRVAVDURV
    KVMABUBUCURVGICDVAVLLVJUDUTISUEABSUFURVBVFIJURVBVEUSFZGHZVEBGHZVFUQUPVHVBVO
    TVIAUSUGOUQVOVPTUPUQVNBVEGBUJUHUIUPVECDUQVPVFTAMVEBUKULUMUNUO $.

  $( Under certain conditions, the conclusion of ~ lesubadd is true even in the
     extended reals.  (Contributed by Mario Carneiro, 4-Sep-2015.) $)
  xlesubadd $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
                      ( 0 <_ A /\ B =/= -oo /\ 0 <_ C ) ) ->
                    ( ( A +e -e B ) <_ C <-> A <_ ( C +e B ) ) ) $=
    ( cxr wcel cc0 cle wbr cmnf wne wa cxad co cpnf wceq syl syl2anc syl5ibrcom
    wb breq1d w3a cxne simpl1 simpl2 xnegcl xaddcl adantr simpll3 simpr xleadd1
    cr syl3anc xnpcan sylan bitrd simpr3 oveq1 pnfaddmnf syl6eq xaddmnf1 simpl3
    wi mnfle breq1 syld pm2.61dne pnfge ge0nemnf xaddpnf1 breqtrrd 2thd xnegpnf
    ex xnegeq oveq2d oveq2 breq2d bibi12d imp simpr2 jca xrnemnf sylib mpjaodan
    wo ) ADEZBDEZCDEZUAZFAGHZBIJZFCGHZUAZKZBUKEZABUBZLMZCGHZACBLMZGHZSZBNOZWNWO
    KZWRWQBLMZWSGHZWTXCWQDEZWHWOWRXESWNXFWOWNWFWPDEZXFWFWGWHWMUCZWNWGXGWFWGWHWM
    UDZBUEPAWPUFQUGWFWGWHWMWOUHWNWOUIWQCBUJULXCXDAWSGWNWFWOXDAOXHABUMUNTUOWNXBX
    AWNXAXBAILMZCGHZACNLMZGHZSWNXKXMWNXKANWNXKANOZWLWIWJWKWLUPZXNXJFCGXNXJNILMF
    ANILUQURUSTRWNANJZXJIOZXKWNWFXPXQVBXHWFXPXQAUTVMPWNXKXQICGHZWNWHXRWFWGWHWMV
    AZCVCPXJICGVDRVEVFWNANXLGWNWFANGHXHAVGPWNWHCIJZXLNOXSWNWHWLXTXSXOCVHQCVIQVJ
    VKXBWRXKWTXMXBWQXJCGXBWPIALXBWPNUBIBNVNVLUSVOTXBWSXLAGBNCLVPVQVRRVSWNWGWKKW
    OXBWEWNWGWKXIWIWJWKWLVTWABWBWCWD $.

  $( Lemma for ~ rexmul .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xmullem $p |- ( ( ( ( ( A e. RR* /\ B e. RR* ) /\ -. ( A = 0 \/ B = 0 ) )
   /\ -. ( ( ( 0 < B /\ A = +oo ) \/ ( B < 0 /\ A = -oo ) ) \/
           ( ( 0 < A /\ B = +oo ) \/ ( A < 0 /\ B = -oo ) ) ) )
   /\ -. ( ( ( 0 < B /\ A = -oo ) \/ ( B < 0 /\ A = +oo ) ) \/
           ( ( 0 < A /\ B = -oo ) \/ ( A < 0 /\ B = +oo ) ) ) ) -> A e. RR ) $=
    ( cxr wcel wa cc0 wceq wo clt wbr cpnf cmnf ioran anbi12i bitri w3o pm2.21d
    wn adantl expdimp cr anbi2i simplll elxr sylib idd wi simpllr 0xr wor solin
    xrltso mpan sylancl simprlr simplrr imp 3jaodan mpdan simprll 3jaod syl2anb
    mpd anassrs ) ACDZBCDZEZAFGZBFGZHRZEZFBIJZAKGZEZBFIJZALGZEZHZFAIJZBKGZEZAFI
    JZBLGZEZHZHRZVLVPEZVOVMEZHZVSWCEZWBVTEZHZHRZAUADZVKVGVHRZVIRZEZEZVNRZVQRZEZ
    WARWDREZEZWGRZWHRZEZWJRWKREZEZEZWNWFWMEVJWQVGVHVIMUBWFXCWMXHWFVRRZWERZEXCVR
    WEMXJXAXKXBVNVQMWAWDMNOWMWIRZWLRZEXHWIWLMXLXFXMXGWGWHMWJWKMNONWRXIEZWNVMVPP
    ZWNXNVEXOVEVFWQXIUCAUDUEXNWNWNVMVPXNWNUFXNVOVIVLPZVMWNUGZXNVFFCDZXPVEVFWQXI
    UHUICIUJVFXREXPULCBFIUKUMUNZXNVOXQVIVLXNVOVMWNXNWHWNXIXEWRXCXDXEXGUOSQTXNVI
    XQXNVIXQVGWOWPXIUPZQUQXNVLVMWNXNVNWNXIWSWRWSWTXBXHUCSQTURUSXNXPVPWNUGZXSXNV
    OYAVIVLXNVOVPWNXNVQWNXIWTWRWSWTXBXHUHSQTXNVIYAXNVIYAXTQUQXNVLVPWNXNWGWNXIXD
    WRXCXDXEXGUTSQTURUSVAVCVBVD $.

  $( Lemma for ~ xmulneg1 .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xmullem2 $p |- ( ( A e. RR* /\ B e. RR* ) ->
       ( ( ( ( 0 < B /\ A = +oo ) \/ ( B < 0 /\ A = -oo ) ) \/
           ( ( 0 < A /\ B = +oo ) \/ ( A < 0 /\ B = -oo ) ) ) ->
      -. ( ( ( 0 < B /\ A = -oo ) \/ ( B < 0 /\ A = +oo ) ) \/
           ( ( 0 < A /\ B = -oo ) \/ ( A < 0 /\ B = +oo ) ) ) ) ) $=
    ( wa cc0 clt wbr cpnf wceq wo cmnf wn wi con2i adantl 0xr mtbiri adantr a1i
    jaod syl6ibr cxr wcel wne necomi eqeq1 necon3bbid mpbiri nltmnf ax-mp breq2
    pnfnemnf jaoi simpr xrltnsym sylancl adantrd ianor orcom bitri con2d pnfnlt
    orim12d breq1d adantld breq1 jcad ioran simpl or4 3imtr4g ) AUAUBZBUAUBZCZD
    BEFZAGHZCZDAEFZBGHZCZIZBDEFZAJHZCZADEFZBJHZCZIZIZVNWBCZWAVOCZIZKZVQWECZWDVR
    CZIZKZCVPWCIVSWFIIWKWOIKVMWHWLWPVMWHWIKZWJKZCWLVMWHWQWRVMWHWBKZVNKZIZWQVMVT
    WSWGWTVTWSLVMVPWSVSVOWSVNWBVOWBVOKZJGUCGJUKUDWBVOJGAJGUEUFUGZMNVQWSVRWBVQWB
    VQDJEFZDUAUBZXDKODUHUIZAJDEUJPZMQULRVMWCWTWFVMWAWTWBVMVLXEWAWTLVKVLUMOBDUNU
    OZUPWFWTLVMWEWTWDWEVNXDXFBJDEUJPZNRSVBWQWTWSIXAVNWBUQWTWSURUSTVMWHWAKZXBIWR
    VMVTXJWGXBVMVPXJVSVMVNXJVOVMWAVNXHUTUPVSXJLVMVSWAGDEFZXEXKKODVAUIZVSBGDEVQV
    RUMVCPRSVMWCXBWFVMWBXBWAWBXBLVMXCRVDWFXBLVMWDXBWEVOWDVOWDXKXLAGDEVEPZMQRSVB
    WAVOUQTVFWIWJVGTVMWHWMKZWNKZCWPVMWHXNXOVMWHWEKZVQKZIZXNVMVTXPWGXQVMVPXPVSVP
    XPLVMVNXPVOWEVNXIMQRVSXPLVMVRXPVQVRXPGJUCUKVRWEGJBGJUEUFUGZNRSVMWCXQWFWCXQL
    VMWBXQWAXGNRVMWDXQWEVMVKXEWDXQLVKVLVHOADUNUOZUPSVBXNXQXPIXRVQWEUQXQXPURUSTV
    MWHWDKZVRKZIXOVMVTYAWGYBVMVPYAVSVPYALVMVOYAVNXMNRVMVQYAVRVMWDVQXTUTUPSWGYBL
    VMWCYBWFWAYBWBVRWAVRWAXKXLBGDEVEPMQWEYBWDVRWEXSMNULRVBWDVRUQTVFWMWNVGTVFVPW
    CVSWFVIWKWOVGVJ $.

  $( Extended real multiplication is commutative.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xmulcom $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A *e B ) = ( B *e A ) ) $=
    ( wcel wa cc0 wceq wo clt wbr cpnf cmnf co wn orcom notbii ifeq2da wb ifbid
    cif a1i cmul cxmu xmullem recnd ancom anbi12i syl2anb mulcomd eqtrd xmulval
    cxr cr ancoms 3eqtr4d ) AUKCZBUKCZDZAEFZBEFZGZEEBHIZAJFZDBEHIZAKFZDGZEAHIZB
    JFZDAEHIZBKFZDGZGZJVAVDDVCVBDGZVFVIDVHVGDGZGZKABUALZSZSZSZUSURGZEVJVEGZJVMV
    LGZKBAUALZSZSZSZABUBLBAUBLZUQVRUTEWDSWEUQUTVQWDEUQUTMZDZVQVKJWCSWDWHVKVPWCJ
    WHVKMZDZVPVNKWBSWCWJVNVOWBKWJVNMZDZABWLAABUCUDWLBWJUPUODZVSMZDZVTMZDWAMBULC
    WKWHWOWIWPUQWMWGWNUOUPUEUTVSURUSNZOUFVKVTVEVJNZOUFVNWAVLVMNZOBAUCUGUDUHPWJV
    NWAKWBVNWAQWJWSTRUIPWHVKVTJWCVKVTQWHWRTRUIPUQUTVSEWDUTVSQUQWQTRUIABUJUPUOWF
    WEFBAUJUMUN $.

  $( Extended real version of ~ mul01 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmul01 $p |- ( A e. RR* -> ( A *e 0 ) = 0 ) $=
    ( cxr wcel cc0 cxmu co wceq wo clt wbr cpnf cmnf cmul cif 0xr xmulval mpan2
    wa eqid olci iftrue ax-mp syl6eq ) ABCZADEFZADGZDDGZHZDDDIJZAKGRZUIALGRZHDA
    IJZDKGZRADIJZDLGZRHHKUKUJHULUORUNUMRHHLADMFNNZNZDUDDBCUEUQGOADPQUHUQDGUGUFD
    STUHDUPUAUBUC $.

  $( Extended real version of ~ mul02 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmul02 $p |- ( A e. RR* -> ( 0 *e A ) = 0 ) $=
    ( cxr wcel cc0 cxmu co wceq 0xr xmulcom mpan xmul01 eqtrd ) ABCZDAEFZADEFZD
    DBCMNOGHDAIJAKL $.

  $( Extended real version of ~ mulneg1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulneg1 $p |- ( ( A e. RR* /\ B e. RR* ) ->
      ( -e A *e B ) = -e ( A *e B ) ) $=
    ( cxr wcel wa cxne cc0 wceq wo clt wbr cpnf co cif wb wn orbi12d syl xnegeq
    cmnf cmul xneg0 eqeq2i 0xr xneg11 mpan2 syl5bbr adantr orbi1d ifbid xnegpnf
    simpll pnfxr sylancl anbi2d xnegmnf mnfxr xlt0neg1 ad2antrr bicomd xlt0neg2
    cxmu anbi1d orcom syl6bb biimpar iftrue xmullem2 notbid sylibrd imp iffalse
    wi adantl syl6eq 3eqtr4d con2d eqtrd adantlr ad2antlr cneg xmullem recnd cr
    eqtr4d ancom notbii anbi12i syl2anb mulneg1d rexneg oveq1d remulcld ifeq2da
    pm2.61dan ifsb syl6eqr xnegcl xmulval sylan ) ACDZBCDZEZAFZGHZBGHZIZGGBJKZX
    DLHZEZBGJKZXDTHZEZIZGXDJKZBLHZEZXDGJKZBTHZEZIZIZLXHXLEZXKXIEZIZXOXSEZXRXPEZ
    IZIZTXDBUAMZNZNZNZAGHZXFIZGXHALHZEZXKATHZEZIZGAJKZXPEZAGJKZXSEZIZIZLXHYREZX
    KYPEZIZUUAXSEZUUCXPEZIZIZTABUAMZNZNZNZFZXDBVBMZABVBMZFZXCYMYOGUUPFZNZUURXCY
    MYOGYLNUVCXCXGYOGYLXCXEYNXFXAXEYNOXBXEXDGFZHZXAYNUVDGXDUBUCXAGCDUVEYNOUDAGU
    EUFUGUHUIUJXCYOYLUVBGXCYOPZEZUUFYLUVBHZUVGUUFEZYKTYLUVBUVIYIYKTHUVGYIUUFUVG
    YEYTYHUUEUVGYCYQYDYSUVGXLYPXHXLXDLFZHZUVGYPUVJTXDUKUCUVGXALCDUVKYPOXAXBUVFU
    LZUMALUEUNUGZUOUVGXIYRXKXIXDTFZHZUVGYRUVNLXDUPUCUVGXATCDUVOYROUVLUQATUEUNUG
    ZUOQUVGYHUUDUUBIUUEUVGYFUUDYGUUBUVGXOUUCXSUVGUUCXOXAUUCXOOXBUVFAURUSUTZVCUV
    GXRUUAXPUVGUUAXRXAUUAXROXBUVFAVAUSUTZVCQUUDUUBVDVEQZVFYITYJVGRUVIYBPZYLYKHZ
    UVGUUFUVTUVGUUFUUMPZUVTXCUUFUWBVMUVFABVHUHZUVGYBUUMUVGXNUUIYAUULUVGXJUUGXMU
    UHUVGXIYRXHUVPUOUVGXLYPXKUVMUOQUVGYAUUKUUJIUULUVGXQUUKXTUUJUVGXOUUCXPUVQVCU
    VGXRUUAXSUVRVCQUUKUUJVDVEQZVIZVJVKYBLYKVLZRUVIUVBUVJTUVIUUPLHZUVBUVJHUUFUWG
    UVGUUFLUUOVGVNUUPLSRUKVOVPUVGUUFPZEZUUMUVHUVGUUMUVHUWHUVGUUMEZYLLUVBUWJYBYL
    LHUVGYBUUMUWDVFYBLYKVGRUWJUVBUVNLUWJUUPTHUVBUVNHUWJUUPUUOTUWJUWHUUPUUOHZUVG
    UUMUWHUVGUUFUUMUWCVQVKUUFLUUOVLZRUUMUUOTHUVGUUMTUUNVGVNVRUUPTSRUPVOWEVSUWIU
    WBEZYKYJYLUVBUWMYIPZYKYJHUWIUWNUWBUVGUWNUWHUVGYIUUFUVSVIVFUHYITYJVLRUWMUVTU
    WAUVGUWBUVTUWHUVGUVTUWBUWEVFVSUWFRUWMUVBUUNFZYJUWMUUPUUNHUVBUWOHUWMUUPUUOUU
    NUWHUWKUVGUWBUWLVTUWBUUOUUNHUWIUUMTUUNVLVNVRUUPUUNSRUWMAWAZBUAMUUNWAZYJUWOU
    WMABUWMAABWBZWCUWMBUWIXBXAEZXFYNIZPZEZUUEYTIZPZEUULUUIIZPBWDDUWBUVGUXBUWHUX
    DXCUWSUVFUXAXAXBWFYOUWTYNXFVDWGWHUUFUXCYTUUEVDWGWHUUMUXEUUIUULVDWGBAWBWIZWC
    WJUWMXDUWPBUAUWMAWDDXDUWPHUWRAWKRWLUWMUUNWDDUWOUWQHUWMABUWRUXFWMUUNWKRVPWEV
    PWOWOWNVRYOGUUPUURGUVBUUQGHUURUVDGUUQGSUBVOUUQUUPSWPWQXAXDCDXBUUSYMHAWRXDBW
    SWTXCUUTUUQHUVAUURHABWSUUTUUQSRVP $.

  $( Extended real version of ~ mulneg2 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulneg2 $p |- ( ( A e. RR* /\ B e. RR* ) ->
      ( A *e -e B ) = -e ( A *e B ) ) $=
    ( cxr wcel wa cxne cxmu co xmulneg1 ancoms xnegcl xmulcom sylan2 xnegeq syl
    wceq 3eqtr4d ) ACDZBCDZEZBFZAGHZBAGHZFZAUAGHZABGHZFZSRUBUDPBAIJSRUACDUEUBPB
    KAUALMTUFUCPUGUDPABLUFUCNOQ $.

  $( The extended real multiplication when both arguments are real.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  rexmul $p |- ( ( A e. RR /\ B e. RR ) -> ( A *e B ) = ( A x. B ) ) $=
    ( wcel wa cc0 wceq wo clt wbr cpnf cmnf cmul cif wne adantr necon2bi adantl
    co wn jaoi cxmu renepnf renemnf con2i iffalse syl eqtrd ifeq2d rexr xmulval
    cxr syl2an ifid oveq1 mul02lem2 sylan9eqr oveq2 recn mul01d ifeq1da syl5eqr
    cr jaodan 3eqtr4d ) AVBCZBVBCZDZAEFZBEFZGZEEBHIZAJFZDZBEHIZAKFZDZGZEAHIZBJF
    ZDZAEHIZBKFZDZGZGZJVKVODZVNVLDZGZVRWBDZWAVSDZGZGZKABLRZMZMZMZVJEWMMZABUARZW
    MVGVJWOWMEVGWOWNWMVGWESWOWNFWEVGVQVGSZWDVMWSVPVLWSVKVGAJVEAJNVFAUBOPZQVOWSV
    NVGAKVEAKNVFAUCOPZQTVTWSWCVSWSVRVGBJVFBJNVEBUBQPZQWBWSWAVGBKVFBKNVEBUCQPZQT
    TUDWEJWNUEUFVGWLSWNWMFWLVGWHWSWKWFWSWGVOWSVKXAQVLWSVNWTQTWIWSWJWBWSVRXCQVSW
    SWAXBQTTUDWLKWMUEUFUGUHVEAUKCBUKCWRWPFVFAUIBUIABUJULVGWMVJWMWMMWQVJWMUMVGVJ
    WMEWMVGVHWMEFVIVHVGWMEBLRZEAEBLUNVFXDEFVEBUOQUPVIVGWMAELRZEBEALUQVEXEEFVFVE
    AAURUSOUPVCUTVAVD $.

  ${
    $d x y $.
    $( The extended real multiplication operation is closed in extended reals.
       (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    xmulf $p |- *e : ( RR* X. RR* ) --> RR* $=
      ( vx vy cv cc0 wceq wo clt wbr cpnf wa cmnf cif cxr wcel a1i orcom notbii
      wral wn ifclda cmul co cxp cxmu wf pnfxr mnfxr xmullem cr anbi12i syl2anb
      0xr ancom remulcld rexrd rgen2a df-xmul fmpt2 mpbi ) ACZDEZBCZDEZFZDDVBGH
      ZUTIEZJVBDGHZUTKEZJFZDUTGHZVBIEZJUTDGHZVBKEZJFZFZIVEVHJVGVFJFZVJVMJVLVKJF
      ZFZKUTVBUAUBZLZLZLZMNZBMRAMRMMUCMUDUEWCABMUTMNZVBMNZJZVDDWAMDMNWFVDJULOWF
      VDSZJZVOIVTMIMNWHVOJUFOWHVOSZJZVRKVSMKMNWJVRJUGOWJVRSZJZVSWLUTVBUTVBUHWJW
      EWDJZVCVAFZSZJZVNVIFZSZJVQVPFZSVBUINWKWHWPWIWRWFWMWGWOWDWEUMVDWNVAVCPQUJV
      OWQVIVNPQUJVRWSVPVQPQVBUTUHUKUNUOTTTUPABMMWBMUDABUQURUS $.
  $}

  $( Closure of extended real multiplication.  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulcl $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A *e B ) e. RR* ) $=
    ( cxr cxmu xmulf fovcl ) ABCCCDEF $.

  $( Multiplication by plus infinity on the right.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xmulpnf1 $p |- ( ( A e. RR* /\ 0 < A ) -> ( A *e +oo ) = +oo ) $=
    ( cxr wcel cc0 clt wbr wa cpnf cxmu co wceq cmnf cmul cif pnfxr xmulval wne
    wo jctir syl mpan2 adantr wn 0xr xrltne mp3an1 cr 0re renepnf ax-mp neanior
    necomi sylib iffalse simpr eqid orcd olcd iftrue 3eqtrd ) ABCZDAEFZGZAHIJZA
    DKHDKRZDDHEFZAHKZGHDEFZALKZGRZVBHHKZGZADEFZHLKZGZRZRZHVFVIGVHVGGRVBVNGVMVKG
    RRLAHMJNZNZNZVSHVAVDVTKZVBVAHBCWAOAHPUAUBVCVEUCZVTVSKVCADQZHDQZGWBVCWCWDDBC
    VAVBWCUDDAUEUFDHDUGCDHQUHDUIUJULSADHDUKUMVEDVSUNTVCVQVSHKVCVPVJVCVLVOVCVBVK
    VAVBUOHUPSUQURVQHVRUSTUT $.

  $( Multiplication by plus infinity on the left.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xmulpnf2 $p |- ( ( A e. RR* /\ 0 < A ) -> ( +oo *e A ) = +oo ) $=
    ( cxr wcel cc0 clt wbr wa cpnf cxmu wceq pnfxr xmulcom mpan adantr xmulpnf1
    co eqtrd ) ABCZDAEFZGHAIPZAHIPZHRTUAJZSHBCRUBKHALMNAOQ $.

  $( Multiplication by minus infinity on the right.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xmulmnf1 $p |- ( ( A e. RR* /\ 0 < A ) -> ( A *e -oo ) = -oo ) $=
    ( cxr wcel cc0 clt wbr wa cmnf cxmu co cpnf cxne xnegpnf oveq2i simpl pnfxr
    wceq xmulneg2 sylancl xmulpnf1 xnegeq syl syl6eq eqtrd syl5eqr ) ABCZDAEFZG
    ZAHIJAKLZIJZHUIHAIMNUHUJAKIJZLZHUHUFKBCUJULQUFUGOPAKRSUHULUIHUHUKKQULUIQATU
    KKUAUBMUCUDUE $.

  $( Multiplication by minus infinity on the left.  (Contributed by Mario
     Carneiro, 20-Aug-2015.) $)
  xmulmnf2 $p |- ( ( A e. RR* /\ 0 < A ) -> ( -oo *e A ) = -oo ) $=
    ( cxr wcel cc0 clt wbr wa cmnf cxmu wceq mnfxr xmulcom mpan adantr xmulmnf1
    co eqtrd ) ABCZDAEFZGHAIPZAHIPZHRTUAJZSHBCRUBKHALMNAOQ $.

  $( Multiplication by plus infinity on the right, for negative input.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xmulpnf1n $p |- ( ( A e. RR* /\ A < 0 ) -> ( A *e +oo ) = -oo ) $=
    ( cxr wcel cc0 clt wa cpnf cxmu cxne cmnf wceq simpl pnfxr xmulneg1 sylancl
    wbr co xnegcl adantr xlt0neg1 biimpa xmulpnf1 syl2anc eqtr3d xnegmnf xmulcl
    syl6eqr wb mnfxr xneg11 mpbid ) ABCZADEPZFZAGHQZIZJIZKZUOJKZUNUPGUQUNAIZGHQ
    ZUPGUNULGBCZVAUPKULUMLZMAGNOUNUTBCZDUTEPZVAGKULVDUMARSULUMVEATUAUTUBUCUDUEU
    GUNUOBCZJBCURUSUHUNULVBVFVCMAGUFOUIUOJUJOUK $.

  $( Extended real version of ~ mulid1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulid1 $p |- ( A e. RR* -> ( A *e 1 ) = A ) $=
    ( cxr wcel cr cpnf wceq cmnf w3o c1 cxmu co elxr cmul 1re rexmul 0lt1 mp2an
    oveq1 id 3eqtr4a mpan2 ax-1rid eqtrd cc0 clt wbr rexri xmulpnf2 3jaoi sylbi
    xmulmnf2 ) ABCADCZAEFZAGFZHAIJKZAFZALULUPUMUNULUOAIMKZAULIDCUOUQFNAIOUAAUBU
    CUMEIJKZEUOAIBCZUDIUEUFZUREFINUGZPIUHQAEIJRUMSTUNGIJKZGUOAUSUTVBGFVAPIUKQAG
    IJRUNSTUIUJ $.

  $( Extended real version of ~ mulid2 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulid2 $p |- ( A e. RR* -> ( 1 *e A ) = A ) $=
    ( cxr wcel c1 cxmu co wceq 1re rexri xmulcom mpan xmulid1 eqtrd ) ABCZDAEFZ
    ADEFZADBCNOPGDHIDAJKALM $.

  $( Extended real version of ~ mulm1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulm1 $p |- ( A e. RR* -> ( -u 1 *e A ) = -e A ) $=
    ( cxr wcel c1 cneg cxmu co cxne wceq 1re rexneg ax-mp oveq1i rexri xmulneg1
    cr mpan syl5eqr xmulid2 xnegeq syl eqtrd ) ABCZDEZAFGZDAFGZHZAHZUCUEDHZAFGZ
    UGUIUDAFDPCUIUDIJDKLMDBCUCUJUGIDJNDAOQRUCUFAIUGUHIASUFATUAUB $.

  $( Lemma for ~ xmulass .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xmulasslem2 $p |- ( ( 0 < A /\ A = -oo ) -> ph ) $=
    ( cmnf wceq cc0 clt wbr breq2 cxr wn 0xr nltmnf ax-mp pm2.21i syl6bi impcom
    wcel ) BCDZEBFGZARSECFGZABCEFHTAEIQTJKELMNOP $.

  $( Extended real version of ~ mulgt0 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulgt0 $p |- ( ( ( A e. RR* /\ 0 < A ) /\ ( B e. RR* /\ 0 < B ) ) ->
      0 < ( A *e B ) ) $=
    ( cxr wcel cc0 clt wbr wa cr cpnf wceq cmnf cxmu co elxr sylib adantr simpr
    w3o sylan simpll simprl anim12i cmul mulgt0 an4s ancoms rexmul breqtrrd 0re
    adantl anassrs ltpnf ax-mp xmulpnf1 sylan9eqr syl5breqr adantlr xmulasslem2
    oveq2 simplrr 3jaodan mpdan oveq1 xmulpnf2 simplr ) ACDZEAFGZHZBCDZEBFGZHZH
    ZAIDZAJKZALKZSZEABMNZFGZVMVGVQVGVHVLUAAOPVMVNVSVOVPVMVNHZBIDZBJKZBLKZSZVSVM
    WDVNVMVJWDVIVJVKUBBOPQVTWAVSWBWCVMVNWAVSVMVHVKHZVNWAHZVSVIVHVLVKVGVHRVJVKRU
    CWEWFHEABUDNZVRFWFWEEWGFGZVNVHWAVKWHABUEUFUGWFVRWGKWEABUHUKUITULVMWBVSVNVMW
    BHEJVRFEIDEJFGUJEUMUNZWBVMVRAJMNZJBJAMUTVIWJJKVLAUOQUPUQURVTVKWCVSVIVJVKVNV
    AVSBUSTVBVCVMVOHEJVRFWIVOVMVRJBMNZJAJBMVDVLWKJKVIBVEUKUPUQVMVHVPVSVGVHVLVFV
    SAUSTVBVC $.

  $( Extended real version of ~ mulge0 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xmulge0 $p |- ( ( ( A e. RR* /\ 0 <_ A ) /\ ( B e. RR* /\ 0 <_ B ) ) ->
      0 <_ ( A *e B ) ) $=
    ( cxr wcel cc0 cle wbr wa clt cxmu co wceq 0xr adantr 0le0 eqcomd sylan9eqr
    wi syl5breqr wo xmulgt0 an4s xmulcl xrltle sylancr mpd ad2ant2r impl xmul01
    ex oveq2 ad2antrr adantlr wb xrleloe mpan biimpa ad2antlr mpjaodan ad2antrl
    oveq1 xmul02 ) ACDZEAFGZHZBCDZEBFGZHZHZEAIGZEABJKZFGZEALZVIVJHEBIGZVLEBLZVI
    VJVNVLVCVFVJVNHZVLRVDVGVCVFHZVPVLVQVPHZEVKIGZVLVCVJVFVNVSABUAUBVRECDZVKCDZV
    SVLRMVQWAVPABUCNEVKUDUEUFUJUGUHVIVOVLVJVIVOHEEVKFOVOVIVKAEJKZEVOWBVKEBAJUKP
    VCWBELVDVHAUIULQSUMVHVNVOTZVEVJVFVGWCVTVFVGWCUNMEBUOUPUQURUSVIVMHEEVKFOVMVI
    VKEBJKZEVMWDVKEABJVAPVFWDELVEVGBVBUTQSVEVJVMTZVHVCVDWEVTVCVDWEUNMEAUOUPUQNU
    S $.

  ${
    $d x D $.  $d x E $.  $d x F $.  $d x ph $.  $d x X $.  $d x Y $.
    xmulasslem.1 $e |- ( x = D -> ( ps <-> X = Y ) ) $.
    xmulasslem.2 $e |- ( x = -e D -> ( ps <-> E = F ) ) $.
    xmulasslem.x $e |- ( ph -> X e. RR* ) $.
    xmulasslem.y $e |- ( ph -> Y e. RR* ) $.
    xmulasslem.d $e |- ( ph -> D e. RR* ) $.
    xmulasslem.ps $e |- ( ( ph /\ ( x e. RR* /\ 0 < x ) ) -> ps ) $.
    xmulasslem.0 $e |- ( ph -> ( x = 0 -> ps ) ) $.
    xmulasslem.e $e |- ( ph -> E = -e X ) $.
    xmulasslem.f $e |- ( ph -> F = -e Y ) $.
    $( Lemma for ~ xmulass .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmulasslem $p |- ( ph -> X = Y ) $=
      ( cc0 cxr wi clt wbr wceq w3o wcel 0xr wor xrltso solin mpan sylancl cxne
      wa wb xlt0neg1 syl xnegcl breq2 imbi12d imbi2d exp32 com12 vtoclga sylbid
      cv mpcom eqeq12d xneg11 syl2anc bitrd sylibd eqeq1 vtoclg 3jaod mpd ) ADR
      UAUBZDRUCZRDUAUBZUDZGHUCZADSUEZRSUEZVSMUFSUAUGWAWBUMVSUHSDRUAUIUJUKAVPVTV
      QVRAVPEFUCZVTAVPRDULZUAUBZWCAWAVPWEUNMDUOUPWDSUEZAWEWCTZAWAWFMDUQUPARCVEZ
      UAUBZBTZTZAWGTCWDSWHWDUCZWJWGAWLWIWEBWCWHWDRUAURJUSUTAWHSUEZWJAWMWIBNVAVB
      ZVCVFVDAWCGULZHULZUCZVTAEWOFWPPQVGAGSUEHSUEWQVTUNKLGHVHVIVJVKWAAVQVTTZMAW
      HRUCZBTZTAWRTCDSWHDUCZWTWRAXAWSVQBVTWHDRVLIUSUTOVMVFWAAVRVTTZMWKAXBTCDSXA
      WJXBAXAWIVRBVTWHDRUAURIUSUTWNVCVFVNVO $.
  $}

  $( Lemma for ~ xmulass .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xmulasslem3 $p |- ( ( ( A e. RR* /\ 0 < A ) /\ ( B e. RR* /\ 0 < B ) /\
    ( C e. RR* /\ 0 < C ) ) -> ( ( A *e B ) *e C ) = ( A *e ( B *e C ) ) ) $=
    ( cxr wcel cc0 clt wa cr cpnf wceq cxmu co adantr cmul rexmul sylan 3eqtr4d
    wbr sylan9eqr w3a cmnf w3o simp1l elxr sylib simp2l simp3l cc mulass syl3an
    remulcl sylan2 anassrs oveq1d adantll oveq2d xmulcl syl2anc xmulgt0 3adant3
    3expa oveq2 xmulpnf1 simpl1 syl eqtr4d 3ad2ant2 adantlr simpl3r xmulasslem2
    recn 3jaodan mpdan xmulpnf2 3ad2ant3 3ad2ant1 simpl2r simpl3 3adant1 simp1r
    oveq1 ) ADEZFAGSZHZBDEZFBGSZHZCDEZFCGSZHZUAZAIEZAJKZAUBKZUCZABLMZCLMZABCLMZ
    LMZKZWLWCWPWCWDWHWKUDZAUEUFWLWMXAWNWOWLWMHZBIEZBJKZBUBKZUCZXAWLXGWMWLWFXGWE
    WFWGWKUGZBUEUFNXCXDXAXEXFWLWMXDXAWLWMXDHZHZCIEZCJKZCUBKZUCZXAWLXNXIWLWIXNWE
    WHWIWJUHZCUEUFNXJXKXAXLXMXIXKXAWLXIXKHZABOMZCLMZABCOMZLMZWRWTXPXQCOMZAXSOMZ
    XRXTWMXDXKYAYBKZWMAUIEXDBUIEXKCUIEYCAVLBVLCVLABCUJUKVBXIXQIEXKXRYAKABULXQCP
    QWMXDXKXTYBKZXDXKHWMXSIEYDBCULAXSPUMUNRXPWQXQCLXIWQXQKXKABPNUOXPWSXSALXDXKW
    SXSKWMBCPUPUQRUPWLXLXAXIWLXLHZWRAJLMZWTYEWRJYFXLWLWRWQJLMZJCJWQLVCWLWQDEZFW
    QGSZYGJKWLWCWFYHXBXHABURUSWEWHYIWKABUTVAWQVDUSTYEWEYFJKZWEWHWKXLVEAVDZVFVGY
    EWSJALXLWLWSBJLMZJCJBLVCWHWEYLJKWKBVDVHTUQVGVIXJWJXMXAWIWJWEWHXIVJXACVKQVMV
    NUNWLXEXAWMWLXEHZJCLMZYFWRWTWLYNYFKXEWLYNJYFWKWEYNJKZWHCVOZVPZWEWHYJWKYKVQZ
    VGNYMWQJCLXEWLWQYFJBJALVCYRTUOYMWSJALXEWLWSYNJBJCLWBYQTUQRVIXCWGXFXAWFWGWEW
    KWMVRXABVKQVMVNWLWNHZYNJWRWTYSWKYOWEWHWKWNVSYPVFYSWQJCLWNWLWQJBLMZJAJBLWBWH
    WEYTJKWKBVOVHTUOWNWLWTJWSLMZJAJWSLWBWLWSDEZFWSGSZUUAJKWLWFWIUUBXHXOBCURUSWH
    WKUUCWEBCUTVTWSVOUSTRWLWDWOXAWCWDWHWKWAXAAVKQVMVN $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    $( Associativity of the extended real multiplication operation.
       Surprisingly, there are no restrictions on the values, unlike ~ xaddass
       which has to avoid the "undefined" combinations ` +oo +e -oo ` and
       ` -oo +e +oo ` .  The equivalent "undefined" expression here would be
       ` 0 *e +oo ` , but since this is defined to equal ` 0 ` any zeroes in
       the expression make the whole thing evaluate to zero (on both sides),
       thus establishing the identity in this case.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xmulass $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
      ( ( A *e B ) *e C ) = ( A *e ( B *e C ) ) ) $=
      ( cxr wcel cxmu co wceq cxne oveq1 oveq1d eqeq12d xmulcl syl2anc wa oveq2
      cc0 oveq2d adantr xmulneg2 vx vy vz cv 3adant3 simp3 simp1 3adant1 simprl
      w3a clt wbr simpl2 xmulasslem3 adantlll xmul01 eqtr4d ad2antrl syl5ibrcom
      3expa syl eqtrd xmulasslem xmul02 3ad2ant3 3eqtr4d xmulneg1 3ad2ant2 ) AD
      EZBDEZCDEZUJZUAUDZBFGZCFGZVMBCFGZFGZHZUAAAIZBFGZCFGZVSVPFGZABFGZCFGZAVPFG
      ZVMAHZVOWDVQWEWFVNWCCFVMABFJKVMAVPFJLVMVSHZVOWAVQWBWGVNVTCFVMVSBFJKVMVSVP
      FJLVLWCDEZVKWDDEVIVJWHVKABMUEZVIVJVKUFZWCCMNVLVIVPDEZWEDEVIVJVKUGZVJVKWKV
      IBCMUHZAVPMNWLVLVMDEZQVMUKULZOZOZVMUBUDZFGZCFGZVMWRCFGZFGZHZUBBVMBIZFGZCF
      GZVMXDCFGZFGZVOVQWRBHZWTVOXBVQXIWSVNCFWRBVMFPKXIXAVPVMFWRBCFJRLWRXDHZWTXF
      XBXHXJWSXECFWRXDVMFPKXJXAXGVMFWRXDCFJRLWQVNDEZVKVODEWQWNVJXKVLWNWOUIZVIVJ
      VKWPUMZVMBMNZVLVKWPWJSZVNCMNWQWNWKVQDEXLVLWKWPWMSZVMVPMNXMWQWRDEZQWRUKULZ
      OZOZWSUCUDZFGZVMWRYAFGZFGZHZUCCWSCIZFGZVMWRYFFGZFGZWTXBYACHZYBWTYDXBYACWS
      FPYJYCXAVMFYACWRFPRLYAYFHZYBYGYDYIYAYFWSFPYKYCYHVMFYAYFWRFPRLXTWSDEZVKWTD
      EXTWNXQYLWQWNXSXLSZWQXQXRUIZVMWRMNZWQVKXSXOSZWSCMNXTWNXADEZXBDEYMXTXQVKYQ
      YNYPWRCMNZVMXAMNYPWPXSYADEQYAUKULOZYEVLWPXSYSYEVMWRYAUNUTUOXTYEYAQHZWSQFG
      ZVMWRQFGZFGZHXTUUAVMQFGZUUCXTUUAQUUDXTYLUUAQHYOWSUPVAXTWNUUDQHZYMVMUPZVAU
      QXTUUBQVMFXQUUBQHWQXRWRUPURRUQYTYBUUAYDUUCYAQWSFPYTYCUUBVMFYAQWRFPRLUSXTY
      LVKYGWTIHYOYPWSCTNXTYIVMXAIZFGZXBIZXTYHUUGVMFXTXQVKYHUUGHYNYPWRCTNRXTWNYQ
      UUHUUIHYMYRVMXATNVBVCWQXCWRQHZUUDCFGZVMQCFGZFGZHWQUULUUDUUKUUMWQUULQUUDVL
      UULQHZWPVKVIUUNVJCVDVEZSZWNUUEVLWOUUFURZUQWQUUDQCFUUQKWQUULQVMFUUPRVFUUJW
      TUUKXBUUMUUJWSUUDCFWRQVMFPKUUJXAUULVMFWRQCFJRLUSWQXFVNIZCFGZVOIZWQXEUURCF
      WQWNVJXEUURHXLXMVMBTNKWQXKVKUUSUUTHXNXOVNCVGNVBWQXHVMVPIZFGZVQIZWQXGUVAVM
      FWQVJVKXGUVAHXMXOBCVGNRWQWNWKUVBUVCHXLXPVMVPTNVBVCVLVRVMQHZQBFGZCFGZQVPFG
      ZHVLUULQUVFUVGUUOVLUVEQCFVJVIUVEQHVKBVDVHKVLWKUVGQHWMVPVDVAVFUVDVOUVFVQUV
      GUVDVNUVECFVMQBFJKVMQVPFJLUSVLWAWCIZCFGZWDIZVLVTUVHCFVIVJVTUVHHVKABVGUEKV
      LWHVKUVIUVJHWIWJWCCVGNVBVLVIWKWBWEIHWLWMAVPVGNVC $.
  $}

  $( Extended real version of ~ lemul1a .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xlemul1a $p |- ( ( ( A e. RR* /\ B e. RR* /\ ( C e. RR* /\ 0 <_ C ) ) /\
    A <_ B ) -> ( A *e C ) <_ ( B *e C ) ) $=
    ( cxr wcel cc0 cle wbr wa cxmu co clt wceq cpnf adantr syl eqbrtrd ad2antrr
    cmnf ax-mp w3a wi wo wb 0xr simpr xrleloe sylancr cr w3o simplll elxr sylib
    simpllr cmul simplrr simprll simprlr simprr simplrl lemul1 syl112anc rexmul
    mpbid syl2anc 3brtr4d expr simprl 0re lttri4 sylancl xmulpnf1n sylan xmulcl
    pnfxr mnfle oveq1 xmul02 syl6eq adantl breq1 syl5ibcom leloe pnfge xmulpnf1
    ex sylibd syl5breqr xrleid breqtrri oveq1d jaodan syldan ltletr mp3an1 impr
    imp syl5breq mpan2d breq12d mpbiri 3jaod mpd oveq2 syl5ibrcom nltmnf mtbiri
    wn breq2 con2i ad2antrl pm2.21d anassrs adantlr xmulpnf2 ad2ant2lr breqtrrd
    sylan9eqr xrletri3 ad3antrrr mpbir2and adantll 3jaodan mpdan xmulmnf2 exp32
    xmul01 ad2antlr a1dd jaod sylbid expimpd 3impia ) ADEZBDEZCDEZFCGHZIZUAABGH
    ZACJKZBCJKZGHZYNYOYRYSUUBUBZYNYOIZYPYQUUCUUDYPIZYQFCLHZFCMZUCZUUCUUEFDEZYPY
    QUUHUDUEUUDYPUFFCUGUHUUEUUFUUCUUGUUEUUFYSUUBUUEUUFYSIZIZAUIEZANMZASMZUJZUUB
    UUKYNUUOYNYOYPUUJUKZAULUMUUKUULUUBUUMUUNUUKUULIZBUIEZBNMZBSMZUJZUUBUUKUVAUU
    LUUKYOUVAYNYOYPUUJUNZBULUMOUUQUURUUBUUSUUTUUKUULUURUUBUUKUULUURIZIZCUIEZCNM
    ZCSMZUJZUUBUVDYPUVHUUDYPUUJUVCUNCULUMUVDUVEUUBUVFUVGUUKUVCUVEUUBUUKUVCUVEIZ
    IZACUOKZBCUOKZYTUUAGUVJYSUVKUVLGHZUUEUUFYSUVIUPUVJUULUURUVEUUFYSUVMUDUUKUUL
    UURUVEUQZUUKUULUURUVEURZUUKUVCUVEUSZUUEUUFYSUVIUTABCVAVBVDUVJUULUVEYTUVKMUV
    NUVPACVCVEUVJUURUVEUUAUVLMUVOUVPBCVCVEVFVGUVDUUBUVFANJKZBNJKZGHZUVDAFLHZAFM
    ZFALHZUJZUVSUVDUULFUIEZUWCUUKUULUURVHVIAFVJVKUVDUVTUVSUWAUWBUVDUVTUVSUVDUVT
    IZUVQSUVRGUVDYNUVTUVQSMUUKYNUVCUUPOAVLVMUWEUVRDEZSUVRGHUWEYONDEZUWFUVDYOUVT
    UUKYOUVCUVBOZOVOBNVNVKUVRVPPQWFUVDUWAUVSUVDUWAIUVQFUVRGUWAUVQFMUVDUWAUVQFNJ
    KZFAFNJVQUWGUWIFMVONVRTZVSVTUVDUWAFBLHZFBMZUCZFUVRGHZUVDUWAUWMUVDUWAFBGHZUW
    MUVDYSUWAUWOUUEUUFYSUVCUPZAFBGWAWBUVDUWDUURUWOUWMUDVIUUKUULUURUSFBWCUHWGWQU
    VDUWKUWNUWLUVDUWKIFNUVRGUUIFNGHUEFWDTUVDYOUWKUVRNMZUWHBWEZVMWHUVDUWLIZFUWIU
    VRGFFUWIGUUIFFGHZUEFWITZUWJWJUWSFBNJUVDUWLUFWKWRWLWMQWFUUKUVCUWBUVSUUKUVCUW
    BIZIZUVSNNGHZUWGUXDVONWDTUXCUVQNUVRNGUXCYNUWBUVQNMUUKYNUXBUUPOUUKUVCUWBUSAW
    EVEUXCYOUWKUWQUUKYOUXBUVBOUUKUVCUWBUWKUVDUWBYSUWKUWPUVCUWBYSIUWKUBZUUKUWDUU
    LUURUXEVIFABWNWOVTWSWPUWRVEWTXAVGXBXCUVFYTUVQUUAUVRGCNAJXDCNBJXDWTXEUVDUVGU
    UBUUKUVGXHZUVCUUFUXFUUEYSUVGUUFUVGUUFFSLHZUUIUXGXHUEFXFTCSFLXIXGXJXKOXLXBXC
    XMUUKUUSUUBUULUUKUUSIZYTNUUAGUXHYTDEZYTNGHUUEUXIUUJUUSYNYPUXIYOACVNXNRYTWDP
    UUSUUKUUANCJKZNBNCJVQYPUUFUXJNMUUDYSCXOXPXRXQXNUUKUUTUUBUULUUKUUTIZYTUUAUUA
    GUXKABCJUXKABMZYSBAGHZUUEUUFYSUUTUPUXKBSAGUUKUUTUFUXKYNSAGHUUKYNUUTUUPOAVPP
    QUUDUXLYSUXMIUDZYPUUJUUTABXSZXTYAWKUXKUUADEZUUAUUAGHZUUEUXPUUJUUTYOYPUXPYNB
    CVNYBZRUUAWIZPQXNYCYDUUKUUMIZYTUUAUUAGUXTABCJUXTUXLYSUXMUUEUUFYSUUMUPUXTBNA
    GUXTYOBNGHUUKYOUUMUVBOBWDPUUKUUMUFXQUUDUXNYPUUJUUMUXOXTYAWKUUEUXQUUJUUMUUEU
    XPUXQUXRUXSPRQUUKUUNIZYTSUUAGUUNUUKYTSCJKZSASCJVQYPUUFUYBSMUUDYSCYEXPXRUYAU
    XPSUUAGHUUEUXPUUJUUNUXRRUUAVPPQYCYDYFUUEUUGUUBYSUUEAFJKZBFJKZGHZUUGUUBUUEUY
    EUWTUXAUUEUYCFUYDFGYNUYCFMYOYPAYGRYOUYDFMYNYPBYGYHWTXAUUGUYCYTUYDUUAGFCAJXD
    FCBJXDWTWBYIYJYKYLYMWQ $.

  $( Extended real version of ~ lemul2a .  (Contributed by Mario Carneiro,
     8-Sep-2015.) $)
  xlemul2a $p |- ( ( ( A e. RR* /\ B e. RR* /\ ( C e. RR* /\ 0 <_ C ) ) /\
    A <_ B ) -> ( C *e A ) <_ ( C *e B ) ) $=
    ( cxr wcel cc0 cle wbr wa w3a cxmu co xlemul1a wceq simpl3l xmulcom syl2anc
    simpl1 simpl2 3brtr3d ) ADEZBDEZCDEZFCGHZIZJABGHZIZACKLZBCKLZCAKLZCBKLZGABC
    MUGUAUCUHUJNUAUBUEUFRUCUDUAUBUFOZACPQUGUBUCUIUKNUAUBUEUFSULBCPQT $.

  $( Extended real version of ~ lemul1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xlemul1 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR+ ) ->
    ( A <_ B <-> ( A *e C ) <_ ( B *e C ) ) ) $=
    ( cxr wcel crp w3a cle wbr cxmu co cc0 wa wi rpxr 3ad2ant3 syl2anc syl wceq
    c1 rpge0 jca xlemul1a ex syl3an3 cdiv simp1 simp2 rpreccl syl112anc xmulass
    xmulcl syl3anc cmul rpre rpred rexmul recnd wne rpne0 recidd oveq2d xmulid1
    cr eqtrd 3eqtrd breq12d sylibd impbid ) ADEZBDEZCFEZGZABHIZACJKZBCJKZHIZVLV
    JVKCDEZLCHIZMZVNVQNVLVRVSCOZCUAUBVJVKVTGVNVQABCUCUDUEVMVQVOTCUFKZJKZVPWBJKZ
    HIZVNVMVODEZVPDEZWBDEZLWBHIZVQWENVMVJVRWFVJVKVLUGZVLVJVRVKWAPZACULQVMVKVRWG
    VJVKVLUHZWKBCULQVMWBFEZWHVLVJWMVKCUIPZWBORZVMWMWIWNWBUARWFWGWHWIMGVQWEVOVPW
    BUCUDUJVMWCAWDBHVMWCACWBJKZJKZATJKZAVMVJVRWHWCWQSWJWKWOACWBUKUMVMWPTAJVMWPC
    WBUNKZTVMCVDEZWBVDEWPWSSVLVJWTVKCUOPZVMWBWNUPCWBUQQVMCVMCXAURVLVJCLUSVKCUTP
    VAVEZVBVMVJWRASWJAVCRVFVMWDBWPJKZBTJKZBVMVKVRWHWDXCSWLWKWOBCWBUKUMVMWPTBJXB
    VBVMVKXDBSWLBVCRVFVGVHVI $.

  $( Extended real version of ~ lemul2 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xlemul2 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR+ ) ->
    ( A <_ B <-> ( C *e A ) <_ ( C *e B ) ) ) $=
    ( cxr wcel crp w3a cle wbr cxmu co xlemul1 wceq simp1 rpxr 3ad2ant3 xmulcom
    syl2anc simp2 breq12d bitrd ) ADEZBDEZCFEZGZABHIACJKZBCJKZHICAJKZCBJKZHIABC
    LUEUFUHUGUIHUEUBCDEZUFUHMUBUCUDNUDUBUJUCCOPZACQRUEUCUJUGUIMUBUCUDSUKBCQRTUA
    $.

  $( Extended real version of ~ ltmul1 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xltmul1 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR+ ) ->
    ( A < B <-> ( A *e C ) < ( B *e C ) ) ) $=
    ( cxr wcel crp w3a cle wbr wn cxmu clt xlemul1 3com12 notbid xrltnle xmulcl
    co wb syl2anc 3adant3 simp1 rpxr 3ad2ant3 simp2 3bitr4d ) ADEZBDEZCFEZGZBAH
    IZJZBCKRZACKRZHIZJZABLIZUNUMLIZUJUKUOUHUGUIUKUOSBACMNOUGUHUQULSUIABPUAUJUND
    EZUMDEZURUPSUJUGCDEZUSUGUHUIUBUIUGVAUHCUCUDZACQTUJUHVAUTUGUHUIUEVBBCQTUNUMP
    TUF $.

  $( Extended real version of ~ ltmul2 .  (Contributed by Mario Carneiro,
     8-Sep-2015.) $)
  xltmul2 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR+ ) ->
    ( A < B <-> ( C *e A ) < ( C *e B ) ) ) $=
    ( cxr wcel crp w3a clt cxmu co xltmul1 wb rpxr wceq xmulcom 3adant2 3adant1
    wbr breq12d syl3an3 bitrd ) ADEZBDEZCFEZGABHRACIJZBCIJZHRZCAIJZCBIJZHRZABCK
    UDUBUCCDEZUGUJLCMUBUCUKGUEUHUFUIHUBUKUEUHNUCACOPUCUKUFUINUBBCOQSTUA $.

  $( Lemma for ~ xadddi .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xadddilem $p |- ( ( ( A e. RR /\ B e. RR* /\ C e. RR* ) /\ 0 < A ) ->
    ( A *e ( B +e C ) ) = ( ( A *e B ) +e ( A *e C ) ) ) $=
    ( cr wcel cxr wa cpnf wceq cmnf cxad co cxmu adantr syl2anc 3eqtr4d adantll
    cc0 oveq2d wne w3a clt wbr w3o simpl2 elxr sylib simpl3 simpl1 cmul cc recn
    syl3an readdcl rexmul sylan2 anassrs remulcl adantlr rexadd oveq12d sylanl1
    caddc adddi 3expa rexr 3ad2ant1 xmulpnf1 sylan eqeltrd renemnf xaddpnf1 syl
    eqtr4d adantl sylan9eqr xmulmnf1 renepnf xaddmnf1 3jaodan ad2antrr xaddpnf2
    oveq2 mpdan simpr oveq1d sylan9eq pnfxr pnfnemnf 3eqtr4a oveqan12d 3eqtr4rd
    mp2an oveq12 syl6eq pnfaddmnf xmul01 3syl xaddmnf2 mnfaddpnf mnfxr necomi )
    ADEZBFEZCFEZUAZRAUBUCZGZBDEZBHIZBJIZUDZABCKLZMLZABMLZACMLZKLZIZXHXDXLXCXDXE
    XGUEBUFUGXHXIXRXJXKXHXIGZCDEZCHIZCJIZUDZXRXHYCXIXHXEYCXCXDXEXGUHCUFUGZNXSXT
    XRYAYBXHXCXIXTXRXCXDXEXGUIZXCXIGZXTGZABCVCLZMLZABUJLZACUJLZKLZXNXQYGAYHUJLZ
    YJYKVCLZYIYLXCXIXTYMYNIZXCAUKEXIBUKEXTCUKEYOAULBULCULABCVDUMVEXCXIXTYIYMIZX
    IXTGXCYHDEYPBCUNAYHUOUPUQYGYJDEZYKDEZYLYNIYFYQXTABURZNXCXTYRXIACURZUSYJYKUT
    OPYGXMYHAMXIXTXMYHIXCBCUTQSYGXOYJXPYKKYFXOYJIXTABUOZNXCXTXPYKIXIACUOZUSVAPV
    BXSYAGZAHMLZXOHKLZXNXQXSUUDUUEIYAXSUUDHUUEXHUUDHIZXIXFAFEZXGUUFXCXDUUGXEAVF
    ZVGZAVHVIZNZXSXODEZUUEHIZXHXCXIUULYEYFXOYJDUUAYSVJVIZUULXOFEZXOJTUUMXOVFZXO
    VKXOVLOVMVNNUUCXMHAMYAXSXMBHKLZHCHBKWCXIUUQHIZXHXIXDBJTUURBVFZBVKBVLOVOVPSU
    UCXPHXOKYAXSXPUUDHCHAMWCZUUKVPSPXSYBGZAJMLZXOJKLZXNXQUVAUVBJUVCXSUVBJIZYBXH
    UVDXIXFUUGXGUVDUUIAVQVIZNZNUVAUULUVCJIZXSUULYBUUNNUULUUOXOHTUVGUUPXOVRXOVSO
    VMVNUVAXMJAMYBXSXMBJKLZJCJBKWCXIUVHJIZXHXIXDBHTUVIUUSBVRBVSOVOVPSUVAXPJXOKY
    BXSXPUVBJCJAMWCZUVFVPSPVTWDXHXJGZYCXRXHYCXJYDNUVKXTXRYAYBUVKXTGZUUDHXPKLZXN
    XQUVLUUDHUVMXHUUFXJXTUUJWAUVLXPDEZUVMHIZUVKXCXTUVNXHXCXJYENXCXTGXPYKDUUBYTV
    JZVIUVNXPFEZXPJTUVOXPVFZXPVKXPWBOVMVNUVLXMHAMUVKXTXMHCKLZHUVKBHCKXHXJWEWFXT
    XECJTUVSHICVFZCVKCWBOWGSUVLXOHXPKUVKXOHIXTXJXHXOUUDHBHAMWCZUUJVPNWFPUVKYAGU
    UDUUDKLZUUDXQXNXHUWBUUDIXJYAXHHHKLZHUWBUUDHFEHJTUWCHIWHWIHVLWMZXHUUDHUUDHKU
    UJUUJVAUUJWJWAXJYAXQUWBIXHXJYAXOUUDXPUUDKUWAUUTWKQXJYAXNUUDIXHXJYAGZXMHAMUW
    EXMUWCHBHCHKWNUWDWOSQWLUVKYBGUUDUVBKLZARMLZXQXNXHUWFUWGIXJYBXHHJKLZRUWFUWGW
    PXHUUDHUVBJKUUJUVEVAXHXCUUGUWGRIYEUUHAWQWRZWJWAXJYBXQUWFIXHXJYBXOUUDXPUVBKU
    WAUVJWKQXJYBXNUWGIZXHXJYBGZXMRAMUWKXMUWHRBHCJKWNWPWOSQWLVTWDXHXKGZYCXRXHYCX
    KYDNUWLXTXRYAYBUWLXTGZUVBJXPKLZXNXQUWMUVBJUWNXHUVDXKXTUVEWAUWMUVNUWNJIZUWLX
    CXTUVNXHXCXKYENUVPVIUVNUVQXPHTUWOUVRXPVRXPWSOVMVNUWMXMJAMUWLXTXMJCKLZJUWLBJ
    CKXHXKWEWFXTXECHTUWPJIUVTCVRCWSOWGSUWMXOJXPKUWLXOJIXTXKXHXOUVBJBJAMWCZUVEVP
    NWFPUWLYAGUWGUVBUUDKLZXNXQXHUWGUWRIXKYAXHUWGRUWRUWIXHUWRJHKLZRXHUVBJUUDHKUV
    EUUJVAWTWOVNWAXKYAUWJXHXKYAGZXMRAMUWTXMUWSRBJCHKWNWTWOSQXKYAXQUWRIXHXKYAXOU
    VBXPUUDKUWQUUTWKQPUWLYBGUVBUVBKLZUVBXQXNXHUXAUVBIXKYBXHJJKLZJUXAUVBJFEJHTUX
    BJIXAHJWIXBJVSWMZXHUVBJUVBJKUVEUVEVAUVEWJWAXKYBXQUXAIXHXKYBXOUVBXPUVBKUWQUV
    JWKQXKYBXNUVBIXHXKYBGZXMJAMUXDXMUXBJBJCJKWNUXCWOSQWLVTWDVTWD $.

  $( Distributive property for extended real addition and multiplication.  Like
     ~ xaddass , this has an unusual domain of correctness due to
     counterexamples like ` ( +oo x. ( 2 - 1 ) ) = -oo =/= `
     ` ( ( +oo x. 2 ) - ( +oo x. 1 ) ) = ( +oo - +oo ) = 0 ` .  In this theorem
     we show that if the multiplier is real then everything works as expected.
     (Contributed by Mario Carneiro, 20-Aug-2015.) $)
  xadddi $p |- ( ( A e. RR /\ B e. RR* /\ C e. RR* ) ->
    ( A *e ( B +e C ) ) = ( ( A *e B ) +e ( A *e C ) ) ) $=
    ( cr wcel cxr cc0 clt wbr wceq cxad cxmu syl2anc xmul02 syl oveq1d xmulneg1
    co cxne xmulcl w3a w3o 0re lttri4 sylancr xadddilem wa simpl2 simpl3 xaddcl
    simp1 xaddid1 ax-mp syl6eqr simpr eqtr3d oveq12d 3eqtr3d adantr cneg rexneg
    0xr renegcl eqeltrd wb rexrd xlt0neg1 biimpa syl31anc xnegdi eqtr4d 3jaodan
    xneg11 mpbid mpdan ) ADEZBFEZCFEZUAZGAHIZGAJZAGHIZUBZABCKRZLRZABLRZACLRZKRZ
    JZVSGDEVPWCUCVPVQVRUKZGAUDUEVSVTWIWAWBABCUFVSWAUGZGWDLRZGGKRZWEWHWKWLGWMWKW
    DFEZWLGJWKVQVRWNVPVQVRWAUHZVPVQVRWAUIZBCUJZMWDNOGFEWMGJVBGULUMUNWKGAWDLVSWA
    UOZPWKGWFGWGKWKGBLRZGWFWKVQWSGJWOBNOWKGABLWRPUPWKGCLRZGWGWKVRWTGJWPCNOWKGAC
    LWRPUPUQURVSWBUGZWESZWHSZJZWIXAASZWDLRZXEBLRZXECLRZKRZXBXCXAXEDEZVQVRGXEHIZ
    XFXIJXAVPXJVSVPWBWJUSVPXEAUTDAVAAVCVDOVPVQVRWBUHZVPVQVRWBUIZVSWBXKVSAFEZWBX
    KVEVSAWJVFZAVGOVHXEBCUFVIXAXNWNXFXBJVSXNWBXOUSZXAVQVRWNXLXMWQMZAWDQMXAXIWFS
    ZWGSZKRZXCXAXGXRXHXSKXAXNVQXGXRJXPXLABQMXAXNVRXHXSJXPXMACQMUQXAWFFEZWGFEZXC
    XTJXAXNVQYAXPXLABTMZXAXNVRYBXPXMACTMZWFWGVJMVKURXAWEFEZWHFEZXDWIVEXAXNWNYEX
    PXQAWDTMXAYAYBYFYCYDWFWGUJMWEWHVMMVNVLVO $.

  $( Commuted version of ~ xadddi .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xadddir $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR ) ->
    ( ( A +e B ) *e C ) = ( ( A *e C ) +e ( B *e C ) ) ) $=
    ( cxr wcel cr w3a cxad co cxmu xadddi 3coml xaddcl 3adant3 3ad2ant3 xmulcom
    wceq rexr syl2anc simp1 simp2 oveq12d 3eqtr4d ) ADEZBDEZCFEZGZCABHIZJIZCAJI
    ZCBJIZHIZUHCJIZACJIZBCJIZHIUFUDUEUIULQCABKLUGUHDEZCDEZUMUIQUDUEUPUFABMNUFUD
    UQUECROZUHCPSUGUNUJUOUKHUGUDUQUNUJQUDUEUFTURACPSUGUEUQUOUKQUDUEUFUAURBCPSUB
    UC $.

  $( The assumption that the multiplier be real in ~ xadddi can be relaxed if
     the addends have the same sign.  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xadddi2 $p |- ( ( A e. RR* /\ ( B e. RR* /\ 0 <_ B ) /\
                                ( C e. RR* /\ 0 <_ C ) ) ->
    ( A *e ( B +e C ) ) = ( ( A *e B ) +e ( A *e C ) ) ) $=
    ( cxr wcel cc0 cle wbr wa cxad co cxmu wceq cpnf cmnf sylancr syl2anc oveq1
    adantr sylan9eqr w3a clt w3o simpl1 elxr sylib simpr simp2l ad2antrr simp3l
    cr xadddi syl3anc wne pnfxr xmulcl simpl3r 0xr pnfge ax-mp xmulge0 ge0nemnf
    mpanl12 xaddpnf2 oveq12d xmulpnf2 sylan oveq1d xaddcl a1i xleadd2a syl31anc
    xaddid1 syl eqbrtrrd xrltletrd 3eqtr4rd mnfxr cxne oveq1i xmulneg1 syl5reqr
    xnegmnf xnegpnf eqeq12d wb xneg11 sylancl necon3bid mpbid xaddmnf2 xmulmnf2
    bitr3d 3jaodan mpdan simp1 xaddid2 eqcomd xmul01 3ad2ant1 oveq2d wo xrleloe
    oveq2 simp2r mpjaodan ) ADEZBDEZFBGHZIZCDEZFCGHZIZUAZFBUBHZABCJKZLKZABLKZAC
    LKZJKZMZFBMZXNXOIZAUKEZANMZAOMZUCZYAYCXGYGXGXJXMXOUDAUEUFYCYDYAYEYFYCYDIYDX
    HXKYAYCYDUGXNXHXOYDXGXHXIXMUHZUIXNXKXOYDXGXJXKXLUJZUIABCULUMYCYEIZNNCLKZJKZ
    NXTXQYJYKDEZYKOUNZYLNMYJNDEZXKYMUOYCXKYEXNXKXOYISZSNCUPZPYCYNYEYCYMFYKGHZYN
    YCYOXKYMUOYPYQPYCXKXLYRYPXKXLXGXJXOUQZYOFNGHZXMYRUOFDEZYTURFUSUTNCVAVCQYKVB
    QZSYKVDQYEYCXTNBLKZYKJKYLYEXRUUCXSYKJANBLRANCLRVEYCUUCNYKJXNXHXOUUCNMYHBVFV
    GVHTYEYCXQNXPLKZNANXPLRYCXPDEZFXPUBHZUUDNMXNUUEXOXNXHXKUUEYHYIBCVIQSZYCFBXP
    UUAYCURVJZXNXHXOYHSZUUGXNXOUGYCBFJKZBXPGYCXHUUJBMUUIBVMVNYCUUAXKXHXLUUJXPGH
    UUHYPUUIYSFCBVKVLVOVPZXPVFQTVQYCYFIOOCLKZJKZOXTXQYCUUMOMZYFYCUULDEZUULNUNZU
    UNYCODEZXKUUOVRYPOCUPPZYCYNUUPUUBYCYKOUULNYCUULVSZNVSZMZYKOMUULNMZYCUUSYKUU
    TOYCYKOVSZCLKZUUSUVCNCLWCVTYCUUQXKUVDUUSMVRYPOCWAPWBUUTOMYCWDVJWEYCUUOYOUVA
    UVBWFUURUOUULNWGWHWMWIWJUULWKQSYFYCXTOBLKZUULJKUUMYFXRUVEXSUULJAOBLRAOCLRVE
    YCUVEOUULJXNXHXOUVEOMYHBWLVGVHTYFYCXQOXPLKZOAOXPLRYCUUEUUFUVFOMUUGUUKXPWLQT
    VQWNWOXNYBIZFXSJKZXSXTXQUVGXSDEZUVHXSMXNUVIYBXNXGXKUVIXGXJXMWPYIACUPQSXSWQV
    NUVGXRFXSJYBXNXRAFLKZFYBUVJXRFBALXDWRXGXJUVJFMXMAWSWTTVHUVGXPCALYBXNXPFCJKZ
    CYBUVKXPFBCJRWRXNXKUVKCMYICWQVNTXAVQXNXIXOYBXBZXGXHXIXMXEXNUUAXHXIUVLWFURYH
    FBXCPWJXF $.

  $( Commuted version of ~ xadddi2 .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  xadddi2r $p |- ( ( ( A e. RR* /\ 0 <_ A ) /\ ( B e. RR* /\ 0 <_ B ) /\
    C e. RR* ) -> ( ( A +e B ) *e C ) = ( ( A *e C ) +e ( B *e C ) ) ) $=
    ( cxr wcel cc0 cle wbr wa w3a cxad co cxmu wceq xadddi2 3coml simp1l simp2l
    syl2anc xmulcom xaddcl simp3 oveq12d 3eqtr4d ) ADEZFAGHZIZBDEZFBGHZIZCDEZJZ
    CABKLZMLZCAMLZCBMLZKLZUMCMLZACMLZBCMLZKLUKUGUJUNUQNCABOPULUMDEZUKURUNNULUEU
    HVAUEUFUJUKQZUGUHUIUKRZABUASUGUJUKUBZUMCTSULUSUOUTUPKULUEUKUSUONVBVDACTSULU
    HUKUTUPNVCVDBCTSUCUD $.

  $( Extended real version of ~ 2times .  (Contributed by Mario Carneiro,
     20-Aug-2015.) $)
  x2times $p |- ( A e. RR* -> ( 2 *e A ) = ( A +e A ) ) $=
    ( cxr wcel c2 cxmu co c1 cxad caddc df-2 cr wceq rexadd mp2an eqtr4i oveq1i
    1re cc0 cle wbr wa rexri 0le1 pm3.2i xadddi2r mp3an12 xmulid2 oveq12d eqtrd
    syl5eq ) ABCZDAEFGGHFZAEFZAAHFZDULAEDGGIFZULJGKCZUPULUOLQQGGMNOPUKUMGAEFZUQ
    HFZUNGBCZRGSTZUAZVAUKUMURLUSUTGQUBUCUDZVBGGAUEUFUKUQAUQAHAUGZVCUHUIUJ $.

  ${
    xnegcld.1 $e |- ( ph -> A e. RR* ) $.
    $( Closure of extended real negative.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    xnegcld $p |- ( ph -> -e A e. RR* ) $=
      ( cxr wcel cxne xnegcl syl ) ABDEBFDECBGH $.

    xaddcld.2 $e |- ( ph -> B e. RR* ) $.
    $( The extended real addition operation is closed in extended reals.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    xaddcld $p |- ( ph -> ( A +e B ) e. RR* ) $=
      ( cxr wcel cxad co xaddcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

    $( Closure of extended real multiplication.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    xmulcld $p |- ( ph -> ( A *e B ) e. RR* ) $=
      ( cxr wcel cxmu co xmulcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

  ${
    xadd4d.1 $e |- ( ph -> ( A e. RR* /\ A =/= -oo ) ) $.
    xadd4d.2 $e |- ( ph -> ( B e. RR* /\ B =/= -oo ) ) $.
    xadd4d.3 $e |- ( ph -> ( C e. RR* /\ C =/= -oo ) ) $.
    xadd4d.4 $e |- ( ph -> ( D e. RR* /\ D =/= -oo ) ) $.
    $( Rearrangement of 4 terms in a sum for extended addition, analogous to
       ~ add4d .  (Contributed by Alexander van der Vekens, 21-Dec-2017.) $)
    xadd4d $p |- ( ph ->
      ( ( A +e B ) +e ( C +e D ) ) = ( ( A +e C ) +e ( B +e D ) ) ) $=
      ( cxad co cxr wcel cmnf wne wa wceq xaddass simpld syl2anc syl3anc oveq2d
      xaddcld xaddnemnf syl112anc xaddcom oveq1d eqtr2d eqtrd 3eqtr4d ) ABDCJKZ
      EJKZJKZBDCEJKZJKZJKZBCJKDEJKZJKZBDJKUNJKZAULUOBJADLMZDNOZPZCLMZCNOZPZELMZ
      ENOZPZULUOQHGIDCERUAUBAURBCUQJKZJKZUMABLMBNOPZVEUQLMUQNOZURVJQFGADEAUTVAH
      SZAVFVGISZUCAVBVHVLHIDEUDTBCUQRUEAVIULBJAULCDJKZEJKZVIAUKVOEJAUTVCUKVOQVM
      AVCVDGSZDCUFTUGAVEVBVHVPVIQGHICDERUAUHUBUIAVKVBUNLMUNNOZUSUPQFHACEVQVNUCA
      VEVHVRGICEUDTBDUNRUEUJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Supremum on the extended reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.  $d x y z w B $.
    $( Adding minus infinity to a set does not affect the existence of its
       supremum.  (Contributed by NM, 26-Oct-2005.) $)
    xrsupexmnf $p |- ( E. x e. RR* ( A. y e. A -. x < y /\
              A. y e. RR* ( y < x -> E. z e. A y < z ) ) ->
         E. x e. RR* ( A. y e. ( A u. { -oo } ) -. x < y /\
              A. y e. RR* ( y < x -> E. z e. ( A u. { -oo } ) y < z ) ) ) $=
      ( cv clt wbr wn wral wrex wi cxr wa cmnf csn cun wcel wo elun syl5bi wceq
      simpr elsn nltmnf breq2 notbid syl5ibrcom adantr ex ralimdv2 elun1 anim1i
      jaod reximi2 imim2i ralimi a1i anim12d reximia ) AEZBEZFGZHZBDIZVAUTFGZVA
      CEZFGZCDJZKZBLIZMVCBDNOZPZIZVEVGCVLJZKZBLIZMALUTLQZVDVMVJVPVQVCVCBDVLVQVA
      DQZVCKZVAVLQZVCKVTVRVAVKQZRVQVSMZVCVADVKSWBVRVCWAVQVSUBVQWAVCKVSWAVANUAZV
      QVCBNUCVQVCWCUTNFGZHUTUDWCVBWDVANUTFUEUFUGTUHUMTUIUJVJVPKVQVIVOBLVHVNVEVG
      VGCDVLVFDQVFVLQVGVFDVKUKULUNUOUPUQURUS $.

    $( Adding plus infinity to a set does not affect the existence of its
       infimum.  (Contributed by NM, 19-Jan-2006.) $)
    xrinfmexpnf $p |- ( E. x e. RR* ( A. y e. A -. y < x /\
              A. y e. RR* ( x < y -> E. z e. A z < y ) ) ->
         E. x e. RR* ( A. y e. ( A u. { +oo } ) -. y < x /\
              A. y e. RR* ( x < y -> E. z e. ( A u. { +oo } ) z < y ) ) ) $=
      ( cv clt wbr wn wral wrex wi cxr wa cpnf csn cun wcel wo elun syl5bi wceq
      simpr elsn pnfnlt breq1 notbid syl5ibrcom adantr ex ralimdv2 elun1 anim1i
      jaod reximi2 imim2i ralimi a1i anim12d reximia ) BEZAEZFGZHZBDIZVAUTFGZCE
      ZUTFGZCDJZKZBLIZMVCBDNOZPZIZVEVGCVLJZKZBLIZMALVALQZVDVMVJVPVQVCVCBDVLVQUT
      DQZVCKZUTVLQZVCKVTVRUTVKQZRVQVSMZVCUTDVKSWBVRVCWAVQVSUBVQWAVCKVSWAUTNUAZV
      QVCBNUCVQVCWCNVAFGZHVAUDWCVBWDUTNVAFUEUFUGTUHUMTUIUJVJVPKVQVIVOBLVHVNVEVG
      VGCDVLVFDQVFVLQVGVFDVKUKULUNUOUPUQURUS $.

    $( Lemma for ~ xrsupss .  (Contributed by NM, 25-Oct-2005.) $)
    xrsupsslem $p |- ( ( A C_ RR* /\ ( A C_ RR \/ +oo e. A ) ) -> E. x e. RR*
        ( A. y e. A -. x < y /\ A. y e. RR* ( y < x -> E. z e. A y < z ) ) ) $=
      ( cxr cr clt wbr wn wral wrex wi wa cpnf wcel c0 wceq cle cmnf breq1 sup3
      wss cv raleq rexeq imbi2d ralbidv anbi12d rexbidv wne rexr anim1i reximi2
      w3a syl elxr simpr pnfnlt adantr wb notbid adantl mpbird pm2.21d ad2antlr
      w3o ex wex ssel mnflt syl6 ancld eximdv n0 df-rex 3imtr4g imp a1d imbi12d
      ad2antrr 3jaod syl5bi ralimdv2 anim2d reximdva 3adant3 3expa ralnex ssel2
      mpd rexnal letric ord sylan an32s syl5bir ralimdva sylan2br breq2 cbvrexv
      ralbii sylib pnfxr ralrimiv c1 caddc co rspcva adantrr ancoms sylan2 ltp1
      peano2re ancli ltletr mpand adantll exp31 a1dd com4r xrltnr ax-mp cc0 0re
      mtbiri mpan9 syl5ibr exp3a 3jaoi sylbi com13 imbi1d rspcev sylancr syldan
      mpan jca adantlr pm2.61dan mnfxr ral0 nltmnf mp2an a1i pm2.61ne ralrimivw
      rgen pm3.2i anim12i jaodan ) DEUBZDFUBZAUCZBUCZGHZIZBDJZUUNUUMGHZUUNCUCZG
      HZCDKZLZBEJZMZAEKZNDOZUULUVEUUKUULUVEUUPBPJZUURUUTCPKZLZBEJZMZAEKZDPDPQZU
      VDUVKAEUVMUUQUVGUVCUVJUUPBDPUDUVMUVBUVIBEUVMUVAUVHUURUUTCDPUEUFUGUHUIUULD
      PUJZMZUUNUUMRHZBDJZAFKZUVEUULUVNUVRUVEUULUVNUVRUNZUUQUVBBFJZMZAEKZUVEUVSU
      WAAFKUWBABCDUAUWAUWAAFEUUMFOZUUMEOZUWAUUMUKULUMUOUULUVNUWBUVELUVRUVOUWAUV
      DAEUVOUWDMZUVTUVCUUQUWEUVBUVBBFEUWEUUNFOZUVBLZUUNEOZUVBLUWHUWFUUNNQZUUNSQ
      ZVFZUWEUWGMZUVBUUNUPZUWLUWFUVBUWIUWJUWEUWGUQUWDUWIUVBLUVOUWGUWDUWIUVBUWDU
      WIMZUURUVAUWNUURIZNUUMGHZIZUWDUWQUWIUUMURUSUWIUWOUWQUTUWDUWIUURUWPUUNNUUM
      GTVAVBVCVDVGVEUWEUWJUVBLUWGUWEUWJUVBUWEUWJMUVBSUUMGHZSUUSGHZCDKZLZUVOUXAU
      WDUWJUVOUWTUWRUULUVNUWTUULUUSDOZCVHUXBUWSMZCVHUVNUWTUULUXBUXCCUULUXBUWSUU
      LUXBUUSFOZUWSDFUUSVIUUSVJZVKVLVMCDVNUWSCDVOVPVQVRVTUWJUVBUXAUTUWEUWJUURUW
      RUVAUWTUUNSUUMGTUWJUUTUWSCDUUNSUUSGTUIZVSVBVCVGUSWAWBVGWCWDWEWFWJWGUULUVR
      IZUVEUVNUULUXGUUMUUSRHZCDKZAFJZUVEUULUXGMUUMUUNRHZBDKZAFJZUXJUXGUULUVQIZA
      FJZUXMUVQAFWHUULUXOUXMUULUXNUXLAFUXNUVPIZBDKUULUWCMZUXLUVPBDWKUXQUXPUXKBD
      UULUUNDOZUWCUXPUXKLZUULUXRMUWFUWCUXSDFUUNWIUWFUWCMUVPUXKUUNUUMWLWMWNWOWEW
      PWQVQWRUXLUXIAFUXKUXHBCDUUNUUSUUMRWSWTXAXBUULUXJMZNEOZNUUNGHZIZBDJZUUNNGH
      ZUVALZBEJZMZUVEXCUXTUYDUYGUULUYDUXJUULUYCBDUULUXRUWFUYCDFUUNVIUWFUWHUYCUU
      NUKUUNURZUOVKXDUSUXTUYFBEUULUXJUWHUYFLUWHUXJUULUYFUWHUWKUXJUULUYFLZLZUWMU
      WFUYKUWIUWJUXJUULUYEUWFUVAUXJUULUWFUVALUYEUXJUULUWFUVAUXJUULMZUWFMUUNXEXF
      XGZUUSRHZCDKZUVAUWFUYLUYMFOZUYOUUNXMZUYPUYLUYOUYPUXJUYOUULUXIUYOAUYMFUUMU
      YMQUXHUYNCDUUMUYMUUSRTUIXHXIXJXKUULUWFUYOUVALUXJUULUWFMUYNUUTCDUULUXBUWFU
      YNUUTLZUULUXBMZUXDUWFUYRDFUUSWIZUWFUXDUYRUWFUXDMUUNUYMGHZUYNUUTUWFVUAUXDU
      UNXLUSUWFUWFUYPMUXDVUAUYNMUUTLZUWFUYPUYQXNUWFUYPUXDVUBUUNUYMUUSXOWGWNXPXJ
      WNWOWEXQWJXRXSXTUWIUYJUXJUWIUYFUULUWIUYEUVAUWIUYENNGHZUYAVUCIXCNYAYBUUNNN
      GTYEVDVRVRUWJUXJUULUYFUWJUYLUVAUYEUYLUVAUWJUWTUXJYCUUSRHZCDKZUULUWTYCFOUX
      JVUEYDUXIVUEAYCFUUMYCQUXHVUDCDUUMYCUUSRTUIXHYPUULVUDUWSCDUYSUWSVUDUYSUXDU
      WSUYTUXEUOVRWEYFUXFYGXSYHYIYJYKVQXDYQUVDUYHANEUUMNQZUUQUYDUVCUYGVUFUUPUYC
      BDVUFUUOUYBUUMNUUNGTVAUGVUFUVBUYFBEVUFUURUYEUVAUUMNUUNGWSYLUGUHYMZYNYOYRY
      SUVLUULSEOSUUNGHZIZBPJZUUNSGHZUVHLZBEJZMZUVLYTVUJVUMVUIBUUAVULBEUWHVUKUVH
      UUNUUBVDUUGUUHUVKVUNASEUUMSQZUVGVUJUVJVUMVUOUUPVUIBPVUOUUOVUHUUMSUUNGTVAU
      GVUOUVIVULBEVUOUURVUKUVHUUMSUUNGWSYLUGUHYMUUCUUDUUEVBUUKUVFMUYAUYHUVEXCUU
      KUYDUVFUYGUUKUYCBDUUKUXRUWHUYCDEUUNVIUYIVKXDUVFUYFBEUVFUYEUVAUUTUYECNDUUS
      NUUNGWSYMVGUUFUUIVUGYNUUJ $.

    $( Lemma for ~ xrinfmss .  (Contributed by NM, 19-Jan-2006.) $)
    xrinfmsslem $p |- ( ( A C_ RR* /\ ( A C_ RR \/ -oo e. A ) ) -> E. x e. RR*
        ( A. y e. A -. y < x /\ A. y e. RR* ( x < y -> E. z e. A z < y ) ) ) $=
      ( cxr cr clt wbr wn wral wrex wi wa cmnf wcel c0 wceq cle cpnf breq2 rexr
      wss raleq rexeq imbi2d ralbidv anbi12d rexbidv wne w3a anim1i reximi2 syl
      cv infm3 w3o elxr simpr wex ssel ltpnf ancld eximdv n0 df-rex 3imtr4g imp
      syl6 a1d ad2antrr wb imbi12d adantl mpbird adantr nltmnf pm2.21d ad2antlr
      ex notbid 3jaod syl5bi ralimdv2 anim2d reximdva 3adant3 mpd ralnex rexnal
      3expa ssel2 letric ancoms ord sylan an32s syl5bir ralimdva sylan2br breq1
      wo cbvrexv ralbii sylib mnfxr ralrimiv c1 cmin co peano2rem rspcva sylan2
      adantrr ltm1 ancri lelttr 3expb mpan2d adantll exp31 a1dd com4r cc0 mpan9
      0re syl5ibr exp3a xrltnr ax-mp mtbiri 3jaoi sylbi com13 jca imbi1d rspcev
      mpan sylancr syldan adantlr pm2.61dan pnfxr ral0 pnfnlt rgen pm3.2i mp2an
      a1i pm2.61ne ralrimivw anim12i jaodan ) DEUBZDFUBZBUNZAUNZGHZIZBDJZUUPUUO
      GHZCUNZUUOGHZCDKZLZBEJZMZAEKZNDOZUUNUVGUUMUUNUVGUURBPJZUUTUVBCPKZLZBEJZMZ
      AEKZDPDPQZUVFUVMAEUVOUUSUVIUVEUVLUURBDPUCUVOUVDUVKBEUVOUVCUVJUUTUVBCDPUDU
      EUFUGUHUUNDPUIZMZUUPUUORHZBDJZAFKZUVGUUNUVPUVTUVGUUNUVPUVTUJZUUSUVDBFJZMZ
      AEKZUVGUWAUWCAFKUWDABCDUOUWCUWCAFEUUPFOZUUPEOZUWCUUPUAUKULUMUUNUVPUWDUVGL
      UVTUVQUWCUVFAEUVQUWFMZUWBUVEUUSUWGUVDUVDBFEUWGUUOFOZUVDLZUUOEOZUVDLUWJUWH
      UUOSQZUUONQZUPZUWGUWIMZUVDUUOUQZUWNUWHUVDUWKUWLUWGUWIURUWGUWKUVDLUWIUWGUW
      KUVDUWGUWKMUVDUUPSGHZUVASGHZCDKZLZUVQUWSUWFUWKUVQUWRUWPUUNUVPUWRUUNUVADOZ
      CUSUWTUWQMZCUSUVPUWRUUNUWTUXACUUNUWTUWQUUNUWTUVAFOZUWQDFUVAUTUVAVAZVHVBVC
      CDVDUWQCDVEVFVGVIVJUWKUVDUWSVKUWGUWKUUTUWPUVCUWRUUOSUUPGTUWKUVBUWQCDUUOSU
      VAGTUHZVLVMVNVSVOUWFUWLUVDLUVQUWIUWFUWLUVDUWFUWLMZUUTUVCUXEUUTIZUUPNGHZIZ
      UWFUXHUWLUUPVPVOUWLUXFUXHVKUWFUWLUUTUXGUUONUUPGTVTVMVNVQVSVRWAWBVSWCWDWEW
      FWGWJUUNUVTIZUVGUVPUUNUXIUVAUUPRHZCDKZAFJZUVGUUNUXIMUUOUUPRHZBDKZAFJZUXLU
      XIUUNUVSIZAFJZUXOUVSAFWHUUNUXQUXOUUNUXPUXNAFUXPUVRIZBDKUUNUWEMZUXNUVRBDWI
      UXSUXRUXMBDUUNUUODOZUWEUXRUXMLZUUNUXTMUWHUWEUYADFUUOWKUWHUWEMUVRUXMUWEUWH
      UVRUXMXAUUPUUOWLWMWNWOWPWEWQWRVGWSUXNUXKAFUXMUXJBCDUUOUVAUUPRWTXBXCXDUUNU
      XLMZNEOZUUONGHZIZBDJZNUUOGHZUVCLZBEJZMZUVGXEUYBUYFUYIUUNUYFUXLUUNUYEBDUUN
      UXTUWHUYEDFUUOUTUWHUWJUYEUUOUAUUOVPZUMVHXFVOUYBUYHBEUUNUXLUWJUYHLUWJUXLUU
      NUYHUWJUWMUXLUUNUYHLZLZUWOUWHUYMUWKUWLUXLUUNUYGUWHUVCUXLUUNUWHUVCLUYGUXLU
      UNUWHUVCUXLUUNMZUWHMUVAUUOXGXHXIZRHZCDKZUVCUWHUYNUYOFOZUYQUUOXJZUYRUYNUYQ
      UYRUXLUYQUUNUXKUYQAUYOFUUPUYOQUXJUYPCDUUPUYOUVARTUHXKXMWMXLUUNUWHUYQUVCLU
      XLUUNUWHMUYPUVBCDUUNUWTUWHUYPUVBLZUUNUWTMZUXBUWHUYTDFUVAWKZUXBUWHMUYPUYOU
      UOGHZUVBUWHVUCUXBUUOXNVMUWHUXBUYRUWHMUYPVUCMUVBLZUWHUYRUYSXOUXBUYRUWHVUDU
      VAUYOUUOXPXQXLXRWOWPWEXSWGXTYAYBUWKUXLUUNUYHUWKUYNUVCUYGUYNUVCUWKUWRUXLUV
      AYCRHZCDKZUUNUWRYCFOUXLVUFYEUXKVUFAYCFUUPYCQUXJVUECDUUPYCUVARTUHXKYQUUNVU
      EUWQCDVUAUWQVUEVUAUXBUWQVUBUXCUMVIWEYDUXDYFYAYGUWLUYLUXLUWLUYHUUNUWLUYGUV
      CUWLUYGNNGHZUYCVUGIXENYHYIUUONNGTYJVQVIVIYKYLYMVGXFYNUVFUYJANEUUPNQZUUSUY
      FUVEUYIVUHUURUYEBDVUHUUQUYDUUPNUUOGTVTUFVUHUVDUYHBEVUHUUTUYGUVCUUPNUUOGWT
      YOUFUGYPZYRYSYTUUAUVNUUNSEOUUOSGHZIZBPJZSUUOGHZUVJLZBEJZMZUVNUUBVULVUOVUK
      BUUCVUNBEUWJVUMUVJUUOUUDVQUUEUUFUVMVUPASEUUPSQZUVIVULUVLVUOVUQUURVUKBPVUQ
      UUQVUJUUPSUUOGTVTUFVUQUVKVUNBEVUQUUTVUMUVJUUPSUUOGWTYOUFUGYPUUGUUHUUIVMUU
      MUVHMUYCUYJUVGXEUUMUYFUVHUYIUUMUYEBDUUMUXTUWJUYEDEUUOUTUYKVHXFUVHUYHBEUVH
      UYGUVCUVBUYGCNDUVANUUOGWTYPVSUUJUUKVUIYRUUL $.

    $( Any subset of extended reals has a supremum.  (Contributed by NM,
       25-Oct-2005.) $)
    xrsupss $p |- ( A C_ RR* -> E. x e. RR* (
         A. y e. A -. x < y /\ A. y e. RR* ( y < x -> E. z e. A y < z ) ) ) $=
      ( cxr wss cr cpnf wcel wo cv clt wbr wral wrex wi wa cmnf xrsupsslem w3o
      wn cdif ssdifss ssxr df-3or neldifsn biorfi bitr4i sylib mpdan xrsupexmnf
      csn syl wb snssi wceq undif uncom eqeq1i bitri raleq rexeq imbi2d ralbidv
      cun anbi12d sylbi rexbidv syl5ib mpan9 mpjaodan ) DEFZDGFZHDIZJZAKZBKZLMU
      AZBDNZVQVPLMZVQCKLMZCDOZPZBENZQZAEOZRDIZABCDSVLVRBDRULZUBZNVTWACWIOPBENQA
      EOZWGWFVLWIEFZWJDEWHUCWKWIGFZHWIIZJZWJWKWLWMRWIIZTZWNWIUDWPWNWOJWNWLWMWOU
      EWOWNRDUFUGUHUIABCWISUJUMWJVRBWIWHVEZNZVTWACWQOZPZBENZQZAEOWGWFABCWIUKWGX
      BWEAEWGWHDFZXBWEUNZRDUOXCWQDUPZXDXCWHWIVEZDUPXEWHDUQXFWQDWHWIURUSUTXEWRVS
      XAWDVRBWQDVAXEWTWCBEXEWSWBVTWACWQDVBVCVDVFVGUMVHVIVJVLVMVNWGTVOWGJDUDVMVN
      WGUEUIVK $.

    $( Any subset of extended reals has an infimum.  (Contributed by NM,
       25-Oct-2005.) $)
    xrinfmss $p |- ( A C_ RR* -> E. x e. RR* (
         A. y e. A -. y < x /\ A. y e. RR* ( x < y -> E. z e. A z < y ) ) ) $=
      ( cxr wss cr cmnf wcel wo cv clt wbr wn wral wrex wi wa cpnf bitri 3orass
      xrinfmsslem csn cdif ssdifss ssxr wb pnfxr elexi snid elndif biorf orbi2i
      w3o mp2b bitr4i sylib mpdan syl xrinfmexpnf wceq undif uncom eqeq1i raleq
      cun snss rexeq imbi2d ralbidv anbi12d sylbi rexbidv syl5ib mpan9 mpjaodan
      df-3or or32 ) DEFZDGFZHDIZJZBKZAKZLMNZBDOZWDWCLMZCKWCLMZCDPZQZBEOZRZAEPZS
      DIZABCDUBVSWEBDSUCZUDZOWGWHCWPPQBEORAEPZWNWMVSWPEFZWQDEWOUEWRWPGFZHWPIZJZ
      WQWRWSSWPIZWTUNZXAWPUFXCWSXBWTJZJXAWSXBWTUAWTXDWSSWOIXBNWTXDUGSSEUHUIZUJS
      WODUKXBWTULUOUMUPUQABCWPUBURUSWQWEBWPWOVFZOZWGWHCXFPZQZBEOZRZAEPWNWMABCWP
      UTWNXKWLAEWNXFDVAZXKWLUGWNWODFZXLSDXEVGXMWOWPVFZDVAXLWODVBXNXFDWOWPVCVDTT
      XLXGWFXJWKWEBXFDVEXLXIWJBEXLXHWIWGWHCXFDVHVIVJVKVLVMVNVOVSVTWNWAUNZWBWNJZ
      DUFXOVTWNJWAJXPVTWNWAVQVTWNWAVRTUQVP $.

    $( Any subset of extended reals has an infimum.  (Contributed by Mario
       Carneiro, 16-Mar-2014.) $)
    xrinfmss2 $p |- ( A C_ RR* -> E. x e. RR* ( A. y e. A -. x `' < y /\
                      A. y e. RR* ( y `' < x -> E. z e. A y `' < z ) ) ) $=
      ( cxr wss cv clt wbr wn wral wrex wi wa ccnv xrinfmss brcnv ralbii rexbii
      vex notbii imbi12i anbi12i sylibr ) DEFBGZAGZHIZJZBDKZUFUEHIZCGZUEHIZCDLZ
      MZBEKZNZAELUFUEHOZIZJZBDKZUEUFUQIZUEUKUQIZCDLZMZBEKZNZAELABCDPVFUPAEUTUIV
      EUOUSUHBDURUGUFUEHATZBTZQUARVDUNBEVAUJVCUMUEUFHVHVGQVBULCDUEUKHVHCTQSUBRU
      CSUD $.

    $( By quantifying only over reals, we can specify any extended real upper
       bound for any set of extended reals.  (Contributed by NM,
       9-Apr-2006.) $)
    xrub $p |- ( ( A C_ RR* /\ B e. RR* ) -> ( A. x e. RR ( x < B ->
          E. y e. A x < y ) <-> A. x e. RR* ( x < B -> E. y e. A x < y ) ) ) $=
      ( vz cxr wcel wa clt wbr wrex wi cr wceq breq1 rexbidv cpnf cmnf c1 ax-mp
      wss wral imbi12d cbvralv w3o elxr pm2.27 a1i pnfnlt notbid syl5ibr pm2.21
      cv wn syl6com ad2antlr a1dd cmin co peano2rem rspcv syl adantl id syl5com
      ltm1 mnflt ssel2 adantlr mnfxr xrlttr mp3an1 syl2anc mpand reximdva 3syld
      rexr 1re ltpnf breq2 mpbiri mp3an12 mpani sylan9r syl5 xrltnr pm2.21d a1d
      mtbiri 3jaodan sylan2b imp syl5ibrcom 3jaod syl5bi com23 ralimdv2 pm2.43d
      ex imim1i ralimi2 impbid1 ) CFUAZDFGZHZAUMZDIJZXFBUMZIJZBCKZLZAMUBZXKAFUB
      ZXEXLXMXLEUMZDIJZXNXHIJZBCKZLZEMUBZXEXLXMLZXKXRAEMXFXNNZXGXOXJXQXFXNDIOYA
      XIXPBCXFXNXHIOPUCUDXEXSXTXEXSHZXKXKAMFYBXFFGZXFMGZXKLZXKYCYDXFQNZXFRNZUEY
      BYEXKLZXFUFYBYDYHYFYGYDYHLYBYDXKUGUHYBYFXKYEXDYFXKLXCXSYFXDXGUNZXKXDYIYFQ
      DIJZUNDUIYFXGYJXFQDIOUJUKXGXJULUOUPUQYBYGXKYEYBXKYGRDIJZRXHIJZBCKZLZXEXSY
      NXDXCDMGZDQNZDRNZUEXSYNLZDUFXCYOYRYPYQXCYOHZXSYMYKYSXSDSURUSZDIJZYTXHIJZB
      CKZLZUUCYMYOXSUUDLZXCYOYTMGZUUEDUTZXRUUDEYTMXNYTNZXOUUAXQUUCXNYTDIOUUHXPU
      UBBCXNYTXHIOPUCVAVBVCYOUUDUUCLXCYOUUAUUDUUCDVFUUDVDVEVCYSUUBYLBCYSXHCGZHZ
      RYTIJZUUBYLUUJUUFUUKYOUUFXCUUIUUGUPZYTVGVBUUJYTFGZXHFGZUUKUUBHYLLZUUJUUFU
      UMUULYTVQVBXCUUIUUNYOCFXHVHZVIRFGZUUMUUNUUOVJRYTXHVKVLVMVNVOVPUQXCYPHZXSY
      MYKXSSDIJZSXHIJZBCKZLZUURYMSMGZXSUVBLVRXRUVBESMXNSNZXOUUSXQUVAXNSDIOUVDXP
      UUTBCXNSXHIOPUCVATYPUVBUVAXCYMYPUUSUVBUVAYPUUSSQIJZUVCUVEVRSVSTDQSIVTWAUV
      BVDVEXCUUTYLBCXCUUIHUUNUUTYLLUUPUUNRSIJZUUTYLUVCUVFVRSVGTUUQSFGZUUNUVFUUT
      HYLLVJUVCUVGVRSVQTRSXHVKWBWCVBVOWDWEUQXCYQHZYNXSUVHYKYMYQYKUNXCYQYKRRIJZU
      UQUVIUNVJRWFTDRRIVTWIVCWGWHWJWKWLYGXGYKXJYMXFRDIOYGXIYLBCXFRXHIOPUCWMUQWN
      WOWPWQWSWOWRXKXKAFMYDYCXKXFVQWTXAXB $.

    $( The supremum of a set of extended reals.  (Contributed by NM,
       9-Apr-2006.)  (Revised by Mario Carneiro, 21-Apr-2015.) $)
    supxr $p |- ( ( ( A C_ RR* /\ B e. RR* ) /\ ( A. x e. A -. B < x /\
    A. x e. RR ( x < B -> E. y e. A x < y ) ) ) -> sup ( A , RR* , < ) = B ) $=
      ( cxr wss wcel wa cv clt wbr wn wral wrex wi cr csup wceq simplr wtru w3a
      simprl xrub biimpa adantrl wor xrltso a1i eqsup trud syl3anc ) CEFZDEGZHZ
      DAIZJKLACMZUODJKUOBIJKBCNOZAPMZHZHUMUPUQAEMZCEJQDRZULUMUSSUNUPURUBUNURUTU
      PUNURUTABCDUCUDUEUMUPUTUAVAOTABECDJEJUFTUGUHUIUJUK $.

    $( The supremum of a set of extended reals.  (Contributed by NM,
       9-Apr-2006.) $)
    supxr2 $p |- ( ( ( A C_ RR* /\ B e. RR* ) /\ ( A. x e. A x <_ B /\
  A. x e. RR ( x < B -> E. y e. A x < y ) ) ) -> sup ( A , RR* , < ) = B ) $=
      ( cxr wss wcel wa cv cle wbr wral clt wrex wi cr wn csup wceq wb ralbidva
      ssel2 xrlenlt sylan an32s anbi1d biimpa supxr syldan ) CEFZDEGZHZAIZDJKZA
      CLZUMDMKUMBIMKBCNOAPLZHZDUMMKQZACLZUPHZCEMRDSULUQUTULUOUSUPULUNURACUJUMCG
      ZUKUNURTZUJVAHUMEGUKVBCEUMUBUMDUCUDUEUAUFUGABCDUHUI $.

    $( The supremum of an arbitrary set of extended reals is an extended real.
       (Contributed by NM, 24-Oct-2005.) $)
    supxrcl $p |- ( A C_ RR* -> sup ( A , RR* , < ) e. RR* ) $=
      ( vx vy vz cxr wss clt wor xrltso a1i xrsupss supcl ) AEFZBCDEAGEGHMIJBCD
      AKL $.

    $( The supremum of the union of two sets of extended reals equals the
       largest of their suprema.  (Contributed by NM, 19-Jan-2006.) $)
    supxrun $p |- ( ( A C_ RR* /\ B C_ RR* /\ sup ( A , RR* , < ) <_ sup
   ( B , RR* , < ) ) -> sup ( ( A u. B ) , RR* , < ) = sup ( B , RR* , < ) ) $=
      ( vx vy vz vw cxr wss clt csup wbr wcel cv wn wral wi cr 3ad2ant2 xrsupss
      wa cle w3a cun wrex wceq unss biimpi 3adant3 supxrcl wo elun xrltso supub
      wor a1i 3ad2ant1 ad2antrr ad2antlr ssel2 adantlr xrlelttr syl3anc expdimp
      con3d exp41 com34 3imp mpdd jaod syl5bi ralrimiv rexr suplub sylani elun2
      anim1i reximi2 syl6 exp3a supxr syl22anc ) AGHZBGHZAGIJZBGIJZUAKZUBZABUCZ
      GHZWEGLZWECMZIKZNZCWHOWKWEIKZWKDMZIKZDWHUDZPZCQOZWHGIJWEUEWBWCWIWFWBWCTZW
      IABGUFUGUHWCWBWJWFBUIZRWGWMCWHWKWHLWKALZWKBLZUJWGWMWKABUKWGXBWMXCWGXBWDWK
      IKZNZWMWBWCXBXEPWFWBDEFGAWKIGIUNZWBULUODEFASUMUPWBWCWFXBXEWMPZPWBWCXBWFXG
      WBWCXBWFXGWTXBTZWFTWLXDXHWFWLXDXHWDGLZWJWKGLZWFWLTXDPWBXIWCXBAUIUQWCWJWBX
      BXAURWBXBXJWCAGWKUSUTWDWEWKVAVBVCVDVEVFVGVHWCWBXCWMPWFWCDEFGBWKIXFWCULUOZ
      DEFBSUMRVIVJVKWCWBWSWFWCWRCQWCWKQLZWNWQWCXLWNTWPDBUDZWQXLWCXJWNXMWKVLWCCE
      DGBWKIXKCEDBSVMVNWPWPDBWHWOBLWOWHLWPWOBAVOVPVQVRVSVKRCDWHWEVTWA $.

    $( The infimum of an arbitrary set of extended reals is an extended real.
       (Contributed by NM, 19-Jan-2006.)  (Revised by Mario Carneiro,
       16-Mar-2014.) $)
    infmxrcl $p |- ( A C_ RR* -> sup ( A , RR* , `' < ) e. RR* ) $=
      ( vx vy vz cxr wss clt ccnv wor xrltso cnvso mpbi a1i xrinfmss2 supcl ) A
      EFZBCDEAGHZEQIZPEGIRJEGKLMBCDANO $.

    $( Adding minus infinity to a set does not affect its supremum.
       (Contributed by NM, 19-Jan-2006.) $)
    supxrmnf $p |- ( A C_ RR* ->
                 sup ( ( A u. { -oo } ) , RR* , < ) = sup ( A , RR* , < ) ) $=
      ( cxr wss cmnf csn cun clt csup uncom supeq1i cle wbr wceq mnfxr snssi id
      wcel mp1i wor xrltso supsn mp2an supxrcl mnfle syl supxrun syl3anc syl5eq
      syl5eqbr ) ABCZADEZFZBGHUKAFZBGHZABGHZBULUMGAUKIJUJUKBCZUJUKBGHZUOKLUNUOM
      DBQZUPUJNDBORUJPUJUQDUOKBGSURUQDMTNBDGUAUBUJUOBQDUOKLAUCUOUDUEUIUKAUFUGUH
      $.

    $( The supremum of a set of extended reals containing plus infnity is plus
       infinity.  (Contributed by NM, 15-Oct-2005.) $)
    supxrpnf $p |- ( ( A C_ RR* /\ +oo e. A ) -> sup ( A , RR* , < ) = +oo ) $=
      ( vy vz cxr wss cpnf wcel cv clt wbr wn wral wrex wi cr wa csup wceq ssel
      pnfnlt syl6 ralrimiv breq2 rspcev ex ralrimivw anim12i pnfxr supxr mpanl2
      syldan ) ADEZFAGZFBHZIJKZBALZUNFIJZUNCHZIJZCAMZNZBOLZPZADIQFRZULUPUMVBULU
      OBAULUNAGUNDGUOADUNSUNTUAUBUMVABOUMUQUTUSUQCFAURFUNIUCUDUEUFUGULFDGVCVDUH
      BCAFUIUJUK $.

    $( The supremum of an unbounded-above set of extended reals is plus
       infinity.  (Contributed by NM, 19-Jan-2006.) $)
    supxrunb1 $p |- ( A C_ RR* -> ( A. x e. RR E. y e. A x <_ y <->
                    sup ( A , RR* , < ) = +oo ) ) $=
      ( vz vw cxr cv cle wbr wrex cr wral clt cpnf wceq wn wi wa wcel rexr csup
      wss ssel pnfnlt ralrimiv adantr c1 caddc co peano2re breq1 rexbidv rspcva
      syl6 adantrr ancoms ssel2 ltp1 ancli xrltletr syl3an2 syl3an1 3expa sylan
      sylan2 mpand an32s reximdva adantll mpd exp31 com4r com13 imp pnfxr supxr
      a1dd jca mpanl2 syldan ad2antlr ltpnf breq2 syl5ibr impcom wor xrltso a1i
      ex xrsupss ad2antrr suplub mp2and adantlr xrltle syl2anc ralrimdva impbid
      syld ) CFUBZAGZBGZHIZBCJZAKLZCFMUAZNOZWTXEXGWTXENDGZMIPZDCLZXHNMIZXHXBMIZ
      BCJZQZDKLZRZXGWTXERZXJXOWTXJXEWTXIDCWTXHCSXHFSZXICFXHUCXHUDUNUEUFXQXNDKWT
      XEXHKSZXNQXSXEWTXNXEWTXKXSXMXEWTXSXMQXKXEWTXSXMXEWTRZXSRXHUGUHUIZXBHIZBCJ
      ZXMXSXTYAKSZYCXHUJZYDXTYCYDXEYCWTXDYCAYAKXAYAOXCYBBCXAYAXBHUKULUMUOUPVEWT
      XSYCXMQXEWTXSRYBXLBCWTXBCSZXSYBXLQZWTYFRXBFSZXSYGCFXBUQZXSYHYGXSYHRXHYAMI
      ZYBXLXSYJYHXHURUFXSXSYDRYHYJYBRXLQZXSYDYEUSXSYDYHYKXSXRYDYHYKXHTYDXRYAFSY
      HYKYATXHYAXBUTVAVBVCVDVFUPVDVGVHVIVJVKVQVLVMVNUEVRWTNFSXPXGVODBCNVPVSVTWI
      WTXGXDAKWTXAKSZRZXGXAXBMIZBCJZXDYMXGYOYMXGRZXAFSZXAXFMIZYOYLYQWTXGXATZWAY
      LXGYRWTXGYLYRYLYRXGXANMIXAWBXFNXAMWCWDWEVIYPDEBFCXAMFMWFYPWGWHWTXHEGZMIPE
      CLYTXHMIYTXBMIBCJQEFLRDFJYLXGDEBCWJWKWLWMWIYMYNXCBCYMYFRYQYHYNXCQYLYQWTYF
      YSWAWTYFYHYLYIWNXAXBWOWPVHWSWQWR $.

    $( The supremum of an unbounded-above set of extended reals is plus
       infinity.  (Contributed by NM, 19-Jan-2006.) $)
    supxrunb2 $p |- ( A C_ RR* -> ( A. x e. RR E. y e. A x < y <->
                    sup ( A , RR* , < ) = +oo ) ) $=
      ( vz vw cxr cv clt wbr wrex cr wral cpnf wceq wn wi wcel ralrimiv exp31
      wa csup ssel pnfnlt syl6 adantr breq1 rexbidv rspcva adantrr ancoms com4r
      wss a1dd com13 imp pnfxr supxr mpanl2 syldan ex rexr ad2antlr ltpnf breq2
      jca syl5ibr impcom adantll wor xrltso a1i ad2antrr suplub mp2and ralrimdv
      xrsupss com23 impbid ) CFULZAGZBGZHIZBCJZAKLZCFHUAZMNZVSWDWFVSWDMDGZHIOZD
      CLZWGMHIZWGWAHIZBCJZPZDKLZTZWFVSWDTZWIWNVSWIWDVSWHDCVSWGCQWGFQWHCFWGUBWGU
      CUDRUEWPWMDKVSWDWGKQZWMPWQWDVSWMWDVSWJWQWLWDVSWQWLPWJWDVSWQWLWQWDVSTWLWQW
      DWLVSWCWLAWGKVTWGNWBWKBCVTWGWAHUFUGUHUIUJSUMUKUNUORVEVSMFQWOWFUPDBCMUQURU
      SUTVSWFWCAKVSVTKQZWFWCVSWRWFWCVSWRTWFTZVTFQZVTWEHIZWCWRWTVSWFVTVAVBWRWFXA
      VSWFWRXAWRXAWFVTMHIVTVCWEMVTHVDVFVGVHWSDEBFCVTHFHVIWSVJVKVSWGEGZHIOECLXBW
      GHIXBWAHIBCJPEFLTDFJWRWFDEBCVPVLVMVNSVQVOVR $.

    $( The supremum of a bounded-above set of extended reals is less than
       infinity.  (Contributed by NM, 30-Jan-2006.) $)
    supxrbnd1 $p |- ( A C_ RR* -> ( E. x e. RR A. y e. A y < x <->
                    sup ( A , RR* , < ) < +oo ) ) $=
      ( cxr wss cv clt wbr wral cr wrex csup cpnf wn cle wceq ralnex wcel wa wb
      rexr ssel2 xrlenlt syl2anr an32s rexbidva rexnal syl6rbb ralbidva syl5bbr
      supxrunb1 supxrcl nltpnft syl 3bitrd con4bid ) CDEZBFZAFZGHZBCIZAJKZCDGLZ
      MGHZUQVBNZUSUROHZBCKZAJIZVCMPZVDNZVEVANZAJIUQVHVAAJQUQVKVGAJUQUSJRZSZVGUT
      NZBCKVKVMVFVNBCUQURCRZVLVFVNTZVLUSDRURDRVPUQVOSUSUACDURUBUSURUCUDUEUFUTBC
      UGUHUIUJABCUKUQVCDRVIVJTCULVCUMUNUOUP $.

    $( The supremum of a bounded-above set of extended reals is less than
       infinity.  (Contributed by NM, 30-Jan-2006.) $)
    supxrbnd2 $p |- ( A C_ RR* -> ( E. x e. RR A. y e. A y <_ x <->
                    sup ( A , RR* , < ) < +oo ) ) $=
      ( cxr wss cv cle wbr wral cr wrex clt csup cpnf wn wceq ralnex wcel wa wb
      ssel2 rexr xrlenlt con2bid syl2an an32s rexbidva syl6rbb ralbidva syl5bbr
      rexnal supxrunb2 supxrcl nltpnft syl 3bitrd con4bid ) CDEZBFZAFZGHZBCIZAJ
      KZCDLMZNLHZURVCOZUTUSLHZBCKZAJIZVDNPZVEOZVFVBOZAJIURVIVBAJQURVLVHAJURUTJR
      ZSZVHVAOZBCKVLVNVGVOBCURUSCRZVMVGVOTZURVPSUSDRZUTDRZVQVMCDUSUAUTUBVRVSSVA
      VGUSUTUCUDUEUFUGVABCUKUHUIUJABCULURVDDRVJVKTCUMVDUNUOUPUQ $.

    $( The supremum of an empty set under the extended reals is minus
       infinity.  (Contributed by NM, 15-Oct-2005.) $)
    xrsup0 $p |- sup ( (/) , RR* , < ) = -oo $=
      ( vy vz c0 cxr wss cmnf wcel cv clt wbr wn wral wrex wi cr csup 0ss mnfxr
      wceq ral0 rexr nltmnf syl pm2.21d rgen supxr mp4an ) CDEFDGFAHZIJKZACLUHF
      IJZUHBHIJBCMZNZAOLCDIPFSDQRUIATULAOUHOGZUJUKUMUHDGUJKUHUAUHUBUCUDUEABCFUF
      UG $.

    $( A member of a set of extended reals is less than or equal to the set's
       supremum.  (Contributed by NM, 7-Feb-2006.) $)
    supxrub $p |- ( ( A C_ RR* /\ B e. A ) -> B <_ sup ( A , RR* , < ) ) $=
      ( vx vy vz cxr wss wcel wa clt csup cle wbr wn wor xrltso a1i xrsupss imp
      supub wb ssel2 supxrcl adantr xrlenlt syl2anc mpbird ) AFGZBAHZIZBAFJKZLM
      ZUKBJMNZUHUIUMUHCDEFABJFJOUHPQCDEARTSUJBFHUKFHZULUMUAAFBUBUHUNUIAUCUDBUKU
      EUFUG $.

    $( The supremum of a set of extended reals is less than or equal to an
       upper bound.  (Contributed by Mario Carneiro, 13-Sep-2015.) $)
    supxrlub $p |- ( ( A C_ RR* /\ B e. RR* ) ->
                      ( B < sup ( A , RR* , < ) <-> E. x e. A B < x ) ) $=
      ( vy vz cxr wss clt wor xrltso a1i xrsupss id suplub2 ) BFGZDEAFBCHFHIOJK
      DEABLOMN $.

    $( The supremum of a set of extended reals is less than or equal to an
       upper bound.  (Contributed by NM, 22-Feb-2006.)  (Revised by Mario
       Carneiro, 6-Sep-2014.) $)
    supxrleub $p |- ( ( A C_ RR* /\ B e. RR* ) ->
                      ( sup ( A , RR* , < ) <_ B <-> A. x e. A x <_ B ) ) $=
      ( cxr wss wcel wa clt csup wbr wn cv wral cle wrex supxrlub notbid ralnex
      wb xrlenlt syl6bbr supxrcl sylan sselda simplr syl2anc ralbidva 3bitr4d
      simpl ) BDEZCDFZGZCBDHIZHJZKZCALZHJZKZABMZUMCNJZUPCNJZABMULUOUQABOZKUSULU
      NVBABCPQUQABRUAUJUMDFUKUTUOSBUBUMCTUCULVAURABULUPBFZGUPDFUKVAURSULBDUPUJU
      KUIUDUJUKVCUEUPCTUFUGUH $.

    $( The real and extended real suprema match when the real supremum exists.
       (Contributed by NM, 18-Oct-2005.)  (Proof shortened by Mario Carneiro,
       7-Sep-2014.) $)
    supxrre $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A y <_ x ) ->
                  sup ( A , RR* , < ) = sup ( A , RR , < ) ) $=
      ( vz cr wss cv cle wbr wral cxr clt csup wcel suprleub mpdan syl2anc cmnf
      wb syl wne wrex w3a wceq suprcl leidd simp1 ressxr syl6ss rexrd supxrleub
      c0 bitr4d mpbid supxrcl xrleid wex simp2 n0 sylib mnfxr a1i sselda adantr
      mnflt supxrub sylan xrltletrd exlimddv xrre syl22anc xrletri3 mpbir2and
      wa ) CEFZCULUAZBGAGZHIBCJAEUBZUCZCKLMZCELMZUDZVTWAHIZWAVTHIZVSWAWAHIZWCVS
      WAABCUEZUFVSWEDGZWAHIDCJZWCVSWAENZWEWHSWFABDCWAOPVSCKFZWAKNZWCWHSVSCEKVOV
      PVRUGZUHUIZVSWAWFUJZDCWAUKQUMUNZVSVTVTHIZWDVSVTKNZWPVSWJWQWMCUOTZVTUPTVSW
      PVQVTHIACJZWDVSWJWQWPWSSWMWRACVTUKQVSVTENZWDWSSVSWQWIRVTLIZWCWTWRWFVSWGCN
      ZXADVSVPXBDUQVOVPVRURDCUSUTVSXBVNZRWGVTRKNXCVAVBXCWGVSCEWGWLVCZUJVSWQXBWR
      VDXCWGENRWGLIXDWGVETVSWJXBWGVTHIWMCWGVFVGVHVIWOVTWAVJVKABACVTOPUMUNVSWQWK
      WBWCWDVNSWRWNVTWAVLQVM $.

    $( The supremum of a bounded-above nonempty set of reals is real.
       (Contributed by NM, 19-Jan-2006.) $)
    supxrbnd $p |- ( ( A C_ RR /\ A =/= (/) /\ sup ( A , RR* , < ) < +oo ) ->
                    sup ( A , RR* , < ) e. RR ) $=
      ( vy vx cr wss c0 wne cxr clt csup cpnf wbr cv cle wral wrex wa wn syl6bb
      wcel ressxr sstr mpan2 wi supxrcl pnfxr xrltne mp3an2 necomd ex supxrunb2
      syl wceq wb adantlr rexr ad2antlr xrlenlt con2bid syl2anc rexbidva rexnal
      ssel2 ralbidva bitr3d ralnex necon2abid sylibrd imp sylan 3adant2 supxrre
      w3a suprcl eqeltrd syld3an3 ) ADEZAFGZAHIJZKILZBMZCMZNLZBAOZCDPZVSDTVQVTW
      EVRVQAHEZVTWEVQDHEWFUAADHUBUCWFVTWEWFVTVSKGZWEWFVSHTZVTWGUDAUEWHVTWGWHVTQ
      KVSWHKHTVTKVSGUFVSKUGUHUIUJULWFWEVSKWFVSKUMZWDRZCDOZWERWFWBWAILZBAPZCDOWI
      WKCBAUKWFWMWJCDWFWBDTZQZWMWCRZBAPWJWOWLWPBAWOWAATZQWAHTZWBHTZWLWPUNWFWQWR
      WNAHWAVCUOWNWSWFWQWBUPUQWRWSQWCWLWAWBURUSUTVAWCBAVBSVDVEWDCDVFSVGVHVIVJVK
      VQVRWEVMVSADIJDCBAVLCBAVNVOVP $.

    $( The supremum of a nonempty set of reals is greater than minus infinity.
       (Contributed by NM, 2-Feb-2006.) $)
    supxrgtmnf $p |- ( ( A C_ RR /\ A =/= (/) ) ->
                     -oo < sup ( A , RR* , < ) ) $=
      ( cr wss c0 wne wa cxr clt csup wcel cpnf wceq wo cmnf wn supxrbnd 3expia
      wbr con3d syl wb ressxr sstr mpan2 supxrcl adantr nltpnft sylibrd mnfltxr
      orrd ) ABCZADEZFZAGHIZBJZUNKLZMNUNHRUMUOUPUMUOOUNKHRZOZUPUMUQUOUKULUQUOAP
      QSUMUNGJZUPURUAUKUSULUKAGCZUSUKBGCUTUBABGUCUDAUETUFUNUGTUHUJUNUIT $.

    $( The supremum of a nonempty set of reals is real iff it is less than plus
       infinity.  (Contributed by NM, 5-Feb-2006.) $)
    supxrre1 $p |- ( ( A C_ RR /\ A =/= (/) ) ->
            ( sup ( A , RR* , < ) e. RR <-> sup ( A , RR* , < ) < +oo ) ) $=
      ( cr wss c0 wne wa cxr clt csup wcel cmnf wbr cpnf wb ressxr sstr supxrcl
      mpan2 xrrebnd 3syl adantr supxrgtmnf biantrurd bitr4d ) ABCZADEZFZAGHIZBJ
      ZKUHHLZUHMHLZFZUKUEUIULNZUFUEAGCZUHGJUMUEBGCUNOABGPRAQUHSTUAUGUJUKAUBUCUD
      $.

    $( The supremum of a nonempty set of reals is real iff it is not plus
       infinity.  (Contributed by NM, 5-Feb-2006.) $)
    supxrre2 $p |- ( ( A C_ RR /\ A =/= (/) ) ->
            ( sup ( A , RR* , < ) e. RR <-> sup ( A , RR* , < ) =/= +oo ) ) $=
      ( cr wss c0 wne wa cxr clt csup wcel cpnf supxrre1 wb wceq wn ressxr sstr
      wbr mpan2 supxrcl nltpnft 3syl necon2abid adantr bitrd ) ABCZADEZFAGHIZBJ
      UHKHRZUHKEZALUFUIUJMUGUFUIUHKUFAGCZUHGJUHKNUIOMUFBGCUKPABGQSATUHUAUBUCUDU
      E $.

    $( Smaller sets of extended reals have smaller suprema.  (Contributed by
       Mario Carneiro, 1-Apr-2015.) $)
    supxrss $p |- ( ( A C_ B /\ B C_ RR* ) ->
        sup ( A , RR* , < ) <_ sup ( B , RR* , < ) ) $=
      ( vx wss cxr wa clt csup cle wbr cv wral wcel simplr simpl sselda supxrub
      syl2anc ralrimiva wb sstr supxrcl adantl supxrleub mpbird ) ABDZBEDZFZAEG
      HBEGHZIJZCKZUIIJZCALZUHULCAUHUKAMZFUGUKBMULUFUGUNNUHABUKUFUGOPBUKQRSUHAED
      UIEMZUJUMTABEUAUGUOUFBUBUCCAUIUDRUE $.

    $( A member of a set of extended reals is greater than or equal to the
       set's infimum.  (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    infmxrlb $p |- ( ( A C_ RR* /\ B e. A ) -> sup ( A , RR* , `' < ) <_ B ) $=
      ( vx vy vz cxr wss wcel wa clt ccnv csup cle wbr wn wor xrltso cnvso mpbi
      wb a1i xrinfmss2 supub infmxrcl brcnvg sylan mtbid adantr xrlenlt syl2anc
      imp ssel2 mpbird ) AFGZBAHZIZAFJKZLZBMNZBURJNZOZUPURBUQNZUTUNUOVBOUNCDEFA
      BUQFUQPZUNFJPVCQFJRSUACDEAUBUCUKUNURFHZUOVBUTTAUDZURBFAJUEUFUGUPVDBFHUSVA
      TUNVDUOVEUHAFBULURBUIUJUM $.

    $( The infimum of a set of extended reals is greater than or equal to a
       lower bound.  (Contributed by Mario Carneiro, 16-Mar-2014.)  (Revised by
       Mario Carneiro, 6-Sep-2014.) $)
    infmxrgelb $p |- ( ( A C_ RR* /\ B e. RR* ) ->
                     ( B <_ sup ( A , RR* , `' < ) <-> A. x e. A B <_ x ) ) $=
      ( vy vz cxr wcel wa clt wbr wn wral cle wrex wor id cvv wb brcnvg sylancl
      wss ccnv csup xrltso cnvso mpbi a1i xrinfmss2 suplub2 simpr supex rexbidv
      cv vex 3bitr3d notbid ralnex syl6bbr infmxrcl xrlenlt simplr simpl sselda
      syl2anr syl2anc ralbidva 3bitr4d ) BFUAZCFGZHZBFIUBZUCZCIJZKZAUMZCIJZKZAB
      LZCVLMJZCVOMJZABLVJVNVPABNZKVRVJVMWAVJCVLVKJZCVOVKJZABNVMWAVHDEAFBCVKFVKO
      ZVHFIOWDUDFIUEUFZUGDEABUHVHPUIVJVIVLQGWBVMRVHVIUJZFBVKWEUKCVLFQISTVJWCVPA
      BVJVIVOQGWCVPRWFAUNCVOFQISTULUOUPVPABUQURVIVIVLFGVSVNRVHVIPBUSCVLUTVDVJVT
      VQABVJVOBGZHVIVOFGVTVQRVHVIWGVAVJBFVOVHVIVBVCCVOUTVEVFVG $.

    $( The real and extended real infima match when the real infimum exists.
       (Contributed by Mario Carneiro, 7-Sep-2014.) $)
    infmxrre $p |- ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y ) ->
                  sup ( A , RR* , `' < ) = sup ( A , RR , `' < ) ) $=
      ( vz cr wss cv cle wbr wral cxr clt csup wcel syl infmxrgelb syl2anc cmnf
      wb wa c0 wne wrex w3a ccnv wceq simp1 ressxr syl6ss infmxrcl xrleid simp2
      wex n0 sylib adantr sselda mnfxr a1i infmrcl rexrd mnflt infmrgelb bitr4d
      leidd mpdan mpbid xrltletrd infmxrlb syl22anc exlimddv xrletri3 mpbir2and
      sylan xrre ) CEFZCUAUBZAGZBGHIBCJAEUCZUDZCKLUEZMZCEWAMZUFZWBWCHIZWCWBHIZV
      TWBWBHIZWEVTWBKNZWGVTCKFZWHVTCEKVPVQVSUGZUHUIZCUJOZWBUKOVTWGWBVRHIACJZWEV
      TWIWHWGWMSWKWLACWBPQVTWBENZWEWMSVTDGZCNZWNDVTVQWPDUMVPVQVSULDCUNUOVTWPTWH
      WOENRWBLIZWBWOHIZWNVTWHWPWLUPVTCEWOWJUQVTWQWPVTRWCWBRKNVTURUSVTWCABCUTZVA
      ZWLVTWCENZRWCLIWSWCVBOVTWCWCHIZWFVTWCWSVEVTXBWCVRHIACJZWFVTXAXBXCSWSABACW
      CVCVFVTWIWCKNZWFXCSWKWTACWCPQVDVGZVHUPVTWIWPWRWKCWOVIVNWBWOVOVJVKABACWBVC
      VFVDVGXEVTWHXDWDWEWFTSWLWTWBWCVLQVM $.

    $( The infimum of the empty set under the extended reals is positive
       infinity.  (Contributed by Mario Carneiro, 21-Apr-2015.) $)
    xrinfm0 $p |- sup ( (/) , RR* , `' < ) = +oo $=
      ( vy vz cxr clt ccnv csup cpnf wceq wtru wor xrltso cnvso mpbi wcel pnfxr
      c0 a1i cv wbr adantl wn noel pm2.21i wrex vex elexi pnfnlt pm2.21d syl5bi
      wa brcnv imp eqsupd trud ) PCDEZFGHIABCPGUOCUOJZICDJUPKCDLMQGCNIOQARZPNZG
      UQUOSUAZIURUSUQUBUCTUQCNZUQGUOSZUJUQBRUOSBPUDZIUTVAVBVAGUQDSZUTVBUQGDAUEG
      COUFUKUTVCVBUQUGUHUIULTUMUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Real number intervals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c (,) $.
  $c (,] $.
  $c [,) $.
  $c [,] $.

  $( Extend class notation with the set of open intervals of extended reals. $)
  cioo $a class (,) $.

  $( Extend class notation with the set of open-below, closed-above intervals
     of extended reals. $)
  cioc $a class (,] $.

  $( Extend class notation with the set of closed-below, open-above intervals
     of extended reals. $)
  cico $a class [,) $.

  $( Extend class notation with the set of closed intervals of extended
     reals. $)
  cicc $a class [,] $.

  ${
    $d x y z $.
    $( Define the set of open intervals of extended reals.  (Contributed by NM,
       24-Dec-2006.) $)
    df-ioo $a |- (,) = ( x e. RR* , y e. RR* |->
                   { z e. RR* | ( x < z /\ z < y ) } ) $.

    $( Define the set of open-below, closed-above intervals of extended reals.
       (Contributed by NM, 24-Dec-2006.) $)
    df-ioc $a |- (,] = ( x e. RR* , y e. RR* |->
                   { z e. RR* | ( x < z /\ z <_ y ) } ) $.

    $( Define the set of closed-below, open-above intervals of extended reals.
       (Contributed by NM, 24-Dec-2006.) $)
    df-ico $a |- [,) = ( x e. RR* , y e. RR* |->
                   { z e. RR* | ( x <_ z /\ z < y ) } ) $.

    $( Define the set of closed intervals of extended reals.  (Contributed by
       NM, 24-Dec-2006.) $)
    df-icc $a |- [,] = ( x e. RR* , y e. RR* |->
                   { z e. RR* | ( x <_ z /\ z <_ y ) } ) $.
  $}

  ${
    $d b w x y z A $.  $d w x y z C $.  $d w x y z D $.  $d b w O $.  $d w Q $.
    $d b w x y z B $.  $d b w P $.  $d x y z R $.  $d x y z S $.  $d x y z T $.
    $d x y z U $.  $d w V $.  $d w W $.  $d w X $.
    ixx.1 $e |- O = ( x e. RR* , y e. RR* |->
                   { z e. RR* | ( x R z /\ z S y ) } ) $.
    $( Value of the interval function.  (Contributed by Mario Carneiro,
       3-Nov-2013.) $)
    ixxval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A O B ) =
                 { z e. RR* | ( A R z /\ z S B ) } ) $=
      ( cxr cv wbr wa crab wceq breq1 anbi1d rabbidv breq2 anbi2d rabex ovmpt2
      xrex ) ABDEJJAKZCKZFLZUEBKZGLZMZCJNDUEFLZUEEGLZMZCJNHUJUHMZCJNUDDOZUIUMCJ
      UNUFUJUHUDDUEFPQRUGEOZUMULCJUOUHUKUJUGEUEGSTRIULCJUCUAUB $.

    $( Membership in an interval of extended reals.  (Contributed by Mario
       Carneiro, 3-Nov-2013.) $)
    elixx1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A O B ) <->
                 ( C e. RR* /\ A R C /\ C S B ) ) ) $=
      ( cxr wcel wa co cv wbr crab w3a ixxval eleq2d breq2 breq1 anbi12d 3anass
      wceq elrab bitr4i syl6bb ) DKLEKLMZFDEINZLFDCOZGPZUKEHPZMZCKQZLZFKLZDFGPZ
      FEHPZRZUIUJUOFABCDEGHIJSTUPUQURUSMZMUTUNVACFKUKFUEULURUMUSUKFDGUAUKFEHUBU
      CUFUQURUSUDUGUH $.

    $( The set of intervals of extended reals maps to subsets of extended
       reals.  (Contributed by FL, 14-Jun-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.) $)
    ixxf $p |- O : ( RR* X. RR* ) --> ~P RR* $=
      ( cv wbr wa cxr crab cpw wcel wral cxp wf wss ssrab2 xrex elpw2 rgen2w
      mpbir fmpt2 mpbi ) AHCHZDIUFBHEIJZCKLZKMZNZBKOAKOKKPUIFQUJABKKUJUHKRUGCKS
      UHKTUAUCUBABKKUHUIFGUDUE $.

    $( The set of intervals of extended reals exists.  (Contributed by Mario
       Carneiro, 3-Nov-2013.)  (Revised by Mario Carneiro, 17-Nov-2014.) $)
    ixxex $p |- O e. _V $=
      ( cxr cxp cpw xrex xpex pwex wf wss ixxf fssxp ax-mp ssexi ) FHHIZHJZIZTU
      AHHKKLHKMLTUAFNFUBOABCDEFGPTUAFQRS $.

    $( The set of intervals of extended reals maps to subsets of extended
       reals.  (Contributed by Mario Carneiro, 4-Jul-2014.) $)
    ixxssxr $p |- ( A O B ) C_ RR* $=
      ( co cxr cpw wcel wss cop cfv df-ov cxp ixxf 0elpw eqeltri ovex elpw mpbi
      f0cli ) DEHJZKLZMUFKNUFDEOZHPUGDEHQKKRUGUHHABCFGHISKTUEUAUFKDEHUBUCUD $.

    $( Membership in a set of open intervals of extended reals.  We use the
       fact that an operation's value is empty outside of its domain to show
       ` A e. RR* ` and ` B e. RR* ` .  (Contributed by Mario Carneiro,
       3-Nov-2013.) $)
    elixx3g $p |- ( C e. ( A O B ) <->
          ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ ( A R C /\ C S B ) ) ) $=
      ( cxr wcel wa wbr w3a co anass df-3an bitrd c0 anbi1i wb elixx1 3anass wn
      ibar syl5bb cxp cpw ixxf fdmi ndmov eleq2d pm2.21i simpl pm5.21ni pm2.61i
      noel 3bitr4ri ) DKLZEKLZMZFKLZMZDFGNZFEHNZMZMVBVCVGMZMZUTVAVCOZVGMFDEIPZL
      ZVBVCVGQVJVDVGUTVAVCRUAVBVLVIUBVBVLVCVEVFOZVIABCDEFGHIJUCVMVHVBVIVCVEVFUD
      VBVHUFUGSVBUEZVLFTLZVIVNVKTFDEKIKKUHKUIIABCGHIJUJUKULUMVOVBVIVOVBFURUNVBV
      HUOUPSUQUS $.

    ${
      ixx.2 $e |- P = ( x e. RR* , y e. RR* |->
                       { z e. RR* | ( x T z /\ z U y ) } ) $.
      ixx.3 $e |- ( ( A e. RR* /\ w e. RR* ) -> ( A R w -> A T w ) ) $.
      ixx.4 $e |- ( ( w e. RR* /\ B e. RR* ) -> ( w S B -> w U B ) ) $.
      $( An interval is a subset of its closure.  (Contributed by Paul Chapman,
         18-Oct-2007.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
      ixxssixx $p |- ( A O B ) C_ ( A P B ) $=
        ( cxr wcel wa wbr co cv crab elmpt2cl w3a wi simp1 simpl 3simpa expimpd
        a1i syl2im simpr 3simpb ancoms 3jcad elixx1 3imtr4d mpcom ssriv ) DEFLU
        AZEFGUAZEQRZFQRZSZDUBZVARZVFVBRZABQQAUBCUBZHTVIBUBITSCQUCEFLVFMUDVEVFQR
        ZEVFHTZVFFITZUEZVJEVFJTZVFFKTZUEVGVHVEVMVJVNVOVMVJUFVEVJVKVLUGUKVEVCVMV
        JVKSVNVCVDUHVJVKVLUIVCVJVKVNOUJULVEVDVMVJVLSVOVCVDUMVJVKVLUNVDVJVLVOVJV
        DVLVOUFPUOUJULUPABCEFVFHILMUQABCEFVFJKGNUQURUSUT $.
    $}

    ${
      ixxun.2 $e |- P = ( x e. RR* , y e. RR* |->
                         { z e. RR* | ( x T z /\ z U y ) } ) $.
      ixxun.3 $e |- ( ( B e. RR* /\ w e. RR* ) -> ( B T w <-> -. w S B ) ) $.
      $( Split an interval into disjoint pieces.  (Contributed by Mario
         Carneiro, 16-Jun-2014.) $)
      ixxdisj $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
                      ( ( A O B ) i^i ( B P C ) ) = (/) ) $=
        ( cxr wcel c0 wbr w3a co cin wss wceq elin elixx1 3adant3 biimpa simp3d
        cv wa wb adantrr wn 3adant1 simp2d simpl2 simp1d syl2anc mpbid pm2.65da
        adantrl pm2.21d syl5bi ssrdv ss0 syl ) EQRZFQRZGQRZUAZEFMUBZFGHUBZUCZSU
        DVOSUEVLDVOSDUKZVORVPVMRZVPVNRZULZVLVPSRZVPVMVNUFVLVSVTVLVSVPFJTZVLVQWA
        VRVLVQULVPQRZEVPITZWAVLVQWBWCWAUAZVIVJVQWDUMVKABCEFVPIJMNUGUHUIUJUNVLVR
        WAUOZVQVLVRULZFVPKTZWEWFWBWGVPGLTZVLVRWBWGWHUAZVJVKVRWIUMVIABCFGVPKLHOU
        GUPUIZUQWFVJWBWGWEUMVIVJVKVRURWFWBWGWHWJUSPUTVAVCVBVDVEVFVOVGVH $.

      ixxun.4 $e |- Q = ( x e. RR* , y e. RR* |->
                         { z e. RR* | ( x R z /\ z U y ) } ) $.
      ixxun.5 $e |- ( ( w e. RR* /\ B e. RR* /\ C e. RR* ) ->
                      ( ( w S B /\ B X C ) -> w U C ) ) $.
      ixxun.6 $e |- ( ( A e. RR* /\ B e. RR* /\ w e. RR* ) ->
                      ( ( A W B /\ B T w ) -> A R w ) ) $.
      $( Split an interval into two parts.  (Contributed by Mario Carneiro,
         16-Jun-2014.) $)
      ixxun $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
                      ( A W B /\ B X C ) ) ->
                    ( ( A O B ) u. ( B P C ) ) = ( A Q C ) ) $=
        ( cxr wcel w3a wbr wa co cun cv wo elun wb simpl1 simpl2 elixx1 syl2anc
        biimpa simp1d simp2d simp3d simplrr adantr simpl3 syl3anc mp2and jaodan
        wi 3jca simplrl biimpar syldan exmid df-3an syl6bb jca biantrurd bitr4d
        wn 3anan12 biantrud 3bitr2d orbi12d mpbiri impbida syl5bb eqrdv ) EUCUD
        ZFUCUDZGUCUDZUEZEFOUFZFGPUFZUGZUGZDEFNUHZFGHUHZUIZEGIUHZDUJZWRUDWTWPUDZ
        WTWQUDZUKZWOWTWSUDZWTWPWQULWOXCXDWOXCWTUCUDZEWTJUFZWTGMUFZUEZXDWOXAXHXB
        WOXAUGZXEXFXGXIXEXFWTFKUFZWOXAXEXFXJUEZWOWHWIXAXKUMWHWIWJWNUNZWHWIWJWNU
        OZABCEFWTJKNQUPUQZURZUSZXIXEXFXJXOUTXIXJWMXGXIXEXFXJXOVAWKWLWMXAVBXIXEW
        IWJXJWMUGXGVHXPWOWIXAXMVCWOWJXAWHWIWJWNVDZVCUAVEVFVIWOXBUGZXEXFXGXRXEFW
        TLUFZXGWOXBXEXSXGUEZWOWIWJXBXTUMXMXQABCFGWTLMHRUPUQZURZUSZXRWLXSXFWKWLW
        MXBVJXRXEXSXGYBUTXRWHWIXEWLXSUGXFVHWOWHXBXLVCWOWIXBXMVCYCUBVEVFXRXEXSXG
        YBVAVIVGWOXDXHWOWHWJXDXHUMXLXQABCEGWTJMITUPUQZVKVLWOXDUGZXCXJXJVSZUKXJV
        MYEXAXJXBYFYEXAXEXFUGZXJUGZXJWOXAYHUMXDWOXAXKYHXNXEXFXJVNVOVCYEYGXJYEXE
        XFYEXEXFXGWOXDXHYDURZUSZYEXEXFXGYIUTVPVQVRYEXBXSXEXGUGZUGZXSYFWOXBYLUMX
        DWOXBXTYLYAXEXSXGVTVOVCYEYKXSYEXEXGYJYEXEXFXGYIVAVPWAYEWIXEXSYFUMWOWIXD
        XMVCYJSUQWBWCWDWEWFWG $.
    $}

    ${
      ixxin.2 $e |- ( ( A e. RR* /\ C e. RR* /\ z e. RR* ) ->
        ( if ( A <_ C , C , A ) R z <-> ( A R z /\ C R z ) ) ) $.
      ixxin.3 $e |- ( ( z e. RR* /\ B e. RR* /\ D e. RR* ) ->
        ( z S if ( B <_ D , B , D ) <-> ( z S B /\ z S D ) ) ) $.
      $( Intersection of two intervals of extended reals.  (Contributed by
         Mario Carneiro, 3-Nov-2013.) $)
      ixxin $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) ) ->
          ( ( A O B ) i^i ( C O D ) ) =
            ( if ( A <_ C , C , A ) O if ( B <_ D , B , D ) ) ) $=
        ( cxr wcel wa co wbr crab ixxval cin cle cif cv inrab ineqan12d wceq wb
        3expa adantlr 3expb ancoms adantll anbi12d an4 syl6bbr rabbidva 3eqtr4a
        an4s ifcl syl2an eqtr4d ) DNOZENOZPZFNOZGNOZPZPZDEJQZFGJQZUAZDFUBRZFDUC
        ZCUDZHRZVOEGUBRZEGUCZIRZPZCNSZVNVRJQZVIDVOHRZVOEIRZPZCNSZFVOHRZVOGIRZPZ
        CNSZUAWEWIPZCNSZVLWAWEWICNUEVEVHVJWFVKWJABCDEHIJKTABCFGHIJKTUFVCVFVDVGW
        AWLUGVCVFPZVDVGPZPZVTWKCNWOVONOZPZVTWCWGPZWDWHPZPWKWQVPWRVSWSWMWPVPWRUH
        ZWNVCVFWPWTLUIUJWNWPVSWSUHZWMWPWNXAWPVDVGXAMUKULUMUNWCWDWGWHUOUPUQUSURV
        CVFVDVGWBWAUGZWMVNNOZVRNOXBWNVFVCXCVMFDNUTULVQEGNUTABCVNVRHIJKTVAUSVB
        $.
    $}

    ${
      ixxss1.2 $e |- P = ( x e. RR* , y e. RR* |->
                         { z e. RR* | ( x T z /\ z S y ) } ) $.
      ixxss1.3 $e |- ( ( A e. RR* /\ B e. RR* /\ w e. RR* ) ->
                       ( ( A W B /\ B T w ) -> A R w ) ) $.
      $( Subset relationship for intervals of extended reals.  (Contributed by
         Mario Carneiro, 3-Nov-2013.)  (Revised by Mario Carneiro,
         28-Apr-2015.) $)
      ixxss1 $p |- ( ( A e. RR* /\ A W B ) ->
                   ( B P C ) C_ ( A O C ) ) $=
        ( cxr wcel wbr wa co cv w3a elixx3g simplbi adantl simp3d simplr simpld
        simprbi wi simpll simp1d syl3anc mp2and simprd wb simp2d elixx1 syl2anc
        mpbir3and ex ssrdv ) EQRZEFMSZTZDFGHUAZEGLUAZVFDUBZVGRZVIVHRZVFVJTZVKVI
        QRZEVIISZVIGJSZVLFQRZGQRZVMVJVPVQVMUCZVFVJVRFVIKSZVOTZABCFGVIKJHOUDZUEU
        FZUGZVLVEVSVNVDVEVJUHVLVSVOVJVTVFVJVRVTWAUJUFZUIVLVDVPVMVEVSTVNUKVDVEVJ
        ULZVLVPVQVMWBUMWCPUNUOVLVSVOWDUPVLVDVQVKVMVNVOUCUQWEVLVPVQVMWBURABCEGVI
        IJLNUSUTVAVBVC $.
    $}

    ${
      ixxss2.2 $e |- P = ( x e. RR* , y e. RR* |->
                         { z e. RR* | ( x R z /\ z T y ) } ) $.
      ixxss2.3 $e |- ( ( w e. RR* /\ B e. RR* /\ C e. RR* ) ->
                       ( ( w T B /\ B W C ) -> w S C ) ) $.
      $( Subset relationship for intervals of extended reals.  (Contributed by
         Mario Carneiro, 3-Nov-2013.)  (Revised by Mario Carneiro,
         28-Apr-2015.) $)
      ixxss2 $p |- ( ( C e. RR* /\ B W C ) ->
                   ( A P B ) C_ ( A O C ) ) $=
        ( cxr wcel wbr wa co cv w3a elixx3g simplbi adantl simp3d simpld simprd
        simprbi simplr wi simp2d simpll syl3anc mp2and wb simp1d elixx1 syl2anc
        mpbir3and ex ssrdv ) GQRZFGMSZTZDEFHUAZEGLUAZVFDUBZVGRZVIVHRZVFVJTZVKVI
        QRZEVIISZVIGJSZVLEQRZFQRZVMVJVPVQVMUCZVFVJVRVNVIFKSZTZABCEFVIIKHOUDZUEU
        FZUGZVLVNVSVJVTVFVJVRVTWAUJUFZUHVLVSVEVOVLVNVSWDUIVDVEVJUKVLVMVQVDVSVET
        VOULWCVLVPVQVMWBUMVDVEVJUNZPUOUPVLVPVDVKVMVNVOUCUQVLVPVQVMWBURWEABCEGVI
        IJLNUSUTVAVBVC $.
    $}

    ${
      ixxss12.2 $e |- P = ( x e. RR* , y e. RR* |->
                         { z e. RR* | ( x T z /\ z U y ) } ) $.
      ixxss12.3 $e |- ( ( A e. RR* /\ C e. RR* /\ w e. RR* ) ->
                        ( ( A W C /\ C T w ) -> A R w ) ) $.
      ixxss12.4 $e |- ( ( w e. RR* /\ D e. RR* /\ B e. RR* ) ->
                        ( ( w U D /\ D X B ) -> w S B ) ) $.
      $( Subset relationship for intervals of extended reals.  (Contributed by
         Mario Carneiro, 20-Feb-2015.)  (Revised by Mario Carneiro,
         28-Apr-2015.) $)
      ixxss12 $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( A W C /\ D X B ) ) ->
        ( C P D ) C_ ( A O B ) ) $=
        ( cxr wa wbr co cv elixx3g simplbi adantl simp3d simplrl simprbi simpld
        wcel w3a wi simplll simp1d syl3anc mp2and simprd simplrr simp2d simpllr
        wb elixx1 ad2antrr mpbir3and ex ssrdv ) EUAUMZFUAUMZUBZEGOUCZHFPUCZUBZU
        BZDGHIUDZEFNUDZVPDUEZVQUMZVSVRUMZVPVTUBZWAVSUAUMZEVSJUCZVSFKUCZWBGUAUMZ
        HUAUMZWCVTWFWGWCUNZVPVTWHGVSLUCZVSHMUCZUBZABCGHVSLMIRUFZUGUHZUIZWBVMWIW
        DVLVMVNVTUJWBWIWJVTWKVPVTWHWKWLUKUHZULWBVJWFWCVMWIUBWDUOVJVKVOVTUPWBWFW
        GWCWMUQWNSURUSWBWJVNWEWBWIWJWOUTVLVMVNVTVAWBWCWGVKWJVNUBWEUOWNWBWFWGWCW
        MVBVJVKVOVTVCTURUSVLWAWCWDWEUNVDVOVTABCEFVSJKNQVEVFVGVHVI $.
    $}

    ${
      ixxub.2 $e |- ( ( w e. RR* /\ B e. RR* ) -> ( w < B -> w S B ) ) $.
      ixxub.3 $e |- ( ( w e. RR* /\ B e. RR* ) -> ( w S B -> w <_ B ) ) $.
      ixxub.4 $e |- ( ( A e. RR* /\ w e. RR* ) -> ( A < w -> A R w ) ) $.
      ixxub.5 $e |- ( ( A e. RR* /\ w e. RR* ) -> ( A R w -> A <_ w ) ) $.
      $( Extract the upper bound of an interval.  (Contributed by Mario
         Carneiro, 17-Jun-2014.) $)
      ixxub $p |- ( ( A e. RR* /\ B e. RR* /\ ( A O B ) =/= (/) ) ->
                   sup ( ( A O B ) , RR* , < ) = B ) $=
        ( cxr wcel cle wbr syl2anc ad2antrr co c0 wne w3a clt csup wceq cv wral
        wa wb elixx1 3adant3 biimpa simp3d wi simp1d simp2 adantr mpd ralrimiva
        wss ex ssrdv supxrleub mpbird wn wrex simprl qre rexrd ad2antlr supxrcl
        cq simp1 syl wex simp3 n0 sylib simp2d supxrub sylan exlimddv xrlelttrd
        xrletrd simprr mpbir3and xrlenlt mpbid pm2.65da nrexdv qbtwnxr xrletri3
        3expia mtod mpbir2and ) EOPZFOPZEFIUAZUBUCZUDZWTOUEUFZFUGZXCFQRZFXCQRZX
        BXEDUHZFQRZDWTUIZXBXHDWTXBXGWTPZUJZXGFHRZXHXKXGOPZEXGGRZXLXBXJXMXNXLUDZ
        WRWSXJXOUKZXAABCEFXGGHIJULUMZUNZUOXKXMWSXLXHUPXKXMXNXLXRUQZXBWSXJWRWSXA
        URZUSLSUTVAXBWTOVBZWSXEXIUKXBDWTOXBXJXMXSVCVDZXTDWTFVESVFXBXFXCFUERZVGZ
        XBYCXCXGUERZXGFUERZUJZDVNVHZXBYGDVNXBXGVNPZUJZYGYEYJYEYFVIZYJYGUJZXGXCQ
        RZYEVGZYLYAXJYMXBYAYIYGYBTYLXJXMXNXLYIXMXBYGYIXGXGVJVKVLZYLEXGUERZXNYLE
        XCXGXBWRYIYGWRWSXAVOZTZXBXCOPZYIYGXBYAYSYBWTVMVPZTZYOXBEXCQRZYIYGXBXJUU
        BDXBXAXJDVQWRWSXAVRDWTVSVTXKEXGXCXBWRXJYQUSZXSXBYSXJYTUSXKXNEXGQRZXKXMX
        NXLXRWAXKWRXMXNUUDUPUUCXSNSUTXBYAXJYMYBWTXGWBZWCWFWDTYKWEYLWRXMYPXNUPYR
        YOMSUTYLYFXLYJYEYFWGYLXMWSYFXLUPYOXBWSYIYGXTTKSUTXBXPYIYGXQTWHUUESYLXMY
        SYMYNUKYOUUAXGXCWISWJWKWLXBYSWSYCYHUPYTXTYSWSYCYHDXCFWMWOSWPXBWSYSXFYDU
        KXTYTFXCWISVFXBYSWSXDXEXFUJUKYTXTXCFWNSWQ $.

      $( Extract the lower bound of an interval.  (Contributed by Mario
         Carneiro, 17-Jun-2014.) $)
      ixxlb $p |- ( ( A e. RR* /\ B e. RR* /\ ( A O B ) =/= (/) ) ->
                   sup ( ( A O B ) , RR* , `' < ) = A ) $=
        ( cxr wcel clt cle wbr syl2anc co c0 wne w3a ccnv csup wceq wn cv wa cq
        wrex simprr wss wb elixx1 3adant3 biimpa simp1d ex ssrdv ad2antrr rexrd
        qre ad2antlr simprl wi simp1 mpd infmxrcl simpll2 simp3 n0 sylib adantr
        syl wex simpl2 infmxrlb sylan simp3d xrletrd exlimddv xrltletrd xrlenlt
        mpbir3and mpbid nrexdv qbtwnxr 3expia mtod mpbird wral simp2d ralrimiva
        pm2.65da infmxrgelb xrletri3 mpbir2and ) EOPZFOPZEFIUAZUBUCZUDZXBOQUEUF
        ZEUGZXEERSZEXERSZXDXGEXEQSZUHZXDXIEDUIZQSZXKXEQSZUJZDUKULZXDXNDUKXDXKUK
        PZUJZXNXMXQXLXMUMZXQXNUJZXEXKRSZXMUHZXSXBOUNZXKXBPZXTXDYBXPXNXDDXBOXDYC
        XKOPZXDYCUJZYDEXKGSZXKFHSZXDYCYDYFYGUDZWTXAYCYHUOZXCABCEFXKGHIJUPUQZURZ
        USZUTVAZVBXSYCYDYFYGXPYDXDXNXPXKXKVDVCVEZXSXLYFXQXLXMVFXSWTYDXLYFVGXDWT
        XPXNWTXAXCVHZVBYNMTVIXSXKFQSZYGXSXKXEFYNXDXEOPZXPXNXDYBYQYMXBVJVPZVBZWT
        XAXCXPXNVKZXRXDXEFRSZXPXNXDYCUUADXDXCYCDVQWTXAXCVLDXBVMVNYEXEXKFXDYQYCY
        RVOYLWTXAXCYCVRZXDYBYCXTYMXBXKVSZVTYEYGXKFRSZYEYDYFYGYKWAYEYDXAYGUUDVGY
        LUUBLTVIWBWCVBWDXSYDXAYPYGVGYNYTKTVIXDYIXPXNYJVBWFUUCTXSYQYDXTYAUOYSYNX
        EXKWETWGWPWHXDWTYQXIXOVGYOYRWTYQXIXODEXEWIWJTWKXDYQWTXGXJUOYRYOXEEWETWL
        XDXHEXKRSZDXBWMZXDUUEDXBYEYFUUEYEYDYFYGYKWNYEWTYDYFUUEVGXDWTYCYOVOYLNTV
        IWOXDYBWTXHUUFUOYMYODXBEWQTWLXDYQWTXFXGXHUJUOYRYOXEEWRTWS $.
    $}
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.  $d x y z D $.
    $( The set of open intervals of extended reals exists.  (Contributed by NM,
       6-Feb-2007.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iooex $p |- (,) e. _V $=
      ( vx vy vz clt cioo df-ioo ixxex ) ABCDDEABCFG $.

    $( Value of the open interval function.  (Contributed by NM, 24-Dec-2006.)
       (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iooval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) =
                 { x e. RR* | ( A < x /\ x < B ) } ) $=
      ( vy vz clt cioo df-ioo ixxval ) DEABCFFGDEAHI $.

    $( An empty open interval of extended reals.  (Contributed by NM,
       6-Feb-2007.) $)
    ioo0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A (,) B ) = (/) <->
                 B <_ A ) ) $=
      ( vx cxr wcel wa cioo co c0 wceq cv clt wbr crab cle iooval wn wrex bitrd
      cq eqeq1d wne df-ne rabn0 bitr3i wi xrlttr 3com23 3expa rexlimdva qbtwnxr
      w3a qre rexrd anim1i reximi2 syl 3expia impbid syl5bb xrltnle con4bid ) A
      DEZBDEZFZABGHZIJACKZLMVGBLMFZCDNZIJZBAOMZVEVFVIICABPUAVEVJVKVEVJQZABLMZVK
      QVLVHCDRZVEVMVLVIIUBVNVIIUCVHCDUDUEVEVNVMVEVHVMCDVCVDVGDEZVHVMUFZVCVOVDVP
      AVGBUGUHUIUJVCVDVMVNVCVDVMULVHCTRVNCABUKVHVHCTDVGTEZVOVHVQVGVGUMUNUOUPUQU
      RUSUTABVASVBS $.

    $( An open interval of extended reals is nonempty iff the lower argument is
       less than the upper argument.  (Contributed by NM, 2-Mar-2007.) $)
    ioon0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A (,) B ) =/= (/) <->
                 A < B ) ) $=
      ( cxr wcel wa clt wbr cioo co c0 wceq cle wn wb xrlenlt ancoms necon1abid
      ioo0 bitr2d ) ACDZBCDZEZABFGZABHIZJUBUDJKBALGZUCMZABRUATUEUFNBAOPSQ $.

    $( The open interval function's value is empty outside of its domain.
       (Contributed by NM, 21-Jun-2007.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    ndmioo $p |- ( -. ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) = (/) ) $=
      ( vx vy vz cxr cioo cxp cpw clt df-ioo ixxf fdmi ndmov ) ABFGFFHFIGCDEJJG
      CDEKLMN $.

    $( An open interval with identical lower and upper bounds is empty.
       (Contributed by NM, 21-Jun-2007.)  (Revised by Mario Carneiro,
       3-Nov-2013.) $)
    iooid $p |- ( A (,) A ) = (/) $=
      ( cxr wcel wa cioo co c0 wceq cle wbr xrleid adantr mpbird ndmioo pm2.61i
      ioo0 ) ABCZQDZAAEFGHZRSAAIJZQTQAKLAAPMAANO $.

    $( Membership in a set of open intervals of extended reals.  We use the
       fact that an operation's value is empty outside of its domain to show
       ` A e. RR* ` and ` B e. RR* ` .  (Contributed by NM, 24-Dec-2006.)
       (Revised by Mario Carneiro, 3-Nov-2013.) $)
    elioo3g $p |- ( C e. ( A (,) B ) <->
          ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ ( A < C /\ C < B ) ) ) $=
      ( vx vy vz clt cioo df-ioo elixx3g ) DEFABCGGHDEFIJ $.

    $( A member of an open interval of reals is a real.  (Contributed by NM,
       17-Aug-2008.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    elioore $p |- ( A e. ( B (,) C ) -> A e. RR ) $=
      ( cioo co wcel cxr w3a clt wbr wa cr elioo3g 3ancomb xrre2 sylanb sylbi )
      ABCDEFBGFZCGFZAGFZHZBAIJACIJKZKALFZBCAMUARTSHUBUCRSTNBACOPQ $.

    $( An open interval does not contain its left endpoint.  (Contributed by
       Mario Carneiro, 29-Dec-2016.) $)
    lbioo $p |- -. A e. ( A (,) B ) $=
      ( cioo co wcel clt wbr cxr w3a wa elioo3g simprbi simpld wn simp3d xrltnr
      simplbi syl pm2.65i ) AABCDEZAAFGZTUAABFGZTAHEZBHEZUCIZUAUBJZABAKZLMTUCUA
      NTUCUDUCTUEUFUGQOAPRS $.

    $( An open interval does not contain its right endpoint.  (Contributed by
       Mario Carneiro, 29-Dec-2016.) $)
    ubioo $p |- -. B e. ( A (,) B ) $=
      ( cioo co wcel clt wbr cxr w3a wa elioo3g simprbi simprd wn simp2d xrltnr
      simplbi syl pm2.65i ) BABCDEZBBFGZTABFGZUATAHEZBHEZUDIZUBUAJZABBKZLMTUDUA
      NTUCUDUDTUEUFUGQOBPRS $.

    $( Value of the open interval function.  (Contributed by NM, 6-Feb-2007.)
       (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iooval2 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) =
                 { x e. RR | ( A < x /\ x < B ) } ) $=
      ( cxr wcel wa cioo co cv clt wbr crab cr iooval cin inrab2 ressxr sseqin2
      wceq wss mpbi rabeq ax-mp eqtri elioore ssriv syl6eqssr df-ss sylib eqtrd
      syl5reqr ) BDECDEFZBCGHZBAIZJKUNCJKFZADLZUOAMLZABCNZULUQUPMOZUPUSUOADMOZL
      ZUQUOADMPUTMSZVAUQSMDTVBQMDRUAUOAUTMUBUCUDULUPMTUSUPSULUPUMMURAUMMUNBCUEU
      FUGUPMUHUIUKUJ $.

    $( Intersection of two open intervals of extended reals.  (Contributed by
       NM, 7-Feb-2007.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iooin $p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) ) ->
         ( ( A (,) B ) i^i ( C (,) D ) ) =
         ( if ( A <_ C , C , A ) (,) if ( B <_ D , B , D ) ) ) $=
      ( vx vy vz clt cioo df-ioo cv xrmaxlt xrltmin ixxin ) EFGABCDHHIEFGJACGKZ
      LOBDMN $.

    $( Subset relationship for open intervals of extended reals.  (Contributed
       by NM, 7-Feb-2007.)  (Revised by Mario Carneiro, 20-Feb-2015.) $)
    iooss1 $p |- ( ( A e. RR* /\ A <_ B ) ->
                 ( B (,) C ) C_ ( A (,) C ) ) $=
      ( vx vy vz vw cioo clt cle df-ioo cv xrlelttr ixxss1 ) DEFGABCHIIIHJDEFKZ
      OABGLMN $.

    $( Subset relationship for open intervals of extended reals.  (Contributed
       by NM, 7-Feb-2007.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iooss2 $p |- ( ( C e. RR* /\ B <_ C ) ->
                 ( A (,) B ) C_ ( A (,) C ) ) $=
      ( vx vy vz vw cioo clt cle df-ioo cv xrltletr ixxss2 ) DEFGABCHIIIHJDEFKZ
      OGLBCMN $.

    $( Value of the open-below, closed-above interval function.  (Contributed
       by NM, 24-Dec-2006.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iocval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,] B ) =
                 { x e. RR* | ( A < x /\ x <_ B ) } ) $=
      ( vy vz clt cle cioc df-ioc ixxval ) DEABCFGHDEAIJ $.

    $( Value of the closed-below, open-above interval function.  (Contributed
       by NM, 24-Dec-2006.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    icoval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A [,) B ) =
                 { x e. RR* | ( A <_ x /\ x < B ) } ) $=
      ( vy vz cle clt cico df-ico ixxval ) DEABCFGHDEAIJ $.

    $( Value of the closed interval function.  (Contributed by NM,
       24-Dec-2006.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    iccval $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A [,] B ) =
                 { x e. RR* | ( A <_ x /\ x <_ B ) } ) $=
      ( vy vz cle cicc df-icc ixxval ) DEABCFFGDEAHI $.

    $( Membership in an open interval of extended reals.  (Contributed by NM,
       24-Dec-2006.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    elioo1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A (,) B ) <->
                 ( C e. RR* /\ A < C /\ C < B ) ) ) $=
      ( vx vy vz clt cioo df-ioo elixx1 ) DEFABCGGHDEFIJ $.

    $( Membership in an open interval of extended reals.  (Contributed by NM,
       6-Feb-2007.) $)
    elioo2 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A (,) B ) <->
                 ( C e. RR /\ A < C /\ C < B ) ) ) $=
      ( vx cxr wcel wa cioo co cv clt wbr cr crab w3a iooval2 eleq2d wceq breq2
      breq1 anbi12d elrab 3anass bitr4i syl6bb ) AEFBEFGZCABHIZFCADJZKLZUHBKLZG
      ZDMNZFZCMFZACKLZCBKLZOZUFUGULCDABPQUMUNUOUPGZGUQUKURDCMUHCRUIUOUJUPUHCAKS
      UHCBKTUAUBUNUOUPUCUDUE $.

    $( Membership in an open-below, closed-above interval of extended reals.
       (Contributed by NM, 24-Dec-2006.)  (Revised by Mario Carneiro,
       3-Nov-2013.) $)
    elioc1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A (,] B ) <->
                 ( C e. RR* /\ A < C /\ C <_ B ) ) ) $=
      ( vx vy vz clt cle cioc df-ioc elixx1 ) DEFABCGHIDEFJK $.

    $( Membership in a closed-below, open-above interval of extended reals.
       (Contributed by NM, 24-Dec-2006.)  (Revised by Mario Carneiro,
       3-Nov-2013.) $)
    elico1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A [,) B ) <->
                 ( C e. RR* /\ A <_ C /\ C < B ) ) ) $=
      ( vx vy vz cle clt cico df-ico elixx1 ) DEFABCGHIDEFJK $.

    $( Membership in a closed interval of extended reals.  (Contributed by NM,
       24-Dec-2006.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    elicc1 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A [,] B ) <->
                 ( C e. RR* /\ A <_ C /\ C <_ B ) ) ) $=
      ( vx vy vz cle cicc df-icc elixx1 ) DEFABCGGHDEFIJ $.

    $( A closed interval with identical lower and upper bounds is a singleton.
       (Contributed by Jeff Hankins, 13-Jul-2009.) $)
    iccid $p |- ( A e. RR* -> ( A [,] A ) = { A } ) $=
      ( vx cxr wcel co csn cv cle wbr w3a wb wi wa clt wn xrlenlt ancoms sylbid
      cicc syl5ibrcom elicc1 anidms xrlttri3 biimprd exp3acom23 com23 ex eleq1a
      wceq 3impd xrleid breq2 breq1 3jcad impbid elsn syl6bbr bitrd eqrdv ) ACD
      ZBAASEZAFZUTBGZVADZVCCDZAVCHIZVCAHIZJZVCVBDZUTVDVHKAAVCUAUBUTVHVCAUIZVIUT
      VHVJUTVEVFVGVJUTVEVFVGVJLZLUTVEMZVFVCANIOZVKAVCPVLVGVMVJVLVGAVCNIOZVMVJLV
      EUTVGVNKVCAPQVLVMVNVJVEUTVMVNMZVJLVEUTMVJVOVCAUCUDQUERUFRUGUJUTVJVEVFVGAC
      VCUHUTVFVJAAHIZAUKZVCAAHULTUTVGVJVPVQVCAAHUMTUNUOBAUPUQURUS $.

    $( An empty open interval of extended reals.  (Contributed by FL,
       30-May-2014.) $)
    ico0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A [,) B ) = (/) <->
                 B <_ A ) ) $=
      ( vx cxr wcel wa cico co c0 wceq cv cle wbr clt crab wn wrex wi cq bitrd
      icoval eqeq1d wne df-ne rabn0 bitr3i xrlelttr 3expa rexlimdva w3a qbtwnxr
      3com23 qre rexrd a1i simpr1 simpl xrltle syl2anc anim1d anim12d ex adantr
      syl pm2.43b reximdv2 mpd 3expia impbid syl5bb xrltnle con4bid ) ADEZBDEZF
      ZABGHZIJACKZLMZVQBNMZFZCDOZIJZBALMZVOVPWAICABUAUBVOWBWCVOWBPZABNMZWCPWDVT
      CDQZVOWEWDWAIUCWFWAIUDVTCDUEUFVOWFWEVOVTWECDVMVNVQDEZVTWERZVMWGVNWHAVQBUG
      ULUHUIVMVNWEWFVMVNWEUJZAVQNMZVSFZCSQWFCABUKWIWKVTCSDWIVQSEZWKFZWGVTFZWLWI
      WMWNRZRZWKWLWGWPWLVQVQUMUNZWGWIWOWGWIFZWLWGWKVTWLWGRWRWQUOWRWJVRVSWRVMWGW
      JVRRWGVMVNWEUPWGWIUQAVQURUSUTVAVBVDVCVEVFVGVHVIVJABVKTVLT $.

    $( An empty open interval of extended reals.  (Contributed by FL,
       30-May-2014.) $)
    ioc0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A (,] B ) = (/) <->
                 B <_ A ) ) $=
      ( vx cxr wcel wa cioc co c0 wceq cv clt wbr cle crab wn wrex wi cq bitrd
      iocval eqeq1d wne df-ne rabn0 bitr3i xrltletr 3expa rexlimdva w3a qbtwnxr
      3com23 qre rexrd a1i xrltle 3ad2antr2 anim2d anim12d syl pm2.43b reximdv2
      ex adantr mpd 3expia impbid syl5bb xrltnle con4bid ) ADEZBDEZFZABGHZIJACK
      ZLMZVOBNMZFZCDOZIJZBANMZVMVNVSICABUAUBVMVTWAVMVTPZABLMZWAPWBVRCDQZVMWCWBV
      SIUCWDVSIUDVRCDUEUFVMWDWCVMVRWCCDVKVLVODEZVRWCRZVKWEVLWFAVOBUGULUHUIVKVLW
      CWDVKVLWCUJZVPVOBLMZFZCSQWDCABUKWGWIVRCSDWGVOSEZWIFZWEVRFZWJWGWKWLRZRZWIW
      JWEWNWJVOVOUMUNZWEWGWMWEWGFZWJWEWIVRWJWERWPWOUOWPWHVQVPWEVKVLWHVQRWCVOBUP
      UQURUSVCUTVDVAVBVEVFVGVHABVITVJT $.

    $( An empty open interval of extended reals.  (Contributed by FL,
       30-May-2014.) $)
    icc0 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( ( A [,] B ) = (/) <->
                 B < A ) ) $=
      ( vx cxr wcel wa cicc co c0 wceq cv cle wbr crab iccval eqeq1d wrex bitrd
      clt wn wne df-ne rabn0 bitr3i wi xrletr 3com23 3expa rexlimdva w3a xrleid
      simp2 simp3 3ad2ant2 anbi12d rspcev syl12anc 3expia impbid syl5bb xrlenlt
      breq2 breq1 con4bid ) ADEZBDEZFZABGHZIJACKZLMZVIBLMZFZCDNZIJZBASMZVGVHVMI
      CABOPVGVNVOVGVNTZABLMZVOTVPVLCDQZVGVQVPVMIUAVRVMIUBVLCDUCUDVGVRVQVGVLVQCD
      VEVFVIDEZVLVQUEZVEVSVFVTAVIBUFUGUHUIVEVFVQVRVEVFVQUJVFVQBBLMZVRVEVFVQULVE
      VFVQUMVFVEWAVQBUKUNVLVQWAFCBDVIBJVJVQVKWAVIBALVBVIBBLVCUOUPUQURUSUTABVARV
      DR $.
  $}

  $( The upper bound belongs to an open-below, closed-above interval.  See
     ~ ubicc2 .  (Contributed by FL, 29-May-2014.) $)
  ubioc1 $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) -> B e. ( A (,] B ) ) $=
    ( cxr wcel clt wbr w3a co cle simp2 simp3 xrleid 3ad2ant2 wb elioc1 3adant3
    cioc mpbir3and ) ACDZBCDZABEFZGBABQHDZTUABBIFZSTUAJSTUAKTSUCUABLMSTUBTUAUCG
    NUAABBOPR $.

  $( The lower bound belongs to a closed-below, open-above interval.  See
     ~ lbicc2 .  (Contributed by FL, 29-May-2014.) $)
  lbico1 $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) -> A e. ( A [,) B ) ) $=
    ( cxr wcel clt wbr w3a co cle simp1 xrleid 3ad2ant1 simp3 wb elico1 3adant3
    cico mpbir3and ) ACDZBCDZABEFZGAABQHDZSAAIFZUASTUAJSTUCUAAKLSTUAMSTUBSUCUAG
    NUAABAOPR $.

  $( An element of a closed interval is less than or equal to its upper bound.
     (Contributed by Jeffrey Hankins, 14-Jul-2009.) $)
  iccleub $p |- ( ( A e. RR* /\ B e. RR* /\ C e. ( A [,] B ) ) -> C <_ B ) $=
    ( cxr wcel cicc co cle wbr wa w3a elicc1 simp3 syl6bi 3impia ) ADEZBDEZCABF
    GEZCBHIZPQJRCDEZACHIZSKSABCLTUASMNO $.

  $( TODO - see if this shortens the uses of any other
     elioo*'s $)
  $( Membership in an open interval of extended reals.  (Contributed by NM,
     17-Aug-2008.) $)
  elioo5 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* )
           -> ( C e. ( A (,) B ) <-> ( A < C /\ C < B ) ) ) $=
    ( cxr wcel w3a co clt wbr wa wb elioo1 3adant3 3anass baibr 3ad2ant3 bitr4d
    cioo ) ADEZBDEZCDEZFCABRGEZUAACHIZCBHIZFZUCUDJZSTUBUEKUAABCLMUASUFUEKTUEUAU
    FUAUCUDNOPQ $.

  $( A non-empty open interval spans an interval of extended reals.
     (Contributed by NM, 17-Aug-2008.) $)
  eliooxr $p |- ( A e. ( B (,) C ) -> ( B e. RR* /\ C e. RR* ) ) $=
    ( cioo co wcel c0 wne cxr wa ne0i ndmioo necon1ai syl ) ABCDEZFOGHBIFCIFJZO
    AKPOGBCLMN $.

  $( Ordering implied by a member of an open interval of reals.  (Contributed
     by NM, 17-Aug-2008.)  (Revised by Mario Carneiro, 9-May-2014.) $)
  eliooord $p |- ( A e. ( B (,) C ) -> ( B < A /\ A < C ) ) $=
    ( cioo co wcel cr clt wbr w3a wa cxr wb eliooxr elioo2 syl ibi 3simpc ) ABC
    DEFZAGFZBAHIZACHIZJZUAUBKSUCSBLFCLFKSUCMABCNBCAOPQTUAUBRP $.

  $( Membership in an open interval of extended reals.  (Contributed by NM,
     8-Jun-2007.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
  elioo4g $p |- ( C e. ( A (,) B ) <->
        ( ( A e. RR* /\ B e. RR* /\ C e. RR ) /\ ( A < C /\ C < B ) ) ) $=
    ( cioo co wcel cxr cr w3a clt wbr wa eliooxr elioore df-3an sylibr eliooord
    jca rexr 3anim3i anim1i elioo3g impbii ) CABDEFZAGFZBGFZCHFZIZACJKCBJKLZLZU
    DUHUIUDUEUFLZUGLUHUDUKUGCABMCABNRUEUFUGOPCABQRUJUEUFCGFZIZUILUDUHUMUIUGULUE
    UFCSTUAABCUBPUC $.

  ${
    $d x A $.  $d x B $.
    $( An open interval is a set of reals.  (Contributed by NM,
       31-May-2007.) $)
    ioossre $p |- ( A (,) B ) C_ RR $=
      ( vx cioo co cr cv elioore ssriv ) CABDEFCGABHI $.
  $}

  ${
    $d v w x y z A $.  $d v x y z B $.  $d x y z C $.
    $( Membership in an open-below, closed-above real interval.  (Contributed
       by Paul Chapman, 30-Dec-2007.)  (Revised by Mario Carneiro,
       14-Jun-2014.) $)
    elioc2 $p |- ( ( A e. RR* /\ B e. RR ) ->
        ( C e. ( A (,] B ) <-> ( C e. RR /\ A < C /\ C <_ B ) ) ) $=
      ( cxr wcel cr wa cioc co clt wbr cle wb rexr cmnf cpnf xrlelttrd ad2antlr
      w3a a1i elioc1 sylan2 mnfxr simpll simpr1 mnfle simpr2 pnfxr simpr3 ltpnf
      ad2antrr xrrebnd syl mpbir2and 3jca ex 3anim1i impbid1 bitrd ) ADEZBFEZGZ
      CABHIEZCDEZACJKZCBLKZSZCFEZVEVFSZVAUTBDEZVCVGMBNZABCUAUBVBVGVIVBVGVIVBVGG
      ZVHVEVFVLVHOCJKZCPJKZVLOACODEVLUCTUTVAVGUDVBVDVEVFUEZUTOALKVAVGAUFUKVBVDV
      EVFUGZQVLCBPVOVAVJUTVGVKRPDEVLUHTVBVDVEVFUIZVABPJKUTVGBUJRQVLVDVHVMVNGMVO
      CULUMUNVPVQUOUPVHVDVEVFCNUQURUS $.

    $( Membership in a closed-below, open-above real interval.  (Contributed by
       Paul Chapman, 21-Jan-2008.)  (Revised by Mario Carneiro,
       14-Jun-2014.) $)
    elico2 $p |- ( ( A e. RR /\ B e. RR* ) ->
        ( C e. ( A [,) B ) <-> ( C e. RR /\ A <_ C /\ C < B ) ) ) $=
      ( cr wcel cxr wa cico co cle wbr clt wb rexr cmnf cpnf ad2antrr xrltletrd
      w3a a1i elico1 sylan mnfxr simpr1 mnflt simpr2 simplr pnfxr pnfge xrrebnd
      simpr3 ad2antlr syl mpbir2and 3jca ex 3anim1i impbid1 bitrd ) ADEZBFEZGZC
      ABHIEZCFEZACJKZCBLKZSZCDEZVEVFSZUTAFEZVAVCVGMANZABCUAUBVBVGVIVBVGVIVBVGGZ
      VHVEVFVLVHOCLKZCPLKZVLOACOFEVLUCTUTVJVAVGVKQVBVDVEVFUDZUTOALKVAVGAUEQVBVD
      VEVFUFZRVLCBPVOUTVAVGUGPFEVLUHTVBVDVEVFUKZVABPJKUTVGBUIULRVLVDVHVMVNGMVOC
      UJUMUNVPVQUOUPVHVDVEVFCNUQURUS $.

    $( Membership in a closed real interval.  (Contributed by Paul Chapman,
       21-Sep-2007.)  (Revised by Mario Carneiro, 14-Jun-2014.) $)
    elicc2 $p |- ( ( A e. RR /\ B e. RR ) -> ( C e. ( A [,] B ) <->
                      ( C e. RR /\ A <_ C /\ C <_ B ) ) ) $=
      ( cr wcel wa cicc co cxr cle wbr w3a rexr cmnf clt cpnf ad2antrr ad2antlr
      wb a1i elicc1 syl2an mnfxr simpr1 mnflt simpr2 xrltletrd simpr3 xrlelttrd
      pnfxr ltpnf xrrebnd syl mpbir2and 3jca ex 3anim1i impbid1 bitrd ) ADEZBDE
      ZFZCABGHEZCIEZACJKZCBJKZLZCDEZVEVFLZUTAIEZBIEZVCVGSVAAMZBMZABCUAUBVBVGVIV
      BVGVIVBVGFZVHVEVFVNVHNCOKZCPOKZVNNACNIEVNUCTUTVJVAVGVLQVBVDVEVFUDZUTNAOKV
      AVGAUEQVBVDVEVFUFZUGVNCBPVQVAVKUTVGVMRPIEVNUJTVBVDVEVFUHZVABPOKUTVGBUKRUI
      VNVDVHVOVPFSVQCULUMUNVRVSUOUPVHVDVEVFCMUQURUS $.
  $}

  ${
    elicc2i.1 $e |- A e. RR $.
    elicc2i.2 $e |- B e. RR $.
    $( Inference for membership in a closed interval.  (Contributed by Scott
       Fenton, 3-Jun-2013.) $)
    elicc2i $p |- ( C e. ( A [,] B ) <-> ( C e. RR /\ A <_ C /\ C <_ B ) ) $=
      ( cr wcel cicc co cle wbr w3a wb elicc2 mp2an ) AFGBFGCABHIGCFGACJKCBJKLM
      DEABCNO $.
  $}

  $( Membership in a closed real interval.  (Contributed by Stefan O'Rear,
     16-Nov-2014.)  (Proof shortened by Mario Carneiro, 1-Jan-2017.) $)
  elicc4 $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
      ( C e. ( A [,] B ) <-> ( A <_ C /\ C <_ B ) ) ) $=
    ( cxr wcel cicc co cle wbr wa wb w3a elicc1 3anass syl6bb baibd 3impa ) ADE
    ZBDEZCDEZCABFGEZACHIZCBHIZJZKRSJZUATUDUEUATUBUCLTUDJABCMTUBUCNOPQ $.

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.  $d w x y z D $.
    $( Condition for a closed interval to be a subset of another closed
       interval.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 20-Feb-2015.) $)
    iccss $p |- ( ( ( A e. RR /\ B e. RR ) /\
                    ( A <_ C /\ D <_ B ) ) -> ( C [,] D ) C_ ( A [,] B ) ) $=
      ( vx vy vz vw cr wcel wa cxr cle wbr cicc co wss rexr anim12i xrletr cv
      df-icc ixxss12 sylan ) AIJZBIJZKALJZBLJZKACMNDBMNKCDOPABOPQUEUGUFUHARBRSE
      FGHABCDOMMMMOMMEFGUBZUIACHUAZTUJDBTUCUD $.

    $( Condition for a closed interval to be a subset of an open interval.
       (Contributed by Mario Carneiro, 20-Feb-2015.) $)
    iccssioo $p |- ( ( ( A e. RR* /\ B e. RR* ) /\
      ( A < C /\ D < B ) ) -> ( C [,] D ) C_ ( A (,) B ) ) $=
      ( vx vy vz vw cicc clt cle cioo df-ioo df-icc xrltletr xrlelttr ixxss12
      cv ) EFGHABCDIJJKKLJJEFGMEFGNACHRZOSDBPQ $.

    $( Condition for a closed interval to be a subset of an open interval.
       (Contributed by Thierry Arnoux, 21-Sep-2017.) $)
    icossico $p |- ( ( ( A e. RR* /\ B e. RR* ) /\
      ( A <_ C /\ D <_ B ) ) -> ( C [,) D ) C_ ( A [,) B ) ) $=
      ( vx vy vz vw cico cle clt df-ico cv xrletr xrltletr ixxss12 ) EFGHABCDIJ
      KJKIJJEFGLZQACHMZNRDBOP $.

    $( Condition for a closed interval to be a subset of another closed
       interval.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    iccss2 $p |- ( ( C e. ( A [,] B ) /\ D e. ( A [,] B ) ) ->
      ( C [,] D ) C_ ( A [,] B ) ) $=
      ( vx vy vz vw cicc co wcel cxr cle wbr w3a elixx3g adantr simprbi xrletr
      wa wss df-icc simplbi simp1d simp2d simpld simprd adantl ixxss12 syl22anc
      cv ) CABIJZKZDULKZTZALKZBLKZACMNZDBMNZCDIJULUAUOUPUQCLKZUMUPUQUTOZUNUMVAU
      RCBMNZTZEFGABCMMIEFGUBZPZUCQZUDUOUPUQUTVFUEUOURVBUMVCUNUMVAVCVERQUFUNUSUM
      UNADMNZUSUNUPUQDLKOVGUSTEFGABDMMIVDPRUGUHEFGHABCDIMMMMIMMVDVDACHUKZSVHDBS
      UIUJ $.

    $( Condition for a closed interval to be a subset of a half-open interval.
       (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    iccssico $p |- ( ( ( A e. RR* /\ B e. RR* ) /\
      ( A <_ C /\ D < B ) ) -> ( C [,] D ) C_ ( A [,) B ) ) $=
      ( vx vy vz vw cicc cle clt cico df-ico df-icc cv xrletr xrlelttr ixxss12
      ) EFGHABCDIJKJJLJKEFGMEFGNACHOZPSDBQR $.

    $( Condition for a closed interval to be a subset of an open interval.
       (Contributed by Mario Carneiro, 20-Feb-2015.) $)
    iccssioo2 $p |- ( ( C e. ( A (,) B ) /\ D e. ( A (,) B ) ) ->
      ( C [,] D ) C_ ( A (,) B ) ) $=
      ( cioo co wcel wa cxr clt wbr cicc wss c0 wne ne0i adantr ndmioo necon1ai
      eliooord syl simpld adantl simprd iccssioo syl12anc ) CABEFZGZDUGGZHZAIGB
      IGHZACJKZDBJKZCDLFUGMUJUGNOZUKUHUNUIUGCPQUKUGNABRSUAUJULCBJKZUHULUOHUICAB
      TQUBUJADJKZUMUIUPUMHUHDABTUCUDABCDUEUF $.

    $( Condition for a closed interval to be a subset of an open interval.
       (Contributed by Mario Carneiro, 20-Feb-2015.) $)
    iccssico2 $p |- ( ( C e. ( A [,) B ) /\ D e. ( A [,) B ) ) ->
      ( C [,] D ) C_ ( A [,) B ) ) $=
      ( vx vy vz cico co wcel wa cxr cle wbr clt cv adantr w3a elixx3g simprbi
      cicc wss crab df-ico elmpt2cl1 elmpt2cl2 simpld simprd iccssico syl22anc
      adantl ) CABHIZJZDULJZKALJZBLJZACMNZDBONZCDUAIULUBUMUOUNEFLLEPGPZMNUSFPON
      KGLUCZABHCEFGUDZUEQUMUPUNEFLLUTABHCVAUFQUMUQUNUMUQCBONZUMUOUPCLJRUQVBKEFG
      ABCMOHVASTUGQUNURUMUNADMNZURUNUOUPDLJRVCURKEFGABDMOHVASTUHUKABCDUIUJ $.
  $}

  $( The open interval from minus to plus infinity.  (Contributed by NM,
     6-Feb-2007.) $)
  ioomax $p |- ( -oo (,) +oo ) = RR $=
    ( vx cmnf cpnf cioo co cv clt wbr wa crab cxr wcel wceq mnfxr pnfxr iooval2
    cr mp2an rabid2 mnflt ltpnf jca mprgbir eqtr4i ) BCDEZBAFZGHZUFCGHZIZAQJZQB
    KLCKLUEUJMNOABCPRQUJMUIAQUIAQSUFQLUGUHUFTUFUAUBUCUD $.

  $( The closed interval from minus to plus infinity.  (Contributed by Mario
     Carneiro, 4-Jul-2014.) $)
  iccmax $p |- ( -oo [,] +oo ) = RR* $=
    ( vx cmnf cpnf cicc co cv cle wbr wa cxr crab wcel mnfxr pnfxr iccval mp2an
    wceq rabid2 mnfle pnfge jca mprgbir eqtr4i ) BCDEZBAFZGHZUECGHZIZAJKZJBJLCJ
    LUDUIQMNABCOPJUIQUHAJUHAJRUEJLUFUGUESUETUAUBUC $.

  $( The set of positive reals expressed as an open interval.  (Contributed by
     NM, 7-May-2007.) $)
  ioopos $p |- ( 0 (,) +oo ) = { x e. RR | 0 < x } $=
    ( cc0 cpnf cioo co cv clt wbr wa crab cxr wcel wceq 0xr pnfxr iooval2 mp2an
    cr ltpnf biantrud rabbiia eqtr4i ) BCDEZBAFZGHZUDCGHZIZARJZUEARJBKLCKLUCUHM
    NOABCPQUEUGARUDRLUFUEUDSTUAUB $.

  $( The set of positive reals expressed as an open interval.  (Contributed by
     Steve Rodriguez, 25-Nov-2007.) $)
  ioorp $p |- ( 0 (,) +oo ) = RR+ $=
    ( vx cc0 cpnf cioo co cv clt wbr cr crab crp ioopos df-rp eqtr4i ) BCDEBAFG
    HAIJKALAMN $.

  $( Shift the arguments of the open interval function.  (Contributed by NM,
     17-Aug-2008.) $)
  iooshf $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR ) )
     -> ( ( A - B ) e. ( C (,) D ) <-> A e. ( ( C + B ) (,) ( D + B ) ) ) ) $=
    ( cr wcel wa caddc co clt wbr cioo wb 3expa cxr readdcl rexrd rexr ad2antrl
    elioo5 ltaddsub 3com13 adantrr w3a ltsubadd bicomd adantrl anbi12d ad2ant2l
    cmin ad2ant2rl syl3anc ancoms ad2antll resubcl adantr 3bitr4rd ) AEFZBEFZGZ
    CEFZDEFZGZGZCBHIZAJKZADBHIZJKZGZCABUJIZJKZVJDJKZGZAVEVGLIFZVJCDLIFZVDVFVKVH
    VLUTVAVFVKMZVBURUSVAVPVAUSURVPCBAUAUBNUCUTVBVHVLMZVAURUSVBVQURUSVBUDVLVHABD
    UEUFNUGUHVCUTVNVIMZVCUTGVEOFZVGOFZAOFZVRVAUSVSVBURVAUSGVECBPQUKVBUSVTVAURVB
    USGVGDBPQUIURWAVCUSARSVEVGATULUMVDCOFZDOFZVJOFZVOVMMVAWBUTVBCRSVBWCUTVADRUN
    UTWDVCUTVJABUOQUPCDVJTULUQ $.

  ${
    $d v w x y z A $.  $d v w x y z B $.
    $( A closed-above interval with real upper bound is a set of reals.
       (Contributed by FL, 29-May-2014.) $)
    iocssre $p |- ( ( A e. RR* /\ B e. RR ) -> ( A (,] B ) C_ RR ) $=
      ( vx cxr wcel cr wa cioc co cv w3a clt wbr cle elioc2 simp1d 3expia ssrdv
      biimp3a ) ADEZBFEZGCABHIZFTUACJZUBEZUCFEZTUAUDKUEAUCLMZUCBNMZTUAUDUEUFUGK
      ABUCOSPQR $.

    $( A closed-below interval with real lower bound is a set of reals.
       (Contributed by Mario Carneiro, 14-Jun-2014.) $)
    icossre $p |- ( ( A e. RR /\ B e. RR* ) -> ( A [,) B ) C_ RR ) $=
      ( vx cr wcel cxr wa cico co cv w3a cle wbr clt elico2 simp1d 3expia ssrdv
      biimp3a ) ADEZBFEZGCABHIZDTUACJZUBEZUCDEZTUAUDKUEAUCLMZUCBNMZTUAUDUEUFUGK
      ABUCOSPQR $.

    $( A closed real interval is a set of reals.  (Contributed by FL,
       6-Jun-2007.)  (Proof shortened by Paul Chapman, 21-Jan-2008.) $)
    iccssre $p |- ( ( A e. RR /\ B e. RR ) -> ( A [,] B ) C_ RR ) $=
      ( vx cr wcel wa cicc co cv w3a cle wbr elicc2 biimp3a simp1d 3expia ssrdv
      ) ADEZBDEZFCABGHZDRSCIZTEZUADEZRSUBJUCAUAKLZUABKLZRSUBUCUDUEJABUAMNOPQ $.

    $( A closed interval is a set of extended reals.  (Contributed by FL,
       28-Jul-2008.)  (Revised by Mario Carneiro, 4-Jul-2014.) $)
    iccssxr $p |- ( A [,] B ) C_ RR* $=
      ( vx vy vz cle cicc df-icc ixxssxr ) CDEABFFGCDEHI $.

    $( An open-below, closed-above interval is a subset of the extended reals.
       (Contributed by FL, 29-May-2014.)  (Revised by Mario Carneiro,
       4-Jul-2014.) $)
    iocssxr $p |- ( A (,] B ) C_ RR* $=
      ( vx vy vz clt cle cioc df-ioc ixxssxr ) CDEABFGHCDEIJ $.

    $( A closed-below, open-above interval is a subset of the extended reals.
       (Contributed by FL, 29-May-2014.)  (Revised by Mario Carneiro,
       4-Jul-2014.) $)
    icossxr $p |- ( A [,) B ) C_ RR* $=
      ( vx vy vz cle clt cico df-ico ixxssxr ) CDEABFGHCDEIJ $.

    $( An open interval is a subset of its closure.  (Contributed by Paul
       Chapman, 18-Oct-2007.) $)
    ioossicc $p |- ( A (,) B ) C_ ( A [,] B ) $=
      ( vx vy vz vw cicc clt cle cioo df-ioo df-icc cv xrltle ixxssixx ) CDEFAB
      GHHIIJCDEKCDELAFMZNPBNO $.
  $}

  ${
    $d A y $.  $d B x y $.  $d S x y $.
    $( A nonempty subset of a closed real interval satisfies the conditions for
       the existence of its supremum (see ~ suprcl ).  (Contributed by Paul
       Chapman, 21-Jan-2008.) $)
    iccsupr $p |- ( ( ( A e. RR /\ B e. RR ) /\ S C_ ( A [,] B ) /\ C e. S ) ->
                   ( S C_ RR /\ S =/= (/) /\ E. x e. RR A. y e. S y <_ x ) ) $=
      ( cr wcel wa cicc co wss w3a c0 wne cv cle wbr wral 3adant3 iccssre sylan
      wrex sstr ancoms ne0i 3ad2ant3 simplr elicc2 biimpd sylan9r imp ralrimiva
      ssel simp3d wceq breq2 ralbidv rspcev syl2anc 3jca ) CGHZDGHZIZFCDJKZLZEF
      HZMFGLZFNOZBPZAPZQRZBFSZAGUCZVDVFVHVGVDVEGLZVFVHCDUAVFVOVHFVEGUDUEUBTVGVD
      VIVFFEUFUGVDVFVNVGVDVFIZVCVJDQRZBFSZVNVBVCVFUHVPVQBFVPVJFHZIVJGHZCVJQRZVQ
      VPVSVTWAVQMZVFVSVJVEHZVDWBFVEVJUNVDWCWBCDVJUIUJUKULUOUMVMVRADGVKDUPVLVQBF
      VKDVJQUQURUSUTTVA $.
  $}

  ${
    $d w x y z A $.  $d x B $.
    $( Membership in an unbounded interval of extended reals.  (Contributed by
       Mario Carneiro, 18-Jun-2014.) $)
    elioopnf $p |- ( A e. RR* ->
                     ( B e. ( A (,) +oo ) <-> ( B e. RR /\ A < B ) ) ) $=
      ( cxr wcel cpnf cioo co cr clt wbr w3a wa pnfxr elioo2 mpan2 df-3an ltpnf
      wb adantr pm4.71i bitr4i syl6bb ) ACDZBAEFGDZBHDZABIJZBEIJZKZUEUFLZUCECDU
      DUHRMAEBNOUHUIUGLUIUEUFUGPUIUGUEUGUFBQSTUAUB $.

    $( Membership in an unbounded interval of extended reals.  (Contributed by
       Mario Carneiro, 18-Jun-2014.) $)
    elioomnf $p |- ( A e. RR* ->
                     ( B e. ( -oo (,) A ) <-> ( B e. RR /\ B < A ) ) ) $=
      ( cxr wcel cmnf cioo co cr clt wbr w3a wa wb mnfxr elioo2 mpan an32 mnflt
      df-3an adantr pm4.71i 3bitr4i syl6bb ) ACDZBEAFGDZBHDZEBIJZBAIJZKZUFUHLZE
      CDUDUEUIMNEABOPUFUGLUHLUJUGLUIUJUFUGUHQUFUGUHSUJUGUFUGUHBRTUAUBUC $.

    $( Membership in a closed unbounded interval of reals.  (Contributed by
       Mario Carneiro, 16-Sep-2014.) $)
    elicopnf $p |- ( A e. RR ->
                     ( B e. ( A [,) +oo ) <-> ( B e. RR /\ A <_ B ) ) ) $=
      ( cr wcel cpnf cico co cle wbr clt w3a wa cxr wb pnfxr elico2 mpan2 ltpnf
      adantr pm4.71i df-3an bitr4i syl6bbr ) ACDZBAEFGDZBCDZABHIZBEJIZKZUFUGLZU
      DEMDUEUINOAEBPQUJUJUHLUIUJUHUFUHUGBRSTUFUGUHUAUBUC $.

    $( Two ways of saying that a real number is positive.  (Contributed by NM,
       7-May-2007.) $)
    repos $p |- ( A e. ( 0 (,) +oo ) <-> ( A e. RR /\ 0 < A ) ) $=
      ( vx cc0 cv clt wbr cr cpnf cioo co breq2 ioopos elrab2 ) CBDZEFCAEFBAGCH
      IJNACEKBLM $.

    $( The set of open intervals of extended reals maps to subsets of reals.
       (Contributed by NM, 7-Feb-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.) $)
    ioof $p |- (,) : ( RR* X. RR* ) --> ~P RR $=
      ( vx vz vy cv clt wbr wa cxr crab cr cpw wcel wral cxp cioo wf iooval wss
      co ioossre ovex elpw mpbir syl6eqelr rgen2a df-ioo fmpt2 mpbi ) ADZBDZEFU
      JCDZEFGBHIZJKZLZCHMAHMHHNUMOPUNACHUIHLUKHLGULUIUKOSZUMBUIUKQUOUMLUOJRUIUK
      TUOJUIUKOUAUBUCUDUEACHHULUMOACBUFUGUH $.

    $( The set of closed intervals of extended reals maps to subsets of
       extended reals.  (Contributed by FL, 14-Jun-2007.)  (Revised by Mario
       Carneiro, 3-Nov-2013.) $)
    iccf $p |- [,] : ( RR* X. RR* ) --> ~P RR* $=
      ( vx vy vz cle cicc df-icc ixxf ) ABCDDEABCFG $.

    $( The union of the range of the open interval function.  (Contributed by
       NM, 7-May-2007.)  (Revised by Mario Carneiro, 30-Jan-2014.) $)
    unirnioo $p |- RR = U. ran (,) $=
      ( cr cioo crn cuni wcel wss cmnf cpnf co ioomax cxr cxp wfn wf ioof ax-mp
      cpw ffn mnfxr pnfxr fnovrn mp3an eqeltrri elssuni frn sspwuni mpbi eqssi
      ) ABCZDZAUIEAUJFGHBIZAUIJBKKLZMZGKEHKEUKUIEULAQZBNZUMOULUNBRPSTKKGHBUAUBU
      CAUIUDPUIUNFZUJAFUOUPOULUNBUEPUIAUFUGUH $.

    $( Alternate definition of the set of open intervals of extended reals.
       (Contributed by NM, 1-Mar-2007.)  (Revised by Mario Carneiro,
       1-Sep-2015.) $)
    dfioo2 $p |- (,) = ( x e. RR* , y e. RR* |->
                         { w e. RR | ( x < w /\ w < y ) } ) $=
      ( cioo cxr cv co cmpt2 clt wbr wa cr crab cxp wfn wceq cpw wf ioof ffn
      ax-mp fnov mpbi iooval2 mpt2eq3ia eqtri ) DABEEAFZBFZDGZHZABEEUGCFZIJUKUH
      IJKCLMZHDEENZOZDUJPUMLQZDRUNSUMUODTUAABEEDUBUCABEEUIULCUGUHUDUEUF $.

    $( Open intervals are elements of the set of all open intervals.
       (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    ioorebas $p |- ( A (,) B ) e. ran (,) $=
      ( vx cioo co crn wcel c0 wceq id cc0 iooid cxr cxp wfn cr cpw 0xr fnovrn
      wf ioof ffn ax-mp mp3an eqeltrri syl6eqel wne cv wex n0 wa eliooxr mp3an1
      syl exlimiv sylbi pm2.61ine ) ABDEZDFZGZURHURHIZURHUSVAJKKDEZHUSKLDMMNZOZ
      KMGZVEVBUSGVCPQZDTVDUAVCVFDUBUCZRRMMKKDSUDUEUFURHUGCUHZURGZCUIUTCURUJVIUT
      CVIAMGZBMGZUKUTVHABULVDVJVKUTVGMMABDSUMUNUOUPUQ $.
  $}

  $( The predicate "is a nonnegative real".  (Contributed by Jeff Madsen,
     2-Sep-2009.)  (Proof shortened by Mario Carneiro, 18-Jun-2014.) $)
  elrege0 $p |- ( A e. ( 0 [,) +oo ) <-> ( A e. RR /\ 0 <_ A ) ) $=
    ( cc0 cr wcel cpnf cico co cle wbr wa wb 0re elicopnf ax-mp ) BCDABEFGDACDB
    AHIJKLBAMN $.

  $( Elementhood in the set of nonnegative extended reals.  (Contributed by
     Mario Carneiro, 28-Jun-2014.) $)
  elxrge0 $p |- ( A e. ( 0 [,] +oo ) <-> ( A e. RR* /\ 0 <_ A ) ) $=
    ( cxr wcel cc0 cle wbr cpnf w3a wa cicc co df-3an wb 0xr pnfxr elicc1 mp2an
    pnfge adantr pm4.71i 3bitr4i ) ABCZDAEFZAGEFZHZUBUCIZUDIADGJKCZUFUBUCUDLDBC
    GBCUGUEMNODGAPQUFUDUBUDUCARSTUA $.

  $( The nonnegative reals are closed under addition.  (Contributed by Mario
     Carneiro, 19-Jun-2014.) $)
  ge0addcl $p |- ( ( A e. ( 0 [,) +oo ) /\ B e. ( 0 [,) +oo ) ) ->
                   ( A + B ) e. ( 0 [,) +oo ) ) $=
    ( cc0 cpnf cico co wcel cr cle wbr wa caddc elrege0 readdcl ad2ant2r addge0
    an4s sylanbrc syl2anb ) ACDEFZGAHGZCAIJZKZBHGZCBIJZKZABLFZTGZBTGAMBMUCUFKUG
    HGZCUGIJZUHUAUDUIUBUEABNOUAUDUBUEUJABPQUGMRS $.

  $( The nonnegative reals are closed under multiplication.  (Contributed by
     Mario Carneiro, 19-Jun-2014.) $)
  ge0mulcl $p |- ( ( A e. ( 0 [,) +oo ) /\ B e. ( 0 [,) +oo ) ) ->
                   ( A x. B ) e. ( 0 [,) +oo ) ) $=
    ( cc0 cpnf cico co wcel cr cle wbr wa cmul elrege0 ad2ant2r mulge0 sylanbrc
    remulcl syl2anb ) ACDEFZGAHGZCAIJZKZBHGZCBIJZKZABLFZSGZBSGAMBMUBUEKUFHGZCUF
    IJUGTUCUHUAUDABQNABOUFMPR $.

  $( The nonnegative reals are closed under addition.  (Contributed by Mario
     Carneiro, 26-Aug-2015.) $)
  ge0xaddcl $p |- ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) ) ->
                   ( A +e B ) e. ( 0 [,] +oo ) ) $=
    ( cc0 cpnf cicc co wcel cxr cle wbr wa cxad elxrge0 xaddcl ad2ant2r xaddge0
    an4s sylanbrc syl2anb ) ACDEFZGAHGZCAIJZKZBHGZCBIJZKZABLFZTGZBTGAMBMUCUFKUG
    HGZCUGIJZUHUAUDUIUBUEABNOUAUDUBUEUJABPQUGMRS $.

  $( The nonnegative extended reals are closed under multiplication.
     (Contributed by Mario Carneiro, 26-Aug-2015.) $)
  ge0xmulcl $p |- ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) ) ->
                   ( A *e B ) e. ( 0 [,] +oo ) ) $=
    ( cc0 cpnf cicc co wcel cxr cle wbr wa cxmu elxrge0 xmulcl ad2ant2r xmulge0
    sylanbrc syl2anb ) ACDEFZGAHGZCAIJZKZBHGZCBIJZKZABLFZSGZBSGAMBMUBUEKUFHGZCU
    FIJUGTUCUHUAUDABNOABPUFMQR $.

  $( The lower bound of a closed interval is a member of it.  (Contributed by
     Paul Chapman, 26-Nov-2007.)  (Revised by FL, 29-May-2014.)  (Revised by
     Mario Carneiro, 9-Sep-2015.) $)
  lbicc2 $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) -> A e. ( A [,] B ) ) $=
    ( cxr wcel cle wbr w3a cicc co simp1 xrleid 3ad2ant1 simp3 elicc1 mpbir3and
    wb 3adant3 ) ACDZBCDZABEFZGAABHIDZRAAEFZTRSTJRSUBTAKLRSTMRSUARUBTGPTABANQO
    $.

  $( The upper bound of a closed interval is a member of it.  (Contributed by
     Paul Chapman, 26-Nov-2007.)  (Revised by FL, 29-May-2014.) $)
  ubicc2 $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) -> B e. ( A [,] B ) ) $=
    ( cxr wcel cle wbr w3a cicc co simp2 simp3 xrleid 3ad2ant2 elicc1 mpbir3and
    wb 3adant3 ) ACDZBCDZABEFZGBABHIDZSTBBEFZRSTJRSTKSRUBTBLMRSUASTUBGPTABBNQO
    $.

  $( Zero is an element of the closed unit.  (Contributed by Scott Fenton,
     11-Jun-2013.) $)
  0elunit $p |- 0 e. ( 0 [,] 1 ) $=
    ( cc0 c1 cicc co wcel cr cle wbr 0re 0le0 0le1 1re elicc2i mpbir3an ) AABCD
    EAFEAAGHABGHIJKABAILMN $.

  $( One is an element of the closed unit.  (Contributed by Scott Fenton,
     11-Jun-2013.) $)
  1elunit $p |- 1 e. ( 0 [,] 1 ) $=
    ( c1 cc0 cicc co wcel cr cle wbr 1re 0le1 1le1 0re elicc2i mpbir3an ) ABACD
    EAFEBAGHAAGHIJKBAALIMN $.

  $( Membership in a negated open real interval.  (Contributed by Paul Chapman,
     26-Nov-2007.) $)
  iooneg $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( C e. ( A (,) B ) <-> -u C e. ( -u B (,) -u A ) ) ) $=
    ( cr wcel w3a clt wbr wa cneg cioo co ltneg 3adant2 cxr rexr elioo5 renegcl
    wb syl3an ancoms 3adant1 anbi12d ancom syl6bb 3com12 3bitr4d ) ADEZBDEZCDEZ
    FZACGHZCBGHZIZBJZCJZGHZUPAJZGHZIZCABKLEZUPUOURKLEZUKUNUSUQIUTUKULUSUMUQUHUJ
    ULUSSUIACMNUIUJUMUQSZUHUJUIVCCBMUAUBUCUSUQUDUEUHAOEUIBOEUJCOEVAUNSAPBPCPABC
    QTUIUHUJVBUTSZUIUODEZUHURDEZUJUPDEZVDBRARCRVEUOOEVFUROEVGUPOEVDUOPURPUPPUOU
    RUPQTTUFUG $.

  $( Membership in a negated closed real interval.  (Contributed by Paul
     Chapman, 26-Nov-2007.) $)
  iccneg $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                  ( C e. ( A [,] B ) <-> -u C e. ( -u B [,] -u A ) ) ) $=
    ( cr wcel w3a cle wbr wa cneg cicc co renegcl anbi12d elicc2 3adant3 3anass
    wb leneg syl6bb ax-1 impbid2 3ad2ant3 ancom 3adant1 3adant2 syl5bbr syl2anr
    ancoms 3bitr4d ) ADEZBDEZCDEZFZUMACGHZCBGHZIZIZCJZDEZBJZUSGHZUSAJZGHZIZIZCA
    BKLEZUSVAVCKLEZUNUMUTUQVEUMUKUMUTRULUMUMUTCMUMUTUAUBUCUQUPUOIUNVEUPUOUDUNUP
    VBUOVDULUMUPVBRZUKUMULVICBSUIUEUKUMUOVDRULACSUFNUGNUNVGUMUOUPFZURUKULVGVJRU
    MABCOPUMUOUPQTUNVHUTVBVDFZVFUKULVHVKRZUMULVADEVCDEVLUKBMAMVAVCUSOUHPUTVBVDQ
    TUJ $.

  $( A shifted real is a member of a shifted, closed-below, open-above real
     interval.  (Contributed by Paul Chapman, 25-Mar-2008.) $)
  icoshft $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) -> ( X e. ( A [,) B ) ->
                  ( X + C ) e. ( ( A + C ) [,) ( B + C ) ) ) ) $=
    ( cr wcel w3a cico co cle wbr clt wa caddc wi cxr wb rexr elico2 readdcl
    sylan2 biimpd 3adant3 3anass syl6ib leadd1 3com12 3expib 3adant2 imp ltadd1
    com12 3adant1 anbi12d pm5.32da expcom syl6ibr 3ad2ant3 biimprd syl2anc syld
    anim1d sylbid ) AEFZBEFZCEFZGZDABHIFZDEFZADJKZDBLKZMZMZDCNIZACNIZBCNIZHIFZV
    GVHVIVJVKGZVMVDVEVHVROVFVDVEMVHVRVEVDBPFVHVRQBRABDSUAUBUCVIVJVKUDUEVGVMVIVO
    VNJKZVNVPLKZMZMZVQVGVIVLWAVGVIMVJVSVKVTVGVIVJVSQZVDVFVIWCOVEVIVDVFMWCVIVDVF
    WCVDVIVFWCADCUFUGUHULUIUJVGVIVKVTQZVEVFVIWDOVDVIVEVFMWDVIVEVFWDDBCUKUHULUMU
    JUNUOVGWBVNEFZVSVTGZVQVFVDWBWFOVEVFWBWEWAMWFVFVIWEWAVIVFWEDCTUPVBWEVSVTUDUQ
    URVGVOEFZVPEFZWFVQOVDVFWGVEACTUIVEVFWHVDBCTUMWGWHMVQWFWHWGVPPFVQWFQVPRVOVPV
    NSUAUSUTVAVCVA $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d y F $.
    icoshftf1o.1 $e |- F = ( x e. ( A [,) B ) |-> ( x + C ) ) $.
    $( Shifting a closed-below, open-above interval is one-to-one onto.
       (Contributed by Paul Chapman, 25-Mar-2008.)  (Proof shortened by Mario
       Carneiro, 1-Sep-2015.) $)
    icoshftf1o $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
        F : ( A [,) B ) -1-1-onto-> ( ( A + C ) [,) ( B + C ) ) ) $=
      ( vy cr wcel cv caddc co cico wral wceq wreu icoshft cmin recnd negsubd
      wf1o ralrimiv wa cneg wi readdcl 3adant2 3adant1 renegcl 3ad2ant3 syl3anc
      w3a imp cxr rexrd icossre syl2anc sselda simpl3 simp3 simp1 eqtrd oveq12d
      wss pncand simp2 adantr 3eltr3d reueq sylib simpll3 simpl1 subadd2d eqcom
      simpl2 3bitr4g reubidva mpbid ralrimiva f1ompt sylanbrc ) BHIZCHIZDHIZULZ
      AJZDKLZBDKLZCDKLZMLZIZABCMLZNGJZWGOZAWLPZGWJNWLWJEUAWEWKAWLBCDWFQUBWEWOGW
      JWEWMWJIZUCZWFWMDRLZOZAWLPZWOWQWRWLIWTWQWMDUDZKLZWHXAKLZWIXAKLZMLZWRWLWEW
      PXBXEIZWEWHHIZWIHIZXAHIZWPXFUEWBWDXGWCBDUFUGZWCWDXHWBCDUFUHZWDWBXIWCDUIUJ
      WHWIXAWMQUKUMWQWMDWQWMWEWJHWMWEXGWIUNIWJHVDXJWEWIXKUOWHWIUPUQURZSWQDWBWCW
      DWPUSSTWEXEWLOWPWEXCBXDCMWEXCWHDRLBWEWHDWEWHXJSWEDWBWCWDUTSZTWEBDWEBWBWCW
      DVASXMVEVBWEXDWIDRLCWEWIDWEWIXKSXMTWECDWECWBWCWDVFSXMVEVBVCVGVHAWLWRVIVJW
      QWSWNAWLWQWFWLIZUCZWRWFOWGWMOWSWNXOWMDWFXOWMWQWMHIXNXLVGSXODWBWCWDWPXNVKS
      XOWFWQWLHWFWQWBCUNIWLHVDWBWCWDWPVLWQCWBWCWDWPVOUOBCUPUQURSVMWFWRVNWMWGVNV
      PVQVRVSAGWLWJWGEFVTWA $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.  $d w x y z D $.
    $( The union of end-to-end closed-below, open-above real intervals.
       (Contributed by Paul Chapman, 15-Mar-2008.)  (Proof shortened by Mario
       Carneiro, 16-Jun-2014.) $)
    icoun $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
                    ( A <_ B /\ B <_ C ) ) ->
                  ( ( A [,) B ) u. ( B [,) C ) ) = ( A [,) C ) ) $=
      ( vx vy vz vw cico cle clt df-ico cv xrlenlt xrltletr xrletr ixxun ) DEFG
      ABCHHIJIJHIIDEFKZQBGLZMQRBCNABROP $.

    $( End-to-end closed-below, open-above real intervals are disjoint.
       (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    icodisj $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
                    ( ( A [,) B ) i^i ( B [,) C ) ) = (/) ) $=
      ( vx cxr wcel w3a cico co cin c0 wss wceq wa clt wbr cle wb elico1 biimpa
      cv 3adant3 simp3d adantrr wn 3adant1 simp2d simpl2 simp1d xrlenlt syl2anc
      elin mpbid adantrl pm2.65da pm2.21d syl5bi ssrdv ss0 syl ) AEFZBEFZCEFZGZ
      ABHIZBCHIZJZKLVGKMVDDVGKDUAZVGFVHVEFZVHVFFZNZVDVHKFZVHVEVFULVDVKVLVDVKVHB
      OPZVDVIVMVJVDVINVHEFZAVHQPZVMVDVIVNVOVMGZVAVBVIVPRVCABVHSUBTUCUDVDVJVMUEZ
      VIVDVJNZBVHQPZVQVRVNVSVHCOPZVDVJVNVSVTGZVBVCVJWARVABCVHSUFTZUGVRVBVNVSVQR
      VAVBVCVJUHVRVNVSVTWBUIBVHUJUKUMUNUOUPUQURVGUSUT $.

    $( The closure of one end of an open real interval.  (Contributed by Paul
       Chapman, 15-Mar-2008.)  (Proof shortened by Mario Carneiro,
       16-Jun-2014.) $)
    snunioo $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) ->
                    ( { A } u. ( A (,) B ) ) = ( A [,) B ) ) $=
      ( vx vy vz vw cxr wcel clt wbr w3a cicc co cioo cun csn cico wceq syl cle
      simp1 iccid uneq1d simp2 xrleid simp3 df-icc df-ioo cv df-ico xrlelttr wi
      xrltnle xrltle 3adant1 adantld ixxun syl32anc eqtr3d ) AGHZBGHZABIJZKZAAL
      MZABNMZOZAPZVEOABQMZVCVDVGVEVCUTVDVGRUTVAVBUAZAUBSUCVCUTUTVAAATJZVBVFVHRV
      IVIUTVAVBUDVCUTVJVIAUESUTVAVBUFCDEFAABNQTTIILTICDEUGCDEUHAFUIZUMCDEUJVKAB
      UKUTUTVKGHZKAVKIJZAVKTJZVJUTVLVMVNULUTAVKUNUOUPUQURUS $.

    $( The closure of the open end of a right-open real interval.  (Contributed
       by Mario Carneiro, 16-Jun-2014.) $)
    snunico $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
                    ( ( A [,) B ) u. { B } ) = ( A [,] B ) ) $=
      ( vx vy vz vw cxr wcel cle wbr w3a cico cicc cun csn wceq simp2 syl clt
      co iccid uneq2d simp1 xrleid df-ico df-icc xrlenlt xrltle 3adant3 adantrd
      simp3 cv wi xrletr ixxun syl32anc eqtr3d ) AGHZBGHZABIJZKZABLTZBBMTZNZVBB
      OZNABMTZVAVCVEVBVAUSVCVEPURUSUTQZBUARUBVAURUSUSUTBBIJZVDVFPURUSUTUCVGVGUR
      USUTUKVAUSVHVGBUDRCDEFABBMMISIILIICDEUECDEUFZBFULZUGVIVJGHZUSUSKVJBSJZVJB
      IJZVHVKUSVLVMUMUSVJBUHUIUJABVJUNUOUPUQ $.

    $( The closure of an open real interval.  (Contributed by Paul Chapman,
       15-Mar-2008.)  (Proof shortened by Mario Carneiro, 16-Jun-2014.) $)
    prunioo $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
                    ( ( A (,) B ) u. { A , B } ) = ( A [,] B ) ) $=
      ( cxr wcel cle wbr w3a cioo co cpr cun cicc wceq simp3 uncom syl5eq oveq2
      csn c0 syl5eqr clt wo wb xrleloe 3adant3 cico df-pr uneq2i eqtr4i snunioo
      wa unass uneq1d 3expa 3adantl3 snunico adantr eqtrd iccid 3ad2ant1 eqcomd
      ex un0 eqtri iooid dfsn2 preq2 uneq12d eqeq12d syl5ibcom jaod sylbid mpd
      ) ACDZBCDZABEFZGZVPABHIZABJZKZABLIZMZVNVOVPNVQVPABUAFZABMZUBZWBVNVOVPWEUC
      VPABUDUEVQWCWBWDVQWCWBVQWCUKVTABUFIZBRZKZWAVNVOWCVTWHMZVPVNVOWCWIVNVOWCGZ
      VTVRARZKZWGKZWHVTVRWKWGKZKWMVSWNVRABUGUHVRWKWGULUIWJWLWFWGWJWLWKVRKWFVRWK
      OABUJPUMPUNUOVQWHWAMWCABUPUQURVBVQWKAALIZMWDWBVQWOWKVNVOWOWKMVPAUSUTVAWDW
      KVTWOWAWDWKSWKKZVTWPWKSKWKSWKOWKVCVDWDSVRWKVSWDSAAHIVRAVEABAHQTWDWKAAJVSA
      VFABAVGPVHTABALQVIVJVKVLVM $.

    $( If the upper bound of one open interval is less than or equal to the
       lower bound of the other, the intervals are disjoint.  (Contributed by
       Jeff Hankins, 13-Jul-2009.) $)
    ioodisj $p |- ( ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) )
     /\ B <_ C ) -> ( ( A (,) B ) i^i ( C (,) D ) ) = (/) ) $=
      ( vx vy vz vw cxr wcel wa cle cioo co cin c0 wss wceq cicc syl wbr iooss1
      simpllr sylancom ioossicc syl6ss sslin simplll simplrr clt df-ioo xrlenlt
      df-icc cv ixxdisj syl3anc sseqtrd ss0 ) AIJZBIJZKZCIJZDIJZKZKZBCLUAZKZABM
      NZCDMNZOZPQVJPRVGVJVHBDSNZOZPVGVIVKQVJVLQVGVIBDMNZVKVEVFUTVIVMQUSUTVDVFUC
      ZBCDUBUDBDUEUFVIVKVHUGTVGUSUTVCVLPRUSUTVDVFUHVNVAVBVCVFUIEFGHABDSUJUJLLME
      FGUKEFGUMBHUNULUOUPUQVJURT $.

    $( Join two open intervals to create a third.  (Contributed by NM,
       11-Aug-2008.)  (Proof shortened by Mario Carneiro, 16-Jun-2014.) $)
    ioojoin $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
                    ( A < B /\ B < C ) ) ->
                 ( ( ( A (,) B ) u. { B } ) u. ( B (,) C ) ) = ( A (,) C ) ) $=
      ( vx vy vz vw cxr wcel w3a clt wbr wa cioo co csn cun unass cico wceq cle
      snunioo 3expa 3adantl1 adantrl uneq2d df-ioo df-ico xrlttr xrltletr ixxun
      cv xrlenlt eqtrd syl5eq ) AHIZBHIZCHIZJZABKLZBCKLZMMZABNOZBPZQBCNOZQVCVDV
      EQZQZACNOZVCVDVERVBVGVCBCSOZQVHVBVFVIVCUSVAVFVITZUTUQURVAVJUPUQURVAVJBCUB
      UCUDUEUFDEFGABCSNKKUAKNKKDEFUGZDEFUHBGULZUMVKVLBCUIABVLUJUKUNUO $.

    $( The class difference of ` RR ` and a closed interval.  (Contributed by
       FL, 18-Jun-2007.) $)
    difreicc $p |- ( ( A e. RR /\ B e. RR ) -> ( RR \ ( A [,] B ) ) =
      ( ( -oo (,) A ) u. ( B (,) +oo ) ) ) $=
      ( cr wcel wa co cmnf cpnf wn cxr wbr w3a wb adantr wi adantl clt ad2antlr
      ex syl5bi vx cicc cdif cioo cun cv eldif wo cle rexr elicc1 syl2an notbid
      3anass notbii ianor pm2.24d mnflt simpr simpll ltnle bicomd syl2anc mnfxr
      biimpa ad3antrrr sylancr mpbir3and adantll ltpnf ad3antlr sylancl sylbird
      elioo1 pnfxr orim12d jaod sylbid expimpd elun syl6ibr ioossre unssi sseli
      elioo2 biimpd a1i com13 3impd xrltnle com3l com14 syl imp intnand sylnibr
      sylibr anim12i mpbird jca impbid syl5bb eqrdv ) ACDZBCDZEZUACABUBFZUCZGAU
      DFZBHUDFZUEZUAUFZXHDXLCDZXLXGDZIZEZXFXLXKDZXLCXGUGXFXPXQXFXPXLXIDZXLXJDZU
      HZXQXFXMXOXTXFXMEZXOXLJDZAXLUIKZXLBUIKZLZIZXTYAXNYEXFXNYEMZXMXDAJDZBJDZYG
      XEAUJZBUJZABXLUKZULNUMYFYBYCYDEZEZIZYAXTYEYNYBYCYDUNZUOYOYBIZYMIZUHYAXTYB
      YMUPYAYQXTYRXMYQXTOXFXMYBXTXLUJZUQPYRYCIZYDIZUHZYAXTYCYDUPZYAYTXRUUAXSYAY
      TXRYAYTEZXRYBGXLQKZXLAQKZXMYBXFYTYSRXMUUEXFYTXLURRYAYTUUFYAXMXDYTUUFMXFXM
      USXDXEXMUTXMXDEZUUFYTXLAVAZVBVCVEUUDGJDZYHXRYBUUEUUFLMVDXDYHXEXMYTYJVFGAX
      LVNVGVHSYAUUABXLQKZXSXEXMUUJUUAMXDBXLVAVIYAUUJXSYAUUJEZXSYBUUJXLHQKZXMYBX
      FUUJYSRYAUUJUSXMUULXFUUJXLVJRUUKYIHJDZXSYBUUJUULLZMZXEYIXDXMUUJYKVKVOBHXL
      VNZVLVHSVMVPTVQTTVRVSXLXIXJVTZWAXFXQXPXFXQEZXMXOXQXMXFXKCXLXIXJCGAWBBHWBW
      CWDPUURXOYFUURYNYEUURYMYBUURUUBYRXFXQUUBXQXTXFUUBUUQXFXRYTXSUUAXFXRXMUUEU
      UFLZYTXDXRUUSMZXEXDUUIYHUUTVDYJGAXLWEVGNXFXMUUEUUFYTXDXMUUEUUFYTOZOOXEUUE
      XMXDUVAXMXDUVAOOUUEXMXDUVAUUGUUFYTUUHWFSWGWHNWIVRXFXSUUNUUAXFYIUUMUUOXEYI
      XDYKPVOUUPVLXFYBUUJUULUUAXEYBUUJUULUUAOOOZXDXEYIUVBYKUULYBUUJYIUUAYBUUJYI
      UUAOOOUULYIYBUUJUUAYIYBUUJUUAOYIYBEUUJUUABXLWJWFSWKWGWLWMPWIVRVPTWNUUCWQW
      OYPWPUURYHYIEZXOYFMXFUVCXQXDYHXEYIYJYKWRNUVCXNYEYLUMWMWSWTSXAXBXC $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Split a closed interval into the union of two closed intervals.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    iccsplit $p |- ( ( A e. RR /\ B e. RR /\ C e. ( A [,] B ) ) ->
                        ( A [,] B ) = ( ( A [,] C ) u. ( C [,] B ) ) ) $=
      ( cr wcel cicc co w3a cle wbr wa 3impia simp1 a1i simp2 3ad2ant3 3ad2ant2
      wi elicc2 wb vx cun cv wo clt simplr1 simplr2 simpr1 iccssre sseld adantr
      ltle syl2anc 3jca orcd simpr simplr3 olcd ltlecasei ex simp1r simp3 letrd
      imp 3exp sylbid 3jcad simp1l jaod impbid 3adant3 imdistani adantlr ancoms
      3impa adantll orbi12d syl 3bitr4d elun syl6bbr eqrdv ) ADEZBDEZCABFGZEZHZ
      UAWEACFGZCBFGZUBZWGUAUCZWEEZWKWHEZWKWIEZUDZWKWJEWGWKDEZAWKIJZWKBIJZHZWPWQ
      WKCIJZHZWPCWKIJZWRHZUDZWLWOWGWSXDWGWSXDWGWSKZXDWKCXEWKCUEJZKZXAXCXGWPWQWT
      WPWQWRWGXFUFWPWQWRWGXFUGXEXFWTXEWPCDEZXFWTRWGWPWQWRUHZWGXHWSWCWDWFXHWCWDK
      ZWEDCABUIUJZLUKZWKCULUMVDUNUOXEXBKZXCXAXMWPXBWRWPWQWRWGXBUFXEXBUPWPWQWRWG
      XBUQUNURXIXLUSUTWGXAWSXCWGXAWPWQWRXAWPRWGWPWQWTMZNXAWQRWGWPWQWTONWCWDWFXA
      WRRZXJWFXHACIJZCBIJZHZXOABCSZXJXRXAWRXJXRXAHWKCBXAXJWPXRXNPXRXJXHXAXHXPXQ
      MZQWCWDXRXAVAXAXJWTXRWPWQWTVBPXRXJXQXAXHXPXQVBQVCVEVFLVGWGXCWPWQWRXCWPRWG
      WPXBWRMZNWCWDWFXCWQRZXJWFXRYBXSXJXRXCWQXJXRXCHACWKWCWDXRXCVHXRXJXHXCXTQXC
      XJWPXRYAPXRXJXPXCXHXPXQOQXCXJXBXRWPXBWROPVCVEVFLXCWRRWGWPXBWRVBNVGVIVJWCW
      DWLWSTWFABWKSVKWGXJXHKZWOXDTWCWDWFYCXJWFXHXKVLVOYCWMXAWNXCWCXHWMXATWDACWK
      SVMWDXHWNXCTZWCXHWDYDCBWKSVNVPVQVRVSWKWHWIVTWAWB $.
  $}

  ${
    iccshftr.1 $e |- ( A + R ) = C $.
    iccshftr.2 $e |- ( B + R ) = D $.
    $( Membership in a shifted interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    iccshftr $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR ) )
                  -> ( X e. ( A [,] B ) <-> ( X + R ) e. ( C [,] D ) ) ) $=
      ( cr wcel wa cle wbr w3a caddc co cicc wb readdcl leadd1 simpl 2thd 3expb
      adantl adantlr breq1i syl6bb an12s adantll breq2i 3anbi123d elicc2 adantr
      syl5eqelr syl2an anandirs adantrl 3bitr4d ) AIJZBIJZKZFIJZEIJZKZKZVBAFLMZ
      FBLMZNZFEOPZIJZCVILMZVIDLMZNZFABQPJZVICDQPJZVEVBVJVFVKVGVLVDVBVJRVAVDVBVJ
      VBVCUAFESUBUDVEVFAEOPZVILMZVKUSVDVFVQRZUTUSVBVCVRAFETUCUEVPCVILGUFUGVEVGV
      IBEOPZLMZVLUTVDVGVTRZUSVBUTVCWAVBUTVCWAFBETUCUHUIVSDVILHUJUGUKVAVNVHRVDAB
      FULUMVAVCVOVMRZVBUSUTVCWBUSVCKZCIJDIJWBUTVCKZWCCVPIGAESUNWDDVSIHBESUNCDVI
      ULUOUPUQUR $.
  $}

  ${
    iccshftri.1 $e |- A e. RR $.
    iccshftri.2 $e |- B e. RR $.
    iccshftri.3 $e |- R e. RR $.
    iccshftri.4 $e |- ( A + R ) = C $.
    iccshftri.5 $e |- ( B + R ) = D $.
    $( Membership in a shifted interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    iccshftri $p |- ( X e. ( A [,] B ) -> ( X + R ) e. ( C [,] D ) ) $=
      ( cr wcel cicc co caddc wss iccssre mp2an sseli wb iccshftr mpanl12 mpan2
      wa biimpd mpcom ) FLMZFABNOZMZFEPOCDNOMZUILFALMZBLMZUILQGHABRSTUHUJUKUHEL
      MZUJUKUAZIULUMUHUNUEUOGHABCDEFJKUBUCUDUFUG $.
  $}

  ${
    iccshftl.1 $e |- ( A - R ) = C $.
    iccshftl.2 $e |- ( B - R ) = D $.
    $( Membership in a shifted interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    iccshftl $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR ) )
                  -> ( X e. ( A [,] B ) <-> ( X - R ) e. ( C [,] D ) ) ) $=
      ( cr wcel wa cle wbr w3a cmin co cicc wb resubcl lesub1 simpl 2thd adantl
      3expb adantlr breq1i syl6bb adantll breq2i 3anbi123d elicc2 adantr syl2an
      an12s syl5eqelr anandirs adantrl 3bitr4d ) AIJZBIJZKZFIJZEIJZKZKZVBAFLMZF
      BLMZNZFEOPZIJZCVILMZVIDLMZNZFABQPJZVICDQPJZVEVBVJVFVKVGVLVDVBVJRVAVDVBVJV
      BVCUAFESUBUCVEVFAEOPZVILMZVKUSVDVFVQRZUTUSVBVCVRAFETUDUEVPCVILGUFUGVEVGVI
      BEOPZLMZVLUTVDVGVTRZUSVBUTVCWAVBUTVCWAFBETUDUNUHVSDVILHUIUGUJVAVNVHRVDABF
      UKULVAVCVOVMRZVBUSUTVCWBUSVCKZCIJDIJWBUTVCKZWCCVPIGAESUOWDDVSIHBESUOCDVIU
      KUMUPUQUR $.
  $}

  ${
    iccshftli.1 $e |- A e. RR $.
    iccshftli.2 $e |- B e. RR $.
    iccshftli.3 $e |- R e. RR $.
    iccshftli.4 $e |- ( A - R ) = C $.
    iccshftli.5 $e |- ( B - R ) = D $.
    $( Membership in a shifted interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    iccshftli $p |- ( X e. ( A [,] B ) -> ( X - R ) e. ( C [,] D ) ) $=
      ( cr wcel cicc co cmin wss iccssre mp2an sseli wb iccshftl mpanl12 biimpd
      wa mpan2 mpcom ) FLMZFABNOZMZFEPOCDNOMZUILFALMZBLMZUILQGHABRSTUHUJUKUHELM
      ZUJUKUAZIULUMUHUNUEUOGHABCDEFJKUBUCUFUDUG $.
  $}

  ${
    iccdil.1 $e |- ( A x. R ) = C $.
    iccdil.2 $e |- ( B x. R ) = D $.
    $( Membership in a dilated interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    iccdil $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR+ ) )
                  -> ( X e. ( A [,] B ) <-> ( X x. R ) e. ( C [,] D ) ) ) $=
      ( cr wcel wa cle wbr w3a cmul co cicc wb remulcl sylan2 simpl rpre adantl
      crp 2thd cc0 clt elrp lemul1 syl3an3b 3expb adantlr breq1i syl6bb adantll
      breq2i 3anbi123d elicc2 adantr syl5eqelr syl2an anandirs adantrl 3bitr4d
      an12s ) AIJZBIJZKZFIJZEUDJZKZKZVIAFLMZFBLMZNZFEOPZIJZCVPLMZVPDLMZNZFABQPJ
      ZVPCDQPJZVLVIVQVMVRVNVSVKVIVQRVHVKVIVQVIVJUAVJVIEIJZVQEUBZFESTUEUCVLVMAEO
      PZVPLMZVRVFVKVMWFRZVGVFVIVJWGVJVFVIWCUFEUGMKZWGEUHZAFEUIUJUKULWECVPLGUMUN
      VLVNVPBEOPZLMZVSVGVKVNWKRZVFVIVGVJWLVIVGVJWLVJVIVGWHWLWIFBEUIUJUKVEUOWJDV
      PLHUPUNUQVHWAVORVKABFURUSVHVJWBVTRZVIVJVHWCWMWDVFVGWCWMVFWCKZCIJDIJWMVGWC
      KZWNCWEIGAESUTWODWJIHBESUTCDVPURVAVBTVCVD $.
  $}

  ${
    iccdili.1 $e |- A e. RR $.
    iccdili.2 $e |- B e. RR $.
    iccdili.3 $e |- R e. RR+ $.
    iccdili.4 $e |- ( A x. R ) = C $.
    iccdili.5 $e |- ( B x. R ) = D $.
    $( Membership in a dilated interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    iccdili $p |- ( X e. ( A [,] B ) -> ( X x. R ) e. ( C [,] D ) ) $=
      ( cr wcel cicc co cmul wss iccssre mp2an sseli wb wa iccdil mpanl12 mpan2
      crp biimpd mpcom ) FLMZFABNOZMZFEPOCDNOMZUJLFALMZBLMZUJLQGHABRSTUIUKULUIE
      UFMZUKULUAZIUMUNUIUOUBUPGHABCDEFJKUCUDUEUGUH $.
  $}

  ${
    icccntr.1 $e |- ( A / R ) = C $.
    icccntr.2 $e |- ( B / R ) = D $.
    $( Membership in a contracted interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    icccntr $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( X e. RR /\ R e. RR+ ) )
                  -> ( X e. ( A [,] B ) <-> ( X / R ) e. ( C [,] D ) ) ) $=
      ( cr wcel wa cle wbr w3a cdiv co cicc wb rerpdivcl lediv1 crp 2thd adantl
      simpl cc0 clt elrp syl3an3b 3expb adantlr breq1i syl6bb adantll 3anbi123d
      an12s breq2i elicc2 adantr syl5eqelr syl2an anandirs adantrl 3bitr4d ) AI
      JZBIJZKZFIJZEUAJZKZKZVGAFLMZFBLMZNZFEOPZIJZCVNLMZVNDLMZNZFABQPJZVNCDQPJZV
      JVGVOVKVPVLVQVIVGVORVFVIVGVOVGVHUDFESUBUCVJVKAEOPZVNLMZVPVDVIVKWBRZVEVDVG
      VHWCVHVDVGEIJUEEUFMKZWCEUGZAFETUHUIUJWACVNLGUKULVJVLVNBEOPZLMZVQVEVIVLWGR
      ZVDVGVEVHWHVGVEVHWHVHVGVEWDWHWEFBETUHUIUOUMWFDVNLHUPULUNVFVSVMRVIABFUQURV
      FVHVTVRRZVGVDVEVHWIVDVHKZCIJDIJWIVEVHKZWJCWAIGAESUSWKDWFIHBESUSCDVNUQUTVA
      VBVC $.
  $}

  ${
    icccntri.1 $e |- A e. RR $.
    icccntri.2 $e |- B e. RR $.
    icccntri.3 $e |- R e. RR+ $.
    icccntri.4 $e |- ( A / R ) = C $.
    icccntri.5 $e |- ( B / R ) = D $.
    $( Membership in a contracted interval.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    icccntri $p |- ( X e. ( A [,] B ) -> ( X / R ) e. ( C [,] D ) ) $=
      ( cr wcel cicc co cdiv wss iccssre mp2an sseli crp icccntr mpanl12 biimpd
      wb wa mpan2 mpcom ) FLMZFABNOZMZFEPOCDNOMZUJLFALMZBLMZUJLQGHABRSTUIUKULUI
      EUAMZUKULUEZIUMUNUIUOUFUPGHABCDEFJKUBUCUGUDUH $.
  $}

  ${
    $( A linear combination of two reals which lies in the interval between
       them.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by
       Mario Carneiro, 8-Sep-2015.) $)
    lincmb01cmp $p |- ( ( ( A e. RR /\ B e. RR /\ A < B ) /\ T e. ( 0 [,] 1 ) )
                    -> ( ( ( 1 - T ) x. A ) + ( T x. B ) ) e. ( A [,] B ) ) $=
      ( cr wcel wbr cc0 c1 cicc co cmin cmul caddc 0re a1i 1re cle eqid recnd
      wb clt w3a simpr crp elicc2i simp1bi adantl difrp biimp3a adantr syl22anc
      wa iccdil simpl2 simpl1 resubcld mul02d mulid2d oveq12d remulcld iccshftr
      eleqtrd mulcld subadd23d subdid oveq1d resubcl sylancr addcomd cc subdird
      mpbid ax-1cn eqtrd oveq2d 3eqtr4d addid2d npcand 3eltr3d ) ADEZBDEZABUAFZ
      UBZCGHIJEZULZCBAKJZLJZAMJZGAMJZWFAMJZIJZHCKJZALJZCBLJZMJZABIJWEWGGWFIJZEZ
      WHWKEZWEWGGWFLJZHWFLJZIJZWPWEWDWGXAEZWCWDUCWEGDEZHDEZCDEZWFUDEZWDXBTXCWEN
      OZXDWEPOWDXEWCWDXEGCQFCHQFGHCNPUEUFUGZWCXFWDVTWAWBXFABUHUIUJGHWSWTWFCWSRW
      TRUMUKVLWEWSGWTWFIWEWFWEWFWEBAVTWAWBWDUNZVTWAWBWDUOZUPZSZUQWEWFXLURUSVBWE
      XCWFDEWGDEVTWQWRTXGXKWECWFXHXKUTXJGWFWIWJAWGWIRWJRVAUKVLWEWNCALJZKJZAMJWN
      AXMKJZMJZWHWOWEWNXMAWECBWECXHSZWEBXISZVCZWECAXQWEAXJSZVCXTVDWEWGXNAMWECBA
      XQXRXTVEVFWEWOWNWMMJXPWEWMWNWEWMWEWLAWEXDXEWLDEPXHHCVGVHXJUTSXSVIWEWMXOWN
      MWEWMHALJZXMKJXOWEHCAHVJEWEVMOXQXTVKWEYAAXMKWEAXTURVFVNVOVNVPWEWIAWJBIWEA
      XTVQWEBAXRXTVRUSVS $.
  $}

  ${
    $d x y A $.  $d x y B $.
    iccf1o.1 $e |- F = ( x e. ( 0 [,] 1 ) |->
      ( ( x x. B ) + ( ( 1 - x ) x. A ) ) ) $.
    $( Describe a bijection from ` [ 0 , 1 ] ` to an arbitrary nontrivial
       closed interval ` [ A , B ] ` .  (Contributed by Mario Carneiro,
       8-Sep-2015.) $)
    iccf1o $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
      ( F : ( 0 [,] 1 ) -1-1-onto-> ( A [,] B ) /\ `' F =
        ( y e. ( A [,] B ) |-> ( ( y - A ) / ( B - A ) ) ) ) ) $=
      ( cr wcel wbr cc0 c1 cicc co cmul cmin caddc recnd cc wceq adantrl clt cv
      w3a cdiv wa cle 0re 1re elicc2i simp1bi adantl simpl2 mulcld ax-1cn subcl
      sylancr simpl1 addcomd lincmb01cmp eqeltrd simpr wb elicc2 3adant3 biimpa
      simp1d iccshftl syl22anc mpbid resubcld difrp biimp3a adantr rpcnd rpne0d
      eqid crp divcan1d mul02d subidd eqtr4d mulid2d oveq12d 3eltr4d rerpdivcld
      a1i iccdil mpbird adantrr wne divmul3d syl5bb remulcld subadd2d subadd23d
      eqcom syl6bb subdid oveq1d subdird oveq2d 3eqtr4d eqeq2d 3bitrd f1ocnv2d
      eqtrd ) CGHZDGHZCDUAIZUCZABJKLMZCDLMZAUBZDNMZKXMOMZCNMZPMZBUBZCOMZDCOMZUD
      MZEFXJXMXKHZUEZXQXPXNPMXLYCXNXPYCXMDYCXMYBXMGHZXJYBYDJXMUFIXMKUFIJKXMUGUH
      UIUJUKZQZYCDXGXHXIYBULZQZUMZYCXOCYCKRHZXMRHZXORHUNYFKXMUOUPYCCXGXHXIYBUQZ
      QZUMURCDXMUSUTXJXRXLHZUEZYAXKHZYAXTNMZJXTNMZKXTNMZLMZHZYOXSCCOMZXTLMZYQYT
      YOYNXSUUCHZXJYNVAYOXGXHXRGHZXGYNUUDVBXGXHXIYNUQZXGXHXIYNULYOUUECXRUFIZXRD
      UFIZXJYNUUEUUGUUHUCZXGXHYNUUIVBXICDXRVCVDVEVFZUUFCDUUBXTCXRUUBVPXTVPVGVHV
      IYOXSXTYOXSYOXRCUUJUUFVJZQZYOXTXJXTVQHZYNXGXHXIUUMCDVKVLVMZVNZYOXTUUNVOZV
      RYOYRUUBYSXTLYOYRJUUBYOXTUUOVSYOCYOCUUFQZVTWAYOXTUUOWBWCWDYOJGHZKGHZYAGHU
      UMYPUUAVBUURYOUGWFUUSYOUHWFYOXSXTUUKUUNWEUUNJKYRYSXTYAYRVPYSVPWGVHWHXJYBY
      NUEUEZXMYASZXSXMXTNMZSZXRUVBCPMZSZXRXQSUVAYAXMSUUTUVCXMYAWPUUTXSXMXTXJYNX
      SRHYBUULTXJYBYKYNYFWIXJYNXTRHYBUUOTXJYNXTJWJYBUUPTWKWLUUTUVCUVDXRSUVEUUTX
      RCUVBUUTXRXJYNUUEYBUUJTQXJYNCRHYBUUQTUUTUVBXJYBUVBGHYNYCXMXTYEYCDCYGYLVJW
      MWIQWNUVDXRWPWQUUTUVDXQXRXJYBUVDXQSYNYCXNXMCNMZOMZCPMXNCUVFOMZPMUVDXQYCXN
      UVFCYIYCXMCYFYMUMYMWOYCUVBUVGCPYCXMDCYFYHYMWRWSYCXPUVHXNPYCXPKCNMZUVFOMUV
      HYCKXMCYJYCUNWFYFYMWTYCUVICUVFOYCCYMWBWSXFXAXBWIXCXDXE $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Any nontrivial closed interval is equinumerous to the unit interval.
       (Contributed by Mario Carneiro, 26-Jul-2014.)  (Revised by Mario
       Carneiro, 8-Sep-2015.) $)
    iccen $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
      ( 0 [,] 1 ) ~~ ( A [,] B ) ) $=
      ( vx vy cr wcel clt wbr w3a cc0 c1 cicc co cmul cmin caddc cmpt cvv ovex
      cv wf1o cen ccnv cdiv wceq eqid iccf1o simpld f1oen2g mp3an12 syl ) AEFBE
      FABGHIZJKLMZABLMZCUMCTZBNMKUOOMANMPMQZUAZUMUNUBHZULUQUPUCDUNDTAOMBAOMUDMQ
      UECDABUPUPUFUGUHUMRFUNRFUQURJKLSABLSUMUNUPRRUIUJUK $.
  $}

  ${
    xov1plusxeqvd.1 $e |- ( ph -> X e. CC ) $.
    xov1plusxeqvd.2 $e |- ( ph -> X =/= -u 1 ) $.
    $( A complex number ` X ` is positive real iff ` X / ( 1 + X ) ` is in
       ` ( 0 (,) 1 ) ` .  Deduction form.  (Contributed by David Moews,
       28-Feb-2017.) $)
    xov1plusxeqvd $p |- ( ph -> ( X e. RR+ <->
                              ( X / ( 1 + X ) ) e. ( 0 (,) 1 ) ) ) $=
      ( wcel c1 caddc co cdiv cc0 wa clt wbr a1i cmin ax-1cn wceq oveq1d adantr
      cr crp cioo simpr rpred 1rp rpaddcld rerpdivcld rprecred 1re 0re readdcld
      ltaddrpd recgt1i syl2anc simprd subid1i syl6breqr ltsub13d cc addcld cneg
      negcld addneintrd negidi neeqtrd divsubdird pncan2d dividd breqtrrd 1m1e0
      3eqtr3d simpld syl5eqbr ltsub23d eqbrtrd cxr w3a wb rexri mp2an syl3anbrc
      0xr elioo2 wne recrecd pncand sylib simp1d resubcld simp3d elrpd eqeltrrd
      eqeltrd addid1i simp2d reclt1d mpbid breqtrd ltadd2d mpbird impbida ) ABU
      AEZBFBGHZIHZJFUBHEZAXBKZXDTEZJXDLMZXDFLMZXEXFBXCXFBAXBUCZUDZXFFBFUAEXFUEN
      XJUFZUGXFJFFXCIHZOHZXDLXFXMFJXFXCXLUHZFTEZXFUINZJTEZXFUJNXFXMFFJOHZLXFJXM
      LMZXMFLMZXFXCTEFXCLMXTYAKXFFBXQXKUKXFFBXQXJULXCUMUNZUOFPUPZUQURAXDXNQXBAX
      CFOHZXCIHXCXCIHZXMOHXDXNAXCFXCAFBFUSEAPNZCUTZYFYGAXCFFVAZGHZJAFBYHYFCAFYF
      VBDVCYIJQAFPVDNVEZVFAYDBXCIAFBYFCVGZRAYEFXMOAXCYGYJVHZRVKSZVIXFXDXNFLYMXF
      FFXMXQXQXOXFFFOHZJXMLVJXFXTYAYBVLVMVNVOJVPEFVPEXEXGXHXIVQZVRWBFUIVSJFXDWC
      VTZWAAXEKZBYQYDBTAYDBQXEYKSYQXCFYQFXMIHZXCTYQXCAXCUSEXEYGSAXCJWDXEYJSWEZY
      QXMYQXMYQXMFXDOHZTAXMYTQXEAXCBOHZXCIHYEXDOHXMYTAXCBXCYGCYGYJVFAUUAFXCIAFB
      YFCWFRAYEFXDOYLRVKSZYQFXDXPYQUINZYQXGXHXIYQXEYOAXEUCYPWGZWHZWIWMYQJYTXMLY
      QXDFJUUEUUCXRYQUJNZYQXDFXSLYQXGXHXIUUDWJYCUQURUUBVIWKZUHWLUUCWIWLZYQJBLMF
      JGHZXCLMYQUUIFXCLFPWNYQFYRXCLYQYAFYRLMYQXMYTFLUUBYQFFXDUUCUUCUUEYQYNJXDLV
      JYQXGXHXIUUDWOVMVNVOYQXMUUGWPWQYSWRVMYQJBFUUFUUHUUCWSWTWKXA $.
  $}


  $( ` ( 0 [,] 1 ) ` is a subset of the reals.  (Contributed by David Moews,
     28-Feb-2017.) $)
  unitssre $p |- ( 0 [,] 1 ) C_ RR $=
    ( cc0 cr wcel c1 cicc co wss 0re 1re iccssre mp2an ) ABCDBCADEFBGHIADJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Finite intervals of integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ... $. $( Dots. $)

  $( Extend class notation to include the notation for a contiguous finite set
     of integers.  Read " ` M ... N ` " as "the set of integers from ` M ` to
     ` N ` inclusive." $)
  cfz $a class ... $.

  ${
    $d m n k z $.
    $( Define an operation that produces a finite set of sequential integers.
       Read " ` M ... N ` " as "the set of integers from ` M ` to ` N `
       inclusive."  See ~ fzval for its value and additional comments.
       (Contributed by NM, 6-Sep-2005.) $)
    df-fz $a |- ... = ( m e. ZZ , n e. ZZ |->
                  { k e. ZZ | ( m <_ k /\ k <_ n ) } ) $.
  $}

  ${
    $d k m n z M $.  $d k m n z N $.
    $( The value of a finite set of sequential integers.  E.g., ` 2 ... 5 `
       means the set ` { 2 , 3 , 4 , 5 } ` .  A special case of this definition
       (starting at 1) appears as Definition 11-2.1 of [Gleason] p. 141, where
       ` NN ` _k means our ` 1 ... k ` ; he calls these sets _segments_ of the
       integers.  (Contributed by NM, 6-Sep-2005.)  (Revised by Mario Carneiro,
       3-Nov-2013.) $)
    fzval $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M ... N ) =
                 { k e. ZZ | ( M <_ k /\ k <_ N ) } ) $=
      ( vm vn cz cv cle wbr wa crab cfz breq1 anbi1d rabbidv breq2 anbi2d df-fz
      wceq zex rabex ovmpt2 ) DEBCFFDGZAGZHIZUDEGZHIZJZAFKBUDHIZUDCHIZJZAFKLUIU
      GJZAFKUCBSZUHULAFUMUEUIUGUCBUDHMNOUFCSZULUKAFUNUGUJUIUFCUDHPQOADERUKAFTUA
      UB $.

    $( An alternative way of expressing a finite set of sequential integers.
       (Contributed by Mario Carneiro, 3-Nov-2013.) $)
    fzval2 $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
        ( M ... N ) = ( ( M [,] N ) i^i ZZ ) ) $=
      ( vk cz wcel wa cfz co cv cle wbr crab cicc cin fzval wceq cr zssre sseli
      cxr ressxr sstri iccval syl2an ineq1d inrab2 wss sseqin2 mpbi rabeq ax-mp
      eqtri syl6req eqtrd ) ADEZBDEZFZABGHACIZJKURBJKFZCDLZABMHZDNZCABOUQVBUSCT
      LZDNZUTUQVAVCDUOATEBTEVAVCPUPDTADQTRUAUBZSDTBVESCABUCUDUEVDUSCTDNZLZUTUSC
      TDUFVFDPZVGUTPDTUGVHVEDTUHUIUSCVFDUJUKULUMUN $.

    $( Establish the domain and codomain of the finite integer sequence
       function.  (Contributed by Scott Fenton, 8-Aug-2013.)  (Revised by Mario
       Carneiro, 16-Nov-2013.) $)
    fzf $p |- ... : ( ZZ X. ZZ ) --> ~P ZZ $=
      ( vm vk vn cv cle wbr wa cz crab cpw wcel cxp cfz wf wss ssrab2 zex elpw2
      wral mpbir rgen2w df-fz fmpt2 mpbi ) ADBDZEFUECDEFGZBHIZHJZKZCHSAHSHHLUHM
      NUIACHHUIUGHOUFBHPUGHQRTUAACHHUGUHMBACUBUCUD $.
  $}

  ${
    $d j K $.  $d j M $.  $d j N $.
    $( Membership in a finite set of sequential integers.  (Contributed by NM,
       21-Jul-2005.) $)
    elfz1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( K e. ( M ... N ) <->
                 ( K e. ZZ /\ M <_ K /\ K <_ N ) ) ) $=
      ( vj cz wcel wa cfz co cv cle wbr crab w3a fzval wceq breq2 breq1 anbi12d
      eleq2d elrab 3anass bitr4i syl6bb ) BEFCEFGZABCHIZFABDJZKLZUGCKLZGZDEMZFZ
      AEFZBAKLZACKLZNZUEUFUKADBCOTULUMUNUOGZGUPUJUQDAEUGAPUHUNUIUOUGABKQUGACKRS
      UAUMUNUOUBUCUD $.
  $}

  $( Membership in a finite set of sequential integers.  (Contributed by NM,
     29-Sep-2005.) $)
  elfz $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) -> ( K e. ( M ... N ) <->
                 ( M <_ K /\ K <_ N ) ) ) $=
    ( cz wcel cfz co cle wbr wa wb w3a elfz1 3anass baib sylan9bb 3impa 3comr )
    BDEZCDEZADEZABCFGEZBAHIZACHIZJZKZSTUAUFSTJUBUAUCUDLZUAUEABCMUGUAUEUAUCUDNOP
    QR $.

  ${
    $d k n m z M $.  $d k n m z N $.
    $( Membership in a finite set of sequential integers.  We use the fact that
       an operation's value is empty outside of its domain to show ` M e. ZZ `
       and ` N e. ZZ ` .  (Contributed by NM, 6-Sep-2005.)  (Revised by Mario
       Carneiro, 28-Apr-2015.) $)
    elfz2 $p |- ( K e. ( M ... N ) <->
           ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) /\ ( M <_ K /\ K <_ N ) ) ) $=
      ( cz wcel wa cle wbr w3a cfz co anass df-3an anbi1i wb elfz1 3anass bitrd
      ibar c0 syl5bb wn cxp cpw fdmi ndmov eleq2d noel pm2.21i pm5.21ni pm2.61i
      fzf simpl 3bitr4ri ) BDEZCDEZFZADEZFZBAGHZACGHZFZFUQURVBFZFZUOUPURIZVBFAB
      CJKZEZUQURVBLVEUSVBUOUPURMNUQVGVDOUQVGURUTVAIZVDABCPVHVCUQVDURUTVAQUQVCSU
      ARUQUBZVGATEZVDVIVFTABCDJDDUCDUDJULUEUFUGVJUQVDVJUQAUHUIUQVCUMUJRUKUN $.
  $}

  $( Membership in a finite set of sequential integers.  (Contributed by NM,
     26-Dec-2005.) $)
  elfz5 $p |- ( ( K e. ( ZZ>= ` M ) /\ N e. ZZ ) ->
                 ( K e. ( M ... N ) <-> K <_ N ) ) $=
    ( cuz cfv wcel cz wa cfz co cle wbr wb eluzelz eluzel2 jca elfz 3expa sylan
    eluzle biantrurd adantr bitr4d ) ABDEFZCGFZHABCIJFZBAKLZACKLZHZUHUDAGFZBGFZ
    HUEUFUIMZUDUJUKBANBAOPUJUKUEULABCQRSUDUHUIMUEUDUGUHBATUAUBUC $.

  $( Membership in a finite set of sequential integers.  (Contributed by NM,
     21-Jul-2005.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
  elfz4 $p |- ( ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) /\ ( M <_ K /\ K <_ N ) )
               -> K e. ( M ... N ) ) $=
    ( cfz co wcel cz w3a cle wbr wa elfz2 biimpri ) ABCDEFBGFCGFAGFHBAIJACIJKKA
    BCLM $.

  $( Membership in a finite set of sequential integers in terms of sets of
     upper integers.  (Contributed by NM, 18-Sep-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfzuzb $p |- ( K e. ( M ... N ) <->
         ( K e. ( ZZ>= ` M ) /\ N e. ( ZZ>= ` K ) ) ) $=
    ( cz wcel w3a cle wbr wa cfz cuz cfv df-3an an6 anandir ancom anbi2i 3bitri
    co eluz2 anbi1i 3bitr4ri elfz2 anbi12i 3bitr4i ) BDEZCDEZADEZFZBAGHZACGHZIZ
    IZUFUHUJFZUHUGUKFZIZABCJSEABKLEZCAKLEZIUFUHIZUHUGIZULFUSUTIZULIUPUMUSUTULMU
    FUHUJUHUGUKNUIVAULUIUFUGIUHIUSUGUHIZIVAUFUGUHMUFUGUHOVBUTUSUGUHPQRUAUBABCUC
    UQUNURUOBATACTUDUE $.

  $( Membership in a finite set of sequential integers.  (Contributed by NM,
     4-Oct-2005.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
  eluzfz $p |- ( ( K e. ( ZZ>= ` M ) /\ N e. ( ZZ>= ` K ) )
               -> K e. ( M ... N ) ) $=
    ( cfz co wcel cuz cfv wa elfzuzb biimpri ) ABCDEFABGHFCAGHFIABCJK $.

  $( A member of a finite set of sequential integers belongs to a set of upper
     integers.  (Contributed by NM, 17-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  elfzuz $p |- ( K e. ( M ... N ) -> K e. ( ZZ>= ` M ) ) $=
    ( cfz co wcel cuz cfv elfzuzb simplbi ) ABCDEFABGHFCAGHFABCIJ $.

  $( Membership in a finite set of sequential integers implies membership in a
     set of upper integers.  (Contributed by NM, 28-Sep-2005.)  (Revised by
     Mario Carneiro, 28-Apr-2015.) $)
  elfzuz3 $p |- ( K e. ( M ... N ) -> N e. ( ZZ>= ` K ) ) $=
    ( cfz co wcel cuz cfv elfzuzb simprbi ) ABCDEFABGHFCAGHFABCIJ $.

  $( Membership in a finite set of sequential integer implies the upper bound
     is an integer.  (Contributed by NM, 6-Sep-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfzel2 $p |- ( K e. ( M ... N ) -> N e. ZZ ) $=
    ( cfz co wcel cuz cfv cz elfzuz3 eluzelz syl ) ABCDEFCAGHFCIFABCJACKL $.

  $( Membership in a finite set of sequential integer implies the lower bound
     is an integer.  (Contributed by NM, 6-Sep-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfzel1 $p |- ( K e. ( M ... N ) -> M e. ZZ ) $=
    ( cfz co wcel cuz cfv cz elfzuz eluzel2 syl ) ABCDEFABGHFBIFABCJBAKL $.

  $( A member of a finite set of sequential integer is an integer.
     (Contributed by NM, 6-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  elfzelz $p |- ( K e. ( M ... N ) -> K e. ZZ ) $=
    ( cfz co wcel cuz cfv cz elfzuz eluzelz syl ) ABCDEFABGHFAIFABCJBAKL $.

  $( A member of a finite set of sequential integer is greater than or equal to
     the lower bound.  (Contributed by NM, 6-Sep-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfzle1 $p |- ( K e. ( M ... N ) -> M <_ K ) $=
    ( cfz co wcel cuz cfv cle wbr elfzuz eluzle syl ) ABCDEFABGHFBAIJABCKBALM
    $.

  $( A member of a finite set of sequential integer is less than or equal to
     the upper bound.  (Contributed by NM, 6-Sep-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfzle2 $p |- ( K e. ( M ... N ) -> K <_ N ) $=
    ( cfz co wcel cuz cfv cle wbr elfzuz3 eluzle syl ) ABCDEFCAGHFACIJABCKACLM
    $.

  $( Implication of membership in a finite set of sequential integers.
     (Contributed by NM, 20-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  elfzuz2 $p |- ( K e. ( M ... N ) -> N e. ( ZZ>= ` M ) ) $=
    ( cfz co wcel cuz cfv wa elfzuzb eqid uztrn2 sylbi ) ABCDEFABGHZFCAGHFICNFA
    BCJBCANNKLM $.

  $( Membership in a finite set of sequential integer implies the bounds are
     comparable.  (Contributed by NM, 18-Sep-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfzle3 $p |- ( K e. ( M ... N ) -> M <_ N ) $=
    ( cfz co wcel cuz cfv cle wbr elfzuz2 eluzle syl ) ABCDEFCBGHFBCIJABCKBCLM
    $.

  $( Membership in a finite set of sequential integers - special case.
     (Contributed by NM, 21-Jul-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  eluzfz1 $p |- ( N e. ( ZZ>= ` M ) -> M e. ( M ... N ) ) $=
    ( cuz cfv wcel cfz co cz eluzel2 uzid syl eluzfz mpancom ) AACDZEZBNEZAABFG
    EPAHEOABIAJKAABLM $.

  $( Membership in a finite set of sequential integers - special case.
     (Contributed by NM, 13-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  eluzfz2 $p |- ( N e. ( ZZ>= ` M ) -> N e. ( M ... N ) ) $=
    ( cuz cfv wcel cfz co cz eluzelz uzid syl eluzfz mpdan ) BACDEZBBCDEZBABFGE
    NBHEOABIBJKBABLM $.

  $( Membership in a finite set of sequential integers - special case.
     (Contributed by NM, 14-Sep-2005.) $)
  eluzfz2b $p |- ( N e. ( ZZ>= ` M ) <-> N e. ( M ... N ) ) $=
    ( cuz cfv wcel cfz co eluzfz2 elfzuz impbii ) BACDEBABFGEABHBABIJ $.

  $( Membership in a finite set of sequential integers containing one integer.
     (Contributed by NM, 21-Jul-2005.) $)
  elfz3 $p |- ( N e. ZZ -> N e. ( N ... N ) ) $=
    ( cz wcel cuz cfv cfz co uzid eluzfz1 syl ) ABCAADECAAAFGCAHAAIJ $.

  $( Membership in a finite set of sequential integers containing one integer.
     (Contributed by NM, 19-Sep-2005.) $)
  elfz1eq $p |- ( K e. ( N ... N ) -> K = N ) $=
    ( cfz co wcel wceq cle wbr elfzle2 elfzle1 cz wa elfzelz elfzel2 zre letri3
    wb cr syl2an syl2anc mpbir2and ) ABBCDEZABFZABGHZBAGHZABBIABBJUBAKEZBKEZUCU
    DUELQZABBMABBNUFAREBREUHUGAOBOABPSTUA $.

  $( A Peano-postulate-like theorem for downward closure of a finite set of
     sequential integers.  (Contributed by Mario Carneiro, 27-May-2014.) $)
  peano2fzr $p |- ( ( K e. ( ZZ>= ` M ) /\ ( K + 1 ) e. ( M ... N ) )
                    -> K e. ( M ... N ) ) $=
    ( cuz cfv wcel c1 caddc co cfz wa simpl cz eluzelz elfzuz3 peano2uzr syl2an
    elfzuzb sylanbrc ) ABDEFZAGHIZBCJIZFZKTCADEFZAUBFTUCLTAMFCUADEFUDUCBANUABCO
    ACPQABCRS $.

  ${
    $d M x $.  $d N x $.  $d A x $.
    $( Properties of a finite interval of integers which is non-empty.
       (Contributed by Jeff Madsen, 17-Jun-2010.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    fzn0 $p |- ( ( M ... N ) =/= (/) <-> N e. ( ZZ>= ` M ) ) $=
      ( vx cfz co c0 wne cuz cfv wcel cv wex elfzuz2 exlimiv sylbi eluzfz1 ne0i
      n0 syl impbii ) ABDEZFGZBAHIJZUBCKZUAJZCLUCCUARUEUCCUDABMNOUCAUAJUBABPUAA
      QST $.
  $}

  ${
    $d K k m $.  $d M k m $.  $d N k m $.
    $( A finite set of sequential integers is empty if the bounds are
       reversed.  (Contributed by NM, 22-Aug-2005.) $)
    fzn $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( N < M <-> ( M ... N ) = (/) ) ) $=
      ( cz wcel wa clt wbr cfz co c0 wne cle wn cuz cfv fzn0 eluz syl5bb cr zre
      wb lenlt syl2an bitr2d necon4bbid ) ACDZBCDZEZBAFGZABHIZJUHUJJKZABLGZUIMZ
      UKBANODUHULABPABQRUFASDBSDULUMUAUGATBTABUBUCUDUE $.

    $( A shifted finite set of sequential integers is equinumerous to the
       original set.  (Contributed by Paul Chapman, 11-Apr-2009.) $)
    fzen $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) ->
                 ( M ... N ) ~~ ( ( M + K ) ... ( N + K ) ) ) $=
      ( cz wcel w3a cfz co caddc cle wbr wi wa elfz1 biimpd cr zre syl3an wceq
      wb vk vm cv cmin cvv ovex a1i 3adant3 zaddcl expcom adantrd leadd1 3com23
      3ad2ant3 3expia imp3a 3adant2 adantld 3coml 3adant1 3jcad syl2anc biimprd
      syld com12 3impb zsubcl leaddsub lesubadd ancoms imp simp1d ex zcn subadd
      cc eqcom 3bitr3g addcom eqeq2d bitrd 3expib syl2and en3d ) BDEZCDEZADEZFZ
      UAUBBCGHZBAIHZCAIHZGHZUAUCZAIHZUBUCZAUDHZWIUEEWHBCGUFUGWLUEEWHWJWKGUFUGWH
      WMWIEZWMDEZBWMJKZWMCJKZFZWNWLEZWEWFWQXALWGWEWFMZWQXAWMBCNOUHZXAWHXBWRWSWT
      WHXBLWHWRWSWTMZMZXBWHXFWNDEZWJWNJKZWNWKJKZFZXBWHXFXGXHXIWHWRXGXEWGWEWRXGL
      WFWRWGXGWMAUIUJUNUKWEWGXFXHLWFWEWGMZWRXEXHWEWGWRXEXHLZWEWRWGXLWEWRWGFZWSX
      HWTXMWSXHWEBPEZWRWMPEZWGAPEZWSXHTBQZWMQZAQZBWMAULROUKUMUOUPUQWFWGXFXILWEW
      FWGMWRXEXIWFWGWRXEXILZWRWFWGXTWRWFWGFZWTXIWSYAWTXIWRXOWFCPEZWGXPWTXITXRCQ
      ZXSWMCAULROURUSUOUPUTVAWHXBXJWHWJDEZWKDEZXBXJTWEWGYDWFBAUIUQZWFWGYEWECAUI
      UTZWNWJWKNVBVCVDVEVFVEVDWHWOWLEZWODEZWJWOJKZWOWKJKZFZWPWIEZWHYHYLWHYDYEYH
      YLTYFYGWOWJWKNVBOZYLWHYMYIYJYKWHYMLWHYIYJYKMZMZYMWHYPWPDEZBWPJKZWPCJKZFZY
      MWHYPYQYRYSWHYIYQYOWGWEYIYQLWFYIWGYQWOAVGUJUNUKWEWGYPYRLWFXKYIYOYRWEWGYIY
      OYRLWEWGYIFZYJYRYKUUAYJYRWEXNWGXPYIWOPEZYJYRTXQXSWOQZBAWOVHROUKUOUPUQWFWG
      YPYSLZWEWGWFUUDWGWFMYIYOYSWGWFYIYOYSLZYIWGWFUUEYIWGWFFZYKYSYJUUFYSYKYIUUB
      WGXPWFYBYSYKTUUCXSYCWOACVIRVCURUSUOUPVJUTVAWEWFYTYMLWGXCYMYTWPBCNVCUHVDVE
      VFVEVDWHWQWRYHYIWMWPSZWOWNSZTZWHWQWRWHWQMWRWSWTWHWQXAXDVKVLVMWHYHYIWHYHMY
      IYJYKWHYHYLYNVKVLVMWGWEWRYIMUUILWFWGWRYIUUIYIWGWRUUIYIWOVPEZWGAVPEZWRWMVP
      EZUUIWOVNAVNWMVNUUJUUKUULFZUUGWOAWMIHZSZUUHUUMWPWMSUUNWOSUUGUUOWOAWMVOWPW
      MVQUUNWOVQVRUUMUUNWNWOUUKUULUUNWNSUUJAWMVSUTVTWARUSWBUNWCWD $.
  $}

  $( A 1-based finite set of sequential integers is empty iff it ends at index
     ` 0 ` .  (Contributed by Paul Chapman, 22-Jun-2011.) $)
  fz1n $p |- ( N e. NN0 -> ( ( 1 ... N ) = (/) <-> N = 0 ) ) $=
    ( cn0 wcel c1 clt wbr cfz co c0 wceq cc0 cz wb 1z nn0z fzn sylancr nn0lt10b
    bitr3d ) ABCZADEFZDAGHIJZAKJTDLCALCUAUBMNAODAPQARS $.

  $( Two ways to say a finite 1-based sequence is empty.  (Contributed by Paul
     Chapman, 26-Oct-2012.) $)
  0fz1 $p |- ( ( N e. NN0 /\ F Fn ( 1 ... N ) ) -> ( F = (/) <-> N = 0 ) ) $=
    ( c1 cfz co wfn c0 wceq cn0 wcel cc0 fndmu sylan2br ex fneq2 syl6bb biimpcd
    fn0 impbid fz1n sylan9bbr ) ACBDEZFZAGHZUBGHZBIJBKHUCUDUEUCUDUEUDUCAGFZUEAR
    ZUBGALMNUEUCUDUEUCUFUDUBGAOUGPQSBTUA $.

  $( There are no integers between 1 and 0.  (Contributed by Jeff Madsen,
     16-Jun-2010.)  (Proof shortened by Mario Carneiro, 28-Apr-2015.) $)
  fz10 $p |- ( 1 ... 0 ) = (/) $=
    ( cc0 c1 clt wbr cfz co c0 wceq 0lt1 cz wcel wb 1z 0z fzn mp2an mpbi ) ABCD
    ZBAEFGHZIBJKAJKRSLMNBAOPQ $.

  ${
    $d M x $.  $d N x $.  $d K x $.
    $( Split a finite interval of integers into two parts.  (Contributed by
       Mario Carneiro, 13-Apr-2016.) $)
    fzsplit2 $p |- ( ( ( K + 1 ) e. ( ZZ>= ` M ) /\ N e. ( ZZ>= ` K ) ) ->
      ( M ... N ) = ( ( M ... K ) u. ( ( K + 1 ) ... N ) ) ) $=
      ( vx co cuz cfv wcel wa cfz wo cle wbr cz adantl syl2anr wb elfzuz syl2an
      elfzuz3 c1 caddc cun cv elfzelz zred eluzel2 lelttric elfz5 simpl eluzelz
      clt cr syl eluz elfzuzb rbaib zltp1le 3bitr4d mpbird simpr uztrn sylanbrc
      orbi12d jaodan impbida elun syl6bbr eqrdv ) AUAUBEZBFGZHZCAFGHZIZDBCJEZBA
      JEZVJCJEZUCZVNDUDZVOHZVSVPHZVSVQHZKZVSVRHVNVTWCVNVTIZWCVSALMZAVSULMZKZVTV
      SUMHAUMHWGVNVTVSVSBCUEZUFVNAVMANHZVLACUGOZUFVSAUHPWDWAWEWBWFVTVSVKHZWIWAW
      EQVNVSBCRWJVSBAUIPWDVSVJFGHZVJVSLMZWBWFVNVJNHZVSNHZWLWMQVTVNVLWNVLVMUJZBV
      JUKUNWHVJVSUOSWDCVSFGZHZWBWLQVTWRVNVSBCTOWBWLWRVSVJCUPUQUNVNWIWOWFWMQVTWJ
      WHAVSURSUSVDUTVNWAVTWBVNWAIWKWRVTWAWKVNVSBAROVNVMAWQHWRWAVLVMVAVSBATACVSV
      BSVSBCUPZVCVNWBIWKWRVTWBWLVLWKVNVSVJCRWPVJVSBVBPWBWRVNVSVJCTOWSVCVEVFVSVP
      VQVGVHVI $.

    $( Split a finite interval of integers into two parts.  (Contributed by
       Jeff Madsen, 17-Jun-2010.)  (Revised by Mario Carneiro, 13-Apr-2016.) $)
    fzsplit $p |- ( K e. ( M ... N ) ->
      ( M ... N ) = ( ( M ... K ) u. ( ( K + 1 ) ... N ) ) ) $=
      ( cfz co wcel caddc cuz cfv cun wceq elfzuz peano2uz syl elfzuz3 fzsplit2
      c1 syl2anc ) ABCDEZFZAQGEZBHIZFZCAHIFSBADEUACDEJKTAUBFUCABCLBAMNABCOABCPR
      $.

    $d J x $.  $d A x $.
    $( Condition for two finite intervals of integers to be disjoint.
       (Contributed by Jeff Madsen, 17-Jun-2010.) $)
    fzdisj $p |- ( K < M -> ( ( J ... K ) i^i ( M ... N ) ) = (/) ) $=
      ( vx clt wbr cfz co cin cv wcel wa wn elin cle cz adantl zred adantr cr
      elfzel1 elfzelz elfzel2 elfzle1 elfzle2 letrd lenltd mpbid sylbi eq0rdv
      con2i ) BCFGZEABHIZCDHIZJZEKZUPLZUMURUQUNLZUQUOLZMZUMNZUQUNUOOVACBPGVBVAC
      UQBVACUTCQLUSUQCDUBRSZUTUQUALUSUTUQUQCDUCSRVABUSBQLUTUQABUDTSZUTCUQPGUSUQ
      CDUERUSUQBPGUTUQABUFTUGVACBVCVDUHUIUJULUK $.
  $}

  $( 0-based and 1-based finite sets of sequential integers are equinumerous.
     (Contributed by Paul Chapman, 11-Apr-2009.) $)
  fz01en $p |- ( N e. ZZ -> ( 0 ... ( N - 1 ) ) ~~ ( 1 ... N ) ) $=
    ( cz wcel cc0 c1 cmin co cfz caddc cen wbr peano2zm 0z 1z fzen mp3an13 wceq
    syl 0p1e1 cc a1i zcn ax-1cn npcan sylancl oveq12d breqtrd ) ABCZDAEFGZHGZDE
    IGZUIEIGZHGZEAHGJUHUIBCZUJUMJKZALDBCUNEBCUOMNEDUIOPRUHUKEULAHUKEQUHSUAUHATC
    ETCULAQAUBUCAEUDUEUFUG $.

  $( A member of a finite set of sequential integers starting at 1 is a natural
     number.  (Contributed by NM, 24-Aug-2005.) $)
  elfznn $p |- ( K e. ( 1 ... N ) -> K e. NN ) $=
    ( c1 cfz co wcel cz cle wbr cn elfzelz elfzle1 elnnz1 sylanbrc ) ACBDEFAGFC
    AHIAJFACBKACBLAMN $.

  $( A nonempty finite range of integers contains its end point.  (Contributed
     by Stefan O'Rear, 10-Oct-2014.) $)
  elfz1end $p |- ( A e. NN <-> A e. ( 1 ... A ) ) $=
    ( cn wcel c1 cfz co cuz cfv elnnuz biimpi cz nnz uzid eluzfz syl2anc elfznn
    syl impbii ) ABCZADAEFCZSADGHCZAAGHCZTSUAAIJSAKCUBALAMQADANOAAPR $.

  $( Membership in a finite set of sequential integers starting at 0.
     (Contributed by NM, 16-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  elfz2nn0 $p |- ( K e. ( 0 ... N ) <-> ( K e. NN0 /\ N e. NN0 /\ K <_ N ) ) $=
    ( cc0 cuz cfv wcel cn0 cle wbr cfz w3a elnn0uz anbi1i eluznn0 eluzle adantl
    wa co cz nn0z jca wb eluz syl2an biimprd impr impbida pm5.32i bitr3i 3anass
    elfzuzb 3bitr4i ) ACDEFZBADEFZQZAGFZBGFZABHIZQZQZACBJRFUPUQURKUOUPUNQZUTUPU
    MUNALMUPUNUSUPUNUSVAUQURBANUNURUPABOPUAUPUQURUNUPUQQUNURUPASFBSFUNURUBUQATB
    TABUCUDUEUFUGUHUIACBUKUPUQURUJUL $.

  $( A member of a finite set of sequential integers starting at 0 is a
     nonnegative integer.  (Contributed by NM, 5-Aug-2005.)  (Revised by Mario
     Carneiro, 28-Apr-2015.) $)
  elfznn0 $p |- ( K e. ( 0 ... N ) -> K e. NN0 ) $=
    ( cc0 cfz co wcel cn0 cle wbr elfz2nn0 simp1bi ) ACBDEFAGFBGFABHIABJK $.

  $( The upper bound of a nonempty finite set of sequential integers starting
     at 0 is a nonnegative integer.  (Contributed by NM, 16-Sep-2005.)
     (Revised by Mario Carneiro, 28-Apr-2015.) $)
  elfz3nn0 $p |- ( K e. ( 0 ... N ) -> N e. NN0 ) $=
    ( cc0 cfz co wcel cn0 cle wbr elfz2nn0 simp2bi ) ACBDEFAGFBGFABHIABJK $.

  $( Subtraction closure for a member of a finite set of sequential integers.
     (Contributed by NM, 16-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  fznn0sub $p |- ( K e. ( M ... N ) -> ( N - K ) e. NN0 ) $=
    ( cfz co wcel cuz cfv cmin cn0 elfzuz3 uznn0sub syl ) ABCDEFCAGHFCAIEJFABCK
    ACLM $.

  $( Subtraction closure for a member of a finite set of sequential integers.
     (Contributed by NM, 26-Sep-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  fznn0sub2 $p |- ( K e. ( 0 ... N ) -> ( N - K ) e. ( 0 ... N ) ) $=
    ( cc0 cfz co wcel cmin cle wbr elfzle1 cz wb elfzel2 elfzelz cr zre subge02
    syl2an syl2anc mpbid cuz cfv cn0 fznn0sub nn0uz syl6eleq elfz5 mpbird ) ACB
    DEZFZBAGEZUIFZUKBHIZUJCAHIZUMACBJUJBKFZAKFZUNUMLZACBMZACBNUOBOFAOFUQUPBPAPB
    AQRSTUJUKCUAUBZFUOULUMLUJUKUCUSACBUDUEUFURUKCBUGSUH $.

  $( Membership of a sum in a finite set of sequential integers.  (Contributed
     by NM, 30-Jul-2005.) $)
  fzaddel $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( J e. ( M ... N ) <-> ( J + K ) e. ( ( M + K ) ... ( N + K ) ) ) ) $=
    ( cz wcel wa cle wbr w3a caddc co cfz wb zaddcl cr zre leadd1 syl3an 3expb
    simpl adantl adantlr 3com12 adantll 3anbi123d elfz1 adantr anandirs adantrl
    2thd syl2an 3bitr4d ) CEFZDEFZGZAEFZBEFZGZGZUQCAHIZADHIZJZABKLZEFZCBKLZVDHI
    ZVDDBKLZHIZJZACDMLFZVDVFVHMLFZUTUQVEVAVGVBVIUSUQVENUPUSUQVEUQURUAABOUKUBUNU
    SVAVGNZUOUNUQURVMUNCPFUQAPFZURBPFZVMCQAQZBQZCABRSTUCUOUSVBVINZUNUOUQURVRUQU
    OURVRUQVNUODPFURVOVRVPDQVQADBRSUDTUEUFUPVKVCNUSACDUGUHUPURVLVJNZUQUNUOURVSU
    NURGVFEFVHEFVSUOURGCBODBOVDVFVHUGULUIUJUM $.

  $( Membership of a difference in a finite set of sequential integers.
     (Contributed by NM, 30-Jul-2005.) $)
  fzsubel $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( J e. ( M ... N ) <-> ( J - K ) e. ( ( M - K ) ... ( N - K ) ) ) ) $=
    ( cz wcel wa cfz co cneg caddc cmin wb znegcl fzaddel cc zcn anim12i negsub
    wceq sylanr2 adantl oveqan12d anandirs adantrl eleq12d syl2an bitrd ) CEFZD
    EFZGZAEFZBEFZGZGACDHIFZABJZKIZCUPKIZDUPKIZHIZFZABLIZCBLIZDBLIZHIZFZUMUKULUP
    EFUOVAMBNAUPCDOUAUKCPFZDPFZGZAPFZBPFZGZVAVFMUNUIVGUJVHCQDQRULVJUMVKAQBQRVIV
    LGUQVBUTVEVLUQVBTVIABSUBVIVKUTVETZVJVGVHVKVMVGVKGVHVKGURVCUSVDHCBSDBSUCUDUE
    UFUGUH $.

  $( A finite set of sequential integers can represent an ordered pair.
     (Contributed by NM, 31-Oct-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  fzopth $p |- ( N e. ( ZZ>= ` M ) ->
                ( ( M ... N ) = ( J ... K ) <-> ( M = J /\ N = K ) ) ) $=
    ( cuz cfv wcel cfz co wceq wa wss eluzfz1 adantr eleqtrd uzss 3syl eleqtrrd
    elfzuz eqssd simpr elfzuz2 cz wb eluzel2 uz11 mpbid eluzfz2 elfzuz3 eluzelz
    syl jca ex oveq12 impbid1 ) DCEFZGZCDHIZABHIZJZCAJZDBJZKZUQUTVCUQUTKZVAVBVD
    UPAEFZJZVAVDUPVEVDCUSGZCVEGUPVELVDCURUSUQCURGUTCDMNUQUTUAZOZCABSACPQVDAURGA
    UPGVEUPLVDAUSURVDVGBVEGZAUSGVICABUBZABMQVHRACDSCAPQTVDCUCGZVFVAUDUQVLUTCDUE
    NCAUFUKUGVDDEFZBEFZJZVBVDVMVNVDBURGDVNGVMVNLVDBUSURVDVGVJBUSGVIVKABUHQVHRBC
    DUIBDPQVDDUSGBVMGVNVMLVDDURUSUQDURGUTCDUHNVHODABUIDBPQTVDDUCGZVOVBUDUQVPUTC
    DUJNDBUFUKUGULUMCADBHUNUO $.

  $( Two ways to express a nondecreasing sequence of four integers.
     (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  fzass4 $p |- ( ( B e. ( A ... D ) /\ C e. ( B ... D ) ) <->
      ( B e. ( A ... C ) /\ C e. ( A ... D ) ) ) $=
    ( cuz cfv wcel wa cfz co simpll simprl uztrn ancoms ad2ant2r simprr elfzuzb
    jca jca32 anbi12i ad2ant2l simplr impbii 3bitr4i ) BAEFZGZDBEFZGZHZCUGGZDCE
    FGZHZHZUFUJHZCUEGZUKHZHZBADIJZGZCBDIJGZHBACIJGZCURGZHUMUQUMUNUOUKUMUFUJUFUH
    ULKUIUJUKLRUFUJUOUHUKUJUFUOBCAMNOUIUJUKPSUQUIUJUKUQUFUHUFUJUPKUJUKUHUFUOUKU
    JUHCDBMNUARUFUJUPUBUNUOUKPSUCUSUIUTULBADQCBDQTVAUNVBUPBACQCADQTUD $.

$(
  @{
    @d j K @.  @d j M @.  @d j N @.
    @( Union of two adjacent finite sets of sequential integers. @)
    fzunt @p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\ ( K <_ M /\ M <_ N ) )
                 -> ( ( K ... M ) u. ( M ... N ) ) = ( K ... N ) ) @=
      ( vj cz wcel w3a cle wbr wa cfz co cun cv wo cr wb wi letr exp3a com23
      3exp com3l imp42 adantlll adantrl anim2d 3expa imp adantlrl adantrr
      anim1d jaod impbid exp42 com34 ex 3imp zre syl3anOLD syl5OLD pm5.32d andi
      bicomi syl5bbOLD elfz1 3anass syl6bb 3adant3 adantr 3adant1 orbi12d
      3adant2 3bitr4d elun eqrdv ) AEFZBEFZCEFZGZABHIZBCHIZJZJZDABKLZBCKLZMZACK
      LZWDDNZWEFZWIWFFZOZWIWHFZWIWGFWDWIEFZAWIHIZWIBHIZJZJZWNBWIHIZWICHIZJZJZOZ
      WNWOWTJZJZWLWMWDWNWQXAOZJZXEXCWDWNXFXDWDWIPFZXFXDQZWNVTWCXHXIRZAPFZBPFZCP
      FZWCXJRZVQVRVSXKXLXMXNXKXLXMXNRXKXLJZXMXHWCXIXOXMXHWCXIXOXMXHJZJZWCJZXFXD
      XRWQXDXAXRWPWTWOXQWBWPWTRZWAXLXPWBXSXKXLXMXHWBXSXHXLXMWBXSRZXHXLXMXTXHXLX
      MGZWPWBWTYAWPWBWTWIBCSTUAUBUCUDUEUFUGXRWSWOWTXQWAWSWORZWBXOXHWAYBXMXOXHJZ
      WAYBYCWAWSWOXKXLXHWAWSJWORABWISUHTUIUJUKULUM?UNUOUPUQURAUSBUSCUSUTUIWIUSV
      AVBXGXCWNWQXAVCVDVEWDWJWRWKXBVTWJWRQZWCVQVRYDVSVQVRJWJWNWOWPGWRWIABVFWNWO
      WPVGVHVIVJVTWKXBQZWCVRVSYEVQVRVSJWKWNWSWTGXBWIBCVFWNWSWTVGVHVKVJVLVTWMXEQ
      ZWCVQVSYFVRVQVSJWMWNWOWTGXEWIACVFWNWOWTVGVHVMVJVNWIWEWFVOVEVP @.
      @( [ ?] @) @( [21-Jul-2005] @)
  @}
$)

  ${
    $d k M $.  $d k N $.  $d k K $.  $d k V $.
    $( Subset relationship for finite sets of sequential integers.
       (Contributed by NM, 28-Sep-2005.)  (Proof shortened by Mario Carneiro,
       28-Apr-2015.) $)
    fzss1 $p |- ( K e. ( ZZ>= ` M ) -> ( K ... N ) C_ ( M ... N ) ) $=
      ( vk cuz cfv wcel co cv wa elfzuz id uztrn syl2anr elfzuz3 adantl elfzuzb
      cfz sylanbrc ex ssrdv ) ABEFZGZDACRHZBCRHZUCDIZUDGZUFUEGZUCUGJUFUBGZCUFEF
      GZUHUGUFAEFGUCUIUCUFACKUCLAUFBMNUGUJUCUFACOPUFBCQSTUA $.

    $( Subset relationship for finite sets of sequential integers.
       (Contributed by NM, 4-Oct-2005.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    fzss2 $p |- ( N e. ( ZZ>= ` K ) -> ( M ... K ) C_ ( M ... N ) ) $=
      ( vk cuz cfv wcel cfz co cv wa elfzuz adantl elfzuz3 uztrn sylan2 elfzuzb
      sylanbrc ex ssrdv ) CAEFGZDBAHIZBCHIZUADJZUBGZUDUCGZUAUEKUDBEFGZCUDEFZGZU
      FUEUGUAUDBALMUEUAAUHGUIUDBANACUDOPUDBCQRST $.

    $( A finite set of sequential integers is a subset of a set of upper
       integers.  (Contributed by NM, 28-Oct-2005.) $)
    fzssuz $p |- ( M ... N ) C_ ( ZZ>= ` M ) $=
      ( vk cfz co cuz cfv cv elfzuz ssriv ) CABDEAFGCHABIJ $.

    $( A finite interval of integers with one element.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    fzsn $p |- ( M e. ZZ -> ( M ... M ) = { M } ) $=
      ( vk cz wcel cfz co csn cv elfz1eq elfz3 eleq1 syl5ibrcom impbid2 syl6bbr
      wceq elsn eqrdv ) ACDZBAAEFZAGZRBHZSDZUAAOZUATDRUBUCUAAIRUBUCASDAJUAASKLM
      BAPNQ $.

    $( Subset relationship for finite sets of sequential integers.
       (Contributed by NM, 21-Jul-2005.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    fzssp1 $p |- ( M ... N ) C_ ( M ... ( N + 1 ) ) $=
      ( vk cfz co c1 caddc cv wcel cuz cfv wss elfzel2 uzid peano2uz fzss2 4syl
      cz id sseldd ssriv ) CABDEZABFGEZDEZCHZUBIZUBUDUEUFBRIBBJKZIUCUGIUBUDLUEA
      BMBNBBOBAUCPQUFSTUA $.
  $}

  $( Join a successor to the end of a finite set of sequential integers.
     (Contributed by NM, 19-Jul-2008.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  fzsuc $p |- ( N e. ( ZZ>= ` M ) ->
                ( M ... ( N + 1 ) ) = ( ( M ... N ) u. { ( N + 1 ) } ) ) $=
    ( cuz cfv wcel c1 caddc co cfz cun csn peano2uz eluzfz2 syl peano2fzr mpdan
    wceq fzsplit cz eluzelz fzsn 3syl uneq2d eqtrd ) BACDZEZABFGHZIHZABIHZUGUGI
    HZJZUIUGKZJUFBUHEZUHUKQUFUGUHEZUMUFUGUEEZUNABLZAUGMNBAUGOPBAUGRNUFUJULUIUFU
    OUGSEUJULQUPAUGTUGUAUBUCUD $.

  $( Append an element to a finite set of sequential integers.  (Contributed by
     NM, 19-Sep-2005.)  (Proof shortened by Mario Carneiro, 28-Apr-2015.) $)
  elfzp1 $p |- ( N e. ( ZZ>= ` M ) ->
    ( K e. ( M ... ( N + 1 ) ) <-> ( K e. ( M ... N ) \/ K = ( N + 1 ) ) ) ) $=
    ( cuz cfv wcel c1 caddc co cfz csn cun wceq fzsuc eleq2d elun elsnc2 orbi2i
    wo ovex bitri syl6bb ) CBDEFZABCGHIZJIZFABCJIZUDKZLZFZAUFFZAUDMZSZUCUEUHABC
    NOUIUJAUGFZSULAUFUGPUMUKUJAUDCGHTQRUAUB $.

  $( Subset relationship for finite sets of sequential integers.  (Contributed
     by NM, 26-Jul-2005.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
  fzp1ss $p |- ( M e. ZZ -> ( ( M + 1 ) ... N ) C_ ( M ... N ) ) $=
    ( cz wcel cuz cfv c1 caddc co cfz wss uzid peano2uz fzss1 3syl ) ACDAAEFZDA
    GHIZPDQBJIABJIKALAAMQABNO $.

  $( Membership in a set of sequential integers with an appended element.
     (Contributed by NM, 7-Dec-2005.)  (Revised by Mario Carneiro,
     28-Apr-2015.) $)
  fzelp1 $p |- ( K e. ( M ... N ) -> K e. ( M ... ( N + 1 ) ) ) $=
    ( cfz co c1 caddc fzssp1 sseli ) BCDEBCFGEDEABCHI $.

  $( Add one to an element of a finite set of integers.  (Contributed by Jeff
     Madsen, 6-Jun-2010.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
  fzp1elp1 $p |- ( K e. ( M ... N ) -> ( K + 1 ) e. ( M ... ( N + 1 ) ) ) $=
    ( cfz co wcel c1 caddc cuz cfv elfzuz peano2uz syl elfzuz3 eluzp1p1 elfzuzb
    sylanbrc ) ABCDEFZAGHEZBIJZFZCGHEZSIJFZSBUBDEFRATFUAABCKBALMRCAIJFUCABCNACO
    MSBUBPQ $.

  ${
    $d M m $.

    $( A finite interval of integers with two elements.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    fzpr $p |- ( M e. ZZ -> ( M ... ( M + 1 ) ) = { M , ( M + 1 ) } ) $=
      ( vm cz wcel c1 caddc co cfz cpr cv wceq cuz cfv uzid elfzp1 syl csn fzsn
      wo wb eleq2d elsn syl6bb orbi1d bitrd vex elpr syl6bbr eqrdv ) ACDZBAAEFG
      ZHGZAUKIZUJBJZULDZUNAKZUNUKKZSZUNUMDUJUOUNAAHGZDZUQSZURUJAALMDUOVATANUNAA
      OPUJUTUPUQUJUTUNAQZDUPUJUSVBUNARUABAUBUCUDUEUNAUKBUFUGUHUI $.

    $( A finite interval of integers with three elements.  (Contributed by NM,
       13-Sep-2011.)  (Revised by Mario Carneiro, 7-Mar-2014.) $)
    fztp $p |- ( M e. ZZ -> ( M ... ( M + 2 ) )
                 = { M , ( M + 1 ) , ( M + 2 ) } ) $=
      ( cz wcel c1 caddc co cfz csn cun c2 ctp cuz cfv wceq uzid peano2uz fzsuc
      cc ax-1cn syl6eqr 3syl zcn addass mp3an23 syl df-2 oveq2i oveq2d cpr fzpr
      sneqd uneq12d df-tp 3eqtr3d ) ABCZAADEFZDEFZGFZAUPGFZUQHZIZAAJEFZGFAUPVBK
      ZUOAALMZCUPVDCURVANAOAAPAUPQUAUOUQVBAGUOUQADDEFZEFZVBUOARCZUQVFNZAUBVGDRC
      ZVIVHSSADDUCUDUEJVEAEUFUGTZUHUOVAAUPUIZVBHZIVCUOUSVKUTVLAUJUOUQVBVJUKULAU
      PVBUMTUN $.
  $}

  $( An integer range from 0 to 2 is an unordered triple.  (Contributed by
     Alexander van der Vekens, 1-Feb-2018.) $)
  fz0tp $p |- ( 0 ... 2 ) = { 0 , 1 , 2 } $=
    ( cc0 c2 cfz co caddc c1 ctp 2cn addid2i eqcomi oveq2i cz wcel wceq 0z fztp
    ax-mp eqid id a1i 0p1e1 tpeq123d 3eqtri ) ABCDAABEDZCDZAAFEDZUDGZAFBGZBUDAC
    UDBBHIZJKALMUEUGNOAPQAANZUGUHNARUJAAUFFUDBUJSUFFNUJUATUDBNUJUITUBQUC $.

  ${
    $d M k $.  $d N k $.
    $( Join a successor to the end of a finite set of sequential integers.
       (Contributed by Mario Carneiro, 7-Mar-2014.) $)
    fzsuc2 $p |- ( ( M e. ZZ /\ N e. ( ZZ>= ` ( M - 1 ) ) ) ->
                   ( M ... ( N + 1 ) ) = ( ( M ... N ) u. { ( N + 1 ) } ) ) $=
      ( c1 cmin co cuz cfv wcel cz wceq caddc wo cfz csn cun cc oveq2d c0 sneqd
      uneq12d uzp1 zcn npcan sylancl uncom un0 eqtri clt wbr zre ltm1d peano2zm
      ax-1cn fzn mpdan mpbid fzsn 3eqtr4a eqtr4d oveq1 oveq2 eqeq12d syl5ibrcom
      wb imp wa fveq2d eleq2d biimpa fzsuc syl jaodan sylan2 ) BACDEZFGHAIHZBVN
      JZBVNCKEZFGZHZLABCKEZMEZABMEZVTNZOZJZVNBUAVOVPWEVSVOVPWEVOWEVPAVQMEZAVNME
      ZVQNZOZJVOWFAAMEZWIVOVQAAMVOAPHCPHVQAJAUBUMACUCUDZQVORANZOZWLWIWJWMWLROWL
      RWLUEWLUFUGVOWGRWHWLVOVNAUHUIZWGRJZVOAAUJUKVOVNIHWNWOVDAULAVNUNUOUPVOVQAW
      KSTAUQURUSVPWAWFWDWIVPVTVQAMBVNCKUTZQVPWBWGWCWHBVNAMVAVPVTVQWPSTVBVCVEVOV
      SVFBAFGZHZWEVOVSWRVOVRWQBVOVQAFWKVGVHVIABVJVKVLVM $.
  $}

  $( ` ( M ... ( N + 1 ) ) ` is the disjoint union of ` ( M ... N ) ` with
     ` { ( N + 1 ) } ` .  (Contributed by Mario Carneiro, 7-Mar-2014.) $)
  fzp1disj $p |- ( ( M ... N ) i^i { ( N + 1 ) } ) = (/) $=
    ( cfz co c1 caddc csn cin c0 wceq wcel wn cle wbr elfzle2 elfzel2 zred ltp1
    cr clt wb peano2re ltnle mpdan mpbid syl pm2.65i disjsn mpbir ) ABCDZBEFDZG
    HIJUKUJKZLULUKBMNZUKABOULBSKZUMLZULBUKABPQUNBUKTNZUOBRUNUKSKUPUOUABUBBUKUCU
    DUEUFUGUJUKUHUI $.

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( Two ways of defining the first two values of a sequence on ` NN ` .
       (Contributed by NM, 5-Sep-2011.) $)
    fzprval $p |- ( A. x e. ( 1 ... 2 ) ( F ` x ) = if ( x = 1 , A , B )
                  <-> ( ( F ` 1 ) = A /\ ( F ` 2 ) = B ) ) $=
      ( cv cfv c1 wceq cif c2 cfz co wral cpr wa caddc df-2 fveq2 eqeq12d wne
      cz wcel 1z fzpr ax-mp oveq2i preq2i 3eqtr4i raleqi 1ex cr elexi iftrue wn
      2re 1ne2 necomi pm13.181 mpan2 neneqd iffalse syl ralpr bitri ) AEZDFZVEG
      HZBCIZHZAGJKLZMVIAGJNZMGDFZBHZJDFZCHZOVIAVJVKGGGPLZKLZGVPNZVJVKGUAUBVQVRH
      UCGUDUEJVPGKQUFJVPGQUGUHUIVIVMVOAGJUJJUKUOULVGVFVLVHBVEGDRVGBCUMSVEJHZVFV
      NVHCVEJDRVSVGUNVHCHVSVEGVSJGTVEGTGJUPUQVEJGURUSUTVGBCVAVBSVCVD $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.
    $( Two ways of defining the first three values of a sequence on ` NN ` .
       (Contributed by NM, 13-Sep-2011.) $)
    fztpval $p |- ( A. x e. ( 1 ... 3 ) ( F ` x )
                      = if ( x = 1 , A , if ( x = 2 , B , C ) )
                  <-> ( ( F ` 1 ) = A /\ ( F ` 2 ) = B /\ ( F ` 3 ) = C ) ) $=
      ( cfv c1 wceq c2 c3 cfz co ctp caddc ax-mp fveq2 eqeq12d wne gtneii neeq1
      cv cif wral w3a cz wcel 1z fztp df-3 2cn ax-1cn addcomi eqtri oveq2i df-2
      tpeq3 tpeq2 3eqtr4i raleqi 1ex elexi 3re iftrue 1re 1lt2 mpbiri ifnefalse
      cc cr syl eqtrd 1lt3 2re 2lt3 raltp bitri ) AUAZEFZVQGHZBVQIHZCDUBZUBZHZA
      GJKLZUCWCAGIJMZUCGEFZBHZIEFZCHZJEFZDHZUDWCAWDWEGGINLZKLZGGGNLZWLMZWDWEGUE
      UFWMWOHUGGUHOJWLGKJIGNLWLUIIGUJUKULUMZUNWEGIWLMZWOJWLHWEWQHWPJWLGIUPOIWNH
      WQWOHUOIWNGWLUQOUMURUSWCWGWIWKAGIJUTIVHUJVAJVIVBVAVSVRWFWBBVQGEPVSBWAVCQV
      TVRWHWBCVQIEPVTWBWACVTVQGRZWBWAHZVTWRIGRGIVDVESVQIGTVFVQGBWAVGZVJVTCDVCVK
      QVQJHZVRWJWBDVQJEPXAWBWADXAWRWSXAWRJGRGJVDVLSVQJGTVFWTVJXAVQIRZWADHXAXBJI
      RIJVMVNSVQJITVFVQICDVGVJVKQVOVP $.
  $}

  $( Reversal of start and end of a finite set of sequential integers.
     (Contributed by NM, 25-Nov-2005.) $)
  fzrev $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( K e. ( ( J - N ) ... ( J - M ) ) <-> ( J - K ) e. ( M ... N ) ) ) $=
    ( cz wcel wa cmin co cle wbr cfz wb cr zre syl3an 3expb zsubcl ancoms elfz
    ancom suble 3comr adantll lesub adantlr anbi12d syl5rbbr ad2ant2lr ad2ant2r
    simprr syl3anc adantl simpll simplr 3bitr4d ) CEFZDEFZGZAEFZBEFZGZGZADHIZBJ
    KZBACHIZJKZGZCABHIZJKZVIDJKZGZBVDVFLIFZVICDLIFZVLVKVJGVCVHVKVJUAVCVKVEVJVGU
    RVBVKVEMZUQURUTVAVOUTVAURVOUTANFZVABNFZURDNFVOAOZBOZDOABDUBPUCQUDUQVBVJVGMZ
    URUQUTVAVTUQCNFUTVPVAVQVTCOVRVSCABUEPQUFUGUHVCVAVDEFZVFEFZVMVHMUSUTVAUKURUT
    WAUQVAUTURWAADRSUIUQUTWBURVAUTUQWBACRSUJBVDVFTULVCVIEFZUQURVNVLMVBWCUSABRUM
    UQURVBUNUQURVBUOVICDTULUP $.

  $( Reversal of start and end of a finite set of sequential integers.
     (Contributed by NM, 25-Nov-2005.) $)
  fzrev2 $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( J e. ZZ /\ K e. ZZ ) ) ->
         ( K e. ( M ... N ) <-> ( J - K ) e. ( ( J - N ) ... ( J - M ) ) ) ) $=
    ( cz wcel wa cmin co cfz wb simpl zsubcl jca fzrev sylan2 wceq cc zcn nncan
    syl2an adantl eleq1d bitr2d ) CEFDEFGZAEFZBEFZGZGZABHIZADHIACHIJIFZAUJHIZCD
    JIZFZBUMFUHUEUFUJEFZGUKUNKUHUFUOUFUGLABMNAUJCDOPUIULBUMUHULBQZUEUFARFBRFUPU
    GASBSABTUAUBUCUD $.

  $( Reversal of start and end of a finite set of sequential integers.
     (Contributed by NM, 25-Nov-2005.) $)
  fzrev2i $p |- ( ( J e. ZZ /\ K e. ( M ... N ) )
                 -> ( J - K ) e. ( ( J - N ) ... ( J - M ) ) ) $=
    ( cz wcel co wa cmin simpr wb elfzel1 adantl elfzel2 simpl elfzelz syl22anc
    cfz fzrev2 mpbid ) AEFZBCDRGFZHZUBABIGADIGACIGRGFZUAUBJUCCEFZDEFZUABEFZUBUD
    KUBUEUABCDLMUBUFUABCDNMUAUBOUBUGUABCDPMABCDSQT $.

  $( The "complement" of a member of a finite set of sequential integers.
     (Contributed by NM, 20-Nov-2005.) $)
  fzrev3 $p |- ( K e. ZZ -> ( K e. ( M ... N )
                <-> ( ( M + N ) - K ) e. ( M ... N ) ) ) $=
    ( cz wcel cfz co caddc cmin w3a wa simpl elfzel1 adantl elfzel2 3jca wb zcn
    cc 3adant1 wceq pncan pncan2 syl2an eleq2d 3simpc zaddcl simp1 fzrev bitr3d
    oveq12d syl12anc pm5.21nd ) ADEZABCFGZEZBCHGZAIGZUOEZUNBDEZCDEZJZUNUPKUNUTV
    AUNUPLUPUTUNABCMNUPVAUNABCONPUNUSKUNUTVAUNUSLUSUTUNURBCMNUSVAUNURBCONPVBAUQ
    CIGZUQBIGZFGZEZUPUSUTVAVFUPQUNUTVAKZVEUOAUTBSEZCSEZVEUOUAVABRCRVHVIKVCBVDCF
    BCUBBCUCUKUDUETVBVGUQDEZUNVFUSQUNUTVAUFUTVAVJUNBCUGTUNUTVAUHUQABCUIULUJUM
    $.

  $( The "complement" of a member of a finite set of sequential integers.
     (Contributed by NM, 20-Nov-2005.) $)
  fzrev3i $p |- ( K e. ( M ... N ) -> ( ( M + N ) - K ) e. ( M ... N ) ) $=
    ( cfz co wcel caddc cmin cz wb elfzelz fzrev3 syl ibi ) ABCDEZFZBCGEAHEOFZP
    AIFPQJABCKABCLMN $.

  $( Finite set of sequential integers starting at 0.  (Contributed by NM,
     1-Aug-2005.) $)
  fznn0 $p |- ( N e. NN0
              -> ( K e. ( 0 ... N ) <-> ( K e. NN0 /\ K <_ N ) ) ) $=
    ( cn0 wcel cc0 cfz co cz cle wbr w3a wa wb nn0z elfz1 sylancr df-3an elnn0z
    0z anbi1i bitr4i syl6bb ) BCDZAEBFGDZAHDZEAIJZABIJZKZACDZUGLZUCEHDBHDUDUHMS
    BNAEBOPUHUEUFLZUGLUJUEUFUGQUIUKUGARTUAUB $.

  $( A non-negative integer is always part of its zero-based finite sequence.
     (Contributed by Scott Fenton, 21-Mar-2018.) $)
  nn0fz0 $p |- ( N e. NN0 <-> N e. ( 0 ... N ) ) $=
    ( cn0 wcel cc0 cfz co cle wbr nn0re leidd fznn0 mpbir2and elfz3nn0 impbii
    id ) ABCZADAEFCZPQPAAGHPOPAAIJAAKLAAMN $.

  $( Finite set of sequential integers starting at 1.  (Contributed by NM,
     31-Aug-2011.)  (Revised by Mario Carneiro, 18-Jun-2015.) $)
  fznn $p |- ( N e. ZZ
              -> ( K e. ( 1 ... N ) <-> ( K e. NN /\ K <_ N ) ) ) $=
    ( c1 cfz co wcel cn cuz cfv wa cz cle wbr elfzuzb elnnuz anbi1i bitr4i eluz
    wb nnz sylan ancoms pm5.32da syl5bb ) ACBDEFZAGFZBAHIFZJZBKFZUFABLMZJUEACHI
    FZUGJUHACBNUFUKUGAOPQUIUFUGUJUFUIUGUJSZUFAKFUIULATABRUAUBUCUD $.

  $( Membership in a finite set of sequential integers.  (Contributed by Paul
     Chapman, 21-Mar-2011.) $)
  elfzm11 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( K e. ( M ... ( N - 1 ) ) <->
                                         ( K e. ZZ /\ M <_ K /\ K < N ) ) ) $=
    ( cz wcel wa c1 cmin co cfz cle wbr w3a clt wb peano2zm elfz1 sylan2 3anass
    zltlem1 anbi2d expcom pm5.32d 3bitr4g adantl bitr4d ) BDEZCDEZFABCGHIZJIEZA
    DEZBAKLZAUIKLZMZUKULACNLZMZUHUGUIDEUJUNOCPABUIQRUHUPUNOUGUHUKULUOFZFUKULUMF
    ZFUPUNUHUKUQURUKUHUQUROUKUHFUOUMULACTUAUBUCUKULUOSUKULUMSUDUEUF $.

  $( Lemma for theorems about the central binomial coefficient.  (Contributed
     by Mario Carneiro, 8-Mar-2014.)  (Revised by Mario Carneiro,
     2-Aug-2014.) $)
  fzctr $p |- ( N e. NN0 -> N e. ( 0 ... ( 2 x. N ) ) ) $=
    ( cn0 wcel cc0 c2 cmul co cfz cle wbr nn0ge0 caddc cr nn0re nn0addge1 nn0cn
    mpancom 2timesd breqtrrd cz wa wb nn0z 0z a1i zmulcl sylancr elfz mpbir2and
    2z syl3anc ) ABCZADEAFGZHGCZDAIJZAUMIJZAKULAAALGZUMIAMCULAUQIJANAAOQULAAPRS
    ULATCZDTCZUMTCZUNUOUPUAUBAUCZUSULUDUEULETCURUTUJVAEAUFUGADUMUHUKUI $.

  ${
    $d k M $.  $d k N $.
    $( Express an upper integer set as the disjoint (see ~ uzdisj ) union of
       the first ` N ` values and the rest.  (Contributed by Mario Carneiro,
       24-Apr-2014.) $)
    uzsplit $p |- ( N e. ( ZZ>= ` M ) -> ( ZZ>= ` M ) =
                  ( ( M ... ( N - 1 ) ) u. ( ZZ>= ` N ) ) ) $=
      ( vk cuz cfv wcel c1 cmin co cfz wo wa cle wbr cr eluzelre syl2an eluzelz
      cz wb cun clt lelttric eluz eluzel2 w3a elfzm11 df-3an syl6bb syl2anr jca
      cv eluzle adantl biantrurd bitr4d orbi12d mpbird orcomd elfzuz a1i expcom
      ex wi uztrn jaod impbid elun syl6bbr eqrdv ) BADEZFZCVKABGHIZJIZBDEZUAZVL
      CULZVKFZVQVNFZVQVOFZKZVQVPFVLVRWAVLVRWAVLVRLZVTVSWBVTVSKBVQMNZVQBUBNZKZVL
      BOFVQOFWEVRABPAVQPBVQUCQWBVTWCVSWDVLBSFZVQSFZVTWCTVRABRZAVQRZBVQUDQWBVSWG
      AVQMNZLZWDLZWDVRASFZWFVSWLTVLAVQUEWHWMWFLVSWGWJWDUFWLVQABUGWGWJWDUHUIUJWB
      WKWDVRWKVLVRWGWJWIAVQUMUKUNUOUPUQURUSVCVLVSVRVTVSVRVDVLVQAVMUTVAVTVLVRBVQ
      AVEVBVFVGVQVNVOVHVIVJ $.

    $( The first ` N ` elements of an upper integer set are distinct from any
       later members.  (Contributed by Mario Carneiro, 24-Apr-2014.) $)
    uzdisj $p |- ( ( M ... ( N - 1 ) ) i^i ( ZZ>= ` N ) ) = (/) $=
      ( vk c1 cmin co cfz cuz cfv cin c0 wss wceq wcel wbr cle syl mpbid zred
      cz cv elin simprbi eluzle eluzel2 eluzelz zlem1lt syl2anc simplbi elfzle2
      clt wb wn peano2zm lenltd pm2.21dd ssriv ss0 ax-mp ) ABDEFZGFZBHIZJZKLVCK
      MCVCKCUAZVCNZUTVDUKOZVDKNVEBVDPOZVFVEVDVBNZVGVEVDVANZVHVDVAVBUBZUCZBVDUDQ
      VEBTNZVDTNZVGVFULVEVHVLVKBVDUEQZVEVHVMVKBVDUFQZBVDUGUHRVEVDUTPOZVFUMVEVIV
      PVEVIVHVJUIVDAUTUJQVEVDUTVEVDVOSVEUTVEVLUTTNVNBUNQSUORUPUQVCURUS $.
  $}

  $( A one value function.  (Contributed by Alexander van der Vekens,
     3-Dec-2017.) $)
  1fv $p |- ( ( N e. V /\ P = { <. 0 , N >. } )
                 -> ( P : ( 0 ... 0 ) --> V /\ ( P ` 0 ) = N ) ) $=
    ( wcel cc0 cop csn wceq wa cfz co wf cfv wf1o cz f1osng mpan biimpi adantr
    0z wfo crn wi f1ofo dffo2 wss fzsn ax-mp eqcomi feq2i snssi fss syl2an 3syl
    ex mpcom fvsng jca wb feq1 fveq1 eqeq1d anbi12d adantl mpbird ) BCDZAEBFGZH
    ZIEEJKZCALZEAMZBHZIZVICVGLZEVGMZBHZIZVFVQVHVFVNVPEGZBGZVGNZVFVNEODZVFVTTEBO
    CPQVTVRVSVGUAZVRVSVGLZVGUBVSHZIZVFVNUCZVRVSVGUDWBWEVRVSVGUERWCWFWDWCVFVNWCV
    IVSVGLZVSCUFVNVFWCWGVRVIVSVGVIVRWAVIVRHTEUGUHUIUJRBCUKVIVSCVGULUMUOSUNUPWAV
    FVPTEBOCUQQURSVHVMVQUSVFVHVJVNVLVPVICAVGUTVHVKVOBEAVGVAVBVCVDVE $.

  ${
    $d P a b c d $.  $d V a b c d $.
    $( The first four function values of a word of length at least 4.
       (Contributed by Alexander van der Vekens, 18-Nov-2017.) $)
    4fvwrd4 $p |- ( ( L e. ( ZZ>= ` 3 ) /\ P : ( 0 ... L ) --> V )
                    -> E. a e. V E. b e. V E. c e. V E. d e. V
                       ( ( ( P ` 0 ) = a /\ ( P ` 1 ) = b )
                      /\ ( ( P ` 2 ) = c /\ ( P ` 3 ) = d ) ) ) $=
      ( c3 cuz cfv wcel cc0 wa cv wceq wrex c1 c2 rexbii bitri cfz co simpr cn0
      wf 0nn0 elnn0uz mpbi 3nn0 uzss ax-mp sseli eluzfz sylancr adantr ffvelrnd
      wss risset eqcom sylib 1nn0 cz cle wbr 1z nn0zi 1re 3re 1lt3 ltleii eluz2
      mpbir3an jca 2nn0 2z 2re 2lt3 jca32 r19.42v anbi2i 2rexbii r19.41v anbi1i
      mpan 3bitri sylibr ) BHIJZKZLBUAUBZCAUEZMZLAJZDNZOZDCPZQAJZENZOZECPZMZRAJ
      ZFNZOZFCPZHAJZGNZOZGCPZMZMZWNWRMZXCXGMZMGCPZFCPZECPDCPZWKWTXDXHWKWOWSWKWL
      CKZWOWKWICLAWHWJUCZWHLWIKZWJWHLLIJZKZBXSKXRLUDKXTUFLUGUHWGXSBHXSKZWGXSUQH
      UDKYAUIHUGUHZLHUJUKULLLBUMUNUOUPXPWMWLOZDCPWODWLCURYCWNDCWMWLUSSTUTWKWPCK
      ZWSWKWICQAXQWHQWIKZWJWHQXSKZBQIJZKYEQUDKYFVAQUGUHWGYGBHYGKZWGYGUQYHQVBKHV
      BKZQHVCVDVEHUIVFZQHVGVHVIVJQHVKVLQHUJUKULQLBUMUNUOUPYDWQWPOZECPWSEWPCURYK
      WRECWQWPUSSTUTVMWKXACKZXDWKWICRAXQWHRWIKZWJWHRXSKZBRIJZKYMRUDKYNVNRUGUHWG
      YOBHYOKZWGYOUQYPRVBKYIRHVCVDVOYJRHVPVHVQVJRHVKVLRHUJUKULRLBUMUNUOUPYLXBXA
      OZFCPXDFXACURYQXCFCXBXAUSSTUTWKXECKZXHWKWICHAXQWHHWIKZWJYAWHYSYBHLBUMWDUO
      UPYRXFXEOZGCPXHGXECURYTXGGCXFXEUSSTUTVRXOXKXCXHMZMZFCPZECPDCPXKXIMZECPZDC
      PZXJXNUUCDECCXMUUBFCXMXKXLGCPZMUUBXKXLGCVSUUGUUAXKXCXGGCVSVTTSWAUUCUUDDEC
      CUUCXKUUAFCPZMUUDXKUUAFCVSUUHXIXKXCXHFCWBVTTWAUUFWNWSMZXIMZDCPUUIDCPZXIMX
      JUUEUUJDCUUEXKECPZXIMUUJXKXIECWBUULUUIXIWNWRECVSWCTSUUIXIDCWBUUKWTXIWNWSD
      CWBWCWEWEWF $.
  $}

  ${
    fseq1p1m1.1 $e |- H = { <. ( N + 1 ) , B >. } $.
    $( Add/remove an item to/from the end of a finite sequence.  (Contributed
       by Paul Chapman, 17-Nov-2012.)  (Revised by Mario Carneiro,
       7-Mar-2014.) $)
    fseq1p1m1 $p |- ( N e. NN0 ->
        ( ( F : ( 1 ... N ) --> A /\ B e. A /\ G = ( F u. H ) ) <->
          ( G : ( 1 ... ( N + 1 ) ) --> A /\ ( G ` ( N + 1 ) ) = B /\
            F = ( G |` ( 1 ... N ) ) ) ) ) $=
      ( cn0 wcel c1 co wf cun wceq cfv cres csn c0 cn 3syl cfz w3a caddc wa cin
      simpr1 wss nn0p1nn adantr simpr2 cop fsng mpbiri syl2anc fss fzp1disj a1i
      snssd fun2 syl21anc cz cmin cuz 1z simpl cc0 nn0uz fveq2i eqtr4i syl6eleq
      1m1e0 fzsuc2 eqcomd feq2d mpbid simpr3 feq1d mpbird ovex snid fvres ax-mp
      sylancr reseq1d wfn wb ffn fnresdisj uneq1d resundir uncom eqtr2i 3eqtr4g
      un0 fnresdm 3eqtrd fveq1d fveq1i fvsng syl5eq eqtrd syl5eqr uneq2d eqcomi
      3eqtrrd 3jca fzssp1 fssres sylancl nnuz eluzfz2 ffvelrnd eqeltrrd fnressn
      incom syl opeq2 sneqd syl6reqr uneq12d reseq2d resundi syl6req impbida )
      FHIZJFUAKZACLZBAIZDCEMZNZUBZJFJUCKZUAKZADLZYLDOZBNZCDYFPZNZUBZYEYKUDZYNYP
      YRYTYNYMAYILZYTYFYLQZMZAYILZUUAYTYGUUBAELZYFUUBUEZRNZUUDYEYGYHYJUFZYTUUBB
      QZELZUUIAUGUUEYTYLSIZYHUUJYEUUKYKFUHZUIZYEYGYHYJUJZUUKYHUDZUUJEYLBUKZQZNG
      YLBSAEULUMUNZYTBAUUNURUUBUUIAEUOUNZUUGYTJFUPUQZYFUUBACEUSUTYTUUCYMAYIYTYM
      UUCYTJVAIZFJJVBKZVCOZIZYMUUCNZVDYTFHUVCYEYKVEHVFVCOUVCVGUVBVFVCVKVHVIZVJJ
      FVLZWCVMVNVOYTYMADYIYEYGYHYJVPZVQVRYTYOYLDUUBPZOZBYLUUBIUVJYONYLFJUCVSVTY
      LUUBDWAWBYTUVJYLEOZBYTYLUVIEYTUVIYIUUBPZEUUBPZEYTDYIUUBUVHWDYTCUUBPZUVMMR
      UVMMZUVLUVMYTUVNRUVMYTUUGUVNRNZUUTYTYGCYFWEZUUGUVPWFUUHYFACWGZYFUUBCWHTVO
      WICEUUBWJUVOUVMRMUVMRUVMWKUVMWNWLWMYTUUEEUUBWEZUVMENUUSUUBAEWGUUBEWOTWPWQ
      YTUUKYHUVKBNUUMUUNUUOUVKYLUUQOBYLEUUQGWRYLBSAWSWTUNXAXBYTYQYIYFPZCYFPZCYT
      DYIYFUVHWDYTUWAEYFPZMUWARMZUVTUWAYTUWBRUWAYTUUBYFUEZRNZUWBRNZYTUWDUUFRUUB
      YFXOUUTWTYTUUJUVSUWEUWFWFUURUUBUUIEWGUUBYFEWHTVOXCCEYFWJUWCUWAUWAWNXDWMYT
      YGUVQUWACNUUHUVRYFCWOTXEXFYEYSUDZYGYHYJUWGYGYFAYQLZUWGYNYFYMUGUWHYEYNYPYR
      UFZJFXGYMAYFDXHXIUWGYFACYQYEYNYPYRVPZVQVRUWGYOBAYEYNYPYRUJZUWGYMAYLDUWIUW
      GYLJVCOZIYLYMIZUWGYLSUWLYEUUKYSUULUIXJVJJYLXKXPZXLXMUWGYIYQUVIMZDYMPZDUWG
      CYQEUVIUWJUWGUVIUUQEUWGUVIYLYOUKZQZUUQUWGDYMWEZUWMUVIUWRNUWGYNUWSUWIYMADW
      GZXPUWNYMYLDXNUNUWGYPUWRUUQNUWKYPUWQUUPYOBYLXQXRXPXAGXSXTUWGUWPDUUCPUWOUW
      GYMUUCDUWGUVAUVDUVEVDUWGFHUVCYEYSVEUVFVJUVGWCYADYFUUBYBYCUWGYNUWSUWPDNUWI
      UWTYMDWOTXEXFYD $.
  $}

  ${
    fseq1m1p1.1 $e |- H = { <. N , B >. } $.
    $( Add/remove an item to/from the end of a finite sequence.  (Contributed
       by Paul Chapman, 17-Nov-2012.) $)
    fseq1m1p1 $p |- ( N e. NN ->
        ( ( F : ( 1 ... ( N - 1 ) ) --> A /\ B e. A /\ G = ( F u. H ) ) <->
          ( G : ( 1 ... N ) --> A /\ ( G ` N ) = B /\
            F = ( G |` ( 1 ... ( N - 1 ) ) ) ) ) ) $=
      ( cn wcel c1 co cfz wf cop csn cun wceq w3a cfv cc cmin caddc cres cn0 wb
      nnm1nn0 eqid fseq1p1m1 syl nncn ax-1cn npcan sylancl opeq1d sneqd syl6eqr
      uneq2d eqeq2d 3anbi3d oveq2d feq2d fveq2d eqeq1d 3anbi12d 3bitr3d ) FHIZJ
      FJUAKZLKZACMZBAIZDCVGJUBKZBNZOZPZQZRZJVKLKZADMZVKDSZBQZCDVHUCQZRZVIVJDCEP
      ZQZRJFLKZADMZFDSZBQZWARVFVGUDIVPWBUEFUFABCDVMVGVMUGUHUIVFVOWDVIVJVFVNWCDV
      FVMECVFVMFBNZOEVFVLWIVFVKFBVFFTIJTIVKFQFUJUKFJULUMZUNUOGUPUQURUSVFVRWFVTW
      HWAVFVQWEADVFVKFJLWJUTVAVFVSWGBVFVKFDWJVBVCVDVE $.
  $}

  ${
    $d k N $.
    $( Quantification over a one-member finite set of sequential integers in
       terms of substitution.  (Contributed by NM, 28-Nov-2005.) $)
    fz1sbc $p |- ( N e. ZZ
        -> ( A. k e. ( N ... N ) ph <-> [. N / k ]. ph ) ) $=
      ( cz wcel wsbc cv wceq wi wal cfz co wral sbc6g df-ral elfz1eq syl5ibrcom
      elfz3 eleq1 impbid2 imbi1d albidv syl5rbb bitr2d ) CDEZABCFBGZCHZAIZBJZAB
      CCKLZMZABCDNUKUFUJEZAIZBJUEUIABUJOUEUMUHBUEULUGAUEULUGUFCPUEULUGCUJECRUFC
      UJSQTUAUBUCUD $.
  $}

  $( An integer is a member of a 1-based finite set of sequential integers iff
     its predecessor is a member of the corresponding 0-based set.
     (Contributed by Paul Chapman, 22-Jun-2011.) $)
  elfzm1b $p |- ( ( K e. ZZ /\ N e. ZZ ) ->
                ( K e. ( 1 ... N ) <-> ( K - 1 ) e. ( 0 ... ( N - 1 ) ) ) ) $=
    ( cz wcel c1 cfz co cmin wb wa 1z fzsubel mpanl1 mpanr2 1m1e0 oveq1i eleq2i
    cc0 syl6bb ancoms ) BCDZACDZAEBFGDZAEHGZRBEHGZFGZDZIUAUBJUCUDEEHGZUEFGZDZUG
    UAUBECDZUCUJIZKUKUAUBUKJULKAEEBLMNUIUFUDUHRUEFOPQST $.

  $( Options for membership in a finite interval of integers.  (Contributed by
     Jeff Madsen, 18-Jun-2010.) $)
  elfzp12 $p |- ( N e. ( ZZ>= ` M ) -> ( K e. ( M ... N ) <->
                                ( K = M \/ K e. ( ( M + 1 ) ... N ) ) ) ) $=
    ( cuz cfv wcel cfz co wceq c1 caddc wo cvv elex anim2i elfvex eleq1 cun syl
    wa syl5ibrcom imdistani jaodan eluzfz1 fzsplit cz eluzel2 fzsn uneq1d eqtrd
    csn eleq2d elun syl6bb elsncg orbi1d sylan9bb pm5.21nd ) CBDEFZABCGHZFZABIZ
    ABJKHCGHZFZLZUSAMFZTZVAVFUSAUTNOUSVBVGVDUSVBVFUSVFVBBMFCBDPABMQUAUBVDVFUSAV
    CNOUCUSVAABUKZFZVDLZVFVEUSVAAVHVCRZFVJUSUTVKAUSUTBBGHZVCRZVKUSBUTFUTVMIBCUD
    BBCUESUSVLVHVCUSBUFFVLVHIBCUGBUHSUIUJULAVHVCUMUNVFVIVBVDABMUOUPUQUR $.

  $( Choices for an element of a finite interval of integers.  (Contributed by
     Jeff Madsen, 2-Sep-2009.) $)
  fzm1 $p |- ( N e. ( ZZ>= ` M ) -> ( K e. ( M ... N ) <->
                              ( K e. ( M ... ( N - 1 ) ) \/ K = N ) ) ) $=
    ( wcel cfz co c1 wceq wa wi cz cle wbr w3a wb elfz1 syl2anc a1i cr ex wo wn
    cuz cfv cmin eluzel2 eluzelz simp1 simp2 clt wne zre eluzelre ltlen syl2anr
    nesym anbi2i ancom bitri syl6bb biimpar an4s zltlem1 sylan2 biimpd ad2ant2r
    ancoms mpd 3adantr2 3jcad 1z zsubcl sylancl biimprd syl6d com23 sylbid orrd
    imp orcomd caddc fzssp1 cc ax-1cn npcan oveq2d syl5sseq sseld eluzfz2 eleq1
    zcnd syl5ibrcom jaod impbid ) CBUCUDDZABCEFZDZABCGUEFZEFZDZACHZUAZWOWQXBWOW
    QIZXAWTXCXAWTWOWQXAUBZWTJZWOWQAKDZBALMZACLMZNZXEWOBKDZCKDZWQXIOBCUFZBCUGZAB
    CPQWOXDXIWTWOXDXIXFXGAWRLMZNZWTWOXDXIXOJWOXDIZXIXFXGXNXIXFJXPXFXGXHUHRXIXGJ
    XPXFXGXHUIRXPXIXNXPXFXHXNXGXPXFXHIIACUJMZXNWOXFXDXHXQWOXFIZXQXDXHIZXRXQXHCA
    UKZIZXSXFASDCSDXQYAOWOAULBCUMACUNUOYAXHXDIXSXTXDXHCAUPUQXHXDURUSUTVAVBWOXFX
    QXNJZXDXHXFWOYBXFWOIXQXNWOXFXKXQXNOXMACVCVDVEVGVFVHVITVJTWOWTXOWOXJWRKDZWTX
    OOXLWOXKGKDYCXMVKCGVLVMABWRPQVNVOVPVQVSVRVTTWOWTWQXAWOWSWPAWOBWRGWAFZEFWSWP
    BWRWBWOYDCBEWOCWCDGWCDYDCHWOCXMWKWDCGWEVMWFWGWHWOWQXACWPDBCWIACWPWJWLWMWN
    $.

  $( No finite set of sequential integers equals a set of upper integers.
     (Contributed by NM, 11-Dec-2005.) $)
  fzneuz $p |- ( ( N e. ( ZZ>= ` M ) /\ K e. ZZ )
               -> -. ( M ... N ) = ( ZZ>= ` K ) ) $=
    ( cuz cfv wcel cz wa cfz co wceq wn c1 caddc peano2uz adantl wbr cr nelneq2
    ad2antrr cle eluzelre clt wb peano2re ltnle mpdan mpbid syl elfzle2 syl2anc
    ltp1 nsyl eqcom sylnib eluzfz2 sylancom pm2.61dan ) CBDEFZAGFZHZCADEZFZBCIJ
    ZVBKZLZVAVCHZVBVDKZVEVGCMNJZVBFZVIVDFZLZVHLVCVJVAACOPUSVLUTVCUSVICUAQZVKUSC
    RFZVMLZBCUBVNCVIUCQZVOCULVNVIRFVPVOUDCUECVIUFUGUHUIVIBCUJUMTVIVBVDSUKVBVDUN
    UOVAVCLZCVDFZVFUSVRUTVQBCUPTCVDVBSUQUR $.

  $( Disjointness of the upper integers and a finite sequence.  (Contributed by
     Mario Carneiro, 30-Jun-2013.)  (Revised by Mario Carneiro,
     24-Aug-2013.) $)
  fznuz $p |- ( K e. ( M ... N ) -> -. K e. ( ZZ>= ` ( N + 1 ) ) ) $=
    ( cfz co wcel c1 caddc cuz cfv cle wbr elfzle2 clt wn cz wi elfzel2 cr zre
    eluzp1l ex syl wb elfzelz ltnle syl2an syl2anc sylibd mt2d ) ABCDEFZACGHEIJ
    FZACKLZABCMUKULCANLZUMOZUKCPFZULUNQABCRZUPULUNCAUAUBUCUKUPAPFZUNUOUDZUQABCU
    EUPCSFASFUSURCTATCAUFUGUHUIUJ $.

  $( Disjointness of the upper integers and a finite sequence.  (Contributed by
     Mario Carneiro, 24-Aug-2013.) $)
  uznfz $p |- ( K e. ( ZZ>= ` N ) -> -. K e. ( M ... ( N - 1 ) ) ) $=
    ( cuz cfv wcel c1 cmin co cfz cle wbr eluzle clt wn cz eluzel2 wi cr zre wa
    elfzel1 w3a elfzm11 simp3 syl6bi impancom mpancom syl5com wb eluzelz syl2an
    ltnle syl2anc sylibd mt2d ) ACDEFZABCGHIZJIFZCAKLZCAMUQUSACNLZUTOZUQCPFZUSV
    ACAQZBPFZUSVCVARABURUBVEVCUSVAVEVCUAUSAPFZBAKLZVAUCVAABCUDVFVGVAUEUFUGUHUIU
    QVFVCVAVBUJZCAUKVDVFASFCSFVHVCATCTACUMULUNUOUP $.

  ${
    $d j k x K $.  $d j k x M $.  $d j k x N $.  $d k x ph $.
    $( Reversal of scanning order inside of a quantification over a finite set
       of sequential integers.  (Contributed by NM, 25-Nov-2005.) $)
    fzrevral $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ )
     -> ( A. j e. ( M ... N ) ph
         <-> A. k e. ( ( K - N ) ... ( K - M ) ) [. ( K - k ) / j ]. ph ) ) $=
      ( cz wcel cfz co wral cv cmin wsbc wi wa wb elfzelz syl wceq simpr sylan2
      w3a fzrev anassrs mpbid rspsbc ex 3impa com23 ralrimdv nfcv nfsbc1v nfral
      nfv fzrev2i oveq2 dfsbcq rspcv cc zcn nncan syl2an eqcomd sbceq1a sylibrd
      zcnd ralrimd 3ad2ant3 impbid ) EGHZFGHZDGHZUCZABEFIJZKZABDCLZMJZNZCDFMJZD
      EMJZIJZKZVNVPVSCWBVNVQWBHZVPVSVKVLVMWDVPVSOZOVKVLPZVMPZWDWEWGWDPZVRVOHZWE
      WHWDWIWGWDUAWDWGVQGHZWDWIQZVQVTWARWFVMWJWKDVQEFUDUEUBUFABVRVOUGSUHUIUJUKV
      MVKWCVPOVLVMWCABVOVMBUOVSBCWBBWBULABVRUMUNVMBLZVOHZWCAVMWMWCAOVMWMPZWCABD
      DWLMJZMJZNZAWNWOWBHWCWQODWLEFUPVSWQCWOWBVQWOTVRWPTVSWQQVQWODMUQABVRWPURSU
      SSWNWLWPTAWQQWNWPWLVMDUTHWLUTHWPWLTWMDVAWMWLWLEFRVGDWLVBVCVDABWPVESVFUHUJ
      VHVIVJ $.

    $( Reversal of scanning order inside of a quantification over a finite set
       of sequential integers.  (Contributed by NM, 25-Nov-2005.) $)
    fzrevral2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ )
        -> ( A. j e. ( ( K - N ) ... ( K - M ) ) ph
             <-> A. k e. ( M ... N ) [. ( K - k ) / j ]. ph ) ) $=
      ( cz wcel cmin co cfz wral wb w3a zsubcl 3adant2 3adant3 cc wceq zcn wsbc
      cv simp1 fzrevral syl3anc nncan oveq12d syl3an raleqdv bitrd 3coml ) DGHZ
      EGHZFGHZABDFIJZDEIJZKJLZABDCUBIJUAZCEFKJZLZMULUMUNNZUQURCDUPIJZDUOIJZKJZL
      ZUTVAUOGHZUPGHZULUQVEMULUNVFUMDFOPULUMVGUNDEOQULUMUNUCABCDUOUPUDUEVAURCVD
      USULDRHZUMERHZUNFRHZVDUSSDTETFTVHVIVJNVBEVCFKVHVIVBESVJDEUFQVHVJVCFSVIDFU
      FPUGUHUIUJUK $.

    $( Reversal of scanning order inside of a quantification over a finite set
       of sequential integers.  (Contributed by NM, 20-Nov-2005.) $)
    fzrevral3 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( A. j e. ( M ... N ) ph
              <-> A. k e. ( M ... N ) [. ( ( M + N ) - k ) / j ]. ph ) ) $=
      ( cz wcel wa cfz co wral caddc cv cmin wsbc wb zaddcl fzrevral cc zcn
      mpd3an3 wceq pncan pncan2 oveq12d syl2an raleqdv bitrd ) DFGZEFGZHZABDEIJ
      ZKZABDELJZCMNJOZCUNENJZUNDNJZIJZKZUOCULKUIUJUNFGUMUSPDEQABCUNDERUAUKUOCUR
      ULUIDSGZESGZURULUBUJDTETUTVAHUPDUQEIDEUCDEUDUEUFUGUH $.

    $( Shift the scanning order inside of a quantification over a finite set of
       sequential integers.  (Contributed by NM, 27-Nov-2005.) $)
    fzshftral $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ )
        -> ( A. j e. ( M ... N ) ph
          <-> A. k e. ( ( M + K ) ... ( N + K ) ) [. ( k - K ) / j ]. ph ) ) $=
      ( vx cz wcel cfz co wral cc0 cmin wsbc caddc wb cc wceq wa cv 0z fzrevral
      w3a mp3an3 3adant3 zsubcl mpan syl3an 3com12 cvv ovex oveq2 sbcco3g ax-mp
      ralbii zcn cneg df-neg oveq2i subneg addcom eqtrd syl5eqr 3adant2 oveq12d
      3coml raleqdv elfzelz negsubdi2 syl2an dfsbcq syl ralbidva 3ad2ant3 bitrd
      id zcnd syl5bb 3bitrd ) EHIZFHIZDHIZUDZABEFJKLZABMGUAZNKZOZGMFNKZMENKZJKL
      ZWHGDCUAZNKZOZCDWJNKZDWINKZJKZLZABWLDNKZOZCEDPKZFDPKZJKZLZWAWBWEWKQZWCWAW
      BMHIZXEUBABGMEFUCUEUFWBWAWCWKWRQZWBWIHIZWAWJHIZWCWCXGXFWBXHUBMFUGUHXFWAXI
      UBMEUGUHWCVQWHGCDWIWJUCUIUJWRABMWMNKZOZCWQLZWDXDWNXKCWQWMUKIWNXKQDWLNULAG
      BWMWGXJUKWFWMMNUMUNUOUPWDXLXKCXCLZXDWDXKCWQXCWAERIZWBFRIZWCDRIZWQXCSZEUQF
      UQDUQZXPXNXOXQXPXNXOUDWOXAWPXBJXPXNWOXASXOXPXNTZWODEURZNKZXAXTWJDNEUSUTXS
      YADEPKXADEVADEVBVCVDUFXPXOWPXBSXNXPXOTZWPDFURZNKZXBYCWIDNFUSUTYBYDDFPKXBD
      FVADFVBVCVDVEVFVGUIVHWCWAXMXDQWBWCXKWTCXCWCWLXCIZTXJWSSZXKWTQWCXPWLRIZYFY
      EXRYEWLWLXAXBVIVRXPYGTXJWMURWSWMUSDWLVJVDVKABXJWSVLVMVNVOVPVSVT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Half-open integer ranges
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ..^ $.
  $( Syntax for half-open integer ranges. $)
  cfzo $a class ..^ $.

  ${
    $d m n N $.  $d m n M $.  $d x A $.  $d x M $.  $d x N $.  $d x K $.
    $d x B $.  $d x C $.  $d x D $.
    $( Define a function generating sets of integers using a _half-open_
       range.  Read ` ( M ..^ N ) ` as the integers from ` M ` up to, but not
       including, ` N ` ; contrast with ` ( M ... N ) ` ~ df-fz , which
       includes ` N ` .  Not including the endpoint simplifies a number of
       formulae related to cardinality and splitting; contrast ~ fzosplit with
       ~ fzsplit , for instance.  (Contributed by Stefan O'Rear,
       14-Aug-2015.) $)
    df-fzo $a |- ..^ = ( m e. ZZ , n e. ZZ |-> ( m ... ( n - 1 ) ) ) $.

    $( Functionality of the half-open integer set function.  (Contributed by
       Stefan O'Rear, 14-Aug-2015.) $)
    fzof $p |- ..^ : ( ZZ X. ZZ ) --> ~P ZZ $=
      ( vm vn cv c1 cmin co cfz cz cpw wcel wral cxp cfzo wf wss cuz cfv fzssuz
      uzssz sstri ovex elpw mpbir rgen2w df-fzo fmpt2 mpbi ) ACZBCDEFZGFZHIZJZB
      HKAHKHHLUKMNULABHHULUJHOUJUHPQHUHUIRUHSTUJHUHUIGUAUBUCUDABHHUJUKMABUEUFUG
      $.

    $( Reverse closure for half-open integer sets.  (Contributed by Stefan
       O'Rear, 14-Aug-2015.) $)
    elfzoel1 $p |- ( A e. ( B ..^ C ) -> B e. ZZ ) $=
      ( cfzo co wcel cz c0 wne ne0i cxp cpw fzof fdmi ndmov necon1ai syl simpld
      wa ) ABCDEZFZBGFZCGFZUATHIUBUCSZTAJUDTHBCGDGGKGLDMNOPQR $.

    $( Reverse closure for half-open integer sets.  (Contributed by Stefan
       O'Rear, 14-Aug-2015.) $)
    elfzoel2 $p |- ( A e. ( B ..^ C ) -> C e. ZZ ) $=
      ( cfzo co wcel cz c0 wne ne0i cxp cpw fzof fdmi ndmov necon1ai syl simprd
      wa ) ABCDEZFZBGFZCGFZUATHIUBUCSZTAJUDTHBCGDGGKGLDMNOPQR $.

    $( Reverse closure for half-open integer sets.  (Contributed by Stefan
       O'Rear, 14-Aug-2015.) $)
    elfzoelz $p |- ( A e. ( B ..^ C ) -> A e. ZZ ) $=
      ( cfzo co wcel cz cpw elfzoel1 elfzoel2 fzof fovcl syl2anc elpwid sseldd
      id ) ABCDEZFZQGARQGRBGFCGFQGHZFABCIABCJBCSGGDKLMNRPO $.

    $( Value of the half-open integer set in terms of the closed integer set.
       (Contributed by Stefan O'Rear, 14-Aug-2015.) $)
    fzoval $p |- ( N e. ZZ -> ( M ..^ N ) = ( M ... ( N - 1 ) ) ) $=
      ( vm vn cz wcel cfzo co c1 cmin cfz wceq cv wn c0 simpl con3i fdmi ndmov
      wa oveq1 oveqan12d df-fzo ovex ovmpt2a cxp cpw fzof syl fzf eqtr4d adantr
      id pm2.61ian ) AEFZBEFZABGHZABIJHZKHZLZCDABEECMZDMZIJHZKHUSGVAALZVBBLVAAV
      CURKVDUMVBBIJUAUBCDUCAURKUDUEUONZUTUPVEUQOUSVEUOUPTZNUQOLVFUOUOUPPQABEGEE
      UFZEUGZGUHRSUIVEUOUREFZTZNUSOLVJUOUOVIPQAUREKVGVHKUJRSUIUKULUN $.
  $}

  $( Membership in a half-open finite set of integers.  (Contributed by Stefan
     O'Rear, 15-Aug-2015.) $)
  elfzo $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) -> ( K e. ( M ..^ N ) <->
        ( M <_ K /\ K < N ) ) ) $=
    ( cz wcel w3a c1 cmin co cfz cle wbr wa cfzo clt wb peano2zm syl3an3 fzoval
    elfz eleq2d 3ad2ant3 zltlem1 3adant2 anbi2d 3bitr4d ) ADEZBDEZCDEZFZABCGHIZ
    JIZEZBAKLZAUKKLZMZABCNIZEZUNACOLZMUIUGUHUKDEUMUPPCQABUKTRUIUGURUMPUHUIUQULA
    BCSUAUBUJUSUOUNUGUIUSUOPUHACUCUDUEUF $.

  $( Membership in a half-open integer interval.  (Contributed by Mario
     Carneiro, 29-Sep-2015.) $)
  elfzo2 $p |- ( K e. ( M ..^ N ) <->
      ( K e. ( ZZ>= ` M ) /\ N e. ZZ /\ K < N ) ) $=
    ( cz wcel w3a cle wbr clt wa cuz cfv cfzo an4 df-3an anbi1i 3ancoma 3bitr4i
    co eluz2 3bitri elfzoelz elfzoel1 elfzoel2 3jca elfzo biadan2 3anass ) ADEZ
    BDEZCDEZFZBAGHZACIHZJZJZABKLEZUKUNJZJZABCMSEZUQUKUNFUIUJJZUKJZUOJVAUMJZURJU
    PUSVAUKUMUNNULVBUOUIUJUKOPUQVCURUQUJUIUMFUIUJUMFVCBATUJUIUMQUIUJUMOUAPRUTUL
    UOUTUIUJUKABCUBABCUCABCUDUEABCUFUGUQUKUNUHR $.

  $( Membership in a half-open integer interval.  (Contributed by Mario
     Carneiro, 29-Sep-2015.) $)
  elfzouz $p |- ( K e. ( M ..^ N ) -> K e. ( ZZ>= ` M ) ) $=
    ( cfzo co wcel cuz cfv cz clt wbr elfzo2 simp1bi ) ABCDEFABGHFCIFACJKABCLM
    $.

  $( The left endpoint of a half-open integer interval is in the set iff the
     two arguments are integers with ` M < N ` .  This provides an alternative
     notation for the "strict upper integer" predicate by analogy to the "weak
     upper integer" predicate ` M e. ( ZZ>= `` N ) ` .  (Contributed by Mario
     Carneiro, 29-Sep-2015.) $)
  fzolb $p |- ( M e. ( M ..^ N ) <-> ( M e. ZZ /\ N e. ZZ /\ M < N ) ) $=
    ( cfzo co wcel cuz cfv clt wbr w3a elfzo2 eluzel2 uzid impbii 3anbi1i bitri
    cz ) AABCDEAAFGEZBQEZABHIZJAQEZSTJAABKRUASTRUAAALAMNOP $.

  $( The left endpoint of a half-open integer interval is in the set iff the
     two arguments are integers with ` M < N ` .  This provides an alternative
     notation for the "strict upper integer" predicate by analogy to the "weak
     upper integer" predicate ` M e. ( ZZ>= `` N ) ` .  (Contributed by Mario
     Carneiro, 29-Sep-2015.) $)
  fzolb2 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M e. ( M ..^ N ) <-> M < N ) ) $=
    ( cfzo co wcel cz wa clt wbr w3a fzolb df-3an bitri baib ) AABCDEZAFEZBFEZG
    ZABHIZOPQSJRSGABKPQSLMN $.

  $( A member in a half-open integer interval is greater than or equal to the
     lower bound.  (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  elfzole1 $p |- ( K e. ( M ..^ N ) -> M <_ K ) $=
    ( cfzo co cle wbr clt wa cz wb elfzoelz elfzoel1 elfzoel2 elfzo syl3anc ibi
    wcel simpld ) ABCDERZBAFGZACHGZTUAUBIZTAJRBJRCJRTUCKABCLABCMABCNABCOPQS $.

  $( A member in a half-open integer interval is less than the upper bound.
     (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  elfzolt2 $p |- ( K e. ( M ..^ N ) -> K < N ) $=
    ( cfzo co cle wbr clt wa cz wb elfzoelz elfzoel1 elfzoel2 elfzo syl3anc ibi
    wcel simprd ) ABCDERZBAFGZACHGZTUAUBIZTAJRBJRCJRTUCKABCLABCMABCNABCOPQS $.

  $( Membership in a half-open integer interval implies that the bounds are
     unequal.  (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  elfzolt3 $p |- ( K e. ( M ..^ N ) -> M < N ) $=
    ( cfzo co wcel elfzoel1 zred elfzoelz elfzoel2 elfzole1 elfzolt2 lelttrd )
    ABCDEFZBACNBABCGHNAABCIHNCABCJHABCKABCLM $.

  $( A member in a half-open integer interval is less than the upper bound.
     (Contributed by Mario Carneiro, 29-Sep-2015.) $)
  elfzolt2b $p |- ( K e. ( M ..^ N ) -> K e. ( K ..^ N ) ) $=
    ( cfzo co wcel cz clt wbr elfzoelz elfzoel2 elfzolt2 fzolb syl3anbrc ) ABCD
    EFAGFCGFACHIAACDEFABCJABCKABCLACMN $.

  $( Membership in a half-open integer interval implies that the bounds are
     unequal.  (Contributed by Mario Carneiro, 29-Sep-2015.) $)
  elfzolt3b $p |- ( K e. ( M ..^ N ) -> M e. ( M ..^ N ) ) $=
    ( cfzo co wcel cz clt wbr elfzoel1 elfzoel2 elfzolt3 fzolb syl3anbrc ) ABCD
    EZFBGFCGFBCHIBOFABCJABCKABCLBCMN $.

  $( A half-open range does not contain its right endpoint.  (Contributed by
     Stefan O'Rear, 25-Aug-2015.) $)
  fzonel $p |- -. B e. ( A ..^ B ) $=
    ( cfzo co wcel clt wbr elfzolt2 elfzoel2 zred ltnrd pm2.65i ) BABCDEZBBFGBA
    BHMBMBBABIJKL $.

  $( The upper bound of a half-open range is greater or equal to an element of
     the range.  (Contributed by Mario Carneiro, 29-Sep-2015.) $)
  elfzouz2 $p |- ( K e. ( M ..^ N ) -> N e. ( ZZ>= ` K ) ) $=
    ( cfzo co wcel cz cle wbr cuz cfv elfzoelz elfzoel2 clt elfzolt2 wi cr ltle
    zre syl2an syl2anc mpd eluz2 syl3anbrc ) ABCDEFZAGFZCGFZACHIZCAJKFABCLZABCM
    ZUEACNIZUHABCOUEUFUGUKUHPZUIUJUFAQFCQFULUGASCSACRTUAUBACUCUD $.

  $( A half-open range is contained in the corresponding closed range.
     (Contributed by Stefan O'Rear, 23-Aug-2015.) $)
  elfzofz $p |- ( K e. ( M ..^ N ) -> K e. ( M ... N ) ) $=
    ( cfzo co wcel cuz cfv cfz elfzouz elfzouz2 elfzuzb sylanbrc ) ABCDEFABGHFC
    AGHFABCIEFABCJABCKABCLM $.

  $( Express membership in a half-open integer interval in terms of the "less
     than or equal" and "less than" predicates on integers, resp.
     ` K e. ( ZZ>= `` M ) <-> M <_ K ` , ` K e. ( K ..^ N ) <-> K < N ` .
     (Contributed by Mario Carneiro, 29-Sep-2015.) $)
  elfzo3 $p |- ( K e. ( M ..^ N ) <->
      ( K e. ( ZZ>= ` M ) /\ K e. ( K ..^ N ) ) ) $=
    ( cuz cfv wcel cz clt wbr wa cfzo co 3anass elfzo2 eluzelz fzolb bitri baib
    w3a wb syl pm5.32i 3bitr4i ) ABDEFZCGFZACHIZSUDUEUFJZJABCKLFUDAACKLFZJUDUEU
    FMABCNUDUHUGUDAGFZUHUGTBAOUHUIUGUHUIUEUFSUIUGJACPUIUEUFMQRUAUBUC $.

  ${
    $d x A $.  $d x B $.  $d x M $.  $d x N $.
    $( A half-open integer interval is nonempty iff it contains its left
       endpoint.  (Contributed by Mario Carneiro, 29-Sep-2015.) $)
    fzon0 $p |- ( ( M ..^ N ) =/= (/) <-> M e. ( M ..^ N ) ) $=
      ( vx cfzo co c0 wne wcel cv wex n0 elfzolt3b exlimiv sylbi ne0i impbii )
      ABDEZFGZAQHZRCIZQHZCJSCQKUASCTABLMNQAOP $.

    $( A half-open range is contained in the corresponding closed range.
       (Contributed by Stefan O'Rear, 23-Aug-2015.)  (Revised by Mario
       Carneiro, 29-Sep-2015.) $)
    fzossfz $p |- ( A ..^ B ) C_ ( A ... B ) $=
      ( vx cfzo co cfz cv elfzofz ssriv ) CABDEABFECGABHI $.
  $}

  $( A half-open set of sequential integers is empty if the bounds are equal or
     reversed.  (Contributed by Alexander van der Vekens, 30-Oct-2017.) $)
  fzon $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( N <_ M <-> ( M ..^ N ) = (/) ) ) $=
    ( cz wcel wa c1 cmin co clt wbr cfz c0 wceq cle cfzo wb peano2zm fzn sylan2
    zlem1lt ancoms fzoval adantl eqeq1d 3bitr4d ) ACDZBCDZEZBFGHZAIJZAUIKHZLMZB
    ANJZABOHZLMUGUFUICDUJULPBQAUIRSUGUFUMUJPBATUAUHUNUKLUGUNUKMUFABUBUCUDUE $.

  $( Half-open sets with equal endpoints are empty.  (Contributed by Stefan
     O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro, 29-Sep-2015.) $)
  fzo0 $p |- ( A ..^ A ) = (/) $=
    ( cfzo co wcel wn c0 wceq fzonel fzon0 necon1bbii mpbi ) AAABCZDZELFGAAHMLF
    AAIJK $.

  $( If ` K < N ` then ` N - K ` is a positive integer.  (Contributed by Mario
     Carneiro, 29-Sep-2015.)  (Revised by Mario Carneiro, 1-Jan-2017.) $)
  fzonnsub $p |- ( K e. ( M ..^ N ) -> ( N - K ) e. NN ) $=
    ( cfzo co wcel clt wbr cmin cn elfzolt2 cz elfzoelz elfzoel2 znnsub syl2anc
    wb mpbid ) ABCDEFZACGHZCAIEJFZABCKSALFCLFTUAQABCMABCNACOPR $.

  $( If ` M < N ` then ` N - M ` is a positive integer.  (Contributed by Mario
     Carneiro, 1-Jan-2017.) $)
  fzonnsub2 $p |- ( K e. ( M ..^ N ) -> ( N - M ) e. NN ) $=
    ( cfzo co wcel cmin cn elfzolt3b fzonnsub syl ) ABCDEZFBLFCBGEHFABCIBBCJK
    $.

  $( Subset relationship for half-open sequences of integers.  (Contributed by
     Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro, 29-Sep-2015.) $)
  fzoss1 $p |- ( K e. ( ZZ>= ` M ) -> ( K ..^ N ) C_ ( M ..^ N ) ) $=
    ( cuz cfv wcel cfzo co wss c0 sseq1 wne cz fzon0 elfzoel2 sylbi wceq fzoval
    cfz adantl wa c1 cmin fzss1 adantr 3sstr4d sylan2 0ss a1i pm2.61ne ) ABDEFZ
    ACGHZBCGHZIZJUMIZULJULJUMKULJLZUKCMFZUNUPAULFUQACNAACOPUKUQUAACUBUCHZSHZBUR
    SHZULUMUKUSUTIUQABURUDUEUQULUSQUKACRTUQUMUTQUKBCRTUFUGUOUKUMUHUIUJ $.

  $( Subset relationship for half-open sequences of integers.  (Contributed by
     Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro, 29-Sep-2015.) $)
  fzoss2 $p |- ( N e. ( ZZ>= ` K ) -> ( M ..^ K ) C_ ( M ..^ N ) ) $=
    ( cuz cfv wcel c1 cmin co cfz cfzo wss cz caddc eluzel2 peano2zm syl fzoval
    cc wceq 1z a1i id zcnd ax-1cn npcan sylancl fveq2d eleqtrrd eluzsub syl3anc
    fzss2 eluzelz 3sstr4d ) CADEZFZBAGHIZJIZBCGHIZJIZBAKIZBCKIZUPUSUQDEFZURUTLU
    PUQMFZGMFZCUQGNIZDEZFVCUPAMFZVDACOZAPQVEUPUAUBUPCUOVGUPUCUPVFADUPASFGSFVFAT
    UPAVIUDUEAGUFUGUHUIGUQCUJUKUQBUSULQUPVHVAURTVIBARQUPCMFVBUTTACUMBCRQUN $.

  $( Subset of a half open range.  (Contributed by Alexander van der Vekens,
     1-Nov-2017.) $)
  fzossrbm1 $p |- ( N e. NN0 -> ( 0 ..^ ( N - 1 ) ) C_ ( 0 ..^ N ) ) $=
    ( cn0 wcel c1 cmin co cuz cfv cc0 cfzo wss cz cle nn0z peano2zm nn0re lem1d
    wbr syl eluz2 syl3anbrc fzoss2 ) ABCZAADEFZGHCZIUDJFIAJFKUCUDLCZALCZUDAMRUE
    UCUGUFANZAOSUHUCAAPQUDATUAUDIAUBS $.

  $( One direction of splitting a half-open integer range in half.
     (Contributed by Stefan O'Rear, 14-Aug-2015.) $)
  fzospliti $p |- ( ( A e. ( B ..^ C ) /\ D e. ZZ ) ->
      ( A e. ( B ..^ D ) \/ A e. ( D ..^ C ) ) ) $=
    ( cfzo co wcel cz wa wo cle wbr clt cr zre adantr a1d wb elfzo syl3anc zred
    adantl elfzoelz lelttric syl2anc orcomd elfzole1 ancrd elfzolt2 orim12d mpd
    ancld elfzoel1 simpr elfzoel2 orbi12d mpbird ) ABCEFGZDHGZIZABDEFGZADCEFGZJ
    BAKLZADMLZIZDAKLZACMLZIZJZUTVDVFJVIUTVFVDUTDNGZANGVFVDJUSVJURDOUBUTAURAHGZU
    SABCUCPZUADAUDUEUFUTVDVEVFVHUTVDVCUTVCVDURVCUSABCUGPQUHUTVFVGUTVGVFURVGUSAB
    CUIPQULUJUKUTVAVEVBVHUTVKBHGZUSVAVERVLURVMUSABCUMPURUSUNZABDSTUTVKUSCHGZVBV
    HRVLVNURVOUSABCUOPADCSTUPUQ $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    $( Split a half-open integer range in half.  (Contributed by Stefan O'Rear,
       14-Aug-2015.) $)
    fzosplit $p |- ( D e. ( B ... C ) -> ( B ..^ C ) =
          ( ( B ..^ D ) u. ( D ..^ C ) ) ) $=
      ( vx cfz co wcel cfzo cun cv wa wo simpr elfzelz adantr cuz cfv wss syl
      cz fzospliti syl2anc elun sylibr ssrdv elfzuz3 fzoss2 elfzuz fzoss1 unssd
      ex eqssd ) CABEFGZABHFZACHFZCBHFZIZUMDUNUQUMDJZUNGZURUQGZUMUSKZURUOGURUPG
      LZUTVAUSCTGZVBUMUSMUMVCUSCABNOURABCUAUBURUOUPUCUDUKUEUMUOUPUNUMBCPQGUOUNR
      CABUFCABUGSUMCAPQGUPUNRCABUHCABUISUJUL $.

    $( Abutting half-open integer ranges are disjoint.  (Contributed by Stefan
       O'Rear, 14-Aug-2015.) $)
    fzodisj $p |- ( ( A ..^ B ) i^i ( B ..^ C ) ) = (/) $=
      ( vx cfzo co cin c0 wceq cv wcel wn wi cle wbr clt elfzolt2 elfzoelz zred
      disj1 elfzoel2 ltnled mpbid elfzole1 nsyl mpgbir ) ABEFZBCEFZGHIDJZUGKZUI
      UHKZLMDDUGUHTUJBUINOZUKUJUIBPOULLUIABQUJUIBUJUIUIABRSUJBUIABUASUBUCUIBCUD
      UEUF $.

    $( Split an upper integer set into a half-open integer range and another
       upper integer set.  (Contributed by Mario Carneiro, 21-Sep-2016.) $)
    fzouzsplit $p |- ( B e. ( ZZ>= ` A ) ->
      ( ZZ>= ` A ) = ( ( A ..^ B ) u. ( ZZ>= ` B ) ) ) $=
      ( vx cuz cfv wcel cfzo co cun cv wo wa clt wbr cr eluzelre syl2an eluzelz
      cz wb cle lelttric orcomd id w3a elfzo2 df-3an bitri baib syl2anr orbi12d
      eluz mpbird ex elun syl6ibr ssrdv wss elfzouz ssriv a1i uzss unssd eqssd
      ) BADEZFZVEABGHZBDEZIZVFCVEVIVFCJZVEFZVJVGFZVJVHFZKZVJVIFVFVKVNVFVKLZVNVJ
      BMNZBVJUANZKVOVQVPVFBOFVJOFVQVPKVKABPAVJPBVJUBQUCVOVLVPVMVQVKVKBSFZVLVPTV
      FVKUDABRZVLVKVRLZVPVLVKVRVPUEVTVPLVJABUFVKVRVPUGUHUIUJVFVRVJSFVMVQTVKVSAV
      JRBVJULQUKUMUNVJVGVHUOUPUQVFVGVHVEVGVEURVFCVGVEVJABUSUTVAABVBVCVD $.

    $( A half-open integer range does not overlap the upper integer range
       starting at the endpoint of the first range.  (Contributed by Mario
       Carneiro, 21-Sep-2016.) $)
    fzouzdisj $p |- ( ( A ..^ B ) i^i ( ZZ>= ` B ) ) = (/) $=
      ( vx cfzo co cuz cfv cin c0 wceq cv wcel wn eq0 wa elfzolt2 adantr adantl
      clt wbr cle eluzle cz eluzel2 zred cr eluzelre lenltd mpbid pm2.65i mtbir
      elin mpgbir ) ABDEZBFGZHZIJCKZUPLZMCCUPNURUQUNLZUQUOLZOZVAUQBSTZUSVBUTUQA
      BPQVABUQUATZVBMUTVCUSBUQUBRVABUQVABUTBUCLUSBUQUDRUEUTUQUFLUSBUQUGRUHUIUJU
      QUNUOULUKUM $.
  $}

  $( An integer is strictly greater than zero iff it is a member of ` NN ` .
     (Contributed by Mario Carneiro, 29-Sep-2015.) $)
  lbfzo0 $p |- ( 0 e. ( 0 ..^ A ) <-> A e. NN ) $=
    ( cc0 cz wcel clt wbr w3a wa cfzo co cn 3anass mpbiran fzolb elnnz 3bitr4i
    0z ) BCDZACDZBAEFZGZSTHZBBAIJDAKDUARUBQRSTLMBANAOP $.

  $( Membership in a half-open integer range based at 0.  (Contributed by
     Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro, 29-Sep-2015.) $)
  elfzo0 $p |- ( A e. ( 0 ..^ B ) <-> ( A e. NN0 /\ B e. NN /\ A < B ) ) $=
    ( cc0 cfzo co wcel cn0 clt wbr w3a cuz cfv elfzouz elnn0uz sylibr elfzolt3b
    cn lbfzo0 sylib elfzolt2 3jca cz simp1 nnz 3ad2ant2 elfzo2 syl3anbrc impbii
    simp3 ) ACBDEZFZAGFZBQFZABHIZJZUKULUMUNUKACKLFZULACBMANZOUKCUJFUMACBPBRSACB
    TUAUOUPBUBFZUNUKUOULUPULUMUNUCUQSUMULURUNBUDUEULUMUNUIACBUFUGUH $.

  ${
    $d k N $.
    $( Half-opened integer ranges starting with 1 are subsets of NN.
       (Contributed by Thierry Arnoux, 28-Dec-2016.) $)
    fzossnn $p |- ( 1 ..^ N ) C_ NN $=
      ( vk c1 cfzo co cfz cn fzossfz cv elfznn ssriv sstri ) CADECAFEZGCAHBMGBI
      AJKL $.
  $}

  $( Membership in a half-open integer range based at 1.  (Contributed by
     Thierry Arnoux, 14-Feb-2017.) $)
  elfzo1 $p |- ( N e. ( 1 ..^ M ) <-> ( N e. NN /\ M e. NN /\ N < M ) ) $=
    ( c1 cfzo co wcel cn clt wbr w3a fzossnn sseli cuz cfv elfzouz2 nnuz uztrn2
    syl2anc elfzolt2 3jca cz eqimssi nnz id 3anim123i elfzo2 sylibr impbii ) BC
    ADEZFZBGFZAGFZBAHIZJZUJUKULUMUIGBAKLZUJUKABMNFULUOBCAOCABGPQRBCASTUNBCMNZFZ
    AUAFZUMJUJUKUQULURUMUMGUPBGUPPUBLAUCUMUDUEBCAUFUGUH $.

  $( A half-open integer range based at 0 is nonempty precisely if the upper
     bound is a positive integer.  (Contributed by Stefan O'Rear,
     15-Aug-2015.)  (Revised by Mario Carneiro, 29-Sep-2015.) $)
  fzo0n0 $p |- ( ( 0 ..^ A ) =/= (/) <-> A e. NN ) $=
    ( cc0 cfzo co c0 wne wcel cn fzon0 lbfzo0 bitri ) BACDZEFBLGAHGBAIAJK $.

  $( Translate membership in a half-open integer range.  (Contributed by Stefan
     O'Rear, 15-Aug-2015.) $)
  fzoaddel $p |- ( ( A e. ( B ..^ C ) /\ D e. ZZ ) ->
      ( A + D ) e. ( ( B + D ) ..^ ( C + D ) ) ) $=
    ( cfzo co wcel cz wa caddc cle wbr clt elfzoel1 adantr zred elfzoelz zaddcl
    simpr sylan elfzole1 leadd1dd elfzoel2 elfzolt2 ltadd1dd wb elfzo mpbir2and
    syl3anc ) ABCEFGZDHGZIZADJFZBDJFZCDJFZEFGZUNUMKLZUMUOMLZULBADULBUJBHGZUKABC
    NZOPULAUJAHGZUKABCQZOPZULDUJUKSPZUJBAKLUKABCUAOUBULACDVCULCUJCHGZUKABCUCZOP
    VDUJACMLUKABCUDOUEULUMHGZUNHGZUOHGZUPUQURIUFUJVAUKVGVBADRTUJUSUKVHUTBDRTUJV
    EUKVIVFCDRTUMUNUOUGUIUH $.

  $( Translate membership in a shifted-down half-open integer range.
     (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  fzoaddel2 $p |- ( ( A e. ( 0 ..^ ( B - C ) ) /\ B e. ZZ /\ C e. ZZ ) ->
      ( A + C ) e. ( C ..^ B ) ) $=
    ( cc0 cmin co cfzo wcel cz w3a caddc fzoaddel 3adant2 wceq cc zcn wa addid2
    adantl npcan oveq12d syl2an 3adant1 eleqtrd ) ADBCEFZGFHZBIHZCIHZJACKFZDCKF
    ZUECKFZGFZCBGFZUFUHUIULHUGADUECLMUGUHULUMNZUFUGBOHZCOHZUNUHBPCPUOUPQUJCUKBG
    UPUJCNUOCRSBCTUAUBUCUD $.

  $( Translate membership in a half-open integer range.  (Contributed by Stefan
     O'Rear, 15-Aug-2015.) $)
  fzosubel $p |- ( ( A e. ( B ..^ C ) /\ D e. ZZ ) ->
      ( A - D ) e. ( ( B - D ) ..^ ( C - D ) ) ) $=
    ( cfzo co wcel cz wa cneg caddc cmin znegcl fzoaddel sylan2 elfzoelz adantr
    zcnd simpr negsubd elfzoel1 elfzoel2 oveq12d 3eltr3d ) ABCEFGZDHGZIZADJZKFZ
    BUHKFZCUHKFZEFZADLFBDLFZCDLFZEFUFUEUHHGUIULGDMABCUHNOUGADUGAUEAHGUFABCPQRUG
    DUEUFSRZTUGUJUMUKUNEUGBDUGBUEBHGUFABCUAQRUOTUGCDUGCUECHGUFABCUBQRUOTUCUD $.

  $( Membership in a translated half-open integer range implies translated
     membership in the original range.  (Contributed by Stefan O'Rear,
     15-Aug-2015.) $)
  fzosubel2 $p |- ( ( A e. ( ( B + C ) ..^ ( B + D ) ) /\ ( B e. ZZ /\
        C e. ZZ /\ D e. ZZ ) ) -> ( A - B ) e. ( C ..^ D ) ) $=
    ( caddc co cfzo wcel cz w3a cmin fzosubel 3ad2antr1 wceq zcn pncan2 3adant3
    wa cc 3adant2 oveq12d syl3an adantl eleqtrd ) ABCEFZBDEFZGFHZBIHZCIHZDIHZJZ
    RABKFZUEBKFZUFBKFZGFZCDGFZUGUIUHULUOHUJAUEUFBLMUKUOUPNZUGUHBSHZUICSHZUJDSHZ
    UQBOCODOURUSUTJUMCUNDGURUSUMCNUTBCPQURUTUNDNUSBDPTUAUBUCUD $.

  $( Membership in a translated half-open integer range when the original range
     is zero-based.  (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  fzosubel3 $p |- ( ( A e. ( B ..^ ( B + D ) ) /\ D e. ZZ ) ->
      ( A - B ) e. ( 0 ..^ D ) ) $=
    ( caddc co cfzo wcel cz wa cmin simpl elfzoel1 adantr zcnd addid1d eleqtrrd
    cc0 oveq1d 0z a1i simpr fzosubel2 syl13anc ) ABBCDEZFEZGZCHGZIZABQDEZUDFEZG
    BHGZQHGZUGABJEQCFEGUHAUEUJUFUGKUHUIBUDFUHBUHBUFUKUGABUDLMZNORPUMULUHSTUFUGU
    AABQCUBUC $.

  $( Expressing a closed integer range as a half-open integer range.
     (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  fzval3 $p |- ( N e. ZZ -> ( M ... N ) = ( M ..^ ( N + 1 ) ) ) $=
    ( cz wcel c1 caddc co cfzo cmin cfz wceq peano2z fzoval syl cc ax-1cn pncan
    zcn sylancl oveq2d eqtr2d ) BCDZABEFGZHGZAUCEIGZJGZABJGUBUCCDUDUFKBLAUCMNUB
    UEBAJUBBODEODUEBKBRPBEQSTUA $.

  $( Expressing a singleton as a half-open range.  (Contributed by Stefan
     O'Rear, 23-Aug-2015.) $)
  fzosn $p |- ( A e. ZZ -> ( A ..^ ( A + 1 ) ) = { A } ) $=
    ( cz wcel cfz co c1 caddc cfzo csn fzval3 fzsn eqtr3d ) ABCAADEAAFGEHEAIAAJ
    AKL $.

  $( Expressing the singleton of ` 0 ` as a half-open integer range.
     (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
  fzo01 $p |- ( 0 ..^ 1 ) = { 0 } $=
    ( cc0 c1 cfzo co caddc csn 1e0p1 oveq2i cz wcel wceq 0z fzosn ax-mp eqtri )
    ABCDAABEDZCDZAFZBPACGHAIJQRKLAMNO $.

  $( A 1-based half-open integer interval up to, but not including, 2 is a
     singleton.  (Contributed by Alexander van der Vekens, 31-Jan-2018.) $)
  fzo12sn $p |- ( 1 ..^ 2 ) = { 1 } $=
    ( c1 c2 cfzo co caddc csn df-2 oveq2i cz wcel wceq 1z fzosn ax-mp eqtri ) A
    BCDAAAEDZCDZAFZBPACGHAIJQRKLAMNO $.

  $( A half-open integer range from 0 to 2 is an unordered pair.  (Contributed
     by Alexander van der Vekens, 4-Dec-2017.) $)
  fzo0to2pr $p |- ( 0 ..^ 2 ) = { 0 , 1 } $=
    ( cc0 c2 cfzo co c1 cmin cfz caddc cz wcel wceq 2z fzoval ax-mp 2m1e1 0p1e1
    cpr eqtr4i oveq2i 0z fzpr preq2i syl6eq 3eqtri ) ABCDZABEFDZGDZAAEHDZGDZAEQ
    ZBIJUEUGKLABMNUFUHAGUFEUHOPRSAIJZUIUJKTUKUIAUHQUJAUAUHEAPUBUCNUD $.

  $( A half-open integer range from 0 to 3 is an unordered triple.
     (Contributed by Alexander van der Vekens, 9-Nov-2017.) $)
  fzo0to3tp $p |- ( 0 ..^ 3 ) = { 0 , 1 , 2 } $=
    ( cc0 c3 cfzo co c1 cmin cfz c2 caddc ctp wcel wceq 3nn0 nn0zi fzoval ax-mp
    cz 3m1e2 2cn a1i addid2i eqtr4i oveq2i 0z eqidd 0p1e1 tpeq123d eqtrd 3eqtri
    fztp ) ABCDZABEFDZGDZAAHIDZGDZAEHJZBQKUKUMLBMNABOPULUNAGULHUNRHSUAZUBUCAQKZ
    UOUPLUDURUOAAEIDZUNJUPAUJURAAUSEUNHURAUEUSELURUFTUNHLURUQTUGUHPUI $.

  $( A half-open integer range from 0 to 4 is a union of two unordered pairs.
     (Contributed by Alexander van der Vekens, 17-Nov-2017.) $)
  fzo0to42pr $p |- ( 0 ..^ 4 ) = ( { 0 , 1 } u. { 2 , 3 } ) $=
    ( cc0 c4 cfzo co c2 cun c1 cpr c3 cfz wcel wceq cn0 4nn0 ax-mp caddc ax-1cn
    cz 3cn eqtri cle wbr 2nn0 2re 4re 2lt4 elfz2nn0 mpbir3an fzosplit fzo0to2pr
    ltleii cmin nn0zi fzoval 4cn df-4 addcomi eqcomi subaddrii df-3 oveq2i fzpr
    2z preq2i 3eqtri uneq12i ) ABCDZAECDZEBCDZFZAGHZEIHZFEABJDKZVGVJLVMEMKBMKEB
    UAUBUCNEBUDUEUFUKEBUGUHABEUIOVHVKVIVLUJVIEBGULDZJDZEEGPDZHZVLBRKVIVOLBNUMEB
    UNOVOEVPJDZVQVNVPEJVNIVPBGIUOQSBGIPDZBIGPDVSUPIGSQUQTURUSUTTVAERKVRVQLVCEVB
    OTVPIEIVPUTURVDVEVFT $.

  $( The endpoint of a half-open integer range.  (Contributed by Mario
     Carneiro, 29-Sep-2015.) $)
  fzoend $p |- ( A e. ( A ..^ B ) -> ( B - 1 ) e. ( A ..^ B ) ) $=
    ( cfzo co wcel c1 cmin cfz cuz cfv wceq elfzoel2 fzoval syl eleqtrd elfzuz3
    id cz eluzfz2 eleqtrrd ) AABCDZEZBFGDZAUCHDZUAUBUCAIJEZUCUDEUBAUDEUEUBAUAUD
    UBQUBBREUAUDKAABLABMNZOAAUCPNAUCSNUFT $.

  $( The endpoint of a zero-based half-open range.  (Contributed by Stefan
     O'Rear, 27-Aug-2015.)  (Revised by Mario Carneiro, 29-Sep-2015.) $)
  fzo0end $p |- ( B e. NN -> ( B - 1 ) e. ( 0 ..^ B ) ) $=
    ( cn wcel cc0 cfzo co c1 cmin lbfzo0 fzoend sylbir ) ABCDDAEFZCAGHFLCAIDAJK
    $.

  $( If a point is in a half-open range, the next point is in the closed
     range.  (Contributed by Stefan O'Rear, 23-Aug-2015.) $)
  fzofzp1 $p |- ( C e. ( A ..^ B ) -> ( C + 1 ) e. ( A ... B ) ) $=
    ( cfzo co wcel c1 caddc cfz cz cuz cfv wss elfzoel1 uzid peano2uz fzoss1 1z
    4syl fzoaddel mpan2 sseldd wceq elfzoel2 fzval3 syl eleqtrrd ) CABDEFZCGHEZ
    ABGHEZDEZABIEZUHAGHEZUJDEZUKUIUHAJFAAKLZFUMUOFUNUKMCABNAOAAPUMAUJQSUHGJFUIU
    NFRCABGTUAUBUHBJFULUKUCCABUDABUEUFUG $.

  $( If a point is in a half-open range, the next point is in the closed
     range.  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
  fzofzp1b $p |- ( C e. ( ZZ>= ` A ) ->
      ( C e. ( A ..^ B ) <-> ( C + 1 ) e. ( A ... B ) ) ) $=
    ( cuz cfv wcel cfzo co c1 caddc fzofzp1 cmin simpl eluzelz elfzuz3 eluzp1m1
    cfz wa cz syl2an elfzuzb sylanbrc wceq elfzel2 adantl fzoval syl ex impbid2
    eleqtrrd ) CADEFZCABGHZFZCIJHZABQHFZABCKUKUOUMUKUORZCABILHZQHZULUPUKUQCDEFZ
    CURFUKUOMUKCSFBUNDEFUSUOACNUNABOCBPTCAUQUAUBUPBSFZULURUCUOUTUKUNABUDUEABUFU
    GUJUHUI $.

  $( An integer is a member of a 1-based finite set of sequential integers iff
     its predecessor is a member of the corresponding 0-based set.
     (Contributed by Mario Carneiro, 27-Sep-2015.) $)
  elfzom1b $p |- ( ( K e. ZZ /\ N e. ZZ ) ->
      ( K e. ( 1 ..^ N ) <-> ( K - 1 ) e. ( 0 ..^ ( N - 1 ) ) ) ) $=
    ( cz wcel wa c1 cmin co cfz cc0 cfzo wb peano2zm elfzm1b sylan2 wceq fzoval
    adantl eleq2d syl 3bitr4d ) ACDZBCDZEZAFBFGHZIHZDZAFGHZJUEFGHIHZDZAFBKHZDUH
    JUEKHZDUCUBUECDZUGUJLBMZAUENOUDUKUFAUCUKUFPUBFBQRSUDULUIUHUDUMULUIPUCUMUBUN
    RJUEQTSUA $.

  $( A value in a finite set of sequential integers is a border value if it is
     not contained in the half-open integer range contained in the finite set
     of sequential integers.  (Contributed by Alexander van der Vekens,
     31-Oct-2017.) $)
  elfznelfzo $p |- ( ( y e. ( 0 ... K ) /\ -. y e. ( 1 ..^ K ) )
                     -> ( y = 0 \/ y = K ) ) $=
    ( cc0 co wcel c1 wn wbr wi cz wa wb syl clt a1i ex com12 cr adantr sylbid
    cv cfz cfzo wceq wo cn0 cle w3a elfz2nn0 cmin nn0z anim12i 3adant3 elfzom1b
    notbid cn elfzo0 w3o 3ianor elnnne0 df-ne anbi2i bitr2i nnm1nn0 sylbi con1d
    wne orcd 3ad2ant1 ioran nn1m1nn nn0re ad2antlr simpr leltned necom syl6rbbr
    imp breq1 biimpa ltsub1d 1m1e0 breq1i 1z zsubcld elnnz sylanbrc syl5bi syl5
    1re exp3a exp31 com14 sylbir com23 com13 adantl lesub1d nngt0 0re peano2rem
    ltletr syl3anc com24 imp41 a1d jaoi pm2.43a 3imp com3l ltsub1 bicomd eqlelt
    3jca syl2an biimpar olcd exp43 3jaoi ) AUAZCBUBDEZXTFBUCDEZGZXTCUDZXTBUDZUE
    ZYAXTUFEZBUFEZXTBUGHZUHZYCYFIXTBUIYJYCXTFUJDZCBFUJDZUCDEZGZYFYJYBYMYJXTJEZB
    JEZKZYBYMLYGYHYQYIYGYOYHYPXTUKBUKZULUMXTBUNMUOYJYNYKUFEZYLUPEZYKYLNHZUHZGZY
    FYJYMUUBYMUUBLYJYKYLUQOUOUUCYJYFUUCYSGZYTGZUUAGZURYJYFIZYSYTUUAUSUUDUUGUUEU
    UFYJUUDYFYGYHUUDYFIYIYGUUDYFYGUUDKYDYEYGUUDYDYGYDYSYGYDGZYSYGUUHKZXTUPEZYSU
    UJYGXTCVGZKZUUIXTUTZUUKUUHYGXTCVAZVBVCXTVDVEPVFVRVHPVIQYJUUEYFYJYFYTYFGZYJY
    TUUOUUHYEGZKYJYTIZYDYEVJUUHUUPUUQUUHUUKUUPUUQIUUNYJUUKUUPYTYGYHYIUUKUUPYTIZ
    IYGUUKYIYHUURUUKYGYIYHUURIZIZYGUUKYGUUTIZUULUUJUVAUUMUUJXTFUDZYKUPEZUEUVAXT
    VKUVBUVAUVCYIYGUVBUUSYHYGUVBYIUURYHYGUVBYIUURIZIUUPUVBYIYHYGKZYTUUPYIUVBUVE
    YTIZUUPXTBVGZYIUVBUVFIIXTBVAUVEYIUVBUVGYTUVEYIUVBUVGYTIUVEYIKZUVBKUVGXTBNHZ
    YTUVHUVGUVILUVBUVHUVIBXTVGUVGUVHXTBYGXTREZYHYIXTVLZVMUVEBREZYIYHUVLYGBVLZSZ
    SUVEYIVNVOXTBVPVQSUVHUVBUVIYTIZUVEUVBUVOIYIUVEUVBUVIYTUVBUVIKFBNHZUVEYTUVBU
    VIUVPXTFBNVSVTUVEUVPFFUJDZYLNHZYTUVEFBFFREZUVEWJOZUVNUVTWAUVRCYLNHZUVEYTUVQ
    CYLNWBWCUVEUWAYTUVEUWAKYLJEZUWAYTUVEUWBUWAYHUWBYGYHBFYRFJEZYHWDOWESSUVEUWAV
    NYLWFZWGPWHTWIWKSVRTWLWMWNWOWMPWMWPUVCYGUUTUVCYGKZYHYIUURUWEYHUVDUWEYHKZYIY
    KYLUGHZUURUWFXTBFYGUVJUVCYHUVKVMYHUVLUWEUVMWQUVSUWFWJOWRUWFUWGUURUWFUWGKZYT
    UUPUWHUWBUWAYTUWHBFYHYPUWEUWGYRVMUWCUWHWDOWEUVCYGYHUWGUWAUVCCYKNHZYGYHUWGUW
    AIIIYKWSUWIUWGYHYGUWAUWIUWGYHYGUWAIIYGYHUWIUWGKZUWAYGYHUWJUWAIZYGYHKZCREZYK
    REZYLREZUWKUWMUWLWTOYGUWNYHYGUVJUWNUVKXTXAMSYHUWOYGYHUVLUWOUVMBXAMWQCYKYLXB
    XCPWPPXDMXEUWDWGXFPTPWOPXGMWNPXHXDXIXJWNVRVEQVFQYJUUFYFYJUUFUVIGZYFYJUUAUVI
    YJUVIUUAYJUVJUVLUVSUHZUVIUUALYGYHUWQYIUWLUVJUVLUVSYGUVJYHUVKSYHUVLYGUVMWQUV
    SUWLWJOXNUMXTBFXKMXLUOYGYHYIUWPYFIYGYHYIUWPYFUWLYIUWPKZKYEYDUWLYEUWRYGUVJUV
    LYEUWRLYHUVKUVMXTBXMXOXPXQXRXITQXSVEQTTVEVR $.

  $( A value in a finite set of sequential integers is a border value if and
     only if it is not contained in the half-open integer range contained in
     the finite set of sequential integerss.  (Contributed by Alexander van der
     Vekens, 17-Jan-2018.) $)
  elfznelfzob $p |- ( y e. ( 0 ... K ) -> ( -. y e. ( 1 ..^ K )
                      <-> ( y = 0 \/ y = K ) ) ) $=
    ( cc0 co wcel c1 wn wceq ex wi wa cle wbr clt cz cr zre adantl a1i con2d cv
    cfz cfzo wo elfznelfzo elfzole1 elfzolt2 elfzoel2 elfzoelz breq1 mpbiri 1re
    0lt1 ltnled syl5ib wne ltlen syl2anr necom df-ne biimpi sylbi syl6bi impcom
    wb com23 imp jctird syl21anc mpd ioran sylibr impbid ) AUAZCBUBDEZVNFBUCDEZ
    GZVNCHZVNBHZUDZVOVQVTABUEIVOVPVTVPVTGZJVOVPVRGZVSGZKZWAVPFVNLMZWDVNFBUFVPVN
    BNMZBOEZVNOEZWEWDJVNFBUGVNFBUHVNFBUIWFWGKZWHKZWEWBWCWJVRWEVRVNFNMZWJWEGVRWK
    CFNMUMVNCFNUJUKWJVNFWHVNPEZWIVNQZRFPEWJULSUNUOTWIWHWCWGWFWHWCJWGWHWFWCWGWHW
    FWCJWGWHKWFVNBLMZBVNUPZKZWCWHWLBPEWFWPVEWGWMBQVNBUQURWOWCWNWOVNBUPZWCBVNUSW
    QWCVNBUTVAVBRVCIVFVDVGVHVIVJVRVSVKVLSTVM $.

  $( A Peano-postulate-like theorem for downward closure of a finite set of
     sequential integers.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
  peano2fzor $p |- ( ( K e. ( ZZ>= ` M ) /\ ( K + 1 ) e. ( M ..^ N ) ) ->
    K e. ( M ..^ N ) ) $=
    ( cuz cfv wcel c1 caddc co cfzo wa cmin cfz simpr cz elfzoel2 adantl fzoval
    wceq syl eleqtrd peano2fzr syldan eleqtrrd ) ABDEFZAGHIZBCJIZFZKZABCGLIZMIZ
    UGUEUHUFUKFAUKFUIUFUGUKUEUHNUICOFZUGUKSUHULUEUFBCPQBCRTZUAABUJUBUCUMUD $.

  $( Extending a half-open range by a singleton on the end.  (Contributed by
     Stefan O'Rear, 23-Aug-2015.) $)
  fzosplitsn $p |- ( B e. ( ZZ>= ` A ) ->
      ( A ..^ ( B + 1 ) ) = ( ( A ..^ B ) u. { B } ) ) $=
    ( cuz cfv wcel c1 caddc co cfzo cun csn cfz wceq eluzelz uzid peano2uz 3syl
    id cz syl elfzuzb sylanbrc fzosplit fzosn uneq2d eqtrd ) BACDEZABFGHZIHZABI
    HZBUHIHZJZUJBKZJUGBAUHLHEZUIULMUGUGUHBCDZEZUNUGRUGBSEZBUOEUPABNZBOBBPQBAUHU
    AUBAUHBUCTUGUKUMUJUGUQUKUMMURBUDTUEUF $.

  $( Membership in a half-open range extende by a singleton.  (Contributed by
     Stefan O'Rear, 23-Aug-2015.) $)
  fzosplitsni $p |- ( B e. ( ZZ>= ` A ) -> ( C e. ( A ..^ ( B + 1 ) ) <->
        ( C e. ( A ..^ B ) \/ C = B ) ) ) $=
    ( cuz cfv wcel c1 caddc co cfzo csn cun wceq fzosplitsn eleq2d elun elsnc2g
    wo orbi2d syl5bb bitrd ) BADEZFZCABGHIJIZFCABJIZBKZLZFZCUEFZCBMZRZUCUDUGCAB
    NOUHUICUFFZRUCUKCUEUFPUCULUJUICBUBQSTUA $.

  $( Two possibilities for a number one greater than a number in a half-open
     range.  (Contributed by Stefan O'Rear, 23-Aug-2015.) $)
  fzostep1 $p |- ( A e. ( B ..^ C ) -> ( ( A + 1 ) e. ( B ..^ C ) \/
          ( A + 1 ) = C ) ) $=
    ( cfzo co wcel c1 caddc wceq wo cz cuz cfv wss elfzoel1 peano2uz wbr cr zre
    uzid fzoss1 4syl 1z fzoaddel mpan2 sseldd wb cle elfzoel2 clt elfzolt3 ltle
    wi syl2an syl2anc mpd eluz2 syl3anbrc fzosplitsni syl mpbid ) ABCDEZFZAGHEZ
    BCGHEZDEZFZVDVBFVDCIJZVCBGHEZVEDEZVFVDVCBKFZBBLMZFVIVLFVJVFNABCOZBTBBPVIBVE
    UAUBVCGKFVDVJFUCABCGUDUEUFVCCVLFZVGVHUGVCVKCKFZBCUHQZVNVMABCUIZVCBCUJQZVPAB
    CUKVCVKVOVRVPUMZVMVQVKBRFCRFVSVOBSCSBCULUNUOUPBCUQURBCVDUSUTVA $.

  ${
    $d K x $.  $d M x y $.  $d N x y $.  $d ch x $.  $d ph y $.  $d ps x $.
    $d ta x $.  $d th x $.
    fzind2.1 $e |- ( x = M -> ( ph <-> ps ) ) $.
    fzind2.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    fzind2.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    fzind2.4 $e |- ( x = K -> ( ph <-> ta ) ) $.
    fzind2.5 $e |- ( N e. ( ZZ>= ` M ) -> ps ) $.
    fzind2.6 $e |- ( y e. ( M ..^ N ) -> ( ch -> th ) ) $.
    $( Induction on the integers from ` M ` to ` N ` inclusive.  The first four
       hypotheses give us the substitution instances we need; the last two are
       the basis and the induction hypothesis.  Version of ~ fzind using
       integer range definitions.  (Contributed by Mario Carneiro,
       6-Feb-2016.) $)
    fzind2 $p |- ( K e. ( M ... N ) -> ta ) $=
      ( wcel wa wbr w3a cfz co cz cle elfz2 df-3an anbi1i 3anass anbi2i 3bitr4i
      anass bitri cuz cfv eluz2 sylbir cv clt wi cfzo elfzo syl6bir 3coml 3expa
      impr sylan2b fzind sylbi ) HIJUAUBQZIUCQZJUCQZRZHUCQZIHUDSZHJUDSZTZRZEVIV
      JVKVMTZVNVORZRZVQHIJUEVLVMRZVSRVLVMVSRZRVTVQVLVMVSUKVRWAVSVJVKVMUFUGVPWBV
      LVMVNVOUHUIUJULABCDEFGHIJKLMNVJVKIJUDSTJIUMUNQBIJUOOUPGUQZUCQZIWCUDSZWCJU
      RSZTVLWDWEWFRZRCDUSZWDWEWFUHVLWDWGWHVJVKWDWGWHUSZWDVJVKWIWDVJVKTWGWCIJUTU
      BQWHWCIJVAPVBVCVDVEVFVGVH $.
  $}

  ${
    $d F f $.  $d K f $.  $d F z $.  $d K z $.  $d y z $.  $d x z $.
    $( Lemma for ~ injresinj .  (Contributed by Alexander van der Vekens,
       31-Oct-2017.) $)
    injresinjlem $p |- ( -. y e. ( 1 ..^ K ) -> ( ( F ` 0 ) =/= ( F ` K )
       -> ( ( F : ( 0 ... K ) --> V /\ K e. NN0 )
         -> ( ( ( F " { 0 , K } ) i^i ( F " ( 1 ..^ K ) ) ) = (/)
           -> ( ( x e. ( 0 ... K ) /\ y e. ( 0 ... K ) )
             -> ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) ) ) ) $=
      ( vz c1 wcel wn cc0 wa wceq cfv wi adantl notbid fveq2 eqcoms a1d com12
      vf cv cfzo co cfz wf cn0 cpr cima cin c0 wne weq wo elfznelfzo wfn adantr
      wral ffn cle wbr 0nn0 a1i nn0ge0 elfz2nn0 syl3anbrc nn0re fnimapr syl3anc
      id leidd ineq1d eqeq1d disj syl6bb cvv wb fvex pm3.2i eleq1 ralprg eleq1d
      mp1i biimpd wrex wss cuz 1nn0 elnn0uz mpbi fzoss1 fzossfz syl6ss fvelimab
      syl2an ralnex rspcva pm2.21 expcom com24 sylbir sylbid syl6com jaoi com13
      syl com14 com15 eqtr3 neeq12d df-ne pm2.24 sylbi syl6bi ex pm2.61i impcom
      ccase com23 com25 ) BUBZGDUCUDZHIZAUBZJDUEUDZHZYAYEHZKZYEECUFZDUGHZKZCJDU
      HUIZCYBUIZUJZUKLZJCMZDCMZULZYDCMZYACMZLZABUMZNZYHYCYKYOYRUUCNZNZNZYGYFYCU
      UFNYGYCYFUUFYGYCYFUUFNZYGYCKYAJLZYADLZUNZUUGBDUOYFUUJUUFYDYBHZYFUUJUUFNZN
      YOYFUUJYKUUKUUDYFYOUUJYKUUKUUDNZNNYKYOUUJYFUUMYKYOUAUBZYMHZIZUAYPYQUHZURZ
      UUJYFUUMNZNZYKYOUUQYMUJZUKLUURYKYNUVAUKYKYLUUQYMYKCYEUPZJYEHZDYEHZYLUUQLY
      IUVBYJYEECUSZUQYJUVCYIYJJUGHZYJJDUTVAUVCUVFYJVBVCYJVJZDVDJDVEVFOYJUVDYIYJ
      YJYJDDUTVAUVDUVGUVGYJDDVGVKDDVEVFOYEJDCVHVIVLVMUAUUQYMVNVOYKUURYPYMHZIZYQ
      YMHZIZKZUUTYPVPHZYQVPHZKUURUVLVQYKUVMUVNJCVRDCVRVSUUPUVIUVKUAYPYQVPVPUUNY
      PLUUOUVHUUNYPYMVTPUUNYQLUUOUVJUUNYQYMVTPWAWCUUJUVLYKUUSUUHUVLYKUUSNZNUUIU
      VLUUHUVOUVIUUHUVONUVKUUHUVIYTYMHZIZUVOUUHUVIUVQUUHUVHUVPUUHYPYTYMYPYTLZJY
      AJYACQRZWBPWDYKUVQUUSYKUVQFUBZCMZYTLZFYBWEZIZUUSYKUVPUWCYIUVBYBYEWFUVPUWC
      VQYJUVEYJYBJDUCUDZYEGJWGMHZYBUWEWFYJGUGHUWFWHGWIWJGJDWKWCJDWLWMFYEYBYTCWN
      WOPUWDYKUUSUWDUWBIZFYBURZUVOUWBFYBWPUWHUUKYFYKUUDUUKUWHYFYKUUDNZNZUUKUWHK
      UUAIZUWJUWGUWKFYDYBFAUMZUWBUUAUWLUWAYSYTUVTYDCQVMPWQUWKUWIYFUWKUUDYKUWKUU
      CYRUUAUUBWRZSSSXFWSWTXATXBTZXCUQTUVLUUIUVOUVKUUIUVONUVIUUIUVKUVQUVOUUIUVK
      UVQUUIUVJUVPUUIYQYTYMYQYTLZDYADYACQRZWBPWDUWNXCOTXDXEXBXBXGTXHYFUUKIZUULY
      FUWQKYDJLZYDDLZUNZUULADUOUWTUUJUUFUWRUUHUWSUUIUUFUWRUUHKUUBUUFYDYAJXIUUBU
      UEYKUUBUUDYOUUBUUCYRUUBUUBUUAUUBVJSSSSZXFUWSUUHKZUUEYKUXBUUDYOUXBYRYTYSUL
      ZUUCUXBYPYTYQYSUUHUVRUWSUVSOUWSYQYSLZUUHUXDDYDDYDCQRUQXJUXCYTYSLZIZUUCYTY
      SXKUUAUXFUUBUXFUUBNYTYSUXEUUBXLRTXMXNSSUWRUUIKZUUEYKUXGUUDYOUXGYRYSYTULZU
      UCUXGYPYSYQYTUWRYPYSLZUUIUXIJYDJYDCQRUQUUIUWOUWRUWPOXJUXHUWKUUCYSYTXKUWMX
      MXNSSUWSUUIKUUBUUFYDYADXIUXAXFXRXOXFWSXPTXFXOXSXQTXT $.
  $}

  ${
    $d F v w x y $.  $d K v w x y $.  $d V x y $.
    $( A function whose restriction is injective and the values of the
       remaining arguments are different from all other values is injective
       itself.  (Contributed by Alexander van der Vekens, 31-Oct-2017.) $)
    injresinj $p |- ( K e. NN0 -> ( ( F : ( 0 ... K ) --> V
                   /\ Fun `' ( F |` ( 1 ..^ K ) ) /\ ( F ` 0 ) =/= ( F ` K ) )
                      -> ( ( ( F " { 0 , K } ) i^i ( F " ( 1 ..^ K ) ) ) = (/)
                           -> Fun `' F ) ) ) $=
      ( vx vy vv vw cc0 co c1 cfv wcel wceq wi wa cv weq wral a1d ex cfz wf wne
      cfzo cres ccnv wfun w3a cn0 cpr cima cin c0 wf1 wss cuz cz cle 1z 0le1 0z
      wbr eluz1i mpbir2an fzoss1 ax-mp fzossfz sstri mpan2 biantrud ancom df-f1
      fssres bitr4i syl6bb simp-4r dff13 eqeq1d equequ1 imbi12d equequ2 rspc2va
      fveq2 eqeq2d fvres eqcomd eqeqan12d biimpd imim1d imp expcom syl wn ianor
      pm2.43a eqcom injresinjlem imp41 syl6ib syl5bi ancomsd exp41 jaoi pm2.61i
      sylbi ralrimivv adantl com13 com24 impcom biantrurd syl6bbr mpbird syl6bi
      wo sylanbrc 3imp com12 ) HBUAIZCAUBZAJBUDIZUEZUFUGZHAKBAKUCZUHBUILZAHBUJU
      KAYAUKULUMMZAUFUGZNZXTYCYDYEYHNZYCXTYDYINZXTYCYACYBUNZXTYJNXTYCYCYACYBUBZ
      OZYKXTYLYCXTYAXSUOYLYAHBUDIZXSJHUPKLZYAYNUOYOJUQLHJURVBUSUTHJVAVCVDJHBVEV
      FHBVGVHXSCYAAVMVIVJYMYLYCOYKYCYLVKYACYBVLVNVOYKXTYDYEYHYKXTOZYDOYEOZYFYGY
      QYFOZYGXSCAUNZYRXTDPZAKZEPZAKZMZDEQZNZEXSRDXSRZYSYKXTYDYEYFVPZYPYDYEYFUUG
      XTYKYDYEYFUUGNZNNXTYEYDYKUUIXTYEYDYKUUINNYKYDXTYEOZUUIYKYLFPZYBKZGPZYBKZM
      ZFGQZNZGYARFYARZOYDUUJUUINNZFGYACYBVQUURUUSYLUURYDUUJYFUUGUURYDOUUJOYFOUU
      FDEXSXSUURYDUUJYFYTXSLZUUBXSLZOZUUFNZYTYALZUUBYALZOZUURYDUUJYFUVCNZNZNZNZ
      UURUVFUVIUVFUURUVFUVINZUVFUUROYTYBKZUUBYBKZMZUUENZUVKUUQUVOUVLUUNMZDGQZNF
      GYTUUBYAYAFDQZUUOUVPUUPUVQUVRUULUVLUUNUUKYTYBWCVRFDGVSVTGEQZUVPUVNUVQUUEU
      VSUUNUVMUVLUUMUUBYBWCWDGEDWAVTWBUVFUVOUVIUVFUVOOZUVHYDUVTUVGUUJUVTUVCYFUV
      TUUFUVBUVFUVOUUFUVFUUDUVNUUEUVFUUDUVNUVDUVEUUAUVLUUCUVMUVDUVLUUAYTYAAWEWF
      UVEUVMUUCUUBYAAWEWFWGWHWIWJSSSSWKWLTWOUVFWMUVDWMZUVEWMZXOZUVJUVDUVEWNUWCU
      VIUURUWAUVIUWBUWAYDUUJYFUVCUWAYDOZUUJOYFOZUVAUUTUUFUWEUVAUUTOZUUFUUDUUCUU
      AMZUWEUWFOZUUEUUAUUCWPUWHUWGEDQZUUEUWDUUJYFUWFUWGUWINZUWAYDUUJYFUWFUWJNNN
      EDABCWQWJWRUUBYTWPWSWTTXAXBDEABCWQXCSXEXDWRXFXBXGXEXHTXIXJWRDEXSCAVQXPYRY
      GXTYGOYSYRXTYGUUHXKXSCAVLXLXMTXBXNWOXQXR $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
        Elementary integer functions
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The floor (greatest integer) function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c |_ $.  $( Floor function. $)

  $( Extend class notation with floor (greatest integer) function. $)
  cfl $a class |_ $.

  ${
    $d x y $.
    $( Define the floor (greatest integer) function.  See ~ flval for its
       value, ~ fllelt for its basic property, and ~ flcl for its closure.  For
       example, ` ( |_ `` ( 3 / 2 ) ) = 1 ` while
       ` ( |_ `` -u ( 3 / 2 ) ) = -u 2 ` ( ~ ex-fl ).

       The term "floor" was coined by Ken Iverson.  He also invented a
       mathematical notation for floor, consisting of an L-shaped left bracket
       and its reflection as a right bracket.  In APL, the left-bracket alone
       is used, and we borrow this idea.  (Thanks to Paul Chapman for this
       information.)  (Contributed by NM, 14-Nov-2004.) $)
    df-fl $a |- |_ = ( x e. RR |->
                ( iota_ y e. ZZ ( y <_ x /\ x < ( y + 1 ) ) ) ) $.
  $}

  ${
    $d x y A $.
    $( Value of the floor (greatest integer) function.  The floor of ` A ` is
       the (unique) integer less than or equal to ` A ` whose successor is
       strictly greater than ` A ` .  (Contributed by NM, 14-Nov-2004.)
       (Revised by Mario Carneiro, 2-Nov-2013.) $)
    flval $p |- ( A e. RR ->
              ( |_ ` A ) = ( iota_ x e. ZZ ( x <_ A /\ A < ( x + 1 ) ) ) ) $=
      ( vy cv cle wbr c1 caddc co clt wa cz crio cfl wceq breq2 breq1 riotabidv
      cr anbi12d df-fl riotaex fvmpt ) CBADZCDZEFZUEUDGHIZJFZKZALMUDBEFZBUGJFZK
      ZALMSNUEBOZUIULALUMUFUJUHUKUEBUDEPUEBUGJQTRCAUAULALUBUC $.

    $( The floor (greatest integer) function is an integer (closure law).
       (Contributed by NM, 15-Nov-2004.)  (Revised by Mario Carneiro,
       2-Nov-2013.) $)
    flcl $p |- ( A e. RR -> ( |_ ` A ) e. ZZ ) $=
      ( vx cr wcel cfl cfv cv cle wbr c1 caddc co wa cz crio flval wreu rebtwnz
      clt riotacl syl eqeltrd ) ACDZAEFBGZAHIAUDJKLSIMZBNOZNBAPUCUEBNQUFNDBARUE
      BNTUAUB $.

    $( The floor (greatest integer) function is real.  (Contributed by NM,
       15-Jul-2008.) $)
    reflcl $p |- ( A e. RR -> ( |_ ` A ) e. RR ) $=
      ( cr wcel cfl cfv flcl zred ) ABCADEAFG $.

    $( A basic property of the floor (greatest integer) function.  (Contributed
       by NM, 15-Nov-2004.)  (Revised by Mario Carneiro, 2-Nov-2013.) $)
    fllelt $p |- ( A e. RR ->
                  ( ( |_ ` A ) <_ A /\ A < ( ( |_ ` A ) + 1 ) ) ) $=
      ( vx cr wcel cfl cfv cle wbr c1 caddc co clt wa cv crio wceq flval eqcomd
      cz wreu wb flcl rebtwnz breq1 oveq1 breq2d anbi12d riota2 syl2anc mpbird
      ) ACDZAEFZAGHZAULIJKZLHZMZBNZAGHZAUQIJKZLHZMZBSOZULPZUKULVBBAQRUKULSDVABS
      TUPVCUAAUBBAUCVAUPBSULUQULPZURUMUTUOUQULAGUDVDUSUNALUQULIJUEUFUGUHUIUJ $.
  $}

  ${
    flcld.1 $e |- ( ph -> A e. RR ) $.
    $( The floor (greatest integer) function is an integer (closure law).
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    flcld $p |- ( ph -> ( |_ ` A ) e. ZZ ) $=
      ( cr wcel cfl cfv cz flcl syl ) ABDEBFGHECBIJ $.
  $}

  $( A basic property of the floor (greatest integer) function.  (Contributed
     by NM, 24-Feb-2005.) $)
  flle $p |- ( A e. RR -> ( |_ ` A ) <_ A ) $=
    ( cr wcel cfl cfv cle wbr c1 caddc co clt fllelt simpld ) ABCADEZAFGANHIJKG
    ALM $.

  $( A basic property of the floor (greatest integer) function.  (Contributed
     by NM, 24-Feb-2005.) $)
  flltp1 $p |- ( A e. RR -> A < ( ( |_ ` A ) + 1 ) ) $=
    ( cr wcel cfl cfv cle wbr c1 caddc co clt fllelt simprd ) ABCADEZAFGANHIJKG
    ALM $.

  $( A basic property of the floor (greatest integer) function.  (Contributed
     by Mario Carneiro, 21-May-2016.) $)
  fllep1 $p |- ( A e. RR -> A <_ ( ( |_ ` A ) + 1 ) ) $=
    ( cr wcel cfl cfv c1 caddc co clt wbr cle flltp1 reflcl peano2re ltle mpdan
    wi syl mpd ) ABCZAADEZFGHZIJZAUBKJZALTUBBCZUCUDQTUABCUEAMUANRAUBOPS $.

  $( The fractional part of a real number is less than one.  (Contributed by
     NM, 15-Jul-2008.) $)
  fraclt1 $p |- ( A e. RR -> ( A - ( |_ ` A ) ) < 1 ) $=
    ( cr wcel cfl cfv co c1 clt wbr caddc flltp1 wb reflcl 1re ltsubadd2 mp3an3
    cmin mpdan mpbird ) ABCZAADEZQFGHIZAUAGJFHIZAKTUABCZUBUCLZAMTUDGBCUENAUAGOP
    RS $.

  $( The fractional part of a real number is less than or equal to one.
     (Contributed by Mario Carneiro, 21-May-2016.) $)
  fracle1 $p |- ( A e. RR -> ( A - ( |_ ` A ) ) <_ 1 ) $=
    ( cr wcel cfl cfv cmin co c1 clt wbr cle fraclt1 wi reflcl resubcl 1re ltle
    mpdan sylancl mpd ) ABCZAADEZFGZHIJZUCHKJZALUAUCBCZHBCUDUEMUAUBBCUFANAUBORP
    UCHQST $.

  $( The fractional part of a real number is nonnegative.  (Contributed by NM,
     17-Jul-2008.) $)
  fracge0 $p |- ( A e. RR -> 0 <_ ( A - ( |_ ` A ) ) ) $=
    ( cr wcel cc0 cfl cfv cmin co cle wbr flle wb reflcl subge0 mpdan mpbird )
    ABCZDAAEFZGHIJZRAIJZAKQRBCSTLAMARNOP $.

  $( The floor function value is the greatest integer less than or equal to its
     argument.  (Contributed by NM, 15-Nov-2004.)  (Proof shortened by Fan
     Zheng, 14-Jul-2016.) $)
  flge $p |- ( ( A e. RR /\ B e. ZZ ) -> ( B <_ A <-> B <_ ( |_ ` A ) ) ) $=
    ( cr wcel cz wa cle wbr cfl cfv c1 caddc co flltp1 adantr wi syl3anc mpan2d
    clt zred simpr simpl peano2zd lelttr wb zleltp1 syl2anc sylibrd flle impbid
    flcld letr ) ACDZBEDZFZBAGHZBAIJZGHZUOUPBUQKLMZSHZURUOUPAUSSHZUTUMVAUNANOUO
    BCDZUMUSCDUPVAFUTPUOBUMUNUAZTZUMUNUBZUOUSUOUQUOAVEUKZUCTBAUSUDQRUOUNUQEDURU
    TUEVCVFBUQUFUGUHUOURUQAGHZUPUMVGUNAUIOUOVBUQCDUMURVGFUPPVDUOUQVFTVEBUQAULQR
    UJ $.

  $( The floor function value is less than the next integer.  (Contributed by
     NM, 24-Feb-2005.) $)
  fllt $p |- ( ( A e. RR /\ B e. ZZ ) -> ( A < B <-> ( |_ ` A ) < B ) ) $=
    ( cr wcel cz wa clt wbr cfl cfv cle wn flge zre lenlt ancoms reflcl syl2anr
    wb sylan 3bitr3d con4bid ) ACDZBEDZFZABGHZAIJZBGHZUEBAKHZBUGKHZUFLZUHLZABMU
    DUCUIUKSZUDBCDZUCUMBNZBAOTPUDUNUGCDUJULSUCUOAQBUGORUAUB $.

  $( An integer is its own floor.  (Contributed by NM, 15-Nov-2004.) $)
  flid $p |- ( A e. ZZ -> ( |_ ` A ) = A ) $=
    ( cz wcel cfl cfv wceq cle wbr cr zre flle syl leidd wb flge mpancom reflcl
    mpbid letri3d mpbir2and ) ABCZADEZAFUBAGHZAUBGHZUAAICZUCAJZAKLUAAAGHZUDUAAU
    FMUEUAUGUDNUFAAOPRUAUBAUAUEUBICUFAQLUFST $.

  $( The floor function is idempotent.  (Contributed by NM, 17-Aug-2008.) $)
  flidm $p |- ( A e. RR -> ( |_ ` ( |_ ` A ) ) = ( |_ ` A ) ) $=
    ( cr wcel cfl cfv cz wceq flcl flid syl ) ABCADEZFCKDEKGAHKIJ $.

  $( A real number equals its floor iff it is an integer.  (Contributed by NM,
     11-Nov-2008.) $)
  flidz $p |- ( A e. RR -> ( ( |_ ` A ) = A <-> A e. ZZ ) ) $=
    ( cr wcel cfl cfv wceq cz flcl eleq1 syl5ibcom flid impbid1 ) ABCZADEZAFZAG
    CZMNGCOPAHNAGIJAKL $.

  $( Ordering relationship for the greatest integer function.  (Contributed by
     NM, 31-Dec-2005.)  (Proof shortened by Fan Zheng, 14-Jul-2016.) $)
  flwordi $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                 ( |_ ` A ) <_ ( |_ ` B ) ) $=
    ( cr wcel cle wbr w3a cfl cfv simp1 flcld zred simp2 flle simp3 letrd cz wb
    syl flge syl2anc mpbid ) ACDZBCDZABEFZGZAHIZBEFZUGBHIEFZUFUGABUFUGUFAUCUDUE
    JZKZLUJUCUDUEMZUFUCUGAEFUJANSUCUDUEOPUFUDUGQDUHUIRULUKBUGTUAUB $.

  $( Ordering relationship for the greatest integer function.  (Contributed by
     Mario Carneiro, 7-Jun-2016.) $)
  flword2 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                 ( |_ ` B ) e. ( ZZ>= ` ( |_ ` A ) ) ) $=
    ( cr wcel cle wbr w3a cfl cfv cuz simp1 flcld simp2 flwordi eluz2 syl3anbrc
    cz ) ACDZBCDZABEFZGZAHIZQDBHIZQDUBUCEFUCUBJIDUAARSTKLUABRSTMLABNUBUCOP $.

  ${
    $d x y z w A $.  $d x y B $.
    $( An alternate way to define the floor (greatest integer) function.
       (Contributed by NM, 16-Nov-2004.) $)
    flval2 $p |- ( A e. RR -> ( |_ ` A ) =
           ( iota_ x e. ZZ ( x <_ A /\ A. y e. ZZ ( y <_ A -> y <_ x ) ) ) ) $=
      ( cr wcel cv cle wbr wi wral crio cfl cfv wceq flle flge biimpd ralrimiva
      cz wa wreu wb flcl zmax breq1 breq2 imbi2d ralbidv anbi12d riota2 syl2anc
      mpbi2and eqcomd ) CDEZAFZCGHZBFZCGHZUQUOGHZIZBSJZTZASKZCLMZUNVDCGHZURUQVD
      GHZIZBSJZVCVDNZCOUNVGBSUNUQSETURVFCUQPQRUNVDSEVBASUAVEVHTZVIUBCUCABCUDVBV
      JASVDUOVDNZUPVEVAVHUOVDCGUEVKUTVGBSVKUSVFURUOVDUQGUFUGUHUIUJUKULUM $.

    $( An alternate way to define the floor (greatest integer) function, as the
       supremum of all integers less than or equal to its argument.
       (Contributed by NM, 15-Nov-2004.)  (Proof shortened by Mario Carneiro,
       6-Sep-2014.) $)
    flval3 $p |- ( A e. RR ->
                  ( |_ ` A ) = sup ( { x e. ZZ | x <_ A } , RR , < ) ) $=
      ( vz vy cr wcel cfl cfv cv cle wbr cz crab wceq wral breq1 elrab syl31anc
      clt wa csup wss c0 wne wrex ssrab2 zssre sstri a1i flcl flle sylanbrc syl
      reflcl biimpd expimpd syl5bi ralrimiv breq2 ralbidv rspcev syl2anc suprub
      ne0i flge wb suprleub mpbird suprcl syl3anc letri3d mpbir2and ) BEFZBGHZA
      IZBJKZALMZESUAZNVNVRJKZVRVNJKZVMVQEUBZVQUCUDZCIZDIZJKZCVQOZDEUEZVNVQFZVSW
      AVMVQLEVPALUFUGUHUIZVMWHWBVMVNLFVNBJKZWHBUJBUKVPWJAVNLVOVNBJPQULZVQVNVDUM
      ZVMVNEFZWCVNJKZCVQOZWGBUNZVMWNCVQWCVQFWCLFZWCBJKZTVMWNVPWRAWCLVOWCBJPQVMW
      QWRWNVMWQTWRWNBWCVEUOUPUQURZWFWODVNEWDVNNWEWNCVQWDVNWCJUSUTVAVBZWKDCVQVNV
      CRVMVTWOWSVMWAWBWGWMVTWOVFWIWLWTWPDCCVQVNVGRVHVMVNVRWPVMWAWBWGVREFWIWLWTD
      CVQVIVJVKVL $.

    $( A condition equivalent to floor.  (Contributed by NM, 11-Mar-2005.)
       (Revised by Mario Carneiro, 2-Nov-2013.) $)
    flbi $p |- ( ( A e. RR /\ B e. ZZ ) ->
                ( ( |_ ` A ) = B <-> ( B <_ A /\ A < ( B + 1 ) ) ) ) $=
      ( vx cr wcel cz wa cfl cfv wceq cv cle wbr c1 caddc co clt crio wb flval
      eqeq1d adantr wreu rebtwnz breq1 oveq1 breq2d riota2 sylan2 ancoms bitr4d
      anbi12d ) ADEZBFEZGAHIZBJZCKZALMZAUQNOPZQMZGZCFRZBJZBALMZABNOPZQMZGZUMUPV
      CSUNUMUOVBBCATUAUBUNUMVGVCSZUMUNVACFUCVHCAUDVAVGCFBUQBJZURVDUTVFUQBALUEVI
      USVEAQUQBNOUFUGULUHUIUJUK $.
  $}

  $( A condition equivalent to floor.  (Contributed by NM, 15-Aug-2008.) $)
  flbi2 $p |- ( ( N e. ZZ /\ F e. RR ) ->
              ( ( |_ ` ( N + F ) ) = N <-> ( 0 <_ F /\ F < 1 ) ) ) $=
    ( cz wcel cr wa caddc co cfl cfv wceq cle wbr c1 clt cc0 zre readdcl sylan
    wb simpl flbi syl2anc addge01 1re ltadd2 mp3an2 ancoms anbi12d bitr4d ) BCD
    ZAEDZFZBAGHZIJBKZBUNLMZUNBNGHOMZFZPALMZANOMZFZUMUNEDZUKUOURTUKBEDZULVBBQZBA
    RSUKULUAUNBUBUCUKVCULVAURTVDVCULFUSUPUTUQBAUDULVCUTUQTZULNEDVCVEUEANBUFUGUH
    UISUJ $.

  $( The floor of a number greater than or equal to 0 is a nonnegative
     integer.  (Contributed by NM, 26-Apr-2005.) $)
  flge0nn0 $p |- ( ( A e. RR /\ 0 <_ A ) -> ( |_ ` A ) e. NN0 ) $=
    ( cr wcel cc0 cle wbr wa cfl cfv cz cn0 flcl adantr wb 0z flge mpan2 biimpa
    elnn0z sylanbrc ) ABCZDAEFZGAHIZJCZDUCEFZUCKCUAUDUBALMUAUBUEUADJCUBUENOADPQ
    RUCST $.

  $( The floor of a number greater than or equal to 1 is a natural number.
     (Contributed by NM, 26-Apr-2005.) $)
  flge1nn $p |- ( ( A e. RR /\ 1 <_ A ) -> ( |_ ` A ) e. NN ) $=
    ( cr wcel c1 cle wbr wa cfl cfv cz cn flcl adantr wb 1z mpan2 biimpa elnnz1
    flge sylanbrc ) ABCZDAEFZGAHIZJCZDUCEFZUCKCUAUDUBALMUAUBUEUADJCUBUENOADSPQU
    CRT $.

  $( An integer can be moved in and out of the floor of a sum.  (Contributed by
     NM, 27-Apr-2005.)  (Proof shortened by Fan Zheng, 16-Jun-2016.) $)
  fladdz $p |- ( ( A e. RR /\ N e. ZZ ) -> ( |_ ` ( A + N ) ) =
                ( ( |_ ` A ) + N ) ) $=
    ( cr wcel cz wa caddc co cfl cfv wceq cle wbr c1 clt reflcl adantr readdcld
    a1i recnd simpl simpr zred flle leadd1dd 1re flltp1 ltadd1dd ax-1cn breqtrd
    cc add32d wb flcld zaddcld flbi syl2anc mpbir2and ) ACDZBEDZFZABGHZIJAIJZBG
    HZKZVDVBLMZVBVDNGHZOMZVAVCABUSVCCDUTAPQZUSUTUAZVABUSUTUBZUCZUSVCALMUTAUDQUE
    VAVBVCNGHZBGHVGOVAAVMBVJVAVCNVINCDVAUFSRVLUSAVMOMUTAUGQUHVAVCNBVAVCVITNUKDV
    AUISVABVLTULUJVAVBCDVDEDVEVFVHFUMVAABVJVLRVAVCBVAAVJUNVKUOVBVDUPUQUR $.

  $( An integer can be moved in and out of the floor of a sum.  (Contributed by
     NM, 2-Jan-2009.) $)
  flzadd $p |- ( ( N e. ZZ /\ A e. RR ) -> ( |_ ` ( N + A ) ) =
                ( N + ( |_ ` A ) ) ) $=
    ( cr wcel cz caddc co cfl cfv wceq wa fladdz cc addcom syl2an fveq2d reflcl
    recn zcn recnd 3eqtr3d ancoms ) ACDZBEDZBAFGZHIZBAHIZFGZJUCUDKZABFGZHIUGBFG
    ZUFUHABLUIUJUEHUCAMDBMDZUJUEJUDARBSZABNOPUCUGMDULUKUHJUDUCUGAQTUMUGBNOUAUB
    $.

  $( Move a nonnegative integer in and out of a floor.  (Contributed by NM,
     2-Jan-2009.)  (Proof shortened by Fan Zheng, 7-Jun-2016.) $)
  flmulnn0 $p |- ( ( N e. NN0 /\ A e. RR )
              -> ( N x. ( |_ ` A ) ) <_ ( |_ ` ( N x. A ) ) ) $=
    ( cn0 wcel cr wa cfl cfv cmul co cle wbr reflcl adantl simpr nn0red nn0ge0d
    simpl flle cz lemul2ad remulcld nn0z flcl zmulcl syl2an flge syl2anc mpbid
    wb ) BCDZAEDZFZBAGHZIJZBAIJZKLZUOUPGHKLZUMUNABULUNEDUKAMNUKULOZUMBUKULRZPZU
    MBUTQULUNAKLUKASNUAUMUPEDUOTDZUQURUJUMBAVAUSUBUKBTDUNTDVBULBUCAUDBUNUEUFUPU
    OUGUHUI $.

  $( A real bounded between an integer and its successor is nonnegative iff the
     integer is nonnegative.  Second half of Lemma 13-4.1 of [Gleason] p. 217.
     (For the first half see ~ rebtwnz .)  (Contributed by NM, 12-Mar-2005.) $)
  btwnzge0 $p |- ( ( ( A e. RR /\ N e. ZZ ) /\ ( N <_ A /\ A < ( N + 1 ) ) )
                -> ( 0 <_ A <-> 0 <_ N ) ) $=
    ( cr wcel cz wa cle wbr c1 caddc co clt cc0 cfl cfv wb flge mpan2 ad2antrr
    0z wceq flbi biimpar breq2d bitrd ) ACDZBEDZFZBAGHABIJKLHFZFZMAGHZMANOZGHZM
    BGHUFUKUMPZUGUIUFMEDUNTAMQRSUJULBMGUHULBUAUIABUBUCUDUE $.

  $( Ordering relation for the floor of half of an integer.  (Contributed by
     NM, 1-Jan-2006.)  (Proof shortened by Mario Carneiro, 7-Jun-2016.) $)
  flhalf $p |- ( N e. ZZ -> N <_ ( 2 x. ( |_ ` ( ( N + 1 ) / 2 ) ) ) ) $=
    ( cz wcel c2 c1 caddc co cdiv cfl cfv cle wbr clt cr syl a1i readdcld recnd
    cmul mpbird zre peano2re rehalfcld flltp1 flcld 1re crp 2rp ltdivmuld mpbid
    zred 2timesd oveq2d 2cn adddid 2re remulcld addassd 3eqtr4d breqtrd ltadd1d
    cc wb 2z zmulcld zleltp1 mpdan ) ABCZADAEFGZDHGZIJZSGZKLZAVLEFGZMLZVHVOVIVN
    EFGZMLVHVIDVKEFGZSGZVPMVHVJVQMLZVIVRMLVHVJNCVSVHVIVHANCVINCAUAZAUBOZUCZVJUD
    OVHVIVQDWAVHVKEVHVKVHVJWBUEZUKZENCVHUFPZQDUGCVHUHPUIUJVHVLDESGZFGVLEEFGZFGV
    RVPVHWFWGVLFVHEVHEWERZULUMVHDVKEDVBCVHUNPVHVKWDRWHUOVHVLEEVHVLVHDVKDNCVHUPP
    WDUQZRWHWHURUSUTVHAVNEVTVHVLEWIWEQWEVATVHVLBCVMVOVCVHDVKDBCVHVDPWCVEAVLVFVG
    T $.

  $( The ceiling function returns an integer (closure law).  (Contributed by
     Jeffrey Hankins, 10-Jun-2007.) $)
  ceicl $p |- ( A e. RR -> -u ( |_ ` -u A ) e. ZZ ) $=
    ( cr wcel cneg cfl cfv renegcl flcld znegcld ) ABCZADZEFJKAGHI $.

  $( The ceiling of a real number is greater than or equal to that number.
     (Contributed by Jeffrey Hankins, 10-Jun-2007.) $)
  ceige $p |- ( A e. RR -> A <_ -u ( |_ ` -u A ) ) $=
    ( wcel cneg cfl cfv cle wbr renegcl reflcl syl flle adantr lenegcon2 mpbird
    cr wa mpdan ) AOBZACZDEZOBZATCFGZRSOBZUAAHZSIJRUAPUBTSFGZRUEUARUCUEUDSKJLAT
    MNQ $.

  $( One less than the ceiling of a real number is strictly less than that
     number.  (Contributed by Jeffrey Hankins, 10-Jun-2007.) $)
  ceim1l $p |- ( A e. RR -> ( -u ( |_ ` -u A ) - 1 ) < A ) $=
    ( cr wcel cneg cfl cfv c1 cmin co caddc cc wceq renegcl reflcl recnd ax-1cn
    clt syl sylancl wbr negdi negcld negsub eqtr2d peano2re wa flltp1 ltnegcon1
    adantr mpbid mpdan eqbrtrd ) ABCZADZEFZDZGHIZUOGJIZDZAQUMUSUPGDJIZUQUMUOKCG
    KCZUSUTLUMUOUMUNBCZUOBCZAMZUNNRZOZPUOGUASUMUPKCVAUTUQLUMUOVFUBPUPGUCSUDUMUR
    BCZUSAQTZUMVCVGVEUOUERUMVGUFUNURQTZVHUMVIVGUMVBVIVDUNUGRUIAURUHUJUKUL $.

  $( The ceiling of a real number is the smallest integer greater than or equal
     to it.  (Contributed by Jeffrey Hankins, 10-Jun-2007.) $)
  ceile $p |- ( ( A e. RR /\ B e. ZZ /\ A <_ B ) -> -u ( |_ ` -u A ) <_ B ) $=
    ( cr wcel cz cle wbr cneg cfl cfv wa c1 cmin co clt ceim1l adantr ceicl zre
    wi peano2rem 3syl simpl adantl ltletr syl3anc mpand wb zlem1lt sylan 3impia
    sylibrd ) ACDZBEDZABFGZAHIJHZBFGZUMUNKZUOUPLMNZBOGZUQURUSAOGZUOUTUMVAUNAPQU
    RUSCDZUMBCDZVAUOKUTTUMVBUNUMUPEDZUPCDVBARZUPSUPUAUBQUMUNUCUNVCUMBSUDUSABUEU
    FUGUMVDUNUQUTUHVEUPBUIUJULUK $.

  ${
    quorem.1 $e |- Q = ( |_ ` ( A / B ) ) $.
    quorem.2 $e |- R = ( A - ( B x. Q ) ) $.
    $( Quotient and remainder of an integer divided by a natural number.  TO DO
       - is this really needed for anything?  Should we use ` mod ` to simplify
       it?  (Contributed by NM, 14-Aug-2008.) $)
    quoremz $p |- ( ( A e. ZZ /\ B e. NN ) -> ( ( Q e. ZZ /\ R e. NN0 )
          /\ ( R < B /\ A = ( ( B x. Q ) + R ) ) ) ) $=
      ( cz wcel wa cn0 clt wbr co caddc cdiv cr adantl cmin cle c1 cn cmul wceq
      cfl cfv zre adantr nnre cc0 wne nnne0 redivcld flcld syl5eqel cc divcan3d
      zcnd nncn flle syl syl5eqbr eqbrtrd wb nnz zmulcld nngt0 lediv1 syl112anc
      zred mpbird simpl znn0sub syl2anc oveq2i fraclt1 oveq1i zcn jca divsubdir
      mpbid syl3anc oveq2d syl5eq dividd 3brtr4d nn0red ltdiv1 pncan3d syl5req
      eqtrd jca31 ) AGHZBUAHZIZCGHDJHDBKLZABCUBMZDNMZUCZIWNCABOMZUDUEZGEWNWSWNA
      BWLAPHZWMAUFUGZWMBPHZWLBUHQZWMBUIUJZWLBUKZQZULZUMUNZWNDAWPRMZJFWNWPASLZXJ
      JHZWNXKWPBOMZWSSLZWNXMCWSSWNCBWNCXIUQWMBUOHZWLBURZQXGUPZWNCWTWSSEWNWSPHZW
      TWSSLXHWSUSUTVAVBWNWPPHXAXCUIBKLZXKXNVCWNWPWNBCWMBGHWLBVDQXIVEZVIXBXDWMXS
      WLBVFQZWPABVGVHVJWNWPGHWLXKXLVCXTWLWMVKWPAVLVMVTUNZWNWOWRWNWODBOMZBBOMZKL
      ZWNWSCRMZTYCYDKWNYFWSWTRMZTKCWTWSREVNWNXRYGTKLXHWSVOUTVAWNYCXJBOMZYFDXJBO
      FVPWNYHWSXMRMZYFWNAUOHZWPUOHXOXEIZYHYIUCWLYJWMAVQUGZWNWPXTUQZWMYKWLWMXOXE
      XPXFVRQAWPBVSWAWNXMCWSRXQWBWJWCWMYDTUCWLWMBXPXFWDQWEWNDPHXCXCXSWOYEVCWNDY
      BWFXDXDYADBBWGVHVJWNWQWPXJNMADXJWPNFVNWNWPAYMYLWHWIVRWK $.

    $( Quotient and remainder of a nonnegative integer divided by a natural
       number.  (Contributed by NM, 14-Aug-2008.) $)
    quoremnn0 $p |- ( ( A e. NN0 /\ B e. NN ) -> ( ( Q e. NN0 /\ R e. NN0 )
          /\ ( R < B /\ A = ( ( B x. Q ) + R ) ) ) ) $=
      ( cn0 wcel wa cz clt wbr co cr cc0 cle adantl jca syl2anc anim1i cn caddc
      cmul wceq cdiv cfl cfv nn0re adantr nnre wne nnne0 redivcld nn0ge0 divge0
      nngt0 syl2an flge0nn0 syl5eqel nn0z quoremz sylan simpl anasss ) AGHZBUAH
      ZIZCGHZCJHZDGHZIZDBKLABCUCMDUBMUDIZIZVHVJIZVLIZVGCABUEMZUFUGZGEVGVPNHOVPP
      LZVQGHVGABVEANHZVFAUHZUIVFBNHZVEBUJZQVFBOUKVEBULQUMVEVSOAPLZIWAOBKLZIVRVF
      VEVSWCVTAUNRVFWAWDWBBUPRABUOUQVPURSUSVEAJHVFVMAUTABCDEFVAVBVHVKVLVOVHVKIV
      NVLVHVIVJVNVHVIIVHVJVHVIVCTVDTVDS $.

    $( TODO - keep either quoremnn0ALT or quoremnn0 (if we don't
       keep quoremz $)
    $( Quotient and remainder of a nonnegative integer divided by a natural
       number.  TO DO - Keep either ~ quoremnn0ALT ((if we don't keep
       ~ quoremz ) or ~ quoremnn0 (Contributed by NM, 14-Aug-2008.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    quoremnn0ALT $p |- ( ( A e. NN0 /\ B e. NN ) -> ( ( Q e. NN0 /\ R e. NN0 )
          /\ ( R < B /\ A = ( ( B x. Q ) + R ) ) ) ) $=
      ( cn0 wcel wa clt wbr co wceq cdiv cr cc0 cle adantl cmin syl cn cmul cfl
      caddc cfv wne nn0re adantr nnre nnne0 redivcl syl3anc nn0ge0 nngt0 divge0
      jca syl2an flge0nn0 syl2anc syl5eqel nnnn0 nn0mulcl simpl cc nncn divcan3
      nn0cn flle syl5eqbr eqbrtrd wb lediv1 syl112anc mpbird nn0sub2 c1 fraclt1
      oveq2i oveq1i divsubdir oveq2d eqtrd syl5eq 3brtr4d ltdiv1 pncan3 syl5req
      divid jca31 ) AGHZBUAHZIZCGHZDGHZDBJKZABCUBLZDUDLZMZIWLCABNLZUCUEZGEWLWSO
      HZPWSQKZWTGHWLAOHZBOHZBPUFZXAWJXCWKAUGZUHZWKXDWJBUIZRZWKXEWJBUJZRZABUKULZ
      WJXCPAQKZIXDPBJKZIXBWKWJXCXMXFAUMUPWKXDXNXHBUNZUPABUOUQWSURUSUTZWLDAWPSLZ
      GFWLWPGHZWJWPAQKZXQGHWLBGHZWMXRWKXTWJBVARXPBCVBUSZWJWKVCWLXSWPBNLZWSQKZWL
      YBCWSQWLCVDHZBVDHZXEYBCMWLWMYDXPCVGTWKYEWJBVEZRXKCBVFULZWLCWTWSQEWLXAWTWS
      QKXLWSVHTVIVJWLWPOHZXCXDXNXSYCVKWLXRYHYAWPUGTXGXIWKXNWJXORZWPABVLVMVNWPAV
      OULUTZWLWOWRWLWODBNLZBBNLZJKZWLWSCSLZVPYKYLJWLYNWSWTSLZVPJCWTWSSEVRWLXAYO
      VPJKXLWSVQTVIWLYKXQBNLZYNDXQBNFVSWLYPWSYBSLZYNWLAVDHZWPVDHZYEXEIZYPYQMWJY
      RWKAVGUHZWLXRYSYAWPVGTZWKYTWJWKYEXEYFXJUPRAWPBVTULWLYBCWSSYGWAWBWCWKYLVPM
      ZWJWKYEXEUUCYFXJBWHUSRWDWLDOHZXDXDXNWOYMVKWLWNUUDYJDUGTXIXIYIDBBWEVMVNWLW
      QWPXQUDLZADXQWPUDFVRWLYSYRUUEAMUUBUUAWPAWFUSWGUPWI $.
  $}

  ${
    intfrac2.1 $e |- Z = ( |_ ` A ) $.
    intfrac2.2 $e |- F = ( A - Z ) $.
    $( Decompose a real into integer and fractional parts.  TODO - should we
       replace this with ~ intfrac ?  (Contributed by NM, 16-Aug-2008.) $)
    intfrac2 $p |- ( A e. RR -> ( 0 <_ F /\ F < 1 /\ A = ( Z + F ) ) ) $=
      ( cr wcel cc0 cle wbr c1 clt caddc co wceq cfl cfv cmin fracge0 oveq2i cz
      eqtri syl6breqr fraclt1 syl5eqbr flcl syl5eqel zcnd recn pncan3d syl5req
      3jca ) AFGZHBIJBKLJACBMNZOUMHAAPQZRNZBIASBACRNZUPECUOARDTUBZUCUMBUPKLURAU
      DUEUMUNCUQMNABUQCMETUMCAUMCUMCUOUADAUFUGUHAUIUJUKUL $.
  $}

  ${
    intfracq.1 $e |- Z = ( |_ ` ( M / N ) ) $.
    intfracq.2 $e |- F = ( ( M / N ) - Z ) $.
    $( Decompose a rational number, expressed as a ratio, into integer and
       fractional parts.  The fractional part has a tighter bound than that of
       ~ intfrac2 .  (Contributed by NM, 16-Aug-2008.) $)
    intfracq $p |- ( ( M e. ZZ /\ N e. NN )
         -> ( 0 <_ F /\ F <_ ( ( N - 1 ) / N ) /\ ( M / N ) = ( Z + F ) ) ) $=
      ( cz wcel cc0 cle wbr c1 cmin co cdiv clt cr adantl syl cmul cn caddc w3a
      wa wceq zre adantr nnre wne nnne0 redivcld intfrac2 simp1d cfl cfv oveq2i
      fraclt1 eqtri a1i dividd 3brtr4d reflcl syl5eqel resubcld nngt0 ltmuldiv2
      nncn wb jca syl3anc mpbird cc recnd flcld zcnd subdid syl5eq zcn divcan2d
      simpl eqeltrd zmulcld zsubcld zltlem1 syl2anc mpbid peano2rem simp3d 3jca
      nnz lemuldiv2 ) BGHZCUAHZUDZIAJKZACLMNZCONJKZBCONZDAUBNUEZWNWOALPKZWSWNWR
      QHZWOWTWSUCWNBCWLBQHWMBUFUGWMCQHZWLCUHZRZWMCIUIWLCUJZRZUKZWRADEFULSZUMWNC
      ATNZWPJKZWQWNXICPKZXJWNXKACCONZPKZWNWRWRUNUOZMNZLAXLPWNXAXOLPKXGWRUQSAXOU
      EWNAWRDMNZXOFDXNWRMEUPURUSWMXLLUEWLWMCCVGZXEUTRVAWNAQHZXBXBICPKZUDZXKXMVH
      WNAXPQFWNWRDXGWNDXNQEWNXAXNQHXGWRVBSVCVDVCZXDWMXTWLWMXBXSXCCVEVIRZACCVFVJ
      VKWNXIGHCGHZXKXJVHWNXICWRTNZCDTNZMNZGWNXICXPTNYFAXPCTFUPWNCWRDWMCVLHWLXQR
      ZWNWRXGVMWNDWNDXNGEWNWRXGVNVCZVOVPVQWNYDYEWNYDBGWNBCWLBVLHWMBVRUGYGXFVSWL
      WMVTWAWNCDWMYCWLCWJRZYHWBWCWAYIXICWDWEWFWNXRWPQHZXTXJWQVHYAWMYJWLWMXBYJXC
      CWGSRYBAWPCWKVJWFWNWOWTWSXHWHWI $.
  $}

  $( Cancellation of the embedded floor of a real divided by an integer.
     (Contributed by NM, 16-Aug-2008.) $)
  fldiv $p |- ( ( A e. RR /\ N e. NN )
                  -> ( |_ ` ( ( |_ ` A ) / N ) ) = ( |_ ` ( A / N ) ) ) $=
    ( cr wcel wa cdiv co cfl caddc wceq cc0 cle wbr c1 clt adantr cc jca adantl
    recnd cn cfv cmin eqid intfrac2 simp3d oveq1d wne reflcl resubcl mpdan nncn
    nnne0 divdir syl3anc eqtrd cz flcl intfracq sylan nnre redivcld syl addassd
    resubcld 3eqtrd fveq2d simp1d fracge0 nngt0 divge0 syl2an addge0d peano2rem
    nnrecre jca31 simp2d fraclt1 wb 1re ltdiv1 mp3an2 mpbid leltadd sylc ax-1cn
    npcan sylancl syl12anc dividd 3eqtr3d breqtrd flcld flbi2 syl2anc mpbir2and
    readdcld eqtr2d ) ACDZBUADZEZABFGZHUBAHUBZBFGZHUBZXDXEUCGZAXCUCGZBFGZIGZIGZ
    HUBZXEXAXBXJHXAXBXDXHIGZXEXFIGZXHIGXJXAXBXCXGIGZBFGZXLXAAXNBFWSAXNJZWTWSKXG
    LMZXGNOMZXPAXGXCXCUDXGUDUEUFPUGXAXCQDZXGQDZBQDZBKUHZEZXOXLJWSXSWTWSXCAUIZTP
    WSXTWTWSXGWSXCCDZXGCDZYDAXCUJUKZTPWTYCWSWTYAYBBULZBUMZRSXCXGBUNUOUPXAXDXMXH
    IWSXCUQDZWTXDXMJZAURZYJWTEZKXFLMZXFBNUCGZBFGZLMZYKXFXCBXEXEUDXFUDUSZUFUTUGX
    AXEXFXHXAXEXAXDCDXECDXAXCBWSYEWTYDPWTBCDZWSBVAZSZWTYBWSYISZVBZXDUIVCZTXAXFX
    AXDXEUUCUUDVEZTXAXHXAXGBWSYFWTYGPUUAUUBVBZTVDVFVGXAXKXEJZKXILMZXINOMZXAXFXH
    UUEUUFWSYJWTYNYLYMYNYQYKYRVHUTWSYFXQEYSKBOMZEZKXHLMWTWSYFXQYGAVIRWTYSUUJYTB
    VJRZXGBVKVLVMXAXIYPNBFGZIGZNOXAXFCDZXHCDZEYPCDZUUMCDZEZEYQXHUUMOMZEXIUUNOMX
    AUUOUUPUUSUUEUUFWTUUSWSWTUUQUURWTYOBWTYSYOCDYTBVNVCZYTYIVBBVORSVPXAYQUUTWSY
    JWTYQYLYMYNYQYKYRVQUTXAXRUUTWSXRWTAVRPWSYFUUKXRUUTVSZWTYGUULYFNCDUUKUVBVTXG
    NBWAWBVLWCRXFXHYPUUMWDWEWTUUNNJWSWTYONIGZBFGZBBFGUUNNWTUVCBBFWTYANQDZUVCBJY
    HWFBNWGWHUGWTYOQDZYAYBUVDUUNJZWTYOUVATYHYIUVFUVEYCUVGWFYONBUNWBWIWTBYHYIWJW
    KSWLXAXEUQDXICDUUGUUHUUIEVSXAXDUUCWMXAXFXHUUEUUFWQXIXEWNWOWPWR $.

  $( Cancellation of an embedded floor of a ratio.  Generalization of Equation
     2.4 in [CormenLeisersonRivest] p. 33 (where ` A ` must be an integer).
     (Contributed by NM, 9-Nov-2008.) $)
  fldiv2 $p |- ( ( A e. RR /\ M e. NN /\ N e. NN )
      -> ( |_ ` ( ( |_ ` ( A / M ) ) / N ) ) = ( |_ ` ( A / ( M x. N ) ) ) ) $=
    ( cr wcel cn w3a cdiv co cfl cfv cmul wceq wa cc cc0 wne nncn nnne0 jca
    nndivre fldiv sylan 3impa recn divdiv1 syl3an fveq2d eqtrd ) ADEZBFEZCFEZGZ
    ABHIZJKCHIJKZUNCHIZJKZABCLIHIZJKUJUKULUOUQMZUJUKNUNDEULUSABUAUNCUBUCUDUMUPU
    RJUJAOEUKBOEZBPQZNULCOEZCPQZNUPURMAUEUKUTVABRBSTULVBVCCRCSTABCUFUGUHUI $.

  $( Finite set of sequential integers starting at 1 and ending at a real
     number.  (Contributed by Mario Carneiro, 3-May-2016.) $)
  fznnfl $p |- ( N e. RR
              -> ( K e. ( 1 ... ( |_ ` N ) ) <-> ( K e. NN /\ K <_ N ) ) ) $=
    ( cr wcel c1 cfl cfv cfz co cn cle wbr wa cz wb flcl fznn syl nnz flge
    sylan2 pm5.32da bitr4d ) BCDZAEBFGZHIDZAJDZAUEKLZMZUGABKLZMUDUENDUFUIOBPAUE
    QRUDUGUJUHUGUDANDUJUHOASBATUAUBUC $.

  ${
    $d n x M $.  $d n x Z $.
    uzsup.1 $e |- Z = ( ZZ>= ` M ) $.
    $( A set of upper integers is unbounded above.  (Contributed by Mario
       Carneiro, 7-May-2016.) $)
    uzsup $p |- ( M e. ZZ -> sup ( Z , RR* , < ) = +oo ) $=
      ( vx vn cz wcel cv cle wbr wrex wral cxr clt csup cfv syl2an adantl sstri
      cr cpnf wceq wa cfl c1 caddc cif cuz simpl flcl peano2zd ifcl syl2anr zre
      co id reflcl peano2re syl max1 eluz2 syl3anbrc syl6eleqr zred fllep1 max2
      simpr letrd breq2 rspcev syl2anc ralrimiva wss uzssz eqsstri zssre ressxr
      wb supxrunb1 ax-mp sylib ) AFGZDHZEHZIJZEBKZDTLZBMNOUAUBZWBWFDTWBWCTGZUCZ
      AWCUDPZUEUFUOZIJZWLAUGZBGWCWNIJZWFWJWNAUHPZBWJWBWNFGZAWNIJZWNWPGWBWIUIWIW
      LFGWBWQWBWIWKWCUJUKWBUPWMWLAFULUMZWBATGZWLTGZWRWIAUNZWIWKTGXAWCUQWKURUSZA
      WLUTQAWNVAVBCVCWJWCWLWNWBWIVGWIXAWBXCRWJWNWSVDWIWCWLIJWBWCVERWBWTXAWLWNIJ
      WIXBXCAWLVFQVHWEWOEWNBWDWNWCIVIVJVKVLBMVMWGWHVRBTMBFTBWPFCAVNVOVPSVQSDEBV
      SVTWA $.
  $}

  ${
    $d w x y z A $.
    $( A set of upper reals is unbounded above.  (Contributed by Mario
       Carneiro, 7-May-2016.) $)
    ioopnfsup $p |- ( ( A e. RR* /\ A =/= +oo ) ->
      sup ( ( A (,) +oo ) , RR* , < ) = +oo ) $=
      ( vx vy vz vw cxr wcel cpnf wne wa cioo co c0 clt csup wceq simpl wbr idd
      xrltle pnfxr a1i nltpnft necon2abid biimpar wb ioon0 syldan mpbird df-ioo
      cv ixxub syl3anc ) AFGZAHIZJZUNHFGZAHKLZMIZURFNOHPUNUOQUQUPUAUBZUPUSAHNRZ
      UNVAUOUNVAAHAUCUDUEUNUOUQUSVAUFUTAHUGUHUIBCDEAHNNKBCDUJEUKZFGZUQJVBHNRSVB
      HTUNVCJAVBNRSAVBTULUM $.

    $( A set of upper reals is unbounded above.  (Contributed by Mario
       Carneiro, 7-May-2016.) $)
    icopnfsup $p |- ( ( A e. RR* /\ A =/= +oo ) ->
      sup ( ( A [,) +oo ) , RR* , < ) = +oo ) $=
      ( vx vy vz vw cxr wcel cpnf wne wa cico co c0 clt csup wbr syl3anc xrltle
      cle idd wceq simpl pnfxr a1i nltpnft necon2abid biimpar lbico1 syl df-ico
      ne0i cv ixxub ) AFGZAHIZJZUNHFGZAHKLZMIZURFNOHUAUNUOUBZUQUPUCUDZUPAURGZUS
      UPUNUQAHNPZVBUTVAUNVCUOUNVCAHAUEUFUGAHUHQURAUKUIBCDEAHSNKBCDUJEULZFGZUQJV
      DHNPTVDHRAVDRUNVEJAVDSPTUMQ $.
  $}

  $( The positive reals are unbounded above.  (Contributed by Mario Carneiro,
     7-May-2016.) $)
  rpsup $p |- sup ( RR+ , RR* , < ) = +oo $=
    ( cc0 cpnf cioo co cxr clt csup crp ioorp supeq1i wcel wne wceq 0xr renepnf
    cr 0re ax-mp ioopnfsup mp2an eqtr3i ) ABCDZEFGZHEFGBEUBHFIJAEKABLZUCBMNAPKU
    DQAORASTUA $.

  $( The real numbers are unbounded above.  (Contributed by Mario Carneiro,
     7-May-2016.) $)
  resup $p |- sup ( RR , RR* , < ) = +oo $=
    ( cmnf cpnf cioo co cxr clt csup cr ioomax supeq1i wcel wceq mnfxr pnfnemnf
    wne necomi ioopnfsup mp2an eqtr3i ) ABCDZEFGZHEFGBETHFIJAEKABOUABLMBANPAQRS
    $.

  $( The extended real numbers are unbounded above.  (Contributed by Mario
     Carneiro, 7-May-2016.) $)
  xrsup $p |- sup ( RR* , RR* , < ) = +oo $=
    ( cxr wss cpnf wcel clt csup wceq ssid pnfxr supxrpnf mp2an ) AABCADAAEFCGA
    HIAJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The modulo (remainder) operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c mod $.  $( Modulo operation. $)
  $c == $.  $( Equivalence symbol. $)

  $( Extend class notation with the modulo operation. $)
  cmo $a class mod $.

  ${
    $d x y $.
    $( Define the modulo (remainder) operation.  See ~ modval for its value.
       (Contributed by NM, 10-Nov-2008.) $)
    df-mod $a |- mod = ( x e. RR , y e. RR+ |->
          ( x - ( y x. ( |_ ` ( x / y ) ) ) ) ) $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The value of the modulo operation.  The modulo congruence notation of
       number theory, ` J == K ( ` modulo ` N ) ` , can be expressed in our
       notation as ` ( J mod N ) = ( K mod N ) ` .  Definition 1 in Knuth, _The
       Art of Computer Programming_, Vol.  I (1972), p. 38.  Knuth uses "mod"
       for the operation and "modulo" for the congruence.  Unlike Knuth, we
       restrict the second argument to positive reals to simplify certain
       theorems.  (This also gives us future flexibility to extend it to any
       one of several different conventions for a zero or negative second
       argument, should there be an advantage in doing so.)  (Contributed by
       NM, 10-Nov-2008.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    modval $p |- ( ( A e. RR /\ B e. RR+ )
           -> ( A mod B ) = ( A - ( B x. ( |_ ` ( A / B ) ) ) ) ) $=
      ( vx vy cr crp cv cdiv co cfl cfv cmul cmin cmo wceq fveq2d oveq2d oveq12
      oveq1 mpdan oveq2 df-mod ovex ovmpt2 ) CDABEFCGZDGZUEUFHIZJKZLIZMIZABABHI
      ZJKZLIZMINAUFAUFHIZJKZLIZMIZUEAOZUIUPOUJUQOURUHUOUFLURUGUNJUEAUFHSPQUEAUI
      UPMRTUFBOZUPUMAMUSUOULOUPUMOUSUNUKJUFBAHUAPUFBUOULLRTQCDUBAUMMUCUD $.
  $}

  $( Closure law for the modulo operation.  (Contributed by NM,
     10-Nov-2008.) $)
  modcl $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A mod B ) e. RR ) $=
    ( cr wcel crp wa cmo co cdiv cfl cfv cmul cmin modval rpre adantl rerpdivcl
    reflcl syl remulcld resubcl syldan eqeltrd ) ACDZBEDZFZABGHABABIHZJKZLHZMHZ
    CABNUDUEUICDUJCDUFBUHUEBCDUDBOPUFUGCDUHCDABQUGRSTAUIUAUBUC $.

  ${
    modcld.1 $e |- ( ph -> A e. RR ) $.
    modcld.2 $e |- ( ph -> B e. RR+ ) $.
    $( Closure law for the modulo operation.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    modcld $p |- ( ph -> ( A mod B ) e. RR ) $=
      ( cr wcel crp cmo co modcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.
  $}

  $( ` A mod B ` is zero iff ` A ` is evenly divisible by ` B ` .  (Contributed
     by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Fan Zheng,
     7-Jun-2016.) $)
  mod0 $p |- ( ( A e. RR /\ B e. RR+ ) ->
                              ( ( A mod B ) = 0 <-> ( A / B ) e. ZZ ) ) $=
    ( cr wcel crp wa cmo co cc0 wceq cdiv cfl cfv cz cc adantl syl recnd bitrd
    wb cmul cmin modval eqeq1d recn adantr rpre rerpdivcl reflcl remulcld eqcom
    subeq0ad wne rpcnne0 divmul2 syl3anc syl5rbbr flidz ) ACDZBEDZFZABGHZIJZABK
    HZLMZVDJZVDNDZVAVCABVEUAHZJZVFVAVCAVHUBHZIJVIVAVBVJIABUCUDVAAVHUSAODZUTAUEU
    FZVAVHVABVEUTBCDUSBUGPVAVDCDZVECDABUHZVDUIQZUJRULSVFVDVEJZVAVIVDVEUKVAVKVEO
    DBODBIUMFZVPVITVLVAVEVORUTVQUSBUNPAVEBUOUPUQSVAVMVFVGTVNVDURQS $.

  $( ` A ` is divisible by ` B ` iff its negative is.  (Contributed by Jeff
     Madsen, 2-Sep-2009.)  (Proof shortened by Fan Zheng, 7-Jun-2016.) $)
  negmod0 $p |- ( ( A e. RR /\ B e. RR+ ) ->
                    ( ( A mod B ) = 0 <-> ( -u A mod B ) = 0 ) ) $=
    ( cr wcel crp wa cdiv co cz cneg cmo cc0 wceq rerpdivcl recn znegclb adantl
    cc wb mod0 3syl adantr wne rpne0 divnegd eleq1d bitrd renegcl sylan 3bitr4d
    rpcn ) ACDZBEDZFZABGHZIDZAJZBGHZIDZABKHLMUQBKHLMZUNUPUOJZIDZUSUNUOCDUORDUPV
    BSABNUOOUOPUAUNVAURIUNABULARDUMAOUBUMBRDULBUKQUMBLUCULBUDQUEUFUGABTULUQCDUM
    UTUSSAUHUQBTUIUJ $.

  $( The modulo operation is nonnegative.  (Contributed by NM, 10-Nov-2008.) $)
  modge0 $p |- ( ( A e. RR /\ B e. RR+ ) -> 0 <_ ( A mod B ) ) $=
    ( cr wcel crp wa cc0 cdiv co cfl cfv cmul cmin cmo cle wbr wb adantl mpbird
    syl rerpdivcl flle clt reflcl simpl rpregt0 lemuldiv2 syl3anc rpre remulcld
    subge0 syldan modval breqtrrd ) ACDZBEDZFZGABABHIZJKZLIZMIZABNIOUQGVAOPZUTA
    OPZUQVCUSUROPZUQURCDZVDABUAZURUBTUQUSCDZUOBCDZGBUCPFZVCVDQUQVEVGVFURUDTZUOU
    PUEUPVIUOBUFRUSABUGUHSUOUPUTCDVBVCQUQBUSUPVHUOBUIRVJUJAUTUKULSABUMUN $.

  $( The modulo operation is less than its second argument.  (Contributed by
     NM, 10-Nov-2008.) $)
  modlt $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A mod B ) < B ) $=
    ( cr wcel crp wa cmo co cdiv cmin cmul clt cc cc0 wceq adantl recnd syl wbr
    c1 cfl cfv recn rpcnne0 divcan2 3expb syl2an oveq1d rerpdivcl reflcl subdid
    rpcn modval 3eqtr4rd fraclt1 divid breqtrrd resubcld rpre rpregt0 ltmuldiv2
    wne wb syl3anc mpbird eqbrtrd ) ACDZBEDZFZABGHZBABIHZVKUAUBZJHZKHZBLVIBVKKH
    ZBVLKHZJHAVPJHVNVJVIVOAVPJVGAMDZBMDZBNVBZFZVOAOZVHAUCBUDZVQVRVSWAABUEUFUGUH
    VIBVKVLVHVRVGBULPVIVKABUIZQVIVLVIVKCDZVLCDWCVKUJRZQUKABUMUNVIVNBLSZVMBBIHZL
    SZVIVMTWGLVIWDVMTLSWCVKUORVHWGTOZVGVHVTWIWBBUPRPUQVIVMCDBCDZWJNBLSFZWFWHVCV
    IVKVLWCWEURVHWJVGBUSPVHWKVGBUTPVMBBVAVDVEVF $.

  $( The modulo operation differs from ` A ` by an integer multiple of ` B ` .
     (Contributed by Mario Carneiro, 6-Sep-2016.) $)
  moddiffl $p |- ( ( A e. RR /\ B e. RR+ ) ->
    ( ( A - ( A mod B ) ) / B ) = ( |_ ` ( A / B ) ) ) $=
    ( cr wcel crp wa cmo co cmin cdiv cfl cfv cmul modval oveq2d simpl recnd cc
    adantl eqtrd rpcn rerpdivcl flcld zcnd mulcld nncand cc0 wne rpne0 divcan3d
    oveq1d ) ACDZBEDZFZAABGHZIHZBJHBABJHZKLZMHZBJHURUNUPUSBJUNUPAAUSIHZIHUSUNUO
    UTAIABNOUNAUSUNAULUMPQUNBURUMBRDULBUASZUNURUNUQABUBUCUDZUEUFTUKUNURBVBVAUMB
    UGUHULBUISUJT $.

  $( The modulo operation differs from ` A ` by an integer multiple of ` B ` .
     (Contributed by Mario Carneiro, 15-Jul-2014.) $)
  moddifz $p |- ( ( A e. RR /\ B e. RR+ ) ->
    ( ( A - ( A mod B ) ) / B ) e. ZZ ) $=
    ( cr wcel crp wa cmo co cmin cdiv cfl cfv moddiffl rerpdivcl flcld eqeltrd
    cz ) ACDBEDFZAABGHIHBJHABJHZKLQABMRSABNOP $.

  $( The fractional part of a number is the number modulo 1.  (Contributed by
     NM, 11-Nov-2008.) $)
  modfrac $p |- ( A e. RR -> ( A mod 1 ) = ( A - ( |_ ` A ) ) ) $=
    ( cr wcel c1 cmo co cdiv cfl cfv cmul cmin crp wceq modval mpan2 recn div1d
    1rp oveq2d eqtrd fveq2d reflcl recnd mulid2d ) ABCZADEFZADADGFZHIZJFZKFZAAH
    IZKFUEDLCUFUJMRADNOUEUIUKAKUEUIDUKJFUKUEUHUKDJUEUGAHUEAAPQUASUEUKUEUKAUBUCU
    DTST $.

  $( The floor function expressed in terms of the modulo operation.
     (Contributed by NM, 11-Nov-2008.) $)
  flmod $p |- ( A e. RR -> ( |_ ` A ) = ( A - ( A mod 1 ) ) ) $=
    ( cr wcel c1 cmo co cmin cfl modfrac oveq2d recn reflcl recnd nncand eqtr2d
    cfv ) ABCZAADEFZGFAAAHPZGFZGFSQRTAGAIJQASAKQSALMNO $.

  $( Break a number into its integer part and its fractional part.
     (Contributed by NM, 31-Dec-2008.) $)
  intfrac $p |- ( A e. RR -> A = ( ( |_ ` A ) + ( A mod 1 ) ) ) $=
    ( cr wcel cfl cfv c1 co caddc cmin modfrac oveq2d reflcl recnd recn pncan3d
    cmo eqtr2d ) ABCZADEZAFPGZHGSASIGZHGARTUASHAJKRSARSALMANOQ $.

  $( An integer modulo 1 is 0.  (Contributed by Paul Chapman, 22-Jun-2011.) $)
  zmod10 $p |- ( N e. ZZ -> ( N mod 1 ) = 0 ) $=
    ( cz wcel c1 cmo co cfl cfv cmin cc0 cr wceq zre modfrac flid oveq2d subidd
    syl zcn 3eqtrd ) ABCZADEFZAAGHZIFZAAIFJUAAKCUBUDLAMANRUAUCAAIAOPUAAASQT $.

  $( Move a natural number in and out of a floor in the first argument of a
     modulo operation.  (Contributed by NM, 2-Jan-2009.) $)
  modmulnn $p |- ( ( N e. NN /\ A e. RR /\ M e. NN ) -> ( ( N x. ( |_ ` A ) )
           mod ( N x. M ) ) <_ ( ( |_ ` ( N x. A ) ) mod ( N x. M ) ) ) $=
    ( cn wcel cr cfl cfv cmul co cdiv cmin reflcl 3adant3 wa 3adant2 cc0 wne cc
    wceq w3a cmo cle nnre remulcl syl2an sylan syl nnmulcl nnred nncn nnne0 jca
    mulne0 redivcld remulcld wbr cn0 nnnn0 flmulnn0 lesub1dd crp modval syl2anc
    nnrpd fldiv recnd divcan5 syl3an fveq2d 3eqtr4rd 3comr eqtrd oveq2d 3brtr4d
    recn ) CDEZAFEZBDEZUAZCAGHZIJZCBIJZWBWCKJZGHZIJZLJZCAIJZGHZWFLJZWBWCUBJZWIW
    CUBJZUCVTWBWIWFVQVRWBFEZVSVQCFEZWAFEWMVRCUDZAMZCWAUEUFNZVQVRWIFEZVSVQVROWHF
    EZWRVQWNVRWSWOCAUEUGZWHMUHNZVTWCWEVQVSWCFEVRVQVSOZWCCBUIZUJPZVTWDFEWEFEVTWB
    WCWQXDVQVSWCQRZVRVQCSEZCQRZOZBSEZBQRZOZXEVSVQXFXGCUKCULUMZVSXIXJBUKBULUMZCB
    UNUFPUOWDMUHUPVQVRWBWIUCUQZVSVQCUREVRXNCUSACUTUGNVAVTWMWCVBEZWKWGTWQVQVSXOV
    RXBWCXCVEPZWBWCVCVDVTWLWIWCWIWCKJGHZIJZLJZWJVTWRXOWLXSTXAXPWIWCVCVDVTXRWFWI
    LVTXQWEWCIVTXQWHWCKJZGHZWEVTWSWCDEZXQYATVQVRWSVSWTNVQVSYBVRXCPWHWCVFVDVRVSV
    QYAWETVRVSVQUAZWABKJZGHZABKJZGHZWEYAVRVSYEYGTVQABVFNYCWDYDGVRWASEVSXKVQXHWD
    YDTVRWAWPVGXMXLWABCVHVIVJYCXTYFGVRASEVSXKVQXHXTYFTAVPXMXLABCVHVIVJVKVLVMVNV
    NVMVO $.

  $( Closure law for the modulo operation restricted to integers.  (Contributed
     by NM, 27-Nov-2008.) $)
  zmodcl $p |- ( ( A e. ZZ /\ B e. NN ) -> ( A mod B ) e. NN0 ) $=
    ( cz wcel cn wa cmo co cc0 cle wbr cn0 cdiv cfl cfv cmul cmin cr crp syl2an
    wceq zre nnrp modval nnz adantl nndivre sylan zmulcld zsubcl syldan eqeltrd
    flcld modge0 elnn0z sylanbrc ) ACDZBEDZFZABGHZCDIUTJKZUTLDUSUTABABMHZNOZPHZ
    QHZCUQARDZBSDZUTVEUAURAUBZBUCZABUDTUQURVDCDVECDUSBVCURBCDUQBUEUFUSVBUQVFURV
    BRDVHABUGUHUMUIAVDUJUKULUQVFVGVAURVHVIABUNTUTUOUP $.

  ${
    zmodcld.1 $e |- ( ph -> A e. ZZ ) $.
    zmodcld.2 $e |- ( ph -> B e. NN ) $.
    $( Closure law for the modulo operation restricted to integers.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    zmodcld $p |- ( ph -> ( A mod B ) e. NN0 ) $=
      ( cz wcel cn cmo co cn0 zmodcl syl2anc ) ABFGCHGBCIJKGDEBCLM $.
  $}

  $( An integer mod ` B ` lies in the first ` B ` nonnegative integers.
     (Contributed by Jeff Madsen, 17-Jun-2010.) $)
  zmodfz $p |- ( ( A e. ZZ /\ B e. NN ) ->
                                  ( A mod B ) e. ( 0 ... ( B - 1 ) ) ) $=
    ( cz wcel cn wa cmo co cc0 c1 cmin cfz cle wbr clt zmodcl nn0zd nn0ge0d crp
    cr zre nnrp modlt syl2an w3a wb 0z nnz adantl elfzm11 sylancr mpbir3and ) A
    CDZBEDZFZABGHZIBJKHLHDZUPCDZIUPMNZUPBONZUOUPABPZQUOUPVARUMATDBSDUTUNAUABUBA
    BUCUDUOICDBCDZUQURUSUTUEUFUGUNVBUMBUHUIUPIBUJUKUL $.

  $( An integer mod ` B ` lies in the first ` B ` nonnegative integers.
     (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
  zmodfzo $p |- ( ( A e. ZZ /\ B e. NN ) -> ( A mod B ) e. ( 0 ..^ B ) ) $=
    ( cz wcel cn wa cmo co cc0 c1 cmin cfz cfzo zmodfz wceq nnz fzoval eleqtrrd
    syl adantl ) ACDZBEDZFABGHIBJKHLHZIBMHZABNUBUDUCOZUAUBBCDUEBPIBQSTR $.

  $( Identity law for modulo.  (Contributed by NM, 29-Dec-2008.) $)
  modid $p |- ( ( ( A e. RR /\ B e. RR+ ) /\ ( 0 <_ A /\ A < B ) )
               -> ( A mod B ) = A ) $=
    ( cr wcel wa cc0 cle wbr clt co cfl cmul cmin wceq adantr c1 ad2antlr eqtrd
    cfv wb crp cmo modval caddc cc rerpdivcl recnd addid2 fveq2d rpregt0 divge0
    cdiv syl sylan2 an32s adantrr simpr rpcn mulid1d breqtrrd ad2ant2l ltdivmul
    simpll 1re mp3an2 syl2anc mpbird cz 0z flbi2 mpbir2and eqtr3d oveq2d mul01d
    sylancr recn subid1d ad2antrr ) ACDZBUADZEZFAGHZABIHZEZEZABUBJZABABULJZKSZL
    JZMJZAWAWFWJNWDABUCOWEWJAFMJZAWEWIFAMWEWIBFLJZFWEWHFBLWEFWGUDJZKSZWHFWEWGUE
    DZWNWHNWEWGWAWGCDZWDABUFOZUGWOWMWGKWGUHUIUMWEWNFNZFWGGHZWGPIHZWAWBWSWCVSWBV
    TWSVTVSWBEBCDFBIHEZWSBUJZABUKUNUOUPWEWTABPLJZIHZVTWCXDVSWBVTWCEABXCIVTWCUQV
    TXCBNWCVTBBURZUSOUTVAWEVSXAWTXDTZVSVTWDVCVTXAVSWDXBQVSPCDXAXFVDAPBVBVEVFVGW
    EFVHDWPWRWSWTETVIWQWGFVJVOVKVLVMVTWLFNVSWDVTBXEVNQRVMVSWKANVTWDVSAAVPVQVRRR
    $.

  $( Identity law for modulo.  (Contributed by NM, 29-Dec-2008.) $)
  modid2 $p |- ( ( A e. RR /\ B e. RR+ )
     -> ( ( A mod B ) = A <-> ( 0 <_ A /\ A < B ) ) ) $=
    ( cr wcel crp wa cmo co wceq cc0 cle wbr clt modge0 modlt jca breq2 anbi12d
    breq1 syl5ibcom modid ex impbid ) ACDBEDFZABGHZAIZJAKLZABMLZFZUDJUEKLZUEBML
    ZFUFUIUDUJUKABNABOPUFUJUGUKUHUEAJKQUEABMSRTUDUIUFABUAUBUC $.

  $( Special case: 0 modulo a positive real number is 0.  (Contributed by Mario
     Carneiro, 22-Feb-2014.) $)
  0mod $p |- ( N e. RR+ -> ( 0 mod N ) = 0 ) $=
    ( crp wcel cc0 cr wa cle wbr clt cmo wceq 0re jctl rpgt0 0le0 jctil syl2anc
    co modid ) ABCZDECZTFDDGHZDAIHZFDAJRDKTUALMTUCUBANOPDASQ $.

  $( Special case: 1 modulo a real number greater than 1 is 1.  (Contributed by
     Mario Carneiro, 18-Feb-2014.) $)
  1mod $p |- ( ( N e. RR /\ 1 < N ) -> ( 1 mod N ) = 1 ) $=
    ( cr wcel c1 clt wbr wa crp cc0 cle cmo co wceq 0lt1 0re lttr mp3an12 jctil
    wi 1re mpani imdistani elrp sylibr simpr 0le1 modid syl2anc ) ABCZDAEFZGZDB
    CZAHCZGIDJFZUJGDAKLDMUKUMULUKUIIAEFZGUMUIUJUOUIIDEFZUJUONIBCULUIUPUJGUOSOTI
    DAPQUAUBAUCUDTRUKUJUNUIUJUEUFRDAUGUH $.

  $( Absorption law for modulo.  (Contributed by NM, 29-Dec-2008.) $)
  modabs $p |- ( ( ( A e. RR /\ B e. RR+ /\ C e. RR+ ) /\ B <_ C )
           -> ( ( A mod B ) mod C ) = ( A mod B ) ) $=
    ( cr wcel crp w3a cle wbr wa cmo co cc0 clt wceq anim1i adantr 3adant3 rpre
    modcl 3impa modge0 3ad2ant2 3ad2ant3 modlt simpr ltletrd modid syl12anc ) A
    DEZBFEZCFEZGZBCHIZJZABKLZDEZULJZMUPHIZUPCNIUPCKLUPOUMURUNUJUKULURUJUKJUQULA
    BTZPUAQUMUSUNUJUKUSULABUBRQUOUPBCUMUQUNUJUKUQULUTRQUMBDEZUNUKUJVAULBSUCQUMC
    DEZUNULUJVBUKCSUDQUMUPBNIZUNUJUKVCULABUERQUMUNUFUGUPCUHUI $.

  $( Absorption law for modulo.  (Contributed by NM, 29-Dec-2008.) $)
  modabs2 $p |- ( ( A e. RR /\ B e. RR+ )
           -> ( ( A mod B ) mod B ) = ( A mod B ) ) $=
    ( cr wcel crp wa cle wbr cmo co wceq leidd adantl wi w3a modabs ex 3anidm23
    rpre mpd ) ACDZBEDZFBBGHZABIJZBIJUDKZUBUCUAUBBBSLMUAUBUCUENUAUBUBOUCUEABBPQ
    RT $.

  $( The modulo operation is periodic.  (Contributed by NM, 10-Nov-2008.) $)
  modcyc $p |- ( ( A e. RR /\ B e. RR+ /\ N e. ZZ )
        -> ( ( A + ( N x. B ) ) mod B ) = ( A mod B ) ) $=
    ( cr wcel cmul co caddc cmo wceq cdiv cfl cfv cmin wa syl2an 3adant1 oveq2d
    cc 3adant2 cz crp w3a zre remulcl readdcl sylan2 3impb simp3 modval syl2anc
    rpre cc0 wne recn 3ad2ant1 recnd rpcnne0 3ad2ant3 syl3anc zcn divcan4 3expb
    divdir eqtrd fveq2d rerpdivcl fladdz rpcn reflcl syl 3ad2ant2 adddid mulcom
    simp2 eqcomd 3eqtrd adantl mulcld pnpcan2d eqtr4d 3com23 ) ADEZCUAEZBUBEZAC
    BFGZHGZBIGZABIGZJWCWDWEUCZWHABABKGZLMZFGZNGZWIWJWHWGBWGBKGZLMZFGZNGZWGWMWFH
    GZNGWNWJWGDEZWEWHWRJWCWDWEWTWDWEOZWCWFDEZWTWDCDEBDEXBWECUDBULCBUEPZAWFUFUGU
    HWCWDWEUIWGBUJUKWJWQWSWGNWJWQBWLCHGZFGWMBCFGZHGWSWJWPXDBFWJWPWKCHGZLMZXDWJW
    OXFLWJWOWKWFBKGZHGZXFWJASEZWFSEZBSEZBUMUNZOZWOXIJWCWDXJWEAUOUPZWDWEXKWCXAWF
    XCUQQZWEWCXNWDBURZUSAWFBVDUTWJXHCWKHWDWEXHCJZWCWDCSEZXNXRWECVAZXQXSXLXMXRCB
    VBVCPQRVEVFWJWKDEZWDXGXDJWCWEYAWDABVGZTWCWDWEVOWKCVHUKVERWJBWLCWEWCXLWDBVIZ
    USWCWEWLSEZWDWCWEOZYAYDYBYAWLWKVJUQVKZTWDWCXSWEXTVLVMWJXEWFWMHWJWFXEWDWEWFX
    EJZWCWDXSXLYGWEXTYCCBVNPQVPRVQRWJAWMWFXOWCWEWMSEWDYEBWLWEXLWCYCVRYFVSTXPVTV
    QWCWEWIWNJWDABUJTWAWB $.

  $( The modulo operation is periodic.  (Contributed by NM, 12-Nov-2008.) $)
  modcyc2 $p |- ( ( A e. RR /\ B e. RR+ /\ N e. ZZ )
        -> ( ( A - ( B x. N ) ) mod B ) = ( A mod B ) ) $=
    ( cr wcel crp cz w3a cmul co cmin cmo cneg caddc cc wceq recn rpcn zcn wa
    mulneg1 ancoms mulcom negeqd eqtr4d oveq2d mulcl negsub sylan2 3impb eqtr2d
    3adant1 syl3an oveq1d znegcl modcyc syl3an3 eqtrd ) ADEZBFEZCGEZHZABCIJZKJZ
    BLJACMZBIJZNJZBLJZABLJZVBVDVGBLUSAOEZUTBOEZVACOEZVDVGPAQBRCSVJVKVLHZVGAVCMZ
    NJZVDVMVFVNANVKVLVFVNPVJVKVLTZVFCBIJZMZVNVLVKVFVRPCBUAUBVPVCVQBCUCUDUEULUFV
    JVKVLVOVDPZVPVJVCOEVSBCUGAVCUHUIUJUKUMUNVAUSUTVEGEVHVIPCUOABVEUPUQUR $.

  $( Addition property of the modulo operation.  (Contributed by NM,
     12-Nov-2008.) $)
  modadd1 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. RR /\ D e. RR+ )
       /\ ( A mod D ) = ( B mod D ) )
       -> ( ( A + C ) mod D ) = ( ( B + C ) mod D ) ) $=
    ( cr wcel wa cmo co wceq caddc cdiv cfl cfv cmul cmin modval adantrl recn
    cc wb eqeqan12d anandirs oveq1 syl6bi adantr ad2antrl rpcn adantl rerpdivcl
    crp reflcl recnd syl mulcld addsubd adantlr adantll eqeq12d sylibrd readdcl
    cz adantrr simprr flcld modcyc2 syl3anc syl5ib syld 3impia ) AEFZBEFZGZCEFZ
    DUKFZGZADHIZBDHIZJZACKIZDHIZBCKIZDHIZJZVMVPGZVSVTDADLIZMNZOIZPIZWBDBDLIZMNZ
    OIZPIZJZWDWEVSAWHPIZCKIZBWLPIZCKIZJZWNWEVSWOWQJZWSVMVOVSWTUAZVNVKVLVOXAVKVO
    GZVLVOGZVQWOVRWQADQBDQUBUCRWOWQCKUDUEWEWIWPWMWRVKVPWIWPJVLVKVPGZACWHVKATFVP
    ASUFVNCTFZVKVOCSZUGVKVOWHTFVNXBDWGVODTFZVKDUHZUIXBWFEFZWGTFADUJZXIWGWFULUMU
    NUORUPUQVLVPWMWRJVKVLVPGZBCWLVLBTFVPBSUFVNXEVLVOXFUGVLVOWLTFVNXCDWKVOXGVLXH
    UIXCWJEFZWKTFBDUJZXLWKWJULUMUNUORUPURUSUTWNWIDHIZWMDHIZJWEWDWIWMDHUDWEXNWAX
    OWCVKVPXNWAJZVLXDVTEFZVOWGVBFZXPVKVNXQVOACVAVCVKVNVOVDVKVOXRVNXBWFXJVERVTDW
    GVFVGUQVLVPXOWCJZVKXKWBEFZVOWKVBFZXSVLVNXTVOBCVAVCVLVNVOVDVLVOYAVNXCWJXMVER
    WBDWKVFVGURUSVHVIVJ $.

  $( Multiplication property of the modulo operation.  Note that the multiplier
     ` C ` must be an integer.  (Contributed by NM, 12-Nov-2008.) $)
  modmul1 $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. ZZ /\ D e. RR+ )
       /\ ( A mod D ) = ( B mod D ) )
       -> ( ( A x. C ) mod D ) = ( ( B x. C ) mod D ) ) $=
    ( cr wcel wa cz cmo co wceq cmul cdiv cfl cfv cmin modval adantrl oveq1 cc
    crp wb eqeqan12d anandirs syl6bi rpcn ad2antll zcn ad2antrl rerpdivcl flcld
    zcnd mulassd mul32d eqtr3d oveq2d recn adantr adantl mulcld subdird adantlr
    eqtr4d adantll eqeq12d sylibrd remulcl sylan2 adantrr simprr simprl zmulcld
    zre modcyc2 syl3anc syl5ib syld 3impia ) AEFZBEFZGZCHFZDUAFZGZADIJZBDIJZKZA
    CLJZDIJZBCLJZDIJZKZWAWDGZWGWHDCADMJZNOZLJZLJZPJZWJDCBDMJZNOZLJZLJZPJZKZWLWM
    WGADWOLJZPJZCLJZBDWTLJZPJZCLJZKZXDWMWGXFXIKZXKWAWCWGXLUBZWBVSVTWCXMVSWCGZVT
    WCGZWEXFWFXIADQBDQUCUDRXFXICLSUEWMWRXGXCXJVSWDWRXGKVTVSWDGZWRWHXECLJZPJXGXP
    WQXQWHPXPDCLJZWOLJWQXQXPDCWOWCDTFZVSWBDUFZUGZWBCTFZVSWCCUHZUIZVSWCWOTFWBXNW
    OXNWNADUJUKZULZRZUMXPDCWOYAYDYGUNUOUPXPAXECVSATFWDAUQURVSWCXETFWBXNDWOWCXSV
    SXTUSYFUTRYDVAVCVBVTWDXCXJKVSVTWDGZXCWJXHCLJZPJXJYHXBYIWJPYHXRWTLJXBYIYHDCW
    TWCXSVTWBXTUGZWBYBVTWCYCUIZVTWCWTTFWBXOWTXOWSBDUJUKZULZRZUMYHDCWTYJYKYNUNUO
    UPYHBXHCVTBTFWDBUQURVTWCXHTFWBXODWTWCXSVTXTUSYMUTRYKVAVCVDVEVFXDWRDIJZXCDIJ
    ZKWMWLWRXCDISWMYOWIYPWKVSWDYOWIKZVTXPWHEFZWCWPHFYQVSWBYRWCWBVSCEFZYRCVMZACV
    GVHVIVSWBWCVJXPCWOVSWBWCVKVSWCWOHFWBYERVLWHDWPVNVOVBVTWDYPWKKZVSYHWJEFZWCXA
    HFUUAVTWBUUBWCWBVTYSUUBYTBCVGVHVIVTWBWCVJYHCWTVTWBWCVKVTWCWTHFWBYLRVLWJDXAV
    NVOVDVEVPVQVR $.

  ${
    modmul12d.1 $e |- ( ph -> A e. ZZ ) $.
    modmul12d.2 $e |- ( ph -> B e. ZZ ) $.
    modmul12d.3 $e |- ( ph -> C e. ZZ ) $.
    modmul12d.4 $e |- ( ph -> D e. ZZ ) $.
    modmul12d.5 $e |- ( ph -> E e. RR+ ) $.
    modmul12d.6 $e |- ( ph -> ( A mod E ) = ( B mod E ) ) $.
    modmul12d.7 $e |- ( ph -> ( C mod E ) = ( D mod E ) ) $.
    $( Multiplication property of the modulo operation.  (Contributed by Mario
       Carneiro, 5-Feb-2015.) $)
    modmul12d $p |- ( ph -> ( ( A x. C ) mod E ) = ( ( B x. D ) mod E ) ) $=
      ( cmul co cmo cr wcel wceq zred crp modmul1 syl221anc zcnd mulcomd oveq1d
      cz 3eqtrd eqtrd ) ABDNOFPOZCDNOZFPOZCENOZFPOZABQRCQRDUGRFUARZBFPOCFPOSUJU
      LSABGTACHTIKLBCDFUBUCAULDCNOZFPOZECNOZFPOZUNAUKUPFPACDACHUDZADIUDUEUFADQR
      EQRCUGRUODFPOEFPOSUQUSSADITAEJTHKMDECFUBUCAURUMFPAECAEJUDUTUEUFUHUI $.
  $}

  ${
    modnegd.1 $e |- ( ph -> A e. RR ) $.
    modnegd.2 $e |- ( ph -> B e. RR ) $.
    modnegd.3 $e |- ( ph -> C e. RR+ ) $.
    modnegd.4 $e |- ( ph -> ( A mod C ) = ( B mod C ) ) $.
    $( Negation property of the modulo operation.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    modnegd $p |- ( ph -> ( -u A mod C ) = ( -u B mod C ) ) $=
      ( c1 cneg cmul co cmo cr wcel cz wceq a1i recnd mulcomd znegcld syl221anc
      crp 1z modmul1 cc ax-1cn negcld mulm1d eqtrd oveq1d 3eqtr3d ) ABIJZKLZDML
      ZCUMKLZDMLZBJZDMLCJZDMLABNOCNOUMPODUCOBDMLCDMLQUOUQQEFAIIPOAUDRUAGHBCUMDU
      EUBAUNURDMAUNUMBKLURABUMABESZAIIUFOAUGRUHZTABUTUIUJUKAUPUSDMAUPUMCKLUSACU
      MACFSZVATACVBUIUJUKUL $.
  $}

  ${
    modadd12d.1 $e |- ( ph -> A e. RR ) $.
    modadd12d.2 $e |- ( ph -> B e. RR ) $.
    modadd12d.3 $e |- ( ph -> C e. RR ) $.
    modadd12d.4 $e |- ( ph -> D e. RR ) $.
    modadd12d.5 $e |- ( ph -> E e. RR+ ) $.
    modadd12d.6 $e |- ( ph -> ( A mod E ) = ( B mod E ) ) $.
    modadd12d.7 $e |- ( ph -> ( C mod E ) = ( D mod E ) ) $.
    $( Additive property of the modulo operation.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    modadd12d $p |- ( ph -> ( ( A + C ) mod E ) = ( ( B + D ) mod E ) ) $=
      ( caddc co cmo cr wcel wceq recnd modadd1 syl221anc addcomd oveq1d 3eqtrd
      crp eqtrd ) ABDNOFPOZCDNOZFPOZCENOZFPOZABQRCQRZDQRZFUFRZBFPOCFPOSUHUJSGHI
      KLBCDFUAUBAUJDCNOZFPOZECNOZFPOZULAUIUPFPACDACHTZADITUCUDAUNEQRUMUODFPOEFP
      OSUQUSSIJHKMDECFUAUBAURUKFPAECAEJTUTUCUDUEUG $.

    $( Subtraction property of the modulo operation.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    modsub12d $p |- ( ph -> ( ( A - C ) mod E ) = ( ( B - D ) mod E ) ) $=
      ( cneg caddc co cmo cmin renegcld recnd modnegd modadd12d negsubd 3eqtr3d
      oveq1d ) ABDNZOPZFQPCENZOPZFQPBDRPZFQPCERPZFQPABCUFUHFGHADISAEJSKLADEFIJK
      MUAUBAUGUJFQABDABGTADITUCUEAUIUKFQACEACHTAEJTUCUEUD $.
  $}

  $( Distribute multiplication over a modulo operation.  (Contributed by NM,
     11-Nov-2008.) $)
  moddi $p |- ( ( A e. RR+ /\ B e. RR /\ C e. RR+ )
      -> ( A x. ( B mod C ) ) = ( ( A x. B ) mod ( A x. C ) ) ) $=
    ( crp wcel cr cdiv co cfl cfv cmul cmin cmo cc rpcn 3ad2ant1 3adant1 oveq2d
    wa wceq w3a recn 3ad2ant2 adantl rerpdivcl reflcl syl remulcld recnd subdid
    cc0 wne rpcnne0 3ad2ant3 divcan5 syl3anc fveq2d mulassd eqtr2d eqtrd modval
    rpre remulcl sylan 3adant3 rpmulcl 3adant2 syl2anc 3eqtr4d ) ADEZBFEZCDEZUA
    ZABCBCGHZIJZKHZLHZKHZABKHZACKHZVSVTGHZIJZKHZLHZABCMHZKHVSVTMHZVMVRVSAVPKHZL
    HWDVMABVPVJVKANEZVLAOPZVKVJBNEZVLBUBUCZVKVLVPNEVJVKVLSZVPWLCVOVLCFEVKCVBUDW
    LVNFEZVOFEBCUEZVNUFZUGUHUIQUJVMWGWCVSLVMWCVTVOKHWGVMWBVOVTKVMWAVNIVMWJCNEZC
    UKULSZWHAUKULSZWAVNTWKVLVJWQVKCUMUNVJVKWRVLAUMPBCAUOUPUQRVMACVOWIVLVJWPVKCO
    UNVKVLVONEZVJWLWMWSWNWMVOWOUIUGQURUSRUTVMWEVQAKVKVLWEVQTVJBCVAQRVMVSFEZVTDE
    ZWFWDTVJVKWTVLVJAFEVKWTAVBABVCVDVEVJVLXAVKACVFVGVSVTVAVHVI $.

  $( Distribute the modulo operation over a subtraction.  (Contributed by NM,
     30-Dec-2008.) $)
  modsubdir $p |- ( ( A e. RR /\ B e. RR /\ C e. RR+ ) -> ( ( B mod C )
  <_ ( A mod C ) <-> ( ( A - B ) mod C ) = ( ( A mod C ) - ( B mod C ) ) ) ) $=
    ( cr wcel cc0 cmo co cmin cle wbr wceq 3adant2 3adant1 wa cmul cz cc adantr
    recnd crp w3a modcl subge0d cfl cfv resubcl 3adant3 simp3 rerpdivcl zsubcld
    cdiv modcyc2 syl3anc recn 3ad2ant1 3ad2ant2 rpre adantl reflcl syl remulcld
    flcld sub4d 3ad2ant3 subdid oveq2d modval oveq12d 3eqtr4d oveq1d eqtr3d clt
    resubcld simpl3 simpr modge0 subge02d mpbid modlt lelttrd modid eqtrd sylan
    syl22anc 3impa breqtrd impbida bitr3d ) ADEZBDEZCUAEZUBZFACGHZBCGHZIHZJKZWO
    WNJKABIHZCGHZWPLZWMWNWOWJWLWNDEWKACUCMZWKWLWODEWJBCUCNZUDWMWQWTWMWQOZWSWPCG
    HZWPWMWSXDLWQWMWRCACULHZUEUFZBCULHZUEUFZIHZPHZIHZCGHZWSXDWMWRDEZWLXIQEXLWSL
    WJWKXMWLABUGZUHWJWKWLUIWMXFXHWJWLXFQEWKWJWLOZXEACUJZVCMWKWLXHQEWJWKWLOZXGBC
    UJZVCNUKWRCXIUMUNWMXKWPCGWMWRCXFPHZCXHPHZIHZIHAXSIHZBXTIHZIHXKWPWMABXSXTWJW
    KAREWLAUOUPWKWJBREWLBUOUQWJWLXSREWKXOXSXOCXFWLCDEZWJCURZUSXOXEDEXFDEXPXEUTV
    AZVBTMWKWLXTREWJXQXTXQCXHWLYDWKYEUSXQXGDEXHDEXRXGUTVAZVBTNVDWMXJYAWRIWMCXFX
    HWMCWLWJYDWKYEVEZTWJWLXFREWKXOXFYFTMWKWLXHREWJXQXHYGTNVFVGWMWNYBWOYCIWJWLWN
    YBLWKACVHMWKWLWOYCLWJBCVHNVIVJVKVLSXCWPDEZWLWQWPCVMKZXDWPLWMYIWQWMWNWOXAXBV
    NZSWJWKWLWQVOWMWQVPWMYJWQWMWPWNCYKXAYHWMFWOJKZWPWNJKWKWLYLWJBCVQNWMWNWOXAXB
    VRVSWJWLWNCVMKWKACVTMWASWPCWBWEWCWMWTOFWSWPJWMFWSJKZWTWJWKWLYMWJWKOXMWLYMXN
    WRCVQWDWFSWMWTVPWGWHWI $.

  $( A number modulo an irrational multiple of it is nonzero.  (Contributed by
     NM, 11-Nov-2008.) $)
  modirr $p |- ( ( A e. RR /\ B e. RR+ /\ ( A / B ) e. ( RR \ QQ ) )
      -> ( A mod B ) =/= 0 ) $=
    ( cr wcel crp cdiv co cq cdif cmo cc0 wne wn wa eldif wceq adantl syl recnd
    cc cfl cmul cmin modval eqeq1d recn adantr rpre rerpdivcl remulcld subeq0ad
    cfv reflcl eqcom wb rpcnne0 divmul2 syl3anc syl5rbbr 3bitrd wi flidz syl6bi
    cz zq sylbid necon3bd adantld syl5bi 3impia ) ACDZBEDZABFGZCHIDZABJGZKLZVNV
    MCDZVMHDZMZNVKVLNZVPVMCHOVTVSVPVQVTVRVOKVTVOKPZVMUAULZVMPZVRVTWAABWBUBGZUCG
    ZKPAWDPZWCVTVOWEKABUDUEVTAWDVKATDZVLAUFUGZVTWDVTBWBVLBCDVKBUHQVTVQWBCDABUIZ
    VMUMZRUJSUKWCVMWBPZVTWFVMWBUNVTWGWBTDZBTDBKLNZWKWFUOWHVTVQWLWIVQWBWJSRVLWMV
    KBUPQAWBBUQURUSUTVTVQWCVRVAWIVQWCVMVDDVRVMVBVMVEVCRVFVGVHVIVJ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The infinite sequence builder "seq"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d y z A $.  $d w z B $.  $d v w x y z C $.  $d v w y z G $.
    om2uz.1 $e |- C e. ZZ $.
    om2uz.2 $e |- G = ( rec ( ( x e. _V |-> ( x + 1 ) ) , C ) |` om ) $.
    $( The mapping ` G ` is a one-to-one mapping from ` om ` onto upper
       integers that will be used to construct a recursive definition
       generator.  Ordinal natural number 0 maps to complex number ` C `
       (normally 0 for the upper integers ` NN0 ` or 1 for the upper integers
       ` NN ` ), 1 maps to ` C ` + 1, etc.  This theorem shows the value of
       ` G ` at ordinal natural number zero.  (This series of theorems
       generalizes an earlier series for ` NN0 ` contributed by Raph Levien,
       10-Apr-2004.)  (Contributed by NM, 3-Oct-2004.)  (Revised by Mario
       Carneiro, 13-Sep-2013.) $)
    om2uz0i $p |- ( G ` (/) ) = C $=
      ( c0 cfv cvv cv c1 caddc co cmpt crdg com cres fveq1i cz wcel wceq ax-mp
      fr0g eqtri ) FCGFAHAIJKLMZBNOPZGZBFCUEEQBRSUFBTDBRUDUBUAUC $.

    $( The value of ` G ` (see ~ om2uz0i ) at a successor.  (Contributed by NM,
       3-Oct-2004.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    om2uzsuci $p |- ( A e. om -> ( G ` suc A ) = ( ( G ` A ) + 1 ) ) $=
      ( vz vy cv csuc cfv c1 caddc co wceq com suceq wcel cvv oveq1 fveq2d ovex
      fveq2 oveq1d eqeq12d frsucmpt2 mpan2 vtoclga ) GIZJZDKZUIDKZLMNZOZBJZDKZB
      DKZLMNZOGBPUIBOZUKUPUMURUSUJUODUIBQUAUSULUQLMUIBDUCUDUEUIPRUMSRUNULLMUBAH
      CUIAIZLMNUMHIZLMNDSFVAUTLMTVAULLMTUFUGUH $.

    $( The value ` G ` (see ~ om2uz0i ) at an ordinal natural number is in the
       upper integers.  (Contributed by NM, 3-Oct-2004.)  (Revised by Mario
       Carneiro, 13-Sep-2013.) $)
    om2uzuzi $p |- ( A e. om -> ( G ` A ) e. ( ZZ>= ` C ) ) $=
      ( vy vz cv cfv cuz wcel c0 csuc wceq fveq2 eleq1d om2uz0i cz uzid eqeltri
      ax-mp com c1 caddc co peano2uz om2uzsuci syl5ibr finds ) GIZDJZCKJZLMDJZU
      MLHIZDJZUMLZUONZDJZUMLZBDJZUMLGHBUKMOULUNUMUKMDPQUKUOOULUPUMUKUODPQUKUROU
      LUSUMUKURDPQUKBOULVAUMUKBDPQUNCUMACDEFRCSLCUMLECTUBUAUQUTUOUCLZUPUDUEUFZU
      MLCUPUGVBUSVCUMAUOCDEFUHQUIUJ $.

    $( Less-than relation for ` G ` (see ~ om2uz0i ).  (Contributed by NM,
       3-Oct-2004.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    om2uzlti $p |- ( ( A e. om /\ B e. om ) ->
                   ( A e. B -> ( G ` A ) < ( G ` B ) ) ) $=
      ( com wcel cfv clt wbr wi c0 wceq eleq2 fveq2 breq2d imbi12d imbi2d vz vy
      cv csuc pm2.21i a1i wo wa id orim12d wb elsuc2g bicomd adantl c1 caddc co
      noel cle om2uzsuci cuz om2uzuzi cz eluzelz zleltp1 syl2an cr syl 3bitr2rd
      zred leloe syl5ib expcom a2d finds impcom ) CHIBHIZBCIZBEJZCEJZKLZMZVQBUA
      UCZIZVSWCEJZKLZMZMVQBNIZVSNEJZKLZMZMVQBUBUCZIZVSWLEJZKLZMZMVQBWLUDZIZVSWQ
      EJZKLZMZMVQWBMUAUBCWCNOZWGWKVQXBWDWHWFWJWCNBPXBWEWIVSKWCNEQRSTWCWLOZWGWPV
      QXCWDWMWFWOWCWLBPXCWEWNVSKWCWLEQRSTWCWQOZWGXAVQXDWDWRWFWTWCWQBPXDWEWSVSKW
      CWQEQRSTWCCOZWGWBVQXEWDVRWFWAWCCBPXEWEVTVSKWCCEQRSTWKVQWHWJBURUEUFWLHIZVQ
      WPXAVQXFWPXAMWPWMBWLOZUGZWOVSWNOZUGZMVQXFUHZXAWPWMWOXGXIWPUIXGXIMWPBWLEQU
      FUJXKXHWRXJWTXFXHWRUKVQXFWRXHBWLHULUMUNXKWTVSWNUOUPUQZKLZVSWNUSLZXJXFWTXM
      UKVQXFWSXLVSKAWLDEFGUTRUNVQVSDVAJZIZWNXOIZXNXMUKZXFABDEFGVBZAWLDEFGVBZXPV
      SVCIZWNVCIZXRXQDVSVDZDWNVDZVSWNVEVFVFVQVSVGIWNVGIXNXJUKXFVQVSVQXPYAXSYCVH
      VJXFWNXFXQYBXTYDVHVJVSWNVKVFVISVLVMVNVOVP $.

    $( The mapping ` G ` (see ~ om2uz0i ) preserves order.  (Contributed by NM,
       4-May-2005.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    om2uzlt2i $p |- ( ( A e. om /\ B e. om ) ->
                   ( A e. B <-> ( G ` A ) < ( G ` B ) ) ) $=
      ( com wcel wa cfv clt wbr om2uzlti wceq wo wn wi con0 wb fveq2 a1i ancoms
      orim12d nnon wss onsseleq ontri1 bitr3d syl2anr cuz om2uzuzi eluzelre syl
      cr cle leloe lenlt 3imtr3d impcon4bid ) BHIZCHIZJZBCIZBEKZCEKZLMZABCDEFGN
      VCCBIZCBOZPZVFVELMZVFVEOZPZVDQZVGQZVBVAVJVMRVBVAJZVHVKVIVLACBDEFGNVIVLRVP
      CBEUAUBUDUCVBCSIZBSIZVJVNTVACUEBUEVQVRJCBUFVJVNCBUGCBUHUIUJVBVFUOIZVEUOIZ
      VMVOTVAVBVFDUKKZIVSACDEFGULDVFUMUNVAVEWAIVTABDEFGULDVEUMUNVSVTJVFVEUPMVMV
      OVFVEUQVFVEURUIUJUSUT $.

    $( Range of ` G ` (see ~ om2uz0i ).  (Contributed by NM, 3-Oct-2004.)
       (Revised by Mario Carneiro, 13-Sep-2013.) $)
    om2uzrani $p |- ran G = ( ZZ>= ` C ) $=
      ( vy vz crn cfv cv wcel com wfn c1 caddc co eleq1 sylbi c0 fnfvelrn mpbir
      cuz wceq wrex wb cvv cmpt crdg cres frfnom fneq1i fvelrnb ax-mp syl5ibcom
      om2uzuzi rexlimiv om2uz0i peano1 mp2an eqeltrri wi wa csuc oveq1 sylan9eq
      om2uzsuci peano2 sylancr adantr eqeltrrd rexlimiva uzind4i impbii eqriv
      a1i ) FCHZBUBIZFJZVPKZVRVQKZVSGJZCIZVRUCZGLUDZVTCLMZVSWDUEWEAUFAJNOPUGZBU
      HLUIZLMBWFUJLCWGEUKUAZGLVRCULUMZWCVTGLWALKZWBVQKWCVTAWABCDEUOWBVRVQQUNUPR
      WAVPKBVPKVSVRNOPZVPKZVSGFBVRDWABVPQWAVRVPQZWAWKVPQWMSCIZBVPABCDEUQWESLKWN
      VPKWHURLSCTUSUTVSWLVAVTVSWDWLWIWCWLGLWJWCVBWAVCZCIZWKVPWJWCWPWBNOPWKAWABC
      DEVFWBVRNOVDVEWJWPVPKZWCWJWEWOLKWQWHWAVGLWOCTVHVIVJVKRVOVLVMVN $.

    $( ` G ` (see ~ om2uz0i ) is a one-to-one onto mapping.  (Contributed by
       NM, 3-Oct-2004.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    om2uzf1oi $p |- G : om -1-1-onto-> ( ZZ>= ` C ) $=
      ( vy vz com cfv wceq cv wi wral wfn mpbir2an wcel wa clt wbr wn cuz wf c1
      wf1o wf1 crn wss cvv caddc cmpt crdg cres frfnom fneq1i om2uzrani eqimssi
      co mpbir df-f wo cr wb cz om2uzuzi eluzelz syl zred lttri3 syl2an syl6bbr
      ioran nnord ordtri3 con2bid om2uzlti ancoms orim12d sylbird sylbid rgen2a
      word con1d dff13 dff1o5 ) HBUAIZCUDHWECUEZCUFZWEJWFHWECUBZFKZCIZGKZCIZJZW
      IWKJZLZGHMFHMWHCHNZWGWEUGWPAUHAKUCUIUQUJZBUKHULZHNBWQUMHCWREUNURWGWEABCDE
      UOZUPHWECUSOWOFGHWIHPZWKHPZQZWMWJWLRSZWLWJRSZUTZTZWNXBWMXCTXDTQZXFWTWJVAP
      WLVAPWMXGVBXAWTWJWTWJWEPWJVCPAWIBCDEVDBWJVEVFVGXAWLXAWLWEPWLVCPAWKBCDEVDB
      WLVEVFVGWJWLVHVIXCXDVKVJXBWNXEXBWNTWIWKPZWKWIPZUTZXEXBWNXJWTWIWAWKWAWNXJT
      VBXAWIVLWKVLWIWKVMVIVNXBXHXCXIXDAWIWKBCDEVOXAWTXIXDLAWKWIBCDEVOVPVQVRWBVS
      VTFGHWECWCOWSHWECWDO $.

    $( ` G ` (see ~ om2uz0i ) is an isomorphism from natural ordinals to upper
       integers.  (Contributed by NM, 9-Oct-2008.)  (Revised by Mario Carneiro,
       13-Sep-2013.) $)
    om2uzisoi $p |- G Isom _E , < ( om , ( ZZ>= ` C ) ) $=
      ( vy vz com cuz cfv cep clt wiso wf1o cv wbr wb wral om2uzf1oi wcel epel
      wa om2uzlt2i syl5bb rgen2a df-isom mpbir2an ) HBIJZKLCMHUHCNFOZGOZKPZUICJ
      UJCJLPZQZGHRFHRABCDESUMFGHUKUIUJTUIHTUJHTUBULFGUAAUIUJBCDEUCUDUEFGHUHKLCU
      FUG $.

    $( An alternative definition of ` G ` in terms of ~ df-oi .  (Contributed
       by Mario Carneiro, 2-Jun-2015.) $)
    om2uzoi $p |- G = OrdIso ( < , ( ZZ>= ` C ) ) $=
      ( com cuz cfv clt coi cdm wceq cep wa ordom wwe wb ax-mp mpbi cvv pm3.2i
      word wiso om2uzisoi wse ordwe isowe wcel fvex exse eqid oieu mp2an simpri
      ) FBGHZIJZKLZCUPLZFUBZFUOMICUCZNZUQURNZUSUTOABCDEUDZUAUOIPZUOIUEZVAVBQFMP
      ZVDUSVFOFUFRUTVFVDQVCFUOMICUGRSUOTUHVEBGUIUOITUJRUOFIUPCUPUKULUMSUN $.

    $d w x y z F $.  $d v w z R $.
    uzrdg.1 $e |- A e. _V $.
    uzrdg.2 $e |- R = ( rec ( ( x e. _V , y e. _V |->
      <. ( x + 1 ) , ( x F y ) >. ) , <. C , A >. ) |` om ) $.
    $( A helper lemma for the value of a recursive definition generator on
       upper integers (typically either ` NN ` or ` NN0 ` ) with characteristic
       function ` F ( x , y ) ` and initial value ` A ` .  Normally ` F ` is a
       function on the partition, and ` A ` is a member of the partition.  See
       also comment in ~ om2uz0i .  (Contributed by Mario Carneiro,
       26-Jun-2013.)  (Revised by Mario Carneiro, 18-Nov-2014.) $)
    om2uzrdg $p |- ( B e. om -> ( R ` B ) =
        <. ( G ` B ) , ( 2nd ` ( R ` B ) ) >. ) $=
      ( cfv c2nd cop wceq c0 fveq2 cvv co vz vv vw cv fveq2d opeq12d eqeq12d c1
      csuc caddc cmpt2 crdg com cres fveq1i wcel opex fr0g ax-mp om2uz0i fveq2i
      eqtri cz elexi op2nd opeq12i eqtr4i frsuc 3eqtr4g df-ov fvex oveq1 opeq2d
      wa oveq2 cbvmpt2v ovmpt2 mp2an eqtr3i syl6eq om2uzsuci adantr ovex eqtr4d
      sylan9eq ex finds ) UAUDZFMZWHHMZWINMZOZPQFMZQHMZWMNMZOZPUBUDZFMZWQHMZWRN
      MZOZPZWQUIZFMZXCHMZXDNMZOZPZDFMZDHMZXINMZOZPUAUBDWHQPZWIWMWLWPWHQFRZXMWJW
      NWKWOWHQHRXMWIWMNXNUEUFUGWHWQPZWIWRWLXAWHWQFRZXOWJWSWKWTWHWQHRXOWIWRNXPUE
      UFUGWHXCPZWIXDWLXGWHXCFRZXQWJXEWKXFWHXCHRXQWIXDNXRUEUFUGWHDPZWIXIWLXLWHDF
      RZXSWJXJWKXKWHDHRXSWIXINXTUEUFUGWMECOZWPWMQABSSAUDZUHUJTZYBBUDZGTZOZUKZYA
      ULUMUNZMZYAQFYHLUOYASUPYIYAPECUQYASYGURUSVBZWNEWOCAEHIJUTWOYANMCWMYANYJVA
      ECEVCIVDKVEVBVFVGWQUMUPZXBXHYKXBVNZXDWSUHUJTZWSWTGTZOZXGYKXBXDWRYGMZYOYKX
      CYHMWQYHMZYGMXDYPYAWQYGVHXCFYHLUOWRYQYGWQFYHLUOVAVIXBYPXAYGMZYOWRXAYGRWSW
      TYGTZYRYOWSWTYGVJWSSUPWTSUPYSYOPWQHVKWRNVKUCUAWSWTSSUCUDZUHUJTZYTWHGTZOZY
      OYGYMWSWHGTZOYTWSPUUAYMUUBUUDYTWSUHUJVLYTWSWHGVLUFWHWTPUUDYNYMWHWTWSGVOVM
      ABUCUASSYFUUCUUAYTYDGTZOYBYTPYCUUAYEUUEYBYTUHUJVLYBYTYDGVLUFYDWHPUUEUUBUU
      AYDWHYTGVOVMVPYMYNUQVQVRVSVTWEZYLXEYMXFYNYKXEYMPXBAWQEHIJWAWBYLXFYONMYNYL
      XDYONUUFUEYMYNWSUHUJWCWSWTGWCVEVTUFWDWFWG $.

    $( A helper lemma for the value of a recursive definition generator on
       upper integers.  (Contributed by Mario Carneiro, 26-Jun-2013.)  (Revised
       by Mario Carneiro, 18-Nov-2014.) $)
    uzrdglem $p |- ( B e. ( ZZ>= ` C ) ->
        <. B , ( 2nd ` ( R ` ( `' G ` B ) ) ) >. e. ran R ) $=
      ( cfv wcel cop com wceq mpan wfn cvv cuz ccnv c2nd crn om2uzf1oi f1ocnvdm
      wf1o om2uzrdg syl f1ocnvfv2 opeq1d eqtrd cv c1 caddc co cmpt2 crdg frfnom
      cres fneq1i mpbir fnfvelrn sylancr eqeltrrd ) DEUAMZNZDHUBMZFMZDVIUCMZOZF
      UDZVGVIVHHMZVJOZVKVGVHPNZVIVNQPVFHUGZVGVOAEHIJUEZPVFDHUFRZABCVHEFGHIJKLUH
      UIVGVMDVJVPVGVMDQVQPVFDHUJRUKULVGFPSZVOVIVLNVSABTTAUMZUNUOUPVTBUMGUPOUQZE
      COZURPUTZPSWBWAUSPFWCLVAVBVRPVHFVCVDVE $.

    $d v w z S $.
    uzrdg.3 $e |- S = ran R $.
    $( The recursive definition generator on upper integers is a function.  See
       comment in ~ om2uzrdg .  (Contributed by Mario Carneiro, 26-Jun-2013.)
       (Revised by Mario Carneiro, 4-May-2015.) $)
    uzrdgfni $p |- S Fn ( ZZ>= ` C ) $=
      ( vz vw cfv wceq wcel cvv com vv cuz wfn wfun cdm wrel cv cop wal wex cxp
      wi wss wrex crn eleq2i wb c1 caddc co cmpt2 crdg cres frfnom fneq1i mpbir
      fvelrnb ax-mp bitri c2nd om2uzrdg om2uzuzi fvex opelxpi sylancl syl5ibcom
      eqeltrd eleq1 rexlimiv sylbi ssriv sstri df-rel eqeq2 imbi2d albidv spcev
      xpss ccnv wa eqeq1d opth1 syl6bi wf1o om2uzf1oi f1ocnvfv mpan syld fveq2d
      fveq2 syl6 imp op2ndd adantl eqtr2d rexlimiva ax-gen dffun5 mpbir2an dmss
      vex mpg dmxpss uzrdglem syl6eleqr opeldm syl eqssi df-fn ) FDUBPZUCFUDZFU
      EZXTQYAFUFZUAUGZNUGZUHZFRZYEOUGZQZULZNUIZOUJZUAUIYCFSSUKZUMFXTSUKZYMNFYNY
      EFRZYHEPZYEQZOTUNZYEYNRZYOYEEUOZRZYRFYTYEMUPETUCZUUAYRUQUUBABSSAUGZURUSUT
      UUCBUGGUTUHVAZDCUHZVBTVCZTUCUUEUUDVDTEUUFLVEVFZOTYEEVGVHVIYQYSOTYHTRZYPYN
      RYQYSUUHYPYHHPZYPVJPZUHZYNABCYHDEGHIJKLVKZUUHUUIXTRUUJSRUUKYNRAYHDHIJVLYP
      VJVMZUUIUUJXTSVNVOVQYPYEYNVRVPVSVTWAZXTSWHWBFWCVFYLUAYGYEYDHWIPZEPZVJPZQZ
      ULZYLNYKUUSNUIOUUQUUPVJVMZYHUUQQZYJUUSNUVAYIUURYGYHUUQYEWDWEWFWGYGYPYFQZO
      TUNZUURYGYFYTRZUVCFYTYFMUPUUBUVDUVCUQUUGOTYFEVGVHVIUVBUUROTUUHUVBWJUUQUUJ
      YEUUHUVBUUQUUJQZUUHUVBUUOYHQZUVEUUHUVBUUIYDQZUVFUUHUVBUUKYFQUVGUUHYPUUKYF
      UULWKUUIUUJYDYEYHHVMUUMWLWMTXTHWNUUHUVGUVFULADHIJWOTXTYHYDHWPWQWRUVFUUPYP
      VJUUOYHEWTWSXAXBUVBUUJYEQUUHYDYEYPUAXKZNXKXCXDXEXFVTXLXGUANOFXHXIYBXTYBYN
      UEZXTFYNUMYBUVIUMUUNFYNXJVHXTSXMWBUAXTYBYDXTRZYDUUQUHZFRYDYBRUVJUVKYTFABC
      YDDEGHIJKLXNMXOYDUUQFUVHUUTXPXQWAXRFXTXSXI $.

    $( Initial value of a recursive definition generator on upper integers.
       See comment in ~ om2uzrdg .  (Contributed by Mario Carneiro,
       26-Jun-2013.)  (Revised by Mario Carneiro, 18-Nov-2014.) $)
    uzrdg0i $p |- ( S ` C ) = A $=
      ( cop wcel cfv wfn c0 cvv com wfun wceq cuz uzrdgfni fnfun ax-mp cv caddc
      c1 co cmpt2 crdg cres fveq1i opex fr0g eqtri frfnom fneq1i mpbir fnfvelrn
      crn peano1 mp2an eqeltrri eleqtrri funopfv mp2 ) FUAZDCNZFODFPCUBFDUCPZQV
      IABCDEFGHIJKLMUDVKFUEUFVJEVBZFREPZVJVLVMRABSSAUGZUIUHUJVNBUGGUJNUKZVJULTU
      MZPZVJREVPLUNVJSOVQVJUBDCUOVJSVOUPUFUQETQZRTOVMVLOVRVPTQVJVOURTEVPLUSUTVC
      TREVAVDVEMVFDCFVGVH $.

    $( Successor value of a recursive definition generator on upper integers.
       See comment in ~ om2uzrdg .  (Contributed by Mario Carneiro,
       26-Jun-2013.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    uzrdgsuci $p |- ( B e. ( ZZ>= ` C ) ->
        ( S ` ( B + 1 ) ) = ( B F ( S ` B ) ) ) $=
      ( cfv wcel c1 co cop wceq vz cuz caddc ccnv csuc c2nd wfun uzrdgfni fnfun
      wfn ax-mp crn peano2uz uzrdglem syl syl6eleqr funopfv mpsyl com om2uzf1oi
      vw wf1o f1ocnvdm mpan peano2 om2uzsuci f1ocnvfv2 oveq1d eqtrd wi f1ocnvfv
      sylc fveq2d cv cmpt2 crdg cres frsuc fveq1i fveq2i 3eqtr4g om2uzrdg df-ov
      syl6eqr fvex oveq1 opeq12d oveq2 opeq2d cbvmpt2v opex ovmpt2 mp2an syl6eq
      cvv ovex op2nd eqcomd oveq12d 3eqtrd ) DEUBOZPZDQUCRZGOZDIUDZOZUEZFOZUFOZ
      XFIOZXFFOZUFOZHRZDDGOZHRXBXDXCXEOZFOZUFOZXIGUGZXBXCXQSZGPXDXQTGXAUJXRABCE
      FGHIJKLMNUHXAGUIUKZXBXSFULZGXBXCXAPXSYAPEDUMABCXCEFHIJKLMUNUONUPXCXQGUQUR
      XBXPXHUFXBXOXGFXBXGUSPZXGIOZXCTZXOXGTZXBXFUSPZYBUSXAIVBZXBYFAEIJKUTZUSXAD
      IVCVDZXFVEUOXBYCXJQUCRZXCXBYFYCYJTYIAXFEIJKVFUOXBXJDQUCYGXBXJDTYHUSXADIVG
      VDZVHVIYGYBYDYEVJYHUSXAXGXCIVKVDVLVMVMVIXBYFXIXMTYIYFXIYJXMSZUFOXMYFXHYLU
      FYFXHXJXLABWOWOAVNZQUCRZYMBVNZHRZSZVOZRZYLYFXHXKYROZYSYFXGYRECSZVPUSVQZOX
      FUUBOZYROXHYTUUAXFYRVRXGFUUBMVSXKUUCYRXFFUUBMVSVTWAYFYTXJXLSZYROYSYFXKUUD
      YRABCXFEFHIJKLMWBVMXJXLYRWCWDVIXJWOPXLWOPYSYLTXFIWEXKUFWEUAVAXJXLWOWOUAVN
      ZQUCRZUUEVAVNZHRZSZYLYRYJXJUUGHRZSUUEXJTUUFYJUUHUUJUUEXJQUCWFUUEXJUUGHWFW
      GUUGXLTUUJXMYJUUGXLXJHWHWIABUAVAWOWOYQUUIUUFUUEYOHRZSYMUUETYNUUFYPUUKYMUU
      EQUCWFYMUUEYOHWFWGYOUUGTUUKUUHUUFYOUUGUUEHWHWIWJYJXMWKWLWMWNVMYJXMXJQUCWP
      XJXLHWPWQWNUOXBXJDXLXNHYKXBXNXLXRXBDXLSZGPXNXLTXTXBUULYAGABCDEFHIJKLMUNNU
      PDXLGUQURWRWSWT $.
  $}

  ${
    $d x y z A $.
    $( ` < ` is a well-founded relation on any sequence of upper integers.
       (Contributed by Andrew Salmon, 13-Nov-2011.)  (Revised by Mario
       Carneiro, 26-Jun-2015.) $)
    ltweuz $p |- < We ( ZZ>= ` A ) $=
      ( vx vy cuz cdm wcel cfv clt wwe cz com cep cvv cv wiso cc0 wceq wb syl
      c0 word ordom ordwe ax-mp c1 caddc co cmpt crdg cres ccnv cima wal wi cif
      rdgeq2 reseq1d isoeq1 fveq2 isoeq5 0z elimel om2uzisoi dedth2v isocnv cin
      eqid dmres inex1 eqeltri cnvimass ssexi ax-gen isowe2 sylancl mpi cpw uzf
      omex fdmi eleq2s wn we0 ndmfv weeq2 mpbiri pm2.61i ) ADEZFZADGZHIZWKAJWHA
      JFZKLIZWKKUAWMUBKUCUDWLWJKHLBMBNUEUFUGUHZAUIZKUJZUKZOZWQCNZULZMFZCUMWMWKU
      NWLKWJLHWPOZWRWLXBKWJLHWNWLAPUOZUIZKUJZOZKXCDGZLHXEOZAAPPAXCQZWPXEQXBXFRX
      IWOXDKAXCWNUPUQKWJLHXEWPURSXIWJXGQXFXHRAXCDUSKWJXGLHXEUTSBXCXEAPJVAVBXEVG
      VCVDKWJLHWPVESXACWTWPEZXJKWOEZVFMWOKVHKXKVSVIVJWPWSVKVLVMCWJKHLWQVNVOVPJJ
      VQDVRVTWAWIWBZWKTHIZHWCXLWJTQWKXMRADWDWJTHWESWFWG $.
  $}

  $( Less than well-orders the naturals.  (Contributed by Scott Fenton,
     6-Aug-2013.) $)
  ltwenn $p |- < We NN $=
    ( cn clt wwe c1 cuz cfv ltweuz wceq wb nnuz weeq2 ax-mp mpbir ) ABCZDEFZBCZ
    DGAOHNPIJAOBKLM $.

  $( Less than well-orders a set of finite integers.  (Contributed by Scott
     Fenton, 8-Aug-2013.) $)
  ltwefz $p |- < We ( M ... N ) $=
    ( cfz co cuz cfv wss clt wwe fzssuz ltweuz wess mp2 ) ABCDZAEFZGOHINHIABJAK
    NOHLM $.

  ${
    $d x M $.
    uzinf.1 $e |- Z = ( ZZ>= ` M ) $.
    $( An upper integer set is denumerable.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    uzenom $p |- ( M e. ZZ -> Z ~~ om ) $=
      ( vx cz wcel com cen wbr cc0 cif cuz cfv wceq fveq2 syl5eq breq1d cvv cv
      c1 caddc co cmpt crdg cres wf1o omex fvex 0z eqid om2uzf1oi f1oen2g mp3an
      elimel ensymi dedth ) AEFZBGHIUQAJKZLMZGHIAJAURNZBUSGHUTBALMUSCAURLOPQGUS
      GRFUSRFGUSDRDSTUAUBUCURUDGUEZUFGUSHIUGURLUHDURVAAJEUIUNVAUJUKGUSVARRULUMU
      OUP $.

    $( An upper integer set is infinite.  (Contributed by Mario Carneiro,
       12-Mar-2015.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    uzinf $p |- ( M e. ZZ -> -. Z e. Fin ) $=
      ( cz wcel cfn com ominf cen wbr wb uzenom enfi syl mtbiri ) ADEZBFEZGFEZH
      PBGIJQRKABCLBGMNO $.
  $}

  ${
    $d k x y A $.  $d k x y B $.  $d k y G $.  $d k y H $.  $d y N $.
    uzrdgxfr.1 $e |- G = ( rec ( ( x e. _V |-> ( x + 1 ) ) , A ) |` om ) $.
    uzrdgxfr.2 $e |- H = ( rec ( ( x e. _V |-> ( x + 1 ) ) , B ) |` om ) $.
    uzrdgxfr.3 $e |- A e. ZZ $.
    uzrdgxfr.4 $e |- B e. ZZ $.
    $( Transfer the value of the recursive sequence builder from one base to
       another.  (Contributed by Mario Carneiro, 1-Apr-2014.) $)
    uzrdgxfr $p |- ( N e. om ->
                     ( G ` N ) = ( ( H ` N ) + ( A - B ) ) ) $=
      ( cfv co caddc wceq c0 fveq2 oveq1d eqeq12d wcel c1 vy vk cv cmin csuc cz
      cc zcn ax-mp pncan3i om2uz0i oveq1i 3eqtr4ri com oveq1 om2uzsuci om2uzuzi
      cuz eluzelz syl zcnd ax-1cn subcli add32 mp3an23 eqtrd syl5ibr finds ) UA
      UCZDKZVIEKZBCUDLZMLZNODKZOEKZVLMLZNUBUCZDKZVQEKZVLMLZNZVQUEZDKZWBEKZVLMLZ
      NZFDKZFEKZVLMLZNUAUBFVIONZVJVNVMVPVIODPWJVKVOVLMVIOEPQRVIVQNZVJVRVMVTVIVQ
      DPWKVKVSVLMVIVQEPQRVIWBNZVJWCVMWEVIWBDPWLVKWDVLMVIWBEPQRVIFNZVJWGVMWIVIFD
      PWMVKWHVLMVIFEPQRCVLMLBVPVNCBCUFSCUGSJCUHUIZBUFSBUGSIBUHUIZUJVOCVLMACEJHU
      KULABDIGUKUMWAWFVQUNSZVRTMLZVTTMLZNVRVTTMUOWPWCWQWEWRAVQBDIGUPWPWEVSTMLZV
      LMLZWRWPWDWSVLMAVQCEJHUPQWPVSUGSZWTWRNZWPVSWPVSCURKSVSUFSAVQCEJHUQCVSUSUT
      VAXATUGSVLUGSXBVBBCWOWNVCVSTVLVDVEUTVFRVGVH $.
  $}

  ${
    $d m n G $.  $d n N $.  $d j k n $.
    fzennn.1 $e |- G = ( rec ( ( x e. _V |-> ( x + 1 ) ) , 0 ) |` om ) $.
    $( The cardinality of a finite set of sequential integers.  (See ~ om2uz0i
       for a description of the hypothesis.)  (Contributed by Mario Carneiro,
       12-Feb-2013.)  (Revised by Mario Carneiro, 7-Mar-2014.) $)
    fzennn $p |- ( N e. NN0 -> ( 1 ... N ) ~~ ( `' G ` N ) ) $=
      ( c1 cfz co cfv cen wbr cc0 caddc wceq oveq2 fveq2 breq12d com wcel cn0
      c0 vn vm cv ccnv 0ex enref fz10 cuz wa 0z om2uzf1oi peano1 pm3.2i om2uz0i
      wf1o f1ocnvfv mp2 3brtr4i csn cun cin simpr cvv ovex fvex en2sn mp2an a1i
      fzp1disj word f1ocnvdm mpan nn0uz eleq2s ordirr 3syl adantr disjsn sylibr
      wn nnord unen syl22anc cz cmin fveq2i eqtr4i eleq2i biimpi fzsuc2 sylancr
      1z 1m1e0 csuc peano2 jctil om2uzsuci f1ocnvfv2 oveq1d eqtrd df-suc syl6eq
      syl sylc 3brtr4d ex nn0ind ) EUAUCZFGZXHBUDZHZIJEKFGZKXJHZIJEUBUCZFGZXNXJ
      HZIJZEXNELGZFGZXRXJHZIJZECFGZCXJHZIJUAUBCXHKMXIXLXKXMIXHKEFNXHKXJOPXHXNMX
      IXOXKXPIXHXNEFNXHXNXJOPXHXRMXIXSXKXTIXHXREFNXHXRXJOPXHCMXIYBXKYCIXHCEFNXH
      CXJOPTTXLXMITUEUFUGQKUHHZBUOZTQRZUITBHKMXMTMYEYFAKBUJDUKZULUMAKBUJDUNQYDT
      KBUPUQURXNSRZXQYAYHXQUIZXOXRUSZUTZXPXPUSZUTZXSXTIYIXQYJYLIJZXOYJVATMZXPYL
      VATMZYKYMIJYHXQVBYNYIXRVCRXPVCRYNXNELVDXNXJVEXRXPVCVCVFVGVHYOYIEXNVIVHYIX
      PXPRVTZYPYHYQXQYHXPQRZXPVJYQYRXNYDSYEXNYDRZYRYGQYDXNBVKVLVMVNZXPWAXPVOVPV
      QXPXPVRVSXOXPYJYLWBWCYHXSYKMZXQYHEWDRXNEEWEGZUHHZRZUUAWLYHUUDSUUCXNSYDUUC
      VMUUBKUHWMWFWGWHWIEXNWJWKVQYIXTXPWNZYMYHXTUUEMZXQYHYEUUEQRZUIUUEBHZXRMUUF
      YHUUGYEYHYRUUGYTXPWOXCYGWPYHUUHXPBHZELGZXRYHYRUUHUUJMYTAXPKBUJDWQXCYHUUIX
      NELYHYEYSUUIXNMYGYHYSSYDXNVMWHWIQYDXNBWRWKWSWTQYDUUEXRBUPXDVQXPXAXBXEXFXG
      $.

    $( The cardinality of a finite set of sequential integers with arbitrary
       endpoints.  (Contributed by Mario Carneiro, 13-Feb-2014.) $)
    fzen2 $p |- ( N e. ( ZZ>= ` M ) ->
                  ( M ... N ) ~~ ( `' G ` ( ( N + 1 ) - M ) ) ) $=
      ( cfv wcel cfz co c1 caddc cmin cen wbr cz cc wceq ax-1cn zcn syl2anc cuz
      ccnv eluzel2 eluzelz 1z zsubcl sylancr fzen syl3anc zcnd pncan3 addsubass
      sylancl mp3an2 syl2an eqcomd oveq12d breqtrd cn0 peano2uz uznn0sub fzennn
      3syl entr ) DCUAFZGZCDHIZJDJKIZCLIZHIZMNVJVIBUBFZMNZVGVKMNVFVGCJCLIZKIZDV
      MKIZHIZVJMVFCOGZDOGZVMOGZVGVPMNCDUCZCDUDZVFJOGVQVSUEVTJCUFUGVMCDUHUIVFVNJ
      VOVIHVFCPGZJPGZVNJQVFCVTUJRCJUKUMVFVIVOVFVRVQVIVOQZWAVTVRDPGZWBWDVQDSCSWE
      WCWBWDRDJCULUNUOTUPUQURVFVHVEGVIUSGVLCDUTCVHVAABVIEVBVCVGVJVKVDT $.

    $( The cardinality of a finite set of sequential integers.  (See ~ om2uz0i
       for a description of the hypothesis.)  (Contributed by NM, 7-Nov-2008.)
       (Revised by Mario Carneiro, 15-Sep-2013.) $)
    cardfz $p |- ( N e. NN0 -> ( card ` ( 1 ... N ) ) = ( `' G ` N ) ) $=
      ( cn0 wcel c1 cfz ccrd cfv ccnv cen wbr wceq fzennn carden2b syl com cc0
      co cuz wf1o 0z om2uzf1oi elnn0uz biimpi f1ocnvdm sylancr cardnn eqtrd ) C
      EFZGCHTZIJZCBKJZIJZUNUKULUNLMUMUONABCDOULUNPQUKUNRFZUOUNNUKRSUAJZBUBCUQFZ
      UPASBUCDUDUKURCUEUFRUQCBUGUHUNUIQUJ $.

    $( ` G ` maps ` om ` one-to-one onto ` NN0 ` .  (Contributed by Paul
       Chapman, 22-Jun-2011.)  (Revised by Mario Carneiro, 13-Sep-2013.) $)
    hashgf1o $p |- G : om -1-1-onto-> NN0 $=
      ( com cn0 wf1o cc0 cuz cfv 0z om2uzf1oi wceq wb nn0uz f1oeq3 ax-mp mpbir
      ) DEBFZDGHIZBFZAGBJCKESLRTMNESDBOPQ $.
  $}

  ${
    $d M n $.  $d N n $.
    $( A finite interval of integers is finite.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 12-Mar-2015.) $)
    fzfi $p |- ( M ... N ) e. Fin $=
      ( vx cfz co cfn wcel c0 wceq 0fin eleq1 mpbiri wne cuz cfv caddc com con0
      c1 cn0 fzn0 cmin cvv cv cmpt cc0 crdg cres ccnv cen wbr cin inss2 eqsstri
      onfin2 wf1o eqid hashgf1o peano2uz uznn0sub f1ocnvdm sylancr sseldi fzen2
      syl enfii syl2anc sylbi pm2.61ine ) ABDEZFGZVJHVJHIVKHFGJVJHFKLVJHMBANOZG
      ZVKABUAVMBSPEZAUBEZCUCCUDSPEUEUFUGQUHZUIOZFGVJVQUJUKVKVMQFVQQRFULFUORFUMU
      NVMQTVPUPVOTGZVQQGCVPVPUQZURVMVNVLGVRABUSAVNUTVEQTVOVPVAVBVCCVPABVSVDVJVQ
      VFVGVHVI $.
  $}

  $( Commonly used special case of ~ fzfi .  (Contributed by Mario Carneiro,
     25-May-2014.) $)
  fzfid $p |- ( ph -> ( M ... N ) e. Fin ) $=
    ( cfz co cfn wcel fzfi a1i ) BCDEFGABCHI $.

  $( Half-open integer sets are finite.  (Contributed by Stefan O'Rear,
     15-Aug-2015.) $)
  fzofi $p |- ( M ..^ N ) e. Fin $=
    ( cz wcel wa cfzo co cfn c1 cmin cfz wceq fzoval adantl fzfi syl6eqel wn c0
    cxp cpw fzof fdmi ndmov 0fin pm2.61i ) ACDZBCDZEZABFGZHDUHUIABIJGZKGZHUGUIU
    KLUFABMNAUJOPUHQUIRHABCFCCSCTFUAUBUCUDPUE $.

  ${
    $d j k m n x y F $.  $d j k m n x y M $.  $d j k n x y N $.
    $( The values of a finite real sequence have an upper bound.  (Contributed
       by NM, 19-Sep-2005.)  (Proof shortened by Mario Carneiro,
       28-Apr-2015.) $)
    fsequb $p |- ( A. k e. ( M ... N ) ( F ` k ) e. RR
                 -> E. x e. RR A. k e. ( M ... N ) ( F ` k ) < x ) $=
      ( vy cv cfv cr wcel cfz co wral cle wbr wrex clt wi wa adantr fzfi r19.26
      cfn fimaxre3 mpan caddc peano2re ltp1 simpr lelttr syl3anc mpan2d expimpd
      c1 simpl ralimdv wceq breq2 ralbidv rspcev ee12an syl5bir exp3a rexlimdva
      impcom mpd ) BGCHZIJZBDEKLZMZVGFGZNOZBVIMZFIPZVGAGZQOZBVIMZAIPZVIUCJVJVND
      EUAFBVIVGUDUEVJVMVRFIVKIJZVJVMVRRVSVJVMVRVJVMSVHVLSZBVIMZVSVRVHVLBVIUBVSV
      KUNUFLZIJZWAVGWBQOZBVIMZVRVKUGZVSVTWDBVIVSVHVLWDVSVHSZVLVKWBQOZWDVSWHVHVK
      UHTWGVHVSWCVLWHSWDRVSVHUIVSVHUOVSWCVHWFTVGVKWBUJUKULUMUPVQWEAWBIVOWBUQVPW
      DBVIVOWBVGQURUSUTVAVBVCVEVDVF $.

    $( The values of a finite real sequence have an upper bound.  (Contributed
       by NM, 20-Sep-2005.)  (Proof shortened by Mario Carneiro,
       28-Apr-2015.) $)
    fsequb2 $p |- ( F : ( M ... N ) --> RR ->
                  E. x e. RR A. y e. ran F y <_ x ) $=
      ( vk cfz co cr wf cv cle wbr crn wral wrex cfv cfn wcel fzfi fimaxre3 wfn
      ffvelrn ralrimiva sylancr wb ffn breq1 ralrn syl rexbidv mpbird ) DEGHZIC
      JZBKZAKZLMZBCNOZAIPFKZCQZUPLMZFUMOZAIPZUNUMRSUTISZFUMOVCDETUNVDFUMUMIUSCU
      CUDAFUMUTUAUEUNURVBAIUNCUMUBURVBUFUMICUGUQVABFUMCUOUTUPLUHUIUJUKUL $.

    $( The values of a finite real sequence have a supremum.  (Contributed by
       NM, 20-Sep-2005.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
    fseqsupcl $p |- ( ( N e. ( ZZ>= ` M ) /\ F : ( M ... N ) --> RR )
                 -> sup ( ran F , RR , < ) e. RR ) $=
      ( cuz cfv wcel cfz co cr wf wa crn clt csup wss adantl cfn c0 wne sylib
      frn wfo fzfi wfn ffn dffn4 fofi sylancr cdm wceq fdm simpl sylibr eqnetrd
      fzn0 dm0rn0 necon3bii wor w3a ltso fisupcl mpan syl3anc sseldd ) CBDEFZBC
      GHZIAJZKZALZIVIIMNZVGVIIOZVEVFIAUAPZVHVIQFZVIRSZVKVJVIFZVHVFQFVFVIAUBZVMB
      CUCVHAVFUDZVPVGVQVEVFIAUEPVFAUFTVFVIAUGUHVHAUIZRSVNVHVRVFRVGVRVFUJVEVFIAU
      KPVHVEVFRSVEVGULBCUOUMUNVRRVIRAUPUQTVLIMURVMVNVKUSVOUTIVIMVAVBVCVD $.

    $( The values of a finite real sequence are bounded by their supremum.
       (Contributed by NM, 20-Sep-2005.) $)
    fseqsupubi $p |- ( ( K e. ( M ... N ) /\ F : ( M ... N ) --> RR ) ->
               ( F ` K ) <_ sup ( ran F , RR , < ) ) $=
      ( vy vx cfz co wcel cr wf wa c0 wne cv cle wbr adantl wceq sylan2 crn wss
      wral wrex cfv clt csup frn cdm fdm ne0i dm0rn0 eqeq1 biimpd syl5bir mpan9
      necon3d fsequb2 wfn ffn fnfvelrn ancoms suprub syl31anc ) BCDGHZIZVEJAKZL
      AUAZJUBZVHMNZEOFOPQEVHUCFJUDZBAUEZVHIZVLVHJUFUGPQVGVIVFVEJAUHRVGVFAUIZVES
      ZVJVEJAUJVFVEMNVOVJVEBUKVOVHMVEMVHMSVNMSZVOVEMSZAULVOVPVQVNVEMUMUNUOUQUPT
      VGVKVFFEACDURRVGVFAVEUSZVMVEJAUTVRVFVMVEBAVAVBTFEVHVLVCVD $.
  $}

  ${
    $d x y z $.
    $( The nonnegative integers are equinumerous to the natural numbers.
       (Contributed by NM, 19-Jul-2004.) $)
    nn0ennn $p |- NN0 ~~ NN $=
      ( vx vy cn cv c1 caddc co cmin nn0ex nnex nn0p1nn nnm1nn0 wcel cc wceq wb
      cn0 nncn ax-1cn eqcom nn0cn wa subadd mp3an2 3bitr4g addcom eqeq2d adantl
      mpan bitrd syl2anr en3i ) ABQCADZEFGZBDZEHGZIJUMKUOLUOCMUONMZUMNMZUMUPOZU
      OUNOZPUMQMUORUMUAUQURUBZUSUOEUMFGZOZUTVAUPUMOZVBUOOZUSVCUQENMZURVDVEPSUOE
      UMUCUDUMUPTUOVBTUEURVCUTPUQURVBUNUOVFURVBUNOSEUMUFUIUGUHUJUKUL $.

    $( The set of natural numbers (as a subset of complex numbers) is
       equinumerous to omega (the set of finite ordinal numbers).  (Contributed
       by NM, 31-Jul-2004.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    nnenom $p |- NN ~~ om $=
      ( vx com cn0 cn cvv wcel cv c1 caddc cmpt cc0 crdg cres wf1o cen wbr omex
      co nn0ex eqid hashgf1o f1oen2g mp3an nn0ennn entr2i ) BCDBEFCEFBCAEAGHIRJ
      KLBMZNBCOPQSAUFUFTUABCUFEEUBUCUDUE $.
  $}

  ${
    $d x y L $.  $d x A $.  $d x S $.  $d x y T $.  $d x ch $.  $d x y ph $.
    $d x th $.  $d y R $.  $d y ps $.
    uzindi.a $e |- ( ph -> A e. V ) $.
    uzindi.b $e |- ( ph -> T e. ( ZZ>= ` L ) ) $.
    uzindi.c $e |- ( ( ph /\ R e. ( L ... T ) /\
          A. y ( S e. ( L ..^ R ) -> ch ) ) -> ps ) $.
    uzindi.d $e |- ( x = y -> ( ps <-> ch ) ) $.
    uzindi.e $e |- ( x = A -> ( ps <-> th ) ) $.
    uzindi.f $e |- ( x = y -> R = S ) $.
    uzindi.g $e |- ( x = A -> R = T ) $.
    $( Indirect strong induction on the upper integers.  (Contributed by Stefan
       O'Rear, 25-Aug-2015.) $)
    uzindi $p |- ( ph -> th ) $=
      ( wcel cfz co cuz cfv eluzfz2 syl wi cfzo cfn ccrd fzofi finnum mp1i csdm
      cdm wbr wal cdom wa simpll simpr wss elfzuz3 adantl fzoss2 fzossfz syl6ss
      sselda wpss wn elfzofz 3syl fzonel jctr ssnelpss sylc sylancr id com13 ex
      php3 com23 alimdv imp31 syl3anc 3adant2 weq eleq1d imbi12d cv wceq oveq2d
      indcardi mpd ) AJKJUAUBZTZDAJKUCUDTWPNKJUEUFAHWOTZBUGZIWOTZCUGZWPDUGEFGKH
      UHUBZKIUHUBZKJUHUBZLMXCUITXCUJUOTAKJUKXCULUMAXBXAUNUPZWTUGZFUQZWRXAXCURUP
      AXFUSZWQBXGWQUSAWQIXATZCUGZFUQZBAXFWQUTXGWQVAAXFWQXJAWQXFXJAWQXFXJUGAWQUS
      ZXEXIFXKXHXECXKXHXECUGZXKXHUSZWSXDXLXKXAWOIXKJHUCUDTZXAWOVBWQXNAHKJVCVDXN
      XAXCWOHKJVEKJVFVGUFVHXMXAUITXBXAVIZXDKHUKXMXBXAVBZXHIXBTVJZUSZXOXMIKHUAUB
      TZHIUCUDTXPXHXSXKIKHVKVDIKHVCIKHVEVLXHXRXKXHXQKIVMVNVDXBXAIVOVPXAXBWAVQXE
      XDWSCXEVRVSVPVTWBWCVTWBWDOWEVTWFEFWGZWQWSBCXTHIWORWHPWIEWJGWKZWQWPBDYAHJW
      OSWHQWIXTHIKUHRWLYAHJKUHSWLWMWN $.
  $}

  ${
    $d f g k m n x A $.  $d f g m C $.  $d f g k n x F $.  $d f g k n x y M $.
    $d f g n x Z $.
    axdc4uz.1 $e |- M e. ZZ $.
    axdc4uz.2 $e |- Z = ( ZZ>= ` M ) $.
    ${
      $d g k m n x G $.  $d f k m H $.
      axdc4uz.3 $e |- A e. _V $.
      axdc4uz.4 $e |- G = ( rec ( ( y e. _V |-> ( y + 1 ) ) , M ) |` om ) $.
      axdc4uz.5 $e |- H = ( n e. om , x e. A |-> ( ( G ` n ) F x ) ) $.
      $( Lemma for ~ axdc4uz .  (Contributed by Mario Carneiro, 8-Jan-2014.)
         (Revised by Mario Carneiro, 26-Dec-2014.) $)
      axdc4uzlem $p |- ( ( C e. A /\ F : ( Z X. A ) --> ( ~P A \ { (/) } ) ) ->
                E. g ( g : Z --> A /\ ( g ` M ) = C /\
                  A. k e. Z ( g ` ( k + 1 ) ) e. ( k F ( g ` k ) ) ) ) $=
        ( wcel com cfv vf vm cxp cpw c0 csn cdif wf wa cv wceq csuc co wral w3a
        wex c1 caddc wf1o om2uzf1oi wb f1oeq3 ax-mp mpbir f1of ffvelrni syl3an2
        cuz fovrn 3expb ralrimivva fmpt2 sylib sylan2 ccnv ccom f1ocnv mp2b fco
        axdc4 mpan2 3ad2ant1 cz eleqtrri fvco3 mp2an om2uz0i wi peano1 f1ocnvfv
        uzid fveq2i eqtri simp2 syl5eq adantl suceq fveq2 oveq12d eleq12d rspcv
        fveq2d id syl peano2uzs sylancr om2uzsuci f1ocnvfv2 oveq1d eqtrd peano2
        mpd eqtr2d ffvelrn oveq2 ovmpt2 syl2anc eqcomd sylibd impancom ralrimiv
        mpan ovex 3adant2 vex cmpt crdg cres wfun rdgfun omex resfunexg eqeltri
        cvv cnvex coex feq1 fveq1 eqeq1d oveq2d ralbidv 3anbi123d spcev syl3anc
        exlimiv ) DCRZLCUCCUDUEUFUGZHUHZUISCUAUJZUHZUEUUITZDUKZUBUJZULZUUITZUUM
        UUMUUITZJUMZRZUBSUNZUOZUAUPZLCEUJZUHZKUVBTZDUKZFUJZUQURUMZUVBTZUVFUVFUV
        BTZHUMZRZFLUNZUOZEUPZUUHUUFSCUCUUGJUHZUVAUUHGUJZITZAUJZHUMZUUGRZACUNGSU
        NUVOUUHUVTGASCUUHUVPSRZUVRCRZUVTUWAUUHUVQLRUWBUVTSLUVPISLIUSZSLIUHUWCSK
        VHTZIUSZBKIMPUTLUWDUKUWCUWEVANLUWDSIVBVCVDZSLIVEVCVFUVQUVRUUGLCHVIVGVJV
        KGASCUVSUUGJQVLVMCDUAUBJOVTVNUUTUVNUAUUTLCUUIIVOZVPZUHZKUWHTZDUKZUVGUWH
        TZUVFUVFUWHTZHUMZRZFLUNZUVNUUJUULUWIUUSUUJLSUWGUHZUWIUWCLSUWGUSUWQUWFSL
        IVQLSUWGVEVRZLSCUUIUWGVSWAWBUUTUWJUUKDUWJKUWGTZUUITZUUKUWQKLRUWJUWTUKUW
        RKUWDLKWCRKUWDRMKWKVCNWDLSKUUIUWGWEWFUWSUEUUIUEITKUKZUWSUEUKZBKIMPWGUWC
        UESRUXAUXBWHUWFWISLUEKIWJWFVCWLWMUUJUULUUSWNWOUUJUUSUWPUULUUJUUSUIUWOFL
        UUJUVFLRZUUSUWOUUJUXCUIZUUSUVFUWGTZULZUUITZUXEUXEUUITZJUMZRZUWOUXDUXESR
        ZUUSUXJWHUXCUXKUUJLSUVFUWGUWRVFZWPZUURUXJUBUXESUUMUXEUKZUUOUXGUUQUXIUXN
        UUNUXFUUIUUMUXEWQXBUXNUUMUXEUUPUXHJUXNXCUUMUXEUUIWRWSWTXAXDUXDUXGUWLUXI
        UWNUXCUXGUWLUKUUJUXCUWLUVGUWGTZUUITZUXGUXCUWQUVGLRUWLUXPUKUWRKUVFLNXELS
        UVGUUIUWGWEXFUXCUXOUXFUUIUXCUXFITZUVGUKZUXOUXFUKZUXCUXQUXEITZUQURUMZUVG
        UXCUXKUXQUYAUKUXLBUXEKIMPXGXDUXCUXTUVFUQURUWCUXCUXTUVFUKUWFSLUVFIXHYBZX
        IXJUXCUWCUXFSRZUXRUXSWHUWFUXCUXKUYCUXLUXEXKXDSLUXFUVGIWJXFXLXBXMWPUXDUX
        IUXTUXHHUMZUWNUXDUXKUXHCRZUXIUYDUKUXMUXCUUJUXKUYEUXLSCUXEUUIXNVNGAUXEUX
        HSCUVSUYDJUXTUVRHUMUVPUXEUKUVQUXTUVRHUVPUXEIWRXIUVRUXHUXTHXOQUXTUXHHYCX
        PXQUXCUYDUWNUKUUJUXCUXTUVFUXHUWMHUYBUXCUWMUXHUWQUXCUWMUXHUKUWRLSUVFUUIU
        WGWEYBXRWSWPXJWTXSXTYAYDUVMUWIUWKUWPUOEUWHUUIUWGUAYEIIBYNBUJUQURUMYFZKY
        GZSYHZYNPUYGYISYNRUYHYNRKUYFYJYKUYGSYNYLWFYMYOYPUVBUWHUKZUVCUWIUVEUWKUV
        LUWPLCUVBUWHYQUYIUVDUWJDKUVBUWHYRYSUYIUVKUWOFLUYIUVHUWLUVJUWNUVGUVBUWHY
        RUYIUVIUWMUVFHUVFUVBUWHYRYTWTUUAUUBUUCUUDUUEXD $.
    $}

    $( A version of ~ axdc4 that works on a set of upper integers instead of
       ` om ` .  (Contributed by Mario Carneiro, 8-Jan-2014.) $)
    axdc4uz $p |- ( ( A e. V /\ C e. A /\
                    F : ( Z X. A ) --> ( ~P A \ { (/) } ) ) ->
                E. g ( g : Z --> A /\ ( g ` M ) = C /\
                  A. k e. Z ( g ` ( k + 1 ) ) e. ( k F ( g ` k ) ) ) ) $=
      ( vf vx vy vn wcel cxp wf cv cfv co cpw c0 csn cdif wceq c1 caddc w3a wex
      wral wa wi eleq2 xpeq2 pweq difeq1d feq23d anbi12d 3anbi1d exbidv imbi12d
      feq3 cvv cmpt crdg com cres cmpt2 vex eqid axdc4uzlem vtoclg 3impib ) AGO
      BAOZHAPZAUAZUBUCZUDZEQZHACRZQZFVTSBUEZDRZUFUGTVTSWCWCVTSETODHUJZUHZCUIZBK
      RZOZHWGPZWGUAZVQUDZEQZUKZHWGVTQZWBWDUHZCUIZULVNVSUKZWFULKAGWGAUEZWMWQWPWF
      WRWHVNWLVSWGABUMWRWIWKVOVREWGAHUNWRWJVPVQWGAUOUPUQURWRWOWECWRWNWAWBWDWGAH
      VTVBUSUTVALMWGBCDNEMVCMRUFUGTVDFVEVFVGZNLVFWGNRWSSLRETVHZFHIJKVIWSVJWTVJV
      KVLVM $.
  $}

  $c seq $.
  $( Extend class notation with recursive sequence builder. $)
  cseq $a class seq M ( .+ , F ) $.

  ${
    $d .+ x y $.  $d F x y $.  $d M x y $.
    $( Define a general-purpose operation that builds a recursive sequence
       (i.e. a function on the natural numbers ` NN ` or some other upper
       integer set) whose value at an index is a function of its previous value
       and the value of an input sequence at that index.  This definition is
       complicated, but fortunately it is not intended to be used directly.
       Instead, the only purpose of this definition is to provide us with an
       object that has the properties expressed by ~ seq1 and ~ seqp1 .
       Typically, those are the main theorems that would be used in practice.

       The first operand in the parentheses is the operation that is applied to
       the previous value and the value of the input sequence (second
       operand).  The operand to the left of the parenthesis is the integer to
       start from.  For example, for the operation ` + ` , an input sequence
       ` F ` with values 1, 1/2, 1/4, 1/8,... would be transformed into the
       output sequence ` seq 1 ( + , F ) ` with values 1, 3/2, 7/4, 15/8,.., so
       that ` ( seq 1 ( + , F ) `` 1 ) = 1 ` , ` ( seq 1 ( + , F ) `` 2 ) = `
       3/2, etc.  In other words, ` seq M ( + , F ) ` transforms a sequence
       ` F ` into an infinite series. ` seq M ( + , F ) ~~> 2 ` means "the sum
       of F(n) from n = M to infinity is 2."  Since limits are unique
       ( ~ climuni ), by ~ climdm the "sum of F(n) from n = 1 to infinity" can
       be expressed as ` ( ~~> `` seq 1 ( + , F ) ) ` (provided the sequence
       converges) and evaluates to 2 in this example.

       Internally, the ` rec ` function generates as its values a set of
       ordered pairs starting at ` <. M , ( F `` M ) >. ` , with the first
       member of each pair incremented by one in each successive value.  So,
       the range of ` rec ` is exactly the sequence we want, and we just
       extract the range (restricted to omega) and throw away the domain.

       This definition has its roots in a series of theorems from ~ om2uz0i
       through ~ om2uzf1oi , originally proved by Raph Levien for use with
       ~ df-exp and later generalized for arbitrary recursive sequences.
       Definition ~ df-sum extracts the summation values from partial (finite)
       and complete (infinite) series.  (Contributed by NM, 18-Apr-2005.)
       (Revised by Mario Carneiro, 4-Sep-2013.) $)
    df-seq $a |- seq M ( .+ , F ) = ( rec (
       ( x e. _V , y e. _V |-> <. ( x + 1 ) , ( y .+ ( F ` ( x + 1 ) ) ) >. ) ,
          <. M , ( F ` M ) >. ) " om ) $.
  $}

  ${
    $d x y F $.  $d x y .+ $.  $d x y G $.  $d x y M $.  $d x y N $.
    $d x y Q $.
    $( Existence of the sequence builder operation.  (Contributed by Mario
       Carneiro, 4-Sep-2013.) $)
    seqex $p |- seq M ( .+ , F ) e. _V $=
      ( vx vy cseq cvv cv c1 caddc cfv cop cmpt2 crdg com cima df-seq wfun wcel
      co rdgfun omex funimaexg mp2an eqeltri ) ABCFDEGGDHIJTZEHUFBKATLMZCCBKLZN
      ZOPZGDEABCQUIROGSUJGSUHUGUAUBUIOGUCUDUE $.

    $( Equality theorem for the sequence builder operation.  (Contributed by
       Mario Carneiro, 4-Sep-2013.) $)
    seqeq1 $p |- ( M = N -> seq M ( .+ , F ) = seq N ( .+ , F ) ) $=
      ( vx vy wceq cvv cv c1 caddc co cfv cop cmpt2 crdg com cima cseq df-seq
      fveq2 opeq12 mpdan rdgeq2 syl imaeq1d 3eqtr4g ) CDGZEFHHEIJKLZFIUIBMALNOZ
      CCBMZNZPZQRUJDDBMZNZPZQRABCSABDSUHUMUPQUHULUOGZUMUPGUHUKUNGUQCDBUACUKDUNU
      BUCULUOUJUDUEUFEFABCTEFABDTUG $.

    $( Equality theorem for the sequence builder operation.  (Contributed by
       Mario Carneiro, 4-Sep-2013.) $)
    seqeq2 $p |- ( .+ = Q -> seq M ( .+ , F ) = seq M ( Q , F ) ) $=
      ( vx vy wceq cvv cv c1 caddc co cfv cop cmpt2 crdg com cima cseq df-seq
      eqidd oveq opeq2d mpt2eq123dv rdgeq1 syl imaeq1d 3eqtr4g ) ABGZEFHHEIJKLZ
      FIZUJCMZALZNZOZDDCMNZPZQREFHHUJUKULBLZNZOZUPPZQRACDSBCDSUIUQVAQUIUOUTGUQV
      AGUIEFHHUNHHUSUIHUAZVBUIUMURUJUKULABUBUCUDUPUOUTUEUFUGEFACDTEFBCDTUH $.

    $( Equality theorem for the sequence builder operation.  (Contributed by
       Mario Carneiro, 4-Sep-2013.) $)
    seqeq3 $p |- ( F = G -> seq M ( .+ , F ) = seq M ( .+ , G ) ) $=
      ( vx vy wceq cvv cv cfv cop cmpt2 crdg com cima cseq fveq1 opeq2d df-seq
      co c1 caddc eqidd oveq2d mpt2eq123dv rdgeq12 syl2anc imaeq1d 3eqtr4g ) BC
      GZEFHHEIUAUBTZFIZUKBJZATZKZLZDDBJZKZMZNOEFHHUKULUKCJZATZKZLZDDCJZKZMZNOAB
      DPACDPUJUSVFNUJUPVCGURVEGUSVFGUJEFHHUOHHVBUJHUCZVGUJUNVAUKUJUMUTULAUKBCQU
      DRUEUJUQVDDDBCQRURVEUPVCUFUGUHEFABDSEFACDSUI $.
  $}

  ${
    seqeqd.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for the sequence builder operation.  (Contributed by
       Mario Carneiro, 7-Sep-2013.) $)
    seqeq1d $p |- ( ph -> seq A ( .+ , F ) = seq B ( .+ , F ) ) $=
      ( wceq cseq seqeq1 syl ) ABCGDEBHDECHGFDEBCIJ $.

    $( Equality deduction for the sequence builder operation.  (Contributed by
       Mario Carneiro, 7-Sep-2013.) $)
    seqeq2d $p |- ( ph -> seq M ( A , F ) = seq M ( B , F ) ) $=
      ( wceq cseq seqeq2 syl ) ABCGBDEHCDEHGFBCDEIJ $.

    $( Equality deduction for the sequence builder operation.  (Contributed by
       Mario Carneiro, 7-Sep-2013.) $)
    seqeq3d $p |- ( ph -> seq M ( .+ , A ) = seq M ( .+ , B ) ) $=
      ( wceq cseq seqeq3 syl ) ABCGDBEHDCEHGFDBCEIJ $.
  $}

  ${
    seqeq123d.1 $e |- ( ph -> M = N ) $.
    seqeq123d.2 $e |- ( ph -> .+ = Q ) $.
    seqeq123d.3 $e |- ( ph -> F = G ) $.
    $( Equality deduction for the sequence builder operation.  (Contributed by
       Mario Carneiro, 7-Sep-2013.) $)
    seqeq123d $p |- ( ph -> seq M ( .+ , F ) = seq N ( Q , G ) ) $=
      ( cseq seqeq1d seqeq2d seqeq3d 3eqtrd ) ABDFKBDGKCDGKCEGKAFGBDHLABCDGIMAD
      ECGJNO $.
  $}

  ${
    $d w x y z $.  $d w y z F $.  $d w y z .+ $.  $d w y z M $.
    nfseq.1 $e |- F/_ x M $.
    nfseq.2 $e |- F/_ x .+ $.
    nfseq.3 $e |- F/_ x F $.
    $( Hypothesis builder for the sequence builder operation.  (Contributed by
       Mario Carneiro, 24-Jun-2013.)  (Revised by Mario Carneiro,
       15-Oct-2016.) $)
    nfseq $p |- F/_ x seq M ( .+ , F ) $=
      ( vz vw cseq cvv cv c1 co cfv cop com nfcv nffv nfop caddc crdg cima nfov
      cmpt2 df-seq nfmpt2 nfrdg nfima nfcxfr ) ABCDJHIKKHLMUANZILZUKCOZBNZPZUEZ
      DDCOZPZUBZQUCHIBCDUFAUSQAURUPHIAKKUOAKRZUTAUKUNAUKRZAULUMBAULRFAUKCGVASUD
      TUGADUQEADCGESTUHAQRUIUJ $.
  $}

  ${
    $d F m w x y z $.  $d .+ m w x y z $.  $d M m x y $.  $d R m $.
    seqval.1 $e |- R = ( rec (
        ( x e. _V , y e. _V |-> <. ( x + 1 ) ,
          ( x ( z e. _V , w e. _V |-> ( w .+ ( F ` ( z + 1 ) ) ) ) y ) >. ) ,
          <. M , ( F ` M ) >. ) |` om ) $.
    $( Value of the sequence builder function.  (Contributed by Mario Carneiro,
       24-Jun-2013.) $)
    seqval $p |- seq M ( .+ , F ) = ran R $=
      ( cvv cv c1 caddc co cfv cop cmpt2 crdg com wceq cima cres cseq eqid wcel
      crn df-ima df-seq oveq1 fveq2d oveq2d ovex ovmpt2 mp2an opeq2i mpt2eq123i
      vex rdgeq1 ax-mp reseq1i eqtri rneqi 3eqtr4i ) ABJJAKZLMNZBKZVEGOZENZPZQZ
      HHGOPZRZSUAVLSUBZUFEGHUCFUFVLSUGABEGHUHFVMFABJJVEVDVFCDJJDKZCKZLMNZGOZENZ
      QZNZPZQZVKRZSUBVMIWCVLSWBVJTWCVLTABJJWAJJVIJUDZWDVTVHVEVDJUEVFJUEVTVHTAUQ
      BUQCDVDVFJJVRVHVSVNVGENVOVDTZVQVGVNEWEVPVEGVOVDLMUIUJUKVNVFVGEUIVSUDVFVGE
      ULUMUNUOUPVKWBVJURUSUTVAVBVC $.
  $}

  ${
    $d w x y z F $.  $d w x y z .+ $.  $d x y M $.
    $( The sequence builder function is a function.  (Contributed by Mario
       Carneiro, 24-Jun-2013.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    seqfn $p |- ( M e. ZZ -> seq M ( .+ , F ) Fn ( ZZ>= ` M ) ) $=
      ( vx vy vz vw cz cseq cuz cfv wfn cc0 cvv cv c1 caddc co cmpt2 cop seqeq1
      wcel cif wceq fveq2 fneq12d crdg com cres cmpt 0z elimel eqid fvex seqval
      uzrdgfni dedth ) CHUBZABCIZCJKZLABURCMUCZIZVAJKZLCMCVAUDUTVCUSVBABCVAUACV
      AJUEUFDEVABKZVADENNDOZPQRZVEEOFGNNGOFOPQRBKARSZRTSVAVDTUGUHUIZVBVGDNVFUJV
      AUGUHUIZCMHUKULVIUMVABUNVHUMZDEFGAVHBVAVJUOUPUQ $.
  $}

  ${
    $d w x y z F $.  $d w x y z .+ $.  $d x y M $.
    $( Value of the sequence builder function at its initial value.
       (Contributed by Mario Carneiro, 24-Jun-2013.)  (Revised by Mario
       Carneiro, 15-Sep-2013.) $)
    seq1 $p |- ( M e. ZZ ->
        ( seq M ( .+ , F ) ` M ) = ( F ` M ) ) $=
      ( vx vy vz vw cz cseq cfv wceq cc0 cvv cv c1 caddc co cmpt2 cop crdg wcel
      cif seqeq1 id fveq12d fveq2 eqeq12d com cres cmpt elimel eqid fvex seqval
      0z uzrdg0i dedth ) CHUAZCABCIZJZCBJZKURCLUBZABVBIZJZVBBJZKCLCVBKZUTVDVAVE
      VFCVBUSVCABCVBUCVFUDUECVBBUFUGDEVEVBDEMMDNZOPQZVGENFGMMGNFNOPQBJAQRZQSRVB
      VESTUHUIZVCVIDMVHUJVBTUHUIZCLHUOUKVKULVBBUMVJULZDEFGAVJBVBVLUNUPUQ $.
  $}

  ${
    seq1i.1 $e |- M e. ZZ $.
    seq1i.2 $e |- ( ph -> ( F ` M ) = A ) $.
    $d w x y z F $.  $d w x y z .+ $.  $d x y M $.
    $( Value of the sequence builder function at its initial value.
       (Contributed by Mario Carneiro, 30-Apr-2014.) $)
    seq1i $p |- ( ph -> ( seq M ( .+ , F ) ` M ) = A ) $=
      ( cseq cfv cz wcel wceq seq1 ax-mp syl5eq ) AECDEHIZEDIZBEJKPQLFCDEMNGO
      $.
  $}

  ${
    $d x y z w .+ $.  $d x y z w F $.  $d x y z w M $.  $d z w N $.
    $( Value of the sequence builder function at a successor.  (Contributed by
       Mario Carneiro, 24-Jun-2013.)  (Revised by Mario Carneiro,
       15-Sep-2013.) $)
    seqp1 $p |- ( N e. ( ZZ>= ` M ) ->
        ( seq M ( .+ , F ) ` ( N + 1 ) ) =
          ( ( seq M ( .+ , F ) ` N ) .+ ( F ` ( N + 1 ) ) ) ) $=
      ( vz vw vx vy cuz cfv wcel c1 caddc co cseq cvv cv wceq cc0 eqid cmpt2 cz
      eluzel2 wi cif fveq2 eleq2d seqeq1 fveq1d oveq2d eqeq12d imbi12d cop crdg
      com cres cmpt 0z elimel fvex seqval uzrdgsuci dedth mpcom elex oveq1 ovex
      fveq2d ovmpt2 sylancl eqtrd ) DCIJZKZDLMNZABCOZJZDDVOJZEFPPFQZEQZLMNZBJZA
      NZUAZNZVQVNBJZANZCUBKZVMVPWDRZCDUCWGVMWHUDDWGCSUEZIJZKZVNABWIOZJZDDWLJZWC
      NZRZUDCSCWIRZVMWKWHWPWQVLWJDCWIIUFUGWQVPWMWDWOWQVNVOWLABCWIUHZUIWQVQWNDWC
      WQDVOWLWRUIUJUKULGHWIBJZDWIGHPPGQZLMNZWTHQWCNUMUAWIWSUMUNUOUPZWLWCGPXAUQW
      IUNUOUPZCSUBURUSXCTWIBUTXBTZGHEFAXBBWIXDVAVBVCVDVMDPKVQPKWDWFRDVLVEDVOUTE
      FDVQPPWBWFWCVRWEANVSDRZWAWEVRAXEVTVNBVSDLMVFVHUJVRVQWEAVFWCTVQWEAVGVIVJVK
      $.
  $}

  ${
    $d x y z w .+ $.  $d x y z w F $.  $d x y w M $.  $d z w N $.
    seqp1i.1 $e |- Z = ( ZZ>= ` M ) $.
    seqp1i.2 $e |- N e. Z $.
    seqp1i.3 $e |- K = ( N + 1 ) $.
    seqp1i.4 $e |- ( ph -> ( seq M ( .+ , F ) ` N ) = A ) $.
    seqp1i.5 $e |- ( ph -> ( F ` K ) = B ) $.
    $( Value of the sequence builder function at a successor.  (Contributed by
       Mario Carneiro, 30-Apr-2014.) $)
    seqp1i $p |- ( ph -> ( seq M ( .+ , F ) ` K ) = ( A .+ B ) ) $=
      ( cseq cfv c1 caddc co fveq2i wcel wceq eleqtri seqp1 ax-mp eqtri syl5eqr
      cuz oveq12d syl5eq ) AFDEGOZPZHUKPZHQRSZEPZDSZBCDSULUNUKPZUPFUNUKLTHGUHPZ
      UAUQUPUBHIURKJUCDEGHUDUEUFAUMBUOCDMAUOFEPCFUNELTNUGUIUJ $.
  $}

  ${
    $( Value of the sequence builder function at a successor.  (Contributed by
       Mario Carneiro, 24-Jun-2013.) $)
    seqm1 $p |- ( ( M e. ZZ /\ N e. ( ZZ>= ` ( M + 1 ) ) ) ->
        ( seq M ( .+ , F ) ` N ) =
          ( ( seq M ( .+ , F ) ` ( N - 1 ) ) .+ ( F ` N ) ) ) $=
      ( cz wcel c1 caddc co cuz cfv wa cmin cseq wceq eluzp1m1 seqp1 syl fveq2d
      cc eluzelz zcnd ax-1cn npcan sylancl adantl oveq2d 3eqtr3d ) CEFZDCGHIZJK
      FZLZDGMIZGHIZABCNZKZUMUOKZUNBKZAIZDUOKUQDBKZAIULUMCJKFUPUSOCDPABCUMQRULUN
      DUOUKUNDOZUIUKDTFGTFVAUKDUJDUAUBUCDGUDUEUFZSULURUTUQAULUNDBVBSUGUH $.
  $}

  ${
    $d k n x y C $.  $d x y D $.  $d k n x y F $.  $d k n x y M $.  $d n x N $.
    $d k n x y .+ $.  $d k n x y ph $.
    seqcl2.1 $e |- ( ph -> ( F ` M ) e. C ) $.
    seqcl2.2 $e |- ( ( ph /\ ( x e. C /\ y e. D ) ) -> ( x .+ y ) e. C ) $.
    ${
      seqcl2.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      seqcl2.4 $e |- ( ( ph /\ x e. ( ( M + 1 ) ... N ) ) -> ( F ` x ) e. D )
          $.
      $( Closure properties of the recursive sequence builder.  (Contributed by
         Mario Carneiro, 2-Jul-2013.)  (Revised by Mario Carneiro,
         27-May-2014.) $)
      seqcl2 $p |- ( ph -> ( seq M ( .+ , F ) ` N ) e. C ) $=
        ( co wcel cfv wi wceq fveq2 eleq1d vn cfz cseq cuz eluzfz2 syl cv caddc
        c1 eleq1 imbi12d imbi2d cz seq1 syl5ibr a1dd wa peano2fzr adantl imim1d
        expr wral eluzp1p1 ad2antrl elfzuz3 ad2antll elfzuzb sylanbrc ralrimiva
        adantr rspcv sylc caovclg ex mpan2d seqp1 sylibrd a2d syld expcom mpcom
        uzind4 mpd ) AIHIUBNZOZIFGHUCZPZDOZAIHUDPZOZWELHIUEUFWJAWEWHQZLABUGZWDO
        ZWLWFPZDOZQZQAHWDOZHWFPZDOZQZQAUAUGZWDOZXAWFPZDOZQZQAXAUIUHNZWDOZXFWFPZ
        DOZQZQAWKQBUAHIWLHRZWPWTAXKWMWQWOWSWLHWDUJXKWNWRDWLHWFSTUKULWLXARZWPXEA
        XLWMXBWOXDWLXAWDUJXLWNXCDWLXAWFSTUKULWLXFRZWPXJAXMWMXGWOXIWLXFWDUJXMWNX
        HDWLXFWFSTUKULWLIRZWPWKAXNWMWEWOWHWLIWDUJXNWNWGDWLIWFSTUKULHUMOZAWSWQAW
        SXOHGPZDOJXOWRXPDFGHUNTUOUPXAWIOZAXEXJAXQXEXJQAXQUQZXEXGXDQXJXRXGXBXDAX
        QXGXBXQXGUQZXBAXAHIURUSVAUTXRXGXDXIAXQXGXDXIQAXSUQZXDXCXFGPZFNZDOZXIXTX
        DYAEOZYCXTXFHUIUHNZIUBNZOZWLGPZEOZBYFVBZYDXTXFYEUDPOZIXFUDPOZYGXQYKAXGH
        XAVCVDXGYLAXQXFHIVEVFXFYEIVGVHAYJXSAYIBYFMVIVJYIYDBXFYFXMYHYAEWLXFGSTVK
        VLAXDYDUQZYCQXSAYMYCABCXCYADEDFKVMVNVJVOXTXHYBDXQXHYBRAXGFGHXAVPVDTVQVA
        VRVSVTVRWBWAWC $.
    $}

    seqf2.3 $e |- Z = ( ZZ>= ` M ) $.
    seqf2.4 $e |- ( ph -> M e. ZZ ) $.
    seqf2.5 $e |- ( ( ph /\ x e. ( ZZ>= ` ( M + 1 ) ) ) -> ( F ` x ) e. D ) $.
    $( Range of the recursive sequence builder.  (Contributed by Mario
       Carneiro, 24-Jun-2013.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    seqf2 $p |- ( ph -> seq M ( .+ , F ) : Z --> C ) $=
      ( vk cuz cfv cv wcel co cseq wf wfn wral cz seqfn wa adantr adantlr simpr
      syl caddc cfz elfzuz sylan2 seqcl2 ralrimiva ffnfv sylanbrc feq2i sylibr
      c1 ) AHPQZDFGHUAZUBZIDVDUBAVDVCUCZORZVDQDSZOVCUDVEAHUESVFMFGHUFUKAVHOVCAV
      GVCSZUGBCDEFGHVGAHGQDSVIJUHABRZDSCRZESUGVJVKFTDSVIKUIAVIUJAVJHVBULTZVGUMT
      SZVJGQESZVIVMAVJVLPQSVNVJVLVGUNNUOUIUPUQOVCDVDURUSIVCDVDLUTVA $.
  $}

  ${
    $d x y .+ $.  $d x y F $.  $d x y M $.  $d x y ph $.  $d x y S $.
    $d x N $.
    seqcl.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqcl.2 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( F ` x ) e. S ) $.
    seqcl.3 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    $( Closure properties of the recursive sequence builder.  (Contributed by
       Mario Carneiro, 2-Jul-2013.)  (Revised by Mario Carneiro,
       27-May-2014.) $)
    seqcl $p |- ( ph -> ( seq M ( .+ , F ) ` N ) e. S ) $=
      ( cfz co wcel cv cfv wral cuz eluzfz1 syl ralrimiva wceq fveq2 rspcv sylc
      eleq1d c1 caddc cz wss eluzel2 fzp1ss sselda syldan seqcl2 ) ABCEEDFGHAGG
      HLMZNZBOZFPZENZBUPQGFPZENZAHGRPNZUQIGHSTAUTBUPJUAUTVBBGUPURGUBUSVAEURGFUC
      UFUDUEKIAURGUGUHMHLMZNURUPNUTAVDUPURAGUINZVDUPUJAVCVEIGHUKTGHULTUMJUNUO
      $.
  $}

  ${
    $d x y .+ $.  $d x y F $.  $d x y M $.  $d x y ph $.  $d x y S $.
    $d x Z $.
    seqf.1 $e |- Z = ( ZZ>= ` M ) $.
    seqf.2 $e |- ( ph -> M e. ZZ ) $.
    seqf.3 $e |- ( ( ph /\ x e. Z ) -> ( F ` x ) e. S ) $.
    seqf.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    $( Range of the recursive sequence builder (special case of ~ seqf2 ).
       (Contributed by Mario Carneiro, 24-Jun-2013.) $)
    seqf $p |- ( ph -> seq M ( .+ , F ) : Z --> S ) $=
      ( wcel cv cfv wral cuz cz uzid syl6eleqr syl ralrimiva fveq2 eleq1d rspcv
      wceq sylc c1 caddc co wa peano2uzr sylan syldan seqf2 ) ABCEEDFGHAGHMBNZF
      OZEMZBHPGFOZEMZAGGQOZHAGRMZGVAMJGSUAITAURBHKUBURUTBGHUPGUFUQUSEUPGFUCUDUE
      UGLIJAUPGUHUIUJQOMZUPHMURAVCUKUPVAHAVBVCUPVAMJGUPULUMITKUNUO $.
  $}

  ${
    $d k n x F $.  $d k n x G $.  $d k n x K $.  $d k n x N $.  $d k n x ph $.
    $d n x M $.  $d n x .+ $.
    seqfveq2.1 $e |- ( ph -> K e. ( ZZ>= ` M ) ) $.
    seqfveq2.2 $e |- ( ph -> ( seq M ( .+ , F ) ` K ) = ( G ` K ) ) $.
    ${
      seqfveq2.3 $e |- ( ph -> N e. ( ZZ>= ` K ) ) $.
      seqfveq2.4 $e |- ( ( ph /\ k e. ( ( K + 1 ) ... N ) ) ->
                         ( F ` k ) = ( G ` k ) ) $.
      $( Equality of sequences.  (Contributed by NM, 17-Mar-2005.)  (Revised by
         Mario Carneiro, 27-May-2014.) $)
      seqfveq2 $p |- ( ph ->
                       ( seq M ( .+ , F ) ` N ) = ( seq K ( .+ , G ) ` N ) ) $=
        ( co wcel cfv wceq cuz wi fveq2 eqeq12d vx vn cfz cseq eluzfz2 cv caddc
        syl c1 eleq1 imbi12d imbi2d cz eluzelz seq1 eqtr4d a1d a1i wa peano2fzr
        adantl imim1d oveq1 simpl uztrn syl2anr seqp1 ad2antrl eluzp1p1 elfzuz3
        expr wral ad2antll elfzuzb sylanbrc ralrimiva adantr rspcv sylc syl5ibr
        oveq2d a2d syld expcom uzind4 mpcom mpd ) AHFHUCMZNZHBDGUDZOZHBEFUDZOZP
        ZAHFQOZNZWIKFHUEUHWPAWIWNRZKAUAUFZWHNZWRWJOZWRWLOZPZRZRAFWHNZFWJOZFWLOZ
        PZRZRZAUBUFZWHNZXJWJOZXJWLOZPZRZRAXJUIUGMZWHNZXPWJOZXPWLOZPZRZRAWQRUAUB
        FHWRFPZXCXHAYBWSXDXBXGWRFWHUJYBWTXEXAXFWRFWJSWRFWLSTUKULWRXJPZXCXOAYCWS
        XKXBXNWRXJWHUJYCWTXLXAXMWRXJWJSWRXJWLSTUKULWRXPPZXCYAAYDWSXQXBXTWRXPWHU
        JYDWTXRXAXSWRXPWJSWRXPWLSTUKULWRHPZXCWQAYEWSWIXBWNWRHWHUJYEWTWKXAWMWRHW
        JSWRHWLSTUKULXIFUMNZAXGXDAXEFEOZXFJAYFXFYGPAFGQOZNZYFIGFUNUHBEFUOUHUPUQ
        URXJWONZAXOYAAYJXOYARAYJUSZXOXQXNRYAYKXQXKXNAYJXQXKYJXQUSZXKAXJFHUTVAVK
        VBYKXQXNXTAYJXQXNXTRXNXTAYLUSZXLXPDOZBMZXMYNBMZPXLXMYNBVCYMXRYOXSYPYMXJ
        YHNZXRYOPYLYJYIYQAYJXQVDIFXJGVEVFBDGXJVGUHYMXSXMXPEOZBMZYPYJXSYSPAXQBEF
        XJVGVHYMYNYRXMBYMXPFUIUGMZHUCMZNZCUFZDOZUUCEOZPZCUUAVLZYNYRPZYMXPYTQONZ
        HXPQONZUUBYJUUIAXQFXJVIVHXQUUJAYJXPFHVJVMXPYTHVNVOAUUGYLAUUFCUUALVPVQUU
        FUUHCXPUUAUUCXPPUUDYNUUEYRUUCXPDSUUCXPESTVRVSWAUPTVTVKWBWCWDWBWEWFWG $.
    $}

    seqfeq2.4 $e |- ( ( ph /\ k e. ( ZZ>= ` ( K + 1 ) ) ) ->
                       ( F ` k ) = ( G ` k ) ) $.
    $( Equality of sequences.  (Contributed by Mario Carneiro, 13-Jul-2013.)
       (Revised by Mario Carneiro, 27-May-2014.) $)
    seqfeq2 $p |- ( ph -> ( seq M ( .+ , F ) |` ( ZZ>= ` K ) ) =
                            seq K ( .+ , G ) ) $=
      ( vx cuz cfv cseq wfn wcel cz seqfn 3syl wceq wss eluzel2 fnssres syl2anc
      cres uzss syl eluzelz cv wa fvres adantl adantr simpr c1 caddc cfz elfzuz
      co sylan2 adantlr seqfveq2 eqtrd eqfnfvd ) AKFLMZBDGNZVEUEZBEFNZAVFGLMZOZ
      VEVIUAZVGVEOAFVIPZGQPVJHGFUBBDGRSAVLVKHGFUFUGVIVEVFUCUDAVLFQPVHVEOHGFUHBE
      FRSAKUIZVEPZUJZVMVGMZVMVFMZVMVHMVNVPVQTAVMVEVFUKULVOBCDEFGVMAVLVNHUMAFVFM
      FEMTVNIUMAVNUNACUIZFUOUPUSZVMUQUSPZVRDMVREMTZVNVTAVRVSLMPWAVRVSVMURJUTVAV
      BVCVD $.
  $}

  ${
    $d k F $.  $d k G $.  $d k M $.  $d k N $.  $d k ph $.
    seqfveq.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqfveq.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) = ( G ` k ) ) $.
    $( Equality of sequences.  (Contributed by NM, 17-Mar-2005.)  (Revised by
       Mario Carneiro, 27-May-2014.) $)
    seqfveq $p |- ( ph ->
                    ( seq M ( .+ , F ) ` N ) = ( seq M ( .+ , G ) ` N ) ) $=
      ( cz wcel cuz cfv eluzel2 syl uzid wceq cfz co fveq2 cseq seq1 cv eluzfz1
      wral ralrimiva eqeq12d rspcv sylc eqtrd c1 caddc wss fzp1ss sselda syldan
      seqfveq2 ) ABCDEFFGAFJKZFFLMZKAGUSKZURHFGNOZFPOAFBDFUAMZFDMZFEMZAURVBVCQV
      ABDFUBOAFFGRSZKZCUCZDMZVGEMZQZCVEUEVCVDQZAUTVFHFGUDOAVJCVEIUFVJVKCFVEVGFQ
      VHVCVIVDVGFDTVGFETUGUHUIUJHAVGFUKULSGRSZKVGVEKVJAVLVEVGAURVLVEUMVAFGUNOUO
      IUPUQ $.
  $}

  ${
    $d k x F $.  $d k x G $.  $d k x M $.  $d x .+ $.  $d k x ph $.
    seqfeq.1 $e |- ( ph -> M e. ZZ ) $.
    seqfeq.2 $e |- ( ( ph /\ k e. ( ZZ>= ` M ) ) -> ( F ` k ) = ( G ` k ) ) $.
    $( Equality of sequences.  (Contributed by Mario Carneiro, 13-Jul-2013.)
       (Revised by Mario Carneiro, 27-May-2014.) $)
    seqfeq $p |- ( ph -> seq M ( .+ , F ) = seq M ( .+ , G ) ) $=
      ( vx cuz cfv cseq cz wcel wfn seqfn syl cv wa simpr co wceq elfzuz sylan2
      cfz adantlr seqfveq eqfnfvd ) AIFJKZBDFLZBEFLZAFMNZUJUIOGBDFPQAULUKUIOGBE
      FPQAIRZUINZSBCDEFUMAUNTACRZFUMUEUANZUODKUOEKUBZUNUPAUOUINUQUOFUMUCHUDUFUG
      UH $.
  $}

  ${
    $d k n x F $.  $d k n x G $.  $d k n x K $.  $d k n x M $.  $d k n x ph $.
    $d k n x N $.  $d n x .+ $.
    seqshft2.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqshft2.2 $e |- ( ph -> K e. ZZ ) $.
    seqshft2.3 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                       ( F ` k ) = ( G ` ( k + K ) ) ) $.
    $( Shifting the index set of a sequence.  (Contributed by Mario Carneiro,
       27-Feb-2014.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    seqshft2 $p |- ( ph -> ( seq M ( .+ , F ) ` N ) =
                           ( seq ( M + K ) ( .+ , G ) ` ( N + K ) ) ) $=
      ( co wcel cfv caddc wceq syl wi oveq1 fveq2d vx vn cfz cseq eluzfz2 cv c1
      cuz eleq1 fveq2 eqeq12d imbi12d imbi2d cz eluzfz1 ralrimiva rspcv eluzel2
      wral sylc seq1 zaddcld 3eqtr4d a1d wa peano2fzr adantl expr imim1d simprl
      seqp1 adantr eluzadd syl2anc eluzelz cc ax-1cn add32 mp3an2 syl2an simprr
      a1i zcn eqtrd oveq2d syl5ibr a2d syld expcom uzind4 mpcom mpd ) AHGHUCLZM
      ZHBDGUDZNZHFOLZBEGFOLZUDZNZPZAHGUHNZMZWNIGHUEQXCAWNXARZIAUAUFZWMMZXEWONZX
      EFOLZWSNZPZRZRAGWMMZGWONZWRWSNZPZRZRZAUBUFZWMMZXRWONZXRFOLZWSNZPZRZRAXRUG
      OLZWMMZYEWONZYEFOLZWSNZPZRZRAXDRUAUBGHXEGPZXKXPAYLXFXLXJXOXEGWMUIYLXGXMXI
      XNXEGWOUJYLXHWRWSXEGFOSTUKULUMXEXRPZXKYDAYMXFXSXJYCXEXRWMUIYMXGXTXIYBXEXR
      WOUJYMXHYAWSXEXRFOSTUKULUMXEYEPZXKYKAYNXFYFXJYJXEYEWMUIYNXGYGXIYIXEYEWOUJ
      YNXHYHWSXEYEFOSTUKULUMXEHPZXKXDAYOXFWNXJXAXEHWMUIYOXGWPXIWTXEHWOUJYOXHWQW
      SXEHFOSTUKULUMXQGUNMZAXOXLAGDNZWRENZXMXNAXLCUFZDNZYSFOLZENZPZCWMUSZYQYRPZ
      AXCXLIGHUOQAUUCCWMKUPZUUCUUECGWMYSGPZYTYQUUBYRYSGDUJUUGUUAWREYSGFOSTUKUQU
      TAYPXMYQPAXCYPIGHURQZBDGVAQAWRUNMXNYRPAGFUUHJVBBEWRVAQVCVDWBXRXBMZAYDYKAU
      UIYDYKRAUUIVEZYDYFYCRYKUUJYFXSYCAUUIYFXSUUIYFVEZXSAXRGHVFVGVHVIUUJYFYCYJA
      UUIYFYCYJRYCYJAUUKVEZXTYEDNZBLZYBUUMBLZPXTYBUUMBSUULYGUUNYIUUOUULUUIYGUUN
      PAUUIYFVJZBDGXRVKQUULYAUGOLZWSNZYBUUQENZBLZYIUUOUULYAWRUHNMZUURUUTPUULUUI
      FUNMZUVAUUPAUVBUUKJVLZFGXRVMVNBEWRYAVKQUULYHUUQWSUULXRUNMZUVBYHUUQPZUULUU
      IUVDUUPGXRVOQUVCUVDXRVPMZFVPMZUVEUVBXRWCFWCUVFUGVPMUVGUVEVQXRUGFVRVSVTVNZ
      TUULUUMUUSYBBUULUUMYHENZUUSUULYFUUDUUMUVIPZAUUIYFWAAUUDUUKUUFVLUUCUVJCYEW
      MYSYEPZYTUUMUUBUVIYSYEDUJUVKUUAYHEYSYEFOSTUKUQUTUULYHUUQEUVHTWDWEVCUKWFVH
      WGWHWIWGWJWKWL $.
  $}

  ${
    $d F k $.  $d M k $.
    $( Restricting its characteristic function to ` ( ZZ>= `` M ) ` does not
       affect the ` seq ` function.  (Contributed by Mario Carneiro,
       24-Jun-2013.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    seqres $p |- ( M e. ZZ -> seq M ( .+ , ( F |` ( ZZ>= ` M ) ) ) =
                              seq M ( .+ , F ) ) $=
      ( vk cz wcel cuz cfv cres id cv wceq fvres adantl seqfeq ) CEFZADBCGHZIZB
      CPJDKZQFSRHSBHLPSQBMNO $.
  $}

  ${
    $d k x F $.  $d k x M $.  $d k x ph $.  $d k Z $.
    serf.1 $e |- Z = ( ZZ>= ` M ) $.
    serf.2 $e |- ( ph -> M e. ZZ ) $.
    ${
      serf.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
      $( An infinite series of complex terms is a function from ` NN ` to
         ` CC ` .  (Contributed by NM, 18-Apr-2005.)  (Revised by Mario
         Carneiro, 27-May-2014.) $)
      serf $p |- ( ph -> seq M ( + , F ) : Z --> CC ) $=
        ( vx caddc cc cv wcel wa co addcl adantl seqf ) ABIJKCDEFGHBLZKMILZKMNS
        TJOKMASTPQR $.
    $}

    serfre.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
    $( An infinite series of real numbers is a function from ` NN ` to
       ` RR ` .  (Contributed by NM, 18-Apr-2005.)  (Revised by Mario Carneiro,
       27-May-2014.) $)
    serfre $p |- ( ph -> seq M ( + , F ) : Z --> RR ) $=
      ( vx caddc cr cv wcel wa co readdcl adantl seqf ) ABIJKCDEFGHBLZKMILZKMNS
      TJOKMASTPQR $.
  $}

  ${
    $d k n x F $.  $d k n x M $.  $d k n x N $.  $d k n x ph $.
    monoord.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    monoord.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. RR ) $.
    monoord.3 $e |- ( ( ph /\ k e. ( M ... ( N - 1 ) ) ) ->
                   ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
    $( Ordering relation for a monotonic sequence, increasing case.
       (Contributed by NM, 13-Mar-2005.)  (Revised by Mario Carneiro,
       9-Feb-2014.) $)
    monoord $p |- ( ph -> ( F ` M ) <_ ( F ` N ) ) $=
      ( co wcel cfv cle wbr syl wi c1 wceq eleq1 fveq2 cr vx vn cfz cuz eluzfz2
      cv caddc breq2d imbi12d imbi2d cz wral eluzfz1 ralrimiva rspcv sylc leidd
      eleq1d a1d wa simprl simprr peano2fzr syl2anc expr imim1d eluzelz elfzuz3
      cmin eluzp1m1 elfzuzb sylanbrc adantr oveq1 fveq2d breq12d syl3anc mpan2d
      a1i letr a2d syld expcom uzind4 mpcom mpd ) AEDEUCIZJZDCKZECKZLMZAEDUDKZJ
      ZWHFDEUENWMAWHWKOZFAUAUFZWGJZWIWOCKZLMZOZOADWGJZWIWILMZOZOZAUBUFZWGJZWIXD
      CKZLMZOZOAXDPUGIZWGJZWIXICKZLMZOZOAWNOUAUBDEWODQZWSXBAXNWPWTWRXAWODWGRXNW
      QWIWILWODCSUHUIUJWOXDQZWSXHAXOWPXEWRXGWOXDWGRXOWQXFWILWOXDCSUHUIUJWOXIQZW
      SXMAXPWPXJWRXLWOXIWGRXPWQXKWILWOXICSUHUIUJWOEQZWSWNAXQWPWHWRWKWOEWGRXQWQW
      JWILWOECSUHUIUJXCDUKJAXAWTAWIAWTBUFZCKZTJZBWGULZWITJZAWMWTFDEUMNAXTBWGGUN
      ZXTYBBDWGXRDQXSWITXRDCSURUOUPZUQUSVSXDWLJZAXHXMAYEXHXMOAYEUTZXHXJXGOXMYFX
      JXEXGAYEXJXEAYEXJUTZUTZYEXJXEAYEXJVAZAYEXJVBZXDDEVCVDZVEVFYFXJXGXLAYEXJXG
      XLOYHXGXFXKLMZXLYHXDDEPVIIZUCIZJZXSXRPUGIZCKZLMZBYNULZYLYHYEYMXDUDKJZYOYI
      YHXDUKJZEXIUDKJZYTYHYEUUAYIDXDVGNYHXJUUBYJXIDEVHNXDEVJVDXDDYMVKVLAYSYGAYR
      BYNHUNVMYRYLBXDYNXRXDQZXSXFYQXKLXRXDCSZUUCYPXICXRXDPUGVNVOVPUOUPYHYBXFTJZ
      XKTJZXGYLUTXLOAYBYGYDVMYHXEYAUUEYKAYAYGYCVMZXTUUEBXDWGUUCXSXFTUUDURUOUPYH
      XJYAUUFYJUUGXTUUFBXIWGXRXIQXSXKTXRXICSURUOUPWIXFXKVTVQVRVEWAWBWCWAWDWEWF
      $.
  $}

  ${
    $d k n x F $.  $d k n x M $.  $d k n x N $.  $d k n x ph $.
    monoord2.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    monoord2.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. RR ) $.
    monoord2.3 $e |- ( ( ph /\ k e. ( M ... ( N - 1 ) ) ) ->
                   ( F ` ( k + 1 ) ) <_ ( F ` k ) ) $.
    $( Ordering relation for a monotonic sequence, decreasing case.
       (Contributed by Mario Carneiro, 18-Jul-2014.) $)
    monoord2 $p |- ( ph -> ( F ` N ) <_ ( F ` M ) ) $=
      ( vn cfv cle wbr cneg cfz co cr wcel c1 wceq syl cv cmpt wa renegcld eqid
      fmptd ffvelrnda cmin caddc wral ralrimiva fveq2d breq12d cbvralv r19.21bi
      oveq1 fveq2 sylib fzp1elp1 adantl cc cz eluzelz zcnd ax-1cn npcan sylancl
      cuz oveq2d adantr eleqtrd eleq1d rspcv sylc fzssp1 syl5sseq sselda lenegd
      mpbid negeqd negex fvmpt 3brtr4d monoord eluzfz1 eluzfz2 3brtr3d mpbird )
      AECJZDCJZKLWJMZWIMZKLADBDENOZBUAZCJZMZUBZJZEWQJZWKWLKAIWQDEFAWMPIUAZWQABW
      MWPPWQAWNWMQUCWOGUDWQUEZUFUGAWTDERUHOZNOZQZUCZWTCJZMZWTRUIOZCJZMZWTWQJZXH
      WQJZKXEXIXFKLZXGXJKLAXMIXCAWNRUIOZCJZWOKLZBXCUJXMIXCUJAXPBXCHUKXPXMBIXCWN
      WTSZXOXIWOXFKXQXNXHCWNWTRUIUPULWNWTCUQZUMUNURUOXEXIXFXEXHWMQZWOPQZBWMUJZX
      IPQZXEXHDXBRUIOZNOZWMXDXHYDQAWTDXBUSUTAYDWMSXDAYCEDNAEVAQRVAQYCESAEAEDVHJ
      QZEVBQFDEVCTVDVEERVFVGVIZVJVKZAYAXDAXTBWMGUKZVJZXTYBBXHWMWNXHSZWOXIPWNXHC
      UQZVLVMVNXEWTWMQZYAXFPQZAXCWMWTAYDXCWMDXBVOYFVPVQZYIXTYMBWTWMXQWOXFPXRVLV
      MVNVRVSXEYLXKXGSYNBWTWPXGWMWQXQWOXFXRVTXAXFWAWBTXEXSXLXJSYGBXHWPXJWMWQYJW
      OXIYKVTXAXIWAWBTWCWDADWMQZWRWKSAYEYOFDEWETZBDWPWKWMWQWNDSZWOWJWNDCUQZVTXA
      WJWAWBTAEWMQZWSWLSAYEYSFDEWFTZBEWPWLWMWQWNESZWOWIWNECUQZVTXAWIWAWBTWGAWIW
      JAYSYAWIPQZYTYHXTUUCBEWMUUAWOWIPUUBVLVMVNAYOYAWJPQZYPYHXTUUDBDWMYQWOWJPYR
      VLVMVNVRWH $.
  $}

  ${
    $d k x y F $.  $d k x y K $.  $d k x y M $.  $d k x y N $.  $d k x y ph $.
    sermono.1 $e |- ( ph -> K e. ( ZZ>= ` M ) ) $.
    sermono.2 $e |- ( ph -> N e. ( ZZ>= ` K ) ) $.
    sermono.3 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( F ` x ) e. RR ) $.
    sermono.4 $e |- ( ( ph /\ x e. ( ( K + 1 ) ... N ) ) -> 0 <_ ( F ` x ) ) $.
    $( The partial sums in an infinite series of positive terms form a
       monotonic sequence.  (Contributed by NM, 17-Mar-2005.)  (Revised by
       Mario Carneiro, 30-Jun-2013.) $)
    sermono $p |- ( ph ->
                    ( seq M ( + , F ) ` K ) <_ ( seq M ( + , F ) ` N ) ) $=
      ( caddc cfz co wcel cr cfv adantl syl c1 cle vk vy cv wa cuz elfzuz uztrn
      cseq syl2anr wss elfzuz3 fzss2 sselda adantlr syldan readdcl cmin cc0 wbr
      seqcl simpr cz wb adantr eluzelz peano2zm elfzelz 1z a1i fzaddel syl22anc
      wral mpbid wceq cc zcn ax-1cn npcan sylancl oveq2d ralrimiva fveq2 breq2d
      eleqtrd rspcv fzelp1 fzss1 fzp1elp1 sseldd eleq1d addge01d seqp1 breqtrrd
      sylc monoord ) AUAKCEUHZDFHAUAUCZDFLMZNZUDZBUBKOCEWQWSWQDUEPZNDEUEPZNZWQX
      BNZAWQDFUFGDWQEUGUIZWTBUCZEWQLMZNXFEFLMZNZXFCPZONZWTXGXHXFWTFWQUEPNZXGXHU
      JWSXLAWQDFUKQWQEFULRUMAXIXKWSIUNUOXFONUBUCZONUDXFXMKMONWTXFXMUPQUTZAWQDFS
      UQMZLMNZUDZWQWPPZXRWQSKMZCPZKMZXSWPPZTXQURXTTUSZXRYATUSXQXSDSKMZFLMZNURXJ
      TUSZBYEVLZYCXQXSYDXOSKMZLMZYEXQXPXSYINZAXPVAXQDVBNZXOVBNZWQVBNZSVBNZXPYJV
      CXQXCYKAXCXPGVDZEDVERXQFVBNZYLXQFXANZYPAYQXPHVDDFVERZFVFRXPYMAWQDXOVGQYNX
      QVHVIWQSDXOVJVKVMXQYHFYDLXQYPYHFVNZYRYPFVONSVONYSFVPVQFSVRVSRZVTWDAYGXPAY
      FBYEJWAVDYFYCBXSYEXFXSVNZXJXTURTXFXSCWBZWCWEWNXQXRXTAXPWSXRONXQWQDYHLMZWR
      XPWQUUCNAWQDXOWFQXQYHFDLYTVTZWDZXNUOXQXSXHNXKBXHVLZXTONZXQWRXHXSXQXCWRXHU
      JYODEFWGRXQXSUUCWRXPXSUUCNAWQDXOWHQUUDWDWIAUUFXPAXKBXHIWAVDXKUUGBXSXHUUAX
      JXTOUUBWJWEWNWKVMXQXDYBYAVNAXPWSXDUUEXEUOKCEWQWLRWMWO $.
  $}

  ${
    $d n x y z F $.  $d n x y z K $.  $d n x y z M $.  $d n x y z ph $.
    $d n x y z N $.  $d n x y z .+ $.  $d x y z S $.
    seqsplit.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqsplit.2 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                       ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    seqsplit.3 $e |- ( ph -> N e. ( ZZ>= ` ( M + 1 ) ) ) $.
    ${
      seqsplit.4 $e |- ( ph -> M e. ( ZZ>= ` K ) ) $.
      seqsplit.5 $e |- ( ( ph /\ x e. ( K ... N ) ) -> ( F ` x ) e. S ) $.
      $( Split a sequence into two sequences.  (Contributed by NM,
         17-Mar-2005.)  (Revised by Mario Carneiro, 27-May-2014.) $)
      seqsplit $p |- ( ph -> ( seq K ( .+ , F ) ` N ) =
          ( ( seq K ( .+ , F ) ` M ) .+ ( seq ( M + 1 ) ( .+ , F ) ` N ) ) ) $=
        ( co wcel cfv wceq wi vn c1 caddc cfz cseq cuz eluzfz2 syl eleq1 oveq2d
        cv fveq2 eqeq12d imbi12d imbi2d cz seqp1 eluzel2 seq1 eqtr4d a1d a1i wa
        3syl peano2fzr adantl imim1d oveq1 simprl peano2uz adantr uztrn syl2anc
        expr simpl wss eluzelz peano2uzr fzss2 sselda seqcl elfzuz3 fzss1 sstrd
        syldan wral simpr ssel2 syl2an ralrimiva eleq1d rspcv caovassg syl13anc
        adantlr sylc syl5ibr a2d syld expcom uzind4 mpcom mpd ) AJIUBUCPZJUDPZQ
        ZJEGHUEZRZIXGRZJEGXDUEZRZEPZSZAJXDUFRZQZXFMXDJUGUHXOAXFXMTZMABUKZXEQZXQ
        XGRZXIXQXJRZEPZSZTZTAXDXEQZXDXGRZXIXDXJRZEPZSZTZTZAUAUKZXEQZYKXGRZXIYKX
        JRZEPZSZTZTAYKUBUCPZXEQZYRXGRZXIYRXJRZEPZSZTZTAXPTBUAXDJXQXDSZYCYIAUUEX
        RYDYBYHXQXDXEUIUUEXSYEYAYGXQXDXGULUUEXTYFXIEXQXDXJULUJUMUNUOXQYKSZYCYQA
        UUFXRYLYBYPXQYKXEUIUUFXSYMYAYOXQYKXGULUUFXTYNXIEXQYKXJULUJUMUNUOXQYRSZY
        CUUDAUUGXRYSYBUUCXQYRXEUIUUGXSYTYAUUBXQYRXGULUUGXTUUAXIEXQYRXJULUJUMUNU
        OXQJSZYCXPAUUHXRXFYBXMXQJXEUIUUHXSXHYAXLXQJXGULUUHXTXKXIEXQJXJULUJUMUNU
        OYJXDUPQZAYHYDAYEXIXDGRZEPZYGAIHUFRZQZYEUUKSNEGHIUQUHAYFUUJXIEAXOUUIYFU
        UJSMXDJUREGXDUSVDUJUTVAVBYKXNQZAYQUUDAUUNYQUUDTAUUNVCZYQYSYPTUUDUUOYSYL
        YPAUUNYSYLUUNYSVCZYLAYKXDJVEVFZVNVGUUOYSYPUUCAUUNYSYPUUCTYPUUCAUUPVCZYM
        YRGRZEPZYOUUSEPZSYMYOUUSEVHUURYTUUTUUBUVAUURYKUULQZYTUUTSUURUUNXDUULQZU
        VBAUUNYSVIZAUVCUUPAUUMUVCNHIVJZUHVKXDYKHVLVMEGHYKUQUHUURUUBXIYNUUSEPZEP
        ZUVAUURUUAUVFXIEUURUUNUUAUVFSUVDEGXDYKUQUHUJUURAXIFQZYNFQUUSFQZUVAUVGSA
        UUPVOAUVHUUPABCEFGHINAXQHIUDPZQXQHJUDPZQZXQGRZFQZAUVJUVKXQAJIUFRQZUVJUV
        KVPAIUPQZXOUVOAUUMUVPNHIVQUHMIJVRVMIHJVSUHVTOWEKWAVKUURBCEFGXDYKUVDUURX
        QXDYKUDPZQUVLUVNUURUVQUVKXQUURUVQXEUVKUURYLJYKUFRQUVQXEVPUUQYKXDJWBYKXD
        JVSVDAXEUVKVPZUUPAUUMUVCUVRNUVEXDHJWCVDZVKWDVTAUVLUVNUUPOWOWEAXQFQCUKZF
        QVCXQUVTEPFQUUPKWOWAUURYRUVKQZUVNBUVKWFZUVIAUVRYSUWAUUPUVSUUNYSWGXEUVKY
        RWHWIAUWBUUPAUVNBUVKOWJVKUVNUVIBYRUVKUUGUVMUUSFXQYRGULWKWLWPABCDXIYNUUS
        FELWMWNUTUMWQVNWRWSWTWRXAXBXC $.
    $}

    seq1p.4 $e |- ( ph -> M e. ZZ ) $.
    seq1p.5 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( F ` x ) e. S ) $.
    $( Removing the first term from a sequence.  (Contributed by NM,
       17-Mar-2005.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    seq1p $p |- ( ph -> ( seq M ( .+ , F ) ` N ) =
                  ( ( F ` M ) .+ ( seq ( M + 1 ) ( .+ , F ) ` N ) ) ) $=
      ( cseq cfv c1 co wcel syl caddc cuz uzid seqsplit wceq seq1 oveq1d eqtrd
      cz ) AIEGHOZPHUJPZIEGHQUAROPZERHGPZULERABCDEFGHHIJKLAHUISZHHUBPSMHUCTNUDA
      UKUMULEAUNUKUMUEMEGHUFTUGUH $.
  $}

  ${
    $d k n w x y z F $.  $d k n z H $.  $d k n x y z N $.  $d k n w x y z ph $.
    $d k n w x y z G $.  $d k n w x y z M $.  $d k n w x y z Q $.
    $d n w x y z .+ $.  $d k w x y z S $.
    seqcaopr3.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqcaopr3.2 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x Q y ) e. S ) $.
    seqcaopr3.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqcaopr3.4 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. S ) $.
    seqcaopr3.5 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. S ) $.
    seqcaopr3.6 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                        ( H ` k ) = ( ( F ` k ) Q ( G ` k ) ) ) $.
    seqcaopr3.7 $e |- ( ( ph /\ n e. ( M ..^ N ) ) ->
      ( ( ( seq M ( .+ , F ) ` n ) Q ( seq M ( .+ , G ) ` n ) ) .+
        ( ( F ` ( n + 1 ) ) Q ( G ` ( n + 1 ) ) ) ) =
      ( ( ( seq M ( .+ , F ) ` n ) .+ ( F ` ( n + 1 ) ) ) Q
        ( ( seq M ( .+ , G ) ` n ) .+ ( G ` ( n + 1 ) ) ) ) ) $.
    $( Lemma for ~ seqcaopr2 .  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    seqcaopr3 $p |- ( ph -> ( seq M ( .+ , H ) ` N ) =
                   ( ( seq M ( .+ , F ) ` N ) Q ( seq M ( .+ , G ) ` N ) ) ) $=
      ( vz cfz co wcel cseq cfv wceq cuz eluzfz2 cv wi c1 caddc oveq12d eqeq12d
      syl fveq2 imbi2d wral eluzfz1 ralrimiva rspcv sylc cz eluzel2 3eqtr4d a1i
      seq1 wa oveq1 elfzouz adantl seqp1 fzofzp1 adantr oveq2d 3eqtr4rd syl5ibr
      cfzo expcom a2d fzind2 mpcom ) MLMUBUCZUDZAMDKLUEZUFZMDILUEZUFZMDJLUEZUFZ
      EUCZUGZAMLUHUFZUDZWEPLMUIUPAUAUJZWFUFZWPWHUFZWPWJUFZEUCZUGZUKALWFUFZLWHUF
      ZLWJUFZEUCZUGZUKZAHUJZWFUFZXHWHUFZXHWJUFZEUCZUGZUKAXHULUMUCZWFUFZXNWHUFZX
      NWJUFZEUCZUGZUKAWMUKUAHMLMWPLUGZXAXFAXTWQXBWTXEWPLWFUQXTWRXCWSXDEWPLWHUQW
      PLWJUQUNUOURWPXHUGZXAXMAYAWQXIWTXLWPXHWFUQYAWRXJWSXKEWPXHWHUQWPXHWJUQUNUO
      URWPXNUGZXAXSAYBWQXOWTXRWPXNWFUQYBWRXPWSXQEWPXNWHUQWPXNWJUQUNUOURWPMUGZXA
      WMAYCWQWGWTWLWPMWFUQYCWRWIWSWKEWPMWHUQWPMWJUQUNUOURXGWOALKUFZLIUFZLJUFZEU
      CZXBXEALWDUDZGUJZKUFZYIIUFZYIJUFZEUCZUGZGWDUSZYDYGUGZAWOYHPLMUTUPAYNGWDSV
      AZYNYPGLWDYILUGZYJYDYMYGYILKUQYRYKYEYLYFEYILIUQYILJUQUNUOVBVCALVDUDZXBYDU
      GAWOYSPLMVEUPZDKLVHUPAYSXEYGUGYTYSXCYEXDYFEDILVHDJLVHUNUPVFVGXHLMVSUCUDZA
      XMXSAUUAXMXSUKXMXSAUUAVIZXIXNKUFZDUCZXLUUCDUCZUGXIXLUUCDVJUUBXOUUDXRUUEUU
      BXHWNUDZXOUUDUGUUAUUFAXHLMVKVLZDKLXHVMUPUUBXLXNIUFZXNJUFZEUCZDUCXJUUHDUCZ
      XKUUIDUCZEUCZUUEXRTUUBUUCUUJXLDUUBXNWDUDZYOUUCUUJUGZUUAUUNALMXHVNVLAYOUUA
      YQVOYNUUOGXNWDYIXNUGZYJUUCYMUUJYIXNKUQUUPYKUUHYLUUIEYIXNIUQYIXNJUQUNUOVBV
      CVPUUBUUFXRUUMUGUUGUUFXPUUKXQUULEDILXHVMDJLXHVMUNUPVQUOVRVTWAWBWC $.
  $}

  ${
    $d k n w x y z F $.  $d k n z H $.  $d k n x y z N $.  $d k n w x y z ph $.
    $d k n w x y z G $.  $d k n w x y z M $.  $d k n w x y z Q $.
    $d n w x y z .+ $.  $d k w x y z S $.
    seqcaopr2.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqcaopr2.2 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x Q y ) e. S ) $.
    seqcaopr2.3 $e |- ( ( ph /\
                        ( ( x e. S /\ y e. S ) /\ ( z e. S /\ w e. S ) ) ) ->
                  ( ( x Q z ) .+ ( y Q w ) ) = ( ( x .+ y ) Q ( z .+ w ) ) ) $.
    seqcaopr2.4 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqcaopr2.5 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. S ) $.
    seqcaopr2.6 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. S ) $.
    seqcaopr2.7 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                        ( H ` k ) = ( ( F ` k ) Q ( G ` k ) ) ) $.
    $( The sum of two infinite series (generalized to an arbitrary commutative
       and associative operation).  (Contributed by Mario Carneiro,
       30-May-2014.) $)
    seqcaopr2 $p |- ( ph -> ( seq M ( .+ , H ) ` N ) =
                   ( ( seq M ( .+ , F ) ` N ) Q ( seq M ( .+ , G ) ` N ) ) ) $=
      ( vn cv cfzo co wcel wa cseq cfv c1 caddc wceq cuz elfzouz adantl cfz wss
      wral elfzouz2 fzss2 syl sselda ralrimiva adantr fveq2 eleq1d sylan syldan
      rspccva adantlr fzofzp1 syl2an anassrs ralrimivva oveq1d eqeq12d 2ralbidv
      seqcl oveq1 oveq2d oveq2 rspc2va syl21anc seqcaopr3 ) ABCFGHIUBJKLMNOPRST
      UAAUBUCZMNUDUEUFZUGZWEFKMUHUIZHUFWEUJUKUEZKUIZHUFZWEFJMUHUIZDUCZGUEZWIJUI
      ZEUCZGUEZFUEZWLWOFUEZWMWPFUEZGUEZULZEHURDHURZWLWHGUEZWOWJGUEZFUEZWSWHWJFU
      EZGUEZULZWGBCFHKMWEWFWEMUMUIUFAWEMNUNUOZWGBUCZMWEUPUEZUFZXKMNUPUEZUFZXKKU
      IZHUFZWGXLXNXKWGNWEUMUIUFZXLXNUQWFXRAWEMNUSUOWEMNUTVAVBZWGIUCZKUIZHUFZIXN
      URZXOXQAYCWFAYBIXNTVCZVDYBXQIXKXNXTXKULZYAXPHXTXKKVEVFVIVGVHAXKHUFCUCZHUF
      UGZXKYFFUEZHUFWFOVJZVRAYCWIXNUFZWKWFYDMNWEVKZYBWKIWIXNXTWIULZYAWJHXTWIKVE
      VFVIVLWGWLHUFWOHUFZXKWMGUEZYFWPGUEZFUEZYHWTGUEZULZEHURDHURZCHURBHURZXCWGB
      CFHJMWEXJWGXMXOXKJUIZHUFZXSAXOUUBWFAXTJUIZHUFZIXNURZXOUUBAUUDIXNSVCZUUDUU
      BIXKXNYEUUCUUAHXTXKJVEVFVIVGVJVHYIVRAUUEYJYMWFUUFYKUUDYMIWIXNYLUUCWOHXTWI
      JVEVFVIVLAYTWFAYSBCHHAYGUGYRDEHHAYGWMHUFWPHUFUGYRQVMVNVNVDYSXCWNYOFUEZWLY
      FFUEZWTGUEZULZEHURDHURBCWLWOHHXKWLULZYRUUJDEHHUUKYPUUGYQUUIUUKYNWNYOFXKWL
      WMGVSVOUUKYHUUHWTGXKWLYFFVSVOVPVQYFWOULZUUJXBDEHHUULUUGWRUUIXAUULYOWQWNFY
      FWOWPGVSVTUULUUHWSWTGYFWOWLFWAVOVPVQWBWCXBXIXDWQFUEZWSWHWPFUEZGUEZULDEWHW
      JHHWMWHULZWRUUMXAUUOUUPWNXDWQFWMWHWLGWAVOUUPWTUUNWSGWMWHWPFVSVTVPWPWJULZU
      UMXFUUOXHUUQWQXEXDFWPWJWOGWAVTUUQUUNXGWSGWPWJWHFWAVTVPWBWCWD $.
  $}

  ${
    $d a b c d k F $.  $d a b c d k G $.  $d c k H $.  $d a b c d k x y z ph $.
    $d a b c d k M $.  $d a b c d k x y z .+ $.  $d a b c d k x y z S $.
    $d a b c k N $.
    seqcaopr.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqcaopr.2 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                       ( x .+ y ) = ( y .+ x ) ) $.
    seqcaopr.3 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                       ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    seqcaopr.4 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqcaopr.5 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. S ) $.
    seqcaopr.6 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. S ) $.
    seqcaopr.7 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                        ( H ` k ) = ( ( F ` k ) .+ ( G ` k ) ) ) $.
    $( The sum of two infinite series (generalized to an arbitrary commutative
       and associative operation).  (Contributed by NM, 17-Mar-2005.)  (Revised
       by Mario Carneiro, 30-May-2014.) $)
    seqcaopr $p |- ( ph -> ( seq M ( .+ , H ) ` N ) =
                  ( ( seq M ( .+ , F ) ` N ) .+ ( seq M ( .+ , G ) ` N ) ) ) $=
      ( co va vb vc vd cv caovclg wcel wa simpl simprrl simprlr caovcomg oveq1d
      syl12anc simprrr caovassg syl13anc 3eqtr3d oveq2d simprll adantrl 3eqtr4d
      wceq seqcaopr2 ) AUAUBUCUDEEFGHIJKLABCUAUEZUBUEZFFFEMUFZVGAVEFUGZVFFUGZUH
      ZUCUEZFUGZUDUEZFUGZUHZUHZUHZVEVKVFVMETZETZETZVEVFVKVMETZETZETZVEVKETVRETZ
      VEVFETWAETZVQVSWBVEEVQVKVFETZVMETZVFVKETZVMETZVSWBVQWFWHVMEVQAVLVIWFWHVCA
      VPUIZAVJVLVNUJZAVHVIVOUKZABCVKVFFENULUNUMVQAVLVIVNWGVSVCWJWKWLAVJVLVNUOZA
      BCDVKVFVMFEOUPUQVQAVIVLVNWIWBVCWJWLWKWMABCDVFVKVMFEOUPUQURUSVQAVHVLVRFUGZ
      WDVTVCWJAVHVIVOUTZWKVQAVIVNWNWJWLWMABCVFVMFFFEMUFUNABCDVEVKVRFEOUPUQVQAVH
      VIWAFUGZWEWCVCWJWOWLAVOWPVJABCVKVMFFFEMUFVAABCDVEVFWAFEOUPUQVBPQRSVD $.
  $}

  ${
    $d f g k x y z F $.  $d f g k m n x y z G $.  $d f g k m n s t w x y z M $.
    $d f g k m n s t w x y z .+ $.  $d f g x y z J $.  $d f g k m n x y z N $.
    $d k m n x y z K $.  $d f g k m n s t w x y z ph $.  $d k s t w x y z S $.
    $d f g k s t w x y z C $.  $d k H $.
    seqf1o.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqf1o.2 $e |- ( ( ph /\ ( x e. C /\ y e. C ) ) ->
                     ( x .+ y ) = ( y .+ x ) ) $.
    seqf1o.3 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ z e. S ) ) ->
                     ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    seqf1o.4 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqf1o.5 $e |- ( ph -> C C_ S ) $.
    ${
      seqf1olem2a.1 $e |- ( ph -> G : A --> C ) $.
      seqf1olem2a.3 $e |- ( ph -> K e. A ) $.
      seqf1olem2a.4 $e |- ( ph -> ( M ... N ) C_ A ) $.
      $( Lemma for ~ seqf1o .  (Contributed by Mario Carneiro, 24-Apr-2016.) $)
      seqf1olem2a $p |- ( ph ->
        ( ( G ` K ) .+ ( seq M ( .+ , G ) ` N ) ) =
        ( ( seq M ( .+ , G ) ` N ) .+ ( G ` K ) ) ) $=
        ( vm vn cfz co wcel cfv cseq wceq cuz eluzfz2 syl cv wi c1 caddc oveq2d
        oveq1d eqeq12d imbi2d ffvelrnd eluzel2 seq1 3syl eluzfz1 sseldd eqeltrd
        fveq2 cz caovcomd a1i cfzo wa oveq1 elfzouz adantl seqp1 adantlr adantr
        w3a wss wf elfzouz2 fzss2 sstrd sselda fzofzp1 caovassd 3eqtr4d syl5ibr
        seqcl eqtr4d expcom a2d fzind2 mpcom ) LKLUCUDZUEZAJIUFZLGIKUGZUFZGUDZW
        TWRGUDZUHZALKUIUFZUEZWQPKLUJUKAWRUAULZWSUFZGUDZXGWRGUDZUHZUMAWRKWSUFZGU
        DZXKWRGUDZUHZUMZAWRUBULZWSUFZGUDZXQWRGUDZUHZUMAWRXPUNUOUDZWSUFZGUDZYBWR
        GUDZUHZUMAXCUMUAUBLKLXFKUHZXJXNAYFXHXLXIXMYFXGXKWRGXFKWSVGZUPYFXGXKWRGY
        GUQURUSXFXPUHZXJXTAYHXHXRXIXSYHXGXQWRGXFXPWSVGZUPYHXGXQWRGYIUQURUSXFYAU
        HZXJYEAYJXHYCXIYDYJXGYBWRGXFYAWSVGZUPYJXGYBWRGYKUQURUSXFLUHZXJXCAYLXHXA
        XIXBYLXGWTWRGXFLWSVGZUPYLXGWTWRGYMUQURUSXOXEABCWRXKFGNAEFJIRSUTZAXKKIUF
        ZFAXEKVHUEXKYOUHPKLVAGIKVBVCAEFKIRAWPEKTAXEKWPUEPKLVDUKVEUTVFVIVJXPKLVK
        UDUEZAXTYEAYPXTYEUMXTYEAYPVLZXRYAIUFZGUDZXSYRGUDZUHXRXSYRGVMYQYCYSYDYTY
        QYCWRXQYRGUDZGUDYSYQYBUUAWRGYQXPXDUEZYBUUAUHYPUUBAXPKLVNVOZGIKXPVPUKZUP
        YQBCDWRXQYRHGABULZHUEZCULZHUEZDULZHUEVSUUEUUGGUDZUUIGUDUUEUUGUUIGUDGUDU
        HYPOVQZAWRHUEYPAFHWRQYNVEVRZYQBCGHIKXPUUCYQUUEKXPUCUDZUEZVLZFHUUEIUFYQF
        HVTZUUNAUUPYPQVRZVRUUOEFUUEIYQEFIWAZUUNAUURYPRVRZVRYQUUMEUUEYQUUMWPEYQL
        XPUIUFUEZUUMWPVTYPUUTAXPKLWBVOXPKLWCUKAWPEVTYPTVRZWDWEUTVEAUUFUUHVLUUJH
        UEYPMVQWJZYQFHYRUUQYQEFYAIUUSYQWPEYAUVAYPYAWPUEAKLXPWFVOVEUTZVEZWGWKYQU
        UAWRGUDXQYRWRGUDZGUDZYDYTYQBCDXQYRWRHGUUKUVBUVDUULWGYQYBUUAWRGUUDUQYQYT
        XQWRYRGUDZGUDUVFYQBCDXQWRYRHGUUKUVBUULUVDWGYQUVEUVGXQGYQBCYRWRFGAUUEFUE
        UUGFUEVLUUJUUGUUEGUDUHYPNVQUVCAWRFUEYPYNVRVIUPWKWHURWIWLWMWNWO $.
    $}

    ${
      seqf1olem.5 $e |- ( ph ->
                  F : ( M ... ( N + 1 ) ) -1-1-onto-> ( M ... ( N + 1 ) ) ) $.
      seqf1olem.6 $e |- ( ph -> G : ( M ... ( N + 1 ) ) --> C ) $.
      seqf1olem.7 $e |- J = ( k e. ( M ... N ) |->
                              ( F ` if ( k < K , k , ( k + 1 ) ) ) ) $.
      seqf1olem.8 $e |- K = ( `' F ` ( N + 1 ) ) $.
      $( Lemma for ~ seqf1o .  (Contributed by Mario Carneiro, 26-Feb-2014.)
         (Revised by Mario Carneiro, 27-May-2014.) $)
      seqf1olem1 $p |- ( ph -> J : ( M ... N ) -1-1-onto-> ( M ... N ) ) $=
        ( cfz co cv clt wbr caddc cif cfv ccnv cmin cvv wcel fvex a1i ovex ifex
        c1 wa wceq wi wb iftrue fveq2d eqeq2d adantl simprr wne cr elfzelz zred
        ad2antlr simprl gtned wn wo wf1o f1of syl ad2antrr fzssp1 simplr sseldi
        wf ffvelrnd cuz elfzp1 mpbid ord f1ocnvfv syl2anc syl6ibr syld necon1ad
        eqeq1i mpd eqeltrd eqcomd eqbrtrd eqtr2d jca expr sylbid iffalse cz wf1
        f1ocnv f1of1 f1f peano2uz eluzfz2 syl5eqel peano2re lenltd mpbird ltp1d
        cle lelttrd ltned fzp1elp1 breq1d lttr syl3anc mpand mtod oveq1d ax-1cn
        recnd pncan sylancl 3eqtrrd pm2.61dan expimpd elfzle1 elfzle2 mpbir2and
        cc adantr eluzelz peano2zd ltletrd zleltp1 eluzel2 elfz peano2zm f1fveq
        f1ocnvfv2 syl12anc necon3bid neeq1i sylibr necomd ltlend breqtrrd letrd
        zltlem1 1re lesubadd mp3an2 zcnd npcan eqtrd impbid f1od ) AHBMNUDUEZUV
        GHUFZLUGUHZUVHUVHUTUIUEZUJZIUKZBUFZIULZUKZLUGUHZUVOUVOUTUMUEZUJZKUNUNUB
        UVLUNUOAUVHUVGUOZVAZUVKIUPUQUVRUNUOAUVMUVGUOZVAZUVPUVOUVQUVMUVNUPUVOUTU
        MURUSUQAUVSUVMUVLVBZVAZUWAUVHUVRVBZVAZAUVSUWCUWFUVTUVIUWCUWFVCUVTUVIVAU
        WCUVMUVHIUKZVBZUWFUVIUWCUWHVDUVTUVIUVLUWGUVMUVIUVKUVHIUVIUVHUVJVEVFZVGV
        HUVTUVIUWHUWFUVTUVIUWHVAZVAZUWAUWEUWKUVMUWGUVGUVTUVIUWHVIZUWKLUVHVJUWGU
        VGUOZUWKUVHLUVSUVHVKUOZAUWJUVSUVHUVHMNVLVMZVNUVTUVIUWHVOZVPUWKUWMLUVHUW
        KUWMVQUWGNUTUIUEZVBZLUVHVBZUWKUWMUWRUWKUWGMUWQUDUEZUOZUWMUWRVRZUWKUWTUW
        TUVHIAUWTUWTIWFZUVSUWJAUWTUWTIVSZUXCTUWTUWTIVTWAZWBUWKUVGUWTUVHMNWCZAUV
        SUWJWDWEZWGAUXAUXBVDZUVSUWJANMWHUKZUOZUXHRUWGMNWIWAWBWJWKUWKUWRUWQUVNUK
        ZUVHVBZUWSUWKUXDUVHUWTUOZUWRUXLVCAUXDUVSUWJTWBZUXGUWTUWTUVHUWQIWLWMLUXK
        UVHUCWQWNWOWPWRWSUWKUVRUVOUVHUWKUVPUVRUVOVBUWKUVOUVHLUGUWKUWGUVMVBZUVOU
        VHVBZUWKUVMUWGUWLWTUWKUXDUXMUXOUXPVCUXNUXGUWTUWTUVHUVMIWLWMWRZUWPXAUVPU
        VOUVQVEZWAUXQXBXCXDXEUVTUVIVQZVAUWCUVMUVJIUKZVBZUWFUXSUWCUYAVDUVTUXSUVL
        UXTUVMUXSUVKUVJIUVIUVHUVJXFVFZVGVHUVTUXSUYAUWFUVTUXSUYAVAZVAZUWAUWEUYDU
        VMUXTUVGUVTUXSUYAVIZUYDLUVJVJUXTUVGUOZUYDLUVJALVKUOZUVSUYCALALUWTUOZLXG
        UOZALUXKUWTUCAUWTUWTUWQUVNAUWTUWTUVNXHZUWTUWTUVNWFZAUWTUWTUVNVSZUYJAUXD
        UYLTUWTUWTIXIWAUWTUWTUVNXJWAZUWTUWTUVNXKWAZAUWQUXIUOZUWQUWTUOZAUXJUYORM
        NXLWAMUWQXMWAZWGXNZLMUWQVLWAZVMZWBZUYDLUVHUVJVUAUVSUWNAUYCUWOVNZUYDUWNU
        VJVKUOZVUBUVHXOWAZUYDLUVHXSUHZUXSUVTUXSUYAVOZUYDLUVHVUAVUBXPXQUYDUVHVUB
        XRZXTYAUYDUYFLUVJUYDUYFVQUXTUWQVBZLUVJVBZUYDUYFVUHUYDUXTUWTUOZUYFVUHVRZ
        UYDUWTUWTUVJIAUXCUVSUYCUXEWBUVSUVJUWTUOZAUYCUVHMNYBVNZWGAVUJVUKVDZUVSUY
        CAUXJVUNRUXTMNWIWAWBWJWKUYDVUHUXKUVJVBZVUIUYDUXDVULVUHVUOVCAUXDUVSUYCTW
        BZVUMUWTUWTUVJUWQIWLWMLUXKUVJUCWQWNWOWPWRWSUYDUVRUVQUVJUTUMUEZUVHUYDUVP
        VQZUVRUVQVBUYDUVPUVIVUFUYDUVPUVJLUGUHZUVIUYDUVOUVJLUGUYDUXTUVMVBZUVOUVJ
        VBZUYDUVMUXTUYEWTUYDUXDVULVUTVVAVCVUPVUMUWTUWTUVJUVMIWLWMWRZYCUYDUVHUVJ
        UGUHZVUSUVIVUGUYDUWNVUCUYGVVCVUSVAUVIVCVUBVUDVUAUVHUVJLYDYEYFXEYGUVPUVO
        UVQXFZWAUYDUVOUVJUTUMVVBYHUYDUVHYSUOUTYSUOZVUQUVHVBUYDUVHVUBYJYIUVHUTYK
        YLYMXCXDXEYNYOAUWAUWEUWDUWBUVPUWEUWDVCUWBUVPVAUWEUVHUVOVBZUWDUVPUWEVVFV
        DUWBUVPUVRUVOUVHUXRVGVHUWBUVPVVFUWDUWBUVPVVFVAZVAZUVSUWCVVHUVSMUVHXSUHZ
        UVHNXSUHZVVHUXMVVIVVHUVHUVOUWTUWBUVPVVFVIZVVHUWTUWTUVMUVNAUYKUWAVVGUYNW
        BVVHUVGUWTUVMUXFAUWAVVGWDWEZWGWSZUVHMUWQYPWAVVHVVJUVHUWQUGUHZVVHUVHLUWQ
        VVHUVHVVHUXMUVHXGUOZVVMUVHMUWQVLWAZVMAUYGUWAVVGUYTWBAUWQVKUOZUWAVVGAUWQ
        ANAUXJNXGUOZRMNUUAWAZUUBVMZWBVVHUVHUVOLUGVVKUWBUVPVVFVOXAZALUWQXSUHZUWA
        VVGAUYHVWBUYRLMUWQYQWAWBUUCVVHVVOVVRVVJVVNVDVVPAVVRUWAVVGVVSWBZUVHNUUDW
        MXQVVHVVOMXGUOZVVRUVSVVIVVJVAVDZVVPAVWDUWAVVGAUXJVWDRMNUUEWAZWBVWCUVHMN
        UUFZYEYRVVHUVLUWGUVOIUKZUVMVVHUVIUVLUWGVBVWAUWIWAVVHUVHUVOIVVKVFVVHUXDU
        VMUWTUOZVWHUVMVBZAUXDUWAVVGTWBVVLUWTUWTUVMIUUIZWMYMXCXDXEUWBVURVAUWEUVH
        UVQVBZUWDVURUWEVWLVDUWBVURUVRUVQUVHVVDVGVHUWBVURVWLUWDUWBVURVWLVAZVAZUV
        SUWCVWNUVSVVIVVJVWNMLUVHAMVKUOUWAVWMAMVWFVMWBAUYGUWAVWMUYTWBZVWNUVHVWNU
        VHUVQXGUWBVURVWLVIZVWNUVOXGUOZUVQXGUOVWNUVOUWTUOZVWQVWNUWTUWTUVMUVNAUYK
        UWAVWMUYNWBVWNUVGUWTUVMUXFAUWAVWMWDWEZWGZUVOMUWQVLWAZUVOUUGWAWSZVMZAMLX
        SUHZUWAVWMAUYHVXDUYRLMUWQYPWAWBVWNLUVQUVHXSVWNLUVOUGUHZLUVQXSUHZVWNVXEL
        UVOXSUHZUVOLVJVWNVXGVURUWBVURVWLVOVWNLUVOVWOVWNUVOVXAVMZXPXQVWNLUVOVWNU
        XKUVOVJZLUVOVJVWNVXIUWQUVMVJZUWBVXJVWMUWBUVMUWQUWBUVMUWAUVMXGUOAUVMMNVL
        VHVMZUWBUVMNUWQVXKANVKUOZUWAANVVSVMZYTZAVVQUWAVVTYTUWAUVMNXSUHAUVMMNYQV
        HUWBNVXNXRXTVPYTVWNUXKUVOUWQUVMVWNUYJUYPVWIUXKUVOVBUWQUVMVBVDAUYJUWAVWM
        UYMWBAUYPUWAVWMUYQWBVWSUWTUWTUWQUVMUVNUUHUUJUUKXQLUXKUVOUCUULUUMUUNVWNL
        UVOVWOVXHUUOYRVWNUYIVWQVXEVXFVDAUYIUWAVWMUYSWBVXALUVOUURWMWJVWPUUPZUUQV
        WNUVHUVQNXSVWPVWNUVQNXSUHZUVOUWQXSUHZVWNVWRVXQVWTUVOMUWQYQWAVWNUVOVKUOZ
        VXLVXPVXQVDZVXHAVXLUWAVWMVXMWBVXRUTVKUOVXLVXSUUSUVOUTNUUTUVAWMXQXAVWNVV
        OVWDVVRVWEVXBAVWDUWAVWMVWFWBAVVRUWAVWMVVSWBVWGYEYRVWNUVLUXTVWHUVMVWNUXS
        UVLUXTVBVWNVUEUXSVXOVWNLUVHVWOVXCXPWJUYBWAVWNUVJUVOIVWNUVJUVQUTUIUEZUVO
        VWNUVHUVQUTUIVWPYHVWNUVOYSUOVVEVXTUVOVBVWNUVOVXAUVBYIUVOUTUVCYLUVDVFVWN
        UXDVWIVWJAUXDUWAVWMTWBVWSVWKWMYMXCXDXEYNYOUVEUVF $.

      seqf1olem.9 $e |- ( ph -> A. g A. f
                       ( ( f : ( M ... N ) -1-1-onto-> ( M ... N ) /\
                           g : ( M ... N ) --> C ) ->
            ( seq M ( .+ , ( g o. f ) ) ` N ) = ( seq M ( .+ , g ) ` N ) ) ) $.
      $( Lemma for ~ seqf1o .  (Contributed by Mario Carneiro, 27-Feb-2014.)
         (Revised by Mario Carneiro, 24-Apr-2016.) $)
      seqf1olem2 $p |- ( ph -> ( seq M ( .+ , ( G o. F ) ) ` ( N + 1 ) ) =
                              ( seq M ( .+ , G ) ` ( N + 1 ) ) ) $=
        ( cfz co cres ccom cseq cfv c1 caddc cvv wcel wa cv wf1o wf wceq wi wal
        cfn wfn wss ffn syl fzssp1 fnssres sylancl fnfi syl2anc elex seqf1olem1
        fzfid f1of fex2 syl3anc jca fssres f1oeq1 seqeq3d fveq1d adantl seqfveq
        fvres eqtrd oveq1d adantlr w3a cuz elfzuz3 elfzuz ffvelrnda seqsplit wo
        fco fss biimpa sylan 3syl peano2uz ffvelrnd elfzelz simpr adantr sselda
        cz fzss1 syldan clt wbr cif fveq2d wn cle cr mpbid fvco3 3eqtr4d eqtr2d
        zred oveq12d seqeq1d cmin eluzp1m1 syl2an cc zcnd ax-1cn eleqtrrd fzss2
        wb seqcl 3jca caovassg seqp1 ad2antrr elfzp1 feq1 bi2anan9r coeq1 coeq2
        sylan9eq simpl eqeq12d imbi12d spc2gv syl3c eluzp1p1 seqeq1 eqcomd ccnv
        elfzp12 eluzfz2 syl5eqel seq1 sylan9eqr eluzfz1 eqeltrd seqf1olem2a a1i
        f1ocnv 1z breq1 id oveq1 ifbieq12d fvex elfzle1 lenltd iffalse fzp1elp1
        seqshft2 fveq2i f1ocnvfv2 syl5eq eqtr4d 3eqtrd eluzel2 eluzelz peano2zm
        fvmpt pncan npcan eqeltrrd elfzm11 simp3d iftrue fzp1ss sseldd peano2re
        seqm1 oveq2d jaodan elfzle2 ltp1d lelttrd simplr breqtrrd wne gtned ord
        fzelp1 f1ocnvfv eqeq1i syl6ibr syld necon1ad syl5eqr eqtr3d mpjaodan
        mpd ) APFLOPUGUHZUIZMUJZOUKZULZPUMUNUHZLULZFUHZPFLOUKZULZUYAFUHZUXTFLKU
        JZOUKZULZUXTUYCULZAUXSUYDUYAFAUXSPFUXPOUKZULZUYDAUXPUOUPZMUOUPZUQUXOUXO
        HURZUSZUXOEIURZUTZUQZPFUYPUYNUJZOUKZULZPFUYPOUKZULZVAZVBZHVCIVCUXOUXOMU
        SZUXOEUXPUTZUQZUXSUYKVAZAUYLUYMAUXPVDUPZUYLAUXPUXOVEZUXOVDUPZVUJALOUXTU
        GUHZVEZUXOVUMVFZVUKAVUMELUTZVUNUCVUMELVGVHOPVIZVUMUXOLVJVKAOPVPZUXOUXPV
        LVMUXPVDVNVHAUXOUXOMUTZVULVULUYMAVUFVUSABCDEFGJKLMNOPQRSTUAUBUCUDUEVOZU
        XOUXOMVQVHZVURVURUXOUXOMVDVDVRVSVTUFAVUFVUGVUTAVUPVUOVUGUCVUQVUMEUXOLWA
        VKVTVUEVUHVUIVBIHUXPMUOUOUYPUXPVAZUYNMVAZUQZUYRVUHVUDVUIVVCUYOVUFVVBUYQ
        VUGUXOUXOUYNMWBUXOEUYPUXPUUAUUBVVDVUAUXSVUCUYKVVDPUYTUXRVVDUYSUXQFOVVBV
        VCUYSUXPUYNUJUXQUYPUXPUYNUUCUYNMUXPUUDUUEWCWDVVDPVUBUYJVVDUYPUXPFOVVBVV
        CUUFWCWDUUGUUHUUIUUJAFBUXPLOPTBURZUXOUPZVVEUXPULVVELULVAAVVEUXOLWGWEWFW
        HWIANUXOUPZUYHUYBVANUXTVAZAVVGUQZUYHNUYGULZUXTFUYFNUMUNUHZUKULZFUHZUYBV
        VIBCDFGUYFONUXTAVVEGUPZCURZGUPZUQZVVEVVOFUHZGUPZVVGQWJZAVVNVVPDURZGUPWK
        ZVVRVWAFUHVVEVVOVWAFUHFUHVAZVVGSWJZVVIPNWLULZUPZUXTVVKWLULUPVVGVWFANOPW
        MWEZNPUUKVHZVVGNOWLULZUPZANOPWNWEZAVVEVUMUPZVVEUYFULZGUPZVVGAVUMGVVEUYF
        AVUMEUYFUTZEGVFZVUMGUYFUTAVUPVUMVUMKUTZVWOUCAVUMVUMKUSZVWQUBVUMVUMKVQVH
        ZVUMVUMELKWRVMZUAVUMEGUYFWSVMWOZWJZWPAVVGNOVAZNOUMUNUHZPUGUHZUPZWQZVVMU
        YBVAZAPVWIUPZVVGVXGTVXIVVGVXGNOPUUOWTXAAVXCVXHVXFAVXCUQZVVMNUYFULZVVLFU
        HZPFUXQNUKZULZUYAFUHZUYBVXJVVJVXKVVLFVXCAVVJNFUYFNUKZULZVXKVXCNUYGVXPVX
        CVXPUYGFUYFNOUULUUMWDANVUMUPZNXIUPZVXQVXKVAANUXTKUUNZULZVUMUEAVUMVUMUXT
        VXTAVWRVUMVUMVXTUSVUMVUMVXTUTUBVUMVUMKUVDVUMVUMVXTVQXBAVXIUXTVWIUPUXTVU
        MUPZTOPXCOUXTUUPXBZXDUUQZNOUXTXEZFUYFNUURXBUUSWIAVXCVVGVXLVXOVAZVXJNOUX
        OAVXCXFZAOUXOUPZVXCAVXIVYHTOPUUTVHXGUVAVVIVXLVVLVXKFUHVXOVVIBCDVUMEFGUY
        FNVVKUXTVVTAVVEEUPVVOEUPUQVVRVVOVVEFUHVAVVGRWJVWDVWHAVWPVVGUAXGAVWOVVGV
        WTXGAVXRVVGVYDXGVVIVWJVVKVWIUPVVKUXTUGUHZVUMVFVWKONXCVVKOUXTXJXBZUVBVVI
        VXNVVLUYAVXKFVVIFBUXQUYFUMNPVWGUMXIUPVVIUVEUVCAVVENPUGUHZUPZVVEUXQULZVV
        EUMUNUHZUYFULZVAVVGAVYLUQZVVEMULZUXPULZVYNKULZLULZVYMVYOVYPVYRVYQLULZVY
        TVYPVYQUXOUPZVYRWUAVAZAVYLVVFWUBAVYKUXOVVEAVXRVWJVYKUXOVFVYDNOUXTWNNOPX
        JXBXHZAUXOUXOVVEMVVAWOZXKVYQUXOLWGZVHVYPVYQVYSLVYPVYQVVENXLXMZVVEVYNXNZ
        KULZVYSVYPVVFVYQWUIVAZWUDJVVEJURZNXLXMZWUKWUKUMUNUHZXNZKULWUIUXOMWUKVVE
        VAZWUNWUHKWUOWULWUGWUKWUMVVEVYNWUKVVENXLUVFWUOUVGWUKVVEUMUNUVHUVIXOUDWU
        HKUVJUWDZVHVYPWUGXPZWUIVYSVAVYPNVVEXQXMZWUQVYLWURAVVENPUVKWEVYPNVVEANXR
        UPVYLANAVXRVXSVYDVYEVHZYCXGVYPVVEVYLVVEXIUPZAVVENPXEWEYCUVLXSWUQWUHVYNK
        WUGVVEVYNUVMXOVHWHXOWHAVYLVVFVYMVYRVAZWUDAVUSVVFWVAVVAUXOUXOVVEUXPMXTXA
        ZXKAVYLVYNVUMUPZVYOVYTVAZVYPVVFWVCWUDVVEOPUVNVHAVWQWVCWVDVWSVUMVUMVYNLK
        XTXAXKYAWJUVOAUYAVXKVAVVGAVXKNKULZLULZUYAAVWQVXRVXKWVFVAVWSVYDVUMVUMNLK
        XTVMAWVEUXTLAWVEVYAKULZUXTNVYAKUEUVPAVWRVYBWVGUXTVAZUBVYCVUMVUMUXTKUVQV
        MZUVRXOYBXGYDUVSZXKVXJVXNUXSUYAFVXJPVXMUXRVXJNOFUXQVYGYEWDWIUVTAVXFUQZN
        UMYFUHZUYGULZVXKFUHZVVLFUHZWVLUXRULZVXNFUHZUYAFUHZVVMUYBWVKWVMVXLFUHZWV
        PVXOFUHZWVOWVRWVKWVMWVPVXLVXOFWVKFBUYFUXQOWVLAOXIUPZNVXDWLULUPZWVLVWIUP
        VXFAVXIWWATOPUWAZVHZNVXDPWNZONYGYHZAVVEOWVLUGUHZUPZVWMVYMVAVXFAWWHUQZVV
        EKULZLULZVYRVWMVYMWWIVYRWUAWWKWWIWUBWUCAWWHVVFWUBAWWGUXOVVEAPWVLWLULZUP
        ZWWGUXOVFAUXTUMYFUHZPWWLAPYIUPUMYIUPZWWNPVAAPAVXIPXIUPTOPUWBVHZYJYKPUMU
        WEVKAWVLXIUPZUXTWVLUMUNUHZWLULZUPWWNWWLUPAVXRVXSWWQVYDVYENUWCXBAUXTVWEW
        WSAVXRUXTVWEUPVYDNOUXTWMVHAWWRNWLANYIUPZWWOWWRNVAZANWUSYJYKNUMUWFZVKXOY
        LWVLUXTYGVMUWGZWVLOPYMVHXHZWUEXKWUFVHWWIVYQWWJLWWIVYQWUIWWJWWIVVFWUJWXD
        WUPVHWWIWUGWUIWWJVAZWWIWUTOVVEXQXMZWUGAWWHWUTWXFWUGWKZAWWAVXSWWHWXGYNWW
        DWUSVVEONUWHVMWTUWIWUGWUHVVEKWUGVVEVYNUWJXOZVHWHXOYBAWWHVWLVWMWWKVAZAWW
        GVUMVVEAWWMUXTWWLUPWWGVUMVFWXCWVLPXCWVLOUXTYMXBXHZAVWQVWLWXIVWSVUMVUMVV
        ELKXTZXAXKAWWHVVFWVAWXDWVBXKYAWJWFAVXFVVGVYFAVXEUXONAVXIWWAVXEUXOVFTWWC
        OPUWKXBXHZWVJXKYDAVXFWVMGUPZVXKGUPZVVLGUPZWKWVOWVSVAWVKWXMWXNWXOWVKBCFG
        UYFOWVLWWFAWWHVWNVXFAWWHVWLVWNWXJVXAXKWJAVVQVVSVXFQWJZYOAWXNVXFAEGVXKUA
        AVUMENUYFVWTVYDXDUWLXGAVXFVVGWXOWXLVVIBCFGUYFVVKUXTVWHVVIVVEVYIUPVWLVWN
        VVIVYIVUMVVEVYJXHVXBXKVVTYOXKYPABCDWVMVXKVVLGFSYQXKAVXFWVPGUPZVXNGUPZUY
        AGUPZWKWVRWVTVAWVKWXQWXRWXSWVKBCFGUXQOWVLWWFAWWHVYMGUPZVXFAWWHVVFWXTWXD
        AUXOGVVEUXQAUXOGUXPUTZVUSUXOGUXQUTAVUMGLUTZVUOWYAAVUPVWPWYBUCUAVUMEGLWS
        VMZVUQVUMGUXOLWAVKVVAUXOUXOGUXPMWRVMWOZXKWJWXPYOWVKBCFGUXQNPVXFVWFANVXD
        PWMWEZAVYLWXTVXFAVYLVVFWXTWUDWYDXKWJWXPYOAWXSVXFAVUMGUXTLWYCVYCXDXGYPAB
        CDWVPVXNUYAGFSYQXKYAWVKVVJWVNVVLFAWWAWWBVVJWVNVAVXFWWDWWEFUYFONUWNYHWIW
        VKUXSWVQUYAFWVKUXSWVPPFUXQWWRUKZULZFUHWVQWVKBCDFGUXQOWVLPWXPAVWBVWCVXFS
        WJWVKPVWEWWSWYEWVKWWRNWLWVKWWTWWOWXAWVKNVXFVXSANVXDPXEWEYJYKWXBVKZXOYLW
        WFAVVFWXTVXFWYDWJWPWVKWYGVXNWVPFWVKPWYFVXMWVKWWRNFUXQWYHYEWDUWOWHWIYAUW
        PXKWHAVVHUQZUYHPUYGULZUXTUYFULZFUHZUYBWYIVXIUYHWYLVAAVXIVVHTXGZFUYFOPYR
        VHWYIWYJUXSWYKUYAFWYIFBUYFUXQOPWYMWYIVVFUQZWWKVYRVWMVYMWYNVYRWWJUXPULZW
        WKWYNVYQWWJUXPWYNVYQWUIWWJVVFWUJWYIWUPWEWYNWUGWXEWYNVVEUXTNXLAVVFVVEUXT
        XLXMVVHAVVFUQZVVEPUXTVVFVVEXRUPZAVVFVVEVVEOPXEYCZWEAPXRUPZVVFAPWWPYCXGZ
        WYPWYSUXTXRUPWYTPUWMVHVVFVVEPXQXMAVVEOPUWQWEWYPPWYTUWRUWSWJAVVHVVFUWTUX
        AZWXHVHWHXOWYNWWJUXOUPZWYOWWKVAWYNNVVEUXBXUBWYNVVENVVFWYQWYIWYRWEXUAUXC
        WYNXUBNVVEWYNXUBXPWWJUXTVAZNVVEVAZWYNXUBXUCWYNWWJVUMUPZXUBXUCWQZWYNVUMV
        UMVVEKAVWQVVHVVFVWSYSVVFVWLWYIVVEOPUXEZWEZXDWYNVXIXUEXUFYNAVXIVVHVVFTYS
        WWJOPYTVHXSUXDWYNXUCVYAVVEVAZXUDWYNVWRVWLXUCXUIVBAVWRVVHVVFUBYSXUHVUMVU
        MVVEUXTKUXFVMNVYAVVEUEUXGUXHUXIUXJUXNWWJUXOLWGVHYBAVVFWXIVVHAVWQVWLWXIV
        VFVWSXUGWXKYHWJAVVFWVAVVHWVBWJYAWFWYIWYKUXTKULZLULZUYAAWYKXUKVAZVVHAVWQ
        VYBXULVWSVYCVUMVUMUXTLKXTVMXGWYIXUJUXTLWYIWVGXUJUXTWYIVYAUXTKWYIVYANUXT
        UEAVVHXFUXKXOAWVHVVHWVIXGUXLXOWHYDWHAVXRVVGVVHWQZVYDAVXIVXRXUMYNTNOPYTV
        HXSUXMAVXIUYIUYEVATFLOPYRVHYA $.
    $}

    seqf1o.6 $e |- ( ph -> F : ( M ... N ) -1-1-onto-> ( M ... N ) ) $.
    seqf1o.7 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( G ` x ) e. C ) $.
    seqf1o.8 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                     ( H ` k ) = ( G ` ( F ` k ) ) ) $.
    $( Rearrange a sum via an arbitrary bijection on ` ( M ... N ) ` .
       (Contributed by Mario Carneiro, 27-Feb-2014.)  (Revised by Mario
       Carneiro, 24-Apr-2016.) $)
    seqf1o $p |- ( ph ->
      ( seq M ( .+ , H ) ` N ) = ( seq M ( .+ , G ) ` N ) ) $=
      ( vf vg vt vs vw cfz co cv cfv cmpt ccom cseq wf1o wf wceq eqid fmptd wal
      wa wi cuz wcel c1 caddc oveq2 f1oeq23 syl2anc feq2d anbi12d fveq2 eqeq12d
      wb imbi12d 2albidv imbi2d weq f1of adantr elfz3 fvco3 syl2anr ffvelrn csn
      cz fzsn eleq2d elsni syl6bi imp syldan adantrr fveq2d eqtrd seq1 alrimivv
      3eqtr4d ex a1d f1oeq1 bi2anan9r coeq1 coeq2 sylan9eq seqeq3d fveq1d simpl
      feq1 cbval2v ccnv clt wbr cif simplll sylan w3a simpllr wss simprl simprr
      syl simplr sylib seqf1olem2 exp31 syl5bir alrimdv syl5bi expcom a2d mpcom
      uzind4 cfn cvv wfn fvex fnmpti fzfi fvmpt seqfveq fnfi mp2an ovex syl3anc
      a1i fex2 spc2gv sylancr mpd mp2and ffvelrnda adantl 3eqtr3d ) AMFBLMUGUHZ
      BUIZJUJZUKZIULZLUMZUJZMFUUQLUMZUJZMFKLUMUJMFJLUMUJAUUNUUNIUNZUUNEUUQUOZUU
      TUVBUPZSABUUNUUPEUUQTUUQUQZURAUUNUUNUBUIZUNZUUNEUCUIZUOZUTZMFUVIUVGULZLUM
      ZUJZMFUVILUMZUJZUPZVAZUBUSUCUSZUVCUVDUTZUVEVAZMLVBUJZVCAUVSQALUUOUGUHZUWC
      UVGUNZUWCEUVIUOZUTZUUOUVMUJZUUOUVOUJZUPZVAZUBUSUCUSZVAALLUGUHZUWLUVGUNZUW
      LEUVIUOZUTZLUVMUJZLUVOUJZUPZVAZUBUSUCUSZVAALHUIZUGUHZUXBUVGUNZUXBEUVIUOZU
      TZUXAUVMUJZUXAUVOUJZUPZVAZUBUSUCUSZVAALUXAVDVEUHZUGUHZUXLUVGUNZUXLEUVIUOZ
      UTZUXKUVMUJZUXKUVOUJZUPZVAZUBUSZUCUSZVAAUVSVABHLMUUOLUPZUWKUWTAUYBUWJUWSU
      CUBUYBUWFUWOUWIUWRUYBUWDUWMUWEUWNUYBUWCUWLUPZUYCUWDUWMVMUUOLLUGVFZUYDUWCU
      WLUWCUWLUVGVGVHUYBUWCUWLEUVIUYDVIVJUYBUWGUWPUWHUWQUUOLUVMVKUUOLUVOVKVLVNV
      OVPBHVQZUWKUXJAUYEUWJUXIUCUBUYEUWFUXEUWIUXHUYEUWDUXCUWEUXDUYEUWCUXBUPZUYF
      UWDUXCVMUUOUXALUGVFZUYGUWCUXBUWCUXBUVGVGVHUYEUWCUXBEUVIUYGVIVJUYEUWGUXFUW
      HUXGUUOUXAUVMVKUUOUXAUVOVKVLVNVOVPUUOUXKUPZUWKUYAAUYHUWJUXSUCUBUYHUWFUXOU
      WIUXRUYHUWDUXMUWEUXNUYHUWCUXLUPZUYIUWDUXMVMUUOUXKLUGVFZUYJUWCUXLUWCUXLUVG
      VGVHUYHUWCUXLEUVIUYJVIVJUYHUWGUXPUWHUXQUUOUXKUVMVKUUOUXKUVOVKVLVNVOVPUUOM
      UPZUWKUVSAUYKUWJUVRUCUBUYKUWFUVKUWIUVQUYKUWDUVHUWEUVJUYKUWCUUNUPZUYLUWDUV
      HVMUUOMLUGVFZUYMUWCUUNUWCUUNUVGVGVHUYKUWCUUNEUVIUYMVIVJUYKUWGUVNUWHUVPUUO
      MUVMVKUUOMUVOVKVLVNVOVPLWEVCZUWTAUYNUWSUCUBUYNUWOUWRUYNUWOUTZLUVLUJZLUVIU
      JZUWPUWQUYOUYPLUVGUJZUVIUJZUYQUWOUWLUWLUVGUOZLUWLVCZUYPUYSUPUYNUWMUYTUWNU
      WLUWLUVGVRZVSLVTZUWLUWLLUVIUVGWAWBUYOUYRLUVIUYNUWMUYRLUPZUWNUYNUWMUYRUWLV
      CZVUDUWMUYTVUAVUEUYNVUBVUCUWLUWLLUVGWCWBUYNVUEVUDUYNVUEUYRLWDZVCVUDUYNUWL
      VUFUYRLWFWGUYRLWHWIWJWKWLWMWNUYNUWPUYPUPUWOFUVLLWOVSUYNUWQUYQUPUWOFUVILWO
      VSWQWRWPWSUXAUWBVCZAUXJUYAAVUGUXJUYAVAUXJUXBUXBUDUIZUNZUXBEUEUIZUOZUTZUXA
      FVUJVUHULZLUMZUJZUXAFVUJLUMZUJZUPZVAZUDUSUEUSZAVUGUTZUYAUXIVUSUCUBUEUDUCU
      EVQZUBUDVQZUTZUXEVULUXHVURVVCUXCVUIVVBUXDVUKUXBUXBUVGVUHWTUXBEUVIVUJXHXAV
      VDUXFVUOUXGVUQVVDUXAUVMVUNVVDUVLVUMFLVVBVVCUVLVUJUVGULVUMUVIVUJUVGXBUVGVU
      HVUJXCXDXEXFVVDUXAUVOVUPVVDUVIVUJFLVVBVVCXGXEXFVLVNXIZVVAVUTUXTUCVVAVUTUX
      SUBVUTUXJVVAUXSVVEVVAUXJUXOUXRVVAUXJUTZUXOUTZBCDEFGUDUEUFUVGUVIUFUXBUFUIZ
      UXKUVGXJUJZXKXLVVHVVHVDVEUHXMUVGUJUKZVVILUXAVVGAUUOGVCZCUIZGVCZUTUUOVVLFU
      HZGVCAVUGUXJUXOXNZNXOVVGAUUOEVCVVLEVCUTVVNVVLUUOFUHUPVVOOXOVVGAVVKVVMDUIZ
      GVCXPVVNVVPFUHUUOVVLVVPFUHFUHUPVVOPXOAVUGUXJUXOXQVVGAEGXRVVORYAVVFUXMUXNX
      SVVFUXMUXNXTVVJUQVVIUQVVGUXJVUTVVAUXJUXOYBVVEYCYDYEYFYGYGYHYIYJYLYKAUUQYM
      VCZIYNVCZUVSUWAVAUUQUUNYOUUNYMVCVVQBUUNUUPUUQUUOJYPUVFYQLMYRUUNUUQUUAUUBA
      UUNUUNIUOZUUNYNVCZVVTVVRAUVCVVSSUUNUUNIVRYAZVVTALMUGUUCUUEZVWBUUNUUNIYNYN
      UUFUUDUVRUWAUCUBUUQIYMYNUVIUUQUPZUVGIUPZUTZUVKUVTUVQUVEVWDUVHUVCVWCUVJUVD
      UUNUUNUVGIWTUUNEUVIUUQXHXAVWEUVNUUTUVPUVBVWEMUVMUUSVWEUVLUURFLVWCVWDUVLUU
      QUVGULUURUVIUUQUVGXBUVGIUUQXCXDXEXFVWEMUVOUVAVWEUVIUUQFLVWCVWDXGXEXFVLVNU
      UGUUHUUIUUJAFHUURKLMQAUXAUUNVCZUTZUXAIUJZUUQUJZVWHJUJZUXAUURUJZUXAKUJVWGV
      WHUUNVCVWIVWJUPAUUNUUNUXAIVWAUUKBVWHUUPVWJUUNUUQUUOVWHJVKUVFVWHJYPYSYAAVV
      SVWFVWKVWIUPVWAUUNUUNUXAUUQIWAXOUAWQYTAFHUUQJLMQVWFUXAUUQUJUXAJUJZUPABUXA
      UUPVWLUUNUUQUUOUXAJVKUVFUXAJYPYSUULYTUUM $.
  $}

  ${
    $d k x y z F $.  $d k x y z G $.  $d k x y z M $.  $d k x y z ph $.
    $d k z H $.  $d k x y z N $.
    seradd.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seradd.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. CC ) $.
    seradd.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. CC ) $.
    seradd.4 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                     ( H ` k ) = ( ( F ` k ) + ( G ` k ) ) ) $.
    $( The sum of two infinite series.  (Contributed by NM, 17-Mar-2005.)
       (Revised by Mario Carneiro, 26-May-2014.) $)
    seradd $p |- ( ph -> ( seq M ( + , H ) ` N ) =
                   ( ( seq M ( + , F ) ` N ) + ( seq M ( + , G ) ` N ) ) ) $=
      ( vx vy vz caddc cc cv wcel co adantl wa addcl addcom w3a addass seqcaopr
      wceq ) ALMNOPBCDEFGLQZPRZMQZPRZUAZUHUJOSZPRAUHUJUBTULUMUJUHOSUGAUHUJUCTUI
      UKNQZPRUDUMUNOSUHUJUNOSOSUGAUHUJUNUETHIJKUF $.
  $}

  ${
    $d k w x y z F $.  $d k w x y z G $.  $d k w x y z M $.  $d k w x y z ph $.
    $d k z H $.  $d k x y z N $.
    sersub.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    sersub.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. CC ) $.
    sersub.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. CC ) $.
    sersub.4 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                     ( H ` k ) = ( ( F ` k ) - ( G ` k ) ) ) $.
    $( The difference of two infinite series.  (Contributed by NM,
       17-Mar-2005.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    sersub $p |- ( ph -> ( seq M ( + , H ) ` N ) =
                   ( ( seq M ( + , F ) ` N ) - ( seq M ( + , G ) ` N ) ) ) $=
      ( vx caddc cmin cc cv wcel wa co adantl vy vz vw addcl subcl wceq addsub4
      eqcomd seqcaopr2 ) ALUAUBUCMNOBCDEFGLPZOQUAPZOQRZUJUKMSZOQAUJUKUDTULUJUKN
      SOQAUJUKUETULUBPZOQUCPZOQRRZUJUNNSUKUONSMSZUMUNUOMSNSZUFAUPURUQUJUKUNUOUG
      UHTHIJKUI $.
  $}

  ${
    $d x y .+ $.  $d x y F $.  $d x y M $.  $d x y ph $.  $d x y Z $.
    $d x N $.
    seqid3.1 $e |- ( ph -> ( Z .+ Z ) = Z ) $.
    seqid3.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqid3.3 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( F ` x ) = Z ) $.
    $( A sequence that consists entirely of zeroes (or whatever the identity
       ` Z ` is for operation ` .+ ` ) sums to zero.  (Contributed by Mario
       Carneiro, 15-Dec-2014.) $)
    seqid3 $p |- ( ph -> ( seq M ( .+ , F ) ` N ) = Z ) $=
      ( vy cfv wcel wceq cv co wa elsnc sylibr elsni cseq fvex oveqan12d eleq1d
      csn cfz ovex syl5ibrcom imp seqcl syl ) AFCDEUALZGUEZMULGNABKCUMDEFIABOZE
      FUFPMQUNDLZGNUOUMMJUOGUNDUBRSAUNUMMZKOZUMMZQZUNUQCPZUMMZAVAUSGGCPZUMMZAVB
      GNVCHVBGGGCUGRSUSUTVBUMUPURUNGUQGCUNGTUQGTUCUDUHUIUJULGTUK $.
  $}

  ${
    $d x y .+ $.  $d x y F $.  $d x y M $.  $d x y N $.  $d x S $.  $d x y Z $.
    $d x y ph $.
    seqid.1 $e |- ( ( ph /\ x e. S ) -> ( Z .+ x ) = x ) $.
    seqid.2 $e |- ( ph -> Z e. S ) $.
    seqid.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqid.4 $e |- ( ph -> ( F ` N ) e. S ) $.
    seqid.5 $e |- ( ( ph /\ x e. ( M ... ( N - 1 ) ) ) -> ( F ` x ) = Z ) $.
    $( Discard the first few terms of a sequence that starts with all zeroes
       (or whatever the identity ` Z ` is for operation ` .+ ` ).  (Contributed
       by Mario Carneiro, 13-Jul-2013.)  (Revised by Mario Carneiro,
       27-May-2014.) $)
    seqid $p |- ( ph -> ( seq M ( .+ , F ) |` ( ZZ>= ` N ) ) =
                          seq N ( .+ , F ) ) $=
      ( wceq cfv c1 co cuz wcel adantr cseq caddc cz eluzelz seq1 seqeq1 fveq1d
      3syl eqeq1d syl5ibcom wa cmin eluzel2 seqm1 sylan cv wral ralrimiva oveq2
      syl id eqeq12d rspcv sylc eluzp1m1 cfz adantlr seqid3 oveq1d 3eqtrd ex wo
      uzp1 mpjaod eqidd seqfeq2 ) ACBEEGFKAGFNZGCEFUAZOZGEOZNZGFPUBQROSZAGCEGUA
      ZOZVTNZVQWAAGFROZSZGUCSWEKFGUDCEGUEUHVQWDVSVTVQGWCVRCEGFUFUGUIUJAWBWAAWBU
      KZVSGPULQZVROZVTCQZHVTCQZVTAFUCSZWBVSWKNAWGWMKFGUMUTZCEFGUNUOWHWJHVTCWHBC
      EFWIHAHHCQZHNZWBAHDSHBUPZCQZWQNZBDUQZWPJAWSBDIURZWSWPBHDWQHNZWRWOWQHWQHHC
      USXBVAVBVCVDTAWMWBWIWFSWNFGVEUOAWQFWIVFQSWQEOZHNWBMVGVHVIWHVTDSZWTWLVTNZA
      XDWBLTAWTWBXATWSXEBVTDWQVTNZWRWLWQVTWQVTHCUSXFVAVBVCVDVJVKAWGVQWBVLKFGVMU
      TVNAWQGPUBQROSUKXCVOVP $.
  $}

  ${
    $d n x F $.  $d n x K $.  $d n x M $.  $d n x N $.  $d n x ph $.  $d x S $.
    $d n x .+ $.  $d x Z $.
    seqid2.1 $e |- ( ( ph /\ x e. S ) -> ( x .+ Z ) = x ) $.
    seqid2.2 $e |- ( ph -> K e. ( ZZ>= ` M ) ) $.
    seqid2.3 $e |- ( ph -> N e. ( ZZ>= ` K ) ) $.
    seqid2.4 $e |- ( ph -> ( seq M ( .+ , F ) ` K ) e. S ) $.
    seqid2.5 $e |- ( ( ph /\ x e. ( ( K + 1 ) ... N ) ) -> ( F ` x ) = Z ) $.
    $( The last few terms of a sequence that ends with all zeroes (or whatever
       the identity ` Z ` is for operation ` .+ ` ) are all the same.
       (Contributed by Mario Carneiro, 13-Jul-2013.)  (Revised by Mario
       Carneiro, 27-May-2014.) $)
    seqid2 $p |- ( ph ->
      ( seq M ( .+ , F ) ` K ) = ( seq M ( .+ , F ) ` N ) ) $=
      ( co wcel cfv wceq wi fveq2 vn cfz cseq cuz eluzfz2 syl cv c1 caddc eleq1
      eqeq2d imbi12d imbi2d cz eqidd a1ii wa peano2fzr adantl expr imim1d oveq1
      wral eluzp1p1 ad2antrl elfzuz3 ad2antll elfzuzb sylanbrc ralrimiva adantr
      eqeq1d rspcv sylc oveq2d id eqeq12d eqtr2d simprl uztrn syl2anc seqp1 a2d
      syl5ibr syld expcom uzind4 mpcom mpd ) AHFHUBOZPZFCEGUCZQZHWLQZRZAHFUDQZP
      ZWKLFHUEUFWQAWKWOSZLABUGZWJPZWMWSWLQZRZSZSAFWJPZWMWMRZSZSAUAUGZWJPZWMXGWL
      QZRZSZSAXGUHUIOZWJPZWMXLWLQZRZSZSAWRSBUAFHWSFRZXCXFAXQWTXDXBXEWSFWJUJXQXA
      WMWMWSFWLTUKULUMWSXGRZXCXKAXRWTXHXBXJWSXGWJUJXRXAXIWMWSXGWLTUKULUMWSXLRZX
      CXPAXSWTXMXBXOWSXLWJUJXSXAXNWMWSXLWLTUKULUMWSHRZXCWRAXTWTWKXBWOWSHWJUJXTX
      AWNWMWSHWLTUKULUMFUNPAXFXDWMUOUPXGWPPZAXKXPAYAXKXPSAYAUQZXKXMXJSXPYBXMXHX
      JAYAXMXHYAXMUQZXHAXGFHURUSUTVAYBXMXJXOAYAXMXJXOSXJXOAYCUQZWMXLEQZCOZXIYEC
      OZRWMXIYECVBYDWMYFXNYGYDYFWMICOZWMYDYEIWMCYDXLFUHUIOZHUBOZPZWSEQZIRZBYJVC
      ZYEIRZYDXLYIUDQPZHXLUDQPZYKYAYPAXMFXGVDVEXMYQAYAXLFHVFVGXLYIHVHVIAYNYCAYM
      BYJNVJVKYMYOBXLYJXSYLYEIWSXLETVLVMVNVOAYHWMRZYCAWMDPWSICOZWSRZBDVCYRMAYTB
      DJVJYTYRBWMDWSWMRZYSYHWSWMWSWMICVBUUAVPVQVMVNVKVRYDXGGUDQZPZXNYGRYDYAFUUB
      PZUUCAYAXMVSAUUDYCKVKFXGGVTWACEGXGWBUFVQWDUTWCWEWFWCWGWHWI $.
  $}

  ${
    $d n x y F $.  $d n x y H $.  $d n x y M $.  $d n x y N $.  $d n x y ph $.
    $d n x G $.  $d x y K $.  $d n x y .+ $.  $d n x y Q $.  $d x y S $.
    $d x y Z $.
    seqhomo.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqhomo.2 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( F ` x ) e. S ) $.
    ${
      seqhomo.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      seqhomo.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                        ( H ` ( x .+ y ) ) = ( ( H ` x ) Q ( H ` y ) ) ) $.
      seqhomo.5 $e |- ( ( ph /\ x e. ( M ... N ) ) ->
                        ( H ` ( F ` x ) ) = ( G ` x ) ) $.
      $( Apply a homomorphism to a sequence.  (Contributed by Mario Carneiro,
         28-Jul-2013.)  (Revised by Mario Carneiro, 27-May-2014.) $)
      seqhomo $p |- ( ph -> ( H ` ( seq M ( .+ , F ) ` N ) ) =
                                  ( seq M ( Q , G ) ` N ) ) $=
        ( wcel cfv wceq wi vn cfz co cseq cuz eluzfz2 syl cv caddc eleq1 fveq2d
        c1 fveq2 eqeq12d imbi12d imbi2d cz wral eluzfz1 ralrimiva rspcv eluzel2
        sylc seq1 3syl 3eqtr4d a1d a1i wa simprl simprr peano2fzr syl2anc oveq1
        expr imim1d seqp1 ad2antrl ralrimivva adantr wss elfzuz3 sselda adantlr
        fzss2 syldan seqcl eleq1d oveq1d oveq2 oveq2d rspc2v mpd 3eqtrd syl5ibr
        a2d syld expcom uzind4 mpcom ) AKJKUBUCZQZKDGJUDZRZIRZKEHJUDZRZSZAKJUER
        ZQZXBNJKUFUGXJAXBXHTZNABUHZXAQZXLXCRZIRZXLXFRZSZTZTAJXAQZJXCRZIRZJXFRZS
        ZTZTZAUAUHZXAQZYFXCRZIRZYFXFRZSZTZTAYFULUIUCZXAQZYMXCRZIRZYMXFRZSZTZTAX
        KTBUAJKXLJSZXRYDAYTXMXSXQYCXLJXAUJYTXOYAXPYBYTXNXTIXLJXCUMUKXLJXFUMUNUO
        UPXLYFSZXRYLAUUAXMYGXQYKXLYFXAUJUUAXOYIXPYJUUAXNYHIXLYFXCUMUKXLYFXFUMUN
        UOUPXLYMSZXRYSAUUBXMYNXQYRXLYMXAUJUUBXOYPXPYQUUBXNYOIXLYMXCUMUKXLYMXFUM
        UNUOUPXLKSZXRXKAUUCXMXBXQXHXLKXAUJUUCXOXEXPXGUUCXNXDIXLKXCUMUKXLKXFUMUN
        UOUPYEJUQQZAYCXSAJGRZIRZJHRZYAYBAXSXLGRZIRZXLHRZSZBXAURZUUFUUGSZAXJXSNJ
        KUSUGAUUKBXAPUTZUUKUUMBJXAYTUUIUUFUUJUUGYTUUHUUEIXLJGUMUKXLJHUMUNVAVCAX
        TUUEIAXJUUDXTUUESNJKVBZDGJVDVEUKAXJUUDYBUUGSNUUOEHJVDVEVFVGVHYFXIQZAYLY
        SAUUPYLYSTAUUPVIZYLYNYKTYSUUQYNYGYKAUUPYNYGAUUPYNVIZVIZUUPYNYGAUUPYNVJZ
        AUUPYNVKZYFJKVLVMZVOVPUUQYNYKYRAUUPYNYKYRTYKYRUUSYIYMHRZEUCZYJUVCEUCZSY
        IYJUVCEVNUUSYPUVDYQUVEUUSYPYHYMGRZDUCZIRZYIUVFIRZEUCZUVDUUSYOUVGIUUPYOU
        VGSAYNDGJYFVQVRUKUUSXLCUHZDUCZIRZXLIRZUVKIRZEUCZSZCFURBFURZUVHUVJSZAUVR
        UURAUVQBCFFOVSVTUUSYHFQUVFFQZUVRUVSTUUSBCDFGJYFUUTUUSXLJYFUBUCZQXMUUHFQ
        ZUUSUWAXAXLUUSYGKYFUERQUWAXAWAUVBYFJKWBYFJKWEVEWCAXMUWBUURMWDWFAXLFQUVK
        FQVIUVLFQUURLWDWGUUSYNUWBBXAURZUVTUVAAUWCUURAUWBBXAMUTVTUWBUVTBYMXAUUBU
        UHUVFFXLYMGUMZWHVAVCUVQUVSYHUVKDUCZIRZYIUVOEUCZSBCYHUVFFFXLYHSZUVMUWFUV
        PUWGUWHUVLUWEIXLYHUVKDVNUKUWHUVNYIUVOEXLYHIUMWIUNUVKUVFSZUWFUVHUWGUVJUW
        IUWEUVGIUVKUVFYHDWJUKUWIUVOUVIYIEUVKUVFIUMWKUNWLVMWMUUSUVIUVCYIEUUSYNUU
        LUVIUVCSZUVAAUULUURUUNVTUUKUWJBYMXAUUBUUIUVIUUJUVCUUBUUHUVFIUWDUKXLYMHU
        MUNVAVCWKWNUUPYQUVESAYNEHJYFVQVRUNWOVOWPWQWRWPWSWTWM $.
    $}

    seqz.3 $e |- ( ( ph /\ x e. S ) -> ( Z .+ x ) = Z ) $.
    seqz.4 $e |- ( ( ph /\ x e. S ) -> ( x .+ Z ) = Z ) $.
    seqz.5 $e |- ( ph -> K e. ( M ... N ) ) $.
    seqz.6 $e |- ( ph -> N e. V ) $.
    seqz.7 $e |- ( ph -> ( F ` K ) = Z ) $.
    $( If the operation ` .+ ` has an absorbing element ` Z ` (a.k.a. zero
       element), then any sequence containing a ` Z ` evaluates to ` Z ` .
       (Contributed by Mario Carneiro, 27-May-2014.) $)
    seqz $p |- ( ph -> ( seq M ( .+ , F ) ` N ) = Z ) $=
      ( wcel wceq cseq cfv cfz co cuz elfzuz syl c1 caddc cz eluzelz seq1 eqtrd
      seqeq1 fveq1d eqeq1d syl5ibcom wa cmin eluzel2 seqm1 sylan adantr cv wral
      oveq2d eluzp1m1 wss fzssp1 cc ax-1cn npcan sylancl syl5sseq elfzuz3 fzss2
      zcnd sstrd sselda adantlr syldan seqcl ralrimiva oveq1 rspcv sylc ex uzp1
      wo mpjaod eqtr4d eqidd seqfveq2 csn fvex elsnc sylibr simprl sylib oveq1d
      elsn simprr oveq2 ovex peano2uz fzss1 seqcl2 elsni ) AIDFHUAZUBIDFGUAZUBZ
      KADBFFGHIAGHIUCUDZSZGHUEUBZSZPGHIUFUGZAGXIUBZKGFUBZAGHTZXQKTZGHUHUIUDUEUB
      SZAGXJUBZKTXSXTAYBXRKAGUJSZYBXRTAXOYCXPHGUKUGZDFGULUGRUMXSYBXQKXSGXJXIDFG
      HUNUOUPUQAYAXTAYAURZXQGUHUSUDZXIUBZXRDUDZKAHUJSZYAXQYHTAXOYIXPHGUTUGZDFHG
      VAVBYEYHYGKDUDZKYEXRKYGDAXRKTZYARVCVFYEYGESBVDZKDUDZKTZBEVEZYKKTZYEBCDEFH
      YFAYIYAYFXNSYJHGVGVBYEYMHYFUCUDZSYMXLSZYMFUBZESZYEYRXLYMAYRXLVHYAAYRHGUCU
      DZXLAHYFUHUIUDZUCUDYRUUBHYFVIAUUCGHUCAGVJSUHVJSUUCGTAGYDVQVKGUHVLVMVFVNAI
      GUEUBSZUUBXLVHAXMUUDPGHIVOUGZGHIVPUGVRVCVSAYSUUAYAMVTWAAYMESCVDZESZURYMUU
      FDUDZESYALVTWBAYPYAAYOBEOWCVCYOYQBYGEYMYGTYNYKKYMYGKDWDUPWEWFUMUMWGAXOXSY
      AWIXPHGWHUGWJRWKUUEAYMGUHUIUDZIUCUDZSZURYTWLWMAXKKWNZSXKKTABCUULEDFGIAYLX
      RUULSRXRKGFWOWPWQAYMUULSZUUGURZURZUUHKTUUHUULSUUOUUHKUUFDUDZKUUOYMKUUFDUU
      OUUMYMKTAUUMUUGWRBKXAWSWTUUOUUGKYMDUDZKTZBEVEZUUPKTZAUUMUUGXBAUUSUUNAUURB
      ENWCVCUURUUTBUUFEYMUUFTUUQUUPKYMUUFKDXCUPWEWFUMUUHKYMUUFDXDWPWQUUEAUUKYSU
      UAAUUJXLYMAUUIXNSZUUJXLVHAXOUVAXPHGXEUGUUIHIXFUGVSMWAXGXKKXHUGUM $.
  $}

  ${
    $d x y .+ $.  $d x y F $.  $d x y M $.  $d x y N $.  $d x y ph $.
    $d x y Q $.  $d x y S $.
    seqfeq4.m $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqfeq4.f $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( F ` x ) e. S ) $.
    seqfeq4.cl $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqfeq4.id $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
        ( x .+ y ) = ( x Q y ) ) $.
    $( Equality of series under different addition operations which agree on an
       additively closed subset.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    seqfeq4 $p |- ( ph ->
      ( seq M ( .+ , F ) ` N ) = ( seq M ( Q , F ) ` N ) ) $=
      ( cfv cid cvv wcel wceq fvi ax-mp cseq fvex cv wa co ovex oveq12i 3eqtr4g
      vex cfz mp1i seqhomo syl5eqr ) AIDGHUAZNZUOONZIEGHUANUOPQUPUORIUNUBUOPSTA
      BCDEFGGOHILKJABUCZFQCUCZFQUDUDUQURDUEZUQUREUEUSONZUQONZURONZEUEMUSPQUTUSR
      UQURDUFUSPSTVAUQVBUREUQPQVAUQRBUIUQPSTURPQVBURRCUIURPSTUGUHUQGNZPQVCONVCR
      AUQHIUJUEQUDUQGUBVCPSUKULUM $.
  $}

  ${
    $d ph a x y $.  $d F a x y $.  $d M a x y $.  $d .+ a x y $.  $d Q a x y $.
    $d S x y $.
    seqfeq3.m $e |- ( ph -> M e. ZZ ) $.
    seqfeq3.f $e |- ( ( ph /\ x e. ( ZZ>= ` M ) ) -> ( F ` x ) e. S ) $.
    seqfeq3.cl $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqfeq3.id $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
        ( x .+ y ) = ( x Q y ) ) $.
    $( Equality of series under different addition operations which agree on an
       additively closed subset.  (Contributed by Stefan O'Rear, 21-Mar-2015.)
       (Revised by Mario Carneiro, 25-Apr-2016.) $)
    seqfeq3 $p |- ( ph -> seq M ( .+ , F ) = seq M ( Q , F ) ) $=
      ( va cfv cseq wcel wfn cv wa co cuz cz seqfn syl cfz simpll elfzuz adantl
      simpr syl2anc adantlr wceq seqfeq4 eqfnfvd ) AMHUANZDGHOZEGHOZAHUBPZUPUOQ
      IDGHUCUDAURUQUOQIEGHUCUDAMRZUOPZSZBCDEFGHUSAUTUIVABRZHUSUETPZSAVBUOPZVBGN
      FPAUTVCUFVCVDVAVBHUSUGUHJUJAVBFPCRZFPSZVBVEDTZFPUTKUKAVFVGVBVEETULUTLUKUM
      UN $.
  $}

  ${
    $d x y z C $.  $d x y z G $.  $d x y z M $.  $d x y z N $.  $d x y z .+ $.
    $d x F $.  $d x y ph $.  $d x y z S $.  $d x y z T $.
    seqdistr.1 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x .+ y ) e. S ) $.
    seqdistr.2 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
                        ( C T ( x .+ y ) ) = ( ( C T x ) .+ ( C T y ) ) ) $.
    seqdistr.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqdistr.4 $e |- ( ( ph /\ x e. ( M ... N ) ) -> ( G ` x ) e. S ) $.
    seqdistr.5 $e |- ( ( ph /\ x e. ( M ... N ) ) ->
                       ( F ` x ) = ( C T ( G ` x ) ) ) $.
    $( The distributive property for series.  (Contributed by Mario Carneiro,
       28-Jul-2013.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    seqdistr $p |- ( ph -> ( seq M ( .+ , F ) ` N ) =
                           ( C T ( seq M ( .+ , G ) ` N ) ) ) $=
      ( vz cfv co wcel cseq cv cmpt wceq oveq2 eqid fvmpt syl ad2antrl ad2antll
      wa ovex oveq12d 3eqtr4d cfz eqtr4d seqhomo seqcl eqtr3d ) AKEIJUARZQFDQUB
      ZGSZUCZRZKEHJUARDUTGSZABCEEFIHVCJKLONABUBZFTZCUBZFTZUKUKZDVFVHESZGSZDVFGS
      ZDVHGSZESVKVCRZVFVCRZVHVCRZESMVJVKFTVOVLUDLQVKVBVLFVCVAVKDGUEVCUFZDVKGULU
      GUHVJVPVMVQVNEVGVPVMUDAVIQVFVBVMFVCVAVFDGUEVRDVFGULUGUIVIVQVNUDAVGQVHVBVN
      FVCVAVHDGUEVRDVHGULUGUJUMUNAVFJKUOSTUKZVFIRZVCRZDVTGSZVFHRVSVTFTWAWBUDOQV
      TVBWBFVCVAVTDGUEVRDVTGULUGUHPUPUQAUTFTVDVEUDABCEFIJKNOLURQUTVBVEFVCVAUTDG
      UEVRDUTGULUGUHUS $.
  $}

  ${
    $d k M $.  $d k N $.  $d k Z $.
    ser0.1 $e |- Z = ( ZZ>= ` M ) $.
    $( The value of the partial sums in a zero-valued infinite series.
       (Contributed by Mario Carneiro, 31-Aug-2013.)  (Revised by Mario
       Carneiro, 15-Dec-2014.) $)
    ser0 $p |- ( N e. Z -> ( seq M ( + , ( Z X. { 0 } ) ) ` N ) = 0 ) $=
      ( vk wcel caddc cc0 csn cxp co wceq 00id a1i cuz cfv eleq2i biimpi cv cc
      cfz wa 0cn elfzuz syl6eleqr adantl fvconst2g sylancr seqid3 ) BCFZEGCHIJZ
      ABHHHGKHLUJMNUJBAOPZFCULBDQRUJESZABUAKFZUBHTFUMCFZUMUKPHLUCUNUOUJUNUMULCU
      MABUDDUEUFCHUMTUGUHUI $.

    $( A zero-valued infinite series is equal to the constant zero function.
       (Contributed by Mario Carneiro, 8-Feb-2014.) $)
    ser0f $p |- ( M e. ZZ -> seq M ( + , ( Z X. { 0 } ) ) = ( Z X. { 0 } ) ) $=
      ( vk cz wcel caddc cc0 csn cxp cseq wceq cv cfv wral ser0 fvconst2 eqtr4d
      c0ex wfn rgen wb cuz seqfn fneq2i sylibr fconst ffn eqfnfv sylancl mpbiri
      wf ax-mp ) AEFZGBHIZJZAKZUPLZDMZUQNZUSUPNZLZDBOZVBDBUSBFUTHVAAUSBCPBHUSSQ
      RUAUNUQBTZUPBTZURVCUBUNUQAUCNZTVDGUPAUDBVFUQCUEUFBUOUPULVEBHSUGBUOUPUHUMD
      BUQUPUIUJUK $.
  $}

  ${
    $d k x y F $.  $d k x G $.  $d k x y M $.  $d k x N $.  $d k x y ph $.
    serge0.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    serge0.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. RR ) $.
    ${
      serge0.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> 0 <_ ( F ` k ) ) $.
      $( A finite sum of nonnegative terms is nonnegative.  (Contributed by
         Mario Carneiro, 8-Feb-2014.)  (Revised by Mario Carneiro,
         27-May-2014.) $)
      serge0 $p |- ( ph -> 0 <_ ( seq M ( + , F ) ` N ) ) $=
        ( vx vy caddc cc0 cv cle wbr cr wcel wa breq2 elrab cfv cfz co sylanbrc
        cseq crab readdcl ad2ant2r addge0 an4s syl2anb adantl seqcl simprbi syl
        ) AEKCDUEUAZLIMZNOZIPUFZQZLUPNOZABJKUSCDEFABMZDEUBUCQRVBCUAZPQLVCNOZVCU
        SQGHURVDIVCPUQVCLNSTUDVBUSQZJMZUSQZRVBVFKUCZUSQZAVEVBPQZLVBNOZRZVFPQZLV
        FNOZRZVIVGURVKIVBPUQVBLNSTURVNIVFPUQVFLNSTVLVORVHPQZLVHNOZVIVJVMVPVKVNV
        BVFUGUHVJVMVKVNVQVBVFUIUJURVQIVHPUQVHLNSTUDUKULUMUTUPPQVAURVAIUPPUQUPLN
        STUNUO $.
    $}

    serle.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. RR ) $.
    serle.4 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) <_ ( G ` k ) ) $.
    $( Comparison of partial sums of two infinite series of reals.
       (Contributed by NM, 27-Dec-2005.)  (Revised by Mario Carneiro,
       27-May-2014.) $)
    serle $p |- ( ph ->
                   ( seq M ( + , F ) ` N ) <_ ( seq M ( + , G ) ` N ) ) $=
      ( vx cc0 caddc cfv cmin co cle wbr wcel cr cseq cvv cv cmpt wa wceq fveq2
      cfz vex oveq12d eqid ovex fvmpt ax-mp resubcld syl5eqel subge0d syl6breqr
      mpbird serge0 recnd a1i sersub breqtrd readdcl adantl seqcl mpbid ) ALFMD
      EUANZFMCEUANZOPZQRVJVIQRALFMKUBKUCZDNZVLCNZOPZUDZEUANVKQABVPEFGABUCZEFUHP
      SUEZVQVPNZVQDNZVQCNZOPZTVQUBSVSWBUFZBUIKVQVOWBUBVPVLVQUFVMVTVNWAOVLVQDUGV
      LVQCUGUJVPUKVTWAOULUMUNZVRVTWAIHUOUPVRLWBVSQVRLWBQRWAVTQRJVRVTWAIHUQUSWDU
      RUTABDCVPEFGVRVTIVAVRWAHVAWCVRWDVBVCVDAVIVJABKMTDEFGIVQTSVLTSUEVQVLMPTSAV
      QVLVEVFZVGABKMTCEFGHWEVGUQVH $.
  $}

  ${
    $d j k A $.  $d j N $.
    $( Value of the partial series sum of a constant function.  (Contributed by
       NM, 8-Aug-2005.)  (Revised by Mario Carneiro, 16-Feb-2014.) $)
    ser1const $p |- ( ( A e. CC /\ N e. NN ) ->
                   ( seq 1 ( + , ( NN X. { A } ) ) ` N ) = ( N x. A ) ) $=
      ( vj vk cn wcel cc caddc c1 cmul co wceq cv wi fveq2 oveq1 eqeq12d imbi2d
      cfv fvconst2g csn cxp cseq 1z 1nn mpan2 mulid2 eqtr4d seq1i wa seqp1 nnuz
      cuz eleq2s adantl peano2nn sylan2 oveq2d eqtrd nncn ax-1cn adddir syl2anr
      id mp3an2 adantr syl5ibr expcom a2d nnind impcom ) BEFAGFZBHEAUAUBZIUCZSZ
      BAJKZLZVLCMZVNSZVRAJKZLZNVLIVNSZIAJKZLZNVLDMZVNSZWEAJKZLZNVLWEIHKZVNSZWIA
      JKZLZNVLVQNCDBVRILZWAWDVLWMVSWBVTWCVRIVNOVRIAJPQRVRWELZWAWHVLWNVSWFVTWGVR
      WEVNOVRWEAJPQRVRWILZWAWLVLWOVSWJVTWKVRWIVNOVRWIAJPQRVRBLZWAVQVLWPVSVOVTVP
      VRBVNOVRBAJPQRVLWCHVMIUDVLIVMSZAWCVLIEFWQALUEEAIGTUFAUGZUHUIWEEFZVLWHWLVL
      WSWHWLNWHWLVLWSUJZWFAHKZWGAHKZLWFWGAHPWTWJXAWKXBWTWJWFWIVMSZHKZXAWSWJXDLZ
      VLXEWEIUMSEHVMIWEUKULUNUOWTXCAWFHWSVLWIEFXCALWEUPEAWIGTUQURUSWTWKWGWCHKZX
      BWSWEGFZVLWKXFLZVLWEUTVLVDXGIGFVLXHVAWEIAVBVEVCWTWCAWGHVLWCALWSWRVFURUSQV
      GVHVIVJVK $.
  $}

  ${
    $d x y z A $.  $d w x y z F $.  $d x G $.  $d w x y z M $.  $d w x y z N $.
    $d w x y z .+ $.  $d x y z ph $.
    seqof.1 $e |- ( ph -> A e. V ) $.
    seqof.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqof.3 $e |- ( ( ph /\ x e. ( M ... N ) ) ->
      ( F ` x ) = ( z e. A |-> ( G ` x ) ) ) $.
    $( Distribute function operation through a sequence.  Note that ` G ( z ) `
       is an implicit function on ` z ` .  (Contributed by Mario Carneiro,
       3-Mar-2015.) $)
    seqof $p |- ( ph -> ( seq M ( oF .+ , F ) ` N ) =
      ( z e. A |-> ( seq M ( .+ , G ) ` N ) ) ) $=
      ( vw cfv wceq wcel wa cvv fvex vy cof cseq cv cmpt wfn cab cfz wral rgenw
      eqid fnmpt mp1i fneq1d mpbird fneq1 elab sylibr simprl simprr adantr offn
      co inidm ex vex anbi12i 3imtr4g imp seqcl sylib dffn5 fveq1 fvmpt adantlr
      ovex eqidd ofval an32s ax-mp oveq12i 3eqtr4g sylan2b fveq1d simplr fvmpt2
      cuz sylancl eqtrd syl5eq seqhomo eqtr3d mpteq2dva ) AIEUBZFHUCZOZCDCUDZWP
      OZUEZCDIEGHUCOZUEAWPDUFZWPWSPAWPWQDUFZCUGZQXAABUAWNXCFHILABUDZHIUHVCQZRZX
      DFOZDUFZXGXCQZXFXHCDXDGOZUEZDUFZXJSQZCDUIXLXFXMCDXDGTZUJCDXJXKSXKUKZULUMX
      FDXGXKMUNUOXBXHCXGXDFTZDWQXGUPUQURZAXDXCQZUAUDZXCQZRZXDXSWNVCZXCQZAXDDUFZ
      XSDUFZRZYBDUFZYAYCAYFYGAYFRZDDEDXDXSJJAYDYEUSZAYDYEUTZADJQYFKVAZYKDVDZVBV
      EXRYDXTYEXBYDCXDBVFZDWQXDUPUQXBYECXSUAVFZDWQXSUPUQVGZXBYGCYBXDXSWNVPZDWQY
      BUPUQVHVIZVJXBXACWPIWOTZDWQWPUPUQVKCDWPVLVKACDWRWTAWQDQZRZWPNSWQNUDZOZUEZ
      OZWRWTWPSQUUDWRPYTYRNWPUUBWRSUUCWQUUAWPVMUUCUKZWQWPTVNUMYTBUAWNEXCFGUUCHI
      AYAYCYSYQVOAXEXIYSXQVOAIHWGOQYSLVAYAYTYFYBUUCOZXDUUCOZXSUUCOZEVCZPYOYTYFR
      WQYBOZWQXDOZWQXSOZEVCZUUFUUIAYFYSUUJUUMPYHDDUUKUULEDXDXSJJWQYIYJYKYKYLYHY
      SRZUUKVQUUNUULVQVRVSYBSQUUFUUJPYPNYBUUBUUJSUUCWQUUAYBVMUUEWQYBTVNVTUUGUUK
      UUHUULEXDSQUUGUUKPYMNXDUUBUUKSUUCWQUUAXDVMUUEWQXDTVNVTXSSQUUHUULPYNNXSUUB
      UULSUUCWQUUAXSVMUUEWQXSTVNVTWAWBWCYTXERZXGUUCOZWQXGOZXJXGSQUUPUUQPXPNXGUU
      BUUQSUUCWQUUAXGVMUUEWQXGTVNVTUUOUUQWQXKOZXJUUOWQXGXKAXEXGXKPYSMVOWDUUOYSX
      MUURXJPAYSXEWEXNCDXJSXKXOWFWHWIWJWKWLWMWI $.
  $}

  ${
    $d n x y z A $.  $d n x y z M $.  $d n x y z N $.  $d n x y z ph $.
    $d n y z .+ $.  $d n x y B $.  $d n y X $.
    seqof2.1 $e |- ( ph -> A e. V ) $.
    seqof2.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqof2.3 $e |- ( ph -> ( M ... N ) C_ B ) $.
    seqof2.4 $e |- ( ( ph /\ ( x e. B /\ z e. A ) ) -> X e. W ) $.
    $( Distribute function operation through a sequence.  Maps-to notation
       version of ~ seqof .  (Contributed by Mario Carneiro, 7-Jul-2017.) $)
    seqof2 $p |- ( ph ->
      ( seq M ( oF .+ , ( x e. B |-> ( z e. A |-> X ) ) ) ` N ) =
      ( z e. A |-> ( seq M ( .+ , ( x e. B |-> X ) ) ` N ) ) ) $=
      ( vy cmpt cfv wcel nfcv vn cof cseq cv csb cfz co wa wceq wi nfv nffvmpt1
      nfmpt nfeq nfim eleq1 anbi2d fveq2 mpteq2dv eqeq12d imbi12d sselda adantr
      weq cvv mptexg eqid fvmpt2 syl2anc simpll simpr syl12anc mpteq2dva eqtr4d
      syl chvar nfcsb1v nffv csbeq1a fveq1d cbvmpt syl6eq seqof seqeq3d syl6eqr
      nfseq ) AHFUBBECDKQZQZGUCRPDHFCPUDZBEKQZUEZGUCZRZQCDHFWJGUCZRZQAUAPDFWHWK
      GHILMAUAUDZGHUFUGZSZUHZWPWHRZCDWPWJRZQZPDWPWKRZQABUDZWQSZUHZXDWHRZCDXDWJR
      ZQZUIZUJWSWTXBUIZUJBUAWSXKBWSBUKBWTXBBEWGWPULBCDXABDTBEKWPULUMUNUOBUAVDZX
      FWSXJXKXLXEWRAXDWPWQUPUQXLXGWTXIXBXDWPWHURXLCDXHXAXDWPWJURUSUTVAXFXGWGXIX
      FXDESZWGVESZXGWGUIAWQEXDNVBZXFDISZXNAXPXELVCCDKIVFVOBEWGVEWHWHVGVHVIXFCDX
      HKXFCUDDSZUHZXMKJSZXHKUIXFXMXQXOVCZXRAXMXQXSAXEXQVJXTXFXQVKOVLBEKJWJWJVGV
      HVIVMVNVPCPDXAXCPXATCWPWKCWIWJVQZCWPTVRCPVDZWPWJWKCWIWJVSZVTWAWBWCCPDWOWM
      PWOTCHWLCFWKGCGTCFTYAWFCHTVRYBHWNWLYBWJWKFGYCWDVTWAWE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Integer powers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ^ $. $( Exponentiation. $)

  $( Extend class notation to include exponentiation of a complex number to an
     integer power. $)
  cexp $a class ^ $.

  ${
    $d x y $.
    $( Define exponentiation to nonnegative integer powers.  This definition is
       not meant to be used directly; instead, ~ exp0 and ~ expp1 provide the
       standard recursive definition.  The up-arrow notation is used by Donald
       Knuth for iterated exponentiation (_Science_ 194, 1235-1242, 1976) and
       is convenient for us since we don't have superscripts. 10-Jun-2005:  The
       definition was extended to include zero exponents, so that ` 0 ^ 0 = 1 `
       per the convention of Definition 10-4.1 of [Gleason] p. 134.
       4-Jun-2014:  The definition was extended to include negative integer
       exponents.  The case ` x = 0 , y < 0 ` gives the value ` ( 1 / 0 ) ` ,
       so we will avoid this case in our theorems.  (Contributed by Raph
       Levien, 20-May-2004.)  (Revised by NM, 15-Oct-2004.) $)
    df-exp $a |- ^ = ( x e. CC , y e. ZZ |-> if ( y = 0 , 1 , if ( 0 < y ,
                       ( seq 1 ( x. , ( NN X. { x } ) ) ` y ) ,
                 ( 1 / ( seq 1 ( x. , ( NN X. { x } ) ) ` -u y ) ) ) ) ) $.

    $(
    Raph Levien's original definition of 20-May-2004:
    df-exp $a |- ^ = { <. <. x , y >. , z >. | ( ( x e. CC /\ y e. NN0 ) /\
          z = ( ( rec ( { <. w , v >. | v = ( w x. x ) } , 1 ) o.
        `' ( rec ( { <. w , v >. | v = ( w + 1 ) } , 0 ) |` om ) ) ` y ) ) } $.
    $)
  $}

  ${
    $d x y A $.  $d x y N $.
    $( Value of exponentiation to integer powers.  (Contributed by NM,
       20-May-2004.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
    expval $p |- ( ( A e. CC /\ N e. ZZ ) -> ( A ^ N ) =
      if ( N = 0 , 1 , if ( 0 < N ,
                       ( seq 1 ( x. , ( NN X. { A } ) ) ` N ) ,
                 ( 1 / ( seq 1 ( x. , ( NN X. { A } ) ) ` -u N ) ) ) ) ) $=
      ( vx vy cv cc0 wceq c1 clt wbr cmul cn csn cxp cseq cfv cneg cdiv co cif
      cc cz cexp simpr eqeq1d breq2d simpl xpeq2d seqeq3d fveq12d negeqd oveq2d
      wa sneqd ifbieq12d ifbieq2d df-exp 1ex fvex ovex ifex ovmpt2a ) CDABUAUBD
      EZFGZHFVCIJZVCKLCEZMZNZHOZPZHVCQZVIPZRSZTZTBFGZHFBIJZBKLAMZNZHOZPZHBQZVSP
      ZRSZTZTUCVFAGZVCBGZUMZVDVOVNWDHWGVCBFWEWFUDZUEWGVEVPVJVMVTWCWGVCBFIWHUFWG
      VCBVIVSWGVHVRKHWGVGVQLWGVFAWEWFUGUNUHUIZWHUJWGVLWBHRWGVKWAVIVSWIWGVCBWHUK
      UJULUOUPCDUQVOHWDURVPVTWCBVSUSHWBRUTVAVAVB $.
  $}

  ${
    $d x y A $.  $d y N $.
    $( Value of exponentiation to positive integer powers.  (Contributed by
       Mario Carneiro, 4-Jun-2014.) $)
    expnnval $p |- ( ( A e. CC /\ N e. NN ) -> ( A ^ N ) =
                     ( seq 1 ( x. , ( NN X. { A } ) ) ` N ) ) $=
      ( cc wcel cn wa cexp co cc0 wceq clt wbr cmul csn cxp cfv cif syl eqtrd
      c1 cseq cneg cdiv cz nnz expval sylan2 nnne0 neneqd iffalse iftrue adantl
      wn nngt0 ) ACDZBEDZFABGHZBIJZTIBKLZBMEANOTUAZPZTBUBUTPUCHZQZQZVAUPUOBUDDU
      QVDJBUEABUFUGUPVDVAJUOUPVDVCVAUPURUMVDVCJUPBIBUHUIURTVCUJRUPUSVCVAJBUNUSV
      AVBUKRSULS $.
  $}

  $( Value of a complex number raised to the 0th power.  Note that under our
     definition, ` 0 ^ 0 = 1 ` , following the convention used by Gleason.
     Part of Definition 10-4.1 of [Gleason] p. 134.  (Contributed by NM,
     20-May-2004.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
  exp0 $p |- ( A e. CC -> ( A ^ 0 ) = 1 ) $=
    ( cc wcel cc0 cexp co wceq c1 clt wbr cmul cn csn cxp cseq cfv cneg cdiv cz
    cif 0z expval mpan2 eqid iftrue ax-mp syl6eq ) ABCZADEFZDDGZHDDIJDKLAMNHOZP
    HDQUKPRFTZTZHUHDSCUIUMGUAADUBUCUJUMHGDUDUJHULUEUFUG $.

  $( Value of a complex number raised to the first power.  (Contributed by NM,
     20-Oct-2004.)  (Revised by Mario Carneiro, 2-Jul-2013.) $)
  exp1 $p |- ( A e. CC -> ( A ^ 1 ) = A ) $=
    ( cc wcel c1 cexp co cn csn cxp cfv cmul cseq wceq 1nn expnnval mpan2 cz 1z
    seq1 ax-mp syl6eq fvconst2g eqtrd ) ABCZADEFZDGAHIZJZAUDUEDKUFDLJZUGUDDGCZU
    EUHMNADOPDQCUHUGMRKUFDSTUAUDUIUGAMNGADBUBPUC $.

  $( Value of a complex number raised to a nonnegative integer power plus one.
     Part of Definition 10-4.1 of [Gleason] p. 134.  (Contributed by NM,
     20-May-2005.)  (Revised by Mario Carneiro, 2-Jul-2013.) $)
  expp1 $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A ^ ( N + 1 ) ) =
               ( ( A ^ N ) x. A ) ) $=
    ( cn0 wcel cc cn cc0 wceq c1 caddc co cexp cmul wa cfv sylan2 oveq2d oveq1d
    expnnval 3eqtr4d wo elnn0 csn cxp cseq seqp1 nnuz eleq2s peano2nn fvconst2g
    cuz adantl eqtrd exp1 mulid2 eqtr4d adantr simpr 0p1e1 oveq2 exp0 sylan9eqr
    syl6eq jaodan sylan2b ) BCDAEDZBFDZBGHZUAABIJKZLKZABLKZAMKZHZBUBVFVGVMVHVFV
    GNZVIMFAUCUDZIUEZOZBVPOZAMKZVJVLVNVQVRVIVOOZMKZVSVGVQWAHZVFWBBIUKOFMVOIBUFU
    GUHULVNVTAVRMVGVFVIFDZVTAHBUIZFAVIEUJPQUMVGVFWCVJVQHWDAVISPVNVKVRAMABSRTVFV
    HNZAILKZIAMKZVJVLVFWFWGHVHVFWFAWGAUNAUOUPUQWEVIIALWEVIGIJKIWEBGIJVFVHURRUSV
    CQWEVKIAMVHVFVKAGLKIBGALUTAVAVBRTVDVE $.

  $( Value of a complex number raised to a negative integer power.
     (Contributed by Mario Carneiro, 4-Jun-2014.) $)
  expneg $p |- ( ( A e. CC /\ N e. NN0 ) ->
                 ( A ^ -u N ) = ( 1 / ( A ^ N ) ) ) $=
    ( wcel cc cn cc0 wceq cneg cexp co c1 cdiv wa clt wbr cfv adantl syl oveq2d
    wn cn0 wo elnn0 cmul csn cxp cseq cif nnne0 nncn negeq0d necon3abid iffalse
    wne mpbid nnnn0 nn0nlt0 nn0red lt0neg1d negnegd fveq2d 3eqtrd nnnegz expval
    mtbid cz sylan2 expnnval 3eqtr4d ax-1cn div1i eqcomi negeq neg0 syl6eq exp0
    sylan9eqr oveq2 3eqtr4a jaodan sylan2b ) BUACZADCZBECZBFGZUBABHZIJZKABIJZLJ
    ZGZBUCWCWDWJWEWCWDMZWFFGZKFWFNOZWFUDEAUEUFKUGZPZKWFHZWNPZLJZUHZUHZKBWNPZLJZ
    WGWIWKWTWSWRXBWKWLTZWTWSGWKBFUNZXCWDXDWCBUIQWKWLBFWKBWDBDCWCBUJQZUKULUOWLKW
    SUMRWKWMTWSWRGWKBFNOZWMWKWBXFTWDWBWCBUPQZBUQRWKBWKBXGURUSVEWMWOWRUMRWKWQXAK
    LWKWPBWNWKBXEUTVASVBWDWCWFVFCWGWTGBVCAWFVDVGWKWHXAKLABVHSVIWCWEMZKKKLJZWGWI
    XIKKVJVKVLWEWCWGAFIJZKWEWFFAIWEWFFHFBFVMVNVOSAVPZVQXHWHKKLWEWCWHXJKBFAIVRXK
    VQSVSVTWA $.

  $( Value of a complex number raised to a negative integer power.
     (Contributed by Mario Carneiro, 4-Jun-2014.) $)
  expneg2 $p |- ( ( A e. CC /\ N e. CC /\ -u N e. NN0 ) ->
                 ( A ^ N ) = ( 1 / ( A ^ -u N ) ) ) $=
    ( cc wcel cneg cn0 w3a cexp cdiv wceq negneg 3ad2ant2 oveq2d expneg 3adant2
    co c1 eqtr3d ) ACDZBCDZBEZFDZGZAUAEZHPZABHPQAUAHPIPZUCUDBAHTSUDBJUBBKLMSUBU
    EUFJTAUANOR $.

  $( A number to the negative one power is the reciprocal.  (Contributed by
     Mario Carneiro, 4-Jun-2014.) $)
  expn1 $p |- ( A e. CC -> ( A ^ -u 1 ) = ( 1 / A ) ) $=
    ( cc wcel c1 cneg cexp co cdiv cn0 wceq 1nn0 expneg mpan2 exp1 oveq2d eqtrd
    ) ABCZADEFGZDADFGZHGZDAHGQDICRTJKADLMQSADHANOP $.

  ${
    $d x y z w A $.  $d x z B $.  $d x y z w F $.
    expcllem.1 $e |- F C_ CC $.
    expcllem.2 $e |- ( ( x e. F /\ y e. F ) -> ( x x. y ) e. F ) $.
    expcllem.3 $e |- 1 e. F $.
    $( Lemma for proving nonnegative integer exponentiation closure laws.
       (Contributed by NM, 14-Dec-2005.) $)
    expcllem $p |- ( ( A e. F /\ B e. NN0 ) -> ( A ^ B ) e. F ) $=
      ( vz wcel cc0 wceq cexp co wi c1 oveq2 eleq1d imbi2d wa vw cn wo elnn0 cv
      cn0 caddc cc sseli exp1 syl ibir caovcl ancoms adantlr nnnn0 expp1 syl2an
      cmul adantr mpbird exp31 com12 a2d nnind impcom sylan9eqr syl6eqel jaodan
      wb exp0 sylan2b ) DUFJCEJZDUBJZDKLZUCCDMNZEJZDUDVMVNVQVOVNVMVQVMCIUEZMNZE
      JZOVMCPMNZEJZOVMCUAUEZMNZEJZOVMCWCPUGNZMNZEJZOVMVQOIUADVRPLZVTWBVMWIVSWAE
      VRPCMQRSVRWCLZVTWEVMWJVSWDEVRWCCMQRSVRWFLZVTWHVMWKVSWGEVRWFCMQRSVRDLZVTVQ
      VMWLVSVPEVRDCMQRSVMWBVMWACEVMCUHJZWACLEUHCFUIZCUJUKRULWCUBJZVMWEWHVMWOWEW
      HOVMWOWEWHVMWOTZWETWHWDCUSNZEJZVMWEWRWOWEVMWRABWDCEUSGUMUNUOWPWHWRVJWEWPW
      GWQEVMWMWCUFJWGWQLWOWNWCUPCWCUQURRUTVAVBVCVDVEVFVMVOTVPPEVOVMVPCKMNZPDKCM
      QVMWMWSPLWNCVKUKVGHVHVIVL $.

    expcl2lem.4 $e |- ( ( x e. F /\ x =/= 0 ) -> ( 1 / x ) e. F ) $.
    $( Lemma for proving integer exponentiation closure laws.  (Contributed by
       Mario Carneiro, 4-Jun-2014.)  (Revised by Mario Carneiro,
       9-Sep-2014.) $)
    expcl2lem $p |- ( ( A e. F /\ A =/= 0 /\ B e. ZZ ) -> ( A ^ B ) e. F ) $=
      ( wcel cc0 wne co wa wi ex c1 cc eldifsn sseli cz cexp cn0 cr cn elznn0nn
      cneg expcllem adantr cdiv wceq simpll sseldi recnd nnnn0 ad2antll expneg2
      wo simprl syl3anc csn cdif difss simpl sylibr sstri cv cmul syl2an anim1i
      sylbi mulne0 sylanbrc ax-1ne0 mpbir2an syl2anc sylib simprd neeq1 imbi12d
      oveq2 eleq1d vtoclga sylc eqeltrd jaod syl5bi 3impia ) CEJZCKLZDUAJZCDUBM
      ZEJZWKDUCJZDUDJZDUGZUEJZNZURWIWJNZWMDUFWSWNWMWRWIWNWMOWJWIWNWMABCDEFGHUHP
      UIWSWRWMWSWRNZWLQCWPUBMZUJMZEWTCRJDRJWPUCJZWLXBUKWTERCFWIWJWRULUMWTDWSWOW
      QUSUNWQXCWSWOWPUOUPZCDUQUTWTXAEJZXAKLZXBEJZWTEKVAZVBZEXAEXHVCZWTCXIJZXCXA
      XIJZWTWSXKWSWRVDCEKSVEXDABCWPXIXIERXJFVFAVGZXIJZBVGZXIJZNXMXOVHMZEJZXQKLZ
      XQXIJXNXMEJZXOEJZXRXPXIEXMXJTXIEXOXJTGVIXNXMRJZXMKLZNZXORJZXOKLZNZXSXPXNX
      TYCNYDXMEKSXTYBYCERXMFTVJVKXPYAYFNYGXOEKSYAYEYFERXOFTVJVKXMXOVLVIXQEKSVMQ
      XIJQEJQKLHVNQEKSVOUHVPZUMWTXEXFWTXLXEXFNYHXAEKSVQVRYCQXMUJMZEJZOXFXGOAXAE
      XMXAUKZYCXFYJXGXMXAKVSYKYIXBEXMXAQUJWAWBVTXTYCYJIPWCWDWEPWFWGWH $.
  $}

  ${
    $d x y A $.  $d x y N $.
    $( Closure of exponentiation of nonnegative integers.  (Contributed by NM,
       16-Dec-2005.) $)
    nnexpcl $p |- ( ( A e. NN /\ N e. NN0 ) -> ( A ^ N ) e. NN ) $=
      ( vx vy cn nnsscn cv nnmulcl 1nn expcllem ) CDABEFCGDGHIJ $.

    $( Closure of exponentiation of nonnegative integers.  (Contributed by NM,
       14-Dec-2005.) $)
    nn0expcl $p |- ( ( A e. NN0 /\ N e. NN0 ) -> ( A ^ N ) e. NN0 ) $=
      ( vx vy cn0 nn0sscn cv nn0mulcl 1nn0 expcllem ) CDABEFCGDGHIJ $.

    $( Closure of exponentiation of integers.  (Contributed by NM,
       16-Dec-2005.) $)
    zexpcl $p |- ( ( A e. ZZ /\ N e. NN0 ) -> ( A ^ N ) e. ZZ ) $=
      ( vx vy cz zsscn cv zmulcl 1z expcllem ) CDABEFCGDGHIJ $.

    $( Closure of exponentiation of rationals.  (Contributed by NM,
       16-Dec-2005.) $)
    qexpcl $p |- ( ( A e. QQ /\ N e. NN0 ) -> ( A ^ N ) e. QQ ) $=
      ( vx vy cq qsscn cv qmulcl c1 cz wcel 1z zq ax-mp expcllem ) CDABEFCGDGHI
      JKIEKLIMNO $.

    $( Closure of exponentiation of reals.  (Contributed by NM,
       14-Dec-2005.) $)
    reexpcl $p |- ( ( A e. RR /\ N e. NN0 ) -> ( A ^ N ) e. RR ) $=
      ( vx vy cr ax-resscn cv remulcl 1re expcllem ) CDABEFCGDGHIJ $.

    $( Closure law for nonnegative integer exponentiation.  (Contributed by NM,
       26-May-2005.) $)
    expcl $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A ^ N ) e. CC ) $=
      ( vx vy cc ssid cv mulcl ax-1cn expcllem ) CDABEEFCGDGHIJ $.

    $( Closure law for exponentiation of positive reals.  (Contributed by NM,
       24-Feb-2008.)  (Revised by Mario Carneiro, 9-Sep-2014.) $)
    rpexpcl $p |- ( ( A e. RR+ /\ N e. ZZ ) -> ( A ^ N ) e. RR+ ) $=
      ( vx vy crp wcel cz wa cc0 wne cexp co simpl rpne0 adantr simpr cr rpssre
      cc cv ax-resscn sstri rpmulcl 1rp c1 cdiv rpreccl expcl2lem syl3anc ) AEF
      ZBGFZHUJAIJZUKABKLEFUJUKMUJULUKANOUJUKPCDABEEQSRUAUBCTZDTUCUDUMEFUEUMUFLE
      FUMIJUMUGOUHUI $.

    $( Closure of exponentiation of reals.  (Contributed by Mario Carneiro,
       4-Jun-2014.)  (Revised by Mario Carneiro, 9-Sep-2014.) $)
    reexpclz $p |- ( ( A e. RR /\ A =/= 0 /\ N e. ZZ ) ->
                     ( A ^ N ) e. RR ) $=
      ( vx vy cr ax-resscn cv remulcl 1re rereccl expcl2lem ) CDABEFCGZDGHILJK
      $.

    $( Closure of exponentiation of rational numbers.  (Contributed by Mario
       Carneiro, 9-Sep-2014.) $)
    qexpclz $p |- ( ( A e. QQ /\ A =/= 0 /\ N e. ZZ ) -> ( A ^ N ) e. QQ ) $=
      ( vx vy cq qsscn cv qmulcl c1 cz wcel 1z zq ax-mp qreccl expcl2lem ) CDAB
      EFCGZDGHIJKIEKLIMNQOP $.

    $( Closure of exponentiation of negative one.  (Contributed by Mario
       Carneiro, 18-Jun-2015.) $)
    m1expcl2 $p |- ( N e. ZZ -> ( -u 1 ^ N ) e. { -u 1 , 1 } ) $=
      ( vx vy c1 cneg wcel cc0 wne co ax-1cn ax-1ne0 cmul wceq eqeltri syl6eqel
      cc cv jaoi syl cdiv cpr cz cexp negex prid1 negne0i neg1cn prssi mp2an wo
      wss wi elpri sseli mulm1d negeq negnegi 1ex prid2 eqeltrd syl5ibr mulid2d
      oveq1 eleq1d imp oveq2 divneg2 mp3an div1i negeqi eqtr3i adantr expcl2lem
      id mp3an12 ) DEZVPDUAZFVPGHAUBFVPAUCIVQFVPDDUDUEZDJKUFBCVPAVQVPPFDPFZVQPU
      KUGJVPDPUHUIZBQZVQFZCQZVQFZWAWCLIZVQFZWBWAVPMZWADMZUJZWDWFULZWAVPDUMZWGWJ
      WHWDWFWGVPWCLIZVQFWDWLWCEZVQWDWCVQPWCVTUNZUOWDWCVPMZWCDMZUJWMVQFZWCVPDUMW
      OWQWPWOWMVPEZVQWCVPUPWRDVQDJUQVPDURUSZNOWPWMVPVQWCDUPVRORSUTWGWEWLVQWAVPW
      CLVCVDVAWDWFWHDWCLIZVQFWDWTWCVQWDWCWNVBWDVNUTWHWEWTVQWADWCLVCVDVARSVEWSWB
      DWATIZVQFZWAGHWBWIXBWKWGXBWHWGXADVPTIZVQWAVPDTVFXCVPVQDDTIZEZXCVPVSVSDGHX
      EXCMJJKDDVGVHXDDDJVIZVJVKVRNOWHXAXDVQWADDTVFXDDVQXFWSNORSVLVMVO $.

    $( Closure of exponentiation of negative one.  (Contributed by Mario
       Carneiro, 18-Jun-2015.) $)
    m1expcl $p |- ( N e. ZZ -> ( -u 1 ^ N ) e. ZZ ) $=
      ( cz wcel c1 cneg cpr cexp co 1z znegcl ax-mp prssi mp2an m1expcl2 sseldi
      wss ) ABCDEZDFZBQAGHQBCZDBCZRBPTSIDJKIQDBLMANO $.

    $( Closure law for integer exponentiation.  (Contributed by Mario Carneiro,
       4-Jun-2014.) $)
    expclzlem $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) ->
                      ( A ^ N ) e. ( CC \ { 0 } ) ) $=
      ( vx vy cc wcel cc0 wne cz cexp co csn cdif wi wa eldifsn difss cv cmul
      c1 mulcl ad2ant2r mulne0 sylanbrc syl2anb ax-1ne0 mpbir2an cdiv reccl jca
      ax-1cn recne0 3imtr4i adantr expcl2lem 3expia sylanbr anabss3 3impia ) AE
      FZAGHZBIFZABJKEGLZMZFZUTVAVBVENZUTVAOAVDFZVAVFAEGPVGVAVBVECDABVDEVCQCRZVD
      FZVHEFZVHGHZOZDRZEFZVMGHZOZVHVMSKZVDFZVMVDFVHEGPZVMEGPVLVPOVQEFZVQGHVRVJV
      NVTVKVOVHVMUAUBVHVMUCVQEGPUDUETVDFTEFTGHUKUFTEGPUGVITVHUHKZVDFZVKVLWAEFZW
      AGHZOVIWBVLWCWDVHUIVHULUJVSWAEGPUMUNUOUPUQURUS $.

    $( Closure law for integer exponentiation.  (Contributed by Mario Carneiro,
       4-Jun-2014.) $)
    expclz $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) -> ( A ^ N ) e. CC ) $=
      ( cc wcel cc0 wne cz w3a cexp co csn expclzlem eldifad ) ACDAEFBGDHABIJCE
      KABLM $.
  $}

  ${
    nn0expcli.1 $e |- A e. NN0 $.
    nn0expcli.2 $e |- N e. NN0 $.
    $( Closure of exponentiation of nonnegative integers.  (Contributed by
       Mario Carneiro, 17-Apr-2015.) $)
    nn0expcli $p |- ( A ^ N ) e. NN0 $=
      ( cn0 wcel cexp co nn0expcl mp2an ) AEFBEFABGHEFCDABIJ $.
  $}

  $( Exponentiation in terms of predecessor exponent.  (Contributed by NM,
     19-Dec-2005.) $)
  expm1t $p |- ( ( A e. CC /\ N e. NN ) -> ( A ^ N ) =
               ( ( A ^ ( N - 1 ) ) x. A ) ) $=
    ( cc wcel cn wa c1 cmin co caddc cexp cmul wceq ax-1cn npcan sylancl oveq2d
    nncn adantl cn0 nnm1nn0 expp1 sylan2 eqtr3d ) ACDZBEDZFABGHIZGJIZKIZABKIZAU
    GKIALIZUFUIUJMUEUFUHBAKUFBCDGCDUHBMBRNBGOPQSUFUEUGTDUIUKMBUAAUGUBUCUD $.

  ${
    $d x y j N $.  $d j k A $.
    $( Value of one raised to a nonnegative integer power.  (Contributed by NM,
       15-Dec-2005.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
    1exp $p |- ( N e. ZZ -> ( 1 ^ N ) = 1 ) $=
      ( vx vy wcel c1 co wceq cc0 wne cc ax-1cn cv cmul elsni syl6eq ovex elsnc
      wa sylibr cdiv cz cexp csn 1ex snid ax-1ne0 wss snssi ax-mp oveq12 syl2an
      1t1e1 oveq2d div1i adantr expcl2lem mp3an12 syl ) AUADZEAUBFZEUCZDZUTEGEV
      ADEHIUSVBEUDUEZUFBCEAVAEJDVAJUGKEJUHUIBLZVADZCLZVADZRVDVFMFZEGZVHVADVEVDE
      GZVFEGZVIVGVDENZVFENVJVKRVHEEMFEVDEVFEMUJULOUKVHEVDVFMPQSVCVEEVDTFZVADZVD
      HIVEVMEGVNVEVMEETFEVEVDEETVLUMEKUNOVMEEVDTPQSUOUPUQUTENUR $.

    $( Natural number exponentiation is 0 iff its mantissa is 0.  (Contributed
       by NM, 23-Feb-2005.) $)
    expeq0 $p |- ( ( A e. CC /\ N e. NN ) -> ( ( A ^ N ) = 0 <-> A = 0 ) ) $=
      ( vj vk cn wcel cc cexp co wceq wb cv wi c1 oveq2 eqeq1d bibi1d imbi2d wa
      cc0 caddc exp1 wo cn0 nnnn0 cmul expp1 expcl simpl mul0ord sylan2 bi1 idd
      bitrd jaod olc impbid1 sylan9bb exp31 com12 a2d nnind impcom ) BEFAGFZABH
      IZTJZATJZKZVDACLZHIZTJZVGKZMVDANHIZTJZVGKZMVDADLZHIZTJZVGKZMVDAVPNUAIZHIZ
      TJZVGKZMVDVHMCDBVINJZVLVOVDWDVKVNVGWDVJVMTVINAHOPQRVIVPJZVLVSVDWEVKVRVGWE
      VJVQTVIVPAHOPQRVIVTJZVLWCVDWFVKWBVGWFVJWATVIVTAHOPQRVIBJZVLVHVDWGVKVFVGWG
      VJVETVIBAHOPQRVDVMATAUBPVPEFZVDVSWCVDWHVSWCMVDWHVSWCVDWHSWBVRVGUCZVSVGWHV
      DVPUDFZWBWIKVPUEVDWJSZWBVQAUFIZTJWIWKWAWLTAVPUGPWKVQAAVPUHVDWJUIUJUNUKVSW
      IVGVSVRVGVGVRVGULVSVGUMUOVGVRUPUQURUSUTVAVBVC $.
  $}

  $( Natural number exponentiation is nonzero iff its mantissa is nonzero.
     (Contributed by NM, 6-May-2005.) $)
  expne0 $p |- ( ( A e. CC /\ N e. NN ) ->
                  ( ( A ^ N ) =/= 0 <-> A =/= 0 ) ) $=
    ( cc wcel cn wa cexp co cc0 expeq0 necon3bid ) ACDBEDFABGHIAIABJK $.

  $( Nonnegative integer exponentiation is nonzero if its mantissa is nonzero.
     (Contributed by NM, 2-Aug-2006.)  (Revised by Mario Carneiro,
     4-Jun-2014.) $)
  expne0i $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ )
              -> ( A ^ N ) =/= 0 ) $=
    ( cc wcel cc0 wne cz w3a cexp co csn cdif expclzlem eldifsni syl ) ACDAEFBG
    DHABIJZCEKLDPEFABMPCENO $.

  $( Nonnegative integer exponentiation with a positive mantissa is positive.
     (Contributed by NM, 16-Dec-2005.)  (Revised by Mario Carneiro,
     4-Jun-2014.) $)
  expgt0 $p |- ( ( A e. RR /\ N e. ZZ /\ 0 < A ) -> 0 < ( A ^ N ) ) $=
    ( cr wcel cc0 clt wbr cz cexp co wa crp rpexpcl rpgt0d sylanbr 3impa 3com23
    elrp ) ACDZEAFGZBHDZEABIJZFGZSTUAUCSTKALDZUAUCARUDUAKUBABMNOPQ $.

  $( Value of a complex number raised to a negative power.  (Contributed by
     Mario Carneiro, 4-Jun-2014.) $)
  expnegz $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) ->
                 ( A ^ -u N ) = ( 1 / ( A ^ N ) ) ) $=
    ( cc wcel cc0 wne cz cneg cexp co c1 cdiv wceq cr cn0 wo wa elznn0 syl3anc
    wi expneg ad2antrr simpll simprl recnd simprr oveq2d expcl ad2ant2rl simplr
    ex expneg2 nn0zd expne0i recrecd eqtr2d expr jaod expimpd syl5bi 3impia ) A
    CDZAEFZBGDZABHZIJZKABIJZLJZMZVDBNDZBODZVEODZPZQVBVCQZVIBRVNVJVMVIVNVJQVKVIV
    LVBVKVITVCVJVBVKVIABUAUKUBVNVJVLVIVNVJVLQZQZVHKKVFLJZLJVFVPVGVQKLVPVBBCDVLV
    GVQMVBVCVOUCZVPBVNVJVLUDUEVNVJVLUFZABULSUGVPVFVBVLVFCDVCVJAVEUHUIVPVBVCVEGD
    VFEFVRVBVCVOUJVPVEVSUMAVEUNSUOUPUQURUSUTVA $.

  $( Value of zero raised to a natural number power.  (Contributed by NM,
     19-Aug-2004.) $)
  0exp $p |- ( N e. NN -> ( 0 ^ N ) = 0 ) $=
    ( cn wcel cc0 cexp co wceq eqid cc wb 0cn expeq0 mpan mpbiri ) ABCZDAEFDGZD
    DGZDHDICOPQJKDALMN $.

  ${
    $d x y z A $.  $d x z N $.
    $( Nonnegative integer exponentiation with a nonnegative mantissa is
       nonnegative.  (Contributed by NM, 16-Dec-2005.)  (Revised by Mario
       Carneiro, 4-Jun-2014.) $)
    expge0 $p |- ( ( A e. RR /\ N e. NN0 /\ 0 <_ A ) -> 0 <_ ( A ^ N ) ) $=
      ( vz vx vy cr wcel cc0 cle wbr cn0 cexp co wa cv crab breq2 elrab cc c1
      ssrab2 ax-resscn sstri cmul remulcl ad2ant2r mulge0 sylanbrc syl2anb 0le1
      1re mpbir2an expcllem simprbi syl sylanbr 3impa 3com23 ) AFGZHAIJZBKGZHAB
      LMZIJZUSUTVAVCUSUTNAHCOZIJZCFPZGZVAVCVEUTCAFVDAHIQRVGVANVBVFGZVCDEABVFVFF
      SVECFUAUBUCDOZVFGVIFGZHVIIJZNZEOZFGZHVMIJZNZVIVMUDMZVFGZVMVFGVEVKCVIFVDVI
      HIQRVEVOCVMFVDVMHIQRVLVPNVQFGZHVQIJZVRVJVNVSVKVOVIVMUEUFVIVMUGVEVTCVQFVDV
      QHIQRUHUITVFGTFGHTIJZUKUJVEWACTFVDTHIQRULUMVHVBFGVCVEVCCVBFVDVBHIQRUNUOUP
      UQUR $.

    $( Nonnegative integer exponentiation with a mantissa greater than or equal
       to 1 is greater than or equal to 1.  (Contributed by NM, 21-Feb-2005.)
       (Revised by Mario Carneiro, 4-Jun-2014.) $)
    expge1 $p |- ( ( A e. RR /\ N e. NN0 /\ 1 <_ A ) -> 1 <_ ( A ^ N ) ) $=
      ( vz vx vy cr wcel cn0 c1 cle wbr w3a co cv wa breq2 elrab cmul 1re jctl
      cexp crab cc ssrab2 ax-resscn sstri remulcl ad2ant2r 1t1e1 wi 0le1 pm3.2i
      cc0 lemul12a syl2an imp syl5eqbrr an4s sylanbrc syl2anb mpbir2an expcllem
      1le1 sylanbr 3impa 3com23 simprbi syl ) AFGZBHGZIAJKZLABUAMZICNZJKZCFUBZG
      ZIVLJKZVIVKVJVPVIVKVJVPVIVKOAVOGVJVPVNVKCAFVMAIJPQDEABVOVOFUCVNCFUDUEUFDN
      ZVOGVRFGZIVRJKZOZENZFGZIWBJKZOZVRWBRMZVOGZWBVOGVNVTCVRFVMVRIJPQVNWDCWBFVM
      WBIJPQWAWEOWFFGZIWFJKZWGVSWCWHVTWDVRWBUGUHVSWCVTWDWIVSWCOZVTWDOZOIIIRMZWF
      JUIWJWKWLWFJKZVSIFGZUMIJKZOZVSOWPWCOWKWMUJWCVSWPWNWOSUKULZTWCWPWQTIVRIWBU
      NUOUPUQURVNWICWFFVMWFIJPQUSUTIVOGWNIIJKZSVCVNWRCIFVMIIJPQVAVBVDVEVFVPVLFG
      VQVNVQCVLFVMVLIJPQVGVH $.
  $}

  $( Natural number exponentiation with a mantissa greater than 1 is greater
     than 1.  (Contributed by NM, 13-Feb-2005.)  (Revised by Mario Carneiro,
     4-Jun-2014.) $)
  expgt1 $p |- ( ( A e. RR /\ N e. NN /\ 1 < A ) -> 1 < ( A ^ N ) ) $=
    ( cr wcel cn c1 clt wbr w3a cexp 1re a1i simp1 cn0 reexpcl syl2anc cmul cle
    co cc0 simp2 nnnn0d simp3 cmin nnm1nn0 syl wi sylancr mpd expge1 syl3anc wb
    ltle 0lt1 lttrd lemul1 syl112anc mpbid cc recn 3ad2ant1 mulid2d eqcomd wceq
    0re expm1t 3brtr4d ltletrd ) ACDZBEDZFAGHZIZFAABJSZFCDZVLKLZVIVJVKMZVLVIBND
    VMCDVPVLBVIVJVKUAZUBABOPVIVJVKUCZVLFAQSZABFUDSZJSZAQSZAVMRVLFWARHZVSWBRHZVL
    VIVTNDZFARHZWCVPVLVJWEVQBUEUFZVLVKWFVRVLVNVIVKWFUGKVPFAUMUHUIAVTUJUKVLVNWAC
    DZVITAGHWCWDULVOVLVIWEWHVPWGAVTOPVPVLTFATCDVLVELVOVPTFGHVLUNLVRUOFWAAUPUQUR
    VLVSAVLAVIVJAUSDZVKAUTVAZVBVCVLWIVJVMWBVDWJVQABVFPVGVH $.

  ${
    $d j k A $.  $d j k B $.  $d j k M $.  $d j N $.
    $( Natural number exponentiation of a product.  Proposition 10-4.2(c) of
       [Gleason] p. 135, restricted to nonnegative integer exponents.
       (Contributed by NM, 13-Feb-2005.) $)
    mulexp $p |- ( ( A e. CC /\ B e. CC /\ N e. NN0 ) ->
                  ( ( A x. B ) ^ N ) = ( ( A ^ N ) x. ( B ^ N ) ) ) $=
      ( vj cc wcel cmul co cexp wceq wa wi c1 oveq2 oveq12d eqeq12d imbi2d exp0
      cc0 expp1 vk cn0 cv caddc mulcl oveqan12d 1t1e1 syl6eq eqtr4d sylan oveq1
      syl adantr expcl anim12i anandirs simpl syl2anc adantlr adantll sylan9eqr
      mul4 eqtrd exp31 com12 a2d nn0ind exp3acom3r 3imp ) AEFZBEFZCUBFZABGHZCIH
      ZACIHZBCIHZGHZJZVLVJVKVRVJVKKZVMDUCZIHZAVTIHZBVTIHZGHZJZLVSVMSIHZASIHZBSI
      HZGHZJZLVSVMUAUCZIHZAWKIHZBWKIHZGHZJZLVSVMWKMUDHZIHZAWQIHZBWQIHZGHZJZLVSV
      RLDUACVTSJZWEWJVSXCWAWFWDWIVTSVMINXCWBWGWCWHGVTSAINVTSBINOPQVTWKJZWEWPVSX
      DWAWLWDWOVTWKVMINXDWBWMWCWNGVTWKAINVTWKBINOPQVTWQJZWEXBVSXEWAWRWDXAVTWQVM
      INXEWBWSWCWTGVTWQAINVTWQBINOPQVTCJZWEVRVSXFWAVNWDVQVTCVMINXFWBVOWCVPGVTCA
      INVTCBINOPQVSWFMWIVSVMEFZWFMJABUEZVMRULVSWIMMGHMVJVKWGMWHMGARBRUFUGUHUIWK
      UBFZVSWPXBVSXIWPXBLVSXIWPXBVSXIKZWPKWRWLVMGHZXAXJWRXKJZWPVSXGXIXLXHVMWKTU
      JUMWPXJXKWOVMGHZXAWLWOVMGUKXJXMWMAGHZWNBGHZGHZXAXJWMEFZWNEFZKZVSXMXPJVJVK
      XIXSVJXIKXQVKXIKXRAWKUNBWKUNUOUPVSXIUQWMWNABVBURXJWSXNWTXOGVJXIWSXNJVKAWK
      TUSVKXIWTXOJVJBWKTUTOUIVAVCVDVEVFVGVHVI $.

    $( Integer exponentiation of a product.  Proposition 10-4.2(c) of [Gleason]
       p. 135.  (Contributed by Mario Carneiro, 4-Jun-2014.) $)
    mulexpz $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) /\
                     N e. ZZ ) ->
                  ( ( A x. B ) ^ N ) = ( ( A ^ N ) x. ( B ^ N ) ) ) $=
      ( cc wcel cc0 wne wa cz cmul co cexp wceq simpl c1 expneg2 syl3anc eqtr4d
      cn0 cdiv cr cneg cn wo elznn0nn anim12i mulexp 3expa sylan simplll mulcld
      simplrl ad2antrl nnnn0 ad2antll oveq12d oveq2d 1t1e1 oveq1i syl6eqr expcl
      recn syl2anc simpllr nnz expne0i simplrr ax-1cn divmuldiv syl22anc jaodan
      mpanl12 sylan2b 3impa ) ADEZAFGZHZBDEZBFGZHZCIEZABJKZCLKZACLKZBCLKZJKZMZW
      AVQVTHZCSEZCUAEZCUBZUCEZHZUDWGCUEWHWIWGWMWHVOVRHWIWGVQVOVTVRVOVPNVRVSNUFV
      OVRWIWGABCUGUHUIWHWMHZWCOWBWKLKZTKZWFWNWBDECDEZWKSEZWCWPMWNABVOVPVTWMUJZV
      QVRVSWMULZUKWJWQWHWLCVBUMZWLWRWHWJWKUNUOZWBCPQWNWFOAWKLKZTKZOBWKLKZTKZJKZ
      WPWNWDXDWEXFJWNVOWQWRWDXDMWSXAXBACPQWNVRWQWRWEXFMWTXAXBBCPQUPWNWPOOJKZXCX
      EJKZTKZXGWNWPOXITKXJWNWOXIOTWNVOVRWRWOXIMWSWTXBABWKUGQUQXHOXITURUSUTWNXCD
      EZXCFGZXEDEZXEFGZXGXJMZWNVOWRXKWSXBAWKVAVCWNVOVPWKIEZXLWSVOVPVTWMVDWLXPWH
      WJWKVEUOZAWKVFQWNVRWRXMWTXBBWKVAVCWNVRVSXPXNWTVQVRVSWMVGXQBWKVFQODEZXRXKX
      LHXMXNHHXOVHVHOOXCXEVIVLVJRRRVKVMVN $.

    $( Nonnegative integer exponentiation of a reciprocal.  (Contributed by NM,
       2-Aug-2006.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
    exprec $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) ->
                  ( ( 1 / A ) ^ N ) = ( 1 / ( A ^ N ) ) ) $=
      ( cc wcel cc0 wne cz w3a cexp co c1 cdiv cmul reccl 3adant3 recne0 expclz
      oveq1d wceq eqtr3d simp3 syl3anc expne0i divcan3d simp1 mulexpz syl221anc
      simp2 recidd 1exp syl ) ACDZAEFZBGDZHZABIJZKALJZBIJZMJZUPLJURKUPLJUOURUPU
      OUQCDZUQEFZUNURCDULUMUTUNANOZULUMVAUNAPOZULUMUNUAZUQBQUBABQABUCUDUOUSKUPL
      UOKBIJZUSKUOAUQMJZBIJZVEUSUOVFKBIUOAULUMUNUEZULUMUNUHZUIRUOULUMUTVAUNVGUS
      SVHVIVBVCVDAUQBUFUGTUOUNVEKSVDBUJUKTRT $.

    $( Sum of exponents law for nonnegative integer exponentiation.
       Proposition 10-4.2(a) of [Gleason] p. 135.  (Contributed by NM,
       30-Nov-2004.) $)
    expadd $p |- ( ( A e. CC /\ M e. NN0 /\ N e. NN0 ) ->
                  ( A ^ ( M + N ) ) = ( ( A ^ M ) x. ( A ^ N ) ) ) $=
      ( vj cc wcel cn0 caddc co cexp cmul wi cc0 c1 oveq2 oveq2d eqeq12d imbi2d
      wceq eqtr4d vk wa cv nn0cn addid1d adantl expcl mulid1d exp0 adantr oveq1
      ax-1cn addass mp3an3 syl2an adantll simpll nn0addcl expp1 syl2anc adantlr
      eqtr3d mulassd syl5ibr expcom a2d nn0ind exp3acom3r 3imp ) AEFZBGFZCGFZAB
      CHIZJIZABJIZACJIZKIZSZVLVJVKVRVJVKUBZABDUCZHIZJIZVOAVTJIZKIZSZLVSABMHIZJI
      ZVOAMJIZKIZSZLVSABUAUCZHIZJIZVOAWKJIZKIZSZLVSABWKNHIZHIZJIZVOAWQJIZKIZSZL
      VSVRLDUACVTMSZWEWJVSXCWBWGWDWIXCWAWFAJVTMBHOPXCWCWHVOKVTMAJOPQRVTWKSZWEWP
      VSXDWBWMWDWOXDWAWLAJVTWKBHOPXDWCWNVOKVTWKAJOPQRVTWQSZWEXBVSXEWBWSWDXAXEWA
      WRAJVTWQBHOPXEWCWTVOKVTWQAJOPQRVTCSZWEVRVSXFWBVNWDVQXFWAVMAJVTCBHOPXFWCVP
      VOKVTCAJOPQRVSWGVONKIZWIVSWGVOXGVSWFBAJVKWFBSVJVKBBUDZUEUFPVSVOABUGZUHTVS
      WHNVOKVJWHNSVKAUIUJPTWKGFZVSWPXBVSXJWPXBLWPXBVSXJUBZWMAKIZWOAKIZSWMWOAKUK
      XKWSXLXAXMXKAWLNHIZJIZWSXLXKXNWRAJVKXJXNWRSZVJVKBEFZWKEFZXPXJXHWKUDXQXRNE
      FXPULBWKNUMUNUOUPPXKVJWLGFZXOXLSVJVKXJUQZVKXJXSVJBWKURUPAWLUSUTVBXKXAVOWN
      AKIZKIXMXKWTYAVOKVJXJWTYASVKAWKUSVAPXKVOWNAVSVOEFXJXIUJVJXJWNEFVKAWKUGVAX
      TVCTQVDVEVFVGVHVI $.

    $( Lemma for ~ expaddz .  (Contributed by Mario Carneiro, 4-Jun-2014.) $)
    expaddzlem $p |- ( ( ( A e. CC /\ A =/= 0 ) /\
                       ( M e. RR /\ -u M e. NN ) /\ N e. NN0 ) ->
                       ( A ^ ( M + N ) ) = ( ( A ^ M ) x. ( A ^ N ) ) ) $=
      ( cc wcel wa cn0 cexp co cdiv c1 cmul caddc cz syl3anc wceq adantr eqtr3d
      eqtrd oveq1d cc0 wne cr cneg w3a simp1l simp3 expcl syl2anc simp2r nnnn0d
      cn simp1r expne0i divrec2d simp2l recnd negnegd nnnegz syl eqeltrrd nn0zd
      nnzd zaddcld expclz divcan4d simpr expadd cmin zcnd negsubd nn0cnd oveq2d
      pncan2d expneg2 znegcld negdi2d negcld npcand recdivd wo simprbi mpjaodan
      elznn0 3eqtr4d ) ADEZAUAUBZFZBUCEZBUDZULEZFZCGEZUEZACHIZAWJHIZJIZKWPJIZWO
      LIABCMIZHIZABHIZWOLIWNWOWPWNWFWMWODEZWFWGWLWMUFZWHWLWMUGZACUHUIZWNWFWJGEZ
      WPDEZXCWNWJWHWIWKWMUJZUKZAWJUHUIZWNWFWGWJNEWPUAUBZXCWFWGWLWMUMZWNWJXHVCAW
      JUNOZUOWNWSGEZWTWQPWSUDZGEZWNXNFZWTWPLIZWPJIWTWQXQWTWPWNWTDEZXNWNWFWGWSNE
      ZXSXCXLWNBCWNWJUDZBNWNBWNBWHWIWKWMUPUQZURWNWKYANEXHWJUSUTVAWNCXDVBZVDZAWS
      VEOQWNXGXNXJQWNXKXNXMQVFXQXRWOWPJXQAWSWJMIZHIZXRWOXQWFXNXFYFXRPWNWFXNXCQW
      NXNVGWNXFXNXIQAWSWJVHOXQYECAHWNYECPXNWNYEWSBVIICWNWSBWNWSYDVJZYBVKWNBCYBW
      NCXDVLZVNSQVMRTRWNXPFZWTKAXOHIZJIZWQYIWFWSDEZXPWTYKPWNWFXPXCQZWNYLXPYGQWN
      XPVGZAWSVOOYIYKKWPWOJIZJIZWQYIYJYOKJYIYJWOLIZWOJIYJYOYIYJWOWNYJDEZXPWNWFW
      GXONEYRXCXLWNWSYDVPAXOVEOQWNXBXPXEQWNWOUAUBZXPWNWFWGCNEYSXCXLYCACUNOZQVFY
      IYQWPWOJYIAXOCMIZHIZYQWPYIWFXPWMUUBYQPYMYNWNWMXPXDQAXOCVHOYIUUAWJAHWNUUAW
      JPXPWNUUAWJCVIIZCMIWJWNXOUUCCMWNBCYBYHVQTWNWJCWNBYBVRYHVSSQVMRTRVMWNYPWQP
      XPWNWPWOXJXEXMYTVTQSSWNXTXNXPWAZYDXTWSUCEUUDWSWDWBUTWCWNXAWRWOLWNWFBDEXFX
      AWRPXCYBXIABVOOTWE $.

    $( Sum of exponents law for integer exponentiation.  Proposition 10-4.2(a)
       of [Gleason] p. 135.  (Contributed by Mario Carneiro, 4-Jun-2014.) $)
    expaddz $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( M e. ZZ /\ N e. ZZ ) ) ->
                  ( A ^ ( M + N ) ) = ( ( A ^ M ) x. ( A ^ N ) ) ) $=
      ( cc wcel cc0 wne wa cz caddc cexp cmul wceq cn0 cneg 3expia syl3anc cdiv
      co c1 cr cn wo elznn0nn expadd adantlr expaddzlem jaodan w3a simp3 nn0cnd
      wi simp2l recnd addcomd oveq2d simp1l expcl syl2anc simp1r negnegd simp2r
      nnnn0d nn0negz syl eqeltrrd expclz mulcomd 3eqtr4d impancom simp3l negdid
      simp3r eqtrd 1t1e1 oveq1i syl6eqr nn0zd expne0i ax-1cn divmuldiv syl22anc
      mpanl12 eqtr4d addcld nn0addcld eqeltrd expneg2 oveq12d jaod sylan2b impr
      syl5bi ) ADEZAFGZHZBIEZCIEZABCJSZKSZABKSZACKSZLSZMZWRCNEZCUAEZCOZUBEZHZUC
      ZWPWQHXDCUDWQWPBNEZBUAEZBOZUBEZHZUCZXJXDULBUDWPXPHXEXDXIWPXKXEXDULZXOWNXK
      XQWOWNXKXEXDABCUEPUFWPXOXEXDABCUGPUHWPXKXIXDULXOWPXIXKXDWPXIXKXDWPXIXKUIZ
      ACBJSZKSXBXALSWTXCACBUGXRWSXSAKXRBCXRBWPXIXKUJZUKXRCWPXFXHXKUMUNZUOUPXRXA
      XBXRWNXKXADEWNWOXIXKUQZXTABURUSXRWNWOWRXBDEYBWNWOXIXKUTXRXGOZCIXRCYAVAXRX
      GNEZYCIEXRXGWPXFXHXKVBVCXGVDVEVFACVGQVHVIPVJWPXOXIXDWPXOXIUIZTAWSOZKSZRSZ
      TAXMKSZRSZTAXGKSZRSZLSZWTXCYEYHTTLSZYIYKLSZRSZYMYEYHTYORSYPYEYGYOTRYEYGAX
      MXGJSZKSZYOYEYFYQAKYEBCYEBWPXLXNXIUMUNZYECWPXOXFXHVKUNZVLZUPYEWNXMNEZYDYR
      YOMWNWOXOXIUQZYEXMWPXLXNXIVBVCZYEXGWPXOXFXHVMVCZAXMXGUEQVNUPYNTYORVOVPVQY
      EYIDEZYIFGZYKDEZYKFGZYMYPMZYEWNUUBUUFUUCUUDAXMURUSYEWNWOXMIEUUGUUCWNWOXOX
      IUTZYEXMUUDVRAXMVSQYEWNYDUUHUUCUUEAXGURUSYEWNWOXGIEUUIUUCUUKYEXGUUEVRAXGV
      SQTDEZUULUUFUUGHUUHUUIHHUUJVTVTTTYIYKWAWCWBWDYEWNWSDEYFNEWTYHMUUCYEBCYSYT
      WEYEYFYQNUUAYEXMXGUUDUUEWFWGAWSWHQYEXAYJXBYLLYEWNBDEUUBXAYJMUUCYSUUDABWHQ
      YEWNCDEYDXBYLMUUCYTUUEACWHQWIVIPUHWJWKWMWL $.

    $( Product of exponents law for natural number exponentiation.  Proposition
       10-4.2(b) of [Gleason] p. 135, restricted to nonnegative integer
       exponents.  (Contributed by NM, 4-Jan-2006.) $)
    expmul $p |- ( ( A e. CC /\ M e. NN0 /\ N e. NN0 ) ->
               ( A ^ ( M x. N ) ) = ( ( A ^ M ) ^ N ) ) $=
      ( vj cc wcel cn0 cmul co cexp wceq wa wi cc0 c1 caddc oveq2 oveq2d imbi2d
      eqeq12d vk cv nn0cn mul01d exp0 sylan9eqr expcl eqtr4d oveq1 ax-1cn adddi
      mp3an3 mulid1 adantr syl2an adantll simpll nn0mulcl simplr expadd syl3anc
      syl eqtrd expp1 sylan syl5ibr expcom a2d nn0ind exp3acom3r 3imp ) AEFZBGF
      ZCGFZABCHIZJIZABJIZCJIZKZVNVLVMVSVLVMLZABDUBZHIZJIZVQWAJIZKZMVTABNHIZJIZV
      QNJIZKZMVTABUAUBZHIZJIZVQWJJIZKZMVTABWJOPIZHIZJIZVQWOJIZKZMVTVSMDUACWANKZ
      WEWIVTWTWCWGWDWHWTWBWFAJWANBHQRWANVQJQTSWAWJKZWEWNVTXAWCWLWDWMXAWBWKAJWAW
      JBHQRWAWJVQJQTSWAWOKZWEWSVTXBWCWQWDWRXBWBWPAJWAWOBHQRWAWOVQJQTSWACKZWEVSV
      TXCWCVPWDVRXCWBVOAJWACBHQRWACVQJQTSVTWGOWHVMVLWGANJIOVMWFNAJVMBBUCZUDRAUE
      UFVTVQEFZWHOKABUGZVQUEVBUHWJGFZVTWNWSVTXGWNWSMWNWSVTXGLZWLVQHIZWMVQHIZKWL
      WMVQHUIXHWQXIWRXJXHWQAWKBPIZJIZXIXHWPXKAJVMXGWPXKKZVLVMBEFZWJEFZXMXGXDWJU
      CXNXOLZWPWKBOHIZPIZXKXNXOOEFWPXRKUJBWJOUKULXPXQBWKPXNXQBKXOBUMUNRVCUOUPRX
      HVLWKGFZVMXLXIKVLVMXGUQVMXGXSVLBWJURUPVLVMXGUSAWKBUTVAVCVTXEXGWRXJKXFVQWJ
      VDVETVFVGVHVIVJVK $.

    $( Product of exponents law for integer exponentiation.  Proposition
       10-4.2(b) of [Gleason] p. 135.  (Contributed by Mario Carneiro,
       7-Jul-2014.) $)
    expmulz $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( M e. ZZ /\ N e. ZZ ) ) ->
               ( A ^ ( M x. N ) ) = ( ( A ^ M ) ^ N ) ) $=
      ( cc wcel wa cz cmul co cexp wceq cn0 expmul 3expia c1 cdiv oveq2d nnnn0d
      recnd syl3anc cc0 wne cr cneg cn wo elznn0nn wi adantlr w3a simp2l nn0cnd
      simp3 simp1l simp2r eqtr3d expcl syl2anc simp1r nnzd expne0i nn0zd exprec
      mulneg1d eqtr4d mulcld nn0mulcld eqeltrrd expneg2 oveq1d 3eqtr4d mulneg2d
      jaodan simp2 simp3l simp3r reccld recrecd mul2negd 3eqtrd 3eqtrrd sylan2b
      jaod syl5bi impr ) ADEZAUAUBZFZBGEZCGEZABCHIZJIZABJIZCJIZKZWJCLEZCUCEZCUD
      ZUEEZFZUFZWHWIFWOCUGWIWHBLEZBUCEZBUDZUEEZFZUFZXAWOUHBUGWHXGFWPWOWTWHXBWPW
      OUHZXFWFXBXHWGWFXBWPWOABCMNUIWHXFWPWOWHXFWPUJZOAWKUDZJIZPIZOAXDJIZPIZCJIZ
      WLWNXIXLOXMCJIZPIZXOXIXKXPOPXIAXDCHIZJIZXKXPXIXRXJAJXIBCXIBWHXCXEWPUKSZXI
      CWHXFWPUMZULZVDZQXIWFXDLEZWPXSXPKWFWGXFWPUNZXIXDWHXCXEWPUOZRZYAAXDCMTUPQX
      IXMDEZXMUAUBZWJXOXQKXIWFYDYHYEYGAXDUQZURXIWFWGXDGEZYIYEWFWGXFWPUSXIXDYFUT
      AXDVAZTXICYAVBXMCVCTVEXIWFWKDEZXJLEZWLXLKZYEXIBCXTYBVFXIXRXJLYCXIXDCYGYAV
      GVHAWKVIZTXIWMXNCJXIWFBDEZYDWMXNKZYEXTYGABVIZTVJVKNVMWHXBWTWOUHXFWHXBWTWO
      WHXBWTUJZXLOWMWRJIZPIZWLWNYTXKUUAOPYTABWRHIZJIZXKUUAYTUUCXJAJYTBCYTBWHXBW
      TVNZULZYTCWHXBWQWSVOSZVLZQYTWFXBWRLEZUUDUUAKWFWGXBWTUNZUUEYTWRWHXBWQWSVPR
      ZABWRMTUPQYTWFYMYNYOUUJYTBCUUFUUGVFYTUUCXJLUUHYTBWRUUEUUKVGVHYPTYTWMDEZCD
      EZUUIWNUUBKYTWFXBUULUUJUUEABUQURUUGUUKWMCVITVKNWHXFWTWOWHXFWTUJZWNXOOXNWR
      JIZPIZWLUUNWMXNCJUUNWFYQYDYRWFWGXFWTUNZUUNBWHXCXEWTUKSZUUNXDWHXCXEWTUOZRZ
      YSTVJUUNXNDEUUMUUIXOUUPKUUNXMUUNWFYDYHUUQUUTYJURZUUNWFWGYKYIUUQWFWGXFWTUS
      UUNXDUUSUTYLTZVQUUNCWHXFWQWSVOSZUUNWRWHXFWQWSVPZRZXNCVITUUNUUPOOXMWRJIZPI
      ZPIUVFWLUUNUUOUVGOPUUNYHYIWRGEZUUOUVGKUVAUVBUUNWRUVDUTZXMWRVCTQUUNUVFUUNY
      HUUIUVFDEUVAUVEXMWRUQURUUNYHYIUVHUVFUAUBUVAUVBUVIXMWRVATVRUUNAXDWRHIZJIZU
      VFWLUUNWFYDUUIUVKUVFKUUQUUTUVEAXDWRMTUUNUVJWKAJUUNBCUURUVCVSQUPVTWANVMWCW
      BWDWE $.
  $}

  $( Exponent subtraction law for nonnegative integer exponentiation.
     (Contributed by NM, 2-Aug-2006.)  (Revised by Mario Carneiro,
     4-Jun-2014.) $)
  expsub $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( M e. ZZ /\ N e. ZZ ) ) ->
                 ( A ^ ( M - N ) ) = ( ( A ^ M ) / ( A ^ N ) ) ) $=
    ( cc wcel cc0 wne wa cz cneg co cexp cmul cdiv wceq zcn oveq2d 3expa expclz
    adantrl cmin znegcl expaddz sylanr2 negsub syl2an adantl c1 expnegz adantrr
    caddc expne0i divrecd eqtr4d 3eqtr3d ) ADEZAFGZHZBIEZCIEZHZHZABCJZUKKZLKZAB
    LKZAVCLKZMKZABCUAKZLKVFACLKZNKZUTURUSVCIEVEVHOCUBABVCUCUDVBVDVIALVAVDVIOZUR
    USBDECDEVLUTBPCPBCUEUFUGQVBVHVFUHVJNKZMKVKVBVGVMVFMURUTVGVMOZUSUPUQUTVNACUI
    RTQVBVFVJURUSVFDEZUTUPUQUSVOABSRUJURUTVJDEZUSUPUQUTVPACSRTURUTVJFGZUSUPUQUT
    VQACULRTUMUNUO $.

  $( Value of a nonzero complex number raised to an integer power plus one.
     (Contributed by Mario Carneiro, 4-Jun-2014.) $)
  expp1z $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) -> ( A ^ ( N + 1 ) ) =
               ( ( A ^ N ) x. A ) ) $=
    ( cc wcel cc0 wne cz w3a c1 caddc co cexp cmul wceq wa expaddz mpanr2 3impa
    1z exp1 3ad2ant1 oveq2d eqtrd ) ACDZAEFZBGDZHZABIJKLKZABLKZAILKZMKZUIAMKUDU
    EUFUHUKNZUDUEOUFIGDULSABIPQRUGUJAUIMUDUEUJANUFATUAUBUC $.

  $( Value of a complex number raised to an integer power minus one.
     (Contributed by NM, 25-Dec-2008.)  (Revised by Mario Carneiro,
     4-Jun-2014.) $)
  expm1 $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) -> ( A ^ ( N - 1 ) ) =
               ( ( A ^ N ) / A ) ) $=
    ( cc wcel cc0 wne cz w3a c1 cmin co cexp cdiv wceq wa 1z expsub mpanr2 exp1
    3impa 3ad2ant1 oveq2d eqtrd ) ACDZAEFZBGDZHZABIJKLKZABLKZAILKZMKZUIAMKUDUEU
    FUHUKNZUDUEOUFIGDULPABIQRTUGUJAUIMUDUEUJANUFASUAUBUC $.

  $( Nonnegative integer exponentiation of a quotient.  (Contributed by NM,
     2-Aug-2006.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
  expdiv $p |- ( ( A e. CC /\ ( B e. CC /\ B =/= 0 ) /\ N e. NN0 ) ->
                ( ( A / B ) ^ N ) = ( ( A ^ N ) / ( B ^ N ) ) ) $=
    ( cc wcel cc0 wne wa cn0 w3a cdiv co cexp c1 cmul wceq divrec 3expb syl3anc
    expcl 3adant3 oveq1d mulexp syl3an2 cz simp2l simp2r 3ad2ant3 exprec oveq2d
    reccl nn0z 3adant2 adantlr 3adant1 expne0i divrecd eqtr4d 3eqtrd ) ADEZBDEZ
    BFGZHZCIEZJZABKLZCMLANBKLZOLZCMLZACMLZVGCMLZOLZVJBCMLZKLZVEVFVHCMUTVCVFVHPZ
    VDUTVAVBVOABQRUAUBVCUTVGDEVDVIVLPBUKAVGCUCUDVEVLVJNVMKLZOLVNVEVKVPVJOVEVAVB
    CUEEZVKVPPUTVAVBVDUFZUTVAVBVDUGZVDUTVQVCCULUHZBCUISUJVEVJVMUTVDVJDEVCACTUMV
    CVDVMDEZUTVAVDWAVBBCTUNUOVEVAVBVQVMFGVRVSVTBCUPSUQURUS $.

  $( Ordering relationship for exponentiation.  (Contributed by NM,
     2-Aug-2006.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
  ltexp2a $p |- ( ( ( A e. RR /\ M e. ZZ /\ N e. ZZ ) /\
             ( 1 < A /\ M < N ) ) -> ( A ^ M ) < ( A ^ N ) ) $=
    ( cr wcel cz w3a c1 clt wbr wa cexp crp cc0 a1i rpexpcl syl2anc rpred recnd
    co cmul simpl1 0re 1re 0lt1 simprl lttrd simpl2 mulid2d cdiv cmin cn simprr
    elrpd wb simpl3 znnsub mpbid expgt1 syl3anc cc wceq gt0ne0d expsub syl22anc
    wne breqtrd ltmuldivd mpbird eqbrtrrd ) ADEZBFEZCFEZGZHAIJZBCIJZKZKZHABLTZU
    ATZVSACLTZIVRVSVRVSVRVSVRAMEZVLVSMEVRAVKVLVMVQUBZVRNHANDEVRUCOHDEVRUDOZWCNH
    IJVRUEOVNVOVPUFZUGZUNZVKVLVMVQUHZABPQZRSUIVRVTWAIJHWAVSUJTZIJVRHACBUKTZLTZW
    JIVRVKWKULEZVOHWLIJWCVRVPWMVNVOVPUMVRVLVMVPWMUOWHVKVLVMVQUPZBCUQQURWEAWKUSU
    TVRAVAEANVFVMVLWLWJVBVRAWCSVRAWFVCWNWHACBVDVEVGVRHWAVSWDVRWAVRWBVMWAMEWGWNA
    CPQRWIVHVIVJ $.

  ${
    $d x y A $.  $d x y M $.  $d x y N $.
    $( Cancellation law for exponentiation.  (Contributed by NM, 2-Aug-2006.)
       (Revised by Mario Carneiro, 4-Jun-2014.) $)
    expcan $p |- ( ( ( A e. RR /\ M e. ZZ /\ N e. ZZ ) /\
               1 < A ) -> ( ( A ^ M ) = ( A ^ N ) <-> M = N ) ) $=
      ( vx vy cr wcel cz w3a c1 clt wbr wa wceq cexp co cv oveq2 cc0 a1i wb crp
      zssre simpl 0re 1re 0lt1 simpr lttrd elrpd rpexpcl sylan wi simpll simprl
      rpred simprr simplr ltexp2a expr syl31anc eqord1 exp43 com24 3imp1 bicomd
      ancom2s ) AFGZBHGZCHGZIJAKLZMBCNZABOPZACOPZNZVHVIVJVKVLVOUAZVHVKVJVIVPVHV
      KVJVIVPVHVKMZVIVJVPVQDEADQZOPZAEQZOPZBCHVMVNVRVTAORVRBAORVRCAORUCVQVRHGZM
      VSVQAUBGWBVSUBGVQAVHVKUDZVQSJASFGVQUETJFGVQUFTWCSJKLVQUGTVHVKUHUIUJAVRUKU
      LUPVQWBVTHGZMZMVHWBWDVKVRVTKLZVSWAKLZUMVHVKWEUNVQWBWDUOVQWBWDUQVHVKWEURVH
      WBWDIVKWFWGAVRVTUSUTVAVBVGVCVDVEVF $.

    $( Ordering law for exponentiation.  (Contributed by NM, 2-Aug-2006.)
       (Revised by Mario Carneiro, 5-Jun-2014.) $)
    ltexp2 $p |- ( ( ( A e. RR /\ M e. ZZ /\ N e. ZZ ) /\
             1 < A ) -> ( M < N <-> ( A ^ M ) < ( A ^ N ) ) ) $=
      ( vx vy cr wcel cz c1 clt wbr cexp co wb wa cv oveq2 crp cc0 a1i 0re 0lt1
      zssre simpl simpr lttrd elrpd rpexpcl sylan rpred wi simpll simprl simprr
      1re simplr w3a ltexp2a expr syl31anc ltord1 ancom2s exp43 com24 3imp1 ) A
      FGZBHGZCHGZIAJKZBCJKABLMZACLMZJKNZVFVIVHVGVLVFVIVHVGVLVFVIOZVGVHVLVMDEADP
      ZLMZAEPZLMZBCHVJVKVNVPALQVNBALQVNCALQUCVMVNHGZOVOVMARGVRVORGVMAVFVIUDZVMS
      IASFGVMUATIFGVMUOTVSSIJKVMUBTVFVIUEUFUGAVNUHUIUJVMVRVPHGZOZOVFVRVTVIVNVPJ
      KZVOVQJKZUKVFVIWAULVMVRVTUMVMVRVTUNVFVIWAUPVFVRVTUQVIWBWCAVNVPURUSUTVAVBV
      CVDVE $.

    $( Ordering law for exponentiation.  (Contributed by Mario Carneiro,
       26-Apr-2016.) $)
    leexp2 $p |- ( ( ( A e. RR /\ M e. ZZ /\ N e. ZZ ) /\
             1 < A ) -> ( M <_ N <-> ( A ^ M ) <_ ( A ^ N ) ) ) $=
      ( cr wcel cz w3a c1 clt wbr wn cexp co cle zre cc0 a1i reexpclz syl3anc
      wb wa 3ancomb ltexp2 sylanb notbid simpl2 simpl3 lenlt syl2an syl2anc wne
      simpl1 0re 1re 0lt1 simpr lttrd gt0ne0d lenltd 3bitr4d ) ADEZBFEZCFEZGZHA
      IJZUAZCBIJZKZACLMZABLMZIJZKBCNJZVJVINJVFVGVKVDVAVCVBGVEVGVKTVAVBVCUBACBUC
      UDUEVFVBVCVLVHTZVAVBVCVEUFZVAVBVCVEUGZVBBDECDEVMVCBOCOBCUHUIUJVFVJVIVFVAA
      PUKZVBVJDEVAVBVCVEULZVFAVFPHAPDEVFUMQHDEVFUNQVQPHIJVFUOQVDVEUPUQURZVNABRS
      VFVAVPVCVIDEVQVRVOACRSUSUT $.
  $}

  $( Weak ordering relationship for exponentiation.  (Contributed by NM,
     14-Dec-2005.)  (Revised by Mario Carneiro, 5-Jun-2014.) $)
  leexp2a $p |- ( ( A e. RR /\ 1 <_ A /\ N e. ( ZZ>= ` M ) ) ->
                   ( A ^ M ) <_ ( A ^ N ) ) $=
    ( cr wcel c1 cle wbr cuz cexp co crp cc0 a1i 3ad2ant3 rpexpcl syl2anc rpred
    cz recnd cfv w3a cmul simp1 0re 1re clt simp2 ltletrd elrpd eluzel2 mulid2d
    0lt1 cdiv cmin cn0 uznn0sub expge1 syl3anc cc wceq gt0ne0d eluzelz syl22anc
    wne expsub breqtrd lemuldivd mpbird eqbrtrrd ) ADEZFAGHZCBIUAEZUBZFABJKZUCK
    ZVOACJKZGVNVOVNVOVNVOVNALEZBSEZVOLEVNAVKVLVMUDZVNMFAMDEVNUENFDEVNUFNZVTMFUG
    HVNUMNVKVLVMUHZUIZUJZVMVKVSVLBCUKOZABPQZRTULVNVPVQGHFVQVOUNKZGHVNFACBUOKZJK
    ZWGGVNVKWHUPEZVLFWIGHVTVMVKWJVLBCUQOWBAWHURUSVNAUTEAMVECSEZVSWIWGVAVNAVTTVN
    AWCVBVMVKWKVLBCVCOZWEACBVFVDVGVNFVQVOWAVNVQVNVRWKVQLEWDWLACPQRWFVHVIVJ $.

  $( The power of a positive number smaller than 1 decreases as its exponent
     increases.  (Contributed by NM, 2-Aug-2006.)  (Revised by Mario Carneiro,
     5-Jun-2014.) $)
  ltexp2r $p |- ( ( ( A e. RR+ /\ M e. ZZ /\ N e. ZZ ) /\ A < 1 ) ->
                  ( M < N <-> ( A ^ N ) < ( A ^ M ) ) ) $=
    ( crp wcel cz w3a c1 clt wbr wa cdiv co cexp cc wceq exprec syl3anc rpexpcl
    syl2anc cc0 wne simpl1 rpcnd rpne0d simpl2 simpl3 breq12d cr rprecred simpr
    wb reclt1d mpbid ltexp2 syl31anc ltrecd 3bitr4d ) ADEZBFEZCFEZGZAHIJZKZHALM
    ZBNMZVECNMZIJZHABNMZLMZHACNMZLMZIJBCIJZVKVIIJVDVFVJVGVLIVDAOEZAUAUBZUTVFVJP
    VDAUSUTVAVCUCZUDZVDAVPUEZUSUTVAVCUFZABQRVDVNVOVAVGVLPVQVRUSUTVAVCUGZACQRUHV
    DVEUIEUTVAHVEIJZVMVHULVDAVPUJVSVTVDVCWAVBVCUKVDAVPUMUNVEBCUOUPVDVKVIVDUSVAV
    KDEVPVTACSTVDUSUTVIDEVPVSABSTUQUR $.

  ${
    $d j k A $.  $d j k B $.  $d j k M $.  $d j k N $.
    $( Weak ordering relationship for exponentiation.  (Contributed by Paul
       Chapman, 14-Jan-2008.)  (Revised by Mario Carneiro, 29-Apr-2014.) $)
    leexp2r $p |- ( ( ( A e. RR /\ M e. NN0 /\ N e. ( ZZ>= ` M ) ) /\
                        ( 0 <_ A /\ A <_ 1 ) ) ->
                      ( A ^ N ) <_ ( A ^ M ) ) $=
      ( vj cr wcel cn0 cle wbr c1 wa cexp co wceq breq1d imbi2d reexpcl syl2anc
      wi oveq2 vk cuz cfv w3a cc0 cv caddc cz adantr leidd a1i cmul simprll 1re
      simprlr simpl eluznn0 simprrl expge0 syl3anc simprrr lemul2ad recnd expp1
      cc mulid1d eqcomd 3brtr4d peano2nn0 syl ad2antrl letr mpand ex a2d uzind4
      exp3a com12 3impia imp ) AEFZBGFZCBUBUCZFZUDUEAHIZAJHIZKZACLMZABLMZHIZWAW
      BWDWGWJSZWDWAWBKZWKWDWLWGWJWLWGKZADUFZLMZWIHIZSWMWIWIHIZSZWMAUAUFZLMZWIHI
      ZSWMAWSJUGMZLMZWIHIZSWMWJSDUABCWNBNZWPWQWMXEWOWIWIHWNBALTOPWNWSNZWPXAWMXF
      WOWTWIHWNWSALTOPWNXBNZWPXDWMXGWOXCWIHWNXBALTOPWNCNZWPWJWMXHWOWHWIHWNCALTO
      PWRBUHFWMWIWLWIEFZWGABQZUIUJUKWSWCFZWMXAXDXKWMXAXDSXKWMKZXCWTHIZXAXDXLWTA
      ULMZWTJULMZXCWTHXLAJWTXKWAWBWGUMZJEFXLUNUKXLWAWSGFZWTEFZXPXLWBXKXQXKWAWBW
      GUOXKWMUPWSBUQRZAWSQRZXLWAXQWEUEWTHIXPXSXKWLWEWFURAWSUSUTXKWLWEWFVAVBXLAV
      EFXQXCXNNXLAXPVCXSAWSVDRXLXOWTXLWTXLWTXTVCVFVGVHXLXCEFZXRXIXMXAKXDSXLWAXB
      GFZYAXPXLXQYBXSWSVIVJAXBQRXTWLXIXKWGXJVKXCWTWIVLUTVMVNVOVPVQVRVSVT $.

    $( Weak mantissa ordering relationship for exponentiation.  (Contributed by
       NM, 18-Dec-2005.) $)
    leexp1a $p |- ( ( ( A e. RR /\ B e. RR /\ N e. NN0 ) /\
               ( 0 <_ A /\ A <_ B ) ) -> ( A ^ N ) <_ ( B ^ N ) ) $=
      ( cr wcel cc0 cle wa cexp co wi c1 wceq oveq2 breq12d imbi2d adantr sylan
      wbr adantlr vj vk cn0 cv caddc cc recn exp0 1le1 syl6eqbr adantl breqtrrd
      syl2an simpll reexpcl simplll simpr simplrl expge0 syl3anc simplr anim12i
      cmul jca31 simpl simpllr jca32 simplrr jca lemul12a expp1 adantll 3brtr4d
      sylc ex expcom a2d nn0ind exp4c com3l 3imp1 ) ADEZBDEZCUCEZFAGSZABGSZHZAC
      IJZBCIJZGSZWDWBWCWGWJKWDWBWCWGWJWBWCHZWGHZAUAUDZIJZBWMIJZGSZKWLAFIJZBFIJZ
      GSZKWLAUBUDZIJZBWTIJZGSZKWLAWTLUEJZIJZBXDIJZGSZKWLWJKUAUBCWMFMZWPWSWLXHWN
      WQWOWRGWMFAINWMFBINOPWMWTMZWPXCWLXIWNXAWOXBGWMWTAINWMWTBINOPWMXDMZWPXGWLX
      JWNXEWOXFGWMXDAINWMXDBINOPWMCMZWPWJWLXKWNWHWOWIGWMCAINWMCBINOPWKWSWGWBAUF
      EZBUFEZWSWCAUGZBUGZXLXMHZWQLWRGXPWQLLGXLWQLMXMAUHQUIUJXMWRLMXLBUHUKULUMQW
      TUCEZWLXCXGWLXQXCXGKWLXQHZXCXGXRXCHZXAAVCJZXBBVCJZXEXFGXSXADEZFXAGSZHXBDE
      ZHZWBWEHZWCHHZXCWFHXTYAGSXRYGXCXRYEYFWCXRYBYCYDWLWBXQYBWBWCWGUNAWTUORXRWB
      XQWEYCWBWCWGXQUPWLXQUQWKWEWFXQURAWTUSUTWLWCXQYDWBWCWGVABWTUORVDWLYFXQWKWB
      WGWEWBWCVEWEWFVEVBQWBWCWGXQVFVGQXSXCWFXRXCUQXRWFXCWKWEWFXQVHQVIXAXBABVJVN
      XRXEXTMZXCWKXQYHWGWBXQYHWCWBXLXQYHXNAWTVKRTTQXRXFYAMZXCWKXQYIWGWCXQYIWBWC
      XMXQYIXOBWTVKRVLTQVMVOVPVQVRVSVTWA $.
  $}

  $( Nonnegative integer exponentiation with a mantissa between 0 and 1
     inclusive is less than or equal to 1.  (Contributed by Paul Chapman,
     29-Dec-2007.)  (Revised by Mario Carneiro, 5-Jun-2014.) $)
  exple1 $p |- ( ( ( A e. RR /\ 0 <_ A /\ A <_ 1 ) /\ N e. NN0 ) ->
                  ( A ^ N ) <_ 1 ) $=
    ( cr wcel cc0 cle wbr c1 w3a cn0 wa cexp co cuz cfv simpl1 0nn0 simpr nn0uz
    a1i syl6eleq simpl2 simpl3 leexp2r syl32anc cc wceq recnd exp0 syl breqtrd
    ) ACDZEAFGZAHFGZIZBJDZKZABLMZAELMZHFUQULEJDZBENOZDUMUNURUSFGULUMUNUPPZUTUQQ
    TUQBJVAUOUPRSUAULUMUNUPUBULUMUNUPUCAEBUDUEUQAUFDUSHUGUQAVBUHAUIUJUK $.

  $( An upper bound on ` A ^ N ` when ` 2 <_ A ` .  (Contributed by NM,
     19-Dec-2005.) $)
  expubnd $p |- ( ( A e. RR /\ N e. NN0 /\ 2 <_ A ) ->
                  ( A ^ N ) <_ ( ( 2 ^ N ) x. ( ( A - 1 ) ^ N ) ) ) $=
    ( cr wcel c2 cle wbr cexp co c1 cmin cmul cc0 wa 2re 0re caddc wceq cc 2cn
    cn0 simp1 peano2rem remulcl sylancr 3ad2ant1 simp2 2pos ltleii letr mp3an12
    w3a wi mpani wb resubcl mpan2 leadd2 mp3an1 mpdan biimpa recn npcan sylancl
    imp adantr ax-1cn subdi mp3an13 2times mulid1i oveq12d addsub mp3an3 anidms
    a1i 3eqtrrd syl 3brtr3d 3adant2 leexp1a syl31anc recnd mulexp sylan 3adant3
    jca breqtrd ) ACDZBUADZEAFGZULZABHIZEAJKIZLIZBHIZEBHIWNBHILIZFWLWIWOCDZWJMA
    FGZAWOFGZNZWMWPFGWIWJWKUBWIWJWRWKWIECDZWNCDWROAUCZEWNUDUEUFWIWJWKUGWIWKXAWJ
    WIWKNZWSWTWIWKWSWIMEFGZWKWSMEPOUHUIMCDXBWIXEWKNWSUMPOMEAUJUKUNVEXDAEKIZEQIZ
    XFAQIZAWOFWIWKXGXHFGZWIXFCDZWKXIUOZWIXBXJOAEUPUQXBWIXJXKOEAXFURUSUTVAWIXGAR
    ZWKWIASDZESDZXLAVBZTAEVCVDVFWIXHWORZWKWIXMXPXOXMWOEALIZEJLIZKIZAAQIZEKIZXHX
    NXMJSDWOXSRTVGEAJVHVIXMXQXTXREKAVJXRERXMETVKVPVLXMYAXHRZXMXMXNYBTAAEVMVNVOV
    QVRVFVSWGVTAWOBWAWBWIWJWPWQRZWKWIWNSDZWJYCWIWNXCWCXNYDWJYCTEWNBWDUSWEWFWH
    $.

  $( Value of the square of a complex number.  (Contributed by Raph Levien,
     10-Apr-2004.) $)
  sqval $p |- ( A e. CC -> ( A ^ 2 ) = ( A x. A ) ) $=
    ( cc wcel c2 cexp co c1 cmul caddc df-2 oveq2i wceq 1nn0 expp1 mpan2 syl5eq
    cn0 exp1 oveq1d eqtrd ) ABCZADEFZAGEFZAHFZAAHFUAUBAGGIFZEFZUDDUEAEJKUAGQCUF
    UDLMAGNOPUAUCAAHARST $.

  $( The square of the negative of a number.)  (Contributed by NM,
     15-Jan-2006.) $)
  sqneg $p |- ( A e. CC -> ( -u A ^ 2 ) = ( A ^ 2 ) ) $=
    ( cc wcel cneg cmul co c2 cexp wceq mul2neg anidms negcl sqval syl 3eqtr4d
    ) ABCZADZQEFZAAEFZQGHFZAGHFPRSIAAJKPQBCTRIALQMNAMO $.

  $( Swap the order of subtraction in a square.  (Contributed by Scott Fenton,
     10-Jun-2013.) $)
  sqsubswap $p |- ( ( A e. CC /\ B e. CC ) ->
             ( ( A - B ) ^ 2 ) = ( ( B - A ) ^ 2 ) ) $=
    ( cc wcel wa cmin co cneg cexp wceq subcl sqneg syl negsubdi2 oveq1d eqtr3d
    c2 ) ACDBCDEZABFGZHZQIGZSQIGZBAFGZQIGRSCDUAUBJABKSLMRTUCQIABNOP $.

  $( Closure of square.  (Contributed by NM, 10-Aug-1999.) $)
  sqcl $p |- ( A e. CC -> ( A ^ 2 ) e. CC ) $=
    ( cc wcel c2 cexp co cmul sqval mulcl anidms eqeltrd ) ABCZADEFAAGFZBAHLMBC
    AAIJK $.

  $( Distribution of square over multiplication.  (Contributed by NM,
     21-Mar-2008.) $)
  sqmul $p |- ( ( A e. CC /\ B e. CC ) ->
             ( ( A x. B ) ^ 2 ) = ( ( A ^ 2 ) x. ( B ^ 2 ) ) ) $=
    ( cc wcel c2 cn0 cmul co cexp wceq 2nn0 mulexp mp3an3 ) ACDBCDEFDABGHEIHAEI
    HBEIHGHJKABELM $.

  $( A number is zero iff its square is zero.  (Contributed by NM,
     11-Mar-2006.) $)
  sqeq0 $p |- ( A e. CC -> ( ( A ^ 2 ) = 0 <-> A = 0 ) ) $=
    ( cc wcel c2 cn cexp co cc0 wceq wb 2nn expeq0 mpan2 ) ABCDECADFGHIAHIJKADL
    M $.

  $( Distribution of square over division.  (Contributed by Scott Fenton,
     7-Jun-2013.)  (Proof shortened by Mario Carneiro, 9-Jul-2013.) $)
  sqdiv $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
      ( ( A / B ) ^ 2 ) = ( ( A ^ 2 ) / ( B ^ 2 ) ) ) $=
    ( cc wcel cc0 wne w3a cdiv co cmul c2 cexp wa wceq simp1 divmuldiv syl22anc
    3simpc divcl sqval syl oveqan12d 3adant3 3eqtr4d ) ACDZBCDZBEFZGZABHIZUIJIZ
    AAJIZBBJIZHIZUIKLIZAKLIZBKLIZHIZUHUEUEUFUGMZURUJUMNUEUFUGOZUSUEUFUGRZUTAABB
    PQUHUICDUNUJNABSUITUAUEUFUQUMNUGUEUFUOUKUPULHATBTUBUCUD $.

  $( A number is nonzero iff its square is nonzero.  (Contributed by NM,
     11-Mar-2006.) $)
  sqne0 $p |- ( A e. CC -> ( ( A ^ 2 ) =/= 0 <-> A =/= 0 ) ) $=
    ( cc wcel c2 cexp co cc0 sqeq0 necon3bid ) ABCADEFGAGAHI $.

  $( Closure of the square of a real number.  (Contributed by NM,
     18-Oct-1999.) $)
  resqcl $p |- ( A e. RR -> ( A ^ 2 ) e. RR ) $=
    ( cr wcel c2 cn0 cexp co 2nn0 reexpcl mpan2 ) ABCDECADFGBCHADIJ $.

  $( The square of a nonzero real is positive.  (Contributed by NM,
     8-Sep-2007.) $)
  sqgt0 $p |- ( ( A e. RR /\ A =/= 0 ) -> 0 < ( A ^ 2 ) ) $=
    ( cr wcel cc0 wne wa cmul co c2 cexp clt msqgt0 wceq cc recn sqval breqtrrd
    syl adantr ) ABCZADEZFDAAGHZAIJHZKALTUCUBMZUATANCUDAOAPRSQ $.

  $( The naturals are closed under squaring.  (Contributed by Scott Fenton,
     29-Mar-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  nnsqcl $p |- ( A e. NN -> ( A ^ 2 ) e. NN ) $=
    ( cn wcel c2 cexp co cmul cc wceq nncn sqval syl nnmulcl anidms eqeltrd ) A
    BCZADEFZAAGFZBPAHCQRIAJAKLPRBCAAMNO $.

  $( Integers are closed under squaring.  (Contributed by Scott Fenton,
     18-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  zsqcl $p |- ( A e. ZZ -> ( A ^ 2 ) e. ZZ ) $=
    ( cz wcel c2 cn0 cexp co 2nn0 zexpcl mpan2 ) ABCDECADFGBCHADIJ $.

  $( The square of a rational is rational.  (Contributed by Stefan O'Rear,
     15-Sep-2014.) $)
  qsqcl $p |- ( A e. QQ -> ( A ^ 2 ) e. QQ ) $=
    ( cq wcel c2 cexp co cmul cc wceq qcn sqval syl qmulcl anidms eqeltrd ) ABC
    ZADEFZAAGFZBPAHCQRIAJAKLPRBCAAMNO $.

  $( The square function is one-to-one for nonnegative reals.  (Contributed by
     NM, 8-Apr-2001.)  (Proof shortened by Mario Carneiro, 28-May-2016.) $)
  sq11 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
               ( ( A ^ 2 ) = ( B ^ 2 ) <-> A = B ) ) $=
    ( cr wcel cc0 cle wbr wa c2 cexp co wceq cc simpl recnd sqval syl eqeqan12d
    cmul msq11 bitrd ) ACDZEAFGZHZBCDZEBFGZHZHAIJKZBIJKZLAASKZBBSKZLABLUDUGUHUJ
    UIUKUDAMDUHUJLUDAUBUCNOAPQUGBMDUIUKLUGBUEUFNOBPQRABTUA $.

  $( The square function on nonnegative reals is strictly monotonic.
     (Contributed by NM, 24-Feb-2006.) $)
  lt2sq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( A < B <-> ( A ^ 2 ) < ( B ^ 2 ) ) ) $=
    ( cr wcel cc0 cle wbr wa clt cmul co c2 cexp lt2msq wb recn sqval breqan12d
    cc syl2an ad2ant2r bitr4d ) ACDZEAFGZHBCDZEBFGZHHABIGAAJKZBBJKZIGZALMKZBLMK
    ZIGZABNUCUEULUIOZUDUFUCASDZBSDZUMUEAPBPUNUOUJUGUKUHIAQBQRTUAUB $.

  $( The square function on nonnegative reals is monotonic.  (Contributed by
     NM, 18-Oct-1999.) $)
  le2sq $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
              ( A <_ B <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
    ( cr wcel cc0 cle wbr wa cmul co c2 cexp le2msq wb cc recn breqan12d syl2an
    sqval ad2ant2r bitr4d ) ACDZEAFGZHBCDZEBFGZHHABFGAAIJZBBIJZFGZAKLJZBKLJZFGZ
    ABMUBUDUKUHNZUCUEUBAODZBODZULUDAPBPUMUNUIUFUJUGFASBSQRTUA $.

  $( The square of a 'less than or equal to' ordering.  (Contributed by NM,
     21-Mar-2008.) $)
  le2sq2 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ A <_ B ) ) ->
              ( A ^ 2 ) <_ ( B ^ 2 ) ) $=
    ( cr wcel cc0 cle wbr wa c2 cexp co simprr wb simprl 0re mp3an1 exp4b com23
    wi letr imp43 jca le2sq syldan mpbid ) ACDZEAFGZHZBCDZABFGZHZHZUJAIJKBIJKFG
    ZUHUIUJLUHUKUIEBFGZHUJUMMULUIUNUHUIUJNUFUGUIUJUNUFUIUGUJUNSUFUIUGUJUNECDUFU
    IUGUJHUNSOEABTPQRUAUBABUCUDUE $.

  $( A square of a real is nonnegative.  (Contributed by NM, 18-Oct-1999.) $)
  sqge0 $p |- ( A e. RR -> 0 <_ ( A ^ 2 ) ) $=
    ( cr wcel cc0 cmul co c2 cexp cle msqge0 cc wceq recn sqval syl breqtrrd )
    ABCZDAAEFZAGHFZIAJQAKCSRLAMANOP $.

  $( The square of an integer is a nonnegative integer.  (Contributed by Mario
     Carneiro, 18-Apr-2014.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  zsqcl2 $p |- ( A e. ZZ -> ( A ^ 2 ) e. NN0 ) $=
    ( cz wcel c2 cexp co cc0 cle wbr cn0 zsqcl cr zre sqge0 syl elnn0z sylanbrc
    ) ABCZADEFZBCGSHIZSJCAKRALCTAMANOSPQ $.

  $( Two real numbers are equal to 0 iff their Euclidean norm is.  (Contributed
     by NM, 29-Apr-2005.)  (Revised by Stefan O'Rear, 5-Oct-2014.)  (Proof
     shortened by Mario Carneiro, 28-May-2016.) $)
  sumsqeq0 $p |- ( ( A e. RR /\ B e. RR ) ->
    ( ( A = 0 /\ B = 0 ) <-> ( ( A ^ 2 ) + ( B ^ 2 ) ) = 0 ) ) $=
    ( cr wcel wa c2 cexp co cc0 wceq cle wbr wb resqcl sqge0 jca recn sqeq0 syl
    cc caddc add20 syl2an bi2anan9 bitr2d ) ACDZBCDZEAFGHZBFGHZUAHIJZUHIJZUIIJZ
    EZAIJZBIJZEUFUHCDZIUHKLZEUICDZIUIKLZEUJUMMUGUFUPUQANAOPUGURUSBNBOPUHUIUBUCU
    FUKUNUGULUOUFATDUKUNMAQARSUGBTDULUOMBQBRSUDUE $.

  ${
    sqval.1 $e |- A e. CC $.
    $( Value of square.  Inference version.  (Contributed by NM,
       1-Aug-1999.) $)
    sqvali $p |- ( A ^ 2 ) = ( A x. A ) $=
      ( cc wcel c2 cexp co cmul wceq sqval ax-mp ) ACDAEFGAAHGIBAJK $.

    $( Closure of square.  (Contributed by NM, 2-Aug-1999.) $)
    sqcli $p |- ( A ^ 2 ) e. CC $=
      ( cc wcel c2 cexp co sqcl ax-mp ) ACDAEFGCDBAHI $.

    $( A number is zero iff its square is zero.  (Contributed by NM,
       2-Oct-1999.) $)
    sqeq0i $p |- ( ( A ^ 2 ) = 0 <-> A = 0 ) $=
      ( cc wcel c2 cexp co cc0 wceq wb sqeq0 ax-mp ) ACDAEFGHIAHIJBAKL $.

    ${
      sqreci.1 $e |- A =/= 0 $.
      $( Square of reciprocal.  (Contributed by NM, 17-Sep-1999.) $)
      sqrecii $p |- ( ( 1 / A ) ^ 2 ) = ( 1 / ( A ^ 2 ) ) $=
        ( c1 cdiv co cmul c2 ax-1cn divmuldivi 1t1e1 oveq1i eqtri reccli sqvali
        cexp oveq2i 3eqtr4i ) DAEFZSGFZDAAGFZEFZSHPFDAHPFZEFTDDGFZUAEFUBDADAIBI
        BCCJUDDUAEKLMSABCNOUCUADEABOQR $.
    $}

    sqmul.2 $e |- B e. CC $.
    $( Distribution of square over multiplication.  (Contributed by NM,
       3-Sep-1999.) $)
    sqmuli $p |- ( ( A x. B ) ^ 2 ) = ( ( A ^ 2 ) x. ( B ^ 2 ) ) $=
      ( cc wcel cmul co c2 cexp wceq sqmul mp2an ) AEFBEFABGHIJHAIJHBIJHGHKCDAB
      LM $.

    sqdiv.3 $e |- B =/= 0 $.
    $( Distribution of square over division.  (Contributed by NM,
       20-Aug-2001.) $)
    sqdivi $p |- ( ( A / B ) ^ 2 ) = ( ( A ^ 2 ) / ( B ^ 2 ) ) $=
      ( cdiv co cmul c2 cexp divmuldivi divcli sqvali oveq12i 3eqtr4i ) ABFGZPH
      GAAHGZBBHGZFGPIJGAIJGZBIJGZFGABABCDCDEEKPABCDELMSQTRFACMBDMNO $.
  $}

  ${
    resqcl.1 $e |- A e. RR $.
    $( Closure of square in reals.  (Contributed by NM, 2-Aug-1999.) $)
    resqcli $p |- ( A ^ 2 ) e. RR $=
      ( cr wcel c2 cexp co resqcl ax-mp ) ACDAEFGCDBAHI $.

    $( The square of a nonzero real is positive.  (Contributed by NM,
       17-Sep-1999.) $)
    sqgt0i $p |- ( A =/= 0 -> 0 < ( A ^ 2 ) ) $=
      ( cr wcel cc0 wne c2 cexp co clt wbr sqgt0 mpan ) ACDAEFEAGHIJKBALM $.

    $( A square of a real is nonnegative.  (Contributed by NM, 3-Aug-1999.) $)
    sqge0i $p |- 0 <_ ( A ^ 2 ) $=
      ( cc0 cmul co c2 cexp cle msqge0i recni sqvali breqtrri ) CAADEAFGEHABIAA
      BJKL $.

    lt2sq.2 $e |- B e. RR $.
    $( The square function on nonnegative reals is strictly monotonic.
       (Contributed by NM, 12-Sep-1999.) $)
    lt2sqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
              ( A < B <-> ( A ^ 2 ) < ( B ^ 2 ) ) ) $=
      ( cc0 cle wbr wa clt cmul co c2 cexp lt2msqi recni sqvali breq12i syl6bbr
      ) EAFGEBFGHABIGAAJKZBBJKZIGALMKZBLMKZIGABCDNUASUBTIAACOPBBDOPQR $.

    $( The square function on nonnegative reals is monotonic.  (Contributed by
       NM, 12-Sep-1999.) $)
    le2sqi $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
              ( A <_ B <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
      ( cc0 cle wbr wa cmul co c2 cexp le2msqi recni sqvali breq12i syl6bbr ) E
      AFGEBFGHABFGAAIJZBBIJZFGAKLJZBKLJZFGABCDMTRUASFAACNOBBDNOPQ $.

    $( The square function is one-to-one for nonnegative reals.  (Contributed
       by NM, 27-Oct-1999.) $)
    sq11i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
              ( ( A ^ 2 ) = ( B ^ 2 ) <-> A = B ) ) $=
      ( c2 cexp co wceq cmul cc0 cle wbr wa recni sqvali eqeq12i msq11i syl5bb
      ) AEFGZBEFGZHAAIGZBBIGZHJAKLJBKLMABHSUATUBAACNOBBDNOPABCDQR $.
  $}

  $( The square of 0 is 0.  (Contributed by NM, 6-Jun-2006.) $)
  sq0 $p |- ( 0 ^ 2 ) = 0 $=
    ( cc0 c2 cexp co wceq eqid 0cn sqeq0i mpbir ) ABCDAEAAEAFAGHI $.

  $( If a number is zero, its square is zero.  (Contributed by FL,
     10-Dec-2006.) $)
  sq0i $p |- ( A = 0 -> ( A ^ 2 ) = 0 ) $=
    ( cc0 wceq c2 cexp co oveq1 sq0 syl6eq ) ABCADEFBDEFBABDEGHI $.

  ${
    sq0id.1 $e |- ( ph -> A = 0 ) $.
    $( If a number is zero, its square is zero.  Deduction form of ~ sq0i .
       Converse of ~ sqeq0d .  (Contributed by David Moews, 28-Feb-2017.) $)
    sq0id $p |- ( ph -> ( A ^ 2 ) = 0 ) $=
      ( cc0 wceq c2 cexp co sq0i syl ) ABDEBFGHDECBIJ $.
  $}

  $( The square of 1 is 1.  (Contributed by NM, 22-Aug-1999.) $)
  sq1 $p |- ( 1 ^ 2 ) = 1 $=
    ( c2 cz wcel c1 cexp co wceq 2z 1exp ax-mp ) ABCDAEFDGHAIJ $.

  $( The square of 2 is 4.  (Contributed by NM, 22-Aug-1999.) $)
  sq2 $p |- ( 2 ^ 2 ) = 4 $=
    ( c2 cexp co cmul c4 2cn sqvali 2t2e4 eqtri ) AABCAADCEAFGHI $.

  $( The square of 3 is 9.  (Contributed by NM, 26-Apr-2006.) $)
  sq3 $p |- ( 3 ^ 2 ) = 9 $=
    ( c3 c2 cexp co cmul c9 3cn sqvali 3t3e9 eqtri ) ABCDAAEDFAGHIJ $.

  $( The cube of 2 is 8.  (Contributed by NM, 2-Aug-2004.) $)
  cu2 $p |- ( 2 ^ 3 ) = 8 $=
    ( c2 c3 cexp co c1 caddc c8 df-3 oveq2i cmul wcel cn0 wceq 2nn0 expp1 mp2an
    cc 2cn c4 eqtri sq2 oveq1i 4t2e8 ) ABCDAAEFDZCDZGBUDACHIUEAACDZAJDZGAQKALKU
    EUGMRNAAOPUGSAJDGUFSAJUAUBUCTTT $.

  $( The reciprocal of ` _i ` .  (Contributed by NM, 11-Oct-1999.) $)
  irec $p |- ( 1 / _i ) = -u _i $=
    ( c1 ci cdiv co cneg wceq cmul ax-icn mulneg2i ax-1cn mulcli negcon2i mpbir
    ixi eqtr4i negcli ine0 divmuli ) ABCDBEZFBSGDZAFTBBGDZEZABBHHIAUBFUAAEFNAUA
    JBBHHKLMOABSJHBHPQRM $.

  $( ` _i ` squared.  (Contributed by NM, 6-May-1999.) $)
  i2 $p |- ( _i ^ 2 ) = -u 1 $=
    ( ci c2 cexp co cmul c1 cneg ax-icn sqvali ixi eqtri ) ABCDAAEDFGAHIJK $.

  $( ` _i ` cubed.  (Contributed by NM, 31-Jan-2007.) $)
  i3 $p |- ( _i ^ 3 ) = -u _i $=
    ( ci c3 cexp co c2 c1 caddc cneg df-3 oveq2i cmul wcel cn0 wceq ax-icn 2nn0
    cc expp1 mp2an eqtri i2 oveq1i mulm1i ) ABCDAEFGDZCDZAHZBUDACIJUEAECDZAKDZU
    FAQLEMLUEUHNOPAERSUHFHZAKDUFUGUIAKUAUBAOUCTTT $.

  $( ` _i ` to the fourth power.  (Contributed by NM, 31-Jan-2007.) $)
  i4 $p |- ( _i ^ 4 ) = 1 $=
    ( ci c2 caddc co cexp cmul c4 c1 cc wcel cn0 wceq ax-icn expadd mp3an 2p2e4
    2nn0 oveq2i i2 ax-1cn cneg oveq12i mul2negi 1t1e1 3eqtri 3eqtr3i ) ABBCDZED
    ZABEDZUIFDZAGEDHAIJBKJZUKUHUJLMQQABBNOUGGAEPRUJHUAZULFDHHFDHUIULUIULFSSUBHH
    TTUCUDUEUF $.

  $( A natural number is less than or equal to its square.  (Contributed by NM,
     15-Sep-1999.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
  nnlesq $p |- ( N e. NN -> N <_ ( N ^ 2 ) ) $=
    ( cn wcel cmul co c2 cexp cle c1 nncn mulid1d wbr nnge1 cr cc0 clt 1re nnre
    wb a1i nngt0 lemul2 syl112anc mpbid eqbrtrrd cc wceq sqval syl breqtrrd ) A
    BCZAAADEZAFGEZHUKAIDEZAULHUKAAJZKUKIAHLZUNULHLZAMUKINCZANCZUSOAPLUPUQSURUKQ
    TARZUTAUAIAAUBUCUDUEUKAUFCUMULUGUOAUHUIUJ $.

  $( Taking ` _i ` to the ` K ` -th power is the same as using the ` K mod 4 `
     -th power instead, by ~ i4 .  (Contributed by Mario Carneiro,
     7-Jul-2014.) $)
  iexpcyc $p |- ( K e. ZZ -> ( _i ^ ( K mod 4 ) ) = ( _i ^ K ) ) $=
    ( cz wcel ci c4 co cexp cdiv cr wceq sylancl oveq2d 4nn sylancr ax-icn ine0
    cc wa c1 eqtrd cmo cfl cfv cmul cmin crp zre 4re 4pos elrpii modval nnzi cn
    nndivre flcld zmulcl cc0 expsub mpanl12 mpdan expmulz i4 oveq1i 1exp syl5eq
    wne syl expclz mp3an12 div1d ) ABCZDAEUAFZGFDAEAEHFZUBUCZUDFZUEFZGFZDAGFZVK
    VLVPDGVKAICZEUFCVLVPJAUGZEUHUIUJAEUKKLVKVQVRDVOGFZHFZVRVKVOBCZVQWBJZVKEBCZV
    NBCZWCEMULZVKVMVKVSEUMCVMICVTMAEUNKUOZEVNUPNDQCZDUQVFZVKWCRWDOPDAVOURUSUTVK
    WBVRSHFVRVKWASVRHVKWADEGFZVNGFZSVKWEWFWAWLJZWGWHWIWJWEWFRWMOPDEVNVAUSNVKWLS
    VNGFZSWKSVNGVBVCVKWFWNSJWHVNVDVGVETLVKVRWIWJVKVRQCOPDAVHVIVJTTT $.

  $( A counterexample showing that exponentiation is not associative.
     (Contributed by Stefan Allan and G&eacute;rard Lang, 21-Sep-2010.) $)
  expnass $p |- ( ( 3 ^ 3 ) ^ 3 ) < ( 3 ^ ( 3 ^ 3 ) ) $=
    ( c3 cmul co cexp clt cc wcel 3cn 3nn0 mp3an wbr 3re nn0zi w3a 1lt3 ltexp2a
    cz c2 mpanr12 eqbrtrri cn0 wceq expmul cr nn0mulcli nn0expcli c1 sqvali 3nn
    2z nnzi 2lt3 ) AAABCZDCZAADCZADCZAUODCZEAFGAUAGZURUNUPUBHIIAAAUCJAUDGZUMQGZ
    UOQGZUNUQEKZLUMAAIIUEMUOAAIIUFMUSUTVANUGAEKZUMUOEKVBOARDCZUMUOEAHUHUSRQGZAQ
    GZVDUOEKZLUJAUIUKUSVEVFNVCRAEKVGOULARAPSJTAUMUOPSJT $.

  $( Cancel one factor of a square in a ` <_ ` comparison.  Unlike ~ lemul1 ,
     the common factor ` A ` may be zero.  (Contributed by NM, 17-Jan-2008.) $)
  sqlecan $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
      ( ( A ^ 2 ) <_ ( B x. A ) <-> A <_ B ) ) $=
    ( cr wcel cc0 cle wbr wa c2 cexp co cmul wb clt wceq wo wi 0re leloe recn
    mpan w3a sqval syl breq1d 3ad2ant1 lemul1 bitr4d 3exp exp4a pm2.43a adantrd
    cc com23 sq0 0le0 eqbrtri mul01d syl5breqr adantl oveq1 oveq2 breq12d mpbid
    adantr adantrr breq1 biimpa adantrl 2thd ex a1i jaod sylbid imp31 ) ACDZEAF
    GZBCDZEBFGZHZAIJKZBALKZFGZABFGZMZVPVQEANGZEAOZPZVTWEQZECDVPVQWHMREASUAVPWFW
    IWGVPVTWFWEVPVRWFWEQZVSVRVPWJVPVRVPWFWEVPVRVPWFHZWEVPVRWKUBWCAALKZWBFGZWDVP
    VRWCWMMWKVPWAWLWBFVPAUMDWAWLOATAUCUDUEUFABAUGUHUIUJUKULUNWGWIQVPWGVTWEWGVTH
    WCWDWGVRWCVSWGVRHEIJKZBELKZFGZWCVRWPWGVRWNEWOFWNEEFUOUPUQVRBBTURUSUTWGWPWCM
    VRWGWNWAWOWBFEAIJVAEABLVBVCVEVDVFWGVSWDVRWGVSWDEABFVGVHVIVJVKVLVMVNVO $.

  $( Factor the difference of two squares.  (Contributed by NM,
     21-Feb-2008.) $)
  subsq $p |- ( ( A e. CC /\ B e. CC ) ->
          ( ( A ^ 2 ) - ( B ^ 2 ) ) = ( ( A + B ) x. ( A - B ) ) ) $=
    ( cc wcel wa caddc co cmin cmul cexp simpl simpr sqval adantr eqtr4d adantl
    c2 wceq oveq12d sqcl subcl adddird subdi oveq1d subdid mulcom mulcl npncand
    3anidm12 3eqtrrd ) ACDZBCDZEZABFGABHGZIGAUNIGZBUNIGZFGAQJGZABIGZHGZURBQJGZH
    GZFGUQUTHGUMABUNUKULKZUKULLZABUAUBUMUOUSUPVAFUMUOAAIGZURHGZUSUKULUOVERAABUC
    UIUMUQVDURHUKUQVDRULAMNUDOUMUPBAIGZBBIGZHGVAUMBABVCVBVCUEUMURVFUTVGHABUFULU
    TVGRUKBMPSOSUMUQURUTUKUQCDULATNABUGULUTCDUKBTPUHUJ $.

  $( Express the difference of the squares of two numbers as a polynomial in
     the difference of the numbers.  (Contributed by NM, 21-Feb-2008.) $)
  subsq2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A ^ 2 ) - ( B ^ 2 ) ) =
    ( ( ( A - B ) ^ 2 ) + ( ( 2 x. B ) x. ( A - B ) ) ) ) $=
    ( cc wcel wa caddc co cmin cmul c2 cexp wceq 2cn mulcl mpan adantl subadd23
    mpd3an3 oveq1d eqtrd 2times pncan anidms oveq2d subcl adddird subsq 3eqtr4d
    eqtr3d sqval syl ) ACDZBCDZEZABFGZABHGZIGZUPUPIGZJBIGZUPIGZFGZAJKGBJKGHGUPJ
    KGZUTFGUNUPUSFGZUPIGUQVAUNVCUOUPIUNVCAUSBHGZFGZUOULUMUSCDZVCVELUMVFULJCDUMV
    FMJBNOPZABUSQRUNVDBAFUMVDBLULUMVDBBFGZBHGZBUMUSVHBHBUASUMVIBLBBUBUCTPUDTSUN
    UPUSUPABUEZVGVJUFUIABUGUNVBURUTFUNUPCDVBURLVJUPUJUKSUH $.

  ${
    binom2.1 $e |- A e. CC $.
    binom2.2 $e |- B e. CC $.
    $( The square of a binomial.  (Contributed by NM, 11-Aug-1999.) $)
    binom2i $p |- ( ( A + B ) ^ 2 ) = ( ( ( A ^ 2 ) + ( 2 x.
                ( A x. B ) ) ) + ( B ^ 2 ) ) $=
      ( caddc co cmul c2 cexp addcli adddii adddiri mulcomi oveq2i eqtri mulcli
      oveq12i addassi oveq1i sqvali 3eqtr2i 2timesi 3eqtr4i ) ABEFZUDGFZAAGFZAB
      GFZUGEFZEFZBBGFZEFZUDHIFAHIFZHUGGFZEFZBHIFZEFUEUDAGFZUDBGFZEFZUKUDABABCDJ
      ZCDKURUFUGEFZUGUJEFZEFUTUGEFZUJEFUKUPUTUQVAEUPUFBAGFZEFUTABACDCLVCUGUFEBA
      DCMNOABBCDDLQUTUGUJUFUGAACCPZABCDPZJVEBBDDPRVBUIUJEUFUGUGVDVEVERSUAOUDUST
      UNUIUOUJEULUFUMUHEACTUGVEUBQBDTQUC $.

    $( Product of sum and difference.  (Contributed by NM, 7-Feb-2005.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    binom2aiOLD $p |- ( ( A + B ) x. ( A - B ) ) = ( ( A ^ 2 ) - ( B ^ 2 ) ) $=
      ( caddc cmin cmul cexp subcli adddiri subdii sqvali oveq1i eqtr4i mulcomi
      co c2 oveq12i sqcli mulcli addsubassi addcomi pncan3i eqtri eqtr3i 3eqtri
      ) ABEPABFPZGPAUGGPZBUGGPZEPAQHPZABGPZFPZUKBQHPZFPZEPZUJUMFPZABUGCDABCDIJU
      HULUIUNEUHAAGPZUKFPULAABCCDKUJUQUKFACLMNUIBAGPZBBGPZFPUNBABDCDKUKURUMUSFA
      BCDOBDLRNRULUKEPZUMFPUOUPULUKUMUJUKACSZABCDTZIZVBBDSUAUTUJUMFUTUKULEPUJUL
      UKVCVBUBUKUJVBVAUCUDMUEUF $.

    $( Factor the difference of two squares.  (Contributed by NM,
       7-Feb-2005.) $)
    subsqi $p |- ( ( A ^ 2 ) - ( B ^ 2 ) ) = ( ( A + B ) x. ( A - B ) ) $=
      ( cc wcel c2 cexp co cmin caddc cmul wceq subsq mp2an ) AEFBEFAGHIBGHIJIA
      BKIABJILIMCDABNO $.

    $( The squares of two complex numbers are equal iff one number equals the
       other or its negative.  Lemma 15-4.7 of [Gleason] p. 311 and its
       converse.  (Contributed by NM, 15-Jan-2006.) $)
    sqeqori $p |- ( ( A ^ 2 ) = ( B ^ 2 ) <-> ( A = B \/ A = -u B ) ) $=
      ( c2 cexp co wceq caddc cc0 cmin wo cneg cmul subsqi eqeq1i sqcli subeq0i
      addcli subcli mul0ori 3bitr3i orcom subnegi negcli bitr3i orbi12i 3bitri
      ) AEFGZBEFGZHZABIGZJHZABKGZJHZLZUOUMLABHZABMZHZLUIUJKGZJHULUNNGZJHUKUPUTV
      AJABCDOPUIUJACQBDQRULUNABCDSABCDTUAUBUMUOUCUOUQUMUSABCDRUMAURKGZJHUSVBULJ
      ABCDUDPAURCBDUERUFUGUH $.

    $( The two solutions to the difference of squares set equal to zero.
       (Contributed by NM, 25-Apr-2006.) $)
    subsq0i $p |- ( ( ( A ^ 2 ) - ( B ^ 2 ) ) = 0
                  <-> ( A = B \/ A = -u B ) ) $=
      ( c2 cexp co cmin cc0 wceq cneg wo sqcli subeq0i sqeqori bitri ) AEFGZBEF
      GZHGIJQRJABJABKJLQRACMBDMNABCDOP $.
  $}

  $( The squares of two complex numbers are equal iff one number equals the
     other or its negative.  Lemma 15-4.7 of [Gleason] p. 311 and its
     converse.  (Contributed by Paul Chapman, 15-Mar-2008.) $)
  sqeqor $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( ( A ^ 2 ) = ( B ^ 2 ) <-> ( A = B \/ A = -u B ) ) ) $=
    ( cc wcel c2 cexp co wceq cneg wo wb cc0 oveq1 eqeq1 orbi12d bibi12d eqeq2d
    cif 0cn elimel eqeq1d eqeq2 negeq sqeqori dedth2h ) ACDZBCDZAEFGZBEFGZHZABH
    ZABIZHZJZKUFALRZEFGZUIHZUOBHZUOULHZJZKUPUGBLRZEFGZHZUOVAHZUOVAIZHZJZKABLLAU
    OHZUJUQUNUTVHUHUPUIAUOEFMUAVHUKURUMUSAUOBNAUOULNOPBVAHZUQVCUTVGVIUIVBUPBVAE
    FMQVIURVDUSVFBVAUOUBVIULVEUOBVAUCQOPUOVAALCSTBLCSTUDUE $.

  $( The square of a binomial.  (Contributed by FL, 10-Dec-2006.) $)
  binom2 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) ^ 2 ) =
     ( ( ( A ^ 2 ) + ( 2 x. ( A x. B ) ) ) + ( B ^ 2 ) ) ) $=
    ( cc wcel caddc co c2 cexp cmul cc0 cif oveq1 oveq1d oveq2d oveq12d eqeq12d
    wceq oveq2 0cn elimel binom2i dedth2h ) ACDZBCDZABEFZGHFZAGHFZGABIFZIFZEFZB
    GHFZEFZQUCAJKZBEFZGHFZUMGHFZGUMBIFZIFZEFZUKEFZQUMUDBJKZEFZGHFZUPGUMVAIFZIFZ
    EFZVAGHFZEFZQABJJAUMQZUFUOULUTVIUEUNGHAUMBELMVIUJUSUKEVIUGUPUIUREAUMGHLVIUH
    UQGIAUMBILNOMPBVAQZUOVCUTVHVJUNVBGHBVAUMERMVJUSVFUKVGEVJURVEUPEVJUQVDGIBVAU
    MIRNNBVAGHLOPUMVAAJCSTBJCSTUAUB $.

  $( Special case of ~ binom2 where ` B = 1 ` .  (Contributed by Scott Fenton,
     11-May-2014.) $)
  binom21 $p |- ( A e. CC -> ( ( A + 1 ) ^ 2 ) = ( ( ( A ^ 2
      ) + ( 2 x. A ) ) + 1 ) ) $=
    ( cc wcel c1 caddc co c2 cexp cmul wceq ax-1cn binom2 mulid1 oveq2d sq1 a1i
    mpan2 oveq12d eqtrd ) ABCZADEFGHFZAGHFZGADIFZIFZEFZDGHFZEFZUBGAIFZEFZDEFTDB
    CUAUGJKADLQTUEUIUFDETUDUHUBETUCAGIAMNNUFDJTOPRS $.

  $( Expand the square of a subtraction.  (Contributed by Scott Fenton,
     10-Jun-2013.) $)
  binom2sub $p |- ( ( A e. CC /\ B e. CC ) ->
    ( ( A - B ) ^ 2 ) =
    ( ( ( A ^ 2 ) - ( 2 x. ( A x. B ) ) ) + ( B ^ 2 ) ) ) $=
    ( cc wcel wa c2 cexp co cneg cmul caddc cmin wceq eqtr3d mulneg2 oveq2d 2cn
    negcl mulcl sylancr binom2 sylan2 negsub oveq1d eqtr2d adantr negsubd sqneg
    sqcl adantl oveq12d ) ACDZBCDZEZAFGHZFABIZJHZJHZKHZUPFGHZKHZABLHZFGHZUOFABJ
    HZJHZLHZBFGHZKHUNAUPKHZFGHZVAVCUMULUPCDVIVAMBRAUPUAUBUNVHVBFGABUCUDNUNUSVFU
    TVGKUNUOVEIZKHUSVFUNVJURUOKUNURFVDIZJHZVJUNUQVKFJABOPUNFCDZVDCDZVLVJMQABSZF
    VDOTUEPUNUOVEULUOCDUMAUIUFUNVMVNVECDQVOFVDSTUGNUMUTVGMULBUHUJUKN $.

  ${
    binom2subi.1 $e |- A e. CC $.
    binom2subi.2 $e |- B e. CC $.
    $( Expand the square of a subtraction.  (Contributed by Scott Fenton,
       13-Jun-2013.) $)
    binom2subi $p |- ( ( A - B ) ^ 2 ) =
    ( ( ( A ^ 2 ) - ( 2 x. ( A x. B ) ) ) + ( B ^ 2 ) ) $=
      ( cc wcel cmin co c2 cexp cmul caddc wceq binom2sub mp2an ) AEFBEFABGHIJH
      AIJHIABKHKHGHBIJHLHMCDABNO $.
  $}

  $( The cube of a binomial.  (Contributed by Mario Carneiro, 24-Apr-2015.) $)
  binom3 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) ^ 3 ) =
     ( ( ( A ^ 3 ) + ( 3 x. ( ( A ^ 2 ) x. B ) ) ) +
       ( ( 3 x. ( A x. ( B ^ 2 ) ) ) + ( B ^ 3 ) ) ) ) $=
    ( cc wcel caddc co c3 cexp c2 cmul c1 sylancl syl oveq1d 2cn adddird oveq2d
    wceq eqtr4d oveq12d wa df-3 oveq2i addcl 2nn0 expp1 syl5eq sqcl simpl simpr
    cn0 adddid binom2 mulcl sylancr addcld sqval mul32d eqtrd a1i 3eqtrd mulcld
    mulassd mulcomd 3nn0 expcl addassd eqtr3d add4d oveq1i ax-1cn mulid2d 2p1e3
    addcomli syl5eqr eqtr2d ) ACDZBCDZUAZABEFZGHFZVTIHFZVTJFZAGHFZIAIHFZBJFZJFZ
    EFZWFEFZABIHFZJFZIWKJFZBGHFZEFZEFZEFZWDGWFJFZEFZGWKJFZWMEFZEFVSWAVTIKEFZHFZ
    WCGXAVTHUBUCVSVTCDZIUKDZXBWCRABUDZUEVTIUFLUGVSWCWBAJFZWBBJFZEFWHWKEFZWFWNEF
    ZEFWPVSWBABVSXCWBCDXEVTUHMVQVRUIZVQVRUJZULVSXFXHXGXIEVSXFWEIABJFZJFZEFZWJEF
    ZAJFXNAJFZWJAJFZEFXHVSWBXOAJABUMZNVSXNWJAVSWEXMVSVQWECDXJAUHMZVSICDZXLCDXMC
    DOABUNZIXLUNUOZUPZVSVRWJCDXKBUHMZXJPVSXPWHXQWKEVSXPWEAJFZXMAJFZEFWHVSWEXMAX
    SYBXJPVSWDYEWGYFEVSWDAXAHFZYEGXAAHUBUCVSVQXDYGYERXJUEAIUFLUGVSWGIXLAJFZJFYF
    VSWFYHIJVSWFAAJFZBJFYHVSWEYIBJVSVQWEYIRXJAUQMNVSAABXJXJXKURUSQVSIXLAXTVSOUT
    ZYAXJVCSTSVSWJAYDXJVDTVAVSXGXOBJFXNBJFZWJBJFZEFZXIVSWBXOBJXRNVSXNWJBYCYDXKP
    VSWFWLEFZWMEFYMXIVSYNYKWMYLEVSYNWFXMBJFZEFYKVSWLYOWFEVSWLIXLBJFZJFYOVSWKYPI
    JVSWKABBJFZJFYPVSWJYQAJVSVRWJYQRXKBUQMQVSABBXJXKXKVCSQVSIXLBYJYAXKVCSQVSWEX
    MBXSYBXKPSVSWMBXAHFZYLGXABHUBUCVSVRXDYRYLRXKUEBIUFLUGTVSWFWLWMVSWEBXSXKVBZV
    SXTWKCDWLCDOVSAWJXJYDVBZIWKUNUOZVSVRGUKDZWMCDXKVEBGVFLZVGVHVATVSWHWKWFWNVSW
    DWGVSVQUUBWDCDXJVEAGVFLZVSXTWFCDWGCDOYSIWFUNUOZUPYTYSVSWLWMUUAUUCUPVIVAVSWI
    WRWOWTEVSWIWDWGWFEFZEFWRVSWDWGWFUUDUUEYSVGVSWQUUFWDEVSWQWGKWFJFZEFZUUFVSWQX
    AWFJFUUHGXAWFJUBVJVSIKWFYJKCDVSVKUTZYSPUGVSUUGWFWGEVSWFYSVLQUSQSVSWTWKWLEFZ
    WMEFWOVSWSUUJWMEVSWSKWKJFZWLEFZUUJVSWSKIEFZWKJFUULUUMGWKJIKGOVKVMVNVJVSKIWK
    UUIYJYTPVOVSUUKWKWLEVSWKYTVLNUSNVSWKWLWMYTUUAUUCVGVPTVA $.

  $( If a complex number equals its square, it must be 0 or 1.  (Contributed by
     NM, 6-Jun-2006.) $)
  sq01 $p |- ( A e. CC -> ( ( A ^ 2 ) = A <-> ( A = 0 \/ A = 1 ) ) ) $=
    ( cc wcel c2 cexp co wceq cc0 c1 wo wa wn df-ne cmul wb sqval oveq1 3eqtr4a
    wne id mulid1 eqcomd eqeq12d adantr ax-1cn mulcan mp3an2 anabss5 bitrd orrd
    biimpd impancom syl5bir ex sq0 sq1 jaoi impbid1 ) ABCZADEFZAGZAHGZAIGZJZUSV
    AVDUSVAKZVBVCVBLAHSZVEVCAHMUSVFVAVCUSVFKZVAVCVGVAAANFZAINFZGZVCUSVAVJOVFUSU
    TVHAVIAPUSVIAAUAUBUCUDUSVFVJVCOZUSIBCVGVKUEAIAUFUGUHUIUKULUMUJUNVBVAVCVBHDE
    FHUTAUOAHDEQVBTRVCIDEFIUTAUPAIDEQVCTRUQUR $.

  $( An integer is even iff its square is even.  (Contributed by Mario
     Carneiro, 12-Sep-2015.) $)
  zesq $p |- ( N e. ZZ ->
              ( ( N / 2 ) e. ZZ <-> ( ( N ^ 2 ) / 2 ) e. ZZ ) ) $=
    ( cz wcel c2 cdiv co cexp wa cmul wceq cc sqval syl oveq1d 2cn 2ne0 divassd
    a1i c1 caddc zcn cc0 eqtrd adantr zmulcl eqeltrd cmin sqcl peano2cn halfcld
    wne wn pncand binom21 sylancr ax-1cn add32d 3eqtr3d divdird divcan3d oveq2d
    mulcl peano2z sylan eqeltrrd simpl zsubcld ex con3d wb zeo2 3imtr4d impbida
    zsqcl imp ) ABCZADEFZBCZADGFZDEFZBCZVPVRHVTAVQIFZBVPVTWBJVRVPVTAAIFZDEFWBVP
    VSWCDEVPAKCZVSWCJAUAZALMNVPAADWEWEDKCZVPORDUBUKZVPPRQUCUDAVQUEUFVPWAVRVPVSS
    TFZDEFZBCZULZASTFZDEFZBCZULWAVRVPWNWJVPWNWJVPWNHZWIATFZAUGFWIBWOWIAWOWHWOVS
    KCZWHKCWOWDWQVPWDWNWEUDZAUHMZVSUIMZUJWRUMWOWPAWOWLWMIFZWPBWOWLWLIFZDEFWHDAI
    FZTFZDEFZXAWPWOXBXDDEWOWLDGFZVSXCTFSTFZXBXDWOWDXFXGJWRAUNMWOWLKCZXFXBJWOWDX
    HWRAUIMZWLLMWOVSXCSWSWOWFWDXCKCOWRDAVBUOZSKCWOUPRUQURNWOWLWLDXIXIWFWOORZWGW
    OPRZQWOXEWIXCDEFZTFWPWOWHXCDWTXJXKXLUSWOXMAWITWOADWRXKXLUTVAUCURVPWLBCWNXAB
    CAVCWLWMUEVDVEVPWNVFVGVEVHVIVPVSBCWAWKVJAVNVSVKMAVKVLVOVM $.

  $( A natural number is even iff its square is even.  (Contributed by NM,
     20-Aug-2001.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
  nnesq $p |- ( N e. NN ->
               ( ( N / 2 ) e. NN <-> ( ( N ^ 2 ) / 2 ) e. NN ) ) $=
    ( cn wcel c2 cdiv co cz cc0 clt wbr cexp nnz zesq syl nnrp rphalfcld rpgt0d
    wa wb elnnz nnsqcl nnrpd 2thd anbi12d 3bitr4g ) ABCZADEFZGCZHUGIJZRADKFZDEF
    ZGCZHUKIJZRUGBCUKBCUFUHULUIUMUFAGCUHULSALAMNUFUIUMUFUGUFAAOPQUFUKUFUJUFUJAU
    AUBPQUCUDUGTUKTUE $.

  ${
    crrecz.1 $e |- A e. RR $.
    crrecz.2 $e |- B e. RR $.
    $( Reciprocal of a complex number in terms of real and imaginary
       components.  Remark in [Apostol] p. 361.  (Contributed by NM,
       29-Apr-2005.)  (Proof shortened by Jeff Hankins, 16-Dec-2013.) $)
    crreczi $p |- ( ( A =/= 0 \/ B =/= 0 ) -> ( 1 / ( A + ( _i x. B ) ) ) =
                    ( ( A - ( _i x. B ) ) / ( ( A ^ 2 ) + ( B ^ 2 ) ) ) ) $=
      ( cc0 wne c1 ci cmul co caddc cdiv c2 cexp wceq cneg sqcli ax-1cn wcel cc
      wo cmin recni ax-icn mulcli negsubi sqmuli oveq1i mulneg1i 3eqtri negnegi
      i2 negeqi mulid2i oveq2i 3eqtr3ri wa wn neorian cr wb sumsqeq0 necon3bbii
      subsqi mp2an bitri addcli subcli divasszi sylbi divid 3eqtr3a divclzi a1i
      mpan crne0 biimpi divmul mp3an1 syl12anc mpbird ) AEFBEFUAZGAHBIJZKJZLJAW
      CUBJZAMNJZBMNJZKJZLJZOZWDWIIJZGOZWBWDWEIJZWHLJZWHWHLJZWKGWMWHWHLWFWCMNJZP
      ZKJWFWPUBJWHWMWFWPAACUCZQZWCHBUDBDUCZUEZQUFWQWGWFKWQGWGIJZPZPXBWGWPXCWPHM
      NJZWGIJGPZWGIJXCHBUDWTUGXDXEWGIULUHGWGRBWTQZUIUJUMXBGWGRXFUEUKWGXFUNUJUOA
      WCWRXAVDUPUHWBWHEFZWNWKOWBAEOBEOUQZURXGAEBEUSXHWHEAUTSZBUTSZXHWHEOVACDABV
      BVEVCVFZWDWEWHAWCWRXAVGZAWCWRXAVHZWFWGWSXFVGZVIVJWBXGWOGOZXKWHTSXGXOXNWHV
      KVOVJVLWBWITSZWDTSZWDEFZWJWLVAZWBXGXPXKWEWHXMXNVMVJXQWBXLVNWBXRXIXJWBXRVA
      CDABVPVEVQGTSXPXQXRUQXSRGWIWDVRVSVTWA $.
  $}

  ${
    $d j k A $.  $d j k N $.
    $( Bernoulli's inequality, due to Johan Bernoulli (1667-1748).
       (Contributed by NM, 21-Feb-2005.) $)
    bernneq $p |- ( ( A e. RR /\ N e. NN0 /\ -u 1 <_ A ) ->
                 ( 1 + ( A x. N ) ) <_ ( ( 1 + A ) ^ N ) ) $=
      ( cr wcel c1 cle wbr cmul co caddc cexp wi wa wceq oveq2 oveq2d cc ax-1cn
      cc0 adantr vj vk cn0 cneg cv breq12d imbi2d recn mul01 addid1i 1le1 addcl
      syl6eq mpan exp0 syl syl5breqr eqbrtrd 1re remulcl sylan2 readdcl sylancr
      nn0re simpl syl2anc remulcld sylan anidms msqge0 jca nn0ge0 mulge0 syl2an
      reexpcl nn0cn adantl mul32d breqtrd addge01d mpbid mulcl addassd muladd11
      mulcld eqtr4d renegcli leadd2 negidi breq1i syl6bb biimpa ad2ant2r simprr
      wb mp3an13 lemul1ad letrd adddi mp3an3 mulid1 eqtrd addass mp3an1 3brtr4d
      expp1 exp43 com12 imp3a a2d nn0ind exp3a 3imp ) ACDZBUCDZEUDZAFGZEABHIZJI
      ZEAJIZBKIZFGZXOXNXQYBLXOXNXQYBXNXQMZEAUAUEZHIZJIZXTYDKIZFGZLYCEASHIZJIZXT
      SKIZFGZLYCEAUBUEZHIZJIZXTYMKIZFGZLYCEAYMEJIZHIZJIZXTYRKIZFGZLYCYBLUAUBBYD
      SNZYHYLYCUUCYFYJYGYKFUUCYEYIEJYDSAHOPYDSXTKOUFUGYDYMNZYHYQYCUUDYFYOYGYPFU
      UDYEYNEJYDYMAHOPYDYMXTKOUFUGYDYRNZYHUUBYCUUEYFYTYGUUAFUUEYEYSEJYDYRAHOPYD
      YRXTKOUFUGYDBNZYHYBYCUUFYFXSYGYAFUUFYEXREJYDBAHOPYDBXTKOUFUGXNYLXQXNAQDZY
      LAUHZUUGYJEYKFUUGYJESJIEUUGYISEJAUIPERUJUMUUGEEYKFUKUUGXTQDZYKENEQDZUUGUU
      IREAULZUNXTUOUPUQURUPTYMUCDZYCYQUUBUULXNXQYQUUBLZXNUULXQUUMLXNUULXQYQUUBX
      NUULMZXQYQMZMZYOAJIZYPXTHIZYTUUAFUUPUUQYOXTHIZUURUUNUUQCDZUUOUUNYOCDZXNUU
      TUUNECDZYNCDZUVAUSUULXNYMCDZUVCYMVDZAYMUTZVAEYNVBVCZXNUULVEYOAVBVFZTUUNUU
      SCDUUOUUNYOXTUVGXNXTCDZUULUVBXNUVIUSEAVBUNZTZVGTUUNUURCDUUOUUNYPXTXNUVIUU
      LYPCDZUVJXTYMVOVHZUVKVGTUUNUUQUUSFGUUOUUNUUQUUQYNAHIZJIZUUSFUUNSUVNFGUUQU
      VOFGUUNSAAHIZYMHIZUVNFXNUVPCDZSUVPFGZMUVDSYMFGZMSUVQFGUULXNUVRUVSXNUVRAAU
      TVIAVJVKUULUVDUVTUVEYMVLVKUVPYMVMVNUUNAAYMXNUUGUULUUHTZUWAUULYMQDZXNYMVPZ
      VQVRVSUUNUUQUVNUVHUULXNUVDUVNCDUVEXNUVDMYNAUVFXNUVDVEVGVAVTWAXNUUGUWBUVOU
      USNUULUUHUWCUUGUWBMZUVOYOAUVNJIJIZUUSUWDYOAUVNUWDUUJYNQDZYOQDRAYMWBZEYNUL
      VCUUGUWBVEZUWDYNAUWGUWHWEWCUWDUWFUUGUUSUWENUWGUWHYNAWDVFWFVNVSTUUPYOYPXTU
      UNUVAUUOUVGTUUNUVLUUOUVMTUUNUVIUUOUVKTXNXQSXTFGZUULYQXNXQUWIXNXQEXPJIZXTF
      GZUWIXPCDXNUVBXQUWKWOEUSWGUSXPAEWHWPUWJSXTFERWIWJWKWLWMUUNXQYQWNWQWRUUNYT
      UUQNZUUOXNUUGUWBUWLUULUUHUWCUWDYTEYNAJIZJIZUUQUWDYSUWMEJUWDYSYNAEHIZJIZUW
      MUUGUWBUUJYSUWPNRAYMEWSWTUWDUWOAYNJUUGUWOANUWBAXATPXBPUWDUWFUUGUUQUWNNZUW
      GUWHUUJUWFUUGUWQREYNAXCXDVFWFVNTUUNUUAUURNZUUOXNUUIUULUWRXNUUJUUGUUIRUUHU
      UKVCXTYMXFVHTXEXGXHXIXJXKXLXHXM $.
  $}

  $( Variation of Bernoulli's inequality ~ bernneq .  (Contributed by NM,
     18-Oct-2007.) $)
  bernneq2 $p |- ( ( A e. RR /\ N e. NN0 /\ 0 <_ A ) ->
               ( ( ( A - 1 ) x. N ) + 1 ) <_ ( A ^ N ) ) $=
    ( cr wcel cn0 cc0 cle wbr w3a c1 cmin co caddc cexp 3ad2ant1 wa wceq ax-1cn
    cc sylancr cmul cneg peano2rem simp2 df-neg 0re 1re lesub1 mp3an13 syl5eqbr
    biimpa 3adant2 bernneq syl3anc recnd nn0cn mulcl syl2an addcom 3adant3 recn
    wb pncan3 oveq1d 3brtr3d ) ACDZBEDZFAGHZIZJAJKLZBUALZMLZJVJMLZBNLZVKJMLZABN
    LZGVIVJCDZVGJUBZVJGHZVLVNGHVFVGVQVHAUCZOVFVGVHUDVFVHVSVGVFVHPVRFJKLZVJGJUEV
    FVHWAVJGHZFCDVFJCDVHWBVBUFUGFAJUHUIUKUJULVJBUMUNVFVGVLVOQZVHVFVGPJSDZVKSDZW
    CRVFVJSDBSDWEVGVFVJVTUOBUPVJBUQURJVKUSTUTVFVGVNVPQVHVFVMABNVFWDASDVMAQRAVAJ
    AVCTVDOVE $.

  $( A corollary of ~ bernneq .  (Contributed by Mario Carneiro,
     11-Mar-2014.) $)
  bernneq3 $p |- ( ( P e. ( ZZ>= ` 2 ) /\ N e. NN0 ) ->
                   N < ( P ^ N ) ) $=
    ( c2 cuz cfv wcel cn0 wa c1 caddc co adantl peano2re syl adantr cc0 cle wbr
    cr nn0ge0 cexp nn0re eluzelre reexpcl sylan ltp1d cn uz2m1nn nnred remulcld
    cmin cmul 1re a1i nnge1d lemulge12d leadd1dd simpr eluznn0 bernneq2 syl3anc
    2nn0 mpan letrd ltletrd ) ACDEFZBGFZHZBBIJKZABUAKZVGBSFZVFBUBLZVHVKVISFVLBM
    NZVFASFZVGVJSFCAUCZABUDUEZVHBVLUFVHVIAIUKKZBULKZIJKZVJVMVHVRSFVSSFVHVQBVHVQ
    VFVQUGFVGAUHOZUIZVLUJZVRMNVPVHBVRIVLWBISFVHUMUNVHBVQVLWAVGPBQRVFBTLVHVQVTUO
    UPUQVHVNVGPAQRZVSVJQRVFVNVGVOOVFVGURVFWCVGVFAGFZWCCGFVFWDVBACUSVCATNOABUTVA
    VDVE $.

  ${
    $d j k A $.  $d j k B $.
    $( TODO - note that min w/ ad2antlr, ad2antrl make compressed
       proof longer $)
    $( Exponentiation with a mantissa greater than 1 has no upper bound.
       (Contributed by NM, 20-Oct-2007.) $)
    expnbnd $p |- ( ( A e. RR /\ B e. RR /\ 1 < B ) ->
          E. k e. NN A < ( B ^ k ) ) $=
      ( cr wcel c1 clt wbr cexp co cn wa 1re syl adantr cle cc0 adantl syl2anc
      wb w3a cv wrex 1nn wi lttr mp3an2 exp4b com34 3imp1 wceq cc recn 3ad2ant2
      exp1 breqtrrd oveq2 breq2d rspcev sylancr cmin cdiv cfl cfv cn0 peano2rem
      caddc wne posdif mpan biimpa gt0ne0d redivcld adantll subge0 biimparc jca
      mpan2 divge0 syl2an flge0nn0 nn0p1nn cmul simplr nn0red remulcld peano2re
      peano2nn0 simprl reexpcl flltp1 ltdivmul syl112anc mpbid ltsubadd mp3an12
      0lt1 0re mpani ltle syld imp bernneq2 syl3anc exp43 com4l simp1 ltlecasei
      ltletrd a1i ) ADEZBDEZFBGHZUAZABCUBZIJZGHZCKUCZAFXNAFGHZLZFKEABFIJZGHZXRU
      DXTABYAGXKXLXMXSABGHZXKXLXSXMYCXKXLXSXMYCXKFDEZXLXSXMLYCUEMAFBUFUGUHUIUJX
      NYABUKZXSXLXKYEXMXLBULEYEBUMBUONUNOUPXQYBCFKXOFUKXPYAAGXOFBIUQURUSUTXKXLX
      MFAPHZXRYFXKXLXMXRYFXKXLXMXRYFXKLZXLXMLZLZAFVAJZBFVAJZVBJZVCVDZFVGJZKEZAB
      YNIJZGHZXRYIYMVEEZYOYIYLDEZQYLPHZYRXKYHYSYFXKYHLYJYKXKYJDEZYHAVFZOYHYKDEZ
      XKXLUUCXMBVFOZRYHYKQVHXKYHYKXLXMQYKGHZYDXLXMUUETMFBVIVJVKZVLRVMVNZYGUUAQY
      JPHZLUUCUUELYTYHYGUUAUUHXKUUAYFUUBRZXKUUHYFXKYDUUHYFTMAFVOVRVPVQYHUUCUUEU
      UDUUFVQYJYKVSVTYLWASZYMWBNYIAYKYNWCJZFVGJZYPYFXKYHWDZYIUUKDEZUULDEYIYKYNY
      HUUCYGUUDRZYIYNYIYRYNVEEZUUJYMWHNZWEZWFZUUKWGNYIXLUUPYPDEYGXLXMWIZUUQBYNW
      JSYIYJUUKGHZAUULGHZYIYLYNGHZUVAYIYSUVCUUGYLWKNYIUUAYNDEUUCUUEUVCUVATYGUUA
      YHUUIOUURUUOYHUUEYGUUFRYJYNYKWLWMWNYIXKUUNUVAUVBTZUUMUUSXKYDUUNUVDMAFUUKW
      OUGSWNYIXLUUPQBPHZUULYPPHUUTUUQYHUVEYGXLXMUVEXLXMQBGHZUVEXLQFGHZXMUVFWQQD
      EZYDXLUVGXMLUVFUEWRMQFBUFWPWSUVHXLUVFUVEUEWRQBWTVJXAXBRBYNXCXDXIXQYQCYNKX
      OYNUKXPYPAGXOYNBIUQURUSSXEXFUJXKXLXMXGYDXNMXJXH $.

    $( The reciprocal of exponentiation with a mantissa greater than 1 has no
       lower bound.  (Contributed by NM, 18-Jul-2008.) $)
    expnlbnd $p |- ( ( A e. RR+ /\ B e. RR /\ 1 < B ) ->
          E. k e. NN ( 1 / ( B ^ k ) ) < A ) $=
      ( crp wcel cr c1 clt wbr w3a cdiv co cv cexp cn wrex rpre wa cc0 adantr
      rpne0 rereccld expnbnd syl3an1 rpregt0 3ad2ant1 cn0 nnnn0 reexpcl adantlr
      wb sylan2 cz simpll nnz adantl 0lt1 0re 1re lttr mp3an12 mpani imp expgt0
      wi syl3anc jca 3adantl1 ltrec1 syl2anc rexbidva mpbid ) ADEZBFEZGBHIZJZGA
      KLZBCMZNLZHIZCOPZGVSKLAHIZCOPVMVQFEVNVOWAVMAAQAUAUBVQBCUCUDVPVTWBCOVPVROE
      ZRAFESAHIRZVSFEZSVSHIZRZVTWBUKVPWDWCVMVNWDVOAUEUFTVNVOWCWGVMVNVORZWCRZWEW
      FVNWCWEVOWCVNVRUGEWEVRUHBVRUIULUJWIVNVRUMEZSBHIZWFVNVOWCUNWCWJWHVRUOUPWHW
      KWCVNVOWKVNSGHIZVOWKUQSFEGFEVNWLVORWKVEURUSSGBUTVAVBVCTBVRVDVFVGVHAVSVIVJ
      VKVL $.

    $( The reciprocal of exponentiation with a mantissa greater than 1 has no
       lower bound.  (Contributed by NM, 18-Jul-2008.)  (Proof shortened by
       Mario Carneiro, 5-Jun-2014.) $)
    expnlbnd2 $p |- ( ( A e. RR+ /\ B e. RR /\ 1 < B ) ->
          E. j e. NN A. k e. ( ZZ>= ` j ) ( 1 / ( B ^ k ) ) < A ) $=
      ( crp wcel cr c1 clt wbr cv cexp co cdiv cn wa wi cle cc0 a1i w3a cuz cfv
      wrex wral expnlbnd simpl2 simpl3 1re ltle sylancr mpd leexp2a syl3anc 0re
      simprr cz 0lt1 lttrd nnz ad2antrl rpexpcl syl2anc eluzelz ad2antll lerecd
      elrpd mpbid rprecred simpl1 rpred lelttr mpand anassrs ralrimdva reximdva
      ) AEFZBGFZHBIJZUAZHBCKZLMZNMZAIJZCOUDHBDKZLMZNMZAIJZDWAUBUCZUEZCOUDABCUFV
      TWDWJCOVTWAOFZPWDWHDWIVTWKWEWIFZWDWHQVTWKWLPZPZWGWCRJZWDWHWNWBWFRJZWOWNVR
      HBRJZWLWPVQVRVSWMUGZWNVSWQVQVRVSWMUHZWNHGFZVRVSWQQUIWRHBUJUKULVTWKWLUPBWA
      WEUMUNWNWBWFWNBEFZWAUQFZWBEFWNBWRWNSHBSGFWNUOTWTWNUITWRSHIJWNURTWSUSVGZWK
      XBVTWLWAUTVABWAVBVCZWNXAWEUQFZWFEFXCWLXEVTWKWAWEVDVEBWEVBVCZVFVHWNWGGFWCG
      FAGFWOWDPWHQWNWFXFVIWNWBXDVIWNAVQVRVSWMVJVKWGWCAVLUNVMVNVOVPUL $.
  $}

  ${
    $d j k n A $.  $d j k n B $.
    $( Exponentiation with a mantissa greater than 1 is not bounded by any
       linear function.  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    expmulnbnd $p |- ( ( A e. RR /\ B e. RR /\ 1 < B ) ->
          E. j e. NN0 A. k e. ( ZZ>= ` j ) ( A x. k ) < ( B ^ k ) ) $=
      ( cr wcel c1 clt wbr c2 cmul co cuz cn0 cn 2re sylancr cc0 cle recnd cmin
      vn w3a cdiv cv cexp cfv wral wrex simp1 remulcl crp simp3 1re simp2 difrp
      wb mpbid rerpdivcld expnbnd syl3anc 2nn0 nnnn0 ad2antrl nn0mulcl ad2antrr
      wa cif 2nn simprl nnmulcl uztrn2 sylan nnred remulcld 0re sylancl simplrl
      nnuz resubcld nnnn0d reexpcl syl2anc nn0ge0d caddc eluzle adantl leadd2dd
      ifcl max1 2timesd breqtrrd leaddsub 2cn a1i subdid max2 lemul12bd mulcomd
      cc mul32d 3brtr4d rpred simplrr ltdivmuld posdif nnzd 0lt1 expgt0 mulgt0d
      lttrd wceq oveq2 breq1d mul01i syl5eqr ifboth simpr fveq2d eleqtrd nngt0d
      cz eluzsub ltmul1 syl112anc breqtrd peano2re ltp1d ltled bernneq2 ltletrd
      syl wne gt0ne0d eluzelz expsub syl22anc ltmuldiv mpbird lelttrd ralrimiva
      fveq2 raleqdv rspcev rexlimddv ) AEFZBEFZGBHIZUCZJAKLZBGUALZUDLZBUBUEZUFL
      ZHIZADUEZKLZBUUPUFLZHIZDCUEZMUGZUHZCNUIZUBOUUIUULEFUUGUUHUUOUBOUIUUIUUJUU
      KUUIJEFZUUFUUJEFZPUUFUUGUUHUJZJAUKZQUUIUUHUUKULFZUUFUUGUUHUMZUUIGEFZUUGUU
      HUVHUQUNUUFUUGUUHUOZGBUPQURZUSUVKUVIUULBUBUTVAUUIUUMOFZUUOVGZVGZJUUMKLZNF
      ZUUSDUVPMUGZUHZUVCUVOJNFUUMNFZUVQVBUVMUVTUUIUUOUUMVCVDJUUMVEQUVOUUSDUVRUV
      OUUPUVRFZVGZUUQJRASIZARVHZKLZUUPUUMUALZKLZUURUWBAUUPUUIUUFUVNUWAUVFVFZUWB
      UUPUVOUVPOFZUWAUUPOFUVOJOFUVMUWIVIUUIUVMUUOVJJUUMVKQGUUPUVPOVSVLVMZVNZVOU
      WBUWEUWFUWBUVDUWDEFZUWEEFZPUWBUUFREFZUWLUWHVPUWCAREWIVQZJUWDUKQZUWBUUPUUM
      UWKUWBUUMUUIUVMUUOUWAVRZVNZVTZVOZUWBUUGUUPNFUUREFZUUIUUGUVNUWAUVKVFZUWBUU
      PUWJWAZBUUPWBWCZUWBUUPAKLJUWFKLZUWDKLUUQUWGSUWBUUPUXEAUWDUWKUWBUVDUWFEFZU
      XEEFPUWSJUWFUKQUWHUWOUWBUUPUXCWDUWBUWNUUFRUWDSIVPUWHRAWJQUWBUUPJUUPKLZUVP
      UALZUXESUWBUUPUVPWELZUXGSIZUUPUXHSIZUWBUXIUUPUUPWELUXGSUWBUVPUUPUUPUWBUVD
      UUMEFUVPEFZPUWRJUUMUKQZUWKUWKUWAUVPUUPSIUVOUVPUUPWFWGWHUWBUUPUWBUUPUWKTZW
      KWLUWBUUPEFZUXLUXGEFZUXJUXKUQUWKUXMUWBUVDUXOUXPPUWKJUUPUKQUUPUVPUXGWMVAUR
      UWBJUUPUUMJWTFUWBWNWOZUXNUWBUUMUWRTZWPWLUWBUWNUUFAUWDSIVPUWHRAWQQWRUWBAUU
      PUWBAUWHTUXNWSUWBJUWDUWFUXQUWBUWDUWOTUWBUWFUWSTZXAXBUWBUWGUUKUWFKLZUUNKLZ
      UURUWTUWBUXTUUNUWBUUKUWFUWBUUKUUIUVHUVNUWAUVLVFZXCZUWSVOZUWBUUGUVTUUNEFZU
      XBUWBUUMUWQWABUUMWBWCZVOUXDUWBUWGUUKUUNKLZUWFKLZUYAHUWBUWEUYGHIZUWGUYHHIZ
      UWBUUJUYGHIZRUYGHIZUYIUWBUUOUYKUUIUVMUUOUWAXDUWBUUJUUNUUKUWBUVDUUFUVEPUWH
      UVGQUYFUYBXEURUWBUUKUUNUYCUYFUWBUUHRUUKHIZUUIUUHUVNUWAUVIVFZUWBUVJUUGUUHU
      YMUQUNUXBGBXFQURUWBUUGUUMYBFZRBHIRUUNHIZUXBUWBUUMUWQXGZUWBRGBUWNUWBVPWOZU
      VJUWBUNWOUXBRGHIUWBXHWOUYNXKZBUUMXIVAZXJUWCUYKUYLUYIARAUWDXLUUJUWEUYGHAUW
      DJKXMXNRUWDXLZRUWEUYGHVUARJRKLUWEJWNXORUWDJKXMXPXNXQWCUWBUWMUYGEFUXFRUWFH
      IUYIUYJUQUWPUWBUUKUUNUYCUYFVOUWSUWBUWFUWBUVMUWFUUMMUGFZUWFOFUWQUWBUYOUYOU
      UPUUMUUMWELZMUGZFVUBUYQUYQUWBUUPUVRVUDUVOUWAXRUWBUVPVUCMUWBUUMUXRWKXSXTUU
      MUUMUUPYCVAGUWFUUMOVSVLWCZYAUWEUYGUWFYDYEURUWBUUKUUNUWFUWBUUKUYCTUWBUUNUY
      FTUXSXAYFUWBUYAUURHIZUXTUURUUNUDLZHIZUWBUXTBUWFUFLZVUGHUWBUXTUXTGWELZVUIU
      YDUWBUXTEFZVUJEFUYDUXTYGYLUWBUUGUWFNFZVUIEFUXBUWBUWFVUEWAZBUWFWBWCUWBUXTU
      YDYHUWBUUGVULRBSIVUJVUISIUXBVUMUWBRBUYRUXBUYSYIBUWFYJVAYKUWBBWTFBRYMUUPYB
      FZUYOVUIVUGXLUWBBUXBTUWBBUYSYNUWAVUNUVOUVPUUPYOWGUYQBUUPUUMYPYQYFUWBVUKUX
      AUYEUYPVUFVUHUQUYDUXDUYFUYTUXTUURUUNYRYEYSXKYTUUAUVBUVSCUVPNUUTUVPXLUUSDU
      VAUVRUUTUVPMUUBUUCUUDWCUUE $.
  $}

  $( Two ways to express the ` K ` th digit in the decimal (when base
     ` B = 10 ` ) expansion of a number ` A ` . ` K = 1 ` corresponds to the
     first digit after the decimal point.  (Contributed by NM, 25-Dec-2008.) $)
  digit2 $p |- ( ( A e. RR /\ B e. NN /\ K e. NN )
    -> ( ( |_ ` ( ( B ^ K ) x. A ) ) mod B ) = ( ( |_ ` ( ( B ^ K ) x.
      A ) ) - ( B x. ( |_ ` ( ( B ^ ( K - 1 ) ) x. A ) ) ) ) ) $=
    ( cr wcel cn cexp co cmul cfl cfv cdiv cmin wceq wa syl2an 3ad2ant2 syl2anc
    cc 3adant1 w3a cmo c1 crp cn0 nnre nnnn0 reexpcl remulcl sylan 3impa reflcl
    3comr syl nnrp simp2 fldiv cc0 wne nncn expcl recn 3ad2ant1 nnne0 jca div23
    modval syl3anc cz nnz expm1 3expa oveq1d eqtr4d fveq2d eqtrd oveq2d ) ADEZB
    FEZCFEZUAZBCGHZAIHZJKZBUBHZWDBWDBLHJKZIHZMHZWDBBCUCMHGHZAIHZJKZIHZMHWAWDDEZ
    BUDEZWEWHNWAWCDEZWMVSVTVRWOVSVTVRWOVSVTOWBDEZVRWOVSBDECUEEZWPVTBUFCUGZBCUHP
    WBAUIUJUKUMZWCULUNVSVRWNVTBUOQWDBVGRWAWGWLWDMWAWFWKBIWAWFWCBLHZJKZWKWAWOVSW
    FXANWSVRVSVTUPWCBUQRWAWTWJJWAWTWBBLHZAIHZWJWAWBSEZASEZBSEZBURUSZOZWTXCNVSVT
    XDVRVSXFWQXDVTBUTZWRBCVAPTVRVSXEVTAVBVCVSVRXHVTVSXFXGXIBVDVEZQWBABVFVHWAWIX
    BAIVSVTWIXBNZVRVSXHCVIEZXKVTXJCVJXFXGXLXKBCVKVLPTVMVNVOVPVQVQVP $.

  $( Two ways to express the ` K ` th digit in the decimal expansion of a
     number ` A ` (when base ` B = 10 ` ). ` K = 1 ` corresponds to the first
     digit after the decimal point.  (Contributed by NM, 3-Jan-2009.) $)
  digit1 $p |- ( ( A e. RR /\ B e. NN /\ K e. NN ) -> ( ( |_ ` ( ( B ^ K ) x.
        A ) ) mod B ) = ( ( ( |_ ` ( ( B ^ K ) x. A ) ) mod ( B ^ K ) )
        - ( ( B x. ( |_ ` ( ( B ^ ( K - 1 ) ) x. A ) ) ) mod ( B ^ K ) ) ) ) $=
    ( cn wcel cr cexp co cmul cfl cfv cmo c1 cmin wceq wa cle wbr syl2an adantr
    digit2 3coml 3expa oveq1d crp cc0 clt cn0 nnre nnnn0 reexpcl remulcl reflcl
    sylan syl nnrp ad2antrr modcld nnexpcl sylan2 nnrpd modge0 syl2anc modlt cc
    nncn exp1 cuz nnge1 nnuz syl6eleq leexp2a syl3anc eqbrtrrd ltletrd syl22anc
    simpr modid simpll nnm1nn0 modmulnn expm1t expcl simpl mulcomd eqtrd oveq2d
    recn adantl mulassd fveq2d oveq12d 3brtr4d wb modsubdir mpbid 3eqtr3d 3impa
    3comr ) BDEZCDEZAFEZBCGHZAIHZJKZBLHZXEXCLHZBBCMNHZGHZAIHZJKZIHZXCLHZNHZOZWT
    XAXBXOWTXAPZXBPZXFXCLHZXEXLNHZXCLHZXFXNXQXFXSXCLWTXAXBXFXSOZXBWTXAYAABCUAUB
    UCUDXQXFFEXCUEEZUFXFQRZXFXCUGRXRXFOXQXEBXQXDFEZXEFEZXPXCFEZXBYDWTBFEZCUHEZY
    FXABUIZCUJZBCUKSZXCAULUNXDUMUOZWTBUEEZXAXBBUPUQZURZXPYBXBXPXCXAWTYHXCDEYJBC
    USUTVATZXQYEYMYCYLYNXEBVBVCXQXFBXCYOWTYGXAXBYIUQZXPYFXBYKTXQYEYMXFBUGRYLYNX
    EBVDVCXPBXCQRXBXPBMGHZBXCQWTYRBOZXAWTBVEEZYSBVFZBVGUOTXPYGMBQRZCMVHKZEYRXCQ
    RWTYGXAYITWTUUBXABVITXPCDUUCWTXAVQVJVKBMCVLVMVNTVOXFXCVRVPXQXMXGQRZXTXNOZXQ
    XLBXIIHZLHZBXJIHZJKZUUFLHZXMXGQXQWTXJFEZXIDEZUUGUUJQRWTXAXBVSXPXIFEZXBUUKWT
    YGXHUHEZUUMXAYICVTZBXHUKSXIAULUNZXPUULXBXAWTUUNUULUUOBXHUSUTTXJXIBWAVMXQXCU
    UFXLLXPXCUUFOZXBWTYTXAUUQUUAYTXAPZXCXIBIHUUFBCWBUURXIBXAYTUUNXIVEEZUUOBXHWC
    ZUTYTXAWDWEWFUNTZWGXQXEUUIXCUUFLXQXDUUHJXQXDUUFAIHUUHXQXCUUFAIUVAUDXQBXIAWT
    YTXAXBUUAUQXPUUSXBWTYTUUNUUSXAUUAUUOUUTSTXBAVEEXPAWHWIWJWFWKUVAWLWMXQYEXLFE
    ZYBUUDUUEWNYLXQYGXKFEZUVBYQXQUUKUVCUUPXJUMUOBXKULVCYPXEXLXCWOVMWPWQWRWS $.

$(
  @( Two ways to express the ` K ` th digit in the decimal expansion of a
     number ` A ` (when base ` B = 10 ` ). ` K = 1 ` corresponds to the first
     digit after the decimal point. @)
  digit3 @p |- ( ( A e. RR /\ B e. NN /\ K e. NN ) -> ( ( B ^ K ) x. ( ( A mod
 ( 1 / ( B ^ K ) ) ) - ( A mod ( 1 / ( B ^ ( K - 1 ) ) ) ) ) ) = ( ( |_ ` ( ( B
   ^ K ) x. A ) ) - ( B x. ( |_ ` ( ( B ^ ( K - 1 ) ) x. A ) ) ) ) ) @=
    ( cr wcel cn w3a cexp co cmul cfl cfv c1 cmin cdiv cmo oveq12d cc wceq
    subdi wa crp cn0 rpexpcl nnrp nnnn0 syl2anOLD rpre syl recnd 3adant1 mulcl
    nnm1nn0 rpreccl rpcn remulcl reexpcl nnre sylan2OLD 3impb reflcl
    sylancOLD cc0
    wne ax-1ne0 redivcl mp3an3 1re sylanclOLD syl3anc eqcomd eqtrd eqid a1i
    nnncan1 recn 3ad2ant1 modval ax-1cn pm3.2i divdiv2 mp3an2 expcl sylanOLD
    expne0i 3expa rpcnne0 jca fveq2d oveq2d adantlr div1 ) ADEZBFEZCFEZGZBCHIZ
    AJIKLBBCMNIZHIZAJIKLJINIZWQAMWQOIZPIZAMWSOIZPIZNIZJIZWPWTWQXCAWSJIZKLZJIZXA
    AWQJIZMOIZKLZJIZNIZJIZXFWPWTWQXIJIWQXMJINIZXO????????QWPXOXPWQREZXIREZXMREZ
    XOXPSWPWQXIXMT??????WNWOUAZWQUBEZWQDEZBUBEZCUCEZYAWNWOBCUDBUEZCUFZUGZWQUHUI
    ZUJUKXCREZXHREXRWPXCXHULWNWOYIWMXTXCUBEZYIXTWSUBEZYJYCWRUCEZYKWNWOBWRUDYECU
    MZUGWSUNUIZXCUOUIUKWPXHWPXGDEZXHDEWMWNWOYOWMWSDEZYOXTAWSUPBDEYLYPWNWOBWRUQB
    URYMUGZUSUTXGVAUIUJVBZWPXMXADEZXLDEZXMDEWPXAXLUPWNWOYSWMXTXAUBEZYSXTYAUUAYG
    WQUNUIZXAUHUIUKWPXKDEZYTXJDEZMDEZUUCWPUUDUUEMVCVDZUUCVEXJMVFVGWMWNWOUUDWMYB
    UUDXTAWQUPYHUSUTVHVIXKVAUIVBUJZVJVKVLWPWQWQXNXEJWQWQSWPWQVMVNWPXNAXMNIZAXIN
    IZNIZXEWPUUJXNAREZXSXRUUJXNSWPAXMXIVOWMWNUUKWOAVPZVQUUGYRVJVKWPXEUUJWMWNWOX
    EUUJSWMXTUAZXBUUHXDUUINUUMXBAXAAXAOIZKLZJIZNIZUUHWMUUAXBUUQSXTAXAVRUUBUSUUM
    UUPXMANUUMUUOXLXAJUUMUUNXKKUUKXQWQVCVDZUAZUUNXKSZWMXTUUKMREZUUFUAZUUSUUTUVA
    UUFVSVEVTZAMWQWAWBUULYCYDUUSWNWOYCYDUAXQUURBREZYDXQYCBCWCBUOWDUVDBVCVDZUAZY
    DUURYCUVDUVEYDUURBCWEWFBWGZWDWHYEYFUGUGWIWJWJVLUUMXDAXCAXCOIZKLZJIZNIZUUIWM
    YJXDUVKSXTAXCVRYNUSUUMUVJXIANUUMUVIXHXCJUUMUVHXGKUUMUVHXGMOIZXGUUKWSREZWSVC
    VDZUAZUVHUVLSZWMXTUUKUVBUVOUVPUVCAMWSWAWBUULUVFYLUVOWNWOUVFYLUAUVMUVNUVDYLU
    VMUVEBWRWCWKUVDUVEYLUVNBWRWEWFWHWNYCUVFYEUVGUIYMUGUGUUMXGREZUVLXGSUUKUVMUVQ
    WMXTAWSULUULXTWSYQUJUGXGWLUIVLWIWJWJVLQUTVKVLQVLVK @.
    @( [ ?] @) @( [27-Dec-2008] @)
$)
  ${
    $d k x A $.  $d k x B $.  $d k x D $.  $d x C $.
    $( Exponentiation property of the modulo operation.  (Contributed by Mario
       Carneiro, 28-Feb-2014.) $)
    modexp $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. NN0 /\ D e. RR+ )
         /\ ( A mod D ) = ( B mod D ) )
         -> ( ( A ^ C ) mod D ) = ( ( B ^ C ) mod D ) ) $=
      ( vx cz wcel cmo co wceq w3a cexp wi cc0 c1 oveq1d eqeq12d imbi2d syl2anc
      oveq2 vk wa cn0 crp simp2l id 3adant2l caddc zcn exp0 syl eqcomd sylan9eq
      cv cc 3ad2ant1 simp21l simp1 zexpcl simp21r simp22 simp3 simp23 modmul12d
      cmul zcnd expp1 3eqtr4d 3exp a2d nn0ind sylc ) AFGZBFGZUBZCUCGZDUDGZUBADH
      IBDHIJZKVPVOVQVRKZACLIZDHIZBCLIZDHIZJZVOVPVQVRUEVOVQVRVSVPVSUFUGVSAEUNZLI
      ZDHIZBWELIZDHIZJZMVSANLIZDHIZBNLIZDHIZJZMVSAUAUNZLIZDHIZBWPLIZDHIZJZMVSAW
      POUHIZLIZDHIZBXBLIZDHIZJZMVSWDMEUACWENJZWJWOVSXHWGWLWIWNXHWFWKDHWENALTPXH
      WHWMDHWENBLTPQRWEWPJZWJXAVSXIWGWRWIWTXIWFWQDHWEWPALTPXIWHWSDHWEWPBLTPQRWE
      XBJZWJXGVSXJWGXDWIXFXJWFXCDHWEXBALTPXJWHXEDHWEXBBLTPQRWECJZWJWDVSXKWGWAWI
      WCXKWFVTDHWECALTPXKWHWBDHWECBLTPQRVOVQWOVRVOWKWMDHVMVNWKOWMVMAUOGZWKOJAUI
      AUJUKVNWMOVNBUOGZWMOJBUIBUJUKULUMPUPWPUCGZVSXAXGXNVSXAXGXNVSXAKZWQAVEIZDH
      IWSBVEIZDHIXDXFXOWQWSABDXOVMXNWQFGVMVNVQVRXNXAUQZXNVSXAURZAWPUSSXOVNXNWSF
      GVMVNVQVRXNXAUTZXSBWPUSSXRXTXNVOVQVRXAVAXNVSXAVBXNVOVQVRXAVCVDXOXCXPDHXOX
      LXNXCXPJXOAXRVFXSAWPVGSPXOXEXQDHXOXMXNXEXQJXOBXTVFXSBWPVGSPVHVIVJVKVL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x X $.  $d x ph $.
    discr.1 $e |- ( ph -> A e. RR ) $.
    discr.2 $e |- ( ph -> B e. RR ) $.
    discr.3 $e |- ( ph -> C e. RR ) $.
    discr.4 $e |- ( ( ph /\ x e. RR ) ->
                    0 <_ ( ( ( A x. ( x ^ 2 ) ) + ( B x. x ) ) + C ) ) $.
    ${
      discr1.5 $e |- X =
        if ( 1 <_ ( ( ( B + if ( 0 <_ C , C , 0 ) ) + 1 ) / -u A ) ,
             ( ( ( B + if ( 0 <_ C , C , 0 ) ) + 1 ) / -u A ) , 1 ) $.
      $( A nonnegative quadratic form has nonnegative leading coefficient.
         (Contributed by Mario Carneiro, 4-Jun-2014.) $)
      discr1 $p |- ( ph -> 0 <_ A ) $=
        ( cc0 cle wbr co cmul caddc cr wcel c1 clt c2 cexp wa cv wral cneg cdiv
        cif adantr 0re ifcl sylancl readdcld peano2re renegcld lt0neg1d gt0ne0d
        syl biimpa redivcld syl5eqel ralrimiva wceq oveq1 oveq2d oveq12d oveq1d
        1re oveq2 breq2d rspcv sylc resqcl remulcld max2 sylancr max1 syl6breqr
        wn a1i lemulge11d letrd leadd2dd recnd adddird addassd mulassd cc sqval
        eqtr4d eqtrd 3eqtr3d breqtrrd ltp1d wb ledivmul syl112anc mpbid ltletrd
        cmin df-neg syl6eq breqtrd ltaddsub2d mpbird 0lt1 ltmul1 mul02d lelttrd
        mulneg1d ltnle pm2.65da wo lelttric ord mt3d ) ALCMNZCLUANZAXSLCFUBUCOZ
        POZDFPOZQOZEQOZMNZAXSUDZFRSZLCBUEZUBUCOZPOZDYHPOZQOZEQOZMNZBRUFZYEYFFTD
        LEMNZELUIZQOZTQOZCUGZUHOZMNZUUATUIZRKYFUUARSZTRSZUUCRSYFYSYTYFYRRSYSRSZ
        YFDYQADRSXSHUJZYFERSZLRSZYQRSAUUHXSIUJZUKYPELRULUMZUNZYRUOUSZYFCACRSZXS
        GUJZUPZYFYTAXSLYTUANZACGUQUTZURVAZVIUUBUUATRULUMVBZAYOXSAYNBRJVCUJYNYEB
        FRYHFVDZYMYDLMUVAYLYCEQUVAYJYAYKYBQUVAYIXTCPYHFUBUCVEVFYHFDPVJVGVHVKVLV
        MYFYDLUANZYEVTZYFYDCFPOZYRQOZFPOZLYFYCEYFYAYBYFCXTUUOYFYGXTRSUUTFVNUSVO
        YFDFUUGUUTVOUNZUUJUNZYFUVEFYFUVDYRYFCFUUOUUTVOZUULUNZUUTVOUUIYFUKWAZYFY
        DYCYQFPOZQOZUVFMYFEUVLYCUUJYFYQFUUKUUTVOZUVGYFEYQUVLUUJUUKUVNYFUUIUUHEY
        QMNUKUUJLEVPVQYFYQFUUKUUTYFUUIUUHLYQMNUKUUJLEVRVQYFTUUCFMYFUUEUUDTUUCMN
        VIUUSTUUAVRVQKVSZWBWCWDYFUVDDQOZYQQOZFPOUVPFPOZUVLQOUVFUVMYFUVPYQFYFUVP
        YFUVDDUVIUUGUNWEYFYQUUKWEZYFFUUTWEZWFYFUVQUVEFPYFUVDDYQYFUVDUVIWEZYFDUU
        GWEZUVSWGVHYFUVRYCUVLQYFUVRUVDFPOZYBQOYCYFUVDDFUWAUWBUVTWFYFUWCYAYBQYFU
        WCCFFPOZPOYAYFCFFYFCUUOWEZUVTUVTWHYFXTUWDCPYFFWISXTUWDVDUVTFWJUSVFWKVHW
        LVHWMWNYFUVFLFPOZLUAYFUVELUANZUVFUWFUANZYFUWGYRLUVDXAOZUANYFYRYTFPOZUWI
        UAYFYRYSUWJUULUUMYFYTFUUPUUTVOYFYRUULWOYFUUAFMNZYSUWJMNZYFUUAUUCFMYFUUE
        UUDUUAUUCMNVIUUSTUUAVPVQKVSYFUUFYGYTRSUUQUWKUWLWPUUMUUTUUPUURYSFYTWQWRW
        SWTYFUWJUVDUGUWIYFCFUWEUVTXKUVDXBXCXDYFUVDYRLUVIUULUVKXEXFYFUVERSUUIYGL
        FUANUWGUWHWPUVJUVKUUTYFLTFUVKUUEYFVIWAUUTLTUANYFXGWAUVOWTUVELFXHWRWSYFF
        UVTXIXDXJYFYDRSUUIUVBUVCWPUVHUKYDLXLUMWSXMAXRXSAUUIUUNXRXSXNUKGLCXOVQXP
        XQ $.
    $}

    $( If a quadratic polynomial with real coefficients is nonnegative for all
       values, then its discriminant is non-positive.  (Contributed by NM,
       10-Aug-1999.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
    discr $p |- ( ph -> ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) <_ 0 ) $=
      ( cc0 wbr c2 co c4 cmul cle cdiv cr wcel caddc cexp cmin wa adantr resqcl
      clt wceq syl recnd 4re remulcld remulcl sylancr 4pos elrpii simpr rpmulcl
      crp elrpd rpcnd rpne0d divsubdird cc 4cn gt0ne0ii divcan5d divcan3d eqtrd
      a1i wne oveq2d rerpdivcld 2timesd oveq1i 2cn mulassd syl5eqr divassd 2ne0
      2t2e4 2rp 3eqtr3d eqtr3d cneg wral renegcld ralrimiva oveq1 oveq2 oveq12d
      oveq1d breq2d rspcv sylc sqneg sqdiv syl3anc mul32d syl6eq 3eqtr2d 3eqtrd
      cv sqval divdiv1d eqtr4d divcan2d mulneg2d negeqd negsubd addsubd breqtrd
      readdcld subge0d mpbid eqbrtrd leadd2d mpbird suble0d resubcld 0re mul01d
      ledivmuld wn c1 peano2re ltnegd df-neg syl6breq ltaddsubd simprr redivcld
      ltp1d expr simprl sqcl mul02d addid2d wb lenlt cif nne sylib sq0id mul01i
      pm2.65d 0cn subidi 0le0 eqbrtri syl6eqbr wo eqid discr1 leloe mpjaodan )
      AJCUFKZDLUAMZNCEOMZOMZUBMZJPKJCUGZAUUPUCZUUTNCOMZJOMZJPUVBUUTUVCQMZJPKUUT
      UVDPKUVBUVEUUQUVCQMZEUBMZJPUVBUVEUVFUUSUVCQMZUBMUVGUVBUUQUUSUVCUVBUUQUVBD
      RSZUUQRSAUVIUUPGUDZDUEUHZUIZUVBUUSUVBNRSUURRSUUSRSUJUVBCEACRSZUUPFUDZAERS
      ZUUPHUDZUKZNUURULUMZUIUVBUVCUVBNURSCURSZUVCURSNUJUNUOUVBCUVNAUUPUPUSZNCUQ
      UMZUTZUVBUVCUWAVAZVBUVBUVHEUVFUBUVBUVHUURCQMEUVBUURCNUVBUURUVQUIUVBCUVNUI
      ZNVCSUVBVDVIUVBCUVTVAZNJVJUVBNUJUNVEVIVFUVBECUVBEUVPUIZUWDUWEVGVHVKVHUVBU
      VGJPKUVFEPKZUVBUWGUVFUVFTMZUVFETMZPKUVBUWHUUQLCOMZQMZUWIPUVBLUVFOMZUWHUWK
      UVBUVFUVBUVFUVBUUQUVCUVKUWAVLZUIZVMUVBLUUQOMZUVCQMUWOLUWJOMZQMUWLUWKUVBUV
      CUWPUWOQUVBUVCLLOMZCOMZUWPUWQNCOVTVNZUVBLLCLVCSUVBVOVIZUWTUWDVPVQVKUVBLUU
      QUVCUWTUVLUWBUWCVRUVBUUQUWJLUVLUVBUWJUVBLURSUVSUWJURSWAUVTLCUQUMZUTZUWTUV
      BUWJUXAVAZLJVJUVBVSVIVFWBWCUVBJUWIUWKUBMZPKUWKUWIPKUVBJCDUWJQMZWDZLUAMZOM
      ZDUXFOMZTMZETMZUXDPUVBUXFRSJCBXBZLUAMZOMZDUXLOMZTMZETMZPKZBRWEZJUXKPKZUVB
      UXEUVBDUWJUVJUXAVLZWFAUXSUUPAUXRBRIWGZUDUXRUXTBUXFRUXLUXFUGZUXQUXKJPUYCUX
      PUXJETUYCUXNUXHUXOUXITUYCUXMUXGCOUXLUXFLUAWHVKUXLUXFDOWIWJWKWLWMWNUVBUXKU
      VFUWKUBMZETMUXDUVBUXJUYDETUVBUXJUVFUWKWDZTMUYDUVBUXHUVFUXIUYETUVBUXHCUVFC
      QMZOMUVFUVBUXGUYFCOUVBUXGUUQUVCCOMZQMZUYFUVBUXGUXELUAMZUUQUWJLUAMZQMZUYHU
      VBUXEVCSUXGUYIUGUVBUXEUYAUIZUXEWOUHUVBDVCSZUWJVCSZUWJJVJUYIUYKUGUVBDUVJUI
      ZUXBUXCDUWJWPWQUVBUYJUYGUUQQUVBUYJUWJUWJOMZUWJLOMZCOMUYGUVBUYNUYJUYPUGUXB
      UWJXCUHUVBUWJLCUXBUWTUWDVPUVBUYQUVCCOUVBUYQUWRUVCUVBLCLUWTUWDUWTWRUWSWSWK
      WTVKXAUVBUUQUVCCUVLUWBUWDUWCUWEXDXEVKUVBUVFCUWNUWDUWEXFVHUVBUXIDUXEOMZWDU
      YEUVBDUXEUYOUYLXGUVBUWKUYRUVBUWKDDOMZUWJQMUYRUVBUUQUYSUWJQUVBUYMUUQUYSUGU
      YODXCUHWKUVBDDUWJUYOUYOUXBUXCVRVHXHXEWJUVBUVFUWKUWNUVBUWKUVBUUQUWJUVKUXAV
      LZUIZXIVHWKUVBUVFEUWKUWNUWFVUAXJXEXKUVBUWIUWKUVBUVFEUWMUVPXLUYTXMXNXOUVBU
      VFEUVFUWMUVPUWMXPXQUVBUVFEUWMUVPXRXQXOUVBUUTJUVCUVBUUQUUSUVKUVRXSJRSZUVBX
      TVIUWAYBXNUVBUVCUWBYAXKAUVAUCZUUTJJUBMZJPVUCUUQJUUSJUBVUCDVUCDJVJZYCDJUGV
      UCVUEEYDTMZWDZETMZJUFKZAUVAVUEVUIAUVAVUEUCZUCZVUIVUGJEUBMZUFKVUKVUGEWDZVU
      LUFVUKEVUFUFKVUGVUMUFKVUKEAUVOVUJHUDZYLVUKEVUFVUNVUKUVOVUFRSVUNEYEUHZYFXN
      EYGYHVUKVUGEJVUKVUFVUOWFZVUNVUBVUKXTVIYIXQYMAUVAVUEVUIYCZVUKJVUHPKZVUQVUK
      JCVUGDQMZLUAMZOMZDVUSOMZTMZETMZVUHPVUKVUSRSUXSJVVDPKZVUKVUGDVUPAUVIVUJGUD
      ZAUVAVUEYJZYKZAUXSVUJUYBUDUXRVVEBVUSRUXLVUSUGZUXQVVDJPVVIUXPVVCETVVIUXNVV
      AUXOVVBTVVIUXMVUTCOUXLVUSLUAWHVKUXLVUSDOWIWJWKWLWMWNVUKVVCVUGETVUKVVCJVUG
      TMVUGVUKVVAJVVBVUGTVUKJVUTOMVVAJVUKJCVUTOAUVAVUEYNWKVUKVUTVUKVUSVCSVUTVCS
      VUKVUSVVHUIVUSYOUHYPWCVUKVUGDVUKVUGVUPUIZVUKDVVFUIVVGXFWJVUKVUGVVJYQVHWKX
      KVUKVUBVUHRSVURVUQYRXTVUKVUGEVUPVUNXLJVUHYSUMXNYMUUEDJUUAUUBUUCVUCUUSNJOM
      JVUCUURJNOVUCJEOMUURJVUCJCEOAUVAUPWKVUCEAEVCSUVAAEHUIUDYPWCVKNVDUUDWSWJVU
      DJJPJUUFUUGUUHUUIUUJAJCPKZUUPUVAUUKZABCDEYDDJEPKEJYTTMYDTMCWDQMZPKVVMYDYT
      ZFGHIVVNUULUUMAVUBUVMVVKVVLYRXTFJCUUNUMXNUUO $.
  $}

  ${
    expcld.1 $e |- ( ph -> A e. CC ) $.
    $( Value of a complex number raised to the 0th power.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    exp0d $p |- ( ph -> ( A ^ 0 ) = 1 ) $=
      ( cc wcel cc0 cexp co c1 wceq exp0 syl ) ABDEBFGHIJCBKL $.

    $( Value of a complex number raised to the first power.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    exp1d $p |- ( ph -> ( A ^ 1 ) = A ) $=
      ( cc wcel c1 cexp co wceq exp1 syl ) ABDEBFGHBICBJK $.

    ${
      expeq0d.2 $e |- ( ph -> N e. NN ) $.
      expeq0d.3 $e |- ( ph -> ( A ^ N ) = 0 ) $.
      $( Natural number exponentiation is 0 iff its mantissa is 0.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      expeq0d $p |- ( ph -> A = 0 ) $=
        ( cexp co cc0 wceq cc wcel cn wb expeq0 syl2anc mpbid ) ABCGHIJZBIJZFAB
        KLCMLRSNDEBCOPQ $.
    $}

    $( Value of square.  Inference version.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    sqvald $p |- ( ph -> ( A ^ 2 ) = ( A x. A ) ) $=
      ( cc wcel c2 cexp co cmul wceq sqval syl ) ABDEBFGHBBIHJCBKL $.

    $( Closure of square.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    sqcld $p |- ( ph -> ( A ^ 2 ) e. CC ) $=
      ( cc wcel c2 cexp co sqcl syl ) ABDEBFGHDECBIJ $.

    ${
      sqeq0d.1 $e |- ( ph -> ( A ^ 2 ) = 0 ) $.
      $( A number is zero iff its square is zero.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      sqeq0d $p |- ( ph -> A = 0 ) $=
        ( c2 cn wcel 2nn a1i expeq0d ) ABECEFGAHIDJ $.
    $}

    ${
      expcld.2 $e |- ( ph -> N e. NN0 ) $.
      $( Closure law for nonnegative integer exponentiation.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      expcld $p |- ( ph -> ( A ^ N ) e. CC ) $=
        ( cc wcel cn0 cexp co expcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.

      $( Value of a complex number raised to a nonnegative integer power plus
         one.  Part of Definition 10-4.1 of [Gleason] p. 134.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      expp1d $p |- ( ph -> ( A ^ ( N + 1 ) ) = ( ( A ^ N ) x. A ) ) $=
        ( cc wcel cn0 c1 caddc co cexp cmul wceq expp1 syl2anc ) ABFGCHGBCIJKLK
        BCLKBMKNDEBCOP $.

      expaddd.2 $e |- ( ph -> M e. NN0 ) $.
      $( Sum of exponents law for nonnegative integer exponentiation.
         Proposition 10-4.2(a) of [Gleason] p. 135.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      expaddd $p |- ( ph -> ( A ^ ( M + N ) ) = ( ( A ^ M ) x. ( A ^ N ) ) ) $=
        ( cc wcel cn0 caddc co cexp cmul wceq expadd syl3anc ) ABHICJIDJIBCDKLM
        LBCMLBDMLNLOEGFBCDPQ $.

      $( Product of exponents law for natural number exponentiation.
         Proposition 10-4.2(b) of [Gleason] p. 135, restricted to nonnegative
         integer exponents.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      expmuld $p |- ( ph -> ( A ^ ( M x. N ) ) = ( ( A ^ M ) ^ N ) ) $=
        ( cc wcel cn0 cmul co cexp wceq expmul syl3anc ) ABHICJIDJIBCDKLMLBCMLD
        MLNEGFBCDOP $.
    $}

    ${
      sqrecd.1 $e |- ( ph -> A =/= 0 ) $.
      $( Square of reciprocal.  (Contributed by Mario Carneiro,
         28-May-2016.) $)
      sqrecd $p |- ( ph -> ( ( 1 / A ) ^ 2 ) = ( 1 / ( A ^ 2 ) ) ) $=
        ( cc wcel cc0 wne c2 cz c1 cdiv co cexp wceq 2z a1i exprec syl3anc ) AB
        EFBGHIJFZKBLMINMKBINMLMOCDTAPQBIRS $.

      expclzd.3 $e |- ( ph -> N e. ZZ ) $.
      $( Closure law for integer exponentiation.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      expclzd $p |- ( ph -> ( A ^ N ) e. CC ) $=
        ( cc wcel cc0 wne cz cexp co expclz syl3anc ) ABGHBIJCKHBCLMGHDEFBCNO
        $.

      $( Nonnegative integer exponentiation is nonzero if its mantissa is
         nonzero.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      expne0d $p |- ( ph -> ( A ^ N ) =/= 0 ) $=
        ( cc wcel cc0 wne cz cexp co expne0i syl3anc ) ABGHBIJCKHBCLMIJDEFBCNO
        $.

      $( Value of a complex number raised to a negative power.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      expnegd $p |- ( ph -> ( A ^ -u N ) = ( 1 / ( A ^ N ) ) ) $=
        ( cc wcel cc0 wne cz cneg cexp co c1 cdiv wceq expnegz syl3anc ) ABGHBI
        JCKHBCLMNOBCMNPNQDEFBCRS $.

      $( Nonnegative integer exponentiation of a reciprocal.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      exprecd $p |- ( ph -> ( ( 1 / A ) ^ N ) = ( 1 / ( A ^ N ) ) ) $=
        ( cc wcel cc0 wne cz c1 cdiv co cexp wceq exprec syl3anc ) ABGHBIJCKHLB
        MNCONLBCONMNPDEFBCQR $.

      $( Value of a nonzero complex number raised to an integer power plus
         one.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      expp1zd $p |- ( ph -> ( A ^ ( N + 1 ) ) = ( ( A ^ N ) x. A ) ) $=
        ( cc wcel cc0 wne cz c1 caddc co cexp cmul wceq expp1z syl3anc ) ABGHBI
        JCKHBCLMNONBCONBPNQDEFBCRS $.

      $( Value of a complex number raised to an integer power minus one.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      expm1d $p |- ( ph -> ( A ^ ( N - 1 ) ) = ( ( A ^ N ) / A ) ) $=
        ( cc wcel cc0 wne cz c1 cmin co cexp cdiv wceq expm1 syl3anc ) ABGHBIJC
        KHBCLMNONBCONBPNQDEFBCRS $.

      expsubd.3 $e |- ( ph -> M e. ZZ ) $.
      $( Exponent subtraction law for nonnegative integer exponentiation.
         (Contributed by Mario Carneiro, 28-May-2016.) $)
      expsubd $p |- ( ph -> ( A ^ ( M - N ) ) = ( ( A ^ M ) / ( A ^ N ) ) ) $=
        ( cc wcel cc0 wne cz cmin co cexp cdiv wceq expsub syl22anc ) ABIJBKLCM
        JDMJBCDNOPOBCPOBDPOQOREFHGBCDST $.
    $}

    mulexpd.2 $e |- ( ph -> B e. CC ) $.
    $( Distribution of square over multiplication.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    sqmuld $p |- ( ph -> ( ( A x. B ) ^ 2 ) = ( ( A ^ 2 ) x. ( B ^ 2 ) ) ) $=
      ( cc wcel cmul co c2 cexp wceq sqmul syl2anc ) ABFGCFGBCHIJKIBJKICJKIHILD
      EBCMN $.

    ${
      sqdivd.3 $e |- ( ph -> B =/= 0 ) $.
      $( Distribution of square over division.  (Contributed by Mario Carneiro,
         28-May-2016.) $)
      sqdivd $p |- ( ph -> ( ( A / B ) ^ 2 ) = ( ( A ^ 2 ) / ( B ^ 2 ) ) ) $=
        ( cc wcel cc0 wne cdiv co c2 cexp wceq sqdiv syl3anc ) ABGHCGHCIJBCKLMN
        LBMNLCMNLKLODEFBCPQ $.

      expdivd.3 $e |- ( ph -> N e. NN0 ) $.
      $( Nonnegative integer exponentiation of a quotient.  (Contributed by
         Mario Carneiro, 28-May-2016.) $)
      expdivd $p |- ( ph -> ( ( A / B ) ^ N ) = ( ( A ^ N ) / ( B ^ N ) ) ) $=
        ( cc wcel cc0 wne cn0 cdiv co cexp wceq expdiv syl121anc ) ABIJCIJCKLDM
        JBCNODPOBDPOCDPONOQEFGHBCDRS $.
    $}

    mulexpd.3 $e |- ( ph -> N e. NN0 ) $.
    $( Natural number exponentiation of a product.  Proposition 10-4.2(c) of
       [Gleason] p. 135, restricted to nonnegative integer exponents.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    mulexpd $p |- ( ph -> ( ( A x. B ) ^ N ) = ( ( A ^ N ) x. ( B ^ N ) ) ) $=
      ( cc wcel cn0 cmul co cexp wceq mulexp syl3anc ) ABHICHIDJIBCKLDMLBDMLCDM
      LKLNEFGBCDOP $.
  $}

  ${
    0exp.1 $e |- ( ph -> N e. NN ) $.
    $( Value of zero raised to a natural number power.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    0expd $p |- ( ph -> ( 0 ^ N ) = 0 ) $=
      ( cn wcel cc0 cexp co wceq 0exp syl ) ABDEFBGHFICBJK $.
  $}

  ${
    reexpcld.1 $e |- ( ph -> A e. RR ) $.
    reexpcld.2 $e |- ( ph -> N e. NN0 ) $.
    $( Closure of exponentiation of reals.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    reexpcld $p |- ( ph -> ( A ^ N ) e. RR ) $=
      ( cr wcel cn0 cexp co reexpcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.

    ${
      expge0d.3 $e |- ( ph -> 0 <_ A ) $.
      $( Nonnegative integer exponentiation with a nonnegative mantissa is
         nonnegative.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      expge0d $p |- ( ph -> 0 <_ ( A ^ N ) ) $=
        ( cr wcel cn0 cc0 cle wbr cexp co expge0 syl3anc ) ABGHCIHJBKLJBCMNKLDE
        FBCOP $.
    $}

    ${
      expge1d.3 $e |- ( ph -> 1 <_ A ) $.
      $( Nonnegative integer exponentiation with a nonnegative mantissa is
         nonnegative.  (Contributed by Mario Carneiro, 28-May-2016.) $)
      expge1d $p |- ( ph -> 1 <_ ( A ^ N ) ) $=
        ( cr wcel cn0 c1 cle wbr cexp co expge1 syl3anc ) ABGHCIHJBKLJBCMNKLDEF
        BCOP $.
    $}
  $}

  ${
    nnexpcld.1 $e |- ( ph -> A e. NN ) $.
    $( The naturals are closed under squaring.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    nnsqcld $p |- ( ph -> ( A ^ 2 ) e. NN ) $=
      ( cn wcel c2 cexp co nnsqcl syl ) ABDEBFGHDECBIJ $.

    nnexpcld.2 $e |- ( ph -> N e. NN0 ) $.
    $( Closure of exponentiation of nonnegative integers.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    nnexpcld $p |- ( ph -> ( A ^ N ) e. NN ) $=
      ( cn wcel cn0 cexp co nnexpcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.
  $}

  ${
    nn0expcld.1 $e |- ( ph -> A e. NN0 ) $.
    nn0expcld.2 $e |- ( ph -> N e. NN0 ) $.
    $( Closure of exponentiation of nonnegative integers.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    nn0expcld $p |- ( ph -> ( A ^ N ) e. NN0 ) $=
      ( cn0 wcel cexp co nn0expcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.
  $}

  ${
    rpexpcld.1 $e |- ( ph -> A e. RR+ ) $.
    rpexpcld.2 $e |- ( ph -> N e. ZZ ) $.
    $( Closure law for exponentiation of positive reals.  (Contributed by Mario
       Carneiro, 28-May-2016.) $)
    rpexpcld $p |- ( ph -> ( A ^ N ) e. RR+ ) $=
      ( crp wcel cz cexp co rpexpcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.

    ltexp2rd.3 $e |- ( ph -> M e. ZZ ) $.
    ltexp2rd.4 $e |- ( ph -> A < 1 ) $.
    $( The power of a positive number smaller than 1 decreases as its exponent
       increases.  (Contributed by Mario Carneiro, 28-May-2016.) $)
    ltexp2rd $p |- ( ph -> ( M < N <-> ( A ^ N ) < ( A ^ M ) ) ) $=
      ( crp wcel cz c1 clt wbr cexp co wb ltexp2r syl31anc ) ABIJCKJDKJBLMNCDMN
      BDOPBCOPMNQEGFHBCDRS $.
  $}

  ${
    rpexpclzd.1 $e |- ( ph -> A e. RR ) $.
    rpexpclzd.2 $e |- ( ph -> A =/= 0 ) $.
    rpexpclzd.3 $e |- ( ph -> N e. ZZ ) $.
    $( Closure of exponentiation of reals.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    reexpclzd $p |- ( ph -> ( A ^ N ) e. RR ) $=
      ( cr wcel cc0 wne cz cexp co reexpclz syl3anc ) ABGHBIJCKHBCLMGHDEFBCNO
      $.
  $}

  ${
    resqcld.1 $e |- ( ph -> A e. RR ) $.
    $( Closure of square in reals.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    resqcld $p |- ( ph -> ( A ^ 2 ) e. RR ) $=
      ( cr wcel c2 cexp co resqcl syl ) ABDEBFGHDECBIJ $.

    $( A square of a real is nonnegative.  (Contributed by Mario Carneiro,
       28-May-2016.) $)
    sqge0d $p |- ( ph -> 0 <_ ( A ^ 2 ) ) $=
      ( cr wcel cc0 c2 cexp co cle wbr sqge0 syl ) ABDEFBGHIJKCBLM $.

    ${
      sqgt0d.2 $e |- ( ph -> A =/= 0 ) $.
      $( The square of a nonzero real is positive.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      sqgt0d $p |- ( ph -> 0 < ( A ^ 2 ) ) $=
        ( cr wcel cc0 wne c2 cexp co clt wbr sqgt0 syl2anc ) ABEFBGHGBIJKLMCDBN
        O $.
    $}

    ${
      ltexp2d.2 $e |- ( ph -> M e. ZZ ) $.
      ltexp2d.3 $e |- ( ph -> N e. ZZ ) $.
      ltexp2d.4 $e |- ( ph -> 1 < A ) $.
      $( Ordering relationship for exponentiation.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      ltexp2d $p |- ( ph -> ( M < N <-> ( A ^ M ) < ( A ^ N ) ) ) $=
        ( cr wcel cz c1 clt wbr cexp co wb ltexp2 syl31anc ) ABIJCKJDKJLBMNCDMN
        BCOPBDOPMNQEFGHBCDRS $.

      $( Ordering law for exponentiation.  (Contributed by Mario Carneiro,
         28-May-2016.) $)
      leexp2d $p |- ( ph -> ( M <_ N <-> ( A ^ M ) <_ ( A ^ N ) ) ) $=
        ( cr wcel cz c1 clt wbr cle cexp co wb leexp2 syl31anc ) ABIJCKJDKJLBMN
        CDONBCPQBDPQONREFGHBCDST $.

      expcand.5 $e |- ( ph -> ( A ^ M ) = ( A ^ N ) ) $.
      $( Ordering relationship for exponentiation.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      expcand $p |- ( ph -> M = N ) $=
        ( cexp co wceq cr wcel cz c1 clt wbr wb expcan syl31anc mpbid ) ABCJKBD
        JKLZCDLZIABMNCONDONPBQRUCUDSEFGHBCDTUAUB $.
    $}

    ${
      leexp2ad.2 $e |- ( ph -> 1 <_ A ) $.
      leexp2ad.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      $( Ordering relationship for exponentiation.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      leexp2ad $p |- ( ph -> ( A ^ M ) <_ ( A ^ N ) ) $=
        ( cr wcel c1 cle wbr cuz cfv cexp co leexp2a syl3anc ) ABHIJBKLDCMNIBCO
        PBDOPKLEFGBCDQR $.
    $}

    ${
      leexp2rd.2 $e |- ( ph -> M e. NN0 ) $.
      leexp2rd.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      leexp2rd.4 $e |- ( ph -> 0 <_ A ) $.
      leexp2rd.5 $e |- ( ph -> A <_ 1 ) $.
      $( Ordering relationship for exponentiation.  (Contributed by Mario
         Carneiro, 28-May-2016.) $)
      leexp2rd $p |- ( ph -> ( A ^ N ) <_ ( A ^ M ) ) $=
        ( cr wcel cn0 cuz cfv cc0 cle wbr c1 cexp co leexp2r syl32anc ) ABJKCLK
        DCMNKOBPQBRPQBDSTBCSTPQEFGHIBCDUAUB $.
    $}

    lt2sqd.2 $e |- ( ph -> B e. RR ) $.
    lt2sqd.3 $e |- ( ph -> 0 <_ A ) $.
    lt2sqd.4 $e |- ( ph -> 0 <_ B ) $.
    $( The square function on nonnegative reals is strictly monotonic.
       (Contributed by Mario Carneiro, 28-May-2016.) $)
    lt2sqd $p |- ( ph -> ( A < B <-> ( A ^ 2 ) < ( B ^ 2 ) ) ) $=
      ( cr wcel cc0 cle wbr clt c2 cexp co wb lt2sq syl22anc ) ABHIJBKLCHIJCKLB
      CMLBNOPCNOPMLQDFEGBCRS $.

    $( The square function on nonnegative reals is monotonic.  (Contributed by
       Mario Carneiro, 28-May-2016.) $)
    le2sqd $p |- ( ph -> ( A <_ B <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
      ( cr wcel cc0 cle wbr c2 cexp co wb le2sq syl22anc ) ABHIJBKLCHIJCKLBCKLB
      MNOCMNOKLPDFEGBCQR $.

    sq11d.5 $e |- ( ph -> ( A ^ 2 ) = ( B ^ 2 ) ) $.
    $( The square function is one-to-one for nonnegative reals.  (Contributed
       by Mario Carneiro, 28-May-2016.) $)
    sq11d $p |- ( ph -> A = B ) $=
      ( c2 cexp co wceq cr wcel cc0 cle wbr wb sq11 syl22anc mpbid ) ABIJKCIJKL
      ZBCLZHABMNOBPQCMNOCPQUBUCRDFEGBCSTUA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ordered pair theorem for nonnegative integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    nn0le2msqi.1 $e |- A e. NN0 $.
    nn0le2msqi.2 $e |- B e. NN0 $.
    $( The square function on nonnegative integers is monotonic.  (Contributed
       by Raph Levien, 10-Dec-2002.) $)
    nn0le2msqi $p |- ( A <_ B <-> ( A x. A ) <_ ( B x. B ) ) $=
      ( cle wbr c2 cexp co cmul cc0 nn0ge0i nn0rei le2sqi nn0cni sqvali breq12i
      wb mp2an bitri ) ABEFZAGHIZBGHIZEFZAAJIZBBJIZEFKAEFKBEFUAUDRACLBDLABACMBD
      MNSUBUEUCUFEAACOPBBDOPQT $.
  $}

  ${
    nn0opthlem1.1 $e |- A e. NN0 $.
    nn0opthlem1.2 $e |- C e. NN0 $.
    $( A rather pretty lemma for ~ nn0opthi .  (Contributed by Raph Levien,
       10-Dec-2002.) $)
    nn0opthlem1 $p |- ( A < C <-> ( ( A x. A ) + ( 2 x. A ) ) < ( C x. C ) ) $=
      ( c1 caddc co cle wbr cmul clt c2 nn0addcli wcel wb nn0mulcli cexp ax-1cn
      cn0 sqvali 1nn0 nn0le2msqi nn0ltp1le nn0cni binom2i addcli oveq1i oveq12i
      mp2an 2nn0 3eqtr3i mulid1i oveq2i eqtri breq1i bitr4i 3bitr4i ) AEFGZBHIZ
      URURJGZBBJGZHIZABKIZAAJGZLAJGZFGZVAKIZURBAECUAMDUBASNBSNVCUSOCDABUCUIVGVF
      EFGZVAHIZVBVFSNVASNVGVIOVDVEAACCPLAUJCPMBBDDPVFVAUCUIUTVHVAHUTVDLAEJGZJGZ
      FGZEEJGZFGZVHURLQGALQGZVKFGZELQGZFGUTVNAEACUDZRUEURAEVRRUFTVPVLVQVMFVOVDV
      KFAVRTUGERTUHUKVLVFVMEFVKVEVDFVJALJAVRULUMUMERULUHUNUOUPUQ $.
  $}

  ${
    nn0opth.1 $e |- A e. NN0 $.
    nn0opth.2 $e |- B e. NN0 $.
    nn0opth.3 $e |- C e. NN0 $.
    nn0opth.4 $e |- D e. NN0 $.
    $( Lemma for ~ nn0opthi .  (Contributed by Raph Levien, 10-Dec-2002.)
       (Revised by Scott Fenton, 8-Sep-2010.) $)
    nn0opthlem2 $p |- ( ( A + B ) < C
           -> ( ( C x. C ) + D ) =/= ( ( ( A + B ) x. ( A + B ) ) + B ) ) $=
      ( caddc co clt wbr cmul wne c2 nn0addcli cle nn0rei remulcli readdcli 2re
      nn0opthlem1 nn0addge2i nn0lele2xi leadd2i lelttri mpan nn0addge1i ltletri
      sylib ax-mp sylbi mpan2 ltnei 3syl ) ABIJZCKLZUPUPMJZBIJZCCMJZKLZUSUTDIJZ
      KLZVBUSNUQUROUPMJZIJZUTKLZVAUPCABEFPZGUBUSVEQLZVFVABUPQLZVHBABFRZEUCVIBVD
      QLVHUPBVGFUDBVDURVJOUPUAUPVGRZSZUPUPVKVKSZUEUJUKUSVEUTURBVMVJTZURVDVMVLTC
      CCGRZVOSZUFUGULVAUTVBQLVCUTDVPHUHUSUTVBVNVPUTDVPDHRTZUIUMUSVBVNVQUNUO $.

    $( An ordered pair theorem for nonnegative integers.  Theorem 17.3 of
       [Quine] p. 124.  We can represent an ordered pair of nonnegative
       integers ` A ` and ` B ` by ` ( ( ( A + B ) x. ( A + B ) ) + B ) ` .  If
       two such ordered pairs are equal, their first elements are equal and
       their second elements are equal.  Contrast this ordered pair
       representation with the standard one ~ df-op that works for any set.
       (Contributed by Raph Levien, 10-Dec-2002.)  (Proof shortened by Scott
       Fenton, 8-Sep-2010.) $)
    nn0opthi $p |- ( ( ( ( A + B ) x. ( A + B ) ) + B ) =
            ( ( ( C + D ) x. ( C + D ) ) + D ) <-> ( A = C /\ B = D ) ) $=
      ( caddc cmul wceq wne clt wbr nn0addcli nn0rei nn0opthlem2 oveq12d nn0cni
      co wa wo lttri2i necomd jaoi sylbi necon4i id oveq1d eqtr4d addcani sylib
      mulcli oveq2d addcan2i jca oveq12 simpr impbii ) ABITZUTJTZBITZCDITZVCJTZ
      DITZKZACKZBDKZUAZVFVGVHVFUTCBITZKVGVFUTVCVJUTVCVBVEUTVCLUTVCMNZVCUTMNZUBV
      BVELZUTVCUTABEFOZPVCCDGHOZPUCVKVMVLVKVEVBABVCDEFVOHQUDCDUTBGHVNFQUEUFUGZV
      FBDCIVFVBVADITZKVHVFVBVEVQVFUHVFVAVDDIVFUTVCUTVCJVPVPRUIUJVABDUTUTUTVNSZV
      RUMBFSZDHSUKULZUNUJACBAESCGSVSUOULVTUPVIVAVDBDIVIUTVCUTVCJACBDIUQZWARVGVH
      URRUS $.

    $( An ordered pair theorem for nonnegative integers.  Theorem 17.3 of
       [Quine] p. 124.  See comments for ~ nn0opthi .  (Contributed by NM,
       22-Jul-2004.) $)
    nn0opth2i $p |- ( ( ( ( A + B ) ^ 2 ) + B ) = ( ( ( C + D ) ^ 2 ) + D ) <->
                   ( A = C /\ B = D ) ) $=
      ( caddc co c2 cexp wceq cmul wa nn0cni addcli sqvali oveq1i eqeq12i bitri
      nn0opthi ) ABIJZKLJZBIJZCDIJZKLJZDIJZMUCUCNJZBIJZUFUFNJZDIJZMACMBDMOUEUJU
      HULUDUIBIUCABAEPBFPQRSUGUKDIUFCDCGPDHPQRSTABCDEFGHUBUA $.
  $}

  $( An ordered pair theorem for nonnegative integers.  Theorem 17.3 of [Quine]
     p. 124.  See ~ nn0opthi .  (Contributed by NM, 22-Jul-2004.) $)
  nn0opth2 $p |- ( ( ( A e. NN0 /\ B e. NN0 ) /\ ( C e. NN0 /\ D e. NN0 ) ) ->
          ( ( ( ( A + B ) ^ 2 ) + B ) = ( ( ( C + D ) ^ 2 ) + D ) <->
                   ( A = C /\ B = D ) ) ) $=
    ( cn0 wcel caddc co c2 cexp wceq wa wb cc0 oveq1 oveq1d bibi12d 0nn0 elimel
    cif eqeq1d eqeq1 anbi1d oveq2 oveq12d anbi2d eqeq2d eqeq2 nn0opth2i dedth4h
    id ) AEFZBEFZCEFZDEFZABGHZIJHZBGHZCDGHZIJHZDGHZKZACKZBDKZLZMULANTZBGHZIJHZB
    GHZVAKZVFCKZVDLZMVFUMBNTZGHZIJHZVMGHZVAKZVKVMDKZLZMVPUNCNTZDGHZIJHZDGHZKZVF
    VTKZVRLZMVPVTUODNTZGHZIJHZWGGHZKZWEVMWGKZLZMABCDNNNNAVFKZVBVJVEVLWNURVIVAWN
    UQVHBGWNUPVGIJAVFBGOPPUAWNVCVKVDAVFCUBUCQBVMKZVJVQVLVSWOVIVPVAWOVHVOBVMGWOV
    GVNIJBVMVFGUDPWOUKUEUAWOVDVRVKBVMDUBUFQCVTKZVQWDVSWFWPVAWCVPWPUTWBDGWPUSWAI
    JCVTDGOPPUGWPVKWEVRCVTVFUHUCQDWGKZWDWKWFWMWQWCWJVPWQWBWIDWGGWQWAWHIJDWGVTGU
    DPWQUKUEUGWQVRWLWEDWGVMUHUFQVFVMVTWGANERSBNERSCNERSDNERSUIUJ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Factorial function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ! $. $( Factorial. $)

  $( Extend class notation to include the factorial of nonnegative integers. $)
  cfa $a class ! $.

  $( Define the factorial function on nonnegative integers.  For example,
     ` ( ! `` 4 ) = ; 2 4 ` because ` ( 4 x. ( 3 x. ( 2 x. 1 ) ) ) = ; 2 4 `
     ( ~ fac4 ).  In the literature, the factorial function is written as a
     postscript exclamation point.  (Contributed by NM, 2-Dec-2004.) $)
  df-fac $a |- ! = ( { <. 0 , 1 >. } u. seq 1 ( x. , _I ) ) $.

  $( Value of the factorial function for positive integers.  (Contributed by
     NM, 2-Dec-2004.)  (Revised by Mario Carneiro, 13-Jul-2013.) $)
  facnn $p |- ( N e. NN ->
      ( ! ` N ) = ( seq 1 ( x. , _I ) ` N ) ) $=
    ( cfa cfv cmul cid c1 cseq wceq cn0 cc0 csn cdif c0ex 1ex cop cun cres dfn2
    cn eqtr3i df-fac cuz nnuz reseq2i cz wcel wfn 1z fnresdm mp2b uneq2i eqtr4i
    seqfn fvsnun2 eleq2s ) ABCADEFGZCHAIJKLZSJFIAUPBMNBJFOKZUPPURUPUQQZPUAUSUPU
    RUPFUBCZQZUSUPUTUQUPSUTUQUCRTUDFUEUFUPUTUGVAUPHUHDEFUMUTUPUIUJTUKULUNRUO $.

  $( The factorial of 0.  (Contributed by NM, 2-Dec-2004.)  (Revised by Mario
     Carneiro, 13-Jul-2013.) $)
  fac0 $p |- ( ! ` 0 ) = 1 $=
    ( cc0 c1 cn0 cmul cid cseq cfa c0ex 1ex cop csn cun cdif cres df-fac cuz cn
    cfv nnuz eqtr3i dfn2 reseq2i cz wcel wfn wceq 1z fnresdm mp2b uneq2i eqtr4i
    seqfn fvsnun1 ) ABCDEBFZGHIGABJKZUNLUOUNCAKMZNZLOUQUNUOUNBPRZNZUQUNURUPUNQU
    RUPSUATUBBUCUDUNURUEUSUNUFUGDEBULURUNUHUITUJUKUM $.

  $( The factorial of 1.  (Contributed by NM, 2-Dec-2004.)  (Revised by Mario
     Carneiro, 13-Jul-2013.) $)
  fac1 $p |- ( ! ` 1 ) = 1 $=
    ( c1 cfa cfv cmul cid cseq cn wcel wceq 1nn facnn ax-mp cz seq1 fvi 3eqtri
    1z ) ABCZADEAFCZAECZAAGHZRSIJAKLAMHSTIQDEANLUATAIJAGOLP $.

  $( The factorial of a successor.  (Contributed by NM, 2-Dec-2004.)  (Revised
     by Mario Carneiro, 13-Jul-2013.) $)
  facp1 $p |- ( N e. NN0 ->
               ( ! ` ( N + 1 ) ) = ( ( ! ` N ) x. ( N + 1 ) ) ) $=
    ( cn0 wcel cn cc0 wceq wo c1 caddc cfa cfv cmul elnn0 cid facnn cvv 3eqtr4a
    co 0p1e1 eqtri cseq peano2nn syl ovex ax-mp oveq2i seqp1 nnuz eleq2s oveq1d
    fvi cuz eqtrd fveq2i fac1 oveq1 fveq2d fveq2 oveq12d fac0 1t1e1 syl6eq jaoi
    oveq12i sylbi ) ABCADCZAEFZGAHIRZJKZAJKZVHLRZFZAMVFVLVGVFVIVHLNHUAZKZVKVFVH
    DCVIVNFAUBVHOUCVFAVMKZVHNKZLRZVOVHLRVNVKVPVHVOLVHPCVPVHFAHIUDVHPUKUEUFVNVQF
    AHULKDLNHAUGUHUIVFVJVOVHLAOUJQUMVGEHIRZJKZHVIVKVSHJKHVRHJSUNUOTVGVHVRJAEHIU
    PZUQVGVKEJKZVRLRZHVGVJWAVHVRLAEJURVTUSWBHHLRHWAHVRHLUTSVDVATVBQVCVE $.

  $( The factorial of 2.  (Contributed by NM, 17-Mar-2005.) $)
  fac2 $p |- ( ! ` 2 ) = 2 $=
    ( c2 cfa cfv c1 caddc df-2 fveq2i cmul cn0 wcel wceq 1nn0 facp1 ax-mp 1p1e2
    co fac1 oveq12i 2cn eqtri mulid2i ) ABCDDEPZBCZAAUBBFGUCDBCZUBHPZADIJUCUEKL
    DMNUEDAHPAUDDUBAHQORASUATTT $.

  $( The factorial of 3.  (Contributed by NM, 17-Mar-2005.) $)
  fac3 $p |- ( ! ` 3 ) = 6 $=
    ( c3 cfa cfv c2 c1 caddc co cmul df-3 fveq2i cn0 wcel wceq 2nn0 facp1 ax-mp
    c6 fac2 2p1e3 3eqtri oveq12i 2cn 3cn mulcomi 3t2e6 ) ABCDEFGZBCZDBCZUFHGZQA
    UFBIJDKLUGUIMNDOPUIDAHGADHGQUHDUFAHRSUADAUBUCUDUETT $.

  $( The factorial of 4.  (Contributed by Mario Carneiro, 18-Jun-2015.) $)
  fac4 $p |- ( ! ` 4 ) = ; 2 4 $=
    ( c3 c1 caddc co cfa cfv cmul c4 cdc cn0 wcel wceq facp1 ax-mp 3p1e4 fveq2i
    c2 3nn0 c6 fac3 oveq12i 6t4e24 eqtri 3eqtr3i ) ABCDZEFZAEFZUEGDZHEFQHIZAJKU
    FUHLRAMNUEHEOPUHSHGDUIUGSUEHGTOUAUBUCUD $.

  $( Value of the factorial function expressed recursively.  (Contributed by
     NM, 2-Dec-2004.) $)
  facnn2 $p |- ( N e. NN ->
               ( ! ` N ) = ( ( ! ` ( N - 1 ) ) x. N ) ) $=
    ( cn wcel cc c1 cmin co cn0 wa cfa cfv cmul wceq elnnnn0 caddc facp1 adantl
    ax-1cn npcan adantr mpan2 fveq2d oveq2d 3eqtr3d sylbi ) ABCADCZAEFGZHCZIZAJ
    KZUGJKZALGZMANUIUGEOGZJKZUKUMLGZUJULUHUNUOMUFUGPQUFUNUJMUHUFUMAJUFEDCUMAMRA
    ESUAZUBTUFUOULMUHUFUMAUKLUPUCTUDUE $.

  ${
    $d j k N $.
    $( Closure of the factorial function.  (Contributed by NM, 2-Dec-2004.) $)
    faccl $p |- ( N e. NN0 -> ( ! ` N ) e. NN ) $=
      ( vj vk cv cfa cfv cn wcel cc0 c1 caddc co wceq fveq2 eleq1d fac0 eqeltri
      1nn cn0 wa cmul facp1 adantl nn0p1nn nnmulcl sylan2 eqeltrd expcom nn0ind
      ) BDZEFZGHIEFZGHCDZEFZGHZUMJKLZEFZGHZAEFZGHBCAUJIMUKULGUJIENOUJUMMUKUNGUJ
      UMENOUJUPMUKUQGUJUPENOUJAMUKUSGUJAENOULJGPRQUOUMSHZURUOUTTUQUNUPUALZGUTUQ
      VAMUOUMUBUCUTUOUPGHVAGHUMUDUNUPUEUFUGUHUI $.
  $}

  $( The factorial function is nonzero.  (Contributed by NM, 26-Apr-2005.) $)
  facne0 $p |- ( N e. NN0 -> ( ! ` N ) =/= 0 ) $=
    ( cn0 wcel cfa cfv faccl nnne0d ) ABCADEAFG $.

  ${
    $d j M $.  $d j k N $.
    $( A natural number divides the factorial of an equal or larger number.
       (Contributed by NM, 2-May-2005.) $)
    facdiv $p |- ( ( M e. NN0 /\ N e. NN /\ N <_ M ) ->
                  ( ( ! ` M ) / N ) e. NN ) $=
      ( wcel cn cle wbr cfa cfv cdiv co wi cc0 wceq breq2 oveq1d eleq1d imbi12d
      fveq2 imbi2d wa vj vk cn0 cv c1 caddc clt wn nngt0 cr wb 0re nnre sylancr
      ltnle mpbid pm2.21d cmul wo peano2nn0 nn0red leloe syl2an nnnn0 nn0leltp1
      sylan nn0p1nn nnmulcl sylan2 expcom adantl cc wne faccl nncnd nn0cnd nncn
      nnne0 jca adantr div23 syl3anc sylibrd imim2d com23 sylbird eqeltrd oveq2
      divcan4d syl5ibcom a1dd jaod sylbid ex com34 com12 imp4d facp1 a2d nn0ind
      exp4d 3imp ) AUCCBDCZBAEFZAGHZBIJZDCZXCBUAUDZEFZXHGHZBIJZDCZKZKXCBLEFZLGH
      ZBIJZDCZKZKXCBUBUDZEFZXSGHZBIJZDCZKZKXCBXSUEUFJZEFZYEGHZBIJZDCZKZKXCXDXGK
      ZKUAUBAXHLMZXMXRXCYLXIXNXLXQXHLBENYLXKXPDYLXJXOBIXHLGROPQSXHXSMZXMYDXCYMX
      IXTXLYCXHXSBENYMXKYBDYMXJYABIXHXSGROPQSXHYEMZXMYJXCYNXIYFXLYIXHYEBENYNXKY
      HDYNXJYGBIXHYEGROPQSXHAMZXMYKXCYOXIXDXLXGXHABENYOXKXFDYOXJXEBIXHAGROPQSXC
      XNXQXCLBUGFZXNUHZBUIXCLUJCBUJCZYPYQUKULBUMZLBUOUNUPUQXSUCCZXCYDYJYTXCYDYF
      YIYTXCYDYFTTYAYEURJZBIJZDCZYIYTXCYDYFUUCXCYTYDYFUUCKKXCYTYFYDUUCXCYTYFYDU
      UCKZKXCYTTZYFBYEUGFZBYEMZUSZUUDXCYRYEUJCYFUUHUKYTYSYTYEXSUTZVABYEVBVCUUEU
      UFUUDUUGUUEUUFXTUUDXCBUCCYTXTUUFUKBVDBXSVEVFUUEYDXTUUCUUEYCUUCXTUUEYCYBYE
      URJZDCZUUCYTYCUUKKXCYCYTUUKYTYCYEDCUUKXSVGYBYEVHVIVJVKUUEUUBUUJDUUEYAVLCZ
      YEVLCZBVLCZBLVMZTZUUBUUJMYTUULXCYTYAXSVNZVOVKZYTUUMXCYTYEUUIVPVKXCUUPYTXC
      UUNUUOBVQZBVRZVSVTYAYEBWAWBPWCWDWEWFUUEUUGUUCYDUUEYABURJZBIJZDCUUGUUCUUEU
      VBYADUUEYABUURXCUUNYTUUSVTXCUUOYTUUTVTWIYTYADCXCUUQVKWGUUGUVBUUBDUUGUVAUU
      ABIBYEYAURWHOPWJWKWLWMWNWOWPWQYTYHUUBDYTYGUUABIXSWROPWCXAWSWTXB $.
  $}

  $( No natural number (greater than one) divides the factorial plus one of an
     equal or larger number.  (Contributed by NM, 3-May-2005.) $)
  facndiv $p |- ( ( ( M e. NN0 /\ N e. NN ) /\ ( 1 < N /\ N <_ M ) ) ->
                -. ( ( ( ! ` M ) + 1 ) / N ) e. ZZ ) $=
    ( cn0 wcel cn wa c1 clt wbr cle cfa cfv caddc co cdiv cz cmin wceq ad2antrr
    cc wn cr nnre recnz sylan ad2ant2lr facdiv 3expa nnzd adantrl zsubcl ex cc0
    syl5com wne faccl nncnd peano2cn syl nncn nnne0 jca ad2antlr syl3anc ax-1cn
    divsubdir pncan2 sylancl oveq1d eqtr3d eleq1d sylibd mtod ) ACDZBEDZFZGBHIZ
    BAJIZFZFZAKLZGMNZBONZPDZGBONZPDZVOVQWFUAZVNVRVOBUBDVQWGBUCBUDUEUFVTWDWCWABO
    NZQNZPDZWFVTWHPDZWDWJVPVRWKVQVPVRFWHVNVOVRWHEDABUGUHUIUJWDWKWJWCWHUKULUNVTW
    IWEPVTWBWAQNZBONZWIWEVTWBTDZWATDZBTDZBUMUOZFZWMWIRVNWNVOVSVNWOWNVNWAAUPUQZW
    AURUSSVNWOVOVSWSSVOWRVNVSVOWPWQBUTBVAVBVCWBWABVFVDVNWMWERVOVSVNWLGBOVNWOGTD
    WLGRWSVEWAGVGVHVISVJVKVLVM $.

  ${
    $d j k M $.  $d j N $.
    $( Ordering property of factorial.  (Contributed by NM, 9-Dec-2005.) $)
    facwordi $p |- ( ( M e. NN0 /\ N e. NN0 /\ M <_ N ) ->
                  ( ! ` M ) <_ ( ! ` N ) ) $=
      ( vj vk cn0 wcel cle wbr cfa cfv wa wi cc0 wceq breq2 anbi2d fveq2 breq2d
      imbi12d cr cv c1 caddc weq nn0le0eq0 biimpa fveq2d fac0 1re eqeltri leidi
      co syl6eqbr impexp clt wo nn0re peano2re syl leloe syl2an nn0leltp1 faccl
      cmul nnred nnnn0d nn0ge0d nn0p1nn nnge1d lemulge11d facp1 breqtrrd adantl
      wb adantr cn peano2nn0 letr syl3anc mpan2d imim2d com23 sylbird syl5ibcom
      leidd syl5 a1dd jaod sylbid ex com13 com4l a2d imp4a syl5bi nn0ind 3impib
      3com12 ) BEFZAEFZABGHZAIJZBIJZGHZWSWTXAXDWTACUAZGHZKZXBXEIJZGHZLWTAMGHZKZ
      XBMIJZGHZLWTADUAZGHZKZXBXNIJZGHZLZWTAXNUBUCULZGHZKZXBXTIJZGHZLZWTXAKZXDLC
      DBXEMNZXGXKXIXMYGXFXJWTXEMAGOPYGXHXLXBGXEMIQRSCDUDZXGXPXIXRYHXFXOWTXEXNAG
      OPYHXHXQXBGXEXNIQRSXEXTNZXGYBXIYDYIXFYAWTXEXTAGOPYIXHYCXBGXEXTIQRSXEBNZXG
      YFXIXDYJXFXAWTXEBAGOPYJXHXCXBGXEBIQRSXKXBXLXLGXKAMIWTXJAMNAUEUFUGXLXLUBTU
      HUIUJUKUMXSWTXOXRLZLZXNEFZYEWTXOXRUNYMYLWTYAYDYMWTYKYAYDLYAYMWTYKYDWTYMYA
      YKYDLZWTYMYAYNLWTYMKZYAAXTUOHZAXTNZUPZYNWTATFXTTFZYAYRVNYMAUQYMXNTFYSXNUQ
      XNURUSZAXTUTVAYOYPYNYQYOYPXOYNAXNVBYOYKXOYDYOXRYDXOYOXRXQYCGHZYDYMUUAWTYM
      XQXQXTVDULYCGYMXQXTYMXQXNVCZVEZYTYMXQYMXQUUBVFVGYMXTXNVHVIVJXNVKVLVMYOXBT
      FZXQTFZYCTFZXRUUAKYDLWTUUDYMWTXBAVCVEZVOYMUUEWTUUCVMYMUUFWTYMYCYMXTEFYCVP
      FXNVQXTVCUSVEVMXBXQYCVRVSVTWAWBWCYOYQYDYKWTYQYDLYMYQXBYCNZWTYDAXTIQWTXBXB
      GHUUHYDWTXBUUGWEXBYCXBGOWDWFVOWGWHWIWJWKWLWMWNWOWPWQWR $.

    $( A lower bound for the factorial function.  (Contributed by NM,
       17-Dec-2005.) $)
    faclbnd $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                   ( M ^ ( N + 1 ) ) <_ ( ( M ^ M ) x. ( ! ` N ) ) ) $=
      ( wcel cc0 wceq c1 caddc co cexp cfa cfv cmul cle wbr wi oveq2d wa cr syl
      cc vj vk cn0 cn wo elnn0 oveq1 fveq2 breq12d imbi2d nnre nnge1 cuz elnnuz
      biimpi leexp2ad 0p1e1 oveq2i a1i fac0 nnnn0 reexpcld recnd mulid1d syl5eq
      cv 3brtr4d ad3antrrr simpllr peano2nn0 faccl nnred remulcld peano2re 3syl
      clt nn0re 0re ltle mpan sylc expge0d simplr simprr lemul12ad anandis nncn
      nngt0 expp1 syl2an adantr facp1 adantl nncnd nn0cn peano2cn mulassd exp32
      eqtr4d com23 wb nn0ltp1le syl2anr reexpcl ad2antrr remulcl simpr ad2antlr
      cz nn0zd nnz eluz syl2anc mpbird anim12i id nn0ge0 nnge1d lemulge11 letrd
      ex sylbid lelttric mpjaod expcom a2d nn0ind impcom nnnn0d nn0ge0d nn0p1nn
      a1dd 0expd 0cn exp0 ax-mp oveq1i mulid2d oveq12 anidms oveq1d syl5ibr imp
      jaoian sylanb ) AUCCZAUDCZADEZUEBUCCZABFGHZIHZAAIHZBJKZLHZMNZAUFUUGUUIUUO
      UUHUUIUUGUUOUUGAUAVFZFGHZIHZUULUUPJKZLHZMNZOUUGADFGHZIHZUULDJKZLHZMNZOUUG
      AUBVFZFGHZIHZUULUVGJKZLHZMNZOUUGAUVHFGHZIHZUULUVHJKZLHZMNZOUUGUUOOUAUBBUU
      PDEZUVAUVFUUGUVRUURUVCUUTUVEMUVRUUQUVBAIUUPDFGUGPUVRUUSUVDUULLUUPDJUHPUIU
      JUUPUVGEZUVAUVLUUGUVSUURUVIUUTUVKMUVSUUQUVHAIUUPUVGFGUGPUVSUUSUVJUULLUUPU
      VGJUHPUIUJUUPUVHEZUVAUVQUUGUVTUURUVNUUTUVPMUVTUUQUVMAIUUPUVHFGUGPUVTUUSUV
      OUULLUUPUVHJUHPUIUJUUPBEZUVAUUOUUGUWAUURUUKUUTUUNMUWAUUQUUJAIUUPBFGUGPUWA
      UUSUUMUULLUUPBJUHPUIUJUUGAFIHZUULUVCUVEMUUGAFAAUKZAULZUUGAFUMKCAUNUOUPUVC
      UWBEUUGUVBFAIUQURUSUUGUVEUULFLHUULUVDFUULLUTURUUGUULUUGUULUUGAAUWCAVAZVBZ
      VCZVDVEVGUVGUCCZUUGUVLUVQUUGUWHUVLUVQOZUUGUWHQZAUVHMNZUWIUVHAVPNZUWJUVLUW
      KUVQUWJUVLUWKUVQUWJUVLUWKQZQUVIALHZUVKUVHLHZUVNUVPMUWJUVLUWKUWNUWOMNUWJUV
      LQZUWJUWKQZQZUVIUVKAUVHUWRAUVHUUGARCZUWHUVLUWQUWCVHZUWRUWHUVHUCCZUUGUWHUV
      LUWQVIZUVGVJZSZVBUWRUULUVJUWRAAUWTUUGUUFUWHUVLUWQUWEVHVBUWRUVJUWRUWHUVJUD
      CUXBUVGVKZSVLVMUWTUWRUWHUVGRCZUVHRCZUXBUVGVQZUVGVNZVOUWRAUVHUWTUXDUWRUWSD
      AVPNZDAMNZUWTUUGUXJUWHUVLUWQAWHVHDRCUWSUXJUXKOVRDAVSVTWAZWBUXLUWJUVLUWQWC
      UWPUWJUWKWDWEWFUWJUVNUWNEZUWMUUGATCUXAUXMUWHAWGUXCAUVHWIWJWKUWJUVPUWOEUWM
      UWJUVPUULUVJUVHLHZLHUWOUWJUVOUXNUULLUWHUVOUXNEUUGUVGWLWMPUWJUULUVJUVHUUGU
      ULTCUWHUWGWKUWHUVJTCUUGUWHUVJUXEWNWMUWHUVHTCZUUGUWHUVGTCUXOUVGWOUVGWPSWMW
      QWSWKVGWRWTUWJUWLUVQUVLUWJUWLUVMAMNZUVQUWHUXAUUFUWLUXPXAUUGUXCUWEUVHAXBXC
      UWJUXPUVQUWJUXPQZUVNUULUVPUWJUVNRCZUXPUUGUWSUVMUCCZUXRUWHUWCUWHUXAUXSUXCU
      VHVJSZAUVMXDWJWKUUGUULRCZUWHUXPUWFXEUWJUVPRCZUXPUUGUYAUVORCZUYBUWHUWFUWHU
      VOUWHUXAUVOUDCUXCUVHVKSZVLZUULUVOXFWJWKUXQAUVMAUUGUWSUWHUXPUWCXEUUGFAMNUW
      HUXPUWDXEUXQAUVMUMKCZUXPUWJUXPXGUXQUVMXICAXICZUYFUXPXAUXQUVMUWHUXSUUGUXPU
      XTXHXJUUGUYGUWHUXPAXKXEUVMAXLXMXNUPUWJUULUVPMNZUXPUWJUYAUYCQDUULMNZFUVOMN
      ZQUYHUUGUYAUWHUYCUWFUYEXOUUGUYIUWHUYJUUGUUFUYIUWEUUFAAAVQUUFXPAXQWBSUWHUV
      OUYDXRXOUULUVOXSXMWKXTYAYBYLUUGUWSUXGUWKUWLUEUWHUWCUWHUXFUXGUXHUXISAUVHYC
      WJYDYEYFYGYHUUHUUIUUOUUIUUOUUHDUUJIHZDDIHZUUMLHZMNUUIDUUMUYKUYMMUUIUUMUUI
      UUMBVKZYIYJUUIUUJBYKYMUUIUYMFUUMLHUUMUYLFUUMLDTCUYLFEYNDYOYPYQUUIUUMUUIUU
      MUYNWNYRVEVGUUHUUKUYKUUNUYMMADUUJIUGUUHUULUYLUUMLUUHUULUYLEADADIYSYTUUAUI
      UUBUUCUUDUUE $.
  $}

  $( A lower bound for the factorial function.  (Contributed by NM,
     17-Dec-2005.) $)
  faclbnd2 $p |- ( N e. NN0 -> ( ( 2 ^ N ) / 2 ) <_ ( ! ` N ) ) $=
    ( cn0 wcel c2 cexp co cdiv c1 cle cmul c4 sq2 oveq2i cc 2cn mpan wa cc0 wbr
    cr caddc cfa cfv 2t2e4 eqtr4i wceq expp1 oveq1d syl5eq expcl 2ne0 divmuldiv
    wne pm3.2i mpanr12 sylancl dividi halfcld mulid1d 3eqtr2rd 2nn0 faclbnd 2re
    wb peano2nn0 reexpcl sylancr faccl nnred clt eqeltri 4pos breqtrri ledivmul
    4re mp3an3 syl2anc mpbird eqbrtrd ) ABCZDAEFZDGFZDAHUAFZEFZDDEFZGFZAUBUCZIV
    TWFWADJFZDDJFZGFZWBDDGFZJFZWBVTWFWDWIGFWJWEWIWDGWEKWILUDUEMVTWDWHWIGDNCZVTW
    DWHUFODAUGPUHUIVTWANCZWMWLWJUFZWMVTWNODAUJPZOWNWMQWMDRUMZQZWRWOWMWQOUKUNZWS
    WADDDULUOUPVTWLWBHJFWBWKHWBJDOUKUQMVTWBVTWAWPURUSUIUTVTWFWGISZWDWEWGJFISZDB
    CVTXAVADAVBPVTWDTCZWGTCZWTXAVDZVTDTCWCBCXBVCAVEDWCVFVGVTWGAVHVIXBXCWETCZRWE
    VJSZQXDXEXFWEKTLVOVKRKWEVJVLLVMUNWDWGWEVNVPVQVRVS $.

  $( A lower bound for the factorial function.  (Contributed by NM,
     19-Dec-2005.) $)
  faclbnd3 $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                 ( M ^ N ) <_ ( ( M ^ M ) x. ( ! ` N ) ) ) $=
    ( cn0 wcel cn cc0 wceq wo cexp co cfv cle wbr wa c1 cr adantr sylan reexpcl
    cmul cfa elnn0 caddc nnre nnge1 cuz nn0z adantl uzid peano2uz 3syl leexp2ad
    cz nnnn0 faclbnd wi nn0re peano2nn0 syl2an mpancom faccl nnred remulcl letr
    syl3anc mp2and 0exp 0le1 syl6eqbr oveq2 cc 0cn exp0 ax-mp 1le1 eqbrtri jaoi
    sylbi 1nn nnmulcl sylancr nnge1d 0re 1re mp3an2 syl2anc oveq1 oveq12 anidms
    mpan wb syl6eq oveq1d breq12d mpbird jaoian sylanb ) ACDZAEDZAFGZHBCDZABIJZ
    AAIJZBUAKZTJZLMZAUBWSXAXFWTWSXANZXBABOUCJZIJZLMZXIXELMZXFXGABXHWSAPDZXAAUDQ
    WSOALMXAAUEQXGBUMDZBBUFKZDXHXNDXAXMWSBUGUHBUIBBUJUKULWSWRXAXKAUNZABUORWSWRX
    AXJXKNXFUPZXOWRXANXBPDZXIPDZXEPDZXPWRXLXAXQAUQZABSRWRXLXHCDXRXAXTBURAXHSUSW
    RXCPDZXDPDZXSXAXLWRYAXTAASUTXAXDBVAZVBZXCXDVCUSXBXIXEVDVERVFWTXANXFFBIJZOXD
    TJZLMZXAYGWTXAYEOLMZOYFLMZYGXABEDZBFGZHYHBUBYJYHYKYJYEFOLBVGVHVIYKYEFFIJZOL
    BFFIVJYLOOLFVKDYLOGVLFVMVNZVOVPVIVQVRXAYFXAOEDXDEDYFEDVSYCOXDVTWAWBXAYEPDZY
    FPDZYHYINYGUPZFPDXAYNWCFBSWJXAOPDZYBYOWDYDOXDVCWAYNYQYOYPWDYEOYFVDWEWFVFUHW
    TXFYGWKXAWTXBYEXEYFLAFBIWGWTXCOXDTWTXCYLOWTXCYLGAFAFIWHWIYMWLWMWNQWOWPWQ $.

  ${
    faclbnd4lem1.1 $e |- N e. NN $.
    faclbnd4lem1.2 $e |- K e. NN0 $.
    faclbnd4lem1.3 $e |- M e. NN0 $.
    $( Lemma for ~ faclbnd4 .  Prepare the induction step.  (Contributed by NM,
       20-Dec-2005.) $)
    faclbnd4lem1 $p |- ( ( ( ( N - 1 ) ^ K ) x. ( M ^ ( N - 1 ) ) ) <_
       ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` ( N - 1 ) ) ) ->
                   ( ( N ^ ( K + 1 ) ) x. ( M ^ N ) ) <_ ( ( (
  2 ^ ( ( K + 1 ) ^ 2 ) ) x. ( M ^ ( M + ( K + 1 ) ) ) ) x. ( ! ` N ) ) ) $=
      ( c1 cle wbr co cexp cmul c2 cr wcel mp2an wceq cc0 wa remulcli clt caddc
      wo cmin cfa cfv nnrei 1re lelttric cn nnge1 ax-mp letri3i mpbiran2 pm3.2i
      0le1 cn0 2re nn0nnaddcl nnnn0i 2nn0 nn0expcli reexpcl nn0rei nn0ge0i exp0
      1nn cc 2cn cuz 1lt2 nn0uz eleqtri leexp2a mp3an eqbrtrri elnn0 nncn exp1d
      ltleii nnuz mp3an13 syl eqbrtrrd breq1 mpbiri sylbi lemul12a mp2 oveq1 cz
      jaoi nnzi 1exp syl6eq oveq2 nn0cni exp1 oveq12d fveq2 oveq2d recni mulcli
      fac1 mulid1i breq12d sylbir adantr a1i faccl nn0mulcli nncni expp1 expm1t
      oveq12i elnnnn0 mpbi simpri mulassi eqtri nn0addcli 3pm3.2i nnltp1le df-2
      w3a breq1i bitr4i lemul1a mul4i oveq2i 3eqtr2i syl6breq mpan letrd ax-1cn
      wb eqtr3i eqtr4i nn0zi sqvali expubnd mp3an12 mul12i adantl mul32i facnn2
      sylancr addassi syl5eqbr expadd ltp1i eqcomi adddii 3brtr4i eluz1i jaoian
      mpbir2an syl6breqr ) CGHIZGCUAIZUCZCGUDJZAKJZBUVBKJZLJZMAMKJZKJZBBAUBJZKJ
      ZLJZUVBUEUFZLJZHIZCAGUBJZKJZBCKJZLJZMUVNMKJZKJZBBUVNUBJZKJZLJZCUEUFZLJZHI
      ZCNOZGNOZUVACDUGZUHCGUIPUUSUVMUWEUUTUUSUWEUVMUUSCGQZUWEUWIUUSGCHIZCUJOZUW
      JDCUKULCGUWHUHUMUNUWIUWEGBLJZUWBHIZUWGRGHIZSZUVSNOZSZBNOZRBHIZSZUWANOZSZS
      GUVSHIZBUWAHIZSUWMUWQUXBUWOUWPUWGUWNUHUPUOMNOZUVRUQOUWPURUVNMUVNAUQOZGUJO
      ZUVNUJOZEVGAGUSPZUTZVAVBZMUVRVCPZUOUWTUXAUWRUWSBFVDZBFVEUOUWABUVTFUVTBUQO
      ZUXHUVTUJOFUXIBUVNUSPZUTVBZVDUOUOUXCUXDMRKJZGUVSHMVHOZUXQGQVIMVFULUXEGMHI
      ZUVRRVJUFZOUXQUVSHIURGMUHURVKVTZUVRUQUXTUXKVLVMMRUVRVNVOVPUXNUXDFUXNBUJOZ
      BRQZUCUXDBVQUYBUXDUYCUYBBGKJZBUWAHUYBBBVRVSUYBGBHIZUYDUWAHIZBUKUWRUYEUVTG
      VJUFZOUYFUXMUVTUJUYGUXOWAVMBGUVTVNWBWCWDUYCUXDRUWAHIUWAUXPVEBRUWAHWEWFWLW
      GULUOGUVSBUWAWHWIUWIUVQUWLUWDUWBHUWIUVOGUVPBLUWIUVOGUVNKJZGCGUVNKWJUVNWKO
      UYHGQUVNUXIWMUVNWNULWOUWIUVPUYDBCGBKWPBVHOZUYDBQBFWQZBWRULWOWSUWIUWDUWBGL
      JUWBUWIUWCGUWBLUWIUWCGUEUFGCGUEWTXDWOXAUWBUVSUWAUVSUXLXBZUWAUXPWQZXCXEWOX
      FWFXGXHUUTUVMSZUVQUVSUWAUWCLJZLJZUWDHUYMUVQUVGMAKJZLJZUYNLJZUYOUVQNOUYMUV
      OUVPUWFUVNUQOUVONOUWHUXJCUVNVCPUWRCUQOZUVPNOUXMCDUTZBCVCPTXIUYRNOUYMUYQUY
      NUVGUYPUXEUVFUQOZUVGNOURAMEVAVBZMUVFVCPZUYPMAVAEVBZVDZTZUYNUWAUWCUXPUWCUY
      SUWCUJOUYTCXJULZUTXKZVDZTXIUYONOUYMUVSUYNUXLVUITXIUYMUVQCAKJZCUVDBLJZLJZL
      JZUYRHUVQVUJCLJZVUKLJVUMUVOVUNUVPVUKLCVHOZUXFUVOVUNQCDXLZECAXMPUYIUWKUVPV
      UKQUYJDBCXNPXOVUJCVUKVUJUWFUXFVUJNOZUWHECAVCPZXBVUPVUKUVDBBUVBFVUOUVBUQOZ
      UWKVUOVUSSDCXPXQXRZVBZFXKZWQZXSXTUYMVUMUVLUYPCLJZBLJZLJZUYRHUYMVUMUVEVVEL
      JZVVFVUMNOUYMVUJVULVURVULCVUKUYTVVBXKZVDZTXIVVGNOUYMUVEVVEUVCUVDUVBNOUXFU
      VCNOUVBVUTVDEUVBAVCPZUVDVVAVDTZVVEVVDBUYPCVUDUYTXKZFXKZVDZTXIVVFNOUYMUVLV
      VEUVJUVKUVGUVIVUCUWRUVHUQOZUVINOUXMBAFEYAZBUVHVCPZTZUVKVUSUVKUJOVUTUVBXJU
      LZUGTZVVNTXIUUTVUMVVGHIUVMUUTVUMUYPUVCLJZVULLJZVVGHUUTVUQVWANOZVULNOZRVUL
      HIZSZYEVUJVWAHIZVUMVWBHIVUQVWCVWFVURUYPUVCVUEVVJTVWDVWEVVIVULVVHVEUOYBUUT
      MCHIZVWGUUTGGUBJZCHIZVWHUXGUWKUUTVWJYPVGDGCYCPMVWICHYDYFYGUWFUXFVWHVWGUWH
      ECAUUAUUBWGVUJVWAVULYHUUGVWBVVDUVCVUKLJZLJVVDUVEBLJZLJVVGUYPUVCCVUKUYPVUD
      WQZUVCVVJXBZVUPVVCYIVWLVWKVVDLUVCUVDBVWNUVDVVAWQUYJXSYJVVDUVEBVVDVVLWQUVE
      VVKXBUYJUUCYKYLXHUVMVVGVVFHIZUUTUVENOZUVLNOZVVENOZRVVEHIZSZYEUVMVWOVWPVWQ
      VWTVVKVVTVWRVWSVVNVVEVVMVEUOYBUVEUVLVVEYHYMUUDYNVVFUVLUYPBLJZCLJZLJZUYQUW
      ALJZUWCLJZUYRVVEVXBUVLLUYPCBVWMVUPUYJUUEYJVXEUVJVXALJZUVKCLJZLJVXCVXDVXFU
      WCVXGLUYQUVIBLJZLJVXDVXFVXHUWAUYQLBUVHGUBJZKJZVXHUWAUYIVVOVXJVXHQUYJVVPBU
      VHXMPVXIUVTBKBAGUYJAEWQZYOUUHYJYQYJUVGUYPUVIBUVGVUCXBVWMUVIVVQXBUYJYIYQUW
      KUWCVXGQDCUUFULXOUVJUVKVXACUVJVVRXBUVKVVSXLUYPBVWMUYJXCVUPYIYRUYQUWAUWCUY
      QVUFXBUYLUWCVUGXLZXSYKYLUUIUYRUYOHIZUYMUYQNOZUWPUYNNOZRUYNHIZSZYEUYQUVSHI
      VXMVXNUWPVXQVUFUXLVXOVXPVUIUYNVUHVEUOYBMUVFAUBJZKJZUYQUVSHUXRVUAUXFVXSUYQ
      QVIVUBEMUVFAUUJVOUXEUXSUVRVXRVJUFOZVXSUVSHIURUYAVXTUVRWKOVXRUVRHIUVRUXKYS
      AUVNLJZUVNUVNLJZVXRUVRHANOZUVNNOZVYDRUVNHIZSZYEAUVNHIVYAVYBHIVYCVYDVYFAEV
      DZUVNUXIUGZVYDVYEVYHUVNUXJVEUOYBAUVNVYGVYHAVYGUUKVTAUVNUVNYHPVXRAALJZAGLJ
      ZUBJVYAUVFVYIAVYJUBAVXKYTVYJAAVXKXEUULXOAAGVXKVXKYOUUMYRUVNUVNUXIXLYTUUNV
      XRUVRVXRUVFAVUBEYAYSUUOUUQMVXRUVRVNVOVPUYQUVSUYNYHPXIYNUVSUWAUWCUYKUYLVXL
      XSUURUUPYM $.
  $}

  $( Lemma for ~ faclbnd4 .  Use the weak deduction theorem to convert the
     hypotheses of ~ faclbnd4lem1 to antecedents.  (Contributed by NM,
     23-Dec-2005.) $)
  faclbnd4lem2 $p |- ( ( M e. NN0 /\ K e. NN0 /\ N e. NN ) ->
           ( ( ( ( N - 1 ) ^ K ) x. ( M ^ ( N - 1 ) ) ) <_
       ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` ( N - 1 ) ) ) ->
                   ( ( N ^ ( K + 1 ) ) x. ( M ^ N ) ) <_ ( ( (
  2 ^ ( ( K + 1 ) ^ 2 ) ) x. ( M ^ ( M + ( K + 1 ) ) ) ) x. ( ! ` N ) ) ) ) $=
    ( cn0 c1 co cexp cmul c2 caddc cfa cfv cle wbr oveq1 oveq2d oveq12d breq12d
    wi oveq1d wcel cn cmin cif wceq imbi12d oveq2 fveq2d fveq2 1nn faclbnd4lem1
    id elimel 1nn0 dedth3h ) BDUAZADUAZCUBUAZCEUCFZAGFZBUSGFZHFZIAIGFZGFZBBAJFZ
    GFZHFZUSKLZHFZMNZCAEJFZGFZBCGFZHFZIVKIGFZGFZBBVKJFZGFZHFZCKLZHFZMNZSUTUPBEU
    DZUSGFZHFZVDWCWCAJFZGFZHFZVHHFZMNZVLWCCGFZHFZVPWCWCVKJFZGFZHFZVTHFZMNZSUSUQ
    AEUDZGFZWDHFZIWRIGFZGFZWCWCWRJFZGFZHFZVHHFZMNZCWREJFZGFZWKHFZIXHIGFZGFZWCWC
    XHJFZGFZHFZVTHFZMNZSURCEUDZEUCFZWRGFZWCXSGFZHFZXEXSKLZHFZMNZXRXHGFZWCXRGFZH
    FZXOXRKLZHFZMNZSBACEEEBWCUEZVJWJWBWQYLVBWEVIWIMYLVAWDUTHBWCUSGOPYLVGWHVHHYL
    VFWGVDHYLBWCVEWFGYLULZBWCAJOQPTRYLVNWLWAWPMYLVMWKVLHBWCCGOPYLVSWOVTHYLVRWNV
    PHYLBWCVQWMGYMBWCVKJOQPTRUFAWRUEZWJXGWQXQYNWEWTWIXFMYNUTWSWDHAWRUSGUGTYNWHX
    EVHHYNVDXBWGXDHYNVCXAIGAWRIGOPYNWFXCWCGAWRWCJUGPQTRYNWLXJWPXPMYNVLXIWKHYNVK
    XHCGAWREJOZPTYNWOXOVTHYNVPXLWNXNHYNVOXKIGYNVKXHIGYOTPYNWMXMWCGYNVKXHWCJYOPP
    QTRUFCXRUEZXGYEXQYKYPWTYBXFYDMYPWSXTWDYAHYPUSXSWRGCXREUCOZTYPUSXSWCGYQPQYPV
    HYCXEHYPUSXSKYQUHPRYPXJYHXPYJMYPXIYFWKYGHCXRXHGOCXRWCGUGQYPVTYIXOHCXRKUIPRU
    FWRWCXRCEUBUJUMAEDUNUMBEDUNUMUKUO $.

  $( Lemma for ~ faclbnd4 .  The ` N = 0 ` case.  (Contributed by NM,
     23-Dec-2005.) $)
  faclbnd4lem3 $p |- ( ( ( M e. NN0
            /\ K e. NN0 ) /\ N = 0 ) -> ( ( N ^ K ) x. ( M ^ N ) )
       <_ ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` N ) ) ) $=
    ( cn0 wcel wa cc0 wceq cexp co cmul c2 caddc cle wbr adantl nn0expcl syl6eq
    c1 cn cfa cfv elnn0 0exp nnnn0 2nn0 mpan2 sylancr nn0addcl syldan nn0mulcld
    wo sylan2 nn0ge0d eqbrtrd 1nn 0nn0 sylancl nnexpcl mpdan oveq1 00id oveq12d
    id cc 0cn exp0 ax-mp syl6eqel jaoi sylbi nnmulcl nnge1d adantr oveq2 oveq2d
    wb sq0i 2cn breq12d mpbird jaodan sylan2b nn0cn exp0d mpan mulid1d sylan9eq
    nn0cnd 3brtr4d fveq2 fac0 ) BDEZADEZFZCGHZFCAIJZBCIJZKJZLALIJZIJZBBAMJZIJZK
    JZCUAUBZKJZNOZGAIJZBGIJZKJZXDSKJZNOZWOXLWPWOXHXDXJXKNWNWMATEZAGHZULXHXDNOZA
    UCWMXMXOXNWMXMFZXHGXDNXMXHGHWMAUDPXPXDXMWMWNXDDEAUEWOXAXCWNXADEZWMWNLDEZWTD
    EZXQUFWNXRXSUFALQUGLWTQUHPWMWNXBDEXCDEBAUIBXBQUJUKZUMUNUOWMXNFXOSSBBGMJZIJZ
    KJZNOZWMYDXNWMYCWMSTEYBTEZYCTEUPWMBTEZBGHZULYEBUCYFYEYGYFYADEZYEYFWMGDEZYHB
    UEUQBGUIURBYAUSUTYGYBSTYGYBGGIJZSYGBGYAGIYGVDYGYAGGMJGBGGMVAVBRVCGVEEYJSHVF
    GVGVHZRUPVIVJVKSYBVLUHVMVNXNXOYDVQWMXNXHSXDYCNXNXHYJSAGGIVOYKRXNXASXCYBKXNX
    ALGIJZSXNWTGLIAVRVPLVEEYLSHVSLVGVHRXNXBYABIAGBMVOVPVCVTPWAWBWCWMWNXJXHSKJXH
    WMXISXHKWMBBWDWEVPWNXHWNXHYIWNXHDEUQGAQWFWIWGWHWOXDWOXDXTWIWGWJVNWPXGXLVQWO
    WPWSXJXFXKNWPWQXHWRXIKCGAIVACGBIVOVCWPXESXDKWPXEGUAUBSCGUAWKWLRVPVTPWA $.

  ${
    $d j m n M $.  $d j m n K $.  $d j n N $.
    $( Lemma for ~ faclbnd4 .  Prove the ` 0 < N ` case by induction on
       ` K ` .  (Contributed by NM, 19-Dec-2005.) $)
    faclbnd4lem4 $p |- ( ( N e. NN /\ K e. NN0 /\ M e. NN0 ) ->
                   ( ( N ^ K ) x. ( M ^ N ) ) <_
              ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` N ) ) ) $=
      ( vn cn wcel cexp co cmul c2 caddc cle wbr wa c1 wceq oveq2 oveq2d oveq1d
      cc0 vm vj cn0 cfa cfv cv wral wi oveq1 oveq12d fveq2 breq12d cbvralv cmin
      clt wo cr nnre 1re lelttric sylancl ancli andi sylib nnge1 adantr biimpar
      wb letri3 anassrs mpdan 1m1e0 syl6eq syl faclbnd4lem3 sylan2 a1d 1nn mpan
      nnsub biimpa rspcv adantl jaodan faclbnd4lem2 3expa syld ralrimdva syl5bi
      expcom a2d nnnn0 faclbnd3 nncn exp0d nn0cn expcl syl2an mulid2d eqtrd sq0
      oveq2i 2cn exp0 ax-mp eqtri a1i addid1d mpancom 3brtr4d ralrimiva ralbidv
      cc imbi2d nn0indALT imp rspcva 3impb ) CEFZAUCFZBUCFZCAGHZBCGHZIHZJAJGHZG
      HZBBAKHZGHZIHZCUDUEZIHZLMZXTYANXSDUFZAGHZBYMGHZIHZYIYMUDUEZIHZLMZDEUGZYLX
      TYAYTYAYMUAUFZGHZYOIHZJUUAJGHZGHZBBUUAKHZGHZIHZYQIHZLMZDEUGZUHYAYMTGHZYOI
      HZJTJGHZGHZBBTKHZGHZIHZYQIHZLMZDEUGZUHYAYMUBUFZGHZYOIHZJUVBJGHZGHZBBUVBKH
      ZGHZIHZYQIHZLMZDEUGZUHYAYMUVBOKHZGHZYOIHZJUVMJGHZGHZBBUVMKHZGHZIHZYQIHZLM
      ZDEUGZUHYAYTUHUAUBAUVBUCFZYAUVLUWCYAUWDUVLUWCUHUVLUUAUVBGHZBUUAGHZIHZUVIU
      UAUDUEZIHZLMZUAEUGZYAUWDNZUWCUVKUWJDUAEYMUUAPZUVDUWGUVJUWILUWMUVCUWEYOUWF
      IYMUUAUVBGUIYMUUABGQUJUWMYQUWHUVIIYMUUAUDUKRULUMUWLUWKUWBDEUWLYMEFZNUWKYM
      OUNHZUVBGHZBUWOGHZIHZUVIUWOUDUEZIHZLMZUWBUWNUWLUWNYMOLMZNZUWNOYMUOMZNZUPZ
      UWKUXAUHZUWNUWNUXBUXDUPZNUXFUWNUXHUWNYMUQFZOUQFZUXHYMURZUSYMOUTVAVBUWNUXB
      UXDVCVDUWLUXCUXGUXEUWLUXCNUXAUWKUXCUWLUWOTPZUXAUXCYMOPZUXLUXCOYMLMZUXMUWN
      UXNUXBYMVEVFUWNUXBUXNUXMUWNUXMUXBUXNNZUWNUXIUXJUXMUXOVHUXKUSYMOVIVAVGVJVK
      UXMUWOOOUNHTYMOOUNUIVLVMVNUVBBUWOVOVPVQUXEUXGUWLUXEUWOEFZUXGUWNUXDUXPOEFU
      WNUXDUXPVHVROYMVTVSWAUWJUXAUAUWOEUUAUWOPZUWGUWRUWIUWTLUXQUWEUWPUWFUWQIUUA
      UWOUVBGUIUUAUWOBGQUJUXQUWHUWSUVIIUUAUWOUDUKRULWBVNWCWDVPYAUWDUWNUXAUWBUHU
      VBBYMWEWFWGWHWIWJWKYAUUTDEYAUWNNZYOBBGHZYQIHZUUMUUSLUWNYAYMUCFZYOUXTLMYMW
      LZBYMWMVPUXRUUMOYOIHZYOUWNUUMUYCPYAUWNUULOYOIUWNYMYMWNWOSWCUXRYOYABXMFZUY
      AYOXMFUWNBWPZUYBBYMWQWRWSWTYAUUSUXTPUWNYAUURUXSYQIYAUUROUXSIHUXSYAUUOOUUQ
      UXSIUUOOPYAUUOJTGHZOUUNTJGXAXBJXMFUYFOPXCJXDXEXFXGYAUUPBBGYABUYEXHRUJYAUX
      SUYDYAUXSXMFUYEBBWQXIWSWTSVFXJXKUUATPZUUKUVAYAUYGUUJUUTDEUYGUUCUUMUUIUUSL
      UYGUUBUULYOIUUATYMGQSUYGUUHUURYQIUYGUUEUUOUUGUUQIUYGUUDUUNJGUUATJGUIRUYGU
      UFUUPBGUUATBKQRUJSULXLXNUUAUVBPZUUKUVLYAUYHUUJUVKDEUYHUUCUVDUUIUVJLUYHUUB
      UVCYOIUUAUVBYMGQSUYHUUHUVIYQIUYHUUEUVFUUGUVHIUYHUUDUVEJGUUAUVBJGUIRUYHUUF
      UVGBGUUAUVBBKQRUJSULXLXNUUAUVMPZUUKUWCYAUYIUUJUWBDEUYIUUCUVOUUIUWALUYIUUB
      UVNYOIUUAUVMYMGQSUYIUUHUVTYQIUYIUUEUVQUUGUVSIUYIUUDUVPJGUUAUVMJGUIRUYIUUF
      UVRBGUUAUVMBKQRUJSULXLXNUUAAPZUUKYTYAUYJUUJYSDEUYJUUCYPUUIYRLUYJUUBYNYOIU
      UAAYMGQSUYJUUHYIYQIUYJUUEYFUUGYHIUYJUUDYEJGUUAAJGUIRUYJUUFYGBGUUAABKQRUJS
      ULXLXNXOXPYSYLDCEYMCPZYPYDYRYKLUYKYNYBYOYCIYMCAGUIYMCBGQUJUYKYQYJYIIYMCUD
      UKRULXQVPXR $.
  $}

  $( Variant of ~ faclbnd5 providing a non-strict lower bound.  (Contributed by
     NM, 23-Dec-2005.) $)
  faclbnd4 $p |- ( ( N e. NN0 /\ K e. NN0 /\ M e. NN0 ) ->
                 ( ( N ^ K ) x. ( M ^ N ) ) <_
            ( ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) x. ( ! ` N ) ) ) $=
    ( cn0 wcel cexp co cmul c2 caddc cfa cfv cle wbr wa cn cc0 wceq wo 3com13
    elnn0 faclbnd4lem4 3expa faclbnd4lem3 jaodan sylan2b 3impa ) BDEZADEZCDEZCA
    FGBCFGHGIAIFGFGBBAJGFGHGCKLHGMNZUHUIUJUKUJUHUIOZCPEZCQRZSUKCUAULUMUKUNUHUIU
    MUKUMUIUHUKABCUBTUCABCUDUEUFUGT $.

  $( The factorial function grows faster than powers and exponentiations.  If
     we consider ` K ` and ` M ` to be constants, the right-hand side of the
     inequality is a constant times ` N ` -factorial.  (Contributed by NM,
     24-Dec-2005.) $)
  faclbnd5 $p |- ( ( N e. NN0 /\ K e. NN0 /\ M e. NN ) ->
                 ( ( N ^ K ) x. ( M ^ N ) ) <
      ( ( 2 x. ( ( 2 ^ ( K ^ 2 ) ) x. ( M ^ ( M + K ) ) ) ) x. ( ! ` N ) ) ) $=
    ( cn0 wcel cn cexp co cmul c2 clt wa cr reexpcl sylan ancoms remulcl syl2an
    wbr cc caddc cfa cfv nn0re nnre anandirs 2nn nn0expcl mpan2 nnexpcl sylancr
    2nn0 nnnn0 nn0addcl sylan2 anabss7 nnmulcl anabss5 nnred faccl 2re faclbnd4
    cle syl3an3 3coml 3expa c1 1lt2 cc0 nngt0d ltmulgt12 mp3an2 syl2anc lelttrd
    wb mpbii wceq nncnd 2cn mulass mp3an1 breqtrrd 3impa 3comr ) ADEZBFEZCDEZCA
    GHZBCGHZIHZJJAJGHZGHZBBAUAHZGHZIHZIHCUBUCZIHZKSZWEWFWGWRWEWFLZWGLZWJJWOWPIH
    ZIHZWQKWTWJXAXBWEWFWGWJMEZWEWGLWHMEZWIMEZXCWFWGLWGWEXDWGCMEWEXDCUDCANOPWFBM
    EWGXEBUEBCNOWHWIQRUFWSWOMEWPMEXAMEZWGWSWOWEWFWOFEZWEWLFEZWNFEZXGWSWEJFEWKDE
    ZXHUGWEJDEXJULAJUHUIJWKUJUKWEWFXIWSWFWMDEZXIWFWEBDEZXKBUMZXLWEXKBAUNPUOBWMU
    JUOUPWLWNUQRURZUSWGWPCUTZUSWOWPQRZWTJMEZXFXBMEVAXPJXAQUKWEWFWGWJXAVCSZWGWEW
    FXRWFWGWEXLXRXMABCVBVDVEVFWTVGJKSZXAXBKSZVHWTXFVIXAKSZXSXTVOZXPWTXAWSXGWPFE
    XAFEWGXNXOWOWPUQRVJXFXQYAYBVAXAJVKVLVMVPVNWSWOTEZWPTEZWQXBVQZWGWSWOXNVRWGWP
    XOVRJTEYCYDYEVSJWOWPVTWARWBWCWD $.

  ${
    $d M m $.  $d N k m $.
    $( Geometric lower bound for the factorial function, where N is usually
       held constant.  (Contributed by Paul Chapman, 28-Dec-2007.) $)
    faclbnd6 $p |- ( ( N e. NN0 /\ M e. NN0 ) ->
             ( ( ! ` N ) x. ( ( N + 1 ) ^ M ) ) <_ ( ! ` ( N + M ) ) ) $=
      ( wcel cfa cfv c1 caddc co cexp cmul cle wbr cc0 wceq oveq2 oveq2d adantr
      wi wa cr vm vk cn0 cv fveq2d breq12d imbi2d faccl nnred leidd cc peano2cn
      weq nn0cn syl exp0d nncnd mulid1d eqtrd addid1d 3brtr4d peano2nn0 reexpcl
      nn0red sylan remulcld cn nnnn0 nn0ge0d simpr expge0d mulge0d jca nn0addcl
      nn0re readdcl syl2an jca31 nn0ge0 adantl 0re leadd2 mp3an1 mpbid eqbrtrrd
      syl2anc 1re leadd1 mp3an3 ax-1cn addass breqtrd lemul12a sylc expp1 expcl
      wb mulassd eqtr4d facp1 3eqtr3d ex expcom a2d nn0ind impcom ) AUCCBUCCZBD
      EZBFGHZAIHZJHZBAGHZDEZKLZXGXHXIUAUDZIHZJHZBXOGHZDEZKLZRXGXHXIMIHZJHZBMGHZ
      DEZKLZRXGXHXIUBUDZIHZJHZBYFGHZDEZKLZRXGXHXIYFFGHZIHZJHZBYLGHZDEZKLZRXGXNR
      UAUBAXOMNZXTYEXGYRXQYBXSYDKYRXPYAXHJXOMXIIOPYRXRYCDXOMBGOUEUFUGUAUBUMZXTY
      KXGYSXQYHXSYJKYSXPYGXHJXOYFXIIOPYSXRYIDXOYFBGOUEUFUGXOYLNZXTYQXGYTXQYNXSY
      PKYTXPYMXHJXOYLXIIOPYTXRYODXOYLBGOUEUFUGXOANZXTXNXGUUAXQXKXSXMKUUAXPXJXHJ
      XOAXIIOPUUAXRXLDXOABGOUEUFUGXGXHXHYBYDKXGXHXGXHBUHZUIZUJXGYBXHFJHXHXGYAFX
      HJXGXIXGBUKCZXIUKCZBUNZBULUOZUPPXGXHXGXHUUBUQZURUSXGYCBDXGBUUFUTZUEVAYFUC
      CZXGYKYQXGUUJYKYQRXGUUJSZYKYQUUKYKSZYHXIJHZYJYOJHZYNYPKUULYHTCZMYHKLZSZYJ
      TCZSXITCZMXIKLZSYOTCZSZSZYKXIYOKLZSUUMUUNKLUUKUVCYKUUKUUQUURUVBUUKUUOUUPU
      UKXHYGXGXHTCUUJUUCQZXGUUSUUJYGTCXGXIBVBZVDZXIYFVCVEZVFUUKXHYGUVEUVHXGMXHK
      LZUUJXGXHVGCZUVIUUBUVJXHXHVHVIUOQUUKXIYFXGUUSUUJUVGQZXGUUJVJXGUUTUUJXGXIU
      VFVIQZVKVLVMUUKYJUUKYIUCCZYJVGCBYFVNZYIUHUOUIUUKUUSUUTUVAUVKUVLXGBTCZYLTC
      UVAUUJBVOZUUJYLYFVBVDBYLVPVQVRVRQUULYKUVDUUKYKVJUUKUVDYKUUKXIYIFGHZYOKUUK
      BYIKLZXIUVQKLZUUKYCBYIKXGYCBNUUJUUIQUUKMYFKLZYCYIKLZUUJUVTXGYFVSVTUUKYFTC
      ZUVOUVTUWAWQZUUJUWBXGYFVOVTXGUVOUUJUVPQZMTCUWBUVOUWCWAMYFBWBWCWFWDWEUUKUV
      OYITCZUVRUVSWQZUWDUUKYIUVNVDUVOUWEFTCUWFWGBYIFWHWIWFWDXGUUDYFUKCZUVQYONZU
      UJUUFYFUNUUDUWGFUKCUWHWJBYFFWKWIVQZWLQVMYHYJXIYOWMWNUUKYNUUMNYKUUKYNXHYGX
      IJHZJHUUMUUKYMUWJXHJXGUUEUUJYMUWJNUUGXIYFWOVEPUUKXHYGXIXGXHUKCUUJUUHQXGUU
      EUUJYGUKCUUGXIYFWPVEXGUUEUUJUUGQWRWSQUUKYPUUNNYKUUKUVQDEZYJUVQJHZYPUUNUUK
      UVMUWKUWLNUVNYIWTUOUUKUVQYODUWIUEUUKUVQYOYJJUWIPXAQVAXBXCXDXEXF $.

    $( An upper bound for the factorial function.  (Contributed by Mario
       Carneiro, 15-Apr-2016.) $)
    facubnd $p |- ( N e. NN0 -> ( ! ` N ) <_ ( N ^ N ) ) $=
      ( vm vk cv cfa cfv cexp co cle wbr c1 cc0 wceq fveq2 oveq12d wcel breq12d
      id adantr cr caddc fac0 syl6eq cc 0cn exp0 ax-mp 1le1 wa cmul faccl nnred
      cn nn0re simpl reexpcld nn0p1nn simpr nn0ge0 lep1d leexp1a syl32anc letrd
      cn0 wb nngt0d lemul1 syl112anc mpbid facp1 nncnd expp1d 3brtr4d ex nn0ind
      clt ) BDZEFZVQVQGHZIJKKIJCDZEFZVTVTGHZIJZVTKUAHZEFZWDWDGHZIJZAEFZAAGHZIJB
      CAVQLMZVRKVSKIWJVRLEFKVQLENUBUCWJVSLLGHZKWJVQLVQLGWJRZWLOLUDPWKKMUELUFUGU
      CQVQVTMZVRWAVSWBIVQVTENWMVQVTVQVTGWMRZWNOQVQWDMZVRWEVSWFIVQWDENWOVQWDVQWD
      GWORZWPOQVQAMZVRWHVSWIIVQAENWQVQAVQAGWQRZWROQUHVTVDPZWCWGWSWCUIZWAWDUJHZW
      DVTGHZWDUJHZWEWFIWTWAXBIJZXAXCIJZWTWAWBXBWTWAWSWAUMPWCVTUKSULZWTVTVTWSVTT
      PZWCVTUNSZWSWCUOZUPWTWDVTWTWDWSWDUMPWCVTUQSZULZXIUPZWSWCURWTXGWDTPZWSLVTI
      JZVTWDIJWBXBIJXHXKXIWSXNWCVTUSSWTVTXHUTVTWDVTVAVBVCWTWATPXBTPXMLWDVPJXDXE
      VEXFXLXKWTWDXJVFWAXBWDVGVHVIWSWEXAMWCVTVJSWTWDVTWTWDXJVKXIVLVMVNVO $.
  $}

  $( The product of two factorials is greater than or equal to the factorial of
     (the floor of) their average.  (Contributed by NM, 9-Dec-2005.) $)
  facavg $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
       ( ! ` ( |_ ` ( ( M + N ) / 2 ) ) ) <_ ( ( ! ` M ) x. ( ! ` N ) ) ) $=
    ( cn0 wcel wa co cle wbr cfv cfa cmul cr syl adantr letr syl3anc cc0 adantl
    wi c1 caddc c2 cdiv cfl nn0addcl nn0red rehalfcld flle reflcl nn0re nn0ge0d
    mpand halfnneg2 mpbid flge0nn0 syl2anc simpl facwordi 3exp sylc faccl nncnd
    wb mulid1d nnred nnnn0d jca nnge1d 1re lemul2a mp3anl1 syl21anc eqbrtrrd cn
    wceq remulcl syl2an mpan2d 3syld simpr mulid2d lemul1a wo avgle mpjaod ) AC
    DZBCDZEZABUAFZUBUCFZAGHZWJUDIZJIZAJIZBJIZKFZGHZWJBGHZWHWKWLAGHZWMWNGHZWQWHW
    LWJGHZWKWSWHWJLDZXAWHWIWHWIABUEZUFZUGZWJUHMZWHWLLDZXBALDZXAWKEWSSWHXBXGXEWJ
    UIMZXEWFXHWGAUJZNWLWJAOPULWHWLCDZWFWSWTSWHXBQWJGHZXKXEWHQWIGHZXLWHWIXCUKWHW
    ILDXMXLVCXDWIUMMUNWJUOUPZWFWGUQXKWFWSWTWLAURUSUTWHWTWNWPGHZWQWHWNTKFZWNWPGW
    FXPWNVOWGWFWNWFWNAVAZVBVDNWHWOLDZWNLDZQWNGHZEZTWOGHZXPWPGHZWGXRWFWGWOBVAZVE
    ZRZWFYAWGWFXSXTWFWNXQVEZWFWNWFWNXQVFUKVGNWGYBWFWGWOYDVHRTLDZXRYAYBYCVITWOWN
    VJVKVLVMWHWMLDZXSWPLDZWTXOEWQSWHWMWHXKWMVNDXNWLVAMVEZWFXSWGYGNZWFXSXRYJWGYG
    YEWNWOVPVQZWMWNWPOPVRVSWHWRWLBGHZWMWOGHZWQWHXAWRYNXFWHXGXBBLDZXAWREYNSXIXEW
    GYPWFBUJZRWLWJBOPULWHXKWGYNYOSXNWFWGVTXKWGYNYOWLBURUSUTWHYOWOWPGHZWQWHTWOKF
    ZWOWPGWGYSWOVOWFWGWOWGWOYDVBWARWHXSXRQWOGHZEZTWNGHZYSWPGHZYLWGUUAWFWGXRYTYE
    WGWOWGWOYDVFUKVGRWFUUBWGWFWNXQVHNYHXSUUAUUBUUCVITWNWOWBVKVLVMWHYIXRYJYOYREW
    QSYKYFYMWMWOWPOPVRVSWFXHYPWKWRWCWGXJYQABWDVQWE $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The binomial coefficient operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c _C $. $( Binomial coefficient operation. $)

  $( Extend class notation to include the binomial coefficient operation
     (combinatorial choose operation). $)
  cbc $a class _C $.

  ${
    $d n k m $.
    $( Define the binomial coefficient operation.  In the literature, this
       function is often written as a column vector of the two arguments, or
       with the arguments as subscripts before and after the letter "C".
       ` ( N _C K ) ` is read " ` N ` choose ` K ` ."  Definition of binomial
       coefficient in [Gleason] p. 295.  As suggested by Gleason, we define it
       to be 0 when ` 0 <_ k <_ n ` does not hold.  (Contributed by NM,
       10-Jul-2005.) $)
    df-bc $a |- _C = ( n e. NN0 , k e. ZZ |-> if ( k e. ( 0 ... n ) ,
                ( ( ! ` n ) / ( ( ! ` ( n - k ) ) x. ( ! ` k ) ) ) , 0 ) ) $.
  $}

  ${
    $d n k m N $.  $d n k m K $.
    $( Value of the binomial coefficient, ` N ` choose ` K ` .  Definition of
       binomial coefficient in [Gleason] p. 295.  As suggested by Gleason, we
       define it to be 0 when ` 0 <_ K <_ N ` does not hold.  See ~ bcval2 for
       the value in the standard domain.  (Contributed by NM, 10-Jul-2005.)
       (Revised by Mario Carneiro, 7-Nov-2013.) $)
    bcval $p |- ( ( N e. NN0 /\ K e. ZZ ) -> ( N _C K ) = if ( K e. ( 0 ... N )
      , ( ( ! ` N ) / ( ( ! ` ( N - K ) ) x. ( ! ` K ) ) ) , 0 ) ) $=
      ( vn vk cv cc0 cfz co wcel cfa cfv cmin cmul cdiv wceq oveq2 fveq2 fveq2d
      cif oveq12d cn0 cz eleq2d oveq1 oveq1d eqidd ifbieq12d eleq1 oveq2d df-bc
      cbc ovex c0ex ifex ovmpt2 ) CDBAUAUBDEZFCEZGHZIZUQJKZUQUPLHZJKZUPJKZMHZNH
      ZFSAFBGHZIZBJKZBALHZJKZAJKZMHZNHZFSUKUPVFIZVHBUPLHZJKZVCMHZNHZFSUQBOZUSVN
      VEFVRFVSURVFUPUQBFGPUCVSUTVHVDVQNUQBJQVSVBVPVCMVSVAVOJUQBUPLUDRUETVSFUFUG
      UPAOZVNVGVRFVMFUPAVFUHVTVQVLVHNVTVPVJVCVKMVTVOVIJUPABLPRUPAJQTUIVTFUFUGDC
      UJVGVMFVHVLNULUMUNUO $.

    $( Value of the binomial coefficient, ` N ` choose ` K ` , in its standard
       domain.  (Contributed by NM, 9-Jun-2005.)  (Revised by Mario Carneiro,
       7-Nov-2013.) $)
    bcval2 $p |- ( K e. ( 0 ... N ) -> ( N _C K ) =
                    ( ( ! ` N ) / ( ( ! ` ( N - K ) ) x. ( ! ` K ) ) ) ) $=
      ( cc0 cfz co wcel cbc cfa cfv cmin cmul cdiv cif cz wceq elfz3nn0 elfzelz
      cn0 bcval syl2anc iftrue eqtrd ) ACBDEFZBAGEZUCBHIBAJEHIAHIKELEZCMZUEUCBR
      FANFUDUFOABPACBQABSTUCUECUAUB $.

    $( Value of the binomial coefficient, ` N ` choose ` K ` , outside of its
       standard domain.  Remark in [Gleason] p. 295.  (Contributed by NM,
       14-Jul-2005.)  (Revised by Mario Carneiro, 8-Nov-2013.) $)
    bcval3 $p |- ( ( N e. NN0 /\ K e. ZZ /\ -. K e. ( 0 ... N ) ) ->
          ( N _C K ) = 0 ) $=
      ( cn0 wcel cz cc0 cfz co wn w3a cbc cfa cfv cmin cmul cdiv cif wceq bcval
      3adant3 iffalse 3ad2ant3 eqtrd ) BCDZAEDZAFBGHDZIZJBAKHZUFBLMBANHLMALMOHP
      HZFQZFUDUEUHUJRUGABSTUGUDUJFRUEUFUIFUAUBUC $.

    $( Value of the binomial coefficient, ` N ` choose ` K ` , outside of its
       standard domain.  Remark in [Gleason] p. 295.  (Contributed by NM,
       14-Jul-2005.)  (Revised by Mario Carneiro, 7-Nov-2013.) $)
    bcval4 $p |- ( ( N e. NN0 /\ K e. ZZ /\ ( K < 0 \/ N < K ) ) ->
          ( N _C K ) = 0 ) $=
      ( cn0 wcel cz cc0 clt wbr wo cfz co wn cbc wa cle cr lenlt mpbid adantl
      wb wceq elfzle1 elfzelz zred sylancr elfzle2 nn0re syl2anr ioran sylanbrc
      wi 0re ex adantr con2d 3impia bcval3 syld3an3 ) BCDZAEDZAFGHZBAGHZIZAFBJK
      DZLZBAMKFUAUSUTVCVEUSUTNVDVCUSVDVCLZUKUTUSVDVFUSVDNZVALZVBLZVFVDVHUSVDFAO
      HZVHAFBUBVDFPDAPDZVJVHTULVDAAFBUCUDZFAQUERSVGABOHZVIVDVMUSAFBUFSVDVKBPDVM
      VITUSVLBUGABQUHRVAVBUIUJUMUNUOUPABUQUR $.
  $}

  $( Closure of the binomial coefficient in the positive reals.  (This is
     mostly a lemma before we have ~ bccl2 .)  (Contributed by Mario Carneiro,
     10-Mar-2014.) $)
  bcrpcl $p |- ( K e. ( 0 ... N ) -> ( N _C K ) e. RR+ ) $=
    ( cc0 cfz co wcel cbc cfa cfv cmin cmul cdiv crp bcval2 cn cn0 faccl syl2an
    syl2anc nnrp elfz3nn0 syl fznn0sub elfznn0 nnmulcl rpdivcl eqeltrd ) ACBDEF
    ZBAGEBHIZBAJEZHIZAHIZKEZLEZMABNUHUIOFZUMOFZUNMFZUHBPFUOABUABQUBUHUJPFZAPFZU
    PACBUCABUDURUKOFULOFUPUSUJQAQUKULUERSUOUIMFUMMFUQUPUITUMTUIUMUFRSUG $.

  $( "Complementing" its second argument doesn't change a binary coefficient.
     (Contributed by NM, 21-Jun-2005.)  (Revised by Mario Carneiro,
     5-Mar-2014.) $)
  bccmpl $p |- ( ( N e. NN0 /\ K e. ZZ ) -> ( N _C K ) =
                    ( N _C ( N - K ) ) ) $=
    ( cn0 wcel cz cc0 co cbc cmin wceq cfa cfv cmul cdiv bcval2 fznn0sub2 cc cn
    syl eqtr4d cfz elfznn0 faccl nncnd mulcomd elfz3nn0 elfzelz nn0cn zcn nncan
    wa syl2an syl2anc fveq2d oveq1d oveq2d adantl w3a bcval3 simp1 zsubcl sylan
    wn nn0z 3adant3 eleq1d syl5ib con3d 3impia syl3anc 3expa pm2.61dan ) BCDZAE
    DZUKZAFBUAGZDZBAHGZBBAIGZHGZJZVQWAVOVQVRBKLZVSKLZAKLZMGZNGZVTABOVQVTWBBVSIG
    ZKLZWCMGZNGZWFVQVSVPDZVTWJJABPZVSBOSVQWEWIWBNVQWEWDWCMGWIVQWCWDVQWKWCQDWLWK
    WCWKVSCDWCRDVSBUBVSUCSUDSVQWDVQACDWDRDABUBAUCSUDUEVQWHWDWCMVQWGAKVQVMVNWGAJ
    ZABUFAFBUGVMBQDAQDWMVNBUHAUIBAUJULZUMUNUOTUPTTUQVMVNVQVCZWAVMVNWOURZVRFVTAB
    USWPVMVSEDZWKVCZVTFJVMVNWOUTVMVNWQWOVMBEDVNWQBVDBAVAVBVEVMVNWOWRVOWKVQWKWGV
    PDVOVQVSBPVOWGAVPWNVFVGVHVIVSBUSVJTVKVL $.

  $( ` N ` choose 0 is 1.  Remark in [Gleason] p. 296.  (Contributed by NM,
     17-Jun-2005.)  (Revised by Mario Carneiro, 8-Nov-2013.) $)
  bcn0 $p |- ( N e. NN0 -> ( N _C 0 ) = 1 ) $=
    ( cn0 wcel cc0 cbc co cfa cfv cmin cmul cdiv c1 cfz wceq cuz eluzfz1 eleq2s
    nn0uz bcval2 eqtrd syl nn0cn subid1d fveq2d fac0 oveq12 sylancl faccl nncnd
    mulid1d oveq2d facne0 dividd ) ABCZADEFZAGHZADIFZGHZDGHZJFZKFZLUNDDAMFCZUOV
    ANVBADOHBDAPRQDASUAUNVAUPUPKFLUNUTUPUPKUNUTUPLJFZUPUNURUPNUSLNUTVCNUNUQAGUN
    AAUBUCUDUEURUPUSLJUFUGUNUPUNUPAUHUIZUJTUKUNUPVDAULUMTT $.

  $( The binomial coefficient " 0 choose ` K ` " is 0 for a positive integer K.
     Note that ` ( 0 _C 0 ) = 1 ` (see ~ bcn0 ).  (Contributed by Alexander van
     der Vekens, 1-Jan-2018.) $)
  bc0k $p |- ( K e. NN -> ( 0 _C K ) = 0 ) $=
    ( cn wcel cc0 cn0 cz clt wbr wo cbc co wceq 0nn0 a1i nnz nngt0 olcd syl3anc
    bcval4 ) ABCZDECZAFCADGHZDAGHZIDAJKDLUATMNAOTUCUBAPQADSR $.

  $( ` N ` choose ` N ` is 1.  Remark in [Gleason] p. 296.  (Contributed by NM,
     17-Jun-2005.)  (Revised by Mario Carneiro, 8-Nov-2013.) $)
  bcnn $p |- ( N e. NN0 -> ( N _C N ) = 1 ) $=
    ( cn0 wcel cc0 co cmin c1 cz wceq 0z bccmpl mpan2 bcn0 nn0cn subid1d oveq2d
    cbc 3eqtr3rd ) ABCZADQEZAADFEZQEZGAAQESDHCTUBIJDAKLAMSUAAAQSAANOPR $.

  $( Binomial coefficient: ` N ` choose ` 1 ` .  (Contributed by NM,
     21-Jun-2005.)  (Revised by Mario Carneiro, 8-Nov-2013.) $)
  bcn1 $p |- ( N e. NN0 -> ( N _C 1 ) = N ) $=
    ( cn0 wcel cn cc0 wceq wo c1 cbc co elnn0 cfa cfv cmin cmul cuz syl clt wbr
    cdiv cfz 1nn0 eleqtri a1i elnnuz biimpi elfzuzb sylanbrc bcval2 facnn2 fac1
    nn0uz oveq2i nnm1nn0 faccl nncnd mulid1d syl5eq nncn nnne0d divcan3d 3eqtrd
    oveq12d cz 0nn0 1z 0lt1 olci bcval4 mp3an oveq1 eqeq12 mpancom mpbiri sylbi
    wb jaoi ) ABCADCZAEFZGAHIJZAFZAKVRWAVSVRVTALMZAHNJZLMZHLMZOJZTJZWDAOJZWDTJA
    VRHEAUAJCZVTWGFVRHEPMZCZAHPMCZWIWKVRHBWJUBULUCUDVRWLAUEUFHEAUGUHHAUIQVRWBWH
    WFWDTAUJVRWFWDHOJWDWEHWDOUKUMVRWDVRWDVRWCBCWDDCAUNWCUOQZUPZUQURVCVRAWDAUSWN
    VRWDWMUTVAVBVSWAEHIJZEFZEBCHVDCHERSZEHRSZGWPVEVFWRWQVGVHHEVIVJVTWOFVSWAWPVP
    AEHIVKVTWOAEVLVMVNVQVO $.

  $( Binomial coefficient: ` N + 1 ` choose ` N ` .  (Contributed by NM,
     20-Jun-2005.)  (Revised by Mario Carneiro, 8-Nov-2013.) $)
  bcnp1n $p |- ( N e. NN0 -> ( ( N + 1 ) _C N ) = ( N + 1 ) ) $=
    ( cn0 wcel c1 caddc co cbc cmin cz wceq peano2nn0 nn0z bccmpl syl2anc nn0cn
    cc ax-1cn pncan2 sylancl oveq2d bcn1 syl 3eqtrd ) ABCZADEFZAGFZUEUEAHFZGFZU
    EDGFZUEUDUEBCZAICUFUHJAKZALAUEMNUDUGDUEGUDAPCDPCUGDJAOQADRSTUDUJUIUEJUKUEUA
    UBUC $.

  $( The proportion of one binomial coefficient to another with ` K ` decreased
     by 1.  (Contributed by Mario Carneiro, 10-Mar-2014.) $)
  bcm1k $p |- ( K e. ( 1 ... N ) -> ( N _C K ) =
                ( ( N _C ( K - 1 ) ) x. ( ( N - ( K - 1 ) ) / K ) ) ) $=
    ( c1 cfz co wcel cfa cfv cmin cmul cdiv cc cc0 wceq cn0 cn faccl syl nncnd
    cz cbc caddc wne cuz elfzuz2 nnuz syl6eleqr nnnn0d fznn0sub nn0p1nn nnm1nn0
    wa elfznn 3syl nnmulcld nncn nnne0 nnne0d divmuldiv syl22anc elfzel2 ax-1cn
    jca subsubd fveq2d oveq1d oveq2d oveq12d facp1 eqcomd facnn2 mul32d mulassd
    a1i 3eqtr4d mulcomd divcan5d 3eqtrrd 0p1e1 oveq1i wss fzp1ss ax-mp eqsstr3i
    zcnd 0z sseli bcval2 npcan sylancl peano2zm uzid peano2uz eqeltrrd fzss2 wb
    4syl elfzelz elfzm1b syl2anc ibi sseldd ) ACBDEZFZBGHZBAIEZGHZAGHZJEZKEZXEB
    ACIEZIEZGHZXKGHZJEZKEZXLAKEZJEZBAUAEZBXKUAEZXQJEXDXRXEXFCUBEZJEZXIYAJEZKEZY
    AXEJEZYAXIJEZKEXJXDXEYAGHZXNJEZKEZYAAKEZJEZYBYHAJEZKEZXRYDXDXELFYALFYHLFZYH
    MUCZULZALFZAMUCZULYKYMNXDXEXDBOFXEPFXDBXDBCUDHPACBUEUFUGUHBQRSZXDYAXDXFOFZY
    APFACBUIZXFUJRZSZXDYHPFZYPXDYGXNXDYAOFYGPFXDYAUUBUHYAQRZXDAPFZXKOFXNPFABUMZ
    AUKXKQUNZUOUUDYNYOYHUPYHUQVCRXDYQYRXDAUUGSZXDAUUGURVCXEYAYHAUSUTXDXPYIXQYJJ
    XDXOYHXEKXDXMYGXNJXDXLYAGXDBACXDBACBVAZWEZUUICLFZXDVBVNVDZVEVFVGXDXLYAAKUUM
    VFVHXDYCYLYBKXDXGYAJEZXHJEYGXNAJEZJEYCYLXDUUNYGXHUUOJXDYGUUNXDYTYGUUNNUUAXF
    VIRVJXDUUFXHUUONUUGAVKRVHXDXGXHYAXDXGXDYTXGPFUUAXFQRZSXDXHXDAOFXHPFXDAUUGUH
    AQRZSUUCVLXDYGXNAXDYGUUESXDXNUUHSUUIVMVOVGVOXDYBYEYCYFKXDXEYAYSUUCVPXDXIYAX
    DXIXDXGXHUUPUUQUOZSZUUCVPVHXDXEXIYAYSUUSUUCXDXIUURURXDYAUUBURVQVRXDAMBDEZFX
    SXJNXCUUTAXCMCUBEZBDEZUUTUVACBDVSVTMTFUVBUUTWAWFMBWBWCWDWGABWHRXDXTXPXQJXDX
    KUUTFXTXPNXDMBCIEZDEZUUTXKXDBUVCUDHZFUVDUUTWAXDUVCCUBEZBUVEXDBLFUULUVFBNUUK
    VBBCWIWJXDBTFZUVCTFUVCUVEFUVFUVEFUUJBWKUVCWLUVCUVCWMWQWNUVCMBWORXDXKUVDFZXD
    ATFUVGXDUVHWPACBWRUUJABWSWTXAXBXKBWHRVFVO $.

  $( The proportion of one binomial coefficient to another with ` N ` increased
     by 1.  (Contributed by Mario Carneiro, 10-Mar-2014.) $)
  bcp1n $p |- ( K e. ( 0 ... N ) -> ( ( N + 1 ) _C K ) =
                ( ( N _C K ) x. ( ( N + 1 ) / ( ( N + 1 ) - K ) ) ) ) $=
    ( cc0 cfz co wcel c1 caddc cfa cfv cmin cmul cdiv cn0 syl cc cn faccl nncnd
    wceq cbc elfz3nn0 fznn0sub nn0cnd ax-1cn a1i elfznn0 addsubd fveq2d 3eqtr4d
    facp1 oveq2d oveq1d nn0p1nn eqeltrd mul32d eqtrd oveq12d wne nnmulcld nnne0
    wa nncn jca nnne0d divmuldiv syl22anc eqtr4d fzelp1 bcval2 ) ACBDEFZBGHEZIJ
    ZVLAKEZIJZAIJZLEZMEZBIJZBAKEZIJZVPLEZMEZVLVNMEZLEZVLAUAEZBAUAEZWDLEVKVRVSVL
    LEZWBVNLEZMEZWEVKVMWHVQWIMVKBNFZVMWHTABUBZBUKOVKVQWAVNLEZVPLEWIVKVOWMVPLVKV
    TGHEZIJZWAWNLEZVOWMVKVTNFZWOWPTACBUCZVTUKOVKVNWNIVKBGAVKBWLUDGPFVKUEUFVKAAB
    UGZUDUHZUIVKVNWNWALWTULUJUMVKWAVNVPVKWAVKWQWAQFWRVTROZSVKVNVKVNWNQWTVKWQWNQ
    FWRVTUNOUOZSZVKVPVKANFVPQFWSAROZSUPUQURVKVSPFVLPFWBPFZWBCUSZVBZVNPFZVNCUSZV
    BWEWJTVKVSVKWKVSQFWLBROSVKVLVKWKVLQFWLBUNOSVKWBQFZXGVKWAVPXAXDUTXJXEXFWBVCW
    BVAVDOVKXHXIXCVKVNXBVEVDVSVLWBVNVFVGVHVKACVLDEFWFVRTACBVIAVLVJOVKWGWCWDLABV
    JUMUJ $.

  $( The proportion of one binomial coefficient to another with ` N ` and ` K `
     increased by 1.  (Contributed by Mario Carneiro, 16-Jan-2015.) $)
  bcp1nk $p |- ( K e. ( 0 ... N ) -> ( ( N + 1 ) _C ( K + 1 ) ) =
                ( ( N _C K ) x. ( ( N + 1 ) / ( K + 1 ) ) ) ) $=
    ( cc0 cfz co wcel c1 caddc cbc cmin cdiv cmul wceq cz wb syl cc oveq2d zred
    eqtrd elfzel1 elfzel2 elfzelz 1z a1i fzaddel syl22anc 1e0p1 syl6eleqr bcm1k
    oveq1i zcnd ax-1cn pncan sylancl bcp1n oveq1d oveq12d bcrpcl rpcnd peano2zd
    ibi clt wbr elfzle2 ltp1d lelttrd znnsub syl2anc mpbid nndivred recnd nnred
    cn cn0 elfznn0 nn0p1nn mulassd nncnd nnne0d dmdcan2d ) ACBDEFZBGHEZAGHEZIEZ
    WCWDGJEZIEZWCWFJEZWDKEZLEZBAIEZWCWDKEZLEZWBWDGWCDEZFWEWJMWBWDCGHEZWCDEZWNWB
    WDWPFZWBCNFBNFANFZGNFZWBWQOACBUAACBUBZACBUCZWSWBUDUEAGCBUFUGVBGWOWCDUHUKUIW
    DWCUJPWBWJWKWCWCAJEZKEZLEZXBWDKEZLEZWMWBWGXDWIXELWBWGWCAIEXDWBWFAWCIWBAQFGQ
    FWFAMWBAXAULUMAGUNUOZRABUPTWBWHXBWDKWBWFAWCJXGRUQURWBXFWKXCXELEZLEWMWBWKXCX
    EWBWKABUSUTWBXCWBWCXBWBWCWBBWTVAZSZWBAWCVCVDZXBVNFZWBABWCWBAXASWBBWTSZXJACB
    VEWBBXMVFVGWBWRWCNFXKXLOXAXIAWCVHVIVJZVKVLWBXEWBXBWDWBXBXNVMWBAVOFWDVNFABVP
    AVQPZVKVLVRWBXHWLWKLWBWCXBWDWBWCXIULWBXBXNVSWBWDXOVSWBXBXNVTWBWDXOVTWARTTT
    $.

  ${
    $d k x y K $.  $d k x y N $.
    $( Write out the top and bottom parts of the binomial coefficient
       ` ( N _C K ) = ( N x. ( N - 1 ) x. ... x. ( ( N - K ) + 1 ) ) / K ! `
       explicitly.  In this form, it is valid even for ` N < K ` , although it
       is no longer valid for non-positive ` K ` .  (Contributed by Mario
       Carneiro, 22-May-2014.) $)
    bcval5 $p |- ( ( N e. NN0 /\ K e. NN ) -> ( N _C K ) =
                 ( ( seq ( ( N - K ) + 1 ) ( x. , _I ) ` N ) / ( ! ` K ) ) ) $=
      ( cn0 wcel cn wa cc0 co cmul cid c1 cfv cfa cdiv adantl cc wbr syl2anc wb
      wceq vk vx vy cfz cbc cmin caddc cseq bcval2 mulcl w3a mulass cuz cle clt
      cv simplr elfzuz3 nnuz uztrn2 adantrr cr nnre nnrp ltsubrp syl2an cz nnzd
      crp nnz ad2antlr zsubcld zltp1le peano2zd eluz mpbird simprr syl6eleq fvi
      mpbid elfzelz zcnd eqeltrd seqsplit facnn syl oveq1d 3eqtr4d simpll faccl
      expr nncn 3syl mulid2d oveq2d eqtr3d fveq2 fac0 syl6eq oveq1 0p1e1 fveq1d
      seqeq1d oveq12d eqeq2d syl5ibrcom fznn0sub elnn0 sylib mpjaod eqid zsubcl
      wo nn0z adantr eluzelz seqf ffvelrnd elfznn0 nncnd nnne0d divcan5d 3eqtrd
      wn nnnn0 nnne0 div0d mul02 mul01 simpr nn0uz ad2antrr elfz5 nn0re subge0d
      bitr4d mtbid zred sylancl 0z 0re ltnle nn0ge0 elfz syl3anc mpbir2and mp1i
      a1i 0cn seqz bcval3 syl3an2 3expa 3eqtr4rd pm2.61dan ) BCDZAEDZFZAGBUDHDZ
      BAUEHZBIJBAUFHZKUGHZUHZLZAMLZNHZTUURUUSFZUUTBMLZUVAMLZUVEIHZNHZUVIUVDIHZU
      VJNHUVFUUSUUTUVKTUURABUIOUVGUVHUVLUVJNUVGUVAEDZUVHUVLTZUVAGTZUURUUSUVMUVN
      UURUUSUVMFZFZBIJKUHZLZUVAUVRLZUVDIHUVHUVLUVQUAUBUCIPJKUVABUAUPZPDZUBUPZPD
      ZFZUWAUWCIHZPDZUVQUWAUWCUJZOUWBUWDUCUPZPDUKUWFUWIIHUWAUWCUWIIHIHTUVQUWAUW
      CUWIULOUVQBUVBUMLZDZUVBBUNQZUVQUVABUOQZUWLUVQBEDZUUQUWMUURUUSUWNUVMUVGUUQ
      BAUMLDZUWNUUPUUQUUSUQZUUSUWOUURAGBUROKBAEUSUTRZVAZUUPUUQUVPUQUWNBVBDZAVID
      UWMUUQBVCAVDBAVEVFZRUVQUVAVGDZBVGDZUWMUWLSZUVQBAUVQBUWRVHZUUQAVGDZUUPUVPA
      VJZVKVLZUXDUVABVMZRVTUVQUVBVGDZUXBUWKUWLSZUVQUVAUXGVNUXDUVBBVOZRVPUVQUVAE
      KUMLUURUUSUVMVQZUSVRUWAKBUDHZDZUWAJLZPDZUVQUXNUXOUWAPUWAUXMVSUXNUWAUWAKBW
      AWBWCOWDUVQUWNUVHUVSTZUWRBWEZWFUVQUVIUVTUVDIUVQUVMUVIUVTTUXLUVAWEWFWGWHWK
      UVGUVNUVOUVHKUVSIHZTUVGKUVHIHUVHUXSUVGUVHUVGUUPUVHEDUVHPDUUPUUQUUSWIBWJUV
      HWLWMWNUVGUVHUVSKIUVGUWNUXQUWQUXRWFWOWPUVOUVLUXSUVHUVOUVIKUVDUVSIUVOUVIGM
      LKUVAGMWQWRWSUVOBUVCUVRUVOUVBKIJUVOUVBGKUGHKUVAGKUGWTXAWSXCXBXDXEXFUVGUVA
      CDZUVMUVOXMUUSUXTUURAGBXGOZUVAXHXIXJWGUVGUVDUVEUVIUVGUWJPBUVCUVGUAUBIPJUV
      BUWJUWJXKUURUXIUUSUURUVAUUPUXBUXEUXAUUQBXNZUXFBAXLVFZVNZXOZUWAUWJDZUXPUVG
      UYFUXOUWAPUWAUWJVSUYFUWAUVBUWAXPWBWCOUWEUWGUVGUWHOXQUVGUWKUWLUVGUWMUWLUVG
      UWNUUQUWMUWQUWPUWTRUVGUXAUXBUXCUURUXAUUSUYCXOUVGBUWQVHZUXHRVTUVGUXIUXBUXJ
      UYEUYGUXKRVPXRUVGUVEUVGACDZUVEEDZUUSUYHUURABXSOAWJZWFZXTUVGUVIUVGUXTUVIED
      UYAUVAWJWFZXTUVGUVEUYKYAUVGUVIUYLYAYBYCUURUUSYDZFZGUVENHZGUVFUUTUYNUYHUYI
      UYOGTUUQUYHUUPUYMAYEVKZUYJUYIUVEUVEWLUVEYFYGWMUYNUVDGUVENUYNUAUBIPJGUVBBC
      GUWEUWGUYNUWHOUWAUVBBUDHZDZUXPUYNUYRUXOUWAPUWAUYQVSUYRUWAUWAUVBBWAWBWCOUW
      BGUWAIHGTUYNUWAYHOUWBUWAGIHGTUYNUWAYIOUYNGUYQDZUVBGUNQZGBUNQZUYNUVAGUOQZU
      YTUYNVUBGUVAUNQZYDZUYNUUSVUCUURUYMYJUYNUUSABUNQZVUCUYNAGUMLZDUXBUUSVUESUY
      NACVUFUYPYKVRUUPUXBUUQUYMUYBYLZAGBYMRUYNBAUUPUWSUUQUYMBYNYLUUQAVBDUUPUYMA
      VCVKYOYPYQUYNUVAVBDGVBDVUBVUDSUYNUVAUURUXAUYMUYCXOZYRUUAUVAGUUBYSVPUYNUXA
      GVGDZVUBUYTSVUHYTUVAGVMYSVTUUPVUAUUQUYMBUUCYLUYNVUIUXIUXBUYSUYTVUAFSVUIUY
      NYTUUHUURUXIUYMUYDXOVUGGUVBBUUDUUEUUFUUPUUQUYMWIGPDGJLGTUYNUUIGPVSUUGUUJW
      GUUPUUQUYMUUTGTZUUQUUPUXEUYMVUJUXFABUUKUULUUMUUNUUO $.
  $}

  $( Binomial coefficient: ` N ` choose ` 2 ` .  (Contributed by Mario
     Carneiro, 22-May-2014.) $)
  bcn2 $p |- ( N e. NN0 -> ( N _C 2 ) = ( ( N x. ( N - 1 ) ) / 2 ) ) $=
    ( cn0 wcel c2 co cmul cid cmin c1 caddc cseq cfv cdiv wceq cc ax-1cn syl cz
    cuz eqtrd cbc cfa cn 2nn bcval5 mpan2 2m1e1 oveq2i nn0cn 2cn npncan mp3an23
    syl5eqr seqeq1d fveq1d peano2zm npcan sylancl fveq2d eleqtrrd seqm1 syl2anc
    nn0z uzid seq1 fvi oveq12d subcl mulcomd fac2 a1i ) ABCZADUAEZAFGADHEZIJEZK
    ZLZDUBLZMEZAAIHEZFEZDMEVLDUCCVMVSNUDDAUEUFVLVQWAVRDMVLVQAFGVTKZLZWAVLAVPWBV
    LVOVTFGVLVOVNDIHEZJEZVTWDIVNJUGUHVLAOCZWEVTNZAUIZWFDOCIOCZWGUJPADIUKULQUMUN
    UOVLWCVTAFEZWAVLWCVTWBLZAGLZFEZWJVLVTRCZAVTIJEZSLZCWCWMNVLARCZWNAVCZAUPQZVL
    AASLZWPVLWQAWTCWRAVDQVLWOASVLWFWIWOANWHPAIUQURUSUTFGVTAVAVBVLWKVTWLAFVLWKVT
    GLZVTVLWNWKXANWSFGVTVEQVLWNXAVTNWSVTRVFQTABVFVGTVLVTAVLWFWIVTOCWHPAIVHURWHV
    ITTVRDNVLVJVKVGT $.

  $( Compute the binomial coefficent of ` ( N + 1 ) ` over ` ( N - 1 ) `
     (Contributed by Scott Fenton, 11-May-2014.)  (Revised by Mario Carneiro,
     22-May-2014.) $)
  bcp1m1 $p |- ( N e. NN0 -> ( ( N + 1 ) _C ( N - 1 ) ) =
                 ( ( ( N + 1 ) x. N ) / 2 ) ) $=
    ( cn0 wcel c1 caddc co cmin cbc cmul c2 cdiv wceq peano2nn0 nn0z syl ax-1cn
    cz cc oveq2d eqtrd peano2zm bccmpl syl2anc nn0cn pnncand df-2 syl6eqr pncan
    a1i bcn2 sylancl oveq1d ) ABCZADEFZADGFZHFZUNUNUOGFZHFZUNAIFZJKFZUMUNBCZUOQ
    CZUPURLAMZUMAQCVBANAUAOUOUNUBUCUMURUNJHFZUTUMUQJUNHUMUQDDEFJUMADDAUDZDRCZUM
    PUIZVGUEUFUGSUMVDUNUNDGFZIFZJKFZUTUMVAVDVJLVCUNUJOUMVIUSJKUMVHAUNIUMARCVFVH
    ALVEPADUHUKSULTTT $.

  $( Pascal's rule for the binomial coefficient, generalized to all integers
     ` K ` .  Equation 2 of [Gleason] p. 295.  (Contributed by NM,
     13-Jul-2005.)  (Revised by Mario Carneiro, 10-Mar-2014.) $)
  bcpasc $p |- ( ( N e. NN0 /\ K e. ZZ ) ->
                ( ( N _C K ) + ( N _C ( K - 1 ) ) ) = ( ( N + 1 ) _C K ) ) $=
    ( cn0 wcel cz wa cc0 caddc cfz cbc cmin wceq syl ax-1cn oveq12d oveq2d cdiv
    c1 co cmul wo wb peano2nn0 cuz cfv elfzp12 nn0uz eleq2s addid1i bcn0 clt 0z
    wbr 1z zsubcl mp2an cr ltm1 ax-mp orci bcval4 mp3an23 3eqtr4a oveq2 eqeq12d
    0re oveq1 syl5ibrcom simpr 0p1e1 oveq1i syl6eleq cn nn0p1nn nnuz fzm1 sylan
    biimpa cc nn0cn pncan sylancl eleq2d wss 1nn0 eleqtri fzss1 sseli bcp1n crp
    bcrpcl rpcnd elfzuz2 syl6eleqr peano2nnd nncnd a1i elfzelz addsubd fznn0sub
    eqeltrd nnne0d div12d nnrpd rpdivcld mulcomd npcand adddid 3eqtr2d divcan1d
    zcnd eqtrd elfznn divdiv2d bcm1k subsub3d oveq1d nnzd elfzm1b syl2anc mpbid
    fzelp1 eleqtrd rpne0d divmul3d mpbird 3eqtr3rd 3eqtrrd nn0re ltp1d mpd3an23
    div23d olcd sylan9eqr bcnn adantr syldan wn bcval3 syl3anc jaodan ex sylbid
    jaod imp adantlr con3i 3expa sylan2 simpll simplr peano2zm id nn0zd syl2anr
    00id fzp1ss eqsstr3i syl6bir sylbird con3and pm2.61dan ) BCDZAEDZFZAGBRHSZI
    SZDZBAJSZBARKSZJSZHSZUVFAJSZLZUVCUVHUVNUVDUVCUVHUVNUVCUVHAGLZAGRHSZUVFISZDZ
    UAZUVNUVCUVFCDZUVHUVSUBZBUCZUWAUVFGUDUEZCAGUVFUFUGUHMUVCUVOUVNUVRUVCUVNUVOB
    GJSZBGRKSZJSZHSZUVFGJSZLUVCRGHSRUWGUWHRNUIUVCUWDRUWFGHBUJUVCUWEEDZUWEGUKUMZ
    BUWEUKUMZUAUWFGLGEDZREDUWIULUNGRUOUPUWJUWKGUQDUWJVFGURUSUTUWEBVAVBOUVCUVTUW
    HRLUWBUVFUJMVCUVOUVLUWGUVMUWHUVOUVIUWDUVKUWFHAGBJVDUVOUVJUWEBJAGRKVGPOAGUVF
    JVDVEVHUVCUVRUVNUVCUVRARUVFISZDZUVNUVCUVRFAUVQUWMUVCUVRVIUVPRUVFIVJVKZVLUVC
    UWNARUVFRKSZISZDZAUVFLZUAZUVNUVCUVFRUDUEZDZUWNUWTUVCUVFVMUXABVNZVOVLUXBUWNU
    WTARUVFVPVRVQUVCUWRUVNUWSUVCUWRFARBISZDZUVNUVCUWRUXEUVCUWQUXDAUVCUWPBRIUVCB
    VSDZRVSDZUWPBLZBVTZNBRWAZWBZPWCVRUXEUVMUVIUVFUVFAKSZQSTSZUVIUXLQSZUXLTSZUXN
    ATSZHSZUVLUXEAGBISZDZUVMUXMLUXDUXRARUWCDUXDUXRWDRCUWCWEUGWFRGBWGUSWHZABWIMU
    XEUXMUXNUVFTSZUXNUXLAHSZTSUXQUXEUXMUVFUXNTSUYAUXEUVIUVFUXLUXEUVIUXEUXSUVIWJ
    DUXTABWKMZWLZUXEUVFUXEBUXEBUXAVMARBWMVOWNZWOZWPZUXEUXLUXEUXLBAKSZRHSZVMUXEB
    RAUXEBUYEWPZUXGUXENWQZUXEAARBWRZXKZWSUXEUYHCDUYIVMDARBWTUYHVNMXAZWPZUXEUXLU
    YNXBZXCUXEUVFUXNUYGUXEUXNUXEUVIUXLUYCUXEUXLUYNXDZXEWLZXFXLUXEUYBUVFUXNTUXEU
    VFAUYGUYMXGPUXEUXNUXLAUYRUYOUYMXHXIUXEUXOUVIUXPUVKHUXEUVIUXLUYDUYOUYPXJUXEU
    VIUXLAQSZQSZUVIATSUXLQSUVKUXPUXEUVIUXLAUYDUYOUYMUYPUXEAABXMZXBXNUXEUYTUVKLU
    VIUVKUYSTSZLUXEUVIUVKBUVJKSZAQSZTSVUBABXOUXEVUDUYSUVKTUXEVUCUXLAQUXEBARUYJU
    YMUYKXPXQPXLUXEUVIUVKUYSUYDUXEUVKUXEUVJUXRDZUVKWJDUXEUVJGUWPISZUXRUXEUWNUVJ
    VUFDZARBYBUXEUVDUVFEDZUWNVUGUBZUYLUXEUVFUYFXRAUVFXSZXTYAUXEUWPBGIUXEUXFUXGU
    XHUYJNUXJWBPYCUVJBWKMWLUXEUYSUXEUXLAUYQUXEAVUAXDXEZWLUXEUYSVUKYDYEYFUXEUVIA
    UXLUYDUYMUYOUYPYLYGOYHMUVCUWSFZUVPRUVLUVMVJVULUVIGUVKRHUWSUVCUVIBUVFJSZGAUV
    FBJVDUVCVUHUVFGUKUMZBUVFUKUMZUAVUMGLUVCUVFUXCXRUVCVUOVUNUVCBBYIYJYMUVFBVAYK
    YNVULUVKBBJSZRVULUVJBBJUWSUVCUVJUWPBAUVFRKVGUXKYNPUVCVUPRLUWSBYOYPXLOUWSUVC
    UVMUVFUVFJSZRAUVFUVFJVDUVCUVTVUQRLUWBUVFYOMYNVCUUAYQYQUUBUUDUUCUUEUUFUVEUVH
    YRZFZGGHSGUVLUVMUUPVUSUVIGUVKGHVURUVEUXSYRZUVIGLZUXSUVHAGBYBUUGUVCUVDVUTVVA
    ABYSUUHUUIVUSUVCUVJEDZVUEYRUVKGLUVCUVDVURUUJZVUSUVDVVBUVCUVDVURUUKZAUULMUVE
    VUEUVHUVEVUEVUGUVHUVEVUFUXRUVJUVEUWPBGIUVEUXFUXGUXHUVCUXFUVDUXIYPNUXJWBPWCU
    VEVUGUWNUVHUVDUVDVUHVUIUVCUVDUUMUVCUVFUWBUUNVUJUUOUWMUVGAUWMUVQUVGUWOUWLUVQ
    UVGWDULGUVFUUQUSUURWHUUSUUTUVAUVJBYSYTOVUSUVTUVDVURUVMGLVUSUVCUVTVVCUWBMVVD
    UVEVURVIAUVFYSYTVCUVB $.

  ${
    $d k m n N $.  $d k m n K $.
    $( A binomial coefficient, in its extended domain, is a nonnegative
       integer.  (Contributed by NM, 10-Jul-2005.)  (Revised by Mario Carneiro,
       9-Nov-2013.) $)
    bccl $p |- ( ( N e. NN0 /\ K e. ZZ ) -> ( N _C K ) e. NN0 ) $=
      ( vk vm cn0 wcel cv cbc co cz wral cc0 c1 wceq oveq1 eleq1d ralbidv oveq2
      wa 0nn0 vn caddc cfz elfz1eq adantl bcn0 1nn0 eqeltri syl6eqel syl bcval3
      ax-mp wn mp3an1 pm2.61dan rgen cbvralv cmin bcpasc adantlr rspccva sylan2
      peano2zm nn0addcld adantll eqeltrrd ralrimiva ex syl5bi nn0ind sylan ) BE
      FBCGZHIZEFZCJKZAJFBAHIZEFZDGZVLHIZEFZCJKLVLHIZEFZCJKUAGZVLHIZEFZCJKZWCMUB
      IZVLHIZEFZCJKZVODUABVRLNZVTWBCJWKVSWAEVRLVLHOPQVRWCNZVTWECJWLVSWDEVRWCVLH
      OPQVRWGNZVTWICJWMVSWHEVRWGVLHOPQVRBNZVTVNCJWNVSVMEVRBVLHOPQWBCJVLJFZVLLLU
      CIFZWBWOWPSVLLNZWBWPWQWOVLLUDUEWQWALLHIZEVLLLHRWRMELEFZWRMNTLUFULUGUHUIUJ
      WOWPUMZSWALEWSWOWTWALNTVLLUKUNTUIUOUPWFWCVRHIZEFZDJKZWCEFZWJWEXBCDJVLVRNW
      DXAEVLVRWCHRPUQXDXCWJXDXCSZWICJXEWOSWDWCVLMURIZHIZUBIZWHEXDWOXHWHNXCVLWCU
      SUTXCWOXHEFXDXCWOSWDXGXBWEDVLJVRVLNXAWDEVRVLWCHRPVAWOXCXFJFXGEFZVLVCXBXID
      XFJVRXFNXAXGEVRXFWCHRPVAVBVDVEVFVGVHVIVJVNVQCAJVLANVMVPEVLABHRPVAVK $.

    $( A binomial coefficient, in its standard domain, is a natural number.
       (Contributed by NM, 3-Jan-2006.)  (Revised by Mario Carneiro,
       10-Mar-2014.) $)
    bccl2 $p |- ( K e. ( 0 ... N ) -> ( N _C K ) e. NN ) $=
      ( cc0 cfz co wcel cbc cn0 clt wbr cn elfz3nn0 elfzelz bccl syl2anc bcrpcl
      cz rpgt0d elnnnn0b sylanbrc ) ACBDEFZBAGEZHFZCUBIJUBKFUABHFAQFUCABLACBMAB
      NOUAUBABPRUBST $.
  $}

  $( Compute the binomial coefficient " ` N ` choose 2 " from " ` ( N - 1 ) `
     choose 2 ":  (N-1) + ( (N-1) 2 ) = ( N 2 ) (Contributed by Alexander van
     der Vekens, 7-Jan-2018.) $)
  bcn2m1 $p |- ( N e. NN
                 -> ( ( N - 1 ) + ( ( N - 1 ) _C 2 ) ) = ( N _C 2 ) ) $=
    ( cn wcel c1 cmin co c2 cbc caddc nnm1nn0 nn0cnd cn0 cz 2z bccl sylancl a1i
    wceq oveq2d eqtrd addcomd bcn1 eqcomd syl 2m1e1 eqcomi bcpasc ax-1cn npcand
    nncn cc oveq1d 3eqtrd ) ABCZADEFZUOGHFZIFUPUOIFUPUOGDEFZHFZIFZAGHFZUNUOUPUN
    UOAJZKUNUPUNUOLCZGMCZUPLCVANGUOOPKUAUNUOURUPIUNUOUODHFZURUNVBUOVDRVAVBVDUOU
    OUBUCUDUNDUQUOHDUQRUNUQDUEUFQSTSUNUSUODIFZGHFZUTUNVBVCUSVFRVANGUOUGPUNVEAGH
    UNADAUJDUKCUNUHQUIULTUM $.

  $( Compute the binomial coefficient " ` ( N + 1 ) ` choose 2 " from " ` N `
     choose 2 ":  N + ( N 2 ) = ( (N+1) 2 ) (Contributed by Alexander van der
     Vekens, 8-Jan-2018.) $)
  bcn2p1 $p |- ( N e. NN0 -> ( N + ( N _C 2 ) ) = ( ( N + 1 ) _C 2 ) ) $=
    ( cn0 wcel c2 cbc co caddc c1 cmin nn0cn cz 2z bccl mpan2 addcomd bcn1 wceq
    nn0cnd 2m1e1 oveq2d eqcomi a1i eqtr3d bcpasc 3eqtrd ) ABCZAADEFZGFUGAGFUGAD
    HIFZEFZGFZAHGFDEFZUFAUGAJUFUGUFDKCZUGBCLDAMNROUFAUIUGGUFAHEFAUIAPUFHUHAEHUH
    QUFUHHSUAUBTUCTUFULUJUKQLDAUDNUE $.

  $( The number of permutations of ` N - R ` objects from a collection of ` N `
     objects is a natural number.  (Contributed by Jason Orendorff,
     24-Jan-2007.) $)
  permnn $p |- ( R e. ( 0 ... N ) -> ( ( ! ` N ) / ( ! ` R ) ) e. NN ) $=
    ( cc0 cfz co wcel cfa cfv cn cmin cmul cdiv elfznn0 faccl fznn0sub nnmulcld
    cc cn0 syl nncnd elfz3nn0 wne facne0 divcan4d eqeltrd bcval2 bccl2 eqeltrrd
    cbc nndivtr syl32anc ) ACBDEFZAGHZIFZBAJEZGHZUMKEZIFBGHZQFZUQUMLEZIFURUQLEZ
    IFURUMLEIFULARFZUNABMZANSZULUPUMULUORFUPIFACBOUONSZVDPULBRFZUSABUAVFURBNTSU
    LUTUPIULUPUMULUPVETULUMVDTULVBUMCUBVCAUCSUDVEUEULBAUIEVAIABUFABUGUHUMUQURUJ
    UK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               The ` # ` (finite set size) function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c # $.

  $( Extend the definition of a class to include the size function. $)
  chash $a class # $.

  ${
    $d x y $.
    $( Define the ` # ` function, which gives the cardinality of a finite set
       as a member of ` NN0 ` , and assigns all infinite sets the value
       ` +oo ` .  (Contributed by Paul Chapman, 22-Jun-2011.) $)
    df-hash $a |- # = ( ( ( rec (
                   ( x e. _V |-> ( x + 1 ) ) , 0 ) |` om ) o. card ) u.
                   ( ( _V \ Fin ) X. { +oo } ) ) $.
  $}

  ${
    $d A x y $.  $d K y $.
    hashgval.1 $e |- G = ( rec ( ( x e. _V |-> ( x + 1 ) ) , 0 ) |` om ) $.
    ${
      hashkf.2 $e |- K = ( G o. card ) $.
      $( The finite part of the size function maps all finite sets to their
         cardinality, as members of ` NN0 ` .  (Contributed by Mario Carneiro,
         13-Sep-2013.)  (Revised by Mario Carneiro, 26-Dec-2014.) $)
      hashkf $p |- K : Fin --> NN0 $=
        ( vy cfn cn0 wf wfn cfv wcel ccrd wfun cdm wceq com ax-mp cen wbr cv c1
        wral ccom cvv caddc co cmpt cc0 crdg cres frfnom fneq1i mpbir con0 wrex
        fnfun cardf2 ffun funco mp2an ccnv cima dmco fndm imaeq2i wa funfn mpbi
        wb elpreima id cardid2 ensymd breq2 rspcev syl2anr isfi sylibr ficardom
        cab finnum impbii bitri eqriv 3eqtri df-fn mpbir2an fveq1i fvco sylancr
        jca syl5eq wf1o hashgf1o f1of ffvelrni syl eqeltrd rgen ffnfv ) GHCICGJ
        ZFUAZCKZHLZFGUCXBBMUDZGJZXGXFNZXFOZGPBNZMNZXHBQJZXJXLAUEAUAZUBUFUGUHZUI
        UJQUKZQJUIXNULQBXODUMUNZQBUQRXMXCSTAUOUPFWAZUOMIXKFAURXQUOMUSRZBMUTVAXI
        MVBZBOZVCXSQVCZGBMVDXTQXSXLXTQPXPQBVERVFFYAGXCYALZXCMOZLZXCMKZQLZVGZXCG
        LZMYCJZYBYGVJXKYIXRMVHVIYCXCQMVKRYGYHYGXCXMSTZAQUPZYHYFYFXCYESTZYKYDYFV
        LYDYEXCXCVMVNYJYLAYEQXMYEXCSVOVPVQAXCVRVSYHYDYFXCWBZXCVTZWLWCWDWEWFXFGW
        GWHGCXFEUMUNXEFGYHXDYEBKZHYHXDXCXFKZYOXCCXFEWIYHXKYDYPYOPXRYMXCBMWJWKWM
        YHYFYOHLYNQHYEBQHBWNQHBIABDWOQHBWPRWQWRWSWTFGHCXAWH $.
    $}

    $( The value of the ` # ` function in terms of the mapping ` G ` from
       ` om ` to ` NN0 ` .  The proof avoids the use of ~ ax-ac .  (Contributed
       by Paul Chapman, 22-Jun-2011.)  (Revised by Mario Carneiro,
       26-Dec-2014.) $)
    hashgval $p |- ( A e. Fin -> ( G ` ( card ` A ) ) = ( # ` A ) ) $=
      ( vy cfn wcel chash cres cfv ccrd ccom cvv cpnf cun c0 wf wceq eqtri con0
      cv c1 caddc co cmpt cc0 crdg com cdif csn cxp resundir cn0 wfn hashkf ffn
      eqid fnresdm mp2b cin incom disjdif cxr pnfxr elexi fconst fnresdisj mpbi
      wb uneq12i un0 df-hash reseq1i coeq1i 3eqtr4i fveq1i wfun cdm cen wbr cab
      wrex cardf2 ffun ax-mp finnum fvco sylancr syl5eq fvres eqtr3d ) BFGZBHFI
      ZJZBKJCJZBHJWLWNBCKLZJZWOBWMWPAMAUAZUBUCUDUEUFUGUHIZKLZMFUIZNUJZUKZOZFIZW
      TWMWPXEWTFIZXCFIZOZWTWTXCFULXHWTPOWTXFWTXGPFUMWTQWTFUNXFWTRAWSWTWSUQWTUQU
      OFUMWTUPFWTURUSXAFUTZPRZXGPRZXIFXAUTPXAFVAFMVBSXAXBXCQXCXAUNXJXKVIXANNVCV
      DVEVFXAXBXCUPXAFXCVGUSVHVJWTVKSSHXDFAVLVMCWSKDVNVOVPWLKVQZBKVRGWQWOREUAWR
      VSVTETWBAWAZTKQXLAEWCXMTKWDWEBWFBCKWGWHWIBFHWJWK $.

    $( ` ``' G ` maps the size function's value to ` card ` .  (Contributed by
       Paul Chapman, 22-Jun-2011.)  (Revised by Mario Carneiro,
       15-Sep-2013.) $)
    hashginv $p |- ( A e. Fin -> ( `' G ` ( # ` A ) ) = ( card ` A ) ) $=
      ( cfn wcel ccrd cfv com chash wceq ccnv ficardom hashgval cn0 wi hashgf1o
      wf1o f1ocnvfv mpan sylc ) BEFBGHZIFZUBCHBJHZKZUDCLHUBKZBMABCDNIOCRUCUEUFP
      ACDQIOUBUDCSTUA $.
  $}

  ${
    $d A x y $.
    $( The value of the ` # ` function on an infinite set.  (Contributed by
       Mario Carneiro, 13-Jul-2014.) $)
    hashinf $p |- ( ( A e. V /\ -. A e. Fin ) -> ( # ` A ) = +oo ) $=
      ( vx wcel cvv cfn chash cfv cpnf wceq cres cun c0 cn0 wfn eqid ffn 3eqtri
      wf mp2b wn elex wa cdif eldif csn cxp cv c1 caddc cmpt cc0 crdg ccrd ccom
      co com df-hash reseq1i resundir cin disjdif wb hashkf fnresdisj cxr pnfxr
      mpbi elexi fconst fnresdm uneq12i uncom un0 fveq1i fvres fvconst2 3eqtr3a
      sylbir sylan ) ABDAEDZAFDUAZAGHZIJZABUBWAWBUCAEFUDZDZWDAEFUEWFAGWEKZHAWEI
      UFZUGZHWCIAWGWIWGCECUHUIUJUPUKULUMUQKZUNUOZWILZWEKWKWEKZWIWEKZLZWIGWLWECU
      RUSWKWIWEUTWOMWILWIMLWIWMMWNWIFWEVAMJZWMMJZFEVBFNWKSWKFOWPWQVCCWJWKWJPWKP
      VDFNWKQFWEWKVETVHWEWHWISWIWEOWNWIJWEIIVFVGVIZVJWEWHWIQWEWIVKTVLMWIVMWIVNR
      RVOAWEGVPWEIAWRVQVRVSVT $.

    $( If ` A ` has size bounded by an integer ` B ` , then ` A ` is finite.
       (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    hashbnd $p |- ( ( A e. V /\ B e. NN0 /\ ( # ` A ) <_ B ) -> A e. Fin ) $=
      ( wcel cn0 chash cfv cle wbr cfn wa wn wi cpnf cr nn0re clt ltpnf cxr wb
      rexr pnfxr xrltnle sylancl mpbid hashinf breq1d notbid syl5ibrcom expdimp
      syl ancoms con4d 3impia ) ACDZBEDZAFGZBHIZAJDZUOUPKUSURUPUOUSLZURLZMUPUOU
      TVAUPVAUOUTKZNBHIZLZUPBODZVDBPVEBNQIZVDBRVEBSDNSDVFVDTBUAUBBNUCUDUEUKVBUR
      VCVBUQNBHACUFUGUHUIUJULUMUN $.
  $}

  ${
    $d x y z $.
    $( The size function maps all finite sets to their cardinality, as members
       of ` NN0 ` , and infinite sets to ` +oo ` .  (Contributed by Mario
       Carneiro, 13-Sep-2013.)  (Revised by Mario Carneiro, 13-Jul-2014.) $)
    hashf $p |- # : _V --> ( NN0 u. { +oo } ) $=
      ( vx cvv cn0 cpnf csn cun chash wf cfn cdif cv c1 caddc cmpt cc0 crdg com
      co cres eqid ccrd ccom cxp wa cin c0 hashkf cxr pnfxr elexi fconst pm3.2i
      wceq disjdif fun mp2an df-hash feq1i unvdif feq2i bitr4i mpbir ) BCDEZFZG
      HZIBIJZFZVDABAKLMRNOPQSZUAUBZVFVCUCZFZHZICVIHZVFVCVJHZUDIVFUEUFUMVLVMVNAV
      HVIVHTVITUGVFDDUHUIUJUKULIBUNIVFCVCVIVJUOUPVEBVDVKHVLBVDGVKAUQURVGBVDVKIU
      SUTVAVB $.
  $}

  $( The value of the hash function for a set is either a nonnegative integer
     or positive infinity.  (Contributed by Alexander van der Vekens,
     6-Dec-2017.) $)
  hashnn0pnf $p |- ( M e. V -> ( ( # ` M ) e. NN0 \/ ( # ` M ) = +oo ) ) $=
    ( wcel chash cfv cn0 cpnf csn cun wceq wo cvv hashf a1i elex ffvelrnd elsni
    wf elun orim2i sylbi syl ) ABCZADEZFGHZIZCZUDFCZUDGJZKZUCLUFADLUFDRUCMNABOP
    UGUHUDUECZKUJUDFUESUKUIUHUDGQTUAUB $.

  $( If the size of a set is not a nonnegative integer, it is greater than or
     equal to any nonnegative integer.  (Contributed by Alexander van der
     Vekens, 6-Dec-2017.) $)
  hashnnn0genn0 $p |- ( ( M e. V /\ ( # ` M ) e/ NN0 /\ N e. NN0 )
                        -> N <_ ( # ` M ) ) $=
    ( wcel chash cfv cn0 wnel w3a cle wbr cpnf wceq wi wn df-nel sylbi 3ad2ant2
    pm2.21 cxr clt cr nn0re ltpnf syl rexrd pnfxr xrltle sylancl mpd syl5ibrcom
    breq2 3ad2ant3 wo hashnn0pnf 3ad2ant1 mpjaod ) ACDZAEFZGHZBGDZIUSGDZBUSJKZU
    SLMZUTURVBVCNZVAUTVBOVEUSGPVBVCSQRVAURVDVCNUTVAVCVDBLJKZVABLUAKZVFVABUBDVGB
    UCZBUDUEVABTDLTDVGVFNVABVHUFUGBLUHUIUJUSLBJULUKUMURUTVBVDUNVAACUOUPUQ $.

  $( The size of a set is never minus infinity.  (Contributed by Alexander van
     der Vekens, 21-Dec-2017.) $)
  hashnemnf $p |- ( A e. V -> ( # ` A ) =/= -oo ) $=
    ( wcel chash cfv cn0 cpnf wceq wo cmnf wne hashnn0pnf cr wnel mnfnre df-nel
    wn nn0re con3i sylbi ax-mp eleq1 mtbiri necon2ai pnfnemnf neeq1 mpbiri jaoi
    syl ) ABCADEZFCZUJGHZIUJJKZABLUKUMULUKUJJUJJHUKJFCZJMNZUNQZOUOJMCZQUPJMPUNU
    QJRSTUAUJJFUBUCUDULUMGJKUEUJGJUFUGUHUI $.

  $( The size of a set is either 0 or 1 or greater than 1.  (Contributed by
     Alexander van der Vekens, 29-Dec-2017.) $)
  hashv01gt1 $p |- ( M e. V
                    -> ( ( # ` M ) = 0 \/ ( # ` M ) = 1 \/ 1 < ( # ` M ) ) ) $=
    ( wcel chash cfv cn0 cpnf wceq wo cc0 c1 clt wbr hashnn0pnf cn elnn0 mpbiri
    w3o jaoi syl wne exmidne nngt1ne1 orbi2d olcd 3orass sylibr 3mix1 sylbi 1re
    cr ltpnf ax-mp breq2 3mix3 ) ABCADEZFCZUPGHZIUPJHZUPKHZKUPLMZRZABNUQVBURUQU
    POCZUSIVBUPPVCVBUSVCUSUTVAIZIVBVCVDUSVCVDUTUPKUAZIUPKUBVCVAVEUTUPUCUDQUEUSU
    TVAUFUGUSUTVAUHSUIURVAVBURVAKGLMZKUKCVFUJKULUMUPGKLUNQVAUSUTUOTST $.

  ${
    $d A x $.  $d B x $.  $d x N $.
    $( The set ` ( 1 ... N ) ` has ` N ` elements.  (Contributed by Paul
       Chapman, 22-Jun-2011.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    hashfz1 $p |- ( N e. NN0 -> ( # ` ( 1 ... N ) ) = N ) $=
      ( vx cn0 wcel c1 cfz co ccrd cfv cvv cv caddc cmpt cc0 crdg com cres ccnv
      chash wceq eqid cardfz fveq2d fzfid hashgval wf1o hashgf1o f1ocnvfv2 mpan
      cfn syl 3eqtr3d ) ACDZEAFGZHIZBJBKELGMNOPQZIZAUPRIZUPIZUNSIZAUMUOURUPBUPA
      UPUAZUBUCUMUNUJDUQUTTUMEAUDBUNUPVAUEUKPCUPUFUMUSATBUPVAUGPCAUPUHUIUL $.

    $( Two finite sets have the same number of elements iff they are
       equinumerous.  (Contributed by Paul Chapman, 22-Jun-2011.)  (Revised by
       Mario Carneiro, 15-Sep-2013.) $)
    hashen $p |- ( ( A e. Fin /\ B e. Fin ) ->
                   ( ( # ` A ) = ( # ` B ) <-> A ~~ B ) ) $=
      ( vx cfn wcel wa chash cfv wceq ccrd cen wbr cvv fveq2 hashginv eqeqan12d
      cv syl5ib hashgval finnum c1 caddc co cmpt cc0 crdg cres ccnv eqid impbid
      com cdm wb carden2 syl2an bitrd ) ADEZBDEZFZAGHZBGHZIZAJHZBJHZIZABKLZUSVB
      VEVBUTCMCQUAUBUCUDUEUFUKUGZUHZHZVAVHHZIUSVEUTVAVHNUQURVIVCVJVDCAVGVGUIZOC
      BVGVKOPRVEVCVGHZVDVGHZIUSVBVCVDVGNUQURVLUTVMVACAVGVKSCBVGVKSPRUJUQAJULZEB
      VNEVEVFUMURATBTABUNUOUP $.

    $( Equinumerous sets have the same number of elements (even if they are not
       finite).  (Contributed by Mario Carneiro, 15-Apr-2015.) $)
    hasheni $p |- ( A ~~ B -> ( # ` A ) = ( # ` B ) ) $=
      ( cen wbr cfn wcel chash cfv wceq wa simpl wb enfii ancoms hashen wn cpnf
      cvv relen hashinf sylancom mpbird brrelexi enfi biimpar syl2anc brrelex2i
      adantr notbid sylan eqtr4d pm2.61dan ) ABCDZBEFZAGHZBGHZIZUMUNJUQUMUMUNKU
      MUNAEFZUQUMLUNUMURABMNABOUAUBUMUNPZJZUOQUPUTARFZURPZUOQIUMVAUSABCSUCUHUMV
      BUSUMURUNABUDUIUEARTUFUMBRFUSUPQIABCSUGBRTUJUKUL $.
  $}

  ${
    $d A f $.  $d B f $.
    $( The size of two finite sets is equal if and only if there is a bijection
       mapping one of the sets onto the other.  (Contributed by Alexander van
       der Vekens, 17-Dec-2017.) $)
    hasheqf1o $p |- ( ( A e. Fin /\ B e. Fin )
                 -> ( ( # ` A ) = ( # ` B ) <-> E. f f : A -1-1-onto-> B ) ) $=
      ( cfn wcel wa chash cfv wceq cen wbr cv wf1o wex hashen bren syl6bb ) ADE
      BDEFAGHBGHIABJKABCLMCNABOABCPQ $.

    $( There is no bijection between a finite set and an infinite set.
       (Contributed by Alexander van der Vekens, 25-Dec-2017.) $)
    fiinfnf1o $p |- ( ( A e. Fin /\ -. B e. Fin )
                      -> -. E. f f : A -1-1-onto-> B ) $=
      ( cfn wcel cv wf1o wex wfo f1ofo fofi ex syl5 exlimdv con3and ) ADEZABCFZ
      GZCHBDEZPRSCRABQIZPSABQJPTSABQKLMNO $.
  $}

  ${
    $d A f g $.  $d B f g $.  $d V f $.  $d W f $.
    $( The size of two sets is equal if there is a bijection mapping one of the
       sets onto the other.  (Contributed by Alexander van der Vekens,
       25-Dec-2017.) $)
    hasheqf1oi $p |- ( ( A e. V /\ B e. W )
                 -> ( E. f f : A -1-1-onto-> B -> ( # ` A ) = ( # ` B ) ) ) $=
      ( vg cfn wcel wa cv wf1o wex wceq wi a1d wn adantr cvv com12 cpnf biimprd
      chash cfv hasheqf1o fiinfnf1o pm2.21d 19.41v ccnv wrel f1orel f1ocnvb syl
      wb wf f1of simprl simprr fex2 syl3anc cnvexg f1oeq1 spcegv pm2.24 anabsi5
      3syl syl6 sylbid exlimiv sylbir com13 ancoms hashinf expcom impcom adantl
      ex eqtr4d 4cases ) AGHZBGHZADHZBEHZIZABCJZKZCLZAUBUCZBUBUCZMZNZNZVSVTIZWJ
      WCWLWIWFABCUDUAOVSVTPZIZWJWCWNWFWIABCUEUFOVTVSPZWKVTWOIBAFJZKZFLZPZWKBAFU
      EWFWCWSWIWFWCWSWINZWFWCIWEWCIZCLWTWEWCCUGXAWTCWEWCWTXAWEWTXAWEBAWDUHZKZWT
      XAWDUIZWEXCUMWEXDWCABWDUJQABWDUKULXAXCWRWTXAWDRHZXBRHXCWRNXAABWDUNZWAWBXE
      WEXFWCABWDUOQWEWAWBUPWEWAWBUQABWDDEURUSWDRUTWQXCFXBRBAWPXBVAVBVEWRWIVCVFV
      GSVDVHVIVPVJULVKWOWMIZWCWJXGWCIZWIWFXHWGTWHWCXGWGTMZWAXGXINWBXGWAXIWOWAXI
      NWMWAWOXIADVLVMQSQVNWCXGWHTMZWBXGXJNWAXGWBXJWMWBXJNWOWBWMXJBEVLVMVOSVOVNV
      QOVPVR $.
  $}

  ${
    $d A f $.  $d B f $.  $d F f $.  $d V f $.  $d W f $.
    $( The size of a finite set which is a one-to-one function is equal to the
       size of the function's range.  (Contributed by Alexander van der Vekens,
       12-Jan-2018.)  (Revised by Alexander van der Vekens, 4-Feb-2018.) $)
    hashf1rn $p |- ( ( A e. V /\ B e. W )
                     -> ( F : A -1-1-> B -> ( # ` F ) = ( # ` ran F ) ) ) $=
      ( vf vx wcel wa chash cfv crn wceq cvv cv wf1o wi ex syl c2nd wf1 wex f1f
      wf fex com12 adantr imp rnexg ancli cres f1o2ndf1 wfun csn df-2nd funmpt2
      cuni expcom syl5com impcom resfunexg f1oeq1 biimpd eqcoms adantl spcimedv
      sylancr com13 mpcom hasheqf1oi sylc ) ADHZBEHZIZABCUAZCJKCLZJKMZVNVOIZCNH
      ZVPNHZIZCVPFOZPZFUBZVQVRVSWAVNVOVSVLVOVSQVMVOVLVSVOABCUDZVLVSQABCUCZWEVLV
      SABDCUEZRSUFUGUHVSVTCNUIUJSVOVNWDCVPTCUKZPZVOVNWDQABCULVNVOWIWDVNVOWIWDQV
      RWCWIFWHNVRTUMVSWHNHGNGOUNLUQTGUOUPVOVNVSVOWEVNVSWFVLWEVSQVMWEVLVSWGURUGU
      SUTTCNVAVGWBWHMWIWCQZVRWJWHWBWHWBMWIWCCVPWHWBVBVCVDVEVFRVHVIUTCVPFNNVJVKR
      $.
  $}

  $( Two possibly-empty 1-based finite sets of sequential integers are equal
     iff their endpoints are equal.  (Contributed by Paul Chapman,
     22-Jun-2011.)  (Proof shortened by Mario Carneiro, 29-Mar-2014.) $)
  fz1eqb $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
               ( ( 1 ... M ) = ( 1 ... N ) <-> M = N ) ) $=
    ( cn0 wcel wa c1 cfz co wceq chash cfv fveq2 hashfz1 eqeqan12d syl5ib oveq2
    impbid1 ) ACDZBCDZEZFAGHZFBGHZIZABIZUCUAJKZUBJKZITUDUAUBJLRSUEAUFBAMBMNOABF
    GPQ $.

  ${
    $d x A $.
    $( The size function of the cardinality function.  (Contributed by Mario
       Carneiro, 19-Sep-2013.)  (Revised by Mario Carneiro, 4-Nov-2013.) $)
    hashcard $p |- ( A e. Fin -> ( # ` ( card ` A ) ) = ( # ` A ) ) $=
      ( vx cfn wcel ccrd cfv cvv cv c1 caddc co cmpt cc0 crdg com chash cardidm
      cres fveq2i hashgval wceq wss ficardom ssid ssnnfi sylancl eqid 3eqtr3a
      syl ) ACDZAEFZEFZBGBHIJKLMNORZFZUKUMFUKPFZAPFULUKUMAQSUJUKCDZUNUOUAUJUKOD
      UKUKUBUPAUCUKUDUKUKUEUFBUKUMUMUGZTUIBAUMUQTUH $.

    $( Closure of the ` # ` function.  (Contributed by Paul Chapman,
       26-Oct-2012.)  (Revised by Mario Carneiro, 13-Jul-2014.) $)
    hashcl $p |- ( A e. Fin -> ( # ` A ) e. NN0 ) $=
      ( vx cfn wcel ccrd cfv cvv cv c1 caddc co cmpt cc0 crdg com cres cn0 eqid
      chash hashgval ficardom wf1o wf hashgf1o f1of ax-mp ffvelrni syl eqeltrrd
      ) ACDZAEFZBGBHIJKLMNOPZFZASFQBAULULRZTUJUKODUMQDAUAOQUKULOQULUBOQULUCBULU
      NUDOQULUEUFUGUHUI $.

    $( Extended real closure of the ` # ` function.  (Contributed by Mario
       Carneiro, 22-Apr-2015.) $)
    hashxrcl $p |- ( A e. V -> ( # ` A ) e. RR* ) $=
      ( wcel cn0 cpnf csn cun cxr chash cfv cr nn0ssre ressxr sstri pnfxr snssi
      wss ax-mp unssi cvv elex hashf ffvelrni syl sseldi ) ABCZDEFZGZHAIJZDUGHD
      KHLMNEHCUGHQOEHPRSUFATCUIUHCABUATUHAIUBUCUDUE $.

    $( Reverse closure of the ` # ` function.  (Contributed by Mario Carneiro,
       15-Jan-2015.) $)
    hashclb $p |- ( A e. V -> ( A e. Fin <-> ( # ` A ) e. NN0 ) ) $=
      ( wcel cfn chash cfv cn0 hashcl cr nn0re wn wa cpnf pnfnre hashinf eleq1d
      neli mtbiri ex con4d syl5 impbid2 ) ABCZADCZAEFZGCZAHUFUEICZUCUDUEJUCUDUG
      UCUDKZUGKUCUHLZUGMICMINQUIUEMIABOPRSTUAUB $.
  $}

  $( A set of finite size is a finite set.  (Contributed by Alexander van der
     Vekens, 8-Dec-2017.) $)
  hashvnfin $p |- ( ( S e. V /\ N e. NN0 )
                    -> ( ( # ` S ) = N -> S e. Fin ) ) $=
    ( wcel cn0 wa chash cfv wceq cfn eleq1a adantl hashclb bicomd adantr sylibd
    wi wb ) ACDZBEDZFAGHZBIZUAEDZAJDZTUBUCQSBEUAKLSUCUDRTSUDUCACMNOP $.

  $( The size of an infinite set is not a nonnegative integer.  (Contributed by
     Alexander van der Vekens, 21-Dec-2017.)  (Proof shortened by Alexander van
     der Vekens, 18-Jan-2018.) $)
  hashnfinnn0 $p |- ( ( A e. V /\ -. A e. Fin ) -> ( # ` A ) e/ NN0 ) $=
    ( wcel cfn wn chash cfv cn0 wnel nnel hashclb biimprd syl5bi con1d imp ) AB
    CZADCZEAFGZHIZPSQSERHCZPQRHJPQTABKLMNO $.

  $( Two ways of saying a finite set is empty.  (Contributed by Paul Chapman,
     26-Oct-2012.)  (Revised by Mario Carneiro, 27-Jul-2014.) $)
  hasheq0 $p |- ( A e. V -> ( ( # ` A ) = 0 <-> A = (/) ) ) $=
    ( wcel cfn chash cfv cc0 wceq c0 wb wn wa cpnf pnfnre neli hashinf syl6eqel
    cr id 0fin eleq1d mtbiri 0re nsyl con3i adantl 2falsed cen wbr hashen mpan2
    ex c1 cfz fz10 fveq2i cn0 0nn0 hashfz1 ax-mp eqtr3i eqeq2i 3bitr3g pm2.61d2
    co en0 ) ABCZADCZAEFZGHZAIHZJZVGVHKZVLVGVMLZVJVKVNVIRCZVJVNVOMRCMRNOVNVIMRA
    BPUAUBVJVIGRVJSUCQUDVMVKKVGVKVHVKAIDVKSTQUEUFUGULVHVIIEFZHZAIUHUIZVJVKVHIDC
    VQVRJTAIUJUKVPGVIUMGUNVEZEFZVPGVSIEUOUPGUQCVTGHURGUSUTVAVBAVFVCVD $.

  $( Positive natural closure of the hash function.  (Contributed by Mario
     Carneiro, 16-Jan-2015.) $)
  hashnncl $p |- ( A e. Fin -> ( ( # ` A ) e. NN <-> A =/= (/) ) ) $=
    ( cfn wcel chash cfv cn cc0 wne c0 nnne0 wceq cn0 wo hashcl elnn0 sylib ord
    necon1ad impbid2 hasheq0 necon3bid bitrd ) ABCZADEZFCZUDGHZAIHUCUEUFUDJUCUE
    UDGUCUEUDGKZUCUDLCUEUGMANUDOPQRSUCUDGAIABTUAUB $.

  $( The empty set has size zero.  (Contributed by Mario Carneiro,
     8-Jul-2014.) $)
  hash0 $p |- ( # ` (/) ) = 0 $=
    ( c0 chash cfv cc0 wceq eqid cvv wcel wb 0ex hasheq0 ax-mp mpbir ) ABCDEZAA
    EZAFAGHNOIJAGKLM $.

  $( The size of a singleton.  (Contributed by Paul Chapman, 26-Oct-2012.)
     (Proof shortened by Mario Carneiro, 13-Feb-2013.) $)
  hashsng $p |- ( A e. V -> ( # ` { A } ) = 1 ) $=
    ( wcel csn chash cfv c1 cen wbr wceq cz 1z en2sn mpan2 wb snfi hashen mp2an
    cfn ax-mp sylibr cfz co cn0 1nn0 hashfz1 fzsn fveq2d syl5reqr syl6eq ) ABCZ
    ADZEFZGDZEFZGUKULUNHIZUMUOJZUKGKCZUPLAGBKMNULSCUNSCUQUPOAPGPULUNQRUAURUOGJL
    URGGGUBUCZEFZUOGUDCUTGJUEGUFTURUSUNEGUGUHUITUJ $.

  ${
    $d x A $.
    $( The size of a restricted class abstraction restricted to a singleton is
       a nonnegative integer.  (Contributed by Alexander van der Vekens,
       22-Dec-2017.) $)
    hashrabrsn $p |- ( # ` { x e. { A } | ph } ) e. NN0 $=
      ( csn crab wceq c0 wo chash cfv cn0 wcel eqid rabrsn fveq2 cc0 hash0 0nn0
      syl6eqel cvv eqeltri c1 hashsng 1nn0 wn snprc sylbi pm2.61i jaoi mp2b ) A
      BCDZEZULFULGFZULUKFZHULIJZKLZULMABCULNUMUPUNUMUOGIJZKULGIOUQPKQRUAZSUNUOU
      KIJZKULUKIOCTLZUSKLZUTUSUBKCTUCUDSUTUEUKGFZVACUFVBUSUQKUKGIOURSUGUHSUIUJ
      $.
  $}

  ${
    $d x y z F $.
    $( A function is equinumerous to its domain.  (Contributed by Mario
       Carneiro, 12-Mar-2015.) $)
    hashfn $p |- ( F Fn A -> ( # ` F ) = ( # ` A ) ) $=
      ( wfn cvv wcel chash cfv wceq wa cen wbr fndmeng ensym hasheni 3syl wn c0
      cdm dmexg fvprc fndm eleq1d syl5ib con3and syl adantl eqtr4d pm2.61dan )
      BACZADEZBFGZAFGZHZUIUJIABJKBAJKUMADBLABMBANOUIUJPZIZUKQULUOBDEZPUKQHUIUPU
      JUPBRZDEUIUJBDSUIUQADABUAUBUCUDBFTUEUNULQHUIAFTUFUGUH $.
  $}

  ${
    $d F f $.  $d N f $.
    $( The value of the size function on a finite 1-based sequence.
       (Contributed by Paul Chapman, 26-Oct-2012.)  (Proof shortened by Mario
       Carneiro, 12-Mar-2015.) $)
    fseq1hash $p |- ( ( N e. NN0 /\ F Fn ( 1 ... N ) ) -> ( # ` F ) = N ) $=
      ( c1 cfz co wfn cn0 wcel chash cfv hashfn hashfz1 sylan9eqr ) ACBDEZFBGHA
      IJNIJBNAKBLM $.
  $}

  ${
    $d A n z $.  $d B n $.  $d G n z $.
    hashgadd.1 $e |- G = ( rec ( ( x e. _V |-> ( x + 1 ) ) , 0 ) |` om ) $.
    $( ` G ` maps ordinal addition to integer addition.  (Contributed by Paul
       Chapman, 30-Nov-2012.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    hashgadd $p |- ( ( A e. om /\ B e. om ) ->
                     ( G ` ( A +o B ) ) = ( ( G ` A ) + ( G ` B ) ) ) $=
      ( com wcel coa co cfv caddc wceq wi c0 oveq2 fveq2d oveq2d cc0 cn0 c1 a1i
      vn vz cv csuc fveq2 eqeq12d imbi2d wf1o wf hashgf1o ax-mp ffvelrni nn0cnd
      f1of addid1d 0z om2uz0i oveq2i 3eqtr4rd w3a wa nnasuc nnacl om2uzsuci syl
      nna0 eqtrd 3adant3 cc ax-1cn addass mp3an3 syl2an oveq1 3ad2ant3 3ad2ant2
      3eqtr4d 3expia expcom a2d finds impcom ) CFGBFGZBCHIZDJZBDJZCDJZKIZLZWDBU
      BUDZHIZDJZWGWKDJZKIZLZMWDBNHIZDJZWGNDJZKIZLZMWDBUCUDZHIZDJZWGXBDJZKIZLZMW
      DBXBUEZHIZDJZWGXHDJZKIZLZMWDWJMUBUCCWKNLZWPXAWDXNWMWRWOWTXNWLWQDWKNBHOPXN
      WNWSWGKWKNDUFQUGUHWKXBLZWPXGWDXOWMXDWOXFXOWLXCDWKXBBHOPXOWNXEWGKWKXBDUFQU
      GUHWKXHLZWPXMWDXPWMXJWOXLXPWLXIDWKXHBHOPXPWNXKWGKWKXHDUFQUGUHWKCLZWPWJWDX
      QWMWFWOWIXQWLWEDWKCBHOPXQWNWHWGKWKCDUFQUGUHWDWGRKIZWGWTWRWDWGWDWGFSBDFSDU
      IFSDUJADEUKFSDUOULZUMUNZUPWTXRLWDWSRWGKARDUQEURUSUAWDWQBDBVGPUTXBFGZWDXGX
      MWDYAXGXMMWDYAXGXMWDYAXGVAZXJXDTKIZXLWDYAXJYCLXGWDYAVBZXJXCUEZDJZYCYDXIYE
      DBXBVCPYDXCFGYFYCLBXBVDAXCRDUQEVEVFVHVIYBXFTKIZWGXETKIZKIZYCXLWDYAYGYILZX
      GWDWGVJGZXEVJGZYJYAXTYAXEFSXBDXSUMUNYKYLTVJGYJVKWGXETVLVMVNVIXGWDYCYGLYAX
      DXFTKVOVPYAWDXLYILXGYAXKYHWGKAXBRDUQEVEQVQVRVHVSVTWAWBWC $.
  $}

  ${
    $d f x y A $.  $d f x y B $.
    $( A short expression for the ` G ` function of ~ hashgf1o .  (Contributed
       by Mario Carneiro, 24-Jan-2015.) $)
    hashgval2 $p |- ( # |` om ) =
      ( rec ( ( x e. _V |-> ( x + 1 ) ) , 0 ) |` om ) $=
      ( vy chash com cres cvv cv c1 caddc co cmpt cc0 crdg wceq cfv wfn wral wb
      mp2an wcel wss cn0 cpnf csn cun hashf ffn ax-mp ssv fnssres frfnom eqfnfv
      wf ccrd fvres cfn nnfi eqid hashgval syl cardnn fveq2d 3eqtr2d mprgbir )
      CDEZAFAGHIJKZLMDEZNZBGZVEOZVIVGOZNZBDVEDPZVGDPVHVLBDQRCFPZDFUAVMFUBUCUDUE
      ZCUMVNUFFVOCUGUHDUIFDCUJSLVFUKBDVEVGULSVIDTZVJVICOZVIUNOZVGOZVKVIDCUOVPVI
      UPTVSVQNVIUQAVIVGVGURUSUTVPVRVIVGVIVAVBVCVD $.

    $( Dominance relation for the size function.  (Contributed by Mario
       Carneiro, 22-Sep-2013.)  (Revised by Mario Carneiro, 22-Apr-2015.) $)
    hashdom $p |- ( ( A e. Fin /\ B e. V )
         -> ( ( # ` A ) <_ ( # ` B ) <-> A ~<_ B ) ) $=
      ( vy vx cfn wcel wa cfv cle wbr wb ccrd coa wceq com caddc cn0 ad2antlr
      co vf chash cdom cv wrex wss c1 cmin cfz fzfi ficardom ax-mp cvv cmpt cc0
      crdg cres ccnv hashgval ad2antrr hashcl simpr nn0sub2 syl3anc hashfz1 syl
      eqid syl5eq oveq12d cc nn0cnd pncan3 syl2an adantr eqtrd hashgadd sylancl
      3eqtr4d fveq2d wf1o hashgf1o nnacl f1ocnvfv1 sylancr 3eqtr3d oveq2 eqeq1d
      rspcev ex cardnn adantl oveq2d fveq2 wi oveqan12d adantlr eqeq12d nn0ge0d
      nnfi cr nn0red addge01 mpbid breq2 syl5ibcom sylbid sylan2 syl5 rexlimdva
      sylbird impbid nnawordex cdm finnum carddom2 3bitr2d wn cpnf cxr hashxrcl
      pnfge hashinf adantll breqtrrd wf1 isinffi ancoms brdomg mpbird pm2.61dan
      wex 2thd ) AFGZBCGZHZBFGZAUBIZBUBIZJKZABUCKZLZYMYPUUAYNYMYPHZYSAMIZDUDZNT
      ZBMIZOZDPUEZUUCUUFUFZYTUUBYSUUHUUBYSUUHUUBYSHZUGYRYQUHTZUITZMIZPGZUUCUUMN
      TZUUFOZUUHUULFGZUUNUGUUKUJZUULUKULZUUJUUOEUMEUDUGQTUNUOUPPUQZIZUUTURZIZUU
      FUUTIZUVBIZUUOUUFUUJUVAUVDUVBUUJUUCUUTIZUUMUUTIZQTZYRUVAUVDUUJUVHYQUUKQTZ
      YRUUJUVFYQUVGUUKQYMUVFYQOYPYSEAUUTUUTVGZUSZUTUUJUVGUULUBIZUUKUUQUVGUVLOUU
      REUULUUTUVJUSULUUJUUKRGZUVLUUKOUUJYQRGZYRRGZYSUVMYMUVNYPYSAVAZUTYPUVOYMYS
      BVAZSUUBYSVBYQYRVCVDUUKVEVFVHVIUUBUVIYROZYSYMYQVJGYRVJGUVRYPYMYQUVPVKYPYR
      UVQVKYQYRVLVMVNVOUUJUUCPGZUUNUVAUVHOYMUVSYPYSAUKZUTZUUSEUUCUUMUUTUVJVPVQY
      PUVDYROZYMYSEBUUTUVJUSZSVRVSUUJPRUUTVTZUUOPGZUVCUUOOEUUTUVJWAZUUJUVSUUNUW
      EUWAUUSUUCUUMWBVQPRUUOUUTWCWDUUJUWDUUFPGZUVEUUFOUWFYPUWGYMYSBUKZSPRUUFUUT
      WCWDWEUUGUUPDUUMPUUDUUMOUUEUUOUUFUUDUUMUUCNWFWGWHWDWIUUBUUGYSDPUUBUUDPGZH
      ZUUGUUCUUDMIZNTZUUFOZYSUWJUWLUUEUUFUWJUWKUUDUUCNUWIUWKUUDOUUBUUDWJWKWLWGU
      WMUWLUUTIZUVDOZUWJYSUWLUUFUUTWMUWIUUBUUDFGZUWOYSWNUUDWSUUBUWPHZUWOYQUUDUB
      IZQTZYROZYSUWQUWNUWSUVDYRYMUWPUWNUWSOYPYMUWPHZUWNUVFUWKUUTIZQTZUWSYMUVSUW
      KPGUWNUXCOUWPUVTUUDUKEUUCUWKUUTUVJVPVMYMUWPUVFYQUXBUWRQUVKEUUDUUTUVJUSWOV
      OWPYPUWBYMUWPUWCSWQUWQYQUWSJKZUWTYSYMUWPUXDYPUXAUOUWRJKZUXDUWPUXEYMUWPUWR
      UUDVAZWRWKYMYQWTGUWRWTGUXEUXDLUWPYMYQUVPXAUWPUWRUXFXAYQUWRXBVMXCWPUWSYRYQ
      JXDXEXFXGXHXJXIXKYMUVSUWGUUIUUHLYPUVTUWHDUUCUUFXLVMYMAMXMZGBUXGGUUIYTLYPA
      XNBXNABXOVMXPWPYOYPXQZHZYSYTUXIYQXRYRJUXIYQXSGZYQXRJKYMUXJYNUXHAFXTUTYQYA
      VFYNUXHYRXROYMBCYBYCYDUXIYTABUAUDYEUAYKZYMUXHUXKYNUXHYMUXKBAUAYFYGWPYNYTU
      XKLYMUXHABCUAYHSYIYLYJ $.
  $}

  $( Non-strict order relation of the ` # ` function on the full cardinal
     poset.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
  hashdomi $p |- ( A ~<_ B -> ( # ` A ) <_ ( # ` B ) ) $=
    ( cdom wbr cfn wcel chash cfv cle wa simpl wb reldom adantr syl2anc wn cpnf
    cvv wceq hashinf simpr brrelex2i mpbird cxr pnfxr pnfge mp1i brrelexi sylan
    hashdom domfi expcom con3and 3brtr4d pm2.61dan ) ABCDZAEFZAGHZBGHZIDZUPUQJZ
    UTUPUPUQKVAUQBRFZUTUPLUPUQUAUPVBUQABCMUBZNABRUJOUCUPUQPZJZQQURUSIQUDFQQIDVE
    UEQUFUGUPARFVDURQSABCMUHARTUIVEVBBEFZPUSQSUPVBVDVCNUPVFUQVFUPUQBAUKULUMBRTO
    UNUO $.

  $( Strict dominance relation for the size function.  (Contributed by Mario
     Carneiro, 18-Aug-2014.) $)
  hashsdom $p |- ( ( A e. Fin /\ B e. Fin )
       -> ( ( # ` A ) < ( # ` B ) <-> A ~< B ) ) $=
    ( cfn wcel wa chash cfv clt wbr cdom cen wn csdm cle hashcl cr nn0re syl2an
    cn0 wceq wne wb ltlen hashdom eqcom hashen syl5bb necon3abid anbi12d brsdom
    bitrd syl6bbr ) ACDZBCDZEZAFGZBFGZHIZABJIZABKIZLZEZABMIUOURUPUQNIZUQUPUAZEZ
    VBUMUPSDZUQSDZURVEUBZUNAOBOVFUPPDUQPDVHVGUPQUQQUPUQUCRRUOVCUSVDVAABCUDUOUTU
    QUPUQUPTUPUQTUOUTUQUPUEABUFUGUHUIUKABUJUL $.

  ${
    $d x A $.  $d x B $.
    $( The size of the union of disjoint finite sets is the sum of their
       sizes.  (Contributed by Paul Chapman, 30-Nov-2012.)  (Revised by Mario
       Carneiro, 15-Sep-2013.) $)
    hashun $p |- ( ( A e. Fin /\ B e. Fin /\ ( A i^i B ) = (/) ) ->
                   ( # ` ( A u. B ) ) = ( ( # ` A ) + ( # ` B ) ) ) $=
      ( vx cfn wcel cin c0 wceq w3a cun ccrd cfv cvv caddc co com chash 3adant3
      hashgval ficardom cv cmpt cc0 crdg cres coa ficardun fveq2d unfi eqid syl
      c1 wa hashgadd syl2an oveqan12d eqtrd 3eqtr3d ) ADEZBDEZABFGHZIZABJZKLZCM
      CUAULNOUBUCUDPUEZLZAKLZBKLZUFOZVELZVCQLZAQLZBQLZNOZVBVDVIVEABUGUHUSUTVFVK
      HZVAUSUTUMZVCDEVOABUICVCVEVEUJZSUKRUSUTVJVNHVAVPVJVGVELZVHVELZNOZVNUSVGPE
      VHPEVJVTHUTATBTCVGVHVEVQUNUOUSUTVRVLVSVMNCAVEVQSCBVEVQSUPUQRUR $.

    $( The size of the union of finite sets is less than or equal to the sum of
       their sizes.  (Contributed by Mario Carneiro, 23-Sep-2013.)  (Proof
       shortened by Mario Carneiro, 27-Jul-2014.) $)
    hashun2 $p |- ( ( A e. Fin /\ B e. Fin ) ->
                   ( # ` ( A u. B ) ) <_ ( ( # ` A ) + ( # ` B ) ) ) $=
      ( cfn wcel wa cun chash cfv cdif caddc co cle undif2 fveq2i adantl hashcl
      wceq cn0 nn0red wbr diffi cin c0 disjdif hashun mp3an3 sylan2 syl5eqr syl
      adantr cdom wss simpr difss ssdomg ee10 hashdom sylancom leadd2dd eqbrtrd
      wb mpbird ) ACDZBCDZEZABFZGHZAGHZBAIZGHZJKZVHBGHZJKLVEVGAVIFZGHZVKVMVFGAB
      MNVDVCVICDZVNVKQZBAUAZVCVOAVIUBUCQVPABUDAVIUEUFUGUHVEVJVLVHVEVJVEVOVJRDVD
      VOVCVQOZVIPUISVEVLVDVLRDVCBPOSVEVHVCVHRDVDAPUJSVEVJVLLTZVIBUKTZVEVDVIBULV
      TVCVDUMBAUNVIBCUOUPVCVDVOVSVTVAVRVIBCUQURVBUSUT $.

    $( The size of the union of finite sets is the sum of their sizes minus the
       size of the intersection.  (Contributed by Mario Carneiro,
       6-Aug-2017.) $)
    hashun3 $p |- ( ( A e. Fin /\ B e. Fin ) -> ( # ` ( A u. B ) ) =
      ( ( ( # ` A ) + ( # ` B ) ) - ( # ` ( A i^i B ) ) ) ) $=
      ( cfn wcel chash cfv cin cmin co caddc cun c0 adantl wss incom a1i hashcl
      wceq cn0 nn0cnd wa cdif diffi simpl inss1 sylancl sslin ax-mp eqtri sseq0
      ssfi disjdif mp2an hashun syl3anc uneq2i inundif 3eqtri fveq2d eqtr3d syl
      subadd2d mpbird oveq2d adantr addsubassd undif2 fveq2i syl5eqr 3eqtr4rd
      uncom ) ACDZBCDZUAZAEFZBEFZABGZEFZHIZJIVOBAUBZEFZJIZVOVPJIVRHIABKZEFZVNVS
      WAVOJVNVSWARWAVRJIZVPRVNVTVQKZEFZWEVPVNVTCDZVQCDZVTVQGZLRZWGWERVMWHVLBAUC
      MZVNVLVQANZWIVLVMUDZABUEZAVQUKUFZWKVNWJVTAGZNZWQLRWKWMWRWOVQAVTUGUHWQAVTG
      ZLVTAOABULZUIWJWQUJUMPVTVQUNUOVNWFBEWFBRVNWFVTBAGZKXAVTKBVQXAVTABOUPVTXAV
      KBAUQURPUSUTVNVPVRWAVNVPVMVPSDVLBQMTZVNVRVNWIVRSDWPVQQVATZVNWAVNWHWASDWLV
      TQVATVBVCVDVNVOVPVRVNVOVLVOSDVMAQVETXBXCVFVNWDAVTKZEFZWBXDWCEABVGVHVNVLWH
      WSLRZXEWBRWNWLXFVNWTPAVTUNUOVIVJ $.
  $}

  $( The extended real addition of the size of an infinite set with the size of
     an arbitrary set yields plus infinity.  (Contributed by Alexander van der
     Vekens, 20-Dec-2017.) $)
  hashinfxadd $p |- ( ( A e. V /\ B e. W /\ ( # ` A ) e/ NN0 )
                      -> ( ( # ` A ) +e ( # ` B ) ) = +oo ) $=
    ( chash cfv cpnf wceq cn0 wcel wn wa wnel w3a cxad co wo wi hashnn0pnf syl
    df-nel anbi2i pm5.61 bitri biimpi ex orcoms imp 3adant2 oveq1 cmnf hashxrcl
    cxr wne hashnemnf jca 3ad2ant2 xaddpnf2 sylan9eqr expcom adantr mpcom ) AEF
    ZGHZVCIJZKZLZACJZBDJZVCIMZNZVCBEFZOPZGHZVHVJVGVIVHVJVGVHVEVDQVJVGRZACSVDVEV
    OVDVEQZVJVGVPVJLZVGVQVPVFLVGVJVFVPVCIUAUBVDVEUCUDUEUFUGTUHUIVDVKVNRVFVKVDVN
    VDVKVMGVLOPZGVCGVLOUJVKVLUMJZVLUKUNZLZVRGHVIVHWAVJVIVSVTBDULBDUOUPUQVLURTUS
    UTVAVB $.

  $( The size of the union of disjoint sets is the result of the extended real
     addition of their sizes, analogous to ~ hashun .  (Contributed by
     Alexander van der Vekens, 21-Dec-2017.) $)
  hashunx $p |- ( ( A e. V /\ B e. W /\ ( A i^i B ) = (/) ) ->
                  ( # ` ( A u. B ) ) = ( ( # ` A ) +e ( # ` B ) ) ) $=
    ( wcel wceq cfn wa chash cfv cxad co wi cr hashcl eqcomd eqtrd wn cpnf ex
    cin c0 w3a cun caddc hashun 3expa nn0red anim12i adantr rexadd syl 3ad2ant3
    expcom cvv unexg unfir con3i hashinf syl2anr wo cn0 wnel simprl hashnfinnn0
    ianor simprr impcom hashinfxadd syl3anc cxr hashxrcl xaddcom jaoi sylbi imp
    adantl 3adant3 pm2.61d ) ACEZBDEZABUAUBFZUCAGEZBGEZHZABUDZIJZAIJZBIJZKLZFZW
    BVTWEWKMWAWEWBWKWEWBHZWGWHWIUELZWJWCWDWBWGWMFABUFUGWLWJWMWLWHNEZWINEZHZWJWM
    FWEWPWBWCWNWDWOWCWHAOUHWDWIBOUHUIUJWHWIUKULPQUNUMVTWAWERZWKMWBWQVTWAHZWKWQW
    RHWGSWJWRWFUOEWFGEZRWGSFWQABCDUPWSWEABUQURWFUOUSUTWQWRSWJFZWQWCRZWDRZVAWRWT
    MZWCWDVFXAXCXBXAWRWTXAWRHZWJSXDVTWAWHVBVCZWJSFXAVTWAVDXAVTWAVGWRXAXEVTXAXEM
    WAVTXAXEACVETUJVHABCDVIVJPTXBWRWTXBWRHZWJSXFWJWIWHKLZSXFWHVKEZWIVKEZHZWJXGF
    WRXJXBVTXHWAXIACVLBDVLUIVQWHWIVMULXFWAVTWIVBVCZXGSFXBVTWAVGXBVTWAVDWRXBXKWA
    XBXKMVTWAXBXKBDVETVQVHBADCVIVJQPTVNVOVPQUNVRVS $.

  $( The cardinality of a set is greater than or equal to zero.  (Contributed
     by Thierry Arnoux, 2-Mar-2017.) $)
  hashge0 $p |- ( A e. V -> 0 <_ ( # ` A ) ) $=
    ( wcel cdom wbr chash cfv cle cc0 0domg hashdomi hash0 breq1i biimpi 3syl
    c0 ) ABCPADEPFGZAFGZHEZIRHEZABJPAKSTQIRHLMNO $.

  $( The cardinality of a non-empty set is greater than zero.  (Contributed by
     Thierry Arnoux, 2-Mar-2017.) $)
  hashgt0 $p |- ( ( A e. V /\ A =/= (/) ) -> 0 < ( # ` A ) ) $=
    ( wcel c0 wne cc0 chash cfv cle wbr wa clt hashge0 adantr hasheq0 necon3bid
    biimpar jca cxr wb 0xr hashxrcl xrltlen sylancr syldan ) ABCZADEZFAGHZIJZUH
    FEZKZFUHLJZUFUGKUIUJUFUIUGABMNUFUJUGUFUHFADABOPQRUFULUKUFFSCUHSCULUKTUAABUB
    FUHUCUDQUE $.

  $( The cardinality of a non-empty set is greater or equal to one.
     (Contributed by Thierry Arnoux, 20-Jun-2017.) $)
  hashge1 $p |- ( ( A e. V /\ A =/= (/) ) -> 1 <_ ( # ` A ) ) $=
    ( wcel c0 wne wa cfn c1 chash cfv cle wbr cn simpr hashnncl biimpar syl2anc
    simplr nnge1d cpnf cxr 1re rexri pnfge ax-mp wceq hashinf adantlr syl5breqr
    wn pm2.61dan ) ABCZADEZFZAGCZHAIJZKLUNUOFZUPUQUOUMUPMCZUNUONULUMUORUOURUMAO
    PQSUNUOUJZFHTUPKHUACHTKLHUBUCHUDUEULUSUPTUFUMABUGUHUIUK $.

  $( If a nonnegative integer is the size of a set which contains at least one
     element, this integer is a positive integer.  (Contributed by Alexander
     van der Vekens, 9-Jan-2018.) $)
  hashnn0n0nn $p |- ( ( ( V e. W /\ Y e. NN0 )
                     /\ ( ( # ` V ) = Y /\ N e. V ) ) -> Y e. NN ) $=
    ( chash cfv wceq wcel wa cn0 cn wi c1 cle wbr c0 wne ne0i cc0 eleq1 hashge1
    sylan2 simpr clt wn 0lt1 0re 1re ltnlei mpbi mtbiri necon2ai adantr elnnne0
    breq2 sylanbrc ex syl impancom com12 anbi2d imbi12d syl5ib imp impcom ) BEF
    ZDGZABHZIBCHZDJHZIZDKHZVGVHVKVLLZVHVIVFJHZIZVFKHZLVGVMVOVHVPVIVHVNVPVIVHIMV
    FNOZVNVPLVHVIBPQVQBARBCUAUBVQVNVPVQVNIVNVFSQZVPVQVNUCVQVRVNVQVFSVFSGVQMSNOZ
    SMUDOVSUEUFSMUGUHUIUJVFSMNUOUKULUMVFUNUPUQURUSUTVGVOVKVPVLVGVNVJVIVFDJTVAVF
    DKTVBVCVDVE $.

  $( The size of the union of a finite set with a disjoint singleton is one
     more than the size of the set.  (Contributed by Paul Chapman,
     30-Nov-2012.) $)
  hashunsng $p |- ( B e. V -> ( ( A e. Fin /\ -. B e. A ) ->
                    ( # ` ( A u. { B } ) ) = ( ( # ` A ) + 1 ) ) ) $=
    ( cfn wcel wn wa csn cun chash cfv c1 caddc co wceq cin disjsn snfi hashun
    c0 mp3an2 sylan2br hashsng oveq2d sylan9eq expcom ) ADEZBAEFZGZBCEZABHZIJKZ
    AJKZLMNZOUIUJULUMUKJKZMNZUNUHUGAUKPTOZULUPOZABQUGUKDEUQURBRAUKSUAUBUJUOLUMM
    BCUCUDUEUF $.

  ${
    $( The size of an unordered pair.  (Contributed by Mario Carneiro,
       27-Sep-2013.)  (Revised by Mario Carneiro, 5-May-2016.) $)
    hashprg $p |- ( ( A e. V /\ B e. V ) ->
      ( A =/= B <-> ( # ` { A , B } ) = 2 ) ) $=
      ( wcel wa wne cpr chash cfv c2 wceq csn cun c1 caddc co simpr imp adantr
      wn elsni eqcomd necon3ai cfn hashunsng mpanr1 syl2an hashsng oveq1d eqtrd
      snfi df-pr fveq2i df-2 3eqtr4g 1ne2 a1i eqnetrd dfsn2 preq2 fveq2d neeq1d
      syl5req syl5ibrcom necon2d impbida ) ACDZBCDZEZABFZABGZHIZJKZVIVJEZALZBLM
      ZHIZNNOPZVLJVNVQVOHIZNOPZVRVIVHBVODZTZVQVTKZVJVGVHQWAABWABABAUAUBUCVHVOUD
      DZWBWCAUKVHWDWBEWCVOBCUERUFUGVNVSNNOVIVSNKZVJVGWEVHACUHSZSUIUJVKVPHABULUM
      UNUOVIVMVJVIABVLJVIVLJFABKZVSJFVIVSNJWFNJFVIUPUQURWGVLVSJWGVKVOHWGVOAAGVK
      AUSABAUTVCVAVBVDVERVF $.
  $}

  $( If one element of an unordered pair is not a set, the size of the
     unordered pair is not 2.  (Contributed by Alexander van der Vekens,
     7-Oct-2017.) $)
  elprchashprn2 $p |- ( -. M e. _V -> -. ( # ` { M , N } ) = 2 ) $=
    ( cvv wcel wn wceq chash cfv c2 c1 wa fveq2 eqcomd eqeq1d biimpa id wne syl
    c0 cc0 cpr csn prprc1 wi hashsng 1ne2 a1i eqnetrd neneqd expcom snprc eqeq2
    hash0 2ne0 necomi sylancl ex sylbi pm2.61i ) ACDEABUAZBUBZFZUTGHZIFEZABUCBC
    DZVBVDUDZVEVAGHZJFZVFBCUEVBVHVDVBVHKVCJFZVDVBVHVIVBVGVCJVBVCVGUTVAGLMNOVIVC
    IVIVCJIVIPJIQVIUFUGUHUIRUJRVEEVASFZVFBUKVJVBVDVJVBKUTSFZSGHZTFZVDVJVBVKVASU
    TULOUMVKVMKVCTFZVDVKVMVNVKVLVCTVKVCVLUTSGLMNOVNVCIVNVCTIVNPTIQVNITUNUOUGUHU
    IRUPUQURUSR $.

  $( The size of an unordered pair is 2 if and only if its elements are
     different sets.  (Contributed by Alexander van der Vekens,
     17-Jan-2018.) $)
  hashprb $p |- ( ( M e. _V /\ N e. _V /\ M =/= N )
                  <-> ( # ` { M , N } ) = 2 ) $=
    ( cvv wcel wne w3a cpr chash cfv c2 hashprg biimp3a wi elprchashprn2 pm2.21
    wceq wn syl prcom wa fveq2i eqeq1i sylnbi simpll simplr biimpar 3jca impbii
    ex ecase ) ACDZBCDZABEZFZABGZHIZJPZUKULUMUQABCKZLUKULUQUNMZUKQUQQUSABNUQUNO
    ZRULQBAGZHIZJPZQUSBANVCUQUSVBUPJVAUOHBASUAUBUTUCRUKULTZUQUNVDUQTUKULUMUKULU
    QUDUKULUQUEVDUMUQURUFUGUIUJUH $.

  $( If the size of a set is less than or equal to zero, the set must be
     empty.  (Contributed by Alexander van der Vekens, 6-Jan-2018.) $)
  hashle00 $p |- ( V e. W -> ( ( # ` V ) <_ 0 <-> V = (/) ) ) $=
    ( wcel chash cfv cc0 cle wbr c0 wceq cn0 cpnf wo wi hashnn0pnf nn0pnfge0 wa
    cxr wb hashxrcl 0xr xrletri3 sylancl hasheq0 biimpd sylbird com12 com23 syl
    expcom mpcom 0le0 fveq2 breq1d hash0 breq1i a1i sylan9bbr mpbiri ex impbid
    ) ABCZADEZFGHZAIJZVCKCVCLJMZVBVDVENZABOVFFVCGHZVBVGNVCPVHVDVBVEVDVHVBVENVBV
    DVHQZVEVBVIVCFJZVEVBVCRCFRCVJVISABTUAVCFUBUCVBVJVEABUDUEUFUGUJUHUIUKVBVEVDV
    BVEQVDFFGHZULVEVDIDEZFGHZVBVKVEVCVLFGAIDUMUNVMVKSVBVLFFGUOUPUQURUSUTVA $.

  ${
    $d V x $.
    $( If the size of a set is greater than zero, the set must contain at least
       one element.  (Contributed by Alexander van der Vekens, 6-Jan-2018.) $)
    hashgt0elex $p |- ( ( V e. W /\ 0 < ( # ` V ) ) -> E. x x e. V ) $=
      ( wcel cc0 chash cfv clt wbr cv wex wn wa cle c0 wceq adantr mpbird cxr
      wb wal wi eq0 biimpri a1d sylbir impcom hashle00 hashxrcl xrlenlt sylancl
      alnex 0xr bicomd ex con4d imp ) BCDZEBFGZHIZAJBDZAKZURVBUTURVBLZUTLZURVCM
      ZVDUSENIZVEVFBOPZVCURVGVCVALAUAZURVGUBVAAULVHVGURVGVHABUCUDUEUFUGURVFVGTV
      CBCUHQRURVDVFTVCURVFVDURUSSDESDVFVDTBCUIUMUSEUJUKUNQRUOUPUQ $.

    $( The size of a set is greater than zero if and only if the set contains
       at least one element.  (Contributed by Alexander van der Vekens,
       18-Jan-2018.) $)
    hashgt0elexb $p |- ( V e. W -> ( 0 < ( # ` V ) <-> E. x x e. V ) ) $=
      ( wcel cc0 chash cfv clt wbr cv wex hashgt0elex c0 wne n0 hashgt0 impbida
      sylan2br ) BCDZEBFGHIZAJBDAKZABCLUASBMNTABOBCPRQ $.
  $}

  ${
    hashp1i.1 $e |- A e. om $.
    hashp1i.2 $e |- B = suc A $.
    hashp1i.3 $e |- ( # ` A ) = M $.
    hashp1i.4 $e |- ( M + 1 ) = N $.
    $( Size of a finite ordinal.  (Contributed by Mario Carneiro,
       5-Jan-2016.) $)
    hashp1i $p |- ( # ` B ) = N $=
      ( chash cfv csn cun csuc eqtri c1 caddc co wcel com ax-mp df-suc cfn wceq
      fveq2i wn nnfi word nnord ordirr mp2b wa wi hashunsng mp2an oveq1i ) BIJA
      AKLZIJZDBUPIBAMUPFAUANUDUQAIJZOPQZDAUBRZAARUEZUQUSUCZASRZUTEAUFTVCAUGVAEA
      UHAUIUJVCUTVAUKVBULEAASUMTUNUSCOPQDURCOPGUOHNNN $.
  $}

  $( Size of a finite ordinal.  (Contributed by Mario Carneiro, 5-Jan-2016.) $)
  hash1 $p |- ( # ` 1o ) = 1 $=
    ( c0 c1o cc0 c1 peano1 df-1o hash0 0p1e1 hashp1i ) ABCDEFGHI $.

  $( Size of a finite ordinal.  (Contributed by Mario Carneiro, 5-Jan-2016.) $)
  hash2 $p |- ( # ` 2o ) = 2 $=
    ( c1o c2o c1 c2 1onn df-2o hash1 1p1e2 hashp1i ) ABCDEFGHI $.

  $( Size of a finite ordinal.  (Contributed by Mario Carneiro, 5-Jan-2016.) $)
  hash3 $p |- ( # ` 3o ) = 3 $=
    ( c2o c3o c2 c3 2onn df-3o hash2 2p1e3 hashp1i ) ABCDEFGHI $.

  $( Size of a finite ordinal.  (Contributed by Mario Carneiro, 5-Jan-2016.) $)
  hash4 $p |- ( # ` 4o ) = 4 $=
    ( c3o c4o c3 c4 3onn df-4o hash3 3p1e4 hashp1i ) ABCDEFGHI $.

  $( The size of the difference of a finite set and a subset is the set's size
     minus the subset's.  (Contributed by Steve Rodriguez, 24-Oct-2015.) $)
  hashssdif $p |- ( ( A e. Fin /\ B C_ A ) ->
    ( # ` ( A \ B ) ) = ( ( # ` A ) - ( # ` B ) ) ) $=
    ( cfn wcel wss wa chash cfv cmin co cdif wceq caddc wb eqcomd hashcl nn0cnd
    cc cn0 syl cun ssfi diffi cin c0 disjdif hashun mp3an3 syl2an anabss1 undif
    biimpi fveq2d eqeq1d adantl mpbid subadd syl3an 3anidm13 anabss5 mpbird ) A
    CDZBAEZFZAGHZBGHZIJZABKZGHZVDVGVILZVFVIMJZVELZVDVEVKVDBVHUAZGHZVKLZVEVKLZVB
    VCVOVDBCDZVHCDZVOVBABUBZABUCZVQVRBVHUDUELVOBAUFBVHUGUHUIUJVCVOVPNVBVCVNVEVK
    VCVMAGVCVMALBAUKULUMUNUOUPOVBVCVJVLNZVBVDWAVBVERDVDVFRDVBVIRDWAVBVEAPQVDVFV
    DVQVFSDVSBPTQVBVIVBVRVISDVTVHPTQVEVFVIUQURUSUTVAO $.

  $( The size of the difference of a finite set and another set is the first
     set's size minus that of the intersection of both.  (Contributed by Steve
     Rodriguez, 24-Oct-2015.) $)
  hashdif $p |- ( A e. Fin ->
    ( # ` ( A \ B ) ) = ( ( # ` A ) - ( # ` ( A i^i B ) ) ) ) $=
    ( cfn wcel cdif chash cfv cin cmin co difin fveq2i wss wceq inss1 hashssdif
    mpan2 syl5eqr ) ACDZABEZFGAABHZEZFGZAFGUAFGIJZUBTFABKLSUAAMUCUDNABOAUAPQR
    $.

  $( The size of the difference of a finite set and a singleton subset is the
     set's size minus 1.  (Contributed by Alexander van der Vekens,
     6-Jan-2018.) $)
  hashdifsn $p |- ( ( A e. Fin /\ B e. A )
                    -> ( # ` ( A \ { B } ) ) = ( ( # ` A ) - 1 ) ) $=
    ( cfn wcel wa csn cdif chash cfv cmin co c1 wss wceq snssi hashssdif sylan2
    hashsng adantl oveq2d eqtrd ) ACDZBADZEZABFZGHIZAHIZUEHIZJKZUGLJKUCUBUEAMUF
    UINBAOAUEPQUDUHLUGJUCUHLNUBBARSTUA $.

  $( Get an upper bound on a concretely specified finite set.  Base case:
     singleton set.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
  hashsnlei $p |- ( { A } e. Fin /\ ( # ` { A } ) <_ 1 ) $=
    ( csn cfn wcel chash cfv c1 cle wbr snfi cvv hashsng 1le1 syl6eqbr cc0 wceq
    wn c0 snprc biimpi fveq2d hash0 syl6eq 0le1 pm2.61i pm3.2i ) ABZCDUGEFZGHIZ
    AJAKDZUIUJUHGGHAKLMNUJQZUHOGHUKUHREFOUKUGREUKUGRPASTUAUBUCUDNUEUF $.

  ${
    $d V a $.
    $( The size of a set is 1 if and only if it is a singleton (containing a
       set).  (Contributed by Alexander van der Vekens, 7-Dec-2017.) $)
    hash1snb $p |- ( V e. W -> ( ( # ` V ) = 1 <-> E. a V = { a } ) ) $=
      ( wcel chash cfv c1 wceq cv csn wex cfn wi wa c1o cen wn cpnf ax-mp cvv
      wbr id hash1 syl6eqr adantl wb com 1onn nnfi mp1i hashen sylan2 mpbid en1
      sylib ex a1d hashinf eqeq1 wne 1re renepnf df-ne pm2.21 eqcoms syl6bi syl
      cr sylbi expcom pm2.61i fveq2 vex hashsng syl6eq exlimiv impbid1 ) ABDZAE
      FZGHZACIZJZHZCKZALDZVRVTWDMZMWEWFVRWEVTWDWEVTNZAOPUAZWDWGVSOEFZHZWHVTWJWE
      VTVSGWIVTUBUCUDUEVTWEOLDZWJWHUFOUGDWKVTUHOUIUJAOUKULUMCAUNUOUPUQVRWEQZWFV
      RWLNVSRHZWFABURWMVTRGHWDVSRGUSWDGRGRUTZGRHZWDMZGVHDWNVAGVBSWNWOQWPGRVCWOW
      DVDVISVEVFVGVJVKWCVTCWCVSWBEFZGAWBEVLWATDWQGHCVMWATVNSVOVPVQ $.
  $}

  ${
    $d W a $.  $d V a b $.
    $( In a set with more than one element are two different elements.
       (Contributed by Alexander van der Vekens, 15-Nov-2017.) $)
    hashgt12el $p |- ( ( V e. W /\ 1 < ( # ` V ) )
                       -> E. a e. V E. b e. V a =/= b ) $=
      ( c0 wceq wcel c1 chash cfv clt wbr wa wne wrex wi cc0 cle wn wral biimpd
      hash0 fveq2 syl5eqr breq2 eqcoms 0le1 0re 1re lenlti pm2.21 sylbi syl6com
      cv ax-mp adantl com12 syl df-ne necom bitr3i weq ralnex nne equcom ralbii
      bitri csn eqsn bicomd ralbidv cfn hashsnlei simpri syl6eqbr a1i reximdva0
      wb r19.36av sylbid cxr hashxrcl adantr rexri xrlenlt sylancl sylibd con4d
      syl5bi impancom pm2.61i ) EAFZABGZHAIJZKLZMZCUNZDUNZNZDAOZCAOZPZWLQWNFZXB
      WLQEIJWNUBEAIUCUDWPXCXAWOXCXAPWMXCWOHQKLZXAWOXDPWNQWNQFWOXDWNQHKUEUAUFQHR
      LZXDXAPZUGXEXDSXFQHUHUIUJXDXAUKULUOUMUPUQURWLSZAENZXBXGEANXHEAUSEAUTVAWPX
      HXAWMXHWOXAWMXHMZXAWOXASZDCVBZDATZCATZXIWOSZXJWTSZCATXMWTCAVCXOXLCAXOWSSZ
      DATXLWSDAVCXPXKDAXPCDVBXKWQWRVDCDVEVGVFVAVFVAXIXMWNHRLZXNXIXMAWQVHZFZCATZ
      XQXIXLXSCAXIXSXLXHXSXLVRWMDAWQVIUPVJVKXIXSXQPZCAOXTXQPWMYACAYAWMWQAGMXSWN
      XRIJZHRAXRIUCXRVLGYBHRLWQVMVNVOVPVQXSXQCAVSURVTXIWNWAGZHWAGXQXNVRWMYCXHAB
      WBWCHUIWDWNHWEWFWGWIWHWJUQULWK $.

    $d A b $.
    $( In a set with more than one element are two different elements.
       (Contributed by Alexander van der Vekens, 15-Nov-2017.) $)
    hashgt12el2 $p |- ( ( V e. W /\ 1 < ( # ` V ) /\ A e. V )
                       -> E. b e. V A =/= b ) $=
      ( c0 wceq wcel c1 chash cfv clt wbr wne wi cc0 cle wn wa wb adantr w3a cv
      wrex hash0 fveq2 syl5eqr breq2 biimpd eqcoms 0le1 0re lenlti pm2.21 sylbi
      ax-mp syl6com 3ad2ant2 syl5com df-ne necom bitr3i wral ralnex eqcom bitri
      1re nne ralbii csn bicomd adantl hashsnlei simpri breq1d mpbiri ex sylbid
      eqsn cfn cxr hashxrcl rexri xrlenlt sylancl sylibd con4d exp31 com24 3imp
      syl5bi com12 pm2.61i ) EBFZBCGZHBIJZKLZABGZUAZADUBZMZDBUCZNZWMOWOFZWRXAWM
      OEIJWOUDEBIUEUFWPWNXCXANWQXCWPHOKLZXAWPXDNWOOWOOFWPXDWOOHKUGUHUIOHPLZXDXA
      NZUJXEXDQXFOHUKVFULXDXAUMUNUOUPUQURWMQZBEMZXBXGEBMXHEBUSEBUTVAWRXHXAWNWPW
      QXHXANWNXHWQWPXAWNXHWQWPXANWNXHRZWQRZXAWPXAQZWSAFZDBVBZXJWPQZXKWTQZDBVBXM
      WTDBVCXOXLDBXOAWSFXLAWSVGAWSVDVEVHVAXJXMWOHPLZXNXJXMBAVIZFZXPXIXMXRSZWQXH
      XSWNXHXRXMDBAVRVJVKTXJXRXPXJXRRXPXQIJZHPLZXQVSGYAAVLVMXRXPYASXJXRWOXTHPBX
      QIUEVNVKVOVPVQXJWOVTGZHVTGXPXNSXIYBWQWNYBXHBCWATTHVFWBWOHWCWDWEWJWFWGWHWI
      WKUNWL $.
  $}

  ${
    hashunlei.c $e |- C = ( A u. B ) $.
    hashunlei.a $e |- ( A e. Fin /\ ( # ` A ) <_ K ) $.
    hashunlei.b $e |- ( B e. Fin /\ ( # ` B ) <_ M ) $.
    hashunlei.k $e |- K e. NN0 $.
    hashunlei.m $e |- M e. NN0 $.
    hashunlei.n $e |- ( K + M ) = N $.
    $( Get an upper bound on a concretely specified finite set.  Induction
       step: union of two finite bounded sets.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    hashunlei $p |- ( C e. Fin /\ ( # ` C ) <_ N ) $=
      ( cfn wcel chash cfv cle wbr mp2an nn0rei cun simpli eqeltri caddc fveq2i
      unfi co hashun2 eqbrtri simpri cn0 hashcl ax-mp le2addi readdcli eqeltrri
      breqtri cr letri pm3.2i ) CMNZCOPZFQRZCABUAZMGAMNZBMNZVDMNVEAOPZDQRZHUBZV
      FBOPZEQRZIUBZABUFSUCZVBVGVJUDUGZQRVNFQRVCVBVDOPZVNQCVDOGUEVEVFVOVNQRVIVLA
      BUHSUIVNDEUDUGZFQVHVKVNVPQRVEVHHUJVFVKIUJVGVJDEVGVEVGUKNVIAULUMTZVJVFVJUK
      NVLBULUMTZDJTZEKTZUNSLUQVBVNFVBVAVBUKNVMCULUMTVGVJVQVRUOVPFURLDEVSVTUOUPU
      SSUT $.
  $}

  ${
    hashsslei.b $e |- B C_ A $.
    hashsslei.a $e |- ( A e. Fin /\ ( # ` A ) <_ N ) $.
    hashsslei.n $e |- N e. NN0 $.
    $( Get an upper bound on a concretely specified finite set.  Transfer
       boundedness to a subset.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    hashsslei $p |- ( B e. Fin /\ ( # ` B ) <_ N ) $=
      ( cfn wcel chash cfv cle wbr wss simpli ssfi mp2an hashcl ax-mp nn0rei
      cn0 cdom ssdomg mp2 wb hashdom mpbir simpri letri pm3.2i ) BGHZBIJZCKLZAG
      HZBAMZUJUMAIJZCKLZENZDABOPZUKUOKLZUPULUSBAUALZUMUNUTUQDBAGUBUCUJUMUSUTUDU
      RUQBAGUEPUFUMUPEUGUKUOCUKUJUKTHURBQRSUOUMUOTHUQAQRSCFSUHPUI $.
  $}

  $( An unordered pair has at most two elements.  (Contributed by Mario
     Carneiro, 11-Feb-2015.) $)
  hashprlei $p |- ( { A , B } e. Fin /\ ( # ` { A , B } ) <_ 2 ) $=
    ( csn cpr c1 c2 df-pr hashsnlei 1nn0 1p1e2 hashunlei ) ACBCABDEEFABGAHBHIIJ
    K $.

  ${
    $d V a b $.
    $( A set of size two is an unordered pair.  (Contributed by Alexander van
       der Vekens, 8-Dec-2017.) $)
    hash2pr $p |- ( ( V e. W /\ ( # ` V ) = 2 ) -> E. a E. b V = { a , b } ) $=
      ( wcel chash cfv c2 wceq wa c2o cen wbr cv cpr wex cfn cn0 wi mpan2 hash2
      2nn0 hashvnfin imp eqcomi a1i eqeq2d wb com 2onn nnfi ax-mp hashen biimpd
      sylbid adantld mpcom en2 syl ) ABEZAFGZHIZJZAKLMZACNDNOIDPCPAQEZVCVDUTVBV
      EUTHREVBVESUBAHBUCTUDVEVBVDUTVEVBVAKFGZIZVDVEHVFVAHVFIVEVFHUAUEUFUGVEVGVD
      VEKQEZVGVDUHKUIEVHUJKUKULAKUMTUNUOUPUQCDAURUS $.

    $d W a b $.
    $( A set of size two is an unordered pair of two different elements.
       (Contributed by Alexander van der Vekens, 8-Dec-2017.) $)
    hash2prde $p |- ( ( V e. W /\ ( # ` V ) = 2 )
                    -> E. a E. b ( a =/= b /\ V = { a , b } ) ) $=
      ( wcel chash cfv c2 wceq wa cv wex wne wi weq vex c1 cvv ax-mp syl6bi cpr
      hash2pr equid csn preqsn eqeq2 fveq2 hashsng syl6eq eqeq1 wn df-ne pm2.21
      1ne2 sylbi eqcoms adantl syl5com com13 com12 sylbir mpan2 pm2.61ine simpr
      imp ax-1 jca ex 2eximdv mpd ) ABEZAFGZHIZJZACKZDKZUAZIZDLCLVOVPMZVRJZDLCL
      ABCDUBVNVRVTCDVNVRVTVNVRJZVSVRWAVSNZVOVPCDOZDDOZWBDUCWCWDJVQVPUDZIZWBVOVP
      VPCPDPZWGUEWAWFVSVNVRWFVSNWFVRVNVSWFVRAWEIZVNVSNVQWEAUFWHVLQIZVNVSWHVLWEF
      GZQAWEFUGVPREWJQIWGVPRUHSUIVMWIVSNVKVMWIHQIVSVLHQUJVSQHQHMZQHIZVSNZUNWKWL
      UKWMQHULWLVSUMUOSUPTUQURTUSVEUTVAVBVSWAVFVCVNVRVDVGVHVIVJ $.

    $( A set of size two is an unordered pair if and only if it contains two
       different elements.  (Contributed by Alexander van der Vekens,
       14-Jan-2018.) $)
    hash2prb $p |- ( V e. W -> ( ( # ` V ) = 2
                    <-> E. a E. b ( a =/= b /\ V = { a , b } ) ) ) $=
      ( wcel chash cfv c2 wceq cv wne cpr wa wex hash2prde ex wi cvv vex a1i wb
      hashprg mp2an biimpd fveq2 eqeq1d sylibrd impcom exlimdvv impbid ) ABEZAF
      GZHIZCJZDJZKZAUNUOLZIZMZDNCNZUKUMUTABCDOPUKUSUMCDUSUMQUKURUPUMURUPUQFGZHI
      ZUMURUPVBUPVBUAZURUNREUOREVCCSDSUNUORUBUCTUDURULVAHAUQFUEUFUGUHTUIUJ $.
  $}

  $( An unordered triple has at most three elements.  (Contributed by Mario
     Carneiro, 11-Feb-2015.) $)
  hashtplei $p |- ( { A , B , C } e. Fin /\ ( # ` { A , B , C } ) <_ 3 ) $=
    ( cpr csn ctp c2 c1 c3 df-tp hashprlei hashsnlei 2nn0 1nn0 2p1e3 hashunlei
    ) ABDCEABCFGHIABCJABKCLMNOP $.

  $( The size of an unordered triple of three different elements.  (Contributed
     by Alexander van der Vekens, 10-Nov-2017.) $)
  hashtpg $p |- ( ( A e. _V /\ B e. _V /\ C e. _V )
    -> ( ( A =/= B /\ B =/= C /\ C =/= A ) <-> ( # ` { A , B , C } ) = 3 ) ) $=
    ( cvv wcel wne ctp chash cfv c3 wceq wa c2 wn a1i wo wi wbr clt ax-mp caddc
    w3a cpr csn cun c1 cfn simpl3 prfi w3o elprg orcom nne eqcom bicomi orbi12i
    co bitri syl6bb biimpd 3ad2ant3 imp olcd ex 3orass syl6ibr 3ianor hashunsng
    con2d syl12anc simpr1 wb 3simpa adantr hashprg syl mpbid oveq1d eqtrd df-tp
    fveq2i 3eqtr4g cle hashprlei cz hashcl nn0zd 2z zleltp1 2p1e3 breq2d sylbid
    mp2an cr nn0red 3re ltnei necomd adantl tpeq1 tpidm12 syl6req fveq2d neeq1d
    df-3 syl5ib sylbi tpeq2 tpidm23 tpeq3 tpidm13 3jaoi com12 necon4bd impbid )
    ADEZBDEZCDEZUBZABFZBCFZCAFZUBZABCGZHIZJKZXSYCYFXSYCLZABUCZCUDUEZHIZMUFUAUQZ
    YEJYGYJYHHIZUFUAUQZYKYGXRYHUGEZCYHEZNZYJYMKZXPXQXRYCUHYNYGABUIZOXSYCYPXSYOY
    CXSYOXTNZYANZYBNZUJZYCNZXSYOYSYTUUAPZPZUUBXSYOUUEXSYOLUUDYSXSYOUUDXRXPYOUUD
    QXQXRYOUUDXRYOCAKZCBKZPZUUDCABDUKUUHUUGUUFPUUDUUFUUGULUUGYTUUFUUAYTUUGYTBCK
    ZUUGBCUMZBCUNURUOUUAUUFCAUMZUOUPURUSUTVAVBVCVDYSYTUUAVEVFXTYAYBVGZVFVIVBXRY
    NYPLYQYHCDVHVBVJYGYLMUFUAYGXTYLMKZXSXTYAYBVKYGXPXQLZXTUUMVLXSUUNYCXPXQXRVMV
    NABDVOVPVQVRVSYDYIHABCVTWAXEWBVDXSYCYEJUUCXSYEJFZUUCUUBXSUUOQZUULYSUUPYTUUA
    YSABKZUUPABUMXSBCUCZHIZJFZUUQUUOUUTXSUURUGEZUUSMWCRZLUUTBCWDUVBUUTUVAUVBJUU
    SUVBUUSJSRZJUUSFUUSWEEZMWEEZUVBUVCQUVAUVDBCUIZUVAUUSUURWFZWGTWHUVDUVELZUVBU
    USYKSRZUVCUUSMWIUVHUVIUVCUVHYKJUUSSYKJKZUVHWJOWKUTWLWMUUSJUVAUUSWNEUVFUVAUU
    SUVGWOTWPWQVPWRWSTOUUQUUSYEJUUQUURYDHUUQYDBBCGUURABBCWTBCXAXBXCXDXFXGYTUUIU
    UPUUJXSACUCZHIZJFZUUIUUOUVMXSUVKUGEZUVLMWCRZLUVMACWDUVOUVMUVNUVOJUVLUVOUVLJ
    SRZJUVLFUVLWEEZUVEUVOUVPQUVNUVQACUIZUVNUVLUVKWFZWGTWHUVQUVELZUVOUVLYKSRZUVP
    UVLMWIUVTUWAUVPUVTYKJUVLSUVJUVTWJOWKUTWLWMUVLJUVNUVLWNEUVRUVNUVLUVSWOTWPWQV
    PWRWSTOUUIUVLYEJUUIUVKYDHUUIYDACCGUVKBCACXHACXIXBXCXDXFXGUUAUUFUUPUUKXSYLJF
    ZUUFUUOUWBXSYNYLMWCRZLUWBABWDUWCUWBYNUWCJYLUWCYLJSRZJYLFYLWEEZUVEUWCUWDQYNU
    WEYRYNYLYHWFZWGTWHUWEUVELZUWCYLYKSRZUWDYLMWIUWGUWHUWDUWGYKJYLSUVJUWGWJOWKUT
    WLWMYLJYNYLWNEYRYNYLUWFWOTWPWQVPWRWSTOUUFYLYEJUUFYHYDHUUFYDABAGYHCAABXJABXK
    XBXCXDXFXGXLXGXMXNXO $.

  ${
    $( Value of the numeric cardinality of a nonempty integer range.
       (Contributed by Stefan O'Rear, 12-Sep-2014.)  (Proof shortened by Mario
       Carneiro, 15-Apr-2015.) $)
    hashfz $p |- ( B e. ( ZZ>= ` A ) ->
      ( # ` ( A ... B ) ) = ( ( B - A ) + 1 ) ) $=
      ( cfv wcel cfz co chash c1 cmin caddc cen wbr wceq cz sylancr zcnd ax-1cn
      cc eqtrd cn0 cuz eluzel2 eluzelz 1z zsubcl fzen syl3anc sylancl addsub12d
      pncan3 a1i subcld oveq12d breqtrd hasheni uznn0sub peano2nn0 hashfz1 3syl
      addcom syl ) BAUACDZABEFZGCZHBAIFZHJFZEFZGCZVFVBVCVGKLVDVHMVBVCAHAIFZJFZB
      VIJFZEFZVGKVBANDZBNDVINDZVCVLKLABUBZABUCZVBHNDVMVNUDVOHAUEOVIABUFUGVBVJHV
      KVFEVBARDHRDZVJHMVBAVOPZQAHUJUHVBVKHVEJFZVFVBBHAVBBVPPZVQVBQUKVRUIVBVQVER
      DVSVFMQVBBAVTVRULHVEUTOSUMUNVCVGUOVAVBVETDVFTDVHVFMABUPVEUQVFURUSS $.

    $( Condition for finite ranges to have a strict dominance relation.
       (Contributed by Stefan O'Rear, 12-Sep-2014.)  (Revised by Mario
       Carneiro, 15-Apr-2015.) $)
    fzsdom2 $p |- ( ( ( B e. ( ZZ>= ` A ) /\ C e. ZZ ) /\ B < C ) ->
      ( A ... B ) ~< ( A ... C ) ) $=
      ( cuz cfv wcel cz wa clt wbr cfz co chash cmin c1 caddc ad2antrr resubcld
      zred wceq csdm eluzelz eluzel2 simplr cr 1re a1i ltsub1dd ltadd1dd hashfz
      simpr cle ltled eluz2 syl3anbrc simpll uztrn syl2anc syl 3brtr4d cfn fzfi
      wb hashsdom mp2an sylib ) BADEZFZCGFZHZBCIJZHZABKLZMEZACKLZMEZIJZVMVOUAJZ
      VLBANLZOPLZCANLZOPLZVNVPIVLVSWAOVLBAVLBVHBGFZVIVKABUBQZSZVLAVHAGFVIVKABUC
      QSZRVLCAVLCVHVIVKUDZSZWFROUEFVLUFUGVLBCAWEWHWFVJVKUKZUHUIVHVNVTTVIVKABUJQ
      VLCVGFZVPWBTVLCBDEFZVHWJVLWCVIBCULJWKWDWGVLBCWEWHWIUMBCUNUOVHVIVKUPBCAUQU
      RACUJUSUTVMVAFVOVAFVQVRVCABVBACVBVMVOVDVEVF $.

    $( Cardinality of a half-open set of integers.  (Contributed by Stefan
       O'Rear, 15-Aug-2015.) $)
    hashfzo $p |- ( B e. ( ZZ>= ` A ) -> ( # ` ( A ..^ B ) ) = ( B - A ) ) $=
      ( cuz cfv wcel wceq cfzo co chash cmin c1 eluzel2 zcnd c0 fveq2d caddc cc
      cc0 ax-1cn eqtrd subidd fzo0 fveq2i hash0 eqtri syl6reqr oveq2 syl5ibrcom
      oveq1 eqeq12d wa cfz cz eluzelz fzoval adantr hashfz sub32d oveq1d subcld
      syl a1i npcan sylancl sylan9eqr ex uzm1 mpjaod ) BACDZEZBAFZABGHZIDZBAJHZ
      FZBKJHZVIEZVJVOVKAAGHZIDZAAJHZFVJVTRVSVJAVJAABLMZUAVSNIDRVRNIAUBUCUDUEUFV
      KVMVSVNVTVKVLVRIBAAGUGOBAAJUIUJUHVJVQVOVJVQUKVMAVPULHZIDZVNVJVMWCFVQVJVLW
      BIVJBUMEVLWBFABUNZABUOVAOUPVQVJWCVPAJHZKPHZVNAVPUQVJWFVNKJHZKPHZVNVJWEWGK
      PVJBKAVJBWDMZKQEZVJSVBWAURUSVJVNQEWJWHVNFVJBAWIWAUTSVNKVCVDTVETVFABVGVH
      $.

    $( Cardinality of a half-open set of integers based at zero.  (Contributed
       by Stefan O'Rear, 15-Aug-2015.) $)
    hashfzo0 $p |- ( B e. NN0 -> ( # ` ( 0 ..^ B ) ) = B ) $=
      ( cn0 wcel cc0 cfzo co chash cfv cmin wceq cuz hashfzo nn0uz eleq2s nn0cn
      subid1d eqtrd ) ABCZDAEFGHZADIFZASTJADKHBDALMNRAAOPQ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    hashxplem.1 $e |- B e. Fin $.
    $( Lemma for ~ hashxp .  (Contributed by Paul Chapman, 30-Nov-2012.) $)
    hashxplem $p |- ( A e. Fin ->
                      ( # ` ( A X. B ) ) = ( ( # ` A ) x. ( # ` B ) ) ) $=
      ( cxp chash cfv cmul co wceq c0 xpeq1 fveq2d fveq2 oveq1d eqeq12d cc0 cfn
      wcel caddc c1 vx vy vz cv csn cun hashcl nn0cnd mul02d ax-mp hash0 oveq1i
      0xp fveq2i eqtri 3eqtr4ri wn wa oveq1 adantl xpundir cin xpfi inxp disjsn
      mpan2 biimpri xpeq1d syl6eq syl5eq snfi hashun mp3an2 syl2an cen wbr snex
      mp2an elexi xpcomen vex xpsnen entri wb hashen mpbir oveq2i adantr cvv wi
      hashunsng cc ax-1cn cn0 nn0cn adddir mp3an23 syl mulid2i eqtrd 3eqtr4d ex
      mp2b findcard2s ) UAUDZBDZEFZXEEFZBEFZGHZIJBDZEFZJEFZXIGHZIUBUDZBDZEFZXOE
      FZXIGHZIZXOUCUDZUEZUFZBDZEFZYCEFZXIGHZIZABDZEFZAEFZXIGHZIUAUBUCAXEJIZXGXL
      XJXNYMXFXKEXEJBKLYMXHXMXIGXEJEMNOXEXOIZXGXQXJXSYNXFXPEXEXOBKLYNXHXRXIGXEX
      OEMNOXEYCIZXGYEXJYGYOXFYDEXEYCBKLYOXHYFXIGXEYCEMNOXEAIZXGYJXJYLYPXFYIEXEA
      BKLYPXHYKXIGXEAEMNOPXIGHZPXNXLBQRZYQPICYRXIYRXIBUGZUHUIUJXMPXIGUKULXLXMPX
      KJEBUMUNUKUOUPXOQRZYAXORUQZURZXTYHUUBXTURXQXISHZXSXISHZYEYGXTUUCUUDIUUBXQ
      XSXISUSUTUUBYEUUCIXTUUBYEXPYBBDZUFZEFZUUCYDUUFEXOYBBVAUNUUBUUGXQUUEEFZSHZ
      UUCYTXPQRZXPUUEVBZJIZUUGUUIIZUUAYTYRUUJCXOBVCVFUUAUUKXOYBVBZBBVBZDZJXOBYB
      BVDUUAUUPJUUODJUUAUUNJUUOUUNJIUUAXOYAVEVGVHUUOUMVIVJUUJUUEQRZUULUUMYBQRYR
      UUQYAVKCYBBVCVRZXPUUEVLVMVNUUHXIXQSUUHXIIZUUEBVOVPZUUEBYBDBYBBYAVQBQCVSZV
      TBYAUVAUCWAZWBWCUUQYRUUSUUTWDUURCUUEBWEVRWFWGVIVJWHUUBYGUUDIXTUUBYGXRTSHZ
      XIGHZUUDUUBYFUVCXIGYAWIRUUBYFUVCIWJUVBXOYAWIWKUJNYTUVDUUDIUUAYTUVDXSTXIGH
      ZSHZUUDYTXRWLRZUVDUVFIZYTXRXOUGUHUVGTWLRXIWLRZUVHWMYRXIWNRUVICYSXIWOXCZXR
      TXIWPWQWRUVEXIXSSXIUVJWSWGVIWHWTWHXAXBXD $.
  $}

  $( The size of the Cartesian product of two finite sets is the product of
     their sizes.  (Contributed by Paul Chapman, 30-Nov-2012.) $)
  hashxp $p |- ( ( A e. Fin /\ B e. Fin ) ->
                 ( # ` ( A X. B ) ) = ( ( # ` A ) x. ( # ` B ) ) ) $=
    ( cfn wcel cxp chash cfv cmul co wceq wi c0 cif xpeq2 fveq2d oveq2d eqeq12d
    fveq2 imbi2d 0fin elimel hashxplem dedth impcom ) BCDZACDZABEZFGZAFGZBFGZHI
    ZJZUEUFULKUFAUEBLMZEZFGZUIUMFGZHIZJZKBLBUMJZULURUFUSUHUOUKUQUSUGUNFBUMANOUS
    UJUPUIHBUMFRPQSAUMBLCTUAUBUCUD $.

  ${
    $d a x y z B $.  $d a x A $.
    $( The size of the set exponential of two finite sets is the exponential of
       their sizes.  (This is the original motivation behind the notation for
       set exponentiation.)  (Contributed by Mario Carneiro, 5-Aug-2014.) $)
    hashmap $p |- ( ( A e. Fin /\ B e. Fin ) ->
                   ( # ` ( A ^m B ) ) = ( ( # ` A ) ^ ( # ` B ) ) ) $=
      ( cfn wcel cmap co chash cfv cexp wceq fveq2d fveq2 eqeq12d imbi2d oveq2d
      wi c0 c1 cvv cmul va vx vy vz cv oveq1 oveq1d csn cun oveq2 hashcl nn0cnd
      cc0 exp0d eqcomd c1o vex map0e ax-mp df1o2 eqtri fveq2i 0ex hashsng hash0
      oveq2i 3eqtr4g wn wa cxp cen wbr w3a 3pm3.2i simprr disjsn sylibr mapunen
      snex sylancr wb simpl simprl snfi unfi sylancl mapfi syl2anc adantrr xpfi
      cin hashen mpbird hashxp mapsnen mpbiri eqtrd hashunsng adantl adantr cn0
      caddc cc ad2antrl expp1d syl5ibr expcom a2d findcard2s com12 vtoclga imp
      ) ACDBCDZABEFZGHZAGHZBGHZIFZJZXMUAUEZBEFZGHZXTGHZXQIFZJZPXMXSPUAACXTAJZYE
      XSXMYFYBXOYDXRYFYAXNGXTABEUFKYFYCXPXQIXTAGLUGMNXMXTCDZYEYGXTUBUEZEFZGHZYC
      YHGHZIFZJZPYGXTQEFZGHZYCQGHZIFZJZPYGXTUCUEZEFZGHZYCYSGHZIFZJZPYGXTYSUDUEZ
      UHZUIZEFZGHZYCUUGGHZIFZJZPYGYEPUBUCUDBYHQJZYMYRYGUUMYJYOYLYQUUMYIYNGYHQXT
      EUJKUUMYKYPYCIYHQGLOMNYHYSJZYMUUDYGUUNYJUUAYLUUCUUNYIYTGYHYSXTEUJKUUNYKUU
      BYCIYHYSGLOMNYHUUGJZYMUULYGUUOYJUUIYLUUKUUOYIUUHGYHUUGXTEUJKUUOYKUUJYCIYH
      UUGGLOMNYHBJZYMYEYGUUPYJYBYLYDUUPYIYAGYHBXTEUJKUUPYKXQYCIYHBGLOMNYGRYCUMI
      FZYOYQYGUUQRYGYCYGYCXTUKULZUNUOYOQUHZGHZRYNUUSGYNUPUUSXTSDZYNUPJUAUQZXTSU
      RUSUTVAVBQSDUUTRJVCQSVDUSVAYPUMYCIVEVFVGYSCDZUUEYSDVHZVIZYGUUDUULYGUVEUUD
      UULPUUDUULYGUVEVIZUUAYCTFZUUCYCTFZJUUAUUCYCTUFUVFUUIUVGUUKUVHUVFUUIYTXTUU
      FEFZVJZGHZUVGUVFUUIUVKJZUUHUVJVKVLZUVFYSSDZUUFSDZUVAVMYSUUFWKQJZUVMUVNUVO
      UVAUCUQUUEVSUVBVNUVFUVDUVPYGUVCUVDVOYSUUEVPVQYSUUFXTSSSVRVTUVFUUHCDZUVJCD
      ZUVLUVMWAUVFYGUUGCDZUVQYGUVEWBZUVFUVCUUFCDZUVSYGUVCUVDWCUUEWDZYSUUFWEWFXT
      UUGWGWHUVFYTCDZUVICDZUVRYGUVCUWCUVDXTYSWGWIZUVFYGUWAUWDUVTUWBXTUUFWGWFZYT
      UVIWJWHUUHUVJWLWHWMUVFUVKUUAUVIGHZTFZUVGUVFUWCUWDUVKUWHJUWEUWFYTUVIWNWHUV
      FUWGYCUUATUVFUWGYCJZUVIXTVKVLZXTUUEUVBUDUQZWOUVFUWDYGUWIUWJWAUWFUVTUVIXTW
      LWHWPOWQWQUVFUUKYCUUBRXBFZIFUVHUVFUUJUWLYCIUVEUUJUWLJZYGUUESDUVEUWMPUWKYS
      UUESWRUSWSOUVFYCUUBYGYCXCDUVEUURWTUVCUUBXADYGUVDYSUKXDXEWQMXFXGXHXIXJXKXL
      $.

    $( The size of the power set of a finite set is 2 raised to the power of
       the size of the set.  (Contributed by Paul Chapman, 30-Nov-2012.)
       (Proof shortened by Mario Carneiro, 5-Aug-2014.) $)
    hashpw $p |- ( A e. Fin -> ( # ` ~P A ) = ( 2 ^ ( # ` A ) ) ) $=
      ( vx cv cpw chash cfv c2 cexp co wceq cfn pweq fveq2d oveq2d eqeq12d wcel
      fveq2 c2o c0 mpan cmap cen wbr vex pw2en wb pwfi biimpi csn df2o2 eqeltri
      cpr mapfi hashen syl2anc mpbiri hashmap hash2 oveq1i syl6eq eqtrd vtoclga
      prfi ) BCZDZEFZGVDEFZHIZJADZEFZGAEFZHIZJBAKVDAJZVFVJVHVLVMVEVIEVDALMVMVGV
      KGHVDAEQNOVDKPZVFRVDUAIZEFZVHVNVFVPJZVEVOUBUCZVDBUDUEVNVEKPZVOKPZVQVRUFVN
      VSVDUGUHRKPZVNVTRSSUIZULKUJSWBVCUKZRVDUMTVEVOUNUOUPVNVPREFZVGHIZVHWAVNVPW
      EJWCRVDUQTWDGVGHURUSUTVAVB $.
  $}

  ${
    $d x y z F $.
    $( A finite set is a function iff it is equinumerous to its domain.
       (Contributed by Mario Carneiro, 26-Sep-2013.)  (Revised by Mario
       Carneiro, 12-Mar-2015.) $)
    hashfun $p |- ( F e. Fin -> ( Fun F <-> ( # ` F ) = ( # ` dom F ) ) ) $=
      ( vx vy vz cfn wcel chash cfv cdm wn cr syl adantr wbr c1 caddc c0 cle c2
      wceq wfun wfn funfn hashfn sylbi wa wrel cv cop weq wi wal wne cn0 hashcl
      dmfi nn0red clt cvv cxp wrex wral df-rel dfss3 bitri notbii rexnal bitr4i
      wss w3a csn cdif cun co dmun fveq2i dmsnn0 biimpri necon1bi uneq2d syl6eq
      3ad2ant3 un0 fveq2d syl5eq diffi peano2re cdom fidomdm wb hashdom syl2anc
      mpbird ltp1d lelttrd 3ad2ant1 eqbrtrd cin snfi incom disjdif eqtri hashun
      mp3an23 vex hashsng ax-mp oveq2i syl6req breqtrd difsnid 3ad2ant2 3brtr3d
      dmeqd rexlimdv3a syl5bi imp gtned necon4bd wex 2nalexn df-ne anbi2i annim
      ex exbii exnal bitr2i 2exbii cpr 2re readdcl sylancr 1re opex prss biimpi
      undif syl5reqr ad2antrl dmprop eqtr4i uneq1i hashun2 oveq1i syl6breq 1lt2
      dfsn2 ltadd1 mp3an12 mpbii leadd2 mpbid prfi mp3an13 opth simprbi necon3i
      mp3an3 hashprg oveq1d ad2antll 3eqtr3rd ltletrd exlimdv exlimdvv sylanbrc
      mp2an sylib dffun4 impbid2 ) AEFZAUAZAGHZAIZGHZTZUVMAUVOUBUVQAUCUVOAUDUEU
      VLUVQUVMUVLUVQUFAUGZBUHZCUHZUIZAFUVSDUHZUIZAFUFZCDUJZUKZDULZCULBULZUVMUVL
      UVQUVRUVLUVRUVNUVPUVLUVRJZUVNUVPUMZUVLUWIUFUVPUVNUVLUVPKFZUWIUVLUVPUVLUVO
      EFUVPUNFAUPUVOUOLUQZMUVLUWIUVPUVNURNZUWIUVSUSUSUTZFZJZBAVAZUVLUWMUWIUWOBA
      VBZJUWQUVRUWRUVRAUWNVIUWRAVCBAUWNVDVEVFUWOBAVGVHUVLUWPUWMBAUVLUVSAFZUWPVJ
      ZAUVSVKZVLZUXAVMZIZGHZUXCGHZUVPUVNURUWTUXEUXBGHZOPVNZUXFURUWTUXEUXBIZGHZU
      XHURUWTUXEUXIUXAIZVMZGHUXJUXDUXLGUXBUXAVOVPUWTUXLUXIGUWTUXLUXIQVMUXIUWTUX
      KQUXIUWPUVLUXKQTUWSUWOUXKQUWOUXKQUMUVSVQVRVSWBVTUXIWCWAWDWEUVLUWSUXJUXHUR
      NUWPUVLUXJUXGUXHUVLUXJUVLUXIEFZUXJUNFUVLUXBEFZUXMAUXAWFZUXBUPLZUXIUOLUQUV
      LUXGUVLUXNUXGUNFUXOUXBUOLUQZUVLUXGKFUXHKFUXQUXGWGLUVLUXJUXGRNZUXIUXBWHNZU
      VLUXNUXSUXOUXBWILUVLUXMUXNUXRUXSWJUXPUXOUXIUXBEWKWLWMUVLUXGUXQWNWOWPWQUVL
      UWSUXHUXFTUWPUVLUXFUXGUXAGHZPVNZUXHUVLUXNUXFUYATZUXOUXNUXAEFZUXBUXAWRZQTU
      YBUVSWSZUYDUXAUXBWRQUXBUXAWTUXAAXAXBUXBUXAXCXDLUXTOUXGPUVSUSFUXTOTBXEZUVS
      USXFXGZXHXIWPXJUWSUVLUXEUVPTUWPUWSUXDUVOGUWSUXCAAUVSXKZXNWDXLUWSUVLUXFUVN
      TUWPUWSUXCAGUYHWDXLXMXOXPXQXRYEXSXQUVLUVQUWHUVLUWHUVNUVPUWHJZUWDUVTUWBUMZ
      UFZDXTZCXTBXTZUVLUWJUYIUWGJZCXTBXTUYMUWGBCYAUYNUYLBCUYLUWFJZDXTUYNUYKUYOD
      UYKUWDUWEJZUFUYOUYJUYPUWDUVTUWBYBYCUWDUWEYDVEYFUWFDYGYHYIVEUVLUYLUWJBCUVL
      UYKUWJDUVLUYKUWJUVLUYKUFZUVPUVNUVLUWKUYKUWLMZUYQUVPSAUWAUWCYJZVLZIZGHZPVN
      ZUVNUYRUYQSKFZVUBKFZVUCKFZYKUVLVUEUYKUVLVUBUVLVUAEFZVUBUNFUVLUYTEFZVUGAUY
      SWFZUYTUPLZVUAUOLUQZMSVUBYLZYMUVLUVNKFUYKUVLUVNAUOUQMUYQUVPOVUBPVNZVUCUYR
      UVLVUMKFZUYKUVLOKFZVUEVUNYNVUKOVUBYLYMMUVLVUFUYKUVLVUDVUEVUFYKVUKVULYMMUY
      QUVPUXAVUAVMZGHZVUMRUWDUVPVUQTUVLUYJUWDUVOVUPGUWDUVOUYSIZVUAVMZVUPUWDVUSU
      YSUYTVMZIUVOUYSUYTVOUWDVUTAUWDVUTATZUWDUYSAVIVVAUWAUWCAUVSUVTYOZUVSUWBYOZ
      YPUYSAYRVEYQZXNYSVURUXAVUAVURUVSUVSYJUXAUVSUVTUVSUWBCXEZDXEUUAUVSUUHUUBUU
      CWAWDYTUVLVUQVUMRNUYKUVLVUQUXTVUBPVNZVUMRUVLUYCVUGVUQVVFRNUYEVUJUXAVUAUUD
      YMUXTOVUBPUYGUUEUUFMWQUVLVUMVUCURNZUYKUVLOSURNZVVGUUGUVLVUEVVHVVGWJZVUKVU
      OVUDVUEVVIYNYKOSVUBUUIUUJLUUKMWOUYQVUCSUYTGHZPVNZUVNRUVLVUCVVKRNZUYKUVLVU
      BVVJRNZVVLUVLVVMVUAUYTWHNZUVLVUHVVNVUIUYTWILUVLVUGVUHVVMVVNWJVUJVUIVUAUYT
      EWKWLWMUVLVUEVVJKFZVVMVVLWJZVUKUVLVVJUVLVUHVVJUNFVUIUYTUOLUQVUEVVOVUDVVPY
      KVUBVVJSUULUUSWLUUMMUYQVUTGHZUYSGHZVVJPVNZUVNVVKUVLVVQVVSTZUYKUVLVUHVVTVU
      IUYSEFVUHUYSUYTWRQTVVTUWAUWCUUNUYSAXAUYSUYTXCUUOLMUWDVVQUVNTUVLUYJUWDVUTA
      GVVDWDYTUYJVVSVVKTUVLUWDUYJVVRSVVJPUYJUWAUWCUMZVVRSTZUWAUWCUVTUWBUWAUWCTB
      BUJUWEUVSUVTUVSUWBUYFVVEUUPUUQUURUWAUSFUWCUSFVWAVWBWJVVBVVCUWAUWCUSUUTUVH
      UVIUVAUVBUVCXJUVDXRYEUVEUVFXPXSXQBCDAUVJUVGYEUVK $.
  $}

  ${
    $d j k u v w x y z A $.  $d j k u v x K $.  $d u v x ph $.
    ${
      hashbc.1 $e |- ( ph -> A e. Fin ) $.
      hashbc.2 $e |- ( ph -> -. z e. A ) $.
      hashbc.3 $e |- ( ph -> A. j e. ZZ
        ( ( # ` A ) _C j ) = ( # ` { x e. ~P A | ( # ` x ) = j } ) ) $.
      hashbc.4 $e |- ( ph -> K e. ZZ ) $.
      $( Lemma for ~ hashbc : inductive step.  (Contributed by Mario Carneiro,
         13-Jul-2014.) $)
      hashbclem $p |- ( ph -> ( ( # ` ( A u. { z } ) ) _C K ) =
        ( # ` { x e. ~P ( A u. { z } ) | ( # ` x ) = K } ) ) $=
        ( chash cfv co c1 caddc wceq wa wcel wss cfn vu vv cbc cmin wel csn cun
        wn cv cpw crab wral oveq2 eqeq2 rabbidv fveq2d eqeq12d rspcv sylc ssun1
        cz cab sspwb mpbi sseli adantl elpwi ssneld mpan9 uncom syl6sseq adantr
        jca cin c0 wb simpr disjsn sylibr disjssun syl mpbid vex impbida anbi1d
        elpw anass syl6bb abbidv df-rab 3eqtr4g eqtrd peano2zm cen wbr cdif cvv
        pwfi sylib rabexg snfi unfi sylancl ssrab2 ssfi elex fveq2 eqeq1d elrab
        ad2antrl unss1 snex syl2anc a1i ssneldd hashun syl3anc ax-mp oveq12d cc
        unex ax-1cn mpbir eleq2 anbi12d sylanbrc syl5bi cn0 hashcl snssd syl5eq
        ex incom eqtri oveq2i syl6eq oveq1d eqcom bitri wo simprr hashsng npcan
        zcnd 3eqtrd ssun2 snss jctil ssundif difexg nn0cnd pncan undif1 simprrl
        ssequn2 disjdif simprrr 3eqtr3d eqtr3d anbi12i simp3rl uneqdifeq bicomd
        3adant3 eqeq1i 3bitr4g 3expib en3d hashen mpbird bcpasc eqtr4d biantrur
        w3a pm2.1 andir rabbiia unrab eqtr4i fveq2i inrab simprl simpll pm2.65i
        rgenw rabeq0 3eqtr4d ) ADKLZFUCMZUWHFNUDMZUCMZOMZCBUEZUHZBUIZKLZFPZQZBD
        CUIZUFZUGZUJZUKZKLZUWMUWQQZBUXBUKZKLZOMZUXAKLZFUCMZUWQBUXBUKZKLZAUWIUXD
        UWKUXGOAUWIUWQBDUJZUKZKLZUXDAFVARZUWHEUIZUCMZUWPUXQPZBUXMUKZKLZPZEVAULZ
        UWIUXOPZJIUYBUYDEFVAUXQFPZUXRUWIUYAUXOUXQFUWHUCUMUYEUXTUXNKUYEUXSUWQBUX
        MUXQFUWPUNUOUPUQURUSAUXNUXCKAUWOUXMRZUWQQZBVBUWOUXBRZUWRQZBVBUXNUXCAUYG
        UYIBAUYGUYHUWNQZUWQQUYIAUYFUYJUWQAUYFUYJAUYFQUYHUWNUYFUYHAUXMUXBUWODUXA
        SUXMUXBSDUWTUTDUXAVCVDVEVFAUWSDRUHZUYFUWNHUYFUWODUWSUWODVGVHVIVMUYJUYFA
        UYJUWODSZUYFUYJUWOUWTDUGZSZUYLUYHUYNUWNUYHUWOUXAUYMUWOUXAVGDUWTVJZVKVLU
        YJUWOUWTVNVOPZUYNUYLVPUYJUWNUYPUYHUWNVQUWOUWSVRVSUWOUWTDVTWAWBUWODBWCWF
        VSVFWDWEUYHUWNUWQWGWHWIUWQBUXMWJUWRBUXBWJWKUPWLAUWKUWPUWJPZBUXMUKZKLZUX
        GAUWJVARZUYCUWKUYSPZAUXPUYTJFWMWAIUYBVUAEUWJVAUXQUWJPZUXRUWKUYAUYSUXQUW
        JUWHUCUMVUBUXTUYRKVUBUXSUYQBUXMUXQUWJUWPUNUOUPUQURUSAUYSUXGPZUYRUXFWNWO
        ZAUAUBUYRUXFUAUIZUWTUGZUBUIZUWTWPZAUXMTRZUYRWQRADTRZVUIGDWRWSZUYQBUXMTW
        TWAAUXFTRZUXFWQRAUXBTRZUXFUXBSVULAUXATRZVUMAVUJUWTTRZVUNGUWSXAZDUWTXBXC
        UXAWRWSZUXEBUXBXDUXBUXFXEXCZUXFTXFWAVUEUYRRZVUEUXMRZVUEKLZUWJPZQZAVUFUX
        FRZUYQVVBBVUEUXMUWOVUEPUWPVVAUWJUWOVUEKXGXHXIZAVVCVVDAVVCQZVUFUXBRZUWSV
        UFRZVUFKLZFPZQZVVDVVFVUFUXASZVVGVVFVUEDSZVVLVUTVVMAVVBVUEDVGXJZVUEDUWTX
        KWAVUFUXAVUEUWTUAWCUWSXLYAWFVSVVFVVJVVHVVFVVIVVAUWTKLZOMZUWJNOMZFVVFVUE
        TRZVUOVUEUWTVNZVOPZVVIVVPPVVFVUJVVMVVRAVUJVVCGVLVVNDVUEXEXMVUOVVFVUPXNV
        VFCUAUEUHVVTVVFVUEDUWSVVNAUYKVVCHVLXOVUEUWSVRVSZVUEUWTXPXQVVFVVAUWJVVON
        OAVUTVVBUUAVVONPZVVFUWSWQRVWBCWCZUWSWQUUBXRZXNXSVVFFXTRNXTRZVVQFPVVFFAU
        XPVVCJVLUUDYBFNUUCXCUUEVVHUWTVUFSUWTVUEUUFUWSVUFVWCUUGYCUUHUXEVVKBVUFUX
        BUWOVUFPZUWMVVHUWQVVJUWOVUFUWSYDVWFUWPVVIFUWOVUFKXGXHYEXIYFYLYGVUGUXFRZ
        VUGUXBRZCUBUEZVUGKLZFPZQZQZAVUHUYRRZUXEVWLBVUGUXBUWOVUGPZUWMVWIUWQVWKUW
        OVUGUWSYDVWOUWPVWJFUWOVUGKXGXHYEXIZAVWMVWNAVWMQZVUHUXMRZVUHKLZUWJPZVWNV
        WQVUHDSZVWRVWQVUGUYMSVXAVWQVUGUXAUYMVWHVUGUXASAVWLVUGUXAVGXJUYOVKVUGUWT
        DUUIWSZVUHDVUGWQRVUHWQRUBWCVUGUWTWQUUJXRWFVSVWQVWSNOMZNUDMZVWSUWJVWQVWS
        XTRVWEVXDVWSPVWQVWSVWQVUHTRZVWSYHRVWQVUJVXAVXEAVUJVWMGVLVXBDVUHXEXMZVUH
        YIWAUUKYBVWSNUULXCVWQVXCFNUDVWQVUHUWTUGZKLZVWJVXCFVWQVXGVUGKVWQVXGVUGUW
        TUGZVUGVUGUWTUUMVWQUWTVUGSZVXIVUGPVWQUWSVUGAVWHVWIVWKUUNYJUWTVUGUUOWSYK
        UPVWQVXHVWSVVOOMZVXCVWQVXEVUOVUHUWTVNZVOPZVXHVXKPVXFVUOVWQVUPXNVXMVWQVX
        LUWTVUHVNVOVUHUWTYMUWTVUGUUPYNXNVUHUWTXPXQVVONVWSOVWDYOYPAVWHVWIVWKUUQU
        URYQUUSUYQVWTBVUHUXMUWOVUHPUWPVWSUWJUWOVUHKXGXHXIYFYLYGVUSVWGQVVCVWMQAV
        UEVUHPZVUGVUFPZVPZVUSVVCVWGVWMVVEVWPUUTAVVCVWMVXPAVVCVWMUVNZVUHVUEPZUWT
        VUEUGZVUGPZVXNVXOVXQVXTVXRVXQVXJUWTVUEVNZVOPVXTVXRVPVXQUWSVUGVWIVWKVWHA
        VVCUVAYJVXQVYAVVSVOUWTVUEYMAVVCVVTVWMVWAUVDYKUWTVUEVUGUVBXMUVCVUEVUHYRV
        XOVUFVUGPVXTVUGVUFYRVUFVXSVUGVUEUWTVJUVEYSUVFUVGYGUVHAUYRTRZVULVUCVUDVP
        AVUIUYRUXMSVYBVUKUYQBUXMXDUXMUYRXEXCVURUYRUXFUVIXMUVJWLXSAUXJUWHNOMZFUC
        MZUWLAUXIVYCFUCAUXIUWHVVOOMZVYCAVUJVUODUWTVNVOPZUXIVYEPGVUOAVUPXNAUYKVY
        FHDUWSVRVSDUWTXPXQVVONUWHOVWDYOYPYQAUWHYHRZUXPUWLVYDPAVUJVYGGDYIWAJFUWH
        UVKXMUVLAUXLUXCUXFUGZKLZUXHUXKVYHKUXKUWRUXEYTZBUXBUKVYHUWQVYJBUXBUWQVYJ
        VPUYHUWQUWNUWMYTZUWQQVYJVYKUWQUWMUVOUVMUWNUWMUWQUVPYSXNUVQUWRUXEBUXBUVR
        UVSUVTAUXCTRZVULUXCUXFVNZVOPZVYIUXHPAVUMUXCUXBSVYLVUQUWRBUXBXDUXBUXCXEX
        CVURVYNAVYMUWRUXEQZBUXBUKZVOUWRUXEBUXBUWAVYPVOPVYOUHZBUXBULVYQBUXBVYOUW
        MUWRUWMUWQUWBUWNUWQUXEUWCUWDUWEVYOBUXBUWFYCYNXNUXCUXFXPXQYKUWG $.
    $}

    $( The binomial coefficient counts the number of subsets of a finite set of
       a given size.  (Contributed by Mario Carneiro, 13-Jul-2014.) $)
    hashbc $p |- ( ( A e. Fin /\ K e. ZZ ) ->
      ( ( # ` A ) _C K ) = ( # ` { x e. ~P A | ( # ` x ) = K } ) ) $=
      ( vk vj wcel chash cfv cv cbc co wceq crab cz c0 fveq2 fveq2d eqeq12d cc0
      wral vw vy vz cfn cpw csn cun oveq1d pweq rabeq syl ralbidv cfz hash0 a1i
      c1 elfz1eq oveq12d cn0 0nn0 bcn0 ax-mp syl6eq pw0 eqcomd raleqi 0ex ralsn
      eqeq1d bitri sylibr rabid2 syl5reqr cvv eqtr4d adantl wn wa oveq1i bcval3
      hashsng mp3an1 id 0z elfz3 syl6eqelr con3i notbid rabeq0 syl5eq pm2.61dan
      rgen oveq2 eqeq2 rabbidv simpll simplr simprr fveq2i eqeq2i ralbii simprl
      cbvrabv cbvralv hashbclem expr ralrimdva syl5bi findcard2s rspccva sylan
      ) BUDFBGHZDIZJKZAIZGHZXMLZABUEZMZGHZLZDNTZCNFXLCJKZXPCLZAXRMZGHZLZUAIZGHZ
      XMJKZXQAYHUEZMZGHZLZDNTOGHZXMJKZXQAOUEZMZGHZLZDNTUBIZGHZXMJKZXQAUUAUEZMZG
      HZLZDNTZUUAUCIZUFUGZGHZXMJKZXQAUUJUEZMZGHZLZDNTZYBUAUBUCBYHOLZYNYTDNUURYJ
      YPYMYSUURYIYOXMJYHOGPUHUURYLYRGUURYKYQLYLYRLYHOUIXQAYKYQUJUKQRULYHUUALZYN
      UUGDNUUSYJUUCYMUUFUUSYIUUBXMJYHUUAGPUHUUSYLUUEGUUSYKUUDLYLUUELYHUUAUIXQAY
      KUUDUJUKQRULYHUUJLZYNUUPDNUUTYJUULYMUUOUUTYIUUKXMJYHUUJGPUHUUTYLUUNGUUTYK
      UUMLYLUUNLYHUUJUIXQAYKUUMUJUKQRULYHBLZYNYADNUVAYJXNYMXTUVAYIXLXMJYHBGPUHU
      VAYLXSGUVAYKXRLYLXSLYHBUIXQAYKXRUJUKQRULYTDNXMNFZXMSSUMKZFZYTUVDYTUVBUVDY
      PUPYSUVDYPSSJKZUPUVDYOSXMSJYOSLUVDUNUOXMSUQZURSUSFZUVEUPLUTSVAVBVCUVDYSOU
      FZGHZUPUVDYRUVHGUVDUVHYQYRVDUVDXQAYQTZYQYRLUVDSXMLZUVJUVDXMSUVFVEUVJXQAUV
      HTUVKXQAYQUVHVDVFXQUVKAOVGXOOLZXPSXMUVLXPYOSXOOGPUNVCVIZVHVJVKXQAYQVLVKVM
      QOVNFUVIUPLVGOVNWAVBVCVOVPUVBUVDVQZVRZYPSXMJKZYSYOSXMJUNVSUVOUVPSYSUVGUVB
      UVNUVPSLUTXMSVTWBUVOYSYOSUVOYROGUVOXQVQZAYQTZYROLUVOUVKVQZUVRUVNUVSUVBUVK
      UVDUVKXMSUVCUVKWCSNFSUVCFWDSWEVBWFWGVPUVRUVQAUVHTUVSUVQAYQUVHVDVFUVQUVSAO
      VGUVLXQUVKUVMWHVHVJVKXQAYQWIVKQUNVCVOWJWKWLUUHUUBEIZJKZUUIGHZUVTLZUCUUDMZ
      GHZLZENTZUUAUDFZUUIUUAFVQZVRZUUQUUGUWFDENXMUVTLZUUCUWAUUFUWEXMUVTUUBJWMUW
      KUUEUWDGUWKUUEXPUVTLZAUUDMZUWDUWKXQUWLAUUDXMUVTXPWNWOUWLUWCAUCUUDXOUUILXP
      UWBUVTXOUUIGPVIXCZVCQRXDUWJUWGUUPDNUWJUVBUWGUUPUWJUVBUWGVRZVRZAUCUUAEXMUW
      HUWIUWOWPUWHUWIUWOWQUWPUWGUWAUWMGHZLZENTUWJUVBUWGWRUWRUWFENUWQUWEUWAUWMUW
      DGUWNWSWTXAVKUWJUVBUWGXBXEXFXGXHXIYAYGDCNXMCLZXNYCXTYFXMCXLJWMUWSXSYEGUWS
      XQYDAXRXMCXPWNWOQRXJXK $.
  $}

  ${
    $d f g h x y A $.  $d f g h x y B $.  $d f g h x y C $.  $d f g h x y D $.
    $( The number of bijections between two sets is a cardinal invariant.
       (Contributed by Mario Carneiro, 21-Jan-2015.) $)
    hashfacen $p |- ( ( A ~~ B /\ C ~~ D ) ->
      { f | f : A -1-1-onto-> C } ~~ { f | f : B -1-1-onto-> D } ) $=
      ( vg vh cv wf1o wex wa ccom cmap cvv wcel wf f1of wb syl wceq cen wbr cab
      vx vy bren eeanv ccnv co wss cdm f1odm vex dmex syl6eqelr syl2anr syl5ibr
      elmapg abssdv ovex ssex crn f1ofo forn rnex f1oco adantll f1ocnv ad2antrr
      syl2anc ex f1oeq1 elab coex cnvex 3imtr4g ad2antlr ancoms adantlr anbi12i
      wfo coass cid cres f1ococnv1 coeq2d adantrr fcoi1 eqtrd syl5req f1ococnv2
      3syl coeq1d adantrl fcoi2 syl5eqr eqeq12d eqcom syl6bb wf1 f1of1 ad2antrl
      cocan1 syl3anc f1ofn ad2antll cocan2 3bitr3d syl5bi en3d exlimivv syl2anb
      wfn sylbir ) ABUAUBABFHZIZFJZCDGHZIZGJZACEHZIZEUCZBDYAIZEUCZUAUBZCDUAUBAB
      FUFCDGUFXQXTKXPXSKZGJFJYFXPXSFGUGYGYFFGYGUDUEYCYEXRUDHZLZXOUHZLZXRUHZUEHZ
      XOLZLZYGYCCAMUIZUJYCNOYGYBEYPYBYAYPOZYGACYAPZACYAQXSCNOANOYQYRRXPXSCXRUKN
      CDXRULXRGUMZUNUOXPAXOUKNABXOULXOFUMZUNUOCAYANNURUPUQUSYCYPCAMUTVASYGYEDBM
      UIZUJYENOYGYDEUUAYDYAUUAOZYGBDYAPZBDYAQXSDNOBNOUUBUUCRXPXSDXRVBZNXSCDXRWA
      UUDDTCDXRVCCDXRVDSXRYSVEUOXPBXOVBZNXPABXOWAZUUEBTABXOVCZABXOVDSXOYTVEUODB
      YANNURUPUQUSYEUUADBMUTVASYGACYHIZBDYKIZYHYCOZYKYEOYGUUHUUIYGUUHKADYIIZBAY
      JIZUUIXSUUHUUKXPACDXRYHVFVGZXPUULXSUUHABXOVHVIBADYIYJVFVJZVKYBUUHEYHUDUMZ
      ACYAYHVLVMZYDUUIEYKYIYJXRYHYSUUOVNXOYTVOVNBDYAYKVLVMVPYGBDYMIZACYOIZYMYEO
      ZYOYCOYGUUQUURYGUUQKDCYLIZADYNIZUURXSUUTXPUUQCDXRVHVQXPUUQUVAXSUUQXPUVAAB
      DYMXOVFVRVSZADCYLYNVFVJZVKYDUUQEYMUEUMZBDYAYMVLVMZYBUUREYOYLYNXRYSVOYMXOU
      VDYTVNVNACYAYOVLVMVPUUJUUSKUUHUUQKZYGYHYOTZYMYKTZRZUUJUUHUUSUUQUUPUVEVTYG
      UVFUVIYGUVFKZYIXRYOLZTZYNYKXOLZTZUVGUVHUVJUVLUVMYNTUVNUVJYIUVMUVKYNUVJUVM
      YIYJXOLZLZYIYIYJXOWBUVJUVPYIWCAWDZLZYIUVJUVOUVQYIXPUVOUVQTXSUVFABXOWEVIWF
      UVJUUKADYIPUVRYITYGUUHUUKUUQUUMWGADYIQADYIWHWLWIWJUVJUVKXRYLLZYNLZYNXRYLY
      NWBUVJUVTWCDWDZYNLZYNUVJUVSUWAYNXSUVSUWATXPUVFCDXRWKVQWMUVJUVAADYNPUWBYNT
      YGUUQUVAUUHUVBWNADYNQADYNWOWLWIWPWQUVMYNWRWSUVJCDXRWTZACYHPZACYOPZUVLUVGR
      XSUWCXPUVFCDXRXAVQUUHUWDYGUUQACYHQXBUVJUURUWEYGUUQUURUUHUVCWNACYOQSACDXRY
      HYOXCXDUVJUUFYMBXMZYKBXMZUVNUVHRXPUUFXSUVFUUGVIUUQUWFYGUUHBDYMXEXFUVJUUIU
      WGYGUUHUUIUUQUUNWGBDYKXESABXOYMYKXGXDXHVKXIXJXKXNXL $.
  $}

  ${
    $d a f g x y z $.  $d a f g x y A $.  $d a f g x y B $.  $d a f g x y ph $.
    $d f g x y F $.
    hashf1lem2.1 $e |- ( ph -> A e. Fin ) $.
    hashf1lem2.2 $e |- ( ph -> B e. Fin ) $.
    hashf1lem2.3 $e |- ( ph -> -. z e. A ) $.
    hashf1lem2.4 $e |- ( ph -> ( ( # ` A ) + 1 ) <_ ( # ` B ) ) $.
    ${
      hashf1lem1.5 $e |- ( ph -> F : A -1-1-> B ) $.
      $( Lemma for ~ hashf1 .  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
      hashf1lem1 $p |- ( ph -> { f | ( ( f |` A ) = F /\
         f : ( A u. { z } ) -1-1-> B ) } ~~ ( B \ ran F ) ) $=
        ( vy cres wceq wa cvv wcel cfn syl c0 vg vx cv csn cun wf1 cab crn cdif
        cfv cop cmap co wss f1f adantl snfi unfi sylancl elmapg syl2anc syl5ibr
        wf wb abssdv ovex ssexg difexg vex weq reseq1 eqeq1d f1eq1 anbi12d elab
        ad2antll ssun2 snss mpbir ffvelrn wn adantr df-ima simprl syl5eq eleq2d
        cima rneqd simprr a1i ssun1 f1elima syl3anc bitr3d mtbird eldifd syl5bi
        cin wf1o f1osn f1of ax-mp eldifi snssd fss sylancr eqtr4i disjsn sylibr
        ex res0 reseq2d 3eqtr4a fresaunres1 f1f1orn eldifn f1oun syl22anc f1of1
        frn unssd f1ss fex snex unexg mpbir2and anbi1i wral wfn simprlr adantrl
        elabg f1fn f1ofn eqfnfv fvres eqcomd simprll ad2antrr fveq2 fveq1d fnsn
        sylan9eqr simpr syl112anc eqtr4d ralrimiva biantrurd ralunb syl6bbr cdm
        fvun1 fdm fsnunfv eqeq2d eqeq12d ralsn eqcom 3bitr4g 3bitr2d en3d ) AUA
        UBEUCZCMZFNZCBUCZUDZUEZDUVBUFZOZEUGZDFUHZUIZUVEUAUCZUJZFUVEUBUCZUKZUDZU
        EZAUVJDUVGULUMZUNUVSPQUVJPQAUVIEUVSUVIUVBUVSQZAUVGDUVBVCZUVHUWAUVDUVGDU
        VBUOUPADRQZUVGRQZUVTUWAVDHACRQZUVFRQUWCGUVEUQCUVFURUSDUVGUVBRRUTVAVBVED
        UVGULVFUVJUVSPVGUSAUWBUVLPQHDUVKRVHSUVMUVJQZUVMCMZFNZUVGDUVMUFZOZAUVNUV
        LQZUVIUWIEUVMUAVIEUAVJZUVDUWGUVHUWHUWKUVCUWFFUVBUVMCVKVLUVGDUVBUVMVMVNV
        OZAUWIUWJAUWIOZUVNDUVKUWMUVGDUVMVCZUVEUVGQZUVNDQUWHUWNAUWGUVGDUVMUOVPUW
        OUVFUVGUNUVFCVQUVEUVGBVIZVRVSZUVGDUVEUVMVTUSUWMUVNUVKQZUVECQZAUWSWAZUWI
        IWBUWMUVNUVMCWGZQZUWRUWSUWMUXAUVKUVNUWMUXAUWFUHUVKUVMCWCUWMUWFFAUWGUWHW
        DWHWEWFUWMUWHUWOCUVGUNZUXBUWSVDAUWGUWHWIUWOUWMUWQWJUXCUWMCUVFWKWJUVGDUV
        MUVECWLWMWNWOWPXJWQAUVOUVLQZUVRUVJQZAUXDOZUXEUVRCMZFNZUVGDUVRUFZUXFCDFV
        CZUVFDUVQVCZFCUVFWRZMZUVQUXLMZNUXHAUXJUXDACDFUFZUXJKCDFUOSZWBZUXFUVFUVO
        UDZUVQVCZUXRDUNUXKUVFUXRUVQWSZUXSUVEUVOUWPUBVIZWTZUVFUXRUVQXAXBUXFUVODU
        XDUVODQAUVODUVKXCUPXDZUVFUXRDUVQXEXFUXFFTMZUVQTMZUXMUXNUYDTUYEFXKUVQXKX
        GUXFUXLTFAUXLTNZUXDAUWTUYFICUVEXHXIZWBZXLUXFUXLTUVQUYHXLXMCUVFDFUVQXNWM
        UXFUVGUVKUXRUEZUVRUFZUYIDUNUXIUXFUVGUYIUVRWSZUYJUXFCUVKFWSZUXTUYFUVKUXR
        WRTNZUYKAUYLUXDAUXOUYLKCDFXOSWBUXTUXFUYBWJUYHUXFUVOUVKQWAZUYMUXDUYNAUVO
        DUVKXPUPUVKUVOXHXICUVKUVFUXRFUVQXQXRZUVGUYIUVRXSSUXFUVKUXRDUXFUXJUVKDUN
        UXQCDFXTSUYCYAUVGUYIDUVRYBVAUXFUVRPQZUXEUXHUXIOZVDUXFFPQZUVQPQUYPAUYRUX
        DAUXJUWDUYRUXPGCDRFYCVAWBUVPYDFUVQPPYEUSUVIUYQEUVRPUVBUVRNZUVDUXHUVHUXI
        UYSUVCUXGFUVBUVRCVKVLUVGDUVBUVRVMVNYLSYFXJUWEUXDOUWIUXDOZAUVMUVRNZUVOUV
        NNZVDZUWEUWIUXDUWLYGAUYTVUCAUYTOZVUALUCZUVMUJZVUEUVRUJZNZLUVGYHZVUHLUVF
        YHZVUBVUDUVMUVGYIZUVRUVGYIZVUAVUIVDVUDUWHVUKAUWGUWHUXDYJUVGDUVMYMSVUDUY
        KVULAUXDUYKUWIUYOYKUVGUYIUVRYNSLUVGUVMUVRYOVAVUDVUJVUHLCYHZVUJOVUIVUDVU
        MVUJVUDVUHLCVUDVUECQZOZVUFVUEFUJZVUGVUNVUDVUFVUEUWFUJZVUPVUNVUQVUFVUECU
        VMYPYQVUDVUEUWFFAUWGUWHUXDYRUUAUUCVUOFCYIZUVQUVFYIZUYFVUNVUGVUPNVUOUXOV
        URAUXOUYTVUNKYSCDFYMSVUSVUOUVEUVOUWPUYAUUBWJAUYFUYTVUNUYGYSVUDVUNUUDCUV
        FFUVQVUEUULUUEUUFUUGUUHVUHLCUVFUUIUUJVUDUVNUVEUVRUJZNZUVNUVONVUJVUBVUDV
        UTUVOUVNVUDUVEPQZUVOPQZUVEFUUKZQZWAZVUTUVONVVBVUDUWPWJVVCVUDUYAWJAVVFUY
        TAVVEUWSIAVVDCUVEAUXJVVDCNUXPCDFUUMSWFWOWBFPPUVEUVOUUNWMUUOVUHVVALUVEUW
        PLBVJVUFUVNVUGVUTVUEUVEUVMYTVUEUVEUVRYTUUPUUQUVOUVNUURUUSUUTXJWQUVA $.
    $}

    $( Lemma for ~ hashf1 .  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    hashf1lem2 $p |- ( ph -> ( # ` { f | f : ( A u. { z } ) -1-1-> B } ) =
      ( ( ( # ` B ) - ( # ` A ) ) x. ( # ` { f | f : A -1-1-> B } ) ) ) $=
      ( wss chash cfv co cmul wceq cfn wcel wi c0 caddc vx vy va cv wf1 cab csn
      cun cmin ssid cmap mapfi syl2anc wf wb elmapg syl5ibr abssdv ssfi cres wa
      f1f cc0 sseq1 eleq2 noel pm2.21i syl6bi adantrd fveq2d hash0 syl6eq fveq2
      ss0 oveq2d eqeq12d imbi12d imbi2d anbi1d abbidv f1eq1 cbvabv eqeq2i ssun1
      syl f1ssres mpan2 vex resex elab sylibr pm4.71rd bicomd cn0 hashcl nn0cnd
      sylbi subcld mul01d eqcomd wn sstr mpan imim1i oveq1 wo elun elsnc orbi2i
      a1d bitri anbi1i andir abbii unab eqtr4i fveq2i snfi unfi sylancl mapvalg
      cin eqeltrrd adantl ss2abi adantr inab syl5eq hashun syl3anc simpr cc cen
      sylib wbr cvv hasheni c1 a1i a2d simprlr wne abn0 simprl exlimiv necon1bi
      wex simpll unssbd snss pncan2d crn f1f1orn f1oen3g sylancr cle hashf1lem1
      cdif wf1o oveq12d frn diffi disjdif undif 3eqtr2d oveq1d eqtr3d hashunsng
      sylan2 eqtrd ax-mp ad2antrl simprll ax-1cn adddid 3eqtrd expr syl5 expcom
      mulid1d findcard2s mpcom mpi ) ACDEUDZUEZEUFZUWFJZCBUDZUGZUHZDUWDUEZEUFZK
      LZDKLZCKLZUIMZUWFKLZNMZOZUWFUJUWFPQZAUWGUWSRZADCUKMZPQZUWFUXBJUWTADPQZCPQ
      ZUXCGFDCULUMAUWEEUXBUWEUWDUXBQZACDUWDUNZCDUWDVBAUXDUXEUXFUXGUOGFDCUWDPPUP
      UMUQURUXBUWFUSUMAUAUDZUWFJZUWDCUTZUXHQZUWKVAZEUFZKLZUWPUXHKLZNMZOZRZRASUW
      FJZVCUWPVCNMZOZRZRAUBUDZUWFJZUXJUYCQZUWKVAZEUFZKLZUWPUYCKLZNMZOZRZRAUYCUC
      UDZUGZUHZUWFJZUXJUYOQZUWKVAZEUFZKLZUWPUYOKLZNMZOZRZRAUXARUAUBUCUWFUXHSOZU
      XRUYBAVUEUXIUXSUXQUYAUXHSUWFVDVUEUXNVCUXPUXTVUEUXNSKLZVCVUEUXMSKVUEUXMSJU
      XMSOVUEUXLESVUEUXKUWDSQZUWKVUEUXKUXJSQZVUGUXHSUXJVEVUHVUGUXJVFVGVHVIURUXM
      VNWEVJVKVLVUEUXOVCUWPNVUEUXOVUFVCUXHSKVMVKVLVOVPVQVRUXHUYCOZUXRUYLAVUIUXI
      UYDUXQUYKUXHUYCUWFVDVUIUXNUYHUXPUYJVUIUXMUYGKVUIUXLUYFEVUIUXKUYEUWKUXHUYC
      UXJVEVSVTVJVUIUXOUYIUWPNUXHUYCKVMVOVPVQVRUXHUYOOZUXRVUDAVUJUXIUYPUXQVUCUX
      HUYOUWFVDVUJUXNUYTUXPVUBVUJUXMUYSKVUJUXLUYREVUJUXKUYQUWKUXHUYOUXJVEVSVTVJ
      VUJUXOVUAUWPNUXHUYOKVMVOVPVQVRUXHUWFOZUXRUXAAVUKUXIUWGUXQUWSUXHUWFUWFVDVU
      KUXNUWMUXPUWRVUKUXMUWLKVUKUXHCDUYCUEZUBUFZOZUXMUWLOUWFVUMUXHUWEVULEUBCDUW
      DUYCWAWBWCVUNUXLUWKEVUNUWKUXLVUNUWKUXKUWKUXKVUNUXJVUMQZUWKCDUXJUEZVUOUWKC
      UWJJVUPCUWIWDUWJDCUWDWFWGVULVUPUBUXJUWDCEWHWIZCDUYCUXJWAWJWKUXHVUMUXJVEUQ
      WLWMVTWQVJVUKUXOUWQUWPNUXHUWFKVMVOVPVQVRAUYAUXSAUXTVCAUWPAUWNUWOAUWNAUXDU
      WNWNQGDWOWEWPAUWOAUXEUWOWNQFCWOWEWPZWRZWSWTXJUYCPQZUYMUYCQZXAZVAZAUYLVUDA
      VVCUYLVUDRUYLUYPUYKRAVVCVAZVUDUYPUYDUYKUYCUYOJUYPUYDUYCUYNWDUYCUYOUWFXBXC
      XDVVDUYPUYKVUCAVVCUYPUYKVUCRUYKVUCAVVCUYPVAZVAZUYHUWPTMZUYJUWPTMZOUYHUYJU
      WPTXEVVFUYTVVGVUBVVHVVFUYTUYHUXJUYMOZUWKVAZEUFZKLZTMZVVGVVFUYTUYGVVKUHZKL
      ZVVMUYSVVNKUYSUYFVVJXFZEUFVVNUYRVVPEUYRUYEVVIXFZUWKVAVVPUYQVVQUWKUYQUYEUX
      JUYNQZXFVVQUXJUYCUYNXGVVRVVIUYEUXJUYMVUQXHXIXKXLUYEVVIUWKXMXKXNUYFVVJEXOX
      PXQVVFUYGPQZVVKPQZUYGVVKYBZSOVVOVVMOAVVSVVEAUWJDUWDUNZEUFZPQZUYGVWCJVVSAD
      UWJUKMZVWCPAUXDUWJPQZVWEVWCOGAUXEUWIPQVWFFUWHXRCUWIXSXTZDUWJPPEYAUMAUXDVW
      FVWEPQGVWGDUWJULUMYCZUYFVWBEUWKVWBUYEUWJDUWDVBZYDYEVWCUYGUSXTYFAVVTVVEAVW
      DVVKVWCJVVTVWHVVJVWBEUWKVWBVVIVWIYDYEVWCVVKUSXTZYFVVFVWAUYFVVJVAZEUFZSUYF
      VVJEYGVVFVVBVWLSOAVUTVVBUYPUUAVVAVWLSVWLSUUBVWKEUUGVVAVWKEUUCVWKVVAEVWKUX
      JUYMUYCUYFVVIUWKUUDUYEUWKVVJUUHYCUUEWQUUFWEYHUYGVVKYIYJYHVVFVVLUWPUYHTVVE
      ACDUYMUEZVVLUWPOVVEUYMUWFQZVWMVVEUYNUWFJVWNVVEUYCUYNUWFVVCUYPYKUUIUYMUWFU
      CWHZUUJWKUWEVWMEUYMVWOCDUWDUYMWAWJYNAVWMVAZUWOVVLTMZUWOUIMVVLUWPVWPUWOVVL
      AUWOYLQVWMVURYFVWPVVLVWPVVTVVLWNQAVVTVWMVWJYFVVKWOWEWPUUKVWPVWQUWNUWOUIVW
      PVWQUYMUULZKLZDVWRUURZKLZTMZVWRVWTUHZKLZUWNVWPUWOVWSVVLVXATVWPCVWRYMYOZUW
      OVWSOVWPUYMYPQZCVWRUYMUUSZVXEVWOVWMVXGACDUYMUUMYDCVWRUYMYPUUNUUOCVWRYQWEV
      WPVVKVWTYMYOVVLVXAOVWPBCDEUYMAUXEVWMFYFAUXDVWMGYFZAUWHCQXAVWMHYFAUWOYRTMU
      WNUUPYOVWMIYFAVWMYKUUQVVKVWTYQWEUUTVWPVWRPQZVWTPQZVWRVWTYBSOZVXDVXBOVWPUX
      DVWRDJZVXIVXHVWMVXLAVWMCDUYMUNVXLCDUYMVBCDUYMUVAWEYDZDVWRUSUMVWPUXDVXJVXH
      DVWRUVBWEVXKVWPVWRDUVCYSVWRVWTYIYJVWPVXCDKVWPVXLVXCDOVXMVWRDUVDYNVJUVEUVF
      UVGUVIVOUVJVVFVUBUWPUYIYRTMZNMUYJUWPYRNMZTMVVHVVFVUAVXNUWPNVVCVUAVXNOZAUY
      PVXFVVCVXPRVWOUYCUYMYPUVHUVKUVLVOVVFUWPUYIYRAUWPYLQVVEVUSYFZVVFUYIVVFVUTU
      YIWNQAVUTVVBUYPUVMUYCWOWEWPYRYLQVVFUVNYSUVOVVFVXOUWPUYJTVVFUWPVXQUVTVOUVP
      VPUQUVQYTUVRUVSYTUWAUWBUWC $.
  $}

  ${
    $d f x y z A $.  $d f x y z B $.
    $( The permutation number ` | A | ! x. ( | B | _C | A | ) = `
       ` | B | ! / ( | B | - | A | ) ! ` counts the number of injections from
       ` A ` to ` B ` .  (Contributed by Mario Carneiro, 21-Jan-2015.) $)
    hashf1 $p |- ( ( A e. Fin /\ B e. Fin ) ->
      ( # ` { f | f : A -1-1-> B } ) =
        ( ( ! ` ( # ` A ) ) x. ( ( # ` B ) _C ( # ` A ) ) ) ) $=
      ( wcel chash cfv cfa cbc co cmul wceq c1 cc0 fveq2d oveq2d cn0 syl adantr
      c0 cn vx vy vz cfn cv wf1 cab csn cun f1eq2 wfn f1fn fn0 sylib f10 mpbiri
      wi f1eq1 impbii elsn bitr4i syl6bb abbi1dv cvv hashsng ax-mp syl6eq fveq2
      0ex hash0 fac0 oveq12d eqeq12d imbi2d abbidv hashcl bcn0 1t1e1 syl6req wn
      wa caddc clt wbr wne wex abn0 cdom f1domg cle vex hashunsng adantl breq1d
      wb simprl snfi unfi sylancl simpl hashdom syl2anc ad2antrl nn0p1nn nn0red
      nnred lenltd 3bitr3d sylibd exlimdv syl5bi necon4ad cc faccl nncnd mul01d
      imp 3eqtr4a cz wo nnzd simpr olcd bcval4 syl3anc eqtr4d cmin cdiv nn0sub2
      eqtrd nnne0d divcld divcan2d nn0cnd ax-1cn nn0uz syl6eleq bcval2 divdiv1d
      3eqtr4d a1d oveq2 simplrr hashf1lem2 peano2nn0 npcan a1i subsub4d eqeltrd
      subcld cfz cuz nn0zd elfz5 mpbird peano2fzr elfzle2 facnn2 oveq1d syl5ibr
      eqeltrrd ltlecasei expcom a2d findcard2s ) AUDDBUDDZABCUEZUFZCUGZEFZAEFZG
      FZBEFZUVKHIZJIZKZUVFUAUEZBUVGUFZCUGZEFZUVQEFZGFZUVMUWAHIZJIZKZUQUVFLLUVMM
      HIZJIZKZUQUVFUBUEZBUVGUFZCUGZEFZUWIEFZGFZUVMUWMHIZJIZKZUQUVFUWIUCUEZUHZUI
      ZBUVGUFZCUGZEFZUWTEFZGFZUVMUXDHIZJIZKZUQUVFUVPUQUAUBUCAUVQSKZUWEUWHUVFUXI
      UVTLUWDUWGUXIUVTSUHZEFZLUXIUVSUXJEUXIUVRCUXJUXIUVRSBUVGUFZUVGUXJDZUVQSBUV
      GUJUXLUVGSKZUXMUXLUXNUXLUVGSUKUXNSBUVGULUVGUMUNUXNUXLSBSUFBUOSBUVGSURUPUS
      CSUTVAVBVCNSVDDUXKLKVISVDVEVFVGUXIUWBLUWCUWFJUXIUWBMGFLUXIUWAMGUXIUWASEFZ
      MUVQSEVHVJVGZNVKVGUXIUWAMUVMHUXPOVLVMVNUVQUWIKZUWEUWQUVFUXQUVTUWLUWDUWPUX
      QUVSUWKEUXQUVRUWJCUVQUWIBUVGUJVONUXQUWBUWNUWCUWOJUXQUWAUWMGUVQUWIEVHZNUXQ
      UWAUWMUVMHUXROVLVMVNUVQUWTKZUWEUXHUVFUXSUVTUXCUWDUXGUXSUVSUXBEUXSUVRUXACU
      VQUWTBUVGUJVONUXSUWBUXEUWCUXFJUXSUWAUXDGUVQUWTEVHZNUXSUWAUXDUVMHUXTOVLVMV
      NUVQAKZUWEUVPUVFUYAUVTUVJUWDUVOUYAUVSUVIEUYAUVRUVHCUVQABUVGUJVONUYAUWBUVL
      UWCUVNJUYAUWAUVKGUVQAEVHZNUYAUWAUVKUVMHUYBOVLVMVNUVFUWGLLJILUVFUWFLLJUVFU
      VMPDZUWFLKBVPZUVMVQQOVRVSUWIUDDZUWRUWIDVTZWAZUVFUWQUXHUVFUYGUWQUXHUQZUVFU
      YGWAZUYHUVMUWMLWBIZUYIUVMUYJWCWDZWAZUXHUWQUYLUXCUXEMJIZUXGUYLUXOMUXCUYMVJ
      UYLUXBSEUYIUYKUXBSKUYIUYKUXBSUXBSWEUXACWFUYIUYKVTZUXACWGUYIUXAUYNCUYIUXAU
      WTBWHWDZUYNUVFUXAUYOUQUYGUWTBUDUVGWIRUYIUXDUVMWJWDZUYJUVMWJWDZUYOUYNUYIUX
      DUYJUVMWJUYGUXDUYJKZUVFUWRVDDUYGUYRUQUCWKUWIUWRVDWLVFWMZWNUYIUWTUDDZUVFUY
      PUYOWOUYIUYEUWSUDDUYTUVFUYEUYFWPZUWRWQUWIUWSWRWSZUVFUYGWTZUWTBUDXAXBUYIUY
      JUVMUYIUYJUYIUWMPDZUYJTDZUYEVUDUVFUYFUWIVPXCZUWMXDQZXFZUYIUVMUVFUYCUYGUYD
      RZXEZXGXHXIXJXKXLXQNUYLUXEUYIUXEXMDUYKUYIUXEUYIUXDPDZUXETDUYIUYTVUKVUBUWT
      VPQUXDXNQXORXPXRUYLUXFMUXEJUYLUXFUVMUYJHIZMUYLUXDUYJUVMHUYIUYRUYKUYSROUYL
      UYCUYJXSDUYJMWCWDZUYKXTVULMKUYIUYCUYKVUIRUYLUYJUYIVUEUYKVUGRYAUYLUYKVUMUY
      IUYKYBYCUYJUVMYDYEYJOYFUUAUWQUXHUYIUYQWAZUVMUWMYGIZUWLJIZVUOUWPJIZKUWLUWP
      VUOJUUBVUNUXCVUPUXGVUQVUNUCUWIBCUYIUYEUYQVUARUYIUVFUYQVUCRUVFUYEUYFUYQUUC
      UYIUYQYBZUUDVUNUYJGFZUVMGFZUVMUYJYGIZGFZYHIZVUSYHIZJIZVUOVVCVUOYHIZJIZUXG
      VUQVUNVVEVVCVVGVUNVVCVUSVUNVUTVVBVUNVUTVUNUYCVUTTDUYIUYCUYQVUIRZUVMXNQXOZ
      VUNVVBVUNVVAPDZVVBTDVUNUYJPDZUYCUYQVVJVUNVUDVVKUYIVUDUYQVUFRZUWMUUEQZVVHV
      URUYJUVMYIYEZVVAXNQZXOZVUNVVBVVOYKZYLZVUNVUSVUNVVKVUSTDVVMUYJXNQZXOZVUNVU
      SVVSYKZYMVUNVVCVUOVVRVUNUVMUWMVUNUVMVVHYNZVUNUWMVVLYNZUUJZVUNVUOVUNVUOLYG
      IZLWBIZVUOTVUNVUOXMDLXMDZVWFVUOKVWDYOVUOLUUFWSVUNVWEPDVWFTDVUNVWEVVAPVUNU
      VMUWMLVWBVWCVWGVUNYOUUGUUHZVVNUUIVWEXDQUVAZYKZYMYFVUNUXEVUSUXFVVDJVUNUXDU
      YJGUYIUYRUYQUYSRZNVUNVULVUTVVBVUSJIYHIZUXFVVDVUNUYJMUVMUUKIZDZVULVWLKVUNV
      WNUYQVURVUNUYJMUULFZDUVMXSDVWNUYQWOVUNUYJPVWOVVMYPYQVUNUVMVVHUUMUYJMUVMUU
      NXBUUOZUYJUVMYRQVUNUXDUYJUVMHVWKOVUNVUTVVBVUSVVIVVPVVTVVQVWAYSYTVLVUNUWPV
      VFVUOJVUNUWPUWNVUTVUOGFZYHIZUWNYHIZJIZVVFVUNUWOVWSUWNJVUNUWOVUTVWQUWNJIYH
      IZVWSVUNUWMVWMDZUWOVXAKVUNUWMVWODVWNVXBVUNUWMPVWOVVLYPYQVWPUWMMUVMUUPXBZU
      WMUVMYRQVUNVUTVWQUWNVVIVUNVWQVUNVUOPDZVWQTDVUNVUDUYCUWMUVMWJWDZVXDVVLVVHV
      UNVXBVXEVXCUWMMUVMUUQQUWMUVMYIYEVUOXNQZXOZVUNUWNVUNVUDUWNTDVVLUWMXNQZXOZV
      UNVWQVXFYKZVUNUWNVXHYKZYSYFOVUNVWRVUTVVBVUOJIZYHIVWTVVFVUNVWQVXLVUTYHVUNV
      WQVWEGFZVUOJIZVXLVUNVUOTDVWQVXNKVWIVUOUURQVUNVXMVVBVUOJVUNVWEVVAGVWHNUUSY
      JOVUNVWRUWNVUNVUTVWQVVIVXGVXJYLVXIVXKYMVUNVUTVVBVUOVVIVVPVWDVVQVWJYSYTYJO
      YTVMUUTVUJVUHUVBUVCUVDUVEXQ $.

    $( A factorial counts the number of bijections on a finite set.
       (Contributed by Mario Carneiro, 21-Jan-2015.)  (Proof shortened by Mario
       Carneiro, 17-Apr-2015.) $)
    hashfac $p |- ( A e. Fin -> ( # ` { f | f : A -1-1-onto-> A } ) =
      ( ! ` ( # ` A ) ) ) $=
      ( cfn wcel cv wf1 cab chash cfv cfa cbc co cmul wf1o hashf1 anidms cen c1
      wceq syl wbr enrefg f1finf1o mpancom abbidv fveq2d cn0 hashcl bcnn oveq2d
      wb cn faccl nncnd mulid1d eqtrd 3eqtr3d ) ACDZAABEZFZBGZHIZAHIZJIZVCVCKLZ
      MLZAAUSNZBGZHIVDURVBVFSAABOPURVAVHHURUTVGBAAQUAURUTVGUKACUBAAUSUCUDUEUFUR
      VFVDRMLVDURVERVDMURVCUGDZVERSAUHZVCUITUJURVDURVDURVIVDULDVJVCUMTUNUOUPUQ
      $.
  $}

  $( Two ways to write a strictly increasing function on the reals.
     (Contributed by Mario Carneiro, 9-Sep-2015.) $)
  leiso $p |- ( ( A C_ RR* /\ B C_ RR* ) ->
    ( F Isom < , < ( A , B ) <-> F Isom <_ , <_ ( A , B ) ) ) $=
    ( cxr wss cxp clt cdif wiso cle cin df-le ineq1i indif1 eqtri xpss12 anidms
    wceq wb dfss1 ccnv sylib difeq1d syl5req isoeq2 syl isoeq3 sylan9bb isocnv2
    wa eqid isocnv3 bitri isores1 isores2 3bitr4g ) ADEZBDEZUJABAAFZGUAZHZBBFZU
    THZCIZABJUSKZJVBKZCIZABGGCIZABJJCIZUQVDABVEVCCIZURVGUQVAVERVDVJSUQVEDDFZUSK
    ZUTHZVAVEVKUTHZUSKVMJVNUSLMVKUSUTNOUQVLUSUTUQUSVKEZVLUSRUQVOADADPQUSVKTUBUC
    UDABVAVCVECUEUFURVCVFRVJVGSURVFVKVBKZUTHZVCVFVNVBKVQJVNVBLMVKVBUTNOURVPVBUT
    URVBVKEZVPVBRURVRBDBDPQVBVKTUBUCUDABVEVCVFCUGUFUHVHABUTUTCIVDABGGCUIABVAVCU
    TUTCVAUKVCUKULUMVIABVEJCIVGABJJCUNABVEJCUOUMUP $.

  $( Version of ~ isorel for strictly increasing functions on the reals.
     (Contributed by Mario Carneiro, 6-Apr-2015.)  (Revised by Mario Carneiro,
     9-Sep-2015.) $)
  leisorel $p |- ( ( F Isom < , < ( A , B ) /\ ( A C_ RR* /\ B C_ RR* ) /\
    ( C e. A /\ D e. A ) ) -> ( C <_ D <-> ( F ` C ) <_ ( F ` D ) ) ) $=
    ( clt wiso cxr wss wa wcel cle wbr cfv wb wi leiso biimpcd isorel ex syl6
    3imp ) ABFFEGZAHIBHIJZCAKDAKJZCDLMCENDENLMOZUCUDABLLEGZUEUFPUDUCUGABEQRUGUE
    UFABCDLLESTUAUB $.

  ${
    $d f n A $.  $d f B $.  $d f G $.  $d f O $.  $d f R $.
    fz1iso.1 $e |- G = ( rec ( ( n e. _V |-> ( n + 1 ) ) , 1 ) |` om ) $.
    fz1iso.2 $e |- B = ( NN i^i ( `' < " { ( ( # ` A ) + 1 ) } ) ) $.
    fz1iso.3 $e |- C = ( om i^i ( `' G ` ( ( # ` A ) + 1 ) ) ) $.
    fz1iso.4 $e |- O = OrdIso ( R , A ) $.
    $( Lemma for ~ fz1iso .  (Contributed by Mario Carneiro, 2-Apr-2014.) $)
    fz1isolem $p |- ( ( R Or A /\ A e. Fin ) ->
                  E. f f Isom < , R ( ( 1 ... ( # ` A ) ) , A ) ) $=
      ( cfn wcel c1 cfv clt cep cn com wor wa ccnv cres ccom cvv chash cfz wiso
      co cv wex wf1o cdm cn0 hashcl adantl caddc cuz wceq nnuz om2uzisoi isoeq5
      wf 1z mpbiri ax-mp isocnv nn0p1nn cin csn cima fvex ineq2i eqtr4i isoini2
      epini sylancr syl wb cle wbr nnz nn0zd eluz syl2anr zleltp1 ovex eliniseg
      cz vex syl6bbr bitr2d pm5.32da elin2 elfzuzb elnnuz anbi1i bitr4i 3bitr4g
      eqrdv mpbid cmpt cc0 crdg con0 oion cen simpr wwe wofi oien syl2anc enfii
      isoeq4 elin sylanbrc onfin2 syl6eleqr cmin eqid 0z uzrdgxfr ax-1cn oveq2i
      subid1i syl6eq ensymd cardennn fveq2d hashgval eqtr3d oveq1d eqtrd isof1o
      ccrd f1ocnvfv1 ineq2d wss word ordom ordelss sylib syl5eq oiiso f1of 3syl
      sseqin2 isotr fzfid fex isoeq1 spcegv sylc ) ADUAZAMNZUBZHGUCZBUDZUEZUFNZ
      OAUGPZUHUJZAQDUUTUIZUVCAQDEUKZUIZEULUUQUVCAUUTVDZUVCMNUVAUUQUVDUVCAUUTUMU
      VGUUQUVCHUNZQRUUSUIZUVHARDHUIZUVDUUQUVCCQRUUSUIZUVIUUQBCQRUUSUIZUVKUUQUVB
      UONZUVLUUPUVMUUOAUPUQZUVMSTQRUURUIZUVBOURUJZSNUVLTSRQGUIZUVOSOUSPZUTZUVQV
      AUVSUVQTUVRRQGUIFOGVEIVBTSUVRRQGVCVFVGZTSRQGVHVGUVBVISTBCQRUURUVPJCTUVPUU
      RPZVJZTRUCUWAVKVLZVJKUWCUWATUWAUVPUURVMVQVNVOVPVRVSUUQBUVCUTUVLUVKVTUUQEB
      UVCUUQUVESNZUVEQUCUVPVKVLZNZUBUWDUVBUVEUSPNZUBZUVEBNUVEUVCNZUUQUWDUWFUWGU
      UQUWDUBZUWGUVEUVBWAWBZUWFUWDUVEWJNZUVBWJNZUWGUWKVTUUQUVEWCZUUQUVBUVNWDZUV
      EUVBWEWFUWJUWKUVEUVPQWBZUWFUWDUWLUWMUWKUWPVTUUQUWNUWOUVEUVBWGWFUVPUFNUWFU
      WPVTUVBOURWHQUVPUVEUFEWKWIVGWLWMWNUVESUWEBJWOUWIUVEUVRNZUWGUBUWHUVEOUVBWP
      UWDUWQUWGUVEWQWRWSWTXABCUVCQRUUSXOVSXBUUQCUVHUTUVKUVIVTUUQCUWBUVHKUUQUWBT
      UVHVJZUVHUUQUWAUVHTUUQUVHGPZUURPZUWAUVHUUQUWSUVPUURUUQUWSUVHFUFFUKOURUJXC
      XDXETUDZPZOURUJZUVPUUQUVHTNZUWSUXCUTUUQUVHXFMVJZTUUQUVHXFNZUVHMNZUVHUXENU
      UPUXFUUOADHMLXGUQUUQUUPUVHAXHWBZUXGUUOUUPXIZUUQUUPADXJZUXHUXIADXKZADHMLXL
      XMZUVHAXNXMUVHXFMXPXQXRXSZUXDUWSUXBOXDXTUJZURUJUXCFOXDGUXAUVHIUXAYAZVEYBY
      CUXNOUXBUROYDYFYEYGVSUUQUXBUVBOURUUQAYPPZUXAPZUXBUVBUUQUXPUVHUXAUUQAUVHXH
      WBUXDUXPUVHUTUUQUVHAUXLYHUXMAUVHYIXMYJUUPUXQUVBUTUUOFAUXAUXOYKUQYLYMYNYJU
      UQTSGUMZUXDUWTUVHUTUVQUXRUVTTSRQGYOVGUXMTSUVHGYQVRYLYRUUQUVHTYSZUWRUVHUTU
      UQTYTUXDUXSUUAUXMTUVHUUBVRUVHTUUHUUCYNUUDUVCCUVHQRUUSVCVSXBUUQUUPUXJUVJUX
      IUXKADHMLUUEXMUVCUVHAQRDHUUSUUIXMZUVCAQDUUTYOUVCAUUTUUFUUGUUQOUVBUUJUVCAM
      UUTUUKXMUXTUVFUVDEUUTUFUVCAQDUUTUVEUULUUMUUN $.
  $}

  ${
    $d f n A $.  $d f n R $.
    $( Any finite ordered set has an order isometry to a one-based finite
       sequence.  (Contributed by Mario Carneiro, 2-Apr-2014.) $)
    fz1iso $p |- ( ( R Or A /\ A e. Fin ) ->
                  E. f f Isom < , R ( ( 1 ... ( # ` A ) ) , A ) ) $=
      ( vn cn clt ccnv chash cfv c1 caddc co csn cima cin com cvv cv cmpt eqid
      crdg cres coi fz1isolem ) AEFGAHIJKLZMNOZPUEDQDRJKLSJUAPUBZGIOZBCDUGABUCZ
      UGTUFTUHTUITUD $.
  $}

  ${
    $d k m n y A $.  $d k m n y F $.  $d k m n y G $.  $d m n y H $.  $d y N $.
    $d k m n y M $.  $d k m n y .+ $.  $d k m n y ph $.  $d k n S $.  $d k Z $.
    seqcoll.1 $e |- ( ( ph /\ k e. S ) -> ( Z .+ k ) = k ) $.
    seqcoll.1b $e |- ( ( ph /\ k e. S ) -> ( k .+ Z ) = k ) $.
    seqcoll.c $e |- ( ( ph /\ ( k e. S /\ n e. S ) ) -> ( k .+ n ) e. S ) $.
    seqcoll.a $e |- ( ph -> Z e. S ) $.
    seqcoll.2 $e |- ( ph -> G Isom < , < ( ( 1 ... ( # ` A ) ) , A ) ) $.
    seqcoll.3 $e |- ( ph -> N e. ( 1 ... ( # ` A ) ) ) $.
    seqcoll.4 $e |- ( ph -> A C_ ( ZZ>= ` M ) ) $.
    seqcoll.5 $e |- ( ( ph /\ k e. ( M ... ( G ` ( # ` A ) ) ) ) ->
                      ( F ` k ) e. S ) $.
    seqcoll.6 $e |- ( ( ph /\ k e. ( ( M ... ( G ` ( # ` A ) ) ) \ A ) ) ->
                      ( F ` k ) = Z ) $.
    seqcoll.7 $e |- ( ( ph /\ n e. ( 1 ... ( # ` A ) ) ) ->
                      ( H ` n ) = ( F ` ( G ` n ) ) ) $.
    $( The function ` F ` contains a sparse set of non-zero values to be
       summed.  The function ` G ` is an order isomorphism from the set of
       non-zero values of ` F ` to a 1-based finite sequence, and ` H `
       collects these non-zero values together.  Under these conditions, the
       sum over the values in ` H ` yields the same result as the sum over the
       original set ` F ` .  (Contributed by Mario Carneiro, 2-Apr-2014.) $)
    seqcoll $p |- ( ph -> ( seq M ( .+ , F ) ` ( G ` N ) ) =
                          ( seq 1 ( .+ , H ) ` N ) ) $=
      ( vy vm c1 chash cfv cfz co wcel cseq wceq cn wi elfznn caddc eleq1 fveq2
      syl cv fveq2d eqeq12d imbi12d imbi2d cuz cres wf1o wf wiso isof1o elfzuz2
      clt eluzfz1 ffvelrnd sseldd cle wbr eluzle cxr wss wb cr cz elfzelz ssriv
      zssre sstri a1i ressxr syl6ss eluzelre eluzfz2 leisorel syl122anc eluzelz
      f1of mpbid elfz5 syl2anc mpbird eleq1d expcom vtoclga mpcom cmin peano2zm
      cdif wa zred lem1d letrd eluz fzss2 sselda wn w3a adantr sylan con2d syl5
      ex imp eldifd syldan seq1 ad2antlr elfzuz3 adantl elfzuzb sylanbrc isorel
      ad2antrr syl12anc zltlem1 elfzle2 uztrn adantrr 3bitrd cc a2d ccnv f1ocnv
      eluzel2 elfzm11 simp3 ffvelrnda nnge1d breqtrd lenltd sylbid seqid fveq1d
      f1ocnvfv2 uzid fvres eqtr4d 3eqtr3d 1z ax-mp syl6eqr simplr nnuz syl6eleq
      a1d peano2uzr imim1d oveq1 simpll nnre ltp1d simpr seqcl simplll peano2uz
      nnz elfzuz syl2anr syl2an elfzle1 jca simprr btwnnz 3expib breq2d zltp1le
      sylc breq1d anbi12d mtbid expr seqid2 oveq1d impcom adantlr oveq2d ax-1cn
      zcnd npcan sylancl eluzp1p1 eqeltrrd seqm1 3eqtr4rd seqp1 syld nnind mpd
      syl5ibr ) AKUEBUFUGZUHUIZUJZKHUGZCGJUKZUGZKCIUEUKZUGZULZRKUMUJZAUXKUXQUNZ
      AUXKUXRRKUXIUOUSAUCUTZUXJUJZUXTHUGZUXMUGZUXTUXOUGZULZUNZUNAUEUXJUJZUEHUGZ
      UXMUGZUEUXOUGZULZUNZUNAUDUTZUXJUJZUYMHUGZUXMUGZUYMUXOUGZULZUNZUNAUYMUEUPU
      IZUXJUJZUYTHUGZUXMUGZUYTUXOUGZULZUNZUNAUXSUNUCUDKUXTUEULZUYFUYLAVUGUYAUYG
      UYEUYKUXTUEUXJUQVUGUYCUYIUYDUYJVUGUYBUYHUXMUXTUEHURVAUXTUEUXOURVBVCVDUXTU
      YMULZUYFUYSAVUHUYAUYNUYEUYRUXTUYMUXJUQVUHUYCUYPUYDUYQVUHUYBUYOUXMUXTUYMHU
      RVAUXTUYMUXOURVBVCVDUXTUYTULZUYFVUFAVUIUYAVUAUYEVUEUXTUYTUXJUQVUIUYCVUCUY
      DVUDVUIUYBVUBUXMUXTUYTHURVAUXTUYTUXOURVBVCVDUXTKULZUYFUXSAVUJUYAUXKUYEUXQ
      UXTKUXJUQVUJUYCUXNUYDUXPVUJUYBUXLUXMUXTKHURVAUXTKUXOURVBVCVDAUYKUYGAUYIUE
      IUGZUYJAUYHUXMUYHVEUGZVFZUGZUYHCGUYHUKZUGZUYIVUKAUYHVUMVUOAECDGJUYHLMPABJ
      VEUGZUYHSAUXJBUEHAUXJBHVGZUXJBHVHZAUXJBVLVLHVIZVURQUXJBVLVLHVJUSZUXJBHWPU
      SZAUXIUEVEUGZUJZUYGAUXKVVDRKUEUXIVKUSZUEUXIVMUSZVNVOZUYHJUXIHUGZUHUIZUJZA
      UYHGUGZDUJZAVVJUYHVVHVPVQZAUEUXIVPVQZVVMAVVDVVNVVEUEUXIVRUSAVUTUXJVSVTZBV
      SVTZUYGUXIUXJUJZVVNVVMWAQAUXJWBVSUXJWBVTAUXJWCWBEUXJWCEUTZUEUXIWDWEWFWGWH
      WIWJZABWBVSABVUQWBSEVUQWBJVVRWKWEWJZWIWJZVVFAVVDVVQVVEUEUXIWLUSZUXJBUEUXI
      HWMWNWQZAUYHVUQUJZVVHWCUJZVVJVVMWAVVGAVVHVUQUJVWEABVUQVVHSAUXJBUXIHVVBVWB
      VNVOJVVHWOUSZUYHJVVHWRWSWTAVVRGUGZDUJZUNAVVLUNEUYHVVIVVRUYHULZVWHVVLAVWIV
      WGVVKDVVRUYHGURXAVDAVVRVVIUJZVWHTXBXCXDAVVRJUYHUEXEUIZUHUIZUJZVVRVVIBXGUJ
      ZVWGLULZAVWMXHVVRVVIBAVWLVVIVVRAVVHVWKVEUGUJZVWLVVIVTAVWPVWKVVHVPVQZAVWKU
      YHVVHAVWKAUYHWCUJZVWKWCUJZAVWDVWRVVGJUYHWOUSZUYHXFUSZXIAUYHVWTXIZAVVHVWFX
      IZAUYHVXBXJVWCXKAVWSVWEVWPVWQWAVXAVWFVWKVVHXLWSWTVWKJVVHXMUSXNAVWMVVRBUJZ
      XOZAVWMVVRWCUJZJVVRVPVQZVVRUYHVLVQZXPZVXEAJWCUJZVWRVWMVXIWAAVWDVXJVVGJUYH
      UUCUSZVWTVVRJUYHUUDWSVXIVXHAVXEVXFVXGVXHUUEAVXDVXHAVXDVXHXOZAVXDXHZUYHVVR
      VPVQVXLVXMUYHVVRHUUAZUGZHUGZVVRVPVXMUEVXOVPVQZUYHVXPVPVQZVXMVXOVXMVXOUXJU
      JZVXOUMUJABUXJVVRVXNABUXJVXNVGZBUXJVXNVHZAVURVXTVVAUXJBHUUBUSBUXJVXNWPUSZ
      UUFZVXOUXIUOUSUUGVXMVUTVVOVVPUYGVXSVXQVXRWAAVUTVXDQXQAVVOVXDVVSXQAVVPVXDV
      WAXQAUYGVXDVVFXQVYCUXJBUEVXOHWMWNWQAVURVXDVXPVVRULZVVAUXJBVVRHUUMZXRUUHVX
      MUYHVVRAUYHWBUJVXDVXBXQABWBVVRVVTXNUUIWQYAXSXTUUJYBYCUAYDUUKUULAUYHVULUJZ
      VUNUYIULAVWRVYFVWTUYHUUNUSUYHVULUXMUUOUSAVUPVVKVUKAVWRVUPVVKULVWTCGUYHYEU
      SUYGAVUKVVKULZVVFAFUTZIUGZVYHHUGZGUGZULZUNZAVYGUNFUEUXJVYHUEULZVYLVYGAVYN
      VYIVUKVYKVVKVYHUEIURVYNVYJUYHGVYHUEHURVAVBVDAVYHUXJUJVYLUBXBZXCXDUUPUUQUE
      WCUJUYJVUKULUURCIUEYEUUSUUTUVDUYMUMUJZAUYSVUFAVYPUYSVUFUNAVYPXHZUYSVUAUYR
      UNVUFVYQVUAUYNUYRVYQVUAUYNVYQVUAXHZUYMVVCUJZUXIUYMVEUGUJZUYNVYRUYMUMVVCAV
      YPVUAUVAUVBUVCZVYRUYMWCUJZUXIUYTVEUGUJZVYTVYPWUBAVUAUYMUVOZYFVUAWUCVYQUYT
      UEUXIYGYHUYMUXIUVEWSUYMUEUXIYIYJZYAUVFVYQVUAUYRVUEVYQVUAUYRVUEUNUYRVUEVYR
      UYPUYTIUGZCUIZUYQWUFCUIZULUYPUYQWUFCUVGVYRVUCWUGVUDWUHVYRUYPVUBGUGZCUIVUB
      UEXEUIZUXMUGZWUICUIZWUGVUCVYRUYPWUKWUICVYRECDGUYOJWUJLVYRAVVRDUJZVVRLCUIV
      VRULAVYPVUAUVHZNXRVYRBVUQUYOABVUQVTZVYPVUASYLZVYRUXJBUYMHAVUSVYPVUAVVBYLZ
      WUEVNVOZVYRWUJUYOVEUGZUJZUYOWUJVPVQZVYRUYOVUBVLVQZWVAVYRUYMUYTVLVQZWVBVYR
      UYMVYPUYMWBUJAVUAUYMUVIYFUVJVYRVUTUYNVUAWVCWVBWAAVUTVYPVUAQYLZWUEVYQVUAUV
      KZUXJBUYMUYTVLVLHYKYMWQVYRUYOWCUJZVUBWCUJZWVBWVAWAVYRUYOVUQUJZWVFWURJUYOW
      OUSZVYRVUBVUQUJWVGVYRBVUQVUBWUPVYRUXJBUYTHWUQWVEVNVOJVUBWOUSZUYOVUBYNWSWQ
      VYRWVFWUJWCUJZWUTWVAWAWVIVYRWVGWVKWVJVUBXFUSZUYOWUJXLWSWTZVYREFCDGJUYOWUR
      VYRVVRJUYOUHUIZUJVWJVWHVYRWVNVVIVVRVYRVVHWUSUJZWVNVVIVTVYRVVHWUJVEUGUJZWU
      TWVOVYRWVPWUJVVHVPVQZVYRWUJVUBVVHVYRWUJWVLXIVYRVUBWVJXIZAVVHWBUJVYPVUAVXC
      YLVYRVUBWVRXJVYRUYTUXIVPVQZVUBVVHVPVQZVUAWVSVYQUYTUEUXIYOYHVYRVUTVVOVVPVU
      AVVQWVSWVTWAWVDAVVOVYPVUAVVSYLAVVPVYPVUAVWAYLWVEAVVQVYPVUAVWBYLUXJBUYTUXI
      HWMWNWQXKVYRWVKVWEWVPWVQWAWVLAVWEVYPVUAVWFYLWUJVVHXLWSWTZWVMWUJVVHUYOYPWS
      UYOJVVHXMUSXNVYRAVWJVWHWUNTXRYDVYRAWUMVYHDUJXHVVRVYHCUIDUJWUNOXRUVLVYRVVR
      UYOUEUPUIZWUJUHUIUJZXHZAVWNVWOAVYPVUAWWCUVMWWDVVRVVIBWWDVVRVUQUJZVVHVVRVE
      UGZUJZVWJWWCVVRWWBVEUGUJWWBVUQUJZWWEVYRVVRWWBWUJUVPVYRWVHWWHWURJUYOUVNUSW
      WBVVRJYPUVQVYRWVPWUJWWFUJWWGWWCWWAVVRWWBWUJYGWUJVVHVVRYPUVRVVRJVVHYIYJVYR
      WWCVXEWWCWWBVVRVPVQZVVRWUJVPVQZXHZVYRVXEWWCWWIWWJVVRWWBWUJUVSVVRWWBWUJYOU
      VTVYRVXDWWKVYQVUAVXDWWKXOVYQVUAVXDXHZXHZUYMVXOVLVQZVXOUYTVLVQZXHZWWKWWMWU
      BVXOWCUJZWWPXOVYPWUBAWWLWUDYFWWMVXSWWQWWMBUXJVVRVXNAVYAVYPWWLVYBYLVYQVUAV
      XDUWAZVNZVXOUEUXIWDUSWUBWWPWWQWUBWWNWWOWWQXOUYMVXOUWBUWCXSUWFWWMWWNWWIWWO
      WWJWWMWWNUYOVXPVLVQZUYOVVRVLVQZWWIWWMVUTUYNVXSWWNWWTWAAVUTVYPWWLQYLZVYQVU
      AUYNVXDWUEYQWWSUXJBUYMVXOVLVLHYKYMWWMVXPVVRUYOVLWWMVURVXDVYDAVURVYPWWLVVA
      YLWWRVYEWSZUWDWWMWVFVXFWXAWWIWAVYQVUAWVFVXDWVIYQWWMWWEVXFWWMBVUQVVRAWUOVY
      PWWLSYLWWRVOJVVRWOUSZUYOVVRUWEWSYRWWMWWOVXPVUBVLVQZVVRVUBVLVQZWWJWWMVUTVX
      SVUAWWOWXEWAWXBWWSVYQVUAVUAVXDWVEYQUXJBVXOUYTVLVLHYKYMWWMVXPVVRVUBVLWXCUW
      GWWMVXFWVGWXFWWJWAWXDVYQVUAWVGVXDWVJYQVVRVUBYNWSYRUWHUWIUWJXSXTYBYCUAWSUW
      KUWLVYRWUFWUIUYPCAVUAWUFWUIULZVYPVUAAWXGVYMAWXGUNFUYTUXJVYHUYTULZVYLWXGAW
      XHVYIWUFVYKWUIVYHUYTIURWXHVYJVUBGVYHUYTHURVAVBVDVYOXCUWMUWNUWOVYRVXJVUBJU
      EUPUIVEUGZUJVUCWULULAVXJVYPVUAVXKYLVYRWUJUEUPUIZVUBWXIVYRVUBYSUJUEYSUJWXJ
      VUBULVYRVUBWVJUWQUWPVUBUEUWRUWSVYRWUJVUQUJZWXJWXIUJVYRWUTWVHWXKWVMWURUYOW
      UJJYPWSJWUJUWTUSUXACGJVUBUXBWSUXCVYRVYSVUDWUHULWUACIUEUYMUXDUSVBUXHYAYTUX
      EXBYTUXFXDUXG $.
  $}

  ${
    $d k n A $.  $d k n F $.  $d k n G $.  $d n H $.  $d k n M $.  $d k n ph $.
    $d k N $.  $d k n .+ $.  $d k n S $.  $d k Z $.
    seqcoll2.1 $e |- ( ( ph /\ k e. S ) -> ( Z .+ k ) = k ) $.
    seqcoll2.1b $e |- ( ( ph /\ k e. S ) -> ( k .+ Z ) = k ) $.
    seqcoll2.c $e |- ( ( ph /\ ( k e. S /\ n e. S ) ) -> ( k .+ n ) e. S ) $.
    seqcoll2.a $e |- ( ph -> Z e. S ) $.
    seqcoll2.2 $e |- ( ph -> G Isom < , < ( ( 1 ... ( # ` A ) ) , A ) ) $.
    seqcoll2.3 $e |- ( ph -> A =/= (/) ) $.
    seqcoll2.5 $e |- ( ph -> A C_ ( M ... N ) ) $.
    seqcoll2.6 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. S ) $.
    seqcoll2.7 $e |- ( ( ph /\ k e. ( ( M ... N ) \ A ) ) -> ( F ` k ) = Z ) $.
    seqcoll2.8 $e |- ( ( ph /\ n e. ( 1 ... ( # ` A ) ) ) ->
                       ( H ` n ) = ( F ` ( G ` n ) ) ) $.
    $( The function ` F ` contains a sparse set of non-zero values to be
       summed.  The function ` G ` is an order isomorphism from the set of
       non-zero values of ` F ` to a 1-based finite sequence, and ` H `
       collects these non-zero values together.  Under these conditions, the
       sum over the values in ` H ` yields the same result as the sum over the
       original set ` F ` .  (Contributed by Mario Carneiro, 13-Dec-2014.) $)
    seqcoll2 $p |- ( ph -> ( seq M ( .+ , F ) ` N ) =
                           ( seq 1 ( .+ , H ) ` ( # ` A ) ) ) $=
      ( chash cfv cseq c1 cfz co cuz fzssuz wf1o wf clt wiso isof1o syl f1of cn
      wcel cc0 wceq wn c0 wne cfn wb wss fzfi sylancr hasheq0 necon3bbid mpbird
      ssfi cn0 wo hashcl elnn0 sylib mt3d nnuz syl6eleq eluzfz2 ffvelrnd sseldd
      ord sseldi elfzuz3 cv fzss2 sselda syldan seqcl caddc cdif peano2uz fzss1
      wa wbr eluzelre adantr peano2re elfzelz zred adantl ltp1d elfzle1 ltletrd
      cr cle ccnv f1ocnv simprr elfzle2 cz nn0red lenltd mpbid isorel f1ocnvfv2
      syl12anc syl2anc breq2d bitrd mtbid expr mt2d eldifd seqid2 syl6ss ssdifd
      seqcoll eqtr3d ) ABUCUDZHUDZCGJUEZUDKYOUDYMCIUFUEUDAECDGYNJKLNAJKUGUHZJUI
      UDZYNJKUJZABYPYNSAUFYMUGUHZBYMHAYSBHUKZYSBHULAYSBUMUMHUNZYTQYSBUMUMHUOUPZ
      YSBHUQUPAYMUFUIUDZUSYMYSUSZAYMURUUCAYMURUSZYMUTVAZAUUFVBBVCVDRAUUFBVCABVE
      USZUUFBVCVAVFAYPVEUSBYPVGUUGJKVHSYPBVMVIZBVEVJUPVKVLAUUEUUFAYMVNUSZUUEUUF
      VOAUUGUUIUUHBVPUPZYMVQVRWEVSVTWAUFYMWBUPZWCWDZWFZAYNYPUSKYNUIUDUSZUULYNJK
      WGUPZAEFCDGJYNUUMAEWHZJYNUGUHZUSUUPYPUSUUPGUDZDUSAUUQYPUUPAUUNUUQYPVGUUOY
      NJKWIUPZWJTWKZOWLAUUPYNUFWMUHZKUGUHZUSZUUPYPBWNZUSZUURLVAZAUVCWQZUUPYPBAU
      VBYPUUPAUVAYQUSZUVBYPVGAYNYQUSZUVHUUMJYNWOUPUVAJKWPUPWJUVGUUPBUSZYNUUPUMW
      RZUVGYNUVAUUPAYNXHUSZUVCAUVIUVLUUMJYNWSUPWTZUVGUVLUVAXHUSUVMYNXAUPUVCUUPX
      HUSAUVCUUPUUPUVAKXBXCXDUVGYNUVMXEUVCUVAUUPXIWRAUUPUVAKXFXDXGAUVCUVJUVKVBA
      UVCUVJWQZWQZYMUUPHXJZUDZUMWRZUVKUVOUVQYMXIWRZUVRVBUVOUVQYSUSZUVSUVOBYSUUP
      UVPUVOBYSUVPUKZBYSUVPULUVOYTUWAAYTUVNUUBWTZYSBHXKUPBYSUVPUQUPAUVCUVJXLZWC
      ZUVQUFYMXMUPUVOUVQYMUVOUVQUVOUVTUVQXNUSUWDUVQUFYMXBUPXCUVOYMAUUIUVNUUJWTX
      OXPXQUVOUVRYNUVQHUDZUMWRZUVKUVOUUAUUDUVTUVRUWFVFAUUAUVNQWTAUUDUVNUUKWTUWD
      YSBYMUVQUMUMHXRXTUVOUWEUUPYNUMUVOYTUVJUWEUUPVAUWBUWCYSBUUPHXSYAYBYCYDYEYF
      YGUAWKYHABCDEFGHIJYMLMNOPQUUKABYPYQSYRYIUUTAUUPUUQBWNZUSUVEUVFAUWGUVDUUPA
      UUQYPBUUSYJWJUAWKUBYKYL $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
  Finite induction on the size of the first component of a binary relation
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Lemma for ~ brfi1ind :  The size of a set is the size of this set with one
     element removed, increased by 1.  (Contributed by Alexander van der
     Vekens, 7-Jan-2018.) $)
  brfi1indlem $p |- ( ( V e. W /\ N e. V /\ Y e. NN0 )
                 -> ( ( # ` V ) = ( Y + 1 ) -> ( # ` ( V \ { N } ) ) = Y ) ) $=
    ( wcel cn0 w3a chash cfv c1 co wceq wa cmin wi adantr imp ex 3ad2ant2 eqtrd
    caddc csn cdif cfn wss peano2nn0 eleq1a hashclb ad2antlr mpbird syl 3adant2
    impcom snssi hashssdif syl2anc oveq1 hashsng oveq2d nn0cn ax-1cn a1i pncand
    wb cc 3ad2ant3 sylan9eqr ) BCEZABEZDFEZGZBHIZDJUAKZLZBAUBZUCHIZDLVKVNMZVPVL
    VOHIZNKZDVQBUDEZVOBUEZVPVSLVKVNVTVHVJVNVTOZVIVJVHWBVJVMFEZVHWBODUFWCVHWBWCV
    HMZVNVTWDVNMVTVLFEZWDVNWEWCVNWEOVHVMFVLUGPQVHVTWEVDWCVNBCUHUIUJRRUKUMULQVKW
    AVNVIVHWAVJABUNSPBVOUOUPVNVKVSVMVRNKZDVLVMVRNUQVKWFVMJNKZDVIVHWFWGLVJVIVRJV
    MNABURUSSVJVHWGDLVIVJDJDUTJVEEVJVAVBVCVFTVGTR $.

  ${
    $d e n v x y $.  $d E e n v $.  $d F f v w $.  $d G e f n v w y $.
    $d G x $.  $d V e n v $.  $d ps f n w y $.  $d ps x $.  $d th e n v $.
    $d ch f w $.  $d ph e n v $.  $d L e n v x y $.
    brfi1uzind.r $e |- Rel G $.
    brfi1uzind.f $e |- F e. U $.
    brfi1uzind.l $e |- L e. NN0 $.
    brfi1uzind.1 $e |- ( ( v = V /\ e = E ) -> ( ps <-> ph ) ) $.
    brfi1uzind.2 $e |- ( ( v = w /\ e = f ) -> ( ps <-> th ) ) $.
    brfi1uzind.3 $e |- ( ( v G e /\ n e. v ) -> ( v \ { n } ) G F ) $.
    brfi1uzind.4 $e |- ( ( w = ( v \ { n } ) /\ f = F ) -> ( th <-> ch ) ) $.
    brfi1uzind.base $e |- ( ( v G e /\ ( # ` v ) = L ) -> ps ) $.
    brfi1uzind.step $e |- ( ( ( ( y + 1 ) e. NN0
           /\ ( v G e /\ ( # ` v ) = ( y + 1 ) /\ n e. v ) ) /\ ch ) -> ps ) $.
    $( Properties of a binary relation with a finite first component with at
       least L elements, proven by finite induction on the size of the first
       component.  This theorem can be applied for graphs (as binary relation
       between the set of vertices and an edge function) with a finite number
       of vertices, usually with ` L = 0 ` (see ~ brfi1ind ) or ` L = 1 ` .
       (Contributed by Alexander van der Vekens, 7-Jan-2018.) $)
    brfi1uzind $p |- ( ( V G E /\ V e. Fin /\ L <_ ( # ` V ) ) -> ph ) $=
      ( vx wbr cfn wcel chash cfv cle wi cn0 hashcl cv wceq wa wex df-clel nn0z
      wal cz mp1i ad2antlr wb breq2 eqcoms biimpcd adantr imp c1 caddc co eqeq1
      anbi2d imbi1d 2albidv weq eqcom sylan2b gen2 a1i w3a breq12 fveq2 anbi12d
      eqeq2d imbi12d cbval2v cc0 nn0ge0 cr 0re zre letr syl3anc cuz 0nn0 pm3.22
      nn0re 0z eluz1 mpbird eluznn0 sylancr ex syl6com com14 pm2.43a com12 mp2b
      3adant1 clt 1re 0lt1 addgegt0d simpr breqtrrd adantrl cvv vex hashgt0elex
      wel csn cdif simpl brfi1indlem syl5bi peano2nn0 ad2antrr jca ax-mp spc2gv
      com15 com23 mpcom mpd exlimiv syl simplrr 3jca difexg eqeq1d syl5bb mp2an
      simprlr expdimp 3anbi2i anbi2i sylanb exp41 com4l com25 impancom alrimivv
      ee12an impcom sylan uzind brrelexi brrelex2i exp3a syl5com expcom pm2.43i
      exp31 com24 sylbi 3imp ) PLNUGZPUHUIZOPUJUKZULUGZAUVLUVKUVNAUMZUVLUVMUNUI
      ZUVKUVOUMZPUOUVPKUPZUVMUQZUVRUNUIZURZKUSUVQKUVMUNUTUWAUVQKUVSUVTUVQUVSUVT
      UVQUMUVSUVKUVTUVSUVOUVKUVSUVTUVSUVOUMUMUVNUVTUVSUVKUVSURZAUVNUVTUVSUWBAUM
      ZUVNUVTURZUVSURZGUPZIUPZNUGZUVRUWFUJUKZUQZURZBUMZIVBGVBZUWBAUWEOVCUIZUVRV
      CUIZOUVRULUGZUWMOUNUIZUWNUWESOVAVDUVTUWOUVNUVSUVRVAVEUWDUVSUWPUVNUVSUWPUM
      UVTUVSUVNUWPUVNUWPVFUVMUVRUVMUVROULVGVHVIVJVKUWHUFUPZUWIUQZURZBUMZIVBGVBU
      WHOUWIUQZURZBUMZIVBGVBZUWHEUPZUWIUQZURZBUMZIVBGVBZUWHUXFVLVMVNZUWIUQZURZB
      UMZIVBGVBZUWMUFEOUVRUWROUQZUXAUXDGIUXPUWTUXCBUXPUWSUXBUWHUWROUWIVOVPVQVRU
      FEVSZUXAUXIGIUXQUWTUXHBUXQUWSUXGUWHUWRUXFUWIVOVPVQVRUWRUXKUQZUXAUXNGIUXRU
      WTUXMBUXRUWSUXLUWHUWRUXKUWIVOVPVQVRUFKVSZUXAUWLGIUXSUWTUWKBUXSUWSUWJUWHUW
      RUVRUWIVOVPVQVRUXEUWNUXDGIUXBUWHUWIOUQBOUWIVTUDWAWBWCUXJFUPZJUPZNUGZUXFUX
      TUJUKZUQZURZDUMZJVBFVBZUWNUXFVCUIZOUXFULUGZWDZUXOUXIUYFGIFJGFVSZIJVSZURZU
      XHUYEBDUYMUWHUYBUXGUYDUWFUXTUWGUYANWEUYKUXGUYDVFUYLUYKUWIUYCUXFUWFUXTUJWF
      WHVJWGUAWIWJUYJUYGUXOUYJUYGURUXNGIUYJUXMUYGBUYJUXFUNUIZUXMUYGBUMZUYHUYIUY
      NUWNUWQWKOULUGZUYHUYIURZUYNUMSOWLUYQUYPUYNUYHUYIUYPUYNUMZUYIUYHUYRUYPUYIU
      YHUYHUYNUYPUYIUYHUYHUYNUMZUMUYHUYPUYIURZWKUXFULUGZUYSUYHWKWMUIZOWMUIZUXFW
      MUIUYTVUAUMVUBUYHWNWCUWQVUCUYHSOXAVDUXFWOWKOUXFWPWQVUAUYHUYNVUAUYHURZWKUN
      UIUXFWKWRUKUIZUYNWSVUDVUEUYHVUAURZVUAUYHWTWKVCUIVUEVUFVFVUDXBWKUXFXCVDXDU
      XFWKXEXFXGXHXGXIXJVKXKXLXMUYNUXMURWKUWIXNUGZUYOUYNUXLVUGUWHUXLUYNUWIUXKUQ
      ZVUGUXKUWIVTZUYNVUHURWKUXKUWIXNUYNWKUXKXNUGVUHUYNUXFVLUXFXAVLWMUIUYNXOWCU
      XFWLWKVLXNUGUYNXPWCXQVJUYNVUHXRXSWAXTUXMUYNVUGUYOUMZUWHUXLUYNVUJUMZUWFYAU
      IZUWHUXLVUKUMUMGYBZVULVUGUXLUYNUWHUYOVULVUGUXLUYNUWHUYOUMZUMUMZVULVUGURKG
      YDZKUSVUOKUWFYAYCVUPVUOKUWHVUPUXLUYNUYOUWHVUPUXLUYNUYOUMUMZUWHVUPURUWFUVR
      YEZYFZMNUGZVUQUBUWHVUPVUTVUQUMUYNVUPVUTUXLUWHUYOUYNVUPVUTUXLVUNUMUMUYNVUP
      URZUXLVUTVUNVVAUXLVUTVUNUMZVUSUJUKZUXFUQZVVAUXLURZVVBVVAUXLVVDVVAVULVUPUY
      NUXLVVDUMVULVVAVUMWCUYNVUPXRUYNVUPYGUXLVUHVULVUPUYNWDVVDVUIUVRUWFYAUXFYHY
      IWQVKVVDVUTVVEVUNUYGVUTVVEUWHVVDBUYGVUTVVEUWHVVDBUMUYGVUTURZVVEURZUWHURZU
      XKUNUIZUWHUXLVUPWDZURZVVDCBVVHVVIVVJVVEVVIVVFUWHUYNVVIVUPUXLUXFYJYKVEVVHU
      WHUXLVUPVVGUWHXRVVFVVAUXLUWHUUAVVGVUPUWHVVFUYNVUPUXLUUGVJUUBYLVVFVVDCUMVV
      EUWHUYGVUTVVDCVUSYAUIZMHUIUYGVUTVVDURZCUMZUMVULVVLVUMUWFVURYAUUCYMRUYFVVN
      FJVUSMYAHUXTVUSUQZUYAMUQZURZUYEVVMDCVVQUYBVUTUYDVVDUXTVUSUYAMNWEVVOUYDVVD
      VFVVPUYDUYCUXFUQVVOVVDUXFUYCVTVVOUYCVVCUXFUXTVUSUJWFUUDUUEVJWGUCWIYNUUFUU
      HYKVVKVVIUWHVUHVUPWDZURCBVVJVVRVVIUXLVUHUWHVUPVUIUUIUUJUEUUKUUQUULYOYPYQX
      GYPXGYOVKYRXGUUMYSYTXGUUNYMVKUURYRUUSUUOUUPXGYIUUTWQUVKUVSUWMAUMZPYAUIZLY
      AUIZURZUVKUVSVVSUMUVKVVTVWAPLNQUVAPLNQUVBYLVWBUVKUVSVVSVWBUWMUWBAUWLUWCGI
      PLYAYAUWFPUQZUWGLUQZURZUWKUWBBAVWEUWHUVKUWJUVSUWFPUWGLNWEVWCUWJUVSVFVWDVW
      CUWIUVMUVRUWFPUJWFWHVJWGTWIYNYPUVCYQVKUVDUVGXIUVEUVHUVFVKYSUVIYTXKUVJ $.
  $}

  ${
    $d E e n v $.  $d F f v w $.  $d G e f n v w y $.  $d V e n v $.
    $d ps f n w y $.  $d th e n v $.  $d ch f w $.  $d ph e n v $.
    brfi1ind.r $e |- Rel G $.
    brfi1ind.f $e |- F e. U $.
    brfi1ind.1 $e |- ( ( v = V /\ e = E ) -> ( ps <-> ph ) ) $.
    brfi1ind.2 $e |- ( ( v = w /\ e = f ) -> ( ps <-> th ) ) $.
    brfi1ind.3 $e |- ( ( v G e /\ n e. v ) -> ( v \ { n } ) G F ) $.
    brfi1ind.4 $e |- ( ( w = ( v \ { n } ) /\ f = F ) -> ( th <-> ch ) ) $.
    brfi1ind.base $e |- ( ( v G e /\ ( # ` v ) = 0 ) -> ps ) $.
    brfi1ind.step $e |- ( ( ( ( y + 1 ) e. NN0
           /\ ( v G e /\ ( # ` v ) = ( y + 1 ) /\ n e. v ) ) /\ ch ) -> ps ) $.
    $( Properties of a binary relation with a finite first component, proven by
       finite induction on the size of the first component.  This theorem can
       be applied for graphs (as binary relation between the set of vertices
       and an edge function) with a finite number of vertices, e.g.
       ~ usgrafis .  (Contributed by Alexander van der Vekens, 7-Jan-2018.) $)
    brfi1ind $p |- ( ( V G E /\ V e. Fin ) -> ph ) $=
      ( wbr cfn wcel cc0 chash cfv cle hashge0 adantl 0nn0 brfi1uzind mpd3an3 )
      OLNUDZOUEUFZUGOUHUIUJUDZAUQURUPOUEUKULABCDEFGHIJKLMNUGOPQUMRSTUAUBUCUNUO
      $.
      $( direct:
      vx cfn wcel wbr chash cfv cn0 wi hashcl cv wa wex df-clel wal cc0 caddc
      wceq c1 co eqeq2 anbi2d imbi1d 2albidv gen2 breq12 wb fveq2 eqeq1d adantr
      weq anbi12d imbi12d cbval2v clt nn0re 1re a1i nn0ge0 0lt1 addgegt0d simpr
      cr breqtrrd adantrl cvv vex wel hashgt0elex csn simpl brfi1indlem syl3anc
      cdif imp w3a peano2nn0 ad2antrr ad2antlr simplrr simprlr jca difexg ax-mp
      3jca spc2gv mp2an expdimp ee12an exp41 com15 com23 mpcom ex com4l exlimiv
      mpd com25 impcom impancom alrimivv syl5bi nn0ind brrelexi brrelex2i exp3a
      syl syl5 expcom eqcoms sylbi ) OUEUFZOLNUGZAYNOUHUIZUJUFZYOAUKZOULYQKUMZY
      PUTZYSUJUFZUNZKUOYRKYPUJUPUUBYRKYTUUAYRUUAYRUKYPYSYPYSUTZYOUUAAYOUUCUUAAU
      KUUAGUMZIUMZNUGZUUDUHUIZYSUTZUNZBUKZIUQGUQZYOUUCUNZAUUFUUGUDUMZUTZUNZBUKZ
      IUQGUQUUFUUGURUTZUNZBUKZIUQGUQUUFUUGEUMZUTZUNZBUKZIUQGUQZUUFUUGUUTVAUSVBZ
      UTZUNZBUKZIUQGUQZUUKUDEYSUUMURUTZUUPUUSGIUVJUUOUURBUVJUUNUUQUUFUUMURUUGVC
      VDVEVFUDEVMZUUPUVCGIUVKUUOUVBBUVKUUNUVAUUFUUMUUTUUGVCVDVEVFUUMUVEUTZUUPUV
      HGIUVLUUOUVGBUVLUUNUVFUUFUUMUVEUUGVCVDVEVFUDKVMZUUPUUJGIUVMUUOUUIBUVMUUNU
      UHUUFUUMYSUUGVCVDVEVFUUSGIUBVGUVDFUMZJUMZNUGZUVNUHUIZUUTUTZUNZDUKZJUQFUQZ
      UUTUJUFZUVIUVCUVTGIFJGFVMZIJVMZUNZUVBUVSBDUWEUUFUVPUVAUVRUUDUVNUUEUVONVHU
      WCUVAUVRVIUWDUWCUUGUVQUUTUUDUVNUHVJVKVLVNSVOVPUWBUWAUVIUWBUWAUNUVHGIUWBUV
      GUWABUWBUVGUNURUUGVQUGZUWABUKZUWBUVFUWFUUFUWBUVFUNURUVEUUGVQUWBURUVEVQUGU
      VFUWBUUTVAUUTVRVAWEUFUWBVSVTUUTWAURVAVQUGUWBWBVTWCVLUWBUVFWDWFWGUVGUWBUWF
      UWGUKZUUFUVFUWBUWHUKZUUDWHUFZUUFUVFUWIUKUKGWIZUWJUWFUVFUWBUUFUWGUWJUWFUVF
      UWBUUFUWGUKZUKUKZUWJUWFUNKGWJZKUOUWMKUUDWHWKUWNUWMKUUFUWNUVFUWBUWGUUFUWNU
      VFUWBUWGUKUKZUUFUWNUNUUDYSWLZWPZMNUGZUWOTUUFUWNUWRUWOUKUWBUWNUWRUVFUUFUWG
      UWBUWNUWRUVFUWLUKUKUWBUWNUNZUVFUWRUWLUWSUVFUWRUWLUKZUWQUHUIZUUTUTZUWSUVFU
      NZUWTUWSUVFUXBUWSUWJUWNUWBUVFUXBUKUWJUWSUWKVTUWBUWNWDUWBUWNWMYSUUDWHUUTWN
      WOWQUXBUWRUXCUWLUWAUWRUXCUUFUXBBUWAUWRUXCUUFUXBBUKUWAUWRUNZUXCUNZUUFUNZUV
      EUJUFZUUFUVFUWNWRZUNUXBCBUXFUXGUXHUXCUXGUXDUUFUWBUXGUWNUVFUUTWSWTXAUXFUUF
      UVFUWNUXEUUFWDUXDUWSUVFUUFXBUXEUWNUUFUXDUWBUWNUVFXCVLXGXDUXDUXBCUKUXCUUFU
      WAUWRUXBCUWQWHUFZMHUFUWAUWRUXBUNZCUKZUKUWJUXIUWKUUDUWPWHXEXFQUVTUXKFJUWQM
      WHHUVNUWQUTZUVOMUTZUNZUVSUXJDCUXNUVPUWRUVRUXBUVNUWQUVOMNVHUXLUVRUXBVIUXMU
      XLUVQUXAUUTUVNUWQUHVJVKVLVNUAVOXHXIXJWTUCXKXLXMXNXOXPXNXPXMWQXSXPXQXRYIXP
      XTXFWQYAXSYBYCXPYDYEYOUUCUUKAUKZOWHUFZLWHUFZUNZYOUUCUXOUKYOUXPUXQOLNPYFOL
      NPYGXDUXRYOUUCUXOUXRUUKUULAUUJUULAUKGIOLWHWHUUDOUTZUUELUTZUNZUUIUULBAUYAU
      UFYOUUHUUCUUDOUUELNVHUXSUUHUUCVIUXTUXSUUGYPYSUUDOUHVJVKVLVNRVOXHXNYHXOWQY
      JYKXNYLWQXRYMYIYA $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Words over a set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Word $.
  $c concat $.
  $c <" "> $.
  $c substr $.
  $c splice $.
  $c reverse $.

  $( Syntax for the Word operator. $)
  cword $a class Word S $.

  $( Syntax for the concatenation operator. $)
  cconcat $a class concat $.

  $( Syntax for the singleton word constructor. $)
  cs1 $a class <" A "> $.

  $( Syntax for the subword operator. $)
  csubstr $a class substr $.

  $( Syntax for the word splicing operator. $)
  csplice $a class splice $.

  $( Syntax for the word reverse operator. $)
  creverse $a class reverse $.

  ${
    $d l w S $.
    $( Define the class of _words over a set_.  A word is a finite sequence of
       symbols from a set.  The domain is forced so that two words with the
       same symbols in the same order will be the same.  This is sometimes
       denoted with the Kleene star, although properly speaking that is an
       operator on languages.  (Contributed by FL, 14-Jan-2014.)  (Revised by
       Stefan O'Rear, 14-Aug-2015.)  (Revised by Mario Carneiro,
       26-Feb-2016.) $)
    df-word $a |- Word S = { w | E. l e. NN0 w : ( 0 ..^ l ) --> S } $.
  $}

  ${
    $d s b t l x $.

    $( Define the concatenation operator which combines two words.
       (Contributed by FL, 14-Jan-2014.)  (Revised by Stefan O'Rear,
       15-Aug-2015.) $)
    df-concat $a |- concat = ( s e. _V , t e. _V |-> ( x e. ( 0 ..^
            ( ( # ` s ) + ( # ` t ) ) ) |-> if ( x e. ( 0 ..^ ( # ` s ) ) ,
            ( s ` x ) , ( t ` ( x - ( # ` s ) ) ) ) ) ) $.

    $( Define the canonical injection from symbols to words.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro,
       26-Feb-2016.) $)
    df-s1 $a |- <" A "> = { <. 0 , ( _I ` A ) >. } $.

    $( Define an operation which extracts portions of words.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.) $)
    df-substr $a |- substr = ( s e. _V , b e. ( ZZ X. ZZ ) |->
        if ( ( ( 1st ` b ) ..^ ( 2nd ` b ) ) C_ dom s ,
          ( x e. ( 0 ..^ ( ( 2nd ` b ) - ( 1st ` b ) ) ) |->
            ( s ` ( x + ( 1st ` b ) ) ) ) , (/) ) ) $.

    $( Define an operation which replaces portions of words.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.) $)
    df-splice $a |- splice = ( s e. _V , b e. _V |->
        ( ( ( s substr <. 0 , ( 1st ` ( 1st ` b ) ) >. ) concat ( 2nd ` b ) )
          concat ( s substr <. ( 2nd ` ( 1st ` b ) ) , ( # ` s ) >. ) ) ) $.

    $( Define an operation which reverses the order of symbols in a word.
       (Contributed by Stefan O'Rear, 26-Aug-2015.) $)
    df-reverse $a |- reverse = ( s e. _V |-> ( x e. ( 0 ..^ ( # ` s ) ) |->
            ( s ` ( ( ( # ` s ) - 1 ) - x ) ) ) ) $.
  $}

  ${
    $d s l w S $.  $d s l w V $.  $d l w W $.  $d l L $.  $d s l w T $.
    $( Property of being a word over a set with a quantifier over the length.
       (Contributed by Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario
       Carneiro, 26-Feb-2016.) $)
    iswrd $p |- ( W e. Word S <->
          E. l e. NN0 W : ( 0 ..^ l ) --> S ) $=
      ( vw cword wcel cc0 cv cfzo co wf cn0 wrex cab df-word eleq2i cvv wfn cfn
      ffn fzofi fnfi mpan2 elex 3syl rexlimivw wceq feq1 rexbidv elab3 bitri )
      BAEZFBGCHZIJZADHZKZCLMZDNZFUNABKZCLMZULURBDACOPUQUTDBUSBQFZCLUSBUNRZBSFZV
      AUNABTVBUNSFVCGUMUAUNBUBUCBSUDUEUFUOBUGUPUSCLUNAUOBUHUIUJUK $.

    $( Value of the set of words over a set.  (Contributed by Stefan O'Rear,
       10-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
    wrdval $p |- ( S e. V -> Word S = U_ l e. NN0 ( S ^m ( 0 ..^ l ) ) ) $=
      ( vw wcel cn0 cc0 cv cfzo co cmap ciun wf wrex cab cword eliun cvv ovex
      wb elmapg mpan2 rexbidv syl5bb abbi2dv df-word syl6reqr ) ABEZCFAGCHZIJZK
      JZLZUJADHZMZCFNZDOAPUHUODULUMULEUMUKEZCFNUHUOCUMFUKQUHUPUNCFUHUJREUPUNTGU
      IISAUJUMBRUAUBUCUDUEDACUFUG $.

    $( A one-based sequence is a word.  (Contributed by Stefan O'Rear,
       15-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
    iswrdi $p |- ( W : ( 0 ..^ L ) --> S -> W e. Word S ) $=
      ( vl cc0 cfzo co wf cv cn0 wrex cword wcel wceq oveq2 feq2d rspcev wn wa
      c0 0nn0 wne cn fzo0n0 nnnn0 sylbi necon1bi fzo0 syl6eqr sylancr pm2.61ian
      biimpa iswrd sylibr ) EBFGZACHZEDIZFGZACHZDJKZCALMBJMZUPUTUSUPDBJUQBNURUO
      ACUQBEFOPQVARZUPSEJMEEFGZACHZUTUAVBUPVDVBUOVCACVBUOTVCVAUOTUOTUBBUCMVABUD
      BUEUFUGEUHUIPULUSVDDEJUQENURVCACUQEEFOPQUJUKACDUMUN $.

    $( The empty set is a word (frequently denoted &#949; in this context).
       (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
    wrd0 $p |- (/) e. Word S $=
      ( cc0 cfzo co c0 wf cword wcel f0 fzo0 feq2i mpbir iswrdi ax-mp ) BBCDZAE
      FZEAGHPEAEFAIOEAEBJKLABEMN $.

    $( A word is a zero-based sequence with a recoverable upper limit.
       (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
    wrdf $p |- ( W e. Word S -> W : ( 0 ..^ ( # ` W ) ) --> S ) $=
      ( vl cword wcel cc0 cv cfzo co wf cn0 wrex chash cfv iswrd simpr wfn wceq
      wa ffn hashfn syl hashfzo0 sylan9eqr oveq2d feq2d mpbird rexlimiva sylbi
      ) BADEFCGZHIZABJZCKLFBMNZHIZABJZABCOULUOCKUJKEZULSZUOULUPULPUQUNUKABUQUMU
      JFHULUPUMUKMNZUJULBUKQUMURRUKABTUKBUAUBUJUCUDUEUFUGUHUI $.

    $( A word is a finite set.  (Contributed by Stefan O'Rear, 2-Nov-2015.) $)
    wrdfin $p |- ( W e. Word S -> W e. Fin ) $=
      ( cword wcel cc0 chash cfv cfzo co wf cfn wrdf wfn ffn fzofi fnfi sylancl
      syl ) BACDEBFGZHIZABJZBKDZABLUABTMTKDUBTABNESOTBPQR $.

    $( The length of a word is a nonnegative integer.  (Contributed by Stefan
       O'Rear, 27-Aug-2015.) $)
    lencl $p |- ( W e. Word S -> ( # ` W ) e. NN0 ) $=
      ( cword wcel cfn chash cfv cn0 wrdfin hashcl syl ) BACDBEDBFGHDABIBJK $.

    $( The length of a nonempty word is a positive integer.  (Contributed by
       Mario Carneiro, 1-Oct-2015.) $)
    lennncl $p |- ( ( W e. Word S /\ W =/= (/) ) -> ( # ` W ) e. NN ) $=
      ( cword wcel chash cfv cn c0 wne cfn wb wrdfin hashnncl syl biimpar ) BAC
      DZBEFGDZBHIZPBJDQRKABLBMNO $.

    $( The set of words respects ordering on the base set.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro,
       26-Feb-2016.) $)
    sswrd $p |- ( S C_ T -> Word S C_ Word T ) $=
      ( vw vl wss cword cc0 cv cfzo co cn0 wrex wcel fss expcom reximdv 3imtr4g
      wf iswrd ssrdv ) ABEZCAFZBFZUAGDHIJZACHZRZDKLUDBUERZDKLUEUBMUEUCMUAUFUGDK
      UFUAUGUDABUENOPAUEDSBUEDSQT $.

    $( Equality theorem for the set of words.  (Contributed by Mario Carneiro,
       26-Feb-2016.) $)
    wrdeq $p |- ( S = T -> Word S = Word T ) $=
      ( wss wa cword wceq sswrd anim12i eqss 3imtr4i ) ABCZBACZDAEZBEZCZNMCZDAB
      FMNFKOLPABGBAGHABIMNIJ $.

    $( The set of words over a set is a set.  (Contributed by Mario Carneiro,
       26-Feb-2016.) $)
    wrdexg $p |- ( S e. V -> Word S e. _V ) $=
      ( vl vs wcel cword cn0 cc0 cv cfzo co cmap ciun cvv wrdval cz cxp cpw wss
      wral mapsspw elfzoelz ssriv xpss1 ax-mp sspwb sstri rgenw iunss mpbir zex
      mpbi xpexg mpan pwexg syl ssexg sylancr eqeltrd ) ABEZAFCGAHCIZJKZLKZMZNA
      BCOUTVDPAQZRZSZVFNEZVDNEVGVCVFSZCGTVICGVCVBAQZRZVFAVBUAVJVESZVKVFSVBPSVLD
      VBPDIHVAUBUCVBPAUDUEVJVEUFULUGUHCGVCVFUIUJUTVENEZVHPNEUTVMUKPANBUMUNVENUO
      UPVDVFNUQURUS $.
  $}

  ${
    $d l w x y $.  $d l w y S $.
    nfwrd.1 $e |- F/_ x S $.
    $( Hypothesis builder for ` Word S ` .  (Contributed by Mario Carneiro,
       26-Feb-2016.) $)
    nfwrd $p |- F/_ x Word S $=
      ( vl vw cword cc0 cv cfzo co wf cn0 wrex cab df-word nfcv nff nfab nfcxfr
      nfrex ) ABFGDHIJZBEHZKZDLMZENEBDOUDAEUCADLALPAUABUBAUBPAUAPCQTRS $.
  $}

  ${
    $d s t x S $.  $d s t x T $.  $d s t x V $.  $d s t x W $.  $d x B $.
    $d x I $.  $d x U $.
    $( The concatenation operator is a two-argument function.  (Contributed by
       Mario Carneiro, 27-Sep-2015.) $)
    ccatfn $p |- concat Fn ( _V X. _V ) $=
      ( vs vt vx cvv cc0 cv chash cfv caddc cfzo wcel crn cun fvrn0 sselii rnex
      co vex p0ex unex cmin cif cmpt cconcat df-concat c0 csn eqid ssun1 keepel
      wf ssun2 a1i fmpti ovex fex2 mp3an fnmpt2i ) ABDDCEAFZGHZBFZGHIQZJQZCFZEU
      TJQKZVDUSHZVDUTUAQZVAHZUBZUCZUDCBAUEVCUSLZUFUGZMZVALZVLMZMZVJUKVCDKVPDKVJ
      DKCVCVPVIVJVJUHVIVPKVDVCKVEVFVHVPVMVPVFVMVOUIUSVDNOVOVPVHVOVMULVAVGNOUJUM
      UNEVBJUOVMVOVKVLUSARPSTVNVLVABRPSTTVCVPVJDDUPUQUR $.

    $( Value of the concatenation operator.  (Contributed by Stefan O'Rear,
       15-Aug-2015.) $)
    ccatfval $p |- ( ( S e. V /\ T e. W ) -> ( S concat T ) =
        ( x e. ( 0 ..^ ( ( # ` S ) + ( # ` T ) ) ) |->
          if ( x e. ( 0 ..^ ( # ` S ) ) , ( S ` x ) ,
            ( T ` ( x - ( # ` S ) ) ) ) ) ) $=
      ( vs vt wcel cvv co cc0 chash cfv caddc cfzo cv cmin wceq oveq2d adantr
      cconcat cif cmpt elex wa fveq2 oveqan12d wb fveq1 simpr fveq12d ifbieq12d
      eleq2d mpteq12dv df-concat ovex mptex ovmpt2a syl2an ) BDHBIHCIHBCUAJAKBL
      MZCLMZNJZOJZAPZKUTOJZHZVDBMZVDUTQJZCMZUBZUCZRCEHBDUDCEUDFGBCIIAKFPZLMZGPZ
      LMZNJZOJZVDKVMOJZHZVDVLMZVDVMQJZVNMZUBZUCVKUAVLBRZVNCRZUEZAVQWCVCVJWFVPVB
      KOWDWEVMUTVOVANVLBLUFZVNCLUFUGSWFVSVFVTWBVGVIWDVSVFUHWEWDVRVEVDWDVMUTKOWG
      SUMTWDVTVGRWEVDVLBUITWFWAVHVNCWDWEUJWDWAVHRWEWDVMUTVDQWGSTUKULUNAGFUOAVCV
      JKVBOUPUQURUS $.

    $( The concatenation of two words is a word.  (Contributed by FL,
       2-Feb-2014.)  (Proof shortened by Stefan O'Rear, 15-Aug-2015.) $)
    ccatcl $p |- ( ( S e. Word B /\ T e. Word B ) ->
        ( S concat T ) e. Word B ) $=
      ( vx wcel wa co cc0 chash cfv cfzo cmin wf ad2antrr adantl cfn cn0 wrdfin
      wrdf syl cword cconcat caddc cv cif ccatfval ffvelrnda wn cz simpr adantr
      cmpt wo hashcl nn0zd fzospliti syl2anc orcanai wceq nn0cnd subidd pncan2d
      fzosubel oveq12d eleqtrd ffvelrnd ifclda eqid fmptd iswrdi eqeltrd ) BAUA
      ZEZCVLEZFZBCUBGDHBIJZCIJZUCGZKGZDUDZHVPKGZEZVTBJZVTVPLGZCJZUEZULZVLDBCVLV
      LUFVOVSAWGMWGVLEVODVSWFAWGVOVTVSEZFZWBWCWEAWIWAAVTBVMWAABMVNWHABSNUGWIWBU
      HZFZHVQKGZAWDCVOWLACMZWHWJVNWMVMACSONWKWDVPVPLGZVRVPLGZKGZWLWKVTVPVRKGEZV
      PUIEZWDWPEWIWBWQWIWHWRWBWQUMVOWHUJVOWRWHVOVPVOBPEZVPQEVMWSVNABRUKBUNTZUOZ
      UKVTHVRVPUPUQURVOWRWHWJXANVTVPVRVPVCUQVOWPWLUSWHWJVOWNHWOVQKVOVPVOVPWTUTZ
      VAVOVPVQXBVOVQVOCPEZVQQEVNXCVMACROCUNTUTVBVDNVEVFVGWGVHVIAVRWGVJTVK $.

    $( The length of a concatenated word.  (Contributed by Stefan O'Rear,
       15-Aug-2015.) $)
    ccatlen $p |- ( ( S e. Word B /\ T e. Word B ) ->
        ( # ` ( S concat T ) ) = ( ( # ` S ) + ( # ` T ) ) ) $=
      ( vx cword wcel wa cconcat co chash cfv cc0 caddc cfzo cmin wceq fvex cn0
      cv lencl cif cmpt ccatfval fveq2d wfn ifex eqid fnmpti hashfn mp1i syl2an
      nn0addcl hashfzo0 syl 3eqtrd ) BAEZFZCUPFZGZBCHIZJKDLBJKZCJKZMIZNIZDSZLVA
      NIFZVEBKZVEVAOIZCKZUAZUBZJKZVDJKZVCUSUTVKJDBCUPUPUCUDVKVDUEVLVMPUSDVDVJVK
      VFVGVIVEBQVHCQUFVKUGUHVDVKUIUJUSVCRFZVMVCPUQVARFVBRFVNURABTACTVAVBULUKVCU
      MUNUO $.

    $( Value of a symbol in the left half of a concatenated word.  (Contributed
       by Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro,
       22-Sep-2015.) $)
    ccatval1 $p |- ( ( S e. Word B /\ T e. Word B /\
          I e. ( 0 ..^ ( # ` S ) ) ) -> ( ( S concat T ) ` I ) = ( S ` I ) ) $=
      ( vx wcel cc0 chash cfv cfzo co cmin cif cvv wceq cz cfn cn0 wrdfin syl
      cword w3a cv caddc cconcat cmpt ccatfval 3adant3 eleq1 fveq2 oveq1 fveq2d
      ifbieq12d iftrue 3ad2ant3 sylan9eqr wa cuz wss adantr hashcl nn0zd adantl
      cle wbr zaddcld cr nn0red nn0addge1 syl2anc eluz2 syl3anbrc fzoss2 sselda
      3impa fvex a1i fvmptd ) BAUAZFZCVSFZDGBHIZJKZFZUBZEDEUCZWCFZWFBIZWFWBLKZC
      IZMZDBIZGWBCHIZUDKZJKZBCUEKZNVTWAWPEWOWKUFOWDEBCVSVSUGUHWFDOZWEWKWDWLDWBL
      KZCIZMZWLWQWGWDWHWJWLWSWFDWCUIWFDBUJWQWIWRCWFDWBLUKULUMWDVTWTWLOWAWDWLWSU
      NUOUPVTWAWDDWOFVTWAUQZWCWODXAWNWBURIFZWCWOUSXAWBPFWNPFWBWNVDVEZXBXAWBXABQ
      FZWBRFVTXDWAABSUTBVATZVBZXAWBWMXFXAWMXACQFZWMRFZWAXGVTACSVCCVATZVBVFXAWBV
      GFXHXCXAWBXEVHXIWBWMVIVJWBWNVKVLWBGWNVMTVNVOWLNFWEDBVPVQVR $.

    $( Value of a symbol in the right half of a concatenated word.
       (Contributed by Stefan O'Rear, 15-Aug-2015.)  (Revised by Mario
       Carneiro, 22-Sep-2015.) $)
    ccatval2 $p |- ( ( S e. Word B /\ T e. Word B /\
          I e. ( ( # ` S ) ..^ ( ( # ` S ) + ( # ` T ) ) ) ) ->
        ( ( S concat T ) ` I ) = ( T ` ( I - ( # ` S ) ) ) ) $=
      ( vx cword wcel chash cfv caddc co cfzo w3a cv cc0 cmin cif cvv wceq cn0
      cconcat cmpt ccatfval 3adant3 eleq1 fveq2 fveq2d ifbieq12d wn cin fzodisj
      oveq1 c0 minel mpan2 3ad2ant3 iffalse syl sylan9eqr cfn wss wrdfin adantr
      wa hashcl cuz fzoss1 nn0uz eleq2s 3syl sseld 3impia fvex a1i fvmptd ) BAF
      ZGZCVPGZDBHIZVSCHIJKZLKZGZMZEDENZOVSLKZGZWDBIZWDVSPKZCIZQZDVSPKZCIZOVTLKZ
      BCUAKZRVQVRWNEWMWJUBSWBEBCVPVPUCUDWDDSZWCWJDWEGZDBIZWLQZWLWOWFWPWGWIWQWLW
      DDWEUEWDDBUFWOWHWKCWDDVSPULUGUHWCWPUIZWRWLSWBVQWSVRWBWEWAUJUMSWSOVSVTUKDW
      AWEUNUOUPWPWQWLUQURUSVQVRWBDWMGVQVRVDZWAWMDWTBUTGZVSTGWAWMVAZVQXAVRABVBVC
      BVEXBVSOVFITVSOVTVGVHVIVJVKVLWLRGWCWKCVMVNVO $.

    $( Value of a symbol in the right half of a concatenated word, using an
       index relative to the subword.  (Contributed by Stefan O'Rear,
       16-Aug-2015.) $)
    ccatval3 $p |- ( ( S e. Word B /\ T e. Word B /\
          I e. ( 0 ..^ ( # ` T ) ) ) ->
        ( ( S concat T ) ` ( I + ( # ` S ) ) ) = ( T ` I ) ) $=
      ( cword wcel cc0 chash cfv cfzo co w3a caddc cconcat cmin cz lencl nn0cnd
      cn0 nn0zd wceq simp3 3ad2ant1 3ad2ant2 pncan2d eleqtrrd zaddcld fzoaddel2
      oveq2d syl3anc ccatval2 syld3an3 elfzoelz 3ad2ant3 pncand fveq2d eqtrd
      zcnd ) BAEZFZCUSFZDGCHIZJKZFZLZDBHIZMKZBCNKIZVGVFOKZCIZDCIUTVAVDVGVFVFVBM
      KZJKFZVHVJUAVEDGVKVFOKZJKZFVKPFVFPFVLVEDVCVNUTVAVDUBVEVMVBGJVEVFVBVEVFUTV
      AVFSFVDABQUCZRZVEVBVAUTVBSFVDACQUDZRUEUIUFVEVFVBVEVFVOTZVEVBVQTUGVRDVKVFU
      HUJABCVGUKULVEVIDCVEDVFVEDVDUTDPFVADGVBUMUNURVPUOUPUQ $.

    $( Concatenation of a word by the empty word on the left.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.) $)
    ccatlid $p |- ( S e. Word B -> ( (/) concat S ) = S ) $=
      ( vx wcel cc0 chash cfv cfzo co c0 wfn wf mpan wrdf ffn caddc wceq syl5eq
      hash0 cmin cword cconcat ccatcl ccatlen oveq1i lencl nn0cnd addid2d eqtrd
      wrd0 3syl oveq2d fneq2d mpbid syl cv wa a1i oveq12d eleq2d biimpar mp3an1
      ccatval2 syldan oveq2i cz elfzoelz adantl zcnd subid1d fveq2d eqfnfvd ) B
      AUAZDZCEBFGZHIZJBUBIZBVNVQEVQFGZHIZKZVQVPKVNVQVMDZVSAVQLVTJVMDZVNWAAUJZAJ
      BUCMAVQNVSAVQOUKVNVSVPVQVNVRVOEHVNVRJFGZVOPIZVOWBVNVRWEQWCAJBUDMVNWEEVOPI
      VOWDEVOPSUEVNVOVNVOABUFUGUHRZUIULUMUNVNVPABLBVPKABNVPABOUOVNCUPZVPDZUQZWG
      VQGZWGWDTIZBGZWGBGVNWHWGWDWEHIZDZWJWLQZVNWNWHVNWMVPWGVNWDEWEVOHWDEQVNSURW
      FUSUTVAWBVNWNWOWCAJBWGVCVBVDWIWKWGBWIWKWGETIWGWDEWGTSVEWIWGWIWGWHWGVFDVNW
      GEVOVGVHVIVJRVKUIVL $.

    $( Concatenation of a word by the empty word on the right.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.) $)
    ccatrid $p |- ( S e. Word B -> ( S concat (/) ) = S ) $=
      ( vx cword wcel cc0 chash cfv cfzo co c0 cconcat wfn wrdf syl mpan2 caddc
      wf ffn wceq wrd0 wa ccatcl ccatlen hash0 oveq2i lencl nn0cnd syl5eq eqtrd
      addid1d oveq2d fneq2d mpbid cv ccatval1 mp3an2 eqfnfvd ) BADZEZCFBGHZIJZB
      KLJZBUTVCFVCGHZIJZMZVCVBMUTVEAVCRZVFUTKUSEZVGAUAZUTVHUBVCUSEVGABKUCAVCNOP
      VEAVCSOUTVEVBVCUTVDVAFIUTVDVAKGHZQJZVAUTVHVDVKTVIABKUDPUTVKVAFQJVAVJFVAQU
      EUFUTVAUTVAABUGUHUKUIUJULUMUNUTVBABRBVBMABNVBABSOUTVHCUOZVBEVLVCHVLBHTVIA
      BKVLUPUQUR $.

    $( Associative law for concatenation of words.  (Contributed by Stefan
       O'Rear, 15-Aug-2015.) $)
    ccatass $p |- ( ( S e. Word B /\ T e. Word B /\
          U e. Word B ) -> ( ( S concat T ) concat U ) =
          ( S concat ( T concat U ) ) ) $=
      ( wcel cc0 chash cfv caddc co cfzo cconcat wfn syl2anc wceq oveq2d adantr
      syl3anc syl cmin vx cword w3a wf ccatcl 3adant3 simp3 wrdf ccatlen oveq1d
      ffn eqtrd fneq2d mpbid simp1 3adant1 cn0 lencl 3ad2ant1 3ad2ant2 3ad2ant3
      3syl nn0cnd addassd 3eqtr4d cv wo cz nn0zd fzospliti ancoms simpl1 simpl2
      sylan wa simpr ccatval1 simpl3 cuz wss uzid uzaddcl fzoss2 sselda zaddcld
      sseqtr4d ccatval2 fzosubel3 eqtr4d fzoss1 nn0uz eleq2s cc elfzoelz adantl
      zcnd subsub4d fveq2d eleq2d biimpa syl13anc oveq12d biimpar jaodan syldan
      fzosubel2 eqfnfvd ) BAUBZEZCXHEZDXHEZUCZUAFBGHZCGHZIJZDGHZIJZKJZBCLJZDLJZ
      BCDLJZLJZXLXTFXTGHZKJZMZXTXRMXLXTXHEZYDAXTUDYEXLXSXHEZXKYFXIXJYGXKABCUEUF
      ZXIXJXKUGZAXSDUENAXTUHYDAXTUKVBXLYDXRXTXLYCXQFKXLYCXSGHZXPIJZXQXLYGXKYCYK
      OYHYIAXSDUINXLYJXOXPIXIXJYJXOOXKABCUIUFZUJZULPUMUNXLYBFYBGHZKJZMZYBXRMXLY
      BXHEZYOAYBUDYPXLXIYAXHEZYQXIXJXKUOZXJXKYRXIACDUEUPZABYAUENAYBUHYOAYBUKVBX
      LYOXRYBXLYNXQFKXLXMYAGHZIJZXMXNXPIJZIJZYNXQXLUUAUUCXMIXJXKUUAUUCOXIACDUIU
      PPZXLXIYRYNUUBOYSYTABYAUINXLXMXNXPXLXMXIXJXMUQEZXKABURUSZVCZXLXNXJXIXNUQE
      ZXKACURUTZVCZXLXPXKXIXPUQEZXJADURVAZVCVDZVEPUMUNXLUAVFZXREZUUOFXMKJZEZUUO
      XMXQKJZEZVGZUUOXTHZUUOYBHZOZXLXMVHEZUUPUVAXLXMUUGVIZUUPUVEUVAUUOFXQXMVJVK
      VNXLUURUVDUUTXLUURVOZUUOXSHZUUOBHZUVBUVCUVGXIXJUURUVHUVIOXIXJXKUURVLZXIXJ
      XKUURVMXLUURVPZABCUUOVQRUVGYGXKUUOFYJKJZEZUVBUVHOZXLYGUURYHQXIXJXKUURVRXL
      UUQUVLUUOXLUUQFXOKJZUVLXLXOXMVSHZEZUUQUVOVTXLXMUVPEZUUIUVQXLUVEUVRUVFXMWA
      SUUJXNXMXMWBNZXMFXOWCSXLYJXOFKYLPZWFWDAXSDUUOVQZRUVGXIYRUURUVCUVIOUVJXLYR
      UURYTQUVKABYAUUOVQRVEXLUUTUUOXMXOKJZEZUUOXOXQKJZEZVGZUVDXLXOVHEZUUTUWFXLX
      MXNUVFXLXNUUJVIZWEZUUTUWGUWFUUOXMXQXOVJVKVNXLUWCUVDUWEXLUWCVOZUVHUUOXMTJZ
      YAHZUVBUVCUWJUVHUWKCHZUWLUWJXIXJUWCUVHUWMOXIXJXKUWCVLZXIXJXKUWCVMZXLUWCVP
      ABCUUOWGRUWJXJXKUWKFXNKJEZUWLUWMOUWOXIXJXKUWCVRZXLXNVHEZUWCUWPUWHUWCUWRUW
      PUUOXMXNWHVKVNACDUWKVQRWIUWJYGXKUVMUVNXLYGUWCYHQUWQXLUWBUVLUUOXLUWBUVOUVL
      XLUUFUWBUVOVTZUUGUWSXMFVSHUQXMFXOWJWKWLSUVTWFWDUWARUWJXIYRUUOXMUUBKJZEZUV
      CUWLOZUWNXLYRUWCYTQXLUWBUWTUUOXLUWBUUSUWTXLXQXOVSHZEZUWBUUSVTXLXOUXCEZUUL
      UXDXLUWGUXEUWIXOWASUUMXPXOXOWBNXOXMXQWCSXLUUBXQXMKXLUUBUUDXQUUEUUNWIPZWFW
      DABYAUUOWGZRVEXLUWEVOZUUOYJTJZDHZUWLUVBUVCUXHUXJUWKXNTJZDHZUWLUXHUXIUXKDU
      XHUXIUUOXOTJZUXKXLUXIUXMOUWEXLYJXOUUOTYLPQUXHUUOXMXNUWEUUOWMEXLUWEUUOUUOX
      OXQWNWPWOXLXMWMEUWEUUHQXLXNWMEUWEUUKQWQWIWRUXHXJXKUWKXNUUCKJEZUWLUXLOXIXJ
      XKUWEVMXIXJXKUWEVRZUXHUUOXOUUDKJZEZUVEUWRUUCVHEZUXNXLUWEUXQXLUWDUXPUUOXLX
      QUUDXOKUUNPWSWTXLUVEUWEUVFQXLUWRUWEUWHQXLUXRUWEXLXNXPUWHXLXPUUMVIWEQUUOXM
      XNUUCXFXAACDUWKWGRWIUXHYGXKUUOYJYKKJZEZUVBUXJOXLYGUWEYHQUXOXLUXTUWEXLUXSU
      WDUUOXLYJXOYKXQKYLYMXBWSXCAXSDUUOWGRUXHXIYRUXAUXBXIXJXKUWEVLXLYRUWEYTQXLU
      WDUWTUUOXLUWDUUSUWTXLUVQUWDUUSVTUVSXOXMXQWJSUXFWFWDUXGRVEXDXEXDXEXG $.
  $}

  $( Identity function protection for a singleton word.  (Contributed by Mario
     Carneiro, 26-Feb-2016.) $)
  ids1 $p |- <" A "> = <" ( _I ` A ) "> $=
    ( cc0 cid cfv cop csn cs1 cvv wcel wceq fvex fvi ax-mp sneqi df-s1 3eqtr4ri
    opeq2i ) BACDZCDZEZFBREZFRGAGTUASRBRHISRJACKRHLMQNROAOP $.

  $( Value of a single-symbol word.  (Contributed by Stefan O'Rear,
     15-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s1val $p |- ( A e. V -> <" A "> = { <. 0 , A >. } ) $=
    ( wcel cs1 cc0 cid cfv cop csn df-s1 fvi opeq2d sneqd syl5eq ) ABCZADEAFGZH
    ZIEAHZIAJOQROPAEABKLMN $.

  $( Equality theorem for a singleton word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1eq $p |- ( A = B -> <" A "> = <" B "> ) $=
    ( wceq cc0 cid cfv cop csn cs1 fveq2 opeq2d sneqd df-s1 3eqtr4g ) ABCZDAEFZ
    GZHDBEFZGZHAIBIOQSOPRDABEJKLAMBMN $.

  ${
    s1eqd.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for a singleton word.  (Contributed by Mario Carneiro,
       26-Feb-2016.) $)
    s1eqd $p |- ( ph -> <" A "> = <" B "> ) $=
      ( wceq cs1 s1eq syl ) ABCEBFCFEDBCGH $.
  $}

  $( A singleton word is a word.  (Contributed by Stefan O'Rear, 15-Aug-2015.)
     (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s1cl $p |- ( A e. B -> <" A "> e. Word B ) $=
    ( wcel cc0 c1 cfzo co cs1 wf csn cop wss wf1o cn0 0nn0 f1osng mpan f1of syl
    cword snssi fss syl2anc s1val feq1d mpbird fzo01 feq2i sylibr iswrdi ) ABCZ
    DEFGZBAHZIZUMBTCUKDJZBUMIZUNUKUPUOBDAKJZIZUKUOAJZUQIZUSBLURUKUOUSUQMZUTDNCU
    KVAODANBPQUOUSUQRSABUAUOUSBUQUBUCUKUOBUMUQABUDUEUFULUOBUMUGUHUIBEUMUJS $.

  ${
    s1cld.1 $e |- ( ph -> A e. B ) $.
    $( A singleton word is a word.  (Contributed by Mario Carneiro,
       26-Feb-2016.) $)
    s1cld $p |- ( ph -> <" A "> e. Word B ) $=
      ( wcel cs1 cword s1cl syl ) ABCEBFCGEDBCHI $.
  $}

  $( A singleton word is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1cli $p |- <" A "> e. Word _V $=
    ( cs1 cid cfv cvv cword ids1 wcel fvex s1cl ax-mp eqeltri ) ABACDZBZEFZAGME
    HNOHACIMEJKL $.

  $( Length of a singleton word.  (Contributed by Stefan O'Rear, 15-Aug-2015.)
     (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s1len $p |- ( # ` <" A "> ) = 1 $=
    ( cs1 chash cfv cc0 cid cop csn c1 df-s1 fveq2i cvv wcel wceq hashsng ax-mp
    opex eqtri ) ABZCDEAFDZGZHZCDZISUBCAJKUALMUCINETQUALOPR $.

  $( A singleton is not the empty string.  (Contributed by Mario Carneiro,
     27-Feb-2016.) $)
  s1nz $p |- <" A "> =/= (/) $=
    ( c1 cc0 wne cs1 ax-1ne0 wceq chash fveq2 s1len hash0 3eqtr3g necon3i ax-mp
    c0 cfv ) BCDAEZODFQOBCQOGQHPOHPBCQOHIAJKLMN $.

  $( Sole symbol of a singleton word.  (Contributed by Stefan O'Rear,
     15-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s1fv $p |- ( A e. B -> ( <" A "> ` 0 ) = A ) $=
    ( wcel cc0 cs1 cfv cop csn s1val fveq1d cn0 wceq 0nn0 fvsng mpan eqtrd ) AB
    CZDAEZFDDAGHZFZAQDRSABIJDKCQTALMDAKBNOP $.

  ${
    $d x A $.  $d x W $.
    $( A word of length 1 is a singleton.  (Contributed by Stefan O'Rear,
       23-Aug-2015.) $)
    eqs1 $p |- ( ( W e. Word A /\ ( # ` W ) = 1 ) -> W = <" ( W ` 0 ) "> ) $=
      ( vx wcel chash cfv c1 wceq cc0 cfzo co wf wfn wrdf cz ax-mp fzo01 fveq2d
      ffn cvv cword wa cs1 adantr simpr oveq2d feq2d mpbid syl 0z snidg ffvelrn
      eleqtrri sylancl s1cld 3syl s1len oveq2i fneq2i sylib cv fvex s1fv eqcomi
      csn elsni eleq2s 3eqtr4a adantl eqfnfvd ) BAUAZDZBEFZGHZUBZCIGJKZBIBFZUCZ
      VOVPABLZBVPMVOIVMJKZABLZVSVLWAVNABNUDVOVTVPABVOVMGIJVLVNUEUFUGUHZVPABSUIV
      OVRIVREFZJKZMZVRVPMVOVRVKDWDAVRLWEVOVQAVOVSIVPDVQADWBIIVEZVPIODIWFDUJIOUK
      PQUMVPAIBULUNUOAVRNWDAVRSUPWDVPVRWCGIJVQUQURUSUTCVAZVPDZWGBFZWGVRFZHVOWHV
      QIVRFZWIWJWKVQVQTDWKVQHIBVBVQTVCPVDWHWGIBWGIHWGWFVPWGIVFQVGZRWHWGIVRWLRVH
      VIVJ $.
  $}

  $( The singleton word function is injective.  (Contributed by Mario Carneiro,
     1-Oct-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s111 $p |- ( ( S e. A /\ T e. A ) -> ( <" S "> = <" T "> <-> S = T ) ) $=
    ( wcel wa cs1 wceq cc0 cop csn s1val eqeqan12d cvv wb opex sneqbg mp1i eqid
    cz 0z opthg baibd mpan2 mpan adantr 3bitrd ) BADZCADZEZBFZCFZGHBIZJZHCIZJZG
    ZULUNGZBCGZUGUHUJUMUKUOBAKCAKLULMDUPUQNUIHBOULUNMPQUGUQURNZUHHSDZUGUSTUTUGE
    ZHHGZUSHRVAUQVBURHBHCSAUAUBUCUDUEUF $.

  ${
    $d s b x S $.  $d s b x F $.  $d s b x L $.  $d s b x V $.  $d x B $.
    $d s b x A $.  $d x X $.
    $( The set of words over a set is a set.  (Contributed by Mario Carneiro,
       26-Feb-2016.) $)
    wrdexb $p |- ( S e. _V <-> Word S e. _V ) $=
      ( vx cvv wcel cword wrdexg cuni wss cv cc0 cop csn opex snid cs1 wceq vex
      wa sylancr uniexg s1val ax-mp s1cl syl5eqelr elunii c0ex opeluu syl ssriv
      simprd 3syl ssexg impbii ) ACDZAEZCDZACFUPAUOGZGZGZHUSCDZUNBAUSBIZADZJUSD
      ZVAUSDZVBJVAKZUQDZVCVDRVBVEVELZDVGUODVFVEJVAMNVBVGVAOZUOVACDVHVGPBQZVACUA
      UBVAAUCUDVEVGUOUESJVAUQUFVIUGUHUJUIUPUQCDURCDUTUOCTUQCTURCTUKAUSCULSUM $.

    $( Value of a subword.  (Contributed by Stefan O'Rear, 15-Aug-2015.) $)
    swrdval $p |- ( ( S e. V /\ F e. ZZ /\ L e. ZZ ) ->
        ( S substr <. F , L >. ) = if ( ( F ..^ L ) C_ dom S ,
          ( x e. ( 0 ..^ ( L - F ) ) |-> ( S ` ( x + F ) ) ) , (/) ) ) $=
      ( vs vb wcel cz cvv cv c1st cfv c2nd cfzo co cc0 cmin c0 wceq w3a cop cxp
      cdm wss caddc cmpt cif csubstr cmpt2 df-substr a1i wa simprl fveq2 adantl
      op1stg 3adant1 sylan9eqr op2ndg simp2 simp3 oveq12d simp1 sseq12d fveq12d
      dmeqd oveq2d mpteq12dv eqidd ifbieq12d syl3anc elex 3ad2ant1 opelxpi ovex
      mptex 0ex ifex ovmpt2d ) BEHZCIHZDIHZUAZFGBCDUBZJIIUCZGKZLMZWGNMZOPZFKZUD
      ZUEZAQWIWHRPZOPZAKZWHUFPZWKMZUGZSUHZCDOPZBUDZUEZAQDCRPZOPZWPCUFPZBMZUGZSU
      HZUIJUIFGJWFWTUJTWDAFGUKULWDWKBTZWGWETZUMZUMXJWHCTZWIDTZWTXITWDXJXKUNXLWD
      WHWELMZCXKWHXOTXJWGWELUOUPWBWCXOCTWACDIIUQURUSXLWDWIWENMZDXKWIXPTXJWGWENU
      OUPWBWCXPDTWACDIIUTURUSXJXMXNUAZWMXCWSSXHSXQWJXAWLXBXQWHCWIDOXJXMXNVAZXJX
      MXNVBZVCXQWKBXJXMXNVDZVGVEXQAWOWRXEXGXQWNXDQOXQWIDWHCRXSXRVCVHXQWQXFWKBXT
      XQWHCWPUFXRVHVFVIXQSVJVKVLWAWBBJHWCBEVMVNWBWCWEWFHWACDIIVOURXIJHWDXCXHSAX
      EXGQXDOVPVQVRVSULVT $.

    $( A zero length substring.  (Contributed by Stefan O'Rear,
       27-Aug-2015.) $)
    swrd00 $p |- ( S substr <. X , X >. ) = (/) $=
      ( vx vs vb cop csubstr cdm wcel co c0 wceq cvv cz cxp cfzo cc0 cfv cmpt
      cv wa opelxp w3a wss cmin caddc cif swrdval fzo0 0ss eqsstri iftrue ax-mp
      zcn subidd oveq2d 3ad2ant2 syl6eq mpteq1d mpt0 syl5eq eqtrd 3expb sylan2b
      sylbi c1st c2nd df-substr ovex mptex 0ex ifex dmmpt2 eleq2s df-ov pm2.61i
      wn ndmfv ) ABBFZFZGHZIZAVSGJZKLZWDVTMNNOZOZWAVTWFIAMIZVSWEIZUAWDAVSMWEUBW
      HWGBNIZWIUAWDBBNNUBWGWIWIWDWGWIWIUCZWCBBPJZAHZUDZCQBBUEJZPJZCTZBUFJARZSZK
      UGZKCABBMUHWJWSWRKWMWSWRLWKKWLBUIWLUJUKWMWRKULUMWJWRCKWQSKWJCWOKWQWJWOQQP
      JZKWIWGWOWTLWIWIWNQQPWIBBUNUOUPUQQUIURUSCWQUTURVAVBVCVDVEDEMWEETZVFRZXAVG
      RZPJDTZHUDZCQXCXBUEJZPJZWPXBUFJXDRZSZKUGGCDEVHXEXIKCXGXHQXFPVIVJVKVLVMVNW
      BVQWCVTGRKAVSGVOVTGVRVAVP $.

    $( Closure of the subword extractor.  (Contributed by Stefan O'Rear,
       16-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
    swrdcl $p |- ( S e. Word A -> ( S substr <. F , L >. ) e. Word A ) $=
      ( vx vs vb wcel csubstr co c0 cz wa cv cfv cfzo cdm wss cc0 cmin cword n0
      cop eleq1 wne wex cxp cvv c1st c2nd caddc cmpt df-substr elmpt2cl2 opelxp
      cif sylib exlimiv sylbi w3a swrdval wf chash wrdf 3ad2ant1 ad2antrr simpr
      simplr simpll3 simpll2 fzoaddel2 syl3anc sseldd wceq fdm eleqtrd ffvelrnd
      syl eqid fmptd iswrdi wn wrd0 a1i ifclda eqeltrd 3expb sylan2 pm2.61ne )
      BAUAZHZBCDUCZIJZWJHZKWJHZWMKWMKWJUDWMKUEZWKCLHZDLHZMZWNWPENZWMHZEUFWSEWMU
      BXAWSEXAWLLLUGZHWSFGUHXBGNZUIOZXCUJOZPJFNZQRESXEXDTJPJWTXDUKJXFOULKUPBWLI
      WTEFGUMUNCDLLUOUQURUSWKWQWRWNWKWQWRUTZWMCDPJZBQZRZESDCTJZPJZWTCUKJZBOZULZ
      KUPWJEBCDWJVAXGXJXOKWJXGXJMZXLAXOVBXOWJHXPEXLXNAXOXPWTXLHZMZSBVCOPJZAXMBX
      GXSABVBZXJXQWKWQXTWRABVDVEVFZXRXMXIXSXRXHXIXMXGXJXQVHXRXQWRWQXMXHHXPXQVGW
      KWQWRXJXQVIWKWQWRXJXQVJWTDCVKVLVMXRXTXIXSVNYAXSABVOVRVPVQXOVSVTAXKXOWAVRW
      OXGXJWBMAWCZWDWEWFWGWHWOWKYBWDWI $.

    $( Value of the subword extractor in its intended domain.  (Contributed by
       Stefan O'Rear, 15-Aug-2015.) $)
    swrdval2 $p |- ( ( S e. Word A /\ F e. ( 0 ... L ) /\
          L e. ( 0 ... ( # ` S ) ) ) -> ( S substr <. F , L >. ) =
          ( x e. ( 0 ..^ ( L - F ) ) |-> ( S ` ( x + F ) ) ) ) $=
      ( wcel cc0 cfz co cfv cfzo wss c0 wceq elfzelz 3ad2ant2 3ad2ant3 cuz syl
      cz cword chash w3a cop csubstr cdm cmin cv caddc cmpt cif swrdval syl3anc
      simp1 elfzuz fzoss1 elfzuz3 fzoss2 sstrd wf wrdf 3ad2ant1 sseqtr4d iftrue
      fdm eqtrd ) CBUAZFZDGEHIFZEGCUBJZHIFZUCZCDEUDUEIZDEKIZCUFZLZAGEDUGIKIAUHD
      UIICJUJZMUKZVQVLVHDTFZETFZVMVRNVHVIVKUNVIVHVSVKDGEOPVKVHVTVIEGVJOQACDEVGU
      LUMVLVPVRVQNVLVNGVJKIZVOVLVNGEKIZWAVLDGRJFZVNWBLVIVHWCVKDGEUOPDGEUPSVLVJE
      RJFZWBWALVKVHWDVIEGVJUQQEGVJURSUSVHVIVOWANZVKVHWABCUTWEBCVAWABCVESVBVCVPV
      QMVDSVF $.

    $( Value of the subword extractor for left-anchored subwords.  (Contributed
       by Stefan O'Rear, 24-Aug-2015.) $)
    swrd0val $p |- ( ( S e. Word A /\ L e. ( 0 ... ( # ` S ) ) ) ->
        ( S substr <. 0 , L >. ) = ( S |` ( 0 ..^ L ) ) ) $=
      ( vx cword wcel cc0 chash cfv cfz cmin cfzo cmpt adantl zcnd wceq cuz syl
      co wa cv caddc cop csubstr cres cz elfzelz subid1d oveq2d mpteq1d addid1d
      elfzoelz fveq2d mpteq2dva eqtrd simpl eluzfz1 simpr swrdval2 syl3anc wrdf
      elfzuz wf adantr wss elfzuz3 fzoss2 feqresmpt 3eqtr4d ) BAEFZCGBHIZJSFZTZ
      DGCGKSZLSZDUAZGUBSZBIZMZDGCLSZVPBIZMZBGCUCUDSZBVTUEVMVSDVTVRMWBVMDVOVTVRV
      MVNCGLVMCVMCVLCUFFVJCGVKUGNOUHUIUJVMDVTVRWAVPVTFZVRWAPVMWDVQVPBWDVPWDVPVP
      GCULOUKUMNUNUOVMVJGGCJSFZVLWCVSPVJVLUPVMCGQIFZWEVLWFVJCGVKVBNGCUQRVJVLURD
      ABGCUSUTVMDGVKLSZAVTBVJWGABVCVLABVAVDVMVKCQIFZVTWGVEVLWHVJCGVKVFNCGVKVGRV
      HVI $.

    $( Length of a left-anchored subword.  (Contributed by Stefan O'Rear,
       24-Aug-2015.) $)
    swrd0len $p |- ( ( S e. Word A /\ L e. ( 0 ... ( # ` S ) ) ) ->
        ( # ` ( S substr <. 0 , L >. ) ) = L ) $=
      ( cword wcel cc0 chash cfv cfz co wa cop csubstr cfzo swrd0val fveq2d wfn
      cres wceq syl wss wf ffn cuz elfzuz3 fzoss2 fnssres syl2an hashfn elfznn0
      wrdf cn0 adantl hashfzo0 3eqtrd ) BADEZCFBGHZIJEZKZBFCLMJZGHBFCNJZRZGHZVA
      GHZCUSUTVBGABCOPUSVBVAQZVCVDSUPBFUQNJZQZVAVFUAZVEURUPVFABUBVGABUKVFABUCTU
      RUQCUDHEVHCFUQUECFUQUFTVFVABUGUHVAVBUITUSCULEZVDCSURVIUPCUQUJUMCUNTUO $.

    $( Length of an extracted subword.  (Contributed by Stefan O'Rear,
       16-Aug-2015.) $)
    swrdlen $p |- ( ( S e. Word A /\ F e. ( 0 ... L ) /\
          L e. ( 0 ... ( # ` S ) ) ) ->
        ( # ` ( S substr <. F , L >. ) ) = ( L - F ) ) $=
      ( vx cword wcel cc0 cfz chash cfv w3a cop csubstr cmin cfzo wfn wceq syl
      co caddc cmpt fvex eqid fnmpti swrdval2 fneq1d mpbiri hashfn cn0 fznn0sub
      cv 3ad2ant2 hashfzo0 eqtrd ) BAFGZCHDITGZDHBJKITGZLZBCDMNTZJKZHDCOTZPTZJK
      ZVBUSUTVCQZVAVDRUSVEEVCEULCUATZBKZUBZVCQEVCVGVHVFBUCVHUDUEUSVCUTVHEABCDUF
      UGUHVCUTUISUSVBUJGZVDVBRUQUPVIURCHDUKUMVBUNSUO $.

    $( A symbol in an extracted subword, indexed using the subword's indices.
       (Contributed by Stefan O'Rear, 16-Aug-2015.) $)
    swrdfv $p |- ( ( ( S e. Word A /\ F e. ( 0 ... L ) /\
            L e. ( 0 ... ( # ` S ) ) ) /\ X e. ( 0 ..^ ( L - F ) ) ) ->
        ( ( S substr <. F , L >. ) ` X ) = ( S ` ( X + F ) ) ) $=
      ( vx cword wcel cc0 cfz co chash cfv w3a cmin cfzo cop csubstr cv caddc
      cmpt swrdval2 fveq1d wceq oveq1 fveq2d eqid fvex fvmpt sylan9eq ) BAGHCID
      JKHDIBLMJKHNZEIDCOKPKZHEBCDQRKZMEFULFSZCTKZBMZUAZMECTKZBMZUKEUMUQFABCDUBU
      CFEUPUSULUQUNEUDUOURBUNECTUEUFUQUGURBUHUIUJ $.

    $( A word is a subword of itself.  (Contributed by Stefan O'Rear,
       16-Aug-2015.) $)
    swrdid $p |- ( S e. Word A ->
        ( S substr <. 0 , ( # ` S ) >. ) = S ) $=
      ( vx wcel cc0 chash cfv cfzo co wfn wf wrdf ffn wceq cn0 nn0uz eleq2s syl
      eqtrd oveq2d cword cop csubstr swrdcl 3syl cmin cfz lencl eluzfz1 eluzfz2
      cuz swrdlen mpd3an23 nn0cnd subid1d fneq2d mpbid cv wa caddc simpl adantr
      eleq2d biimpar swrdfv syl31anc elfzoelz addid1d adantl fveq2d eqfnfvd
      zcnd ) BAUAZDZCEBFGZHIZBEVOUBUCIZBVNVQEVQFGZHIZJZVQVPJVNVQVMDVSAVQKVTABEV
      OUDAVQLVSAVQMUEVNVSVPVQVNVRVOEHVNVRVOEUFIZVOVNEEVOUGIZDZVOWBDZVRWANVNVOOD
      ZWCABUHZWCVOEUKGZOEVOUIPQRZVNWEWDWFWDVOWGOEVOUJPQRZABEVOULUMVNVOVNVOWFUNU
      OZSTUPUQVNVPABKBVPJABLVPABMRVNCURZVPDZUSZWKVQGZWKEUTIZBGZWKBGWMVNWCWDWKEW
      AHIZDZWNWPNVNWLVAVNWCWLWHVBVNWDWLWIVBVNWRWLVNWQVPWKVNWAVOEHWJTVCVDABEVOWK
      VEVFWMWOWKBWLWOWKNVNWLWKWLWKWKEVOVGVLVHVIVJSVK $.
  $}

  ${
    $d x A $.  $d x S $.  $d x X $.  $d x Y $.  $d x Z $.
    $( Joining two adjacent subwords makes a longer subword.  (Contributed by
       Stefan O'Rear, 20-Aug-2015.) $)
    ccatswrd $p |- ( ( S e. Word A /\ ( X e. ( 0 ... Y ) /\
        Y e. ( 0 ... Z ) /\ Z e. ( 0 ... ( # ` S ) ) ) ) ->
      ( ( S substr <. X , Y >. ) concat ( S substr <. Y , Z >. ) ) =
        ( S substr <. X , Z >. ) ) $=
      ( wcel cc0 cfz co chash cfv wa cmin cfzo adantr syl2anc caddc wceq oveq2d
      syl3anc vx cword w3a cop csubstr cconcat wfn wf swrdcl ccatcl ffn ccatlen
      wrdf simpl simpr1 simpr2 simpr3 fzass4 biimpri swrdlen oveq12d cz elfzelz
      3syl simpld syl npncan3d eqtrd fneq2d mpbid cv wo simpr zsubcld fzospliti
      eleq2d biimpar ccatval1 simpll simplr1 swrdfv syl31anc ccatval2 fzosubel3
      simplr2 simplr3 eqeltrd oveq1d cc elfzoelz adantl subcld subadd23d nncand
      zcnd 3eqtrd fveq2d jaodan syldan eqtr4d eqfnfvd ) BAUBZFZCGDHIFZDGEHIZFZE
      GBJKZHIZFZUCZLZUAGECMIZNIZBCDUDUEIZBDEUDUEIZUFIZBCEUDUEIZXKXPGXPJKZNIZUGZ
      XPXMUGXKXPXBFZXSAXPUHXTXKXNXBFZXOXBFZYAXCYBXJABCDUIOZXCYCXJABDEUIOZAXNXOU
      JPAXPUMXSAXPUKVDXKXSXMXPXKXRXLGNXKXRXNJKZXOJKZQIZXLXKYBYCXRYHRYDYEAXNXOUL
      PXKYHDCMIZEDMIZQIZXLXKYFYIYGYJQXKXCXDDXHFZYFYIRXCXJUNZXCXDXFXIUOZXKXFXIYL
      XCXDXFXIUPZXCXDXFXIUQZXFXILZYLEDXGHIFZYLYRLYQGDEXGURUSVEPZABCDUTTZXKXCXFX
      IYGYJRYMYOYPABDEUTTVAXKDCEXKDXKXFDVBFYODGEVCVFZWOZXKCXKXDCVBFYNCGDVCVFZWO
      ZXKEXKXIEVBFYPEGXGVCVFZWOVGZVHZVHSVIVJXKXQGXQJKZNIZUGZXQXMUGXKXQXBFZUUIAX
      QUHUUJXCUUKXJABCEUIOAXQUMUUIAXQUKVDXKUUIXMXQXKUUHXLGNXKXCCXEFZXIUUHXLRYMX
      KXDXFUULYNYOXDXFLZUULDCEHIFZUULUUNLUUMGCDEURUSVEPZYPABCEUTTSVIVJXKUAVKZXM
      FZLZUUPXPKZUUPCQIZBKZUUPXQKZXKUUQUUPGYINIZFZUUPYIXLNIZFZVLZUUSUVARZUURUUQ
      YIVBFZUVGXKUUQVMZXKUVIUUQXKDCUUAUUCVNOUUPGXLYIVOPXKUVDUVHUVFXKUVDLZUUSUUP
      XNKZUVAUVKYBYCUUPGYFNIZFZUUSUVLRXKYBUVDYDOXKYCUVDYEOXKUVNUVDXKUVMUVCUUPXK
      YFYIGNYTSVPVQAXNXOUUPVRTUVKXCXDYLUVDUVLUVARXCXJUVDVSXDXFXIXCUVDVTXKYLUVDY
      SOXKUVDVMABCDUUPWAWBVHXKUVFLZUUSUUPYFMIZXOKZUVPDQIZBKZUVAUVOYBYCUUPYFYHNI
      ZFZUUSUVQRXKYBUVFYDOXKYCUVFYEOXKUWAUVFXKUVTUVEUUPXKYFYIYHXLNYTUUGVAVPVQAX
      NXOUUPWCTUVOXCXFXIUVPGYJNIZFUVQUVSRXCXJUVFVSXDXFXIXCUVFWEXDXFXIXCUVFWFUVO
      UVPUUPYIMIZUWBXKUVPUWCRUVFXKYFYIUUPMYTSZOUVOUUPYIYKNIZFZYJVBFZUWCUWBFXKUW
      FUVFXKUWEUVEUUPXKYKXLYINUUFSVPVQXKUWGUVFXKEDUUEUUAVNOUUPYIYJWDPWGABDEUVPW
      AWBUVOUVRUUTBUVOUVRUWCDQIZUUPDYIMIZQIZUUTXKUVRUWHRUVFXKUVPUWCDQUWDWHOUVOU
      UPYIDUVFUUPWIFXKUVFUUPUUPYIXLWJWOWKXKYIWIFUVFXKDCUUBUUDWLOXKDWIFUVFUUBOWM
      XKUWJUUTRUVFXKUWICUUPQXKDCUUBUUDWNSOWPWQWPWRWSUURXCUULXIUUQUVBUVARXCXJUUQ
      VSXKUULUUQUUOOXDXFXIXCUUQWFUVJABCEUUPWAWBWTXA $.
  $}

  ${
    $d k B $.  $d k S $.  $d k T $.
    $( Recover the left half of a concatenated word.  (Contributed by Mario
       Carneiro, 27-Sep-2015.) $)
    swrdccat1 $p |- ( ( S e. Word B /\ T e. Word B ) ->
      ( ( S concat T ) substr <. 0 , ( # ` S ) >. ) = S ) $=
      ( vk wcel wa co cc0 chash cfv cfzo wceq cuz cn0 adantr syl adantl syl2anc
      lencl wfn cword cconcat cop csubstr cres cfz nn0uz syl6eleq caddc ccatlen
      ccatcl cz nn0zd uzid uzaddcl eqeltrd elfzuzb sylanbrc swrd0val wss wf ffn
      wrdf 3syl fzoss2 fnssres cv fvres ccatval1 3expa eqtrd eqfnfvd ) BAUAZEZC
      VMEZFZBCUBGZHBIJZUCUDGZVQHVRKGZUEZBVPVQVMEZVRHVQIJZUFGEZVSWALABCUKZVPVRHM
      JZEWCVRMJZEZWDVPVRNWFVNVRNEVOABSOZUGUHVPWCVRCIJZUIGZWGABCUJVPVRWGEZWJNEZW
      KWGEVPVRULEWLVPVRWIUMVRUNPVOWMVNACSQWJVRVRUORUPZVRHWCUQURAVQVRUSRVPDVTWAB
      VPVQHWCKGZTZVTWOUTZWAVTTVPWBWOAVQVAWPWEAVQVCWOAVQVBVDVPWHWQWNVRHWCVEPWOVT
      VQVFRVPVTABVAZBVTTVNWRVOABVCOVTABVBPVPDVGZVTEZFWSWAJZWSVQJZWSBJZWTXAXBLVP
      WSVTVQVHQVNVOWTXBXCLABCWSVIVJVKVLVK $.

    $( Recover the right half of a concatenated word.  (Contributed by Mario
       Carneiro, 27-Sep-2015.) $)
    swrdccat2 $p |- ( ( S e. Word B /\ T e. Word B ) ->
 ( ( S concat T ) substr <. ( # ` S ) , ( ( # ` S ) + ( # ` T ) ) >. ) = T ) $=
      ( vk wcel wa cc0 chash cfv cfzo co wfn cfz wceq cuz cn0 adantr syl oveq2d
      caddc cword cconcat cop csubstr wf ccatcl swrdcl wrdf ffn 4syl cmin lencl
      nn0uz syl6eleq cz nn0zd adantl uzaddcl syl2anc elfzuzb sylanbrc nn0addcld
      ccatlen eleqtrrd swrdlen syl3anc nn0cnd pncan2d eqtrd fneq2d mpbid eleq2d
      uzid cv biimpar swrdfv syl31anc ccatval3 3expa eqfnfvd ) BAUAZEZCWAEZFZDG
      CHIZJKZBCUBKZBHIZWHWETKZUCUDKZCWDWJGWJHIZJKZLZWJWFLWDWGWAEZWJWAEWLAWJUEWM
      ABCUFZAWGWHWIUGAWJUHWLAWJUIUJWDWLWFWJWDWKWEGJWDWKWIWHUKKZWEWDWNWHGWIMKZEZ
      WIGWGHIZMKZEZWKWPNWOWDWHGOIZEWIWHOIZEZWRWDWHPXBWBWHPEWCABULQZUMUNWDWHXCEZ
      WEPEZXDWDWHUOEXFWDWHXEUPWHVMRWCXGWBACULUQZWEWHWHURUSWHGWIUTVAZWDWIWQWTWDW
      IXBEWIWIOIEZWIWQEWDWIPXBWDWHWEXEXHVBZUMUNWDWIUOEXJWDWIXKUPWIVMRWIGWIUTVAW
      DWSWIGMABCVCSVDZAWGWHWIVEVFWDWHWEWDWHXEVGWDWEXHVGVHZVISVJVKWDWFACUEZCWFLW
      CXNWBACUHUQWFACUIRWDDVNZWFEZFZXOWJIZXOWHTKWGIZXOCIZXQWNWRXAXOGWPJKZEZXRXS
      NWDWNXPWOQWDWRXPXIQWDXAXPXLQWDYBXPWDYAWFXOWDWPWEGJXMSVLVOAWGWHWIXOVPVQWBW
      CXPXSXTNABCXOVRVSVIVT $.
  $}

  $( An ~ opth -like theorem for recovering the two halves of a concatenated
     word.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
  ccatopth $p |- ( ( ( A e. Word X /\ B e. Word X ) /\
    ( C e. Word X /\ D e. Word X ) /\ ( # ` A ) = ( # ` C ) ) ->
      ( ( A concat B ) = ( C concat D ) <-> ( A = C /\ B = D ) ) ) $=
    ( wcel wa chash cfv wceq cconcat co cc0 cop csubstr swrdccat1 caddc ccatlen
    syl 3eqtr3d cword oveq1 3ad2ant1 simp3 opeq2d oveq2d 3ad2ant2 eqtrd eqeq12d
    w3a syl5ib simpr simpl3 fveq2d simpl1 simpl2 opeq12d oveq12d swrdccat2 jcad
    ex oveq12 impbid1 ) AEUAZFBVDFGZCVDFDVDFGZAHIZCHIZJZUJZABKLZCDKLZJZACJZBDJZ
    GVJVMVNVOVMVKMVGNZOLZVLVPOLZJVJVNVKVLVPOUBVJVQAVRCVEVFVQAJVIEABPUCVJVRVLMVH
    NZOLZCVJVPVSVLOVJVGVHMVEVFVIUDUEUFVFVEVTCJVIECDPUGUHUIUKVJVMVOVJVMGZVKVGVGB
    HIQLZNZOLZVLVHVHDHIQLZNZOLZBDWAVKVLWCWFOVJVMULZWAVGVHWBWEVEVFVIVMUMWAVKHIZV
    LHIZWBWEWAVKVLHWHUNWAVEWIWBJVEVFVIVMUOZEABRSWAVFWJWEJVEVFVIVMUPZECDRSTUQURW
    AVEWDBJWKEABUSSWAVFWGDJWLECDUSSTVAUTACBDKVBVC $.

  $( An ~ opth -like theorem for recovering the two halves of a concatenated
     word.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
  ccatopth2 $p |- ( ( ( A e. Word X /\ B e. Word X ) /\
    ( C e. Word X /\ D e. Word X ) /\ ( # ` B ) = ( # ` D ) ) ->
      ( ( A concat B ) = ( C concat D ) <-> ( A = C /\ B = D ) ) ) $=
    ( wcel wa chash cfv wceq w3a cconcat co caddc ccatlen cn0 lencl syl nn0cnd
    wi cword fveq2 3ad2ant1 simp3 oveq2d eqtrd 3ad2ant2 eqeq12d simp1l addcan2d
    simp2l simp2r bitrd syl5ib ccatopth biimpd 3expia com23 3adant3 mpdd oveq12
    impbid1 ) AEUAZFZBVCFZGZCVCFZDVCFZGZBHIZDHIZJZKZABLMZCDLMZJZACJBDJGZVMVPAHI
    ZCHIZJZVQVPVNHIZVOHIZJZVMVTVNVOHUBVMWCVRVKNMZVSVKNMZJVTVMWAWDWBWEVMWAVRVJNM
    ZWDVFVIWAWFJVLEABOUCVMVJVKVRNVFVIVLUDUEUFVIVFWBWEJVLECDOUGUHVMVRVSVKVMVRVMV
    DVRPFVDVEVIVLUIEAQRSVMVSVMVGVSPFVFVGVHVLUKECQRSVMVKVMVHVKPFVFVGVHVLULEDQRSU
    JUMUNVFVIVPVTVQTTVLVFVIGVTVPVQVFVIVTVPVQTVFVIVTKVPVQABCDEUOUPUQURUSUTACBDLV
    AVB $.

  $( Concatenation of words is left-cancellative.  (Contributed by Mario
     Carneiro, 2-Oct-2015.) $)
  ccatlcan $p |- ( ( A e. Word X /\ B e. Word X /\
    C e. Word X ) -> ( ( C concat A ) = ( C concat B ) <-> A = B ) ) $=
    ( cword wcel w3a cconcat co wceq wa wb chash cfv eqid ccatopth mp3an3 3coml
    3impdi biantrur syl6bbr ) ADEZFZBUBFZCUBFZGCAHICBHIJZCCJZABJZKZUHUEUCUDUFUI
    LZUEUCUDUJUEUCKUEUDKCMNZUKJUJUKOCACBDPQSRUGUHCOTUA $.

  $( Concatenation of words is right-cancellative.  (Contributed by Mario
     Carneiro, 2-Oct-2015.) $)
  ccatrcan $p |- ( ( A e. Word X /\ B e. Word X /\
    C e. Word X ) -> ( ( A concat C ) = ( B concat C ) <-> A = B ) ) $=
    ( cword wcel w3a cconcat co wceq wa chash cfv eqid ccatopth2 mp3an3 3impdir
    wb biantru syl6bbr ) ADEZFZBUAFZCUAFZGACHIBCHIJZABJZCCJZKZUFUBUDUCUEUHRZUBU
    DKUCUDKCLMZUJJUIUJNACBCDOPQUGUFCNST $.

  ${
    $d b s F $.  $d b s R $.  $d b s S $.  $d b s T $.  $d b s V $.
    $d b s W $.  $d b s X $.  $d b s Y $.
    $( Value of the substring replacement operator.  (Contributed by Stefan
       O'Rear, 15-Aug-2015.) $)
    splval $p |- ( ( S e. V /\ ( F e. W /\ T e. X /\ R e. Y ) ) ->
        ( S splice <. F , T , R >. ) = ( ( ( S substr <. 0 , F >. ) concat R )
          concat ( S substr <. T , ( # ` S ) >. ) ) ) $=
      ( vs vb wcel cvv c1st cfv csubstr co c2nd cconcat wceq adantl w3a wa cotp
      cv cc0 chash csplice cmpt2 df-splice simprl fveq2 fveq2d ot1stg sylan9eqr
      cop a1i opeq2d oveq12d ot3rdg 3ad2ant3 ot2ndg opeq12d elex adantr ovmpt2d
      otex ovex ) BEKZDFKZCGKZAHKZUAZUBZIJBDCAUCZLLIUDZUEJUDZMNZMNZUOZOPZVPQNZR
      PZVOVQQNZVOUFNZUOZOPZRPZBUEDUOZOPZARPZBCBUFNZUOZOPZRPZUGLUGIJLLWGUHSVMIJU
      IUPVMVOBSZVPVNSZUBZUBZWBWJWFWMRWRVTWIWAARWRVOBVSWHOVMWOWPUJZWRVRDUEWQVMVR
      VNMNZMNZDWPVRXASWOWPVQWTMVPVNMUKZULTVLXADSVHDCAFGHUMTUNUQURWQVMWAVNQNZAWP
      WAXCSWOVPVNQUKTVLXCASZVHVKVIXDVJDCAHUSUTTUNURWRVOBWEWLOWSWRWCCWDWKWQVMWCW
      TQNZCWPWCXESWOWPVQWTQXBULTVLXECSVHDCAFGHVATUNWRVOBUFWSULVBURURVHBLKVLBEVC
      VDVNLKVMDCAVFUPWNLKVMWJWMRVGUPVE $.

    $( Closure of the substring replacement operator.  (Contributed by Stefan
       O'Rear, 26-Aug-2015.) $)
    splcl $p |- ( ( S e. Word A /\ R e. Word A ) ->
        ( S splice <. F , T , R >. ) e. Word A ) $=
      ( vs vb wcel cc0 c1st cfv cop csubstr c2nd cconcat chash wceq cvv fveq2d
      co cword wa cotp csplice elex otex cv id fveq2 opeq2d simpr oveq12d simpl
      oveqan12d opeq12d ovex ovmpt2a sylancl adantr swrdcl ot3rdg adantl ccatcl
      df-splice eqeltrd syl2anc ) CAUAZHZBVGHZUBZCEDBUCZUDTZCIVKJKZJKZLZMTZVKNK
      ZOTZCVMNKZCPKZLZMTZOTZVGVHVLWCQZVIVHCRHVKRHWDCVGUEEDBUFFGCVKRRFUGZIGUGZJK
      ZJKZLZMTZWFNKZOTZWEWGNKZWEPKZLZMTZOTWCUDWECQZWFVKQZUBZWLVRWPWBOWSWJVPWKVQ
      OWQWRWECWIVOMWQUHWRWHVNIWRWGVMJWFVKJUISUJUNWSWFVKNWQWRUKZSULWSWECWOWAMWQW
      RUMZWSWMVSWNVTWSWGVMNWSWFVKJWTSSWSWECPXASUOULULFGVDVRWBOUPUQURUSVJVRVGHZW
      BVGHZWCVGHVJVPVGHZVQVGHXBVHXDVIACIVNUTUSVJVQBVGVIVQBQVHEDBVGVAVBVHVIUKVEA
      VPVQVCVFVHXCVIACVSVTUTUSAVRWBVCVFVE $.

    $( Splicing a subword for the same subword makes no difference.
       (Contributed by Stefan O'Rear, 20-Aug-2015.) $)
    splid $p |- ( ( S e. Word A /\ ( X e. ( 0 ... Y ) /\
        Y e. ( 0 ... ( # ` S ) ) ) ) ->
      ( S splice <. X , Y , ( S substr <. X , Y >. ) >. ) = S ) $=
      ( wcel cc0 cfz co cfv wa cop csubstr cconcat wceq elfzuz eluzfz1 ccatswrd
      cvv syl eqtrd cword chash cotp csplice ovex splval mp3anr3 simpl ad2antrl
      cuz simprl simprr syl13anc oveq1d ad2antll elfzuz2 eluzfz2 swrdid adantr
      ) BAUAZEZCFDGHZEZDFBUBIZGHZEZJZJZBCDBCDKZLHZUCUDHZBFCKLHVJMHZBDVDKLHZMHZB
      VAVCVFVJREVKVNNBVILUEVJBDCUTVBVERUFUGVHVNBFDKLHZVMMHZBVHVLVOVMMVHVAFFCGHE
      ZVCVFVLVONVAVGUHZVHCFUJIZEZVQVCVTVAVFCFDOUIFCPSVAVCVFUKVAVCVFULZABFCDQUMU
      NVHVPBFVDKLHZBVHVAFVBEZVFVDVEEZVPWBNVRVHDVSEZWCVFWEVAVCDFVDOUOFDPSWAVHVDV
      SEZWDVFWFVAVCDFVDUPUOFVDUQSABFDVDQUMVAWBBNVGABURUSTTT $.
  $}

  ${
    spllen.s $e |- ( ph -> S e. Word A ) $.
    spllen.f $e |- ( ph -> F e. ( 0 ... T ) ) $.
    spllen.t $e |- ( ph -> T e. ( 0 ... ( # ` S ) ) ) $.
    spllen.r $e |- ( ph -> R e. Word A ) $.
    $( The length of a splice.  (Contributed by Stefan O'Rear, 23-Aug-2015.) $)
    spllen $p |- ( ph -> ( # ` ( S splice <. F , T , R >. ) ) =
          ( ( # ` S ) + ( ( # ` R ) - ( T - F ) ) ) ) $=
      ( co chash cfv cc0 caddc cmin wcel wceq syl syl2anc csplice csubstr cword
      cop cconcat cfz splval syl13anc fveq2d swrdcl ccatcl ccatlen lencl nn0cnd
      cotp cn0 elfzelz zcnd addcld elfzel2 addsub12d cuz elfzuz eluzfz1 elfzuz3
      cz elfzuzb sylanbrc swrdlen syl3anc subid1d oveq1d addcomd 3eqtrd elfzuz2
      uztrn eqtrd eluzfz2 oveq12d subsub3d oveq2d 3eqtr4d ) ADFECUOUAKZLMDNFUDU
      BKZCUEKZDEDLMZUDUBKZUEKZLMZWELMZWGLMZOKZWFCLMZEFPKPKZOKZAWCWHLADBUCZQZFNE
      UFKZQZENWFUFKZQZCWPQZWCWHRGHIJCDEFWPWRWTWPUGUHUIAWEWPQZWGWPQZWIWLRAWDWPQZ
      XBXCAWQXEGBDNFUJSZJBWDCUKTAWQXDGBDEWFUJSBWEWGULTAWMFOKZWFEPKZOKWFXGEPKZOK
      WLWOAXGWFEAWMFAWMAXBWMUPQJBCUMSUNZAFAWSFVFQHFNEUQSURZUSAWFAXAWFVFQIENWFUT
      SURAEAXAEVFQIENWFUQSURZVAAWJXGWKXHOAWJWDLMZWMOKZFWMOKXGAXEXBWJXNRXFJBWDCU
      LTAXMFWMOAXMFNPKZFAWQNNFUFKQZFWTQZXMXORGAFNVBMZQZXPAWSXSHFNEVCSZNFVDSAXSW
      FFVBMZQZXQXTAWFEVBMQZEYAQZYBAXAYCIENWFVESAWSYDHFNEVESEWFFVPTFNWFVGVHBDNFV
      IVJAFXKVKVQVLAFWMXKXJVMVNAWQXAWFWTQZWKXHRGIAWFXRQZYEAXAYFIENWFVOSNWFVRSBD
      EWFVIVJVSAWNXIWFOAWMEFXJXLXKVTWAWBVN $.

    ${
      splfv1.x $e |- ( ph -> X e. ( 0 ..^ F ) ) $.
      $( Symbols to the left of a splice are unaffected.  (Contributed by
         Stefan O'Rear, 23-Aug-2015.) $)
      splfv1 $p |- ( ph -> ( ( S splice <. F , T , R >. ) ` X ) =
            ( S ` X ) ) $=
        ( co cfv cc0 chash wcel wceq cfzo syl csplice cop csubstr cconcat cword
        cotp cfz splval syl13anc fveq1d swrdcl ccatcl syl2anc caddc cuz wss cn0
        cz elfzelz uzid 3syl wrdfin hashcl uzaddcl fzoss2 sseldd ccatlen elfzuz
        cfn cmin eluzfz1 wa fzass4 bicomi simplbi swrdlen syl3anc subid1d eqtrd
        zcnd oveq1d oveq2d eleqtrrd ccatval1 swrdfv syl31anc cc elfzoelz fveq2d
        addid1d 3eqtrd ) AGDFECUFUAMZNGDOFUBUCMZCUDMZDEDPNZUBUCMZUDMZNZGWNNZGDN
        ZAGWLWQADBUEZQZFOEUGMZQZEOWOUGMZQZCXAQZWLWQRHIJKCDEFXAXCXEXAUHUIUJAWNXA
        QZWPXAQZGOWNPNZSMZQWRWSRAWMXAQZXGXHAXBXLHBDOFUKTZKBWMCULUMAXBXIHBDEWOUK
        TAGOFCPNZUNMZSMZXKAOFSMZXPGAXOFUONZQZXQXPUPAFXRQZXNUQQZXSAXDFURQZXTIFOE
        USZFUTVAAXGCVIQYAKBCVBCVCVAXNFFVDUMFOXOVETLVFAXJXOOSAXJWMPNZXNUNMZXOAXL
        XGXJYERXMKBWMCVGUMAYDFXNUNAYDFOVJMZFAXBOOFUGMQZFXEQZYDYFRHAXDFOUONQYGIF
        OEVHOFVKVAZAXDXFYHIJXDXFVLZYHEFWOUGMQZYHYKVLYJOFEWOVMVNVOUMZBDOFVPVQAFA
        FAXDYBIYCTVTVRZVSZWAVSWBWCBWNWPGWDVQAWSGWMNZGOUNMZDNZWTAXLXGGOYDSMZQWSY
        ORXMKAGXQYRLAYDFOSYNWBWCBWMCGWDVQAXBYGYHGOYFSMZQYOYQRHYIYLAGXQYSLAYFFOS
        YMWBWCBDOFGWEWFAYPGDAGAGXQQZGWGQLYTGGOFWHVTTWJWIWKWK $.
    $}

    ${
      splfv2a.x $e |- ( ph -> X e. ( 0 ..^ ( # ` R ) ) ) $.
      $( Symbols within the replacement region of a splice, expressed using the
         coordinates of the replacement region.  (Contributed by Stefan O'Rear,
         23-Aug-2015.) $)
      splfv2a $p |- ( ph -> ( ( S splice <. F , T , R >. ) ` ( F + X ) ) =
            ( R ` X ) ) $=
        ( caddc co cfv cc0 wcel wceq cn0 syl cotp csplice csubstr chash cconcat
        cop cword cfz splval syl13anc elfznn0 nn0cnd cfzo elfzoelz zcnd addcomd
        cz cmin nn0uz syl6eleq eluzfz1 elfzuz3 syl2anc elfzuzb sylanbrc swrdlen
        cuz uztrn syl3anc subid1d eqtrd oveq2d eqtr4d fveq12d swrdcl ccatcl wss
        0nn0 nn0addcl sylancr fzoss1 eleq2s ccatlen oveq1d wrdfin hashcl 3eqtrd
        cfn sseqtr4d nn0zd fzoaddel sseldd eqeltrd ccatval1 ccatval3 ) AFGMNZDF
        ECUAUBNZOGDPFUFUCNZUDOZMNZWRCUENZDEDUDOZUFUCNZUENZOZWTXAOZGCOZAWPWTWQXD
        ADBUGZQZFPEUHNZQZEPXBUHNZQZCXHQZWQXDRHIJKCDEFXHXJXLXHUIUJAWPGFMNZWTAFGA
        FAXKFSQZIFEUKTZULZAGAGPCUDOZUMNQZGUQQLGPXSUNTUOUPAWSFGMAWSFPURNZFAXIPPF
        UHNQZFXLQZWSYARHAFPVGOZQZYBAFSYDXQUSUTZPFVATAYEXBFVGOZQZYCYFAXBEVGOQZEY
        GQZYHAXMYIJEPXBVBTAXKYJIFPEVBTEXBFVHVCFPXBVDVEBDPFVFVIAFXRVJVKZVLZVMVNA
        XAXHQZXCXHQZWTPXAUDOZUMNZQXEXFRAWRXHQZXNYMAXIYQHBDPFVOTZKBWRCVPVCAXIYNH
        BDEXBVOTAWTXOYPYLAPFMNZXSFMNZUMNZYPXOAUUAPYTUMNZYPAYSSQZUUAUUBVQZAPSQXP
        UUCVRXQPFVSVTUUDYSYDSYSPYTWAUSWBTAYOYTPUMAYOWSXSMNZFXSMNYTAYQXNYOUUERYR
        KBWRCWCVCAWSFXSMYKWDAFXSXRAXSACWHQZXSSQAXNUUFKBCWETCWFTULUPWGVLWIAXTFUQ
        QXOUUAQLAFXQWJGPXSFWKVCWLWMBXAXCWTWNVIAYQXNXTXFXGRYRKLBWRCGWOVIWG $.
    $}
  $}

  ${
    splval2.a $e |- ( ph -> A e. Word X ) $.
    splval2.b $e |- ( ph -> B e. Word X ) $.
    splval2.c $e |- ( ph -> C e. Word X ) $.
    splval2.r $e |- ( ph -> R e. Word X ) $.
    splval2.s $e |- ( ph -> S = ( ( A concat B ) concat C ) ) $.
    splval2.f $e |- ( ph -> F = ( # ` A ) ) $.
    splval2.t $e |- ( ph -> T = ( F + ( # ` B ) ) ) $.
    $( Value of a splice, assuming the input word ` S ` has already been
       decomposed into its pieces.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    splval2 $p |- ( ph ->
      ( S splice <. F , T , R >. ) = ( ( A concat R ) concat C ) ) $=
      ( co cc0 wcel wceq csplice cop csubstr cconcat chash cfv cword cn0 ccatcl
      cotp syl2anc eqeltrd lencl syl caddc nn0addcld splval syl13anc wa cfz cuz
      nn0uz syl6eleq eluzfz1 nn0zd uzid uzaddcl elfzuzb sylanbrc ccatlen fveq2d
      cz oveq1d 3eqtr4d ccatswrd eluzfz2 swrdid 3eqtrd wb swrdcl swrd0len eqtrd
      ccatopth syl221anc mpbid simpld uztrn simprd oveq12d ) AFHGEUJUAQZFRHUBUC
      QZEUDQZFGFUEUFZUBUCQZUDQZBEUDQZDUDQAFIUGZSZHUHSGUHSEWQSWJWOTAFBCUDQZDUDQZ
      WQNAWSWQSZDWQSZWTWQSABWQSZCWQSZXAJKIBCUIUKZLIWSDUIUKULZAHBUEUFZUHOAXCXGUH
      SJIBUMUNULZAGHCUEUFZUOQZUHPAHXIXHAXDXIUHSZKICUMUNZUPULZMEFGHWQUHUHWQUQURA
      WLWPWNDUDAWKBEUDAWKBTZFHGUBUCQZCTZAWKXOUDQZWSTZXNXPUSZAXQFRGUBUCQZWSAWRRR
      HUTQSZHRGUTQZSZGRWMUTQZSZXQXTTXFAHRVAUFZSZYAAHUHYFXHVBVCZRHVDUNAYGGHVAUFZ
      SZYCYHAGXJYIPAHYISZXKXJYISAHVLSYKAHXHVEHVFUNXLXIHHVGUKULZHRGVHVIAGYFSZWMG
      VAUFZSZYEAGUHYFXMVBVCZAWMGDUEUFZUOQZYNAWTUEUFZWSUEUFZYQUOQZWMYRAXAXBYSUUA
      TXELIWSDVJUKAFWTUENVKAGYTYQUOAXJXGXIUOQZGYTAHXGXIUOOVMPAXCXDYTUUBTJKIBCVJ
      UKVNZVMVNAGYNSZYQUHSZYRYNSAGVLSUUDAGXMVEGVFUNAXBUUELIDUMUNYQGGVGUKULZGRWM
      VHVIZIFRHGVOURAXTWSTZWNDTZAXTWNUDQZWTTZUUHUUIUSZAUUJFRWMUBUCQZFWTAWRRYBSZ
      YEWMYDSZUUJUUMTXFAYMUUNYPRGVDUNUUGAWMYFSUUOAWMUHYFAWRWMUHSXFIFUMUNVBVCRWM
      VPUNIFRGWMVOURAWRUUMFTXFIFVQUNNVRAXTWQSZWNWQSZXAXBXTUEUFZYTTUUKUULVSAWRUU
      PXFIFRGVTUNAWRUUQXFIFGWMVTUNXELAUURGYTAWRYEUURGTXFUUGIFGWAUKUUCWBXTWNWSDI
      WCWDWEZWFWBAWKWQSZXOWQSZXCXDWKUEUFZXGTXRXSVSAWRUUTXFIFRHVTUNAWRUVAXFIFHGV
      TUNJKAUVBHXGAWRHYDSZUVBHTXFAYGWMYISZUVCYHAYOYJUVDUUFYLGWMHWGUKHRWMVHVIIFH
      WAUKOWBWKXOBCIWCWDWEWFVMAUUHUUIUUSWHWIWB $.
  $}

  $( Extract a single symbol from a word.  (Contributed by Stefan O'Rear,
     23-Aug-2015.) $)
  swrds1 $p |- ( ( W e. Word A /\ I e. ( 0 ..^ ( # ` W ) ) ) ->
      ( W substr <. I , ( I + 1 ) >. ) = <" ( W ` I ) "> ) $=
    ( cword wcel cc0 chash cfv cfzo co c1 caddc cs1 wceq cfz adantl cz cc eqtrd
    cuz wa csubstr swrdcl adantr cmin simpl elfzouz elfzoelz uzid peano2uz 3syl
    elfzuzb sylanbrc fzofzp1 swrdlen syl3anc zcnd ax-1cn pncan2 sylancl syl2anc
    cop csn 0z snidg ax-mp oveq2d fzo01 syl6eq syl5eleqr swrdfv syl31anc addid2
    eqs1 eqcomd syl fveq2d eqtr4d s1eqd ) CADZEZBFCGHZIJEZUAZCBBKLJZVBUBJZFWFHZ
    MZBCHZMWDWFVTEZWFGHZKNWFWHNWAWJWCACBWEUCUDWDWKWEBUEJZKWDWABFWEOJEZWEFWBOJEZ
    WKWLNWAWCUFZWDBFTHEZWEBTHZEZWMWCWPWABFWBUGPWDBQEZBWQEWRWCWSWABFWBUHPZBUIBBU
    JUKBFWEULUMZWCWNWAFWBBUNPZACBWEUOUPWDBREZKREWLKNWDBWTUQZURBKUSUTZSAWFVNVAWD
    WGWIWDWGFBLJZCHZWIWDWAWMWNFFWLIJZEWGXGNWOXAXBWDFFVCZXHFQEFXIEVDFQVEVFWDXHFK
    IJXIWDWLKFIXEVGVHVIVJACBWEFVKVLWDBXFCWDXCBXFNXDXCXFBBVMVOVPVQVRVSS $.

  $( Decompose a non-empty word by separating off the last symbol.
     (Contributed by Stefan O'Rear, 25-Aug-2015.)  (Revised by Mario Carneiro,
     1-Oct-2015.) $)
  wrdeqcats1 $p |- ( ( W e. Word A /\ W =/= (/) ) -> W =
        ( ( W substr <. 0 , ( ( # ` W ) - 1 ) >. ) concat
          <" ( W ` ( ( # ` W ) - 1 ) ) "> ) ) $=
    ( cword wcel c0 cc0 cfv c1 co cop csubstr cconcat cfz wceq cn0 nn0uz eleq2s
    3syl cc oveq2d wne wa chash cmin caddc cs1 simpl cn lennncl nnm1nn0 eluzfz1
    cuz cfzo fzossfz fzo0end sseldi nncnd ax-1cn npcan sylancl eleqtrrd eluzfz2
    syl nnnn0 eqeltrd ccatswrd opeq2d swrdid adantr 3eqtrd swrds1 syldan eqtr3d
    syl13anc ) BACDZBEUAZUBZBFBUCGZHUDIZJKIZBVSVSHUEIZJKIZLIZBVTVSBGUFZLIVQWCBF
    WAJZKIZBFVRJZKIZBVQVOFFVSMIDZVSFWAMIZDWAFVRMIZDWCWFNVOVPUGVQVRUHDZVSODWIABU
    IZVRUJWIVSFULGZOFVSUKPQRVQVSWKWJVQFVRUMIZWKVSFVRUNVQWLVSWODZWMVRUOVCZUPVQWA
    VRFMVQVRSDHSDWAVRNVQVRWMUQURVRHUSUTZTVAVQWAVRWKWRVQWLVRODVRWKDZWMVRVDWSVRWN
    OFVRVBPQRVEABFVSWAVFVNVQWEWGBKVQWAVRFWRVGTVOWHBNVPABVHVIVJVQWBWDVTLVOVPWPWB
    WDNWQAVSBVKVLTVM $.

  $( Decompose a non-empty word by separating off the first symbol.
     (Contributed by Stefan O'Rear, 25-Aug-2015.)  (Revised by Mario Carneiro,
     1-Oct-2015.) $)
  wrdeqs1cat $p |- ( ( W e. Word A /\ W =/= (/) ) -> W =
      ( <" ( W ` 0 ) "> concat ( W substr <. 1 , ( # ` W ) >. ) ) ) $=
    ( cword wcel cc0 c1 cop csubstr co cfv cconcat cfz wceq cn0 1nn0 eleq2s wbr
    nn0uz a1i syl3anbrc c0 wne wa chash cs1 cuz eluzfz1 mp1i cle lennncl nnnn0d
    simpl hashge1 elfz2nn0 syl ccatswrd syl13anc caddc 0p1e1 opeq2i oveq2i cfzo
    eluzfz2 cn 0nn0 hashgt0 elfzo0 swrds1 syldan syl5eqr oveq1d swrdid 3eqtr3rd
    clt adantr ) BACZDZBUAUBZUCZBEFGZHIZBFBUDJZGHIZKIZBEWBGHIZEBJUEZWCKIBVSVQEE
    FLIDZFEWBLIZDZWBWHDZWDWEMVQVRULFNDZWGVSOWGFEUFJZNEFUGRPUHVSWKWBNDZFWBUIQWIW
    KVSOSVSWBABUJZUKZBVPUMFWBUNTVSWMWJWOWJWBWLNEWBVCRPUOABEFWBUPUQVSWAWFWCKVSWA
    BEEFURIZGZHIZWFWQVTBHWPFEUSUTVAVQVREEWBVBIDZWRWFMVSENDZWBVDDEWBVNQWSWTVSVES
    WNBVPVFEWBVGTAEBVHVIVJVKVQWEBMVRABVLVOVM $.

  ${
    $d x A $.  $d x B $.  $d x X $.
    $( Express a word with an extra symbol as the union of the word and the new
       value.  (Contributed by Mario Carneiro, 28-Feb-2016.) $)
    cats1un $p |- ( ( A e. Word X /\ B e. X ) ->
      ( A concat <" B "> ) = ( A u. { <. ( # ` A ) , B >. } ) ) $=
      ( wcel wa cc0 chash cfv cfzo co csn cun wf syl c1 caddc wceq cn0 a1i cvv
      vx cword cs1 cconcat cop wfn s1cl ccatcl sylan2 wrdf ccatlen s1len oveq2i
      syl6eq oveq2d cuz lencl adantr nn0uz fzosplitsn eqtrd feq2d mpbid ffn cin
      syl6eleq c0 eqid fsng mpbiri sylan wn fzonel disjsn sylibr syl21anc cv wo
      fun elun ccatval1 syl3an2 3expa simpr nelne2 sylancl necomd fvunsn eqtr4d
      wne cdm fvex elex adantl fdm eleq2d mtbiri fsnunfv syl3anc cn 1nn eqeltri
      simpl lbfzo0 ccatval3 s1fv nn0cnd addid2d fveq2d elsni eqeq12d syl5ibrcom
      3eqtr2rd imp jaodan sylan2b eqfnfvd ) ACUBZDZBCDZEZUAFAGHZIJZYBKZLZABUCZU
      DJZAYBBUEKZLZYAYECYGMZYGYEUFYAFYGGHZIJZCYGMZYJYAYGXRDZYMXTXSYFXRDZYNBCUGZ
      CAYFUHUICYGUJNYAYLYECYGYAYLFYBOPJZIJZYEYAYKYQFIYAYKYBYFGHZPJZYQXTXSYOYKYT
      QYPCAYFUKUIYSOYBPBULZUMUNUOYAYBFUPHZDYRYEQYAYBRUUBXSYBRDZXTCAUQZURZUSVFFY
      BUTNVAVBVCYECYGVDNYAYECBKZLZYIMZYIYEUFYAYCCAMZYDUUFYHMZYCYDVEVGQZUUHXSUUI
      XTCAUJURZXSUUCXTUUJUUDUUCXTEUUJYHYHQYHVHYBBRCYHVIVJVKYAYBYCDZVLZUUKUUNYAF
      YBVMZSYCYBVNVOYCYDCUUFAYHVSVPYEUUGYIVDNUAVQZYEDYAUUPYCDZUUPYDDZVRUUPYGHZU
      UPYIHZQZUUPYCYDVTYAUUQUVAUURYAUUQEZUUSUUPAHZUUTXSXTUUQUUSUVCQZXTXSYOUUQUV
      DYPCAYFUUPWAWBWCUVBYBUUPWJUUTUVCQUVBUUPYBUVBUUQUUNUUPYBWJYAUUQWDUUOUUPYBY
      CWEWFWGAYBBUUPWHNWIYAUURUVAYAUVAUURYBYGHZYBYIHZQYAUVFBFYBPJZYGHZUVEYAYBTD
      ZBTDZYBAWKZDZVLUVFBQUVIYAAGWLSXTUVJXSBCWMWNYAUVLUUMUUOYAUVKYCYBYAUUIUVKYC
      QUULYCCAWONWPWQATTYBBWRWSYAUVHFYFHZBYAXSYOFFYSIJDZUVHUVMQXSXTXCXTYOXSYPWN
      YAYSWTDZUVNUVOYAYSOWTUUAXAXBSYSXDVOCAYFFXEWSXTUVMBQXSBCXFWNVAYAUVGYBYGYAY
      BYAYBUUEXGXHXIXMUURUUSUVEUUTUVFUURUUPYBYGUUPYBXJZXIUURUUPYBYIUVPXIXKXLXNX
      OXPXQ $.
  $}

  ${
    $d n x A $.  $d m n x y z B $.  $d x ch $.  $d m n y z ph $.  $d x ta $.
    $d x th $.
    wrdind.1 $e |- ( x = (/) -> ( ph <-> ps ) ) $.
    wrdind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    wrdind.3 $e |- ( x = ( y concat <" z "> ) -> ( ph <-> th ) ) $.
    wrdind.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    wrdind.5 $e |- ps $.
    wrdind.6 $e |- ( ( y e. Word B /\ z e. B ) -> ( ch -> th ) ) $.
    $( Perform induction over the structure of a word.  (Contributed by Mario
       Carneiro, 27-Sep-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
    wrdind $p |- ( A e. Word B -> ta ) $=
      ( wcel wceq wi co vn vm cword cv chash cfv wral cn0 lencl cc0 caddc eqeq2
      c1 imbi1d ralbidv weq c0 hasheq0 mpbiri syl6bi rgen fveq2 imbi12d cbvralv
      eqeq1d wa cmin cop csubstr cs1 cconcat wsbc swrdcl ad2antrl simplr simprl
      cfz fzossfz cn simprr nn0p1nn ad2antrr eqeltrd fzo0end syl sseldi syl2anc
      cfzo swrd0len oveq1d nn0cn ax-1cn pncan sylancl 3eqtrd vex dfsbcq syl5bbr
      cc sbcie rspcv syl3c wf wrdf ffvelrnd wb oveq1 s1eq oveq2d imbi2d 3imtr4g
      ovex vtocl2ga mpd wne cfn wrdfin hashnncl mpbid wrdeqcats1 sbceq1a mpbird
      expr ralrimiva ex syl5bi nn0ind eqidd mp2d ) IJUCZQZFUDZUEUFZIUEUFZRZASZF
      YJUGZYNYNRZEYKYNUHQYQJIUIYMUAUDZRZASZFYJUGYMUJRZASZFYJUGYMUBUDZRZASZFYJUG
      ZYMUUDUMUKTZRZASZFYJUGZYQUAUBYNYSUJRZUUAUUCFYJUULYTUUBAYSUJYMULUNUOUAUBUP
      ZUUAUUFFYJUUMYTUUEAYSUUDYMULUNUOYSUUHRZUUAUUJFYJUUNYTUUIAYSUUHYMULUNUOYSY
      NRZUUAYPFYJUUOYTYOAYSYNYMULUNUOUUCFYJYLYJQZUUBYLUQRZAYLYJURUUQABOKUSUTVAU
      UGGUDZUEUFZUUDRZCSZGYJUGZUUDUHQZUUKUUFUVAFGYJFGUPZUUEUUTACUVDYMUUSUUDYLUU
      RUEVBVELVCVDUVCUVBUUKUVCUVBVFZUUJFYJUVEUUPUUIAUVEUUPUUIVFZVFZAAFYLUJYMUMV
      GTZVHVITZUVHYLUFZVJZVKTZVLZUVGAFUVIVLZUVMUVGUVIYJQZUVBUVIUEUFZUUDRZUVNUUP
      UVOUVEUUIJYLUJUVHVMVNZUVCUVBUVFVOUVGUVPUVHUUHUMVGTZUUDUVGUUPUVHUJYMVQTZQU
      VPUVHRUVEUUPUUIVPZUVGUJYMWHTZUVTUVHUJYMVRUVGYMVSQZUVHUWBQUVGYMUUHVSUVEUUP
      UUIVTZUVCUUHVSQUVBUVFUUDWAWBWCZYMWDWEZWFJYLUVHWIWGUVGYMUUHUMVGUWDWJUVGUUD
      WSQZUMWSQUVSUUDRUVCUWGUVBUVFUUDWKWBWLUUDUMWMWNWOUVAUVQUVNSGUVIYJUURUVIRZU
      UTUVQCUVNUWHUUSUVPUUDUURUVIUEVBVECAFUURVLZUWHUVNACFUURGWPLWTZAFUURUVIWQZW
      RVCXAXBUVGUVOUVJJQUVNUVMSZUVRUVGUWBJUVHYLUUPUWBJYLXCUVEUUIJYLXDVNUWFXEUWI
      AFUURHUDZVJZVKTZVLZSUVNAFUVIUWNVKTZVLZSUWLGHUVIUVJYJJUWHUWIUVNUWPUWRUWKUW
      HUWOUWQRUWPUWRXFUURUVIUWNVKXGAFUWOUWQWQWEVCUWMUVJRZUWRUVMUVNUWSUWQUVLRUWR
      UVMXFUWSUWNUVKUVIVKUWMUVJXHXIAFUWQUVLWQWEXJUURYJQUWMJQVFCDUWIUWPPUWJADFUW
      OUURUWNVKXLMWTXKXMWGXNUVGYLUVLRZAUVMXFUVGUUPYLUQXOZUWTUWAUVGUWCUXAUWEUVGY
      LXPQZUWCUXAXFUUPUXBUVEUUIJYLXQVNYLXRWEXSJYLXTWGAFUVLYAWEYBYCYDYEYFYGWEYKY
      NYHYPYRESFIYJYLIRZYOYRAEUXCYMYNYNYLIUEVBVENVCXAYI $.
  $}

  ${
    $d w x W $.  $d x A $.  $d x X $.
    $( Value of the word reversing function.  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    revval $p |- ( W e. V -> ( reverse ` W ) = ( x e. ( 0 ..^ ( # ` W ) ) |->
          ( W ` ( ( ( # ` W ) - 1 ) - x ) ) ) ) $=
      ( vw wcel cvv creverse cfv cc0 chash cfzo co c1 cmin cmpt wceq elex fveq2
      cv oveq1d oveq2d id fveq12d mpteq12dv df-reverse ovex mptex fvmpt syl ) C
      BECFECGHAICJHZKLZUJMNLZASZNLZCHZOZPCBQDCAIDSZJHZKLZURMNLZUMNLZUQHZOUPFGUQ
      CPZAUSVBUKUOVCURUJIKUQCJRZUAVCVAUNUQCVCUBVCUTULUMNVCURUJMNVDTTUCUDADUEAUK
      UOIUJKUFUGUHUI $.

    $( The reverse of a word is a word.  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    revcl $p |- ( W e. Word A -> ( reverse ` W ) e. Word A ) $=
      ( vx cword wcel creverse cfv cc0 chash cfzo co c1 cmin cmpt revval adantr
      cv wf wa syl wrdf cfz simpr wceq cn0 lencl nn0zd fzoval eleqtrd fznn0sub2
      cz eleqtrrd ffvelrnd eqid fmptd iswrdi eqeltrd ) BADZEZBFGCHBIGZJKZUTLMKZ
      CQZMKZBGZNZURCURBOUSVAAVFRVFUREUSCVAVEAVFUSVCVAEZSZVAAVDBUSVAABRVGABUAPVH
      VDHVBUBKZVAVHVCVIEVDVIEVHVCVAVIUSVGUCVHUTUKEVAVIUDVHUTUSUTUEEVGABUFPUGHUT
      UHTZUIVCVBUJTVJULUMVFUNUOAUTVFUPTUQ $.

    $( The reverse of a word has the same length as the original.  (Contributed
       by Stefan O'Rear, 26-Aug-2015.) $)
    revlen $p |- ( W e. Word A ->
        ( # ` ( reverse ` W ) ) = ( # ` W ) ) $=
      ( vx cword wcel creverse cfv chash cfzo co c1 cmin cv cmpt wf wceq adantr
      cc0 3syl syl revval fveq2d wfn wa wrdf cfz simpr cn0 cz lencl nn0z fzoval
      eleqtrd fznn0sub2 eleqtrrd ffvelrnd eqid fmptd ffn hashfn hashfzo0 3eqtrd
      ) BADZEZBFGZHGCRBHGZIJZVFKLJZCMZLJZBGZNZHGZVGHGZVFVDVEVLHCVCBUAUBVDVGAVLO
      VLVGUCVMVNPVDCVGVKAVLVDVIVGEZUDZVGAVJBVDVGABOVOABUEQVPVJRVHUFJZVGVPVIVQEV
      JVQEVPVIVGVQVDVOUGVPVFUHEZVFUIEVGVQPVDVRVOABUJZQVFUKRVFULSZUMVIVHUNTVTUOU
      PVLUQURVGAVLUSVGVLUTSVDVRVNVFPVSVFVATVB $.

    $( Reverse of a word at a point.  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    revfv $p |- ( ( W e. Word A /\ X e. ( 0 ..^ ( # ` W ) ) ) ->
        ( ( reverse ` W ) ` X ) = ( W ` ( ( ( # ` W ) - 1 ) - X ) ) ) $=
      ( vx cword wcel cc0 chash cfv cfzo co creverse c1 cmin cmpt revval fveq1d
      cv wceq oveq2 fveq2d eqid fvex fvmpt sylan9eq ) BAEZFZCGBHIZJKZFCBLIZICDU
      IUHMNKZDRZNKZBIZOZIUKCNKZBIZUGCUJUODUFBPQDCUNUQUIUOULCSUMUPBULCUKNTUAUOUB
      UPBUCUDUE $.

    $( The empty word is its own reverse.  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    rev0 $p |- ( reverse ` (/) ) = (/) $=
      ( c0 creverse cfv chash cc0 wceq cword wcel wrd0 revlen ax-mp hash0 eqtri
      cvv wb fvex hasheq0 mpbi ) ABCZDCZEFZSAFZTADCZEANGHTUCFNINAJKLMSNHUAUBOAB
      PSNQKR $.

    $d x V $.  $d x S $.  $d x T $.
    $( Singleton words are their own reverses.  (Contributed by Stefan O'Rear,
       26-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
    revs1 $p |- ( reverse ` <" S "> ) = <" S "> $=
      ( cc0 cs1 creverse cfv cid wceq chash c1 cmin co cword wcel cfzo cn mp2an
      cvv oveq1i eqtri ax-mp s1cli s1len 1nn eqeltri lbfzo0 mpbir subidi fveq2i
      revfv 1m1e0 0cn ids1 fveq1i fvex s1fv s1eq revcl revlen eqs1 3eqtr4i ) BA
      CZDEZEZCZAFEZCZVBVAVCVEGVDVFGVCVAHEZIJKZBJKZVAEZVEVAQLZMZBBVGNKMZVCVJGAUA
      ZVMVGOMVGIOAUBZUCUDVGUEUFQVABUIPVJBVAEZVEVIBVAVIBBJKBVHBBJVHIIJKBVGIIJVOR
      UJSRBUKUGSUHVPBVFEZVEBVAVFAULZUMVEQMVQVEGAFUNVEQUOTSSSVCVEUPTVBVKMZVBHEZI
      GVBVDGVLVSVNQVAUQTVTVGIVLVTVGGVNQVAURTVOSQVBUSPVRUT $.

    $( Antiautomorphic property of the reversal operation.  (Contributed by
       Stefan O'Rear, 27-Aug-2015.) $)
    revccat $p |- ( ( S e. Word A /\ T e. Word A ) ->
        ( reverse ` ( S concat T ) ) =
          ( ( reverse ` T ) concat ( reverse ` S ) ) ) $=
      ( wcel cc0 chash cfv caddc co cfzo wceq syl cc eqtrd oveq2d syl2anr cz c1
      cmin adantr vx cword wa cconcat creverse wfn ccatcl revcl wrdf ffn revlen
      wf 4syl ccatlen lencl nn0cnd addcom syl2an mpbid 3syl oveqan12rd cv wo id
      fneq2d nn0zd adantl fzospliti simpll simplr fzoval eleq2d biimpa eleqtrrd
      cfz ccatval3 syl3anc oveq1d ax-1cn a1i addsubd peano2zm ad2antlr ad2antrr
      fznn0sub2 zcnd elfzoelz fveq2d revfv adantll 3eqtr4d cuz wss uzid uzaddcl
      cn0 syl2anc eqeltrd fzoss2 sselda biimpar ccatval1 subsub3d eqtr4d zaddcl
      fzrev2i subidd addcl sub32d pncan2 oveq12d 3eltr4d fzosubel3 fzoss1 nn0uz
      eleq2s sseqtr4d ccatval2 jaodan syldan eqfnfvd ) BAUBZDZCYBDZUCZUAECFGZBF
      GZHIZJIZBCUDIZUEGZCUEGZBUEGZUDIZYEYKEYKFGZJIZUFZYKYIUFYEYJYBDZYKYBDYPAYKU
      LYQABCUGZAYJUHAYKUIYPAYKUJUMYEYPYIYKYEYOYHEJYEYOYJFGZYHYEYRYOYTKYSAYJUKLY
      EYTYGYFHIZYHABCUNZYCYGMDZYFMDZUUAYHKYDYCYGABUOZUPZYDYFACUOZUPZYGYFUQURNZN
      OVEUSYEYNEYNFGZJIZUFZYNYIUFYEYNYBDZUUKAYNULUULYDYLYBDZYMYBDZUUMYCACUHZABU
      HZAYLYMUGPAYNUIUUKAYNUJUTYEUUKYIYNYEUUJYHEJYEUUJYLFGZYMFGZHIZYHYDUUNUUOUU
      JUUTKYCUUPUUQAYLYMUNPYDYCUURYFUUSYGHACUKZABUKVAZNOVEUSYEUAVBZYIDZUVCEYFJI
      ZDZUVCYFYHJIZDZVCZUVCYKGZUVCYNGZKZUVDUVDYFQDZUVIYEUVDVDYDUVMYCYDYFUUGVFZV
      GZUVCEYHYFVHPYEUVFUVLUVHYEUVFUCZYTRSIZUVCSIZYJGZUVCYLGZUVJUVKUVPYFRSIZUVC
      SIZYGHIZYJGZUWBCGZUVSUVTUVPYCYDUWBUVEDUWDUWEKYCYDUVFVIYCYDUVFVJUVPUWBEUWA
      VOIZUVEUVPUVCUWFDZUWBUWFDYEUVFUWGYEUVEUWFUVCYEUVMUVEUWFKZUVOEYFVKLZVLVMUV
      CUWAWELYEUWHUVFUWITVNABCUWBVPVQUVPUVRUWCYJUVPUVRUWAYGHIZUVCSIZUWCYEUVRUWK
      KUVFYEUVQUWJUVCSYEUVQYHRSIZUWJYEYTYHRSUUIVRZYEYFYGRYDUUDYCUUHVGZYCUUCYDUU
      FTZRMDYEVSVTZWANVRTUVPUWAYGUVCYDUWAMDYCUVFYDUWAYDUVMUWAQDUVNYFWBLWFWCYCUU
      CYDUVFUUFWDUVFUVCMDZYEUVFUVCUVCEYFWGWFVGWANWHYDUVFUVTUWEKYCACUVCWIWJWKUVP
      YRUVCEYTJIZDZUVJUVSKZYEYRUVFYSTYEUVEUWRUVCYEYTYFWLGZDUVEUWRWMYEYTYHUXAUUI
      YEYFUXADZYGWPDZYHUXADYEUVMUXBUVOYFWNLYCUXCYDUUETYGYFYFWOWQWRYFEYTWSLWTAYJ
      UVCWIZWQUVPUUNUUOUVCEUURJIZDZUVKUVTKYDUUNYCUVFUUPWCYCUUOYDUVFUUQWDYEUXFUV
      FYEUXEUVEUVCYEUURYFEJYDUURYFKZYCUVAVGZOVLXAAYLYMUVCXBVQWKYEUVHUCZUVSUVCUU
      RSIZYMGZUVJUVKUXIUVRBGZYGRSIZUXJSIZBGZUVSUXKUXIUVRUXNBUXIUVRUXMUVCYFSIZSI
      ZUXNUXIUVRUXMYFHIZUVCSIZUXQYEUVRUXSKUVHYEUVQUXRUVCSYEUVQUUARSIUXRYEYTUUAR
      SUUBVRYEYGYFRUWOUWNUWPWANVRTUXIUXMUVCYFYCUXMMDYDUVHYCUXMYCYGQDZUXMQDYCYGU
      UEVFZYGWBLWFWDUVHUWQYEUVHUVCUVCYFYHWGWFVGYDUUDYCUVHUUHWCXCXDYEUXNUXQKUVHY
      EUXJUXPUXMSYEUURYFUVCSUXHOOTXDWHUXIYCYDUVREYGJIZDUVSUXLKYCYDUVHVIZYCYDUVH
      VJUXIUWLUVCSIZUWLUWLSIZUWLYFSIZVOIZUVRUYBUXIUWLQDZUVCYFUWLVOIZDZUYDUYGDYE
      UYHUVHYEYHQDZUYHYDUVMUXTUYKYCUVNUYAYFYGXEPZYHWBLZTYEUVHUYJYEUVGUYIUVCYEUY
      KUVGUYIKUYLYFYHVKLVLVMUWLUVCYFUWLXFWQYEUVRUYDKUVHYEUVQUWLUVCSUWMVRTYEUYBU
      YGKUVHYEUYBEUXMVOIZUYGYEUXTUYBUYNKYCUXTYDUYATZEYGVKLYEUYEEUYFUXMVOYEUWLYE
      UWLUYMWFXGYEUYFYHYFSIZRSIUXMYEYHRYFYDUUDUUCYHMDYCUUHUUFYFYGXHPUWPUWNXIYEU
      YPYGRSYDUUDUUCUYPYGKYCUUHUUFYFYGXJPVRNXKXDTXLABCUVRXBVQUXIYCUXJUYBDUXKUXO
      KUYCUXIUXJUXPUYBUXIUURYFUVCSYDUXGYCUVHUVAWCOUVHUVHUXTUXPUYBDYEUVHVDUYOUVC
      YFYGXMPWRABUXJWIWQWKUXIYRUWSUWTYEYRUVHYSTYEUVGUWRUVCYEUVGYIUWRYEYFWPDZUVG
      YIWMZYDUYQYCUUGVGUYRYFEWLGWPYFEYHXNXOXPLYEYTYHEJUUIOXQWTUXDWQUXIUUNUUOUVC
      UURUUTJIZDZUVKUXKKYDUUNYCUVHUUPWCYCUUOYDUVHUUQWDYEUYTUVHYEUYSUVGUVCYEUURY
      FUUTYHJUXHUVBXKVLXAAYLYMUVCXRVQWKXSXTYA $.

    $( Reversion is an involution on words.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    revrev $p |- ( W e. Word A -> ( reverse ` ( reverse ` W ) ) = W ) $=
      ( vx wcel cc0 chash cfv cfzo co creverse wfn wf revcl wrdf wceq syl eqtrd
      c1 cmin adantr cword 4syl revlen oveq2d fneq2d mpbid cv wa simpr eleqtrrd
      revfv syl2anc oveq1d fveq2d cz lencl nn0zd fzoval eleq2d biimpa fznn0sub2
      ffn cfz syldan cc peano2zm zcnd elfzoelz nncan syl2an eqfnfvd ) BAUAZDZCE
      BFGZHIZBJGZJGZBVMVQEVQFGZHIZKZVQVOKVMVPVLDZVQVLDVSAVQLVTABMZAVPMAVQNVSAVQ
      VBUBVMVSVOVQVMVRVNEHVMVRVPFGZVNVMWAVRWCOWBAVPUCPABUCZQUDUEUFVMVOABLBVOKAB
      NVOABVBPVMCUGZVODZUHZWEVQGZWCRSIZWESIZVPGZWEBGZWGWAWEEWCHIZDWHWKOVMWAWFWB
      TWGWEVOWMVMWFUIWGWCVNEHVMWCVNOWFWDTZUDUJAVPWEUKULWGWKVNRSIZWESIZVPGZWLWGW
      JWPVPWGWIWOWESWGWCVNRSWNUMUMUNWGWQWOWPSIZBGZWLVMWFWPVODWQWSOWGWPEWOVCIZVO
      WGWEWTDZWPWTDVMWFXAVMVOWTWEVMVNUODZVOWTOZVMVNABUPUQZEVNURPZUSUTWEWOVAPVMX
      CWFXETUJABWPUKVDWGWRWEBVMWOVEDWEVEDWRWEOWFVMWOVMXBWOUODXDVNVFPVGWFWEWEEVN
      VHVGWOWEVIVJUNQQQVK $.
  $}

  $( Mapping a word by a function.  (Contributed by Stefan O'Rear,
     27-Aug-2015.) $)
  wrdco $p |- ( ( W e. Word A /\ F : A --> B ) -> ( F o. W ) e. Word B ) $=
    ( cword wcel wf wa cc0 chash cfv cfzo co ccom simpr wrdf adantr fco syl2anc
    iswrdi syl ) DAEFZABCGZHZIDJKZLMZBCDNZGZUGBEFUDUCUFADGZUHUBUCOUBUIUCADPQUFA
    BCDRSBUEUGTUA $.

  $( Length of a mapped word is unchanged.  (Contributed by Stefan O'Rear,
     27-Aug-2015.) $)
  lenco $p |- ( ( W e. Word A /\ F : A --> B ) ->
      ( # ` ( F o. W ) ) = ( # ` W ) ) $=
    ( cword wcel wf wa ccom chash cfv cc0 cfzo wfn wceq simpr ffn hashfn 3syl
    co wrdf adantr fco syl2anc eqtr4d ) DAEFZABCGZHZCDIZJKZLDJKZMTZJKZUKUHULBUI
    GZUIULNUJUMOUHUGULADGZUNUFUGPUFUOUGADUAUBZULABCDUCUDULBUIQULUIRSUHUODULNUKU
    MOUPULADQULDRSUE $.

  $( Mapping of a singleton word.  (Contributed by Mario Carneiro,
     27-Sep-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s1co $p |- ( ( S e. A /\ F : A --> B ) ->
    ( F o. <" S "> ) = <" ( F ` S ) "> ) $=
    ( wcel wf wa cs1 ccom cc0 csn cxp cfv wceq cop s1val cc 0cn eqtr4d cvv mpan
    xpsng adantr coeq2d wfn ffn id fcoconst syl2anr fvex ax-mp c0ex xpsn eqtr4i
    syl6reqr ) CAEZABDFZGZDCHZIDJKZCKLZIZCDMZHZURUSVADUPUSVANUQUPUSJCOKZVACAPJQ
    EUPVAVENRJCQAUBUASUCUDURVBUTVCKLZVDUQDAUEUPVBVFNUPABDUFUPUGDUTACUHUIVDJVCOK
    ZVFVCTEVDVGNCDUJZVCTPUKJVCULVHUMUNUOS $.

  ${
    $d x y A $.  $d x B $.  $d x y F $.  $d x y S $.  $d x y T $.  $d x W $.
    $( Mapping of words commutes with reversal.  (Contributed by Stefan O'Rear,
       27-Aug-2015.) $)
    revco $p |- ( ( W e. Word A /\ F : A --> B ) ->
        ( F o. ( reverse ` W ) ) = ( reverse ` ( F o. W ) ) ) $=
      ( vx wcel wf wa cc0 cfv chash cfzo co cmpt cmin wceq syl adantr syl2anc
      c1 cword creverse cv ccom wfn wrdf ffn ad2antrr cfz cz lencl nn0zd fzoval
      eleq2d biimpa fznn0sub2 eleqtrrd fvco2 lenco oveq1d revfv adantlr 3eqtr4d
      fveq2d mpteq2dva oveq2d mpteq1d revlen 3eqtr4rd simpr revcl cvv wfun ffun
      fcompt adantl simpl cofunexg revval ) DAUAZFZABCGZHZEIDUBJZKJZLMZEUCZWDJZ
      CJZNZEICDUDZKJZLMZWLTOMZWGOMZWKJZNZCWDUDZWKUBJZWCEIDKJZLMZWPNEXAWINWQWJWC
      EXAWPWIWCWGXAFZHZWTTOMZWGOMZWKJZXEDJZCJZWPWIXCDXAUEZXEXAFXFXHPWAXIWBXBWAX
      AADGXIADUFXAADUGQUHXCXEIXDUIMZXAXCWGXJFZXEXJFWCXBXKWCXAXJWGWAXAXJPZWBWAWT
      UJFXLWAWTADUKULIWTUMQRZUNUOWGXDUPQWCXLXBXMRUQXACDXEURSXCWOXEWKWCWOXEPXBWC
      WNXDWGOWCWLWTTOABCDUSZUTUTRVDXCWHXGCWAXBWHXGPWBADWGVAVBVDVCVEWCEWMXAWPWCW
      LWTILXNVFVGWCEWFXAWIWCWEWTILWAWEWTPWBADVHRVFVGVIWCWBWFAWDGZWRWJPWAWBVJWAX
      OWBWAWDVTFXOADVKAWDUFQRECWDWFABVOSWCWKVLFZWSWQPWCCVMZWAXPWBXQWAABCVNVPWAW
      BVQCDVTVRSEVLWKVSQVC $.

    $( Mapping of words commutes with concatenation.  (Contributed by Stefan
       O'Rear, 27-Aug-2015.) $)
    ccatco $p |- ( ( S e. Word A /\ T e. Word A /\ F : A --> B ) ->
        ( F o. ( S concat T ) ) = ( ( F o. S ) concat ( F o. T ) ) ) $=
      ( vx vy wcel wf cc0 chash cfv caddc co cfzo cif cmpt wceq syl2anc cvv w3a
      cword cv cmin cconcat lenco 3adant2 3adant1 oveq12d oveq2d mpteq1d adantr
      ccom wa eleq2d ifbid eqeq1 wfn 3ad2ant1 ffn syl fvco2 sylan iftrue adantl
      eqtr4d wn 3ad2ant2 ad2antrr cz wo lencl nn0zd fzospliti orcanai fzosubel3
      ancoms fveq2d iffalse 3eqtr4d ifbothda eqtrd mpteq2dva ffvelrnda ffvelrnd
      wrdf eqtr2d ifclda ccatfval 3adant3 simp3 feqmptd fvif syl6eq fmptco wfun
      fveq2 ffun 3ad2ant3 simp1 cofunexg simp2 ) CAUBZHZDXCHZABEIZUAZFJCKLZDKLZ
      MNZONZFUCZJXHONZHZXLCLZELZXLXHUDNZDLZELZPZQZFJECUMZKLZEDUMZKLZMNZONZXLJYC
      ONZHZXLYBLZXLYCUDNZYDLZPZQZECDUENZUMYBYDUENZXGYNFXKYMQYAXGFYGXKYMXGYFXJJO
      XGYCXHYEXIMXDXFYCXHRXEABECUFUGZXEXFYEXIRXDABEDUFUHUIUJUKXGFXKYMXTXGXLXKHZ
      UNZYMXNYJYLPZXTYSYIXNYJYLYSYHXMXLXGYHXMRYRXGYCXHJOYQUJULUOUPXNYJXTRYLXTRY
      TXTRYSYJYLYJYTXTUQYLYTXTUQYSXNUNYJXPXTYSCXMURZXNYJXPRYSXMACIZUUAXGUUBYRXD
      XEUUBXFACWFUSULZXMACUTVAXMECXLVBVCXNXTXPRYSXNXPXSVDVEVFYSXNVGZUNZXQYDLZXS
      YLXTUUEDJXIONZURZXQUUGHZUUFXSRUUEUUGADIZUUHXGUUJYRUUDXEXDUUJXFADWFVHVIZUU
      GADUTVAUUEXLXHXJONHZXIVJHZUUIYSXNUULXGXHVJHZYRXNUULVKZXDXEUUNXFXDXHACVLVM
      USYRUUNUUOXLJXJXHVNVQVCVOXGUUMYRUUDXEXDUUMXFXEXIADVLVMVHVIXLXHXIVPSZUUGED
      XQVBSXGYLUUFRYRUUDXGYKXQYDXGYCXHXLUDYQUJVRVIUUDXTXSRYSXNXPXSVSVEVTWAWBWCW
      GXGFGXKAXNXOXRPZGUCZELZXTYOEYSXNXOXRAYSXMAXLCUUCWDUUEUUGAXQDUUKUUPWEWHXDX
      EYOFXKUUQQRXFFCDXCXCWIWJXGGABEXDXEXFWKWLUURUUQRUUSUUQELXTUURUUQEWQXNXOXRE
      WMWNWOXGYBTHZYDTHZYPYNRXGEWPZXDUUTXFXDUVBXEABEWRWSZXDXEXFWTECXCXASXGUVBXE
      UVAUVCXDXEXFXBEDXCXASFYBYDTTWISVT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Longer string literals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)
  $( Syntax for the length 2 word constructor. $)
  cs2 $a class <" A B "> $.

  $( Syntax for the length 3 word constructor. $)
  cs3 $a class <" A B C "> $.

  $( Syntax for the length 4 word constructor. $)
  cs4 $a class <" A B C D "> $.

  $( Syntax for the length 5 word constructor. $)
  cs5 $a class <" A B C D E "> $.

  $( Syntax for the length 6 word constructor. $)
  cs6 $a class <" A B C D E F "> $.

  $( Syntax for the length 7 word constructor. $)
  cs7 $a class <" A B C D E F G "> $.

  $( Syntax for the length 8 word constructor. $)
  cs8 $a class <" A B C D E F G H "> $.

  $( Define the length 2 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s2 $a |- <" A B "> = ( <" A "> concat <" B "> ) $.

  $( Define the length 3 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s3 $a |- <" A B C "> = ( <" A B "> concat <" C "> ) $.

  $( Define the length 4 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s4 $a |- <" A B C D "> = ( <" A B C "> concat <" D "> ) $.

  $( Define the length 5 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s5 $a |- <" A B C D E "> = ( <" A B C D "> concat <" E "> ) $.

  $( Define the length 6 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s6 $a |- <" A B C D E F "> = ( <" A B C D E "> concat <" F "> ) $.

  $( Define the length 7 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s7 $a |- <" A B C D E F G "> = ( <" A B C D E F "> concat <" G "> ) $.

  $( Define the length 8 word constructor.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  df-s8 $a |- <" A B C D E F G H "> = ( <" A B C D E F G "> concat <" H "> ) $.

  ${
    cats1cld.1 $e |- T = ( S concat <" X "> ) $.
    ${
      cats1cld.2 $e |- ( ph -> S e. Word A ) $.
      cats1cld.3 $e |- ( ph -> X e. A ) $.
      $( Closure of concatenation with a singleton.  (Contributed by Mario
         Carneiro, 26-Feb-2016.) $)
      cats1cld $p |- ( ph -> T e. Word A ) $=
        ( cs1 cconcat co cword wcel s1cld ccatcl syl2anc syl5eqel ) ADCEIZJKZBL
        ZFACTMRTMSTMGAEBHNBCROPQ $.

      cats1co.4 $e |- ( ph -> F : A --> B ) $.
      cats1co.5 $e |- ( ph -> ( F o. S ) = U ) $.
      cats1co.6 $e |- V = ( U concat <" ( F ` X ) "> ) $.
      $( Closure of concatenation with a singleton.  (Contributed by Mario
         Carneiro, 26-Feb-2016.) $)
      cats1co $p |- ( ph -> ( F o. T ) = V ) $=
        ( cs1 cconcat co ccom wcel cfv cword wf wceq s1cld syl3anc s1co syl2anc
        ccatco oveq12d eqtrd coeq2i 3eqtr4g ) AGDIPZQRZSZFIGUAPZQRZGESHAUPGDSZG
        UNSZQRZURADBUBZTUNVBTBCGUCZUPVAUDKAIBLUEMBCDUNGUIUFAUSFUTUQQNAIBTVCUTUQ
        UDLMBCIGUGUHUJUKEUOGJULOUM $.
    $}

    ${
      cats1cli.2 $e |- S e. Word _V $.
      $( Closure of concatenation with a singleton.  (Contributed by Mario
         Carneiro, 26-Feb-2016.) $)
      cats1cli $p |- T e. Word _V $=
        ( cs1 cconcat co cvv cword wcel s1cli ccatcl mp2an eqeltri ) BACFZGHZIJ
        ZDARKPRKQRKECLIAPMNO $.

      cats1fvn.3 $e |- ( # ` S ) = M $.
      $( The last symbol of a concatenation with a singleton.  (Contributed by
         Mario Carneiro, 26-Feb-2016.) $)
      cats1fvn $p |- ( X e. V -> ( T ` M ) = X ) $=
        ( wcel cfv cc0 cs1 chash caddc co cconcat oveq2i cn0 cvv cn cword lencl
        ax-mp eqeltrri nn0cni addid2i eqtr2i fveq12i cfzo wceq s1cli c1 eqeltri
        s1len 1nn lbfzo0 mpbir ccatval3 mp3an eqtri s1fv syl5eq ) EDICBJZKELZJZ
        EVCKAMJZNOZAVDPOZJZVECVGBVHFVGKCNOCVFCKNHQCCVFCRHASUAZIZVFRIGSAUBUCUDUE
        UFUGUHVKVDVJIKKVDMJZUIOIZVIVEUJGEUKVMVLTIVLULTEUNUOUMVLUPUQSAVDKURUSUTE
        DVAVB $.

      ${
        cats1fv.4 $e |- ( Y e. V -> ( S ` N ) = Y ) $.
        cats1fv.5 $e |- N e. NN0 $.
        cats1fv.6 $e |- N < M $.
        $( A symbol other than the last in a concatenation with a singleton.
           (Contributed by Mario Carneiro, 26-Feb-2016.) $)
        cats1fv $p |- ( Y e. V -> ( T ` N ) = Y ) $=
          ( wcel cfv co cvv cc0 clt cn0 cs1 cconcat cword chash cfzo wceq s1cli
          fveq1i cuz wbr nn0uz eleqtri lencl nn0z mp2b breqtrri elfzo2 mpbir3an
          cz ccatval1 mp3an eqtri syl5eq ) GENDBOZDAOZGVDDAFUAZUBPZOZVEDBVGHUHA
          QUCZNZVFVINDRAUDOZUEPNZVHVEUFIFUGVLDRUIOZNVKUSNZDVKSUJDTVMLUKULVJVKTN
          VNIQAUMVKUNUODCVKSMJUPDRVKUQURQAVFDUTVAVBKVC $.
      $}

      cats1len.4 $e |- ( M + 1 ) = N $.
      $( The length of concatenation with a singleton.  (Contributed by Mario
         Carneiro, 26-Feb-2016.) $)
      cats1len $p |- ( # ` T ) = N $=
        ( chash cfv cs1 cconcat co fveq2i c1 caddc cvv wcel eqtri cword ccatlen
        wceq s1cli mp2an s1len oveq12i ) BJKAELZMNZJKZDBUIJFOUJCPQNZDUJAJKZUHJK
        ZQNZUKARUAZSUHUOSUJUNUCGEUDRAUHUBUEULCUMPQHEUFUGTITT $.
    $}

    ${
      cats1cat.2 $e |- A e. Word _V $.
      cats1cat.3 $e |- S e. Word _V $.
      cats1cat.4 $e |- C = ( B concat <" X "> ) $.
      cats1cat.5 $e |- B = ( A concat S ) $.
      $( Closure of concatenation with a singleton.  (Contributed by Mario
         Carneiro, 26-Feb-2016.) $)
      cats1cat $p |- C = ( A concat T ) $=
        ( cs1 cconcat co oveq1i cvv cword wcel wceq s1cli ccatass mp3an 3eqtr4i
        eqtri oveq2i ) BFLZMNZADUFMNZMNZCAEMNUGADMNZUFMNZUIBUJUFMKOAPQZRDULRUFU
        LRUKUISHIFTPADUFUAUBUDJEUHAMGUEUC $.
    $}
  $}

  ${
    s2eqd.1 $e |- ( ph -> A = N ) $.
    s2eqd.2 $e |- ( ph -> B = O ) $.
    $( Equality theorem for a doubleton word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s2eqd $p |- ( ph -> <" A B "> = <" N O "> ) $=
      ( cs1 cconcat co cs2 s1eqd oveq12d df-s2 3eqtr4g ) ABHZCHZIJDHZEHZIJBCKDE
      KAPRQSIABDFLACEGLMBCNDENO $.

    s3eqd.3 $e |- ( ph -> C = P ) $.
    $( Equality theorem for a length 3 word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s3eqd $p |- ( ph -> <" A B C "> = <" N O P "> ) $=
      ( cs2 cs1 cconcat co cs3 s2eqd s1eqd oveq12d df-s3 3eqtr4g ) ABCKZDLZMNFG
      KZELZMNBCDOFGEOAUAUCUBUDMABCFGHIPADEJQRBCDSFGEST $.

    s4eqd.4 $e |- ( ph -> D = Q ) $.
    $( Equality theorem for a length 4 word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s4eqd $p |- ( ph -> <" A B C D "> = <" N O P Q "> ) $=
      ( cs3 cs1 cconcat co cs4 s3eqd df-s4 s1eqd oveq12d 3eqtr4g ) ABCDNZEOZPQH
      IFNZGOZPQBCDERHIFGRAUDUFUEUGPABCDFHIJKLSAEGMUAUBBCDETHIFGTUC $.

    s5eqd.5 $e |- ( ph -> E = R ) $.
    $( Equality theorem for a length 5 word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s5eqd $p |- ( ph -> <" A B C D E "> = <" N O P Q R "> ) $=
      ( cs4 cs1 cconcat co cs5 s4eqd s1eqd oveq12d df-s5 3eqtr4g ) ABCDEQZIRZST
      JKFGQZHRZSTBCDEIUAJKFGHUAAUGUIUHUJSABCDEFGJKLMNOUBAIHPUCUDBCDEIUEJKFGHUEU
      F $.

    s6eqd.6 $e |- ( ph -> F = S ) $.
    $( Equality theorem for a length 6 word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s6eqd $p |- ( ph -> <" A B C D E F "> = <" N O P Q R S "> ) $=
      ( cconcat cs5 cs1 co cs6 s5eqd s1eqd oveq12d df-s6 3eqtr4g ) ABCDEJUAZKUB
      ZTUCLMFGHUAZIUBZTUCBCDEJKUDLMFGHIUDAUJULUKUMTABCDEFGHJLMNOPQRUEAKISUFUGBC
      DEJKUHLMFGHIUHUI $.

    s7eqd.6 $e |- ( ph -> G = T ) $.
    $( Equality theorem for a length 7 word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s7eqd $p |- ( ph -> <" A B C D E F G "> = <" N O P Q R S T "> ) $=
      ( cs6 cs1 cconcat co cs7 s6eqd s1eqd oveq12d df-s7 3eqtr4g ) ABCDEKLUCZMU
      DZUEUFNOFGHIUCZJUDZUEUFBCDEKLMUGNOFGHIJUGAUMUOUNUPUEABCDEFGHIKLNOPQRSTUAU
      HAMJUBUIUJBCDEKLMUKNOFGHIJUKUL $.

    s8eqd.6 $e |- ( ph -> H = U ) $.
    $( Equality theorem for a length 8 word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s8eqd $p |- ( ph -> <" A B C D E F G H "> = <" N O P Q R S T U "> ) $=
      ( cs7 cs1 cconcat co cs8 s7eqd s1eqd oveq12d df-s8 3eqtr4g ) ABCDELMNUFZO
      UGZUHUIPQFGHIJUFZKUGZUHUIBCDELMNOUJPQFGHIJKUJAUPURUQUSUHABCDEFGHIJLMNPQRS
      TUAUBUCUDUKAOKUEULUMBCDELMNOUNPQFGHIJKUNUO $.
  $}

  ${
    s2cld.1 $e |- ( ph -> A e. X ) $.
    s2cld.2 $e |- ( ph -> B e. X ) $.
    $( A doubleton is a word.  (Contributed by Mario Carneiro, 27-Feb-2016.) $)
    s2cld $p |- ( ph -> <" A B "> e. Word X ) $=
      ( cs1 cs2 df-s2 s1cld cats1cld ) ADBGBCHCBCIABDEJFK $.

    s3cld.3 $e |- ( ph -> C e. X ) $.
    $( A length 3 string is a word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s3cld $p |- ( ph -> <" A B C "> e. Word X ) $=
      ( cs2 cs3 df-s3 s2cld cats1cld ) AEBCIBCDJDBCDKABCEFGLHM $.

    s4cld.4 $e |- ( ph -> D e. X ) $.
    $( A length 4 string is a word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s4cld $p |- ( ph -> <" A B C D "> e. Word X ) $=
      ( cs3 cs4 df-s4 s3cld cats1cld ) AFBCDKBCDELEBCDEMABCDFGHINJO $.

    s5cld.5 $e |- ( ph -> E e. X ) $.
    $( A length 5 string is a word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s5cld $p |- ( ph -> <" A B C D E "> e. Word X ) $=
      ( cs4 cs5 df-s5 s4cld cats1cld ) AGBCDEMBCDEFNFBCDEFOABCDEGHIJKPLQ $.

    s6cld.6 $e |- ( ph -> F e. X ) $.
    $( A length 6 string is a word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s6cld $p |- ( ph -> <" A B C D E F "> e. Word X ) $=
      ( cs5 cs6 df-s6 s5cld cats1cld ) AHBCDEFOBCDEFGPGBCDEFGQABCDEFHIJKLMRNS
      $.

    s7cld.7 $e |- ( ph -> G e. X ) $.
    $( A length 7 string is a word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s7cld $p |- ( ph -> <" A B C D E F G "> e. Word X ) $=
      ( cs6 cs7 df-s7 s6cld cats1cld ) AIBCDEFGQBCDEFGHRHBCDEFGHSABCDEFGIJKLMNO
      TPUA $.

    s8cld.8 $e |- ( ph -> H e. X ) $.
    $( A length 7 string is a word.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s8cld $p |- ( ph -> <" A B C D E F G H "> e. Word X ) $=
      ( cs7 cs8 df-s8 s7cld cats1cld ) AJBCDEFGHSBCDEFGHITIBCDEFGHIUAABCDEFGHJK
      LMNOPQUBRUC $.
  $}

  $( A doubleton is a word.  (Contributed by Stefan O'Rear, 23-Aug-2015.)
     (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s2cl $p |- ( ( A e. X /\ B e. X ) -> <" A B "> e. Word X ) $=
    ( wcel wa simpl simpr s2cld ) ACDZBCDZEABCIJFIJGH $.

  $( A length 3 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s3cl $p |- ( ( A e. X /\ B e. X /\ C e. X ) -> <" A B C "> e. Word X ) $=
    ( wcel w3a simp1 simp2 simp3 s3cld ) ADEZBDEZCDEZFABCDKLMGKLMHKLMIJ $.

  $( A doubleton is a word.  (Contributed by Mario Carneiro, 26-Feb-2016.) $)
  s2cli $p |- <" A B "> e. Word _V $=
    ( cs1 cs2 df-s2 s1cli cats1cli ) ACABDBABEAFG $.

  $( A length 3 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s3cli $p |- <" A B C "> e. Word _V $=
    ( cs2 cs3 df-s3 s2cli cats1cli ) ABDABCECABCFABGH $.

  $( A length 4 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s4cli $p |- <" A B C D "> e. Word _V $=
    ( cs3 cs4 df-s4 s3cli cats1cli ) ABCEABCDFDABCDGABCHI $.

  $( A length 5 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s5cli $p |- <" A B C D E "> e. Word _V $=
    ( cs4 cs5 df-s5 s4cli cats1cli ) ABCDFABCDEGEABCDEHABCDIJ $.

  $( A length 6 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s6cli $p |- <" A B C D E F "> e. Word _V $=
    ( cs5 cs6 df-s6 s5cli cats1cli ) ABCDEGABCDEFHFABCDEFIABCDEJK $.

  $( A length 7 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s7cli $p |- <" A B C D E F G "> e. Word _V $=
    ( cs6 cs7 df-s7 s6cli cats1cli ) ABCDEFHABCDEFGIGABCDEFGJABCDEFKL $.

  $( A length 8 string is a word.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s8cli $p |- <" A B C D E F G H "> e. Word _V $=
    ( cs7 cs8 df-s8 s7cli cats1cli ) ABCDEFGIABCDEFGHJHABCDEFGHKABCDEFGLM $.

  $( Extract the first symbol from a doubleton.  (Contributed by Stefan O'Rear,
     23-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s2fv0 $p |- ( A e. V -> ( <" A B "> ` 0 ) = A ) $=
    ( cs1 cs2 c1 cc0 df-s2 s1cli s1len s1fv 0nn0 0lt1 cats1fv ) ADABEFGCBAABHAI
    AJACKLMN $.

  $( Extract the second symbol from a doubleton.  (Contributed by Stefan
     O'Rear, 23-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s2fv1 $p |- ( B e. V -> ( <" A B "> ` 1 ) = B ) $=
    ( cs1 cs2 c1 df-s2 s1cli s1len cats1fvn ) ADABEFCBABGAHAIJ $.

  $( The length of a doubleton.  (Contributed by Stefan O'Rear, 23-Aug-2015.)
     (Revised by Mario Carneiro, 26-Feb-2016.) $)
  s2len $p |- ( # ` <" A B "> ) = 2 $=
    ( cs1 cs2 c1 c2 df-s2 s1cli s1len 1p1e2 cats1len ) ACABDEFBABGAHAIJK $.

  $( Extract the first symbol from a length 3 string.  (Contributed by Mario
     Carneiro, 13-Jan-2017.) $)
  s3fv0 $p |- ( A e. V -> ( <" A B C "> ` 0 ) = A ) $=
    ( cs2 cs3 c2 cc0 df-s3 s2cli s2len s2fv0 0nn0 2pos cats1fv ) ABEABCFGHDCAAB
    CIABJABKABDLMNO $.

  $( Extract the second symbol from a length 3 string.  (Contributed by Mario
     Carneiro, 13-Jan-2017.) $)
  s3fv1 $p |- ( B e. V -> ( <" A B C "> ` 1 ) = B ) $=
    ( cs2 cs3 c2 c1 df-s3 s2cli s2len s2fv1 1nn0 1lt2 cats1fv ) ABEABCFGHDCBABC
    IABJABKABDLMNO $.

  $( Extract the third symbol from a length 3 string.  (Contributed by Mario
     Carneiro, 13-Jan-2017.) $)
  s3fv2 $p |- ( C e. V -> ( <" A B C "> ` 2 ) = C ) $=
    ( cs2 cs3 c2 df-s3 s2cli s2len cats1fvn ) ABEABCFGDCABCHABIABJK $.

  $( The length of a length 3 string.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s3len $p |- ( # ` <" A B C "> ) = 3 $=
    ( cs2 cs3 c2 c3 df-s3 s2cli s2len 2p1e3 cats1len ) ABDABCEFGCABCHABIABJKL
    $.

  $( The length of a length 4 string.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s4len $p |- ( # ` <" A B C D "> ) = 4 $=
    ( cs3 cs4 c3 c4 df-s4 s3cli s3len 3p1e4 cats1len ) ABCEABCDFGHDABCDIABCJABC
    KLM $.

  $( The length of a length 5 string.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s5len $p |- ( # ` <" A B C D E "> ) = 5 $=
    ( cs4 cs5 c4 c5 df-s5 s4cli s4len 4p1e5 cats1len ) ABCDFABCDEGHIEABCDEJABCD
    KABCDLMN $.

  $( The length of a length 6 string.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s6len $p |- ( # ` <" A B C D E F "> ) = 6 $=
    ( cs5 cs6 c5 c6 df-s6 s5cli s5len 5p1e6 cats1len ) ABCDEGABCDEFHIJFABCDEFKA
    BCDELABCDEMNO $.

  $( The length of a length 7 string.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s7len $p |- ( # ` <" A B C D E F G "> ) = 7 $=
    ( cs6 cs7 c6 c7 df-s7 s6cli s6len 6p1e7 cats1len ) ABCDEFHABCDEFGIJKGABCDEF
    GLABCDEFMABCDEFNOP $.

  $( The length of a length 8 string.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s8len $p |- ( # ` <" A B C D E F G H "> ) = 8 $=
    ( cs7 cs8 c7 c8 df-s8 s7cli s7len 7p1e8 cats1len ) ABCDEFGIABCDEFGHJKLHABCD
    EFGHMABCDEFGNABCDEFGOPQ $.

  $( A length 2 word is an unordered pair of ordered pairs.  (Contributed by
     Alexander van der Vekens, 14-Aug-2017.) $)
  s2prop $p |- ( ( A e. S /\ B e. S )
                -> <" A B "> = { <. 0 , A >. , <. 1 , B >. } ) $=
    ( wcel wa cs2 cs1 cconcat co cc0 cop cpr df-s2 chash cfv csn cun cword wceq
    c1 s1cl cats1un sylan s1val adantr uneq1d df-pr s1len opeq1d preq2d syl5eqr
    a1i 3eqtrd syl5eq ) ACDZBCDZEZABFAGZBGHIZJAKZTBKZLZABMUQUSURURNOZBKZPZQZUTP
    ZVEQZVBUOURCRDUPUSVFSACUAURBCUBUCUQURVGVEUOURVGSUPACUDUEUFUQVHUTVDLVBUTVDUG
    UQVDVAUTUQVCTBVCTSUQAUHULUIUJUKUMUN $.

  $( A length 4 word is a union of two unordered pairs of ordered pairs.
     (Contributed by Alexander van der Vekens, 14-Aug-2017.) $)
  s4prop $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) )
                -> <" A B C D "> = ( { <. 0 , A >. , <. 1 , B >. }
                                  u. { <. 2 , C >. , <. 3 , D >. } ) ) $=
    ( wcel wa cs1 cconcat co cop cpr c2 c3 cun chash cfv wceq adantr a1i cs4 c1
    cs3 cc0 df-s4 cs2 cword simpl simpr adantl s3cld cats1un syl2anc df-s3 s2cl
    csn syl5eq s2prop uneq1d eqtrd unass df-pr s2len opeq1d s3len uneq2d 3eqtrd
    preq12d syl5eqr ) AEFZBEFZGZCEFZDEFZGZGZABCDUAABCUCZDHIJZUDAKUBBKLZMCKZNDKZ
    LZOZABCDUEVPVRVSABUFZPQZCKZUPZOZVQPQZDKZUPZOZVSWGWKOZOZWCVPVRVQWKOZWLVPVQEU
    GZFVNVRWORVPABCEVLVJVOVJVKUHSVLVKVOVJVKUISVOVMVLVMVNUHUJZUKVOVNVLVMVNUIUJVQ
    DEULUMVPVQWHWKVPVQWDWGOZWHVPVQWDCHIJZWRABCUNVPWDWPFZVMWSWRRVLWTVOABEUOSWQWD
    CEULUMUQVPWDVSWGVLWDVSRVOABEURSUSUTUSUTWLWNRVPVSWGWKVATVPWMWBVSVPWMWFWJLWBW
    FWJVBVPWFVTWJWAVPWEMCWEMRVPABVCTVDVPWINDWINRVPABCVETVDVHVIVFVGUQ $.

  $( A length 2 word with mutually different symbols is a one-to-one function
     onto the set of the symbols.  (Contributed by Alexander van der Vekens,
     14-Aug-2017.) $)
  s2f1o $p |- ( ( A e. S /\ B e. S /\ A =/= B ) -> ( E = <" A B ">
                -> E : { 0 , 1 } -1-1-onto-> { A , B } ) ) $=
    ( wcel wne w3a cs2 wceq cc0 c1 cpr wf1o wa cop cz simpl1 0z jctil eqidd jca
    simpl2 simpl3 ax-1ne0 necomi f1oprg sylc eqcom s2prop 3adant3 eqeq1d syl5bb
    1z biimpa f1oeq123d mpbid ex ) ACEZBCEZABFZGZDABHZIZJKLZABLZDMZVAVCNZVDVEJA
    OKBOLZMZVFVGJPEZURNZKPEZUSNZNJKFZUTNVIVGVKVMVGURVJURUSUTVCQRSVGUSVLURUSUTVC
    UBUMSUAVGUTVNURUSUTVCUCKJUDUESJAKBPCPCUFUGVGVDVDVEVEVHDVAVCVHDIZVCVBDIVAVOD
    VBUHVAVBVHDURUSVBVHIUTABCUIUJUKULUNVGVDTVGVETUOUPUQ $.

  $( A union of unordered pairs of ordered pairs with different elements is a
     one-to-one onto function.  (Contributed by Alexander van der Vekens,
     14-Aug-2017.) $)
  f1oun2prg $p |- ( ( ( A e. V /\ B e. W ) /\ ( C e. X /\ D e. Y ) )
                    -> ( ( ( A =/= B /\ A =/= C /\ A =/= D )
                        /\ ( B =/= C /\ B =/= D /\ C =/= D ) )
    -> ( { <. 0 , A >. , <. 1 , B >. } u. { <. 2 , C >. , <. 3 , D >. } ) :
       ( { 0 , 1 } u. { 2 , 3 } ) -1-1-onto-> ( { A , B } u. { C , D } ) ) ) $=
    ( wcel wa wne cc0 c1 c2 c3 cin c0 wceq csn disjsn2 w3a cpr cun cop cz simpl
    wf1o 0z jctil ad2antrr simpr 1z jca id 3ad2ant1 necomi adantr adantl f1oprg
    ax-1ne0 sylc 2nn 3nn 3ad2ant3 2re 2lt3 ltneii 3ad2ant2 anim12i df-pr ineq1i
    cn eqeq1i undisj1 bitr4i sylibr undisj2 eqcomi ineq2i bitri sylib 2ne0 1ne2
    ax-mp pm3.2i mpbi eqtr3i 3ne0 1re 1lt3 f1oun syl21anc ex ) AEIZBFIZJZCGIZDH
    IZJZJZABKZACKZADKZUAZBCKZBDKZCDKZUAZJZLMUBZNOUBZUCABUBZCDUBZUCLAUDMBUDUBZNC
    UDODUDUBZUCUGZWTXIJZXJXLXNUGZXKXMXOUGZXJXKPZQRZXLXMPZQRZJXPXQLUEIZWNJZMUEIZ
    WOJZJLMKZXAJZXRXQYEYGWPYEWSXIWPWNYDWNWOUFUHUIUJWPYGWSXIWPWOYFWNWOUKULUIUJUM
    XIYIWTXDYIXHXDXAYHXAXBXAXCXAUNUOMLUTUPUIUQURLAMBUEEUEFUSVAXQNVLIZWQJZOVLIZW
    RJZJZNOKZXGJZXSWTYNXIWTYKYMWSYKWPWSWQYJWQWRUFVBUIURWSYMWPWSWRYLWQWRUKVCUIUR
    UMUQXIYPWTXHYPXDXHXGYOXGXEXGXFXGUNVDNOVEVFVGUIURURNCODVLGVLHUSVAXQYCYAXQXLC
    SZPZQRZXLDSZPZQRZJZYCXQYSUUBXQASZYQPQRZBSZYQPQRZJZYSXIUUHWTXDUUEXHUUGXBXAUU
    EXCACTVHXEXFUUGXGBCTUOVIURYSUUDUUFUCZYQPZQRUUHYRUUJQXLUUIYQABVJZVKVMUUDUUFY
    QVNVOVPXQUUDYTPQRZUUFYTPQRZJZUUBXIUUNWTXDUULXHUUMXCXAUULXBADTVDXFXEUUMXGBDT
    VHVIURUUBUUIYTPZQRUUNUUAUUOQXLUUIYTUUKVKVMUUDUUFYTVNVOVPUMUUCXLYQYTUCZPZQRY
    CXLYQYTVQUUQYBQUUPXMXLXMUUPCDVJVRVSVMVTWAXJNSZPZQRZXJOSZPZQRZJZYAUUTUVCLSZM
    SZUCZUURPZUUSQUVGXJUURXJUVGLMVJVRZVKUVEUURPQRZUVFUURPQRZJUVHQRUVJUVKLNKUVJN
    LWBUPLNTWDMNKUVKWCMNTWDWEUVEUVFUURVNWFWGUVGUVAPZUVBQUVGXJUVAUVIVKUVEUVAPQRZ
    UVFUVAPQRZJUVLQRUVMUVNLOKUVMOLWHUPLOTWDMOKUVNMOWIWJVGMOTWDWEUVEUVFUVAVNWFWG
    WEUVDXJUURUVAUCZPZQRYAXJUURUVAVQUVPXTQUVOXKXJXKUVONOVJVRVSVMVTWFUIXJXLXKXMX
    NXOWKWLWM $.

  ${
    $d x y E $.
    $( A length 4 word with mutually different symbols is a one-to-one function
       onto the set of the symbols.  (Contributed by Alexander van der Vekens,
       14-Aug-2017.) $)
    s4f1o $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) )
                    -> ( ( ( A =/= B /\ A =/= C /\ A =/= D )
                        /\ ( B =/= C /\ B =/= D /\ C =/= D ) )
             -> ( E = <" A B C D ">
                  -> E : dom E -1-1-onto-> ( { A , B } u. { C , D } ) ) ) ) $=
      ( vx vy wcel wa wne w3a wceq cpr cun wf1o cc0 c1 cop sylibr cs4 cdm c2 c3
      f1oun2prg imp adantr s4prop eqeq2d biimpa eqcomd eqidd f1oeq123d mpbid wf
      wf1 crn cv wbr wmo wal dff1o5 biimpi bicomi anbi1i wss ffdm simpld anim1i
      dff12 syl exp31 ) AEIBEIJCEIDEIJJZABKACKADKLBCKBDKCDKLJZFABCDUAZMZFUBZABN
      CDNOZFPZVMVNJZVPJZQRNUCUDNOZVRFPZVSWAWBVRQASRBSNUCCSUDDSNOZPZWCVTWEVPVMVN
      WEABCDEEEEUEUFUGWAWBWBVRVRWDFWAFWDVTVPFWDMVTVOWDFVMVOWDMVNABCDEUHUGUIUJUK
      WAWBULWAVRULUMUNWCVQVRFUPZFUQVRMZJZVSWCVQVRFUOZGURHURFUSGUTHVAZJZWGJZWHWC
      WBVRFUOZWJJZWGJZWLWCWBVRFUPZWGJZWOWCWQWBVRFVBVCWNWPWGWPWNGHWBVRFVJVDVETWN
      WKWGWMWIWJWMWIVQWBVFWBVRFVGVHVIVIVKWFWKWGGHVQVRFVJVETVQVRFVBTVKVL $.
  $}

  $( The domain of a length 4 word is the union of two (disjunct) pairs.
     (Contributed by Alexander van der Vekens, 15-Aug-2017.) $)
  s4dom $p |- ( ( ( A e. S /\ B e. S ) /\ ( C e. S /\ D e. S ) )
                -> ( E = <" A B C D ">
                     -> dom E = ( { 0 , 1 } u. { 2 , 3 } ) ) ) $=
    ( wcel wa cs4 wceq cdm cc0 c1 cpr c2 c3 cun dmeq cop dmpropg s4prop uneq12d
    dmeqd dmun adantr adantl syl5eq eqtrd sylan9eqr ex ) AEGBEGHZCEGDEGHZHZFABC
    DIZJZFKZLMNZOPNZQZJUOUMUPUNKZUSFUNRUMUTLASMBSNZOCSPDSNZQZKZUSUMUNVCABCDEUAU
    CUMVDVAKZVBKZQUSVAVBUDUMVEUQVFURUKVEUQJULLAMBEETUEULVFURJUKOCPDEETUFUBUGUHU
    IUJ $.

  ${
    s2co.1 $e |- ( ph -> F : X --> Y ) $.
    s2co.2 $e |- ( ph -> A e. X ) $.
    s2co.3 $e |- ( ph -> B e. X ) $.
    $( Mapping a doubleton by a function.  (Contributed by Mario Carneiro,
       27-Feb-2016.) $)
    s2co $p |- ( ph -> ( F o. <" A B "> ) = <" ( F ` A ) ( F ` B ) "> ) $=
      ( cs1 cs2 cfv df-s2 s1cld wcel wf ccom wceq s1co syl2anc cats1co ) AEFBJZ
      BCKBDLZJZDUCCDLZKCBCMABEHNIGABEOEFDPDUBQUDRHGEFBDSTUCUEMUA $.

    s3co.4 $e |- ( ph -> C e. X ) $.
    $( Mapping a length 3 string by a function.  (Contributed by Mario
       Carneiro, 27-Feb-2016.) $)
    s3co $p |- ( ph -> ( F o. <" A B C "> ) =
      <" ( F ` A ) ( F ` B ) ( F ` C ) "> ) $=
      ( cs2 cs3 cfv df-s3 s2cld s2co cats1co ) AFGBCLBCDMBENZCENZLESTDENZMDBCDO
      ABCFIJPKHABCEFGHIJQSTUAOR $.
  $}

  $( Concatenation of fixed length strings.  (This special case of ~ ccatlid is
     provided to complete the pattern ~ s0s1 , ~ df-s2 , ~ df-s3 , ...)
     (Contributed by Mario Carneiro, 28-Feb-2016.) $)
  s0s1 $p |- <" A "> = ( (/) concat <" A "> ) $=
    ( c0 cs1 cconcat co cvv cword wcel wceq s1cli ccatlid ax-mp eqcomi ) BACZDE
    ZNNFGHONIAJFNKLM $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1s2 $p |- <" A B C "> = ( <" A "> concat <" B C "> ) $=
    ( cs1 cs2 cs3 df-s2 s1cli df-s3 cats1cat ) ADABEABCFBDBCECBCGAHBHABCIABGJ
    $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1s3 $p |- <" A B C D "> = ( <" A "> concat <" B C D "> ) $=
    ( cs1 cs3 cs4 cs2 df-s3 s1cli s2cli df-s4 s1s2 cats1cat ) AEABCFABCDGBCHBCD
    FDBCDIAJBCKABCDLABCMN $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1s4 $p |- <" A B C D E "> = ( <" A "> concat <" B C D E "> ) $=
    ( cs1 cs4 cs5 cs3 df-s4 s1cli s3cli df-s5 s1s3 cats1cat ) AFABCDGABCDEHBCDI
    BCDEGEBCDEJAKBCDLABCDEMABCDNO $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1s5 $p |- <" A B C D E F "> = ( <" A "> concat <" B C D E F "> ) $=
    ( cs1 cs5 cs6 cs4 df-s5 s1cli s4cli df-s6 s1s4 cats1cat ) AGABCDEHABCDEFIBC
    DEJBCDEFHFBCDEFKALBCDEMABCDEFNABCDEOP $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1s6 $p |- <" A B C D E F G "> = ( <" A "> concat <" B C D E F G "> ) $=
    ( cs1 cs6 cs7 cs5 df-s6 s1cli s5cli df-s7 s1s5 cats1cat ) AHABCDEFIABCDEFGJ
    BCDEFKBCDEFGIGBCDEFGLAMBCDEFNABCDEFGOABCDEFPQ $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s1s7 $p |- <" A B C D E F G H "> = ( <" A "> concat <" B C D E F G H "> ) $=
    ( cs1 cs7 cs8 cs6 df-s7 s1cli s6cli df-s8 s1s6 cats1cat ) AIABCDEFGJABCDEFG
    HKBCDEFGLBCDEFGHJHBCDEFGHMANBCDEFGOABCDEFGHPABCDEFGQR $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s2s2 $p |- <" A B C D "> = ( <" A B "> concat <" C D "> ) $=
    ( cs2 cs3 cs4 cs1 df-s2 s2cli s1cli df-s4 df-s3 cats1cat ) ABEABCFABCDGCHCD
    EDCDIABJCKABCDLABCMN $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s4s2 $p |- <" A B C D E F "> = ( <" A B C D "> concat <" E F "> ) $=
    ( cs4 cs5 cs6 cs1 cs2 df-s2 s4cli s1cli df-s6 df-s5 cats1cat ) ABCDGABCDEHA
    BCDEFIEJEFKFEFLABCDMENABCDEFOABCDEPQ $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s4s3 $p |- <" A B C D E F G "> = ( <" A B C D "> concat <" E F G "> ) $=
    ( cs4 cs6 cs7 cs2 cs3 df-s3 s4cli s2cli df-s7 s4s2 cats1cat ) ABCDHABCDEFIA
    BCDEFGJEFKEFGLGEFGMABCDNEFOABCDEFGPABCDEFQR $.

  $( Concatenation of fixed length strings.  (Contributed by Mario Carneiro,
     26-Feb-2016.) $)
  s4s4 $p |- <" A B C D E F G H "> = ( <" A B C D "> concat <" E F G H "> ) $=
    ( cs4 cs7 cs8 cs3 df-s4 s4cli s3cli df-s8 s4s3 cats1cat ) ABCDIABCDEFGJABCD
    EFGHKEFGLEFGHIHEFGHMABCDNEFGOABCDEFGHPABCDEFGQR $.

  $( Extract two adjacent symbols from a word.  (Contributed by Stefan O'Rear,
     23-Aug-2015.)  (Revised by Mario Carneiro, 26-Feb-2016.) $)
  swrds2 $p |- ( ( W e. Word A /\ I e. NN0 /\
        ( I + 1 ) e. ( 0 ..^ ( # ` W ) ) ) ->
      ( W substr <. I , ( I + 2 ) >. ) = <" ( W ` I ) ( W ` ( I + 1 ) ) "> ) $=
    ( wcel cn0 c1 caddc cc0 cfv cop csubstr cconcat wceq wbr 3ad2ant3 syl3anbrc
    co syl cfz cle cword chash w3a cs2 c2 cs1 simp1 cn clt simp2 elfzo0 simp2bi
    nn0red peano2nn0 nnred lep1d elfzolt2 lelttrd swrds1 syl2anc nn0cn 3ad2ant2
    cfzo ax-1cn addass mp3an23 df-2 oveq2i syl6reqr opeq2d oveq2d 3adant2 eqtrd
    cc oveq12d df-s2 elfz2nn0 eqeltrd breqtrrd fzofzp1 ccatswrd syl13anc eqtr2d
    ) CAUADZBEDZBFGQZHCUBIZVCQZDZUCZBCIZWFCIZUDZCBWFJKQZCWFBUEGQZJZKQZLQZCBWOJK
    QZWJWRWKUFZWLUFZLQWMWJWNWTWQXALWJWDBWHDZWNWTMWDWEWIUGZWJWEWGUHDZBWGUINXBWDW
    EWIUJZWIWDXDWEWIWFEDZXDWFWGUINZWFWGUKULOZWJBWFWGWJBXEUMZWJWFWJWEXFXEBUNRZUM
    ZWJWGXHUOWJBXIUPZWIWDXGWEWFHWGUQOURBWGUKPABCUSUTWJWQCWFWFFGQZJZKQZXAWJWPXNC
    KWJWOXMWFWJBVNDZWOXMMWEWDXPWIBVAVBXPXMBFFGQZGQZWOXPFVNDZXSXMXRMVDVDBFFVEVFU
    EXQBGVGVHVIRZVJVKWDWIXOXAMWEAWFCUSVLVMVOWKWLVPVIWJWDBHWFSQDZWFHWOSQDZWOHWGS
    QZDWRWSMXCWJWEXFBWFTNYAXEXJXLBWFVQPWJXFWOEDWFWOTNYBXJWJWOXMEXTWJXFXMEDXJWFU
    NRVRWJWFXMWOTWJWFXKUPXTVSWFWOVQPWJWOXMYCXTWIWDXMYCDWEHWGWFVTOVRACBWFWOWAWBW
    C $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
        Elementary real and complex functions
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The "shift" operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c shift $.  $( Symbol for function shifter. $)

  $( Extend class notation with function shifter. $)
  cshi $a class shift $.

  ${
    $d x y z f g $.
    $( Define a function shifter.  This operation offsets the value argument of
       a function (ordinarily on a subset of ` CC ` ) and produces a new
       function on ` CC ` .  See ~ shftval for its value.  (Contributed by NM,
       20-Jul-2005.) $)
    df-shft $a |- shift = ( f e. _V , x e. CC |->
                  { <. y , z >. | ( y e. CC /\ ( y - x ) f z ) } ) $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Two ways to write a shifted set ` ( B + A ) ` .  (Contributed by Mario
       Carneiro, 3-Nov-2013.) $)
    shftlem $p |- ( ( A e. CC /\ B C_ CC ) ->
          { x e. CC | ( x - A ) e. B } = { x | E. y e. B x = ( y + A ) } ) $=
      ( cc wcel wss wa cv cmin co crab cab caddc wceq wrex ancoms oveq1 sylan
      wi df-rab npcan eqcomd eqeq2d rspcev expcom syl expimpd ssel2 addcl pncan
      adantr simplr eqeltrd jca anassrs eleq1d anbi12d syl5ibrcom impbid abbidv
      eleq1 rexlimdva syl5eq ) CEFZDEGZHZAIZCJKZDFZAELVHEFZVJHZAMVHBIZCNKZOZBDP
      ZAMVJAEUAVGVLVPAVGVLVPVEVLVPTVFVEVKVJVPVEVKHZVHVICNKZOZVJVPTVQVRVHVKVEVRV
      HOVHCUBQUCVJVSVPVOVSBVIDVMVIOVNVRVHVMVICNRUDUEUFUGUHULVGVOVLBDVGVMDFZHVLV
      OVNEFZVNCJKZDFZHZVEVFVTWDVFVTHZVEWDWEVEHZWAWCWEVMEFZVEWADEVMUIZVMCUJSWFWB
      VMDWEWGVEWBVMOWHVMCUKSVFVTVEUMUNUOQUPVOVKWAVJWCVHVNEVBVOVIWBDVHVNCJRUQURU
      SVCUTVAVD $.

    $( A shift of the upper integers.  (Contributed by Mario Carneiro,
       5-Nov-2013.) $)
    shftuz $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
          { x e. CC | ( x - A ) e. ( ZZ>= ` B ) } = ( ZZ>= ` ( B + A ) ) ) $=
      ( cz wcel wa cv cmin co cuz cfv cc crab cab caddc df-rab w3a simp2 ancoms
      wi zcn 3ad2ant1 npcand eluzadd 3adant2 eqeltrrd 3expib adantr eluzelz a1i
      zcnd eluzsub 3expia jcad impbid abbi1dv syl5eq ) BDEZCDEZFZAGZBHIZCJKEZAL
      MVALEZVCFZANCBOIZJKZVCALPUTVEAVGUTVEVAVGEZURVEVHTUSURVDVCVHURVDVCQZVBBOIZ
      VAVGVIVABURVDVCRURVDBLEVCBUAUBUCURVCVJVGEZVDVCURVKBCVBUDSUEUFUGUHUTVHVDVC
      VHVDTUTVHVAVFVAUIUKUJUSURVHVCTUSURVHVCBCVAULUMSUNUOUPUQ $.
  $}

  ${
    $d w x y z A $.  $d w x y z F $.  $d w x y z B $.
    shftfval.1 $e |- F e. _V $.
    $( The value of the sequence shifter operation is a function on ` CC ` .
       ` A ` is ordinarily an integer.  (Contributed by NM, 20-Jul-2005.)
       (Revised by Mario Carneiro, 3-Nov-2013.) $)
    shftfval $p |- ( A e. CC -> ( F shift A ) =
                    { <. x , y >. | ( x e. CC /\ ( x - A ) F y ) } ) $=
      ( vz vw cc wcel cv cmin co wbr wa copab cvv cshi wceq caddc wrex cdm ovex
      cab crn cxp wss vex breldm npcan eqcomd ancoms oveq1 eqeq2d syl2anr eqeq1
      rspcev rexbidv elab sylibr brelrn jca expl ssopab2dv df-xp syl6sseqr dmex
      adantl abrexex rnex xpex ssexg sylancl breq anbi2d opabbidv oveq2 df-shft
      breq1d ovmpt2g mp3an1 mpdan ) CHIZAJZHIZWCCKLZBJZDMZNZABOZPIZDCQLWIRZWBWI
      FJZGJZCSLZRZGDUAZTZFUCZDUDZUEZUFWTPIWJWBWIWCWRIZWFWSIZNZABOWTWBWHXCABWBWD
      WGXCWBWDNZWGNZXAXBXEWCWNRZGWPTZXAWGWEWPIWCWECSLZRZXGXDWEWFDWCCKUBZBUGZUHW
      DWBXIWDWBNXHWCWCCUIUJUKXFXIGWEWPWMWERWNXHWCWMWECSULUMUPUNWQXGFWCAUGWLWCRW
      OXFGWPWLWCWNUOUQURUSWGXBXDWEWFDXJXKUTVGVAVBVCABWRWSVDVEWRWSGFWPWNDEVFVHDE
      VIVJWIWTPVKVLDPIWBWJWKEFGDCPHWDWCWMKLZWFWLMZNZABOWIQWDXLWFDMZNZABOPWLDRZX
      NXPABXQXMXOWDXLWFWLDVMVNVOWMCRZXPWHABXRXOWGWDXRXLWEWFDWMCWCKVPVRVNVOGABFV
      QVSVTWA $.

    $( Domain of a relation shifted by ` A ` .  The set on the right is more
       commonly notated as ` ( dom F + A ) ` (meaning add ` A ` to every
       element of ` dom F ` ).  (Contributed by Mario Carneiro, 3-Nov-2013.) $)
    shftdm $p |- ( A e. CC -> dom ( F shift A ) =
                  { x e. CC | ( x - A ) e. dom F } ) $=
      ( vy cc wcel cshi co cdm cv cmin wbr wa copab crab shftfval dmeqd wex cab
      19.42v ovex eldm anbi2i bitr4i abbii dmopab df-rab 3eqtr4i syl6eq ) BFGZC
      BHIZJAKZFGZUMBLIZEKCMZNZAEOZJZUOCJGZAFPZUKULURAEBCDQRUQESZATUNUTNZATUSVAV
      BVCAVBUNUPESZNVCUNUPEUAUTVDUNEUOCUMBLUBUCUDUEUFUQAEUGUTAFUHUIUJ $.

    $( Value of a fiber of the relation ` F ` .  (Contributed by Mario
       Carneiro, 4-Nov-2013.) $)
    shftfib $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( F shift A ) " { B } ) = ( F " { ( B - A ) } ) ) $=
      ( vz vx vy cc wcel wa cv co wbr cab cmin csn cima cvv wb wceq copab breqd
      cshi shftfval eleq1 oveq1 breq1d anbi12d breq2 anbi2d eqid brabg sylan9bb
      vex mpan2 ibar adantl bitr4d abbidv imasng ovex mp1i 3eqtr4d ) AHIZBHIZJZ
      BEKZCAUCLZMZENZBAOLZVGCMZENZVHBPQZCVKPQZVFVIVLEVFVIVEVLJZVLVDVIBVGFKZHIZV
      QAOLZGKZCMZJZFGUAZMZVEVPVDVHWCBVGFGACDUDUBVEVGRIWDVPSEUNWBVEVKVTCMZJVPFGB
      VGHRWCVQBTZVRVEWAWEVQBHUEWFVSVKVTCVQBAOUFUGUHVTVGTWEVLVEVTVGVKCUIUJWCUKUL
      UOUMVEVLVPSVDVEVLUPUQURUSVEVNVJTVDEBHVHUTUQVKRIVOVMTVFBAOVAEVKRCUTVBVC $.

    $( Functionality and domain of a sequence shifted by ` A ` .  (Contributed
       by NM, 20-Jul-2005.)  (Revised by Mario Carneiro, 3-Nov-2013.) $)
    shftfn $p |- ( ( F Fn B /\ A e. CC ) ->
                  ( F shift A ) Fn { x e. CC | ( x - A ) e. B } ) $=
      ( vy vz vw wfn cc wcel wa co wfun cdm cv cmin crab wceq wbr cshi wrel wmo
      copab wal relopab a1i fnfun adantr funmo eleq1 oveq1 breq1d anbi12d breq2
      vex anbi2d eqid simprbi moimi syl alrimiv dffun6 sylanbrc shftfval adantl
      brab funeqd mpbird shftdm fndm eleq2d rabbidv sylan9eqr df-fn ) DCIZBJKZL
      ZDBUAMZNZVSOZAPZBQMZCKZAJRZSVSWEIVRVTWBJKZWCFPZDTZLZAFUDZNZVRWJUBZGPZHPZW
      JTZHUCZGUEZWKWLVRWIAFUFUGVRDNZWQVPWRVQCDUHUIWRWPGWRWMBQMZWNDTZHUCWPHWSDUJ
      WOWTHWOWMJKZWTWIXAWSWGDTZLXAWTLAFWMWNWJGUPHUPWBWMSZWFXAWHXBWBWMJUKXCWCWSW
      GDWBWMBQULUMUNWGWNSXBWTXAWGWNWSDUOUQWJURVGUSUTVAVBVAGHWJVCVDVRVSWJVQVSWJS
      VPAFBDEVEVFVHVIVQVPWAWCDOZKZAJRWEABDEVJVPXEWDAJVPXDCWCCDVKVLVMVNVSWEVOVD
      $.

    $( Value of a sequence shifted by ` A ` .  (Contributed by NM,
       20-Jul-2005.)  (Revised by Mario Carneiro, 4-Nov-2013.) $)
    shftval $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( F shift A ) ` B ) = ( F ` ( B - A ) ) ) $=
      ( vx cc wcel wa cv cshi co csn cima cio cfv shftfib eleq2d iotabidv dffv3
      cmin 3eqtr4g ) AFGBFGHZEIZCAJKZBLMZGZENUCCBATKZLMZGZENBUDOUGCOUBUFUIEUBUE
      UHUCABCDPQREBUDSEUGCSUA $.

    $( Value of a sequence shifted by ` A - B ` .  (Contributed by NM,
       20-Jul-2005.)  (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftval2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                ( ( F shift ( A - B ) ) ` ( A + C ) ) = ( F ` ( B + C ) ) ) $=
      ( cc wcel w3a caddc co cmin cshi wceq subcl 3adant3 addcl 3adant2 shftval
      cfv syl2anc pnncan 3com23 addcom 3adant1 eqtr4d fveq2d eqtrd ) AFGZBFGZCF
      GZHZACIJZDABKJZLJSZULUMKJZDSZBCIJZDSUKUMFGZULFGZUNUPMUHUIURUJABNOUHUJUSUI
      ACPQUMULDERTUKUOUQDUKUOCBIJZUQUHUJUIUOUTMACBUAUBUIUJUQUTMUHBCUCUDUEUFUG
      $.

    $( Value of a sequence shifted by ` A - B ` .  (Contributed by NM,
       20-Jul-2005.) $)
    shftval3 $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( F shift ( A - B ) ) ` A ) = ( F ` B ) ) $=
      ( cc wcel wa cc0 caddc co cmin cshi cfv 0cn shftval2 mp3an3 addid1 adantr
      wceq fveq2d adantl 3eqtr3d ) AEFZBEFZGZAHIJZCABKJLJZMZBHIJZCMZAUGMBCMUCUD
      HEFUHUJSNABHCDOPUEUFAUGUCUFASUDAQRTUEUIBCUDUIBSUCBQUATUB $.

    $( Value of a sequence shifted by ` -u A ` .  (Contributed by NM,
       18-Aug-2005.)  (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftval4 $p |- ( ( A e. CC /\ B e. CC ) ->
                ( ( F shift -u A ) ` B ) = ( F ` ( A + B ) ) ) $=
      ( cc wcel wa cneg cshi co cfv cmin caddc wceq negcl shftval subneg ancoms
      sylan addcom eqtr4d fveq2d eqtrd ) AEFZBEFZGZBCAHZIJKZBUGLJZCKZABMJZCKUDU
      GEFUEUHUJNAOUGBCDPSUFUIUKCUFUIBAMJZUKUEUDUIULNBAQRABTUAUBUC $.

    $( Value of a shifted sequence.  (Contributed by NM, 19-Aug-2005.)
       (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftval5 $p |- ( ( A e. CC /\ B e. CC ) ->
                ( ( F shift A ) ` ( B + A ) ) = ( F ` B ) ) $=
      ( cc wcel caddc co cshi cfv wceq wa cmin simpr addcl shftval pncan fveq2d
      syl2anc eqtrd ancoms ) BEFZAEFZBAGHZCAIHJZBCJZKUBUCLZUEUDAMHZCJZUFUGUCUDE
      FUEUIKUBUCNBAOAUDCDPSUGUHBCBAQRTUA $.

    $d y C $.
    $( Functionality of a shifted sequence.  (Contributed by NM, 19-Aug-2005.)
       (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftf $p |- ( ( F : B --> C /\ A e. CC ) ->
          ( F shift A ) : { x e. CC | ( x - A ) e. B } --> C ) $=
      ( vy wf cc wcel wa co cv cmin wfn cfv wceq simpr simpl syl2an cshi shftfn
      crab wral ffn sylan oveq1 elrab shftval ffvelrn eqeltrd sylan2b ralrimiva
      eleq1d ffnfv sylanbrc ) CDEHZBIJZKZEBUALZAMZBNLZCJZAIUCZOZGMZUTPZDJZGVDUD
      VDDUTHUQECOURVECDEUEABCEFUBUFUSVHGVDVFVDJUSVFIJZVFBNLZCJZKZVHVCVKAVFIVAVF
      QVBVJCVAVFBNUGUNUHUSVLKVGVJEPZDUSURVIVGVMQVLUQURRVIVKSBVFEFUITUSUQVKVMDJV
      LUQURSVIVKRCDVJEUJTUKULUMGVDDUTUOUP $.

    $( Composite shift operations.  (Contributed by NM, 19-Aug-2005.)  (Revised
       by Mario Carneiro, 5-Nov-2013.) $)
    2shfti $p |- ( ( A e. CC /\ B e. CC ) -> ( ( F shift A ) shift B ) =
                ( F shift ( A + B ) ) ) $=
      ( vx vy vz vw cc wcel wa cv cmin co cshi wbr copab wb shftfval wceq caddc
      breqd ovex vex eleq1 oveq1 breq1d anbi12d breq2 anbi2d eqid brab ad2antrr
      syl6bb subcl biantrurd ancoms adantll sub32 subsub4 eqtr3d 3expb pm5.32da
      w3a 3bitr2d opabbidv adantl addcl syl 3eqtr4d ) AIJZBIJZKZELZIJZVNBMNZFLZ
      CAONZPZKZEFQZVOVNABUANZMNZVQCPZKZEFQZVRBONZCWBONZVMVTWEEFVMVOVSWDVMVOKZVS
      VPIJZVPAMNZVQCPZKZWLWDVKVSWMRVLVOVKVSVPVQGLZIJZWNAMNZHLZCPZKZGHQZPWMVKVRW
      TVPVQGHACDSUBWSWJWKWQCPZKWMGHVPVQWTVNBMUCFUDWNVPTZWOWJWRXAWNVPIUEXBWPWKWQ
      CWNVPAMUFUGUHWQVQTXAWLWJWQVQWKCUIUJWTUKULUNUMVLVOWLWMRZVKVOVLXCVOVLKWJWLV
      NBUOUPUQURWIWKWCVQCVOVMWKWCTZVOVKVLXDVOVKVLVDVNAMNBMNWKWCVNABUSVNABUTVAVB
      UQUGVEVCVFVLWGWATVKEFBVRCAOUCSVGVMWBIJWHWFTABVHEFWBCDSVIVJ $.

    $( Identity law for the shift operation.  (Contributed by Mario Carneiro,
       5-Nov-2013.) $)
    shftidt2 $p |- ( F shift 0 ) = ( F |` CC ) $=
      ( vx vy cv cc wcel cc0 cmin co wbr copab cshi cres subid1 pm5.32i opabbii
      wa breq1d wceq 0cn shftfval ax-mp dfres2 3eqtr4i ) CEZFGZUFHIJZDEZAKZRZCD
      LZUGUFUIAKZRZCDLAHMJZAFNUKUNCDUGUJUMUGUHUFUIAUFOSPQHFGUOULTUACDHABUBUCCDF
      AUDUE $.

    $( Identity law for the shift operation.  (Contributed by NM,
       19-Aug-2005.)  (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftidt $p |- ( A e. CC -> ( ( F shift 0 ) ` A ) = ( F ` A ) ) $=
      ( cc wcel cc0 cshi co cfv cres shftidt2 fveq1i fvres syl5eq ) ADEABFGHZIA
      BDJZIABIAOPBCKLADBMN $.

    $( Cancellation law for the shift operation.  (Contributed by NM,
       4-Aug-2005.)  (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftcan1 $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( ( F shift A ) shift -u A ) ` B ) = ( F ` B ) ) $=
      ( cc wcel cshi co cneg cfv cc0 caddc wceq negcl 2shfti mpdan negid oveq2d
      eqtrd fveq1d shftidt sylan9eq ) AEFZBEFBCAGHAIZGHZJBCKGHZJBCJUCBUEUFUCUEC
      AUDLHZGHZUFUCUDEFUEUHMANAUDCDOPUCUGKCGAQRSTBCDUAUB $.

    $( Cancellation law for the shift operation.  (Contributed by NM,
       4-Aug-2005.)  (Revised by Mario Carneiro, 5-Nov-2013.) $)
    shftcan2 $p |- ( ( A e. CC /\ B e. CC ) ->
                    ( ( ( F shift -u A ) shift A ) ` B ) = ( F ` B ) ) $=
      ( cc wcel wa cneg cshi co wceq negneg adantr oveq2d fveq1d negcl shftcan1
      cfv sylan eqtr3d ) AEFZBEFZGZBCAHZIJZUDHZIJZRZBUEAIJZRBCRZUCBUGUIUCUFAUEI
      UAUFAKUBALMNOUAUDEFUBUHUJKAPUDBCDQST $.
  $}

  ${
    $d F x y z $.  $d M x y z $.  $d N x y z $.  $d .+ x y z $.
    seqshft.1 $e |- F e. _V $.
    $( Shifting the index set of a sequence.  (Contributed by NM,
       17-Mar-2005.)  (Revised by Mario Carneiro, 27-Feb-2014.) $)
    seqshft $p |- ( ( M e. ZZ /\ N e. ZZ ) -> seq M ( .+ , ( F shift N ) ) =
        ( seq ( M - N ) ( .+ , F ) shift N ) ) $=
      ( vx vy cz wcel wa cuz cfv co cseq cmin wfn cc caddc wceq syl2an vz seqfn
      cshi adantr cv crab zsubcl syl zcn adantl seqex shftfn simpr shftuz npcan
      syl2anc fveq2d eqtrd fneq2d mpbid cneg negsub seqeq1d eluzelz zcnd znegcl
      syl2anr fveq12d ad2antlr cfz wral elfzelz shftval ancoms eqtr4d ralrimiva
      r19.21bi seqshft2 uzssz zsscn sstri sseli 3eqtr4d eqfnfvd ) CHIZDHIZJZUAC
      KLZABDUCMZCNZABCDOMZNZDUCMZWEWJWHPWFAWICUBUDWGWMFUEDOMWKKLZIFQUFZPZWMWHPW
      GWLWNPZDQIZWPWGWKHIZWQCDUGZABWKUBUHWFWRWEDUIZUJZFDWNWLABWKUKZULUPWGWOWHWM
      WGWOWKDRMZKLZWHWGWFWSWOXESWEWFUMWTFDWKUNUPWGXDCKWECQIZWRXDCSWFCUIZXACDUOT
      UQURUSUTWGUAUEZWHIZJZXHDVAZRMZABCXKRMZNZLXHDOMZWLLZXHWJLXHWMLZXJXLXOXNWLX
      JXMWKABWGXMWKSZXIWEXFWRXRWFXGXACDVBTUDVCXIXHQIZWRXLXOSWGXIXHCXHVDVEXBXHDV
      BVGVHXJAGWIBXKCXHWGXIUMWFXKHIWEXIDVFVIXJGUEZWILZXTXKRMZBLZSZGCXHVJMZWFYDG
      YEVKWEXIWFYDGYEWFWRXTQIZYDXTYEIZXAYGXTXTCXHVLVEWRYFJZYAXTDOMZBLYCDXTBEVMY
      HYBYIBYFWRYBYISXTDVBVNUQVOTVPVIVQVRWGWRXSXQXPSXIXBWHQXHWHHQCVSVTWAWBDXHWL
      XCVMTWCWD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Real and imaginary parts; conjugate
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Re $. $( Real part of a complex number. $)
  $c Im $. $( Imaginary part of a complex number. $)
  $c * $. $( Complex conjugate function. $)

  $( Extend class notation to include complex conjugate function. $)
  ccj $a class * $.

  $( Extend class notation to include real part of a complex number. $)
  cre $a class Re $.

  $( Extend class notation to include imaginary part of a complex number. $)
  cim $a class Im $.

  ${
    $d x y $.
    $( Define the complex conjugate function.  See ~ cjcli for its closure and
       ~ cjval for its value.  (Contributed by NM, 9-May-1999.)  (Revised by
       Mario Carneiro, 6-Nov-2013.) $)
    df-cj $a |- * = ( x e. CC |-> ( iota_ y e. CC
                 ( ( x + y ) e. RR /\ ( _i x. ( x - y ) ) e. RR ) ) ) $.

    $( Define a function whose value is the real part of a complex number.  See
       ~ reval for its value, ~ recli for its closure, and ~ replim for its use
       in decomposing a complex number.  (Contributed by NM, 9-May-1999.) $)
    df-re $a |- Re = ( x e. CC |-> ( ( x + ( * ` x ) ) / 2 ) ) $.

    $( Define a function whose value is the imaginary part of a complex
       number.  See ~ imval for its value, ~ imcli for its closure, and
       ~ replim for its use in decomposing a complex number.  (Contributed by
       NM, 9-May-1999.) $)
    df-im $a |- Im = ( x e. CC |-> ( Re ` ( x / _i ) ) ) $.
  $}

  ${
    $d x y A $.
    $( The value of the conjugate of a complex number.  (Contributed by Mario
       Carneiro, 6-Nov-2013.) $)
    cjval $p |- ( A e. CC -> ( * ` A ) = ( iota_ x e. CC
          ( ( A + x ) e. RR /\ ( _i x. ( A - x ) ) e. RR ) ) ) $=
      ( vy cv caddc co cr wcel ci cmin cmul wa cc crio wceq oveq1 eleq1d oveq2d
      ccj anbi12d riotabidv df-cj riotaex fvmpt ) CBCDZADZEFZGHZIUEUFJFZKFZGHZL
      ZAMNBUFEFZGHZIBUFJFZKFZGHZLZAMNMSUEBOZULURAMUSUHUNUKUQUSUGUMGUEBUFEPQUSUJ
      UPGUSUIUOIKUEBUFJPRQTUACAUBURAMUCUD $.

    $( The defining property of the complex conjugate.  (Contributed by Mario
       Carneiro, 6-Nov-2013.) $)
    cjth $p |- ( A e. CC ->
          ( ( A + ( * ` A ) ) e. RR /\ ( _i x. ( A - ( * ` A ) ) ) e. RR ) ) $=
      ( vx cc wcel cv caddc co cr ci cmin cmul ccj cfv wsbc crio syl wceq oveq2
      wa eleq1d wreu cju riotasbc cjval dfsbcq mpbird fvex oveq2d anbi12d sbcie
      wb sylib ) ACDZABEZFGZHDZIAUNJGZKGZHDZSZBALMZNZAVAFGZHDZIAVAJGZKGZHDZSZUM
      VBUTBUTBCOZNZUMUTBCUAVJBAUBUTBCUCPUMVAVIQVBVJUKBAUDUTBVAVIUEPUFUTVHBVAALU
      GUNVAQZUPVDUSVGVKUOVCHUNVAAFRTVKURVFHVKUQVEIKUNVAAJRUHTUIUJUL $.

    $( Domain and codomain of the conjugate function.  (Contributed by Mario
       Carneiro, 6-Nov-2013.) $)
    cjf $p |- * : CC --> CC $=
      ( vx vy cc cv caddc co cr wcel ci cmin cmul wa crio ccj df-cj cju riotacl
      wreu syl fmpti ) ACCADZBDZEFGHIUAUBJFKFGHLZBCMZNABOUACHUCBCRUDCHBUAPUCBCQ
      ST $.

    $( The conjugate of a complex number is a complex number (closure law).
       (Contributed by NM, 10-May-1999.)  (Revised by Mario Carneiro,
       6-Nov-2013.) $)
    cjcl $p |- ( A e. CC -> ( * ` A ) e. CC ) $=
      ( cc ccj cjf ffvelrni ) BBACDE $.

    $( The value of the real part of a complex number.  (Contributed by NM,
       9-May-1999.)  (Revised by Mario Carneiro, 6-Nov-2013.) $)
    reval $p |- ( A e. CC -> ( Re ` A ) = ( ( A + ( * ` A ) ) / 2 ) ) $=
      ( vx cv ccj cfv caddc co c2 cdiv cre wceq fveq2 oveq12 mpdan oveq1d df-re
      cc ovex fvmpt ) BABCZTDEZFGZHIGAADEZFGZHIGQJTAKZUBUDHIUEUAUCKUBUDKTADLTAU
      AUCFMNOBPUDHIRS $.

    $( The value of the imaginary part of a complex number.  (Contributed by
       NM, 9-May-1999.)  (Revised by Mario Carneiro, 6-Nov-2013.) $)
    imval $p |- ( A e. CC -> ( Im ` A ) = ( Re ` ( A / _i ) ) ) $=
      ( vx cv ci cdiv co cre cfv cc cim wceq oveq1 fveq2d df-im fvex fvmpt ) BA
      BCZDEFZGHADEFZGHIJQAKRSGQADELMBNSGOP $.

    $( The imaginary part of a complex number in terms of the real part
       function.  (Contributed by NM, 12-May-2005.)  (Revised by Mario
       Carneiro, 6-Nov-2013.) $)
    imre $p |- ( A e. CC -> ( Im ` A ) = ( Re ` ( -u _i x. A ) ) ) $=
      ( cc wcel cim cfv ci cdiv co cre cneg cmul imval cc0 wne wceq ax-icn ine0
      c1 divrec2 mp3an23 irec oveq1i syl6eq fveq2d eqtrd ) ABCZADEAFGHZIEFJZAKH
      ZIEALUFUGUIIUFUGRFGHZAKHZUIUFFBCFMNUGUKOPQAFSTUJUHAKUAUBUCUDUE $.

    $( The real part of a complex number in terms of the imaginary part
       function.  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    reim $p |- ( A e. CC -> ( Re ` A ) = ( Im ` ( _i x. A ) ) ) $=
      ( cc wcel ci cmul co cim cfv cdiv cre wceq ax-icn mulcl imval syl cc0 wne
      mpan ine0 divcan3 mp3an23 fveq2d eqtr2d ) ABCZDAEFZGHZUEDIFZJHZAJHUDUEBCZ
      UFUHKDBCZUDUILDAMRUENOUDUGAJUDUJDPQUGAKLSADTUAUBUC $.

    $( The real part of a complex number is real.  (Contributed by NM,
       9-May-1999.)  (Revised by Mario Carneiro, 6-Nov-2013.) $)
    recl $p |- ( A e. CC -> ( Re ` A ) e. RR ) $=
      ( cc wcel cre cfv caddc co c2 cdiv cr reval ci cmin cmul simpld rehalfcld
      ccj cjth eqeltrd ) ABCZADEAAQEZFGZHIGJAKTUBTUBJCLAUAMGNGJCAROPS $.

    $( The imaginary part of a complex number is real.  (Contributed by NM,
       9-May-1999.)  (Revised by Mario Carneiro, 6-Nov-2013.) $)
    imcl $p |- ( A e. CC -> ( Im ` A ) e. RR ) $=
      ( cc wcel cim cfv ci cneg cmul co cre cr imre ax-icn negcli mpan recl syl
      mulcl eqeltrd ) ABCZADEFGZAHIZJEZKALTUBBCZUCKCUABCTUDFMNUAAROUBPQS $.

    $( Domain and codomain of the real part function.  (Contributed by Paul
       Chapman, 22-Oct-2007.)  (Revised by Mario Carneiro, 6-Nov-2013.) $)
    ref $p |- Re : CC --> RR $=
      ( vx cc cr cv ccj cfv caddc co c2 cdiv cre df-re wcel reval recl eqeltrrd
      fmpti ) ABCADZREFGHIJHZKALRBMRKFSCRNROPQ $.

    $( Domain and codomain of the imaginary part function.  (Contributed by
       Paul Chapman, 22-Oct-2007.)  (Revised by Mario Carneiro, 6-Nov-2013.) $)
    imf $p |- Im : CC --> RR $=
      ( vx cc cr cv ci cdiv co cre cfv cim df-im wcel imval imcl eqeltrrd fmpti
      ) ABCADZEFGHIZJAKQBLQJIRCQMQNOP $.

    $( The real part of a complex number representation.  Definition 10-3.1 of
       [Gleason] p. 132.  (Contributed by NM, 12-May-2005.)  (Revised by Mario
       Carneiro, 7-Nov-2013.) $)
    crre $p |- ( ( A e. RR /\ B e. RR )
        -> ( Re ` ( A + ( _i x. B ) ) ) = A ) $=
      ( cr wcel ci cmul co caddc c2 cdiv cc ax-icn mulcl sylancr syl addcld a1i
      cmin oveq1d 3eqtr4d cre cfv ccj wceq recn addcl syl2an reval cjcl halfcld
      wa adantr cc0 recl eqeltrrd simpl resubcld adantl subcld pnpcand pnpcan2d
      subdid eqtr4d addsubd subsubd 2timesd oveq2d 2cn 2ne0 divsubdird divcan3d
      wne 3eqtr3d mulassd divassd oveq12d cneg ixi 1re renegcli eqeltri remulcl
      c1 simpr cjth simprd rehalfcld eqeltrd rimul syl2anc subeq0d eqtrd ) ACDZ
      BCDZUKZAEBFGZHGZUAUBZWQWQUCUBZHGZIJGZAWOWQKDZWRXAUDWMAKDZWPKDZXBWNAUEZWNE
      KDZBKDZXDLBUEZEBMZNAWPUFUGZWQUHOZWOXAAWOWTWOWQWSXJWOXBWSKDXJWQUIOZPZUJWMX
      CWNXEULZWOXAARGZCDEXOFGZCDXOUMUDWOXAAWOWRXACXKWOXBWRCDXJWQUNOUOWMWNUPUQWO
      XPEEFGZBFGZEWQWSRGZFGZIJGZRGZCWOEWPXSIJGZRGZFGEWPFGZEYCFGZRGXPYBWOEWPYCXF
      WOLQZWOXFXGXDLWNXGWMXHURZXINZWOXSWOWQWSXJXLUSZUJVBWOXOYDEFWOXAIAFGZIJGZRG
      ZIWPFGZIJGZYCRGZXOYDWOWTYKRGZIJGYNXSRGZIJGYMYPWOYQYRIJWOWTAAHGZRGZWPWPHGZ
      XSRGZYQYRWOWQYSRGZWSHGUUAWQRGZWSHGYTUUBWOUUCUUDWSHWOUUCWPARGUUDWOAWPAXNYI
      XNUTWOWPAWPYIXNYIVAVCSWOWQWSYSXJXLWOAAXNXNPVDWOUUAWQWSWOWPWPYIYIPXJXLVETW
      OYKYSWTRWOAXNVFVGWOYNUUAXSRWOWPYIVFSTSWOWTYKIXMWOIKDZXCYKKDVHXNIAMNUUEWOV
      HQZIUMVLWOVIQZVJWOYNXSIWOUUEXDYNKDVHYIIWPMNYJUUFUUGVJVMWOYLAXARWOAIXNUUFU
      UGVKVGWOYOWPYCRWOWPIYIUUFUUGVKSVMVGWOXRYEYAYFRWOEEBYGYGYHVNWOEXSIYGYJUUFU
      UGVOVPTWOXRYAWOXQCDWNXRCDXQWCVQCVRWCVSVTWAWMWNWDXQBWBNWOXTWOXBXTCDZXJXBWT
      CDUUHWQWEWFOWGUQWHXOWIWJWKWL $.

    $( The real part of a complex number representation.  Definition 10-3.1 of
       [Gleason] p. 132.  (Contributed by NM, 12-May-2005.)  (Revised by Mario
       Carneiro, 7-Nov-2013.) $)
    crim $p |- ( ( A e. RR /\ B e. RR )
        -> ( Im ` ( A + ( _i x. B ) ) ) = B ) $=
      ( cr wcel wa ci cmul co caddc cfv cdiv cre cneg cc wceq recn ax-icn mulcl
      sylancr ine0 cim addcl syl2an imval syl mpan cc0 wne divdir 3expa mpanr12
      sylan2 c1 divrec2 mp3an23 irec oveq1i a1i mulneg12 3eqtrd oveqan12d negcl
      divcan3 addcom sylan 3eqtrrd fveq2d id renegcl crre syl2anr 3eqtr2d ) ACD
      ZBCDZEZAFBGHZIHZUAJZVQFKHZLJZBFAMZGHZIHZLJZBVOVQNDZVRVTOVMANDZVPNDZWEVNAP
      ZVNFNDZBNDZWGQBPZFBRZSAVPUBUCVQUDUEVOWCVSLVMWFWJWCVSOVNWHWKWFWJEVSAFKHZVP
      FKHZIHZWBBIHZWCWJWFWGVSWOOZWIWJWGQWLUFWFWGEWIFUGUHZWQQTWFWGWIWREWQAVPFUIU
      JUKULWFWJWMWBWNBIWFWMUMFKHZAGHZFMZAGHZWBWFWIWRWMWTOQTAFUNUOWTXBOWFWSXAAGU
      PUQURWIWFXBWBOQFAUSUFUTWJWIWRWNBOQTBFVCUOVAWFWBNDZWJWPWCOWFWIWANDXCQAVBFW
      ARSWBBVDVEVFUCVGVNVNWACDWDBOVMVNVHAVIBWAVJVKVL $.

    $( Reconstruct a complex number from its real and imaginary parts.
       (Contributed by NM, 10-May-1999.)  (Revised by Mario Carneiro,
       7-Nov-2013.) $)
    replim $p |- ( A e. CC -> A = ( ( Re ` A ) + ( _i x. ( Im ` A ) ) ) ) $=
      ( vx vy cc wcel cv ci cmul co caddc wceq cr wrex cre cfv cim cnre oveq12d
      oveq2d fveq2 wa crre crim eqcomd id eqeq12d syl5ibrcom rexlimivv syl ) AD
      EABFZGCFZHIZJIZKZCLMBLMAANOZGAPOZHIZJIZKZBCAQUNUSBCLLUJLEUKLEUAZUSUNUMUMN
      OZGUMPOZHIZJIZKUTVDUMUTVAUJVCULJUJUKUBUTVBUKGHUJUKUCSRUDUNAUMURVDUNUEUNUO
      VAUQVCJAUMNTUNUPVBGHAUMPTSRUFUGUHUI $.

    $( Value of the conjugate of a complex number.  The value is the real part
       minus ` _i ` times the imaginary part.  Definition 10-3.2 of [Gleason]
       p. 132.  (Contributed by NM, 10-May-1999.)  (Revised by Mario Carneiro,
       7-Nov-2013.) $)
    remim $p |- ( A e. CC ->
                      ( * ` A ) = ( ( Re ` A ) - ( _i x. ( Im ` A ) ) ) ) $=
      ( vx cc wcel caddc co cr ci cmin cmul wa wceq oveq1d recnd ax-icn sylancr
      cfv eqtrd readdcld eqeltrd ccj cv crio cre cjval replim recl imcl ppncand
      cim mulcl pnncand a1i adddid 3eqtr4d oveq2d mulass mp3an12 eqtr4d c1 cneg
      syl ixi 1re renegcli eqeltri remulcl wreu subcld cju oveq2 eleq1d anbi12d
      wb riota2 syl2anc mpbi2and ) ACDZAUAQABUBZEFZGDZHAVSIFZJFZGDZKZBCUCZAUDQZ
      HAUJQZJFZIFZBAUEVRAWJEFZGDZHAWJIFZJFZGDZWFWJLZVRWKWGWGEFZGVRWKWGWIEFZWJEF
      WQVRAWRWJEAUFZMVRWGWIWGVRWGAUGZNZVRHCDZWHCDWICDOVRWHAUHZNZHWHUKPZXAUIRVRW
      GWGWTWTSTVRWNHHJFZWHWHEFZJFZGVRWNHHXGJFZJFZXHVRWMXIHJVRWRWJIFWIWIEFWMXIVR
      WGWIWIXAXEXEULVRAWRWJIWSMVRHWHWHXBVROUMXDXDUNUOUPVRXGCDZXHXJLZVRXGVRWHWHX
      CXCSZNXBXBXKXLOOHHXGUQURVBUSVRXFGDXGGDXHGDXFUTVAGVCUTVDVEVFXMXFXGVGPTVRWJ
      CDWEBCVHWLWOKZWPVNVRWGWIXAXEVIBAVJWEXNBCWJVSWJLZWAWLWDWOXOVTWKGVSWJAEVKVL
      XOWCWNGXOWBWMHJVSWJAIVKUPVLVMVOVPVQR $.
  $}

  $( The imaginary part of a real number is 0.  (Contributed by NM,
     18-Mar-2005.)  (Revised by Mario Carneiro, 7-Nov-2013.) $)
  reim0 $p |- ( A e. RR -> ( Im ` A ) = 0 ) $=
    ( cr wcel ci cc0 cmul co caddc cim cc wceq recn ax-icn mul01i oveq2i addid1
    cfv syl5eq syl fveq2d 0re crim mpan2 eqtr3d ) ABCZADEFGZHGZIQZAIQEUEUGAIUEA
    JCZUGAKALUIUGAEHGAUFEAHDMNOAPRSTUEEBCUHEKUAAEUBUCUD $.

  $( A number is real iff its imaginary part is 0.  (Contributed by NM,
     26-Sep-2005.) $)
  reim0b $p |- ( A e. CC -> ( A e. RR <-> ( Im ` A ) = 0 ) ) $=
    ( cc wcel cr cim cfv cc0 wceq reim0 wa ci cmul co caddc replim adantr oveq2
    cre ax-icn mul01i syl6eq recl recnd addid1d sylan9eqr eqtrd eqeltrd impbid2
    oveq2d ex ) ABCZADCZAEFZGHZAIUKUNULUKUNJZAARFZDUOAUPKUMLMZNMZUPUKAURHUNAOPU
    NUKURUPGNMUPUNUQGUPNUNUQKGLMGUMGKLQKSTUAUIUKUPUKUPAUBZUCUDUEUFUKUPDCUNUSPUG
    UJUH $.

  $( A number is real iff it equals its real part.  Proposition 10-3.4(f) of
     [Gleason] p. 133.  (Contributed by NM, 20-Aug-2008.) $)
  rereb $p |- ( A e. CC -> ( A e. RR <-> ( Re ` A ) = A ) ) $=
    ( cc wcel cr cre cfv wceq wa ci cim co caddc cc0 replim adantr reim0 oveq2d
    cmul ax-icn mul01i syl6eq recl recnd addid1d 3eqtrrd simpr eqeltrrd impbida
    adantl ) ABCZADCZAEFZAGZUJUKHZAULIAJFZRKZLKZULMLKZULUJAUQGUKANOUNUPMULLUKUP
    MGUJUKUPIMRKMUKUOMIRAPQISTUAUIQUJURULGUKUJULUJULAUBZUCUDOUEUJUMHULADUJUMUFU
    JULDCUMUSOUGUH $.

  $( A product with a nonzero real multiplier is real iff the multiplicand is
     real.  (Contributed by NM, 21-Aug-2008.) $)
  mulre $p |- ( ( A e. CC /\ B e. RR /\ B =/= 0 )
         -> ( A e. RR <-> ( B x. A ) e. RR ) ) $=
    ( cc wcel cr cre cfv wceq co wb rereb 3ad2ant1 wa recnd caddc adantl ax-icn
    cmul ci mulcl cc0 wne w3a recl simp1 recn anim1i 3adant1 mulcan syl3anc cim
    adantr imcl sylancr adddid replim oveq2d mul12 mp3an1 syl2an 3eqtr4d fveq2d
    remulcl sylan2 crre syl2anc eqtr2d eqeq1d syl bitr4d ancoms 3adant3 3bitr2d
    sylan ) ACDZBEDZBUAUBZUCZAEDZAFGZAHZBVTRIZBARIZHZWCEDZVOVPVSWAJVQAKLVRVTCDZ
    VOBCDZVQMZWDWAJVOVPWFVQVOVTAUDZNZLVOVPVQUEVPVQWHVOVPWGVQBUFZUGUHVTABUIUJVOV
    PWDWEJZVQVPVOWLVPVOMZWDWCFGZWCHZWEWMWBWNWCWMWNWBSBAUKGZRIZRIZOIZFGZWBWMWCWS
    FWMBVTSWPRIZOIZRIWBBXARIZOIWCWSWMBVTXAVPWGVOWKULVOWFVPWJPVOXACDZVPVOSCDZWPC
    DZXDQVOWPAUMZNZSWPTUNPUOWMAXBBRVOAXBHVPAUPPUQWMWRXCWBOVPWGXFWRXCHZVOWKXHXEW
    GXFXIQSBWPURUSUTUQVAVBWMWBEDZWQEDZWTWBHVOVPVTEDXJWIBVTVCVDVOVPWPEDXKXGBWPVC
    VDWBWQVEVFVGVHWMWCCDZWEWOJVPWGVOXLWKBATVNWCKVIVJVKVLVM $.

  $( A real number equals its real part.  One direction of Proposition
     10-3.4(f) of [Gleason] p. 133.  (Contributed by Paul Chapman,
     7-Sep-2007.) $)
  rere $p |- ( A e. RR -> ( Re ` A ) = A ) $=
    ( cr wcel cre cfv wceq cc wb recn rereb syl ibi ) ABCZADEAFZMAGCMNHAIAJKL
    $.

  $( A number is real iff it equals its complex conjugate.  Proposition
     10-3.4(f) of [Gleason] p. 133.  (Contributed by NM, 2-Jul-2005.)  (Revised
     by Mario Carneiro, 14-Jul-2014.) $)
  cjreb $p |- ( A e. CC -> ( A e. RR <-> ( * ` A ) = A ) ) $=
    ( cc wcel ccj cfv wceq cre ci cneg cmul co caddc cr cmin recnd ax-icn mulcl
    cim sylancr cc0 negsubd mulneg2 oveq2d remim 3eqtr4rd replim eqeq12d negcld
    recl imcl addcand eqcom eqnegd syl5bb wne wa ine0 pm3.2i a1i mulcan syl3anc
    wb reim0b 3bitr4d 3bitrrd ) ABCZADEZAFAGEZHAREZIZJKZLKZVHHVIJKZLKZFVKVMFZAM
    CZVFVGVLAVNVFVHVMIZLKVHVMNKVLVGVFVHVMVFVHAUIOZVFHBCZVIBCZVMBCPVFVIAUJOZHVIQ
    SZUAVFVKVQVHLVFVSVTVKVQFPWAHVIUBSUCAUDUEAUFUGVFVHVKVMVRVFVSVJBCZVKBCPVFVIWA
    UHZHVJQSWBUKVFVJVIFZVITFZVOVPWEVIVJFVFWFVJVIULVFVIWAUMUNVFWCVTVSHTUOZUPZVOW
    EVBWDWAWHVFVSWGPUQURUSVJVIHUTVAAVCVDVE $.

  $( Real part of a complex conjugate.  (Contributed by Mario Carneiro,
     14-Jul-2014.) $)
  recj $p |- ( A e. CC -> ( Re ` ( * ` A ) ) = ( Re ` A ) ) $=
    ( cc wcel ccj cfv cre ci cim cneg cmul co caddc cmin recl recnd ax-icn imcl
    sylancr wceq cr mulcl negsubd mulneg2 oveq2d remim 3eqtr4rd fveq2d renegcld
    crre syl2anc eqtrd ) ABCZADEZFEAFEZGAHEZIZJKZLKZFEZUNULUMURFULUNGUOJKZIZLKU
    NUTMKURUMULUNUTULUNANZOULGBCZUOBCZUTBCPULUOAQZOZGUOUARUBULUQVAUNLULVCVDUQVA
    SPVFGUOUCRUDAUEUFUGULUNTCUPTCUSUNSVBULUOVEUHUNUPUIUJUK $.

  $( Real part of negative.  (Contributed by NM, 17-Mar-2005.)  (Revised by
     Mario Carneiro, 14-Jul-2014.) $)
  reneg $p |- ( A e. CC -> ( Re ` -u A ) = -u ( Re ` A ) ) $=
    ( cc wcel cneg cre cfv ci cim cmul co caddc recl recnd ax-icn mulcl sylancr
    imcl wceq cr renegcld negdid replim negeqd mulneg2 oveq2d fveq2d crre eqtrd
    3eqtr4d syl2anc ) ABCZADZEFAEFZDZGAHFZDZIJZKJZEFZUNUKULUREUKUMGUOIJZKJZDUNU
    TDZKJULURUKUMUTUKUMALZMUKGBCZUOBCZUTBCNUKUOAQZMZGUOOPUAUKAVAAUBUCUKUQVBUNKU
    KVDVEUQVBRNVGGUOUDPUEUIUFUKUNSCUPSCUSUNRUKUMVCTUKUOVFTUNUPUGUJUH $.

  $( Real part distributes over addition.  (Contributed by NM, 17-Mar-2005.)
     (Revised by Mario Carneiro, 14-Jul-2014.) $)
  readd $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Re ` ( A + B ) ) = ( ( Re ` A ) + ( Re ` B ) ) ) $=
    ( cc wcel caddc co cre cfv ci cmul cr recl adantr recnd ax-icn imcl sylancr
    cim mulcl adantl wa add4d replim oveqan12d a1i adddid oveq2d 3eqtr4d fveq2d
    wceq readdcl syl2an crre syl2anc eqtrd ) ACDZBCDZUAZABEFZGHAGHZBGHZEFZIARHZ
    BRHZEFZJFZEFZGHZVBURUSVGGURUTIVCJFZEFZVAIVDJFZEFZEFVBVIVKEFZEFUSVGURUTVIVAV
    KURUTUPUTKDZUQALZMNURICDZVCCDVICDOURVCUPVCKDZUQAPZMNZIVCSQURVAUQVAKDZUPBLZT
    NURVPVDCDVKCDOURVDUQVDKDZUPBPZTNZIVDSQUBUPUQAVJBVLEAUCBUCUDURVFVMVBEURIVCVD
    VPUROUEVSWDUFUGUHUIURVBKDZVEKDZVHVBUJUPVNVTWEUQVOWAUTVAUKULUPVQWBWFUQVRWCVC
    VDUKULVBVEUMUNUO $.

  $( Real part distributes over subtraction.  (Contributed by NM,
     17-Mar-2005.) $)
  resub $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Re ` ( A - B ) ) = ( ( Re ` A ) - ( Re ` B ) ) ) $=
    ( cc wcel wa cneg caddc cre cfv cmin negcl readd sylan2 reneg adantl negsub
    co wceq recl recnd oveq2d eqtrd fveq2d syl2an 3eqtr3d ) ACDZBCDZEZABFZGQZHI
    ZAHIZBHIZFZGQZABJQZHIULUMJQZUHUKULUIHIZGQZUOUGUFUICDUKUSRBKAUILMUHURUNULGUG
    URUNRUFBNOUAUBUHUJUPHABPUCUFULCDUMCDUOUQRUGUFULASTUGUMBSTULUMPUDUE $.

  $( Lemma for ~ remul , ~ immul , and ~ cjmul .  (Contributed by NM,
     28-Jul-1999.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  remullem $p |- ( ( A e. CC /\ B e. CC ) ->
    ( ( Re ` ( A x. B ) ) =
        ( ( ( Re ` A ) x. ( Re ` B ) ) - ( ( Im ` A ) x. ( Im ` B ) ) ) /\
      ( Im ` ( A x. B ) ) =
        ( ( ( Re ` A ) x. ( Im ` B ) ) + ( ( Im ` A ) x. ( Re ` B ) ) ) /\
      ( * ` ( A x. B ) ) = ( ( * ` A ) x. ( * ` B ) ) ) ) $=
    ( cc wcel cmul co cre cfv cim cmin wceq caddc ci recnd ax-icn mulcl sylancr
    cr oveq12d remulcld wa ccj replim oveqan12d recl adantr imcl addcld adddird
    adantl adddid mulcld add42d cneg mul4d c1 oveq1i mulm1d syl5eq eqtrd oveq2d
    a1i negsubd addcomd mulassd mul12d 3eqtr4d 3eqtr2d 3eqtrd resubcld readdcld
    ixi fveq2d crre syl2anc crim syl subcld subdird subadd4d subdid eqtr4d 3jca
    remim ) ACDZBCDZUAZABEFZGHZAGHZBGHZEFZAIHZBIHZEFZJFZKWHIHZWJWNEFZWMWKEFZLFZ
    KWHUBHZAUBHZBUBHZEFZKWGWIWPMWTEFZLFZGHZWPWGWHXFGWGWHWJMWMEFZLFZWKMWNEFZLFZE
    FXIWKEFZXIXJEFZLFZXFWEWFAXIBXKEAUCBUCUDWGXIWKXJWGWJXHWGWJWEWJRDWFAUEUFZNZWG
    MCDZWMCDXHCDOWGWMWEWMRDWFAUGUFZNZMWMPQZUHWGWKWFWKRDWEBUEUJZNZWGXQWNCDXJCDOW
    GWNWFWNRDWEBUGUJZNZMWNPQZUKWGXNWLXHWKEFZLFZWJXJEFZXHXJEFZLFZLFWLYILFZYFYHLF
    ZLFXFWGXLYGXMYJLWGWJXHWKXPXTYBUIWGWJXHXJXPXTYEUISWGWLYIYFYHWGWLWGWJWKXOYATZ
    NZWGXHXJXTYEULZWGXHWKXTYBULZWGWJXJXPYEULZUMWGYKWPYLXELWGYKWLWOUNZLFWPWGYIYR
    WLLWGYIMMEFZWOEFZYRWGMWMMWNXQWGOVBZXSUUAYDUOWGYTUPUNZWOEFYRYSUUBWOEVLUQWGWO
    WGWOWGWMWNXRYCTZNZURUSUTVAWGWLWOYNUUDVCUTZWGMWSEFZMWREFZLFUUGUUFLFZYLXEWGUU
    FUUGWGXQWSCDUUFCDOWGWSWGWMWKXRYATZNZMWSPQWGXQWRCDUUGCDOWGWRWGWJWNXOYCTZNZMW
    RPQVDWGYFUUFYHUUGLWGMWMWKUUAXSYBVEZWGWJMWNXPUUAYDVFZSWGMWRWSUUAUULUUJUKZVGS
    VHVIZVMZWGWPRDZWTRDZXGWPKWGWLWOYMUUCVJZWGWRWSUUKUUIVKZWPWTVNVOZUTWGWQXFIHZW
    TWGWHXFIUUPVMWGUURUUSUVCWTKUUTUVAWPWTVPVOUTZWGXAWIMWQEFZJFZXDWGWHCDXAUVFKAB
    PWHWDVQWGXDWJXHJFZWKXJJFZEFWJUVHEFZXHUVHEFZJFZUVFWEWFXBUVGXCUVHEAWDBWDUDWGW
    JXHUVHXPXTWGWKXJYBYEVRVSWGWLYHJFZYFYIJFZJFYKYHYFLFZJFUVKUVFWGWLYHYFYIYNYQYP
    YOVTWGUVIUVLUVJUVMJWGWJWKXJXPYBYEWAWGXHWKXJXTYBYEWASWGWIYKUVEUVNJWGXGWPWIYK
    UVBUUQUUEVGWGXEUUHUVEUVNUUOWGWQWTMEUVDVAWGYHUUGYFUUFLUUNUUMSVGSVGVIWBWC $.

  $( Real part of a product.  (Contributed by NM, 28-Jul-1999.)  (Revised by
     Mario Carneiro, 14-Jul-2014.) $)
  remul $p |- ( ( A e. CC /\ B e. CC ) -> ( Re ` ( A x. B ) ) =
           ( ( ( Re ` A ) x. ( Re ` B ) ) - ( ( Im ` A ) x. ( Im ` B ) ) ) ) $=
    ( cc wcel wa cmul co cre cfv cim cmin wceq caddc ccj remullem simp1d ) ACDB
    CDEABFGZHIAHIZBHIZFGAJIZBJIZFGKGLQJIRUAFGTSFGMGLQNIANIBNIFGLABOP $.

  $( Real part of a product.  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  remul2 $p |- ( ( A e. RR /\ B e. CC ) ->
                 ( Re ` ( A x. B ) ) = ( A x. ( Re ` B ) ) ) $=
    ( cr wcel cc wa cmul cre cfv cim cmin cc0 wceq recn remul sylan rere oveq1d
    co recnd adantr reim0 imcl mul02d sylan9eq oveq12d recl mulcl syl2an 3eqtrd
    subid1d ) ACDZBEDZFZABGSHIZAHIZBHIZGSZAJIZBJIZGSZKSZAUQGSZLKSVCULAEDZUMUOVB
    MANZABOPUNURVCVALKUNUPAUQGULUPAMUMAQUARULUMVALUTGSLULUSLUTGAUBRUMUTUMUTBUCT
    UDUEUFUNVCULVDUQEDVCEDUMVEUMUQBUGTAUQUHUIUKUJ $.

  $( Real part of a division.  Related to ~ remul2 .  (Contributed by David A.
     Wheeler, 10-Jun-2015.) $)
  rediv $p |- ( ( A e. CC /\ B e. RR /\ B =/= 0 ) ->
              ( Re ` ( A / B ) ) = ( ( Re ` A ) / B ) ) $=
    ( cc wcel cr cc0 wne w3a c1 cdiv co cmul cre cfv wceq 3anass bitr4i rereccl
    wa ancom anim1i sylbir remul2 syl recn divrec2 fveq2d syl3an2 recl 3ad2ant1
    recnd 3ad2ant2 simp3 divrec2d 3eqtr4d ) ACDZBEDZBFGZHZIBJKZALKZMNZUTAMNZLKZ
    ABJKZMNZVCBJKUSUTEDZUPSZVBVDOUSUQURSZUPSZVHVJUPVISUSVIUPTUPUQURPQVIVGUPBRUA
    UBUTAUCUDUQUPBCDZURVFVBOBUEZUPVKURHVEVAMABUFUGUHUSVCBUPUQVCCDURUPVCAUIUKUJU
    QUPVKURVLULUPUQURUMUNUO $.

  $( Imaginary part of a complex conjugate.  (Contributed by NM, 18-Mar-2005.)
     (Revised by Mario Carneiro, 14-Jul-2014.) $)
  imcj $p |- ( A e. CC -> ( Im ` ( * ` A ) ) = -u ( Im ` A ) ) $=
    ( cc wcel ccj cfv cim cre ci cneg cmul co caddc cmin recl recnd ax-icn imcl
    sylancr wceq cr mulcl negsubd mulneg2 oveq2d remim 3eqtr4rd fveq2d renegcld
    crim syl2anc eqtrd ) ABCZADEZFEAGEZHAFEZIZJKZLKZFEZUPULUMURFULUNHUOJKZIZLKU
    NUTMKURUMULUNUTULUNANZOULHBCZUOBCZUTBCPULUOAQZOZHUOUARUBULUQVAUNLULVCVDUQVA
    SPVFHUOUCRUDAUEUFUGULUNTCUPTCUSUPSVBULUOVEUHUNUPUIUJUK $.

  $( The imaginary part of a negative number.  (Contributed by NM,
     18-Mar-2005.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  imneg $p |- ( A e. CC -> ( Im ` -u A ) = -u ( Im ` A ) ) $=
    ( cc wcel cneg cim cfv cre ci cmul co caddc recl recnd ax-icn mulcl sylancr
    imcl wceq cr renegcld negdid replim negeqd mulneg2 oveq2d fveq2d crim eqtrd
    3eqtr4d syl2anc ) ABCZADZEFAGFZDZHAEFZDZIJZKJZEFZUPUKULUREUKUMHUOIJZKJZDUNU
    TDZKJULURUKUMUTUKUMALZMUKHBCZUOBCZUTBCNUKUOAQZMZHUOOPUAUKAVAAUBUCUKUQVBUNKU
    KVDVEUQVBRNVGHUOUDPUEUIUFUKUNSCUPSCUSUPRUKUMVCTUKUOVFTUNUPUGUJUH $.

  $( Imaginary part distributes over addition.  (Contributed by NM,
     18-Mar-2005.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  imadd $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Im ` ( A + B ) ) = ( ( Im ` A ) + ( Im ` B ) ) ) $=
    ( cc wcel caddc co cim cfv ci cmul cr recl adantr recnd ax-icn imcl sylancr
    cre mulcl adantl wa add4d replim oveqan12d a1i adddid oveq2d 3eqtr4d fveq2d
    wceq readdcl syl2an crim syl2anc eqtrd ) ACDZBCDZUAZABEFZGHARHZBRHZEFZIAGHZ
    BGHZEFZJFZEFZGHZVEURUSVGGURUTIVCJFZEFZVAIVDJFZEFZEFVBVIVKEFZEFUSVGURUTVIVAV
    KURUTUPUTKDZUQALZMNURICDZVCCDVICDOURVCUPVCKDZUQAPZMNZIVCSQURVAUQVAKDZUPBLZT
    NURVPVDCDVKCDOURVDUQVDKDZUPBPZTNZIVDSQUBUPUQAVJBVLEAUCBUCUDURVFVMVBEURIVCVD
    VPUROUEVSWDUFUGUHUIURVBKDZVEKDZVHVEUJUPVNVTWEUQVOWAUTVAUKULUPVQWBWFUQVRWCVC
    VDUKULVBVEUMUNUO $.

  $( Imaginary part distributes over subtraction.  (Contributed by NM,
     18-Mar-2005.) $)
  imsub $p |- ( ( A e. CC /\ B e. CC ) ->
              ( Im ` ( A - B ) ) = ( ( Im ` A ) - ( Im ` B ) ) ) $=
    ( cc wcel wa cneg caddc cim cfv cmin negcl imadd sylan2 imneg adantl negsub
    co wceq imcl recnd oveq2d eqtrd fveq2d syl2an 3eqtr3d ) ACDZBCDZEZABFZGQZHI
    ZAHIZBHIZFZGQZABJQZHIULUMJQZUHUKULUIHIZGQZUOUGUFUICDUKUSRBKAUILMUHURUNULGUG
    URUNRUFBNOUAUBUHUJUPHABPUCUFULCDUMCDUOUQRUGUFULASTUGUMBSTULUMPUDUE $.

  $( Imaginary part of a product.  (Contributed by NM, 28-Jul-1999.)  (Revised
     by Mario Carneiro, 14-Jul-2014.) $)
  immul $p |- ( ( A e. CC /\ B e. CC ) -> ( Im ` ( A x. B ) ) =
           ( ( ( Re ` A ) x. ( Im ` B ) ) + ( ( Im ` A ) x. ( Re ` B ) ) ) ) $=
    ( cc wcel wa cmul co cre cfv cim cmin wceq caddc ccj remullem simp2d ) ACDB
    CDEABFGZHIAHIZBHIZFGAJIZBJIZFGKGLQJIRUAFGTSFGMGLQNIANIBNIFGLABOP $.

  $( Imaginary part of a product.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  immul2 $p |- ( ( A e. RR /\ B e. CC ) ->
                 ( Im ` ( A x. B ) ) = ( A x. ( Im ` B ) ) ) $=
    ( cr wcel cc wa cmul co cim cfv cre caddc wceq recn immul sylan rere oveq1d
    cc0 recnd adantr reim0 recl mul02d oveq12d imcl mulcl syl2an addid1d 3eqtrd
    sylan9eq ) ACDZBEDZFZABGHIJZAKJZBIJZGHZAIJZBKJZGHZLHZAUQGHZSLHVCULAEDZUMUOV
    BMANZABOPUNURVCVASLUNUPAUQGULUPAMUMAQUARULUMVASUTGHSULUSSUTGAUBRUMUTUMUTBUC
    TUDUKUEUNVCULVDUQEDVCEDUMVEUMUQBUFTAUQUGUHUIUJ $.

  $( Imaginary part of a division.  Related to ~ immul2 .  (Contributed by
     Mario Carneiro, 20-Jun-2015.) $)
  imdiv $p |- ( ( A e. CC /\ B e. RR /\ B =/= 0 ) ->
              ( Im ` ( A / B ) ) = ( ( Im ` A ) / B ) ) $=
    ( cc wcel cr cc0 wne w3a c1 cdiv co cmul cim cfv wceq 3anass bitr4i rereccl
    wa ancom anim1i sylbir immul2 syl recn divrec2 fveq2d syl3an2 imcl 3ad2ant1
    recnd 3ad2ant2 simp3 divrec2d 3eqtr4d ) ACDZBEDZBFGZHZIBJKZALKZMNZUTAMNZLKZ
    ABJKZMNZVCBJKUSUTEDZUPSZVBVDOUSUQURSZUPSZVHVJUPVISUSVIUPTUPUQURPQVIVGUPBRUA
    UBUTAUCUDUQUPBCDZURVFVBOBUEZUPVKURHVEVAMABUFUGUHUSVCBUPUQVCCDURUPVCAUIUKUJU
    QUPVKURVLULUPUQURUMUNUO $.

  $( A real number equals its complex conjugate.  Proposition 10-3.4(f) of
     [Gleason] p. 133.  (Contributed by NM, 8-Oct-1999.) $)
  cjre $p |- ( A e. RR -> ( * ` A ) = A ) $=
    ( cc wcel cr ccj cfv wceq recn cjreb biimpd mpcom ) ABCZADCZAEFAGZAHLMNAIJK
    $.

  $( The conjugate of the conjugate is the original complex number.
     Proposition 10-3.4(e) of [Gleason] p. 133.  (Contributed by NM,
     29-Jul-1999.)  (Proof shortened by Mario Carneiro, 14-Jul-2014.) $)
  cjcj $p |- ( A e. CC -> ( * ` ( * ` A ) ) = A ) $=
    ( cc wcel ccj cfv cre ci cim cmul co caddc wceq cjcl recj eqtrd cneg negeqd
    syl imcj replim imcl recnd negnegd oveq2d oveq12d 3syl 3eqtr4d ) ABCZADEZDE
    ZFEZGUJHEZIJZKJZAFEZGAHEZIJZKJUJAUHUKUOUMUQKUHUKUIFEZUOUHUIBCZUKURLAMZUINRA
    NOUHULUPGIUHULUIHEZPZUPUHUSULVBLUTUISRUHVBUPPZPUPUHVAVCASQUHUPUHUPAUAUBUCOO
    UDUEUHUSUJBCUJUNLUTUIMUJTUFATUG $.

  $( Complex conjugate distributes over addition.  Proposition 10-3.4(a) of
     [Gleason] p. 133.  (Contributed by NM, 31-Jul-1999.)  (Revised by Mario
     Carneiro, 14-Jul-2014.) $)
  cjadd $p |- ( ( A e. CC /\ B e. CC ) ->
                   ( * ` ( A + B ) ) = ( ( * ` A ) + ( * ` B ) ) ) $=
    ( cc wcel caddc co cre cfv ci cim cmul cmin ccj ax-icn cr imcl adantr recnd
    adantl remim readd imadd oveq2d a1i adddid eqtrd oveq12d recl mulcl sylancr
    wa addsub4d wceq addcl syl oveqan12d 3eqtr4d ) ACDZBCDZUKZABEFZGHZIVAJHZKFZ
    LFZAGHZIAJHZKFZLFZBGHZIBJHZKFZLFZEFZVAMHZAMHZBMHZEFUTVEVFVJEFZVHVLEFZLFVNUT
    VBVRVDVSLABUAUTVDIVGVKEFZKFVSUTVCVTIKABUBUCUTIVGVKICDZUTNUDUTVGURVGODUSAPQR
    ZUTVKUSVKODURBPSRZUEUFUGUTVFVJVHVLUTVFURVFODUSAUHQRUTVJUSVJODURBUHSRUTWAVGC
    DVHCDNWBIVGUIUJUTWAVKCDVLCDNWCIVKUIUJULUFUTVACDVOVEUMABUNVATUOURUSVPVIVQVME
    ATBTUPUQ $.

  $( Complex conjugate distributes over multiplication.  Proposition 10-3.4(c)
     of [Gleason] p. 133.  (Contributed by NM, 29-Jul-1999.)  (Proof shortened
     by Mario Carneiro, 14-Jul-2014.) $)
  cjmul $p |- ( ( A e. CC /\ B e. CC ) ->
                   ( * ` ( A x. B ) ) = ( ( * ` A ) x. ( * ` B ) ) ) $=
    ( cc wcel wa cmul co cre cfv cim cmin wceq caddc ccj remullem simp3d ) ACDB
    CDEABFGZHIAHIZBHIZFGAJIZBJIZFGKGLQJIRUAFGTSFGMGLQNIANIBNIFGLABOP $.

  $( Standard inner product on complex numbers.  (Contributed by NM,
     29-Jul-1999.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  ipcnval $p |- ( ( A e. CC /\ B e. CC ) -> ( Re ` ( A x. ( * ` B ) ) ) =
           ( ( ( Re ` A ) x. ( Re ` B ) ) + ( ( Im ` A ) x. ( Im ` B ) ) ) ) $=
    ( cc wcel wa cfv cmul co cre cmin cneg wceq adantl oveq2d imcl recnd syl2an
    cim recl mulcl ccj caddc cjcl remul recj imcj mulneg2 eqtrd oveq12d subnegd
    sylan2 3eqtrd ) ACDZBCDZEZABUAFZGHIFZAIFZUPIFZGHZARFZUPRFZGHZJHZURBIFZGHZVA
    BRFZGHZKZJHVFVHUBHUNUMUPCDUQVDLBUCAUPUDUKUOUTVFVCVIJUOUSVEURGUNUSVELUMBUEMN
    UOVCVAVGKZGHZVIUOVBVJVAGUNVBVJLUMBUFMNUMVACDZVGCDZVKVILUNUMVAAOPZUNVGBOPZVA
    VGUGQUHUIUOVFVHUMURCDVECDVFCDUNUMURASPUNVEBSPURVETQUMVLVMVHCDUNVNVOVAVGTQUJ
    UL $.

  $( A complex number times its conjugate is real.  (Contributed by NM,
     26-Mar-2005.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  cjmulrcl $p |- ( A e. CC -> ( A x. ( * ` A ) ) e. RR ) $=
    ( cc wcel ccj cfv cmul co cr wceq cjcj oveq2d cjmul mpdan mulcom 3eqtr4d wb
    cjcl mulcl cjreb syl mpbird ) ABCZAADEZFGZHCZUDDEZUDIZUBUCUCDEZFGZUCAFGZUFU
    DUBUHAUCFAJKUBUCBCZUFUIIAQZAUCLMUBUKUDUJIULAUCNMOUBUDBCZUEUGPUBUKUMULAUCRMU
    DSTUA $.

  $( A complex number times its conjugate.  (Contributed by NM, 1-Feb-2007.)
     (Revised by Mario Carneiro, 14-Jul-2014.) $)
  cjmulval $p |- ( A e. CC -> ( A x. ( * ` A ) ) =
                 ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
    ( cc wcel cre cfv c2 cexp cim caddc cmul ccj recl recnd sqvald imcl oveq12d
    co wceq ipcnval anidms cr cjmulrcl rere syl 3eqtr2rd ) ABCZADEZFGQZAHEZFGQZ
    IQUGUGJQZUIUIJQZIQZAAKEJQZDEZUNUFUHUKUJULIUFUGUFUGALMNUFUIUFUIAOMNPUFUOUMRA
    ASTUFUNUACUOUNRAUBUNUCUDUE $.

  $( A complex number times its conjugate is nonnegative.  (Contributed by NM,
     26-Mar-2005.)  (Revised by Mario Carneiro, 14-Jul-2014.) $)
  cjmulge0 $p |- ( A e. CC -> 0 <_ ( A x. ( * ` A ) ) ) $=
    ( cc wcel cc0 cre cfv c2 cexp co cim caddc ccj cmul cle recl resqcld sqge0d
    imcl addge0d cjmulval breqtrrd ) ABCZDAEFZGHIZAJFZGHIZKIAALFMINUBUDUFUBUCAO
    ZPUBUEARZPUBUCUGQUBUEUHQSATUA $.

  $( Complex conjugate of negative.  (Contributed by NM, 27-Feb-2005.)
     (Revised by Mario Carneiro, 14-Jul-2014.) $)
  cjneg $p |- ( A e. CC -> ( * ` -u A ) = -u ( * ` A ) ) $=
    ( cc wcel cneg cre cfv ci cim cmul co cmin ccj recl recnd imcl sylancr wceq
    ax-icn 3eqtr4d remim mulcl neg2subd reneg oveq2d mulneg2 oveq12d negsubdi2d
    imneg eqtrd negcl syl negeqd ) ABCZADZEFZGUNHFZIJZKJZAEFZGAHFZIJZKJZDZUNLFZ
    ALFZDUMUSDZVADZKJVAUSKJURVCUMUSVAUMUSAMNZUMGBCZUTBCZVABCRUMUTAONZGUTUAPZUBU
    MUOVFUQVGKAUCUMUQGUTDZIJZVGUMUPVMGIAUHUDUMVIVJVNVGQRVKGUTUEPUIUFUMUSVAVHVLU
    GSUMUNBCVDURQAUJUNTUKUMVEVBATULS $.

  $( A number plus its conjugate is twice its real part.  Compare Proposition
     10-3.4(h) of [Gleason] p. 133.  (Contributed by NM, 21-Jan-2007.)
     (Revised by Mario Carneiro, 14-Jul-2014.) $)
  addcj $p |- ( A e. CC -> ( A + ( * ` A ) ) = ( 2 x. ( Re ` A ) ) ) $=
    ( cc wcel c2 cre cfv cmul ccj caddc cdiv reval oveq2d wceq cjcl addcl mpdan
    co cc0 wne 2cn 2ne0 divcan2 mp3an23 syl eqtr2d ) ABCZDAEFZGQDAAHFZIQZDJQZGQ
    ZUIUFUGUJDGAKLUFUIBCZUKUIMZUFUHBCULANAUHOPULDBCDRSUMTUAUIDUBUCUDUE $.

  $( Complex conjugate distributes over subtraction.  (Contributed by NM,
     28-Apr-2005.) $)
  cjsub $p |- ( ( A e. CC /\ B e. CC ) ->
                   ( * ` ( A - B ) ) = ( ( * ` A ) - ( * ` B ) ) ) $=
    ( cc wcel wa cneg caddc ccj cfv cmin negcl cjadd sylan2 negsub fveq2d cjneg
    co wceq adantl cjcl oveq2d syl2an eqtrd 3eqtr3d ) ACDZBCDZEZABFZGQZHIZAHIZU
    HHIZGQZABJQZHIUKBHIZJQZUFUEUHCDUJUMRBKAUHLMUGUIUNHABNOUGUMUKUOFZGQZUPUGULUQ
    UKGUFULUQRUEBPSUAUEUKCDUOCDURUPRUFATBTUKUONUBUCUD $.

  ${
    $d j k A $.  $d j k N $.
    $( Complex conjugate of natural number exponentiation.  (Contributed by NM,
       7-Jun-2006.) $)
    cjexp $p |- ( ( A e. CC /\ N e. NN0 ) ->
               ( * ` ( A ^ N ) ) = ( ( * ` A ) ^ N ) ) $=
      ( vj vk cn0 wcel cc cexp co ccj cfv wi cc0 c1 oveq2 fveq2d eqeq12d imbi2d
      wceq cmul cv caddc exp0 cjcl cr 1re cjre ax-mp syl6eqr eqtr4d expp1 expcl
      syl wa simpl cjmul syl2anc eqtrd adantr oveq1 sylan sylan9eqr exp31 com12
      eqcomd a2d nn0ind impcom ) BEFAGFZABHIZJKZAJKZBHIZSZVIACUAZHIZJKZVLVOHIZS
      ZLVIAMHIZJKZVLMHIZSZLVIADUAZHIZJKZVLWDHIZSZLVIAWDNUBIZHIZJKZVLWIHIZSZLVIV
      NLCDBVOMSZVSWCVIWNVQWAVRWBWNVPVTJVOMAHOPVOMVLHOQRVOWDSZVSWHVIWOVQWFVRWGWO
      VPWEJVOWDAHOPVOWDVLHOQRVOWISZVSWMVIWPVQWKVRWLWPVPWJJVOWIAHOPVOWIVLHOQRVOB
      SZVSVNVIWQVQVKVRVMWQVPVJJVOBAHOPVOBVLHOQRVIWANJKZWBVIVTNJAUCPVIVLGFZWBWRS
      AUDZWSWBNWRVLUCNUEFWRNSUFNUGUHUIUMUJWDEFZVIWHWMVIXAWHWMLVIXAWHWMVIXAUNZWH
      UNWKWFVLTIZWLXBWKXCSWHXBWKWEATIZJKZXCXBWJXDJAWDUKPXBWEGFVIXEXCSAWDULVIXAU
      OWEAUPUQURUSWHXBXCWGVLTIZWLWFWGVLTUTXBWLXFVIWSXAWLXFSWTVLWDUKVAVEVBURVCVD
      VFVGVH $.
  $}

  $( The imaginary part of a number in terms of complex conjugate.
     (Contributed by NM, 30-Apr-2005.) $)
  imval2 $p |- ( A e. CC ->
    ( Im ` A ) = ( ( A - ( * ` A ) ) / ( 2 x. _i ) ) ) $=
    ( cc wcel cim cfv c2 ci cmul cdiv ccj cmin wceq imcl recnd 2cn ax-icn caddc
    co syl oveq1d cc0 wne mulcli 2ne0 ine0 mulne0i divcan4 mp3an23 recl sylancr
    cre mulcl addcld subsubd replim remim oveq12d 2timesd mulcom mulass mp3an12
    mpan2 eqtrd pncan2d 3eqtr4d 3eqtr4rd eqtr3d ) ABCZADEZFGHRZHRZVJIRZVIAAJEZK
    RZVJIRVHVIBCZVLVILZVHVIAMNZVOVJBCZVJUAUBVPFGOPUCZFGOPUDUEUFVIVJUGUHSVHVKVNV
    JIVHAUKEZGVIHRZQRZVTWAKRZKRWBVTKRZWAQRZVNVKVHWBVTWAVHVTWAVHVTAUINZVHGBCZVOW
    ABCPVQGVIULUJZUMWFWHUNVHAWBVMWCKAUOAUPUQVHFWAHRZWAWAQRVKWEVHWAWHURVHVOVKWIL
    VQVOVKVJVIHRZWIVOVRVKWJLVSVIVJUSVBFBCWGVOWJWILOPFGVIUTVAVCSVHWDWAWAQVHVTWAW
    FWHVDTVEVFTVG $.

  $( The real part of zero.  (Contributed by NM, 27-Jul-1999.) $)
  re0 $p |- ( Re ` 0 ) = 0 $=
    ( cc0 cr wcel cre cfv wceq 0re rere ax-mp ) ABCADEAFGAHI $.

  $( The imaginary part of zero.  (Contributed by NM, 27-Jul-1999.) $)
  im0 $p |- ( Im ` 0 ) = 0 $=
    ( cc0 cr wcel cim cfv wceq 0re reim0 ax-mp ) ABCADEAFGAHI $.

  $( The real part of one.  (Contributed by Scott Fenton, 9-Jun-2006.) $)
  re1 $p |- ( Re ` 1 ) = 1 $=
    ( c1 cr wcel cre cfv wceq 1re rere ax-mp ) ABCADEAFGAHI $.

  $( The imaginary part of one.  (Contributed by Scott Fenton, 9-Jun-2006.) $)
  im1 $p |- ( Im ` 1 ) = 0 $=
    ( c1 cr wcel cim cfv cc0 wceq 1re reim0 ax-mp ) ABCADEFGHAIJ $.

  $( The real part of ` _i ` .  (Contributed by Scott Fenton, 9-Jun-2006.) $)
  rei $p |- ( Re ` _i ) = 0 $=
    ( cc0 ci c1 cmul co caddc cre ax-icn ax-1cn mulcli addid2i fveq2i wcel wceq
    cfv cr 0re 1re crre mp2an mulid1i 3eqtr3ri ) ABCDEZFEZGOZUCGOABGOUDUCGUCBCH
    IJKLAPMCPMUEANQRACSTUCBGBHUALUB $.

  $( The imaginary part of ` _i ` .  (Contributed by Scott Fenton,
     9-Jun-2006.) $)
  imi $p |- ( Im ` _i ) = 1 $=
    ( ci c1 cmul cim cfv cc0 ax-icn ax-1cn mulcli addid2i eqcomi fveq2i mulid1i
    co caddc cr wcel wceq 0re 1re crim mp2an 3eqtr3i ) ABCNZDEFUDONZDEZADEBUDUE
    DUEUDUDABGHIJKLUDADAGMLFPQBPQUFBRSTFBUAUBUC $.

  $( The conjugate of zero.  (Contributed by NM, 27-Jul-1999.) $)
  cj0 $p |- ( * ` 0 ) = 0 $=
    ( cc0 cr wcel ccj cfv wceq 0re cjre ax-mp ) ABCADEAFGAHI $.

  $( The complex conjugate of the imaginary unit.  (Contributed by NM,
     26-Mar-2005.) $)
  cji $p |- ( * ` _i ) = -u _i $=
    ( ci cre cfv cim cmul co cmin cc0 ccj cneg rei c1 imi oveq2i ax-icn mulid1i
    eqtri oveq12i cc wcel wceq remim ax-mp df-neg 3eqtr4i ) ABCZAADCZEFZGFZHAGF
    AICZAJUFHUHAGKUHALEFAUGLAEMNAOPQRASTUJUIUAOAUBUCAUDUE $.

  $( The conjugate of a representation of a complex number in terms of real and
     imaginary parts.  (Contributed by NM, 1-Jul-2005.) $)
  cjreim $p |- ( ( A e. RR /\ B e. RR ) -> ( * ` ( A + ( _i x. B ) ) ) =
                ( A - ( _i x. B ) ) ) $=
    ( cr wcel wa ci cmul co caddc ccj cfv cneg cc wceq recn ax-icn sylancr cjre
    syl2an 3eqtrd cmin mulcl cjadd cjmul cji oveq12d mulneg1 oveqan12d negsub
    a1i ) ACDZBCDZEAFBGHZIHJKZAJKZUMJKZIHZAUMLZIHZAUMUAHZUKAMDZUMMDZUNUQNULAOZU
    LFMDZBMDZVBPBOZFBUBQZAUMUCSUKULUOAUPURIARULUPFJKZBJKZGHZFLZBGHZURULVDVEUPVJ
    NPVFFBUDQULVHVKVIBGVHVKNULUEUJBRUFULVDVEVLURNPVFFBUGQTUHUKVAVBUSUTNULVCVGAU
    MUIST $.

  $( The conjugate of the representation of a complex number in terms of real
     and imaginary parts.  (Contributed by NM, 1-Jul-2005.)  (Proof shortened
     by Mario Carneiro, 29-May-2016.) $)
  cjreim2 $p |- ( ( A e. RR /\ B e. RR ) -> ( * ` ( A - ( _i x. B ) ) ) =
                ( A + ( _i x. B ) ) ) $=
    ( cr wcel wa ci cmul co caddc ccj cfv cmin cjreim fveq2d simpl recnd ax-icn
    cc wceq a1i simpr mulcld addcld cjcj syl eqtr3d ) ACDZBCDZEZAFBGHZIHZJKZJKZ
    AUJLHZJKUKUIULUNJABMNUIUKRDUMUKSUIAUJUIAUGUHOPUIFBFRDUIQTUIBUGUHUAPUBUCUKUD
    UEUF $.

  $( Complex conjugate is a one-to-one function.  (Contributed by NM,
     29-Apr-2005.)  (Proof shortened by Eric Schmidt, 2-Jul-2009.) $)
  cj11 $p |- ( ( A e. CC /\ B e. CC ) ->
              ( ( * ` A ) = ( * ` B ) <-> A = B ) ) $=
    ( cc wcel wa ccj cfv wceq fveq2 cjcj eqeqan12d syl5ib impbid1 ) ACDZBCDZEZA
    FGZBFGZHZABHZSQFGZRFGZHPTQRFINOUAAUBBAJBJKLABFIM $.

  $( A number is nonzero iff its complex conjugate is nonzero.  (Contributed by
     NM, 29-Apr-2005.) $)
  cjne0 $p |- ( A e. CC -> ( A =/= 0 <-> ( * ` A ) =/= 0 ) ) $=
    ( cc wcel cc0 ccj cfv wceq cj0 eqeq2i wb 0cn cj11 mpan2 syl5rbbr necon3bid
    ) ABCZADAEFZDQDGQDEFZGZPADGZRDQHIPDBCSTJKADLMNO $.

  $( Complex conjugate distributes over division.  (Contributed by NM,
     29-Apr-2005.)  (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  cjdiv $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                   ( * ` ( A / B ) ) = ( ( * ` A ) / ( * ` B ) ) ) $=
    ( cc wcel cc0 wne w3a cdiv co ccj cfv cmul divcl cjcl syl simp2 simp3 cjne0
    wb eqtr3d mpbid divcan4d wceq cjmul syl2anc divcan1 fveq2d oveq1d ) ACDZBCD
    ZBEFZGZABHIZJKZBJKZLIZUOHIUNAJKZUOHIULUNUOULUMCDZUNCDABMZUMNOULUJUOCDUIUJUK
    PZBNOULUKUOEFZUIUJUKQULUJUKVASUTBROUAUBULUPUQUOHULUMBLIZJKZUPUQULURUJVCUPUC
    USUTUMBUDUEULVBAJABUFUGTUHT $.

  ${
    $d F u v w z $.  $d x y u v w z $.
    cnrecnv.1 $e |- F = ( x e. RR , y e. RR |-> ( x + ( _i x. y ) ) ) $.
    $( The inverse to the canonical bijection from ` ( RR X. RR ) ` to ` CC `
       from ~ cnref1o .  (Contributed by Mario Carneiro, 25-Aug-2014.) $)
    cnrecnv $p |- `' F = ( z e. CC |-> <. ( Re ` z ) , ( Im ` z ) >. ) $=
      ( ccnv cc cv cfv cmpt wceq wtru cr wf1o wcel ci cmul co caddc syl2anc cre
      cim cop cxp wf cnref1o f1ocnv f1of mp2b a1i feqmptd trud df-ov recl oveq1
      imcl oveq2d ovmpt2 syl5eqr replim eqtr4d fveq2d opelxpi f1ocnvfv1 sylancr
      oveq2 ovex eqtr3d mpteq2ia eqtri ) DFZCGCHZVKIZJZCGVLUAIZVLUBIZUCZJVKVNKL
      CGMMUDZVKGVRVKUEZLVRGDNZGVRVKNVSABDEUFZVRGDUGGVRVKUHUIUJUKULCGVMVQVLGOZVQ
      DIZVKIZVMVQWBWCVLVKWBWCVOPVPQRZSRZVLWBWCVOVPDRZWFVOVPDUMWBVOMOZVPMOZWGWFK
      VLUNZVLUPZABVOVPMMAHZPBHZQRZSRWFDVOWNSRWLVOWNSUOWMVPKWNWEVOSWMVPPQVFUQEVO
      WESVGURTUSVLUTVAVBWBVTVQVROZWDVQKWAWBWHWIWOWJWKVOVPMMVCTVRGVQDVDVEVHVIVJ
      $.
  $}

  ${
    sqeqd.1 $e |- ( ph -> A e. CC ) $.
    sqeqd.2 $e |- ( ph -> B e. CC ) $.
    sqeqd.3 $e |- ( ph -> ( A ^ 2 ) = ( B ^ 2 ) ) $.
    sqeqd.4 $e |- ( ph -> 0 <_ ( Re ` A ) ) $.
    sqeqd.5 $e |- ( ph -> 0 <_ ( Re ` B ) ) $.
    sqeqd.6 $e |- ( ( ph /\ ( Re ` A ) = 0 /\ ( Re ` B ) = 0 ) -> A = B ) $.
    $( A deduction for showing two numbers whose squares are equal are
       themselves equal.  (Contributed by Mario Carneiro, 3-Apr-2015.) $)
    sqeqd $p |- ( ph -> A = B ) $=
      ( wceq cneg c2 cexp wcel cre cfv cc0 cle wbr adantr wn co wo cc wb sqeqor
      syl2anc mpbid ord wa simpl fveq2 reneg sylan9eqr breqtrd cr recl le0neg1d
      syl mpbird letri3 sylancl mpbir2and negeqd neg0 syl6eq eqtrd syl3anc syld
      0re ex pm2.18d ) ABCJZAVMUABCKZJZVMAVMVOABLMUBCLMUBJZVMVOUCZFABUDNCUDNZVP
      VQUEDEBCUFUGUHUIAVOVMAVOUJZABOPZQJCOPZQJZVMAVOUKVSVTWAKZQVOAVTVNOPZWCBVNO
      ULAVRWDWCJECUMUSUNZVSWCQKQVSWAQVSWBWAQRSZQWARSZVSWFQWCRSVSQVTWCRAQVTRSVOG
      TWEUOVSWAVSVRWAUPNZAVRVOETCUQUSZURUTAWGVOHTVSWHQUPNWBWFWGUJUEWIVJWAQVAVBV
      CZVDVEVFVGWJIVHVKVIVL $.
  $}

  ${
    recl.1 $e |- A e. CC $.
    $( The real part of a complex number is real (closure law).  (Contributed
       by NM, 11-May-1999.) $)
    recli $p |- ( Re ` A ) e. RR $=
      ( cc wcel cre cfv cr recl ax-mp ) ACDAEFGDBAHI $.

    $( The imaginary part of a complex number is real (closure law).
       (Contributed by NM, 11-May-1999.) $)
    imcli $p |- ( Im ` A ) e. RR $=
      ( cc wcel cim cfv cr imcl ax-mp ) ACDAEFGDBAHI $.

    $( Closure law for complex conjugate.  (Contributed by NM, 11-May-1999.) $)
    cjcli $p |- ( * ` A ) e. CC $=
      ( cc wcel ccj cfv cjcl ax-mp ) ACDAEFCDBAGH $.

    $( Construct a complex number from its real and imaginary parts.
       (Contributed by NM, 1-Oct-1999.) $)
    replimi $p |- A = ( ( Re ` A ) + ( _i x. ( Im ` A ) ) ) $=
      ( cc wcel cre cfv ci cim cmul co caddc wceq replim ax-mp ) ACDAAEFGAHFIJK
      JLBAMN $.

    $( The conjugate of the conjugate is the original complex number.
       Proposition 10-3.4(e) of [Gleason] p. 133.  (Contributed by NM,
       11-May-1999.) $)
    cjcji $p |- ( * ` ( * ` A ) ) = A $=
      ( cc wcel ccj cfv wceq cjcj ax-mp ) ACDAEFEFAGBAHI $.

    $( A number is real iff its imaginary part is 0.  (Contributed by NM,
       29-May-1999.) $)
    reim0bi $p |- ( A e. RR <-> ( Im ` A ) = 0 ) $=
      ( cc wcel cr cim cfv cc0 wceq wb reim0b ax-mp ) ACDAEDAFGHIJBAKL $.

    $( A real number equals its real part.  Proposition 10-3.4(f) of [Gleason]
       p. 133.  (Contributed by NM, 27-Oct-1999.) $)
    rerebi $p |- ( A e. RR <-> ( Re ` A ) = A ) $=
      ( cc wcel cr cre cfv wceq wb rereb ax-mp ) ACDAEDAFGAHIBAJK $.

    $( A number is real iff it equals its complex conjugate.  Proposition
       10-3.4(f) of [Gleason] p. 133.  (Contributed by NM, 11-Oct-1999.) $)
    cjrebi $p |- ( A e. RR <-> ( * ` A ) = A ) $=
      ( cc wcel cr ccj cfv wceq wb cjreb ax-mp ) ACDAEDAFGAHIBAJK $.

    $( Real part of a complex conjugate.  (Contributed by NM, 2-Oct-1999.) $)
    recji $p |- ( Re ` ( * ` A ) ) = ( Re ` A ) $=
      ( cc wcel ccj cfv cre wceq recj ax-mp ) ACDAEFGFAGFHBAIJ $.

    $( Imaginary part of a complex conjugate.  (Contributed by NM,
       2-Oct-1999.) $)
    imcji $p |- ( Im ` ( * ` A ) ) = -u ( Im ` A ) $=
      ( cc wcel ccj cfv cim cneg wceq imcj ax-mp ) ACDAEFGFAGFHIBAJK $.

    $( A complex number times its conjugate is real.  (Contributed by NM,
       11-May-1999.) $)
    cjmulrcli $p |- ( A x. ( * ` A ) ) e. RR $=
      ( cc wcel ccj cfv cmul co cr cjmulrcl ax-mp ) ACDAAEFGHIDBAJK $.

    $( A complex number times its conjugate.  (Contributed by NM,
       2-Oct-1999.) $)
    cjmulvali $p |- ( A x. ( * ` A ) ) =
                   ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) $=
      ( cc wcel ccj cfv cmul co cre c2 cexp cim caddc wceq cjmulval ax-mp ) ACD
      AAEFGHAIFJKHALFJKHMHNBAOP $.

    $( A complex number times its conjugate is nonnegative.  (Contributed by
       NM, 28-May-1999.) $)
    cjmulge0i $p |- 0 <_ ( A x. ( * ` A ) ) $=
      ( cc wcel cc0 ccj cfv cmul co cle wbr cjmulge0 ax-mp ) ACDEAAFGHIJKBALM
      $.

    $( Real part of negative.  (Contributed by NM, 2-Aug-1999.) $)
    renegi $p |- ( Re ` -u A ) = -u ( Re ` A ) $=
      ( cc wcel cneg cre cfv wceq reneg ax-mp ) ACDAEFGAFGEHBAIJ $.

    $( Imaginary part of negative.  (Contributed by NM, 2-Aug-1999.) $)
    imnegi $p |- ( Im ` -u A ) = -u ( Im ` A ) $=
      ( cc wcel cneg cim cfv wceq imneg ax-mp ) ACDAEFGAFGEHBAIJ $.

    $( Complex conjugate of negative.  (Contributed by NM, 2-Aug-1999.) $)
    cjnegi $p |- ( * ` -u A ) = -u ( * ` A ) $=
      ( cc wcel cneg ccj cfv wceq cjneg ax-mp ) ACDAEFGAFGEHBAIJ $.

    $( A number plus its conjugate is twice its real part.  Compare Proposition
       10-3.4(h) of [Gleason] p. 133.  (Contributed by NM, 2-Oct-1999.) $)
    addcji $p |- ( A + ( * ` A ) ) = ( 2 x. ( Re ` A ) ) $=
      ( cc wcel ccj cfv caddc co c2 cre cmul wceq addcj ax-mp ) ACDAAEFGHIAJFKH
      LBAMN $.

    readdi.2 $e |- B e. CC $.
    $( Real part distributes over addition.  (Contributed by NM,
       28-Jul-1999.) $)
    readdi $p |- ( Re ` ( A + B ) ) = ( ( Re ` A ) + ( Re ` B ) ) $=
      ( cc wcel caddc co cre cfv wceq readd mp2an ) AEFBEFABGHIJAIJBIJGHKCDABLM
      $.

    $( Imaginary part distributes over addition.  (Contributed by NM,
       28-Jul-1999.) $)
    imaddi $p |- ( Im ` ( A + B ) ) = ( ( Im ` A ) + ( Im ` B ) ) $=
      ( cc wcel caddc co cim cfv wceq imadd mp2an ) AEFBEFABGHIJAIJBIJGHKCDABLM
      $.

    $( Real part of a product.  (Contributed by NM, 28-Jul-1999.) $)
    remuli $p |- ( Re ` ( A x. B ) ) =
          ( ( ( Re ` A ) x. ( Re ` B ) ) - ( ( Im ` A ) x. ( Im ` B ) ) ) $=
      ( cc wcel cmul co cre cfv cim cmin wceq remul mp2an ) AEFBEFABGHIJAIJBIJG
      HAKJBKJGHLHMCDABNO $.

    $( Imaginary part of a product.  (Contributed by NM, 28-Jul-1999.) $)
    immuli $p |- ( Im ` ( A x. B ) ) =
          ( ( ( Re ` A ) x. ( Im ` B ) ) + ( ( Im ` A ) x. ( Re ` B ) ) ) $=
      ( cc wcel cmul co cim cfv cre caddc wceq immul mp2an ) AEFBEFABGHIJAKJBIJ
      GHAIJBKJGHLHMCDABNO $.

    $( Complex conjugate distributes over addition.  Proposition 10-3.4(a) of
       [Gleason] p. 133.  (Contributed by NM, 28-Jul-1999.) $)
    cjaddi $p |- ( * ` ( A + B ) ) = ( ( * ` A ) + ( * ` B ) ) $=
      ( cc wcel caddc co ccj cfv wceq cjadd mp2an ) AEFBEFABGHIJAIJBIJGHKCDABLM
      $.

    $( Complex conjugate distributes over multiplication.  Proposition
       10-3.4(c) of [Gleason] p. 133.  (Contributed by NM, 28-Jul-1999.) $)
    cjmuli $p |- ( * ` ( A x. B ) ) = ( ( * ` A ) x. ( * ` B ) ) $=
      ( cc wcel cmul co ccj cfv wceq cjmul mp2an ) AEFBEFABGHIJAIJBIJGHKCDABLM
      $.

    $( Standard inner product on complex numbers.  (Contributed by NM,
       2-Oct-1999.) $)
    ipcni $p |- ( Re ` ( A x. ( * ` B ) ) ) =
           ( ( ( Re ` A ) x. ( Re ` B ) ) + ( ( Im ` A ) x. ( Im ` B ) ) ) $=
      ( cc wcel ccj cfv cmul co cre cim caddc wceq ipcnval mp2an ) AEFBEFABGHIJ
      KHAKHBKHIJALHBLHIJMJNCDABOP $.

    $( Complex conjugate distributes over division.  (Contributed by NM,
       29-Apr-2005.)  (Revised by Mario Carneiro, 29-May-2016.) $)
    cjdivi $p |- ( B =/= 0 ->
                    ( * ` ( A / B ) ) = ( ( * ` A ) / ( * ` B ) ) ) $=
      ( cc wcel cc0 wne cdiv co ccj cfv wceq cjdiv mp3an12 ) AEFBEFBGHABIJKLAKL
      BKLIJMCDABNO $.
  $}

  ${
    crre.1 $e |- A e. RR $.
    crre.2 $e |- B e. RR $.
    $( The real part of a complex number representation.  Definition 10-3.1 of
       [Gleason] p. 132.  (Contributed by NM, 10-May-1999.) $)
    crrei $p |- ( Re ` ( A + ( _i x. B ) ) ) = A $=
      ( cr wcel ci cmul co caddc cre cfv wceq crre mp2an ) AEFBEFAGBHIJIKLAMCDA
      BNO $.

    $( The imaginary part of a complex number representation.  Definition
       10-3.1 of [Gleason] p. 132.  (Contributed by NM, 10-May-1999.) $)
    crimi $p |- ( Im ` ( A + ( _i x. B ) ) ) = B $=
      ( cr wcel ci cmul co caddc cim cfv wceq crim mp2an ) AEFBEFAGBHIJIKLBMCDA
      BNO $.
  $}

  ${
    recld.1 $e |- ( ph -> A e. CC ) $.
    $( The real part of a complex number is real (closure law).  (Contributed
       by Mario Carneiro, 29-May-2016.) $)
    recld $p |- ( ph -> ( Re ` A ) e. RR ) $=
      ( cc wcel cre cfv cr recl syl ) ABDEBFGHECBIJ $.

    $( The imaginary part of a complex number is real (closure law).
       (Contributed by Mario Carneiro, 29-May-2016.) $)
    imcld $p |- ( ph -> ( Im ` A ) e. RR ) $=
      ( cc wcel cim cfv cr imcl syl ) ABDEBFGHECBIJ $.

    $( Closure law for complex conjugate.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    cjcld $p |- ( ph -> ( * ` A ) e. CC ) $=
      ( cc wcel ccj cfv cjcl syl ) ABDEBFGDECBHI $.

    $( Construct a complex number from its real and imaginary parts.
       (Contributed by Mario Carneiro, 29-May-2016.) $)
    replimd $p |- ( ph -> A = ( ( Re ` A ) + ( _i x. ( Im ` A ) ) ) ) $=
      ( cc wcel cre cfv ci cim cmul co caddc wceq replim syl ) ABDEBBFGHBIGJKLK
      MCBNO $.

    $( Value of the conjugate of a complex number.  The value is the real part
       minus ` _i ` times the imaginary part.  Definition 10-3.2 of [Gleason]
       p. 132.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    remimd $p |- ( ph -> ( * ` A ) = ( ( Re ` A ) - ( _i x. ( Im ` A ) ) ) ) $=
      ( cc wcel ccj cfv cre ci cim cmul co cmin wceq remim syl ) ABDEBFGBHGIBJG
      KLMLNCBOP $.

    $( The conjugate of the conjugate is the original complex number.
       Proposition 10-3.4(e) of [Gleason] p. 133.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    cjcjd $p |- ( ph -> ( * ` ( * ` A ) ) = A ) $=
      ( cc wcel ccj cfv wceq cjcj syl ) ABDEBFGFGBHCBIJ $.

    ${
      reim0bd.2 $e |- ( ph -> ( Im ` A ) = 0 ) $.
      $( A number is real iff its imaginary part is 0.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      reim0bd $p |- ( ph -> A e. RR ) $=
        ( cr wcel cim cfv cc0 wceq cc wb reim0b syl mpbird ) ABEFZBGHIJZDABKFPQ
        LCBMNO $.
    $}

    ${
      rerebd.2 $e |- ( ph -> ( Re ` A ) = A ) $.
      $( A real number equals its real part.  Proposition 10-3.4(f) of
         [Gleason] p. 133.  (Contributed by Mario Carneiro, 29-May-2016.) $)
      rerebd $p |- ( ph -> A e. RR ) $=
        ( cr wcel cre cfv wceq cc wb rereb syl mpbird ) ABEFZBGHBIZDABJFOPKCBLM
        N $.
    $}

    ${
      cjrebd.2 $e |- ( ph -> ( * ` A ) = A ) $.
      $( A number is real iff it equals its complex conjugate.  Proposition
         10-3.4(f) of [Gleason] p. 133.  (Contributed by Mario Carneiro,
         29-May-2016.) $)
      cjrebd $p |- ( ph -> A e. RR ) $=
        ( cr wcel ccj cfv wceq cc wb cjreb syl mpbird ) ABEFZBGHBIZDABJFOPKCBLM
        N $.
    $}

    ${
      cjne0d.2 $e |- ( ph -> A =/= 0 ) $.
      $( A number is nonzero iff its complex conjugate is nonzero.
         (Contributed by Mario Carneiro, 29-May-2016.) $)
      cjne0d $p |- ( ph -> ( * ` A ) =/= 0 ) $=
        ( cc0 wne ccj cfv cc wcel wb cjne0 syl mpbid ) ABEFZBGHEFZDABIJOPKCBLMN
        $.
    $}

    $( Real part of a complex conjugate.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    recjd $p |- ( ph -> ( Re ` ( * ` A ) ) = ( Re ` A ) ) $=
      ( cc wcel ccj cfv cre wceq recj syl ) ABDEBFGHGBHGICBJK $.

    $( Imaginary part of a complex conjugate.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    imcjd $p |- ( ph -> ( Im ` ( * ` A ) ) = -u ( Im ` A ) ) $=
      ( cc wcel ccj cfv cim cneg wceq imcj syl ) ABDEBFGHGBHGIJCBKL $.

    $( A complex number times its conjugate is real.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    cjmulrcld $p |- ( ph -> ( A x. ( * ` A ) ) e. RR ) $=
      ( cc wcel ccj cfv cmul co cr cjmulrcl syl ) ABDEBBFGHIJECBKL $.

    $( A complex number times its conjugate.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    cjmulvald $p |- ( ph -> ( A x. ( * ` A ) ) =
                   ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
      ( cc wcel ccj cfv cmul co cre c2 cexp cim caddc wceq cjmulval syl ) ABDEB
      BFGHIBJGKLIBMGKLINIOCBPQ $.

    $( A complex number times its conjugate is nonnegative.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    cjmulge0d $p |- ( ph -> 0 <_ ( A x. ( * ` A ) ) ) $=
      ( cc wcel cc0 ccj cfv cmul co cle wbr cjmulge0 syl ) ABDEFBBGHIJKLCBMN $.

    $( Real part of negative.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    renegd $p |- ( ph -> ( Re ` -u A ) = -u ( Re ` A ) ) $=
      ( cc wcel cneg cre cfv wceq reneg syl ) ABDEBFGHBGHFICBJK $.

    $( Imaginary part of negative.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    imnegd $p |- ( ph -> ( Im ` -u A ) = -u ( Im ` A ) ) $=
      ( cc wcel cneg cim cfv wceq imneg syl ) ABDEBFGHBGHFICBJK $.

    $( Complex conjugate of negative.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    cjnegd $p |- ( ph -> ( * ` -u A ) = -u ( * ` A ) ) $=
      ( cc wcel cneg ccj cfv wceq cjneg syl ) ABDEBFGHBGHFICBJK $.

    $( A number plus its conjugate is twice its real part.  Compare Proposition
       10-3.4(h) of [Gleason] p. 133.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    addcjd $p |- ( ph -> ( A + ( * ` A ) ) = ( 2 x. ( Re ` A ) ) ) $=
      ( cc wcel ccj cfv caddc co c2 cre cmul wceq addcj syl ) ABDEBBFGHIJBKGLIM
      CBNO $.

    ${
      cjexpd.2 $e |- ( ph -> N e. NN0 ) $.
      $( Complex conjugate of natural number exponentiation.  (Contributed by
         Mario Carneiro, 29-May-2016.) $)
      cjexpd $p |- ( ph -> ( * ` ( A ^ N ) ) = ( ( * ` A ) ^ N ) ) $=
        ( cc wcel cn0 cexp co ccj cfv wceq cjexp syl2anc ) ABFGCHGBCIJKLBKLCIJM
        DEBCNO $.
    $}

    readdd.2 $e |- ( ph -> B e. CC ) $.
    $( Real part distributes over addition.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    readdd $p |- ( ph -> ( Re ` ( A + B ) ) = ( ( Re ` A ) + ( Re ` B ) ) ) $=
      ( cc wcel caddc co cre cfv wceq readd syl2anc ) ABFGCFGBCHIJKBJKCJKHILDEB
      CMN $.

    $( Imaginary part distributes over addition.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    imaddd $p |- ( ph -> ( Im ` ( A + B ) ) = ( ( Im ` A ) + ( Im ` B ) ) ) $=
      ( cc wcel caddc co cim cfv wceq imadd syl2anc ) ABFGCFGBCHIJKBJKCJKHILDEB
      CMN $.

    $( Real part distributes over subtraction.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    resubd $p |- ( ph -> ( Re ` ( A - B ) ) = ( ( Re ` A ) - ( Re ` B ) ) ) $=
      ( cc wcel cmin co cre cfv wceq resub syl2anc ) ABFGCFGBCHIJKBJKCJKHILDEBC
      MN $.

    $( Imaginary part distributes over subtraction.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    imsubd $p |- ( ph -> ( Im ` ( A - B ) ) = ( ( Im ` A ) - ( Im ` B ) ) ) $=
      ( cc wcel cmin co cim cfv wceq imsub syl2anc ) ABFGCFGBCHIJKBJKCJKHILDEBC
      MN $.

    $( Real part of a product.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    remuld $p |- ( ph -> ( Re ` ( A x. B ) ) =
          ( ( ( Re ` A ) x. ( Re ` B ) ) - ( ( Im ` A ) x. ( Im ` B ) ) ) ) $=
      ( cc wcel cmul co cre cfv cim cmin wceq remul syl2anc ) ABFGCFGBCHIJKBJKC
      JKHIBLKCLKHIMINDEBCOP $.

    $( Imaginary part of a product.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    immuld $p |- ( ph -> ( Im ` ( A x. B ) ) =
          ( ( ( Re ` A ) x. ( Im ` B ) ) + ( ( Im ` A ) x. ( Re ` B ) ) ) ) $=
      ( cc wcel cmul co cim cfv cre caddc wceq immul syl2anc ) ABFGCFGBCHIJKBLK
      CJKHIBJKCLKHIMINDEBCOP $.

    $( Complex conjugate distributes over addition.  Proposition 10-3.4(a) of
       [Gleason] p. 133.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    cjaddd $p |- ( ph -> ( * ` ( A + B ) ) = ( ( * ` A ) + ( * ` B ) ) ) $=
      ( cc wcel caddc co ccj cfv wceq cjadd syl2anc ) ABFGCFGBCHIJKBJKCJKHILDEB
      CMN $.

    $( Complex conjugate distributes over multiplication.  Proposition
       10-3.4(c) of [Gleason] p. 133.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    cjmuld $p |- ( ph -> ( * ` ( A x. B ) ) = ( ( * ` A ) x. ( * ` B ) ) ) $=
      ( cc wcel cmul co ccj cfv wceq cjmul syl2anc ) ABFGCFGBCHIJKBJKCJKHILDEBC
      MN $.

    $( Standard inner product on complex numbers.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    ipcnd $p |- ( ph -> ( Re ` ( A x. ( * ` B ) ) ) =
           ( ( ( Re ` A ) x. ( Re ` B ) ) + ( ( Im ` A ) x. ( Im ` B ) ) ) ) $=
      ( cc wcel ccj cfv cmul co cre cim caddc wceq ipcnval syl2anc ) ABFGCFGBCH
      IJKLIBLICLIJKBMICMIJKNKODEBCPQ $.

    cjdivd.2 $e |- ( ph -> B =/= 0 ) $.
    $( Complex conjugate distributes over division.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    cjdivd $p |- ( ph ->
                    ( * ` ( A / B ) ) = ( ( * ` A ) / ( * ` B ) ) ) $=
      ( cc wcel cc0 wne cdiv co ccj cfv wceq cjdiv syl3anc ) ABGHCGHCIJBCKLMNBM
      NCMNKLODEFBCPQ $.
  $}

  ${
    crred.1 $e |- ( ph -> A e. RR ) $.
    $( A real number equals its real part.  One direction of Proposition
       10-3.4(f) of [Gleason] p. 133.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    rered $p |- ( ph -> ( Re ` A ) = A ) $=
      ( cr wcel cre cfv wceq rere syl ) ABDEBFGBHCBIJ $.

    $( The imaginary part of a real number is 0.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    reim0d $p |- ( ph -> ( Im ` A ) = 0 ) $=
      ( cr wcel cim cfv cc0 wceq reim0 syl ) ABDEBFGHICBJK $.

    $( A real number equals its complex conjugate.  Proposition 10-3.4(f) of
       [Gleason] p. 133.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    cjred $p |- ( ph -> ( * ` A ) = A ) $=
      ( cr wcel ccj cfv wceq cjre syl ) ABDEBFGBHCBIJ $.

    ${
      remul2d.2 $e |- ( ph -> B e. CC ) $.
      $( Real part of a product.  (Contributed by Mario Carneiro,
         29-May-2016.) $)
      remul2d $p |- ( ph -> ( Re ` ( A x. B ) ) = ( A x. ( Re ` B ) ) ) $=
        ( cr wcel cc cmul co cre cfv wceq remul2 syl2anc ) ABFGCHGBCIJKLBCKLIJM
        DEBCNO $.

      $( Imaginary part of a product.  (Contributed by Mario Carneiro,
         29-May-2016.) $)
      immul2d $p |- ( ph -> ( Im ` ( A x. B ) ) = ( A x. ( Im ` B ) ) ) $=
        ( cr wcel cc cmul co cim cfv wceq immul2 syl2anc ) ABFGCHGBCIJKLBCKLIJM
        DEBCNO $.

      redivd.2 $e |- ( ph -> A =/= 0 ) $.
      $( Real part of a division.  Related to ~ remul2 .  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      redivd $p |- ( ph -> ( Re ` ( B / A ) ) = ( ( Re ` B ) / A ) ) $=
        ( cc wcel cr cc0 wne cdiv co cre cfv wceq rediv syl3anc ) ACGHBIHBJKCBL
        MNOCNOBLMPEDFCBQR $.

      $( Imaginary part of a division.  Related to ~ remul2 .  (Contributed by
         Mario Carneiro, 29-May-2016.) $)
      imdivd $p |- ( ph -> ( Im ` ( B / A ) ) = ( ( Im ` B ) / A ) ) $=
        ( cc wcel cr cc0 wne cdiv co cim cfv wceq imdiv syl3anc ) ACGHBIHBJKCBL
        MNOCNOBLMPEDFCBQR $.
    $}

    crred.2 $e |- ( ph -> B e. RR ) $.
    $( The real part of a complex number representation.  Definition 10-3.1 of
       [Gleason] p. 132.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    crred $p |- ( ph -> ( Re ` ( A + ( _i x. B ) ) ) = A ) $=
      ( cr wcel ci cmul co caddc cre cfv wceq crre syl2anc ) ABFGCFGBHCIJKJLMBN
      DEBCOP $.

    $( The imaginary part of a complex number representation.  Definition
       10-3.1 of [Gleason] p. 132.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    crimd $p |- ( ph -> ( Im ` ( A + ( _i x. B ) ) ) = B ) $=
      ( cr wcel ci cmul co caddc cim cfv wceq crim syl2anc ) ABFGCFGBHCIJKJLMCN
      DEBCOP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Square root; absolute value
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c sqr $. $( Positive square root of a positive real number. $)
  $c abs $. $( Absolute value function. $)
  $c +- $. $( Plus-or-minus symbol (for comments only) $)

  $( Extend class notation to include square root of a complex number. $)
  csqr $a class sqr $.

  $( Extend class notation to include a function for the absolute value
     (modulus) of a complex number. $)
  cabs $a class abs $.

  ${
    $d x y A $.
    $( Define a function whose value is the square root of a complex number.
       Since ` ( y ^ 2 ) = x ` iff ` ( -u y ^ 2 ) = x ` , we ensure uniqueness
       by restricting the range to numbers with positive real part, or numbers
       with 0 real part and nonnegative imaginary part.  A description can be
       found under "Principal square root of a complex number" at
       ~ http://en.wikipedia.org/wiki/Square_root .  The square root symbol was
       introduced in 1525 by Christoff Rudolff.

       See ~ sqrcl for its closure, ~ sqrval for its value, ~ sqrth and
       ~ sqsqri for its relationship to squares, and ~ sqr11i for uniqueness.
       (Contributed by NM, 27-Jul-1999.)  (Revised by Mario Carneiro,
       8-Jul-2013.) $)
    df-sqr $a |- sqr = ( x e. CC |-> ( iota_ y e. CC ( ( y ^ 2 ) = x /\
      0 <_ ( Re ` y ) /\ ( _i x. y ) e/ RR+ ) ) ) $.

    $( Define the function for the absolute value (modulus) of a complex
       number.  See ~ abscli for its closure and ~ absval or ~ absval2i for its
       value.  (Contributed by NM, 27-Jul-1999.) $)
    df-abs $a |- abs = ( x e. CC |-> ( sqr ` ( x x. ( * ` x ) ) ) ) $.

    $( Value of square root function.  (Contributed by Mario Carneiro,
       8-Jul-2013.) $)
    sqrval $p |- ( A e. CC -> ( sqr ` A ) =
      ( iota_ x e. CC ( ( x ^ 2 ) = A /\
        0 <_ ( Re ` x ) /\ ( _i x. x ) e/ RR+ ) ) ) $=
      ( vy cv c2 cexp co wceq cc0 cre cfv cle wbr ci cmul crp wnel w3a cc crio
      csqr eqeq2 3anbi1d riotabidv df-sqr riotaex fvmpt ) CBADZEFGZCDZHZIUHJKLM
      ZNUHOGPQZRZASTUIBHZULUMRZASTSUAUJBHZUNUPASUQUKUOULUMUJBUIUBUCUDCAUEUPASUF
      UG $.

    $( The absolute value (modulus) of a complex number.  Proposition 10-3.7(a)
       of [Gleason] p. 133.  (Contributed by NM, 27-Jul-1999.)  (Revised by
       Mario Carneiro, 7-Nov-2013.) $)
    absval $p |- ( A e. CC -> ( abs ` A ) = ( sqr ` ( A x. ( * ` A ) ) ) ) $=
      ( vx cv ccj cfv cmul co csqr cc cabs wceq fveq2 oveq12 fveq2d df-abs fvex
      mpdan fvmpt ) BABCZSDEZFGZHEAADEZFGZHEIJSAKZUAUCHUDTUBKUAUCKSADLSATUBFMQN
      BOUCHPR $.
  $}

  $( A real number does not lie on the negative imaginary axis.  (Contributed
     by Mario Carneiro, 8-Jul-2013.) $)
  rennim $p |- ( A e. RR -> ( _i x. A ) e/ RR+ ) $=
    ( cr wcel ci cmul co crp wn wnel cc0 wceq cre cfv cc wi ax-icn recn sylancr
    mulcl rpre rereb syl5ib caddc addid2d fveq2d crre mpan eqtr3d eqeq1d sylibd
    syl 0re rpne0 necon2bi eqcoms syl6 pm2.01d df-nel sylibr ) ABCZDAEFZGCZHZVA
    GIUTVBUTVBJVAKZVCUTVBVALMZVAKZVDUTVANCZVBVFOUTDNCANCVGPAQDASRZVBVABCVGVFVAT
    VAUAUBUKUTVEJVAUTJVAUCFZLMZVEJUTVIVALUTVAVHUDUEJBCUTVJJKULJAUFUGUHUIUJVCVAJ
    VBVAJVAUMUNUOUPUQVAGURUS $.

  $( The specification of restriction to the right half-plane partitions the
     complex plane without 0 into two disjoint pieces, which are related by a
     reflection about the origin (under the map ` x |-> -u x ` ).  (Contributed
     by Mario Carneiro, 8-Jul-2013.) $)
  cnpart $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( ( 0 <_ ( Re ` A ) /\ ( _i x. A ) e/ RR+ ) <->
      -. ( 0 <_ ( Re ` -u A ) /\ ( _i x. -u A ) e/ RR+ ) ) ) $=
    ( wcel cc0 wne wa cre cfv cle wbr ci cmul co crp cneg wn wb wceq ax-icn syl
    cr wnel df-nel simpr 0le0 syl6eqbr biantrurd syl5bbr con1bid cim mulcl mpan
    cc reim0b imre cdiv c1 ine0 divrec2 mp3an23 irec oveq1i syl6eq eqtr3d eqtrd
    divcan3 fveq2d eqeq1d biimpar adantlr mulne0 mpanl12 adantr syl2anc con2bid
    bitrd rpneg syl6bbr syl5breqr necon3bbid rpre nsyl sylibr biantrud 0re recl
    3bitrrd clt ltlen ltnle bitr3d sylancr ad2antrr renegcl negnegd eleq1d mtod
    syl5ib notbid pm2.61dane breq2d le0neg1d bitr4d mulneg2 neleq1 anbi12d
    reneg ) AULBZACDZEZCAFGZHIZJAKLZMUAZEZXJCHIZXLNZMUAZEZOZCANZFGZHIZJXTKLZMUA
    ZEZOZXIXNXSPXJCXIXJCQZEZXSXPMBZXMXNYHYIXRYIOZXQYHXRXPMUBZYHXOXQYHXJCCHXIYGU
    CZUDUEUFUGUHYHYIXLMBZOZXMYHYMYIYHXLTBZXLCDZYMYJPXGYGYOXHXGYOYGXGYOXLUIGZCQZ
    YGXGXLULBZYOYRPJULBZXGYSRJAUJUKZXLUMSXGYQXJCXGYQJNZXLKLZFGZXJXGYSYQUUDQUUAX
    LUNSXGUUCAFXGXLJUOLZUUCAXGUUEUPJUOLZXLKLZUUCXGYSUUEUUGQZUUAYSYTJCDZUUHRUQXL
    JURUSSUUFUUBXLKUTVAVBXGYTUUIUUEAQRUQAJVEUSVCVFVDVGVOZVHVIXIYPYGYTUUIXIYPRUQ
    JAVJVKVLXLVPVMVNXLMUBZVQYHXKXMYHCCXJHUDYLVRUFWFXIXJCDZEZXNXOOZXSUUMXKXNUUNU
    UMXMXKUUMYNXMUUMYOYMXIYOOUULXIYOXJCXGYOYGPXHUUJVLVSVHZXLVTWAUUKWBWCUUMXKXKU
    ULEZUUNUUMUULXKXIUULUCWCXGUUPUUNPZXHUULXGCTBZXJTBZUUQWDAWEZUURUUSECXJWGIUUP
    UUNCXJWHCXJWIWJWKWLVOWJUUMXOXRUUMXQXOUUMYJXQUUMXPTBZYIUUMUVAYOUUOUVAXPNZTBZ
    UUMYOXPWMXGUVCYOPXHUULXGUVBXLTXGXLUUAWNWOWLWQWPXPVTWAYKWBWCWRVOWSXGYFXSPXHX
    GYEXRXGYBXOYDXQXGYBCXJNZHIXOXGYAUVDCHAXFWTXGXJUUTXAXBXGYCXPQZYDXQPYTXGUVERJ
    AXCUKYCXPMXDSXEWRVLXB $.

  $( Square root of zero.  (Contributed by Mario Carneiro, 9-Jul-2013.) $)
  sqr0lem $p |- ( ( A e. CC /\ ( ( A ^ 2 ) = 0 /\
        0 <_ ( Re ` A ) /\ ( _i x. A ) e/ RR+ ) ) <-> A = 0 ) $=
    ( cc wcel c2 cexp co cc0 wceq cre cfv cle wbr ci cmul crp wnel w3a wa sqeq0
    cr biimpa 3ad2antr1 0re eleq1 mpbiri recnd sq0i 0le0 fveq2 syl6eq syl5breqr
    re0 rennim syl 3jca jca impbii ) ABCZADEFGHZGAIJZKLZMANFOPZQZRAGHZURVAUSVDV
    BURUSVDASUAUBVDURVCVDAVDATCZGTCUCAGTUDUEZUFVDUSVAVBAUGVDGGUTKUHVDUTGIJGAGIU
    IULUJUKVDVEVBVFAUMUNUOUPUQ $.

  $( Square root of zero.  (Contributed by Mario Carneiro, 9-Jul-2013.) $)
  sqr0 $p |- ( sqr ` 0 ) = 0 $=
    ( vx cc0 csqr cfv cv c2 cexp co wceq cre cle wbr ci cmul wnel cc wcel ax-mp
    crp 0cn w3a crio sqrval id wb wa sqr0lem biimpi simpr sylbir impbid1 adantl
    ex riota5 eqtri ) BCDZAEZFGHBIBUQJDKLMUQNHSOUAZAPUBZBBPQZUPUSITABUCRUTUSBIT
    UTURAPBUTUDUQPQZURUQBIZUEUTVAURVBVAURVBVAURUFZVBUQUGZUHUMVBVCURVDVAURUIUJUK
    ULUNRUO $.

  ${
    $d a b u v y z S $.  $d a b v x y z A $.  $d v y z B $.
    sqrlem1.1 $e |- S = { x e. RR+ | ( x ^ 2 ) <_ A } $.
    sqrlem1.2 $e |- B = sup ( S , RR , < ) $.
    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem1 $p |- ( ( A e. RR+ /\ A <_ 1 ) -> A. y e. S y <_ 1 ) $=
      ( crp wcel c1 cle wbr wa cv c2 cexp co cr rpre ad2antrl weq breq1d elrab2
      oveq1 simprr simplr wi resqcld ad2antrr 1re letr mp3an3 syl2anc syl6breqr
      mp2and sq1 cc0 wb rpge0 0le1 le2sq mpanr12 mpbird ex syl5bi ralrimiv ) CH
      IZCJKLZMZBNZJKLZBEVJEIVJHIZVJOPQZCKLZMZVIVKANZOPQZCKLVNAVJHEABUAVQVMCKVPV
      JOPUDUBFUCVIVOVKVIVOMZVKVMJOPQZKLZVRVMJVSKVRVNVHVMJKLZVIVLVNUEVGVHVOUFVRV
      MRIZCRIZVNVHMWAUGZVRVJVLVJRIZVIVNVJSTZUHVGWCVHVOCSUIWBWCJRIZWDUJVMCJUKULU
      MUOUPUNVRWEUQVJKLZVKVTURZWFVLWHVIVNVJUSTWEWHMWGUQJKLWIUJUTVJJVAVBUMVCVDVE
      VF $.

    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem2 $p |- ( ( A e. RR+ /\ A <_ 1 ) -> A e. S ) $=
      ( crp wcel c1 cle wbr wa c2 cexp co simpl cmul cr wceq adantr cc0 wb rpre
      clt rpgt0 1re lemul1 mp3an2 syl12anc biimpa rpcn sqval eqcomd syl mulid2d
      cc 3brtr3d cv oveq1 breq1d elrab2 sylanbrc ) BGHZBIJKZLZVCBMNOZBJKZBDHVCV
      DPVEBBQOZIBQOZVFBJVCVDVHVIJKZVCBRHZVKUABUDKZVDVJUBZBUCZVNBUEVKIRHVKVLLVMU
      FBIBUGUHUIUJVEBUPHZVHVFSVCVOVDBUKZTVOVFVHBULUMUNVCVIBSVDVCBVPUOTUQAURZMNO
      ZBJKVGABGDVQBSVRVFBJVQBMNUSUTEVAVB $.

    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem3 $p |- ( ( A e. RR+ /\ A <_ 1 ) ->
      ( S C_ RR /\ S =/= (/) /\ E. z e. RR A. y e. S y <_ z ) ) $=
      ( crp wcel c1 cle wbr wa cr wss c0 wne cv wral wrex c2 cexp ssrab2 rpssre
      co crab sstri eqsstri a1i sqrlem2 ne0i syl 1re sqrlem1 wceq breq2 ralbidv
      rspcev sylancr 3jca ) DIJDKLMNZFOPZFQRZBSZCSZLMZBFTZCOUAZVCVBFASUBUCUFDLM
      ZAIUGZOGVKIOVJAIUDUEUHUIUJVBDFJVDADEFGHUKFDULUMVBKOJVEKLMZBFTZVIUNABDEFGH
      UOVHVMCKOVFKUPVGVLBFVFKVELUQURUSUTVA $.

    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem4 $p |- ( ( A e. RR+ /\ A <_ 1 ) -> ( B e. RR+ /\ B <_ 1 ) ) $=
      ( vz vy crp wcel c1 cle wbr wa cr clt cv wral cc0 adantr csup wss c0 wrex
      wne w3a sqrlem3 suprcl syl5eqel rpgt0 sqrlem2 suprub syl2anc syl6breqr wi
      syl 0re ltletr mp3an1 mp2and elrpd sqrlem1 wb 1re suprleub sylancl mpbird
      rpre syl5eqbr jca ) BIJZBKLMZNZCIJCKLMVMCVMCDOPUAZOFVMDOUBDUCUEGQZHQLMGDR
      HOUDUFZVNOJAGHBCDEFUGZHGDUHUPUIZVMSBPMZBCLMZSCPMZVKVSVLBUJTVMBVNCLVMVPBDJ
      BVNLMVQABCDEFUKHGDBULUMFUNVMBOJZCOJZVSVTNWAUOZVKWBVLBVHTVRSOJWBWCWDUQSBCU
      RUSUMUTVAVMCVNKLFVMVNKLMZVOKLMGDRZAGBCDEFVBVMVPKOJWEWFVCVQVDHGGDKVEVFVGVI
      VJ $.

    $d u v T $.
    sqrlem5.3 $e |- T = { y | E. a e. S E. b e. S y = ( a x. b ) } $.
    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem5 $p |- ( ( A e. RR+ /\ A <_ 1 ) ->
      ( ( T C_ RR /\ T =/= (/) /\ E. v e. RR A. u e. T u <_ v ) /\
        ( B ^ 2 ) = sup ( T , RR , < ) ) ) $=
      ( vz crp wcel cle wbr cr cv c1 wa wss c0 wne wral wrex w3a c2 cexp co clt
      csup wceq cc0 crab ssrab2 eqsstri sseli rpge0d a1i sqrlem3 pm4.24 3anbi1i
      rgen supmullem2 syl3anc cmul sqrlem4 rpre adantr syl recnd sqvald oveq12i
      supmul syl5eq eqtrd jca ) EOPEUAQRUBZHSUCHUDUEDTCTZQRDHUFCSUGUHZFUIUJUKZH
      SULUMZUNVTUOWAQRZCGUFZGSUCGUDUENTWAQRNGUFCSUGUHZWGWBWFVTWECGWAGPWAGOWAGAT
      UIUJUKEQRZAOUPOKWHAOUQURUSUTVEVAZANCEFGKLVBZWJWFWGWGUHZCNBDIGGHJMWFWFWFUB
      WGWGWFVCVDZVFVGVTWCFFVHUKZWDVTFVTFVTFOPZFUAQRZUBFSPZAEFGKLVIWNWPWOFVJVKVL
      VMVNVTWMGSULUMZWQVHUKZWDFWQFWQVHLLVOVTWFWGWGWRWDUNWIWJWJWKCNBIGGHJMWLVPVG
      VQVRVS $.

    $d a b v x y A $.  $d v y B $.
    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem6 $p |- ( ( A e. RR+ /\ A <_ 1 ) -> ( B ^ 2 ) <_ A ) $=
      ( vv wcel cle wbr wa c2 co cr wb vu crp c1 cexp clt csup wss c0 wral wrex
      wne cv w3a wceq sqrlem5 simprd cmul vex weq eqeq1 2rexbidv elab2 wi oveq1
      breq1d elrab2 simplbi cc0 rpre adantr adantl rpgt0 lemul1 syl112anc rpcnd
      syl2an sqvald breq2d simprbi ad2antll rpred remulcl resqcld ad2antrr letr
      bitr4d syl3anc mpan2d sylbid lemul2 ad2antrl sqrlem3 simp1d sseld anim12d
      wo imp letric syl mpjaod ex breq1 biimprcd syl6 rexlimdvv syl5bi ralrimiv
      simpld suprleub syl2anc mpbird eqbrtrd ) CUBMZCUCNOZPZDQUDRZFSUEUFZCNXOFS
      UGFUHUKUAULLULZNOUAFUILSUJUMZXPXQUNZABLUACDEFGHIJKUOZUPXOXQCNOZXRCNOZLFUI
      ZXOYCLFXRFMXRGULZHULZUQRZUNZHEUJGEUJZXOYCBULZYGUNZHEUJGEUJYIBXRFLURBLUSYK
      YHGHEEYJXRYGUTVAKVBXOYHYCGHEEXOYEEMZYFEMZPZYGCNOZYHYCVCXOYNYOXOYNPZYEYFNO
      ZYOYFYENOZYPYQYGYFQUDRZNOZYOYNYQYTTXOYNYQYGYFYFUQRZNOZYTYLYEUBMZYFUBMZYQU
      UBTZYMYLUUCYEQUDRZCNOZAULZQUDRZCNOZUUGAYEUBEAGUSUUIUUFCNUUHYEQUDVDVEIVFZV
      GZYMUUDYSCNOZUUJUUMAYFUBEAHUSUUIYSCNUUHYFQUDVDVEIVFZVGZUUCUUDPZYESMZYFSMZ
      UURVHYFUEOZUUEUUCUUQUUDYEVIVJZUUDUURUUCYFVIVKZUVAUUDUUSUUCYFVLVKYEYFYFVMV
      NVPYMYTUUBTYLYMYSUUAYGNYMYFYMYFUUOVOVQVRVKWFVKYPYTUUMYOYMUUMXOYLYMUUDUUMU
      UNVSVTYPYGSMZYSSMZCSMZYTUUMPYOVCYNUVBXOYLUUQUURUVBYMYLYEUULWAZYMYFUUOWAZY
      EYFWBVPVKZYMUVCXOYLYMYFUVFWCVTXMUVDXNYNCVIZWDZYGYSCWEWGWHWIYPYRYGUUFNOZYO
      YNYRUVJTXOYNYRYGYEYEUQRZNOZUVJYLUUCUUDYRUVLTZYMUULUUOUUPUURUUQUUQVHYEUEOZ
      UVMUVAUUTUUTUUCUVNUUDYEVLVJYFYEYEWJVNVPYLUVJUVLTYMYLUUFUVKYGNYLYEYLYEUULV
      OVQVRVJWFVKYPUVJUUGYOYLUUGXOYMYLUUCUUGUUKVSWKYPUVBUUFSMZUVDUVJUUGPYOVCUVG
      YLUVOXOYMYLYEUVEWCWKUVIYGUUFCWEWGWHWIYPUUQUURPZYQYRWPXOYNUVPXOYLUUQYMUURX
      OESYEXOESUGEUHUKXRYJNOLEUIBSUJALBCDEIJWLWMZWNXOESYFUVQWNWOWQYEYFWRWSWTXAY
      HYCYOXRYGCNXBXCXDXEXFXGXOXSUVDYBYDTXOXSXTYAXHXMUVDXNUVHVJLUALFCXIXJXKXL
      $.

    $( Lemma for ~ 01sqrex .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrlem7 $p |- ( ( A e. RR+ /\ A <_ 1 ) -> ( B ^ 2 ) = A ) $=
      ( crp wcel c1 cle wbr c2 co c3 cr vz wa cexp wceq sqrlem6 cmin cdiv caddc
      clt wn wss c0 wne cv wral wrex w3a sqrlem3 adantr sqrlem4 simpld rpre syl
      resqcld resubcld cc0 posdifd biimpa elrpd 3re 3pos elrpii rpdivcl sylancl
      rpaddcld cmul cc recnd cn 3nn nndivre binom2 syl2anc 2re remulcld remulcl
      sylancr addassd mulass mp3an1 eqcomd sqvald oveq12d adddird eqtr4d simprd
      eqtrd 2cn 2pos 1re lemul2 mp3an2 mpanr12 mpbid ax-1rid ax-mp syl6breq a1i
      wb sqge0d addge01d lesubaddd mpbird simplr letrd nnge1 wi letr mpan2i mpd
      mp3an23 syl6breqr ledivmul le2add mp2and readdcld lemul1d divcan2 breqtrd
      df-3 3cn 3ne0 eqbrtrd leaddsub2d oveq1 breq1d crab cbvrabv eqtri elrab2
      sylanbrc suprub rpgt0d ltaddposd ltnled syldan pm2.65da eqleltd mpbir2and
      csup bitrd ) CLMZCNOPZUBZDQUCRZCUDUUOCOPUUOCUIPZUJABCDEFGHIJKUEUUNUUPDCUU
      OUFRZSUGRZUHRZDOPZUUNUUPUBZETUKEULUMUAUNBUNZOPUAEUOBTUPUQZUUSEMZUUTUUNUVC
      UUPAUABCDEIJURUSUVAUUSLMUUSQUCRZCOPZUVDUVADUURUVADLMZDNOPZUUNUVGUVHUBZUUP
      ACDEIJUTZUSVAUVAUUQLMSLMUURLMUVAUUQUUNUUQTMZUUPUUNCUUOUULCTMZUUMCVBUSZUUN
      DUUNUVIDTMZUVJUVGUVNUVHDVBUSVCZVDZVEZUSZUUNUUPVFUUQUIPUUNUUOCUVPUVMVGVHVI
      SVJVKVLUUQSVMVNZVOUVAUVEUUOQDUURVPRZVPRZUURQUCRZUHRZUHRZCOUVAUVEUUOUWAUHR
      UWBUHRZUWDUVADVQMZUURVQMZUVEUWEUDUVADUUNUVNUUPUVOUSZVRZUVAUURUUNUURTMZUUP
      UUNUVKSVSMZUWJUVQVTUUQSWAVNZUSZVRZDUURWBWCUVAUUOUWAUWBUVAUUOUUNUUOTMUUPUV
      PUSZVRUVAUWAUVAQTMZUVTTMUWATMWDUVADUURUWHUWMWEQUVTWFWGZVRUVAUWBUVAUURUWMV
      DZVRWHWQUVAUWDCOPUWCUUQOPUVAUWCQDVPRZUURUHRZUURVPRZUUQOUVAUWCUWSUURVPRZUU
      RUURVPRZUHRUXAUVAUWAUXBUWBUXCUHUVAUXBUWAUVAUWFUWGUXBUWAUDZUWIUWNQVQMUWFUW
      GUXDWRQDUURWIWJWCWKUVAUURUWNWLWMUVAUWSUURUURUVAUWSUVAUWPUVNUWSTMZWDUWHQDW
      FWGZVRUWNUWNWNWOUVAUXASUURVPRZUUQOUVAUWTSOPUXAUXGOPUVAUWTQNUHRZSOUVAUWSQO
      PZUURNOPZUWTUXHOPZUVAUWSQNVPRZQOUUNUWSUXLOPZUUPUUNUVHUXMUUNUVGUVHUVJWPUUN
      UVNUVHUXMXIZUVOUVNUWPVFQUIPZUXNWDWSUVNNTMZUWPUXOUBUXNWTDNQXAXBXCVCXDUSUWP
      UXLQUDWDQXEXFXGUVAUXJUUQSNVPRZOPZUVAUUQSUXQOUVAUUQNOPZUUQSOPZUVAUUQCNUVRU
      UNUVLUUPUVMUSZUXPUVAWTXHUVAUUQCOPCCUUOUHROPZUVAVFUUOOPUYBUVADUWHXJUVACUUO
      UYAUWOXKXDUVACUUOCUYAUWOUYAXLXMUULUUMUUPXNXOUVAUXSNSOPZUXTUWKUYCVTSXPXFUV
      AUVKUXSUYCUBUXTXQZUVRUVKUXPSTMZUYDWTVJUUQNSXRYAVCXSXTUYEUXQSUDVJSXEXFYBUV
      AUVKUXJUXRXIZUVRUVKUYEVFSUIPZUYFVJVKUVKUXPUYEUYGUBUYFWTUUQNSYCXBXCVCXMUVA
      UXEUWJUXIUXJUBUXKXQZUXFUWMUXEUWJUBUWPUXPUYHWDWTUWSUURQNYDXCWCYEYJYBUVAUWT
      SUURUVAUWSUURUXFUWMYFUYEUVAVJXHUVSYGXDUVAUUQVQMZUXGUUQUDZUVAUUQUVRVRUYISV
      QMSVFUMUYJYKYLUUQSYHYAVCYIYMUVAUUOUWCCUWOUVAUWAUWBUWQUWRYFUYAYNXMYMUVBQUC
      RZCOPZUVFBUUSLEUVBUUSUDUYKUVECOUVBUUSQUCYOYPEAUNZQUCRZCOPZALYQUYLBLYQIUYO
      UYLABLUYMUVBUDUYNUYKCOUYMUVBQUCYOYPYRYSYTUUAUVCUVDUBUUSETUIUUJDOBUAEUUSUU
      BJYBWCUUNUUPVFUURUIPZUUTUJZUVAUURUVSUUCUUNUYPUYQUUNUYPDUUSUIPUYQUUNUURDUW
      LUVOUUDUUNDUUSUVOUUNDUURUVOUWLYFUUEUUKVHUUFUUGUUNUUOCUVPUVMUUHUUI $.
  $}

  ${
    $d A w x y z $.
    $( Existence of a square root for reals in the interval ` ( 0 , 1 ] ` .
       (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    01sqrex $p |- ( ( A e. RR+ /\ A <_ 1 ) ->
      E. x e. RR+ ( x <_ 1 /\ ( x ^ 2 ) = A ) ) $=
      ( vy vz vw crp wcel c1 cle wbr wa cv c2 cexp co crab cr wceq wrex eqid
      clt csup sqrlem4 cmul sqrlem7 breq1 eqeq1d anbi12d rspcev anassrs syl2anc
      cab oveq1 ) BFGBHIJKCLMNOBIJCFPZQUAUBZFGZUOHIJZKUOMNOZBRZALZHIJZUTMNOZBRZ
      KZAFSZCBUOUNUNTZUOTZUCCDBUOUNDLELUTUDORAUNSEUNSDULZEAVFVGVHTUEUPUQUSVEVDU
      QUSKAUOFUTUORZVAUQVCUSUTUOHIUFVIVBURBUTUOMNUMUGUHUIUJUK $.
  $}

  ${
    $d A x y $.
    $( Existence of a square root for positive reals.  (Contributed by Mario
       Carneiro, 9-Jul-2013.) $)
    resqrex $p |- ( ( A e. RR /\ 0 <_ A ) ->
      E. x e. RR ( 0 <_ x /\ ( x ^ 2 ) = A ) ) $=
      ( vy cr wcel cc0 cle wbr wa c1 c2 cexp co wceq wi clt 0re crp cdiv syldan
      cv wrex wo wb leloe mpan elrp 01sqrex rprege0 anass sylib adantrl reximi2
      anim1i syl sylanbr exp31 sq0 syl5eq 0le0 jctil breq2 oveq1 eqeq1d anbi12d
      id rspcev sylancr a1d a1i jaod sylbid imp 0lt1 1re ltletr mp3an12 biimpri
      mpani rpreccld simpr lerec mpanl12 mpbid ax-1cn syl6breq syl2anc w3a rpre
      div1i 3ad2ant2 rpgt0 wne gt0ne0 rereccl recgt0 ltle sylc cc adantr sqrecd
      recn simp3r oveq2d recrec sylan 3ad2ant1 3eqtrd syl12anc rexlimdv3a simpl
      mpd ex letric sylancl mpjaod ) BDEZFBGHZIZBJGHZFAUAZGHZYAKLMZBNZIZADUBZJB
      GHZXQXRXTYFOZXQXRFBPHZFBNZUCZYHFDEZXQXRYKUDQFBUEUFXQYIYHYJXQYIXTYFXQYIIZB
      REZXTYFBUGZYNXTIYAJGHZYDIZARUBYFABUHYQYEARDYAREZYDYADEZYEIZYPYRYDIYSYBIZY
      DIYTYRUUAYDYAUIUNYSYBYDUJUKULUMUOUPUQYJYHOXQYJYFXTYJYLFFGHZFKLMZBNZIZYFQY
      JUUDUUBYJUUCFBURYJVFUSUTVAYEUUEAFDYAFNZYBUUBYDUUDYAFFGVBUUFYCUUCBYAFKLVCV
      DVEVGVHVIVJVKVLVMXQYGYFOXRXQYGYFXQYGIZCUAZJGHZUUHKLMZJBSMZNZIZCRUBZYFUUGU
      UKREUUKJGHUUNUUGBXQYGYIYNXQYGYIXQFJPHZYGYIVNYLJDEZXQUUOYGIYIOQVOFJBVPVQVS
      VMZYNYMYOVRTVTUUGUUKJJSMZJGUUGYGUUKUURGHZXQYGWAXQYGYIYGUUSUDZUUQUUPUUOYMU
      UTVOVNJBWBWCTWDJWEWJWFCUUKUHWGUUGUUMYFCRUUGUUHREZUUMWHZJUUHSMZDEZFUVCGHZU
      VCKLMZBNZYFUVBUUHDEZFUUHPHZUVDUVAUUGUVHUUMUUHWIWKZUVAUUGUVIUUMUUHWLWKZUVH
      UVIUUHFWMUVDUUHWNZUUHWOTZWGUVBUVHUVIUVEUVJUVKUVHUVIIZUVDFUVCPHZUVEUVMUUHW
      PYLUVDUVOUVEOQFUVCWQUFWRWGUVBUVFJUUJSMZJUUKSMZBUVBUVHUVIUVFUVPNUVJUVKUVNU
      UHUVHUUHWSEUVIUUHXBWTUVLXAWGUVBUUJUUKJSUUGUVAUUIUULXCXDUUGUVAUVQBNZUUMXQY
      GBFWMZUVRXQYGYIUVSUUQBWNTXQBWSEUVSUVRBXBBXEXFTXGXHYEUVEUVGIAUVCDYAUVCNZYB
      UVEYDUVGYAUVCFGVBUVTYCUVFBYAUVCKLVCVDVEVGXIXJXLXMWTXSXQUUPXTYGUCXQXRXKVOB
      JXNXOXP $.

    $( Uniqueness for the square root function.  (Contributed by Mario
       Carneiro, 9-Jul-2013.)  (Revised by NM, 17-Jun-2017.) $)
    sqrmo $p |- ( A e. CC -> E* x e. CC ( ( x ^ 2 ) = A /\
        0 <_ ( Re ` x ) /\ ( _i x. x ) e/ RR+ ) ) $=
      ( vy cc wcel c2 cexp co wceq cc0 cre cfv cle wbr ci cmul crp wnel wa wi
      cv w3a weq wral wrmo wn cneg wo simplr1 simprr1 eqtr4d wb sqeqor ad2ant2r
      mpbid ord 3simpc fveq2 breq2d oveq2 neleq1 syl anbi12d syl5ibcom ad2antlr
      syld negeq neg0 syl6eq eqeq2d eqeq2 bitr4d biimpcd necon3bd cnpart syl5ib
      wne syli impancom adantl pm2.65d notnotrd an4s a1i ralrimivv oveq1 eqeq1d
      ex 3anbi123d rmo4 sylibr ) BDEZAUAZFGHZBIZJWMKLZMNZOWMPHZQRZUBZCUAZFGHZBI
      ZJXAKLZMNZOXAPHZQRZUBZSZACUCZTZCDUDADUDWTADUEWLXKACDDWMDEZXADEZSZXKTWLXNX
      IXJXLWTXMXHXJXLWTSZXMXHSZSZXJXQXJUFZJXAUGZKLZMNZOXSPHZQRZSZXQXRWMXSIZYDXQ
      XJYEXQWNXBIZXJYEUHZXQWNBXBWOWQWSXLXPUIXCXEXGXMXOUJUKXLXMYFYGULWTXHWMXAUMU
      NUOUPZWTYEYDTXLXPWTWQWSSYEYDWOWQWSUQYEWQYAWSYCYEWPXTJMWMXSKURUSYEWRYBIWSY
      CULWMXSOPUTWRYBQVAVBVCVDVEVFXQXRXAJVQZYDUFZXRXQYEYIYHYEXJXAJXAJIZYEXJYKYE
      WMJIXJYKXSJWMYKXSJUGJXAJVGVHVIVJXAJWMVKVLVMVNVRXPYIYJTXOXMYIXHYJXHXEXGSXM
      YISYJXCXEXGUQXAVOVPVSVTVFWAWBWCWHWDWEWTXHACDXJWOXCWQXEWSXGXJWNXBBWMXAFGWF
      WGXJWPXDJMWMXAKURUSXJWRXFIWSXGULWMXAOPUTWRXFQVAVBWIWJWK $.
  $}

  ${
    $d A x $.
    $( Existence and uniqueness for the real square root function.
       (Contributed by Mario Carneiro, 9-Jul-2013.) $)
    resqreu $p |- ( ( A e. RR /\ 0 <_ A ) -> E! x e. CC ( ( x ^ 2 ) = A /\
        0 <_ ( Re ` x ) /\ ( _i x. x ) e/ RR+ ) ) $=
      ( cr wcel cc0 cle wbr wa cv c2 cexp co wceq cre cfv wrex recn adantr syl
      cc cmul crp wnel w3a wrmo wreu resqrex simprr rere breq2d biimpar adantrr
      ci rennim 3jca jca reximi2 sqrmo reu5 sylanbrc ) BCDZEBFGZHZAIZJKLBMZEVDN
      OZFGZUMVDUALUBUCZUDZATPZVIATUEZVIATUFVCEVDFGZVEHZACPVJABUGVMVIACTVDCDZVMH
      ZVDTDZVIVNVPVMVDQRVOVEVGVHVNVLVEUHVNVLVGVEVNVGVLVNVFVDEFVDUIUJUKULVNVHVMV
      DUNRUOUPUQSVCBTDZVKVAVQVBBQRABURSVIATUSUT $.
  $}

  ${
    $d A x y z $.
    $( Closure of the square root function.  (Contributed by Mario Carneiro,
       9-Jul-2013.) $)
    resqrcl $p |- ( ( A e. RR /\ 0 <_ A ) -> ( sqr ` A ) e. RR ) $=
      ( vy vx cr wcel cc0 cle wbr c2 cexp co wceq cfv w3a cre cmul crp 3ad2ant2
      ci cc wrex csqr resqrex wnel crio simp1l recn sqrval 3syl simp3r breqtrrd
      wa cv simp3l rere rennim 3jca wreu wb resqreu 3ad2ant1 oveq1 eqeq1d fveq2
      breq2d oveq2 neleq1 3anbi123d riota2 syl2anc mpbid eqtrd simp2 rexlimdv3a
      syl eqeltrd mpd ) ADEZFAGHZULZFBUMZGHZWAIJKZALZULZBDUAAUBMZDEZBAUCVTWEWGB
      DVTWADEZWENZWFWADWIWFCUMZIJKZALZFWJOMZGHZSWJPKZQUDZNZCTUEZWAWIVRATEWFWRLV
      RVSWHWEUFAUGCAUHUIWIWDFWAOMZGHZSWAPKZQUDZNZWRWALZWIWDWTXBVTWHWBWDUJWIFWAW
      SGVTWHWBWDUNWHVTWSWALWEWAUORUKWHVTXBWEWAUPRUQWIWATEZWQCTURZXCXDUSWHVTXEWE
      WAUGRVTWHXFWECAUTVAWQXCCTWAWJWALZWLWDWNWTWPXBXGWKWCAWJWAIJVBVCXGWMWSFGWJW
      AOVDVEXGWOXALWPXBUSWJWASPVFWOXAQVGVOVHVIVJVKVLVTWHWEVMVPVNVQ $.

    $( Lemma for ~ resqrth .  (Contributed by Mario Carneiro, 9-Jul-2013.) $)
    resqrthlem $p |- ( ( A e. RR /\ 0 <_ A ) -> ( ( ( sqr ` A ) ^ 2 ) = A /\
        0 <_ ( Re ` ( sqr ` A ) ) /\ ( _i x. ( sqr ` A ) ) e/ RR+ ) ) $=
      ( vx wcel cc0 cle wbr cfv c2 cexp co wceq cre ci cmul crp wnel w3a cc syl
      wb cr wa csqr cv crio recn sqrval eqcomd wreu resqrcl recnd resqreu oveq1
      adantr eqeq1d fveq2 breq2d oveq2 neleq1 3anbi123d riota2 syl2anc mpbird )
      AUACZDAEFZUBZAUCGZHIJZAKZDVGLGZEFZMVGNJZOPZQZBUDZHIJZAKZDVOLGZEFZMVONJZOP
      ZQZBRUEZVGKZVDWDVEVDARCZWDAUFWEVGWCBAUGUHSUNVFVGRCWBBRUIVNWDTVFVGAUJUKBAU
      LWBVNBRVGVOVGKZVQVIVSVKWAVMWFVPVHAVOVGHIUMUOWFVRVJDEVOVGLUPUQWFVTVLKWAVMT
      VOVGMNURVTVLOUSSUTVAVBVC $.
  $}

  $( Square root theorem over the reals.  Theorem I.35 of [Apostol] p. 29.
     (Contributed by Mario Carneiro, 9-Jul-2013.) $)
  resqrth $p |- ( ( A e. RR /\ 0 <_ A ) -> ( ( sqr ` A ) ^ 2 ) = A ) $=
    ( cr wcel cc0 cle wbr wa csqr cfv c2 cexp wceq cre cmul crp wnel resqrthlem
    co ci simp1d ) ABCDAEFGAHIZJKRALDUAMIEFSUANROPAQT $.

  $( Square of square root.  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
  remsqsqr $p |- ( ( A e. RR /\ 0 <_ A ) ->
    ( ( sqr ` A ) x. ( sqr ` A ) ) = A ) $=
    ( cr wcel cc0 cle wbr wa csqr cfv c2 cexp cmul resqrcl recnd sqvald resqrth
    co eqtr3d ) ABCDAEFGZAHIZJKQTTLQASTSTAMNOAPR $.

  $( The square root function is nonnegative for nonnegative input.
     (Contributed by NM, 26-May-1999.)  (Revised by Mario Carneiro,
     9-Jul-2013.) $)
  sqrge0 $p |- ( ( A e. RR /\ 0 <_ A ) -> 0 <_ ( sqr ` A ) ) $=
    ( cr wcel cc0 cle wbr wa csqr cfv cre c2 cexp wceq cmul crp wnel resqrthlem
    co ci simp2d resqrcl rered breqtrd ) ABCDAEFGZDAHIZJIZUEEUDUEKLRAMDUFEFSUEN
    ROPAQTUDUEAUAUBUC $.

  $( The square root function is positive for positive input.  (Contributed by
     Mario Carneiro, 10-Jul-2013.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
  sqrgt0 $p |- ( ( A e. RR /\ 0 < A ) -> 0 < ( sqr ` A ) ) $=
    ( cr wcel cc0 clt wbr wa csqr cfv cle wi 0re ltle imp resqrcl syldan sqrge0
    mpan wne wceq gt0ne0 c2 cexp sq0i resqrth eqeq1d syl5ib necon3d mpd ne0gt0d
    co ) ABCZDAEFZGZAHIZULUMDAJFZUOBCULUMUPDBCULUMUPKLDAMRNZAOPULUMUPDUOJFUQAQP
    UNADSUODSAUAUNUODADUODTUOUBUCUKZDTUNADTUOUDUNURADULUMUPURATUQAUEPUFUGUHUIUJ
    $.

  $( Square root distributes over multiplication.  (Contributed by NM,
     30-Jul-1999.)  (Revised by Mario Carneiro, 29-May-2016.) $)
  sqrmul $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
             ( sqr ` ( A x. B ) ) = ( ( sqr ` A ) x. ( sqr ` B ) ) ) $=
    ( cr wcel cc0 cle wbr wa cmul co cfv remulcld resqrcl syl2anc adantr sqrge0
    csqr c2 cexp resqrth simpll simprl mulge0 adantl mulge0d oveqan12d 3eqtr4rd
    recnd sqmuld wceq sq11d ) ACDZEAFGZHZBCDZEBFGZHZHZABIJZQKZAQKZBQKZIJZURUSCD
    ZEUSFGZUTCDURABULUMUQUAUNUOUPUBLZABUCZUSMNURVAVBUNVACDUQAMOZUQVBCDUNBMUDZLU
    RVDVEEUTFGVFVGUSPNURVAVBVHVIUNEVAFGUQAPOUQEVBFGUNBPUDUEURVARSJZVBRSJZIJUSVC
    RSJUTRSJZUNUQVJAVKBIATBTUFURVAVBURVAVHUHURVBVIUHUIURVDVEVLUSUJVFVGUSTNUGUK
    $.

  $( Square root is monotonic.  (Contributed by NM, 17-Mar-2005.)  (Proof
     shortened by Mario Carneiro, 29-May-2016.) $)
  sqrle $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
      ( A <_ B <-> ( sqr ` A ) <_ ( sqr ` B ) ) ) $=
    ( cr wcel cc0 cle wbr wa csqr cfv c2 cexp co wb resqrcl sqrge0 le2sq syl2an
    jca resqrth breqan12d bitr2d ) ACDEAFGHZBCDEBFGHZHAIJZBIJZFGZUEKLMZUFKLMZFG
    ZABFGUCUECDZEUEFGZHUFCDZEUFFGZHUGUJNUDUCUKULAOAPSUDUMUNBOBPSUEUFQRUCUDUHAUI
    BFATBTUAUB $.

  $( Square root is strictly monotonic.  Closed form of ~ sqrlti .
     (Contributed by Scott Fenton, 17-Apr-2014.)  (Proof shortened by Mario
     Carneiro, 29-May-2016.) $)
  sqrlt $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
    ( A < B <-> ( sqr ` A ) < ( sqr ` B ) ) ) $=
    ( cr wcel cc0 cle wbr wa wn csqr cfv clt ancoms notbid simpll simprl ltnled
    wb sqrle resqrcl adantr adantl 3bitr4d ) ACDZEAFGZHZBCDZEBFGZHZHZBAFGZIBJKZ
    AJKZFGZIABLGUMULLGUJUKUNUIUFUKUNRBASMNUJABUDUEUIOUFUGUHPQUJUMULUFUMCDUIATUA
    UIULCDUFBTUBQUC $.

  $( The square root function is one-to-one.  (Contributed by Scott Fenton,
     11-Jun-2013.) $)
  sqr11 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
    ( ( sqr ` A ) = ( sqr ` B ) <-> A = B ) ) $=
    ( cr wcel cc0 cle wbr wa csqr cfv c2 cexp co wceq wb resqrcl sqrge0 resqrth
    jca sq11 syl2an eqeqan12d bitr3d ) ACDEAFGHZBCDEBFGHZHAIJZKLMZBIJZKLMZNZUFU
    HNZABNUDUFCDZEUFFGZHUHCDZEUHFGZHUJUKOUEUDULUMAPAQSUEUNUOBPBQSUFUHTUAUDUEUGA
    UIBARBRUBUC $.

  $( A square root is zero iff its argument is 0.  (Contributed by NM,
     27-Jul-1999.)  (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  sqr00 $p |- ( ( A e. RR /\ 0 <_ A ) ->
               ( ( sqr ` A ) = 0 <-> A = 0 ) ) $=
    ( csqr cfv cc0 wceq cr wcel cle wbr wa sqr0 eqeq2i 0re 0le0 mpanr12 syl5bbr
    wb sqr11 ) ABCZDESDBCZEZAFGDAHIJZADEZTDSKLUBDFGDDHIUAUCQMNADROP $.

  $( The square root of a positive real is a postive real.  (Contributed by NM,
     22-Feb-2008.) $)
  rpsqrcl $p |- ( A e. RR+ -> ( sqr ` A ) e. RR+ ) $=
    ( crp wcel csqr cfv cc0 cle wbr rpre rpge0 resqrcl syl2anc clt rpgt0 sqrgt0
    cr elrpd ) ABCZADEZRAPCZFAGHSPCAIZAJAKLRTFAMHFSMHUAANAOLQ $.

  $( Square root distributes over division.  (Contributed by Mario Carneiro,
     5-May-2016.) $)
  sqrdiv $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR+ ) ->
             ( sqr ` ( A / B ) ) = ( ( sqr ` A ) / ( sqr ` B ) ) ) $=
    ( cr wcel cc0 cle wbr wa crp cdiv csqr cfv cmul rerpdivcl adantlr clt recnd
    co adantl eqtr3d elrp divge0 sylan2b resqrcl syl2anc rpsqrcl rpcnd divcan4d
    rpne0d wceq rprege0 sqrmul syl21anc simpll wne rpne0 divcan1d fveq2d oveq1d
    cc rpcn ) ACDZEAFGZHZBIDZHZABJRZKLZBKLZMRZVIJRVHAKLZVIJRVFVHVIVFVHVFVGCDZEV
    GFGZVHCDVBVEVLVCABNOZVEVDBCDZEBPGHVMBUAABUBUCZVGUDUEQVFVIVEVIIDVDBUFSZUGVFV
    IVQUIUHVFVJVKVIJVFVGBMRZKLZVJVKVFVLVMVOEBFGHZVSVJUJVNVPVEVTVDBUKSVGBULUMVFV
    RAKVFABVFAVBVCVEUNQVEBUTDVDBVASVEBEUOVDBUPSUQURTUST $.

  $( The square root of a negative number.  (Contributed by Mario Carneiro,
     9-Jul-2013.) $)
  sqrneglem $p |- ( ( A e. RR /\ 0 <_ A ) ->
      ( ( ( _i x. ( sqr ` A ) ) ^ 2 ) = -u A /\
        0 <_ ( Re ` ( _i x. ( sqr ` A ) ) ) /\
        ( _i x. ( _i x. ( sqr ` A ) ) ) e/ RR+ ) ) $=
    ( cr wcel cc0 cle wbr ci cfv cmul co cexp cneg wceq cre crp ax-icn recn syl
    c2 cc wa csqr c1 resqrcl sqmul sylancr i2 a1i resqrth oveq12d adantr mulm1d
    wnel 3eqtrd renegcl 0re cim imre eqtr3d eqle 3syl mul2neg fveq2d breqtrd wn
    reim0 ixi oveq1i mulass mp3an12 mulm1 3eqtr3a clt sqrge0 wb le0neg2 sylancl
    lenlt bitrd mpbid biantrurd elrp syl6rbbr mtbird eqneltrd df-nel sylibr
    3jca ) ABCZDAEFZUAZGAUBHZIJZSKJZALZMDWMNHZEFGWMIJZOUMZWKWNGSKJZWLSKJZIJZUCL
    ZAIJWOWKGTCZWLTCZWNXAMPWKWLBCZXDAUDZWLQRZGWLUEUFWKWSXBWTAIWSXBMWKUGUHAUIUJW
    KAWIATCWJAQUKULUNWKDGLWLLZIJZNHZWPEWKXEXHBCZDXJEFZXFWLUOZXKDBCZDXJMXLUPXKXH
    UQHZDXJXHVFXKXHTCXOXJMXHQXHURRUSDXJUTUFVAWKXIWMNWKXCXDXIWMMPXGGWLVBUFVCVDWK
    WQOCVEWRWKWQXHOWKXDWQXHMXGXDGGIJZWLIJZXBWLIJWQXHXPXBWLIVGVHXCXCXDXQWQMPPGGW
    LVIVJWLVKVLRWKXHOCZDXHVMFZWKDWLEFZXSVEZAVNWKXEXTYAVOXFXEXTXHDEFZYAWLVPXEXKX
    NYBYAVOXMUPXHDVRVQVSRVTWKXSXKXSUAXRWKXKXSWKXEXKXFXMRWAXHWBWCWDWEWQOWFWGWH
    $.

  ${
    $d A x y $.
    $( The square root of a negative number.  (Contributed by Mario Carneiro,
       9-Jul-2013.) $)
    sqrneg $p |- ( ( A e. RR /\ 0 <_ A ) ->
        ( sqr ` -u A ) = ( _i x. ( sqr ` A ) ) ) $=
      ( vx wcel cc0 cle wbr csqr cfv c2 cexp co wceq cre ci cmul crp w3a cc syl
      wnel cr cneg crio recn adantr negcld sqrval sqrneglem wreu ax-icn resqrcl
      wa cv wb recnd mulcl sylancr wrex wrmo oveq1 eqeq1d fveq2 oveq2 3anbi123d
      breq2d neleq1 rspcev syl2anc sqrmo reu5 sylanbrc riota2 mpbid eqtrd ) AUA
      CZDAEFZULZAUBZGHZBUMZIJKZVRLZDVTMHZEFZNVTOKZPTZQZBRUCZNAGHZOKZVQVRRCZVSWH
      LVQAVOARCVPAUDUEUFZBVRUGSVQWJIJKZVRLZDWJMHZEFZNWJOKZPTZQZWHWJLZAUHZVQWJRC
      ZWGBRUIZWSWTUNVQNRCWIRCXBUJVQWIAUKUONWIUPUQZVQWGBRURZWGBRUSZXCVQXBWSXEXDX
      AWGWSBWJRVTWJLZWBWNWDWPWFWRXGWAWMVRVTWJIJUTVAXGWCWODEVTWJMVBVEXGWEWQLWFWR
      UNVTWJNOVCWEWQPVFSVDZVGVHVQWKXFWLBVRVISWGBRVJVKWGWSBRWJXHVLVHVMVN $.
  $}

  $( Relationship between square root and squares.  (Contributed by NM,
     31-Jul-1999.)  (Revised by Mario Carneiro, 29-May-2016.) $)
  sqrsq2 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
    ( ( sqr ` A ) = B <-> A = ( B ^ 2 ) ) ) $=
    ( cr wcel cc0 cle wbr wa csqr cfv c2 cexp co wceq resqrcl sqrge0 sq11 sylan
    wb jca resqrth adantr eqeq1d bitr3d ) ACDEAFGHZBCDEBFGHZHZAIJZKLMZBKLMZNZUH
    BNZAUJNUEUHCDZEUHFGZHUFUKULSUEUMUNAOAPTUHBQRUGUIAUJUEUIANUFAUAUBUCUD $.

  $( Square root of square.  (Contributed by NM, 14-Jan-2006.)  (Revised by
     Mario Carneiro, 29-May-2016.) $)
  sqrsq $p |- ( ( A e. RR /\ 0 <_ A ) -> ( sqr ` ( A ^ 2 ) ) = A ) $=
    ( cr wcel cc0 cle wbr wa c2 cexp co csqr cfv wceq eqid wb resqcl jca adantr
    sqge0 sqrsq2 mpancom mpbiri ) ABCZDAEFZGZAHIJZKLAMZUFUFMZUFNUFBCZDUFEFZGZUE
    UGUHOUCUKUDUCUIUJAPASQRUFATUAUB $.

  $( Square root of square.  (Contributed by NM, 2-Aug-1999.)  (Revised by
     Mario Carneiro, 29-May-2016.) $)
  sqrmsq $p |- ( ( A e. RR /\ 0 <_ A ) -> ( sqr ` ( A x. A ) ) = A ) $=
    ( cr wcel cc0 cle wbr wa c2 cexp co csqr cfv cmul simpl recnd sqvald fveq2d
    sqrsq eqtr3d ) ABCZDAEFZGZAHIJZKLAAMJZKLAUBUCUDKUBAUBATUANOPQARS $.

  $( The square root of 1 is 1.  (Contributed by NM, 31-Jul-1999.) $)
  sqr1 $p |- ( sqr ` 1 ) = 1 $=
    ( c1 c2 cexp co csqr cfv sq1 fveq2i cr wcel cc0 cle wbr wceq 1re 0le1 sqrsq
    mp2an eqtr3i ) ABCDZEFZAEFATAEGHAIJKALMUAANOPAQRS $.

  $( The square root of 4 is 2.  (Contributed by NM, 3-Aug-1999.) $)
  sqr4 $p |- ( sqr ` 4 ) = 2 $=
    ( c2 cexp co csqr cfv c4 sq2 fveq2i cr wcel cc0 cle wbr wceq 2re 0re ltleii
    2pos sqrsq mp2an eqtr3i ) AABCZDEZFDEAUBFDGHAIJKALMUCANOKAPORQASTUA $.

  $( The square root of 9 is 3.  (Contributed by NM, 11-May-2004.) $)
  sqr9 $p |- ( sqr ` 9 ) = 3 $=
    ( c3 c2 cexp co csqr cfv c9 sq3 fveq2i wcel cc0 cle wbr wceq 3re 0re ltleii
    cr 3pos sqrsq mp2an eqtr3i ) ABCDZEFZGEFAUCGEHIARJKALMUDANOKAPOSQATUAUB $.

  $( The square root of 2 is bounded by 1 and 2.  (Contributed by Roy F.
     Longton, 8-Aug-2005.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
  sqr2gt1lt2 $p |- ( 1 < ( sqr ` 2 ) /\ ( sqr ` 2 ) < 2 ) $=
    ( c1 c2 csqr cfv clt wbr sqr1 cr wcel cc0 cle wb 2re 0re ltleii sqrlt mp4an
    mpbi c4 4re 1lt2 1re 0le1 2pos eqbrtrri 2lt4 4pos sqr4 breqtri pm3.2i ) ABC
    DZEFUKBEFACDZAUKEGABEFZULUKEFZUAAHIJAKFBHIZJBKFZUMUNLUBUCMJBNMUDOZABPQRUEUK
    SCDZBEBSEFZUKUREFZUFUOUPSHIJSKFUSUTLMUQTJSNTUGOBSPQRUHUIUJ $.

  $( The imaginary unit is the square root of negative 1.  A lot of people like
     to call this the "definition" of ` _i ` , but the definition of ` sqr `
     ~ df-sqr has already been crafted with ` _i ` being mentioned explicitly,
     and in any case it doesn't make too much sense to define a value based on
     a function evaluated outside its domain.  A more appropriate view is to
     take ~ ax-i2m1 or ~ i2 as the "definition", and simply postulate the
     existence of a number satisfying this property.  This is the approach we
     take here.  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
  sqrm1 $p |- _i = ( sqr ` -u 1 ) $=
    ( c1 cneg csqr cfv ci cmul co cr wcel cc0 cle wbr wceq 1re 0le1 sqrneg sqr1
    mp2an oveq2i ax-icn mulid1i 3eqtrri ) ABCDZEACDZFGZEAFGEAHIJAKLUCUEMNOAPRUD
    AEFQSETUAUB $.

  $( Absolute value of negative.  (Contributed by NM, 27-Feb-2005.) $)
  absneg $p |- ( A e. CC -> ( abs ` -u A ) = ( abs ` A ) ) $=
    ( cc wcel cneg ccj cfv cmul co csqr cabs cjneg oveq2d wceq cjcl mpdan eqtrd
    mul2neg fveq2d negcl absval syl 3eqtr4d ) ABCZADZUDEFZGHZIFZAAEFZGHZIFUDJFZ
    AJFUCUFUIIUCUFUDUHDZGHZUIUCUEUKUDGAKLUCUHBCULUIMANAUHQOPRUCUDBCUJUGMASUDTUA
    ATUB $.

  $( Real closure of absolute value.  (Contributed by NM, 3-Oct-1999.) $)
  abscl $p |- ( A e. CC -> ( abs ` A ) e. RR ) $=
    ( cc wcel cabs cfv ccj cmul co csqr cr absval cc0 cle wbr cjmulrcl cjmulge0
    resqrcl syl2anc eqeltrd ) ABCZADEAAFEGHZIEZJAKTUAJCLUAMNUBJCAOAPUAQRS $.

  $( The absolute value of a number and its conjugate are the same.
     Proposition 10-3.7(b) of [Gleason] p. 133.  (Contributed by NM,
     28-Apr-2005.) $)
  abscj $p |- ( A e. CC -> ( abs ` ( * ` A ) ) = ( abs ` A ) ) $=
    ( cc wcel ccj cfv cabs cmul co csqr wceq cjcl absval syl mulcom cjcj oveq2d
    mpdan eqtr4d fveq2d ) ABCZADEZFEZAUAGHZIEZAFETUBUAUADEZGHZIEZUDTUABCZUBUGJA
    KZUALMTUCUFITUCUAAGHZUFTUHUCUJJUIAUANQTUEAUAGAOPRSRALR $.

  $( Square of value of absolute value function.  (Contributed by NM,
     16-Jan-2006.) $)
  absvalsq $p |- ( A e. CC -> ( ( abs ` A ) ^ 2 ) = ( A x. ( * ` A ) ) ) $=
    ( cc wcel cabs cfv c2 cexp ccj cmul csqr absval oveq1d cc0 cle wbr cjmulrcl
    co cr wceq cjmulge0 resqrth syl2anc eqtrd ) ABCZADEZFGQAAHEIQZJEZFGQZUFUDUE
    UGFGAKLUDUFRCMUFNOUHUFSAPATUFUAUBUC $.

  $( Square of value of absolute value function.  (Contributed by NM,
     1-Feb-2007.) $)
  absvalsq2 $p |- ( A e. CC -> ( ( abs ` A ) ^ 2 ) =
                    ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
    ( cc wcel cabs cfv c2 cexp ccj cmul cre cim caddc absvalsq cjmulval eqtrd
    co ) ABCADEFGPAAHEIPAJEFGPAKEFGPLPAMANO $.

  $( Square of absolute value of sum.  Proposition 10-3.7(g) of [Gleason]
     p. 133.  (Contributed by NM, 21-Jan-2007.) $)
  sqabsadd $p |- ( ( A e. CC /\ B e. CC ) -> ( ( abs ` ( A + B ) ) ^ 2 ) =
                  ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) )
                    + ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) ) $=
    ( cc wcel wa caddc co ccj cmul cabs c2 cexp oveq2d wceq cjcl mpdan absvalsq
    cfv eqtrd sylan2 cre cjadd anim12i muladd addcl syl mulcom oveqan12d addcjd
    mulcl cjmul cjcj adantl eqtr3d oveq12d 3eqtr4d ) ACDZBCDZEZABFGZUTHRZIGZAAH
    RZIGZBHRZBIGZFGZAVEIGZVCBIGZFGZFGZUTJRKLGZAJRKLGZBJRKLGZFGZKVHUARIGZFGUSVBU
    TVCVEFGZIGZVKUSVAVQUTIABUBMUSVCCDZVECDZEVRVKNUQVSURVTAOBOZUCABVCVEUDPSUSUTC
    DVLVBNABUEUTQUFUSVOVGVPVJFUQURVMVDVNVFFAQURVNBVEIGZVFBQURVTWBVFNWABVEUGPSUH
    USVHVHHRZFGVPVJUSVHURUQVTVHCDWAAVEUJTUIUSWCVIVHFUSWCVCVEHRZIGZVIURUQVTWCWEN
    WAAVEUKTUSWDBVCIURWDBNUQBULUMMSMUNUOUP $.

  $( Square of absolute value of difference.  (Contributed by NM,
     21-Jan-2007.) $)
  sqabssub $p |- ( ( A e. CC /\ B e. CC ) -> ( ( abs ` ( A - B ) ) ^ 2 ) =
                  ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) )
                    - ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) ) $=
    ( cc wcel wa cmin co ccj cfv cmul caddc cabs c2 cexp oveq2d wceq cjcl mpdan
    eqtrd absvalsq cre cjsub anim12i mulsub subcl mulcom oveqan12d mulcl sylan2
    syl addcjd cjmul cjcj adantl eqtr3d oveq12d 3eqtr4d ) ACDZBCDZEZABFGZVAHIZJ
    GZAAHIZJGZBHIZBJGZKGZAVFJGZVDBJGZKGZFGZVALIMNGZALIMNGZBLIMNGZKGZMVIUAIJGZFG
    UTVCVAVDVFFGZJGZVLUTVBVRVAJABUBOUTVDCDZVFCDZEVSVLPURVTUSWAAQBQZUCABVDVFUDRS
    UTVACDVMVCPABUEVATUJUTVPVHVQVKFURUSVNVEVOVGKATUSVOBVFJGZVGBTUSWAWCVGPWBBVFU
    FRSUGUTVIVIHIZKGVQVKUTVIUSURWAVICDWBAVFUHUIUKUTWDVJVIKUTWDVDVFHIZJGZVJUSURW
    AWDWFPWBAVFULUIUTWEBVDJUSWEBPURBUMUNOSOUOUPUQ $.

  $( Value of absolute value function.  Definition 10.36 of [Gleason] p. 133.
     (Contributed by NM, 17-Mar-2005.) $)
  absval2 $p |- ( A e. CC -> ( abs ` A ) =
               ( sqr ` ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) ) $=
    ( cc wcel cabs cfv ccj cmul co csqr cre c2 cim caddc absval cjmulval fveq2d
    cexp eqtrd ) ABCZADEAAFEGHZIEAJEKQHALEKQHMHZIEANSTUAIAOPR $.

  $( The absolute value of 0.  (Contributed by NM, 26-Mar-2005.)  (Revised by
     Mario Carneiro, 29-May-2016.) $)
  abs0 $p |- ( abs ` 0 ) = 0 $=
    ( cc0 cabs cfv ccj cmul co csqr cc wcel wceq 0cn absval ax-mp mul02i fveq2i
    cjcli sqr0 3eqtri ) ABCZAADCZEFZGCZAGCAAHISUBJKALMUAAGTAKPNOQR $.

  $( The absolute value of the imaginary unit.  (Contributed by NM,
     26-Mar-2005.) $)
  absi $p |- ( abs ` _i ) = 1 $=
    ( ci cabs cfv ccj cmul co csqr c1 cc wcel wceq ax-icn absval ax-mp cneg cji
    oveq2i mulneg2i ixi 3eqtri negeqi ax-1cn negnegi eqtri fveq2i sqr1 ) ABCZAA
    DCZEFZGCZHGCHAIJUGUJKLAMNUIHGUIAAOZEFAAEFZOZHUHUKAEPQAALLRUMHOZOHULUNSUAHUB
    UCUDTUEUFT $.

  $( Absolute value is nonnegative.  (Contributed by NM, 20-Nov-2004.)
     (Revised by Mario Carneiro, 29-May-2016.) $)
  absge0 $p |- ( A e. CC -> 0 <_ ( abs ` A ) ) $=
    ( cc wcel cc0 ccj cfv cmul co csqr cabs cle cr wbr cjmulrcl cjmulge0 sqrge0
    syl2anc absval breqtrrd ) ABCZDAAEFGHZIFZAJFKTUALCDUAKMDUBKMANAOUAPQARS $.

  $( The absolute value of a nonzero number is a positive real.  (Contributed
     by FL, 27-Dec-2007.)  (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  absrpcl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( abs ` A ) e. RR+ ) $=
    ( cc wcel cc0 wne wa cabs cfv ccj cmul co csqr crp wceq absval adantr simpl
    cjmulrcld cjmulge0d cjcld simpr cjne0d mulne0d ne0gt0d rpsqrcl syl eqeltrd
    elrpd ) ABCZADEZFZAGHZAAIHZJKZLHZMUIULUONUJAOPUKUNMCUOMCUKUNUKAUIUJQZRZUKUN
    UQUKAUPSUKAUMUPUKAUPTUIUJUAZUKAUPURUBUCUDUHUNUEUFUG $.

  $( The absolute value of a number is zero iff the number is zero.
     Proposition 10-3.7(c) of [Gleason] p. 133.  (Contributed by NM,
     26-Sep-2005.)  (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  abs00 $p |- ( A e. CC -> ( ( abs ` A ) = 0 <-> A = 0 ) ) $=
    ( cc wcel cabs cfv cc0 wceq wne wa absrpcl rpne0d necon4d fveq2 abs0 syl6eq
    ex impbid1 ) ABCZADEZFGAFGZRAFSFRAFHZSFHRUAISAJKPLTSFDEFAFDMNOQ $.

  ${
    abs00ad.1 $e |- ( ph -> A e. CC ) $.
    $( A complex number is zero iff its absolute value is zero.  Deduction form
       of ~ abs00 .  (Contributed by David Moews, 28-Feb-2017.) $)
    abs00ad $p |- ( ph -> ( ( abs ` A ) = 0 <-> A = 0 ) ) $=
      ( cc wcel cabs cfv cc0 wceq wb abs00 syl ) ABDEBFGHIBHIJCBKL $.
  $}

  ${
    abs00bd.1 $e |- ( ph -> A = 0 ) $.
    $( If a complex number is zero, its absolute value is zero.  Converse of
       ~ abs00d .  One-way deduction form of ~ abs00 .  (Contributed by David
       Moews, 28-Feb-2017.) $)
    abs00bd $p |- ( ph -> ( abs ` A ) = 0 ) $=
      ( cabs cfv cc0 wceq cc 0cn syl6eqel abs00ad mpbird ) ABDEFGBFGCABABFHCIJK
      L $.
  $}

  $( Square of the absolute value of a number that has been decomposed into
     real and imaginary parts.  (Contributed by NM, 1-Feb-2007.) $)
  absreimsq $p |- ( ( A e. RR /\ B e. RR ) ->
         ( ( abs ` ( A + ( _i x. B ) ) ) ^ 2 ) = ( ( A ^ 2 ) + ( B ^ 2 ) ) ) $=
    ( cr wcel wa ci cmul co caddc cabs cfv cexp cre cim wceq recn ax-icn oveq1d
    c2 cc mulcl sylancr addcl syl2an absvalsq2 syl crre crim oveq12d eqtrd ) AC
    DZBCDZEZAFBGHZIHZJKSLHZUOMKZSLHZUONKZSLHZIHZASLHZBSLHZIHUMUOTDZUPVAOUKATDUN
    TDZVDULAPULFTDBTDVEQBPFBUAUBAUNUCUDUOUEUFUMURVBUTVCIUMUQASLABUGRUMUSBSLABUH
    RUIUJ $.

  $( Absolute value of a number that has been decomposed into real and
     imaginary parts.  (Contributed by NM, 14-Jan-2006.) $)
  absreim $p |- ( ( A e. RR /\ B e. RR ) -> ( abs ` ( A + ( _i x. B ) ) ) =
               ( sqr ` ( ( A ^ 2 ) + ( B ^ 2 ) ) ) ) $=
    ( cr wcel wa ci cmul co caddc cabs cfv c2 cexp csqr cc0 cle wbr cc recn syl
    wceq ax-icn mulcl sylancr addcl syl2an abscl absge0 sqrsq syl2anc absreimsq
    fveq2d eqtr3d ) ACDZBCDZEZAFBGHZIHZJKZLMHZNKZUSALMHBLMHIHZNKUPUSCDZOUSPQZVA
    USUAUPURRDZVCUNARDUQRDZVEUOASUOFRDBRDVFUBBSFBUCUDAUQUEUFZURUGTUPVEVDVGURUHT
    USUIUJUPUTVBNABUKULUM $.

  $( Absolute value distributes over multiplication.  Proposition 10-3.7(f) of
     [Gleason] p. 133.  (Contributed by NM, 11-Oct-1999.)  (Revised by Mario
     Carneiro, 29-May-2016.) $)
  absmul $p |- ( ( A e. CC /\ B e. CC ) ->
                ( abs ` ( A x. B ) ) = ( ( abs ` A ) x. ( abs ` B ) ) ) $=
    ( cc wcel wa cmul co ccj cfv csqr cabs cjcld eqtrd cr cc0 cle wceq cjmulrcl
    wbr absval cjmul oveq2d simpl simpr mul4d fveq2d cjmulge0 jca sqrmul syl2an
    mulcl syl oveqan12d 3eqtr4d ) ACDZBCDZEZABFGZURHIZFGZJIZAAHIZFGZJIZBBHIZFGZ
    JIZFGZURKIZAKIZBKIZFGUQVAVCVFFGZJIZVHUQUTVLJUQUTURVBVEFGZFGVLUQUSVNURFABUAU
    BUQABVBVEUOUPUCZUOUPUDZUQAVOLUQBVPLUEMUFUOVCNDZOVCPSZEVFNDZOVFPSZEVMVHQUPUO
    VQVRARAUGUHUPVSVTBRBUGUHVCVFUIUJMUQURCDVIVAQABUKURTULUOUPVJVDVKVGFATBTUMUN
    $.

  $( Absolute value distributes over division.  (Contributed by NM,
     27-Apr-2005.) $)
  absdiv $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) ->
                ( abs ` ( A / B ) ) = ( ( abs ` A ) / ( abs ` B ) ) ) $=
    ( cc wcel cc0 wne w3a cdiv co cabs cfv cr divcl abscl syl recnd crp absrpcl
    cmul eqtr3d 3adant1 rpcnd rpne0d divcan4d wceq simp2 absmul syl2anc divcan1
    fveq2d oveq1d ) ACDZBCDZBEFZGZABHIZJKZBJKZSIZURHIUQAJKZURHIUOUQURUOUQUOUPCD
    ZUQLDABMZUPNOPUOURUMUNURQDULBRUAZUBUOURVCUCUDUOUSUTURHUOUPBSIZJKZUSUTUOVAUM
    VEUSUEVBULUMUNUFUPBUGUHUOVDAJABUIUJTUKT $.

  $( A nonnegative number is its own absolute value.  (Contributed by NM,
     11-Oct-1999.)  (Revised by Mario Carneiro, 29-May-2016.) $)
  absid $p |- ( ( A e. RR /\ 0 <_ A ) -> ( abs ` A ) = A ) $=
    ( cr wcel cc0 cle wbr wa cabs cfv ccj cmul co csqr c2 cexp wceq simpl recnd
    cc absval syl cjred oveq2d sqvald eqtr4d fveq2d sqrsq 3eqtrd ) ABCZDAEFZGZA
    HIZAAJIZKLZMIZANOLZMIAUKASCULUOPUKAUIUJQZRZATUAUKUNUPMUKUNAAKLUPUKUMAAKUKAU
    QUBUCUKAURUDUEUFAUGUH $.

  $( The absolute value of 1.  Common special case.  (Contributed by David A.
     Wheeler, 16-Jul-2016.) $)
  abs1 $p |- ( abs ` 1 ) = 1 $=
    ( c1 cr wcel cc0 cle wbr cabs cfv wceq 1re 0le1 absid mp2an ) ABCDAEFAGHAIJ
    KALM $.

  $( A negative number is the negative of its own absolute value.  (Contributed
     by NM, 27-Feb-2005.) $)
  absnid $p |- ( ( A e. RR /\ A <_ 0 ) -> ( abs ` A ) = -u A ) $=
    ( cr wcel cc0 cle wbr cabs cfv cneg wceq le0neg1 wa recn absneg syl renegcl
    cc adantr absid sylan eqtr3d ex sylbid imp ) ABCZADEFZAGHZAIZJZUEUFDUHEFZUI
    AKUEUJUIUEUJLUHGHZUGUHUEUKUGJZUJUEAQCULAMANORUEUHBCUJUKUHJAPUHSTUAUBUCUD $.

  $( A real number is less than or equal to its absolute value.  (Contributed
     by NM, 27-Feb-2005.) $)
  leabs $p |- ( A e. RR -> A <_ ( abs ` A ) ) $=
    ( cr wcel cabs cfv cle wbr cc0 0re a1i wceq absid eqcom eqle sylan2b syldan
    id cc recn syl absge0 wa wi abscl letr mp3an2 mpdan mpan2d imp lecasei ) AB
    CZAADEZFGZHAHBCZUKIJUKQUKHAFGULAKZUMALUOUKAULKUMULAMAULNOPUKAHFGZUMUKUPHULF
    GZUMUKARCZUQASZAUATUKULBCZUPUQUBUMUCZUKURUTUSAUDTUKUNUTVAIAHULUEUFUGUHUIUJ
    $.

  $( The absolute value of a real number is either that number or its
     negative.  (Contributed by NM, 27-Feb-2005.) $)
  absor $p |- ( A e. RR -> ( ( abs ` A ) = A \/ ( abs ` A ) = -u A ) ) $=
    ( cr wcel cc0 cle wbr wo cabs cfv wceq cneg 0re letric mpan absid ex absnid
    orim12d mpd ) ABCZDAEFZADEFZGZAHIZAJZUDAKJZGDBCTUCLDAMNTUAUEUBUFTUAUEAOPTUB
    UFAQPRS $.

  $( Absolute value of a real number.  (Contributed by NM, 17-Mar-2005.) $)
  absre $p |- ( A e. RR -> ( abs ` A ) = ( sqr ` ( A ^ 2 ) ) ) $=
    ( cr wcel cabs cfv ccj cmul co csqr c2 cexp cc wceq recn absval sqvald cjre
    syl oveq2d eqtr4d fveq2d ) ABCZADEZAAFEZGHZIEZAJKHZIEUBALCUCUFMANZAORUBUGUE
    IUBUGAAGHUEUBAUHPUBUDAAGAQSTUAT $.

  $( Square of the absolute value of a real number.  (Contributed by NM,
     16-Jan-2006.) $)
  absresq $p |- ( A e. RR -> ( ( abs ` A ) ^ 2 ) = ( A ^ 2 ) ) $=
    ( cr wcel ccj cmul co cabs c2 cexp cjre oveq2d cc wceq recn absvalsq sqvald
    cfv syl 3eqtr4d ) ABCZAADQZEFZAAEFAGQHIFZAHIFTUAAAEAJKTALCUCUBMANZAORTAUDPS
    $.

  $( ` A ` is divisible by ` B ` iff its absolute value is.  (Contributed by
     Jeff Madsen, 2-Sep-2009.) $)
  absmod0 $p |- ( ( A e. RR /\ B e. RR+ ) ->
                    ( ( A mod B ) = 0 <-> ( ( abs ` A ) mod B ) = 0 ) ) $=
    ( cr wcel crp wa cabs cfv wceq cmo co cc0 wb wi oveq1 eqcoms eqeq1d negmod0
    cneg a1i bibi2d syl5ibrcom wo absor adantr mpjaod ) ACDZBEDZFZAGHZAIZABJKZL
    IZUJBJKZLIZMZUJASZIZUKUPNUIUKULUNLULUNIAUJAUJBJOPQTUIUPURUMUQBJKZLIZMABRURU
    OUTUMURUNUSLUJUQBJOQUAUBUGUKURUCUHAUDUEUF $.

  ${
    $d j k A $.  $d j k N $.
    $( Absolute value of natural number exponentiation.  (Contributed by NM,
       5-Jan-2006.) $)
    absexp $p |- ( ( A e. CC /\ N e. NN0 ) ->
                  ( abs ` ( A ^ N ) ) = ( ( abs ` A ) ^ N ) ) $=
      ( vj vk cn0 wcel cc cexp co cabs cfv wceq wi cc0 c1 fveq2d eqeq12d imbi2d
      oveq2 cmul cv caddc abs1 exp0 abscl recnd exp0d 3eqtr4a oveq1 expp1 expcl
      wa adantl simpl absmul syl2anc eqtrd adantr sylan 3eqtr4d exp31 com12 a2d
      nn0ind impcom ) BEFAGFZABHIZJKZAJKZBHIZLZVFACUAZHIZJKZVIVLHIZLZMVFANHIZJK
      ZVINHIZLZMVFADUAZHIZJKZVIWAHIZLZMVFAWAOUBIZHIZJKZVIWFHIZLZMVFVKMCDBVLNLZV
      PVTVFWKVNVRVOVSWKVMVQJVLNAHSPVLNVIHSQRVLWALZVPWEVFWLVNWCVOWDWLVMWBJVLWAAH
      SPVLWAVIHSQRVLWFLZVPWJVFWMVNWHVOWIWMVMWGJVLWFAHSPVLWFVIHSQRVLBLZVPVKVFWNV
      NVHVOVJWNVMVGJVLBAHSPVLBVIHSQRVFOJKOVRVSUCVFVQOJAUDPVFVIVFVIAUEUFZUGUHWAE
      FZVFWEWJVFWPWEWJMVFWPWEWJVFWPULZWEULWCVITIZWDVITIZWHWIWEWRWSLWQWCWDVITUIU
      MWQWHWRLWEWQWHWBATIZJKZWRWQWGWTJAWAUJPWQWBGFVFXAWRLAWAUKVFWPUNWBAUOUPUQUR
      WQWIWSLZWEVFVIGFWPXBWOVIWAUJUSURUTVAVBVCVDVE $.
  $}

  $( Absolute value of integer exponentiation.  (Contributed by Mario Carneiro,
     6-Apr-2015.) $)
  absexpz $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) ->
                ( abs ` ( A ^ N ) ) = ( ( abs ` A ) ^ N ) ) $=
    ( cz wcel cc cc0 wne cn0 cr wa cexp co cabs cfv wceq absexp ex cdiv syl3anc
    c1 cneg cn wo elznn0nn wi adantr ax-1cn simpll nnnn0 ad2antll expcld simplr
    a1i nnz expne0d absdiv abs1 oveq1i syl2anc oveq2d syl5eq eqtrd simprl recnd
    expneg2 fveq2d abscl ad2antrr 3eqtr4d jaod 3impia syl3an3b ) BCDAEDZAFGZBHD
    ZBIDZBUAZUBDZJZUCZABKLZMNZAMNZBKLZOZBUDVMVNVTWEVMVNJZVOWEVSVMVOWEUEVNVMVOWE
    ABPQUFWFVSWEWFVSJZTAVQKLZRLZMNZTWCVQKLZRLZWBWDWGWJTMNZWHMNZRLZWLWGTEDZWHEDW
    HFGWJWOOWPWGUGUMWGAVQVMVNVSUHZVRVQHDZWFVPVQUIUJZUKWGAVQWQVMVNVSULVRVQCDWFVP
    VQUNUJUOTWHUPSWGWOTWNRLWLWMTWNRUQURWGWNWKTRWGVMWRWNWKOWQWSAVQPUSUTVAVBWGWAW
    IMWGVMBEDZWRWAWIOWQWGBWFVPVRVCVDZWSABVESVFWGWCEDWTWRWDWLOWGWCVMWCIDVNVSAVGV
    HVDXAWSWCBVESVIQVJVKVL $.

  $( Square can be moved in and out of absolute value.  (Contributed by Scott
     Fenton, 18-Apr-2014.)  (Proof shortened by Mario Carneiro,
     29-May-2016.) $)
  abssq $p |- ( A e. CC -> ( ( abs ` A ) ^ 2 ) = ( abs ` ( A ^ 2 ) ) ) $=
    ( cc wcel c2 cexp co cabs cfv cn0 wceq 2nn0 absexp mpan2 eqcomd ) ABCZADEFG
    HZAGHDEFZODICPQJKADLMN $.

  $( The squares of two reals are equal iff their absolute values are equal.
     (Contributed by NM, 6-Mar-2009.) $)
  sqabs $p |- ( ( A e. RR /\ B e. RR ) -> ( ( A ^ 2 ) = ( B ^ 2 ) <->
               ( abs ` A ) = ( abs ` B ) ) ) $=
    ( cr wcel wa c2 cexp co wceq cabs cfv cc0 cle resqcl sqge0 absid syl2anc cc
    wbr recn cn0 2nn0 absexp sylancl eqtr3d eqeqan12d wb absge0 jca sq11 syl2an
    abscl bitrd ) ACDZBCDZEAFGHZBFGHZIAJKZFGHZBJKZFGHZIZURUTIZUNUOUPUSUQVAUNUPJ
    KZUPUSUNUPCDLUPMSVDUPIANAOUPPQUNARDZFUADZVDUSIATZUBAFUCUDUEUOUQJKZUQVAUOUQC
    DLUQMSVHUQIBNBOUQPQUOBRDZVFVHVAIBTZUBBFUCUDUEUFUNVEVIVBVCUGZUOVGVJVEURCDZLU
    RMSZEUTCDZLUTMSZEVKVIVEVLVMAULAUHUIVIVNVOBULBUHUIURUTUJUKUKUM $.

  $( The absolute value of a complex number is greater than or equal to the
     absolute value of its real part.  (Contributed by NM, 1-Apr-2005.) $)
  absrele $p |- ( A e. CC -> ( abs ` ( Re ` A ) ) <_ ( abs ` A ) ) $=
    ( cc wcel cre cfv c2 cexp co csqr cim caddc cabs cle wbr cc0 sqge0d resqcld
    imcl mpbid cr recl addge01d wb readdcld addge0d sqrle syl22anc wceq absval2
    absre syl 3brtr4d ) ABCZADEZFGHZIEZUOAJEZFGHZKHZIEZUNLEZALEMUMUOUSMNZUPUTMN
    ZUMOURMNVBUMUQARZPZUMUOURUMUNAUAZQZUMUQVDQZUBSUMUOTCOUOMNUSTCOUSMNVBVCUCVGU
    MUNVFPZUMUOURVGVHUDUMUOURVGVHVIVEUEUOUSUFUGSUMUNTCVAUPUHVFUNUJUKAUIUL $.

  $( The absolute value of a complex number is greater than or equal to the
     absolute value of its imaginary part.  (Contributed by NM, 17-Mar-2005.)
     (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  absimle $p |- ( A e. CC -> ( abs ` ( Im ` A ) ) <_ ( abs ` A ) ) $=
    ( cc wcel ci cneg cmul co cre cfv cabs cim cle wbr ax-icn negcli a1i mulcld
    id wceq c1 syl imre fveq2d absmul mpan absneg ax-mp absi eqtri oveq1i abscl
    absrele recnd mulid2d syl5eq eqtr2d 3brtr4d ) ABCZDEZAFGZHIZJIZUTJIZAKIZJIA
    JIZLURUTBCVBVCLMURUSAUSBCZURDNOZPURRQUTULUAURVDVAJAUBUCURVCUSJIZVEFGZVEVFUR
    VCVISVGUSAUDUEURVITVEFGVEVHTVEFVHDJIZTDBCVHVJSNDUFUGUHUIUJURVEURVEAUKUMUNUO
    UPUQ $.

  $( The sum of the positive and negative part functions is the absolute value
     function over the reals.  (Contributed by Mario Carneiro, 24-Aug-2014.) $)
  max0add $p |- ( A e. RR ->
    ( if ( 0 <_ A , A , 0 ) + if ( 0 <_ -u A , -u A , 0 ) ) = ( abs ` A ) ) $=
    ( cr wcel cc0 cle wbr cif caddc co wceq 0re wa adantr iftrue biimpa ifeq1da
    wb letri3 ifid syl6eq cneg cabs cfv id cc recn addid1d adantl le0neg2 simpr
    a1i renegcl ad2antrr sylancl mpbir2and oveq12d absid 3eqtr4d negcld addid2d
    mpan2 biimprd impl le0neg1 syl absnid lecasei ) ABCZDAEFZADGZDAUAZEFZVKDGZH
    IZAUBUCZJDADBCZVHKUKVHUDVHVILZADHIAVNVOVQAVHAUECZVIAUFZMUGVQVJAVMDHVIVJAJVH
    VIADNUHVQVMVLDDGDVQVLVKDDVQVLLZVKDJZVKDEFZVLVQWBVLVHVIWBAUIOMVQVLUJVTVKBCZV
    PWAWBVLLQVHWCVIVLAULUMKVKDRUNUOPVLDSTUPAUQURVHADEFZLZDVKHIVKVNVOWEVKWEAVHVR
    WDVSMUSUTWEVJDVMVKHWEVJVIDDGDWEVIADDVHWDVIADJZVHWFWDVILZVHVPWFWGQKADRVAVBVC
    PVIDSTWEVLVMVKJVHWDVLAVDOVLVKDNVEUPAVFURVG $.

  $( A real number is an integer iff its absolute value is an integer.
     (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
     Carneiro, 29-May-2016.) $)
  absz $p |- ( A e. RR -> ( A e. ZZ <-> ( abs ` A ) e. ZZ ) ) $=
    ( cr wcel cabs cfv wceq cz wb cneg eleq1 bicomd a1i recn znegclb syl bibi2d
    wi cc syl5ibrcom absor mpjaod ) ABCZADEZAFZAGCZUCGCZHZUCAIZFZUDUGQUBUDUFUEU
    CAGJKLUBUGUIUEUHGCZHZUBARCUKAMANOUIUFUJUEUCUHGJPSATUA $.

  $( The absolute value of an integer is a nonnegative integer.  (Contributed
     by NM, 27-Feb-2005.)  (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  nn0abscl $p |- ( A e. ZZ -> ( abs ` A ) e. NN0 ) $=
    ( cz wcel cabs cfv cc0 cle wbr cn0 cr wb zre absz syl ibi zcn absge0 elnn0z
    cc sylanbrc ) ABCZADEZBCZFUBGHZUBICUAUCUAAJCUAUCKALAMNOUAASCUDAPAQNUBRT $.

  $( Absolute value and 'less than' relation.  (Contributed by NM,
     6-Apr-2005.)  (Revised by Mario Carneiro, 29-May-2016.) $)
  abslt $p |- ( ( A e. RR /\ B e. RR ) ->
               ( ( abs ` A ) < B <-> ( -u B < A /\ A < B ) ) ) $=
    ( cr wcel wa cabs cfv clt wbr cneg simpll renegcld cc syl cle leabs lelttrd
    wceq breq1 biimprd recnd abscl simplr absneg simpr ad2antrr jca ex wo absor
    breqtrd wi adantr jaoa ancomsd impbid ltnegcon1 anbi1d bitrd ) ACDZBCDZEZAF
    GZBHIZAJZBHIZABHIZEZBJAHIZVGEVBVDVHVBVDVHVBVDEZVFVGVJVEVCBVJAUTVAVDKZLZVJAM
    DZVCCDVJAVKUAZAUBNZUTVAVDUCZVJVEVEFGZVCOVJVECDVEVQOIVLVEPNVJVMVQVCRVNAUDNUK
    VBVDUEZQVJAVCBVKVOVPUTAVCOIVAVDAPUFVRQUGUHVBVCARZVCVERZUIZVHVDULUTWAVAAUJUM
    WAVGVFVDVSVGVDVTVFVSVDVGVCABHSTVTVDVFVCVEBHSTUNUONUPVBVFVIVGABUQURUS $.

  $( Absolute value and 'less than or equal to' relation.  (Contributed by NM,
     6-Apr-2005.)  (Revised by Mario Carneiro, 29-May-2016.) $)
  absle $p |- ( ( A e. RR /\ B e. RR ) ->
               ( ( abs ` A ) <_ B <-> ( -u B <_ A /\ A <_ B ) ) ) $=
    ( cr wcel wa cabs cfv cle wbr cneg simpll renegcld cc recnd syl leabs letrd
    wceq breq1 biimprd abscl simplr absneg breqtrd simpr ad2antrr jca ex adantr
    wo wi absor jaoa ancomsd impbid lenegcon1 anbi1d bitrd ) ACDZBCDZEZAFGZBHIZ
    AJZBHIZABHIZEZBJAHIZVFEVAVCVGVAVCVGVAVCEZVEVFVIVDVBBVIAUSUTVCKZLZVIAMDZVBCD
    VIAVJNZAUAOZUSUTVCUBZVIVDVDFGZVBHVIVDCDVDVPHIVKVDPOVIVLVPVBRVMAUCOUDVAVCUEZ
    QVIAVBBVJVNVOUSAVBHIUTVCAPUFVQQUGUHVAVBARZVBVDRZUJZVGVCUKUSVTUTAULUIVTVFVEV
    CVRVFVCVSVEVRVCVFVBABHSTVSVCVEVBVDBHSTUMUNOUOVAVEVHVFABUPUQUR $.

  $( If the absolute value of a complex number is less than a real, its
     difference from the real is nonzero.  (Contributed by NM, 2-Nov-2007.)
     (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  abssubne0 $p |- ( ( A e. CC /\ B e. RR /\ ( abs ` A ) < B ) ->
                   ( B - A ) =/= 0 ) $=
    ( cc wcel cr cabs cfv clt wbr cmin co cc0 wne simplr recnd simpll abscl syl
    wa simpr cle leabs ltletrd gtned fveq2 necon3i subne0d 3impa ) ACDZBEDZAFGZ
    BHIZBAJKLMUIUJSZULSZBAUNBUIUJULNZOZUIUJULPZUNBFGZUKMBAMUNUKURUNUIUKEDUQAQRZ
    UNUKBURUSUOUNBCDUREDUPBQRUMULTUNUJBURUAIUOBUBRUCUDBAURUKBAFUEUFRUGUH $.

  $( The absolute value of a difference and 'less than' relation.  (Contributed
     by Paul Chapman, 18-Sep-2007.) $)
  absdiflt $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                    ( ( abs ` ( A - B ) ) < C <->
                      ( ( B - C ) < A /\ A < ( B + C ) ) ) ) $=
    ( cr wcel w3a cmin co cabs cfv clt wbr cneg wa caddc wb resubcl abslt recn
    cc sylan 3impa renegcl ltaddsub2 syl3an2 3comr negsub syl2an 3adant1 breq1d
    wceq bitr3d ltsubadd2 anbi12d bitrd ) ADEZBDEZCDEZFZABGHZIJCKLZCMZUTKLZUTCK
    LZNZBCGHZAKLZABCOHKLZNUPUQURVAVEPZUPUQNUTDEURVIABQUTCRUAUBUSVCVGVDVHUSBVBOH
    ZAKLZVCVGUQURUPVKVCPZURUQVBDEUPVLCUCBVBAUDUEUFUSVJVFAKUQURVJVFUKZUPUQBTECTE
    VMURBSCSBCUGUHUIUJULABCUMUNUO $.

  $( The absolute value of a difference and 'less than or equal to' relation.
     (Contributed by Paul Chapman, 18-Sep-2007.) $)
  absdifle $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                    ( ( abs ` ( A - B ) ) <_ C <->
                      ( ( B - C ) <_ A /\ A <_ ( B + C ) ) ) ) $=
    ( cr wcel w3a cmin co cabs cfv cle wbr cneg wa caddc wb resubcl absle recn
    cc sylan 3impa renegcl leaddsub2 syl3an2 3comr negsub syl2an 3adant1 breq1d
    wceq bitr3d lesubadd2 anbi12d bitrd ) ADEZBDEZCDEZFZABGHZIJCKLZCMZUTKLZUTCK
    LZNZBCGHZAKLZABCOHKLZNUPUQURVAVEPZUPUQNUTDEURVIABQUTCRUAUBUSVCVGVDVHUSBVBOH
    ZAKLZVCVGUQURUPVKVCPZURUQVBDEUPVLCUCBVBAUDUEUFUSVJVFAKUQURVJVFUKZUPUQBTECTE
    VMURBSCSBCUGUHUIUJULABCUMUNUO $.

  $( Membership in a symmetric closed real interval.  (Contributed by Stefan
     O'Rear, 16-Nov-2014.) $)
  elicc4abs $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
      ( C e. ( ( A - B ) [,] ( A + B ) ) <-> ( abs ` ( C - A ) ) <_ B ) ) $=
    ( cr wcel w3a cmin co caddc cicc cle wbr wa cabs cfv cxr wb resubcl 3adant3
    rexrd readdcl rexr 3ad2ant3 elicc4 syl3anc absdifle 3coml bitr4d ) ADEZBDEZ
    CDEZFZCABGHZABIHZJHEZUMCKLCUNKLMZCAGHNOBKLZULUMPEUNPECPEZUOUPQULUMUIUJUMDEU
    KABRSTULUNUIUJUNDEUKABUASTUKUIURUJCUBUCUMUNCUDUEUKUIUJUQUPQCABUFUGUH $.

  $( Comparison to a nonnegative number based on comparison to squares.
     (Contributed by NM, 16-Jan-2006.) $)
  lenegsq $p |- ( ( A e. RR /\ B e. RR /\ 0 <_ B ) ->
              ( ( A <_ B /\ -u A <_ B ) <-> ( A ^ 2 ) <_ ( B ^ 2 ) ) ) $=
    ( cr wcel cc0 cle wbr cneg wa c2 cexp co wb cabs cfv recn abscl absge0 jca
    cc le2sq sylan absle ancom lenegcon1 anbi1d syl5rbbr adantrr absresq breq1d
    syl bitrd adantr 3bitr3d 3impb ) ACDZBCDZEBFGZABFGZAHBFGZIZAJKLZBJKLZFGZMUP
    UQURIZIANOZBFGZVFJKLZVCFGZVAVDUPVFCDZEVFFGZIZVEVGVIMUPATDZVLAPVMVJVKAQARSUK
    VFBUAUBUPUQVGVAMURUPUQIZVGBHAFGZUSIZVAABUCVAUTUSIVNVPUTUSUDVNUTVOUSABUEUFUG
    ULUHUPVIVDMVEUPVHVBVCFAUIUJUMUNUO $.

  $( The real part of a number is less than or equal to its absolute value.
     Proposition 10-3.7(d) of [Gleason] p. 133.  (Contributed by NM,
     1-Apr-2005.) $)
  releabs $p |- ( A e. CC -> ( Re ` A ) <_ ( abs ` A ) ) $=
    ( cc wcel cre cfv cabs recl cr recnd abscl syl cle wbr leabs absrele letrd
    ) ABCZADEZRFEZAFEAGZQRBCSHCQRTIRJKAJQRHCRSLMTRNKAOP $.

  $( Reciprocal expressed with a real denominator.  (Contributed by Mario
     Carneiro, 1-Apr-2015.) $)
  recval $p |- ( ( A e. CC /\ A =/= 0 ) ->
                  ( 1 / A ) = ( ( * ` A ) / ( ( abs ` A ) ^ 2 ) ) ) $=
    ( cc wcel cc0 wne wa c1 cabs cfv c2 cexp co ccj cdiv wceq cmul adantr simpl
    cjcl mpbird mulcomd absvalsq eqtr4d abscl recnd sqcld biimpa divmuld oveq2d
    cr cjne0 abs00 necon3bid biimpar wb sqne0 syl recdivd eqtr3d ) ABCZADEZFZGA
    HIZJKLZAMIZNLZNLGANLVEVDNLVBVFAGNVBVFAOVEAPLZVDOVBVGAVEPLZVDVBVEAUTVEBCVAAS
    QZUTVARZUAUTVDVHOVAAUBQUCVBVDVEAVBVCVBVCUTVCUJCVAAUDQUEZUFZVIVJUTVAVEDEAUKU
    GZUHTUIVBVDVEVLVIVBVDDEZVCDEZUTVOVAUTVCDADAULUMUNVBVCBCVNVOUOVKVCUPUQTVMURU
    S $.

  $( The absolute value function is idempotent.  (Contributed by NM,
     20-Nov-2004.) $)
  absidm $p |- ( A e. CC -> ( abs ` ( abs ` A ) ) = ( abs ` A ) ) $=
    ( cc wcel cabs cfv cr cc0 cle wbr wceq abscl absge0 absid syl2anc ) ABCADEZ
    FCGOHIODEOJAKALOMN $.

  $( The absolute value of a nonzero number is positive.  (Contributed by NM,
     1-Oct-1999.)  (Proof shortened by Mario Carneiro, 29-May-2016.) $)
  absgt0 $p |- ( A e. CC -> ( A =/= 0 <-> 0 < ( abs ` A ) ) ) $=
    ( cc wcel cc0 cabs cfv clt wbr wne cr 0re a1i abscl leltned abs00 necon3bid
    absge0 bitr2d ) ABCZDAEFZGHTDIADISDTDJCSKLAMAQNSTDADAOPR $.

  $( The absolute value of a nonzero integer is a positive integer.
     (Contributed by Paul Chapman, 21-Mar-2011.)  (Proof shortened by Andrew
     Salmon, 25-May-2011.) $)
  nnabscl $p |- ( ( N e. ZZ /\ N =/= 0 ) -> ( abs ` N ) e. NN ) $=
    ( cz wcel cc0 wne wa cabs cfv clt wbr cn nn0abscl nn0zd adantr cc wb absgt0
    zcn syl biimpa elnnz sylanbrc ) ABCZADEZFAGHZBCZDUEIJZUEKCUCUFUDUCUEALMNUCU
    DUGUCAOCUDUGPARAQSTUEUAUB $.

  $( Swapping order of subtraction doesn't change the absolute value.
     (Contributed by NM, 1-Oct-1999.)  (Proof shortened by Mario Carneiro,
     29-May-2016.) $)
  abssub $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( abs ` ( A - B ) ) = ( abs ` ( B - A ) ) ) $=
    ( cc wcel wa cmin co cneg cabs cfv subcl absneg syl negsubdi2 fveq2d eqtr3d
    wceq ) ACDBCDEZABFGZHZIJZSIJZBAFGZIJRSCDUAUBQABKSLMRTUCIABNOP $.

  $( Absolute value of a nonnegative difference.  (Contributed by NM,
     14-Feb-2008.) $)
  abssubge0 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B )
                      -> ( abs ` ( B - A ) ) = ( B - A ) ) $=
    ( cr wcel cle wbr cmin co cabs cfv wceq w3a resubcl 3adant3 subge0 biimp3ar
    cc0 absid syl2anc 3com12 ) BCDZACDZABEFZBAGHZIJUDKZUAUBUCLUDCDZQUDEFZUEUAUB
    UFUCBAMNUAUBUGUCBAOPUDRST $.

  $( Absolute value of a nonpositive difference.  (Contributed by FL,
     3-Jan-2008.) $)
  abssuble0 $p |- ( ( A e. RR /\ B e. RR /\ A <_ B )
                      -> ( abs ` ( A - B ) ) = ( B - A ) ) $=
    ( cr wcel cle wbr w3a cmin co cabs cfv wceq cc recn abssub syl2an abssubge0
    3adant3 eqtrd ) ACDZBCDZABEFZGABHIJKZBAHIZJKZUDTUAUCUELZUBTAMDBMDUFUAANBNAB
    OPRABQS $.

  $( The maximum of two numbers using absolute value.  (Contributed by NM,
     7-Aug-2008.) $)
  absmax $p |- ( ( A e. RR /\ B e. RR ) -> if ( A <_ B , B , A )
              = ( ( ( A + B ) + ( abs ` ( A - B ) ) ) / 2 ) ) $=
    ( cr wcel wa cle wbr caddc co cmin c2 cdiv wceq cmul syl simpr simpl adantl
    cc oveq1d cif cabs cfv clt recn cc0 wne 2cn 2ne0 divcan3 ad2antlr abssubge0
    mp3an23 ltle imp 3expa syldan oveq2d ppncand 2times eqtr4d syl2an adantr wn
    eqtrd ltnle biimpa iffalse 3eqtr4rd ancom1s abssuble0 addcom 3eqtr4d iftrue
    ltlecasei ) ACDZBCDZEZABFGZBAUAZABHIZABJIZUBUCZHIZKLIZMZBAVQVPBAUDGZWFVQVPE
    ZWGEZKANIZKLIZAWEVTVPWKAMZVQWGVPASDZWLAUEZWMKSDZKUFUGZWLUHUIAKUJUMOUKWIWDWJ
    KLWIWDWAWBHIZWJWIWCWBWAHWHWGBAFGZWCWBMZWHWGWRBAUNUOVQVPWRWSBAULUPUQURWHWQWJ
    MZWGVQBSDZWMWTVPBUEZWNXAWMEZWQAAHIZWJXCABAXAWMPZXAWMQXEUSWMWJXDMXAAUTRVAVBV
    CVETWIVSVDZVTAMWHWGXFBAVFVGVSBAVHOVIVJVRVSEZKBNIZKLIZBWEVTVQXIBMZVPVSVQXAXJ
    XBXAWOWPXJUHUIBKUJUMOUKXGWDXHKLXGWDWABAJIZHIZXHXGWCXKWAHVPVQVSWCXKMABVKUPUR
    VRXLXHMZVSVPWMXAXMVQWNXBWMXAEZBAHIZXKHIBBHIZXLXHXNBABWMXAPZWMXAQXQUSXNWAXOX
    KHABVLTXAXHXPMWMBUTRVMVBVCVETVSVTBMVRVSBAVNRVIVPVQPVPVQQVO $.

  $( Triangle inequality for absolute value.  Proposition 10-3.7(h) of
     [Gleason] p. 133.  (Contributed by NM, 7-Mar-2005.)  (Proof shortened by
     Mario Carneiro, 29-May-2016.) $)
  abstri $p |- ( ( A e. CC /\ B e. CC ) ->
                ( abs ` ( A + B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) ) $=
    ( cc wcel caddc co cabs cfv cle wbr c2 cexp cmul cr remulcld abscl syl wceq
    recnd cc0 wa ccj cre 2re a1i simpl simpr cjcld mulcld recld resqcld releabs
    readdcld absmul syl2anc abscj oveq2d eqtrd breqtrd crp 2rp lemul2d leadd2dd
    mpbid sqabsadd binom2 add32d 3brtr4d addcl absge0 addge0d le2sqd mpbird ) A
    CDZBCDZUAZABEFZGHZAGHZBGHZEFZIJVRKLFZWAKLFZIJVPVSKLFZVTKLFZEFZKABUBHZMFZUCH
    ZMFZEFWFKVSVTMFZMFZEFZWBWCIVPWJWLWFVPKWIKNDVPUDUEZVPWHVPAWGVNVOUFZVPBVNVOUG
    ZUHZUIZUJZOVPKWKWNVPVSVTVPVNVSNDWOAPQZVPVOVTNDWPBPQZOZOZVPWDWEVPVSWTUKZVPVT
    XAUKZUMVPWIWKIJWJWLIJVPWIWHGHZWKIVPWHCDWIXFIJWRWHULQVPXFVSWGGHZMFZWKVPVNWGC
    DXFXHRWOWQAWGUNUOVPXGVTVSMVPVOXGVTRWPBUPQUQURUSVPWIWKKWSXBKUTDVPVAUEVBVDVCA
    BVEVPWCWDWLEFWEEFZWMVPVSCDVTCDWCXIRVPVSWTSVPVTXASVSVTVFUOVPWDWLWEVPWDXDSVPW
    LXCSVPWEXESVGURVHVPVRWAVPVQCDZVRNDABVIZVQPQVPVSVTWTXAUMVPXJTVRIJXKVQVJQVPVS
    VTWTXAVPVNTVSIJWOAVJQVPVOTVTIJWPBVJQVKVLVM $.

  $( Absolute value of differences around common element.  (Contributed by FL,
     9-Oct-2006.) $)
  abs3dif $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
            ( abs ` ( A - B ) ) <_ ( ( abs ` ( A - C ) ) +
                      ( abs ` ( C - B ) ) ) ) $=
    ( cc wcel w3a cmin caddc cabs cfv cle wceq npncan 3com23 fveq2d wbr 3adant2
    co subcl ancoms 3adant1 abstri syl2anc eqbrtrrd ) ADEZBDEZCDEZFZACGRZCBGRZH
    RZIJZABGRZIJUIIJUJIJHRZKUHUKUMIUEUGUFUKUMLACBMNOUHUIDEZUJDEZULUNKPUEUGUOUFA
    CSQUFUGUPUEUGUFUPCBSTUAUIUJUBUCUD $.

  $( Difference of absolute values.  (Contributed by Paul Chapman,
     7-Sep-2007.) $)
  abs2dif $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( ( abs ` A ) - ( abs ` B ) ) <_ ( abs ` ( A - B ) ) ) $=
    ( cc wcel wa cc0 cmin co cfv cle subid1 fveq2d wbr 0cn cr subcl mpan2 abscl
    cabs syl oveqan12d caddc abs3dif mp3an2 wb anim12i df-3an sylanbrc lesubadd
    w3a mpbird eqbrtrrd ) ACDZBCDZEZAFGHZSIZBFGHZSIZGHZASIZBSIZGHABGHZSIZJUMUNU
    QVAUSVBGUMUPASAKLUNURBSBKLUAUOUTVDJMZUQVDUSUBHJMZUMFCDZUNVFNAFBUCUDUOUQODZU
    SODZVDODZUJZVEVFUEUOVHVIEVJVKUMVHUNVIUMUPCDZVHUMVGVLNAFPQUPRTUNURCDZVIUNVGV
    MNBFPQURRTUFUOVCCDVJABPVCRTVHVIVJUGUHUQUSVDUITUKUL $.

  $( Difference of absolute values.  (Contributed by Mario Carneiro,
     14-Apr-2016.) $)
  abs2dif2 $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( abs ` ( A - B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) ) $=
    ( cc wcel wa cneg caddc co cabs cfv cmin cle wbr negcl abstri sylan2 negsub
    fveq2d wceq absneg adantl oveq2d 3brtr3d ) ACDZBCDZEZABFZGHZIJZAIJZUGIJZGHZ
    ABKHZIJUJBIJZGHLUEUDUGCDUIULLMBNAUGOPUFUHUMIABQRUFUKUNUJGUEUKUNSUDBTUAUBUC
    $.

  $( Absolute value of difference of absolute values.  (Contributed by Paul
     Chapman, 7-Sep-2007.) $)
  abs2difabs $p |- ( ( A e. CC /\ B e. CC ) ->
            ( abs ` ( ( abs ` A ) - ( abs ` B ) ) ) <_ ( abs ` ( A - B ) ) ) $=
    ( cc wcel wa cabs cfv cmin co cle cneg abs2dif ancoms abscl recnd syl2an cr
    wbr wb syl2anc wceq negsubdi2 abssub 3brtr4d resubcl subcl syl absle anbi1d
    lenegcon1 bitr4d mpbir2and ) ACDZBCDZEZAFGZBFGZHIZFGABHIZFGZJRZURKZUTJRZURU
    TJRZUOUQUPHIZBAHIFGZVBUTJUNUMVEVFJRBALMUMUPCDUQCDVBVEUAUNUMUPANZOUNUQBNZOUP
    UQUBPABUCUDABLUOVAUTKURJRZVDEZVCVDEUOURQDZUTQDZVAVJSUMUPQDUQQDVKUNVGVHUPUQU
    EPZUOUSCDVLABUFUSNUGZURUTUHTUOVCVIVDUOVKVLVCVISVMVNURUTUJTUIUKUL $.

  ${
    $d x A $.
    $( For any complex number, there exists a unit-magnitude multiplier that
       produces its absolute value.  Part of proof of Theorem 13-2.12 of
       [Gleason] p. 195.  (Contributed by NM, 26-Mar-2005.) $)
    abs1m $p |- ( A e. CC ->
      E. x e. CC ( ( abs ` x ) = 1 /\ ( abs ` A ) = ( x x. A ) ) ) $=
      ( cc wcel cabs cfv c1 wceq cmul co wa wrex cc0 fveq2 adantr eqtr3d eqeq1d
      wne cdiv ci cv abs0 syl6eq oveq2 eqeq12d anbi2d rexbidv simpl cjcld abscl
      ccj cr recnd abs00 necon3bid biimpar divcld absdiv syl3anc absidm oveq12d
      abscj dividd 3eqtrd divassd divcan3d cexp sqvald absvalsq mulcomd 3eqtr4d
      c2 oveq1d eqeq2d anbi12d rspcev syl12anc ax-icn absi mul01i eqcomi pm3.2i
      oveq1 mp2an a1i pm2.61ne ) BCDZAUAZEFZGHZBEFZWHBIJZHZKZACLZWJMWHMIJZHZKZA
      CLZBMBMHZWNWRACWTWMWQWJWTWKMWLWPWTWKMEFMBMENUBUCBMWHIUDUEUFUGWGBMRZKZBUKF
      ZWKSJZCDXDEFZGHZWKXDBIJZHZWOXBXCWKXBBWGXAUHZUIZXBWKWGWKULDXABUJOUMZWGWKMR
      ZXAWGWKMBMBUNUOUPZUQZXBXEXCEFZWKEFZSJZWKWKSJGXBXCCDWKCDXLXEXQHXJXKXMXCWKU
      RUSXBXOWKXPWKSWGXOWKHXABVBOWGXPWKHXABUTOVAXBWKXKXMVCVDXBBXCIJZWKSJZBXDIJW
      KXGXBBXCWKXIXJXKXMVEXBWKWKIJZWKSJWKXSXBWKWKXKXKXMVFXBXTXRWKSXBWKVLVGJZXTX
      RXBWKXKVHWGYAXRHXABVIOPVMPXBXDBXNXIVJVKWNXFXHKAXDCWHXDHZWJXFWMXHYBWIXEGWH
      XDENQYBWLXGWKWHXDBIWCVNVOVPVQWSWGTCDTEFZGHZMTMIJZHZKZWSVRYDYFVSYEMTVRVTWA
      WBWRYGATCWHTHZWJYDWQYFYHWIYCGWHTENQYHWPYEMWHTMIWCVNVOVPWDWEWF $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Cancellation law involving the real part of a complex number.
       (Contributed by NM, 12-May-2005.) $)
    recan $p |- ( ( A e. CC /\ B e. CC ) -> ( A. x e. CC
                 ( Re ` ( x x. A ) ) = ( Re ` ( x x. B ) ) <-> A = B ) ) $=
      ( cc wcel cmul co cre cfv wceq c1 ci caddc wi oveq1 fveq2d eqeq12d oveq2d
      rspcv oveq12d wa wral ax-1cn ax-mp ax-icn negcli cim replim mulid2 eqcomd
      cv cneg imre eqtrd eqeqan12d syl5ibr oveq2 ralrimivw impbid1 ) BDEZCDEZUA
      ZAUKZBFGZHIZVCCFGZHIZJZADUBZBCJZVIVJVBKBFGZHIZLLULZBFGZHIZFGZMGZKCFGZHIZL
      VMCFGZHIZFGZMGZJVIVLVSVPWBMKDEVIVLVSJZNUCVHWDAKDVCKJZVEVLVGVSWEVDVKHVCKBF
      OPWEVFVRHVCKCFOPQSUDVIVOWALFVMDEVIVOWAJZNLUEUFVHWFAVMDVCVMJZVEVOVGWAWGVDV
      NHVCVMBFOPWGVFVTHVCVMCFOPQSUDRTUTVABVQCWCUTBBHIZLBUGIZFGZMGVQBUHUTWHVLWJV
      PMUTBVKHUTVKBBUIUJPUTWIVOLFBUMRTUNVACCHIZLCUGIZFGZMGWCCUHVAWKVSWMWBMVACVR
      HVAVRCCUIUJPVAWLWALFCUMRTUNUOUPVJVHADVJVDVFHBCVCFUQPURUS $.

    $( Mapping domain and codomain of the absolute value function.
       (Contributed by NM, 30-Aug-2007.)  (Revised by Mario Carneiro,
       7-Nov-2013.) $)
    absf $p |- abs : CC --> RR $=
      ( vx cc cr cv ccj cfv cmul co csqr cabs df-abs wcel absval abscl eqeltrrd
      fmpti ) ABCADZQEFGHIFZJAKQBLQJFRCQMQNOP $.
  $}

  $( Lemma involving absolute value of differences.  (Contributed by NM,
     2-Oct-1999.) $)
  abs3lem $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\
                   D e. RR ) ) -> (
          ( ( abs ` ( A - C ) ) < ( D / 2 ) /\
            ( abs ` ( C - B ) ) < ( D / 2 ) ) ->
            ( abs ` ( A - B ) ) < D ) ) $=
    ( cc wcel wa cr cmin co cabs cfv c2 cdiv clt wbr caddc subcld abscl syl cle
    simplll simpllr simplrl readdcld simplrr abs3dif syl3anc lt2halvesd lelttrd
    simprl simprr ex ) AEFZBEFZGZCEFZDHFZGZGZACIJZKLZDMNJZOPZCBIJZKLZVCOPZGZABI
    JZKLZDOPUTVHGZVJVBVFQJZDVKVIEFVJHFVKABUNUOUSVHUBZUNUOUSVHUCZRVISTVKVBVFVKVA
    EFVBHFVKACVMUPUQURVHUDZRVASTZVKVEEFVFHFVKCBVOVNRVESTZUEUPUQURVHUFZVKUNUOUQV
    JVLUAPVMVNVOABCUGUHVKVBVFDVPVQVRUTVDVGUKUTVDVGULUIUJUM $.

  $( Lemma involving absolute values.  (Contributed by NM, 11-Oct-1999.)
     (Revised by Mario Carneiro, 29-May-2016.) $)
  abslem2 $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( ( ( * ` ( A / ( abs ` A ) ) ) x. A ) +
      ( ( A / ( abs ` A ) ) x. ( * ` A ) ) ) = ( 2 x. ( abs ` A ) ) ) $=
    ( cc wcel cc0 wne wa cabs cfv cdiv ccj cmul caddc cexp wceq absvalsq adantr
    co c2 cr 3eqtr3d abscl recnd sqvald eqtr3d oveq1d simpl cjcld abs00 biimpar
    necon3bid div23d divcan3d fveq2d divcld cjmuld cjcjd oveq2d oveq12d 2timesd
    eqtrd cjred eqtr4d ) ABCZADEZFZAAGHZIQZJHZAKQZVGAJHZKQZLQVFVFLQRVFKQVEVIVFV
    KVFLVEVKJHZVFJHVIVFVEVKVFJVEAVJKQZVFIQVFVFKQZVFIQVKVFVEVMVNVFIVEVFRMQZVMVNV
    CVOVMNVDAOPVEVFVEVFVCVFSCVDAUAPZUBZUCUDUEVEAVJVFVCVDUFZVEAVRUGZVQVCVFDEVDVC
    VFDADAUHUJUIZUKVEVFVFVQVQVTULTZUMVEVLVHVJJHZKQVIVEVGVJVEAVFVRVQVTUNVSUOVEWB
    AVHKVEAVRUPUQUTVEVFVPVATWAURVEVFVQUSVB $.

  $( The difference between a real number and its nearest integer is less than
     or equal to one half.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof
     shortened by Mario Carneiro, 14-Sep-2015.) $)
  rddif $p |- ( A e. RR -> ( abs ` ( ( |_ ` ( A + ( 1 / 2 ) ) ) - A ) )
                                                          <_ ( 1 / 2 ) ) $=
    ( cr wcel c1 c2 cdiv co caddc cfl cfv cmin cabs cle wbr cmul 2re 2ne0 mpan2
    a1i syl rereccli recni 2timesi 2cn recidi eqtr3i oveq2i cc nppcan3d syl5eqr
    recn readdcl fllep1 eqbrtrd resubcl reflcl 1re leadd1d mpbird flle wa wb id
    absdifle syl3anc mpbir2and ) ABCZADEFGZHGZIJZAKGLJVHMNZAVHKGZVJMNZVJVIMNZVG
    VMVLDHGZVJDHGZMNVGVOVIVPMVGVOVLVHVHHGZHGVIVQDVLHEVHOGVQDVHVHEPQUAZUBZUCEUDQ
    UEUFUGVGAVHVHAUKVHUHCVGVSSZVTUIUJVGVIBCZVIVPMNVGVHBCZWAVRAVHULRZVIUMTUNVGVL
    VJDVGWBVLBCVRAVHUORVGWAVJBCZWCVIUPTZDBCVGUQSURUSVGWAVNWCVIUTTVGWDVGWBVKVMVN
    VAVBWEVGVCWBVGVRSVJAVHVDVEVF $.

  $( Bound on the absolute value of a real number rounded to the nearest
     integer.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by
     Mario Carneiro, 14-Sep-2015.) $)
  absrdbnd $p |- ( A e. RR -> ( abs ` ( |_ ` ( A + ( 1 / 2 ) ) ) )
                                        <_ ( ( |_ ` ( abs ` A ) ) + 1 ) ) $=
    ( cr wcel c1 c2 co caddc cfl cfv cabs cle wbr cc reflcl syl recnd abscl a1i
    cmin cz cdiv 2re 2ne0 rereccli readdcl 1re resubcld resubcl mpancom abs2dif
    mpan2 syl2anc rddif halflt1 ltleii letrd subled wb cn0 flcld nn0abscl nn0zd
    recn peano2zm flge mpbid lesubaddd ) ABCZADEUAFZGFZHIZJIZDSFZAJIZHIZKLZVLVO
    DGFKLVHVMVNKLZVPVHVLVNDVHVKMCZVLBCVHVKVHVJBCZVKBCZVHVIBCZVSEUBUCUDZAVIUEUKZ
    VJNOZPZVKQOZVHAMCZVNBCZAVCZAQOZDBCVHUFRZVHVLVNSFZVKASFZJIZDVHVLVNWFWJUGVHWM
    MCWNBCVHWMVTVHWMBCWDVKAUHUIPWMQOZWKVHVRWGWLWNKLWEWIVKAUJULVHWNVIDWOWAVHWBRW
    KAUMVIDKLVHVIDWBUFUNUORUPUPUQVHWHVMTCZVQVPURWJVHVLTCWPVHVLVHVKTCVLUSCVHVJWC
    UTVKVAOVBVLVDOVNVMVEULVFVHVLDVOWFWKVHWHVOBCWJVNNOVGVF $.

  $( Lemma for ~ fzomaxdif .  (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
  fzomaxdiflem $p |- ( ( ( A e. ( C ..^ D ) /\ B e. ( C ..^ D ) ) /\
        A <_ B ) -> ( abs ` ( B - A ) ) e. ( 0 ..^ ( D - C ) ) ) $=
    ( cfzo co wcel wa cle wbr cmin cabs cc0 elfzoelz adantl adantr zsubcld zred
    cz clt cfv cr wceq subge0d biimpar absid syl2anc elfzoel1 resubcld elfzoel2
    elfzole1 lesub2dd elfzolt2 ltsub1dd lelttrd wb 0z a1i elfzo syl3anc eqeltrd
    mpbir2and ) ACDEFZGZBVCGZHZABIJZHZBAKFZLUAZVIMDCKFZEFZVHVIUBGZMVIIJZVJVIUCV
    FVMVGVFVIVFBAVEBSGVDBCDNOZVDASGVEACDNPZQZRZPVFVNVGVFBAVFBVORZVFAVPRZUDUEZVI
    UFUGVHVIVLGZVNVIVKTJZWAVFWCVGVFVIBCKFVKVRVFBCVSVFCVECSGVDBCDUHOZRZUIVFVKVFD
    CVEDSGVDBCDUJOZWDQZRVFCABWEVTVSVDCAIJVEACDUKPULVFBDCVSVFDWFRWEVEBDTJVDBCDUM
    OUNUOPVFWBVNWCHUPZVGVFVISGMSGZVKSGWHVQWIVFUQURWGVIMVKUSUTPVBVA $.

  $( A bound on the separation of two points in a half-open range.
     (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
  fzomaxdif $p |- ( ( A e. ( C ..^ D ) /\ B e. ( C ..^ D ) ) ->
      ( abs ` ( A - B ) ) e. ( 0 ..^ ( D - C ) ) ) $=
    ( cfzo co wcel wa cle wbr cmin cabs cc elfzoelz zcnd syl2an fzomaxdiflem cr
    cfv zred cc0 wceq abssub adantr eqeltrd ancom1s wo letric mpjaodan ) ACDEFZ
    GZBUJGZHZABIJZABKFLSZUADCKFEFZGZBAIJZUMUNHUOBAKFLSZUPUMUOUSUBZUNUKAMGBMGUTU
    LUKAACDNZOULBBCDNZOABUCPUDABCDQUEULUKURUQBACDQUFUKARGBRGUNURUGULUKAVATULBVB
    TABUHPUI $.

  ${
    $d x y A $.  $d x y B $.
    $( The upper integers are closed under intersection.  (Contributed by Mario
       Carneiro, 24-Dec-2013.) $)
    uzin2 $p |- ( ( A e. ran ZZ>= /\ B e. ran ZZ>= ) ->
                  ( A i^i B ) e. ran ZZ>= ) $=
      ( vx vy cv cuz cfv cin crn wcel cz wfn wceq wrex wb cpw wf fvelrnb eleq1d
      ax-mp uzf ffn ineq1 ineq2 wa cle wbr cif uzin ifcl ancoms sylancr eqeltrd
      fnfvelrn 2gencl ) CEZFGZDEZFGZHZFIZJAUSHZVAJABHZVAJCDUQUSABKVAFKLZAVAJUQA
      MZCKNOKKPZFQVDUAKVFFUBTZCKAFRTVDBVAJUSBMZDKNOVGDKBFRTVEUTVBVAUQAUSUCSVHVB
      VCVAUSBAUDSUPKJZURKJZUEZUTUPURUFUGZURUPUHZFGZVAUPURUIVKVDVMKJZVNVAJVGVJVI
      VOVLURUPKUJUKKVMFUNULUMUO $.
  $}

  ${
    $d j k x y z A $.  $d j x y z ph $.  $d j x y z ps $.
    $( Combine two different upper integer properties into one.  (Contributed
       by Mario Carneiro, 25-Dec-2013.) $)
    rexanuz $p |- ( E. j e. ZZ A. k e. ( ZZ>= ` j ) ( ph /\ ps ) <->
                    ( E. j e. ZZ A. k e. ( ZZ>= ` j ) ph /\
                      E. j e. ZZ A. k e. ( ZZ>= ` j ) ps ) ) $=
      ( vx vy vz wa cv cuz wral cz wrex wb uzf raleq rexrn mp2b wi wcel cfv crn
      r19.26 rexbii r19.40 sylbi cpw wf wfn ffn cin uzin2 wss inss1 ax-mp inss2
      ssralv anim12i sylibr rspcev an4s rexlimdvaa rexlimiva imp sylib syl2anbr
      syl2an impbii ) ABHZDCIJUAZKZCLMZADVJKZCLMZBDVJKZCLMZHZVLVMVOHZCLMVQVKVRC
      LABDVJUCUDVMVOCLUEUFVNADEIZKZEJUBZMZBDFIZKZFWAMZVLVPLLUGZJUHZJLUIZWBVNNOL
      WFJUJZVTVMECLJADVSVJPQRWGWHWEVPNOWIWDVOFCLJBDWCVJPQRWBWEHVIDGIZKZGWAMZVLW
      BWEWLVTWEWLSEWAVSWATZVTHWDWLFWAWMWCWATZVTWDWLWMWNHVSWCUKZWATVIDWOKZWLVTWD
      HZVSWCULWQADWOKZBDWOKZHWPVTWRWDWSWOVSUMVTWRSVSWCUNADWOVSUQUOWOWCUMWDWSSVS
      WCUPBDWOWCUQUOURABDWOUCUSWKWPGWOWAVIDWJWOPUTVGVAVBVCVDWGWHWLVLNOWIWKVKGCL
      JVIDWJVJPQRVEVFVH $.

    $( Combine two different upper real properties into one.  (Contributed by
       Mario Carneiro, 8-May-2016.) $)
    rexanre $p |- ( A C_ RR ->
                    ( E. j e. RR A. k e. A ( j <_ k -> ( ph /\ ps ) ) <->
                      ( E. j e. RR A. k e. A ( j <_ k -> ph ) /\
                        E. j e. RR A. k e. A ( j <_ k -> ps ) ) ) ) $=
      ( vx vy cr cv cle wbr wa wi wral wrex wceq breq1 imbi1d ralbidv wcel ifcl
      wss simpl imim2i ralimi reximi simpr cbvrexv anbi12i reeanv bitr4i ancoms
      jca adantl r19.26 prth wb simplrl simplrr sselda syl3anc syl5ibr ralimdva
      cif maxle syl5bir rspcev ee12an rexlimdvva syl5bi impbid2 ) CHUBZDIZEIZJK
      ZABLZMZECNZDHOZVOAMZECNZDHOZVOBMZECNZDHOZLZVSWBWEVRWADHVQVTECVPAVOABUCUDU
      EUFVRWDDHVQWCECVPBVOABUGUDUEUFUMWFFIZVNJKZAMZECNZGIZVNJKZBMZECNZLZGHOFHOZ
      VLVSWFWJFHOZWNGHOZLWPWBWQWEWRWAWJDFHVMWGPZVTWIECWSVOWHAVMWGVNJQRSUHWDWNDG
      HVMWKPZWCWMECWTVOWLBVMWKVNJQRSUHUIWJWNFGHHUJUKVLWOVSFGHHVLWGHTZWKHTZLZLZW
      GWKJKZWKWGVDZHTZWOXFVNJKZVPMZECNZVSXCXGVLXBXAXGXEWKWGHUAULUNWOWIWMLZECNXD
      XJWIWMECUOXDXKXIECXKXIXDVNCTZLZWHWLLZVPMWHAWLBUPXMXHXNVPXMXAXBVNHTXHXNUQV
      LXAXBXLURVLXAXBXLUSXDCHVNVLXCUCUTWGWKVNVEVARVBVCVFVRXJDXFHVMXFPZVQXIECXOV
      OXHVPVMXFVNJQRSVGVHVIVJVK $.
  $}

  ${
    $d j k n x y z A $.  $d j x y z ph $.
    $( Combine finitely many different upper integer properties into one.
       (Contributed by Mario Carneiro, 6-Jun-2014.) $)
    rexfiuz $p |- ( A e. Fin ->
                    ( E. j e. ZZ A. k e. ( ZZ>= ` j ) A. n e. A ph <->
                      A. n e. A E. j e. ZZ A. k e. ( ZZ>= ` j ) ph ) ) $=
      ( vx vy vz cv wral cz wrex wb c0 wceq raleq rexralbidv bibi12d wcel wa 0z
      cuz cfv csn cun weq wne cc0 ne0i ax-mp ral0 rgen2w r19.2z mp2an 2th anbi1
      wi cfn rexanuz ralunb ralbii rexbii cvv vex ralsnsg ralcom syl5bb rexbidv
      wsbc sbcrex syl6rbbr bitrd anbi2i 3bitr4i 3bitr4g a1i findcard2 ) AEFIZJZ
      DCIUBUCZJCKLZADVTJZCKLZEVRJZMAENJZDVTJZCKLZWCENJZMAEGIZJZDVTJCKLZWCEWIJZM
      ZAEWIHIZUDZUEZJZDVTJZCKLZWCEWPJZMZAEBJZDVTJCKLZWCEBJZMFGHBVRNOZWAWGWDWHXE
      VSWECDKVTAEVRNPQWCEVRNPRFGUFZWAWKWDWLXFVSWJCDKVTAEVRWIPQWCEVRWIPRVRWPOZWA
      WSWDWTXGVSWQCDKVTAEVRWPPQWCEVRWPPRVRBOZWAXCWDXDXHVSXBCDKVTAEVRBPQWCEVRBPR
      WGWHKNUGZWFCKJWGUHKSXIUAKUHUIUJWECDKVTAEUKULWFCKUMUNWCEUKUOWMXAUQWIURSWMW
      KWCEWOJZTZWLXJTWSWTWKWLXJUPWJAEWOJZTZDVTJZCKLWKXLDVTJZCKLZTWSXKWJXLCDUSWR
      XNCKWQXMDVTAEWIWOUTVAVBXJXPWKWNVCSZXJXPMHVDXQXJWCEWNVIZXPWCEWNVCVEXQXPWBE
      WNVIZCKLXRXQXOXSCKXOWBEWOJXQXSADEVTWOVFWBEWNVCVEVGVHWBECWNKVJVKVLUJVMVNWC
      EWIWOUTVOVPVQ $.
  $}

  ${
    $d j m M $.  $d j m ph $.  $d j k m Z $.
    rexuz3.1 $e |- Z = ( ZZ>= ` M ) $.
    $( Rextrict the base of the upper integers set to another upper integers
       set.  (Contributed by Mario Carneiro, 26-Dec-2013.) $)
    rexuz3 $p |- ( M e. ZZ -> ( E. j e. Z A. k e. ( ZZ>= ` j ) ph <->
                                E. j e. ZZ A. k e. ( ZZ>= ` j ) ph ) ) $=
      ( cz wcel cv cuz cfv wral wrex wa id rgen wceq fveq2 syl6eqr ralimi mpan2
      raleqdv rspcev biantrurd uztrn2 ancrd ralimdva eluzelz eleq2s jctild uzid
      a1d imp simpl eleq1 rspcva syl2an simpr adantl jca impbii rexbii2 rexanuz
      bitr2i syl6rbb ) DGHZACBIZJKZLZBGMZCIZEHZCVHLZBGMZVJNZVIBEMZVFVNVJVFVLCEL
      ZVNVLCEVLOPVMVQBDGVGDQZVLCVHEVRVHDJKZEVGDJRFSUBUCUAUDVPVLANZCVHLZBGMVOVIW
      ABEGVGEHZVINVGGHZWANZWBVIWDWBVIWAWCWBAVTCVHWBVKVHHNZAVLWEVLADVKVGEFUEULUF
      UGWCVGVSEDVGUHFUIUJUMWDWBVIWCVGVHHVMWBWAVGUKVTVLCVHVLAUNTVLWBCVGVHVKVGEUO
      UPUQWAVIWCVTACVHVLAURTUSUTVAVBVLABCVCVDVE $.

    ${
      $d j ps $.
      $( Combine two different upper integer properties into one.  (Contributed
         by Mario Carneiro, 26-Dec-2013.) $)
      rexanuz2 $p |- ( E. j e. Z A. k e. ( ZZ>= ` j ) ( ph /\ ps ) <->
                       ( E. j e. Z A. k e. ( ZZ>= ` j ) ph /\
                         E. j e. Z A. k e. ( ZZ>= ` j ) ps ) ) $=
        ( wa cv cuz cfv wral wrex cz wcel eluzel2 eleq2s a1d rexlimiv rexuz3
        adantr anbi12d rexanuz syl6rbbr bitrd pm5.21nii ) ABHZDCIZJKZLZCFMZENOZ
        ADUILZCFMZBDUILZCFMZHZUJULCFUHFOZULUJULUHEJKFEUHPGQZRSUNULUPUMULCFURULU
        MUSRSUAULUKUJCNMZUQUGCDEFGTULUQUMCNMZUOCNMZHUTULUNVAUPVBACDEFGTBCDEFGTU
        BABCDUCUDUEUF $.
    $}

    $( A version of ~ 19.29 for upper integer quantifiers.  (Contributed by
       Mario Carneiro, 10-Feb-2014.) $)
    r19.29uz $p |- ( ( A. k e. Z ph /\ E. j e. Z A. k e. ( ZZ>= ` j ) ps ) ->
                     E. j e. Z A. k e. ( ZZ>= ` j ) ( ph /\ ps ) ) $=
      ( wral cv cuz cfv wrex wa wcel wi uztrn2 ex pm3.2 a1i imim12d impcom syl
      ralimdv2 ralim reximdva imp ) ADFHZBDCIZJKZHZCFLABMZDUIHZCFLUGUJULCFUGUHF
      NZMBUKOZDUIHZUJULOUMUGUOUMAUNDFUIUMDIZUINZUPFNZAUNUMUQUREUPUHFGPQAUNOUMAB
      RSTUCUABUKDUIUDUBUEUF $.

    $( A version of ~ r19.2z for upper integer quantifiers.  (Contributed by
       Mario Carneiro, 15-Feb-2014.) $)
    r19.2uz $p |- ( E. j e. Z A. k e. ( ZZ>= ` j ) ph -> E. k e. Z ph ) $=
      ( cv cuz cfv wral wrex wcel c0 wne cz eluzelz uzid ne0i 3syl eleq2s sylan
      r19.2z uztrn2 ex anim1d reximdv2 imp syldan rexlimiva ) ACBGZHIZJZACEKZBE
      UJELZULACUKKZUMUNUKMNZULUOUPUJDHIZEUJUQLUJOLUJUKLUPDUJPUJQUKUJRSFTACUKUBU
      AUNUOUMUNAACUKEUNCGZUKLZURELZAUNUSUTDURUJEFUCUDUEUFUGUHUI $.

    $d k M $.
    $( Convert an upper real quantifier to an upper integer quantifier.
       (Contributed by Mario Carneiro, 7-May-2016.) $)
    rexuzre $p |- ( M e. ZZ -> ( E. j e. Z A. k e. ( ZZ>= ` j ) ph <->
        E. j e. RR A. k e. Z ( j <_ k -> ph ) ) ) $=
      ( vm cz wcel cv cuz cfv wral wrex cle wbr wi cr wa adantl eluzelre eleq2s
      adantr wb eluzelz eluz syl2an biimprd expimpd imim1d ralimdv2 imp reximi2
      exp4a jca cfl c1 caddc co cif simpl flcl peano2zd ifcl syl2anc zre reflcl
      peano2re syl max1 eluz2 syl3anbrc syl6eleqr impexp wss uzss sselda simplr
      syl6sseqr zred simpr fllep1 max2 letrd eluzle syl5bir wceq raleqdv rspcev
      ex fveq2 ee12an rexlimdva cbvrexv syl6ib impbid2 ) DHIZACBJZKLZMZBENZWRCJ
      ZOPZAQZCEMZBRNZWTXEBERWREIZWTSWRRIZXEXGXHWTXHWRDKLZEDWRUAFUBUCXGWTXEXGAXD
      CWSEXGXBWSIZAQXBEIZXCAXGXKXCSZXJAXGXKXCXJXGXKSXJXCXGWRHIZXBHIZXJXCUDXKXMW
      RXIEDWRUEFUBXNXBXIEDXBUEFUBWRXBUFUGUHUIUJUNUKULUOUMWQXFACGJZKLZMZGENZXAWQ
      XEXRBRWQXHSZDWRUPLZUQURUSZOPZYADUTZEIXEACYCKLZMZXRXSYCXIEXSWQYCHIZDYCOPZY
      CXIIZWQXHVAZXSYAHIWQYFXSXTXHXTHIWQWRVBTVCYIYBYADHVDVEZWQDRIZYARIZYGXHDVFZ
      XHXTRIYLWRVGXTVHVIZDYAVJUGDYCVKVLZFVMXSXDACEYDXKXDQXLAQXSXBYDIZAQXKXCAVNX
      SYPXLAXSYPXLXSYPSZXKXCXSYDEXBXSYDXIEXSYHYDXIVOYODYCVPVIFVSVQYQWRYCXBWQXHY
      PVRYQYCXSYFYPYJUCVTYPXBRIXSYCXBUATXSWRYCOPYPXSWRYAYCWQXHWAXHYLWQYNTXSYCYJ
      VTXHWRYAOPWQWRWBTWQYKYLYAYCOPXHYMYNDYAWCUGWDUCYPYCXBOPXSYCXBWETWDUOWJUJWF
      UKXQYEGYCEXOYCWGACXPYDXOYCKWKWHWIWLWMXQWTGBEXOWRWGACXPWSXOWRKWKWHWNWOWP
      $.
  $}

  ${
    $d j k n A $.  $d j k n B $.  $d j n ph $.
    $( Rextrict the base of an upper real quantifier to an upper real set.
       (Contributed by Mario Carneiro, 12-May-2016.) $)
    rexico $p |- ( ( A C_ RR /\ B e. RR ) ->
      ( E. j e. ( B [,) +oo ) A. k e. A ( j <_ k -> ph ) <->
        E. j e. RR A. k e. A ( j <_ k -> ph ) ) ) $=
      ( vn cr wss wcel wa cv cle wbr wi wral cpnf wrex simpr simplr syl2anc cxr
      cico co pnfxr icossre sylancl ssrexv syl cif ifcl max1 elicopnf mpbir2and
      wb ad2antlr adantr simpll sselda maxle syl3anc syl6bi ralimdva wceq breq1
      imim1d imbi1d ralbidv rspcev ee12an rexlimdva cbvrexv syl6ib impbid ) BGH
      ZCGIZJZDKZEKZLMZANZEBOZDCPUBUCZQZWADGQZVPWBGHZWCWDNVPVOPUAIWEVNVORUDCPUEU
      FWADWBGUGUHVPWDFKZVRLMZANZEBOZFWBQZWCVPWAWJDGVPVQGIZJZCVQLMZVQCUIZWBIZWAW
      NVRLMZANZEBOZWJWLWOWNGIZCWNLMZWLWKVOWSVPWKRZVNVOWKSZWMVQCGUJTWLVOWKWTXBXA
      CVQUKTVOWOWSWTJUNVNWKCWNULUOUMWLVTWQEBWLVRBIZJZWPVSAXDWPCVRLMZVSJZVSXDVOW
      KVRGIWPXFUNWLVOXCXBUPVPWKXCSWLBGVRVNVOWKUQURCVQVRUSUTXEVSRVAVEVBWIWRFWNWB
      WFWNVCZWHWQEBXGWGWPAWFWNVRLVDVFVGVHVIVJWIWAFDWBWFVQVCZWHVTEBXHWGVSAWFVQVR
      LVDVFVGVKVLVM $.
  $}

  ${
    $d j z $.  $d k m ch $.  $d k m x z D $.  $d k m x z F $.  $d j k m x ph $.
    $d k m x z G $.  $d m x z ps $.  $d x z ta $.  $d k th $.  $d x z Z $.
    cau3lem.1 $e |- Z C_ ZZ $.
    cau3lem.2 $e |- ( ta -> ps ) $.
    cau3lem.3 $e |- ( ( F ` k ) = ( F ` j ) -> ( ps <-> ch ) ) $.
    cau3lem.4 $e |- ( ( F ` k ) = ( F ` m ) -> ( ps <-> th ) ) $.
    cau3lem.5 $e |- ( ( ph /\ ch /\ ps ) ->
     ( G ` ( ( F ` j ) D ( F ` k ) ) ) = ( G ` ( ( F ` k ) D ( F ` j ) ) ) ) $.
    cau3lem.6 $e |- ( ( ph /\ th /\ ch ) ->
     ( G ` ( ( F ` m ) D ( F ` j ) ) ) = ( G ` ( ( F ` j ) D ( F ` m ) ) ) ) $.
    cau3lem.7 $e |- ( ( ph /\ ( ps /\ th ) /\ ( ch /\ x e. RR ) ) ->
                      ( ( ( G ` ( ( F ` k ) D ( F ` j ) ) ) < ( x / 2 ) /\
                          ( G ` ( ( F ` j ) D ( F ` m ) ) ) < ( x / 2 ) ) ->
                          ( G ` ( ( F ` k ) D ( F ` m ) ) ) < x ) ) $.
    $( Lemma for ~ cau3 .  (Contributed by Mario Carneiro, 15-Feb-2014.)
       (Revised by Mario Carneiro, 1-May-2014.) $)
    cau3lem $p |- ( ph -> ( A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( ta /\
                            ( G ` ( ( F ` k ) D ( F ` j ) ) ) < x ) <->
          A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( ta /\
            A. m e. ( ZZ>= ` k ) ( G ` ( ( F ` k ) D ( F ` m ) ) ) < x ) ) ) $=
      ( vz cv cfv co clt wbr wa cuz wral wrex crp weq anbi2d rexralbidv cbvralv
      breq2 wcel c2 cdiv wi rphalfcl wceq rspcv syl adantl ralimi r19.26 oveq1d
      wb fveq2 fveq2d breq1d anbi12d biimpi a1i syl5bir expdimp cz sseli rspcva
      uzid sylan adantll simplll simplrr simplrl syl3anc cr simpr simpllr rpred
      jctild syl122anc sylbid exp3a impr an32s anassrs expimpd ralimdv expr wss
      uzss ssralv sylan9 ralimdva com23 adantr mpdd imdistanda 3imtr4g reximdva
      ex sylan2 syld ralrimdva syl5bi raleqbidv ad2antlr oveq2d anim2i w3a sylc
      3expia ralbi syl5bb sylibd impbid ) AEIUBZKUCZHUBZKUCZGUDZLUCZFUBZUEUFZUG
      ZIYKUHUCZUIZHMUJZFUKUIZEYJJUBZKUCZGUDZLUCZYOUEUFZJYIUHUCZUIZUGIYRUIZHMUJZ
      FUKUIZUUAEYNUAUBZUEUFZUGZIYRUIHMUJZUAUKUIZAUUKYTUUOFUAUKFUAULZYQUUNHIMYRU
      UQYPUUMEYOUULYNUEUPUMUNUOAUUPUUJFUKAYOUKUQZUGZUUPEYNYOURUSUDZUEUFZUGZIYRU
      IZHMUJZUUJUURUUPUVDUTZAUURUUTUKUQUVEYOVAUUOUVDUAUUTUKUULUUTVBZUUNUVBHIMYR
      UVFUUMUVAEUULUUTYNUEUPUMUNVCVDVEUUSUVCUUIHMUUSYKMUQZUGZEIYRUIZUVAIYRUIZUG
      UVIUUHIYRUIZUGZUVCUUIUVHUVIUVJUVKUVIUVHBIYRUIZUVJUVKUTEBIYROVFZUVHUVMUGZU
      VJCDUUCYLGUDZLUCZUUTUEUFZUGZJYRUIZUGZUVKUVOUVJUVTCUVHUVMUVJUVTUVMUVJUGZBU
      VAUGZIYRUIZUVHUVTBUVAIYRVGZUWDUVTUTUVHUWDUVTUWCUVSIJYRIJULZBDUVAUVRUWFYJU
      UCVBBDVIYIUUBKVJZQVDUWFYNUVQUUTUEUWFYMUVPLUWFYJUUCYLGUWGVHVKVLVMUOVNVOVPV
      QUVGUVMCUUSUVGYKYRUQZUVMCUVGYKVRUQUWHMVRYKNVSYKWAVDZBCIYKYRIHULZYJYLVBBCV
      IYIYKKVJZPVDVTZWBWCWLUVHUVMUVJUWAUVKUTZUWBUWDUVHUWMUWEUUSUWDUWMUTUVGUUSUW
      AUWDUVKUUSUWAUWDUVKUTUUSUWAUGZUWCUUHIYRUWNYIYRUQZUGBUVAUUHUWNBUWOUVAUUHUT
      UWNBUGUVAUUFJYRUIZUWOUUHUWNBUVAUWPUUSUWCUWAUWPUUSUWCUGZCUVTUWPUWQCUGZUVSU
      UFJYRUWRDUVRUUFUWQCDUVRUUFUTZUUSCDUGZUWCUWSUUSUWTUGZBUVAUWSUXABUGZUVAUVRU
      UFUXBUVAUVRUGUVAYLUUCGUDZLUCZUUTUEUFZUGZUUFUXBUVRUXEUVAUXBUVQUXDUUTUEUXBA
      DCUVQUXDVBAUURUWTBWDZUUSCDBWEZUUSCDBWFZSWGVLUMUXBABDCYOWHUQUXFUUFUTUXGUXA
      BWIUXHUXIUXBYOAUURUWTBWJWKTWMWNWOWPWQWRWSWTWPWQXAUWOUUGYRXBUWPUUHUTYKYIXC
      UUFJUUGYRXDVDXEWQWSXFXMXGXHVPVQXIXNXJEUVAIYRVGEUUHIYRVGZXKXLXOXPXQAUUJYTF
      UKAUUIYSHMAUVGUGUVLUVIYPIYRUIZUGZUUIYSUVGAUWHUVLUXLUTUWIAUWHUGZUVIUVKUXKU
      VIUXMUVMUVKUXKUTUVNUXMUVMUGZUVKUXDYOUEUFZJYRUIZUXKUWHUVKUXPUTAUVMUUHUXPIY
      KYRUWJUUFUXOJUUGYRYIYKUHVJUWJUUEUXDYOUEUWJUUDUXCLUWJYJYLUUCGUWKVHVKVLXRVC
      XSUXPYLYJGUDZLUCZYOUEUFZIYRUIZUXNUXKUXOUXSJIYRJIULZUXDUXRYOUEUYAUXCUXQLUY
      AUUCYJYLGUUBYIKVJXTVKVLUOUXNUXSYPVIZIYRUIZUXTUXKVIUXNACUGZUVMUYCAUWHUVMUY
      DUWHUVMUGCAUWLYAWRUXMUVMWIUYDBUYBIYRACBUYBACBYBUXRYNYOUERVLYDWTYCUXSYPIYR
      YEVDYFYGXNXJXNUXJEYPIYRVGXKXLWTYH $.
  $}

  ${
    $d j k m w x y z F $.  $d j k w x M $.  $d j k x N $.  $d j k w x y z Z $.
    $d j k x W $.
    cau3.1 $e |- Z = ( ZZ>= ` M ) $.
    $( Convert between three-quantifier and four-quantifier versions of the
       Cauchy criterion.  (In particular, the four-quantifier version has no
       occurence of ` j ` in the assertion, so it can be used with ~ rexanuz
       and friends.)  (Contributed by Mario Carneiro, 15-Feb-2014.) $)
    cau3 $p |- ( A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
            ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) <->
               A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( ( F ` k ) e. CC /\
            A. m e. ( ZZ>= ` k ) ( abs ` ( ( F ` k ) - ( F ` m ) ) ) < x ) ) $=
      ( cv cfv cc wcel cmin co cabs clt wbr wa wral wtru cuz wrex wb cz eqsstri
      crp uzssz id eleq1 wceq abssub 3adant1 cr c2 cdiv wi abs3lem cau3lem trud
      ) CIZEJZKLZVABIZEJZMNOJZAIZPQRCVCUAJZSBGUBAUFSVBVADIEJZMNOJVFPQZDUTUAJSRC
      VGSBGUBAUFSUCTVBVDKLZVHKLZVBAMBCDEOGGFUAJUDHFUGUEVBUHVAVDKUIVAVHKUIVJVBVD
      VAMNOJVEUJTVDVAUKULVKVJVHVDMNOJVDVHMNOJZUJTVHVDUKULVBVKRVJVFUMLRVEVFUNUON
      ZPQVLVMPQRVIUPTVAVHVDVFUQULURUS $.

    ${
      cau4.2 $e |- W = ( ZZ>= ` N ) $.
      $( Change the base of a Cauchy criterion.  (Contributed by Mario
         Carneiro, 18-Mar-2014.) $)
      cau4 $p |- ( N e. Z -> ( A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
          ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x )
        <-> A. x e. RR+ E. j e. W A. k e. ( ZZ>= ` j )
          ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ) ) $=
        ( vy wcel cv cfv cuz wral wrex crp wb cz cc cmin co cabs clt wa eluzel2
        wbr rexuz3 syl eluzelz bitr4d eleq2s ralbidv cau3 3bitr4g ) FHLZCMZDNZU
        ALZUSKMDNUBUCUDNAMZUEUHKURONPUFZCBMZONZPZBHQZARPVEBGQZARPUTUSVCDNUBUCUD
        NVAUEUHUFCVDPZBHQARPVHBGQARPUQVFVGARVFVGSFEONZHFVILZVFVEBTQZVGVJETLVFVK
        SEFUGVBBCEHIUIUJVJFTLVGVKSEFUKVBBCFGJUIUJULIUMUNABCKDEHIUOABCKDFGJUOUP
        $.
    $}

    $( A Cauchy sequence of complex numbers is eventually bounded.
       (Contributed by Mario Carneiro, 14-Feb-2014.) $)
    caubnd2 $p |- ( A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
            ( ( F ` k ) e. CC /\ ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ->
         E. y e. RR E. j e. Z A. k e. ( ZZ>= ` j ) ( abs ` ( F ` k ) ) < y ) $=
      ( cv cfv cc wcel clt wbr wa wral wrex c1 cr syl cmin co cabs cuz crp wceq
      wi breq2 anbi2d rexralbidv rspcv ax-mp caddc cz eluzelz eleq2s uzid simpl
      1rp ralimi fveq2 eleq1d rspcva syl2an abscl 1re readdcl sylancl cle simpr
      simplr abs2dif syl2anc resubcld subcld lelttr mp3an3 wb ltsubadd2 expimpd
      mpand sylibd ralimdv impancom mpd ralbidv rspcev ex reximia rexcom sylib
      ) DIZEJZKLZWMCIZEJZUAUBZUCJZAIZMNZOZDWOUDJZPCGQZAUEPZWNWRRMNZOZDXBPZCGQZW
      MUCJZBIZMNZDXBPZCGQBSQZRUELXDXHUGUSXCXHARUEWSRUFZXAXFCDGXBXNWTXEWNWSRWRMU
      HUIUJUKULXHXLBSQZCGQXMXGXOCGWOGLZXGXOXPXGOZWPUCJZRUMUBZSLZXIXSMNZDXBPZXOX
      QXRSLZRSLZXTXQWPKLZYCXPWOXBLZWNDXBPYEXGXPWOUNLZYFYGWOFUDJGFWOUOHUPWOUQTXF
      WNDXBWNXEURUTWNYEDWOXBWLWOUFWMWPKWLWOEVAVBVCVDZWPVEZTVFXRRVGVHXQYEYBYHXPY
      EXGYBXPYEOZXFYADXBYJWNXEYAYJWNOZXEXIXRUAUBZRMNZYAYKYLWRVINZXEYMYKWNYEYNYJ
      WNVJZXPYEWNVKZWMWPVLVMYKYLSLZWRSLZYNXEOYMUGZYKXIXRYKWNXISLZYOWMVETZYKYEYC
      YPYITZVNYKWQKLYRYKWMWPYOYPVOWQVETYQYRYDYSVFYLWRRVPVQVMWAYKYTYCYMYAVRZUUAU
      UBYTYCYDUUCVFXIXRRVSVQVMWBVTWCWDWEXLYBBXSSXJXSUFXKYADXBXJXSXIMUHWFWGVMWHW
      IXLCBGSWJWKT $.

    $( A Cauchy sequence of complex numbers is bounded.  (Contributed by NM,
       4-Apr-2005.)  (Revised by Mario Carneiro, 14-Feb-2014.) $)
    caubnd $p |- ( ( A. k e. Z ( F ` k ) e. CC /\ A. x e. RR+ E. j e. Z
              A. k e. ( ZZ>= ` j ) ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ->
                   E. y e. RR A. k e. Z ( abs ` ( F ` k ) ) < y ) $=
      ( vz cv cfv wcel wral clt wbr wrex cr wa wi cz vw cc cmin co cabs cuz crp
      abscl ralimi r19.29uz ralimdv caubnd2 syl6 cfz wss fzssuz sseqtr4i ssralv
      ex ax-mp cle cfn fzfi fimaxre3 mpan c1 caddc peano2re adantl ltp1 mpd3an3
      lelttr mpan2d expcom impcom ralim syl wceq breq2 ralbidv rspcev rexlimdva
      ee12an mpd wo cif w3a max1 3adant3 simp3 simp1 ifcl ancoms ltletr syl3anc
      max2 simp2 jaod 3expia syl6d wal uzssz eqsstri sseli uztric syl2anr simpr
      wb syl6eleq elfzuzb baib orbi1d mpbird pm3.48 alimdv df-ral anbi12i 19.26
      bitr4i 3imtr4g 3impib imim1i 3expd com23 expimpd com3r rexlimdv rexlimdvv
      syl9 com34 sylsyld imp ) DJZEKZUBLZDGMZYNCJZEKUCUDUEKAJZNOZDYQUFKZMCGPZAU
      GMZYNUEKZBJZNOZDGMZBQPZYPUUCQLZDGMZUUBUUCIJZNOZDYTMZCGPIQPZUUGYOUUHDGYNUH
      UIYPUUBYOYSRDYTMCGPZAUGMUUMYPUUAUUNAUGYPUUAUUNYOYSCDFGHUJUSUKAICDEFGHULUM
      UUIUULUUGICQGUUIUUCUAJZNOZDFYQUNUDZMZUAQPZUUJQLZYQGLZRZUULUUGSZSZUUIUUHDU
      UQMZUUSUUQGUOUUIUVESUUQFUFKZGFYQUPHUQUUHDUUQGURUTUVEUUCYRVAOZDUUQMZAQPZUU
      SUUQVBLUVEUVIFYQVCADUUQUUCVDVEUVEUVHUUSAQUVEYRQLZRZYRVFVGUDZQLZUVHUUCUVLN
      OZDUUQMZUUSUVJUVMUVEYRVHZVIUVKUVGUVNSZDUUQMZUVHUVOSUVJUVEUVRUVJUUHUVQDUUQ
      UUHUVJUVQUUHUVJRUVGYRUVLNOZUVNUVJUVSUUHYRVJVIUUHUVJUVMUVGUVSRUVNSUVJUVMUU
      HUVPVIUUCYRUVLVLVKVMVNUKVOUVGUVNDUUQVPVQUURUVOUAUVLQUUOUVLVRUUPUVNDUUQUUO
      UVLUUCNVSVTWAWCWBWDVQUUIUURUVDUAQUUIUUOQLZUVBUURUVCUVTUVBUUIUURUVCSZUVTUU
      TUVAUUIUWASUVTUUTRZUUIUVAUWAUWBUUIUUPUUKWEZDGMZUUGSZUVAUWASUWBUUIUWDUUCUU
      OUUJVAOZUUJUUOWFZNOZDGMZUUGUWBUUIUWCUWHSZDGMUWDUWISUWBUUHUWJDGUVTUUTUUHUW
      JUVTUUTUUHWGZUUPUWHUUKUWKUUPUUOUWGVAOZUWHUVTUUTUWLUUHUUOUUJWHWIUWKUUHUVTU
      WGQLZUUPUWLRUWHSUVTUUTUUHWJZUVTUUTUUHWKUVTUUTUWMUUHUUTUVTUWMUWFUUJUUOQWLW
      MZWIZUUCUUOUWGWNWOVMUWKUUKUUJUWGVAOZUWHUVTUUTUWQUUHUUOUUJWPWIUWKUUHUUTUWM
      UUKUWQRUWHSUWNUVTUUTUUHWQUWPUUCUUJUWGWNWOVMWRWSUKUWCUWHDGVPUMUWBUWMUWIUUG
      SUWOUWMUWIUUGUUFUWIBUWGQUUDUWGVRUUEUWHDGUUDUWGUUCNVSVTWAUSVQWTUWEUVAUURUU
      LUUGUVAUURUULWGUWDUUGUVAUURUULUWDUVAYMUUQLZUUPSZYMYTLZUUKSZRZDXAZYMGLZUWC
      SZDXAUURUULRZUWDUVAUXBUXEDUVAUXDUWRUWTWEZUXBUWCUVAUXDUXGUVAUXDRZUXGYQYMUF
      KLZUWTWEZUXDYMTLYQTLUXJUVAGTYMGUVFTHFXBXCZXDGTYQUXKXDYMYQXEXFUXHUWRUXIUWT
      UXHYMUVFLZUWRUXIXHUXHYMGUVFUVAUXDXGHXIUWRUXLUXIYMFYQXJXKVQXLXMUSUWRUUPUWT
      UUKXNYIXOUXFUWSDXAZUXADXAZRUXCUURUXMUULUXNUUPDUUQXPUUKDYTXPXQUWSUXADXRXSU
      WCDGXPXTYAYBYCUMYDYEYFYJYGWDYHYKYL $.
  $}

  ${
    sqreulem.1 $e |- B = ( ( sqr ` ( abs ` A ) ) x.
      ( ( ( abs ` A ) + A ) / ( abs ` ( ( abs ` A ) + A ) ) ) ) $.
    $( Lemma for ~ sqreu : write a general complex square root in terms of the
       square root function over nonnegative reals.  (Contributed by Mario
       Carneiro, 9-Jul-2013.) $)
    sqreulem $p |- ( ( A e. CC /\ ( ( abs ` A ) + A ) =/= 0 ) ->
      ( ( B ^ 2 ) = A /\ 0 <_ ( Re ` B ) /\ ( _i x. B ) e/ RR+ ) ) $=
      ( cc wcel cfv caddc co cc0 cexp wceq cle wbr cmul cdiv ccj adantr mpancom
      c2 cr cabs wne wa cre ci crp wnel csqr oveq1i abscl resqrcl syl2anc recnd
      absge0 addcl syl abs00ad necon3bid biimpar divcld sqmuld resqrth absvalsq
      syl5eq sqdivd 2cn mulass mp3an1 mulcl sylancr mulcom eqtr3d oveq12d adddi
      cjcl mpd3an23 eqtr4d sqval binom2 id addcld adddid 3eqtr4d mulcld addcomd
      2timesd mul12 sqvald mpdan 3eqtr3d oveq2d 3eqtr3rd oveq1d muladdd addassd
      cjadd cjred eqtrd mul12d wb sqeq0 eqeq1d 3bitr3rd biimpa divassd divcan4d
      simpl 3eqtrd addcjd 2re remulcl eqeltrd redivcld remulcld sqrge0 clt cneg
      recld cmin negcl releabs subge0d mpbird readd absneg negneg fveq2d renegd
      rered negsubd breqtrrd 2pos ltleii mulge0 mpanl12 divge0 wn eleq1d syl5ib
      0re ne0gt0d syl22anc mulge0d mpanr12 syl5eqel reval fveq2i cjmuld 3eqtr4a
      cjdivd cjcld divdird subneg subeq0ad bitr3d resqcl c1 ax-icn sqmul i2 a1i
      mulm1 renegcl sylsyld sqge0 breq2d le0neg1 biimprcd syl6c absnid necon3ad
      jcad syl6 mpd rpre nsyl df-nel sylibr 3jca ) ADEZAUAFZAGHZIUBZUCZBSJHZAKI
      BUDFZLMUEBNHZUFUGZUWDUWEUWAUHFZSJHZUWBUWBUAFZOHZSJHZNHZUWAAAPFZSUWANHZGHZ
      AGHZNHZUWAUWRNHZOHZNHZAUWDUWEUWIUWLNHZSJHUWNBUXCSJCUIUWDUWIUWLUVTUWIDEUWC
      UVTUWIUVTUWATEZIUWALMZUWITEZAUJZAUNZUWAUKULZUMQZUWDUWBUWKUVTUWBDEZUWCUWAD
      EZUVTUXKUVTUWAUXGUMZUWAAUORZQZUVTUWKDEZUWCUVTUWKUVTUXKUWKTEZUXNUWBUJUPZUM
      ZQZUVTUWKIUBUWCUVTUWKIUWBIUVTUWBUXNUQZURUSZUTZVAVDUWDUWJUWAUWMUXANUWDUXDU
      XEUWJUWAKUVTUXDUWCUXGQUVTUXEUWCUXHQUWAVBULUWDUWMUWBSJHZUWKSJHZOHZUXAUWDUW
      BUWKUXOUXTUYBVEUVTUYFUXAKUWCUVTUYDUWSUYEUWTOUVTUWASJHZSUWAANHZNHZGHZASJHZ
      GHZAUWQNHZAANHZGHUYDUWSUVTUYJUYMUYKUYNGUVTUYJAUWONHZAUWPNHZGHZUYMUVTUYGUY
      OUYIUYPGAVCZUVTUWPANHZUYIUYPUXLUVTUYSUYIKZUXMSDEZUXLUVTUYTVFSUWAAVGVHRUWP
      DEZUVTUYSUYPKUVTVUAUXLVUBVFUXMSUWAVIVJZUWPAVKRVLVMUVTUWODEZVUBUYMUYQKAVOZ
      VUCAUWOUWPVNVPVQAVRVMUXLUVTUYDUYLKUXMUWAAVSRUVTAUWQAUVTVTZUVTUWOUWPVUEVUC
      WAZVUFWBWCUVTUWAUWANHZUWOANHZGHZUWAUWONHZGHZUYHGHZUWAUWQNHZUYHGHUYEUWTUVT
      VULVUNUYHGUVTUWAUWPNHZVUKGHVUKVUOGHVULVUNUVTVUOVUKUVTUWAUWPUXMVUCWDUVTUWA
      UWOUXMVUEWDZWEUVTVUJVUOVUKGUVTSVUHNHZVUHVUHGHVUOVUJUVTVUHUVTUWAUWAUXMUXMW
      DZWFUVTUXLUXLVUQVUOKZUXMUXMVUAUXLUXLVUSVFSUWAUWAWGVHULUVTVUHVUIVUHGUVTUYG
      UYOVUHVUIUYRUVTUWAUXMWHUVTVUDUYOVUIKVUEAUWOVKWIWJWKWLWMUVTUWAUWOUWPUXMVUE
      VUCWBWCWMUVTUWBUWBPFZNHZVUJVUKUYHGHGHZUYEVUMUVTVVAUWBUWAUWOGHZNHVVBUVTVUT
      VVCUWBNUVTVUTUWAPFZUWOGHZVVCUXLUVTVUTVVEKUXMUWAAWPRUVTVVDUWAUWOGUVTUWAUXG
      WQWMWRWKUVTUWAAUWAUWOUXMVUFUXMVUEWNWRUVTUXKUYEVVAKUXNUWBVCUPUVTVUJVUKUYHU
      VTVUHVUIVURVUDUVTVUIDEVUEUWOAVIRWAVUPUXLUVTUYHDEUXMUWAAVIRWOWCUVTUWAUWQAU
      XMVUGVUFWBWCZVMQWRVMUWDUWAUWSNHZUWTOHZAUWTNHZUWTOHZUXBAUVTVVHVVJKUWCUVTVV
      GVVIUWTOUVTUWAAUWRUXMVUFUWQDEUVTUWRDEZVUGUWQAUORZWSWMQUWDUWAUWSUWTUVTUXLU
      WCUXMQUVTUWSDEZUWCUVTVVKVVMVVLAUWRVIWIQUVTUWTDEUWCUVTUWAUWRUXMVVLWDQZUVTU
      WCUWTIUBUVTUWBIUWTIUVTUYEIKZUWKIKZUWTIKUWBIKZUVTUXPVVOVVPWTUXSUWKXAUPUVTU
      YEUWTIVVFXBUYAXCURXDZXEUWDAUWTUVTUWCXGZVVNVVRXFWJXHZUWDIUWIUWBVUTGHZUWKOH
      ZNHZSOHZUWFLUWDVWCTEZIVWCLMZIVWDLMZUWDUWIVWBUVTUXFUWCUXIQZUWDVWAUWKUVTVWA
      TEZUWCUVTVWASUWBUDFZNHZTUVTUWBUXNXIZUVTSTEZVWJTEZVWKTEXJUVTUWBUXNXRZSVWJX
      KVJXLQZUVTUXQUWCUXRQZUYBXMZXNUWDUWIVWBVWHVWRUVTIUWILMZUWCUVTUXDUXEVWSUXGU
      XHUWAXOULQUWDVWIIVWALMZUXQIUWKXPMIVWBLMVWPUVTVWTUWCUVTIVWKVWALUVTVWNIVWJL
      MZIVWKLMZVWOUVTIAXQZUAFZVXCUDFZXSHZVWJLUVTIVXFLMVXEVXDLMZUVTVXCDEZVXGAXTZ
      VXCYAUPUVTVXDVXEUVTVXHVXDTEVXIVXCUJUPZUVTVXCVXIXRZYBYCUVTVWJUWAUDFZAUDFZG
      HZVXDVXEXQZGHVXFUXLUVTVWJVXNKUXMUWAAYDRUVTVXLVXDVXMVXOGUVTVXLUWAVXDUVTUWA
      UXGYIAYEVQUVTVXCXQZUDFVXMVXOUVTVXPAUDAYFZYGUVTVXCVXIYHVLVMUVTVXDVXEUVTVXD
      VXJUMUVTVXEVXKUMYJXHYKVWMISLMVWNVXAUCVXBXJISYTXJYLYMSVWJYNYOULVWLYKQVWQUW
      DUWKVWQUWDUXKIUWKLMUXOUWBUNUPUYBUUAVWAUWKYPUUBUUCVWEVWFUCVWMISXPMVWGXJYLV
      WCSYPUUDULUWDUWFBBPFZGHZSOHZVWDUWDBDEZUWFVXTKUWDBUXCDCUWDUWIUWLUXJUYCWDUU
      EZBUUFUPUWDVXSVWCSOUWDVXSUWIUWLVUTUWKOHZGHZNHZVWCUWDBUWIVYCNHZGHUXCVYFGHV
      XSVYEBUXCVYFGCUIUWDVXRVYFBGUWDVXRUWIPFZUWLPFZNHZVYFUWDVXRUXCPFVYIBUXCPCUU
      GUWDUWIUWLUXJUYCUUHVDUWDVYGUWIVYHVYCNUVTVYGUWIKUWCUVTUWIUXIWQQUWDVYHVUTUW
      KPFZOHVYCUWDUWBUWKUXOUXTUYBUUJUWDVYJUWKVUTOUWDUWKVWQWQWKWRVMWRWKUWDUWIUWL
      VYCUXJUYCUWDVUTUWKUWDUWBUXOUUKZUXTUYBUTWBUUIUWDVWBVYDUWINUWDUWBVUTUWKUXOV
      YKUXTUYBUULWKVQWMWRYKUWDUWGUFEZYQUWHUWDUWGTEZVYLUWDUWAVXCUBZVYMYQUVTUWCVY
      NUVTUWBIUWAVXCUVTUWAVXCXSHZIKVVQUWAVXCKZUVTVYOUWBIUXLUVTVYOUWBKUXMUWAAUUM
      RXBUVTUWAVXCUXMVXIUUNUUOURXDUWDVYMUWAVXCUWDVYMATEZAILMZUCVYPUWDVYMVYQVYRU
      WDUVTVYMVXCTEZVYQVVSVYMUWGSJHZTEUWDVYSUWGUUPUWDVYTVXCTUWDVYTUESJHZUWENHZU
      UQXQZANHZVXCUWDUEDEVYAVYTWUBKUURVYBUEBUUSVJUWDWUAWUCUWEANWUAWUCKUWDUUTUVA
      VVTVMUVTWUDVXCKUWCAUVBQXHZYRYSVYSVXPTEUVTVYQVXCUVCUVTVXPATVXQYRYSUVDZUWDV
      YMIVXCLMZVYQVYRVYMIVYTLMUWDWUGUWGUVEUWDVYTVXCILWUEUVFYSWUFVYQVYRWUGAUVGUV
      HUVIUVLAUVJUVMUVKUVNUWGUVOUVPUWGUFUVQUVRUVS $.
  $}

  ${
    $d A x $.
    $( Existence and uniqueness for the square root function in general.
       (Contributed by Mario Carneiro, 9-Jul-2013.) $)
    sqreu $p |- ( A e. CC -> E! x e. CC ( ( x ^ 2 ) = A /\
        0 <_ ( Re ` x ) /\ ( _i x. x ) e/ RR+ ) ) $=
      ( cc wcel c2 cexp co wceq cc0 cre cfv cle wbr ci cmul crp w3a recnd syl
      cr cv wnel wrex wrmo wreu cabs caddc cneg cmin abscl subneg mpancom negcl
      eqeq1d subeq0ad bitr3d csqr ax-icn absge0 jca eleq1 anbi12d syl5ib impcom
      wa breq2 resqrcl mulcl sylancr sqrneglem negneg adantr eqeq2d mpbid oveq1
      3anbi1d fveq2 breq2d wb oveq2 neleq1 3anbi123d rspcev syl2anc sylbid cdiv
      wne addcl abs00ad necon3bid biimpar divcld mulcld eqid sqreulem pm2.61dne
      ex sqrmo reu5 sylanbrc ) BCDZAUAZEFGZBHZIXBJKZLMZNXBOGZPUBZQZACUCZXIACUDX
      IACUEXAXJBUFKZBUGGZIXAXLIHZXKBUHZHZXJXAXKXNUIGZIHXMXOXAXPXLIXKCDZXAXPXLHX
      AXKBUJZRZXKBUKULUNXAXKXNXSBUMUOUPXAXOXJXAXOVEZNXNUQKZOGZCDZYBEFGZBHZIYBJK
      ZLMZNYBOGZPUBZQZXJXTNCDYACDYCURXTYAXTXNTDZIXNLMZVEZYATDXOXAYMXAXKTDZIXKLM
      ZVEXOYMXAYNYOXRBUSZUTXOYNYKYOYLXKXNTVAXKXNILVFVBVCVDZXNVGSRNYAVHVIXTYDXNU
      HZHZYGYIQZYJXTYMYTYQXNVJSXTYSYEYGYIXTYRBYDXAYRBHXOBVKVLVMVPVNXIYJAYBCXBYB
      HZXDYEXFYGXHYIUUAXCYDBXBYBEFVOUNUUAXEYFILXBYBJVQVRUUAXGYHHXHYIVSXBYBNOVTX
      GYHPWASWBWCWDWQWEXAXLIWGZXJXAUUBVEZXKUQKZXLXLUFKZWFGZOGZCDUUGEFGZBHZIUUGJ
      KZLMZNUUGOGZPUBZQZXJUUCUUDUUFXAUUDCDUUBXAUUDXAYNYOUUDTDXRYPXKVGWDRVLUUCXL
      UUEXAXLCDZUUBXQXAUUOXSXKBWHULZVLXAUUECDUUBXAUUEXAUUOUUETDUUPXLUJSRVLXAUUE
      IWGUUBXAUUEIXLIXAXLUUPWIWJWKWLWMBUUGUUGWNWOXIUUNAUUGCXBUUGHZXDUUIXFUUKXHU
      UMUUQXCUUHBXBUUGEFVOUNUUQXEUUJILXBUUGJVQVRUUQXGUULHXHUUMVSXBUUGNOVTXGUULP
      WASWBWCWDWQWPABWRXIACWSWT $.
  $}

  ${
    $d A x y $.
    $( Closure of the square root function over the complexes.  (Contributed by
       Mario Carneiro, 10-Jul-2013.) $)
    sqrcl $p |- ( A e. CC -> ( sqr ` A ) e. CC ) $=
      ( vx cc wcel csqr cfv cv c2 cexp co wceq cc0 cre cle wbr ci cmul crp wnel
      w3a crio sqrval wreu sqreu riotacl syl eqeltrd ) ACDZAEFBGZHIJAKLUIMFNOPU
      IQJRSTZBCUAZCBAUBUHUJBCUCUKCDBAUDUJBCUEUFUG $.

    $( Lemma for ~ sqrth .  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
    sqrthlem $p |- ( A e. CC -> ( ( ( sqr ` A ) ^ 2 ) = A /\
        0 <_ ( Re ` ( sqr ` A ) ) /\ ( _i x. ( sqr ` A ) ) e/ RR+ ) ) $=
      ( vx cc wcel csqr cfv c2 cexp co wceq cc0 cre cle wbr ci cmul crp wnel wb
      w3a crio sqrval eqcomd sqrcl sqreu oveq1 eqeq1d fveq2 breq2d oveq2 neleq1
      cv wreu syl 3anbi123d riota2 syl2anc mpbird ) ACDZAEFZGHIZAJZKUTLFZMNZOUT
      PIZQRZTZBULZGHIZAJZKVHLFZMNZOVHPIZQRZTZBCUAZUTJZUSUTVPBAUBUCUSUTCDVOBCUMV
      GVQSAUDBAUEVOVGBCUTVHUTJZVJVBVLVDVNVFVRVIVAAVHUTGHUFUGVRVKVCKMVHUTLUHUIVR
      VMVEJVNVFSVHUTOPUJVMVEQUKUNUOUPUQUR $.

    $( Mapping domain and codomain of the square root function.  (Contributed
       by Mario Carneiro, 13-Sep-2015.) $)
    sqrf $p |- sqr : CC --> CC $=
      ( vx vy cc csqr wf wfn cv cfv wcel wral c2 cexp wceq cc0 cre cle wbr cmul
      co ci crp wnel w3a crio riotaex df-sqr fnmpti sqrcl rgen ffnfv mpbir2an )
      CCDEDCFAGZDHCIZACJACBGZKLSULMNUNOHPQTUNRSUAUBUCZBCUDDUOBCUEABUFUGUMACULUH
      UIACCDUJUK $.
  $}

  $( Square root theorem over the complexes.  Theorem I.35 of [Apostol] p. 29.
     (Contributed by Mario Carneiro, 10-Jul-2013.) $)
  sqrth $p |- ( A e. CC -> ( ( sqr ` A ) ^ 2 ) = A ) $=
    ( cc wcel csqr cfv c2 cexp co wceq cc0 cre cle wbr cmul crp sqrthlem simp1d
    ci wnel ) ABCADEZFGHAIJTKELMRTNHOSAPQ $.

  $( The square root function must make a choice between the two roots, which
     differ by a sign change.  In the general complex case, the choice of
     "positive" and "negative" is not so clear.  The convention we use is to
     take the root with positive real part, unless ` A ` is a non-positive real
     (in which case both roots have 0 real part); in this case we take the one
     in the positive imaginary direction.  Another way to look at this is that
     we choose the root that is largest with respect to lexicographic order on
     the complexes (sorting by real part first, then by imaginary part as
     tie-breaker).  (Contributed by Mario Carneiro, 10-Jul-2013.) $)
  sqrrege0 $p |- ( A e. CC -> 0 <_ ( Re ` ( sqr ` A ) ) ) $=
    ( cc wcel csqr cfv c2 cexp co wceq cc0 cre cle wbr cmul crp sqrthlem simp2d
    ci wnel ) ABCADEZFGHAIJTKELMRTNHOSAPQ $.

  $( Solve an equation containing a square.  (Contributed by Mario Carneiro,
     23-Apr-2015.) $)
  eqsqror $p |- ( ( A e. CC /\ B e. CC ) ->
    ( ( A ^ 2 ) = B <-> ( A = ( sqr ` B ) \/ A = -u ( sqr ` B ) ) ) ) $=
    ( cc wcel wa c2 cexp co csqr cfv wceq cneg wo sqrth adantl eqeq2d wb sqeqor
    sqrcl sylan2 bitr3d ) ACDZBCDZEZAFGHZBIJZFGHZKZUEBKAUFKAUFLKMZUDUGBUEUCUGBK
    UBBNOPUCUBUFCDUHUIQBSAUFRTUA $.

  ${
    $d x A $.  $d x B $.
    eqsqrd.1 $e |- ( ph -> A e. CC ) $.
    eqsqrd.2 $e |- ( ph -> B e. CC ) $.
    eqsqrd.3 $e |- ( ph -> ( A ^ 2 ) = B ) $.
    ${
      eqsqrd.4 $e |- ( ph -> 0 <_ ( Re ` A ) ) $.
      eqsqrd.5 $e |- ( ph -> -. ( _i x. A ) e. RR+ ) $.
      $( A deduction for showing that a number equals the square root of
         another.  (Contributed by Mario Carneiro, 3-Apr-2015.) $)
      eqsqrd $p |- ( ph -> A = ( sqr ` B ) ) $=
        ( vx c2 cexp co wceq cc0 cre cle ci cmul crp cc cfv wnel wrmo wcel csqr
        cv wbr w3a wreu sqreu reurmo 3syl df-nel sylibr 3jca sqrcl syl sqrthlem
        wn oveq1 eqeq1d fveq2 breq2d wb oveq2 neleq1 3anbi123d rmoi syl122anc )
        AIUFZJKLZCMZNVJOUAZPUGZQVJRLZSUBZUHZITUCZBTUDBJKLZCMZNBOUAZPUGZQBRLZSUB
        ZUHZCUEUAZTUDZWFJKLZCMZNWFOUAZPUGZQWFRLZSUBZUHZBWFMACTUDZVQITUIVREICUJV
        QITUKULDAVTWBWDFGAWCSUDUSWDHWCSUMUNUOAWOWGECUPUQAWOWNECURUQVQWEWNITBWFV
        JBMZVLVTVNWBVPWDWPVKVSCVJBJKUTVAWPVMWANPVJBOVBVCWPVOWCMVPWDVDVJBQRVEVOW
        CSVFUQVGVJWFMZVLWIVNWKVPWMWQVKWHCVJWFJKUTVAWQVMWJNPVJWFOVBVCWQVOWLMVPWM
        VDVJWFQRVEVOWLSVFUQVGVHVI $.
    $}

    eqsqr2d.4 $e |- ( ph -> 0 < ( Re ` A ) ) $.
    $( A deduction for showing that a number equals the square root of
       another.  (Contributed by Mario Carneiro, 3-Apr-2015.) $)
    eqsqr2d $p |- ( ph -> A = ( sqr ` B ) ) $=
      ( cc0 cre cfv clt wbr cle cr wcel wi 0re recld ltle syl sylancr mpd ci co
      cmul cim wne wn cc wceq reim gt0ne0d eqnetrrd rpre reim0d necon3ai eqsqrd
      crp ) ABCDEFAHBIJZKLZHUSMLZGAHNOUSNOUTVAPQABDRHUSSUAUBAUCBUEUDZUFJZHUGVBU
      ROZUHAUSVCHABUIOUSVCUJDBUKTAUSGULUMVDVCHVDVBVBUNUOUPTUQ $.
  $}

  $( Arithmetic-geometric mean inequality for ` n = 2 ` .  (Contributed by
     Mario Carneiro, 2-Jul-2014.) $)
  amgm2 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) ) ->
      ( sqr ` ( A x. B ) ) <_ ( ( A + B ) / 2 ) ) $=
    ( cr wcel cc0 cle wbr wa c2 cmul co caddc cexp c4 cc wceq syl2anc recnd 2re
    cmin csqr cfv 2cn simpll simprl remulcl mulge0 resqrcl sqmul sylancr oveq1i
    cdiv sq2 sqrth oveq2d syl5eq eqtrd resubcld sqge0d binom2 binom2sub oveq12d
    syl resqcld readdcld pnpcan2d 2timesd 2t2e4 mulassd syl5eqr 3eqtr4rd 3eqtrd
    a1i pnncand 4re subsub23 syl3anc mpbid breqtrrd subge0d eqbrtrd sqrge0 2pos
    wb 0re ltleii mpanl12 addge0 an4s le2sqd mpbird clt pm3.2i lemuldiv2 ) ACDZ
    EAFGZHZBCDZEBFGZHZHZIABJKZUAUBZJKZABLKZFGZXCXEIULKFGZXAXFXDIMKZXEIMKZFGXAXH
    NXBJKZXIFXAXHIIMKZXCIMKZJKZXJXAIODZXCODXHXMPUCXAXCXAXBCDZEXBFGZXCCDZXAWOWRX
    OWOWPWTUDZWQWRWSUEZABUFQZABUGZXBUHQZRIXCUIUJXAXMNXLJKXJXKNXLJUMUKXAXLXBNJXA
    XBODXLXBPXAXBXTRZXBUNVCUOUPUQXAEXIXJTKZFGXJXIFGXAEABTKZIMKZYDFXAYEXAABXRXSU
    RZUSXAXIYFTKZXJPZYDYFPZXAYHAIMKZIXBJKZLKZBIMKZLKZYKYLTKZYNLKZTKYMYPTKZXJXAX
    IYOYFYQTXAAODZBODZXIYOPXAAXRRZXABXSRZABUTQXAYSYTYFYQPUUAUUBABVAQVBXAYMYPYNX
    AYMXAYKYLXAAXRVDZXAICDZXOYLCDSXTIXBUFUJZVERXAYPXAYKYLUUCUUEURRXAYNXABXSVDRV
    FXAIYLJKZYLYLLKXJYRXAYLXAYLUUERZVGXAXJIIJKZXBJKUUFUUHNXBJVHUKXAIIXBXNXAUCVM
    ZUUIYCVIVJXAYKYLYLXAYKUUCRUUGUUGVNVKVLXAXIODYFODXJODYIYJWDXAXIXAXEXAABXRXSV
    EZVDZRXAYFXAYEYGVDRXAXJXANCDXOXJCDVOXTNXBUFUJZRXIYFXJVPVQVRVSXAXIXJUUKUULVT
    VRWAXAXDXEXAUUDXQXDCDSYBIXCUFUJUUJXAXQEXCFGZEXDFGZYBXAXOXPUUMXTYAXBWBQUUDEI
    FGXQUUMHUUNSEIWESWCWFIXCUGWGQWOWRWPWSEXEFGABWHWIWJWKXAXQXECDUUDEIWLGZHZXFXG
    WDYBUUJUUPXAUUDUUOSWCWMVMXCXEIWNVQVR $.

  ${
    sqrth.1 $e |- A e. RR $.
    $( Square root theorem.  Theorem I.35 of [Apostol] p. 29.  (Contributed by
       NM, 26-May-1999.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
    sqrthi $p |- ( 0 <_ A -> ( ( sqr ` A ) x. ( sqr ` A ) ) = A ) $=
      ( cr wcel cc0 cle wbr csqr cfv cmul co wceq remsqsqr mpan ) ACDEAFGAHIZOJ
      KALBAMN $.

    $( The square root of a nonnegative real is a real.  (Contributed by NM,
       26-May-1999.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
    sqrcli $p |- ( 0 <_ A -> ( sqr ` A ) e. RR ) $=
      ( cr wcel cc0 cle wbr csqr cfv resqrcl mpan ) ACDEAFGAHICDBAJK $.

    $( The square root of a positive real is positive.  (Contributed by NM,
       26-May-1999.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
    sqrgt0i $p |- ( 0 < A -> 0 < ( sqr ` A ) ) $=
      ( cr wcel cc0 clt wbr csqr cfv sqrgt0 mpan ) ACDEAFGEAHIFGBAJK $.

    $( Square root of square.  (Contributed by NM, 2-Aug-1999.) $)
    sqrmsqi $p |- ( 0 <_ A -> ( sqr ` ( A x. A ) ) = A ) $=
      ( cr wcel cc0 cle wbr cmul co csqr cfv wceq sqrmsq mpan ) ACDEAFGAAHIJKAL
      BAMN $.

    $( Square root of square.  (Contributed by NM, 11-Aug-1999.) $)
    sqrsqi $p |- ( 0 <_ A -> ( sqr ` ( A ^ 2 ) ) = A ) $=
      ( cr wcel cc0 cle wbr c2 cexp co csqr cfv wceq sqrsq mpan ) ACDEAFGAHIJKL
      AMBANO $.

    $( Square of square root.  (Contributed by NM, 11-Aug-1999.) $)
    sqsqri $p |- ( 0 <_ A -> ( ( sqr ` A ) ^ 2 ) = A ) $=
      ( cr wcel cc0 cle wbr csqr cfv c2 cexp co wceq resqrth mpan ) ACDEAFGAHIJ
      KLAMBANO $.

    $( The square root of a nonnegative real is nonnegative.  (Contributed by
       NM, 26-May-1999.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
    sqrge0i $p |- ( 0 <_ A -> 0 <_ ( sqr ` A ) ) $=
      ( cr wcel cc0 cle wbr csqr cfv sqrge0 mpan ) ACDEAFGEAHIFGBAJK $.

    $( A nonnegative number is its own absolute value.  (Contributed by NM,
       2-Aug-1999.) $)
    absidi $p |- ( 0 <_ A -> ( abs ` A ) = A ) $=
      ( cr wcel cc0 cle wbr cabs cfv wceq absid mpan ) ACDEAFGAHIAJBAKL $.

    $( A negative number is the negative of its own absolute value.
       (Contributed by NM, 2-Aug-1999.) $)
    absnidi $p |- ( A <_ 0 -> ( abs ` A ) = -u A ) $=
      ( cr wcel cc0 cle wbr cabs cfv cneg wceq absnid mpan ) ACDAEFGAHIAJKBALM
      $.

    $( A real number is less than or equal to its absolute value.  (Contributed
       by NM, 2-Aug-1999.) $)
    leabsi $p |- A <_ ( abs ` A ) $=
      ( cr wcel cabs cfv cle wbr leabs ax-mp ) ACDAAEFGHBAIJ $.

    $( The absolute value of a real number is either that number or its
       negative.  (Contributed by NM, 30-Sep-1999.) $)
    absori $p |- ( ( abs ` A ) = A \/ ( abs ` A ) = -u A ) $=
      ( cr wcel cabs cfv wceq cneg wo absor ax-mp ) ACDAEFZAGLAHGIBAJK $.

    $( Absolute value of a real number.  (Contributed by NM, 3-Aug-1999.) $)
    absrei $p |- ( abs ` A ) = ( sqr ` ( A ^ 2 ) ) $=
      ( cr wcel cabs cfv c2 cexp co csqr wceq absre ax-mp ) ACDAEFAGHIJFKBALM
      $.

    ${
      sqrpclii.2 $e |- 0 < A $.
      $( The square root of a positive real is a real.  (Contributed by Mario
         Carneiro, 6-Sep-2013.) $)
      sqrpclii $p |- ( sqr ` A ) e. RR $=
        ( cc0 cle wbr csqr cfv cr wcel 0re ltleii sqrcli ax-mp ) DAEFAGHIJDAKBC
        LABMN $.

      $( The square root of a positive real is positive.  (Contributed by NM,
         26-May-1999.)  (Revised by Mario Carneiro, 6-Sep-2013.) $)
      sqrgt0ii $p |- 0 < ( sqr ` A ) $=
        ( cc0 clt wbr csqr cfv sqrgt0i ax-mp ) DAEFDAGHEFCABIJ $.
    $}

    sqr11.1 $e |- B e. RR $.
    $( The square root function is one-to-one.  (Contributed by NM,
       27-Jul-1999.) $)
    sqr11i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
               ( ( sqr ` A ) = ( sqr ` B ) <-> A = B ) ) $=
      ( cr wcel cc0 cle wbr csqr cfv wceq wb wa sqr11 mpanr1 mpanl1 ) AEFZGAHIZ
      GBHIZAJKBJKLABLMZCRSNBEFTUADABOPQ $.

    $( Square root distributes over multiplication.  (Contributed by NM,
       30-Jul-1999.) $)
    sqrmuli $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
               ( sqr ` ( A x. B ) ) = ( ( sqr ` A ) x. ( sqr ` B ) ) ) $=
      ( cr wcel cc0 cle wbr cmul co csqr cfv wceq wa sqrmul mpanr1 mpanl1 ) AEF
      ZGAHIZGBHIZABJKLMALMBLMJKNZCSTOBEFUAUBDABPQR $.

    ${
      sqrmuli.1 $e |- 0 <_ A $.
      sqrmuli.2 $e |- 0 <_ B $.
      $( Square root distributes over multiplication.  (Contributed by NM,
         30-Jul-1999.) $)
      sqrmulii $p |- ( sqr ` ( A x. B ) ) = ( ( sqr ` A ) x. ( sqr ` B ) ) $=
        ( cc0 cle wbr cmul co csqr cfv wceq sqrmuli mp2an ) GAHIGBHIABJKLMALMBL
        MJKNEFABCDOP $.
    $}

    $( Relationship between square root and squares.  (Contributed by NM,
       31-Jul-1999.) $)
    sqrmsq2i $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
       ( ( sqr ` A ) = B <-> A = ( B x. B ) ) ) $=
      ( cc0 cle wbr wa csqr cfv wceq c2 cexp co cmul cr wcel wb sqrsq2 mpanr1
      mpanl1 recni sqvali eqeq2i syl6bb ) EAFGZEBFGZHAIJBKZABLMNZKZABBONZKAPQZU
      FUGUHUJRZCULUFHBPQUGUMDABSTUAUIUKABBDUBUCUDUE $.

    $( Square root is monotonic.  (Contributed by NM, 3-Aug-1999.) $)
    sqrlei $p |- ( ( 0 <_ A /\ 0 <_ B ) ->
        ( A <_ B <-> ( sqr ` A ) <_ ( sqr ` B ) ) ) $=
      ( cr wcel cc0 cle wbr csqr cfv wb wa sqrle mpanr1 mpanl1 ) AEFZGAHIZGBHIZ
      ABHIAJKBJKHILZCQRMBEFSTDABNOP $.

    $( Square root is strictly monotonic.  (Contributed by Roy F. Longton,
       8-Aug-2005.) $)
    sqrlti $p |- ( ( 0 <_ A /\ 0 <_ B ) -> ( A < B <-> ( sqr ` A ) <
      ( sqr ` B ) ) ) $=
      ( cr wcel cc0 cle wbr clt csqr cfv wb wa sqrlt mpanr1 mpanl1 ) AEFZGAHIZG
      BHIZABJIAKLBKLJIMZCRSNBEFTUADABOPQ $.

    $( Absolute value and 'less than' relation.  (Contributed by NM,
       6-Apr-2005.) $)
    abslti $p |- ( ( abs ` A ) < B <-> ( -u B < A /\ A < B ) ) $=
      ( cr wcel cabs cfv clt wbr cneg wa wb abslt mp2an ) AEFBEFAGHBIJBKAIJABIJ
      LMCDABNO $.

    $( Absolute value and 'less than or equal to' relation.  (Contributed by
       NM, 6-Apr-2005.) $)
    abslei $p |- ( ( abs ` A ) <_ B <-> ( -u B <_ A /\ A <_ B ) ) $=
      ( cr wcel cabs cfv cle wbr cneg wa wb absle mp2an ) AEFBEFAGHBIJBKAIJABIJ
      LMCDABNO $.
  $}

  ${
    absvalsqi.1 $e |- A e. CC $.
    $( Square of value of absolute value function.  (Contributed by NM,
       2-Oct-1999.) $)
    absvalsqi $p |- ( ( abs ` A ) ^ 2 ) = ( A x. ( * ` A ) ) $=
      ( cc wcel cabs cfv c2 cexp co ccj cmul wceq absvalsq ax-mp ) ACDAEFGHIAAJ
      FKILBAMN $.

    $( Square of value of absolute value function.  (Contributed by NM,
       2-Oct-1999.) $)
    absvalsq2i $p |- ( ( abs ` A ) ^ 2 ) =
                    ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) $=
      ( cc wcel cabs cfv c2 cexp co cre cim caddc wceq absvalsq2 ax-mp ) ACDAEF
      GHIAJFGHIAKFGHILIMBANO $.

    $( Real closure of absolute value.  (Contributed by NM, 2-Aug-1999.) $)
    abscli $p |- ( abs ` A ) e. RR $=
      ( cc wcel cabs cfv cr abscl ax-mp ) ACDAEFGDBAHI $.

    $( Absolute value is nonnegative.  (Contributed by NM, 2-Aug-1999.) $)
    absge0i $p |- 0 <_ ( abs ` A ) $=
      ( cc wcel cc0 cabs cfv cle wbr absge0 ax-mp ) ACDEAFGHIBAJK $.

    $( Value of absolute value function.  Definition 10.36 of [Gleason]
       p. 133.  (Contributed by NM, 2-Oct-1999.) $)
    absval2i $p |- ( abs ` A ) =
                 ( sqr ` ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
      ( cc wcel cabs cfv cre c2 cexp co cim caddc csqr wceq absval2 ax-mp ) ACD
      AEFAGFHIJAKFHIJLJMFNBAOP $.

    $( The absolute value of a number is zero iff the number is zero.
       Proposition 10-3.7(c) of [Gleason] p. 133.  (Contributed by NM,
       28-Jul-1999.) $)
    abs00i $p |- ( ( abs ` A ) = 0 <-> A = 0 ) $=
      ( cc wcel cabs cfv cc0 wceq wb abs00 ax-mp ) ACDAEFGHAGHIBAJK $.

    $( The absolute value of a nonzero number is positive.  Remark in [Apostol]
       p. 363.  (Contributed by NM, 1-Oct-1999.) $)
    absgt0i $p |- ( A =/= 0 <-> 0 < ( abs ` A ) ) $=
      ( cc wcel cc0 wne cabs cfv clt wbr wb absgt0 ax-mp ) ACDAEFEAGHIJKBALM $.

    $( Absolute value of negative.  (Contributed by NM, 2-Aug-1999.) $)
    absnegi $p |- ( abs ` -u A ) = ( abs ` A ) $=
      ( cc wcel cneg cabs cfv wceq absneg ax-mp ) ACDAEFGAFGHBAIJ $.

    $( The absolute value of a number and its conjugate are the same.
       Proposition 10-3.7(b) of [Gleason] p. 133.  (Contributed by NM,
       2-Oct-1999.) $)
    abscji $p |- ( abs ` ( * ` A ) ) = ( abs ` A ) $=
      ( cc wcel ccj cfv cabs wceq abscj ax-mp ) ACDAEFGFAGFHBAIJ $.

    $( The real part of a number is less than or equal to its absolute value.
       Proposition 10-3.7(d) of [Gleason] p. 133.  (Contributed by NM,
       2-Oct-1999.) $)
    releabsi $p |- ( Re ` A ) <_ ( abs ` A ) $=
      ( cc wcel cre cfv cabs cle wbr releabs ax-mp ) ACDAEFAGFHIBAJK $.

    abssub.2 $e |- B e. CC $.
    $( Swapping order of subtraction doesn't change the absolute value.
       Example of [Apostol] p. 363.  (Contributed by NM, 1-Oct-1999.) $)
    abssubi $p |- ( abs ` ( A - B ) ) = ( abs ` ( B - A ) ) $=
      ( cc wcel cmin co cabs cfv wceq abssub mp2an ) AEFBEFABGHIJBAGHIJKCDABLM
      $.

    $( Absolute value distributes over multiplication.  Proposition 10-3.7(f)
       of [Gleason] p. 133.  (Contributed by NM, 1-Oct-1999.) $)
    absmuli $p |- ( abs ` ( A x. B ) ) = ( ( abs ` A ) x. ( abs ` B ) ) $=
      ( cc wcel cmul co cabs cfv wceq absmul mp2an ) AEFBEFABGHIJAIJBIJGHKCDABL
      M $.

    $( Square of absolute value of sum.  Proposition 10-3.7(g) of [Gleason]
       p. 133.  (Contributed by NM, 2-Oct-1999.) $)
    sqabsaddi $p |- ( ( abs ` ( A + B ) ) ^ 2 ) =
                 ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) ) +
                 ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) $=
      ( cc wcel caddc co cabs cfv c2 cexp ccj cmul cre wceq sqabsadd mp2an ) AE
      FBEFABGHIJKLHAIJKLHBIJKLHGHKABMJNHOJNHGHPCDABQR $.

    $( Square of absolute value of difference.  (Contributed by Steve
       Rodriguez, 20-Jan-2007.) $)
    sqabssubi $p |- ( ( abs ` ( A - B ) ) ^ 2 ) =
                    ( ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) )
                      - ( 2 x. ( Re ` ( A x. ( * ` B ) ) ) ) ) $=
      ( cc wcel cmin co cabs cfv c2 cexp caddc ccj cmul cre wceq sqabssub mp2an
      ) AEFBEFABGHIJKLHAIJKLHBIJKLHMHKABNJOHPJOHGHQCDABRS $.

    $( Absolute value distributes over division.  (Contributed by NM,
       26-Mar-2005.) $)
    absdivzi $p |- ( B =/= 0 ->
                  ( abs ` ( A / B ) ) = ( ( abs ` A ) / ( abs ` B ) ) ) $=
      ( cc wcel cc0 wne cdiv co cabs cfv wceq absdiv mp3an12 ) AEFBEFBGHABIJKLA
      KLBKLIJMCDABNO $.

    $( Triangle inequality for absolute value.  Proposition 10-3.7(h) of
       [Gleason] p. 133.  (Contributed by NM, 2-Oct-1999.) $)
    abstrii $p |- ( abs ` ( A + B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) $=
      ( cc wcel caddc co cabs cfv cle wbr abstri mp2an ) AEFBEFABGHIJAIJBIJGHKL
      CDABMN $.

    abs3dif.3 $e |- C e. CC $.
    $( Absolute value of differences around common element.  (Contributed by
       NM, 2-Oct-1999.) $)
    abs3difi $p |- ( abs ` ( A - B ) ) <_ ( ( abs ` ( A - C ) ) +
                  ( abs ` ( C - B ) ) ) $=
      ( cc wcel cmin co cabs cfv caddc cle wbr abs3dif mp3an ) AGHBGHCGHABIJKLA
      CIJKLCBIJKLMJNODEFABCPQ $.

    abs3lem.4 $e |- D e. RR $.
    $( Lemma involving absolute value of differences.  (Contributed by NM,
       2-Oct-1999.) $)
    abs3lemi $p |- ( ( ( abs ` ( A - C ) ) < ( D / 2 ) /\
                       ( abs ` ( C - B ) ) < ( D / 2 ) ) ->
                       ( abs ` ( A - B ) ) < D ) $=
      ( cmin co cabs cfv c2 clt wbr caddc subcli abscli readdcli recni cdiv cle
      abs3difi rehalfcli lt2addi lelttri sylancr cmul 2timesi 2cn 2ne0 divcan2i
      wa eqtr3i syl6breq ) ACIJZKLZDMUAJZNOCBIJZKLZURNOUMZABIJZKLZURURPJZDNVAVC
      UQUTPJZUBOVEVDNOVCVDNOABCEFGUCUQUTURURUPACEGQRZUSCBGFQRZDHUDZVHUEVCVEVDVB
      ABEFQRUQUTVFVGSURURVHVHSUFUGMURUHJVDDURURVHTUIDMDHTUJUKULUNUO $.
  $}

  ${
    sqrgt0d.1 $e |- ( ph -> A e. RR+ ) $.
    $( The square root of a positive real is positive.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    rpsqrcld $p |- ( ph -> ( sqr ` A ) e. RR+ ) $=
      ( crp wcel csqr cfv rpsqrcl syl ) ABDEBFGDECBHI $.

    $( The square root of a positive real is positive.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    sqrgt0d $p |- ( ph -> 0 < ( sqr ` A ) ) $=
      ( csqr cfv rpsqrcld rpgt0d ) ABDEABCFG $.
  $}

  ${
    resqrcld.1 $e |- ( ph -> A e. RR ) $.
    ${
      absnidd.2 $e |- ( ph -> A <_ 0 ) $.
      $( A negative number is the negative of its own absolute value.
         (Contributed by Mario Carneiro, 29-May-2016.) $)
      absnidd $p |- ( ph -> ( abs ` A ) = -u A ) $=
        ( cr wcel cc0 cle wbr cabs cfv cneg wceq absnid syl2anc ) ABEFBGHIBJKBL
        MCDBNO $.
    $}

    $( A real number is less than or equal to its absolute value.  (Contributed
       by Mario Carneiro, 29-May-2016.) $)
    leabsd $p |- ( ph -> A <_ ( abs ` A ) ) $=
      ( cr wcel cabs cfv cle wbr leabs syl ) ABDEBBFGHICBJK $.

    $( The absolute value of a real number is either that number or its
       negative.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    absord $p |- ( ph -> ( ( abs ` A ) = A \/ ( abs ` A ) = -u A ) ) $=
      ( cr wcel cabs cfv wceq cneg wo absor syl ) ABDEBFGZBHMBIHJCBKL $.

    $( Absolute value of a real number.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    absred $p |- ( ph -> ( abs ` A ) = ( sqr ` ( A ^ 2 ) ) ) $=
      ( cr wcel cabs cfv c2 cexp co csqr wceq absre syl ) ABDEBFGBHIJKGLCBMN $.

    resqrcld.2 $e |- ( ph -> 0 <_ A ) $.
    $( The square root of a nonnegative real is a real.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    resqrcld $p |- ( ph -> ( sqr ` A ) e. RR ) $=
      ( cr wcel cc0 cle wbr csqr cfv resqrcl syl2anc ) ABEFGBHIBJKEFCDBLM $.

    $( Square root of square.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    sqrmsqd $p |- ( ph -> ( sqr ` ( A x. A ) ) = A ) $=
      ( cr wcel cc0 cle wbr cmul co csqr cfv wceq sqrmsq syl2anc ) ABEFGBHIBBJK
      LMBNCDBOP $.

    $( Square root of square.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    sqrsqd $p |- ( ph -> ( sqr ` ( A ^ 2 ) ) = A ) $=
      ( cr wcel cc0 cle wbr c2 cexp co csqr cfv wceq sqrsq syl2anc ) ABEFGBHIBJ
      KLMNBOCDBPQ $.

    $( The square root of a nonnegative real is nonnegative.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    sqrge0d $p |- ( ph -> 0 <_ ( sqr ` A ) ) $=
      ( cr wcel cc0 cle wbr csqr cfv sqrge0 syl2anc ) ABEFGBHIGBJKHICDBLM $.

    $( The square root of a negative number.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    sqrnegd $p |- ( ph -> ( sqr ` -u A ) = ( _i x. ( sqr ` A ) ) ) $=
      ( cr wcel cc0 cle wbr cneg csqr cfv ci cmul co wceq sqrneg syl2anc ) ABEF
      GBHIBJKLMBKLNOPCDBQR $.

    $( A nonnegative number is its own absolute value.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    absidd $p |- ( ph -> ( abs ` A ) = A ) $=
      ( cr wcel cc0 cle wbr cabs cfv wceq absid syl2anc ) ABEFGBHIBJKBLCDBMN $.

    ${
      sqrdivd.3 $e |- ( ph -> B e. RR+ ) $.
      $( Square root distributes over division.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      sqrdivd $p |- ( ph ->
                 ( sqr ` ( A / B ) ) = ( ( sqr ` A ) / ( sqr ` B ) ) ) $=
        ( cr wcel cc0 cle wbr crp cdiv co csqr cfv wceq sqrdiv syl21anc ) ABGHI
        BJKCLHBCMNOPBOPCOPMNQDEFBCRS $.
    $}

    sqr11d.3 $e |- ( ph -> B e. RR ) $.
    sqr11d.4 $e |- ( ph -> 0 <_ B ) $.
    $( Square root distributes over multiplication.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    sqrmuld $p |- ( ph ->
               ( sqr ` ( A x. B ) ) = ( ( sqr ` A ) x. ( sqr ` B ) ) ) $=
      ( cr wcel cc0 cle wbr cmul co csqr cfv wceq sqrmul syl22anc ) ABHIJBKLCHI
      JCKLBCMNOPBOPCOPMNQDEFGBCRS $.

    $( Relationship between square root and squares.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    sqrsq2d $p |- ( ph -> ( ( sqr ` A ) = B <-> A = ( B ^ 2 ) ) ) $=
      ( cr wcel cc0 cle wbr csqr cfv wceq c2 cexp co wb sqrsq2 syl22anc ) ABHIJ
      BKLCHIJCKLBMNCOBCPQROSDEFGBCTUA $.

    $( Square root is monotonic.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    sqrled $p |- ( ph -> ( A <_ B <-> ( sqr ` A ) <_ ( sqr ` B ) ) ) $=
      ( cr wcel cc0 cle wbr csqr cfv wb sqrle syl22anc ) ABHIJBKLCHIJCKLBCKLBMN
      CMNKLODEFGBCPQ $.

    $( Square root is strictly monotonic.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    sqrltd $p |- ( ph -> ( A < B <-> ( sqr ` A ) < ( sqr ` B ) ) ) $=
      ( cr wcel cc0 cle wbr clt csqr cfv wb sqrlt syl22anc ) ABHIJBKLCHIJCKLBCM
      LBNOCNOMLPDEFGBCQR $.

    sqr11d.5 $e |- ( ph -> ( sqr ` A ) = ( sqr ` B ) ) $.
    $( The square root function is one-to-one.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    sqr11d $p |- ( ph -> A = B ) $=
      ( csqr cfv wceq cr wcel cc0 cle wbr wb sqr11 syl22anc mpbid ) ABIJCIJKZBC
      KZHABLMNBOPCLMNCOPUAUBQDEFGBCRST $.
  $}

  ${
    absltd.1 $e |- ( ph -> A e. RR ) $.
    absltd.2 $e |- ( ph -> B e. RR ) $.
    $( Absolute value and 'less than' relation.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    absltd $p |- ( ph -> ( ( abs ` A ) < B <-> ( -u B < A /\ A < B ) ) ) $=
      ( cr wcel cabs cfv clt wbr cneg wa wb abslt syl2anc ) ABFGCFGBHICJKCLBJKB
      CJKMNDEBCOP $.

    $( Absolute value and 'less than or equal to' relation.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    absled $p |- ( ph -> ( ( abs ` A ) <_ B <-> ( -u B <_ A /\ A <_ B ) ) ) $=
      ( cr wcel cabs cfv cle wbr cneg wa wb absle syl2anc ) ABFGCFGBHICJKCLBJKB
      CJKMNDEBCOP $.

    ${
      abssubge0d.2 $e |- ( ph -> A <_ B ) $.
      $( Absolute value of a nonnegative difference.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      abssubge0d $p |- ( ph -> ( abs ` ( B - A ) ) = ( B - A ) ) $=
        ( cr wcel cle wbr cmin co cabs cfv wceq abssubge0 syl3anc ) ABGHCGHBCIJ
        CBKLZMNRODEFBCPQ $.

      $( Absolute value of a nonpositive difference.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      abssuble0d $p |- ( ph -> ( abs ` ( A - B ) ) = ( B - A ) ) $=
        ( cr wcel cle wbr cmin co cabs cfv wceq abssuble0 syl3anc ) ABGHCGHBCIJ
        BCKLMNCBKLODEFBCPQ $.
    $}

    absltd.3 $e |- ( ph -> C e. RR ) $.
    $( The absolute value of a difference and 'less than' relation.
       (Contributed by Mario Carneiro, 29-May-2016.) $)
    absdifltd $p |- ( ph -> ( ( abs ` ( A - B ) ) < C <->
                        ( ( B - C ) < A /\ A < ( B + C ) ) ) ) $=
      ( cr wcel cmin co cabs cfv clt wbr caddc wa wb absdiflt syl3anc ) ABHICHI
      DHIBCJKLMDNOCDJKBNOBCDPKNOQREFGBCDST $.

    $( The absolute value of a difference and 'less than or equal to'
       relation.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    absdifled $p |- ( ph -> ( ( abs ` ( A - B ) ) <_ C <->
                        ( ( B - C ) <_ A /\ A <_ ( B + C ) ) ) ) $=
      ( cr wcel cmin co cabs cfv cle wbr caddc wa wb absdifle syl3anc ) ABHICHI
      DHIBCJKLMDNOCDJKBNOBCDPKNOQREFGBCDST $.
  $}

  ${
    abscld.1 $e |- ( ph -> A e. CC ) $.
    $( Real closure of absolute value.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    abscld $p |- ( ph -> ( abs ` A ) e. RR ) $=
      ( cc wcel cabs cfv cr abscl syl ) ABDEBFGHECBIJ $.

    $( Closure of the square root function over the complexes.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    sqrcld $p |- ( ph -> ( sqr ` A ) e. CC ) $=
      ( cc wcel csqr cfv sqrcl syl ) ABDEBFGDECBHI $.

    $( The real part of the square root function is nonnegative.  (Contributed
       by Mario Carneiro, 29-May-2016.) $)
    sqrrege0d $p |- ( ph -> 0 <_ ( Re ` ( sqr ` A ) ) ) $=
      ( cc wcel cc0 csqr cfv cre cle wbr sqrrege0 syl ) ABDEFBGHIHJKCBLM $.

    $( Square root theorem.  Theorem I.35 of [Apostol] p. 29.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    sqsqrd $p |- ( ph -> ( ( sqr ` A ) ^ 2 ) = A ) $=
      ( cc wcel csqr cfv c2 cexp co wceq sqrth syl ) ABDEBFGHIJBKCBLM $.

    $( Square root theorem.  Theorem I.35 of [Apostol] p. 29.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    msqsqrd $p |- ( ph -> ( ( sqr ` A ) x. ( sqr ` A ) ) = A ) $=
      ( csqr cfv c2 cexp co cmul sqrcld sqvald sqsqrd eqtr3d ) ABDEZFGHNNIHBANA
      BCJKABCLM $.

    ${
      sqr00d.2 $e |- ( ph -> ( sqr ` A ) = 0 ) $.
      $( A square root is zero iff its argument is 0.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      sqr00d $p |- ( ph -> A = 0 ) $=
        ( csqr cfv c2 cexp co cc0 sqsqrd sq0id eqtr3d ) ABEFZGHIBJABCKANDLM $.
    $}

    $( Square of value of absolute value function.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    absvalsqd $p |- ( ph -> ( ( abs ` A ) ^ 2 ) = ( A x. ( * ` A ) ) ) $=
      ( cc wcel cabs cfv c2 cexp co ccj cmul wceq absvalsq syl ) ABDEBFGHIJBBKG
      LJMCBNO $.

    $( Square of value of absolute value function.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    absvalsq2d $p |- ( ph -> ( ( abs ` A ) ^ 2 ) =
                    ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) $=
      ( cc wcel cabs cfv c2 cexp co cre cim caddc wceq absvalsq2 syl ) ABDEBFGH
      IJBKGHIJBLGHIJMJNCBOP $.

    $( Absolute value is nonnegative.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    absge0d $p |- ( ph -> 0 <_ ( abs ` A ) ) $=
      ( cc wcel cc0 cabs cfv cle wbr absge0 syl ) ABDEFBGHIJCBKL $.

    $( Value of absolute value function.  Definition 10.36 of [Gleason]
       p. 133.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    absval2d $p |- ( ph -> ( abs ` A ) =
                 ( sqr ` ( ( ( Re ` A ) ^ 2 ) + ( ( Im ` A ) ^ 2 ) ) ) ) $=
      ( cc wcel cabs cfv cre c2 cexp co cim caddc csqr wceq absval2 syl ) ABDEB
      FGBHGIJKBLGIJKMKNGOCBPQ $.

    ${
      abs00d.2 $e |- ( ph -> ( abs ` A ) = 0 ) $.
      $( The absolute value of a number is zero iff the number is zero.
         Proposition 10-3.7(c) of [Gleason] p. 133.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      abs00d $p |- ( ph -> A = 0 ) $=
        ( cabs cfv cc0 wceq abs00ad mpbid ) ABEFGHBGHDABCIJ $.
    $}

    ${
      absne0d.2 $e |- ( ph -> A =/= 0 ) $.
      $( The absolute value of a number is zero iff the number is zero.
         Proposition 10-3.7(c) of [Gleason] p. 133.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      absne0d $p |- ( ph -> ( abs ` A ) =/= 0 ) $=
        ( cabs cfv cc0 wne abs00ad necon3bid mpbird ) ABEFZGHBGHDALGBGABCIJK $.

      $( The absolute value of a nonzero number is a positive real.
         (Contributed by Mario Carneiro, 29-May-2016.) $)
      absrpcld $p |- ( ph -> ( abs ` A ) e. RR+ ) $=
        ( cc wcel cc0 wne cabs cfv crp absrpcl syl2anc ) ABEFBGHBIJKFCDBLM $.
    $}

    $( Absolute value of negative.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    absnegd $p |- ( ph -> ( abs ` -u A ) = ( abs ` A ) ) $=
      ( cc wcel cneg cabs cfv wceq absneg syl ) ABDEBFGHBGHICBJK $.

    $( The absolute value of a number and its conjugate are the same.
       Proposition 10-3.7(b) of [Gleason] p. 133.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    abscjd $p |- ( ph -> ( abs ` ( * ` A ) ) = ( abs ` A ) ) $=
      ( cc wcel ccj cfv cabs wceq abscj syl ) ABDEBFGHGBHGICBJK $.

    $( The real part of a number is less than or equal to its absolute value.
       Proposition 10-3.7(d) of [Gleason] p. 133.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    releabsd $p |- ( ph -> ( Re ` A ) <_ ( abs ` A ) ) $=
      ( cc wcel cre cfv cabs cle wbr releabs syl ) ABDEBFGBHGIJCBKL $.

    ${
      absexpd.2 $e |- ( ph -> N e. NN0 ) $.
      $( Absolute value of natural number exponentiation.  (Contributed by
         Mario Carneiro, 29-May-2016.) $)
      absexpd $p |- ( ph ->
                    ( abs ` ( A ^ N ) ) = ( ( abs ` A ) ^ N ) ) $=
        ( cc wcel cn0 cexp co cabs cfv wceq absexp syl2anc ) ABFGCHGBCIJKLBKLCI
        JMDEBCNO $.
    $}

    abssubd.2 $e |- ( ph -> B e. CC ) $.
    $( Swapping order of subtraction doesn't change the absolute value.
       Example of [Apostol] p. 363.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    abssubd $p |- ( ph -> ( abs ` ( A - B ) ) = ( abs ` ( B - A ) ) ) $=
      ( cc wcel cmin co cabs cfv wceq abssub syl2anc ) ABFGCFGBCHIJKCBHIJKLDEBC
      MN $.

    $( Absolute value distributes over multiplication.  Proposition 10-3.7(f)
       of [Gleason] p. 133.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    absmuld $p |- ( ph ->
      ( abs ` ( A x. B ) ) = ( ( abs ` A ) x. ( abs ` B ) ) ) $=
      ( cc wcel cmul co cabs cfv wceq absmul syl2anc ) ABFGCFGBCHIJKBJKCJKHILDE
      BCMN $.

    ${
      absdivd.2 $e |- ( ph -> B =/= 0 ) $.
      $( Absolute value distributes over division.  (Contributed by Mario
         Carneiro, 29-May-2016.) $)
      absdivd $p |- ( ph ->
                    ( abs ` ( A / B ) ) = ( ( abs ` A ) / ( abs ` B ) ) ) $=
        ( cc wcel cc0 wne cdiv co cabs cfv wceq absdiv syl3anc ) ABGHCGHCIJBCKL
        MNBMNCMNKLODEFBCPQ $.
    $}

    $( Triangle inequality for absolute value.  Proposition 10-3.7(h) of
       [Gleason] p. 133.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    abstrid $p |- ( ph ->
      ( abs ` ( A + B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) ) $=
      ( cc wcel caddc co cabs cfv cle wbr abstri syl2anc ) ABFGCFGBCHIJKBJKCJKH
      ILMDEBCNO $.

    $( Difference of absolute values.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    abs2difd $p |- ( ph ->
      ( ( abs ` A ) - ( abs ` B ) ) <_ ( abs ` ( A - B ) ) ) $=
      ( cc wcel cabs cfv cmin co cle wbr abs2dif syl2anc ) ABFGCFGBHICHIJKBCJKH
      ILMDEBCNO $.

    $( Difference of absolute values.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    abs2dif2d $p |- ( ph ->
      ( abs ` ( A - B ) ) <_ ( ( abs ` A ) + ( abs ` B ) ) ) $=
      ( cc wcel cmin co cabs cfv caddc cle wbr abs2dif2 syl2anc ) ABFGCFGBCHIJK
      BJKCJKLIMNDEBCOP $.

    $( Absolute value of difference of absolute values.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    abs2difabsd $p |- ( ph ->
            ( abs ` ( ( abs ` A ) - ( abs ` B ) ) ) <_ ( abs ` ( A - B ) ) ) $=
      ( cc wcel cabs cfv cmin co cle wbr abs2difabs syl2anc ) ABFGCFGBHICHIJKHI
      BCJKHILMDEBCNO $.

    abs3difd.3 $e |- ( ph -> C e. CC ) $.
    $( Absolute value of differences around common element.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    abs3difd $p |- ( ph -> ( abs ` ( A - B ) ) <_ ( ( abs ` ( A - C ) ) +
                  ( abs ` ( C - B ) ) ) ) $=
      ( cc wcel cmin co cabs cfv caddc cle wbr abs3dif syl3anc ) ABHICHIDHIBCJK
      LMBDJKLMDCJKLMNKOPEFGBCDQR $.

    abs3lemd.4 $e |- ( ph -> D e. RR ) $.
    abs3lemd.5 $e |- ( ph -> ( abs ` ( A - C ) ) < ( D / 2 ) ) $.
    abs3lemd.6 $e |- ( ph -> ( abs ` ( C - B ) ) < ( D / 2 ) ) $.
    $( Lemma involving absolute value of differences.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    abs3lemd $p |- ( ph -> ( abs ` ( A - B ) ) < D ) $=
      ( cmin co cabs cfv c2 clt wbr cc wcel cdiv cr wa abs3lem syl22anc mp2and
      wi ) ABDLMNOEPUAMZQRZDCLMNOUHQRZBCLMNOEQRZJKABSTCSTDSTEUBTUIUJUCUKUGFGHIB
      CDEUDUEUF $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
        Elementary limits and convergence
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Superior limit (lim sup)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c limsup $.

  $( Extend class notation to include the limsup function. $)
  clsp $a class limsup $.

  ${
    $d j n w x y z A $.  $d j w x y z B $.  $d a i j m n r x G $.  $d n x ph $.
    $d f k $.  $d j k x C $.  $d a i j k m n r x F $.  $d a i k m n r M $.
    $d a i k m n r Z $.
$(
    df-limsupOLD $a |- limsup = { <. x , y >. | y = sup ( { z |
                  E. k e. ZZ ( ran ( x |` ( ZZ>= ` k ) ) C_ RR* /\
        z = sup ( ran ( x |` ( ZZ>= ` k ) ) , RR* , < ) ) } , RR* , `' < ) } $.

    df-limsupOLD2 $a |- limsup = { <. x , y >. | y = sup ( { z |
   E. k e. ZZ z = sup ( ( x " ( ZZ>= ` k ) ) , RR* , < ) } , RR* , `' < ) } $.
$)

    $( Define the superior limit of an infinite sequence of extended real
       numbers.  Definition 12-4.1 of [Gleason] p. 175.  See ~ limsupval for
       its value.  (Contributed by NM, 26-Oct-2005.) $)
    df-limsup $a |- limsup = ( x e. _V |-> sup ( ran ( k e. RR |->
      sup ( ( ( x " ( k [,) +oo ) ) i^i RR* ) , RR* , < ) ) , RR* , `' < ) ) $.

    $( Ordering property of the superior limit function.  (Contributed by Mario
       Carneiro, 7-Sep-2014.)  (Revised by Mario Carneiro, 7-May-2016.) $)
    limsupgord $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
      sup ( ( ( F " ( B [,) +oo ) ) i^i RR* ) , RR* , < ) <_
      sup ( ( ( F " ( A [,) +oo ) ) i^i RR* ) , RR* , < ) ) $=
      ( vx vy vz vw cr wcel cle wbr cv cpnf cico co cima cxr cin clt wss df-ico
      w3a csup wral rexr 3ad2ant1 simp3 xrletr ixxss1 syl2anc imass2 ssrin 3syl
      inss2 supxrcl ax-mp xrleid wb supxrleub mp2an mpbi ssralv ee10 sylibr ) A
      HIZBHIZABJKZUBZDLCAMNOZPZQRZQSUCZJKZDCBMNOZPZQRZUDZVPQSUCVLJKZVHVPVKTZVMD
      VKUDZVQVHVNVITZVOVJTVSVHAQIZVGWAVEVFWBVGAUEUFVEVFVGUGDEFGABMNJSJNJDEFUAZW
      CABGLUHUIUJVNVICUKVOVJQULUMVLVLJKZVTVLQIZWDVKQTZWEVJQUNZVKUOUPZVLUQUPWFWE
      WDVTURWGWHDVKVLUSUTVAVMDVPVKVBVCVPQTWEVRVQURVOQUNWHDVPVLUSUTVD $.

    $( Closure of the superior limit.  (Contributed by NM, 26-Oct-2005.)
       (Revised by Mario Carneiro, 7-May-2016.) $)
    limsupcl $p |- ( F e. V -> ( limsup ` F ) e. RR* ) $=
      ( vf vk wcel cvv clsp cfv cxr elex cr cv cpnf cico co clt csup mp1i fmpti
      wss cima cin cmpt crn ccnv df-limsup wf eqid inss2 supxrcl ax-mp infmxrcl
      frn ffvelrni syl ) ABEAFEAGHIEABJFIAGCFIDKCLZDLZMNOUAZIUBZIPQZUCZUDZIPUEQ
      ZGCDUFVBITZVCIEUPFEKIVAUGVDDKIUTVAVAUHUSITUTIEUQKEURIUIUSUJRSKIVAUMUKVBUL
      RSUNUO $.

    limsupval.1 $e |- G = ( k e. RR |->
      sup ( ( ( F " ( k [,) +oo ) ) i^i RR* ) , RR* , < ) ) $.
    $( The superior limit of an infinite sequence ` F ` of extended real
       numbers, which is the infimum (indicated by ` ``' < ` ) of the set of
       suprema of all upper infinite subsequences of ` F ` .  Definition 12-4.1
       of [Gleason] p. 175.  (Contributed by NM, 26-Oct-2005.)  (Revised by
       Mario Carneiro, 5-Sep-2014.) $)
    limsupval $p |- ( F e. V ->
      ( limsup ` F ) = sup ( ran G , RR* , `' < ) ) $=
      ( vx wcel cvv clsp crn cxr clt csup wceq cr cv cima cin cmpt supeq1d ccnv
      cfv elex cpnf cico co imaeq1 ineq1d mpteq2dv syl6eqr df-limsup wor xrltso
      rneqd cnvso mpbi supex fvmpt syl ) BDGBHGBIUBCJZKLUAZMZNBDUCFBAOFPZAPUDUE
      UFZQZKRZKLMZSZJZKVAMVBHIVCBNZKVIUTVAVJVHCVJVHAOBVDQZKRZKLMZSCVJAOVGVMVJKV
      FVLLVJVEVKKVCBVDUGUHTUIEUJUNTFAUKKUTVAKLULKVAULUMKLUOUPUQURUS $.

    $( Closure of the superior limit function.  (Contributed by Mario Carneiro,
       7-Sep-2014.)  (Revised by Mario Carneiro, 7-May-2016.) $)
    limsupgf $p |- G : RR --> RR* $=
      ( cr cxr cv cpnf cico cima cin clt csup wss wcel inss2 supxrcl mp1i fmpti
      co ) AEFBAGZHITJZFKZFLMZCDUCFNUDFOUAEOUBFPUCQRS $.

    $( Value of the superior limit function.  (Contributed by Mario Carneiro,
       7-Sep-2014.)  (Revised by Mario Carneiro, 7-May-2016.) $)
    limsupgval $p |- ( M e. RR -> ( G ` M ) =
      sup ( ( ( F " ( M [,) +oo ) ) i^i RR* ) , RR* , < ) ) $=
      ( cv cpnf cico co cima cxr cin clt csup wceq oveq1 imaeq2d ineq1d supeq1d
      cr xrltso supex fvmpt ) ADBAFZGHIZJZKLZKMNBDGHIZJZKLZKMNTCUDDOZKUGUJMUKUF
      UIKUKUEUHBUDDGHPQRSEKUJMUAUBUC $.

    $( The defining property of the superior limit function.  (Contributed by
       Mario Carneiro, 5-Sep-2014.)  (Revised by Mario Carneiro,
       7-May-2016.) $)
    limsupgle $p |- ( ( ( B C_ RR /\ F : B --> RR* ) /\ C e. RR /\ A e. RR* )
      -> ( ( G ` C ) <_ A <-> A. j e. B ( C <_ j -> ( F ` j ) <_ A ) ) ) $=
      ( vx cr wss cxr wa wcel cle wbr cin wral wi wceq wf w3a cpnf cico co cima
      cfv csup cv limsupgval 3ad2ant2 breq1d inss2 simp3 supxrleub sylancr cres
      clt wb cdm crn imassrn simp1r frn syl syl5ss df-ss sylib imadmres syl6eqr
      raleqdv wfn ffn fdm ineq2d dmres incom 3eqtr4g inss1 breq1 ralima syl2anc
      syl6eqss eleq2d syl6bb simpl2 simp1l sselda elicopnf baibd pm5.32da bitrd
      elin imbi1d impexp ralbidv2 3bitrd ) BJKZBLFUAZMZCJNZALNZUBZCGUGZAOPFCUCU
      DUEZUFZLQZLURUHZAOPZIUIZAOPZIXGRZCDUIZOPZXMFUGZAOPZSZDBRZXCXDXHAOXAWTXDXH
      TXBEFGCHUJUKULXCXGLKXBXIXLUSXFLUMWTXAXBUNIXGAUOUPXCXLXKIFFXEUQUTZUFZRZXPD
      XSRZXRXCXKIXGXTXCXGXFXTXCXFLKXGXFTXCXFFVAZLFXEVBXCWSYCLKWRWSXAXBVCZBLFVDV
      EVFXFLVGVHFXEVIVJVKXCFBVLZXSBKYAYBUSXCWSYEYDBLFVMVEXCXSBXEQZBXCXEFUTZQXEB
      QXSYFXCYGBXEXCWSYGBTYDBLFVNVEVOFXEVPBXEVQVRZBXEVSWCXKXPIDBXSFXJXOAOVTWAWB
      XCXPXQDXSBXCXMXSNZXPSXMBNZXNMZXPSYJXQSXCYIYKXPXCYIYJXMXENZMZYKXCYIXMYFNYM
      XCXSYFXMYHWDXMBXEWMWEXCYJYLXNXCYJMXAXMJNZYLXNUSWTXAXBYJWFXCBJXMWRWSXAXBWG
      WHXAYLYNXNCXMWIWJWBWKWLWNYJXNXPWOWEWPWQWQ $.

    $( The defining property of the superior limit.  (Contributed by Mario
       Carneiro, 7-Sep-2014.)  (Revised by Mario Carneiro, 7-May-2016.) $)
    limsuple $p |- ( ( B C_ RR /\ F : B --> RR* /\ A e. RR* ) ->
      ( A <_ ( limsup ` F ) <-> A. j e. RR A <_ ( G ` j ) ) ) $=
      ( vx cr wss cxr wf wcel cfv cle wbr cv wral cvv ax-mp clsp ccnv csup wceq
      w3a crn clt reex ssex 3ad2ant1 xrex a1i fex2 syl3anc limsupval syl breq2d
      simp2 wb limsupgf frn simp3 infmxrgelb sylancr wfn ffn breq2 ralrn syl6bb
      bitrd ) BIJZBKELZAKMZUEZAEUANZOPAFUFZKUGUBUCZOPZACQFNZOPZCIRZVNVOVQAOVNES
      MZVOVQUDVNVLBSMZKSMZWBVKVLVMURVKVLWCVMBIUHUIUJWDVNUKULBKESSUMUNDEFSGUOUPU
      QVNVRAHQZOPZHVPRZWAVNVPKJZVMVRWGUSIKFLZWHDEFGUTZIKFVATVKVLVMVBHVPAVCVDFIV
      EZWGWAUSWIWKWJIKFVFTWFVTHCIFWEVSAOVGVHTVIVJ $.

    $( The defining property of the superior limit.  (Contributed by Mario
       Carneiro, 7-Sep-2014.)  (Revised by Mario Carneiro, 7-May-2016.) $)
    limsuplt $p |- ( ( B C_ RR /\ F : B --> RR* /\ A e. RR* ) ->
      ( ( limsup ` F ) < A <-> E. j e. RR ( G ` j ) < A ) ) $=
      ( cr cxr wcel cfv cle wbr wn wrex clt wb cvv xrltnle syl2anc wss w3a clsp
      wf wral limsuple notbid rexnal syl6bbr simp2 reex ssex 3ad2ant1 xrex fex2
      cv a1i syl3anc limsupcl simp3 wa limsupgf ffvelrni adantl simpl3 rexbidva
      syl 3bitr4d ) BHUAZBIEUDZAIJZUBZAEUCKZLMZNZACUPZFKZLMZNZCHOZVMAPMZVQAPMZC
      HOVLVOVRCHUEZNVTVLVNWCABCDEFGUFUGVRCHUHUIVLVMIJZVKWAVOQVLERJZWDVLVJBRJZIR
      JZWEVIVJVKUJVIVJWFVKBHUKULUMWGVLUNUQBIERRUOURERUSVGVIVJVKUTVMASTVLWBVSCHV
      LVPHJZVAVQIJZVKWBVSQWHWIVLHIVPFDEFGVBVCVDVIVJVKWHVEVQASTVFVH $.

    ${
      limsupval2.1 $e |- ( ph -> F e. V ) $.
      limsupval2.2 $e |- ( ph -> A C_ RR ) $.
      limsupval2.3 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
      $( The superior limit, relativized to an unbounded set.  (Contributed by
         Mario Carneiro, 7-Sep-2014.)  (Revised by Mario Carneiro,
         8-May-2016.) $)
      limsupval2 $p |- ( ph ->
        ( limsup ` F ) = sup ( ( G " A ) , RR* , `' < ) ) $=
        ( vx vn cxr csup wcel wceq cle wbr wral cr clsp cfv ccnv cima limsupval
        crn clt syl cv wss imassrn limsupgf frn ax-mp infmxrlb ralrimiva ssralv
        wf mp1i mpsyl sstri infmxrcl infmxrgelb mp2an sylibr wrex ressxr syl6ss
        wb cpnf supxrunb1 mpbird sselda ad2ant2r ffvelrni ad2antlr wfn ad2antrr
        wa ffn simprl fnfvima syl3anc sylancr cico cin simplr simprr limsupgord
        limsupgval 3brtr4d xrletrd rexlimdvaa ralimdva mpd breq2 ralrn xrletri3
        co sylanbrc eqtrd ) ADUAUBZEUFZMUGUCZNZEBUDZMXDNZADFOXBXEPHCDEFGUEUHAXE
        XGQRZXGXEQRZXEXGPZAXEKUIZQRZKXFSZXHXFXCUJAXLKXCSZXMEBUKZXCMUJZXNATMEURZ
        XPCDEGULZTMEUMUNZXPXLKXCXCXKUOUPUSXLKXFXCUQUTXFMUJZXEMOZXHXMVIXFXCMXOXS
        VAZXPYAXSXCVBUNZKXFXEVCVDVEAXGXKQRZKXCSZXIAXGLUIZEUBZQRZLTSZYEAYFXKQRZK
        BVFZLTSZYIAYLBMUGNVJPZJABMUJYLYMVIABTMIVGVHLKBVKUHVLAYKYHLTAYFTOZVSZYJY
        HKBYOXKBOZYJVSZVSZXGXKEUBZYGXTXGMOZYRYBXFVBZUSYRXKTOZYSMOAYPUUBYNYJABTX
        KIVMVNZTMXKEXRVOUHYNYGMOAYQTMYFEXRVOVPYRXTYSXFOZXGYSQRYBYRETVQZBTUJZYPU
        UDXQUUEYRXRTMEVTZUSAUUFYNYQIVRYOYPYJWATBEXKWBWCXFYSUOWDYRDXKVJWEWSUDMWF
        MUGNZDYFVJWEWSUDMWFMUGNZYSYGQYRYNUUBYJUUHUUIQRAYNYQWGUUCYOYPYJWHYFXKDWI
        WCYRUUBYSUUHPUUCCDEXKGWJUHYNYGUUIPAYQCDEYFGWJVPWKWLWMWNWOUUEYEYIVIXQUUE
        XRUUGUNYDYHKLTEXKYGXGQWPWQUNVEXPYTXIYEVIXSXTYTYBUUAUNZKXCXGVCVDVEYAYTXJ
        XHXIVSVIYCUUJXEXGWRVDWTXA $.
    $}

    limsupgre.z $e |- Z = ( ZZ>= ` M ) $.
    $( If a sequence of real numbers has upper bounded limit supremum, then all
       the partial suprema are real.  (Contributed by Mario Carneiro,
       7-Sep-2014.) $)
    limsupgre $p |- ( ( M e. ZZ /\ F : Z --> RR /\ ( limsup ` F ) < +oo ) ->
      G : RR --> RR ) $=
      ( vi cz wcel cr cfv cpnf clt wbr cxr wa cle adantr syl2anc va vn vm vr wf
      clsp w3a cv cico co cima cin csup cvv xrltso supex cmpt limsupgval adantl
      a1i wceq wrex simpl3 wss wb cuz uzssz eqsstri zssre simpl2 ressxr sylancl
      sstri fss pnfxr limsuplt syl3anc mpbid cfl cfz wral fzfi elfzuz syl6eleqr
      cfn ffvelrn syl2an ralrimiva fimaxre3 sylancr cif simpr ad2antrr limsupgf
      ffvelrni simprl sseldi ifcl wi sselda xrleid limsupgle syl211anc r19.21bi
      syl imp xrmax1 ffvelrnda xrletr mpan2d syl6eleq flcld flge bitr4d biimpar
      mpd elfz5 simprr fveq2 breq1d rspcv sylc xrmax2 lecasei a1d ltpnf simplrr
      mpbird breq1 ifboth xrlelttrd rexlimddv eqbrtrrd wne crn imassrn frn zred
      c0 syl5ss syl6ss df-ss sylib eqsstrd cdm caddc simpl1 flcl peano2zd eluz2
      c1 max1 syl3anbrc fdm eleqtrrd fllep1 max2 letrd mpbir2and inelcm imadisj
      elicopnf necon3bii sylibr eqnetrd supxrre1 eqeltrd fmpt2d ) DIJZEKBUEZBUF
      LMNOZUGZAUAKBAUHZMUIUJUKPULZPNUMZKCUNUVOUNJUVLUVMKJQPUVNNUOUPUTCAKUVOUQVA
      UVLFUTUVLUAUHZKJZQZUVPCLZBUVPMUIUJZUKZPULZPNUMZKUVQUVSUWCVAUVLABCUVPFURUS
      ZUVRUWCKJZUWCMNOZUVRUVSUWCMNUWDUVRUBUHZCLZMNOZUVSMNOZUBKUVRUVKUWIUBKVBZUV
      IUVJUVKUVQVCUVREKVDZEPBUEZMPJZUVKUWKVEUWLUVREIKEDVFLZIGDVGVHZVIVMZUTUVRUV
      JKPVDUWMUVIUVJUVKUVQVJZVKEKPBVNVLZUWNUVRVOUTMEUBABCFVPVQVRUVRUWGKJZUWIQZQ
      ZUCUHZBLZUDUHZROZUCDUWGVSLZVTUJZWAZUWJUDKUXBUXHWEJUXDKJZUCUXHWAUXIUDKVBDU
      XGWBUXBUXJUCUXHUXBUVJUXCEJUXJUXCUXHJZUVRUVJUXAUWRSUXKUXCUWOEUXCDUXGWCGWDE
      KUXCBWFWGWHUDUCUXHUXDWIWJUXBUXEKJZUXIQZQZUVSUWHUXEROZUXEUWHWKZMUXNUVQUVSP
      JUVRUVQUXAUXMUVLUVQWLZWMZKPUVPCABCFWNZWOXEUXNUXEPJZUWHPJZUXPPJZUXNKPUXEVK
      UXBUXLUXIWPZWQZUXNUWTUYAUXBUWTUXMUVRUWTUWIWPZSZKPUWGCUXSWOZXEZUXOUXEUWHPW
      RTZUWNUXNVOUTUXNUVSUXPROZUVPHUHZROZUYKBLZUXPROZWSZHEWAZUXNUYOHEUXNUYKEJZQ
      ZUYNUYLUYRUYNUWGUYKUXBUWTUXMUYQUYEWMZUXNEKUYKUWLUXNUWQUTZWTUYRUWGUYKROZQU
      YMUWHROZUYNUYRVUAVUBUXNVUAVUBWSZHEUXNUWHUWHROZVUCHEWAZUXNUYAVUDUYHUWHXAXE
      UXNUWLUWMUWTUYAVUDVUEVEUYTUVRUWMUXAUXMUWSWMZUYFUYHUWHEUWGHABCFXBXCVRXDXFU
      YRVUBUYNWSVUAUYRVUBUWHUXPROZUYNUYRUYAUXTVUGUYRUWTUYAUYSUYGXEZUXNUXTUYQUYD
      SZUWHUXEXGTUYRUYMPJZUYAUYBVUBVUGQUYNWSUXNEPUYKBVUFXHZVUHUXNUYBUYQUYISZUYM
      UWHUXPXIVQXJSXPUYRUYKUWGROZQZUYMUXEROZUYNVUNUYKUXHJZUXIVUOUYRVUPVUMUYRVUP
      UYKUXGROZVUMUYRUYKUWOJUXGIJZVUPVUQVEUYRUYKEUWOUXNUYQWLZGXKUXNVURUYQUXNUWG
      UYFXLSUYKDUXGXQTUYRUWTUYKIJVUMVUQVEUYSUYREIUYKUWPVUSWQUWGUYKXMTXNXOUXNUXI
      UYQVUMUXBUXLUXIXRWMUXFVUOUCUYKUXHUXCUYKVAUXDUYMUXERUXCUYKBXSXTYAYBUYRVUOU
      YNWSVUMUYRVUOUXEUXPROZUYNUXNVUTUYQUXNUYAUXTVUTUYHUYDUWHUXEYCTSUYRVUJUXTUY
      BVUOVUTQUYNWSVUKVUIVULUYMUXEUXPXIVQXJSXPYDYEWHUXNUWLUWMUVQUYBUYJUYPVEUYTV
      UFUXRUYIUXPEUVPHABCFXBXCYHUXNUXEMNOZUWIUXPMNOZUXNUXLVVAUYCUXEYFXEUVRUWTUW
      IUXMYGUXOVVAUWIVVBUXEUWHUXEUXPMNYIUWHUXPMNYIYJTYKYLYLYMUVRUWBKVDUWBYSYNUW
      EUWFVEUVRUWBUWAKUVRUWAPVDUWBUWAVAUVRUWAKPUVRUWABYOZKBUVTYPUVRUVJVVCKVDUWR
      EKBYQXEYTZVKUUAUWAPUUBUUCZVVDUUDUVRUWBUWAYSVVEUVRBUUEZUVTULZYSYNZUWAYSYNU
      VRDUVPVSLZUUKUUFUJZROZVVJDWKZVVFJVVLUVTJZVVHUVRVVLEVVFUVRVVLUWOEUVRUVIVVL
      IJZDVVLROZVVLUWOJUVIUVJUVKUVQUUGZUVRVVJIJUVIVVNUVRVVIUVQVVIIJUVLUVPUUHUSU
      UIZVVPVVKVVJDIWRTZUVRDKJZVVJKJZVVOUVRDVVPYRZUVRVVJVVQYRZDVVJUULTDVVLUUJUU
      MGWDUVRUVJVVFEVAUWREKBUUNXEUUOUVRVVMVVLKJZUVPVVLROZUVRVVLVVRYRZUVRUVPVVJV
      VLUXQVWBVWEUVQUVPVVJROUVLUVPUUPUSUVRVVSVVTVVJVVLROVWAVWBDVVJUUQTUURUVQVVM
      VWCVWDQVEUVLUVPVVLUVBUSUUSVVLVVFUVTUUTTUWAYSVVGYSBUVTUVAUVCUVDUVEUWBUVFTY
      HUVGUVH $.
  $}

  ${
    $d j k m A $.  $d j k m n B $.  $d j k m n F $.  $d j k m ph $.
    limsupbnd.1 $e |- ( ph -> B C_ RR ) $.
    limsupbnd.2 $e |- ( ph -> F : B --> RR* ) $.
    limsupbnd.3 $e |- ( ph -> A e. RR* ) $.
    ${
      limsupbnd1.4 $e |- ( ph ->
        E. k e. RR A. j e. B ( k <_ j -> ( F ` j ) <_ A ) ) $.
      $( If a sequence is eventually at most ` A ` , then the limsup is also at
         most ` A ` .  (The converse is only true if the less or equal is
         replaced by strictly less than; consider the sequence ` 1 / n ` which
         is never less or equal to zero even though the limsup is.)
         (Contributed by Mario Carneiro, 7-Sep-2014.)  (Revised by Mario
         Carneiro, 7-May-2016.) $)
      limsupbnd1 $p |- ( ph -> ( limsup ` F ) <_ A ) $=
        ( vn cv cle wbr cfv cr wcel cxr adantr cvv wi wral wrex clsp wa cpnf co
        cico cima cin clt csup cmpt wf simpr eqid limsupgle syl211anc reex ssex
        wss wb syl xrex fex2 syl3anc limsupcl xrleid limsuple r19.21bi limsupgf
        a1i mpbid ffvelrnda xrletr mpand sylbird rexlimdva mpd ) AELZDLZMNWAFOB
        MNUADCUBZEPUCFUDOZBMNZJAWBWDEPAVTPQZUEZWBVTKPFKLUFUHUGUIRUJRUKULUMZOZBM
        NZWDWFCPVAZCRFUNZWEBRQZWIWBVBAWJWEGSAWKWEHSAWEUOAWLWEISZBCVTDKFWGWGUPZU
        QURWFWCWHMNZWIWDAWOEPAWCWCMNZWOEPUBZAWCRQZWPAFTQZWRAWKCTQZRTQZWSHAWJWTG
        CPUSUTVCXAAVDVLCRFTTVEVFFTVGVCZWCVHVCAWJWKWRWPWQVBGHXBWCCEKFWGWNVIVFVMV
        JWFWRWHRQWLWOWIUEWDUAAWRWEXBSAPRVTWGPRWGUNAKFWGWNVKVLVNWMWCWHBVOVFVPVQV
        RVS $.
    $}

    limsupbnd2.4 $e |- ( ph -> sup ( B , RR* , < ) = +oo ) $.
    limsupbnd2.5 $e |- ( ph ->
      E. k e. RR A. j e. B ( k <_ j -> A <_ ( F ` j ) ) ) $.
    $( If a sequence is eventually greater than ` A ` , then the limsup is also
       greater than ` A ` .  (Contributed by Mario Carneiro, 7-Sep-2014.)
       (Revised by Mario Carneiro, 7-May-2016.) $)
    limsupbnd2 $p |- ( ph -> A <_ ( limsup ` F ) ) $=
      ( vm vn cle wbr cr cxr wi wcel wa clsp cfv cv cpnf cico cima cin clt csup
      co cmpt wral wrex cif wceq wss wb ressxr syl6ss supxrunb1 syl mpbird ifcl
      breq1 rexbidv rspccva syl2an r19.29 simplrr simprl adantr syl2anc syl3anc
      max1 sselda letr mpand imim1d imp3a max2 adantld limsupgf ffvelrni adantl
      eqid xrleid adantrr limsupgle syl211anc mpbid r19.21bi syld jcad ad2antrr
      wf ffvelrnda xrletr rexlimdva syl5 mpan2d anassrs ralrimdva mpd limsuple
      ) ABFUAUBNOZBLUCZMPFMUCZUDUEUJUFQUGQUHUIUKZUBZNOZLPULZAEUCZDUCZNOZBXMFUBZ
      NOZRZDCULZEPUMZXKKAXSXJLPAXFPSZTZXRXJEPAXTXLPSZXRXJRAXTYBTZTZXRXLXFNOZXFX
      LUNZXMNOZDCUMZXJAXGXMNOZDCUMZMPULZYFPSZYHYCAYKCQUHUIUDUOZJACQUPYKYMUQACPQ
      GURUSMDCUTVAVBYEXFXLPVCZYJYHMYFPXGYFUOYIYGDCXGYFXMNVDVEVFVGXRYHTXQYGTZDCU
      MYDXJXQYGDCVHYDYOXJDCYDXMCSZTZYOXPXOXINOZTZXJYQYOXPYRYQXQYGXPYQYGXNXPYQXL
      YFNOZYGXNYQYBXTYTAXTYBYPVIZYDXTYPAXTYBVJZVKZXLXFVNVLYQYBYLXMPSZYTYGTXNRUU
      AYQXTYBYLUUCUUAYNVLZYDCPXMACPUPZYCGVKZVOZXLYFXMVPVMVQVRVSYQYOXFXMNOZYRYQY
      GUUIXQYQXFYFNOZYGUUIYQYBXTUUJUUAUUCXLXFVTVLYQXTYLUUDUUJYGTUUIRUUCUUEUUHXF
      YFXMVPVMVQWAYDUUIYRRZDCYDXIXINOZUUKDCULZAXTUULYBYAXIQSZUULXTUUNAPQXFXHMFX
      HXHWEZWBWCZWDXIWFVAWGYDUUFCQFWOZXTUUNUULUUMUQUUGAUUQYCHVKZUUBYDXTUUNUUBUU
      PVAZXICXFDMFXHUUOWHWIWJWKWLWMYQBQSZXOQSUUNYSXJRAUUTYCYPIWNYDCQXMFUURWPYDU
      UNYPUUSVKBXOXIWQVMWLWRWSWTXAWRXBXCAUUFUUQUUTXEXKUQGHIBCLMFXHUUOXDVMVB $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~~> $.  $( Limit arrow. $)
  $c ~~>r $.  $( Limit arrow with subscript r $)
  $c O(1) $.  $( big-O of one $)
  $c <_O(1) $.  $( less than or equal to big-O of one $)

  $( Extend class notation with convergence relation for limits. $)
  cli $a class ~~> $.

  $( Extend class notation with real convergence relation for limits. $)
  crli $a class ~~>r $.

  $( Extend class notation with the set of all eventually bounded functions. $)
  co1 $a class O(1) $.

  $( Extend class notation with the set of all eventually upper bounded
     functions. $)
  clo1 $a class <_O(1) $.

  ${
    $d j k w x y z f m $.
    $( Define the limit relation for complex number sequences.  See ~ clim for
       its relational expression.  (Contributed by NM, 28-Aug-2005.) $)
    df-clim $a |- ~~> = { <. f , y >. | ( y e. CC /\
        A. x e. RR+ E. j e. ZZ A. k e. ( ZZ>= ` j )
          ( ( f ` k ) e. CC /\ ( abs ` ( ( f ` k ) - y ) ) < x ) ) } $.

    $( Define the limit relation for partial functions on the reals.  See
       ~ rlim for its relational expression.  (Contributed by Mario Carneiro,
       16-Sep-2014.) $)
    df-rlim $a |- ~~>r = { <. f , x >. | ( ( f e. ( CC ^pm RR ) /\ x e. CC ) /\
      A. y e. RR+ E. z e. RR A. w e. dom f ( z <_ w ->
      ( abs ` ( ( f ` w ) - x ) ) < y ) ) } $.

    $( Define the set of eventually bounded functions.  We don't bother to
       build the full conception of big-O notation, because we can represent
       any big-O in terms of ` O(1) ` and division, and any little-O in terms
       of a limit and division.  We could also use limsup for this, but it only
       works on integer sequences, while this will work for real sequences or
       integer sequences.  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    df-o1 $a |- O(1) = { f e. ( CC ^pm RR ) | E. x e. RR E. m e. RR
      A. y e. ( dom f i^i ( x [,) +oo ) ) ( abs ` ( f ` y ) ) <_ m } $.

    $( Define the set of eventually upper bounded real functions.  This fills a
       gap in ` O(1) ` coverage, to express statements like
       ` f ( x ) <_ g ( x ) + O ( x ) ` via
       ` ( x e. RR+ |-> ( f ( x ) - g ( x ) ) / x ) e. <_O(1) ` .  (Contributed
       by Mario Carneiro, 25-May-2016.) $)
    df-lo1 $a |- <_O(1) = { f e. ( RR ^pm RR ) | E. x e. RR E. m e. RR
      A. y e. ( dom f i^i ( x [,) +oo ) ) ( f ` y ) <_ m } $.

    $( The limit relation is a relation.  (Contributed by NM, 28-Aug-2005.)
       (Revised by Mario Carneiro, 31-Jan-2014.) $)
    climrel $p |- Rel ~~> $=
      ( vy vk vf vx vj cv cc wcel cfv cmin co cabs clt wbr wa cuz wral wrex crp
      cz cli df-clim relopabi ) AFZGHBFCFIZGHUEUDJKLIDFMNOBEFPIQETRDSQOCAUADACE
      BUBUC $.

    $( The limit relation is a relation.  (Contributed by Mario Carneiro,
       24-Sep-2014.) $)
    rlimrel $p |- Rel ~~>r $=
      ( vf vx vz vw vy cv cc cr cpm co wcel wa cle wbr cfv cmin cabs clt wral
      wi cdm wrex crp crli df-rlim relopabi ) AFZGHIJKBFZGKLCFDFZMNUIUGOUHPJQOE
      FRNTDUGUASCHUBEUCSLABUDBECDAUEUF $.
  $}

  ${
    $d f j k x y A $.  $d f j k x y F $.  $d j k x ph $.
    clim.1 $e |- ( ph -> F e. V ) $.
    clim.3 $e |- ( ( ph /\ k e. ZZ ) -> ( F ` k ) = B ) $.
    $( Express the predicate:  The limit of complex number sequence ` F ` is
       ` A ` , or ` F ` converges to ` A ` .  This means that for any real
       ` x ` , no matter how small, there always exists an integer ` j ` such
       that the absolute difference of any later complex number in the sequence
       and the limit is less than ` x ` .  (Contributed by NM, 28-Aug-2005.)
       (Revised by Mario Carneiro, 28-Apr-2015.) $)
    clim $p |- ( ph -> ( F ~~> A <-> ( A e. CC /\ A. x e. RR+ E. j e. ZZ
           A. k e. ( ZZ>= ` j ) ( B e. CC /\ ( abs ` ( B - A ) ) < x ) ) ) ) $=
      ( cc wcel cv cfv cmin cabs clt wa wral cz vy vf cli wbr co cuz crp cvv wi
      wrex climrel brrelex2i a1i elex adantr wb simpr eleq1d fveq1 oveq12 sylan
      fveq2d breq1d anbi12d ralbidv rexbidv df-clim brabga ex pm5.21ndd eluzelz
      wceq syl oveq1d sylan2 ralbidva anbi2d bitrd ) AGCUCUDZCKLZFMZGNZKLZWBCOU
      EZPNZBMZQUDZRZFEMZUFNZSZETUJZBUGSZRZVTDKLZDCOUEZPNZWFQUDZRZFWJSZETUJZBUGS
      ZRACUHLZVSWNVSXCUIAGCUCUKULUMWNXCUIAVTXCWMCKUNUOUMAGHLZXCVSWNUPZUIIXDXCXE
      UAMZKLZWAUBMZNZKLZXIXFOUEZPNZWFQUDZRZFWJSZETUJZBUGSZRWNUBUAGCUCHUHXHGVLZX
      FCVLZRZXGVTXQWMXTXFCKXRXSUQURXTXPWLBUGXTXOWKETXTXNWHFWJXTXJWCXMWGXTXIWBKX
      RXIWBVLZXSWAXHGUSZUOURXTXLWEWFQXTXKWDPXRYAXSXKWDVLYBXIWBXFCOUTVAVBVCVDVEV
      FVEVDBUAUBEFVGVHVIVMVJAWMXBVTAWLXABUGAWKWTETAWHWSFWJWAWJLAWATLZWHWSUPWIWA
      VKAYCRZWCWOWGWRYDWBDKJURYDWEWQWFQYDWDWPPYDWBDCOJVNVBVCVDVOVPVFVEVQVR $.
  $}

  ${
    $d z A $.  $d f w x y z C $.  $d f w x y z F $.  $d x y z ph $.
    rlim.1 $e |- ( ph -> F : A --> CC ) $.
    rlim.2 $e |- ( ph -> A C_ RR ) $.
    rlim.4 $e |- ( ( ph /\ z e. A ) -> ( F ` z ) = B ) $.
    $( Express the predicate:  The limit of complex number function ` F ` is
       ` C ` , or ` F ` converges to ` C ` , in the real sense.  This means
       that for any real ` x ` , no matter how small, there always exists a
       number ` y ` such that the absolute difference of any number in the
       function beyond ` y ` and the limit is less than ` x ` .  (Contributed
       by Mario Carneiro, 16-Sep-2014.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    rlim $p |- ( ph -> ( F ~~>r C <-> ( C e. CC /\ A. x e. RR+ E. y e. RR
           A. z e. A ( y <_ z -> ( abs ` ( B - C ) ) < x ) ) ) ) $=
      ( wbr cc cr wcel cv wi wral wa cvv vf vw crli cpm co cle cfv cmin clt cdm
      cabs wrex crp rlimrel brrelex2i a1i elex ad2antrl wb wss cnex reex elpm2r
      mpanl12 syl2anc wceq eleq1 bi2anan9 simpl dmeqd fveq1 oveq12 sylan fveq2d
      wf breq1d imbi2d raleqbidv rexbidv ralbidv anbi12d brabga anass syl6bb ex
      df-rlim syl pm5.21ndd biantrurd fdm raleqdv oveq1d ralbidva bitrd 3bitr2d
      anbi2d ) AHGUCLZHMNUDUEZOZGMOZCPDPZUFLZXAHUGZGUHUEZUKUGZBPZUILZQZDHUJZRZC
      NULZBUMRZSZSZXMWTXBFGUHUEZUKUGZXFUILZQZDERZCNULZBUMRZSAGTOZWQXNWQYBQAHGUC
      UNUOUPXNYBQAWTYBWSXLGMUQURUPAWSYBWQXNUSZQAEMHVOZENUTZWSIJMTONTOYDYESWSVAV
      BMNEHTTVCVDVEZWSYBYCWSYBSWQWSWTSZXLSZXNUAPZWROZUBPZMOZSZXBXAYIUGZYKUHUEZU
      KUGZXFUILZQZDYIUJZRZCNULZBUMRZSYHUAUBHGUCWRTYIHVFZYKGVFZSZYMYGUUBXLUUCYJW
      SUUDYLWTYIHWRVGYKGMVGVHUUEUUAXKBUMUUEYTXJCNUUEYRXHDYSXIUUEYIHUUCUUDVIVJUU
      EYQXGXBUUEYPXEXFUIUUEYOXDUKUUCYNXCVFUUDYOXDVFXAYIHVKYNXCYKGUHVLVMVNVPVQVR
      VSVTWAUBBCDUAWFWBWSWTXLWCWDWEWGWHAWSXMYFWIAXLYAWTAXKXTBUMAXJXSCNAXJXHDERX
      SAXHDXIEAYDXIEVFIEMHWJWGWKAXHXRDEAXAEOSZXGXQXBUUFXEXPXFUIUUFXDXOUKUUFXCFG
      UHKWLVNVPVQWMWNVSVTWPWO $.
  $}

  ${
    $d w x y z A $.  $d w x y B $.  $d w x y z C $.  $d w x y ph $.
    $d w y z D $.
    rlim2.1 $e |- ( ph -> A. z e. A B e. CC ) $.
    rlim2.2 $e |- ( ph -> A C_ RR ) $.
    rlim2.3 $e |- ( ph -> C e. CC ) $.
    $( Rewrite ~ rlim for a mapping operation.  (Contributed by Mario Carneiro,
       16-Sep-2014.)  (Revised by Mario Carneiro, 28-Feb-2015.) $)
    rlim2 $p |- ( ph -> ( ( z e. A |-> B ) ~~>r C <-> A. x e. RR+ E. y e. RR
           A. z e. A ( y <_ z -> ( abs ` ( B - C ) ) < x ) ) ) $=
      ( vw wbr cc wcel cfv cmin cabs clt wral nfcv cmpt crli cv cle co wrex crp
      wi cr wa eqid fmpt sylib eqidd rlim biantrurd nfv nffvmpt1 nfov nffv nfbr
      wf nfim weq breq2 fveq2 oveq1d fveq2d breq1d imbi12d cbvral fvmpt2 imbi2d
      wb ralimiaa ralbi 3syl syl5bb rexbidv ralbidv 3bitr2d ) ADEFUAZGUBLGMNZCU
      CZKUCZUDLZWEWBOZGPUEZQOZBUCZRLZUHZKESZCUIUFZBUGSZUJWOWDDUCZUDLZFGPUEZQOZW
      JRLZUHZDESZCUIUFZBUGSABCKEWGGWBAFMNZDESZEMWBVBHDEMFWBWBUKZULUMIAWEENUJWGU
      NUOAWCWOJUPAWNXCBUGAWMXBCUIWMWQWPWBOZGPUEZQOZWJRLZUHZDESZAXBWLXKKDEWFWKDW
      FDUQDWIWJRDWHQDQTDWGGPDEFWEURDPTDGTUSUTDRTDWJTVAVCXKKUQKDVDZWFWQWKXJWEWPW
      DUDVEXMWIXIWJRXMWHXHQXMWGXGGPWEWPWBVFVGVHVIVJVKAXEXKXAVNZDESXLXBVNHXDXNDE
      WPENXDUJZXJWTWQXOXIWSWJRXOXHWRQXOXGFGPDEFMWBXFVLVGVHVIVMVOXKXADEVPVQVRVSV
      TWA $.

    $( Use strictly less-than in place of less equal in the real limit
       predicate.  (Contributed by Mario Carneiro, 18-Sep-2014.) $)
    rlim2lt $p |- ( ph -> ( ( z e. A |-> B ) ~~>r C <-> A. x e. RR+ E. y e. RR
           A. z e. A ( y < z -> ( abs ` ( B - C ) ) < x ) ) ) $=
      ( vw wbr cv wi wral cr crp cle wcel wa cmpt crli clt cmin cabs wrex rlim2
      co cfv wss simplr simpl sselda ltle syl2anc imim1d ralimdva sylan ralimdv
      reximdva sylbid c1 caddc peano2re adantl ltp1 ad2antlr syl3anc mpand wceq
      ltletr breq1 imbi1d ralbidv rspcev ee12an rexlimdva sylibrd impbid ) ADEF
      UAGUBLZCMZDMZUCLZFGUDUHUEUIBMUCLZNZDEOZCPUFZBQOZAVTWAWBRLZWDNZDEOZCPUFZBQ
      OWHABCDEFGHIJUGAWLWGBQAWKWFCPAEPUJZWAPSZWKWFNIWMWNTZWJWEDEWOWBESZTZWCWIWD
      WQWNWBPSZWCWINWMWNWPUKZWOEPWBWMWNULUMZWAWBUNUOUPUQURUTUSVAAWHKMZWBRLZWDNZ
      DEOZKPUFZBQOVTAWGXEBQAWFXECPAWNTWAVBVCUHZPSZWFXFWBRLZWDNZDEOZXEWNXGAWAVDZ
      VEAWMWNWFXJNIWOWEXIDEWQXHWCWDWQWAXFUCLZXHWCWNXLWMWPWAVFVGWQWNXGWRXLXHTWCN
      WSWNXGWMWPXKVGWTWAXFWBVKVHVIUPUQURXDXJKXFPXAXFVJZXCXIDEXMXBXHWDXAXFWBRVLV
      MVNVOVPVQUSABKDEFGHIJUGVRVS $.

    rlim3.4 $e |- ( ph -> D e. RR ) $.
    $( Restrict the range of the domain bound to reals greater than some
       ` D e. RR ` .  (Contributed by Mario Carneiro, 16-Sep-2014.) $)
    rlim3 $p |- ( ph -> ( ( z e. A |-> B ) ~~>r C <-> A. x e. RR+
   E. y e. ( D [,) +oo ) A. z e. A ( y <_ z -> ( abs ` ( B - C ) ) < x ) ) ) $=
      ( wbr cle wi wral crp cr wcel wa vw cmpt crli cmin cabs cfv clt cpnf cico
      cv co wrex rlim2 cif simpr adantr ifcl syl2anc max1 sylan wb elicopnf syl
      mpbir2and wss simpllr simplr max2 simpll sselda letr syl3anc mpand imim1d
      ralimdva wceq breq1 imbi1d ralbidv rspcev ee12an rexlimdva ralimdv sylbid
      jca cxr pnfxr icossre sylancl ssrexv sylibrd impbid ) ADEFUBGUCMZCUJZDUJZ
      NMZFGUDUKUEUFBUJUGMZOZDEPZCHUHUIUKZULZBQPZAWMUAUJZWONMZWQOZDEPZUARULZBQPX
      BABUADEFGIJKUMAXGXABQAXFXAUARAXCRSZTZHXCNMZXCHUNZWTSZXFXKWONMZWQOZDEPZXAX
      IXLXKRSZHXKNMZXIXHHRSZXPAXHUOAXRXHLUPZXJXCHRUQZURAXRXHXQLHXCUSUTXIXRXLXPX
      QTVAXSHXKVBVCVDAERVEZXRTZXHXFXOOAYAXRJLWEYBXHTZXEXNDEYCWOESZTZXMXDWQYEXCX
      KNMZXMXDYEXRXHYFYAXRXHYDVFZYBXHYDVGZHXCVHURYEXHXPWORSYFXMTXDOYHYEXHXRXPYH
      YGXTURYCERWOYAXRXHVIVJXCXKWOVKVLVMVNVOUTWSXOCXKWTWNXKVPZWRXNDEYIWPXMWQWNX
      KWONVQVRVSVTWAWBWCWDAXBWSCRULZBQPWMAXAYJBQAWTRVEZXAYJOAXRUHWFSYKLWGHUHWHW
      IWSCWTRWJVCWCABCDEFGIJKUMWKWL $.
  $}

  ${
    $d f w x y z $.  $d j k x y z A $.  $d j k x y z F $.  $d j k x y z V $.
    $( Closure of the limit of a sequence of complex numbers.  (Contributed by
       NM, 28-Aug-2005.)  (Revised by Mario Carneiro, 28-Apr-2015.) $)
    climcl $p |- ( F ~~> A -> A e. CC ) $=
      ( vk vx vj cli wbr cc wcel cv cfv cmin co cabs clt wa cuz wral cz wrex
      crp cvv climrel brrelexi eqidd clim ibi simpld ) BAFGZAHIZCJZBKZHIULALMNK
      DJOGPCEJQKRESTDUARZUIUJUMPUIDAULECBUBBAFUCUDUIUKSIPULUEUFUGUH $.

    $( Closure of a function with a limit in the complex numbers.  (Contributed
       by Mario Carneiro, 16-Sep-2014.) $)
    rlimpm $p |- ( F ~~>r A -> F e. ( CC ^pm RR ) ) $=
      ( vf vx vz vw vy crli wbr cdm cc cr cpm co wss cv wcel wa cfv wral cxp wi
      cle cmin cabs clt wrex crp copab df-rlim opabssxp dmss ax-mp dmxpss sstri
      eqsstri rlimrel releldmi sseldi ) BAHIHJZKLMNZBUTVAKUAZJZVAHVBOUTVCOHCPZV
      AQDPZKQREPFPZUCIVFVDSVEUDNUESGPUFIUBFVDJTELUGGUHTZRCDUIVBDGEFCUJVGCDVAKUK
      UPHVBULUMVAKUNUOBAHUQURUS $.

    $( Closure of a function with a limit in the complex numbers.  (Contributed
       by Mario Carneiro, 16-Sep-2014.) $)
    rlimf $p |- ( F ~~>r A -> F : dom F --> CC ) $=
      ( crli wbr cc cr cpm co wcel cdm rlimpm wss cnex reex elpm2 simplbi syl
      wf ) BACDBEFGHIZBJZEBRZABKSUATFLEFBMNOPQ $.

    $( Domain closure of a function with a limit in the complex numbers.
       (Contributed by Mario Carneiro, 16-Sep-2014.) $)
    rlimss $p |- ( F ~~>r A -> dom F C_ RR ) $=
      ( crli wbr cc cr cpm co wcel cdm wss rlimpm cnex reex elpm2 simprbi syl
      wf ) BACDBEFGHIZBJZFKZABLSTEBRUAEFBMNOPQ $.

    $( Closure of the limit of a sequence of complex numbers.  (Contributed by
       Mario Carneiro, 16-Sep-2014.)  (Revised by Mario Carneiro,
       28-Apr-2015.) $)
    rlimcl $p |- ( F ~~>r A -> A e. CC ) $=
      ( vz vx vy crli wbr cc wcel cv cle cfv cmin co cabs clt wi cdm wral wa cr
      wrex crp rlimf rlimss eqidd rlim ibi simpld ) BAFGZAHIZCJDJZKGULBLZAMNOLE
      JPGQDBRZSCUAUBEUCSZUJUKUOTUJECDUNUMABABUDABUEUJULUNITUMUFUGUHUI $.
  $}

  ${
    $d j k x A $.  $d j k x F $.  $d j M $.  $d j k x ph $.  $d j k Z $.
    clim2.1 $e |- Z = ( ZZ>= ` M ) $.
    clim2.2 $e |- ( ph -> M e. ZZ ) $.
    clim2.3 $e |- ( ph -> F e. V ) $.
    clim2.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    $( Express the predicate:  The limit of complex number sequence ` F ` is
       ` A ` , or ` F ` converges to ` A ` , with more general quantifier
       restrictions than ~ clim .  (Contributed by NM, 6-Jan-2007.)  (Revised
       by Mario Carneiro, 31-Jan-2014.) $)
    clim2 $p |- ( ph -> ( F ~~> A <-> ( A e. CC /\ A. x e. RR+ E. j e. Z
           A. k e. ( ZZ>= ` j ) ( B e. CC /\ ( abs ` ( B - A ) ) < x ) ) ) ) $=
      ( wbr cc wcel cfv wa wral cli cv cmin co cabs clt cuz wrex crp eqidd clim
      cz wb uztrn2 eleq1d oveq1d fveq2d breq1d anbi12d sylan2 ralbidva rexbidva
      anassrs rexuz3 syl bitr3d ralbidv anbi2d bitr4d ) AGCUAOCPQZFUBZGRZPQZVLC
      UCUDZUERZBUBZUFOZSZFEUBZUGRZTZEULUHZBUITZSVJDPQZDCUCUDZUERZVPUFOZSZFVTTZE
      JUHZBUITZSABCVLEFGIMAVKULQSVLUJUKAWKWCVJAWJWBBUIAWAEJUHZWJWBAWAWIEJAVSJQZ
      SVRWHFVTAWMVKVTQZVRWHUMZWMWNSAVKJQZWOHVKVSJKUNAWPSZVMWDVQWGWQVLDPNUOWQVOW
      FVPUFWQVNWEUEWQVLDCUCNUPUQURUSUTVCVAVBAHULQWLWBUMLVREFHJKVDVEVFVGVHVI $.

    clim2c.5 $e |- ( ph -> A e. CC ) $.
    clim2c.6 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
    $( Express the predicate ` F ` converges to ` A ` .  (Contributed by NM,
       24-Feb-2008.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
    clim2c $p |- ( ph -> ( F ~~> A <->
      A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( abs ` ( B - A ) ) < x ) ) $=
      ( wcel cv wa wral cmin cabs cfv clt wbr cuz wrex crp cli biantrurd uztrn2
      cc co wb sylan2 anassrs ralbidva rexbidva ralbidv clim2 3bitr4rd ) ADULQZ
      DCUAUMUBUCBRUDUEZSZFERZUFUCZTZEJUGZBUHTZCULQZVISVCFVFTZEJUGZBUHTGCUIUEAVJ
      VIOUJAVLVHBUHAVKVGEJAVEJQZSVCVDFVFAVMFRZVFQZVCVDUNZVMVOSAVNJQZVPHVNVEJKUK
      AVQSVBVCPUJUOUPUQURUSABCDEFGHIJKLMNUTVA $.
  $}

  ${
    $d j k x F $.  $d j M $.  $d j k x ph $.  $d j k Z $.
    clim0.1 $e |- Z = ( ZZ>= ` M ) $.
    clim0.2 $e |- ( ph -> M e. ZZ ) $.
    clim0.3 $e |- ( ph -> F e. V ) $.
    clim0.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    $( Express the predicate ` F ` converges to ` 0 ` .  (Contributed by NM,
       24-Feb-2008.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
    clim0 $p |- ( ph -> ( F ~~> 0 <-> A. x e. RR+ E. j e. Z
                  A. k e. ( ZZ>= ` j ) ( B e. CC /\ ( abs ` B ) < x ) ) ) $=
      ( cc0 wbr cabs cfv clt wa wral cli cc wcel cmin co cuz wrex crp clim2 0cn
      cv biantrur subid1 fveq2d breq1d pm5.32i ralbii rexbii bitr3i syl6bb ) AF
      NUAONUBUCZCUBUCZCNUDUEZPQZBUKZROZSZEDUKUFQZTZDIUGZBUHTZSZVBCPQZVEROZSZEVH
      TZDIUGZBUHTZABNCDEFGHIJKLMUIVLVKVRVAVKUJULVJVQBUHVIVPDIVGVOEVHVBVFVNVBVDV
      MVERVBVCCPCUMUNUOUPUQURUQUSUT $.

    clim0c.6 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
    $( Express the predicate ` F ` converges to ` 0 ` .  (Contributed by NM,
       24-Feb-2008.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
    clim0c $p |- ( ph -> ( F ~~> 0 <->
              A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( abs ` B ) < x ) ) $=
      ( cc0 wbr cabs cfv wral wcel cli cmin co cv clt cuz crp cc 0cn a1i clim2c
      wrex wa wb uztrn2 subid1d fveq2d breq1d anassrs ralbidva rexbidva ralbidv
      sylan2 bitrd ) AFOUAPCOUBUCZQRZBUDZUEPZEDUDZUFRZSZDIULZBUGSCQRZVGUEPZEVJS
      ZDIULZBUGSABOCDEFGHIJKLMOUHTAUIUJNUKAVLVPBUGAVKVODIAVIITZUMVHVNEVJAVQEUDZ
      VJTZVHVNUNZVQVSUMAVRITZVTGVRVIIJUOAWAUMZVFVMVGUEWBVECQWBCNUPUQURVCUSUTVAV
      BVD $.
  $}

  ${
    $d x y z A $.  $d x y B $.  $d x y ph $.
    rlim0.1 $e |- ( ph -> A. z e. A B e. CC ) $.
    rlim0.2 $e |- ( ph -> A C_ RR ) $.
    $( Express the predicate ` B ( z ) ` converges to ` 0 ` .  (Contributed by
       Mario Carneiro, 16-Sep-2014.)  (Revised by Mario Carneiro,
       28-Feb-2015.) $)
    rlim0 $p |- ( ph -> ( ( z e. A |-> B ) ~~>r 0 <-> A. x e. RR+ E. y e. RR
           A. z e. A ( y <_ z -> ( abs ` B ) < x ) ) ) $=
      ( cc0 wbr cv cabs cfv clt wi wral cr wrex crp cc cmpt crli cle co 0cn a1i
      cmin wcel rlim2 wb subid1 fveq2d breq1d imbi2d ralbi 3syl rexbidv ralbidv
      ralimi bitrd ) ADEFUAIUBJCKDKUCJZFIUGUDZLMZBKZNJZOZDEPZCQRZBSPVAFLMZVDNJZ
      OZDEPZCQRZBSPABCDEFIGHITUHAUEUFUIAVHVMBSAVGVLCQAFTUHZDEPVFVKUJZDEPVGVLUJG
      VNVODEVNVEVJVAVNVCVIVDNVNVBFLFUKULUMUNUSVFVKDEUOUPUQURUT $.

    $( Use strictly less-than in place of less equal in the real limit
       predicate.  (Contributed by Mario Carneiro, 18-Sep-2014.)  (Revised by
       Mario Carneiro, 28-Feb-2015.) $)
    rlim0lt $p |- ( ph -> ( ( z e. A |-> B ) ~~>r 0 <-> A. x e. RR+ E. y e. RR
           A. z e. A ( y < z -> ( abs ` B ) < x ) ) ) $=
      ( cc0 wbr cv clt cabs cfv wi wral cr wrex crp cc cmpt crli co 0cn rlim2lt
      cmin wcel a1i wb subid1 fveq2d breq1d imbi2d ralimi ralbi rexbidv ralbidv
      3syl bitrd ) ADEFUAIUBJCKDKLJZFIUFUCZMNZBKZLJZOZDEPZCQRZBSPUTFMNZVCLJZOZD
      EPZCQRZBSPABCDEFIGHITUGAUDUHUEAVGVLBSAVFVKCQAFTUGZDEPVEVJUIZDEPVFVKUIGVMV
      NDEVMVDVIUTVMVBVHVCLVMVAFMFUJUKULUMUNVEVJDEUOURUPUQUS $.
  $}

  ${
    $d j k x A $.  $d j k x C $.  $d j k x F $.  $d j k x ph $.  $d j k x Z $.
    $d x B $.  $d j M $.
    climi.1 $e |- Z = ( ZZ>= ` M ) $.
    climi.2 $e |- ( ph -> M e. ZZ ) $.
    climi.3 $e |- ( ph -> C e. RR+ ) $.
    climi.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    ${
      climi.5 $e |- ( ph -> F ~~> A ) $.
      $( Convergence of a sequence of complex numbers.  (Contributed by NM,
         11-Jan-2007.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
      climi $p |- ( ph -> E. j e. Z A. k e. ( ZZ>= ` j )
                    ( B e. CC /\ ( abs ` ( B - A ) ) < C ) ) $=
        ( vx crp wcel clt wbr wa cc cmin cabs cfv cuz wral wrex cli cvv climrel
        co cv brrelexi syl clim2 mpbid simprd wceq breq2 anbi2d rexralbidv sylc
        rspcv ) ADPQCUAQZCBUBUKUCUDZOULZRSZTZFEULUEUDZUFEIUGZOPUFZVDVEDRSZTZFVI
        UFEIUGZLABUAQZVKAGBUHSZVOVKTNAOBCEFGHUIIJKAVPGUIQNGBUHUJUMUNMUOUPUQVJVN
        ODPVFDURZVHVMEFIVIVQVGVLVDVFDVERUSUTVAVCVB $.

      $( Convergence of a sequence of complex numbers.  (Contributed by NM,
         11-Jan-2007.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
      climi2 $p |- ( ph -> E. j e. Z A. k e. ( ZZ>= ` j )
                     ( abs ` ( B - A ) ) < C ) $=
        ( cc wcel cmin cfv wral wrex co cabs clt wbr wa cuz climi ralimi reximi
        cv simpr syl ) ACOPZCBQUAUBRDUCUDZUEZFEUJUFRZSZEITUNFUPSZEITABCDEFGHIJK
        LMNUGUQUREIUOUNFUPUMUNUKUHUIUL $.
    $}

    climi0.5 $e |- ( ph -> F ~~> 0 ) $.
    $( Convergence of a sequence of complex numbers to zero.  (Contributed by
       NM, 11-Jan-2007.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
    climi0 $p |- ( ph -> E. j e. Z A. k e. ( ZZ>= ` j ) ( abs ` B ) < C ) $=
      ( cc0 cabs cfv clt wbr wral wrex cc wcel co wa cv cuz climi subid1 fveq2d
      cmin breq1d biimpa ralimi reximi syl ) ABUAUBZBNUJUCZOPZCQRZUDZEDUEUFPZSZ
      DHTBOPZCQRZEVASZDHTANBCDEFGHIJKLMUGVBVEDHUTVDEVAUPUSVDUPURVCCQUPUQBOBUHUI
      UKULUMUNUO $.
  $}

  ${
    $d x y z A $.  $d x y B $.  $d x y z C $.  $d x y ph $.  $d x y z R $.
    $d y z D $.  $d z V $.
    rlimi.1 $e |- ( ph -> A. z e. A B e. V ) $.
    rlimi.2 $e |- ( ph -> R e. RR+ ) $.
    rlimi.3 $e |- ( ph -> ( z e. A |-> B ) ~~>r C ) $.
    $( Convergence at infinity of a function on the reals.  (Contributed by
       Mario Carneiro, 28-Feb-2015.) $)
    rlimi $p |- ( ph -> E. y e. RR A. z e. A
      ( y <_ z -> ( abs ` ( B - C ) ) < R ) ) $=
      ( vx crp wcel cv wbr wral cr cc syl cle cmin co cabs cfv clt wi wrex cmpt
      crli wf cdm rlimf wceq eqid fmpt sylib feq2d mpbid sylibr rlimss eqsstr3d
      fdm wss rlimcl rlim2 breq2 imbi2d rexralbidv rspcv sylc ) AGMNBOCOUAPZEFU
      BUCUDUEZLOZUFPZUGZCDQBRUHZLMQZVLVMGUFPZUGZCDQBRUHZJACDEUIZFUJPZVRKALBCDEF
      ADSWBUKZESNCDQAWBULZSWBUKZWDAWCWFKFWBUMTAWEDSWBADHWBUKZWEDUNAEHNCDQWGICDH
      EWBWBUOZUPUQDHWBVCTZURUSCDSEWBWHUPUTADWERWIAWCWERVDKFWBVATVBAWCFSNKFWBVET
      VFUSVQWALGMVNGUNZVPVTBCRDWJVOVSVLVNGVMUFVGVHVIVJVK $.

    rlimi.4 $e |- ( ph -> D e. RR ) $.
    $( Convergence at infinity of a function on the reals.  (Contributed by
       Mario Carneiro, 12-May-2016.) $)
    rlimi2 $p |- ( ph -> E. y e. ( D [,) +oo ) A. z e. A
      ( y <_ z -> ( abs ` ( B - C ) ) < R ) ) $=
      ( cv wbr co wral wrex cr wss cle cmin cabs cfv wi cpnf cico rlimi wcel wb
      clt cmpt cdm wfn wceq eqid fnmpt fndm 3syl crli rlimss syl rexico syl2anc
      eqsstr3d mpbird ) ABNCNUAOEFUBPUCUDHUKOZUECDQZBGUFUGPRZVHBSRZABCDEFHIJKLU
      HADSTGSUIVIVJUJADCDEULZUMZSAEIUICDQVKDUNVLDUOJCDEVKIVKUPUQDVKURUSAVKFUTOV
      LSTLFVKVAVBVEMVGDGBCVCVDVF $.
  $}

  ${
    $d m x y A $.  $d m x y B $.  $d m x y C $.  $d f m x y F $.  $d m x M $.
    $( Elementhood in the set of eventually upper bounded functions.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    ello1 $p |- ( F e. <_O(1) <-> ( F e. ( RR ^pm RR ) /\ E. x e. RR
      E. m e. RR A. y e. ( dom F i^i ( x [,) +oo ) ) ( F ` y ) <_ m ) ) $=
      ( vf cv cfv cle wbr cdm cpnf cico co cin wral cr wrex cpm clo1 wceq fveq1
      dmeq ineq1d breq1d raleqbidv 2rexbidv df-lo1 elrab2 ) BFZEFZGZCFZHIZBUJJZ
      AFKLMZNZOZCPQAPQUIDGZULHIZBDJZUONZOZCPQAPQEDPPRMSUJDTZUQVBACPPVCUMUSBUPVA
      VCUNUTUOUJDUBUCVCUKURULHUIUJDUAUDUEUFABECUGUH $.

    $( Elementhood in the set of eventually upper bounded functions.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    ello12 $p |- ( ( F : A --> RR /\ A C_ RR ) -> ( F e. <_O(1) <-> E. x e. RR
      E. m e. RR A. y e. A ( x <_ y -> ( F ` y ) <_ m ) ) ) $=
      ( cr wa wcel cv cle wbr co wral wrex wi wb cvv reex syl simpllr clo1 cpnf
      wf wss cfv cdm cico cin cpm elpm2r mpanl12 ello1 baib elin wceq ad3antrrr
      fdm eleq2d anbi1d elicopnf sselda biantrurd bitr4d pm5.32da syl5bb imbi1d
      bitrd impexp syl6bb ralbidv2 rexbidva ) CFEUCZCFUDZGZEUAHZBIZEUEDIZJKZBEU
      FZAIZUBUGLZUHZMZDFNZAFNZVTVPJKZVROZBCMZDFNZAFNVNEFFUILHZVOWEPFQHZWKVNWJRR
      FFCEQQUJUKVOWJWEABDEULUMSVNWDWIAFVNVTFHZGZWCWHDFWMVQFHZGZVRWGBWBCWOVPWBHZ
      VROVPCHZWFGZVROWQWGOWOWPWRVRWPVPVSHZVPWAHZGZWOWRVPVSWAUNWOXAWQWTGWRWOWSWQ
      WTWOVSCVPVLVSCUOVMWLWNCFEUQUPURUSWOWQWTWFWOWQGZWTVPFHZWFGZWFXBWLWTXDPVNWL
      WNWQTVTVPUTSXBXCWFWOCFVPVLVMWLWNTVAVBVCVDVGVEVFWQWFVRVHVIVJVKVKVG $.

    $( Sufficient condition for elementhood in the set of eventually upper
       bounded functions.  (Contributed by Mario Carneiro, 26-May-2016.) $)
    ello12r $p |- ( ( ( F : A --> RR /\ A C_ RR ) /\ ( C e. RR /\ M e. RR ) /\
      A. x e. A ( C <_ x -> ( F ` x ) <_ M ) ) -> F e. <_O(1) ) $=
      ( vy vm cr wf wss wa wcel cv cle wbr wi wral wrex wceq ralbidv clo1 breq1
      cfv w3a imbi1d breq2 imbi2d rspc2ev 3expa 3adant1 ello12 3ad2ant1 mpbird
      wb ) BHDIBHJKZCHLZEHLZKZCAMZNOZUSDUCZENOZPZABQZUDDUALZFMZUSNOZVAGMZNOZPZA
      BQZGHRFHRZURVDVLUOUPUQVDVLVKVDUTVIPZABQFGCEHHVFCSZVJVMABVNVGUTVIVFCUSNUBU
      ETVHESZVMVCABVOVIVBUTVHEVANUFUGTUHUIUJUOURVEVLUNVDFABGDUKULUM $.

    $( An eventually upper bounded function is a function.  (Contributed by
       Mario Carneiro, 26-May-2016.) $)
    lo1f $p |- ( F e. <_O(1) -> F : dom F --> RR ) $=
      ( vy vm vx clo1 wcel cr cpm co cdm wf cfv cle cpnf cico wrex simplbi reex
      cv wbr cin wral ello1 wss elpm2 syl ) AEFZAGGHIFZAJZGAKZUGUHBSALCSMTBUIDS
      NOIUAUBCGPDGPDBCAUCQUHUJUIGUDGGARRUEQUF $.

    $( An eventually upper bounded function's domain is a subset of the reals.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    lo1dm $p |- ( F e. <_O(1) -> dom F C_ RR ) $=
      ( vy vm vx clo1 wcel cr cpm co cdm wss cv cfv cle wbr cpnf cico wrex reex
      cin wral ello1 simplbi wf elpm2 simprbi syl ) AEFZAGGHIFZAJZGKZUHUIBLAMCL
      NOBUJDLPQITUACGRDGRDBCAUBUCUIUJGAUDUKGGASSUEUFUG $.

    $( The defining property of an eventually upper bounded function.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    lo1bdd $p |- ( ( F e. <_O(1) /\ F : A --> RR ) -> E. x e. RR
      E. m e. RR A. y e. A ( x <_ y -> ( F ` y ) <_ m ) ) $=
      ( clo1 wcel cr wf wa cv cle wbr cfv wi wral wrex simpl wss wb wceq adantl
      simpr cdm fdm lo1dm adantr eqsstr3d ello12 syl2anc mpbid ) EFGZCHEIZJZULA
      KBKZLMUOENDKLMOBCPDHQAHQZULUMRUNUMCHSULUPTULUMUCUNCEUDZHUMUQCUAULCHEUEUBU
      LUQHSUMEUFUGUHABCDEUIUJUK $.
  $}

  ${
    $d m w x y z A $.  $d m w y z B $.  $d m x y C $.  $d m x y ph $.
    $d m x M $.  $d x N $.
    ello1mpt.1 $e |- ( ph -> A C_ RR ) $.
    ello1mpt.2 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    $( Elementhood in the set of eventually upper bounded functions.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    ello1mpt $p |- ( ph -> ( ( x e. A |-> B ) e. <_O(1) <-> E. y e. RR
      E. m e. RR A. x e. A ( y <_ x -> B <_ m ) ) ) $=
      ( vz wcel cv cle wbr cfv wi wral cr wrex syl2anc nfv cmpt clo1 wf wb eqid
      wss fmptd ello12 nffvmpt1 nfcv nfbr nfim wceq breq2 breq1d imbi12d cbvral
      fveq2 wa simpr fvmpt2 imbi2d ralbidva syl5bb 2rexbidv bitrd ) ABDEUAZUBJZ
      CKZIKZLMZVJVGNZFKZLMZOZIDPZFQRCQRZVIBKZLMZEVMLMZOZBDPZFQRCQRADQVGUCDQUFVH
      VQUDABDEQVGHVGUEZUGGCIDFVGUHSAVPWBCFQQVPVSVRVGNZVMLMZOZBDPAWBVOWFIBDVKVNB
      VKBTBVLVMLBDEVJUIBLUJBVMUJUKULWFITVJVRUMZVKVSVNWEVJVRVILUNWGVLWDVMLVJVRVG
      URUOUPUQAWFWABDAVRDJZUSZWEVTVSWIWDEVMLWIWHEQJWDEUMAWHUTHBDEQVGWCVASUOVBVC
      VDVEVF $.

    ello1d.3 $e |- ( ph -> C e. RR ) $.
    $( Elementhood in the set of eventually upper bounded functions.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    ello1mpt2 $p |- ( ph -> ( ( x e. A |-> B ) e. <_O(1)
                      <-> E. y e. ( C [,) +oo )
      E. m e. RR A. x e. A ( y <_ x -> B <_ m ) ) ) $=
      ( cmpt clo1 wcel cv cle wbr wi cr wrex rexcom wral cpnf cico ello1mpt wss
      co wb rexico syl2anc rexbidv 3bitr4g bitr4d ) ABDEKLMCNBNOPEGNOPZQBDUAZGR
      SZCRSZUOCFUBUCUFZSZABCDEGHIUDAUNCUQSZGRSUNCRSZGRSURUPAUSUTGRADRUEFRMUSUTU
      GHJUMDFCBUHUIUJUNCGUQRTUNCGRRTUKUL $.

    ello1d.4 $e |- ( ph -> M e. RR ) $.
    ${
      ello1d.5 $e |- ( ( ph /\ ( x e. A /\ C <_ x ) ) -> B <_ M ) $.
      $( Sufficient condition for elementhood in the set of eventually upper
         bounded functions.  (Contributed by Mario Carneiro, 26-May-2016.) $)
      ello1d $p |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $=
        ( vy vm wcel cv cle wbr wi wral cr cmpt clo1 wrex expr ralrimiva imbi1d
        wceq breq1 ralbidv breq2 imbi2d rspc2ev syl3anc ello1mpt mpbird ) ABCDU
        AUBNLOZBOZPQZDMOZPQZRZBCSZMTUCLTUCZAETNFTNEUQPQZDFPQZRZBCSZVCIJAVFBCAUQ
        CNVDVEKUDUEVBVGVDUTRZBCSLMEFTTUPEUGZVAVHBCVIURVDUTUPEUQPUHUFUIUSFUGZVHV
        FBCVJUTVEVDUSFDPUJUKUIULUMABLCDMGHUNUO $.
    $}
  $}

  ${
    $d m n x y A $.  $d m n y B $.  $d n x y C $.  $d n x y ph $.
    $d m n x M $.
    lo1bdd2.1 $e |- ( ph -> A C_ RR ) $.
    lo1bdd2.2 $e |- ( ph -> C e. RR ) $.
    lo1bdd2.3 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    lo1bdd2.4 $e |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $.
    lo1bdd2.5 $e |- ( ( ph /\ ( y e. RR /\ C <_ y ) ) -> M e. RR ) $.
    lo1bdd2.6 $e |- ( ( ( ph /\ x e. A ) /\
      ( ( y e. RR /\ C <_ y ) /\ x < y ) ) -> B <_ M ) $.
    $( If an eventually bounded function is bounded on every interval
       ` A i^i ( -oo , y ) ` by a function ` M ( y ) ` , then the function is
       bounded on the whole domain.  (Contributed by Mario Carneiro,
       9-Apr-2016.) $)
    lo1bdd2 $p |- ( ph -> E. m e. RR A. x e. A B <_ m ) $=
      ( cle wbr wi cr wcel wa vn cv wral wrex cpnf cico co cmpt ello1mpt2 mpbid
      clo1 cif wb elicopnf syl biimpa syldan ad2antrr wn simplrl ifclda clt wss
      sselda simpld ltnled expr an32s ex imp adantlr simplr max2 syl2anc simpll
      ad3antrrr simpllr letr syl3anc mpan2d syld sylbird max1 jad ralimdva impr
      sylan wceq breq2 ralbidv rspcev rexlimdva mpd ) ACUBZBUBZOPZEUAUBZOPZQZBD
      UCZUARUDZCFUEUFUGZUDZEGUBZOPZBDUCZGRUDZABDEUHUKSXCLABCDEFUAIKJUIUJAXAXGCX
      BAWNXBSZTZWTXGUARXIWQRSZWTXGXIXJWTTZTZWQHOPZHWQULZRSZEXNOPZBDUCZXGXLXMHWQ
      RXIHRSZXKXMAXHWNRSZFWNOPZTZXRAXHYAAFRSXHYAUMJFWNUNUOUPZMUQZURXIXJWTXMUSZU
      TVAXIXJWTXQXIXJTZWSXPBDYEWODSZTZWPWRXPYGWPUSWOWNVBPZXPYGWOWNYEDRWOADRVCXH
      XJIURVDXIXSXJYFXIXSXTYBVEURVFYGYHEHOPZXPXIYFYHYIQZXJXIYFYJAXHYAYFYJQYBAYA
      TYFYJAYFYAYJAYFTYAYHYINVGVHVIUQVJVKYGYIHXNOPZXPYGXJXRYKXIXJYFVLZXIXRXJYFY
      CURZWQHVMVNYGERSZXRXOYIYKTXPQYEAYFYNAXHXJVOKWGZYMYGXMHWQRXIXRXJYFXMYCVPXI
      XJYFYDVQVAZEHXNVRVSVTWAWBYGWRWQXNOPZXPYGXJXRYQYLYMWQHWCVNYGYNXJXOWRYQTXPQ
      YOYLYPEWQXNVRVSVTWDWEWFXFXQGXNRXDXNWHXEXPBDXDXNEOWIWJWKVNVGWLWLWM $.

    $( Refine ~ o1bdd2 to give a strictly positive upper bound.  (Contributed
       by Mario Carneiro, 25-May-2016.) $)
    lo1bddrp $p |- ( ph -> E. m e. RR+ A. x e. A B <_ m ) $=
      ( vn cv cle wbr cr wcel wral wrex crp lo1bdd2 wa cfv c1 caddc simpr recnd
      cabs co abscld absge0d ge0p1rpd simplr adantr peano2re leabsd lep1d letrd
      syl adantlr letr syl3anc mpan2d ralimdva wceq breq2 ralbidv rspcev ee12an
      wi rexlimdva mpd ) AEOPZQRZBDUAZOSUBEGPZQRZBDUAZGUCUBZABCDEFOHIJKLMNUDAVR
      WBOSAVPSTZUEZVPUKUFZUGUHULZUCTVREWFQRZBDUAZWBWDWEWDVPWDVPAWCUIUJZUMZWDVPW
      IUNUOWDVQWGBDWDBPDTZUEZVQVPWFQRZWGWLVPWEWFAWCWKUPZWDWESTZWKWJUQZWLWOWFSTZ
      WPWEURVBZWLVPWNUSWLWEWPUTVAWLESTZWCWQVQWMUEWGVMAWKWSWCKVCWNWREVPWFVDVEVFV
      GWAWHGWFUCVSWFVHVTWGBDVSWFEQVIVJVKVLVNVO $.
  $}

  ${
    $d m x y A $.  $d m x y B $.  $d m x y C $.  $d f m x y F $.  $d m x M $.
    $( Elementhood in the set of eventually bounded functions.  (Contributed by
       Mario Carneiro, 15-Sep-2014.) $)
    elo1 $p |- ( F e. O(1) <-> ( F e. ( CC ^pm RR ) /\ E. x e. RR E. m e. RR
      A. y e. ( dom F i^i ( x [,) +oo ) ) ( abs ` ( F ` y ) ) <_ m ) ) $=
      ( vf cv cfv cabs cle wbr cdm cpnf cico co cin wral cr wrex cc cpm ineq1d
      co1 wceq dmeq fveq1 fveq2d breq1d raleqbidv 2rexbidv df-o1 elrab2 ) BFZEF
      ZGZHGZCFZIJZBUMKZAFLMNZOZPZCQRAQRULDGZHGZUPIJZBDKZUSOZPZCQRAQREDSQTNUBUMD
      UCZVAVGACQQVHUQVDBUTVFVHURVEUSUMDUDUAVHUOVCUPIVHUNVBHULUMDUEUFUGUHUIABECU
      JUK $.

    $( Elementhood in the set of eventually bounded functions.  (Contributed by
       Mario Carneiro, 15-Sep-2014.) $)
    elo12 $p |- ( ( F : A --> CC /\ A C_ RR ) -> ( F e. O(1) <-> E. x e. RR
      E. m e. RR A. y e. A ( x <_ y -> ( abs ` ( F ` y ) ) <_ m ) ) ) $=
      ( cc cr wa wcel cv cfv cle wbr co wral wrex wi wb cvv syl wf wss co1 cabs
      cdm cpnf cico cin cpm cnex reex mpanl12 elo1 baib elin wceq fdm ad3antrrr
      elpm2r eleq2d anbi1d simpllr elicopnf sselda bitr4d pm5.32da bitrd syl5bb
      biantrurd imbi1d impexp syl6bb ralbidv2 rexbidva ) CFEUAZCGUBZHZEUCIZBJZE
      KUDKDJZLMZBEUEZAJZUFUGNZUHZOZDGPZAGPZWCVSLMZWAQZBCOZDGPZAGPVQEFGUINIZVRWH
      RFSIGSIVQWMUJUKFGCESSUSULVRWMWHABDEUMUNTVQWGWLAGVQWCGIZHZWFWKDGWOVTGIZHZW
      AWJBWECWQVSWEIZWAQVSCIZWIHZWAQWSWJQWQWRWTWAWRVSWBIZVSWDIZHZWQWTVSWBWDUOWQ
      XCWSXBHWTWQXAWSXBWQWBCVSVOWBCUPVPWNWPCFEUQURUTVAWQWSXBWIWQWSHZXBVSGIZWIHZ
      WIXDWNXBXFRVQWNWPWSVBWCVSVCTXDXEWIWQCGVSVOVPWNWPVBVDVIVEVFVGVHVJWSWIWAVKV
      LVMVNVNVG $.

    $( Sufficient condition for elementhood in the set of eventually bounded
       functions.  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    elo12r $p |- ( ( ( F : A --> CC /\ A C_ RR ) /\ ( C e. RR /\ M e. RR ) /\
      A. x e. A ( C <_ x -> ( abs ` ( F ` x ) ) <_ M ) ) -> F e. O(1) ) $=
      ( vy vm cc cr wa wcel cv cle wbr cfv wi wral wrex wceq ralbidv wf wss w3a
      co1 breq1 imbi1d breq2 imbi2d rspc2ev 3expa 3adant1 elo12 3ad2ant1 mpbird
      cabs wb ) BHDUABIUBJZCIKZEIKZJZCALZMNZVADOUOOZEMNZPZABQZUCDUDKZFLZVAMNZVC
      GLZMNZPZABQZGIRFIRZUTVFVNUQURUSVFVNVMVFVBVKPZABQFGCEIIVHCSZVLVOABVPVIVBVK
      VHCVAMUEUFTVJESZVOVEABVQVKVDVBVJEVCMUGUHTUIUJUKUQUTVGVNUPVFFABGDULUMUN $.

    $( An eventually bounded function is a function.  (Contributed by Mario
       Carneiro, 15-Sep-2014.) $)
    o1f $p |- ( F e. O(1) -> F : dom F --> CC ) $=
      ( vy vm vx co1 wcel cc cr cpm co cdm wf cv cfv cabs cle cpnf wrex simplbi
      wbr cico cin wral elo1 wss cnex reex elpm2 syl ) AEFZAGHIJFZAKZGALZUJUKBM
      ANONCMPTBULDMQUAJUBUCCHRDHRDBCAUDSUKUMULHUEGHAUFUGUHSUI $.

    $( An eventually bounded function's domain is a subset of the reals.
       (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    o1dm $p |- ( F e. O(1) -> dom F C_ RR ) $=
      ( vy vm vx co1 wcel cc cr cpm co cdm wss cfv cabs cle wbr cpnf cico wrex
      cv cin wral elo1 simplbi wf cnex reex elpm2 simprbi syl ) AEFZAGHIJFZAKZH
      LZUKULBTAMNMCTOPBUMDTQRJUAUBCHSDHSDBCAUCUDULUMGAUEUNGHAUFUGUHUIUJ $.

    $( The defining property of an eventually bounded function.  (Contributed
       by Mario Carneiro, 15-Sep-2014.) $)
    o1bdd $p |- ( ( F e. O(1) /\ F : A --> CC ) -> E. x e. RR
      E. m e. RR A. y e. A ( x <_ y -> ( abs ` ( F ` y ) ) <_ m ) ) $=
      ( co1 wcel cc wf wa cv cle wbr cfv cabs wi wral cr wrex wss simpl wb wceq
      simpr cdm fdm adantl o1dm adantr eqsstr3d elo12 syl2anc mpbid ) EFGZCHEIZ
      JZUNAKBKZLMUQENONDKLMPBCQDRSARSZUNUOUAUPUOCRTUNURUBUNUOUDUPCEUEZRUOUSCUCU
      NCHEUFUGUNUSRTUOEUHUIUJABCDEUKULUM $.

    $( A function is eventually bounded iff its absolute value is eventually
       upper bounded.  (Contributed by Mario Carneiro, 26-May-2016.) $)
    lo1o1 $p |- ( F : A --> CC -> ( F e. O(1) <-> ( abs o. F ) e. <_O(1) ) ) $=
      ( vx vy vm cc wf cr wss wcel cabs cdm fdm sseq1d syl5ib cle wbr cfv wrex
      cv co1 ccom clo1 o1dm lo1dm wceq absf fco mpan syl wb wa wi fvco3 adantlr
      breq1d imbi2d ralbidva 2rexbidv ello12 sylan elo12 3bitr4rd ex pm5.21ndd
      wral ) AFBGZAHIZBUAJZKBUBZUCJZVIBLZHIVGVHBUDVGVLAHAFBMNOVKVJLZHIVGVHVJUEV
      GVMAHVGAHVJGZVMAUFFHKGVGVNUGAFHKBUHUIZAHVJMUJNOVGVHVIVKUKVGVHULZCTDTZPQZV
      QVJRZETZPQZUMZDAVFZEHSCHSZVRVQBRKRZVTPQZUMZDAVFZEHSCHSVKVIVPWCWHCEHHVPWBW
      GDAVPVQAJZULZWAWFVRWJVSWEVTPVGWIVSWEUFVHAFVQKBUNUOUPUQURUSVGVNVHVKWDUKVOC
      DAEVJUTVACDAEBVBVCVDVE $.
  $}

  ${
    $d x y $.  $d x A $.  $d y B $.  $d x ph $.
    lo1o12.1 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    $( A function is eventually bounded iff its absolute value is eventually
       upper bounded.  (This function is useful for converting theorems about
       ` <_O(1) ` to ` O(1) ` .)  (Contributed by Mario Carneiro,
       26-May-2016.) $)
    lo1o12 $p |- ( ph -> ( ( x e. A |-> B ) e. O(1) <->
      ( x e. A |-> ( abs ` B ) ) e. <_O(1) ) ) $=
      ( vy cmpt co1 wcel cabs ccom clo1 cfv cc wf wb eqid fmptd lo1o1 cr syl cv
      eqidd absf a1i feqmptd fveq2 fmptco eleq1d bitrd ) ABCDGZHIZJUKKZLIZBCDJM
      ZGZLIACNUKOULUNPABCDNUKEUKQRCUKSUAAUMUPLABFCNDFUBZJMUOUKJEAUKUCAFNTJNTJOA
      UDUEUFUQDJUGUHUIUJ $.
  $}

  ${
    $d m w x y z A $.  $d m w y z B $.  $d m x y C $.  $d m x y ph $.
    $d m x M $.  $d x N $.
    elo1mpt.1 $e |- ( ph -> A C_ RR ) $.
    elo1mpt.2 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    $( Elementhood in the set of eventually bounded functions.  (Contributed by
       Mario Carneiro, 21-Sep-2014.)  (Proof shortened by Mario Carneiro,
       26-May-2016.) $)
    elo1mpt $p |- ( ph -> ( ( x e. A |-> B ) e. O(1) <-> E. y e. RR
      E. m e. RR A. x e. A ( y <_ x -> ( abs ` B ) <_ m ) ) ) $=
      ( cmpt co1 wcel cabs cfv clo1 cv cle wbr wi cr wrex wral lo1o12 wa abscld
      ello1mpt bitrd ) ABDEIJKBDELMZINKCOBOZPQUGFOPQRBDUAFSTCSTABDEHUBABCDUGFGA
      UHDKUCEHUDUEUF $.

    elo1d.3 $e |- ( ph -> C e. RR ) $.
    $( Elementhood in the set of eventually bounded functions.  (Contributed by
       Mario Carneiro, 12-May-2016.)  (Proof shortened by Mario Carneiro,
       26-May-2016.) $)
    elo1mpt2 $p |- ( ph -> ( ( x e. A |-> B ) e. O(1) <-> E. y e. ( C [,) +oo )
      E. m e. RR A. x e. A ( y <_ x -> ( abs ` B ) <_ m ) ) ) $=
      ( cmpt co1 wcel cabs cfv clo1 cv cle wbr wrex wi wral cr cpnf cico lo1o12
      co wa abscld ello1mpt2 bitrd ) ABDEKLMBDENOZKPMCQBQZRSULGQRSUABDUBGUCTCFU
      DUEUGTABDEIUFABCDULFGHAUMDMUHEIUIJUJUK $.

    elo1d.4 $e |- ( ph -> M e. RR ) $.
    elo1d.5 $e |- ( ( ph /\ ( x e. A /\ C <_ x ) ) -> ( abs ` B ) <_ M ) $.
    $( Sufficient condition for elementhood in the set of eventually bounded
       functions.  (Contributed by Mario Carneiro, 21-Sep-2014.)  (Proof
       shortened by Mario Carneiro, 26-May-2016.) $)
    elo1d $p |- ( ph -> ( x e. A |-> B ) e. O(1) ) $=
      ( cmpt co1 wcel cabs cfv clo1 cv wa abscld ello1d lo1o12 mpbird ) ABCDLMN
      BCDOPZLQNABCUDEFGABRCNSDHTIJKUAABCDHUBUC $.
  $}

  ${
    $d c m n p x A $.  $d c m n p B $.  $d x M $.  $d c m n p x ph $.
    o1lo1.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    $( A real function is eventually bounded iff it is eventually lower bounded
       and eventually upper bounded.  (Contributed by Mario Carneiro,
       25-May-2016.) $)
    o1lo1 $p |- ( ph -> ( ( x e. A |-> B ) e. O(1) <->
      ( ( x e. A |-> B ) e. <_O(1) /\ ( x e. A |-> -u B ) e. <_O(1) ) ) ) $=
      ( vc vm vn vp cr wcel wa wi wb wral wceq cv cle wbr wrex cmpt cdm wss co1
      clo1 cneg o1dm a1i lo1dm adantr ralrimiva dmmptg syl sseq1d simpr adantlr
      cabs cfv simplr absled ancom lenegcon1 syl2anc anbi2d syl5bb bitrd imbi2d
      ralbidva rexbidv biimpd breq2 anbi1d rexralbidv 3anidm12 ee12an rexlimdva
      rspc2ev cif simplrr wn simplrl ifclda max2 ad2antlr renegcld ifcl syl3anc
      letr mpan2d sylibd anim12d ancomsd sylibrd imim2d ralimdva reximdv rspcev
      max1 rexlimdvva impbid rexanre adantl 2rexbidv reeanv syl6bb rexcom recnd
      anbi12i 3bitr4g elo1mpt ello1mpt anbi12d 3bitr4d ex sylbid pm5.21ndd ) AB
      CDUAZUBZJUCZXQUDKZXQUEKZBCDUFZUAUEKZLZXTXSMAXQUGUHYDXSMAYAXSYCXQUIUJUHAXS
      CJUCZXTYDNZAXRCJADJKZBCOXRCPAYGBCEUKBCDJULUMUNAYEYFAYELZFQBQZRSZDUQURZGQZ
      RSZMZBCOZGJTFJTZYJDHQZRSZMBCOZHJTFJTZYJYBIQZRSZMBCOZIJTFJTZLZXTYDYHYOFJTZ
      GJTZYSFJTZHJTZUUCFJTZIJTZLZYPUUEYHUUGUUHUUJLZIJTHJTZUULYHUUGYJYRUUBLZMZBC
      OZFJTZIJTHJTZUUNYHUUGUUSYHUUFUUSGJYHYLJKZLZUUTUUFYJDYLRSZYBYLRSZLZMZBCOZF
      JTZUUSYHUUTUOUVAUUFUVGUVAYOUVFFJUVAYNUVEBCUVAYICKZLZYMUVDYJUVIYMYLUFDRSZU
      VBLZUVDUVIDYLYHUVHYGUUTAUVHYGYEEUPZUPZYHUUTUVHUSZUTUVKUVBUVJLUVIUVDUVJUVB
      VAUVIUVJUVCUVBUVIUUTYGUVJUVCNUVNUVMYLDVBVCVDVEVFVGVHVIVJUUTUVGUUSUURUVGYJ
      UVBUUBLZMZBCOFJTHIYLYLJJYQYLPZUUPUVPFBJCUVQUUOUVOYJUVQYRUVBUUBYQYLDRVKVLV
      GVMUUAYLPZUVPUVEFBJCUVRUVOUVDYJUVRUUBUVCUVBUUAYLYBRVKVDVGVMVQVNVOVPYHUURU
      UGHIJJYHYQJKZUUAJKZLZLZYQUUARSZUUAYQVRZJKZUURYJYKUWDRSZMZBCOZFJTZUUGUWBUW
      CUUAYQJYHUVSUVTUWCVSYHUVSUVTUWCVTWAWBUWBUUQUWHFJUWBUUPUWGBCUWBUVHLZUUOUWF
      YJUWJUUOUWDUFDRSZDUWDRSZLZUWFUWJUUBYRUWMUWJUUBUWKYRUWLUWJUUBYBUWDRSZUWKUW
      JUUBUUAUWDRSZUWNUWAUWOYHUVHYQUUAWCWDUWJYBJKUVTUWEUUBUWOLUWNMUWJDYHUVHYGUW
      AUVLUPZWEYHUVSUVTUVHVSZUWJUVTUVSUWEUWQYHUVSUVTUVHWAZUWCUUAYQJWFVCZYBUUAUW
      DWHWGWIUWJYGUWEUWNUWKNUWPUWSDUWDVBVCWJUWJYRYQUWDRSZUWLUWAUWTYHUVHYQUUAWRW
      DUWJYGUVSUWEYRUWTLUWLMUWPUWRUWSDYQUWDWHWGWIWKWLUWJDUWDUWPUWSUTWMWNWOWPUUF
      UWIGUWDJYLUWDPZYNUWGFBJCUXAYMUWFYJYLUWDYKRVKVGVMWQVOWSWTYHUURUUMHIJJYEUUR
      UUMNAYRUUBCFBXAXBXCVFUUHUUJHIJJXDXEYOFGJJXFYTUUIUUDUUKYSFHJJXFUUCFIJJXFXH
      XIYHBFCDGAYEUOZYHUVHLZDUVLXGXJYHYAYTYCUUDYHBFCDHUXBUVLXKYHBFCYBIUXBUXCDUV
      LWEXKXLXMXNXOXP $.

    ${
      o1lo12.2 $e |- ( ph -> M e. RR ) $.
      o1lo12.3 $e |- ( ( ph /\ x e. A ) -> M <_ B ) $.
      $( A lower bounded real function is eventually bounded iff it is
         eventually upper bounded.  (Contributed by Mario Carneiro,
         26-May-2016.) $)
      o1lo12 $p |- ( ph -> ( ( x e. A |-> B ) e. O(1) <->
        ( x e. A |-> B ) e. <_O(1) ) ) $=
        ( cmpt cr wss wcel clo1 wi a1i cneg wa renegcld cle wbr cdm co1 o1dm wb
        lo1dm wral wceq ralrimiva dmmptg syl sseq1d simpr adantlr adantr lenegd
        cv mpbid ad2ant2r ello1d o1lo1 rbaibd syldan ex sylbid pm5.21ndd ) ABCD
        IZUAZJKZVFUBLZVFMLZVIVHNAVFUCOVJVHNAVFUEOAVHCJKZVIVJUDZAVGCJADJLZBCUFVG
        CUGAVMBCFUHBCDJUIUJUKAVKVLAVKBCDPZIMLZVLAVKQZBCVNEEPZAVKULABUPZCLZVNJLV
        KAVSQZDFRUMAEJLZVKGUNZVPEWBRAVSVNVQSTZVKEVRSTVTEDSTWCHVTEDAWAVSGUNFUOUQ
        URUSAVIVJVOABCDFUTVAVBVCVDVE $.
    $}

    lo1o1.1 $e |- ( ph -> ( x e. A |-> B ) e. O(1) ) $.
    $( A real eventually bounded function is eventually upper bounded.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    o1lo1d $p |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $=
      ( cmpt clo1 wcel cneg co1 wa o1lo1 mpbid simpld ) ABCDGZHIZBCDJGHIZAPKIQR
      LFABCDEMNO $.
  $}

  ${
    $d x A $.  $d x C $.  $d x M $.  $d x N $.  $d x ph $.
    icco1.1 $e |- ( ph -> A C_ RR ) $.
    icco1.2 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    icco1.3 $e |- ( ph -> C e. RR ) $.
    icco1.4 $e |- ( ph -> M e. RR ) $.
    icco1.5 $e |- ( ph -> N e. RR ) $.
    icco1.6 $e |- ( ( ph /\ ( x e. A /\ C <_ x ) ) -> B e. ( M [,] N ) ) $.
    $( Derive eventual boundedness from separate upper and lower eventual
       bounds.  (Contributed by Mario Carneiro, 15-Apr-2016.) $)
    icco1 $p |- ( ph -> ( x e. A |-> B ) e. O(1) ) $=
      ( cmpt wcel clo1 cle wbr wa cr co1 cneg cv cicc w3a elicc2 syl2anc adantr
      co wb mpbid simp3d ello1d renegcld simp2d adantrr lenegd o1lo1 mpbir2and
      ) ABCDNZUAOUTPOBCDUBZNPOABCDEGHIJLABUCZCOZEVBQRZSZSZDTOZFDQRZDGQRZVFDFGUD
      UIOZVGVHVIUEZMAVJVKUJZVEAFTOZGTOVLKLFGDUFUGUHUKZULUMABCVAEFUBZHAVCSDIUNJA
      FKUNVFVHVAVOQRVFVGVHVIVNUOVFFDAVMVEKUHAVCVGVDIUPUQUKUMABCDIURUS $.
  $}

  ${
    $d m n x y A $.  $d m n y B $.  $d x y C $.  $d m x M $.  $d n x y ph $.
    o1bdd2.1 $e |- ( ph -> A C_ RR ) $.
    o1bdd2.2 $e |- ( ph -> C e. RR ) $.
    o1bdd2.3 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    o1bdd2.4 $e |- ( ph -> ( x e. A |-> B ) e. O(1) ) $.
    o1bdd2.5 $e |- ( ( ph /\ ( y e. RR /\ C <_ y ) ) -> M e. RR ) $.
    o1bdd2.6 $e |- ( ( ( ph /\ x e. A ) /\
      ( ( y e. RR /\ C <_ y ) /\ x < y ) ) -> ( abs ` B ) <_ M ) $.
    $( If an eventually bounded function is bounded on every interval
       ` A i^i ( -oo , y ) ` by a function ` M ( y ) ` , then the function is
       bounded on the whole domain.  (Contributed by Mario Carneiro,
       9-Apr-2016.)  (Proof shortened by Mario Carneiro, 26-May-2016.) $)
    o1bdd2 $p |- ( ph -> E. m e. RR A. x e. A ( abs ` B ) <_ m ) $=
      ( cabs cfv cv wcel wa cmpt abscld co1 clo1 lo1o12 mpbid lo1bdd2 ) ABCDEOP
      ZFGHIJABQDRSEKUAABDETUBRBDUGTUCRLABDEKUDUEMNUF $.

    $( Refine ~ o1bdd2 to give a strictly positive upper bound.  (Contributed
       by Mario Carneiro, 25-May-2016.) $)
    o1bddrp $p |- ( ph -> E. m e. RR+ A. x e. A ( abs ` B ) <_ m ) $=
      ( cabs cfv cv wcel wa cmpt abscld co1 clo1 lo1o12 mpbid lo1bddrp ) ABCDEO
      PZFGHIJABQDRSEKUAABDETUBRBDUGTUCRLABDEKUDUEMNUF $.
  $}

  ${
    $d j k x A $.  $d j k x F $.  $d j M $.  $d j k x ph $.  $d j k Z $.
    climconst.1 $e |- Z = ( ZZ>= ` M ) $.
    climconst.2 $e |- ( ph -> M e. ZZ ) $.
    climconst.3 $e |- ( ph -> F e. V ) $.
    climconst.4 $e |- ( ph -> A e. CC ) $.
    climconst.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    $( An (eventually) constant sequence converges to its value.  (Contributed
       by NM, 28-Aug-2005.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
    climconst $p |- ( ph -> F ~~> A ) $=
      ( vx vj wbr cabs cfv cv wcel cc0 cli cmin co clt cuz wral wrex wa cz uzid
      crp syl syl6eleqr adantr wceq subidd fveq2d syl6eq rpgt0 adantl ralrimivw
      abs0 eqbrtrd fveq2 syl6eqr raleqdv rspcev syl2anc ralrimiva clim2c mpbird
      cc ) ADBUAOBBUBUCZPQZMRZUDOZCNRZUEQZUFZNGUGZMUKUFAVTMUKAVOUKSZUHZEGSZVPCG
      UFZVTAWCWAAEEUEQZGAEUISEWESIEUJULHUMUNWBVPCGWBVNTVOUDAVNTUOWAAVNTPQTAVMTP
      ABKUPUQVBURUNWATVOUDOAVOUSUTVCVAVSWDNEGVQEUOZVPCVRGWFVRWEGVQEUEVDHVEVFVGV
      HVIAMBBNCDEFGHIJLKABVLSCRGSKUNVJVK $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( A constant sequence converges to its value.  (Contributed by Mario
       Carneiro, 16-Sep-2014.) $)
    rlimconst $p |- ( ( A C_ RR /\ B e. CC ) -> ( x e. A |-> B ) ~~>r B ) $=
      ( vz vy cr wss wcel wa wbr cv cle cabs cfv clt wi wral crp cc0 ralrimiva
      cc cmpt crli cmin co wrex 0re simpllr subidd fveq2d syl6eq rpgt0 ad2antlr
      abs0 eqbrtrd breq1 imbi1d ralbidv rspcev sylancr simplr simpl simpr rlim2
      a1d wceq mpbird ) BFGZCUAHZIZABCUBCUCJDKZAKZLJZCCUDUEZMNZEKZOJZPZABQZDFUF
      ZERQVJVTERVJVPRHZIZSFHSVLLJZVQPZABQZVTUGWBWDABWBVLBHZIZVQWCWGVOSVPOWGVOSM
      NSWGVNSMWGCVHVIWAWFUHUIUJUNUKWASVPOJVJWFVPULUMUOVETVSWEDSFVKSVFZVRWDABWHV
      MWCVQVKSVLLUPUQURUSUTTVJEDABCCVJVIABVHVIWFVATVHVIVBVHVIVCVDVG $.
  $}

  ${
    $d j k w y z A $.  $d j k w y z F $.  $d j k y z ph $.  $d j k z Z $.
    $d j k M $.
    rlimclim1.1 $e |- Z = ( ZZ>= ` M ) $.
    rlimclim1.2 $e |- ( ph -> M e. ZZ ) $.
    rlimclim1.3 $e |- ( ph -> F ~~>r A ) $.
    rlimclim1.4 $e |- ( ph -> Z C_ dom F ) $.
    $( Forward direction of ~ rlimclim .  (Contributed by Mario Carneiro,
       16-Sep-2014.) $)
    rlimclim1 $p |- ( ph -> F ~~> A ) $=
      ( vk vw wbr cv cfv wral wcel wa cle cr cc vy vj vz cli cmin cabs clt wrex
      co cuz crp wi cdm cvv fvex rgenw a1i simpr cmpt crli wf rlimf syl feqmptd
      adantr eqbrtrrd rlimi cfl c1 caddc cif cz ad2antrr flcl peano2zd ad2antrl
      ifcl syl2anc zred eluz2 syl3anbrc syl6eleqr ad3antrrr uztrn2 sylan sseldd
      max1 simplrr simplrl eluzelre adantl fllep1 max2 letrd eluzle breq2 fveq2
      wceq oveq1d fveq2d breq1d imbi12d rspcv syl3c ralrimiva raleqdv rexlimddv
      wss rspcev cpm rlimpm eqidd rlimcl sselda ffvelrnda syldan clim2c mpbird
      ) ACBUDLJMZCNZBUEUIZUFNZUAMZUGLZJUBMZUJNZOZUBEUHZUAUKOAYHUAUKAYCUKPZQZUCM
      ZKMZRLZYLCNZBUEUIZUFNZYCUGLZULZKCUMZOZYHUCSYJUCKYSYNBYCUNYNUNPZKYSOYJUUAK
      YSYLCUOUPUQAYIURYJCKYSYNUSBUTYJKYSTCAYSTCVAZYIACBUTLZUUBHBCVBVCZVEVDAUUCY
      IHVEVFVGYJYKSPZYTQZQZDYKVHNZVIVJUIZRLZUUIDVKZEPZYDJUUKUJNZOZYHUUGUUKDUJNZ
      EUUGDVLPZUUKVLPZDUUKRLZUUKUUOPAUUPYIUUFGVMZUUGUUIVLPZUUPUUQUUEUUTYJYTUUEU
      UHYKVNVOZVPZUUSUUJUUIDVLVQVRUUGDSPZUUISPZUURUUGDUUSVSZUUGUUIUVBVSDUUIWGVR
      DUUKVTWAFWBZUUGYDJUUMUUGXSUUMPZQZXSYSPZYTYKXSRLZYDUVHEYSXSAEYSXHYIUUFUVGI
      WCUUGUULUVGXSEPZUVFDXSUUKEFWDWEWFYJUUEYTUVGWHUVHYKUUKXSYJUUEYTUVGWIZUVHUV
      DUVCUUKSPUVHUUEUVDUVLUUEUUIUVAVSVCZUUGUVCUVGUVEVEZUUJUUIDSVQVRZUVGXSSPUUG
      UUKXSWJWKUVHYKUUIUUKUVLUVMUVOUVHUUEYKUUIRLUVLYKWLVCUVHUVCUVDUUIUUKRLUVNUV
      MDUUIWMVRWNUVGUUKXSRLUUGUUKXSWOWKWNYRUVJYDULKXSYSYLXSWRZYMUVJYQYDYLXSYKRW
      PUVPYPYBYCUGUVPYOYAUFUVPYNXTBUEYLXSCWQWSWTXAXBXCXDXEYGUUNUBUUKEYEUUKWRYDJ
      YFUUMYEUUKUJWQXFXIVRXGXEAUABXTUBJCDTSXJUIZEFGAUUCCUVQPHBCXKVCAUVKQXTXLAUU
      CBTPHBCXMVCAUVKUVIXTTPAEYSXSIXNAYSTXSCUUDXOXPXQXR $.
  $}

  ${
    $d k w y z A $.  $d k w y z F $.  $d k w y z ph $.  $d k w z Z $.
    $d z M $.
    rlimclim.1 $e |- Z = ( ZZ>= ` M ) $.
    rlimclim.2 $e |- ( ph -> M e. ZZ ) $.
    rlimclim.3 $e |- ( ph -> F : Z --> CC ) $.
    $( A sequence on an upper integer set converges in the real sense iff it
       converges in the integer sense.  (Contributed by Mario Carneiro,
       16-Sep-2014.) $)
    rlimclim $p |- ( ph -> ( F ~~>r A <-> F ~~> A ) ) $=
      ( vz vw vy vk wbr wa cz wcel adantr cv cfv cr crli cli simpr cdm wss wceq
      cc wf fdm eqimss2 3syl rlimclim1 cle cmin co cabs clt wi wral wrex climcl
      crp adantl cuz ad2antrr eqidd simplr climi2 eqsstri simplrl sseldi simprl
      uzssz simprr eluz2 syl3anbrc simplrr fveq2 oveq1d fveq2d breq1d sylc expr
      rspcv ralrimiva reximdva zssre sstri ssrexv ax-mp syl6 mpd rlim mpbir2and
      a1i impbida ) ACBUAMZCBUBMZAWQNBCDEFADOPZWQGQAWQUCAECUDZUEZWQAEUGCUHZWTEU
      FXAHEUGCUIEWTUJUKQULAWRNZWQBUGPZIRZJRZUMMZXFCSZBUNUOZUPSZKRZUQMZURZJEUSZI
      TUTZKVBUSWRXDABCVAVCXCXOKVBXCXKVBPZNZLRZCSZBUNUOZUPSZXKUQMZLXEVDSZUSZIEUT
      ZXOXQBXSXKILCDEFAWSWRXPGVEXCXPUCXQXREPNXSVFAWRXPVGVHXQYEXNIEUTZXOXQYDXNIE
      XQXEEPZYDXNXQYGYDNNZXMJEYHXFEPZXGXLYHYIXGNZNZXFYCPZYDXLYKXEOPXFOPXGYLYKEO
      XEEDVDSOFDVMVIZXQYGYDYJVJVKYKEOXFYMYHYIXGVLVKYHYIXGVNXEXFVOVPXQYGYDYJVQYB
      XLLXFYCXRXFUFZYAXJXKUQYNXTXIUPYNXSXHBUNXRXFCVRVSVTWAWDWBWCWEWCWFETUEZYFXO
      UREOTYMWGWHZXNIETWIWJWKWLWEXCKIJEXHBCAXBWRHQYOXCYPWOXCYINXHVFWMWNWP $.
  $}

  ${
    $d j x y A $.  $d j k x y B $.  $d j n y C $.  $d j k x y D $.  $d j k M $.
    $d j k n x y ph $.  $d j k n x y Z $.
    climrlim2.1 $e |- Z = ( ZZ>= ` M ) $.
    climrlim2.2 $e |- ( n = ( |_ ` x ) -> B = C ) $.
    climrlim2.3 $e |- ( ph -> A C_ RR ) $.
    climrlim2.4 $e |- ( ph -> M e. ZZ ) $.
    climrlim2.5 $e |- ( ph -> ( n e. Z |-> B ) ~~> D ) $.
    climrlim2.6 $e |- ( ( ph /\ n e. Z ) -> B e. CC ) $.
    climrlim2.7 $e |- ( ( ph /\ x e. A ) -> M <_ x ) $.
    $( Produce a real limit from an integer limit, where the real function is
       only dependent on the integer part of ` x ` .  (Contributed by Mario
       Carneiro, 2-May-2016.) $)
    climrlim2 $p |- ( ph -> ( x e. A |-> C ) ~~>r D ) $=
      ( wbr wcel cfv wa vk vy vj cmpt cli crli cc cv cmin co cabs clt wral wrex
      cuz crp cle wi cr cfl eluzelz eleq2s ad2antlr sselda flcld adantlr simprr
      cz ad2ant2r wb flge syl2anc mpbid eluz2 syl3anbrc simpr ralimi wceq fveq2
      oveq1d fveq2d breq1d syl2im adantr syl6eleqr ralrimiva eleq1d sylc fvmptg
      rspcv eqid sylibd com23 ralrimdva eluzelre adantl jctild expimpd reximdv2
      expr ralimdva adantld cvv climrel brrelexi syl eqidd clim2 climcl 3imtr4d
      rlim2 mpd ) AGIDUDZFUEQZBCEUDFUFQZNAFUGRZUAUHZXMSZUGRZXRFUIUJZUKSZUBUHZUL
      QZTZUAUCUHZUOSZUMZUCIUNZUBUPUMZTYEBUHZUQQZEFUIUJZUKSZYBULQZURZBCUMZUCUSUN
      ZUBUPUMZXNXOAYIYRXPAYHYQUBUPAYBUPRZTZYGYPUCIUSYTYEIRZYGYEUSRZYPTYTUUATZYG
      YPUUBUUCYGYOBCUUCYJCRZTYKYGYNUUCUUDYKYGYNURUUCUUDYKTZTZYGYJUTSZXMSZFUIUJZ
      UKSZYBULQZYNUUFUUGYFRZYGYCUAYFUMUUKUUFYEVHRZUUGVHRZYEUUGUQQZUULUUAUUMYTUU
      EUUMYEHUOSZIHYEVAJVBVCZYTUUDUUNUUAYKAUUDUUNYSAUUDTZYJACUSYJLVDZVEZVFVIUUF
      YKUUOUUCUUDYKVGUUFYJUSRZUUMYKUUOVJYTUUDUVAUUAYKAUUDUVAYSUUSVFVIUUQYJYEVKV
      LVMYEUUGVNVOYDYCUAYFXSYCVPVQYCUUKUAUUGYFXQUUGVRZYAUUJYBULUVBXTUUIUKUVBXRU
      UHFUIXQUUGXMVSVTWAWBWJWCUUFUUJYMYBULUUFUUIYLUKUUFUUHEFUIYTUUDUUHEVRZUUAYK
      AUUDUVCYSUURUUGIRZEUGRZUVCUURUUGUUPIUURHVHRZUUNHUUGUQQZUUGUUPRAUVFUUDMWDZ
      UUTUURHYJUQQZUVGPUURUVAUVFUVIUVGVJUUSUVHYJHVKVLVMHUUGVNVOJWEZUURUVDDUGRZG
      IUMZUVEUVJAUVLUUDAUVKGIOWFWDUVKUVEGUUGIGUHUUGVRDEUGKWGWJWHZGUUGDEIUGXMKXM
      WKWIVLVFVIVTWAWBWLWTWMWNUUAUUBYTUUBYEUUPIHYEWOJVBWPWQWRWSXAXBAUBFXRUCUAXM
      HXCIJMAXNXMXCRNXMFUEXDXEXFAXQIRTXRXGXHAUBUCBCEFAUVEBCUVMWFLAXNXPNFXMXIXFX
      KXJXL $.
  $}

  ${
    $d k A $.  $d k M $.  $d k Z $.
    climconst2.1 $e |- ( ZZ>= ` M ) C_ Z $.
    climconst2.2 $e |- Z e. _V $.
    $( A constant sequence converges to its value.  (Contributed by NM,
       6-Feb-2008.)  (Revised by Mario Carneiro, 31-Jan-2014.) $)
    climconst2 $p |- ( ( A e. CC /\ M e. ZZ ) -> ( Z X. { A } ) ~~> A ) $=
      ( vk cc wcel cz wa csn cxp cvv cuz cfv eqid simpr snex xpex a1i fvconst2g
      simpl cv wceq sseli syl2an climconst ) AGHZBIHZJZAFCAKZLZBMBNOZUMPUHUIQUL
      MHUJCUKEARSTUHUIUBZUJUHFUCZCHUOULOAUDUOUMHUNUMCUODUECAUOGUAUFUG $.
  $}

  $( The zero sequence converges to zero.  (Contributed by NM, 2-Oct-1999.)
     (Revised by Mario Carneiro, 31-Jan-2014.) $)
  climz $p |- ( ZZ X. { 0 } ) ~~> 0 $=
    ( cc0 cc wcel cz csn cxp cli wbr 0cn 0z uzssz zex climconst2 mp2an ) ABCADC
    DAEFAGHIJAADAKLMN $.

  ${
    $d j k A $.  $d j k B $.  $d j k C $.  $d j k x y F $.  $d j k x y ph $.
    rlimuni.1 $e |- ( ph -> F : A --> CC ) $.
    rlimuni.2 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    ${
      rlimuni.3 $e |- ( ph -> F ~~>r B ) $.
      rlimuni.4 $e |- ( ph -> F ~~>r C ) $.
      $( A real function whose domain is unbounded above converges to at most
         one limit.  (Contributed by Mario Carneiro, 8-May-2016.) $)
      rlimuni $p |- ( ph -> B = C ) $=
        ( vj vk wbr clt wa cr wrex wcel cc syl adantr cv cle cfv cmin cabs cdiv
        co c2 wi wral wceq crli rlimcl ad2antrr subcld abscld ffvelrnda adantlr
        wn ltnrd abssubd breq1d anbi1d abs3lem syl22anc sylbid com23 imp3a mtod
        imim2d nrexdv r19.29r nsyl cxr csup cpnf wss wb cdm fdm rlimss eqsstr3d
        wf ressxr syl6ss supxrunb1 mpbird r19.29 ex wne ffvelrn ralrimiva simpr
        subne0d absrpcld rphalfcld cmpt feqmptd eqbrtrrd rlimi rexanre necon1bd
        mpbir2and mpd ) AJUAZKUAZUBLZXFEUCZCUDUGUEUCZCDUDUGZUEUCZUHUFUGZMLZXHDU
        DUGUEUCXLMLZNZUIZKBUJZJOPZUSCDUKAXRXGKBPZXQNZJOPZAXTJOAXEOQZNZXGXPNZKBP
        XTYCYDKBYCXFBQZNZYDXKXKMLZYFXKYFXJYFCDACRQZYBYEAECULLZYHHCEUMSZUNZADRQZ
        YBYEAEDULLZYLIDEUMSZUNZUOUPZUTYFXGXPYGYFXPXGYGYFXOYGXGYFXOCXHUDUGUEUCZX
        LMLZXNNZYGYFXMYRXNYFXIYQXLMYFXHCAYEXHRQZYBABRXFEFUQURZYKVAVBVCYFYHYLYTX
        KOQYSYGUIYKYOUUAYPCDXHXKVDVEVFVJVGVHVIVKXGXPKBVLVMVKAXSJOUJZXRYAUIAUUBB
        VNMVOVPUKZGABVNVQUUBUUCVRABOVNABEVSZOABREWCZUUDBUKFBREVTSAYIUUDOVQHCEWA
        SWBZWDWEJKBWFSWGUUBXRYAXSXQJOWHWISVIAXRCDACDWJZXRAUUGNZXRXGXMUIKBUJJOPZ
        XGXNUIKBUJJOPZUUHJKBXHCXLRUUHUUEYTKBUJAUUEUUGFTZUUEYTKBBRXFEWKWLSZUUHXK
        UUHXJUUHCDAYHUUGYJTZAYLUUGYNTZUOUUHCDUUMUUNAUUGWMWNWOWPZUUHEKBXHWQZCULU
        UHKBREUUKWRZAYIUUGHTWSWTUUHJKBXHDXLRUULUUOUUHEUUPDULUUQAYMUUGITWSWTUUHB
        OVQZXRUUIUUJNVRAUURUUGUUFTXMXNBJKXASXCWIXBXD $.
    $}

    $( Two ways to express that a function has a limit.  (The expression
       ` ( ~~>r `` F ) ` is sometimes useful as a shorthand for "the unique
       limit of the function ` F ` ").  (Contributed by Mario Carneiro,
       8-May-2016.) $)
    rlimdm $p |- ( ph -> ( F e. dom ~~>r <-> F ~~>r ( ~~>r ` F ) ) ) $=
      ( vx vy crli cdm wcel cfv wbr cv wex eldmg ibi wa cvv wceq adantr cio vex
      simpr df-fv wb cc cxr clt csup cpnf simprr simprl rlimuni expr syl5ibrcom
      wf breq2 impbid iota5 mpan2 syl5eq breqtrrd exlimdv syl5 rlimrel releldmi
      ex impbid1 ) ACHIZJZCCHKZHLZVJCFMZHLZFNZAVLVJVOFCHVIOPAVNVLFAVNVLAVNQZCVM
      VKHAVNUCZVPVKCGMZHLZGUAZVMGCHUDVPVMRJZVTVMSFUBVPVSGVMRVPVSVRVMSZUEWAVPVSW
      BAVNVSWBAVNVSQZQBVRVMCABUFCUPWCDTABUGUHUIUJSWCETAVNVSUKAVNVSULUMUNVPVSWBV
      NVQVRVMCHUQUOURTUSUTVAVBVGVCVDCVKHVEVFVH $.
  $}

  ${
    $d j k x A $.  $d j k x B $.  $d j k x F $.
    $( An infinite sequence of complex numbers converges to at most one limit.
       (Contributed by NM, 2-Oct-1999.)  (Proof shortened by Mario Carneiro,
       31-Jan-2014.) $)
    climuni $p |- ( ( F ~~> A /\ F ~~> B ) -> A = B ) $=
      ( vk vj wbr wa c1 wcel cfv cc cmin co cabs clt wral cn wrex nnuz wi cz 1z
      cli wceq wne wn w3a cv cdiv cuz a1i climcl 3ad2ant1 3ad2ant2 subcld simp3
      subne0d absrpcld rphalfcld eqidd simp1 climi simp2 rexanuz2 sylanbrc uzid
      c2 c0 nnz ne0i r19.2z ex 4syl simpr simpll abssubd breq1d cr simplr subcl
      adantr abscld abs3lem syl22anc ltnrd pm2.21d exp3a sylbid adantld expimpd
      syld impr rexlimdvw sylan9r rexlimdva syl2anc mpd 3expia necon4ad mpi ) C
      AUCFZCBUCFZGZHUAIZABUDUBXCXDABXAXBABUEZXDUFZXAXBXEUGZDUHZCJZKIZXIALMNJZAB
      LMZNJZVGUIMZOFZGZXJXIBLMNJXNOFZGZGZDEUHZUJJZPZEQRZXFXGXPDYAPEQRXRDYAPEQRY
      CXGAXIXNEDCHQSXDXGUBUKZXGXMXGXLXGABXAXBAKIZXEACULUMZXBXABKIZXEBCULUNZUOXG
      ABYFYHXAXBXEUPUQURUSZXGXHQIGXIUTZXAXBXEVAVBXGBXIXNEDCHQSYDYIYJXAXBXEVCVBX
      PXREDHQSVDVEXGYEYGYCXFTYFYHYEYGGZYBXFEQXTQIZYBXSDYARZYKXFYLXTUAIXTYAIYAVH
      UEZYBYMTXTVIXTVFYAXTVJYNYBYMXSDYAVKVLVMYKXSXFDYAYKXPXRXFYKXPGXQXFXJYKXJXO
      XQXFTZYKXJGZXOAXILMNJZXNOFZYOYPXKYQXNOYPXIAYKXJVNZYEYGXJVOZVPVQYPYRXQXFYP
      YRXQGZXMXMOFZXFYPYEYGXJXMVRIUUAUUBTYTYEYGXJVSYSYPXLYKXLKIXJABVTWAWBZABXIX
      MWCWDYPUUBXFYPXMUUCWEWFWKWGWHWLWIWJWMWNWOWPWQWRWSWT $.
  $}

  ${
    $d x y z $.
    $( The limit relation is function-like, and with range the complex
       numbers.  (Contributed by Mario Carneiro, 31-Jan-2014.) $)
    fclim $p |- ~~> : dom ~~> --> CC $=
      ( vx vy vz cli cdm cc wf wfn crn wss wfun wrel cv wbr wa weq wal mpbir2an
      ax-gen wcel climrel climuni dffun2 funfn mpbi wex vex elrn climcl exlimiv
      wi sylbi ssriv df-f ) DEZFDGDUOHZDIZFJDKZUPURDLAMZBMZDNZUSCMZDNOBCPUKZCQZ
      BQZAQUAVEAVDBVCCUTVBUSUBSSSABCDUCRDUDUEBUQFUTUQTVAAUFUTFTZAUTDBUGUHVAVFAU
      TUSUIUJULUMUOFDUNR $.
  $}

  $( Two ways to express that a function has a limit.  (The expression
     ` ( ~~> `` F ) ` is sometimes useful as a shorthand for "the unique limit
     of the function ` F ` ").  (Contributed by Mario Carneiro,
     18-Mar-2014.) $)
  climdm $p |- ( F e. dom ~~> <-> F ~~> ( ~~> ` F ) ) $=
    ( cli cdm cc wf wfun wcel cfv wbr wb fclim ffun funfvbrb mp2b ) BCZDBEBFAOG
    AABHBIJKODBLABMN $.

  ${
    $d y A $.  $d x y F $.
    $( An infinite sequence of complex numbers converges to at most one limit.
       (Contributed by NM, 25-Dec-2005.) $)
    climeu $p |- ( F ~~> A -> E! x F ~~> x ) $=
      ( vy cli wbr cv wex wa weq wi wal weu wcel climcl breq2 spcegv mpcom nfv
      cc climuni gen2 jctir cbveu eu4 bitri sylibr ) CBEFZCDGZEFZDHZUJCAGZEFZID
      AJKZALDLZIZUMAMZUHUKUOBTNUHUKBCOUJUHDBTUIBCEPQRUNDAUIULCUAUBUCUQUJDMUPUMU
      JADUMDSUJASULUICEPUDUJUMDAUIULCEPUEUFUG $.

    $( An infinite sequence of complex numbers converges to at most one limit.
       (Contributed by NM, 25-Dec-2005.) $)
    climreu $p |- ( F ~~> A -> E! x e. CC F ~~> x ) $=
      ( cli wbr cv weu cc wreu climeu climcl pm4.71ri eubii df-reu bitr4i sylib
      wcel wa ) CBDECAFZDEZAGZTAHIZABCJUASHQZTRZAGUBTUDATUCSCKLMTAHNOP $.

    $( An infinite sequence of complex numbers converges to at most one limit.
       (Contributed by Mario Carneiro, 13-Jul-2013.) $)
    climmo $p |- E* x F ~~> x $=
      ( vy cv cli wbr wmo wex weu breq2 cbvexv climeu exlimiv sylbi df-mo mpbir
      wi ) BADZEFZAGSAHZSAIZQTBCDZEFZCHUASUCACRUBBEJKUCUACAUBBLMNSAOP $.
  $}

  ${
    $d m x y z A $.  $d x y z B $.  $d m x y z F $.  $d x y z V $.
    $( The restriction of a function converges if the original converges.
       (Contributed by Mario Carneiro, 16-Sep-2014.) $)
    rlimres $p |- ( F ~~>r A -> ( F |` B ) ~~>r A ) $=
      ( vy vz vx crli wbr cres cc wcel cv cfv wi wral cr wrex crp wa wf cmin co
      cle cabs clt cdm cin inss1 ssralv ax-mp reximi ralimi anim2i rlimf rlimss
      wss a1i eqidd rlim fssres sylancl resres wfn wceq fnresdm reseq1d syl5eqr
      ffn 3syl feq1d mpbid syl5ss inss2 sseli fvres syl adantl 3imtr4d pm2.43i
      ) CAGHZCBIZAGHZVTAJKZDLELZUCHWDCMZAUAUBUDMFLUEHNZECUFZOZDPQZFROZSZWCWFEWG
      BUGZOZDPQZFROZSZVTWBWKWPNVTWJWOWCWIWNFRWHWMDPWLWGUPZWHWMNWGBUHZWFEWLWGUIU
      JUKULUMUQVTFDEWGWEACACUNZACUOZVTWDWGKSWEURUSVTFDEWLWEAWAVTWLJCWLIZTZWLJWA
      TVTWGJCTZWQXBWSWRWGJWLCUTVAVTWLJXAWAVTXACWGIZBIWACWGBVBVTXDCBVTXCCWGVCXDC
      VDWSWGJCVHWGCVEVIVFVGVJVKVTWLWGPWRWTVLWDWLKZWDWAMWEVDZVTXEWDBKXFWLBWDWGBV
      MVNWDBCVOVPVQUSVRVS $.

    $( The restriction of an eventually upper bounded function is eventually
       upper bounded.  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    lo1res $p |- ( F e. <_O(1) -> ( F |` A ) e. <_O(1) ) $=
      ( vx vy vm clo1 wcel cres cv cle wbr cfv wi wral cr wrex wf wss wceq syl
      cdm lo1f lo1bdd mpdan inss1 ssralv ax-mp inss2 sseli fvres breq1d ralbiia
      cin imbi2d sylibr reximi wb fssres sylancl resres wfn ffn fnresdm reseq1d
      3syl syl5eqr feq1d mpbid lo1dm syl5ss ello12 syl2anc mpbird ) BFGZBAHZFGZ
      CIDIZJKZVQVOLZEIZJKZMZDBUAZAUMZNZEOPZCOPZVNVRVQBLZVTJKZMZDWCNZEOPZCOPZWGV
      NWCOBQZWMBUBZCDWCEBUCUDWLWFCOWKWEEOWKWJDWDNZWEWDWCRZWKWPMWCAUEZWJDWDWCUFU
      GWBWJDWDVQWDGZWAWIVRWSVSWHVTJWSVQAGVSWHSWDAVQWCAUHUIVQABUJTUKUNULUOUPUPTV
      NWDOVOQZWDORVPWGUQVNWDOBWDHZQZWTVNWNWQXBWOWRWCOWDBURUSVNWDOXAVOVNXABWCHZA
      HVOBWCAUTVNXCBAVNWNBWCVAXCBSWOWCOBVBWCBVCVEVDVFVGVHVNWDWCOWRBVIVJCDWDEVOV
      KVLVM $.

    $( The restriction of an eventually bounded function is eventually
       bounded.  (Contributed by Mario Carneiro, 15-Sep-2014.)  (Proof
       shortened by Mario Carneiro, 26-May-2016.) $)
    o1res $p |- ( F e. O(1) -> ( F |` A ) e. O(1) ) $=
      ( co1 wcel cres cabs ccom clo1 resco cdm cc wf wb o1f lo1o1 syl syl5eqelr
      ibi lo1res cin fresin 3syl mpbird ) BCDZBAEZCDZFUEGZHDZUDUGFBGZAEZHFBAIUD
      UIHDZUJHDUDUKUDBJZKBLZUDUKMBNZULBOPRAUISPQUDUMULATZKUELUFUHMUNULKBAUAUOUE
      OUBUC $.
  $}

  ${
    $d x A $.  $d x B $.
    rlimres2.1 $e |- ( ph -> A C_ B ) $.
    ${
      rlimres2.2 $e |- ( ph -> ( x e. B |-> C ) ~~>r D ) $.
      $( The restriction of a function converges if the original converges.
         (Contributed by Mario Carneiro, 16-Sep-2014.) $)
      rlimres2 $p |- ( ph -> ( x e. A |-> C ) ~~>r D ) $=
        ( cmpt cres crli wss wceq resmpt syl wbr rlimres eqbrtrrd ) ABDEIZCJZBC
        EIZFKACDLTUAMGBDCENOASFKPTFKPHFCSQOR $.
    $}

    ${
      lo1res2.2 $e |- ( ph -> ( x e. B |-> C ) e. <_O(1) ) $.
      $( The restriction of a function is eventually bounded if the original
         is.  (Contributed by Mario Carneiro, 26-May-2016.) $)
      lo1res2 $p |- ( ph -> ( x e. A |-> C ) e. <_O(1) ) $=
        ( cmpt cres clo1 wss wceq resmpt syl wcel lo1res eqeltrrd ) ABDEHZCIZBC
        EHZJACDKSTLFBDCEMNARJOSJOGCRPNQ $.
    $}

    ${
      o1res2.2 $e |- ( ph -> ( x e. B |-> C ) e. O(1) ) $.
      $( The restriction of a function is eventually bounded if the original
         is.  (Contributed by Mario Carneiro, 21-May-2016.) $)
      o1res2 $p |- ( ph -> ( x e. A |-> C ) e. O(1) ) $=
        ( cmpt cres co1 wss wceq resmpt syl wcel o1res eqeltrrd ) ABDEHZCIZBCEH
        ZJACDKSTLFBDCEMNARJOSJOGCRPNQ $.
    $}
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z F $.  $d x y z ph $.
    lo1resb.1 $e |- ( ph -> F : A --> RR ) $.
    lo1resb.2 $e |- ( ph -> A C_ RR ) $.
    lo1resb.3 $e |- ( ph -> B e. RR ) $.
    $( The restriction of a function to an unbounded-above interval is
       eventually upper bounded iff the original is eventually upper bounded.
       (Contributed by Mario Carneiro, 26-May-2016.) $)
    lo1resb $p |- ( ph ->
      ( F e. <_O(1) <-> ( F |` ( B [,) +oo ) ) e. <_O(1) ) ) $=
      ( vx vy vz clo1 wcel cv cr cle wbr wi wa adantr sylbid cpnf cico cres cin
      co lo1res cfv cmpt feqmptd reseq1d resmpt3 syl6eq eleq1d wral wrex syl5ss
      inss1 sseli ffvelrn syl2an ello1mpt cif elin imbi1i impexp bitri ad2antrr
      wf wss sselda elicopnf baibd syl2anc anbi1d simplrl syl3anc bitr4d imbi1d
      maxle syl5bbr pm5.74da syl5bb ralbidv2 simprl ifcl simprr 3expia syl22anc
      wb ello12r rexlimdvva impbid2 ) ADKLZDCUAUBUEZUCZKLZWNDUFAWPHBWNUDZHMZDUG
      ZUHZKLZWMAWOWTKAWOHBWSUHZWNUCWTADXBWNAHBNDEUIUJHBWNWSUKULUMAXAIMZWROPZWSJ
      MZOPZQZHWQUNZJNUOINUOWMAHIWQWSJAWQBNBWNUQZFUPABNDVHZWRBLZWSNLWRWQLZEWQBWR
      XIURBNWRDUSUTVAAXHWMIJNNAXCNLZXENLZRZRZXHCXCOPZXCCVBZWROPZXFQZHBUNZWMXPXG
      XTHWQBXLXGQZXKWRWNLZXGQZQZXPXKXTQYBXKYCRZXGQYEXLYFXGWRBWNVCVDXKYCXGVEVFXP
      XKYDXTYDYCXDRZXFQXPXKRZXTYCXDXFVEYHYGXSXFYHYGCWROPZXDRZXSYHYCYIXDYHCNLZWR
      NLZYCYIWIAYKXOXKGVGZXPBNWRABNVIZXOFSZVJZYKYCYLYICWRVKVLVMVNYHYKXMYLXSYJWI
      YMAXMXNXKVOYPCXCWRVSVPVQVRVTWAWBWCXPXJYNXRNLZXNYAWMQAXJXOESYOXPXMYKYQAXMX
      NWDAYKXOGSXQXCCNWEVMAXMXNWFXJYNRYQXNRYAWMHBXRDXEWJWGWHTWKTTWL $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z F $.  $d x y z ph $.
    rlimresb.1 $e |- ( ph -> F : A --> CC ) $.
    rlimresb.2 $e |- ( ph -> A C_ RR ) $.
    rlimresb.3 $e |- ( ph -> B e. RR ) $.
    $( The restriction of a function to an unbounded-above interval converges
       iff the original converges.  (Contributed by Mario Carneiro,
       16-Sep-2014.) $)
    rlimresb $p |- ( ph -> ( F ~~>r C <-> ( F |` ( B [,) +oo ) ) ~~>r C ) ) $=
      ( vx vz vy crli wbr cc wcel wi wa wral cr adantr cv cfv cmpt cpnf cico co
      cin cres rlimcl a1i wb cle cmin cabs clt wrex crp simprrl sseldd elicopnf
      wss biimpa adantrr simpld simprd simprrr letrd mpbir2and anassrs pm5.74da
      syl biimt bi2.04 syl6bb elin imbi1i impexp bitri syl6bbr ralbidv2 ralbidv
      rexbidva ffvelrnda ralrimiva simpr rlim3 inss1 sylan2 syl5ss ex pm5.21ndd
      3bitr4d feqmptd breq1d resres wf wfn wceq ffn fnresdm 3syl reseq1d resmpt
      sseli ax-mp syl6eq 3eqtr3a ) AIBIUAZEUBZUCZDLMZIBCUDUEUFZUGZXIUCZDLMZEDLM
      EXLUHZDLMADNOZXKXOXKXQPADXJUIUJXOXQPADXNUIUJAXQXKXOUKAXQQZJUAZXHULMZXIDUM
      UFUNUBKUAUOMZPZIBRZJXLUPZKUQRZYBIXMRZJXLUPZKUQRZXKXOAYEYHUKXQAYDYGKUQAYCY
      FJXLAXSXLOZQZYBYBIBXMYJXHBOZYBPYKXHXLOZYBPZPZXHXMOZYBPZYJYKYBYMYJYKQZYBXT
      YLYAPZPYMYQXTYAYRYQXTQYLYAYRUKYJYKXTYLAYIYKXTQZYLAYIYSQZQZYLXHSOZCXHULMZU
      UABSXHABSVAZYTGTAYIYKXTURUSZUUACXSXHACSOZYTHTZUUAXSSOZCXSULMZAYIUUHUUIQZY
      SAYIUUJAUUFYIUUJUKHCXSUTVKVBVCZVDUUEUUAUUHUUIUUKVEAYIYKXTVFVGUUAUUFYLUUBU
      UCQUKUUGCXHUTVKVHVIVIYLYAVLVKVJXTYLYAVMVNVJYPYKYLQZYBPYNYOUULYBXHBXLVOVPY
      KYLYBVQVRVSVTWBWATXRKJIBXIDCAXINOZIBRXQAUUMIBABNXHEFWCZWDTAUUDXQGTAXQWEZA
      UUFXQHTZWFXRKJIXMXIDCAUUMIXMRXQAUUMIXMYOAYKUUMXMBXHBXLWGZXDUUNWHWDTAXMSVA
      XQAXMBSUUQGWITUUOUUPWFWLWJWKAEXJDLAIBNEFWMZWNAXPXNDLAEBUHZXLUHEXMUHZXPXNE
      BXLWOAUUSEXLABNEWPEBWQUUSEWRFBNEWSBEWTXAXBAUUTXJXMUHZXNAEXJXMUURXBXMBVAUV
      AXNWRUUQIBXMXIXCXEXFXGWNWL $.

    $( The restriction of a function to an unbounded-above interval is
       eventually bounded iff the original is eventually bounded.  (Contributed
       by Mario Carneiro, 9-Apr-2016.) $)
    o1resb $p |- ( ph -> ( F e. O(1) <-> ( F |` ( B [,) +oo ) ) e. O(1) ) ) $=
      ( vx vy vz co1 wcel cv cc cle wbr wi cr wa adantr cpnf cico co cres o1res
      cin cfv cmpt feqmptd reseq1d resmpt3 syl6eq eleq1d cabs wral inss1 syl5ss
      wrex wf sseli ffvelrn syl2an elo1mpt elin imbi1i impexp bitri wb ad2antrr
      cif wss sselda elicopnf baibd syl2anc anbi1d simplrl maxle syl3anc bitr4d
      imbi1d pm5.74da syl5bb ralbidv2 simprl ifcl simprr elo12r 3expia syl22anc
      syl5bbr sylbid rexlimdvva impbid2 ) ADKLZDCUAUBUCZUDZKLZWPDUEAWRHBWPUFZHM
      ZDUGZUHZKLZWOAWQXBKAWQHBXAUHZWPUDXBADXDWPAHBNDEUIUJHBWPXAUKULUMAXCIMZWTOP
      ZXAUNUGJMZOPZQZHWSUOZJRURIRURWOAHIWSXAJAWSBRBWPUPZFUQABNDUSZWTBLZXANLWTWS
      LZEWSBWTXKUTBNWTDVAVBVCAXJWOIJRRAXERLZXGRLZSZSZXJCXEOPZXECVJZWTOPZXHQZHBU
      OZWOXRXIYBHWSBXNXIQZXMWTWPLZXIQZQZXRXMYBQYDXMYESZXIQYGXNYHXIWTBWPVDVEXMYE
      XIVFVGXRXMYFYBYFYEXFSZXHQXRXMSZYBYEXFXHVFYJYIYAXHYJYICWTOPZXFSZYAYJYEYKXF
      YJCRLZWTRLZYEYKVHAYMXQXMGVIZXRBRWTABRVKZXQFTZVLZYMYEYNYKCWTVMVNVOVPYJYMXO
      YNYAYLVHYOAXOXPXMVQYRCXEWTVRVSVTWAWKWBWCWDXRXLYPXTRLZXPYCWOQAXLXQETYQXRXO
      YMYSAXOXPWEAYMXQGTXSXECRWFVOAXOXPWGXLYPSYSXPSYCWOHBXTDXGWHWIWJWLWMWLWLWN
      $.
  $}

  ${
    $d k x y A $.  $d k x y F $.  $d k x y G $.  $d k x y ph $.  $d k y Z $.
    $d y M $.
    climeq.1 $e |- Z = ( ZZ>= ` M ) $.
    climeq.2 $e |- ( ph -> F e. V ) $.
    climeq.3 $e |- ( ph -> G e. W ) $.
    climeq.5 $e |- ( ph -> M e. ZZ ) $.
    climeq.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = ( G ` k ) ) $.
    $( Two functions that are eventually equal to one another have the same
       limit.  (Contributed by Mario Carneiro, 5-Nov-2013.)  (Revised by Mario
       Carneiro, 31-Jan-2014.) $)
    climeq $p |- ( ph -> ( F ~~> A <-> G ~~> A ) ) $=
      ( vx vy wbr wcel cv cfv cli cc cmin co cabs clt cuz wral wrex clim2 eqidd
      wa crp bitr4d ) ADBUAQBUBRCSZETZUBRUPBUCUDUETOSUFQULCPSUGTUHPIUIOUMUHULEB
      UAQAOBUPPCDFGIJMKNUJAOBUPPCEFHIJMLAUOIRULUPUKUJUN $.
  $}

  ${
    $d x A $.  $d x D $.  $d x ph $.
    lo1eq.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    lo1eq.2 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    lo1eq.3 $e |- ( ph -> D e. RR ) $.
    lo1eq.4 $e |- ( ( ph /\ ( x e. A /\ D <_ x ) ) -> B = C ) $.
    $( Two functions that are eventually equal to one another are eventually
       bounded if one of them is.  (Contributed by Mario Carneiro,
       26-May-2016.) $)
    lo1eq $p |- ( ph ->
      ( ( x e. A |-> B ) e. <_O(1) <-> ( x e. A |-> C ) e. <_O(1) ) ) $=
      ( cr wss cmpt clo1 wcel wceq wa cres resmpt adantr cdm lo1dm wf fmptd fdm
      eqid syl sseq1d syl5ib wb cpnf cico co cin cv cle simpr elin sylib simpld
      wbr simprd elicopnf biimpa syldan jca mpteq2dva inss1 3eqtr4g resres ssid
      ax-mp reseq1 mp2b 3eqtr3g eleq1d lo1resb 3bitr4d ex pm5.21ndd ) ACKLZBCDM
      ZNOZBCEMZNOZWCWBUAZKLAWAWBUBAWFCKACKWBUCZWFCPABCDKWBGWBUFUDZCKWBUEUGUHUIW
      EWDUAZKLAWAWDUBAWICKACKWDUCZWICPABCEKWDHWDUFUDZCKWDUEUGUHUIAWAWCWEUJAWAQZ
      WBFUKULUMZRZNOZWDWMRZNOZWCWEAWOWQUJWAAWNWPNAWBCRZWMRZWDCRZWMRZWNWPAWBCWMU
      NZRZWDXBRZWSXAABXBDMZBXBEMZXCXDABXBDEABUOZXBOZXGCOZFXGUPVAZQDEPAXHQZXIXJX
      KXIXGWMOZXKXHXIXLQAXHUQXGCWMURUSZUTXKXGKOZXJAXHXLXNXJQZXKXIXLXMVBAXLXOAFK
      OZXLXOUJIFXGVCUGVDVEVBVFJVEVGXBCLZXCXEPCWMVHZBCXBDSVLXQXDXFPXRBCXBESVLVIW
      BCWMVJWDCWMVJVICCLZWRWBPWSWNPCVKZBCCDSWRWBWMVMVNXSWTWDPXAWPPXTBCCESWTWDWM
      VMVNVOVPTWLCFWBAWGWAWHTAWAUQZAXPWAITZVQWLCFWDAWJWAWKTYAYBVQVRVSVT $.
  $}

  ${
    $d x A $.  $d x D $.  $d x ph $.
    rlimeq.1 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    rlimeq.2 $e |- ( ( ph /\ x e. A ) -> C e. CC ) $.
    rlimeq.3 $e |- ( ph -> D e. RR ) $.
    rlimeq.4 $e |- ( ( ph /\ ( x e. A /\ D <_ x ) ) -> B = C ) $.
    $( Two functions that are eventually equal to one another have the same
       limit.  (Contributed by Mario Carneiro, 16-Sep-2014.) $)
    rlimeq $p |- ( ph ->
      ( ( x e. A |-> B ) ~~>r E <-> ( x e. A |-> C ) ~~>r E ) ) $=
      ( cr wss crli wbr cc wceq wa cres wcel cmpt cdm rlimss eqid fmptd fdm syl
      wf sseq1d syl5ib wb cpnf cico co cin cle simpr elin sylib simpld elicopnf
      simprd biimpa syldan jca mpteq2dva inss1 resmpt ax-mp 3eqtr4g resres ssid
      cv reseq1 mp2b 3eqtr3g breq1d adantr rlimresb 3bitr4d ex pm5.21ndd ) ACLM
      ZBCDUAZGNOZBCEUAZGNOZWEWDUBZLMAWCGWDUCAWHCLACPWDUHZWHCQABCDPWDHWDUDUEZCPW
      DUFUGUIUJWGWFUBZLMAWCGWFUCAWKCLACPWFUHZWKCQABCEPWFIWFUDUEZCPWFUFUGUIUJAWC
      WEWGUKAWCRZWDFULUMUNZSZGNOZWFWOSZGNOZWEWGAWQWSUKWCAWPWRGNAWDCSZWOSZWFCSZW
      OSZWPWRAWDCWOUOZSZWFXDSZXAXCABXDDUAZBXDEUAZXEXFABXDDEABVMZXDTZXICTZFXIUPO
      ZRDEQAXJRZXKXLXMXKXIWOTZXMXJXKXNRAXJUQXICWOURUSZUTXMXILTZXLAXJXNXPXLRZXMX
      KXNXOVBAXNXQAFLTZXNXQUKJFXIVAUGVCVDVBVEKVDVFXDCMZXEXGQCWOVGZBCXDDVHVIXSXF
      XHQXTBCXDEVHVIVJWDCWOVKWFCWOVKVJCCMZWTWDQXAWPQCVLZBCCDVHWTWDWOVNVOYAXBWFQ
      XCWRQYBBCCEVHXBWFWOVNVOVPVQVRWNCFGWDAWIWCWJVRAWCUQZAXRWCJVRZVSWNCFGWFAWLW
      CWMVRYCYDVSVTWAWB $.

    $( Two functions that are eventually equal to one another are eventually
       bounded if one of them is.  (Contributed by Mario Carneiro,
       26-May-2016.) $)
    o1eq $p |- ( ph ->
      ( ( x e. A |-> B ) e. O(1) <-> ( x e. A |-> C ) e. O(1) ) ) $=
      ( cabs cfv cmpt clo1 wcel co1 cv wa abscld lo1o12 cle wbr fveq2d 3bitr4d
      lo1eq ) ABCDKLZMNOBCEKLZMNOBCDMPOBCEMPOABCUFUGFABQZCOZRZDGSUJEHSIAUIFUHUA
      UBRRDEKJUCUEABCDGTABCEHTUD $.
  $}

  ${
    $d j k m y A $.  $d j k m x F $.  $d j m x y G $.  $d j m M $.  $d m V $.
    $d j k y ph $.  $d m W $.  $d j k m x Z $.
    2clim.1 $e |- Z = ( ZZ>= ` M ) $.
    ${
      climmpt.2 $e |- G = ( k e. Z |-> ( F ` k ) ) $.
      $( Exhibit a function ` G ` with the same convergence properties as the
         not-quite-function ` F ` .  (Contributed by Mario Carneiro,
         31-Jan-2014.) $)
      climmpt $p |- ( ( M e. ZZ /\ F e. V ) ->
                      ( F ~~> A <-> G ~~> A ) ) $=
        ( vm cz wcel wa cvv simpr cv cfv cuz fvex eqeltri cmpt mptex simpl wceq
        a1i fveq2 fvmpt eqcomd adantl climeq ) EKLZCFLZMZAJCDEFNGHUKULODNLUMDBG
        BPZCQZUANIBGUOGERQNHERSTUBTUEUKULUCJPZGLZUPCQZUPDQZUDUMUQUSURBUPUOURGDU
        NUPCUFIUPCSUGUHUIUJ $.
    $}

    $d k G $.
    2clim.2 $e |- ( ph -> M e. ZZ ) $.
    2clim.3 $e |- ( ph -> G e. V ) $.
    2clim.5 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
    2clim.6 $e |- ( ph -> A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
                    ( abs ` ( ( F ` k ) - ( G ` k ) ) ) < x ) $.
    2clim.7 $e |- ( ph -> F ~~> A ) $.
    $( If two sequences converge to each other, they converge to the same
       limit.  (Contributed by NM, 24-Dec-2005.)  (Proof shortened by Mario
       Carneiro, 31-Jan-2014.) $)
    2clim $p |- ( ph -> G ~~> A ) $=
      ( wbr cfv wcel wa vy cli cv cmin co cabs clt cuz wral wrex crp c2 cdiv cc
      rphalfcl wceq breq2 rexralbidv rspccva syl2an adantr eqidd climi rexanuz2
      cz adantl sylanbrc wi uztrn2 simprr ad2ant2r abssubd breq1d anbi1d climcl
      an12 cr syl ad2antrr rpre ad2antlr abs3lem syl22anc sylbid anassrs syl5bi
      expimpd sylan2 ralimdva reximdva mpd ralrimiva clim2c mpbird ) AGCUBQEUCZ
      GRZCUDUEUFRUAUCZUGQZEDUCZUHRZUIZDJUJZUAUKUIAXBUAUKAWQUKSZTZWOFRZWPUDUEUFR
      ZWQULUMUEZUGQZXEUNSZXECUDUEUFRXGUGQZTZTZEWTUIZDJUJZXBXDXHEWTUIDJUJZXKEWTU
      IDJUJXNAXFBUCZUGQZEWTUIDJUJZBUKUIXGUKSZXOXCOWQUOZXRXOBXGUKXPXGUPXQXHDEJWT
      XPXGXFUGUQURUSUTXDCXEXGDEFHJKAHVESXCLVAXCXSAXTVFXDWOJSZTZXEVBAFCUBQZXCPVA
      VCXHXKDEHJKVDVGXDXMXADJXDWSJSZTXLWREWTXDYDWOWTSZXLWRVHZYDYETXDYAYFHWOWSJK
      VIXLXIXHXJTZTYBWRXHXIXJVPYBXIYGWRXDYAXIYGWRVHXDYAXITZTZYGWPXEUDUEUFRZXGUG
      QZXJTZWRYIXHYKXJYIXFYJXGUGYIXEWPXDYAXIVJZAYAWPUNSZXCXINVKZVLVMVNYIYNCUNSZ
      XIWQVQSZYLWRVHYOAYPXCYHAYCYPPCFVOVRZVSYMXCYQAYHWQVTWAWPCXEWQWBWCWDWEWGWFW
      HWEWIWJWKWLAUACWPDEGHIJKLMAYATWPVBYRNWMWN $.
  $}

  ${
    $d k m F $.  $d k m Z $.  $d k ph $.  $d m n F $.  $d n A $.  $d n Z $.
    $d n ph $.
    climmpt2.1 $e |- Z = ( ZZ>= ` M ) $.
    climmpt2.2 $e |- ( ph -> M e. ZZ ) $.
    climmpt2.3 $e |- ( ph -> F e. V ) $.
    climmpt2.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( Relate an integer limit on a not-quite-function to a real limit.
       (Contributed by Mario Carneiro, 17-Sep-2014.) $)
    climmpt2 $p |- ( ph ->
                    ( F ~~> A <-> ( n e. Z |-> ( F ` n ) ) ~~>r A ) ) $=
      ( vm cli wbr cv cfv wcel cc wral cmpt crli eqid climmpt syl2anc ralrimiva
      cz wb weq fveq2 eleq1d cbvralv bitri sylib r19.21bi fmptd rlimclim bitr4d
      ) AEBNOZDHDPZEQZUAZBNOZVBBUBOAFUGREGRUSVCUHJKBDEVBFGHIVBUCZUDUEABVBFHIJAD
      HVASVBAVASRZDHACPZEQZSRZCHTZVEDHTZAVHCHLUFVIMPZEQZSRZMHTVJVHVMCMHCMUIVGVL
      SVFVKEUJUKULVMVEMDHMDUIVLVASVKUTEUJUKULUMUNUOVDUPUQUR $.
  $}

  ${
    $d f k m n x A $.  $d f k m n x F $.  $d f k m n x M $.  $d k m n x V $.
    $d f k W $.
    ${
      climshft.1 $e |- F e. _V $.
      $( A shifted function converges if the original function converges.
         (Contributed by Mario Carneiro, 5-Nov-2013.) $)
      climshftlem $p |- ( M e. ZZ ->
                          ( F ~~> A -> ( F shift M ) ~~> A ) ) $=
        ( vm vx vk vn cz wcel cc cv cfv cmin co cabs clt wbr wa wral wrex caddc
        cuz crp cshi cli zaddcl ancoms eluzsub 3com12 3expa fveq2 eleq1d oveq1d
        wi wceq fveq2d breq1d anbi12d rspcv syl zcn eluzelz zcnd shftval syl2an
        wb adantlr sylibrd ralrimdva raleqdv rspcev ee12an rexlimdva anim2d cvv
        ralimdv a1i eqidd clim ovex 3imtr4d ) CIJZAKJZELZBMZKJZWFANOZPMZFLZQRZS
        ZEGLZUCMZTZGIUAZFUDTZSWDHLZBCUEOZMZKJZWTANOZPMZWJQRZSZHWEUCMZTZEIUAZFUD
        TZSBAUFRWSAUFRWCWQXIWDWCWPXHFUDWCWOXHGIWCWMIJZSZWMCUBOZIJZWOXEHXLUCMZTZ
        XHXJWCXMWMCUGUHXKWOXEHXNXKWRXNJZSZWOWRCNOZBMZKJZXSANOZPMZWJQRZSZXEXQXRW
        NJZWOYDUOWCXJXPYEXJWCXPYECWMWRUIUJUKWLYDEXRWNWEXRUPZWGXTWKYCYFWFXSKWEXR
        BULZUMYFWIYBWJQYFWHYAPYFWFXSANYGUNUQURUSUTVAWCXPXEYDVGZXJWCCKJZWRKJZYHX
        PCVBXPWRXLWRVCVDYIYJSZXAXTXDYCYKWTXSKCWRBDVEZUMYKXCYBWJQYKXBYAPYKWTXSAN
        YLUNUQURUSVFVHVIVJXGXOEXLIWEXLUPXEHXFXNWEXLUCULVKVLVMVNVQVOWCFAWFGEBVPB
        VPJWCDVRWCWEIJSWFVSVTWCFAWTEHWSVPWSVPJWCBCUEWAVRWCWRIJSWTVSVTWB $.
    $}

    $( A function restricted to upper integers converges iff the original
       function converges.  (Contributed by Mario Carneiro, 13-Jul-2013.)
       (Revised by Mario Carneiro, 31-Jan-2014.) $)
    climres $p |- ( ( M e. ZZ /\ F e. V ) ->
                        ( ( F |` ( ZZ>= ` M ) ) ~~> A <-> F ~~> A ) ) $=
      ( vk cz wcel wa cuz cfv cres eqid resexg adantl simpr simpl cv wceq fvres
      cvv climeq ) CFGZBDGZHZAEBCIJZKZBCTDUEUELUCUFTGUBBUEDMNUBUCOUBUCPEQZUEGUG
      UFJUGBJRUDUGUEBSNUA $.

    $( A shifted function converges iff the original function converges.
       (Contributed by NM, 16-Aug-2005.)  (Revised by Mario Carneiro,
       31-Jan-2014.) $)
    climshft $p |- ( ( M e. ZZ /\ F e. V ) ->
                      ( ( F shift M ) ~~> A <-> F ~~> A ) ) $=
      ( vf vk wcel cz cshi co cli wbr wb cv wi wceq ovex climshftlem cvv cfv id
      oveq1 breq1d breq1 bibi12d imbi2d cneg znegcl syl cuz eqid a1i vex cc zcn
      eluzelz zcnd shftcan1 syl2an climeq sylibd impbid vtoclg impcom ) BDGCHGZ
      BCIJZAKLZBAKLZMZVEENZCIJZAKLZVJAKLZMZOVEVIOEBDVJBPZVNVIVEVOVLVGVMVHVOVKVF
      AKVJBCIUBUCVJBAKUDUEUFVEVLVMVEVLVKCUGZIJZAKLZVMVEVPHGVLVROCUHAVKVPVJCIQRU
      IVEAFVQVJCSSCUJTZVSUKVQSGVEVKVPIQULVJSGVEEUMZULVEUAVECUNGFNZUNGWAVQTWAVJT
      PWAVSGZCUOWBWACWAUPUQCWAVJVTURUSUTVAAVJCVTRVBVCVD $.
  $}

  ${
    $d k M $.
    $( The zero series converges to zero.  (Contributed by Paul Chapman,
       9-Feb-2008.)  (Proof shortened by Mario Carneiro, 31-Jan-2014.) $)
    serclim0 $p |- ( M e. ZZ ->
                      seq M ( + , ( ( ZZ>= ` M ) X. { 0 } ) ) ~~> 0 ) $=
      ( cz wcel caddc cuz cfv cc0 csn cxp cseq cli eqid ser0f wbr 0cn ssid fvex
      cc climconst2 mpan eqbrtrd ) ABCZDAEFZGHIZAJUDGKAUCUCLMGRCUBUDGKNOGAUCUCP
      AEQSTUA $.
  $}

  ${
    $d r x y z A $.  $d r w y z B $.  $d r w x y z C $.  $d r x y z ph $.
    $d r x y z D $.  $d r x z R $.
    rlimcld2.1 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    rlimcld2.2 $e |- ( ph -> ( x e. A |-> B ) ~~>r C ) $.
    ${
      rlimcld2.3 $e |- ( ph -> D C_ CC ) $.
      rlimcld2.4 $e |- ( ( ph /\ y e. ( CC \ D ) ) -> R e. RR+ ) $.
      rlimcld2.5 $e |- ( ( ( ph /\ y e. ( CC \ D ) ) /\ z e. D ) ->
        R <_ ( abs ` ( z - y ) ) ) $.
      rlimcld2.6 $e |- ( ( ph /\ x e. A ) -> B e. D ) $.
      $( If ` D ` is a closed set in the topology of the complexes (stated here
         in basic form), and all the elements of the sequence lie in ` D ` ,
         then the limit of the sequence also lies in ` D ` .  (Contributed by
         Mario Carneiro, 10-May-2016.) $)
      rlimcld2 $p |- ( ph -> C e. D ) $=
        ( vr wcel cle wral cr cv wbr cmin co cabs cfv csb clt wi wrex ralrimiva
        wn wa adantr cc cdif crp cmpt crli rlimcl syl simpr eldifd nfcsb1v wceq
        nfel1 csbeq1a eleq1d rspc sylc rlimi adantlr nfral oveq2 fveq2d breq12d
        nfcv nfbr ad2antrr oveq1 breq2d rspcv rpred wss ad3antrrr sseldd subcld
        ralbidv abscld lenltd mpbid id imp nsyl nrexdv cxr csup cpnf wb wf eqid
        cdm fmptd fdm rlimss eqsstr3d ressxr syl6ss mpbird r19.21bi r19.29 mtod
        supxrunb1 expcom condan ) AGHQZPUAZBUAZRUBZFGUCUDZUEUFZCGIUGZUHUBZUIZBE
        SZPTUJAXPULZUMZPBEFGYBHAFHQZBESYFAYHBEOUKUNYGGUOHUPZQZIUQQZCYISZYBUQQZY
        GGUOHYGBEFURZGUSUBZGUOQZAYOYFKUNZGYNUTVAZAYFVBVCZAYLYFAYKCYIMUKUNYKYMCG
        YICYBUQCGIVDZVFCUAZGVEZIYBUQCGIVGZVHVIVJZYQVKYGYEPTYGXQTQZUMZYEYDXSUMZB
        EUJZUUFUUGBEUUFXREQZUMZYCUUGUUJYBYARUBZYCULUUJYHYBDUAZGUCUDZUEUFZRUBZDH
        SZUUKYGUUIYHUUEAUUIYHYFOVLVLZYGUUPUUEUUIYGYJIUULUUAUCUDZUEUFZRUBZDHSZCY
        ISZUUPYSAUVBYFAUVACYIAUUAYIQUMUUTDHNUKUKUNUVAUUPCGYIUUOCDHCHVQCYBUUNRYT
        CRVQCUUNVQVRVMUUBUUTUUODHUUBIYBUUSUUNRUUCUUBUURUUMUEUUAGUULUCVNVOVPWHVI
        VJVSUUOUUKDFHUULFVEZUUNYAYBRUVCUUMXTUEUULFGUCVTVOWAWBVJUUJYBYAUUJYBYGYM
        UUEUUIUUDVSWCUUJXTUUJFGUUJHUOFAHUOWDYFUUEUUILWEUUQWFYGYPUUEUUIYRVSWGWIW
        JWKYDXSYCYDWLWMWNWOUUFXSBEUJZYEUUHUIYGUVDPTAUVDPTSZYFAUVEEWPUHWQWRVEZJA
        EWPWDUVEUVFWSAETWPAEYNXBZTAEHYNWTUVGEVEABEFHYNOYNXAXCEHYNXDVAAYOUVGTWDK
        GYNXEVAXFXGXHPBEXMVAXIUNXJYEUVDUUHYDXSBEXKXNVAXLWOXO $.
    $}

    ${
      rlimrege0.4 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
      rlimrege0.5 $e |- ( ( ph /\ x e. A ) -> 0 <_ ( Re ` B ) ) $.
      $( The limit of a sequence of complexes with nonnegative real part has
         nonnegative real part.  (Contributed by Mario Carneiro,
         10-May-2016.) $)
      rlimrege0 $p |- ( ph -> 0 <_ ( Re ` C ) ) $=
        ( vw cc0 cv cre cfv cle wbr cc wcel adantl wceq vy crab cneg wss ssrab2
        vz a1i cdif wa eldifi recld renegcld clt wn breq2d notbid notrab elrab2
        fveq2 simprbi cr wb ltnle sylancl mpbird lt0neg1d mpbid elrpd cmin cabs
        0re co adantr elrabi subcld abscld elrab lesub1dd df-neg resubd 3brtr4d
        releabsd letrd sylanbrc rlimcld2 syl ) AEKJLZMNZOPZJQUBZRZKEMNZOPZABUAU
        FCDEWJUALZMNZUCZFGWJQUDAWIJQUEUGAWNQWJUHZRZUIZWPWSWOWSWNWRWNQRZAWNQWJUJ
        SZUKZULZWSWOKUMPZKWPUMPWSXDKWOOPZUNZWRXFAWRWTXFWIUNXFJWNQWQWGWNTZWIXEXG
        WHWOKOWGWNMUSUOUPWIJQUQURUTSWSWOVARKVARZXDXFVBXBVKWOKVCVDVEWSWOXBVFVGVH
        WSUFLZWJRZUIZWPXIWNVIVLZMNZXLVJNWSWPVARXJXCVMXKXLXKXIWNXJXIQRZWSWIJXIQV
        NSZWSWTXJXAVMZVOZUKXKXLXQVPXKKWOVIVLZXIMNZWOVIVLWPXMOXKKXSWOXHXKVKUGXKX
        IXOUKXKWNXPUKXJKXSOPZWSXJXNXTWIXTJXIQWGXITWHXSKOWGXIMUSUOVQUTSVRWPXRTXK
        WOVSUGXKXIWNXOXPVTWAXKXLXQWBWCABLCRUIDQRKDMNZOPZDWJRHIWIYBJDQWGDTWHYAKO
        WGDMUSUOVQWDWEWKEQRWMWIWMJEQWGETWHWLKOWGEMUSUOVQUTWF $.
    $}

    rlimrecl.3 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    $( The limit of a real sequence is real.  (Contributed by Mario Carneiro,
       9-May-2016.) $)
    rlimrecl $p |- ( ph -> C e. RR ) $=
      ( vy vz cr cim cfv cabs cc wcel adantl cc0 cmin co wss ax-resscn a1i cdif
      cv wa eldifi imcld recnd wn wne eldifn wceq wb reim0b necon3bbid absrpcld
      syl mpbid cle wbr adantr simpr subcld absimle imsubd reim0 oveq2d subid1d
      3eqtrrd fveq2d abssubd 3brtr4d rlimcld2 ) ABIJCDEKIUEZLMZNMZFGKOUAAUBUCAV
      OOKUDPZUFZVPVSVPVSVOVRVOOPZAVOOKUGQZUHUIZVSVOKPZUJZVPRUKVRWDAVOOKULQVSWCV
      PRVSVTWCVPRUMUNWAVOUOURUPUSUQVSJUEZKPZUFZVOWESTZLMZNMZWHNMZVQWEVOSTNMUTWG
      WHOPWJWKUTVAWGVOWEVSVTWFWAVBZWGWEVSWFVCUIZVDWHVEURWGVPWINWGWIVPWELMZSTVPR
      STVPWGVOWEWLWMVFWGWNRVPSWFWNRUMVSWEVGQVHWGVPVSVPOPWFWBVBVIVJVKWGWEVOWMWLV
      LVMHVN $.

    rlimge0.4 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
    $( The limit of a sequence of nonnegative reals is nonnegative.
       (Contributed by Mario Carneiro, 10-May-2016.) $)
    rlimge0 $p |- ( ph -> 0 <_ C ) $=
      ( cc0 cre cfv cle cv wcel wa recnd rered breqtrrd rlimrege0 rlimrecl
      breqtrd ) AJEKLEMABCDEFGABNCOPZDHQUCJDDKLMIUCDHRSTAEABCDEFGHUARUB $.
  $}

  ${
    $d j k F $.  $d k G $.  $d k K $.  $d j k M $.  $d j k x ph $.  $d j k Z $.
    $d j k x A $.
    climshft2.1 $e |- Z = ( ZZ>= ` M ) $.
    climshft2.2 $e |- ( ph -> M e. ZZ ) $.
    ${
      climshft2.3 $e |- ( ph -> K e. ZZ ) $.
      climshft2.5 $e |- ( ph -> F e. W ) $.
      climshft2.6 $e |- ( ph -> G e. X ) $.
      climshft2.7 $e |- ( ( ph /\ k e. Z ) ->
                          ( G ` ( k + K ) ) = ( F ` k ) ) $.
      $( A shifted function converges iff the original function converges.
         (Contributed by Paul Chapman, 21-Nov-2007.)  (Revised by Mario
         Carneiro, 6-Feb-2014.) $)
      climshft2 $p |- ( ph -> ( F ~~> A <-> G ~~> A ) ) $=
        ( cshi co wcel cfv cneg cli wbr cvv ovex a1i cv wa caddc cid cc wceq cz
        zcnd cuz eluzelz eleq2s shftval4 syl2an fvi adantr oveq1d fveq1d addcom
        fvex syl fveq12d 3eqtr3d eqtrd climeq znegcld climshft syl2anc bitr3d
        wb ) AEFUAZQRZBUBUCZDBUBUCEBUBUCZABCVQDGUDHJKVQUDSAEVPQUEUFNLACUGZJSZUH
        ZVTVQTZVTFUIRZETZVTDTWBVTEUJTZVPQRZTZFVTUIRZWFTZWCWEAFUKSZVTUKSZWHWJULW
        AAFMUNZWAVTVTUMSVTGUOTJGVTUPKUQUNZFVTWFEUJVEURUSWBVTWGVQWBWFEVPQAWFEULZ
        WAAEISZWOOEIUTVFVAZVBVCWBWIWDWFEWQAWKWLWIWDULWAWMWNFVTVDUSVGVHPVIVJAVPU
        MSWPVRVSVOAFMVKOBEVPIVLVMVN $.
    $}

    climrecl.3 $e |- ( ph -> F ~~> A ) $.
    climrecl.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
    $( The limit of a convergent real sequence is real.  Corollary 12-2.5 of
       [Gleason] p. 172.  (Contributed by NM, 10-Sep-2005.)  (Proof shortened
       by Mario Carneiro, 10-May-2016.) $)
    climrecl $p |- ( ph -> A e. RR ) $=
      ( cv cfv cz wcel cxr clt syl wbr cli cvv csup cpnf wceq cmpt crli climrel
      uzsup wb brrelexi climmpt syl2anc mpbid cc wa recnd fmptd rlimclim mpbird
      eqid rlimrecl ) ACFCKZDLZBAEMNZFOPUAUBUCHEFGUGQACFVBUDZBUERVDBSRZADBSRZVE
      IAVCDTNZVFVEUHHAVFVGIDBSUFUIQBCDVDETFGVDUSZUJUKULABVDEFGHACFVBUMVDAVAFNUN
      VBJUOVHUPUQURJUT $.

    climge0.5 $e |- ( ( ph /\ k e. Z ) -> 0 <_ ( F ` k ) ) $.
    $( A nonnegative sequence converges to a nonnegative number.  (Contributed
       by NM, 11-Sep-2005.)  (Proof shortened by Mario Carneiro,
       10-May-2016.) $)
    climge0 $p |- ( ph -> 0 <_ A ) $=
      ( cv cfv cz wcel cxr syl wbr cli cvv clt csup cpnf wceq cmpt crli climrel
      uzsup wb brrelexi climmpt syl2anc mpbid cc wa recnd fmptd rlimclim mpbird
      eqid rlimge0 ) ACFCLZDMZBAENOZFPUAUBUCUDHEFGUHQACFVCUEZBUFRVEBSRZADBSRZVF
      IAVDDTOZVGVFUIHAVGVHIDBSUGUJQBCDVEETFGVEUTZUKULUMABVEEFGHACFVCUNVEAVBFOUO
      VCJUPVIUQURUSJKVA $.
  $}

  ${
    $d j k x F $.  $d j k x G $.  $d j M $.  $d j k x ph $.  $d j k Z $.
    climabs0.1 $e |- Z = ( ZZ>= ` M ) $.
    climabs0.2 $e |- ( ph -> M e. ZZ ) $.
    climabs0.3 $e |- ( ph -> F e. V ) $.
    climabs0.4 $e |- ( ph -> G e. W ) $.
    climabs0.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    climabs0.6 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = ( abs ` ( F ` k ) ) ) $.
    $( Convergence to zero of the absolute value is equivalent to convergence
       to zero.  (Contributed by NM, 8-Jul-2008.)  (Revised by Mario Carneiro,
       31-Jan-2014.) $)
    climabs0 $p |- ( ph -> ( F ~~> 0 <-> G ~~> 0 ) ) $=
      ( vx vj cfv wbr wral wcel cv cabs clt cuz wrex crp cc0 cli wa uztrn2 wceq
      wb cc absidm breq1d sylan2 anassrs ralbidva rexbidva ralbidv abscld recnd
      syl clim0c eqidd 3bitr4rd ) ABUAZCQZUBQZUBQZOUAZUCRZBPUAZUDQZSZPHUEZOUFSV
      IVKUCRZBVNSZPHUEZOUFSDUGUHRCUGUHRAVPVSOUFAVOVRPHAVMHTZUIVLVQBVNAVTVGVNTZV
      LVQULZVTWAUIAVGHTZWBEVGVMHIUJAWCUIZVJVIVKUCWDVHUMTVJVIUKMVHUNVCUOUPUQURUS
      UTAOVIPBDEGHIJLNWDVIWDVHMVAVBVDAOVHPBCEFHIJKWDVHVEMVDVF $.
  $}

  ${
    $d m n x y z A $.  $d m n x y z F $.  $d m n x y z G $.  $d m n x y ph $.
    $d m n x y B $.
    o1co.1 $e |- ( ph -> F : A --> CC ) $.
    o1co.2 $e |- ( ph -> F e. O(1) ) $.
    o1co.3 $e |- ( ph -> G : B --> A ) $.
    o1co.4 $e |- ( ph -> B C_ RR ) $.
    o1co.5 $e |- ( ( ph /\ m e. RR ) ->
      E. x e. RR A. y e. B ( x <_ y -> m <_ ( G ` y ) ) ) $.
    $( Sufficient condition for transforming the index set of an eventually
       bounded function.  (Contributed by Mario Carneiro, 12-May-2016.) $)
    o1co $p |- ( ph -> ( F o. G ) e. O(1) ) $=
      ( vn wcel cle cfv cr wrex wa vz ccom co1 cv wbr cabs wi wral cc wf wss wb
      cdm wceq fdm o1dm eqsstr3d elo12 syl2anc mpbid reeanv ad3antrrr ffvelrnda
      breq2 fveq2 fveq2d breq1d imbi12d rspcva sylan an32s adantr fvco3 sylibrd
      syl imim2d ralimdva expimpd ancomsd reximdva syl5bir rexlimdva mpd mpbird
      mpand fco ) AGHUBZUCOZBUDZCUDZPUEZWJWGQZUFQZNUDZPUEZUGZCEUHZNRSZBRSZAFUDZ
      UAUDZPUEZXAGQZUFQZWNPUEZUGZUADUHZNRSZFRSZWSAGUCOZXIJADUIGUJZDRUKXJXIULIAD
      GUMZRAXKXLDUNIDUIGUOVOAXJXLRUKJGUPVOUQFUADNGURUSUTAXHWSFRAWTROZTZWKWTWJHQ
      ZPUEZUGZCEUHZBRSZXHWSMXSXHTXRXGTZNRSZBRSXNWSXRXGBNRRVAXNYAWRBRXNWIROZTZXT
      WQNRYCWNROZTZXGXRWQYEXGXRWQYEXGTZXQWPCEYFWJEOZTZXPWOWKYHXPXOGQZUFQZWNPUEZ
      WOYEYGXGXPYKUGZYEYGTXODOXGYLYEEDWJHAEDHUJZXMYBYDKVBZVCXFYLUAXODXAXOUNZXBX
      PXEYKXAXOWTPVDYOXDYJWNPYOXCYIUFXAXOGVEVFVGVHVIVJVKYHWMYJWNPYHWLYIUFYFYMYG
      WLYIUNYEYMXGYNVLEDWJGHVMVJVFVGVNVPVQVRVSVTVTWAWEWBWCAEUIWGUJZERUKWHWSULAX
      KYMYPIKEDUIGHWFUSLBCENWGURUSWD $.
  $}

  ${
    $d m x y z A $.  $d m x y z B $.  $d m x z C $.  $d m x y z ph $.
    $d m x z F $.
    o1compt.1 $e |- ( ph -> F : A --> CC ) $.
    o1compt.2 $e |- ( ph -> F e. O(1) ) $.
    o1compt.3 $e |- ( ( ph /\ y e. B ) -> C e. A ) $.
    o1compt.4 $e |- ( ph -> B C_ RR ) $.
    o1compt.5 $e |- ( ( ph /\ m e. RR ) ->
      E. x e. RR A. y e. B ( x <_ y -> m <_ C ) ) $.
    $( Sufficient condition for transforming the index set of an eventually
       bounded function.  (Contributed by Mario Carneiro, 12-May-2016.) $)
    o1compt $p |- ( ph -> ( F o. ( y e. B |-> C ) ) e. O(1) ) $=
      ( vz cv cr wcel cle wbr wi cmpt eqid fmptd wa cfv wral wrex nfcv nffvmpt1
      nfv nfbr nfim wceq breq2 fveq2 breq2d imbi12d cbvral simpr fvmpt2 syl2anc
      wb imbi2d ralbidva syl5bb rexbidv adantr mpbird o1co ) ABNDEGHCEFUAZIJACE
      FDVJKVJUBZUCLAGOZPQZUDBOZNOZRSZVLVOVJUEZRSZTZNEUFZBPUGZVNCOZRSZVLFRSZTZCE
      UFZBPUGZMAWAWGVBVMAVTWFBPVTWCVLWBVJUEZRSZTZCEUFAWFVSWJNCEVPVRCVPCUJCVLVQR
      CVLUHCRUHCEFVOUIUKULWJNUJVOWBUMZVPWCVRWIVOWBVNRUNWKVQWHVLRVOWBVJUOUPUQURA
      WJWECEAWBEQZUDZWIWDWCWMWHFVLRWMWLFDQWHFUMAWLUSKCEFDVJVKUTVAUPVCVDVEVFVGVH
      VI $.
  $}

  ${
    $d c w x y A $.  $d c v w x y z F $.  $d c v w x y z G $.  $d c w x y ph $.
    $d c w x y z C $.  $d c v w z X $.
    rlimcn1.1 $e |- ( ph -> G : A --> X ) $.
    rlimcn1.2 $e |- ( ph -> C e. X ) $.
    rlimcn1.3 $e |- ( ph -> G ~~>r C ) $.
    rlimcn1.4 $e |- ( ph -> F : X --> CC ) $.
    rlimcn1.5 $e |- ( ( ph /\ x e. RR+ ) -> E. y e. RR+ A. z e. X
                    ( ( abs ` ( z - C ) ) < y ->
                      ( abs ` ( ( F ` z ) - ( F ` C ) ) ) < x ) ) $.
    $( Image of a limit under a continuous map.  (Contributed by Mario
       Carneiro, 17-Sep-2014.) $)
    rlimcn1 $p |- ( ph -> ( F o. G ) ~~>r ( F ` C ) ) $=
      ( vw vc cv cfv wbr cmin vv ccom cmpt crli ffvelrnda feqmptd cc fmptco cle
      fveq2 co cabs clt wi wral cr wrex crp wcel wa cvv fvex ralrimiva eqbrtrrd
      simpr ad2antrr rlimi simpll sylan simplrr wceq oveq1 fveq2d breq1d oveq1d
      a1i imbi12d rspcv sylc imim2d ralimdva reximdv expr mpid rexlimdva syldan
      mpd cdm wf fdm syl wss rlimss eqsstr3d ffvelrnd rlim2 mpbird eqbrtrd ) AG
      HUBOEOQZHRZGRZUCZFGRZUDAOUAEIWTUAQZGRXAHGAEIWSHJUEZAOEIHJUFZAUAIUGGMUFXDW
      TGUJUHAXBXCUDSPQWSUISZXAXCTUKZULRZBQZUMSZUNZOEUOZPUPUQZBURUOAXNBURAXJURUS
      ZUTZDQZFTUKZULRZCQZUMSZXQGRZXCTUKZULRZXJUMSZUNZDIUOZCURUQXNNXPYGXNCURXPXT
      URUSZUTZYGXGWTFTUKZULRZXTUMSZUNZOEUOZPUPUQZXNYIPOEWTFXTVAYIWTVAUSZOEYPYIW
      SEUSZUTWSHVBVPVCXPYHVEAOEWTUCZFUDSXOYHAHYRFUDXFLVDVFVGXPYHYGYOXNUNXPYHYGU
      TZUTZYNXMPUPYTYMXLOEYTYQUTZYLXKXGUUAWTIUSZYGYLXKUNZYTAYQUUBAXOYSVHXEVIXPY
      HYGYQVJYFUUCDWTIXQWTVKZYAYLYEXKUUDXSYKXTUMUUDXRYJULXQWTFTVLVMVNUUDYDXIXJU
      MUUDYCXHULUUDYBXAXCTXQWTGUJVOVMVNVQVRVSVTWAWBWCWDWEWGVCABPOEXAXCAXAUGUSZO
      EAYQUUBUUEXEAIUGWTGMUEWFVCAEHWHZUPAEIHWIUUFEVKJEIHWJWKAHFUDSUUFUPWLLFHWMW
      KWNAIUGFGMKWOWPWQWR $.
  $}

  ${
    $d k x y z A $.  $d x y z B $.  $d x y z C $.  $d k x y z F $.  $d k z X $.
    $d k x y ph $.
    rlimcn1b.1 $e |- ( ( ph /\ k e. A ) -> B e. X ) $.
    rlimcn1b.2 $e |- ( ph -> C e. X ) $.
    rlimcn1b.3 $e |- ( ph -> ( k e. A |-> B ) ~~>r C ) $.
    rlimcn1b.4 $e |- ( ph -> F : X --> CC ) $.
    rlimcn1b.5 $e |- ( ( ph /\ x e. RR+ ) -> E. y e. RR+ A. z e. X
                    ( ( abs ` ( z - C ) ) < y ->
                      ( abs ` ( ( F ` z ) - ( F ` C ) ) ) < x ) ) $.
    $( Image of a limit under a continuous map.  (Contributed by Mario
       Carneiro, 10-May-2016.) $)
    rlimcn1b $p |- ( ph -> ( k e. A |-> ( F ` B ) ) ~~>r ( F ` C ) ) $=
      ( cmpt ccom cfv crli cv eqidd cc feqmptd fveq2 fmptco eqid fmptd eqbrtrrd
      rlimcn1 ) AIHEFPZQHEFIRZPGIRSAHDEJFDTZIRUKUJIKAUJUAADJUBINUCULFIUDUEABCDE
      GIUJJAHEFJUJKUJUFUGLMNOUIUH $.
  $}

  ${
    $d a b c r s x z A $.  $d a b c r s u v x z F $.  $d a b c r s u v x z R $.
    $d a b c r s u v x B $.  $d a b c r s x z ph $.  $d a b c r s u v x z S $.
    $d a b c r s v x C $.  $d a b u z X $.  $d a b u v z Y $.
    rlimcn2.1a $e |- ( ( ph /\ z e. A ) -> B e. X ) $.
    rlimcn2.1b $e |- ( ( ph /\ z e. A ) -> C e. Y ) $.
    rlimcn2.2a $e |- ( ph -> R e. X ) $.
    rlimcn2.2b $e |- ( ph -> S e. Y ) $.
    rlimcn2.3a $e |- ( ph -> ( z e. A |-> B ) ~~>r R ) $.
    rlimcn2.3b $e |- ( ph -> ( z e. A |-> C ) ~~>r S ) $.
    rlimcn2.4 $e |- ( ph -> F : ( X X. Y ) --> CC ) $.
    rlimcn2.5 $e |- ( ( ph /\ x e. RR+ ) ->
      E. r e. RR+ E. s e. RR+ A. u e. X A. v e. Y
        ( ( ( abs ` ( u - R ) ) < r /\ ( abs ` ( v - S ) ) < s ) ->
          ( abs ` ( ( u F v ) - ( R F S ) ) ) < x ) ) $.
    $( Image of a limit under a continuous map, two-arg version.  (Contributed
       by Mario Carneiro, 17-Sep-2014.) $)
    rlimcn2 $p |- ( ph -> ( z e. A |-> ( B F C ) ) ~~>r ( R F S ) ) $=
      ( vc va vb co cmpt crli wbr cv cle cmin cabs cfv clt wi wral cr wrex wcel
      crp wa ralrimiva adantr simprl rlimi simprr reeanv r19.26 prth wb simplrl
      cif simplrr wss cdm wf wceq fmptd fdm syl rlimss eqsstr3d ad2antrr sselda
      eqid maxle syl3anc imbi1d syl5ibr ralimdva ifcl ancoms ad2antlr jca oveq1
      adantlr fveq2d breq1d anbi1d oveq1d anbi2d oveq2 sylan imim2d an32s breq1
      imbi12d rspc2va ralbidv rspcev ee12an ex com23 syld rexlimdvva mp2and imp
      syl5bir syldan cc cxp fovrnd rlim2 mpbird ) ACFGHKUGZUHIJKUGZUIUJUDUKZCUK
      ZULUJZYGYHUMUGZUNUOZBUKZUPUJZUQZCFURZUDUSUTZBVBURAYRBVBAYNVBVAEUKZIUMUGZU
      NUOZOUKZUPUJZDUKZJUMUGZUNUOZNUKZUPUJZVCZYSUUDKUGZYHUMUGZUNUOZYNUPUJZUQZDM
      URELURZNVBUTOVBUTZYRUCAUUPYRAUUOYRONVBVBAUUBVBVAZUUGVBVAZVCZVCZUEUKZYJULU
      JZGIUMUGZUNUOZUUBUPUJZUQZCFURZUEUSUTZUFUKZYJULUJZHJUMUGZUNUOZUUGUPUJZUQZC
      FURZUFUSUTZUUOYRUQZUUTUECFGIUUBLAGLVAZCFURUUSAUVRCFPVDVEAUUQUURVFACFGUHZI
      UIUJZUUSTVEVGUUTUFCFHJUUGMAHMVAZCFURUUSAUWACFQVDVEAUUQUURVHACFHUHJUIUJUUS
      UAVEVGUVHUVPVCUVGUVOVCZUFUSUTUEUSUTUUTUVQUVGUVOUEUFUSUSVIUUTUWBUVQUEUFUSU
      SUWBUVFUVNVCZCFURZUUTUVAUSVAZUVIUSVAZVCZVCZUVQUVFUVNCFVJUWHUWDUVAUVIULUJZ
      UVIUVAVNZYJULUJZUVEUVMVCZUQZCFURZUVQUWHUWCUWMCFUWCUWMUWHYJFVAZVCZUVBUVJVC
      ZUWLUQUVBUVEUVJUVMVKUWPUWKUWQUWLUWPUWEUWFYJUSVAUWKUWQVLUUTUWEUWFUWOVMUUTU
      WEUWFUWOVOUWHFUSYJAFUSVPUUSUWGAFUVSVQZUSAFLUVSVRUWRFVSACFGLUVSPUVSWGVTFLU
      VSWAWBAUVTUWRUSVPTIUVSWCWBWDZWEWFUVAUVIYJWHWIWJWKWLUWHUUOUWNYRUWHUUOUWNYR
      UQUWHUUOVCUWJUSVAZUWNUWKYOUQZCFURZYRUWGUWTUUTUUOUWFUWEUWTUWIUVIUVAUSWMWNW
      OUUTUUOUWNUXBUQUWGUUTUUOVCUWMUXACFUUTUWOUUOUWMUXAUQUUTUWOVCZUUOVCUWLYOUWK
      UXCUVRUWAVCUUOUWLYOUQZUXCUVRUWAAUWOUVRUUSPWRAUWOUWAUUSQWRWPUUNUXDUVEUUHVC
      ZGUUDKUGZYHUMUGZUNUOZYNUPUJZUQEDGHLMYSGVSZUUIUXEUUMUXIUXJUUCUVEUUHUXJUUAU
      VDUUBUPUXJYTUVCUNYSGIUMWQWSWTXAUXJUULUXHYNUPUXJUUKUXGUNUXJUUJUXFYHUMYSGUU
      DKWQXBWSWTXIUUDHVSZUXEUWLUXIYOUXKUUHUVMUVEUXKUUFUVLUUGUPUXKUUEUVKUNUUDHJU
      MWQWSWTXCUXKUXHYMYNUPUXKUXGYLUNUXKUXFYGYHUMUUDHGKXDXBWSWTXIXJXEXFXGWLWRYQ
      UXBUDUWJUSYIUWJVSZYPUXACFUXLYKUWKYOYIUWJYJULXHWJXKXLXMXNXOXPXTXQXTXRXQXSY
      AVDABUDCFYGYHAYGYBVACFAUWOVCGHYBLMKALMYCYBKVRUWOUBVEPQYDVDUWSAIJYBLMKUBRS
      YDYEYF $.
  $}

  ${
    $d j k x y z A $.  $d j k z B $.  $d j k y z G $.  $d j k x H $.  $d j M $.
    $d j k x y z F $.  $d j k x y z ph $.  $d j k y Z $.
    climcn1.1 $e |- Z = ( ZZ>= ` M ) $.
    climcn1.2 $e |- ( ph -> M e. ZZ ) $.
    climcn1.3 $e |- ( ph -> A e. B ) $.
    climcn1.4 $e |- ( ( ph /\ z e. B ) -> ( F ` z ) e. CC ) $.
    climcn1.5 $e |- ( ph -> G ~~> A ) $.
    climcn1.6 $e |- ( ph -> H e. W ) $.
    climcn1.7 $e |- ( ( ph /\ x e. RR+ ) -> E. y e. RR+ A. z e. B
                    ( ( abs ` ( z - A ) ) < y ->
                      ( abs ` ( ( F ` z ) - ( F ` A ) ) ) < x ) ) $.
    climcn1.8 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. B ) $.
    climcn1.9 $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) = ( F ` ( G ` k ) ) ) $.
    $( Image of a limit under a continuous map.  (Contributed by Mario
       Carneiro, 31-Jan-2014.) $)
    climcn1 $p |- ( ph -> H ~~> ( F ` A ) ) $=
      ( vj cfv cli wbr cv cmin co cabs clt cuz wral wrex crp wa wi adantr simpr
      wcel cz eqidd climi2 uztrn2 adantlr wceq oveq1 fveq2d breq1d fveq2 oveq1d
      imbi12d rspcva sylan an32s sylan2 anassrs ralimdva reximdva rexlimdva mpd
      ex mpid ralrimiva cc eleq1d rspcv sylc clim2c mpbird ) AJEHUDZUEUFGUGZIUD
      ZHUDZWKUHUIZUJUDZBUGZUKUFZGUCUGZULUDZUMZUCMUNZBUOUMAXBBUOAWQUOUTZUPDUGZEU
      HUIZUJUDZCUGZUKUFZXDHUDZWKUHUIZUJUDZWQUKUFZUQZDFUMZCUOUNZXBTAXOXBUQXCAXNX
      BCUOAXGUOUTZUPZXNWMEUHUIZUJUDZXGUKUFZGWTUMZUCMUNZXBXQEWMXGUCGIKMNAKVAUTXP
      OURAXPUSXQWLMUTZUPZWMVBAIEUEUFXPRURVCXQXNYBXBUQXQXNUPZYAXAUCMYEWSMUTZUPXT
      WRGWTYEYFWLWTUTZXTWRUQZYFYGUPYEYCYHKWLWSMNVDXQYCXNYHYDWMFUTZXNYHAYCYIXPUA
      VEXMYHDWMFXDWMVFZXHXTXLWRYJXFXSXGUKYJXEXRUJXDWMEUHVGVHVIYJXKWPWQUKYJXJWOU
      JYJXIWNWKUHXDWMHVJZVKVHVIVLVMVNVOVPVQVRVSWBWCVTURWAWDABWKWNUCGJKLMNOSUBAE
      FUTXIWEUTZDFUMZWKWEUTZPAYLDFQWDZYLYNDEFXDEVFXIWKWEXDEHVJWFWGWHAYCUPYIYMWN
      WEUTZUAAYMYCYOURYLYPDWMFYJXIWNWEYKWFWGWHWIWJ $.
  $}

  ${
    $d j k u v C $.  $d j k u v D $.  $d j k v y z H $.  $d j k u v x y z ph $.
    $d j k u v x y z A $.  $d j k u v y z G $.  $d j k x K $.  $d j k y z Z $.
    $d j k u v x y z B $.  $d j k u v x y z F $.  $d j M $.
    climcn2.1 $e |- Z = ( ZZ>= ` M ) $.
    climcn2.2 $e |- ( ph -> M e. ZZ ) $.
    climcn2.3a $e |- ( ph -> A e. C ) $.
    climcn2.3b $e |- ( ph -> B e. D ) $.
    climcn2.4 $e |- ( ( ph /\ ( u e. C /\ v e. D ) ) -> ( u F v ) e. CC ) $.
    climcn2.5a $e |- ( ph -> G ~~> A ) $.
    climcn2.5b $e |- ( ph -> H ~~> B ) $.
    climcn2.6 $e |- ( ph -> K e. W ) $.
    climcn2.7 $e |- ( ( ph /\ x e. RR+ ) ->
      E. y e. RR+ E. z e. RR+ A. u e. C A. v e. D
        ( ( ( abs ` ( u - A ) ) < y /\ ( abs ` ( v - B ) ) < z ) ->
          ( abs ` ( ( u F v ) - ( A F B ) ) ) < x ) ) $.
    climcn2.8a $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. C ) $.
    climcn2.8b $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) e. D ) $.
    climcn2.9 $e |- ( ( ph /\ k e. Z ) ->
                      ( K ` k ) = ( ( G ` k ) F ( H ` k ) ) ) $.
    $( Image of a limit under a continuous map, two-arg version.  (Contributed
       by Mario Carneiro, 31-Jan-2014.) $)
    climcn2 $p |- ( ph -> K ~~> ( A F B ) ) $=
      ( vj co cli wbr cv cfv cmin cabs clt cuz wral wrex crp wcel adantr simprl
      wa wi cz eqidd climi2 simprr rexanuz2 sylanbrc uztrn2 oveq1 fveq2d breq1d
      wceq anbi1d oveq1d imbi12d anbi2d oveq2 rspc2v syl2anc imp sylan2 anassrs
      an32s ralimdva reximdva ex rexlimdvva mpd ralrimiva cc caovcld ralrimivva
      mpid jca eleq1d sylc clim2c mpbird ) AOGHLULZUMUNKUOZMUPZXGNUPZLULZXFUQUL
      ZURUPZBUOZUSUNZKUKUOZUTUPZVAZUKRVBZBVCVAAXRBVCAXMVCVDZVGFUOZGUQULZURUPZCU
      OZUSUNZEUOZHUQULZURUPZDUOZUSUNZVGZXTYELULZXFUQULZURUPZXMUSUNZVHZEJVAFIVAZ
      DVCVBCVCVBZXRUGAYQXRVHXSAYPXRCDVCVCAYCVCVDZYHVCVDZVGZVGZYPXHGUQULZURUPZYC
      USUNZXIHUQULZURUPZYHUSUNZVGZKXPVAZUKRVBZXRUUAUUDKXPVAUKRVBUUGKXPVAUKRVBUU
      JUUAGXHYCUKKMPRSAPVIVDYTTVEZAYRYSVFUUAXGRVDZVGZXHVJAMGUMUNYTUDVEVKUUAHXIY
      HUKKNPRSUUKAYRYSVLUUMXIVJANHUMUNYTUEVEVKUUDUUGUKKPRSVMVNAYPUUJXRVHZVHYTAY
      PUUNAYPVGZUUIXQUKRUUOXORVDZVGUUHXNKXPUUOUUPXGXPVDZUUHXNVHZUUPUUQVGUUOUULU
      URPXGXORSVOAUULYPUURAUULVGZYPUURUUSXHIVDZXIJVDZYPUURVHUHUIYOUURUUDYIVGZXH
      YELULZXFUQULZURUPZXMUSUNZVHFEXHXIIJXTXHVSZYJUVBYNUVFUVGYDUUDYIUVGYBUUCYCU
      SUVGYAUUBURXTXHGUQVPVQVRVTUVGYMUVEXMUSUVGYLUVDURUVGYKUVCXFUQXTXHYELVPZWAV
      QVRWBYEXIVSZUVBUUHUVFXNUVIYIUUGUUDUVIYGUUFYHUSUVIYFUUEURYEXIHUQVPVQVRWCUV
      IUVEXLXMUSUVIUVDXKURUVIUVCXJXFUQYEXIXHLWDZWAVQVRWBWEWFWGWJWHWIWKWLWMVEWTW
      NVEWOWPABXFXJUKKOPQRSTUFUJAFEGHIJWQLUCUAUBWRUUSUUTUVAVGYKWQVDZEJVAFIVAZXJ
      WQVDZUUSUUTUVAUHUIXAAUVLUULAUVKFEIJUCWSVEUVKUVMUVCWQVDFEXHXIIJUVGYKUVCWQU
      VHXBUVIUVCXJWQUVJXBWEXCXDXE $.
  $}

  ${
    $d u v w y z A $.  $d u v w y z B $.  $d u v w y z C $.  $d y z T $.
    $( Complex number addition is a continuous function.  Part of Proposition
       14-4.16 of [Gleason] p. 243.  (We write out the definition directly
       because ~ df-cn and ~ df-cncf are not yet available to us.  See ~ addcn
       for the abbreviated version.)  (Contributed by Mario Carneiro,
       31-Jan-2014.) $)
    addcn2 $p |- ( ( A e. RR+ /\ B e. CC /\ C e. CC ) ->
      E. y e. RR+ E. z e. RR+ A. u e. CC A. v e. CC
        ( ( ( abs ` ( u - B ) ) < y /\ ( abs ` ( v - C ) ) < z ) ->
          ( abs ` ( ( u + v ) - ( B + C ) ) ) < A ) ) $=
      ( crp wcel cc co cv cmin cabs cfv clt wbr wa wi wral w3a c2 cdiv rphalfcl
      caddc 3ad2ant1 simprl simpl2 simprr pnpcan2d fveq2d breq1d simpl3 pnpcand
      wrex anbi12d cr addcl adantl addcld simpl1 rpred abs3lem syl22anc sylbird
      ralrimivva wceq breq2 anbi1d imbi1d 2ralbidv anbi2d rspc2ev syl3anc ) EHI
      ZFJIZGJIZUAZEUBUCKZHIZVTDLZFMKZNOZVSPQZCLZGMKZNOZVSPQZRZWAWEUEKZFGUEKZMKN
      OEPQZSZCJTDJTZWCALZPQZWGBLZPQZRZWLSZCJTDJTZBHUOAHUOVOVPVTVQEUDUFZXBVRWMDC
      JJVRWAJIZWEJIZRZRZWIWJFWEUEKZMKZNOZVSPQZXGWKMKZNOZVSPQZRZWLXFXJWDXMWHXFXI
      WCVSPXFXHWBNXFWAFWEVRXCXDUGVOVPVQXEUHZVRXCXDUIZUJUKULXFXLWGVSPXFXKWFNXFFW
      EGXOXPVOVPVQXEUMZUNUKULUPXFWJJIZWKJIXGJIEUQIXNWLSXEXRVRWAWEURUSXFFGXOXQUT
      XFFWEXOXPUTXFEVOVPVQXEVAVBWJWKXGEVCVDVEVFXAWNWDWRRZWLSZCJTDJTABVSVSHHWOVS
      VGZWTXTDCJJYAWSXSWLYAWPWDWRWOVSWCPVHVIVJVKWQVSVGZXTWMDCJJYBXSWIWLYBWRWHWD
      WQVSWGPVHVLVJVKVMVN $.

    $( Complex number subtraction is a continuous function.  Part of
       Proposition 14-4.16 of [Gleason] p. 243.  (Contributed by Mario
       Carneiro, 31-Jan-2014.) $)
    subcn2 $p |- ( ( A e. RR+ /\ B e. CC /\ C e. CC ) ->
      E. y e. RR+ E. z e. RR+ A. u e. CC A. v e. CC
        ( ( ( abs ` ( u - B ) ) < y /\ ( abs ` ( v - C ) ) < z ) ->
          ( abs ` ( ( u - v ) - ( B - C ) ) ) < A ) ) $=
      ( vw crp wcel cc cv cmin co cabs cfv clt wbr wa caddc w3a cneg wral negcl
      wi wrex addcn2 syl3an3 wceq oveq1 fveq2d breq1d anbi2d oveq2 oveq1d rspcv
      imbi12d syl adantl simpr simpll3 neg2subd abssubd adantll simpll2 negsubd
      eqtrd negsub oveq12d sylibd ralrimdva ralimdva reximdv mpd ) EIJZFKJZGKJZ
      UAZDLZFMNOPALQRZHLZGUBZMNZOPZBLZQRZSZVSWATNZFWBTNZMNZOPZEQRZUEZHKUCZDKUCZ
      BIUFZAIUFZVTCLZGMNOPZWEQRZSZVSWRMNZFGMNZMNZOPZEQRZUEZCKUCZDKUCZBIUFZAIUFV
      QVOVPWBKJWQGUDABHDEFWBUGUHVRWPXJAIVRWOXIBIVRWNXHDKVRVSKJZSZWNXGCKXLWRKJZS
      ZWNVTWRUBZWBMNZOPZWEQRZSZVSXOTNZWIMNZOPZEQRZUEZXGXMWNYDUEZXLXMXOKJYEWRUDW
      MYDHXOKWAXOUIZWGXSWLYCYFWFXRVTYFWDXQWEQYFWCXPOWAXOWBMUJUKULUMYFWKYBEQYFWJ
      YAOYFWHXTWIMWAXOVSTUNUOUKULUQUPURUSXNXSXAYCXFXNXRWTVTXNXQWSWEQXNXQGWRMNZO
      PWSXNXPYGOXNWRGXLXMUTZVOVPVQXKXMVAZVBUKXNGWRYIYHVCVGULUMXNYBXEEQXNYAXDOXN
      XTXBWIXCMXKXMXTXBUIVRVSWRVHVDXNFGVOVPVQXKXMVEYIVFVIUKULUQVJVKVLVMVMVN $.

    $( Complex number multiplication is a continuous function.  Part of
       Proposition 14-4.16 of [Gleason] p. 243.  (Contributed by Mario
       Carneiro, 31-Jan-2014.) $)
    mulcn2 $p |- ( ( A e. RR+ /\ B e. CC /\ C e. CC ) ->
      E. y e. RR+ E. z e. RR+ A. u e. CC A. v e. CC
        ( ( ( abs ` ( u - B ) ) < y /\ ( abs ` ( v - C ) ) < z ) ->
          ( abs ` ( ( u x. v ) - ( B x. C ) ) ) < A ) ) $=
      ( crp wcel cc co cabs cfv clt wbr wa cmul wi cr cle c2 cdiv c1 caddc cmin
      w3a cv wral rphalfcl 3ad2ant1 abscl 3ad2ant3 3ad2ant2 1re readdcl sylancl
      wrex cc0 0lt1 addgegt0 an4s mpanr12 syl2anc elrpd rpdivcld rpred readdcld
      absge0 elrp sylan2b syl21anc simprl simpl2 subcld abscld adantr ltmuldivd
      simprr simpl3 abs2difd resubcld lelttr syl3anc mpand ltsubadd2d ltle syld
      sylibd absge0d lemul2a syl112anc remulcld exp3a 3syld com23 sylbird imp3a
      ex absmuld subdird fveq2d eqtr3d breq1d ltmuldiv2d subdid lemul1a syl3an3
      lep1d jca mpd eqbrtrd mulcld adantld mulcl adantl simpl1 abs3lem syl22anc
      jcad ralrimivva wceq breq2 anbi1d imbi1d 2ralbidv anbi2d rspc2ev ) EHIZFJ
      IZGJIZUFZEUAUBKZGLMZYLFLMZUCUDKZUBKZUDKZUBKZHIYPHIZDUGZFUEKZLMZYRNOZCUGZG
      UEKZLMZYPNOZPZYTUUDQKZFGQKZUEKLMENOZRZCJUHDJUHZUUBAUGZNOZUUFBUGZNOZPZUUKR
      ZCJUHDJUHZBHUQAHUQYKYLYQYHYIYLHIZYJEUIUJZYKYQYKYMYPYJYHYMSIZYIGUKULZYKYPY
      KYLYOUVBYKYOYKYNSIZUCSIZYOSIZYIYHUVEYJFUKZUMUNYNUCUOUPZYIYHURYONOZYJYIUVE
      URYNTOZUVJUVHFVHUVEUVKPUVFURUCNOZUVJUNUSUVEUVFUVKUVLUVJYNUCUTVAVBVCUMVDZV
      EZVFZVGZYKUVCURYMTOZYSURYQNOZUVDYJYHUVQYIGVHULUVNYSUVCUVQPYPSIZURYPNOZPUV
      RYPVIUVCUVSUVQUVTUVRYMYPUTVAVJVKVDZVEUVNYKUULDCJJYKYTJIZUUDJIZPZPZUUHUUIF
      UUDQKZUEKZLMZYLNOZUWFUUJUEKZLMZYLNOZPZUUKUWEUUHUWIUWLUWEUUHUUBUUDLMZQKZYL
      NOZUWIUWEUUCUUGUWPUWEUUCUUBYQQKZYLNOZUUGUWPRUWEUUBYLYQUWEUUAUWEYTFYKUWBUW
      CVLZYHYIYJUWDVMZVNZVOZUWEYLYKUVAUWDUVBVPVFZYKYQHIUWDUWAVPVQUWEUUGUWRUWPUW
      EUUGUWNYQTOZUWOUWQTOZUWRUWPRUWEUUGUWNYQNOZUXDUWEUUGUWNYMUEKZYPNOZUXFUWEUX
      GUUFTOZUUGUXHUWEUUDGYKUWBUWCVRZYHYIYJUWDVSZVTUWEUXGSIUUFSIZUVSUXIUUGPUXHR
      UWEUWNYMUWEUUDUXJVOZYKUVCUWDUVDVPZWAUWEUUEUWEUUDGUXJUXKVNZVOZYKUVSUWDUVOV
      PZUXGUUFYPWBWCWDUWEUWNYMYPUXMUXNUXQWEWHUWEUWNSIZYQSIZUXFUXDRUXMYKUXSUWDUV
      PVPZUWNYQWFVCWGUWEUXRUXSUUBSIZURUUBTOZUXDUXERUXMUXTUXBUWEUUAUXAWIUXRUXSUY
      AUYBPUFUXDUXEUWNYQUUBWJWRWKUWEUXEUWRUWPUWEUWOSIUWQSIYLSIZUXEUWRPUWPRUWEUU
      BUWNUXBUXMWLUWEUUBYQUXBUXTWLUXCUWOUWQYLWBWCWMWNWOWPWQUWEUWOUWHYLNUWEUUAUU
      DQKZLMUWOUWHUWEUUAUUDUXAUXJWSUWEUYDUWGLUWEYTFUUDUWSUWTUXJWTXAXBXCWHUWEUUG
      UWLUUCUWEUUGYOUUFQKZYLNOZUWLUWEUUFYLYOUXPUXCYKYOHIUWDUVMVPXDUWEUWKUYETOZU
      YFUWLUWEUWKYNUUFQKZUYETUWEFUUEQKZLMUWKUYHUWEUYIUWJLUWEFUUDGUWTUXJUXKXEXAU
      WEFUUEUWTUXOWSXBUWEYNYOTOZUYHUYETOZUWEYNUWEFUWTVOZXHUWEUVEUVGUUEJIZUYJUYK
      RZUYLYKUVGUWDUVIVPZUXOUYMUVEUVGUXLURUUFTOZPZUYNUYMUXLUYPUUEUKUUEVHXIUVEUV
      GUYQUFUYJUYKYNYOUUFXFWRXGWCXJXKUWEUWKSIUYESIUYCUYGUYFPUWLRUWEUWJUWEUWFUUJ
      UWEFUUDUWTUXJXLZUWEFGUWTUXKXLZVNVOUWEYOUUFUYOUXPWLUXCUWKUYEYLWBWCWDWPXMXS
      UWEUUIJIZUUJJIUWFJIESIUWMUUKRUWDUYTYKYTUUDXNXOUYSUYRUWEEYHYIYJUWDXPVFUUIU
      UJUWFEXQXRWGXTUUTUUMUUCUUQPZUUKRZCJUHDJUHABYRYPHHUUNYRYAZUUSVUBDCJJVUCUUR
      VUAUUKVUCUUOUUCUUQUUNYRUUBNYBYCYDYEUUPYPYAZVUBUULDCJJVUDVUAUUHUUKVUDUUQUU
      GUUCUUPYPUUFNYBYFYDYEYGWC $.

    reccn2.t $e |- T = ( if ( 1 <_ ( ( abs ` A ) x. B ) , 1 ,
      ( ( abs ` A ) x. B ) ) x. ( ( abs ` A ) / 2 ) ) $.
    $( The reciprocal function is continuous.  (Contributed by Mario Carneiro,
       9-Feb-2014.)  (Revised by Mario Carneiro, 22-Sep-2014.) $)
    reccn2 $p |- ( ( A e. ( CC \ { 0 } ) /\ B e. RR+ ) -> E. y e. RR+
      A. z e. ( CC \ { 0 } ) ( ( abs ` ( z - A ) ) < y ->
        ( abs ` ( ( 1 / z ) - ( 1 / A ) ) ) < B ) ) $=
      ( cc cc0 wcel crp cmin co cabs cfv clt wbr c1 cdiv cmul cle cdif wa cv wi
      csn wral wrex cif c2 1rp wne simpl eldifsn sylib absrpcl rpmulcl sylancom
      syl ifcl sylancr rphalfcld rpmulcld syl5eqel adantr simpld simprl syl2anc
      mulcld mulne0 divsubdird mulid1d oveq1d ax-1cn a1i divcan5 syl3anc eqtr3d
      wceq mulcomd oveq12d eqtrd fveq2d subcld absdivd cr abssubd eqeltrd rpred
      abscld rpre ad2antlr remulcld simprr eqbrtrd 1re min2 lemul1d mpbid caddc
      syl5eqbr recnd 2halvesd resubcld abs2difd mulid2d breqtrd ltletrd lelttrd
      ltsubadd2d ltadd1d mpbird ltmul2dd absmuld mul32d breqtrrd lttrd absrpcld
      min1 ltdivmuld expr ralrimiva breq2 imbi1d ralbidv rspcev ) CGHUEUAZIZDJI
      ZUBZEJIZBUCZCKLZMNZEOPZQYKRLZQCRLZKLZMNZDOPZUDZBYFUFZYMAUCZOPZYSUDZBYFUFZ
      AJUGYIEQCMNZDSLZTPZQUUGUHZUUFUIRLZSLZJFYIUUIUUJYIQJIUUGJIZUUIJIZUJYGYHUUF
      JIZUULYICGIZCHUKZUBZUUNYIYGUUQYGYHULCGHUMUNZCUOURZUUFDUPUQZUUHQUUGJUSUTZY
      IUUFUUSVAZVBVCZYIYTBYFYIYKYFIZYNYSYIUVDYNUBZUBZYRCYKKLZMNZCYKSLZMNZRLZDOU
      VFUVGUVIRLZMNYRUVKUVFUVLYQMUVFUVLCUVIRLZYKUVIRLZKLYQUVFCYKUVIUVFUUOUUPYIU
      UQUVEUURVDZVEZUVFYKGIZYKHUKZUVFUVDUVQUVRUBZYIUVDYNVFYKGHUMUNZVEZUVFCYKUVP
      UWAVHZUVFUUQUVSUVIHUKUVOUVTCYKVIVGZVJUVFUVMYOUVNYPKUVFCQSLZUVIRLZUVMYOUVF
      UWDCUVIRUVFCUVPVKVLUVFQGIZUVSUUQUWEYOVRUWFUVFVMVNZUVTUVOQYKCVOVPVQUVFYKQS
      LZYKCSLZRLZUVNYPUVFUWHYKUWIUVIRUVFYKUWAVKUVFYKCUWAUVPVSVTUVFUWFUUQUVSUWJY
      PVRUWGUVOUVTQCYKVOVPVQVTWAWBUVFUVGUVIUVFCYKUVPUWAWCUWBUWCWDVQUVFUVKDOPUVH
      UVJDSLZOPUVFUVHEUWKUVFUVHYMWEUVFCYKUVPUWAWFZUVFYLUVFYKCUWAUVPWCWIWGZUVFEY
      IYJUVEUVCVDWHZUVFUVJDUVFUVIUWBWIYHDWEIYGUVEDWJWKZWLZUVFUVHYMEOUWLYIUVDYNW
      MWNZUVFEUUGUUJSLZUWKUWNUVFUUGUUJUVFUUGYIUULUVEUUTVDZWHZUVFUUJYIUUJJIUVEUV
      BVDZWHZWLUWPUVFEUUKUWRTFUVFUUIUUGTPZUUKUWRTPUVFQWEIZUUGWEIZUXCWOUWTQUUGWP
      UTUVFUUIUUGUUJUVFUUIYIUUMUVEUVAVDWHZUWTUXAWQWRWTUVFUWRUUGYKMNZSLZUWKOUVFU
      UJUXGUUGUXBUVFYKUWAWIZUWSUVFUUJUXGOPUUJUUJWSLZUXGUUJWSLZOPUVFUXJUUFUXKOUV
      FUUFUVFUUFUVFCUVPWIZXAZXBUVFUUFUXGKLZUUJOPUUFUXKOPUVFUXNUVHUUJUVFUUFUXGUX
      LUXIXCUWMUXBUVFCYKUVPUWAXDUVFUVHEUUJUWMUWNUXBUWQUVFEQUUJSLZUUJTUVFEUUKUXO
      TFUVFUUIQTPZUUKUXOTPUVFUXDUXEUXPWOUWTQUUGXRUTUVFUUIQUUJUXFUXDUVFWOVNUXAWQ
      WRWTUVFUUJUVFUUJUXBXAXEXFXGXHUVFUUFUXGUUJUXLUXIUXBXIWRWNUVFUUJUXGUUJUXBUX
      IUXBXJXKXLUVFUWKUUFUXGSLZDSLUXHUVFUVJUXQDSUVFCYKUVPUWAXMVLUVFUUFUXGDUXMUV
      FUXGUXIXAUVFDUWOXAXNWAXOXHXPUVFUVHDUVJUWMUWOUVFUVIUWBUWCXQXSXKWNXTYAUUEUU
      AAEJUUBEVRZUUDYTBYFUXRUUCYNYSUUBEYMOYBYCYDYEVG $.
  $}

  ${
    $d x y z $.  $d y z A $.  $d y F $.
    cn1lem.1 $e |- F : CC --> CC $.
    cn1lem.2 $e |- ( ( z e. CC /\ A e. CC ) ->
                ( abs ` ( ( F ` z ) - ( F ` A ) ) ) <_ ( abs ` ( z - A ) ) ) $.
    $( A sufficient condition for a function to be continuous.  (Contributed by
       Mario Carneiro, 9-Feb-2014.) $)
    cn1lem $p |- ( ( A e. CC /\ x e. RR+ ) -> E. y e. RR+ A. z e. CC
                  ( ( abs ` ( z - A ) ) < y ->
                    ( abs ` ( ( F ` z ) - ( F ` A ) ) ) < x ) ) $=
      ( cc wcel cv crp wa cmin co cabs cfv clt wbr wi cr wral wrex simpr simpll
      cle syl2anc ffvelrni syl subcld abscld rpre ad2antlr lelttr syl3anc mpand
      ralrimiva weq breq2 imbi1d ralbidv rspcev ) DHIZAJZKIZLZVDCJZDMNZOPZVCQRZ
      VFEPZDEPZMNZOPZVCQRZSZCHUAZVHBJZQRZVNSZCHUAZBKUBVBVDUCVEVOCHVEVFHIZLZVMVH
      UERZVIVNWBWAVBWCVEWAUCZVBVDWAUDZGUFWBVMTIVHTIVCTIZWCVILVNSWBVLWBVJVKWBWAV
      JHIWDHHVFEFUGUHWBVBVKHIWEHHDEFUGUHUIUJWBVGWBVFDWDWEUIUJVDWFVBWAVCUKULVMVH
      VCUMUNUOUPVTVPBVCKBAUQZVSVOCHWGVRVIVNVQVCVHQURUSUTVAUF $.
  $}

  ${
    $d x y z $.  $d y z A $.
    $( The absolute value function is continuous.  (Contributed by Mario
       Carneiro, 9-Feb-2014.) $)
    abscn2 $p |- ( ( A e. CC /\ x e. RR+ ) -> E. y e. RR+ A. z e. CC
                    ( ( abs ` ( z - A ) ) < y ->
                      ( abs ` ( ( abs ` z ) - ( abs ` A ) ) ) < x ) ) $=
      ( cabs cc cr wf wss absf ax-resscn fss mp2an cv abs2difabs cn1lem ) ABCDE
      FGEHGFIFFEHJKFGFELMCNDOP $.

    $( The complex conjugate function is continuous.  (Contributed by Mario
       Carneiro, 9-Feb-2014.) $)
    cjcn2 $p |- ( ( A e. CC /\ x e. RR+ ) -> E. y e. RR+ A. z e. CC
                    ( ( abs ` ( z - A ) ) < y ->
                      ( abs ` ( ( * ` z ) - ( * ` A ) ) ) < x ) ) $=
      ( ccj cjf cv cc wcel wa cfv cmin co cabs cr wceq cle wbr cjcl subcl cjsub
      syl2an abscld fveq2d abscjd eqtr3d eqle syl2anc cn1lem ) ABCDEFCGZHIZDHIZ
      JZUJEKZDEKZLMZNKZOIUQUJDLMZNKZPUQUSQRUMUPUKUNHIUOHIUPHIULUJSDSUNUOTUBUCUM
      UREKZNKUQUSUMUTUPNUJDUAUDUMURUJDTUEUFUQUSUGUHUI $.

    $( The real part function is continuous.  (Contributed by Mario Carneiro,
       9-Feb-2014.) $)
    recn2 $p |- ( ( A e. CC /\ x e. RR+ ) -> E. y e. RR+ A. z e. CC
                    ( ( abs ` ( z - A ) ) < y ->
                      ( abs ` ( ( Re ` z ) - ( Re ` A ) ) ) < x ) ) $=
      ( cre cc cr wf wss ref ax-resscn fss mp2an cv wcel cmin co cfv cabs cle
      wa resub fveq2d wbr subcl absrele syl eqbrtrrd cn1lem ) ABCDEFGEHGFIFFEHJ
      KFGFELMCNZFODFOUAZUJDPQZERZSRZUJERDERPQZSRULSRZTUKUMUOSUJDUBUCUKULFOUNUPT
      UDUJDUEULUFUGUHUI $.

    $( The imaginary part function is continuous.  (Contributed by Mario
       Carneiro, 9-Feb-2014.) $)
    imcn2 $p |- ( ( A e. CC /\ x e. RR+ ) -> E. y e. RR+ A. z e. CC
                    ( ( abs ` ( z - A ) ) < y ->
                      ( abs ` ( ( Im ` z ) - ( Im ` A ) ) ) < x ) ) $=
      ( cim cc cr wf wss imf ax-resscn fss mp2an cv wcel cmin co cfv cabs cle
      wa imsub fveq2d wbr subcl absimle syl eqbrtrrd cn1lem ) ABCDEFGEHGFIFFEHJ
      KFGFELMCNZFODFOUAZUJDPQZERZSRZUJERDERPQZSRULSRZTUKUMUOSUJDUBUCUKULFOUNUPT
      UDUJDUEULUFUGUHUI $.
  $}

  ${
    $d k x y z A $.  $d k y z F $.  $d k x G $.  $d k x y z ph $.  $d k y Z $.
    $d k x y z H $.  $d k M $.
    climcn1lem.1 $e |- Z = ( ZZ>= ` M ) $.
    climcn1lem.2 $e |- ( ph -> F ~~> A ) $.
    climcn1lem.4 $e |- ( ph -> G e. W ) $.
    climcn1lem.5 $e |- ( ph -> M e. ZZ ) $.
    climcn1lem.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    ${
      climcn1lem.7 $e |- H : CC --> CC $.
      climcn1lem.8 $e |- ( ( A e. CC /\ x e. RR+ ) -> E. y e. RR+ A. z e. CC
                    ( ( abs ` ( z - A ) ) < y ->
                      ( abs ` ( ( H ` z ) - ( H ` A ) ) ) < x ) ) $.
      climcn1lem.9 $e |- ( ( ph /\ k e. Z ) ->
                           ( G ` k ) = ( H ` ( F ` k ) ) ) $.
      $( The limit of a continuous function, theorem form.  (Contributed by
         Mario Carneiro, 9-Feb-2014.) $)
      climcn1lem $p |- ( ph -> G ~~> ( H ` A ) ) $=
        ( cc cli wbr wcel climcl syl cv cfv ffvelrni adantl crp cmin co cabs wi
        clt wral wrex sylan climcn1 ) ABCDEUAFIGHJKLMPAGEUBUCEUAUDZNEGUEUFZDUGZ
        UAUDVCIUHZUAUDAUAUAVCIRUIUJNOAVABUGZUKUDVCEULUMUNUHCUGUPUCVDEIUHULUMUNU
        HVEUPUCUODUAUQCUKURVBSUSQTUT $.
    $}

    ${
      climabs.7 $e |- ( ( ph /\ k e. Z ) ->
                        ( G ` k ) = ( abs ` ( F ` k ) ) ) $.
      $( Limit of the absolute value of a sequence.  Proposition 12-2.4(c) of
         [Gleason] p. 172.  (Contributed by NM, 7-Jun-2006.)  (Revised by Mario
         Carneiro, 9-Feb-2014.) $)
      climabs $p |- ( ph -> G ~~> ( abs ` A ) ) $=
        ( vx vy vz cabs cc cr wf wss absf ax-resscn fss mp2an abscn2 climcn1lem
        ) AOPQBCDERFGHIJKLMSTRUATSUBSSRUAUCUDSTSRUEUFOPQBUGNUH $.
    $}

    ${
      climcj.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = ( * ` ( F ` k ) ) ) $.
      $( Limit of the complex conjugate of a sequence.  Proposition 12-2.4(c)
         of [Gleason] p. 172.  (Contributed by NM, 7-Jun-2006.)  (Revised by
         Mario Carneiro, 9-Feb-2014.) $)
      climcj $p |- ( ph -> G ~~> ( * ` A ) ) $=
        ( vx vy vz ccj cjf cjcn2 climcn1lem ) AOPQBCDERFGHIJKLMSOPQBTNUA $.
    $}

    ${
      climre.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = ( Re ` ( F ` k ) ) ) $.
      $( Limit of the real part of a sequence.  Proposition 12-2.4(c) of
         [Gleason] p. 172.  (Contributed by NM, 7-Jun-2006.)  (Revised by Mario
         Carneiro, 9-Feb-2014.) $)
      climre $p |- ( ph -> G ~~> ( Re ` A ) ) $=
        ( vx vy vz cre cc cr wf wss ref ax-resscn fss mp2an recn2 climcn1lem )
        AOPQBCDERFGHIJKLMSTRUATSUBSSRUAUCUDSTSRUEUFOPQBUGNUH $.
    $}

    ${
      climim.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = ( Im ` ( F ` k ) ) ) $.
      $( Limit of the imaginary part of a sequence.  Proposition 12-2.4(c) of
         [Gleason] p. 172.  (Contributed by NM, 7-Jun-2006.)  (Revised by Mario
         Carneiro, 9-Feb-2014.) $)
      climim $p |- ( ph -> G ~~> ( Im ` A ) ) $=
        ( vx vy vz cim cc cr wf wss imf ax-resscn fss mp2an imcn2 climcn1lem )
        AOPQBCDERFGHIJKLMSTRUATSUBSSRUAUCUDSTSRUEUFOPQBUGNUH $.
    $}
  $}

  ${
    $d k x y z A $.  $d x y z B $.  $d x y z C $.  $d k x y ph $.
    rlimabs.1 $e |- ( ( ph /\ k e. A ) -> B e. V ) $.
    rlimabs.2 $e |- ( ph -> ( k e. A |-> B ) ~~>r C ) $.
    $( Reverse closure for a real limit.  (Contributed by Mario Carneiro,
       10-May-2016.) $)
    rlimmptrcl $p |- ( ( ph /\ k e. A ) -> B e. CC ) $=
      ( cc wcel cmpt wf wral cdm crli wbr rlimf syl wfn wceq fnmpt feq2d sylibr
      ralrimiva eqid fndm 3syl mpbid fmpt r19.21bi ) ACIJZEBABIEBCKZLZUKEBMAULN
      ZIULLZUMAULDOPUOHDULQRAUNBIULACFJZEBMULBSUNBTAUPEBGUDEBCULFULUEZUABULUFUG
      UBUHEBICULUQUIUCUJ $.

    $( Limit of the absolute value of a sequence.  Proposition 12-2.4(c) of
       [Gleason] p. 172.  (Contributed by Mario Carneiro, 10-May-2016.) $)
    rlimabs $p |- ( ph -> ( k e. A |-> ( abs ` B ) ) ~~>r ( abs ` C ) ) $=
      ( vx vy vz cabs cc wbr wcel wf cr cv crp cfv rlimmptrcl cmpt crli syl wss
      rlimcl absf ax-resscn fss mp2an a1i cmin co clt wi wral wrex abscn2 sylan
      rlimcn1b ) AIJKBCDELMABCDEFGHUAAEBCUBZDUCNDMOZHDVAUFUDZHMMLPZAMQLPQMUEVDU
      GUHMQMLUIUJUKAVBIRZSOKRZDULUMLTJRUNNVFLTDLTULUMLTVEUNNUOKMUPJSUQVCIJKDURU
      SUT $.

    $( Limit of the complex conjugate of a sequence.  Proposition 12-2.4(c) of
       [Gleason] p. 172.  (Contributed by Mario Carneiro, 10-May-2016.) $)
    rlimcj $p |- ( ph -> ( k e. A |-> ( * ` B ) ) ~~>r ( * ` C ) ) $=
      ( vx vy vz ccj cc wbr wcel cv crp cmin co cfv rlimmptrcl cmpt crli rlimcl
      syl wf cjf a1i cabs clt wi wral wrex cjcn2 sylan rlimcn1b ) AIJKBCDELMABC
      DEFGHUAAEBCUBZDUCNDMOZHDUQUDUEZHMMLUFAUGUHAURIPZQOKPZDRSUITJPUJNVALTDLTRS
      UITUTUJNUKKMULJQUMUSIJKDUNUOUP $.

    $( Limit of the real part of a sequence.  Proposition 12-2.4(c) of
       [Gleason] p. 172.  (Contributed by Mario Carneiro, 10-May-2016.) $)
    rlimre $p |- ( ph -> ( k e. A |-> ( Re ` B ) ) ~~>r ( Re ` C ) ) $=
      ( vx vy vz cre cc wbr wcel wf cr cv crp cfv rlimmptrcl rlimcl syl wss ref
      cmpt crli ax-resscn fss mp2an a1i cmin co cabs clt wi wral recn2 rlimcn1b
      wrex sylan ) AIJKBCDELMABCDEFGHUAAEBCUFZDUGNDMOZHDVBUBUCZHMMLPZAMQLPQMUDV
      EUEUHMQMLUIUJUKAVCIRZSOKRZDULUMUNTJRUONVGLTDLTULUMUNTVFUONUPKMUQJSUTVDIJK
      DURVAUS $.

    $( Limit of the imaginary part of a sequence.  Proposition 12-2.4(c) of
       [Gleason] p. 172.  (Contributed by Mario Carneiro, 10-May-2016.) $)
    rlimim $p |- ( ph -> ( k e. A |-> ( Im ` B ) ) ~~>r ( Im ` C ) ) $=
      ( vx vy vz cim cc wbr wcel wf cr cv crp cfv rlimmptrcl rlimcl syl wss imf
      cmpt crli ax-resscn fss mp2an a1i cmin co cabs clt wi wral imcn2 rlimcn1b
      wrex sylan ) AIJKBCDELMABCDEFGHUAAEBCUFZDUGNDMOZHDVBUBUCZHMMLPZAMQLPQMUDV
      EUEUHMQMLUIUJUKAVCIRZSOKRZDULUMUNTJRUONVGLTDLTULUMUNTVFUONUPKMUQJSUTVDIJK
      DURVAUS $.
  $}

  ${
    $d a b m n x y z F $.  $d a b m n x y z G $.  $d a b m n x y z R $.
    $d x y z M $.
    o1of2.1 $e |- ( ( m e. RR /\ n e. RR ) -> M e. RR ) $.
    o1of2.2 $e |- ( ( x e. CC /\ y e. CC ) -> ( x R y ) e. CC ) $.
    o1of2.3 $e |- ( ( ( m e. RR /\ n e. RR ) /\ ( x e. CC /\ y e. CC ) ) ->
                    ( ( ( abs ` x ) <_ m /\ ( abs ` y ) <_ n ) ->
                      ( abs ` ( x R y ) ) <_ M ) ) $.
    $( Show that a binary operation preserves eventual boundedness.
       (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    o1of2 $p |- ( ( F e. O(1) /\ G e. O(1) ) -> ( F oF R G ) e. O(1) ) $=
      ( vz wcel wa cle wbr cfv cabs cr cc va vb co1 cv wi cdm wral wrex cof o1f
      co wf o1bdd mpdan adantr adantl reeanv cin wss inss1 ssralv ax-mp anim12i
      inss2 r19.26 sylibr cif prth simplrl simplrr o1dm ad3antrrr syl5ss sselda
      wb maxle syl3anc biimpd sseli ffvelrn syl2an ad3antlr ralrimivva ad2antlr
      wceq fveq2 breq1d anbi1d oveq1 fveq2d imbi12d anbi2d rspc2va syl21anc cvv
      oveq2 wfn ffn syl reex ssexg sylancl dmexg eqidd sylibrd imim12d ralimdva
      eqid syl5 off ifcl syl2anc elo12r 3expia syl22anc syld rexlimdvva syl5bir
      ofval mp2and ) FUCMZGUCMZNZUAUDZLUDZOPZYEFQZRQZDUDZOPZUEZLFUFZUGZDSUHZUAS
      UHZUBUDZYEOPZYEGQZRQZEUDZOPZUEZLGUFZUGZESUHZUBSUHZFGCUIUKZUCMZYAYOYBYAYLT
      FULZYOFUJZUALYLDFUMUNUOYBUUFYAYBUUCTGULZUUFGUJZUBLUUCEGUMUNUPYOUUFNYNUUEN
      ZUBSUHUASUHYCUUHYNUUEUAUBSSUQYCUUMUUHUAUBSSUUMYMUUDNZESUHDSUHYCYDSMZYPSMZ
      NZNZUUHYMUUDDESSUQUURUUNUUHDESSUUNYKUUBNZLYLUUCURZUGZUURYISMYTSMNZNZUUHUU
      NYKLUUTUGZUUBLUUTUGZNUVAYMUVDUUDUVEUUTYLUSYMUVDUEYLUUCUTZYKLUUTYLVAVBUUTU
      UCUSUUDUVEUEYLUUCVDZUUBLUUTUUCVAVBVCYKUUBLUUTVEVFUVCUVAYDYPOPZYPYDVGZYEOP
      ZYEUUGQZRQZHOPZUEZLUUTUGZUUHUVCUUSUVNLUUTUUSYFYQNZYJUUANZUEUVCYEUUTMZNZUV
      NYFYJYQUUAVHUVSUVJUVPUVQUVMUVSUVJUVPUVSUUOUUPYESMUVJUVPVOUVCUUOUVRYCUUOUU
      PUVBVIZUOUVCUUPUVRYCUUOUUPUVBVJZUOUVCUUTSYEUVCUUTYLSUVFYAYLSUSZYBUUQUVBFV
      KVLZVMZVNYDYPYEVPVQVRUVSUVQYGYRCUKZRQZHOPZUVMUVSYGTMZYRTMZAUDZRQZYIOPZBUD
      ZRQZYTOPZNZUWJUWMCUKZRQZHOPZUEZBTUGATUGZUVQUWGUEZUVCUUIYEYLMZUWHUVRYAUUIY
      BUUQUVBUUJVLZUUTYLYEUVFVSYLTYEFVTWAUVCUUKYEUUCMZUWIUVRYBUUKYAUUQUVBUULWBZ
      UUTUUCYEUVGVSUUCTYEGVTWAUVBUXAUURUVRUVBUWTABTTKWCWDUWTUXBYJUWONZYGUWMCUKZ
      RQZHOPZUEABYGYRTTUWJYGWEZUWPUXGUWSUXJUXKUWLYJUWOUXKUWKYHYIOUWJYGRWFWGWHUX
      KUWRUXIHOUXKUWQUXHRUWJYGUWMCWIWJWGWKUWMYRWEZUXGUVQUXJUWGUXLUWOUUAYJUXLUWN
      YSYTOUWMYRRWFWGWLUXLUXIUWFHOUXLUXHUWERUWMYRYGCWPWJWGWKWMWNUVSUVLUWFHOUVSU
      VKUWERUVCYLUUCYGYRCUUTFGWOWOYEUVCUUIFYLWQUXDYLTFWRWSUVCUUKGUUCWQUXFUUCTGW
      RWSUVCUWBSWOMYLWOMUWCWTYLSWOXAXBZYBUUCWOMYAUUQUVBGUCXCWBZUUTXHZUVCUXCNYGX
      DUVCUXENYRXDXSWJWGXEXFXIXGUVCUUTTUUGULZUUTSUSZUVISMZHSMZUVOUUHUEUVCABYLUU
      CUUTCTTTFGWOWOUWJTMUWMTMNUWQTMUVCJUPUXDUXFUXMUXNUXOXJUWDUVCUUPUUOUXRUWAUV
      TUVHYPYDSXKXLUVBUXSUURIUPUXPUXQNUXRUXSNUVOUUHLUUTUVIUUGHXMXNXOXPXIXQXRXQX
      RXT $.
  $}

  ${
    $d w x y z A $.  $d x B $.  $d a b m n w x y z F $.  $d a b m n x y z G $.
    $( The sum of two eventually bounded functions is eventually bounded.
       (Contributed by Mario Carneiro, 15-Sep-2014.)  (Proof shortened by Fan
       Zheng, 14-Jul-2016.) $)
    o1add $p |- ( ( F e. O(1) /\ G e. O(1) ) -> ( F oF + G ) e. O(1) ) $=
      ( vm vn vx vy caddc cv co readdcl cr wcel wa cc cabs cfv cle wbr readdcld
      abscld addcl w3a simp2l simp2r addcld simp1l simp1r abstrid simp3l simp3r
      le2addd letrd 3expia o1of2 ) CDGEFABEHZFHZGIZUOUPJCHZDHZUAUOKLZUPKLZMZURN
      LZUSNLZMZUROPZUOQRZUSOPZUPQRZMZURUSGIZOPZUQQRVBVEVJUBZVLVFVHGIUQVMVKVMURU
      SVBVCVDVJUCZVBVCVDVJUDZUETVMVFVHVMURVNTZVMUSVOTZSVMUOUPUTVAVEVJUFZUTVAVEV
      JUGZSVMURUSVNVOUHVMVFVHUOUPVPVQVRVSVBVEVGVIUIVBVEVGVIUJUKULUMUN $.

    $( The product of two eventually bounded functions is eventually bounded.
       (Contributed by Mario Carneiro, 15-Sep-2014.)  (Proof shortened by Fan
       Zheng, 14-Jul-2016.) $)
    o1mul $p |- ( ( F e. O(1) /\ G e. O(1) ) -> ( F oF x. G ) e. O(1) ) $=
      ( vx vy vm vn cmul cv co remulcl cr wcel wa cc cfv cle wbr abscld absge0d
      cabs mulcl w3a simp2l simp2r simp1l simp1r simp3l simp3r lemul12ad 3expia
      absmuld eqbrtrd o1of2 ) CDGEFABEHZFHZGIZUNUOJCHZDHZUAUNKLZUOKLZMZUQNLZURN
      LZMZUQTOZUNPQZURTOZUOPQZMZUQURGITOZUPPQVAVDVIUBZVJVEVGGIUPPVKUQURVAVBVCVI
      UCZVAVBVCVIUDZUKVKVEUNVGUOVKUQVLRUSUTVDVIUEVKURVMRUSUTVDVIUFVKUQVLSVKURVM
      SVAVDVFVHUGVAVDVFVHUHUIULUJUM $.

    $( The difference of two eventually bounded functions is eventually
       bounded.  (Contributed by Mario Carneiro, 15-Sep-2014.)  (Proof
       shortened by Fan Zheng, 14-Jul-2016.) $)
    o1sub $p |- ( ( F e. O(1) /\ G e. O(1) ) -> ( F oF - G ) e. O(1) ) $=
      ( vm vn vx vy cmin cv caddc co cr wcel wa cc cabs cfv cle abscld readdcld
      wbr readdcl subcl w3a simp2l simp2r subcld simp1l simp1r abs2dif2d simp3l
      simp3r le2addd letrd 3expia o1of2 ) CDGEFABEHZFHZIJZUPUQUACHZDHZUBUPKLZUQ
      KLZMZUSNLZUTNLZMZUSOPZUPQTZUTOPZUQQTZMZUSUTGJZOPZURQTVCVFVKUCZVMVGVIIJURV
      NVLVNUSUTVCVDVEVKUDZVCVDVEVKUEZUFRVNVGVIVNUSVORZVNUTVPRZSVNUPUQVAVBVFVKUG
      ZVAVBVFVKUHZSVNUSUTVOVPUIVNVGVIUPUQVQVRVSVTVCVFVHVJUJVCVFVHVJUKULUMUNUO
      $.

    $( Any function with a finite limit is eventually bounded.  (Contributed by
       Mario Carneiro, 18-Sep-2014.) $)
    rlimo1 $p |- ( F ~~>r A -> F e. O(1) ) $=
      ( vy vz vw wbr wcel cv cle cfv cabs wi wral cr wrex co c1 clt cc adantr
      crli co1 cdm cmin rlimf ffvelrnda ralrimiva crp 1rp cmpt feqmptd eqbrtrrd
      a1i id rlimi wa caddc rlimcl abscld peano2re syl abs2difd resubcld subcld
      adantlr lelttr syl3anc mpand ltsubadd2d sylibd ltle syl2anc syld ralimdva
      1re imim2d wceq breq2 imbi2d ralbidv rspcev ee12an reximdva mpd wf wss wb
      rlimss elo12 mpbird ) BAUAFZBUBGZCHZDHZIFZWNBJZKJZEHZIFZLZDBUCZMZENOZCNOZ
      WKWOWPAUDPZKJZQRFZLZDXAMZCNOXDWKCDXAWPAQSWKWPSGZDXAWKXASWNBABUEZUFZUGQUHG
      WKUIUMWKBDXAWPUJAUAWKDXASBXKUKWKUNULUOWKXIXCCNWKWMNGZUPZAKJZQUQPZNGZXIWOW
      QXPIFZLZDXAMZXCXNXONGZXQXNAWKASGZXMABURTZUSZXOUTVAZXNXHXSDXAXNWNXAGZUPZXG
      XRWOYGXGWQXPRFZXRYGXGWQXOUDPZQRFZYHYGYIXFIFZXGYJYGWPAWKYFXJXMXLVEZXNYBYFY
      CTZVBYGYINGXFNGQNGZYKXGUPYJLYGWQXOYGWPYLUSZXNYAYFYDTZVCYGXEYGWPAYLYMVDUSY
      NYGVOUMZYIXFQVFVGVHYGWQXOQYOYPYQVIVJYGWQNGXQYHXRLYOXNXQYFYETWQXPVKVLVMVPV
      NXBXTEXPNWRXPVQZWTXSDXAYRWSXRWOWRXPWQIVRVSVTWAWBWCWDWKXASBWEXANWFWLXDWGXK
      ABWHCDXAEBWIVLWJ $.

    $( A convergent function is eventually bounded.  (Contributed by Mario
       Carneiro, 12-May-2016.) $)
    rlimdmo1 $p |- ( F e. dom ~~>r -> F e. O(1) ) $=
      ( vx crli cdm wcel cv wbr wex co1 eldmg ibi rlimo1 exlimiv syl ) ACDZEZAB
      FZCGZBHZAIEZPSBACOJKRTBQALMN $.

    $( The product of an eventually bounded function and a function of limit
       zero has limit zero.  (Contributed by Mario Carneiro, 18-Sep-2014.) $)
    o1rlimmul $p |- ( ( F e. O(1) /\ G ~~>r 0 ) -> ( F oF x. G ) ~~>r 0 ) $=
      ( vx wcel cc0 wbr wa cmul co cv cfv cvv cc adantr cr cle cabs clt wi wral
      vz vy va vm vb co1 crli cof cdm cin cmpt wfn o1f ffn syl rlimf adantl wss
      o1dm reex ssexg sylancl rlimss eqid eqidd offval crp o1bdd mpdan ad2antrr
      wf wrex cmin c1 caddc cdiv fvex a1i ralrimiva simplr recn ad2antll abscld
      absge0d ge0p1rpd rpdivcld feqmptd simpr eqbrtrrd rlimi inss1 ssralv ax-mp
      cif inss2 anim12i r19.26 sylibr ralimi wb simplrl simprl syl5ss ad3antrrr
      prth simprr sseldd maxle syl3anc biimpd sseli subid1d fveq2d breq1d rpred
      ffvelrnd ltle syl2anc sylbid anim2d jca simplrr lemul12a syl22anc absmuld
      recnd rpcnd rpne0d divassd peano2re leabsd ltp1d ltmul1dd remulcld mpbird
      lelttrd mulcld mpd ffvelrn syl2an ltdivmuld lelttr mpan2d sylbird imim12d
      3syld anassrs ralimdva ifcl jctild wceq breq1 imbi1d ralbidv rspcev syl56
      exp3acom23 rexlimdva rexlimdvva rlim0 eqbrtrd ) AUFDZBEUGFZGZABHUHICAUIZB
      UIZUJZCJZAKZUVHBKZHIZUKZEUGUVDCUVEUVFUVIUVJHUVGABLLUVDUVEMAVKZAUVEULUVBUV
      MUVCAUMZNZUVEMAUNUOUVDUVFMBVKZBUVFULUVCUVPUVBEBUPUQZUVFMBUNUOUVDUVEOURZOL
      DZUVELDUVBUVRUVCAUSNZUTUVEOLVAVBUVDUVFOURZUVSUVFLDUVCUWAUVBEBVCUQUTUVFOLV
      AVBUVGVDUVDUVHUVEDZGUVIVEUVDUVHUVFDZGUVJVEVFUVDUVLEUGFUAJZUVHPFZUVKQKZUBJ
      ZRFZSZCUVGTZUAOVLZUBVGTUVDUWKUBVGUVDUWGVGDZGZUCJZUVHPFZUVIQKZUDJZPFZSZCUV
      ETZUDOVLUCOVLZUWKUVBUXAUVCUWLUVBUVMUXAUVNUCCUVEUDAVHVIVJUWMUWTUWKUCUDOOUW
      MUWNODZUWQODZGZGZUEJZUVHPFZUVJEVMIZQKZUWGUWQQKZVNVOIZVPIZRFZSZCUVFTZUEOVL
      UWTUWKSZUXEUECUVFUVJEUXLLUXEUVJLDZCUVFUXQUXEUWCGUVHBVQVRVSUXEUWGUXKUVDUWL
      UXDVTZUXEUXJUXEUWQUXCUWQMDUWMUXBUWQWAWBZWCZUXEUWQUXSWDWEZWFZUVDCUVFUVJUKZ
      EUGFUWLUXDUVDBUYCEUGUVDCUVFMBUVQWGUVBUVCWHWIVJWJUXEUXOUXPUEOUXEUXFODZGZUW
      TUXOUWKUWTUXOGZUWOUXGGZUWRUXMGZSZCUVGTZUYEUWNUXFPFZUXFUWNWNZODZUYLUVHPFZU
      WHSZCUVGTZGUWKUYFUWSUXNGZCUVGTZUYJUYFUWSCUVGTZUXNCUVGTZGUYRUWTUYSUXOUYTUV
      GUVEURUWTUYSSUVEUVFWKZUWSCUVGUVEWLWMUVGUVFURUXOUYTSUVEUVFWOZUXNCUVGUVFWLW
      MWPUWSUXNCUVGWQWRUYQUYICUVGUWOUWRUXGUXMXEWSUOUYEUYJUYPUYMUYEUYIUYOCUVGUXE
      UYDUVHUVGDZUYIUYOSUXEUYDVUCGZGZUYNUYGUYHUWHVUEUYNUYGVUEUXBUYDUVHODUYNUYGW
      TUWMUXBUXCVUDXAUXEUYDVUCXBVUEUVGOUVHUVDUVGOURUWLUXDVUDUVDUVGUVEOVUAUVTXCZ
      XDUXEUYDVUCXFXGUWNUXFUVHXHXIXJVUEUYHUWRUVJQKZUXLPFZGZUWPVUGHIZUWQUXLHIZPF
      ZUWHVUEUXMVUHUWRVUEUXMVUGUXLRFZVUHVUEUXIVUGUXLRVUEUXHUVJQVUEUVJVUEUVFMUVH
      BUVDUVPUWLUXDVUDUVQXDVUCUWCUXEUYDUVGUVFUVHVUBXKZWBXPZXLXMXNVUEVUGODZUXLOD
      ZVUMVUHSVUEUVJVUOWCZVUEUXLUXEUXLVGDVUDUYBNXOZVUGUXLXQXRXSXTVUEUWPODZEUWPP
      FZGUXCVUPEVUGPFZGVUQVUIVULSVUEVUTVVAVUEUVIVUEUVEMUVHAUVDUVMUWLUXDVUDUVOXD
      VUCUWBUXEUYDUVGUVEUVHVUAXKZWBXPZWCVUEUVIVVDWDYAUWMUXBUXCVUDYBZVUEVUPVVBVU
      RVUEUVJVUOWDYAVUSUWPUWQVUGUXLYCYDVUEVULUWFVUKPFZUWHVUEUWFVUJVUKPVUEUVIUVJ
      VVDVUOYEXNVUEVVFVUKUWGRFZUWHVUEUWQUWGHIZUXKVPIZVUKUWGRVUEUWQUWGUXKVUEUWQV
      VEYFVUEUWGUXEUWLVUDUXRNZYGVUEUXKUXEUXKVGDVUDUYANZYGVUEUXKVVKYHYIVUEVVIUWG
      RFVVHUXKUWGHIRFVUEUWQUXKUWGVVEUXEUXKODZVUDUXEUXJODZVVLUXTUXJYJUONZVVJVUEU
      WQUXJUXKVVEUXEVVMVUDUXTNZVVNVUEUWQVVEYKVUEUXJVVOYLYPYMVUEVVHUWGUXKVUEUWQU
      WGVVEVUEUWGVVJXOZYNVVPVVKUUAYOWIVUEUWFODVUKODUWGODVVFVVGGUWHSVUEUVKVUEUVI
      UVJVVDVUOYQWCVUEUWQUXLVVEVUSYNVVPUWFVUKUWGUUBXIUUCUUDUUFUUEUUGUUHUYEUYDUX
      BUYMUXEUYDWHUWMUXBUXCUYDXAUYKUXFUWNOUUIXRUUJUWJUYPUAUYLOUWDUYLUUKZUWIUYOC
      UVGVVQUWEUYNUWHUWDUYLUVHPUULUUMUUNUUOUUPUUQUURYRUUSYRVSUVDUBUACUVGUVKUVDU
      VKMDCUVGUVDVUCGUVIUVJUVDUVMUWBUVIMDVUCUVOVVCUVEMUVHAYSYTUVDUVPUWCUVJMDVUC
      UVQVUNUVFMUVHBYSYTYQVSVUFUUTYOUVA $.

    $( A constant function is eventually bounded.  (Contributed by Mario
       Carneiro, 15-Sep-2014.)  (Proof shortened by Mario Carneiro,
       26-May-2016.) $)
    o1const $p |- ( ( A C_ RR /\ B e. CC ) -> ( x e. A |-> B ) e. O(1) ) $=
      ( cr wss cc wcel wa cmpt crli wbr co1 rlimconst rlimo1 syl ) BDECFGHABCIZ
      CJKPLGABCMCPNO $.

    $( A constant function is eventually upper bounded.  (Contributed by Mario
       Carneiro, 26-May-2016.) $)
    lo1const $p |- ( ( A C_ RR /\ B e. RR ) -> ( x e. A |-> B ) e. <_O(1) ) $=
      ( cr wss wcel wa simpl cv simplr simpr cle wbr leid ad2antlr ello1d ) BDE
      ZCDFZGABCCCQRHQRAIZBFZJQRKZUARCCLMQTCSLMGCNOP $.
  $}

  ${
    $d c m n p x A $.  $d c m n p B $.  $d c m n p C $.  $d c m n p x ph $.
    o1add2.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    ${
      lo1mptrcl.3 $e |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $.
      $( Reverse closure for an eventually upper bounded function.
         (Contributed by Mario Carneiro, 26-May-2016.) $)
      lo1mptrcl $p |- ( ( ph /\ x e. A ) -> B e. RR ) $=
        ( cr wcel cmpt wf wral cdm clo1 lo1f syl wceq ralrimiva dmmptg feq2d
        mpbid eqid fmpt sylibr r19.21bi ) ADHIZBCACHBCDJZKZUFBCLAUGMZHUGKZUHAUG
        NIUJGUGOPAUICHUGADEIZBCLUICQAUKBCFRBCDESPTUABCHDUGUGUBUCUDUE $.
    $}

    ${
      o1mptrcl.3 $e |- ( ph -> ( x e. A |-> B ) e. O(1) ) $.
      $( Reverse closure for an eventually bounded function.  (Contributed by
         Mario Carneiro, 26-May-2016.) $)
      o1mptrcl $p |- ( ( ph /\ x e. A ) -> B e. CC ) $=
        ( cc wcel cmpt wf wral cdm co1 o1f syl wceq ralrimiva dmmptg feq2d eqid
        mpbid fmpt sylibr r19.21bi ) ADHIZBCACHBCDJZKZUFBCLAUGMZHUGKZUHAUGNIUJG
        UGOPAUICHUGADEIZBCLUICQAUKBCFRBCDESPTUBBCHDUGUGUAUCUDUE $.
    $}

    o1add2.2 $e |- ( ( ph /\ x e. A ) -> C e. V ) $.
    ${
      o1add2.3 $e |- ( ph -> ( x e. A |-> B ) e. O(1) ) $.
      o1add2.4 $e |- ( ph -> ( x e. A |-> C ) e. O(1) ) $.
      $( The sum of two eventually bounded functions is eventually bounded.
         (Contributed by Mario Carneiro, 26-May-2016.) $)
      o1add2 $p |- ( ph -> ( x e. A |-> ( B + C ) ) e. O(1) ) $=
        ( cmpt caddc co co1 cvv cr wss wcel syl eqidd cof wral ralrimiva dmmptg
        cdm wceq o1dm eqsstr3d reex ssex offval2 o1add syl2anc eqeltrrd ) ABCDK
        ZBCEKZLUAMZBCDELMKNABCDELUOUPOFFACPQCORACUOUEZPADFRZBCUBURCUFAUSBCGUCBC
        DFUDSAUONRZURPQIUOUGSUHCPUIUJSGHAUOTAUPTUKAUTUPNRUQNRIJUOUPULUMUN $.

      $( The product of two eventually bounded functions is eventually
         bounded.  (Contributed by Mario Carneiro, 26-May-2016.) $)
      o1mul2 $p |- ( ph -> ( x e. A |-> ( B x. C ) ) e. O(1) ) $=
        ( cmpt cmul co co1 cvv cr wss wcel syl eqidd wral wceq ralrimiva dmmptg
        cof cdm o1dm eqsstr3d reex ssex offval2 o1mul syl2anc eqeltrrd ) ABCDKZ
        BCEKZLUEMZBCDELMKNABCDELUOUPOFFACPQCORACUOUFZPADFRZBCUAURCUBAUSBCGUCBCD
        FUDSAUONRZURPQIUOUGSUHCPUIUJSGHAUOTAUPTUKAUTUPNRUQNRIJUOUPULUMUN $.

      $( The product of two eventually bounded functions is eventually
         bounded.  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
      o1sub2 $p |- ( ph -> ( x e. A |-> ( B - C ) ) e. O(1) ) $=
        ( cmpt cmin co co1 cvv cr wss wcel syl eqidd wral wceq ralrimiva dmmptg
        cof cdm o1dm eqsstr3d reex ssex offval2 o1sub syl2anc eqeltrrd ) ABCDKZ
        BCEKZLUEMZBCDELMKNABCDELUOUPOFFACPQCORACUOUFZPADFRZBCUAURCUBAUSBCGUCBCD
        FUDSAUONRZURPQIUOUGSUHCPUIUJSGHAUOTAUPTUKAUTUPNRUQNRIJUOUPULUMUN $.
    $}

    ${
      lo1add.3 $e |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $.
      lo1add.4 $e |- ( ph -> ( x e. A |-> C ) e. <_O(1) ) $.
      $( The sum of two eventually upper bounded functions is eventually upper
         bounded.  (Contributed by Mario Carneiro, 26-May-2016.) $)
      lo1add $p |- ( ph -> ( x e. A |-> ( B + C ) ) e. <_O(1) ) $=
        ( vc vm vn wcel cle wi wral cr wrex wa vp cmpt clo1 caddc co wbr reeanv
        cv wss wb cdm wceq ralrimiva dmmptg syl eqsstr3d adantr rexanre readdcl
        lo1dm adantl lo1mptrcl adantlr simplrl simplrr le2add syl22anc ralimdva
        imim2d imbi2d ralbidv rspcev ee12an reximdv sylbird rexlimdvva ello1mpt
        breq2 syl5bir rexcom syl6bb anbi12d readdcld 3imtr4d mp2and ) ABCDUBZUC
        NZBCEUBUCNZBCDEUDUEZUBUCNZIJAKUHBUHZOUFZDLUHZOUFZPBCQZKRSZLRSZWLEMUHZOU
        FZPBCQZKRSZMRSZTZWLWIUAUHZOUFZPZBCQZUARSZKRSZWGWHTWJXCWPXATZMRSLRSAXIWP
        XALMRRUGAXJXILMRRAWMRNZWRRNZTZTZXJWLWNWSTZPZBCQZKRSZXIXNCRUIZXRXJUJAXSX
        MACWFUKZRADFNZBCQXTCULAYABCGUMBCDFUNUOAWGXTRUIIWFUTUOUPZUQWNWSCKBURUOXN
        XQXHKRXNWMWRUDUEZRNZXQWLWIYCOUFZPZBCQZXHXMYDAWMWRUSVAXNXPYFBCXNWKCNZTZX
        OYEWLYIDRNZERNZXKXLXOYEPAYHYJXMABCDFGIVBZVCAYHYKXMABCEFHJVBZVCAXKXLYHVD
        AXKXLYHVEDEWMWRVFVGVIVHXGYGUAYCRXDYCULZXFYFBCYNXEYEWLXDYCWIOVRVJVKVLVMV
        NVOVPVSAWGWQWHXBAWGWOLRSKRSWQABKCDLYBYLVQWOKLRRVTWAAWHWTMRSKRSXBABKCEMY
        BYMVQWTKMRRVTWAWBABKCWIUAYBAYHTDEYLYMWCVQWDWE $.

      lo1mul.5 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
      $( The product of an eventually upper bounded function and a positive
         eventually upper bounded function is eventually upper bounded.
         (Contributed by Mario Carneiro, 26-May-2016.) $)
      lo1mul $p |- ( ph -> ( x e. A |-> ( B x. C ) ) e. <_O(1) ) $=
        ( vc vm vn wcel cle wbr cr wrex wa vp cmpt clo1 cmul co wral reeanv wss
        cv wi wb cdm ralrimiva dmmptg syl lo1dm eqsstr3d adantr rexanre cc0 cif
        wceq simprl simprr ifcl sylancl remulcld simplrr max2 sylancr lo1mptrcl
        0re adantlr syl3anc mpan2d jca simplrl lemul12b syl22anc sylan2d imim2d
        letr max1 breq2 imbi2d ralbidv rspcev ee12an reximdv sylbird rexlimdvva
        ralimdva syl5bir ello1mpt rexcom syl6bb anbi12d 3imtr4d mp2and ) ABCDUB
        ZUCOZBCEUBUCOZBCDEUDUEZUBUCOZIJALUIBUIZPQZDMUIZPQZUJBCUFZLRSZMRSZXFENUI
        ZPQZUJBCUFZLRSZNRSZTZXFXCUAUIZPQZUJZBCUFZUARSZLRSZXAXBTXDXQXJXOTZNRSMRS
        AYCXJXOMNRRUGAYDYCMNRRAXGROZXLROZTZTZYDXFXHXMTZUJZBCUFZLRSZYCYHCRUHZYLY
        DUKAYMYGACWTULZRADFOZBCUFYNCVBAYOBCGUMBCDFUNUOAXAYNRUHIWTUPUOUQZURXHXMC
        LBUSUOYHYKYBLRYHXGUTXLPQZXLUTVAZUDUEZROYKXFXCYSPQZUJZBCUFZYBYHXGYRAYEYF
        VCYHYFUTROZYRROZAYEYFVDVLYQXLUTRVEZVFVGYHYJUUABCYHXECOZTZYIYTXFUUGXMEYR
        PQZXHYTUUGXMXLYRPQZUUHUUGUUCYFUUIVLAYEYFUUFVHZUTXLVIVJUUGEROZYFUUDXMUUI
        TUUHUJAUUFUUKYGABCEFHJVKZVMZUUJUUGYFUUCUUDUUJVLUUEVFZEXLYRWBVNVOUUGDROZ
        UTDPQZTYEUUKUUDUTYRPQZTXHUUHTYTUJUUGUUOUUPAUUFUUOYGABCDFGIVKZVMAUUFUUPY
        GKVMVPAYEYFUUFVQUUMUUGUUDUUQUUNUUGUUCYFUUQVLUUJUTXLWCVJVPDXGEYRVRVSVTWA
        WLYAUUBUAYSRXRYSVBZXTUUABCUUSXSYTXFXRYSXCPWDWEWFWGWHWIWJWKWMAXAXKXBXPAX
        AXIMRSLRSXKABLCDMYPUURWNXILMRRWOWPAXBXNNRSLRSXPABLCENYPUULWNXNLNRRWOWPW
        QABLCXCUAYPAUUFTDEUURUULVGWNWRWS $.

      $( The product of an eventually upper bounded function and a positive
         eventually upper bounded function is eventually upper bounded.
         (Contributed by Mario Carneiro, 26-May-2016.) $)
      lo1mul2 $p |- ( ph -> ( x e. A |-> ( C x. B ) ) e. <_O(1) ) $=
        ( cmul co cmpt clo1 cv wcel wa lo1mptrcl recnd mulcomd mpteq2dva lo1mul
        eqeltrd ) ABCEDLMZNBCDELMZNOABCUEUFABPCQRZEDUGEABCEFHJSTUGDABCDFGISTUAU
        BABCDEFGHIJKUCUD $.
    $}
  $}

  ${
    $d x A $.  $d x ph $.
    o1dif.1 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    o1dif.2 $e |- ( ( ph /\ x e. A ) -> C e. CC ) $.
    o1dif.3 $e |- ( ph -> ( x e. A |-> ( B - C ) ) e. O(1) ) $.
    $( If the difference of two functions is eventually bounded, eventual
       boundedness of either one implies the other.  (Contributed by Mario
       Carneiro, 26-May-2016.) $)
    o1dif $p |- ( ph ->
      ( ( x e. A |-> B ) e. O(1) <-> ( x e. A |-> C ) e. O(1) ) ) $=
      ( cmpt co1 wcel cmin co cof syl cvv cc cr eqidd caddc wi o1sub expcom wss
      wral wceq cv wa subcld ralrimiva dmmptg o1dm eqsstr3d reex offval2 nncand
      cdm ssex mpteq2dva eqtrd eleq1d sylibd o1add ex npcand impbid ) ABCDIZJKZ
      BCEIZJKZAVHVGBCDELMZIZLNMZJKZVJAVLJKZVHVNUAHVHVOVNVGVLUBUCOAVMVIJAVMBCDVK
      LMZIVIABCDVKLVGVLPQQACRUDCPKACVLUQZRAVKQKZBCUEVQCUFAVRBCABUGCKUHZDEFGUIZU
      JBCVKQUKOAVOVQRUDHVLULOUMCRUNUROZFVTAVGSAVLSZUOABCVPEVSDEFGUPUSUTVAVBAVJV
      LVITNMZJKZVHAVOVJWDUAHVOVJWDVLVIVCVDOAWCVGJAWCBCVKETMZIVGABCVKETVLVIPQQWA
      VTGWBAVISUOABCWEDVSDEFGVEUSUTVAVBVF $.
  $}

  ${
    $d x A $.  $d x ph $.
    lo1sub.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    lo1sub.2 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    lo1sub.3 $e |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $.
    lo1sub.4 $e |- ( ph -> ( x e. A |-> C ) e. O(1) ) $.
    $( The difference of an eventually upper bounded function and an eventually
       bounded function is eventually upper bounded.  The "correct" sharp
       result here takes the second function to be eventually lower bounded
       instead of just bounded, but our notation for this is simply
       ` ( x e. A |-> -u C ) e. <_O(1) ` , so it is just a special case of
       ~ lo1add .  (Contributed by Mario Carneiro, 31-May-2016.) $)
    lo1sub $p |- ( ph -> ( x e. A |-> ( B - C ) ) e. <_O(1) ) $=
      ( cneg caddc co cmpt cmin clo1 cv wcel wa recnd lo1mptrcl cr renegcld co1
      negsubd mpteq2dva o1lo1 mpbid simprd lo1add eqeltrrd ) ABCDEKZLMZNBCDEOMZ
      NPABCUMUNABQCRSZDEUODABCDFGIUAZTUOEHTUEUFABCDULUBUPUOEHUCIABCENZPRZBCULNP
      RZAUQUDRURUSSJABCEHUGUHUIUJUK $.
  $}

  ${
    $d k u v x y z B $.  $d k C $.  $d j k u v y z F $.  $d j k u v x y z ph $.
    $d j k u v x y z A $.  $d j k v x y z G $.  $d k x y z H $.  $d j k x M $.
    $d j k x y z Z $.
    climadd.1 $e |- Z = ( ZZ>= ` M ) $.
    climadd.2 $e |- ( ph -> M e. ZZ ) $.
    climadd.4 $e |- ( ph -> F ~~> A ) $.
    ${
      climadd.6 $e |- ( ph -> H e. X ) $.
      climadd.7 $e |- ( ph -> G ~~> B ) $.
      climadd.8 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
      climadd.9 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
      ${
        climadd.h $e |- ( ( ph /\ k e. Z ) ->
                          ( H ` k ) = ( ( F ` k ) + ( G ` k ) ) ) $.
        $( Limit of the sum of two converging sequences.  Proposition 12-2.1(a)
           of [Gleason] p. 168.  (Contributed by NM, 24-Sep-2005.)  (Proof
           shortened by Mario Carneiro, 31-Jan-2014.) $)
        climadd $p |- ( ph -> H ~~> ( A + B ) ) $=
          ( cc wcel vx vy vz vv vu caddc cli wbr climcl syl cv wa co adantl crp
          addcl cmin cabs cfv clt wral wrex simpr adantr addcn2 syl3anc climcn2
          wi ) AUAUBUCUDUEBCSSDUFEFGHIJKLAEBUGUHBSTZMBEUIUJZAFCUGUHCSTZOCFUIUJZ
          UEUKZSTUDUKZSTULVMVNUFUMZSTAVMVNUPUNMONAUAUKZUOTZULVQVIVKVMBUQUMURUSU
          BUKUTUHVNCUQUMURUSUCUKUTUHULVOBCUFUMUQUMURUSVPUTUHVHUDSVAUESVAUCUOVBU
          BUOVBAVQVCAVIVQVJVDAVKVQVLVDUBUCUDUEVPBCVEVFPQRVG $.
      $}

      ${
        climmul.h $e |- ( ( ph /\ k e. Z ) ->
                          ( H ` k ) = ( ( F ` k ) x. ( G ` k ) ) ) $.
        $( Limit of the product of two converging sequences.  Proposition
           12-2.1(c) of [Gleason] p. 168.  (Contributed by NM, 27-Dec-2005.)
           (Proof shortened by Mario Carneiro, 1-Feb-2014.) $)
        climmul $p |- ( ph -> H ~~> ( A x. B ) ) $=
          ( cc wcel vx vy vz vv vu cli wbr climcl syl cv wa co mulcl adantl crp
          cmul cmin cabs cfv clt wral wrex simpr adantr mulcn2 syl3anc climcn2
          wi ) AUAUBUCUDUEBCSSDUPEFGHIJKLAEBUFUGBSTZMBEUHUIZAFCUFUGCSTZOCFUHUIZ
          UEUJZSTUDUJZSTUKVMVNUPULZSTAVMVNUMUNMONAUAUJZUOTZUKVQVIVKVMBUQULURUSU
          BUJUTUGVNCUQULURUSUCUJUTUGUKVOBCUPULUQULURUSVPUTUGVHUDSVAUESVAUCUOVBU
          BUOVBAVQVCAVIVQVJVDAVKVQVLVDUBUCUDUEVPBCVEVFPQRVG $.
      $}

      ${
        climsub.h $e |- ( ( ph /\ k e. Z ) ->
                          ( H ` k ) = ( ( F ` k ) - ( G ` k ) ) ) $.
        $( Limit of the difference of two converging sequences.  Proposition
           12-2.1(b) of [Gleason] p. 168.  (Contributed by NM, 4-Aug-2007.)
           (Proof shortened by Mario Carneiro, 1-Feb-2014.) $)
        climsub $p |- ( ph -> H ~~> ( A - B ) ) $=
          ( cc cmin vx vy vz vv vu cli wbr climcl syl cv wa co subcl adantl crp
          wcel cabs cfv clt wi wral wrex simpr adantr subcn2 syl3anc climcn2 )
          AUAUBUCUDUEBCSSDTEFGHIJKLAEBUFUGBSUPZMBEUHUIZAFCUFUGCSUPZOCFUHUIZUEUJ
          ZSUPUDUJZSUPUKVLVMTULZSUPAVLVMUMUNMONAUAUJZUOUPZUKVPVHVJVLBTULUQURUBU
          JUSUGVMCTULUQURUCUJUSUGUKVNBCTULTULUQURVOUSUGUTUDSVAUESVAUCUOVBUBUOVB
          AVPVCAVHVPVIVDAVJVPVKVDUBUCUDUEVOBCVEVFPQRVG $.
      $}
    $}

    ${
      climaddc1.5 $e |- ( ph -> C e. CC ) $.
      climaddc1.6 $e |- ( ph -> G e. W ) $.
      climaddc1.7 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
      ${
        climaddc1.h $e |- ( ( ph /\ k e. Z ) ->
                            ( G ` k ) = ( ( F ` k ) + C ) ) $.
        $( Limit of a constant ` C ` added to each term of a sequence.
           (Contributed by NM, 24-Sep-2005.)  (Revised by Mario Carneiro,
           3-Feb-2014.) $)
        climaddc1 $p |- ( ph -> G ~~> ( A + C ) ) $=
          ( cz cc wcel cfv csn cxp cc0 cli wbr 0z uzssz climconst2 sylancl wceq
          zex cv wa cuz eluzelz eleq2s fvconst2g syl2an adantr eqeltrd caddc co
          oveq2d eqtr4d climadd ) ABCDEQCUAUBZFGHIJKLNACRSZUCQSVFCUDUEMUFCUCQUC
          UGUKUHUIOADULZISZUMZVHVFTZCRAVGVHQSZVKCUJVIMVLVHGUNTIGVHUOJUPQCVHRUQU
          RZAVGVIMUSUTVJVHFTVHETZCVAVBVNVKVAVBPVJVKCVNVAVMVCVDVE $.
      $}

      ${
        climaddc2.h $e |- ( ( ph /\ k e. Z ) ->
                            ( G ` k ) = ( C + ( F ` k ) ) ) $.
        $( Limit of a constant ` C ` added to each term of a sequence.
           (Contributed by NM, 24-Sep-2005.)  (Revised by Mario Carneiro,
           3-Feb-2014.) $)
        climaddc2 $p |- ( ph -> G ~~> ( C + A ) ) $=
          ( caddc co cli wcel cv wa cfv adantr addcomd climaddc1 wbr climcl syl
          cc eqtrd breqtrd ) AFBCQRCBQRSABCDEFGHIJKLMNOADUAZITZUBZUMFUCCUMEUCZQ
          RUPCQRPUOCUPACUJTUNMUDOUEUKUFABCAEBSUGBUJTLBEUHUIMUEUL $.
      $}

      ${
        climmulc2.h $e |- ( ( ph /\ k e. Z ) ->
                            ( G ` k ) = ( C x. ( F ` k ) ) ) $.
        $( Limit of a sequence multiplied by a constant ` C ` .  Corollary
           12-2.2 of [Gleason] p. 171.  (Contributed by NM, 24-Sep-2005.)
           (Revised by Mario Carneiro, 3-Feb-2014.) $)
        climmulc2 $p |- ( ph -> G ~~> ( C x. A ) ) $=
          ( cz cc wcel cfv csn cxp cc0 cli wbr 0z uzssz climconst2 sylancl wceq
          zex cv cuz eluzelz eleq2s fvconst2g syl2an adantr eqeltrd cmul oveq1d
          wa co eqtr4d climmul ) ACBDQCUAUBZEFGHIJKACRSZUCQSVFCUDUEMUFCUCQUCUGU
          KUHUINLADULZISZVBZVHVFTZCRAVGVHQSZVKCUJVIMVLVHGUMTIGVHUNJUOQCVHRUPUQZ
          AVGVIMURUSOVJVHFTCVHETZUTVCVKVNUTVCPVJVKCVNUTVMVAVDVE $.
      $}

      ${
        climsubc1.h $e |- ( ( ph /\ k e. Z ) ->
                            ( G ` k ) = ( ( F ` k ) - C ) ) $.
        $( Limit of a constant ` C ` subtracted from each term of a sequence.
           (Contributed by Mario Carneiro, 9-Feb-2014.) $)
        climsubc1 $p |- ( ph -> G ~~> ( A - C ) ) $=
          ( cz cc wcel cfv csn cxp cc0 cli wbr 0z uzssz climconst2 sylancl wceq
          zex cv cuz eluzelz eleq2s fvconst2g syl2an adantr eqeltrd cmin oveq2d
          wa co eqtr4d climsub ) ABCDEQCUAUBZFGHIJKLNACRSZUCQSVFCUDUEMUFCUCQUCU
          GUKUHUIOADULZISZVBZVHVFTZCRAVGVHQSZVKCUJVIMVLVHGUMTIGVHUNJUOQCVHRUPUQ
          ZAVGVIMURUSVJVHFTVHETZCUTVCVNVKUTVCPVJVKCVNUTVMVAVDVE $.
      $}

      ${
        climsubc2.h $e |- ( ( ph /\ k e. Z ) ->
                            ( G ` k ) = ( C - ( F ` k ) ) ) $.
        $( Limit of a constant ` C ` minus each term of a sequence.
           (Contributed by NM, 24-Sep-2005.)  (Revised by Mario Carneiro,
           9-Feb-2014.) $)
        climsubc2 $p |- ( ph -> G ~~> ( C - A ) ) $=
          ( cz cc wcel cfv csn cxp cc0 cli wbr 0z uzssz climconst2 sylancl wceq
          zex cv cuz eluzelz eleq2s fvconst2g syl2an adantr eqeltrd cmin oveq1d
          wa co eqtr4d climsub ) ACBDQCUAUBZEFGHIJKACRSZUCQSVFCUDUEMUFCUCQUCUGU
          KUHUINLADULZISZVBZVHVFTZCRAVGVHQSZVKCUJVIMVLVHGUMTIGVHUNJUOQCVHRUPUQZ
          AVGVIMURUSOVJVHFTCVHETZUTVCVKVNUTVCPVJVKCVNUTVMVAVDVE $.
      $}
    $}

    ${
      climle.5 $e |- ( ph -> G ~~> B ) $.
      climle.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
      climle.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. RR ) $.
      climle.8 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) <_ ( G ` k ) ) $.
      $( Comparison of the limits of two sequences.  (Contributed by Paul
         Chapman, 10-Sep-2007.)  (Revised by Mario Carneiro, 1-Feb-2014.) $)
      climle $p |- ( ph -> A <_ B ) $=
        ( vj cmin cle wbr cfv cc0 co cv cmpt cvv wcel cuz fvex eqeltri mptex wa
        a1i recnd wceq fveq2 oveq12d eqid ovex fvmpt adantl climsub cr resubcld
        eqeltrd subge0d mpbird breqtrrd climge0 climrecl mpbid ) AUACBQUBZRSBCR
        SAVKDPHPUCZFTZVLETZQUBZUDZGHIJACBDFEVPGUEHIJLVPUEUFAPHVOHGUGTUEIGUGUHUI
        UJULKADUCZHUFZUKZVQFTZNUMVSVQETZMUMVRVQVPTZVTWAQUBZUNAPVQVOWCHVPVLVQUNV
        MVTVNWAQVLVQFUOVLVQEUOUPVPUQVTWAQURUSUTZVAVSWBWCVBWDVSVTWANMVCVDVSUAWCW
        BRVSUAWCRSWAVTRSOVSVTWANMVEVFWDVGVHACBACDFGHIJLNVIABDEGHIJKMVIVEVJ $.
    $}

    climsqz.5 $e |- ( ph -> G e. W ) $.
    climsqz.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
    climsqz.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. RR ) $.
    ${
      climsqz.8 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) <_ ( G ` k ) ) $.
      climsqz.9 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) <_ A ) $.
      $( Convergence of a sequence sandwiched between another converging
         sequence and its limit.  (Contributed by NM, 6-Feb-2008.)  (Revised by
         Mario Carneiro, 3-Feb-2014.) $)
      climsqz $p |- ( ph -> G ~~> A ) $=
        ( vj wcel wa cr vx cli wbr cv cfv cmin co cabs clt cuz wral wrex crp cz
        adantr simpr eqidd climi2 uztrn2 cle climrecl lesub2dd abssuble0d letrd
        wi 3brtr4d adantlr ad2antrr resubcld recnd abscld rpre ad2antlr syl3anc
        lelttr mpand sylan2 anassrs ralimdva reximdva ralrimiva clim2c mpbird
        mpd ) AEBUBUCCUDZEUEZBUFUGZUHUEZUAUDZUIUCZCQUDZUJUEZUKZQHULZUAUMUKAWNUA
        UMAWIUMRZSZWEDUEZBUFUGZUHUEZWIUIUCZCWLUKZQHULWNWPBWQWIQCDFHIAFUNRWOJUOA
        WOUPWPWEHRZSZWQUQADBUBUCWOKUOURWPXAWMQHWPWKHRZSWTWJCWLWPXDWEWLRZWTWJVEZ
        XDXESWPXBXFFWEWKHIUSXCWHWSUTUCZWTWJAXBXGWOAXBSZBWFUFUGBWQUFUGWHWSUTXHWQ
        WFBMNABTRZXBABCDFHIJKMVAZUOZOVBXHWFBNXKPVCXHWQBMXKXHWQWFBMNXKOPVDVCVFVG
        XCWHTRWSTRWITRZXGWTSWJVEXCWGXCWGXCWFBAXBWFTRWONVGAXIWOXBXJVHZVIVJVKXCWR
        XCWRXCWQBAXBWQTRWOMVGXMVIVJVKWOXLAXBWIVLVMWHWSWIVOVNVPVQVRVSVTWDWAAUABW
        FQCEFGHIJLXHWFUQABXJVJXHWFNVJWBWC $.
    $}

    ${
      climsqz2.8 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) <_ ( F ` k ) ) $.
      climsqz2.9 $e |- ( ( ph /\ k e. Z ) -> A <_ ( G ` k ) ) $.
      $( Convergence of a sequence sandwiched between another converging
         sequence and its limit.  (Contributed by NM, 14-Feb-2008.)  (Revised
         by Mario Carneiro, 3-Feb-2014.) $)
      climsqz2 $p |- ( ph -> G ~~> A ) $=
        ( vj wcel wa cr vx cli wbr cv cfv cmin co cabs clt cuz wral wrex crp cz
        adantr simpr eqidd climi2 uztrn2 cle climrecl lesub1dd abssubge0d letrd
        wi 3brtr4d adantlr ad2antrr resubcld recnd abscld rpre ad2antlr syl3anc
        lelttr mpand sylan2 anassrs ralimdva reximdva ralrimiva clim2c mpbird
        mpd ) AEBUBUCCUDZEUEZBUFUGZUHUEZUAUDZUIUCZCQUDZUJUEZUKZQHULZUAUMUKAWNUA
        UMAWIUMRZSZWEDUEZBUFUGZUHUEZWIUIUCZCWLUKZQHULWNWPBWQWIQCDFHIAFUNRWOJUOA
        WOUPWPWEHRZSZWQUQADBUBUCWOKUOURWPXAWMQHWPWKHRZSWTWJCWLWPXDWEWLRZWTWJVEZ
        XDXESWPXBXFFWEWKHIUSXCWHWSUTUCZWTWJAXBXGWOAXBSZWGWRWHWSUTXHWFWQBNMABTRZ
        XBABCDFHIJKMVAZUOZOVBXHBWFXKNPVCXHBWQXKMXHBWFWQXKNMPOVDVCVFVGXCWHTRWSTR
        WITRZXGWTSWJVEXCWGXCWGXCWFBAXBWFTRWONVGAXIWOXBXJVHZVIVJVKXCWRXCWRXCWQBA
        XBWQTRWOMVGXMVIVJVKWOXLAXBWIVLVMWHWSWIVOVNVPVQVRVSVTWDWAAUABWFQCEFGHIJL
        XHWFUQABXJVJXHWFNVJWBWC $.
    $}
  $}

  ${
    $d v w x y z A $.  $d v w y z C $.  $d u v w x y z D $.  $d v w x y z ph $.
    $d u v w y z B $.  $d u v w x y z E $.
    rlimadd.3 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    rlimadd.4 $e |- ( ( ph /\ x e. A ) -> C e. V ) $.
    rlimadd.5 $e |- ( ph -> ( x e. A |-> B ) ~~>r D ) $.
    rlimadd.6 $e |- ( ph -> ( x e. A |-> C ) ~~>r E ) $.
    $( Limit of the sum of two converging functions.  Proposition 12-2.1(a) of
       [Gleason] p. 168.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    rlimadd $p |- ( ph -> ( x e. A |-> ( B + C ) ) ~~>r ( D + E ) ) $=
      ( vv vu vw vz cc wbr cv co caddc rlimmptrcl cmpt crli wcel rlimcl syl cxp
      vy wf ax-addf a1i crp wa cmin cabs cfv clt wral wrex simpr adantr syl3anc
      wi addcn2 rlimcn2 ) AUIBMNCDEFGUAQQOPACDFBHIKUBACEGBHJLUBABCDUCZFUDRFQUEZ
      KFVGUFUGZABCEUCZGUDRGQUEZLGVJUFUGZKLQQUHQUAUJAUKULAUISZUMUEZUNVNVHVKNSZFU
      OTUPUQPSURRMSZGUOTUPUQOSURRUNVOVPUATFGUATUOTUPUQVMURRVDMQUSNQUSOUMUTPUMUT
      AVNVAAVHVNVIVBAVKVNVLVBPOMNVMFGVEVCVF $.

    $( Limit of the difference of two converging functions.  Proposition
       12-2.1(b) of [Gleason] p. 168.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    rlimsub $p |- ( ph -> ( x e. A |-> ( B - C ) ) ~~>r ( D - E ) ) $=
      ( vv vu vw cmin cc wbr cv co vy vz rlimmptrcl cmpt crli rlimcl syl cxp wf
      wcel subf a1i crp wa cabs cfv clt wral wrex adantr subcn2 syl3anc rlimcn2
      wi simpr ) AUABMNCDEFGPQQOUBACDFBHIKUCACEGBHJLUCABCDUDZFUERFQUJZKFVFUFUGZ
      ABCEUDZGUERGQUJZLGVIUFUGZKLQQUHQPUIAUKULAUASZUMUJZUNVMVGVJNSZFPTUOUPUBSUQ
      RMSZGPTUOUPOSUQRUNVNVOPTFGPTPTUOUPVLUQRVDMQURNQUROUMUSUBUMUSAVMVEAVGVMVHU
      TAVJVMVKUTUBOMNVLFGVAVBVC $.

    $( Limit of the product of two converging functions.  Proposition 12-2.1(c)
       of [Gleason] p. 168.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    rlimmul $p |- ( ph -> ( x e. A |-> ( B x. C ) ) ~~>r ( D x. E ) ) $=
      ( vv vu vw vz cc wbr cv co vy cmul rlimmptrcl cmpt crli rlimcl syl cxp wf
      wcel ax-mulf a1i crp wa cmin cabs cfv clt wral wrex adantr mulcn2 syl3anc
      wi simpr rlimcn2 ) AUABMNCDEFGUBQQOPACDFBHIKUCACEGBHJLUCABCDUDZFUERFQUJZK
      FVGUFUGZABCEUDZGUERGQUJZLGVJUFUGZKLQQUHQUBUIAUKULAUASZUMUJZUNVNVHVKNSZFUO
      TUPUQPSURRMSZGUOTUPUQOSURRUNVOVPUBTFGUBTUOTUPUQVMURRVDMQUSNQUSOUMUTPUMUTA
      VNVEAVHVNVIVAAVKVNVLVAPOMNVMFGVBVCVF $.

    rlimdiv.7 $e |- ( ph -> E =/= 0 ) $.
    rlimdiv.8 $e |- ( ( ph /\ x e. A ) -> C =/= 0 ) $.
    $( Limit of the quotient of two converging functions.  Proposition
       12-2.1(a) of [Gleason] p. 168.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    rlimdiv $p |- ( ph -> ( x e. A |-> ( B / C ) ) ~~>r ( D / E ) ) $=
      ( c1 cdiv co cc wcel cc0 vy vz vw vv cmul cmpt crli rlimmptrcl reccld csn
      cv wa cdif ccom cfv wne eldifsn sylanbrc fmptd wbr rlimcl syl reccl sylbi
      eqid adantl crp cmin cabs clt wi wral wrex cle c2 reccn2 sylan oveq2 ovex
      cif fvmpt oveqan12rd fveq2d breq1d imbi2d ralbidva rexbidv biimpar syldan
      wceq rlimcn1 eqidd fmptco 3brtr3d rlimmul divrecd mpteq2dva 3brtr4d ) ABC
      DOEPQZUEQZUFFOGPQZUEQBCDEPQZUFFGPQUGABCDWSFXARACDFBHIKUHZABUKCSULZEACEGBH
      JLUHZNUIKAUARTUJUMZOUAUKZPQZUFZBCEUFZUNGXIUOZBCWSUFXAUGAUBUCUDCGXIXJXFABC
      EXFXJXDERSETUPEXFSXENERTUQURZXJVEUSAGRSZGTUPGXFSZAXJGUGUTXMLGXJVAVBZMGRTU
      QURZLAUAXFXHRXIXGXFSZXHRSZAXQXGRSXGTUPULXRXGRTUQXGVCVDVFXIVEZUSAUBUKZVGSZ
      UDUKZGVHQVIUOUCUKVJUTZOYBPQZXAVHQZVIUOZXTVJUTZVKZUDXFVLZUCVGVMZYCYBXIUOZX
      KVHQZVIUOZXTVJUTZVKZUDXFVLZUCVGVMZAXNYAYJXPUCUDGXTOGVIUOZXTUEQZVNUTOYSVTY
      RVOPQUEQZYTVEVPVQAYQYJAYPYIUCVGAYOYHUDXFAYBXFSZULZYNYGYCUUBYMYFXTVJUUBYLY
      EVIUUAAYKYDXKXAVHUAYBXHYDXFXIXGYBOPVRXSOYBPVSWAAXNXKXAWJXPUAGXHXAXFXIXGGO
      PVRXSOGPVSWAVBZWBWCWDWEWFWGWHWIWKABUACXFEXHWSXJXIXLAXJWLAXIWLXGEOPVRWMUUC
      WNWOABCXBWTXDDEXCXENWPWQAFGABCDUFZFUGUTFRSKFUUDVAVBXOMWPWR $.
  $}

  ${
    $d k x y z A $.  $d x y z B $.  $d k x y z C $.  $d k x y ph $.
    rlimneg.1 $e |- ( ( ph /\ k e. A ) -> B e. V ) $.
    rlimneg.2 $e |- ( ph -> ( k e. A |-> B ) ~~>r C ) $.
    $( Limit of the negative of a sequence.  (Contributed by Mario Carneiro,
       18-May-2016.) $)
    rlimneg $p |- ( ph -> ( k e. A |-> -u B ) ~~>r -u C ) $=
      ( cc0 cmin co cmpt cneg crli cc wcel 0cn cr wss wbr cv a1i rlimmptrcl cdm
      wa wral wceq ralrimiva dmmptg syl rlimss rlimconst sylancl rlimsub df-neg
      eqsstr3d mpteq2i 3brtr4g ) AEBICJKZLIDJKEBCMZLDMNAEBICIDOIOPZAEUABPUEQUBA
      BCDEFGHUCABRSVAEBILINTABEBCLZUDZRACFPZEBUFVCBUGAVDEBGUHEBCFUIUJAVBDNTVCRS
      HDVBUKUJUPQEBIULUMHUNEBUTUSCUOUQDUOUR $.
  $}

  ${
    $d v w x y z A $.  $d v w y z C $.  $d u v w x y z D $.  $d v w x y z ph $.
    $d u v w y z B $.  $d u v w x y z E $.
    rlimle.1 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    rlimle.2 $e |- ( ph -> ( x e. A |-> B ) ~~>r D ) $.
    rlimle.3 $e |- ( ph -> ( x e. A |-> C ) ~~>r E ) $.
    rlimle.4 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    rlimle.5 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    rlimle.6 $e |- ( ( ph /\ x e. A ) -> B <_ C ) $.
    $( Comparison of the limits of two sequences.  (Contributed by Mario
       Carneiro, 10-May-2016.) $)
    rlimle $p |- ( ph -> D <_ E ) $=
      ( cc0 cmin co cle wbr subge0d rlimrecl cr rlimsub cv wcel resubcld mpbird
      wa rlimge0 mpbid ) ANGFOPZQRFGQRABCEDOPZUJHABCEDGFUALKJIUBABUCCUDUGZEDLKU
      EULNUKQRDEQRMULEDLKSUFUHAGFABCEGHJLTABCDFHIKTSUI $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z D $.  $d x y z E $.  $d x y z ph $.
    $d y z C $.  $d x z M $.
    rlimsqzlem.m $e |- ( ph -> M e. RR ) $.
    rlimsqzlem.e $e |- ( ph -> E e. CC ) $.
    rlimsqzlem.1 $e |- ( ph -> ( x e. A |-> B ) ~~>r D ) $.
    rlimsqzlem.2 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    rlimsqzlem.3 $e |- ( ( ph /\ x e. A ) -> C e. CC ) $.
    rlimsqzlem.4 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) ->
      ( abs ` ( C - E ) ) <_ ( abs ` ( B - D ) ) ) $.
    $( Lemma for ~ rlimsqz and ~ rlimsqz2 .  (Contributed by Mario Carneiro,
       18-Sep-2014.)  (Revised by Mario Carneiro, 20-May-2016.) $)
    rlimsqzlem $p |- ( ph -> ( x e. A |-> C ) ~~>r E ) $=
      ( vz wbr wcel wa cr cc vy cmpt crli cv cle cmin co cabs cfv clt wral cpnf
      wi cico wrex crp ad3antrrr ad2antrr elicopnf syl simprbda adantrr wss cdm
      wb wf wceq eqid fmptd rlimss eqsstr3d adantr sselda simplbda simprr letrd
      anassrs adantllr syldan subcld abscld adantlr rlimcl rpre ad3antlr lelttr
      fdm syl3anc mpand an32s a2d ralimdva reximdva ralrimiva rlim3 3imtr4d mpd
      expr ) ABCDUBZFUCPZBCEUBGUCPZKAOUDZBUDZUEPZDFUFUGZUHUIZUAUDZUJPZUMZBCUKZO
      HULUNUGZUOZUAUPUKXDEGUFUGZUHUIZXGUJPZUMZBCUKZOXKUOZUAUPUKWTXAAXLXRUAUPAXG
      UPQZRZXJXQOXKXTXBXKQZRZXIXPBCYBXCCQZRXDXHXOXTYCYAXDXHXOUMZUMXTYCRZYAXDYDY
      EYAXDRZRZXNXFUEPZXHXOYEYFHXCUEPZYHYGHXBXCAHSQZXSYCYFIUQYEYAXBSQZXDYEYAYKH
      XBUEPZYEYJYAYKYLRVEAYJXSYCIURHXBUSUTZVAVBYEXCSQYFXTCSXCACSVCXSACWSVDZSACT
      WSVFYNCVGABCDTWSLWSVHVICTWSWGUTAWTYNSVCKFWSVJUTVKZVLVMVLYEYAYLXDYEYAYKYLY
      MVNVBYEYAXDVOVPAYCYIYHXSAYCYIYHNVQVRVSYGXNSQZXFSQZXGSQZYHXHRXOUMYEYPYFAYC
      YPXSAYCRZXMYSEGMAGTQYCJVLVTWAWBVLYEYQYFAYCYQXSYSXEYSDFLAFTQZYCAWTYTKFWSWC
      UTZVLVTWAWBVLXSYRAYCYFXGWDWEXNXFXGWFWHWIWRWJWKWLWMWLAUAOBCDFHADTQBCLWNYOU
      UAIWOAUAOBCEGHAETQBCMWNYOJIWOWPWQ $.
  $}

  ${
    $d x A $.  $d x D $.  $d x M $.  $d x ph $.
    rlimsqz.d $e |- ( ph -> D e. RR ) $.
    rlimsqz.m $e |- ( ph -> M e. RR ) $.
    rlimsqz.l $e |- ( ph -> ( x e. A |-> B ) ~~>r D ) $.
    rlimsqz.b $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    rlimsqz.c $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    ${
      rlimsqz.1 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) -> B <_ C ) $.
      rlimsqz.2 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) -> C <_ D ) $.
      $( Convergence of a sequence sandwiched between another converging
         sequence and its limit.  (Contributed by Mario Carneiro,
         18-Sep-2014.)  (Revised by Mario Carneiro, 20-May-2016.) $)
      rlimsqz $p |- ( ph -> ( x e. A |-> C ) ~~>r D ) $=
        ( recnd wcel wa cmin co cr cle wbr cabs cfv adantrr lesub2dd abssuble0d
        cv adantr letrd 3brtr4d rlimsqzlem ) ABCDEFFGIAFHOJABUHZCPZQZDKOUOELOAU
        NGUMUAUBZQZQZFERSFDRSEFRSUCUDDFRSUCUDUAURDEFAUNDTPUPKUEZAUNETPUPLUEZAFT
        PUQHUIZMUFUREFUTVANUGURDFUSVAURDEFUSUTVAMNUJUGUKUL $.
    $}

    ${
      rlimsqz2.1 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) -> C <_ B ) $.
      rlimsqz2.2 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) -> D <_ C ) $.
      $( Convergence of a sequence sandwiched between another converging
         sequence and its limit.  (Contributed by Mario Carneiro, 3-Feb-2014.)
         (Revised by Mario Carneiro, 20-May-2016.) $)
      rlimsqz2 $p |- ( ph -> ( x e. A |-> C ) ~~>r D ) $=
        ( recnd wcel wa cle cmin cr cv wbr cabs cfv adantrr lesub1dd abssubge0d
        co adantr letrd 3brtr4d rlimsqzlem ) ABCDEFFGIAFHOJABUAZCPZQZDKOUOELOAU
        NGUMRUBZQZQZEFSUHZDFSUHZUSUCUDUTUCUDRUREDFAUNETPUPLUEZAUNDTPUPKUEZAFTPU
        QHUIZMUFURFEVCVANUGURFDVCVBURFEDVCVAVBNMUJUGUKUL $.
    $}
  $}

  ${
    $d m x y z A $.  $d m y z C $.  $d m x z M $.  $d m x y z ph $.
    $d m y B $.
    lo1le.1 $e |- ( ph -> M e. RR ) $.
    lo1le.2 $e |- ( ph -> ( x e. A |-> B ) e. <_O(1) ) $.
    lo1le.3 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    lo1le.4 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    lo1le.5 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) -> C <_ B ) $.
    $( Transfer eventual upper boundedness from a larger function to a smaller
       function.  (Contributed by Mario Carneiro, 26-May-2016.) $)
    lo1le $p |- ( ph -> ( x e. A |-> C ) e. <_O(1) ) $=
      ( vm wcel cle wbr wi cr wrex wa vy vz cmpt clo1 cv wral simpr adantr ifcl
      cif syl2anc wb ad2antrr simplr wss cdm wceq ralrimiva dmmptg syl eqsstr3d
      lo1dm simprr sseldd maxle syl3anc syl6bi adantlr adantrll simpl lo1mptrcl
      imim1d syl2an simprll letr mpand expr adantrd sylbid a2d anassrs ralimdva
      reximdva breq1 imbi1d rexralbidv rspcev ee12an rexlimdva ello1mpt 3imtr4d
      syld mpd ) ABCDUCZUDNZBCEUCUDNZIAUAUEZBUEZOPZDMUEZOPZQZBCUFZMRSZUARSUBUEZ
      WROPZEWTOPZQZBCUFMRSZUBRSZWOWPAXDXJUARAWQRNZTZFWQOPZWQFUJZRNZXDXNWROPZXGQ
      ZBCUFZMRSZXJXLXKFRNZXOAXKUGAXTXKHUHXMWQFRUIUKXLXCXRMRXLWTRNZTXBXQBCXLYAWR
      CNZXBXQQXLYAYBTZTZXBXPXAQXQYDXPWSXAYDXPFWROPZWSTZWSYDXTXKWRRNXPYFULAXTXKY
      CHUMAXKYCUNYDCRWRACRUOXKYCACWNUPZRADGNZBCUFYGCUQAYHBCJURBCDGUSUTAWOYGRUOI
      WNVBUTVAZUMXLYAYBVCVDFWQWRVEVFZYEWSUGVGVLYDXPXAXGYDXPYFXAXGQZYJYDYEYKWSXL
      YCYEYKXLYCYETZTZEDOPZXAXGXLYBYEYNYAAYBYETYNXKLVHVIYMERNZDRNZYAYNXATXGQXLA
      YBYOYLAXKVJZYAYBYEUNZKVMXLAYBYPYLYQYRABCDGJIVKZVMXLYAYBYEVNEDWTVOVFVPVQVR
      VSVTWLWAWBWCXIXSUBXNRXEXNUQZXHXQMBRCYTXFXPXGXEXNWROWDWEWFWGWHWIABUACDMYIY
      SWJABUBCEMYIKWJWKWM $.
  $}

  ${
    $d m x y z A $.  $d m y z C $.  $d m x z M $.  $d m x y z ph $.
    $d m y B $.
    o1le.1 $e |- ( ph -> M e. RR ) $.
    o1le.2 $e |- ( ph -> ( x e. A |-> B ) e. O(1) ) $.
    o1le.3 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    o1le.4 $e |- ( ( ph /\ x e. A ) -> C e. CC ) $.
    o1le.5 $e |- ( ( ph /\ ( x e. A /\ M <_ x ) ) ->
      ( abs ` C ) <_ ( abs ` B ) ) $.
    $( Transfer eventual boundedness from a larger function to a smaller
       function.  (Contributed by Mario Carneiro, 25-Sep-2014.)  (Proof
       shortened by Mario Carneiro, 26-May-2016.) $)
    o1le $p |- ( ph -> ( x e. A |-> C ) e. O(1) ) $=
      ( cmpt co1 wcel cabs cfv clo1 cvv lo1o12 o1mptrcl mpbid cv wa fvex abscld
      a1i lo1le mpbird ) ABCEMNOBCEPQZMROABCDPQZUJFSHABCDMNOBCUKMROIABCDABCDGJI
      UATUBUKSOABUCCOUDZDPUEUGULEKUFLUHABCEKTUI $.
  $}

  ${
    $d c x y A $.  $d c y B $.  $d c x y ph $.
    rlimno1.1 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    rlimno1.2 $e |- ( ph -> ( x e. A |-> ( 1 / B ) ) ~~>r 0 ) $.
    rlimno1.3 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    rlimno1.4 $e |- ( ( ph /\ x e. A ) -> B =/= 0 ) $.
    $( A function whose inverse converges to zero is unbounded.  (Contributed
       by Mario Carneiro, 30-May-2016.) $)
    rlimno1 $p |- ( ph -> -. ( x e. A |-> B ) e. O(1) ) $=
      ( vc vy wcel cle wbr cr wrex wa wfal c1 cc0 adantr cmpt co1 cabs cfv wral
      cv wi fal cdiv co cmin cif clt cc reccld ralrimiva simpr 1re ifcl sylancl
      crp 1rp a1i max1 sylancr rpgecld rpreccld crli wss wb cdm wceq dmmptg syl
      rlimi rlimss eqsstr3d cxr csup cpnf ressxr syl6ss supxrunb1 mpbird r19.29
      rexanre r19.29r wn adantlr wne absrpcld ad2antrr 0le1 rpred max2 lediv2ad
      rprecred lenltd subid1d fveq2d absdivd absidd oveq1d 3eqtrd breq1d mtbird
      letrd mpbid recnd pm2.21d expimpd ancomsd com23 imp3a rexlimdva rexlimdvw
      imim2d syl5 mpand sylbird mtoi nrexdv elo1mpt rexcom syl6bb ) ABCDUAUBKZI
      UFBUFZLMZDUCUDZJUFZLMZUGBCUEZINOZJNOZAYMJNAYJNKZPZYMQUHYPYHRDUIUJZSUKUJZU
      CUDZRRYJLMZYJRULZUIUJZUMMZUGBCUEINOZYMQYPIBCYQSUUBUNAYQUNKZBCUEZYOAUUEBCA
      YGCKZPDGHUOUPZTYPUUAYPUUARYPYORNKZUUANKZAYOUQZURYTYJRNUSUTZRVAKYPVBVCYPUU
      IYORUUALMURUUKRYJVDVEVFZVGABCYQUAZSVHMZYOFTVOYPUUDYMPZYHUUCYKPZUGZBCUEZIN
      OZQYPCNVIZUUTUUPVJAUVAYOACUUNVKZNAUUFUVBCVLUUHBCYQUNVMVNAUUOUVBNVIFSUUNVP
      VNVQZTUUCYKCIBWFVNYPYHBCOZINUEZUUTQAUVEYOAUVECVRUMVSVTVLZEACVRVIUVEUVFVJA
      CNVRUVCWAWBIBCWCVNWDTUVEUUTPUVDUUSPZINOYPQUVDUUSINWEYPUVGQINUVGYHUURPZBCO
      YPQYHUURBCWGYPUVHQBCYPUUGPZYHUURQUVIUURYHQUVIUUQQYHUVIYKUUCQUVIYKUUCQUVIY
      KPZUUCQUVJUUCRYIUIUJZUUBUMMZUVJUUBUVKLMUVLWHUVJYIUUARUVIYIVAKYKUVIDAUUGDU
      NKZYOGWIZAUUGDSWJZYOHWIZWKTZYPUUAVAKUUGYKUUMWLZUUIUVJURVCZSRLMUVJWMVCZUVJ
      YIYJUUAUVJYIUVQWNYPYOUUGYKUUKWLZYPUUJUUGYKUULWLUVIYKUQUVJUUIYOYJUUALMURUW
      ARYJWOVEXGWPUVJUUBUVKUVJUUAUVRWQUVJYIUVQWQWRXHUVJYSUVKUUBUMUVJYSYQUCUDRUC
      UDZYIUIUJUVKUVJYRYQUCUVJYQUVJDUVIUVMYKUVNTZUVIUVOYKUVPTZUOWSWTUVJRDUVJRUV
      SXIUWCUWDXAUVJUWBRYIUIUVJRUVSUVTXBXCXDXEXFXJXKXLXQXMXNXOXRXPXRXSXTXSYAYBA
      YFYLJNOINOYNABICDJUVCGYCYLIJNNYDYEXF $.
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k x y F $.  $d j k x y M $.  $d j k x y N $.
    $d j k x C $.  $d j k G $.  $d j k x y ph $.  $d j k x Z $.
    clim2ser.1 $e |- Z = ( ZZ>= ` M ) $.
    ${
      clim2ser.2 $e |- ( ph -> N e. Z ) $.
      clim2ser.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
      ${
        clim2ser.5 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
        $( The limit of an infinite series with an initial segment removed.
           (Contributed by Paul Chapman, 9-Feb-2008.)  (Revised by Mario
           Carneiro, 1-Feb-2014.) $)
        clim2ser $p |- ( ph -> seq ( N + 1 ) ( + , F ) ~~>
                               ( A - ( seq M ( + , F ) ` N ) ) ) $=
          ( caddc cfv co wcel syl cc cv adantr cmin vj vx vy cseq c1 cvv cuz cz
          eqid syl6eleq peano2uz eluzelz eluzel2 serf ffvelrnd a1i wa syl6eleqr
          seqex wf uztrn2 sylan addcl adantl w3a addass simpr cfz elfzuz sylan2
          adantlr seqsplit oveq1d syldan ffvelrnda pncan2d eqtr2d climsubc1
          wceq ) ABFLDEUDZMZUAVTLDFUELNZUDZWBUFWBUGMZWDUIZAWBEUGMZOZWBUHOAFWFOZ
          WGAFGWFIHUJZEFUKPZEWBULPZKAGQFVTACDEGHAWHEUHOWIEFUMPJUNZIUOZWCUFOALDW
          BUSUPAUARZWDOZUQZGQWNVTAGQVTUTWOWLSAWBGOZWOWNGOAWBWFGWJHURZEWNWBGHVAV
          BUOWPWNVTMZWATNWAWNWCMZLNZWATNWTWPWSXAWATWPCUBUCLQDEFWNCRZQOZUBRZQOZU
          QXBXDLNZQOWPXBXDVCVDXCXEUCRZQOVEXFXGLNXBXDXGLNLNVSWPXBXDXGVFVDAWOVGAW
          HWOWISAXBEWNVHNOZXBDMQOZWOXHAXBGOZXIXHXBWFGXBEWNVIHURJVJVKVLVMWPWAWTA
          WAQOWOWMSAWDQWNWCACDWBWDWEWKAXBWDOZXJXIAWQXKXJWREXBWBGHVAVBJVNUNVOVPV
          QVR $.
      $}

      ${
        clim2ser2.5 $e |- ( ph -> seq ( N + 1 ) ( + , F ) ~~> A ) $.
        $( The limit of an infinite series with an initial segment added.
           (Contributed by Paul Chapman, 9-Feb-2008.)  (Revised by Mario
           Carneiro, 1-Feb-2014.) $)
        clim2ser2 $p |- ( ph -> seq M ( + , F ) ~~>
                               ( A + ( seq M ( + , F ) ` N ) ) ) $=
          ( vj vx caddc cfv co wcel syl cc cv vy cseq cvv cuz syl6eleq peano2uz
          c1 eqid cz eluzelz eluzel2 serf ffvelrnd seqex syl6eleqr uztrn2 sylan
          a1i syldan ffvelrnda wa addcl adantl w3a wceq addass simpr adantr cfz
          elfzuz sylan2 adantlr seqsplit addcomd eqtrd climaddc1 ) ABFNDEUBZOZL
          NDFUGNPZUBZVQVSUCVSUDOZWAUHZAVSEUDOZQZVSUIQAFWCQZWDAFGWCIHUEZEFUFRZEV
          SUJRZKAGSFVQACDEGHAWEEUIQWFEFUKRJULIUMZVQUCQANDEUNURAWASLTZVTACDVSWAW
          BWHACTZWAQZWKGQZWKDOSQZAVSGQWLWMAVSWCGWGHUOEWKVSGHUPUQJUSULUTZAWJWAQZ
          VAZWJVQOVRWJVTOZNPWRVRNPWQCMUANSDEFWJWKSQZMTZSQZVAWKWTNPZSQWQWKWTVBVC
          WSXAUATZSQVDXBXCNPWKWTXCNPNPVEWQWKWTXCVFVCAWPVGAWEWPWFVHAWKEWJVIPQZWN
          WPXDAWMWNXDWKWCGWKEWJVJHUOJVKVLVMWQVRWRAVRSQWPWIVHWOVNVOVP $.
      $}
    $}

    ${
      iserex.2 $e |- ( ph -> N e. Z ) $.
      iserex.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
      $( An infinite series converges, if and only if the series does with
         initial terms removed.  (Contributed by Paul Chapman, 9-Feb-2008.)
         (Revised by Mario Carneiro, 27-Apr-2014.) $)
      iserex $p |- ( ph -> ( seq M ( + , F ) e. dom ~~> <->
                             seq N ( + , F ) e. dom ~~> ) ) $=
        ( wceq caddc cseq cli wcel c1 co cfv wa wbr syl cdm wb wi seqeq1 eleq1d
        cmin cuz bicomd simpll cc cz syl6eleq eluzelz zcnd ax-1cn npcan sylancl
        a1i seqeq1d simplr syl6eleqr sylan simpr climdm sylib clim2ser eqbrtrrd
        cv climrel releldmi adantr eqbrtrd clim2ser2 impbida ex wo uzm1 mpjaod
        ) AEDJZKCDLZMUAZNZKCELZWANZUBZEOUFPZDUGQZNZVSWEUCAVSWDWBVSWCVTWAKCEDUDU
        EUHURAWHWEAWHRZWBWDWIWBRZWCVTMQZWFVTQZUFPZMSWDWJKCWFOKPZLZWCWMMWJAWOWCJ
        ZAWHWBUIZAWNEKCAEUJNOUJNWNEJAEAEWGNZEUKNAEFWGHGULZDEUMTUNUOEOUPUQUSZTWJ
        WKBCDWFFGWJWFWGFAWHWBUTGVAWJABVHZFNZXACQUJNZWQIVBWJWBVTWKMSWIWBVCVTVDVE
        VFVGWCWMMVIVJTWIWDRZVTWCMQZWLKPZMSWBXDXEBCDWFFGWIWFFNWDWIWFWGFAWHVCGVAV
        KXDAXBXCAWHWDUIZIVBXDWOWCXEMXDAWPXGWTTXDWDWCXEMSWIWDVCWCVDVEVLVMVTXFMVI
        VJTVNVOAWRVSWHVPWSDEVQTVR $.
    $}

    ${
      isermulc2.2 $e |- ( ph -> M e. ZZ ) $.
      isermulc2.4 $e |- ( ph -> C e. CC ) $.
      isermulc2.5 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
      isermulc2.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
      isermulc2.7 $e |- ( ( ph /\ k e. Z ) ->
                          ( G ` k ) = ( C x. ( F ` k ) ) ) $.
      $( Multiplication of an infinite series by a constant.  (Contributed by
         Paul Chapman, 14-Nov-2007.)  (Revised by Mario Carneiro,
         1-Feb-2014.) $)
      isermulc2 $p |- ( ph -> seq M ( + , G ) ~~> ( C x. A ) ) $=
        ( caddc wcel cc cv cmul co vj vx cseq cvv seqex serf ffvelrnda wa addcl
        a1i adantl wceq adantr adddi 3expb sylan cuz cfv syl6eleq cfz syl6eleqr
        simpr elfzuz sylan2 adantlr seqdistr climmulc2 ) ABCUAOEGUCZOFGUCZGUDHI
        JLKVIUDPAOFGUEUJAHQUARZVHADEGHIJMUFUGAVJHPZUHZDUBCOQSFEGVJDRZQPZUBRZQPZ
        UHZVMVOOTZQPVLVMVOUIUKVLCQPZVQCVRSTCVMSTCVOSTOTULZAVSVKKUMVSVNVPVTCVMVO
        UNUOUPVLVJHGUQURZAVKVBIUSAVMGVJUTTPZVMEURZQPZVKWBAVMHPZWDWBVMWAHVMGVJVC
        IVAZMVDVEAWBVMFURCWCSTULZVKWBAWEWGWFNVDVEVFVG $.
    $}

    ${
      climlec2.2 $e |- ( ph -> M e. ZZ ) $.
      climlec2.3 $e |- ( ph -> A e. RR ) $.
      climlec2.4 $e |- ( ph -> F ~~> B ) $.
      climlec2.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
      climlec2.6 $e |- ( ( ph /\ k e. Z ) -> A <_ ( F ` k ) ) $.
      $( Comparison of a constant to the limit of a sequence.  (Contributed by
         NM, 28-Feb-2008.)  (Revised by Mario Carneiro, 1-Feb-2014.) $)
      climlec2 $p |- ( ph -> A <_ B ) $=
        ( cz csn cxp wcel cc0 cfv cr cc cli wbr recnd 0z zex climconst2 sylancl
        uzssz cv wa wceq cuz eluzelz eleq2s fvconst2g syl2an adantr eqeltrd cle
        eqbrtrd climle ) ABCDNBOPZEFGHIABUAQRNQVCBUBUCABJUDUEBRNRUIUFUGUHKADUJZ
        GQZUKZVDVCSZBTABTQZVDNQZVGBULVEJVIVDFUMSGFVDUNHUONBVDTUPUQZAVHVEJURUSLV
        FVGBVDESUTVJMVAVB $.
    $}

    ${
      iserle.2 $e |- ( ph -> M e. ZZ ) $.
      iserle.4 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
      iserle.5 $e |- ( ph -> seq M ( + , G ) ~~> B ) $.
      iserle.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
      iserle.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. RR ) $.
      iserle.8 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) <_ ( G ` k ) ) $.
      $( Comparison of the limits of two infinite series.  (Contributed by Paul
         Chapman, 12-Nov-2007.)  (Revised by Mario Carneiro, 3-Feb-2014.) $)
      iserle $p |- ( ph -> A <_ B ) $=
        ( vj cr wcel cfv syl2anc caddc cseq cv serfre ffvelrnda wa cuz syl6eleq
        simpr cfz co simpll elfzuz syl6eleqr adantl cle wbr serle climle ) ABCP
        UAEGUBZUAFGUBZGHIJKLAHQPUCZUTADEGHIJMUDUEAHQVBVAADFGHIJNUDUEAVBHRZUFZDE
        FGVBVDVBHGUGSZAVCUIIUHVDDUCZGVBUJUKRZUFZAVFHRZVFESZQRAVCVGULZVGVIVDVGVF
        VEHVFGVBUMIUNUOZMTVHAVIVFFSZQRVKVLNTVHAVIVJVMUPUQVKVLOTURUS $.
    $}

    ${
      iserge0.2 $e |- ( ph -> M e. ZZ ) $.
      iserge0.3 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
      iserge0.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
      iserge0.5 $e |- ( ( ph /\ k e. Z ) -> 0 <_ ( F ` k ) ) $.
      $( The limit of an infinite series of nonnegative reals is nonnegative.
         (Contributed by Paul Chapman, 9-Feb-2008.)  (Revised by Mario
         Carneiro, 3-Feb-2014.) $)
      iserge0 $p |- ( ph -> 0 <_ A ) $=
        ( cc0 cuz cfv csn cxp cz wcel caddc syl cseq cli serclim0 cv wa cr wceq
        wbr simpr syl6eleq c0ex fvconst2 0re syl6eqel cle eqbrtrd iserle ) ALBC
        EMNZLOPZDEFGHAEQRSUSEUALUBUHHEUCTIACUDZFRZUEZUTUSNZLUFVBUTURRVCLUGVBUTF
        URAVAUIGUJURLUTUKULTZUMUNJVBVCLUTDNUOVDKUPUQ $.
    $}

    ${
      climub.2 $e |- ( ph -> N e. Z ) $.
      climub.3 $e |- ( ph -> F ~~> A ) $.
      climub.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
      climub.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
      $( The limit of a monotonic sequence is an upper bound.  (Contributed by
         NM, 18-Mar-2005.)  (Revised by Mario Carneiro, 10-Feb-2014.) $)
      climub $p |- ( ph -> ( F ` N ) <_ A ) $=
        ( vj cfv cuz wcel cr wi syldan co eqid cz syl6eleq eluzelz syl cv fveq2
        eleq1d imbi2d expcom vtoclga mpcom uztrn2 sylan impcom simpr cfz elfzuz
        wceq wa sylan2 adantlr c1 cmin caddc cle wbr monoord climlec2 ) AFDNZBM
        DFFONZVKUAAFEONZPFUBPAFGVLIHUCEFUDUEFGPZAVJQPZIACUFZDNZQPZRZAVNRCFGVOFU
        SZVQVNAVSVPVJQVOFDUGUHUIAVOGPZVQKUJZUKULJAMUFZVKPZWBGPZWBDNZQPZAVMWCWDI
        EWBFGHUMUNWDAWFVRAWFRCWBGVOWBUSZVQWFAWGVPWEQVOWBDUGUHUIWAUKUOSAWCUTCDFW
        BAWCUPAVOFWBUQTPZVQWCWHAVOVKPZVQVOFWBURAWIVTVQAVMWIVTIEVOFGHUMUNZKSVAVB
        AVOFWBVCVDTZUQTPZVPVOVCVETDNVFVGZWCWLAWIWMVOFWKURAWIVTWMWJLSVAVBVHVI $.
    $}

    ${
      climserle.2 $e |- ( ph -> N e. Z ) $.
      climserle.3 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
      climserle.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
      climserle.5 $e |- ( ( ph /\ k e. Z ) -> 0 <_ ( F ` k ) ) $.
      $( The partial sums of a converging infinite series with nonnegative
         terms are bounded by its limit.  (Contributed by NM, 27-Dec-2005.)
         (Revised by Mario Carneiro, 9-Feb-2014.) $)
      climserle $p |- ( ph -> ( seq M ( + , F ) ` N ) <_ A ) $=
        ( caddc cr cfv wcel cle cc0 wbr wi vj cv cuz cz syl6eleq eluzel2 serfre
        cseq syl ffvelrnda wa c1 co peano2uzs wceq breq2d imbi2d expcom vtoclga
        fveq2 impcom sylan2 eleq1d addge01d mpbid simpr seqp1 breqtrrd climub )
        ABUAMDEUHZEFGHIJAGNUAUBZVJACDEGHAFEUCOZPEUDPAFGVLIHUEEFUFUIKUGUJZAVKGPZ
        UKZVKVJOZVPVKULMUMZDOZMUMZVQVJOZQVORVRQSZVPVSQSVNAVQGPZWAEVKGHUNZWBAWAA
        RCUBZDOZQSZTAWATCVQGWDVQUOZWFWAAWGWEVRRQWDVQDUTZUPUQAWDGPZWFLURUSVAVBVO
        VPVRVMVNAWBVRNPZWCWBAWJAWENPZTAWJTCVQGWGWKWJAWGWEVRNWHVCUQAWIWKKURUSVAV
        BVDVEVOVKVLPVTVSUOVOVKGVLAVNVFHUEMDEVKVGUIVHVI $.
    $}
  $}

  ${
    isershft.1 $e |- F e. _V $.
    $( Index shift of the limit of an infinite series.  (Contributed by Mario
       Carneiro, 6-Sep-2013.)  (Revised by Mario Carneiro, 5-Nov-2013.) $)
    isershft $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( seq M ( .+ , F ) ~~> A <->
          seq ( M + N ) ( .+ , ( F shift N ) ) ~~> A ) ) $=
      ( cz wcel wa cshi co caddc cseq cli wbr cmin wceq cc zcn cvv zaddcl pncan
      seqshft sylancom syl2an seqeq1d oveq1d eqtrd breq1d seqex climshft adantl
      wb mpan2 bitr2d ) DGHZEGHZIZBCEJKDELKZMZANOBCDMZEJKZANOZVAANOZURUTVBANURU
      TBCUSEPKZMZEJKZVBUPUQUSGHUTVGQDEUABCUSEFUCUDURVFVAEJURVEDBCUPDRHERHVEDQUQ
      DSESDEUBUEUFUGUHUIUQVCVDUMZUPUQVATHVHBCDUJAVAETUKUNULUO $.
  $}

  ${
    $d j k m n x A $.  $d j k m n x F $.  $d k n x y N $.  $d j k m n x y ph $.
    $d j k m n x y G $.  $d j k m n x H $.  $d j k m n x y M $.  $d x y S $.
    $d n Z $.
    isercoll.z $e |- Z = ( ZZ>= ` M ) $.
    isercoll.m $e |- ( ph -> M e. ZZ ) $.
    isercoll.g $e |- ( ph -> G : NN --> Z ) $.
    isercoll.i $e |- ( ( ph /\ k e. NN ) -> ( G ` k ) < ( G ` ( k + 1 ) ) ) $.
    $( Lemma for ~ isercoll .  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    isercolllem1 $p |- ( ( ph /\ S C_ NN ) ->
      ( G |` S ) Isom < , < ( S , ( G " S ) ) ) $=
      ( vx vn cn clt cfv wcel cmin co cr cz vy wss wa cima cres wiso cv wi wral
      wbr uzssz eqsstri zssre sstri wf ad2antrr simplrl ffvelrnd sseldi simplrr
      cuz nnred resubcld simpr ltsub2dd cmpt cle nnzd ltled eluz2 syl3anbrc cfz
      elfzuz c1 nnuz uztrn2 sylan wceq weq fveq2 oveq12d eqid ovex fvmpt adantl
      id ffvelrnda nnre eqeltrd syldan sylan2 peano2nn ffvelrn syl2an peano2rem
      caddc syl simpll wb zltlem1 syl2anc mpbid lesub1dd recnd cc ax-1cn sub32d
      a1i subsub4d eqtrd breqtrd 3brtr4d monoord 3brtr3d ltletrd ltsub1d mpbird
      ex ralrimivva ssralv ralimdv syld mpan9 wor nnssre ltso soss mp2 soisores
      adantr syl22anc ) ABMUBZUCZBDBUDNNDBUEUFZKUGZUAUGZNUJZYODOZYPDOZNUJZUHZUA
      BUIZKBUIZAUUAUAMUIZKMUIZYLUUCAUUAKUAMMAYOMPZYPMPZUCZUCZYQYTUUIYQUCZYTYRYP
      QRZYSYPQRZNUJUUJUUKYRYOQRZUULUUJYRYPUUJFSYRFTSFEVAOTGEUKULZUMUNZUUJMFYODA
      MFDUOZUUHYQIUPZAUUFUUGYQUQZURUSZUUJYPAUUFUUGYQUTZVBZVCUUJYRYOUUSUUJYOUURV
      BZVCUUJYSYPUUJFSYSUUOUUJMFYPDUUQUUTURUSZUVAVCUUJYOYPYRUVBUVAUUSUUIYQVDZVE
      UUJYOLMLUGZDOZUVEQRZVFZOZYPUVHOZUUMUULVGUUJCUVHYOYPUUJYOTPYPTPYOYPVGUJYPY
      OVAOZPUUJYOUURVHUUJYPUUTVHUUJYOYPUVBUVAUVDVIYOYPVJVKCUGZYOYPVLRPUUJUVLUVK
      PZUVLUVHOZSPZUVLYOYPVMUUJUVMUVLMPZUVOUUJUUFUVMUVPUURVNUVLYOMVOVPVQZUUJUVP
      UCZUVNUVLDOZUVLQRZSUVPUVNUVTVRUUJLUVLUVGUVTMUVHLCVSZUVFUVSUVEUVLQUVEUVLDV
      TUWAWFWAUVHWBZUVSUVLQWCWDWEZUVRUVSUVLUVRFSUVSUUOUUJMFUVLDUUQWGZUSZUVPUVLS
      PUUJUVLWHWEZVCWIWJWKUVLYOYPVNQRZVLRPUUJUVMUVNUVLVNWPRZUVHOZVGUJZUVLYOUWGV
      MUUJUVMUVPUWJUVQUVRUVTUWHDOZUWHQRZUVNUWIVGUVRUVTUWKVNQRZUVLQRZUWLVGUVRUVS
      UWMUVLUWEUVRUWKSPUWMSPUVRFSUWKUUOUUJUUPUWHMPZUWKFPUVPUUQUVLWLZMFUWHDWMWNZ
      USZUWKWOWQUWFUVRUVSUWKNUJZUVSUWMVGUJZUUJAUVPUWSAUUHYQWRJVQUVRUVSTPUWKTPUW
      SUWTWSUVRFTUVSUUNUWDUSUVRFTUWKUUNUWQUSUVSUWKWTXAXBXCUVRUWNUWKUVLQRVNQRUWL
      UVRUWKVNUVLUVRUWKUWRXDZVNXEPUVRXFXHZUVRUVLUWFXDZXGUVRUWKUVLVNUXAUXCUXBXIX
      JXKUWCUVRUWOUWIUWLVRUVPUWOUUJUWPWELUWHUVGUWLMUVHUVEUWHVRZUVFUWKUVEUWHQUVE
      UWHDVTUXDWFWAUWBUWKUWHQWCWDWQXLWJWKXMUUJUUFUVIUUMVRUURLYOUVGUUMMUVHLKVSZU
      VFYRUVEYOQUVEYODVTUXEWFWAUWBYRYOQWCWDWQUUJUUGUVJUULVRUUTLYPUVGUULMUVHLUAV
      SZUVFYSUVEYPQUVEYPDVTUXFWFWAUWBYSYPQWCWDWQXNXOUUJYRYSYPUUSUVCUVAXPXQXRXSY
      LUUEUUBKMUIUUCYLUUDUUBKMUUAUABMXTYAUUBKBMXTYBYCYMMNYDZFNYDZUUPYLYNUUCWSUX
      GYMMSUBSNYDZUXGYEYFMSNYGYHXHUXHYMFSUBUXIUXHUUOYFFSNYGYHXHAUUPYLIYJAYLVDKU
      ABMFNNDYIYKXQ $.

    $( Lemma for ~ isercoll .  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    isercolllem2 $p |- ( ( ph /\ N e. ( ZZ>= ` ( G ` 1 ) ) ) ->
      ( 1 ... ( # ` ( G " ( `' G " ( M ... N ) ) ) ) ) =
        ( `' G " ( M ... N ) ) ) $=
      ( c1 cfv wcel cr clt cn adantr syl wb wss vx vy cuz wa ccnv cfz cima csup
      co chash cv wi elfznn a1i cdm cnvimass wf wceq fdm syl5sseq sseld cle wbr
      cz id nnuz syl6eleq wor cfn c0 wne ltso cen fzfid crn wfun ffun funimacnv
      cin 3syl inss1 syl6eqss ssfi syl2anc wf1 wiso wf1o cres ssid isercolllem1
      cvv mpan2 wfn ffn fnresdm isoeq1 4syl mpbid isof1o f1ocnv f1ofun sylanbrc
      df-f1 nnex ssexg sylancl f1imaeng syl3anc enfii 1nn ffvelrn simpr elfzuzb
      ensymd elpreima mpbir2and ne0i nnssre syl6ss fisupcl syl13anc sseldd nnzd
      elfz5 syl2anr simprd elfzle2 uzssz eqsstri zssre sstri ffvelrnda ffvelrnd
      sseldi eluzelz ad2antlr cxr ad2antrr ressxr ex letr mpan2d imassrn syl5ss
      frn leisorel syl122anc 3imtr4d baibd sylan sylibrd wral wrex fimaxre2 w3a
      suprub impbid bitrd pm5.21ndd fveq2d nnnn0d hashfz1 hashen mpbird 3eqtr3d
      eqrdv cn0 oveq2d eqtr3d ) AEKCLZUCLMZUDZKCUEZDEUFUIZUGZNOUHZUFUIZKCUVOUGZ
      UJLZUFUIUVOUVLUVPUVSKUFUVLUVQUJLZUVOUJLZUVPUVSUVLUVQUVOUJUVLUAUVQUVOUVLUA
      UKZPMZUWBUVQMZUWBUVOMZUWDUWCULUVLUWBUVPUMUNUVLUVOPUWBUVLCUOZUVOPCUVNUPUVL
      PFCUQZUWFPURAUWGUVKIQZPFCUSRUTZVAUVLUWCUWDUWESUVLUWCUDZUWDUWBUVPVBVCZUWEU
      WCUWBKUCLZMUVPVDMUWDUWKSUVLUWCUWBPUWLUWCVEVFVGUVLUVPUVLUVOPUVPUWIUVLNOVHZ
      UVOVIMZUVOVJVKZUVONTZUVPUVOMZUWMUVLVLUNUVLUVRVIMZUVOUVRVMVCZUWNUVLUVNVIMU
      VRUVNTUWRUVLDEVNUVLUVRUVNCVOZVSZUVNUVLUWGCVPUVRUXAURUWHPFCVQUVNCVRVTUVNUW
      TWAWBUVNUVRWCWDZUVLUVRUVOUVLPFCWEZUVOPTZUVOWKMZUVRUVOVMVCAUXCUVKAUWGUVMVP
      ZUXCIAPCPUGZOOCWFZPUXGCWGUXGPUVMWGUXFAPUXGOOCPWHZWFZUXHAPPTUXJPWIAPBCDFGH
      IJWJWLAUWGCPWMZUXICURUXJUXHSIPFCWNZPCWOPUXGOOCUXIWPWQWRZPUXGOOCWSPUXGCWTU
      XGPUVMXAWQPFCXCXBQUWIUVLUXDPWKMUXEUWIXDUVOPWKXEXFPFUVOCWKXGXHXNZUVOUVRXIW
      DZUVLKUVOMZUWOUVLUXPKPMZUVJUVNMZUXQUVLXJUNUVLUVJDUCLZMZUVKUXRAUXTUVKAUVJF
      UXSAUWGUXQUVJFMIXJPFKCXKXFGVGQAUVKXLUVJDEXMXBUVLUXKUXPUXQUXRUDSUVLUWGUXKU
      WHUXLRZPKUVNCXORXPUVOKXQRZUVLUVOPNUWIXRXSZNUVOOXTYAZYBZYCUWBKUVPYDYEUWJUW
      KUWEUWJUWKUWBCLZUVNMZUWEUWJUYFUVPCLZVBVCZUYFEVBVCZUWKUYGUWJUYIUYHEVBVCZUY
      JUVLUYKUWCUVLUYHUVNMZUYKUVLUVPPMZUYLUVLUWQUYMUYLUDZUYDUVLUXKUWQUYNSUYAPUV
      PUVNCXORWRYFUYHDEYGRQUWJUYFNMUYHNMENMUYIUYKUDUYJULUWJFNUYFFVDNFUXSVDGDYHY
      IYJYKZUVLPFUWBCUWHYLZYNUWJFNUYHUYOUVLUYHFMUWCUVLPFUVPCUWHUYEYMQYNUWJVDNEY
      JUVKEVDMZAUWCUVJEYOYPZYNUYFUYHEUUAXHUUBUWJUXHPYQTUXGYQTUWCUYMUWKUYISAUXHU
      VKUWCUXMYRUWJPNYQPNTUWJXRUNYSXSUWJUXGNYQUWJUXGFNUWJUXGUWTFCPUUCUWJUWGUWTF
      TAUWGUVKUWCIYRPFCUUERUUDUYOXSYSXSUVLUWCXLUVLUYMUWCUYEQPUXGUWBUVPCUUFUUGUW
      JUYFUXSMUYQUYGUYJSUWJUYFFUXSUYPGVGUYRUYFDEYDWDUUHUVLUXKUWCUWEUYGSUYAUXKUW
      EUWCUYGPUWBUVNCXOUUIUUJUUKUVLUWEUWKULZUWCUVLUWPUWOUBUKUWBVBVCUBUVOUULUANU
      UMZUYSUYCUYBUVLUWPUWNUYTUYCUXOUAUBUVOUUNWDUWPUWOUYTUUOUWEUWKUAUBUVOUWBUUP
      YTXHQUUQUURYTUUSUVFZUUTUVLUVPUVGMUVTUVPURUVLUVPUYEUVAUVPUVBRUVLUWAUVSURZU
      WSUXNUVLUWNUWRVUBUWSSUXOUXBUVOUVRUVCWDUVDUVEUVHVUAUVI $.

    isercoll.0 $e |- ( ( ph /\ n e. ( Z \ ran G ) ) -> ( F ` n ) = 0 ) $.
    isercoll.f $e |- ( ( ph /\ n e. Z ) -> ( F ` n ) e. CC ) $.
    isercoll.h $e |- ( ( ph /\ k e. NN ) -> ( H ` k ) = ( F ` ( G ` k ) ) ) $.
    $( Lemma for ~ isercoll .  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    isercolllem3 $p |- ( ( ph /\ N e. ( ZZ>= ` ( G ` 1 ) ) ) ->
      ( seq M ( + , F ) ` N ) = ( seq 1 ( + , H ) `
        ( # ` ( G " ( `' G " ( M ... N ) ) ) ) ) ) $=
      ( cfv wcel wceq cn c1 cuz wa ccnv cfz co cima caddc cc cres cc0 cv addid2
      adantl addid1 addcl 0cn a1i chash clt wiso wss cdm cnvimass wf adantr fdm
      syl syl5sseq isercolllem1 syldan wb isercolllem2 isoeq4 mpbird cin c0 wne
      dfss1 sylib ffvelrn sylancl syl6eleq simpr elfzuzb sylanbrc elpreima 3syl
      1nn wfn ffn mpbir2and ne0i eqnetrd imadisj necon3bii sylibr crn wfun ffun
      funimacnv inss1 eqsstrd simpl elfzuz syl6eleqr syl2an cdif difeq2d syl6eq
      difin ssriv ssdif sselda adantlr elfznn eleq2d biimpa fvres fveq2d eqtr4d
      mp1i seqcoll2 ) AHUAEQZUBQRZUCZEEUDGHUEUFZUGZUGZUHUICBDEYHUJZFGHUKCULZUIR
      ZUKYKUHUFYKSYFYKUMUNYLYKUKUHUFYKSYFYKUOUNYLBULZUIRUCYKYMUHUFUIRYFYKYMUPUN
      UKUIRYFUQURYFUAYIUSQZUEUFZYIUTUTYJVAZYHYIUTUTYJVAZAYEYHTVBYQYFEVCZYHTEYGV
      DZYFTIEVEZYRTSAYTYELVFZTIEVGVHVIAYHBEGIJKLMVJVKYFYOYHSYPYQVLABEGHIJKLMVMZ
      YOYIYHUTUTYJVNVHVOYFYRYHVPZVQVRYIVQVRYFUUCYHVQYFYHYRVBZUUCYHSUUDYFYSURYHY
      RVSVTYFUAYHRZYHVQVRYFUUEUATRZYDYGRZUUFYFWIURYFYDGUBQZRZYEUUGAUUIYEAYDIUUH
      AYTUUFYDIRLWITIUAEWAWBJWCVFAYEWDYDGHWEWFYFYTETWJUUEUUFUUGUCVLUUATIEWKTUAY
      GEWGWHWLYHUAWMVHWNYIVQUUCVQEYHWOWPWQYFYIYGEWRZVPZYGYFYTEWSYIUUKSUUATIEWTY
      GEXAWHZUUKYGVBYFYGUUJXBURXCYFAYKIRYKDQZUIRYKYGRZAYEXDZUUNYKUUHIYKGHXEJXFZ
      OXGYFYKYGYIXHZRYKIUUJXHZRZUUMUKSZYFUUQUURYKYFUUQYGUUJXHZUURYFUUQYGUUKXHUV
      AYFYIUUKYGUULXIYGUUJXKXJYGIVBUVAUURVBYFCYGIUUPXLYGIUUJXMYBXCXNAUUSUUTYENX
      OVKYFYMYORZUCZYMFQZYMEQZDQZYMYJQZDQYFAYMTRUVDUVFSUVBUUOYMYNXPPXGUVCUVGUVE
      DUVCYMYHRZUVGUVESYFUVBUVHYFYOYHYMUUBXQXRYMYHEXSVHXTYAYC $.

    $( Rearrange an infinite series by spacing out the terms using an order
       isomorphism.  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    isercoll $p |- ( ph ->
      ( seq 1 ( + , H ) ~~> A <-> seq M ( + , F ) ~~> A ) ) $=
      ( wcel cfv wbr cn vx vm vj vy cc cv caddc c1 cseq cmin co cabs clt wa cuz
      wral wrex crp cfz cima chash cli cz ffvelrnda sseldi cle ad2antlr cfn cn0
      wi wss fzfid cin wfun wceq funimacnv 3syl inss1 syl6eqss ad2antrr syl2anc
      ssfi hashcl nn0z cen wiso wf1o wb 4syl mpbid elfznn ssriv f1imaen sylancl
      ovex enfii hashen mpbird nnnn0 hashfz1 eqtrd cdom adantl cr sstri ffvelrn
      syl eluzelz ad3antrrr nnred lenltd 3bitr4d eluzle syl6eleq elfz5 elpreima
      wn adantr imass2 ssdomg hashdom fveq2 eleq1d oveq1d fveq2d breq1d anbi12d
      rspcv ralrimdva raleqdv rspcev ee12an rexlimdva cxr ressxr syl6ss imaeq2d
      nnuz a1i cvv ccnv uzssz eqsstri nnz crn ffun cres ssid isercolllem1 mpan2
      wf1 wfn ffn fnresdm isoeq1 isof1o f1ocnv f1ofun df-f1 sylanbrc zssre zred
      wf syl2an elfzle2 simpllr isorel syl12anc notbid letrd mpbir2and ex ssrdv
      sylc eqbrtrrd eluz2 syl3anbrc rexuz3 sylibrd nn0p1nn zltp1le nn0re uztrn2
      1nn eqid sylan ltnled fzss2 ffvelrnd nnssre imassrn syl5ss simpr leisorel
      frn syl122anc bitr4d pm5.32da fznn sseq1d bitr3d 3imtr4d syl5 mtod uztric
      eqrdv wo ord mpd oveq2 sylibd impbid ralbidv anbi2d 1z seqex isercolllem3
      eqidd clim2 ) ABUEQZCUFZUGGUHUIZRZUEQZUYCBUJUKZULRZUAUFZUMSZUNZCDUFZUORZU
      PZDTUQZUAURUPZUNUXTFFUUAZHUBUFZUSUKZUTZUTZVARZUYBRZUEQZVUABUJUKZULRZUYGUM
      SZUNZUBUCUFZUORZUPZUCUHFRZUORZUQZUAURUPZUNUYBBVBSUGEHUIZBVBSAUYNVUMUXTAUY
      MVULUAURAUYMVULAUYMVUIUCVCUQZVULAUYLVUODTAUYJTQZUNZUYJFRZVCQUYLVUFUBVURUO
      RZUPZVUOVUQIVCVURIHUORZVCJHUUBUUCZATIUYJFLVDZVEVUQUYLVUFUBVUSVUQUYPVUSQZU
      NZUYTUYKQZUYLVUFVJVVEUYJVCQZUYTVCQZUYJUYTVFSVVFVUPVVGAVVDUYJUUDVGVVEUYSVH
      QZUYTVIQVVHVVEUYQVHQUYSUYQVKZVVIVVEHUYPVLAVVJVUPVVDAUYSUYQFUUEZVMZUYQATIF
      UVCZFVNZUYSVVLVOLTIFUUFZUYQFVPVQUYQVVKVRVSVTUYQUYSWBWAZUYSWCUYTWDVQVVEFUH
      UYJUSUKZUTZVARZUYJUYTVFVVEVVSVVQVARZUYJVVEVVSVVTVOZVVRVVQWESZVVETIFUUKZVV
      QTVKVWBAVWCVUPVVDAVVMUYOVNZVWCLATFTUTZUMUMFWFZTVWEFWGVWETUYOWGVWDATVWEUMU
      MFTUUGZWFZVWFATTVKVWHTUUHATCFHIJKLMUUIUUJAVVMFTUULZVWGFVOVWHVWFWHLTIFUUMZ
      TFUUNTVWEUMUMFVWGUUOWIWJZTVWEUMUMFUUPTVWEFUUQVWETUYOUURWITIFUUSUUTZVTUDVV
      QTUDUFZUYJWKZWLTIVVQFUHUYJUSWOWMWNZVVEVVRVHQZVVQVHQZVWAVWBWHVVEVWQVWBVWPV
      VEUHUYJVLZVWOVVRVVQWPWAZVWRVVRVVQWQWAWRVVEUYJVIQZVVTUYJVOVUPVWTAVVDUYJWSV
      GUYJWTXGXAVVEVVSUYTVFSZVVRUYSXBSZVVEVVIVVRUYSVKZVXBVVPVVEVVQUYRVKVXCVVEUD
      VVQUYRVVEVWMVVQQZVWMUYRQZVVEVXDUNZVXEVWMTQZVWMFRZUYQQZVXDVXGVVEVWNXCZVXFV
      XIVXHUYPVFSZVXFVXHVURUYPVXFIXDVXHIVCXDVVBUVAXEZVVEVVMVXGVXHIQVXDAVVMVUPVV
      DLVTZVWNTIVWMFXFUVDZVEZVXFIXDVURVXLVUQVURIQVVDVXDVVCVTVEZVXFUYPVVDUYPVCQZ
      VUQVXDVURUYPXHVGZUVBVXFVWMUYJVFSZVXHVURVFSZVXDVXSVVEVWMUHUYJUVEXCVXFUYJVW
      MUMSZXQVURVXHUMSZXQVXSVXTVXFVYAVYBVXFVWFVUPVXGVYAVYBWHAVWFVUPVVDVXDVWKXIA
      VUPVVDVXDUVFZVXJTVWEUYJVWMUMUMFUVGUVHUVIVXFVWMUYJVXFVWMVXJXJVXFUYJVYCXJXK
      VXFVXHVURVXOVXPXKXLWJVVDVURUYPVFSVUQVXDVURUYPXMVGUVJVXFVXHVVAQVXQVXIVXKWH
      VXFVXHIVVAVXNJXNVXRVXHHUYPXOWAWRVXFVWIVXEVXGVXIUNWHVVEVWIVXDVVEVVMVWIVXMV
      WJXGXRTVWMUYQFXPXGUVKUVLUVMVVQUYRFXSXGVVRUYSVHXTUVNVVEVWPVVIVXAVXBWHVWSVV
      PVVRUYSVHYAWAWRUVOUYJUYTUVPUVQUYIVUFCUYTUYKUYAUYTVOZUYDVUBUYHVUEVYDUYCVUA
      UEUYAUYTUYBYBZYCVYDUYFVUDUYGUMVYDUYEVUCULVYDUYCVUABUJVYEYDYEYFYGYHXGYIVUI
      VUTUCVURVCVUGVURVOVUFUBVUHVUSVUGVURUOYBYJYKYLYMAVUJVVAQZVUJVCQZVULVUOWHAV
      UJIVVAAVVMUHTQVUJIQLUWDTIUHFXFWNJXNZHVUJXHZVUFUCUBVUJVUKVUKUWEZUVRVQUVSAV
      UIUYMUCVUKAVUGVUKQZUNZFUYOHVUGUSUKZUTZUTZVARZUHUGUKZTQZVUIUYICVYQUORZUPZU
      YMVYLVYOVHQZVYPVIQZVYRVYLVYMVHQVYOVYMVKZWUAVYLHVUGVLAWUCVYKAVYOVYMVVKVMZV
      YMAVVMVVNVYOWUDVOLVVOVYMFVPVQVYMVVKVRVSXRVYMVYOWBWAZVYOWCZVYPUVTVQZVYLVUI
      UYICVYSVYLUYAVYSQZUNZVUIFUYOHUYAFRZUSUKZUTZUTZVARZUYBRZUEQZWUOBUJUKZULRZU
      YGUMSZUNZUYIWUIWUJVUHQZVUIWUTVJWUIVUGWUJUORQZXQWVAWUIWVBUYAVYPVFSZWUIVYPU
      YAUMSZWVCXQWUIWVDVYQUYAVFSZWUHWVEVYLVYQUYAXMXCWUIVYPVCQZUYAVCQZWVDWVEWHWU
      IWUAWUBWVFVYLWUAWUHWUEXRZWUFVYPWDVQWUHWVGVYLVYQUYAXHXCZVYPUYAUWAWAWRWUIVY
      PUYAVYLVYPXDQZWUHVYLWUAWUBWVJWUEWUFVYPUWBVQXRWUIUYAVYLVYRWUHUYATQZWUGUHUY
      AVYQTYRUWCUWFZXJUWGWJWVBWUMVYOVKZWUIWVCWVBWUKVYMVKWULVYNVKWVMWUJHVUGUWHWU
      KVYMUYOXSWULVYNFXSVQWUIFUHUYAUSUKZUTZVYOVKZWVOVYOXBSZWVMWVCWUIWUAWVPWVQVJ
      WVHWVOVYOVHXTXGWUIWUMWVOVYOWUIWULWVNFWUIUAWULWVNWUIUYGTQZUYGFRZWUKQZUNZWV
      RUYGUYAVFSZUNZUYGWULQZUYGWVNQZWUIWVRWVTWWBWUIWVRUNZWVTWVSWUJVFSZWWBWWFWVS
      VVAQWUJVCQZWVTWWGWHWWFWVSIVVAWUITIUYGFAVVMVYKWUHLVTZVDJXNWUIWWHWVRWUIIVCW
      UJVVBWUITIUYAFWWIWVLUWIVEZXRWVSHWUJXOWAWWFVWFTYNVKZVWEYNVKWVRWVKWWBWWGWHA
      VWFVYKWUHWVRVWKXIWWKWWFTXDYNUWJYOXEYSWWFVWEXDYNWWFVWEVVKXDFTUWKWWFVVKIXDW
      WFVVMVVKIVKWUIVVMWVRWWIXRTIFUWOXGVXLYPUWLYOYPWUIWVRUWMWUIWVKWVRWVLXRTVWEU
      YGUYAFUWNUWPUWQUWRWUIVVMVWIWWDWWAWHWWIVWJTUYGWUKFXPVQWUIWVGWWEWWCWHWVIUYG
      UYAUWSXGXLUXFYQZUWTWUIWVOVARZVYPVFSZWVCWVQWUIWWMUYAVYPVFWUIWWMWVNVARZUYAW
      UIWWMWWOVOZWVOWVNWESZWUIVWCWVNTVKWWQAVWCVYKWUHVWLVTUAWVNTUYGUYAWKWLTIWVNF
      UHUYAUSWOWMWNZWUIWVOVHQZWVNVHQZWWPWWQWHWUIWWTWWQWWSWUIUHUYAVLZWWRWVOWVNWP
      WAZWXAWVOWVNWQWAWRWUIWVKUYAVIQWWOUYAVOWVLUYAWSUYAWTVQXAZYFWUIWWSWUAWWNWVQ
      WHWXBWVHWVOVYOVHYAWAUXAUXBUXCUXDWUIWVBWVAWUIWWHVUGVCQZWVBWVAUXGWWJVYKWXDA
      WUHVUJVUGXHVGWUJVUGUXEWAUXHUXIVUFWUTUBWUJVUHUYPWUJVOZVUBWUPVUEWUSWXEVUAWU
      OUEWXEUYTWUNUYBWXEUYSWUMVAWXEUYRWULFWXEUYQWUKUYOUYPWUJHUSUXJYQYQYEYEZYCWX
      EVUDWURUYGUMWXEVUCWUQULWXEVUAWUOBUJWXFYDYEYFYGYHXGWUIWUPUYDWUSUYHWUIWUOUY
      CUEWUIWUNUYAUYBWUIWUNWWMUYAWUIWUMWVOVAWWLYEWXCXAYEZYCWUIWURUYFUYGUMWUIWUQ
      UYEULWUIWUOUYCBUJWXGYDYEYFYGUXKYIUYLVYTDVYQTUYJVYQVOUYICUYKVYSUYJVYQUOYBY
      JYKYLYMUXLUXMUXNAUABUYCDCUYBUHYTTYRUHVCQAUXOYSUYBYTQAUGGUHUXPYSAWVKUNUYCU
      XRUXSAUABVUAUCUBVUNVUJYTVUKVYJAVYFVYGVYHVYIXGVUNYTQAUGEHUXPYSACDEFGHUYPIJ
      KLMNOPUXQUXSXL $.
  $}

  ${
    $d j k n A $.  $d j k n F $.  $d j k n x G $.  $d j k n x H $.  $d j n N $.
    $d j k n x M $.  $d j k n x ph $.  $d n x W $.  $d j k Z $.
    isercoll2.z $e |- Z = ( ZZ>= ` M ) $.
    isercoll2.w $e |- W = ( ZZ>= ` N ) $.
    isercoll2.m $e |- ( ph -> M e. ZZ ) $.
    isercoll2.n $e |- ( ph -> N e. ZZ ) $.
    isercoll2.g $e |- ( ph -> G : Z --> W ) $.
    isercoll2.i $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) < ( G ` ( k + 1 ) ) ) $.
    isercoll2.0 $e |- ( ( ph /\ n e. ( W \ ran G ) ) -> ( F ` n ) = 0 ) $.
    isercoll2.f $e |- ( ( ph /\ n e. W ) -> ( F ` n ) e. CC ) $.
    isercoll2.h $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) = ( F ` ( G ` k ) ) ) $.
    $( Generalize ~ isercoll so that both sequences have arbitrary starting
       point.  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    isercoll2 $p |- ( ph ->
      ( seq M ( + , H ) ~~> A <-> seq N ( + , F ) ~~> A ) ) $=
      ( vx vj caddc cseq cli wbr cn cv c1 cmin cfv cmpt cvv wcel zsubcl sylancr
      co cz 1z seqex a1i wa cuz simpr syl6eleq adantr wceq cfz elfzuz syl6eleqr
      simpl eluzelz syl cc ax-1cn subadd23d cn0 uznn0sub nn0p1nn eqeltrrd oveq1
      zcnd oveq2d fveq2d fvmpt oveq1d nn0cnd pncan sylancl eqtr3d pncan3d eqtrd
      eqid fvex eqtr2d syl2an seqshft2 pncan3 seqeq1d climshft2 wf uzid nnm1nn0
      fveq1d uzaddcl ffvelrnd fmptd clt wral ralrimiva fveq2 breq12d rspcv sylc
      nncn adantl addsubd addassd eqtr4d breqtrrd peano2nn 3brtr4d crn cdif cc0
      wss wfn ffn eleq2s eqeq2d rspcev syl2anc wb elrnmpt ax-mp sylibr sylanbrc
      wrex ffnfv frn sscond sselda syldan eqeq12d 3eqtr4d isercoll bitrd ) AUCG
      HUDZBUEUFUCUAUGHUAUHZUIUJUQZUCUQZGUKZULZUIUDZBUEUFUCEIUDBUEUFABCUUHUUNUIH
      UJUQZHUMUMKLNAUIURUNHURUNZUUOURUNZUSNUIHUOUPZUUHUMUNAUCGHUTVAUUNUMUNAUCUU
      MUIUTVAACUHZKUNZVBZUUSUUHUKUUSUUOUCUQZUCUUMHUUOUCUQZUDZUKUVBUUNUKUVAUCUBG
      UUMUUOHUUSUVAUUSKHVCUKZAUUTVDLVEZAUUQUUTUURVFUVAAUBUHZKUNZUVGGUKZUVGUUOUC
      UQZUUMUKZVGUVGHUUSVHUQUNZAUUTVKUVLUVGUVEKUVGHUUSVILVJAUVHVBZUVKHUVJUIUJUQ
      ZUCUQZGUKZUVIUVMUVJUGUNUVKUVPVGUVMUVGHUJUQZUIUCUQZUVJUGUVMUVGHUIUVMUVGUVM
      UVGUVEUNZUVGURUNUVMUVGKUVEAUVHVDLVEZHUVGVLVMWBZAHVNUNZUVHAHNWBZVFZUIVNUNZ
      UVMVOVAVPZUVMUVQVQUNZUVRUGUNUVMUVSUWGUVTHUVGVRVMZUVQVSVMVTUAUVJUULUVPUGUU
      MUUIUVJVGZUUKUVOGUWIUUJUVNHUCUUIUVJUIUJWAWCWDUUMWMZUVOGWNWEVMUVMUVOUVGGUV
      MUVOHUVQUCUQUVGUVMUVNUVQHUCUVMUVRUIUJUQZUVNUVQUVMUVRUVJUIUJUWFWFUVMUVQVNU
      NUWEUWKUVQVGUVMUVQUWHWGVOUVQUIWHWIWJWCUVMHUVGUWDUWAWKWLWDWOWPWQUVAUVBUVDU
      UNUVAUVCUIUCUUMUVAUWBUWEUVCUIVGAUWBUUTUWCVFVOHUIWRWIWSXDWOWTABUBDEUAUGUUK
      FUKZULZUUMIJMOAUAUGUWLJUWMAUUIUGUNZVBZKJUUKFAKJFXAZUWNPVFUWOUUKUVEKAHUVEU
      NZUUJVQUNUUKUVEUNUWNAUUPUWQNHXBVMZUUIXCUUJHHXEWPLVJXFUWMWMZXGAUVGUGUNZVBZ
      HUVGUIUJUQZUCUQZFUKZHUVGUIUCUQZUIUJUQZUCUQZFUKZUVGUWMUKZUXEUWMUKZXHUXAUXD
      UXCUIUCUQZFUKZUXHXHUXAUXCKUNZUUSFUKZUUSUIUCUQZFUKZXHUFZCKXIZUXDUXLXHUFZUX
      AUXCUVEKAUWQUXBVQUNZUXCUVEUNUWTUWRUVGXCZUXBHHXEWPLVJZAUXRUWTAUXQCKQXJVFUX
      QUXSCUXCKUUSUXCVGZUXNUXDUXPUXLXHUUSUXCFXKZUYCUXOUXKFUUSUXCUIUCWAWDXLXMXNU
      XAUXGUXKFUXAUXGHUXBUIUCUQZUCUQUXKUXAUXFUYEHUCUXAUVGUIUIUWTUVGVNUNAUVGXOXP
      UWEUXAVOVAZUYFXQWCUXAHUXBUIAUWBUWTUWCVFUXAUXBUWTUXTAUYAXPWGUYFXRXSWDXTUWT
      UXIUXDVGAUAUVGUWLUXDUGUWMUUIUVGVGZUUKUXCFUYGUUJUXBHUCUUIUVGUIUJWAWCZWDUWS
      UXCFWNWEXPZUXAUXEUGUNZUXJUXHVGUWTUYJAUVGYAXPUAUXEUWLUXHUGUWMUUIUXEVGZUUKU
      XGFUYKUUJUXFHUCUUIUXEUIUJWAWCWDUWSUXGFWNWEVMYBADUHZJUWMYCZYDZUNUYLJFYCZYD
      ZUNUYLEUKYEVGAUYNUYPUYLAUYOUYMJAKUYMFXAZUYOUYMYFAFKYGZUXNUYMUNZCKXIUYQAUW
      PUYRPKJFYHVMAUYSCKUVAUXNUWLVGZUAUGYRZUYSUVAUUSHUJUQZUIUCUQZUGUNZUXNHVUCUI
      UJUQZUCUQZFUKZVGZVUAUVAVUBVQUNZVUDUVAUUSUVEUNVUIUVFHUUSVRVMZVUBVSVMUVAUUS
      VUFFUVAVUFHVUBUCUQZUUSUVAVUEVUBHUCUVAVUBVNUNUWEVUEVUBVGUVAVUBVUJWGVOVUBUI
      WHWIWCAUWBUUSVNUNVUKUUSVGUUTUWCUUTUUSUUSURUNUUSUVEKHUUSVLLYIWBHUUSWRWPWOW
      DUYTVUHUAVUCUGUUIVUCVGZUWLVUGUXNVULUUKVUFFVULUUJVUEHUCUUIVUCUIUJWAWCWDYJY
      KYLUXNUMUNUYSVUAYMUUSFWNUAUGUWLUXNUWMUMUWSYNYOYPXJCKUYMFYSYQKUYMFYTVMUUAU
      UBRUUCSUXAUXCGUKZUXDEUKZUVGUUMUKZUXIEUKUXAUXMUUSGUKZUXNEUKZVGZCKXIZVUMVUN
      VGZUYBAVUSUWTAVURCKTXJVFVURVUTCUXCKUYCVUPVUMVUQVUNUUSUXCGXKUYCUXNUXDEUYDW
      DUUDXMXNUWTVUOVUMVGAUAUVGUULVUMUGUUMUYGUUKUXCGUYHWDUWJUXCGWNWEXPUXAUXIUXD
      EUYIWDUUEUUFUUG $.
  $}

  ${
    $d j k n x y F $.  $d j M $.  $d j k n y ph $.  $d j k n x y Z $.
    climsup.1 $e |- Z = ( ZZ>= ` M ) $.
    climsup.2 $e |- ( ph -> M e. ZZ ) $.
    climsup.3 $e |- ( ph -> F : Z --> RR ) $.
    climsup.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
    climsup.5 $e |- ( ph -> E. x e. RR A. k e. Z ( F ` k ) <_ x ) $.
    $( A bounded monotonic sequence converges to the supremum of its range.
       Theorem 12-5.1 of [Gleason] p. 180.  (Contributed by NM, 13-Mar-2005.)
       (Revised by Mario Carneiro, 10-Feb-2014.) $)
    climsup $p |- ( ph -> F ~~> sup ( ran F , RR , < ) ) $=
      ( vy vn cr clt wbr cfv co wcel cle vj crn csup cli cv cmin cabs wral wrex
      cuz crp wa wss c0 wne w3a frn syl wfn ffn uzid syl6eleqr fnfvelrn syl2anc
      wf cz ne0i wb breq1 ralrn rexbidv mpbird 3jca suprcl ltsubrp sylan adantr
      rpre resubcl syl2an suprlub mpbid breq2 biimpa syldan wi ffvelrn ad2ant2r
      rexrn uztrn2 ad2antrr simprr fzssuz uzss syl6sseqr eleq2s ad2antrl syl5ss
      cfz ralrimiva ssralv sylc r19.21bi c1 caddc sselda weq fveq2 oveq1 fveq2d
      breq12d rspccva monoord lesub2dd resubcld ad2antlr lelttr syl3anc ltsub23
      mpand suprub abssuble0d breq1d 3imtr4d anassrs ralrimdva reximdva mpd cvv
      fvex eqeltri fex sylancl eqidd recnd clim2c ) ADDUBZNOUCZUDPCUEZDQZYRUFRU
      GQZLUEZOPZCUAUEZUJQZUHZUAFUIZLUKUHAUUGLUKAUUBUKSZULZYRUUBUFRZUUDDQZOPZUAF
      UIZUUGAUUHUUJYSOPZCYQUIZUUMUUIUUJYROPZUUOAYRNSZUUHUUPAYQNUMZYQUNUOZUUBBUE
      ZTPZLYQUHZBNUIZUPZUUQAUURUUSUVCAFNDVEZUURIFNDUQURAEDQZYQSZUUSADFUSZEFSUVG
      AUVEUVHIFNDUTURZAEEUJQZFAEVFSEUVJSHEVAURGVBFEDVCVDYQUVFVGURAUVCYTUUTTPZCF
      UHZBNUIZKAUVHUVCUVMVHUVIUVHUVBUVLBNUVAUVKLCFDUUBYTUUTTVIVJVKURVLVMZBLYQVN
      URZYRUUBVOVPUUIUVDUUJNSZUUPUUOVHAUVDUUHUVNVQAUUQUUBNSZUVPUUHUVOUUBVRZYRUU
      BVSVTBLCYQUUJWAVDWBAUUOUUMAUVHUUOUUMVHUVIUUNUULCUAFDYSUUKUUJOWCWIURWDWEUU
      IUULUUFUAFUUIUUDFSZULUULUUCCUUEUUIUVSYSUUESZUULUUCWFUUIUVSUVTULZULZYRUUKU
      FRZUUBOPZYRYTUFRZUUBOPZUULUUCUWBUWEUWCTPZUWDUWFUWBUUKYTYRAUVSUUKNSZUUHUVT
      AUVEUVSUWHIFNUUDDWGVPWHZUUIUVEYSFSZYTNSZUWAAUVEUUHIVQEYSUUDFGWJZFNYSDWGZV
      TZAUUQUUHUWAUVOWKZUWBMDUUDYSUUIUVSUVTWLUWBMUEZDQZNSZMUUDYSWSRZUWBUWSFUMUW
      RMFUHZUWRMUWSUHUWBUWSUUEFUUDYSWMUVSUUEFUMZUUIUVTUXAUUDUVJFUUDUVJSUUEUVJFE
      UUDWNGWOGWPWQZWRAUWTUUHUWAAUVEUWTIUVEUWRMFFNUWPDWGWTURWKUWRMUWSFXAXBXCUWB
      UWPUUDYSXDUFRZWSRZSUWPFSZUWQUWPXDXERZDQZTPZUWBUXDFUWPUWBUXDUUEFUUDUXCWMUX
      BWRXFUWBYTYSXDXERZDQZTPZCFUHZUXEUXHAUXLUUHUWAAUXKCFJWTWKUXKUXHCUWPFCMXGZY
      TUWQUXJUXGTYSUWPDXHUXMUXIUXFDYSUWPXDXEXIXJXKXLVPWEXMXNUWBUWENSUWCNSUVQUWG
      UWDULUWFWFUWBYRYTUWOUWNXOUWBYRUUKUWOUWIXOUUHUVQAUWAUVRXPZUWEUWCUUBXQXRXTU
      WBUUQUVQUWHUULUWDVHUWOUXNUWIYRUUBUUKXSXRUWBUUAUWEUUBOUWBYTYRUWNUWOUWBUVDY
      TYQSZYTYRTPAUVDUUHUWAUVNWKUUIUVHUWJUXOUWAAUVHUUHUVIVQUWLFYSDVCVTBLYQYTYAV
      DYBYCYDYEYFYGYHWTALYRYTUACDEYIFGHAUVEFYISDYISIFUVJYIGEUJYJYKFNYIDYLYMAUWJ
      ULZYTYNAYRUVOYOUXPYTAUVEUWJUWKIUWMVPYOYPVL $.
  $}

  ${
    $d j k x y F $.  $d j k x y M $.  $d j k x y Z $.
    climcau.1 $e |- Z = ( ZZ>= ` M ) $.
    $( A converging sequence of complex numbers is a Cauchy sequence.  Theorem
       12-5.3 of [Gleason] p. 180 (necessity part).  (Contributed by NM,
       16-Apr-2005.)  (Revised by Mario Carneiro, 26-Apr-2014.) $)
    climcau $p |- ( ( M e. ZZ /\ F e. dom ~~> ) -> A. x e. RR+ E. j e. Z
              A. k e. ( ZZ>= ` j ) ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) $=
      ( vy wcel cli cv cfv cmin co cabs clt wbr crp wa cc cdm cuz wral wrex cop
      cz wex eldm2g ibi df-br c2 cdiv simpll rphalfcl adantl eqidd simplr climi
      wi eluzelz syl eleq2s weq fveq2 eleq1d oveq1d fveq2d breq1d anbi12d rspcv
      uzid cr rpre simpllr climcl simprl simplrl simplll simprr abssubd simplrr
      ad2antlr eqbrtrd abs3lemd ex ralimdv com23 syl2anc reximdva mpd ralrimiva
      mpdd syl5bir exlimdv syl5 imp ) EUFIZDJUAZIZCKZDLZBKZDLZMNOLAKZPQZCXBUBLZ
      UCZBFUDZARUCZWSDHKZUEJIZHUGZWQXIWSXLHDJWRUHUIWQXKXIHXKDXJJQZWQXIDXJJUJWQX
      MXIWQXMSZXHARXNXDRIZSZXATIZXAXJMNZOLZXDUKULNZPQZSZCXFUCZBFUDXHXPXJXAXTBCD
      EFGWQXMXOUMXOXTRIXNXDUNUOXPWTFISXAUPWQXMXOUQURXPYCXGBFXPXBFIZSZYCXCTIZXCX
      JMNZOLZXTPQZSZXGYEXBXFIZYCYJUSYDYKXPYKXBEUBLZFXBYLIXBUFIYKEXBUTXBVKVAGVBU
      OYBYJCXBXFCBVCZXQYFYAYIYMXAXCTWTXBDVDZVEYMXSYHXTPYMXRYGOYMXAXCXJMYNVFVGVH
      VIVJVAYEXDVLIZXJTIZYCYJXGUSUSXOYOXNYDXDVMWBYEXMYPWQXMXOYDVNXJDVOVAYOYPSZY
      JYCXGYQYJYCXGUSYQYJSZYBXECXFYRYBXEYRYBSZXAXCXJXDYRXQYAVPYQYFYIYBVQZYOYPYJ
      YBVNZYOYPYJYBVRYRXQYAVSYSXJXCMNOLYHXTPYSXJXCUUAYTVTYQYFYIYBWAWCWDWEWFWEWG
      WHWLWIWJWKWEWMWNWOWP $.

    $( A converging sequence of complex numbers is bounded.  (Contributed by
       Mario Carneiro, 9-Jul-2017.) $)
    climbdd $p |- ( ( M e. ZZ /\ F e. dom ~~> /\ A. k e. Z ( F ` k ) e. CC ) ->
      E. x e. RR A. k e. Z ( abs ` ( F ` k ) ) <_ x ) $=
      ( vj vy wcel cv cfv wral cabs clt wbr cr wrex syl2anc wi wa cz cli cdm cc
      w3a cle cmin co cuz crp simp3 climcau 3adant3 caubnd r19.26 simpr simpllr
      abscld ltle expimpd ralimdva syl5bir exp4b com23 3impia reximdvai mpd ) D
      UAIZCUBUCIZBJZCKZUDIZBELZUEZVKMKZAJZNOZBELZAPQZVOVPUFOZBELZAPQVNVMVKGJZCK
      UGUHMKHJNOBWBUIKLGEQHUJLZVSVHVIVMUKVHVIWCVMHGBCDEFULUMHAGBCDEFUNRVNVRWAAP
      VHVIVMVPPIZVRWASZSVHVITZWDVMWEWFWDVMVRWAVMVRTVLVQTZBELWFWDTZWAVLVQBEUOWHW
      GVTBEWHVJEIZTZVLVQVTWJVLTZVOPIWDVQVTSWKVKWJVLUPURWFWDWIVLUQVOVPUSRUTVAVBV
      CVDVEVFVG $.
  $}

  ${
    $d j k m n x A $.  $d j k m n x y F $.  $d j k m n x y ph $.
    $d j k m n x R $.
    caurcvgr.1 $e |- ( ph -> A C_ RR ) $.
    caurcvgr.2 $e |- ( ph -> F : A --> RR ) $.
    caurcvgr.3 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    caurcvgr.4 $e |- ( ph -> A. x e. RR+ E. j e. A A. k e. A
      ( j <_ k -> ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ) $.
    ${
      caucvgrlem.4 $e |- ( ph -> R e. RR+ ) $.
      $( Lemma for ~ caurcvgr .  (Contributed by Mario Carneiro, 15-Feb-2014.)
         (Revised by Mario Carneiro, 8-May-2016.) $)
      caucvgrlem $p |- ( ph -> E. j e. A ( ( limsup ` F ) e. RR /\
        A. k e. A ( j <_ k ->
          ( abs ` ( ( F ` k ) - ( limsup ` F ) ) ) < ( 3 x. R ) ) ) ) $=
        ( vm cle wbr cmin co cr wcel adantr vn cv cfv cabs wi wral wrex clsp c3
        clt cmul crp wceq breq2 imbi2d rexralbidv rspcv sylc cxr caddc cmnf cvv
        wa wf wss reex ssex syl a1i fex2 syl3anc limsupcl simprl ffvelrnd rpred
        readdcld mnfxr resubcld rexrd mnflt ressxr fss sylancl csup cpnf sseldd
        simprr fveq2 oveq1d fveq2d breq1d imbi12d cbvralv sylib ffvelrnda recnd
        weq abscld ltle syl2anc absdifled sylibd simpl syl6 imim2d ralimdva mpd
        breq1 imbi1d ralbidv rspcev xrltletrd adantrr simplrr syl3c ltled mpbid
        limsupbnd2 simprd expr ralrimiva limsupbnd1 syl22anc c2 remulcl sylancr
        2re 3re abssubd 2timesd oveq2d subsub4d eqtr4d lesubaddd mpbird eqbrtrd
        xrre lesub1dd letrd leadd1dd addassd breqtrd 2lt3 ltmul1d mpbii lelttrd
        mpbir2and sylibr jca reximdva ) AEUBZFUBZNOZUULGUCZUUKGUCZPQZUDUCZDUJOZ
        UEZFCUFZECUGZGUHUCZRSZUUMUUNUVBPQZUDUCZUIDUKQZUJOZUEZFCUFZVCZECUGADULSZ
        UUMUUQBUBZUJOZUEZFCUFECUGZBULUFUVALKUVOUVABDULUVLDUMZUVNUUSEFCCUVPUVMUU
        RUUMUVLDUUQUJUNUOUPUQURAUUTUVJECAUUKCSZUUTUVJAUVQUUTVCZVCZUVCUVIUVSUVBU
        SSZUUODUTQZRSZVAUVBUJOUVBUWANOZUVCAUVTUVRAGVBSZUVTACRGVDZCVBSZRVBSZUWDI
        ACRVEZUWFHCRVFVGVHUWGAVFVICRGVBVBVJVKGVBVLVHTZUVSUUODUVSCRUUKGAUWEUVRIT
        ZAUVQUUTVMZVNZADRSZUVRADLVOTZVPZUVSVAUUODPQZUVBVAUSSUVSVQVIUVSUWPUVSUUO
        DUWLUWNVRZVSZUWIUVSUWPRSZVAUWPUJOUWQUWPVTVHUVSUWPCMUAGAUWHUVRHTZACUSGVD
        ZUVRAUWERUSVEUXAIWACRUSGWBWCTZUWRACUSUJWDWEUMUVRJTUVSUUKRSZUUKMUBZNOZUW
        PUXDGUCZNOZUEZMCUFZUAUBZUXDNOZUXGUEZMCUFZUARUGUVSCRUUKUWTUWKWFZUVSUXEUX
        FUUOPQZUDUCZDUJOZUEZMCUFZUXIUVSUUTUXSAUVQUUTWGUUSUXRFMCFMWQZUUMUXEUURUX
        QUULUXDUUKNUNZUXTUUQUXPDUJUXTUUPUXOUDUXTUUNUXFUUOPUULUXDGWHZWIWJWKWLZWM
        WNUVSUXRUXHMCUVSUXDCSZVCZUXQUXGUXEUYEUXQUXGUXFUWANOZVCZUXGUYEUXQUXPDNOZ
        UYGUYEUXPRSZUWMUXQUYHUEUYEUXOUYEUXOUYEUXFUUOUVSCRUXDGUWJWOZUVSUUORSZUYD
        UWLTZVRWPWRZUVSUWMUYDUWNTZUXPDWSWTUYEUXFUUODUYJUYLUYNXAXBUXGUYFXCZXDXEX
        FXGUXMUXIUAUUKRUAEWQZUXLUXHMCUYPUXKUXEUXGUXJUUKUXDNXHZXIXJXKWTXRZXLUVSU
        WACMUAGUWTUXBUVSUWAUWOVSUVSUXCUXEUYFUEZMCUFZUXKUYFUEZMCUFZUARUGUXNUVSUY
        SMCUVSUYDUXEUYFUVSUYDUXEVCZVCZUXGUYFVUDUYHUYGVUDUXPDUVSUYDUYIUXEUYMXMUV
        SUWMVUCUWNTZVUDUYDUUTUXEUXQUVSUYDUXEVMAUVQUUTVUCXNUVSUYDUXEWGUUSUXRFUXD
        CUYCUQXOXPVUDUXFUUODUVSUYDUXFRSUXEUYJXMZUVSUYKVUCUWLTZVUEXAXQZXSZXTYAVU
        BUYTUAUUKRUYPVUAUYSMCUYPUXKUXEUYFUYQXIXJXKWTYBZUVBUWAYQYCZUVSUXEUXFUVBP
        QZUDUCZUVFUJOZUEZMCUFUVIUVSVUOMCUVSUYDUXEVUNVUDVUMYDDUKQZUVFVUDVULVUDVU
        LVUDUXFUVBVUFUVSUVCVUCVUKTZVRWPWRVUDYDRSZUWMVUPRSYGVUEYDDYEYFZVUDUIRSZU
        WMUVFRSYHVUEUIDYEYFVUDVUMUVBUXFPQUDUCZVUPNVUDUXFUVBVUDUXFVUFWPZVUDUVBVU
        QWPYIVUDVVAVUPNOUXFVUPPQZUVBNOUVBUXFVUPUTQZNOVUDVVCUWPUVBVUDUXFVUPVUFVU
        SVRUVSUWSVUCUWQTVUQVUDVVCUXFDPQZDPQZUWPNVUDVVCUXFDDUTQZPQVVFVUDVUPVVGUX
        FPVUDDVUDDVUEWPZYJZYKVUDUXFDDVVBVVHVVHYLYMVUDVVEUUODVUDUXFDVUFVUEVRVUGV
        UEVUDVVEUUONOUYFVUIVUDUXFDUUOVUFVUEVUGYNYOYRYPUVSUWPUVBNOVUCUYRTYSVUDUV
        BUWAVVDVUQUVSUWBVUCUWOTVUDUXFVUPVUFVUSVPUVSUWCVUCVUJTVUDUWAUXFDUTQZDUTQ
        ZVVDNVUDUUOVVJDVUGVUDUXFDVUFVUEVPVUEVUDUXGUUOVVJNOVUDUYGUXGVUHUYOVHVUDU
        UODUXFVUGVUEVUFYNXQYTVUDVVKUXFVVGUTQVVDVUDUXFDDVVBVVHVVHUUAVUDVUPVVGUXF
        UTVVIYKYMUUBYSVUDUVBUXFVUPVUQVUFVUSXAUUGYPVUDYDUIUJOVUPUVFUJOUUCVUDYDUI
        DVURVUDYGVIVUTVUDYHVIUVSUVKVUCAUVKUVRLTTUUDUUEUUFXTYAUVHVUOFMCUXTUUMUXE
        UVGVUNUYAUXTUVEVUMUVFUJUXTUVDVULUDUXTUUNUXFUVBPUYBWIWJWKWLWMUUHUUIXTUUJ
        XG $.
    $}

    $( A Cauchy sequence of real numbers converges to its limit supremum.  The
       third hypothesis specifies that ` F ` is a Cauchy sequence.
       (Contributed by Mario Carneiro, 7-May-2016.) $)
    caurcvgr $p |- ( ph -> F ~~>r ( limsup ` F ) ) $=
      ( cfv wbr cc wcel clt wral cr wrex crp c3 vy clsp crli cv cmin co cabs wi
      cle c1 cmul wa 1rp a1i caucvgrlem simpl rexlimivw syl recnd wss adantr wf
      cdiv cxr csup cpnf wceq simpr 3re 3pos elrpii rpdivcl sylancl reximi sylc
      ssrexv rpcn adantl 3cn cc0 wne divcan2d breq2d rexralbidv mpbid ralrimiva
      3ne0 imbi2d ax-resscn fss eqidd rlim mpbir2and ) AFFUBKZUCLWNMNDUDZEUDZUI
      LZWPFKZWNUEUFUGKZUAUDZOLZUHZECPDQRZUASPAWNAWNQNZWQWSTUJUKUFOLUHECPZULZDCR
      XDABCUJDEFGHIJUJSNAUMUNUOXFXDDCXDXEUPUQURUSAXCUASAWTSNZULZWQWSTWTTVCUFZUK
      UFZOLZUHZECPZDQRZXCXHCQUTZXMDCRZXNAXOXGGVAZXHXDXMULZDCRXPXHBCXIDEFXQACQFV
      BZXGHVAACVDOVEVFVGXGIVAAWQWRWOFKUEUFUGKBUDOLUHECPDCRBSPXGJVAXHXGTSNXISNAX
      GVHTVIVJVKWTTVLVMUOXRXMDCXDXMVHVNURXMDCQVPVOXHXLXBDEQCXHXKXAWQXHXJWTWSOXH
      WTTXGWTMNAWTVQVRTMNXHVSUNTVTWAXHWGUNWBWCWHWDWEWFAUADECWRWNFAXSQMUTCMFVBHW
      ICQMFWJVMGAWPCNULWRWKWLWM $.
  $}

  ${
    $d j k n x A $.  $d j k n x F $.  $d j k n x H $.  $d j k n x ph $.
    caucvgr.1 $e |- ( ph -> A C_ RR ) $.
    caucvgr.2 $e |- ( ph -> F : A --> CC ) $.
    caucvgr.3 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    caucvgr.4 $e |- ( ph -> A. x e. RR+ E. j e. A A. k e. A
      ( j <_ k -> ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ) $.
    ${
      caucvgrlem2.5 $e |- H : CC --> RR $.
      caucvgrlem2.6 $e |- ( ( ( F ` k ) e. CC /\ ( F ` j ) e. CC ) ->
                      ( abs ` ( ( H ` ( F ` k ) ) - ( H ` ( F ` j ) ) ) ) <_
                      ( abs ` ( ( F ` k ) - ( F ` j ) ) ) ) $.
      $( Lemma for ~ caucvgr .  (Contributed by NM, 4-Apr-2005.)  (Proof
         shortened by Mario Carneiro, 8-May-2016.) $)
      caucvgrlem2 $p |- ( ph ->
        ( n e. A |-> ( H ` ( F ` n ) ) ) ~~>r ( ~~>r ` ( H o. F ) ) ) $=
        ( cfv crli cc cr wcel wbr ccom cv cmpt wceq fcompt sylancr cdm clsp fco
        wf cle cmin co cabs clt wi wral wrex wa ad2antrr simprr ffvelrnd simprl
        crp syl2anc ffvelrni resubcld recnd abscld subcld rpre ad2antlr syl3anc
        syl lelttr mpand oveq12d fveq2d breq1d sylibrd imim2d ralimdva reximdva
        fvco3 anassrs mpd caurcvgr rlimrel releldmi wss ax-resscn sylancl mpbid
        fss rlimdm eqbrtrrd ) AHGUAZFCFUBGOHOUCZWQPOZPAQRHUJZCQGUJZWQWRUDMJFHGC
        QRUEUFAWQPUGSZWQWSPTAWQWQUHOZPTXBABCDEWQIAWTXACRWQUJZMJCQRHGUIUFZKADUBZ
        EUBZUKTZXGGOZXFGOZULUMZUNOZBUBZUOTZUPZECUQZDCURZBVDUQXHXGWQOZXFWQOZULUM
        ZUNOZXMUOTZUPZECUQZDCURZBVDUQLAXQYEBVDAXMVDSZUSZXPYDDCYGXFCSZUSXOYCECYG
        YHXGCSZXOYCUPYGYHYIUSZUSZXNYBXHYKXNXIHOZXJHOZULUMZUNOZXMUOTZYBYKYOXLUKT
        ZXNYPYKXIQSZXJQSZYQYKCQXGGAXAYFYJJUTZYGYHYIVAZVBZYKCQXFGYTYGYHYIVCZVBZN
        VEYKYORSXLRSXMRSZYQXNUSYPUPYKYNYKYNYKYLYMYKYRYLRSUUBQRXIHMVFVNYKYSYMRSU
        UDQRXJHMVFVNVGVHVIYKXKYKXIXJUUBUUDVJVIYFUUEAYJXMVKVLYOXLXMVOVMVPYKYAYOX
        MUOYKXTYNUNYKXRYLXSYMULYKXAYIXRYLUDYTUUACQXGHGWDVEYKXAYHXSYMUDYTUUCCQXF
        HGWDVEVQVRVSVTWAWEWBWCWBWFWGWQXCPWHWIVNACWQAXDRQWJCQWQUJXEWKCRQWQWNWLKW
        OWMWP $.
    $}

    $( A Cauchy sequence of complex numbers converges to a complex number.
       Theorem 12-5.3 of [Gleason] p. 180 (sufficiency part).  (Contributed by
       NM, 20-Dec-2006.)  (Revised by Mario Carneiro, 8-May-2016.) $)
    caucvgr $p |- ( ph -> F e. dom ~~>r ) $=
      ( vn cre crli cfv ci cim co wcel cc cabs ccom cmul caddc wbr cmpt feqmptd
      cdm cv ffvelrnda replimd mpteq2dva eqtrd cvv fvex a1i ovex ref cmin resub
      wa cle fveq2d subcl absrele syl eqbrtrrd caucvgrlem2 ax-icn wss rlimconst
      elexi sylancl imf imsub absimle rlimmul rlimadd eqbrtrd rlimrel releldmi
      cr ) AFLFUAMNZOPFUAMNZUBQZUCQZMUDFMUGRAFKCKUHZFNZLNZOWGPNZUBQZUCQZUEZWEMA
      FKCWGUEWLAKCSFHUFAKCWGWKAWFCRUTZWGACSWFFHUIUJUKULAKCWHWJWBWDUMWHUMRWMWGLU
      NUOWJUMRWMOWIUBUPUOABCDEKFLGHIJUQEUHFNZSRDUHFNZSRUTZWNWOURQZLNZTNZWNLNWOL
      NURQZTNWQTNZVAWPWRWTTWNWOUSVBWPWQSRZWSXAVAUDWNWOVCZWQVDVEVFVGAKCOWIOWCUMO
      UMRWMOSVHVKUOWIUMRWMWGPUNUOACWAVIOSRKCOUEOMUDGVHKCOVJVLABCDEKFPGHIJVMWPWQ
      PNZTNZWNPNWOPNURQZTNXAVAWPXDXFTWNWOVNVBWPXBXEXAVAUDXCWQVOVEVFVGVPVQVRFWEM
      VSVTVE $.
  $}

  ${
    $d k m x F $.  $d m x M $.  $d k m x ph $.  $d k m x Z $.
    caurcvg.1 $e |- Z = ( ZZ>= ` M ) $.
    caurcvg.3 $e |- ( ph -> F : Z --> RR ) $.
    caurcvg.4 $e |- ( ph -> A. x e. RR+ E. m e. Z A. k e. ( ZZ>= ` m )
            ( abs ` ( ( F ` k ) - ( F ` m ) ) ) < x ) $.
    $( A Cauchy sequence of real numbers converges to its limit supremum.  The
       fourth hypothesis specifies that ` F ` is a Cauchy sequence.
       (Contributed by NM, 4-Apr-2005.)  (Revised by Mario Carneiro,
       8-May-2016.) $)
    caurcvg $p |- ( ph -> F ~~> ( limsup ` F ) ) $=
      ( cfv wbr cr cz cv wral wrex crp wcel syl clsp crli cli wss uzssz eqsstri
      cuz zssre sstri a1i cmin co cabs clt cxr csup cpnf wceq c0 wne ne0i ax-mp
      c1 1rp r19.2z sylancr eluzel2 eleq2s uzsup rexlimiv rexlimivw wi wa sseli
      a1d wb eluz syl2an biimprd expimpd imim1d exp4a ralimdv2 reximia caurcvgr
      cle ralimi wf cc ax-resscn fss sylancl rlimclim mpbid ) AEEUAKZUBLEWOUCLA
      BGDCEGMUDAGNMGFUGKZNHFUEUFZUHUIUJIACOZEKDOZEKUKULUMKBOUNLZCWSUGKZPZDGQZBR
      QZGUOUNUPUQURZARUSUTZXCBRPZXDVCRSXFVDRVCVAVBJXCBRVEVFZXCXEBRXBXEDGWSGSZXE
      XBXIFNSZXEXJWSWPGFWSVGHVHZFGHVITVOVJVKTAXGWSWRWFLZWTVLZCGPZDGQZBRPJXCXOBR
      XBXNDGXIWTXMCXAGXIWRXASZWTVLWRGSZXLWTXIXQXLVMXPWTXIXQXLXPXIXQVMXPXLXIWSNS
      WRNSXPXLVPXQGNWSWQVNGNWRWQVNWSWRVQVRVSVTWAWBWCWDWGTWEAWOEFGHAXDXJXHXCXJBR
      XBXJDGXIXJXBXKVOVJVKTAGMEWHMWIUDGWIEWHIWJGMWIEWKWLWMWN $.
  $}

  ${
    $d i j k m n x F $.  $d j n H $.  $d i j k m n x M $.  $d i j k m n x ph $.
    $d j k x G $.  $d i j k m n x Z $.
    caucvg.1 $e |- Z = ( ZZ>= ` M ) $.
    ${
      caurcvg2.2 $e |- ( ph -> F e. V ) $.
      caurcvg2.3 $e |- ( ph -> A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
            ( ( F ` k ) e. RR /\ ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ) $.
      $( A Cauchy sequence of real numbers converges, existence version.
         (Contributed by NM, 4-Apr-2005.)  (Revised by Mario Carneiro,
         7-Sep-2014.) $)
      caurcvg2 $p |- ( ph -> F e. dom ~~> ) $=
        ( vn vi vm cfv wcel cmin wa wral crp cv cr co cabs clt wbr cuz wrex cli
        cdm c0 wne c1 1rp ne0i ax-mp r19.2z sylancr simpl ralimi cmpt clsp eqid
        simprr weq fveq2 eleq1d rspccva sylan fmptd oveq2d fveq2d breq1d anbi2d
        raleqbidv cbvrexv oveq1d anbi12d cbvralv anim1i sylbi reximi syl adantr
        cc recn wb cau4 ad2antrl mpbid simpr wceq uztrn2 fvmpt oveq12d ralimdva
        fvex syl5ibr reximia caurcvg cz eluzelz cbvmptv climmpt syl2anc climrel
        eleq2s mpbird releldmi expr syl5 rexlimdva rexlimdvw mpd ) ADUAZEOZUBPZ
        XPCUAZEOZQUCZUDOZBUAZUEUFZRZDXRUGOZSZCHUHZBTUHZEUIUJPZATUKULZYGBTSZYHUM
        TPYJUNTUMUOUPKYGBTUQURAYGYIBTAYFYICHYFXQDYESZAXRHPZRYIYDXQDYEXQYCUSUTAY
        MYLYIAYMYLRZRZELYELUAZEOZVAZVBOZUIUFZYIYOYTYRYSUIUFZYOBMNYRXRYEYEVCZYOL
        YEYQUBYRYOYLYPYEPYQUBPZAYMYLVDXQUUCDYPYEDLVEXPYQUBXOYPEVFVGVHVIYRVCZVJY
        OMUAZEOZWEPZUUFNUAZEOZQUCZUDOZYBUEUFZRZMUUHUGOZSZNYEUHZBTSZUUEYROZUUHYR
        OZQUCZUDOZYBUEUFZMUUNSZNYEUHZBTSYOUUONHUHZBTSZUUQAUVFYNAYKUVFKYGUVEBTYG
        XQXPUUIQUCZUDOZYBUEUFZRZDUUNSZNHUHUVEYFUVKCNHCNVEZYDUVJDYEUUNXRUUHUGVFU
        VLYCUVIXQUVLYAUVHYBUEUVLXTUVGUDUVLXSUUIXPQXRUUHEVFVKVLVMVNVOVPUVKUUONHU
        VKUUFUBPZUULRZMUUNSUUOUVJUVNDMUUNDMVEZXQUVMUVIUULUVOXPUUFUBXOUUEEVFZVGU
        VOUVHUUKYBUEUVOUVGUUJUDUVOXPUUFUUIQUVPVQVLVMVRVSUVNUUMMUUNUVMUUGUULUUFW
        FVTUTWAWBWAUTWCWDYMUVFUUQWGAYLBNMEFXRYEHIUUBWHWIWJUUPUVDBTUUOUVCNYEUUHY
        EPZUUMUVBMUUNUUMUVBUVQUUEUUNPZRZUULUUGUULWKUVSUVAUUKYBUEUVSUUTUUJUDUVSU
        URUUFUUSUUIQUVSUUEYEPUURUUFWLXRUUEUUHYEUUBWMLUUEYQUUFYEYRYPUUEEVFUUDUUE
        EWQWNWCUVQUUSUUIWLUVRLUUHYQUUIYEYRYPUUHEVFUUDUUHEWQWNWDWOVLVMWRWPWSUTWC
        WTYOXRXAPZEGPZYTUUAWGYMUVTAYLUVTXRFUGOHFXRXBIXGWIAUWAYNJWDYSDEYRXRGYEUU
        BLDYEYQXPYPXOEVFXCXDXEXHEYSUIXFXIWCXJXKXLXMXN $.
    $}

    caucvg.2 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    caucvg.3 $e |- ( ph -> A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
                           ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) $.
    caucvg.4 $e |- ( ph -> F e. V ) $.
    $( A Cauchy sequence of complex numbers converges to a complex number.
       Theorem 12-5.3 of [Gleason] p. 180 (sufficiency part).  (Contributed by
       NM, 20-Dec-2006.)  (Proof shortened by Mario Carneiro, 15-Feb-2014.)
       (Revised by Mario Carneiro, 8-May-2016.) $)
    caucvg $p |- ( ph -> F e. dom ~~> ) $=
      ( vn cv cfv crli wbr wcel cz crp cmpt cli cdm fveq2 cbvmptv wss cuz uzssz
      cr eqsstri zssre sstri a1i cc eqcomi fmptd cxr clt csup cpnf wceq cmin co
      cabs wral wrex c0 wne c1 1rp ne0i ax-mp r19.2z sylancr eluzel2 eleq2s a1d
      rexlimiv rexlimivw syl uzsup wi wa wb sseli eluz syl2an biimprd eqid fvex
      fvmpt3i oveqan12rd fveq2d breq1d imim12d ex com23 ralimdv2 reximia ralimi
      cle caucvgr rlimdm mpbid syl5eqbr rlimclim climmpt syl2anc mpbird climrel
      releldmi ) AEMHMNZEOZUAZPOZUBQZEUBUCRAXPDHDNZEOZUAZXOUBQZAXSXOPQXTAXSXNXO
      PDMHXRXMXQXLEUDUEZAXNPUCRXNXOPQABHCDXNHUIUFAHSUIHFUGOZSIFUHUJZUKULUMADHXR
      UNXNJXSXNYAUOUPZAFSRZHUQURUSUTVAAXRCNZEOZVBVCZVDOZBNZURQZDYFUGOZVEZCHVFZB
      TVFZYEATVGVHZYNBTVEZYOVITRYPVJTVIVKVLKYNBTVMVNYNYEBTYMYECHYFHRZYEYMYEYFYB
      HFYFVOIVPVQVRVSVTZFHIWAVTZAYQYFXQXAQZXQXNOZYFXNOZVBVCZVDOZYJURQZWBZDHVEZC
      HVFZBTVEKYNUUIBTYMUUHCHYRYKUUGDYLHYRXQHRZXQYLRZYKWBZUUGYRUUJUULUUGWBYRUUJ
      WCZUUAUUKYKUUFUUMUUKUUAYRYFSRXQSRUUKUUAWDUUJHSYFYCWEHSXQYCWEYFXQWFWGWHUUM
      UUFYKUUMUUEYIYJURUUMUUDYHVDUUJYRUUBXRUUCYGVBMXQXMXRHXNXLXQEUDXNWIZXLEWJZW
      KMYFXMYGHXNXLYFEUDUUNUUOWKWLWMWNWHWOWPWQWRWSWTVTXBAHXNYDYTXCXDXEAXOXSFHIY
      SADHXRUNXSJXSWIZUPXFXDAYEEGRXPXTWDYSLXODEXSFGHIUUPXGXHXIEXOUBXJXKVT $.
  $}

  ${
    $d i j k m n x y F $.  $d j k m n x M $.  $d i j k m n x y Z $.
    $d j k n x ph $.  $d i k m n y V $.
    caucvgb.1 $e |- Z = ( ZZ>= ` M ) $.
    $( A function is convergent if and only if it is Cauchy.  Theorem 12-5.3 of
       [Gleason] p. 180.  (Contributed by Mario Carneiro, 15-Feb-2014.) $)
    caucvgb $p |- ( ( M e. ZZ /\ F e. V ) -> ( F e. dom ~~> <->
              A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( ( F ` k ) e. CC /\
                ( abs ` ( ( F ` k ) - ( F ` j ) ) ) < x ) ) ) $=
      ( vn vm vi wcel wa cv cfv cuz wral wrex clt crp vy cz cc cli cmin co cabs
      cdm wbr cop wex eldm2g ibi df-br c1 simpll eqidd simpr climi simpl ralimi
      1rp a1i reximi syl ex syl5bir exlimdv syl5 wi wb wceq weq raleqdv cbvrexv
      fveq2 rspcv mpsyl eluzelz eqid climcau sylan r19.29uz ralimdv mpan9 an32s
      eleq2s adantll simplrr eleq1d rspccva oveq1d fveq2d breq1d cbvralv adantl
      sylib oveq2d raleqbidv rexralbidv syl5bb caucvg adantlll impbida ad2antrl
      breq2 cau4 bitr4d rexlimdvaa pm5.21ndd ) EUBLZDFLZMZCNZDOZUCLZCINZPOZQZIG
      RZDUDUHZLZXPXOBNZDOZUEUFZUGOZANZSUIZMZCYCPOZQZBGRZATQZYBDJNZUJUDLZJUKZXMX
      TYBYPJDUDYAULUMXMYOXTJYODYNUDUIZXMXTDYNUDUNXMYQXTXMYQMZXPXOYNUEUFUGOUOSUI
      ZMZCXRQZIGRXTYRYNXOUOICDEGHXKXLYQUPUOTLZYRVBVCYRXNGLMXOUQXMYQURUSUUAXSIGY
      TXPCXRXPYSUTVAVDVEVFVGVHVIYMXTVJXMUUBYMXPCYJQZBGRZATQXTVBYLUUDATYKUUCBGYI
      XPCYJXPYHUTVAVDVAUUDXTAUOTUUDXTVKYGUOVLUUCXSBIGBIVMXPCYJXRYCXQPVPVNVOVCVQ
      VRVCXMXSYBYMVKIGXMXQGLZXSMZMZYBYKBXRRZATQZYMUUGYBUUIUUFYBUUIXMUUEYBXSUUIU
      UEYBMYHCYJQZBXRRZATQZXSUUIUUEXQUBLZYBUULUUMXQEPOGEXQVSHWGABCDXQXRXRVTZWAW
      BXSUUKUUHATXSUUKUUHXPYHBCXQXRUUNWCVFWDWEWFWHXLUUFUUIYBXKXLUUFMZUUIMZUAKJD
      XQFXRUUNUUPXSYNXRLYNDOZUCLZXLUUEXSUUIWIXPUURCYNXRCJVMZXOUUQUCXNYNDVPZWJWK
      WBUUPUUQYDUEUFZUGOZYGSUIZJYJQZBXRRZATQZUUQKNZDOZUEUFZUGOZUANZSUIZJUVGPOZQ
      KXRRZUATQUUIUVFUUOUUHUVEATYKUVDBXRYKUUJUVDYIYHCYJXPYHURVAYHUVCCJYJUUSYFUV
      BYGSUUSYEUVAUGUUSXOUUQYDUEUUTWLWMWNWOWQVDVAWPUVEUVNAUATUVEUVJYGSUIZJUVMQZ
      KXRRAUAVMZUVNUVDUVPBKXRBKVMZUVCUVOJYJUVMYCUVGPVPUVRUVBUVJYGSUVRUVAUVIUGUV
      RYDUVHUUQUEYCUVGDVPWRWMWNWSVOUVQUVOUVLKJXRUVMYGUVKUVJSXFWTXAWOWQXLUUFUUIU
      PXBXCXDUUEYMUUIVKXMXSABCDEXQXRGHUUNXGXEXHXIXJ $.

    serf0.2 $e |- ( ph -> M e. ZZ ) $.
    serf0.3 $e |- ( ph -> F e. V ) $.
    serf0.4 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    serf0.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( If an infinite series converges, its underlying sequence converges to
       zero.  (Contributed by NM, 2-Sep-2005.)  (Revised by Mario Carneiro,
       16-Feb-2014.) $)
    serf0 $p |- ( ph -> F ~~> 0 ) $=
      ( vx vm cfv cabs clt wral wcel cmin co vn vj cc0 cli wbr cv cuz crp caddc
      wrex cseq cc wa cdm cz wb caucvgb syl2anc mpbid sylib c1 peano2uzs adantl
      cau3 wi eluzelz uzid peano2uz wceq fveq2 oveq2d fveq2d rspcv 4syl adantld
      breq1d ralimia simpr syl6eleq syl eluzp1m1 sylan oveq12d wf serf ad2antrr
      oveq1 uztrn2 syldan ffvelrnd abssubd zcnd ax-1cn npcan sylancl eqid seqm1
      eluzp1p1 oveq1d adantlr pncan2d eqtr2d 3eqtr4d sylibd syl5 raleqdv rspcev
      ralrimdva ee12an rexlimdva ralimdv mpd eqidd clim0c mpbird ) ACUCUDUEBUFZ
      CNZONZLUFZPUEZBUAUFZUGNZQZUAFUJZLUHQZAMUFZUICDUKZNZULRZYHXPYGNZSTZONZXSPU
      EZBYFUGNZQZUMZMUBUFZUGNZQZUBFUJZLUHQZYEAYIYHYQYGNSTONXSPUEUMMYRQUBFUJLUHQ
      ZUUAAYGUDUNZRZUUBJADUORZUUDUUDUUBUPHJLUBMYGDUUCFGUQURUSLUBMBYGDFGVDUTAYTY
      DLUHAYSYDUBFAYQFRZUMZYQVAUITZFRZYSXTBUUHUGNZQZYDUUFUUIADYQFGVBVCZYSYHYFVA
      UITZYGNZSTZONZXSPUEZMYRQZUUGUUKYPUUQMYRYFYRRZYOUUQYIUUSYFUORYFYNRUUMYNRYO
      UUQVEYQYFVFYFVGYFYFVHYMUUQBUUMYNXPUUMVIZYLUUPXSPUUTYKUUOOUUTYJUUNYHSXPUUM
      YGVJVKVLVPVMVNVOVQUUGUURXTBUUJUUGXPUUJRZUMZUURXPVASTZYGNZUVCVAUITZYGNZSTZ
      ONZXSPUEZXTUVBUVCYRRZUURUVIVEUUGYQUORZUVAUVJUUGYQDUGNZRZUVKUUGYQFUVLAUUFV
      RZGVSZDYQVFVTYQXPWAWBZUUQUVIMUVCYRYFUVCVIZUUPUVHXSPUVQUUOUVGOUVQYHUVDUUNU
      VFSYFUVCYGVJUVQUUMUVEYGYFUVCVAUIWGVLWCVLVPVMVTUVBUVHXRXSPUVBUVDYJSTZONYJU
      VDSTZONUVHXRUVBUVDYJUVBFULUVCYGAFULYGWDUUFUVAABCDFGHKWEWFZUUGUVAUVJUVCFRZ
      UVPUUGUUFUVJUWAUVNDUVCYQFGWHWBWIWJZUVBFULXPYGUVTUUGUUIUVAXPFRZUULDXPUUHFG
      WHWBZWJWKUVBUVGUVROUVBUVFYJUVDSUVBUVEXPYGUVBXPULRVAULRUVEXPVIUVBXPUVAXPUO
      RUUGUUHXPVFVCWLWMXPVAWNWOVLVKVLUVBXQUVSOUVBUVSUVDXQUITZUVDSTXQUVBYJUWEUVD
      SUVBUUEXPDVAUITZUGNZRZYJUWEVIAUUEUUFUVAHWFUUGUUHUWGRZUVAUWHUUGUVMUWIUVODY
      QWRVTUWFXPUUHUWGUWGWPWHWBUICDXPWQURWSUVBUVDXQUWBUUGUVAUWCXQULRZUWDAUWCUWJ
      UUFKWTWIXAXBVLXCVPXDXHXEYCUUKUAUUHFYAUUHVIXTBYBUUJYAUUHUGVJXFXGXIXJXKXLAL
      XQUABCDEFGHIAUWCUMXQXMKXNXO $.
  $}

  ${
    $d j k n x F $.  $d j k n x G $.  $d j k n x M $.  $d j k n x ph $.
    $d k x K $.  $d k n x N $.  $d j k n x Z $.
    iseralt.1 $e |- Z = ( ZZ>= ` M ) $.
    iseralt.2 $e |- ( ph -> M e. ZZ ) $.
    iseralt.3 $e |- ( ph -> G : Z --> RR ) $.
    iseralt.4 $e |- ( ( ph /\ k e. Z ) -> ( G ` ( k + 1 ) ) <_ ( G ` k ) ) $.
    iseralt.5 $e |- ( ph -> G ~~> 0 ) $.
    $( Lemma for ~ iseralt .  A decreasing sequence with limit zero consists of
       positive terms.  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    iseraltlem1 $p |- ( ( ph /\ N e. Z ) -> 0 <_ ( G ` N ) ) $=
      ( wcel wa cfv cz wbr adantr c1 cr co vn cc0 csn cxp eluzelz eleq2s adantl
      cuz cli cc ffvelrnda recnd 1z uzssz zex climconst2 sylancl cv wf ad2antrr
      eqid uztrn2 adantll ffvelrnd wceq fvex fvconst2 syl eqeltrd cle simpr cfz
      simplr elfzuz syl2an caddc simpl adantlr syldan monoord2 breqtrrd climle
      cmin ) AEFLZMZUBECNZUACOWFUCUDZEEUHNZWHVAWDEOLZAWIEDUHNFDEUEGUFUGACUBUIPW
      DKQWEWFUJLROLWGWFUIPWEWFAFSECIUKZULUMWFRORUNUOUPUQWEUAURZWHLZMZFSWKCAFSCU
      SZWDWLIUTZWDWLWKFLADWKEFGVBVCVDWMWKWGNZWFSWMWKOLZWPWFVEWLWQWEEWKUEUGOWFWK
      ECVFVGVHZWEWFSLWLWJQVIWMWKCNWFWPVJWMBCEWKWEWLVKWMBURZEWKVLTLZMFSWSCWMWNWT
      WOQWMWDWSWHLZWSFLZWTAWDWLVMWSEWKVNDWSEFGVBZVOVDWMWEXAWSRVPTCNWSCNVJPZWSEW
      KRWCTZVLTLWEWLVQWSEXEVNWEXAXBXDWDXAXBAXCVCAXBXDWDJVRVSVOVTWRWAWB $.

    iseralt.6 $e |- ( ( ph /\ k e. Z ) ->
      ( F ` k ) = ( ( -u 1 ^ k ) x. ( G ` k ) ) ) $.
    $( Lemma for ~ iseralt .  The terms of an alternating series form a chain
       of inequalities in alternate terms, so that for example
       ` S ( 1 ) <_ S ( 3 ) <_ S ( 5 ) <_ ... ` and
       ` ... <_ S ( 4 ) <_ S ( 2 ) <_ S ( 0 ) ` (assuming ` M = 0 ` so that
       these terms are defined).  (Contributed by Mario Carneiro,
       6-Apr-2015.) $)
    iseraltlem2 $p |- ( ( ph /\ N e. Z /\ K e. NN0 ) ->
      ( ( -u 1 ^ N ) x. ( seq M ( + , F ) ` ( N + ( 2 x. K ) ) ) ) <_
      ( ( -u 1 ^ N ) x. ( seq M ( + , F ) ` N ) ) ) $=
      ( wcel c1 co c2 cmul caddc vx vn cn0 cneg cexp cseq cfv cle wbr wa cv cc0
      wi wceq oveq2 2cn mul01i syl6eq oveq2d fveq2d breq1d imbi2d wss cuz uzssz
      cz eqsstri a1i sselda zcnd addid1d cr wne renegcli ax-1cn ax-1ne0 negne0i
      1re reexpclz mp3an12 ffvelrnda remulcld eqeltrd serfre leidd eqbrtrd cmin
      syl wf ad2antrr 2timesi oveq2i simpr syl6eleq adantr eluzelz nn0cn adantl
      mulcl sylancr mulcli addassd syl5eqr 2nn0 nn0mulcl uzaddcl syl2anc sseldi
      cc adddid 3eqtr4d peano2nn0 syl6eleqr ffvelrnd peano2uz resubcld 0re wral
      ralrimiva oveq1 fveq2 breq12d rspcv sylc seqp1 oveq1d eqtrd recnd oveq12d
      eqeq12d neg1cn expp1zd sylancl 3eqtr3d mulassd 3eqtrrd syl22anc mulid2d
      3eqtrd eqtr4d mpbird leadd2dd reexpclzd mulcom mulneg12 renegcld peano2zd
      suble0d mulm1d mul2neg mulid1d readdcld 2timesd expaddz 2z zaddcl expmulz
      syl2an sqneg ax-mp sq1 eqtri oveq1i syl5eq negcld addcomd negsubd 3brtr3d
      nn0z 1exp letr syl3anc mpand expcom a2d nn0ind com12 3impia ) AGHOZEUCOZP
      UDZGUEQZGRESQZTQZTCFUFZUGZSQZUWBGUWEUGZSQZUHUIZUVTAUVSUJZUWJUWKUWBGRUAUKZ
      SQZTQZUWEUGZSQZUWIUHUIZUMUWKUWBGULTQZUWEUGZSQZUWIUHUIZUMUWKUWBGRUBUKZSQZT
      QZUWEUGZSQZUWIUHUIZUMUWKUWBGRUXBPTQZSQZTQZUWEUGZSQZUWIUHUIZUMUWKUWJUMUAUB
      EUWLULUNZUWQUXAUWKUXNUWPUWTUWIUHUXNUWOUWSUWBSUXNUWNUWRUWEUXNUWMULGTUXNUWM
      RULSQULUWLULRSUORUPUQURUSUTUSVAVBUWLUXBUNZUWQUXGUWKUXOUWPUXFUWIUHUXOUWOUX
      EUWBSUXOUWNUXDUWEUXOUWMUXCGTUWLUXBRSUOUSUTUSVAVBUWLUXHUNZUWQUXMUWKUXPUWPU
      XLUWIUHUXPUWOUXKUWBSUXPUWNUXJUWEUXPUWMUXIGTUWLUXHRSUOUSUTUSVAVBUWLEUNZUWQ
      UWJUWKUXQUWPUWGUWIUHUXQUWOUWFUWBSUXQUWNUWDUWEUXQUWMUWCGTUWLERSUOUSUTUSVAV
      BUWKUWTUWIUWIUHUWKUWSUWHUWBSUWKUWRGUWEUWKGUWKGAHVFGHVFVCAHFVDUGZVFIFVEZVG
      VHZVIZVJVKUTUSUWKUWIUWKUWBUWHUWKGVFOZUWBVLOZUYAUWAVLOZUWAULVMZUYBUYCPVRVN
      ZPVOVPVQZUWAGVSVTWHZAHVLGUWEABCFHIJABUKZHOUJZUYICUGZUWAUYIUEQZUYIDUGZSQZV
      LNUYJUYLUYMUYJUYIVFOZUYLVLOZAHVFUYIUXTVIUYDUYEUYOUYPUYFUYGUWAUYIVSVTWHAHV
      LUYIDKWAWBWCWDZWAWBZWEWFUXBUCOZUWKUXGUXMUWKUYSUXGUXMUMUWKUYSUJZUXLUXFUHUI
      ZUXGUXMUYTUXFUXDPTQZPTQZDUGZVUBDUGZWGQZTQZUXFULTQUXLUXFUHUYTVUFULUXFUYTVU
      DVUEUYTHVLVUCDAHVLDWIUVSUYSKWJZUYTVUCUXJHUYTUXDPPTQZTQZGUXCRPSQZTQZTQZVUC
      UXJUYTVUJUXDVUKTQVUMVUKVUIUXDTPVOWKWLUYTGUXCVUKUYTGUYTGUXROZUYBUWKVUNUYSU
      WKGHUXRAUVSWMIWNWOZFGWPWHZVJZUYTRXIOZUXBXIOZUXCXIOUPUYSVUSUWKUXBWQWRZRUXB
      WSWTZVUKXIOUYTRPUPVOXAVHXBXCUYTUXDPPUYTUXDUYTUXRVFUXDUXSUYTVUNUXCUCOZUXDU
      XROZVUOUYTRUCOZUYSVVBXDUWKUYSWMRUXBXEWTUXCFGXFXGZXHZVJPXIOZUYTVOVHZVVHXBU
      YTUXIVULGTUYTRUXBPVURUYTUPVHZVUTVVHXJUSXKZUYTUXJUXRHUYTVUNUXIUCOZUXJUXROV
      UOUYTVVDUXHUCOZVVKXDUYSVVLUWKUXBXLWRRUXHXEWTUXIFGXFXGIXMZWCZXNZUYTHVLVUBD
      VUHUYTVUBUXRHUYTVVCVUBUXROZVVEFUXDXOWHZIXMZXNZXPULVLOUYTXQVHUYTUWBUXEUWKU
      YCUYSUYHWOZUYTHVLUXDUWEAHVLUWEWIUVSUYSUYQWJZUYTUXDUXRHVVEIXMXNZWBZUYTVUFU
      LUHUIVUDVUEUHUIZUYTVUBHOZUYIPTQZDUGZUYMUHUIZBHXRZVWDVVRAVWIUVSUYSAVWHBHLX
      SWJVWHVWDBVUBHUYIVUBUNZVWGVUDUYMVUEUHVWJVWFVUCDUYIVUBPTXTUTUYIVUBDYAZYBYC
      YDUYTVUDVUEVVOVVSUUHUUAUUBUYTUXLUWBUXEVUBCUGZVUCCUGZTQZTQZSQUXFUWBVWNSQZT
      QVUGUYTUXKVWOUWBSUYTVUCUWEUGZUXEVWLTQZVWMTQZUXKVWOUYTVWQVUBUWEUGZVWMTQZVW
      SUYTVVPVWQVXAUNVVQTCFVUBYEWHUYTVWTVWRVWMTUYTVVCVWTVWRUNVVETCFUXDYEWHYFYGU
      YTVUCUXJUWEVVJUTUYTUXEVWLVWMUYTUXEVWBYHZUYTVWLUYTVWLUWAUXDUEQZVUEUDZSQZVL
      UYTVWLUWAVUBUEQZVUESQZVXCUDZVUESQZVXEUYTVWEUYKUYNUNZBHXRZVWLVXGUNZVVRAVXK
      UVSUYSAVXJBHNXSWJZVXJVXLBVUBHVWJUYKVWLUYNVXGUYIVUBCYAVWJUYLVXFUYMVUESUYIV
      UBUWAUEUOVWKYIYJYCYDUYTVXFVXHVUESUYTVXFVXCUWASQZUWAVXCSQZVXHUYTUWAUXDUWAX
      IOZUYTYKVHZUYEUYTUYGVHZVVFYLUYTVXCXIOZVXPVXNVXOUNUYTVXCUYTUWAUXDUYDUYTUYF
      VHVXRVVFUUCZYHZYKVXCUWAUUDYMUYTVXCVYAUUIYSZYFUYTVXSVUEXIOVXIVXEUNVYAUYTVU
      EVVSYHZVXCVUEUUEXGYSZUYTVXCVXDVXTUYTVUEVVSUUFZWBWCZYHZUYTVWMUYTVWMVXCVUDS
      QZVLUYTVWMUWAVUCUEQZVUDSQZVYHUYTVUCHOVXKVWMVYJUNZVVNVXMVXJVYKBVUCHUYIVUCU
      NZUYKVWMUYNVYJUYIVUCCYAVYLUYLVYIUYMVUDSUYIVUCUWAUEUOUYIVUCDYAYIYJYCYDUYTV
      YIVXCVUDSUYTVYIVXFUWASQVXHUWASQZVXCUYTUWAVUBVXQVXRUYTUXDVVFUUGYLUYTVXFVXH
      UWASVYBYFUYTVYMVXCPSQZVXCUYTVXSVVGVYMVYNUNVYAVOVXCPUUJYMUYTVXCVYAUUKYGYSY
      FYGZUYTVXCVUDVXTVVOWBWCZYHZXBYNUSUYTUWBUXEVWNUYTUWBVVTYHZVXBUYTVWNUYTVWLV
      WMVYFVYPUULYHXJUYTVWPVUFUXFTUYTVWPUWBVWLSQZUWBVWMSQZTQVXDVUDTQZVUFUYTUWBV
      WLVWMVYRVYGVYQXJUYTVYSVXDVYTVUDTUYTVYSUWBVXCSQZVXDSQZPVXDSQVXDUYTVYSUWBVX
      ESQWUCUYTVWLVXEUWBSVYDUSUYTUWBVXCVXDVYRVYAUYTVXDVYEYHZYOYTUYTWUBPVXDSUYTU
      WAGUXDTQZUEQZUWARGUXBTQZSQZUEQZWUBPUYTWUEWUHUWAUEUYTWUHRGSQZUXCTQGGTQZUXC
      TQWUEUYTRGUXBVVIVUQVUTXJUYTWUJWUKUXCTUYTGVUQUUMYFUYTGGUXCVUQVUQVVAXBYPUSU
      YTVXPUYEUYBUXDVFOWUFWUBUNVXQVXRVUPVVFUWAGUXDUUNYQUYTWUIUWARUEQZWUGUEQZPUY
      TVXPUYERVFOZWUGVFOZWUIWUMUNVXQVXRWUNUYTUUOVHUWKUYBUXBVFOWUOUYSUYAUXBUVIGU
      XBUUPUURZUWARWUGUUQYQUYTWUMPWUGUEQZPWULPWUGUEWULPRUEQZPVVGWULWURUNVOPUUSU
      UTUVAUVBUVCUYTWUOWUQPUNWUPWUGUVJWHUVDYGYNZYFUYTVXDWUDYRYSUYTVYTWUBVUDSQZP
      VUDSQVUDUYTVYTUWBVYHSQWUTUYTVWMVYHUWBSVYOUSUYTUWBVXCVUDVYRVYAUYTVUDVVOYHZ
      YOYTUYTWUBPVUDSWUSYFUYTVUDWVAYRYSYIUYTWUAVUDVXDTQVUFUYTVXDVUDUYTVUEVYCUVE
      WVAUVFUYTVUDVUEWVAVYCUVGYGYSUSYPUYTUXFUYTUXFVWCYHVKUVHUYTUXLVLOUXFVLOUWIV
      LOZVUAUXGUJUXMUMUYTUWBUXKVVTUYTHVLUXJUWEVWAVVMXNWBVWCUWKWVBUYSUYRWOUXLUXF
      UWIUVKUVLUVMUVNUVOUVPUVQUVR $.

    $( Lemma for ~ iseralt .  From ~ iseraltlem2 , we have
       ` ( -u 1 ^ n ) x. S ( n + 2 k ) <_ ( -u 1 ^ n ) x. S ( n ) ` and
       ` ( -u 1 ^ n ) x. S ( n + 1 ) <_ ( -u 1 ^ n ) x. S ( n + 2 k + 1 ) ` ,
       and we also have ` ( -u 1 ^ n ) x. S ( n + 1 ) = `
       ` ( -u 1 ^ n ) x. S ( n ) - G ( n + 1 ) ` for each ` n ` by the
       definition of the partial sum ` S ` , so combining the inequalities we
       get ` ( -u 1 ^ n ) x. S ( n ) - G ( n + 1 ) = `
       ` ( -u 1 ^ n ) x. S ( n + 1 ) <_ `
       ` ( -u 1 ^ n ) x. S ( n + 2 k + 1 ) = `
       ` ( -u 1 ^ n ) x. S ( n + 2 k ) - G ( n + 2 k + 1 ) <_ `
       ` ( -u 1 ^ n ) x. S ( n + 2 k ) <_ ( -u 1 ^ n ) x. S ( n ) <_ `
       ` ( -u 1 ^ n ) x. S ( n ) + G ( n + 1 ) ` , so
       ` | ( -u 1 ^ n ) x. S ( n + 2 k + 1 ) - ( -u 1 ^ n ) x. S ( n ) | = `
       ` | S ( n + 2 k + 1 ) - S ( n ) | <_ G ( n + 1 ) ` and
       ` | ( -u 1 ^ n ) x. S ( n + 2 k ) - ( -u 1 ^ n ) x. S ( n ) | = `
       ` | S ( n + 2 k ) - S ( n ) | <_ G ( n + 1 ) ` .  Thus, both even and
       odd partial sums are Cauchy if ` G ` converges to ` 0 ` .  (Contributed
       by Mario Carneiro, 6-Apr-2015.) $)
    iseraltlem3 $p |- ( ( ph /\ N e. Z /\ K e. NN0 ) ->
      ( ( abs ` ( ( seq M ( + , F ) ` ( N + ( 2 x. K ) ) ) -
        ( seq M ( + , F ) ` N ) ) ) <_ ( G ` ( N + 1 ) ) /\
        ( abs ` ( ( seq M ( + , F ) ` ( ( N + ( 2 x. K ) ) + 1 ) ) -
        ( seq M ( + , F ) ` N ) ) ) <_ ( G ` ( N + 1 ) ) ) ) $=
      ( cmul co cfv c1 cle cexp wcel cn0 w3a c2 caddc cseq cmin cabs wbr cr 1re
      cneg renegcli a1i cc0 wne ax-1cn ax-1ne0 negne0i cuz uzssz eqsstri sseldi
      cz simp2 reexpclzd recnd wf cv wa simpr ffvelrnda remulcld eqeltrd serfre
      3ad2ant1 syl6eleq simp3 nn0mulcl sylancr uzaddcl syl2anc syl6eleqr subdid
      2nn0 ffvelrnd fveq2d resubcld absmuld eqtr3d wceq absexpz syl3anc absnegi
      cc abs1 eqtri oveq1i 1exp syl syl5eq eqtrd oveq1d abscld 3eqtrd peano2uzs
      mulid2d 3ad2ant2 seqp1 ralrimiva fveq2 oveq2 oveq12d eqeq12d rspcv oveq2d
      wral sylc expp1zd neg1cn mulcom sylancl mulneg1d negsubd expmulz syl22anc
      mulm1d zcnd expaddz 3eqtr3d mulassd iseraltlem2 3brtr3d nn0zd iseraltlem1
      eqbrtrrd mpbid letrd absdifled mpbir2and 2timesd sqneg sq1 syl6eq syl3an2
      ax-mp nn0cnd add32d lenegd mpbird mulid1d simp1 subge02d eqbrtrd readdcld
      2z negcld addge01d jca ) AGHUAZEUBUAZUCZGUDEOPZUEPZUECFUFZQZGUVEQZUGPZUHQ
      ZGRUEPZDQZSUIUVDRUEPZUVEQZUVGUGPZUHQZUVKSUIUVBRULZGTPZUVFOPZUVQUVGOPZUGPZ
      UHQZUVIUVKSUVBUWAUVQUHQZUVIOPZRUVIOPUVIUVBUVQUVHOPZUHQUWAUWCUVBUWDUVTUHUV
      BUVQUVFUVGUVBUVQUVBUVPGUVPUJUAZUVBRUKUMZUNZUVPUOUPZUVBRUQURUSZUNZUVBHVDGH
      FUTQZVDIFVAVBZAUUTUVAVEZVCZVFZVGZUVBUVFUVBHUJUVDUVEAUUTHUJUVEVHUVAABCFHIJ
      ABVIZHUAZVJZUWQCQZUVPUWQTPZUWQDQZOPZUJNUWSUXAUXBUWSUVPUWQUWEUWSUWFUNUWHUW
      SUWIUNUWSHVDUWQUWLAUWRVKVCVFAHUJUWQDKVLVMVNVOVPZUVBUVDUWKHUVBGUWKUAZUVCUB
      UAZUVDUWKUAZUVBGHUWKUWMIVQZUVBUDUBUAUVAUXFWEAUUTUVAVRZUDEVSVTZUVCFGWAWBZI
      WCZWFZVGZUVBUVGUVBHUJGUVEUXDUWMWFZVGZWDWGUVBUVQUVHUWPUVBUVHUVBUVFUVGUXMUX
      OWHVGZWIWJUVBUWBRUVIOUVBUWBUVPUHQZGTPZRUVBUVPWOUAZUWHGVDUAZUWBUXSWKUVBUVP
      UWGVGZUWJUWNUVPGWLWMUVBUXSRGTPZRUXRRGTUXRRUHQRRUQWNWPWQWRUVBUYAUYCRWKUWNG
      WSWTZXAXBZXCUVBUVIUVBUVIUVBUVHUXQXDVGXGXEUVBUWAUVKSUIUVSUVKUGPZUVRSUIUVRU
      VSUVKUEPZSUIUVBUYFUVQUVMOPZUVRUVBUVSUVKUVBUVQUVGUWOUXOVMZUVBHUJUVJDAUUTHU
      JDVHUVAKVPZUUTAUVJHUAZUVAFGHIXFZXHZWFZWHUVBUVQUVMUWOUVBHUJUVLUVEUXDUVBUVD
      HUAUVLHUAZUXLFUVDHIXFWTZWFZVMZUVBUVQUVFUWOUXMVMZUVBUVQUVJUVEQZOPZUYFUYHSU
      VBVUAUVQUVGUVQUVKOPZUGPZOPUVSUVQVUBOPZUGPUYFUVBUYTVUCUVQOUVBUYTUVGVUBULZU
      EPZVUCUVBUYTUVGUVJCQZUEPZUVGUVPUVJTPZUVKOPZUEPVUFUVBUXEUYTVUHWKUXHUECFGXI
      WTUVBVUGVUJUVGUEUVBUYKUWTUXCWKZBHXQZVUGVUJWKZUYMAUUTVULUVAAVUKBHNXJVPZVUK
      VUMBUVJHUWQUVJWKZUWTVUGUXCVUJUWQUVJCXKVUOUXAVUIUXBUVKOUWQUVJUVPTXLUWQUVJD
      XKXMXNXOXRXPUVBVUJVUEUVGUEUVBVUJUVQULZUVKOPVUEUVBVUIVUPUVKOUVBVUIUVQUVPOP
      ZUVPUVQOPZVUPUVBUVPGUYBUWJUWNXSUVBUVQWOUAUXTVUQVURWKUWPXTUVQUVPYAYBUVBUVQ
      UWPYGXEZXCUVBUVQUVKUWPUVBUVKUYNVGZYCXBXPXEUVBUVGVUBUXPUVBVUBUVBUVQUVKUWOU
      YNVMVGZYDXBXPUVBUVQUVGVUBUWPUXPVVAWDUVBVUDUVKUVSUGUVBUVQUVQOPZUVKOPRUVKOP
      VUDUVKUVBVVBRUVKOUVBUVPGGUEPZTPZUYCVVBRUVBVVDUVPUDTPZGTPZUYCUVBUVPUDGOPZT
      PZVVDVVFUVBVVGVVCUVPTUVBGUVBGUWNYHZUUAXPUVBUXTUWHUDVDUAZUYAVVHVVFWKUYBUWJ
      VVJUVBUUPUNZUWNUVPUDGYEYFWJVVERGTVVERUDTPZRRWOUAZVVEVVLWKUQRUUBUUFUUCWQZW
      RUUDUVBUXTUWHUYAUYAVVDVVBWKUYBUWJUWNUWNUVPGGYIYFUYDYJZXCUVBUVQUVQUVKUWPUW
      PVUTYKUVBUVKVUTXGYJXPXEUVBVUAUYHSUIUYHULZVUAULZSUIUVBVUPUVMOPZVUPUYTOPZVV
      PVVQSUVBVUIUVJUVCUEPZUVEQZOPZVUIUYTOPZVVRVVSSUUTAUYKUVAVWBVWCSUIUYLABCDEF
      UVJHIJKLMNYLUUEUVBVUIVUPVWAUVMOVUSUVBVVTUVLUVEUVBGRUVCVVIVVMUVBUQUNUVBUVC
      UXJUUGUUHZWGXMUVBVUIVUPUYTOVUSXCYMUVBUVQUVMUWPUVBUVMUYQVGZYCUVBUVQUYTUWPU
      VBUYTUVBHUJUVJUVEUXDUYMWFZVGYCYMUVBVUAUYHUVBUVQUYTUWOVWFVMUYRUUIUUJYPZUVB
      UYHUVRUVLDQZUGPZUVRSUVBUYHUVQUVFUVQVWHOPZUGPZOPUVRUVQVWJOPZUGPVWIUVBUVMVW
      KUVQOUVBUVMUVFUVLCQZUEPZUVFVWJULZUEPVWKUVBUXGUVMVWNWKUXKUECFUVDXIWTUVBVWM
      VWOUVFUEUVBVWMUVPUVLTPZVWHOPZVUPVWHOPVWOUVBUYOVULVWMVWQWKZUYPVUNVUKVWRBUV
      LHUWQUVLWKZUWTVWMUXCVWQUWQUVLCXKVWSUXAVWPUXBVWHOUWQUVLUVPTXLUWQUVLDXKXMXN
      XOXRUVBVWPVUPVWHOUVBUVPVVTTPZVUPROPZVWPVUPUVBVWTVUIUVPUVCTPZOPZVXAUVBUXTU
      WHUVJVDUAUVCVDUAVWTVXCWKUYBUWJUVBHVDUVJUWLUYMVCUVBUVCUXJYNUVPUVJUVCYIYFUV
      BVUIVUPVXBROVUSUVBVXBVVEETPZRUVBUXTUWHVVJEVDUAZVXBVXDWKUYBUWJVVKUVBEUXIYN
      ZUVPUDEYEYFUVBVXDRETPZRVVERETVVNWRUVBVXEVXGRWKVXFEWSWTXAXBXMXBUVBVVTUVLUV
      PTVWDXPUVBVUPUVBUVQUWPUUQUUKYJXCUVBUVQVWHUWPUVBVWHUVBHUJUVLDUYJUYPWFZVGZY
      CXEXPUVBUVFVWJUXNUVBVWJUVBUVQVWHUWOVXHVMVGZYDXEXPUVBUVQUVFVWJUWPUXNVXJWDU
      VBVWLVWHUVRUGUVBVVBVWHOPRVWHOPVWLVWHUVBVVBRVWHOVVOXCUVBUVQUVQVWHUWPUWPVXI
      YKUVBVWHVXIXGYJXPXEUVBUOVWHSUIZVWIUVRSUIUVBAUYOVXKAUUTUVAUULZUYPABDFUVLHI
      JKLMYOWBUVBUVRVWHUYSVXHUUMYQUUNZYRUVBUVRUVSUYGUYSUYIUVBUVSUVKUYIUYNUUOZAB
      CDEFGHIJKLMNYLUVBUOUVKSUIZUVSUYGSUIUVBAUYKVXOVXLUYMABDFUVJHIJKLMYOWBUVBUV
      SUVKUYIUYNUURYQYRZUVBUVRUVSUVKUYSUYIUYNYSYTYPUVBUYHUVSUGPZUHQZUVOUVKSUVBV
      XRUWBUVOOPZRUVOOPUVOUVBUVQUVNOPZUHQVXRVXSUVBVXTVXQUHUVBUVQUVMUVGUWPVWEUXP
      WDWGUVBUVQUVNUWPUVBUVNUVBUVMUVGUYQUXOWHVGZWIWJUVBUWBRUVOOUYEXCUVBUVOUVBUV
      OUVBUVNVYAXDVGXGXEUVBVXRUVKSUIUYFUYHSUIUYHUYGSUIVWGUVBUYHUVRUYGUYRUYSVXNV
      XMVXPYRUVBUYHUVSUVKUYRUYIUYNYSYTYPUUS $.

    $( The alternating series test.  If ` G ( k ) ` is a decreasing sequence
       that converges to ` 0 ` , then ` sum_ k e. Z ( -u 1 ^ k ) x. G ( k ) `
       is a convergent series.  (Note that the first term is positive if ` M `
       is even, and negative if ` M ` is odd.  If the parity of your series
       does not match up with this, you will need to post-compose the series
       with multiplication by ` -u 1 ` using ~ isermulc2 .)  (Contributed by
       Mario Carneiro, 7-Apr-2015.) $)
    iseralt $p |- ( ph -> seq M ( + , F ) e. dom ~~> ) $=
      ( wcel cfv wbr cr cmin co c1 c2 vx vj vn caddc cseq cvv seqex a1i cv cabs
      clt cuz wral wrex crp cc0 cli climrel brrelexi syl eqidd ffvelrnda clim0c
      wa recnd mpbid wi cz simpr syl6eleq eluzelz uzid 3syl peano2uz wceq fveq2
      fveq2d breq1d rspcv cle cdiv cmul ad2antll zcnd eleq2s ad2antrl subcld cc
      2cn wne 2ne0 divcan2d oveq2d pncan3d eqtr2d adantr oveq1d simpll ad2antlr
      cn0 simpl zsubcld zred eluzle subge0d mpbird 2re divge0 syl22anc sylanbrc
      2pos elnn0z w3a iseraltlem3 simpld syl3anc eqbrtrd dividi oveq2i peano2cn
      divsubdird df-2 ax-1cn pnpcan2d syl5eq eqtr3d syl5eqr subcl sub32d 3eqtrd
      sylancl eqtrd npcan cn uznn0sub wf ffvelrn syl2an adantlr eqeltrd nn0p1nn
      nnrpd rphalfcld rpgt0d elnnz simprd wo zeo mpjaodan peano2uzs iseraltlem1
      nnm1nn0 sylan2 absidd breqtrrd cneg 1re renegcli ax-1ne0 adantl reexpclzd
      cexp negne0i remulcld serfre uztrn2 resubcld abscld lelttr jctild anassrs
      rpre mpand ralrimdva syld reximdva ralimdva mpd caurcvg2 ) AUAUBUCUDCEUEZ
      EUFFGUVTUFMAUDCEUGUHAUCUIZDNZUJNZUAUIZUKOZUCUBUIZULNZUMZUBFUNZUAUOUMZUWAU
      VTNZPMZUWKUWFUVTNZQRZUJNZUWDUKOZVDZUCUWGUMZUBFUNZUAUOUMADUPUQOZUWJKAUAUWB
      UBUCDEUFFGHAUWTDUFMKDUPUQURUSUTAUWAFMZVDZUWBVAUXBUWBAFPUWADIVBVEVCVFAUWIU
      WSUAUOAUWDUOMZVDZUWHUWRUBFUXDUWFFMZVDZUWHUWFSUDRZDNZUJNZUWDUKOZUWRUXFUWFU
      WGMZUXGUWGMUWHUXJVGUXFUWFEULNZMUWFVHMZUXKUXFUWFFUXLUXDUXEVIGVJEUWFVKZUWFV
      LVMUWFUWFVNUWEUXJUCUXGUWGUWAUXGVOZUWCUXIUWDUKUXOUWBUXHUJUWAUXGDVPVQVRVSVM
      UXFUXJUWQUCUWGUXDUXEUWAUWGMZUXJUWQVGUXDUXEUXPVDZVDZUXJUWPUWLUXRUWOUXIVTOZ
      UXJUWPAUXQUXSUXCAUXQVDZUWOUXHUXIVTUXTUWAUWFQRZTWARZVHMZUWOUXHVTOUYASUDRZT
      WARZVHMZUXTUYCVDZUWOUWFTUYBWBRZUDRZUVTNZUWMQRZUJNZUXHVTUYGUWNUYKUJUYGUWKU
      YJUWMQUYGUWAUYIUVTUXTUWAUYIVOUYCUXTUYIUWFUYAUDRUWAUXTUYHUYAUWFUDUXTUYATUX
      TUWAUWFUXTUWAUXPUWAVHMAUXEUWFUWAVKWCZWDZUXTUWFUXEUXMAUXPUXMUWFUXLFUXNGWEW
      FZWDZWGZTWHMUXTWIUHZTUPWJUXTWKUHZWLWMUXTUWFUWAUYPUYNWNWOWPVQWQVQUYGAUXEUY
      BWTMZUYLUXHVTOZAUXQUYCWRUXQUXEAUYCUXEUXPXAZWSUYGUYCUPUYBVTOZUYTUXTUYCVIUX
      TVUCUYCUXTUYAPMUPUYAVTOZTPMZUPTUKOZVUCUXTUYAUXTUWAUWFUYMUYOXBZXCUXTVUDUWF
      UWAVTOZUXPVUHAUXEUWFUWAXDWCUXTUWAUWFUXTUWAUYMXCUXTUWFUYOXCXEXFVUEUXTXGUHV
      UFUXTXKUHUYATXHXIWPUYBXLXJAUXEUYTXMVUAUYISUDRUVTNUWMQRUJNUXHVTOABCDUYBEUW
      FFGHIJKLXNXOXPXQUXTUYFVDZUWOUWFTUYESQRZWBRZUDRZSUDRZUVTNZUWMQRZUJNZUXHVTV
      UIUWNVUOUJVUIUWKVUNUWMQVUIUWAVUMUVTUXTUWAVUMVOUYFUXTVUMUWASQRZSUDRZUWAUXT
      VULVUQSUDUXTVULUWFVUQUWFQRZUDRVUQUXTVUKVUSUWFUDUXTVUKTUYASQRZTWARZWBRVUTV
      USUXTVUJVVATWBUXTVUJUYETTWARZQRZVVAVVBSUYEQTWIWKXRXSUXTUYDTQRZTWARVVCVVAU
      XTUYDTTUXTUYAWHMZUYDWHMUYQUYAXTUTUYRUYRUYSYAUXTVVDVUTTWAUXTVVDUYDSSUDRZQR
      VUTTVVFUYDQYBXSUXTUYASSUYQSWHMZUXTYCUHZVVHYDYEWQYFYGWMUXTVUTTUXTVVEVVGVUT
      WHMUYQYCUYASYHYKUYRUYSWLUXTUWAUWFSUYNUYPVVHYIYJWMUXTUWFVUQUYPUXTUWAWHMZVV
      GVUQWHMUYNYCUWASYHYKWNYLWQUXTVVIVVGVURUWAVOUYNYCUWASYMYKWOWPVQWQVQVUIAUXE
      VUJWTMZVUPUXHVTOZAUXQUYFWRUXQUXEAUYFVUBWSVUIUYEYNMZVVJVUIUYFUPUYEUKOZVVLU
      XTUYFVIUXTVVMUYFUXTUYEUXTUYDUXTUYDUXTUYAWTMZUYDYNMUXPVVNAUXEUWFUWAYOWCUYA
      UUAUTUUBUUCUUDWPUYEUUEXJUYEUULUTAUXEVVJXMVULUVTNUWMQRUJNUXHVTOVVKABCDVUJE
      UWFFGHIJKLXNUUFXPXQUXTUYAVHMUYCUYFUUGVUGUYAUUHUTUUIUXTUXHAFPDYPUXGFMZUXHP
      MUXQIUXEVVOUXPEUWFFGUUJWPZFPUXGDYQYRZUXQAVVOUPUXHVTOVVPABDEUXGFGHIJKUUKUU
      MUUNZUUOYSUXRUWOPMZUXIPMZUWDPMZUXSUXJVDUWPVGAUXQVVSUXCUXTUWNUXTUWNUXTUWKU
      WMAFPUVTYPZUXAUWLUXQABCEFGHABUIZFMZVDZVWCCNSUUPZVWCUVBRZVWCDNZWBRPLVWEVWG
      VWHVWEVWFVWCVWFPMVWESUUQUURUHVWFUPWJVWESYCUUSUVCUHVWDVWCVHMZAVWIVWCUXLFEV
      WCVKGWEUUTUVAAFPVWCDIVBUVDYTUVEZEUWAUWFFGUVFZFPUWAUVTYQZYRAVWBUXEUWMPMUXQ
      VWJVUBFPUWFUVTYQYRUVGVEUVHYSAUXQVVTUXCUXTUXIUXHPVVRVVQYTYSUXCVWAAUXQUWDUV
      LWSUWOUXIUWDUVIXPUVMUXDVWBUXAUWLUXQAVWBUXCVWJWPVWKVWLYRUVJUVKUVNUVOUVPUVQ
      UVRUVS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Finite and infinite sums
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c sum_ $. $( Summation sign. $)

  $( Extend class notation to include finite summations.  (An underscore was
     added to the ASCII token in order to facilitate set.mm text searches,
     since "sum" is a commonly used word in comments.) $)
  csu $a class sum_ k e. A B $.

  ${
    $d k f m n x $.  $d A f m n x $.  $d B f m n x $.
    $( Define the sum of a series with an index set of integers ` A ` . ` k `
       is normally a free variable in ` B ` , i.e. ` B ` can be thought of as
       ` B ( k ) ` .  This definition is the result of a collection of
       discussions over the most general definition for a sum that does not
       need the index set to have a specified ordering.  This definition is in
       two parts, one for finite sums and one for subsets of the upper
       integers.  When summing over a subset of the upper integers, we extend
       the index set to the upper integers by adding zero outside the domain,
       and then sum the set in order, setting the result to the limit of the
       partial sums, if it exists.  This means that conditionally convergent
       sums can be evaluated meaningfully.  For finite sums, we are explicitly
       order-independent, by picking any bijection to a 1-based finite sequence
       and summing in the induced order.  These two methods of summation
       produce the same result on their common region of definition (i.e.
       finite subsets of the upper integers) by ~ summo .  Examples:
       ` sum_ k e. { 1 , 2 , 4 } ` ` k ` means ` 1 + 2 + 4 = 7 ` , and
       ` sum_ k e. NN ` ` ( 1 / ( 2 ^ k ) ) = 1 ` means 1/2 + 1/4 + 1/8 + ... =
       1 ( ~ geoihalfsum ).  (Contributed by NM, 11-Dec-2005.)  (Revised by
       Mario Carneiro, 13-Jul-2013.) $)
    df-sum $a |- sum_ k e. A B = ( iota x ( E. m e. ZZ ( A C_ ( ZZ>= ` m ) /\
      seq m ( + , ( k e. ZZ |-> if ( k e. A , B , 0 ) ) ) ~~> x ) \/
      E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> A /\
       x = ( seq 1 ( + , ( n e. NN |-> [_ ( f ` n ) / k ]_ B ) ) ` m ) ) ) ) $.

    $( A sum is a set.  (Contributed by NM, 11-Dec-2005.)  (Revised by Mario
       Carneiro, 13-Jul-2013.) $)
    sumex $p |- sum_ k e. A B e. _V $=
      ( vm vx vf vn csu cv cuz cfv wss caddc cz cmpt cseq wa wrex c1 cn cc0 cif
      wcel cli wbr cfz co wf1o csb wceq wex wo cio cvv df-sum iotaex eqeltri )
      ABCHADIZJKLMCNCIAUCBUAUBOURPEIZUDUEQDNRSURUFUGAFIZUHUSURMGTCGIUTKBUIOSPKU
      JQFUKDTRULZEUMUNEABFCDGUOVAEUPUQ $.

    $d C f m n x $.
    ${
      sumeq1f.1 $e |- F/_ k A $.
      sumeq1f.2 $e |- F/_ k B $.
      $( Equality theorem for a sum.  (Contributed by NM, 11-Dec-2005.)
         (Revised by Mario Carneiro, 13-Jul-2013.) $)
      sumeq1f $p |- ( A = B -> sum_ k e. A C = sum_ k e. B C ) $=
        ( vm vx vf vn cv cfv caddc cz wcel cc0 cmpt wa wrex cn wceq cuz wss cif
        cseq cli wbr c1 cfz co wf1o csb wex wo cio csu sseq1 simpl eleq2d ifbid
        nfeq seqeq3d breq1d anbi12d rexbidv f1oeq3 anbi1d exbidv orbi12d df-sum
        mpteq2da iotabidv 3eqtr4g ) ABUAZAGKZUBLZUCZMDNDKZAOZCPUDZQZVOUEZHKZUFU
        GZRZGNSZUHVOUIUJZAIKZUKZWCVOMJTDJKWHLCULQUHUELUAZRZIUMZGTSZUNZHUOBVPUCZ
        MDNVRBOZCPUDZQZVOUEZWCUFUGZRZGNSZWGBWHUKZWJRZIUMZGTSZUNZHUOACDUPBCDUPVN
        WNXGHVNWFXBWMXFVNWEXAGNVNVQWOWDWTABVPUQVNWBWSWCUFVNWAWRMVOVNDNVTWQDABEF
        VAVNVRNOZRZVSWPCPXIABVRVNXHURUSUTVKVBVCVDVEVNWLXEGTVNWKXDIVNWIXCWJABWGW
        HVFVGVHVEVIVLHACIDGJVJHBCIDGJVJVM $.
    $}
  $}

  ${
    $d A k x $.  $d B k x $.  $d C x $.
    $( Equality theorem for a sum.  (Contributed by NM, 11-Dec-2005.)  (Revised
       by Mario Carneiro, 13-Jul-2013.) $)
    sumeq1 $p |- ( A = B -> sum_ k e. A C = sum_ k e. B C ) $=
      ( nfcv sumeq1f ) ABCDDAEDBEF $.
  $}

  ${
    $d f k m n x y A $.  $d f m n x y B $.
    nfsum1.1 $e |- F/_ k A $.
    $( Bound-variable hypothesis builder for sum.  (Contributed by NM,
       11-Dec-2005.)  (Revised by Mario Carneiro, 13-Jul-2013.) $)
    nfsum1 $p |- F/_ k sum_ k e. A B $=
      ( vm vy vf vn cv cfv caddc cz cmpt cseq cli wa wrex c1 cn nfcv csu cuz co
      wss wcel cc0 cif wbr cfz wf1o csb wceq wex wo cio df-sum nfss nfmpt1 nfbr
      nfseq nfan nfrex nff1o nfcsb1v nfmpt nffv nfeq2 nfex nfor nfiota nfcxfr )
      CABCUAAEIZUBJZUDZKCLCIAUEBUFUGZMZVLNZFIZOUHZPZELQZRVLUIUCZAGIZUJZVRVLKHSC
      HIWCJZBUKZMZRNZJZULZPZGUMZESQZUNZFUOFABGCEHUPWNCFWAWMCVTCELCLTVNVSCCAVMDC
      VMTUQCVQVROCKVPVLCVLTZCKTZCLVOURUTCOTCVRTUSVAVBWLCESCSTZWKCGWDWJCCWBAWCCW
      CTCWBTDVCCVRWICVLWHCKWGRCRTWPCHSWFWQCWEBVDVEUTWOVFVGVAVHVBVIVJVK $.
  $}

  ${
    $d f k m n x y z $.  $d f m n y z A $.  $d f m n y z B $.
    nfsum.1 $e |- F/_ x A $.
    nfsum.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for sum: if ` x ` is (effectively) not
       free in ` A ` and ` B ` , it is not free in ` sum_ k e. A B ` .
       (Contributed by NM, 11-Dec-2005.)  (Revised by Mario Carneiro,
       13-Jul-2013.) $)
    nfsum $p |- F/_ x sum_ k e. A B $=
      ( vm vz vf vn cv cfv caddc cz cc0 cmpt cli c1 cn nfcv csu cuz wss cif wbr
      wcel cseq wa wrex cfz co wf1o csb wceq wex wo cio df-sum nfss nfcri nfmpt
      nfif nfseq nfbr nfan nfrex nff1o nfcsb nffv nfeq2 nfex nfor nfiota nfcxfr
      ) ABCDUABGKZUBLZUCZMDNDKBUFZCOUDZPZVOUGZHKZQUEZUHZGNUIZRVOUJUKZBIKZULZWBV
      OMJSDJKWGLZCUMZPZRUGZLZUNZUHZIUOZGSUIZUPZHUQHBCIDGJURWRAHWEWQAWDAGNANTZVQ
      WCAABVPEAVPTUSAWAWBQAMVTVOAVOTZAMTZADNVSWSVRACOADBEUTFAOTVBVAVCAQTAWBTVDV
      EVFWPAGSASTZWOAIWHWNAAWFBWGAWGTAWFTEVGAWBWMAVOWLAMWKRARTXAAJSWJXBADWICAWI
      TFVHVAVCWTVIVJVEVKVFVLVMVN $.
  $}

  ${
    $d f k m n x A $.  $d f m n x B $.  $d f m n x C $.
    $( Equality theorem for sum, when the class expressions ` B ` and ` C ` are
       equal everywhere.  Proved using only Extensionality.  (Contributed by
       Mario Carneiro, 24-Jun-2014.)  (Revised by Mario Carneiro,
       23-Aug-2014.) $)
    sumeq2w $p |- ( A. k B = C -> sum_ k e. A B = sum_ k e. A C ) $=
      ( vm vx vf vn wceq cv cfv caddc cz cc0 cmpt cseq wa wrex c1 cn wal cuz co
      wss wcel cif cli wbr cfz wf1o csb wex cio csu wral eqid ifeq1 alimi alral
      wo syl mpteq12 sylancr seqeq3d breq1d anbi2d rexbidv wi fvex nfcv nfcsb1v
      nfeq csbeq1a eqeq12d spcgf mpteq2dv fveq1d eqeq2d exbidv orbi12d iotabidv
      cvv ax-mp df-sum 3eqtr4g ) BCIZDUAZAEJZUBKUDZLDMDJZAUEZBNUFZOZWHPZFJZUGUH
      ZQZEMRZSWHUIUCAGJZUJZWOWHLHTDHJZWSKZBUKZOZSPZKZIZQZGULZETRZUTZFUMWILDMWKC
      NUFZOZWHPZWOUGUHZQZEMRZWTWOWHLHTDXBCUKZOZSPZKZIZQZGULZETRZUTZFUMABDUNACDU
      NWGXKYFFWGWRXQXJYEWGWQXPEMWGWPXOWIWGWNXNWOUGWGWMXMLWHWGMMIWLXLIZDMUOZWMXM
      IMUPWGYGDUAYHWFYGDWKBCNUQURYGDMUSVADMWLMXLVBVCVDVEVFVGWGXIYDETWGXHYCGWGXG
      YBWTWGXFYAWOWGWHXEXTWGXDXSLSWGHTXCXRXBWBUEWGXCXRIZVHXAWSVIWFYIDXBWBDXBVJD
      XCXRDXBBVKDXBCVKVLWJXBIBXCCXRDXBBVMDXBCVMVNVOWCVPVDVQVRVFVSVGVTWAFABGDEHW
      DFACGDEHWDWE $.
  $}

  ${
    $d f k m n x A $.  $d f m n x B $.  $d f m n x C $.
    $( Equality theorem for sum, with the class expressions ` B ` and ` C `
       guarded by ` _I ` to be always sets.  (Contributed by Mario Carneiro,
       29-Mar-2014.) $)
    sumeq2ii $p |- ( A. k e. A ( _I ` B ) = ( _I ` C ) ->
                   sum_ k e. A B = sum_ k e. A C ) $=
      ( vm vx vf vn cid cfv wceq cv caddc cz wcel cmpt wa cn csb eqid wral cseq
      cuz wss cc0 cif cli wbr wrex c1 cfz co wf1o wex wo cio csu simpr nfra1 wi
      adantr ifeq1 syl6 wn iffalse eqtr4d pm2.61d1 fvif 3eqtr4g mpteq2da fveq1d
      rsp fvmptex adantlr seqfeq breq1d anbi2d rexbidva simplr nnuz syl6eleq wf
      f1of ad2antlr ffvelrn sylancom simplll nfcsb1v nfeq csbeq1a rspc sylc cvv
      eqeq12d fvex csbfv2g ax-mp 3eqtr3g elfznn adantl fveq2 csbeq1d fvmpti syl
      3eqtr4d seqfveq eqeq2d pm5.32da exbidv orbi12d iotabidv df-sum ) BIJZCIJZ
      KZDAUAZAELZUCJZUDZMDNDLZAOZBUEUFZPZXQUBZFLZUGUHZQZENUIZUJXQUKULZAGLZUMZYE
      XQMHRDHLZYJJZBSZPZUJUBJZKZQZGUNZERUIZUOZFUPXSMDNYACUEUFZPZXQUBZYEUGUHZQZE
      NUIZYKYEXQMHRDYMCSZPZUJUBJZKZQZGUNZERUIZUOZFUPABDUQACDUQXPUUAUUOFXPYHUUGY
      TUUNXPYGUUFENXPXQNOZQZYFUUEXSUUQYDUUDYEUGUUQMFYCUUCXQXPUUPURXPYEXROZYEYCJ
      ZYEUUCJZKUUPXPUURQZYEDNYBIJZPZJYEDNUUBIJZPZJUUSUUTUVAYEUVCUVEXPUVCUVEKUUR
      XPDNUVBUVDXODAUSXPXTNOZQZYAXMUEIJZUFZYAXNUVHUFZUVBUVDUVGYAUVIUVJKZUVGYAXO
      UVKXPYAXOUTUVFXODAVLVAYAXMXNUVHVBVCYAVDUVIUVHUVJYAXMUVHVEYAXNUVHVEVFVGYAB
      UEIVHYACUEIVHVIVJVAVKDNYBYEYCUVCYCTUVCTVMDNUUBYEUUCUVEUUCTUVETVMVIVNVOVPV
      QVRXPYSUUMERXPXQROZQZYRUULGUVMYKYQUUKUVMYKQZYPUUJYEUVNMFYOUUIUJXQUVNXQRUJ
      UCJXPUVLYKVSVTWAUVNYEYIOZQZDYEYJJZBSZIJZDUVQCSZIJZYEYOJZYEUUIJZUVPDUVQXMS
      ZDUVQXNSZUVSUWAUVPUVQAOZXPUWDUWEKZUVNUVOYIAYJWBZUWFYKUWHUVMUVOYIAYJWCWDYI
      AYEYJWEWFXPUVLYKUVOWGXOUWGDUVQADUWDUWEDUVQXMWHDUVQXNWHWIXTUVQKXMUWDXNUWED
      UVQXMWJDUVQXNWJWNWKWLUVQWMOZUWDUVSKYEYJWOZDUVQBWMIWPWQUWIUWEUWAKUWJDUVQCW
      MIWPWQWRUVPYEROZUWBUVSKUVOUWKUVNYEXQWSWTZHYEYNUVRRYOYLYEKZDYMUVQBYLYEYJXA
      ZXBYOTXCXDUVPUWKUWCUWAKUWLHYEUUHUVTRUUIUWMDYMUVQCUWNXBUUITXCXDXEXFXGXHXIV
      RXJXKFABGDEHXLFACGDEHXLVI $.
  $}

  ${
    $d f k m n x A $.  $d f m n x B $.  $d f m n x C $.
    $( Equality theorem for sum.  (Contributed by NM, 11-Dec-2005.)  (Revised
       by Mario Carneiro, 13-Jul-2013.) $)
    sumeq2 $p |- ( A. k e. A B = C -> sum_ k e. A B = sum_ k e. A C ) $=
      ( wceq wral cid cfv csu fveq2 ralimi sumeq2ii syl ) BCEZDAFBGHCGHEZDAFABD
      IACDIENODABCGJKABCDLM $.
  $}

  ${
    $d f j k m n x $.  $d f m n x A $.  $d f m n x B $.  $d f m n x C $.
    cbvsum.1 $e |- ( j = k -> B = C ) $.
    ${
      cbvsum.2 $e |- F/_ k A $.
      cbvsum.3 $e |- F/_ j A $.
      cbvsum.4 $e |- F/_ k B $.
      cbvsum.5 $e |- F/_ j C $.
      $( Change bound variable in a sum.  (Contributed by NM, 11-Dec-2005.)
         (Revised by Mario Carneiro, 23-Aug-2014.) $)
      cbvsum $p |- sum_ j e. A B = sum_ k e. A C $=
        ( vm vx vf vn cv caddc cz cc0 cn wtru cuz cfv wss wcel cif cmpt cli wbr
        cseq wa wrex c1 cfz co wf1o csb wceq wex cio csu nfcri nfcv eleq1 eqidd
        nfif ifbieq12d cbvmpt a1i seqeq3d breq1d anbi2d rexbidv cbvcsb mpteq2dv
        wo fveq1d eqeq2d exbidv orbi12d iotabidv trud df-sum 3eqtr4i ) AKOZUAUB
        UCZPDQDOZAUDZBRUEZUFZWDUIZLOZUGUHZUJZKQUKZULWDUMUNAMOZUOZWKWDPNSDNOWOUB
        ZBUPZUFZULUIZUBZUQZUJZMURZKSUKZVOZLUSZWEPEQEOZAUDZCRUEZUFZWDUIZWKUGUHZU
        JZKQUKZWPWKWDPNSEWQCUPZUFZULUIZUBZUQZUJZMURZKSUKZVOZLUSZABDUTACEUTXGYEU
        QTXFYDLTWNXOXEYCTWMXNKQTWLXMWETWJXLWKUGTWIXKPWDWIXKUQTDEQWHXJWGEBREDAGV
        AIERVBVEXIDCRDEAHVAJDRVBVEWFXHUQZWGXIBRCRWFXHAVCFYFRVDVFVGVHVIVJVKVLTXD
        YBKSTXCYAMTXBXTWPTXAXSWKTWDWTXRTWSXQPULTNSWRXPWRXPUQTDEWQBCIJFVMVHVNVIV
        PVQVKVRVLVSVTWALABMDKNWBLACMEKNWBWC $.
    $}

    $d A j k $.  $d B k $.  $d C j $.
    $( Change bound variable in a sum.  (Contributed by NM, 11-Dec-2005.)
       (Revised by Mario Carneiro, 13-Jul-2013.) $)
    cbvsumv $p |- sum_ j e. A B = sum_ k e. A C $=
      ( nfcv cbvsum ) ABCDEFEAGDAGEBGDCGH $.
  $}

  ${
    $d j k x A $.  $d x B $.  $d x C $.
    cbvsumi.1 $e |- F/_ k B $.
    cbvsumi.2 $e |- F/_ j C $.
    cbvsumi.3 $e |- ( j = k -> B = C ) $.
    $( Change bound variable in a sum.  (Contributed by NM, 11-Dec-2005.) $)
    cbvsumi $p |- sum_ j e. A B = sum_ k e. A C $=
      ( nfcv cbvsum ) ABCDEHEAIDAIFGJ $.
  $}

  ${
    $d k A $.  $d k B $.
    sumeq1i.1 $e |- A = B $.
    $( Equality inference for sum.  (Contributed by NM, 2-Jan-2006.) $)
    sumeq1i $p |- sum_ k e. A C = sum_ k e. B C $=
      ( wceq csu sumeq1 ax-mp ) ABFACDGBCDGFEABCDHI $.
  $}

  ${
    $d k A $.
    sumeq2i.1 $e |- ( k e. A -> B = C ) $.
    $( Equality inference for sum.  (Contributed by NM, 3-Dec-2005.) $)
    sumeq2i $p |- sum_ k e. A B = sum_ k e. A C $=
      ( wceq csu sumeq2 mprg ) BCFABDGACDGFDAABCDHEI $.
  $}

  ${
    $d k A $.  $d k B $.
    sumeq12i.1 $e |- A = B $.
    sumeq12i.2 $e |- ( k e. A -> C = D ) $.
    $( Equality inference for sum.  (Contributed by FL, 10-Dec-2006.) $)
    sumeq12i $p |- sum_ k e. A C = sum_ k e. B D $=
      ( csu sumeq2i sumeq1i eqtri ) ACEHADEHBDEHACDEGIABDEFJK $.
  $}

  ${
    $d k A $.  $d k B $.
    sumeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for sum.  (Contributed by NM, 1-Nov-2005.) $)
    sumeq1d $p |- ( ph -> sum_ k e. A C = sum_ k e. B C ) $=
      ( wceq csu sumeq1 syl ) ABCGBDEHCDEHGFBCDEIJ $.
  $}

  ${
    $d k A $.
    sumeq2d.1 $e |- ( ph -> A. k e. A B = C ) $.
    $( Equality deduction for sum.  Note that unlike ~ sumeq2dv , ` k ` may
       occur in ` ph ` .  (Contributed by NM, 1-Nov-2005.) $)
    sumeq2d $p |- ( ph -> sum_ k e. A B = sum_ k e. A C ) $=
      ( wceq wral csu sumeq2 syl ) ACDGEBHBCEIBDEIGFBCDEJK $.
  $}

  ${
    $d k A $.  $d k ph $.
    sumeq2dv.1 $e |- ( ( ph /\ k e. A ) -> B = C ) $.
    $( Equality deduction for sum.  (Contributed by NM, 3-Jan-2006.)  (Revised
       by Mario Carneiro, 31-Jan-2014.) $)
    sumeq2dv $p |- ( ph -> sum_ k e. A B = sum_ k e. A C ) $=
      ( wceq ralrimiva sumeq2d ) ABCDEACDGEBFHI $.
  $}

  ${
    $d k A $.  $d k ph $.
    sumeq2sdv.1 $e |- ( ph -> B = C ) $.
    $( Equality deduction for sum.  (Contributed by NM, 3-Jan-2006.) $)
    sumeq2sdv $p |- ( ph -> sum_ k e. A B = sum_ k e. A C ) $=
      ( wceq cv wcel adantr sumeq2dv ) ABCDEACDGEHBIFJK $.
  $}

  ${
    $d j k A $.  $d k B $.  $d j k ph $.
    2sumeq2dv.1 $e |- ( ( ph /\ j e. A /\ k e. B ) -> C = D ) $.
    $( Equality deduction for double sum.  (Contributed by NM, 3-Jan-2006.)
       (Revised by Mario Carneiro, 31-Jan-2014.) $)
    2sumeq2dv $p |- ( ph ->
           sum_ j e. A sum_ k e. B C = sum_ j e. A sum_ k e. B D ) $=
      ( csu cv wcel wa wceq 3expa sumeq2dv ) ABCDGICEGIFAFJBKZLCDEGAPGJCKDEMHNO
      O $.
  $}

  ${
    $d k A $.  $d k B $.  $d k ph $.
    sumeq12dv.1 $e |- ( ph -> A = B ) $.
    sumeq12dv.2 $e |- ( ( ph /\ k e. A ) -> C = D ) $.
    $( Equality deduction for sum.  (Contributed by NM, 1-Dec-2005.) $)
    sumeq12dv $p |- ( ph -> sum_ k e. A C = sum_ k e. B D ) $=
      ( csu sumeq2dv sumeq1d eqtrd ) ABDFIBEFICEFIABDEFHJABCEFGKL $.
  $}

  ${
    $d k A $.  $d k B $.  $d k ph $.
    sumeq12rdv.1 $e |- ( ph -> A = B ) $.
    sumeq12rdv.2 $e |- ( ( ph /\ k e. B ) -> C = D ) $.
    $( Equality deduction for sum.  (Contributed by NM, 1-Dec-2005.) $)
    sumeq12rdv $p |- ( ph -> sum_ k e. A C = sum_ k e. B D ) $=
      ( csu sumeq1d sumeq2dv eqtrd ) ABDFICDFICEFIABCDFGJACDEFHKL $.
  $}

  ${
    $d k A $.
    $( The second class argument to a sum can be chosen so that it is always a
       set.  (Contributed by NM, 11-Dec-2005.)  (Revised by Mario Carneiro,
       13-Jul-2013.) $)
    sum2id $p |- sum_ k e. A B = sum_ k e. A ( _I ` B ) $=
      ( cid cfv wceq csu sumeq2ii cv wcel cvv fvex fvi ax-mp eqcomi a1i mprg )
      BDEZRDEZFZABCGARCGFCAABRCHTCIAJSRRKJSRFBDLRKMNOPQ $.
  $}

  ${
    $d j k x A $.  $d j x B $.
    $( A lemma to facilitate conversions from the function form to the
       class-variable form of a sum.  (Contributed by Mario Carneiro,
       12-Aug-2013.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    sumfc $p |- sum_ j e. A ( ( k e. A |-> B ) ` j ) = sum_ k e. A B $=
      ( cv cmpt cfv csu eqid fvmpt2i sumeq2i nffvmpt1 nfcv fveq2 cbvsumi sum2id
      cid 3eqtr4i ) ADEZDABFZGZDHABQGZDHACEZTGZCHABDHAUAUBDDABTTIJKAUDUACDDABUC
      LCUAMUCSTNOABDPR $.
  $}

  ${
    $d f A $.
    $( A lemma for working with finite sums.  (Contributed by Mario Carneiro,
       22-Apr-2014.) $)
    fz1f1o $p |- ( A e. Fin -> ( A = (/) \/ ( ( # ` A ) e. NN /\
                   E. f f : ( 1 ... ( # ` A ) ) -1-1-onto-> A ) ) ) $=
      ( cfn wcel chash cfv cc0 wceq cn wo c0 c1 cfz co cv wf1o wex sylib mpbid
      wa cn0 hashcl orcomd hasheq0 cen wbr hashfz1 syl wb fzfi hashen mpan bren
      elnn0 biantrud orbi12d ) ACDZAEFZGHZURIDZJAKHZUTLURMNZABOPBQZTZJUQUTUSUQU
      RUADZUTUSJAUBZURUNRUCUQUSVAUTVDACUDUQVCUTUQVBAUEUFZVCUQVBEFURHZVGUQVEVHVF
      URUGUHVBCDUQVHVGUILURUJVBAUKULSVBABUMRUOUPS $.
  $}

  ${
    $d f g i j k m n x y A $.  $d f g j k m n x y F $.  $d g i j k m n x y G $.
    $d i x H $.  $d i j k m n x y K $.  $d k m n N $.  $d g i j k m n y ph $.
    $d f j m n x y B $.  $d i j k m n x y M $.
    summo.1 $e |- F = ( k e. ZZ |-> if ( k e. A , B , 0 ) ) $.
    summo.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    ${
      sumrb.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      $( Lemma for ~ sumrb .  (Contributed by Mario Carneiro, 12-Aug-2013.) $)
      sumrblem $p |- ( ( ph /\ A C_ ( ZZ>= ` N ) ) ->
                     ( seq M ( + , F ) |` ( ZZ>= ` N ) ) = seq N ( + , F ) ) $=
        ( cuz cfv cc cc0 wcel co wceq adantl adantr cz vn wss wa addid2 0cn a1i
        caddc cv wf cif iftrue eqeltrd ex iffalse syl6eqel pm2.61d1 eluzelz syl
        wn fmptd ffvelrnd c1 cmin cfz cdif elfzelz simplr ad2antrr ax-1cn npcan
        sylancl fveq2d sseqtr4d fznuz ssneldd eldifd fveq2 eqeq1d eldifi eldifn
        zcnd fvmpt2 syl2anc eqtrd vtoclga seqid ) ABGKLZUBZUCZUAUGMEFGNUAUHZMON
        WJUGPWJQWIWJUDRNMOWIUEUFAGFKLOZWHJSWITMGEATMEUIWHADTDUHZBOZCNUJZMEAWNMO
        ZWLTOZAWMWOAWMWOAWMUCWNCMWMWNCQAWMCNUKRIULUMWMUSZWNNMWMCNUNZUEUOUPSHUTS
        AGTOZWHAWKWSJFGUQURZSVAWIWJFGVBVCPZVDPOZUCZWJTBVEZOWJELZNQZXCWJTBXBWJTO
        WIWJFXAVFRXCBXAVBUGPZKLZWJXCBWGXHAWHXBVGXCXGGKXCGMOZVBMOXGGQAXIWHXBAGWT
        WAVHVIGVBVJVKVLVMXBWJXHOUSWIWJFXAVNRVOVPWLELZNQXFDWJXDWLWJQXJXENWLWJEVQ
        VRWLXDOZXJWNNXKWPWOXJWNQWLTBVSXKWNNMXKWQWNNQWLTBVTWRURZUEUODTWNMEHWBWCX
        LWDWEURWF $.

      fsumcvg.4 $e |- ( ph -> A C_ ( M ... N ) ) $.
      $( The sequence of partial sums of a finite sum converges to the whole
         sum.  (Contributed by Mario Carneiro, 20-Apr-2014.) $)
      fsumcvg $p |- ( ph -> seq M ( + , F ) ~~> ( seq M ( + , F ) ` N ) ) $=
        ( caddc cfv wcel cz syl cc wa cc0 wceq vn vm cseq cvv cuz eluzelz seqex
        eqid a1i eluzel2 cv cif iftrue adantl eqeltrd iffalse syl6eqel pm2.61d1
        ex wn 0cn fvmpt2 syl2anr adantr serf ffvelrnd co addid1 simpr c1 elfzuz
        cfz cdif sseld fznuz syl6 con2d imp eldifd eqeq1d eldifi eldifn syl2anc
        fveq2 eqtrd vtoclga sylan2 adantlr seqid2 eqcomd climconst ) AGLEFUCZMZ
        UAWLGUDGUEMZWNUHAGFUEMZNZGONJFGUFPWLUDNALEFUGUIAWOQGWLADEFWOWOUHAWPFONJ
        FGUJPADUKZWONZRWQEMZWQBNZCSULZQWRWQONZXAQNZWSXATZAFWQUFAWTXCAWTXCAWTRXA
        CQWTXACTAWTCSUMUNIUOUSWTUTZXASQWTCSUPZVAUQURZDOXAQEHVBZVCAXCWRXGVDUOVEJ
        VFZAUAUKZWNNZRZWMXJWLMXLUBLQEGFXJSUBUKZQNXMSLVGXMTXLXMVHUNAWPXKJVDAXKVI
        AWMQNXKXIVDAXMGVJLVGZXJVLVGNZXMEMZSTZXKXOAXMXNUEMNZXQXMXNXJVKAXRRZXMOBV
        MZNXQXSXMOBXRXMONAXNXMUFUNAXRXMBNZUTAYAXRAYAXMFGVLVGZNXRUTABYBXMKVNXMFG
        VOVPVQVRVSWSSTXQDXMXTWQXMTWSXPSWQXMEWDVTWQXTNZWSXASYCXBXCXDWQOBWAYCXASQ
        YCXEXASTWQOBWBXFPZVAUQXHWCYDWEWFPWGWHWIWJWK $.
    $}

    ${
      sumrb.4 $e |- ( ph -> M e. ZZ ) $.
      sumrb.5 $e |- ( ph -> N e. ZZ ) $.
      sumrb.6 $e |- ( ph -> A C_ ( ZZ>= ` M ) ) $.
      sumrb.7 $e |- ( ph -> A C_ ( ZZ>= ` N ) ) $.
      $( Rebase the starting point of a sum.  (Contributed by Mario Carneiro,
         14-Jul-2013.)  (Revised by Mario Carneiro, 9-Apr-2014.) $)
      sumrb $p |- ( ph ->
                    ( seq M ( + , F ) ~~> C <-> seq N ( + , F ) ~~> C ) ) $=
        ( wcel caddc cli wbr cvv adantr cuz cfv cseq wb wa cres climres sylancl
        cz seqex wss cv cc adantlr simpr sumrblem mpdan breq1d bitr3d wo uztric
        wceq syl2anc mpjaodan ) AHGUAUBZOZPFGUCZDQRZPFHUCZDQRZUDGHUAUBZOZAVFUEZ
        VGVKUFZDQRZVHVJVMHUIOZVGSOVOVHUDAVPVFLTPFGUJDVGHSUGUHVMVNVIDQVMBVKUKZVN
        VIVBAVQVFNTVMBCEFGHIAEULBOZCUMOZVFJUNAVFUOUPUQURUSAVLUEZVIVEUFZDQRZVHVJ
        VTWAVGDQVTBVEUKZWAVGVBAWCVLMTVTBCEFHGIAVRVSVLJUNAVLUOUPUQURVTGUIOZVISOW
        BVJUDAWDVLKTPFHUJDVIGSUGUHUSAWDVPVFVLUTKLGHVAVCVD $.
    $}

    summo.3 $e |- G = ( n e. NN |-> [_ ( f ` n ) / k ]_ B ) $.
    ${
      summolem3.4 $e |- H = ( n e. NN |-> [_ ( K ` n ) / k ]_ B ) $.
      summolem3.5 $e |- ( ph -> ( M e. NN /\ N e. NN ) ) $.
      summolem3.6 $e |- ( ph -> f : ( 1 ... M ) -1-1-onto-> A ) $.
      summolem3.7 $e |- ( ph -> K : ( 1 ... N ) -1-1-onto-> A ) $.
      $( Lemma for ~ summo .  (Contributed by Mario Carneiro, 29-Mar-2014.) $)
      summolem3 $p |- ( ph ->
                        ( seq 1 ( + , G ) ` M ) = ( seq 1 ( + , H ) ` N ) ) $=
        ( wcel vm vj vy vi caddc c1 cseq cfv cc cv ccnv ccom wa co addcl adantl
        wceq addcom w3a addass cuz simpld nnuz syl6eleq wss ssid a1i cfz f1ocnv
        cn wf1o syl f1oco syl2anc wb chash cen wbr ovex f1oen fzfi hashen mp2an
        cfn sylibr cn0 simprd hashfz1 3syl 3eqtr3rd oveq2d f1oeq2 mpbird elfznn
        nnnn0 csb wral wf f1of ffvelrnda ralrimiva adantr nfcsb1v nfel1 csbeq1a
        eleq1d rspc sylc fveq2 csbeq1d fvmptg eqeltrd cid fvco3 sylan f1ocnvfv2
        fveq2d eqtr2d fvmpti 3eqtr4d seqf1o eqtr3d ) AKUEIUFUGZUHKUEHUFUGUHLYCU
        HAUAUBUCUIUEUIUDDUJZUKZJULZHIUFKUAUJZUITZUBUJZUITZUMZYGYIUEUNZUITAYGYIU
        OUPYKYLYIYGUEUNUQAYGYIURUPYHYJUCUJZUITUSYLYMUEUNYGYIYMUEUNUEUNUQAYGYIYM
        UTUPAKVJUFVAUHAKVJTZLVJTZQVBZVCVDUIUIVEAUIVFVGAUFKVHUNZYQYFVKZUFLVHUNZY
        QYFVKZABYQYEVKZYSBJVKZYTAYQBYDVKZUUARYQBYDVIVLSYSBYQYEJVMVNZAYQYSUQZYRY
        TVOAKLUFVHAYSVPUHZYQVPUHZLKAYSYQVQVRZUUFUUGUQZAYTUUHUUDYSYQYFUFLVHVSVTV
        LYSWDTYQWDTUUIUUHVOUFLWAUFKWAYSYQWBWCWEAYOLWFTUUFLUQAYNYOQWGLWOLWHWIAYN
        KWFTUUGKUQYPKWOKWHWIWJZWKZYQYSYQYFWLVLWMZAYGYQTZUMZYGHUHZEYGYDUHZCWPZUI
        UUNYGVJTZUUQUITZUUOUUQUQUUMUURAYGKWNUPUUNUUPBTCUITZEBWQZUUSAYQBYGYDAUUC
        YQBYDWRRYQBYDWSVLWTAUVAUUMAUUTEBNXAXBUUTUUSEUUPBEUUQUIEUUPCXCXDEUJUUPUQ
        CUUQUIEUUPCXEXFXGXHZFYGEFUJZYDUHZCWPZUUQVJUIHUVCYGUQEUVDUUPCUVCYGYDXIXJ
        OXKVNUVBXLAUDUJZYQTZUMZEUVFJUHZCWPZXMUHZEUVFYFUHZYDUHZCWPZXMUHZUVFIUHZU
        VLHUHZUVHUVJUVNXMUVHEUVIUVMCUVHUVMUVIYEUHZYDUHZUVIUVHUVLUVRYDAYQBJWRZUV
        GUVLUVRUQAYQBJVKZUVTAUWAUUBSAUUEUWAUUBVOUUKYQYSBJWLVLWMYQBJWSVLZYQBUVFY
        EJXNXOXQUVHUUCUVIBTUVSUVIUQAUUCUVGRXBAYQBUVFJUWBWTYQBUVIYDXPVNXRXJXQUVH
        UVFVJTZUVPUVKUQUVGUWCAUVFKWNUPFUVFEUVCJUHZCWPUVJVJIUVCUVFUQEUWDUVICUVCU
        VFJXIXJPXSVLUVHUVLYQTUVLVJTUVQUVOUQAYQYQUVFYFAYRYQYQYFWRUULYQYQYFWSVLWT
        UVLKWNFUVLUVEUVNVJHUVCUVLUQEUVDUVMCUVCUVLYDXIXJOXSWIXTYAAKLYCUUJXQYB $.
    $}

    $d x ph $.
    ${
      summolem2.4 $e |- H = ( n e. NN |-> [_ ( K ` n ) / k ]_ B ) $.
      summolem2.5 $e |- ( ph -> N e. NN ) $.
      summolem2.6 $e |- ( ph -> M e. ZZ ) $.
      summolem2.7 $e |- ( ph -> A C_ ( ZZ>= ` M ) ) $.
      summolem2.8 $e |- ( ph -> f : ( 1 ... N ) -1-1-onto-> A ) $.
      summolem2.9 $e |- ( ph -> K Isom < , < ( ( 1 ... ( # ` A ) ) , A ) ) $.
      $( Lemma for ~ summo .  (Contributed by Mario Carneiro, 3-Apr-2014.)
         (Revised by Mario Carneiro, 20-Apr-2014.) $)
      summolem2a $p |- ( ph -> seq M ( + , F ) ~~> ( seq 1 ( + , G ) ` N ) ) $=
        ( vm vx caddc cseq cfv c1 cli cuz cfz co wf1o wf clt wiso chash wceq wb
        cen wbr cv ovex f1oen syl wcel fzfid ensymd enfii syl2anc hashen mpbird
        cfn cn cn0 nnnn0 hashfz1 3syl eqtr3d oveq2d isoeq4 isof1o f1of syl6eleq
        mpbid nnuz eluzfz2 ffvelrnd sseldd wa sselda cle f1ocnvfv2 sylan f1ocnv
        ccnv ffvelrnda elfzle2 cxr adantr cr fzssuz cz uzssz zssre sstri ressxr
        wss syl6ss leisorel syl122anc eqbrtrrd eluzelz eluz elfzuzb sylanbrc ex
        a1i ssrdv cc cc0 adantl 0cn cif iftrue syl6eqel elfzelz weq csb nfcsb1v
        fveq2 wi nfv nfcv nfif eleq1 csbeq1a eqidd ifbieq12d cmpt fvmptg addid2
        fsumcvg addid1 addcl eleqtrrd eqeltrd wn iffalse pm2.61d1 fmptd ffvelrn
        syl2an cdif eqeq1d eldifi eldifn fvmpt2 eqtrd vtoclga nfel1 nfim eleq1d
        fvex imbi2d vtoclf csbeq1 cbvmpt eqtri elfznn eqeltrrd csbeq1d 3eqtr4rd
        seqcoll jca summolem3 eqtr4d breqtrd ) AUDGKUEZLJUFZUVRUFZLUDHUGUEUFZUH
        ABCEGKUVSMNABKUIUFZUVSSAUGLUJUKZBLJAUWCBJULZUWCBJUMAUWCBUNUNJUOZUWDAUGB
        UPUFZUJUKZBUNUNJUOZUWEUAAUWGUWCUQUWHUWEURAUWFLUGUJAUWCUPUFZUWFLAUWIUWFU
        QZUWCBUSUTZAUWCBDVAZULUWKTUWCBUWLUGLUJVBVCVDZAUWCVLVEZBVLVEZUWJUWKURAUG
        LVFZAUWNBUWCUSUTUWOUWPAUWCBUWMVGBUWCVHVIUWCBVJVIVKALVMVEZLVNVEUWILUQQLV
        OLVPVQVRVSZUWGBUWCUNUNJVTVDWDZUWCBUNUNJWAVDZUWCBJWBVDALUGUIUFZVELUWCVEZ
        ALVMUXAQWEWCUGLWFVDZWGWHZAFBKUVSUJUKZAFVAZBVEZUXFUXEVEZAUXGWIZUXFUWBVEZ
        UVSUXFUIUFVEZUXHABUWBUXFSWJZUXIUXKUXFUVSWKUTZUXIUXFJWOZUFZJUFZUXFUVSWKA
        UWDUXGUXPUXFUQUWTUWCBUXFJWLWMUXIUXOLWKUTZUXPUVSWKUTZUXIUXOUWCVEZUXQABUW
        CUXFUXNAUWDBUWCUXNULBUWCUXNUMUWTUWCBJWNBUWCUXNWBVQWPZUXOUGLWQVDUXIUWEUW
        CWRXGZBWRXGUXSUXBUXQUXRURAUWEUXGUWSWSUYAUXIUWCWTWRUWCUXAWTUGLXAUXAXBWTU
        GXCXDXEXEXFXEXQUXIBWTWRUXIBUWBWTABUWBXGZUXGSWSUWBXBWTKXCXDXEXHXFXHUXTAU
        XBUXGUXCWSUWCBUXOLJXIXJWDXKUXIUXFXBVEZUVSXBVEZUXKUXMURUXIUXJUYCUXLKUXFX
        LVDAUYDUXGAUVSUWBVEUYDUXDKUVSXLVDWSUXFUVSXMVIVKUXFKUVSXNXOXPXRUUBAUVTLU
        DIUGUEUFUWAABUDXSUBUCGJIKLXTUBVAZXSVEZXTUYEUDUKUYEUQAUYEUUAYAUYFUYEXTUD
        UKUYEUQAUYEUUCYAUYFUCVAZXSVEWIUYEUYGUDUKXSVEAUYEUYGUUDYAXTXSVEAYBXQUAAL
        UWCUWGUXCUWRUUESAXBXSGUMUYEXBVEUYEGUFZXSVEUYEKUWFJUFZUJUKZVEAEXBEVAZBVE
        ZCXTYCZXSGAUYMXSVEZUYKXBVEZAUYLUYNAUYLUYNAUYLWIUYMCXSUYLUYMCUQAUYLCXTYD
        YANUUFXPUYLUUGZUYMXTXSUYLCXTUUHZYBYEUUIZWSMUUJUYEKUYIYFXBXSUYEGUUKUULUY
        EUYJBUUMZVEUYHXTUQZAUYKGUFZXTUQUYTEUYEUYSEUBYGVUAUYHXTUYKUYEGYJUUNUYKUY
        SVEZVUAUYMXTVUBUYOUYNVUAUYMUQVUBUYKUYJVEUYOUYKUYJBUUOUYKKUYIYFVDVUBUYMX
        TXSVUBUYPUYMXTUQUYKUYJBUUPUYQVDZYBYEEXBUYMXSGMUUQVIVUCUURUUSYAAUYGUWGVE
        ZWIZUYGJUFZBVEZEVUFCYHZXTYCZVUHVUFGUFZUYGIUFZVUEVUGVUIVUHUQAUWGBUYGJAUW
        HUWGBJULUWGBJUMUAUWGBUNUNJWAUWGBJWBVQWPZVUGVUHXTYDVDZVUEVUFXBVEZVUIXSVE
        ZVUJVUIUQVUEVUFUWBVEVUNVUEBUWBVUFAUYBVUDSWSVULWHKVUFXLVDAVUOVUDAUYNYKAV
        UOYKEVUFAVUOEAEYLEVUIXSVUGEVUHXTVUGEYLEVUFCYIEXTYMZYNUUTUVAUYGJUVCUYKVU
        FUQZUYNVUOAVUQUYMVUIXSVUQUYLVUGCXTVUHXTUYKVUFBYOEVUFCYPVUQXTYQYRUVBUVDU
        YRUVEWSZFVUFUXGEUXFCYHZXTYCZVUIXBXSGUXFVUFUQZUXGVUGVUSXTVUHXTUXFVUFBYOE
        UXFVUFCUVFVVAXTYQYRGEXBUYMYSFXBVUTYSMEFXBUYMVUTFUYMYMUXGEVUSXTUXGEYLEUX
        FCYIVUPYNEFYGZUYLUXGCXTVUSXTUYKUXFBYOEUXFCYPVVBXTYQYRUVGUVHYTVIVUEUYGVM
        VEZVUHXSVEVUKVUHUQVUDVVCAUYGUWFUVIYAVUEVUIVUHXSVUMVURUVJFUYGEUXFJUFZCYH
        VUHVMXSIFUCYGEVVDVUFCUXFUYGJYJUVKPYTVIUVLUVMABCDEFGHIJLLMNOPAUWQUWQQQUV
        NTUWTUVOUVPUVQ $.
    $}

    $d f ph $.
    ${
      $( Lemma for ~ summo .  (Contributed by Mario Carneiro, 3-Apr-2014.) $)
      summolem2 $p |- ( ( ph /\
         E. m e. ZZ ( A C_ ( ZZ>= ` m ) /\ seq m ( + , F ) ~~> x ) ) ->
       ( E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> A /\
         y = ( seq 1 ( + , G ) ` m ) ) -> x = y ) ) $=
        ( cv cfv wa cz wcel clt vj vg cuz wss caddc cseq cli wbr wrex c1 cfz co
        wf1o wex cn wi fveq2 sseq2d seqeq1 breq1d anbi12d cbvrexv simplrr chash
        wceq wiso wor cfn cr simplrl uzssz zssre syl6ss ltso soss ee10 cen fzfi
        sstri ovex f1oen ad2antll ensymd enfii sylancr syl2anc csb cmpt simplll
        fz1iso cc sylan eqid simprll simpllr simprlr simprr summolem2a expr mpd
        exlimdv climuni anassrs eqeq2 syl5ibrcom expimpd rexlimdva imp sylan2b
        ex ) DHOZUCPZUDZUEJXKUFZBOZUGUHZQZHRUIADUAOZUCPZUDZUEJXRUFZXOUGUHZQZUAR
        UIZUJXKUKULZDFOZUMZCOZXKUEKUJUFPZVEZQZFUNZHUOUIXOYHVEZUPZXQYCHUARXKXRVE
        ZXMXTXPYBYOXLXSDXKXRUCUQURYOXNYAXOUGUEJXKXRUSUTVAVBAYDYNAYCYNUARAXRRSZQ
        ZYCYNYQYCQZYLYMHUOYRXKUOSZQZYKYMFYTYGYJYMYTYGQYMYJXOYIVEZYRYSYGUUAYRYSY
        GQZQZYBYAYIUGUHZUUAYQXTYBUUBVCUUCUJDVDPUKULDTTUBOZVFZUBUNZUUDUUCDTVGZDV
        HSZUUGUUCDVIUDVITVGUUHUUCDXSVIYQXTYBUUBVJXSRVIXRVKVLVSVMVNDVITVOVPUUCYE
        VHSDYEVQUHUUIUJXKVRUUCYEDYGYEDVQUHYRYSYEDYFUJXKUKVTWAWBWCDYEWDWEDTUBWJW
        FUUCUUFUUDUBYRUUBUUFUUDYRUUBUUFQZQZDEFGIJKIUOGIOUUEPEWGWHZUUEXRXKLUUKAG
        ODSEWKSAYPYCUUJWIMWLNUULWMYRYSYGUUFWNAYPYCUUJWOYQXTYBUUJVJYRYSYGUUFWPYR
        UUBUUFWQWRWSXAWTXOYIYAXBWFXCYHYIXOXDXEXFXAXGXJXGXHXI $.
    $}

    $( A sum has at most one limit.  (Contributed by Mario Carneiro,
       3-Apr-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    summo $p |- ( ph -> E* x
        ( E. m e. ZZ ( A C_ ( ZZ>= ` m ) /\ seq m ( + , F ) ~~> x ) \/
          E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> A /\
                            x = ( seq 1 ( + , G ) ` m ) ) ) ) $=
      ( vy cv cfv wa cz wrex cn vg vj cuz wss caddc cseq cli wbr c1 cfz co wf1o
      wceq wex wo weq wal wmo fveq2 sseq2d seqeq1 breq1d anbi12d cbvrexv reeanv
      wi wcel simprlr sylan simplrl simplrr simprll simprrl sumrb mpbid simprrr
      cc simpll climuni syl2anc rexlimdvv syl5bir expdimp syl5bi summolem2 jaod
      exp31 equcom syl6ib impancom csb wb oveq2 f1oeq2 syl eqeq2d exbidv f1oeq1
      cmpt fveq1 csbeq1d mpteq2dv syl5eq seqeq3d fveq1d cbvexv syl6bb eeanv an4
      cbvmptv simplr simprl simprr summolem3 eqeq12 syl5ibrcom expimpd exlimdvv
      eqtri rexlimdvva jaodan alrimivv breq2 anbi2d rexbidv orbi12d mo4 sylibr
      eqeq1 ) ACGOZUCPZUDZUEIYJUFZBOZUGUHZQZGRSZUIYJUJUKZCEOZULZYNYJUEJUIUFZPZU
      MZQZEUNZGTSZUOZYLYMNOZUGUHZQZGRSZYTUUHUUBUMZQZEUNZGTSZUOZQBNUPZVFZNUQBUQU
      UGBURAUURBNAUUGUUPUUQAYQUUPUUQVFUUFAYQQZUUKUUQUUOUUKCHOZUCPZUDZUEIUUTUFZU
      UHUGUHZQZHRSZUUSUUQUUJUVEGHRGHUPZYLUVBUUIUVDUVGYKUVACYJUUTUCUSUTUVGYMUVCU
      UHUGUEIYJUUTVAVBVCVDAYQUVFUUQYQUVFQYPUVEQZHRSGRSAUUQYPUVEGHRRVEAUVHUUQGHR
      RAYJRVGZUUTRVGZQZUVHUUQAUVKQZUVHQZUVCYNUGUHZUVDUUQUVMYOUVNUVLYLYOUVEVHUVM
      CDYNFIYJUUTKUVMAFOCVGZDVQVGZAUVKUVHVRLVIAUVIUVJUVHVJAUVIUVJUVHVKUVLYLYOUV
      EVLUVLYPUVBUVDVMVNVOUVLYPUVBUVDVPYNUUHUVCVSVTWGWAWBWCWDABNCDEFGHIJKLMWEWF
      AUUFQZUUKUUQUUOAUUKUUFUUQAUUKQUUFNBUPUUQANBCDEFGHIJKLMWENBWHWIWJUUOUIUUTU
      JUKZCUAOZULZUUHUUTUEHTFUUTUVSPZDWKZWSZUIUFZPZUMZQZUAUNZHTSZUVQUUQUUNUWHGH
      TUVGUUNUVRCYSULZUUHUUTUUAPZUMZQZEUNUWHUVGUUMUWMEUVGYTUWJUULUWLUVGYRUVRUMY
      TUWJWLYJUUTUIUJWMYRUVRCYSWNWOUVGUUBUWKUUHYJUUTUUAUSWPVCWQUWMUWGEUAEUAUPZU
      WJUVTUWLUWFUVRCYSUVSWRUWNUWKUWEUUHUWNUUTUUAUWDUWNJUWCUEUIUWNJHTFUUTYSPZDW
      KZWSZUWCMUWNHTUWPUWBUWNFUWOUWADUUTYSUVSWTXAXBXCXDXEWPVCXFXGVDAUUFUWIUUQUU
      FUWIQUUEUWHQZHTSGTSAUUQUUEUWHGHTTVEAUWRUUQGHTTUWRUUDUWGQZUAUNEUNAYJTVGUUT
      TVGQZQZUUQUUDUWGEUAXHUXAUWSUUQEUAUWSYTUVTQZUUCUWFQZQUXAUUQYTUUCUVTUWFXIUX
      AUXBUXCUUQUXAUXBQZUUQUXCUUBUWEUMUXDCDEFUBIJUWCUVSYJUUTKUXDAUVOUVPAUWTUXBV
      RLVIJUWQUBTFUBOZYSPZDWKZWSMHUBTUWPUXGHUBUPZFUWOUXFDUUTUXEYSUSXAXJXSHUBTUW
      BFUXEUVSPZDWKUXHFUWAUXIDUUTUXEUVSUSXAXJAUWTUXBXKUXAYTUVTXLUXAYTUVTXMXNYNU
      UBUUHUWEXOXPXQWDXRWBXTWBWCWDWFYAXQYBUUGUUPBNUUQYQUUKUUFUUOUUQYPUUJGRUUQYO
      UUIYLYNUUHYMUGYCYDYEUUQUUEUUNGTUUQUUDUUMEUUQUUCUULYTYNUUHUUBYIYDWQYEYFYGY
      H $.
  $}

  ${
    $d f g i j k m n x A $.  $d j k n x F $.  $d f g i j k m x ph $.  $d k Z $.
    $d f g i j m n x B $.  $d f g i j k m x M $.
    zsum.1 $e |- Z = ( ZZ>= ` M ) $.
    zsum.2 $e |- ( ph -> M e. ZZ ) $.
    ${
      zsum.3 $e |- ( ph -> A C_ Z ) $.
      zsum.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = if ( k e. A , B , 0 ) ) $.
      zsum.5 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
      $( Series sum with index set a subset of the upper integers.
         (Contributed by Mario Carneiro, 9-Apr-2014.) $)
      zsum $p |- ( ph -> sum_ k e. A B = ( ~~> ` seq M ( + , F ) ) ) $=
        ( vi cv cfv cz wcel cc0 cli wa vm vx vf vn vg vj cuz wss caddc cif cmpt
        cseq wbr wrex c1 cfz co wf1o csb wceq wex cio csu nfcv nfv nfcsb1v nfif
        cn wo weq eleq1 csbeq1a eqidd ifbieq12d cbvmpt cc simpll wral ralrimiva
        nfel1 eleq1d rspc syl5 mpan9 simplr ad2antrr simpr sumrb biimpd expimpd
        syl6sseq rexlimdva chash clt wiso wor cr uzssz eqsstri zssre sstri ltso
        cfn soss mp2 ee10 fzfi f1oen adantl ensymd enfii sylancr fz1iso syl2anc
        cen ovex fveq2 csbeq1d csbco syl6eqr eqid simprl simprr summolem2a expr
        cbvmptv exlimdv mpd syl5ibrcom jaod adantr sseq2d seqeq1 breq1d anbi12d
        breq2 rspcev syl12anc orcd ex impbid eleq2i sseli iftrue eqeltrd wn 0cn
        iffalse syl6eqel pm2.61d1 fvmpt2 syl2anr eqtr4d sylan2br nffvmpt1 nfeq1
        eqeq12d seqfeq bitrd iotabidv df-sum df-fv 3eqtr4g ) ABUANZUGOZUHZUIDPD
        NZBQZCRUJZUKZUVDULZUBNZSUMZTZUAPUNZUOUVDUPUQZBUCNZURZUVLUVDUIUDVHDUDNZU
        VQOZCUSZUKZUOULOZUTZTZUCVAZUAVHUNZVIZUBVBUIEFULZUVLSUMZUBVBBCDVCUWISOAU
        WHUWJUBAUWHUIUVJFULZUVLSUMZUWJAUWHUWLAUVOUWLUWGAUVNUWLUAPAUVDPQZTZUVFUV
        MUWLUWNUVFTZUVMUWLUWOBDMNZCUSZUVLMUVJUVDFDMPUVIUWPBQZUWQRUJMUVIVDUWRDUW
        QRUWRDVEDUWPCVFZDRVDVGDMVJZUVHUWRCRUWQRUVGUWPBVKDUWPCVLZUWTRVMVNVOZUWOA
        UWRUWQVPQZAUWMUVFVQACVPQZDBVRUWRUXCAUXDDBLVSUXDUXCDUWPBDUWQVPUWSVTUWTCU
        WQVPUXAWAWBWCZWDAUWMUVFWEAFPQZUWMUVFIWFUWNUVFWGABFUGOZUHZUWMUVFABGUXGJH
        WKZWFWHWIWJWLAUWFUWLUAVHAUVDVHQZTZUWEUWLUCUXKUVRUWDUWLUXKUVRTZUWLUWDUWK
        UWCSUMZUXLUOBWMOUPUQBWNWNUENZWOZUEVAZUXMUXLBWNWPZBXCQZUXPUXLBGUHZGWNWPZ
        UXQAUXSUXJUVRJWFGWQUHWQWNWPUXTGPWQGUXGPHFWRWSZWTXAXBGWQWNXDXEBGWNXDXFUX
        LUVPXCQBUVPXOUMUXRUOUVDXGUXLUVPBUVRUVPBXOUMUXKUVPBUVQUOUVDUPXPXHXIXJBUV
        PXKXLBWNUEXMXNUXLUXOUXMUEUXKUVRUXOUXMUXKUVRUXOTZTZBUWQUCMUFUVJUWBUFVHMU
        FNZUXNOUWQUSUKZUXNFUVDUXBUYCAUWRUXCAUXJUYBVQUXEWDUDUFVHUWAMUYDUVQOZUWQU
        SZUDUFVJZUWADUYFCUSUYGUYHDUVTUYFCUVSUYDUVQXQXRDMUYFCXSXTYFUYEYAAUXJUYBW
        EAUXFUXJUYBIWFAUXHUXJUYBUXIWFUXKUVRUXOYBUXKUVRUXOYCYDYEYGYHUVLUWCUWKSYP
        YIWJYGWLYJAUWLUWHAUWLTZUVOUWGUYIUXFUXHUWLUVOAUXFUWLIYKAUXHUWLUXIYKAUWLW
        GUVNUXHUWLTUAFPUVDFUTZUVFUXHUVMUWLUYJUVEUXGBUVDFUGXQYLUYJUVKUWKUVLSUIUV
        JUVDFYMYNYOYQYRYSYTUUAAUWKUWIUVLSAUIUFUVJEFIAUVGUVJOZUVGEOZUTZDUXGVRUYD
        UXGQUYDUVJOZUYDEOZUTZAUYMDUXGUVGUXGQAUVGGQZUYMGUXGUVGHUUBAUYQTUYKUVIUYL
        UYQUVGPQUVIVPQZUYKUVIUTAGPUVGUYAUUCAUVHUYRAUVHUYRAUVHTUVICVPUVHUVICUTAU
        VHCRUUDXILUUEYTUVHUUFUVIRVPUVHCRUUHUUGUUIUUJDPUVIVPUVJUVJYAUUKUULKUUMUU
        NVSUYMUYPDUYDUXGDUYNUYODPUVIUYDUUOUUPDUFVJUYKUYNUYLUYOUVGUYDUVJXQUVGUYD
        EXQUUQWBWDUURYNUUSUUTUBBCUCDUAUDUVAUBUWISUVBUVC $.
    $}

    isum.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    isum.4 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
    $( Series sum with an upper integer index set (i.e. an infinite series).
       (Contributed by Mario Carneiro, 15-Jul-2013.)  (Revised by Mario
       Carneiro, 7-Apr-2014.) $)
    isum $p |- ( ph -> sum_ k e. Z B = ( ~~> ` seq M ( + , F ) ) ) $=
      ( wss ssid a1i cv wcel wa cfv cc0 cif wceq iftrue adantl eqtr4d zsum ) AF
      BCDEFGHFFKAFLMACNZFOZPUEDQBUFBRSZIUFUGBTAUFBRUAUBUCJUD $.
  $}

  ${
    $d f i j m n x B $.  $d f k m x C $.  $d f k n F $.  $d f i j k m n x ph $.
    $d f i j k m n x A $.  $d f k m n x G $.  $d f k m n x M $.
    fsum.1 $e |- ( k = ( F ` n ) -> B = C ) $.
    fsum.2 $e |- ( ph -> M e. NN ) $.
    fsum.3 $e |- ( ph -> F : ( 1 ... M ) -1-1-onto-> A ) $.
    fsum.4 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    fsum.5 $e |- ( ( ph /\ n e. ( 1 ... M ) ) -> ( G ` n ) = C ) $.
    $( The value of a sum over a nonempty finite set.  (Contributed by Mario
       Carneiro, 20-Apr-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    fsum $p |- ( ph -> sum_ k e. A B = ( seq 1 ( + , G ) ` M ) ) $=
      ( vm cfv wcel c1 cn wceq vx vf vj vi csu cv cuz wss caddc cz cc0 cif cmpt
      cseq cli wbr wa wrex cfz co wf1o csb wex wo cio df-sum cvv fvex wb wmo wi
      nfcv nfv nfcsb1v nfif eleq1 csbeq1a eqidd ifbieq12d cbvmpt wral ralrimiva
      cc nfel1 eleq1d rspc mpan9 fveq2 csbeq1d csbco syl6eqr cbvmptv summo f1of
      weq wf syl ovex sylancl nnuz syl6eleq elfznn adantl syl6eqelr eqid fvmpt2
      fex syl2anc eqtr4d nffvmpt1 nfeq2 eqeq12d seqfveq jca f1oeq1 fveq1 csbief
      syl6eq mpteq2dv seqeq3d fveq1d eqeq2d anbi12d spcegv f1oeq2 exbidv rspcev
      sylc oveq2 olcd breq2 anbi2d rexbidv eqeq1 orbi12d moi2 mpanl1 syl5ibrcom
      ancom2s expr impbid adantr iota5 mpan2 syl5eq ) ABCEUEBOUFZUGPUHZUIEUJEUF
      ZBQZCUKULZUMZUUFUNZUAUFZUOUPZUQZOUJURZRUUFUSUTZBUBUFZVAZUUMUUFUIFSEFUFZUU
      RPZCVBZUMZRUNZPZTZUQZUBVCZOSURZVDZUAVEZIUIHRUNZPZUABCUBEOFVFAUVMVGQZUVKUV
      MTIUVLVHZAUVJUAUVMVGAUVJUUMUVMTZVIUVNAUVJUVPAUVJUAVJZUUGUULUVMUOUPZUQZOUJ
      URZUUSUVMUVETZUQZUBVCZOSURZVDZUVJUVPVKAUABEUCUFZCVBZUBUCOUDUUKUVCEUCUJUUJ
      UWFBQZUWGUKULUCUUJVLUWHEUWGUKUWHEVMEUWFCVNZEUKVLVOEUCWOZUUIUWHCUKUWGUKUUH
      UWFBVPEUWFCVQZUWJUKVRVSVTACWCQZEBWAUWHUWGWCQZAUWLEBMWBUWLUWMEUWFBEUWGWCUW
      IWDUWJCUWGWCUWKWEWFWGFUDSUVBUCUDUFZUURPZUWGVBZFUDWOZUVBEUWOCVBUWPUWQEUVAU
      WOCUUTUWNUURWHWIEUCUWOCWJWKWLWMAUWDUVTAISQRIUSUTZBUURVAZUVMIUVDPZTZUQZUBV
      CZUWDKAGVGQZUWRBGVAZUVMIUIFSDUMZRUNZPZTZUQZUXCAUWRBGWPZUWRVGQUXDAUXEUXKLU
      WRBGWNWQRIUSWRUWRBVGGXGWSAUXEUXILAUIEHUXFRIAISRUGPKWTXAAUUTHPZUUTUXFPZTZF
      UWRWAUUHUWRQUUHHPZUUHUXFPZTZAUXNFUWRAUUTUWRQZUQZUXLDUXMNUXSUUTSQZDVGQUXMD
      TUXRUXTAUUTIXBXCUXSDUXLVGNUUTHVHXDFSDVGUXFUXFXEXFXHXIWBUXNUXQFUUHUWRFUXOU
      XPFSDUUHXJXKFEWOUXLUXOUXMUXPUUTUUHHWHUUTUUHUXFWHXLWFWGXMXNUXBUXJUBGVGUURG
      TZUWSUXEUXAUXIUWRBUURGXOUYAUWTUXHUVMUYAIUVDUXGUYAUVCUXFUIRUYAFSUVBDUYAUVB
      EUUTGPZCVBDUYAEUVAUYBCUUTUURGXPWIEUYBCDUUTGVHEDVLJXQXRXSXTYAYBYCYDYHUWCUX
      COISUUFITZUWBUXBUBUYCUUSUWSUWAUXAUYCUUQUWRTUUSUWSVIUUFIRUSYIUUQUWRBUURYEW
      QUYCUVEUWTUVMUUFIUVDWHYBYCYFYGXHYJZUVQUWEUVJUVPUVQUVJUWEUVPUVNUVQUVJUWEUQ
      UVPUVOUVJUWEUAUVMVGUVPUUPUVTUVIUWDUVPUUOUVSOUJUVPUUNUVRUUGUUMUVMUULUOYKYL
      YMUVPUVHUWCOSUVPUVGUWBUBUVPUVFUWAUUSUUMUVMUVEYNYLYFYMYOZYPYQYSYTXHAUVJUVP
      UWEUYDUYEYRUUAUUBUUCUUDUUE $.
  $}

  $( Any sum over the empty set is zero.  (Contributed by Mario Carneiro,
     12-Aug-2013.)  (Revised by Mario Carneiro, 20-Apr-2014.) $)
  sum0 $p |- sum_ k e. (/) A = 0 $=
    ( c0 csu caddc c1 cuz cfv cc0 csn cli wceq wtru cn nnuz wcel 1z a1i ax-mp
    cc cxp cseq cz wss 0ss cv cif simpr syl6eleq c0ex fvconst2 syl noel iffalse
    wa wn syl6eqr pm2.21i adantl zsum trud wfun wbr fclim ffun serclim0 funbrfv
    cdm wf mp2 eqtri ) CABDZEFGHZIJUAZFUBZKHZIVLVPLMCABVNFNOFUCPZMQRCNUDMNUERMB
    UFZNPZUOZVRVNHZIVRCPZAIUGZVTVRVMPWAILVTVRNVMMVSUHOUIVMIVRUJUKULWBUPWCILVRUM
    ZWBAIUNSUQWBATPZMWBWEWDURUSUTVAKVBZVOIKVCZVPILKVHZTKVIWFVDWHTKVESVQWGQFVFSV
    OIKVGVJVK $.

  ${
    $d f k n A $.  $d k M $.
    $( Any sum of zero over a summable set is zero.  (Contributed by Mario
       Carneiro, 12-Aug-2013.)  (Revised by Mario Carneiro, 20-Apr-2014.) $)
    sumz $p |- ( ( A C_ ( ZZ>= ` M ) \/ A e. Fin ) -> sum_ k e. A 0 = 0 ) $=
      ( vf vn cuz cfv wss cc0 wceq wcel cz wa cli cv adantl cc c0 cn c1 csu cfn
      caddc csn cxp cseq eqid simpr cif c0ex fvconst2 ifid syl6eqr 0cn a1i zsum
      simpl wfun wbr cdm wf fclim ax-mp serclim0 funbrfv mpsyl eqtrd wn cpw uzf
      ffun fdmi eleq2i ndmfv sylnbir sseq2d biimpac ss0 sumeq1 sum0 syl6eq 3syl
      pm2.61dan chash cfz co wf1o wex wo fz1f1o eqidd elfznn syl fsum nnuz ser0
      adantr ex exlimdv imp jaoi ) ACFGZHZAIBUAZIJZAUBKZXCCLKZXEXCXGMZXDUCXBIUD
      ZUEZCUFZNGZIXHAIBXJCXBXBUGXCXGUHXCXGUQBOZXBKZXMXJGZXMAKZIIUIZJXHXNXOIXQXB
      IXMUJUKXPIULUMPIQKZXHXPMUNUOUPNURZXHXKINUSZXLIJNUTZQNVAXSVBYAQNVKVCXGXTXC
      CVDPXKINVEVFVGXCXGVHZMARHZARJZXEYBXCYCYBXBRAXGCFUTZKXBRJYELCLLVIFVJVLVMCF
      VNVOVPVQAVRYDXDRIBUAIARIBVSIBVTWAZWBWCXFYDAWDGZSKZTYGWEWFZADOZWGZDWHZMZWI
      XEADWJYDXEYMYFYHYLXEYHYKXEDYHYKXEYHYKMZXDYGUCSXIUEZTUFGZIYNAIIBEYJYOYGXME
      OZYJGJIWKYHYKUQYHYKUHXRYNXPMUNUOYQYIKZYQYOGIJZYNYRYQSKYSYQYGWLSIYQUJUKWMP
      WNYHYPIJYKTYGSWOWPWQVGWRWSWTXAWMXA $.
  $}

  ${
    $d f k m n A $.  $d f m n B $.  $d f m n C $.  $d f k m D $.  $d f m n F $.
    $d k G $.  $d f k m n ph $.
    fsumf1o.1 $e |- ( k = G -> B = D ) $.
    fsumf1o.2 $e |- ( ph -> C e. Fin ) $.
    fsumf1o.3 $e |- ( ph -> F : C -1-1-onto-> A ) $.
    fsumf1o.4 $e |- ( ( ph /\ n e. C ) -> ( F ` n ) = G ) $.
    fsumf1o.5 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( Re-index a finite sum using a bijection.  (Contributed by Mario
       Carneiro, 20-Apr-2014.) $)
    fsumf1o $p |- ( ph -> sum_ k e. A B = sum_ n e. C D ) $=
      ( vm c0 wceq csu cfv wcel vf chash cn c1 cfz co cv wf1o wex wa cc0 f1oeq2
      sum0 wfo syl5ibcom imp f1ofo fo00 simprbi sumeq1d simpr syl6eq 3eqtr4a ex
      3syl cmpt caddc ccom cseq fveq2 fveq2d simprl simprr cc wf f1of ffvelrnda
      eqid fmptd syldan adantlr adantr f1oco syl2anc fvco3 sylan ad2antll eqtrd
      syl fsum wral cid eqeltrrd fvmpti fvmpt2i adantl 3eqtr4rd ralrimiva nfeq1
      nffvmpt1 eqeq12d rspc mpan9 sumeq2dv sumfc 3eqtr3g exlimdv expimpd cfn wo
      expr fz1f1o mpjaod ) ADPQZBCFRZDEGRZQZDUBSZUCTZUDXRUEUFZDUAUGZUHZUAUIZUJZ
      AXNXQAXNUJZPCFRUKXOXPCFUMYEBPCFYEPBHUHZPBHUNZBPQZAXNYFADBHUHZXNYFLDPBHULU
      OUPPBHUQYGHPQYHBHURUSVEUTYEXPPEGRUKYEDPEGAXNVAUTEGUMVBVCVDAXSYCXQAXSUJYBX
      QUAAXSYBXQAXSYBUJZUJZBOUGZFBCVFZSZORZDYLGDEVFZSZORZXOXPYKDYLHSZYMSZORXRVG
      YMHYAVHZVHZUDVISYRYOYKDYTGUGZYASZHSZYMSZOGYAUUBXRYLUUDQYSUUEYMYLUUDHVJVKA
      XSYBVLZAXSYBVMZAYLDTZYTVNTZYJAUUIYSBTUUJADBYLHAYIDBHVOLDBHVPWIZVQABVNYSYM
      AFBCVNYMNYMVRZVSZVQVTWAYKUUCXTTZUJZUUCUUBSZUUCUUASZYMSZUUFYKXTBUUAVOZUUNU
      UPUURQYKXTBUUAUHZUUSYKYIYBUUTAYIYJLWBUUHXTDBHYAWCWDZXTBUUAVPWIXTBUUCYMUUA
      WEWFZUUOUUQUUEYMYKXTDYAVOZUUNUUQUUEQYBUVCAXSXTDYAVPWGXTDUUCHYAWEWFVKWHWJY
      KDYQYTOAUUIYQYTQZYJAUUCYPSZUUCHSZYMSZQZGDWKUUIUVDAUVHGDAUUCDTZUJZIYMSZEWL
      SZUVGUVEUVJIBTUVKUVLQUVJUVFIBMADBUUCHUUKVQWMFICEBYMJUULWNWIUVJUVFIYMMVKUV
      IUVEUVLQAGDEYPYPVRWOWPWQWRUVHUVDGYLDGYQYTGDEYLWTWSUUCYLQZUVEYQUVGYTUUCYLY
      PVJUVMUVFYSYMUUCYLHVJVKXAXBXCWAXDYKBYNUUROGUUAUUBXRYLUUQYMVJUUGUVAYKBVNYL
      YMABVNYMVOYJUUMWBVQUVBWJWQBCOFXEDEOGXEXFXKXGXHADXITXNYDXJKDUAXLWIXM $.
  $}

  ${
    $d f k m n x A $.  $d f k m n x B $.  $d f m n x C $.  $d f k m n ph $.
    $d k m x M $.
    sumss.1 $e |- ( ph -> A C_ B ) $.
    sumss.2 $e |- ( ( ph /\ k e. A ) -> C e. CC ) $.
    sumss.3 $e |- ( ( ph /\ k e. ( B \ A ) ) -> C = 0 ) $.
    ${
      sumss.4 $e |- ( ph -> B C_ ( ZZ>= ` M ) ) $.
      $( Change the index set to a subset in an upper integer sum.
         (Contributed by Mario Carneiro, 21-Apr-2014.) $)
      sumss $p |- ( ph -> sum_ k e. A C = sum_ k e. B C ) $=
        ( vm cz wcel wceq wa cfv cc0 adantr cc c0 csu cv cmpt caddc cuz cif cli
        cseq eqid simpr wss sstrd nfcv nffvmpt1 nfv nfif nfeq fveq2 eleq1 eqidd
        ifbieq12d eqeq12d fvmpt2i iftrue fveq2d sylan9eq eqtrd adantl eqtr4d wn
        cid iffalse 0z fvi ax-mp syl6eq pm2.61dan vtoclgaf fmptd ffvelrnda zsum
        wf nfim imbi2d adantll sselda syl ad2antrl cdif eldif 0cn sylan2br expr
        wi a1d imp expcom impcom adantlr syl6eqel pm2.61d sumfc 3eqtr3g cdm cpw
        ex uzf fdmi eleq2i ndmfv sylnbir sseq2d syl5ib ss0 sumeq1d ) AFLMZBDEUA
        ZCDEUAZNAXPOZBKUBZEBDUCZPZKUAZCXTECDUCZPZKUAZXQXRXSYCUDEFUEPZEUBZBMZDQU
        FZUCZFUHUGPYFXSBYBKYKFYGYGUIZAXPUJZABYGUKXPABCYGGJULRXTYGMZXTYKPZXTBMZY
        BQUFZNZXSYHYKPZYIYHYAPZQUFZNZYREXTYGEXTUMZEYOYQEYGYJXTUNZYPEYBQYPEUOEBD
        XTUNEQUMZUPUQYHXTNZYSYOUUAYQYHXTYKURZUUFYIYPYTQYBQYHXTBUSYHXTYAURUUFQUT
        ZVAVBYHYGMZYIUUBUUIYIOYSDVKPZUUAUUIYIYSYJVKPZUUJEYGYJYKYKUIVCZYIYJDVKYI
        DQVDVEVFZYIUUAUUJNUUIYIUUAYTUUJYIYTQVDEBDYAYAUIZVCVGVHVIUUIYIVJZOYSQUUA
        UUIUUOYSUUKQUULUUOUUKQVKPZQUUOYJQVKYIDQVLVEQLMUUPQNZVMQLVNVOVPVFZUUOUUA
        QNUUIYIYTQVLVHVIVQVRVHXSBSXTYAABSYAWBXPAEBDSYAHUUNVSRVTWAXSCYEKYKFYGYLY
        MACYGUKZXPJRAYNYOXTCMZYEQUFZNZXPYNAUVBAYSYHCMZYHYDPZQUFZNZWNAUVBWNEXTYG
        UUCAUVBEAEUOEYOUVAUUDUUTEYEQUUTEUOECDXTUNUUEUPUQWCUUFUVFUVBAUUFYSYOUVEU
        VAUUGUUFUVCUUTUVDQYEQYHXTCUSYHXTYDURUUHVAVBWDAUUIUVFAUUIOZYIUVFUVGYIOZY
        SUUJUVEUUIYIYSUUJNAUUMWEUVHUVCUVEUUJNZUVGBCYHABCUKZUUIGRWFUVCUVEUVDUUJU
        VCUVDQVDECDYDYDUIZVCVGZWGVIUVGUUOOYSQUVEUUIUUOYSQNAUURWEUVGUUOUVEQNZAUU
        OUVMWNZUUIAUVCUVNAUVCUUOUVMAUVCUUOOZOUVEUUJQUVCUVIAUUOUVLWHUVOAYHCBWIMZ
        UUJQNYHCBWJZAUVPOZUUJUUPQUVRDQVKIVEQSMUUQWKQSVNVOVPWLVGWMAUVCVJZOUVMUUO
        UVSUVMAUVCUVDQVLVHWOVQRWPVIVQWQVRWRWSXSCSXTYDACSYDWBXPAECDSYDAUVCOYIDSM
        ZAYIUVTWNUVCAYIUVTHXFRAUVCUUOUVTUVOAUVPUVTUVQUVRDQSIWKWTWLWMXAUVKVSRVTW
        AVIBDKEXBCDKEXBXCAXPVJZOZBCDEUWBBTCUWBBTUKBTNUWBBCTAUVJUWAGRUWAACTUKZAU
        USUWAUWCJUWAYGTCXPFUEXDZMYGTNUWDLFLLXEUEXGXHXIFUEXJXKXLXMWRZULBXNWGUWBU
        WCCTNUWECXNWGVIXOVQ $.
    $}

    fsumss.4 $e |- ( ph -> B e. Fin ) $.
    $( Change the index set to a subset in a finite sum.  (Contributed by Mario
       Carneiro, 21-Apr-2014.) $)
    fsumss $p |- ( ph -> sum_ k e. A C = sum_ k e. B C ) $=
      ( vm vn wceq csu cfv wcel c1 wa cc0 cc syl vf c0 chash cn cfz co wf1o wex
      cv wss adantr adantlr cdif cuz simpr 0ss syl6eqss sumss ex cmpt ccnv cima
      cdm cnvimass wf simprr fdm syl5sseq wfn wb ffn elpreima ffvelrnda adantrd
      f1of sylbid imp wi wn eldif 0cn syl6eqel sylan2br expr pm2.61d eqid fmptd
      syldan eldifi sylan2 eldifn adantl bitr4d mtbid eldifd difss resmpt ax-mp
      biantrurd cres fveq1i fvres syl5eqr csn c0ex elsnc2 sylibr ad2antrr elsni
      ffvelrnd eqtr3d fzssuz a1i fveq1d sumeq2dv fveq2 fzfid ssfi syl2anc f1of1
      cfn wf1 f1ores wfo f1ofo foimacnv f1oeq3 mpbid sselda fsumf1o eqtrd eqidd
      3eqtr4d sumfc 3eqtr3g exlimdv expimpd wo fz1f1o mpjaod ) ACUBLZBDEMZCDEMZ
      LZCUCNZUDOZPUUEUEUFZCUAUIZUGZUAUHZQZAUUAUUDAUUAQZBCDERABCUJZUUAFUKAEUIZBO
      ZDSOZUUAGULAUUNCBUMZOZDRLZUUAHULUULCUBRUNNZAUUAUOUUTUPUQURUSAUUFUUJUUDAUU
      FQUUIUUDUAAUUFUUIUUDAUUFUUIQZQZBJUIZEBDUTZNZJMZCUVCECDUTZNZJMZUUBUUCUVBUU
      HVABVBZKUIZUUHNZUVGNZKMZUUGUVMKMUVFUVIUVBUVJUUGUVMKPUVBUUHVCZUVJUUGUUHBVD
      UVBUUGCUUHVEZUVOUUGLUVBUUIUVPAUUFUUIVFZUUGCUUHVOTZUUGCUUHVGTVHZUVBUVKUVJO
      ZUVLCOZUVMSOUVBUVTUWAUVBUVTUVKUUGOZUVLBOZQZUWAUVBUUHUUGVIZUVTUWDVJZUVBUVP
      UWEUVRUUGCUUHVKTUUGUVKBUUHVLTZUVBUWBUWAUWCUVBUWBUWAUVBUUGCUVKUUHUVRVMZUSV
      NVPVQUVBCSUVLUVGACSUVGVEUVAAECDSUVGAUUNCOZQUUOUUPAUUOUUPVRUWIAUUOUUPGUSUK
      AUWIUUOVSZUUPUWIUWJQAUURUUPUUNCBVTAUURQZDRSHWAWBWCWDWEUVGWFWGUKZVMWHUVBUV
      KUUGUVJUMOZQZUVLEUUQDUTZNZUVMRUWNUVLUUQOZUWPUVMLUWNUVLCBUWMUVBUWBUWAUVKUU
      GUVJWIZUWHWJUWNUVTUWCUWMUVTVSUVBUVKUUGUVJWKWLUWNUVTUWDUWCUVBUWFUWMUWGUKUW
      NUWBUWCUWMUWBUVBUWRWLWSWMWNWOZUWQUWPUVLUVGUUQWTZNUVMUVLUWTUWOUUQCUJUWTUWO
      LCBWPECUUQDWQWRXAUVLUUQUVGXBXCTUWNUWPRXDZOUWPRLUWNUUQUXAUVLUWOAUUQUXAUWOV
      EUVAUWMAEUUQDUXAUWOUWKUUSDUXAOHDRXEXFXGUWOWFWGXHUWSXJUWPRXITXKUUGPUNNUJUV
      BPUUEXLXMURUVBUVFBUVHJMUVNUVBBUVEUVHJUVBUVCBOZQZUVCUVGBWTZNZUVEUVHUXCUVCU
      XDUVDUXCUUMUXDUVDLAUUMUVAUXBFXHECBDWQTXNUXBUXEUVHLUVBUVCBUVGXBWLXKXOUVBBU
      VHUVJUVMJKUUHUVJWTZUVLUVCUVLUVGXPZUVBUUGYAOUVJUUGUJZUVJYAOUVBPUUEXQZUVSUU
      GUVJXRXSUVBUVJUUHUVJVBZUXFUGZUVJBUXFUGZUVBUUGCUUHYBZUXHUXKUVBUUIUXMUVQUUG
      CUUHXTTUVSUUGCUVJUUHYCXSUVBUXJBLZUXKUXLVJUVBUUGCUUHYDZUUMUXNUVBUUIUXOUVQU
      UGCUUHYETAUUMUVAFUKZUUGCBUUHYFXSUXJBUVJUXFYGTYHUVTUVKUXFNUVLLUVBUVKUVJUUH
      XBWLUVBUXBUVCCOUVHSOUVBBCUVCUXPYIUVBCSUVCUVGUWLVMZWHYJYKUVBCUVHUUGUVMJKUU
      HUVLUXGUXIUVQUVBUWBQUVLYLUXQYJYMBDJEYNCDJEYNYOWDYPYQACYAOUUAUUKYRICUAYSTY
      T $.
  $}

  ${
    $d j k m A $.  $d j k m B $.  $d j m C $.  $d m M $.
    $( Change the index set of a sum by adding zeroes.  (Contributed by Mario
       Carneiro, 15-Jul-2013.)  (Revised by Mario Carneiro, 20-Apr-2014.) $)
    sumss2 $p |- ( ( ( A C_ B /\ A. k e. A C e. CC ) /\
                    ( B C_ ( ZZ>= ` M ) \/ B e. Fin ) ) ->
      sum_ k e. A C = sum_ k e. B if ( k e. A , C , 0 ) ) $=
      ( vm wss cc wcel wa cv cc0 cif csu wceq simpll simplr iftrue adantl sylan
      wral cuz cfv cfn wo nfcsb1v nfel1 csbeq1a eleq1d rspc impcom eqeltrd cdif
      csb wn eldifn iffalse syl simpr sumss fsumss jaodan sumeq2i nfcv nfv nfif
      eleq1 eqidd ifbieq12d cbvsumi eqtr3i 3eqtr4g ) ABGZCHIZDAUAZJZBEUBUCGZBUD
      IZUEJAFKZAIZDVSCUNZLMZFNZBWBFNZACDNZBDKZAIZCLMZDNVPVQWCWDOVRVPVQJZABWBFEV
      MVOVQPWIVOVTWBHIZVMVOVQQVOVTJWBWAHVTWBWAOVOVTWALRSVTVOWAHIZVNWKDVSADWAHDV
      SCUFZUGWFVSOZCWAHDVSCUHZUIUJUKULZTVSBAUMIZWBLOZWIWPVTUOWQVSBAUPVTWALUQURZ
      SVPVQUSUTVPVRJZABWBFVMVOVRPWSVOVTWJVMVOVRQWOTWPWQWSWRSVPVRUSVAVBAWHDNWEWC
      AWHCDWGCLRVCAWHWBDFFWHVDZVTDWALVTDVEWLDLVDVFZWMWGVTCLWALWFVSAVGWNWMLVHVIZ
      VJVKBWHWBDFWTXAXBVJVL $.
  $}

  ${
    $d k m n x A $.  $d m n x B $.  $d k n x F $.  $d k m N $.  $d k m n ph $.
    $d k m n M $.
    fsumsers.1 $e |- ( ( ph /\ k e. ( ZZ>= ` M ) ) ->
                       ( F ` k ) = if ( k e. A , B , 0 ) ) $.
    fsumsers.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fsumsers.3 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    fsumsers.4 $e |- ( ph -> A C_ ( M ... N ) ) $.
    $( The sequence of partial sums of a finite sum converges to the whole
       sum.  (Contributed by Mario Carneiro, 20-Apr-2014.) $)
    fsumcvg2 $p |- ( ph -> seq M ( + , F ) ~~> ( seq M ( + , F ) ` N ) ) $=
      ( vm caddc cz cv wcel cc0 cfv wceq cc cif cmpt cseq cli csb nfcv nfv nfif
      vn nfcsb1v eleq1 csbeq1a eqidd ifbieq12d cbvmpt wral ralrimiva nfel1 rspc
      eleq1d mpan9 fsumcvg cuz eluzel2 wa eluzelz iftrue adantl eqeltrd iffalse
      syl ex wn 0cn syl6eqel pm2.61d1 eqid fvmpt2 syl2anr eqtr4d nffvmpt1 nfeq2
      fveq2 eqeq12d seqfeq fveq1d 3brtr4d ) AMDNDOZBPZCQUAZUBZFUCZGWLRMEFUCZGWM
      RUDABDLOZCUEZLWKFGDLNWJWNBPZWOQUALWJUFWPDWOQWPDUGDWNCUJZDQUFUHWHWNSZWIWPC
      QWOQWHWNBUKDWNCULZWRQUMUNUOACTPZDBUPWPWOTPZAWTDBJUQWTXADWNBDWOTWQURWRCWOT
      WSUTUSVAIKVBAMUIEWKFAGFVCRZPFNPIFGVDVKAWHERZWHWKRZSZDXBUPUIOZXBPXFERZXFWK
      RZSZAXEDXBAWHXBPZVEXCWJXDHXJWHNPWJTPZXDWJSAFWHVFAWIXKAWIXKAWIVEWJCTWIWJCS
      AWICQVGVHJVIVLWIVMWJQTWICQVJVNVOVPDNWJTWKWKVQVRVSVTUQXEXIDXFXBDXGXHDNWJXF
      WAWBWHXFSXCXGXDXHWHXFEWCWHXFWKWCWDUSVAWEZAGWMWLXLWFWG $.

    $( Special case of series sum over a finite upper integer index set.
       (Contributed by Mario Carneiro, 26-Jul-2013.)  (Revised by Mario
       Carneiro, 21-Apr-2014.) $)
    fsumsers $p |- ( ph -> sum_ k e. A B = ( seq M ( + , F ) ` N ) ) $=
      ( csu caddc cseq cli cfv cuz eqid wcel cc cz eluzel2 syl co fzssuz syl6ss
      cfz zsum wfun wbr wceq cdm fclim ffun ax-mp fsumcvg2 funbrfv mpsyl eqtrd
      wf ) ABCDLMEFNZOPZGVAPZABCDEFFQPZVDRAGVDSFUASIFGUBUCABFGUGUDVDKFGUEUFHJUH
      OUIZAVAVCOUJVBVCUKOULZTOUTVEUMVFTOUNUOABCDEFGHIJKUPVAVCOUQURUS $.
  $}

  ${
    $d k n A $.  $d k n F $.  $d k n M $.  $d k n ph $.
    fsumcvg3.1 $e |- Z = ( ZZ>= ` M ) $.
    fsumcvg3.2 $e |- ( ph -> M e. ZZ ) $.
    fsumcvg3.3 $e |- ( ph -> A e. Fin ) $.
    fsumcvg3.4 $e |- ( ph -> A C_ Z ) $.
    fsumcvg3.5 $e |- ( ( ph /\ k e. Z ) ->
                       ( F ` k ) = if ( k e. A , B , 0 ) ) $.
    fsumcvg3.6 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( A finite sum is convergent.  (Contributed by Mario Carneiro,
       24-Apr-2014.) $)
    fsumcvg3 $p |- ( ph -> seq M ( + , F ) e. dom ~~> ) $=
      ( vn cfz wss wcel c0 wceq cr cv caddc cseq cli cdm cuz wrex sseq1 rexbidv
      co cfv wne wa clt csup adantr syl6sseq wor cfn w3a ltso simpr uzssz zssre
      cz sstri eqsstri syl6ss 3jca fisupcl sylancr sseldd cle wbr wral fimaxre2
      syl2anc suprub sylan wb sselda sseldi elfz5 mpbird ex ssrdv sseq2d rspcev
      oveq2 uzid syl 0ss sylancl pm2.61ne cc0 eleq2i sylan2br adantlr simprl cc
      cif simprr fsumcvg2 climrel releldmi rexlimddv ) ABFNUAZOUJZPZUBEFUCZUDUE
      QZNFUFUKZAXINXLUGZRXHPZNXLUGZBRBRSXIXNNXLBRXHUHUIABRULZUMZBTUNUOZXLQBFXRO
      UJZPZXMXQBXLXRXQBGXLABGPXPKUPZHUQZXQTUNURBUSQZXPBTPZUTXRBQVAXQYCXPYDAYCXP
      JUPZAXPVBZXQBGTYAGXLTHXLVETFVCZVDVFVGVHZVITBUNVJVKVLZXQDBXSXQDUAZBQZYJXSQ
      ZXQYKUMZYLYJXRVMVNZXQYDXPXGYJVMVNNBVODTUGZUTYKYNXQYDXPYOYHYFXQYDYCYOYHYED
      NBVPVQVIDNBYJVRVSYMYJXLQZXRVEQZYLYNVTXQBXLYJYBWAXQYQYKXQXLVEXRYGYIWBUPYJF
      XRWCVQWDWEWFXIXTNXRXLXGXRSXHXSBXGXRFOWIWGWHVQAFXLQZRFFOUJZPZXOAFVEQYRIFWJ
      WKYSWLXNYTNFXLXGFSXHYSRXGFFOWIWGWHWMWNAXGXLQZXIUMZUMZXJXGXJUKZUDVNXKUUCBC
      DEFXGAYPYJEUKYKCWOXASZUUBYPAYJGQUUEGXLYJHWPLWQWRAUUAXIWSAYKCWTQUUBMWRAUUA
      XIXBXCXJUUDUDXDXEWKXF $.
  $}

  ${
    $d k m F $.  $d k m M $.  $d k m N $.  $d k ph $.
    fsumser.1 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) = A ) $.
    fsumser.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fsumser.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    $( A finite sum expressed in terms of a partial sum of an infinite series.
       The recursive definition of follows as ~ fsum1 and ~ fsump1i , which
       should make our notation clear and from which, along with closure
       ~ fsumcl , we will derive the basic properties of finite sums.
       (Contributed by NM, 11-Dec-2005.)  (Revised by Mario Carneiro,
       21-Apr-2014.) $)
    fsumser $p |- ( ph -> sum_ k e. ( M ... N ) A =
                          ( seq M ( + , F ) ` N ) ) $=
      ( vm cfz caddc cfv cv wcel cc0 cif cseq wceq eqtrd co csu cuz eleq1 fveq2
      cmpt eqidd ifbieq12d eqid fvex c0ex ifex fvmpt ifeq1da sylan9eqr wss ssid
      a1i fsumsers elfzuz syl iftrue adantl seqfveq ) AEFKUAZBCUBFLJEUCMZJNZVEO
      ZVGDMZPQZUFZERMFLDERMAVEBCVKEFCNZVFOZAVLVKMZVLVEOZVLDMZPQZVOBPQJVLVJVQVFV
      KVGVLSZVHVOVIPVPPVGVLVEUDVGVLDUEVRPUGUHVKUIVOVPPVLDUJUKULUMZAVOVPBPGUNUOH
      IVEVEUPAVEUQURUSALCVKDEFHVOVNVPSAVOVNVQVPVOVMVNVQSVLEFUTVSVAVOVPPVBTVCVDT
      $.
  $}

  ${
    $d f k m x y A $.  $d f m x y B $.  $d f k m x y ph $.  $d f k x y S $.
    fsumcllem.1 $e |- ( ph -> S C_ CC ) $.
    fsumcllem.2 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x + y ) e. S ) $.
    fsumcllem.3 $e |- ( ph -> A e. Fin ) $.
    fsumcllem.4 $e |- ( ( ph /\ k e. A ) -> B e. S ) $.
    ${
      fsumcl2lem.5 $e |- ( ph -> A =/= (/) ) $.
      $( - Lemma for finite sum closures.  (The "-" before "Lemma" forces the
         math content to be displayed in the Statement List - NM 11-Feb-2008.)
         (Contributed by Mario Carneiro, 3-Jun-2014.) $)
      fsumcl2lem $p |- ( ph -> sum_ k e. A B e. S ) $=
        ( vf vm c0 wcel cfv c1 cv wa wceq csu chash cn cfz co wf1o wex necon4bd
        wne wn a1d caddc cmpt ccom sumfc fveq2 simprl simprr cc wss ad2antrr wf
        cseq eqid fmptd adantr ffvelrnda sseldd f1of syl fvco3 fsum syl5eqr cuz
        sylan nnuz syl6eleq fco syl2anc adantlr eqeltrd expr exlimdv expimpd wo
        seqcl cfn fz1f1o mpjaod ) ADOUAZDEGUBZFPZDUCQZUDPZRWNUEUFZDMSZUGZMUHZTZ
        AWMDOADOUJWMUKLULUIAWOWSWMAWOTWRWMMAWOWRWMAWOWRTZTZWLWNUMGDEUNZWQUOZRVD
        QZFXBWLDNSZXCQZNUBXEDENGUPXBDXGBSZWQQZXCQZNBWQXDWNXFXIXCUQAWOWRURZAWOWR
        USZXBXFDPZTFUTXGAFUTVAXAXMHVBXBDFXFXCADFXCVCZXAAGDEFXCKXCVEVFVGZVHVIXBW
        PDWQVCZXHWPPXHXDQXJUAXBWRXPXLWPDWQVJVKZWPDXHXCWQVLVPVMVNXBBCUMFXDRWNXBW
        NUDRVOQXKVQVRXBWPFXHXDXBXNXPWPFXDVCXOXQWPDFXCWQVSVTVHAXHFPCSZFPTXHXRUMU
        FFPXAIWAWGWBWCWDWEADWHPWKWTWFJDMWIVKWJ $.
    $}

    fsumcllem.5 $e |- ( ph -> 0 e. S ) $.
    $( - Lemma for finite sum closures.  (The "-" before "Lemma" forces the
       math content to be displayed in the Statement List - NM 11-Feb-2008.)
       (Contributed by NM, 9-Nov-2005.)  (Revised by Mario Carneiro,
       3-Jun-2014.) $)
    fsumcllem $p |- ( ph -> sum_ k e. A B e. S ) $=
      ( csu wcel c0 wa cc0 simpr adantr cv wceq sumeq1d sum0 syl6eq eqeltrd wne
      cc wss caddc co adantlr cfn fsumcl2lem pm2.61dane ) ADEGMZFNDOADOUAZPZUOQ
      FUQUOOEGMQUQDOEGAUPRUBEGUCUDAQFNUPLSUEADOUFZPBCDEFGAFUGUHURHSABTZFNCTZFNP
      USUTUIUJFNURIUKADULNURJSAGTDNEFNURKUKAURRUMUN $.
  $}

  ${
    $d k x y A $.  $d x y B $.  $d k x y ph $.
    fsumcl.1 $e |- ( ph -> A e. Fin ) $.
    ${
      fsumcl.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
      $( Closure of a finite sum of complex numbers ` A ( k ) ` .  (Contributed
         by NM, 9-Nov-2005.)  (Revised by Mario Carneiro, 22-Apr-2014.) $)
      fsumcl $p |- ( ph -> sum_ k e. A B e. CC ) $=
        ( vx vy cc wss ssid a1i cv wcel wa caddc co addcl adantl cc0 fsumcllem
        0cn ) AGHBCIDIIJAIKLGMZINHMZINOUCUDPQINAUCUDRSEFTINAUBLUA $.
    $}

    ${
      fsumrecl.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
      $( Closure of a finite sum of reals.  (Contributed by NM, 9-Nov-2005.)
         (Revised by Mario Carneiro, 22-Apr-2014.) $)
      fsumrecl $p |- ( ph -> sum_ k e. A B e. RR ) $=
        ( vx vy cr cc wss ax-resscn a1i cv wcel wa caddc co readdcl adantl cc0
        0re fsumcllem ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUAIOAUBMUC $.
    $}

    ${
      fsumzcl.2 $e |- ( ( ph /\ k e. A ) -> B e. ZZ ) $.
      $( Closure of a finite sum of integers.  (Contributed by NM,
         9-Nov-2005.)  (Revised by Mario Carneiro, 22-Apr-2014.) $)
      fsumzcl $p |- ( ph -> sum_ k e. A B e. ZZ ) $=
        ( vx vy cz cc wss zsscn a1i cv wcel wa caddc co zaddcl adantl fsumcllem
        cc0 0z ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUBIOAUCMUA $.
    $}

    ${
      fsumnn0cl.2 $e |- ( ( ph /\ k e. A ) -> B e. NN0 ) $.
      $( Closure of a finite sum of nonnegative integers.  (Contributed by
         Mario Carneiro, 23-Apr-2015.) $)
      fsumnn0cl $p |- ( ph -> sum_ k e. A B e. NN0 ) $=
        ( vx vy cn0 cc wss nn0sscn a1i cv wcel wa caddc co nn0addcl adantl 0nn0
        cc0 fsumcllem ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUBIOAUAMUC $.
    $}

    fsumrpcl.2 $e |- ( ph -> A =/= (/) ) $.
    fsumrpcl.3 $e |- ( ( ph /\ k e. A ) -> B e. RR+ ) $.
    $( Closure of a finite sum of positive reals.  (Contributed by Mario
       Carneiro, 3-Jun-2014.) $)
    fsumrpcl $p |- ( ph -> sum_ k e. A B e. RR+ ) $=
      ( vx vy crp cc wss cr rpssre ax-resscn sstri a1i cv wcel wa caddc rpaddcl
      co adantl fsumcl2lem ) AHIBCJDJKLAJMKNOPQHRZJSIRZJSTUFUGUAUCJSAUFUGUBUDEG
      FUE $.
  $}

  ${
    $d f k m n x A $.  $d f m n x B $.  $d f m n x C $.  $d f k m n ph $.
    fsumadd.1 $e |- ( ph -> A e. Fin ) $.
    fsumadd.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    fsumadd.3 $e |- ( ( ph /\ k e. A ) -> C e. CC ) $.
    $( The sum of two finite sums.  (Contributed by NM, 14-Nov-2005.)  (Revised
       by Mario Carneiro, 22-Apr-2014.) $)
    fsumadd $p |- ( ph -> sum_ k e. A ( B + C ) =
                        ( sum_ k e. A B + sum_ k e. A C ) ) $=
      ( vm c0 wceq caddc co csu cfv wcel c1 wa cc ffvelrnda vf vn chash cn wf1o
      cfz cv wex cc0 00id sum0 oveq12i 3eqtr4ri sumeq1 oveq12d 3eqtr4a a1i cmpt
      wi ccom cseq cuz simprl nnuz syl6eleq wf adantlr eqid simprr f1of syl fco
      fmptd syl2anc wral cvv ovex fvmpt2 mpan2 adantl eqtr4d ralrimiva ad2antrr
      simpr nffvmpt1 nfcv nfov nfeq fveq2 eqeq12d rspc sylc fvco3 sylan 3eqtr4d
      seradd addcld fsum sumfc 3eqtr3g expr exlimdv expimpd cfn fz1f1o mpjaod
      wo ) ABJKZBCDLMZENZBCENZBDENZLMZKZBUCOZUDPZQXOUFMZBUAUGZUEZUAUHZRZXHXNUSA
      XHJXIENZJCENZJDENZLMZXJXMUIUILMUIYEYBUJYCUIYDUILCEUKDEUKULXIEUKUMBJXIEUNX
      HXKYCXLYDLBJCEUNBJDEUNUOUPUQAXPXTXNAXPRXSXNUAAXPXSXNAXPXSRZRZBIUGZEBXIURZ
      OZINZBYHEBCURZOZINZBYHEBDURZOZINZLMZXJXMYGXOLYIXRUTZQVAOXOLYLXRUTZQVAOZXO
      LYOXRUTZQVAOZLMYKYRYGUBYTUUBYSQXOYGXOUDQVBOAXPXSVCZVDVEYGXQSUBUGZYTYGBSYL
      VFXQBXRVFZXQSYTVFYGEBCSYLAEUGZBPZCSPZYFGVGZYLVHZVMZYGXSUUFAXPXSVIZXQBXRVJ
      VKZXQBSYLXRVLVNTYGXQSUUEUUBYGBSYOVFUUFXQSUUBVFYGEBDSYOAUUHDSPZYFHVGZYOVHZ
      VMZUUNXQBSYOXRVLVNTYGUUEXQPZRZUUEXROZYIOZUVAYLOZUVAYOOZLMZUUEYSOZUUEYTOZU
      UEUUBOZLMUUTUVABPUUGYIOZUUGYLOZUUGYOOZLMZKZEBVOZUVBUVEKZYGXQBUUEXRUUNTAUV
      NYFUUSAUVMEBAUUHRZUVIXIUVLUUHUVIXIKZAUUHXIVPPUVQCDLVQEBXIVPYIYIVHZVRVSVTU
      VPUVJCUVKDLUVPUUHUUIUVJCKAUUHWDZGEBCSYLUUKVRVNUVPUUHUUOUVKDKUVSHEBDSYOUUQ
      VRVNUOWAWBWCUVMUVOEUVABEUVBUVEEBXIUVAWEEUVCUVDLEBCUVAWEELWFEBDUVAWEWGWHUU
      GUVAKZUVIUVBUVLUVEUUGUVAYIWIUVTUVJUVCUVKUVDLUUGUVAYLWIUUGUVAYOWIUOWJWKWLY
      GUUFUUSUVFUVBKUUNXQBUUEYIXRWMWNZUUTUVGUVCUVHUVDLYGUUFUUSUVGUVCKUUNXQBUUEY
      LXRWMWNZYGUUFUUSUVHUVDKUUNXQBUUEYOXRWMWNZUOWOWPYGBYJUVBIUBXRYSXOYHUVAYIWI
      UUDUUMYGBSYHYIYGEBXISYIYGUUHRCDUUJUUPWQUVRVMTUWAWRYGYNUUAYQUUCLYGBYMUVCIU
      BXRYTXOYHUVAYLWIUUDUUMYGBSYHYLUULTUWBWRYGBYPUVDIUBXRUUBXOYHUVAYOWIUUDUUMY
      GBSYHYOUURTUWCWRUOWOBXIIEWSYNXKYQXLLBCIEWSBDIEWSULWTXAXBXCABXDPXHYAXGFBUA
      XEVKXF $.
  $}

  ${
    $d k A $.  $d k B $.  $d k ph $.  $d k U $.
    fsumsplit.1 $e |- ( ph -> ( A i^i B ) = (/) ) $.
    fsumsplit.2 $e |- ( ph -> U = ( A u. B ) ) $.
    fsumsplit.3 $e |- ( ph -> U e. Fin ) $.
    fsumsplit.4 $e |- ( ( ph /\ k e. U ) -> C e. CC ) $.
    $( Split a sum into two parts.  (Contributed by Mario Carneiro,
       18-Aug-2013.)  (Revised by Mario Carneiro, 22-Apr-2014.) $)
    fsumsplit $p |- ( ph -> sum_ k e. U C =
                          ( sum_ k e. A C + sum_ k e. B C ) ) $=
      ( csu caddc co wcel cc0 wss cc wceq syldan wa cv cif wral cuz cfv cfn cun
      wo ssun1 syl5sseqr sselda ralrimiva olcd sumss2 syl21anc oveq12d 0cn ifcl
      ssun2 sylancl fsumadd eleq2d elun syl6bb biimpa iftrue adantl wn noel cin
      wi elin syl5rbbr mtbii imnan sylibr imp iffalse syl addid1d eqtrd addid2d
      c0 con2d jaodan sumeq2dv 3eqtr2rd ) ABDFKZCDFKZLMEFUAZBNZDOUBZFKZEWJCNZDO
      UBZFKZLMEWLWOLMZFKEDFKAWHWMWIWPLABEPDQNZFBUCEOUDUEPZEUFNZUHZWHWMRABCUGZBE
      BCUIHUJZAWRFBAWKWJENZWRABEWJXCUKJSZULAWTWSIUMZBEDFOUNUOACEPWRFCUCXAWIWPRA
      XBCECBUSHUJZAWRFCAWNXDWRACEWJXGUKJSZULXFCEDFOUNUOUPAEWLWOFIAXDTZWROQNZWLQ
      NJUQWKDOQURUTXIWRXJWOQNJUQWNDOQURUTVAAEWQDFAXDWKWNUHZWQDRZAXDXKAXDWJXBNXK
      AEXBWJHVBWJBCVCVDVEAWKXLWNAWKTZWQDOLMDXMWLDWOOLWKWLDRAWKDOVFVGXMWNVHZWOOR
      AWKXNAWKWNTZVHWKXNVKAWJWCNZXOWJVIXOWJBCVJZNAXPWJBCVLAXQWCWJGVBVMVNWKWNVOV
      PZVQWNDOVRVSUPXMDXEVTWAAWNTZWQODLMDXSWLOWODLXSWKVHZWLORAWNXTAWKWNXRWDVQWK
      DOVRVSWNWODRAWNDOVFVGUPXSDXHWBWAWESWFWG $.
  $}

  ${
    $d j m n A $.  $d j k m n B $.  $d j k m n M $.  $d j k m n V $.
    fsum1.1 $e |- ( k = M -> A = B ) $.
    $( A sum of a singleton is the term.  (Contributed by Mario Carneiro,
       22-Apr-2014.) $)
    sumsn $p |- ( ( M e. V /\ B e. CC ) -> sum_ k e. { M } A = B ) $=
      ( vm vn wcel cc wa csn csu c1 cfv csb cn 1nn sylancr wceq caddc cseq nfcv
      cop cv nfcsb1v csbeq1a cbvsumi csbeq1 a1i wf1o co simpl f1osng cz wb fzsn
      cfz f1oeq2 mp2b sylibr elsni adantl csbeq1d nfcvd csbiegf ad2antrr simplr
      1z eqeltrd elfz1eq fveq2d fvsng sylan9eqr simpr 3eqtr4rd fsum seq1i eqtrd
      syl5eq ) DEIZBJIZKZDLZACMZNUANBUDLZNUBOZBWCWEWDCGUEZAPZGMWGWDAWICGGAUCCWH
      AUFCWHAUGUHWCWDWICHUEZNDUDLZOZAPZGHWKWFNCWHWLAUINQIZWCRUJWCNLZWDWKUKZNNUR
      ULZWDWKUKZWCWNWAWPRWAWBUMZNDQEUNSNUOIWQWOTWRWPUPVINUQWQWOWDWKUSUTVAWCWHWD
      IZKZWICDAPZJXACWHDAWTWHDTWCWHDVBVCVDXAXBBJWAXBBTZWBWTCDABEWACBVEFVFZVGWAW
      BWTVHVJVJWCWJWQIZKZXBBWMWJWFOZWAXCWBXEXDVGXFCWLDAXEWCWLNWKOZDXEWJNWKWJNVK
      ZVLWCWNWAXHDTRWSNDQEVMSVNVDXEWCXGNWFOZBXEWJNWFXIVLWCWNWBXJBTRWAWBVONBQJVM
      SZVNVPVQVTWCBUAWFNVIXKVRVS $.

    $( The finite sum of ` A ( k ) ` from ` k = M ` to ` M ` (i.e. a sum with
       only one term) is ` B ` i.e. ` A ( M ) ` .  (Contributed by NM,
       8-Nov-2005.)  (Revised by Mario Carneiro, 21-Apr-2014.) $)
    fsum1 $p |- ( ( M e. ZZ /\ B e. CC ) -> sum_ k e. ( M ... M ) A = B ) $=
      ( cz wcel cc wa cfz co csu csn wceq fzsn adantr sumeq1d sumsn eqtrd ) DFG
      ZBHGZIZDDJKZACLDMZACLBUBUCUDACTUCUDNUADOPQABCDFERS $.
  $}

  ${
    $d n x A $.  $d k n x M $.  $d n V $.
    $( A sum of a singleton is the term.  (Contributed by Mario Carneiro,
       22-Apr-2014.) $)
    sumsns $p |- ( ( M e. V /\ [_ M / k ]_ A e. CC ) ->
                   sum_ k e. { M } A = [_ M / k ]_ A ) $=
      ( vn wcel csb cc wa csn csu cv nfcv nfcsb1v csbeq1a cbvsumi csbeq1 syl5eq
      sumsn ) CDFBCAGZHFICJZABKUABELZAGZEKTUAAUCBEEAMBUBANBUBAOPUCTECDBUBCAQSR
      $.
  $}

  ${
    $d k B $.  $d k M $.  $d k N $.  $d k ph $.
    fsumm1.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fsumm1.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    ${
      fsumm1.3 $e |- ( k = N -> A = B ) $.
      $( Separate out the last term in a finite sum.  (Contributed by Mario
         Carneiro, 26-Apr-2014.) $)
      fsumm1 $p |- ( ph -> sum_ k e. ( M ... N ) A =
                         ( sum_ k e. ( M ... ( N - 1 ) ) A + B ) ) $=
        ( cfz co csu c1 caddc cz wcel wceq cuz syl cc cmin csn cin eluzelz fzsn
        cfv ineq2d clt wbr zred ltm1d fzdisj eqtr3d cun eluzel2 peano2zm ax-1cn
        zcnd npcan sylancl fveq2d eleqtrrd eluzp1m1 syl2anc fzsuc2 oveq2d sneqd
        c0 uneq2d fzfid fsumsplit eluzfz2 ralrimiva cv eleq1d rspcv sumsn eqtrd
        wral sylc ) AEFJKZBDLEFMUAKZJKZBDLZFUBZBDLZNKWDCNKAWCWEBWADAWCFFJKZUCZW
        CWEUCVHAWGWEWCAFOPZWGWEQAFERUFZPZWIGEFUDSZFUESUGAWBFUHUIWHVHQAFAFWLUJUK
        EWBFFULSUMAWCWBMNKZUBZUNZWAWCWEUNAEWMJKZWOWAAEOPZWBEMUAKZRUFPZWPWOQAWKW
        QGEFUOSZAWROPZFWRMNKZRUFZPWSAWQXAWTEUPSAFWJXCGAXBERAETPMTPZXBEQAEWTURUQ
        EMUSUTVAVBWRFVCVDEWBVEVDAWMFEJAFTPXDWMFQAFWLURUQFMUSUTZVFUMAWNWEWCAWMFX
        EVGVIUMAEFVJHVKAWFCWDNAWKCTPZWFCQGAFWAPZBTPZDWAVSXFAWKXGGEFVLSAXHDWAHVM
        XHXFDFWADVNFQBCTIVOVPVTBCDFWJIVQVDVFVR $.

      $( Separate out the last term in a finite sum.  (Contributed by Mario
         Carneiro, 13-Apr-2016.) $)
      fzosump1 $p |- ( ph -> sum_ k e. ( M ..^ ( N + 1 ) ) A =
                           ( sum_ k e. ( M ..^ N ) A + B ) ) $=
        ( cfzo co csu caddc c1 cmin cfz wcel wceq syl sumeq1d cz cuz cfv fzoval
        eluzelz oveq1d fsumm1 fzval3 3eqtr2rd ) AEFJKZBDLZCMKEFNOKPKZBDLZCMKEFP
        KZBDLEFNMKJKZBDLAUKUMCMAUJULBDAFUAQZUJULRAFEUBUCQUPGEFUESZEFUDSTUFABCDE
        FGHIUGAUNUOBDAUPUNUORUQEFUHSTUI $.
    $}

    fsum1p.3 $e |- ( k = M -> A = B ) $.
    $( Separate out the first term in a finite sum.  (Contributed by NM,
       3-Jan-2006.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    fsum1p $p |- ( ph -> sum_ k e. ( M ... N ) A =
                       ( B + sum_ k e. ( ( M + 1 ) ... N ) A ) ) $=
      ( cfz co csu caddc cin c0 cz wcel wceq syl cc csn c1 cuz cfv eluzel2 fzsn
      ineq1d clt wbr ltp1d fzdisj eqtr3d cun eluzfz1 fzsplit uneq1d eqtrd fzfid
      zred fsumsplit wral ralrimiva cv eleq1d rspcv sylc sumsn syl2anc oveq1d )
      AEFJKZBDLEUAZBDLZEUBMKZFJKZBDLZMKCVOMKAVKVNBVJDAEEJKZVNNZVKVNNOAVPVKVNAEP
      QZVPVKRAFEUCUDQZVRGEFUESZEUFSZUGAEVMUHUIVQORAEAEVTUSUJEEVMFUKSULAVJVPVNUM
      ZVKVNUMAEVJQZVJWBRAVSWCGEFUNSZEEFUOSAVPVKVNWAUPUQAEFURHUTAVLCVOMAVRCTQZVL
      CRVTAWCBTQZDVJVAWEWDAWFDVJHVBWFWEDEVJDVCERBCTIVDVEVFBCDEPIVGVHVIUQ $.
  $}

  ${
    $d k B $.  $d k M $.  $d k N $.  $d k ph $.
    fsump1.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fsump1.2 $e |- ( ( ph /\ k e. ( M ... ( N + 1 ) ) ) -> A e. CC ) $.
    fsump1.3 $e |- ( k = ( N + 1 ) -> A = B ) $.
    $( The addition of the next term in a finite sum of ` A ( k ) ` is the
       current term plus ` B ` i.e. ` A ( N + 1 ) ` .  (Contributed by NM,
       4-Nov-2005.)  (Revised by Mario Carneiro, 21-Apr-2014.) $)
    fsump1 $p |- ( ph -> sum_ k e. ( M ... ( N + 1 ) ) A =
                       ( sum_ k e. ( M ... N ) A + B ) ) $=
      ( c1 caddc co cfz csu cmin cuz cfv wcel syl cc peano2uz fsumm1 cz eluzelz
      wceq zcnd ax-1cn pncan sylancl oveq2d sumeq1d oveq1d eqtrd ) AEFJKLZMLBDN
      EUNJOLZMLZBDNZCKLEFMLZBDNZCKLABCDEUNAFEPQZRZUNUTRGEFUASHIUBAUQUSCKAUPURBD
      AUOFEMAFTRJTRUOFUEAFAVAFUCRGEFUDSUFUGFJUHUIUJUKULUM $.
  $}

  ${
    $d k F $.  $d k M $.  $d k ph $.  $d k Z $.
    isumclim.1 $e |- Z = ( ZZ>= ` M ) $.
    isumclim.2 $e |- ( ph -> M e. ZZ ) $.
    isumclim.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumclim.4 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    ${
      isumclim.6 $e |- ( ph -> seq M ( + , F ) ~~> B ) $.
      $( An infinite sum equals the value its series converges to.
         (Contributed by NM, 25-Dec-2005.)  (Revised by Mario Carneiro,
         23-Apr-2014.) $)
      isumclim $p |- ( ph -> sum_ k e. Z A = B ) $=
        ( csu caddc cseq cli cfv isum wfun cc wbr wceq fclim ffun ax-mp funbrfv
        cdm wf mpsyl eqtrd ) AGBDMNEFOZPQZCABDEFGHIJKRPSZAUKCPUAULCUBPUGZTPUHUM
        UCUNTPUDUELUKCPUFUIUJ $.
    $}

    isumclim2.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( A converging series converges to its infinite sum.  (Contributed by NM,
       2-Jan-2006.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    isumclim2 $p |- ( ph -> seq M ( + , F ) ~~> sum_ k e. Z A ) $=
      ( caddc cseq cli cfv csu cdm wcel wbr climdm sylib isum breqtrrd ) ALDEMZ
      UDNOZFBCPNAUDNQRUDUENSKUDTUAABCDEFGHIJUBUC $.
  $}

  ${
    $d j m x A $.  $d j k m x M $.  $d j k m x ph $.  $d j k m x Z $.
    $d j x F $.
    isumclim3.1 $e |- Z = ( ZZ>= ` M ) $.
    isumclim3.2 $e |- ( ph -> M e. ZZ ) $.
    isumclim3.3 $e |- ( ph -> F e. dom ~~> ) $.
    isumclim3.4 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    isumclim3.5 $e |- ( ( ph /\ j e. Z ) ->
                        ( F ` j ) = sum_ k e. ( M ... j ) A ) $.
    $( The sequence of partial finite sums of a converging infinite series
       converge to the infinite sum of the series.  Note that ` j ` must not
       occur in ` A ` .  (Contributed by NM, 9-Jan-2006.)  (Revised by Mario
       Carneiro, 23-Apr-2014.) $)
    isumclim3 $p |- ( ph -> F ~~> sum_ k e. Z A ) $=
      ( vm vx cli cfv csu wcel wbr cv cdm climdm sylib caddc cmpt cseq sumfc wa
      eqidd cc eqid fmptd ffvelrnda isum syl5eqr cio cvv seqex a1i cfz cres wss
      wceq cuz fzssuz sseqtr4i resmpt ax-mp fveq1i fvres syl5reqr sumeq2i eqtri
      simpr syl6eleq simpl elfzuz syl6eleqr syl2an eqtr2d climeq iotabidv df-fv
      co fsumser 3eqtr4g eqtrd breqtrrd ) AEEOPZGBDQZOAEOUAZREWIOSJEUBUCAWJUDDG
      BUEZFUFZOPZWIAWJGMTZWLPZMQWNGBMDUGAWPMWLFGHIAWOGRZUHWPUIAGUJWOWLADGBUJWLK
      WLUKULUMZUNUOAWMNTZOSZNUPEWSOSZNUPWNWIAWTXANAWSCWMEFUQWKGHWMUQRAUDWLFURUS
      JIACTZGRZUHZXBEPFXBUTWDZBDQZXBWMPZLXDXFXEWPMQZXGXHXEWODXEBUEZPZMQXFXEWPXJ
      MWOXERZXJWOWLXEVAZPWPWOXLXIXEGVBXLXIVCXEFVDPZGFXBVEHVFDGXEBVGVHVIWOXEWLVJ
      VKVLXEBMDUGVMXDWPMWLFXBXDXKUHWPUIXDXBGXMAXCVNHVOXDAWQWPUJRXKAXCVPXKWOXMGW
      OFXBVQHVRWRVSWEUOVTWAWBNWMOWCNEOWCWFWGWH $.
  $}

  ${
    $d m x A $.  $d k m x B $.  $d k m x F $.  $d k m ph $.  $d k m x Z $.
    $d k m M $.
    isumcl.1 $e |- Z = ( ZZ>= ` M ) $.
    isumcl.2 $e |- ( ph -> M e. ZZ ) $.
    isumcl.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumcl.4 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    ${
      sumnul.5 $e |- ( ph -> -. seq M ( + , F ) e. dom ~~> ) $.
      $( The sum of a non-convergent infinite series evaluates to the empty
         set.  (Contributed by Paul Chapman, 4-Nov-2007.)  (Revised by Mario
         Carneiro, 23-Apr-2014.) $)
      sumnul $p |- ( ph -> sum_ k e. Z A = (/) ) $=
        ( csu caddc cseq cli cfv c0 isum cdm wcel wn wceq ndmfv syl eqtrd ) AFB
        CLMDENZOPZQABCDEFGHIJRAUFOSTUAUGQUBKUFOUCUDUE $.
    $}

    isumcl.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( The sum of a converging infinite series is a complex number.
       (Contributed by NM, 13-Dec-2005.)  (Revised by Mario Carneiro,
       23-Apr-2014.) $)
    isumcl $p |- ( ph -> sum_ k e. Z A e. CC ) $=
      ( csu caddc cseq cli cfv cc isum cdm wcel fclim ffvelrn sylancr eqeltrd
      wf ) AFBCLMDENZOPZQABCDEFGHIJRAOSZQOUEUFUHTUGQTUAKUHQUFOUBUCUD $.

    summulc.6 $e |- ( ph -> B e. CC ) $.
    $( An infinite sum multiplied by a constant.  (Contributed by NM,
       12-Nov-2005.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    isummulc2 $p |- ( ph ->
                      ( B x. sum_ k e. Z A ) = sum_ k e. Z ( B x. A ) ) $=
      ( vm cmul co cfv wcel cc wceq csu cv cmpt sumfc eqidd adantr mulcld fmptd
      wa eqid ffvelrnda isumclim2 wral eqeltrd ralrimiva fveq2 eleq1d sylan cvv
      rspccva simpr ovex fvmpt2 sylancl oveq2d eqtr4d nffvmpt1 nfeq1 rspc mpan9
      eqeq12d isermulc2 isumclim syl5reqr ) AGCBOPZDUAGNUBZDGVOUCZQZNUACGBDUAZO
      PZGVONDUDAVRVTNVQFGHIAVPGRZUIVRUEAGSVPVQADGVOSVQADUBZGRZUIZCBACSRWCMUFKUG
      VQUJZUHUKAVSCNEVQFGHIMABDEFGHIJKLULAWBEQZSRZDGUMWAVPEQZSRZAWGDGWDWFBSJKUN
      UOWGWIDVPGWBVPTZWFWHSWBVPEUPZUQUTURAWBVQQZCWFOPZTZDGUMWAVRCWHOPZTZAWNDGWD
      WLVOWMWDWCVOUSRWLVOTAWCVACBOVBDGVOUSVQWEVCVDWDWFBCOJVEVFUOWNWPDVPGDVRWODG
      VOVPVGVHWJWLVRWMWOWBVPVQUPWJWFWHCOWKVEVKVIVJVLVMVN $.

    $( An infinite sum multiplied by a constant.  (Contributed by NM,
       13-Nov-2005.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    isummulc1 $p |- ( ph ->
                      ( sum_ k e. Z A x. B ) = sum_ k e. Z ( A x. B ) ) $=
      ( csu cmul co isummulc2 isumcl mulcomd wcel cv wa adantr sumeq2dv 3eqtr4d
      cc ) ACGBDNZOPGCBOPZDNUGCOPGBCOPZDNABCDEFGHIJKLMQAUGCABDEFGHIJKLRMSAGUIUH
      DADUAGTZUBBCKACUFTUJMUCSUDUE $.

    isumdivc.7 $e |- ( ph -> B =/= 0 ) $.
    $( An infinite sum divided by a constant.  (Contributed by NM,
       2-Jan-2006.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    isumdivc $p |- ( ph -> ( sum_ k e. Z A / B ) = sum_ k e. Z ( A / B ) ) $=
      ( csu cdiv co cmul divrecd wcel c1 reccld isummulc1 isumcl adantr cc0 wne
      cv wa cc sumeq2dv 3eqtr4d ) AGBDOZUACPQZRQGBUNRQZDOUMCPQGBCPQZDOABUNDEFGH
      IJKLACMNUBUCAUMCABDEFGHIJKLUDMNSAGUPUODADUHGTZUIBCKACUJTUQMUEACUFUGUQNUES
      UKUL $.
  $}

  ${
    $d j A $.  $d j k F $.  $d j k M $.  $d j k ph $.  $d j k Z $.
    isumrecl.1 $e |- Z = ( ZZ>= ` M ) $.
    isumrecl.2 $e |- ( ph -> M e. ZZ ) $.
    isumrecl.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumrecl.4 $e |- ( ( ph /\ k e. Z ) -> A e. RR ) $.
    isumrecl.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( The sum of a converging infinite real series is a real number.
       (Contributed by Mario Carneiro, 24-Apr-2014.) $)
    isumrecl $p |- ( ph -> sum_ k e. Z A e. RR ) $=
      ( vj csu caddc cseq cv wcel wa recnd cr isumclim2 eqeltrd serfre climrecl
      cfv ffvelrnda ) AFBCMLNDEOZEFGHABCDEFGHIACPZFQRZBJSKUAAFTLPUGACDEFGHUIUHD
      UEBTIJUBUCUFUD $.

    isumge0.6 $e |- ( ( ph /\ k e. Z ) -> 0 <_ A ) $.
    $( An infinite sum of nonnegative terms is nonnegative.  (Contributed by
       Mario Carneiro, 28-Apr-2014.) $)
    isumge0 $p |- ( ph -> 0 <_ sum_ k e. Z A ) $=
      ( vj cc0 cv cfv csu cle caddc breqtrrd cseq wcel wa recnd isumclim2 fveq2
      cli cbvsumv sumeq2dv syl5eq cr eqeltrd iserge0 breqtrd ) ANFMOZDPZMQZFBCQ
      ZRAUQCDEFGHASDEUAURUQUGABCDEFGHIACOZFUBUCZBJUDKUEAUQFUSDPZCQURFUPVAMCUOUS
      DUFUHAFVABCIUIUJZTUTVABUKIJULUTNBVARLITUMVBUN $.
  $}

  ${
    $d j k m F $.  $d j k m G $.  $d j k M $.  $d j k ph $.  $d j k m Z $.
    $d j A $.  $d j B $.
    isumadd.1 $e |- Z = ( ZZ>= ` M ) $.
    isumadd.2 $e |- ( ph -> M e. ZZ ) $.
    isumadd.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumadd.4 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    isumadd.5 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = B ) $.
    isumadd.6 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
    isumadd.7 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    isumadd.8 $e |- ( ph -> seq M ( + , G ) e. dom ~~> ) $.
    $( Addition of infinite sums.  (Contributed by Mario Carneiro,
       18-Aug-2013.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    isumadd $p |- ( ph -> sum_ k e. Z ( A + B ) =
                        ( sum_ k e. Z A + sum_ k e. Z B ) ) $=
      ( caddc cfv wcel cc vm vj co csu cv cmpt wa wceq fveq2 oveq12d eqid fvmpt
      ovex adantl eqtrd cseq cvv isumclim2 seqex a1i eqeltrd serf ffvelrnda cuz
      addcld simpr syl6eleq cfz simpll elfzuz syl6eleqr syl2anc seradd isumclim
      syl climadd ) ABCQUCZHBDUDZHCDUDZQUCDUAHUAUEZERZVTFRZQUCZUFZGHIJADUEZHSZU
      GZWEWDRZWEERZWEFRZQUCZVQWFWHWKUHZAUAWEWCWKHWDVTWEUHWAWIWBWJQVTWEEUIVTWEFU
      IUJWDUKWIWJQUMULZUNWGWIBWJCQKMUJUOWGBCLNVEAVRVSUBQEGUPZQFGUPZQWDGUPZGUQHI
      JABDEGHIJKLOURWPUQSAQWDGUSUTACDFGHIJMNPURAHTUBUEZWNADEGHIJWGWIBTKLVAZVBVC
      AHTWQWOADFGHIJWGWJCTMNVAZVBVCAWQHSZUGZDEFWDGWQXAWQHGVDRZAWTVFIVGXAWEGWQVH
      UCSZUGZAWFWITSAWTXCVIZXCWFXAXCWEXBHWEGWQVJIVKUNZWRVLXDAWFWJTSXEXFWSVLXDWF
      WLXFWMVOVMVPVN $.
  $}

  ${
    $d k A $.  $d k B $.  $d k F $.  $d k G $.  $d k M $.  $d k ph $.
    $d k Z $.
    sumsplit.1 $e |- Z = ( ZZ>= ` M ) $.
    sumsplit.2 $e |- ( ph -> M e. ZZ ) $.
    sumsplit.3 $e |- ( ph -> ( A i^i B ) = (/) ) $.
    sumsplit.4 $e |- ( ph -> ( A u. B ) C_ Z ) $.
    sumsplit.5 $e |- ( ( ph /\ k e. Z ) ->
                       ( F ` k ) = if ( k e. A , C , 0 ) ) $.
    sumsplit.6 $e |- ( ( ph /\ k e. Z ) ->
                       ( G ` k ) = if ( k e. B , C , 0 ) ) $.
    sumsplit.7 $e |- ( ( ph /\ k e. ( A u. B ) ) -> C e. CC ) $.
    sumsplit.8 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    sumsplit.9 $e |- ( ph -> seq M ( + , G ) e. dom ~~> ) $.
    $( Split a sum into two parts.  (Contributed by Mario Carneiro,
       18-Aug-2013.)  (Revised by Mario Carneiro, 23-Apr-2014.) $)
    sumsplit $p |- ( ph -> sum_ k e. ( A u. B ) C =
                         ( sum_ k e. A C + sum_ k e. B C ) ) $=
      ( wcel cc0 cun csu cv cif caddc co wss cc wral cuz cfv cfn wceq ralrimiva
      wo eqimssi a1i orcd sumss2 syl21anc wa iftrue adantl elun1 sylan2 eqeltrd
      wn iffalse 0cn syl6eqel pm2.61dan adantr elun2 isumadd addid1d wi c0 noel
      cin elin eleq2d syl5rbbr mtbii sylibr imp oveq12d 3eqtr4rd addid2d oveq1d
      imnan syl wb biorf elun syl6rbbr ifbid sumeq2sdv unssad unssbd eqtr4d ) A
      BCUAZDEUBZIEUCZXASZDTUDZEUBZBDEUBZCDEUBZUEUFZAXAIUGDUHSZEXAUIIHUJUKZUGZIU
      LSZUOZXBXFUMMAXJEXAPUNAXLXMXLAIXKJUPUQURZXAIDEHUSUTAIXCBSZDTUDZXCCSZDTUDZ
      UEUFZEUBIXQEUBZIXSEUBZUEUFXFXIAXQXSEFGHIJKNAXQUHSZXCISZAXPYCAXPVAZXQDUHXP
      XQDUMAXPDTVBVCZXPAXDXJXCBCVDZPVEZVFXPVGZYCAYIXQTUHXPDTVHZVIVJVCVKVLOAXSUH
      SZYDAXRYKAXRVAXSDUHXRXSDUMAXRDTVBVCXRAXDXJXCCBVMPVEZVFXRVGZYKAYMXSTUHXRDT
      VHZVIVJVCVKZVLQRVNAIXEXTEAXPXEXTUMYEDTUEUFDXTXEYEDYHVOYEXQDXSTUEYFYEYMXST
      UMAXPYMAXPXRVAZVGXPYMVPAXCVQSZYPXCVRYPXCBCVSZSAYQXCBCVTAYRVQXCLWAWBWCXPXR
      WJWDWEYNWKWFXPXEDUMZAXPXDYSYGXDDTVBWKVCWGAYIVAZTXSUEUFZXSXTXEAUUAXSUMYIAX
      SYOWHVLYTXQTXSUEYIXQTUMAYJVCWIYTXDXRDTYIXDXRWLAYIXRXPXRUOXDXPXRWMXCBCWNWO
      VCWPWGVKWQAXGYAXHYBUEABIUGXJEBUIXNXGYAUMABCIMWRAXJEBYHUNXOBIDEHUSUTACIUGX
      JECUIXNXHYBUMABCIMWSAXJECYLUNXOCIDEHUSUTWFWGWT $.
  $}

  ${
    $d k B $.  $d k K $.  $d k M $.  $d k N $.  $d k ph $.
    fsump1i.1 $e |- Z = ( ZZ>= ` M ) $.
    fsump1i.2 $e |- N = ( K + 1 ) $.
    fsump1i.3 $e |- ( k = N -> A = B ) $.
    fsump1i.4 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    fsump1i.5 $e |- ( ph -> ( K e. Z /\ sum_ k e. ( M ... K ) A = S ) ) $.
    fsump1i.6 $e |- ( ph -> ( S + B ) = T ) $.
    $( Optimized version of ~ fsump1 for making sums of a concrete number of
       terms.  (Contributed by Mario Carneiro, 23-Apr-2014.) $)
    fsump1i $p |- ( ph -> ( N e. Z /\ sum_ k e. ( M ... N ) A = T ) ) $=
      ( wcel cfz co wceq csu c1 caddc cuz cfv simpld syl6eleq peano2uz syl5eqel
      syl6eleqr syl oveq2i sumeq1i cv elfzuz sylan2 eqeq2i sylbir fsump1 syl5eq
      cc simprd oveq1d 3eqtrd jca ) AIJQHIRSZBFUAZETAIGUBUCSZJLAGHUDUEZQZVHJQAG
      JVIAGJQZHGRSBFUAZDTZOUFKUGZVJVHVIJHGUHKUJUKUIAVGVLCUCSZDCUCSEAVGHVHRSZBFU
      AVOVFVPBFIVHHRLULUMABCFHGVNFUNZVPQZAVQJQBVAQVRVQVIJVQHVHUOKUJNUPVQVHTVQIT
      BCTIVHVQLUQMURUSUTAVLDCUCAVKVMOVBVCPVDVE $.
  $}

  ${
    $d j k m w x y z A $.  $d k m w x y z B $.  $d j k m w x y D $.
    $d m w x y z C $.  $d j k m w z ph $.
    fsum2d.1 $e |- ( z = <. j , k >. -> D = C ) $.
    fsum2d.2 $e |- ( ph -> A e. Fin ) $.
    fsum2d.3 $e |- ( ( ph /\ j e. A ) -> B e. Fin ) $.
    fsum2d.4 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> C e. CC ) $.
    ${
      fsum2d.5 $e |- ( ph -> -. y e. x ) $.
      fsum2d.6 $e |- ( ph -> ( x u. { y } ) C_ A ) $.
      fsum2d.7 $e |- ( ps <-> sum_ j e. x sum_ k e. B C =
                             sum_ z e. U_ j e. x ( { j } X. B ) D ) $.
      $( Lemma for ~ fsum2d - induction step.  (Contributed by Mario Carneiro,
         23-Apr-2014.) $)
      fsum2dlem $p |- ( ( ph /\ ps ) ->
                        sum_ j e. ( x u. { y } ) sum_ k e. B C =
                        sum_ z e. U_ j e. ( x u. { y } ) ( { j } X. B ) D ) $=
        ( vm wcel wa cv csu csn caddc co cxp ciun csb cun wceq simpr sylib nfcv
        nfcsb1v nfsum weq csbeq1a adantr sumeq12dv cbvsumi cc wss unssbd sylibr
        vex snss cfn wral ralrimiva nfel1 eleq1d rspc sylc ralrimivva raleqbidv
        nfral r19.21bi fsumcl csbeq1 sumsn syl2anc c2nd cfv cres snfi xpfi wf1o
        sylancr 2ndconst syl fvres adantl mpan9 fsumf1o cop wex elxp nfcri nfan
        nfv nfex opeq1 eqeq2d eqtr2 eleq2d pm5.32da elsn anbi1i syl6rbbr anbi1d
        equequ1 bitrd anbi12d exbidv cbvex bitri nfcsb ad2antlr ad2antrl exlimd
        nfeq2 syl5bi imp syl5eq eqtrd wel cin syldan fsumsplit wrex eliun xp1st
        c0 elsni eqeltrd elin sneq xpeq12d eqtri fveq2 op2nd 3eqtrd expl eqtr4d
        syl6req sumeq2dv oveq12d wn disjsn eqidd ssfi sselda anassrs c1st simpl
        rexlimiva sylbi anim12i 3imtr4i noel pm2.21i syl6bi syl5 ssrdv ss0 nfxp
        iunxun cbviun iunxsn uneq2i iunfi simprl simprrl opeq1d simpll syl12anc
        a1i simprrr ex exlimdvv rexlimdva 3eqtr4d ) ABUAZCUBZGHKUCZJUCZDUBZUDZU
        WFJUCZUEUFZJUWEJUBZUDZGUGZUHZIEUCZUWIJUWHGUIZUGZIEUCZUEUFZUWEUWIUJZUWFJ
        UCZJUXAUWNUHZIEUCZUWDUWGUWPUWJUWSUEUWDBUWGUWPUKABULRUMAUWJUWSUKBAUWJUWI
        JSUBZGUIZJUXEHUIZKUCZSUCZUWSUWIUWFUXHJSSUWFUNJUXFUXGKJUXEGUOZJUXEHUOUPJ
        SUQZGUXFHUXGKJUXEGURZUXKHUXGUKKUBZGTZJUXEHURUSUTVAAUXIUWQJUWHHUIZKUCZUW
        SAUWHFTZUXPVBTUXIUXPUKAUWIFVCUXQAUWEUWIFQVDUWHFDVFZVGVEZAUWQUXOKAUXQGVH
        TZJFVIUWQVHTZUXSAUXTJFNVJUXTUYAJUWHFJUWQVHJUWHGUOZVKJDUQZGUWQVHJUWHGURZ
        VLVMVNZAUXOVBTZKUWQAUXQHVBTZKGVIZJFVIUYFKUWQVIZUXSAUYGJKFGOVOUYHUYIJUWH
        FUYFJKUWQUYBJUXOVBJUWHHUOZVKVQUYCUYGUYFKGUWQUYDUYCHUXOVBJUWHHURZVLVPVMV
        NZVRVSUXHUXPSUWHFSDUQZUXFUWQUXGUXOKJUXEUWHGVTZUYMUXGUXOUKUXMUXFTJUXEUWH
        HVTUSUTWAWBAUXPUWQKUXEUXOUIZSUCZUWSUWQUXOUYOKSSUXOUNKUXEUXOUOZKUXEUXOUR
        ZVAAUYPUWRKEUBZWCWDZUXOUIZEUCUWSAUWQUYOUWRVUASEWCUWRWEZUYTKUXEUYTUXOVTA
        UWIVHTUYAUWRVHTUWHWFUYEUWIUWQWGWIAUXQUWRUWQVUBWHUXSUWHUWQFWJWKUYSUWRTZU
        YSVUBWDUYTUKAUYSUWRWCWLWMAUYIUXEUWQTUYOVBTZUYLUYFVUDKUXEUWQKUYOVBUYQVKK
        SUQUXOUYOVBUYRVLVMWNWOAUWRIVUAEAVUCIVUAUKZVUCUYSUWLUXMWPZUKZUYCUXNUAZUA
        ZKWQZJWQZAVUEVUCUYSUXEUXMWPZUKZUXEUWITZUXMUWQTZUAZUAZKWQZSWQVUKSKUYSUWI
        UWQWRVURVUJSJVUQJKVUMVUPJVUMJXAVUNVUOJVUNJXAJKUWQUYBWSWTWTXBVUJSXASJUQZ
        VUQVUIKVUSVUMVUGVUPVUHVUSVULVUFUYSUXEUWLUXMXCXDVUSVUPUYMUXNUAZVUHVUSVUT
        UYMVUOUAVUPVUSUYMUXNVUOVUSUYMUAZGUWQUXMVVAUYCGUWQUKUXEUWLUWHXEUYDWKXFXG
        VUNUYMVUOSUWHXHXIXJVUSUYMUYCUXNSJDXLXKXMXNXOXPXQAVUJVUEJAJXAJIVUAJKUYTU
        XOJUYTUNUYJXRYBAVUIVUEKAKXAKIVUAKUYTUXOUOYBAVUGVUHVUEAVUGUAZVUHUAZIHUXO
        VUAVUGIHUKZAVUHLXSUYCHUXOUKVVBUXNUYKXTVVCUXMUYTUKZUXOVUAUKVUGVVEAVUHVUG
        UYTVUFWCWDUXMUYSVUFWCUUAUWLUXMJVFKVFUUBUUFXSKUYTUXOURWKUUCUUDYAYAYCYDUU
        GUUEYEYFYEUSUUHAUXBUWKUKBAUWEUWIUWFUXAJADCYGUUIUWEUWIYHZYNUKPUWEUWHUUJV
        EZAUXAUUKAFVHTUXAFVCUXAVHTZMQFUXAUULWBZAUWLUXATZUWLFTZUWFVBTAUXAFUWLQUU
        MZAVVKUAGHKNAVVKUXNUYGOUUNVSYIYJUSAUXDUWTUKBAUWOUWRIUXCEAUWOUWRYHZYNVCV
        VMYNUKAEVVMYNUYSVVMTZUYSUUOWDZVVFTZAUYSYNTZUYSUWOTZVUCUAVVOUWETZVVOUWIT
        ZUAVVNVVPVVRVVSVUCVVTVVRUYSUWNTZJUWEYKVVSJUYSUWEUWNYLVWAVVSJUWEJCYGZVWA
        UAVVOUWLUWEVWAVVOUWLUKZVWBVWAVVOUWMTVWCUYSUWMGYMVVOUWLYOWKWMVWBVWAUUPYP
        UUQUURUYSUWIUWQYMUUSUYSUWOUWRYQVVOUWEUWIYQUUTAVVPVVOYNTZVVQAVVFYNVVOVVG
        XFVWDVVQVVOUVAUVBUVCUVDUVEVVMUVFWKUXCUWOUWRUJZUKAUXCUWOJUWIUWNUHZUJVWEJ
        UWEUWIUWNUVHVWFUWRUWOVWFSUWIUXEUDZUXFUGZUHUWRJSUWIUWNVWHSUWNUNJVWGUXFJV
        WGUNUXJUVGUXKUWMVWGGUXFUWLUXEYRUXLYSUVISUWHVWHUWRUXRUYMVWGUWIUXFUWQUXEU
        WHYRUYNYSUVJYTUVKYTUVRAVVHUWNVHTZJUXAVIUXCVHTVVIAVWIJUXAAVVJUAZUWMVHTUX
        TVWIUWLWFAVVJVVKUXTVVLNYIUWMGWGWIVJJUXAUWNUVLWBAUYSUXCTZIVBTZVWKVWAJUXA
        YKAVWLJUYSUXAUWNYLAVWAVWLJUXAVWAVUMUXEUWMTZUXNUAZUAZKWQSWQVWJVWLSKUYSUW
        MGWRVWJVWOVWLSKVWJVWOVWLVWJVWOUAZIHVBVWPVUGVVDVWPUYSVULVUFVWJVUMVWNUVMV
        WPUXEUWLUXMVWPVWMVUSVWJVUMVWMUXNUVNUXEUWLYOWKUVOYFLWKVWPAVVKUXNUYGAVVJV
        WOUVPVWJVVKVWOVVLUSVWJVUMVWMUXNUVSOUVQYPUVTUWAYCUWBYCYDYJUSUWC $.
    $}

    $d x y ph $.
    $( Write a double sum as a sum over a two-dimensional region.  Note that
       ` B ( j ) ` is a function of ` j ` .  (Contributed by Mario Carneiro,
       27-Apr-2014.) $)
    fsum2d $p |- ( ph -> sum_ j e. A sum_ k e. B C =
                         sum_ z e. U_ j e. A ( { j } X. B ) D ) $=
      ( wss csu cv ciun wceq wcel wi c0 vw vx csn cxp ssid cfn cun sseq1 sumeq1
      iuneq1 sumeq1d eqeq12d imbi12d imbi2d cc0 sum0 0iun sumeq1i 3eqtr4ri a1ii
      vy wn wa ssun1 sstr mpan imim1i simpll syl sylan cc simplr biid fsum2dlem
      simpr exp31 a2d syl5 expcom adantl findcard2s mpcom mpi ) ACCMZCDEHNZGNZG
      CGOZUCDUDZPZFBNZQZCUECUFRZAWDWKSZJAUAOZCMZWNWEGNZGWNWHPZFBNZQZSZSATCMZTWE
      GNZGTWHPZFBNZQZSZSAUBOZCMZXGWEGNZGXGWHPZFBNZQZSZSZAXGVAOZUCZUGZCMZXQWEGNZ
      GXQWHPZFBNZQZSZSZAWMSUAUBVACWNTQZWTXFAYEWOXAWSXEWNTCUHYEWPXBWRXDWNTWEGUIY
      EWQXCFBGWNTWHUJUKULUMUNWNXGQZWTXMAYFWOXHWSXLWNXGCUHYFWPXIWRXKWNXGWEGUIYFW
      QXJFBGWNXGWHUJUKULUMUNWNXQQZWTYCAYGWOXRWSYBWNXQCUHYGWPXSWRYAWNXQWEGUIYGWQ
      XTFBGWNXQWHUJUKULUMUNWNCQZWTWMAYHWOWDWSWKWNCCUHYHWPWFWRWJWNCWEGUIYHWQWIFB
      GWNCWHUJUKULUMUNAXAXETFBNUOXDXBFBUPXCTFBGWHUQURWEGUPUSUTXOXGRVBZXNYDSXGUF
      RYIAXMYCAYIXMYCSXMXRXLSAYIVCZYCXRXHXLXGXQMXRXHXGXPVDXGXQCVEVFVGYJXRXLYBYJ
      XRXLYBYJXRVCZXLUBVABCDEFGHIYKAWLAYIXRVHZJVIYKAWGCRZDUFRYLKVJYKAYMHODRVCEV
      KRYLLVJAYIXRVLYJXRVOXLVMVNVPVQVRVSVQVTWAWBWC $.
  $}

  ${
    $d j k z A $.  $d j k z B $.  $d z C $.  $d j k D $.  $d j k z ph $.
    fsumxp.1 $e |- ( z = <. j , k >. -> D = C ) $.
    fsumxp.2 $e |- ( ph -> A e. Fin ) $.
    fsumxp.3 $e |- ( ph -> B e. Fin ) $.
    fsumxp.4 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> C e. CC ) $.
    $( Combine two sums into a single sum over the cartesian product.
       (Contributed by Mario Carneiro, 23-Apr-2014.) $)
    fsumxp $p |- ( ph -> sum_ j e. A sum_ k e. B C =
                         sum_ z e. ( A X. B ) D ) $=
      ( csu cv csn cxp ciun cfn wcel adantr fsum2d iunxpconst sumeq1i syl6eq )
      ACDEHMGMGCGNZODPQZFBMCDPZFBMABCDEFGHIJADRSUECSKTLUAUFUGFBGCDUBUCUD $.
  $}

  ${
    $d w x y z A $.  $d j k y B $.  $d j k x C $.  $d w x y z ph $.
    $d x y D $.
    fsumcnv.1 $e |- ( x = <. j , k >. -> B = D ) $.
    fsumcnv.2 $e |- ( y = <. k , j >. -> C = D ) $.
    fsumcnv.3 $e |- ( ph -> A e. Fin ) $.
    fsumcnv.4 $e |- ( ph -> Rel A ) $.
    fsumcnv.5 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    $( Transform a region of summation by using the converse operation.
       (Contributed by Mario Carneiro, 23-Apr-2014.) $)
    fsumcnv $p |- ( ph -> sum_ x e. A B = sum_ y e. `' A C ) $=
      ( vz ccnv cv cfv csb wceq csu c2nd c1st csn cuni cmpt cop csbeq1a fvex wa
      opex nfcv csbief opeq12 csbeq1d syl5eqr csbie2 syl6eqr cfn wcel cnvfi syl
      wf1o wrel relcnv cnvf1o ax-mp wb dfrel2 sylib f1oeq3 mpbii 1st2nd mpan id
      fveq2d eqeltrrd sneq cnveqd unieqd opswap syl6eq eqid fvmpt eqtrd fsumf1o
      adantl ancoms sumeq2i ) ADEBUADPZHCQZUBRZIWKUCRZGSSZCUAWJFCUAADEWJWNBCOWJ
      OQZUDZPZUEZUFZWLWMUGZBQWTTEBWTESZWNBWTEUHHIWLWMGXAWKUBUIZWKUCUIZHQZWLTZIQ
      ZWMTZUJZGBXDXFUGZESXABXIEGXDXFUKBGULJUMXHBXIWTEXDXFWLWMUNUOUPUQURADUSUTWJ
      USUTLDVAVBAWJWJPZWSVCZWJDWSVCZWJVDZXKDVEZOWJVFVGAXJDTZXKXLVHADVDXOMDVIVJX
      JDWJWSVKVBVLWKWJUTZWKWSRZWTTAXPXQWMWLUGZWSRZWTXPWKXRWSXMXPWKXRTZXNWKWJVMV
      NZVPXPXRWJUTXSWTTXPWKXRWJYAXPVOVQOXRWRWTWJWSWOXRTZWRXRUDZPZUEWTYBWQYDYBWP
      YCWOXRVRVSVTWMWLWAWBWSWCWLWMUKWDVBWEWGNWFWJFWNCXPFCXRFSZWNXPXTFYETYACXRFU
      HVBHIWLWMGYEXBXCXHGCXFXDUGZFSYECYFFGXFXDUKCGULKUMXHCYFXRFXGXEYFXRTXFXDWMW
      LUNWHUOUPUQURWIUR $.
  $}

  ${
    $d j k m n x y z A $.  $d j k m n w x y z C $.  $d j k m n w x y z ph $.
    $d k m n x y z B $.  $d j m n w x y z D $.  $d m n w x z E $.
    fsumcom2.1 $e |- ( ph -> A e. Fin ) $.
    fsumcom2.2 $e |- ( ph -> C e. Fin ) $.
    fsumcom2.3 $e |- ( ( ph /\ j e. A ) -> B e. Fin ) $.
    fsumcom2.4 $e |- ( ph ->
      ( ( j e. A /\ k e. B ) <-> ( k e. C /\ j e. D ) ) ) $.
    fsumcom2.5 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> E e. CC ) $.
    $( Interchange order of summation.  Note that ` B ( j ) ` and ` D ( k ) `
       are not necessarily constant expressions.  (Contributed by Mario
       Carneiro, 28-Apr-2014.)  (Revised by Mario Carneiro, 8-Apr-2016.) $)
    fsumcom2 $p |- ( ph -> sum_ j e. A sum_ k e. B E =
                           sum_ k e. C sum_ j e. D E ) $=
      ( vm vn csb csu wceq wcel wa vz vw vx vy csn cxp ciun c2nd c1st ccnv wrel
      cv cfv wral relxp rgenw reliun mpbir relcnv cop wex wb weq ancom vex opth
      3bitr4i a1i anbi12d 2exbidv eliunxp opelcnv excom 3bitri 3bitr4g eqrelrdv
      nfcv nfcsb1v csbeq1a xpeq12d cbviun cnveqi 3eqtr3g sumeq1d op1std csbeq1d
      nfxp sneq op2ndd csbeq2dv eqtrd cfn snfi adantr wrex nfcri snid syl6eqelr
      wss id biantrurd opelxp syl6rbbr eleq2d bitrd rspce eliun sylibr eleqtrrd
      adantl sylib simpr simpld elsni syl simpl eqeltrd rexlimiva ssrdv syl2anc
      expr ssfi xpfi sylancr ralrimiva cc ralrimivva nfel1 raleqbidv rspc mpan9
      eleq1d csbeq1 rspcv sylc fsum2d nfsum cbvsumi sumeq12dv syl5eq mprgbir wi
      iunfi xp2nd xp1st eqcomd biimpa sylbi rexlimi nfral syl5com impr syl12anc
      fsumcnv eqtr4d 3eqtr4d nfcsb 3eqtr4g ) ABFNULZCPZGOULZFUUSHPZPZOQZNQZDGUV
      AEPZUVCNQZOQZBCHGQZFQDEHFQZGQANBUUSUEZUUTUFZUGZGUAULZUHUMZFUVNUIUMZHPZPZU
      AQZODUVAUEZUVFUFZUGZGUBULZUIUMZFUWCUHUMZHPZPZUBQZUVEUVHAUVSUWBUJZUVRUAQUW
      HAUVMUWIUVRUAAFBFULZUEZCUFZUGZGDGULZUEZEUFZUGZUJZUVMUWIAUCUDUWMUWRUWMUKUW
      LUKZFBUNUWSFBUWKCUOUPFBUWLUQURUWQUSAUCULZUDULZUTZUWJUWNUTRZUWJBSZUWNCSTZT
      ZGVAFVAUXAUWTUTZUWNUWJUTRZUWNDSUWJESTZTZGVAFVAZUXBUWMSUXBUWRSZAUXFUXJFGAU
      XCUXHUXEUXIUXCUXHVBAUCFVCZUDGVCZTUXNUXMTUXCUXHUXMUXNVDUWTUXAUWJUWNUCVEZUD
      VEZVFUXAUWTUWNUWJUXPUXOVFVGVHLVIVJFGBCUXBVKUXLUXGUWQSUXJFVAGVAUXKUWTUXAUW
      QUXOUXPVLGFDEUXGVKUXJGFVMVNVOVPZFNBUWLUVLNUWLVQFUVKUUTFUVKVQFUUSCVRZWGFNV
      CZUWKUVKCUUTUWJUUSWHFUUSCVSZVTWAUWQUWBGODUWPUWAOUWPVQGUVTUVFGUVTVQGUVAEVR
      ZWGGOVCZUWOUVTEUVFUWNUVAWHGUVAEVSZVTWAWBWCWDAUBUAUWBUWGUVRUVCONUWCUVAUUSU
      TZRZUWGGUVAUWFPUVCUYEGUWDUVAUWFUVAUUSUWCOVEZNVEZWEWFUYEGUVAUWFUVBUYEFUWEU
      USHUVAUUSUWCUYFUYGWIWFWJWKZUVNUUSUVAUTZRZUVRGUVAUVQPUVCUYJGUVOUVAUVQUUSUV
      AUVNUYGUYFWIWFUYJGUVAUVQUVBUYJFUVPUUSHUUSUVAUVNUYGUYFWEWFWJWKZADWLSUWAWLS
      ZODUNUWBWLSJAUYLODAUVADSZTZUVTWLSUVFWLSZUYLUVAWMUYNBWLSZUVFBWSUYOAUYPUYMI
      WNUYNNUVFBAUYMUUSUVFSZUUSBSZAUYMUYQTZTZUYIUWLSZFBWOZUYRUYTUYIUWMSVUBUYTUY
      IUWRUWMUYSUYIUWRSZAUYSUYDUWQSZVUCUYSUYDUWPSZGDWOVUDVUEUYQGUVADGNUVFUYAWPU
      YBVUEUUSESZUYQUYBVUFUVAUWOSZVUFTVUEUYBVUGVUFUYBUVAUWNUWOUYBWTUWNGVEWQWRXA
      UVAUUSUWOEXBXCUYBEUVFUUSUYCXDXEXFGUYDDUWPXGXHUUSUVAUWQUYGUYFVLXHXJAUWMUWR
      RUYSUXQWNXIFUYIBUWLXGXKZVUAUYRFBUXDVUATZUUSUWJBVUIUUSUWKSZNFVCVUIVUJUVACS
      ZVUIVUAVUJVUKTZUXDVUAXLUUSUVAUWKCXBZXKXMUUSUWJXNZXOUXDVUAXPXQXRXOZYAXSBUV
      FYBXTZUVTUVFYCYDYEODUWAUUCXTUWBUKZAVUQUWAUKZODODUWAUQVURUYMUVTUVFUOVHUUAV
      HAUWCUWBSZTZUWEGUWDEPZSZGUWDUVBPZYFSZNVVAUNZUWGYFSZVUTUWCUWASZODWOZVVBVUT
      VUSVVHAVUSXLOUWCDUWAXGXKZVVGVVBODUYMVVGTZUWEUVFVVAVVGUWEUVFSUYMUWCUVTUVFU
      UDXJVVJGUWDUVAEVVJUWDUVTSZUWDUVARVVGVVKUYMUWCUVTUVFUUEXJUWDUVAXNXOZWFXIXR
      XOVUTUWDDSZUVCYFSZNUVFUNZODUNZVVEVUTVVHVVMVVIVVGVVMODVVJUWDUVADVVLUYMVVGX
      PXQXRXOAVVPVUSAVVNONDUVFUYTAUYRUVAUUTSZVVNAUYSXPVUOUYTVUBVVQVUHVUAVVQFBFO
      UUTUXRWPVUAVVQUUBUXDVUAVULVVQVUMVUJVUKVVQVUJCUUTUVAVUJUXSCUUTRVUJUUSUWJVU
      NUUFUXTXOXDUUGUUHVHUUIXOAUYRVVQVVNAUYRTUVBYFSZGUUTUNZVVQVVNAHYFSZGCUNZFBU
      NUYRVVSAVVTFGBCMYGVWAVVSFUUSBVVRFGUUTUXRFUVBYFFUUSHVRZYHUUJUXSVVTVVRGCUUT
      UXTUXSHUVBYFFUUSHVSZYLYIYJYKVVRVVNGUVAUUTGUVCYFGUVAUVBVRZYHUYBUVBUVCYFGUV
      AUVBVSZYLYJUUKUULZUUMZYGWNVVOVVEOUWDDUVAUWDRZVVNVVDNUVFVVAGUVAUWDEYMVWHUV
      CVVCYFGUVAUWDUVBYMYLYIYNYOVVDVVFNUWEVVAUUSUWERZVVCUWGYFVWIGUWDUVBUWFFUUSU
      WEHYMWJYLYNYOUUNUUOAUABUUTUVCUVRNOUYKIACWLSZFBUNUYRUUTWLSZAVWJFBKYEVWJVWK
      FUUSBFUUTWLUXRYHUXSCUUTWLUXTYLYJYKVWFYPAUBDUVFUVCUWGONUYHJVUPVWGYPUUPBUVI
      UVDFNNUVIVQFUUTUVCOUXRFGUVAUVBFUVAVQVWBUUQYQUXSUVICGUVAHPZOQUVDCHVWLGOOHV
      QGUVAHVRGUVAHVSYRUXSCUUTVWLUVCOUXTUXSVWLUVCRVUKUXSGUVAHUVBVWCWJWNYSYTYRDU
      VJUVGGOOUVJVQGUVFUVCNUYAVWDYQUYBUVJEUVBNQUVGEHUVBFNNHVQVWBVWCYRUYBEUVFUVB
      UVCNUYCUYBUVBUVCRVUFVWEWNYSYTYRUUR $.
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k ph $.
    fsumcom.1 $e |- ( ph -> A e. Fin ) $.
    fsumcom.2 $e |- ( ph -> B e. Fin ) $.
    fsumcom.3 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> C e. CC ) $.
    $( Interchange order of summation.  (Contributed by NM, 15-Nov-2005.)
       (Revised by Mario Carneiro, 23-Apr-2014.) $)
    fsumcom $p |- ( ph -> sum_ j e. A sum_ k e. B C =
                          sum_ k e. B sum_ j e. A C ) $=
      ( cfn wcel cv adantr wa wb ancom a1i fsumcom2 ) ABCCBEFDGHACJKELBKZHMSFLC
      KZNTSNOASTPQIR $.
  $}

  ${
    $d j k x y N $.
    $( Lemma for ~ fsum0diag .  (Contributed by Mario Carneiro, 28-Apr-2014.)
       (Revised by Mario Carneiro, 8-Apr-2016.) $)
    fsum0diaglem $p |- ( ( j e. ( 0 ... N ) /\ k e. ( 0 ... ( N - j ) ) ) ->
        ( k e. ( 0 ... N ) /\ j e. ( 0 ... ( N - k ) ) ) ) $=
      ( cv cc0 cfz co wcel cmin cuz cfv cle adantr zred elfzelz zsubcld syl2anc
      wbr cz wb wss elfzle1 cn0 elfz3nn0 nn0zd subge02d mpbid eluz mpbird fzss2
      wa syl simpr sseldd adantl elfzle2 lesubd elfzuz elfz5 jca ) ADZECFGZHZBD
      ZECVAIGZFGZHZUKZVDVBHVAECVDIGZFGHZVHVFVBVDVHCVEJKHZVFVBUAVHVKVECLRZVHEVAL
      RZVLVCVMVGVAECUBMVHCVAVHCVHCVCCUCHVGVACUDMUEZNZVHVAVCVASHVGVAECOMZNZUFUGV
      HVESHCSHVKVLTVHCVAVNVPPVNVECUHQUIVEECUJULVCVGUMUNVHVJVAVILRZVHVDCVAVHVDVG
      VDSHVCVDEVEOUOZNVOVQVGVDVELRVCVDEVEUPUOUQVHVAEJKHZVISHVJVRTVCVTVGVAECURMV
      HCVDVNVSPVAEVIUSQUIUT $.
  $}

  ${
    $d j k x y N $.  $d j k x y ph $.
    fsum0diag.1 $e |- ( ( ph /\ ( j e. ( 0 ... N ) /\
                          k e. ( 0 ... ( N - j ) ) ) ) -> A e. CC ) $.
    $( Two ways to express "the sum of ` A ( j , k ) ` over the triangular
       region ` M <_ j ` , ` M <_ k ` , ` j + k <_ N ` ."  (Contributed by NM,
       31-Dec-2005.)  (Proof shortened by Mario Carneiro, 28-Apr-2014.)
       (Revised by Mario Carneiro, 8-Apr-2016.) $)
    fsum0diag $p |- ( ph ->
                     sum_ j e. ( 0 ... N ) sum_ k e. ( 0 ... ( N - j ) ) A =
                     sum_ k e. ( 0 ... N ) sum_ j e. ( 0 ... ( N - k ) ) A ) $=
      ( cc0 cfz co cv cmin fzfid wcel wa wb fsum0diaglem impbii a1i fsumcom2 )
      AGEHIZGECJZKIZHIZTGEDJZKIHIZCDBAGELZUFAUATMZNGUBLUGUDUCMNZUDTMUAUEMNZOAUH
      UICDEPDCEPQRFS $.
  $}

  ${
    $d k m x A $.  $d j x B $.  $d j k m K $.  $d j k m x M $.  $d j k m x N $.
    $d j k m ph $.
    fsumrev.1 $e |- ( ph -> K e. ZZ ) $.
    fsumrev.2 $e |- ( ph -> M e. ZZ ) $.
    fsumrev.3 $e |- ( ph -> N e. ZZ ) $.
    fsumrev.4 $e |- ( ( ph /\ j e. ( M ... N ) ) -> A e. CC ) $.
    ${
      fsumrev.5 $e |- ( j = ( K - k ) -> A = B ) $.
      $( Reversal of a finite sum.  (Contributed by NM, 26-Nov-2005.)  (Revised
         by Mario Carneiro, 24-Apr-2014.) $)
      fsumrev $p |- ( ph -> sum_ j e. ( M ... N ) A =
                            sum_ k e. ( ( K - N ) ... ( K - M ) ) B ) $=
        ( co cmin wcel wceq wa cz adantr cfz cmpt fzfid wfn ccnv wf1o ovex eqid
        cv fnmpti a1i copab simprr simprl wb elfzelz syl fzrev syl22anc eqeltrd
        mpbid oveq2d cc zcn nncan syl2an syl2anc eqtr2d fzrev2 impbida opabbidv
        df-mpt cnveqi cnvopab eqtri 3eqtr4g fneq1d mpbiri dff1o4 sylanbrc oveq2
        jca cfv fvmpt adantl fsumf1o ) AGHUANZBFHONZFGONZUANZCDEDWJFDUIZONZUBZF
        EUIZONZMAWHWIUCAWMWJUDZWMUEZWGUDZWJWGWMUFWPADWJWLWMFWKOUGWMUHZUJUKAWREW
        GWOUBZWGUDEWGWOWTFWNOUGZWTUHUJAWGWQWTAWKWJPZWNWLQZRZEDULZWNWGPZWKWOQZRZ
        EDULWQWTAXDXHEDAXDXHAXDRZXFXGXIWNWLWGAXBXCUMZXIXBWLWGPZAXBXCUNZXIGSPZHS
        PZFSPZWKSPZXBXKUOAXMXDJTAXNXDKTAXOXDITZXIXBXPXLWKWHWIUPUQZFWKGHURUSVAUT
        XIWOFWLONZWKXIWNWLFOXJVBXIXOXPXSWKQZXQXRXOFVCPZWKVCPXTXPFVDZWKVDFWKVEVF
        VGVHWBAXHRZXBXCYCWKWOWJAXFXGUMZYCXFWOWJPZAXFXGUNZYCXMXNXOWNSPZXFYEUOAXM
        XHJTAXNXHKTAXOXHITZYCXFYGYFWNGHUPUQZFWNGHVIUSVAUTYCWLFWOONZWNYCWKWOFOYD
        VBYCXOYGYJWNQZYHYIXOYAWNVCPYKYGYBWNVDFWNVEVFVGVHWBVJVKWQXDDEULZUEXEWMYL
        DEWJWLVLVMXDDEVNVOEDWGWOVLVPVQVRWJWGWMVSVTWNWJPWNWMWCWOQADWNWLWOWJWMWKW
        NFOWAWSXAWDWELWF $.
    $}

    ${
      fsumshft.5 $e |- ( j = ( k - K ) -> A = B ) $.
      $( Index shift of a finite sum.  (Contributed by NM, 27-Nov-2005.)
         (Revised by Mario Carneiro, 24-Apr-2014.) $)
      fsumshft $p |- ( ph -> sum_ j e. ( M ... N ) A =
                             sum_ k e. ( ( M + K ) ... ( N + K ) ) B ) $=
        ( co caddc cmin wcel wceq cz adantr cfz cv cmpt wfn ccnv wf1o ovex eqid
        fzfid fnmpti a1i wa copab simprr oveq1d elfzelz ad2antrl cc zcn syl2anc
        npcan syl2an eqtr2d simprl eqeltrrd wb zsubcld eqeltrd fzaddel syl22anc
        mpbird mpbid pncan impbida opabbidv df-mpt cnveqi cnvopab eqtri 3eqtr4g
        jca fneq1d mpbiri dff1o4 sylanbrc cfv oveq1 fvmpt adantl fsumf1o ) AGHU
        ANZBGFONZHFONZUANZCDEDWNDUBZFPNZUCZEUBZFPNZMAWLWMUIAWQWNUDZWQUEZWKUDZWN
        WKWQUFWTADWNWPWQWOFPUGWQUHZUJUKAXBEWKWRFONZUCZWKUDEWKXDXEWRFOUGXEUHUJAW
        KXAXEAWOWNQZWRWPRZULZEDUMZWRWKQZWOXDRZULZEDUMXAXEAXHXLEDAXHXLAXHULZXJXK
        XMXJXDWNQZXMWOXDWNXMXDWPFONZWOXMWRWPFOAXFXGUNZUOXMWOSQZFSQZXOWORZXFXQAX
        GWOWLWMUPUQZAXRXHITZXQWOURQFURQZXSXRWOUSFUSZWOFVAVBUTVCZAXFXGVDVEXMGSQZ
        HSQZWRSQZXRXJXNVFZAYEXHJTAYFXHKTXMWRWPSXPXMWOFXTYAVGVHYAWRFGHVIZVJVKYDW
        AAXLULZXFXGYJWOXDWNAXJXKUNZYJXJXNAXJXKVDYJYEYFYGXRYHAYEXLJTAYFXLKTXJYGA
        XKWRGHUPUQZAXRXLITZYIVJVLVHYJWPXDFPNZWRYJWOXDFPYKUOYJYGXRYNWRRZYLYMYGWR
        URQYBYOXRWRUSYCWRFVMVBUTVCWAVNVOXAXHDEUMZUEXIWQYPDEWNWPVPVQXHDEVRVSEDWK
        XDVPVTWBWCWNWKWQWDWEWRWNQWRWQWFWSRADWRWPWSWNWQWOWRFPWGXCWRFPUGWHWILWJ
        $.
    $}

    ${
      fsumshftm.5 $e |- ( j = ( k + K ) -> A = B ) $.
      $( Negative index shift of a finite sum.  (Contributed by NM,
         28-Nov-2005.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
      fsumshftm $p |- ( ph -> sum_ j e. ( M ... N ) A =
                              sum_ k e. ( ( M - K ) ... ( N - K ) ) B ) $=
        ( vm cfz co csu caddc cc wcel cv cmin nfcv nfcsb1v csbeq1a cbvsumi cneg
        csb znegcld wral ralrimiva nfel1 wceq eleq1d rspc mpan9 csbeq1 fsumshft
        zcnd negsubd oveq12d sumeq1d elfzelz subneg syl2anr csbeq1d ovex csbief
        wa syl6eq sumeq2dv 3eqtrd syl5eq ) AGHOPZBDQVNDNUAZBUHZNQZGFUBPZHFUBPZO
        PZCEQZVNBVPDNNBUCDVOBUDZDVOBUEZUFAVQGFUGZRPZHWDRPZOPZDEUAZWDUBPZBUHZEQV
        TWJEQWAAVPWJNEWDGHAFIUIJKABSTZDVNUJVOVNTVPSTZAWKDVNLUKWKWLDVOVNDVPSWBUL
        DUAVOUMBVPSWCUNUOUPDVOWIBUQURAWGVTWJEAWEVRWFVSOAGFAGJUSAFIUSZUTAHFAHKUS
        WMUTVAVBAVTWJCEAWHVTTZVIZWJDWHFRPZBUHCWODWIWPBWNWHSTFSTWIWPUMAWNWHWHVRV
        SVCUSWMWHFVDVEVFDWPBCWHFRVGDCUCMVHVJVKVLVM $.
    $}
  $}

  ${
    $d k A $.  $d j B $.  $d j k M $.  $d j k N $.  $d j k ph $.
    fsumrev2.1 $e |- ( ( ph /\ j e. ( M ... N ) ) -> A e. CC ) $.
    fsumrev2.2 $e |- ( j = ( ( M + N ) - k ) -> A = B ) $.
    $( Reversal of a finite sum.  (Contributed by NM, 27-Nov-2005.)  (Revised
       by Mario Carneiro, 13-Apr-2016.) $)
    fsumrev2 $p |- ( ph -> sum_ j e. ( M ... N ) A =
                           sum_ k e. ( M ... N ) B ) $=
      ( cfz co csu wceq c0 sum0 sumeq1 adantl wcel cmin cz cc0 3eqtr4a wne fzn0
      eqtr4i cuz cfv wa caddc eluzel2 eluzelz zaddcld cv adantlr fsumrev pncand
      cc zcnd pncan2d oveq12d sumeq1d eqtrd sylan2b pm2.61dane ) AFGJKZBDLZVECE
      LZMZVENVENMZVHAVINBDLZNCELZVFVGVJUAVKBDOCEOUEVENBDPVENCEPUBQVENUCAGFUFUGR
      ZVHFGUDAVLUHZVFFGUIKZGSKZVNFSKZJKZCELVGVMBCDEVNFGVMFGVLFTRAFGUJQZVLGTRAFG
      UKQZULVRVSADUMVERBUQRVLHUNIUOVMVQVECEVMVOFVPGJVMFGVMFVRURZVMGVSURZUPVMFGV
      TWAUSUTVAVBVCVD $.
  $}

  ${
    $d j k n x N $.  $d j k n ph $.  $d k n B $.  $d n x A $.  $d n x C $.
    fsum0diag2.1 $e |- ( x = k -> B = A ) $.
    fsum0diag2.2 $e |- ( x = ( k - j ) -> B = C ) $.
    fsum0diag2.3 $e |- ( ( ph /\ ( j e. ( 0 ... N ) /\
                          k e. ( 0 ... ( N - j ) ) ) ) -> A e. CC ) $.
    $( Two ways to express "the sum of ` A ( j , k ) ` over the triangular
       region ` 0 <_ j ` , ` 0 <_ k ` , ` j + k <_ N ` ."  (Contributed by
       Mario Carneiro, 21-Jul-2014.) $)
    fsum0diag2 $p |- ( ph ->
                      sum_ j e. ( 0 ... N ) sum_ k e. ( 0 ... ( N - j ) ) A =
                      sum_ k e. ( 0 ... N ) sum_ j e. ( 0 ... k ) C ) $=
      ( vn cc0 cfz co cmin csu wcel cc wceq cv caddc wa wral fznn0sub2 ad2antll
      csb expr ralrimiv eleq1d cbvralv sylibr adantrr nfcsb1v csbeq1a rspc sylc
      nfel1 fsum0diag mpan9 csbeq1 fsumrev2 cn0 elfz3nn0 ad2antlr elfzelz nn0cn
      cz zcn subcl syl2an syl2anc addid2 syl oveq1d csbeq1d sumeq2dv eqtrd 3syl
      adantl oveq2d adantr sub32 syl3anc sumeq12rdv 3eqtr4d cuz elfzuz3 elfzuzb
      syl3an fzfid cfv sylanbrc wb elfzel2 fzsubel syl22anc mpbid subid eleqtrd
      simpll wss fzss2 sselda fsumcl oveq2 sumeq12dv eqtr4d vex nfcv csbief a1i
      oveq1 sumeq2i ovex 3eqtr3g ) AMHNOZMHFUAZPOZNOZBGUAZDUGZGQZFQZXQMYANOZBYA
      XRPOZDUGZFQZGQZXQXTCGQZFQXQYEEFQZGQAYDXQMMHUBOZLUAZPOZNOZBYNXRPOZDUGZFQZL
      QZYIAXQXTBXSYMPOZDUGZLQZFQXQMHYMPOZNOZUUAFQZLQYDYSAUUAFLHAXRXQRZYMXTRZUCU
      CYTXTRZDSRZBXTUDZUUASRZUUGUUHAUUFYMXSUEUFAUUFUUJUUGAUUFUCZCSRZGXTUDUUJUUL
      UUMGXTAUUFYAXTRZUUMKUHUIUUIUUMBGXTBUAZYATZDCSIUJUKULZUMUUIUUKBYTXTBUUASBY
      TDUNURUUOYTTDUUASBYTDUOUJUPUQUSAXQYCUUBFUULYCXTBMXSUBOZYMPOZDUGZLQUUBUULY
      BUUTGLMXSUULUUJUUNYBSRZUUQUUIUVABYAXTBYBSBYADUNURUUPDYBSBYADUOUJUPUTBYAUU
      SDVAVBUULXTUUTUUALUULUUGUCZBUUSYTDUVBUURXSYMPUVBXSSRZUURXSTUVBHVCRZXRVHRZ
      UVCUUFUVDAUUGXRHVDVEUUFUVEAUUGXRMHVFVEUVDHSRZXRSRZUVCUVEHVGZXRVIZHXRVJVKV
      LXSVMVNVOVPVQVRVQAXQYRUUELAYMXQRZUCZYOUUDYQUUAFUVKYNUUCMNUVKYLHYMPUVKUVDU
      VFYLHTUVJUVDAYMHVDZVTUVHHVMVSVOZWAUVKXRUUDRZUCZBYPYTDUVOYPUUCXRPOZYTUVKYP
      UVPTUVNUVKYNUUCXRPUVMVOWBUVOUVDYMVHRZUVEUVPYTTZUVJUVDAUVNUVLVEUVJUVQAUVNY
      MMHVFVEUVNUVEUVKXRMUUCVFVTUVDUVFUVQYMSRUVEUVGUVRUVHYMVIUVIHYMXRWCWJWDVRVP
      WEVQWFAYHYRGLMHAYAXQRZUCZYEYGFUVTMYAWKUVTXRYERZUCZYFXTRUUJYGSRZUWBYFXRXRP
      OZXSNOZXTUWBYAXRHNORZYFUWERZUWBYAXRWGWLRZHYAWGWLRZUWFUWAUWHUVTXRMYAWHVTUV
      TUWIUWAUVSUWIAYAMHWHVTZWBYAXRHWIWMUWBUVEHVHRZYAVHRZUVEUWFUWGWNUWAUVEUVTXR
      MYAVFVTZUVSUWKAUWAYAMHWOVEUVSUWLAUWAYAMHVFVEUWMYAXRXRHWPWQWRUWBUWDMXSNUWB
      UVEUVGUWDMTUWMUVIXRWSVSVOWTUWBAUUFUUJAUVSUWAXAUVTYEXQXRUVTUWIYEXQXBUWJYAM
      HXCVNXDUUQVLUUIUWCBYFXTBYGSBYFDUNURUUOYFTDYGSBYFDUOUJUPUQXEYAYNTZYEYOYGYQ
      FYAYNMNXFUWNYGYQTUWAUWNBYFYPDYAYNXRPXMVPWBXGVBXHXQYCYJFUUFXTYBCGYBCTUUFUU
      NUCBYADCGXIBCXJIXKXLVQXNXQYHYKGUVSYEYGEFYGETUVSUWAUCBYFDEYAXRPXOBEXJJXKXL
      VQXNXP $.
  $}

  ${
    $d f k m n x A $.  $d f m n x B $.  $d f k m n x C $.  $d f k m n ph $.
    fsummulc2.1 $e |- ( ph -> A e. Fin ) $.
    fsummulc2.2 $e |- ( ph -> C e. CC ) $.
    fsummulc2.3 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( A finite sum multiplied by a constant.  (Contributed by NM,
       12-Nov-2005.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsummulc2 $p |- ( ph ->
                      ( C x. sum_ k e. A B ) = sum_ k e. A ( C x. B ) ) $=
      ( vm c0 wceq csu cmul co cfv wcel c1 wa cc0 cc vf vn chash cn cfz cv wf1o
      mul01d sumeq1 sum0 syl6eq oveq2d eqeq12d syl5ibrcom cmpt caddc ccom addcl
      wex cseq adantl adantr adddi 3expb sylan cuz simprl nnuz syl6eleq wf eqid
      fmptd ad2antrr simprr syl fco syl2anc simpr ffvelrnd mulcld fvmpt2 eqtr4d
      f1of wral ralrimiva nffvmpt1 nfcv nfov nfeq fveq2 rspc sylc fvco3 3eqtr4d
      ad2antll seqdistr ffvelrnda 3eqtr4rd sumfc oveq2i 3eqtr3g exlimdv expimpd
      fsum expr cfn wo fz1f1o mpjaod ) ABJKZDBCELZMNZBDCMNZELZKZBUCOZUDPZQXPUEN
      ZBUAUFZUGZUAUSZRZAXOXJDSMNZSKADGUHXJXLYCXNSXJXKSDMXJXKJCELSBJCEUICEUJUKUL
      XJXNJXMELSBJXMEUIXMEUJUKUMUNAXQYAXOAXQRXTXOUAAXQXTXOAXQXTRZRZDBIUFZEBCUOZ
      OZILZMNZBYFEBXMUOZOZILZXLXNYEXPUPYKXSUQZQUTODXPUPYGXSUQZQUTOZMNYMYJYEUBID
      UPTMYNYOQXPUBUFZTPZYFTPZRZYQYFUPNZTPYEYQYFURVAYEDTPZYTDUUAMNDYQMNDYFMNUPN
      KZAUUBYDGVBUUBYRYSUUCDYQYFVCVDVEYEXPUDQVFOAXQXTVGZVHVIYEYQXRPZRZXRTYQYOUU
      FBTYGVJZXRBXSVJZXRTYOVJAUUGYDUUEAEBCTYGHYGVKZVLZVMUUFXTUUHYEXTUUEAXQXTVNZ
      VBXRBXSWCZVOZXRBTYGXSVPVQYEUUEVRZVSUUFYQXSOZYKOZDUUOYGOZMNZYQYNOZDYQYOOZM
      NUUFUUOBPEUFZYKOZDUVAYGOZMNZKZEBWDZUUPUURKZUUFXRBYQXSUUMUUNVSAUVFYDUUEAUV
      EEBAUVABPZRZUVBXMUVDUVIUVHXMTPUVBXMKAUVHVRZUVIDCAUUBUVHGVBHVTZEBXMTYKYKVK
      ZWAVQUVIUVCCDMUVIUVHCTPUVCCKUVJHEBCTYGUUIWAVQULWBWEVMUVEUVGEUUOBEUUPUUREB
      XMUUOWFEDUUQMEDWGEMWGEBCUUOWFWHWIUVAUUOKZUVBUUPUVDUURUVAUUOYKWJUVMUVCUUQD
      MUVAUUOYGWJULUMWKWLYEUUHUUEUUSUUPKXTUUHAXQUULWOZXRBYQYKXSWMVEZUUFUUTUUQDM
      YEUUHUUEUUTUUQKUVNXRBYQYGXSWMVEZULWNWPYEBYLUUPIUBXSYNXPYFUUOYKWJUUDUUKYEB
      TYFYKABTYKVJYDAEBXMTYKUVKUVLVLVBWQUVOXDYEYIYPDMYEBYHUUQIUBXSYOXPYFUUOYGWJ
      UUDUUKYEBTYFYGAUUGYDUUJVBWQUVPXDULWRYIXKDMBCIEWSWTBXMIEWSXAXEXBXCABXFPXJY
      BXGFBUAXHVOXI $.

    $( A finite sum multiplied by a constant.  (Contributed by NM,
       13-Nov-2005.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsummulc1 $p |- ( ph ->
                      ( sum_ k e. A B x. C ) = sum_ k e. A ( B x. C ) ) $=
      ( csu cmul co fsummulc2 fsumcl mulcomd cv wcel wa cc adantr sumeq2dv
      3eqtr4d ) ADBCEIZJKBDCJKZEIUBDJKBCDJKZEIABCDEFGHLAUBDABCEFHMGNABUDUCEAEOB
      PZQCDHADRPUEGSNTUA $.

    fsumdivc.4 $e |- ( ph -> C =/= 0 ) $.
    $( A finite sum divided by a constant.  (Contributed by NM, 2-Jan-2006.)
       (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsumdivc $p |- ( ph -> ( sum_ k e. A B / C ) = sum_ k e. A ( B / C ) ) $=
      ( csu c1 cdiv co cmul reccld fsummulc1 fsumcl divrecd wcel adantr cc0 wne
      cv wa cc sumeq2dv 3eqtr4d ) ABCEJZKDLMZNMBCUINMZEJUHDLMBCDLMZEJABCUIEFADG
      IOHPAUHDABCEFHQGIRABUKUJEAEUCBSZUDCDHADUESULGTADUAUBULITRUFUG $.
  $}

  ${
    $d k A $.  $d k ph $.
    fsumneg.1 $e |- ( ph -> A e. Fin ) $.
    fsumneg.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( Negation of a finite sum.  (Contributed by Scott Fenton, 12-Jun-2013.)
       (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsumneg $p |- ( ph -> sum_ k e. A -u B = -u sum_ k e. A B ) $=
      ( c1 cneg csu cmul co cc wcel neg1cn a1i fsummulc2 fsumcl mulm1d cv wa
      sumeq2dv 3eqtr3rd ) AGHZBCDIZJKBUCCJKZDIUDHBCHZDIABCUCDEUCLMANOFPAUDABCDE
      FQRABUEUFDADSBMTCFRUAUB $.

    fsumsub.3 $e |- ( ( ph /\ k e. A ) -> C e. CC ) $.
    $( Split a finite sum over a subtraction.  (Contributed by Scott Fenton,
       12-Jun-2013.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsumsub $p |- ( ph -> sum_ k e. A ( B - C ) =
                        ( sum_ k e. A B - sum_ k e. A C ) ) $=
      ( cneg caddc co csu cmin cv wcel wa negcld fsumadd negsubd fsumcl fsumneg
      oveq2d eqtrd sumeq2dv 3eqtr3d ) ABCDIZJKZELZBCELZBDELZIZJKZBCDMKZELUIUJMK
      AUHUIBUFELZJKULABCUFEFGAENBOPZDHQRAUNUKUIJABDEFHUAUBUCABUGUMEUOCDGHSUDAUI
      UJABCEFGTABDEFHTSUE $.
  $}

  ${
    $d j k A $.  $d j k B $.  $d k C $.  $d j D $.  $d j k ph $.
    fsum2mul.1 $e |- ( ph -> A e. Fin ) $.
    fsum2mul.2 $e |- ( ph -> B e. Fin ) $.
    fsum2mul.3 $e |- ( ( ph /\ j e. A ) -> C e. CC ) $.
    fsum2mul.4 $e |- ( ( ph /\ k e. B ) -> D e. CC ) $.
    $( Separate the nested sum of the product ` C ( j ) x. D ( k ) ` .
       (Contributed by NM, 13-Nov-2005.)  (Revised by Mario Carneiro,
       24-Apr-2014.) $)
    fsum2mul $p |- ( ph -> sum_ j e. A sum_ k e. B ( C x. D ) =
                           ( sum_ j e. A C x. sum_ k e. B D ) ) $=
      ( csu cmul co fsumcl fsummulc1 cv wcel wa cfn adantr cc adantlr fsummulc2
      sumeq2dv eqtr2d ) ABDFLCEGLZMNBDUGMNZFLBCDEMNGLZFLABDUGFHACEGIKOJPABUHUIF
      AFQBRZSCEDGACTRUJIUAJAGQCREUBRUJKUCUDUEUF $.
  $}

  ${
    $d f k n A $.  $d f k n B $.
    $( The sum of constant terms ( ` k ` is not free in ` A ` ).  (Contributed
       by NM, 24-Dec-2005.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsumconst $p |- ( ( A e. Fin /\ B e. CC ) ->
                      sum_ k e. A B = ( ( # ` A ) x. B ) ) $=
      ( vf vn wcel cc wa c0 wceq csu chash cfv cmul co cn c1 cv cc0 syl6eq wf1o
      cfn cfz wex mul02 adantl eqcomd sumeq1 sum0 fveq2 hash0 oveq1d syl5ibrcom
      eqeq12d caddc csn cxp eqidd simprl simprr simpllr simplr elfznn fvconst2g
      cseq syl2an fsum ser1const ad2ant2lr eqtrd expr exlimdv expimpd wo fz1f1o
      adantr mpjaod ) AUBFZBGFZHZAIJZABCKZALMZBNOZJZWCPFZQWCUCOZADRZUAZDUDZHZVT
      WEWASSBNOZJVTWLSVSWLSJVRBUEUFUGWAWBSWDWLWAWBIBCKSAIBCUHBCUITWAWCSBNWAWCIL
      MSAILUJUKTULUNUMVTWFWJWEVTWFHWIWEDVTWFWIWEVTWFWIHZHZWBWCUOPBUPUQZQVEMZWDW
      NABBCEWHWOWCCRZERZWHMJBURVTWFWIUSVTWFWIUTVRVSWMWQAFVAWNVSWRPFWRWOMBJWRWGF
      VRVSWMVBWRWCVCPBWRGVDVFVGVSWFWPWDJVRWIBWCVHVIVJVKVLVMVRWAWKVNVSADVOVPVQ
      $.
  $}

  ${
    $d k m x y A $.  $d m x y B $.  $d k C $.  $d k M $.  $d k m x y ph $.
    fsumge0.1 $e |- ( ph -> A e. Fin ) $.
    fsumge0.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
    fsumge0.3 $e |- ( ( ph /\ k e. A ) -> 0 <_ B ) $.
    $( If all of the terms of a finite sum are nonnegative, so is the sum.
       (Contributed by NM, 26-Dec-2005.)  (Revised by Mario Carneiro,
       24-Apr-2014.) $)
    fsumge0 $p |- ( ph -> 0 <_ sum_ k e. A B ) $=
      ( vx vy cc0 co wcel cle wbr cc cr cv elrege0 a1i wa csu cpnf cico simplbi
      wss ssriv ax-resscn sstri ge0addcl adantl sylanbrc 0re mpbir2an fsumcllem
      caddc 0le0 simprbi syl ) ABCDUAZJUBUCKZLZJUSMNZAHIBCUTDUTOUEAUTPOHUTPHQZU
      TLZVCPLJVCMNVCRUDUFUGUHSVDIQZUTLTVCVEUOKUTLAVCVEUIUJEADQBLTCPLJCMNCUTLFGC
      RUKJUTLZAVFJPLJJMNULUPJRUMSUNVAUSPLVBUSRUQUR $.

    ${
      fsumless.4 $e |- ( ph -> C C_ A ) $.
      $( A shorter sum of nonnegative terms is smaller than a longer one.
         (Contributed by NM, 26-Dec-2005.)  (Proof shortened by Mario Carneiro,
         24-Apr-2014.) $)
      fsumless $p |- ( ph -> sum_ k e. C B <_ sum_ k e. A B ) $=
        ( csu cle cc0 wbr cfn wcel wss ssfi sylan2 fsumrecl wceq caddc co difss
        cdif sylancl cv eldifi fsumge0 syl2anc sselda syldan addge01d mpbid cin
        cr c0 disjdif a1i cun undif sylib eqcomd wa recnd fsumsplit breqtrrd )
        ADCEJZVGBDUDZCEJZUAUBZBCEJKALVIKMVGVJKMAVHCEABNOZVHBPVHNOFBDUCBVHQUEZEU
        FZVHOZAVMBOZCUOOZVMBDUGZGRZVNAVOLCKMVQHRUHAVGVIADCEAVKDBPZDNOFIBDQUIAVM
        DOVOVPADBVMIUJGUKSAVHCEVLVRSULUMADVHCBEDVHUNUPTADBUQURADVHUSZBAVSVTBTID
        BUTVAVBFAVOVCCGVDVEVF $.
    $}

    ${
      fsumge1.4 $e |- ( k = M -> B = C ) $.
      fsumge1.5 $e |- ( ph -> M e. A ) $.
      $( A sum of nonnegative numbers is greater than or equal to any one of
         its terms.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof
         shortened by Mario Carneiro, 4-Jun-2014.) $)
      fsumge1 $p |- ( ph -> C <_ sum_ k e. A B ) $=
        ( csn csu cle wcel cc wceq wral cv wa recnd ralrimiva eleq1d rspcv sylc
        sumsn syl2anc snssd fsumless eqbrtrrd ) AFLZCEMZDBCEMNAFBOZDPOZULDQKAUM
        CPOZEBRUNKAUOEBAESZBOTCHUAUBUOUNEFBUPFQCDPJUCUDUECDEFBJUFUGABCUKEGHIAFB
        KUHUIUJ $.
    $}

    $( A sum of nonnegative numbers is zero iff all terms are zero.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 24-Apr-2014.) $)
    fsum00 $p |- ( ph -> ( sum_ k e. A B = 0 <-> A. k e. A B = 0 ) ) $=
      ( vm csu cc0 wceq wral wa cv wcel cle wbr adantr cr adantlr csb csn snssi
      cfn wss adantl fsumless cc simpr jca ralrimiva nfcsb1v nfel1 nfcv csbeq1a
      nfbr nfan eleq1d breq2d anbi12d mpan9 simpld recnd sumsns syl2anc 3brtr3d
      rspc simplr simprd wb letri3 sylancl mpbir2and nfeq1 eqeq1d cbvral sylibr
      0re nfv ex wi cuz cfv sumz olcs sumeq2 syl5ibrcom syl impbid ) ABCDIZJKZC
      JKZDBLZAWKWMAWKMZDHNZCUAZJKZHBLWMWNWQHBWNWOBOZMZWQWPJPQZJWPPQZWSWOUBZCDIZ
      WJWPJPAWRXCWJPQWKAWRMBCXBDABUDOZWRERADNZBOZCSOZWRFTAXFJCPQZWRGTWRXBBUEAWO
      BUCUFUGTWSWRWPUHOXCWPKWNWRUIWSWPWSWPSOZXAWNXGXHMZDBLZWRXIXAMZAXKWKAXJDBAX
      FMXGXHFGUJUKRXJXLDWOBXIXADDWPSDWOCULZUMDJWPPDJUNDPUNXMUPUQXEWOKZXGXIXHXAX
      NCWPSDWOCUOZURXNCWPJPXOUSUTVGVAZVBZVCCDWOBVDVEAWKWRVHVFWSXIXAXPVIWSXIJSOW
      QWTXAMVJXQVRWPJVKVLVMUKWLWQDHBWLHVSDWPJXMVNXNCWPJXOVOVPVQVTAXDWMWKWAEXDWK
      WMBJDIZJKZBJWBWCUEXDXSBDJWDWEWMWJXRJBCJDWFVOWGWHWI $.
  $}

  ${
    $d k A $.  $d k ph $.
    fsumle.1 $e |- ( ph -> A e. Fin ) $.
    fsumle.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
    fsumle.3 $e |- ( ( ph /\ k e. A ) -> C e. RR ) $.
    fsumle.4 $e |- ( ( ph /\ k e. A ) -> B <_ C ) $.
    $( If all of the terms of finite sums compare, so do the sums.
       (Contributed by NM, 11-Dec-2005.)  (Proof shortened by Mario Carneiro,
       24-Apr-2014.) $)
    fsumle $p |- ( ph -> sum_ k e. A B <_ sum_ k e. A C ) $=
      ( cc0 csu cmin co cle wbr cv wcel subge0d recnd fsumrecl resubcld fsumge0
      wa mpbird fsumsub breqtrd mpbid ) AJBDEKZBCEKZLMZNOUIUHNOAJBDCLMZEKUJNABU
      KEFAEPBQUCZDCHGUAULJUKNOCDNOIULDCHGRUDUBABDCEFULDHSULCGSUEUFAUHUIABDEFHTA
      BCEFGTRUG $.
  $}

  ${
    $d k A $.  $d k ph $.
    fsumlt.1 $e |- ( ph -> A e. Fin ) $.
    fsumlt.2 $e |- ( ph -> A =/= (/) ) $.
    fsumlt.3 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
    fsumlt.4 $e |- ( ( ph /\ k e. A ) -> C e. RR ) $.
    fsumlt.5 $e |- ( ( ph /\ k e. A ) -> B < C ) $.
    $( If every term in one finite sum is less than the corresponding term in
       another, then the first sum is less than the second.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 3-Jun-2014.) $)
    fsumlt $p |- ( ph -> sum_ k e. A B < sum_ k e. A C ) $=
      ( csu clt wbr cc0 cmin co wcel cr recnd fsumrecl cv wa crp wb difrp mpbid
      syl2anc fsumrpcl rpgt0d fsumsub breqtrd posdifd mpbird ) ABCEKZBDEKZLMNUO
      UNOPZLMANBDCOPZEKZUPLAURABUQEFGAEUABQUBZCDLMZUQUCQZJUSCRQDRQUTVAUDHICDUEU
      GUFUHUIABDCEFUSDISUSCHSUJUKAUNUOABCEFHTABDEFITULUM $.
  $}

  ${
    $d k w x y A $.  $d w x y B $.  $d k w x y ph $.
    fsumabs.1 $e |- ( ph -> A e. Fin ) $.
    fsumabs.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( Generalized triangle inequality: the absolute value of a finite sum is
       less than or equal to the sum of absolute values.  (Contributed by NM,
       9-Nov-2005.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    fsumabs $p |- ( ph ->
                    ( abs ` sum_ k e. A B ) <_ sum_ k e. A ( abs ` B ) ) $=
      ( wss csu cabs cfv cle wbr wcel wi c0 wceq sumeq1 fveq2d caddc cc vw ssid
      vx vy cfn csn cun sseq1 breq12d imbi12d imbi2d cc0 0le0 sum0 fveq2i eqtri
      cv abs0 3brtr4i a1ii wn wa ssun1 sstr mpan imim1i csb co simpll syl simpr
      unssad ssfi syl2anc sselda sylan syldan fsumcl abscld fsumrecl unssbd vex
      wral snss sylibr ralrimiva nfcsb1v nfel1 csbeq1a eleq1d rspc sylc leadd1d
      cin simplr disjsn eqidd recnd fsumsplit cvv csbfv2g ax-mp syl5eqel sumsns
      sylancr syl6eq oveq2d eqtrd breq2d bitr4d abstrid eqbrtrd cr letr syl3anc
      readdcld mpand sylbid ex a2d syl5 expcom adantl findcard2s mpcom mpi ) AB
      BGZBCDHZIJZBCIJZDHZKLZBUBBUEMZAYGYLNZEAUAUQZBGZYOCDHZIJZYOYJDHZKLZNZNAOBG
      ZOCDHZIJZOYJDHZKLZNZNAUCUQZBGZUUHCDHZIJZUUHYJDHZKLZNZNZAUUHUDUQZUFZUGZBGZ
      UURCDHZIJZUURYJDHZKLZNZNZAYNNUAUCUDBYOOPZUUAUUGAUVFYPUUBYTUUFYOOBUHUVFYRU
      UDYSUUEKUVFYQUUCIYOOCDQRYOOYJDQUIUJUKYOUUHPZUUAUUNAUVGYPUUIYTUUMYOUUHBUHU
      VGYRUUKYSUULKUVGYQUUJIYOUUHCDQRYOUUHYJDQUIUJUKYOUURPZUUAUVDAUVHYPUUSYTUVC
      YOUURBUHUVHYRUVAYSUVBKUVHYQUUTIYOUURCDQRYOUURYJDQUIUJUKYOBPZUUAYNAUVIYPYG
      YTYLYOBBUHUVIYRYIYSYKKUVIYQYHIYOBCDQRYOBYJDQUIUJUKAUUBUUFULULUUDUUEKUMUUD
      ULIJULUUCULICDUNUOURUPYJDUNUSUTUUPUUHMVAZUUOUVENUUHUEMZUVJAUUNUVDAUVJUUNU
      VDNUUNUUSUUMNAUVJVBZUVDUUSUUIUUMUUHUURGUUSUUIUUHUUQVCUUHUURBVDVEVFUVLUUSU
      UMUVCUVLUUSUUMUVCNUVLUUSVBZUUMUUKDUUPCVGZIJZSVHZUVBKLZUVCUVMUUMUVPUULUVOS
      VHZKLUVQUVMUUKUULUVOUVMUUJUVMUUHCDUVMYMUUIUVKUVMAYMAUVJUUSVIZEVJZUVMUUHUU
      QBUVLUUSVKZVLZBUUHVMVNZUVMDUQZUUHMZUWDBMZCTMZUVMUUHBUWDUWBVOUVMAUWFUWGUVS
      FVPZVQZVRZVSZUVMUUHYJDUWCUVMUWEVBCUWIVSVTUVMUVNUVMUUPBMZUWGDBWCZUVNTMZUVM
      UUQBGUWLUVMUUHUUQBUWAWAUUPBUDWBZWDWEZUVMAUWMUVSAUWGDBFWFVJUWGUWNDUUPBDUVN
      TDUUPCWGWHUWDUUPPCUVNTDUUPCWIWJWKWLZVSZWMUVMUVBUVRUVPKUVMUVBUULUUQYJDHZSV
      HUVRUVMUUHUUQYJUURDUVMUVJUUHUUQWNOPAUVJUUSWOUUHUUPWPWEZUVMUURWQZUVMYMUUSU
      URUEMUVTUWABUURVMVNZUVMUWDUURMZVBZYJUXDCUVMUXCUWFUWGUVMUURBUWDUWAVOUWHVQZ
      VSZWRWSUVMUWSUVOUULSUVMUWSDUUPYJVGZUVOUVMUUPWTMZUXGTMUWSUXGPUWOUVMUXGUVOT
      UXHUXGUVOPUWODUUPCWTIXAXBZUVMUVOUWRWRXCYJDUUPWTXDXEUXIXFXGXHXIXJUVMUVAUVP
      KLZUVQUVCUVMUVAUUJUVNSVHZIJUVPKUVMUUTUXKIUVMUUTUUJUUQCDHZSVHUXKUVMUUHUUQC
      UURDUWTUXAUXBUXEWSUVMUXLUVNUUJSUVMUWLUWNUXLUVNPUWPUWQCDUUPBXDVNXGXHRUVMUU
      JUVNUWJUWQXKXLUVMUVAXMMUVPXMMUVBXMMUXJUVQVBUVCNUVMUUTUVMUURCDUXBUXEVRVSUV
      MUUKUVOUWKUWRXPUVMUURYJDUXBUXFVTUVAUVPUVBXNXOXQXRXSXTYAYBXTYCYDYEYF $.
  $}

  ${
    $d j A $.  $d k B $.  $d k C $.  $d j k M $.  $d j k N $.  $d j k ph $.
    $d k D $.  $d k E $.
    fsumtscopo.1 $e |- ( k = j -> A = B ) $.
    fsumtscopo.2 $e |- ( k = ( j + 1 ) -> A = C ) $.
    fsumtscopo.3 $e |- ( k = M -> A = D ) $.
    fsumtscopo.4 $e |- ( k = N -> A = E ) $.
    fsumtscopo.5 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fsumtscopo.6 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    $( Sum of a telescoping series, using half-open intervals.  (Contributed by
       Mario Carneiro, 2-May-2016.) $)
    fsumtscopo $p |- ( ph -> sum_ j e. ( M ..^ N ) ( B - C ) = ( D - E ) ) $=
      ( wceq co wcel cc cfzo cmin csu c1 caddc cuz cfv cc0 cfz wral eluzfz1 syl
      wa c0 ralrimiva eleq1d rspcv sylc adantr subidd sum0 syl6reqr adantl fzo0
      cv oveq2 syl6eq sumeq1d wi eqeq1 eqeq1d imbi12d vtoclg imp oveq2d 3eqtr4d
      sylan cfn a1i elfzofz fzofzp1 fsumsub cbvsumv cz eluzel2 eluzp1m1 eluzelz
      fzofi fzoval fzossfz syl6eqssr sselda adantlr syldan fsum1p syl5eqr simpr
      wss fzp1ss fsumm1 1z peano2zd fsumshftm zcnd ax-1cn sylancl oveq1d eqtr4d
      pncan eqtrd sylan2 fsumcl eluzfz2 addcomd eqtr3d 3eqtr3d oveq12d pnpcan2d
      wo uzp1 mpjaodan ) AJIQZIJUARZCDUBRZFUCZEHUBRZQJIUDUERZUFUGSZAYBUMZUNYDFU
      CZEEUBRZYEYFYIYKUHYJYIEAETSZYBAIIJUIRZSZBTSZGYMUJZYLAJIUFUGZSZYNOIJUKULAY
      OGYMPUOZYOYLGIYMGVEZIQZBETMUPUQURZUSUTYDFVAVBYIYCUNYDFYIYCIIUARZUNYBYCUUC
      QAJIIUAVFVCIVDVGVHYIHEEUBAYRYBHEQZOYRYBUUDUUABEQZVIYBUUDVIGJYQYTJQZUUAYBU
      UEUUDYTJIVJUUFBHENVKVLMVMVNVQVOVPAYHUMZYEYCCFUCZYCDFUCZUBRZYFAYEUUJQYHAYC
      CDFYCVRSAIJWHVSAFVEZYCSZUMZUUKYMSZYPCTSZUULUUNAUUKIJVTVCAYPUULYSUSZYOUUOG
      UUKYMYTUUKQBCTKUPUQURUUMUUKUDUERZYMSZYPDTSZUULUURAIJUUKWAVCUUPYOUUSGUUQYM
      YTUUQQBDTLUPUQURWBUSUUGUUJEYGJUARZBGUCZUERZHUVAUERZUBRZYFUUGUUHUVBUUIUVCU
      BUUGUUHYCBGUCZUVBYCBCGFKWCUUGIJUDUBRZUIRZBGUCEYGUVFUIRZBGUCZUERUVEUVBUUGB
      EGIUVFAIWDSZYHUVFYQSAYRUVJOIJWEULZIJWFVQUUGYTUVGSYTYMSZYOUUGUVGYMYTUUGUVG
      YCYMUUGJWDSZYCUVGQZAUVMYHAYRUVMOIJWGULZUSZIJWIZULZIJWJWKWLAUVLYOYHPWMWNMW
      OUUGYCUVGBGUVRVHUUGUVAUVIEUEUUGUUTUVHBGUUGUVMUUTUVHQZUVPYGJWIZULVHVOVPWPU
      UGYGJUIRZBGUCZUVIHUERZUUIUVCUUGBHGYGJAYHWQAYTUWASZYOYHAUWDUVLYOAUWAYMYTAU
      VJUWAYMWRUVKIJWSULWLPWNZWMNWTAUWBUUIQYHAUWBYGUDUBRZUVFUIRZDFUCUUIABDGFUDY
      GJUDWDSAXAVSAIUVKXBUVOUWELXCAUWGYCDFAUWGUVGYCAUWFIUVFUIAITSUDTSUWFIQAIUVK
      XDXEIUDXIXFXGAUVMUVNUVOUVQULXHVHXJUSAUWCUVCQYHAUVAHUERUWCUVCAUVAUVIHUEAUU
      TUVHBGAUVMUVSUVOUVTULVHXGAUVAHAUUTBGUUTVRSAYGJWHVSYTUUTSAUWDYOYTYGJVTUWEX
      KXLZAJYMSZYPHTSZAYRUWIOIJXMULYSYOUWJGJYMUUFBHTNUPUQURZXNXOUSXPXQAUVDYFQYH
      AEHUVAUUBUWKUWHXRUSXJXJAYRYBYHXSOIJXTULYA $.

    $( Sum of a telescoping series.  (Contributed by Mario Carneiro,
       2-May-2016.) $)
    fsumtscopo2 $p |- ( ph -> sum_ j e. ( M ..^ N ) ( C - B ) = ( E - D ) ) $=
      ( co cneg wcel cc cfzo cmin csu cv wceq negeqd c1 caddc cfz wa fsumtscopo
      negcld wral ralrimiva elfzofz eleq1d rspccva syl2an neg2subd sumeq2dv cuz
      fzofzp1 cfv eluzfz1 syl rspcv sylc eluzfz2 3eqtr3d ) AIJUAQZCRZDRZUBQZFUC
      ERZHRZUBQVJDCUBQZFUCHEUBQABRVKVLVNFGVOIJGUDZFUDZUEZBCKUFVQVRUGUHQZUEZBDLU
      FVQIUEZBEMUFVQJUEZBHNUFOAVQIJUIQZSUJBPULUKAVJVMVPFAVRVJSZUJCDABTSZGWDUMZV
      RWDSCTSZWEAWFGWDPUNZVRIJUOWFWHGVRWDVSBCTKUPUQURAWGVTWDSDTSZWEWIIJVRVBWFWJ
      GVTWDWABDTLUPUQURUSUTAEHAIWDSZWGETSZAJIVAVCSZWKOIJVDVEWIWFWLGIWDWBBETMUPV
      FVGAJWDSZWGHTSZAWMWNOIJVHVEWIWFWOGJWDWCBHTNUPVFVGUSVI $.
  $}

  ${
    $d j A $.  $d k B $.  $d k C $.  $d j k M $.  $d j k N $.  $d j k ph $.
    $d k D $.  $d k E $.
    fsumtscop.1 $e |- ( k = j -> A = B ) $.
    fsumtscop.2 $e |- ( k = ( j + 1 ) -> A = C ) $.
    fsumtscop.3 $e |- ( k = M -> A = D ) $.
    fsumtscop.4 $e |- ( k = ( N + 1 ) -> A = E ) $.
    fsumtscop.5 $e |- ( ph -> N e. ZZ ) $.
    fsumtscop.6 $e |- ( ph -> ( N + 1 ) e. ( ZZ>= ` M ) ) $.
    fsumtscop.7 $e |- ( ( ph /\ k e. ( M ... ( N + 1 ) ) ) -> A e. CC ) $.
    $( Sum of a telescoping series.  (Contributed by Scott Fenton,
       24-Apr-2014.)  (Revised by Mario Carneiro, 2-May-2016.) $)
    fsumtscop $p |- ( ph -> sum_ j e. ( M ... N ) ( B - C ) = ( D - E ) ) $=
      ( co cmin csu cfz c1 caddc cfzo wcel wceq fzval3 sumeq1d fsumtscopo eqtrd
      cz syl ) AIJUARZCDSRZFTIJUBUCRZUDRZUNFTEHSRAUMUPUNFAJUKUEUMUPUFOIJUGULUHA
      BCDEFGHIUOKLMNPQUIUJ $.

    $( Sum of a telescoping series.  (Contributed by Mario Carneiro,
       15-Jun-2014.)  (Revised by Mario Carneiro, 2-May-2016.) $)
    fsumtscop2 $p |- ( ph -> sum_ j e. ( M ... N ) ( C - B ) = ( E - D ) ) $=
      ( co cmin csu cfz c1 caddc cfzo cz wcel wceq fzval3 syl fsumtscopo2 eqtrd
      sumeq1d ) AIJUARZDCSRZFTIJUBUCRZUDRZUNFTHESRAUMUPUNFAJUEUFUMUPUGOIJUHUIUL
      ABCDEFGHIUOKLMNPQUJUK $.
  $}

  ${
    $d j A $.  $d k B $.  $d k C $.  $d k D $.  $d k E $.  $d j V $.  $d k W $.
    $d j k M $.  $d j k N $.  $d j k ph $.  $d k X $.  $d k Y $.  $d k Z $.
    fsumparts.b $e |- ( k = j -> ( A = B /\ V = W ) ) $.
    fsumparts.c $e |- ( k = ( j + 1 ) -> ( A = C /\ V = X ) ) $.
    fsumparts.d $e |- ( k = M -> ( A = D /\ V = Y ) ) $.
    fsumparts.e $e |- ( k = N -> ( A = E /\ V = Z ) ) $.
    fsumparts.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fsumparts.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    fsumparts.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> V e. CC ) $.
    $( Summation by parts.  (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    fsumparts $p |- ( ph -> sum_ j e. ( M ..^ N ) ( B x. ( X - W ) ) =
      ( ( ( E x. Z ) - ( D x. Y ) ) -
        sum_ j e. ( M ..^ N ) ( ( C - B ) x. X ) ) ) $=
      ( wceq cfzo co cmin cmul csu c1 caddc cuz cfv wcel wa cc0 sum0 0cn subidi
      c0 eqtr4i simpr oveq2d fzo0 syl6eq sumeq1d cfz eluzfz1 wi cv eqtr3 oveq12
      syl 3syl adantr eqeq12d pm5.74da eqidd vtoclg sylan oveq1d wral ralrimiva
      cc simpld eleq1d rspcv sylc simprd mulcld subidd eqtrd oveq12d 3eqtr4a cz
      imp wss eluzel2 fzp1ss sselda adantlr syldan fsumm1 eluzelz fzoval ax-1cn
      pncan sylancl eqtr4d 1z a1i peano2zd fsumshftm 3eqtr4d cfn fzofi peano2uz
      zcnd fzoss1 elfzofz sylan2 fsumcl eluzfz2 addcomd fzofzp1 rspccva subdird
      uzid 4syl syl2an sumeq2dv fsumsub subsub3d subcld nnncan1d eleq2d biimpar
      eluzp1m1 fsum1p cbvsumv subsub4d subdid 3eqtrrd wo uzp1 mpjaodan ) AJIUCZ
      IJUDUEZCMLUFUEUGUEZFUHZHOUGUEZENUGUEZUFUEZUUGDCUFUEMUGUEZFUHZUFUEZUCJIUIU
      JUEZUKULUMZAUUFUNZUSUUHFUHZUOUOUFUEZUUIUUOUUSUOUUTUUHFUPUOUQURUTUURUUGUSU
      UHFUURUUGIIUDUEUSUURJIIUDAUUFVAVBIVCVDZVEUURUULUOUUNUOUFUURUULUUKUUKUFUEZ
      UOUURUUJUUKUUKUFAIIJVFUEZUMZUUFUUJUUKUCZAJIUKULZUMZUVDTIJVGVLZUVDUUFUVEUU
      FBKUGUEZUVIUCZVHUUFUVEVHGIUVCGVIZIUCZUUFUVJUVEUVLUUFUNZUVIUUJUVIUUKUVMUVK
      JUCZBHUCZKOUCZUNZUVIUUJUCZUVKJIVJSBHKOUGVKZVMUVLUVIUUKUCZUUFUVLBEUCZKNUCZ
      UNUVTRBEKNUGVKVLZVNVOVPUUFUVIVQVRWOVSVTAUVBUOUCUUFAUUKAENAUVDBWCUMZGUVCWA
      ZEWCUMZUVHAUWDGUVCUAWBZUWDUWFGIUVCUVLBEWCUVLUWAUWBRWDWEWFWGAUVDKWCUMZGUVC
      WAZNWCUMZUVHAUWHGUVCUBWBZUWHUWJGIUVCUVLKNWCUVLUWAUWBRWHWEWFWGWIZWJVNWKUUR
      UUNUSUUMFUHUOUURUUGUSUUMFUVAVEUUMFUPVDWLWMAUUQUNZUUOUULUUJUUGCMUGUEZFUHZU
      UPJUDUEZUVIGUHZUFUEZUFUEZUFUEUWRUUKUFUEZUUIUWMUUNUWSUULUFUWMUUGDMUGUEZFUH
      ZUWOUFUEZUUJUWQUJUEZUWOUFUEUUNUWSUWMUXBUXDUWOUFUWMUXBUWQUUJUJUEZUXDUWMUUP
      JVFUEZUVIGUHZUUPJUIUFUEZVFUEZUVIGUHZUUJUJUEUXBUXEUWMUVIUUJGUUPJAUUQVAUWMU
      VKUXFUMUVKUVCUMZUVIWCUMZUWMUXFUVCUVKUWMIWNUMZUXFUVCWPAUXMUUQAUVGUXMTIJWQV
      LZVNZIJWRVLWSAUXKUXLUUQAUXKUNBKUAUBWIZWTXAZUVNUVQUVRSUVSVLXBUWMUXBUUPUIUF
      UEZUXHVFUEZUXAFUHUXGUWMUUGUXSUXAFUWMUUGIUXHVFUEZUXSUWMJWNUMZUUGUXTUCAUYAU
      UQAUVGUYATIJXCVLVNZIJXDVLZUWMUXRIUXHVFUWMIWCUMUIWCUMUXRIUCUWMIUXOXQXEIUIX
      FXGVTXHVEUWMUVIUXAGFUIUUPJUIWNUMUWMXIXJUWMIUXOXKUYBUXQUVKFVIZUIUJUEZUCZBD
      UCZKMUCZUNUVIUXAUCQBDKMUGVKVLXLXHUWMUWQUXJUUJUJUWMUWPUXIUVIGUWMUYAUWPUXIU
      CUYBUUPJXDVLVEZVTXMUWMUWQUUJUWMUWPUVIGUWPXNUMUWMUUPJXOXJUWMUVKUWPUMUVKUUG
      UMZUXLUWMUWPUUGUVKUWMUXMIUVFUMUUPUVFUMUWPUUGWPUXOIYGIIXPUUPIJXRYHWSAUYJUX
      LUUQUYJAUXKUXLUVKIJXSUXPXTWTZXAYAZAUUJWCUMUUQAHOAJUVCUMZUWEHWCUMZAUVGUYMT
      IJYBVLZUWGUWDUYNGJUVCUVNBHWCUVNUVOUVPSWDWEWFWGAUYMUWIOWCUMZUYOUWKUWHUYPGJ
      UVCUVNKOWCUVNUVOUVPSWHWEWFWGWIVNZYCWKVTAUUNUXCUCUUQAUUNUUGUXAUWNUFUEZFUHU
      XCAUUGUUMUYRFAUYDUUGUMZUNZDCMAUWEUYEUVCUMZDWCUMZUYSUWGIJUYDYDZUWDVUBGUYEU
      VCUYFBDWCUYFUYGUYHQWDWEYEYIZAUWEUYDUVCUMZCWCUMZUYSUWGUYDIJXSZUWDVUFGUYDUV
      CUVKUYDUCZBCWCVUHBCUCZKLUCZPWDWEYEYIZAUWIVUAMWCUMZUYSUWKVUCUWHVULGUYEUVCU
      YFKMWCUYFUYGUYHQWHWEYEYIZYFYJAUUGUXAUWNFUUGXNUMAIJXOXJZUYTDMVUDVUMWIUYTCM
      VUKVUMWIZYKWKVNUWMUUJUWOUWQUYQAUWOWCUMUUQAUUGUWNFVUNVUOYAVNZUYLYLXMVBUWMU
      UJUUKUWRUYQAUUKWCUMUUQUWLVNZUWMUWOUWQVUPUYLYMYNUWMUWOUWQUUKUJUEZUFUEUWOUU
      GCLUGUEZFUHZUFUEZUWTUUIUWMVURVUTUWOUFUWMVURUUGUVIGUHZVUTUWMVURUUKUWQUJUEZ
      VVBUWMUWQUUKUYLVUQYCUWMUXTUVIGUHUUKUXJUJUEVVBVVCUWMUVIUUKGIUXHAUXMUUQUXHU
      VFUMUXNIJYQVSUWMUVKUXTUMZUYJUXLUWMUYJVVDUWMUUGUXTUVKUYCYOYPUYKXAUWCYRUWMU
      UGUXTUVIGUYCVEUWMUWQUXJUUKUJUYIVBXMXHUUGUVIVUSGFVUHVUIVUJUNUVIVUSUCPBCKLU
      GVKVLYSVDVBUWMUWOUWQUUKVUPUYLVUQYTAUUIVVAUCUUQAUUIUUGUWNVUSUFUEZFUHVVAAUU
      GUUHVVEFUYTCMLVUKVUMAUWIVUELWCUMZUYSUWKVUGUWHVVFGUYDUVCVUHKLWCVUHVUIVUJPW
      HWEYEYIZUUAYJAUUGUWNVUSFVUNVUOUYTCLVUKVVGWIYKWKVNXMUUBAUVGUUFUUQUUCTIJUUD
      VLUUE $.
  $}

  ${
    $d f k m x y A $.  $d f m x y B $.  $d f k m x y F $.  $d f k m x y ph $.
    fsumre.1 $e |- ( ph -> A e. Fin ) $.
    fsumre.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    ${
      fsumrelem.3 $e |- F : CC --> CC $.
      fsumrelem.4 $e |- ( ( x e. CC /\ y e. CC ) ->
        ( F ` ( x + y ) ) = ( ( F ` x ) + ( F ` y ) ) ) $.
      $( Lemma for ~ fsumre , ~ fsumim , and ~ fsumcj .  (Contributed by Mario
         Carneiro, 25-Jul-2014.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
      fsumrelem $p |- ( ph
          -> ( F ` sum_ k e. A B ) = sum_ k e. A ( F ` B ) ) $=
        ( vm wceq cfv wcel co wa cc0 caddc cc vf c0 csu chash cn c1 cfz cv wf1o
        wex wi 0cn ffvelrni ax-mp addid1i oveq1 fveq2d fveq2 eqeq12d oveq2 00id
        oveq1d syl6eq oveq2d vtocl2ga mp2an eqtr2i addcani mpbi sumeq1 sum0 a1i
        3eqtr4a cmpt ccom cseq addcl adantl wf eqid fmptd adantr simprr syl fco
        f1of syl2anc ffvelrnda cuz simprl nnuz syl6eleq wral fvmpt2 cvv sylancl
        simpr fvex eqtr4d ralrimiva ad2antrr nfcv nffvmpt1 nffv nfeq rspc fvco3
        sylc sylan 3eqtr4d seqhomo fsum fveq2i 3eqtr3g expr exlimdv expimpd cfn
        sumfc wo fz1f1o mpjaod ) ADUBMZDEFUCZGNZDEGNZFUCZMZDUDNZUEOZUFYIUGPZDUA
        UHZUIZUAUJZQZYCYHUKAYCRGNZRYEYGYPYPSPZYPRSPZMYPRMYRYPYQYPRTOZYPTOULTTRG
        JUMUNZUOYSYSYPYQMZULULBUHZCUHZSPZGNZUUBGNZUUCGNZSPZMZRUUCSPZGNZYPUUGSPZ
        MUUABCRRTTUUBRMZUUEUUKUUHUULUUMUUDUUJGUUBRUUCSUPUQUUMUUFYPUUGSUUBRGURVB
        USUUCRMZUUKYPUULYQUUNUUJRGUUNUUJRRSPRUUCRRSUTVAVCUQUUNUUGYPYPSUUCRGURVD
        USKVEVFVGYPYPRYTYTULVHVIYCYDRGYCYDUBEFUCRDUBEFVJEFVKVCUQYCYGUBYFFUCRDUB
        YFFVJYFFVKVCVMVLAYJYNYHAYJQYMYHUAAYJYMYHAYJYMQZQZDLUHZFDEVNZNZLUCZGNZDU
        UQFDYFVNZNZLUCZYEYGUUPYISUURYLVOZUFVPNZGNYISUVBYLVOZUFVPNUVAUVDUUPBCSST
        UVEUVGGUFYIUUBTOUUCTOQZUUDTOUUPUUBUUCVQVRUUPYKTUUBUVEUUPDTUURVSZYKDYLVS
        ZYKTUVEVSAUVIUUOAFDETUURIUURVTZWAWBZUUPYMUVJAYJYMWCZYKDYLWFWDZYKDTUURYL
        WEWGWHUUPYIUEUFWINAYJYMWJZWKWLUVHUUIUUPKVRUUPUUBYKOZQZUUBYLNZUURNZGNZUV
        RUVBNZUUBUVENZGNUUBUVGNZUVQUVRDOFUHZUURNZGNZUWDUVBNZMZFDWMZUVTUWAMZUUPY
        KDUUBYLUVNWHAUWIUUOUVPAUWHFDAUWDDOZQZUWFYFUWGUWLUWEEGUWLUWKETOZUWEEMAUW
        KWQZIFDETUURUVKWNWGUQUWLUWKYFWOOUWGYFMUWNEGWRFDYFWOUVBUVBVTZWNWPWSWTXAU
        WHUWJFUVRDFUVTUWAFUVSGFGXBFDEUVRXCXDFDYFUVRXCXEUWDUVRMZUWFUVTUWGUWAUWPU
        WEUVSGUWDUVRUURURUQUWDUVRUVBURUSXFXHUVQUWBUVSGUUPUVJUVPUWBUVSMUVNYKDUUB
        UURYLXGXIZUQUUPUVJUVPUWCUWAMUVNYKDUUBUVBYLXGXIZXJXKUUPUUTUVFGUUPDUUSUVS
        LBYLUVEYIUUQUVRUURURUVOUVMUUPDTUUQUURUVLWHUWQXLUQUUPDUVCUWALBYLUVGYIUUQ
        UVRUVBURUVOUVMUUPDTUUQUVBADTUVBVSUUOAFDYFTUVBUWLUWMYFTOITTEGJUMWDUWOWAW
        BWHUWRXLXJUUTYDGDELFXSXMDYFLFXSXNXOXPXQADXROYCYOXTHDUAYAWDYB $.
    $}

    $( The real part of a sum.  (Contributed by Paul Chapman, 9-Nov-2007.)
       (Revised by Mario Carneiro, 25-Jul-2014.) $)
    fsumre $p |- ( ph -> ( Re ` sum_ k e. A B ) = sum_ k e. A ( Re ` B ) ) $=
      ( vx vy cre cc cr wf wss ref ax-resscn fss mp2an cv readd fsumrelem ) AGH
      BCDIEFJKILKJMJJILNOJKJIPQGRHRST $.

    $( The imaginary part of a sum.  (Contributed by Paul Chapman,
       9-Nov-2007.)  (Revised by Mario Carneiro, 25-Jul-2014.) $)
    fsumim $p |- ( ph -> ( Im ` sum_ k e. A B ) = sum_ k e. A ( Im ` B ) ) $=
      ( vx vy cim cc cr wf wss imf ax-resscn fss mp2an cv imadd fsumrelem ) AGH
      BCDIEFJKILKJMJJILNOJKJIPQGRHRST $.

    $( The complex conjugate of a sum.  (Contributed by Paul Chapman,
       9-Nov-2007.)  (Revised by Mario Carneiro, 25-Jul-2014.) $)
    fsumcj $p |- ( ph -> ( * ` sum_ k e. A B ) = sum_ k e. A ( * ` B ) ) $=
      ( vx vy ccj cjf cv cjadd fsumrelem ) AGHBCDIEFJGKHKLM $.
  $}

  ${
    $d k t w x y z A $.  $d k w x y z B $.  $d t w y z C $.  $d k w x y z ph $.
    $d t w y z D $.
    fsumrlim.1 $e |- ( ph -> A C_ RR ) $.
    fsumrlim.2 $e |- ( ph -> B e. Fin ) $.
    fsumrlim.3 $e |- ( ( ph /\ ( x e. A /\ k e. B ) ) -> C e. V ) $.
    fsumrlim.4 $e |- ( ( ph /\ k e. B ) -> ( x e. A |-> C ) ~~>r D ) $.
    $( Limit of a finite sum of converging sequences.  Note that ` C ( k ) ` is
       a collection of functions with implicit parameter ` k ` , each of which
       converges to ` D ( k ) ` as ` n ~~> +oo ` .  (Contributed by Mario
       Carneiro, 22-May-2016.) $)
    fsumrlim $p |- ( ph -> ( x e. A |-> sum_ k e. B C ) ~~>r sum_ k e. B D ) $=
      ( vw csu cmpt crli wcel wi cc caddc vy vz wss wbr ssid cfn cv cc0 csn cun
      c0 wceq sseq1 sumeq1 syl6eq mpteq2dv breq12d imbi12d imbi2d weq rlimconst
      sum0 cr 0cn sylancl a1d wn wa ssun1 sstr mpan imim1i csb co cvv sumex a1i
      wral simprr unssbd snss sylibr adantr anass1rs rlimmptrcl an32s ralrimiva
      vex adantllr nfcsb1v nfel1 csbeq1a eleq1d rspc sylc mpan9 elex nfcv nfsum
      syl sumeq2sdv cbvmpt simpr syl5eqbrr nfmpt nfbr rlimadd cin simprl disjsn
      eqidd syl2anc sselda adantlr syldan fsumsplit cbvsumi csbeq1 sumsn syl5eq
      ssfi oveq2d mpteq2dva nfov oveq12d rlimcl 3brtr4d ex expr a2d syl5 expcom
      eqtrd adantl findcard2s mpcom mpi ) ADDUCZBCDEGNZOZDFGNZPUDZDUEDUFQZAYRUU
      BRZJAMUGZDUCZBCUUEEGNZOZUUEFGNZPUDZRZRAUKDUCZBCUHOZUHPUDZRZRAUAUGZDUCZBCU
      UPEGNZOZUUPFGNZPUDZRZRZAUUPUBUGZUIZUJZDUCZBCUVFEGNZOZUVFFGNZPUDZRZRZAUUDR
      MUAUBDUUEUKULZUUKUUOAUVNUUFUULUUJUUNUUEUKDUMUVNUUHUUMUUIUHPUVNBCUUGUHUVNU
      UGUKEGNUHUUEUKEGUNEGVBUOUPUVNUUIUKFGNUHUUEUKFGUNFGVBUOUQURUSMUAUTZUUKUVBA
      UVOUUFUUQUUJUVAUUEUUPDUMUVOUUHUUSUUIUUTPUVOBCUUGUURUUEUUPEGUNUPUUEUUPFGUN
      UQURUSUUEUVFULZUUKUVLAUVPUUFUVGUUJUVKUUEUVFDUMUVPUUHUVIUUIUVJPUVPBCUUGUVH
      UUEUVFEGUNUPUUEUVFFGUNUQURUSUUEDULZUUKUUDAUVQUUFYRUUJUUBUUEDDUMUVQUUHYTUU
      IUUAPUVQBCUUGYSUUEDEGUNUPUUEDFGUNUQURUSAUUNUULACVCUCUHSQUUNIVDBCUHVAVEVFU
      VDUUPQVGZUVCUVMRUUPUFQUVRAUVBUVLAUVRUVBUVLRUVBUVGUVARAUVRVHZUVLUVGUUQUVAU
      UPUVFUCUVGUUQUUPUVEVIUUPUVFDVJVKVLUVSUVGUVAUVKAUVRUVGUVAUVKRAUVRUVGVHZVHZ
      UVAUVKUWAUVAVHZMCUUPBUUEEVMZGNZBUUEGUVDEVMZVMZTVNZOZUUTGUVDFVMZTVNZUVIUVJ
      PUWBMCUWDUWFUUTUWIVOUWDVOQUWBUUECQZVHZUUPUWCGVPVQUWLUWFSQZUWFVOQUWBUWESQZ
      BCVRZUWKUWMUWAUWOUVAUWAUWNBCUWABUGCQZVHZUVDDQZESQZGDVRUWNUWAUWRUWPUWAUVED
      UCUWRUWAUUPUVEDAUVRUVGVSZVTUVDDUBWHWAWBZWCZUWQUWSGDAUWPGUGZDQZUWSUVTAUXDU
      WPUWSAUXDVHZCEFBHAUWPUXDEHQKWDLWEWFWIZWGUWSUWNGUVDDGUWESGUVDEWJZWKGUBUTZE
      UWESGUVDEWLZWMWNWOZWGWCUWNUWMBUUECBUWFSBUUEUWEWJZWKBMUTZUWEUWFSBUUEUWEWLZ
      WMWNWPUWFSWQWTUWBMCUWDOUUSUUTPBMCUURUWDMUURWRBUUPUWCGBUUPWRBUUEEWJWSZUXLU
      UPEUWCGBUUEEWLXAZXBUWAUVAXCXDUWBMCUWFOBCUWEOZUWIPBMCUWEUWFMUWEWRUXKUXMXBU
      WAUXPUWIPUDZUVAUWAUWRBCEOZFPUDZGDVRZUXQUXAAUXTUVTAUXSGDLWGWCUXSUXQGUVDDGU
      XPUWIPGBCUWEGCWRUXGXEGPWRGUVDFWJZXFUXHUXRUXPFUWIPUXHBCEUWEUXIUPGUVDFWLZUQ
      WNWOWCXDXGUWBUVIBCUURUWETVNZOZUWHUWAUVIUYDULUVAUWABCUVHUYCUWQUVHUURUVEEGN
      ZTVNUYCUWQUUPUVEEUVFGUWAUUPUVEXHUKULZUWPUWAUVRUYFAUVRUVGXIUUPUVDXJWBZWCUW
      QUVFXKUWAUVFUFQZUWPUWAUUCUVGUYHAUUCUVTJWCUWTDUVFYAXLZWCUWQUXCUVFQZUXDUWSU
      WAUYJUXDUWPUWAUVFDUXCUWTXMZXNUXFXOXPUWQUYEUWEUURTUWQUYEUVEGUUEEVMZMNZUWEU
      VEEUYLGMMEWRGUUEEWJGUUEEWLXQUWQUWRUWNUYMUWEULUXBUXJUYLUWEMUVDDGUUEUVDEXRX
      SXLXTYBYMYCWCBMCUYCUWGMUYCWRBUWDUWFTUXNBTWRUXKYDUXLUURUWDUWEUWFTUXOUXMYEX
      BUOUWAUVJUWJULUVAUWAUVJUUTUVEFGNZTVNUWJUWAUUPUVEFUVFGUYGUWAUVFXKUYIUWAUYJ
      UXDFSQZUYKAUXDUYOUVTUXEUXSUYOLFUXRYFWTXNZXOXPUWAUYNUWIUUTTUWAUYNUVEGUUEFV
      MZMNZUWIUVEFUYQGMMFWRGUUEFWJGUUEFWLXQUWAUWRUWISQZUYRUWIULUXAUWAUWRUYOGDVR
      UYSUXAUWAUYOGDUYPWGUYOUYSGUVDDGUWISUYAWKUXHFUWISUYBWMWNWOUYQUWIMUVDDGUUEU
      VDFXRXSXLXTYBYMWCYGYHYIYJYKYLYJYNYOYPYQ $.
  $}

  ${
    $d k t w x y z A $.  $d k w x y z B $.  $d t w y z C $.  $d k w x y z ph $.
    fsumo1.1 $e |- ( ph -> A C_ RR ) $.
    fsumo1.2 $e |- ( ph -> B e. Fin ) $.
    fsumo1.3 $e |- ( ( ph /\ ( x e. A /\ k e. B ) ) -> C e. V ) $.
    fsumo1.4 $e |- ( ( ph /\ k e. B ) -> ( x e. A |-> C ) e. O(1) ) $.
    $( The finite sum of eventually bounded functions (where the index set
       ` B ` does not depend on ` x ` ) is eventually bounded.  (Contributed by
       Mario Carneiro, 30-Apr-2016.)  (Proof shortened by Mario Carneiro,
       22-May-2016.) $)
    fsumo1 $p |- ( ph -> ( x e. A |-> sum_ k e. B C ) e. O(1) ) $=
      ( vw wss csu cmpt co1 wcel wi wceq adantr vy vz ssid cfn cv cc0 csn sseq1
      c0 cun sumeq1 syl6eq mpteq2dv eleq1d imbi12d imbi2d cr cc o1const sylancl
      sum0 0cn a1d wn wa ssun1 sstr mpan imim1i csb caddc cof cin simprl disjsn
      sylibr eqidd simprr ssfi syl2anc adantlr anass1rs o1mptrcl an32s adantllr
      sselda syldan fsumsplit nfcv nfcsb1v csbeq1a cbvsumi unssbd vex snss wral
      ralrimiva nfel1 rspc sylc csbeq1 sumsn syl5eq oveq2d eqtrd mpteq2dva reex
      co cvv ssex syl sumex a1i offval2 eqtr4d nfmpt o1add syl2anr eqeltrd expr
      id ex a2d syl5 expcom adantl findcard2s mpcom mpi ) ADDMZBCDEFNZOZPQZDUCD
      UDQZAYJYMRZIALUEZDMZBCYPEFNZOZPQZRZRAUIDMZBCUFOZPQZRZRAUAUEZDMZBCUUFEFNZO
      ZPQZRZRZAUUFUBUEZUGZUJZDMZBCUUOEFNZOZPQZRZRZAYORLUAUBDYPUISZUUAUUEAUVBYQU
      UBYTUUDYPUIDUHUVBYSUUCPUVBBCYRUFUVBYRUIEFNUFYPUIEFUKEFVAULUMUNUOUPYPUUFSZ
      UUAUUKAUVCYQUUGYTUUJYPUUFDUHUVCYSUUIPUVCBCYRUUHYPUUFEFUKUMUNUOUPYPUUOSZUU
      AUUTAUVDYQUUPYTUUSYPUUODUHUVDYSUURPUVDBCYRUUQYPUUOEFUKUMUNUOUPYPDSZUUAYOA
      UVEYQYJYTYMYPDDUHUVEYSYLPUVEBCYRYKYPDEFUKUMUNUOUPAUUDUUBACUQMZUFURQUUDHVB
      BCUFUSUTVCUUMUUFQVDZUULUVARUUFUDQUVGAUUKUUTAUVGUUKUUTRUUKUUPUUJRAUVGVEZUU
      TUUPUUGUUJUUFUUOMUUPUUGUUFUUNVFUUFUUODVGVHVIUVHUUPUUJUUSAUVGUUPUUJUUSRAUV
      GUUPVEZVEZUUJUUSUVJUUJVEUURUUIBCFUUMEVJZOZVKVLXHZPUVJUURUVMSUUJUVJUURBCUU
      HUVKVKXHZOUVMUVJBCUUQUVNUVJBUECQZVEZUUQUUHUUNEFNZVKXHUVNUVPUUFUUNEUUOFUVJ
      UUFUUNVMUISZUVOUVJUVGUVRAUVGUUPVNUUFUUMVOVPTUVPUUOVQUVJUUOUDQZUVOUVJYNUUP
      UVSAYNUVIITAUVGUUPVRZDUUOVSVTTUVPFUEZUUOQZUWADQZEURQZUVJUWBUWCUVOUVJUUODU
      WAUVTWFWAAUVOUWCUWDUVIAUWCUVOUWDAUWCVEBCEGAUVOUWCEGQJWBKWCWDWEZWGWHUVPUVQ
      UVKUUHVKUVPUVQUUNFYPEVJZLNZUVKUUNEUWFFLLEWIFYPEWJFYPEWKWLUVPUUMDQZUVKURQZ
      UWGUVKSUVJUWHUVOUVJUUNDMUWHUVJUUFUUNDUVTWMUUMDUBWNWOVPZTZUVPUWHUWDFDWPUWI
      UWKUVPUWDFDUWEWQUWDUWIFUUMDFUVKURFUUMEWJZWRUWAUUMSZEUVKURFUUMEWKZUNWSWTZU
      WFUVKLUUMDFYPUUMEXAXBVTXCXDXEXFUVJBCUUHUVKVKUUIUVLXIXIURUVJUVFCXIQAUVFUVI
      HTCUQXGXJXKUUHXIQUVPUUFEFXLXMUWOUVJUUIVQUVJUVLVQXNXOTUUJUUJUVLPQZUVMPQUVJ
      UUJYAUVJUWHBCEOZPQZFDWPZUWPUWJAUWSUVIAUWRFDKWQTUWRUWPFUUMDFUVLPFBCUVKFCWI
      UWLXPWRUWMUWQUVLPUWMBCEUVKUWNUMUNWSWTUUIUVLXQXRXSYBXTYCYDYEYCYFYGYHYI $.
  $}

  ${
    $d c m n x y A $.  $d c k m n x y ph $.
    o1fsum.1 $e |- ( ( ph /\ k e. NN ) -> A e. V ) $.
    o1fsum.2 $e |- ( ph -> ( k e. NN |-> A ) e. O(1) ) $.
    $( If ` A ( k ) ` is O(1), then ` sum_ k <_ x , A ( k ) ` is O( ` x ` ).
       (Contributed by Mario Carneiro, 23-May-2016.) $)
    o1fsum $p |- ( ph ->
      ( x e. RR+ |-> ( sum_ k e. ( 1 ... ( |_ ` x ) ) A / x ) ) e. O(1) ) $=
      ( vn cle wbr cabs cfv cn cr c1 co wcel wa cc syl vc vm wral wrex cpnf crp
      cv wi cico cfl cfz csu cdiv cmpt co1 wss nnssre a1i o1mptrcl 1re elo1mpt2
      mpbid csb caddc rpssre nfcv nfcsb1v csbeq1a cbvsumi fzfid wf cdm o1f wceq
      ralrimiva dmmptg feq2d eqid fmpt sylibr elfznn nfel1 eleq1d impcom syl2an
      ad3antrrr rspc fsumcl syl5eqel rpcn adantl cc0 wne rpne0 simplrl elicopnf
      divcld wb ax-mp simpld ad2antrr fsumrecl simplrr readdcld absdivd adantrr
      sylib abscld rprege0 ad2antrl absid oveq2d adantlr adantr remulcld fveq2i
      eqtrd cmul fsumabs syl5eqbr cun ssun2 flge1nn nnred flle simprr mpbir2and
      letrd fznnfl syldan recnd absge0d chash cfn cn0 3syl reflcl breqtrd sylc
      clt fzsplit syl5sseqr sselda mulid2d fsumge0 jca simprd syl31anc eqbrtrrd
      lemul1a hashcl nn0re elfzuz peano2nnd nnuz uztrn2 simpllr peano2re fllep1
      cuz sylan eluzle nffv nfbr nfim breq2 fveq2d breq1d imbi12d sylan2 fsumle
      nfv syl3c fsumconst syl2anc nnzd uzid 0re mpan9 biidd rspcv cdom hashdomi
      ssdomg flge0nn0 hashfz1 lemul1ad le2addd cin ltp1 fzdisj fsumsplit adddid
      cz c0 3brtr4d rpregt0 ledivmul syl3anc mpbird eqbrtrd elo1d ex rexlimdvva
      mpd ) AUAUGZDUGZIJZCKLZUBUGZIJZUHZDMUCZUBNUDUAOUEUIPZUDZBUFOBUGZUJLZUKPZC
      DULZUXPUMPZUNUOQZADMCUNZUOQZUXOGADUAMCOUBMNUPAUQURADMCEFGUSONQZAUTURVAVBA
      UXMUYAUAUBUXNNAUXFUXNQZUXJNQZRZRZUXMUYAUYHUXMRZBUFUXTUXFOUXFUJLZUKPZDHUGZ
      CVCZKLZHULZUXJVDPZUFNUPUYIVEURUYIUXPUFQZRZUXSUXPUYRUXSUXRUYMHULZSUXRCUYMD
      HHCVFDUYLCVGZDUYLCVHZVIZUYRUXRUYMHUYROUXQVJUYRCSQZDMUCZUYLMQZUYMSQZUYLUXR
      QZAVUDUYGUXMUYQAMSUYBVKZVUDAUYBVLZSUYBVKZVUHAUYCVUJGUYBVMTAVUIMSUYBACEQZD
      MUCVUIMVNAVUKDMFVODMCEVPTVQVBDMSCUYBUYBVRVSVTZWFUYLUXQWAZVUEVUDVUFVUCVUFD
      UYLMDUYMSUYTWBUXGUYLVNZCUYMSVUAWCWGZWDZWEWHWIZUYQUXPSQZUYIUXPWJWKZUYQUXPW
      LWMUYIUXPWNWKZWQUYIUXFNQZOUXFIJZUYIUYEVVAVVBRZAUYEUYFUXMWOUYDUYEVVCWRUTOU
      XFWPWSXGZWTZUYIUYOUXJUYIUYKUYNHUYIOUYJVJZUYIUYLUYKQZRZUYMUYIVUDVUEVUFVVGA
      VUDUYGUXMVULXAZUYLUYJWAVUPWEZXHZXBZAUYEUYFUXMXCZXDUYIUYQUXFUXPIJZRZRZUXTK
      LZUXSKLZUXPUMPZUYPIVVPVVQVVRUXPKLZUMPZVVSUYIUYQVVQVWAVNVVNUYRUXSUXPVUQVUS
      VUTXEXFVVPVVTUXPVVRUMVVPUXPNQZWLUXPIJZRZVVTUXPVNUYQVWDUYIVVNUXPXIXJZUXPXK
      TXLXQVVPVVSUYPIJZVVRUXPUYPXRPZIJZVVPVVRUXRUYNHULZVWGVVPUXSUYIUYQUXSSQVVNV
      UQXFXHZVVPUXRUYNHVVPOUXQVJZVVPVUGRZUYMUYIVUGVUFVVOUYIVUDVUEVUFVUGVVIVUMVU
      PWEZXMZXHXBVVPUXPUYPVVPVWBVWCVWEWTZVVPUYOUXJUYIUYONQZVVOVVLXNZUYIUYFVVOVV
      MXNZXDZXOVVPVVRUYSKLVWIIUXSUYSKVUBXPVVPUXRUYMHVWKVWNXSXTVVPUYOUYJOVDPZUXQ
      UKPZUYNHULZVDPUXPUYOXRPZUXPUXJXRPZVDPVWIVWGIVVPUYOVXBVXCVXDVWQVVPVXAUYNHV
      VPVWTUXQVJZVVPUYLVXAQZVUGUYNNQZVVPVXAUXRUYLVVPUYKVXAYAZVXAUXRVXAUYKYBVVPU
      YJUXRQZUXRVXHVNVVPVXIUYJMQZUYJUXPIJZUYIVXJVVOUYIVVCVXJVVDUXFYCTXNZVVPUYJU
      XFUXPVVPUYJVXLYDZUYIVVAVVOVVEXNZVWOVVPVVAUYJUXFIJVXNUXFYETUYIUYQVVNYFZYHV
      VPVWBVXIVXJVXKRWRVWOUYJUXPYITYGUYJOUXQUUATZUUBZUUCUYIVUGVXGVVOUYIVUGRUYMV
      WMXHXMZYJZXBZVVPUXPUYOVWOVWQXOVVPUXPUXJVWOVWRXOZVVPOUYOXRPZUYOVXCIVVPUYOV
      VPUYOVWQYKZUUDVVPUYDVWBVWPWLUYOIJZRZOUXPIJVYBVXCIJUYDVVPUTURZVWOUYIVYEVVO
      UYIVWPVYDVVLUYIUYKUYNHVVFVVKVVHUYMVVJYLUUEUUFXNVVPOUXFUXPVYFVXNVWOUYIVVBV
      VOUYIVVAVVBVVDUUGXNVXOYHOUXPUYOUUJUUHUUIVVPVXBVXAYMLZUXJXRPZVXDVXTVVPVYGU
      XJVVPVXAYNQZVYGYOQVYGNQVXEVXAUUKVYGUULYPZVWRXOVYAVVPVXBVXAUXJHULZVYHIVVPV
      XAUYNUXJHVXEVXSVVPUYFVXFVWRXNVXFVVPUYLVWTUUTLZQZUYNUXJIJZUYLVWTUXQUUMVVPV
      YMRZVUEUXMUXFUYLIJZVYNVVPVWTMQVYMVUEVVPUYJVXLUUNZOUYLVWTMUUOUUPUVAZUYHUXM
      VVOVYMUUQVYOUXFVWTUYLVVPVVAVYMVXNXNZVYOVVAUYJNQZVWTNQVYSUXFYQUYJUURYPVYOU
      YLVYRYDVYOVVAUXFVWTIJVYSUXFUUSTVYMVWTUYLIJVVPVWTUYLUVBWKYHUXLVYPVYNUHDUYL
      MVYPVYNDVYPDUVLDUYNUXJIDUYMKDKVFUYTUVCDIVFDUXJVFUVDUVEVUNUXHVYPUXKVYNUXGU
      YLUXFIUVFVUNUXIUYNUXJIVUNCUYMKVUAUVGUVHUVIWGUVMZUVJUVKVVPVYIUXJSQVYKVYHVN
      VXEVVPUXJVWRYKZVXAUXJHUVNUVOYRVVPVYGUXPUXJVYJVWOVWRVVPVWTVYLQZWLUXJIJZHVY
      LUCWUDVVPVWTUWNQWUCVVPVWTVYQUVPVWTUVQTVVPWUDHVYLVYOWLUYNUXJWLNQVYOUVRURVY
      OUYMVVPVYMVUEVUFVYRUYIVUEVUFVVOUYIVUDVUEVUFVVIVUOUVSXMYJZXHVVPUYFVYMVWRXN
      VYOUYMWUEYLWUAYHVOWUDWUDHVWTVYLUYLVWTVNWUDUVTUWAYSVVPVYGUXQUXPVYJVVPVWBUX
      QNQVWOUXPYQTVWOVVPVYGUXRYMLZUXQIVVPVXAUXRUWBJZVYGWUFIJVVPUXRYNQVXAUXRUPWU
      GVWKVXQVXAUXRYNUWDYSVXAUXRUWCTVVPVWDUXQYOQWUFUXQVNVWEUXPUWEUXQUWFYPYRVVPV
      WBUXQUXPIJVWOUXPYETYHUWGYHUWHVVPUYKVXAUYNUXRHVVPVYTUYJVWTYTJUYKVXAUWIUWOV
      NVXMUYJUWJOUYJVWTUXQUWKYPVXPVWKVWLUYNVXRYKUWLVVPUXPUYOUXJUYIUYQVURVVNVUSX
      FVYCWUBUWMUWPYHVVPVVRNQUYPNQVWBWLUXPYTJRZVWFVWHWRVWJVWSUYQWUHUYIVVNUXPUWQ
      XJVVRUYPUXPUWRUWSUWTUXAUXBUXCUXDUXE $.
  $}

  ${
    $d k F $.  $d k G $.  $d k M $.  $d k N $.  $d k ph $.
    seqabs.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    seqabs.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. CC ) $.
    seqabs.3 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
                      ( G ` k ) = ( abs ` ( F ` k ) ) ) $.
    $( Generalized triangle inequality: the absolute value of a finite sum is
       less than or equal to the sum of absolute values.  (Contributed by Mario
       Carneiro, 26-Mar-2014.)  (Revised by Mario Carneiro, 27-May-2014.) $)
    seqabs $p |- ( ph ->
              ( abs ` ( seq M ( + , F ) ` N ) ) <_ ( seq M ( + , G ) ` N ) ) $=
      ( cfz co cv cfv csu cabs caddc cseq wcel fsumser cc cle fsumabs wa fveq2d
      fzfid eqidd abscl recnd syl 3brtr3d ) AEFJKZBLZCMZBNZOMUKUMOMZBNFPCEQMZOM
      FPDEQMUAAUKUMBAEFUEHUBAUNUPOAUMBCEFAULUKRUCZUMUFGHSUDAUOBDEFIGUQUMTRZUOTR
      HURUOUMUGUHUISUJ $.
  $}

  ${
    $d k m n F $.  $d k n G $.  $d k m n M $.  $d k n ph $.  $d k m n Z $.
    $d n A $.  $d n B $.
    iserabs.1 $e |- Z = ( ZZ>= ` M ) $.
    iserabs.2 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
    iserabs.3 $e |- ( ph -> seq M ( + , G ) ~~> B ) $.
    iserabs.5 $e |- ( ph -> M e. ZZ ) $.
    iserabs.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    iserabs.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = ( abs ` ( F ` k ) ) ) $.
    $( Generalized triangle inequality: the absolute value of an infinite sum
       is less than or equal to the sum of absolute values.  (Contributed by
       Paul Chapman, 10-Sep-2007.)  (Revised by Mario Carneiro,
       27-May-2014.) $)
    iserabs $p |- ( ph -> ( abs ` A ) <_ B ) $=
      ( vn vm cabs cfv cv wcel caddc cseq cmpt cvv cuz fvex eqeltri a1i cc serf
      mptex ffvelrnda wceq fveq2 fveq2d eqid fvmpt adantl climabs wa cr eqeltrd
      abscld serfre cle syl6eleq cfz co elfzuz syl6eleqr sylan2 adantlr eqbrtrd
      simpr seqabs climle ) ABQRCOPHPSZUAEGUBZRZQRZUCZUAFGUBZGHILABOVRWAGUDHIJW
      AUDTAPHVTHGUERZUDIGUEUFUGUKUHLAHUIOSZVRADEGHILMUJULZWDHTZWDWARZWDVRRZQRZU
      MAPWDVTWIHWAVQWDUMVSWHQVQWDVRUNUOWAUPWHQUFUQURZUSKAWFUTZWGWIVAWJWKWHWEVCV
      BAHVAWDWBADFGHILADSZHTZUTZWLFRZWLERZQRZVANWNWPMVCVBVDULWKWGWIWDWBRVEWJWKD
      EFGWDWKWDHWCAWFVNIVFAWLGWDVGVHTZWPUITZWFWRAWMWSWRWLWCHWLGWDVIIVJZMVKVLAWR
      WOWQUMZWFWRAWMXAWTNVKVLVOVMVP $.
  $}

  ${
    $d n A $.  $d n B $.  $d k m n x F $.  $d k m n x G $.  $d k m n x ph $.
    $d k m n x M $.  $d k m n x N $.  $d k m n x Z $.
    cvgcmp.1 $e |- Z = ( ZZ>= ` M ) $.
    cvgcmp.2 $e |- ( ph -> N e. Z ) $.
    cvgcmp.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
    cvgcmp.4 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. RR ) $.
    ${
      cvgcmp.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
      cvgcmp.6 $e |- ( ( ph /\ k e. ( ZZ>= ` N ) ) -> 0 <_ ( G ` k ) ) $.
      cvgcmp.7 $e |- ( ( ph /\ k e. ( ZZ>= ` N ) ) ->
                       ( G ` k ) <_ ( F ` k ) ) $.
      $( A comparison test for convergence of a real infinite series.  Exercise
         3 of [Gleason] p. 182.  (Contributed by NM, 1-May-2005.)  (Revised by
         Mario Carneiro, 24-Mar-2014.) $)
      cvgcmp $p |- ( ph -> seq M ( + , G ) e. dom ~~> ) $=
        ( vx vm vn wcel cfv cr caddc cseq cvv seqex a1i cv cc cmin cabs clt wbr
        co wa cuz wral wrex crp cz cli cdm syl6eleq eluzel2 syl climcau syl2anc
        wi serfre ffvelrnda recnd ralrimiva r19.29uz ex mpd uztrn2 sylan syldan
        ralimdv adantr cle simpll simprl ffvelrnd eqid adantl resubcld cmpt cfz
        wf simprr elfzuz syl6eleqr wceq fveq2 oveq12d ovex fvmpt eqeltrd syl2an
        c1 cc0 peano2uz subge0d mpbird breqtrrd sylan2 sermono sersub lesubaddd
        wb 3brtr3d mpbid subsubd lesubd ad2antlr lelttr syl3anc mpand 0re letrd
        rpre abssubge0d breq1d 3imtr4d anassrs adantld ralimdva reximdva ee12an
        cau4 simpr biantrurd syl5ib caurcvg2 ) AOPQUADEUBZEUCGHYNUCRAUADEUDUEAQ
        UFZYNSZUGRZYPPUFZYNSZUHULZUISZOUFZUJUKZUMZQYRUNSZUOZPGUPZOUQUOZYPTRZUUC
        UMZQUUEUOZPGUPZOUQUOAYOUACEUBZSZUGRZUUNYRUUMSZUHULZUISZUUBUJUKZUMZQUUEU
        OZPGUPZOUQUOZUUHAUUSQUUEUOPGUPZOUQUOZUVCAEURRZUUMUSUTRUVEAFEUNSZRUVFAFG
        UVGIHVAEFVBVCZLOPQUUMEGHVDVEAUVDUVBOUQAUUOQGUOZUVDUVBVFAUUOQGAYOGRZUMZU
        UNAGTYOUUMABCEGHUVHJVGZVHZVIVJUVIUVDUVBUUOUUSPQEGHVKVLVCVQVMAUVAPFUNSZU
        PZOUQUOZUUFPUVNUPZOUQUOZUVCUUHAUVOUVQOUQAUUBUQRZUMZYQQUVNUOZUVOUUCQUUEU
        OZPUVNUPUVQAUWAUVSAYQQUVNAYOUVNRZUVJYQAFGRZUWCUVJIEYOFGHVNZVOUVKYPAGTYO
        YNABDEGHUVHKVGZVHZVIVPVJVRUVTUVAUWBPUVNUVTYRUVNRZUMZUUTUUCQUUEUWIYOUUER
        ZUMUUSUUCUUOUVTUWHUWJUUSUUCVFUVTUWHUWJUMZUMZUUQUUBUJUKZYTUUBUJUKZUUSUUC
        UWLYTUUQVSUKZUWMUWNUWLUUPUUNYTUWLGTYRUUMUWLAGTUUMWHAUVSUWKVTZUVLVCUWLUW
        DUWHYRGRZUWLAUWDUWPIVCZUVTUWHUWJWAZEYRFGHVNVEZWBZUWLAUVJUUNTRUWPUWLUWDU
        WCUVJUWRUWKUWCUVTFYOYRUVNUVNWCZVNWDUWEVEZUVMVEZUWLYPYSUWLAUVJUUIUWPUXCU
        WGVEZUWLGTYRYNUWLAGTYNWHUWPUWFVCUWTWBZWEZUWLUUPUUNYPUHULZYSUAULZUUNYTUH
        ULVSUWLUUPYSUHULZUXHVSUKUUPUXIVSUKUWLYRUAPGYRCSZYRDSZUHULZWFZEUBZSYOUXO
        SUXJUXHVSUWLBUXNYREYOUWLYRGUVGUWTHVAZUVTUWHUWJWIZUWLABUFZGRZUXRUXNSZTRU
        XREYOWGULRZUWPUYAUXRUVGGUXREYOWJHWKZAUXSUMZUXTUXRCSZUXRDSZUHULZTUXSUXTU
        YFWLZAPUXRUXMUYFGUXNYRUXRWLUXKUYDUXLUYEUHYRUXRCWMYRUXRDWMWNUXNWCUYDUYEU
        HWOWPZWDZUYCUYDUYEJKWEWQWRUXRYRWSUAULZYOWGULRZUWLUXRUYJUNSRZWTUXTVSUKZU
        XRUYJYOWJZUWLUYLUXRUVNRZUYMUWLUYJUVNRZUYLUYOUWLUWHUYPUWSFYRXAVCFUXRUYJU
        VNUXBVNVOZUWLAUYOUYMUWPAUYOUMZWTUYFUXTVSUYRWTUYFVSUKZUYEUYDVSUKZNAUYOUX
        SUYSUYTXIAUWDUYOUXSIEUXRFGHVNVOZUYCUYDUYEJKXBVPXCUYRUXSUYGVUAUYHVCXDVOV
        PXEXFUWLBCDUXNEYRUXPUWLAUXSUYDUGRZUXREYRWGULRZUWPVUCUXRUVGGUXREYRWJHWKZ
        UYCUYDJVIZWRUWLAUXSUYEUGRZVUCUWPVUDUYCUYEKVIZWRUWLAUXSUYGVUCUWPVUDUYIWR
        XGUWLBCDUXNEYOUWLYOGUVGUXCHVAUWLAUXSVUBUYAUWPUYBVUEWRUWLAUXSVUFUYAUWPUY
        BVUGWRUWLAUXSUYGUYAUWPUYBUYIWRXGXJUWLUUPYSUXHUXAUXFUWLUUNYPUXDUXEWEXHXK
        UWLUUNYPYSUWLUUNUXDVIUWLYPUXEVIUWLYSUXFVIXLXDXMUWLYTTRUUQTRUUBTRZUWOUWM
        UMUWNVFUXGUWLUUNUUPUXDUXAWEUVSVUHAUWKUUBXTXNYTUUQUUBXOXPXQUWLUURUUQUUBU
        JUWLUUPUUNUXAUXDUWLBCYREYOUXPUXQUWLAUXSUYDTRZUYAUWPUYBJWRUWLUYKUYOWTUYD
        VSUKZUYKUWLUYLUYOUYNUYQXEUWLAUYOVUJUWPUYRWTUYEUYDWTTRUYRXRUEAUYOUXSUYET
        RZVUAKVPAUYOUXSVUIVUAJVPMNXSVOVPXFYAYBUWLUUAYTUUBUJUWLYSYPUXFUXEUWLBDYR
        EYOUXPUXQUWLAUXSVUKUYAUWPUYBKWRUYKUWLUYLWTUYEVSUKZUYNUWLUYLUYOVULUYQUWL
        AUYOVULUWPMVOVPXEXFYAYBYCYDYEYFYGYQUUCPQFUVNUXBVKYHYFAUWDUVCUVPXIIOPQUU
        MEFUVNGHUXBYIVCAUWDUUHUVRXIIOPQYNEFUVNGHUXBYIVCYCVMAUUGUULOUQAUUFUUKPGA
        UWQUMUUDUUJQUUEAUWQUWJUUDUUJVFZUWQUWJUMAUVJVUMEYOYRGHVNUUDUUCUVKUUJYQUU
        CYJUVKUUIUUCUWGYKYLXEYDYFYGVQVMYM $.
    $}

    cvgcmpub.5 $e |- ( ph -> seq M ( + , F ) ~~> A ) $.
    cvgcmpub.6 $e |- ( ph -> seq M ( + , G ) ~~> B ) $.
    cvgcmpub.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) <_ ( F ` k ) ) $.
    $( An upper bound for the limit of a real infinite series.  This theorem
       can also be used to compare two infinite series.  (Contributed by Mario
       Carneiro, 24-Mar-2014.) $)
    cvgcmpub $p |- ( ph -> B <_ A ) $=
      ( cfv wcel cr syl2an caddc cseq cuz syl6eleq eluzel2 syl serfre ffvelrnda
      vn cz cv wa simpr cfz co simpl elfzuz syl6eleqr cle wbr serle climle ) AC
      BUIUAFGUBZUAEGUBZGIJAHGUCQZRGUJRAHIVEKJUDGHUEUFZONAISUIUKZVCADFGIJVFMUGUH
      AISVGVDADEGIJVFLUGUHAVGIRZULZDFEGVGVIVGIVEAVHUMJUDVIADUKZIRZVJFQZSRVJGVGU
      NUORZAVHUPZVMVJVEIVJGVGUQJURZMTVIAVKVJEQZSRVMVNVOLTVIAVKVLVPUSUTVMVNVOPTV
      AVB $.
  $}

  ${
    $d k m C $.  $d k m F $.  $d j k m n x G $.  $d k N $.  $d j k m n x Z $.
    $d j k n x M $.  $d j k n x ph $.
    cvgcmpce.1 $e |- Z = ( ZZ>= ` M ) $.
    cvgcmpce.2 $e |- ( ph -> N e. Z ) $.
    cvgcmpce.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
    cvgcmpce.4 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
    cvgcmpce.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    cvgcmpce.6 $e |- ( ph -> C e. RR ) $.
    cvgcmpce.7 $e |- ( ( ph /\ k e. ( ZZ>= ` N ) ) ->
                       ( abs ` ( G ` k ) ) <_ ( C x. ( F ` k ) ) ) $.
    $( A comparison test for convergence of a complex infinite series.
       (Contributed by NM, 25-Apr-2005.)  (Revised by Mario Carneiro,
       27-May-2014.) $)
    cvgcmpce $p |- ( ph -> seq M ( + , G ) e. dom ~~> ) $=
      ( cfv wcel co wa cr vx vj vn vm caddc cseq cvv cc cv cuz syl6eleq eluzel2
      syl serf ffvelrnda cabs cmpt cmin clt wbr wral wrex crp cli cdm cmul wceq
      fveq2 oveq2d eqid ovex fvmpt adantl adantr remulcld eqeltrd fveq2d abscld
      fvex recnd climdm sylib isermulc2 climrel releldmi cc0 cle uztrn2 absge0d
      cz sylan breqtrrd syldan 3brtr4d cvgcmp climcau syl2anc ad2antrr ffvelrnd
      wi serfre simprl resubcld 0re a1i subcld cfz cdif csu cfn wss fzfid difss
      ssfi sylancl eldifi simpll elfzuz syl6eleqr syl2an sylan2 fsumabs fsumser
      wf eqidd oveq12d c0 disjdif undif2 fzss2 ad2antll fsumsplit eqcomd fsumcl
      cin cun subaddd mpbird eqtr3d ralimdva ssequn1 syl5req abscl letrd absidd
      breq1d ad2antlr lelttr syl3anc mpand sylbid anassrs reximdva seqex caucvg
      rpre mpd ) AUAUBUCUEEFUFZFUGHIAHUHUCUIZUURACEFHIAGFUJPZQFWJQZAGHUUTJIUKFG
      ULUMZLUNZUOAUUSUEUDHUDUIZEPZUPPZUQZFUFZPZUBUIZUVHPZURRZUPPZUAUIZUSUTZUCUV
      JUJPZVAZUBHVBZUAVCVAZUUSUURPZUVJUURPZURRZUPPZUVNUSUTZUCUVPVAZUBHVBZUAVCVA
      AUVAUVHVDVEZQUVSUVBACUDHBUVDDPZVFRZUQZUVGFGHIJACUIZHQZSZUWKUWJPZBUWKDPZVF
      RZTUWLUWNUWPVGZAUDUWKUWIUWPHUWJUVDUWKVGZUWHUWOBVFUVDUWKDVHVIUWJVJBUWOVFVK
      VLZVMZUWMBUWOABTQUWLNVNKVOVPUWMUWKUVGPZUWKEPZUPPZTUWLUXAUXCVGZAUDUWKUVFUX
      CHUVGUWRUVEUXBUPUVDUWKEVHVQUVGVJUXBUPVSVLZVMZUWMUXBLVRVPZAUEUWJFUFZBUEDFU
      FZVDPZVFRZVDUTUXHUWGQAUXJBCDUWJFHIUVBABNVTAUXIUWGQUXIUXJVDUTMUXIWAWBUWMUW
      OKVTUWTWCUXHUXKVDWDWEUMAUWKGUJPQZUWLWFUXAWGUTAGHQUXLUWLJFUWKGHIWHWKZUWMWF
      UXCUXAWGUWMUXBLWIUXFWLWMAUXLSZUXCUWPUXAUWNWGOUXNUWLUXDUXMUXEUMUXNUWLUWQUX
      MUWSUMWNWOUAUBUCUVHFHIWPWQAUVRUWFUAVCAUVNVCQZSZUVQUWEUBHUXPUVJHQZSUVOUWDU
      CUVPUXPUXQUUSUVPQZUVOUWDWTUXPUXQUXRSZSZUVOUVLUVNUSUTZUWDUXTUVMUVLUVNUSUXT
      UVLUXTUVIUVKUXTHTUUSUVHAHTUVHYDUXOUXSACUVGFHIUVBUXGXAWRZUXSUUSHQUXPFUUSUV
      JHIWHVMZWSUXTHTUVJUVHUYBUXPUXQUXRXBZWSXCZUXTWFUWCUVLWFTQUXTXDXEUXTUWBUXTU
      VTUWAUXTHUHUUSUURAHUHUURYDUXOUXSUVCWRZUYCWSUXTHUHUVJUURUYFUYDWSXFZVRZUYEU
      XTUWBUYGWIUXTFUUSXGRZFUVJXGRZXHZUXBCXIZUPPUYKUXCCXIZUWCUVLWGUXTUYKUXBCUXT
      UYIXJQUYKUYIXKUYKXJQUXTFUUSXLZUYIUYJXMUYIUYKXNXOZUWKUYKQZUXTUWKUYIQZUXBUH
      QZUWKUYIUYJXPUXTAUWLUYRUYQAUXOUXSXQZUYQUWKUUTHUWKFUUSXRIXSZLXTZYAZYBUXTUW
      BUYLUPUXTUYIUXBCXIZUYJUXBCXIZURRZUWBUYLUXTVUCUVTVUDUWAURUXTUXBCEFUUSUXTUY
      QSZUXBYEUXTUUSHUUTUYCIUKZVUAYCUXTUXBCEFUVJUXTUWKUYJQZSZUXBYEUXTUVJHUUTUYD
      IUKZUXTAUWLUYRVUHUYSVUHUWKUUTHUWKFUVJXRIXSZLXTZYCYFUXTVUEUYLVGVUDUYLUERZV
      UCVGUXTVUCVUMUXTUYJUYKUXBUYICUYJUYKYOYGVGUXTUYJUYIYHXEZUXTUYJUYKYPUYJUYIY
      PZUYIUYJUYIYIUXTUYJUYIXKZVUOUYIVGUXRVUPUXPUXQUVJFUUSYJYKUYJUYIUUAWBUUBZUY
      NVUAYLYMUXTVUCVUDUYLUXTUYIUXBCUYNVUAYNUXTUYJUXBCUXTFUVJXLZVULYNUXTUYKUXBC
      UYOVUBYNYQYRYSVQUXTUYIUXCCXIZUYJUXCCXIZURRZUVLUYMUXTVUSUVIVUTUVKURUXTUXCC
      UVGFUUSVUFUWLUXDUYQUWLUXTUYTVMUXEUMVUGVUFUYRUXCUHQZVUAUYRUXCUXBUUCVTZUMZY
      CUXTUXCCUVGFUVJVUIUWLUXDVUHUWLUXTVUKVMUXEUMVUJVUIUYRVVBVULVVCUMZYCYFUXTVV
      AUYMVGVUTUYMUERZVUSVGUXTVUSVVFUXTUYJUYKUXCUYICVUNVUQUYNVVDYLYMUXTVUSVUTUY
      MUXTUYIUXCCUYNVVDYNUXTUYJUXCCVURVVEYNUXTUYKUXCCUYOUXTUYPSUYRVVBVUBVVCUMYN
      YQYRYSWNZUUDUUEUUFUXTUWCUVLWGUTZUYAUWDVVGUXTUWCTQUVLTQUVNTQZVVHUYASUWDWTU
      YHUYEUXOVVIAUXSUVNUUPUUGUWCUVLUVNUUHUUIUUJUUKUULYTUUMYTUUQUURUGQAUEEFUUNX
      EUUO $.
  $}

  ${
    $d k F $.  $d k G $.  $d k M $.  $d k ph $.  $d k Z $.
    abscvgcvg.1 $e |- Z = ( ZZ>= ` M ) $.
    abscvgcvg.2 $e |- ( ph -> M e. ZZ ) $.
    abscvgcvg.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = ( abs ` ( G ` k ) ) )
        $.
    abscvgcvg.4 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
    abscvgcvg.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( An absolutely convergent series is convergent.  (Contributed by Mario
       Carneiro, 28-Apr-2014.) $)
    abscvgcvg $p |- ( ph -> seq M ( + , G ) e. dom ~~> ) $=
      ( c1 cuz cfv cz wcel uzid cr cle wbr syl syl6eleqr cv cabs abscld eqeltrd
      wa 1re a1i cmul co eleq2i wceq eqcomd eqle syl2anc recnd mulid2d breqtrrd
      sylan2br cvgcmpce ) ALBCDEEFGAEEMNZFAEOPEVBPHEQUAGUBABUCZFPZUGZVCCNZVCDNZ
      UDNZRIVEVGJUEZUFZJKLRPAUHUIVCVBPAVDVHLVFUJUKZSTFVBVCGULVEVHVFVKSVEVHRPVHV
      FUMVHVFSTVIVEVFVHIUNVHVFUOUPVEVFVEVFVJUQURUSUTVA $.
  $}

  ${
    $d k m n x y z A $.  $d n H $.  $d k m n x y z ph $.  $d j k m n x y z Z $.
    $d m n x y z B $.  $d j m n x y z F $.  $d n M $.
    climfsum.1 $e |- Z = ( ZZ>= ` M ) $.
    climfsum.2 $e |- ( ph -> M e. ZZ ) $.
    climfsum.3 $e |- ( ph -> A e. Fin ) $.
    climfsum.5 $e |- ( ( ph /\ k e. A ) -> F ~~> B ) $.
    climfsum.6 $e |- ( ph -> H e. W ) $.
    climfsum.7 $e |- ( ( ph /\ ( k e. A /\ n e. Z ) ) -> ( F ` n ) e. CC ) $.
    climfsum.8 $e |- ( ( ph /\ n e. Z ) ->
                      ( H ` n ) = sum_ k e. A ( F ` n ) ) $.
    $( Limit of a finite sum of converging sequences.  Note that ` F ( k ) ` is
       a collection of functions with implicit parameter ` k ` , each of which
       converges to ` B ( k ) ` as ` n ~~> +oo ` .  (Contributed by Mario
       Carneiro, 22-Jul-2014.)  (Proof shortened by Mario Carneiro,
       22-May-2016.) $)
    climfsum $p |- ( ph -> H ~~> sum_ k e. A B ) $=
      ( cli wbr wcel csu cv cfv cmpt mpteq2dva crli cvv cr wss cz uzssz eqsstri
      cuz zssre sstri a1i fvex adantr climrel brrelexi syl eqid climmpt syl2anc
      wa wb mpbid cc anassrs fmptd rlimclim mpbird fsumrlim cfn anass1rs fsumcl
      eqbrtrd ) AGBCDUAZRSZEJEUBZGUCZUDZVRRSZAWBEJBVTFUCZDUAZUDZVRRAEJWAWEQUEAW
      FVRUFSWFVRRSAEJBWDCDUGJUHUIAJUJUHJHUMUCUJKHUKULUNUOUPMWDUGTAVTJTZDUBBTZVE
      VEVTFUQUPAWHVEZEJWDUDZCUFSWJCRSZWIFCRSZWKNWIHUJTZFUGTZWLWKVFAWMWHLURZWIWL
      WNNFCRUSUTVACEFWJHUGJKWJVBZVCVDVGWICWJHJKWOWIEJWDVHWJAWHWGWDVHTZPVIWPVJVK
      VLVMAVRWFHJKLAEJWEVHWFAWGVEBWDDABVNTWGMURAWHWGWQPVOVPWFVBVJVKVGVQAWMGITVS
      WCVFLOVREGWBHIJKWBVBVCVDVL $.
  $}

  ${
    $d k u w x y z A $.  $d k u w y z B $.  $d k u w x y z ph $.
    $d u w x y z C $.
    fsumiun.1 $e |- ( ph -> A e. Fin ) $.
    fsumiun.2 $e |- ( ( ph /\ x e. A ) -> B e. Fin ) $.
    fsumiun.3 $e |- ( ph -> Disj_ x e. A B ) $.
    ${
      fsumiun.4 $e |- ( ( ph /\ ( x e. A /\ k e. B ) ) -> C e. CC ) $.
      $( Sum over a disjoint indexed union.  (Contributed by Mario Carneiro,
         1-Jul-2015.)  (Revised by Mario Carneiro, 10-Dec-2016.) $)
      fsumiun $p |- ( ph ->
          sum_ k e. U_ x e. A B C = sum_ x e. A sum_ k e. B C ) $=
        ( vz vw wss ciun csu wceq wcel wi c0 sumeq1d vu ssid cfn csn cun iuneq1
        cv sseq1 0iun syl6eq sumeq1 eqeq12d imbi12d imbi2d weq sum0 eqtr4i a1ii
        cc0 wn wa id unssad imim1i csb caddc co cin nfcv nfcsb1v csbeq1a cbviun
        oveq1 vex csbeq1 iunxsn eqtri ineq2i wdisj ad2antrr adantl simpr unssbd
        simplr disjsn sylibr disjiun syl13anc syl5eqr iunxun uneq2i a1i syl2anc
        wral ssfi ralrimiva ssralv sylc iunfi cc iunss1 sselda eliun rexlimdvaa
        syl5bi imp syldan fsumsplit eqidd anassrs fsumcl r19.21bi nfsum cbvsumi
        wrex cvv snss nfel1 eleq1d sumsn sylancr syl5eq oveq2d eqtrd syl5ibr ex
        rspc a2d syl5 expcom findcard2s mpcom mpi ) ACCMZBCDNZEFOZCDEFOZBOZPZCU
        BCUCQZAYNYSRZGAUAUGZCMZBUUBDNZEFOZUUBYQBOZPZRZRASCMZSEFOZSYQBOZPZRZRAKU
        GZCMZBUUNDNZEFOZUUNYQBOZPZRZRZAUUNLUGZUDZUEZCMZBUVDDNZEFOZUVDYQBOZPZRZR
        ZAUUARUAKLCUUBSPZUUHUUMAUVLUUCUUIUUGUULUUBSCUHUVLUUEUUJUUFUUKUVLUUDSEFU
        VLUUDBSDNSBUUBSDUFBDUIUJTUUBSYQBUKULUMUNUAKUOZUUHUUTAUVMUUCUUOUUGUUSUUB
        UUNCUHUVMUUEUUQUUFUURUVMUUDUUPEFBUUBUUNDUFTUUBUUNYQBUKULUMUNUUBUVDPZUUH
        UVJAUVNUUCUVEUUGUVIUUBUVDCUHUVNUUEUVGUUFUVHUVNUUDUVFEFBUUBUVDDUFTUUBUVD
        YQBUKULUMUNUUBCPZUUHUUAAUVOUUCYNUUGYSUUBCCUHUVOUUEYPUUFYRUVOUUDYOEFBUUB
        CDUFTUUBCYQBUKULUMUNAUUIUULUUJUSUUKEFUPYQBUPUQURUVBUUNQUTZUVAUVKRUUNUCQ
        UVPAUUTUVJAUVPUUTUVJRUUTUVEUUSRAUVPVAZUVJUVEUUOUUSUVEUUNUVCCUVEVBVCZVDU
        VQUVEUUSUVIUVQUVEUUSUVIRUUSUVIUVQUVEVAZUUQBUVBDVEZEFOZVFVGZUURUWAVFVGZP
        UUQUURUWAVFVMUVSUVGUWBUVHUWCUVSUUPUVTEUVFFUVSUUPUVTVHUUPBUVCDNZVHZSUWDU
        VTUUPUWDKUVCBUUNDVEZNUVTBKUVCDUWFKDVIBUUNDVJZBUUNDVKZVLKUVBUWFUVTLVNZBU
        UNUVBDVOZVPVQZVRUVSBCDVSZUUOUVCCMZUUNUVCVHSPZUWESPAUWLUVPUVEIVTUVEUUOUV
        QUVRWAUVSUUNUVCCUVQUVEWBZWCZUVSUVPUWNAUVPUVEWDUUNUVBWEWFZBCDUUNUVCWGWHW
        IUVFUUPUVTUEZPUVSUVFUUPUWDUEUWRBUUNUVCDWJUWDUVTUUPUWKWKVQWLUVSUVDUCQZDU
        CQZBUVDWNZUVFUCQUVSYTUVEUWSAYTUVPUVEGVTUWOCUVDWOWMZUVSUVEUWTBCWNZUXAUWO
        AUXCUVPUVEAUWTBCHWPVTUWTBUVDCWQWRBUVDDWSWMUVSFUGZUVFQUXDYOQZEWTQZUVSUVF
        YOUXDUVEUVFYOMUVQBUVDCDXAWAXBUVSUXEUXFUXEUXDDQZBCXOZUVSUXFBUXDCDXCAUXHU
        XFRUVPUVEAUXGUXFBCJXDVTXEXFXGXHUVSUVHUURUVCYQBOZVFVGUWCUVSUUNUVCYQUVDBU
        WQUVSUVDXIUXBUVSBUGZUVDQUXJCQZYQWTQZUVSUVDCUXJUWOXBUVSUXLBCAUXLBCWNZUVP
        UVEAUXLBCAUXKVADEFHAUXKUXGUXFJXJXKWPVTZXLXGXHUVSUXIUWAUURVFUVSUXIUVCUWF
        EFOZKOZUWAUVCYQUXOBKKYQVIBUWFEFUWGBEVIZXMBKUODUWFEFUWHTXNUVSUVBXPQUWAWT
        QZUXPUWAPUWIUVSUVBCQZUXMUXRUVSUWMUXSUWPUVBCUWIXQWFUXNUXLUXRBUVBCBUWAWTB
        UVTEFBUVBDVJUXQXMXRBLUOZYQUWAWTUXTDUVTEFBUVBDVKTXSYGWRUXOUWAKUVBXPKLUOU
        WFUVTEFUWJTXTYAYBYCYDULYEYFYHYIYJYHWAYKYLYM $.
    $}

    $d u w x y z A $.  $d u w y z B $.  $d x z C $.  $d u w x y z ph $.
    $( The cardinality of a disjoint indexed union.  (Contributed by Mario
       Carneiro, 24-Jan-2015.)  (Revised by Mario Carneiro, 10-Dec-2016.) $)
    hashiun $p |- ( ph -> ( # ` U_ x e. A B ) = sum_ x e. A ( # ` B ) ) $=
      ( vk c1 csu chash cfv cc wcel cv wa ax-1cn cmul cfn wceq ciun a1i fsumiun
      co wral ralrimiva iunfi syl2anc fsumconst sylancl cn0 hashcl nn0cn mulid1
      4syl eqtrd sumeq2dv 3eqtr3d ) ABCDUAZIHJZCDIHJZBJUSKLZCDKLZBJABCDIHEFGIMN
      ZABOCNZHODNPPQUBUCAUTVBIRUDZVBAUSSNZVDUTVFTACSNDSNZBCUEVGEAVHBCFUFBCDUGUH
      ZQUSIHUIUJAVGVBUKNVBMNVFVBTVIUSULVBUMVBUNUOUPACVAVCBAVEPZVAVCIRUDZVCVJVHV
      DVAVKTFQDIHUIUJVJVHVCUKNVCMNVKVCTFDULVCUMVCUNUOUPUQUR $.
  $}

  ${
    $d k u w x y z A $.  $d k u w y z B $.  $d k u w x y z ph $.
    $d u w x y z C $.
    fsumiunOLD.1 $e |- ( ph -> A e. Fin ) $.
    fsumiunOLD.2 $e |- ( ( ph /\ x e. A ) -> B e. Fin ) $.
    fsumiunOLD.3 $e |- ( ph -> E* x ( x e. A /\ y e. B ) ) $.
    ${
      fsumiunOLD.4 $e |- ( ( ph /\ ( x e. A /\ k e. B ) ) -> C e. CC ) $.
      $( Sum over a disjoint indexed union.  (Contributed by Mario Carneiro,
         1-Jul-2015.)  (New usage is discouraged.)
         (Proof modification is discouraged.) $)
      fsumiunOLD $p |- ( ph ->
          sum_ k e. U_ x e. A B C = sum_ x e. A sum_ k e. B C ) $=
        ( cv wcel wa wmo wal wdisj alrimiv dfdisj2 sylibr fsumiun ) ABDEFGHIABL
        DMCLEMNBOZCPBDEQAUBCJRBCDESTKUA $.
    $}

    $d u w x y z A $.  $d u w y z B $.  $d x z C $.  $d u w x y z ph $.
    $( The cardinality of a disjoint indexed union.  (Contributed by Mario
       Carneiro, 24-Jan-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hashiunOLD $p |- ( ph -> ( # ` U_ x e. A B ) = sum_ x e. A ( # ` B ) ) $=
      ( cv wcel wa wmo wal wdisj alrimiv dfdisj2 sylibr hashiun ) ABDEFGABIDJCI
      EJKBLZCMBDENASCHOBCDEPQR $.
  $}

  ${
    $d x y A $.  $d x y ph $.
    hashuni.1 $e |- ( ph -> A e. Fin ) $.
    hashuni.2 $e |- ( ph -> A C_ Fin ) $.
    hashuni.3 $e |- ( ph -> Disj_ x e. A x ) $.
    $( The cardinality of a disjoint union.  (Contributed by Mario Carneiro,
       24-Jan-2015.) $)
    hashuni $p |- ( ph -> ( # ` U. A ) = sum_ x e. A ( # ` x ) ) $=
      ( cuni chash cfv cv ciun csu uniiun fveq2i cfn sselda hashiun syl5eq ) AC
      GZHIBCBJZKZHICTHIBLSUAHBCMNABCTDACOTEPFQR $.
  $}

  ${
    $d x y A $.  $d x y ph $.
    hashuniOLD.1 $e |- ( ph -> A e. Fin ) $.
    hashuniOLD.2 $e |- ( ph -> A C_ Fin ) $.
    hashuniOLD.3 $e |- ( ph -> E* x ( x e. A /\ y e. x ) ) $.
    $( The cardinality of a disjoint union.  (Contributed by Mario Carneiro,
       24-Jan-2015.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    hashuniOLD $p |- ( ph -> ( # ` U. A ) = sum_ x e. A ( # ` x ) ) $=
      ( cuni chash cfv cv ciun csu uniiun fveq2i cfn sselda hashiunOLD syl5eq )
      ADHZIJBDBKZLZIJDUAIJBMTUBIBDNOABCDUAEADPUAFQGRS $.
  $}

  ${
    $d x y z A $.  $d x y z ph $.  $d x y z .~ $.
    qshash.1 $e |- ( ph -> .~ Er A ) $.
    qshash.2 $e |- ( ph -> A e. Fin ) $.
    $( The cardinality of a set with an equivalence relation is the sum of the
       cardinalities of its equivalence classes.  (Contributed by Mario
       Carneiro, 16-Jan-2015.) $)
    qshash $p |- ( ph -> ( # ` A ) = sum_ x e. ( A /. .~ ) ( # ` x ) ) $=
      ( cqs cuni chash cfv cv csu cvv wer cfn wcel erex sylc wss ssfi cpw sylib
      uniqs2 fveq2d pwfi qsss syl2anc elpwi ex syl2im ssrdv sstrd wdisj qsdisj2
      syl hashuni eqtr3d ) ACDGZHZIJCIJURBKZIJBLAUSCIACDMEACDNZCOPZDMPEFCDOQRUC
      UDABURACUAZOPZURVCSUROPAVBVDFCUEUBACDEUFZVCURTUGAURVCOVEABVCOAVBUTVCPUTCS
      ZUTOPZFUTCUHVBVFVGCUTTUIUJUKULAVABURUTUMEBCDCUNUOUPUQ $.
  $}

  ${
    $d w x y z $.
    ackbijnn.1 $e |- F = ( x e. ( ~P NN0 i^i Fin ) |->
        sum_ y e. x ( 2 ^ y ) ) $.
    $( Translate the Ackermann bijection ~ ackbij1 onto the natural numbers.
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    ackbijnn $p |- F : ( ~P NN0 i^i Fin ) -1-1-onto-> NN0 $=
      ( vz vw cn0 cpw cfn chash com ccrd cfv wf1o ax-mp wceq c2 wcel syl wtru
      cin cres cv csn cxp ciun cmpt ccnv cima ccom hashgval2 hashgf1o sneq pweq
      xpeq12d cbviunv iuneq1 syl5eq fveq2d cbvmptv ackbij1 f1ocnv f1opwfi f1oco
      weq mp2an wb cexp co wral inss2 wf f1of eqid fmpt mpbir rspec sseldi snfi
      csu cdm cnvimass f1odm sseqtri con0 onfin2 eqsstri sstri simpr pwfi sylib
      wa xpfi sylancr ralrimiva iunfi ficardom fvres hashcard wdisj xp1st elsni
      syl2anc c1st rgen rgenw invdisj mp1i hashiun sseli wf1 f1of1 inss1 elpwid
      f1ores adantl cc hashcl nn0cn 3syl fsumf1o cmul c1 sselda ffvelrni hashxp
      wss hashsng hashpw f1ocnvfv2 eqtr3d oveq2d eqtrd oveq12d 2cn expcl 3eqtrd
      mulid2d eqidd fmptco sumeq2dv mpteq2ia feqmptd fveq2 trud 3eqtr4i f1oeq1
      mpbi ) GHZIUAZGJKUBZEKHZIUAZFEUCZFUCZUDZUUOHZUEZUFZLMZUGZAUUJUUKUHZAUCZUI
      ZUGZUJZUJZNZUUJGCNZKGUUKNZUUJKUVFNZUVHAUUKAUKULZUUMKUVANUUJUUMUVENZUVKABU
      VAEAUUMUUTBUVCBUCZUDZUVNHZUEZUFZLMEAVEZUUSUVRLUVSUUSBUUNUVQUFUVRFBUUNUURU
      VQFBVEUUPUVOUUQUVPUUOUVNUMUUOUVNUNUOUPBUUNUVCUVQUQURUSUTVAGKUVBNZUVMUVJUV
      TUVLKGUUKVBOZGKUVBAVCOZUUJUUMKUVAUVEVDVFUUJKGUUKUVFVDVFUVGCPUVHUVIVGAUUJF
      UVDUURUFZLMZUUKMZUGZAUUJUVCQUVNVHVIZBVTZUGUVGCAUUJUWEUWHUVCUUJRZUWEUWDJMZ
      UWCJMZUWHUWIUWDKRZUWEUWJPUWIUWCIRZUWLUWIUVDIRUURIRZFUVDVJUWMUWIUUMIUVDUUL
      IVKUVDUUMRZAUUJUWOAUUJVJUUJUUMUVEVLZUVMUWPUWBUUJUUMUVEVMOAUUJUUMUVDUVEUVE
      VNVOVPVQZVRZUWIUWNFUVDUWIUUOUVDRZWLZUUPIRUUQIRZUWNUUOVSUWTUUOIRUXAUWTUVDI
      UUOUVDKIUVDUUKWAZKUUKUVCWBUVJUXBKPUVLKGUUKWCOWDKWEIUAIWFWEIVKWGZWHUWIUWSW
      IVRUUOWJWKUUPUUQWMWNZWOFUVDUURWPXCZUWCWQSZUWDKJWRSUWIUWMUWJUWKPUXEUWCWSSU
      WIUWKUVDUURJMZFVTUVCUVNUVBMZUDZUXHHZUEZJMZBVTUWHUWIFUVDUURUWRUXDUUNXDMZUU
      OPZEUURVJZFUVDVJFUVDUURWTUWIUXOFUVDUXNEUURUUNUURRUXMUUPRUXNUUNUUPUUQXAUXM
      UUOXBSXEXFFEUVDUURUXMXGXHXIUWIUVDUXGUVCUXLFBUVBUVCUBZUXHUUOUXHPZUURUXKJUX
      QUUPUXIUUQUXJUUOUXHUMUUOUXHUNUOUSUUJIUVCUUIIVKXJUWIGKUVBXKZUVCGYGUVCUVDUX
      PNUVTUXRUWAGKUVBXLOUWIUVCGUUJUUIUVCUUIIXMXJXNZGKUVCUVBXOWNUVNUVCRZUVNUXPM
      UXHPUWIUVNUVCUVBWRXPUWTUWNUXGGRUXGXQRUXDUURXRUXGXSXTYAUWIUVCUXLUWGBUWIUXT
      WLZUXLUXIJMZUXJJMZYBVIZYCUWGYBVIUWGUYAUXIIRUXJIRZUXLUYDPUXHVSUYAUXHIRZUYE
      UYAKIUXHUXCUYAUVNGRZUXHKRZUWIUVCGUVNUXSYDZGKUVNUVBUVTGKUVBVLUWAGKUVBVMOYE
      SZVRZUXHWJWKUXIUXJYFWNUYAUYBYCUYCUWGYBUYAUYHUYBYCPUYJUXHKYHSUYAUYCQUXHJMZ
      VHVIZUWGUYAUYFUYCUYMPUYKUXHYISUYAUYLUVNQVHUYAUXHUUKMZUYLUVNUYAUYHUYNUYLPU
      YJUXHKJWRSUYAUVJUYGUYNUVNPUVLUYIKGUVNUUKYJWNYKYLYMYNUYAUWGUYAQXQRUYGUWGXQ
      RYOUYIQUVNYPWNYRYQUUAYQYQUUBUVGUWFPTABUUJKUWDUVNUUKMUWEUVFUUKUWIUWLTUXFXP
      TAEUUJUUMUVDUUTUWDUVEUVAUWIUWOTUWQXPTUVEYSTUVAYSUUNUVDPUUSUWCLFUUNUVDUURU
      QUSYTTBKGUUKUVJKGUUKVLTUVLKGUUKVMXHUUCUVNUWDUUKUUDYTUUEDUUFUUJGUVGCUUGOUU
      H $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The binomial theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k A $.  $d j k B $.  $d j k N $.  $d j k ph $.
    binomlem.1 $e |- ( ph -> A e. CC ) $.
    binomlem.2 $e |- ( ph -> B e. CC ) $.
    binomlem.3 $e |- ( ph -> N e. NN0 ) $.
    binomlem.4 $e |- ( ps -> ( ( A + B ) ^ N ) = sum_ k e. ( 0 ... N )
                      ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) ) $.
    $( Lemma for ~ binom (binomial theorem).  Inductive step.  (Contributed by
       NM, 6-Dec-2005.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    binomlem $p |- ( ( ph /\ ps ) -> ( ( A + B ) ^ ( N + 1 ) ) =
                     sum_ k e. ( 0 ... ( N + 1 ) ) ( ( ( N + 1 ) _C k ) x.
                       ( ( A ^ ( ( N + 1 ) - k ) ) x. ( B ^ k ) ) ) ) $=
      ( co cexp cmul cc0 c1 csu wceq wcel cc adantr vj wa caddc cfz cv cbc cmin
      adantl oveq1d fzfid fzelp1 cn0 elfzelz bccl syl2an nn0cnd sylan2 fznn0sub
      cz expcl elfznn0 mulcld fsummulc1 mulassd ax-1cn a1i addsubd oveq2d expp1
      zcnd eqtrd mul32d eqtr4d sumeq2dv wss fzssp1 cdif wn eldifi eldifn bcval3
      syl syl3anc mul02d cuz cfv fzssuz sumss 3eqtrd 1z 0z nn0zd oveq2 fsumshft
      oveq12d oveq1 cbvsumv syl6eq subsub3d fzp1ss ax-mp sseli peano2zm syl2anc
      elfznn 0p1e1 oveq1i eleq2s nnm1nn0 expcld expm1t fzaddel syl22anc sylancl
      cn npcan eleq1d bitrd mtbird sylan9eqr addcld expp1d adddid bcpasc eqtr3d
      wb adddird fsumadd 3eqtr4d ) ABUBZCDUCKZFLKZCMKZYLDMKZUCKZNFOUCKZUDKZFEUE
      ZUFKZCYPYRUGKZLKZDYRLKZMKZMKZEPZYQFYROUGKZUFKZUUCMKZEPZUCKZYKYPLKZYQYPYRU
      FKZUUCMKZEPZYJYMUUEYNUUIUCYJYMNFUDKZYSCFYRUGKZLKZUUBMKZMKZEPZCMKZUUEYJYLU
      UTCMBYLUUTQAJUHUIAUVAUUEQBAUVAUUOUUSCMKZEPUUOUUDEPUUEAUUOUUSCEANFUJZGAYRU
      UORZUBZYSUURUVDAYRYQRZYSSRYRNFUKZAUVFUBZYSAFULRZYRUSRZYSULRUVFIYRNYPUMZYR
      FUNUOUPZUQZUVEUUQUUBACSRZUUPULRZUUQSRUVDGYRNFURZCUUPUTUOZUVDAUVFUUBSRZUVG
      ADSRZYRULRUVRUVFHYRYPVADYRUTUOZUQZVBZVBZVCAUUOUVBUUDEUVEUVBYSUURCMKZMKUUD
      UVEYSUURCUVMUWBAUVNUVDGTZVDUVEUUCUWDYSMUVEUUCUUQCMKZUUBMKUWDUVEUUAUWFUUBM
      UVEUUACUUPOUCKZLKZUWFUVEYTUWGCLUVEFOYRAFSRZUVDAFIUPZTOSRZUVEVEVFUVEYRUVDU
      VJAYRNFUMUHVJVGVHAUVNUVOUWHUWFQUVDGUVPCUUPVIUOVKUIUVEUUQCUUBUVQUWEUWAVLVK
      VHVMVNAUUOYQUUDENUUOYQVOANFVPVFUVDAUVFUUDSRUVGUVHYSUUCUVLUVHUUAUUBAUVNYTU
      LRUUASRZUVFGYRNYPURCYTUTUOZUVTVBZVBZUQAYRYQUUOVQRZUBZUUDNUUCMKZNUWQYSNUUC
      MUWQUVIUVJUVDVRZYSNQAUVIUWPITUWPUVJAUWPUVFUVJYRYQUUOVSZUVKWBUHUWPUWSAYRYQ
      UUOVTUHYRFWAWCUIUWPAUVFUWRNQZUWTUVHUUCUWNWDZUQVKYQNWEWFVOANYPWGVFZWHWITVK
      BAYNUUTDMKZUUIBYLUUTDMJUIAUXDUUOUUSDMKZEPZUUIAUUOUUSDEUVCHUWCVCAUXFNOUCKZ
      YPUDKZUUGCFUUFUGKZLKZDUUFLKZMKZMKZDMKZEPZUXHUUHEPUUIAUXFUXHFUAUEZOUGKZUFK
      ZCFUXQUGKZLKZDUXQLKZMKZMKZDMKZUAPUXOAUXEUYDEUAONFOUSRZAWJVFNUSRZAWKVFAFIW
      LUVEUUSDUWCAUVSUVDHTVBYRUXQQZUUSUYCDMUYGYSUXRUURUYBMYRUXQFUFWMUYGUUQUXTUU
      BUYAMUYGUUPUXSCLYRUXQFUGWMVHYRUXQDLWMWOWOUIWNUXHUYDUXNUAEUXPYRQZUYCUXMDMU
      YHUXRUUGUYBUXLMUYHUXQUUFFUFUXPYROUGWPZVHUYHUXTUXJUYAUXKMUYHUXSUXICLUYHUXQ
      UUFFUGUYIVHVHUYHUXQUUFDLUYIVHWOWOUIWQWRAUXHUXNUUHEAYRUXHRZUBZUXNUUGUUAUXK
      MKZMKZDMKUUGUYLDMKZMKUUHUYKUXMUYMDMUYKUXLUYLUUGMUYKUXJUUAUXKMUYKUXIYTCLUY
      KFYROAUWIUYJUWJTUYKYRUYJUVJAYRUXGYPUMUHVJUWKUYKVEVFWSVHUIVHUIUYKUUGUYLDUY
      JAUVFUUGSRUXHYQYRUYFUXHYQVOZWKNYPWTXAZXBZUVHUUGUVHUVIUUFUSRZUUGULRAUVIUVF
      ITUVHUVJUYRUVFUVJAUVKUHYRXCZWBUUFFUNXDUPZUQUYKUUAUXKUYJAUVFUWLUYQUWMUQZUY
      KDUUFAUVSUYJHTZUYKYRXORZUUFULRUYJVUCAVUCYROYPUDKUXHYRYPXEUXGOYPUDXFXGXHZU
      HYRXIWBXJZVBVUBVDUYKUYNUUCUUGMUYKUYNUUAUXKDMKZMKUUCUYKUUAUXKDVUAVUEVUBVDU
      YKUUBVUFUUAMAUVSVUCUUBVUFQUYJHVUDDYRXKUOVHVMVHWIVNAUXHYQUUHENUYOAUYPVFUYJ
      AUVFUUHSRUYQUVHUUGUUCUYTUWNVBZUQAYRYQUXHVQRZUBZUUHUWRNVUIUUGNUUCMVUIUVIUY
      RUUFUUORZVRUUGNQAUVIVUHITZVUIUVJUYRVUIUVFUVJVUHUVFAYRYQUXHVSZUHUVKWBZUYSW
      BZVUIVUJUYJVUHUYJVRAYRYQUXHVTUHVUIVUJUUFOUCKZUXHRZUYJVUIUYFFUSRUYRUYEVUJV
      UPYFUYFVUIWKVFVUIFVUKWLVUNUYEVUIWJVFUUFONFXLXMVUIVUOYRUXHVUIYRSRUWKVUOYRQ
      VUIYRVUMVJVEYROXPXNXQXRXSUUFFWAWCUIVUHAUVFUXAVULUXBUQVKUXCWHWIVKXTWOAUUKY
      OQBAUUKYLYKMKYOAYKFACDGHYAZIYBAYLCDAYKFVUQIXJGHYCVKTAUUNUUJQBAUUNYQUUDUUH
      UCKZEPUUJAYQUUMVUREUVHYSUUGUCKZUUCMKUUMVURUVHVUSUULUUCMAUVIUVJVUSUULQUVFI
      UVKYRFYDUOUIUVHYSUUGUUCUVLUYTUWNYGYEVNAYQUUDUUHEANYPUJUWOVUGYHVKTYI $.
  $}

  ${
    $d k n x A $.  $d k n x B $.  $d k x N $.
    $( The binomial theorem: ` ( A + B ) ^ N ` is the sum from ` k = 0 ` to
       ` N ` of ` ( N _C k ) x. ( ( A ^ k ) x. ( B ^ ( N - k ) ) ` .  Theorem
       15-2.8 of [Gleason] p. 296.  This part of the proof sets up the
       induction and does the base case, with the bulk of the work (the
       induction step) in ~ binomlem .  (Contributed by NM, 7-Dec-2005.)
       (Proof shortened by Mario Carneiro, 24-Apr-2014.) $)
    binom $p |- ( ( A e. CC /\ B e. CC /\ N e. NN0 ) ->
                  ( ( A + B ) ^ N ) = sum_ k e. ( 0 ... N )
                    ( ( N _C k ) x. ( ( A ^ ( N - k ) ) x. ( B ^ k ) ) ) ) $=
      ( wcel co cexp cc0 cfz cbc cmin cmul csu wi c1 oveq2 oveq1 oveq2d oveq12d
      wceq vx vn cc cn0 caddc cv wa oveq1d adantr sumeq12dv eqeq12d imbi2d exp0
      oveqan12d 1t1e1 syl6eq cz 0z ax-1cn syl6eqel 0nn0 bcn0 ax-mp subidi fsum1
      sylancr addcl exp0d 3eqtr4rd simprl simprr simpl id binomlem exp31 nn0ind
      0cn a2d impcom 3impa ) AUCEZBUCEZDUDEZABUEFZDGFZHDIFZDCUFZJFZADWGKFZGFZBW
      GGFZLFZLFZCMZTZWCWAWBUGZWOWPWDUAUFZGFZHWQIFZWQWGJFZAWQWGKFZGFZWKLFZLFZCMZ
      TZNWPWDHGFZHHIFZHWGJFZAHWGKFZGFZWKLFZLFZCMZTZNWPWDUBUFZGFZHXPIFZXPWGJFZAX
      PWGKFZGFZWKLFZLFZCMZTZNWPWDXPOUEFZGFZHYFIFZYFWGJFZAYFWGKFZGFZWKLFZLFZCMZT
      ZNWPWONUAUBDWQHTZXFXOWPYPWRXGXEXNWQHWDGPYPWSXHXDXMCWQHHIPYPXDXMTWGWSEZYPW
      TXIXCXLLWQHWGJQYPXBXKWKLYPXAXJAGWQHWGKQRUHSUIUJUKULWQXPTZXFYEWPYRWRXQXEYD
      WQXPWDGPYRWSXRXDYCCWQXPHIPYRXDYCTYQYRWTXSXCYBLWQXPWGJQYRXBYAWKLYRXAXTAGWQ
      XPWGKQRUHSUIUJUKULWQYFTZXFYOWPYSWRYGXEYNWQYFWDGPYSWSYHXDYMCWQYFHIPYSXDYMT
      YQYSWTYIXCYLLWQYFWGJQYSXBYKWKLYSXAYJAGWQYFWGKQRUHSUIUJUKULWQDTZXFWOWPYTWR
      WEXEWNWQDWDGPYTWSWFXDWMCWQDHIPYTXDWMTYQYTWTWHXCWLLWQDWGJQYTXBWJWKLYTXAWIA
      GWQDWGKQRUHSUIUJUKULWPOAHGFZBHGFZLFZLFZOXNXGWPUUDOOLFZOWPUUCOOLWPUUCUUEOW
      AWBUUAOUUBOLAUMBUMUNUOUPRUOUPZWPHUQEUUDUCEXNUUDTURWPUUDOUCUUFUSUTXMUUDCHW
      GHTZXIOXLUUCLUUGXIHHJFZOWGHHJPHUDEUUHOTVAHVBVCUPUUGXKUUAWKUUBLUUGXJHAGUUG
      XJHHKFHWGHHKPHVQVDUPRWGHBGPSSVEVFWPWDABVGVHVIXPUDEZWPYEYOUUIWPYEYOUUIWPUG
      YEABCXPUUIWAWBVJUUIWAWBVKUUIWPVLYEVMVNVOVRVPVSVT $.

    $( Special case of the binomial theorem for ` ( 1 + A ) ^ N ` .
       (Contributed by Paul Chapman, 10-May-2007.) $)
    binom1p $p |- ( ( A e. CC /\ N e. NN0 ) -> ( ( 1 + A ) ^ N ) =
                  sum_ k e. ( 0 ... N ) ( ( N _C k ) x. ( A ^ k ) ) ) $=
      ( cc wcel cn0 wa c1 caddc co cexp cc0 cfz cv cbc cmin cmul csu wceq eqtrd
      ax-1cn binom mp3an1 cz fznn0sub adantl nn0zd 1exp syl simpl elfznn0 expcl
      oveq1d syl2an mulid2d oveq2d sumeq2dv ) ADEZCFEZGZHAIJCKJZLCMJZCBNZOJZHCV
      CPJZKJZAVCKJZQJZQJZBRZVBVDVGQJZBRHDEURUSVAVJSUAHABCUBUCUTVBVIVKBUTVCVBEZG
      ZVHVGVDQVMVHHVGQJVGVMVFHVGQVMVEUDEVFHSVMVEVLVEFEUTVCLCUEUFUGVEUHUIUMVMVGU
      TURVCFEVGDEVLURUSUJVCCUKAVCULUNUOTUPUQT $.

    $( Special case of the binomial theorem for ` 2 ^ N ` .  (Contributed by
       Mario Carneiro, 13-Mar-2014.) $)
    binom11 $p |- ( N e. NN0 -> ( 2 ^ N ) =
                     sum_ k e. ( 0 ... N ) ( N _C k ) ) $=
      ( cn0 wcel c2 cexp co cc0 cfz cv cbc c1 cmul csu caddc df-2 oveq1i ax-1cn
      cc wceq binom1p mpan syl5eq cz elfzelz 1exp syl bccl2 nncnd mulid1d eqtrd
      oveq2d sumeq2i syl6eq ) BCDZEBFGZHBIGZBAJZKGZLURFGZMGZANZUQUSANUOUPLLOGZB
      FGZVBEVCBFPQLSDUOVDVBTRLABUAUBUCUQVAUSAURUQDZVAUSLMGUSVEUTLUSMVEURUDDUTLT
      URHBUEURUFUGULVEUSVEUSURBUHUIUJUKUMUN $.

    $( A summation for the difference between ` ( ( A + 1 ) ^ N ) ` and
       ` ( A ^ N ) ` .  (Contributed by Scott Fenton, 9-Apr-2014.)  (Revised by
       Mario Carneiro, 22-May-2014.) $)
    binom1dif $p |- ( ( A e. CC /\ N e. NN0 ) ->
      ( ( ( A + 1 ) ^ N ) - ( A ^ N ) ) =
      sum_ k e. ( 0 ... ( N - 1 ) ) ( ( N _C k ) x. ( A ^ k ) ) ) $=
      ( cc wcel cn0 wa c1 caddc co cexp cmin cc0 cfz cbc cmul wceq oveq1d eqtrd
      adantl cv csu simpl ax-1cn addcom sylancl binom1p simpr nn0uz syl6eleq cn
      cuz cfv bccl2 nncnd elfznn0 expcl syl2an mulcld oveq2 oveq12d fsumm1 bcnn
      mulid2d oveq2d 3eqtrd fzfid fzssp1 syl5sseq sselda syldan fsumcl pncand
      nn0cn npcan ) ADEZCFEZGZAHIJZCKJZACKJZLJMCHLJZNJZCBUAZOJZAWDKJZPJZBUBZWAI
      JZWALJWHVRVTWIWALVRVTHAIJZCKJMCNJZWGBUBZWIVRVSWJCKVRVPHDEZVSWJQVPVQUCZUDA
      HUEUFRABCUGVRWLWHCCOJZWAPJZIJWIVRWGWPBMCVRCFMULUMVPVQUHUIUJVRWDWKEZGZWEWF
      WRWEWQWEUKEVRWDCUNTUOVRVPWDFEWFDEWQWNWDCUPAWDUQURUSZWDCQWEWOWFWAPWDCCOUTW
      DCAKUTVAVBVRWPWAWHIVRWPHWAPJWAVRWOHWAPVQWOHQVPCVCTRVRWAACUQZVDSVESVFRVRWH
      WAVRWCWGBVRMWBVGVRWDWCEWQWGDEVRWCWKWDVRMWBHIJZNJWCWKMWBVHVRXACMNVRCDEZWMX
      ACQVQXBVPCVNTUDCHVOUFVEVIVJWSVKVLWTVMS $.
  $}

  ${
    $d j m M $.  $d j k m N $.
    $( Lemma for ~ bcxmas .  (Contributed by Paul Chapman, 18-May-2007.) $)
    bcxmaslem1 $p |- ( A = B -> ( ( N + A ) _C A ) = ( ( N + B ) _C B ) ) $=
      ( wceq caddc co cbc oveq2 id oveq12d ) ABDZCAEFCBEFABGABCEHKIJ $.

    $( Lemma for ~ bcxmas .  (Contributed by Paul Chapman, 18-May-2007.) $)
    bcxmaslem2 $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                          ( A + ( B + C ) ) = ( ( A + C ) + B ) ) $=
      ( cc wcel w3a caddc co addass add32 eqtr3d ) ADEBDECDEFABGHCGHABCGHGHACGH
      BGHABCIABCJK $.

    $( Parallel summation (Christmas Stocking) theorem for Pascal's Triangle.
       (Contributed by Paul Chapman, 18-May-2007.)  (Revised by Mario Carneiro,
       24-Apr-2014.) $)
    bcxmas $p |- ( ( N e. NN0 /\ M e. NN0 ) ->
                     ( ( ( N + 1 ) + M ) _C M ) =
                     sum_ j e. ( 0 ... M ) ( ( N + j ) _C j ) ) $=
      ( cn0 wcel c1 caddc co cbc cc0 cfz wceq wi bcxmaslem1 oveq2 sumeq1d wa cc
      csu adantl vm vk cv eqeq12d imbi2d 0nn0 nn0addcl syl mpan2 cz 0z syl6eqel
      bcn0 1nn0 nn0cnd fsum1 sylancr peano2nn0 sylancl 3eqtr4rd cuz cfv elnn0uz
      simpr sylib simpl elfznn0 syl2an elfzelz bccl syl2anc fsump1 nn0cn adantr
      ax-1cn a1i bcxmaslem2 syl3anc oveq1d eqtrd oveq1 cmin pncan sylan nn0p1nn
      oveq2d nnzd bcpasc eqtr3d nnnn0addcl nnnn0d nn0z addcomd peano2cn addassd
      cn 3eqtr3d 3eqtr2rd ex expcom a2d nn0ind impcom ) BDECDEZCFGHZBGHBIHZJBKH
      ZCAUCZGHZXHIHZASZLZXDXEUAUCZGHXMIHZJXMKHZXJASZLZMXDXEJGHZJIHZJJKHZXJASZLZ
      MXDXEUBUCZGHZYCIHZJYCKHZXJASZLZMXDXEYCFGHZGHZYIIHZJYIKHZXJASZLZMXDXLMUAUB
      BXMJLZXQYBXDYOXNXSXPYAXMJXENYOXOXTXJAXMJJKOPUDUEXMYCLZXQYHXDYPXNYEXPYGXMY
      CXENYPXOYFXJAXMYCJKOPUDUEXMYILZXQYNXDYQXNYKXPYMXMYIXENYQXOYLXJAXMYIJKOPUD
      UEXMBLZXQXLXDYRXNXFXPXKXMBXENYRXOXGXJAXMBJKOPUDUEXDCJGHZJIHZFYAXSXDJDEZYT
      FLZUFXDUUAQYSDEUUBCJUGYSUMUHUIZXDJUJEYTREYAYTLUKXDYTXDYTFDUUCUNULUOXJYTAJ
      XHJCNUPUQXDXRDEZXSFLXDXEDEZUUAUUDCURZUFXEJUGUSXRUMUHUTYCDEZXDYHYNXDUUGYHY
      NMXDUUGQZYHYNUUHYHQYMYGYDYIIHZGHZYEUUIGHZYKUUHYMUUJLYHUUHYMYGCYIGHZYIIHZG
      HUUJUUHXJUUMAJYCUUHUUGYCJVAVBEXDUUGVDYCVCVEUUHXHYLEZQZXJUUOXIDEZXHUJEZXJD
      EUUHXDXHDEUUPUUNXDUUGVFXHYIVGCXHUGVHUUNUUQUUHXHJYIVITXHXIVJVKUOXHYICNVLUU
      HUUMUUIYGGUUHUULYDYIIUUHCREZYCREZFREZUULYDLXDUURUUGCVMZVNUUGUUSXDYCVMTZUU
      TUUHVOVPZCYCFVQVRVSWFVTVNYHUUKUUJLUUHYEYGUUIGWATUUHUUKYKLYHUUHUUIYEGHZYDF
      GHZYIIHZUUKYKUUHUUIYDYIFWBHZIHZGHZUVDUVFUUHUVHYEUUIGUUHUVGYCYDIUUHUUSUUTU
      VGYCLUVBVOYCFWCUSWFWFUUHYDDEZYIUJEZUVIUVFLXDUUEUUGUVJUUFXEYCUGZWDUUHYIUUG
      YIWPEXDYCWETWGZYIYDWHVKWIUUHUUIYEUUHUUIUUHUVJUVKUUIDEUUHYDXDXEWPEUUGYDWPE
      CWEXEYCWJWDWKUVMYIYDVJVKUOUUHYEXDUUEUUGYEDEZUUFUUEUUGQUVJYCUJEZUVNUVLUUGU
      VOUUEYCWLTYCYDVJVKWDUOWMUUHUVEYJYIIUUHXEYCFXDXEREZUUGXDUURUVPUVACWNUHVNUV
      BUVCWOVSWQVNWRWSWTXAXBXC $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          The inclusion/exclusion principle
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d b k n s t u x y z A $.  $d b s B $.
    $( Lemma for ~ incexc .  (Contributed by Mario Carneiro, 7-Aug-2017.) $)
    incexclem $p |- ( ( A e. Fin /\ B e. Fin ) ->
      ( ( # ` B ) - ( # ` ( B i^i U. A ) ) ) = sum_ s e. ~P A
      ( ( -u 1 ^ ( # ` s ) ) x. ( # ` ( B i^i |^| s ) ) ) ) $=
      ( vb cfn wcel chash cfv cin cmin co cmul csu wceq c0 syl6eq fveq2d oveq2d
      wa wss vx vy vz vt vu cv cuni cpw c1 cneg cexp cint wral cc0 csn cun uni0
      unieq ineq2d in0 hash0 pw0 sumeq1d eqeq12d ralbidv weq uniun unisn uneq2i
      pweq vex eqtri hashcl nn0cnd mulid2d cvv cc 0ex eqeltrd fveq2 neg1cn exp0
      ax-mp rint0 oveq12d sumsn sylancr subid1d 3eqtr4rd rgen wn ineq1 sumeq2dv
      simpl ineq1d rspcva adantll simpr inss1 ssfi sylancl in32 inass sumeq2sdv
      sylan caddc hashun3 syl2anc indi fveq2i inindi 3eqtr4g cn0 syl addsubassd
      oveq2i eqtrd adantl adantr cdif mpbi pwfi sylib elpwi syl2an mulcld inteq
      unex sylibr simpllr eqcomd eqeq2d syl5ibrcom ssneldd sylan2 3eqtrd syldan
      a1i uneq1 fsumcl subcld subsub4d eqtr4d disjdif ssun1 sspwb eqcomi simpll
      undif snfi unfi expcld simplr fsumsplit cmpt intunsn eqid unss1 snex elpw
      ssun2 snss mpbir ssel syl5com eldifd eldifi elpwid uncom syl6sseq ssundif
      syl5 elpw2 elpwunsn ad2antll ssequn2 undif1 ad2antrl difsnb difeq1 difun2
      mtod snssd impbid f1o2d fvmpt fsumf1o cbvsumv wi hashunsng expp1d mulcomd
      mulm1d 3eqtr2d oveq1d mulneg1d syl5eq fsumneg sselda negsubd ex ralrimdva
      sseli 3eqtr4d cbvralv syl6ibr findcard2s rspccva ) AEFDUFZGHZUXIAUGZIZGHZ
      JKZAUHZUIUJZCUFZGHZUKKZUXIUXQULZIZGHZLKZCMZNZDEUMZBEFBGHZBUXKIZGHZJKZUXOU
      XSBUXTIZGHZLKZCMZNZUXJUXIUAUFZUGZIZGHZJKZUYPUHZUYCCMZNZDEUMUXJUNJKZOUOZUY
      CCMZNZDEUMUXJUXIUBUFZUGZIZGHZJKZVUHUHZUYCCMZNZDEUMZUXJUXIVUIUCUFZUPZIZGHZ
      JKZVUHVUQUOZUPZUHZUYCCMZNZDEUMZUYFUAUBUCAUYPONZVUCVUGDEVVHUYTVUDVUBVUFVVH
      UYSUNUXJJVVHUYSOGHZUNVVHUYROGVVHUYRUXIOIOVVHUYQOUXIVVHUYQOUGOUYPOURUQPUSU
      XIUTPQVAPRVVHVUAVUEUYCCVVHVUAOUHVUEUYPOVJVBPVCVDVEUAUBVFZVUCVUODEVVJUYTVU
      LVUBVUNVVJUYSVUKUXJJVVJUYRVUJGVVJUYQVUIUXIUYPVUHURUSQRVVJVUAVUMUYCCUYPVUH
      VJVCVDVEUYPVVCNZVUCVVFDEVVKUYTVVAVUBVVEVVKUYSVUTUXJJVVKUYRVUSGVVKUYQVURUX
      IVVKUYQVVCUGZVURUYPVVCURVVLVUIVVBUGZUPVURVUHVVBVGVVMVUQVUIVUQUCVKZVHVIVLP
      USQRVVKVUAVVDUYCCUYPVVCVJVCVDVEUYPANZVUCUYEDEVVOUYTUXNVUBUYDVVOUYSUXMUXJJ
      VVOUYRUXLGVVOUYQUXKUXIUYPAURUSQRVVOVUAUXOUYCCUYPAVJVCVDVEVUGDEUXIEFZUIUXJ
      LKZUXJVUFVUDVVPUXJVVPUXJUXIVMVNZVOZVVPOVPFVVQVQFVUFVVQNVRVVPVVQUXJVQVVSVV
      RVSUYCVVQCOVPUXQONZUXSUIUYBUXJLVVTUXSUXPUNUKKZUIVVTUXRUNUXPUKVVTUXRVVIUNU
      XQOGVTVAPRUXPVQFZVWAUINWAUXPWBWCPVVTUYAUXIGUXIUXQWDQWEWFWGVVPUXJVVRWHWIWJ
      VUHEFZVUQVUHFZWKZSZVUPUYPGHZUYPVURIZGHZJKZVVDUXSUYPUXTIZGHZLKZCMZNZUAEUMV
      VGVWFVUPVWOUAEVWFUYPEFZSZVUPVWOVWQVUPSZVWGUYPVUIIZGHZJKZUYPVUQIZGHZUYPVUI
      VUQIZIZGHZJKZJKZVUMVWMCMZVUMUXSUYPUXTVUQIZIZGHZLKZCMZJKZVWJVWNVWRVXAVXIVX
      GVXNJVWPVUPVXAVXINZVWFVUOVXPDUYPEDUAVFZVULVXAVUNVXIVXQUXJVWGVUKVWTJUXIUYP
      GVTZVXQVUJVWSGUXIUYPVUIWLQWEVXQVUMUYCVWMCVXQUXQVUMFZSZUYBVWLUXSLVXTUYAVWK
      GVXTUXIUYPUXTVXQVXSWNWOQRWMVDWPWQVWQVXBEFZVUPVXGVXNNZVWQVWPVXBUYPTVYAVWFV
      WPWRZUYPVUQWSUYPVXBWTXAZVUOVYBDVXBEUXIVXBNZVULVXGVUNVXNVYEUXJVXCVUKVXFJUX
      IVXBGVTVYEVUJVXEGVYEVUJVXBVUIIZVXEUXIVXBVUIWLVYFVWSVUQIVXEUYPVUQVUIXBUYPV
      UIVUQXCVLPQWEVYEVUMUYCVXMCVYEUYBVXLUXSLVYEUYAVXKGVYEUYAVXBUXTIZVXKUXIVXBU
      XTWLVYGVWKVUQIVXKUYPVUQUXTXBUYPUXTVUQXCVLPQRXDVDWPXEWEVWQVWJVXHNVUPVWQVWJ
      VWGVWTVXGXFKZJKVXHVWQVWIVYHVWGJVWQVWIVWTVXCXFKZVXFJKZVYHVWQVWSVXBUPZGHZVY
      IVWSVXBIZGHZJKZVWIVYJVWQVWSEFZVYAVYLVYONVWQVWPVWSUYPTVYPVYCUYPVUIWSUYPVWS
      WTXAZVYDVWSVXBXGXHVWHVYKGUYPVUIVUQXIXJVXFVYNVYIJVXEVYMGUYPVUIVUQXKXJXPXLV
      WQVWTVXCVXFVWQVWTVWQVYPVWTXMFVYQVWSVMXNVNZVWQVXCVWQVYAVXCXMFVYDVXBVMXNVNZ
      VWQVXFVWQVXEEFZVXFXMFVWQVWPVXEUYPTVYTVYCUYPVXDWSUYPVXEWTXAVXEVMXNVNZXOXQR
      VWQVWGVWTVXGVWQVWGVWPVWGXMFVWFUYPVMXRVNVYRVWQVXCVXFVYSWUAUUAUUBUUCXSVWQVW
      NVXONVUPVWQVWNVXIVVDVUMXTZVWMCMZXFKVXIVXNUJZXFKVXOVWQVUMWUBVWMVVDCVUMWUBI
      ONVWQVUMVVDUUDYRVVDVUMWUBUPZNVWQWUEVVDVUMVVDTZWUEVVDNVUHVVCTWUFVUHVVBUUEV
      UHVVCUUFYAZVUMVVDUUIYAUUGYRVWQVVCEFZVVDEFVWQVWCVVBEFWUHVWCVWEVWPUUHZVUQUU
      JVUHVVBUUKXAZVVCYBYCVWQUXQVVDFZSZUXSVWLWULUXPUXRVWBWULWAYRWULUXQEFZUXRXMF
      ZVWQWUHUXQVVCTWUMWUKWUJUXQVVCYDVVCUXQWTYEUXQVMZXNUULZWULVWLWULVWKEFZVWLXM
      FWULVWPVWKUYPTWUQVWFVWPWUKUUMZUYPUXTWSUYPVWKWTXAVWKVMXNVNYFZUUNVWQWUCWUDV
      XIXFVWQWUCVUMUXPUDUFZVVBUPZGHZUKKZUYPWUTULZVUQIZIZGHZLKZUDMZVUMVXMUJZCMZW
      UDVWQWUBVWMVUMWVHCUDUEVUMUEUFZVVBUPZUUOZWVAUXQWVANZUXSWVCVWLWVGLWVOUXRWVB
      UXPUKUXQWVAGVTRWVOVWKWVFGWVOUXTWVEUYPWVOUXTWVAULWVEUXQWVAYGWUTVUQVVNUUPPU
      SQWEVWQVWCVUMEFWUIVUHYBYCZVWQUECVUMWUBWVMUXQVVBXTZWVNWVNUUQZVWQWVLVUMFZSZ
      WVMVVDVUMWVTWVMVVCTZWVMVVDFWVTWVLVUHTZWWAWVSWWBVWQWVLVUHYDZXRWVLVUHVVBUUR
      XNWVMVVCWVLVVBUEVKVUQUUSZYHUUTYIWVTWVMVUMFZVWDVWCVWEVWPWVSYJWWEWVMVUHTZWV
      TVWDWVMVUHYDWVTVUQWVMFZWWFVWDWWGWVTWWGVVBWVMTVVBWVLUVAVUQWVMVVNUVBUVCYRWV
      MVUHVUQUVDUVEUVLUWBUVFVWQUXQWUBFZSZWVQVUHTZWVQVUMFWWIUXQVVBVUHUPZTWWJWWIU
      XQVVCWWKWWIUXQVVCWWHWUKVWQUXQVVDVUMUVGZXRUVHVUHVVBUVIUVJUXQVVBVUHUVKYCWVQ
      VUHUBVKUVMYIVWQWVSWWHSZSZWVLWVQNZUXQWVMNZWWNWWPWWOUXQUXQVVBUPZNWWNWWQUXQW
      WNVVBUXQTWWQUXQNWWNVUQUXQWWHVUQUXQFZVWQWVSUXQVUHVUQUVNUVOUWCVVBUXQUVPYCYK
      WWOWVMWWQUXQWWOWVMWVQVVBUPWWQWVLWVQVVBYSUXQVVBUVQPYLYMWWNWWOWWPWVLWVLVVBX
      TZNWWNWWSWVLWWNVUQWVLFWKWWSWVLNWWNWVLVUHVUQWVSWWBVWQWWHWWCUVRVWCVWEVWPWWM
      YJYNVUQWVLUVSYCYKWWPWVQWWSWVLWWPWVQWVMVVBXTWWSUXQWVMVVBUVTWVLVVBUWAPYLYMU
      WDUWEWUTVUMFWUTWVNHWVANVWQUEWUTWVMWVAVUMWVNWVLWUTVVBYSWVRWUTVVBUDVKWWDYHU
      WFXRWWHVWQWUKVWMVQFZWWLWUSYOUWGVWQWVIVUMUXPWWQGHZUKKZVXLLKZCMWVKVUMWVHWXC
      UDCUDCVFZWVCWXBWVGVXLLWXDWVBWXAUXPUKWXDWVAWWQGWUTUXQVVBYSQRWXDWVFVXKGWXDW
      VEVXJUYPWXDWVDUXTVUQWUTUXQYGWOUSQWEUWHVWQVUMWXCWVJCVWQVXSSZWXCUXSUJZVXLLK
      WVJWXEWXBWXFVXLLWXEWXBUXSUXPLKZUXPUXSLKWXFWXEWXBUXPUXRUIXFKZUKKWXGWXEWXAW
      XHUXPUKWXEWUMWWRWKZWXAWXHNZVWQVWCUXQVUHTZWUMVXSWUIUXQVUHYDZVUHUXQWTYEZWXE
      UXQVUHVUQVXSWXKVWQWXLXRVWCVWEVWPVXSYJYNVUQVPFWUMWXISWXJUWIVVNUXQVUQVPUWJW
      CXHRWXEUXPUXRVWBWXEWAYRZWXEWUMWUNWXMWUOXNUWKXQWXEUXPUXSWXNVXSVWQWUKUXSVQF
      VUMVVDUXQWUGUXCZWUPYOZUWLWXEUXSWXPUWMUWNUWOWXEUXSVXLWXPVXSVWQWUKVXLVQFWXO
      WULVXLWULVXKEFZVXLXMFWULVWPVXKUYPTWXQWURUYPVXJWSUYPVXKWTXAVXKVMXNVNZYOUWP
      XQWMUWQVWQVUMVXMCWVPVXSVWQWUKVXMVQFZWXOWULUXSVXLWUPWXRYFZYOUWRYPRVWQVXIVX
      NVWQVUMVWMCWVPVWQVXSWUKWWTVWQVUMVVDUXQWUFVWQWUGYRUWSZWUSYQYTVWQVUMVXMCWVP
      VWQVXSWUKWXSWYAWXTYQYTUWTYPXSUXDUXAUXBVVFVWODUAEVXQVVAVWJVVEVWNVXQUXJVWGV
      UTVWIJVXRVXQVUSVWHGUXIUYPVURWLQWEVXQVVDUYCVWMCVXQUYBVWLUXSLVXQUYAVWKGUXIU
      YPUXTWLQRXDVDUXEUXFUXGUYEUYODBEUXIBNZUXNUYJUYDUYNWYBUXJUYGUXMUYIJUXIBGVTW
      YBUXLUYHGUXIBUXKWLQWEWYBUXOUYCUYMCWYBUXQUXOFZSZUYBUYLUXSLWYDUYAUYKGWYDUXI
      BUXTWYBWYCWNWOQRWMVDUXHXE $.

    $( The inclusion/exclusion principle for counting the elements of a finite
       union of finite sets.  (Contributed by Mario Carneiro, 7-Aug-2017.) $)
    incexc $p |- ( ( A e. Fin /\ A C_ Fin ) ->
      ( # ` U. A ) = sum_ s e. ( ~P A \ { (/) } )
      ( ( -u 1 ^ ( ( # ` s ) - 1 ) ) x. ( # ` |^| s ) ) ) $=
      ( cfn wcel wss chash cfv c0 c1 cneg cmin co cexp cmul csu cc syl a1i wceq
      cc0 wa cuni cpw csn cdif cint unifi hashcl nn0cnd simpl pwfi sylib ax-1cn
      cv diffi negcld cn cn0 wne eldifsni adantl wb eldifi ssfi syl2an hashnncl
      elpwi mpbird nnm1nn0 expcld simplr sstrd intssuni mulcld fsumcl cin caddc
      syl2anc disjdif cun 0elpw snssi ax-mp undif eqcomi adantr inss1 fsumsplit
      sylancl inidm fveq2i oveq2i subidd syl5eq incexclem syldan eqtr3d negsubd
      mpbi cvv fveq2 hash0 syl6eq oveq2d neg1cn exp0 rint0 fveq2d oveq12d sumsn
      sylancr mulid2d eqtr2d fsumneg expm1t mulm1d 3eqtrd unissd dfss1 mulneg1d
      0ex mulcomd sumeq2dv 3eqtr4rd subeq0d ) ACDZACEZUAZAUBZFGZAUCZHUDZUEZIJZB
      UNZFGZIKLZMLZYOUFZFGZNLZBOZYHYICDZYJPDAUGZUUCYJYIUHUIQZYHYMUUABYHYKCDZYMC
      DYHYFUUFYFYGUJZAUKULZYKYLUOQZYHYOYMDZUAZYRYTUUKYNYQUUKIIPDZUUKUMRUPZUUKYP
      UQDZYQURDUUKUUNYOHUSZUUJUUOYHYOYKHUTVAZUUKYOCDZUUNUUOVBYHYFYOAEZUUQUUJUUG
      UUJYOYKDZUURYOYKYLVCYOAVGZQZAYOVDZVEZYOVFQVHZYPVIQVJZUUKYTUUKYSCDZYTURDUU
      KYOUBZCDZYSUVGEZUVFUUKUUQYOCEUVHUVCUUKYOACUUJUURYHUVAVAZYFYGUUJVKVLYOUGVR
      UUKUUOUVIUUPYOVMQZUVGYSVDVRYSUHQUIZVNZVOZYHYKYNYPMLZYIYSVPZFGZNLZBOZYLUVR
      BOZYMUVRBOZVQLZTYJUUBKLZYHYLYMUVRYKBYLYMVPHSYHYLYKVSRYKYLYMVTZSYHUWDYKYLY
      KEZUWDYKSHYKDUWEAWAHYKWBWCYLYKWDWSWERUUHYHUUSUAZUVOUVQUWFYNYPUWFIUULUWFUM
      RUPUWFUUQYPURDYHYFUURUUQUUSUUGUUTUVBVEYOUHQVJUWFUVQUWFUVPCDZUVQURDUWFUUCU
      VPYIEUWGYHUUCUUSUUDWFYIYSWGYIUVPVDWIUVPUHQUIVNWHYHYJYIYIVPZFGZKLZTUVSYHUW
      JYJYJKLTUWIYJYJKUWHYIFYIWJWKWLYHYJUUEWMWNYFYGUUCUWJUVSSUUDAYIBWOWPWQYHYJU
      UBJZVQLUWCUWBYHYJUUBUUEUVNWRYHYJUVTUWKUWAVQYHUVTIYJNLZYJYHHWTDUWLPDUVTUWL
      SYAYHIYJUULYHUMRUUEVNUVRUWLBHWTYOHSZUVOIUVQYJNUWMUVOYNTMLZIUWMYPTYNMUWMYP
      HFGTYOHFXAXBXCXDYNPDZUWNISXEYNXFWCXCUWMUVPYIFYIYOXGXHXIXJXKYHYJUUEXLXMYHY
      MUUAJZBOUWKUWAYHYMUUABUUIUVMXNYHYMUWPUVRBUUKUVRYRJZYTNLUWPUUKUVOUWQUVQYTN
      UUKUVOYRYNNLZYNYRNLUWQUUKUWOUUNUVOUWRSUUMUVDYNYPXOVRUUKYRYNUVEUUMYBUUKYRU
      VEXPXQUUKUVPYSFUUKYSYIEUVPYSSUUKYSUVGYIUVKUUKYOAUVJXRVLYSYIXSULXHXIUUKYRY
      TUVEUVLXTXMYCWQXIWQYDYE $.

    $( The inclusion/exclusion principle for counting the elements of a finite
       union of finite sets.  (Contributed by Mario Carneiro, 7-Aug-2017.) $)
    incexc2 $p |- ( ( A e. Fin /\ A C_ Fin ) ->
      ( # ` U. A ) = sum_ n e. ( 1 ... ( # ` A ) )
        ( ( -u 1 ^ ( n - 1 ) ) x.
          sum_ s e. { k e. ~P A | ( # ` k ) = n } ( # ` |^| s ) ) ) $=
      ( cfn wcel wss wa chash cfv c1 co wceq cmul csu c0 cn syl ssfi cc cuni cv
      cfz cpw crab ciun cneg cmin cexp cint csn cdif incexc wn wrex wne cle wbr
      cz wb cn0 hashcl ad2antrr nn0zd cdom simpl elpwi ssdomg imp hashdomi fznn
      syl2an rbaibd syl2anc hashnncl bitr2d df-ne risset 3bitr3g notbii 3bitr4g
      elsn eqcom rexbii rabbidva dfdif2 iunrab 3eqtr4g sumeq1d eqtrd fzfid pwfi
      simpll sylib ssrab2 sylancl wral wdisj fveq2 eqeq1d elrab simprbi invdisj
      adantl ralrimiva oveq1d oveq2d ax-1cn negcld elfznn nnm1nn0 expcld adantr
      a1i unifi eqeltrd elrabi mpbid intssuni unissd sstrd nn0cnd mulcld anasss
      fsumiun sumeq2dv fsummulc2 eqtr4d 3eqtrd ) AEFZAEGZHZAUAZIJZCKAIJZUCLZBUB
      ZIJZCUBZMZBAUDZUEZUFZKUGZDUBZIJZKUHLZUILZUUEUJZIJZNLZDOZYPUUBUUKDOZCOYPUU
      DYSKUHLZUILZUUBUUJDONLZCOYLYNUUAPUKZULZUUKDOUULADUMYLUURUUCUUKDYLYQUUQFZU
      NZBUUAUEYTCYPUOZBUUAUEUURUUCYLUUTUVABUUAYLYQUUAFZHZYQPMZUNZYSYRMZCYPUOZUU
      TUVAUVCYQPUPZYRYPFZUVEUVGUVCUVIYRQFZUVHUVCYOUSFZYRYOUQURZUVIUVJUTUVCYOYJY
      OVAFYKUVBAVBVCVDUVCYQAVEURZUVLYLYJYQAGZUVMUVBYJYKVFZYQAVGZYJUVNUVMYQAEVHV
      IVLYQAVJRUVKUVIUVJUVLYRYOVKVMVNUVCYQEFZUVJUVHUTYLYJUVNUVQUVBUVOUVPAYQSVLY
      QVORVPYQPVQCYRYPVRVSUUSUVDBPWBVTYTUVFCYPYRYSWCWDWAWEBUUAUUQWFYTCBYPUUAWGW
      HWIWJYLCYPUUBUUKDYLKYOWKYLYSYPFZHZUUAEFZUUBUUAGUUBEFUVSYJUVTYJYKUVRWMZAWL
      WNYTBUUAWOUUAUUBSWPZYLUUFYSMZDUUBWQZCYPWQCYPUUBWRYLUWDCYPUVSUWCDUUBUUEUUB
      FZUWCUVSUWEUUEUUAFZUWCYTUWCBUUEUUAYQUUEMYRUUFYSYQUUEIWSWTXAXBXDZXEXECDYPU
      UBUUFXCRYLUVRUWEUUKTFUVSUWEHZUUKUUOUUJNLZTUWHUUHUUOUUJNUWHUUGUUNUUDUIUWHU
      UFYSKUHUWGXFXGXFZUWHUUOUUJUVSUUOTFUWEUVSUUDUUNUVSKKTFUVSXHXNXIUVSYSQFZUUN
      VAFUVRUWKYLYSYOXJXDZYSXKRXLZXMUWHUUJUWHUUIEFZUUJVAFUWHYMEFZUUIYMGUWNYLUWO
      UVRUWEAXOVCUWHUUIUUEUAZYMUWHUUEPUPZUUIUWPGUWHUUFQFZUWQUWHUUFYSQUWGUVSUWKU
      WEUWLXMXPUWHUUEEFZUWRUWQUTUWHYJUUEAGZUWSUVSYJUWEUWAXMUWHUWFUWTUWEUWFUVSYT
      BUUEUUAXQXDUUEAVGRZAUUESVNUUEVORXRUUEXSRUWHUUEAUXAXTYAYMUUISVNUUIVBRYBZYC
      XPYDYEYLYPUUMUUPCUVSUUMUUBUWIDOUUPUVSUUBUUKUWIDUWJYFUVSUUBUUJUUODUWBUWMUX
      BYGYHYFYI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Infinite sums (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k m n x A $.  $d j k m n x K $.  $d j k m n x ph $.  $d j k m n x W $.
    $d j m n x B $.  $d m n x M $.  $d k m n x Z $.
    isumshft.1 $e |- Z = ( ZZ>= ` M ) $.
    isumshft.2 $e |- W = ( ZZ>= ` ( M + K ) ) $.
    isumshft.3 $e |- ( j = ( K + k ) -> A = B ) $.
    isumshft.4 $e |- ( ph -> K e. ZZ ) $.
    isumshft.5 $e |- ( ph -> M e. ZZ ) $.
    isumshft.6 $e |- ( ( ph /\ j e. W ) -> A e. CC ) $.
    $( Index shift of an infinite sum.  (Contributed by Paul Chapman,
       31-Oct-2007.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    isumshft $p |- ( ph -> sum_ j e. W A = sum_ k e. Z B ) $=
      ( cfv caddc wcel wceq cc vm vn vx cv cmpt csu co cseq cli wbr cio zaddcld
      cshi cuz eleq2i wa cmin zcnd eluzelz eleq2s cvv fvex eqeltri mptex syl2an
      shftval wral cid simpr eqid fvmpt2i addcom cz id syl6eleq eluzadd syl2anr
      syl eqeltrd syl6eleqr fvmpti eqtr4d ralrimiva nffvmpt1 nfeq1 fveq2 fveq2d
      oveq2 eqeq12d mpan9 adantr eluzsub syl3anc rspccva syl2anc pncan3 3eqtrrd
      sylan2br seqfeq breq1d wb isershft bitr4d iotabidv df-fv 3eqtr4g eqidd wf
      rspc fmptd ffvelrn sylan isum eleq1d 3eqtr4d sumfc 3eqtr3g ) AHUAUDZDHBUE
      ZPZUAUFZIUBUDZEICUEZPZUBUFZHBDUFICEUFAQXSGFQUGZUHZUIPZQYCGUHZUIPZYAYEAYGU
      CUDZUIUJZUCUKYIYKUIUJZUCUKYHYJAYLYMUCAYLQYCFUMUGZYFUHZYKUIUJZYMAYGYOYKUIA
      QUAXSYNYFAGFNMULZXRYFUNPZRZAXRHRZXTXRYNPZSHYRXRKUOAYTUPZUUAXRFUQUGZYCPZFU
      UCQUGZXSPZXTAFTRZXRTRZUUAUUDSYTAFMURZUUHXRYRHYSXRYFXRUSURKUTZFXRYCEICIGUN
      PZVAJGUNVBVCVDZVFVEUUBYDFYBQUGZXSPZSZUBIVGZUUCIRUUDUUFSZAUUPYTAUUOUBIAEUD
      ZYCPZFUURQUGZXSPZSZEIVGYBIRZUUOAUVBEIAUURIRZUPZUUSCVHPZUVAUVEUVDUUSUVFSAU
      VDVIEICYCYCVJVKVRUVEUUTHRZUVAUVFSUVEUUTYRHUVEUUTUURFQUGZYRAUUGUURTRZUUTUV
      HSUVDUUIUVIUURUUKIUURUUKRZUURGUURUSURJUTFUURVLVEUVDUVJFVMRZUVHYRRAUVDUURI
      UUKUVDVNJVOMFGUURVPVQVSKVTZDUUTBCHXSLXSVJZWAVRWBWCUVBUUOEYBIEYDUUNEICYBWD
      WEUURYBSZUUSYDUVAUUNUURYBYCWFUVNUUTUUMXSUURYBFQWHZWGWIXIWJZWCWKUUBUUCUUKI
      UUBGVMRZUVKYSUUCUUKRAUVQYTNWKAUVKYTMWKUUBXRHYRAYTVIKVOFGXRWLWMJVTUUOUUQUB
      UUCIYBUUCSZYDUUDUUNUUFYBUUCYCWFUVRUUMUUEXSYBUUCFQWHWGWIWNWOUUBUUEXRXSAUUG
      UUHUUEXRSYTUUIUUJFXRWPVEWGWQWRWSWTAUVQUVKYMYPXANMYKQYCGFUULXBWOXCXDUCYGUI
      XEUCYIUIXEXFAXTUAXSYFHKYQUUBXTXGAHTXSXHZYTXTTRADHBTXSOUVMXJZHTXRXSXKXLXMA
      YDUBYCGIJNAUVCUPZYDXGUWAYDUUNTUVPUWAUVSUUMHRZUUNTRAUVSUVCUVTWKAUVGEIVGUVC
      UWBAUVGEIUVLWCUVGUWBEYBIUVNUUTUUMHUVOXNWNXLHTUUMXSXKWOVSXMXOHBUADXPICUBEX
      PXQ $.
  $}

  ${
    $d j A $.  $d j k m x F $.  $d j k m x M $.  $d j k m x ph $.  $d k Z $.
    $d j k m x N $.  $d j k m x W $.
    isumsplit.1 $e |- Z = ( ZZ>= ` M ) $.
    isumsplit.2 $e |- W = ( ZZ>= ` N ) $.
    isumsplit.3 $e |- ( ph -> N e. Z ) $.
    isumsplit.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumsplit.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    isumsplit.6 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( Split off the first ` N ` terms of an infinite sum.  (Contributed by
       Paul Chapman, 9-Feb-2008.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    isumsplit $p |- ( ph -> sum_ k e. Z A =
                      ( sum_ k e. ( M ... ( N - 1 ) ) A + sum_ k e. W A ) ) $=
      ( co caddc cfv wcel wceq cc vj vm vx c1 cmin cfz csu cuz syl6eleq eluzel2
      cz syl cseq cli cdm eluzelz wss uzss 3sstr4g sselda syldan eqeltrd iserex
      cv wa mpbid isumclim2 fzfid elfzuz syl6eleqr sylan2 fsumcl serf ffvelrnda
      cc0 c0 clt wbr zred ltm1d peano2zm fzn syl2anc sumeq1d adantr sum0 syl6eq
      oveq1d addid2d eqtr2d oveq1 oveq2d seqeq1 fveq1d oveq12d syl5ibrcom addcl
      wb eqeq2d adantl w3a addass simplr simpll zcnd ax-1cn npcan eqcomd fveq2d
      sylancl syl5eq eleqtrd eluzp1m1 syl2an seqsplit fsumser seqeq1d eqtr4d ex
      sylan wo uzp1 mpjaod climaddc2 isumclim ) ABEFUDUEOZUFOZBCUGZGBCUGZPOCDEH
      IAFEUHQZRZEUKRZAFHYJKIUIZEFUJULZLMAYIYHUAPDFUMZPDEUMZFUNUOZGJAYKFUKRYMEFU
      PULZABCDFGJYRACVDZGRZYSHRZYSDQZBSZAGHYSAFUHQZYJGHAYKUUDYJUQYMEFURULJIUSZU
      TZLVAAYTUUABTRZUUFMVAAYPYQRYOYQRNACDEFHIKAUUAVEUUBBTLMVBZVCVFVGAYGBCAEYFV
      HYSYGRZAUUAUUGUUIYSYJHYSEYFVIIVJZMVKVLNAGTUAVDZYOACDFGJYRAYTUUAUUBTRZUUFU
      UHVAVMVNAUUKGRZVEZFESZUUKYPQZYHUUKYOQZPOZSZFEUDPOUHQRZUUNUUSUUOUUPEEUDUEO
      ZUFOZBCUGZUUPPOZSUUNUVDVOUUPPOUUPUUNUVCVOUUPPUUNUVCVPBCUGZVOAUVCUVESUUMAU
      VBVPBCAUVAEVQVRZUVBVPSZAEAEYNVSVTAYLUVAUKRZUVFUVGWRYNAYLUVHYNEWAULEUVAWBW
      CVFWDWEBCWFWGWHUUNUUPAUUMUUKHRUUPTRAGHUUKUUEUTAHTUUKYPACDEHIYNUUHVMVNVAWI
      WJUUOUURUVDUUPUUOYHUVCUUQUUPPUUOYGUVBBCUUOYFUVAEUFFEUDUEWKWLWDUUOUUKYOYPP
      DFEWMWNWOWSWPUUNUUTUUSUUNUUTVEZUUPYFYPQZUUKPDYFUDPOZUMZQZPOUURUVICUBUCPTD
      EYFUUKYSTRZUBVDZTRZVEYSUVOPOZTRUVIYSUVOWQWTUVNUVPUCVDZTRXAUVQUVRPOYSUVOUV
      RPOPOSUVIYSUVOUVRXBWTUVIUUKGUVKUHQZAUUMUUTXCUVIGUUDUVSJUVIFUVKUHUVIAFUVKS
      AUUMUUTXDZAUVKFAFTRUDTRUVKFSAFYRXEXFFUDXGXJXHULZXIXKXLUUNYLUUTYFYJRAYLUUM
      YNWEEFXMXTZUVIAUUAUULYSEUUKUFORZUVTUWCYSYJHYSEUUKVIIVJUUHXNXOUVIYHUVJUUQU
      VMPUVIBCDEYFUVIAUUAUUCUUIUVTUUJLXNUWBUVIAUUAUUGUUIUVTUUJMXNXPUVIUUKYOUVLU
      VIFUVKPDUWAXQWNWOXRXSAUUOUUTYAZUUMAYKUWDYMEFYBULWEYCYDYE $.
  $}

  ${
    $d k F $.  $d k M $.  $d k ph $.  $d k Z $.
    isum1p.1 $e |- Z = ( ZZ>= ` M ) $.
    isum1p.3 $e |- ( ph -> M e. ZZ ) $.
    isum1p.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isum1p.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    isum1p.6 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( The infinite sum of a converging infinite series equals the first term
       plus the infinite sum of the rest of it.  (Contributed by NM,
       2-Jan-2006.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    isum1p $p |- ( ph -> sum_ k e. Z A =
                   ( ( F ` M ) + sum_ k e. ( ZZ>= ` ( M + 1 ) ) A ) ) $=
      ( csu c1 caddc co cfz cfv wcel cc wceq cmin cuz eqid cz uzid syl peano2uz
      syl6eleqr isumsplit cv zcnd ax-1cn sylancl oveq2d sumeq1d elfzuz sumeq2dv
      pncan sylan2 wral eqeltrd ralrimiva fveq2 eleq1d rspcv sylc fsum1 syl2anc
      wa 3eqtr2d oveq1d eqtrd ) AFBCLEEMNOZMUAOZPOZBCLZVMUBQZBCLZNOEDQZVRNOABCD
      EVMVQFGVQUCAVMEUBQZFAEVTRZVMVTRAEUDRZWAHEUEUFZEEUGUFGUHIJKUIAVPVSVRNAVPEE
      POZBCLWDCUJZDQZCLZVSAVOWDBCAVNEEPAESRMSRVNETAEHUKULEMURUMUNUOAWDWFBCWEWDR
      ZAWEFRZWFBTWHWEVTFWEEEUPGUHIUSUQAWBVSSRZWGVSTHAEFRWFSRZCFUTWJAEVTFWCGUHAW
      KCFAWIVIWFBSIJVAVBWKWJCEFWEETWFVSSWEEDVCZVDVEVFWFVSCEWLVGVHVJVKVL $.
  $}

  ${
    $d k F $.  $d k B $.  $d k ph $.
    isumnn0nn.1 $e |- ( k = 0 -> A = B ) $.
    isumnn0nn.2 $e |- ( ( ph /\ k e. NN0 ) -> ( F ` k ) = A ) $.
    isumnn0nn.3 $e |- ( ( ph /\ k e. NN0 ) -> A e. CC ) $.
    isumnn0nn.4 $e |- ( ph -> seq 0 ( + , F ) e. dom ~~> ) $.
    $( Sum from 0 to infinity in terms of sum from 1 to infinity.  (Contributed
       by NM, 2-Jan-2006.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    isumnn0nn $p |- ( ph -> sum_ k e. NN0 A = ( B + sum_ k e. NN A ) ) $=
      ( cn0 csu cc0 cfv c1 caddc co cuz cn wcel wceq nn0uz cz 0z isum1p cv wral
      0nn0 ralrimiva fveq2 eqeq12d rspcv mpsyl 0p1e1 fveq2i nnuz eqtr4i sumeq1i
      a1i oveq12d eqtrd ) AJBDKLEMZLNOPZQMZBDKZOPCRBDKZOPABDELJUALUBSAUCURGHIUD
      AVACVDVEOLJSADUEZEMZBTZDJUFVACTZUGAVHDJGUHVHVIDLJVFLTVGVABCVFLEUIFUJUKULV
      DVETAVCRBDVCNQMRVBNQUMUNUOUPUQURUSUT $.
  $}

  ${
    $d m A $.  $d k m F $.  $d k M $.  $d k m N $.  $d k m ph $.  $d k m W $.
    $d k Z $.
    isumrpcl.1 $e |- Z = ( ZZ>= ` M ) $.
    isumrpcl.2 $e |- W = ( ZZ>= ` N ) $.
    isumrpcl.3 $e |- ( ph -> N e. Z ) $.
    isumrpcl.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumrpcl.5 $e |- ( ( ph /\ k e. Z ) -> A e. RR+ ) $.
    isumrpcl.6 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( The infinite sum of positive reals is positive.  (Contributed by Paul
       Chapman, 9-Feb-2008.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    isumrpcl $p |- ( ph -> sum_ k e. W A e. RR+ ) $=
      ( cfv wcel syl wceq wa crp vm csu cuz cz syl6eleq eluzelz cv uzss 3sstr4g
      wss sselda syldan cr rpred caddc cseq cli cdm rpcnd iserex mpbid isumrecl
      eqeltrd wral ralrimiva fveq2 rspcv sylc cle seq1 uzid syl6eleqr isumclim2
      eleq1d recnd sseld syl5com syld imp rpge0d climserle eqbrtrrd rpgecld ) A
      GBCUBZFDOZABCDFGJAFEUCOZPZFUDPZAFHWFKIUEZEFUFQZACUGZGPZWKHPZWKDOZBRAGHWKA
      FUCOZWFGHAWGWOWFUJWIEFUHQJIUIZUKZLULZAWLWMBUMPWQAWMSZBMUNULZAUODEUPUQURZP
      UODFUPZXAPNACDEFHIKWSWNWSWNBTLMVCZUSUTVAZVBAFHPWNTPZCHVDZWETPZKAXECHXCVEZ
      XEXGCFHWKFRWNWETWKFDVFVNVGVHAFXBOZWEWDVIAWHXIWERWJUODFVJQAWDUADFFGJAFWOGA
      WHFWOPWJFVKQJVLABCDFGJWJWRAWLSBWTVOXDVMAUAUGZGPZSZXJDOZAXKXMTPZAXKXJHPZXN
      AGHXJWPVPAXFXOXNXHXEXNCXJHWKXJRWNXMTWKXJDVFVNVGVQVRVSZUNXLXMXPVTWAWBWC $.
  $}

  ${
    $d k F $.  $d k G $.  $d k M $.  $d k ph $.  $d k Z $.
    isumle.1 $e |- Z = ( ZZ>= ` M ) $.
    isumle.2 $e |- ( ph -> M e. ZZ ) $.
    isumle.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumle.4 $e |- ( ( ph /\ k e. Z ) -> A e. RR ) $.
    isumle.5 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = B ) $.
    isumle.6 $e |- ( ( ph /\ k e. Z ) -> B e. RR ) $.
    isumle.7 $e |- ( ( ph /\ k e. Z ) -> A <_ B ) $.
    isumle.8 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    isumle.9 $e |- ( ph -> seq M ( + , G ) e. dom ~~> ) $.
    $( Comparison of two infinite sums.  (Contributed by Paul Chapman,
       13-Nov-2007.)  (Revised by Mario Carneiro, 24-Apr-2014.) $)
    isumle $p |- ( ph -> sum_ k e. Z A <_ sum_ k e. Z B ) $=
      ( cli cfv wcel caddc cseq csu cle cdm wbr climdm sylib cv eqeltrd 3brtr4d
      wa cr iserle recnd isum ) AUAEGUBZRSZUAFGUBZRSZHBDUCHCDUCUDAURUTDEFGHIJAU
      QRUEZTUQURRUFPUQUGUHAUSVATUSUTRUFQUSUGUHADUIZHTULZVBESZBUMKLUJVCVBFSZCUMM
      NUJVCBCVDVEUDOKMUKUNABDEGHIJKVCBLUOUPACDFGHIJMVCCNUOUPUK $.
  $}

  ${
    $d j k A $.  $d j k F $.  $d k M $.  $d k ph $.  $d j k Z $.
    isumless.1 $e |- Z = ( ZZ>= ` M ) $.
    isumless.2 $e |- ( ph -> M e. ZZ ) $.
    isumless.3 $e |- ( ph -> A e. Fin ) $.
    isumless.4 $e |- ( ph -> A C_ Z ) $.
    isumless.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    isumless.6 $e |- ( ( ph /\ k e. Z ) -> B e. RR ) $.
    isumless.7 $e |- ( ( ph /\ k e. Z ) -> 0 <_ B ) $.
    isumless.8 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( A finite sum of nonnegative numbers is less or equal to its limit.
       (Contributed by Mario Carneiro, 24-Apr-2014.) $)
    isumless $p |- ( ph -> sum_ k e. A B <_ sum_ k e. Z B ) $=
      ( wcel cc0 cle cfv cr vj csu cv cif wss cc wral cuz cfn wo wceq sselda wa
      recnd syldan ralrimiva eqimssi orci a1i sumss2 syl21anc eleq1 fveq2 eqidd
      cmpt ifbieq12d eqid fvex c0ex ifex fvmpt adantl ifeq1d eqtrd ifcl sylancl
      0re wbr leid breq1 ifboth sylan syl2anc fsumcvg3 isumle eqbrtrd ) ABCDUBZ
      GDUCZBPZCQUDZDUBZGCDUBRABGUECUFPZDBUGGFUHSZUEZGUIPZUJZWGWKUKKAWLDBAWIWHGP
      ZWLABGWHKULAWQUMZCMUNUOZUPWPAWNWOGWMHUQURUSBGCDFUTVAAWJCDUAGUAUCZBPZWTESZ
      QUDZVEZEFGHIWRWHXDSZWIWHESZQUDZWJWQXEXGUKAUAWHXCXGGXDWTWHUKZXAWIXBQXFQWTW
      HBVBWTWHEVCXHQVDVFXDVGWIXFQWHEVHVIVJVKVLWRWIXFCQLVMVNZWRCTPZQTPWJTPMVQWIC
      QTVOVPLMWRXJQCRVRZWJCRVRZMNXJCCRVRZXKXLCVSWIXMXKXLCQCWJCRVTQWJCRVTWAWBWCA
      BCDXDFGHIJKXIWSWDOWEWF $.
  $}

  ${
    $d j x A $.  $d j k x F $.  $d j k x M $.  $d j k ph $.  $d j k x Z $.
    $d j x G $.
    isumsup.1 $e |- Z = ( ZZ>= ` M ) $.
    isumsup.2 $e |- G = seq M ( + , F ) $.
    isumsup.3 $e |- ( ph -> M e. ZZ ) $.
    isumsup.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumsup.5 $e |- ( ( ph /\ k e. Z ) -> A e. RR ) $.
    isumsup.6 $e |- ( ( ph /\ k e. Z ) -> 0 <_ A ) $.
    isumsup.7 $e |- ( ph -> E. x e. RR A. j e. Z ( G ` j ) <_ x ) $.
    $( An infinite sum of nonnegative terms is equal to the supremum of the
       partial sums.  (Contributed by Mario Carneiro, 12-Jun-2014.) $)
    isumsup2 $p |- ( ph -> G ~~> sup ( ran G , RR , < ) ) $=
      ( cr wcel cfv co caddc cseq wf cv wa eqeltrd serfre feq1i sylibr c1 simpr
      cle cuz syl6eleq cz eluzelz uzid peano2uz 4syl cfz simpl elfzuz syl6eleqr
      syl2an cc0 peano2uzs adantl uztrn2 breqtrrd adantlr syldan sermono fveq1i
      wbr 3brtr4g climsup ) ABDGHIJLAIQUAFHUBZUCIQGUCAEFHIJLAEUDZIRZUEZVRFSZCQM
      NUFZUGIQGVQKUHUIADUDZIRZUEZWCVQSWCUJUATZVQSWCGSWFGSULWEEFWCHWFWEWCIHUMSZA
      WDUKJUNZWEWCWGRWCUORWCWCUMSZRWFWIRWHHWCUPWCUQWCWCURUSWEAVSWAQRVRHWFUTTRZA
      WDVAWJVRWGIVRHWFVBJVCWBVDWEVRWFWFUTTRZVSVEWAULVNZWEWFIRZVRWFUMSRVSWKWDWMA
      HWCIJVFVGVRWFWFVBHVRWFIJVHVDAVSWLWDVTVECWAULOMVIVJVKVLWCGVQKVMWFGVQKVMVOP
      VP $.

    $( An infinite sum of nonnegative terms is equal to the supremum of the
       partial sums.  (Contributed by Mario Carneiro, 12-Jun-2014.) $)
    isumsup $p |- ( ph -> sum_ k e. Z A = sup ( ran G , RR , < ) ) $=
      ( crn cr clt csup cv wcel wa recnd caddc cseq isumsup2 syl5eqbrr isumclim
      cli ) ACGQRSTZEFHIJLMAEUAIUBUCCNUDAUEFHUFGUKUJKABCDEFGHIJKLMNOPUGUHUI $.
  $}

  ${
    $d k x A $.  $d x B $.  $d k F $.  $d k x M $.  $d k x ph $.  $d k x Z $.
    isumltss.1 $e |- Z = ( ZZ>= ` M ) $.
    isumltss.2 $e |- ( ph -> M e. ZZ ) $.
    isumltss.3 $e |- ( ph -> A e. Fin ) $.
    isumltss.4 $e |- ( ph -> A C_ Z ) $.
    isumltss.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    isumltss.6 $e |- ( ( ph /\ k e. Z ) -> B e. RR+ ) $.
    isumltss.7 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( A partial sum of a series with positive terms is less than the infinite
       sum.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by
       Mario Carneiro, 12-Mar-2015.) $)
    isumltss $p |- ( ph -> sum_ k e. A B < sum_ k e. Z B ) $=
      ( vx wcel csu wceq cfn wss cv cdif clt wbr c0 wn wex cz uzinf ssdif0 eqss
      syl wa eleq1 syl5ibcom syl5bir mpand mtod neq0 sylib csn adantr cr sselda
      cun crp adantlr rpred syldan fsumrecl snfi unfi sylancl eldifi snssd unss
      anim12i cfv caddc cseq cli cdm isumrecl co a1i wne snnz fsumrpcl ltaddrpd
      vex adantl cin eldifn disjsn sylibr eqidd rpcnd fsumsplit breqtrrd rpge0d
      cc isumless ltletrd exlimddv ) AOUAZGBUBZPZBCDQZGCDQZUCUDOAXFUERZUFXGOUGA
      XJGSPZAFUHPZXKUFIFGHUIULXJGBTZAXKGBUJABGTZXMXKKXNXMUMBGRZAXKBGUKABSPZXOXK
      JBGSUNUOUPUQUPUROXFUSUTAXGUMZXHBXEVAZVEZCDQZXIXQBCDAXPXGJVBZXQDUAZBPYBGPZ
      CVCPZXQBGYBAXNXGKVBVDXQYCUMZCAYCCVFPZXGMVGZVHZVIVJZXQXSCDXQXPXRSPZXSSPYAX
      EVKZBXRVLVMZXQYBXSPZYCYDXQXSGYBXQXNXRGTZUMXSGTAXNXGYNKXGXEGXEGBVNVOZVQBXR
      GVPUTZVDZYHVIVJXQCDEFGHAXLXGIVBZAYCYBEVRCRXGLVGZYHAVSEFVTWAWBPXGNVBZWCXQX
      HXHXRCDQZVSWDXTUCXQXHUUAYIXQXRCDYJXQYKWEXRUEWFXQXEOWJWGWEXQYBXRPYCYFXQXRG
      YBXGYNAYOWKVDYGVIWHWIXQBXRCXSDXQXEBPUFZBXRWLUERXGUUBAXEGBWMWKBXEWNWOXQXSW
      PYLXQYMYCCXAPYQYECYGWQVIWRWSXQXSCDEFGHYRYLYPYSYHYECYGWTYTXBXCXD $.
  $}

  ${
    $d j k n x F $.  $d j k n x G $.  $d x N $.  $d j k n x ph $.
    climcnds.1 $e |- ( ( ph /\ k e. NN ) -> ( F ` k ) e. RR ) $.
    climcnds.2 $e |- ( ( ph /\ k e. NN ) -> 0 <_ ( F ` k ) ) $.
    climcnds.3 $e |- ( ( ph /\ k e. NN ) -> ( F ` ( k + 1 ) ) <_ ( F ` k ) ) $.
    climcnds.4 $e |- ( ( ph /\ n e. NN0 ) ->
      ( G ` n ) = ( ( 2 ^ n ) x. ( F ` ( 2 ^ n ) ) ) ) $.
    $( Lemma for ~ climcnds : bound the original series by the condensed
       series.  (Contributed by Mario Carneiro, 18-Jul-2014.) $)
    climcndslem1 $p |- ( ( ph /\ N e. NN0 ) ->
                        ( seq 1 ( + , F ) ` ( ( 2 ^ ( N + 1 ) ) - 1 ) ) <_
                        ( seq 0 ( + , G ) ` N ) ) $=
      ( cn0 wcel c2 c1 caddc co cfv cc0 cle wceq vx vj cexp cmin cseq wbr cv wi
      oveq1 0p1e1 syl6eq oveq2d cc 2cn exp1 ax-mp df-2 eqtri oveq1d pncan mp2an
      ax-1cn fveq2d fveq2 breq12d imbi2d cmul cn cr wral ralrimiva eleq1d rspcv
      mpsyl leidd recnd mulid2d breqtrrd 1z eqidd seq1i 0nn0 oveq2 exp0 oveq12d
      1nn 0z eqeq12d 3brtr4d wa cfz csu fzfid simpl adantr cuz peano2nn0 adantl
      2nn nnexpcl sylancr elfzuz nnuz uztrn2 syl2an syl2anc sylc simpr monoord2
      simplll breq1d chash cfn hashcl syl nn0cnd nnred cun cz 2z zexpcl 2re 1re
      syl6eleq leexp2a mp3an12 sylanbrc peano2zm zred a1i eqtrd hashfz1 3eqtr4d
      nnnn0d elfznn fsumrecl nn0uz remulcld eqeltrd fsumser rspccva fsumle 1lt2
      nn0p1nn ltleii syl5eqbrr eluz1i uz2m1nn nn0zd uzid peano2uz 4syl lesub1dd
      eluz2 syl3anbrc elfzuzb fzsplit npcan sylancl expp1 times2d addsubd uztrn
      uneq2d syl6eleqr cin c0 clt ltm1d fzdisj hashun syl3anc 3eqtr3d fsumconst
      addcanad serfre ffvelrnda le2add syl22anc mpan2d eqcomd fsumsplit 3imtr4d
      eqtr3d seqp1 expcom a2d nn0ind impcom ) FKLAMFNOPZUCPZNUDPZODNUEZQZFOERUE
      ZQZSUFZAMUAUGZNOPZUCPZNUDPZUWMQZUWRUWOQZSUFZUHANUWMQZRUWOQZSUFZUHAMUBUGZN
      OPZUCPZNUDPZUWMQZUXHUWOQZSUFZUHAMUXINOPZUCPZNUDPZUWMQZUXIUWOQZSUFZUHAUWQU
      HUAUBFUWRRTZUXDUXGAUYAUXBUXEUXCUXFSUYAUXANUWMUYAUXANNOPZNUDPZNUYAUWTUYBNU
      DUYAUWTMNUCPZUYBUYAUWSNMUCUYAUWSRNOPNUWRRNOUIUJUKULUYDMUYBMUMLZUYDMTUNMUO
      UPZUQURUKUSNUMLZUYGUYCNTVBVBNNUTVAUKVCUWRRUWOVDVEVFUWRUXHTZUXDUXNAUYHUXBU
      XLUXCUXMSUYHUXAUXKUWMUYHUWTUXJNUDUYHUWSUXIMUCUWRUXHNOUIULUSVCUWRUXHUWOVDV
      EVFUWRUXITZUXDUXTAUYIUXBUXRUXCUXSSUYIUXAUXQUWMUYIUWTUXPNUDUYIUWSUXOMUCUWR
      UXINOUIULUSVCUWRUXIUWOVDVEVFUWRFTZUXDUWQAUYJUXBUWNUXCUWPSUYJUXAUWLUWMUYJU
      WTUWKNUDUYJUWSUWJMUCUWRFNOUIULUSVCUWRFUWOVDVEVFANDQZNUYKVGPZUXEUXFSAUYKUY
      KUYLSAUYKNVHLABUGZDQZVILZBVHVJZUYKVILZWFAUYOBVHGVKZUYOUYQBNVHUYMNTUYNUYKV
      IUYMNDVDVLVMVNZVOAUYKAUYKUYSVPVQVRAUYKODNVSAUYKVTWAAUYLOERWGRKLACUGZEQZMU
      YTUCPZVUBDQZVGPZTZCKVJZREQZUYLTZWBAVUECKJVKZVUEVUHCRKUYTRTZVUAVUGVUDUYLUY
      TREVDVUJVUBNVUCUYKVGVUJVUBMRUCPZNUYTRMUCWCUYEVUKNTUNMWDUPUKZVUJVUBNDVULVC
      WEWHVMVNWAWIUXHKLZAUXNUXTAVUMUXNUXTUHAVUMWJZNUXKWKPZUYNBWLZUXMSUFZVUPUXJU
      XQWKPZUYNBWLZOPZUXMUXIEQZOPZSUFZUXNUXTVUNVUQVUSVVASUFZVVCVUNVUSVURUXJDQZB
      WLZVVASVUNVURUYNVVEBVUNUXJUXQWMZVUNUYMVURLZWJAUYMVHLZUYOVUNAVVHAVUMWNZWOV
      UNUXJVHLZUYMUXJWPQZLZVVIVVHVUNMVHLZUXIKLZVVKWSVUMVVOAUXHWQWRZMUXIWTXAZUYM
      UXJUXQXBZNUYMUXJVHXCXDZXEGXFZVUNVVEVILZVVHVUNVVKUYPVWAVVQAUYPVUMUYRWOUYOV
      WABUXJVHUYMUXJTUYNVVEVIUYMUXJDVDVLVMXGZWOVUNUYTDQZVVESUFZCVVLVJVVMUYNVVES
      UFZVVHVUNVWDCVVLVUNUYTVVLLZWJZBDUXJUYTVUNVWFXHVWGUYMUXJUYTWKPLZWJAVVIUYOA
      VUMVWFVWHXJVWGVVKVVMVVIVWHVUNVVKVWFVVQWOZUYMUXJUYTXBVVSXEGXFVWGUYMUXJUYTN
      UDPZWKPLZWJAVVIUYMNOPDQUYNSUFAVUMVWFVWKXJVWGVVKVVMVVIVWKVWIUYMUXJVWJXBVVS
      XEIXFXIVKVVRVWDVWECUYMVVLUYTUYMTVWCUYNVVESUYTUYMDVDXKUUAXEUUBVUNUXJVVEVGP
      ZVURXLQZVVEVGPZVVAVVFVUNUXJVWMVVEVGVUNVUOXLQZUXJVWMVUNVWOVUNVUOXMLZVWOKLV
      UNNUXKWMZVUOXNXOXPVUNUXJVUNUXJVVQXQZVPZVUNVWMVUNVURXMLZVWMKLVVGVURXNXOXPV
      UNNUXQWKPZXLQZVUOVURXRZXLQZVWOUXJOPZVWOVWMOPZVUNVXAVXCXLVUNVXAVUOUXKNOPZU
      XQWKPZXRZVXCVUNUXKVXALZVXAVXITVUNUXKNWPQZLZUXQUXKWPQLZVXJVUNUXKVHVXKVUNUX
      JMWPQLZUXKVHLVUNUXJXSLZMUXJSUFVXNVUNMXSLZVVOVXOXTVVPMUXIYAXAZVUNMUYDUXJSU
      YFVUNUXIVXKLZUYDUXJSUFZVUNUXIVHVXKVUMUXIVHLAUXHUUDWRXCYDMVILZNMSUFZVXRVXS
      YBNMYCYBUUCUUEZMNUXIYEYFXOUUFMUXJXTUUGYGUXJUUHXOZXCYDZVUNUXKXSLZUXQXSLZUX
      KUXQSUFVXMVUNVXOVYEVXQUXJYHXOVUNUXPXSLZVYFVUNVXPUXOKLZVYGXTVUNVVOVYHVVPUX
      IWQXOMUXOYAXAZUXPYHXOVUNUXJUXPNVUNUXJVXQYIZVUNUXPVYIYINVILVUNYCYJVUNUXIXS
      LUXIUXIWPQZLUXOVYKLZUXJUXPSUFZVUNUXIVVPUUIUXIUUJUXIUXIUUKVXTVYAVYLVYMYBVY
      BMUXIUXOYEYFUULUUMUXKUXQUUNUUOZUXKNUXQUUPYGUXKNUXQUUQXOVUNVXHVURVUOVUNVXG
      UXJUXQWKVUNUXJUMLUYGVXGUXJTVWSVBUXJNUURUUSUSUVDYKZVCVUNUXQUXKUXJOPZVXBVXE
      VUNUXQUXJUXJOPZNUDPVYPVUNUXPVYQNUDVUNUXPUXJMVGPZVYQVUNUYEVVOUXPVYRTUNVVPM
      UXIUUTXAVUNUXJVWSUVAYKUSVUNUXJUXJNVWSVWSUYGVUNVBYJUVBYKVUNUXQKLVXBUXQTVUN
      UXQVUNUXQVXKVHVUNVXMVXLUXQVXKLVYNVYDUXKUXQNUVCXFZXCUVEYNUXQYLXOVUNVWOUXKU
      XJOVUNUXKKLVWOUXKTVUNUXKVYCYNUXKYLXOUSYMVUNVWPVWTVUOVURUVFUVGTZVXDVXFTVWQ
      VVGVUNUXKUXJUVHUFVYTVUNUXJVWRUVINUXKUXJUXQUVJXOZVUOVURUVKUVLUVMUVOUSVUNVV
      OVUFVVAVWLTZVVPAVUFVUMVUIWOVUEWUBCUXIKUYTUXITZVUAVVAVUDVWLUYTUXIEVDWUCVUB
      UXJVUCVVEVGUYTUXIMUCWCZWUCVUBUXJDWUDVCWEWHVMXGZVUNVWTVVEUMLVVFVWNTVVGVUNV
      VEVWBVPVURVVEBUVNXFYMVRVUNVUPVILVUSVILUXMVILVVAVILVUQVVDWJVVCUHVUNVUOUYNB
      VWQVUNAVVIUYOUYMVUOLZVVJUYMUXKYOZGXEYPVUNVURUYNBVVGVVTYPAKVIUXHUWOACERKYQ
      RXSLAWGYJAUYTKLZWJZVUAVUDVIJWUIVUBVUCWUIVUBWUIVVNWUHVUBVHLZWSAWUHXHMUYTWT
      XAZXQWUIWUJUYPVUCVILZWUKAUYPWUHUYRWOUYOWULBVUBVHUYMVUBTUYNVUCVIUYMVUBDVDV
      LVMXGYRYSUVPUVQVUNVVAVWLVIWUEVUNUXJVVEVYJVWBYRYSVUPVUSUXMVVAUVRUVSUVTVUNU
      XLVUPUXMSVUNVUPUXLVUNUYNBDNUXKVUNWUFWJUYNVTVYDVUNAVVIUYNUMLZWUFVVJWUGAVVI
      WJUYNGVPZXEYTUWAXKVUNUXRVUTUXSVVBSVUNVXAUYNBWLUXRVUTVUNUYNBDNUXQVUNUYMVXA
      LZWJUYNVTVYSVUNAVVIWUMWUOVVJUYMUXQYOWUNXEZYTVUNVUOVURUYNVXABWUAVYOVUNNUXQ
      WMWUPUWBUWDVUNUXHRWPQZLUXSVVBTVUNUXHKWUQAVUMXHYQYDOERUXHUWEXOVEUWCUWFUWGU
      WHUWI $.

    $( Lemma for ~ climcnds : bound the condensed series by the original
       series.  (Contributed by Mario Carneiro, 18-Jul-2014.) $)
    climcndslem2 $p |- ( ( ph /\ N e. NN ) -> ( seq 1 ( + , G ) ` N ) <_
      ( 2 x. ( seq 1 ( + , F ) ` ( 2 ^ N ) ) ) ) $=
      ( cn wcel c1 cfv c2 co cmul cle wceq cr vx vj caddc cseq cexp cv wi fveq2
      wbr oveq2 2cn exp1 ax-mp syl6eq fveq2d oveq2d breq12d imbi2d cc0 wral 1nn
      cc ralrimiva breq2d rspcv mpsyl 2nn eleq1d addge02d mpbid clt wa readdcld
      wb 2re 2pos pm3.2i a1i lemul2 syl3anc cn0 1nn0 oveq12d eqeq12d seq1i nnuz
      1z df-2 eqidd seqp1i 3brtr4d cfz peano2nn adantl nnnn0d adantr sylc nnnn0
      csu expp1 sylancr nnexpcl nncnd mulcom sylancl eqtrd oveq1d recnd mulassd
      3eqtrd chash hashfz1 syl eqeltrd cfn fzfid hashcl nn0cnd cun cz cuz simpr
      nnzd uzid peano2uz 1re syl2anc nnred 3eqtr3d elfzuz uztrn2 syl2an simplll
      syl6eleq eqbrtrd remulcld serfre remulcl elfznn fsumser 1lt2 leexp2a 4syl
      ltleii mp3an12 elfz5 mpbird fzsplit times2d 3eqtr4d cin c0 ltp1d addcanad
      fzdisj hashun fsumconst eqtr4d simpl elfzuz3 cmin monoord2 rspccva fsumle
      sylan fsumrecl sylan2 ffvelrnda wf le2add syl22anc mpan2d seqp1 fsumsplit
      ffvelrn adddid sylibrd expcom a2d nnind impcom ) FKLAFUCEMUDZNZOOFUEPZUCD
      MUDZNZQPZRUIZAUAUFZUWBNZOOUWIUEPZUWENZQPZRUIZUGAMUWBNZOOUWENZQPZRUIZUGAUB
      UFZUWBNZOOUWSUEPZUWENZQPZRUIZUGAUWSMUCPZUWBNZOOUXEUEPZUWENZQPZRUIZUGAUWHU
      GUAUBFUWIMSZUWNUWRAUXKUWJUWOUWMUWQRUWIMUWBUHUXKUWLUWPOQUXKUWKOUWEUXKUWKOM
      UEPZOUWIMOUEUJOVBLZUXLOSUKOULUMZUNUOUPUQURUWIUWSSZUWNUXDAUXOUWJUWTUWMUXCR
      UWIUWSUWBUHUXOUWLUXBOQUXOUWKUXAUWEUWIUWSOUEUJUOUPUQURUWIUXESZUWNUXJAUXPUW
      JUXFUWMUXIRUWIUXEUWBUHUXPUWLUXHOQUXPUWKUXGUWEUWIUXEOUEUJUOUPUQURUWIFSZUWN
      UWHAUXQUWJUWCUWMUWGRUWIFUWBUHUXQUWLUWFOQUXQUWKUWDUWEUWIFOUEUJUOUPUQURAOOD
      NZQPZOMDNZUXRUCPZQPZUWOUWQRAUXRUYARUIZUXSUYBRUIZAUSUXTRUIZUYCMKLZAUSBUFZD
      NZRUIZBKUTUYEVAAUYIBKHVCUYIUYEBMKUYGMSZUYHUXTUSRUYGMDUHZVDVEVFAUXRUXTOKLZ
      AUYHTLZBKUTZUXRTLZVGAUYMBKGVCZUYMUYOBOKUYGOSUYHUXRTUYGODUHVHVEVFZUYFAUYNU
      XTTLZVAUYPUYMUYRBMKUYJUYHUXTTUYKVHVEVFZVIVJAUYOUYATLOTLZUSOVKUIZVLZUYCUYD
      VNUYQAUXTUXRUYSUYQVMVUBAUYTVUAVOVPVQZVRUXRUYAOVSVTVJAUXSUCEMWGMWALACUFZEN
      ZOVUDUEPZVUFDNZQPZSZCWAUTZMENZUXSSZWBAVUICWAJVCZVUIVULCMWAVUDMSZVUEVUKVUH
      UXSVUDMEUHVUNVUFOVUGUXRQVUNVUFUXLOVUDMOUEUJUXNUNZVUNVUFODVUOUOWCWDVEVFWEA
      UWPUYAOQAUXTUXRUCDOMMKWFVAWHAUXTUCDMWGAUXTWIWEAUXRWIWJUPWKUWSKLZAUXDUXJAV
      UPUXDUXJUGAVUPVLZUXDUWTUXEENZUCPZUXCOUXAMUCPZUXGWLPZUYHBWSZQPZUCPZRUIZUXJ
      VUQUXDVURVVCRUIZVVEVUQVUROUXAUXGDNZQPZQPZVVCRVUQVURUXGVVGQPZOUXAQPZVVGQPV
      VIVUQUXEWALZVUJVURVVJSZVUQUXEVUPUXEKLZAUWSWMWNZWOZAVUJVUPVUMWPVUIVVMCUXEW
      AVUDUXESZVUEVURVUHVVJVUDUXEEUHZVVQVUFUXGVUGVVGQVUDUXEOUEUJZVVQVUFUXGDVVSU
      OWCWDVEWQVUQUXGVVKVVGQVUQUXGUXAOQPZVVKVUQUXMUWSWALZUXGVVTSUKVUPVWAAUWSWRZ
      WNOUWSWTXAZVUQUXAVBLUXMVVTVVKSVUQUXAVUPUXAKLZAVUPUYLVWAVWDVGVWBOUWSXBXAZW
      NZXCZUKUXAOXDXEXFXGVUQOUXAVVGUXMVUQUKVRZVWGVUQVVGVUQUXGKLZUYNVVGTLZVUQUYL
      VVLVWIVGVVPOUXEXBXAZAUYNVUPUYPWPUYMVWJBUXGKUYGUXGSUYHVVGTUYGUXGDUHVHVEWQZ
      XHZXIXJVUQVVHVVBRUIZVVIVVCRUIZVUQVVHVVAVVGBWSZVVBRVUQVVHVVAXKNZVVGQPZVWPV
      UQUXAVWQVVGQVUQMUXAWLPZXKNZUXAVWQVUQVWTUXAVBVUQUXAWALVWTUXASVUQUXAVWFWOUX
      AXLXMZVWGXNVWGVUQVWQVUQVVAXOLZVWQWALVUQVUTUXGXPZVVAXQXMXRVUQMUXGWLPZXKNZV
      WSVVAXSZXKNZVWTUXAUCPZVWTVWQUCPZVUQVXDVXFXKVUQUXAVXDLZVXDVXFSVUQVXJUXAUXG
      RUIZVUQUWSXTLUWSUWSYANZLUXEVXLLZVXKVUQUWSAVUPYBZYCUWSYDUWSUWSYEUYTMORUIVX
      MVXKVOMOYFVOUUAUUDOUWSUXEUUBUUEUUCVUQUXAMYANZLUXGXTLVXJVXKVNVUQUXAKVXOVWF
      WFYNZVUQUXGVWKYCUXAMUXGUUFYGUUGUXAMUXGUUHXMZUOVUQUXGUXAUXAUCPZVXEVXHVUQUX
      GVVTVXRVWCVUQUXAVWGUUIXFVUQUXGWALVXEUXGSVUQUXGVWKWOUXGXLXMVUQVWTUXAUXAUCV
      XAXGUUJVUQVWSXOLVXBVWSVVAUUKUULSZVXGVXISVUQMUXAXPVXCVUQUXAVUTVKUIVXSVUQUX
      AVUQUXAVWFYHZUUMMUXAVUTUXGUUOXMZVWSVVAUUPVTYIUUNXGVUQVXBVVGVBLVWPVWRSVXCV
      WMVVAVVGBUUQYGUURVUQVVAVVGUYHBVXCVUQVWJUYGVVALZVWLWPVUQVYBVLAUYGKLZUYMVUQ
      AVYBAVUPUUSZWPVUQVUTKLZUYGVUTYANZLVYCVYBVUQVWDVYEVWFUXAWMXMZUYGVUTUXGYJMU
      YGVUTKWFYKYLGYGZVUQVVGVUDDNZRUIZCVVAUTVYBVVGUYHRUIZVUQVYJCVVAVUQVUDVVALZV
      LZBDVUDUXGVYLUXGVUDYANZLVUQVUDVUTUXGUUTWNVYMUYGVUDUXGWLPLZVLAVYCUYMAVUPVY
      LVYOYMVYMVUDKLZUYGVYNLZVYCVYOVUQVYEVUDVYFLVYPVYLVYGVUDVUTUXGYJMVUDVUTKWFY
      KYLZUYGVUDUXGYJMUYGVUDKWFYKZYLGYGVYMUYGVUDUXGMUVAPZWLPLZVLAVYCUYGMUCPDNUY
      HRUIAVUPVYLWUAYMVYMVYPVYQVYCWUAVYRUYGVUDVYTYJVYSYLIYGUVBVCVYJVYKCUYGVVAVU
      DUYGSVYIUYHVVGRVUDUYGDUHVDUVCUVEUVDYOVUQVVHTLVVBTLZVUBVWNVWOVNVUQUXAVVGVX
      TVWLYPVUQVVAUYHBVXCVYHUVFZVUBVUQVUCVRVVHVVBOVSVTVJYOVUQUWTTLVURTLZUXCTLZV
      VCTLZUXDVVFVLVVEUGAKTUWSUWBACEMKWFMXTLAWGVRZVYPAVUDWALZVUETLZVUDWRAWUHVLZ
      VUEVUHTJWUJVUFVUGWUJVUFWUJUYLWUHVUFKLZVGAWUHYBOVUDXBXAZYHWUJWUKUYNVUGTLZW
      ULAUYNWUHUYPWPUYMWUMBVUFKUYGVUFSUYHVUGTUYGVUFDUHVHVEWQYPXNUVGZYQUVHVUQVVN
      WUICKUTZWUDVVOAWUOVUPAWUICKWUNVCWPWUIWUDCUXEKVVQVUEVURTVVRVHVEWQVUQUYTUXB
      TLZWUEVOAKTUWEUVIVWDWUPVUPABDMKWFWUGGYQVWEKTUXAUWEUVOYLZOUXBYRXAVUQUYTWUB
      WUFVOWUCOVVBYRXAUWTVURUXCVVCUVJUVKUVLVUQUXFVUSUXIVVDRVUQUWSVXOLUXFVUSSVUQ
      UWSKVXOVXNWFYNUCEMUWSUVMXMVUQUXIOUXBVVBUCPZQPVVDVUQUXHWUROQVUQVXDUYHBWSVW
      SUYHBWSZVVBUCPUXHWURVUQVWSVVAUYHVXDBVYAVXQVUQMUXGXPVUQAVYCUYHVBLZUYGVXDLZ
      VYDUYGUXGYSAVYCVLUYHGXHZYLZUVNVUQUYHBDMUXGVUQWVAVLUYHWIVUQUXGKVXOVWKWFYNW
      VCYTVUQWUSUXBVVBUCVUQUYHBDMUXAVUQUYGVWSLZVLUYHWIVXPVUQAVYCWUTWVDVYDUYGUXA
      YSWVBYLYTXGYIUPVUQOUXBVVBVWHVUQUXBWUQXHVUQVVBWUCXHUVPXFUQUVQUVRUVSUVTUWA
      $.

    $( The Cauchy condensation test.  If ` a ( k ) ` is a decreasing sequence
       of nonnegative terms, then ` sum_ k e. NN a ( k ) ` converges iff
       ` sum_ n e. NN0 2 ^ n x. a ( 2 ^ n ) ` converges.  (Contributed by Mario
       Carneiro, 18-Jul-2014.) $)
    climcnds $p |- ( ph ->
      ( seq 1 ( + , F ) e. dom ~~> <-> seq 0 ( + , G ) e. dom ~~> ) ) $=
      ( c1 wcel cc0 wa cr wbr cn cn0 cfv c2 cle vx vj cseq cli cdm crn clt csup
      caddc nnuz cz 1z a1i wf cv nnnn0 cexp co cmul simpr nnexpcl sylancr nnred
      2nn wral ralrimiva adantr wceq fveq2 eleq1d rspcv remulcld eqeltrd sylan2
      sylc serfre cuz syl6eleq nnz adantl uzid peano2uz cfz simpl elfznn syl2an
      3syl simpll elfz1eq peano2nn0 syl ad2antlr nnnn0d nn0ge0d breq2d breqtrrd
      mulge0d syl2anc sermono adantlr csu wrex eqidd isumrecl remulcl ffvelrnda
      2re ad2antrr ffvelrnd climcndslem2 cc recnd fsumser fzfid wss ssriv sylan
      simplr isumless eqbrtrrd 2pos lemul2 syl112anc mpbid letrd ralbidv rspcev
      wb breq2 climsup climrel releldmi nn0uz iserex biimpar syldan peano2nn 0z
      1nn0 uztrn2 eleq1 biimparc ffvelrn cmin nn0red 2z ax-mp bernneq3 peano2zd
      ltled nnzd eluz mpbird eluzp1m1 elfzuz climcndslem1 elfznn0 impbida ) AUI
      DJUCZUDUEZKZUIELUCZUUTKZAUVAUIEJUCZUUTKZUVCAUVAMZUVDUVDUFNUGUHZUDOUVEUVFU
      AUBUVDJPUJJUKKZUVFULUMZAPNUVDUNUVAACEJPUJUVHAULUMZCUOZPKZAUVKQKZUVKERZNKZ
      UVKUPAUVMMZUVNSUVKUQURZUVQDRZUSURZNIUVPUVQUVRUVPUVQUVPSPKZUVMUVQPKZVDAUVM
      UTSUVKVAVBZVCZUVPUWABUOZDRZNKZBPVEZUVRNKZUWBAUWGUVMAUWFBPFVFVGUWFUWHBUVQP
      UWDUVQVHZUWEUVRNUWDUVQDVIZVJVKVOZVLVMZVNZVPVGZAUBUOZPKZUWOUVDRZUWOJUIURZU
      VDRTOUVAAUWPMZCEUWOJUWRUWSUWOPJVQRZAUWPUTUJVRZUWSUWOUKKZUWOUWOVQRZKUWRUXC
      KUWPUXBAUWOVSZVTUWOWAUWOUWOWBWGZUWSAUVLUVOUVKJUWRWCURZKAUWPWDZUVKUWRWEUWM
      WFUWSUVKUWRUWRWCURZKZMZAUVMLUVNTOZAUWPUXIWHUXJUVKUWRQUXIUVKUWRVHUWSUVKUWR
      WIVTUWPUWRQKZAUXIUWPUWOQKZUXLUWOUPZUWOWJWKZWLVMUVPLUVSUVNTUVPUVQUVRUWCUWK
      UVPUVQUVPUVQUWBWMWNUVPUWALUWETOZBPVEZLUVRTOZUWBAUXQUVMAUXPBPGVFVGUXPUXRBU
      VQPUWIUWEUVRLTUWJWOVKVOWQIWPZWRWSWTUVFSPUWEBXAZUSURZNKZUWQUYATOZUBPVEZUWQ
      UAUOZTOZUBPVEZUANXBUVFSNKZUXTNKZUYBXGUVFUWEBDJPUJUVIUVFUWDPKZMUWEXCAUYJUW
      FUVAFWTZAUVAUTXDZSUXTXEVBZUVFUYCUBPUVFUWPMZUWQSSUWOUQURZUUSRZUSURZUYAUVFP
      NUWOUVDUWNXFUYNUYHUYPNKZUYQNKXGUYNPNUYOUUSAPNUUSUNZUVAUWPABDJPUJUVJFVPZXH
      UYNUVTUXMUYOPKVDUWPUXMUVFUXNVTSUWOVAVBZXIZSUYPXEVBUVFUYBUWPUYMVGAUWPUWQUY
      QTOUVAABCDEUWOFGHIXJWTUYNUYPUXTTOZUYQUYATOZUYNJUYOWCURZUWEBXAUYPUXTTUYNUW
      EBDJUYOUYNUWDVUEKZMUWEXCUYNUYOPUWTVUAUJVRUYNAUYJUWEXKKVUFAUVAUWPWHZUWDUYO
      WEZAUYJMUWEFXLWFXMUYNVUEUWEBDJPUJUVHUYNULUMUYNJUYOXNVUEPXOUYNBVUEPVUHXPUM
      UYNUYJMUWEXCUVFUYJUWFUWPUYKWTUYNAUYJUXPVUGGXQAUVAUWPXRXSXTUYNUYRUYIUYHLSU
      GOZVUCVUDYHVUBUVFUYIUWPUYLVGUYHUYNXGUMVUIUYNYAUMUYPUXTSYBYCYDYEVFUYGUYDUA
      UYANUYEUYAVHUYFUYCUBPUYEUYAUWQTYIYFYGWRYJUVDUVGUDYKYLWKAUVCUVEACELJQYMJQK
      AYSUMUVPUVNUWLXLZYNYOYPAUVCMZUUSUUSUFNUGUHZUDOUVAVUKUAUBUUSJPUJUVHVUKULUM
      AUYSUVCUYTVGZAUWPUWOUUSRZUWRUUSRTOUVCUWSBDUWOJUWRUXAUXEUWSAUYJUWFUWDUXFKU
      XGUWDUWRWEFWFUWSUWDUXHKZMAUYJUXPAUWPVUOWHUWSUWRPKZUWDUWRVHZUYJVUOUWPVUPAU
      WOYQZVTUWDUWRWIVUQUYJVUPUWDUWRPUUAUUBWFGWRWSWTVUKQUVNCXAZNKZVUNVUSTOZUBPV
      EZVUNUYETOZUBPVEZUANXBVUKUVNCELQYMLUKKZVUKYRUMVUKUVMMUVNXCAUVMUVOUVCUWLWT
      AUVCUTXDZVUKVVAUBPVUKUWPMZVUNUWOUVBRZVUSVUKPNUWOUUSVUMXFZVUKQNUVBUNZUXMVV
      HNKUWPAVVJUVCACELQYMVVEAYRUMUWLVPVGUXNQNUWOUVBUUCWFZVUKVUTUWPVVFVGVVGVUNS
      UWRUQURZJUUDURZUUSRZVVHVVIVVGPNVVMUUSVUKUYSUWPVUMVGVVGUWPVVMUXCKZVVMPKVUK
      UWPUTVVGUXBVVLUWRVQRZKZVVOUWPUXBVUKUXDVTZVVGVVQUWRVVLTOZVVGUWRVVLVVGUWRUW
      PUXLVUKUXOVTZUUEVVGVVLVVGUVTUXLVVLPKVDVVTSUWRVAVBZVCVVGSSVQRKZUXLUWRVVLUG
      OSUKKVWBUUFSWAUUGVVTSUWRUUHVBUUJVVGUWRUKKVVLUKKVVQVVSYHVVGUWOVVRUUIVVGVVL
      VWAUUKUWRVVLUULWRUUMUWOVVLUUNWRZJVVMUWOPUJYTWRXIVVKVVGBDUWOJVVMAUWPUWOUWT
      KUVCUXAWTVWCVVGAUYJUWFUWDJVVMWCURKAUVCUWPWHZUWDVVMWEFWFVVGUWDUWRVVMWCURKZ
      MAUYJUXPVVGAVWEVWDVGVVGVUPUWDVVPKUYJVWEUWPVUPVUKVURVTUWDUWRVVMUUOJUWDUWRP
      UJYTWFGWRWSVVGAUXMVVNVVHTOVWDUWPUXMVUKUXNVTZABCDEUWOFGHIUUPWRYEVVGLUWOWCU
      RZUVNCXAVVHVUSTVVGUVNCELUWOVVGUVKVWGKZMUVNXCVVGUWOQLVQRVWFYMVRVVGAUVMUVNX
      KKVWHVWDUVKUWOUUQZVUJWFXMVVGVWGUVNCELQYMVVEVVGYRUMVVGLUWOXNVWGQXOVVGCVWGQ
      VWIXPUMVVGUVMMUVNXCVVGAUVMUVOVWDUWLXQVVGAUVMUXKVWDUXSXQAUVCUWPXRXSXTYEVFV
      VDVVBUAVUSNUYEVUSVHVVCVVAUBPUYEVUSVUNTYIYFYGWRYJUUSVULUDYKYLWKUUR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Miscellaneous converging and diverging sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d n x y A $.
    $( The sequence of reciprocals of real numbers, multiplied by the factor
       ` A ` , converges to zero.  (Contributed by Mario Carneiro,
       18-Sep-2014.) $)
    divrcnv $p |- ( A e. CC -> ( n e. RR+ |-> ( A / n ) ) ~~>r 0 ) $=
      ( vy vx cc wcel crp cv cdiv co cc0 wbr clt cabs cfv cr ad2antrl ralrimiva
      wral wa cmpt crli wi wrex abscl rerpdivcl sylan simpll rpcn rpne0 absdivd
      wne cle rpge0 absidd oveq2d eqtrd simprr wb abscld ad2antlr rpgt0 ltdiv23
      rpre syl122anc mpbid eqbrtrd expr wceq breq1 imbi1d ralbidv syl2anc simpl
      rspcev adantl divcld wss rpssre a1i rlim0lt mpbird ) AEFZBGABHZIJZUAKUBLC
      HZWDMLZWENOZDHZMLZUCZBGSZCPUDZDGSWCWMDGWCWIGFZTZANOZWIIJZPFZWQWDMLZWJUCZB
      GSZWMWCWPPFZWNWRAUEWPWIUFUGWOWTBGWOWDGFZWSWJWOXCWSTZTZWHWPWDIJZWIMXEWHWPW
      DNOZIJXFXEAWDWCWNXDUHZXCWDEFZWOWSWDUIZQXCWDKULZWOWSWDUJZQUKXEXGWDWPIXEWDX
      CWDPFZWOWSWDVDQZXCKWDUMLWOWSWDUNQUOUPUQXEWSXFWIMLZWOXCWSURXEXBWIPFZKWIMLZ
      XMKWDMLZWSXOUSXEAXHUTWNXPWCXDWIVDVAWNXQWCXDWIVBVAXNXCXRWOWSWDVBQWPWIWDVCV
      EVFVGVHRWLXACWQPWFWQVIZWKWTBGXSWGWSWJWFWQWDMVJVKVLVOVMRWCDCBGWEWCWEEFBGWC
      XCTAWDWCXCVNXCXIWCXJVPXCXKWCXLVPVQRGPVRWCVSVTWAWB $.

    $( The sequence of reciprocals of natural numbers, multiplied by the factor
       ` A ` , converges to zero.  (Contributed by NM, 6-Feb-2008.)  (Revised
       by Mario Carneiro, 18-Sep-2014.) $)
    divcnv $p |- ( A e. CC -> ( n e. NN |-> ( A / n ) ) ~~> 0 ) $=
      ( cc wcel cn cv cdiv co cmpt cc0 crli wbr cli crp wss ssriv a1i c1 adantl
      nnrp divrcnv rlimres2 nnuz cz 1z wa simpl nncn nnne0 divcld eqid rlimclim
      wne fmptd mpbid ) ACDZBEABFZGHZIZJKLUSJMLUPBENURJENOUPBENUQTPQABUAUBUPJUS
      REUCRUDDUPUEQUPBEURCUSUPUQEDZUFAUQUPUTUGUTUQCDUPUQUHSUTUQJUMUPUQUISUJUSUK
      UNULUO $.

    $( The floor function satisfies ` |_ ( x ) = x + O(1) ` .  (Contributed by
       Mario Carneiro, 21-May-2016.) $)
    flo1 $p |- ( x e. RR |-> ( x - ( |_ ` x ) ) ) e. O(1) $=
      ( cr cv cfl cfv cmin co cmpt co1 wcel wtru c1 wss ssid a1i reflcl resubcl
      cc cle wbr mpdan recnd adantl 1re cabs id flle abssubge0d fracle1 eqbrtrd
      ad2antrl elo1d trud ) ABACZUNDEZFGZHIJKABUPLLBBMKBNOUNBJZUPRJKUQUPUQUOBJU
      PBJUNPZUNUOQUAUBUCLBJKUDOZUSUQUPUEEZLSTKLUNSTUQUTUPLSUQUOUNURUQUFUNUGUHUN
      UIUJUKULUM $.
  $}

  ${
    $d f k m x z F $.  $d f k m n z ph $.  $d f k m x z R $.  $d f k m x z X $.
    $d x y z A $.  $d k m n S $.
    supcvg.1 $e |- X e. _V $.
    supcvg.2 $e |- S = sup ( A , RR , < ) $.
    supcvg.3 $e |- R = ( n e. NN |-> ( S - ( 1 / n ) ) ) $.
    supcvg.4 $e |- ( ph -> X =/= (/) ) $.
    supcvg.5 $e |- ( ph -> F : X -onto-> A ) $.
    supcvg.6 $e |- ( ph -> A C_ RR ) $.
    supcvg.7 $e |- ( ph -> E. x e. RR A. y e. A y <_ x ) $.
    $( Extract a sequence ` f ` in ` X ` such that the image of the points in
       the bounded set ` A ` converges to the supremum ` S ` of the set.
       Similar to Equation 4 of [Kreyszig] p. 144.  The proof uses countable
       choice ~ ax-cc .  (Contributed by Mario Carneiro, 15-Feb-2013.)  (Proof
       shortened by Mario Carneiro, 26-Apr-2014.) $)
    supcvg $p |- ( ph -> E. f ( f : NN --> X /\ ( F o. f ) ~~> S ) ) $=
      ( cn wcel cr vk vz vm cv wf cfv cle wbr wral wa wex ccom cli wrex csup c1
      clt cdiv cmin wceq weq oveq2 oveq2d ovex fvmpt adantl crp wss wne w3a wfo
      co c0 fof syl feq3 syl5ibcom f00 simprbi syl6 necon3d mpd suprcl syl5eqel
      3jca nnrp rpreccld ltsubrp syl2an eqbrtrd syl6breq adantr nnrecre resubcl
      wb fmptd ffvelrnda suprlub syl2anc mpbid wi sselda ltle reximdva crn forn
      rexeqdv wfn ffn breq2 rexrn 3syl bitr3d ralrimiva nnenom fveq2 breq2d cvv
      axcc4 nnuz cz 1z a1i cc0 csn cxp cc recnd cuz eqimss2i climconst2 sylancl
      cmpt nnex mptex eqeltri ax-1cn sylan eqeltrd ad2antrr mp1i fvconst2g eqid
      divcnv oveq12d eqtr4d climsub subid1d breqtrd fex vex fss breq12d rspccva
      coexg fco fveq2d adantll simplr fvco3 breqtrrd ad3antrrr syldan syl6breqr
      suprub climsqz ex imdistanda eximdv ) ARJGUDZUEZUAUDZEUFZUVLUVJUFZIUFZUGU
      HZUARUIZUJZGUKZUVKIUVJULZFUMUHZUJZGUKAUVMBUDZIUFZUGUHZBJUNZUARUIUVSAUWFUA
      RAUVLRSZUJZUVMUBUDZUGUHZUBDUNZUWFUWHUVMUWIUQUHZUBDUNZUWKUWHUVMDTUQUOZUQUH
      ZUWMUWHUVMFUWNUQUWHUVMFUPUVLURVLZUSVLZFUQUWGUVMUWQUTAHUVLFUPHUDZURVLZUSVL
      ZUWQREHUAVAUWSUWPFUSUWRUVLUPURVBZVCMFUWPUSVDVEVFZAFTSZUWPVGSUWQFUQUHUWGAF
      UWNTLADTVHZDVMVIZCUDUWCUGUHCDUIBTUNZVJZUWNTSAUXDUXEUXFPAJVMVIUXENADVMJVMA
      DVMUTZJVMIUEZJVMUTZAJDIUEZUXHUXIAJDIVKZUXKOJDIVNVOZDVMJIVPVQUXIIVMUTUXJJI
      VRVSVTWAWBQWEZBCDWCVOWDZUWGUVLUVLWFWGFUWPWHWIWJLWKUWHUXGUVMTSZUWOUWMWOAUX
      GUWGUXNWLARTUVLEAHRUWTTEAUXCUWSTSUWTTSUWRRSUXOUWRWMFUWSWNWIMWPZWQZBCUBDUV
      MWRWSWTUWHUWLUWJUBDUWHUWIDSZUJUXPUWITSUWLUWJXAUWHUXPUXSUXRWLUWHDTUWIAUXDU
      WGPWLXBUVMUWIXCWSXDWBAUWKUWFWOUWGAUWJUBIXEZUNZUWKUWFAUWJUBUXTDAUXLUXTDUTO
      JDIXFVOXGAUXKIJXHUYAUWFWOUXMJDIXIUWJUWEUBBJIUWIUWDUVMUGXJXKXLXMWLWTXNUWEU
      VPBJGUARKXOUWCUVNUTUWDUVOUVMUGUWCUVNIXPXQXSVOAUVRUWBGAUVKUVQUWAAUVKUJZUVQ
      UWAUYBUVQUJZFUCEUVTUPXRRXTUPYASZUYCYBYCAEFUMUHUVKUVQAEFYDUSVLFUMAFYDUARFY
      EYFZHRUWSYMZEUPXRRXTUYDAYBYCAFYGSZUYDUYEFUMUHAFUXOYHZYBFUPRRUPYIUFXTYJYNY
      KYLEXRSAEHRUWTYMXRMHRUWTYNYOYPYCUPYGSUYFYDUMUHAYQUPHUUDUUAUWHUVLUYEUFZFYG
      AUXCUWGUYIFUTUXORFUVLTUUBYRZAUYGUWGUYHWLYSUWHUVLUYFUFZUWPYGUWGUYKUWPUTAHU
      VLUWSUWPRUYFUXAUYFUUCUPUVLURVDVEVFZUWGUWPYGSAUWGUWPUVLWMYHVFYSUWHUVMUWQUY
      IUYKUSVLUXBUWHUYIFUYKUWPUSUYJUYLUUEUUFUUGAFUYHUUHUUIYTUYCIXRSZUVJXRSUVTXR
      SUYCUXKJXRSUYMAUXKUVKUVQUXMYTZKJDXRIUUJYLGUUKIUVJXRXRUUOYLUYCRTUCUDZEARTE
      UEUVKUVQUXQYTWQUYCRTUYOUVTUYBRTUVTUEZUVQAJTIUEZUVKUYPAUXKUXDUYQUXMPJDTIUU
      LWSRJTIUVJUUPYRWLWQUYCUYORSZUJZUYOEUFZUYOUVJUFZIUFZUYOUVTUFZUGUVQUYRUYTVU
      BUGUHZUYBUVPVUDUAUYORUAUCVAZUVMUYTUVOVUBUGUVLUYOEXPVUEUVNVUAIUVLUYOUVJXPU
      UQUUMUUNUURUYCUVKUYRVUCVUBUTAUVKUVQUUSZRJUYOIUVJUUTYRZUVAUYSVUCVUBFUGVUGU
      YSVUBUWNFUGUYSUXGVUBDSZVUBUWNUGUHAUXGUVKUVQUYRUXNUVBUYCUYRVUAJSVUHUYCRJUY
      OUVJVUFWQUYCJDVUAIUYNWQUVCBCDVUBUVEWSLUVDWJUVFUVGUVHUVIWB $.
  $}

  ${
    $d u x A $.  $d x y B $.  $d w z R $.  $d x y X $.  $d u x y Z $.
    $d y C $.
    infcvg.1 $e |- R = { x | E. y e. X x = -u A } $.
    infcvg.2 $e |- ( y e. X -> A e. RR ) $.
    infcvg.3 $e |- Z e. X $.
    infcvg.4 $e |- E. z e. RR A. w e. R w <_ z $.
    $( Auxiliary theorem for applications of ~ supcvg .  Hypothesis for several
       supremum theorems.  (Contributed by NM, 8-Feb-2008.) $)
    infcvgaux1i $p |- ( R C_ RR /\ R =/= (/)
           /\ E. z e. RR A. w e. R w <_ z ) $=
      ( cr wss c0 cv wrex cneg wceq wcel wne cle wral renegcld eleq1 syl5ibrcom
      wbr cab rexlimiv abssi eqsstri csb eqid csbeq1a negeqd eqeq2d rspce mp2an
      nfth negex nfcsb1v nfneg nfeq2 eqeq1 rexbid elab mpbir ne0i ax-mp 3pm3.2i
      eleqtrri ) FMNFOUAZDPCPUBUGDFUCCMQFAPZERZSZBGQZAUHZMIVPAMVOVMMTZBGBPZGTZV
      RVOVNMTVTEJUDVMVNMUEUFUIUJUKBHEULZRZFTVLWBVQFWBVQTWBVNSZBGQZHGTWBWBSZWDKW
      BUMZWCWEBHGWEBWFUSVSHSZVNWBWBWGEWABHEUNUOUPUQURVPWDAWBWAUTVMWBSVOWCBGBVMW
      BBWABHEVAVBVCVMWBVNVDVEVFVGIVKFWBVHVILVJ $.

    ${
      infcvg.5a $e |- S = -u sup ( R , RR , < ) $.
      infcvg.13 $e |- ( y = C -> A = B ) $.
      $( Auxiliary theorem for applications of ~ supcvg .  (Contributed by NM,
         4-Mar-2008.) $)
      infcvgaux2i $p |- ( C e. X -> S <_ B ) $=
        ( wcel cr wceq clt csup cneg cle wbr wrex cv negeqd eqeq2d rspcev mpan2
        eqid negex eqeq1 rexbidv sylibr infcvgaux1i suprubii syl eleq1d vtoclga
        elab2 wb suprclii lenegcon1 sylancl mpbid syl5eqbr ) GJRZIHSUAUBZUCZFUD
        PVIFUCZVJUDUEZVKFUDUEZVIVLHRZVMVIVLEUCZTZBJUFZVOVIVLVLTZVRVLULVQVSBGJBU
        GGTZVPVLVLVTEFQUHUIUJUKAUGZVPTZBJUFVRAVLHFUMWAVLTWBVQBJWAVLVPUNUOLVBUPC
        DHVLABCDEHJKLMNOUQZURUSVIFSRZVJSRVMVNVCESRWDBGJVTEFSQUTMVACDHWCVDFVJVEV
        FVGVH $.
    $}
  $}

  ${
    $d k n $.  $d j k F $.  $d j k H $.
    harmonic.1 $e |- F = ( n e. NN |-> ( 1 / n ) ) $.
    harmonic.2 $e |- H = seq 1 ( + , F ) $.
    $( The harmonic series ` H ` diverges.  This fact follows from the stronger
       ~ emcl , which establishes that the harmonic series grows as
       ` log n + gamma + ` _o_(1), but this uses a more elementary method,
       attributed to Nicole Oresme (1323-1382).  (Contributed by Mario
       Carneiro, 11-Jul-2014.) $)
    harmonic $p |- -. H e. dom ~~> $=
      ( vk wcel cn0 c1 wbr cn cr cc0 cfv wceq adantl cdiv co cle cmul vj cli cv
      cdm csu clt wrex csn cxp nn0uz cz 0z a1i 1ex fvconst2 wa 1re caddc eleq1i
      cseq biimpi oveq2 ovex nnrecre eqeltrd nnrp rpreccld rpge0d breqtrrd nnre
      fvmpt lep1d wb nngt0 peano2re syl peano2nn nngt0d lerec syl22anc mpbid c2
      3brtr4d cexp fveq2d oveq12d cmpt fconstmpt nnexpcl mpan oveq2d nncn nnne0
      2nn recidd eqtrd mpteq2ia eqtr4i climcnds isumrecl wn cfz chash cfn fzfid
      arch cc ax-1cn fsumconst sylancl hashfz1 oveq1d mulid1d 3eqtrd wss elfznn
      nnnn0 ssriv 0le1 adantr isumless eqbrtrrd lenlt syl2anr nrexdv pm2.65i )
      CUBUDZGZHIFUEZUAUCZUFJZUAKUGZYHYILGZYLYHIFHIUHUIZMHUJMUKGZYHULUMFUCZHGZYP
      YNNIOZYHHIYPUNUOZPILGZYHYQUPUQUMYHURBIUTZYGGZURYNMUTYGGZYHUUBCUUAYGEUSVAY
      HFUABYNYPKGZYPBNZLGYHUUDUUEIYPQRZLAYPIAUCZQRZUUFKBUUGYPIQVBDIYPQVCVKZYPVD
      VEPUUDMUUESJYHUUDMUUFUUESUUDUUFUUDYPYPVFVGVHUUIVIPUUDYPIURRZBNZUUESJYHUUD
      IUUJQRZUUFUUKUUESUUDYPUUJSJZUULUUFSJZUUDYPYPVJZVLUUDYPLGZMYPUFJUUJLGZMUUJ
      UFJUUMUUNVMUUOYPVNUUDUUPUUQUUOYPVOVPUUDUUJYPVQZVRYPUUJVSVTWAUUDUUJKGUUKUU
      LOUURAUUJUUHUULKBUUGUUJIQVBDIUUJQVCVKVPUUIWCPYJHGZYJYNNWBYJWDRZUUTBNZTRZO
      YHFYJWBYPWDRZUVCBNZTRZUVBHYNYPYJOZUVCUUTUVDUVATYPYJWBWDVBZUVFUVCUUTBUVGWE
      WFYNFHIWGFHUVEWGFHIWHFHUVEIYQUVEUVCIUVCQRZTRZIYQUVDUVHUVCTYQUVCKGZUVDUVHO
      WBKGYQUVJWNWBYPWIWJZAUVCUUHUVHKBUUGUVCIQVBDIUVCQVCVKVPWKYQUVJUVIIOUVKUVJU
      VCUVCWLUVCWMWOVPWPWQWRUUTUVATVCVKPWSWAZWTZYIUAXFVPYHYKUAKYHYJKGZUPZYJYISJ
      ZYKXAZUVOIYJXBRZIFUEZYJYISUVOUVSUVRXCNZITRZYJITRYJUVOUVRXDGIXGGUVSUWAOUVO
      IYJXEZXHUVRIFXIXJUVOUVTYJITUVOUUSUVTYJOUVNUUSYHYJXQPYJXKVPXLUVOYJUVNYJXGG
      YHYJWLPXMXNUVOUVRIFYNMHUJYOUVOULUMUWBUVRHXOUVOFUVRHYPUVRGUUDYQYPYJXPYPXQV
      PXRUMYQYRUVOYSPYTUVOYQUPZUQUMMISJUWCXSUMYHUUCUVNUVLXTYAYBUVNYJLGYMUVPUVQV
      MYHYJVJUVMYJYIYCYDWAYEYF $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Arithmetic series
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k N $.
    $( Arithmetic series sum of the first ` N ` positive integers.
       (Contributed by FL, 16-Nov-2006.)  (Proof shortened by Mario Carneiro,
       22-May-2014.) $)
    arisum $p |- ( N e. NN0 -> sum_ k e. ( 1 ... N ) k =
                   ( ( ( N ^ 2 ) + N ) / 2 ) ) $=
      ( vj cn0 wcel cc0 wceq c1 cfz co csu c2 caddc cbc cc syl6eq ax-1cn oveq1d
      cdiv syl cn wo cv cexp elnn0 cmin cz 1z a1i elfzelz zcnd adantl fsumshftm
      nnz id 1m1e0 oveq1i sumeq1i elfznn0 bcnp1n nn0cnd addcom sylancl sumeq2dv
      wa eqtr3d 1nn0 nnm1nn0 bcxmas sylancr eqtr4d cmul nncn eqtrd nnnn0 bcp1m1
      ppncand adddird sqval eqcomd mulid2 oveq12d 3eqtrd fz10 sumeq1d sum0 sq0i
      c0 oveq2 00id 2cn 2ne0 div0i jaoi sylbi ) BDEZBUAEZBFGZUBHBIJZAUCZAKZBLUD
      JZBMJZLSJZGZBUEWQXEWRWQXAFBHUFJZIJZCUCZHMJZCKZHHMJXFMJZXFNJZXDWQXAHHUFJZX
      FIJZXICKXJWQWTXIACHHBHUGEWQUHUIZXOBUNWTWSEZWTOEWQXPWTWTHBUJUKULWTXIGUOUMX
      NXGXICXMFXFIUPUQURPWQXJXGHXHMJZXHNJZCKZXLWQXGXIXRCWQXHXGEZVEZXIXHNJZXIXRY
      AXHDEZYBXIGXTYCWQXHXFUSULZXHUTTYAXIXQXHNYAXHOEHOEZXIXQGYAXHYDVAQXHHVBVCRV
      FVDWQHDEXFDEXLXSGVGBVHCXFHVIVJVKWQXLBHMJZXFNJZYFBVLJZLSJZXDWQXKYFXFNWQXKH
      BMJZYFWQHHBYEWQQUIZYKBVMZVQWQYEBOEZYJYFGQYLHBVBVJVNRWQWPYGYIGBVOBVPTWQYHX
      CLSWQYHBBVLJZHBVLJZMJZXCWQBHBYLYKYLVRWQYMYPXCGYLYMYNXBYOBMYMXBYNBVSVTBWAW
      BTVNRWCWCWRXAFXDWRXAWHWTAKFWRWSWHWTAWRWSHFIJWHBFHIWIWDPWEWTAWFPWRXDFLSJFW
      RXCFLSWRXCFFMJFWRXBFBFMBWGWRUOWBWJPRLWKWLWMPVKWNWO $.

    $( Arithmetic series sum of the first ` N ` nonnegative integers.
       (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    arisum2 $p |- ( N e. NN0 -> sum_ k e. ( 0 ... ( N - 1 ) ) k =
                   ( ( ( N ^ 2 ) - N ) / 2 ) ) $=
      ( cn0 wcel cc0 wceq c1 cmin co cfz csu c2 cexp cdiv caddc oveq2d eqtrd c0
      cmul syl6eq cn wo cv elnn0 cuz cfv nnm1nn0 syl6eleq elfznn0 adantl nn0cnd
      nn0uz wa id fsum1p 1e0p1 oveq1i sumeq1i oveq2i fzfid elfznn nncnd addid2d
      fsumcl syl5eqr arisum syl nncn mulid1d 2timesd sqcld subsub4d sq1 oveq12d
      eqtr4d a1i cc ax-1cn binom2sub sylancl subcld subsubd oveq1d subcl npcand
      3eqtr4d oveq1 clt wbr cr 0re ltm1 ax-mp cz wb peano2zm mp2an mpbi sumeq1d
      0z fzn sum0 sq0i 0cn subidi 2cn 2ne0 div0i jaoi sylbi ) BCDBUADZBEFZUBEBG
      HIZJIZAUCZAKZBLMIZBHIZLNIZFZBUDXKXTXLXKXPEEGOIZXMJIZXOAKZOIZXSXKXOEAEXMXK
      XMCEUEUFBUGZULUHXKXOXNDZUMXOYFXOCDXKXOXMUIUJUKXOEFUNUOXKYDGXMJIZXOAKZXSXK
      YDEYHOIYHYHYCEOYGYBXOAGYAXMJUPUQURUSXKYHXKYGXOAXKGXMUTXKXOYGDZUMXOYIXOUAD
      XKXOXMVAUJVBVDVCVEXKYHXMLMIZXMOIZLNIZXSXKXMCDYHYLFYEAXMVFVGXKYKXRLNXKYKXR
      XMHIZXMOIXRXKYJYMXMOXKXQLBGSIZSIZHIZGLMIZOIZXRBHIZGOIYJYMXKYPYSYQGOXKYPXQ
      BBOIZHIYSXKYOYTXQHXKYOLBSIYTXKYNBLSXKBBVHZVIPXKBUUAVJQPXKXQBBXKBUUAVKZUUA
      UUAVLVOYQGFXKVMVPVNXKBVQDZGVQDZYJYRFUUAVRBGVSVTXKXRBGXKXQBUUBUUAWAZUUAUUD
      XKVRVPWBWFWCXKXRXMUUEXKUUCUUDXMVQDUUAVRBGWDVTWEQWCQQQXLXPEXSXLXPRXOAKEXLX
      NRXOAXLXNEEGHIZJIZRXLXMUUFEJBEGHWGPUUFEWHWIZUUGRFZEWJDUUHWKEWLWMEWNDZUUFW
      NDZUUHUUIWOWTUUJUUKWTEWPWMEUUFXAWQWRTWSXOAXBTXLXSELNIEXLXRELNXLXREEHIEXLX
      QEBEHBXCXLUNVNEXDXETWCLXFXGXHTVOXIXJ $.
  $}

  ${
    $d F j $.  $d F k $.  $d F x $.  $d j k $.  $d j x $.  $d k x $.  $d N k $.
    $d n k $.  $d N n $.  $d j n $.
    trireciplem.1 $e |- F = ( n e. NN |-> ( 1 / ( n x. ( n + 1 ) ) ) ) $.
    $( Lemma for ~ trirecip .  Show that the sum converges.  (Contributed by
       Scott Fenton, 22-Apr-2014.)  (Revised by Mario Carneiro,
       22-May-2014.) $)
    trireciplem $p |- seq 1 ( + , F ) ~~> 1 $=
      ( vj caddc c1 cc0 cmin co wtru cdiv cvv wcel a1i ax-1cn syl cfv wceq cmul
      cn vk cseq cli cv cmpt nnuz cz 1z cc divcnv nnex mptex wa peano2nn adantl
      oveq2 eqid ovex fvmpt oveq1 oveq2d eqtr4d climshft2 mpbird seqex nnrecred
      wbr recnd eqeltrd elfznn nncnd peano2cn nnmulcld nnne0d divsubdird pncan2
      cfz sylancl oveq1d mulid1d mulcomd oveq12d divcan5d eqtr3d sumeq2dv div1i
      csu 3eqtr3d syl6eq nnz syl6eleq fsumtscop eqtrd id simpr fsumser 3eqtr2rd
      cuz climsubc2 trud subid1i breqtri ) EBFUBZFGHIZFUCXCXDUCVGJGFUAATFAUDZFE
      IZKIZUEZXCFLTUFFUGMJUHNZJXHGUCVGATFXEKIZUEZGUCVGZJFUIMZXLXMJONZFAUJPJGUAX
      HXKFFLLTUFXIXIXHLMJATXGUKULNXKLMJATXJUKULNJUAUDZTMZUMZXOFEIZXKQZFXRKIZXOX
      HQZXQXRTMZXSXTRXPYBJXOUNUOZAXRXJXTTXKXEXRFKUPZXKUQFXRKURZUSPXPYAXTRJAXOXG
      XTTXHXEXORXFXRFKXEXOFEUTVAXHUQYEUSUOZVBVCVDXNXCLMJEBFVENXQYAXTUIYFXQXTXQX
      RYCVFVHVIXQFYAHIFXTHIZFXOVQIZFDUDZYIFEIZSIZKIZDWGZXOXCQXQYAXTFHYFVAXQYMYH
      FYIKIZFYJKIZHIZDWGYGXQYHYLYPDXQYIYHMZUMZYJYIHIZYKKIYJYKKIZYIYKKIZHIYLYPYR
      YJYIYKYRYIUIMZYJUIMYRYIYQYITMZXQYIXOVJUOZVKZYIVLPZUUEYRYKYRYIYJUUDYRUUCYJ
      TMUUDYIUNPZVMZVKYRYKUUHVNVOYRYSFYKKYRUUBXMYSFRUUEOYIFVPVRVSYRYTYNUUAYOHYR
      YJFSIZYJYISIZKIYTYNYRUUIYJUUJYKKYRYJUUFVTYRYJYIUUFUUEWAWBYRFYIYJXMYRONZUU
      EUUFYRYIUUDVNZYRYJUUGVNZWCWDYRYIFSIZYKKIUUAYOYRUUNYIYKKYRYIUUEVTVSYRFYJYI
      UUKUUFUUEUUMUULWCWDWBWHWEXQXJYNYOFDAXTFXOXEYIFKUPXEYJFKUPXEFRXJFFKIFXEFFK
      UPFOWFWIYDXPXOUGMJXOWJUOXQXRTFWRQZYCUFWKXQXEFXRVQIMZUMZXJUUQXEUUPXETMXQXE
      XRVJUOVFVHWLWMXQYLDBFXOYRUUCYIBQYLRUUDAYIFXEXFSIZKIYLTBXEYIRZUURYKFKUUSXE
      YIXFYJSUUSWNXEYIFEUTWBVACFYKKURUSPXQXOTUUOJXPWOUFWKYRYLYRYKUUHVFVHWPWQWSW
      TFOXAXB $.
  $}

  ${
    $d k j n $.
    $( The sum of the reciprocals of the triangle numbers converge to two.
       (Contributed by Scott Fenton, 23-Apr-2014.)  (Revised by Mario Carneiro,
       22-May-2014.) $)
    trirecip $p |- sum_ k e. NN ( 2 / ( k x. ( k + 1 ) ) ) = 2 $=
      ( vn cn c2 cv c1 caddc co cmul cdiv csu wcel cc 2cn wceq wtru nnuz oveq2d
      a1i cli peano2nn nnmulcl mpdan nncnd nnne0d divrecd sumeq2i cmpt cz 1z id
      cfv oveq1 oveq12d eqid ovex fvmpt nnrecred recnd cseq wbr cdm trireciplem
      adantl climrel releldmi syl isummulc2 isumclim eqtr3d trud mulid1i 3eqtri
      ) CDAEZVNFGHZIHZJHZAKCDFVPJHZIHZAKZDFIHZDCVQVSAVNCLZDVPDMLZWBNSWBVPWBVOCL
      VPCLVNUAVNVOUBUCZUDWBVPWDUEUFUGVTWAOPDCVRAKZIHVTWAPVRDABCFBEZWFFGHZIHZJHZ
      UHZFCQFUILPUJSZWBVNWJULVROPBVNWIVRCWJWFVNOZWHVPFJWLWFVNWGVOIWLUKWFVNFGUMU
      NRWJUOZFVPJUPUQVDZWBVRMLPWBVRWBVPWDURUSVDZPGWJFUTZFTVAZWPTVBLWQPBWJWMVCSZ
      WPFTVEVFVGWCPNSVHPWEFDIPVRFAWJFCQWKWNWOWRVIRVJVKDNVLVM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Geometric series
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n A $.  $d k ph $.
    expcnv.1 $e |- ( ph -> A e. CC ) $.
    expcnv.2 $e |- ( ph -> ( abs ` A ) < 1 ) $.
    $( A sequence of powers of a complex number ` A ` with absolute value
       smaller than 1 converges to zero.  (Contributed by NM, 8-May-2006.)
       (Proof shortened by Mario Carneiro, 26-Apr-2014.) $)
    expcnv $p |- ( ph -> ( n e. NN0 |-> ( A ^ n ) ) ~~> 0 ) $=
      ( cexp co cc0 wbr wceq wa c1 cn wcel a1i cc cdiv crp cr syl2an vk cv cmpt
      cn0 cli cvv nnuz cz nn0ex mptex 0cn cfv nnnn0 oveq2 eqid ovex fvmpt simpr
      syl oveq1d sylan9eqr 0exp adantl eqtrd climconst wne cabs cmin clt adantr
      1z absrpcl sylan reclt1d mpbid wb 1re rpreccld rpred difrp sylancr divcnv
      rpcnd nnex nndivre eqeltrd nnz rpexpcl cle cmul nnrp caddc peano2re lep1d
      rpmulcl rpge0d bernneq2 syl3anc letrd rpcnne0d 3expa breqtrd lerec2d nncn
      exprec nnne0 jca recdiv2 breqtrrd 3brtr4d climsqz2 absexp fveq2d 3eqtr4rd
      expcl climabs0 biimpar syldan pm2.61dane ) ACUDBCUBZFGZUCZHUEIZBHABHJZKZH
      UAYBLUFMUGLUHNZYEVKOYBUFNZYECUDYAUIUJZOHPNYEUKOYEUAUBZMNZKYIYBULZHYIFGZHY
      JYEYKBYIFGZYLYJYIUDNZYKYMJZYIUMZCYIYAYMUDYBXTYIBFUNYBUOBYIFUPUQZUSYEBHYIF
      AYDURUTVAYJYLHJYEYIVBVCVDVEABHVFZCMBVGULZXTFGZUCZHUEIZYCAYRKZHUACMLLYSQGZ
      LVHGZQGZXTQGZUCZUUALUFMUGYFUUCVKOUUCUUFPNUUHHUEIUUCUUFUUCUUEUUCLUUDVIIZUU
      ERNZUUCYSLVIIZUUIAUUKYREVJUUCYSABPNZYRYSRNZDBVLVMZVNVOUUCLSNUUDSNZUUIUUJV
      PVQUUCUUDUUCYSUUNVRZVSZLUUDVTWAVOZVRZWCUUFCWBUSUUAUFNZUUCCMYTWDUJZOUUCYJK
      ZYIUUHULZUUFYIQGZSYJUVCUVDJUUCCYIUUGUVDMUUHXTYIUUFQUNUUHUOUUFYIQUPUQVCZUU
      CUUFSNYJUVDSNUUCUUFUUSVSUUFYIWEVMWFUVBYIUUAULZUVBUVFYSYIFGZRYJUVFUVGJZUUC
      CYIYTUVGMUUAXTYIYSFUNUUAUOYSYIFUPUQZVCZUUCUUMYIUHNZUVGRNYJUUNYIWGZYSYIWHT
      ZWFZVSUVBUVGUVDUVFUVCWIUVBUVGLUUEYIWJGZQGZUVDWIUVBUVOUVGUUCUUJYIRNUVORNYJ
      UURYIWKUUEYIWOTZUVMUVBUVOUUDYIFGZLUVGQGZWIUVBUVOUVOLWLGZUVRUVBUVOUVQVSZUV
      BUVOSNUVTSNUWAUVOWMUSUVBUVRUUCUUDRNUVKUVRRNYJUUPUVLUUDYIWHTVSUVBUVOUWAWNU
      VBUUOYNHUUDWIIZUVTUVRWIIUUCUUOYJUUQVJYJYNUUCYPVCUUCUWBYJUUCUUDUUPWPVJUUDY
      IWQWRWSUUCYSPNZYSHVFZKUVKUVRUVSJZYJUUCYSUUNWTUVLUWCUWDUVKUWEYSYIXEXATXBXC
      UUCUUEPNUUEHVFKYIPNZYIHVFZKUVDUVPJYJUUCUUEUURWTYJUWFUWGYIXDYIXFXGUUEYIXHT
      XIUVJUVEXJUVBUVFUVNWPXKAYCUUBAUAYBUUALUFUFMUGYFAVKOYGAYHOUUTAUVAOAYJKZYKY
      MPUWHYNYOYJYNAYPVCYQUSZAUULYNYMPNYJDYPBYIXOTWFUWHYMVGULZUVGYKVGULUVFAUULY
      NUWJUVGJYJDYPBYIXLTUWHYKYMVGUWIXMYJUVHAUVIVCXNXPXQXRXS $.
  $}

  ${
    $d k n A $.  $d k ph $.  $d k n F $.  $d k n Z $.  $d k M $.
    explecnv.1 $e |- Z = ( ZZ>= ` M ) $.
    explecnv.2 $e |- ( ph -> F e. V ) $.
    explecnv.3 $e |- ( ph -> M e. ZZ ) $.
    explecnv.5 $e |- ( ph -> A e. RR ) $.
    explecnv.4 $e |- ( ph -> ( abs ` A ) < 1 ) $.
    explecnv.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    explecnv.7 $e |- ( ( ph /\ k e. Z ) ->
                       ( abs ` ( F ` k ) ) <_ ( A ^ k ) ) $.
    $( A sequence of terms converges to zero when it is less than powers of a
       number ` A ` whose absolute value is smaller than 1.  (Contributed by
       NM, 19-Jul-2008.)  (Revised by Mario Carneiro, 26-Apr-2014.) $)
    explecnv $p |- ( ph -> F ~~> 0 ) $=
      ( vn cc0 wbr cfv cn0 wcel cli cv cabs cmpt cexp co cle cif cvv eqid cz 0z
      cuz ifcl sylancr recnd expcnv fvex eqeltri mptex a1i wa cr wceq cin nn0uz
      ineq12i uzin sylancl eleq2d biimpa elin sylib simprd oveq2 ovex fvmpt syl
      syl5req adantr reexpcld eqeltrd simpld fveq2 fveq2d syldan abscld 3brtr4d
      cc absge0d breqtrrd climsqz2 adantl climabs0 mpbird ) ADPUAQOGOUBZDRZUCRZ
      UDZPUAQAPCOSBWPUEUFZUDZWSEPUGQZPEUHZUIXCUMRZXDUJAPUKTZEUKTZXCUKTULJXBPEUK
      UNUOABOABKUPLUQWSUITAOGWRGEUMRZUIHEUMURUSUTVAZACUBZXDTZVBZXIXARZBXIUEUFZV
      CXKXISTZXLXMVDXKXIGTZXNXKXIGSVEZTZXOXNVBAXJXQAXDXPXIAXPXGPUMRZVEZXDGXGSXR
      HVFVGAXFXEXSXDVDJULEPVHVIVSVJVKXIGSVLVMZVNZOXIWTXMSXAWPXIBUEVOXAUJBXIUEVP
      VQVRZXKBXIABVCTXJKVTYAWAWBXKXIWSRZXIDRZUCRZVCXKXOYCYEVDZXKXOXNXTWCZOXIWRY
      EGWSWPXIVDWQYDUCWPXIDWDWEWSUJYDUCURVQZVRZXKYDAXJXOYDWITYGMWFZWGWBXKYEXMYC
      XLUGAXJXOYEXMUGQYGNWFYIYBWHXKPYEYCUGXKYDYJWJYIWKWLACDWSEFUIGHJIXHMXOYFAYH
      WMWNWO $.
  $}

  ${
    $d j k A $.  $d j k M $.  $d j k N $.  $d j k ph $.
    geoserg.1 $e |- ( ph -> A e. CC ) $.
    geoserg.2 $e |- ( ph -> A =/= 1 ) $.
    geoserg.3 $e |- ( ph -> M e. NN0 ) $.
    geoserg.4 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    $( The value of the finite geometric series ` A ^ M + A ^ ( M + 1 ) + ` ...
       ` + A ^ ( N - 1 ) ` .  (Contributed by Mario Carneiro, 2-May-2016.) $)
    geoserg $p |- ( ph -> sum_ k e. ( M ..^ N ) ( A ^ k ) =
                    ( ( ( A ^ M ) - ( A ^ N ) ) / ( 1 - A ) ) ) $=
      ( cexp co cmin c1 csu wceq cmul wcel cn0 expcld oveq2 vj cdiv cfzo cv cfn
      caddc fzofi a1i cc ax-1cn subcl sylancr wa adantr cuz cfv elfzouz eluznn0
      syl2an fsummulc1 subdid mulid1d expp1d eqcomd oveq12d sumeq2dv cfz elfzuz
      eqtrd fsumtscopo 3eqtrrd syl2anc subcld fsumcl necomd wb subeq0 necon3bid
      cc0 wne mpbird divmul3d ) ABDJKZBEJKZLKZMBLKZUBKZDEUCKZBCUDZJKZCNZAWGWKOW
      EWKWFPKZOAWLWHWJWFPKZCNWHWJBWIMUFKZJKZLKZCNWEAWHWJWFCWHUEQADEUGUHZAMUIQZB
      UIQZWFUIQUJFMBUKULZAWIWHQZUMZBWIAWSXAFUNZADRQZWIDUOUPZQWIRQXAHWIDEUQWIDUR
      USZSZUTAWHWMWPCXBWMWJMPKZWJBPKZLKWPXBWJMBXGWRXBUJUHXCVAXBXHWJXIWOLXBWJXGV
      BXBWOXIXBBWIXCXFVCVDVEVIVFABUAUDZJKWJWOWCCUAWDDEXJWIBJTXJWNBJTXJDBJTXJEBJ
      TIAXJDEVGKQZUMBXJAWSXKFUNAXDXJXEQXJRQXKHXJDEVHXJDURUSSVJVKAWEWKWFAWCWDABD
      FHSABEFAXDEXEQERQHIEDURVLSVMAWHWJCWQXGVNWTAWFVSVTMBVTABMGVOAWFVSMBAWRWSWF
      VSOMBOVPUJFMBVQULVRWAWBWAVD $.
  $}

  ${
    $d j k A $.  $d j k N $.  $d j k ph $.
    geoser.1 $e |- ( ph -> A e. CC ) $.
    geoser.2 $e |- ( ph -> A =/= 1 ) $.
    geoser.3 $e |- ( ph -> N e. NN0 ) $.
    $( The value of the finite geometric series ` 1 + A ^ 1 + A ^ 2 + ` ...
       ` + A ^ ( N - 1 ) ` .  (Contributed by NM, 12-May-2006.)  (Proof
       shortened by Mario Carneiro, 15-Jun-2014.) $)
    geoser $p |- ( ph -> sum_ k e. ( 0 ... ( N - 1 ) ) ( A ^ k ) =
                    ( ( 1 - ( A ^ N ) ) / ( 1 - A ) ) ) $=
      ( cc0 cfzo co cv cexp csu cmin c1 cdiv cfz cn0 wcel oveq1d 0nn0 a1i nn0uz
      cuz cfv syl6eleq geoserg cz wceq nn0zd fzoval syl sumeq1d exp0d 3eqtr3d )
      AHDIJZBCKLJZCMBHLJZBDLJZNJZOBNJZPJHDONJQJZUQCMOUSNJZVAPJABCHDEFHRSAUAUBAD
      RHUDUEGUCUFUGAUPVBUQCADUHSUPVBUIADGUJHDUKULUMAUTVCVAPAUROUSNABEUNTTUO $.
  $}

  ${
    $d j k n A $.  $d j k F $.  $d j k M $.  $d j k ph $.
    geolim.1 $e |- ( ph -> A e. CC ) $.
    geolim.2 $e |- ( ph -> ( abs ` A ) < 1 ) $.
    ${
      geolim.3 $e |- ( ( ph /\ k e. NN0 ) -> ( F ` k ) = ( A ^ k ) ) $.
      $( The partial sums in the infinite series ` 1 + A ^ 1 + A ^ 2 ` ...
         converge to ` ( 1 / ( 1 - A ) ) ` .  (Contributed by NM,
         15-May-2006.) $)
      geolim $p |- ( ph -> seq 0 ( + , F ) ~~> ( 1 / ( 1 - A ) ) ) $=
        ( vn cc0 c1 cmin co cdiv cn0 cexp wcel cmul cc cfv wceq vj caddc cli cv
        cseq cmpt cvv nn0uz cz a1i expcnv ax-1cn subcl sylancr wne cabs clt wbr
        0z 1re ltnri fveq2 abs1 syl6eq breq1d mtbiri necon2ai syl necomd subeq0
        wb necon3bid mpbird divcld nn0ex mptex wa oveq2 eqid fvmpt adantl expcl
        sylan eqeltrd expp1 adantr mulcomd eqtrd oveq1d div23d oveq2d climmulc2
        ovex oveq1 3eqtr4d mul01d breqtrd reccld seqex peano2nn0 syl2an cfz csu
        nn0cn pncan sylancl sumeq1d divsubdird geoser elfznn0 syl2anc cuz simpr
        simpll syl6eleq expcld fsumser 3eqtr3rd climsubc2 subid1d ) AUBDIUEZJJB
        KLZMLZIKLYCUCAIYCUAHNBHUDZJUBLZOLZYBMLZUFZYAIUGNUHIUIPAUSUJZAYHBYBMLZIQ
        LIUCAIYJUAHNBYDOLZUFZYHIUGNUHYIABHEFUKABYBEAJRPZBRPZYBRPZULEJBUMUNZAYBI
        UOZJBUOABJABUPSZJUQURZBJUOZFYSBJBJTZYSJJUQURJUTVAUUAYRJJUQUUAYRJUPSJBJU
        PVBVCVDVEVFVGVHZVIAYBIJBAYMYNYBITJBTVKULEJBVJUNVLVMZVNZYHUGPAHNYGVOVPUJ
        AUAUDZNPZVQZUUEYLSZBUUEOLZRUUFUUHUUITAHUUEYKUUINYLYDUUEBOVRYLVSBUUEOWMV
        TWAZAYNUUFUUIRPEBUUEWBWCZWDUUGBUUEJUBLZOLZYBMLZYJUUIQLZUUEYHSZYJUUHQLUU
        GUUNBUUIQLZYBMLUUOUUGUUMUUQYBMUUGUUMUUIBQLZUUQAYNUUFUUMUURTEBUUEWEWCUUG
        UUIBUUKAYNUUFEWFZWGWHWIUUGBUUIYBUUSUUKAYOUUFYPWFZAYQUUFUUCWFZWJWHUUFUUP
        UUNTAHUUEYGUUNNYHYDUUETZYFUUMYBMUVBYEUULBOYDUUEJUBWNWKWIYHVSUUMYBMWMVTW
        AZUUGUUHUUIYJQUUJWKWOWLAYJUUDWPWQAYBYPUUCWRZYAUGPAUBDIWSUJUUGUUPUUNRUVC
        UUGUUMYBAYNUULNPZUUMRPUUFEUUEWTZBUULWBXAZUUTUVAVNWDUUGIUULJKLZXBLZBCUDZ
        OLZCXCZIUUEXBLZUVKCXCYCUUPKLZUUEYASUUGUVIUVMUVKCUUGUVHUUEIXBUUGUUERPZYM
        UVHUUETUUFUVOAUUEXDWAULUUEJXEXFWKXGUUGJUUMKLYBMLYCUUNKLUVLUVNUUGJUUMYBY
        MUUGULUJUVGUUTUVAXHUUGBCUULUUSAYTUUFUUBWFUUFUVEAUVFWAXIUUGUUPUUNYCKUVCW
        KWOUUGUVKCDIUUEUUGUVJUVMPZVQZAUVJNPZUVJDSUVKTAUUFUVPXNZUVPUVRUUGUVJUUEX
        JWAZGXKUUGUUENIXLSAUUFXMUHXOUVQBUVJUVQAYNUVSEVHUVTXPXQXRXSAYCUVDXTWQ $.
    $}

    geolim2.3 $e |- ( ph -> M e. NN0 ) $.
    geolim2.4 $e |- ( ( ph /\ k e. ( ZZ>= ` M ) ) -> ( F ` k ) = ( A ^ k ) ) $.
    $( The partial sums in the geometric series ` A ^ M + A ^ ( M + 1 ) ` ...
       converge to ` ( ( A ^ M ) / ( 1 - A ) ) ` .  (Contributed by NM,
       6-Jun-2006.)  (Revised by Mario Carneiro, 26-Apr-2014.) $)
    geolim2 $p |- ( ph -> seq M ( + , F ) ~~> ( ( A ^ M ) / ( 1 - A ) ) ) $=
      ( caddc cfv cexp co c1 cmin cdiv wcel cc cn0 cc0 vn cseq cuz csu cli eqid
      vj cv nn0zd wa adantr eluznn0 sylan expcld cmpt cdm wceq oveq2 ovex fvmpt
      syl eqtr4d seqfeq wbr adantl geolim seqex breldm nn0uz expcl iserex mpbid
      eqeltrd eqeltrrd isumclim2 cfz isumsplit a1i isumclim eqtr3d cabs clt wne
      cz 0z ltnri fveq2 abs1 syl6eq breq1d mtbiri necon2ai geoser oveq1d ax-1cn
      1re subcl sylancr necomd subeq0 necon3bid mpbird divsubdird divcld isumcl
      wb nncan pncan2d 3eqtr3rd breqtrd ) AJDEUBZEUCKZBCUHZLMZCUDZBELMZNBOMZPMZ
      UEAXNCDEXLXLUFZAEHUIZIAXMXLQZUJZBXMABRQZYAFUKAESQYAXMSQZHXMEULUMZUNZAJUAS
      BUAUHZLMZUOZEUBZXKUEUPZAJCYIDEXTYBXMYIKZXNXMDKYBYDYLXNUQZYEUAXMYHXNSYIYGX
      MBLURYIUFZBXMLUSUTZVAZIVBVCAJYITUBZYKQZYJYKQAYQNXQPMZUEVDYRABUGYIFGUGUHZS
      QZYTYIKZBYTLMZUQAUAYTYHUUCSYIYGYTBLURYNBYTLUSUTVEZVFZYQYSUEJYITVGNXQPUSVH
      VAZAUGYITESVIHAUUAUJUUBUUCRUUDAYCUUAUUCRQFBYTVJUMVMVKVLZVNVOAYSNXPOMZXQPM
      ZOMZUUIXOJMZUUIOMXRXOAYSUUKUUIOATENOMVPMXNCUDZXOJMZYSUUKASXNCUDUUMYSAXNCY
      ITEXLSVIXSHYDYMAYOVEZAYCYDXNRQFBXMVJUMZUUFVQAXNYSCYITSVITWDQAWEVRUUNUUOUU
      EVSVTAUULUUIXOJABCEFABWAKZNWBVDZBNWCGUUQBNBNUQZUUQNNWBVDNWPWFUURUUPNNWBUU
      RUUPNWAKNBNWAWGWHWIWJWKWLVAZHWMWNVTWNANUUHOMZXQPMUUJXRANUUHXQNRQZAWOVRAUV
      AXPRQZUUHRQWOABEFHUNZNXPWQWRZAUVAYCXQRQWOFNBWQWRZAXQTWCNBWCABNUUSWSAXQTNB
      AUVAYCXQTUQNBUQXFWOFNBWTWRXAXBZXCAUUTXPXQPAUVAUVBUUTXPUQWOUVCNXPXGWRWNVTA
      UUIXOAUUHXQUVDUVEUVFXDAXNCYIEXLXSXTYPYFUUGXEXHXIXJ $.
  $}

  ${
    $d k A $.  $d k F $.  $d k ph $.
    georeclim.1 $e |- ( ph -> A e. CC ) $.
    georeclim.2 $e |- ( ph -> 1 < ( abs ` A ) ) $.
    georeclim.3 $e |- ( ( ph /\ k e. NN0 ) ->
                        ( F ` k ) = ( ( 1 / A ) ^ k ) ) $.
    $( The limit of a geometric series of reciprocals.  (Contributed by Paul
       Chapman, 28-Dec-2007.)  (Revised by Mario Carneiro, 26-Apr-2014.) $)
    georeclim $p |- ( ph -> seq 0 ( + , F ) ~~> ( A / ( A - 1 ) ) ) $=
      ( cc0 c1 cdiv co cmin cabs cfv clt wbr wne wceq syl6eq cc cseq cli cle wn
      caddc 0le1 0re 1re lenlti mpbi fveq2 abs0 breq2d mtbiri necon2ai syl wcel
      reccld ax-1cn a1i absdivd abs1 oveq1i absrpcld recgt1d eqbrtrd divsubdird
      mpbid geolim dividd oveq1d eqtrd oveq2d subcl sylancl wb subeq0 necon3bid
      ltnri mpbird recdivd eqtr3d breqtrd ) AUEDHUAIIIBJKZLKZJKZBBILKZJKZUBAWDC
      DABEAIBMNZOPZBHQFWJBHBHRZWJIHOPZHIUCPWLUDUFHIUGUHUIUJWKWIHIOWKWIHMNHBHMUK
      ULSUMUNUOUPZURAWDMNZIWIJKZIOAWNIMNZWIJKWOAIBITUQZAUSUTZEWMVAWPIWIJVBVCSAW
      JWOIOPFAWIABEWMVDVEVHVFGVIAIWGBJKZJKWFWHAWSWEIJAWSBBJKZWDLKWEABIBEWREWMVG
      AWTIWDLABEWMVJVKVLVMAWGBABTUQZWQWGTUQEUSBIVNVOEAWGHQBIQZAWJXBFWJBIBIRZWJI
      IOPIUHVSXCWIIIOXCWIWPIBIMUKVBSUMUNUOUPAWGHBIAXAWQWGHRXCVPEUSBIVQVOVRVTWMW
      AWBWC $.
  $}

  ${
    $d j k A $.  $d j k N $.
    $( The value of the finite geometric series ` 2 ^ -u 1 + 2 ^ -u 2 + ` ...
       ` + 2 ^ -u N ` , multiplied by a constant.  (Contributed by Mario
       Carneiro, 17-Mar-2014.)  (Revised by Mario Carneiro, 26-Apr-2014.) $)
    geo2sum $p |- ( ( N e. NN /\ A e. CC ) ->
                    sum_ k e. ( 1 ... N ) ( A / ( 2 ^ k ) ) =
                                 ( A - ( A / ( 2 ^ N ) ) ) ) $=
      ( vj cn wcel cc c1 cfz co cexp cdiv csu cmin cc0 cmul a1i adantl sylancr
      c2 wa cv caddc cz 1z nnz adantr simplr cn0 2nn elfznn nnnn0d nncnd nnne0d
      nnexpcl divcld wceq oveq2 oveq2d fsumshftm 1m1e0 sumeq1i cr nnrecre ax-mp
      oveq1i recni elfznn0 expcl 2cn wne divrecd expp1 elfzelz peano2zd exprecd
      2ne0 3eqtr2rd peano2nn0 syl div12d sumeq2dv fzfid halfcl fsummulc1 eqtr4d
      3eqtr4d syl5eq 1mhlfehlf simpr divrec2d ax-1cn nnnn0 nnrecred recnd subcl
      oveq12d 0re halfgt0 gtneii mulassd divcan1d oveq1d 3eqtr2d halflt1 ltneii
      geoser mulid2 eqcomd subdird 3eqtrd ) CEFZAGFZUAZHCIJZATBUBZKJZLJZBMHHNJZ
      CHNJZIJZATDUBZHUCJZKJZLJZDMZOXTIJZHTLJZYBKJZDMZATLJZPJZAATCKJZLJZNJZXNXRY
      EBDHHCHUDFXNUEQZYPXLCUDFXMCUFUGZXNXPXOFZUAZAXQXLXMYRUHYSXQYSTEFZXPUIFXQEF
      UJYSXPYRXPEFXNXPCUKRULTXPUOSZUMYSXQUUAUNUPXPYCUQXQYDALXPYCTKURUSUTXNYFYGY
      EDMZYLYAYGYEDXSOXTIVAVFVBXNUUBYGYIYKPJZDMYLXNYGYEUUCDXNYBYGFZUAZAHYDLJZPJ
      AYITLJZPJYEUUCUUEUUFUUGAPUUEUUGYIYHPJZYHYCKJZUUFUUEYITUUEYHGFZYBUIFZYIGFY
      HYTYHVCFUJTVDVEZVGZUUDUUKXNYBXTVHRZYHYBVISZTGFZUUEVJQZTOVKZUUEVQQZVLUUEUU
      JUUKUUIUUHUQUUMUUNYHYBVMSUUETYCUUQUUSUUDYCUDFXNUUDYBYBOXTVNVORVPVRUSUUEAY
      DXLXMUUDUHZUUEYDUUEYTYCUIFZYDEFUJUUEUUKUVAUUNYBVSVTTYCUOSZUMUUEYDUVBUNVLU
      UEYIATUUOUUTUUQUUSWAWGWBXNYGYIYKDXNOXTWCXMYKGFXLAWDRUUOWEWFWHXNHYHCKJZNJZ
      HYHNJZLJZYKPJZHHYMLJZNJZAPJZYLYOXNUVGUVIYHLJZYHAPJZPJUVKYHPJZAPJUVJXNUVFU
      VKYKUVLPXNUVDUVIUVEYHLXNUVCUVHHNXNTCUUPXNVJQZUURXNVQQZYQVPUSUVEYHUQXNWIQW
      QXNATXLXMWJZUVNUVOWKWQXNUVKYHAXNUVIYHXNHGFZUVHGFUVIGFWLXNUVHXNYMXNYTCUIFZ
      YMEFUJXLUVRXMCWMUGZTCUOSZWNWOZHUVHWPSZUUJXNUUMQZYHOVKXNOYHWRWSWTQZUPUWCUV
      PXAXNUVMUVIAPXNUVIYHUWBUWCUWDXBXCXDXNYJUVFYKPXNYHDCUWCYHHVKXNYHHUULXEXFQU
      VSXGXCXNYOHAPJZUVHAPJZNJUVJXNAUWEYNUWFNXNUWEAXMUWEAUQXLAXHRXIXNAYMUVPXNYM
      UVTUMXNYMUVTUNWKWQXNHUVHAUVQXNWLQUWAUVPXJWFWGXK $.
  $}

  ${
    $d j k A $.  $d j k N $.
    $( The value of the finite geometric series ` 1 + 2 + 4 + 8 + ` ...
       ` + 2 ^ ( N - 1 ) ` .  (Contributed by Mario Carneiro, 7-Sep-2016.) $)
    geo2sum2 $p |- ( N e. NN0 ->
                    sum_ k e. ( 0 ..^ N ) ( 2 ^ k ) = ( ( 2 ^ N ) - 1 ) ) $=
      ( cn0 wcel cc0 cfzo co c2 cexp csu cmin cdiv wceq 2cn a1i wne cneg ax-1cn
      c1 cc cv cfz cz nn0z fzoval syl sumeq1d 1ne2 necomi geoser expcld ax-1ne0
      subcld div2negd negsubdi2d 2m1e1 negeqi negsubdi2i eqtr3i oveq12d 3eqtr3d
      id div1d 3eqtrd ) BCDZEBFGZHAUAIGZAJEBSKGUBGZVGAJSHBIGZKGZSHKGZLGZVISKGZV
      EVFVHVGAVEBUCDVFVHMBUDEBUEUFUGVEHABHTDVENOZHSPVESHUHUIOVEVBZUJVEVMQZSQZLG
      VMSLGVLVMVEVMSVEVISVEHBVNVOUKZSTDVEROZUMZVSSEPVEULOUNVEVPVJVQVKLVEVISVRVS
      UOVQVKMVEHSKGZQVQVKWASUPUQHSNRURUSOUTVEVMVTVCVAVD $.
  $}

  ${
    $d j k n A $.  $d j n F $.
    geo2lim.1 $e |- F = ( k e. NN |-> ( A / ( 2 ^ k ) ) ) $.
    $( The value of the infinite geometric series
       ` 2 ^ -u 1 + 2 ^ -u 2 + ` ... , multiplied by a constant.  (Contributed
       by Mario Carneiro, 15-Jun-2014.) $)
    geo2lim $p |- ( A e. CC -> seq 1 ( + , F ) ~~> A ) $=
      ( vn cc wcel c1 cc0 cmin co cvv cn a1i cmul c2 cdiv cexp cfv wceq vj cseq
      caddc cli nnuz cz 1z cn0 cv cmpt 1re rehalfcli recni cabs clt wbr cle 0re
      cr halfgt0 ltleii absid mp2an halflt1 eqbrtri id nnex mptex eqeltri nnnn0
      expcnv wa adantl oveq2 eqid ovex fvmpt syl nnz wne 2cn 2ne0 mp3an12 eqtrd
      exprec nnexpcl sylancr nnrecred recnd eqeltrd simpl nnne0d divrecd oveq2d
      2nn nncnd 3eqtr4d climmulc2 mul01 breqtrd seqex divcld cfz geo2sum ancoms
      csu elfznn cuz simpr syl6eleq simpll fsumser 3eqtr2rd climsubc2 subid1 )
      AFGZUCCHUBZAIJKAUDXPIAUACXQHLMUEHUFGXPUGNZXPCAIOKIUDXPIAUABUHHPQKZBUIZRKZ
      UJZCHLMUEXRXPXSBXSFGXPXSHUKULZUMNXSUNSZHUOUPXPYDXSHUOXSUSGIXSUQUPYDXSTYCI
      XSURYCUTVAXSVBVCVDVENVKXPVFZCLGXPCBMAPXTRKZQKZUJLDBMYGVGVHVINXPUAUIZMGZVL
      ZYHYBSZHPYHRKZQKZFYJYKXSYHRKZYMYJYHUHGZYKYNTYIYOXPYHVJVMZBYHYAYNUHYBXTYHX
      SRVNYBVOXSYHRVPVQVRYJYHUFGZYNYMTZYIYQXPYHVSVMPFGPIVTYQYRWAWBPYHWEWCVRWDZY
      JYMYJYLYJPMGZYOYLMGWOYPPYHWFWGZWHWIWJYJAYLQKZAYMOKYHCSZAYKOKYJAYLXPYIWKZY
      JYLUUAWPZYJYLUUAWLZWMYIUUCUUBTXPBYHYGUUBMCXTYHTYFYLAQXTYHPRVNWNDAYLQVPVQV
      MZYJYKYMAOYSWNWQWRAWSWTYEXQLGXPUCCHXANYJUUCUUBFUUGYJAYLUUDUUEUUFXBWJYJAUU
      CJKAUUBJKZHYHXCKZAPEUIZRKZQKZEXFZYHXQSYJUUCUUBAJUUGWNYIXPUUMUUHTAEYHXDXEY
      JUULECHYHYJUUJUUIGZVLZUUJMGZUUJCSUULTUUNUUPYJUUJYHXGVMZBUUJYGUULMCXTUUJTY
      FUUKAQXTUUJPRVNWNDAUUKQVPVQVRYJYHMHXHSXPYIXIUEXJUUOAUUKXPYIUUNXKUUOUUKUUO
      UUPUUKMGZUUQUUPYTUUJUHGUURWOUUJVJPUUJWFWGVRZWPUUOUUKUUSWLXBXLXMXNAXOWT $.
  $}

  ${
    $d k m n A $.  $d m n F $.
    geomulcvg.1 $e |- F = ( k e. NN0 |-> ( k x. ( A ^ k ) ) ) $.
    $( The geometric series converges even if it is multiplied by ` k ` to
       result in the larger series ` k x. A ^ k ` .  (Contributed by Mario
       Carneiro, 27-Mar-2015.) $)
    geomulcvg $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
      seq 0 ( + , F ) e. dom ~~> ) $=
      ( cc wcel cabs cfv c1 clt wbr wa cc0 cn0 cexp co cmul adantl cr adantr vn
      vm caddc cseq cli cdm wceq cuz csn cxp cmpt cv cn elnn0 simpr oveq1d 0exp
      wo sylan9eq oveq2d nncn mul01d simplll 0nn0 syl6eqel expcld mul02d jaodan
      eqtrd sylan2b mpteq2dva syl5eq fconstmpt nn0uz xpeq1i eqtr3i syl6eq cz 0z
      seqeq3d serclim0 ax-mp syl6eqbr c0ex breldm syl wne c2 cdiv wral wrex 1re
      seqex a1i abscl peano2re rehalfcld crp absrpcl adantlr rerpdivcld mulid2d
      recnd wb sylancl mpbid eqbrtrd ltmuldivd expmulnbnd syl3anc eluznn0 nn0cn
      avglt1 ad2antrr rpne0d expdivd breq12d nn0re reexpcl nn0z rpgt0d ltmuldiv
      sylan expgt0 syl112anc bitr4d sylan2 anassrs ralbidva wi oveq2 ovex fvmpt
      reexpcld eqeltrd oveq12d cle ltled absidd 3brtr4d simprl id simpll mulcld
      eqid expcl 0re absge0 lelttrd avglt2 geolim nn0red abscld remulcld syldan
      cmin simprr rspccva nn0cnd absmuld nn0ge0d absexpd fveq2d cvgcmpce sylbid
      expr rexlimdva mpd pm2.61dane ) AEFZAGHZIJKZLZUCCMUDZUEUFZFZAMUVMAMUGZLZU
      VNMUEKUVPUVRUVNUCMUHHZMUIZUJZMUDZMUEUVRCUWAUCMUVRCBNMUKZUWAUVRCBNBULZAUWD
      OPZQPZUKUWCDUVRBNUWFMUWDNFZUVRUWDUMFZUWDMUGZURUWFMUGZUWDUNUVRUWHUWJUWIUVR
      UWHLZUWFUWDMQPMUWKUWEMUWDQUVRUWHUWEMUWDOPMUVRAMUWDOUVMUVQUOUPUWDUQUSUTUWK
      UWDUWHUWDEFZUVRUWDVARVBVIUVRUWILZUWFMUWEQPMUWMUWDMUWEQUVRUWIUOZUPUWMUWEUW
      MAUWDUVJUVLUVQUWIVCUWMUWDMNUWNVDVEVFVGVIVHVJVKVLNUVTUJUWCUWABNMVMNUVSUVTV
      NVOVPVQVTMVRFUWBMUEKVSMWAWBWCUVNMUEUCCMWMWDWEWFUVMAMWGZLZIUWDQPZUVKIUCPZW
      HWIPZUVKWIPZUWDOPZJKZBUAULZUHHZWJZUANWKZUVPUWPISFZUWTSFIUWTJKZUXFUXGUWPWL
      WNZUWPUWSUVKUVMUWSSFZUWOUVMUWRUVMUVKSFZUWRSFUVJUXKUVLAWOTZUVKWPWFWQZTZUVJ
      UWOUVKWRFZUVLAWSWTZXAUWPIUVKQPZUWSJKZUXHUVMUXRUWOUVMUXQUVKUWSJUVMUVKUVMUV
      KUXLXCZXBUVMUVLUVKUWSJKZUVJUVLUOZUVMUXKUXGUVLUXTXDUXLWLUVKIXMXEXFZXGTUWPI
      UWSUVKUXIUXNUXPXHXFIUWTUABXIXJUWPUXEUVPUANUWPUXCNFZLZUXEUWDUVKUWDOPZQPZUW
      SUWDOPZJKZBUXDWJZUVPUYDUXBUYHBUXDUWPUYCUWDUXDFZUXBUYHXDZUYCUYJLUWPUWGUYKU
      WDUXCXKUWPUWGLZUXBUWDUYGUYEWIPZJKZUYHUYLUWQUWDUXAUYMJUYLUWDUWGUWLUWPUWDXL
      RXBUYLUWSUVKUWDUVMUWSEFUWOUWGUVMUWSUXMXCZXNUVMUVKEFUWOUWGUXSXNUYLUVKUWPUX
      OUWGUXPTZXOUWPUWGUOXPXQUYLUWDSFZUYGSFZUYESFZMUYEJKZUYHUYNXDUWGUYQUWPUWDXR
      RUWPUXJUWGUYRUXNUWSUWDXSYCUWPUXKUWGUYSUVMUXKUWOUXLTZUVKUWDXSYCUYLUXKUWDVR
      FZMUVKJKUYTUWPUXKUWGVUATUWGVUBUWPUWDXTRUYLUVKUYPYAUVKUWDYDXJUWDUYGUYEYBYE
      YFYGYHYIUVMUYCUYIUVPYJUWOUVMUYCUYIUVPUVMUYCUYILZLZIUBBNUYGUKZCMUXCNVNUVMU
      YCUYIUUAZVUDUBULZNFZLZVUGVUEHZUWSVUGOPZSVUHVUJVUKUGZVUDBVUGUYGVUKNVUEUWDV
      UGUWSOYKZVUEUUEZUWSVUGOYLYMZRVUIUWSVUGUVMUXJVUCVUHUXMXNVUDVUHUOYNZYOVUIVU
      GCHZVUGAVUGOPZQPZEVUHVUQVUSUGZVUDBVUGUWFVUSNCUWDVUGUGZUWDVUGUWEVURQVVAUUB
      ZUWDVUGAOYKYPDVUGVURQYLYMZRVUIVUGVURVUHVUGEFVUDVUGXLRVUDUVJVUHVUREFUVJUVL
      VUCUUCAVUGUUFYCUUDYOUVMUCVUEMUDZUVOFZVUCUVMVVDIIUWSUUPPZWIPZUEKVVEUVMUWSU
      AVUEUYOUVMUWSGHUWSIJUVMUWSUXMUVMMUWSMSFUVMUUGWNZUXMUVMMUVKUWSVVHUXLUXMUVJ
      MUVKYQKUVLAUUHTUYBUUIYRYSUVMUVLUWSIJKZUYAUVMUXKUXGUVLVVIXDUXLWLUVKIUUJXEX
      FXGUYCUXCVUEHUWSUXCOPZUGUVMBUXCUYGVVJNVUEUWDUXCUWSOYKVUNUWSUXCOYLYMRUUKVV
      DVVGUEUCVUEMWMIVVFWIYLWEWFTUXGVUDWLWNVUDVUGUXDFZLZVUSGHZIVUKQPZVUQGHIVUJQ
      PYQVVLVUGUVKVUGOPZQPZVUKVVMVVNYQVVLVVPVUKVVLVUGVVOVVLVUGVUDUYCVVKVUHVUFVU
      GUXCXKYCZUULZVVLUVKVUGVVLAUVJUVLVUCVVKVCZUUMVVQYNUUNVUDVVKVUHVUKSFVVQVUPU
      UOZVUDUYIVVKVVPVUKJKZUVMUYCUYIUUQUYHVWABVUGUXDVVAUYFVVPUYGVUKJVVAUWDVUGUY
      EVVOQVVBUWDVUGUVKOYKYPVUMXQUURYCYRVVLVVMVUGGHZVURGHZQPVVPVVLVUGVURVVLVUGV
      VQUUSVVLAVUGVVSVVQVFUUTVVLVWBVUGVWCVVOQVVLVUGVVRVVLVUGVVQUVAYSVVLAVUGVVSV
      VQUVBYPVIVVLVUKVVLVUKVVTXCXBYTVVLVUQVUSGVVLVUHVUTVVQVVCWFUVCVVLVUJVUKIQVV
      LVUHVULVVQVUOWFUTYTUVDUVFWTUVEUVGUVHUVI $.
  $}

  ${
    $d k n A $.  $d k n R $.
    $( The infinite sum of ` 1 + A ^ 1 + A ^ 2 ` ... is
       ` ( 1 / ( 1 - A ) ) ` .  (Contributed by NM, 15-May-2006.)  (Revised by
       Mario Carneiro, 26-Apr-2014.) $)
    geoisum $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
                  sum_ k e. NN0 ( A ^ k ) = ( 1 / ( 1 - A ) ) ) $=
      ( vn cc wcel cabs cfv c1 clt wbr wa cv cexp cmin cdiv cn0 cmpt cc0 nn0uz
      co cz 0z a1i wceq oveq2 eqid ovex fvmpt adantl expcl adantlr simpl geolim
      simpr isumclim ) ADEZAFGHIJZKZABLZMTZHHANTOTBCPACLZMTZQZRPSRUAEURUBUCUSPE
      ZUSVCGUTUDURCUSVBUTPVCVAUSAMUEVCUFAUSMUGUHUIZUPVDUTDEUQAUSUJUKURABVCUPUQU
      LUPUQUNVEUMUO $.

    $( The infinite sum of reciprocals
       ` 1 + ( 1 / A ) ^ 1 + ( 1 / A ) ^ 2 ` ... is ` A / ( A - 1 ) ` .
       (Contributed by rpenner, 3-Nov-2007.)  (Revised by Mario Carneiro,
       26-Apr-2014.) $)
    geoisumr $p |- ( ( A e. CC /\ 1 < ( abs ` A ) ) ->
              sum_ k e. NN0 ( ( 1 / A ) ^ k ) = ( A / ( A - 1 ) ) ) $=
      ( vn cc wcel c1 cabs cfv clt wbr wa cdiv co cexp cmin cn0 cmpt cc0 wceq
      cv nn0uz cz 0z a1i oveq2 eqid ovex fvmpt adantl wne cle wn 0re 1re lenlti
      0le1 mpbi fveq2 abs0 syl6eq breq2d necon2ai reccl expcl sylan simpl simpr
      mtbiri sylan2 georeclim isumclim ) ADEZFAGHZIJZKZFALMZBTZNMZAAFOMLMBCPVPC
      TZNMZQZRPUARUBEVOUCUDVQPEZVQWAHVRSVOCVQVTVRPWAVSVQVPNUEWAUFVPVQNUGUHUIZVO
      VPDEZWBVRDEVNVLARUJWDVNARARSZVNFRIJZRFUKJWFULUPRFUMUNUOUQWEVMRFIWEVMRGHRA
      RGURUSUTVAVHVBAVCVIVPVQVDVEVOABWAVLVNVFVLVNVGWCVJVK $.

    $( The infinite sum of ` A ^ 1 + A ^ 2 ` ... is ` ( A / ( 1 - A ) ) ` .
       (Contributed by NM, 1-Nov-2007.)  (Revised by Mario Carneiro,
       26-Apr-2014.) $)
    geoisum1 $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
                  sum_ k e. NN ( A ^ k ) = ( A / ( 1 - A ) ) ) $=
      ( vn cc wcel cabs cfv c1 clt wbr wa cn cv cexp co csu cdiv a1i wceq cn0
      cmin cmpt nnuz cz 1z oveq2 eqid ovex fvmpt adantl simpl nnnn0 expcl simpr
      syl2an 1nn0 cuz elnnuz sylan2br geolim2 isumclim exp1 adantr oveq1d eqtrd
      ) ADEZAFGHIJZKZLABMZNOZBPAHNOZHAUAOZQOZAVLQOVHVJVMBCLACMZNOZUBZHLUCHUDEVH
      UERVILEZVIVPGVJSZVHCVIVOVJLVPVNVIANUFVPUGAVINUHUIUJZVHVFVITEVJDEVQVFVGUKZ
      VIULAVIUMUOVHABVPHVTVFVGUNHTEVHUPRVIHUQGEVHVQVRVIURVSUSUTVAVHVKAVLQVFVKAS
      VGAVBVCVDVE $.

    $( The infinite sum of ` A x. ( R ^ 1 ) + A x. ( R ^ 2 ) ` ... is
       ` ( A x. R ) / ( 1 - R ) ` .  (Contributed by NM, 2-Nov-2007.)  (Revised
       by Mario Carneiro, 26-Apr-2014.) $)
    geoisum1c $p |- ( ( A e. CC /\ R e. CC /\ ( abs ` R ) < 1 ) ->
          sum_ k e. NN ( A x. ( R ^ k ) ) = ( ( A x. R ) / ( 1 - R ) ) ) $=
      ( vn cc wcel cabs cfv c1 clt wbr cmul co cdiv cn cv cexp csu wceq cli w3a
      cmin simp1 simp2 subcl sylancr cc0 wne simp3 1re ltnri abs1 fveq2 syl5eqr
      ax-1cn breq1d mtbii necon2ai syl subeq0 necon3bid mpbird divassd geoisum1
      wb wa 3adant1 oveq2d cmpt nnuz cz 1z a1i oveq2 eqid ovex fvmpt adantl cn0
      nnnn0 expcl syl2an caddc cseq cdm 1nn0 cuz elnnuz sylan2br geolim2 breldm
      seqex isummulc2 3eqtr2rd ) AEFZBEFZBGHZIJKZUAZABLMIBUBMZNMABWTNMZLMAOBCPZ
      QMZCRZLMOAXCLMCRWSABWTWOWPWRUCZWOWPWRUDZWSIEFZWPWTEFUOXFIBUEUFWSWTUGUHZIB
      UHZWSWRXIWOWPWRUIZWRIBIBSZIIJKWRIUJUKXKIWQIJXKIIGHWQULIBGUMUNUPUQURUSWSXG
      WPXHXIVEUOXFXGWPVFWTUGIBIBUTVAUFVBVCWSXDXAALWPWRXDXASWOBCVDVGVHWSXCACDOBD
      PZQMZVIZIOVJIVKFWSVLVMXBOFZXBXNHXCSZWSDXBXMXCOXNXLXBBQVNXNVOBXBQVPVQVRZWS
      WPXBVSFXCEFXOXFXBVTBXBWAWBWSWCXNIWDZBIQMZWTNMZTKXRTWEFWSBCXNIXFXJIVSFWSWF
      VMXBIWGHFWSXOXPXBWHXQWIWJXRXTTWCXNIWLXSWTNVPWKUSXEWMWN $.
  $}

  $( The recurring decimal 0.999..., which is defined as the infinite sum 0.9 +
     0.09 + 0.009 + ... i.e. ` 9 / 10 ^ 1 + 9 / 10 ^ 2 + 9 / 10 ^ 3 + ... ` ,
     is exactly equal to 1, according to ZF set theory.  Interestingly, about
     40% of the people responding to a poll at
     ~ http://forum.physorg.com/index.php?showtopic=13177 disagree.
     (Contributed by NM, 2-Nov-2007.) $)
  0.999... $p |- sum_ k e. NN ( 9 / ( 10 ^ k ) ) = 1 $=
    ( cn c9 c10 co cdiv c1 cmul wcel cc0 wceq 10re recni 10pos 9re cmin clt wbr
    cc ax-1cn cv cexp csu wne cn0 nnnn0 sylancr a1i gt0ne0ii nnz expne0d divrec
    mp3an1 syl2anc exprecd oveq2d eqtr4d sumeq2i cabs cfv rereccli cle recgt0ii
    expcl 0re ltleii absidi ax-mp 1lt10 cr wb recgt1 mp2an mpbi geoisum1c mp3an
    eqbrtri divreci divcan2i subdii mulid1i recidi oveq12i caddc addcomi eqtr4i
    df-10 subaddrii 3eqtrri eqtri redivcli subcli mulcani 9pos divgt0ii 3eqtr2i
    dividi ) BCDAUAZUBEZFEZAUCBCGDFEZWRUBEZHEZAUCZGBWTXCAWRBIZWTCGWSFEZHEZXCXEW
    SSIZWSJUDZWTXGKZXEDSIZWRUEIXHDLMZWRUFDWRVDUGXEDWRXKXEXLUHZDJUDXEDLNUIZUHZWR
    UJZUKCSIZXHXIXJCOMZCWSULUMUNXEXBXFCHXEDWRXMXOXPUOUPUQURXDCXAHEZGXAPEZFEZCDF
    EZYBFEGXQXASIXAUSUTZGQRXDYAKXRXADLXNVAZMZYCXAGQJXAVBRYCXAKJXAVEYDDLNVCVFXAY
    DVGVHGDQRZXAGQRZVIDVJIJDQRYFYGVKLNDVLVMVNVQCXAAVOVPYBXSYBXTFCDXRXLXNVRDYBHE
    ZDXTHEZKYBXTKYHCYICDXRXLXNVSYIDGHEZDXAHEZPEDGPECDGXAXLTYEVTYJDYKGPDXLWADXLX
    NWBWCDGCXLTXRGCWDECGWDEDGCTXRWEWGWFWHWIWJYBXTDYBCDOLXNWKZMZGXATYEWLXLXNWMVN
    WCYBYMYBYLCDOLWNNWOUIWQWPWJ $.

  $( Prove that the infinite geometric series of 1/2, 1/2 + 1/4 + 1/8 + ... =
     1.  Uses ~ geoisum1 .  This is a representation of .111... in binary with
     an infinite number of 1's.  Theorem ~ 0.999... proves a similar claim for
     .999... in base 10.  (Contributed by David A. Wheeler, 4-Jan-2017.) $)
  geoihalfsum $p |- sum_ k e. NN ( 1 / ( 2 ^ k ) ) = 1 $=
    ( cn c1 c2 cdiv co cexp csu wcel cc 2cn a1i cc0 2ne0 clt wbr wceq cle 2re
    cr cv wne nnz exprecd sumeq2i cmin cabs cfv reccli rereccli 0le1 1re ge0div
    wb 2pos mp3an absid mp2an halflt1 eqbrtri geoisum1 1mhlfehlf oveq2i ax-1ne0
    mpbi ax-1cn divne0i dividi 3eqtri eqtr3i ) BCDEFZAUAZGFZAHZBCDVLGFEFZAHCBVM
    VOAVLBIZDVLDJIVPKLDMUBVPNLVLUCUDUEVNVKCVKUFFZEFZVKVKEFCVKJIVKUGUHZCOPVNVRQD
    KNUIZVSVKCOVKTIMVKRPZVSVKQDSNUJMCRPZWAUKCTIDTIMDOPWBWAUNULSUOCDUMUPVEVKUQUR
    USUTVKAVAURVQVKVKEVBVCVKVTCDVFKVDNVGVHVIVJ $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ratio test for infinite series convergence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n A $.  $d k n F $.  $d k M $.  $d k n N $.  $d k n ph $.  $d k n W $.
    $d k n Z $.
    cvgrat.1 $e |- Z = ( ZZ>= ` M ) $.
    cvgrat.2 $e |- W = ( ZZ>= ` N ) $.
    cvgrat.3 $e |- ( ph -> A e. RR ) $.
    cvgrat.4 $e |- ( ph -> A < 1 ) $.
    cvgrat.5 $e |- ( ph -> N e. Z ) $.
    cvgrat.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    cvgrat.7 $e |- ( ( ph /\ k e. W ) ->
               ( abs ` ( F ` ( k + 1 ) ) ) <_ ( A x. ( abs ` ( F ` k ) ) ) ) $.
    $( Ratio test for convergence of a complex infinite series.  If the ratio
       ` A ` of the absolute values of successive terms in an infinite sequence
       ` F ` is less than 1 for all terms beyond some index ` B ` , then the
       infinite sum of the terms of ` F ` converges to a complex number.
       Equivalent to first part of Exercise 4 of [Gleason] p. 182.
       (Contributed by NM, 26-Apr-2005.)  (Proof shortened by Mario Carneiro,
       27-Apr-2014.) $)
    cvgrat $p |- ( ph -> seq M ( + , F ) e. dom ~~> ) $=
      ( wcel cle co cexp cmul caddc cseq cli cdm cfv cabs cc0 wbr cif cmin cmpt
      vn cv cuz cz syl6eleq eluzelz syl uzid syl6eleqr wa wceq weq oveq1 oveq2d
      cr eqid ovex fvmpt adantl 0re ifcl sylancr adantr simpr uznn0sub reexpcld
      cn0 eqeltrd cc wss uzss 3sstr4g sselda syldan cshi oveq2 zcnd nn0ex mptex
      shftval syl2an 3eqtr4rd seqfeq seqshft syl2anc subidd seqeq1d oveq1d cdiv
      3eqtrd recnd clt max2 sylancl absidd 0lt1 breq1 ifboth eqbrtrd geolim cvv
      c1 wb seqex climshft mpbird breldm wral ralrimiva fveq2 eleq1d rspcv sylc
      abscld wi fveq2d breq12d imbi2d leidd exp0d mulid1d breqtrrd a1i remulcld
      eqtrd w3a lemul2a ex syl112anc mul12d expp1d eleq2s ax-1cn addsub syl2anr
      mp3an2 mulcomd breq2d sylibd peano2uzs sylan2 cbvralv sylib max1 lemul1ad
      absge0d letrd peano2uz letr syl3anc mpand syld expcom a2d uzind4 cvgcmpce
      impcom iserex ) AUADEUBUCUDZPUADFUBUVJPAFDUEZUFUEZCULGBUGQUHZUGBUIZULUMZF
      UJRZSRZUKZDFFGJAFFUNUEZGAFUOPZFUVSPAFEUNUEZPZUVTAFHUWAMIUPZEFUQURZFUSURJU
      TACUMZGPZVAZUWEUVRUEZUVNUWEFUJRZSRZVFUWFUWHUWJVBZAULUWEUVQUWJGUVRULCVCZUV
      PUWIUVNSUVOUWEFUJVDVEZUVRVGUVNUWISVHZVIZVJUWGUVNUWIAUVNVFPZUWFAUGVFPZBVFP
      ZUWPVKKUVMUGBVFVLVMZVNZUWGUWEUVSPZUWIVRPZUWGUWEGUVSAUWFVOJUPZFUWEVPZURZVQ
      ZVSAUWFUWEHPUWEDUEZVTPZAGHUWEAUVSUWAGHAUWBUVSUWAWAUWCEFWBURJIWCZWDNWEZAUA
      UVRFUBZUAULVRUVNUVOSRZUKZUGUBZFWFRZUVJAUXKUAUXMFWFRZFUBZUAUXMFFUJRZUBZFWF
      RZUXOAUACUVRUXPFUWDAUXAVAZUWIUXMUEZUWJUWEUXPUEZUWHUYAUXBUYBUWJVBUXAUXBAUX
      DVJULUWIUXLUWJVRUXMUVOUWIUVNSWGUXMVGZUWNVIURAFVTPZUWEVTPZUYCUYBVBUXAAFUWD
      WHZUXAUWEFUWEUQWHZFUWEUXMULVRUXLWIWJZWKWLUYAUWFUWKUYAUWEUVSGAUXAVOJUTZUWO
      URZWMWNAUVTUVTUXQUXTVBUWDUWDUAUXMFFUYIWOWPAUXSUXNFWFAUXRUGUAUXMAFUYGWQZWR
      WSXAAUXOXMXMUVNUJRZWTRZUCUHZUXOUVJPAUYOUXNUYNUCUHZAUVNCUXMAUVNUWSXBZAUVNU
      FUEUVNXMXCAUVNUWSAUWRUWQUGUVNQUHZKVKBUGXDXEZXFAUGXMXCUHZBXMXCUHZUVNXMXCUH
      ZXGLUVMUYTVUAVUBUGBUGUVNXMXCXHBUVNXMXCXHXIVMXJUWEVRPUWEUXMUEUVNUWESRZVBAU
      LUWEUXLVUCVRUXMUVOUWEUVNSWGUYDUVNUWESVHVIVJXKAUVTUXNXLPUYOUYPXNUWDUAUXMUG
      XOUYNUXNFXLXPXEXQUXOUYNUCUXNFWFVHXMUYMWTVHXRURVSAUVKAFHPUXHCHXSZUVKVTPZMA
      UXHCHNXTZUXHVUECFHUWEFVBUXGUVKVTUWEFDYAYBYCYDYEZUYAUXGUFUEZUVLUWJTRZUVLUW
      HTRQUXAAVUHVUIQUHZAUVODUEZUFUEZUVLUVQTRZQUHZYFAUVLUVLUVNUXRSRZTRZQUHZYFZA
      VUJYFZAUWEXMUARZDUEZUFUEZUVLUVNVUTFUJRZSRZTRZQUHZYFVUSULCFUWEUVOFVBZVUNVU
      QAVVGVULUVLVUMVUPQVVGVUKUVKUFUVOFDYAYGVVGUVQVUOUVLTVVGUVPUXRUVNSUVOFFUJVD
      VEVEYHYIUWLVUNVUJAUWLVULVUHVUMVUIQUWLVUKUXGUFUVOUWEDYAYGUWLUVQUWJUVLTUWMV
      EYHYIZUVOVUTVBZVUNVVFAVVIVULVVBVUMVVEQVVIVUKVVAUFUVOVUTDYAZYGVVIUVQVVDUVL
      TVVIUVPVVCUVNSUVOVUTFUJVDVEVEYHYIVVHVURUVTAUVLUVLVUPQAUVLVUGYJAVUPUVLXMTR
      UVLAVUOXMUVLTAVUOUVNUGSRXMAUXRUGUVNSUYLVEAUVNUYQYKYPVEAUVLAUVLVUGXBZYLYPY
      MYNUXAAVUJVVFAUXAVUJVVFYFZAUXAUWFVVLUYJUWGVUJUVNVUHTRZVVEQUHZVVFUWGVUJVVM
      UVNVUITRZQUHZVVNUWGVUHVFPZVUIVFPZUWPUYRVUJVVPYFUWGUXGUXJYEZUWGUVLUWJAUVLV
      FPUWFVUGVNZUXFYOUWTAUYRUWFUYSVNVVQVVRUWPUYRVAYQVUJVVPVUHVUIUVNYRYSYTUWGVV
      OVVEVVMQUWGVVOUVLUVNUWJTRZTRVVEUWGUVNUVLUWJAUVNVTPUWFUYQVNZAUVLVTPUWFVVKV
      NUWGUWJUXFXBZUUAUWGVWAVVDUVLTUWGUVNUWIXMUARZSRUWJUVNTRVVDVWAUWGUVNUWIVWBU
      XEUUBUWGVVCVWDUVNSUWFUYFUYEVVCVWDVBZAUYFUWEUVSGUYHJUUCUYGUYFXMVTPUYEVWEUU
      DUWEXMFUUEUUGUUFVEUWGUVNUWJVWBVWCUUHWMVEYPUUIUUJUWGVVBVVMQUHZVVNVVFUWGVVB
      BVUHTRVVMUWGVVAUWGVUTHPZVUKVTPZULHXSZVVAVTPZUWFAVUTGPVWGFUWEGJUUKAGHVUTUX
      IWDUULAVWIUWFAVUDVWIVUFUXHVWHCULHCULVCUXGVUKVTUWEUVODYAYBUUMUUNVNVWHVWJUL
      VUTHVVIVUKVVAVTVVJYBYCYDYEZUWGBVUHAUWRUWFKVNZVVSYOUWGUVNVUHUWTVVSYOZOUWGB
      UVNVUHVWLUWTVVSUWGUXGUXJUUQABUVNQUHZUWFAUWRUWQVWNKVKBUGUUOXEVNUUPUURUWGVV
      BVFPVVMVFPVVEVFPVWFVVNVAVVFYFVWKVWMUWGUVLVVDVVTUWGUVNVVCUWTUWGVUTUVSPZVVC
      VRPUWGUXAVWOUXCFUWEUUSURFVUTVPURVQYOVVBVVMVVEUUTUVAUVBUVCWEUVDUVEUVFUVHUY
      AUWHUWJUVLTUYKVEYMUVGACDEFHIMNUVIXQ $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Mertens' theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j m n s t x y z B $.  $d i j k l m n s u y z G $.  $d j k m x y z ph $.
    $d k m n s t y A $.  $d j k m n s t y z E $.  $d i j k m n s t u y z K $.
    $d j m n u x y F $.  $d j k m n t y z ps $.  $d j k m n t w y z T $.
    $d k m x y H $.
    mertens.1 $e |- ( ( ph /\ j e. NN0 ) -> ( F ` j ) = A ) $.
    mertens.2 $e |- ( ( ph /\ j e. NN0 ) -> ( K ` j ) = ( abs ` A ) ) $.
    mertens.3 $e |- ( ( ph /\ j e. NN0 ) -> A e. CC ) $.
    mertens.4 $e |- ( ( ph /\ k e. NN0 ) -> ( G ` k ) = B ) $.
    mertens.5 $e |- ( ( ph /\ k e. NN0 ) -> B e. CC ) $.
    mertens.6 $e |- ( ( ph /\ k e. NN0 ) -> ( H ` k ) =
                      sum_ j e. ( 0 ... k ) ( A x. ( G ` ( k - j ) ) ) ) $.
    mertens.7 $e |- ( ph -> seq 0 ( + , K ) e. dom ~~> ) $.
    mertens.8 $e |- ( ph -> seq 0 ( + , G ) e. dom ~~> ) $.
    ${
      mertens.9 $e |- ( ph -> E e. RR+ ) $.
      mertens.10 $e |- T = { z | E. n e. ( 0 ... ( s - 1 ) ) z =
                        ( abs ` sum_ k e. ( ZZ>= ` ( n + 1 ) ) ( G ` k ) ) } $.
      mertens.11 $e |- ( ps <-> ( s e. NN /\ A. n e. ( ZZ>= ` s )
        ( abs ` sum_ k e. ( ZZ>= ` ( n + 1 ) ) ( G ` k ) ) <
          ( ( E / 2 ) / ( sum_ j e. NN0 ( K ` j ) + 1 ) ) ) ) $.
      ${
        mertens.12 $e |- ( ph -> ( ps /\ ( t e. NN0 /\ A. m e. ( ZZ>= ` t )
       ( K ` m ) < ( ( ( E / 2 ) / s ) / ( sup ( T , RR , < ) + 1 ) ) ) ) ) $.
        mertens.13 $e |- ( ph -> ( 0 <_ sup ( T , RR , < ) /\
          ( T C_ RR /\ T =/= (/) /\ E. z e. RR A. w e. T w <_ z ) ) ) $.
        $( Lemma for ~ mertens .  (Contributed by Mario Carneiro,
           29-Apr-2014.) $)
        mertenslem1 $p |- ( ph ->
        E. y e. NN0 A. m e. ( ZZ>= ` y ) ( abs ` sum_ j e. ( 0 ... m ) ( A x.
            sum_ k e. ( ZZ>= ` ( ( m - j ) + 1 ) ) B ) ) < E ) $=
          ( cv caddc co cn0 wcel cc0 cfz cmin c1 cuz cfv csu cmul cabs clt wral
          wbr wrex cdiv wa cr simpld simprd fzfid cc elfznn0 syl2an eqid adantl
          peano2nn0 nn0zd wceq simplll sylan syl2anc cseq ad2antrr nn0uz simpll
          syl eqeltrd mpbid isumcl abscld fsumrecl rpred adantr wss cle cz zred
          nn0red wb syl6eleq elfzelz eluz mpbird sselda remulcld syldan crp a1i
          absge0d breqtrrd ge0p1rpd rerpdivcld rpdivcld jca fveq2d breq1d rspcv
          0z sumeq2dv eqbrtrrd ltled recnd rpcnd wne fveq2 oveq2i adantlr ltp1d
          sylc lelttrd syl3anc zcnd cen oveq1d cn c2 csup sylib nn0addcld simpl
          nnnn0d fznn0sub eluznn0 cli cdm iserex mulcld fsumabs nn0ge0d eluzelz
          fsumcl subge02d nnzd uzid uzaddcl uztrn2 elfzuzb sylanbrc fzss2 fzss1
          fznn0sub2 rphalfcld isumrecl isumge0 ad2antlr elfzle2 zsubcld sumeq1d
          lesubd lemul2a syl31anc fsumle peano2re rpne0d divassd cbvsumv oveq1i
          eqidd oveq1 syl5eqel fsummulc1 sumeq2i eqtrd isumless rpregt0d ltmul1
          3eqtr3g ssriv ltdivmul c0 w3a suprcl nnrpd elfzuz leaddsub2d peano2uz
          eluzle uztrn syl2anr ax-1cn subsubd subled elfz5 eqcomd eqeq2d rspcev
          peano2zm elfzle1 eqbrtrd fvex eqeq1 rexbidv sylibr suprub wi lemul12a
          elab2 syl22anc mp2and chash cfn fsumconst fzen addcom sylancr pncan3d
          1z oveq12d breqtrd hashen hashfz1 eqtr3d rpcnne0d div23 divass nnne0d
          divcan2d mulassd 3eqtr2rd ltmul2dd ltdivmul2d lt2addd absmuld cin cun
          3eqtrd fzdisj fzsplit fsumsplit 2halvesd 3brtr3d ralrimiva raleqdv
          eqtr2d ) ASUMZFUMZUNUOZUPUQURLUMZUSUOZGVVDJUMZUTUOZVAUNUOZVBVCZHKVDZV
          EUOZJVDZVFVCZNVGVIZLVVCVBVCZVHZVVNLCUMZVBVCZVHZCUPVJAVVAVVBAVVAAVVAUU
          AUQZMUMZVAUNUOZVBVCZKUMZPVCZKVDZVFVCZNUUBVKUOZUPVVFRVCZJVDZVAUNUOZVKU
          OZVGVIZMVVAVBVCZVHZABVVTVWOVLABVVBUPUQZVVDRVCZVWHVVAVKUOZIVMVGUUCZVAU
          NUOZVKUOZVGVIZLVVBVBVCZVHZVLZUKVNUJUUDZVNZUUGZAVWPVXDABVXEUKVOZVNZUUE
          AVVNLVVOAVVDVVOUQZVLZVVMVVEVVKVFVCZJVDZNVXLVVLVXLVVEVVKJVXLURVVDVPZVX
          LVVFVVEUQZVLZGVVJVXLAVVFUPUQZGVQUQVXPAVXKUUFZVVFVVDVRZUBVSZVXQHKPVVHV
          VIVVIVTZVXQVVHVXQVVGUPUQZVVHUPUQZVXPVYCVXLVVFURVVDUUHZWAVVGWBWLZWCZVX
          QVWDVVIUQZVLZAVWDUPUQZVWEHWDZAVXKVXPVYHWEZVXQVYDVYHVYJVYFVWDVVHUUIZWF
          ZUCWGVYIAVYJHVQUQZVYLVYNUDWGVXQUNPURWHUUJUUKZUQZUNPVVHWHVYPUQZAVYQVXK
          VXPUGWIVXQKPURVVHUPWJVYFVXQAVYJVWEVQUQAVXKVXPWKAVYJVLVWEHVQUCUDWMWFUU
          LWNZWOZUUMZUUQWPVXLVVEVXMJVXOVXQVVKWUAWPWQANVMUQVXKANUHWRWSVXLVVEVVKJ
          VXOWUAUUNVXLURVVDVVAUTUOZUSUOZGVFVCZVVJVFVCZVEUOZJVDZWUBVAUNUOZVVDUSU
          OZWUFJVDZUNUOZVWHVWHUNUOVXNNVGVXLWUGWUJVWHVWHVXLWUCWUFJVXLURWUBVPZVXL
          VVFWUCUQZVXPWUFVMUQZVXLWUCVVEVVFVXLVVDWUBVBVCUQZWUCVVEWTVXLWUOWUBVVDX
          AVIZVXLURVVAXAVIWUPVXLVVAAVVAUPUQZVXKVXHWSZUUOVXLVVDVVAVXLVVDVXKVVDXB
          UQZAVVCVVDUUPZWAZXCZVXLVVAWURXDZUURWNVXLWUBXBUQZWUSWUOWUPXEVXLWUBVVEU
          QZWVDVXLVVAVVEUQZWVEVXLVVAURVBVCZUQVVDVWNUQZWVFVXLVVAUPWVGWURWJXFAVVC
          VWNUQZVXKWVHAVVAVWNUQZVWPWVIAVVAXBUQZWVJAVVAVXGUUSZVVAUUTWLVXJVVBVVAV
          VAUVAWGVVAVVDVVCVWNVWNVTUVBWFVVAURVVDUVCUVDVVAVVDUVGWLZWUBURVVDXGWLZW
          VAWUBVVDXHWGXIWUBURVVDUVEWLXJZVXQWUDWUEVXLAVXRWUDVMUQZVXPVXSVXTAVXRVL
          ZGUBWPZVSVXQVVJVYTWPZXKZXLZWQZVXLWUIWUFJVXLWUHVVDVPZVXLVVFWUIUQZVXPWU
          NVXLWUIVVEVVFVXLWUHWVGUQWUIVVEWTVXLWUHUPWVGVXLWUBUPUQZWUHUPUQVXLWVEWW
          EWVMWUBVVDVRWLWUBWBWLWJXFWUHURVVDUVFWLXJZWVTXLZWQZAVWHVMUQZVXKAVWHANU
          HUVHZWRZWSZWWLVXLWUGWUCWUDJVDZVWHVEUOZVWKVKUOZVWHWWBVXLWWNVWKVXLWWMVW
          HVXLWUCWUDJWULVXLAVXRWVPWUMVXSVVFWUBVRZWVRVSZWQZWWLXKZAVWKXMUQVXKAVWJ
          AVWIJRURUPWJURXBUQZAYDXNZWVQVWIUWDZWVQVWIWUDVMUAWVRWMZUFUVIZAVWIJRURU
          PWJWXAWXBWXCUFWVQURWUDVWIXAWVQGUBXOZUAXPUVJXQZWSXRWWLVXLWUGWUCWUDVWLV
          EUOZJVDZWWOXAVXLWUCWUFWXGJWULWWAVXLWUMVLZWUDVWLWWQAVWLVMUQZVXKWUMAVWL
          AVWHVWKWWJWXFXSZWRWIZXKWXIWUEVMUQZWXJWVPURWUDXAVIZVLZWUEVWLXAVIWUFWXG
          XAVIWXIVVJWXIHKPVVHVVIVYBVXLWUMVXPVVHXBUQWVOVYGXLWXIVYHVLZAVYJVYKAVXK
          WUMVYHWEZWXIVYDVYHVYJVXLWUMVXPVYDWVOVYFXLVYMWFZUCWGZWXPAVYJVYOWXQWXRU
          DWGVXLWUMVXPVYRWVOVYSXLWOWPZWXLVXLAVXRWXOWUMVXSWWPWVQWVPWXNWVRWXEXTZV
          SWXIWUEVWLWXTWXLWXIVVIVWEKVDZVFVCZWUEVWLVGWXIWYBVVJVFWXIVVIVWEHKWXSYE
          YAWXIVVGVWNUQZVWOWYCVWLVGVIZWXIWYDVVAVVGXAVIZWXIVVFVVDVVAWXIVVFWUMVVF
          XBUQVXLVVFURWUBXGWAZXCWXIVVDVXKWUSAWUMWUTUVKZXCWXIVVAAWVKVXKWUMWVLWIZ
          XCWUMVVFWUBXAVIVXLVVFURWUBUVLWAUVOWXIWVKVVGXBUQWYDWYFXEWYIWXIVVDVVFWY
          HWYGUVMVVAVVGXHWGXIAVWOVXKWUMAVVTVWOVXFVOWIVWMWYEMVVGVWNVWAVVGWDZVWGW
          YCVWLVGWYJVWFWYBVFWYJVWCVVIVWEKWYJVWBVVHVBVWAVVGVAUNUWEYAUVNYAZYBYCYO
          YFYGWUEVWLWUDUVPUVQUVRVXLWWOWWMVWLVEUOZWXHVXLWWMVWHVWKVXLWWMWWRYHAVWH
          VQUQZVXKAVWHWWJYIZWSAVWKVQUQVXKAVWKAVWJVMUQZVWKVMUQZWXDVWJUVSWLZYHWSA
          VWKURYJVXKAVWKWXFUVTWSUWAVXLWWMVWHUPVWARVCZMVDZVAUNUOZVKUOZVEUOWUCWUD
          XUAVEUOZJVDWYLWXHVXLWUCWUDXUAJWULAXUAVQUQVXKAXUAAXUAVWLXMWYTVWKVWHVKW
          YSVWJVAUNUPWYRVWIMJVWAVVFRYKUWBUWCYLZWXKUWFYIWSVXLAVXRWUDVQUQWUMVXSWW
          PWVQWUDWVRYHVSUWGXUAVWLWWMVEXUCYLWUCXUBWXGJXUBWXGWDWUMXUAVWLWUDVEXUCY
          LXNUWHUWMUWIXPVXLWWOVWHVGVIZWWNVWKVWHVEUOVGVIZVXLWWMVWKVGVIZXUEVXLWWM
          VWJVWKWWRAWYOVXKWXDWSAWYPVXKWYQWSZVXLWWMUPWUDJVDZVWJXAVXLWUCWUDJRURUP
          WJWWTVXLYDXNWULWUCUPWTVXLJWUCUPWWPUWNXNAVXRVWIWUDWDZVXKUAYMAVXRWVPVXK
          WVRYMAVXRWXNVXKWXEYMAUNRURWHVYPUQVXKUFWSUWJAVWJXUHWDVXKAUPVWIWUDJUAYE
          WSXPAVWJVWKVGVIVXKAVWJWXDYNWSYPVXLWWMVMUQWYPWWIURVWHVGVIVLZXUFXUEXEWW
          RXUGAXUJVXKAVWHWWJUWKWSWWMVWKVWHUWLYQWNVXLWWNVMUQWWIWYPURVWKVGVIVLZXU
          DXUEXEWWSWWLAXUKVXKAVWKWXFUWKWSWWNVWHVWKUWOYQXIYPVXLWUJVWHVWSVEUOZVWT
          VKUOZVWHWWHAXUMVMUQVXKAXULVWTAVWHVWSWWKAIVMWTIUWPYJEUMDUMZXAVIEIVHDVM
          VJUWQZVWSVMUQZAURVWSXAVIZXUOULVOZDEIUWRWLZXKZAVWSXUSAXUQXUOULVNXQZXRW
          SWWLVXLWUJWUIVXAVWSVEUOZJVDZXUMXAVXLWUIWUFXVBJWWCWWGAXVBVMUQVXKWWDAVX
          AVWSAVXAAVWRVWTAVWHVVAWWJAVVAVXGUWSXSZXVAXSZWRZXUSXKZWIVXLWWDVLZWUDVX
          AXAVIZWUEVWSXAVIZWUFXVBXAVIZXVHWUDVXAXVHAVXRWVPAVXKWWDWKZXVHVXPVXRWWF
          VXTWLZWVRWGAVXAVMUQZVXKWWDXVFWIZXVHVWIWUDVXAVGXVHAVXRXUIXVLXVMUAWGXVH
          VVFVXCUQZVXDVWIVXAVGVIZWWDVVFWUHVBVCUQWUHVXCUQZXVPVXLVVFWUHVVDUWTVXLW
          UBVXCUQZXVRVXLXVSVVBWUBXAVIZVXLVVCVVDXAVIZXVTVXKXWAAVVCVVDUXCWAVXLVVA
          VVBVVDWVCVXLVVBAVVBXBUQZVXKAVVBVXJWCWSZXCWVBUXAWNVXLXWBWVDXVSXVTXEXWC
          WVNVVBWUBXHWGXIVVBWUBUXBWLWUHVVFVVBUXDUXEAVXDVXKWWDAVWPVXDVXIVOWIVXBX
          VQLVVFVXCVVDVVFWDVWQVWIVXAVGVVDVVFRYKYBYCYOYFYGXVHXUOWUEIUQZXVJAXUOVX
          KWWDXURWIXVHWUEVWGWDZMURVVAVAUTUOZUSUOZVJZXWDXVHVVGXWGUQZWUEWYCWDZXWH
          XVHXWIVVGXWFXAVIZXVHVVDXWFVVFVXLVVDVMUQWWDWVBWSAXWFVMUQVXKWWDAXWFAWVK
          XWFXBUQZWVLVVAUXMWLZXCWIXVHVVFXVMXDXVHVVDXWFUTUOZWUHVVFXAVXLXWNWUHWDW
          WDVXLVVDVVAVAVXLVVDWVAYRZVXLVVAWVCYHZVAVQUQZVXLUXFXNUXGWSWWDWUHVVFXAV
          IVXLVVFWUHVVDUXNWAUXOUXHXVHVVGWVGUQXWLXWIXWKXEXVHVVGUPWVGXVHVXPVYCWWF
          VYEWLWJXFAXWLVXKWWDXWMWIVVGURXWFUXIWGXIXVHVVJWYBVFXVHWYBVVJXVHVVIVWEH
          KXVHVYHVLAVYJVYKAVXKWWDVYHWEXVHVYDVYHVYJVXLWWDVXPVYDWWFVYFXLVYMWFUCWG
          YEUXJYAXWEXWJMVVGXWGWYJVWGWYCWUEWYKUXKUXLWGXUNVWGWDZMXWGVJXWHDWUEIVVJ
          VFUXPXUNWUEWDXWRXWEMXWGXUNWUEVWGUXQUXRUIUYCUXSDEIWUEUXTWGXVHWXOXVNWXM
          URWUEXAVIZVLXUPXVIXVJVLXVKUYAXVHAVXRWXOXVLXVMWYAWGXVOXVHWXMXWSVXLWWDV
          XPWXMWWFWVSXLVXLWWDVXPXWSWWFVXQVVJVYTXOXLXTAXUPVXKWWDXUSWIWUDVXAWUEVW
          SUYBUYDUYEUVRVXLXVCWUIUYFVCZXVBVEUOZVVAXVBVEUOZXUMVXLWUIUYGUQZXVBVQUQ
          ZXVCXXAWDWWCAXXDVXKAXVBXVGYHWSWUIXVBJUYHWGVXLXWTVVAXVBVEVXLVAVVAUSUOZ
          UYFVCZXWTVVAVXLXXFXWTWDZXXEWUIYSVIZVXLXXEVAWUBUNUOZVVAWUBUNUOZUSUOZWU
          IYSVXLVAXBUQZWVKWVDXXEXXKYSVIXXLVXLUYMXNAWVKVXKWVLWSWVNWUBVAVVAUYIYQV
          XLXXIWUHXXJVVDUSVXLXWQWUBVQUQXXIWUHWDUXFVXLWUBWVNYRVAWUBUYJUYKVXLVVAV
          VDXWPXWOUYLUYNUYOVXLXXEUYGUQXXCXXGXXHXEVXLVAVVAVPWWCXXEWUIUYPWGXIVXLW
          UQXXFVVAWDWURVVAUYQWLUYRYTAXXBXUMWDVXKAXUMVWHVWTVKUOZVWSVEUOZVVAVXAVE
          UOZVWSVEUOXXBAWYMVWSVQUQVWTVQUQVWTURYJVLZXUMXXNWDWYNAVWSXUSYHZAVWTXVA
          UYSZVWHVWSVWTUYTYQAXXOXXMVWSVEAVVAVWRVEUOZVWTVKUOZXXOXXMAVVAVQUQVWRVQ
          UQXXPXXTXXOWDAVVAWVLYRZAVWRXVDYIXXRVVAVWRVWTVUAYQAXXSVWHVWTVKAVWHVVAW
          YNXYAAVVAVXGVUBVUCYTUYRYTAVVAVXAVWSXYAAVXAXVEYIXXQVUDVUEWSVULUYOAXUMV
          WHVGVIZVXKAXYBXULVWHVWTVEUOVGVIAVWSVWTVWHXUSAXUPVWTVMUQXUSVWSUVSWLWWJ
          AVWSXUSYNVUFAXULVWHVWTXUTWWKXVAVUGXIWSYPVUHVXLVXNVVEWUFJVDWUKVXLVVEVX
          MWUFJVXQGVVJVYAVYTVUIYEVXLWUCWUIWUFVVEJVXLWUBWUHVGVIWUCWUIVUJUWPWDVXL
          WUBVXLWUBWVNXCYNURWUBWUHVVDVUMWLVXLWVEVVEWUCWUIVUKWDWVMWUBURVVDVUNWLV
          XOVXQWUFWVTYHVUOVUTVXLNANVQUQVXKANUHYIWSVUPVUQYPVURVVSVVPCVVCUPVVQVVC
          WDVVNLVVRVVOVVQVVCVBYKVUSUXLWG $.
      $}

      $d n s t ph $.
      $( Lemma for ~ mertens .  (Contributed by Mario Carneiro,
         28-Apr-2014.) $)
      mertenslem2 $p |- ( ph -> E. y e. NN0 A. m e. ( ZZ>= ` y )
        ( abs ` sum_ j e. ( 0 ... m ) ( A x.
          sum_ k e. ( ZZ>= ` ( ( m - j ) + 1 ) ) B ) ) < E ) $=
        ( vt vw cv caddc cc0 cseq cfv cn0 csu cmin co cabs c2 cdiv clt wbr wral
        c1 cuz cn wrex cfz cmul nnuz cz wcel 1z a1i rphalfcld nn0uz 0z wa eqidd
        abscld eqeltrd isumrecl cle absge0d breqtrrd isumge0 ge0p1rpd isumclim2
        cr rpdivcld climi2 wb cc syl2an isumcl adantr eqid adantl peano2nn0 syl
        nnnn0 nn0zd wceq simpll eluznn0 sylan syl2anc cli adantlr mpbid sumeq1d
        iserex syl6eleq eqtrd oveq1d sumeq2dv fveq2d breq1d sylan2 ralbidva weq
        elfznn0 oveq1 cbvralv crp simplll ad2antrr rexlimdva cfn fvex w3a fveq2
        fvmpt cvv adantll anbi2i sylbid mpd uztrn2 serf ffvelrn abssubd pncan2d
        wf cdm isumsplit nncn ax-1cn pncan sylancl oveq2d simpl fsumser 3eqtr4d
        anassrs syl6bb csup cmpt simplbi nnrpd cab wi eleq1a abssdv syl5eqss c0
        wne fzfid abrexfi syl5eqel nnm1nn0 eluzfz1 eqcomd syl6eq syl6eqr eqeq2d
        wss 0p1e1 rspcev eqeq1 rexbidv elab2 ne0i wor ltso fisupcl mpan syl3anc
        sylibr sseldd 0re 1nn0 fimaxre2 3jca letrd nn0ex mptex elnn0uz sylan2br
        suprub seqfeq recnd climi0 absidd ralrimiva eqeq12d rspccva syl6bbr jca
        serf0 biimpi mertenslem1 expr ex syl5bir expdimp ) AJUKZULNUMUNZUOZUPFI
        UQZURUSUTUOZLVAVBUSZUPHUKZPUOZHUQZVFULUSZVBUSZVCVDZJQUKZVGUOZVEZQVHVIUM
        UXSVJUSZEUXSUYEURUSVFULUSVGUOFIUQVKUSHUQUTUOLVCVDJCUKVGUOVECUPVIZAUYBUY
        AUYIQJUXTVFVHVLVFVMVNAVOVPZAUYDUYHALUFVQZAUYGAUYFHPUMUPVRUMVMVNZAVSVPZA
        UYEUPVNZVTZUYFWAZVUAUYFEUTUOZWKSVUAETWBZWCZUDWDAUYFHPUMUPVRUYSVUBVUEUDV
        UAUMVUCUYFWEVUAETWFSWGZWHWIWLAUXSVHVNZVTZUYAWAAFINUMUPVRUYSUAUBUEWJWMAU
        YMUYOQVHAUYKVHVNZVTZUYMKUKZVFULUSZVGUOZIUKZNUOZIUQZUTUOZUYIVCVDZKUYLVEZ
        UYOVUJUYMUXSVFULUSZVGUOZVUOIUQZUTUOZUYIVCVDZJUYLVEVUSVUJUYJVVDJUYLAVUIU
        XSUYLVNZUYJVVDWNZVUIVVEVTAVUGVVFVFUXSUYKVHVLUUAVUHUYCVVCUYIVCVUHUYCUYBU
        YAURUSZUTUOVVCVUHUYAUYBAUPWOUXTUUFUXSUPVNZUYAWOVNVUGAINUMUPVRUYSAVUNUPV
        NZVTVUOFWOUAUBWCZUUBUXSXCZUPWOUXSUXTUUCWPZAUYBWOVNVUGAFINUMUPVRUYSUAUBU
        EWQWRUUDVUHVVGVVBUTVUHUYAVVAFIUQZULUSZUYAURUSVVMVVGVVBVUHUYAVVMVVLVUHFI
        NVUTVVAVVAWSZVUHVUTVUHVVHVUTUPVNZVUGVVHAVVKWTZUXSXAXBZXDVUHVUNVVAVNZVTZ
        AVVIVUOFXEZAVUGVVSXFZVUHVVPVVSVVIVVRVUNVUTXGXHZUAXIZVVTAVVIFWOVNZVWBVWC
        UBXIVUHUXTXJUUGZVNZULNVUTUNVWFVNAVWGVUGUEWRZVUHINUMVUTUPVRVVRAVVIVUOWOV
        NZVUGVVJXKXNXLWQUUEVUHUYBVVNUYAURVUHUYBUMVUTVFURUSZVJUSZFIUQZVVMULUSVVN
        VUHFINUMVUTVVAUPVRVVOVVRAVVIVWAVUGUAXKAVVIVWEVUGUBXKVWHUUHVUHVWLUYAVVMU
        LVUHVWLUYNFIUQUYAVUHVWKUYNFIVUHVWJUXSUMVJVUHUXSWOVNZVFWOVNVWJUXSXEVUGVW
        MAUXSUUIWTUUJUXSVFUUKUULUUMXMVUHFINUMUXSVUHAVVIVWAVUNUYNVNZAVUGUUNZVUNU
        XSYDZUAWPVUHUXSUPUMVGUOZVVQVRXOVUHAVVIVWEVWNVWOVWPUBWPUUOXPXQXPXQVUHVVA
        VUOFIVWDXRUUPXSXPXTYAUUQYBVVDVURJKUYLJKYCZVVCVUQUYIVCVWRVVBVUPUTVWRVVAV
        UMVUOIVWRVUTVULVGUXSVUKVFULYEXSXMXSXTYFUURAVUIVUSUYOVUIVUSVTBAUYOUHABUY
        OABVTZUXSPUOZUTUOZUYDUYKVBUSZGWKVCUUSZVFULUSZVBUSZVCVDZJUIUKZVGUOZVEZUI
        UPVIUYOVWSVWTVXEUIJKUPVUKPUOZUUTZUMUPVRUYRVWSVSVPVWSVXBVXDVWSUYDUYKAUYD
        YGVNBUYQWRVWSUYKBVUIABVUIVUSUHUVAWTZUVBWLVWSVXCVWSGWKVXCVWSGDUKZVUQXEZK
        UMUYKVFURUSZVJUSZVIZDUVCZWKUGVWSVXQDWKVWSVXNVXMWKVNZKVXPVWSVUKVXPVNZVTZ
        VUQWKVNVXNVXSUVDVYAVUPVYAVUOINVULVUMVUMWSVYAVULVYAVUKUPVNZVULUPVNZVXTVY
        BVWSVUKVXOYDWTVUKXAXBZXDVYAVUNVUMVNZVTZVUOWAVYFAVVIVWIABVXTVYEYHVYAVYCV
        YEVVIVYDVUNVULXGXHVVJXIVYAVWGULNVULUNVWFVNAVWGBVXTUEYIVYAINUMVULUPVRVYD
        VYAAVVIVWIABVXTXFVVJXHXNXLWQWBVUQWKVXMUVEXBYJUVFUVGZVWSGYKVNZGUVHUVIZGW
        KUVSZVXCGVNZVWSGVXRYKUGVWSVXPYKVNVXRYKVNVWSUMVXOUVJKDVXPVUQUVKXBUVLZVWS
        VHFIUQZUTUOZGVNZVYIVWSVYNVUQXEZKVXPVIZVYOVWSUMVXPVNZVYNVHVUOIUQZUTUOZXE
        ZVYQVWSVXOVWQVNVYRVWSVXOUPVWQVWSVUIVXOUPVNVXLUYKUVMXBVRXOUMVXOUVNXBVWSV
        YTVYNVWSVYSVYMUTAVYSVYMXEBAVHVUOFIVUNVHVNZAVVIVWAVUNXCZUAYAZXRWRXSUVOVY
        PWUAKUMVXPVUKUMXEZVUQVYTVYNWUEVUPVYSUTWUEVUMVHVUOIWUEVUMVFVGUOVHWUEVULV
        FVGWUEVULUMVFULUSVFVUKUMVFULYEUVTUVPXSVLUVQXMXSUVRUWAXIVXQVYQDVYNGVYMUT
        YLVXMVYNXEVXNVYPKVXPVXMVYNVUQUWBUWCUGUWDUWKZGVYNUWEXBZVYGWKVCUWFVYHVYIV
        YJYMVYKUWGWKGVCUWHUWIUWJUWLZVWSUMVYNVXCUMWKVNVWSUWMVPVWSVYMAVYMWOVNBAFI
        NVFVHVLUYPWUDWUBAVVIVWEWUCUBYAAVWGULNVFUNVWFVNUEAINUMVFUPVRVFUPVNAUWNVP
        VVJXNXLWQWRZWBWUHVWSVYMWUIWFVWSVYJVYIUJUKVXMWEVDUJGVEDWKVIZYMZVYOVYNVXC
        WEVDVWSVYJVYIWUJVYGWUGVWSVYJVYHWUJVYGVYLDUJGUWOXIUWPZWUFDUJGVYNUXBXIUWQ
        ZWIWLVVHUXSVXKUOVWTXEVWSKUXSVXJVWTUPVXKVUKUXSPYNZVXKWSZUXSPYLYOWTAVXKUM
        XJVDBAHVXKUMYPUPVRUYSVXKYPVNAKUPVXJUWRUWSVPAULVXKUMUNULPUMUNZVWFAULHVXK
        PUMUYSUYEVWQVNAUYTUYEVXKUOZUYFXEZUYEUWTUYTWURAKUYEVXJUYFUPVXKVUKUYEPYNW
        UOUYEPYLYOWTZUXAUXCUDWCVUAWUQVUAWUQVUCWKVUAWUQUYFVUCWUSSXPVUDWCUXDUXLWR
        UXEVWSVXIUYOUIUPVWSVXGUPVNZVTZVXIVXJVXEVCVDZKVXHVEZUYOWVAVXIVWTVXEVCVDZ
        JVXHVEZWVCWVAVXFWVDJVXHWVAUXSVXHVNZVTZVXAVWTVXEVCWVGAVVHVXAVWTXEZABWUTW
        VFYHWUTWVFVVHVWSUXSVXGXGYQAUYFUTUOZUYFXEZHUPVEVVHWVHAWVJHUPVUAUYFVUEVUF
        UXFUXGWVJWVHHUXSUPHJYCZWVIVXAUYFVWTWVKUYFVWTUTUYEUXSPYNZXSWVLUXHUXIXHXI
        XTYBWVBWVDKJVXHKJYCVXJVWTVXEVCWUNXTYFZUXJVWSWUTWVCUYOVWSWUTWVCVTZVTZBCD
        UJUIEFGHIJKLMNOPQWVOAUYTUYEMUOEXEABWVNXFZRXHWVOAUYTUYFVUCXEWVPSXHWVOAUY
        TEWOVNWVPTXHWVOAVVIVWAWVPUAXHWVOAVVIVWEWVPUBXHWVOAVVIVUNOUOUMVUNVJUSEVU
        NUYEURUSNUOVKUSHUQXEWVPUCXHAWUPVWFVNBWVNUDYIAVWGBWVNUEYIALYGVNBWVNUFYIU
        GUHBWVNBWUTWVEVTZVTZABWVNVTWVRWVNWVQBWVCWVEWUTWVMYRYRUXMYQVWSUMVXCWEVDZ
        WUKVTWVNVWSWVSWUKWUMWULUXKWRUXNUXOYSYJYTUXPUXQUXRYSYJYT $.
    $}

    $d n s ph $.
    $( Mertens' thoerem.  If ` A ( j ) ` is an absolutely convergent series and
       ` B ( k ) ` is convergent, then
       ` ( sum_ j e. NN0 A ( j ) x. sum_ k e. NN0 B ( k ) ) = `
       ` sum_ k e. NN0 sum_ j e. ( 0 ... k ) ( A ( j ) x. B ( k - j ) ) ` (and
       this latter series is convergent).  This latter sum is commonly known as
       the Cauchy product of the sequences.  The proof follows the outline at
~ http://en.wikipedia.org/wiki/Cauchy_product#Proof_of_Mertens.27_theorem .
       (Contributed by Mario Carneiro, 29-Apr-2014.) $)
    mertens $p |- ( ph -> seq 0 ( + , H ) ~~>
                    ( sum_ j e. NN0 A x. sum_ k e. NN0 B ) ) $=
      ( cn0 co wcel vx vy vm vn vi vs vu vz vl csu cmul caddc cfv cmpt cc0 cseq
      cv cvv nn0uz cz 0z a1i seqex cc wa cfz cmin fzfid elfznn0 syl2an fznn0sub
      simpl wral adantl eqeltrd ralrimiva weq fveq2 cbvralv sylib ad2antrr wceq
      eleq1d rspcv sylc mulcld fsumcl serf ffvelrnda cabs clt wbr cuz crp c1 cn
      wrex c2 cdiv cab adantlr cli cdm adantr simpr cbvsumv oveq1 fveq2d syl5eq
      sumeq1d eqeq2d cbvrexv eqeq1 syl5bb cbvabv oveq1i oveq2i breq2i breq1d wb
      rexbidv eluznn0 simpll isumcl syl2anc simplll eqid oveq2d sumeq2dv eqtr4d
      syl sylan oveq1d eqtrd mulcomd oveq12d 3eqtr3rd ovex fvmpt fsumser anbi2i
      mertenslem2 ad2antlr fsumsub subdid peano2nn0 nn0cnd ax-1cn pncan sylancl
      isumsplit nn0zd iserex mpbid pncan2d fsummulc2 syl6eleq anasss fsum0diag2
      sylan2 anassrs ralbidva rexbidva mpbird abscvgcvg isumclim2 rspccva 2clim
      isermulc2 breqtrd ) AUARBDUJZRCEUJZUKSZUBUCULUDRUVLUDUQZFUMZUKSZUNZUOUPZU
      LHUOUPZUOURRUSUOUTTAVAVBZUVSURTAULHUOVCVBARVDUCUQZUVSAEHUORUSUVTAEUQZRTZV
      EZUWBHUMZUOUWBVFSZBUWBDUQZVGSZGUMZUKSZDUJZVDOUWDUWFUWJDUWDUOUWBVHUWDUWGUW
      FTZVEZBUWIUWDAUWGRTZBVDTZUWLAUWCVLUWGUWBVILVJUWMUWHRTZUEUQZGUMZVDTZUERVMZ
      UWIVDTZUWLUWPUWDUWGUOUWBVKVNAUWTUWCUWLAUWBGUMZVDTZERVMUWTAUXCERUWDUXBCVDM
      NVOZVPUXCUWSEUEREUEVQUXBUWRVDUWBUWQGVRWCVSVTWAUWSUXAUEUWHRUWQUWHWBUWRUWIV
      DUWQUWHGVRWCWDWEWFWGZVOWHWIAUWAUVRUMZUWAUVSUMZVGSZWJUMZUAUQZWKWLZUCUBUQZW
      MUMZVMZUBRWQZUAWNAUXJWNTZVEZUXOUOUWAVFSZBUWAUWGVGSZWOULSZWMUMZCEUJZUKSZDU
      JZWJUMZUXJWKWLZUCUXMVMZUBRWQZUXQUFUQZWPTZUGUQZWOULSZWMUMZUWRUEUJZWJUMZUXJ
      WRWSSZRUWQIUMZUEUJZWOULSZWSSZWKWLZUGUYIWMUMZVMZVEUBUHBCUYKUWQWOULSZWMUMZU
      IUQZGUMZUIUJZWJUMZWBZUEUOUYIWOVGSVFSZWQZUGWTDEUCUDUXJFGHIUFAUWNUWGFUMZBWB
      UXPJXAAUWNUWGIUMZBWJUMZWBUXPKXAAUWNUWOUXPLXAAUWCUXBCWBZUXPMXAAUWCCVDTZUXP
      NXAAUWCUWEUWKWBZUXPOXAAULIUOUPXBXCZTUXPPXDAULGUOUPVUSTZUXPQXDAUXPXEVULUHU
      QZUVNWOULSZWMUMZUXBEUJZWJUMZWBZUDVUKWQZUGUHVULUYKVVEWBZUDVUKWQUGUHVQZVVGV
      UJVVHUEUDVUKUEUDVQZVUIVVEUYKVVJVUHVVDWJVVJVUHVUEUXBEUJVVDVUEVUGUXBUIEVUFU
      WBGVRXFVVJVUEVVCUXBEVVJVUDVVBWMUWQUVNWOULXGXHXJXIXHXKXLVVIVVHVVFUDVUKUYKV
      VAVVEXMYAXNXOVUCVVEUYPRVUNDUJZWOULSZWSSZWKWLZUDVUBVMUYJVUAVVNUGUDVUBVUAUY
      OVVMWKWLUGUDVQZVVNUYTVVMUYOWKUYSVVLUYPWSUYRVVKWOULRUYQVUNUEDUWQUWGIVRXFXP
      XQXRVVOUYOVVEVVMWKVVOUYNVVDWJVVOUYNUYMUXBEUJVVDUYMUWRUXBUEEUWQUWBGVRXFVVO
      UYMVVCUXBEVVOUYLVVBWMUYKUVNWOULXGXHXJXIXHXSXNVSUUAUUBAUXOUYHXTUXPAUXNUYGU
      BRAUXLRTZVEUXKUYFUCUXMAVVPUWAUXMTZUXKUYFXTZVVPVVQVEAUWARTZVVRUWAUXLYBAVVS
      VEZUXIUYEUXJWKVVTUXHUYDWJVVTUXRUVLVUMUKSZUOUXSVFSZBUXBUKSZEUJZVGSZDUJUXRV
      WADUJZUXRVWDDUJZVGSUYDUXHVVTUXRVWAVWDDVVTUOUWAVHVVTUWGUXRTZVEZAUWNVWAVDTA
      VVSVWHYCZVWHUWNVVTUWGUWAVIZVNZAUWNVEZUVLVUMAUVLVDTZUWNACEGUORUSUVTMNQYDZX
      DZVWMVUMBVDJLVOZWFYEZVWIVWBVWCEVWIUOUXSVHZVWIUWBVWBTZVEZBUXBVXAAUWNUWOAVV
      SVWHVWTYFZVWHUWNVVTVWTVWKUUCLYEVXAAUWCUXCVXBVWTUWCVWIUWBUXSVIVNZUXDYEZWFZ
      WGUUDVVTUXRVWEUYCDVWIBUVLVWBUXBEUJZVGSZUKSBUVLUKSZBVXFUKSZVGSUYCVWEVWIBUV
      LVXFVWIAUWNUWOVWJVWLLYEZAVWNVVSVWHVWOWAVWIVWBUXBEVWSVXDWGZUUEVWIVXGUYBBUK
      VWIVXGVXFUYBULSZVXFVGSUYBVWIUVLVXLVXFVGVWIUVLUOUXTWOVGSZVFSZCEUJZUYBULSVX
      LVWICEGUOUXTUYARUSUYAYGZVWIUXSRTZUXTRTZVWHVXQVVTUWGUOUWAVKVNZUXSUUFYKZVWI
      AUWCVUPVWJMYLZVWIAUWCVUQVWJNYLZAVUTVVSVWHQWAZUUKVWIVXOVXFUYBULVWIVXOVWBCE
      UJVXFVWIVXNVWBCEVWIVXMUXSUOVFVWIUXSVDTWOVDTVXMUXSWBVWIUXSVXSUUGUUHUXSWOUU
      IUUJYHXJVWIVWBUXBCEVXAAUWCVUPVXBVXCMYEYIYJYMYNYMVWIVXFUYBVXKVWICEGUXTUYAV
      XPVWIUXTVXTUULVWIUWBUYATZVEZAUWCVUPAVVSVWHVYDYFZVWIVXRVYDUWCVXTUWBUXTYBYL
      ZMYEVYEAUWCVUQVYFVYGNYEVWIVUTULGUXTUPVUSTVYCVWIEGUOUXTRUSVXTVWIUWCVEUXBCV
      DVYAVYBVOUUMUUNYDUUOYNYHVWIVXHVWAVXIVWDVGVWIAUWNVXHVWAWBVWJVWLVWMVXHUVLBU
      KSVWAVWMBUVLLVWPYOVWMVUMBUVLUKJYHYJYEVWIVWBUXBBEVWSVXJVXDUUPYPYQYIVVTVWFU
      XFVWGUXGVGVVTVWADUVQUOUWAVWIUWNUWGUVQUMVWAWBVWLUDUWGUVPVWARUVQUDDVQUVOVUM
      UVLUKUVNUWGFVRYHUVQYGZUVLVUMUKYRYSYKVVTUWARUOWMUMAVVSXEUSUUQZVWRYTVVTVWGU
      XRUWKEUJUXGVVTUDVWCBUVNGUMZUKSUWJDEUWAUDEVQVYJUXBBUKUVNUWBGVRYHUVNUWHWBVY
      JUWIBUKUVNUWHGVRYHVVTVWHVWTVWCVDTVXEUURUUSVVTUWKEHUOUWAVVTUWBUXRTZVEZAUWC
      VURAVVSVYKYCZVYKUWCVVTUWBUWAVIVNZOYEVYIVYLAUWCUWKVDTVYMVYNUXEYEYTYNYPYQXH
      XSUUTUVAUVBUVCXDUVDVPAUVRUVLUVKUKSUVMXBAUVKUVLUCFUVQUORUSUVTVWOABDFUORUSU
      VTJLADIFUORUSUVTVWMVUNVUOVUMWJUMKVWMVUMBWJJXHYJVWQPUVEZUVFAVUMVDTZDRVMVVS
      UWAFUMZVDTZAVYPDRVWQVPVYPVYRDUWARDUCVQVUMVYQVDUWGUWAFVRWCUVGYLVVSUWAUVQUM
      UVLVYQUKSZWBAUDUWAUVPVYSRUVQUDUCVQUVOVYQUVLUKUVNUWAFVRYHVYHUVLVYQUKYRYSVN
      UVIAUVLUVKVWOABDFUORUSUVTJLVYOYDYOUVJUVH $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Elementary trigonometry
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The exponential, sine, and cosine functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c exp $. $( Exponential function. $)
  $c _e $. $( Letter e (Euler's constant = 2.71828...) $)
  $c sin $. $( Sine function. $)
  $c cos $. $( Cosine function. $)
  $c tan $. $( Tangent function. $)
  $c pi $. $( Pi = 3.14159... $)

  $( Extend class notation to include the exponential function. $)
  ce $a class exp $.

  $( Extend class notation to include Euler's constant = 2.7182818.... $)
  ceu $a class _e $.

  $( Extend class notation to include the sine function. $)
  csin $a class sin $.

  $( Extend class notation to include the cosine function. $)
  ccos $a class cos $.

  $( Extend class notation to include the tangent function. $)
  ctan $a class tan $.

  $( Extend class notation to include pi = 3.14159.... $)
  cpi $a class pi $.

  ${
    $d j k x y w $.
    $( Define the exponential function.  (Contributed by NM, 14-Mar-2005.) $)
    df-ef $a |- exp = ( x e. CC |->
                        sum_ k e. NN0 ( ( x ^ k ) / ( ! ` k ) ) ) $.

    $( Define Euler's constant 2.71828....  (Contributed by NM,
       14-Mar-2005.) $)
    df-e $a |- _e = ( exp ` 1 ) $.

    $( Define the sine function.  (Contributed by NM, 14-Mar-2005.) $)
    df-sin $a |- sin = ( x e. CC |-> ( ( ( exp ` ( _i x. x ) ) -
                         ( exp ` ( -u _i x. x ) ) ) / ( 2 x. _i ) ) ) $.

$(
    @( Define the cosine function. @)
    df-cos @a |- cos =
        { <. x , y >. | ( x e. CC /\ y = ( sin ` ( x + ( pi / 2 ) ) ) ) } @.
$)

    $( Define the cosine function.  (Contributed by NM, 14-Mar-2005.) $)
    df-cos $a |- cos = ( x e. CC |-> ( ( ( exp ` ( _i x. x ) ) +
                         ( exp ` ( -u _i x. x ) ) ) / 2 ) ) $.

    $( Define the tangent function.  We define it this way for ~ cmpt , which
       requires the form ` ( x e. A |-> B ) ` .  (Contributed by Mario
       Carneiro, 14-Mar-2014.) $)
    df-tan $a |- tan = ( x e. ( `' cos " ( CC \ { 0 } ) ) |->
                       ( ( sin ` x ) / ( cos ` x ) ) ) $.

    $( Define pi = 3.14159..., which is the smallest positive number whose sine
       is zero.  Definition of pi in [Gleason] p. 311.  (We use the inverse of
       less-than, " ` ``' < ` ", to turn supremum into infimum; currently we
       don't have infimum defined separately.)  (Contributed by Paul Chapman,
       23-Jan-2008.) $)
    df-pi $a |- pi = sup ( ( RR+ i^i ( `' sin " { 0 } ) ) , RR , `' < ) $.
  $}

  $( Closure of a term in the series expansion of the exponential function.
     (Contributed by Paul Chapman, 11-Sep-2007.) $)
  eftcl $p |- ( ( A e. CC /\ K e. NN0 ) ->
                 ( ( A ^ K ) / ( ! ` K ) ) e. CC ) $=
    ( cc wcel cn0 wa cexp co cfa cfv expcl faccl nncnd adantl cc0 facne0 divcld
    wne ) ACDZBEDZFABGHBIJZABKTUACDSTUABLMNTUAORSBPNQ $.

  $( The terms of the series expansion of the exponential function of a real
     number are real.  (Contributed by Paul Chapman, 15-Jan-2008.) $)
  reeftcl $p |- ( ( A e. RR /\ K e. NN0 ) ->
                   ( ( A ^ K ) / ( ! ` K ) ) e. RR ) $=
    ( cr wcel cn0 wa cexp co cfa cfv reexpcl cn faccl adantl nndivred ) ACDZBED
    ZFABGHBIJZABKQRLDPBMNO $.

  $( The absolute value of a term in the series expansion of the exponential
     function.  (Contributed by Paul Chapman, 23-Nov-2007.) $)
  eftabs $p |- ( ( A e. CC /\ K e. NN0 ) ->
                 ( abs ` ( ( A ^ K ) / ( ! ` K ) ) ) =
                 ( ( ( abs ` A ) ^ K ) / ( ! ` K ) ) ) $=
    ( cc wcel cn0 wa cexp co cfa cfv cdiv cabs expcl faccl adantl nncnd cc0 wne
    cn facne0 absdivd absexp nnred nnnn0d nn0ge0d absidd oveq12d eqtrd ) ACDZBE
    DZFZABGHZBIJZKHLJULLJZUMLJZKHALJBGHZUMKHUKULUMABMUKUMUJUMSDUIBNOZPUJUMQRUIB
    TOUAUKUNUPUOUMKABUBUKUMUKUMUQUCUKUMUKUMUQUDUEUFUGUH $.

  ${
    $d k n A $.  $d k F $.  $d n N $.
    eftval.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    $( The value of a term in the series expansion of the exponential
       function.  (Contributed by Paul Chapman, 21-Aug-2007.)  (Revised by
       Mario Carneiro, 28-Apr-2014.) $)
    eftval $p |- ( N e. NN0 -> ( F ` N ) = ( ( A ^ N ) / ( ! ` N ) ) ) $=
      ( cv cexp co cfa cfv cdiv cn0 wceq oveq2 fveq2 oveq12d ovex fvmpt ) BDABF
      ZGHZSIJZKHADGHZDIJZKHLCSDMTUBUAUCKSDAGNSDIOPEUBUCKQR $.

    $( Lemma for ~ efcl .  The series that defines the exponential function
       converges, in the case where its argument is nonzero.  The ratio test
       ~ cvgrat is used to show convergence.  (Contributed by NM,
       26-Apr-2005.)  (Proof shortened by Mario Carneiro, 28-Apr-2014.) $)
    efcllem $p |- ( A e. CC -> seq 0 ( + , F ) e. dom ~~> ) $=
      ( cc wcel c1 c2 cdiv co cc0 cabs cfv cmul cr clt wbr cle wceq syl cfl cuz
      vk cn0 nn0uz eqid 2nn nnrecre ax-mp a1i halflt1 2re abscl remulcl sylancr
      cn absge0 0re 2pos ltleii mulge0 mpanl12 syl2anc flge0nn0 cexp cfa eftval
      wa cv adantl eftcl eqeltrd caddc adantr eluznn0 nn0p1nn nndivred reexpcld
      sylan faccl expcl syldan absge0d absexp breqtrd nngt0d syl22anc peano2nn0
      nnred divge0 nn0red flltp1 eluzp1p1 eluzle ltletrd recnd 2cn mulcom nncnd
      sylancl mulid2d 3brtr4d pm3.2i 1re jca lt2mul2div mpbid ltle mpd lemul2ad
      wb fveq2d expp1d eqtrd nnnn0d nn0ge0d absidd facp1 oveq12d nnne0d absdivd
      wi divmuldivd 3eqtr4d recni abscld eftabs oveq1d cvgrat ) AEFZGHIJZUCCKHA
      LMZNJZUAMZYNUBMZUDUEYOUFYKOFZYJHUPFYPUGHUHUIZUJYKGPQYJUKUJYJYMOFZKYMRQZYN
      UDFZYJHOFZYLOFZYRULAUMZHYLUNUOZYJUUBKYLRQZYSUUCAUQUUAKHRQUUBUUEVHYSULKHUR
      ULUSUTHYLVAVBVCYMVDVCZYJUCVIZUDFZVHUUGCMZAUUGVEJZUUGVFMZIJZEUUHUUIUULSZYJ
      ABCUUGDVGZVJAUUGVKVLZYJUUGYOFZVHZYLUUGVEJZUUKIJZYLUUGGVMJZIJZNJZUUSYKNJZU
      UTCMZLMZYKUUILMZNJZRUUQUVAYKUUSUUQYLUUTYJUUBUUPUUCVNZUUQUUHUUTUPFYJYTUUPU
      UHUUFUUGYNVOVSZUUGVPTZVQZYPUUQYQUJUUQUURUUKUUQYLUUGUVHUVIVRZUUQUUHUUKUPFU
      VIUUGVTTZVQUUQUUROFKUURRQUUKOFKUUKPQKUUSRQUVLUUQKUUJLMZUURRUUQUUJYJUUPUUH
      UUJEFUVIAUUGWAWBWCYJUUPUUHUVNUURSUVIAUUGWDWBWEUUQUUKUVMWIUUQUUKUVMWFUURUU
      KWJWGUUQUVAYKPQZUVAYKRQZUUQYLHNJZGUUTNJZPQZUVOUUQYMUUTUVQUVRPUUQYMYNGVMJZ
      UUTYJYRUUPUUDVNZYJUVTOFUUPYJUVTYJYTUVTUDFUUFYNWHTWKVNUUQUUTUVJWIZUUQYRYMU
      VTPQUWAYMWLTUUQUUTUVTUBMFZUVTUUTRQUUPUWCYJYNUUGWMVJUVTUUTWNTWOUUQYLEFHEFU
      VQYMSUUQYLUVHWPZWQYLHWRWTUUQUUTUUQUUTUVJWSZXAXBUUQUUBUUAKHPQZVHZGOFZUUTOF
      ZKUUTPQZVHUVSUVOXKUVHUWGUUQUUAUWFULUSXCUJUWHUUQXDUJUUQUWIUWJUWBUUQUUTUVJW
      FXEYLHGUUTXFWGXGUUQUVAOFYPUVOUVPYBUVKYQUVAYKXHWTXIXJUUQUVEAUUTVEJZUUTVFMZ
      IJZLMZUVBUUQUVDUWMLUUQUUTUDFZUVDUWMSUUQUUHUWOUVIUUGWHTZABCUUTDVGTXLUUQUWK
      LMZUWLLMZIJUURYLNJZUUKUUTNJZIJUWNUVBUUQUWQUWSUWRUWTIUUQUWQYLUUTVEJZUWSYJU
      UPUWOUWQUXASUWPAUUTWDWBUUQYLUUGUWDUVIXMXNUUQUWRUWLUWTUUQUWLUUQUWLUUQUWOUW
      LUPFUWPUUTVTTZWIUUQUWLUUQUWLUXBXOXPXQUUQUUHUWLUWTSUVIUUGXRTXNXSUUQUWKUWLY
      JUUPUWOUWKEFUWPAUUTWAWBUUQUWLUXBWSUUQUWLUXBXTYAUUQUURUUKYLUUTUUQUURUVLWPU
      UQUUKUVMWSUWDUWEUUQUUKUVMXTUUQUUTUVJXTYCYDXNUUQUVGUVFYKNJZUVCUUQYKEFUVFEF
      UVGUXCSYKYQYEUUQUVFUUQUUIYJUUPUUHUUIEFUVIUUOWBYFWPYKUVFWRUOUUQUVFUUSYKNUU
      QUVFUULLMZUUSUUQUUIUULLUUQUUHUUMUVIUUNTXLYJUUPUUHUXDUUSSUVIAUUGYGWBXNYHXN
      XBYI $.

    $( The series defining the exponential function converges in the (trivial)
       case of a zero argument.  (Contributed by Steve Rodriguez, 7-Jun-2006.)
       (Revised by Mario Carneiro, 28-Apr-2014.) $)
    ef0lem $p |- ( A = 0 -> seq 0 ( + , F ) ~~> 1 ) $=
      ( vk cc0 wceq caddc cfv c1 wcel cn wa cn0 cexp co cdiv syl ax-mp a1i cseq
      cli csn cv cuz wo cif simpr nn0uz syl6eleqr elnn0 sylib cfa adantl eftval
      nnnn0 oveq1 0exp sylan9eq oveq1d faccl nncn nnne0 div0d 3eqtrd necon3bbii
      wn wne elsn sylibr iffalse eqtr4d fveq2 cc exp0 syl6eq 0nn0 oveq2i ax-1cn
      0cn fac0 eqtr2i 3eqtr4g sylan9eqr iftrue jaodan syldan eleqtri cfz wss cz
      div1i 0z fzsn eqimss2i fsumcvg2 seq1i breqtrd ) AFGZHCFUAZFWTIJUBWSFUCZJE
      CFFWSEUDZFUEIZKZXBLKZXBFGZUFZXBCIZXBXAKZJFUGZGZWSXDMZXBNKZXGXLXBXCNWSXDUH
      UIUJXBUKULWSXEXKXFWSXEMZXHFXJXNXHAXBOPZXBUMIZQPZFXPQPZFXNXMXHXQGXEXMWSXBU
      PUNZABCXBDUORXNXOFXPQWSXEXOFXBOPFAFXBOUQXBURUSUTXNXPLKZXRFGXNXMXTXSXBVARX
      TXPXPVBXPVCVDRVEXNXIVGZXJFGXEYAWSXEXBFVHYAXBVCXIXBFEFVIZVFVJUNXIJFVKRVLWS
      XFMZXHJXJXFWSXHFCIZJXBFCVMWSAFOPZFUMIZQPZJYFQPZYDJWSYEJYFQWSYEFFOPZJAFFOU
      QFVNKYIJGVTFVOSVPUTFNKYDYGGVQABCFDUOSYHJJQPJYFJJQWAVRJVSWLWBWCZWDYCXIXJJG
      YCXFXIWSXFUHYBVJXIJFWERVLWFWGFXCKWSFNXCVQUIWHTJVNKWSXIMVSTXAFFWIPZWJWSYKX
      AFWKKYKXAGWMFWNSWOTWPWSJHCFWMYJWQWR $.
  $}

  ${
    $d x k A $.
    $( Value of the exponential function.  (Contributed by NM, 8-Jan-2006.)
       (Revised by Mario Carneiro, 10-Nov-2013.) $)
    efval $p |- ( A e. CC ->
                 ( exp ` A ) = sum_ k e. NN0 ( ( A ^ k ) / ( ! ` k ) ) ) $=
      ( vx cn0 cv cexp co cfa cfv cdiv csu cc wceq oveq1 oveq1d sumeq2sdv df-ef
      ce sumex fvmpt ) CADCEZBEZFGZUBHIZJGZBKDAUBFGZUDJGZBKLRUAAMZDUEUGBUHUCUFU
      DJUAAUBFNOPCBQDUGBST $.
  $}

  $( Value of Euler's constant ` _e ` = 2.71828...  (Contributed by Steve
     Rodriguez, 5-Mar-2006.) $)
  esum $p |- _e = sum_ k e. NN0 ( 1 / ( ! ` k ) ) $=
    ( ceu c1 ce cfv cn0 cv cexp co cfa cdiv csu df-e cc wcel ax-1cn efval ax-mp
    wceq cz nn0z 1exp syl oveq1d sumeq2i 3eqtri ) BCDEZFCAGZHIZUHJEZKIZALZFCUJK
    IZALMCNOUGULSPCAQRFUKUMAUHFOZUICUJKUNUHTOUICSUHUAUHUBUCUDUEUF $.

  ${
    $d k n x $.
    $( Domain and codomain of the exponential function.  (Contributed by Paul
       Chapman, 22-Oct-2007.)  (Proof shortened by Mario Carneiro,
       28-Apr-2014.) $)
    eff $p |- exp : CC --> CC $=
      ( vx vk vn cc cn0 cv cexp co cfa cfv cdiv csu ce df-ef wcel cmpt nn0uz cz
      cc0 0z a1i wceq eqid eftval adantl eftcl efcllem isumcl fmpti ) ADDEAFZBF
      ZGHUKIJKHZBLMABNUJDOZULBCEUJCFZGHUNIJKHPZSEQSROUMTUAUKEOUKUOJULUBUMUJCUOU
      KUOUCZUDUEUJUKUFUJCUOUPUGUHUI $.

    $( Closure law for the exponential function.  (Contributed by NM,
       8-Jan-2006.)  (Revised by Mario Carneiro, 10-Nov-2013.) $)
    efcl $p |- ( A e. CC -> ( exp ` A ) e. CC ) $=
      ( cc ce eff ffvelrni ) BBACDE $.
  $}

  ${
    $d k n A $.  $d k F $.
    efcvg.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    $( Value of the exponential function.  (Contributed by Mario Carneiro,
       29-Apr-2014.) $)
    efval2 $p |- ( A e. CC -> ( exp ` A ) = sum_ k e. NN0 ( F ` k ) ) $=
      ( cc wcel ce cfv cn0 cv cexp co cfa cdiv csu efval eftval sumeq2i syl6eqr
      ) AFGAHIJABKZLMUANIOMZBPJUADIZBPABQJUCUBBACDUAERST $.

    $( The series that defines the exponential function converges to it.
       (Contributed by NM, 9-Jan-2006.)  (Revised by Mario Carneiro,
       28-Apr-2014.) $)
    efcvg $p |- ( A e. CC -> seq 0 ( + , F ) ~~> ( exp ` A ) ) $=
      ( vk cc wcel caddc cc0 cseq cn0 cv cexp co cfa cfv cdiv csu ce cli cz a1i
      nn0uz 0z wceq eftval adantl eftcl efcllem isumclim2 efval breqtrrd ) AFGZ
      HCIJKAELZMNUNOPQNZERASPTUMUOECIKUCIUAGUMUDUBUNKGUNCPUOUEUMABCUNDUFUGAUNUH
      ABCDUIUJAEUKUL $.
  $}

  ${
    $d j k n A $.  $d j F $.
    efcvgfsum.1 $e |- F = ( n e. NN0 |->
                        sum_ k e. ( 0 ... n ) ( ( A ^ k ) / ( ! ` k ) ) ) $.
    $( Exponential function convergence in terms of a sequence of partial
       finite sums.  (Contributed by NM, 10-Jan-2006.)  (Revised by Mario
       Carneiro, 28-Apr-2014.) $)
    efcvgfsum $p |- ( A e. CC -> F ~~> ( exp ` A ) ) $=
      ( vj cc wcel caddc cn0 cv cexp co cfa cfv cdiv cc0 wceq cfz wfn cmpt cseq
      ce cli wral wa csu oveq2 sumeq1d sumex adantl elfznn0 eqid eftval syl cuz
      fvmpt simpr nn0uz syl6eleq simpll eftcl syl2anc eqtrd ralrimiva wb fnmpti
      fsumser cz 0z seqfn ax-mp fneq2i mpbir eqfnfv mp2an sylibr efcvg eqbrtrd
      ) AGHZDICJACKZLMWANOPMUAZQUBZAUCOUDVTFKZDOZWDWCOZRZFJUEZDWCRZVTWGFJVTWDJH
      ZUFZWEQWDSMZABKZLMWMNOPMZBUGZWFWJWEWORVTCWDQWASMZWNBUGZWOJDWAWDRWPWLWNBWA
      WDQSUHUIEWLWNBUJUQUKWKWNBWBQWDWKWMWLHZUFZWMJHZWMWBOWNRWRWTWKWMWDULUKZACWB
      WMWBUMZUNUOWKWDJQUPOZVTWJURUSUTWSVTWTWNGHVTWJWRVAXAAWMVBVCVHVDVEDJTWCJTZW
      IWHVFCJWQDWPWNBUJEVGXDWCXCTZQVIHXEVJIWBQVKVLJXCWCUSVMVNFJDWCVOVPVQACWBXBV
      RVS $.
  $}

  ${
    $d k n A $.
    $( The exponential function is real if its argument is real.  (Contributed
       by NM, 27-Apr-2005.)  (Revised by Mario Carneiro, 28-Apr-2014.) $)
    reefcl $p |- ( A e. RR -> ( exp ` A ) e. RR ) $=
      ( vk vn cr wcel ce cfv cn0 cv cexp co cfa cdiv csu cc wceq recn efval syl
      cc0 cmpt nn0uz cz 0z a1i eqid eftval adantl reeftcl caddc cli cdm efcllem
      cseq isumrecl eqeltrd ) ADEZAFGZHABIZJKUSLGMKZBNZDUQAOEZURVAPAQZABRSUQUTB
      CHACIZJKVDLGMKUAZTHUBTUCEUQUDUEUSHEUSVEGUTPUQACVEUSVEUFZUGUHAUSUIUQVBUJVE
      TUNUKULEVCACVEVFUMSUOUP $.

    reefcld.1 $e |- ( ph -> A e. RR ) $.
    $( The exponential function is real if its argument is real.  (Contributed
       by Mario Carneiro, 29-May-2016.) $)
    reefcld $p |- ( ph -> ( exp ` A ) e. RR ) $=
      ( cr wcel ce cfv reefcl syl ) ABDEBFGDECBHI $.
  $}

  $( Euler's constant ` _e ` = 2.71828... is a real number.  (Contributed by
     NM, 19-Mar-2005.)  (Revised by Steve Rodriguez, 8-Mar-2006.) $)
  ere $p |- _e e. RR $=
    ( ceu c1 ce cfv cr df-e wcel 1re reefcl ax-mp eqeltri ) ABCDZEFBEGLEGHBIJK
    $.

  ${
    $d k n $.  $d k F $.  $d k G $.
    erelem1.1 $e |- F = ( n e. NN |-> ( 2 x. ( ( 1 / 2 ) ^ n ) ) ) $.
    erelem1.2 $e |- G = ( n e. NN0 |-> ( 1 / ( ! ` n ) ) ) $.
    $( Lemma for ~ egt2lt3 .  (Contributed by NM, 20-Mar-2005.)  (Proof
       shortened by Mario Carneiro, 28-Apr-2014.) $)
    ege2le3 $p |- ( 2 <_ _e /\ _e <_ 3 ) $=
      ( c2 ceu cle wbr wtru c1 caddc cc0 cfv co cn0 wcel wceq cdiv cexp vk cseq
      c3 nn0uz 0nn0 1e0p1 0z cv cfa fveq2 fac0 syl6eq oveq2d ax-1cn div1i fvmpt
      1ex mp1i seq1i 1nn0 fac1 seqp1i df-2 syl6eqr a1i ce cli cc cmpt nn0z 1exp
      cz oveq1d mpteq2ia eqtr4i efcvg df-e syl6breqr wa cr ovex adantl cn faccl
      syl nnrecred eqeltrd clt nnred nngt0d 1re divge0 mpanl12 syl2anc breqtrrd
      0le1 climserle eqbrtrrd trud cmin nnuz recnd clim2ser 0p1e1 seqeq1 oveq2i
      ax-mp 3brtr3g cmul 2cn oveq2 eqid nnrecre simpr reexpcl sylancr cabs 1lt2
      1z 2nn 2re 0re ltleii absid mp2an breqtrri georeclim 2m1e1 eqtri syl6breq
      2pos 2ne0 reccli exp0 nnnn0 sylan2 eqtr4d isermulc2 nnrpd wne mpbid nncnd
      mulid1i remulcl faclbnd2 nnexpcl rphalfcld lerecd divrecd mpanr12 exprecd
      nnne0d recdiv 3eqtr4rd 3brtr4d iserle ere lesubaddi mpbi df-3 pm3.2i ) FG
      HIZGUCHIUVBJKLCMUBZNZFGHJUVDKKLOFJKKLCKMMPUDUEUFJKLCMUGMPQZMCNKRJUEAMKAUH
      ZUINZSOZKPCUVFMRZUVHKKSOZKUVIUVGKKSUVIUVGMUINKUVFMUIUJUKULUMKUNUOZULEUQUP
      URUSZKPQZKCNKRJUTAKUVHKPCUVFKRZUVHUVJKUVNUVGKKSUVNUVGKUINKUVFKUIUJVAULUMU
      VKULEUQUPURVBVCVDJGUACMKPUDUVMJUTVEJUVCKVFNZGVGKVHQUVCUVOVGIJUNKACCAPUVHV
      IAPKUVFTOZUVGSOZVIEAPUVQUVHUVFPQZUVPKUVGSUVRUVFVLQUVPKRUVFVJUVFVKWEVMVNVO
      VPURVQVRZJUAUHZPQZVSZUVTCNZKUVTUINZSOZVTUWAUWCUWERZJAUVTUVHUWEPCUVFUVTRZU
      VGUWDKSUVFUVTUIUJUMEKUWDSWAUPWBZUWBUWDUWAUWDWCQJUVTWDWBZWFWGZUWBMUWEUWCHU
      WBUWDVTQZMUWDWHIZMUWEHIZUWBUWDUWIWIUWBUWDUWIWJKVTQMKHIUWKUWLVSUWMWKWPKUWD
      WLWMWNUWHWOWQWRWSGFKLOZUCHGKWTOZFHIZGUWNHIUWPJUWOFUACBKWCXAKVLQJXSVEZJLCM
      KLOZUBZGMUVCNZWTOLCKUBZUWOVGJGUACMMPUDUVEJUEVEZUWBUWCUWJXBUVSXCUWRKRZUWSU
      XARXDLCUWRKXEXGUWTKGWTUWTKRUVLWSXFXHJLBKUBFKXIOFVGJKFUAAPKFSOZUVFTOZVIZBK
      WCXAUWQFVHQZJXJVEZJLUXFUWRUBZFMLUXFMUBZNZWTOZLUXFKUBZKVGJFUAUXFMMPUDUXBUW
      BUVTUXFNZUXDUVTTOZVHUWAUXNUXORZJAUVTUXEUXOPUXFUVFUVTUXDTXKZUXFXLZUXDUVTTW
      AUPWBZUWBUXOUWBUXDVTQZUWAUXOVTQZFWCQZUXTXTFXMXGJUWAXNZUXDUVTXOXPZXBWGZJUX
      JFFKWTOZSOZFVGJFUAUXFUXHKFXQNZWHIJKFUYHWHXRFVTQZMFHIUYHFRYAMFYBYAYKYCFYDY
      EYFVEUXSYGUYGFKSOFUYFKFSYHXFFXJUOYIYJXCUXCUXIUXMRXDLUXFUWRKXEXGUXLUYFKUXK
      KFWTUXKKRJKLUXFMUGMUXFNZKRJUYJUXDMTOZKUVEUYJUYKRUEAMUXEUYKPUXFUVFMUXDTXKU
      XRUXDMTWAUPXGUXDVHQUYKKRFXJYLYMUXDYNXGYIVEUSWSXFYHYIXHUVTWCQZJUWAUXNVHQUV
      TYOZUYEYPJUYLVSZUVTBNZFUXOXIOZFUXNXIOUYLUYOUYPRJAUVTFUXEXIOUYPWCBUWGUXEUX
      OFXIUXQUMDFUXOXIWAUPWBZUYNUXNUXOFXIUYLJUWAUXPUYMUXSYPUMYQYRFXJUUCYJUYLJUW
      AUWCVTQUYMUWJYPUYNUYOUYPVTUYQUYLJUWAUYPVTQZUYMUWBUYIUYAUYRYAUYDFUXOUUDXPY
      PWGUYNUWEUYPUWCUYOHUYLJUWAUWEUYPHIUYMUWBUWEKFUVTTOZFSOZSOZUYPHUWBUYTUWDHI
      ZUWEVUAHIUWAVUBJUVTUUEWBUWBUYTUWDUWBUYSUWBUYSUWBUYBUWAUYSWCQXTUYCFUVTUUFX
      PZYSUUGUWBUWDUWIYSUUHUUAUWBFUYSSOZFKUYSSOZXIOVUAUYPUWBFUYSUXGUWBXJVEZUWBU
      YSVUCUUBZUWBUYSVUCUULZUUIUWBUYSVHQZUYSMYTZVUAVUDRZVUGVUHVUIVUJVSUXGFMYTZV
      UKXJYLUYSFUUMUUJWNUWBUXOVUEFXIUWBFUVTVUFVULUWBYLVEUWAUVTVLQJUVTVJWBUUKUMU
      UNWOYPUYLJUWAUWFUYMUWHYPUYQUUOUUPWSGKFUUQWKYAUURUUSUUTYFUVA $.
  $}

  $( Value of the exponential function at 0.  Equation 2 of [Gleason] p. 308.
     (Contributed by Steve Rodriguez, 27-Jun-2006.)  (Revised by Mario
     Carneiro, 28-Apr-2014.) $)
  ef0 $p |- ( exp ` 0 ) = 1 $=
    ( vn caddc cn0 cc0 cv cexp co cfa cfv cdiv cmpt cseq ce cli c1 wceq cc eqid
    wbr ax-mp wcel 0cn efcvg ef0lem climuni mp2an ) BACDAEZFGUGHIJGKZDLZDMIZNSZ
    UIONSZUJOPDQUAUKUBDAUHUHRZUCTDDPULDRDAUHUMUDTUJOUIUEUF $.

  ${
    $d j k m n A $.
    $( Exponential function of a complex conjugate.  Equation 3 of [Gleason]
       p. 308.  (Contributed by NM, 29-Apr-2005.)  (Revised by Mario Carneiro,
       28-Apr-2014.) $)
    efcj $p |- ( A e. CC -> ( exp ` ( * ` A ) ) = ( * ` ( exp ` A ) ) ) $=
      ( vn vj vk vm cc wcel caddc cn0 ccj cfv cv cexp co cdiv cc0 wceq nn0uz wa
      adantl cfa cmpt cseq ce cli wbr cjcl efcvg syl cvv seqex a1i cz 0z eftval
      eqid eftcl eqeltrd serf ffvelrnda addcl cfz simpl elfznn0 syl2an syl6eleq
      cuz simpr cjadd expcl faccl nncnd nnne0d cjdivd cjexp nnred cjred oveq12d
      cn eqtrd fveq2d 3eqtr4d seqhomo eqcomd climcj climuni syl2anc ) AFGZHBIAJ
      KZBLZMNWJUAKZONUBZPUCZWIUDKZUEUFZWMAUDKZJKZUEUFWNWQQWHWIFGWOAUGWIBWLWLUPZ
      UHUIWHWPCHBIAWJMNWKONUBZPUCZWMPUJIRABWSWSUPZUHWMUJGWHHWLPUKULPUMGWHUNULZW
      HIFCLZWTWHDWSPIRXBWHDLZIGZSZXDWSKZAXDMNZXDUAKZONZFXEXGXJQWHABWSXDXAUOTZAX
      DUQURZUSUTWHXCIGZSZXCWTKJKXCWMKXNDEHHFWSWLJPXCXDFGELZFGSZXDXOHNZFGXNXDXOV
      ATXNWHXEXGFGXDPXCVBNGZWHXMVCZXDXCVDZXLVEXNXCIPVGKWHXMVHRVFXPXQJKXDJKXOJKH
      NQXNXDXOVITXNWHXEXGJKZXDWLKZQXRXSXTXFXJJKZWIXDMNZXIONZYAYBXFYCXHJKZXIJKZO
      NYEXFXHXIAXDVJXFXIXEXIVSGWHXDVKTZVLXFXIYHVMVNXFYFYDYGXIOAXDVOXFXIXFXIYHVP
      VQVRVTXFXGXJJXKWAXEYBYEQWHWIBWLXDWRUOTWBVEWCWDWEWNWQWMWFWG $.
  $}

  ${
    $d j k m n A $.  $d j k n B $.  $d j F $.  $d j k m G $.  $d j k m ph $.
    $d k H $.
    efadd.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    efadd.2 $e |- G = ( n e. NN0 |-> ( ( B ^ n ) / ( ! ` n ) ) ) $.
    efadd.3 $e |- H = ( n e. NN0 |-> ( ( ( A + B ) ^ n ) / ( ! ` n ) ) ) $.
    efadd.4 $e |- ( ph -> A e. CC ) $.
    efadd.5 $e |- ( ph -> B e. CC ) $.
    $( Lemma for ~ efadd (exponential function addition law).  (Contributed by
       Mario Carneiro, 29-Apr-2014.) $)
    efaddlem $p |- ( ph ->
                     ( exp ` ( A + B ) ) = ( ( exp ` A ) x. ( exp ` B ) ) ) $=
      ( vj co cfv cmul wceq wcel cexp cdiv vk vm caddc cc0 ce cli wbr cc addcld
      cseq efcvg syl cn0 cv cfa csu cabs eftval adantl wa absexp sylan cn faccl
      cmpt nnre nnnn0 nn0ge0d absidd oveq12d expcl nnne0d absdivd eqid 3eqtr4rd
      nncnd eftcl cfz cmin cbc adantr simpr binom syl3anc oveq1d fzfid ad2antrr
      bccl2 fznn0sub expcld elfznn0 mulcld fsumdivc divcld eqeltrd oveq2 fveq2d
      fveq2 fsumrev2 oveq2d nnmulcld divrec2d divmuldivd bcval2 divdiv32d eqtrd
      c1 wne dividd eqtr4d nn0cn ad2antlr addid2d nncand div23d sumeq2dv syl6eq
      cbvsumv cdm abscld recnd efcllem mertens efval breqtrrd climuni syl2anc )
      AUCGUDUJZBCUCNZUEOZUFUGZYHBUEOZCUEOZPNZUFUGYJYNQAYIUHRYKABCKLUIYIDGJUKULA
      YHUMBMUNZSNZYOUOOZTNZMUPZUMCUAUNZSNYTUOOZTNZUAUPZPNYNUFAYRUUBMUAEFGDUMBUQ
      OZDUNZSNUUEUOOTNVEZYOUMRZYOEOYRQABDEYOHURUSAUUGUTZYPUQOZYQUQOZTNUUDYOSNZY
      QTNZYRUQOYOUUFOZUUHUUIUUKUUJYQTABUHRZUUGUUIUUKQKBYOVAVBUUHYQVCRZUUJYQQUUG
      UUOAYOVDZUSZUUOYQYQVFUUOYQYQVGVHVIULVJUUHYPYQAUUNUUGYPUHRKBYOVKVBUUHYQUUQ
      VPUUHYQUUQVLVMUUGUUMUULQAUUDDUUFYOUUFVNZURUSVOAUUNUUGYRUHRKBYOVQVBYTUMRZY
      TFOUUBQACDFYTIURUSACUHRZUUSUUBUHRLCYTVQVBAUUSUTZYTGOZYIYTSNZUUATNZUDYTVRN
      ZYRYTYOVSNZFOZPNZMUPZUUSUVBUVDQAYIDGYTJURUSUVAUVDUVEYTYOVTNZBUVFSNZCYOSNZ
      PNZPNZMUPZUUATNZUVIUVAUVCUVOUUATUVAUUNUUTUUSUVCUVOQAUUNUUSKWAAUUTUUSLWAAU
      USWBBCMYTWCWDWEUVAUVPUVEUVNUUATNZMUPZUVIUVAUVEUVNUUAMUVAUDYTWFUVAUUAUUSUU
      AVCRAYTVDUSZVPZUVAYOUVERZUTZUVJUVMUWBUVJUWAUVJVCRUVAYOYTWHUSVPZUWBUVKUVLU
      WBBUVFAUUNUUSUWAKWGZUWAUVFUMRZUVAYOUDYTWIUSZWJZUWBCYOAUUTUUSUWALWGZUWAUUG
      UVAYOYTWKUSZWJZWLZWLUVAUUAUVSVLZWMUVAUVIUVEBUDYTUCNZUBUNZVSNZSNZUWOUOOZTN
      ZYTUWOVSNZFOZPNZUBUPZUVRUVAUVHUXAMUBUDYTUWBYRUVGUWBYPYQUWBBYOUWDUWIWJUWBY
      QUWBUUGUUOUWIUUPULZVPZUWBYQUXCVLZWNUWBUVGCUVFSNZUVFUOOZTNZUHUWBUWEUVGUXHQ
      UWFCDFUVFIURULUWBUXFUXGUWBCUVFUWHUWFWJUWBUXGUWBUWEUXGVCRUWFUVFVDULZVPZUWB
      UXGUXIVLZWNWOWLYOUWOQZYRUWRUVGUWTPUXLYPUWPYQUWQTYOUWOBSWPYOUWOUOWRVJUXLUV
      FUWSFYOUWOYTVSWPWQVJWSUVAUVRUVEBUWMYOVSNZSNZUXMUOOZTNZYTUXMVSNZFOZPNZMUPU
      XBUVAUVEUVQUXSMUWBUVKUXGTNZYOFOZPNZUVJUUATNZUVMPNZUXSUVQUWBUYBUXTUVLYQTNZ
      PNZUYDUWBUYAUYEUXTPUWBUUGUYAUYEQUWICDFYOIURULWTUWBUVMUXGYQPNZTNXGUYGTNZUV
      MPNUYFUYDUWBUVMUYGUWKUWBUYGUWBUXGYQUXIUXCXAZVPZUWBUYGUYIVLZXBUWBUVKUXGUVL
      YQUWGUXJUWJUXDUXKUXEXCUWBUYCUYHUVMPUWBUYCUUAUYGTNZUUATNZUYHUWBUVJUYLUUATU
      WAUVJUYLQUVAYOYTXDUSWEUWBUYMUUAUUATNZUYGTNUYHUWBUUAUYGUUAUVAUUAUHRUWAUVTW
      AZUYJUYOUYKUVAUUAUDXHUWAUWLWAZXEUWBUYNXGUYGTUWBUUAUYOUYPXIWEXFXFWEVOXJUWB
      UXPUXTUXRUYAPUWBUXNUVKUXOUXGTUWBUXMUVFBSUWBUWMYTYOVSUWBYTUUSYTUHRAUWAYTXK
      XLZXMWEZWTUWBUXMUVFUOUYRWQVJUWBUXQYOFUWBUXQYTUVFVSNYOUWBUXMUVFYTVSUYRWTUW
      BYTYOUYQUWBUUGYOUHRUWIYOXKULXNXFWQVJUWBUVJUVMUUAUWCUWKUYOUYPXOVOXPUVEUXSU
      XAMUBYOUWNQZUXPUWRUXRUWTPUYSUXNUWPUXOUWQTUYSUXMUWOBSYOUWNUWMVSWPZWTUYSUXM
      UWOUOUYTWQVJUYSUXQUWSFUYSUXMUWOYTVSUYTWTWQVJXRXQXJXJXFXFAUUDUHRUCUUFUDUJU
      FXSZRAUUDABKXTYAUUDDUUFUURYBULAUUTUCFUDUJVUARLCDFIYBULYCAYLYSYMUUCPAUUNYL
      YSQKBMYDULAUUTYMUUCQLCUAYDULVJYEYJYNYHYFYG $.
  $}

  ${
    $d n A $.  $d n B $.
    $( Sum of exponents law for exponential function.  (Contributed by NM,
       10-Jan-2006.)  (Proof shortened by Mario Carneiro, 29-Apr-2014.) $)
    efadd $p |- ( ( A e. CC /\ B e. CC ) ->
                 ( exp ` ( A + B ) ) = ( ( exp ` A ) x. ( exp ` B ) ) ) $=
      ( vn cc wcel wa cn0 cv cexp cfa cdiv cmpt caddc eqid simpl simpr efaddlem
      co cfv ) ADEZBDEZFABCCGACHZIRUBJSZKRLZCGBUBIRUCKRLZCGABMRUBIRUCKRLZUDNUEN
      UFNTUAOTUAPQ $.
  $}

  $( Cancellation of law for exponential function.  Equation 27 of [Rudin]
     p. 164.  (Contributed by NM, 13-Jan-2006.) $)
  efcan $p |- ( A e. CC -> ( ( exp ` A ) x. ( exp ` -u A ) ) = 1 ) $=
    ( cc wcel cneg caddc co ce cfv cmul wceq negcl efadd mpdan cc0 negid fveq2d
    c1 ef0 syl6eq eqtr3d ) ABCZAADZEFZGHZAGHUBGHIFZQUAUBBCUDUEJAKAUBLMUAUDNGHQU
    AUCNGAOPRST $.

  $( The exponential function never vanishes.  Corollary 15-4.3 of [Gleason]
     p. 309.  (Contributed by NM, 13-Jan-2006.)  (Revised by Mario Carneiro,
     29-Apr-2014.) $)
  efne0 $p |- ( A e. CC -> ( exp ` A ) =/= 0 ) $=
    ( cc wcel c1 cc0 wne ce cfv ax-1ne0 wceq cneg cmul co oveq1 efcan negcl syl
    efcl mul02d eqeq12d syl5ib necon3d mpi ) ABCZDEFAGHZEFIUDUEEDEUEEJUEAKZGHZL
    MZEUGLMZJUDDEJUEEUGLNUDUHDUIEAOUDUGUDUFBCUGBCAPUFRQSTUAUBUC $.

  $( Exponent of a negative number.  (Contributed by Mario Carneiro,
     10-May-2014.) $)
  efneg $p |- ( A e. CC -> ( exp ` -u A ) = ( 1 / ( exp ` A ) ) ) $=
    ( cc wcel ce cfv cneg cmul co cdiv c1 negcl syl efne0 divcan3d efcan oveq1d
    efcl eqtr3d ) ABCZADEZAFZDEZGHZTIHUBJTIHSUBTSUABCUBBCAKUAQLAQAMNSUCJTIAOPR
    $.

  $( The exponential function maps the complex numbers to the nonzero complex
     numbers.  (Contributed by Paul Chapman, 16-Apr-2008.) $)
  eff2 $p |- exp : CC --> ( CC \ { 0 } ) $=
    ( vx cc cc0 csn cdif ce wf wfn cfv wcel wral eff ffn ax-mp wne efcl eldifsn
    cv efne0 sylanbrc rgen ffnfv mpbir2an ) BBCDEZFGFBHZARZFIZUDJZABKBBFGUELBBF
    MNUHABUFBJUGBJUGCOUHUFPUFSUGBCQTUAABUDFUBUC $.

  $( Difference of exponents law for exponential function.  (Contributed by
     Steve Rodriguez, 25-Nov-2007.) $)
  efsub $p |- ( ( A e. CC /\ B e. CC ) ->
               ( exp ` ( A - B ) ) = ( ( exp ` A ) / ( exp ` B ) ) ) $=
    ( cc wcel wa ce cfv cdiv co c1 cmul cneg caddc cmin wceq cc0 wne efcl efne0
    divrec syl3an 3anidm23 efcan eqcomd wb negcl ax-1cn divmul2 mp3an1 syl12anc
    syl mpbird oveq2d adantl efadd sylan2 eqtr4d negsub fveq2d 3eqtrrd ) ACDZBC
    DZEZAFGZBFGZHIZVDJVEHIZKIZABLZMIZFGZABNIZFGVAVBVFVHOZVAVDCDVBVECDZVBVEPQZVM
    ARBRZBSZVDVETUAUBVCVHVDVIFGZKIZVKVBVHVSOVAVBVGVRVDKVBVGVROZJVEVRKIZOZVBWAJB
    UCUDVBVRCDZVNVOVTWBUEZVBVICDZWCBUFZVIRUKVPVQJCDWCVNVOEWDUGJVRVEUHUIUJULUMUN
    VBVAWEVKVSOWFAVIUOUPUQVCVJVLFABURUSUT $.

  ${
    $d j N $.  $d j k A $.
    $( Exponential function to an integer power.  Corollary 15-4.4 of [Gleason]
       p. 309, restricted to integers.  (Contributed by NM, 13-Jan-2006.)
       (Revised by Mario Carneiro, 5-Jun-2014.) $)
    efexp $p |- ( ( A e. CC /\ N e. ZZ ) ->
                 ( exp ` ( N x. A ) ) = ( ( exp ` A ) ^ N ) ) $=
      ( cc wcel wa cmul co ce cfv cexp sylan2 fveq2d cc0 c1 caddc oveq2 eqeq12d
      wceq adantr eqtrd vj vk cz zcn mulcom cv cneg ef0 mul01 exp0d 3eqtr4a cn0
      efcl oveq1 adantl nn0cn ax-1cn adddi mp3an3 mulcl simpl efadd expp1 sylan
      mulid1 oveq2d syl2anc 3eqtr4d exp31 cn cdiv nncn mulneg2 efneg syl expneg
      wi nnnn0 syl2an syl5ibr ex zindd imp eqtr3d ) ACDZBUCDZEZABFGZHIZBAFGZHIA
      HIZBJGZWGWHWJHWFWEBCDWHWJRBUDABUEKLWEWFWIWLRZAUAUFZFGZHIZWKWNJGZRAMFGZHIZ
      WKMJGZRAUBUFZFGZHIZWKXAJGZRZAXAUGZFGZHIZWKXFJGZRZAXANOGZFGZHIZWKXKJGZRZWM
      WEUAUBBWNMRZWPWSWQWTXPWOWRHWNMAFPLWNMWKJPQWNXARZWPXCWQXDXQWOXBHWNXAAFPLWN
      XAWKJPQWNXKRZWPXMWQXNXRWOXLHWNXKAFPLWNXKWKJPQWNXFRZWPXHWQXIXSWOXGHWNXFAFP
      LWNXFWKJPQWNBRZWPWIWQWLXTWOWHHWNBAFPLWNBWKJPQWEMHINWSWTUHWEWRMHAUILWEWKAU
      MZUJUKWEXAULDZXEXOWEYBEZXEEXCWKFGZXDWKFGZXMXNXEYDYERYCXCXDWKFUNUOYCXMYDRX
      EYCXMXBAOGZHIZYDYCXLYFHYBWEXACDZXLYFRXAUPZWEYHEZXLXBANFGZOGZYFWEYHNCDXLYL
      RUQAXANURUSYJYKAXBOWEYKARYHAVESVFTKLYCXBCDZWEYGYDRYBWEYHYMYIAXAUTZKWEYBVA
      XBAVBVGTSYCXNYERZXEWEWKCDZYBYOYAWKXAVCVDSVHVIWEXAVJDZXEXJVQXEXJWEYQEZNXCV
      KGZNXDVKGZRXCXDNVKPYRXHYSXIYTYRXHXBUGZHIZYSYRXGUUAHYQWEYHXGUUARXAVLZAXAVM
      KLYRYMUUBYSRYQWEYHYMUUCYNKXBVNVOTWEYPYBXIYTRYQYAXAVRWKXAVPVSQVTWAWBWCWD
      $.
  $}

  $( Value of the exponential function for integers.  Special case of
     ~ efval .  Equation 30 of [Rudin] p. 164.  (Contributed by Steve
     Rodriguez, 15-Sep-2006.)  (Revised by Mario Carneiro, 5-Jun-2014.) $)
  efzval $p |- ( N e. ZZ -> ( exp ` N ) = ( _e ^ N ) ) $=
    ( cz wcel ce cfv c1 cexp co ceu cmul zcn mulid1d fveq2d cc wceq ax-1cn mpan
    efexp eqtr3d df-e oveq1i syl6eqr ) ABCZADEZFDEZAGHZIAGHUCAFJHZDEZUDUFUCUGAD
    UCAAKLMFNCUCUHUFOPFARQSIUEAGTUAUB $.

  $( The exponential function of a real number is greater than 0.  (Contributed
     by Paul Chapman, 21-Aug-2007.)  (Revised by Mario Carneiro,
     30-Apr-2014.) $)
  efgt0 $p |- ( A e. RR -> 0 < ( exp ` A ) ) $=
    ( cr wcel ce cfv reefcl cc0 c2 cdiv co cexp rehalfcl reefcld sqge0d cmul cc
    cle wceq wne syl cz recnd 2z efexp sylancl recn 2ne0 divcan2 mp3an23 fveq2d
    2cn eqtr3d breqtrd efne0 ne0gt0d ) ABCZADEZAFUPGAHIJZDEZHKJZUQQUPUSUPURALZM
    NUPHUROJZDEZUTUQUPURPCHUACVCUTRUPURVAUBUCURHUDUEUPVBADUPAPCZVBARZAUFZVDHPCH
    GSVEUKUGAHUHUITUJULUMUPVDUQGSVFAUNTUO $.

  $( The exponential function of a real number is a positive real.
     (Contributed by Mario Carneiro, 10-Nov-2013.) $)
  rpefcl $p |- ( A e. RR -> ( exp ` A ) e. RR+ ) $=
    ( cr wcel ce cfv reefcl efgt0 elrpd ) ABCADEAFAGH $.

  ${
    rpefcld.1 $e |- ( ph -> A e. RR ) $.
    $( The exponential function of a real number is a positive real.
       (Contributed by Mario Carneiro, 29-May-2016.) $)
    rpefcld $p |- ( ph -> ( exp ` A ) e. RR+ ) $=
      ( cr wcel ce cfv crp rpefcl syl ) ABDEBFGHECBIJ $.
  $}

  ${
    $d j k n A $.  $d k F $.  $d j k G $.  $d j H $.  $d j k n M $.
    $d j k ph $.
    eftl.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    $( The tail series of the exponential function are convergent.
       (Contributed by Mario Carneiro, 29-Apr-2014.) $)
    eftlcvg $p |- ( ( A e. CC /\ M e. NN0 ) -> seq M ( + , F ) e. dom ~~> ) $=
      ( vk cc wcel cn0 wa caddc cc0 cseq cli cdm efcllem adantr nn0uz cfv co cv
      simpr cexp cfa cdiv wceq eftval adantl eftcl adantlr eqeltrd iserex mpbid
      ) AGHZDIHZJZKCLMNOZHZKCDMUQHUNURUOABCEPQUPFCLDIRUNUOUBUPFUAZIHZJUSCSZAUSU
      CTUSUDSUETZGUTVAVBUFUPABCUSEUGUHUNUTVBGHUOAUSUIUJUKULUM $.

    $( Closure of the sum of an infinite tail of the series defining the
       exponential function.  (Contributed by Paul Chapman, 17-Jan-2008.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    eftlcl $p |- ( ( A e. CC /\ M e. NN0 ) ->
                    sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. CC ) $=
      ( cc wcel cn0 wa cv cfv cuz eqid cz nn0z adantl eqidd cexp co cfa eluznn0
      cdiv wceq adantll eftval syl simpll eftcl syl2anc eqeltrd eftlcvg isumcl
      ) AGHZEIHZJZBKZDLZBDEEMLZUSNUOEOHUNEPQUPUQUSHZJZURRVAURAUQSTUQUALUCTZGVAU
      QIHZURVBUDUOUTVCUNUQEUBUEZACDUQFUFUGVAUNVCVBGHUNUOUTUHVDAUQUIUJUKACDEFULU
      M $.

    $( Closure of the sum of an infinite tail of the series defining the
       exponential function.  (Contributed by Paul Chapman, 17-Jan-2008.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    reeftlcl $p |- ( ( A e. RR /\ M e. NN0 ) ->
                      sum_ k e. ( ZZ>= ` M ) ( F ` k ) e. RR ) $=
      ( cr wcel cn0 wa cv cfv cuz eqid cz nn0z adantl eqidd cexp co cfa eluznn0
      cdiv wceq adantll eftval syl simpll reeftcl syl2anc eqeltrd cc caddc cseq
      cli cdm recn eftlcvg sylan isumrecl ) AGHZEIHZJZBKZDLZBDEEMLZVFNVBEOHVAEP
      QVCVDVFHZJZVERVHVEAVDSTVDUALUCTZGVHVDIHZVEVIUDVBVGVJVAVDEUBUEZACDVDFUFUGV
      HVAVJVIGHVAVBVGUHVKAVDUIUJUKVAAULHVBUMDEUNUOUPHAUQACDEFURUSUT $.

    eftl.2 $e |- G = ( n e. NN0 |-> ( ( ( abs ` A ) ^ n ) / ( ! ` n ) ) ) $.
    eftl.3 $e |- H = ( n e. NN0 |->
      ( ( ( ( abs ` A ) ^ M ) / ( ! ` M ) ) x. ( ( 1 / ( M + 1 ) ) ^ n ) ) ) $.
    eftl.4 $e |- ( ph -> M e. NN ) $.
    eftl.5 $e |- ( ph -> A e. CC ) $.
    eftl.6 $e |- ( ph -> ( abs ` A ) <_ 1 ) $.
    $( An upper bound on the absolute value of the infinite tail of the series
       expansion of the exponential function on the closed unit disk.
       (Contributed by Paul Chapman, 19-Jan-2008.)  (Proof shortened by Mario
       Carneiro, 29-Apr-2014.) $)
    eftlub $p |- ( ph -> ( abs ` sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) <_
          ( ( ( abs ` A ) ^ M ) x. ( ( M + 1 ) / ( ( ! ` M ) x. M ) ) ) ) $=
      ( cfv co cmul cdiv wcel cc0 vj cuz cv csu cabs c1 caddc cfa cc cn0 nnnn0d
      cexp eftlcl syl2anc abscld cr reeftlcl reexpcld peano2nn0 nn0red cn faccl
      nnmulcld nndivred remulcld eqid nnzd wa eqidd eluznn0 sylan eftval adantl
      syl wceq eftcl eqeltrd syldan cseq cli cdm eftlcvg isumclim2 recnd eftabs
      reeftcl fveq2d 3eqtr4rd iserabs cle cneg cshi nn0uz cz 0z a1i nncnd nn0cn
      cmpt cvv nn0ex mptex eqeltri shftval4 syl2an nn0addcl adantr oveq2 oveq2d
      ovex fvmpt peano2nnd nnrecred reexpcl nnred uzid uzaddcl absge0d leexp2rd
      wbr nnexpcl expge0d jca mpbid nnne0d divassd divdiv1d eqtrd breqtrd letrd
      clt wb mpbird eqbrtrd cmin sylancr seqex sylancl breldm eqtr4d lemuldiv2d
      faclbnd6 lemul1a syl31anc nn0z exprecd divrecd wne facne0 3eqtr2rd nngt0d
      nnrpd ledivmul syl112anc znegcld seqshft 0cn subneg mpan seqeq1d climshft
      addid2 sumex nnge1d 1nn nnleltp1 nn0ge0d absidd breqtrrd georeclim ax-1cn
      isermulc2 pncan div23d mulcomd 3eqtrd isumle fveq2 eleq2d biimpa isumshft
      addid2d sumeq1d eqtr3d isumclim 3brtr3d ) AHUBOZCUCZEOZCUDZUEOUWGUWHFOZCU
      DZBUEOZHULPZHUFUGPZHUHOZHQPZRPZQPZAUWJABUISZHUJSZUWJUISMAHLUKZBCDEHIUMUNU
      OAUWMUPSZUXAUWLUPSABMUOZUXBUWMCDFHJUQUNAUWNUWRAUWMHUXDUXBURZAUWOUWQAUWOAU
      XAUWOUJSUXBHUSVNZUTZAUWPHAUXAUWPVASZUXBHVBVNZLVCVDVEAUWJUWLCEFHUWGUWGVFZA
      UWICEHUWGUXJAHLVGZAUWHUWGSZVHZUWIVIAUXLUWHUJSZUWIUISAUXAUXLUXNUXBUWHHVJVK
      ZAUXNVHZUWIBUWHULPUWHUHOZRPZUIUXNUWIUXRVOABDEUWHIVLVMZAUWTUXNUXRUISMBUWHV
      PVKVQVRZAUWTUXAUGEHVSVTWAZSMUXBBDEHIWBUNWCAUWKCFHUWGUXJUXKUXMUWKVIUXMUWKA
      UXLUXNUWKUPSUXOUXPUWKUWMUWHULPUXQRPZUPUXNUWKUYBVOAUWMDFUWHJVLVMZAUXCUXNUY
      BUPSUXDUWMUWHWFVKVQVRWDZAUWMUISUXAUGFHVSZUYASAUWMUXDWDUXBUWMDFHJWBUNWCZUX
      KUXTAUXLUXNUWKUWIUEOZVOUXOUXPUXRUEOZUYBUYGUWKAUWTUXNUYHUYBVOMBUWHWEVKUXPU
      WIUXRUEUXSWGUYCWHVRWIAUJHUAUCZUGPZFOZUAUDZUJUWNUWPRPZUFUWORPZUYIULPZQPZUA
      UDUWLUWSWJAUYKUYPUAFHWKZWLPZGTUJWMTWNSZAWOWPZAHUISZUYIUISUYIUYROUYKVOUYIU
      JSZAHLWQZUYIWRHUYIFFDUJUWMDUCZULPVUDUHORPZWSWTJDUJVUEXAXBXCZXDXEAVUBVHZUY
      KUWMUYJULPZUYJUHOZRPZUPVUGUYJUJSZUYKVUJVOAUXAVUBVUKUXBHUYIXFVKZUWMDFUYJJV
      LVNZVUGUXCVUKVUJUPSAUXCVUBUXDXGZVULUWMUYJWFUNVQVUBUYIGOZUYPVOADUYIUYMUYNV
      UDULPZQPUYPUJGVUDUYIVOVUPUYOUYMQVUDUYIUYNULXHZXIKUYMUYOQXJXKVMZVUGUYMUYOA
      UYMUPSVUBAUWNUWPUXEUXIVDZXGAUYNUPSVUBUYOUPSAUWOAHLXLZXMUYNUYIXNVKZVEZVUGU
      YKVUJUYPWJVUMVUGVUJUYPWJXTZVUHVUIUYPQPZWJXTZVUGVUHUWNVVDVUGUWMUYJVUNVULUR
      ZAUWNUPSZVUBUXEXGZVUGVUIUYPVUGVUIVUGVUKVUIVASVULUYJVBVNZXOZVVBVEVUGUWMHUY
      JVUNAUXAVUBUXBXGAHUWGSZVUBUYJUWGSAHWNSVVKUXKHXPVNUYIHHXQVKATUWMWJXTVUBABM
      XRZXGAUWMUFWJXTVUBNXGXSVUGUWNVUIUWNQPZUWPUWOUYIULPZQPZRPZVVDWJVUGVVOUWNQP
      VVMWJXTZUWNVVPWJXTVUGVVOUPSVUIUPSZVVGTUWNWJXTZVHZVVOVUIWJXTZVVQVUGVVOVUGU
      WPVVNAUXHVUBUXIXGAUWOVASZVUBVVNVASVUTUWOUYIYAVKZVCZXOVVJAVVTVUBAVVGVVSUXE
      AUWMHUXDUXBVVLYBYCXGAUXAVUBVWAUXBUYIHUUBVKVVOVUIUWNUUCUUDVUGUWNVVMVVOVVHV
      UGVUIUWNVVJVVHVEVUGVVOVWDUULUUAYDVUGVVPVUIUWNVVORPZQPVVDVUGVUIUWNVVOVUGVU
      IVVIWQAUWNUISVUBAUWNUXEWDZXGZVUGVVOVWDWQVUGVVOVWDYEYFVUGVWEUYPVUIQVUGUYPU
      YMUFVVNRPZQPUYMVVNRPVWEVUGUYOVWHUYMQVUGUWOUYIAUWOUISVUBAUWOVUTWQZXGVUGUWO
      AVWBVUBVUTXGYEVUBUYIWNSAUYIUUEVMUUFXIVUGUYMVVNAUYMUISVUBAUYMVUSWDZXGVUGVV
      NVWCWQZVUGVVNVWCYEZUUGVUGUWNUWPVVNVWGAUWPUISVUBAUWPUXIWQZXGVWKAUWPTUUHZVU
      BAUXAVWNUXBHUUIVNZXGVWLYGUUJXIYHYIYJVUGVUHUPSUYPUPSVVRTVUIYKXTVVCVVEYLVVF
      VVBVVJVUGVUIVVIUUKVUHUYPVUIUUMUUNYMYNAUGUYRTVSZUGFTUYQYOPZVSZUYQWLPZUYAAU
      YSUYQWNSZVWPVWSVOWOAHUXKUUOZUGFTUYQVUFUUPYPAVWSUWLVTXTZVWSUYASAVXBVWRUWLV
      TXTZAVWRUYEUWLVTAVWQHUGFAVUAVWQHVOVUCVUAVWQTHUGPZHTUISVUAVWQVXDVOUUQTHUUR
      UUSHUVBYHVNUUTUYFYNAVWTVWRWTSVXBVXCYLVXAUGFVWQYQUWLVWRUYQWTUVAYRYMVWSUWLV
      TVWRUYQWLXJUWGUWKCUVCYSVNVQAUGGTVSZUWSVTXTVXEUYASAVXEUYMUWOUWOUFYOPZRPZQP
      ZUWSVTAVXGUYMUADUJVUPWSZGTUJWMUYTVWJAUWOUAVXIVWIAUFUWOUWOUEOYKAUFHWJXTZUF
      UWOYKXTZAHLUVDAUFVASHVASVXJVXKYLUVELUFHUVFYPYDAUWOUXGAUWOUXFUVGUVHUVIVUBU
      YIVXIOZUYOVOADUYIVUPUYOUJVXIVUQVXIVFUYNUYIULXJXKVMZUVJVUGVXLUYOUIVXMVUGUY
      OVVAWDVQVUGVUOUYPUYMVXLQPVURVUGVXLUYOUYMQVXMXIYTUVLAVXHUWNUWOHRPZQPUWPRPZ
      UWNVXNUWPRPZQPUWSAVXHUYMVXNQPVXOAVXGVXNUYMQAVXFHUWORAVUAUFUISVXFHVOVUCUVK
      HUFUVMYRXIXIAUWNVXNUWPVWFAVXNAUWOHUXGLVDWDZVWMVWOUVNYTAUWNVXNUWPVWFVXQVWM
      VWOYFAVXPUWRUWNQAVXPUWOHUWPQPZRPUWRAUWOHUWPVWIVUCVWMAHLYEVWOYGAVXRUWQUWOR
      AHUWPVUCVWMUVOXIYHXIUVPYIZVXEUWSVTUGGTYQUWNUWRQXJYSVNUVQAVXDUBOZUWKCUDUYL
      UWLAUWKUYKCUAHTVXTUJWMVXTVFUWHUYJFUVRUXKUYTAUWHVXTSZUXLUWKUISAVYAUXLAVXTU
      WGUWHAVXDHUBAHVUCUWBWGZUVSUVTUYDVRUWAAVXTUWGUWKCVYBUWCUWDAUYPUWSUAGTUJWMU
      YTVURVUGUYPVVBWDVXSUWEUWFYJ $.
  $}

  ${
    $d k n A $.  $d k F $.  $d k n M $.  $d k n N $.  $d k ph $.
    efsep.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    efsep.2 $e |- N = ( M + 1 ) $.
    efsep.3 $e |- M e. NN0 $.
    efsep.4 $e |- ( ph -> A e. CC ) $.
    efsep.5 $e |- ( ph -> B e. CC ) $.
    efsep.6 $e |- ( ph -> ( exp ` A ) =
                    ( B + sum_ k e. ( ZZ>= ` M ) ( F ` k ) ) ) $.
    efsep.7 $e |- ( ph -> ( B + ( ( A ^ M ) / ( ! ` M ) ) ) = D ) $.
    $( Separate out the next term of the power series expansion of the
       exponential function.  The last hypothesis allows the separated terms to
       be rearranged as desired.  (Contributed by Paul Chapman, 23-Nov-2007.)
       (Revised by Mario Carneiro, 29-Apr-2014.) $)
    efsep $p |- ( ph -> ( exp ` A ) =
                  ( D + sum_ k e. ( ZZ>= ` N ) ( F ` k ) ) ) $=
      ( cfv caddc co wcel ce cuz cv csu cexp cfa cdiv c1 eqid cz nn0zi wa eqidd
      a1i cn0 cc eluznn0 mpan wceq eftval adantl eftcl sylan eqeltrd sylan2 cli
      cseq cdm eftlcvg sylancl isum1p ax-mp eqcomi fveq2i sumeq1i syl6eq oveq2d
      oveq12i peano2nn0 eqeltri eftlcl addassd eqtr4d oveq1d 3eqtrd ) ABUAQCHUB
      QZEUCZGQZEUDZRSZCBHUESHUFQUGSZRSZIUBQZWHEUDZRSZDWNRSOAWJCWKWNRSZRSWOAWIWP
      CRAWIHGQZHUHRSZUBQZWHEUDZRSWPAWHEGHWFWFUIHUJTAHLUKUNAWGWFTZULWHUMXAAWGUOT
      ZWHUPTHUOTZXAXBLWGHUQURAXBULWHBWGUESWGUFQUGSZUPXBWHXDUSABFGWGJUTVAABUPTZX
      BXDUPTMBWGVBVCVDVEAXEXCRGHVGVFVHTMLBFGHJVIVJVKWQWKWTWNRXCWQWKUSLBFGHJUTVL
      WSWMWHEWRIUBIWRKVMVNVOVRVPVQACWKWNNAXEXCWKUPTMLBHVBVJAXEIUOTWNUPTMIWRUOKX
      CWRUOTLHVSVLVTBEFGIJWAVJWBWCAWLDWNRPWDWE $.
  $}

  ${
    $d k n A $.  $d k F $.  $d k N $.  $d k ph $.
    effsumlt.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    effsumlt.2 $e |- ( ph -> A e. RR+ ) $.
    effsumlt.3 $e |- ( ph -> N e. NN0 ) $.
    $( The partial sums of the series expansion of the exponential function of
       a positive real number are bounded by the value of the function.
       (Contributed by Paul Chapman, 21-Aug-2007.)  (Revised by Mario Carneiro,
       29-Apr-2014.) $)
    effsumlt $p |- ( ph -> ( seq 0 ( + , F ) ` N ) < ( exp ` A ) ) $=
      ( vk caddc cc0 cfv c1 co csu cn0 cr nn0uz wcel cc cuz cv ce clt cz 0z a1i
      cseq wa cexp cdiv wceq eftval adantl rpred reeftcl sylan eqeltrd ffvelrnd
      cfa serfre eqid peano2nn0 syl eqidd nn0z rpexpcl syl2an cn faccl rpdivcld
      crp nnrpd cli cdm recnd efcllem isumrpcl ltaddrpd efval2 isumsplit nn0cnd
      cmin cfz ax-1cn pncan sylancl oveq2d sumeq1d elfznn0 sylan2 fsumser eqtrd
      syl6eleq oveq1d 3eqtrd breqtrrd ) AEJDKUHZLZWSEMJNZUALZIUBZDLZIOZJNZBUCLZ
      UDAWSXDAPQEWRAIDKPRKUESAUFUGAXBPSZUIZXCBXBUJNZXBUTLZUKNZQXGXCXKULABCDXBFU
      MUNZABQSXGXKQSABGUOZBXBUPUQURZVAHUSAXCIDKWTXAPRXAVBZAEPSWTPSHEVCVDZXHXCVE
      ZXHXCXKVLXLXHXIXJABVLSXBUESXIVLSXGGXBVFBXBVGVHXHXJXGXJVISAXBVJUNVMVKURABT
      SZWRVNVOSABXMVPZBCDFVQVDZVRVSAXFPXCIOZKWTMWCNZWDNZXCIOZXDJNXEAXRXFYAULXSB
      ICDFVTVDAXCIDKWTXAPRXOXPXQXHXCXNVPZXTWAAYDWSXDJAYDKEWDNZXCIOWSAYCYFXCIAYB
      EKWDAETSMTSYBEULAEHWBWEEMWFWGWHWIAXCIDKEAXBYFSZUIXCVEAEPKUALHRWNYGAXGXCTS
      XBEWJYEWKWLWMWOWPWQ $.
  $}

  $( The value of the first term of the series expansion of the exponential
     function is 1.  (Contributed by Paul Chapman, 21-Aug-2007.)  (Revised by
     Mario Carneiro, 29-Apr-2014.) $)
  eft0val $p |- ( A e. CC -> ( ( A ^ 0 ) / ( ! ` 0 ) ) = 1 ) $=
    ( cc wcel cc0 cexp co cfa cfv cdiv c1 exp0 oveq1d oveq2i ax-1cn div1i eqtri
    fac0 syl6eq ) ABCZADEFZDGHZIFJUAIFZJSTJUAIAKLUBJJIFJUAJJIQMJNOPR $.

  ${
    $d k n A $.  $d k F $.
    ef4p.1 $e |- F = ( n e. NN0 |-> ( ( A ^ n ) / ( ! ` n ) ) ) $.
    $( Separate out the first four terms of the infinite series expansion of
       the exponential function.  (Contributed by Paul Chapman, 19-Jan-2008.)
       (Revised by Mario Carneiro, 29-Apr-2014.) $)
    ef4p $p |- ( A e. CC -> ( exp ` A ) =
                ( ( ( ( 1 + A ) + ( ( A ^ 2 ) / 2 ) ) + ( ( A ^ 3 ) / 6 ) ) +
                  sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) $=
      ( cc wcel c1 caddc co c2 cexp cdiv c3 a1i cc0 cfv cfa efsep oveq2i ax-1cn
      c6 c4 df-4 3nn0 id addcl mpan sqcl halfcld df-3 2nn0 df-2 1nn0 1e0p1 0nn0
      addcld 0cn cuz cv csu ce efval2 nn0uz sumeq1i syl6req oveq2d efcl addid2d
      eqtr2d eft0val 0p1e1 syl6eq exp1 wceq fac1 oveq12d div1 eqtrd fac2 fac3
      cn0 ) AFGZAHAIJZAKLJZKMJZIJZWGANLJZUBMJZIJZBCDNUCEUDUEWCUFZWCWDWFHFGZWCWD
      FGUAHAUGUHZWCWEAUIUJUQWCAWDWGBCDKNEUKULWKWMWCAHWDBCDHKEUMUNWKWLWCUAOWCAPH
      BCDPHEUOUPWKPFGWCUROWCPPUSQZBUTDQZBVAZIJPAVBQZIJWQWCWPWQPIWCWQWBWOBVAWPAB
      CDEVCWBWNWOBVDVEVFVGWCWQAVHVIVJWCPAPLJPRQMJZIJPHIJHWCWRHPIAVKVGVLVMSWCAHL
      JZHRQZMJZAHIWCXAAHMJAWCWSAWTHMAVNWTHVOWCVPOVQAVRVSVGSWDWEKRQZMJZIJWGVOWCX
      CWFWDIXBKWEMVTTTOSWGWHNRQZMJZIJWJVOWCXEWIWGIXDUBWHMWATTOS $.
  $}

  ${
    $d A n $.
    $( The exponential function of a positive real number is greater than the
       first three terms of the series expansion.  (Contributed by Mario
       Carneiro, 15-Sep-2014.) $)
    efgt1p2 $p |- ( A e. RR+ ->
      ( ( 1 + A ) + ( ( A ^ 2 ) / 2 ) ) < ( exp ` A ) ) $=
      ( vn wcel c2 caddc cn0 cexp co cfa cfv cdiv cc0 c1 nn0uz 1nn0 wceq eftval
      0nn0 ax-mp syl5eq crp cv cmpt cseq ce clt df-2 cc rpcn 1e0p1 eqid eft0val
      0z seq1i fac1 oveq2i exp1 oveq1d div1 eqtrd seqp1i syl 2nn0 fac2 eqtri id
      a1i effsumlt eqbrtrrd ) AUACZDEBFABUBZGHVKIJKHUCZLUDZJMAEHZADGHZDKHZEHAUE
      JUFVJVNVPEVLDLMFNOUGVJAUHCZMVMJVNPAUIVQMAEVLMLLFNRUJVQMEVLLUMVQLVLJZALGHL
      IJKHZMLFCVRVSPRABVLLVLUKZQSAULTUNVQMVLJZAMGHZMIJZKHZAMFCWAWDPOABVLMVTQSVQ
      WDWBMKHZAWCMWBKUOUPVQWEAMKHAVQWBAMKAUQURAUSUTTTVAVBDVLJZVPPVJWFVODIJZKHZV
      PDFCZWFWHPVCABVLDVTQSWGDVOKVDUPVEVGVAVJABVLDVTVJVFWIVJVCVGVHVI $.

    $d A n $.
    $( The exponential function of a positive real number is greater than 1
       plus that number.  (Contributed by Mario Carneiro, 14-Mar-2014.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    efgt1p $p |- ( A e. RR+ -> ( 1 + A ) < ( exp ` A ) ) $=
      ( vn crp wcel c1 caddc cn0 cv cexp co cfa cfv cdiv wceq 0nn0 eftval ax-mp
      cc0 syl5eq 1nn0 cmpt cseq ce clt cc rpcn nn0uz 1e0p1 0z eqid eft0val fac1
      seq1i oveq2i exp1 oveq1d div1 eqtrd seqp1i syl id a1i effsumlt eqbrtrrd )
      ACDZEFBGABHZIJVFKLMJUAZRUBLZEAFJZAUCLUDVEAUEDZVHVINAUFVJEAFVGERRGUGOUHVJE
      FVGRUIVJRVGLZARIJRKLMJZERGDVKVLNOABVGRVGUJZPQAUKSUMVJEVGLZAEIJZEKLZMJZAEG
      DZVNVQNTABVGEVMPQVJVQVOEMJZAVPEVOMULUNVJVSAEMJAVJVOAEMAUOUPAUQURSSUSUTVEA
      BVGEVMVEVAVRVETVBVCVD $.

    $( The exponential function of a positive real number is greater than 1.
       (Contributed by Paul Chapman, 21-Aug-2007.)  (Revised by Mario Carneiro,
       30-Apr-2014.) $)
    efgt1 $p |- ( A e. RR+ -> 1 < ( exp ` A ) ) $=
      ( crp wcel c1 caddc co ce cfv cr 1re a1i rpre readdcl sylancr reefcld clt
      wbr ltaddrp mpan efgt1p lttrd ) ABCZDDAEFZAGHDICZUBJKUBUDAICUCICJALZDAMNU
      BAUEOUDUBDUCPQJDARSATUA $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The exponential function on the reals is strictly monotonic.
       (Contributed by Paul Chapman, 21-Aug-2007.)  (Revised by Mario Carneiro,
       17-Jul-2014.) $)
    eflt $p |- ( ( A e. RR /\ B e. RR ) ->
                 ( A < B <-> ( exp ` A ) < ( exp ` B ) ) ) $=
      ( vx vy wtru cr wcel wa clt wbr ce cfv wb cv fveq2 adantl cc0 syl recnd
      co tru ssid reefcl wi w3a cmin c1 crp simp2 simp1 resubcld posdif biimp3a
      cmul elrpd efgt1 reefcld efgt0 ltmulgt11 syl3anc mpbid caddc wceq syl2anc
      cc efadd pncan3d fveq2d eqtr3d breqtrd 3expia ltord1 mpan ) EAFGBFGHABIJA
      KLZBKLZIJMUAECDCNZKLZDNZKLZABFVNVOVPVRKOVPAKOVPBKOFUBVPFGZVQFGZEVPUCPVTVR
      FGZHVPVRIJZVQVSIJZUDEVTWBWCWDVTWBWCUEZVQVQVRVPUFTZKLZUNTZVSIWEUGWGIJZVQWH
      IJZWEWFUHGWIWEWFWEVRVPVTWBWCUIZVTWBWCUJZUKZVTWBWCQWFIJVPVRULUMUOWFUPRWEWA
      WGFGQVQIJZWIWJMWEVPWLUQWEWFWMUQWEVTWNWLVPURRVQWGUSUTVAWEVPWFVBTZKLZWHVSWE
      VPVEGWFVEGWPWHVCWEVPWLSZWEWFWMSVPWFVFVDWEWOVRKWEVPVRWQWEVRWKSVGVHVIVJVKPV
      LVM $.

    $( The exponential function on the reals is strictly monotonic.
       (Contributed by Mario Carneiro, 11-Mar-2014.) $)
    efle $p |- ( ( A e. RR /\ B e. RR ) ->
                 ( A <_ B <-> ( exp ` A ) <_ ( exp ` B ) ) ) $=
      ( cr wcel wa clt wbr wn ce cfv cle eflt ancoms notbid lenlt reefcl syl2an
      wb 3bitr4d ) ACDZBCDZEZBAFGZHBIJZAIJZFGZHZABKGUEUDKGZUBUCUFUATUCUFRBALMNA
      BOTUECDUDCDUHUGRUAAPBPUEUDOQS $.

    $( The exponential function on real numbers is one-to-one.  (Contributed by
       NM, 21-Aug-2008.)  (Revised by Mario Carneiro, 11-Mar-2014.) $)
    reef11 $p |- ( ( A e. RR /\ B e. RR )
          -> ( ( exp ` A ) = ( exp ` B ) <-> A = B ) ) $=
      ( cr wcel wa cle wbr ce cfv wceq efle ancoms anbi12d letri3 reefcl syl2an
      wb 3bitr4rd ) ACDZBCDZEZABFGZBAFGZEAHIZBHIZFGZUEUDFGZEZABJUDUEJZUAUBUFUCU
      GABKTSUCUGQBAKLMABNSUDCDUECDUIUHQTAOBOUDUENPR $.

    $( The exponential function maps real arguments one-to-one to positive
       reals.  (Contributed by Steve Rodriguez, 25-Aug-2007.)  (Revised by
       Mario Carneiro, 10-Nov-2013.) $)
    reeff1 $p |- ( exp |` RR ) : RR -1-1-> RR+ $=
      ( vx vy cr crp ce cres wf1 wf cv cfv wceq wi wral wfn cc wss eff mpbir2an
      wcel fvres ffn ax-mp ax-resscn fnssres mp2an rpefcl eqeltrd rgen ffnfv wa
      eqeqan12d reef11 biimpd sylbid rgen2a dff13 ) CDECFZGCDUQHZAIZUQJZBIZUQJZ
      KZUSVAKZLZBCMACMURUQCNZUTDSZACMEONZCOPVFOOEHVHQOOEUAUBUCOCEUDUEVGACUSCSZU
      TUSEJZDUSCETZUSUFUGUHACDUQUIRVEABCVIVACSZUJZVCVJVAEJZKZVDVIVLUTVJVBVNVKVA
      CETUKVMVOVDUSVAULUMUNUOABCDUQUPR $.
  $}

  ${
    $d A k n $.  $d k ph $.
    eflegeo.1 $e |- ( ph -> A e. RR ) $.
    eflegeo.2 $e |- ( ph -> 0 <_ A ) $.
    eflegeo.3 $e |- ( ph -> A < 1 ) $.
    $( The exponential function on the reals between 0 and 1 lies below the
       comparable geometric series sum.  (Contributed by Paul Chapman,
       11-Sep-2007.) $)
    eflegeo $p |- ( ph -> ( exp ` A ) <_ ( 1 / ( 1 - A ) ) ) $=
      ( vk vn cn0 cexp co cfv cdiv c1 cle cc0 wcel wceq adantl cr wbr cv cfa ce
      csu cmin cmpt nn0uz cz 0z a1i eqid reeftcl sylan oveq2 ovex fvmpt reexpcl
      eftval wa cmul cn faccl nnred adantr expge0d nnge1d lemulge12d clt nngt0d
      simpr wb ledivmul syl112anc mpbird cc caddc cseq cli cdm efcllem syl cabs
      recnd absidd eqbrtrd geolim seqex breldm isumle isumclim eqcomd 3brtr4d
      efval expcl ) AHBFUAZIJZWOUBKZLJZFUDZHWPFUDZBUCKZMMBUEJZLJZNAWRWPFGHBGUAZ
      IJZXDUBKLJUFZGHXEUFZOHUGOUHPAUIUJZWOHPZWOXFKWRQABGXFWOXFUKZURRABSPZXIWRSP
      CBWOULUMXIWOXGKWPQAGWOXEWPHXGXDWOBIUNXGUKBWOIUOUPRZAXKXIWPSPZCBWOUQUMZAXI
      USZWRWPNTZWPWQWPUTJNTZXOWPWQXNXOWQXIWQVAPAWOVBRZVCZXOBWOAXKXICVDAXIVJAOBN
      TXIDVDVEXOWQXRVFVGXOXMXMWQSPOWQVHTXPXQVKXNXNXSXOWQXRVIWPWPWQVLVMVNABVOPZV
      PXFOVQVRVSZPABCWCZBGXFXJVTWAAVPXGOVQZXCVRTYCYAPABFXGYBABWBKBMVHABCDWDEWEX
      LWFZYCXCVRVPXGOWGMXBLUOWHWAWIAXTXAWSQYBBFWMWAAWTXCAWPXCFXGOHUGXHXLAXTXIWP
      VOPYBBWOWNUMYDWJWKWL $.
  $}

  ${
    $d x A $.
    $( Value of the sine function.  (Contributed by NM, 14-Mar-2005.)  (Revised
       by Mario Carneiro, 10-Nov-2013.) $)
    sinval $p |- ( A e. CC -> ( sin ` A ) =
    ( ( ( exp ` ( _i x. A ) ) - ( exp ` ( -u _i x. A ) ) ) / ( 2 x. _i ) ) ) $=
      ( vx ci cv cmul co ce cneg cmin c2 cdiv cc csin wceq oveq2 fveq2d oveq12d
      cfv oveq1d df-sin ovex fvmpt ) BACBDZEFZGRZCHZUCEFZGRZIFZJCEFZKFCAEFZGRZU
      FAEFZGRZIFZUJKFLMUCANZUIUOUJKUPUEULUHUNIUPUDUKGUCACEOPUPUGUMGUCAUFEOPQSBT
      UOUJKUAUB $.

    $( Value of the cosine function.  (Contributed by NM, 14-Mar-2005.)
       (Revised by Mario Carneiro, 10-Nov-2013.) $)
    cosval $p |- ( A e. CC -> ( cos ` A ) =
       ( ( ( exp ` ( _i x. A ) ) + ( exp ` ( -u _i x. A ) ) ) / 2 ) ) $=
      ( vx ci cv cmul co ce cfv cneg caddc c2 cdiv cc ccos oveq2 fveq2d oveq12d
      wceq oveq1d df-cos ovex fvmpt ) BACBDZEFZGHZCIZUCEFZGHZJFZKLFCAEFZGHZUFAE
      FZGHZJFZKLFMNUCARZUIUNKLUOUEUKUHUMJUOUDUJGUCACEOPUOUGULGUCAUFEOPQSBTUNKLU
      AUB $.
  $}

  ${
    $d x y $.
    $( Domain and codomain of the sine function.  (Contributed by Paul Chapman,
       22-Oct-2007.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
    sinf $p |- sin : CC --> CC $=
      ( vx cc ci cv cmul co ce cfv cneg cmin c2 cdiv csin wcel ax-icn mpan efcl
      mulcl syl 2cn df-sin negcli subcld cc0 wne mulcli 2ne0 ine0 mulne0i divcl
      mp3an23 fmpti ) ABBCADZEFZGHZCIZUMEFZGHZJFZKCEFZLFZMAUAUMBNZUSBNZVABNZVBU
      OURVBUNBNZUOBNCBNVBVEOCUMRPUNQSVBUQBNZURBNUPBNVBVFCOUBUPUMRPUQQSUCVCUTBNU
      TUDUEVDKCTOUFKCTOUGUHUIUSUTUJUKSUL $.

    $( Domain and codomain of the sine function.  (Contributed by Paul Chapman,
       22-Oct-2007.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
    cosf $p |- cos : CC --> CC $=
      ( vx cc ci cv cmul co ce cneg caddc c2 cdiv ccos df-cos wcel ax-icn mulcl
      cfv mpan efcl syl negcli addcld halfcld fmpti ) ABBCADZEFZGQZCHZUEEFZGQZI
      FZJKFLAMUEBNZUKULUGUJULUFBNZUGBNCBNULUMOCUEPRUFSTULUIBNZUJBNUHBNULUNCOUAU
      HUEPRUISTUBUCUD $.
  $}

  $( Closure of the sine function.  (Contributed by NM, 28-Apr-2005.)  (Revised
     by Mario Carneiro, 30-Apr-2014.) $)
  sincl $p |- ( A e. CC -> ( sin ` A ) e. CC ) $=
    ( cc csin sinf ffvelrni ) BBACDE $.

  $( Closure of the cosine function with a complex argument.  (Contributed by
     NM, 28-Apr-2005.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
  coscl $p |- ( A e. CC -> ( cos ` A ) e. CC ) $=
    ( cc ccos cosf ffvelrni ) BBACDE $.

  ${
    $d x y A $.
    $( Value of the tangent function.  (Contributed by Mario Carneiro,
       14-Mar-2014.) $)
    tanval $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
                   ( tan ` A ) = ( ( sin ` A ) / ( cos ` A ) ) ) $=
      ( vx cc wcel ccos cfv cc0 wne wa ccnv cdif cima ctan csin cdiv wceq simpl
      csn co fveq2 coscl anim1i eldifsn sylibr wf wfn wb cosf ffn elpreima mp2b
      sylanbrc cv oveq12d df-tan ovex fvmpt syl ) ACDZAEFZGHZIZAEJCGRKZLZDZAMFA
      NFZUTOSZPVBUSUTVCDZVEUSVAQVBUTCDZVAIVHUSVIVAAUAUBUTCGUCUDCCEUEECUFVEUSVHI
      UGUHCCEUICAVCEUJUKULBABUMZNFZVJEFZOSVGVDMVJAPVKVFVLUTOVJANTVJAETUNBUOVFUT
      OUPUQUR $.
  $}

  $( The closure of the tangent function with a complex argument.  (Contributed
     by David A. Wheeler, 15-Mar-2014.) $)
  tancl $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) -> ( tan ` A ) e. CC ) $=
    ( cc wcel ccos cfv cc0 wa ctan csin cdiv co tanval sincl adantr coscl simpr
    wne divcld eqeltrd ) ABCZADEZFQZGZAHEAIEZUAJKBALUCUDUATUDBCUBAMNTUABCUBAONT
    UBPRS $.

  ${
    sincld.1 $e |- ( ph -> A e. CC ) $.
    $( Closure of the sine function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    sincld $p |- ( ph -> ( sin ` A ) e. CC ) $=
      ( cc wcel csin cfv sincl syl ) ABDEBFGDECBHI $.

    $( Closure of the cosine function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    coscld $p |- ( ph -> ( cos ` A ) e. CC ) $=
      ( cc wcel ccos cfv coscl syl ) ABDEBFGDECBHI $.

    tancld.2 $e |- ( ph -> ( cos ` A ) =/= 0 ) $.
    $( Closure of the tangent function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    tancld $p |- ( ph -> ( tan ` A ) e. CC ) $=
      ( cc wcel ccos cfv cc0 wne ctan tancl syl2anc ) ABEFBGHIJBKHEFCDBLM $.
  $}

  $( Express the tangent function directly in terms of ` exp ` .  (Contributed
     by Mario Carneiro, 25-Feb-2015.) $)
  tanval2 $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) -> ( tan ` A ) =
    ( ( ( exp ` ( _i x. A ) ) - ( exp ` ( -u _i x. A ) ) ) /
      ( _i x. ( ( exp ` ( _i x. A ) ) + ( exp ` ( -u _i x. A ) ) ) ) ) ) $=
    ( cc wcel cfv cc0 wne ci cmul co ce cdiv c2 2cn ax-icn adantr mulcl sylancr
    wceq efcl a1i ccos wa ctan cneg cmin caddc csin tanval mulcomi oveq2i simpl
    sinval negcli subcld ine0 2ne0 divdiv1d 3eqtr4a cosval oveq12d eqtrd divcld
    syl addcld simpr eqnetrrd diveq0ad necon3bid mpbid divcan7d 3eqtrd ) ABCZAU
    ADZEFZUBZAUCDZGAHIZJDZGUDZAHIZJDZUEIZGKIZLKIZVRWAUFIZLKIZKIZWCWEKIWBGWEHIKI
    VOVPAUGDZVMKIWGAUHVOWHWDVMWFKVOWBLGHIZKIZWBGLHIZKIWHWDWIWKWBKLGMNUIUJVLWHWJ
    RVNAULOVOWBGLVOVRWAVOVQBCZVRBCVOGBCZVLWLNVLVNUKZGAPQVQSVCZVOVTBCZWABCVOVSBC
    VLWPGNUMWNVSAPQVTSVCZUNZWMVONTZLBCVOMTZGEFVOUOTZLEFVOUPTZUQURVLVMWFRVNAUSOZ
    UTVAVOWCWELVOWBGWRWSXAVBVOVRWAWOWQVDZWTVOWFEFWEEFVOVMWFEXCVLVNVEVFVOWFEWEEV
    OWELXDWTXBVGVHVIZXBVJVOWBGWEWRWSXDXAXEUQVK $.

  $( Express the tangent function directly in terms of ` exp ` .  (Contributed
     by Mario Carneiro, 25-Feb-2015.) $)
  tanval3 $p |- ( ( A e. CC /\ ( ( exp ` ( 2 x. ( _i x. A ) ) ) + 1 ) =/= 0 )
  -> ( tan ` A ) = ( ( ( exp ` ( 2 x. ( _i x. A ) ) ) - 1 ) /
      ( _i x. ( ( exp ` ( 2 x. ( _i x. A ) ) ) + 1 ) ) ) ) $=
    ( cc wcel c2 ci cmul co ce cfv caddc cc0 wne cmin cdiv ax-icn mulcl sylancr
    c1 syl wceq wa cneg ctan simpl efcl negcli subcld addcld cexp cz 2z sylancl
    efexp sqvald eqtrd mulneg1 fveq2d oveq2d efcan eqtr2d oveq12d adddid eqtr4d
    a1i mul12d 2cn ax-1cn addcl simpr mulne0d eqnetrrd mulne0bbd efne0 divcan5d
    ine0 subdid ccos cosval adantr 2ne0 divne0d eqnetrd tanval2 syldan 3eqtr4rd
    ) ABCZDEAFGZFGZHIZRJGZKLZUAZWGHIZWMEUBZAFGZHIZMGZFGZWMEWMWPJGZFGZFGZNGWQWTN
    GZWIRMGZEWJFGZNGAUCIZWLWQWTWMWLWMWPWLWGBCZWMBCWLEBCZWFXFOWFWKUDZEAPQZWGUESZ
    WLWOBCZWPBCWLWNBCWFXKEOUFXHWNAPQWOUESZUGWLXGWSBCWTBCOWLWMWPXJXLUHZEWSPQZXJW
    LWMWTXJXNWLXDXAKWLXDEWMWSFGZFGXAWLWJXOEFWLWJWMWMFGZWMWPFGZJGXOWLWIXPRXQJWLW
    IWMDUIGZXPWLXFDUJCWIXRTXIUKWGDUMULWLWMXJUNUOZWLXQWMWGUBZHIZFGZRWLWPYAWMFWLW
    OXTHWLXGWFWOXTTOXHEAUPQUQURWLXFYBRTXIWGUSSUTZVAWLWMWMWPXJXJXLVBVCURWLEWMWSX
    GWLOVDZXJXMVEUOZWLEWJYDWLWIBCZRBCWJBCWLWHBCZYFWLDBCZXFYGVFXIDWGPQWHUESVGWIR
    VHULEKLWLVOVDWFWKVIVJVKVLZWLXFWMKLXIWGVMSVNWLXCWRXDXANWLXCXPXQMGWRWLWIXPRXQ
    MXSYCVAWLWMWMWPXJXJXLVPVCYEVAWFWKAVQIZKLXEXBTWLYJWSDNGZKWFYJYKTWKAVRVSWLWSD
    XMYHWLVFVDWLEWSYDXMYIVLDKLWLVTVDWAWBAWCWDWE $.

  $( The sine of a real number in terms of the exponential function.
     (Contributed by NM, 30-Apr-2005.) $)
  resinval $p |- ( A e. RR -> ( sin ` A ) = ( Im ` ( exp ` ( _i x. A ) ) ) ) $=
    ( cr wcel ci cmul co ce cfv cneg cmin c2 cdiv csin cc ax-icn sylancr oveq2d
    ccj wceq syl cim recn cjmul cji oveq1i cjre syl5eq eqtrd fveq2d efcj eqtr3d
    mulcl oveq1d sinval efcl imval2 3syl 3eqtr4d ) ABCZDAEFZGHZDIZAEFZGHZJFZKDE
    FZLFZVAVARHZJFZVFLFZAMHZVAUAHZUSVEVIVFLUSVDVHVAJUSUTRHZGHZVDVHUSVMVCGUSVMDR
    HZARHZEFZVCUSDNCZANCZVMVQSOAUBZDAUCPUSVQVBVPEFVCVOVBVPEUDUEUSVPAVBEAUFQUGUH
    UIUSUTNCZVNVHSUSVRVSWAOVTDAULPZUTUJTUKQUMUSVSVKVGSVTAUNTUSWAVANCVLVJSWBUTUO
    VAUPUQUR $.

  $( The cosine of a real number in terms of the exponential function.
     (Contributed by NM, 30-Apr-2005.) $)
  recosval $p |- ( A e. RR -> ( cos ` A ) = ( Re ` ( exp ` ( _i x. A ) ) ) ) $=
    ( cr wcel ci cmul co ce cfv cneg caddc c2 cdiv ccj ccos wceq ax-icn sylancr
    cc oveq2d syl cre recn cjmul cji oveq1i cjre syl5eq eqtrd fveq2d mulcl efcj
    eqtr3d oveq1d cosval efcl reval 3syl 3eqtr4d ) ABCZDAEFZGHZDIZAEFZGHZJFZKLF
    ZVAVAMHZJFZKLFZANHZVAUAHZUSVEVHKLUSVDVGVAJUSUTMHZGHZVDVGUSVLVCGUSVLDMHZAMHZ
    EFZVCUSDRCZARCZVLVPOPAUBZDAUCQUSVPVBVOEFVCVNVBVOEUDUEUSVOAVBEAUFSUGUHUIUSUT
    RCZVMVGOUSVQVRVTPVSDAUJQZUTUKTULSUMUSVRVJVFOVSAUNTUSVTVARCVKVIOWAUTUOVAUPUQ
    UR $.

  ${
    $d A k n $.  $d F k $.
    efi4p.1 $e |- F = ( n e. NN0 |-> ( ( ( _i x. A ) ^ n ) / ( ! ` n ) ) ) $.
    $( Separate out the first four terms of the infinite series expansion of
       the exponential function of an imaginary number.  (Contributed by Paul
       Chapman, 19-Jan-2008.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
    efi4p $p |- ( A e. CC -> ( exp ` ( _i x. A ) ) =
        ( ( ( 1 - ( ( A ^ 2 ) / 2 ) ) + ( _i x. ( A - ( ( A ^ 3 ) / 6 ) ) ) ) +
          sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) $=
      ( cc wcel ci cmul co c1 caddc c2 cexp cdiv c3 c6 wceq ax-icn syl ce c4 cv
      cfv cuz cmin mulcl mpan ef4p ax-1cn addcl sylancr sqcl halfcld 3nn0 expcl
      csu cn0 sylancl cc0 wne 6re recni 6pos gt0ne0ii divcl mp3an23 addassd a1i
      add4d cneg 2nn0 mulexp mp3an13 i2 oveq1i mulm1d 3eqtrd oveq1d 2ne0 divneg
      2cn eqtr4d oveq2d negsub eqtrd syl6eq mpan2 negcli pm3.2i divass mulneg12
      i3 wa negcld adddi mp3an1 mpdan 3eqtr2d oveq12d ) AFGZHAIJZUAUDZKXBLJZXBM
      NJZMOJZLJXBPNJZQOJZLJZUBUEUDBUCDUDBUQZLJZKAMNJZMOJZUFJZHAAPNJZQOJZUFJZIJZ
      LJZXJLJXAXBFGZXCXKRHFGZXAXTSHAUGUHZXBBCDEUITXAXIXSXJLXAXIXDXFXHLJLJKXFLJZ
      XBXHLJZLJXSXAXDXFXHXAKFGZXTXDFGUJYBKXBUKULXAXEXAXTXEFGYBXBUMTUNZXAXGFGZXH
      FGZXAXTPURGZYGYBUOXBPUPUSYGQFGZQUTVAZYHQVBVCZQVBVDVEZXGQVFVGTZVHXAKXBXFXH
      YEXAUJVIYBYFYNVJXAYCXNYDXRLXAYCKXMVKZLJZXNXAXFYOKLXAXFXLVKZMOJZYOXAXEYQMO
      XAXEHMNJZXLIJZKVKZXLIJZYQYAXAMURGXEYTRSVLHAMVMVNYTUUBRXAYSUUAXLIVOVPVIXAX
      LAUMZVQVRVSXAXLFGZYOYRRZUUCUUDMFGMUTVAUUEWBVTXLMWAVGTWCWDXAYEXMFGYPXNRUJX
      AXLUUCUNKXMWEULWFXAYDXBHXPVKZIJZLJZHAUUFLJZIJZXRXAXHUUGXBLXAXHHVKZXOIJZQO
      JZUUKXPIJZUUGXAXGUULQOXAXGHPNJZXOIJZUULYAXAYIXGUUPRSUOHAPVMVNUUOUUKXOIWMV
      PWGVSXAXOFGZUUMUUNRZXAYIUUQUOAPUPWHZUUKFGUUQYJYKWNUURHSWIYJYKYLYMWJUUKXOQ
      WKVNTXAYAXPFGZUUNUUGRSXAUUQUUTUUSUUQYJYKUUTYLYMXOQVFVGTZHXPWLULVRWDXAUUFF
      GZUUJUUHRZXAXPUVAWOYAXAUVBUVCSHAUUFWPWQWRXAUUIXQHIXAUUTUUIXQRUVAAXPWEWRWD
      WSWTVRVSWF $.

    $( Separate out the first four terms of the infinite series expansion of
       the sine of a real number.  (Contributed by Paul Chapman, 19-Jan-2008.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    resin4p $p |- ( A e. RR -> ( sin ` A ) = ( ( A - ( ( A ^ 3 ) / 6 ) ) +
                       ( Im ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) ) $=
      ( cr wcel cfv ci cmul co cim c3 cexp c6 c4 caddc c1 cc sylancr csin ce cv
      cdiv cmin cuz csu resinval c2 wceq recn efi4p syl fveq2d resqcl rehalfcld
      1re resubcl recnd ax-icn cn0 3nn0 reexpcl mpan2 cc0 wne 6re 6pos gt0ne0ii
      redivcl mp3an23 mpdan mulcl addcld 4nn0 eftlcl imaddd crimd oveq1d 3eqtrd
      sylancl eqtrd ) AFGZAUAHIAJKZUBHZLHZAAMNKZOUDKZUEKZPUFHBUCDHBUGZLHZQKZAUH
      WCWFRAUINKZUIUDKZUEKZIWIJKZQKZWJQKZLHWQLHZWKQKWLWCWEWRLWCASGZWEWRUJAUKZAB
      CDEULUMUNWCWQWJWCWOWPWCWOWCRFGWNFGWOFGUQWCWMAUOUPRWNURTZUSWCISGZWISGWPSGU
      TWCWIWCWHFGZWIFGWCWGFGZXDWCMVAGXEVBAMVCVDXEOFGOVEVFXDVGOVGVHVIWGOVJVKUMAW
      HURVLZUSIWIVMTVNWCWDSGZPVAGWJSGWCXCWTXGUTXAIAVMTVOWDBCDPEVPWAVQWCWSWIWKQW
      CWOWIXBXFVRVSVTWB $.

    $( Separate out the first four terms of the infinite series expansion of
       the cosine of a real number.  (Contributed by Paul Chapman,
       19-Jan-2008.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
    recos4p $p |- ( A e. RR -> ( cos ` A ) = ( ( 1 - ( ( A ^ 2 ) / 2 ) ) +
                       ( Re ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) ) ) $=
      ( cr wcel cfv ci cmul co cre c1 c2 c4 caddc c3 c6 cc sylancr ccos ce cexp
      cdiv cmin cuz cv csu recosval wceq recn efi4p syl fveq2d resqcl rehalfcld
      1re resubcl recnd ax-icn cn0 3nn0 reexpcl mpan2 cc0 wne 6re 6pos gt0ne0ii
      redivcl mp3an23 mpdan mulcl addcld 4nn0 eftlcl readdd crred oveq1d 3eqtrd
      sylancl eqtrd ) AFGZAUAHIAJKZUBHZLHZMANUCKZNUDKZUEKZOUFHBUGDHBUHZLHZPKZAU
      IWCWFWIIAAQUCKZRUDKZUEKZJKZPKZWJPKZLHWQLHZWKPKWLWCWEWRLWCASGZWEWRUJAUKZAB
      CDEULUMUNWCWQWJWCWIWPWCWIWCMFGWHFGWIFGUQWCWGAUOUPMWHURTZUSWCISGZWOSGWPSGU
      TWCWOWCWNFGZWOFGWCWMFGZXDWCQVAGXEVBAQVCVDXERFGRVEVFXDVGRVGVHVIWMRVJVKUMAW
      NURVLZUSIWOVMTVNWCWDSGZOVAGWJSGWCXCWTXGUTXAIAVMTVOWDBCDOEVPWAVQWCWSWIWKPW
      CWIWOXBXFVRVSVTWB $.
  $}

  $( The sine of a real number is real.  (Contributed by NM, 30-Apr-2005.) $)
  resincl $p |- ( A e. RR -> ( sin ` A ) e. RR ) $=
    ( cr wcel csin cfv ci cmul co ce resinval cc ax-icn recn mulcl sylancr efcl
    cim syl imcld eqeltrd ) ABCZADEFAGHZIEZQEBAJUAUCUAUBKCZUCKCUAFKCAKCUDLAMFAN
    OUBPRST $.

  $( The cosine of a real number is real.  (Contributed by NM, 30-Apr-2005.) $)
  recoscl $p |- ( A e. RR -> ( cos ` A ) e. RR ) $=
    ( cr wcel ccos cfv ci cmul co ce recosval cc ax-icn recn mulcl sylancr efcl
    cre syl recld eqeltrd ) ABCZADEFAGHZIEZQEBAJUAUCUAUBKCZUCKCUAFKCAKCUDLAMFAN
    OUBPRST $.

  $( The closure of the tangent function with a real argument.  (Contributed by
     David A. Wheeler, 15-Mar-2014.) $)
  retancl $p |- ( ( A e. RR /\ ( cos ` A ) =/= 0 ) -> ( tan ` A ) e. RR ) $=
    ( cr wcel ccos cfv cc0 wne wa ctan csin cdiv co cc wceq recn tanval recoscl
    sylan resincl redivcl syl3an1 syl3an2 3anidm12 eqeltrd ) ABCZADEZFGZHAIEZAJ
    EZUFKLZBUEAMCUGUHUJNAOAPRUEUGUJBCZUEUEUFBCZUGUKAQUEUIBCULUGUKASUIUFTUAUBUCU
    D $.


  ${
    resincld.1 $e |- ( ph -> A e. RR ) $.
    $( Closure of the sine function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    resincld $p |- ( ph -> ( sin ` A ) e. RR ) $=
      ( cr wcel csin cfv resincl syl ) ABDEBFGDECBHI $.

    $( Closure of the cosine function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    recoscld $p |- ( ph -> ( cos ` A ) e. RR ) $=
      ( cr wcel ccos cfv recoscl syl ) ABDEBFGDECBHI $.

    retancld.2 $e |- ( ph -> ( cos ` A ) =/= 0 ) $.
    $( Closure of the tangent function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    retancld $p |- ( ph -> ( tan ` A ) e. RR ) $=
      ( cr wcel ccos cfv cc0 wne ctan retancl syl2anc ) ABEFBGHIJBKHEFCDBLM $.
  $}

  $( The sine of a negative is the negative of the sine.  (Contributed by NM,
     30-Apr-2005.) $)
  sinneg $p |- ( A e. CC -> ( sin ` -u A ) = -u ( sin ` A ) ) $=
    ( cc wcel cneg csin cfv ci cmul co ce cmin c2 cdiv wceq sinval ax-icn mulcl
    syl mpan eqtr4d negcl negeqd efcl negcli subcld cc0 wne mulcli 2ne0 mulne0i
    ine0 divneg mp3an23 eqtrd mulneg12 eqcomd fveq2d mul2neg oveq12d negsubdi2d
    2cn oveq1d ) ABCZADZEFZGVDHIZJFZGDZVDHIZJFZKIZLGHIZMIZAEFZDZVCVDBCVEVMNAUAV
    DORVCVOGAHIZJFZVHAHIZJFZKIZDZVLMIZVMVCVOVTVLMIZDZWBVCVNWCAOUBVCVTBCZWDWBNZV
    CVQVSVCVPBCZVQBCGBCZVCWGPGAQSVPUCRZVCVRBCZVSBCVHBCVCWJGPUDVHAQSVRUCRZUEWEVL
    BCVLUFUGWFLGVAPUHLGVAPUIUKUJVTVLULUMRUNVCVKWAVLMVCVKVSVQKIWAVCVGVSVJVQKVCVF
    VRJVCVRVFWHVCVRVFNPGAUOSUPUQVCVIVPJWHVCVIVPNPGAURSUQUSVCVQVSWIWKUTTVBTT $.

  $( The cosines of a number and its negative are the same.  (Contributed by
     NM, 30-Apr-2005.) $)
  cosneg $p |- ( A e. CC -> ( cos ` -u A ) = ( cos ` A ) ) $=
    ( cc wcel ci cneg cmul co ce cfv caddc c2 cdiv ccos wceq ax-icn mpan fveq2d
    mulcl efcl syl mulneg12 eqcomd mul2neg oveq12d negcli addcomd oveq1d cosval
    eqtrd negcl 3eqtr4d ) ABCZDAEZFGZHIZDEZUMFGZHIZJGZKLGZDAFGZHIZUPAFGZHIZJGZK
    LGUMMIZAMIULUSVEKLULUSVDVBJGVEULUOVDURVBJULUNVCHULVCUNDBCZULVCUNNODAUAPUBQU
    LUQVAHVGULUQVANODAUCPQUDULVDVBULVCBCZVDBCUPBCULVHDOUEUPARPVCSTULVABCZVBBCVG
    ULVIODARPVASTUFUIUGULUMBCVFUTNAUJUMUHTAUHUK $.

  $( The tangent of a negative is the negative of the tangent.  (Contributed by
     David A. Wheeler, 23-Mar-2014.) $)
  tanneg $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
                      ( tan ` -u A ) = -u ( tan ` A ) ) $=
    ( cc wcel ccos cfv cc0 wne wa csin cdiv cneg ctan wceq coscl divneg syl3an1
    co sincl tanval adantr syl3an2 3anidm12 negeqd cosneg eqnetrd syldan sinneg
    simpr negcl sylan oveq12d eqtrd 3eqtr4rd ) ABCZADEZFGZHZAIEZUOJQZKZURKZUOJQ
    ZALEZKAKZLEZUNUPUTVBMZUNUNUOBCZUPVFANUNURBCVGUPVFARURUOOPUAUBUQVCUSASUCUQVE
    VDIEZVDDEZJQZVBUNUPVIFGZVEVJMZUQVIUOFUNVIUOMUPAUDZTUNUPUHUEUNVDBCVKVLAUIVDS
    UJUFUNVJVBMUPUNVHVAVIUOJAUGVMUKTULUM $.

  $( Value of the sine function at 0.  (Contributed by Steve Rodriguez,
     14-Mar-2005.) $)
  sin0 $p |- ( sin ` 0 ) = 0 $=
    ( cc0 csin cfv cneg wceq neg0 fveq2i cc wcel 0cn sinneg ax-mp eqtr3i eqnegi
    sincl mpbi ) ABCZQDZEQAEADZBCZQRSABFGAHIZTREJAKLMQUAQHIJAOLNP $.

  $( Value of the cosine function at 0.  (Contributed by NM, 30-Apr-2005.) $)
  cos0 $p |- ( cos ` 0 ) = 1 $=
    ( cc0 ccos cfv ci cmul co ce cre c1 cr wcel wceq 0re recosval ax-icn mul01i
    ax-mp fveq2i ef0 eqtri re1 ) ABCZDAEFZGCZHCZIAJKUBUELMANQUEIHCIUDIHUDAGCIUC
    AGDOPRSTRUATT $.

  $( The value of the tangent function at zero is zero.  (Contributed by David
     A. Wheeler, 16-Mar-2014.) $)
  tan0 $p |- ( tan ` 0 ) = 0 $=
    ( cc0 ctan cfv csin ccos cdiv co cc wcel wne wceq c1 ax-1ne0 eqnetri tanval
    0cn cos0 mp2an sin0 oveq1i ax-1cn eqeltri div0i 3eqtri ) ABCZADCZAECZFGZAUG
    FGAAHIUGAJUEUHKPUGLAQMNZAORUFAUGFSTUGUGLHQUAUBUIUCUD $.

  $( The exponential function in terms of sine and cosine.  (Contributed by NM,
     30-Apr-2005.) $)
  efival $p |- ( A e. CC -> ( exp ` ( _i x. A ) ) =
                ( ( cos ` A ) + ( _i x. ( sin ` A ) ) ) ) $=
    ( cc wcel ci cmul co ce cfv caddc c2 cdiv wceq ax-icn syl 2ne0 3eqtr4d ine0
    2cn c1 eqtr3i cneg cmin ccos csin mpan efcl negcli addcld subcld cc0 wne wa
    pm3.2i divdir mp3an3 syl2anc pncan3d oveq2d addassd 2timesd divcan3 mp3an23
    mulcl oveq1d eqtr2d cosval mulcli mulne0i div12 sinval divrec oveq1i dividi
    mp3an13 mulid2i oveq2i ax-1cn divmuldivi reccli mulid1i syl6eqr oveq12d ) A
    BCZDAEFZGHZDUAZAEFZGHZIFZWEWHUBFZIFZJKFZWIJKFZWJJKFZIFZWEAUCHZDAUDHZEFZIFWC
    WIBCZWJBCZWLWOLZWCWEWHWCWDBCZWEBCZDBCZWCXBMDAVCUEWDUFNZWCWGBCZWHBCWFBCWCXFD
    MUGWFAVCUEWGUFNZUHWCWEWHXEXGUIZWSWTJBCZJUJUKZULXAXIXJROUMWIWJJUNUOUPWCWLJWE
    EFZJKFZWEWCWKXKJKWCWEWHWJIFZIFWEWEIFWKXKWCXMWEWEIWCWHWEXGXEUQURWCWEWHWJXEXG
    XHUSWCWEXEUTPVDWCXCXLWELZXEXCXIXJXNROWEJVAVBNVEWCWPWMWRWNIAVFWCDWJJDEFZKFZE
    FZWJDXOKFZEFZWRWNWCWTXQXSLZXHXDWTXOBCZXOUJUKZULXTMYAYBJDRMVGJDRMOQVHUMDWJXO
    VIVNNWCWQXPDEAVJURWCWNWJSJKFZEFZXSWCWTWNYDLZXHWTXIXJYEROWJJVKVBNXRYCWJESDEF
    ZXOKFZXRYCYFDXOKDMVOVLYCSEFZYGYCYCDDKFZEFYHYGYISYCEDMQVMVPSJDDVQRMMOQVRTYCJ
    ROVSVTTTVPWAPWBP $.

  $( The exponential function in terms of sine and cosine.  (Contributed by NM,
     14-Jan-2006.) $)
  efmival $p |- ( A e. CC -> ( exp ` ( -u _i x. A ) ) =
                ( ( cos ` A ) - ( _i x. ( sin ` A ) ) ) ) $=
    ( cc wcel ci cneg cmul co ce cfv ccos csin cmin wceq ax-icn mulneg12 fveq2d
    mpan caddc sylancr eqtrd negcl efival syl cosneg sinneg sincl mulneg2 coscl
    oveq2d oveq12d mulcl negsubd ) ABCZDEAFGZHIDAEZFGZHIZAJIZDAKIZFGZLGZUMUNUPH
    DBCZUMUNUPMNDAOQPUMUQUOJIZDUOKIZFGZRGZVAUMUOBCUQVFMAUAUOUBUCUMVFURUTEZRGVAU
    MVCURVEVGRAUDUMVEDUSEZFGZVGUMVDVHDFAUEUIUMVBUSBCZVIVGMNAUFZDUSUGSTUJUMURUTA
    UHUMVBVJUTBCNVKDUSUKSULTTT $.

  $( Value of the hyperbolic sine of a complex number.  (Contributed by Mario
     Carneiro, 4-Apr-2015.) $)
  sinhval $p |- ( A e. CC -> ( ( sin ` ( _i x. A ) ) / _i ) =
    ( ( ( exp ` A ) - ( exp ` -u A ) ) / 2 ) ) $=
    ( cc wcel ci cmul co cfv cdiv ce cneg cmin c2 c1 oveq1i ax-icn eqtri oveq1d
    wceq a1i eqtrd csin ixi mulass mp3an12 mulm1 3eqtr3a fveq2d mulneg1i negeqi
    ax-1cn negnegi negcli mulid2 oveq12d mulcl mpan sinval syl irec ine0 reccli
    negcl subcld halfcld mulneg12 sylancr 2cn cc0 wne divnegd negsubdi2d oveq2d
    efcl 2ne0 divrec2d divdiv1d 3eqtr2d syl5eqr 3eqtr4d divcan3d ) ABCZDAEFZUAG
    ZDHFDAIGZAJZIGZKFZLHFZEFZDHFWHWAWCWIDHWADWBEFZIGZDJZWBEFZIGZKFZLDEFZHFZWFWD
    KFZWPHFZWCWIWAWOWRWPHWAWKWFWNWDKWAWJWEIWADDEFZAEFZMJZAEFWJWEWTXBAEUBNDBCZXC
    WAXAWJROODDAUCUDAUEUFUGWAWMAIWAWLDEFZAEFZMAEFWMAXDMAEXDWTJZMDDOOUHXFXBJMWTX
    BUBUIMUJUKPPNWLBCXCWAXEWMRDOULOWLDAUCUDAUMUFUGUNQWAWBBCZWCWQRXCWAXGODAUOUPW
    BUQURWAWIMDHFZJZWHEFZWSXIDWHEXIWLJDXHWLUSUIDOUKPNWAXJXHWHJZEFZWSWAXHBCWHBCX
    JXLRDOUTVAWAWGWAWDWFAVMZWAWEBCWFBCAVBWEVMURZVCZVDZXHWHVEVFWAXLXHWRLHFZEFXQD
    HFWSWAXKXQXHEWAXKWGJZLHFXQWAWGLXOLBCWAVGSZLVHVIWAVNSZVJWAXRWRLHWAWDWFXMXNVK
    QTVLWAXQDWAWRWAWFWDXNXMVCZVDXCWAOSZDVHVIWAUTSZVOWAWRLDYAXSYBXTYCVPVQTVRVSQW
    AWHDXPYBYCVTT $.

  $( Value of the hyperbolic cosine of a complex number.  (Contributed by Mario
     Carneiro, 4-Apr-2015.) $)
  coshval $p |- ( A e. CC -> ( cos ` ( _i x. A ) ) =
    ( ( ( exp ` A ) + ( exp ` -u A ) ) / 2 ) ) $=
    ( cc wcel ci cmul co cfv ce cneg caddc c2 cdiv wceq ax-icn c1 oveq1i mulass
    syl ixi mp3an12 ccos mulcl mpan cosval mulm1 3eqtr3a fveq2d mulneg1i negeqi
    ax-1cn negnegi 3eqtri negcli mulid2 oveq12d negcl efcl addcomd eqtrd oveq1d
    ) ABCZDAEFZUAGZDVBEFZHGZDIZVBEFZHGZJFZKLFZAHGZAIZHGZJFZKLFVAVBBCZVCVJMDBCZV
    AVONDAUBUCVBUDRVAVIVNKLVAVIVMVKJFVNVAVEVMVHVKJVAVDVLHVADDEFZAEFZOIZAEFVDVLV
    QVSAESPVPVPVAVRVDMNNDDAQTAUEUFUGVAVGAHVAVFDEFZAEFZOAEFVGAVTOAEVTVQIVSIODDNN
    UHVQVSSUIOUJUKULPVFBCVPVAWAVGMDNUMNVFDAQTAUNUFUGUOVAVMVKVAVLBCVMBCAUPVLUQRA
    UQURUSUTUS $.

  $( The hyperbolic sine of a real number is real.  (Contributed by Mario
     Carneiro, 4-Apr-2015.) $)
  resinhcl $p |- ( A e. RR -> ( ( sin ` ( _i x. A ) ) / _i ) e. RR ) $=
    ( cr wcel ci cmul co csin cfv cdiv ce cneg cmin c2 cc wceq recn sinhval syl
    reefcl renegcl reefcld resubcld rehalfcld eqeltrd ) ABCZDAEFGHDIFZAJHZAKZJH
    ZLFZMIFZBUEANCUFUKOAPAQRUEUJUEUGUIASUEUHATUAUBUCUD $.

  $( The hyperbolic cosine of a real number is a positive real.  (Contributed
     by Mario Carneiro, 4-Apr-2015.) $)
  rpcoshcl $p |- ( A e. RR -> ( cos ` ( _i x. A ) ) e. RR+ ) $=
    ( cr wcel ci cmul co ccos cfv ce cneg caddc c2 cdiv crp cc wceq coshval syl
    recn rpefcl renegcl rpefcld rpaddcld rphalfcld eqeltrd ) ABCZDAEFGHZAIHZAJZ
    IHZKFZLMFZNUFAOCUGULPASAQRUFUKUFUHUJATUFUIAUAUBUCUDUE $.

  $( The hyperbolic cosine of a real number is real.  (Contributed by Mario
     Carneiro, 4-Apr-2015.) $)
  recoshcl $p |- ( A e. RR -> ( cos ` ( _i x. A ) ) e. RR ) $=
    ( cr wcel ci cmul co ccos cfv rpcoshcl rpred ) ABCDAEFGHAIJ $.

  $( The hyperbolic tangent of a real number is real.  (Contributed by Mario
     Carneiro, 4-Apr-2015.) $)
  retanhcl $p |- ( A e. RR -> ( ( tan ` ( _i x. A ) ) / _i ) e. RR ) $=
    ( cr wcel ci cmul co ctan cfv cdiv csin ccos cc0 wne wceq ax-icn recn mulcl
    cc sylancr a1i rpcoshcl rpne0d tanval syl2anc oveq1d sincld recnd divdiv32d
    recoshcl ine0 eqtrd resinhcl rerpdivcld eqeltrd ) ABCZDAEFZGHZDIFZUPJHZDIFZ
    UPKHZIFZBUOURUSVAIFZDIFVBUOUQVCDIUOUPRCZVALMUQVCNUODRCZARCVDOAPDAQSZUOVAAUA
    ZUBZUPUCUDUEUOUSVADUOUPVFUFUOVAAUIUGVEUOOTVHDLMUOUJTUHUKUOUTVAAULVGUMUN $.

  $( The hyperbolic tangent of a real number is upper bounded by ` 1 ` .
     (Contributed by Mario Carneiro, 4-Apr-2015.) $)
  tanhlt1 $p |- ( A e. RR -> ( ( tan ` ( _i x. A ) ) / _i ) < 1 ) $=
    ( cr wcel ci cmul co cfv cdiv ce c1 clt c2 cc0 wne wceq recnd a1i syl wbr
    cc ctan cneg cmin caddc csin ccos ax-icn recn mulcl sylancr rpcoshcl rpne0d
    tanval syl2anc oveq1d sincld recoshcl ine0 divdiv32d sinhval coshval 3eqtrd
    oveq12d reefcl renegcl reefcld resubcld readdcld 2cn eqnetrrd 2ne0 divne0bd
    mpbird divcan7d eqtrd rpefcld ltsubrpd ltaddrpd lttrd breqtrrd wb 1re efgt0
    mulid1d addgt0d ltdivmul syl112anc eqbrtrd ) ABCZDAEFZUAGZDHFZAIGZAUBZIGZUC
    FZWMWOUDFZHFZJKWIWLWPLHFZWQLHFZHFZWRWIWLWJUEGZWJUFGZHFZDHFXBDHFZXCHFXAWIWKX
    DDHWIWJTCZXCMNWKXDOWIDTCZATCZXFUGAUHZDAUIUJZWIXCAUKULZWJUMUNUOWIXBXCDWIWJXJ
    UPWIXCAUQPXGWIUGQXKDMNWIURQUSWIXEWSXCWTHWIXHXEWSOXIAUTRWIXHXCWTOXIAVARZVCVB
    WIWPWQLWIWPWIWMWOAVDZWIWNAVEZVFZVGZPWIWQWIWMWOXMXOVHZPZLTCWIVIQZWIWQMNWTMNW
    IXCWTMXLXKVJWIWQLXRXSLMNWIVKQZVLVMXTVNVOWIWRJKSZWPWQJEFZKSZWIWPWQYBKWIWPWMW
    QXPXMXQWIWMWOXMWIWNXNVPZVQWIWMWOXMYDVRVSWIWQXRWDVTWIWPBCJBCZWQBCMWQKSYAYCWA
    XPYEWIWBQXQWIWMWOXMXOAWCWIWNBCMWOKSXNWNWCRWEWPJWQWFWGVMWH $.

  $( The hyperbolic tangent of a real number is bounded by ` 1 ` .
     (Contributed by Mario Carneiro, 4-Apr-2015.) $)
  tanhbnd $p |- ( A e. RR ->
    ( ( tan ` ( _i x. A ) ) / _i ) e. ( -u 1 (,) 1 ) ) $=
    ( cr wcel ci cmul co ctan cfv cdiv c1 clt wbr cc ax-icn sylancr a1i cc0 wne
    cneg 1re cioo retanhcl recn mulcl ccos rpcoshcl rpne0d ine0 divnegd mulneg2
    tancld wceq fveq2d tanneg syl2anc oveq1d eqtr4d renegcl tanhlt1 syl eqbrtrd
    eqtrd ltnegcon1 sylancl mpbid cxr w3a renegcli rexri elioo2 mp2an syl3anbrc
    wb ) ABCZDAEFZGHZDIFZBCZJSZVQKLZVQJKLZVQVSJUAFCZAUBZVNVQSZJKLZVTVNWDDASZEFZ
    GHZDIFZJKVNWDVPSZDIFWIVNVPDVNVOVNDMCZAMCZVOMCZNAUCZDAUDOZVNVOUEHZAUFUGZUKWK
    VNNPDQRVNUHPUIVNWHWJDIVNWHVOSZGHZWJVNWGWRGVNWKWLWGWRULNWNDAUJOUMVNWMWPQRWSW
    JULWOWQVOUNUOVBUPUQVNWFBCWIJKLAURWFUSUTVAVNVRJBCWEVTVMWCTVQJVCVDVEAUSVSVFCJ
    VFCWBVRVTWAVGVMVSJTVHVIJTVIVSJVQVJVKVL $.

  $( Eulerian representation of the complex exponential.  (Suggested by Jeffrey
     Hankins, 3-Jul-2006.)  (Contributed by NM, 4-Jul-2006.) $)
  efeul $p |- ( A e. CC -> ( exp ` A ) = ( ( exp ` ( Re ` A ) ) x.
               ( ( cos ` ( Im ` A ) ) + ( _i x. ( sin ` ( Im ` A ) ) ) ) ) ) $=
    ( cc wcel ce cfv cre ci cim cmul co caddc ccos csin replim fveq2d wceq recl
    recnd ax-icn imcl mulcl sylancr efadd syl2anc efival syl oveq2d 3eqtrd ) AB
    CZADEAFEZGAHEZIJZKJZDEZUJDEZULDEZIJZUOUKLEGUKMEIJKJZIJUIAUMDANOUIUJBCULBCZU
    NUQPUIUJAQRUIGBCUKBCZUSSUIUKATRZGUKUAUBUJULUCUDUIUPURUOIUIUTUPURPVAUKUEUFUG
    UH $.

  $( The exponentials of two imaginary numbers are equal iff their sine and
     cosine components are equal.  (Contributed by Paul Chapman,
     15-Mar-2008.) $)
  efieq $p |- ( ( A e. RR /\ B e. RR ) ->
       ( ( exp ` ( _i x. A ) ) = ( exp ` ( _i x. B ) ) <->
         ( ( cos ` A ) = ( cos ` B ) /\ ( sin ` A ) = ( sin ` B ) ) ) ) $=
    ( cr wcel wa ci cmul co ce wceq ccos csin caddc cc wb efival syl2an recoscl
    cfv recn eqeqan12d resincl jca cru bitrd ) ACDZBCDZEFAGHISZFBGHISZJZAKSZFAL
    SZGHMHZBKSZFBLSZGHMHZJZUKUNJULUOJEZUFANDZBNDZUJUQOUGATBTUSUTUHUMUIUPAPBPUAQ
    UFUKCDZULCDZEUNCDZUOCDZEUQUROUGUFVAVBARAUBUCUGVCVDBRBUBUCUKULUNUOUDQUE $.

  $( Addition formula for sine.  Equation 14 of [Gleason] p. 310.  (Contributed
     by Steve Rodriguez, 10-Nov-2006.)  (Revised by Mario Carneiro,
     30-Apr-2014.) $)
  sinadd $p |- ( ( A e. CC /\ B e. CC ) -> ( sin ` ( A + B ) ) =
       ( ( ( sin ` A ) x. ( cos ` B ) ) + ( ( cos ` A ) x. ( sin ` B ) ) ) ) $=
    ( cc wcel caddc co cfv ci cmul ce cmin c2 2cn a1i ax-icn mulcld eqtrd mulcl
    wceq sylancr csin cneg cdiv ccos addcl sinval syl coscl adantr sincl adantl
    wa addcld mulassd adddid mul12d mulcomd oveq2d oveq12d mulcli cc0 2ne0 ine0
    mulne0i divmuld mpbird pnncand adddi mp3an1 fveq2d simpl simpr efadd efival
    wne syl2anc oveqan12d muladdd 3eqtrd negcli efmival mulsubd 2timesd 3eqtr4d
    oveq1d addcomd ) ACDZBCDZULZABEFZUAGZHWJIFZJGZHUBZWJIFZJGZKFZLHIFZUCFZAUAGZ
    BUDGZIFZAUDGZBUAGZIFZEFZWIWJCDWKWSSABUEWJUFUGWILXCHXDIFZIFZXAHWTIFZIFZEFZIF
    ZWRUCFZXEXBEFZWSXFWIXMXNSWRXNIFZXLSWIXOLHXNIFZIFXLWILHXNLCDZWIMNHCDZWIONZWI
    XEXBWIXCXDWGXCCDWHAUHUIZWHXDCDZWGBUJUKZPZWIWTXAWGWTCDZWHAUJUIZWHXACDWGBUHUK
    ZPZUMZUNWIXPXKLIWIXPHXEIFZHXBIFZEFXKWIHXEXBXSYCYGUOWIYIXHYJXJEWIHXCXDXSXTYB
    UPWIYJHXAWTIFZIFXJWIXBYKHIWIWTXAYEYFUQURWIHXAWTXSYFYEUPQUSQURQWIXLWRXNWIXQX
    KCDXLCDMWIXHXJWIXCXGXTWIXRYAXGCDOYBHXDRTZPWIXAXIYFWIXRYDXICDOYEHWTRTZPUMZLX
    KRTWRCDWILHMOUTNYHWRVAVOWILHMOVBVCVDNVEVFWIWQXLWRUCWIXCXAIFZXGXIIFZEFZXKEFZ
    YQXKKFZKFXKXKEFWQXLWIYQXKXKWIYOYPWIXCXAXTYFPWIXGXIYLYMPUMYNYNVGWIWMYRWPYSKW
    IWMHAIFZHBIFZEFZJGZYTJGZUUAJGZIFZYRWIWLUUBJXRWGWHWLUUBSOHABVHVIVJWIYTCDZUUA
    CDZUUCUUFSWIXRWGUUGOWGWHVKZHARTWIXRWHUUHOWGWHVLZHBRTYTUUAVMVPWIUUFXCXIEFZXA
    XGEFZIFYRWGWHUUDUUKUUEUULIAVNBVNVQWIXCXIXAXGXTYMYFYLVRQVSWIWPWNAIFZWNBIFZEF
    ZJGZUUMJGZUUNJGZIFZYSWIWOUUOJWNCDZWGWHWOUUOSHOVTZWNABVHVIVJWIUUMCDZUUNCDZUU
    PUUSSWIUUTWGUVBUVAUUIWNARTWIUUTWHUVCUVAUUJWNBRTUUMUUNVMVPWIUUSXCXIKFZXAXGKF
    ZIFYSWGWHUUQUVDUURUVEIAWABWAVQWIXCXIXAXGXTYMYFYLWBQVSUSWIXKYNWCWDWEWIXBXEYG
    YCWFWDQ $.

  $( Addition formula for cosine.  Equation 15 of [Gleason] p. 310.
     (Contributed by NM, 15-Jan-2006.)  (Revised by Mario Carneiro,
     30-Apr-2014.) $)
  cosadd $p |- ( ( A e. CC /\ B e. CC ) -> ( cos ` ( A + B ) ) =
       ( ( ( cos ` A ) x. ( cos ` B ) ) - ( ( sin ` A ) x. ( sin ` B ) ) ) ) $=
    ( cc wcel caddc co ccos cfv ci cmul ce cneg cmin wceq mulcld ax-icn sylancr
    c2 mulcl 3eqtrd cdiv csin addcl cosval syl coscl adantr adantl sincl addcld
    wa ppncand adddi mp3an1 fveq2d simpl simpr syl2anc efival oveqan12d muladdd
    efadd eqtrd negcli efmival mulsubd oveq12d 2timesd 3eqtr4d cc0 wne 2cn 2ne0
    oveq1d divcan3 mp3an23 c1 a1i mul4d ixi oveq1i mulcomd oveq2d syl5eq mulm1d
    negsubd ) ACDZBCDZUKZABEFZGHZIWJJFZKHZILZWJJFZKHZEFZRUAFZRAGHZBGHZJFZIBUBHZ
    JFZIAUBHZJFZJFZEFZJFZRUAFZXAXDXBJFZMFZWIWJCDWKWRNABUCWJUDUEWIWQXHRUAWIXGWSX
    CJFZWTXEJFZEFZEFZXGXNMFZEFXGXGEFWQXHWIXGXNXGWIXAXFWIWSWTWGWSCDWHAUFUGZWHWTC
    DWGBUFUHZOZWIXCXEWIICDZXBCDZXCCDPWHYAWGBUIUHZIXBSQZWIXTXDCDZXECDPWGYDWHAUIU
    GZIXDSQZOUJZWIXLXMWIWSXCXQYCOWIWTXEXRYFOUJYGULWIWMXOWPXPEWIWMIAJFZIBJFZEFZK
    HZYHKHZYIKHZJFZXOWIWLYJKXTWGWHWLYJNPIABUMUNUOWIYHCDZYICDZYKYNNWIXTWGYOPWGWH
    UPZIASQWIXTWHYPPWGWHUQZIBSQYHYIVBURWIYNWSXEEFZWTXCEFZJFXOWGWHYLYSYMYTJAUSBU
    SUTWIWSXEWTXCXQYFXRYCVAVCTWIWPWNAJFZWNBJFZEFZKHZUUAKHZUUBKHZJFZXPWIWOUUCKWN
    CDZWGWHWOUUCNIPVDZWNABUMUNUOWIUUACDZUUBCDZUUDUUGNWIUUHWGUUJUUIYQWNASQWIUUHW
    HUUKUUIYRWNBSQUUAUUBVBURWIUUGWSXEMFZWTXCMFZJFXPWGWHUUEUULUUFUUMJAVEBVEUTWIW
    SXEWTXCXQYFXRYCVFVCTVGWIXGYGVHVIVNWIXIXGXAXJLZEFXKWIXGCDZXIXGNZYGUUORCDRVJV
    KUUPVLVMXGRVOVPUEWIXFUUNXAEWIXFIIJFZXBXDJFZJFZVQLZXJJFZUUNWIIXBIXDXTWIPVRZY
    BUVBYEVSWIUUSUUTUURJFUVAUUQUUTUURJVTWAWIUURXJUUTJWIXBXDYBYEWBWCWDWIXJWIXDXB
    YEYBOZWETWCWIXAXJXSUVCWFTT $.

  $( A useful intermediate step in ~ tanadd when showing that the addition of
     tangents is well-defined.  (Contributed by Mario Carneiro, 4-Apr-2015.) $)
  tanaddlem $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( cos ` A ) =/= 0 /\
    ( cos ` B ) =/= 0 ) ) -> ( ( cos ` ( A + B ) ) =/= 0 <->
    ( ( tan ` A ) x. ( tan ` B ) ) =/= 1 ) ) $=
    ( cc wcel wa ccos cfv cc0 co ctan cmul c1 csin wceq coscl ad2antrr ad2antlr
    wne eqeq1d cdiv caddc mulcld sincl subeq0ad cosadd adantr ad2ant2r ad2ant2l
    cmin tanval oveq12d simprl simprr divmuldivd ax-1cn mulne0d divmuld mulid1d
    eqtrd a1i 3bitrd 3bitr4d necon3bid ) ACDZBCDZEZAFGZHRZBFGZHRZEZEZABUAIFGZHA
    JGZBJGZKIZLVLVGVIKIZAMGZBMGZKIZUIIZHNVQVTNZVMHNVPLNZVLVQVTVLVGVIVDVGCDVEVKA
    OPZVEVICDVDVKBOQZUBZVLVRVSVDVRCDVEVKAUCPZVEVSCDVDVKBUCQZUBZUDVLVMWAHVFVMWAN
    VKABUEUFSVLWCVTVQTIZLNVQLKIZVTNWBVLVPWJLVLVPVRVGTIZVSVITIZKIWJVLVNWLVOWMKVD
    VHVNWLNVEVJAUJUGVEVJVOWMNVDVHBUJUHUKVLVRVGVSVIWGWDWHWEVFVHVJULZVFVHVJUMZUNU
    SSVLVTVQLWIWFLCDVLUOUTVLVGVIWDWEWNWOUPUQVLWKVQVTVLVQWFURSVAVBVC $.

  $( Addition formula for tangent.  (Contributed by Mario Carneiro,
     4-Apr-2015.) $)
  tanadd $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( ( cos ` A ) =/= 0 /\
    ( cos ` B ) =/= 0 /\ ( cos ` ( A + B ) ) =/= 0 ) ) ->
      ( tan ` ( A + B ) ) = ( ( ( tan ` A ) + ( tan ` B ) ) /
        ( 1 - ( ( tan ` A ) x. ( tan ` B ) ) ) ) ) $=
    ( cc wcel wa ccos cfv cc0 caddc co ctan csin cdiv c1 cmul cmin wceq oveq12d
    wne eqtrd w3a addcl adantr simpr3 tanval sinadd cosadd simpll coscld simplr
    mulcld simpr1 tancld simpr2 adddid mul32d oveq2d sincld divcan2d oveq1d a1i
    syl2anc mulassd ax-1cn subdid mulid1d mul4d addcld subcl tanaddlem 3adantr3
    sylancr wb necomd subeq0 necon3bid mpbird mulne0d divcan5d 3eqtr2rd eqtr4d
    mpbid ) ACDZBCDZEZAFGZHSZBFGZHSZABIJZFGZHSZUAZEZWJKGZWJLGZWKMJZAKGZBKGZIJZN
    WRWSOJZPJZMJZWNWJCDZWLWOWQQWEXDWMABUBUCWEWGWIWLUDZWJUEVBWNWQALGZWHOJZWFBLGZ
    OJZIJZWFWHOJZXFXHOJZPJZMJXKWTOJZXKXBOJZMJXCWNWPXJWKXMMWEWPXJQWMABUFUCWEWKXM
    QWMABUGUCRWNXNXJXOXMMWNXNXKWROJZXKWSOJZIJXJWNXKWRWSWNWFWHWNAWCWDWMUHZUIZWNB
    WCWDWMUJZUIZUKZWNAXRWEWGWIWLULZUMZWNBXTWEWGWIWLUNZUMZUOWNXPXGXQXIIWNXPWFWRO
    JZWHOJXGWNWFWHWRXSYAYDUPWNYGXFWHOWNYGWFXFWFMJZOJXFWNWRYHWFOWNWCWGWRYHQXRYCA
    UEVBUQWNXFWFWNAXRURXSYCUSTZUTTWNXQWFWHWSOJZOJXIWNWFWHWSXSYAYFVCWNYJXHWFOWNY
    JWHXHWHMJZOJXHWNWSYKWHOWNWDWIWSYKQXTYEBUEVBUQWNXHWHWNBXTURYAYEUSTZUQTRTWNXO
    XKNOJZXKXAOJZPJXMWNXKNXAYBNCDZWNVDVAWNWRWSYDYFUKZVEWNYMXKYNXLPWNXKYBVFWNYNY
    GYJOJXLWNWFWHWRWSXSYAYDYFVGWNYGXFYJXHOYIYLRTRTRWNWTXBXKWNWRWSYDYFVHWNYOXACD
    ZXBCDVDYPNXAVIVLYBWNXBHSZNXASZWNXANWNWLXANSZXEWEWGWIWLYTVMWLABVJVKWBVNWNYOY
    QYRYSVMVDYPYOYQEXBHNXANXAVOVPVLVQWNWFWHXSYAYCYEVRVSVTWA $.

  $( Sine of difference.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  sinsub $p |- ( ( A e. CC /\ B e. CC ) -> ( sin ` ( A - B ) ) =
                  ( ( ( sin ` A ) x. ( cos ` B ) ) -
                    ( ( cos ` A ) x. ( sin ` B ) ) ) ) $=
    ( cc wcel cneg caddc csin cfv ccos cmul cmin wceq adantl oveq2d coscl sincl
    co syl2an eqtrd mulcl wa sinadd sylan2 negsub fveq2d cosneg mulneg2 oveq12d
    negcl sinneg negsubd 3eqtr3d ) ACDZBCDZUAZABEZFQZGHZAGHZUPIHZJQZAIHZUPGHZJQ
    ZFQZABKQZGHUSBIHZJQZVBBGHZJQZKQZUNUMUPCDURVELBUIAUPUBUCUOUQVFGABUDUEUOVEVHV
    JEZFQVKUOVAVHVDVLFUOUTVGUSJUNUTVGLUMBUFMNUOVDVBVIEZJQZVLUOVCVMVBJUNVCVMLUMB
    UJMNUMVBCDZVICDZVNVLLUNAOZBPZVBVIUGRSUHUOVHVJUMUSCDVGCDVHCDUNAPBOUSVGTRUMVO
    VPVJCDUNVQVRVBVITRUKSUL $.

  $( Cosine of difference.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  cossub $p |- ( ( A e. CC /\ B e. CC ) -> ( cos ` ( A - B ) ) =
                  ( ( ( cos ` A ) x. ( cos ` B ) ) +
                    ( ( sin ` A ) x. ( sin ` B ) ) ) ) $=
    ( cc wcel cneg caddc co ccos cmul csin cmin wceq adantl oveq2d sincl syl2an
    cfv eqtrd coscl mulcl wa cosadd sylan2 negsub fveq2d cosneg mulneg2 oveq12d
    negcl sinneg subnegd 3eqtr3d ) ACDZBCDZUAZABEZFGZHQZAHQZUPHQZIGZAJQZUPJQZIG
    ZKGZABKGZHQUSBHQZIGZVBBJQZIGZFGZUNUMUPCDURVELBUIAUPUBUCUOUQVFHABUDUEUOVEVHV
    JEZKGVKUOVAVHVDVLKUOUTVGUSIUNUTVGLUMBUFMNUOVDVBVIEZIGZVLUOVCVMVBIUNVCVMLUMB
    UJMNUMVBCDZVICDZVNVLLUNAOZBOZVBVIUGPRUHUOVHVJUMUSCDVGCDVHCDUNASBSUSVGTPUMVO
    VPVJCDUNVQVRVBVITPUKRUL $.

  $( Sum of sines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  addsin $p |- ( ( A e. CC /\ B e. CC ) -> ( ( sin ` A ) + ( sin ` B ) ) =
                    ( 2 x. ( ( sin ` ( ( A + B ) / 2 ) ) x.
                             ( cos ` ( ( A - B ) / 2 ) ) ) ) ) $=
    ( cc wcel c2 caddc co cdiv csin cmin ccos cmul halfcld sincld coscld mulcld
    cfv wceq syl2anc oveq12d wa addcl subcl 2timesd sinadd sinsub ppncand eqtrd
    halfaddsub simpld fveq2d simprd 3eqtr2rd ) ACDBCDUAZEABFGZEHGZIQZABJGZEHGZK
    QZLGZLGVAVAFGZUPUSFGZIQZUPUSJGZIQZFGZAIQZBIQZFGUNVAUNUQUTUNUPUNUOABUBMZNUNU
    SUNURABUCMZOPZUDUNVGVAUPKQZUSIQZLGZFGZVAVOJGZFGVBUNVDVPVFVQFUNUPCDZUSCDZVDV
    PRVJVKUPUSUESUNVRVSVFVQRVJVKUPUSUFSTUNVAVOVAVLUNVMVNUNUPVJOUNUSVKNPVLUGUHUN
    VDVHVFVIFUNVCAIUNVCARZVEBRZABUIZUJUKUNVEBIUNVTWAWBULUKTUM $.

  $( Difference of sines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  subsin $p |- ( ( A e. CC /\ B e. CC ) -> ( ( sin ` A ) - ( sin ` B ) ) =
                    ( 2 x. ( ( cos ` ( ( A + B ) / 2 ) ) x.
                             ( sin ` ( ( A - B ) / 2 ) ) ) ) ) $=
    ( cc wcel wa c2 caddc cdiv ccos cfv cmin csin cmul coscl sincl mulcl syl2an
    co syl wceq halfaddsubcl 2timesd sinadd sinsub oveq12d pnncand eqtrd simpld
    halfaddsub fveq2d simprd 3eqtr2rd ) ACDBCDEZFABGRFHRZIJZABKRFHRZLJZMRZMRURU
    RGRZUNUPGRZLJZUNUPKRZLJZKRZALJZBLJZKRUMURUMUNCDZUPCDZEZURCDZABUAZVGUOCDUQCD
    VJVHUNNUPOUOUQPQSZUBUMVDUNLJZUPIJZMRZURGRZVOURKRZKRZUSUMVIVDVRTVKVIVAVPVCVQ
    KUNUPUCUNUPUDUESUMVOURURUMVIVOCDZVKVGVMCDVNCDVSVHUNOUPNVMVNPQSVLVLUFUGUMVAV
    EVCVFKUMUTALUMUTATZVBBTZABUIZUHUJUMVBBLUMVTWAWBUKUJUEUL $.

  $( Product of sines can be rewritten as half the difference of certain
     cosines.  This follows from ~ cosadd and ~ cossub .  (Contributed by David
     A. Wheeler, 26-May-2015.) $)
  sinmul $p |- ( ( A e. CC /\ B e. CC ) -> ( ( sin ` A ) x. ( sin ` B ) ) =
           ( ( ( cos ` ( A - B ) ) - ( cos ` ( A + B ) ) ) / 2 ) ) $=
    ( cc wcel wa cmin co ccos cfv caddc cdiv csin cmul coscl mulcl syl2an sincl
    c2 wceq 2cn cossub cosadd oveq12d pnncan 2times adantl eqtr4d mulcom 3eqtrd
    3anidm23 syl2anc sylancr oveq1d cc0 wne 2ne0 divcan4 mp3an23 syl eqtr2d ) A
    CDZBCDZEZABFGHIZABJGHIZFGZRKGALIZBLIZMGZRMGZRKGZVIVCVFVJRKVCVFAHIZBHIZMGZVI
    JGZVNVIFGZFGZRVIMGZVJVCVDVOVEVPFABUAABUBUCVCVNCDZVICDZVQVRSVAVLCDVMCDVSVBAN
    BNVLVMOPVAVGCDVHCDVTVBAQBQVGVHOPZVSVTEVQVIVIJGZVRVSVTVQWBSVNVIVIUDUJVTVRWBS
    VSVIUEUFUGUKVCRCDZVTVRVJSTWARVIUHULUIUMVCVTVKVISZWAVTWCRUNUOWDTUPVIRUQURUSU
    T $.

  $( Product of cosines can be rewritten as half the sum of certain cosines.
     This follows from ~ cosadd and ~ cossub .  (Contributed by David A.
     Wheeler, 26-May-2015.) $)
  cosmul $p |- ( ( A e. CC /\ B e. CC ) -> ( ( cos ` A ) x. ( cos ` B ) ) =
          ( ( ( cos ` ( A - B ) ) + ( cos ` ( A + B ) ) ) / 2 ) ) $=
    ( cc wcel wa c2 ccos cfv cmul co cdiv cmin caddc cc0 wne coscl mulcl syl2an
    csin sincl w3a wceq 2cn 2ne0 pm3.2i a1i 3anass sylanbrc divcan3 syl ppncand
    cossub cosadd oveq12d 2timesd 3eqtr4rd oveq1d eqtr3d ) ACDZBCDZEZFAGHZBGHZI
    JZIJZFKJZVDABLJGHZABMJGHZMJZFKJVAVDCDZFCDZFNOZUAZVFVDUBVAVJVKVLEZVMUSVBCDVC
    CDVJUTAPBPVBVCQRZVNVAVKVLUCUDUEUFVJVKVLUGUHVDFUIUJVAVEVIFKVAVDASHZBSHZIJZMJ
    ZVDVRLJZMJVDVDMJVIVEVAVDVRVDVOUSVPCDVQCDVRCDUTATBTVPVQQRVOUKVAVGVSVHVTMABUL
    ABUMUNVAVDVOUOUPUQUR $.

  $( Sum of cosines.  (Contributed by Paul Chapman, 12-Oct-2007.) $)
  addcos $p |- ( ( A e. CC /\ B e. CC ) -> ( ( cos ` A ) + ( cos ` B ) ) =
                    ( 2 x. ( ( cos ` ( ( A + B ) / 2 ) ) x.
                             ( cos ` ( ( A - B ) / 2 ) ) ) ) ) $=
    ( cc wcel wa ccos cfv caddc co c2 cdiv cmin cmul wceq syl2an fveq2d oveq12d
    coscl csin syl addcom simprd simpld halfaddsubcl mulcl sincl ppncand cossub
    halfaddsub cosadd 2timesd 3eqtr4d 3eqtr2d ) ACDZBCDZEZAFGZBFGZHIZURUQHIZABH
    IJKIZABLIJKIZLIZFGZVAVBHIZFGZHIZJVAFGZVBFGZMIZMIZUNUQCDURCDUSUTNUOARBRUQURU
    AOUPVDURVFUQHUPVCBFUPVEANZVCBNZABUIZUBPUPVEAFUPVLVMVNUCPQUPVJVASGZVBSGZMIZH
    IZVJVQLIZHIZVJVJHIVGVKUPVJVQVJUPVACDZVBCDZEZVJCDZABUDZWAVHCDVICDWDWBVARVBRV
    HVIUEOTZUPWCVQCDZWEWAVOCDVPCDWGWBVAUFVBUFVOVPUEOTWFUGUPWCVGVTNWEWCVDVRVFVSH
    VAVBUHVAVBUJQTUPVJWFUKULUM $.

  $( Difference of cosines.  (Contributed by Paul Chapman, 12-Oct-2007.)
     (Revised by Mario Carneiro, 10-May-2014.) $)
  subcos $p |- ( ( A e. CC /\ B e. CC ) -> ( ( cos ` B ) - ( cos ` A ) ) =
                  ( 2 x. ( ( sin ` ( ( A + B ) / 2 ) ) x.
                           ( sin ` ( ( A - B ) / 2 ) ) ) ) ) $=
    ( cc wcel wa c2 caddc co cdiv csin cfv cmin cmul ccos sincl syl2an syl wceq
    mulcl oveq12d halfaddsubcl 2timesd cossub cosadd coscl pnncand eqtrd simprd
    halfaddsub fveq2d simpld 3eqtr2rd ) ACDBCDEZFABGHFIHZJKZABLHFIHZJKZMHZMHURU
    RGHZUNUPLHZNKZUNUPGHZNKZLHZBNKZANKZLHUMURUMUNCDZUPCDZEZURCDZABUAZVGUOCDUQCD
    VJVHUNOUPOUOUQSPQZUBUMVDUNNKZUPNKZMHZURGHZVOURLHZLHZUSUMVIVDVRRVKVIVAVPVCVQ
    LUNUPUCUNUPUDTQUMVOURURUMVIVOCDZVKVGVMCDVNCDVSVHUNUEUPUEVMVNSPQVLVLUFUGUMVA
    VEVCVFLUMUTBNUMVBARZUTBRZABUIZUHUJUMVBANUMVTWAWBUKUJTUL $.

  $( Sine squared plus cosine squared is 1.  Equation 17 of [Gleason] p. 311.
     Note that this holds for non-real arguments, even though individually each
     term is unbounded.  (Contributed by NM, 15-Jan-2006.) $)
  sincossq $p |- ( A e. CC ->
                  ( ( ( sin ` A ) ^ 2 ) + ( ( cos ` A ) ^ 2 ) ) = 1 ) $=
    ( cc wcel cneg caddc co ccos cfv cmul csin c1 cexp cc0 sqvald oveq2d eqtr4d
    c2 sqcld eqtrd mulcld cmin wceq negcl cosadd mpdan negid fveq2d cos0 syl6eq
    addcomd cosneg sinneg negeqd negnegd sincld mulneg2d oveq12d coscld negsubd
    sincl coscl 3eqtrrd 3eqtr3rd ) ABCZAADZEFZGHZAGHZVEGHZIFZAJHZVEJHZIFZUAFZKV
    KQLFZVHQLFZEFZVDVEBCVGVNUBAUCZAVEUDUEVDVGMGHKVDVFMGAUFUGUHUIVDVQVPVOEFVJVMD
    ZEFVNVDVOVPVDVKAUTZRVDVHAVAZRUJVDVPVJVOVSEVDVPVHVHIFVJVDVHWANVDVIVHVHIAUKOP
    VDVOVKVLDZIFZVSVDVOVKVKIFWCVDVKVTNVDWBVKVKIVDWBVKDZDVKVDVLWDAULUMVDVKVTUNSO
    PVDVKVLVTVDVEVRUOZUPSUQVDVJVMVDVHVIWAVDVEVRURTVDVKVLVTWETUSVBVC $.

  $( Double-angle formula for sine.  (Contributed by Paul Chapman,
     17-Jan-2008.) $)
  sin2t $p |- ( A e. CC ->
      ( sin ` ( 2 x. A ) ) = ( 2 x. ( ( sin ` A ) x. ( cos ` A ) ) ) ) $=
    ( cc wcel c2 cmul co csin cfv caddc ccos 2times fveq2d coscl mulcomd oveq2d
    sincl wceq sinadd anidms mulcld 2timesd 3eqtr4d eqtrd ) ABCZDAEFZGHAAIFZGHZ
    DAGHZAJHZEFZEFZUDUEUFGAKLUDUJUIUHEFZIFZUJUJIFUGUKUDULUJUJIUDUIUHAMZAPZNOUDU
    GUMQAARSUDUJUDUHUIUOUNTUAUBUC $.

  $( Double-angle formula for cosine.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  cos2t $p |- ( A e. CC -> ( cos ` ( 2 x. A ) ) =
                           ( ( 2 x. ( ( cos ` A ) ^ 2 ) ) - 1 ) ) $=
    ( cc wcel ccos cfv c2 cexp co c1 cmin caddc cmul coscl sqcld ax-1cn subsub3
    wceq syl2anc sqvald 3eqtr4d mp3an2 csin cosadd anidms 2times fveq2d oveq12d
    sincl addcomd sincossq eqtr3d wb subadd mp3an1 mpbird oveq2d eqtr4d 2timesd
    oveq1d ) ABCZADEZFGHZIVBJHZJHZVBVBKHZIJHZFALHZDEZFVBLHZIJHUTVBBCZVJVDVFQZUT
    VAAMZNZVMVJIBCZVJVKOVBIVBPUARUTVHVBAUBEZFGHZJHZVDUTAAKHZDEZVAVALHZVOVOLHZJH
    ZVHVQUTVSWBQAAUCUDUTVGVRDAUEUFUTVBVTVPWAJUTVAVLSUTVOAUHZSUGTUTVCVPVBJUTVCVP
    QZVBVPKHZIQZUTVPVBKHWEIUTVPVBUTVOWCNZVMUIAUJUKUTVJVPBCZWDWFULZVMWGVNVJWHWIO
    IVBVPUMUNRUOUPUQUTVIVEIJUTVBVMURUST $.

  $( Double-angle formula for cosine in terms of sine.  (Contributed by NM,
     12-Sep-2008.) $)
  cos2tsin $p |- ( A e. CC -> ( cos ` ( 2 x. A ) ) =
                           ( 1 - ( 2 x. ( ( sin ` A ) ^ 2 ) ) ) ) $=
    ( cc wcel c2 cmul co ccos cfv cexp cmin wceq caddc sqcld 2cn mp3an1 syl2anc
    c1 syl6eq mulcl sylancr csin cos2t sincl coscl adddi sincossq oveq2d eqtr3d
    mulid1i subadd mpbird oveq1d ax-1cn sub32 mp3an13 syl 2m1e1 oveq1i 3eqtr2d
    wb ) ABCZDAEFGHDAGHZDIFZEFZQJFDDAUAHZDIFZEFZJFZQJFZQVGJFZAUBVAVHVDQJVAVHVDK
    ZVGVDLFZDKZVAVLDQEFZDVADVFVCLFZEFZVLVNVAVFBCZVCBCZVPVLKZVAVEAUCMZVAVBAUDMZD
    BCZVQVRVSNDVFVCUEOPVAVOQDEAUFUGUHDNUIRVAVGBCZVDBCZVKVMUTZVAWBVQWCNVTDVFSTZV
    AWBVRWDNWADVCSTWBWCWDWENDVGVDUJOPUKULVAVIDQJFZVGJFZVJVAWCVIWHKZWFWBWCQBCWIN
    UMDVGQUNUOUPWGQVGJUQURRUS $.

  $( The sine of a real number lies between -1 and 1.  Equation 18 of [Gleason]
     p. 311.  (Contributed by NM, 16-Jan-2006.) $)
  sinbnd $p |- ( A e. RR -> ( -u 1 <_ ( sin ` A ) /\ ( sin ` A ) <_ 1 ) ) $=
    ( cr wcel csin cfv c1 cle wbr cneg c2 cexp co wa ccos cc0 resqcld mpbid syl
    wb 1re caddc recoscl sqge0d resincl addge01d wceq recn sincossq sq1 syl6eqr
    cc breqtrd 0le1 lenegsq mp3an23 lenegcon1 mpan2 anbi2d bitr3d ancomd ) ABCZ
    ADEZFGHZFIVBGHZVAVBJKLZFJKLZGHZVCVDMZVAVEVEANEZJKLZUALZVFGVAOVJGHVEVKGHVAVI
    AUBZUCVAVEVJVAVBAUDZPVAVIVLPUEQVAVKFVFVAAUKCVKFUFAUGAUHRUIUJULVAVBBCZVGVHSV
    MVNVCVBIFGHZMZVGVHVNFBCZOFGHVPVGSTUMVBFUNUOVNVOVDVCVNVQVOVDSTVBFUPUQURUSRQU
    T $.

  $( The cosine of a real number lies between -1 and 1.  Equation 18 of
     [Gleason] p. 311.  (Contributed by NM, 16-Jan-2006.) $)
  cosbnd $p |- ( A e. RR -> ( -u 1 <_ ( cos ` A ) /\ ( cos ` A ) <_ 1 ) ) $=
    ( cr wcel ccos cfv c1 cle wbr cneg c2 cexp co wa csin cc0 resqcld mpbid syl
    wb 1re caddc resincl sqge0d recoscl addge02d wceq recn sincossq sq1 syl6eqr
    cc breqtrd 0le1 lenegsq mp3an23 lenegcon1 mpan2 anbi2d bitr3d ancomd ) ABCZ
    ADEZFGHZFIVBGHZVAVBJKLZFJKLZGHZVCVDMZVAVEANEZJKLZVEUALZVFGVAOVJGHVEVKGHVAVI
    AUBZUCVAVEVJVAVBAUDZPVAVIVLPUEQVAVKFVFVAAUKCVKFUFAUGAUHRUIUJULVAVBBCZVGVHSV
    MVNVCVBIFGHZMZVGVHVNFBCZOFGHVPVGSTUMVBFUNUOVNVOVDVCVNVQVOVDSTVBFUPUQURUSRQU
    T $.

  $( The sine of a real number is in the closed interval from -1 to 1.
     (Contributed by Mario Carneiro, 12-May-2014.) $)
  sinbnd2 $p |- ( A e. RR -> ( sin ` A ) e. ( -u 1 [,] 1 ) ) $=
    ( cr wcel csin cfv c1 cneg cle wbr cicc co resincl sinbnd simpld simprd 1re
    renegcli elicc2i syl3anbrc ) ABCZADEZBCFGZUAHIZUAFHIZUAUBFJKCALTUCUDAMZNTUC
    UDUEOUBFUAFPQPRS $.

  $( The cosine of a real number is in the closed interval from -1 to 1.
     (Contributed by Mario Carneiro, 12-May-2014.) $)
  cosbnd2 $p |- ( A e. RR -> ( cos ` A ) e. ( -u 1 [,] 1 ) ) $=
    ( cr wcel ccos cfv c1 cneg cle wbr cicc co recoscl cosbnd simpld simprd 1re
    renegcli elicc2i syl3anbrc ) ABCZADEZBCFGZUAHIZUAFHIZUAUBFJKCALTUCUDAMZNTUC
    UDUEOUBFUAFPQPRS $.

  ${
    $d k n A $.  $d k F $.
    ef01bnd.1 $e |- F = ( n e. NN0 |-> ( ( ( _i x. A ) ^ n ) / ( ! ` n ) ) ) $.
    $( Lemma for ~ sin01bnd and ~ cos01bnd .  (Contributed by Paul Chapman,
       19-Jan-2008.) $)
    ef01bndlem $p |- ( A e. ( 0 (,] 1 ) ->
        ( abs ` sum_ k e. ( ZZ>= ` 4 ) ( F ` k ) ) < ( ( A ^ 4 ) / 6 ) ) $=
      ( c1 co wcel c4 cfv cexp cmul cdiv c6 cr clt wbr c5 c2 c3 cc0 cioc cuz cv
      csu cabs caddc cfa ci cc cn0 ax-icn cle cxr w3a wb 0xr 1re elioc2 simp1bi
      mp2an recnd mulcl sylancr 4nn0 eftlcl sylancl abscld reexpcl 4re readdcli
      cn faccl ax-mp 4nn nnmulcli nndivre remulcl 6nn cmpt eqid a1i wceq absmul
      absi oveq1i crp simp2bi elrpd rpre rpge0 absidd syl oveq2d syl5eq mulid2d
      3eqtrd simp3bi eqbrtrd eftlub breqtrd 3pos 0re 3re 5re ltadd1i mpbi recni
      oveq1d addid2i cu2 5p3e8 3nn nncni addcomi 3eqtr2ri 3brtr3i 2re 2nn nnge1
      c8 cz nnzi 3lt4 ltleii eluz1i mpbir2an leexp2a mp3an 8re eqeltri 6re 6pos
      df-4 sq2 oveq2i fac3 3eqtr3i 2nn0 eqtr3i nnexpcl remulcli nngt0i mulgt0ii
      nnrei ltletri ltdiv1ii df-5 fveq2i 3nn0 facp1 eqtr2i 3eqtri mulassi 2p2e4
      2cn expadd oveq12i mulid2i nnne0i dividi ax-1cn gt0ne0ii rereccli mulid1i
      divmuldivi rpexpcl wa elrp ltmul2 mp3an12 sylbi mpbii wne divrec breqtrrd
      mp3an23 lelttrd ) AUAFUBGHZIUCJBUDDJBUEZUFJZAIKGZIFUGGZIUHJZILGZMGZLGZUWB
      NMGZUVSUVTUVSUIALGZUJHZIUKHZUVTUJHUVSUIUJHZAUJHZUWJULUVSAUVSAOHZUAAPQZAFU
      MQZUAUNHFOHUVSUWNUWOUWPUOUPUQURUAFAUSVAZUTZVBZUIAVCVDZVEUWIBCDIEVFVGVHUVS
      UWBOHZUWFOHZUWGOHUVSUWNUWKUXAUWRVEAIVIVGZUWCOHUWEVLHUXBIFVJURVKUWDIUWKUWD
      VLHVEIVMVNVOVPUWCUWEVQVAZUWBUWFVRVGUVSUXANVLHUWHOHUXCVSUWBNVQVGUVSUWAUWIU
      FJZIKGZUWFLGUWGUMUVSUWIBCDCUKUXECUDZKGUXGUHJMGVTZCUKUXFUWDMGFUWCMGUXGKGLG
      VTZIEUXHWAUXIWAIVLHUVSVOWBUWTUVSUXEAFUMUVSUXEUIUFJZAUFJZLGZFALGZAUVSUWLUW
      MUXEUXLWCULUWSUIAWDVDUVSUXLFUXKLGUXMUXJFUXKLWEWFUVSUXKAFLUVSAWGHZUXKAWCUV
      SAUWRUVSUWNUWOUWPUWQWHWIZUXNAAWJAWKWLWMWNWOUVSAUWSWPWQZUVSUWNUWOUWPUWQWRW
      SWTUVSUXFUWBUWFLUVSUXEAIKUXPXIXIXAUVSUWGUWBFNMGZLGZUWHPUVSUWFUXQPQZUWGUXR
      PQZRNSIKGZLGZMGZUYAUYBMGZUWFUXQPRUYAPQZUYCUYDPQRSTKGZPQUYFUYAUMQZUYEUARUG
      GZTRUGGZRUYFPUATPQUYHUYIPQXBUATRXCXDXEXFXGRRXEXHZXJUYFYARTUGGUYIXKXLRTUYJ
      TXMXNXOXPXQSOHFSUMQZITUCJHZUYGXRSVLHZUYKXSSXTVNUYLIYBHZTIUMQIVOYCZTIXDVJY
      DYETITXMYCYFYGSTIYHYIRUYFUYAXEUYFYAOXKYJYKUYAUYMUWKUYAVLHXSVESIUUAVAZUUEZ
      UUFVARUYAUYBXEUYQNUYAYLUYQUUBNUYAYLUYQYMUYAUYPUUCUUDUUGXGRUWCUYBUWEMUUHUW
      ETUHJZSSKGZUYSLGZLGZUYRUYALGUYBUWDUYSLGUYRUYSLGZUYSLGUWEVUAUWDVUBUYSLUWDT
      FUGGZUHJZUYRVUCLGZVUBIVUCUHYNUUITUKHVUDVUEWCUUJTUUKVNVUCUYSUYRLUYSIVUCYOY
      NUULYPUUMWFUYSIUWDLYOYPUYRUYSUYSUYRNUJYQNYLXHZYKUYSIUJYOIVJXHYKZVUGUUNYRU
      YAUYTUYRLSSSUGGZKGZUYAUYTVUHISKUUOYPSUJHSUKHZVUJVUIUYTWCUUPYSYSSSSUUQYIYT
      YPUYRNUYALYQWFXPUURFUYALGZUYBMGZUYDUXQVUKUYAUYBMUYAUYAUYPXNZUUSWFUXQUYAUY
      AMGZLGUXQFLGVULUXQVUNFUXQLUYAVUMUYAUYPUUTZUVAYPFNUYAUYAUVBVUFVUMVUMNYLYMU
      VCZVUOUVFUXQUXQNYLVUPUVDZXHUVEYRYTXQUVSUWBWGHZUXSUXTUPZUVSUXNUYNVURUXOUYO
      AIUVGVGVURUXAUAUWBPQUVHZVUSUWBUVIUXBUXQOHVUTVUSUXDVUQUWFUXQUWBUVJUVKUVLWM
      UVMUVSUWBUJHZUWHUXRWCZUVSUWBUXCVBVVANUJHNUAUVNVVBVUFVUPUWBNUVOUVQWMUVPUVR
      $.
  $}

  ${
    $d A k n $.
    $( Bounds on the sine of a positive real number less than or equal to 1.
       (Contributed by Paul Chapman, 19-Jan-2008.)  (Revised by Mario Carneiro,
       30-Apr-2014.) $)
    sin01bnd $p |- ( A e. ( 0 (,] 1 ) ->
        ( ( A - ( ( A ^ 3 ) / 3 ) ) < ( sin ` A ) /\ ( sin ` A ) < A ) ) $=
      ( vk vn cc0 co wcel cfv c3 c6 cdiv cmin clt wbr c4 caddc cr recnd sylancl
      cle cc c1 cioc csin cexp cabs wa cuz cv cn0 ci cmul cfa cmpt csu cim wceq
      cxr w3a wb 0xr 1re elioc2 mp2an simp1bi eqid resin4p eqcomd resincld 3nn0
      syl reexpcl 6nn nndivre resubcld ax-icn mulcl sylancr 4nn0 eftlcl subaddd
      cn imcld mpbird fveq2d abscld absimle ef01bndlem a1i cz 4nn nnzi 3re 3lt4
      4re ltleii 3nn eluz1i mpbir2an simp2bi 0re ltle mpd simp3bi leexp2rd 6pos
      6re lediv1 syl112anc mpbid ltletrd lelttrd eqbrtrd absdifltd subsub4d wne
      wi 3cn 3ne0 pm3.2i 2cn 2ne0 divdiv1 mp3an23 3t2e6 oveq2i syl6req 2halvesd
      c2 oveq12d eqtrd oveq2d breq1d npcand breq2d anbi12d bitrd ) ADUAUBEFZAUC
      GZAAHUDEZIJEZKEZKEZUEGZYTLMZAYSHJEZKEZYRLMZYRALMZUFZYQUUCNUGGBUHCUIUJAUKE
      ZCUHZUDEUUKULGJEUMZGBUNZUOGZUEGZYTLYQUUBUUNUEYQUUBUUNUPUUAUUNOEZYRUPYQYRU
      UPYQAPFZYRUUPUPYQUUQDALMZAUASMZDUQFUAPFYQUUQUURUUSURUSUTVADUAAVBVCZVDZABC
      UULUULVEZVFVJVGYQYRUUAUUNYQYRYQAUVAVHZQYQUUAYQAYTUVAYQYSPFZIWAFZYTPFYQUUQ
      HUIFZUVDUVAVIAHVKRZVLYSIVMRZVNZQYQUUNYQUUMYQUUJTFZNUIFZUUMTFZYQUJTFATFUVJ
      VOYQAUVAQZUJAVPVQVRUUJBCUULNUVBVSRZWBQZVTWCWDYQUUOUUMUEGZYTYQUUNUVOWEYQUU
      MUVNWEZUVHYQUVLUUOUVPSMUVNUUMWFVJYQUVPANUDEZIJEZYTUVQYQUVRPFZUVEUVSPFYQUU
      QUVKUVTUVAVRANVKRZVLUVRIVMRUVHABCUULUVBWGYQUVRYSSMZUVSYTSMZYQAHNUVAUVFYQV
      IWHNHUGGFZYQUWDNWIFHNSMNWJWKHNWLWNWMWOHNHWPWKWQWRWHYQUURDASMZYQUUQUURUUSU
      UTWSYQDPFUUQUURUWEXPWTUVADAXAVQXBYQUUQUURUUSUUTXCXDYQUVTUVDIPFZDILMZUWBUW
      CUSUWAUVGUWFYQXFWHUWGYQXEWHUVRYSIXGXHXIXJXKXLYQUUDUUAYTKEZYRLMZYRUUAYTOEZ
      LMZUFUUIYQYRUUAYTUVCUVIUVHXMYQUWIUUGUWKUUHYQUWHUUFYRLYQUWHAYTYTOEZKEUUFYQ
      AYTYTUVMYQYTUVHQZUWMXNYQUWLUUEAKYQUWLUUEYHJEZUWNOEUUEYQYTUWNYTUWNOYQUWNYS
      HYHUKEZJEZYTYQYSTFZUWNUWPUPZYQYSUVGQUWQHTFZHDXOZUFYHTFZYHDXOZUFUWRUWSUWTX
      QXRXSUXAUXBXTYAXSYSHYHYBYCVJUWOIYSJYDYEYFZUXCYIYQUUEYQUUEYQUVDHWAFUUEPFUV
      GWPYSHVMRQYGYJYKYJYLYQUWJAYRLYQAYTUVMUWMYMYNYOYPXI $.

    $( Bounds on the cosine of a positive real number less than or equal to 1.
       (Contributed by Paul Chapman, 19-Jan-2008.)  (Revised by Mario Carneiro,
       30-Apr-2014.) $)
    cos01bnd $p |- ( A e. ( 0 (,] 1 ) ->
                     ( ( 1 - ( 2 x. ( ( A ^ 2 ) / 3 ) ) ) < ( cos ` A ) /\
                       ( cos ` A ) < ( 1 - ( ( A ^ 2 ) / 3 ) ) ) ) $=
      ( cc0 c1 co wcel cfv c2 cdiv cmin c6 clt wbr c3 cmul c4 wceq cr syl recnd
      cc vk vn cioc ccos cexp cabs wa cuz cv cn0 cfa cmpt csu cre caddc cle cxr
      ci w3a wb 0xr elioc2 mp2an simp1bi eqid recos4p eqcomd recoscld rehalfcld
      1re resqcld resubcl sylancr ax-icn mulcl 4nn0 eftlcl sylancl recld mpbird
      subaddd fveq2d abscld 6nn nndivre absrele reexpcl ef01bndlem 2nn0 a1i 4nn
      cn cz nnzi 2re 4re 2lt4 ltleii 2z eluz1i mpbir2an simp2bi wi 0re ltle mpd
      simp3bi leexp2rd lediv1 syl112anc mpbid ltletrd lelttrd eqbrtrd absdifltd
      6re 6pos ax-1cn subsub4d halfpm6th simpri oveq2i 2ne0 reccli nncni nnne0i
      2cn adddi mp3an23 syl5eqr wne 3ne0 pm3.2i mp3an13 divrec oveq12d 3eqtr4rd
      3cn div12 oveq2d eqtrd breq1d subsubd simpli subdi eqtr3d breq2d anbi12d
      bitrd ) ABCUCDEZAUDFZCAGUEDZGHDZIDZIDZUFFZUULJHDZKLZCGUULMHDZNDZIDZUUKKLZ
      UUKCUUSIDZKLZUGZUUJUUPOUHFUAUIUBUJURANDZUBUIZUEDUVGUKFHDULZFUAUMZUNFZUFFZ
      UUQKUUJUUOUVJUFUUJUUOUVJPUUNUVJUODZUUKPUUJUUKUVLUUJAQEZUUKUVLPUUJUVMBAKLZ
      ACUPLZBUQECQEZUUJUVMUVNUVOUSUTVAVJBCAVBVCZVDZAUAUBUVHUVHVEZVFRVGUUJUUKUUN
      UVJUUJUUKUUJAUVRVHZSUUJUUNUUJUVPUUMQEUUNQEVJUUJUULUUJAUVRVKZVIZCUUMVLVMZS
      UUJUVJUUJUVIUUJUVFTEZOUJEZUVITEZUUJURTEATEUWDVNUUJAUVRSURAVOVMVPUVFUAUBUV
      HOUVSVQVRZVSSZWAVTWBUUJUVKUVIUFFZUUQUUJUVJUWHWCUUJUVIUWGWCZUUJUULQEZJWLEZ
      UUQQEUWAWDUULJWEVRZUUJUWFUVKUWIUPLUWGUVIWFRUUJUWIAOUEDZJHDZUUQUWJUUJUWNQE
      ZUWLUWOQEUUJUVMUWEUWPUVRVPAOWGVRZWDUWNJWEVRUWMAUAUBUVHUVSWHUUJUWNUULUPLZU
      WOUUQUPLZUUJAGOUVRGUJEUUJWIWJOGUHFEZUUJUWTOWMEGOUPLOWKWNGOWOWPWQWRGOWSWTX
      AWJUUJUVNBAUPLZUUJUVMUVNUVOUVQXBUUJBQEUVMUVNUXAXCXDUVRBAXEVMXFUUJUVMUVNUV
      OUVQXGXHUUJUWPUWKJQEZBJKLZUWRUWSUTUWQUWAUXBUUJXPWJUXCUUJXQWJUWNUULJXIXJXK
      XLXMXNUUJUURUUNUUQIDZUUKKLZUUKUUNUUQUODZKLZUGUVEUUJUUKUUNUUQUVTUWCUWMXOUU
      JUXEUVBUXGUVDUUJUXDUVAUUKKUUJUXDCUUMUUQUODZIDUVAUUJCUUMUUQCTEUUJXRWJZUUJU
      UMUWBSZUUJUUQUWMSZXSUUJUXHUUTCIUUJUULGMHDZNDZUULCGHDZNDZUULCJHDZNDZUODZUU
      TUXHUUJUXMUULUXNUXPUODZNDZUXRUXSUXLUULNUXNUXPIDZCMHDZPZUXSUXLPZXTYAYBUUJU
      ULTEZUXTUXRPZUUJUULUWASZUYEUXNTEZUXPTEZUYFGYGYCYDZJJWDYEZJWDYFZYDZUULUXNU
      XPYHYIRYJUUJUYEUUTUXMPZUYGGTEZUYEMTEZMBYKZUGUYNYGUYPUYQYRYLYMGUULMYSYNRUU
      JUUMUXOUUQUXQUOUUJUYEUUMUXOPZUYGUYEUYOGBYKUYRYGYCUULGYOYIRZUUJUYEUUQUXQPZ
      UYGUYEJTEJBYKUYTUYKUYLUULJYOYIRZYPYQYTUUAUUBUUJUXFUVCUUKKUUJCUUMUUQIDZIDU
      XFUVCUUJCUUMUUQUXIUXJUXKUUCUUJVUBUUSCIUUJUULUYBNDZUXOUXQIDZUUSVUBUUJVUCUU
      LUYANDZVUDUYAUYBUULNUYCUYDXTUUDYBUUJUYEVUEVUDPZUYGUYEUYHUYIVUFUYJUYMUULUX
      NUXPUUEYIRYJUUJUYEUUSVUCPZUYGUYEUYPUYQVUGYRYLUULMYOYIRUUJUUMUXOUUQUXQIUYS
      VUAYPYQYTUUFUUGUUHUUIXK $.
  $}

  $( Bounds on the cosine of 1.  (Contributed by Paul Chapman, 19-Jan-2008.) $)
  cos1bnd $p |- ( ( 1 / 3 ) < ( cos ` 1 ) /\ ( cos ` 1 ) < ( 2 / 3 ) ) $=
    ( c1 c3 cdiv co clt wbr c2 cmul cmin oveq1i oveq2i 2cn 3cn 3ne0 caddc eqtri
    ax-1cn wcel cc0 1re ccos cfv cexp divreci eqtr4i divcli reccli df-3 divdiri
    sq1 dividi 3eqtr3ri subaddrii cr cle wa 0lt1 1le1 w3a cioc cxr wb 0xr mp2an
    elioc2 cos01bnd sylbir mp3an simpli eqbrtrri simpri subadd2i breqtri pm3.2i
    wceq mpbir ) ABCDZAUAUBZEFVRGBCDZEFAGAGUCDZBCDZHDZIDZVQVREWCAVSIDVQWBVSAIWB
    GVQHDVSWAVQGHVTABCUJJZKGBLMNUDUEKAVSVQQGBLMNUFZBMNUGZBBCDGAODZBCDAVSVQODZBW
    GBCUHJBMNUKGABLQMNUIULZUMPWCVREFZVRAWAIDZEFZAUNRZSAEFZAAUOFZWJWLUPZTUQURWMW
    NWOUSZASAUTDRZWPSVARWMWRWQVBVCTSAAVEVDAVFVGVHZVIVJVRWKVSEWJWLWSVKWKAVQIDZVS
    WAVQAIWDKWTVSVOWHAVOWIAVQVSQWFWEVLVPPVMVN $.

  $( Bounds on the cosine of 2.  (Contributed by Paul Chapman, 19-Jan-2008.) $)
  cos2bnd $p |- ( -u ( 7 / 9 ) < ( cos ` 2 ) /\
                     ( cos ` 2 ) < -u ( 1 / 9 ) ) $=
    ( c7 c9 cdiv co cneg c2 clt wbr c1 cexp cmin wcel cc0 wceq 9re mp3an eqtr3i
    2cn c3 c8 ccos cfv cmul wne 7re recni 9pos gt0ne0ii divneg pm3.2i divsubdir
    cc negsubdi2i caddc 7p2e9 subadd2i mpbir negeqi oveq1i dividi oveq2i ax-1cn
    wa 3eqtr2ri divassi mulid1i 3cn sqdivi sq1 sq3 oveq12i eqtri cos1bnd simpli
    3ne0 cle wb 0le1 3pos 1re 3re divge0i mp2an 0re cr recoscl rereccli lelttri
    ax-mp ltleii lt2sqi mpbi eqbrtrri 2pos resqcli 2re redivcli remulcli ltsub1
    ltmul2i fveq2i cos2t breqtrri simpri 2nn0 nn0ge0i sq2 breqtri 4re 4cn 4t2e8
    c4 mulcomli 8re 8p1e9 subaddrii eqbrtri ) ABCDEZFUAUBZGHXSIBCDZEZGHXRFIUAUB
    ZFJDZUCDZIKDZXSGFBCDZIKDZXRYEGXRAEZBCDZYFBBCDZKDZYGAULLBULLZBMUDZXRYINAUEUF
    ZBOUFZBOUGUHZABUIPFBKDZBCDZYKYIFULLYLYLYMVCZYRYKNRYOYLYMYOYPUJZFBBUKPYQYHBC
    BFKDZEYQYHBFYORUMUUAAUUAANAFUNDBNUOBFAYORYNUPUQURQUSQYJIYFKBYOYPUTZVAVDYFYD
    GHZYGYEGHZFXTUCDZYFYDGFIUCDZBCDUUEYFFIBRVBYOYPVEUUFFBCFRVFZUSQXTYCGHZUUEYDG
    HZISCDZFJDZXTYCGUUKIFJDZSFJDZCDXTISVBVGVOVHUULIUUMBCVIVJVKVLUUJYBGHZUUKYCGH
    ZUUNYBFSCDZGHZVMVNZMUUJVPHZMYBVPHZUUNUUOVQMIVPHMSGHZUUSVRVSISVTWAWBWCZMYBWD
    IWELZYBWELVTIWFWIZUUSUUNMYBGHUVBUURMUUJYBWDSWAVOWGZUVDWHWCWJZUUJYBUVEUVDWKW
    CWLWMMFGHZUUHUUIVQWNXTYCFBOYPWGYBUVDWOZWPWTWIWLWMYFWELYDWELZUVCUUCUUDVQFBWP
    OYPWQFYCWPUVHWRZVTYFYDIWSPWLWMUUFUAUBZXSYEUUFFUAUUGXAIULLZUVKYENVBIXBWIQZXC
    XSYEYAGUVMYETBCDZIKDZYAGYDUVNGHZYEUVOGHZYDFXLBCDZUCDZUVNGYCUVRGHZYDUVSGHZYC
    UUPFJDZUVRGUUQYCUWBGHZUUNUUQVMXDUUTMUUPVPHZUUQUWCVQUVFMFVPHUVAUWDFXEXFVSFSW
    PWAWBWCYBUUPUVDFSWPWAVOWQWKWCWLUWBFFJDZUUMCDUVRFSRVGVOVHUWEXLUUMBCXGVJVKVLX
    HUVGUVTUWAVQWNYCUVRFUVHXLBXIOYPWQWPWTWIWLFXLUCDZBCDUVSUVNFXLBRXJYOYPVEUWFTB
    CXLFTXJRXKXMUSQXHUVIUVNWELUVCUVPUVQVQUVJTBXNOYPWQVTYDUVNIWSPWLUVNYJKDZUVOYA
    YJIUVNKUUBVAYAIEZBCDZTBKDZBCDZUWGUVLYLYMYAUWINVBYOYPIBUIPUWJUWHBCBTKDZEUWJU
    WHBTYOTXNUFZUMUWLIBTIYOUWMVBXOXPURQUSTULLYLYSUWKUWGNUWMYOYTTBBUKPVDQXHXQUJ
    $.

  $( The sine of a positive real number is less than its argument.
     (Contributed by Mario Carneiro, 29-Jul-2014.) $)
  sinltx $p |- ( A e. RR+ -> ( sin ` A ) < A ) $=
    ( crp wcel csin cfv clt wbr c1 wa cr adantr resincld 1re a1i cle simprd cc0
    rpre co c3 cneg sinbnd syl simpr lelttrd w3a df-3an cxr wb 0xr elioc2 mp2an
    cioc elrp anbi1i 3bitr4i cexp cdiv cmin sin01bnd sylbir ltlecasei ) ABCZADE
    ZAFGZHAVCHAFGZIZVDHAVGAVCAJCZVFARZKZLHJCZVGMNVJVCVDHOGZVFVCVHVLVIVHHUAVDOGV
    LAUBPUCKVCVFUDUEVCAHOGZIZAQHUMSCZVEVHQAFGZVMUFZVHVPIZVMIVOVNVHVPVMUGQUHCVKV
    OVQUIUJMQHAUKULVCVRVMAUNUOUPVOAATUQSTURSUSSVDFGVEAUTPVAVKVCMNVIVB $.

  $( The sine of a positive real number less than or equal to 1 is positive.
     (Contributed by Paul Chapman, 19-Jan-2008.) $)
  sin01gt0 $p |- ( A e. ( 0 (,] 1 ) -> 0 < ( sin ` A ) ) $=
    ( cc0 c1 co wcel c3 cexp cdiv clt wbr cfv cr cn0 cle w3a 1re 3re wi wa 1lt3
    cioc cmin csin cxr wb 0xr elioc2 mp2an simp1bi 3nn0 reexpcl sylancl redivcl
    wne 3ne0 mp3an23 syl cz 3nn nnzi expgt0 mp3an2 3adant3 sylbi 0lt1 ltdiv2OLD
    3pos mpbii expcom mp3an12 com12 sylc recnd div1d breqtrd 1nn0 a1i ltleii 1z
    cuz eluz1i mpbir2an simp2bi 0re ltle sylancr simp3bi leexp2rd exp1d ltletrd
    posdifd mpbid sin01bnd simpld resubcld resincld lttr mp3an1 syl2anc mp2and
    mpd ) ABCUADEZBAAFGDZFHDZUBDZIJZXEAUCKZIJZBXGIJZXBXDAIJXFXBXDXCAXBXCLEZXDLE
    ZXBALEZFMEXJXBXLBAIJZACNJZBUDECLEZXBXLXMXNOZUEUFPBCAUGUHZUIZUJAFUKULZXJFLEZ
    FBUNXKQUOXCFUMUPUQZXSXRXBXDXCCHDZXCIXBXJBXCIJZXDYBIJZXSXBXPYCXQXLXMYCXNXLFU
    REZXMYCFUSUTZAFVAVBVCVDXOXTXJYCYDRPQYCXOXTXJOZYDBCIJZBFIJZYCYGYDRVEVGYGYHYI
    YCOZYDYGYJSCFIJYDTCFXCVFVHVIVJVKVJVLXBXCXBXCXSVMVNVOXBXCACGDANXBACFXRCMEXBV
    PVQFCVTKEZXBYKYECFNJYFCFPQTVRCFVSWAWBVQXBXMBANJZXBXLXMXNXQWCXBBLEZXLXMYLRWD
    XRBAWEWFXAXBXLXMXNXQWGWHXBAXBAXRVMWIVOWJXBXDAYAXRWKWLXBXHXGAIJAWMWNXBXELEZX
    GLEZXFXHSXIRZXBAXDXRYAWOXBAXRWPYMYNYOYPWDBXEXGWQWRWSWT $.

  $( The cosine of a positive real number less than or equal to 1 is positive.
     (Contributed by Paul Chapman, 19-Jan-2008.) $)
  cos01gt0 $p |- ( A e. ( 0 (,] 1 ) -> 0 < ( cos ` A ) ) $=
    ( cc0 c1 co wcel c2 c3 cdiv cmul clt wbr cle cc cr wb 1re wa 3ne0 2re 3re
    cioc cexp cmin ccos cfv wceq cxr w3a 0xr elioc2 mp2an simp1bi resqcld recnd
    wne 2cn 3cn pm3.2i div12 mp3an13 syl cz 2z expgt0 mp3an2 3adant3 sylbi 2lt3
    3pos ltdiv1ii dividi breqtri redivcli mp3an12 mpbii syl2anc mulid1d breqtrd
    mpbi ltmul2 eqbrtrd wi 0re ltle mpan imdistani le2sq2 mpanr1 sylan syl6breq
    3impa sq1 redivcl mp3an23 remulcl sylancr ltletr mp3an3 mp2and posdif mpbid
    sylancl cos01bnd simpld resubcl recoscld lttr mp3an1 ) ABCUADEZBCFAFUBDZGHD
    ZIDZUCDZJKZXMAUDUEZJKZBXOJKZXIXLCJKZXNXIXLXJJKZXJCLKZXRXIXLXJFGHDZIDZXJJXIX
    JMEZXLYBUFZXIXJXIAXIANEZBAJKZACLKZBUGECNEZXIYEYFYGUHZOUIPBCAUJUKZULZUMZUNZF
    MEYCGMEZGBUOZQYDUPYNYOUQRURFXJGUSUTVAXIYBXJCIDZXJJXIXJNEZBXJJKZYBYPJKZYLXIY
    IYRYJYEYFYRYGYEFVBEYFYRVCAFVDVEVFVGYQYRQZYACJKZYSYAGGHDZCJFGJKYAUUBJKVHFGGS
    TTVIVJVSGUQRVKVLYANEYHYTUUAYSOFGSTRVMPYACXJVTVNVOVPXIXJYMVQVRWAXIXJCFUBDZCL
    XIYIXJUUCLKZYJYEYFYGUUDYEYFQYEBALKZQZYGUUDYEYFUUEBNEZYEYFUUEWBWCBAWDWEWFUUF
    YHYGUUDPACWGWHWIWKVGWLWJXIXLNEZYQXSXTQXRWBZXIFNEXKNEZUUHSXIYQUUJYLYQGNEYOUU
    JTRXJGWMWNVAFXKWOWPZYLUUHYQYHUUIPXLXJCWQWRVPWSXIUUHYHXRXNOUUKPXLCWTXBXAXIXP
    XOCXKUCDJKAXCXDXIXMNEZXONEZXNXPQXQWBZXIYHUUHUULPUUKCXLXEWPXIAYKXFUUGUULUUMU
    UNWCBXMXOXGXHVPWS $.

  $( The sine of a positive real number less than or equal to 2 is positive.
     (Contributed by Paul Chapman, 19-Jan-2008.) $)
  sin02gt0 $p |- ( A e. ( 0 (,] 2 ) -> 0 < ( sin ` A ) ) $=
    ( cc0 c2 cioc co wcel cmul csin cfv clt cr wbr cle wb 2re syl c1 wa 2pos cc
    cdiv ccos w3a cxr 0xr elioc2 mp2an rehalfcl 3ad2ant1 sylbi resincl remulcld
    recoscl divgt0 mpanr12 3adant3 pm3.2i lediv1 mp3an23 biimpa 2cn 2ne0 dividi
    syl6breq 3adant2 3jca 1re 3imtr4i sin01gt0 cos01gt0 axmulgt0 syl2anc mp2and
    wi mpan mpani sylc wceq recnd sin2t breqtrrd simp1bi divcan2 fveq2d breqtrd
    wne ) ABCDEFZBCACUAEZGEZHIZAHIJWGBCWHHIZWHUBIZGEZGEZWJJWGWMKFZBWMJLZBWNJLZW
    GWHKFZWOWGAKFZBAJLZACMLZUCZWRBUDFZCKFZWGXBNUEOBCAUFUGZWSWTWRXAAUHUIZUJZWRWK
    WLWHUKZWHUMZULPWGBWKJLZBWLJLZWPWGWHBQDEFZXJXBWRBWHJLZWHQMLZUCZWGXLXBWRXMXNX
    FWSWTXMXAWSWTRXDBCJLZXMOSACUNUOUPWSXAXNWTWSXARWHCCUAEZQMWSXAWHXQMLZWSXDXDXP
    RXAXRNOXDXPOSUQACCURUSUTCVAVBVCVDVEVFXEXCQKFXLXONUEVGBQWHUFUGVHZWHVIPWGXLXK
    XSWHVJPWGWRXJXKRWPVNZXGWRWKKFWLKFXTXHXIWKWLVKVLPVMWOXPWPWQSXDWOXPWPRWQVNOCW
    MVKVOVPVQWGWHTFWJWNVRWGWHXGVSWHVTPWAWGWIAHWGATFZWIAVRZWGAWGWSWTXAXEWBVSYACT
    FCBWFYBVAVBACWCUSPWDWE $.

  $( The signs of the sine and cosine of 1.  (Contributed by Paul Chapman,
     19-Jan-2008.) $)
  sincos1sgn $p |- ( 0 < ( sin ` 1 ) /\ 0 < ( cos ` 1 ) ) $=
    ( c1 cc0 cioc co wcel csin cfv clt wbr ccos wa cr cle 1re 0lt1 1le1 cxr w3a
    wb 0xr elioc2 mp2an mpbir3an sin01gt0 cos01gt0 jca ax-mp ) ABACDEZBAFGHIZBA
    JGHIZKUHALEZBAHIZAAMIZNOPBQEUKUHUKULUMRSTNBAAUAUBUCUHUIUJAUDAUEUFUG $.

  $( The signs of the sine and cosine of 2.  (Contributed by Paul Chapman,
     19-Jan-2008.) $)
  sincos2sgn $p |- ( 0 < ( sin ` 2 ) /\ ( cos ` 2 ) < 0 ) $=
    ( cc0 c2 csin cfv clt wbr ccos cioc co wcel cr 2re wb mp2an ax-mp cdiv cneg
    c9 9re 9pos cle 2pos cxr w3a 0xr elioc2 mpbir3an sin02gt0 c1 cos2bnd simpri
    leidi c7 recgt0ii gt0ne0ii rereccli lt0neg2 mpbi recoscl renegcli 0re lttri
    pm3.2i ) ABCDEFZBGDZAEFZBABHIJZVDVGBKJZABEFZBBUAFZLUBBLULAUCJVHVGVHVIVJUDMU
    ELABBUFNUGBUHOVEUIRPIZQZEFZVLAEFZVFUMRPIQVEEFVMUJUKAVKEFZVNRSTUNVKKJVOVNMRS
    RSTUOUPZVKUQOURVEVLAVHVEKJLBUSOVKVPUTVAVBNVC $.

  $( The sine of 4 is negative.  (Contributed by Paul Chapman, 19-Jan-2008.) $)
  sin4lt0 $p |- ( sin ` 4 ) < 0 $=
    ( c4 csin cfv c2 cmul co cc0 clt wcel 2cn ax-mp wbr sincos2sgn cr wa wb 2re
    0re pm3.2i ltmul2 ccos 2t2e4 fveq2i wceq sin2t eqtr3i simpri recoscl simpli
    cc resincl mp3an mpbi recni mul01i breqtri remulcli 2pos eqbrtri ) ABCZDDBC
    ZDUACZEFZEFZGHDDEFZBCZUTVDVEABUBUCDUJIVFVDUDJDUEKUFVDDGEFZGHVCGHLZVDVGHLZVC
    VAGEFZGHVBGHLZVCVJHLZGVAHLZVKMUGVBNIZGNIZVANIZVMOVKVLPDNIZVNQDUHKZRVPVMVQVP
    QDUKKZVMVKMUISVBGVATULUMVAVAVSUNUOUPVCNIVOVQGDHLZOVHVIPVAVBVSVRUQRVQVTQURSV
    CGDTULUMDJUOUPUS $.

  $( The absolute value of the exponential function of an imaginary number is
     one.  Equation 48 of [Rudin] p. 167.  (Contributed by Jason Orendorff,
     9-Feb-2007.) $)
  absefi $p |- ( A e. RR -> ( abs ` ( exp ` ( _i x. A ) ) ) = 1 ) $=
    ( cr wcel ci cmul co ce cfv cabs caddc c1 wceq syl fveq2d cexp csqr resqcld
    c2 recnd eqtrd ccos csin cc efival recoscl resincl absreim syl2anc sincossq
    recn addcomd sqr1 syl6eq ) ABCZDAEFGHZIHAUAHZDAUBHZEFJFZIHZKUNUOURIUNAUCCZU
    OURLAUJZAUDMNUNUSUPROFZUQROFZJFZPHZKUNUPBCUQBCUSVELAUEZAUFZUPUQUGUHUNVEKPHK
    UNVDKPUNVDVCVBJFZKUNVBVCUNVBUNUPVFQSUNVCUNUQVGQSUKUNUTVHKLVAAUIMTNULUMTT $.

  $( The absolute value of the exponential function is the exponential function
     of the real part.  (Contributed by Paul Chapman, 13-Sep-2007.) $)
  absef $p |- ( A e. CC -> ( abs ` ( exp ` A ) ) = ( exp ` ( Re ` A ) ) ) $=
    ( cc wcel ce cfv cabs cre c1 cmul co ci fveq2d wceq recnd sylancr cr 3eqtrd
    syl cc0 wbr caddc replim recl ax-icn imcl mulcl efadd syl2anc eqtrd reefcld
    cim efcl absmuld absefi oveq2d abscld mulid1d clt cle efgt0 wi 0re ltle mpd
    absidd ) ABCZADEZFEZAGEZDEZFEZHIJZVKVJVFVHVJKAUKEZIJZDEZIJZFEVKVOFEZIJVLVFV
    GVPFVFVGVIVNUAJZDEZVPVFAVRDAUBLVFVIBCVNBCZVSVPMVFVIAUCZNVFKBCVMBCVTUDVFVMAU
    EZNKVMUFOZVIVNUGUHUILVFVJVOVFVJVFVIWAUJZNZVFVTVOBCWCVNULRUMVFVQHVKIVFVMPCVQ
    HMWBVMUNRUOQVFVKVFVKVFVJWEUPNUQVFVJWDVFSVJURTZSVJUSTZVFVIPCWFWAVIUTRVFSPCVJ
    PCWFWGVAVBWDSVJVCOVDVEQ $.

  $( A number is real iff its imaginary exponential has absolute value one.
     (Contributed by NM, 21-Aug-2008.) $)
  absefib $p |- ( A e. CC
          -> ( A e. RR <-> ( abs ` ( exp ` ( _i x. A ) ) ) = 1 ) ) $=
    ( cc wcel cfv cneg ce c1 wceq cc0 ci co cr recnd cre ax-icn mulcl syl caddc
    cmul eqtrd cim cabs ef0 eqeq2i wb imcl renegcld 0re sylancl syl5bbr negeq0d
    reef11 bitr4d mpan absef replim sylancr addcomd oveq2d adddi mp3an1 syl2anc
    recl oveq1i mulass mp3an12 mulm1d 3eqtr3a oveq1d fveq2d crred eqeq1d reim0b
    ixi 3bitr4rd ) ABCZAUADZEZFDZGHZVQIHZJASKZFDUBDZGHALCVPVTVRIHZWAVTVSIFDZHZV
    PWDWEGVSUCUDVPVRLCILCWFWDUEVPVQAUFZUGZUHVRIULUIUJVPVQVPVQWGMZUKUMVPWCVSGVPW
    CWBNDZFDZVSVPWBBCZWCWKHJBCZVPWLOJAPUNWBUOQVPWJVRFVPWJVRJANDZSKZRKZNDVRVPWBW
    PNVPWBJJVQSKZWNRKZSKZWPVPAWRJSVPAWNWQRKWRAUPVPWNWQVPWNAVCZMZVPWMVQBCZWQBCZO
    WIJVQPUQZURTUSVPWSJWQSKZWORKZWPVPXCWNBCZWSXFHZXDXAWMXCXGXHOJWQWNUTVAVBVPXEV
    RWORVPJJSKZVQSKZGEZVQSKXEVRXIXKVQSVNVDVPXBXJXEHZWIWMWMXBXLOOJJVQVEVFQVPVQWI
    VGVHVITTVJVPVRWNWHWTVKTVJTVLAVMVO $.

  $( TODO - make obsolete $)
  $( A number whose imaginary exponential is one is real.  (Contributed by NM,
     21-Aug-2008.) $)
  efieq1re $p |- ( ( A e. CC /\ ( exp ` ( _i x. A ) ) = 1 ) -> A e. RR ) $=
    ( cc wcel ci cmul co ce cfv c1 wceq cneg cabs caddc oveq2d recnd ax-icn syl
    cr eqtrd cc0 cim replim recl imcl mulcl sylancr adddi mp3an1 syl2anc oveq1i
    cre mulass mp3an12 mulm1d 3eqtr3a fveq2d renegcld efadd eqeq1d efcl absmuld
    ixi absefi reefcld clt wbr cle wi 0re ltle mpan sylc absidd oveq12d mulid2d
    efgt0 3eqtrrd fveq2 sylan9eq ex sylbid negeq0d reim0b abs1 eqtr4i eqeq2i wb
    ef0 reef11 sylancl syl5bbr 3bitr4rd sylibd imp ) ABCZDAEFZGHZIJZARCZWOWRAUA
    HZKZGHZILHZJZWSWOWRDAUKHZEFZGHZXBEFZIJZXDWOWQXHIWOWQXFXAMFZGHZXHWOWPXJGWOWP
    DXEDWTEFZMFZEFZXJWOAXMDEAUBNWOXNXFDXLEFZMFZXJWOXEBCZXLBCZXNXPJZWOXEAUCZOZWO
    DBCZWTBCZXRPWOWTAUDZOZDWTUEUFYBXQXRXSPDXEXLUGUHUIWOXOXAXFMWODDEFZWTEFZIKZWT
    EFXOXAYFYHWTEVBUJWOYCYGXOJZYEYBYBYCYIPPDDWTULUMQWOWTYEUNUONSSUPWOXFBCZXABCZ
    XKXHJWOYBXQYJPYADXEUEUFZWOXAWOWTYDUQZOZXFXAURUISUSWOXIXDWOXIXBXHLHZXCWOYOXG
    LHZXBLHZEFIXBEFXBWOXGXBWOYJXGBCYLXFUTQWOYKXBBCYNXAUTQZVAWOYPIYQXBEWOXERCYPI
    JXTXEVCQWOXBWOXAYMVDZWOXBRCZTXBVEVFZTXBVGVFZYSWOXARCZUUAYMXAVPQTRCZYTUUAUUB
    VHVITXBVJVKVLVMVNWOXBYRVOVQXHILVRVSVTWAWOWTTJXATJZWSXDWOWTYEWBAWCXDXBTGHZJZ
    WOUUEUUFXCXBUUFIXCWHWDWEWFWOUUCUUDUUGUUEWGYMVIXATWIWJWKWLWMWN $.

  ${
    $d x k $.  $d x N $.  $d A x $.  $d A k $.
    $( De Moivre's Formula.  Shorter proof of ~ demoivreALT using the
       exponential function.  (Contributed by NM, 24-Jul-2007.) $)
    demoivre $p |- ( ( A e. CC /\ N e. ZZ ) ->
                  ( ( ( cos ` A ) + ( _i x. ( sin ` A ) ) ) ^ N ) =
                 ( ( cos ` ( N x. A ) ) + ( _i x. ( sin ` ( N x. A ) ) ) ) ) $=
      ( cc wcel cz wa ci cmul co ce cexp ccos csin caddc wceq ax-icn mulcl mpan
      cfv efival efexp sylan zcn mul12 mp3an2 fveq2d eqtrd ancoms sylan2 oveq1d
      syl adantr 3eqtr3rd ) ACDZBEDZFBGAHIZHIZJSZUPJSZBKIZBAHIZLSGVAMSHINIZALSG
      AMSHINIZBKIZUNUPCDZUOURUTOGCDZUNVEPGAQRUPBUAUBUOUNBCDZURVBOZBUCVGUNVHVGUN
      FZURGVAHIZJSZVBVIUQVJJVGVFUNUQVJOPBGAUDUEUFVIVACDVKVBOBAQVATUKUGUHUIUNUTV
      DOUOUNUSVCBKATUJULUM $.

    $( De Moivre's Formula.  Proof by induction given at
       ~ http://en.wikipedia.org/wiki/De&#x5F;Moivre&#x27;s&#x5F;formula , but
       restricted to nonnegative integer powers.  (Contributed by Steve
       Rodriguez, 10-Nov-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    demoivreALT $p |- ( ( A e. CC /\ N e. NN0 ) ->
                  ( ( ( cos ` A ) + ( _i x. ( sin ` A ) ) ) ^ N ) =
                 ( ( cos ` ( N x. A ) ) + ( _i x. ( sin ` ( N x. A ) ) ) ) ) $=
      ( wcel cc ccos cfv ci csin cmul caddc cexp wceq cc0 fveq2d oveq2d oveq12d
      co c1 ax-icn syl2anc vx vk cn0 cv wi oveq2 oveq1 imbi2d coscl sincl mulcl
      eqeq12d sylancr addcl exp0 mul02 cos0 syl6eq mul01i ax-1cn addid1i eqtr4d
      syl sin0 wa expp1 sylan ancoms adantr adantl nn0cn sinadd sylancom mulcom
      oveq1d addcom 3eqtr2d w3a adddir mulid2 3ad2ant3 syl3an1 mp3an2 cmin cneg
      eqtrd mpan 3syl jca muladd syl21anc jctil mul4 oveq1i mul12 mp3an1 3eqtrd
      ixi adddi mulm1 negsub cosadd 3eqtr4rd exp31 a2d nn0ind impcom ) BUCCADCZ
      AEFZGAHFZIQZJQZBKQZBAIQZEFZGXNHFZIQZJQZLZXHXLUAUDZKQZXTAIQZEFZGYBHFZIQZJQ
      ZLZUEXHXLMKQZMAIQZEFZGYIHFZIQZJQZLZUEXHXLUBUDZKQZYOAIQZEFZGYQHFZIQZJQZLZU
      EXHXLYORJQZKQZUUCAIQZEFZGUUEHFZIQZJQZLZUEXHXSUEUAUBBXTMLZYGYNXHUUKYAYHYFY
      MXTMXLKUFUUKYCYJYEYLJUUKYBYIEXTMAIUGZNUUKYDYKGIUUKYBYIHUULNOPULUHXTYOLZYG
      UUBXHUUMYAYPYFUUAXTYOXLKUFUUMYCYRYEYTJUUMYBYQEXTYOAIUGZNUUMYDYSGIUUMYBYQH
      UUNNOPULUHXTUUCLZYGUUJXHUUOYAUUDYFUUIXTUUCXLKUFUUOYCUUFYEUUHJUUOYBUUEEXTU
      UCAIUGZNUUOYDUUGGIUUOYBUUEHUUPNOPULUHXTBLZYGXSXHUUQYAXMYFXRXTBXLKUFUUQYCX
      OYEXQJUUQYBXNEXTBAIUGZNUUQYDXPGIUUQYBXNHUURNOPULUHXHYHRYMXHXLDCZYHRLXHXID
      CZXKDCZUUSAUIZXHGDCZXJDCZUVASAUJZGXJUKUMZXIXKUNTZXLUOVCXHYMRMJQRXHYJRYLMJ
      XHYJMEFRXHYIMEAUPZNUQURXHYLGMIQMXHYKMGIXHYKMHFMXHYIMHUVHNVDUROGSUSURPRUTV
      AURVBYOUCCZXHUUBUUJUVIXHUUBUUJUVIXHVEZUUBVEUUDYPXLIQZUUAXLIQZUUIUVJUUDUVK
      LZUUBXHUVIUVMXHUUSUVIUVMUVGXLYOVFVGVHVIUUBUVKUVLLUVJYPUUAXLIUGVJUVJUVLUUI
      LUUBUVJYQAJQZEFZGUVNHFZIQZJQUVOGYRXJIQZXIYSIQZJQZIQZJQZUUIUVLUVJUVQUWAUVO
      JUVJUVPUVTGIUVJUVPYSXIIQZUVRJQZUVSUVRJQZUVTUVIXHYQDCZUVPUWDLUVIYODCZXHUWF
      YOVKZYOAUKVGZYQAVLVMUVJUVSUWCUVRJUVJUUTYSDCZUVSUWCLXHUUTUVIUVBVJZUVJUWFUW
      JUWIYQUJZVCZXIYSVNTVOUVJUVSDCZUVRDCZUWEUVTLUVJUUTUWJUWNUWKUWMXIYSUKTZUVJY
      RDCZUVDUWOUVJUWFUWQUWIYQUIVCZXHUVDUVIUVEVJZYRXJUKTZUVSUVRVPTVQOOUVJUUFUVO
      UUHUVQJUVJUUEUVNEUVIRDCZXHUUEUVNLZUTUVIUWGUXAXHUXBUWHUWGUXAXHVRUUEYQRAIQZ
      JQZUVNYORAVSXHUWGUXDUVNLUXAXHUXCAYQJAVTOWAWFWBWCZNUVJUUGUVPGIUVJUUEUVNHUX
      ENOPUVJUVLYRXIIQZXJYSIQZWDQZUWAJQZUWBUVJUVLUXFRWEZUXGIQZJQZUWAJQZUXFUXGWE
      ZJQZUWAJQUXIUVJUVLUXFXKYTIQZJQZYRXKIQZXIYTIQZJQZJQZUXLUXTJQUXMUVJUWQYTDCZ
      UUTUVAVEZUVLUYALUWRUVJUWFUWJUYBUWIUWLUVCUWJUYBSGYSUKWGWHXHUYCUVIXHUUTUVAU
      VBUVFWIVJYRYTXIXKWJWKUVJUXQUXLUXTJUVJUXPUXKUXFJUVJUVCUVDVEZUVCUWJVEZUXPUX
      KLUVJUVDUVCUWSSWLUVJUWJUVCUWMSWLUYDUYEVEUXPGGIQZUXGIQUXKGXJGYSWMUYFUXJUXG
      IWRWNURTOVOUVJUXTUWAUXLJUVJUXTGUVRIQZGUVSIQZJQZUWAUVJUXRUYGUXSUYHJUVJUWQU
      VDUXRUYGLZUWRUWSUWQUVCUVDUYJSYRGXJWOWCTUVJUUTUWJUXSUYHLZUWKUWMUUTUVCUWJUY
      KSXIGYSWOWCTPUVJUWOUWNUWAUYILZUWTUWPUVCUWOUWNUYLSGUVRUVSWSWPTVBOWQUVJUXLU
      XOUWAJUVJUXKUXNUXFJUVJUXGDCZUXKUXNLUVJUVDUWJUYMUWSUWMXJYSUKTZUXGWTVCOVOUV
      JUXOUXHUWAJUVJUXFDCZUYMUXOUXHLUVJUWQUUTUYOUWRUWKYRXIUKTUYNUXFUXGXATVOWQUV
      JUVOUXHUWAJUVJUVOUXFYSXJIQZWDQZUXHUVIXHUWFUVOUYQLUWIYQAXBVMUVJUYPUXGUXFWD
      UVJUWJUVDUYPUXGLUWMUWSYSXJVNTOWFVOVBXCVIWQXDXEXFXG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          _e is irrational
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k x y F $.  $d k x y ph $.  $d k n x y Q $.
    eirr.1 $e |- F = ( n e. NN0 |-> ( 1 / ( ! ` n ) ) ) $.
    eirr.2 $e |- ( ph -> P e. ZZ ) $.
    eirr.3 $e |- ( ph -> Q e. NN ) $.
    eirr.4 $e |- ( ph -> _e = ( P / Q ) ) $.
    $( Lemma for ~ eirr .  (Contributed by Paul Chapman, 9-Feb-2008.)  (Revised
       by Mario Carneiro, 29-Apr-2014.) $)
    eirrlem $p |- -. ph $=
      ( vk c1 co cmul wcel ceu cc0 cn0 cdiv wbr clt cfa cfv caddc cuz cv csu cz
      cfz cmin esum wceq fveq2 oveq2d ovex fvmpt sumeq2i eqtr4i nn0uz peano2nnd
      eqid nnnn0d wa eqidd cexp cc cmpt nn0z 1exp oveq1d mpteq2ia eftval adantl
      syl ax-1cn a1i eftcl sylan eqeltrd cli cdm efcllem isumsplit syl5eq nncnd
      cseq pncan sylancl sumeq1d eqtrd fzfid elfznn0 sylan2 fsumcl crp cn faccl
      nnrpd rpreccld isumrpcl rpred recnd pncan2d ere subdid eqtr3d zcnd nnne0d
      recni div12d cle nnred leidd facdiv syl3anc nnzd zmulcld fsummulc2 adantr
      wne facne0 divrecd eqtr4d permnn fsumzcl zsubcld rpmulcld rpgt0d nnmulcld
      wn 0z cabs abs1 oveq1i cr wb mpbid c2 nngt0d syl112anc mpbird 1le1 eftlub
      nndivred nnrecred mpteq2i eqbrtri rprege0d absid mulid2d 3brtr3d readdcld
      remulcld 1re 1nn nnleltp1 sylancr ltadd2dd 2timesd df-2 leadd1dd syl5eqbr
      nnge1d 2re lemul1 eqbrtrrd ltletrd facp1 divcan3d 3eqtr3rd mul32d breqtrd
      ltdivmul lelttrd ltmuldiv2d 0p1e1 syl6breqr btwnnz pm2.65i ) ACUAUBZCKUCL
      ZUDUBZJUEZEUBZJUFZMLZUGNZAUWEUVSOMLZUVSPCUHLZUWCJUFZMLZUILZUGAUVSOUWIUILZ
      MLUWEUWKAUWLUWDUVSMAUWLUWIUWDUCLZUWIUILUWDAOUWMUWIUIAOPUVTKUILZUHLZUWCJUF
      ZUWDUCLZUWMAOQUWCJUFZUWQOQKUWBUAUBZRLZJUFUWRJUJQUWCUWTJDUWBKDUEZUAUBZRLZU
      WTQEUXAUWBUKUXBUWSKRUXAUWBUAULUMFKUWSRUNUOZUPUQAUWCJEPUVTUWAQURUWAUTZAUVT
      ACHUSZVAZAUWBQNZVBZUWCVCZUXIUWCKUWBVDLUWSRLZVEUXHUWCUXKUKAKDEUWBEDQUXCVFD
      QKUXAVDLZUXBRLZVFZFDQUXMUXCUXAQNZUXLKUXBRUXOUXAUGNUXLKUKUXAVGUXAVHVMVIVJU
      QZVKVLAKVENZUXHUXKVENUXQAVNVOZKUWBVPVQVRZAUXQUCEPWEVSVTNUXRKDEUXPWAVMZWBW
      CAUWPUWIUWDUCAUWOUWHUWCJAUWNCPUHACVENUXQUWNCUKACHWDZVNCKWFWGUMWHVIWIVIAUW
      IUWDAUWHUWCJAPCWJZUWBUWHNZAUXHUWCVENUWBCWKZUXSWLZWMZAUWDAUWDAUWCJEPUVTUWA
      QURUXEUXGUXJUXIUWCUWTWNUXHUWCUWTUKZAUXDVLUXIUWSUXIUWSUXHUWSWONZAUWBWPVLZW
      QWRVRUXTWSZWTZXAXBWIUMAUVSOUWIAUVSACQNZUVSWONACHVAZCWPVMZWDZOVENAOXCXHVOU
      YFXDXEAUWGUWJAUWGBUVSCRLZMLZUGAUWGUVSBCRLZMLUYQAOUYRUVSMIUMAUVSBCUYOABGXF
      UYAACHXGXIWIABUYPGAUYPAUYLCWONZCCXJSUYPWONUYMHACACHXKZXLCCXMXNXOXPVRAUWJU
      WHUVSUWCMLZJUFUGAUWHUWCUVSJUYBUYOUYEXQAUWHVUAJUYBAUYCVBZVUAVUBVUAUVSUWSRL
      ZWOVUBVUAUVSUWTMLVUCVUBUWCUWTUVSMVUBUXHUYGUYCUXHAUYDVLZUXDVMUMVUBUVSUWSAU
      VSVENUYCUYOXRVUBUWSUYCAUXHUYHUYDUYIWLWDVUBUXHUWSPXSVUDUWBXTVMYAYBUYCVUCWO
      NAUWBCYCVLVRXOYDVRYEVRAPUGNZPUWETSUWEPKUCLZTSUWFYIVUEAYJVOAUWEAUVSUWDAUVS
      UYNWQZUYJYFYGAUWEKVUFTAUWEKTSUWDKUVSRLZTSAUWDUVTKUCLZUVTUAUBZUVTMLZRLZVUH
      UYKAVUIVUKAVUIAUVTUXFUSXKZAVUJUVTAUVTQNVUJWONUXGUVTWPVMZUXFYHZUUCZAUVSUYN
      UUDZAUWDYKUBZKYKUBZUVTVDLZVULMLZUWDVULXJAKJDEEDQVUTVUJRLKVUIRLUXAVDLMLVFZ
      UVTUXPEUXNDQVUSUXAVDLZUXBRLZVFUXPDQVVDUXMVVCUXLUXBRVUSKUXAVDYLYMYMUUEUQVV
      BUTUXFUXRVUSKXJSAVUSKKXJYLUUAUUFVOUUBAUWDYNNPUWDXJSVBVURUWDUKAUWDUYJUUGUW
      DUUHVMAVVAKVULMLVULAVUTKVULMAVUTKUVTVDLZKVUSKUVTVDYLYMAUVTUGNVVEKUKAUVTUX
      FXOUVTVHVMWCVIAVULAVULVUPXAUUIWIUUJAVULVUHTSZVUIVUKVUHMLZTSZAVUIUVTUVTMLZ
      VVGTAVUIUVTUVTUCLZVVIVUMAUVTUVTAUVTUXFXKZVVKUUKAUVTUVTVVKVVKUULAKUVTUVTKY
      NNAUUMVOZVVKVVKAKCXJSZKUVTTSZACHUVBZAKWONUYSVVMVVNYOUUNHKCUUOUUPYPUUQAYQU
      VTMLZVVJVVIXJAUVTAUVTUXFWDZUURAYQUVTXJSZVVPVVIXJSZAYQKKUCLUVTXJUUSAKCKVVL
      UYTVVLVVOUUTUVAAYQYNNZUVTYNNZVWAPUVTTSVVRVVSYOVVTAUVCVOVVKVVKAUVTUXFYRYQU
      VTUVTUVDYSYPUVEUVFAVVIVUJVUHMLZUVTMLVVGAUVTVWBUVTMAVUJUVSRLUVSUVTMLZUVSRL
      VWBUVTAVUJVWCUVSRAUYLVUJVWCUKUYMCUVGVMVIAVUJUVSAVUJVUNWDZUYOAUVSUYNXGZYAA
      UVTUVSVVQUYOVWEUVHUVIVIAVUJVUHUVTVWDAVUHVUQXAVVQUVJWIUVKAVUIYNNVUHYNNVUKY
      NNPVUKTSVVFVVHYOVUMVUQAVUKVUOXKAVUKVUOYRVUIVUHVUKUVLYSYTUVMAUWDKUVSUYKVVL
      VUGUVNYTUVOUVPPUWEUVQXNUVR $.
  $}

  ${
    $d n p q $.
    $( ` _e ` is irrational.  (Contributed by Paul Chapman, 9-Feb-2008.)
       (Proof shortened by Mario Carneiro, 29-Apr-2014.) $)
    eirr $p |- _e e/ QQ $=
      ( vp vq vn ceu cq wcel cv cdiv co wceq cn wrex cz wa cn0 c1 cfa cmpt eqid
      cfv simpll simplr simpr eirrlem imnani nrexdv nrex elq mtbir nelir ) DEDE
      FDAGZBGZHIJZBKLZAMLUNAMUKMFZUMBKUOULKFZNZUMUQUMNUKULCCOPCGQTHIRZURSUOUPUM
      UAUOUPUMUBUQUMUCUDUEUFUGABDUHUIUJ $.
  $}

  $( Euler's constant ` _e ` = 2.71828... is bounded by 2 and 3.  (Contributed
     by NM, 28-Nov-2008.)  (Revised by Mario Carneiro, 29-Apr-2014.) $)
  egt2lt3 $p |- ( 2 < _e /\ _e < 3 ) $=
    ( vn c2 ceu clt wbr c3 cle cn c1 cdiv co cmpt eqid wcel wceq eleq1 necon3bi
    wne cq ax-mp cv cexp cmul cn0 cfa cfv ege2le3 simpli wn eirr nnq mto mpbiri
    neli 2nn 2re ere ltleni mpbir2an simpri 3nn mpbii 3re pm3.2i ) BCDEZCFDEZVE
    BCGEZCBRZVGCFGEZAAHBIBJKAUAZUBKUCKLZAUDIVJUEUFJKLZVKMVLMUGZUHCHNZUIZVHVNCSN
    CSUJUNCUKULZVNCBCBOVNBHNUOCBHPUMQTBCUPUQURUSVFVIFCRZVGVIVMUTVOVQVPVNFCFCOFH
    NVNVAFCHPVBQTCFUQVCURUSVD $.

  $( Euler's constant ` _e ` is greater than 0.  (Contributed by Jeff Hankins,
     22-Nov-2008.) $)
  epos $p |- 0 < _e $=
    ( cc0 c2 clt wbr ceu 2pos c3 egt2lt3 simpli 0re 2re ere lttri mp2an ) ABCDB
    ECDZAECDFOEGCDHIABEJKLMN $.

  $( Euler's constant ` _e ` is a positive real.  (Contributed by Jeff Hankins,
     22-Nov-2008.) $)
  epr $p |- _e e. RR+ $=
    ( ceu ere epos elrpii ) ABCD $.


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
              Cardinality of real and complex number subsets
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Countability of integers and rationals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w v u $.
    $( The cross product of the set of natural numbers with itself is
       equinumerous to the set of natural numbers.  (Contributed by NM,
       1-Aug-2004.)  (Revised by Mario Carneiro, 9-Mar-2013.) $)
    xpnnen $p |- ( NN X. NN ) ~~ NN $=
      ( cn cxp com cen wbr nnenom xpen mp2an xpomen entr4i entri ) AABZCCBZAACD
      EZNLMDEFFACACGHMCAIFJK $.
  $}

  ${
    $d x y z w v u $.
    $( The cross product of the set of natural numbers with itself is
       equinumerous to the set of natural numbers.  The key idea is to use
       ~ nn0opth2 to show that the mapping from natural numbers ` z ` and ` w `
       to ` ( ( z + w ) ^ 2 ) + w ` is one-to-one.  (Contributed by NM,
       1-Aug-2004.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    xpnnenOLD $p |- ( NN X. NN ) ~~ NN $=
      ( vz vw vv vu cn wbr cvv wcel nnex cv cint csn caddc co c2 cexp wa cn0 c1
      wceq vx cxp cdom cen crn cuni elxp5 nnaddcl 2nn0 nnexpcl sylancl sylancom
      vy cop adantl sylbi wrex wb elxp2 wi inteq inteqd vex op1stb syl6eq rneqd
      sneq unieqd op2nda oveq12d oveq1d eqeqan12d nnnn0 anim12i nn0opth2 syl2an
      sylan9bbr eqeq12 opth syl6bb bitr4d exp43 rexlimivv rexlimdvv imp syl2anb
      com23 dom2 ax-mp 1nn elexi xpsnen ensymi wss xpex ssid snssi xpss12 mp2an
      ssdomg mp2 endomtr sbth ) EEUBZEUCFZEXDUCFZXDEUDFEGHXEIUAUMXDEUAJZKZKZXGL
      ZUEZUFZMNZOPNZXLMNZUMJZKZKZXPLZUEZUFZMNZOPNZYAMNZGXGXDHZXGXIXLUNTZXIEHZXL
      EHZQZQXOEHZXGEEUGYIYJYFYGYHXNEHZYJYIXMEHORHYKXIXLUHUIXMOUJUKXNXLUHULUOUPY
      EXGAJZBJZUNZTZBEUQAEUQZXPCJZDJZUNZTZDEUQCEUQZXOYDTZXGXPTZURZXPXDHABXGEEUS
      CDXPEEUSYPUUAUUDYPYTUUDCDEEYOYQEHZYREHZQZYTUUDUTZUTABEEYLEHZYMEHZQZUUGYOU
      UHUUKUUGYOYTUUDUUKUUGQZYOYTQZQUUBYLYQTYMYRTQZUUCUUMUUBYLYMMNZOPNZYMMNZYQY
      RMNZOPNZYRMNZTZUULUUNYOYTXOUUQYDUUTYOXNUUPXLYMMYOXMUUOOPYOXIYLXLYMMYOXIYN
      KZKYLYOXHUVBXGYNVAVBYLYMAVCZBVCZVDVEYOXLYNLZUEZUFYMYOXKUVFYOXJUVEXGYNVGVF
      VHYLYMUVCUVDVIVEZVJVKUVGVJYTYCUUSYAYRMYTYBUUROPYTXRYQYAYRMYTXRYSKZKYQYTXQ
      UVHXPYSVAVBYQYRCVCZDVCZVDVEYTYAYSLZUEZUFYRYTXTUVLYTXSUVKXPYSVGVFVHYQYRUVI
      UVJVIVEZVJVKUVMVJVLUUKYLRHZYMRHZQYQRHZYRRHZQUVAUUNURUUGUUIUVNUUJUVOYLVMYM
      VMVNUUEUVPUUFUVQYQVMYRVMVNYLYMYQYRVOVPVQUUMUUCUUNURUULUUMUUCYNYSTUUNXGYNX
      PYSVRYLYMYQYRUVCUVDVSVTUOWAWBWGWCWDWEWFWHWIEESLZUBZUDFUVSXDUCFZXFUVSEESIS
      EWJWKWLWMXDGHUVSXDWNZUVTEEIIWOEEWNUVREWNZUWAEWPSEHUWBWJSEWQWIEEUVREWRWSUV
      SXDGWTXAEUVSXDXBWSXDEXCWS $.
  $}

  $( The cross product of omega (the set of ordinal natural numbers) with
     itself is equinumerous to omega.  Exercise 1 of [Enderton] p. 133 (which
     proves this with a direct, but longer, proof; ours uses instead the
     Schroeder-Bernstein Theorem ~ sbth in ~ xpnnen ).  (Contributed by NM,
     23-Jul-2004.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  xpomenOLD $p |- ( om X. om ) ~~ om $=
    ( com cxp cn cen wbr nnenom xpen mp2an xpnnen entr3i entri ) AABZCACCBZLCCA
    DEZNMLDEFFCACAGHIJFK $.

  $( Lemma for ~ znnen .  (Contributed by NM, 31-Jul-2004.) $)
  znnenlem $p |- ( ( ( 0 <_ x /\ -. 0 <_ y ) /\ ( x e. ZZ /\ y e. ZZ ) ) ->
                  ( x = y <-> ( 2 x. x ) = ( ( -u 2 x. y ) + 1 ) ) ) $=
    ( cc0 cv cle wbr wa cz wcel c2 cmul co cneg c1 caddc wne cr wi zre clt zneo
    wn wb 0re ltnle adantr anbi1d ltletr mp3an2 sylbird ancomsd 3impia syld3an3
    mpan2 ltneOLD 3com12 3expia syl2an impcom znegcl sylan2 cc 2cn zcn mulneg12
    wceq sylancr adantl oveq1d neeqtrrd 2thd necon4bid ) CADZEFZCBDZEFUBZGZVMHI
    ZVOHIZGZGZVMVOJVMKLZJMVOKLZNOLZWAVMVOPZWBWDPZVTVQWEVRVMQIZVOQIZVQWERVSVMSVO
    SWGWHVQWEWHWGVQWEWHWGVQVOVMTFZWEWHWGVQWIWHWGGZVPVNWIWJVPVNGVOCTFZVNGZWIWJWK
    VPVNWHWKVPUCZWGWHCQIZWMUDVOCUEUNUFUGWHWNWGWLWIRUDVOCVMUHUIUJUKULVOVMUOUMUPU
    QURUSVTWFVQVTWBJVOMZKLZNOLZWDVSVRWOHIWBWQPVOUTVMWOUAVAVTWCWPNOVSWCWPVFZVRVS
    JVBIVOVBIWRVCVOVDJVOVEVGVHVIVJVHVKVL $.

  ${
    $d x y z $.
    $( The set of integers and the set of natural numbers are equinumerous.
       Exercise 1 of [Gleason] p. 140.  (Contributed by NM, 31-Jul-2004.)
       (Proof shortened by Mario Carneiro, 13-Jun-2014.) $)
    znnen $p |- ZZ ~~ NN $=
      ( cz cn cdom wbr cen cxp ccrd cdm wcel cmin wfo com mp2an wss subf nnsscn
      cc ax-mp mp2 cvv cres con0 omelon nnenom ensymi isnumi xpnum cima wfun wf
      ffun xpss12 fdmi sseqtr4i fores wceq wb dfz2 foeq3 mpbir fodomnum domentr
      xpnnen zex nnssz ssdomg sbth ) ABCDZBACDZABEDABBFZCDZVJBEDVHVJGHZIZVJAJVJ
      UAZKZVKBVLIZVPVMLUBILBEDVPUCBLUDUELBUFMZVQBBUGMVOVJJVJUHZVNKZJUIZVJJHZNVS
      QQFZQJUJVTOWBQJUKRVJWBWABQNZWCVJWBNPPBQBQULMWBQJOUMUNVJJUOMAVRUPVOVSUQURA
      VRVJVNUSRUTVJAVNVASVCAVJBVBMATIBANVIVDVEBATVFSABVGM $.
  $}

  ${
    $d w x y z $.  $d q r $.  $d a x y $.  $d b x y $.
    $( The rational numbers are countable.  This proof does not use the Axiom
       of Choice, even though it uses an onto function, because the base set
       ` ( ZZ X. NN ) ` is numerable.  Exercise 2 of [Enderton] p. 133.
       (Contributed by NM, 31-Jul-2004.)  (Revised by Mario Carneiro,
       3-Mar-2013.) $)
    qnnen $p |- QQ ~~ NN $=
      ( vx vy vz cq cn cdom wbr cen cz cxp wcel cv cdiv com mp2an wceq wrex mp2
      znnen cvv ccrd cdm co cmpt2 wfo con0 omelon nnenom ensymi isnumi wb ennum
      ax-mp mpbir xpnum wfn crn eqid fnmpt2i cab rnmpt2 elq abbi2i eqtr4i df-fo
      ovex mpbir2an fodomnum nnex enref xpen xpnnen entri domentr wss qex nnssq
      ssdomg sbth ) DEFGZEDFGZDEHGDIEJZFGZWBEHGVTWBUAUBZKZWBDABIEALZBLZMUCZUDZU
      EZWCIWDKZEWDKZWEWKWLNUFKNEHGWLUGENUHUINEUJOZIEHGZWKWLUKSIEULUMUNWMIEUOOWJ
      WIWBUPWIUQZDPABIEWHWIWIURZWFWGMVFUSWOCLZWHPBEQAIQZCUTDABCIEWHWIWPVAWRCDAB
      WQVBVCVDWBDWIVEVGWBDWIVHRWBEEJZEWNEEHGWBWSHGSEVIVJIEEEVKOVLVMDWBEVNODTKED
      VOWAVPVQEDTVRRDEVSO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The reals are uncountable
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d m n x y z $.  $d k n x A $.  $d k n x B $.  $d k m y z F $.  $d k ph $.
    $d k n x M $.  $d n N $.
    rpnnen2.1 $e |- F = ( x e. ~P NN |->
      ( n e. NN |-> if ( n e. x , ( ( 1 / 3 ) ^ n ) , 0 ) ) ) $.
    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.) $)
    rpnnen2lem1 $p |- ( ( A C_ NN /\ N e. NN ) ->
        ( ( F ` A ) ` N ) = if ( N e. A , ( ( 1 / 3 ) ^ N ) , 0 ) ) $=
      ( cn wss wcel cfv cv c1 co cexp cc0 cif cmpt wceq nnex fvmpt c3 cpw elpw2
      cdiv eleq2 ifbid mpteq2dv mptex sylbir fveq1d eleq1 oveq2 eqidd ifbieq12d
      eqid ovex c0ex ifex sylan9eq ) BGHZEGIEBDJZJECGCKZBIZLUAUDMZVBNMZOPZQZJEB
      IZVDENMZOPZUTEVAVGUTBGUBZIVAVGRBGSUCABCGVBAKZIZVEOPZQVGVKDVLBRZCGVNVFVOVM
      VCVEOVLBVBUEUFUGFCGVFSUHTUIUJCEVFVJGVGVBERZVCVHVEOVIOVBEBUKVBEVDNULVPOUMU
      NVGUOVHVIOVDENUPUQURTUS $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 23-Aug-2014.) $)
    rpnnen2lem2 $p |- ( A C_ NN -> ( F ` A ) : NN --> RR ) $=
      ( cn wss cr cfv wf cv wcel c1 c3 co cc0 cif cmpt wceq nnex cdiv cn0 mp2an
      cexp 1re 3nn nndivre nnnn0 reexpcl sylancr ifcl sylancl adantl eqid fmptd
      0re cpw elpw2 eleq2 ifbid mpteq2dv mptex fvmpt sylbir feq1d mpbird ) BFGZ
      FHBDIZJFHCFCKZBLZMNUAOZVIUDOZPQZRZJVGCFVMHVNVIFLZVMHLZVGVOVLHLZPHLVPVOVKH
      LZVIUBLVQMHLNFLVRUEUFMNUGUCVIUHVKVIUIUJUPVJVLPHUKULUMVNUNUOVGFHVHVNVGBFUQ
      ZLVHVNSBFTURABCFVIAKZLZVLPQZRVNVSDVTBSZCFWBVMWCWAVJVLPVTBVIUSUTVAECFVMTVB
      VCVDVEVF $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.) $)
    rpnnen2lem3 $p |- seq 1 ( + , ( F ` NN ) ) ~~> ( 1 / 2 ) $=
      ( cn cfv c1 c3 cdiv co cmin c2 wbr wtru cc wcel cr clt cc0 wceq cseq cexp
      vk caddc cli 1re 3nn nndivre mp2an recni a1i cabs cle 0re 3re 3pos ltleii
      recgt0ii absid 1lt3 wb recgt1 mpbi eqbrtri cn0 1nn0 cv cuz cif ssid simpr
      wss nnuz syl6eleqr rpnnen2lem1 sylancr iftrue syl eqtrd geolim2 trud exp1
      wa ax-mp wne 3cn ax-1cn 3ne0 pm3.2i divsubdir mp3an 3m1e2 oveq1i 3eqtr3ri
      dividi oveq12i 2cn 2ne0 divcan7 eqtri breqtri ) UDECFZGUAZGHIJZGUBJZGXDKJ
      ZIJZGLIJZUEXCXGUEMNXDUCXBGXDOPZNXDGQPHEPXDQPZUFUGGHUHUIZUJZUKXDULFZGRMNXM
      XDGRXJSXDUMMXMXDTXKSXDUNXKHUOUPURUQXDUSUIGHRMZXDGRMZUTHQPSHRMXNXOVAUOUPHV
      BUIVCVDUKGVEPNVFUKNUCVGZGVHFZPZWCZXPXBFZXPEPZXDXPUBJZSVIZYBXSEEVLYAXTYCTE
      VJXSXPXQENXRVKVMVNZAEBCXPDVOVPXSYAYCYBTYDYAYBSVQVRVSVTWAXGXDLHIJZIJZXHXEX
      DXFYEIXIXEXDTXLXDWBWDHGKJZHIJZHHIJZXDKJZYEXFHOPZGOPZYKHSWEZWCZYHYJTWFWGYK
      YMWFWHWIZHGHWJWKYGLHIWLWMYIGXDKHWFWHWOWMWNWPYLLOPZLSWEZWCYNYFXHTWGYPYQWQW
      RWIYOGLHWSWKWTXA $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 31-Aug-2014.) $)
    rpnnen2lem4 $p |- ( ( A C_ B /\ B C_ NN /\ k e. NN ) ->
      ( 0 <_ ( ( F ` A ) ` k ) /\ ( ( F ` A ) ` k ) <_ ( ( F ` B ) ` k ) ) ) $=
      ( wss cn wcel cc0 cfv cle wbr c1 c3 co cif 0re cr w3a cdiv cexp cn0 nnnn0
      cv 1re 3nn nndivre mp2an 3re 3pos recgt0ii ltleii expge0 sylancl 3ad2ant3
      mp3an1 0le0 breq2 ifboth wceq wa sstr rpnnen2lem1 sylan 3impa breqtrrd wi
      reexpcl sylancr a1i simp1 sseld ifle syl31anc 3adant1 3brtr4d jca ) BCHZC
      IHZDUFZIJZUAZKWBBFLLZMNWEWBCFLLZMNWDKWBBJZOPUBQZWBUCQZKRZWEMWDKWIMNZKKMNZ
      KWJMNZWCVTWKWAWCWBUDJZKWHMNZWKWBUEZKWHSOTJPIJWHTJZUGUHOPUIUJZPUKULUMUNWQW
      NWOWKWRWHWBUOURUPUQZUSWGWKWLWMWIKWIWJKMUTKWJKMUTVAUPVTWAWCWEWJVBZVTWAVCBI
      HWCWTBCIVDABEFWBGVEVFVGZVHWDWJWBCJZWIKRZWEWFMWDWITJZKTJZWKWGXBVIWJXCMNWCV
      TXDWAWCWQWNXDWRWPWHWBVJVKUQXEWDSVLWSWDBCWBVTWAWCVMVNWGXBWIKVOVPXAWAWCWFXC
      VBVTACEFWBGVEVQVRVS $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    rpnnen2lem5 $p |- ( ( A C_ NN /\ M e. NN ) ->
                        seq M ( + , ( F ` A ) ) e. dom ~~> ) $=
      ( vk cn wss wcel wa caddc cfv c1 cseq cli nnuz cr rpnnen2lem2 wbr cdm 1nn
      a1i cv wf ssid mp1i ffvelrnda c2 cdiv co rpnnen2lem3 seqex breldm cuz cc0
      ovex elnnuz rpnnen2lem4 mp3an2 sylan2br simpld simprd cvgcmp adantr simpr
      cle adantlr recnd iserex mpbid ) BHIZEHJZKZLBDMZNOPUAZJZLVOEOVPJVLVQVMVLG
      HDMZVONNHQNHJVLUBUCVLHRGUDZVRHHIZHRVRUEVLHUFZAHCDFSUGUHVLHRVSVOABCDFSUHZL
      VRNOZNUIUJUKZPTWCVPJVLACDFULWCWDPLVRNUMNUIUJUQUNUGVLVSNUOMJZKZUPVSVOMZVGT
      ZWGVSVRMVGTZWEVLVSHJZWHWIKZVSURVLVTWJWKWAABHGCDFUSUTVAZVBWFWHWIWLVCVDVEVN
      GVONEHQVLVMVFVNWJKWGVLWJWGRJVMWBVHVIVJVK $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    rpnnen2lem6 $p |- ( ( A C_ NN /\ M e. NN ) ->
        sum_ k e. ( ZZ>= ` M ) ( ( F ` A ) ` k ) e. RR ) $=
      ( cn wss wcel wa cv cfv cuz eqid cz nnz adantl eqidd cr wf rpnnen2lem2 c1
      ad2antrr nnuz uztrn2 adantll ffvelrnd rpnnen2lem5 isumrecl ) BHIZFHJZKZCL
      ZBEMZMZCUOFFNMZUQOULFPJUKFQRUMUNUQJZKZUPSUSHTUNUOUKHTUOUAULURABDEGUBUDULU
      RUNHJUKUCUNFHUEUFUGUHABDEFGUIUJ $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    rpnnen2lem7 $p |- ( ( A C_ B /\ B C_ NN /\ M e. NN ) ->
        sum_ k e. ( ZZ>= ` M ) ( ( F ` A ) ` k ) <_
        sum_ k e. ( ZZ>= ` M ) ( ( F ` B ) ` k ) ) $=
      ( wss cn wcel w3a cfv eqidd cr wf rpnnen2lem2 ffvelrnda syldan cle cv cuz
      eqid simp3 nnzd wa c1 nnuz uztrn2 sylan sstr 3adant3 syl 3ad2ant2 wbr cc0
      rpnnen2lem4 3expa 3adantl3 caddc cseq cli cdm rpnnen2lem5 syl2anc 3adant1
      simprd isumle ) BCIZCJIZGJKZLZDUAZBFMZMZVMCFMZMZDVNVPGGUBMZVRUCVLGVIVJVKU
      DZUEVLVMVRKZUFZVONVLVTVMJKZVOOKVLVKVTWBVSUGVMGJUHUIUJZVLJOVMVNVLBJIZJOVNP
      VIVJWDVKBCJUKULZABEFHQUMRSWAVQNVLVTWBVQOKWCVLJOVMVPVJVIJOVPPVKACEFHQUNRSV
      LVTWBVOVQTUOZWCVIVJWBWFVKVIVJWBWFVIVJWBLUPVOTUOWFABCDEFHUQVGURUSSVLWDVKUT
      VNGVAVBVCZKWEVSABEFGHVDVEVJVKUTVPGVAWGKVIACEFGHVDVFVH $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    rpnnen2lem8 $p |- ( ( A C_ NN /\ M e. NN ) ->
       sum_ k e. NN ( ( F ` A ) ` k ) =
         ( sum_ k e. ( 1 ... ( M - 1 ) ) ( ( F ` A ) ` k ) +
           sum_ k e. ( ZZ>= ` M ) ( ( F ` A ) ` k ) ) ) $=
      ( cn wss wcel wa cv cfv c1 cuz nnuz eqid simpr cr adantr rpnnen2lem2 cseq
      eqidd wf ffvelrnda recnd caddc cli cdm 1nn rpnnen2lem5 mpan2 isumsplit )
      BHIZFHJZKZCLZBEMZMZCURNFFOMZHPUTQUNUORUPUQHJKZUSUCVAUSUPHSUQURUNHSURUDUOA
      BDEGUATUEUFUNUGURNUBUHUIJZUOUNNHJVBUJABDENGUKULTUM $.

    $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    rpnnen2lem9 $p |- ( M e. NN ->
       sum_ k e. ( ZZ>= ` M ) ( ( F ` ( NN \ { M } ) ) ` k ) =
         ( 0 + ( ( ( 1 / 3 ) ^ ( M + 1 ) ) / ( 1 - ( 1 / 3 ) ) ) ) ) $=
      ( cn wcel cfv c1 caddc co cc0 c3 cexp cr syl wceq clt wbr cuz cv csn cdif
      csu cdiv cmin eqid nnz wa eqidd cc nnuz uztrn2 wf difss rpnnen2lem2 ax-mp
      wss ffvelrni recnd cseq cli rpnnen2lem5 mpan isum1p rpnnen2lem1 neldifsnd
      cdm cif iffalse eqtrd peano2nn nnzd sylan 1re 3nn nndivre mp2an recni a1i
      wn cabs cle 0re 3re 3pos recgt0ii ltleii absid 1lt3 wb recgt1 mpbi nnnn0d
      eqbrtri nnre adantr eluzle adantl nnltp1le syldan mpbird eldifsn sylanbrc
      wne gtned iftrue geolim2 isumclim oveq12d ) EGHZEUAIZBUBZGEUCZUDZDIZIZBUE
      EXQIZEJKLZUAIZXRBUEZKLMJNUFLZXTOLJYCUGLUFLZKLXLXRBXQEXMXMUHEUIXLXNXMHUJZX
      RUKYEXNGHZXRULHZJXNEGUMUNYFXRGPXNXQXPGUSZGPXQUOGXOUPZAXPCDFUQURUTVAZQYHXL
      KXQEVBVCVIHYIAXPCDEFVDVEVFXLXSMYBYDKXLXSEXPHZYCEOLZMVJZMYHXLXSYMRYIAXPCDE
      FVGVEXLYKWBYMMRXLEGVHYKYLMVKQVLXLXRYDBXQXTYAYAUHXLXTEVMZVNXLXNYAHZUJZXRUK
      YPYFYGXLXTGHYOYFYNJXNXTGUMUNVOZYJQXLYCBXQXTYCULHXLYCJPHNGHYCPHZVPVQJNVRVS
      ZVTWAYCWCIZJSTXLYTYCJSYRMYCWDTYTYCRYSMYCWEYSNWFWGWHWIYCWJVSJNSTZYCJSTZWKN
      PHMNSTUUAUUBWLWFWGNWMVSWNWPWAXLXTYNWOYPXRXNXPHZYCXNOLZMVJZUUDYPYFXRUUERZY
      QYHYFUUFYIAXPCDXNFVGVEQYPUUCUUEUUDRYPYFXNEXFUUCYQYPEXNXLEPHYOEWQWRYPEXNST
      ZXTXNWDTZYOUUHXLXTXNWSWTXLYOYFUUGUUHWLYQEXNXAXBXCXGXNGEXDXEUUCUUDMXHQVLXI
      XJXKVL $.

    ${
      rpnnen2.2 $e |- ( ph -> A C_ NN ) $.
      rpnnen2.3 $e |- ( ph -> B C_ NN ) $.
      rpnnen2.4 $e |- ( ph -> m e. ( A \ B ) ) $.
      rpnnen2.5 $e |- ( ph ->
                        A. n e. NN ( n < m -> ( n e. A <-> n e. B ) ) ) $.
      rpnnen2.6 $e |- ( ps <-> sum_ k e. NN ( ( F ` A ) ` k ) =
                               sum_ k e. NN ( ( F ` B ) ` k ) ) $.
      $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro, 13-May-2013.)
         (Revised by Mario Carneiro, 30-Apr-2014.) $)
      rpnnen2lem10 $p |- ( ( ph /\ ps ) ->
            sum_ k e. ( ZZ>= ` m ) ( ( F ` A ) ` k ) =
            sum_ k e. ( ZZ>= ` m ) ( ( F ` B ) ` k ) ) $=
        ( c1 co wceq cn wcel wa cmin cfz cfv csu cuz caddc simpr sylib wss cdif
        cv eldifi ssel2 sylan2 syl2anc rpnnen2lem8 c3 cdiv cexp cc0 cif clt wbr
        wb cz cle w3a 1z nnz elfzm11 sylancr biimpa sylan simp3d wi wral elfznn
        breq1 eleq1 bibi12d imbi12d rspccva syl2an rpnnen2lem1 3eqtr4d sumeq2dv
        mpd ifbid oveq1d eqtrd adantr 3eqtr3d rpnnen2lem6 fzfid rpnnen2lem2 syl
        cr wf ffvelrn fsumrecl readdcan syl3anc mpbid ) ABUAZPGULZPUBQZUCQZFULZ
        EIUDZUDZFUEZXFUFUDZXIDIUDUDZFUEZUGQZXLXMXKFUEZUGQZRZXOXQRZXESXNFUEZSXKF
        UEZXPXRXEBYAYBRABUHOUIAYAXPRBAYAXHXNFUEZXOUGQZXPADSUJZXFSTZYAYDRKAYEXFD
        EUKTZYFKMYGYEXFDTYFXFDEUMDSXFUNUOUPZCDFHIXFJUQUPAYCXLXOUGAXHXNXKFAXIXHT
        ZUAZXIDTZPURUSQXIUTQZVAVBZXIETZYLVAVBZXNXKYJYKYNYLVAYJXIXFVCVDZYKYNVEZY
        JXIVFTZPXIVGVDZYPAYFYIYRYSYPVHZYHYFYIYTYFPVFTXFVFTYIYTVEVIXFVJXIPXFVKVL
        VMVNVOAHULZXFVCVDZUUADTZUUAETZVEZVPZHSVQXISTZYPYQVPZYINXIXGVRZUUFUUHHXI
        SUUAXIRZUUBYPUUEYQUUAXIXFVCVSUUJUUCYKUUDYNUUAXIDVTUUAXIEVTWAWBWCWDWHWIA
        YEUUGXNYMRYIKUUICDHIXIJWEWDAESUJZUUGXKYORYILUUICEHIXIJWEWDWFWGWJWKWLAYB
        XRRZBAUUKYFUULLYHCEFHIXFJUQUPWLWMAXSXTVEZBAXOWRTZXQWRTZXLWRTUUMAYEYFUUN
        KYHCDFHIXFJWNUPAUUKYFUUOLYHCEFHIXFJWNUPAXHXKFAPXGWOASWRXJWSZUUGXKWRTYIA
        UUKUUPLCEHIJWPWQUUISWRXIXJWTWDXAXOXQXLXBXCWLXD $.

      $( Lemma for ~ rpnnen2 .  (Contributed by Mario Carneiro,
         13-May-2013.) $)
      rpnnen2lem11 $p |- ( ph -> -. ps ) $=
        ( cn wcel c3 cdiv co cv cuz cfv csu wne wn wss cdif eldifi ssel2 sylan2
        cr syl2anc rpnnen2lem6 c1 cexp cn0 nnrecre ax-mp nnnn0d reexpcl sylancr
        3nn c2 crp nnrp rpreccl mp2b nnzd rpexpcl rpred rehalfcld csn cle snssd
        cz wbr ssdifd sstrd ssconb mpbird difssd rpnnen2lem7 syl3anc caddc cmin
        wb cc0 wceq rpnnen2lem9 syl cmul cc recni expp1 3cn 3ne0 divrec mp3an23
        recnd eqtr4d oveq1d ax-1cn pm3.2i divsubdir mp3an 3m1e2 oveq1i 3eqtr3ri
        wa dividi oveq2i 2cn divcan7 syl5eq eqtrd oveq2d addid2d 3eqtrd breqtrd
        2ne0 clt rphalflt lelttrd nnuz uztrn2 sylan rpnnen2lem1 syldan sumeq2dv
        cif wral cfn wo uzid vex oveq2 eleq1d ralsn sylibr ssid a1i orcd sumss2
        syl21anc sumsn 3eqtr2d eqbrtrrd ltletrd gtned rpnnen2lem10 necon3ad mpd
        ex ) AGUAZUBUCZFUAZDIUCUCFUDZUUPUUQEIUCUCFUDZUEBUFAUUSUURAEPUGZUUOPQZUU
        SULQLADPUGZUUODEUHZQZUVAKMUVDUVBUUODQZUVAUUODEUIZDPUUOUJUKUMZCEFHIUUOJU
        NUMZAUUSUORSTZUUOUPTZUURUVHAUVIULQZUUOUQQZUVJULQRPQZUVKVCRURUSZAUUOUVGU
        TZUVIUUOVAVBAUVBUVAUURULQKUVGCDFHIUUOJUNUMAUUSUVJVDSTZUVJUVHAUVJAUVJAUV
        IVEQZUUOVPQZUVJVEQZUVMRVEQUVQVCRVFRVGVHAUUOUVGVIZUVIUUOVJVBZVKZVLZUWBAU
        USUUPUUQPUUOVMZUHZIUCUCFUDZUVPVNAEUWEUGZUWEPUGUVAUUSUWFVNVQAUWGUWDPEUHZ
        UGZAUWDUVCUWHAUUOUVCMVOADPEKVRVSAUUTUWDPUGZUWGUWIWGLAUUOPUVGVOZEUWDPVTU
        MWAAPUWDWBUVGCEUWEFHIUUOJWCWDAUWFWHUVIUUOUOWETUPTZUOUVIWFTZSTZWETZWHUVP
        WETUVPAUVAUWFUWOWIUVGCFHIUUOJWJWKAUWNUVPWHWEAUWNUVJRSTZUWMSTZUVPAUWLUWP
        UWMSAUWLUVJUVIWLTZUWPAUVIWMQUVLUWLUWRWIUVIUVNWNUVOUVIUUOWOVBAUVJWMQZUWP
        UWRWIZAUVJUWBWTZUWSRWMQZRWHUEZUWTWPWQUVJRWRWSWKXAXBAUWQUWPVDRSTZSTZUVPU
        WMUXDUWPSRUOWFTZRSTZRRSTZUVIWFTZUXDUWMUXBUOWMQUXBUXCXJZUXGUXIWIWPXCUXBU
        XCWPWQXDZRUORXEXFUXFVDRSXGXHUXHUOUVIWFRWPWQXKXHXIXLAUWSUXEUVPWIZUXAUWSV
        DWMQZVDWHUEZXJUXJUXLUXMUXNXMYAXDUXKUVJVDRXNWSWKXOXPXQAUVPAUVPUWCWTXRXSX
        TAUVSUVPUVJYBVQUWAUVJYCWKYDAUUPUUQUWDIUCUCZFUDZUVJUURVNAUXPUUPUUQUWDQUV
        IUUQUPTZWHYKZFUDZUWDUXQFUDZUVJAUUPUXOUXRFAUUQUUPQZUUQPQZUXOUXRWIZAUVAUY
        AUYBUVGUOUUQUUOPYEYFYGAUWJUYBUYCUWKCUWDHIUUQJYHYGYIYJAUWDUUPUGUXQWMQZFU
        WDYLZUUPUUPUGZUUPYMQZYNUXTUXSWIAUUOUUPAUVRUUOUUPQUVTUUOYOWKVOAUWSUYEUXA
        UYDUWSFUUOGYPUUQUUOWIUXQUVJWMUUQUUOUVIUPYQZYRYSYTAUYFUYGUYFAUUPUUAUUBUU
        CUWDUUPUXQFUUOUUDUUEAUVAUWSUXTUVJWIUVGUXAUXQUVJFUUOPUYHUUFUMUUGAUWDDUGU
        VBUVAUXPUURVNVQAUUODAUVDUVEMUVFWKVOKUVGCUWDDFHIUUOJWCWDUUHUUIUUJABUURUU
        SABUURUUSWIABCDEFGHIJKLMNOUUKUUNUULUUM $.
    $}

    $( The other half of ~ rpnnen , where we show an injection from sets of
       natural numbers to real numbers.  The obvious choice for this is binary
       expansion, but it has the unfortunate property that it does not produce
       an injection on numbers which end with all 0's or all 1's (the more
       well-known decimal version of this is ~ 0.999... ).  Instead, we opt for
       a ternary expansion, which produces (a scaled version of) the Cantor
       set.  Since the Cantor set is riddled with gaps, we can show that any
       two sequences that are not equal must differ somewhere, and when they
       do, they are placed a finite distance apart, thus ensuring that the map
       is injective.

       Our map assigns to each subset ` A ` of the natural numbers the number
       ` sum_ k e. A ( 3 ^ -u k ) = sum_ k e. NN ( ( F `` A ) `` k ) ` , where
       ` ( ( F `` A ) `` k ) = if ( k e. A , ( 3 ^ -u k ) , 0 ) ) `
       ( ~ rpnnen2lem1 ).  This is an infinite sum of real numbers
       ( ~ rpnnen2lem2 ), and since ` A C_ B ` implies
       ` ( F `` A ) <_ ( F `` B ) ` ( ~ rpnnen2lem4 ) and ` ( F `` NN ) `
       converges to ` 1 / 2 ` ( ~ rpnnen2lem3 ) by ~ geoisum1 , the sum is
       convergent to some real ( ~ rpnnen2lem5 and ~ rpnnen2lem6 ) by the
       comparison test for convergence ~ cvgcmp .  The comparison test also
       tells us that ` A C_ B ` implies ` sum_ ( F `` A ) <_ sum_ ( F `` B ) `
       ( ~ rpnnen2lem7 ).

       Putting it all together, if we have two sets ` x =/= y ` , there must
       differ somewhere, and so there must be an ` m ` such that
       ` A. n < m ( n e. x <-> n e. y ) ` but ` m e. ( x \ y ) ` or vice
       versa.  In this case, we split off the first ` m - 1 ` terms
       ( ~ rpnnen2lem8 ) and cancel them ( ~ rpnnen2lem10 ), since these are
       the same for both sets.  For the remaining terms, we use the subset
       property to establish that
       ` sum_ ( F `` y ) <_ sum_ ( F `` ( NN \ { m } ) ) ` and
       ` sum_ ( F `` { m } ) <_ sum_ ( F `` x ) ` (where these sums are only
       over ` ( ZZ>= `` m ) ` ), and since
       ` sum_ ( F `` ( NN \ { m } ) ) = ( 3 ^ -u m ) / 2 ` ( ~ rpnnen2lem9 )
       and ` sum_ ( F `` { m } ) = ( 3 ^ -u m ) ` , we establish that
       ` sum_ ( F `` y ) < sum_ ( F `` x ) ` ( ~ rpnnen2lem11 ) so that they
       must be different.  By contraposition, we find that this map is an
       injection.  (Contributed by Mario Carneiro, 13-May-2013.)  (Proof
       shortened by Mario Carneiro, 30-Apr-2014.) $)
    rpnnen2 $p |- ~P NN ~<_ ( 0 [,] 1 ) $=
      ( vk vm cc0 c1 wcel cn wbr cv cfv cr cle wss a1i wa wi wn vy cicc cvv cpw
      vz co cdom ovex csu elpwi cuz nnuz sumeq1i 1nn rpnnen2lem6 mpan2 syl5eqel
      syl cz 1z eqidd wf rpnnen2lem2 ffvelrnda cseq cli cdm rpnnen2lem5 sylancl
      caddc ssid rpnnen2lem4 mp3an2 sylan isumge0 c2 cdiv rehalfcli rpnnen2lem7
      simpld 1re mp3an23 eqid cc elnnuz ax-mp ffvelrni recnd sylbir rpnnen2lem3
      adantl isumclim breqtrd syl5eqbr halflt1 letrd 0re elicc2i syl3anbrc wceq
      ltleii wne clt wb wral cdif wrex wo cun ssdifss unss biimpi syl2an ssdif0
      c0 eqss anbi12i un00 3bitri necon3bii nnwo sselda wal df-ral con34b eldif
      orbi12i elun xor imbi2i bitri nnre syld simpll simplr simprl rpnnen2lem11
      ex simprr rexlimdvaa 3bitr4ri con1bii albii alral syl2anr imbi1d ralbidva
      ltnle syl5ibr syl5bi reximdva rexun syl6ib biid bicom ralbii sylibr eqcom
      jaod necon4ad fveq2 fveq1d sumeq2sdv impbid1 dom2 ) GHUBUFZUCIJUDZUVFUGKG
      HUBUHUAUEUVGUVFJELZUALZCMZMZEUIZJUVHUELZCMZMZEUIZUCUVIUVGIZUVLNIZGUVLOKUV
      LHOKUVLUVFIUVQUVIJPZUVRUVIJUJZUVSUVLHUKMZUVKEUIZNJUWAUVKEULUMZUVSHJIZUWBN
      IUNAUVIEBCHDUOUPUQURZUVQUVKEUVJHJULHUSIUVQUTQZUVQUVHJIZRUVKVAUVQJNUVHUVJU
      VQUVSJNUVJVBUVTAUVIBCDVCURVDUVQUVSUWDVJUVJHVEVFVGIUVTUNAUVIBCHDVHVIUVQUVS
      UWGGUVKOKZUVTUVSUWGRUWHUVKUVHJCMZMZOKZUVSJJPZUWGUWHUWKRJVKZAUVIJEBCDVLVMV
      TVNVOUVQUVLHVPVQUFZHUWEUWNNIUVQHWAVRZQHNIUVQWAQUVQUVLUWBUWNOUWCUVQUWBUWAU
      WJEUIZUWNOUVQUVSUWBUWPOKZUVTUVSUWLUWDUWQUWMUNAUVIJEBCHDVSWBURUVQUWJUWNEUW
      IHUWAUWAWCUWFUVQUVHUWAIZRUWJVAUWRUWJWDIZUVQUWRUWGUWSUVHWEUWGUWJJNUVHUWIUW
      LJNUWIVBUWMAJBCDVCWFWGWHWIWKVJUWIHVEUWNVFKUVQABCDWJQWLWMWNUWNHOKUVQUWNHUW
      OWAWOXAQWPGHUVLWQWAWRWSUVQUVMUVGIZRZUVLUVPWTZUVIUVMWTZUXAUXBUVIUVMUXAUVIU
      VMXBZBLZFLZXCKZUXEUVIIZUXEUVMIZXDZSZBJXEZFUVIUVMXFZXGZUXLFUVMUVIXFZXGZXHZ
      UXBTZUXAUXDUXLFUXMUXOXIZXGZUXQUXAUXDUXFUXEOKZBUXSXEZFUXSXGZUXTUXAUXDUYCUX
      AUXSJPZUXSXOXBZUYCUXDUVQUVSUVMJPZUYDUWTUVTUVMJUJZUVSUXMJPZUXOJPZUYDUYFUVI
      JUVMXJUVMJUVIXJUYHUYIRUYDUXMUXOJXKXLXMXMZUXDUYEUVIUVMUXSXOUXCUVIUVMPZUVMU
      VIPZRUXMXOWTZUXOXOWTZRUXSXOWTUVIUVMXPUYKUYMUYLUYNUVIUVMXNUVMUVIXNXQUXMUXO
      XRXSXTXLFBUXSYAXMYRUXAUYBUXLFUXSUXAUXFUXSIRUXFJIZUYBUXLSUXAUXSJUXFUYJYBUY
      BUYATZUXJSZBYCZUYOUXLUYBUXEUXSIZUYASZBYCUYRUYABUXSYDUYTUYQBUYTUYPUYSTZSUY
      QUYSUYAYEVUAUXJUYPUXJUYSUXEUXMIZUXEUXOIZXHUXHUXITRZUXIUXHTRZXHUYSUXJTVUBV
      UDVUCVUEUXEUVIUVMYFUXEUVMUVIYFYGUXEUXMUXOYHUXHUXIYIUUAUUBYJYKUUCYKUYRUXLU
      YOUYQBJXEUYQBJUUDUYOUXKUYQBJUYOUXEJIZRUXGUYPUXJVUFUXENIUXFNIUXGUYPXDUYOUX
      EYLUXFYLUXEUXFUUHUUEUUFUUGUUIUUJURUUKYMUXLFUXMUXOUULUUMUVQUVSUYFUXQUXRSUW
      TUVTUYGUVSUYFRZUXNUXRUXPVUGUXLUXRFUXMVUGUXFUXMIZUXLRZRUXBAUVIUVMEFBCDUVSU
      YFVUIYNUVSUYFVUIYOVUGVUHUXLYPVUGVUHUXLYSUXBUUNYQYTVUGUXLUXRFUXOVUGUXFUXOI
      ZUXLRZRZUXBAUVMUVIEFBCDUVSUYFVUKYOUVSUYFVUKYNVUGVUJUXLYPVULUXLUXGUXIUXHXD
      ZSZBJXEVUGVUJUXLYSVUNUXKBJVUMUXJUXGUXIUXHUUOYJUUPUUQUVLUVPUURYQYTUUSXMYMU
      UTUXCJUVKUVOEUXCUVHUVJUVNUVIUVMCUVAUVBUVCUVDUVEWF $.
  $}

  ${
    $d j k m n x y $.
    $( The cardinality of the continuum is the same as the powerset of
       ` om ` .  This is a stronger statement than ~ ruc , which only asserts
       that ` RR ` is uncountable, i.e. has a cardinality larger than ` om ` .
       The main proof is in two parts, ~ rpnnen1 and ~ rpnnen2 , each showing
       an injection in one direction, and this last part uses ~ sbth to prove
       that the sets are equinumerous.  By constructing explicit injections, we
       avoid the use of AC. (Contributed by Mario Carneiro, 13-May-2013.)
       (Revised by Mario Carneiro, 23-Aug-2014.) $)
    rpnnen $p |- RR ~~ ~P NN $=
      ( vx vm vk vn vy cr cn cdom wbr cen cq co cv cdiv clt cmpt c2o mp2an cc0
      cz vj cpw cmap crab csup weq oveq1 breq1d cbvrabv rabbidv supeq1d oveq12d
      oveq2 cbvmptv breq2 oveq1d mpteq2dv syl5eq rpnnen1 csdm qnnen nnex canth2
      ensdomtr sdomdom mapdom1 mp2b pw2en enref mapen domentr cxp com wcel 2onn
      id cvv mapxpen mp3an elexi xpnnen entri entr4i domtr c1 cicc wel cexp cif
      c3 elequ2 ifbid elequ1 eqidd ifbieq12d syl6eq rpnnen2 wss unitssre ssdomg
      reex mp2 sbth ) FGUBZHIZXDFHIZFXDJIFKGUCLZHIXGXDHIZXEABMZCMZNLZAMZOIZBTUD
      ZCDEFUAGXIUAMZNLZEMZOIZBTUDZFOUEZXONLZPZPXMDMZXJNLZXLOIBDTBDUFXKYDXLOXIYC
      XJNUGUHUIEAFYBCGXNFOUEZXJNLZPZEAUFZYBCGXKXQOIZBTUDZFOUEZXJNLZPYGUACGYAYLU
      ACUFZXTYKXOXJNYMFXSYJOYMXRYIBTYMXPXKXQOXOXJXINUMUHUJUKYMVPULUNYHCGYLYFYHY
      KYEXJNYHFYJXNOYHYIXMBTXQXLXKOUOUJUKUPUQURUNUSXGQGUCLZGUCLZHIZYOXDJIXHXGXD
      GUCLZHIZYQYOJIZYPKXDUTIZKXDHIYRKGJIGXDUTIYTVAGVBVCKGXDVDRKXDVEKXDGVFVGXDY
      NJIGGJIYSGVBVHZGVBVIXDYNGGVJRXGYQYOVKRYOYNXDYOQGGVLZUCLZYNQVMVNGVQVNZUUDY
      OUUCJIVOVBVBQGGVMVQVQVRVSQQJIUUBGJIUUCYNJIQQVMVOVTVIWAQQUUBGVJRWBUUAWCXGY
      OXDVKRFXGXDWDRXDSWEWFLZHIUUEFHIZXFACEXDDGDEWGZWEWJNLZYCWHLZSWIZPZPEAXDUUK
      CGCAWGZUUHXJWHLZSWIZPZYHUUKDGDAWGZUUISWIZPUUOYHDGUUJUUQYHUUGUUPUUISEADWKW
      LUQDCGUUQUUNDCUFZUUPUULUUISUUMSDCAWMYCXJUUHWHUMUURSWNWOUNWPUNWQFVQVNUUEFW
      RUUFXAWSUUEFVQWTXBXDUUEFWDRFXDXCR $.
  $}

  $( The real numbers are equinumerous to their own cross product, even though
     it is not necessarily true that ` RR ` is well-orderable (so we cannot use
     ~ infxpidm2 directly).  (Contributed by NM, 30-Jul-2004.)  (Revised by
     Mario Carneiro, 16-Jun-2013.) $)
  rexpen $p |- ( RR X. RR ) ~~ RR $=
    ( cr cxp c2o com cmap co cen wbr ax-mp entri omex mp2an cdom 2onn csdm wcel
    cn cfn domentr cvv cpw rpnnen nnenom pwen pw2en xpen elexi xpmapen wss ssid
    ensymi ssnnfi xpfi isfinite mpbi canth2 sdomdom mapdom1 mapxpen mp3an enref
    sdomtr xpomen mapen endomtr c0 csn ovex 0ex xpsnen snfi xpdom2 sbth entr4i
    ) AABZCDEFZAVOVPVPBZVPAVPGHZVRVOVQGHADUAZVPAQUAZVSUBQDGHVTVSGHUCQDUDIJDKUEZ
    JZWBAVPAVPUFLVQVPMHZVPVQMHZVQVPGHVQCCBZDEFZGHWFVPMHZWCWFVQCCDCDNUGZWHKUHUKW
    FVPDEFZMHZWIVPGHWGWEVPMHZWJWEVSMHZVSVPGHZWKWEVSOHZWLWEDOHZDVSOHZWNWERPZWOCR
    PZWRWQCDPZCCUIWRNCUJCCULLZWTCCUMLWEUNUODKUPZWEDVSVBLWEVSUQIWAWEVSVPSLWEVPDU
    RIWICDDBZEFZVPWSDTPZXDWIXCGHNKKCDDDTTUSUTCCGHXBDGHXCVPGHCWHVAVCCCXBDVDLJWFW
    IVPSLVQWFVPVELVPVPVFVGZBZGHXFVQMHZWDXFVPVPVFCDEVHZVIVJUKXEVPMHZXGXEVSMHZWMX
    IXEVSOHZXJXEDOHZWPXKXERPXLVFVKXEUNUOXAXEDVSVBLXEVSUQIWAXEVSVPSLXEVPVPXHVLIV
    PXFVQVELVQVPVMLJWBVN $.

  ${
    $d v w x y z $.
    $( The complex numbers are equinumerous to the powerset of the natural
       numbers.  (Contributed by Mario Carneiro, 16-Jun-2013.) $)
    cpnnen $p |- CC ~~ ~P NN $=
      ( vv vw vz vx vy cr cc cn cv wcel wa ci cmul caddc wceq coprab eleq1 reex
      co entr3i cpw cxp rexpen wf1o cen wbr cmpt2 bi2anan9 oveq12 sylan2 eqeq2d
      oveq2 anbi12d cbvoprab12v df-mpt2 eqtr4i cnref1o xpex f1oen ax-mp rpnnen
      ) FGHUAFFUBZFGUCVBGAIZFJZBIZFJZKZCIZVCLVEMSZNSZOZKZABCPZUDVBGUEUFDEVMVMDI
      ZFJZEIZFJZKZVHVNLVPMSZNSZOZKZDECPDEFFVTUGVLWBABCDEVCVNOZVEVPOZKZVGVRVKWAW
      CVDVOWDVFVQVCVNFQVEVPFQUHWEVJVTVHWDWCVIVSOVJVTOVEVPLMULVCVNVIVSNUIUJUKUMU
      NDECFFVTUOUPUQVBGVMFFRRURUSUTTVAT $.
  $}

  $( The set of natural numbers is strictly dominated by the set of real
     numbers, i.e. the real numbers are uncountable.  This proof is a simple
     corollary of ~ rpnnen , which determines the exact cardinality of the
     reals.  For an alternate proof discussed at
     ~ http://us.metamath.org/mpeuni/mmcomplex.html#uncountable , see ~ ruc .
     (Contributed by NM, 13-Oct-2004.)  (Revised by Mario Carneiro,
     13-May-2013.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  rucALT $p |- NN ~< RR $=
    ( cn cpw csdm wbr cr cen nnex canth2 rpnnen ensymi sdomentr mp2an ) AABZCDM
    EFDAECDAGHEMIJAMEKL $.

  ${
    $d m w x y $.  $d m x y A $.  $d m x y B $.  $d w z C $.  $d m n x y z F $.
    $d k m n x y z G $.  $d k m n x y M $.  $d k m x y N $.  $d k n w z ph $.
    $d w z D $.  $d n z S $.
    ruc.1 $e |- ( ph -> F : NN --> RR ) $.
    ruc.2 $e |- ( ph -> D = ( x e. ( RR X. RR ) , y e. RR |->
                    [_ ( ( ( 1st ` x ) + ( 2nd ` x ) ) / 2 ) / m ]_
                    if ( m < y , <. ( 1st ` x ) , m >. ,
                       <. ( ( m + ( 2nd ` x ) ) / 2 ) , ( 2nd ` x ) >. ) ) ) $.
    ${
      ruclem1.3 $e |- ( ph -> A e. RR ) $.
      ruclem1.4 $e |- ( ph -> B e. RR ) $.
      ruclem1.5 $e |- ( ph -> M e. RR ) $.
      ruclem1.6 $e |- X = ( 1st ` ( <. A , B >. D M ) ) $.
      ruclem1.7 $e |- Y = ( 2nd ` ( <. A , B >. D M ) ) $.
      $( Lemma for ~ ruc (the reals are uncountable).  Substitutions for the
         function ` D ` .  (Contributed by Mario Carneiro, 28-May-2014.)
         (Revised by Fan Zheng, 6-Jun-2016.) $)
      ruclem1 $p |- ( ph -> ( ( <. A , B >. D M ) e. ( RR X. RR ) /\
        X = if ( ( ( A + B ) / 2 ) < M , A ,
             ( ( ( ( A + B ) / 2 ) + B ) / 2 ) ) /\
        Y = if ( ( ( A + B ) / 2 ) < M , ( ( A + B ) / 2 ) , B ) ) ) $=
        ( co cr cop cxp wcel caddc c2 cdiv clt wbr cif wceq c1st cfv c2nd cmpt2
        cv csb oveqd opelxpi syl2anc wa simpr breq2d simpl fveq2d opeq1d oveq2d
        oveq1d opeq12d ifbieq12d csbeq2dv oveq12d csbeq1d eqtrd eqid opex csbex
        ifex ovmpt2a op1stg op2ndg ovex breq1 opeq2 oveq1 csbief ifeq12d syl5eq
        nfcv readdcld rehalfcld ifcl eqeltrd fvif cvv sylancl sylancr 3jca ) AD
        EUAZIFSZTTUBZUCJDEUDSZUEUFSZIUGUHZDXBEUDSZUEUFSZUIZUJKXCXBEUIZUJAWSXCDX
        BUAZXEEUAZUIZWTAWSGWRUKULZWRUMULZUDSZUEUFSZGUOZIUGUHZXKXOUAZXOXLUDSZUEU
        FSZXLUAZUIZUPZXJAWSWRIBCWTTGBUOZUKULZYCUMULZUDSZUEUFSZXOCUOZUGUHZYDXOUA
        ZXOYEUDSZUEUFSZYEUAZUIZUPZUNZSZYBAFYPWRIMUQAWRWTUCZITUCYQYBUJADTUCZETUC
        ZYRNODETTURUSPBCWRIWTTYOYBYPYCWRUJZYHIUJZUTZYOGYGYAUPYBUUCGYGYNYAUUCYIX
        PYJYMXQXTUUCYHIXOUGUUAUUBVAVBUUCYDXKXOUUCYCWRUKUUAUUBVCZVDZVEUUCYLXSYEX
        LUUCYKXRUEUFUUCYEXLXOUDUUCYCWRUMUUDVDZVFVGUUFVHVIVJUUCGYGXNYAUUCYFXMUEU
        FUUCYDXKYEXLUDUUEUUFVKVGVLVMYPVNGXNYAXPXQXTXKXOVOXSXLVOVQVPVRUSVMAYBGXB
        YAUPZXJAGXNXBYAAXMXAUEUFAXKDXLEUDAYSYTXKDUJNODETTVSUSZAYSYTXLEUJNODETTV
        TUSZVKVGVLAUUGXCXKXBUAZXBXLUDSZUEUFSZXLUAZUIZXJGXBYAUUNXAUEUFWAZGUUNWHX
        OXBUJZXPXCXQXTUUJUUMXOXBIUGWBXOXBXKWCUUPXSUULXLUUPXRUUKUEUFXOXBXLUDWDVG
        VEVIWEAXCUUJXHUUMXIAXKDXBUUHVEAUULXEXLEAUUKXDUEUFAXLEXBUDUUIVFVGUUIVHWF
        WGVMVMZAXHWTUCZXIWTUCZXJWTUCAYSXBTUCUURNAXAADENOWIWJZDXBTTURUSAXETUCYTU
        USAXDAXBEUUTOWIWJOXEETTURUSXCXHXIWTWKUSWLAJWSUKULZXFQAUVAXJUKULZXFAWSXJ
        UKUUQVDAUVBXCXHUKULZXIUKULZUIXFXCXHXIUKWMAXCUVCDUVDXEAYSXBWNUCZUVCDUJNU
        UODXBTWNVSWOAXEWNUCZYTUVDXEUJXDUEUFWAZOXEEWNTVSWPWFWGVMWGAKWSUMULZXGRAU
        VHXJUMULZXGAWSXJUMUUQVDAUVIXCXHUMULZXIUMULZUIXGXCXHXIUMWMAXCUVJXBUVKEAY
        SUVEUVJXBUJNUUODXBTWNVTWOAUVFYTUVKEUJUVGOXEEWNTVTWPWFWGVMWGWQ $.

      ruclem2.8 $e |- ( ph -> A < B ) $.
      $( Lemma for ~ ruc .  Ordering property for the input to ` D ` .
         (Contributed by Mario Carneiro, 28-May-2014.) $)
      ruclem2 $p |- ( ph -> ( A <_ X /\ X < Y /\ Y <_ B ) ) $=
        ( wbr cle clt caddc co c2 cdiv cif leidd readdcld rehalfcld wcel avglt1
        cr wb syl2anc mpbid avglt2 lttrd ltled breq2 ifboth cop cxp wceq simp2d
        ruclem1 breqtrrd iftrue breq12d syl5ibrcom iffalse pm2.61d simp3d breq1
        wn 3brtr4d eqbrtrd 3jca ) ADJUATJKUBTKEUATADDEUCUDZUEUFUDZIUBTZDVTEUCUD
        ZUEUFUDZUGZJUAADDUATZDWCUATZDWDUATZADNUHADWCNAWBAVTEAVSADENOUIUJZOUIUJZ
        ADVTWCNWHWIADEUBTZDVTUBTZSADUMUKZEUMUKZWJWKUNNODEULUOUPZAVTEUBTZVTWCUBT
        ZAWJWOSAWLWMWJWOUNNODEUQUOUPZAVTUMUKZWMWOWPUNWHOVTEULUOUPURUSWAWEWFWGDW
        CDWDDUAUTWCWDDUAUTVAUOADEVBIFUDUMUMVCUKZJWDVDZKWAVTEUGZVDZABCDEFGHIJKLM
        NOPQRVFZVEZVGAWDXAJKUBAWAWDXAUBTZAXEWAWKWNWAWDDXAVTUBWADWCVHWAVTEVHVIVJ
        AXEWAVOZWCEUBTZAWOXGWQAWRWMWOXGUNWHOVTEUQUOUPXFWDWCXAEUBWADWCVKWAVTEVKV
        IVJVLXDAWSWTXBXCVMZVPAKXAEUAXHAVTEUATZEEUATZXAEUATZAVTEWHOWQUSAEOUHWAXI
        XJXKVTEVTXAEUAVNEXAEUAVNVAUOVQVR $.

      $( Lemma for ~ ruc .  The constructed interval ` [ X , Y ] ` always
         excludes ` M ` .  (Contributed by Mario Carneiro, 28-May-2014.) $)
      ruclem3 $p |- ( ph -> ( M < X \/ Y < M ) ) $=
        ( clt wbr wn caddc co c2 cdiv cle readdcld rehalfcld lenltd wcel avglt2
        wa cr wb syl2anc mpbid avglt1 lelttr syl3anc mpan2d sylbird imp cif cop
        wi wceq ruclem1 simp2d iffalse sylan9eq breqtrrd ex con1d simp3d iftrue
        cxp simpr eqbrtrd syld orrd ) AIJTUAZKITUAZAWBUBDEUCUDZUEUFUDZITUAZWCAW
        FWBAWFUBZWBAWGUMIWEEUCUDZUEUFUDZJTAWGIWITUAZAWGIWEUGUAZWJAIWEPAWDADENOU
        HUIZUJAWKWEWITUAZWJAWEETUAZWMADETUAZWNSADUNUKEUNUKZWOWNUONODEULUPUQAWEU
        NUKZWPWNWMUOWLOWEEURUPUQAIUNUKWQWIUNUKWKWMUMWJVFPWLAWHAWEEWLOUHUIIWEWIU
        SUTVAVBVCAWGJWFDWIVDZWIADEVEIFUDUNUNVQUKZJWRVGZKWFWEEVDZVGZABCDEFGHIJKL
        MNOPQRVHZVIWFDWIVJVKVLVMVNAWFWCAWFUMKWEITAWFKXAWEAWSWTXBXCVOWFWEEVPVKAW
        FVRVSVMVTWA $.
    $}

    ruc.4 $e |- C = ( { <. 0 , <. 0 , 1 >. >. } u. F ) $.
    ruc.5 $e |- G = seq 0 ( D , C ) $.
    $( Lemma for ~ ruc .  Initial value of the interval sequence.  (Contributed
       by Mario Carneiro, 28-May-2014.) $)
    ruclem4 $p |- ( ph -> ( G ` 0 ) = <. 0 , 1 >. ) $=
      ( cc0 cfv c1 cop csn cn0 cres cn cseq fveq1i 0z cdif cun dfn2 reseq2i wfn
      cr wf wceq ffn fnresdm 3syl syl5reqr uneq2d syl5eq c0ex opex eqid fvsnun1
      fveq1d syl6eq seq1i ) AMHNMEDMUAZNMOPZMHVELUBAVFEDMUCAMDNMMVFPQZGRMQUDZSZ
      UEZNVFAMDVJADVGGUEVJKAGVIVGAVIGTSZGTVHGUFUGATUIGUJGTUHVKGUKITUIGULTGUMUNU
      OUPUQVBMVFRGVJURMOUSVJUTVAVCVDUQ $.

    $( Lemma for ~ ruc .  Domain and range of the interval sequence.
       (Contributed by Mario Carneiro, 28-May-2014.) $)
    ruclem6 $p |- ( ph -> G : NN0 --> ( RR X. RR ) ) $=
      ( cr cc0 cfv c1 cop wcel wceq co vz vw cn0 cxp cseq wf fveq1i cz 0z ax-mp
      seq1 eqtri ruclem4 syl5eqr 0re 1re opelxpi mp2an syl6eqel cv wa c1st c2nd
      1st2nd2 ad2antrl oveq1d caddc c2 cdiv clt wbr cn adantr cmpt2 xp1st xp2nd
      cif csb simprr eqid ruclem1 simp1d eqeltrd nn0uz 0p1e1 fveq2i nnuz eqtr4i
      a1i cuz eleq2i csn cun equncomi wne nnne0 necomd fvunsn syl syl5eq adantl
      ffvelrnda sylan2b seqf2 feq1i sylibr ) AUCMMUDZEDNUEZUFUCXGHUFAUAUBXGMEDN
      UCANDOZNPQZXGAXINHOZXJXKNXHOZXINHXHLUGNUHRZXLXISUIEDNUKUJULABCDEFGHIJKLUM
      UNNMRPMRXJXGRUOUPNPMMUQURUSAUAUTZXGRZUBUTZMRZVAZVAZXNXPETXNVBOZXNVCOZQZXP
      ETZXGXSXNYBXPEXOXNYBSAXQXNMMVDVEVFXSYCXGRYCVBOZXTYAVGTVHVITZXPVJVKZXTYEYA
      VGTVHVITVQSYCVCOZYFYEYAVQSXSBCXTYAEFGXPYDYGAVLMGUFXRIVMAEBCXGMFBUTZVBOZYH
      VCOZVGTVHVITFUTZCUTVJVKYIYKQYKYJVGTVHVITYJQVQVRVNSXRJVMXOXTMRAXQXNMMVOVEX
      OYAMRAXQXNMMVPVEAXOXQVSYDVTYGVTWAWBWCWDXMAUIWIXNNPVGTZWJOZRAXNVLRZXNDOZMR
      YMVLXNYMPWJOVLYLPWJWEWFWGWHWKAYNVAYOXNGOZMYNYOYPSAYNYOXNGNXJQWLZWMZOZYPXN
      DYRDYQGKWNUGYNNXNWOYSYPSYNXNNXNWPWQGNXJXNWRWSWTXAAVLMXNGIXBWCXCXDUCXGHXHL
      XEXF $.

    $( Lemma for ~ ruc .  Successor value for the interval sequence.
       (Contributed by Mario Carneiro, 28-May-2014.) $)
    ruclem7 $p |- ( ( ph /\ N e. NN0 ) ->
      ( G ` ( N + 1 ) ) = ( ( G ` N ) D ( F ` ( N + 1 ) ) ) ) $=
      ( cn0 wcel c1 co cfv cc0 fveq1i caddc cseq cuz simpr nn0uz syl6eleq seqp1
      wceq syl oveq1i 3eqtr4g wne nn0p1nn adantl nnne0d necomd cop csn equncomi
      wa cn cun fvunsn syl5eq oveq2d eqtrd ) AINOZUTZIPUAQZHRZIHRZVIDRZEQZVKVIG
      RZEQVHVIEDSUBZRZIVORZVLEQZVJVMVHISUCRZOVPVRUHVHINVSAVGUDUEUFEDSIUGUIVIHVO
      MTVKVQVLEIHVOMTUJUKVHVLVNVKEVHSVIULZVLVNUHVHVISVHVIVGVIVAOAIUMUNUOUPVTVLV
      IGSSPUQZUQURZVBZRVNVIDWCDWBGLUSTGSWAVIVCVDUIVEVF $.

    $( Lemma for ~ ruc .  The intervals of the ` G ` sequence are all
       nonempty.  (Contributed by Mario Carneiro, 28-May-2014.) $)
    ruclem8 $p |- ( ( ph /\ N e. NN0 ) ->
                    ( 1st ` ( G ` N ) ) < ( 2nd ` ( G ` N ) ) ) $=
      ( cfv c1st c2nd clt wbr fveq2d cr vk vn cn0 wcel cv wi cc0 c1 caddc fveq2
      co wceq breq12d imbi2d 0lt1 a1i cop ruclem4 c0ex 1ex op1st syl6eq 3brtr4d
      op2nd wa cle cn wf adantr cxp c2 cdiv cif cmpt2 ruclem6 ffvelrnda adantrr
      csb xp1st xp2nd nn0p1nn ffvelrn syl2an eqid simprr ruclem2 simp2d ruclem7
      syl 1st2nd2 oveq1d eqtrd expr expcom a2d nn0ind impcom ) IUCUDAIHNZONZWRP
      NZQRZAUAUEZHNZONZXCPNZQRZUFAUGHNZONZXGPNZQRZUFAUBUEZHNZONZXLPNZQRZUFAXKUH
      UIUKZHNZONZXQPNZQRZUFAXAUFUAUBIXBUGULZXFXJAYAXDXHXEXIQYAXCXGOXBUGHUJZSYAX
      CXGPYBSUMUNXBXKULZXFXOAYCXDXMXEXNQYCXCXLOXBXKHUJZSYCXCXLPYDSUMUNXBXPULZXF
      XTAYEXDXRXEXSQYEXCXQOXBXPHUJZSYEXCXQPYFSUMUNXBIULZXFXAAYGXDWSXEWTQYGXCWRO
      XBIHUJZSYGXCWRPYHSUMUNAUGUHXHXIQUGUHQRAUOUPAXHUGUHUQZONUGAXGYIOABCDEFGHJK
      LMURZSUGUHUSUTVAVBAXIYIPNUHAXGYIPYJSUGUHUSUTVDVBVCXKUCUDZAXOXTAYKXOXTUFAY
      KXOXTAYKXOVEZVEZXMXNUQZXPGNZEUKZONZYPPNZXRXSQYMXMYQVFRYQYRQRYRXNVFRYMBCXM
      XNEFGYOYQYRAVGTGVHZYLJVIAEBCTTVJZTFBUEZONZUUAPNZUIUKVKVLUKFUEZCUEQRUUBUUD
      UQUUDUUCUIUKVKVLUKUUCUQVMVRVNULYLKVIYMXLYTUDZXMTUDAYKUUEXOAUCYTXKHABCDEFG
      HJKLMVOVPVQZXLTTVSWIYMUUEXNTUDUUFXLTTVTWIAYKYOTUDZXOAYSXPVGUDUUGYKJXKWAVG
      TXPGWBWCVQYQWDYRWDAYKXOWEWFWGYMXQYPOYMXQXLYOEUKZYPAYKXQUUHULXOABCDEFGHXKJ
      KLMWHVQYMXLYNYOEYMUUEXLYNULUUFXLTTWJWIWKWLZSYMXQYPPUUISVCWMWNWOWPWQ $.

    ${
      ruclem9.6 $e |- ( ph -> M e. NN0 ) $.
      ruclem9.7 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      $( Lemma for ~ ruc .  The first components of the ` G ` sequence are
         increasing, and the second components are decreasing.  (Contributed by
         Mario Carneiro, 28-May-2014.) $)
      ruclem9 $p |- ( ph -> ( ( 1st ` ( G ` M ) ) <_ ( 1st ` ( G ` N ) ) /\
                              ( 2nd ` ( G ` N ) ) <_ ( 2nd ` ( G ` M ) ) ) ) $=
        ( cfv cle wbr cr vk vn cuz wcel c1st c2nd wa cv wi c1 caddc wceq fveq2d
        co fveq2 breq2d breq1d anbi12d imbi2d cz cxp cn0 ruclem6 ffvelrnd xp1st
        syl leidd xp2nd jca a1i cop clt cn wf adantr cdiv cif csb cmpt2 eluznn0
        sylan nn0p1nn eqid ruclem8 syldan ruclem2 simp1d ruclem7 1st2nd2 oveq1d
        c2 eqtrd breqtrrd peano2nn0 syl3anc mpan2d simp3d eqbrtrd mpand anim12d
        letr expcom a2d uzind4 mpcom ) JIUCQZUDAIHQZUEQZJHQZUEQZRSZXIUFQZXGUFQZ
        RSZUGZPAXHUAUHZHQZUEQZRSZXQUFQZXMRSZUGZUIAXHXHRSZXMXMRSZUGZUIZAXHUBUHZH
        QZUEQZRSZYHUFQZXMRSZUGZUIAXHYGUJUKUNZHQZUEQZRSZYOUFQZXMRSZUGZUIAXOUIUAU
        BIJXPIULZYBYEAUUAXSYCYAYDUUAXRXHXHRUUAXQXGUEXPIHUOZUMUPUUAXTXMXMRUUAXQX
        GUFUUBUMUQURUSXPYGULZYBYMAUUCXSYJYAYLUUCXRYIXHRUUCXQYHUEXPYGHUOZUMUPUUC
        XTYKXMRUUCXQYHUFUUDUMUQURUSXPYNULZYBYTAUUEXSYQYAYSUUEXRYPXHRUUEXQYOUEXP
        YNHUOZUMUPUUEXTYRXMRUUEXQYOUFUUFUMUQURUSXPJULZYBXOAUUGXSXKYAXNUUGXRXJXH
        RUUGXQXIUEXPJHUOZUMUPUUGXTXLXMRUUGXQXIUFUUHUMUQURUSYFIUTUDAYCYDAXHAXGTT
        VAZUDZXHTUDZAVBUUIIHABCDEFGHKLMNVCZOVDZXGTTVEVFZVGAXMAUUJXMTUDZUUMXGTTV
        HVFZVGVIVJYGXFUDZAYMYTAUUQYMYTUIAUUQUGZYJYQYLYSUURYJYIYPRSZYQUURYIYIYKV
        KZYNGQZEUNZUEQZYPRUURYIUVCRSZUVCUVBUFQZVLSZUVEYKRSZUURBCYIYKEFGUVAUVCUV
        EAVMTGVNUUQKVOZAEBCUUITFBUHZUEQZUVIUFQZUKUNWKVPUNFUHZCUHVLSUVJUVLVKUVLU
        VKUKUNWKVPUNUVKVKVQVRVSULUUQLVOUURYHUUIUDZYITUDZUURVBUUIYGHAVBUUIHVNUUQ
        UULVOZAIVBUDUUQYGVBUDZOYGIVTWAZVDZYHTTVEVFZUURUVMYKTUDZUVRYHTTVHVFZUURV
        MTYNGUVHUURUVPYNVMUDUVQYGWBVFVDUVCWCUVEWCAUUQUVPYIYKVLSUVQABCDEFGHYGKLM
        NWDWEWFZWGUURYOUVBUEUURYOYHUVAEUNZUVBAUUQUVPYOUWCULUVQABCDEFGHYGKLMNWHW
        EUURYHUUTUVAEUURUVMYHUUTULUVRYHTTWIVFWJWLZUMWMUURUUKUVNYPTUDZYJUUSUGYQU
        IAUUKUUQUUNVOUVSUURYOUUIUDZUWEUURVBUUIYNHUVOUURUVPYNVBUDUVQYGWNVFVDZYOT
        TVEVFXHYIYPXAWOWPUURYRYKRSZYLYSUURYRUVEYKRUURYOUVBUFUWDUMUURUVDUVFUVGUW
        BWQWRUURYRTUDZUVTUUOUWHYLUGYSUIUURUWFUWIUWGYOTTVHVFUWAAUUOUUQUUPVOYRYKX
        MXAWOWSWTXBXCXDXE $.
    $}

    ${
      ruclem10.6 $e |- ( ph -> M e. NN0 ) $.
      ruclem10.7 $e |- ( ph -> N e. NN0 ) $.
      $( Lemma for ~ ruc .  Every first component of the ` G ` sequence is less
         than every second component.  That is, the sequences form a chain a_1
         ` < ` a_2 ` < ` ... ` < ` b_2 ` < ` b_1, where a_i are the first
         components and b_i are the second components.  (Contributed by Mario
         Carneiro, 28-May-2014.) $)
      ruclem10 $p |- ( ph -> ( 1st ` ( G ` M ) ) < ( 2nd ` ( G ` N ) ) ) $=
        ( cfv wbr cr wcel c1st cle cif c2nd cxp cn0 ruclem6 ffvelrnd xp1st ifcl
        syl syl2anc xp2nd cuz nn0red max1 cz wb nn0zd mpbird ruclem9 simpld clt
        eluz ruclem8 mpdan max2 simprd ltletrd lelttrd ) AIHQZUAQZIJUBRZJIUCZHQ
        ZUAQZJHQZUDQZAVKSSUEZTVLSTAUFVSIHABCDEFGHKLMNUGZOUHVKSSUIUKAVOVSTZVPSTA
        UFVSVNHVTAJUFTIUFTVNUFTZPOVMJIUFUJULZUHZVOSSUIUKZAVQVSTVRSTAUFVSJHVTPUH
        VQSSUMUKZAVLVPUBRVOUDQZVKUDQUBRABCDEFGHIVNKLMNOAVNIUNQTZIVNUBRZAISTZJST
        ZWIAIOUOZAJPUOZIJUPULAIUQTVNUQTZWHWIURAIOUSAVNWCUSZIVNVDULUTVAVBAVPWGVR
        WEAWAWGSTWDVOSSUMUKWFAWBVPWGVCRWCABCDEFGHVNKLMNVEVFAVQUAQVPUBRWGVRUBRAB
        CDEFGHJVNKLMNPAVNJUNQTZJVNUBRZAWJWKWQWLWMIJVGULAJUQTWNWPWQURAJPUSWOJVNV
        DULUTVAVHVIVJ $.
    $}

    $( Lemma for ~ ruc .  Closure lemmas for supremum.  (Contributed by Mario
       Carneiro, 28-May-2014.) $)
    ruclem11 $p |- ( ph -> ( ran ( 1st o. G ) C_ RR /\ ran ( 1st o. G ) =/= (/)
                             /\ A. z e. ran ( 1st o. G ) z <_ 1 ) ) $=
      ( cr c0 c1 cn0 syl cc0 cfv vn c1st ccom crn wss wne cv cle wbr wf ruclem6
      wral cxp 1stcof frn cdm wceq wcel 0nn0 ne0i mp1i eqnetrd dm0rn0 necon3bii
      fdm sylib wa fvco3 sylan clt c2nd cn adantr caddc co c2 cop cif csb cmpt2
      cdiv simpr a1i ruclem10 ruclem4 fveq2d elexi 1ex syl6eq breqtrd ffvelrnda
      op2nd wi xp1st 1re ltle sylancl mpd eqbrtrd ralrimiva wfn ffn breq1 ralrn
      wb mpbird 3jca ) AUBIUCZUDZNUEZXIOUFZDUGZPUHUIZDXIULZAQNXHUJZXJAQNNUMZIUJ
      ZXOABCEFGHIJKLMUKZQNNIUNRZQNXHUORAXHUPZOUFXKAXTQOAXOXTQUQXSQNXHVERSQURZQO
      UFAUSQSUTVAVBXTOXIOXHVCVDVFAXNUAUGZXHTZPUHUIZUAQULZAYDUAQAYBQURZVGZYCYBIT
      ZUBTZPUHAXQYFYCYIUQXRQXPYBUBIVHVIYGYIPVJUIZYIPUHUIZYGYISITZVKTZPVJYGBCEFG
      HIYBSAVLNHUJYFJVMAFBCXPNGBUGZUBTZYNVKTZVNVOVPWAVOGUGZCUGVJUIYOYQVQYQYPVNV
      OVPWAVOYPVQVRVSVTUQYFKVMLMAYFWBYAYGUSWCWDAYMPUQYFAYMSPVQZVKTPAYLYRVKABCEF
      GHIJKLMWEWFSPSQUSWGWHWLWIVMWJYGYINURZPNURYJYKWMYGYHXPURYSAQXPYBIXRWKYHNNW
      NRWOYIPWPWQWRWSWTAXHQXAZXNYEXEAXOYTXSQNXHXBRXMYDDUAQXHXLYCPUHXCXDRXFXG $.

    ruc.6 $e |- S = sup ( ran ( 1st o. G ) , RR , < ) $.
    $( Lemma for ~ ruc .  The supremum of the increasing sequence ` 1st o. G `
       is a real number that is not in the range of ` F ` .  (Contributed by
       Mario Carneiro, 28-May-2014.) $)
    ruclem12 $p |- ( ph -> S e. ( RR \ ran F ) ) $=
      ( vz cr wbr wcel cfv cn0 vn vk crn c1st ccom clt csup wss c0 wne cle wral
      cv wrex c1 ruclem11 simp1d simp2d 1re simp3d breq2 ralbidv rspcev sylancr
      wceq suprcl syl3anc syl5eqel cn wa wo c2nd cmin co cop wf adantr caddc c2
      cxp cdiv cif csb cmpt2 ruclem6 nnm1nn0 ffvelrn syl2an xp1st syl ffvelrnda
      xp2nd eqid ruclem8 sylan2 ruclem3 ruclem7 nncn adantl ax-1cn npcan fveq2d
      cc sylancl 1st2nd2 oveq12d 3eqtr3d breq2d breq1d orbi12d mpbird nnnn0 wfn
      fvco3 1stcof ffn 3syl fnfvelrn syl2anc eqeltrrd suprub syl31anc syl6breqr
      wi ltletr mpan2d sylan simpr ruclem10 ltled eqbrtrd ralrimiva breq1 ralrn
      wb suprleub syl5eqbr lelttr mpand orim12d mpd lttri2d neneqd nrexdv eqeq1
      risset rexrn syl5bb mtbird eldifd ) AFPHUCZAFUDIUEZUCZPUFUGZPNAUUMPUHZUUM
      UIUJZOUMZUAUMZUKQZOUUMULZUAPUNZUUNPRAUUOUUPUUQUOUKQZOUUMULZABCODEGHIJKLMU
      PZUQZAUUOUUPUVCUVDURZAUOPRUVCUVAUSAUUOUUPUVCUVDUTUUTUVCUAUOPUURUOVEUUSUVB
      OUUMUURUOUUQUKVAVBVCVDZUAOUUMVFVGVHZAFUUKRZUURHSZFVEZUAVIUNZAUVKUAVIAUURV
      IRZVJZUVJFUVNUVJFUJUVJFUFQZFUVJUFQZVKZUVNUVJUURISZUDSZUFQZUVRVLSZUVJUFQZV
      KZUVQUVNUWCUVJUURUOVMVNZISZUDSZUWEVLSZVOZUVJEVNZUDSZUFQZUWIVLSZUVJUFQZVKU
      VNBCUWFUWGEGHUVJUWJUWLAVIPHVPZUVMJVQZAEBCPPVTZPGBUMZUDSZUWQVLSZVRVNVSWAVN
      GUMZCUMUFQUWRUWTVOUWTUWSVRVNVSWAVNUWSVOWBWCWDVEZUVMKVQZUVNUWEUWPRZUWFPRAT
      UWPIVPZUWDTRZUXCUVMABCDEGHIJKLMWEZUURWFZTUWPUWDIWGWHZUWEPPWIWJUVNUXCUWGPR
      UXHUWEPPWLWJAVIPUURHJWKZUWJWMUWLWMUVMAUXEUWFUWGUFQUXGABCDEGHIUWDJKLMWNWOW
      PUVNUVTUWKUWBUWMUVNUVSUWJUVJUFUVNUVRUWIUDUVNUWDUOVRVNZISZUWEUXJHSZEVNZUVR
      UWIUVMAUXEUXKUXMVEUXGABCDEGHIUWDJKLMWQWOUVNUXJUURIUVNUURXCRZUOXCRUXJUURVE
      UVMUXNAUURWRWSWTUURUOXAXDZXBUVNUWEUWHUXLUVJEUVNUXCUWEUWHVEUXHUWEPPXEWJUVN
      UXJUURHUXOXBXFXGZXBXHUVNUWAUWLUVJUFUVNUVRUWIVLUXPXBXIXJXKUVNUVTUVOUWBUVPU
      VNUVTUVSFUKQZUVOUVNUVSUUNFUKUVNUUOUUPUVAUVSUUMRUVSUUNUKQAUUOUVMUVEVQZAUUP
      UVMUVFVQZAUVAUVMUVGVQZUVNUURUULSZUVSUUMAUXDUURTRZUYAUVSVEUVMUXFUURXLZTUWP
      UURUDIXNWHUVNUULTXMZUYBUYAUUMRUVNUXDTPUULVPUYDAUXDUVMUXFVQZTPPIXOTPUULXPX
      QZUVMUYBAUYCWSZTUURUULXRXSXTUAOUUMUVSYAYBNYCUVNUVJPRZUVSPRZFPRZUVTUXQVJUV
      OYDUXIUVNUVRUWPRZUYIAUXDUYBUYKUVMUXFUYCTUWPUURIWGWHZUVRPPWIWJAUYJUVMUVHVQ
      ZUVJUVSFYEVGYFUVNFUWAUKQZUWBUVPUVNFUUNUWAUKNUVNUUNUWAUKQZUUQUWAUKQZOUUMUL
      ZUVNUYQUBUMZUULSZUWAUKQZUBTULZUVNUYTUBTUVNUYRTRZVJZUYSUYRISZUDSZUWAUKUVNU
      XDVUBUYSVUEVEUYETUWPUYRUDIXNYGVUCVUEUWAVUCVUDUWPRVUEPRUVNTUWPUYRIUYEWKVUD
      PPWIWJUVNUWAPRZVUBUVNUYKVUFUYLUVRPPWLWJZVQVUCBCDEGHIUYRUURUVNUWNVUBUWOVQU
      VNUXAVUBUXBVQLMUVNVUBYHUVNUYBVUBUYGVQYIYJYKYLUVNUYDUYQVUAYOUYFUYPUYTOUBTU
      ULUUQUYSUWAUKYMYNWJXKUVNUUOUUPUVAVUFUYOUYQYOUXRUXSUXTVUGUAOOUUMUWAYPYBXKY
      QUVNUYJVUFUYHUYNUWBVJUVPYDUYMVUGUXIFUWAUVJYRVGYSYTUUAUVNUVJFUXIUYMUUBXKUU
      CUUDUVIUUQFVEZOUUKUNZAUVLOFUUKUUFAUWNHVIXMVUIUVLYOJVIPHXPVUHUVKOUAVIHUUQU
      VJFUUEUUGXQUUHUUIUUJ $.

  $}

  ${
    $d d k m w x y z F $.
    $( Lemma for ~ ruc .  There is no function that maps ` NN ` onto ` RR ` .
       (Use ~ nex if you want this in the form
       ` -. E. f f : NN -onto-> RR ` .)  (Contributed by NM, 14-Oct-2004.)
       (Proof shortened by Fan Zheng, 6-Jun-2016.) $)
    ruclem13 $p |- -. F : NN -onto-> RR $=
      ( vd vx vy vm cn cr crn cdif c0 wceq cv c1st cfv caddc cop reex cc0 eqid
      co wfo forn difeq2d difid syl6eq cxp c2nd c2 clt wbr cif csb cmpt2 wex wn
      cdiv xpex mpt2ex isseti wa c1 csn cun cseq ccom csup wcel wf adantr simpr
      fof ruclem12 n0i syl ex exlimdv mpi pm2.65i ) FGAUAZGAHZIZJKZVSWAGGIJVSVT
      GGFGAUBUCGUDUEVSBLZCDGGUFZGECLZMNZWEUGNZOTUHUPTELZDLUIUJWFWHPWHWGOTUHUPTW
      GPUKULZUMZKZBUNWBUOZBWJCDWDGWIGGQQUQQURUSVSWKWLBVSWKWLVSWKUTZMWCRRVAPPVBA
      VCZRVDZVEHGUIVFZWAVGWLWMCDWNWCWPEAWOVSFGAVHWKFGAVKVIVSWKVJWNSWOSWPSVLWAWP
      VMVNVOVPVQVR $.
  $}

  $( The set of natural numbers is strictly dominated by the set of real
     numbers, i.e. the real numbers are uncountable.  The proof consists of
     lemmas ~ ruclem1 through ~ ruclem13 and this final piece.  Our proof is
     based on the proof of Theorem 5.18 of [Truss] p. 114.  See ~ ruclem13 for
     the function existence version of this theorem.  For an informal
     discussion of this proof, see
     ~ http://us.metamath.org/mpeuni/mmcomplex.html#uncountable .  For an
     alternate proof see ~ rucALT .  (Contributed by NM, 13-Oct-2004.) $)
  ruc $p |- NN ~< RR $=
    ( vf cn cr csdm wbr cdom cen wn cvv wcel wss reex nnssre ssdomg mp2 cv wf1o
    wex wfo ruclem13 f1ofo mto nex bren mtbir brsdom mpbir2an ) BCDEBCFEZBCGEZH
    CIJBCKUHLMBCINOUIBCAPZQZARUKAUKBCUJSUJTBCUJUAUBUCBCAUDUEBCUFUG $.

  $( The set of rationals is strictly less equinumerous than the set of reals
     ( ` RR ` strictly dominates ` QQ ` ).  (Contributed by NM,
     18-Dec-2004.) $)
  resdomq $p |- QQ ~< RR $=
    ( cq cn cen wbr cr csdm qnnen ruc ensdomtr mp2an ) ABCDBEFDAEFDGHABEIJ $.

  $( There are at least aleph-one real numbers.  (Contributed by NM,
     2-Feb-2005.) $)
  aleph1re $p |- ( aleph ` 1o ) ~<_ RR $=
    ( c1o cale cfv cr cdom wbr csdm wn c0 csuc cn cen com aleph0 nnenom eqbrtri
    ensymi mp2an cvv wcel ruc ensdomtr alephnbtwn2 mpto1 df-1o fveq2i breq2i wb
    mtbir fvex reex domtri mpbir ) ABCZDEFZDUNGFZHZUPDIJZBCZGFZIBCZDGFZUTVAKLFK
    DGFVBVAMKLNKMOQPUAVAKDUBRIDUCUDUNUSDGAURBUEUFUGUIUNSTDSTUOUQUHABUJUKUNDSSUL
    RUM $.

  $( There are at least aleph-one irrationals.  (Contributed by NM,
     2-Feb-2005.) $)
  aleph1irr $p |- ( aleph ` 1o ) ~<_ ( RR \ QQ ) $=
    ( c1o cale cfv cr cdom wbr cq cdif cen aleph1re ccrd cdm wcel com cvv ax-mp
    csdm cn ensymi mp2an reex numth3 nnenom ruc ensdomtr sdomdom resdomq infdif
    mp3an domentr ) ABCZDEFDDGHZIFUKULEFJULDDKLMZNDEFZGDQFULDIFDOMUMUADOUBPNDQF
    ZUNNRIFRDQFUORNUCSUDNRDUETNDUFPUGDGUHUISUKDULUJT $.

  ${
    $d a b c d e x $.
    $( The complex numbers can be linearly ordered.  (Contributed by Stefan
       O'Rear, 16-Nov-2014.) $)
    cnso $p |- E. x x Or CC $=
      ( va vb vd vc ve cr cc cv wf1o wex wor wbr cfv wceq wa clt wrex syl cnex
      cen cn cpw rpnnen cpnnen entr4i bren mpbi copab cxp cin ltso wiso wb eqid
      f1oiso mpan2 isoso soinxp syl6bb mpbii inex2 soeq1 spcev exlimiv ax-mp
      xpex ) GHBIZJZBKZHAIZLZAKZGHUAMVJGUBUCHUDUEUFGHBUGUHVIVMBVIHCIDIZVHNOEIFI
      ZVHNOPVNVOQMPFGRDGRCEUIZHHUJZUKZLZVMVIGQLZVSULVIGHQVPVHUMZVTVSUNVIVPVPOWA
      VPUODFCEGHQVPVHUPUQWAVTHVPLVSGHQVPVHURHVPUSUTSVAVLVSAVRVQVPHHTTVGVBHVKVRV
      CVDSVEVF $.
  $}

$(
###############################################################################
                       ELEMENTARY NUMBER THEORY
###############################################################################

Here we introduce elementary number theory, in particular the
elementary properties of divisibility and elementary prime number theory.
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
            Elementary properties of divisibility
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Irrationality of square root of 2
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    sqr2irrlem.1 $e |- ( ph -> A e. ZZ ) $.
    sqr2irrlem.2 $e |- ( ph -> B e. NN ) $.
    sqr2irrlem.3 $e |- ( ph -> ( sqr ` 2 ) = ( A / B ) ) $.
    $( Lemma for irrationality of square root of 2.  The core of the proof - if
       ` A / B = sqr ( 2 ) ` , then ` A ` and ` B ` are even, so ` A / 2 ` and
       ` B / 2 ` are smaller representatives, which is absurd by the method of
       infinite descent (here implemented by strong induction).  (Contributed
       by NM, 20-Aug-2001.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
    sqr2irrlem $p |- ( ph -> ( ( A / 2 ) e. ZZ /\ ( B / 2 ) e. NN ) ) $=
      ( c2 cdiv co cz wcel cn cexp cmul 2cn oveq1d nncnd nnne0d eqtrd syl sqrth
      csqr cfv cc wceq ax-mp syl5eqr zcnd sqdivd sqcld nnsqcld divcan1d a1i cc0
      wne 2ne0 divcan3d eqtr3d eqeltrd nnzd zesq mpbird clt wbr sqvali divdiv1d
      oveq2i 3eqtr4a zsqcl eqeltrrd nnrpd rphalfcld rpgt0d elnnz sylanbrc nnesq
      wb jca ) ABGHIZJKZCGHILKZAVTBGMIZGHIZJKZAWCAWCCGMIZLAGWENIZGHIWCWEAWFWBGH
      AWFWBWEHIZWENIWBAGWGWENAGBCHIZGMIZWGAGGUBUCZGMIZWIGUDKZWKGUEOGUAUFAWJWHGM
      FPUGABCABDUHZACEQACERUISPAWBWEABWMUJZAWEACEUKZQZAWEWORULSPAWEGWPWLAOUMZGU
      NUOAUPUMZUQURZWOUSUTABJKVTWDVQDBVATVBZAWAWEGHIZLKZAXAJKUNXAVCVDXBAVSGMIZX
      AJAXCWCGHIZXAAWBGGMIZHIWBGGNIZHIXCXDXEXFWBHGOVEVGABGWMWQWRUIAWBGGWNWQWQWR
      WRVFVHAWCWEGHWSPSAVTXCJKWTVSVITVJAXAAWEAWEWOVKVLVMXAVNVOACLKWAXBVQECVPTVB
      VR $.
  $}

  ${
    $d n x y z $.
    $( The square root of 2 is irrational.  See ~ zsqrelqelz for a
       generalization to all non-square integers.  The proof's core is proven
       in ~ sqr2irrlem , which shows that if ` A / B = sqr ( 2 ) ` , then ` A `
       and ` B ` are even, so ` A / 2 ` and ` B / 2 ` are smaller
       representatives, which is absurd.  An older version of this proof was
       included in _The Seventeen Provers of the World_ compiled by Freek
       Wiedijk.  It is also the first "top 100" mathematical theorems whose
       formalization is tracked by Freek Wiedijk on his _Formalizing 100
       Theorems_ page at ~ http://www.cs.ru.nl/~~freek/100/ .  (Contributed by
       NM, 8-Jan-2002.)  (Proof shortened by Mario Carneiro, 12-Sep-2015.) $)
    sqr2irr $p |- ( sqr ` 2 ) e/ QQ $=
      ( vx vy vz c2 wcel cv cdiv co wceq cz wrex cn c1 clt wbr wne wral ralbidv
      wi wa vn csqr cfv cq caddc peano2nn breq2 imbi1d nnnlt1 pm2.21d rgen nnrp
      wn crp rphalflt syl breq1 oveq2 neeq2d imbi12d rspcv com13 simpr ad2antlr
      cc zcn nncn ad2antrr 2cn a1i cc0 nnne0 2ne0 divcan7d eqtr4d simplr simpll
      sqr2irrlem simprd simpld oveq1 embantd necon2bd mpd ex necon2ad ralrimdva
      syld cbvralv syl6ibr ceqsralv sylibrd ancld wo wb cle nnleltp1 nnre leloe
      syl2an bitr3d ancoms jaob syl6bb ralbidva r19.26 nnind ltp1d df-ne ralnex
      cr mp2d nrex elq rexcom bitri mtbir nelir ) DUBUCZUDXSUDEZXSAFZBFZGHZIZAJ
      KZBLKZYEBLYBLEZCFZYBMUEHZNOZXSYAYHGHZPZAJQZSZCLQZYBYINOZYEUMZYGYILEYOYBUF
      YHUAFZNOZYMSZCLQYHMNOZYMSZCLQYHYBNOZYMSZCLQZYOYOUABYIYRMIZYTUUBCLUUFYSUUA
      YMYRMYHNUGUHRYRYBIZYTUUDCLUUGYSUUCYMYRYBYHNUGUHRYRYIIZYTYNCLUUHYSYJYMYRYI
      YHNUGUHRZUUIUUBCLYHLEZUUAYMYHUIUJUKYGUUEUUEYHYBIZYMSZCLQZTZYOYGUUEUUMYGUU
      EXSYCPZAJQZUUMYGUUEXSYHYBGHZPZCJQZUUPYGUUEYBDGHZLEZXSYAUUTGHZPZAJQZSZUUSY
      GUUTYBNOZUUEUVESYGYBUNEUVFYBULYBUOUPUVAUUEUVFUVDUUDUVFUVDSCUUTLYHUUTIZUUC
      UVFYMUVDYHUUTYBNUQUVGYLUVCAJUVGYKUVBXSYHUUTYAGURUSRUTVAVBUPYGUVEUURCJYGYH
      JEZTZUVEXSUUQUVIXSUUQIZUVEUMZUVIUVJTZXSYHDGHZUUTGHZIUVKUVLXSUUQUVNUVIUVJV
      CZUVLYHYBDUVHYHVEEYGUVJYHVFVDYGYBVEEUVHUVJYBVGVHDVEEUVLVIVJYGYBVKPUVHUVJY
      BVLVHDVKPUVLVMVJVNVOUVLUVEXSUVNUVLUVAUVDXSUVNPZUVLUVMJEZUVAUVLYHYBYGUVHUV
      JVPYGUVHUVJVQUVOVRZVSUVLUVQUVDUVPSUVLUVQUVAUVRVTUVCUVPAUVMJYAUVMIUVBUVNXS
      YAUVMUUTGWAUSVAUPWBWCWDWEWFWGWHUUOUURACJYAYHIYCUUQXSYAYHYBGWAUSWIWJYMUUPC
      YBLUUKYLUUOAJUUKYKYCXSYHYBYAGURUSZRWKWLWMYGYOUUDUULTZCLQUUNYGYNUVTCLYGUUJ
      TZYNUUCUUKWNZYMSUVTUWAYJUWBYMUUJYGYJUWBWOUUJYGTYHYBWPOZYJUWBYHYBWQUUJYHXK
      EYBXKEUWCUWBWOYGYHWRYBWRZYHYBWSWTXAXBUHUUCYMUUKXCXDXEUUDUULCLXFXDWLXGUPYG
      YBUWDXHYNYPYQSCYBLUUKYJYPYMYQYHYBYINUQUUKYMYDUMZAJQYQUUKYLUWEAJUUKYLUUOUW
      EUVSXSYCXIXDRYDAJXJXDUTVAXLXMXTYDBLKAJKYFABXSXNYDABJLXOXPXQXR $.
  $}

  $( The square root of 2 exists and is a real number.  (Contributed by NM,
     3-Dec-2004.) $)
  sqr2re $p |- ( sqr ` 2 ) e. RR $=
    ( c2 2re 2pos sqrpclii ) ABCD $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Some Number sets are chains of proper subsets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( The sequence ` NN ` , ` ZZ ` , ` QQ ` , ` RR ` , and ` CC ` forms a
       chain of proper subsets.  In each case the proper subset relationship is
       shown by demonstrating a number that belongs to one set but not the
       other.  We show that zero belongs to ` ZZ ` but not ` NN ` , one-half
       belongs to ` QQ ` but not ` ZZ ` , the square root of 2 belongs to
       ` RR ` but not ` QQ ` , and finally that the imaginary number ` _i `
       belongs to ` CC ` but not ` RR ` .  See ~ nthruz for a further
       refinement.  (Contributed by NM, 12-Jan-2002.) $)
    nthruc $p |- ( ( NN C. ZZ /\ ZZ C. QQ ) /\ ( QQ C. RR /\ RR C. CC ) ) $=
      ( cn cz wpss cq wa cr cc wss cc0 wcel wn nnssz 0z 0nnn pm3.2i ssnelpss c1
      mp2 c2 ci cdiv co zssq 2nn znq mp2an halfnz csqr cfv qssre sqr2re sqr2irr
      1z neli ax-resscn ax-icn inelr ) ABCZBDCZEDFCZFGCZEURUSABHIBJZIAJKZEURLVB
      VCMNOABIPRBDHQSUAUBZDJZVDBJKZEUSUCVEVFQBJSAJVEUMUDQSUEUFUGOBDVDPROUTVADFH
      SUHUIZFJZVGDJKZEUTUJVHVIUKVGDULUNODFVGPRFGHTGJZTFJKZEVAUOVJVKUPUQOFGTPROO
      $.
  $}

  ${
    $( The sequence ` NN ` , ` NN0 ` , and ` ZZ ` forms a chain of proper
       subsets.  In each case the proper subset relationship is shown by
       demonstrating a number that belongs to one set but not the other.  We
       show that zero belongs to ` NN0 ` but not ` NN ` and minus one belongs
       to ` ZZ ` but not ` NN0 ` .  This theorem refines the chain of proper
       subsets ~ nthruc .  (Contributed by NM, 9-May-2004.) $)
    nthruz $p |- ( NN C. NN0 /\ NN0 C. ZZ ) $=
      ( cn cn0 wpss cz wss cc0 wcel wn wa nnssnn0 0nn0 0nnn pm3.2i ssnelpss mp2
      c1 cneg nn0ssz clt wbr 1nn nnnegz ax-mp neg0 eqbrtri 1re ltnegcon1i mpbir
      0lt1 0re nn0nlt0 mt2 ) ABCZBDCZABEFBGZFAGHZIUMJUOUPKLMABFNOBDEPQZDGZUQBGZ
      HZIUNRURUTPAGURUAPUBUCUSUQFSTZVAFQZPSTVBFPSUDUIUEPFUFUJUGUHUQUKULMBDUQNOM
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             The divides relation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c || $.

  $( Extend the definition of a class to include the divides relation.  See
     ~ df-dvds . $)
  cdivides $a class || $.

  ${
    $d n x y $.
    $( Define the divides relation.  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    df-dvds $a |- || = { <. x , y >. | ( ( x e. ZZ /\ y e. ZZ ) /\
                                            E. n e. ZZ ( n x. x ) = y ) } $.
  $}

  ${
    $d M n x y $.  $d N n x y $.
    $( Define the divides relation. ` M || N ` means ` M ` divides into ` N `
       with no remainder.  For example, ` 3 || 6 ` ( ~ ex-dvds ).  As proven in
       ~ dvdsval3 , ` M || N <-> ( N mod M ) = 0 ` .  See ~ divides and
       ~ dvdsval2 for other equivalent expressions.  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    divides $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                    ( M || N <-> E. n e. ZZ ( n x. M ) = N ) ) $=
      ( vx vy cdivides wbr cop cv cz wcel wa cmul wceq wrex copab df-br df-dvds
      co rexbidv eleq2i bitri oveq2 eqeq1d eqeq2 opelopab2 syl5bb ) BCFGZBCHZDI
      ZJKEIZJKLAIZUJMSZUKNZAJOZLDEPZKZBJKCJKLULBMSZCNZAJOZUHUIFKUQBCFQFUPUIDEAR
      UAUBUOURUKNZAJOUTDEBCJJUJBNZUNVAAJVBUMURUKUJBULMUCUDTUKCNVAUSAJUKCURUETUF
      UG $.
  $}

  ${
    $d k M $.  $d k N $.
    $( One nonzero integer divides another integer if and only if their
       quotient is an integer.  (Contributed by Jeff Hankins, 29-Sep-2013.) $)
    dvdsval2 $p |- ( ( M e. ZZ /\ M =/= 0 /\ N e. ZZ ) ->
      ( M || N <-> ( N / M ) e. ZZ ) ) $=
      ( vk cz wcel cc0 wne w3a cdivides wbr cv cmul co wceq wrex cdiv wa cc zcn
      adantr wb divides 3adant2 3ad2ant3 adantl 3ad2ant1 simpl2 divmul3d syl6bb
      eqcom biimprd simprl eqeltrd rexlimdvaa simpr simp2 divcan1d oveq1 eqeq1d
      impr rspcev syl2anc ex impbid bitrd ) ADEZAFGZBDEZHZABIJZCKZALMZBNZCDOZBA
      PMZDEZVFVHVJVNUAVGCABUBUCVIVNVPVIVMVPCDVIVKDEZVMQQVOVKDVIVQVMVOVKNZVIVQQZ
      VRVMVSVRBVLNVMVSBVKAVIBREZVQVHVFVTVGBSUDZTVQVKREVIVKSUEVIAREZVQVFVGWBVHAS
      UFZTVFVGVHVQUGUHBVLUJUIUKUTVIVQVMULUMUNVIVPVNVIVPQVPVOALMZBNZVNVIVPUOVIWE
      VPVIBAWAWCVFVGVHUPUQTVMWECVODVKVONVLWDBVKVOALURUSVAVBVCVDVE $.
  $}

  ${
    $d k M $.  $d k N $.
    $( One nonzero integer divides another integer if and only if the remainder
       upon division is zero.  (Contributed by Mario Carneiro, 22-Feb-2014.)
       (Revised by Mario Carneiro, 15-Jul-2014.) $)
    dvdsval3 $p |- ( ( M e. NN /\ N e. ZZ ) ->
                     ( M || N <-> ( N mod M ) = 0 ) ) $=
      ( cn wcel cz wa cdivides wbr cdiv co cmo cc0 wceq wne wb nnz jca dvdsval2
      nnne0 3expa sylan cr crp zre nnrp mod0 syl2anr bitr4d ) ACDZBEDZFABGHZBAI
      JEDZBAKJLMZUIAEDZALNZFUJUKULOZUIUNUOAPASQUNUOUJUPABRTUAUJBUBDAUCDUMULOUIB
      UDAUEBAUFUGUH $.
  $}

  ${
    $d x y z $.
    $( Reverse closure for the divisibility relation.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    dvdszrcl $p |- ( X || Y -> ( X e. ZZ /\ Y e. ZZ ) ) $=
      ( vx vy vz cz cdivides cv wcel wa cmul co wceq copab cxp df-dvds opabssxp
      wrex eqsstri brel ) ABFFGGCHZFIDHZFIJEHUAKLUBMEFRZJCDNFFOCDEPUCCDFFQST $.
  $}

  $( Strong form of ~ dvdsval2 for natural numbers.  (Contributed by Stefan
     O'Rear, 13-Sep-2014.) $)
  nndivdvds $p |- ( ( A e. NN /\ B e. NN ) ->
    ( B || A <-> ( A / B ) e. NN ) ) $=
    ( cn wcel wa cdivides wbr cc0 cdiv co clt cz wne wb nnz adantl adantr nngt0
    cr nnre nnne0 dvdsval2 syl3anc anbi1d divgt0d biantrud elnnz a1i 3bitr4d )
    ACDZBCDZEZBAFGZHABIJZKGZEUNLDZUOEZUMUNCDZULUMUPUOULBLDZBHMZALDZUMUPNUKUSUJB
    OPUKUTUJBUAPUJVAUKAOQBAUBUCUDULUOUMULABUJASDUKATQUKBSDUJBTPUJHAKGUKARQUKHBK
    GUJBRPUEUFURUQNULUNUGUHUI $.

  $( Two ways to say ` A == B ( mod N ) ` .  (Contributed by Mario Carneiro,
     18-Feb-2014.) $)
  moddvds $p |- ( ( N e. NN /\ A e. ZZ /\ B e. ZZ ) ->
                  ( ( A mod N ) = ( B mod N ) <-> N || ( A - B ) ) ) $=
    ( wcel cz cmo co wceq wb wa cc0 caddc cr zre modadd1 3expia syl22anc oveq1d
    wi recnd cn cmin cdivides wbr crp nnrp adantr 0mod syl eqeq2d cneg ad2antrl
    ad2antll renegcld negsubd negidd eqeq12d sylibd resubcld 0re npcand addid2d
    a1i impbid zsubcl dvdsval3 sylan2 3bitr4d 3impb ) CUADZAEDZBEDZACFGZBCFGZHZ
    CABUBGZUCUDZIVJVKVLJZJZVPCFGZKCFGZHZVTKHZVOVQVSWAKVTVSCUEDZWAKHVJWDVRCUFUGZ
    CUHUIUJVSVOWBVSVOABUKZLGZCFGZBWFLGZCFGZHZWBVSAMDZBMDZWFMDZWDVOWKSVKWLVJVLAN
    ULZVLWMVJVKBNUMZVSBWPUNWEWLWMJWNWDJVOWKABWFCOPQVSWHVTWJWAVSWGVPCFVSABVSAWOT
    ZVSBWPTZUORVSWIKCFVSBWRUPRUQURVSWBVPBLGZCFGZKBLGZCFGZHZVOVSVPMDZKMDZWMWDWBX
    CSVSABWOWPUSXEVSUTVCWPWEXDXEJWMWDJWBXCVPKBCOPQVSWTVMXBVNVSWSACFVSABWQWRVARV
    SXABCFVSBWRVBRUQURVDVRVJVPEDVQWCIABVECVPVFVGVHVI $.

  ${
    $d K x $.  $d M x $.  $d N x $.
    $( A lemma to assist theorems of ` || ` with no antecedents.  (Contributed
       by Paul Chapman, 21-Mar-2011.) $)
    dvds0lem $p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\ ( K x. M ) = N ) ->
                     M || N ) $=
      ( vx cz wcel w3a cmul co wceq cdivides wbr wi wa wrex oveq1 eqeq1d rspcev
      cv adantl wb divides adantr mpbird expr 3impa 3comr imp ) AEFZBEFZCEFZGAB
      HIZCJZBCKLZUJUKUIUMUNMZUJUKUIUOUJUKNZUIUMUNUPUIUMNZNUNDSZBHIZCJZDEOZUQVAU
      PUTUMDAEURAJUSULCURABHPQRTUPUNVAUAUQDBCUBUCUDUEUFUGUH $.
  $}

  ${
    $d J x $.  $d K x $.  $d M x z $.  $d N x z $.  $d Z z $.  $d ph x $.
    dvds1lem.1 $e |- ( ph -> ( J e. ZZ /\ K e. ZZ ) ) $.
    dvds1lem.2 $e |- ( ph -> ( M e. ZZ /\ N e. ZZ ) ) $.
    dvds1lem.3 $e |- ( ( ph /\ x e. ZZ ) -> Z e. ZZ ) $.
    dvds1lem.4 $e |- ( ( ph /\ x e. ZZ ) ->
                       ( ( x x. J ) = K -> ( Z x. M ) = N ) ) $.
    $( A lemma to assist theorems of ` || ` with one antecedent.  (Contributed
       by Paul Chapman, 21-Mar-2011.) $)
    dvds1lem $p |- ( ph -> ( J || K -> M || N ) ) $=
      ( vz cv cmul co wceq cz wrex wcel wa cdivides wbr eqeq1d rspcev rexlimdva
      oveq1 ee12an wb divides syl 3imtr4d ) ABMZCNODPZBQRZLMZENOZFPZLQRZCDUAUBZ
      EFUAUBZAUMURBQAULQSTGQSUMGENOZFPZURJKUQVBLGQUOGPUPVAFUOGENUFUCUDUGUEACQSD
      QSTUSUNUHHBCDUIUJAEQSFQSTUTURUHILEFUIUJUK $.
  $}

  ${
    $d I x y $.  $d J x y $.  $d K x y $.  $d L x y $.  $d M x y z $.
    $d N x y z $.  $d Z z $.  $d ph x y $.
    dvds2lem.1 $e |- ( ph -> ( I e. ZZ /\ J e. ZZ ) ) $.
    dvds2lem.2 $e |- ( ph -> ( K e. ZZ /\ L e. ZZ ) ) $.
    dvds2lem.3 $e |- ( ph -> ( M e. ZZ /\ N e. ZZ ) ) $.
    dvds2lem.4 $e |- ( ( ph /\ ( x e. ZZ /\ y e. ZZ ) ) -> Z e. ZZ ) $.
    dvds2lem.5 $e |- ( ( ph /\ ( x e. ZZ /\ y e. ZZ ) ) ->
               ( ( ( x x. I ) = J /\ ( y x. K ) = L ) -> ( Z x. M ) = N ) ) $.
    $( A lemma to assist theorems of ` || ` with two antecedents.  (Contributed
       by Paul Chapman, 21-Mar-2011.) $)
    dvds2lem $p |- ( ph -> ( ( I || J /\ K || L ) -> M || N ) ) $=
      ( wa cmul wceq cz wcel vz cdivides cv co wrex wb divides bi2anan9 syl2anc
      wbr biimpd reeanv syl6ibr oveq1 eqeq1d rspcev rexlimdvva syld syl sylibrd
      ee12an ) ADEUBUJZFGUBUJZPZUAUCZHQUDZIRZUASUEZHIUBUJZAVDBUCZDQUDERZCUCZFQU
      DGRZPZCSUEBSUEZVHAVDVKBSUEZVMCSUEZPZVOAVDVRADSTESTPZFSTGSTPZVDVRUFKLVSVBV
      PVTVCVQBDEUGCFGUGUHUIUKVKVMBCSSULUMAVNVHBCSSAVJSTVLSTPPJSTVNJHQUDZIRZVHNO
      VGWBUAJSVEJRVFWAIVEJHQUNUOUPVAUQURAHSTISTPVIVHUFMUAHIUGUSUT $.
  $}

  $( An integer divides itself.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
  iddvds $p |- ( N e. ZZ -> N || N ) $=
    ( cz wcel c1 cmul co wceq cdivides wbr zcn mulid2d dvds0lem mp3anl1 anabsan
    1z mpdan ) ABCZDAEFAGZAAHIZQAAJKQRSDBCQQRSODAALMNP $.

  $( 1 divides any integer.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
  1dvds $p |- ( N e. ZZ -> 1 || N ) $=
    ( cz wcel c1 cmul co wceq cdivides wbr zcn mulid1d dvds0lem mp3anl2 anabsan
    1z mpdan ) ABCZADEFAGZDAHIZQAAJKQRSQDBCQRSOADALMNP $.

  $( Any integer divides 0.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
  dvds0 $p |- ( N e. ZZ -> N || 0 ) $=
    ( cz wcel cc0 cmul co cdivides wbr zcn mul02d wi 0z w3a dvds0lem ex mp3an13
    wceq mpd ) ABCZDAEFDQZADGHZSAAIJDBCZSUBTUAKLLUBSUBMTUADADNOPR $.

  ${
    $d M x $.  $d N x $.
    $( An integer divides another iff its negation does.  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    negdvdsb $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M || N <-> -u M || N ) ) $=
      ( vx cz wcel wa cdivides wbr cneg znegcl cmul co wceq zcn syl2anr adantlr
      cc eqeq1d biimprd dvds1lem cv id anim1i adantl mul2neg mulneg12 impbid )
      ADEZBDEZFZABGHAIZBGHUJCABUKBCUAZIZUJUBZUHUKDEUIAJUCZULDEZUMDEUJULJUDZUJUP
      FZUMUKKLZBMULAKLZBMURUSUTBUHUPUSUTMZUIUPULQEZAQEZVAUHULNZANZULAUEOPRSTUJC
      UKBABUMUOUNUQURUMAKLZBMULUKKLZBMURVFVGBUHUPVFVGMZUIUPVBVCVHUHVDVEULAUFOPR
      STUG $.

    $( An integer divides another iff it divides its negation.  (Contributed by
       Paul Chapman, 21-Mar-2011.) $)
    dvdsnegb $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M || N <-> M || -u N ) ) $=
      ( vx cz wcel wa cdivides wbr cneg cv id znegcl cmul co wi cc zcn dvds1lem
      wceq negeq anim2i adantl mulneg1 eqeq2d syl5ibcom syl2anr negneg sylan9eq
      adantlr sylan9eqr expr 3impa syl3an 3coml 3expa impbid ) ADEZBDEZFZABGHAB
      IZGHUSCABAUTCJZIZUSKZURUTDEUQBLUAZVADEZVBDEUSVALUBZUQVEVAAMNZBSZVBAMNZUTS
      ZOZURVEVAPEZAPEZVKUQVAQZAQZVLVMFZVIVGIZSVHVJVAAUCZVHVQUTVIVGBTUDUEUFUIRUS
      CAUTABVBVDVCVFUQURVEVGUTSZVIBSZOZVEUQURWAVEVLUQVMURBPEZWAVNVOBQVLVMWBWAVP
      WBVSVTVPWBVSFVIVQBVRVSWBVQUTIBVGUTTBUGUJUHUKULUMUNUORUP $.
  $}

  $( An integer divides another iff its absolute value does.  (Contributed by
     Paul Chapman, 21-Mar-2011.) $)
  absdvdsb $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                   ( M || N <-> ( abs ` M ) || N ) ) $=
    ( cz wcel wa cabs cfv wceq cdivides wbr wb cneg wi bicomd negdvdsb sylan9bb
    breq1 a1i ex wo zre absord adantr mpjaod ) ACDZBCDZEZAFGZAHZABIJZUHBIJZKZUH
    ALZHZUIULMUGUIUKUJUHABIQNRUGUNULUGUJUMBIJZUNUKABOUNUKUOUHUMBIQNPSUEUIUNTUFU
    EAAUAUBUCUD $.

  $( An integer divides another iff it divides its absolute value.
     (Contributed by Paul Chapman, 21-Mar-2011.) $)
  dvdsabsb $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                   ( M || N <-> M || ( abs ` N ) ) ) $=
    ( cz wcel wa cabs cfv wceq cdivides wbr wb cneg wi bicomd dvdsnegb sylan9bb
    breq2 a1i ex wo zre absord adantl mpjaod ) ACDZBCDZEZBFGZBHZABIJZAUHIJZKZUH
    BLZHZUIULMUGUIUKUJUHBAIQNRUGUNULUGUJAUMIJZUNUKABOUNUKUOUHUMAIQNPSUFUIUNTUEU
    FBBUAUBUCUD $.

  ${
    $d N n $.
    $( Only 0 is divisible by 0 .  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    0dvds $p |- ( N e. ZZ -> ( 0 || N <-> N = 0 ) ) $=
      ( vn cz wcel cc0 cdivides wbr wceq cv cmul co wrex wb 0z divides mpan zcn
      mul01d eqtr2 sylan2 ancoms rexlimiva syl6bi dvds0 ax-mp mpbiri impbid1
      breq2 ) ACDZEAFGZAEHZUIUJBIZEJKZAHZBCLZUKECDZUIUJUOMNBEAOPUNUKBCUNULCDZUK
      UQUNUMEHUKUQULULQRUMAESTUAUBUCUKUJEEFGZUPURNEUDUEAEEFUHUFUG $.
  $}

  $( An integer divides a multiple of itself.  (Contributed by Paul Chapman,
     21-Mar-2011.) $)
  dvdsmul1 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> M || ( M x. N ) ) $=
    ( cz wcel wa cmul co wceq cdivides wbr cc mulcom syl2anr wi zmulcl dvds0lem
    zcn w3a ex 3com12 mpd3an3 mpd ) ACDZBCDZEBAFGABFGZHZAUEIJZUDBKDAKDUFUCBQAQB
    ALMUCUDUECDZUFUGNZABOUDUCUHUIUDUCUHRUFUGBAUEPSTUAUB $.

  $( An integer divides a multiple of itself.  (Contributed by Paul Chapman,
     21-Mar-2011.) $)
  dvdsmul2 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> N || ( M x. N ) ) $=
    ( cz wcel cmul co cdivides wbr zmulcl w3a wceq eqid dvds0lem mpan2 mpd3an3
    ) ACDZBCDZABEFZCDZBRGHZABIPQSJRRKTRLABRMNO $.

  $( An integer divides a positive integer power of itself.  (Contributed by
     Paul Chapman, 26-Oct-2012.) $)
  iddvdsexp $p |- ( ( M e. ZZ /\ N e. NN ) -> M || ( M ^ N ) ) $=
    ( cz wcel cn wa c1 cmin co cexp cmul cdivides wbr cn0 nnm1nn0 zexpcl sylan2
    simpl dvdsmul2 syl2anc cc wceq zcn expm1t sylan breqtrrd ) ACDZBEDZFZAABGHI
    ZJIZAKIZABJIZLUIUKCDZUGAULLMUHUGUJNDUNBOAUJPQUGUHRUKASTUGAUADUHUMULUBAUCABU
    DUEUF $.

  ${
    $d K x $.  $d M x $.  $d N x $.
    $( If a product divides an integer, so does one of its factors.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    muldvds1 $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( ( K x. M ) || N -> K || N ) ) $=
      ( vx cz wcel w3a cmul co cv wa zmulcl anim1i 3simpb ancoms 3ad2antl2 wceq
      3impa cc zcn mulass mul32 eqtr3d syl3an 3adantl3 eqeq1d biimpd dvds1lem
      3coml 3expa ) AEFZBEFZCEFZGZDABHIZCACDJZBHIZUKULUMUOEFZUMKUKULKURUMABLMRU
      KULUMNULUKUPEFZUQEFZUMUSULUTUPBLOPUNUSKZUPUOHIZCQUQAHIZCQVAVBVCCUKULUSVBV
      CQZUMUKULUSVDUSUKULVDUSUPSFZUKASFZULBSFZVDUPTATBTVEVFVGGUPAHIBHIVBVCUPABU
      AUPABUBUCUDUIUJUEUFUGUH $.

    $( If a product divides an integer, so does one of its factors.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    muldvds2 $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( ( K x. M ) || N -> M || N ) ) $=
      ( vx cz wcel w3a cmul co cv wa zmulcl anim1i 3simpc ancoms 3ad2antl1 wceq
      3impa cc zcn mulass syl3an 3coml 3expa 3adantl3 eqeq1d biimprd dvds1lem )
      AEFZBEFZCEFZGZDABHIZCBCDJZAHIZUIUJUKUMEFZUKKUIUJKUPUKABLMRUIUJUKNUIUJUNEF
      ZUOEFZUKUQUIURUNALOPULUQKZUOBHIZCQUNUMHIZCQUSUTVACUIUJUQUTVAQZUKUIUJUQVBU
      QUIUJVBUQUNSFUIASFUJBSFVBUNTATBTUNABUAUBUCUDUEUFUGUH $.

    $( Multiplication by a constant maintains the divides relation.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvdscmul $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) ->
                     ( M || N -> ( K x. M ) || ( K x. N ) ) ) $=
      ( vx cz wcel cdivides wbr cmul co wi w3a cv 3simpc zmulcl 3adant3 wceq cc
      zcn 3coml 3adant2 jca simpr wa mul12 syl3an 3expa 3adantl3 oveq2 sylan9eq
      ex dvds1lem ) AEFZBEFZCEFZBCGHABIJZACIJZGHKUMUNUOLZDBCUPUQDMZUMUNUONURUPE
      FZUQEFZUMUNUTUOABOPUMUOVAUNACOUAUBURUSEFZUCURVBUDZUSBIJZCQZUSUPIJZUQQVCVE
      VFAVDIJZUQUMUNVBVFVGQZUOUMUNVBVHVBUMUNVHVBUSRFUMARFUNBRFVHUSSASBSUSABUEUF
      TUGUHVDCAIUIUJUKULT $.

    $( Multiplication by a constant maintains the divides relation.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvdsmulc $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) ->
                     ( M || N -> ( M x. K ) || ( N x. K ) ) ) $=
      ( vx cz wcel cdivides wbr cmul co wi w3a cv 3simpc wa zmulcl 3adant2 wceq
      cc zcn 3adant1 jca 3comr simpr mulass syl3an 3com13 3expa oveq1 sylan9req
      3adantl3 ex dvds1lem 3coml ) AEFZBEFZCEFZBCGHBAIJZCAIJZGHKUOUPUQLZDBCURUS
      DMZUOUPUQNUPUQUOUREFZUSEFZOUPUQUOLVBVCUPUOVBUQBAPQUQUOVCUPCAPUAUBUCUTVAEF
      ZUDUTVDOZVABIJZCRZVAURIJZUSRVEVGVHVFAIJZUSUOUPVDVIVHRZUQUOUPVDVJVDUPUOVJV
      DVASFUPBSFUOASFVJVATBTATVABAUEUFUGUHUKVFCAIUIUJULUMUN $.

    $( Cancellation law for the divides relation.  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    dvdscmulr $p |- ( ( M e. ZZ /\ N e. ZZ /\ ( K e. ZZ /\ K =/= 0 ) ) ->
                      ( ( K x. M ) || ( K x. N ) <-> M || N ) ) $=
      ( vx cz wcel wa w3a cmul co cdivides wbr zmulcl 3adant2 3coml 3adant3r wb
      wceq cc zcn cc0 wne cv 3adant3 jca 3simpa simpr wi anim12i mul12 3adant1r
      anim1i 3expb ancoms eqeq1d mulcl mulcan syl3an1 bitr3d syl3an 3impa 3impb
      3expia imp biimpd dvds1lem dvdscmul impbid ) BEFZCEFZAEFZAUAUBZGZHZABIJZA
      CIJZKLZBCKLZVNDVOVPBCDUCZVIVJVKVOEFZVPEFZGZVLVKVIVJWBVKVIVJHVTWAVKVIVTVJA
      BMUDVKVJWAVIACMNUEOPVIVJVMUFVNVSEFZUGVNWCGVSVOIJZVPRZVSBIJZCRZVNWCWEWGQZV
      IVJVMWCWHUHVIVJVMGZWCWHWCVIWIWHWCVIWIWHWCVIGZVJVMWHWJVSSFZBSFZGZVJCSFZVMA
      SFZVLGZWHWCWKVIWLVSTBTUICTVKWOVLATULWMWNWPHZAWFIJZVPRZWEWGWQWRWDVPWMWPWRW
      DRZWNWPWMWTWPWKWLWTWOWKWLWTVLAVSBUJUKUMUNNUOWMWFSFWNWPWSWGQVSBUPWFCAUQURU
      SUTUMVAOVCVBVDVEVFVIVJVKVRVQUHVLABCVGPVH $.

    $( Cancellation law for the divides relation.  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    dvdsmulcr $p |- ( ( M e. ZZ /\ N e. ZZ /\ ( K e. ZZ /\ K =/= 0 ) ) ->
                      ( ( M x. K ) || ( N x. K ) <-> M || N ) ) $=
      ( vx cz wcel wa w3a cmul co cdivides wbr zmulcl 3adant2 3adant3r wb wi cc
      wceq zcn cc0 wne cv 3adant1 jca 3simpa simpr anim12i anim1i 3expa adantrr
      mulass eqeq1d mulcl mulcan2 syl3an1 bitr3d syl3an 3expb 3impa 3coml 3impb
      3expia imp biimpd dvds1lem dvdsmulc impbid ) BEFZCEFZAEFZAUAUBZGZHZBAIJZC
      AIJZKLZBCKLZVNDVOVPBCDUCZVIVJVKVOEFZVPEFZGVLVIVJVKHVTWAVIVKVTVJBAMNVJVKWA
      VICAMUDUEOVIVJVMUFVNVSEFZUGVNWBGVSVOIJZVPSZVSBIJZCSZVNWBWDWFPZVIVJVMWBWGQ
      VIVJVMGZWBWGWBVIWHWGWBVIWHWGWBVIGZVJVMWGWIVSRFZBRFZGZVJCRFZVMARFZVLGZWGWB
      WJVIWKVSTBTUHCTVKWNVLATUIWLWMWOHZWEAIJZVPSZWDWFWPWQWCVPWLWOWQWCSZWMWLWNWS
      VLWJWKWNWSVSBAULUJUKNUMWLWERFWMWOWRWFPVSBUNWECAUOUPUQURUSUTVAVCVBVDVEVFVI
      VJVKVRVQQVLABCVGOVH $.
  $}

  ${
    $d I x y $.  $d J x y $.  $d K x y $.  $d M x y $.  $d N x y $.
    $( If an integer divides each of two other integers, it divides any linear
       combination of them.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvds2ln $p |- ( ( ( I e. ZZ /\ J e. ZZ ) /\
                      ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ) ->
        ( ( K || M /\ K || N ) -> K || ( ( I x. M ) + ( J x. N ) ) ) ) $=
      ( vx vy cz wcel wa cmul co caddc cv jca adantr wceq cc zcn adantl zmulcld
      w3a simpr1 simpr2 simpr3 simpll simplr zaddcld zmulcl anim12i an4s expcom
      imp zaddcl syl zcnd adddir 3expa syl2anc ad3antrrr mul32d oveq12d mulcomd
      wi mulcld 3eqtrd oveq2 oveqan12d sylan9eq ex dvds2lem ) AHIZBHIZJZCHIZDHI
      ZEHIZUBZJZFGCDCECADKLZBEKLZMLZFNZAKLZGNZBKLZMLZVSVOVPVNVOVPVQUCZVNVOVPVQU
      DZOVSVOVQWHVNVOVPVQUEZOVSVOWBHIWHVSVTWAVSADVLVMVRUFWIUAVSBEVLVMVRUGZWJUAU
      HOVSWCHIZWEHIZJZJZWDHIZWFHIZJZWGHIVSWNWRVNWNWRVDVRWNVNWRWLVLWMVMWRWLVLJWP
      WMVMJWQWCAUIWEBUIUJUKULPUMZWDWFUNUOWOWCCKLZDQZWECKLZEQZJZWGCKLZWBQWOXDXEA
      WTKLZBXBKLZMLZWBWOXEWDCKLZWFCKLZMLZWTAKLZXBBKLZMLXHWOWDRIZWFRIZJZCRIZXEXK
      QZWOWRXPWSWPXNWQXOWDSWFSUJUOVSXQWNVSCWHUPPZXNXOXQXRWDWFCUQURUSWOXIXLXJXMM
      WOWCACWNWCRIZVSWLXTWMWCSPTZVLARIVMVRWNASUTZXSVAWOWEBCWNWERIZVSWMYCWLWESTT
      ZVSBRIWNVSBWKUPPZXSVAVBWOXLXFXMXGMWOWTAWOWCCYAXSVEYBVCWOXBBWOWECYDXSVEYEV
      CVBVFXAXCXFVTXGWAMWTDAKVGXBEBKVGVHVIVJVK $.
  $}

  ${
    $d K x y $.  $d M x y $.  $d N x y $.
    $( If an integer divides each of two other integers, it divides their sum.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvds2add $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( ( K || M /\ K || N ) -> K || ( M + N ) ) ) $=
      ( vx vy cz wcel w3a caddc co cv 3simpa 3simpb zaddcl anim2i cmul wceq zcn
      wa cc 3impb adantl wi adddir syl3an 3comr 3expb oveq12 sylan9eq 3ad2antl1
      ex dvds2lem ) AFGZBFGZCFGZHZDEABACABCIJZDKZEKZIJZUMUNUOLUMUNUOMUMUNUOUMUQ
      FGZSUNUOSVAUMBCNOUAURFGZUSFGZSZUTFGUPURUSNUBUMUNVDURAPJZBQUSAPJZCQSZUTAPJ
      ZUQQZUCUOUMVDSZVGVIVJVGVHVEVFIJZUQUMVBVCVHVKQZVBVCUMVLVBURTGVCUSTGUMATGVL
      URRUSRARURUSAUDUEUFUGVEBVFCIUHUIUKUJUL $.

    $( If an integer divides each of two other integers, it divides their
       difference.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvds2sub $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( ( K || M /\ K || N ) -> K || ( M - N ) ) ) $=
      ( vx vy cz wcel w3a cmin co cv 3simpa 3simpb wa zsubcl anim2i cmul cc zcn
      wceq 3impb adantl wi subdir syl3an 3comr 3expb oveq12 sylan9eq 3ad2antl1
      ex dvds2lem ) AFGZBFGZCFGZHZDEABACABCIJZDKZEKZIJZUMUNUOLUMUNUOMUMUNUOUMUQ
      FGZNUNUONVAUMBCOPUAURFGZUSFGZNZUTFGUPURUSOUBUMUNVDURAQJZBTUSAQJZCTNZUTAQJ
      ZUQTZUCUOUMVDNZVGVIVJVGVHVEVFIJZUQUMVBVCVHVKTZVBVCUMVLVBURRGVCUSRGUMARGVL
      URSUSSASURUSAUDUEUFUGVEBVFCIUHUIUKUJUL $.

    $( The divides relation is transitive.  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    dvdstr $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                   ( ( K || M /\ M || N ) -> K || N ) ) $=
      ( vx vy cz wcel w3a cv cmul co 3simpa 3simpc 3simpb wa zmulcl adantl wceq
      cc zcn oveq2 adantr eqeq2 mpbid mulass mul12 eqtrd syl3an 3comr 3ad2antl1
      wb 3expb eqeq1d syl5ibr dvds2lem ) AFGZBFGZCFGZHZDEABBCACDIZEIZJKZUPUQURL
      UPUQURMUPUQURNUTFGZVAFGZOZVBFGUSUTVAPQUTAJKZBRZVABJKZCRZOZVBAJKZCRUSVEOZV
      AVFJKZCRZVJVMVHRZVNVGVOVIVFBVAJUAUBVIVOVNUKVGVHCVMUCQUDVLVKVMCUPUQVEVKVMR
      ZURUPVCVDVPVCVDUPVPVCUTSGZVDVASGZUPASGZVPUTTVATATVQVRVSHVKUTVAAJKJKVMUTVA
      AUEUTVAAUFUGUHUIULUJUMUNUO $.
  $}

  $( If an integer divides another, it divides a multiple of it.  (Contributed
     by Paul Chapman, 17-Nov-2012.) $)
  dvdsmultr1 $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( K || M -> K || ( M x. N ) ) ) $=
    ( cz wcel w3a cdivides wbr co dvdsmul1 3adant1 wa wi zmulcl dvdstr syld3an3
    cmul mpan2d ) ADEZBDEZCDEZFABGHZBBCQIZGHZAUCGHZTUAUDSBCJKSTUAUCDEZUBUDLUEMT
    UAUFSBCNKABUCOPR $.

  $( If an integer divides another, it divides a multiple of it.  (Contributed
     by Paul Chapman, 17-Nov-2012.) $)
  dvdsmultr2 $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( K || N -> K || ( M x. N ) ) ) $=
    ( cz wcel w3a cdivides wbr cmul co wa wb dvdsmul2 biantrud 3adant1 wi simp1
    simp3 zmulcl dvdstr syl3anc sylbid ) ADEZBDEZCDEZFZACGHZUGCBCIJZGHZKZAUHGHZ
    UDUEUGUJLUCUDUEKUIUGBCMNOUFUCUEUHDEZUJUKPUCUDUEQUCUDUERUDUEULUCBCSOACUHTUAU
    B $.

  $( If an integer divides either of two others, it divides their product.
     (Contributed by Paul Chapman, 17-Nov-2012.)  (Proof shortened by Mario
     Carneiro, 17-Jul-2014.) $)
  ordvdsmul $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                    ( ( K || M \/ K || N ) -> K || ( M x. N ) ) ) $=
    ( cz wcel w3a cdivides wbr cmul co dvdsmultr1 dvdsmultr2 jaod ) ADEBDECDEFA
    BGHABCIJGHACGHABCKABCLM $.

  $( If an integer divides a difference, then it divides one term iff it
     divides the other.  (Contributed by Mario Carneiro, 13-Jul-2014.) $)
  dvdssub2 $p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\ K || ( M - N ) ) ->
                   ( K || M <-> K || N ) ) $=
    ( cz wcel cmin co cdivides wbr wa wi 3adant1 imp wceq cc zcn syl2an breqtrd
    adantr expr w3a zsubcl dvds2sub syld3an3 ancomsd nncan caddc dvds2add npcan
    syld3an2 impbid ) ADEZBDEZCDEZUAZABCFGZHIZJABHIZACHIZUOUQURUSUOUQURJZJABUPF
    GZCHUOUTAVAHIZUOURUQVBULUMUNUPDEZURUQJVBKUMUNVCULBCUBLZABUPUCUDUEMUOVACNZUT
    UMUNVEULUMBOEZCOEZVEUNBPZCPZBCUFQLSRTUOUQUSURUOUQUSJZJAUPCUGGZBHUOVJAVKHIZU
    LVCUMUNVJVLKVDAUPCUHUJMUOVKBNZVJUMUNVMULUMVFVGVMUNVHVIBCUIQLSRTUK $.

  $( An integer divides another iff it divides their sum.  (Contributed by Paul
     Chapman, 31-Mar-2011.)  (Revised by Mario Carneiro, 13-Jul-2014.) $)
  dvdsadd $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M || N <-> M || ( M + N ) ) ) $=
    ( cz wcel wa caddc co cdivides wbr cmin wb simpl zaddcl simpr iddvds adantr
    cc wceq zcn pncan syl2an breqtrrd dvdssub2 syl31anc bicomd ) ACDZBCDZEZAABF
    GZHIZABHIZUHUFUICDUGAUIBJGZHIUJUKKUFUGLABMUFUGNUHAAULHUFAAHIUGAOPUFAQDBQDUL
    ARUGASBSABTUAUBAUIBUCUDUE $.

  $( An integer divides another iff it divides their sum.  (Contributed by Paul
     Chapman, 31-Mar-2011.) $)
  dvdsaddr $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M || N <-> M || ( N + M ) ) ) $=
    ( cz wcel wa cdivides wbr caddc co dvdsadd cc wceq zcn addcom syl2an breq2d
    bitrd ) ACDZBCDZEZABFGAABHIZFGABAHIZFGABJTUAUBAFRAKDBKDUAUBLSAMBMABNOPQ $.

  $( An integer divides another iff it divides their difference.  (Contributed
     by Paul Chapman, 31-Mar-2011.) $)
  dvdssub $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M || N <-> M || ( M - N ) ) ) $=
    ( cz wcel wa cdivides wbr cneg caddc co cmin dvdsnegb znegcl dvdsadd sylan2
    wb cc wceq zcn negsub syl2an breq2d 3bitrd ) ACDZBCDZEZABFGABHZFGZAAUGIJZFG
    ZAABKJZFGABLUEUDUGCDUHUJPBMAUGNOUFUIUKAFUDAQDBQDUIUKRUEASBSABTUAUBUC $.

  $( An integer divides another iff it divides their difference.  (Contributed
     by Paul Chapman, 31-Mar-2011.) $)
  dvdssubr $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M || N <-> M || ( N - M ) ) ) $=
    ( cz wcel wa cmin co cdivides caddc wb zsubcl ancoms dvdsadd syldan cc wceq
    wbr zcn pncan3 syl2an breq2d bitr2d ) ACDZBCDZEZABAFGZHQZAAUFIGZHQZABHQUCUD
    UFCDZUGUIJUDUCUJBAKLAUFMNUEUHBAHUCAODBODUHBPUDARBRABSTUAUB $.

  $( Adding a multiple of the base does not affect divisibility.  (Contributed
     by Stefan O'Rear, 23-Sep-2014.) $)
  dvdsadd2b $p |- ( ( A e. ZZ /\ B e. ZZ /\ ( C e. ZZ /\ A || C ) ) ->
    ( A || B <-> A || ( C + B ) ) ) $=
    ( cz wcel cdivides wbr wa w3a caddc co simpl1 simpl3l simpl2 simpr dvds2add
    simpl3r imp syl2anc adantr syl32anc simp3l simp2 zaddcl znegcld wb dvdsnegb
    cneg mpbid wceq cmin ancoms zcnd zcn adantl negsubd pncan2d breqtrd impbida
    cc eqtrd ) ADEZBDEZCDEZACFGZHZIZABFGZACBJKZFGZVGVHHVBVDVCVEVHVJVBVCVFVHLVDV
    EVBVCVHMVBVCVFVHNVDVEVBVCVHQVGVHOVBVDVCIVEVHHVJACBPRUAVGVJHZAVICUHZJKZBFVKV
    BVIDEZVLDEZVJAVLFGZAVMFGZVBVCVFVJLZVGVNVJVGVDVCVNVBVCVDVEUBZVBVCVFUCCBUDZST
    VGVOVJVGCVSUETVGVJOVKVEVPVDVEVBVCVJQVKVBVDVEVPUFVRVDVEVBVCVJMZACUGSUIVBVNVO
    IVJVPHVQAVIVLPRUAVKVCVDVMBUJVBVCVFVJNWAVCVDHZVMVICUKKBWBVICWBVIVDVCVNVTULUM
    VDCUTEVCCUNUOZUPWBCBWCVCBUTEVDBUNTUQVASURUS $.

  ${
    $d k A $.  $d k N $.  $d k ph $.
    fsumdvds.1 $e |- ( ph -> A e. Fin ) $.
    fsumdvds.2 $e |- ( ph -> N e. ZZ ) $.
    fsumdvds.3 $e |- ( ( ph /\ k e. A ) -> B e. ZZ ) $.
    fsumdvds.4 $e |- ( ( ph /\ k e. A ) -> N || B ) $.
    $( If every term in a sum is divisible by ` N ` , then so is the sum.
       (Contributed by Mario Carneiro, 17-Jan-2015.) $)
    fsumdvds $p |- ( ph -> N || sum_ k e. A B ) $=
      ( csu cdivides wbr cc0 wceq wa cz wcel adantlr wb adantr dvds0 mp1i simpr
      0z cv simplr eqbrtrrd 0dvds syl mpbid sumeq2dv cuz cfv wss cfn olcd eqtrd
      wo sumz 3brtr4d wne cdiv co zcnd fsumdivc dvdsval2 syl3anc fsumzcl mpbird
      eqeltrd pm2.61dane ) AEBCDJZKLZEMAEMNZOZMMEVLKMPQMMKLVOUDMUAUBAVNUCVOVLBM
      DJZMVOBCMDVODUEBQZOZMCKLZCMNZVREMCKAVNVQUFAVQECKLZVNIRUGVRCPQZVSVTSAVQWBV
      NHRCUHUIUJUKVOBMULUMUNZBUOQZURVPMNVOWDWCAWDVNFTUPBDMUSUIUQUTAEMVAZOZVMVLE
      VBVCZPQZWFWGBCEVBVCZDJPWFBCEDAWDWEFTZWFEAEPQZWEGTZVDWFVQOZCAVQWBWEHRZVDAW
      EUCZVEWFBWIDWJWMWAWIPQZAVQWAWEIRWMWKWEWBWAWPSWFWKVQWLTAWEVQUFWNECVFVGUJVH
      VJWFWKWEVLPQZVMWHSWLWOAWQWEABCDFHVHTEVLVFVGVIVK $.
  $}

  ${
    dvdslelem.1 $e |- M e. ZZ $.
    dvdslelem.2 $e |- N e. NN $.
    dvdslelem.3 $e |- K e. ZZ $.
    $( Lemma for ~ dvdsle .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvdslelem $p |- ( N < M -> ( K x. M ) =/= N ) $=
      ( clt wbr cmul co wo cc0 cle cr wcel zrei 0re wb wa ax-mp wne c1 lelttric
      mp2an cz wi cn elnnz elnnz1 bitr3i pm5.32 orbi2i mpbi cneg le0neg1 nngt0i
      mpbir nnrei lttri mpan syl renegcli mulge0i sylan2 sylanb expcom remulcli
      ltlei recni mulneg1i breq2i bitr4i syl6ibr lelttri syl6 lemulge12 mpanl12
      mpan2 sylan ex ltletri syld orim12d mpi lttri2i sylibr ) CBGHZABIJZCGHZCW
      HGHZKZWHCUAWGALMHZUBAMHZKZWKWLLAGHZKZWNANOZLNOWPAFPZQALUCUDWOWMWLAUEOZWOW
      MRZFWSWTUFWSWOSZWSWMSZRXAAUGOXBAUHAUIUJWSWOWMUKUQTULUMWGWLWIWMWJWGWLWHLMH
      ZWIWGWLLAUNZBIJZMHZXCWLWGXFWLLXDMHZWGXFWQWLXGRWRAUOTWGXGLBMHZXFWGLBGHZXHL
      CGHZWGXICEUPZLCBQCEURZBDPZUSUTLBQXMVHVAZXDBAWRVBXMVCVDVEVFXCLWHUNZMHZXFWH
      NOXCXPRABWRXMVGZWHUOTXEXOLMABAWRVIBXMVIVJVKVLVMXCXJWIXKWHLCXQQXLVNVRVOWGW
      MBWHMHZWJWGWMXRWGXHWMXRXNBNOWQXHWMSXRXMWRBAVPVQVSVTWGXRWJCBWHXLXMXQWAVTWB
      WCWDWHCXQXLWEWF $.
  $}

  ${
    $d M n $.  $d N n $.
    $( The divisors of a positive integer are bounded by it.  The proof does
       not use ` / ` .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvdsle $p |- ( ( M e. ZZ /\ N e. NN ) -> ( M || N -> M <_ N ) ) $=
      ( vn cz wcel cn wa wbr clt wn cmul co wne wi c1 cif neeq1d imbi12d elimel
      wceq cdivides cle w3a cv wrex breq2 oveq2 breq1 neeq2 oveq1 imbi2d 1z 1nn
      dvdslelem dedth3h 3expia com23 3impia imp neneqd nrexdv wb divides sylan2
      nnz 3adant3 mtbird con2d cr zre nnre lenlt syl2an sylibrd ) ADEZBFEZGZABU
      AHZBAIHZJZABUBHZVQVSVRVOVPVSVRJVOVPVSUCZVRCUDZAKLZBTZCDUEZWBWECDWBWCDEZGW
      DBWBWGWDBMZVOVPVSWGWHNVQWGVSWHVOVPWGVSWHNZVOVPWGWIBVOAOPZIHZWCWJKLZBMZNVP
      BOPZWJIHZWLWNMZNWOWGWCOPZWJKLZWNMZNABWCOOOAWJTZVSWKWHWMAWJBIUFWTWDWLBAWJW
      CKUGQRBWNTWKWOWMWPBWNWJIUHBWNWLUIRWCWQTZWPWSWOXAWLWRWNWCWQWJKUJQUKWQWJWNA
      ODULSBOFUMSWCODULSUNUOUPUQURUSUTVAVOVPVRWFVBZVSVPVOBDEXBBVECABVCVDVFVGUPV
      HVOAVIEBVIEWAVTVBVPAVJBVKABVLVMVN $.
  $}

  $( The divisors of a nonzero integer are bounded by its absolute value.
     (Contributed by Paul Chapman, 21-Mar-2011.)  (Proof shortened by Fan
     Zheng, 3-Jul-2016.) $)
  dvdsleabs $p |- ( ( M e. ZZ /\ N e. ZZ /\ N =/= 0 ) ->
                    ( M || N -> M <_ ( abs ` N ) ) ) $=
    ( cz wcel cc0 wne w3a cdivides wbr cabs cfv cle wb dvdsabsb 3adant3 nnabscl
    wi wa cn dvdsle sylan2 3impb sylbid ) ACDZBCDZBEFZGABHIZABJKZHIZAUHLIZUDUEU
    GUIMUFABNOUDUEUFUIUJQZUEUFRUDUHSDUKBPAUHTUAUBUC $.

  $( If two integers divide each other, they must be equal, up to a difference
     in sign.  (Contributed by Mario Carneiro, 30-May-2014.) $)
  dvdseq $p |- ( ( ( M e. NN0 /\ N e. NN0 ) /\ ( M || N /\ N || M ) ) ->
                    M = N ) $=
    ( cn0 wcel wa cdivides wbr wceq cn cc0 wo elnn0 cle dvdsle syl2anc ad2antlr
    wi cz mpd wb simprl nn0z ad2antrr simplr simprr nnz wne nnne0 breq1 biimpcd
    wn ad2antrl 0dvds syl sylibd necon3ad simpll sylib ord mt3d cr nn0re letri3
    nnre syl2an adantr mpbir2and ex simpr sylan9bbr eqeq2d bitr4d syl5ib jaodan
    sylan2b imp ) ACDZBCDZEABFGZBAFGZEZABHZVRVQBIDZBJHZKWAWBQZBLVQWCWEWDVQWCEZW
    AWBWFWAEZWBABMGZBAMGZWGVSWHWFVSVTUAWGARDZWCVSWHQVQWJWCWAAUBZUCVQWCWAUDABNOS
    WGVTWIWFVSVTUEWGBRDZAIDZVTWIQWCWLVQWABUFPZWGWMAJHZWGBJUGZWOUKWCWPVQWABUHPWG
    WOBJWGWOJBFGZWDVSWOWQQWFVTWOVSWQAJBFUIUJULWGWLWQWDTWNBUMUNUOUPSWGWMWOWGVQWM
    WOKVQWCWAUQALURUSUTBANOSWFWBWHWIETZWAVQAVADBVADWRWCAVBBVDABVCVEVFVGVHWAVTVQ
    WDEZWBVSVTVIWSVTWOWBWDVTJAFGZVQWOBJAFUIVQWJWTWOTWKAUMUNVJWSBJAVQWDVIVKVLVMV
    NVOVP $.

  $( The only nonnegative integer that divides 1 is 1.  (Contributed by Mario
     Carneiro, 2-Jul-2015.) $)
  dvds1 $p |- ( M e. NN0 -> ( M || 1 <-> M = 1 ) ) $=
    ( cn0 wcel c1 cdivides wbr wceq wa simpl 1nn0 a1i simpr cz 1dvds syl adantr
    nn0z dvdseq syl22anc ex id 1z iddvds ax-mp syl6eqbr impbid1 ) ABCZADEFZADGZ
    UGUHUIUGUHHZUGDBCZUHDAEFZUIUGUHIUKUJJKUGUHLUGULUHUGAMCULAQANOPADRSTUIADDEUI
    UADMCDDEFUBDUCUDUEUF $.

  ${
    $d x A $.  $d x B $.  $d x N $.
    $( Only 0 is divisible by all integers.  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    alzdvds $p |- ( N e. ZZ -> ( A. x e. ZZ x || N <-> N = 0 ) ) $=
      ( cz wcel cv cdivides wbr wral cc0 wceq wa wne wn wrex cn cr syl ralrimiv
      wi expcom cabs cfv cle clt wss nnssz zcn abscld ssrexv mpsyl wb zre ltnle
      arch syl2an rexbidva rexnal syl6bb mpbid adantl 3expb ralim com12 expdimp
      dvdsleabs mtod nne sylib dvds0 breq2 syl5ibr impbid1 ) BCDZAEZBFGZACHZBIJ
      ZVPVMVQVPVMKZBILZMVQVRVSVNBUAUBZUCGZACHZVMWBMZVPVMVTVNUDGZACNZWCOCUEVMWDA
      ONZWEUFVMVTPDZWFVMBBUGUHZVTAUNQWDAOCUIUJVMWEWAMZACNWCVMWDWIACVMWGVNPDWDWI
      UKVNCDZWHVNULVTVNUMUOUPWAACUQURUSUTVPVMVSWBVMVSKZVPWBWKVOWASZACHVPWBSWKWL
      ACWJWKWLWJVMVSWLVNBVEVATRVOWAACVBQVCVDVFBIVGVHTVQVOACWJVOVQVNIFGVNVIBIVNF
      VJVKRVL $.

    $( Poset extensionality for division.  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    dvdsext $p |- ( ( A e. NN0 /\ B e. NN0 ) -> ( A = B <->
          A. x e. NN0 ( A || x <-> B || x ) ) ) $=
      ( cn0 wcel wa wceq cv cdivides wbr wb wral breq1 cz nn0z iddvds syl breq2
      bibi12d rspcva simpll simplr ad2antlr adantll mpbird adantlr mpbid dvdseq
      ralrimivw ad2antrr syl22anc ex impbid2 ) BDEZCDEZFZBCGZBAHZIJZCURIJZKZADL
      ZUQVAADBCURIMUIUPVBUQUPVBFZUNUOBCIJZCBIJZUQUNUOVBUAUNUOVBUBVCVDCCIJZUOVFU
      NVBUOCNEVFCOCPQUCUOVBVDVFKZUNVAVGACDURCGUSVDUTVFURCBIRURCCIRSTUDUEVCBBIJZ
      VEUNVHUOVBUNBNEVHBOBPQUJUNVBVHVEKZUOVAVIABDURBGUSVHUTVEURBBIRURBCIRSTUFUG
      BCUHUKULUM $.
  $}

  ${
    $d M n $.  $d N n $.
    $( No number between ` 1 ` and ` M - 1 ` divides ` M ` .  (Contributed by
       Mario Carneiro, 24-Jan-2015.) $)
    fzm1ndvds $p |- ( ( M e. NN /\ N e. ( 1 ... ( M - 1 ) ) ) -> -. M || N ) $=
      ( cn wcel c1 cmin co cfz wa cdivides wbr cle clt wn elfzle2 adantl adantr
      cz wb syl2anc elfzelz zltlem1 mpbird elfznn nnred cr nnre ltnled mpbid wi
      nnz dvdsle mtod ) ACDZBEAEFGZHGDZIZABJKZABLKZUQBAMKZUSNUQUTBUOLKZUPVAUNBE
      UOOPUQBRDZARDZUTVASUPVBUNBEUOUAPUNVCUPAUKQZBAUBTUCUQBAUQBUPBCDZUNBUOUDPZU
      EUNAUFDUPAUGQUHUIUQVCVEURUSUJVDVFABULTUM $.
  $}

  $( Zero is the only one of the first ` A ` nonnegative integers that is
     divisible by ` A ` .  (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
  fzo0dvdseq $p |- ( B e. ( 0 ..^ A ) -> ( A || B <-> B = 0 ) ) $=
    ( cc0 cfzo co wcel cdivides wbr wceq wne wn wa cle clt elfzolt2 zred adantr
    cn cn0 syl elfzoelz elfzoel2 ltnled mpbid cz csn cdif elfzofz elfznn0 simpr
    wi eldifsn sylanbrc dfn2 syl6eleqr dvdsle syl2anc mtod necon4ad dvds0 breq2
    cfz ex syl5ibrcom impbid ) BCADEFZABGHZBCIZVFVGBCVFBCJZVGKVFVILZVGABMHZVFVK
    KZVIVFBANHVLBCAOVFBAVFBBCAUAPVFABCAUBZPUCUDQVJAUEFZBRFVGVKUKVFVNVIVMQVJBSCU
    FUGZRVJBSFZVIBVOFVFVPVIVFBCAVBEFVPBCAUHBAUITQVFVIUJBSCULUMUNUOABUPUQURVCUSV
    FVGVHACGHZVFVNVQVMAUTTBCAGVAVDVE $.

  $( Two different elements of a half-open range are not congruent mod its
     length.  (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
  fzocongeq $p |- ( ( A e. ( C ..^ D ) /\ B e. ( C ..^ D ) ) ->
      ( ( D - C ) || ( A - B ) <-> A = B ) ) $=
    ( cfzo co wcel wa cmin cdivides wbr cc0 wceq cz wb elfzoelz syl2an bitrd cc
    zcnd cfv elfzoel2 elfzoel1 zsubcld adantl zsubcl dvdsabsb syl2anc fzomaxdif
    cabs fzo0dvdseq syl subcl abs00ad subeq0 ) ACDEFZGZBUPGZHZDCIFZABIFZJKZVAUJ
    UAZLMZABMZUSVBUTVCJKZVDUSUTNGZVANGZVBVFOURVGUQURDCBCDUBBCDUCUDUEUQANGBNGVHU
    RACDPZBCDPZABUFQUTVAUGUHUSVCLUTEFGVFVDOABCDUIUTVCUKULRUSVDVALMZVEUSVAUQASGZ
    BSGZVASGURUQAVITZURBVJTZABUMQUNUQVLVMVKVEOURVNVOABUOQRR $.

  ${
    $d K x y $.  $d N x $.
    $( A positive integer divides any greater factorial.  (Contributed by Paul
       Chapman, 28-Nov-2012.) $)
    dvdsfac $p |- ( ( K e. NN /\ N e. ( ZZ>= ` K ) ) -> K || ( ! ` N ) ) $=
      ( vx vy cfv wcel cn cfa cdivides wbr wi c1 co wceq fveq2 breq2d imbi2d cz
      syl nnzd cuz cv caddc cmin cmul cn0 nnm1nn0 faccl dvdsmul2 syl2anc facnn2
      nnz breqtrrd a1i wa adantl elnnuz uztrn sylibr nnnn0d peano2zd dvdsmultr1
      sylan2b syl3anc facp1 sylibrd ex a2d uzind4 impcom ) BAUAEZFAGFZABHEZIJZV
      LACUBZHEZIJZKVLAAHEZIJZKZVLADUBZHEZIJZKVLAWALUCMZHEZIJZKVLVNKCDABVOANZVQV
      SVLWGVPVRAIVOAHOPQVOWANZVQWCVLWHVPWBAIVOWAHOPQVOWDNZVQWFVLWIVPWEAIVOWDHOP
      QVOBNZVQVNVLWJVPVMAIVOBHOPQVTARFZVLAALUDMZHEZAUEMZVRIVLWMRFWKAWNIJVLWMVLW
      LUFFWMGFAUGWLUHSTAULZWMAUIUJAUKUMUNWAVKFZVLWCWFWPVLWCWFKWPVLUOZWCAWBWDUEM
      ZIJZWFWQWKWBRFWDRFWCWSKVLWKWPWOUPWQWBWQWAUFFZWBGFWQWAWQWALUAEZFZWAGFVLWPA
      XAFXBAUQAWALURVCWAUQUSZUTZWAUHSTWQWAWQWAXCTVAAWBWDVBVDWQWEWRAIWQWTWEWRNXD
      WAVESPVFVGVHVIVJ $.
  $}

  ${
    $d K x y $.  $d N x $.
    $( A power divides a power with a greater exponent.  (Contributed by Mario
       Carneiro, 23-Feb-2014.) $)
    dvdsexp $p |- ( ( A e. ZZ /\ M e. NN0 /\ N e. ( ZZ>= ` M ) ) ->
                    ( A ^ M ) || ( A ^ N ) ) $=
      ( cz wcel cn0 cuz cfv w3a cexp co cmin cdivides wbr simp1 3ad2ant3 zexpcl
      cmul syl2anc zcnd uznn0sub 3adant3 dvdsmul2 caddc simp2 expaddd cc nn0cnd
      eluzelz npcand oveq2d eqtr3d breqtrd ) ADEZBFEZCBGHEZIZABJKZACBLKZJKZURRK
      ZACJKZMUQUTDEZURDEZURVAMNUQUNUSFEZVCUNUOUPOZUPUNVEUOBCUAPZAUSQSUNUOVDUPAB
      QUBUTURUCSUQAUSBUDKZJKVAVBUQAUSBUQAVFTUNUOUPUEZVGUFUQVHCAJUQCBUPUNCUGEUOU
      PCBCUITPUQBVIUHUJUKULUM $.
  $}

  ${
    $( Any number ` K ` whose mod base ` N ` is divisible by a divisor ` P ` of
       the base is also divisible by ` P ` .  This means that primes will also
       be relatively prime to the base when reduced ` mod N ` for any base.
       (Contributed by Mario Carneiro, 13-Mar-2014.) $)
    dvdsmod $p |- ( ( ( P e. NN /\ N e. NN /\ K e. ZZ ) /\ P || N ) ->
                    ( P || ( K mod N ) <-> P || K ) ) $=
      ( cn wcel cdivides wbr cmo cmin cc0 wceq breq2d nnzd syl3anc zcnd subid1d
      cz co wb moddvds w3a wa cdiv cfl cfv cmul cr crp simpl3 zred simpl2 nnrpd
      modval syl2anc simpr wi simpl1 nndivred flcld dvdsmultr1 zmulcld breqtrrd
      mpd 0z a1i mpbird eqeq2d 3bitr3d 3bitrd ) ADEZCDEZBQEZUAZACFGZUBZABCHRZFG
      ABCBCUCRZUDUEZUFRZIRZFGZABJIRZFGZABFGVOVPVTAFVOBUGECUHEVPVTKVOBVJVKVLVNUI
      ZUJZVOCVJVKVLVNUKZULBCUMUNLVOBAHRZVSAHRZKZWGJAHRZKZWAWCVOWHWJWGVOWHWJKZAV
      SJIRZFGZVOAVSWMFVOVNAVSFGZVMVNUOVOAQECQEVRQEVNWOUPVOAVJVKVLVNUQZMVOCWFMZV
      OVQVOBCWEWFURUSZACVRUTNVCVOVSVOVSVOCVRWQWRVAZOPVBVOVJVSQEZJQEZWLWNSWPWSXA
      VOVDVEZVSJATNVFVGVOVJVLWTWIWASWPWDWSBVSATNVOVJVLXAWKWCSWPWDXBBJATNVHVOWBB
      AFVOBVOBWDOPLVI $.
  $}

  ${
    $d j k $.  $d j m $.  $d j n $.  $d j x $.  $d j y $.  $d k m $.  $d k y $.
    $d m n $.  $d m x $.  $d m y $.  $d N j $.  $d N k $.  $d N n $.  $d n x $.
    $d n y $.  $d k x $.
    $( Lemma for ~ odd2np1 .  (Contributed by Scott Fenton, 3-Apr-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    odd2np1lem $p |- ( N e. NN0 -> (
      E. n e. ZZ ( ( 2 x. n ) + 1 ) = N \/ E. k e. ZZ ( k x. 2 ) = N ) ) $=
      ( vy c2 cv cmul co c1 caddc wceq cz wrex wo cc0 eqeq2 rexbidv eqeq1d wcel
      2cn vj vx vm orbi12d weq oveq2 oveq1d syl6bb oveq1 0z mul02i rspcev mp2an
      cbvrexv olci cn0 orcom wa cc zcn mulcom sylancl adantl wi mpan2 syl5ibcom
      eqid eqeq2d sylbid rexlimdva peano2z mulid2i oveq12d oveq2i syl6eq ax-1cn
      a1i df-2 adddir mp3an23 mpan addass 3eqtr4d syl2anc orim12d syl5bi nn0ind
      mulcl syl ) EBFZGHZIJHZUAFZKZBLMZAFZEGHZWMKZALMZNWLOKZBLMZWQOKZALMZNEUBFZ
      GHZIJHZUCFZKZUBLMZDFZEGHZXGKZDLMZNZWLXGIJHZKZBLMZWQXOKZALMZNZWLCKZBLMZWQC
      KZALMZNUAUCCWMOKZWOXAWSXCYEWNWTBLWMOWLPQYEWRXBALWMOWQPQUDUAUCUEZWOXIWSXMY
      FWOWLXGKZBLMXIYFWNYGBLWMXGWLPQYGXHBUBLBUBUEZWLXFXGYHWKXEIJWJXDEGUFUGRUNUH
      YFWSWQXGKZALMXMYFWRYIALWMXGWQPQYIXLADLADUEWQXKXGWPXJEGUIRUNUHUDWMXOKZWOXQ
      WSXSYJWNXPBLWMXOWLPQYJWRXRALWMXOWQPQUDWMCKZWOYBWSYDYKWNYABLWMCWLPQYKWRYCA
      LWMCWQPQUDXCXAOLSOEGHZOKZXCUJETUKXBYMAOLWPOKWQYLOWPOEGUIRULUMUOXNXMXINXGU
      PSZXTXIXMUQYNXMXQXIXSYNXLXQDLYNXJLSZURZXLEXJGHZXGKZXQYPXKYQXGYOXKYQKZYNYO
      XJUSSEUSSZYSXJUTTXJEVAVBVCRYOYRXQVDYNYOWLYQIJHZKZBLMZYRXQYOUUAUUAKZUUCUUA
      VGUUBUUDBXJLBDUEZWLUUAUUAUUEWKYQIJWJXJEGUFUGRULVEYRUUBXPBLYRUUAXOWLYQXGIJ
      UIVHQVFVCVIVJYNXHXSUBLYNXDLSZURZWQXFIJHZKZALMZXHXSUUGXDIJHZLSZUUKEGHZUUHK
      ZUUJUUFUULYNXDVKVCUUFUUNYNUUFXDUSSZUUNXDUTUUOXDEGHZIEGHZJHZXEIIJHZJHZUUMU
      UHUUOUURXEEJHUUTUUOUUPXEUUQEJUUOYTUUPXEKTXDEVAVEUUQEKUUOETVLVQVMEUUSXEJVR
      VNVOUUOIUSSZYTUUMUURKVPTXDIEVSVTUUOXEUSSZUUHUUTKZYTUUOUVBTEXDWHWAUVBUVAUV
      AUVCVPVPXEIIWBVTWIWCWIVCUUIUUNAUUKLWPUUKKWQUUMUUHWPUUKEGUIRULWDXHUUIXRALX
      HUUHXOWQXFXGIJUIVHQVFVJWEWFWG $.
  $}

  ${
    $d n A $.  $d k n x y N $.
    $( An integer is odd iff it is one plus twice another integer.
       (Contributed by Scott Fenton, 3-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    odd2np1 $p |- ( N e. ZZ ->
     ( -. 2 || N <-> E. n e. ZZ ( ( 2 x. n ) + 1 ) = N ) ) $=
      ( vk cz wcel c2 cmul co wceq wrex c1 caddc wb wa cneg syl 2cn cmin ax-1cn
      cc vx vy cdivides wbr wn cv 2z divides notbid wo cr cn0 elznn0 odd2np1lem
      mpan adantl peano2z znegcl ad2antlr zcn mulcl simpl recnd negcon2 syl2anc
      peano2cn eqcom sylancr mulcli addsubass mp3an23 oveq1i 2m1e1 eqtri oveq2i
      mulid1i syl6req adddi mp3an13 oveq1d eqtr4d negeqd mulneg2 sylancl eqeq1d
      negsubdi syl5bb bitrd biimpa oveq2 rspcev rexlimdva recn syl2anr syl6rbbr
      ex mulneg1 oveq1 orim12d syl5 imp jaodan sylbi halfnz reeanv eqtr3 mulcom
      cdiv eqeq2d subadd mp3an3 subcl cc0 wne pm3.2i divmul ancoms subdi mp3an1
      2ne0 w3a syl2an wi zsubcl eleq1 syl5ibcom sylbird sylbid rexlimivv sylbir
      mto jctir pm5.17 bicom bitri sylib ) BDEZFBUCUDZUECUFZFGHZBIZCDJZUEZFAUFZ
      GHZKLHZBIZADJZYQYRUUBFDEYQYRUUBMUGCFBUHUOUIYQUUHUUBUJZUUHUUBNZUEZNZUUCUUH
      MZYQUUIUUKYQBUKEZBULEZBOZULEZUJNUUIBUMUUNUUOUUIUUQUUOUUIUUNCABUNUPUUNUUQU
      UIUUQFUAUFZGHZKLHZUUPIZUADJZUBUFZFGHZUUPIZUBDJZUJUUNUUIUBUAUUPUNUUNUVBUUH
      UVFUUBUUNUVAUUHUADUUNUURDEZNZUVAUUHUVHUVANUURKLHZOZDEZFUVJGHZKLHZBIZUUHUV
      GUVKUUNUVAUVGUVIDEZUVKUURUQZUVIURPUSUVHUVAUVNUVHUVABUUTOZIZUVNUVHUUTTEZBT
      EZUVAUVRMUVGUVSUUNUVGUURTEZUVSUURUTZUWAUUSTEZUVSFTEZUWAUWCQFUURVAZUOUUSVF
      PPUPUVHBUUNUVGVBVCUUTBVDVEUVRUVQBIUVHUVNBUVQVGUVHUVQUVMBUVGUVQUVMIUUNUVGU
      VQFUVIGHZKRHZOZUVMUVGUUTUWGUVGUUTUUSFKGHZLHZKRHZUWGUVGUWKUUSUWIKRHZLHZUUT
      UVGUWCUWKUWMIZUVGUWDUWAUWCQUWBUWEVHUWCUWITEKTEZUWNFKQSVISUUSUWIKVJVKPUWLK
      UUSLUWLFKRHKUWIFKRFQVPVLVMVNVOVQUVGUWFUWJKRUVGUWAUWFUWJIZUWBUWDUWAUWOUWPQ
      SFUURKVRVSPVTWAWBUVGUVMUWFOZKLHZUWHUVGUVLUWQKLUVGUWDUVITEZUVLUWQIQUVGUVOU
      WSUVPUVIUTPZFUVIWCVHVTUVGUWFTEZUWOUWHUWRIUVGUWDUWSUXAQUWTFUVIVAVHSUWFKWFW
      DWAWAUPWEWGWHWIUUGUVNAUVJDUUDUVJIZUUFUVMBUXBUUEUVLKLUUDUVJFGWJVTWEWKVEWPW
      LUUNUVEUUBUBDUUNUVCDEZNZUVEUUBUXDUVENUVCOZDEZUXEFGHZBIZUUBUXCUXFUUNUVEUVC
      URUSUXDUVEUXHUXDUVEBUVDOZIZUXHUXCUVDTEZUVTUVEUXJMUUNUXCUVCTEZUWDUXKUVCUTZ
      QUVCFVAWDBWMUVDBVDWNUXDUXHUXIBIUXJUXDUXGUXIBUXCUXGUXIIZUUNUXCUXLUWDUXNUXM
      QUVCFWQWDUPWEBUXIVGWOWHWIUUAUXHCUXEDYSUXEIYTUXGBYSUXEFGWRWEWKVEWPWLWSWTXA
      XBXCUUJKFXHHZDEZXDUUJUUGUUANZCDJADJUXPUUGUUAACDDXEUXQUXPACDDUXQUUFYTIZUUD
      DEZYSDEZNZUXPUUFYTBXFUYAUXRUUFFYSGHZIZUXPUXTUXRUYCMUXSUXTYTUYBUUFUXTYSTEZ
      UWDYTUYBIYSUTZQYSFXGWDXIUPUYAUYCUYBUUERHZKIZUXPUXTUYBTEZUUETEZUYGUYCMZUXS
      UXTUWDUYDUYHQUYEFYSVAVHUXSUWDUUDTEZUYIQUUDUTZFUUDVAVHUYHUYIUWOUYJSUYBUUEK
      XJXKWNUYAUYGYSUUDRHZUXOIZUXPUXSUYKUYDUYNUYGMUXTUYLUYEUYKUYDNZUYNFUYMGHZKI
      ZUYGUYDUYKUYNUYQMZUYDUYKNUYMTEZUYRYSUUDXLUWOUYSUWDFXMXNZNZUYRSUWDUYTQXTXO
      UYNUXOUYMIUWOUYSVUAYAUYQUYMUXOVGKUYMFXPWGVSPXQUYOUYPUYFKUYDUYKUYPUYFIZUWD
      UYDUYKVUBQFYSUUDXRXSXQWEWHYBUXTUXSUYNUXPYCUXTUXSNUYMDEUYNUXPYSUUDYDUYMUXO
      DYEYFXQYGYGYHWTYIYJYKYLUULUUHUUCMUUMUUHUUBYMUUHUUCYNYOYPWH $.

    $( An integer is odd iff its predecessor is even.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    oddm1even $p |- ( N e. ZZ -> ( -. 2 || N <-> 2 || ( N - 1 ) ) ) $=
      ( vn cz wcel c2 cv cmul co c1 caddc wceq wrex cmin cdivides wn wa zcnd cc
      wbr a1i simpl ax-1cn 2cn simpr mulcld subadd2d eqcom eqeq1d syl5bb bitr3d
      mulcomd rexbidva odd2np1 wb 2z peano2zm divides sylancr 3bitr4d ) ACDZEBF
      ZGHZIJHAKZBCLVAEGHZAIMHZKZBCLZEANSOEVENSZUTVCVFBCUTVACDZPZVEVBKZVCVFVJAIV
      BVJAUTVIUAQIRDVJUBTVJEVAERDVJUCTZVJVAUTVIUDQZUEUFVKVBVEKVJVFVEVBUGVJVBVDV
      EVJEVAVLVMUKUHUIUJULBAUMUTECDVECDVHVGUNUOAUPBEVEUQURUS $.

    $( An integer is odd iff its successor is even.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    oddp1even $p |- ( N e. ZZ -> ( -. 2 || N <-> 2 || ( N + 1 ) ) ) $=
      ( cz wcel c2 cdivides wbr wn c1 co caddc oddm1even wb 2z peano2zm dvdsadd
      cmin sylancr cc 2cn a1i zcn ax-1cn addsub12d oveq2i syl6eq breq2d 3bitrd
      2m1e1 ) ABCZDAEFGDAHPIZEFZDDUJJIZEFZDAHJIZEFAKUIDBCUJBCUKUMLMANDUJOQUIULU
      NDEUIULADHPIZJIUNUIDAHDRCUISTAUAHRCUIUBTUCUOHAJUHUDUEUFUG $.

    $( The exponential of the negative of a number, when the exponent is odd.
       (Contributed by Mario Carneiro, 25-Apr-2015.) $)
    oexpneg $p |- ( ( A e. CC /\ N e. NN /\ -. 2 || N ) ->
      ( -u A ^ N ) = -u ( A ^ N ) ) $=
      ( vn cc wcel c2 wbr cmul co c1 wceq cneg cexp cz syl cn0 a1i cc0 eqtr3d
      wa cn cdivides wn w3a cv caddc wrex wb odd2np1 biimpa 3adant1 simpl1 cmin
      nnz simprr simpl2 nncnd ax-1cn simprl zmulcl sylancr zcnd subadd2d mpbird
      2z nnm1nn0 eqeltrrd expcld mulneg2d sqneg oveq1d negcld cle clt zred 2pos
      cr nn0ge0d prodge0 syl22anc elnn0z sylanbrc expmuld 3eqtr4d expp1d oveq2d
      2re 2nn0 negeqd rexlimddv ) ADEZBUAEZFBUBGUCZUDZFCUEZHIZJUFIZBKZALZBMIZAB
      MIZLZKCNWLWMWRCNUGZWKWLWMXCWLBNEWMXCUHBUNCBUIOUJUKWNWONEZWRTZTZAWPMIZAHIZ
      LZWTXBXFXGWSHIZXIWTXFXGAXFAWPWKWLWMXEULZXFBJUMIZWPPXFXLWPKWRWNXDWRUOZXFBJ
      WPXFBWKWLWMXEUPZUQJDEXFURQXFWPXFFNEXDWPNEVEWNXDWRUSZFWOUTVAVBVCVDXFWLXLPE
      XNBVFOVGZVHXKVIXFWSWPMIZWSHIZXJWTXFXQXGWSHXFWSFMIZWOMIAFMIZWOMIXQXGXFXSXT
      WOMXFWKXSXTKXKAVJOVKXFWSFWOXFAXKVLZXFXDRWOVMGZWOPEXOXFFVQEZWOVQERFVNGZRWP
      VMGYBYCXFWGQXFWOXOVOYDXFVPQXFWPXPVRFWOVSVTWOWAWBZFPEXFWHQZWCXFAFWOXKYEYFW
      CWDVKXFWSWQMIXRWTXFWSWPYAXPWEXFWQBWSMXMWFSSSXFXHXAXFAWQMIXHXAXFAWPXKXPWEX
      FWQBAMXMWFSWISWJ $.
  $}

  ${
    $d j k x y F $.  $d j k x y N $.
    $( A rule for divisibility by 3 of a number written in base 10.
       (Contributed by Mario Carneiro, 14-Jul-2014.)  (Revised by Mario
       Carneiro, 17-Jan-2015.) $)
    3dvds $p |- ( ( N e. NN0 /\ F : ( 0 ... N ) --> ZZ ) ->
     ( 3 || sum_ k e. ( 0 ... N ) ( ( F ` k ) x. ( 10 ^ k ) ) <->
       3 || sum_ k e. ( 0 ... N ) ( F ` k ) ) ) $=
      ( vj wcel cc0 co cz c3 c10 cmul csu cdivides wbr a1i sylancr c1 c9 ax-1cn
      cmin cn0 cfz wf wa cv cfv cexp wb nnzi fzfid ffvelrn adantll 10nn elfznn0
      adantl zexpcl zmulcld fsumzcl zsubcld caddc nncni negsubdi2i df-10 oveq1i
      3nn cneg cc wceq 9nn pncan mp2an 3eqtri 3t3e9 eqtr4i wne 1re 1lt10 gtneii
      cdiv id geoser eqeltrrd 1z zsubcl ltneii subeq0i necon3bii mpbir dvdsval2
      syl3anc mpbird zcnd negsubdi2 sylancl breqtrrd peano2zm dvdsnegb negdvdsb
      syl mpbid syl5eqbrr muldvds1 mpd dvdsmultr2 subdid mulid1d oveq2d breqtrd
      wi eqtrd fsumdvds fsumsub dvdssub2 syl31anc ) CUAEZFCUBGZHBUCZUDZIHEZXPAU
      EZBUFZJXTUGGZKGZALZHEXPYAALZHEIYDYETGZMNIYDMNIYEMNUHXSXRIVEUIZOZXRXPYCAXR
      FCUJZXRXTXPEZUDZYAYBXQYJYAHEZXOXPHXTBUKULZYKJHEZXTUAEZYBHEZJUMUIZYJYOXRXT
      CUNUOZJXTUPZPZUQZURXRXPYAAYIYMURXRIXPYCYATGZALYFMXRXPUUBAIYIYHYKYCYAUUAYM
      USYKIYAYBQTGZKGZUUBMYKIUUCMNZIUUDMNZYKYOUUEYRYOIIKGZUUCMNZUUEYOUUGQJTGZVF
      ZUUCMUUJRUUGUUJJQTGRQUTGZQTGZRQJSJUMVAZVBJUUKQTVCVDRVGEQVGEZUULRVHRVIVASR
      QVJVKVLVMVNYOUUIUUCMNZUUJUUCMNZYOUUOUUIUUCVFZMNZYOUUIQYBTGZUUQMYOUUIUUSMN
      ZUUSUUIVSGZHEZYOFXTQTGZUBGZJDUEZUGGZDLUVAHYOJDXTJVGEYOUUMOJQVOYOQJVPVQVRO
      YOVTZWAYOUVDUVFDYOFUVCUJYOUVEUVDEZUDYNUVEUAEZUVFHEYQUVHUVIYOUVEUVCUNUOJUV
      EUPPURWBYOUUIHEZUUIFVOZUUSHEZUUTUVBUHUVJYOQHEZYNUVJWCYQQJWDVKZOUVKYOUVKQJ
      VOQJVPVQWEUUIFQJQJSUUMWFWGWHOYOUVMYPUVLWCYOYNYOYPYQUVGYSPZQYBWDPUUIUUSWIW
      JWKYOYBVGEUUNUUQUUSVHYOYBUVOWLSYBQWMWNWOYOUVJUUCHEZUUOUURUHUVNYOYPUVPUVOY
      BWPZWSZUUIUUCWQPWKYOUVJUVPUUOUUPUHUVNUVRUUIUUCWRPWTXAYOXSXSUVPUUHUUEXIXSY
      OYGOZUVSUVRIIUUCXBWJXCWSYKXSYLUVPUUEUUFXIXSYKYGOYMYKYPUVPYTUVQWSIYAUUCXDW
      JXCYKUUDYCYAQKGZTGUUBYKYAYBQYKYAYMWLZYKYBYTWLUUNYKSOXEYKUVTYAYCTYKYAUWAXF
      XGXJXHXKXRXPYCYAAYIYKYCUUAWLUWAXLXHIYDYEXMXN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                           The division algorithm
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    divalglem0.1 $e |- N e. ZZ $.
    divalglem0.2 $e |- D e. ZZ $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem0 $p |- ( ( R e. ZZ /\ K e. ZZ ) -> ( D || ( N - R ) ->
                       D || ( N - ( R - ( K x. ( abs ` D ) ) ) ) ) ) $=
      ( cz wcel wa cmin co cdivides wbr cabs ax-mp wi mp3an1 syl2an cc zcn cmul
      cfv caddc iddvds wb dvdsabsb anidms mpbid cn0 nn0abscl dvdsmultr2 mp3an13
      nn0zi adantl zsubcl mpan zmulcl mpan2 dvds2add mpan2d wceq subsub sylibrd
      mpi zcnd breq2d ) BGHZCGHZIZADBJKZLMZAVJCANUBZUAKZUCKZLMZADBVMJKJKZLMVIVK
      AVMLMZVOVHVQVGVHAVLLMZVQAGHZVRFVSAALMZVRAUDVSVTVRUEAAUFUGUHOVSVHVLGHZVRVQ
      PFVLVSVLUIHFAUJOUMZACVLUKULVDUNVGVJGHZVMGHZVKVQIVOPZVHDGHZVGWCEDBUOUPVHWA
      WDWBCVLUQURZVSWCWDWEFAVJVMUSQRUTVIVPVNALVGBSHZVMSHZVPVNVAZVHBTVHVMWGVEDSH
      ZWHWIWJWFWKEDTODBVMVBQRVFVC $.

    divalglem1.3 $e |- D =/= 0 $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem1 $p |- 0 <_ ( N + ( abs ` ( N x. D ) ) ) $=
      ( cmul co cabs cfv cle wbr cc0 zrei 0re wcel ax-mp cr wb recni abscli wne
      cneg caddc wo letrii c1 cn nnabscl mp2an nnge1 le0neg1 renegcli lemulge11
      cz wa mpanl12 sylanb mpan2 absmuli absnidi oveq1d syl5eq breqtrrd le0neg2
      remulcli absge0i letri sylbi jaoi cmin df-neg breq1i lesubadd2i bitri
      mpbi ) BUBZBAFGZHIZJKZLBVRUCGJKZBLJKZLBJKZUDVSBLBCMZNUEWAVSWBWAVPVPAHIZFG
      ZVRJWAUFWDJKZVPWEJKZWDUGOZWFAUNOALUAWHDEAUHUIWDUJPWALVPJKZWFWGBQOZWAWIRWC
      BUKPVPQOWDQOWIWFUOWGBWCULZAAADMZSZTVPWDUMUPUQURWAVRBHIZWDFGWEBABWCSWMUSWA
      WNVPWDFBWCUTVAVBVCWBVPLJKZVSWJWBWORWCBVDPWOLVRJKVSVQVQBAWCWLVESZVFVPLVRWK
      NVQWPTZVGURVHVIPVSLBVJGZVRJKVTVPWRVRJBVKVLLBVRNWCWQVMVNVO $.

    $d D r $.  $d N r $.
    divalglem2.4 $e |- S = { r e. NN0 | D || ( N - r ) } $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem2 $p |- sup ( S , RR , `' < ) e. S $=
      ( cc0 cfv wcel cn0 cmin co cdivides wbr cmul cabs cz ax-mp cuz wss c0 wne
      cr clt ccnv csup crab ssrab2 eqsstri nn0uz sseqtri caddc cle zmulcl mp2an
      cv nn0abscl nn0zi zaddcl divalglem1 elnn0z mpbir2an cneg iddvds wb anidms
      dvdsabsb mpbid nn0negzi dvdsmultr2 mp3an zcn absmuli negeqi df-neg subidi
      wi cc oveq1i wceq nn0cni subsub4 3eqtr2ri recni mulneg1i 3eqtr4i breqtrri
      abscli oveq2 breq2d elrab2 ne0i infmssuzcl ) BIUAJZUBBUCUDZBUEUFUGUHBKBLW
      PBACDURZMNZOPZDLUILHWTDLUJUKULUMCCAQNZRJZUNNZBKZWQXDXCLKZACXCMNZOPZXEXCSK
      ZIXCUOPCSKZXBSKXHEXBXASKZXBLKXIASKZXJEFCAUPUQXAUSTZUTCXBVAUQACEFGVBXCVCVD
      ACRJZVEZARJZQNZXFOAXOOPZAXPOPZXKXQFXKAAOPZXQAVFXKXSXQVGAAVIVHVJTXKXNSKXOS
      KXQXRVSFXMXIXMLKECUSTVKXOXKXOLKFAUSTUTAXNXOVLVMTXBVEZXMXOQNZVEXFXPXBYACAX
      ICVTKZECVNTZXKAVTKFAVNTZVOVPXTIXBMNCCMNZXBMNZXFXBVQYEIXBMCYCVRWAYBYBXBVTK
      YFXFWBYCYCXBXLWCCCXBWDVMWEXMXOXMCYCWJWFXOAYDWJWFWGWHWIWTXGDXCLBWRXCWBWSXF
      AOWRXCCMWKWLHWMVDBXCWNTBIWOUQ $.

    $d D q r x z $.  $d N q r x z $.  $d R x $.  $d S z $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem4 $p |- S = { r e. NN0 | E. q e. ZZ N = ( ( q x. D ) + r ) } $=
      ( cv co caddc wceq cz wrex cn0 wcel cmin cdivides wa vz cmul crab wb nn0z
      wbr zsubcl sylancr divides cc nn0cn zmulcl mpan2 zcnd ax-mp subadd mp3an1
      zcn addcom eqeq1d bitrd syl2an eqcom 3bitr3g rexbidva oveq2 breq2d elrab2
      pm5.32i eqeq2d rexbidv elrab 3bitr4i eqriv ) UABCEJZAUBKZDJZLKZMZENOZDPUC
      ZUAJZPQZACWBRKZSUFZTWCCVPWBLKZMZENOZTWBBQWBWAQWCWEWHWCWEVPWDMZENOZWHWCANQ
      ZWDNQZWEWJUDGWCCNQZWBNQWLFWBUECWBUGUHEAWDUIUHWCWIWGENWCVONQZTWDVPMZWFCMZW
      IWGWCWBUJQZVPUJQZWOWPUDWNWBUKWNVPWNWKVPNQGVOAULUMUNWQWRTZWOWBVPLKZCMZWPCU
      JQZWQWRWOXAUDWMXBFCURUOCWBVPUPUQWSWTWFCWBVPUSUTVAVBWDVPVCWFCVCVDVEVAVIACV
      QRKZSUFWEDWBPBVQWBMZXCWDASVQWBCRVFVGIVHVTWHDWBPXDVSWGENXDVRWFCVQWBVPLVFVJ
      VKVLVMVN $.

    divalglem5.5 $e |- R = sup ( S , RR , `' < ) $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem5 $p |- ( 0 <_ R /\ R < ( abs ` D ) ) $=
      ( vx cc0 cle wbr cn0 wcel cmin co cdivides breq2d cabs cfv clt wa cr ccnv
      csup divalglem2 eqeltri wceq oveq2 crab cbvrabv eqtri elrab2 mpbi nn0ge0i
      cv simpli wn cz wne cn nnabscl mp2an nngt0i 0re zcn abscli ltnlei cuz wss
      cc ax-mp ssrab2 eqsstri nn0uz sseqtri nn0abscl nn0sub2 mp3an12 wi nn0z c1
      a1i cmul divalglem0 mpan2 recni mulid2i oveq2i breq2i syl6ib syl sylanbrc
      1z infmssuzle sylancr syl5eqbr wb simpld nn0re lesub mp3an3 syl2anc recnd
      imp subidd bitrd mpbid mto mpbir pm3.2i ) LBMNBAUAUBZUCNZBBOPZADBQRZSNZBC
      PXPXRUDZBCUEUCUFUGZCJACDEFGHIUHUIADKURZQRZSNZXRKBOCYABUJYBXQASYABDQUKTCAD
      EURZQRZSNZEOULZYCKOULIYFYCEKOYDYAUJYEYBASYDYADQUKTUMUNZUOUPZUSZUQXOXNBMNZ
      UTYKXNLMNZLXNUCNYLUTXNAVAPZALVBXNVCPGHAVDVEVFLXNVGAYMAVMPGAVHVNVIZVJUPYKB
      BXNQRZMNZYLYKBXTYOMJYKCLVKUBZVLYOCPZXTYOMNCOYQCYGOIYFEOVOVPVQVRYKYOOPZADY
      OQRZSNZYRXNOPZXPYKYSYMUUBGAVSVNYJXNBVTWAYKXSUUAXSYKYIWEZXPXRUUAXPBVAPZXRU
      UAWBBWCUUDXRADBWDXNWFRZQRZQRZSNZUUAUUDWDVAPXRUUHWBWPABWDDFGWGWHUUGYTASUUF
      YODQUUEXNBQXNXNYNWIWJWKWKWLWMWNXGWNYCUUAKYOOCYAYOUJYBYTASYAYODQUKTYHUOWOY
      OCLWQWRWSYKYPXNBBQRZMNZYLYKBUEPZUUKYPUUJWTZYKXPUUKYKXPXRUUCXABXBZWNZUUNUU
      KUUKXNUEPUULYNBBXNXCXDXEYKUUILXNMYKBYKBUUNXFXHTXIXJXKBXNXPUUKYJUUMVNYNVJX
      LXM $.
  $}

  ${
    divalglem6.1 $e |- A e. NN $.
    divalglem6.2 $e |- X e. ( 0 ... ( A - 1 ) ) $.
    divalglem6.3 $e |- K e. ZZ $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem6 $p |- ( K =/= 0 ->
                       -. ( X + ( K x. A ) ) e. ( 0 ... ( A - 1 ) ) ) $=
      ( cc0 clt wbr co caddc c1 cmin wcel cle cz wb 0z mp2an cr wne wo cmul cfz
      wn zrei 0re lttri2i w3a nnzi elfzm11 simp3i simp1i nnrei remulcli ltadd1i
      mpbi cneg renegcli wa nnnn0i nn0ge0i lemulge12 an4s mpanl12 lt0neg1 ax-mp
      mpan znegcl zltp1le 0p1e1 breq1i bitri recni mulneg1i oveq2i eqtri suble0
      subnegi bitr3i 3imtr4i readdcli ltletri sylancr ltnlei sylib elfzle1 nsyl
      sylbi simp2i addge02 letri sylancl lenlti simp3bi jaoi ) BGUABGHIZGBHIZUB
      CBAUCJZKJZGALMJZUDJZNZUEZBGBFUFZUGUHWQXDWRWQGWTOIZXCWQWTGHIZXFUEWQWTAWSKJ
      ZHIZXHGOIZXGCAHIZXICPNZGCOIZXKCXBNZXLXMXKUIZEGPNZAPNZXNXOQRADUJZCGAUKSUQZ
      ULCAWSCXLXMXKXSUMUFZADUNZBAXEYAUOZUPUQLBURZOIZAYCAUCJZOIZWQXJYCTNZYDYFBXE
      USZATNZGAOIZYGYDUTYFYAAADVAVBZYIYGYJYDYFAYCVCVDVEVHWQGYCHIZYDBTNZWQYLQXEB
      VFVGYLGLKJZYCOIZYDXPYCPNZYLYOQRBPNZYPFBVIVGGYCVJSYNLYCOVKVLVMVMXJAYEMJZGO
      IZYFYRXHGOYRAWSURZMJXHYEYTAMBABXEVNAYAVNZVOVPAWSUUAWSYBVNVSVQVLYIYETNYSYF
      QYAYCAYHYAUOAYEVRSVTWAWTXHGCWSXTYBWBZAWSYAYBWBUGWCWDWTGUUBUGWEWFWTGXAWGWH
      WRWTAHIZXCWRAWTOIZUUCUEWRAWSOIZWSWTOIZUUDWRLBOIZUUEWRYNBOIZUUGXPYQWRUUHQR
      FGBVJSYNLBOVKVLVMYJUUGUUEYKYIYMYJUUGUTUUEYAXEABVCVEVHWIXMUUFXLXMXKXSWJWST
      NCTNXMUUFQYBXTWSCWKSUQAWSWTYAYBUUBWLWMAWTYAUUBWNWFXCWTPNZXFUUCXPXQXCUUIXF
      UUCUIQRXRWTGAUKSWOWHWPWI $.
  $}

  ${
    divalglem7.1 $e |- D e. ZZ $.
    divalglem7.2 $e |- D =/= 0 $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem7 $p |- ( ( X e. ( 0 ... ( ( abs ` D ) - 1 ) ) /\ K e. ZZ ) ->
                       ( K =/= 0 -> -. ( X + ( K x. ( abs ` D ) ) ) e.
                                       ( 0 ... ( ( abs ` D ) - 1 ) ) ) ) $=
      ( cc0 co wcel cz wne cmul caddc wn wi cif wceq oveq1 eleq1d notbid 0z cfv
      cabs c1 cmin cfz imbi2d neeq1 oveq2d imbi12d cn nnabscl mp2an cle wbr clt
      0le0 nngt0i w3a wb nnzi elfzm11 mpbir3an elimel divalglem6 dedth2h ) CFAU
      BUAZUCUDGUEGZHZBIHZBFJZCBVFKGZLGZVGHZMZNVJVHCFOZVKLGZVGHZMZNVIBFOZFJZVOVS
      VFKGZLGZVGHZMZNCBFFCVOPZVNVRVJWEVMVQWEVLVPVGCVOVKLQRSUFBVSPZVJVTVRWDBVSFU
      GWFVQWCWFVPWBVGWFVKWAVOLBVSVFKQUHRSUIVFVSVOAIHAFJVFUJHDEAUKULZCFVGFVGHZFI
      HZFFUMUNZFVFUOUNZTUPVFWGUQWIVFIHWHWIWJWKURUSTVFWGUTFFVFVAULVBVCBFITVCVDVE
      $.
  $}

  ${
    $d D q r x z $.  $d N q r x z $.  $d S x z $.  $d X z $.  $d Y z $.
    divalglem8.1 $e |- N e. ZZ $.
    divalglem8.2 $e |- D e. ZZ $.
    divalglem8.3 $e |- D =/= 0 $.
    divalglem8.4 $e |- S = { r e. NN0 | D || ( N - r ) } $.
    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem8 $p |-
        ( ( ( X e. S /\ Y e. S ) /\ ( X < ( abs ` D ) /\ Y < ( abs ` D ) ) ) ->
          ( K e. ZZ -> ( ( K x. ( abs ` D ) ) = ( Y - X ) -> X = Y ) ) ) $=
      ( wcel cz co wceq wi wa cc0 cc cn0 vz cabs cfv clt wbr cmul cmin caddc wb
      w3a cv cdivides crab ssrab2 eqsstri nn0sscn sstri sseli wne nnabscl mp2an
      cn nnzi zmulcl mpan2 subadd syl3an 3com12 eqcom 3bitr3g 3adant1r 3adant2r
      zcnd wn c1 cfz breq1 eleq1 imbi12d cle elnn0z sylib anim1i df-3an elfzm11
      sylibr 0z ex vtoclga biimpd sylan9 impancom 3ad2ant2 imp divalglem7 sylan
      3adant2 con2d syld df-ne con2bii syl6ibr sylbid oveq1 nncni mul02i syl6eq
      eqeq1d biimpac subeq0 syl2anr syl5ib ad2ant2r 3adant3 exp3a mpdd 3expia
      an4s ) EBLZEAUBUCZUDUEZFBLZFXTUDUEZCMLZCXTUFNZFEUGNZOZEFOZPZPXSYAQZYBYCQZ
      YDYIYJYKYDUJZYGCROZYHYLYGFEYEUHNZOZYMYJYBYDYGYOUIZYCXSYBYDYPYAXSYBYDUJYFY
      EOZYNFOZYGYOYBXSYDYQYRUIZYBFSLZXSESLZYDYESLYSBSFBTSBADGUKUGNULUEZGTUMTKUU
      BGTUNUOZUPUQZURZBSEUUDURZYDYEYDXTMLZYEMLXTAMLARUSXTVBLIJAUTVAZVCZCXTVDVEV
      MFEYEVFVGVHYFYEVIYNFVIVJVKVLYLYOCRUSZVNZYMYLYOYNRXTVOUGNVPNZLZUUKYKYJYOUU
      MPYDYBYOYCUUMYBYCFUULLZYOUUMUAUKZXTUDUEZUUOUULLZPZYCUUNPUAFBUUOFOUUPYCUUQ
      UUNUUOFXTUDVQUUOFUULVRVSUUOBLZUUPUUQUUSUUPQZUUOMLZRUUOVTUEZUUPUJZUUQUUTUV
      AUVBQZUUPQUVCUUSUVDUUPUUSUUOTLUVDBTUUOUUCURUUOWAWBWCUVAUVBUUPWDWFRMLUUGUU
      QUVCUIWGUUIUUORXTWEVAWFWHZWIYOUUNUUMFYNUULVRWJWKWLWMYLUUJUUMYJYDUUJUUMVNP
      ZYKYJEUULLZYDUVFXSYAUVGUURYAUVGPUAEBUUOEOUUPYAUUQUVGUUOEXTUDVQUUOEUULVRVS
      UVEWIWNACEIJWOWPWQWRWSUUJYMCRWTXAXBXCYLYGYMYHYJYKYGYMQZYHPZYDXSYBUVIYAYCU
      VHRYFOZXSYBQZYHYMYGUVJYMYERYFYMYERXTUFNRCRXTUFXDXTXTUUHXEXFXGXHXIUVKYFROZ
      FEOZUVJYHYBYTUUAUVLUVMUIXSUUEUUFFEXJXKYFRVIFEVIVJXLXMXNXOXPXQXR $.

    ${
      $d D k r x y $.  $d R x $.  $d S k x y $.
      divalglem9.5 $e |- R = sup ( S , RR , `' < ) $.
      $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
      divalglem9 $p |- E! x e. S x < ( abs ` D ) $=
        ( wbr wa wceq wcel cc0 co cmin cz cdivides vy vk cabs cfv clt wreu wrex
        cv wi wral cr ccnv csup divalglem2 eqeltri cle divalglem5 simpri rspcev
        breq1 mp2an cn0 oveq2 breq2d elrab2 simplbi nn0zd zsubcl anim12i syl2an
        cmul mpan simprbi dvds2sub mp3an1 sylc cc zcn caddc recni subidi oveq1i
        zrei 0cn subsub2 syl5eq sub4 mpanl12 subcl ancoms addid2d 3eqtr3d mpbid
        wb absdvdsb sylancr wne nnabscl nnzi divides adantr divalglem8 rexlimdv
        cn mpd ex rgen2a reu4 mpbir2an ) AUHZBUCUDZUELZADUFXLADUGZXLUAUHZXKUELZ
        MZXJXNNZUIZUADUJADUJCDOCXKUELZXMCDUKUEULUMDKBDEFGHIJUNUOPCUPLXSBCDEFGHI
        JKUQURXLXSACDXJCXKUEUTUSVAXRAUADXJDOZXNDOZMZXPXQYBXPMZUBUHZXKVKQXNXJRQZ
        NZUBSUGZXQYBYGXPYBXKYETLZYGYBBYETLZYHYBBEXJRQZEXNRQZRQZTLZYIYBYJSOZYKSO
        ZMZBYJTLZBYKTLZMZYMXTXJSOZXNSOZYPYAXTXJXTXJVBOZYQBEFUHZRQZTLZYQFXJVBDUU
        CXJNUUDYJBTUUCXJERVCVDJVEZVFVGZYAXNYAXNVBOZYRUUEYRFXNVBDUUCXNNUUDYKBTUU
        CXNERVCVDJVEZVFVGZYTYNUUAYOESOZYTYNGEXJVHVLUUKUUAYOGEXNVHVLVIVJXTYQYAYR
        XTUUBYQUUFVMYAUUHYRUUIVMVIBSOZYNYOYSYMUIHBYJYKVNVOVPYBYLYEBTXTYTUUAYLYE
        NZYAUUGUUJYTXJVQOZXNVQOZUUMUUAXJVRXNVRUUNUUOMZEERQZXJXNRQZRQZPYEVSQZYLY
        EUUPUUSPUURRQZUUTUUQPUURREEEGWCVTZWAWBPVQOUUNUUOUVAUUTNWDPXJXNWEVOWFEVQ
        OZUVCUUPUUSYLNUVBUVBEEXJXNWGWHUUPYEUUOUUNYEVQOXNXJWIWJWKWLVJVJVDWMXTYTU
        UAYIYHWNZYAUUGUUJYTUUAMZUULYESOZUVDHUUAYTUVFXNXJVHWJZBYEWOWPVJWMXTYTUUA
        YHYGWNZYAUUGUUJUVEXKSOUVFUVHXKUULBPWQXKXDOHIBWRVAWSUVGUBXKYEWTWPVJWMXAY
        CYFXQUBSBDYDEXJXNFGHIJXBXCXEXFXGXLXOAUADXJXNXKUEUTXHXI $.
    $}

    $( Lemma for ~ divalg .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalglem10 $p |- E! r e. ZZ E. q e. ZZ
                   ( 0 <_ r /\ r < ( abs ` D ) /\ N = ( ( q x. D ) + r ) ) $=
      ( vx cc0 wbr clt caddc wceq cz wrex wa anbi2i bitri cle cabs cfv cmul w3a
      cv co wreu cr ccnv csup eqid divalglem9 wcel weu elnn0z an12 ancom anbi1i
      anass oveq2 eqeq2d rexbidv divalglem4 elrab2 3bitr4i df-3an r19.42v eubii
      cn0 rexbii df-reu mpbi breq2 breq1 3anbi123d cbvreuv ) KJUFZUALZVRAUBUCZM
      LZCEUFAUDUGZVRNUGZOZUEZEPQZJPUHZKDUFZUALZWHVTMLZCWBWHNUGZOZUEZEPQZDPUHWAJ
      BUHZWGJABUIMUJUKZBCDFGHIWPULUMVRBUNZWARZJUOVRPUNZWFRZJUOWOWGWRWTJWAVRVJUN
      ZRZWDEPQZRZWSVSWARZXCRZRZWRWTXDWSXERZXCRXGXBXHXCXBWAWSVSRZRZXHXAXIWAVRUPS
      XJWSWAVSRZRXHWAWSVSUQXKXEWSWAVSURSTTUSWSXEXCUTTWAWQRWAXAXCRZRWRXDWQXLWAWL
      EPQXCDVRVJBWHVROZWLWDEPXMWKWCCWHVRWBNVAVBVCABCDEFGHIVDVESWQWAURWAXAXCUTVF
      WFXFWSWFXEWDRZEPQXFWEXNEPVSWAWDVGVKXEWDEPVHTSVFVIWAJBVLWFJPVLVFVMWFWNJDPV
      RWHOZWEWMEPXOVSWIWAWJWDWLVRWHKUAVNVRWHVTMVOXOWCWKCVRWHWBNVAVBVPVCVQVM $.
  $}

  ${
    $d D q r $.  $d N q r $.
    $( The division algorithm (theorem).  Dividing an integer ` N ` by a
       nonzero integer ` D ` produces a (unique) quotient ` q ` and a unique
       remainder ` 0 <_ r < ( abs `` D ) ` .  The proof does not use ` / ` ,
       ` |_ ` or ` mod ` .  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    divalg $p |- ( ( N e. ZZ /\ D e. ZZ /\ D =/= 0 ) -> E! r e. ZZ E. q e. ZZ
                   ( 0 <_ r /\ r < ( abs ` D ) /\ N = ( ( q x. D ) + r ) ) ) $=
      ( cz wcel cc0 wne cv wbr cabs clt cmul co caddc wceq w3a wrex wreu c1 cle
      cfv wa cif eqeq1 3anbi3d rexbidv reubidv fveq2 breq2d oveq2 oveq1d eqeq2d
      3anbi23d cmin cdivides cn0 crab elimel simpl eleq1 elimdhyp simpr ax-1ne0
      1z neeq1 eqid divalglem10 dedth2h 3impb ) BEFZAEFZAGHZGCIZUAJZVNAKUBZLJZB
      DIZAMNZVNONZPZQZDERZCESZVKVLVMUCZWDVOVQVKBTUDZVTPZQZDERZCESVOVNWEATUDZKUB
      ZLJZWFVRWJMNZVNONZPZQZDERZCESBATTBWFPZWCWICEWRWBWHDEWRWAWGVOVQBWFVTUEUFUG
      UHAWJPZWIWQCEWSWHWPDEWSVQWLWGWOVOWSVPWKVNLAWJKUIUJWSVTWNWFWSVSWMVNOAWJVRM
      UKULUMUNUGUHWJWJWFVNUONUPJCUQURZWFCDBTEVEUSWEVLWJEFTEFATVLVMUTAWJEVATWJEV
      AVEVBWEVMWJGHTGHATVLVMVCAWJGVFTWJGVFVDVBWTVGVHVIVJ $.

    $( Express the division algorithm as stated in ~ divalg in terms of
       ` || ` .  (Contributed by Paul Chapman, 31-Mar-2011.) $)
    divalgb $p |- ( ( N e. ZZ /\ D e. ZZ /\ D =/= 0 ) ->
                    ( E! r e. ZZ E. q e. ZZ ( 0 <_ r /\ r < ( abs ` D ) /\
                                              N = ( ( q x. D ) + r ) ) <->
                      E! r e. NN0 ( r < ( abs ` D ) /\ D || ( N - r ) ) ) ) $=
      ( cz wcel cc0 cv wbr co caddc wceq w3a wrex wreu wa cn0 wb cc zcn cle cfv
      cabs clt cmul cmin cdivides wne zsubcl divides sylan2 3impb 3com12 zmulcl
      wi zcnd subadd syl3an addcom syl2an 3adant1 eqeq1d bitrd eqcom exp3acom23
      3bitr3g 3expia 3impia rexbidva 3com23 anbi2d df-3an rexbii bitri syl6rbbr
      imp r19.42v anass syl6bb 3expa reubidva weu elnn0z anbi1i df-reu 3bitr4ri
      eubii 3adant3 ) BEFZAEFZGCHZUAIZWKAUCUBUDIZBDHZAUEJZWKKJZLZMZDENZCEOZWMAB
      WKUFJZUGIZPZCQOZRAGUHWIWJPZWTWLXCPZCEOZXDXEWSXFCEWIWJWKEFZWSXFRWIWJXHMZWS
      WLWMPZXBPZXFXIXKXJWQDENZPZWSXIXBXLXJXIXBWOXALZDENZXLWJWIXHXBXORZWJWIXHXPW
      IXHPZWJXAEFXPBWKUIDAXAUJUKULUMWIXHWJXOXLRWIXHWJMZXNWQDEXRWNEFZXNWQRZWIXHW
      JXSXTUOXQXSWJXTWIXHXSWJPZXTWIXHYAMZXAWOLZWPBLZXNWQYBYCWKWOKJZBLZYDWIBSFXH
      WKSFZYAWOSFZYCYFRBTWKTZYAWOWNAUNUPZBWKWOUQURYBYEWPBXHYAYEWPLZWIXHYGYHYKYA
      YIYJWKWOUSUTVAVBVCXAWOVDWPBVDVFVGVEVHVPVIVJVCVKWSXJWQPZDENXMWRYLDEWLWMWQV
      LVMXJWQDEVQVNVOWLWMXBVRVSVTWAWKQFZXCPZCWBXHXFPZCWBXDXGYNYOCYNXHWLPZXCPYOY
      MYPXCWKWCWDXHWLXCVRVNWGXCCQWEXFCEWEWFVSWH $.

    $( The division algorithm (theorem) for a positive divisor.  (Contributed
       by Paul Chapman, 21-Mar-2011.) $)
    divalg2 $p |- ( ( N e. ZZ /\ D e. NN ) ->
                    E! r e. NN0 ( r < D /\ D || ( N - r ) ) ) $=
      ( vq cz wcel cn wa cv cabs cfv clt wbr cmin co cn0 wreu cc0 w3a mpbid wne
      cdivides nnz nnne0 jca cle cmul caddc wceq divalg divalgb 3expb sylan2 wb
      wrex nnre nnnn0 nn0ge0d absidd breq2d anbi1d reubidv adantl ) BEFZAGFZHCI
      ZAJKZLMZABVFNOUBMZHZCPQZVFALMZVIHZCPQZVEVDAEFZARUAZHVKVEVOVPAUCAUDUEVDVOV
      PVKVDVOVPSRVFUFMVHBDIAUGOVFUHOUISDEUOCEQVKABCDUJABCDUKTULUMVEVKVNUNVDVEVJ
      VMCPVEVHVLVIVEVGAVFLVEAAUPVEAAUQURUSUTVAVBVCT $.
  $}

  ${
    $d D r z $.  $d N r z $.
    $( The result of the ` mod ` operator satisfies the requirements for the
       remainder ` r ` in the division algorithm for a positive divisor
       (compare ~ divalg2 and ~ divalgb ).  This demonstration theorem
       justifies the use of ` mod ` to yield an explicit remainder from this
       point forward.  (Contributed by Paul Chapman, 31-Mar-2011.) $)
    divalgmod $p |- ( ( N e. ZZ /\ D e. NN ) -> ( r = ( N mod D ) <->
                      ( r e. NN0 /\ ( r < D /\ D || ( N - r ) ) ) ) ) $=
      ( vz cz wcel wa cv co csn clt wbr cmin cdivides cn0 wceq cr syl2an cmul
      cc cn cmo crab crio crp zre nnrp modlt cdiv cfl cfv cc0 wne nnne0 redivcl
      nnre syl3an 3anidm23 flcld adantl zmodcl nn0zd zsubcl syldan nncn mulcomd
      nnz zcnd modval zcn adantr zmulcl anabss7 nn0cnd subsub23 syl3anc 3bitr3g
      wb eqcom mpbid eqtr3d dvds0lem syl31anc wreu divalg2 breq1 breq2d anbi12d
      oveq2 riota2 syl2anc mpbi2and eqcomd sneqd snriota syl eqtr4d eleq2d elsn
      elrab ) BEFZAUAFZGZCHZBAUBIZJZFXDDHZAKLZABXGMIZNLZGZDOUCZFXDXEPXDOFXDAKLZ
      ABXDMIZNLZGZGXCXFXLXDXCXFXKDOUDZJZXLXCXEXQXCXQXEXCXEAKLZABXEMIZNLZXQXEPZX
      ABQFZAUEFZXSXBBUFZAUGZBAUHRXCBAUIIZUJUKZEFZAEFZXTEFZYHASIZXTPYAXCYGXAXBYG
      QFZXAYCXBAQFXBAULUMYMYEAUPAUNBAUOUQURUSZXBYJXAAVGZUTXAXBXEEFYKXCXEBAVAZVB
      BXEVCVDXCAYHSIZYLXTXCAYHXBATFXAAVEUTXCYHYNVHVFXCXEBYQMIZPZYQXTPZXAYCYDYSX
      BYEYFBAVIRXCYRXEPZXTYQPZYSYTXCBTFZYQTFXETFUUAUUBVRXAUUCXBBVJVKXCYQXAXBYQE
      FZXBYJYIUUDXCYOYNAYHVLRVMVHXCXEYPVNBYQXEVOVPYRXEVSXTYQVSVQVTWAYHAXTWBWCXC
      XEOFXKDOWDZXSYAGZYBVRYPABDWEZXKUUFDOXEXGXEPZXHXSXJYAXGXEAKWFUUHXIXTANXGXE
      BMWIWGWHWJWKWLWMWNXCUUEXLXRPUUGXKDOWOWPWQWRCXEWSXKXPDXDOXGXDPZXHXMXJXOXGX
      DAKWFUUIXIXNANXGXDBMWIWGWHWTVQ $.
  $}

  ${
    $d D r x $.  $d K r $.  $d N r x $.
    $( Corollary of the division algorithm.  If an integer ` D ` greater than
       ` 1 ` divides ` N ` , then it does not divide any of ` N - 1 ` ,
       ` N - 2 ` ... ` N - ( D - 1 ) ` .  (Contributed by Paul Chapman,
       31-Mar-2011.) $)
    ndvdssub $p |- ( ( N e. ZZ /\ D e. NN /\ ( K e. NN /\ K < D ) ) ->
                     ( D || N -> -. D || ( N - K ) ) ) $=
      ( vr vx wcel clt wbr wa cdivides cmin co wi cn0 cc0 wceq wral breq1 oveq2
      breq2d cz cn wn w3a wne nnnn0 nnne0 jca df-ne anbi2i cv wrex wreu divalg2
      anbi12d reu4 sylib simprd nngt0 3ad2ant2 zcn subid1d biimpar 3expa anim2i
      3adant2 ancoms 0nn0 anbi2d eqeq2 imbi12d rspcv ax-mp exp3a ralimi r19.21v
      syl5 syl pm2.43i 3impia eqeq1 pm4.14 syl6ib syl7bi exp4a com23 imp4a syl7
      syl5com imp3a 3expia ) CUAFZAUBFZBUBFZBAGHZIZACJHZACBKLZJHZUCZMWLWMIZWQWP
      WTWLWMWQWPWTMWLWMWQUDZWNWOWTXBWOWNWTWNBNFZBOUEZIXBWOWTWNXCXDBUFBUGUHXBWOX
      CXDWTXBXCWOXDWTMXBXCWOXDWTWOXDIWOBOPZUCZIZXBXCWTXDXFWOBOUIUJXBXCWOWSIZXEM
      ZXGWTMXBDUKZAGHZACXJKLZJHZIZXJOPZMZDNQZXCXIWLWMWQXQXAWQXQMXAXAWQXQXAXAWQI
      ZXPMZDNQZXRXQMXAXNEUKZAGHZACYAKLZJHZIZIZXJYAPZMZENQZDNQZXTXAXNDNULZYJXAXN
      DNUMYKYJIACDUNXNYEDENYGXKYBXMYDXJYAAGRYGXLYCAJXJYACKSTUOUPUQURYIXSDNYIXRX
      NXOXRXNIXNOAGHZACOKLZJHZIZIZYIXOXNXRYPXRYOXNWLWMWQYOXBYLYNWMWLYLWQAUSUTWL
      WQYNWMWLYNWQWLYMCAJWLCCVAVBTVCVFUHVDVEVGONFYIYPXOMZMVHYHYQEONYAOPZYFYPYGX
      OYRYEYOXNYRYBYLYDYNYAOAGRYRYCYMAJYAOCKSTUOVIYAOXJVJVKVLVMVQVNVOVRXRXPDNVP
      UQVNVSVTXPXIDBNXJBPZXNXHXOXEYSXKWOXMWSXJBAGRYSXLWRAJXJBCKSTUOXJBOWAVKVLWI
      WOWSXEWBWCWDWEWFWGWHWFWJWKWFVT $.
  $}

  $( Corollary of the division algorithm.  If an integer ` D ` greater than
     ` 1 ` divides ` N ` , then it does not divide any of ` N + 1 ` ,
     ` N + 2 ` ... ` N + ( D - 1 ) ` .  (Contributed by Paul Chapman,
     31-Mar-2011.) $)
  ndvdsadd $p |- ( ( N e. ZZ /\ D e. NN /\ ( K e. NN /\ K < D ) ) ->
                   ( D || N -> -. D || ( N + K ) ) ) $=
    ( cz wcel cn clt wbr wa w3a cdivides cmin co wn wi cc0 cr wb syl2an cc nnre
    caddc posdif syl2anr pm5.32i nnz zsubcl elnnz biimpri sylan anasss ltsubpos
    sylbi nngt0 biimpd expcom mpdi imp adantrr 3adant1 ndvdssub syld3an3 zaddcl
    jca sylan2 dvdssubr an12s wceq zcn nncn subsub3 syl3an breq2d bitr4d notbid
    3impb 3adant3r sylibrd ) CDEZAFEZBFEZBAGHZIZJACKHZACABLMZLMZKHZNZACBUBMZKHZ
    NZVSVTWCWEFEZWEAGHZIZWDWHOVTWCWNVSVTWCIWLWMVTWAWBWLVTWAIZWBIWOPWEGHZIWLWOWB
    WPWABQEZAQEZWBWPRVTBUAZAUAZBAUCUDUEWOWEDEZWPWLVTADEZBDEZXAWAAUFZBUFZABUGSWL
    XAWPIWEUHUIUJUMUKVTWAWMWBVTWAWMVTWAPBGHZWMBUNWAVTXFWMOWAVTIXFWMWAWQWRXFWMRV
    TWSWTBAULSUOUPUQURUSVDUTAWECVAVBVSVTWAWKWHRWBVSVTWAJZWJWGXGWJAWIALMZKHZWGVS
    VTWAWJXIRZVTVSWAXJVTXBWIDEZXJVSWAIXDWAVSXCXKXECBVCVEAWIVFSVGVPXGWFXHAKVSCTE
    VTATEWABTEWFXHVHCVIAVJBVJCABVKVLVMVNVOVQVR $.

  $( Special case of ~ ndvdsadd .  If an integer ` D ` greater than ` 1 `
     divides ` N ` , it does not divide ` N + 1 ` .  (Contributed by Paul
     Chapman, 31-Mar-2011.) $)
  ndvdsp1 $p |- ( ( N e. ZZ /\ D e. NN /\ 1 < D ) ->
                  ( D || N -> -. D || ( N + 1 ) ) ) $=
    ( c1 clt wbr cz wcel cn wa cdivides caddc co wn 1nn jctl ndvdsadd syl3an3
    wi ) CADEZBFGAHGCHGZSIABJEABCKLJEMRSTNOACBPQ $.

  ${
    ndvdsi.1 $e |- A e. NN $.
    ndvdsi.2 $e |- Q e. NN0 $.
    ndvdsi.3 $e |- R e. NN $.
    ndvdsi.4 $e |- ( ( A x. Q ) + R ) = B $.
    ndvdsi.5 $e |- R < A $.
    $( A quick test for non-divisibility.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    ndvdsi $p |- -. A || B $=
      ( cmul co caddc cdivides wbr wn cz wcel nnzi mp2an cn dvdsmul1 clt zmulcl
      nn0zi wa wi pm3.2i ndvdsadd mp3an ax-mp breq2i mtbi ) AACJKZDLKZMNZABMNAU
      MMNZUOOZAPQZCPQZUPAERZCFUDZACUASUMPQZATQDTQZDAUBNZUEUPUQUFURUSVBUTVAACUCS
      EVCVDGIUGADUMUHUIUJUNBAMHUKUL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Bit sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c bits $.
  $c sadd $.
  $c smul $.

  $( Define the binary bits of an integer. $)
  cbits $a class bits $.

  $( Define the sequence addition on bit sequences. $)
  csad $a class sadd $.

  $( Define the sequence multiplication on bit sequences. $)
  csmu $a class smul $.

  ${
    $d k n $.  $d m M $.  $d m n N $.
    $( Define the binary bits of an integer.  The expression
       ` M e. ( bits `` N ) ` means that the ` M ` -th bit of ` N ` is 1 (and
       its negation means the bit is 0).  (Contributed by Mario Carneiro,
       4-Sep-2016.) $)
    df-bits $a |- bits = ( n e. ZZ |->
      { m e. NN0 | -. 2 || ( |_ ` ( n / ( 2 ^ m ) ) ) } ) $.

    $( Expand the definition of the bits of an integer.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    bitsfval $p |- ( N e. ZZ -> ( bits ` N ) =
      { m e. NN0 | -. 2 || ( |_ ` ( N / ( 2 ^ m ) ) ) } ) $=
      ( vn c2 cv cexp co cdiv cfl cfv cdivides wbr wn cn0 crab cbits wceq oveq1
      cz fveq2d breq2d notbid rabbidv df-bits nn0ex rabex fvmpt ) CBDCEZDAEFGZH
      GZIJZKLZMZANODBUIHGZIJZKLZMZANOSPUHBQZUMUQANURULUPURUKUODKURUJUNIUHBUIHRT
      UAUBUCACUDUQANUEUFUG $.

    $( Expand the definition of the bits of an integer.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    bitsval $p |- ( M e. ( bits ` N ) <-> ( N e. ZZ /\ M e. NN0 /\
      -. 2 || ( |_ ` ( N / ( 2 ^ M ) ) ) ) ) $=
      ( vn vm cbits cfv wcel cz cn0 c2 cexp co cdiv cfl cdivides wbr wn wa crab
      cv w3a cdm df-bits elfvdm sseldi bitsfval eleq2d wceq oveq2 oveq2d fveq2d
      dmmptss breq2d notbid elrab syl6bb biadan2 3anass bitr4i ) ABEFZGZBHGZAIG
      ZJBJAKLZMLZNFZOPZQZRZRVBVCVHUAVAVBVIVAEUBHBCHJCTJDTZKLZMLNFOPQDISEDCUCULA
      BEUDUEVBVAAJBVKMLZNFZOPZQZDISZGVIVBUTVPADBUFUGVOVHDAIVJAUHZVNVGVQVMVFJOVQ
      VLVENVQVKVDBMVJAJKUIUJUKUMUNUOUPUQVBVCVHURUS $.

    $( Expand the definition of the bits of an integer.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    bitsval2 $p |- ( ( N e. ZZ /\ M e. NN0 ) -> ( M e. ( bits ` N ) <->
      -. 2 || ( |_ ` ( N / ( 2 ^ M ) ) ) ) ) $=
      ( cbits cfv wcel cz cn0 wa c2 cexp co cdiv cfl cdivides wbr wn w3a df-3an
      bitsval bitri baib ) ABCDEZBFEZAGEZHZIBIAJKLKMDNOPZUBUCUDUFQUEUFHABSUCUDU
      FRTUA $.

    $( The set of bits of an integer is a subset of ` NN0 ` .  (Contributed by
       Mario Carneiro, 5-Sep-2016.) $)
    bitsss $p |- ( bits ` N ) C_ NN0 $=
      ( vm cbits cfv cn0 cv wcel cz c2 cexp co cdiv cfl cdivides wbr wn bitsval
      simp2bi ssriv ) BACDZEBFZTGAHGUAEGIAIUAJKLKMDNOPUAAQRS $.

    $( The ` bits ` function is a function from integers to subsets of
       nonnegative integers.  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
    bitsf $p |- bits : ZZ --> ~P NN0 $=
      ( vn vk cz cn0 cpw c2 cv cexp co cdiv cfl cfv cdivides crab cbits df-bits
      wbr wn wcel wss ssrab2 nn0ex elpw2 mpbir a1i fmpti ) ACDEZFAGZFBGHIJIKLMQ
      RZBDNZOBAPUJUGSZUHCSUKUJDTUIBDUAUJDUBUCUDUEUF $.
  $}

  $( Value of the zeroth bit.  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
  bits0 $p |- ( N e. ZZ -> ( 0 e. ( bits ` N ) <-> -. 2 || N ) ) $=
    ( cz wcel cc0 cbits cfv c2 cexp co cdiv cfl cdivides wbr wn cn0 wb bitsval2
    0nn0 mpan2 c1 wceq 2cn exp0 ax-mp oveq2i zcn div1d syl5eq fveq2d flid eqtrd
    cc breq2d notbid bitrd ) ABCZDAEFCZGAGDHIZJIZKFZLMZNZGALMZNUPDOCUQVBPRDAQSU
    PVAVCUPUTAGLUPUTAKFAUPUSAKUPUSATJIAURTAJGULCURTUAUBGUCUDUEUPAAUFUGUHUIAUJUK
    UMUNUO $.

  $( The zeroth bit of an even number is zero.  (Contributed by Mario Carneiro,
     5-Sep-2016.) $)
  bits0e $p |- ( N e. ZZ -> -. 0 e. ( bits ` ( 2 x. N ) ) ) $=
    ( cz wcel c2 cmul co cdivides wbr cc0 cbits cfv wn 2z dvdsmul1 mpan zmulcld
    wb a1i id bits0 syl con2bid mpbid ) ABCZDDAEFZGHZIUEJKCZLDBCZUDUFMDANOUDUGU
    FUDUEBCUGUFLQUDDAUHUDMRUDSPUETUAUBUC $.

  $( The zeroth bit of an odd number is zero.  (Contributed by Mario Carneiro,
     5-Sep-2016.) $)
  bits0o $p |- ( N e. ZZ -> 0 e. ( bits ` ( ( 2 x. N ) + 1 ) ) ) $=
    ( cz wcel cc0 c2 cmul co c1 caddc cbits cfv cdivides wn 2z dvdsmul1 mpan cn
    wbr clt a1i wi id zmulcld 2nn 1lt2 ndvdsp1 syl3anc wb peano2zd bits0 mpbird
    mpd syl ) ABCZDEAFGZHIGZJKCZEUPLRMZUNEUOLRZUREBCZUNUSNEAOPUNUOBCEQCZHESRZUS
    URUAUNEAUTUNNTUNUBUCZVAUNUDTVBUNUETEUOUFUGULUNUPBCUQURUHUNUOVCUIUPUJUMUK $.

  $( The ` M + 1 ` -th bit of ` N ` is the ` M ` -th bit of ` |_ ( N / 2 ) ` .
     (Contributed by Mario Carneiro, 5-Sep-2016.) $)
  bitsp1 $p |- ( ( N e. ZZ /\ M e. NN0 ) ->
    ( ( M + 1 ) e. ( bits ` N ) <-> M e. ( bits ` ( |_ ` ( N / 2 ) ) ) ) ) $=
    ( cz wcel cn0 c2 co cexp cdiv cfl cfv cdivides wbr wn cbits cn nncnd nnne0d
    cmul eqtr4d wa c1 caddc 2nn simpr expp1d nnexpcld mulcomd eqtrd oveq2d zcnd
    simpl divdiv1d fveq2d cr wceq zred rehalfcld fldiv syl2anc breq2d notbid wb
    a1i peano2nn0 bitsval2 sylan2 flcld sylancom 3bitr4d ) BCDZAEDZUAZFBFAUBUCG
    ZHGZIGZJKZLMZNZFBFIGZJKZFAHGZIGJKZLMZNZVNBOKDZAWAOKDZVMVRWDVMVQWCFLVMVQVTWB
    IGZJKZWCVMVPWHJVMVPBFWBSGZIGWHVMVOWJBIVMVOWBFSGWJVMFAVMFFPDVMUDVDZQZVKVLUEZ
    UFVMWBFVMWBVMFAWKWMUGZQZWLUHUIUJVMBFWBVMBVKVLULZUKWLWOVMFWKRVMWBWNRUMTUNVMV
    TUODWBPDWCWIUPVMBVMBWPUQURZWNVTWBUSUTTVAVBVLVKVNEDWFVSVCAVEVNBVFVGVKVLWACDW
    GWEVCVMVTWQVHAWAVFVIVJ $.

  $( The ` M + 1 ` -th bit of ` 2 N ` is the ` M ` -th bit of ` N ` .
     (Contributed by Mario Carneiro, 5-Sep-2016.) $)
  bitsp1e $p |- ( ( N e. ZZ /\ M e. NN0 ) ->
    ( ( M + 1 ) e. ( bits ` ( 2 x. N ) ) <-> M e. ( bits ` N ) ) ) $=
    ( cz wcel cn0 wa c1 caddc co c2 cmul cbits cfv cdiv cfl wb 2z a1i id fveq2d
    zmulcld bitsp1 sylan wceq zcn zcnd cc0 wne 2ne0 divcan3d flid adantr eleq2d
    eqtrd bitrd ) BCDZAEDZFZAGHIJBKIZLMDZAUSJNIZOMZLMZDZABLMZDUPUSCDUQUTVDPUPJB
    JCDUPQRZUPSUAAUSUBUCURVCVEAURVBBLUPVBBUDUQUPVBBOMBUPVABOUPBJBUEUPJVFUFJUGUH
    UPUIRUJTBUKUNULTUMUO $.

  $( The ` M + 1 ` -th bit of ` 2 N + 1 ` is the ` M ` -th bit of ` N ` .
     (Contributed by Mario Carneiro, 5-Sep-2016.) $)
  bitsp1o $p |- ( ( N e. ZZ /\ M e. NN0 ) ->
    ( ( M + 1 ) e. ( bits ` ( ( 2 x. N ) + 1 ) ) <-> M e. ( bits ` N ) ) ) $=
    ( cz wcel wa c1 caddc co c2 cbits cfv cdiv cfl wb a1i wceq cr 2re cc cc0 2z
    cn0 cmul id zmulcld peano2zd bitsp1 sylan zre remulcld recnd ax-1cn 2cn wne
    2ne0 divdird zcn divcan3d oveq1d fveq2d cle wbr clt rereccli halfgt0 ltleii
    eqtrd 0re halflt1 pm3.2i flbi2 mpan2 mpbiri adantr eleq2d bitrd ) BCDZAUBDZ
    EZAFGHIBUCHZFGHZJKDZAWAILHZMKZJKZDZABJKZDVQWACDVRWBWFNVQVTVQIBICDVQUAOVQUDU
    EUFAWAUGUHVSWEWGAVSWDBJVQWDBPVRVQWDBFILHZGHZMKZBVQWCWIMVQWCVTILHZWHGHWIVQVT
    FIVQVTVQIBIQDVQROBUIUJUKFSDVQULOISDVQUMOZITUNVQUOOZUPVQWKBWHGVQBIBUQWLWMURU
    SVGUTVQWJBPZTWHVAVBZWHFVCVBZEZWOWPTWHVHIRUOVDZVEVFVIVJVQWHQDWNWQNWRWHBVKVLV
    MVGVNUTVOVP $.

  ${
    $d m n N $.  $d m S $.
    bitsfzo.1 $e |- ( ph -> N e. NN0 ) $.
    bitsfzo.2 $e |- ( ph -> M e. NN0 ) $.
    bitsfzo.3 $e |- ( ph -> ( bits ` N ) C_ ( 0 ..^ M ) ) $.
    bitsfzo.4 $e |- S = sup ( { n e. NN0 | N < ( 2 ^ n ) } , RR , `' < ) $.
    $( Lemma for ~ bitsfzo .  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
    bitsfzolem $p |- ( ph -> N e. ( 0 ..^ ( 2 ^ M ) ) ) $=
      ( cc0 wcel c2 cexp co clt wbr cn0 a1i cle c1 vm cuz cfv cz nn0uz syl6eleq
      cfzo cn 2nn nnexpcld nnzd wn cmin cbits wss adantr cdiv cfl cdivides 1lt2
      wa 1re 2re ltnlei mpbi wi 2z 1nn dvdsle mp2an mto wceq caddc cmul cv crab
      ssrab2 cr ccnv csup c0 sseqtri wrex nnssnn0 nn0red expnbnd syl3anc ssrexv
      wne mpsyl rabn0 sylibr infmssuzcl sylancr syl5eqel sseldi 0z zred nn0ge0d
      nn0zd nnred simpr oveq2 breq2d cbvrabv elrab2 simprbi syl lelttrd ltexp2d
      reexpcld mpbird elnnz nnm1nn0 nncnd mulid2d ltm1d ltnled mpbid infmssuzle
      sylanbrc mpan syl5eqbr syl5bir mpand mtod lenltd eqbrtrd crp 2rp rpexpcld
      1z zsubcld lemuldivd cc 2cn expm1t breqtrd wb syl2anc syl6breq rerpdivcld
      ltdivmuld df-2 sylancl mpbir2and mtbiri bitsval2 sseldd elfzolt2 pm2.65da
      flbi zlem1lt elfzo2 syl3anbrc ) AEJUBUCZKLDMNZUDKEUUQOPZEJUUQUGNKAEQUUPFU
      EUFAUUQALDLUHKZAUIRZGUJZUKAUURUUQESPZULAUVBBDSPZAUVBVAZUVCBTUMNZDOPZUVDUV
      EJDUGNZKUVFUVDEUNUCZUVGUVEAUVHUVGUOUVBHUPUVDUVEUVHKZLELUVEMNZUQNZURUCZUSP
      ZULZUVDUVMLTUSPZUVOLTSPZTLOPZUVPULUTTLVBVCVDVELUDKTUHKUVOUVPVFVGVHLTVIVJV
      KUVDUVLTLUSUVDUVLTVLZTUVKSPZUVKTTVMNZOPZUVDTUVJVNNZESPUVSUVDUWBUVJESUVDUV
      JUVDUVJUVDLUVEUUSUVDUIRUVDBUHKZUVEQKZUVDBUDKZJBOPUWCAUWEUVBABAELCVOZMNZOP
      ZCQVPZQBUWHCQVQZABUWIVROVSVTZUWIIAUWIUUPUOZUWIWAWIZUWKUWIKUWIQUUPUWJUEWBZ
      AUWHCQWCZUWMUHQUOAUWHCUHWCZUWOWDAEVRKZLVRKZUVQUWPAEFWEZUWRAVCRUVQAUTRELCW
      FWGUWHCUHQWHWJUWHCQWKWLUWIJWMWNWOZWPZWTUPZUVDJDBUVDJJUDKUVDWQRWRUVDDADUDK
      ZUVBADGWTUPZWRZUVDBUXBWRZUVDDADQKUVBGUPZWSUVDDBOPZUUQLBMNZOPUVDUUQEUXIUVD
      LDUWRUVDVCRZUXGXKAUWQUVBUWSUPZUVDUXIAUXIUHKUVBALBUUTUXAUJUPXAAUVBXBUVDBUW
      IKZEUXIOPZAUXLUVBUWTUPUXLBQKUXMELUAVOZMNZOPZUXMUABQUWIUXNBVLUXOUXIEOUXNBL
      MXCXDUWHUXPCUAQUWFUXNVLUWGUXOEOUWFUXNLMXCXDXEZXFXGXHZXIUVDLDBUXJUXDUXBUVQ
      UVDUTRXJXLZXIBXMYAZBXNXHZUJZXOXPUVDUVJESPEUVJOPZULUVDUYCBUVESPZUVDUVEBOPU
      YDULUVDBUXFXQUVDUVEBUVDUVEUYAWEUXFXRXSUVDUWDUYCUYDUYAUWDUYCVAUVEUWIKZUVDU
      YDUXPUYCUAUVEQUWIUXNUVEVLUXOUVJEOUXNUVELMXCXDUXQXFUYEUYDVFUVDUYEBUWKUVESI
      UWLUYEUWKUVESPUWNUVEUWIJXTYBYCRYDYEYFUVDUVJEUVDUVJUYBXAUXKYGXLYHUVDTEUVJT
      VRKUVDVBRUXKUVDLUVELYIKUVDYJRUVDBTUXBTUDKZUVDYLRYMYKZYNXSUVDUVKLUVTOUVDUV
      KLOPEUVJLVNNZOPUVDEUXIUYHOUXRUVDLYOKUWCUXIUYHVLYPUXTLBYQWNYRUVDELUVJUXKUX
      JUYGUUCXLUUDUUAUVDUVKVRKUYFUVRUVSUWAVAYSUVDEUVJUXKUYGUUBYLUVKTUULUUEUUFXD
      UUGUVDEUDKZUWDUVIUVNYSAUYIUVBAEFWTUPUYAUVEEUUHYTXLUUIUVEJDUUJXHUVDUWEUXCU
      VCUVFYSUXBUXDBDUUMYTXLUVDUXHUVCULUXSUVDDBUXEUXFXRXSUUKAEUUQUWSAUUQUVAXAXR
      XLEJUUQUUNUUO $.
  $}

  ${
    $d m x M $.  $d m n x N $.
    $( The bits of a number are all less than ` M ` iff the number is
       nonnegative and less than ` 2 ^ M ` .  (Contributed by Mario Carneiro,
       5-Sep-2016.) $)
    bitsfzo $p |- ( ( N e. ZZ /\ M e. NN0 ) ->
      ( N e. ( 0 ..^ ( 2 ^ M ) ) <-> ( bits ` N ) C_ ( 0 ..^ M ) ) ) $=
      ( cz wcel cn0 wa cc0 c2 cexp co cfv cdivides wbr wn clt cr a1i cle mpbird
      c1 vm vn cfzo cbits wss cv cdiv cfl w3a bitsval cuz simp32 nn0uz syl6eleq
      simp1r nn0zd 2re reexpcld simp1l zred cmul recnd mulid2d crp 2rp rpexpcld
      simp33 rerpdivcld 1re ltnled caddc 0p1e1 breq2i elfzole1 3ad2ant2 divge0d
      wceq wb 0z flbi sylancl 2z dvds0 ax-mp id syl5breqr syl6bir mpand syl5bir
      sylbird mt3d lemuldivd eqbrtrrd elfzolt2 lelttrd ltexp2d elfzo2 syl3anbrc
      1lt2 3expia syl5bi ssrdv crab ccnv csup cn cif simpr nnred simpllr nn0red
      cneg max2 syl2anc simplr ltnlei mpbi wi 1nn dvdsle mp2an 1z dvdsnegb mtbi
      mto simplll 2nn nnnn0d ifcl nnexpcld nndivred zcnd nncnd 2cn wne breqtrrd
      cc 2ne0 nngt0d ax-1cn expne0d divnegd max1 bernneq3 sylancr ltled mulid1d
      letrd nnrpd ledivmuld eqbrtrd lenegcon1d divgt0d lt0neg1d neg1cn addcomli
      uzid negidi syl6breqr nn0negzi mpbir2and breq2d mtbiri bitsval2 syl mpbid
      1nn0 sseldd pm2.65da intnand wo simpll elznn0nn sylib ord eqid bitsfzolem
      impbida ) BCDZAEDZFZBGHAIJZUCJDZBUDKZGAUCJZUEZUWAUWCFZUAUWDUWEUAUFZUWDDUV
      SUWHEDZHBHUWHIJZUGJZUHKZLMZNZUIZUWGUWHUWEDZUWHBUJUWAUWCUWOUWPUWAUWCUWOUIZ
      UWHGUKKZDACDUWHAOMZUWPUWQUWHEUWRUWAUWCUVSUWIUWNULZUMUNUWQAUVSUVTUWCUWOUOZ
      UPZUWQUWSUWJUWBOMUWQUWJBUWBUWQHUWHHPDUWQUQQZUWTURZUWQBUVSUVTUWCUWOUSUTZUW
      QHAUXCUXAURUWQTUWJVAJZUWJBRUWQUWJUWQUWJUXDVBVCUWQUXFBRMTUWKRMZUWQUXGUWMUW
      AUWCUVSUWIUWNVGUWQUXGNUWKTOMZUWMUWQUWKTUWQBUWJUXEUWQHUWHHVDDUWQVEQUWQUWHU
      WTUPZVFZVHZTPDZUWQVIQZVJUXHUWKGTVKJZOMZUWQUWMUXNTUWKOVLVMUWQGUWKRMZUXOUWM
      UWQBUWJUXEUXJUWCUWAGBRMUWOBGUWBVNVOVPUWQUXPUXOFZUWLGVQZUWMUWQUWKPDGCDUXRU
      XQVRUXKVSUWKGVTWAUXRHGUWLLHCDZHGLMWBHWCWDUXRWEWFWGWHWIWJWKUWQTBUWJUXMUXEU
      XJWLSWMUWCUWABUWBOMUWOBGUWBWNVOWOUWQHUWHAUXCUXIUXBTHOMZUWQWSQWPSUWHGAWQWR
      WTXAXBUWAUWFFZBHUBUFIJOMUBEXCPOXDXEZUBABUYABEDZBPDZBXLZXFDZFZUYAUYFUYDUYA
      UYFAUYEARMZAUYEXGZRMZUYAUYFFZUYEPDZAPDZUYJUYKUYEUYAUYFXHZXIZUYKAUVSUVTUWF
      UYFXJZXKZUYEAXMXNUYKUYIAOMZUYJNUYKUYIUWEDUYRUYKUWDUWEUYIUWAUWFUYFXOUYKUYI
      UWDDZHBHUYIIJZUGJZUHKZLMZNZUYKVUCHTXLZLMZHTLMZVUFVUGHTRMZUXTVUHNWSTHVIUQX
      PXQUXSTXFDVUGVUHXRWBXSHTXTYAYEUXSTCDVUGVUFVRWBYBHTYCYAYDUYKVUBVUEHLUYKVUB
      VUEVQZVUEVUARMZVUAVUETVKJZOMZUYKVUATUYKBUYTUYKBUVSUVTUWFUYFYFZUTUYKHUYIHX
      FDUYKYGQUYKUVTUYEEDUYIEDZUYPUYKUYEUYNYHUYHAUYEEYIXNZYJZYKZUXLUYKVIQZUYKVU
      AXLZUYEUYTUGJZTRUYKBUYTUYKBVUMYLUYKUYTVUPYMZUYKHUYIHYQDUYKYNQHGYOUYKYRQUY
      KUYIVUOUPUUAUUBZUYKVUTTRMUYEUYTTVAJZRMUYKUYEUYTVVCRUYKUYEUYIUYTUYOUYKUYIV
      UOXKZUYKUYTVUPXIZUYKUYLUYMUYEUYIRMUYOUYQUYEAUUCXNUYKUYIUYTVVDVVEUYKHHUKKD
      ZVUNUYIUYTOMUXSVVFWBHUUQWDVUOHUYIUUDUUEUUFUUHUYKUYTVVAUUGYPUYKUYETUYTUYOV
      URUYKUYTVUPUUIUUJSUUKUULUYKVUAGVUKOUYKVUAGOMGVUSOMUYKGVUTVUSOUYKUYEUYTUYO
      VVEUYKUYEUYNYSUYKUYTVUPYSUUMVVBYPUYKVUAVUQUUNSTVUEGYTUUOTYTUURUUPUUSUYKVU
      APDVUECDVUIVUJVULFVRVUQTUVGUUTVUAVUEVTWAUVAUVBUVCUYKUVSVUNUYSVUDVRVUMVUOU
      YIBUVDXNSUVHUYIGAWNUVEUYKUYIAVVDUYQVJUVFUVIUVJUYAUYCUYGUYAUVSUYCUYGUVKUVS
      UVTUWFUVLBUVMUVNUVOWKUVSUVTUWFXOUWAUWFXHUYBUVPUVQUVR $.

    $( Truncating the bit sequence after some ` M ` is equivalent to reducing
       the argument ` mod 2 ^ M ` .  (Contributed by Mario Carneiro,
       6-Sep-2016.) $)
    bitsmod $p |- ( ( N e. ZZ /\ M e. NN0 ) -> ( bits `
      ( N mod ( 2 ^ M ) ) ) = ( ( bits ` N ) i^i ( 0 ..^ M ) ) ) $=
      ( cz wcel cn0 wa c2 co cfv cc0 cdiv cdivides wbr clt nn0zd wb ad2antrr c1
      a1i syl3anc vx cexp cmo cbits cfzo cin cv cfl wn w3a simpl simpr nnexpcld
      2nn zmodcld biantrurd simplr bitsval2 syl2anc biantrud cmin zred nndivred
      cn 2z flcld cmul caddc 2cn expp1d cuz 1nn0 nn0addcld cle adantr nn0ltp1le
      cc mpbid eluz2 syl3anbrc dvdsexp eqbrtrrd crp nnrpd moddifz wne nnzd 2ne0
      cr expne0d zsubcld dvdsval2 mpbird wi zmulcld dvdstr mp2and zcnd divcan2d
      nncnd nn0red ltled dvdscmulr syl112anc pncan3d oveq1d divdird eqtr3d wceq
      breqtrrd fveq2d fladdz eqtrd pncan2d dvdssub2 syl31anc notbid dvds0 ax-mp
      3bitr3d 2rp rpexpcld modcld nn0ge0d divge0d rpred modlt 1re ltleii lenltd
      2re 1lt2 leexp2ad ltletrd rpcnd mulid1d bitr3d an12 3anass 3bitr4g syl6bb
      ltdivmuld syl6breq rerpdivcld 0z flbi sylancl mpbir2and syl5breqr intnand
      1e0p1 2thd con2bid pm2.61dan pm5.32da elfzo2 elnn0uz 3anbi1i anbi2i bitri
      3bitr2i bitsval elin eqrdv ) BCDZAEDZFZUABGAUBHZUCHZUDIZBUDIZJAUEHZUFZUVG
      UVICDZUAUGZEDZGUVIGUVOUBHZKHZUHIZLMZUIZUJZUVOUVKDZUVOUVLDZFZUVOUVJDUVOUVM
      DUVGUVNUVPUWAFZFZUVPUWCACDZUVOANMZFZFZFZUWBUWEUVGUWFUWGUWLUVGUVNUWFUVGUVI
      UVGBUVHUVEUVFUKZUVGGAGVDDZUVGUNSUVEUVFULUMZUOZOZUPUVGUVPUWAUWKUVGUVPFZUWA
      UWHUWCUWIFZFZUWKUWRUWSUWAUWTUWRUWIUWSUWAPUWRUWIFZUWCGBUVQKHZUHIZLMZUIZUWS
      UWAUXAUVEUVPUWCUXEPUVGUVEUVPUWIUWMQZUVGUVPUWIUQZUVOBURUSUXAUWIUWCUWRUWIUL
      ZUTUXAUXDUVTUXAGCDZUXCCDUVSCDGUXCUVSVAHZLMUXDUVTPUXIUXAVESZUXAUXBUXABUVQU
      XABUXFVBZUXAGUVOUWNUXAUNSUXGUMZVCVFUXAUVRUXAUVIUVQUXAUVIUVGUVNUVPUWIUWQQZ
      VBUXMVCZVFZUXAGBUVIVAHZUVQKHZUXJLUXAUVQGVGHZUVQUXRVGHZLMZGUXRLMZUXAUXSUXQ
      UXTLUXAUXSUVHLMZUVHUXQLMZUXSUXQLMZUXAGUVORVHHZUBHZUXSUVHLUXAGUVOGVQDUXAVI
      SZUXGVJUXAUXIUYFEDAUYFVKIDZUYGUVHLMUXKUXAUVORUXGREDUXAVLSVMZUXAUYFCDUWHUY
      FAVNMZUYIUXAUYFUYJOUXAAUWRUVFUWIUVEUVFUVPUQZVOZOZUXAUWIUYKUXHUXAUVPUVFUWI
      UYKPUXGUYMUVOAVPUSVRUYFAVSVTGUYFAWATWBUXAUYDUXQUVHKHCDZUXABWIDZUVHWCDZUYO
      UXLUXAUVHUVGUVHVDDUVPUWIUWOQZWDBUVHWEUSUXAUVHCDZUVHJWFUXQCDZUYDUYOPUXAUVH
      UYRWGZUXAGAUYHGJWFUXAWHSZUYNWJUXABUVIUXFUXNWKZUVHUXQWLTWMZUXAUXSCDUYSUYTU
      YCUYDFUYEWNUXAUVQGUXAUVQUXMWGZUXKWOVUAVUCUXSUVHUXQWPTWQUXAUXQUVQUXAUXQVUC
      WRZUXAUVQUXMWTZUXAGUVOUYHVUBUXAUVOUXGOZWJZWSXJUXAUXIUXRCDZUVQCDZUVQJWFZUY
      AUYBPUXKUXAUVQUXQLMZVUJUXAUVQUVHLMZUYDVUMUXAUXIUVPAUVOVKIDZVUNUXKUXGUXAUV
      OCDZUWHUVOAVNMVUOVUHUYNUXAUVOAUXAUVOUXGXAUXAAUYMXAUXHXBUVOAVSVTGUVOAWATVU
      DUXAVUKUYSUYTVUNUYDFVUMWNVUEVUAVUCUVQUVHUXQWPTWQUXAVUKVULUYTVUMVUJPVUEVUI
      VUCUVQUXQWLTVRZVUEVUIUVQGUXRXCXDVRUXAUXJUVSUXRVHHZUVSVAHUXRUXAUXCVURUVSVA
      UXAUXCUVRUXRVHHZUHIZVURUXAUXBVUSUHUXAUVIUXQVHHZUVQKHUXBVUSUXAVVABUVQKUXAU
      VIBUXAUVIUXNWRZUXABUXFWRXEXFUXAUVIUXQUVQVVBVUFVUGVUIXGXHXKUXAUVRWIDZVUJVU
      TVURXIUXOVUQUVRUXRXLUSXMXFUXAUVSUXRUXAUVSUXPWRUXAUXRVUQWRXNXMXJGUXCUVSXOX
      PXQXTUWRUWIUIZFZUVTUWSVVEUVTUWSUIVVEGJUVSLUXIGJLMVEGXRXSVVEUVSJXIZJUVRVNM
      ZUVRJRVHHZNMZVVEUVIUVQVVEBUVHVVEBUVGUVEUVPVVDUWMQVBZVVEGAGWCDVVEYASZUWRUW
      HVVDUWRAUYLOZVOZYBZYCZVVEGUVOVVKVVEUVOUVGUVPVVDUQZOZYBZVVEUVIUVGUVIEDUVPV
      VDUWPQYDYEVVEUVRRVVHNVVEUVRRNMUVIUVQRVGHZNMVVEUVIUVQVVSNVVEUVIUVHUVQVVOVV
      EUVHVVNYFVVEUVQVVRYFVVEUYPUYQUVIUVHNMVVJVVNBUVHYGUSVVEGAUVOVVEGVVKYFRGVNM
      VVERGYHYKYLYISVVEUWHVUPAUVOVNMZUVOAVKIDVVMVVQVVEVVTVVDUWRVVDULZVVEAUVOVVE
      AVVMVBVVEUVOVVPXAYJWMAUVOVSVTYMYNVVEUVQVVEUVQVVRYOYPXJVVEUVIRUVQVVORWIDVV
      EYHSVVRUUBWMUUKUUCVVEVVCJCDVVFVVGVVIFPVVEUVIUVQVVOVVRUUDUUEUVRJUUFUUGUUHU
      UIVVEUWIUWCVWAUUJUULUUMUUNUWRUWHUWSVVLUPYQUWHUWCUWIYRUUAUUOYQUVNUVPUWAYSU
      WEUWCUVPUWJFZFUWLUWDVWBUWCUWDUVOJVKIDZUWHUWIUJUVPUWHUWIUJVWBUVOJAUUPUVPVW
      CUWHUWIUVOUUQUURUVPUWHUWIYSUVAUUSUWCUVPUWJYRUUTYTUVOUVIUVBUVOUVKUVLUVCYTU
      VD $.

    $( Every number is associated to a finite set of bits.  (Contributed by
       Mario Carneiro, 5-Sep-2016.) $)
    bitsfi $p |- ( N e. NN0 -> ( bits ` N ) e. Fin ) $=
      ( vm cn0 wcel c2 cv cexp co clt wbr cbits cfv cfn cn cr a1i wa cc0 cfzo
      cz wrex nn0re 2re 1lt2 expnbnd syl3anc wss fzofi cuz simpl nn0uz syl6eleq
      c1 simprl nnnn0d nnexpcld nnzd simprr elfzo2 syl3anbrc wb bitsfzo syl2anc
      2nn nn0zd mpbid ssfi sylancr rexlimddv ) ACDZAEBFZGHZIJZAKLZMDZBNVJAODEOD
      ZUMEIJZVMBNUAAUBVPVJUCPVQVJUDPAEBUEUFVJVKNDZVMQZQZRVKSHZMDVNWAUGZVORVKUHV
      TARVLSHDZWBVTARUILZDVLTDVMWCVTACWDVJVSUJZUKULVTVLVTEVKENDVTVDPVTVKVJVRVMU
      NUOZUPUQVJVRVMURARVLUSUTVTATDVKCDWCWBVAVTAWEVEWFVKAVBVCVFWAVNVGVHVI $.

    $( The bit complement of ` N ` is ` -u N - 1 ` .  (Thus, by ~ bitsfi , all
       negative numbers have cofinite ` bits ` representations.)  (Contributed
       by Mario Carneiro, 5-Sep-2016.) $)
    bitscmp $p |- ( N e. ZZ ->
      ( NN0 \ ( bits ` N ) ) = ( bits ` ( -u N - 1 ) ) ) $=
      ( cz wcel cn0 cfv cneg c1 co wn wa c2 cdivides wbr wb a1i syl2anc cle clt
      cdiv mpbid vm cbits cdif cmin cv cexp cfl bitsval2 2z simpl zred cn simpr
      nnexpcld nndivred flcld dvdsnegb notbid znegcld oddm1even wceq caddc cmul
      2nn syl cr flltp1 1re readdcld ltnegd recnd negdi2d nncnd divnegd 3brtr3d
      nnne0d 1z zsubcld renegcld ltmuldivd mpbird nnzd zmulcld zltlem1 resubcld
      nnrpd lemuldivd lenegd eqbrtrrd ledivmuld zlem1lt ltdivmuld negcld npcand
      flle breqtrrd flbi mpbir2and breq2d bitr4d pm5.32da biantrurd bitrd eldif
      3bitrd znegcl w3a bitsval 3anass bitri 3bitr4g eqrdv ) ABCZUADAUBEZUCZAFZ
      GUDHZUBEZXMUAUEZDCZXSXNCZIZJZXQBCZXTKXQKXSUFHZSHZUGEZLMZIZJZJZXSXOCXSXRCZ
      XMYCYJYKXMXTYBYIXMXTJZYAYHYMYAKAYESHZUGEZLMZIKYOFZLMZIZYHXSAUHYMYPYRYMKBC
      ZYOBCYPYRNYTYMUIOYMYNYMAYEYMAXMXTUJZUKZYMKXSKULCYMVDOXMXTUMUNZUOZUPZKYOUQ
      PURYMYSKYQGUDHZLMZYHYMYQBCYSUUGNYMYOUUEUSZYQUTVEYMYGUUFKLYMYGUUFVAZUUFYFQ
      MZYFUUFGVBHZRMZYMUUFYEVCHZXQQMZUUJYMUUMXPRMZUUNYMUUOUUFXPYESHZRMYMYOGVBHZ
      FZYNFZUUFUUPRYMYNUUQRMZUURUUSRMYMYNVFCZUUTUUDYNVGVEYMYNUUQUUDYMYOGYMYOUUE
      UKZGVFCYMVHOZVIVJTYMYOGYMYOUVBVKZYMGUVCVKZVLYMAYEYMAUUBVKYMYEUUCVMYMYEUUC
      VPVNZVOYMUUFXPYEYMUUFYMYQGUUHGBCZYMVQOVRZUKZYMAUUBVSZYMYEUUCWFZVTWAYMUUMB
      CXPBCZUUOUUNNYMUUFYEUVHYMYEUUCWBZWCYMAUUAUSZUUMXPWDPTYMUUFXQYEUVIYMXPGUVJ
      UVCWEZUVKWGTYMYFYQUUKRYMYFYQRMXQYEYQVCHZRMZYMXPUVPQMZUVQYMUUPYQQMUVRYMUUS
      UUPYQQUVFYMYOYNQMZUUSYQQMYMUVAUVSUUDYNWOVEYMYOYNUVBUUDWHTWIYMXPYQYEUVJYMY
      OUVBVSZUVKWJTYMUVLUVPBCUVRUVQNUVNYMYEYQUVMUUHWCXPUVPWKPTYMXQYQYEUVOUVTUVK
      WLWAYMYQGYMYOUVDWMUVEWNWPYMYFVFCUUFBCUUIUUJUULJNYMXQYEUVOUUCUOUVHYFUUFWQP
      WRWSWTXEURXAXMYDYJXMXPGAXFUVGXMVQOVRXBXCXSDXNXDYLYDXTYIXGYKXSXQXHYDXTYIXI
      XJXKXL $.
  $}

  $( The bits of zero.  (Contributed by Mario Carneiro, 6-Sep-2016.) $)
  0bits $p |- ( bits ` 0 ) = (/) $=
    ( cc0 cbits cfv c0 cfzo co c2 cexp wcel wss c1 csn c0ex snid fzo01 eleqtrri
    cc wceq 2cn exp0 ax-mp oveq2i cz wb 0z 0nn0 bitsfzo mp2an mpbi fzo0 sseqtri
    cn0 0ss eqssi ) ABCZDUOAAEFZDAAGAHFZEFZIZUOUPJZAAKEFZURAALVAAMNOPUQKAEGQIUQ
    KRSGTUAUBPAUCIAULIUSUTUDUEUFAAUGUHUIAUJUKUOUMUN $.

  $( The bits of negative one.  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
  m1bits $p |- ( bits ` -u 1 ) = NN0 $=
    ( cn0 cc0 cbits cdif cneg c1 cmin co cz wcel wceq 0z bitscmp ax-mp c0 0bits
    cfv difeq2i dif0 eqtri neg0 oveq1i df-neg eqtr4i fveq2i 3eqtr3ri ) ABCQZDZB
    EZFGHZCQZAFEZCQBIJUHUKKLBMNUHAODAUGOAPRASTUJULCUJBFGHULUIBFGUAUBFUCUDUEUF
    $.

  ${
    $d k m n x A $.  $d k n x y N $.
    $( Lemma for ~ bitsinv1 .  (Contributed by Mario Carneiro, 22-Sep-2016.) $)
    bitsinv1lem $p |- ( ( N e. ZZ /\ M e. NN0 ) ->
     ( N mod ( 2 ^ ( M + 1 ) ) ) = ( ( N mod ( 2 ^ M ) ) +
       if ( M e. ( bits ` N ) , ( 2 ^ M ) , 0 ) ) ) $=
      ( wcel c2 c1 caddc co wceq cc0 cmin a1i adantr cdiv cdivides syl2anc cmul
      cz wbr clt cle cbits cfv cexp cmo cif cn0 wa oveq2 eqeq2d cc simpl cn 2nn
      simpr nnexpcld zmodcld nn0cnd 1nn0 nn0addcld pncan3d subcld nncnd wne 2cn
      simplr 2ne0 nn0zd expne0d wn 2z dvds0 ax-mp id syl5breqr cfl bitsval2 crp
      zred nnrpd moddiffl breq2d moddifz zcnd nnncan1d oveq1d divsubdird eqtr3d
      cr mulcomd expp1d eqtr4d oveq12d divcan5d peano2zd div23d 3eqtr3d zmulcld
      eqeltrd zsubcld dvdsmul2 nnncan2d breqtrrd dvdssub2 syl31anc bitr3d bitrd
      wb notbid con2bid syl5ib con2d cpr wo cfzo cuz cneg df-neg nnred renegcld
      mulm1d modcld resubcld modlt ltnegd mpbid modge0 lesub1dd ltletrd eqbrtrd
      0re syl5eqbr 1re ltmuldivd syl5eqbrr zlem1lt mpbird elnn0z syl6eleq imp
      0z sylanbrc subge02d lelttrd breqtrd ltdivmuld elfzo2 syl3anbrc fzo0to2pr
      nn0uz elpri syl ord syld diveq1d oveq2d 1lt2 2re ltnlei mpbi wi 1nn mp2an
      dvdsle breq2 mtbiri syl6 sylibrd con1d diveq0d subeq0d addid1d ifbothda
      mto ) ABUAUBCZBDAEFGZUCGZUDGZBDAUCGZUDGZUVRFGZHUVQUVSIFGZHUVQUVSUVNUVRIUE
      ZFGZHBQCZAUFCZUGZUVRIUVRUWBHUVTUWCUVQUVRUWBUVSFUHUIIUWBHUWAUWCUVQIUWBUVSF
      UHUIUWFUVNUGZUVSUVQUVSJGZFGUVQUVTUWGUVSUVQUWFUVSUJCZUVNUWFUVSUWFBUVRUWDUW
      EUKZUWFDADULCZUWFUMKZUWDUWEUNZUOZUPUQZLUWFUVQUJCZUVNUWFUVQUWFBUVPUWJUWFDU
      VOUWLUWFAEUWMEUFCUWFURKUSUOZUPUQZLUTUWGUWHUVRUVSFUWGUWHUVRUWFUWHUJCZUVNUW
      FUVQUVSUWRUWOVAZLUWGUVRUWGDAUWKUWGUMKUWDUWEUVNVEUOVBUWFUVRIVCZUVNUWFDADUJ
      CUWFVDKZDIVCUWFVFKZUWFAUWMVGZVHZLUWFUVNUWHUVRMGZEHZUWFUVNUXFIHZVIZUXGUWFU
      XHUVNUXHDUXFNRZUWFUVNVIZUXHDIUXFNDQCZDINRVJDVKVLUXHVMVNUWFUVNUXJUWFUVNDBU
      VRMGVOUBZNRZVIUXJVIZABVPUWFUXNUXJUWFDBUVSJGZUVRMGZNRZUXNUXJUWFUXQUXMDNUWF
      BWHCZUVRVQCZUXQUXMHUWFBUWJVRZUWFUVRUWNVSZBUVRVTOWAUWFUXLUXQQCZUXFQCZDUXQU
      XFJGZNRUXRUXJXGUXLUWFVJKZUWFUXSUXTUYCUYAUYBBUVRWBOZUWFUXFUXQBUVQJGZUVRMGZ
      JGZQUWFUXPUYHJGZUVRMGUXFUYJUWFUYKUWHUVRMUWFBUVSUVQUWFBUWJWCZUWOUWRWDWEUWF
      UXPUYHUVRUWFBUVSUYLUWOVAZUWFBUVQUYLUWRVAZUWFUVRUWNVBZUXEWFWGUWFUXQUYIUYGU
      WFUYIUYHUVPMGZDPGZQUWFDUYHPGZDUVRPGZMGUYHDPGZUVPMGUYIUYQUWFUYRUYTUYSUVPMU
      WFDUYHUXBUYNWIUWFUYSUVRDPGZUVPUWFDUVRUXBUYOWIUWFDAUXBUWMWJZWKWLUWFUYHUVRD
      UYNUYOUXBUXEUXCWMUWFUYHDUVPUYNUXBUWFUVPUWQVBUWFDUVOUXBUXCUWFAUXDWNVHWOWPZ
      UWFUYPDUWFUXSUVPVQCZUYPQCZUYAUWFUVPUWQVSZBUVPWBOZUYFWQWRWSWRZUWFDUYQUYENU
      WFVUEUXLDUYQNRVUGUYFUYPDWTOUWFUXPUWHJGZUVRMGUYIUYEUYQUWFVUIUYHUVRMUWFBUVQ
      UVSUYLUWRUWOXAWEUWFUXPUWHUVRUYMUWTUYOUXEWFVUCWPXBDUXQUXFXCXDXEXHXFZXIXJXK
      UWFUXHUXGUWFUXFIEXLZCUXHUXGXMUWFUXFIDXNGZVUKUWFUXFIXOUBZCUXLUXFDSRZUXFVUL
      CUWFUXFUFVUMUWFUYDIUXFTRZUXFUFCVUHUWFVUOIEJGZUXFSRZUWFVUPEXPZUXFSEXQUWFVU
      RUVRPGZUWHSRVURUXFSRUWFVUSUVRXPZUWHSUWFUVRUYOXTUWFVUTUVSXPZUWHUWFUVRUWFUV
      RUWNXRZXSUWFUVSUWFBUVRUYAUYBYAZXSUWFUVQUVSUWFBUVPUYAVUFYAZVVCYBZUWFUVSUVR
      SRZVUTVVASRUWFUXSUXTVVFUYAUYBBUVRYCOUWFUVSUVRVVCVVBYDYEUWFVVAIUVSJGUWHTUV
      SXQUWFIUVQUVSIWHCUWFYJKVVDVVCUWFUXSVUDIUVQTRUYAVUFBUVPYFOYGYKYHYIUWFVURUW
      HUVRUWFEEWHCUWFYLKXSVVEUYBYMYEYNUWFIQCZUYDVUOVUQXGVVGUWFYTKVUHIUXFYOOYPUX
      FYQUUAUUIYRUYFUWFVUNUWHVUASRUWFUWHUVPVUASUWFUWHUVQUVPVVEVVDUWFUVPUWQXRUWF
      IUVSTRZUWHUVQTRUWFUXSUXTVVHUYAUYBBUVRYFOUWFUVQUVSVVDVVCUUBYEUWFUXSVUDUVQU
      VPSRUYAVUFBUVPYCOUUCVUBUUDUWFUWHDUVRVVEUWFDUWLXRUYBUUEYPUXFIDUUFUUGUUHYRU
      XFIEUUJUUKUULZUUMYSUUNUUOWGUWFUXKUGZUVQUVSUWAVVJUVQUVSUWFUWPUXKUWRLUWFUWI
      UXKUWOLZVVJUWHUVRUWFUWSUXKUWTLUWFUVRUJCUXKUYOLUWFUXAUXKUXELUWFUXKUXHUWFUX
      HUVNUWFUXIUXOUVNUWFUXIUXGUXOVVIUXGUXJDENRZVVLDETRZEDSRVVMVIUUPEDYLUUQUURU
      USUXLEULCVVLVVMUUTVJUVADEUVCUVBUVMUXFEDNUVDUVEUVFVUJUVGUVHYSUVIUVJVVJUVSV
      VKUVKWKUVL $.

    $( There is an explicit inverse to the ` bits ` function for nonnegative
       integers (which can be extended to negative integers using ~ bitscmp ),
       part 1.  (Contributed by Mario Carneiro, 7-Sep-2016.) $)
    bitsinv1 $p |- ( N e. NN0 -> sum_ n e. ( bits ` N ) ( 2 ^ n ) = N ) $=
      ( cn0 wcel cc0 cfzo co cin c2 cexp csu cmo wceq wi caddc c0 syl6eq ineq2d
      oveq2 sumeq1d vx vk cbits cfv cv c1 fzo0 in0 sum0 2cn exp0 oveq2d eqeq12d
      cc ax-mp imbi2d cz zmod10 syl eqcomd wa csn oveq1 wn fzonel disjsn sylibr
      nn0z a1i inindi 3eqtr3g cun cuz simpr nn0uz syl6eleq fzosplitsn cfn fzofi
      indi wss inss2 ssfi mp2an 2nn sseldi elfzouz syl6eleqr nnexpcld fsumsplit
      cn nncnd cif bitsinv1lem sylan eqeq2 snssd dfss1 sylib simplr sumsn eqtrd
      syl2anc ifbothda eqtr4d syl5ibr expcom a2d nn0ind pm2.43i clt wbr id nnzd
      2z uzid bernneq3 elfzo2 syl3anbrc wb bitsfzo mpbid df-ss cr crp cle nn0re
      mpan 2rp rpexpcld nn0ge0 modid syl22anc 3eqtr3d ) BCDZBUCUDZEBFGZHZIAUEZJ
      GZAKZBIBJGZLGZYPYTAKBYOUUAUUCMZYOYPEUAUEZFGZHZYTAKZBIUUEJGZLGZMZNYOEBUFLG
      ZMZNYOYPEUBUEZFGZHZYTAKZBIUUNJGZLGZMZNYOYPEUUNUFOGZFGZHZYTAKZBIUVAJGZLGZM
      ZNYOUUDNUAUBBUUEEMZUUKUUMYOUVHUUHEUUJUULUVHUUHPYTAKZEUVHUUGPYTAUVHUUGYPPH
      ZPUVHUUFPYPUVHUUFEEFGPUUEEEFSEUGQRYPUHZQTYTAUIZQUVHUUIUFBLUVHUUIIEJGZUFUU
      EEIJSIUNDUVMUFMUJIUKUOQULUMUPUUEUUNMZUUKUUTYOUVNUUHUUQUUJUUSUVNUUGUUPYTAU
      VNUUFUUOYPUUEUUNEFSRTUVNUUIUURBLUUEUUNIJSULUMUPUUEUVAMZUUKUVGYOUVOUUHUVDU
      UJUVFUVOUUGUVCYTAUVOUUFUVBYPUUEUVAEFSRTUVOUUIUVEBLUUEUVAIJSULUMUPUUEBMZUU
      KUUDYOUVPUUHUUAUUJUUCUVPUUGYRYTAUVPUUFYQYPUUEBEFSRTUVPUUIUUBBLUUEBIJSULUM
      UPYOUULEYOBUQDZUULEMBVHZBURUSUTUUNCDZYOUUTUVGYOUVSUUTUVGNUUTUVGYOUVSVAZUU
      QYPUUNVBZHZYTAKZOGZUUSUWCOGZMUUQUUSUWCOVCUVTUVDUWDUVFUWEUVTUUPUWBYTUVCAUV
      TYPUUOUWAHZHUVJUUPUWBHPUVTUWFPYPUVTUUNUUODVDZUWFPMUWGUVTEUUNVEVIUUOUUNVFV
      GRYPUUOUWAVJUVKVKUVTUVCYPUUOUWAVLZHUUPUWBVLUVTUVBUWHYPUVTUUNEVMUDZDUVBUWH
      MUVTUUNCUWIYOUVSVNVOVPEUUNVQUSRYPUUOUWAVTQUVCVRDZUVTUVBVRDUVCUVBWAUWJEUVA
      VSYPUVBWBZUVBUVCWCWDVIUVTYSUVCDZVAZYTUWMIYSIWKDZUWMWEVIUWMYSUWICUWMYSUVBD
      YSUWIDUWMUVCUVBYSUWKUVTUWLVNWFYSEUVAWGUSVOWHWIWLWJUVTUVFUUSUUNYPDZUUREWMZ
      OGZUWEYOUVQUVSUVFUWQMUVRUUNBWNWOUVTUWCUWPUUSOUWOUWCUURMUWCEMUWCUWPMUVTUUR
      EUURUWPUWCWPEUWPUWCWPUVTUWOVAZUWCUWAYTAKZUURUWRUWBUWAYTAUWRUWAYPWAUWBUWAM
      UWRUUNYPUVTUWOVNWQUWAYPWRWSTUWRUVSUURUNDUWSUURMYOUVSUWOWTZUWRUURUWRIUUNUW
      NUWRWEVIUWTWIWLYTUURAUUNCYSUUNIJSXAXCXBUVTUWOVDZVAZUWCUVIEUXBUWBPYTAUXBUX
      AUWBPMUVTUXAVNYPUUNVFVGTUVLQXDULXEUMXFXGXHXIXJYOYRYPYTAYOYPYQWAZYRYPMYOBE
      UUBFGDZUXCYOBUWIDUUBUQDBUUBXKXLZUXDYOBCUWIYOXMZVOVPYOUUBYOIBUWNYOWEVIUXFW
      IXNIIVMUDDZYOUXEIUQDUXGXOIXPUOIBXQYHZBEUUBXRXSYOUVQYOUXDUXCXTUVRUXFBBYAXC
      YBYPYQYCWSTYOBYDDUUBYEDEBYFXLUXEUUCBMBYGYOIBIYEDYOYIVIUVRYJBYKUXHBUUBYLYM
      YN $.

    $( There is an explicit inverse to the ` bits ` function for nonnegative
       integers, part 2.  (Contributed by Mario Carneiro, 8-Sep-2016.) $)
    bitsinv2 $p |- ( A e. ( ~P NN0 i^i Fin ) ->
      ( bits ` sum_ n e. A ( 2 ^ n ) ) = A ) $=
      ( vk vm cn0 cfn wcel c2 cv cexp co csu cfv wss elfpw a1i syl sumeq1 sumex
      wceq cpw cin cbits cmpt simprbi wa 2nn0 simplbi sselda nn0expcld bitsinv1
      fsumnn0cl bitsss bitsfi sylanbrc oveq2 cbvsumv syl5eq eqid 3eqtr4d wf1 wb
      fvmpt wf1o ackbijnn f1of1 mp1i id f1fveq syl12anc mpbid ) AEUAFUBZGZAHBIZ
      JKZBLZUCMZCVLCIZVOBLZUDZMZAVTMZTZVQATZVMVQHDIZJKZDLZVPWAWBVMVPEGZWGVPTVMA
      VOBVMAENZAFGZAEOZUEVMVNAGUFZHVNHEGWLUGPVMAEVNVMWIWJWKUHUIUJULZDVPUKQVMVQV
      LGZWAWGTVMVQENZVQFGZWNWOVMVPUMPVMWHWPWMVPUNQVQEOUOZCVQVSWGVLVTVRVQTVSVRWF
      DLWGVRVOWFBDVNWEHJUPUQVRVQWFDRURVTUSZVQWFDSVCQCAVSVPVLVTVRAVOBRWRAVOBSVCU
      TVMVLEVTVAZWNVMWCWDVBVLEVTVDWSVMCBVTWRVEVLEVTVFVGWQVMVHVLEVQAVTVIVJVK $.

    $( The ` bits ` function restricted to nonnegative integers is a bijection
       from the integers to the finite sets of integers.  It is in fact the
       inverse of the Ackermann bijection ~ ackbijnn .  (Contributed by Mario
       Carneiro, 8-Sep-2016.) $)
    bitsf1ocnv $p |- ( ( bits |` NN0 ) : NN0 -1-1-onto-> ( ~P NN0 i^i Fin ) /\
     `' ( bits |` NN0 ) =
        ( x e. ( ~P NN0 i^i Fin ) |-> sum_ n e. x ( 2 ^ n ) ) ) $=
      ( vk cn0 cfn cbits cres wf1o ccnv cv c2 csu cmpt wceq wa wtru wcel wss cz
      a1i cpw cin cexp co eqid bitsss bitsfi elfpw sylanbrc adantl simprbi 2nn0
      cfv simplbi sselda nn0expcld fsumnn0cl bitsinv2 ad2antll fveq2 syl5ibrcom
      eqcomd eqeq2d bitsinv1 ad2antrl sumeq1 impbid f1ocnv2d simpld wb wf bitsf
      feqmptd reseq1d nn0ssz resmpt ax-mp syl6eq f1oeq1 syl mpbird cnveqd eqtrd
      simprd jca trud ) DDUAZEUBZFDGZHZWIIZAWHAJZKBJZUCUDZBLZMZNZOPWJWQPWJDWHCD
      CJZFUMZMZHZPXAWTIZWPNZPCADWHWSWOWTWTUEWRDQZWSWHQZPXDWSDRZWSEQXEXFXDWRUFTW
      RUGWSDUHUIUJWLWHQZWODQPXGWLWNBXGWLDRZWLEQZWLDUHZUKXGWMWLQOZKWMKDQXKULTXGW
      LDWMXGXHXIXJUNUOUPUQUJPXDXGOOZWRWONZWLWSNZXLXNXMWLWOFUMZNZXGXPPXDXGXOWLWL
      BURVBUSXMWSXOWLWRWOFUTVCVAXLXMXNWRWSWNBLZNZXDXRPXGXDXQWRBWRVDVBVEXNWOXQWR
      WLWSWNBVFVCVAVGVHZVIPWIWTNWJXAVJPWICSWSMZDGZWTPFXTDPCSWGFSWGFVKPVLTVMVNDS
      RYAWTNVOCSDWSVPVQVRZDWHWIWTVSVTWAPWKXBWPPWIWTYBWBPXAXCXSWDWCWEWF $.

    $( The ` bits ` function restricted to nonnegative integers is a bijection
       from the integers to the finite sets of integers.  It is in fact the
       inverse of the Ackermann bijection ~ ackbijnn .  (Contributed by Mario
       Carneiro, 8-Sep-2016.) $)
    bitsf1o $p |- ( bits |` NN0 ) : NN0 -1-1-onto-> ( ~P NN0 i^i Fin ) $=
      ( vx vn cn0 cpw cfn cin cbits cres wf1o ccnv cv c2 cexp co csu bitsf1ocnv
      cmpt wceq simpli ) CCDEFZGCHZIUAJATAKLBKMNBOQRABPS $.

    $( The ` bits ` function is an injection from ` ZZ ` to ` ~P NN0 ` .  It is
       obviously not a bijection (by Cantor's theorem ~ canth2 ), and in fact
       its range is the set of finite and cofinite subsets of ` NN0 ` .
       (Contributed by Mario Carneiro, 22-Sep-2016.) $)
    bitsf1 $p |- bits : ZZ -1-1-> ~P NN0 $=
      ( vx vy cz cn0 cbits cfv wceq wcel wa cneg cn cc adantr fvres syl cfn com
      c1 wn bitsfi cpw wf1 wf cv wral bitsf simpl zcnd simpr negcld ax-1cn cmin
      wi a1i cres cdif simprr difeq2d bitscmp ad2antrr ad2antlr 3eqtr3d nnm1nn0
      ad2antrl ominf cen wbr nn0ennn nnenom entr2i enfii mpan2 mto mpan eqeltrd
      co difinf nsyl3 eqneltrrd nsyl wo znegcld cr elznn simprbi negnegd eleq1d
      orbi2d mpbid ord mt3d 3eqtr4d cin wf1o bitsf1o f1of1 ax-mp f1fveq syl2anc
      wb subcan2d neg11d expr biimpa eqeltrrd mpd simprl syldan mpjaodan rgen2a
      sylancr dff13 mpbir2an ) CDUAZEUBCXNEUCAUDZEFZBUDZEFZGZXOXQGZUMZBCUEACUEU
      FYAABCXOCHZXQCHZIZXOJZKHZYAYEJZDHZYDYFXSXTYDYFXSIZIZXOXQYDXOLHYIYDXOYBYCU
      GZUHZMZYDXQLHYIYDXQYBYCUIZUHZMZYJYEXQJZRYJXOYMUJYJXQYPUJRLHYJUKUNYJYERULV
      PZEDUOZFZYQRULVPZYSFZGZYRUUAGZYJYREFZUUAEFZYTUUBYJDXPUPZDXRUPZUUEUUFYJXPX
      RDYDYFXSUQZURYBUUGUUEGYCYIXOUSUTZYCUUHUUFGZYBYIXQUSZVAVBYJYRDHZYTUUEGYFUU
      MYDXSYEVCVDZYRDENOYJUUADHZUUBUUFGYJYQKHZUUOYJUUPXQDHZYJXRPHZUUQYJXPXRPUUI
      XPPHZUUGPHZYJDPHZSZUUSUUTSUVAQPHZVEUVAQDVFVGUVCDKQVHVIVJQDVKVLVMZDXPVQVNY
      JUUGUUEPUUJYJUUMUUEPHUUNYRTOVOVRVSXQTVTYJUUPUUQYDUUPUUQWAZYIYDUUPYQJZDHZW
      AZUVEYDYQCHZUVHYDXQYNWBUVIYQWCHUVHYQWDWEOYDUVGUUQUUPYDUVFXQDYDXQYOWFWGWHW
      IZMWJWKYQVCZOZUUADENOWLYJUUMUUOUUCUUDWTZUUNUVLDXNPWMZYSUBZUUMUUOIUVMDUVNY
      SWNUVOWODUVNYSWPWQZDUVNYRUUAYSWRVNWSWIXAXBXCYDYHXODHZYAYDYHUVQYDYGXODYDXO
      YLWFWGXDYDUVQXSXTYDUVQXSIZIZXOYSFZXQYSFZGZXTUVSXPXRUVTUWAYDUVQXSUQZUVQUVT
      XPGYDXSXODENVDUVSUUQUWAXRGUVSUUPSUUQUVSUUOUUPUVSUUFPHUUOUVSUUHUUFPYCUUKYB
      UVRUULVAUVSUVBUURUUHPHSUVDUVSXPXRPUWCUVQUUSYDXSXOTVDXEDXRVQXKVSUUATVTUVKV
      TUVSUUPUUQYDUVEUVRUVJMWJXFZXQDENOWLUVSUVQUUQUWBXTWTZYDUVQXSXGUWDUVOUVQUUQ
      IUWEUVPDUVNXOXQYSWRVNWSWIXCXHYDYECHZYFYHWAZYDXOYKWBUWFYEWCHUWGYEWDWEOXIXJ
      ABCXNEXLXM $.

    $( The bits of a power of two.  (Contributed by Mario Carneiro,
       5-Sep-2016.) $)
    2ebits $p |- ( N e. NN0 -> ( bits ` ( 2 ^ N ) ) = { N } ) $=
      ( vk cn0 wcel csn c2 cv cexp co csu cbits cfv cc wceq cn 2nn a1i nnexpcld
      id cfn nncnd oveq2 sumsn mpdan fveq2d cpw cin wss snssi sylanbrc bitsinv2
      snfi elfpw syl eqtr3d ) ACDZAEZFBGZHIZBJZKLZFAHIZKLUQUPUTVBKUPVBMDUTVBNUP
      VBUPFAFODUPPQUPSRUAUSVBBACURAFHUBUCUDUEUPUQCUFTUGDZVAUQNUPUQCUHUQTDZVCACU
      IVDUPAULQUQCUMUJUQBUKUNUO $.

    bitsinv.k $e |- K = `' ( bits |` NN0 ) $.
    $( The inverse of the ` bits ` function.  (Contributed by Mario Carneiro,
       8-Sep-2016.) $)
    bitsinv $p |- ( A e. ( ~P NN0 i^i Fin ) ->
      ( K ` A ) = sum_ k e. A ( 2 ^ k ) ) $=
      ( vx cv c2 cexp co csu cn0 cpw cfn cin sumeq1 cbits cres ccnv cmpt wf1o
      wceq bitsf1ocnv simpri eqtri sumex fvmpt ) EAEFZGBFHIZBJZAUHBJKLMNZCUGAUH
      BOCPKQZRZEUJUISZDKUJUKTULUMUAEBUBUCUDAUHBUEUF $.

    $( Recursive definition of the inverse of the ` bits ` function.
       (Contributed by Mario Carneiro, 8-Sep-2016.) $)
    bitsinvp1 $p |- ( ( A C_ NN0 /\ N e. NN0 ) ->
      ( K ` ( A i^i ( 0 ..^ ( N + 1 ) ) ) ) =
      ( ( K ` ( A i^i ( 0 ..^ N ) ) ) + if ( N e. A , ( 2 ^ N ) , 0 ) ) ) $=
      ( vk cn0 wss wcel wa cc0 caddc co cin c2 cexp csu c0 wceq a1i cfn c1 cfzo
      cv csn cfv cif fzonel disjsn sylibr ineq2d inindi in0 3eqtr3g simpr nn0uz
      wn cun cuz syl6eleq fzosplitsn syl indi syl6eq fzofi inss2 sylancl cn 2nn
      ssfi inss1 simpl syl5ss sselda nnexpcld nncnd fsumsplit cpw elfpw bitsinv
      sylanbrc eqeq1 snssi adantl dfss1 sylib sumeq1d simplr oveq2 sumsn eqtr2d
      cc syl2anc sum0 syl6req ifbothda oveq12d 3eqtr4d ) AFGZCFHZIZAJCUAKLZUBLZ
      MZNEUCZOLZEPZAJCUBLZMZXEEPZACUDZMZXEEPZKLXCBUEZXHBUEZCAHZNCOLZJUFZKLWTXHX
      KXEXCEWTAXGXJMZMAQMXHXKMQWTXRQAWTCXGHUPZXRQRXSWTJCUGSXGCUHUIUJAXGXJUKAULU
      MWTXCAXGXJUQZMXHXKUQWTXBXTAWTCJURUEZHXBXTRWTCFYAWRWSUNUOUSJCUTVAUJAXGXJVB
      VCWTXBTHZXCXBGXCTHZYBWTJXAVDSAXBVEXBXCVIVFZWTXDXCHIZXEYENXDNVGHZYEVHSWTXC
      FXDWTXCAFAXBVJWRWSVKZVLZVMVNVOVPWTXCFVQTMZHZXMXFRWTXCFGYCYJYHYDXCFVRVTXCE
      BDVSVAWTXNXIXQXLKWTXHYIHZXNXIRWTXHFGXHTHZYKWTXHAFAXGVJYGVLWTXGTHZXHXGGYLY
      MWTJCVDSAXGVEXGXHVIVFXHFVRVTXHEBDVSVAXOXPXLRJXLRXQXLRWTXPJXPXQXLWAJXQXLWA
      WTXOIZXLXJXEEPZXPYNXKXJXEEYNXJAGZXKXJRXOYPWTCAWBWCXJAWDWEWFYNXOXPWKHYOXPR
      WTXOUNYNXPYNNCYFYNVHSWRWSXOWGVNVOXEXPECAXDCNOWHWIWLWJWTXOUPZIZXLQXEEPJYRX
      KQXEEYRYQXKQRWTYQUNACUHUIWFXEEWMWNWOWPWQ $.
  $}

  $( The core of the proof of ~ sadadd2 .  The intuitive justification for this
     is that ` cadd ` is true if at least two arguments are true, and ` hadd `
     is true if an odd number of arguments are true, so altogether the result
     is ` n x. A ` where ` n ` is the number of true arguments, which is
     equivalently obtained by adding together one ` A ` for each true argument,
     on the right side.  (Contributed by Mario Carneiro, 8-Sep-2016.) $)
  sadadd2lem2 $p |- ( A e. CC ->
    ( if ( hadd ( ph , ps , ch ) , A , 0 ) +
      if ( cadd ( ph , ps , ch ) , ( 2 x. A ) , 0 ) ) =
    ( ( if ( ph , A , 0 ) + if ( ps , A , 0 ) ) + if ( ch , A , 0 ) ) ) $=
    ( cc wcel cc0 cif co caddc wa wb adantl ifbid iftrue oveq12d oveq1d 3eqtr4d
    wceq iffalse whad wcad c2 cmul wo ifcl mpan2 ad2antrr simpll add12d addassd
    0cn eqtr4d pm5.501 bicomd simpr syl 2timesd eqtrd wn addid2d 2cn a1i mulcld
    orcd id 2times adantr simpl addcomd pm2.61dan ifnot syl5eqr 3eqtr2rd hadrot
    nbn2 had1 syl5bbr cad1 oveq2d wxo notbid df-xor syl6bbr ibar simplll ifclda
    biorf con1bid syl5bb intnanrd had0 cad0 addcld addid1d sylan9eqr ) DEFZCABC
    UAZDGHZABCUBZUCDUDIZGHZJIZADGHZBDGHZJIZCDGHZJIZSWQCKZABLZDGHZABUEZXAGHZJIZX
    FDJIZXCXHXIAXNXOSXIAKZXEDDJIZJIZDXEJIZDJIZXNXOXPXRDXEDJIZJIXTXPXEDDWQXEEFZC
    AWQGEFZYBULBDGEUFUGZUHZWQCAUIZYFUJXPDXEDYFYEYFUKUMXPXKXEXMXQJXPXJBDGXPBXJAB
    XJLZXIABUNZMUONXPXMXAXQXPXLXMXASXPABXIAUPVEXLXAGOUQXPDYFURUSPXPXFXSDJXPXDDX
    EJAXDDSZXIADGOZMQQRXIAUTZKZXOYABGDHZBXAGHZJIZXNYLXFXEDJYLXFGXEJIZXEYLXDGXEJ
    YKXDGSZXIADGTZMQYLXEWQYBCYKYDUHVAUSQWQYOYASZCYKWQBYSWQBKZGXAJIZXQYOYAWQUUAX
    QSBWQUUAXAXQWQXAWQUCDUCEFWQVBVCWQVFVDVADVGUSVHZYTYMGYNXAJBYMGSWQBGDOMBYNXAS
    WQBXAGOMPZYTXEDDJBXEDSWQBDGOMZQRWQBUTZKZDGJIGDJIYOYAUUFDGWQUUEVIYCUUFULVCVJ
    UUFYMDYNGJUUEYMDSWQBGDTMZUUEYNGSWQBXAGTMZPUUFXEGDJUUEXEGSWQBDGTMZQRVKUHYLYM
    XKYNXMJYLYMUUEDGHZXKBDGVLZYLUUEXJDGYKUUEXJLZXIABVPZMNVMYLBXLXAGYKBXLLXIABWH
    MNPVNVKXIWSXKXBXMJXIWRXJDGCWRXJLWQWRCABUAZCXJCABVOZCABVQVRMNXIWTXLXAGCWTXLL
    WQABCVSMNPXIXGDXFJCXGDSWQCDGOMVTRWQCUTZKZABWAZDGHZABKZXAGHZJIZXFXCXHUUQAUVB
    XFSUUQAKZXFXSYOUVBUVCXDDXEJAYIUUQYJMQWQYOXSSZUUPAWQBUVDYTUUAXQYOXSUUBUUCYTX
    EDDJUUDVTRUUFYMDYNXEJUUGUUFYNGXEUUHUUIUMPVKUHUVCYMUUSYNUVAJUVCYMUUJUUSUUKUV
    CUUEUURDGUVCUUEXJUTZUURUVCBXJAYGUUQYHMWBABWCZWDNVMUVCBUUTXAGABUUTLUUQABWEMN
    PVNUUQYKKZXEGJIYPUVBXFUVGXEGUVGBDGEWQUUPYKBWFYCUVGUUEKULVCWGYCUVGULVCVJUVGU
    USXEUVAGJUVGUURBDGUURUVEUVGBUVFUVGBXJYKUULUUQUUMMWIWJNUVGUUTUTUVAGSUVGABUUQ
    YKUPWKUUTXAGTUQPUVGXDGXEJYKYQUUQYRMQRVKUUQWSUUSXBUVAJUUQWRUURDGUUPWRUURLWQW
    RUUNUUPUURUUOCABWLVRMNUUQWTUUTXAGUUPWTUUTLWQABCWMMNPUUPWQXHXFGJIXFUUPXGGXFJ
    CDGTVTWQXFWQXDXEWQYCXDEFULADGEUFUGYDWNWOWPRVK $.

  ${
    $d c k m n x y z $.  $d c k m x y A $.  $d c k m x y B $.  $d k n x y N $.
    $d k x y C $.  $d k x K $.  $d k x y ph $.
    $( Define the addition of two bit sequences, using ~ df-had and ~ df-cad
       bit operations.  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
    df-sad $a |- sadd = ( x e. ~P NN0 , y e. ~P NN0 |-> { k e. NN0 |
      hadd ( k e. x , k e. y , (/) e. ( seq 0 (
        ( c e. 2o , m e. NN0 |->
          if ( cadd ( m e. x , m e. y , (/) e. c ) , 1o , (/) ) ) ,
        ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) ` k ) ) } ) $.

    sadval.a $e |- ( ph -> A C_ NN0 ) $.
    sadval.b $e |- ( ph -> B C_ NN0 ) $.
    sadval.c $e |- C = seq 0 ( ( c e. 2o , m e. NN0 |->
          if ( cadd ( m e. A , m e. B , (/) e. c ) , 1o , (/) ) ) ,
        ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
    $( Define the addition of two bit sequences, using ~ df-had and ~ df-cad
       bit operations.  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
    sadfval $p |- ( ph -> ( A sadd B ) = { k e. NN0 |
      hadd ( k e. A , k e. B , (/) e. ( C ` k ) ) } ) $=
      ( vx cn0 wcel cv c0 wceq c2o cc0 eleq2d vy cpw csad co cfv whad wss nn0ex
      crab elpw2 sylibr wcad c1o cif cmpt2 c1 cmin cmpt cseq wa simpl simpr w3a
      simp1l simp1r biidd cadbi123d mpt2eq3dva seqeq2d syl6eqr fveq1d hadbi123d
      ifbid rabbidv df-sad rabex ovmpt2a syl2anc ) ABMUBZNZCVSNZBCUCUDEOZBNZWBC
      NZPWBDUEZNZUFZEMUIZQABMUGVTIBMUHUJUKACMUGWAJCMUHUJUKLUABCVSVSWBLOZNZWBUAO
      ZNZPWBHFRMFOZWINZWMWKNZPHOZNZULZUMPUNZUOZGMGOZSQPXAUPUQUDUNURZSUSZUEZNZUF
      ZEMUIWHUCWIBQZWKCQZUTZXFWGEMXIWJWCWLWDXEWFXIWIBWBXGXHVATXIWKCWBXGXHVBTXIX
      DWEPXIWBXCDXIXCHFRMWMBNZWMCNZWQULZUMPUNZUOZXBSUSDXIWTXNXBSXIHFRMWSXMXIWPR
      NZWMMNZVCZWRXLUMPXQWNXJWOXKWQWQXQWIBWMXGXHXOXPVDTXQWKCWMXGXHXOXPVETXQWQVF
      VGVMVHVIKVJVKTVLVNLUAEFGHVOWGEMUHVPVQVR $.

    $( The carry sequence is a sequence of elements of ` 2o ` encoding a
       "sequence of wffs".  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
    sadcf $p |- ( ph -> C : NN0 --> 2o ) $=
      ( cn0 c2o cv wcel c0 c1o cc0 co cfv a1i vx vy wcad cif cmpt2 wceq c1 cmin
      cmpt cseq wf cvv 0nn0 iftrue eqid 0ex fvmpt ax-mp cpr prid1 df2o3 eqeltri
      eleqtrri cop df-ov cxp wral con0 1on elexi prid2 keepel rgen2w fmpt2 mpbi
      wa f0cli nn0uz cz 0z caddc cuz fvex seqf2 feq1i sylibr ) AKLGELKEMZBNWGCN
      OGMNUCZPOUDZUEZFKFMZQUFZOWKUGUHRZUDZUIZQUJZUKKLDUKAUAUBLULWJWOQKQWOSZLNAW
      QOLQKNWQOUFUMFQWNOKWOWLOWMUNWOUOUPUQUROOPUSZLOPUPUTVAVCZVBTUAMZUBMZWJRZLN
      AWTLNXAULNVPVPXBWTXAVDZWJSLWTXAWJVELKVFZLXCWJWILNZEKVGGLVGXDLWJUKXEGELKWH
      POLPWRLOPPVHVIVJVKVAVCWSVLVMGELKWILWJWJUOVNVOWSVQVBTVRQVSNAVTTWTWOSULNAWT
      QUGWARWBSNVPWTWOWCTWDKLDWPJWEWF $.

    $( The initial element of the carry sequence is ` F. ` .  (Contributed by
       Mario Carneiro, 5-Sep-2016.) $)
    sadc0 $p |- ( ph -> -. (/) e. ( C ` 0 ) ) $=
      ( c0 cc0 cfv wcel wn cn0 cv cif wceq ax-mp noel c2o wcad cmpt2 c1 cmin co
      c1o cmpt cseq fveq1i cz 0z seq1 0nn0 iftrue 0ex fvmpt 3eqtri eleq2i mtbir
      eqid a1i ) KLDMZNZOAVEKKNKUAVDKKVDLGEUBPEQZBNVFCNKGQNUCUHKRUDZFPFQZLSZKVH
      UEUFUGZRZUIZLUJZMZLVLMZKLDVMJUKLULNVNVOSUMVGVLLUNTLPNVOKSUOFLVKKPVLVIKVJU
      PVLVBUQURTUSUTVAVC $.

    sadcp1.n $e |- ( ph -> N e. NN0 ) $.
    $( The carry sequence (which is a sequence of wffs, encoded as ` 1o ` and
       ` (/) ` ) is defined recursively as the carry operation applied to the
       previous carry and the two current inputs.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    sadcp1 $p |- ( ph -> ( (/) e. ( C ` ( N + 1 ) ) <->
      cadd ( N e. A , N e. B , (/) e. ( C ` N ) ) ) ) $=
      ( c0 c1 co wcel c1o cn0 cc0 wceq vx vy caddc cfv wcad cif cmin cmpt cmpt2
      cv c2o cuz nn0uz syl6eleq seqp1 syl fveq1i oveq1i 3eqtr4g peano2nn0 eqeq1
      cseq oveq1 ifbieq2d eqid 0ex ovex ifex fvmpt 3syl wne cn nnne0d ifnefalse
      nn0p1nn nn0cnd cc ax-1cn a1i pncand 3eqtrd oveq2d sadcf ffvelrnd wa simpr
      eleq1d simpl eleq2d cadbi123d ifbid biidd eleq2 eleq1 cbvmpt2v con0 elexi
      1on ovmpt2a syl2anc wn iffalse mtbiri con4i 0lt1o iftrue syl5eleqr impbii
      noel syl6bb ) AMGNUCOZDUDZPMGBPZGCPZMGDUDZPZUEZQMUFZPZXQAXLXRMAXLXOXKFRFU
      JZSTZMXTNUGOZUFZUHZUDZHEUKREUJZBPZYFCPZMHUJZPZUEZQMUFZUIZOZXOGYMOZXRAXKYM
      YDSVBZUDZGYPUDZYEYMOZXLYNAGSULUDZPYQYSTAGRYTLUMUNYMYDSGUOUPXKDYPKUQXOYRYE
      YMGDYPKUQURUSAYEGXOYMAYEXKSTZMXKNUGOZUFZUUBGAGRPZXKRPYEUUCTLGUTFXKYCUUCRY
      DXTXKTYAUUAYBUUBMXTXKSVAXTXKNUGVCVDYDVEUUAMUUBVFXKNUGVGVHVIVJAXKSVKUUCUUB
      TAXKAUUDXKVLPLGVOUPVMXKSMUUBVNUPAGNAGLVPNVQPAVRVSVTWAWBAXOUKPUUDYOXRTARUK
      GDABCDEFHIJKWCLWDLUAUBXOGUKRUBUJZBPZUUECPZMUAUJZPZUEZQMUFZXRYMUUHXOTZUUEG
      TZWEZUUJXQQMUUNUUFXMUUGXNUUIXPUUNUUEGBUULUUMWFZWGUUNUUEGCUUOWGUUNUUHXOMUU
      LUUMWHWIWJWKHEUAUBUKRYLUUKYGYHUUIUEZQMUFYIUUHTZYKUUPQMUUQYGYGYHYHYJUUIUUQ
      YGWLUUQYHWLYIUUHMWMWJWKYFUUETZUUPUUJQMUURYGUUFYHUUGUUIUUIYFUUEBWNYFUUECWN
      UURUUIWLWJWKWOXQQMQWPWRWQVFVHWSWTWAWIXSXQXQXSXQXAZXSMMPMXIUUSXRMMXQQMXBWI
      XCXDXQMQXRXEXQQMXFXGXHXJ $.

    $( The full adder sequence is the half adder function applied to the inputs
       and the carry sequence.  (Contributed by Mario Carneiro, 5-Sep-2016.) $)
    sadval $p |- ( ph -> ( N e. ( A sadd B ) <->
      hadd ( N e. A , N e. B , (/) e. ( C ` N ) ) ) ) $=
      ( vk wcel c0 cfv whad cn0 eleq2d eleq1 csad co cv crab sadfval wceq fveq2
      wb hadbi123d elrab3 syl bitrd ) AGBCUAUBZNGMUCZBNZUNCNZOUNDPZNZQZMRUDZNZG
      BNZGCNZOGDPZNZQZAUMUTGABCDMEFHIJKUESAGRNVAVFUHLUSVFMGRUNGUFZUOVBUPVCURVEU
      NGBTUNGCTVGUQVDOUNGDUGSUIUJUKUL $.

    sadcadd.k $e |- K = `' ( bits |` NN0 ) $.
    ${
      sadcaddlem.1 $e |- ( ph -> ( (/) e. ( C ` N ) <-> ( 2 ^ N ) <_
      ( ( K ` ( A i^i ( 0 ..^ N ) ) ) + ( K ` ( B i^i ( 0 ..^ N ) ) ) ) ) ) $.
      $( Lemma for ~ sadcadd .  (Contributed by Mario Carneiro, 8-Sep-2016.) $)
      sadcaddlem $p |- ( ph -> ( (/) e. ( C ` ( N + 1 ) ) <->
        ( 2 ^ ( N + 1 ) ) <_ ( ( K ` ( A i^i ( 0 ..^ ( N + 1 ) ) ) ) +
                               ( K ` ( B i^i ( 0 ..^ ( N + 1 ) ) ) ) ) ) ) $=
        ( wcel caddc cc0 cle cn0 c0 cfv wcad c2 cexp co cin cif wbr c1 wb wa wo
        cfzo cad1 adantl cr cn 2nn a1i nnexpcld nnred ad2antrr cpw inss1 syl5ss
        cfn wss fzofi inss2 ssfi sylancl elfpw sylanbrc wf1o wf cbits cres ccnv
        bitsf1o f1ocnv ax-mp wceq f1oeq1 mpbir f1of ffvelrni syl nn0addcld 2nn0
        nn0red adantr nn0expcld 0nn0 ifclda biimpa nnnn0d ifcl nn0ge0d addge01d
        wn 0re mpbid iftrue oveq1d breqtrrd addge02d oveq2d clt iffalse oveq12d
        ex readdcld addid1d eqtrd fveq1i fveq2i fvres f1ocnvfv2 sylancr 3eqtr3a
        syl6eqss cz nn0zd bitsfzo syl2anc mpbird elfzolt2 eqbrtrd ltnled nn0cnd
        bitrd wi breq1 ifboth breq1d syl5ibrcom con1d nncnd bitsinvp1 00id cad0
        jaodan le2addd ioran ad2antrl ad2antll syl6eq lt2addd syl5bi impcon4bid
        recnd oveqan12d lenltd con2bid biimpar ltadd1dd syl3anc ltadd2d sylibrd
        ltletr mpand leidd jcad sylbid syld impbid pm2.61dan sadcp1 cmul expp1d
        addid2d times2d add4d breq12d 3bitr4d ) AHBPZHCPZUAHDUBPZUCZUDHUEUFZUWA
        QUFZBRHUNUFZUGZGUBZCUWCUGZGUBZQUFZUVQUWARUHZUVRUWARUHZQUFZQUFZSUIZUAHUJ
        QUFZDUBPUDUWNUEUFZBRUWNUNUFZUGGUBZCUWPUGGUBZQUFZSUIAUVSUVTUWMUKAUVSULZU
        VTUVQUVRUMZUWMUVSUVTUXAUKAUVQUVRUVSUOUPUWTUXAUWMUWTUXAUWMUWTUXAULUWAUWA
        UWHUWKAUWAUQPZUVSUXAAUWAAUDHUDURPAUSUTZMVAZVBZVCZUXFAUWHUQPZUVSUXAAUWHA
        UWEUWGAUWDTVDVGUGZPZUWETPZAUWDTVHUWDVGPZUXIAUWDBTBUWCVEJVFAUWCVGPZUWDUW
        CVHUXKUXLARHVIUTZBUWCVJZUWCUWDVKVLUWDTVMVNZUXHTUWDGUXHTGVOZUXHTGVPUXPUX
        HTVQTVRZVSZVOZTUXHUXQVOZUXSVTTUXHUXQWAWBGUXRWCUXPUXSUKNUXHTGUXRWDWBWEUX
        HTGWFWBZWGWHZAUWFUXHPZUWGTPZAUWFTVHUWFVGPZUYCAUWFCTCUWCVEKVFAUXLUWFUWCV
        HUYEUXMCUWCVJZUWCUWFVKVLUWFTVMVNZUXHTUWFGUYAWGWHZWIZWKZVCAUWKUQPZUVSUXA
        AUWKAUWIUWJAUVQUWARTAUVQULZUDHUDTPZUYLWJUTAHTPZUVQMWLWMRTPZAUVQXAZULZWN
        UTWOAUVRUWARTAUVRULZUDHUYMUYRWJUTAUYNUVRMWLWMUYOAUVRXAZULZWNUTWOWIWKZVC
        UWTUWAUWHSUIZUXAAUVSVUBOWPWLUWTUVQUWAUWKSUIUVRUWTUVQULZUWAUWAUWJQUFZUWK
        SAUWAVUDSUIZUVSUVQARUWJSUIVUEAUWJAUWATPZUYOUWJTPAUWAUXDWQZWNUVRUWARTWRV
        LZWSAUWAUWJUXEAUVRUWARUQAUXBUVRUXEWLRUQPZUYTXBUTWOZWTXCVCVUCUWIUWAUWJQU
        VQUWIUWAWCUWTUVQUWARXDZUPXEXFUWTUVRULZUWAUWIUWAQUFZUWKSAUWAVUMSUIZUVSUV
        RARUWISUIVUNAUWIAVUFUYOUWITPVUGWNUVQUWARTWRVLZWSAUWAUWIUXEAUVQUWARUQAUX
        BUVQUXEWLVUIUYQXBUTWOZXGXCVCVULUWJUWAUWIQUVRUWJUWAWCUWTUVRUWARXDZUPXHXF
        UUCUUDXLUXAXAUYPUYSULZUWTUWMXAZUVQUVRUUEUWTVURVUSUWTVURULZUWLUWBXIUIVUS
        VUTUWLUWHUWBXIVUTUWLUWHRQUFUWHVUTUWKRUWHQVUTUWKRRQUFRVUTUWIRUWJRQUYPUWI
        RWCUWTUYSUVQUWARXJZUUFUYSUWJRWCUWTUYPUVRUWARXJZUUGXKUUAUUHXHVUTUWHVUTUW
        HVUTUWEUWGAUWEUQPZUVSVURAUWEUYBWKZVCAUWGUQPZUVSVURAUWGUYHWKZVCXMZUULXNX
        OAUWHUWBXIUIUVSVURAUWEUWGUWAUWAVVDVVFUXEUXEAUWERUWAUNUFZPZUWEUWAXIUIAVV
        IUWEVQUBZUWCVHZAVVJUWDUWCAUWEUXQUBZUWDUXRUBZUXQUBZVVJUWDUWEVVMUXQUWDGUX
        RNXPXQAUXJVVLVVJWCUYBUWETVQXRWHAUXTUXIVVNUWDWCVTUXOTUXHUWDUXQXSXTYAUXNY
        BAUWEYCPUYNVVIVVKUKAUWEUYBYDMHUWEYEYFYGUWERUWAYHWHAUWGVVHPZUWGUWAXIUIAV
        VOUWGVQUBZUWCVHZAVVPUWFUWCAUWGUXQUBZUWFUXRUBZUXQUBZVVPUWFUWGVVSUXQUWFGU
        XRNXPXQAUYDVVRVVPWCUYHUWGTVQXRWHAUXTUYCVVTUWFWCVTUYGTUXHUWFUXQXSXTYAUYF
        YBAUWGYCPUYNVVOVVQUKAUWGUYHYDMHUWGYEYFYGUWGRUWAYHWHUUIVCYIVUTUWLUWBVUTU
        WHUWKVVGVUTUWIUWJAUWIUQPUVSVURVUPVCAUWJUQPUVSVURVUJVCXMXMVUTUWAUWAAUXBU
        VSVURUXEVCZVWAXMYJXCXLUUJUUKYLAUVSXAZULZUVTUVQUVRULZUWMVWBUVTVWDUKAUVQU
        VRUVSUUBUPVWCVWDUWMVWCVWDUWMVWCVWDULZUWBUWHUWBQUFZUWLSAUWBVWFSUIZVWBVWD
        ARUWHSUIVWGAUWHUYIWSAUWBUWHAUWAUWAUXEUXEXMZUYJXGXCVCVWEUWKUWBUWHQVWDUWK
        UWBWCVWCUVQUVRUWIUWAUWJUWAQVUKVUQUUMUPXHXFXLVWCUWMUWAUWKXIUIZVWDVWCUWMU
        WHUWAQUFZUWLXIUIZVWIVWCVWJUWBXIUIZUWMVWKVWCUWHUWAUWAVWCUWEUWGAVVCVWBVVD
        WLAVVEVWBVVFWLXMZAUXBVWBUXEWLZVWNAUWHUWAXIUIZVWBAUVSVWOAUVSVUBVWOXAOAUW
        AUWHUXEUYJUUNYLUUOUUPUUQVWCVWJUQPUWBUQPZUWLUQPZVWLUWMULVWKYMVWCUWHUWAVW
        MVWNXMAVWPVWBVWHWLAVWQVWBAUWHUWKUYJVUAXMWLVWJUWBUWLUVAUURUVBVWCUWAUWKUW
        HVWNAUYKVWBVUAWLAUXGVWBUYJWLUUSUUTAVWIVWDYMVWBAVWIUWKUWASUIZXAZVWDAUWAU
        WKUXEVUAYJAVWSUVQUVRAUVQVWRAVWRUYPRUWJQUFZUWASUIAVWTUWJUWASAUWJAUWJVUHY
        KZUVLAUWAUWASUIZRUWASUIZUWJUWASUIZAUWAUXEUVCZAUWAVUGWSZUVRVXBVXCVXDUWAR
        UWAUWJUWASYNRUWJUWASYNYOYFYIUYPUWKVWTUWASUYPUWIRUWJQVVAXEYPYQYRAUVRVWRA
        VWRUYSUWIRQUFZUWASUIAVXGUWIUWASAUWIAUWIVUOYKZXNAVXBVXCUWIUWASUIZVXEVXFU
        VQVXBVXCVXIUWARUWAUWIUWASYNRUWIUWASYNYOYFYIUYSUWKVXGUWASUYSUWJRUWIQVVBX
        HYPYQYRUVDUVEWLUVFUVGYLUVHABCDEFHIJKLMUVIAUWOUWBUWSUWLSAUWOUWAUDUVJUFUW
        BAUDHAUDUXCYSMUVKAUWAAUWAUXDYSUVMXOAUWSUWEUWIQUFZUWGUWJQUFZQUFUWLAUWQVX
        JUWRVXKQABTVHUYNUWQVXJWCJMBGHNYTYFACTVHUYNUWRVXKWCKMCGHNYTYFXKAUWEUWIUW
        GUWJAUWEUYBYKVXHAUWGUYHYKVXAUVNXOUVOUVP $.
    $}

    $( Non-recursive definition of the carry sequence.  (Contributed by Mario
       Carneiro, 8-Sep-2016.) $)
    sadcadd $p |- ( ph -> ( (/) e. ( C ` N ) <-> ( 2 ^ N ) <_
      ( ( K ` ( A i^i ( 0 ..^ N ) ) ) + ( K ` ( B i^i ( 0 ..^ N ) ) ) ) ) ) $=
      ( c0 cfv c2 co cc0 cin vx vk cn0 wcel cexp cfzo caddc cle wbr wb cv wi c1
      wceq fveq2 eleq2d oveq2 cc 2cn exp0 ax-mp syl6eq fzo0 ineq2d fveq2d cbits
      in0 cres ccnv 0nn0 fvres 0bits eqtr2i fveq12i cpw bitsf1o f1ocnvfv1 mp2an
      cfn wf1o eqtri oveq12d 00id breq12d bibi12d imbi2d sadc0 clt 0lt1 0re 1re
      wn ltnlei mpbi a1i 2falsed wa wss ad2antrr simplr simpr sadcaddlem expcom
      ex a2d nn0ind mpcom ) HUCUDAOHDPZUDZQHUERZBSHUFRZTZGPZCXKTZGPZUGRZUHUIZUJ
      ZMAOUAUKZDPZUDZQXSUERZBSXSUFRZTZGPZCYCTZGPZUGRZUHUIZUJZULAOSDPZUDZUMSUHUI
      ZUJZULAOUBUKZDPZUDZQYOUERZBSYOUFRZTZGPZCYSTZGPZUGRZUHUIZUJZULAOYOUMUGRZDP
      ZUDZQUUGUERZBSUUGUFRZTZGPZCUUKTZGPZUGRZUHUIZUJZULAXRULUAUBHXSSUNZYJYNAUUS
      YAYLYIYMUUSXTYKOXSSDUOUPUUSYBUMYHSUHUUSYBQSUERZUMXSSQUEUQQURUDUUTUMUNUSQU
      TVAVBUUSYHSSUGRSUUSYESYGSUGUUSYEOGPZSUUSYDOGUUSYDBOTOUUSYCOBUUSYCSSUFROXS
      SSUFUQSVCVBZVDBVGVBVEUVASVFUCVHZPZUVCVIZPZSOUVDGUVENUVDSVFPZOSUCUDZUVDUVG
      UNVJSUCVFVKVAVLVMVNUCUCVOVSTZUVCVTUVHUVFSUNVPVJUCUVISUVCVQVRWAZVBUUSYGUVA
      SUUSYFOGUUSYFCOTOUUSYCOCUVBVDCVGVBVEUVJVBWBWCVBWDWEWFXSYOUNZYJUUFAUVKYAYQ
      YIUUEUVKXTYPOXSYODUOUPUVKYBYRYHUUDUHXSYOQUEUQUVKYEUUAYGUUCUGUVKYDYTGUVKYC
      YSBXSYOSUFUQZVDVEUVKYFUUBGUVKYCYSCUVLVDVEWBWDWEWFXSUUGUNZYJUURAUVMYAUUIYI
      UUQUVMXTUUHOXSUUGDUOUPUVMYBUUJYHUUPUHXSUUGQUEUQUVMYEUUMYGUUOUGUVMYDUULGUV
      MYCUUKBXSUUGSUFUQZVDVEUVMYFUUNGUVMYCUUKCUVNVDVEWBWDWEWFXSHUNZYJXRAUVOYAXI
      YIXQUVOXTXHOXSHDUOUPUVOYBXJYHXPUHXSHQUEUQUVOYEXMYGXOUGUVOYDXLGUVOYCXKBXSH
      SUFUQZVDVEUVOYFXNGUVOYCXKCUVPVDVEWBWDWEWFAYLYMABCDEFIJKLWGYMWLZASUMWHUIUV
      QWISUMWJWKWMWNWOWPYOUCUDZAUUFUURAUVRUUFUURULAUVRWQZUUFUURUVSUUFWQBCDEFGYO
      IABUCWRUVRUUFJWSACUCWRUVRUUFKWSLAUVRUUFWTNUVSUUFXAXBXDXCXEXFXG $.

    ${
      sadadd2lem.1 $e |- ( ph -> ( ( K ` ( ( A sadd B ) i^i ( 0 ..^ N ) ) ) +
      if ( (/) e. ( C ` N ) , ( 2 ^ N ) , 0 ) ) =
      ( ( K ` ( A i^i ( 0 ..^ N ) ) ) + ( K ` ( B i^i ( 0 ..^ N ) ) ) ) ) $.
      $( Lemma for ~ sadadd2 .  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
      sadadd2lem $p |- ( ph ->
        ( ( K ` ( ( A sadd B ) i^i ( 0 ..^ ( N + 1 ) ) ) ) +
          if ( (/) e. ( C ` ( N + 1 ) ) , ( 2 ^ ( N + 1 ) ) , 0 ) ) =
        ( ( K ` ( A i^i ( 0 ..^ ( N + 1 ) ) ) ) +
          ( K ` ( B i^i ( 0 ..^ ( N + 1 ) ) ) ) ) ) $=
        ( co cc0 wcel caddc cn0 vk csad cfzo cin cfv c2 cexp cif c0 cpw cfn wss
        c1 inss1 cv whad sadfval ssrab2 syl6eqss syl5ss fzofi a1i inss2 sylancl
        crab ssfi elfpw sylanbrc cbits cres ccnv wf1o bitsf1o f1ocnv f1of feq1i
        wf mp2b mpbir ffvelrni nn0cnd 2nn0 nn0expcld 0nn0 ifcl nn0addcld addcld
        syl 1nn0 cc adantr wn 0cn ifclda wcad cmul sadval sadcp1 expp1d mulcomd
        wa ifbid eqtrd eqidd ifbieq12d oveq12d wceq sadadd2lem2 addassd 3eqtr4d
        add32d addcan2ad add4d bitsinvp1 syl2anc oveq1d ) ABCUBPZQHUCPZUDZGUEZH
        XQRZUFHUGPZQUHZSPZUIHUMSPZDUERZUFYEUGPZQUHZSPZBXRUDZGUEZHBRZYBQUHZSPZCX
        RUDZGUEZHCRZYBQUHZSPZSPZXQQYEUCPZUDGUEZYHSPBUUAUDGUEZCUUAUDGUEZSPAXTYCY
        HSPZSPZYKYPSPZYMYRSPZSPZYIYTAUUFUUIUIHDUERZYBQUHZAXTUUEAXTAXSTUJUKUDZRZ
        XTTRAXSTULXSUKRZUUMAXSXQTXQXRUNAXQUAUOZBRUUOCRUIUUODUERUPZUATVETABCDUAE
        FIJKLUQUUPUATURUSZUTAXRUKRZXSXRULUUNUURAQHVAVBZXQXRVCXRXSVFVDXSTVGVHUUL
        TXSGUULTGVQUULTVITVJZVKZVQZTUULUUTVLUULTUVAVLUVBVMTUULUUTVNUULTUVAVOVRU
        ULTGUVANVPVSZVTWHWAZAYCYHAYCAYBTRZQTRZYCTRAUFHUFTRAWBVBZMWCZWDYAYBQTWEV
        DWAZAYHAYGTRUVFYHTRAUFYEUVGAHUMMUMTRAWIVBWFWCWDYFYGQTWEVDWAZWGZWGAUUGUU
        HAYKYPAYKAYJUULRZYKTRAYJTULYJUKRZUVLAYJBTBXRUNJUTAUURYJXRULUVMUUSBXRVCX
        RYJVFVDYJTVGVHUULTYJGUVCVTWHWAZAYPAYOUULRZYPTRAYOTULYOUKRZUVOAYOCTCXRUN
        KUTAUURYOXRULUVPUUSCXRVCXRYOVFVDYOTVGVHUULTYOGUVCVTWHWAZWGZAYMYRAYMAUVE
        UVFYMTRUVHWDYLYBQTWEVDWAZAYRAUVEUVFYRTRUVHWDYQYBQTWEVDWAZWGZWGAUUJYBQWJ
        AYBWJRZUUJAYBUVHWAZWKQWJRAUUJWLXAWMVBWNZAXTUUKSPZUUESPUUGUUHUUKSPZSPUUF
        UUKSPUUIUUKSPAUWEUUGUUEUWFSOAUUEYLYQUUJUPZYBQUHZYLYQUUJWOZUFYBWPPZQUHZS
        PZUWFAYCUWHYHUWKSAYAUWGYBQABCDEFHIJKLMWQXBAYFUWIYGQUWJQABCDEFHIJKLMWRAY
        GYBUFWPPUWJAUFHAUFUVGWAZMWSAYBUFUWCUWMWTXCAQXDXEXFAUWBUWLUWFXGUWCYLYQUU
        JYBXHWHXCXFAXTUUEUUKUVDUVKUWDXKAUUGUUHUUKUVRUWAUWDXIXJXLAXTYCYHUVDUVIUV
        JXIAYKYMYPYRUVNUVSUVQUVTXMXJAUUBYDYHSAXQTULHTRZUUBYDXGUUQMXQGHNXNXOXPAU
        UCYNUUDYSSABTULUWNUUCYNXGJMBGHNXNXOACTULUWNUUDYSXGKMCGHNXNXOXFXJ $.
    $}

    $( Sum of initial segments of the ` sadd ` sequence.  (Contributed by Mario
       Carneiro, 8-Sep-2016.) $)
    sadadd2 $p |- ( ph -> ( ( K ` ( ( A sadd B ) i^i ( 0 ..^ N ) ) ) +
      if ( (/) e. ( C ` N ) , ( 2 ^ N ) , 0 ) ) =
      ( ( K ` ( A i^i ( 0 ..^ N ) ) ) + ( K ` ( B i^i ( 0 ..^ N ) ) ) ) ) $=
      ( co cc0 cin cfv c0 caddc vx vk cn0 wcel csad cfzo c2 cexp cif wceq cv wi
      c1 oveq2 fzo0 syl6eq ineq2d fveq2d cbits cres ccnv 0nn0 fvres ax-mp 0bits
      in0 eqtr2i fveq12i cpw cfn wf1o bitsf1o f1ocnvfv1 mp2an eqtri fveq2 eqidd
      eleq2d ifbieq12d oveq12d 00id eqeq12d imbi2d sadc0 iffalse syl oveq2d wss
      wn wa ad2antrr simplr simpr sadadd2lem ex expcom a2d nn0ind mpcom ) HUCUD
      ABCUEOZPHUFOZQZGRZSHDRZUDZUGHUHOZPUIZTOZBXAQZGRZCXAQZGRZTOZUJZMAWTPUAUKZU
      FOZQZGRZSXODRZUDZUGXOUHOZPUIZTOZBXPQZGRZCXPQZGRZTOZUJZULAPSPDRZUDZUGPUHOZ
      PUIZTOZPUJZULAWTPUBUKZUFOZQZGRZSYPDRZUDZUGYPUHOZPUIZTOZBYQQZGRZCYQQZGRZTO
      ZUJZULAWTPYPUMTOZUFOZQZGRZSUUKDRZUDZUGUUKUHOZPUIZTOZBUULQZGRZCUULQZGRZTOZ
      UJZULAXNULUAUBHXOPUJZYIYOAUVFYCYNYHPUVFXRPYBYMTUVFXRSGRZPUVFXQSGUVFXQWTSQ
      SUVFXPSWTUVFXPPPUFOSXOPPUFUNPUOUPZUQWTVFUPURUVGPUSUCUTZRZUVIVAZRZPSUVJGUV
      KNUVJPUSRZSPUCUDZUVJUVMUJVBPUCUSVCVDVEVGVHUCUCVIVJQZUVIVKUVNUVLPUJVLVBUCU
      VOPUVIVMVNVOZUPUVFXTYKYAPYLPUVFXSYJSXOPDVPVRXOPUGUHUNUVFPVQVSVTUVFYHPPTOZ
      PUVFYEPYGPTUVFYEUVGPUVFYDSGUVFYDBSQSUVFXPSBUVHUQBVFUPURUVPUPUVFYGUVGPUVFY
      FSGUVFYFCSQSUVFXPSCUVHUQCVFUPURUVPUPVTWAUPWBWCXOYPUJZYIUUJAUVRYCUUDYHUUIU
      VRXRYSYBUUCTUVRXQYRGUVRXPYQWTXOYPPUFUNZUQURUVRXTUUAYAPUUBPUVRXSYTSXOYPDVP
      VRXOYPUGUHUNUVRPVQVSVTUVRYEUUFYGUUHTUVRYDUUEGUVRXPYQBUVSUQURUVRYFUUGGUVRX
      PYQCUVSUQURVTWBWCXOUUKUJZYIUVEAUVTYCUUSYHUVDUVTXRUUNYBUURTUVTXQUUMGUVTXPU
      ULWTXOUUKPUFUNZUQURUVTXTUUPYAPUUQPUVTXSUUOSXOUUKDVPVRXOUUKUGUHUNUVTPVQVSV
      TUVTYEUVAYGUVCTUVTYDUUTGUVTXPUULBUWAUQURUVTYFUVBGUVTXPUULCUWAUQURVTWBWCXO
      HUJZYIXNAUWBYCXHYHXMUWBXRXCYBXGTUWBXQXBGUWBXPXAWTXOHPUFUNZUQURUWBXTXEYAPX
      FPUWBXSXDSXOHDVPVRXOHUGUHUNUWBPVQVSVTUWBYEXJYGXLTUWBYDXIGUWBXPXABUWCUQURU
      WBYFXKGUWBXPXACUWCUQURVTWBWCAYNUVQPAYMPPTAYKWIYMPUJABCDEFIJKLWDYKYLPWEWFW
      GWAUPYPUCUDZAUUJUVEAUWDUUJUVEULAUWDWJZUUJUVEUWEUUJWJBCDEFGYPIABUCWHUWDUUJ
      JWKACUCWHUWDUUJKWKLAUWDUUJWLNUWEUUJWMWNWOWPWQWRWS $.

    $( Sum of initial segments of the ` sadd ` sequence.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    sadadd3 $p |- ( ph ->
      ( ( K ` ( ( A sadd B ) i^i ( 0 ..^ N ) ) ) mod ( 2 ^ N ) ) =
      ( ( ( K ` ( A i^i ( 0 ..^ N ) ) ) +
          ( K ` ( B i^i ( 0 ..^ N ) ) ) ) mod ( 2 ^ N ) ) ) $=
      ( co cc0 cfv wcel cdivides cn0 vk csad cfzo cin c0 c2 cexp cif caddc wceq
      cmo cmin wbr cz cn 2nn a1i nnexpcld iddvds syl dvds0 breq2 ifboth syl2anc
      nnzd cpw cfn wss inss1 cv whad sadfval ssrab2 syl6eqss syl5ss fzofi inss2
      crab ssfi sylancl elfpw sylanbrc cbits cres ccnv wf1o bitsf1o f1ocnv f1of
      wf mp2b feq1i mpbir ffvelrni nn0cnd cc nncnd 0cn ifcl pncan2d breqtrrd wb
      nn0zd adantr wn wa 0z ifclda zaddcld moddvds syl3anc mpbird oveq1d eqtr3d
      sadadd2 ) ABCUBOZPHUCOZUDZGQZUEHDQRZUFHUGOZPUHZUIOZYAUKOZXSYAUKOZBXQUDGQC
      XQUDGQUIOZYAUKOAYDYEUJZYAYCXSULOZSUMZAYAYBYHSAYAYASUMZYAPSUMZYAYBSUMZAYAU
      NRZYJAYAAUFHUFUORAUPUQMURZVEZYAUSUTAYMYKYOYAVAUTXTYJYKYLYAPYAYBYASVBPYBYA
      SVBVCVDAXSYBAXSAXRTVFVGUDZRZXSTRAXRTVHXRVGRZYQAXRXPTXPXQVIAXPUAVJZBRYSCRU
      EYSDQRVKZUATVRTABCDUAEFIJKLVLYTUATVMVNVOAXQVGRZXRXQVHYRUUAAPHVPUQXPXQVQXQ
      XRVSVTXRTWAWBYPTXRGYPTGWJYPTWCTWDZWEZWJZTYPUUBWFYPTUUCWFUUDWGTYPUUBWHYPTU
      UCWIWKYPTGUUCNWLWMWNUTZWOAYAWPRPWPRYBWPRAYAYNWQWRXTYAPWPWSVTWTXAAYAUORYCU
      NRXSUNRYGYIXBYNAXSYBAXSUUEXCZAXTYAPUNAYMXTYOXDPUNRAXTXEXFXGUQXHXIUUFYCXSY
      AXJXKXLAYCYFYAUKABCDEFGHIJKLMNXOXMXN $.
  $}

  ${
    $d c k m n $.  $d c k m A $.  $d c k m B $.
    $( The sum of two sequences is a sequence.  (Contributed by Mario Carneiro,
       5-Sep-2016.) $)
    sadcl $p |- ( ( A C_ NN0 /\ B C_ NN0 ) -> ( A sadd B ) C_ NN0 ) $=
      ( vk vc vm vn cn0 wss wa csad co cv wcel c0 c2o wcad c1o cif cmpt2 cc0 c1
      wceq cmin cmpt cseq whad crab simpl simpr eqid sadfval ssrab2 syl6eqss
      cfv ) AGHZBGHZIZABJKCLZAMURBMNURDEOGELZAMUSBMNDLMPQNRSFGFLZTUBNUTUAUCKRUD
      TUEZUNMUFZCGUGGUQABVACEFDUOUPUHUOUPUIVAUJUKVBCGULUM $.

    $( The adder sequence function is commutative.  (Contributed by Mario
       Carneiro, 5-Sep-2016.) $)
    sadcom $p |- ( ( A C_ NN0 /\ B C_ NN0 ) -> ( A sadd B ) = ( B sadd A ) ) $=
      ( vk vc vm vn cn0 wss wa cv wcel c0 c2o wcad c1o cif cmpt2 cc0 wceq co c1
      cmin cmpt cseq cfv whad crab csad wb hadcoma a1i rabbidv simpl simpr eqid
      sadfval cadcoma ifbid mpt2eq3ia seqeq2 ax-mp 3eqtr4d ) AGHZBGHZIZCJZAKZVF
      BKZLVFDEMGEJZAKZVIBKZLDJZKZNZOLPZQZFGFJZRSLVQUAUBTPUCZRUDZUEKZUFZCGUGVHVG
      VTUFZCGUGABUHTBAUHTVEWAWBCGWAWBUIVEVGVHVTUJUKULVEABVSCEFDVCVDUMZVCVDUNZVS
      UOUPVEBAVSCEFDWDWCVPDEMGVKVJVMNZOLPZQZSVSWGVRRUDSDEMGVOWFVLMKVIGKIZVNWEOL
      VNWEUIWHVJVKVMUQUKURUSVPWGVRRUTVAUPVB $.
  $}

  ${
    $d c k m n x $.  $d c k m A $.  $d c k m B $.  $d k x C $.  $d k x ph $.
    $d n x N $.
    saddisj.1 $e |- ( ph -> A C_ NN0 ) $.
    saddisj.2 $e |- ( ph -> B C_ NN0 ) $.
    saddisj.3 $e |- ( ph -> ( A i^i B ) = (/) ) $.
    ${
      saddisjlem.c $e |- C = seq 0 ( ( c e. 2o , m e. NN0 |->
        if ( cadd ( m e. A , m e. B , (/) e. c ) , 1o , (/) ) ) ,
          ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
      saddisjlem.3 $e |- ( ph -> N e. NN0 ) $.
      $( Lemma for ~ sadadd .  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
      saddisjlem $p |- ( ph -> ( N e. ( A sadd B ) <-> N e. ( A u. B ) ) ) $=
        ( wcel c0 cfv wn wi wceq eleq2d vx vk csad co whad wxo cun sadval wb cv
        cn0 cc0 c1 caddc fveq2 notbid imbi2d sadc0 wa noel wcad ad2antrr simplr
        wss sadcp1 cad0 adantl cin elin syl5bbr 3bitrd mtbiri expcom a2d nn0ind
        ex mpcom hadrot had0 syl wo xor2 rbaib elun syl6bbr ) AGBCUCUDNGBNZGCNZ
        OGDPZNZUEZWFWGUFZGBCUGNZABCDEFGHIJLMUHAWIQZWJWKUIGUKNAWMMAOUAUJZDPZNZQZ
        RAOULDPZNZQZRAOUBUJZDPZNZQZRAOXAUMUNUDZDPZNZQZRAWMRUAUBGWNULSZWQWTAXIWP
        WSXIWOWROWNULDUOTUPUQWNXASZWQXDAXJWPXCXJWOXBOWNXADUOTUPUQWNXESZWQXHAXKW
        PXGXKWOXFOWNXEDUOTUPUQWNGSZWQWMAXLWPWIXLWOWHOWNGDUOTUPUQABCDEFHIJLURXAU
        KNZAXDXHAXMXDXHRAXMUSZXDXHXNXDUSZXGXAONZXAUTXOXGXABNZXACNZXCVAZXQXRUSZX
        PXOBCDEFXAHABUKVDXMXDIVBACUKVDXMXDJVBLAXMXDVCVEXDXSXTUIXNXQXRXCVFVGXTXA
        BCVHZNXOXPXABCVIXOYAOXAAYAOSXMXDKVBTVJVKVLVPVMVNVOVQWJWIWFWGUEWMWKWIWFW
        GVRWIWFWGVSVJVTAWKWFWGWAZWLAWFWGUSZQZWKYBUIAYCGONZGUTYCGYANAYEGBCVIAYAO
        GKTVJVLWKYBYDWFWGWBWCVTGBCWDWEVK $.
    $}

    $( The sum of disjoint sequences is the union of the sequences.  (In this
       case, there are no carried bits.)  (Contributed by Mario Carneiro,
       9-Sep-2016.) $)
    saddisj $p |- ( ph -> ( A sadd B ) = ( A u. B ) ) $=
      ( vk vc vm vx co cv cn0 wcel wss sseld c0 cif cc0 adantr csad cun syl2anc
      sadcl unssd wb c2o wcad c1o cmpt2 wceq cmin cmpt cseq cin eqid saddisjlem
      wa c1 simpr ex pm5.21ndd eqrdv ) AGBCUAKZBCUBZAGLZMNZVFVDNZVFVENZAVDMVFAB
      MOZCMOZVDMODEBCUDUCPAVEMVFABCMDEUEPAVGVHVIUFAVGURBCHIUGMILZBNVLCNQHLNUHUI
      QRUJJMJLZSUKQVMUSULKRUMSUNZIJVFHAVJVGDTAVKVGETABCUOQUKVGFTVNUPAVGUTUQVAVB
      VC $.
  $}

  ${
    $d c k m n $.  $d c k m A $.  $d c k m B $.  $d n N $.
    ${
      sadaddlem.c $e |- C = seq 0 ( ( c e. 2o , m e. NN0 |-> if (
     cadd ( m e. ( bits ` A ) , m e. ( bits ` B ) , (/) e. c ) , 1o , (/) ) ) ,
          ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
      sadaddlem.k $e |- K = `' ( bits |` NN0 ) $.
      sadaddlem.1 $e |- ( ph -> A e. ZZ ) $.
      sadaddlem.2 $e |- ( ph -> B e. ZZ ) $.
      sadaddlem.3 $e |- ( ph -> N e. NN0 ) $.
      $( Lemma for ~ sadadd .  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
      sadaddlem $p |- ( ph ->
        ( ( ( bits ` A ) sadd ( bits ` B ) ) i^i ( 0 ..^ N ) ) =
          ( bits ` ( ( A + B ) mod ( 2 ^ N ) ) ) ) $=
        ( co cfv wceq cz wcel cn0 caddc c2 cexp cmo cbits csad cc0 cin cdivides
        cfzo cmin wbr cdiv cres ccnv fveq1i cn 2nn a1i nnexpcld zmodcld bitsmod
        fvres syl syl2anc eqtrd cpw cfn wf1o wi bitsf1o f1ocnvfv sylancr syl5eq
        mpd oveq2d oveq1d cr crp zred nnrpd moddifz eqeltrd wne nnzd nnne0d wss
        wb inss1 bitsss sstri fzofi inss2 ssfi mp2an elfpw mpbir2an f1ocnv f1of
        wf mp2b feq1i mpbir ffvelrni mp1i nn0zd zsubcld dvdsval2 syl3anc mpbird
        wa dvds2add mp2and nn0cnd addsub4d breqtrrd zaddcld moddvds sadadd3 cle
        zcnd clt sadcl nn0red nn0ge0d fveq2i f1ocnvfv2 3eqtr3a syl6eqss bitsfzo
        elfzolt2 modid syl22anc 3eqtr2d fveq2d eqtr2d ) ABCUAOZUBHUCOZUDOZUEPBU
        EPZCUEPZUFOZUGHUJOZUHZGPZUEPZUUDAYSUUEUEAYSYTUUCUHZGPZUUAUUCUHZGPZUAOZY
        RUDOZUUEYRUDOZUUEAYSUULQZYRYQUUKUKOZUIULZAYRBUUHUKOZCUUJUKOZUAOZUUOUIAY
        RUUQUIULZYRUURUIULZYRUUSUIULZAUUTUUQYRUMOZRSZAUVCBBYRUDOZUKOZYRUMOZRAUU
        QUVFYRUMAUUHUVEBUKAUUHUUGUETUNZUOZPZUVEUUGGUVIKUPAUVEUVHPZUUGQZUVJUVEQZ
        AUVKUVEUEPZUUGAUVETSZUVKUVNQABYRLAUBHUBUQSAURUSNUTZVAZUVETUEVCVDABRSHTS
        ZUVNUUGQLNHBVBVEVFATTVGVHUHZUVHVIZUVOUVLUVMVJVKUVQTUVSUVEUUGUVHVLVMVOVN
        VPVQABVRSYRVSSZUVGRSABLVTAYRUVPWAZBYRWBVEWCAYRRSZYRUGWDZUUQRSZUUTUVDWHA
        YRUVPWEZAYRUVPWFZABUUHLAUUHUUGUVSSZUUHTSAUWHUUGTWGUUGVHSZUUGYTTYTUUCWIB
        WJZWKUUCVHSZUUGUUCWGUWIUGHWLZYTUUCWMUUCUUGWNWOUUGTWPWQUVSTUUGGUVSTGWTUV
        STUVIWTZUVTUVSTUVIVIUWMVKTUVSUVHWRUVSTUVIWSXAUVSTGUVIKXBXCZXDXEZXFZXGZY
        RUUQXHXIXJAUVAUURYRUMOZRSZAUWRCCYRUDOZUKOZYRUMOZRAUURUXAYRUMAUUJUWTCUKA
        UUJUUIUVIPZUWTUUIGUVIKUPAUWTUVHPZUUIQZUXCUWTQZAUXDUWTUEPZUUIAUWTTSZUXDU
        XGQACYRMUVPVAZUWTTUEVCVDACRSUVRUXGUUIQMNHCVBVEVFAUVTUXHUXEUXFVJVKUXITUV
        SUWTUUIUVHVLVMVOVNVPVQACVRSUWAUXBRSACMVTUWBCYRWBVEWCAUWCUWDUURRSZUVAUWS
        WHUWFUWGACUUJMAUUJUUIUVSSZUUJTSAUXKUUITWGUUIVHSZUUIUUATUUAUUCWICWJZWKUW
        KUUIUUCWGUXLUWLUUAUUCWMUUCUUIWNWOUUITWPWQUVSTUUIGUWNXDXEZXFZXGZYRUURXHX
        IXJAUWCUWEUXJUUTUVAXKUVBVJUWFUWQUXPYRUUQUURXLXIXMABCUUHUUJABLYAACMYAAUU
        HUWOXNAUUJUXNXNXOXPAYRUQSYQRSUUKRSUUNUUPWHUVPABCLMXQAUUHUUJUWPUXOXQYQUU
        KYRXRXIXJAYTUUADEFGHIYTTWGZAUWJUSUUATWGZAUXMUSJNKXSAUUEVRSUWAUGUUEXTULU
        UEYRYBULZUUMUUEQAUUEUUDUVSSZUUETSZAUXTUUDTWGUUDVHSZUUDUUBTUUBUUCWIUXQUX
        RUUBTWGUWJUXMYTUUAYCWOWKUWKUUDUUCWGUYBUWLUUBUUCWMZUUCUUDWNWOUUDTWPWQZUV
        STUUDGUWNXDXEZYDUWBAUUEUYEYEAUUEUGYRUJOSZUXSAUYFUUFUUCWGZAUUFUUDUUCAUUE
        UVHPZUUDUVIPZUVHPZUUFUUDUUEUYIUVHUUDGUVIKUPYFAUYAUYHUUFQUYEUUETUEVCVDAU
        VTUXTUYJUUDQVKUXTAUYDUSTUVSUUDUVHYGVMYHZUYCYIAUUERSUVRUYFUYGWHAUUEUYEXF
        NHUUEYJVEXJUUEUGYRYKVDUUEYRYLYMYNYOUYKYP $.
    $}

    $( For sequences that correspond to valid integers, the adder sequence
       function produces the sequence for the sum.  This is effectively a proof
       of the correctness of the ripple carry adder, implemented with logic
       gates corresponding to ~ df-had and ~ df-cad .

       It is interesting to consider in what sense the ` sadd ` function can be
       said to be "adding" things outside the range of the ` bits ` function,
       that is, when adding sequences that are not eventually constant and so
       do not denote any integer.  The correct interpretation is that the
       sequences are representations of 2-adic integers, which have a natural
       ring structure.  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
    sadadd $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
      ( ( bits ` A ) sadd ( bits ` B ) ) = ( bits ` ( A + B ) ) ) $=
      ( vc vm vn cz wcel wa cbits cfv co cv cn0 wss bitsss a1i cc0 c1 c0 wceq
      vk csad caddc wi sadcl mp2an sseli wb cfzo cin c2 cexp cmo c2o wcad cmpt2
      c1o cmin cmpt cseq cres ccnv eqid simpll simplr simpr nn0addcld sadaddlem
      cif 1nn0 zaddcld bitsmod syl2anc eqtrd eleq2d elin 3bitr3g nn0uz syl6eleq
      cfz cuz eluzfz2 syl nn0zd fzval3 eleqtrd biantrud 3bitr4d pm5.21ndd eqrdv
      ex ) AFGZBFGZHZUAAIJZBIJZUBKZABUCKZIJZWNUALZMGZWTWQGZWTWSGZXBXAUDWNWQMWTW
      OMNWPMNWQMNAOBOWOWPUEUFUGPXCXAUDWNWSMWTWROUGPWNXAXBXCUHWNXAHZXBWTQWTRUCKZ
      UIKZGZHZXCXGHZXBXCXDWTWQXFUJZGWTWSXFUJZGXHXIXDXJXKWTXDXJWRUKXEULKUMKIJZXK
      XDABCDUNMDLZWOGXMWPGSCLGUOUQSVIUPEMELZQTSXNRURKVIUSQUTZDEIMVAVBZXECXOVCXP
      VCWLWMXAVDZWLWMXAVEZXDWTRWNXAVFZRMGXDVJPVGZVHXDWRFGXEMGXLXKTXDABXQXRVKXTX
      EWRVLVMVNVOWTWQXFVPWTWSXFVPVQXDXGXBXDWTQWTVTKZXFXDWTQWAJZGWTYAGXDWTMYBXSV
      RVSQWTWBWCXDWTFGYAXFTXDWTXSWDQWTWEWCWFZWGXDXGXCYCWGWHWKWIWJ $.

    $( The adder sequence function has a left identity, the empty set, which is
       the representation of the integer zero.  (Contributed by Mario Carneiro,
       9-Sep-2016.) $)
    sadid1 $p |- ( A C_ NN0 -> ( A sadd (/) ) = A ) $=
      ( cn0 wss c0 csad co cun id 0ss a1i cin wceq in0 saddisj un0 syl6eq ) ABC
      ZADEFADGAQADQHDBCQBIJADKDLQAMJNAOP $.

    $( The adder sequence function has a right identity, the empty set, which
       is the representation of the integer zero.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    sadid2 $p |- ( A C_ NN0 -> ( (/) sadd A ) = A ) $=
      ( cn0 wss c0 csad co wceq 0ss sadcom mpan sadid1 eqtrd ) ABCZDAEFZADEFZAD
      BCMNOGBHDAIJAKL $.

    $d c k m C $.
    ${
      sadasslem.1 $e |- ( ph -> A C_ NN0 ) $.
      sadasslem.2 $e |- ( ph -> B C_ NN0 ) $.
      sadasslem.3 $e |- ( ph -> C C_ NN0 ) $.
      sadasslem.4 $e |- ( ph -> N e. NN0 ) $.
      $( Lemma for ~ sadass .  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
      sadasslem $p |- ( ph ->
        ( ( ( A sadd B ) sadd C ) i^i ( 0 ..^ N ) ) =
        ( ( A sadd ( B sadd C ) ) i^i ( 0 ..^ N ) ) ) $=
        ( vc vm co cc0 cn0 cfv wceq cmo wcel wss syl vn csad cfzo cin cres ccnv
        cbits c2 cexp caddc cpw cfn inss1 syl5ss fzofi inss2 ssfi sylancl elfpw
        a1i sylanbrc wf1o wf bitsf1o f1ocnv f1of ffvelrni nn0cnd addassd oveq1d
        mp2b sadcl syl2anc nn0red readdcld crp 2rp nn0zd rpexpcld c2o cv c0 c1o
        wcad cif cmpt2 c1 cmin cmpt cseq sadadd3 eqidd modadd12d 3eqtr4d cr cle
        eqid wbr clt nn0ge0d fvres f1ocnvfv2 sylancr eqtr3d syl6eqss cz bitsfzo
        wb mpbird elfzolt2 modid syl22anc 2nn nnexpcld nnrpd 3eqtr3d wf1 f1fveq
        cn wa f1of1 mpan mpbid ) ABCUBLZDUBLZMEUCLZUDZUGNUEZUFZOZBCDUBLZUBLZYFU
        DZYIOZPZYGYMPZAYJUHEUILZQLZYNYQQLZYJYNAYDYFUDZYIOZDYFUDZYIOZUJLYQQLZBYF
        UDZYIOZYKYFUDZYIOZUJLYQQLZYRYSAUUFCYFUDZYIOZUJLZUUCUJLZYQQLUUFUUKUUCUJL
        ZUJLZYQQLUUDUUIAUUMUUOYQQAUUFUUKUUCAUUFAUUENUKULUDZRZUUFNRAUUENSUUEULRZ
        UUQAUUEBNBYFUMFUNAYFULRZUUEYFSUURUUSAMEUOUTZBYFUPYFUUEUQURUUENUSVAUUPNU
        UEYINUUPYHVBZUUPNYIVBZUUPNYIVCVDNUUPYHVEZUUPNYIVFVKZVGTZVHAUUKAUUJUUPRZ
        UUKNRAUUJNSUUJULRZUVFAUUJCNCYFUMGUNAUUSUUJYFSUVGUUTCYFUPYFUUJUQURUUJNUS
        VAUUPNUUJYIUVDVGTZVHAUUCAUUBUUPRZUUCNRAUUBNSUUBULRZUVIAUUBDNDYFUMHUNAUU
        SUUBYFSUVJUUTDYFUPYFUUBUQURUUBNUSVAUUPNUUBYIUVDVGTZVHVIVJAUUAUULUUCUUCY
        QAUUAAYTUUPRZUUANRAYTNSYTULRZUVLAYTYDNYDYFUMABNSZCNSZYDNSZFGBCVLVMZUNAU
        USYTYFSUVMUUTYDYFUPYFYTUQURYTNUSVAUUPNYTYIUVDVGTVNAUUFUUKAUUFUVEVNZAUUK
        UVHVNZVOAUUCUVKVNZUVTAUHEUHVPRAVQUTAEIVRVSZABCJKVTNKWAZBRZUWBCRZWBJWARZ
        WDWCWBWEWFUANUAWAZMPWBUWFWGWHLWEWIZMWJZKUAYIEJFGUWHWQIYIWQZWKAUUCYQQLWL
        WMAUUFUUFUUHUUNYQUVRUVRAUUHAUUGUUPRZUUHNRAUUGNSUUGULRZUWJAUUGYKNYKYFUMA
        UVODNSZYKNSZGHCDVLVMZUNAUUSUUGYFSUWKUUTYKYFUPYFUUGUQURUUGNUSVAUUPNUUGYI
        UVDVGTVNAUUKUUCUVSUVTVOUWAAUUFYQQLWLACDJKVTNUWDUWBDRZUWEWDWCWBWEWFUWGMW
        JZKUAYIEJGHUWPWQIUWIWKWMWNAYDDJKVTNUWBYDRUWOUWEWDWCWBWEWFUWGMWJZKUAYIEJ
        UVQHUWQWQIUWIWKABYKJKVTNUWCUWBYKRUWEWDWCWBWEWFUWGMWJZKUAYIEJFUWNUWRWQIU
        WIWKWNAYJWORYQVPRZMYJWPWRYJYQWSWRZYRYJPAYJAYGUUPRZYJNRZAYGNSYGULRZUXAAY
        GYENYEYFUMAUVPUWLYENSUVQHYDDVLVMUNAUUSYGYFSUXCUUTYEYFUPZYFYGUQURYGNUSVA
        ZUUPNYGYIUVDVGTZVNUWAAYJUXFWTAYJMYQUCLZRZUWTAUXHYJUGOZYFSZAUXIYGYFAYJYH
        OZUXIYGAUXBUXKUXIPUXFYJNUGXATAUVAUXAUXKYGPVDUXENUUPYGYHXBXCXDUXDXEAYJXF
        RENRZUXHUXJXHAYJUXFVRIEYJXGVMXIYJMYQXJTYJYQXKXLAYNWORUWSMYNWPWRYNYQWSWR
        ZYSYNPAYNAYMUUPRZYNNRZAYMNSYMULRZUXNAYMYLNYLYFUMAUVNUWMYLNSFUWNBYKVLVMU
        NAUUSYMYFSUXPUUTYLYFUPZYFYMUQURYMNUSVAZUUPNYMYIUVDVGTZVNAYQAUHEUHXSRAXM
        UTIXNXOAYNUXSWTAYNUXGRZUXMAUXTYNUGOZYFSZAUYAYMYFAYNYHOZUYAYMAUXOUYCUYAP
        UXSYNNUGXATAUVAUXNUYCYMPVDUXRNUUPYMYHXBXCXDUXQXEAYNXFRUXLUXTUYBXHAYNUXS
        VRIEYNXGVMXIYNMYQXJTYNYQXKXLXPAUXAUXNYOYPXHZUXEUXRUUPNYIXQZUXAUXNXTUYDU
        VAUVBUYEVDUVCUUPNYIYAVKUUPNYGYMYIXRYBVMYC $.
    $}

    $( Sequence addition is associative.  (Contributed by Mario Carneiro,
       9-Sep-2016.) $)
    sadass $p |- ( ( A C_ NN0 /\ B C_ NN0 /\ C C_ NN0 ) ->
      ( ( A sadd B ) sadd C ) = ( A sadd ( B sadd C ) ) ) $=
      ( vk cn0 wss csad co wcel sadcl syl2anc sseld wa cc0 c1 cin elin biantrud
      adantr syl cv 3adant3 simp3 simp1 3adant1 wb caddc cfzo simpl2 simpr 1nn0
      w3a a1i nn0addcld sadasslem eleq2d 3bitr3g cfz cuz nn0uz syl6eleq eluzfz2
      cfv cz wceq nn0zd fzval3 eleqtrd 3bitr4d ex pm5.21ndd eqrdv ) AEFZBEFZCEF
      ZULZDABGHZCGHZABCGHZGHZVPDUAZEIZWAVRIZWAVTIZVPVREWAVPVQEFZVOVREFVMVNWEVOA
      BJUBVMVNVOUCZVQCJKLVPVTEWAVPVMVSEFZVTEFVMVNVOUDZVNVOWGVMBCJUEAVSJKLVPWBWC
      WDUFVPWBMZWCWANWAOUGHZUHHZIZMZWDWLMZWCWDWIWAVRWKPZIWAVTWKPZIWMWNWIWOWPWAW
      IABCWJVPVMWBWHSVMVNVOWBUIVPVOWBWFSWIWAOVPWBUJZOEIWIUKUMUNUOUPWAVRWKQWAVTW
      KQUQWIWLWCWIWANWAURHZWKWIWANUSVCZIWAWRIWIWAEWSWQUTVANWAVBTWIWAVDIWRWKVEWI
      WAWQVFNWAVGTVHZRWIWLWDWTRVIVJVKVL $.
  $}

  ${
    $d c m A $.  $d c m B $.  $d c m n N $.
    sadeq.a $e |- ( ph -> A C_ NN0 ) $.
    sadeq.b $e |- ( ph -> B C_ NN0 ) $.
    sadeq.n $e |- ( ph -> N e. NN0 ) $.
    $( Any element of a sequence sum only depends on the values of the argument
       sequences up to and including that point.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    sadeq $p |- ( ph -> ( ( A sadd B ) i^i ( 0 ..^ N ) ) =
  ( ( ( A i^i ( 0 ..^ N ) ) sadd ( B i^i ( 0 ..^ N ) ) ) i^i ( 0 ..^ N ) ) ) $=
      ( vc vm co cc0 cin cbits cn0 cfv wceq cmo wcel wss syl vn csad cfzo caddc
      cres ccnv c2 cexp inass inidm ineq2i eqtri fveq2i oveq12i oveq1i c2o wcad
      cv c0 c1o cif cmpt2 c1 cmin cmpt cseq inss1 syl5ss sadadd3 3eqtr4a cr crp
      eqid cle wbr clt cpw cfn sadcl syl2anc fzofi a1i inss2 ssfi sylancl elfpw
      sylanbrc wf1o bitsf1o f1ocnv f1of mp2b ffvelrni nn0red 2rp nn0zd rpexpcld
      wf nn0ge0d fvres f1ocnvfv2 sylancr eqtr3d syl6eqss cz wb bitsfzo elfzolt2
      mpbird modid syl22anc 3eqtr3rd wf1 wa f1of1 f1fveq mpan mpbid ) ABCUBJZKD
      UCJZLZMNUEZUFZOZBXTLZCXTLZUBJZXTLZYCOZPZYAYHPZAYIUGDUHJZQJZYDYLQJZYIYDAYE
      XTLZYCOZYFXTLZYCOZUDJZYLQJYEYCOZYFYCOZUDJZYLQJYMYNYSUUBYLQYPYTYRUUAUDYOYE
      YCYOBXTXTLZLYEBXTXTUIUUCXTBXTUJZUKULUMYQYFYCYQCUUCLYFCXTXTUIUUCXTCUUDUKUL
      UMUNUOAYEYFHIUPNIURZYERUUEYFRUSHURRZUQUTUSVAVBUANUAURZKPUSUUGVCVDJVAVEZKV
      FZIUAYCDHAYEBNBXTVGEVHZAYFCNCXTVGFVHZUUIVMGYCVMZVIABCHIUPNUUEBRUUECRUUFUQ
      UTUSVAVBUUHKVFZIUAYCDHEFUUMVMGUULVIVJAYIVKRYLVLRZKYIVNVOYIYLVPVOZYMYIPAYI
      AYHNVQVRLZRZYINRZAYHNSYHVRRZUUQAYHYGNYGXTVGAYENSYFNSYGNSUUJUUKYEYFVSVTVHA
      XTVRRZYHXTSUUSUUTAKDWAWBZYGXTWCZXTYHWDWEYHNWFWGZUUPNYHYCNUUPYBWHZUUPNYCWH
      ZUUPNYCWRWINUUPYBWJZUUPNYCWKWLZWMTZWNAUGDUGVLRAWOWBADGWPWQZAYIUVHWSAYIKYL
      UCJZRZUUOAUVKYIMOZXTSZAUVLYHXTAYIYBOZUVLYHAUURUVNUVLPUVHYINMWTTAUVDUUQUVN
      YHPWIUVCNUUPYHYBXAXBXCUVBXDAYIXERDNRZUVKUVMXFAYIUVHWPGDYIXGVTXIYIKYLXHTYI
      YLXJXKAYDVKRUUNKYDVNVOYDYLVPVOZYNYDPAYDAYAUUPRZYDNRZAYANSYAVRRZUVQAYAXSNX
      SXTVGABNSCNSXSNSEFBCVSVTVHAUUTYAXTSUVSUVAXSXTWCZXTYAWDWEYANWFWGZUUPNYAYCU
      VGWMTZWNUVIAYDUWBWSAYDUVJRZUVPAUWCYDMOZXTSZAUWDYAXTAYDYBOZUWDYAAUVRUWFUWD
      PUWBYDNMWTTAUVDUVQUWFYAPWIUWANUUPYAYBXAXBXCUVTXDAYDXERUVOUWCUWEXFAYDUWBWP
      GDYDXGVTXIYDKYLXHTYDYLXJXKXLAUVQUUQYJYKXFZUWAUVCUUPNYCXMZUVQUUQXNUWGUVDUV
      EUWHWIUVFUUPNYCXOWLUUPNYAYHYCXPXQVTXR $.
  $}

  $( Restrict the bits of a number to an upper integer set.  (Contributed by
     Mario Carneiro, 5-Sep-2016.) $)
  bitsres $p |- ( ( A e. ZZ /\ N e. NN0 ) -> ( ( bits ` A ) i^i ( ZZ>= ` N ) )
      = ( bits ` ( ( |_ ` ( A / ( 2 ^ N ) ) ) x. ( 2 ^ N ) ) ) ) $=
    ( cz wcel cn0 c2 co cbits cfv csad caddc cin cmul wceq a1i syl2anc cc0 zcnd
    c0 wss wa cexp cmo cneg cuz cdiv cfl simpl 2nn simpr nnexpcld zmodcld nn0zd
    znegcld sadadd addcomd negidd eqtrd fveq2d 0bits syl6eq oveq1d bitsss inss1
    syl5ss sadass syl3anc cfzo cun bitsmod fzouzdisj ineq2i in0 3eqtr3i saddisj
    cn inindi syl6eqr nn0uz syl6eleq fzouzsplit syl syl5eq syl5sseq df-ss sylib
    indi 3eqtrd oveq2d sadid2 3eqtr3d cmin negsubd subcld nncnd nnne0d divcan1d
    cr crp zred nnrpd moddiffl eqtr3d ) ACDZBEDZUAZAFBUBGZUCGZUDZHIZAHIZJGZXIAK
    GZHIZXKBUEIZLZAXGUFGUGIZXGMGZHIXFXICDZXDXLXNNXFXHXFXHXFAXGXDXEUHZXFFBFVPDXF
    UIOXDXEUJZUKZULUMZUNZXTXIAUOPXFXJXHHIZJGZXPJGZSXPJGZXLXPXFYFSXPJXFYFXIXHKGZ
    HIZSXFXSXHCDYFYJNYDYCXIXHUOPXFYJQHISXFYIQHXFYIXHXIKGQXFXIXHXFXIYDRZXFXHYCRZ
    UPXFXHYLUQURUSUTVAURVBXFYGXJYEXPJGZJGZXLXFXJETZYEETZXPETZYGYNNYOXFXIVCOYPXF
    XHVCOXFXPXKEXKXOVDXKETXFAVCZOZVEZXJYEXPVFVGXFYMXKXJJXFYMXKQBVHGZLZXPJGZXKUU
    AXOVIZLZXKXFYEUUBXPJBAVJVBXFUUCUUBXPVIUUEXFUUBXPXFUUBXKEXKUUAVDYSVEYTUUBXPL
    ZSNXFXKUUAXOLZLXKSLUUFSUUGSXKQBVKVLXKUUAXOVQXKVMVNOVOXKUUAXOWGVRXFXKUUDTUUE
    XKNXFEXKUUDYRXFEQUEIZUUDVSXFBUUHDUUHUUDNXFBEUUHYAVSVTQBWAWBWCWDXKUUDWEWFWHW
    IURXFYQYHXPNYTXPWJWBWKXFXMXRHXFXMAXIKGAXHWLGZXRXFXIAYKXFAXTRZUPXFAXHUUJYLWM
    XFUUIXGUFGZXGMGUUIXRXFUUIXGXFAXHUUJYLWNXFXGYBWOXFXGYBWPWQXFUUKXQXGMXFAWRDXG
    WSDUUKXQNXFAXTWTXFXGYBXAAXGXBPVBXCWHUSWK $.

  $( The bits of a number are all at least ` N ` iff the number is divisible by
     ` 2 ^ N ` .  (Contributed by Mario Carneiro, 21-Sep-2016.) $)
  bitsuz $p |- ( ( A e. ZZ /\ N e. NN0 ) ->
    ( ( 2 ^ N ) || A <-> ( bits ` A ) C_ ( ZZ>= ` N ) ) ) $=
    ( cz wcel cn0 wa c2 cdivides wbr cbits cfv wceq cmul a1i syl2anc cc0 adantr
    co wb cc cexp cuz cin wss cdiv cfl bitsres eqeq1d simpl zred simpr nnexpcld
    cn 2nn nndivred flcld nnzd zmulcld cpw wf1 bitsf1 f1fveq dvdsmul2 syl5ibcom
    mpan breq2 wne nnne0d dvdsval2 syl3anc biimpa flid syl oveq1d zcnd 2cn 2ne0
    nncnd nn0zd expne0d divcan1d eqtrd ex impbid 3bitrrd df-ss syl6bbr ) ACDZBE
    DZFZGBUARZAHIZAJKZBUBKZUCZWMLZWMWNUDWJWPAWKUERZUFKZWKMRZJKZWMLZWSALZWLWJWOW
    TWMABUGUHWJWSCDZWHXAXBSZWJWRWKWJWQWJAWKWJAWHWIUIZUJWJGBGUMDWJUNNWHWIUKZULZU
    OUPZWJWKXGUQZURXECEUSZJUTXCWHFXDVACXJWSAJVBVEOWJXBWLWJWKWSHIZXBWLWJWRCDWKCD
    ZXKXHXIWRWKVCOWSAWKHVFVDWJWLXBWJWLFZWSWQWKMRAXMWRWQWKMXMWQCDZWRWQLWJWLXNWJX
    LWKPVGWHWLXNSXIWJWKXGVHXEWKAVIVJVKWQVLVMVNXMAWKWJATDWLWJAXEVOQWJWKTDWLWJWKX
    GVRQXMGBGTDXMVPNGPVGXMVQNWJBCDWLWJBXFVSQVTWAWBWCWDWEWMWNWFWG $.

  ${
    $d n A $.  $d n N $.
    $( Shifting a bit sequence to the left (toward the more significant bits)
       causes the number to be multiplied by a power of two.  (Contributed by
       Mario Carneiro, 22-Sep-2016.) $)
    bitsshft $p |- ( ( A e. ZZ /\ N e. NN0 ) ->
        { n e. NN0 | ( n - N ) e. ( bits ` A ) }
            = ( bits ` ( A x. ( 2 ^ N ) ) ) ) $=
      ( cz wcel cn0 wa c2 cexp co cfv wss cdivides wbr nnexpcld syl2anc wb cdiv
      a1i cfl cmul cbits cin cv cmin crab wceq bitsss dfss1 mpbi cuz simpll 2nn
      cn simplr nnzd dvdsmul2 zmulcld bitsuz mpbid sseld uznn0sub wn 2cn nnne0d
      syl6 cc nn0zd simprl expsubd oveq2d simpl zcnd adantr nncnd eqtr2d fveq2d
      divdiv2d breq2d notbid adantrr ad2ant2rl 3bitr4d expr pm5.21ndd rabbi2dva
      bitsval2 syl5reqr ) ADEZCFEZGZAHCIJZUAJZUBKZFWNUCZBUDZCUEJZAUBKZEZBFUFWNF
      LWOWNUGWMUHWNFUIUJWKWSBFWNWKWPFEZGZWQFEZWPWNEZWSXAXCWPCUKKZEXBXAWNXDWPXAW
      LWMMNZWNXDLZXAWIWLDEXEWIWJWTULZXAWLXAHCHUNEZXAUMSWIWJWTUOZOUPZAWLUQPXAWMD
      EZWJXEXFQXAAWLXGXJURZXIWMCUSPUTVACWPVBVFXAWRFWQWRFLXAAUHSVAWKWTXBXCWSQWKW
      TXBGZGZHWMHWPIJZRJZTKZMNZVCZHAHWQIJZRJZTKZMNZVCZXCWSXNXRYCXNXQYBHMXNXPYAT
      XNYAAXOWLRJZRJXPXNXTYEARXNHWPCHVGEXNVDSXNHXHXNUMSZVEXNCWIWJXMUOZVHXNWPWKW
      TXBVIZVHVJVKXNAXOWLWKAVGEXMWKAWIWJVLVMVNXNXOXNHWPYFYHOZVOXNWLXNHCYFYGOZVO
      XNXOYIVEXNWLYJVEVRVPVQVSVTXNXKWTXCXSQWKWTXKXBXLWAYHWPWMWGPWIXBWSYDQWJWTWQ
      AWGWBWCWDWEWFWH $.
  $}

  ${
    $d k m n p x y z $.  $d k m n p x y A $.  $d k n x y N $.  $d k n x y ph $.
    $d k m n p x y B $.  $d k x M $.  $d k x y P $.
    $( Define the multiplication of two bit sequences, using repeated sequence
       addition.  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
    df-smu $a |- smul = ( x e. ~P NN0 , y e. ~P NN0 |-> { k e. NN0 |
      k e. ( seq 0 ( ( p e. ~P NN0 , m e. NN0 |->
          ( p sadd { n e. NN0 | ( m e. x /\ ( n - m ) e. y ) } ) ) ,
      ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) ` ( k + 1 ) ) } ) $.

    smuval.a $e |- ( ph -> A C_ NN0 ) $.
    smuval.b $e |- ( ph -> B C_ NN0 ) $.
    smuval.p $e |- P = seq 0 ( ( p e. ~P NN0 , m e. NN0 |->
          ( p sadd { n e. NN0 | ( m e. A /\ ( n - m ) e. B ) } ) ) ,
      ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
    $( Define the addition of two bit sequences, using ~ df-had and ~ df-cad
       bit operations.  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
    smufval $p |- ( ph ->
      ( A smul B ) = { k e. NN0 | k e. ( P ` ( k + 1 ) ) } ) $=
      ( vx vy cn0 wcel co cv crab wceq cc0 cpw csmu c1 caddc nn0ex elpw2 sylibr
      cfv wss cmin wa csad cmpt2 cif cmpt cseq w3a simp1l eleq2d simp1r anbi12d
      c0 rabbidv oveq2d mpt2eq3dva seqeq2d syl6eqr fveq1d rabex ovmpt2a syl2anc
      df-smu ) ABNUAZOZCVMOZBCUBPEQZVPUCUDPZDUHZOZENRZSABNUIVNIBNUEUFUGACNUIVOJ
      CNUEUFUGLMBCVMVMVPVQHFVMNHQZFQZLQZOZGQZWBUJPZMQZOZUKZGNRZULPZUMZGNWETSVBW
      EUCUJPUNUOZTUPZUHZOZENRVTUBWCBSZWGCSZUKZWPVSENWSWOVRVPWSVQWNDWSWNHFVMNWAW
      BBOZWFCOZUKZGNRZULPZUMZWMTUPDWSWLXEWMTWSHFVMNWKXDWSWAVMOZWBNOZUQZWJXCWAUL
      XHWIXBGNXHWDWTWHXAXHWCBWBWQWRXFXGURUSXHWGCWFWQWRXFXGUTUSVAVCVDVEVFKVGVHUS
      VCLMEFGHVLVSENUEVIVJVK $.

    $( The sequence of partial sums of the sequence multiplication.
       (Contributed by Mario Carneiro, 9-Sep-2016.) $)
    smupf $p |- ( ph -> P : NN0 --> ~P NN0 ) $=
      ( cn0 cv wcel co wa cc0 c0 wf cvv cfv vx vy cpw cmin crab csad cmpt2 wceq
      c1 cif cmpt cseq 0nn0 iftrue eqid 0ex fvmpt mp1i 0elpw syl6eqel cop df-ov
      cxp wral elpwi adantr ssrab2 sadcl sylancl nn0ex elpw2 sylibr rgen2 fmpt2
      wss mpbi f0cli eqeltri a1i nn0uz cz 0z caddc cuz fvex seqf2 feq1i ) AKKUC
      ZGEWHKGLZELZBMFLZWJUDNCMOZFKUEZUFNZUGZFKWKPUHZQWKUIUDNZUJZUKZPULZRKWHDRAU
      AUBWHSWOWSPKAPWSTZQWHPKMXAQUHAUMFPWRQKWSWPQWQUNWSUOUPUQURKUSZUTUALZUBLZWO
      NZWHMAXCWHMXDSMOOXEXCXDVAZWOTWHXCXDWOVBWHKVCZWHXFWOWNWHMZEKVDGWHVDXGWHWOR
      XHGEWHKWIWHMZWJKMZOZWNKVOZXHXKWIKVOZWMKVOXLXIXMXJWIKVEVFWLFKVGWIWMVHVIWNK
      VJVKVLVMGEWHKWNWHWOWOUOVNVPXBVQVRVSVTPWAMAWBVSXCWSTSMAXCPUIWCNWDTMOXCWSWE
      VSWFKWHDWTJWGVL $.

    $( The initial element of the partial sum sequence.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    smup0 $p |- ( ph -> ( P ` 0 ) = (/) ) $=
      ( cc0 cfv cn0 cv wceq c0 cmin co wcel mp1i c1 cif cmpt cz 0z wa crab csad
      cpw cmpt2 cseq fveq1i seq1 syl5eq 0nn0 iftrue eqid 0ex fvmpt eqtrd ) AKDL
      ZKFMFNZKOZPVBUAQRZUBZUCZLZPKUDSZVAVGOAUEVHVAKGEMUIMGNENZBSVBVIQRCSUFFMUGU
      HRUJZVFKUKZLVGKDVKJULVJVFKUMUNTKMSVGPOAUOFKVEPMVFVCPVDUPVFUQURUSTUT $.

    smuval.n $e |- ( ph -> N e. NN0 ) $.
    $( The initial element of the partial sum sequence.  (Contributed by Mario
       Carneiro, 9-Sep-2016.) $)
    smupp1 $p |- ( ph -> ( P ` ( N + 1 ) ) =
      ( ( P ` N ) sadd { n e. NN0 | ( N e. A /\ ( n - N ) e. B ) } ) ) $=
      ( c1 co cn0 cc0 wceq cmin wcel csad vx vy vk caddc cfv cv c0 cif cmpt cpw
      wa crab cmpt2 cseq cuz nn0uz syl6eleq seqp1 syl fveq1i oveq1i 3eqtr4g a1i
      1nn0 nn0addcld eqeq1 oveq1 ifbieq2d eqid 0ex ovex ifex wne nn0p1nn nnne0d
      fvmpt cn ifnefalse nn0cnd pncand 3eqtrd oveq2d smupf ffvelrnd simpl simpr
      eleq1d anbi12d rabbidv anbi2d cbvrabv syl6eq oveq12d eleq1 oveq2 cbvmpt2v
      syl6eqr ovmpt2a syl2anc ) AGMUDNZDUEZGDUEZWTFOFUFZPQZUGXCMRNZUHZUIZUEZHEO
      UJZOHUFZEUFZBSZXCXKRNZCSZUKZFOULZTNZUMZNZXBGXRNZXBGBSZXCGRNZCSZUKZFOULZTN
      ZAWTXRXGPUNZUEZGYGUEZXHXRNZXAXSAGPUOUEZSYHYJQAGOYKLUPUQXRXGPGURUSWTDYGKUT
      XBYIXHXRGDYGKUTVAVBAXHGXBXRAXHWTPQZUGWTMRNZUHZYMGAWTOSXHYNQAGMLMOSAVDVCZV
      EFWTXFYNOXGXCWTQXDYLXEYMUGXCWTPVFXCWTMRVGVHXGVIYLUGYMVJWTMRVKVLVPUSAWTPVM
      YNYMQAWTAGOSZWTVQSLGVNUSVOWTPUGYMVRUSAGMAGLVSAMYOVSVTWAWBAXBXISYPXTYFQAOX
      IGDABCDEFHIJKWCLWDLUAUBXBGXIOUAUFZUBUFZBSZUCUFZYRRNZCSZUKZUCOULZTNZYFXRYQ
      XBQZYRGQZUKZYQXBUUDYETUUFUUGWEUUHUUDYAYTGRNZCSZUKZUCOULYEUUHUUCUUKUCOUUHY
      SYAUUBUUJUUHYRGBUUFUUGWFZWGUUHUUAUUICUUHYRGYTRUULWBWGWHWIUUKYDUCFOYTXCQZU
      UJYCYAUUMUUIYBCYTXCGRVGWGWJWKWLWMHEUAUBXIOXQUUEYQXPTNXJYQXPTVGXKYRQZXPUUD
      YQTUUNXPYSXCYRRNZCSZUKZFOULUUDUUNXOUUQFOUUNXLYSXNUUPXKYRBWNUUNXMUUOCXKYRX
      CRWOWGWHWIUUCUUQUCFOUUMUUBUUPYSUUMUUAUUOCYTXCYRRVGWGWJWKWQWBWPXBYETVKWRWS
      WA $.

    $( Define the addition of two bit sequences, using ~ df-had and ~ df-cad
       bit operations.  (Contributed by Mario Carneiro, 9-Sep-2016.) $)
    smuval $p |- ( ph -> ( N e. ( A smul B ) <-> N e. ( P ` ( N + 1 ) ) ) ) $=
      ( vk csmu co wcel c1 caddc cfv cn0 cv crab smufval eleq2d wb oveq1 fveq2d
      wceq id eleq12d elrab3 syl bitrd ) AGBCNOZPGMUAZUOQROZDSZPZMTUBZPZGGQROZD
      SZPZAUNUSGABCDMEFHIJKUCUDAGTPUTVCUELURVCMGTUOGUHZUOGUQVBVDUIVDUPVADUOGQRU
      FUGUJUKULUM $.

    ${
      smuval2.m $e |- ( ph -> M e. ( ZZ>= ` ( N + 1 ) ) ) $.
      $( The partial sum sequence stabilizes at ` N ` after the ` N + 1 ` -th
         element of the sequence; this stable value is the value of the
         sequence multiplication.  (Contributed by Mario Carneiro,
         9-Sep-2016.) $)
      smuval2 $p |- ( ph -> ( N e. ( A smul B ) <-> N e. ( P ` M ) ) ) $=
        ( co cfv wcel wceq cn0 cin vx vk c1 caddc cuz wb cv fveq2 eleq2d bibi2d
        csmu wi imbi2d cz smuval a1i wa cmin crab csad wss adantr peano2nn0 syl
        eluznn0 sylan smupp1 cc0 cfzo cpw smupf ffvelrnd elpwid ssrab2 sadeq c0
        inrab2 wn wral cle wbr clt inss1 simpr sseldi nn0red 1re readdcld inss2
        elfzolt2 eluzle ad2antlr ltletrd ltnled mpbid sseld nn0ge0 syl6 subge0d
        sylibd adantld mtod ralrimiva rabeq0 sylibr syl5eq oveq2d syl5ss sadid1
        cr eqtrd ineq1d inass inidm ineq2i eqtri syl6eq elin cfz nn0uz syl6eleq
        3bitr3g eluzfz2 nn0zd fzval3 eleqtrd biantrud 3bitr4d bitrd biimprd a2d
        expcom uzind4 mpcom ) GHUCUDOZUEPZQAHBCUKOQZHGDPZQZUFZNAYQHUAUGZDPZQZUF
        ZULAYQHYODPZQZUFZULZAYQHUBUGZDPZQZUFZULAYQHUUIUCUDOZDPZQZUFZULAYTULUAUB
        YOGUUAYORZUUDUUGAUUQUUCUUFYQUUQUUBUUEHUUAYODUHUIUJUMUUAUUIRZUUDUULAUURU
        UCUUKYQUURUUBUUJHUUAUUIDUHUIUJUMUUAUUMRZUUDUUPAUUSUUCUUOYQUUSUUBUUNHUUA
        UUMDUHUIUJUMUUAGRZUUDYTAUUTUUCYSYQUUTUUBYRHUUAGDUHUIUJUMUUHYOUNQABCDEFH
        IJKLMUOUPUUIYPQZAUULUUPAUVAUULUUPULAUVAUQZUUPUULUVBUUOUUKYQUVBUUOHUUJUU
        IBQZFUGZUUIUROZCQZUQZFSUSZUTOZQZUUKUVBUUNUVIHUVBBCDEFUUIIABSVAUVAJVBZAC
        SVAZUVAKVBZLAYOSQZUVAUUISQZAHSQZUVNMHVCVDZUUIYOVEVFZVGUIUVBUVJHVHYOVIOZ
        QZUQZUUKUVTUQZUVJUUKUVBHUVIUVSTZQHUUJUVSTZQUWAUWBUVBUWCUWDHUVBUWCUWDUVH
        UVSTZUTOZUVSTZUWDUVBUUJUVHYOUVBUUJSUVBSSVJUUIDUVBBCDEFIUVKUVMLVKUVRVLVM
        ZUVHSVAUVBUVGFSVNUPAUVNUVAUVQVBVOUVBUWGUWDUVSTZUWDUVBUWFUWDUVSUVBUWFUWD
        VPUTOZUWDUVBUWEVPUWDUTUVBUWEUVGFSUVSTZUSZVPUVGFSUVSVQUVBUVGVRZFUWKVSUWL
        VPRUVBUWMFUWKUVBUVDUWKQZUQZUVGUUIUVDVTWAZUWOUVDUUIWBWAUWPVRUWOUVDYOUUIU
        WOUVDUWOUWKSUVDSUVSWCUVBUWNWDZWEWFZUWOHUCUWOHUVBUVPUWNAUVPUVAMVBZVBWFUC
        XJQUWOWGUPWHUWOUUIUVBUVOUWNUVRVBWFZUWOUVDUVSQUVDYOWBWAUWOUWKUVSUVDSUVSW
        IUWQWEUVDVHYOWJVDUVAYOUUIVTWAAUWNYOUUIWKWLWMUWOUVDUUIUWRUWTWNWOUWOUVFUW
        PUVCUWOUVFVHUVEVTWAZUWPUWOUVFUVESQUXAUWOCSUVEUVBUVLUWNUVMVBWPUVEWQWRUWO
        UVDUUIUWRUWTWSWTXAXBXCUVGFUWKXDXEXFXGUVBUWDSVAUWJUWDRUVBUWDUUJSUUJUVSWC
        UWHXHUWDXIVDXKXLUWIUUJUVSUVSTZTUWDUUJUVSUVSXMUXBUVSUUJUVSXNXOXPXQXKUIHU
        VIUVSXRHUUJUVSXRYBUVBUVTUVJUVBHVHHXSOZUVSUVBHVHUEPZQHUXCQUVBHSUXDUWSXTY
        AVHHYCVDUVBHUNQUXCUVSRUVBHUWSYDVHHYEVDYFZYGUVBUVTUUKUXEYGYHYIUJYJYLYKYM
        YN $.
    $}

    smupvallem.a $e |- ( ph -> A C_ ( 0 ..^ N ) ) $.
    smupvallem.m $e |- ( ph -> M e. ( ZZ>= ` N ) ) $.
    $( If ` A ` only has elements less than ` N ` , then all elements of the
       partial sum sequence past ` N ` already equal the final value.
       (Contributed by Mario Carneiro, 20-Sep-2016.) $)
    smupvallem $p |- ( ph -> ( P ` M ) = ( A smul B ) ) $=
      ( vk cfv cn0 wcel wceq vx csmu co cv cpw smupf cuz eluznn0 syl2anc elpwid
      ffvelrnd sseld c1 caddc smufval ssrab2 syl6eqss wb wa wss ad2antrr simplr
      adantr uztrn sylan smuval2 bicomd simpll wi fveq2 eqeq1d imbi2d eqidd a1i
      crab cz cmin csad c0 smupp1 wn clt wbr cle eluzle adantl cr nn0red lenltd
      wral mpbid cfzo elfzolt2 syl6 adantrd mtod ralrimivw rabeq0 sylibr oveq2d
      cc0 sadid1 syl 3eqtrd biimprd expcom a2d uzind4 sylc eqtr4d eleq2d smuval
      wf simpr bitr4d wo nn0zd peano2zd uztric mpjaodan ex pm5.21ndd eqrdv ) AP
      GDQZBCUBUCZAPUDZRSZYFYDSZYFYESZAYDRYFAYDRARRUEZGDABCDEFIJKLUFZAHRSZGHUGQZ
      SZGRSMOGHUHUIUKUJULAYERYFAYEYFYFUMUNUCZDQZSZPRVORABCDPEFIJKLUOYQPRUPUQULA
      YGYHYIURZAYGUSZHYOUGQZSZYRYOYMSZYSUUAUSZYIYHUUCBCDEFGYFIABRUTZYGUUAJVAACR
      UTZYGUUAKVALAYGUUAVBYSYNUUAGYTSAYNYGOVCHGYOVDVEVFVGYSUUBUSZYHYQYIUUFYDYPY
      FUUFYDHDQZYPUUFYNAYDUUGTZAYNYGUUBOVAAYGUUBVHZAUAUDZDQZUUGTZVIZAUUGUUGTZVI
      ZAYFDQZUUGTZVIZAYPUUGTZVIZAUUHVIUAPHGUUJHTZUULUUNAUVAUUKUUGUUGUUJHDVJVKVL
      ZUUJYFTZUULUUQAUVCUUKUUPUUGUUJYFDVJVKVLZUUJYOTZUULUUSAUVEUUKYPUUGUUJYODVJ
      VKVLZUUJGTZUULUUHAUVGUUKYDUUGUUJGDVJVKVLUUOHVPSZAUUGVMVNZYFYMSZAUUQUUSAUV
      JUUQUUSVIAUVJUSZUUSUUQUVKYPUUPUUGUVKYPUUPYFBSZFUDYFVQUCCSZUSZFRVOZVRUCUUP
      VSVRUCZUUPUVKBCDEFYFIAUUDUVJJVCAUUEUVJKVCLAYLUVJYGMYFHUHVEZVTUVKUVOVSUUPV
      RUVKUVNWAZFRWJUVOVSTUVKUVRFRUVKUVNYFHWBWCZUVKHYFWDWCZUVSWAUVJUVTAHYFWEWFU
      VKHYFAHWGSUVJAHMWHVCUVKYFUVQWHWIWKUVKUVLUVSUVMUVKUVLYFXAHWLUCZSUVSUVKBUWA
      YFABUWAUTUVJNVCULYFXAHWMWNWOWPWQUVNFRWRWSWTUVKUUPRUTUVPUUPTUVKUUPRUVKRYJY
      FDARYJDXMUVJYKVCUVQUKUJUUPXBXCXDVKXEXFXGZXHXIUUFUUBAUUSYSUUBXNUUIUUMUUOUU
      RUUTUUTUAPHYOUVBUVDUVFUVFUVIUWBXHXIXJXKUUFBCDEFYFIAUUDYGUUBJVAAUUEYGUUBKV
      ALAYGUUBVBXLXOYSYOVPSUVHUUAUUBXPYSYFYSYFAYGXNXQXRAUVHYGAHMXQVCYOHXSUIXTYA
      YBYC $.
  $}

  ${
    $d k m n p x A $.  $d k m n p x B $.  $d k n x ph $.
    $( The product of two sequences is a sequence.  (Contributed by Mario
       Carneiro, 19-Sep-2016.) $)
    smucl $p |- ( ( A C_ NN0 /\ B C_ NN0 ) -> ( A smul B ) C_ NN0 ) $=
      ( vk vp vm vn cn0 wss wa csmu co cv c1 caddc cpw wcel cmin crab csad cc0
      cmpt2 wceq c0 cif cmpt cseq cfv simpl simpr eqid smufval ssrab2 syl6eqss
      ) AGHZBGHZIZABJKCLZUQMNKDEGOGDLELZAPFLZURQKBPIFGRSKUAFGUSTUBUCUSMQKUDUETU
      FZUGPZCGRGUPABUTCEFDUNUOUHUNUOUIUTUJUKVACGULUM $.

    ${
      smu01lem.1 $e |- ( ph -> A C_ NN0 ) $.
      smu01lem.2 $e |- ( ph -> B C_ NN0 ) $.
      smu01lem.3 $e |- ( ( ph /\ ( k e. NN0 /\ n e. NN0 ) ) ->
        -. ( k e. A /\ ( n - k ) e. B ) ) $.
      $( Lemma for ~ smu01 and ~ smu02 .  (Contributed by Mario Carneiro,
         19-Sep-2016.) $)
      smu01lem $p |- ( ph -> ( A smul B ) = (/) ) $=
        ( vp vm co cv wcel cn0 wss csad cc0 wceq c0 wi vx csmu wn smucl syl2anc
        sseld wa c1 caddc cpw cmin crab cmpt2 cif cmpt cseq cfv peano2nn0 fveq2
        noel eqeq1d imbi2d eqid smup0 oveq1 adantr simpr wral anassrs ralrimiva
        smupp1 rabeq0 sylibr oveq2d sadid1 eqtr2d eqeq12d syl5ibr expcom nn0ind
        0ss mp1i a2d syl impcom eleq2d mtbiri smuval mtbird syld pm2.01d eq0rdv
        ex ) ADBCUBKZADLZWNMZAWPWONMZWPUCZAWNNWOABNOZCNOZWNNOFGBCUDUEUFAWQWRAWQ
        UGZWPWOWOUHUIKZIJNUJNILJLZBMELZXCUKKCMUGENULPKUMENXDQRSXDUHUKKUNUOQUPZU
        QZMZXAXGWOSMWOUTXAXFSWOWQAXFSRZWQXBNMAXHTZWOURAUALZXEUQZSRZTAQXEUQZSRZT
        AWOXEUQZSRZTXIXIUADXBXJQRZXLXNAXQXKXMSXJQXEUSVAVBXJWORZXLXPAXRXKXOSXJWO
        XEUSVAVBXJXBRZXLXHAXSXKXFSXJXBXEUSVAVBZXTABCXEJEIFGXEVCZVDWQAXPXHAWQXPX
        HTXPXHXAXOWOBMXDWOUKKCMUGZENULZPKZSYCPKZRXOSYCPVEXAXFYDSYEXABCXEJEWOIAW
        SWQFVFZAWTWQGVFZYAAWQVGZVKXAYESSPKZSXAYCSSPXAYBUCZENVHYCSRXAYJENAWQXDNM
        YJHVIVJYBENVLVMVNSNOYISRXANWASVOWBVPVQVRVSWCVTWDWEWFWGXABCXEJEWOIYFYGYA
        YHWHWIWMWJWKWL $.
    $}

    $( Multiplication of a sequence by ` 0 ` on the right.  (Contributed by
       Mario Carneiro, 19-Sep-2016.) $)
    smu01 $p |- ( A C_ NN0 -> ( A smul (/) ) = (/) ) $=
      ( vk vn cn0 wss c0 id 0ss a1i cv wcel cmin co wa wn noel intnan smu01lem
      ) ADEZAFBCSGFDESDHIBJZAKZCJZTLMZFKZNOSTDKUBDKNNUDUAUCPQIR $.

    $( Multiplication of a sequence by ` 0 ` on the left.  (Contributed by
       Mario Carneiro, 9-Sep-2016.) $)
    smu02 $p |- ( A C_ NN0 -> ( (/) smul A ) = (/) ) $=
      ( vk vn cn0 wss c0 0ss a1i id cv wcel cmin co wa wn noel intnanr smu01lem
      ) ADEZFABCFDESDGHSIBJZFKZCJZTLMAKZNOSTDKUBDKNNUAUCTPQHR $.
  $}

  ${
    $d k m n p x A $.  $d k m n p x B $.  $d k m n p x N $.  $d k n x ph $.
    $d k x P $.
    smupval.a $e |- ( ph -> A C_ NN0 ) $.
    smupval.b $e |- ( ph -> B C_ NN0 ) $.
    smupval.p $e |- P = seq 0 ( ( p e. ~P NN0 , m e. NN0 |->
          ( p sadd { n e. NN0 | ( m e. A /\ ( n - m ) e. B ) } ) ) ,
      ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
    smupval.n $e |- ( ph -> N e. NN0 ) $.
    $( Rewrite the elements of the partial sum sequence in terms of sequence
       multiplication.  (Contributed by Mario Carneiro, 20-Sep-2016.) $)
    smupval $p |- ( ph -> ( P ` N ) = ( ( A i^i ( 0 ..^ N ) ) smul B ) ) $=
      ( cfv cn0 cc0 co wcel csad wceq fveq2 vx vk cpw cv cfzo cin cmin wa cmpt2
      crab c0 c1 cif cmpt cseq csmu cfz cuz nn0uz syl6eleq eluzfz2b sylib caddc
      wi eqeq12d imbi2d smup0 inss1 syl5ss eqid eqtr4d a1i oveq1 adantr elfzouz
      adantl syl6eleqr smupp1 wb elin rbaib anbi1d rabbidv oveq2d eqtrd syl5ibr
      wss expcom a2d fzind2 mpcom inss2 cz nn0zd uzid syl smupvallem ) AGDMZGHE
      NUCNHUDEUDZBOGUEPZUFZQFUDZWSUGPCQUHFNUJRPUIFNXBOSUKXBULUGPUMUNOUOZMZXACUP
      PGOGUQPQZAWRXDSZAGOURMZQZXEAGNXGLUSUTOGVAVBAUAUDZDMZXIXCMZSZVDAODMZOXCMZS
      ZVDZAUBUDZDMZXQXCMZSZVDAXQULVCPZDMZYAXCMZSZVDAXFVDUAUBGOGXIOSZXLXOAYEXJXM
      XKXNXIODTXIOXCTVEVFXIXQSZXLXTAYFXJXRXKXSXIXQDTXIXQXCTVEVFXIYASZXLYDAYGXJY
      BXKYCXIYADTXIYAXCTVEVFXIGSZXLXFAYHXJWRXKXDXIGDTXIGXCTVEVFXPXHAXMUKXNABCDE
      FHIJKVGAXACXCEFHAXABNBWTVHIVIZJXCVJZVGVKVLXQWTQZAXTYDAYKXTYDVDXTYDAYKUHZX
      RXQBQZXBXQUGPCQZUHZFNUJZRPZXSYPRPZSXRXSYPRVMYLYBYQYCYRYLBCDEFXQHABNWGYKIV
      NACNWGYKJVNZKYLXQXGNYKXQXGQAXQOGVOVPUSVQZVRYLYCXSXQXAQZYNUHZFNUJZRPYRYLXA
      CXCEFXQHAXANWGYKYIVNYSYJYTVRYLUUCYPXSRYLUUBYOFNYLUUAYMYNYKUUAYMVSAUUAYMYK
      XQBWTVTWAVPWBWCWDWEVEWFWHWIWJWKAXACXCEFGGHYIJYJLXAWTWGABWTWLVLAGWMQGGURMQ
      AGLWNGWOWPWQWE $.
  $}

  ${
    $d m n p A $.  $d m n p B $.  $d m n p N $.  $d n ph $.
    smup1.a $e |- ( ph -> A C_ NN0 ) $.
    smup1.b $e |- ( ph -> B C_ NN0 ) $.
    smup1.n $e |- ( ph -> N e. NN0 ) $.
    $( Rewrite ~ smupp1 using only ` smul ` instead of the internal recursive
       function ` P ` .  (Contributed by Mario Carneiro, 20-Sep-2016.) $)
    smup1 $p |- ( ph -> ( ( A i^i ( 0 ..^ ( N + 1 ) ) ) smul B ) =
      ( ( ( A i^i ( 0 ..^ N ) ) smul B ) sadd
        { n e. NN0 | ( N e. A /\ ( n - N ) e. B ) } ) ) $=
      ( vp vm c1 co cn0 cv wcel cmin wa crab csad cc0 caddc cpw cmpt2 wceq cmpt
      c0 cif cseq cfv cfzo cin csmu smupp1 peano2nn0 syl smupval oveq1d 3eqtr3d
      eqid ) AEKUALZIJMUBMINJNZBODNZVAPLCOQDMRSLUCDMVBTUDUFVBKPLUGUETUHZUIEVCUI
      ZEBOVBEPLCOQDMRZSLBTUTUJLUKCULLBTEUJLUKCULLZVESLABCVCJDEIFGVCUSZHUMABCVCJ
      DUTIFGVGAEMOUTMOHEUNUOUPAVDVFVESABCVCJDEIFGVGHUPUQUR $.
  $}

  ${
    $d k m n p A $.  $d k m n p B $.  $d i k m n p x N $.  $d i k n x ph $.
    $d i x P $.  $d i x Q $.
    smueq.a $e |- ( ph -> A C_ NN0 ) $.
    smueq.b $e |- ( ph -> B C_ NN0 ) $.
    smueq.n $e |- ( ph -> N e. NN0 ) $.
    ${
      smueq.p $e |- P = seq 0 ( ( p e. ~P NN0 , m e. NN0 |->
          ( p sadd { n e. NN0 | ( m e. A /\ ( n - m ) e. B ) } ) ) ,
        ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
      smueq.q $e |- Q = seq 0 ( ( p e. ~P NN0 , m e. NN0 |->
 ( p sadd { n e. NN0 | ( m e. A /\ ( n - m ) e. ( B i^i ( 0 ..^ N ) ) ) } ) ) ,
        ( n e. NN0 |-> if ( n = 0 , (/) , ( n - 1 ) ) ) ) $.
      $( Any element of a sequence multiplication only depends on the values of
         the argument sequences up to and including that point.  (Contributed
         by Mario Carneiro, 20-Sep-2016.) $)
      smueqlem $p |- ( ph -> ( ( A smul B ) i^i ( 0 ..^ N ) ) =
  ( ( ( A i^i ( 0 ..^ N ) ) smul ( B i^i ( 0 ..^ N ) ) ) i^i ( 0 ..^ N ) ) ) $=
        ( co cc0 cin wcel cn0 ineq1d vk vx vi csmu cfzo cv wa wb cfv wss adantr
        cuz elfzouz adantl nn0uz syl6eleqr c1 caddc cle nn0zd peano2zd elfzolt2
        cz wbr clt nn0ltp1le syl2anc mpbid eluz2 syl3anbrc smuval2 cfz syl6eleq
        eluzfz2b sylib wi fveq2 eqeq12d imbi2d c0 smup0 inss1 syl5ss eqtr4d a1i
        wceq cmin crab csad oveq1 smupp1 cpw smupf ffvelrn syl2an elpwid ssrab2
        wf sadeq eqtrd inss2 sseli sseld elfzo0 simp2bi simp1bi nn0red resubcld
        cn nnred nn0ge0d subge02d lelttrd jca 3anass bitri baib syl5ibrcom syld
        w3a pm4.71rd ancom bitr4i syl6rbb anbi2d sylan2 rabbidva inrab2 3eqtr4g
        elin oveq2d 3eqtrd syl5ibr expcom a2d fzind2 mpcom eleq2d rbaib 3bitr3d
        smupval 3bitrd ex pm5.32rd 3bitr4g eqrdv ) AUABCUDOZPHUEOZQZBUUHQCUUHQZ
        UDOZUUHQZAUAUFZUUGRZUUMUUHRZUGUUMUUKRZUUOUGUUMUUIRUUMUULRAUUOUUNUUPAUUO
        UUNUUPUHAUUOUGZUUNUUMHDUIZRZUUMHEUIZRZUUPUUQBCDFGHUUMIABSUJZUUOJUKZACSU
        JZUUOKUKMUUQUUMPULUIZSUUOUUMUVERAUUMPHUMUNUOUPZUUQUUMUQUROZVCRHVCRUVGHU
        SVDZHUVGULUIRUUQUUMUUQUUMUVFUTVAUUQHAHSRZUUOLUKZUTUUQUUMHVEVDZUVHUUOUVK
        AUUMPHVBUNUUQUUMSRUVIUVKUVHUHUVFUVJUUMHVFVGVHUVGHVIVJVKUUQUUMUURUUHQZRZ
        UUMUUTUUHQZRZUUSUVAUUQUVLUVNUUMAUVLUVNWFZUUOHPHVLORZAUVPAHUVERZUVQAHSUV
        ELUOVMPHVNVOAUBUFZDUIZUUHQZUVSEUIZUUHQZWFZVPAPDUIZUUHQZPEUIZUUHQZWFZVPZ
        AUCUFZDUIZUUHQZUWKEUIZUUHQZWFZVPAUWKUQUROZDUIZUUHQZUWQEUIZUUHQZWFZVPAUV
        PVPUBUCHPHUVSPWFZUWDUWIAUXCUWAUWFUWCUWHUXCUVTUWEUUHUVSPDVQTUXCUWBUWGUUH
        UVSPEVQTVRVSUVSUWKWFZUWDUWPAUXDUWAUWMUWCUWOUXDUVTUWLUUHUVSUWKDVQTUXDUWB
        UWNUUHUVSUWKEVQTVRVSUVSUWQWFZUWDUXBAUXEUWAUWSUWCUXAUXEUVTUWRUUHUVSUWQDV
        QTUXEUWBUWTUUHUVSUWQEVQTVRVSUVSHWFZUWDUVPAUXFUWAUVLUWCUVNUXFUVTUURUUHUV
        SHDVQTUXFUWBUUTUUHUVSHEVQTVRVSUWJUVRAUWEUWGUUHAUWEVTUWGABCDFGIJKMWAABUU
        JEFGIJAUUJCSCUUHWBKWCZNWAWDTWEUWKUUHRZAUWPUXBAUXHUWPUXBVPUWPUXBAUXHUGZU
        WMUWKBRZGUFZUWKWGOZCRZUGZGSWHZUUHQZWIOZUUHQZUWOUXPWIOZUUHQZWFUWPUXQUXSU
        UHUWMUWOUXPWIWJTUXIUWSUXRUXAUXTUXIUWSUWLUXOWIOZUUHQUXRUXIUWRUYAUUHUXIBC
        DFGUWKIAUVBUXHJUKZAUVDUXHKUKZMUXHUWKSRZAUXHUWKUVESUWKPHUMUOUPZUNZWKTUXI
        UWLUXOHUXIUWLSASSWLZDWRUYDUWLUYGRUXHABCDFGIJKMWMUYESUYGUWKDWNWOWPUXOSUJ
        UXIUXNGSWQWEAUVIUXHLUKZWSWTUXIUXAUWNUXJUXLUUJRZUGZGSWHZWIOZUUHQUWOUYKUU
        HQZWIOZUUHQUXTUXIUWTUYLUUHUXIBUUJEFGUWKIUYBAUUJSUJZUXHUXGUKNUYFWKTUXIUW
        NUYKHUXIUWNSASUYGEWRUYDUWNUYGRUXHABUUJEFGIJUXGNWMUYESUYGUWKEWNWOWPUYKSU
        JUXIUYJGSWQWEUYHWSUXIUYNUXSUUHUXIUYMUXPUWOWIUXIUYJGSUUHQZWHUXNGUYPWHUYM
        UXPUXIUYJUXNGUYPUXKUYPRUXIUXKUUHRZUYJUXNUHUYPUUHUXKSUUHXAXBUXIUYQUGZUYI
        UXMUXJUYRUXMUXLUUHRZUXMUGZUYIUYRUXMUYSUYRUXMUXLSRZUYSUYRCSUXLUXIUVDUYQU
        YCUKXCUYRUYSVUAHXIRZUXLHVEVDZUGZUYRVUBVUCUYQVUBUXIUYQUXKSRZVUBUXKHVEVDZ
        UXKHXDZXEUNZUYRUXLUXKHUYRUXKUWKUYRUXKUYQVUEUXIUYQVUEVUBVUFVUGXFUNXGZUYR
        UWKUXIUYDUYQUYFUKZXGZXHVUIUYRHVUHXJUYRPUWKUSVDUXLUXKUSVDUYRUWKVUJXKUYRU
        XKUWKVUIVUKXLVHUYQVUFUXIUXKPHVBUNXMXNUYSVUAVUDUYSVUAVUBVUCXTVUAVUDUGUXL
        HXDVUAVUBVUCXOXPXQXRXSYAUYTUXMUYSUGUYIUYSUXMYBUXLCUUHYJYCYDYEYFYGUYJGSU
        UHYHUXNGSUUHYHYIYKTYLVRYMYNYOYPYQUKYRUUOUVMUUSUHAUVMUUSUUOUUMUURUUHYJYS
        UNUUOUVOUVAUHAUVOUVAUUOUUMUUTUUHYJYSUNYTUUQUUTUUKUUMUUQBUUJEFGHIUVCAUYO
        UUOUXGUKNUVJUUAYRUUBUUCUUDUUMUUGUUHYJUUMUUKUUHYJUUEUUF $.
    $}

    $( Any element of a sequence multiplication only depends on the values of
       the argument sequences up to and including that point.  (Contributed by
       Mario Carneiro, 20-Sep-2016.) $)
    smueq $p |- ( ph -> ( ( A smul B ) i^i ( 0 ..^ N ) ) =
  ( ( ( A i^i ( 0 ..^ N ) ) smul ( B i^i ( 0 ..^ N ) ) ) i^i ( 0 ..^ N ) ) ) $=
      ( vp vm vn cn0 cv wcel cmin co wa crab csad cmpt2 cc0 cpw wceq c0 c1 cmpt
      cif cseq cfzo cin eqid smueqlem ) ABCHIKUAZKHLZILZBMZJLZUNNOZCMPJKQROSJKU
      PTUBUCUPUDNOUFUEZTUGZHIULKUMUOUQCTDUHOUIMPJKQROSURTUGZIJDHEFGUSUJUTUJUK
      $.
  $}

  ${
    $d k n x A $.  $d k n x B $.  $d x N $.  $d k n x ph $.
    smumullem.a $e |- ( ph -> A e. ZZ ) $.
    smumullem.b $e |- ( ph -> B e. ZZ ) $.
    smumullem.n $e |- ( ph -> N e. NN0 ) $.
    $( Lemma for ~ smumul .  (Contributed by Mario Carneiro, 22-Sep-2016.) $)
    smumullem $p |- ( ph ->
      ( ( ( bits ` A ) i^i ( 0 ..^ N ) ) smul ( bits ` B ) ) =
      ( bits ` ( ( A mod ( 2 ^ N ) ) x. B ) ) ) $=
      ( vn cn0 wcel cbits cfv cc0 co c2 cmul wceq c0 oveq2 oveq1d cfzo cin csmu
      vx vk cexp cmo cv wi c1 caddc syl6eq ineq2d in0 wss bitsss smu02 ax-mp cc
      fzo0 2cn exp0 oveq2d fveq2d eqeq12d imbi2d cz zmod10 syl zcnd eqtrd 0bits
      mul02d syl6req cmin crab csad oveq1 a1i simpr smup1 cif bitsinv1lem sylan
      wa adantr cn 2nn nnexpcld zmodcld nn0cnd nnnn0d 0nn0 ifcl sylancl adddird
      mulcomd 3eqtrd nn0zd zmulcld sadadd syl2anc eqeq1d ibar rabbidv sylan9req
      bitsshft wn mul01d wral intnanrd ralrimivw rabeq0 sylibr 3eqtr4a ifbothda
      3eqtr2d syl5ibr expcom a2d nn0ind mpcom ) DIJABKLZMDUANZUBZCKLZUCNZBODUFN
      ZUGNZCPNZKLZQZGAYCMUDUHZUANZUBZYFUCNZBOYMUFNZUGNZCPNZKLZQZUIARBUJUGNZCPNZ
      KLZQZUIAYCMUEUHZUANZUBZYFUCNZBOUUFUFNZUGNZCPNZKLZQZUIAYCMUUFUJUKNZUANZUBZ
      YFUCNZBOUUOUFNZUGNZCPNZKLZQZUIAYLUIUDUEDYMMQZUUAUUEAUVDYPRYTUUDUVDYPRYFUC
      NZRUVDYORYFUCUVDYOYCRUBRUVDYNRYCUVDYNMMUANRYMMMUASMUTULUMYCUNULTYFIUOZUVE
      RQCUPZYFUQURULUVDYSUUCKUVDYRUUBCPUVDYQUJBUGUVDYQOMUFNZUJYMMOUFSOUSJUVHUJQ
      VAOVBURULVCTVDVEVFYMUUFQZUUAUUNAUVIYPUUIYTUUMUVIYOUUHYFUCUVIYNUUGYCYMUUFM
      UASUMTUVIYSUULKUVIYRUUKCPUVIYQUUJBUGYMUUFOUFSVCTVDVEVFYMUUOQZUUAUVCAUVJYP
      UURYTUVBUVJYOUUQYFUCUVJYNUUPYCYMUUOMUASUMTUVJYSUVAKUVJYRUUTCPUVJYQUUSBUGY
      MUUOOUFSVCTVDVEVFYMDQZUUAYLAUVKYPYGYTYKUVKYOYEYFUCUVKYNYDYCYMDMUASUMTUVKY
      SYJKUVKYRYICPUVKYQYHBUGYMDOUFSVCTVDVEVFAUUDMKLZRAUUCMKAUUCMCPNMAUUBMCPABV
      GJZUUBMQEBVHVITACACFVJZVMVKVDVLVNUUFIJZAUUNUVCAUVOUUNUVCUIUUNUVCAUVOWEZUU
      IUUFYCJZHUHUUFVONYFJZWEZHIVPZVQNZUUMUVTVQNZQUUIUUMUVTVQVRUVPUURUWAUVBUWBU
      VPYCYFHUUFYCIUOUVPBUPVSUVFUVPUVGVSAUVOVTZWAUVPUVBUULCUVQUUJMWBZPNZUKNZKLZ
      UUMUWEKLZVQNZUWBUVPUVAUWFKUVPUVAUUKUWDUKNZCPNUULUWDCPNZUKNUWFUVPUUTUWJCPA
      UVMUVOUUTUWJQEUUFBWCWDTUVPUUKUWDCUVPUUKUVPBUUJAUVMUVOEWFUVPOUUFOWGJUVPWHV
      SUWCWIZWJZWKUVPUWDUVPUUJIJMIJUWDIJUVPUUJUWLWLWMUVQUUJMIWNWOZWKZACUSJZUVOU
      VNWFZWPUVPUWKUWEUULUKUVPUWDCUWOUWQWQVCWRVDUVPUULVGJUWEVGJUWIUWGQUVPUUKCUV
      PUUKUWMWSACVGJZUVOFWFZWTUVPCUWDUWSUVPUWDUWNWSWTUULUWEXAXBUVPUWHUVTUUMVQUV
      QCUUJPNZKLZUVTQCMPNZKLZUVTQUWHUVTQUVPUUJMUUJUWDQZUXAUWHUVTUXDUWTUWEKUUJUW
      DCPSVDXCMUWDQZUXCUWHUVTUXEUXBUWEKMUWDCPSVDXCUVPUVQUXAUVRHIVPZUVTAUWRUVOUX
      FUXAQFCHUUFXGWDUVQUVRUVSHIUVQUVRXDXEXFUVPUVQXHZWEZUVLRUXCUVTVLUXHUXBMKUXH
      CUVPUWPUXGUWQWFXIVDUXHUVSXHZHIXJUVTRQUXHUXIHIUXHUVQUVRUVPUXGVTXKXLUVSHIXM
      XNXOXPVCXQVEXRXSXTYAYB $.
  $}

  ${
    $d k A $.  $d k B $.
    $( For sequences that correspond to valid integers, the sequence
       multiplication function produces the sequence for the product.  This is
       effectively a proof of the correctness of the multiplication process,
       implemented in terms of logic gates for ~ df-sad , whose correctness is
       verified in ~ sadadd .

       Outside this range, the sequences cannot be representing integers, but
       the ` smul ` function still "works".  This extended function is best
       interpreted in terms of the ring structure of the 2-adic integers.
       (Contributed by Mario Carneiro, 22-Sep-2016.) $)
    smumul $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
      ( ( bits ` A ) smul ( bits ` B ) ) = ( bits ` ( A x. B ) ) ) $=
      ( cz wcel wa cbits cfv csmu co cn0 wss bitsss a1i cc0 c1 cin wceq syl2anc
      c2 cmo vk cmul cv wi smucl mp2an sseli caddc cfzo cexp simpll simplr 1nn0
      wb simpr nn0addcld smumullem ineq1d cn 2nn nnexpcld zmodcld nn0zd zmulcld
      bitsmod eqtr4d inass inidm ineq2i eqtri oveq1i ineq1i inss1 smueq 3eqtr4a
      syl5ss nnrpd crp zred modabs2 eqidd modmul12d fveq2d 3eqtr3d eqtrd eleq2d
      cr elin 3bitr3g cfz cuz nn0uz syl6eleq eluzfz2b sylib fzval3 syl biantrud
      eleqtrd 3bitr4d ex pm5.21ndd eqrdv ) ACDZBCDZEZUAAFGZBFGZHIZABUBIZFGZXFUA
      UCZJDZXLXIDZXLXKDZXNXMUDXFXIJXLXGJKZXHJKZXIJKALZBLZXGXHUEUFUGMXOXMUDXFXKJ
      XLXJLUGMXFXMXNXOUNXFXMEZXNXLNXLOUHIZUIIZDZEZXOYCEZXNXOXTXLXIYBPZDXLXKYBPZ
      DYDYEXTYFYGXLXTYFXJSYAUJIZTIZFGZYGXTXGYBPZXHHIZYBPZAYHTIZBUBIZYHTIZFGZYFY
      JXTYMYOFGZYBPZYQXTYLYRYBXTABYAXDXEXMUKZXDXEXMULZXTXLOXFXMUOZOJDXTUMMUPZUQ
      URXTYOCDYAJDZYQYSQXTYNBXTYNXTAYHYTXTSYASUSDXTUTMUUCVAZVBVCZUUAVDUUCYAYOVE
      RVFXTYKYBPZXHYBPZHIZYBPYKUUHHIZYBPYMYFUUIUUJYBUUGYKUUHHUUGXGYBYBPZPYKXGYB
      YBVGUUKYBXGYBVHVIVJVKVLXTYKXHYAXTYKXGJXGYBVMXPXTXRMZVPXQXTXSMZUUCVNXTXGXH
      YAUULUUMUUCVNVOXTYPYIFXTYNABBYHUUFYTUUAUUAXTYHUUEVQZXTAWGDYHVRDYNYHTIYNQX
      TAYTVSUUNAYHVTRXTBYHTIWAWBWCWDXTXJCDUUDYJYGQXTABYTUUAVDUUCYAXJVERWEWFXLXI
      YBWHXLXKYBWHWIXTYCXNXTXLNXLWJIZYBXTXLNWKGZDXLUUODXTXLJUUPUUBWLWMNXLWNWOXT
      XLCDUUOYBQXTXLUUBVCNXLWPWQWSZWRXTYCXOUUQWRWTXAXBXC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      The greatest common divisor operator
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c gcd $.

  $( Extend the definition of a class to include the greatest common divisor
     operator. $)
  cgcd $a class gcd $.

  ${
    $d n x y z $.
    $( Define the ` gcd ` operator.  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    df-gcd $a |- gcd = ( x e. ZZ , y e. ZZ |-> if ( ( x = 0 /\ y = 0 ) , 0 ,
             sup ( { n e. ZZ | ( n || x /\ n || y ) } , RR , < ) ) ) $.
  $}

  ${
    $d M n x y $.  $d N n x y $.
    $( The value of the ` gcd ` operator. ` ( M gcd N ) ` is the greatest
       common divisor of ` M ` and ` N ` .  If ` M ` and ` N ` are both ` 0 ` ,
       the result is defined conventionally as ` 0 ` .  (Contributed by Paul
       Chapman, 21-Mar-2011.)  (Revised by Mario Carneiro, 10-Nov-2013.) $)
    gcdval $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M gcd N ) =
              if ( ( M = 0 /\ N = 0 ) , 0 ,
                   sup ( { n e. ZZ | ( n || M /\ n || N ) } , RR , < ) ) ) $=
      ( vx vy cz cv cc0 wceq wa cdivides wbr crab cr clt cif eqeq1 anbi1d breq2
      csup cgcd rabbidv supeq1d ifbieq2d anbi2d df-gcd c0ex ltso supex ovmpt2
      ifex ) DEBCFFDGZHIZEGZHIZJZHAGZULKLZUQUNKLZJZAFMZNOTZPBHIZCHIZJZHUQBKLZUQ
      CKLZJZAFMZNOTZPUAVCUOJZHVFUSJZAFMZNOTZPULBIZUPVKVBVNHVOUMVCUOULBHQRVONVAV
      MOVOUTVLAFVOURVFUSULBUQKSRUBUCUDUNCIZVKVEVNVJHVPUOVDVCUNCHQUEVPNVMVIOVPVL
      VHAFVPUSVGVFUNCUQKSUEUBUCUDDEAUFVEHVJUGNVIOUHUIUKUJ $.
  $}

  $( The value, by convention, of the ` gcd ` operator when both operands are
     0.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
  gcd0val $p |- ( 0 gcd 0 ) = 0 $=
    ( vn cc0 cgcd co wceq wa cv cdivides wbr cz crab cr clt csup wcel 0z gcdval
    cif mp2an eqid iftrue eqtri ) BBCDZBBEZUDFZBAGBHIZUFFAJKLMNZRZBBJOZUIUCUHEP
    PABBQSUDUDUHBEBTZUJUEBUGUASUB $.

  ${
    $d M n $.  $d N n $.
    $( The value of the ` gcd ` operator when at least one operand is nonzero.
       (Contributed by Paul Chapman, 21-Mar-2011.) $)
    gcdn0val $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ -. ( M = 0 /\ N = 0 ) ) ->
        ( M gcd N ) = sup ( { n e. ZZ | ( n || M /\ n || N ) } , RR , < ) ) $=
      ( cz wcel wa cc0 wceq wn cgcd co cv cdivides wbr crab clt csup cif gcdval
      cr iffalse sylan9eq ) BDECDEFBGHCGHFZIBCJKUCGALZBMNUDCMNFADOTPQZRUEABCSUC
      GUEUAUB $.
  $}

  ${
    $d A n w x y z $.  $d S w x $.
    gcdcllem1.1 $e |- S = { z e. ZZ | A. n e. A z || n } $.
    $( Lemma for ~ gcdn0cl , ~ gcddvds and ~ dvdslegcd .  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    gcdcllem1 $p |- ( ( A C_ ZZ /\ E. n e. A n =/= 0 ) ->
                      ( S =/= (/) /\ E. x e. ZZ A. y e. S y <_ x ) ) $=
      ( vw cz cv cc0 wa cle wbr wral c1 wcel cdivides wceq wi wss wne wrex ssel
      c0 1z 1dvds syl6 ralrimiv breq1 ralbidv elrab2 biimpri sylancr syl adantr
      ne0i neeq1 cbvrexv cabs cfv simprbi adantl simplbi ssel2 dvdsleabs 3expia
      sylan2 anassrs com23 ralrimiva ancoms r19.26 pm3.35 ralimi sylbir syl2anc
      fveq2 breq2d imbi12d cbvralv ralbii ralcom r19.21v 3bitri sylib cn0 nn0zd
      nn0abscl wb breq2 rspcedv imim2d ralimdva mpd r19.23v imp sylan2b jca ) D
      IUAZFJZKUBZFDUCZLEUEUBZBJZAJZMNZBEOZAIUCZWTXDXCWTPEQZXDWTPIQZPXARNZFDOZXJ
      UFWTXLFDWTXADQZXAIQZXLDIXAUDXAUGUHUIXJXKXMLCJZXARNZFDOZXMCPIEXPPSXQXLFDXP
      PXARUJUKGULUMUNEPUQUOUPXCWTHJZKUBZHDUCZXIXBXTFHDXAXSKURZUSWTYAXIWTXTXITZH
      DOZYAXITWTXTXEXSUTVAZMNZBEOZTZHDOZYDWTXBXEXAUTVAZMNZTZFDOZBEOZYIWTYMBEWTX
      EEQZLXEXARNZFDOZYPYLTZFDOZYMYOYQWTYOXEIQZYQXRYQCXEIEXPXESXQYPFDXPXEXARUJU
      KGULZVBVCYOWTYTYSYOYTYQUUAVDYTWTYSYTWTLZYRFDUUBXNLXBYPYKYTWTXNXBYPYKTZTZW
      TXNLYTXOUUDDIXAVEYTXOXBUUCXEXAVFVGVHVIVJVKVLVHYQYSLYPYRLZFDOYMYPYRFDVMUUE
      YLFDYPYLVNVOVPVQVKYNXTYFTZHDOZBEOUUFBEOZHDOYIYMUUGBEYLUUFFHDXAXSSZXBXTYKY
      FYBUUIYJYEXEMXAXSUTVRVSVTWAWBUUFBHEDWCUUHYHHDXTYFBEWDWBWEWFWTYHYCHDWTXSDQ
      LZYGXIXTUUJXHYGAYEIUUJYEUUJXSIQYEWGQDIXSVEXSWIUOWHXFYESZXHYGWJUUJUUKXGYFB
      EXFYEXEMWKUKVCWLWMWNWOXTXIHDWPWFWQWRWS $.
  $}

  ${
    $d x z K $.  $d n x y z M $.  $d n x y z N $.  $d x y R $.  $d x y S $.
    gcdcllem2.1 $e |- S = { z e. ZZ | A. n e. { M , N } z || n } $.
    gcdcllem2.2 $e |- R = { z e. ZZ | ( z || M /\ z || N ) } $.
    $( Lemma for ~ gcdn0cl , ~ gcddvds and ~ dvdslegcd .  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    gcdcllem2 $p |- ( ( M e. ZZ /\ N e. ZZ ) -> R = S ) $=
      ( vx cz wcel wa cv cdivides wbr cpr wral breq1 elrab2 breq2 ralprg anbi2d
      weq ralbidv syl5bb anbi12d syl6rbbr eqrdv ) EJKFJKLZIBCUIIMZCKZUJJKZUJENO
      ZUJFNOZLZLZUJBKUKULUJDMZNOZDEFPZQZLUIUPAMZUQNOZDUSQUTAUJJCAIUCZVBURDUSVAU
      JUQNRUDGSUIUTUOULURUMUNDEFJJUQEUJNTUQFUJNTUAUBUEVAENOZVAFNOZLUOAUJJBVCVDU
      MVEUNVAUJENRVAUJFNRUFHSUGUH $.

    $( Lemma for ~ gcdn0cl , ~ gcddvds and ~ dvdslegcd .  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    gcdcllem3 $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ -. ( M = 0 /\ N = 0 ) ) ->
        ( sup ( R , RR , < ) e. NN /\
          ( sup ( R , RR , < ) || M /\ sup ( R , RR , < ) || N ) /\
          ( ( K e. ZZ /\ K || M /\ K || N ) -> K <_ sup ( R , RR , < ) ) ) ) $=
      ( vy vx cz wcel wa cc0 wceq cdivides wbr c1 breq1 wn cr clt cn w3a cle wi
      csup cv crab ssrab2 eqsstri c0 wne wral wrex cpr wss prssi adantr neorian
      prid1g neeq1 rspcev sylan adantlr prid2g adantll jaodan gcdcllem1 syl2anc
      wo sylan2br wb gcdcllem2 raleq rexbidv anbi12d syl mpbird suprzcl2 mp3an1
      sseldi a1i simprd anim12i 1z elrab2 mpbiran sylibr suprzub syl3anc elnnz1
      1dvds sylanbrc cbvrabv eqtri sylib biimpri 3impb 3expia mpan syl2im 3jca
      ) FLMZGLMZNZFOPGOPNUAZNZBUBUCUHZUDMZXJFQRZXJGQRZNZELMZEFQRZEGQRZUEZEXJUFR
      ZUGXIXJLMZSXJUFRZXKXIBLXJBAUIZFQRZYBGQRZNZALUJZLIYEALUKULZXIBUMUNZJUIKUIZ
      UFRZJBUOZKLUPZNZXJBMZXIYMCUMUNZYJJCUOZKLUPZNZXIFGUQZLURZDUIZOUNZDYSUPZYRX
      GYTXHFGLUSUTXHXGFOUNZGOUNZVLUUCFOGOVAXGUUDUUCUUEXEUUDUUCXFXEFYSMUUDUUCFGL
      VBUUBUUDDFYSUUAFOVCVDVEVFXFUUEUUCXEXFGYSMUUEUUCFGLVGUUBUUEDGYSUUAGOVCVDVE
      VHVIVMKJAYSCDHVJVKXGYMYRVNZXHXGBCPZUUFABCDFGHIVOUUGYHYOYLYQBCUMVCUUGYKYPK
      LYJJBCVPVQVRVSUTVTZBLURZYHYLYNYGKJBWAWBVSZWCXIUUIYLSBMZYAUUIXIYGWDXIYHYLU
      UHWEZXGUUKXHXGSFQRZSGQRZNZUUKXEUUMXFUUNFWNGWNWFUUKSLMUUOWGYEUUOASLBYBSPYC
      UUMYDUUNYBSFQTYBSGQTVRIWHWIWJUTKJBSWKWLXJWMWOXIXTXNXIYNXTXNNUUJYIFQRZYIGQ
      RZNZXNKXJLBYIXJPUUPXLUUQXMYIXJFQTYIXJGQTVRBYFUURKLUJIYEUURAKLYBYIPYCUUPYD
      UUQYBYIFQTYBYIGQTVRWPWQWHWRWEXIYLXREBMZXSUULXOXPXQUUSUUSXOXPXQNZNYEUUTAEL
      BYBEPYCXPYDXQYBEFQTYBEGQTVRIWHWSWTUUIYLUUSXSUGYGUUIYLUUSXSKJBEWKXAXBXCXD
      $.
  $}

  ${
    $d K n $.  $d M n z $.  $d N n z $.
    $( Closure of the ` gcd ` operator.  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    gcdn0cl $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ -. ( M = 0 /\ N = 0 ) ) ->
                    ( M gcd N ) e. NN ) $=
      ( vn cK vz cz wcel wa cc0 wceq wn cgcd co cv cdivides wbr crab cr cn eqid
      clt csup gcdn0val w3a cle wi cpr wral gcdcllem3 simp1d eqeltrd ) AFGBFGHA
      IJBIJHKHZABLMCNZAOPUMBOPHCFQZRUAUBZSCABUCULUOSGUOAOPUOBOPHDFGDAOPDBOPUDDU
      OUEPUFCUNUMENOPEABUGUHCFQZEDABUPTUNTUIUJUK $.

    $( The gcd of two integers divides each of them.  (Contributed by Paul
       Chapman, 21-Mar-2011.) $)
    gcddvds $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                    ( ( M gcd N ) || M /\ ( M gcd N ) || N ) ) $=
      ( vn cK vz cz wcel wa cc0 wceq cgcd co cdivides wbr breq1d anbi12d mpbird
      breq2 cv crab 0z dvds0 ax-mp bi2anan9 syl6bb mpbiri oveq12 gcd0val syl6eq
      anidm adantl wn cr clt csup cn w3a cle cpr wral gcdcllem3 simp2d gcdn0val
      wi eqid pm2.61dan ) AFGBFGHZAIJZBIJZHZABKLZAMNZVKBMNZHZVJVNVGVJVNIAMNZIBM
      NZHZVJVQIIMNZIFGVRUAIUBUCVJVQVRVRHVRVHVOVRVIVPVRAIIMRBIIMRUDVRUJUEUFVJVLV
      OVMVPVJVKIAMVJVKIIKLIAIBIKUGUHUIZOVJVKIBMVSOPQUKVGVJULHZVNCSZAMNWABMNHCFT
      ZUMUNUOZAMNZWCBMNZHZVTWCUPGWFDFGDAMNDBMNUQDWCURNVDCWBWAESMNEABUSUTCFTZEDA
      BWGVEWBVEVAVBVTVLWDVMWEVTVKWCAMCABVCZOVTVKWCBMWHOPQVF $.

    $( An integer which divides both operands of the ` gcd ` operator is
       bounded by it.  (Contributed by Paul Chapman, 21-Mar-2011.) $)
    dvdslegcd $p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\
                        -. ( M = 0 /\ N = 0 ) ) ->
                      ( ( K || M /\ K || N ) -> K <_ ( M gcd N ) ) ) $=
      ( vn vz cz wcel w3a cc0 wceq wa wn cdivides wbr cle wi cv crab eqid com12
      cgcd co cr clt csup cn cpr gcdcllem3 simp3d gcdn0val breq2d sylibrd 3expb
      wral exp4b com23 impcom 3impb imp ) AFGZBFGZCFGZHBIJCIJKLZABMNZACMNZKZABC
      UAUBZONZPZUTVAVBVCVIPZVAVBKZUTVJVKVCUTVIVKVCUTVFVHUTVFKVKVCKZVHUTVDVEVLVH
      PVLUTVDVEHZVHVLVMADQZBMNVNCMNKDFRZUCUDUEZONZVHVLVPUFGVPBMNVPCMNKVMVQPDVOV
      NEQMNEBCUGUNDFRZEABCVRSVOSUHUIVLVGVPAODBCUJUKULTUMTUOUPUQURUS $.
  $}

  $( Closure of the ` gcd ` operator.  (Contributed by Paul Chapman,
     21-Mar-2011.) $)
  gcdcl $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M gcd N ) e. NN0 ) $=
    ( cz wcel wa cc0 wceq cgcd co oveq12 gcd0val syl6eq 0nn0 syl6eqel adantl wn
    cn0 gcdn0cl nnnn0d pm2.61dan ) ACDBCDEZAFGBFGEZABHIZQDZUBUDUAUBUCFQUBUCFFHI
    FAFBFHJKLMNOUAUBPEUCABRST $.

  ${
    gcdcld.1 $e |- ( ph -> M e. ZZ ) $.
    gcdcld.2 $e |- ( ph -> N e. ZZ ) $.
    $( Closure of the ` gcd ` operator.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    gcdcld $p |- ( ph -> ( M gcd N ) e. NN0 ) $=
      ( cz wcel cgcd co cn0 gcdcl syl2anc ) ABFGCFGBCHIJGDEBCKL $.
  $}

  ${
    $d n x y $.
    $( Domain and codomain of the ` gcd ` operator.  (Contributed by Paul
       Chapman, 31-Mar-2011.)  (Revised by Mario Carneiro, 16-Nov-2013.) $)
    gcdf $p |- gcd : ( ZZ X. ZZ ) --> NN0 $=
      ( vx vy vn cv cc0 wceq wa cdivides wbr cz crab clt csup cif cn0 wcel wral
      cr cxp cgcd wf co gcdval gcdcl eqeltrrd rgen2a df-gcd fmpt2 mpbi ) ADZEFB
      DZEFGECDZUJHIULUKHIGCJKRLMNZOPZBJQAJQJJSOTUAUNABJUJJPUKJPGUJUKTUBUMOCUJUK
      UCUJUKUDUEUFABJJUMOTABCUGUHUI $.
  $}

  ${
    $d M n $.  $d N n $.
    $( The ` gcd ` operator is commutative.  (Contributed by Paul Chapman,
       21-Mar-2011.) $)
    gcdcom $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M gcd N ) = ( N gcd M ) ) $=
      ( vn cz wcel wa cc0 wceq cv cdivides wbr crab cr clt csup cif cgcd gcdval
      co ancom wb a1i rabbiia supeq1i ifbieq2i ancoms 3eqtr4a ) ADEZBDEZFAGHZBG
      HZFZGCIZAJKZUMBJKZFZCDLZMNOZPUKUJFZGUOUNFZCDLZMNOZPZABQSBAQSZULUSURVBGUJU
      KTMUQVANUPUTCDUPUTUAUMDEUNUOTUBUCUDUECABRUIUHVDVCHCBARUFUG $.
  $}

  $( The gcd of two integers is zero iff they are both zero.  (Contributed by
     Paul Chapman, 21-Mar-2011.) $)
  gcdeq0 $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                 ( ( M gcd N ) = 0 <-> ( M = 0 /\ N = 0 ) ) ) $=
    ( cz wcel wa cgcd co cc0 wceq wn wne gcdn0cl nnne0d necon4bd oveq12 gcd0val
    ex syl6eq impbid1 ) ACDBCDEZABFGZHIAHIBHIEZTUBUAHTUBJZUAHKTUCEUAABLMQNUBUAH
    HFGHAHBHFOPRS $.

  $( The gcd of two integers is positive (nonzero) iff they are not both zero.
     (Contributed by Paul Chapman, 22-Jun-2011.) $)
  gcdn0gt0 $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                   ( -. ( M = 0 /\ N = 0 ) <-> 0 < ( M gcd N ) ) ) $=
    ( cz wcel wa cc0 cgcd co clt wbr wne wceq wn cn0 wb gcdcl cle nn0re nn0ge0
    cr 0re leltne mp3an1 syl2anc syl gcdeq0 necon3abid bitr2d ) ACDBCDEZFABGHZI
    JZUJFKZAFLBFLEZMUIUJNDZUKULOZABPUNUJTDZFUJQJZUOUJRUJSFTDUPUQUOUAFUJUBUCUDUE
    UIUMUJFABUFUGUH $.

  $( The gcd of 0 and an integer is the integer's absolute value.  (Contributed
     by Paul Chapman, 21-Mar-2011.) $)
  gcd0id $p |- ( N e. ZZ -> ( 0 gcd N ) = ( abs ` N ) ) $=
    ( cz wcel cc0 cgcd co cabs cfv wceq wa cle cdivides 0z mpan adantr wi nn0zd
    wbr mpd wb gcd0val oveq2 fveq2 syl6eq 3eqtr4a adantl wne gcddvds simprd cn0
    abs0 gcdcl dvdsleabs syl3an1 3anidm12 nn0abscl dvds0 iddvds absdvdsb anidms
    syl mpbid jca wn biantrur necon3abii w3a dvdslegcd ex mp3an2 mpancom syl5bi
    eqid imp zred letri3d mpbir2and pm2.61dane ) ABCZDAEFZAGHZIZADADIZWBVSWCDDE
    FDVTWAUAADDEUBWCWADGHDADGUCUKUDUEUFVSADUGZJZWBVTWAKRZWAVTKRZWEVTALRZWFVSWHW
    DVSVTDLRZWHDBCZVSWIWHJMDAUHNUIOVSWDWHWFPZVSVTBCVSWDWKVSVTWJVSVTUJCMDAULNQZV
    TAUMUNUOSWEWADLRZWAALRZJZWGVSWOWDVSWMWNVSWABCZWMVSWAAUPQZWAUQVAVSAALRZWNAUR
    VSWRWNTAAUSUTVBVCOVSWDWOWGPZWDDDIZWCJZVDZVSWSXAADWTWCDVMVEVFWPVSXBWSPZWQWPW
    JVSXCMWPWJVSVGXBWSWADAVHVIVJVKVLVNSVSWBWFWGJTWDVSVTWAVSVTWLVOVSWAWQVOVPOVQV
    R $.

  $( The gcd of an integer and 0 is the integer's absolute value.  (Contributed
     by Paul Chapman, 31-Mar-2011.) $)
  gcdid0 $p |- ( N e. ZZ -> ( N gcd 0 ) = ( abs ` N ) ) $=
    ( cz wcel cc0 cgcd co cabs cfv wceq 0z gcdcom mpan gcd0id eqtr3d ) ABCZDAEF
    ZADEFZAGHDBCOPQIJDAKLAMN $.

  $( The gcd of a nonnegative integer with 0 is itself.  (Contributed by Paul
     Chapman, 31-Mar-2011.) $)
  nn0gcdid0 $p |- ( N e. NN0 -> ( N gcd 0 ) = N ) $=
    ( cn0 wcel cc0 cgcd co cabs cfv cz wceq nn0z gcdid0 syl nn0re nn0ge0 absidd
    eqtrd ) ABCZADEFZAGHZARAICSTJAKALMRAANAOPQ $.

  $( Negating one operand of the ` gcd ` operator does not alter the result.
     (Contributed by Paul Chapman, 21-Mar-2011.) $)
  gcdneg $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( M gcd -u N ) = ( M gcd N ) ) $=
    ( cz wcel wa cgcd co cc0 wceq oveq12 adantl anbi2d cle wbr cdivides gcddvds
    wb wn gcdcl wi cneg zcn negeq0d syl6bi eqtr4d nn0zd dvdsnegb sylancom mpbid
    imp notbid simpl znegcl w3a dvdslegcd ex syl3anc sylbid com12 impcom sylan2
    mpdi mpbird simpr zred letri3d adantr mpbir2and pm2.61dan eqcomd ) ACDZBCDZ
    EZABFGZABUAZFGZVMAHIZBHIZEZVNVPIZVMVSEVNHHFGZVPVSVNWAIVMAHBHFJKVMVSVPWAIZVM
    VSVQVOHIZEZWBVLVSWDQVKVLVRWCVQVLBBUBUCLKZAHVOHFJUDUJUEVMVSRZEVTVNVPMNZVPVNM
    NZWFVMWGWFVMVNAONZVNVOONZEZWGVMWIVNBONZEWKABPVMWLWJWIVKVLVNCDZWLWJQVMVNABSU
    FZVNBUGUHLUIVMWFWKWGTZVMWFWDRZWOVMVSWDWEUKVMWMVKVOCDZWPWOTWNVKVLULZVLWQVKBU
    MZKWMVKWQUNWPWOVNAVOUOUPUQURUSVBUTWFVMWHWFVMVPAONZVPBONZEZWHVMXBWTVPVOONZEZ
    VLVKWQXDWSAVOPVAVMXAXCWTVKVLVPCDZXAXCQVLVKWQXEWSVKWQEVPAVOSUFVAZVPBUGUHLVCV
    MWFXBWHTZVMXEVKVLWFXGTXFWRVKVLVDXEVKVLUNWFXGVPABUOUPUQUSVBUTVMVTWGWHEQWFVMV
    NVPVMVNWNVEVMVPXFVEVFVGVHVIVJ $.

  $( Negating one operand of the ` gcd ` operator does not alter the result.
     (Contributed by Paul Chapman, 22-Jun-2011.) $)
  neggcd $p |- ( ( M e. ZZ /\ N e. ZZ ) -> ( -u M gcd N ) = ( M gcd N ) ) $=
    ( cz wcel wa cneg cgcd co wceq gcdneg ancoms znegcl gcdcom sylan 3eqtr4d )
    ACDZBCDZEBAFZGHZBAGHZRBGHZABGHQPSTIBAJKPRCDQUASIALRBMNABMO $.

  ${
    gcdaddmlem.1 $e |- K e. ZZ $.
    gcdaddmlem.2 $e |- M e. ZZ $.
    gcdaddmlem.3 $e |- N e. ZZ $.
    $( Lemma for ~ gcdaddm .  (Contributed by Paul Chapman, 31-Mar-2011.) $)
    gcdaddmlem $p |- ( M gcd N ) = ( M gcd ( ( K x. M ) + N ) ) $=
      ( cc0 wceq cmul co caddc wa cgcd wbr cdivides cz wcel mp2an wi ax-mp cneg
      wn cle gcddvds simpli c1 cn0 gcdcl nn0zi w3a 1z dvds2ln mpanl12 mp3an zcn
      cc mulid2i oveq2i breqtri zmulcl zaddcl dvdslegcd mp2ani mulneg1i oveq12i
      znegcl mulcli negcli negidi addcomli oveq1i addassi addid2i 3eqtr3i eqtri
      ex anim12i zrei letri3i sylibr pm4.57 mul01i syl6eq oveq1d eqeq1d pm5.32i
      wo oveq2 oveq12 sylbir eqtr4d sylbi jaoi pm2.61i ) BGHZABIJZCKJZGHZLZUBZW
      OCGHZLZUBZLZBCMJZBWQMJZHZXDXEXFUCNZXFXEUCNZLXGWTXHXCXIWTXEBONZXEWQONZXHXJ
      XECONZBPQZCPQZXJXLLZEFBCUDRZUEXEWPUFCIJZKJZWQOXOXEXRONZXPXEPQZXMXNXOXSSZX
      EXMXNXEUGQEFBCUHRUIZEFAPQZUFPQZXTXMXNUJYADUKAUFXEBCULUMUNTXQCWPKCXNCUPQFC
      UOTZUQURUSXTXMWQPQZWTXJXKLXHSZSYBEWPPQZXNYFYCXMYHDEABUTRFWPCVARZXTXMYFUJW
      TYGXEBWQVBVPUNVCXCXFBONZXFCONZXIYJXFWQONZXMYFYJYLLZEYIBWQUDRZUEXFAUAZBIJZ
      UFWQIJZKJZCOYMXFYRONZYNXFPQZXMYFYMYSSZXFXMYFXFUGQEYIBWQUHRUIZEYIYOPQZYDYT
      XMYFUJUUAYCUUCDAVFTUKYOUFXFBWQULUMUNTYRWPUAZWQKJZCYPUUDYQWQKABYCAUPQDAUOT
      ZXMBUPQEBUOTZVDWQYFWQUPQYIWQUOTUQVEUUDWPKJZCKJGCKJZUUECUUHGCKWPUUDGABUUFU
      UGVGZWPUUJVHZWPUUJVIVJVKUUDWPCUUKUUJYEVLCYEVMZVNVOUSYTXMXNXCYJYKLXISZSUUB
      EFYTXMXNUJXCUUMXFBCVBVPUNVCVQXEXFXEYBVRXFUUBVRVSVTXDUBWSXBWGXGWSXBWAWSXGX
      BWSXBXGWOWRXAWOWQCGWOWQUUICWOWPGCKWOWPAGIJGBGAIWHAUUFWBWCWDUULWCWEWFZXBXE
      GGMJZXFBGCGMWIXBWSXFUUOHUUNBGWQGMWIWJWKZWLUUPWMWLWN $.
  $}

  $( Adding a multiple of one operand of the ` gcd ` operator to the other does
     not alter the result.  (Contributed by Paul Chapman, 31-Mar-2011.) $)
  gcdaddm $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                  ( M gcd N ) = ( M gcd ( N + ( K x. M ) ) ) ) $=
    ( cz wcel cgcd co cmul caddc cc0 cif oveq1 oveq1d oveq2d oveq2 0z elimel cc
    wceq zcn eqeq2d id oveq12d eqeq12d gcdaddmlem dedth3h wa mulcl syl2an 3impa
    w3a addcom eqtrd ) ADEZBDEZCDEZUKZBCFGZBABHGZCIGZFGZBCUSIGZFGUNUOUPURVASURB
    UNAJKZBHGZCIGZFGZSUOBJKZCFGZVGVCVGHGZCIGZFGZSVGUPCJKZFGZVGVIVLIGZFGZSABCJJJ
    AVCSZVAVFURVPUTVEBFVPUSVDCIAVCBHLMNUABVGSZURVHVFVKBVGCFLVQBVGVEVJFVQUBVQVDV
    ICIBVGVCHOMUCUDCVLSZVHVMVKVOCVLVGFOVRVJVNVGFCVLVIIONUDVCVGVLAJDPQBJDPQCJDPQ
    UEUFUQUTVBBFUNUOUPUTVBSZUNUOUGUSREZCREVSUPUNAREBREVTUOATBTABUHUICTUSCULUIUJ
    NUM $.

  $( The GCD of two numbers is the same as the GCD of the left and their sum.
     (Contributed by Scott Fenton, 20-Apr-2014.) $)
  gcdadd $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
  ( M gcd N ) = ( M gcd ( N + M ) ) ) $=
    ( cz wcel wa cgcd co c1 cmul caddc wceq 1z gcdaddm mp3an1 zcn mulid2 oveq2d
    cc syl adantr eqtrd ) ACDZBCDZEABFGZABHAIGZJGZFGZABAJGZFGZHCDUBUCUDUGKLHABM
    NUBUGUIKZUCUBARDZUJAOUKUFUHAFUKUEABJAPQQSTUA $.

  $( The gcd of a number and itself is its absolute value.  (Contributed by
     Paul Chapman, 31-Mar-2011.) $)
  gcdid $p |- ( N e. ZZ -> ( N gcd N ) = ( abs ` N ) ) $=
    ( cz wcel cc0 cgcd co c1 cmul caddc cabs cfv wceq 1z gcdaddm mp3an13 gcdid0
    0z cc zcn oveq2d mulid2 addid2 eqtrd syl 3eqtr3rd ) ABCZADEFZADGAHFZIFZEFZA
    JKAAEFGBCUFDBCUGUJLMQGADNOAPUFUIAAEUFARCZUIALASUKUIDAIFAUKUHADIAUATAUBUCUDT
    UE $.

  $( The gcd of a number with 1 is 1.  (Contributed by Mario Carneiro,
     19-Feb-2014.) $)
  gcd1 $p |- ( M e. ZZ -> ( M gcd 1 ) = 1 ) $=
    ( cz wcel c1 cgcd co cle wbr wceq cdivides wa 1z gcddvds mpan2 simprd cn wi
    cc0 wn wne ax-1ne0 simpr necon3ai ax-mp gcdn0cl nnzd 1nn dvdsle sylancl mpd
    wb nnle1eq1 syl mpbid ) ABCZADEFZDGHZUPDIZUOUPDJHZUQUOUPAJHZUSUODBCZUTUSKLA
    DMNOUOUPBCDPCUSUQQUOUPUOVAUPPCZLUOVAKARIZDRIZKZSZVBDRTVFUAVEDRVCVDUBUCUDADU
    ENNZUFUGUPDUHUIUJUOVBUQURUKVGUPULUMUN $.

  $( The gcd of two integers is the same as that of their absolute values.
     (Contributed by Paul Chapman, 31-Mar-2011.) $)
  gcdabs $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
                 ( ( abs ` M ) gcd ( abs ` N ) ) = ( M gcd N ) ) $=
    ( cz wcel wa cabs cfv wceq cneg wo co cr zre absor anim12i oveq12 sylan9eqr
    cgcd ex gcdneg syl2an wi a1i neggcd znegcl sylan eqtrd ccased mpd ) ACDZBCD
    ZEZAFGZAHZUMAIZHZJZBFGZBHZURBIZHZJZEZUMURRKZABRKZHZUJALDZBLDZVCUKAMBMVGUQVH
    VBANBNOUAULUNUSUPVAVFUNUSEVFUBULUMAURBRPUCULUPUSEZVFVIULVDUOBRKZVEUMUOURBRP
    ABUDZQSULUNVAEZVFVLULVDAUTRKVEUMAURUTRPABTQSULUPVAEZVFVMULVDUOUTRKZVEUMUOUR
    UTRPULVNVJVEUJUOCDUKVNVJHAUEUOBTUFVKUGQSUHUI $.

  $( ` gcd ` of the absolute value of the first operator.  (Contributed by
     Scott Fenton, 2-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  gcdabs1 $p |- ( ( N e. ZZ /\ M e. ZZ ) ->
    ( ( abs ` N ) gcd M ) = ( N gcd M ) ) $=
    ( cz wcel wa cabs cfv wceq cgcd co wi oveq1 a1i neggcd eqeq1d syl5ibrcom wo
    cneg zre absord adantr mpjaod ) BCDZACDZEZBFGZBHZUFAIJZBAIJZHZUFBRZHZUGUJKU
    EUFBAILMUEUJULUKAIJZUIHBANULUHUMUIUFUKAILOPUCUGULQUDUCBBSTUAUB $.

  $( ` gcd ` of the absolute value of the second operator.  (Contributed by
     Scott Fenton, 2-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  gcdabs2 $p |- ( ( N e. ZZ /\ M e. ZZ ) ->
    ( N gcd ( abs ` M ) ) = ( N gcd M ) ) $=
    ( cz wcel wa cabs cfv cgcd wceq gcdabs1 ancoms nn0abscl nn0zd gcdcom sylan2
    co 3eqtr4d ) BCDZACDZEAFGZBHPZABHPZBTHPZBAHPSRUAUBIBAJKSRTCDUCUAISTALMBTNOB
    ANQ $.

  $( The gcd remains unchanged if one operand is replaced with its remainder
     modulo the other.  (Contributed by Paul Chapman, 31-Mar-2011.) $)
  modgcd $p |- ( ( M e. ZZ /\ N e. NN ) ->
                 ( ( M mod N ) gcd N ) = ( M gcd N ) ) $=
    ( cz wcel wa co cgcd cneg cmul caddc cr wceq cc adantl eqtrd oveq2d syl3anc
    eqtr4d gcdcom syl2anc cn cmo cdiv cfl cfv cmin crp zre modval syl2an adantr
    nnrp zcn nncn cc0 wne nnre nnne0 redivcl syl3an 3anidm23 flcld zcnd mulneg1
    mulcom negeqd ancoms 3adant1 mulcl negsub sylan2 3impb znegcld simpl zmodcl
    w3a nnz gcdaddm nn0zd 3eqtr3d ) ACDZBUADZEZBABUBFZGFZBAGFZWDBGFZABGFZWCWEBA
    ABUCFZUDUEZHZBIFZJFZGFZWFWCWDWMBGWCWDABWJIFZUFFZWMWAAKDZBUGDWDWPLWBAUHZBULA
    BUIUJWCAMDZBMDZWJMDZWMWPLWAWSWBAUMUKWBWTWABUNNWCWJWCWIWAWBWIKDZWAWQWBBKDWBB
    UOUPXBWRBUQBURABUSUTVAVBZVCWSWTXAVPZWMAWOHZJFZWPXDWLXEAJWTXAWLXELZWSXAWTXGX
    AWTEZWLWJBIFZHXEWJBVDXHXIWOWJBVEVFOVGVHPWSWTXAXFWPLZWTXAEWSWOMDXJBWJVIAWOVJ
    VKVLOQRPWCWKCDBCDZWAWFWNLWCWJXCVMWBXKWABVQNZWAWBVNZWKBAVRQRWCXKWDCDWEWGLXLW
    CWDABVOVSBWDSTWCXKWAWFWHLXLXMBASTVT $.

  $( The GCD of one and an integer is one.  (Contributed by Scott Fenton,
     17-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  1gcd $p |- ( M e. ZZ -> ( 1 gcd M ) = 1 ) $=
    ( cz wcel c1 cgcd co wceq 1z gcdcom mpan gcd1 eqtrd ) ABCZDAEFZADEFZDDBCMNO
    GHDAIJAKL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                           B&eacute;zout's identity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d s t u v x y z A $.  $d s t u v x y z B $.
    ${
      $d s t u v x y z G $.  $d s t u v M $.  $d s t u v x y z ph $.
      $d s t u v x y z C $.
      bezout.1 $e |- M = { z e. NN | E. x e. ZZ E. y e. ZZ
                           z = ( ( A x. x ) + ( B x. y ) ) } $.
      bezout.3 $e |- ( ph -> A e. ZZ ) $.
      bezout.4 $e |- ( ph -> B e. ZZ ) $.
      $( Lemma for ~ bezout .  (Contributed by Mario Carneiro, 15-Mar-2014.) $)
      bezoutlem1 $p |- ( ph -> ( A =/= 0 -> ( abs ` A ) e. M ) ) $=
        ( cmul co caddc wceq cz wrex cc0 wcel c1 cc cabs cfv cv wne fveq2 oveq1
        cn eqeq12d rexbidv cr zre 1z ax-1rid eqcomd oveq2 eqeq2d rspcev sylancr
        cneg eqeq1 syl5ibrcom znegcl ax-mp recn mulm1d neg1cn mulcom eqtr3d syl
        absor mpjaod vtoclga zcnd adantr mul01d oveq2d zcn mulcl syl2an addid1d
        wa eqtrd 0z syl6bir reximdva mpd wi nnabscl 2rexbidv elrab2 simplbi2com
        mpan ex sylsyld ) AEUAUBZEBUCZKLZFCUCZKLZMLZNZCOPZBOPZEQUDZWOUGRZWOGRZA
        WOWQNZBOPZXCAEORZXHIDUCZUAUBZXJWPKLZNZBOPZXHDEOXJENZXMXGBOXOXKWOXLWQXJE
        UAUEXJEWPKUFUHUIXJORXJUJRZXNXJUKXPXKXJNZXNXKXJUSZNZXPXNXQXJXLNZBOPZXPSO
        RZXJXJSKLZNZYAULXPYCXJXJUMUNXTYDBSOWPSNXLYCXJWPSXJKUOUPUQURXQXMXTBOXKXJ
        XLUTUIVAXPXNXSXRXLNZBOPZXPSUSZORZXRXJYGKLZNZYFYBYHULSVBVCXPYGXJKLZXRYIX
        PXJXJVDZVEXPYGTRXJTRYKYINVFYLYGXJVGURVHYEYJBYGOWPYGNXLYIXRWPYGXJKUOUPUQ
        URXSXMYEBOXKXRXLUTUIVAXJVJVKVIVLVIAXGXBBOAWPORZWAZXGWOWQFQKLZMLZNZXBYNY
        PWQWOYNYPWQQMLWQYNYOQWQMYNFAFTRYMAFJVMVNVOVPYNWQAETRWPTRWQTRYMAEIVMWPVQ
        EWPVRVSVTWBUPQORYQXBWCXAYQCQOWRQNZWTYPWOYRWSYOWQMWRQFKUOVPUPUQWLWDWEWFA
        XIXDXEWGIXIXDXEEWHWMVIXFXEXCXJWTNZCOPBOPXCDWOUGGXJWONYSXABCOOXJWOWTUTWI
        HWJWKWN $.

      bezout.2 $e |- G = sup ( M , RR , `' < ) $.
      bezout.5 $e |- ( ph -> -. ( A = 0 /\ B = 0 ) ) $.
      $( Lemma for ~ bezout .  (Contributed by Mario Carneiro, 15-Mar-2014.) $)
      bezoutlem2 $p |- ( ph -> G e. M ) $=
        ( wcel cn co wceq cz wrex cc0 cr clt ccnv csup c1 cuz cfv wss c0 wne cv
        cmul caddc crab ssrab2 eqsstri nnuz sseqtri cabs bezoutlem1 ne0i rexcom
        syl6 eqid wa cc zcnd adantr zcn ad2antll mulcld ad2antrl addcomd eqeq2d
        2rexbidva syl5bb rabbidv syl5eq eleq2d sylibrd wn neorian sylibr mpjaod
        wo infmssuzcl sylancr syl5eqel ) AGHUAUBUCUDZHLAHUEUFUGZUHHUIUJZWIHNHOW
        JHDUKZEBUKZULPZFCUKZULPZUMPZQZCRSBRSZDOUNZOIWSDOUOUPUQURAETUJZWKFTUJZAX
        AEUSUGZHNWKABCDEFHIJKUTHXCVAVCAXBFUSUGZHNZWKAXBXDWLWPWNUMPZQZBRSCRSZDOU
        NZNXEACBDFEXIXIVDKJUTAHXIXDAHWTXIIAWSXHDOWSWRBRSCRSAXHWRBCRRVBAWRXGCBRR
        AWORNZWMRNZVEZVEZWQXFWLXMWNWPXMEWMAEVFNXLAEJVGVHXKWMVFNAXJWMVIVJVKXMFWO
        AFVFNXLAFKVGVHXJWOVFNAXKWOVIVLVKVMVNVOVPVQVRVSVTHXDVAVCAETQFTQVEWAXAXBW
        EMETFTWBWCWDHUEWFWGWH $.

      $d M x y $.
      $( Lemma for ~ bezout .  (Contributed by Mario Carneiro, 22-Feb-2014.) $)
      bezoutlem3 $p |- ( ph -> ( C e. M -> G || C ) ) $=
        ( wcel co wceq cmul caddc cz vs vt vu vv cdivides wbr wa cmo cc0 cn cle
        wn clt cr crp cv wrex simpr eqeq1 2rexbidv oveq2 oveq1d eqeq2d cbvrex2v
        oveq2d syl6bb elrab2 sylib simpld nnred bezoutlem2 syl5bb nnrpd syl2anc
        weq adantr modlt nnzd zmodcld nn0red ltnled wi cdiv cfl cfv cmin simprd
        mpbid ad2antrr simprll simprrl nndivred zmulcld zsubcld simprlr simprrr
        flcld zcnd mulcld addsub4d adddird mulassd oveq12d eqtrd subdid 3eqtr4d
        cc rspc2ev syl3anc oveq12 sylan2 eqeq1d syl5ibrcom exp3acom23 rexlimdvv
        oveq1 expr mpd ex modval eqcomd simplbi2com syl ccnv csup c1 cuz ssrab2
        wss crab eqsstri nnuz sseqtri infmssuzle mpan syl5eqbr syl6 mtod cn0 wo
        elnn0 ord wb dvdsval3 mpbird ) AGIOZHGUEUFZAUUFUGZUUGGHUHPZUIQZUUHUUIUJ
        OZULUUJUUHUUKHUUIUKUFZUUHUUIHUMUFZUULULUUHGUNOZHUOOZUUMUUHGUUHGUJOZGEUA
        UPZRPZFUBUPZRPZSPZQZUBTUQUATUQZUUHUUFUUPUVCUGAUUFURDUPZEBUPZRPZFCUPZRPZ
        SPZQZCTUQBTUQZUVCDGUJIUVDGQZUVKGUVIQZCTUQBTUQUVCUVLUVJUVMBCTTUVDGUVIUSU
        TUVMUVBGUURUVHSPZQBCUAUBTTBUAVOZUVIUVNGUVOUVFUURUVHSUVEUUQERVAVBVCCUBVO
        ZUVNUVAGUVPUVHUUTUURSUVGUUSFRVAVEVCVDVFJVGVHZVIZVJZAUUOUUFAHAHUJOZHEUCU
        PZRPZFUDUPZRPZSPZQZUDTUQUCTUQZAHIOUVTUWGUGABCDEFHIJKLMNVKUVKUWGDHUJIUVK
        UVDUWEQZUDTUQUCTUQUVDHQZUWGUVJUWHUVDUWBUVHSPZQBCUCUDTTBUCVOZUVIUWJUVDUW
        KUVFUWBUVHSUVEUWAERVAVBVCCUDVOZUWJUWEUVDUWLUVHUWDUWBSUVGUWCFRVAVEVCVDUW
        IUWHUWFUCUDTTUVDHUWEUSUTVLJVGVHZVIZVMVPZGHVQVNUUHUUIHUUHUUIUUHGHUUHGUVR
        VRZAUVTUUFUWNVPZVSZVTAHUNOUUFAHUWNVJVPWAWHUUHUUKUUIIOZUULUUHUUIUVIQZCTU
        QBTUQZUUKUWSWBUUHGHGHWCPZWDWEZRPZWFPZUVIQZCTUQBTUQZUXAUUHUVCUXGUUHUUPUV
        CUVQWGUUHUVBUXGUAUBTTUUHUUQTOZUUSTOZUGZUVBUXGWBZUUHUXJUGZUWGUXKAUWGUUFU
        XJAUVTUWGUWMWGWIUXLUWFUXKUCUDTTUUHUXJUWATOZUWCTOZUGZUWFUXKWBUUHUXJUXOUG
        ZUGZUVBUWFUXGUXQUXGUVBUWFUGZUVAUWEUXCRPZWFPZUVIQZCTUQBTUQZUXQUUQUWAUXCR
        PZWFPZTOUUSUWCUXCRPZWFPZTOUXTEUYDRPZFUYFRPZSPZQZUYBUXQUUQUYCUUHUXHUXIUX
        OWJZUXQUWAUXCUUHUXJUXMUXNWKZUUHUXCTOUXPUUHUXBUUHGHUVSUWQWLWQZVPZWMZWNUX
        QUUSUYEUUHUXHUXIUXOWOZUXQUWCUXCUUHUXJUXMUXNWPZUYNWMZWNUXQUVAEUYCRPZFUYE
        RPZSPZWFPUURUYSWFPZUUTUYTWFPZSPUXTUYIUXQUURUUTUYSUYTUXQEUUQAEXGOUUFUXPA
        EKWRWIZUXQUUQUYKWRZWSUXQFUUSAFXGOUUFUXPAFLWRWIZUXQUUSUYPWRZWSUXQEUYCVUD
        UXQUYCUYOWRZWSUXQFUYEVUFUXQUYEUYRWRZWSWTUXQUXSVUAUVAWFUXQUXSUWBUXCRPZUW
        DUXCRPZSPVUAUXQUWBUWDUXCUXQEUWAVUDUXQUWAUYLWRZWSUXQFUWCVUFUXQUWCUYQWRZW
        SUUHUXCXGOUXPUUHUXCUYMWRVPZXAUXQVUJUYSVUKUYTSUXQEUWAUXCVUDVULVUNXBUXQFU
        WCUXCVUFVUMVUNXBXCXDVEUXQUYGVUBUYHVUCSUXQEUUQUYCVUDVUEVUHXEUXQFUUSUYEVU
        FVUGVUIXEXCXFUYAUYJUXTUYGUVHSPZQBCUYDUYFTTUVEUYDQZUVIVUOUXTVUPUVFUYGUVH
        SUVEUYDERVAVBVCUVGUYFQZVUOUYIUXTVUQUVHUYHUYGSUVGUYFFRVAVEVCXHXIUXRUXFUY
        ABCTTUXRUXEUXTUVIUWFUVBUXDUXSQUXEUXTQHUWEUXCRXPGUVAUXDUXSWFXJXKXLUTXMXN
        XQXOXRXSXOXRUUHUXFUWTBCTTUUHUXEUUIUVIUUHUUIUXEUUHUUNUUOUUIUXEQUVSUWOGHX
        TVNYAXLUTWHUWSUUKUXAUVKUXADUUIUJIUVDUUIQUVJUWTBCTTUVDUUIUVIUSUTJVGYBYCU
        WSHIUNUMYDYEZUUIUKMIYFYGWEZYIUWSVURUUIUKUFIUJVUSIUVKDUJYJUJJUVKDUJYHYKY
        LYMUUIIYFYNYOYPYQYRUUHUUKUUJUUHUUIYSOUUKUUJYTUWRUUIUUAVHUUBXRUUHUVTGTOU
        UGUUJUUCUWQUWPHGUUDVNUUEXS $.

      $( Lemma for ~ bezout .  (Contributed by Mario Carneiro, 22-Feb-2014.) $)
      bezoutlem4 $p |- ( ph -> ( A gcd B ) e. M ) $=
        ( co wbr cdivides cmul cz wrex wcel vs vt vu vv cgcd wceq cv wa gcddvds
        cle syl2anc simpld wb gcdcld nn0zd divides mpbid simprd reeanv caddc wi
        cn bezoutlem2 oveq2 oveq1d eqeq2d oveq2d cbvrex2v eqeq1 2rexbidv syl5bb
        weq elrab2 sylib simprrl simprll zmulcld simprrr simprlr zaddcld adantr
        dvdsmul2 adddird mul32d oveq12d eqtrd breqtrd oveq1 oveqan12d syl5ibcom
        zcnd breq2d breq2 imbi2d syl5ibrcom expr com23 rexlimdvva mpd rexlimdvv
        syl5bir mp2and dvdsle cc0 cabs bezoutlem1 bezoutlem3 syld nnzd dvdsabsb
        wne cfv sylibrd imp dvds0 syl pm2.61ne crab eqid rexcom cc zcn ad2antll
        mulcld ad2antrl addcomd 2rexbidva rabbidv syl5eq eleq2d syl31anc nn0red
        wn dvdslegcd nnred letri3d mpbir2and eqeltrd ) AEFUENZGHAYSGUFYSGUJOZGY
        SUJOZAYSGPOZYTAUAUGZYSQNZEUFZUARSZUBUGZYSQNZFUFZUBRSZUUBAYSEPOZUUFAUUKY
        SFPOZAERTZFRTZUUKUULUHJKEFUIUKZULAYSRTZUUMUUKUUFUMAYSAEFJKUNZUOZJUAYSEU
        PUKUQAUULUUJAUUKUULUUOURAUUPUUNUULUUJUMUURKUBYSFUPUKUQUUFUUJUHUUEUUIUHZ
        UBRSUARSAUUBUUEUUIUAUBRRUSAUUSUUBUAUBRRAGEUCUGZQNZFUDUGZQNZUTNZUFZUDRSU
        CRSZUUCRTZUUGRTZUHZUUSUUBVAZVAZAGVBTZUVFAGHTUVLUVFUHABCDEFGHIJKLMVCZDUG
        ZEBUGZQNZFCUGZQNZUTNZUFZCRSBRSZUVFDGVBHUWAUVNUVDUFZUDRSUCRSUVNGUFZUVFUV
        TUWBUVNUVAUVRUTNZUFBCUCUDRRBUCVLZUVSUWDUVNUWEUVPUVAUVRUTUVOUUTEQVDVEVFC
        UDVLZUWDUVDUVNUWFUVRUVCUVAUTUVQUVBFQVDVGVFVHUWCUWBUVEUCUDRRUVNGUVDVIVJV
        KIVMVNZURAUVEUVKUCUDRRAUUTRTZUVBRTZUHZUHUVIUVEUVJAUWJUVIUVEUVJVAAUWJUVI
        UHZUHZUVJUVEUUSYSUVDPOZVAUWLYSUUDUUTQNZUUHUVBQNZUTNZPOUUSUWMUWLYSUUCUUT
        QNZUUGUVBQNZUTNZYSQNZUWPPUWLUWSRTUUPYSUWTPOUWLUWQUWRUWLUUCUUTAUWJUVGUVH
        VOZAUWHUWIUVIVPZVQZUWLUUGUVBAUWJUVGUVHVRZAUWHUWIUVIVSZVQZVTAUUPUWKUURWA
        ZUWSYSWBUKUWLUWTUWQYSQNZUWRYSQNZUTNUWPUWLUWQUWRYSUWLUWQUXCWKUWLUWRUXFWK
        UWLYSUXGWKZWCUWLUXHUWNUXIUWOUTUWLUUCUUTYSUWLUUCUXAWKUWLUUTUXBWKUXJWDUWL
        UUGUVBYSUWLUUGUXDWKUWLUVBUXEWKUXJWDWEWFWGUUSUWPUVDYSPUUEUUIUWNUVAUWOUVC
        UTUUDEUUTQWHUUHFUVBQWHWIWLWJUVEUUBUWMUUSGUVDYSPWMWNWOWPWQWRWSWTXAXBAUUP
        UVLUUBYTVAUURAUVLUVFUWGULZYSGXCUKWSAGEPOZGFPOZUUAAUXLGXDPOZEXDEXDGPWMAE
        XDXKZUXLAUXOGEXEXLZPOZUXLAUXOUXPHTUXQABCDEFHIJKXFABCDEFUXPGHIJKLMXGXHAG
        RTZUUMUXLUXQUMAGUXKXIZJGEXJUKXMXNAUXRUXNUXSGXOXPZXQAUXMUXNFXDFXDGPWMAFX
        DXKZUXMAUYAGFXEXLZPOZUXMAUYAUYBHTZUYCAUYAUYBUVNUVRUVPUTNZUFZBRSCRSZDVBX
        RZTUYDACBDFEUYHUYHXSKJXFAHUYHUYBAHUWADVBXRUYHIAUWAUYGDVBUWAUVTBRSCRSAUY
        GUVTBCRRXTAUVTUYFCBRRAUVQRTZUVORTZUHZUHZUVSUYEUVNUYLUVPUVRUYLEUVOAEYATU
        YKAEJWKWAUYJUVOYATAUYIUVOYBYCYDUYLFUVQAFYATUYKAFKWKWAUYIUVQYATAUYJUVQYB
        YEYDYFVFYGVKYHYIYJXMABCDEFUYBGHIJKLMXGXHAUXRUUNUXMUYCUMUXSKGFXJUKXMXNUX
        TXQAUXRUUMUUNEXDUFFXDUFUHYMUXLUXMUHUUAVAUXSJKMGEFYNYKXBAYSGAYSUUQYLAGUX
        KYOYPYQUVMYR $.
    $}

    $( B&eacute;zout's identity:  For any integers ` A ` and ` B ` , there are
       integers ` x , y ` such that ` ( A gcd B ) = A x. x + B x. y ` .
       (Contributed by Mario Carneiro, 22-Feb-2014.) $)
    bezout $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
           E. x e. ZZ E. y e. ZZ ( A gcd B ) = ( ( A x. x ) + ( B x. y ) ) ) $=
      ( vz vu vv vt cz wcel cc0 wceq co cv cmul caddc wrex cn oveq2 eqeq2d cgcd
      wa wn crab clt ccnv csup weq eqeq1 2rexbidv oveq1d oveq2d cbvrex2v syl6bb
      cr cbvrabv simpll simplr eqid simpr bezoutlem4 elrab simprbi syl 00id 0cn
      ex mul01i oveq12i gcd0val 3eqtr4ri rspc2ev mp3an oveq12 oveqan12d eqeq12d
      0z oveq1 mpbiri pm2.61d2 ) CIJZDIJZUBZCKLZDKLZUBZCDUAMZCANZOMZDBNZOMZPMZL
      ZBIQAIQZWCWFUCZWNWCWOUBZWGENZWLLZBIQAIQZERUDZJZWNWPFGHCDWTUOUEUFUGZWTWSHN
      ZCFNZOMZDGNZOMZPMZLZGIQFIQZEHREHUHZWSXCWLLZBIQAIQXJXKWRXLABIIWQXCWLUIUJXL
      XIXCXEWKPMZLABFGIIAFUHZWLXMXCXNWIXEWKPWHXDCOSUKTBGUHZXMXHXCXOWKXGXEPWJXFD
      OSULTUMUNUPWAWBWOUQWAWBWOURXBUSWCWOUTVAXAWGRJWNWSWNEWGRWQWGLWRWMABIIWQWGW
      LUIUJVBVCVDVGWFWNKKUAMZKWHOMZKWJOMZPMZLZBIQAIQZKIJZYBXPKKOMZYCPMZLZYAVQVQ
      KKPMKYDXPVEYCKYCKPKVFVHZYFVIVJVKXTYEXPYCXRPMZLABKKIIWHKLZXSYGXPYHXQYCXRPW
      HKKOSUKTWJKLZYGYDXPYIXRYCYCPWJKKOSULTVLVMWFWMXTABIIWFWGXPWLXSCKDKUAVNWDWE
      WIXQWKXRPCKWHOVRDKWJOVRVOVPUJVSVT $.
  $}

  ${
    $d K x y $.  $d M x y $.  $d N x y $.
    $( An integer which divides each of two others also divides their gcd.
       (Contributed by Paul Chapman, 22-Jun-2011.)  (Revised by Mario Carneiro,
       30-May-2014.) $)
    dvdsgcd $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                     ( ( K || M /\ K || N ) -> K || ( M gcd N ) ) ) $=
      ( vx vy cz wcel w3a cdivides wbr wa co cv cmul caddc wceq wrex wi cc zcn
      bezout 3adant1 dvds2ln 3impia simp3l simp12 mulcom syl2an syl2anc oveq12d
      cgcd 3coml simp3r simp13 breqtrd breq2 syl5ibrcom 3expia rexlimdvv mpid
      ex ) AFGZBFGZCFGZHZABIJACIJKZBCUKLZBDMZNLZCEMZNLZOLZPZEFQDFQZAVGIJZVCVDVN
      VBDEBCUAUBVEVFVNVORVEVFKVMVODEFFVEVFVHFGZVJFGZKZVMVORVEVFVRHZVOVMAVLIJVSA
      VHBNLZVJCNLZOLZVLIVRVEVFAWBIJZVRVEVFWCVHVJABCUCUDULVSVTVIWAVKOVSVPVCVTVIP
      ZVEVFVPVQUEVBVCVDVFVRUFVPVHSGBSGWDVCVHTBTVHBUGUHUIVSVQVDWAVKPZVEVFVPVQUMV
      BVCVDVFVRUNVQVJSGCSGWEVDVJTCTVJCUGUHUIUJUOVGVLAIUPUQURUSVAUT $.
  $}

  $( Biconditional form of ~ dvdsgcd .  (Contributed by Scott Fenton,
     2-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  dvdsgcdb $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
    ( ( K || M /\ K || N ) <-> K || ( M gcd N ) ) ) $=
    ( cz wcel w3a cdivides wbr wa co dvdsgcd gcddvds simpld 3adant1 simp1 gcdcl
    cgcd wi dvdstr mpan2d nn0zd simp2 syl3anc simprd syld3an2 jcad impbid ) ADE
    ZBDEZCDEZFZABGHZACGHZIABCQJZGHZABCKUKUOULUMUKUOUNBGHZULUIUJUPUHUIUJIZUPUNCG
    HZBCLZMNUKUHUNDEZUIUOUPIULRUHUIUJOUIUJUTUHUQUNBCPUANZUHUIUJUBAUNBSUCTUKUOUR
    UMUIUJURUHUQUPURUSUDNUHUTUIUJUOURIUMRVAAUNCSUETUFUG $.

  ${
    $d N x $.  $d M x $.  $d P x $.
    $( Associative law for ` gcd ` operator.  (Contributed by Scott Fenton,
       2-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    gcdass $p |- ( ( N e. ZZ /\ M e. ZZ /\ P e. ZZ ) ->
    ( ( N gcd M ) gcd P ) = ( N gcd ( M gcd P ) ) ) $=
      ( vx cz wcel cc0 wceq wa cdivides wbr crab cr clt csup cif cgcd co anass
      wb w3a a1i rabbiia supeq1i ifbieq2i cn0 gcdcl 3adant3 nn0zd simp3 syl2anc
      gcdval gcdeq0 anbi1d bicomd simpr simpl1 simpl2 dvdsgcdb syl3anc rabbidva
      cv supeq1d ifbieq2d eqtr4d simp1 3adant1 anbi2d simpl3 3eqtr4a ) CEFZBEFZ
      AEFZUAZCGHZBGHZIZAGHZIZGDVBZCJKZVTBJKZIZVTAJKZIZDELZMNOZPZVOVPVRIZIZGWAWB
      WDIZIZDELZMNOZPZCBQRZAQRZCBAQRZQRZVSWJWGWNGVOVPVRSMWFWMNWEWLDEWEWLTVTEFZW
      AWBWDSUBUCUDUEVNWQWPGHZVRIZGVTWPJKZWDIZDELZMNOZPZWHVNWPEFVMWQXGHVNWPVKVLW
      PUFFVMCBUGUHUIVKVLVMUJDWPAULUKVNVSXBWGXFGVNXBVSVNXAVQVRVKVLXAVQTVMCBUMUHU
      NUOVNMWFXENVNWEXDDEVNWTIZWCXCWDXHWTVKVLWCXCTVNWTUPZVKVLVMWTUQVKVLVMWTURZV
      TCBUSUTUNVAVCVDVEVNWSVOWRGHZIZGWAVTWRJKZIZDELZMNOZPZWOVNVKWREFWSXQHVKVLVM
      VFVNWRVLVMWRUFFVKBAUGVGUIDCWRULUKVNWJXLWNXPGVNXLWJVNXKWIVOVLVMXKWITVKBAUM
      VGVHUOVNMWMXONVNWLXNDEXHWKXMWAXHWTVLVMWKXMTXIXJVKVLVMWTVIVTBAUSUTVHVAVCVD
      VEVJ $.
  $}

  $( Distribute multiplication by a nonnegative integer over gcd.  (Contributed
     by Paul Chapman, 22-Jun-2011.)  (Proof shortened by Mario Carneiro,
     30-May-2014.) $)
  mulgcd $p |- ( ( K e. NN0 /\ M e. ZZ /\ N e. ZZ ) ->
                 ( ( K x. M ) gcd ( K x. N ) ) = ( K x. ( M gcd N ) ) ) $=
    ( cn0 wcel cz cmul co cgcd cc0 cdivides wbr 3adant1 syl2anc dvdsgcd syl3anc
    wa wi wb mp2and wceq cn wo elnn0 w3a simp1 nnzd simp2 zmulcld gcdcld nnnn0d
    simp3 gcdcl nn0mulcld cdiv nn0cnd nncnd nnne0d divcan2d gcddvds eqbrtrd wne
    simpld dvdsmul1 nn0zd dvdsval2 dvdscmulr syl112anc simprd dvdscmul eqbrtrrd
    mpbid mpd dvdseq syl22anc 3expib mul02d gcd0val syl6reqr oveq1d cc 3ad2ant2
    zcn eqtrd 3ad2ant3 oveq12d 3eqtr4d jaoi sylbi 3impib ) ADEZBFEZCFEZABGHZACG
    HZIHZABCIHZGHZUAZWKAUBEZAJUAZUCWLWMQWSRZAUDWTXBXAWTWLWMWSWTWLWMUEZWPDEWRDEW
    PWRKLWRWPKLZWSXCWNWOXCABXCAWTWLWMUFZUGZWTWLWMUHZUIZXCACXFWTWLWMULZUIZUJZXCA
    WQXCAXEUKWLWMWQDEZWTBCUMZMZUNZXCAWPAUOHZGHZWPWRKXCWPAXCWPXKUPXCAXEUQXCAXEUR
    ZUSZXCXPWQKLZXQWRKLZXCXPBKLZXPCKLZXTXCXQWNKLZYBXCXQWPWNKXSXCWPWNKLZWPWOKLZX
    CWNFEZWOFEZYEYFQXHXJWNWOUTNZVCVAXCXPFEZWLAFEZAJVBZYDYBSXCAWPKLZYJXCAWNKLZAW
    OKLZYMXCYKWLYNXFXGABVDNXCYKWMYOXFXIACVDNXCYKYGYHYNYOQYMRXFXHXJAWNWOOPTXCYKY
    LWPFEYMYJSXFXRXCWPXKVEAWPVFPVLZXGXFXRAXPBVGVHVLXCXQWOKLZYCXCXQWPWOKXSXCYEYF
    YIVIVAXCYJWMYKYLYQYCSYPXIXFXRAXPCVGVHVLXCYJWLWMYBYCQXTRYPXGXIXPBCOPTXCYJWQF
    EZYKXTYARYPXCWQXNVEZXFAXPWQVJPVMVKXCWRWNKLZWRWOKLZXDXCWQBKLZYTXCUUBWQCKLZWL
    WMUUBUUCQWTBCUTMZVCXCYRWLYKUUBYTRYSXGXFAWQBVJPVMXCUUCUUAXCUUBUUCUUDVIXCYRWM
    YKUUCUUARYSXIXFAWQCVJPVMXCWRFEYGYHYTUUAQXDRXCWRXOVEXHXJWRWNWOOPTWPWRVNVOVPX
    AWLWMWSXAWLWMUEZJJIHZJWQGHZWPWRUUEUUGJUUFUUEWQUUEWQWLWMXLXAXMMUPVQVRVSUUEWN
    JWOJIUUEWNJBGHJUUEAJBGXAWLWMUFZVTUUEBWLXABWAEWMBWCWBVQWDUUEWOJCGHJUUEAJCGUU
    HVTUUECWMXACWAEWLCWCWEVQWDWFUUEAJWQGUUHVTWGVPWHWIWJ $.

  $( Distribute absolute value of multiplication over gcd.  (Contributed by
     Paul Chapman, 22-Jun-2011.) $)
  absmulgcd $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
      ( ( K x. M ) gcd ( K x. N ) ) = ( abs ` ( K x. ( M gcd N ) ) ) ) $=
    ( cz wcel cabs cfv cgcd co cmul wceq wa cn0 oveq2d 3adant1 cc absmul syl2an
    zcn nn0abscl gcdcl nn0re nn0ge0 absidd nn0cnd 3impb oveqan12d 3impdi syl3an
    w3a syl zmulcl gcdabs nn0zd mulgcd 3eqtr3d eqtrd 3eqtr4rd ) ADEZBDEZCDEZUJZ
    AFGZBCHIZFGZJIZVCVDJIZAVDJIFGZABJIZACJIZHIZUTVAVFVGKUSUTVALZVEVDVCJVLVDMEZV
    EVDKBCUAZVMVDVDUBVDUCUDUKNOUSUTVAVHVFKZUSAPEZVDPEVOVLASZVLVDVNUEAVDQRUFVBVK
    VCBFGZCFGZHIZJIZVGVBVIFGZVJFGZHIZVCVRJIZVCVSJIZHIZVKWAUSVPUTBPEZVACPEZWDWGK
    ZVQBSCSVPWHWIWJVPWHLVPWILWBWEWCWFHABQACQUGUHUIUSUTVAWDVKKZUSUTLVIDEVJDEWKUS
    VALABULACULVIVJUMRUHUSVCMEUTVRDEVAVSDEWGWAKATUTVRBTUNVAVSCTUNVCVRVSUOUIUPVB
    VTVDVCJUTVAVTVDKUSBCUMONUQUR $.

  $( Reverse distribution law for the ` gcd ` operator.  (Contributed by Scott
     Fenton, 2-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  mulgcdr $p |- ( ( A e. ZZ /\ B e. ZZ /\ C e. NN0 ) ->
    ( ( A x. C ) gcd ( B x. C ) ) = ( ( A gcd B ) x. C ) ) $=
    ( cz wcel cn0 w3a cmul co cgcd wceq mulgcd 3coml cc 3ad2ant1 nn0cn 3ad2ant3
    zcn mulcomd 3ad2ant2 oveq12d gcdcl 3adant3 nn0cnd 3eqtr4d ) ADEZBDEZCFEZGZC
    AHIZCBHIZJIZCABJIZHIZACHIZBCHIZJIUMCHIUHUFUGULUNKCABLMUIUOUJUPUKJUIACUFUGAN
    EUHAROUHUFCNEUGCPQZSUIBCUGUFBNEUHBRTUQSUAUIUMCUIUMUFUGUMFEUHABUBUCUDUQSUE
    $.

  ${
    $d A a b $.  $d B a b $.  $d C a b $.
    $( Division law for GCD. (Contributed by Scott Fenton, 18-Apr-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    gcddiv $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ C e. NN )
       /\ ( C || A /\ C || B ) ) ->
       ( ( A gcd B ) / C ) = ( ( A / C ) gcd ( B / C ) ) ) $=
      ( va vb cz wcel w3a cdivides wbr wa cgcd cdiv wceq cmul 3ad2ant3 divcan4d
      co wrex cc cn cv wb simp1 divides syl2anc simp2 anbi12d reeanv syl6bbr wi
      nnz gcdcl nn0cnd 3adant3 nncn cc0 wne nnne0 cn0 nnnn0 mulgcdr syl3an3 zcn
      oveq1d 3ad2ant1 3ad2ant2 oveq12d 3eqtr4d oveq12 oveq1 oveqan12d syl5ibcom
      eqeq12d 3expa expcom rexlimdvv sylbid imp ) AFGZBFGZCUAGZHZCAIJZCBIJZKZAB
      LRZCMRZACMRZBCMRZLRZNZWCWFDUBZCORZANZEUBZCORZBNZKZEFSDFSZWLWCWFWODFSZWREF
      SZKWTWCWDXAWEXBWCCFGZVTWDXAUCWBVTXCWACULPZVTWAWBUDDCAUEUFWCXCWAWEXBUCXDVT
      WAWBUGECBUEUFUHWOWRDEFFUIUJWBVTWTWLUKWAWBWSWLDEFFWMFGZWPFGZKZWBWSWLUKZXEX
      FWBXHXEXFWBHZWNWQLRZCMRZWNCMRZWQCMRZLRZNWSWLXIWMWPLRZCORZCMRXOXKXNXIXOCXE
      XFXOTGWBXGXOWMWPUMUNUOWBXECTGXFCUPPZWBXECUQURXFCUSPZQXIXJXPCMWBXEXFCUTGXJ
      XPNCVAWMWPCVBVCVEXIXLWMXMWPLXIWMCXEXFWMTGWBWMVDVFXQXRQXIWPCXFXEWPTGWBWPVD
      VGXQXRQVHVIWSXKWHXNWKWSXJWGCMWNAWQBLVJVEWOWRXLWIXMWJLWNACMVKWQBCMVKVLVNVM
      VOVPVQPVRVS $.
  $}

  ${
    $d M k n $.  $d N k n $.
    $( The GCD of a multiple of a number is the number itself.  (Contributed by
       Scott Fenton, 12-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    gcdmultiple $p |- ( ( M e. NN /\ N e. NN ) -> ( M gcd ( M x. N ) ) = M ) $=
      ( vk vn cn wcel cmul co cgcd wi c1 caddc oveq2 oveq2d eqeq1d imbi2d eqtrd
      wceq cz cc cv weq nncn mulid1d cabs cfv nnz gcdid syl nnre nn0ge0d absidd
      nnnn0 wa adantr zmulcl syl2an gcdaddm mp3an1 syl2anc ax-1cn mp3an3 mulcom
      1z adddi mpan2 eqtr4d biimpd expcom a2d nnind impcom ) BEFAEFZAABGHZIHZAR
      ZVMAACUAZGHZIHZARZJVMAAKGHZIHZARZJVMAADUAZGHZIHZARZJVMAAWDKLHZGHZIHZARZJV
      MVPJCDBVQKRZVTWCVMWLVSWBAWLVRWAAIVQKAGMNOPCDUBZVTWGVMWMVSWFAWMVRWEAIVQWDA
      GMNOPVQWHRZVTWKVMWNVSWJAWNVRWIAIVQWHAGMNOPVQBRZVTVPVMWOVSVOAWOVRVNAIVQBAG
      MNOPVMWBAAIHZAVMWAAAIVMAAUCZUDNVMWPAUEUFZAVMASFZWPWRRAUGZAUHUIVMAAUJVMAAU
      MUKULQQWDEFZVMWGWKVMXAWGWKJVMXAUNZWGWKXBWFWJAXBWFAWEKAGHZLHZIHZWJXBWSWESF
      ZWFXERZVMWSXAWTUOVMWSWDSFXFXAWTWDUGAWDUPUQKSFWSXFXGVDKAWEURUSUTXBWIXDAIVM
      ATFZWDTFZWIXDRXAWQWDUCXHXIUNZWIWEWALHZXDXHXIKTFZWIXKRVAAWDKVEVBXJWAXCWELX
      HWAXCRZXIXHXLXMVAAKVCVFUONQUQNVGOVHVIVJVKVL $.
  $}

  ${
    $( Extend ~ gcdmultiple so ` N ` can be an integer.  (Contributed by Scott
       Fenton, 18-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    gcdmultiplez $p |- ( ( M e. NN /\ N e. ZZ ) ->
       ( M gcd ( M x. N ) ) = M ) $=
      ( cn wcel cz wa cmul co cgcd wceq cc0 oveq2 oveq2d eqeq1d cabs cfv adantr
      cc eqtrd syl wne nncn zcn absmul syl2an nnre nn0ge0d absidd oveq1d simpll
      nnnn0 nnz zmulcl sylan gcdabs2 syl2anc nnabscl gcdmultiple sylan2 anassrs
      nnzd 3eqtr3d mul01 cn0 nn0gcdid0 pm2.61ne ) ACDZBEDZFZAABGHZIHZAJAAKGHZIH
      ZAJBKBKJZVKVMAVNVJVLAIBKAGLMNVIBKUAZFZAVJOPZIHZAABOPZGHZIHZVKAVIVRWAJVOVI
      VQVTAIVIVQAOPZVSGHZVTVGARDZBRDVQWCJVHAUBZBUCABUDUEVGWCVTJVHVGWBAVSGVGAAUF
      VGAAUKZUGUHUIQSMQVPAEDZVJEDZVRVKJVPAVGVHVOUJVAVIWHVOVGWGVHWHAULABUMUNQVJA
      UOUPVGVHVOWAAJZVHVOFVGVSCDWIBUQAVSURUSUTVBVIVMAKIHZAVGVMWJJZVHVGWDWKWEWDV
      LKAIAVCMTQVGWJAJZVHVGAVDDWLWFAVETQSVF $.
  $}

  $( ` A ` is equal to its gcd with ` B ` if and only if ` A ` divides ` B ` .
     (Contributed by Mario Carneiro, 23-Feb-2014.) $)
  gcdeq $p |- ( ( A e. NN /\ B e. NN ) -> ( ( A gcd B ) = A <-> A || B ) ) $=
    ( cn wcel wa cgcd co wceq cdivides wbr cz nnz gcddvds syl2an cle adantr syl
    cc0 wi simpl simprd breq1 syl5ibcom iddvds wn adantl wne necon3ai dvdslegcd
    nnne0 syl31anc mpand simpld cn0 gcdcl nn0zd dvdsle syl2anc jctild nn0red cr
    mpd nnre letri3d sylibrd impbid ) ACDZBCDZEZABFGZAHZABIJZVIVJBIJZVKVLVIVJAI
    JZVMVGAKDZBKDZVNVMEVHALZBLZABMNZUAVJABIUBUCVIVLVJAOJZAVJOJZEVKVIVLWAVTVIAAI
    JZVLWAVIVOWBVGVOVHVQPZAUDQVIVOVOVPARHZBRHZEZUEZWBVLEWASWCWCVHVPVGVRUFVGWGVH
    VGARUGWGAUJWFARWDWETUHQPAABUIUKULVIVNVTVIVNVMVSUMVIVJKDVGVNVTSVIVJVGVOVPVJU
    NDVHVQVRABUONZUPVGVHTVJAUQURVBUSVIVJAVIVJWHUTVGAVADVHAVCPVDVEVF $.

  ${
    $d M k $.  $d N k $.
    $( Unidirectional form of ~ dvdssq .  (Contributed by Scott Fenton,
       19-Apr-2014.) $)
    dvdssqim $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
       ( M || N -> ( M ^ 2 ) || ( N ^ 2 ) ) ) $=
      ( vk cz wcel wa cdivides wbr cv cmul co wceq wrex c2 cexp divides syl2anr
      zsqcl cc zcn wi dvdsmul2 sqmul breqtrrd breq2d syl5ibcom rexlimdva adantr
      oveq1 sylbid ) ADEZBDEZFABGHCIZAJKZBLZCDMZANOKZBNOKZGHZCABPUKUPUSUAULUKUO
      USCDUKUMDEZFZUQUNNOKZGHUOUSVAUQUMNOKZUQJKZVBGUTVCDEUQDEUQVDGHUKUMRARVCUQU
      BQUTUMSEASEVBVDLUKUMTATUMAUCQUDUOVBURUQGUNBNOUIUEUFUGUHUJ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( A divisibility equivalent for ~ odmulg .  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    dvdsmulgcd $p |- ( ( B e. ZZ /\ C e. ZZ ) ->
        ( A || ( B x. C ) <-> A || ( B x. ( C gcd A ) ) ) ) $=
      ( vx vy cz wcel wa co cdivides wbr cv caddc simplr simpld syl2anc zmulcld
      cmul mpd zcnd cgcd wceq wrex dvdszrcl adantl bezout adantr simplll simprl
      simpllr simprr wi dvdsmultr1 syl3anc mulassd dvdsmul1 mul12d breqtrrd w3a
      dvds2add syl32anc adddid oveq2 breq2d syl5ibrcom rexlimdvva simprd zmulcl
      breqtrd imp simpr gcddvds gcdcld nn0zd simpll dvdscmul dvdstr impbida ) B
      FGZCFGZHZABCRIZJKZABCAUAIZRIZJKZWAWCHZWDCDLZRIZAELZRIZMIZUBZEFUCDFUCZWFWG
      VTAFGZWNVSVTWCNWGWOWBFGZWCWOWPHWAAWBUDUEOZDECAUFPWGWMWFDEFFWGWHFGZWJFGZHZ
      HZWFWMABWLRIZJKXAABWIRIZBWKRIZMIZXBJXAWOXCFGZXDFGZAXCJKZAXDJKZAXEJKZWGWOW
      TWQUGZXABWIVSVTWCWTUHZXACWHVSVTWCWTUJZWGWRWSUIZQZQXABWKXLXAAWJXKWGWRWSUKZ
      QZQXAAWBWHRIZXCJXAWCAXRJKZWAWCWTNXAWOWPWRWCXSULXKXABCXLXMQXNAWBWHUMUNSXAB
      CWHXABXLTZXACXMTXAWHXNTUOVIXAAABWJRIZRIZXDJXAWOYAFGAYBJKXKXABWJXLXPQAYAUP
      PXABAWJXTXAAXKTXAWJXPTUQURWOXFXGUSXHXIHXJAXCXDUTVJVAXABWIWKXTXAWIXOTXAWKX
      QTVBURWMWEXBAJWDWLBRVCVDVEVFSWAWFHZWOWEFGZWPWFWEWBJKZWCYCWOYDWFWOYDHWAAWE
      UDUEZOZYCWOYDYFVGWAWPWFBCVHUGWAWFVKYCWDCJKZYEYCYHWDAJKZYCVTWOYHYIHVSVTWFN
      ZYGCAVLPOYCWDFGVTVSYHYEULYCWDYCCAYJYGVMVNYJVSVTWFVOBWDCVPUNSWOYDWPUSWFYEH
      WCAWEWBVQVJVAVR $.
  $}

  $( If ` K ` and ` M ` are relatively prime, then the GCD of ` K ` and
     ` M x. N ` is the GCD of ` K ` and ` N ` .  (Contributed by Scott Fenton,
     12-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  rpmulgcd $p |- ( ( ( K e. NN /\ M e. NN /\ N e. NN ) /\
                ( K gcd M ) = 1 ) -> ( K gcd ( M x. N ) ) = ( K gcd N ) ) $=
    ( cn wcel w3a cgcd co c1 wceq wa cmul gcdmultiple 3adant2 nnz zmulcl syl2an
    cz adantr eqtrd oveq1d 3ad2ant1 3adant1 gcdass syl3anc eqtr3d nnnn0 mulgcdr
    cn0 syl3an oveq1 sylan9eq cc nncn 3ad2ant3 mulid2d oveq2d ) ADEZBDEZCDEZFZA
    BGHZIJZKZABCLHZGHZAACLHZVEGHZGHZACGHVAVFVIJVCVAAVGGHZVEGHZVFVIVAVJAVEGURUTV
    JAJUSACMNUAVAAREZVGREZVEREZVKVIJURUSVLUTAOZUBURUTVMUSURVLCREZVMUTVOCOZACPQN
    USUTVNURUSBREZVPVNUTBOZVQBCPQUCVEVGAUDUEUFSVDVHCAGVDVHICLHZCVAVCVHVBCLHZVTU
    RVLUSVRUTCUIEVHWAJVOVSCUGABCUHUJVBICLUKULVDCVACUMEZVCUTURWBUSCUNUOSUPTUQT
    $.

  ${
    $d A n k $.  $d B n k $.  $d N n k $.
    $( If ` A ` and ` B ` are relatively prime, then so are ` A ^ N ` and
       ` B ` .  (Contributed by Scott Fenton, 12-Apr-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    rplpwr $p |- ( ( A e. NN /\ B e. NN /\ N e. NN ) ->
       ( ( A gcd B ) = 1 -> ( ( A ^ N ) gcd B ) = 1 ) ) $=
      ( vk vn cn wcel cgcd co c1 wceq cexp wi oveq2 oveq1d eqeq1d imbi2d adantr
      wa cz cv caddc weq nncn exp1d biimpar w3a df-3an cmul simpl1 nncnd simpl3
      nnnn0d expp1d simp1 cn0 nnnn0 3ad2ant3 nnexpcld nnzd mulcomd eqtrd oveq2d
      zcnd simpl2 nnz 3ad2ant1 3ad2ant2 gcdcom syl2anc biimpa rpmulgcd syl31anc
      peano2nn 3eqtr4d biimprd sylanbr an32s expcom nnind exp3a com12 3impia
      a2d ) AFGZBFGZCFGZABHIZJKZACLIZBHIZJKZMZWGWEWFSZWMWGWNWIWLWNWISZADUAZLIZB
      HIZJKZMWOAJLIZBHIZJKZMWOAEUAZLIZBHIZJKZMWOAXCJUBIZLIZBHIZJKZMWOWLMDECWPJK
      ZWSXBWOXKWRXAJXKWQWTBHWPJALNOPQDEUCZWSXFWOXLWRXEJXLWQXDBHWPXCALNOPQWPXGKZ
      WSXJWOXMWRXIJXMWQXHBHWPXGALNOPQWPCKZWSWLWOXNWRWKJXNWQWJBHWPCALNOPQWNXBWIW
      NXAWHJWEXAWHKWFWEWTABHWEAAUDUEORPUFXCFGZWOXFXJWOXOXFXJMZWNXOWIXPWNXOSWEWF
      XOUGZWIXPWEWFXOUHXQWISZXJXFXRXIXEJXRBXHHIZBXDHIZXIXEXRXSBAXDUIIZHIZXTXRXH
      YABHXRXHXDAUIIYAXRAXCXRAWEWFXOWIUJZUKZXRXCWEWFXOWIULUMUNXRXDAXRXDXQXDTGZW
      IXQXDXQAXCWEWFXOUOXOWEXCUPGWFXCUQURUSZUTRZVDYDVAVBVCXRWFWEXDFGZBAHIZJKZYB
      XTKWEWFXOWIVEYCXQYHWIYFRXQWIYJXQWHYIJXQATGZBTGZWHYIKWEWFYKXOAVFVGWFWEYLXO
      BVFVHZABVIVJPVKBAXDVLVMVBXRXHTGYLXIXSKXRXHXRAXGYCXRXGXQXGFGZWIXOWEYNWFXCV
      NURRUMUSUTXQYLWIYMRZXHBVIVJXRYEYLXEXTKYGYOXDBVIVJVOPVPVQVRVSWDVTWAWBWC $.
  $}

  $( If ` A ` and ` B ` are relatively prime, then so are ` A ^ N ` and
     ` B ^ N ` .  (Contributed by Scott Fenton, 12-Apr-2014.)  (Revised by
     Mario Carneiro, 19-Apr-2014.) $)
  rppwr $p |- ( ( A e. NN /\ B e. NN /\ N e. NN ) ->
      ( ( A gcd B ) = 1 -> ( ( A ^ N ) gcd ( B ^ N ) ) = 1 ) ) $=
    ( cn wcel w3a cgcd co c1 wceq cexp 3jca nnzd gcdcom syl2anc nnz rplpwr sylc
    wa cz simpl1 simpl2 simpl3 nnnn0d nnexpcld 3ad2ant1 3ad2ant2 eqeq1d biimpa
    eqtrd ex ) ADEZBDEZCDEZFZABGHZIJZACKHBCKHZGHIJZUOUQSZULURDEZUNFAURGHZIJUSUT
    ULVAUNULUMUNUQUAZUTBCULUMUNUQUBZUTCULUMUNUQUCZUDUEZVELUTVBURAGHZIUTATEZURTE
    VBVGJUTAVCMUTURVFMAURNOUTUMULUNFBAGHZIJZVGIJUTUMULUNVDVCVELUOUQVJUOUPVIIUOV
    HBTEZUPVIJULUMVHUNAPUFUMULVKUNBPUGABNOUHUIBACQRUJAURCQRUK $.

  ${
    $( Square distributes over GCD. (Contributed by Scott Fenton,
       18-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    sqgcd $p |- ( ( M e. NN /\ N e. NN ) ->
           ( ( M gcd N ) ^ 2 ) = ( ( M ^ 2 ) gcd ( N ^ 2 ) ) ) $=
      ( cn wcel wa cgcd co c2 cexp c1 cc0 wceq adantr syl2anc cdiv cdivides wbr
      cz adantl cc cmul nnz anim12i nnne0 neneqd intnanrd gcdn0cl nnsqcld nncnd
      wn mulid1d nnsqcl nnzd gcddvds syl2an simpld dvdssqim mpd simprd syl32anc
      gcddiv nncn nnne0d sqdivd oveq12d syl31anc dividd eqtr3d clt wne dvdsval2
      wi wb syl3anc mpbid cr nnre nnred nngt0 nngt0d divgt0d elnnz sylanbrc 2nn
      rppwr mp3an3 3eqtr2d ax-1cn divmul mp3an2 syl12anc ) ACDZBCDZEZABFGZHIGZJ
      UAGZWPAHIGZBHIGZFGZWNWPWNWPWNWOWNARDZBRDZEAKLZBKLZEUJZWOCDZWLXAWMXBAUBZBU
      BZUCWLXEWMWLXCXDWLAKAUDUEUFMABUGNZUHZUIZUKWNWTWPOGZJLZWQWTLZWNXLWRWPOGZWS
      WPOGZFGZAWOOGZHIGZBWOOGZHIGZFGZJWNWRRDZWSRDZWPCDWPWRPQZWPWSPQZXLXQLWLYCWM
      WLWRAULZUMZMWMYDWLWMWSBULUMZSXJWNWOAPQZYEWNYJWOBPQZWLXAXBYJYKEZWMXGXHABUN
      UOZUPZWNWORDZXAYJYEVLWNWOXIUMZWLXAWMXGMZWOAUQNURWNYKYFWNYJYKYMUSZWNYOXBYK
      YFVLYPWMXBWLXHSZWOBUQNURWRWSWPVAUTWNXSXOYAXPFWNAWOWLATDWMAVBMWNWOXIUIZWNW
      OXIVCZVDWNBWOWMBTDWLBVBSYTUUAVDVEWNXRXTFGZJLZYBJLZWNWOWOOGZUUBJWNXAXBXFYL
      UUEUUBLYQYSXIYMABWOVAVFWNWOYTUUAVGVHWNXRCDZXTCDZUUCUUDVLZWNXRRDZKXRVIQUUF
      WNYJUUIYNWNYOWOKVJZXAYJUUIVMYPUUAYQWOAVKVNVOWNAWOWLAVPDWMAVQMWNWOXIVRZWLK
      AVIQWMAVSMWNWOXIVTZWAXRWBWCWNXTRDZKXTVIQUUGWNYKUUMYRWNYOUUJXBYKUUMVMYPUUA
      YSWOBVKVNVOWNBWOWMBVPDWLBVQSUUKWMKBVIQWLBVSSUULWAXTWBWCUUFUUGHCDUUHWDXRXT
      HWEWFNURWGWNWTTDZWPTDZWPKVJZXMXNVMZWNWTWNYCYDEWRKLZWSKLZEUJZWTCDWLYCWMYDY
      HYIUCWLUUTWMWLUURUUSWLWRKWLWRYGVCUEUFMWRWSUGNUIXKWNWPXJVCUUNJTDUUOUUPEUUQ
      WHWTJWPWIWJWKVOVH $.
  $}

  ${
    $d M k $.  $d N k $.
    $( Lemma for ~ dvdssq .  (Contributed by Scott Fenton, 18-Apr-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    dvdssqlem $p |- ( ( M e. NN /\ N e. NN ) ->
             ( M || N <-> ( M ^ 2 ) || ( N ^ 2 ) ) ) $=
      ( cn wcel wa cdivides wbr c2 cexp co cz syl2an cgcd wceq adantr wb nnsqcl
      nnz cr cc0 wi dvdssqim sqgcd gcdeq biimpar eqtrd cle gcdcl nn0red nn0ge0d
      cn0 nnre nnnn0 sq11 syl22anc mpbid gcddvds simprd eqbrtrrd ex impbid ) AC
      DZBCDZEZABFGZAHIJZBHIJZFGZVBAKDZBKDZVEVHUAVCARZBRZABUBLVDVHVEVDVHEZABMJZA
      BFVMVNHIJZVFNZVNANZVMVOVFVGMJZVFVDVOVRNVHABUCOVDVRVFNZVHVBVFCDVGCDVSVHPVC
      AQBQVFVGUDLUEUFVDVPVQPZVHVDVNSDTVNUGGASDZTAUGGZVTVDVNVBVIVJVNUKDVCVKVLABU
      HLZUIVDVNWCUJVBWAVCAULOVBWBVCVBAAUMUJOVNAUNUOOUPVMVNAFGZVNBFGZVDWDWEEZVHV
      BVIVJWFVCVKVLABUQLOURUSUTVA $.
  $}

  ${
    $( Two numbers are divisible iff their squares are.  (Contributed by Scott
       Fenton, 18-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    dvdssq $p |- ( ( M e. ZZ /\ N e. ZZ ) ->
             ( M || N <-> ( M ^ 2 ) || ( N ^ 2 ) ) ) $=
      ( cz wcel wa cdivides wbr c2 cexp co wb cc0 wceq cabs syl2an zsqcl adantr
      cfv syl bitr4d breq1 breq1d bibi12d wne cn nnabscl breq2 breq2d dvdssqlem
      sq0i sylan2 nnz simpl dvdsabsb nnsqcl cc zcn abssq adantl 3bitr4d anassrs
      nnzd dvds0 pm2.61ne sylan absdvdsb adantlr eqcomd bitrd an32s 0dvds sqeq0
      2thd ) ACDZBCDZEABFGZAHIJZBHIJZFGZKZLBFGZLVRFGZKZALALMZVPWAVSWBALBFUAWDVQ
      LVRFAUJUBUCVNALUDZVOVTVNWEEZVOEZANRZBFGZWHHIJZVRFGZVPVSWFWHUEDZVOWIWKKZAU
      FWLVOEWMWHLFGZWJLFGZKZBLBLMZWIWNWKWOBLWHFUGWQVRLWJFBUJUHUCWLVOBLUDZWMWLVO
      WREZEZWHBNRZFGZWJXAHIJZFGZWIWKWSWLXAUEDXBXDKBUFWHXAUIUKWLWHCDZVOWIXBKWSWH
      ULZVOWRUMWHBUNOWTWKWJVRNRZFGZXDWLWJCDZVRCDZWKXHKWSWLWJWHUOVBVOXJWRBPZQWJV
      RUNOWSXDXHKWLWSXCXGWJFWSBUPDZXCXGMVOXLWRBUQZQBURSUHUSTUTVAWLWPVOWLXEWPXFX
      EWNWOWHVCXEXIWOWHPWJVCSVMSQVDVEVNVOVPWIKWEABVFVGWGVSVQNRZVRFGZWKWFVQCDZXJ
      VSXOKVOVNXPWEAPQXKVQVRVFOWFXOWKKVOWFXNWJVRFVNXNWJMWEVNWJXNVNAUPDWJXNMAUQA
      URSVHQUBQVIUTVJVOWCVNVOWAVRLMZWBVOWAWQXQBVKVOXLXQWQKXMBVLSTVOXJWBXQKXKVRV
      KSTUSVD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                 Algorithms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F k m $.  $d N k m $.  $d k m ph $.
    nn0seqcvgd.1 $e |- ( ph -> F : NN0 --> NN0 ) $.
    nn0seqcvgd.2 $e |- ( ph -> N = ( F ` 0 ) ) $.
    nn0seqcvgd.3 $e |- ( ( ph /\ k e. NN0 ) ->
      ( ( F ` ( k + 1 ) ) =/= 0 -> ( F ` ( k + 1 ) ) < ( F ` k ) ) ) $.
    $( A strictly-decreasing nonnegative integer sequence with initial term
       ` N ` reaches zero by the ` N ` th term.  Deduction version.
       (Contributed by Paul Chapman, 31-Mar-2011.) $)
    nn0seqcvgd $p |- ( ph -> ( F ` N ) = 0 ) $=
      ( cfv cc0 wceq cle wbr cmin co cn0 wcel wi clt wa cr 0nn0 ffvelrn sylancl
      vm wf eqeltrd nn0red leidd cv c1 caddc fveq2 oveq2 breq12d eqbrtrrd recnd
      imbi2d subid1d breqtrrd a1i wb nn0re posdif adantr breq1 adantl peano2nn0
      syl2anr cz syl2an nn0zd nn0z zsubcl zltlem1 syl2anc ax-1cn subsub4 mp3an3
      cc nn0cn breq2d bitrd 3bitr2d biimpa an32s a1d wne ffvelrnda zred syl3anc
      ltletr sylibd syland expdimp pm2.61dane anasss expcom a2d 3adant1 fnn0ind
      pm2.43i subidd breqtrd ffvelrnd nn0ge0d 0re letri3 mpbir2and ) ADCHZIJZXI
      IKLZIXIKLZAXIDDMNZIKAXIXMKLZADOPZXODDKLAXNQZADICHZOFAOOCUEZIOPXQOPEUAOOIC
      UBUCUFZXSADADXSUGZUHZAUDUIZCHZDYBMNZKLZQAXQDIMNZKLZQZABUIZCHZDYIMNZKLZQZA
      YIUJUKNZCHZDYNMNZKLZQZXPUDBDDYBIJZYEYGAYSYCXQYDYFKYBICULYBIDMUMUNUQYBYIJZ
      YEYLAYTYCYJYDYKKYBYICULYBYIDMUMUNUQYBYNJZYEYQAUUAYCYOYDYPKYBYNCULYBYNDMUM
      UNUQYBDJZYEXNAUUBYCXIYDXMKYBDCULYBDDMUMUNUQYHXOAXQDYFKADXQDKFYAUOADADXTUP
      ZURUSUTYIOPZYIDRLZYMYRQXOUUDUUESZAYLYQAUUFYLYQQZAUUDUUEUUGAUUDSZUUESZUUGY
      OIUUIYOIJZSYQYLUUHUUJUUEYQUUHUUJSZUUEYQUUKUUEIYKRLZYOYKRLZYQUUHUUEUULVAZU
      UJUUDYITPDTPUUNAYIVBXTYIDVCVHVDUUJUUMUULVAUUHYOIYKRVEVFUUHUUMYQVAUUJUUHUU
      MYOYKUJMNZKLZYQUUHYOVIPYKVIPZUUMUUPVAUUHYOAXRYNOPYOOPUUDEYIVGOOYNCUBVJZVK
      ADVIPYIVIPUUQUUDADXSVKYIVLDYIVMVJZYOYKVNVOUUHUUOYPYOKADVSPZYIVSPZUUOYPJZU
      UDUUCYIVTUUTUVAUJVSPUVBVPDYIUJVQVRVJWAWBZVDWCWDWEWFUUIYOIWGZYLYQUUHUVDYLS
      YQQUUEUUHUVDYOYJRLZYLYQGUUHUVEYLSZUUMYQUUHYOTPYJTPYKTPUVFUUMQUUHYOUURUGUU
      HYJAOOYICEWHUGUUHYKUUSWIYOYJYKWKWJUVCWLWMVDWNWOWPWQWRWSWTWJXAADUUCXBXCAXI
      AOODCEXSXDZXEAXITPITPXJXKXLSVAAXIUVGUGXFXIIXGUCXH $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y M $.  $d x y ph $.  $d x y S $.
    $d x y V $.  $d x y Z $.
    algrf.1 $e |- Z = ( ZZ>= ` M ) $.
    algrf.2 $e |- R = seq M ( ( F o. 1st ) , ( Z X. { A } ) ) $.
    $( A sequence whose iteration function ignores the second argument is only
       affected by the first point of the initial value function.  (Contributed
       by Mario Carneiro, 11-Feb-2015.) $)
    seq1st $p |- ( ( M e. ZZ /\ A e. V ) ->
      R = seq M ( ( F o. 1st ) , { <. M , A >. } ) ) $=
      ( vx wcel cfv adantr wceq wi co fveq2 eqeq12d imbi2d eqtr4d fvex vy cz wa
      c1st ccom csn cxp cseq cop cuz seqfn cv c1 caddc seq1 syl6eleqr fvconst2g
      wfn id uzid syl2anr fvsng ex wb algrflem syl6eq adantl syl5ibr expcom a2d
      seqp1 uzind4 impcom adantll eqfnfvd syl5eq ) DUBJZAEJZUCZBCUDUEZFAUFUGZDU
      HZVTDAUIUFZDUHZHVSIDUJKZWBWDVQWBWEURVRVTWADUKLVQWDWEURVRVTWCDUKLVRIULZWEJ
      ZWFWBKZWFWDKZMZVQWGVRWJVRUAULZWBKZWKWDKZMZNVRDWBKZDWDKZMZNVRWJNZVRWFUMUNO
      ZWBKZWSWDKZMZNWRUAIDWFWKDMZWNWQVRXCWLWOWMWPWKDWBPWKDWDPQRWKWFMZWNWJVRXDWL
      WHWMWIWKWFWBPWKWFWDPQRZWKWSMZWNXBVRXFWLWTWMXAWKWSWBPWKWSWDPQRXEVQVRWQVSWO
      DWAKZWPVQWOXGMVRVTWADUOLVSWPDWCKZXGVQWPXHMVRVTWCDUOLVSXGAXHVRVRDFJXGAMVQV
      RUSVQDWEFDUTGUPFADEUQVADAUBEVBSSSVCWGVRWJXBVRWGWJXBNWJXBVRWGUCWHCKZWICKZM
      ZWHWICPWGXBXKVDVRWGWTXIXAXJWGWTWHWSWAKZVTOXIVTWADWFVKWHXLCWFWBTWSWATVEVFW
      GXAWIWSWCKZVTOXJVTWCDWFVKWIXMCWFWDTWSWCTVEVFQVGVHVIVJVLVMVNVOVP $.

    algrf.3 $e |- ( ph -> M e. ZZ ) $.
    algrf.4 $e |- ( ph -> A e. S ) $.
    $( The value of the algorithm iterator ` R ` at ` 0 ` is the initial state
       ` A ` .  (Contributed by Paul Chapman, 31-Mar-2011.)  (Revised by Mario
       Carneiro, 28-May-2014.) $)
    algr0 $p |- ( ph -> ( R ` M ) = A ) $=
      ( cfv c1st ccom csn cxp cseq wcel wceq syl fveq1i seq1 cuz uzid syl6eleqr
      cz fvconst2g syl2anc eqtrd syl5eq ) AFCLFEMNZGBOPZFQZLZBFCUMIUAAUNFULLZBA
      FUFRZUNUOSJUKULFUBTABDRFGRUOBSKAFFUCLZGAUPFUQRJFUDTHUEGBFDUGUHUIUJ $.

    algrf.5 $e |- ( ph -> F : S --> S ) $.
    $( An algorithm is step a function ` F : S --> S ` on a state space
       ` S ` .  An algorithm acts on an initial state ` A e. S ` by iteratively
       applying ` F ` to give ` A ` , ` ( F `` A ) ` , ` ( F `` ( F `` A ) ) `
       and so on.  An algorithm is said to halt if a fixed point of ` F ` is
       reached after a finite number of iterations.

       The algorithm iterator ` R : NN0 --> S ` "runs" the algorithm ` F ` so
       that ` ( R `` k ) ` is the state after ` k ` iterations of ` F ` on the
       initial state ` A ` .

       Domain and codomain of the algorithm iterator ` R ` .  (Contributed by
       Paul Chapman, 31-Mar-2011.)  (Revised by Mario Carneiro,
       28-May-2014.) $)
    algrf $p |- ( ph -> R : Z --> S ) $=
      ( vx vy wf cv wcel wa cfv vex c1st ccom csn cxp cseq wceq fvconst2g sylan
      adantr eqeltrd algrflem simpl ffvelrn syl2an syl5eqel seqf feq1i sylibr
      co ) AGDEUAUBZGBUCUDZFUEZOGDCOAMNUTDVAFGHJAMPZGQZRVCVASZBDABDQZVDVEBUFKGB
      VCDUGUHAVFVDKUIUJAVCDQZNPZDQZRZRVCVHUTUSVCESZDVCVHEMTNTUKADDEOVGVKDQVJLVG
      VIULDDVCEUMUNUOUPGDCVBIUQUR $.

    $( The value of the algorithm iterator ` R ` at ` ( K + 1 ) ` .
       (Contributed by Paul Chapman, 31-Mar-2011.)  (Revised by Mario Carneiro,
       27-Dec-2014.) $)
    algrp1 $p |- ( ( ph /\ K e. Z ) ->
                   ( R ` ( K + 1 ) ) = ( F ` ( R ` K ) ) ) $=
      ( wcel wa c1 co cfv fveq1i fvex caddc c1st ccom csn cxp cseq cuz syl6eleq
      wceq simpr seqp1 syl fveq2i algrflem eqtr4i 3eqtr4g ) AFHNZOZFPUAQZEUBUCZ
      HBUDUEZGUFZRZFVBRZUSVARZUTQZUSCRFCRZERZURFGUGRZNVCVFUIURFHVIAUQUJIUHUTVAG
      FUKULUSCVBJSVHVDERVFVGVDEFCVBJSUMVDVEEFVBTUSVATUNUOUP $.
  $}

  ${
    $d k z A $.  $d x F $.  $d k x z I $.  $d k x z R $.  $d k x z S $.
    $d z K $.
    alginv.1 $e |- R = seq 0 ( ( F o. 1st ) , ( NN0 X. { A } ) ) $.
    alginv.2 $e |- F : S --> S $.
    alginv.3 $e |- I Fn S $.
    alginv.4 $e |- ( x e. S -> ( I ` ( F ` x ) ) = ( I ` x ) ) $.
    $( If ` I ` is an invariant of ` F ` , its value is unchanged after any
       number of iterations of ` F ` .  (Contributed by Paul Chapman,
       31-Mar-2011.) $)
    alginv $p |- ( ( A e. S /\ K e. NN0 ) ->
                   ( I ` ( R ` K ) ) = ( I ` ( R ` 0 ) ) ) $=
      ( cn0 wcel cfv cc0 wceq wi fveq2 fveq2d eqeq1d vz vk cv c1 caddc co eqidd
      imbi2d wa nn0uz cz 0z a1i id algrp1 algrf ffvelrnda eqeq12d vtoclga eqtrd
      wf syl biimprd expcom a2d nn0ind impcom ) GLMBDMZGCNZFNZOCNZFNZPZVHUAUCZC
      NZFNZVLPZQVHVLVLPZQVHUBUCZCNZFNZVLPZQVHVSUDUEUFZCNZFNZVLPZQVHVMQUAUBGVNOP
      ZVQVRVHWGVPVLVLWGVOVKFVNOCRSTUHVNVSPZVQWBVHWHVPWAVLWHVOVTFVNVSCRSTUHVNWCP
      ZVQWFVHWIVPWEVLWIVOWDFVNWCCRSTUHVNGPZVQVMVHWJVPVJVLWJVOVIFVNGCRSTUHVHVLUG
      VSLMZVHWBWFVHWKWBWFQVHWKUIZWFWBWLWEWAVLWLWEVTENZFNZWAWLWDWMFVHBCDEVSOLUJH
      OUKMVHULUMZVHUNZDDEVAVHIUMZUOSWLVTDMWNWAPZVHLDVSCVHBCDEOLUJHWOWPWQUPUQAUC
      ZENZFNZWSFNZPWRAVTDWSVTPZXAWNXBWAXCWTWMFWSVTERSWSVTFRURKUSVBUTTVCVDVEVFVG
      $.
  $}

  ${
    $d A k $.  $d C k z $.  $d F z $.  $d N k $.  $d R k z $.  $d S k z $.
    algcvg.1 $e |- F : S --> S $.
    algcvg.2 $e |- R = seq 0 ( ( F o. 1st ) , ( NN0 X. { A } ) ) $.
    algcvg.3 $e |- C : S --> NN0 $.
    algcvg.4 $e |- ( z e. S -> ( ( C ` ( F ` z ) ) =/= 0 ->
                                 ( C ` ( F ` z ) ) < ( C ` z ) ) ) $.
    algcvg.5 $e |- N = ( C ` A ) $.
    $( One way to prove that an algorithm halts is to construct a countdown
       function ` C : S --> NN0 ` whose value is guaranteed to decrease for
       each iteration of ` F ` until it reaches ` 0 ` .  That is, if ` X e. S `
       is not a fixed point of ` F ` , then
       ` ( C `` ( F `` X ) ) < ( C `` X ) ` .

       If ` C ` is a countdown function for algorithm ` F ` , the sequence
       ` ( C `` ( R `` k ) ) ` reaches ` 0 ` after at most ` N ` steps, where
       ` N ` is the value of ` C ` for the initial state ` A ` .  (Contributed
       by Paul Chapman, 22-Jun-2011.) $)
    algcvg $p |- ( A e. S -> ( C ` ( R ` N ) ) = 0 ) $=
      ( wcel cfv cc0 cn0 wf wceq fvco3 clt vk nn0uz cz 0z a1i id algrf ffvelrni
      ccom syl5eqel syl2anc sylancr 0nn0 sylancl algr0 fveq2d eqtrd syl6reqr cv
      fco wa wne wbr c1 caddc co ffvelrnda fveq2 neeq1d breq12d imbi12d vtoclga
      wi syl peano2nn0 syl2an algrp1 sylan 3imtr4d nn0seqcvgd eqtr3d ) BEMZGCDU
      IZNZGDNCNZOWBPEDQZGPMWDWERWBBDEFOPUBIOUCMWBUDUEZWBUFZEEFQWBHUEZUGZWBGBCNZ
      PLEPBCJUHUJPEGCDSUKWBUAWCGWBEPCQWFPPWCQJWJPEPCDUTULWBOWCNZWKGWBWLODNZCNZW
      KWBWFOPMWLWNRWJUMPEOCDSUNWBWMBCWBBDEFOPUBIWGWHUOUPUQLURWBUAUSZPMZVAZWODNZ
      FNZCNZOVBZWTWRCNZTVCZWOVDVEVFZWCNZOVBXEWOWCNZTVCWQWREMXAXCVMZWBPEWODWJVGA
      USZFNZCNZOVBZXJXHCNZTVCZVMXGAWREXHWRRZXKXAXMXCXNXJWTOXNXIWSCXHWRFVHUPZVIX
      NXJWTXLXBTXOXHWRCVHVJVKKVLVNWQXEWTOWQXEXDDNZCNZWTWBWFXDPMXEXQRWPWJWOVOPEX
      DCDSVPWQXPWSCWBBDEFWOOPUBIWGWHWIVQUPUQZVIWQXEWTXFXBTXRWBWFWPXFXBRWJPEWOCD
      SVRVJVSVTWA $.
  $}

  $( Lemma for ~ algcvgb .  (Contributed by Paul Chapman, 31-Mar-2011.) $)
  algcvgblem $p |- ( ( M e. NN0 /\ N e. NN0 ) -> ( ( N =/= 0 -> N < M ) <->
                      ( ( M =/= 0 -> N < M ) /\ ( M = 0 -> N = 0 ) ) ) ) $=
    ( cn0 wcel wa cc0 wne clt wbr wi wceq wn cle cr wb 0re nn0re adantr syl6bbr
    df-ne wo imor ltnle sylancr nn0le0eq0 notbid bitrd anbi2d nne breq1 biimpar
    sylbi syl6bir exp3a jctir sylibr syl5bi nn0ge0 adantl lelttr mp3an1 syl2anr
    ax-1 jaob mpand sylibd imim2d pm3.34 impbid1 con34b imbi12i bitr4i anbi2i
    jcad ) ACDZBCDZEZBFGZBAHIZJZAFGZVSJZVRWAJZEZWBAFKZBFKZJZEVQVTWDVQVTWBWCVTVR
    LZVSUAZVQWBVRVSUBVQWHWBJZVSWBJZEWIWBJVQWJWKVQWHWAVSVQWHWAEWHFAHIZEVSVQWLWAW
    HVQWLWELZWAVQWLAFMIZLZWMVQFNDZANDZWLWOOPVOWQVPAQZRFAUCUDVOWOWMOVPVOWNWEAUEU
    FRUGAFTZSZUHWHVSWLWHWFVSWLOBFUIBFAHUJULUKUMUNVSWAVCUOWHWBVSVDUPUQVQVSWAVRVQ
    VSWLWAVQFBMIZVSWLVPXAVOBURUSVPBNDZWQXAVSEWLJZVOBQWRWPXBWQXCPFBAUTVAVBVEWTVF
    VGVNVRWAVSVHVIWGWCWBWGWFLZWMJWCWEWFVJVRXDWAWMBFTWSVKVLVMS $.

  ${
    algcvgb.1 $e |- F : S --> S $.
    algcvgb.2 $e |- C : S --> NN0 $.
    $( Two ways of expressing that ` C ` is a countdown function for algorithm
       ` F ` .  The first is used in these theorems.  The second states the
       condition more intuitively as a conjunction: if the countdown function's
       value is currently non-zero, it must decrease at the next step; if it
       has reached zero, it must remain zero at the next step.  (Contributed by
       Paul Chapman, 31-Mar-2011.) $)
    algcvgb $p |- ( X e. S ->
        ( ( ( C ` ( F ` X ) ) =/= 0 -> ( C ` ( F ` X ) ) < ( C ` X ) ) <->
          ( ( ( C ` X ) =/= 0 -> ( C ` ( F ` X ) ) < ( C ` X ) ) /\
            ( ( C ` X ) = 0 -> ( C ` ( F ` X ) ) = 0 ) ) ) ) $=
      ( wcel cfv cn0 cc0 wne clt wbr wi wceq wa wb ffvelrni syl algcvgblem
      syl2anc ) DBGZDAHZIGDCHZAHZIGZUEJKUEUCLMZNUCJKUGNUCJOUEJONPQBIDAFRUBUDBGU
      FBBDCERBIUDAFRSUCUETUA $.
  $}

  ${
    $d A k m $.  $d C k m z $.  $d F z $.  $d K m $.  $d N k m $.
    $d R k m z $.  $d S k m z $.
    algcvga.1 $e |- F : S --> S $.
    algcvga.2 $e |- R = seq 0 ( ( F o. 1st ) , ( NN0 X. { A } ) ) $.
    algcvga.3 $e |- C : S --> NN0 $.
    algcvga.4 $e |- ( z e. S -> ( ( C ` ( F ` z ) ) =/= 0 ->
                                  ( C ` ( F ` z ) ) < ( C ` z ) ) ) $.
    algcvga.5 $e |- N = ( C ` A ) $.
    $( The countdown function ` C ` remains ` 0 ` after ` N ` steps.
       (Contributed by Paul Chapman, 22-Jun-2011.) $)
    algcvga $p |- ( A e. S -> ( K e. ( ZZ>= ` N ) ->
                                ( C ` ( R ` K ) ) = 0 ) ) $=
      ( wcel cn0 cfv cc0 wceq wi wbr vm vk cuz ffvelrni syl5eqel cz nn0z cle wa
      eluz1 cv c1 caddc fveq2 fveq2d eqeq1d imbi2d algcvg a1i w3a nn0ge0 adantr
      co cr nn0re zre 0re letr mp3an1 syl2an mpand elnn0z simplbi2 adantl sylan
      syld impr expcom 3adant1 ancld nn0uz 0z id algrf ffvelrnda wne clt neeq1d
      wf breq12d imbi12d vtoclga algcvgb syl6bi mpd syl algrp1 sylibrd syl6 a2d
      simpr uzind 3expib sylbid com3r ) BENZHONZGHUCPNZGDPZCPZQRZSXFHBCPOMEOBCK
      UDUEZXGXHXFXKXGHUFNZXHXFXKSZSHUGXMXHGUFNZHGUHTZUIXNHGUJXMXOXPXNXFUAUKZDPZ
      CPZQRZSXFHDPZCPZQRZSZXFUBUKZDPZCPZQRZSXFYEULUMVCZDPZCPZQRZSXNUAUBHGXQHRZX
      TYCXFYMXSYBQYMXRYACXQHDUNUOUPUQXQYERZXTYHXFYNXSYGQYNXRYFCXQYEDUNUOUPUQXQY
      IRZXTYLXFYOXSYKQYOXRYJCXQYIDUNUOUPUQXQGRZXTXKXFYPXSXJQYPXRXICXQGDUNUOUPUQ
      YDXMABCDEFHIJKLMURUSXMYEUFNZHYEUHTZUTZXFYHYLYSXFXFYEONZUIZYHYLSYSXFYTYQYR
      XFYTSXMXFYQYRUIYTXFYQYRYTXFXGYQYRYTSXLXGYQUIZYRQYEUHTZYTUUBQHUHTZYRUUCXGU
      UDYQHVAVBXGHVDNZYEVDNZUUDYRUIUUCSZYQHVEYEVFQVDNUUEUUFUUGVGQHYEVHVIVJVKYQU
      UCYTSXGYTYQUUCYEVLVMVNVPVOVQVRVSVTUUAYHYFFPZCPZQRZYLUUAYFENZYHUUJSZXFOEYE
      DXFBDEFQOWAJQUFNXFWBUSZXFWCZEEFWIXFIUSZWDWEUUKUUIQWFZUUIYGWGTZSZUULAUKZFP
      ZCPZQWFZUVAUUSCPZWGTZSUURAYFEUUSYFRZUVBUUPUVDUUQUVEUVAUUIQUVEUUTUUHCUUSYF
      FUNUOZWHUVEUVAUUIUVCYGWGUVFUUSYFCUNWJWKLWLUUKUURYGQWFUUQSZUULUIUULCEFYFIK
      WMUVGUULXAWNWOWPUUAYKUUIQUUAYJUUHCXFBDEFYEQOWAJUUMUUNUUOWQUOUPWRWSWTXBXCX
      DWPXEWO $.

    $d K z $.  $d N z $.
    algfx.6 $e |- ( z e. S -> ( ( C ` z ) = 0 -> ( F ` z ) = z ) ) $.
    $( If ` F ` reaches a fixed point when the countdown function ` C ` reaches
       ` 0 ` , ` F ` remains fixed after ` N ` steps.  (Contributed by Paul
       Chapman, 22-Jun-2011.) $)
    algfx $p |- ( A e. S -> ( K e. ( ZZ>= ` N ) -> ( R ` K ) = ( R ` N ) ) ) $=
      ( wcel cfv wceq wi cn0 fveq2 vm vk cz cuz ffvelrni syl5eqel nn0zd cle wbr
      wa cv crab uzval eleq2d pm5.32i c1 caddc co eqeq1d imbi2d eqidd a1i sylan
      eluznn0 cc0 nn0uz 0z id algrp1 syldan algrf ffvelrnda algcvga imp eqeq12d
      wf imbi12d vtoclga eqtrd biimprd expcom adantl sylbir a2d uzind3 sylbi ex
      sylc com3r mpd ) BEOZHUCOZGHUDPZOZGDPZHDPZQZRWKHWKHBCPSMESBCKUEUFZUGWLWNW
      KWQWLWNWKWQRZWLWNUJWLGHAUKZUHUIAUCULZOZUJWSWLWNXBWLWMXAGAHUMZUNUOWKUAUKZD
      PZWPQZRWKWPWPQZRZWKUBUKZDPZWPQZRWKXIUPUQURZDPZWPQZRWSUAAUBHGXDHQZXFXGWKXO
      XEWPWPXDHDTUSUTXDXIQZXFXKWKXPXEXJWPXDXIDTUSUTXDXLQZXFXNWKXQXEXMWPXDXLDTUS
      UTXDGQZXFWQWKXRXEWOWPXDGDTUSUTXHWLWKWPVAVBWLXIXAOZUJZWKXKXNXTWLXIWMOZUJWK
      XKXNRZRZWLYAXSWLWMXAXIXCUNUOYAYCWLWKYAYBWKYAUJZXNXKYDXMXJWPYDXMXJFPZXJWKY
      AXISOZXMYEQWKHSOYAYFWRXIHVDVCZWKBDEFXIVESVFJVEUCOWKVGVBZWKVHZEEFVPWKIVBZV
      IVJYDXJEOZXJCPZVEQZYEXJQZWKYAYFYKYGWKSEXIDWKBDEFVESVFJYHYIYJVKVLVJWKYAYMA
      BCDEFXIHIJKLMVMVNWTCPZVEQZWTFPZWTQZRYMYNRAXJEWTXJQZYPYMYRYNYSYOYLVEWTXJCT
      USYSYQYEWTXJWTXJFTYSVHVOVQNVRWHVSUSVTWAWBWCWDWEWFWGWIWJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Euclid's Algorithm
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y M $.  $d x y N $.  $d x y X $.  $d x y z A $.  $d x z R $.
    $d z E $.
    eucalgval.1 $e |- E = ( x e. NN0 , y e. NN0 |->
                        if ( y = 0 , <. x , y >. , <. y , ( x mod y ) >. ) ) $.
    $( The value of the step function ` E ` for Euclid's Algorithm on an
       ordered pair.  (Contributed by Paul Chapman, 31-Mar-2011.)  (Revised by
       Mario Carneiro, 28-May-2014.) $)
    eucalgval2 $p |- ( ( M e. NN0 /\ N e. NN0 ) -> ( M E N ) =
                     if ( N = 0 , <. M , N >. , <. N , ( M mod N ) >. ) ) $=
      ( cn0 cv cc0 wceq cop cmo co cif wa simpr eqeq1d opeq12 oveq12 opex ifex
      opeq12d ifbieq12d ovmpt2a ) ABDEGGBHZIJZAHZUEKZUEUGUELMZKZNEIJZDEKZEDELMZ
      KZNCUGDJZUEEJZOZUFUKUHUJULUNUQUEEIUOUPPZQUGUEDERUQUEEUIUMURUGDUEELSUBUCFU
      KULUNDETEUMTUAUD $.

    $( Euclid's Algorithm ~ eucalg computes the greatest common divisor of two
       nonnegative integers by repeatedly replacing the larger of them with its
       remainder modulo the smaller until the remainder is 0.

       The value of the step function ` E ` for Euclid's Algorithm.
       (Contributed by Paul Chapman, 31-Mar-2011.)  (Revised by Mario Carneiro,
       28-May-2014.) $)
    eucalgval $p |- ( X e. ( NN0 X. NN0 ) -> ( E ` X ) =
          if ( ( 2nd ` X ) = 0 , X , <. ( 2nd ` X ) , ( mod ` X ) >. ) ) $=
      ( cn0 cxp wcel c1st cfv c2nd cop cc0 wceq cmo co cif df-ov xp1st fveq2d
      xp2nd eucalgval2 syl2anc syl5eqr 1st2nd2 syl6eqr opeq2d ifeq12d 3eqtr4d )
      DFFGHZDIJZDKJZLZCJZULMNZUMULUKULOPZLZQZDCJUODULDOJZLZQUJUNUKULCPZURUKULCR
      UJUKFHULFHVAURNDFFSDFFUAABCUKULEUBUCUDUJDUMCDFFUEZTUJUODUMUTUQVBUJUSUPULU
      JUSUMOJUPUJDUMOVBTUKULORUFUGUHUI $.

    $( Domain and codomain of the step function ` E ` for Euclid's Algorithm.
       (Contributed by Paul Chapman, 31-Mar-2011.)  (Revised by Mario Carneiro,
       28-May-2014.) $)
    eucalgf $p |- E : ( NN0 X. NN0 ) --> ( NN0 X. NN0 ) $=
      ( cv cc0 wceq cop cmo co cif cn0 cxp wcel wral wf adantl opelxpi eqeltrd
      wa cn wn wne nnne0 neneqd iffalse syl nnnn0 cz nn0z sylan syl2anc adantlr
      zmodcl iftrue adantr wo simpr elnn0 sylib mpjaodan rgen2a fmpt2 mpbi ) BE
      ZFGZAEZVEHZVEVGVEIJZHZKZLLMZNZBLOALOVLVLCPVMABLVGLNZVELNZTZVEUANZVMVFVNVQ
      VMVOVNVQTZVKVJVLVRVFUBVKVJGVRVEFVQVEFUCVNVEUDQUEVFVHVJUFUGVRVOVILNZVJVLNV
      QVOVNVEUHQVNVGUINVQVSVGUJVGVEUNUKVEVILLRULSUMVPVFTVKVHVLVFVKVHGVPVFVHVJUO
      QVPVHVLNVFVGVELLRUPSVPVOVQVFUQVNVOURVEUSUTVAVBABLLVKVLCDVCVD $.

    $( The invariant of the step function ` E ` for Euclid's Algorithm is the
       ` gcd ` operator applied to the state.  (Contributed by Paul Chapman,
       31-Mar-2011.)  (Revised by Mario Carneiro, 29-May-2014.) $)
    eucalginv $p |- ( X e. ( NN0 X. NN0 ) ->
                        ( gcd ` ( E ` X ) ) = ( gcd ` X ) ) $=
      ( cn0 wcel cfv cgcd cc0 wceq cmo fveq2d co adantr df-ov syl6eqr cz adantl
      cop cxp c2nd cif eucalgval cn wa c1st 1st2nd2 oveq2d xp1st nn0zd sylancom
      nnz zmodcl gcdcom syl2anc modgcd 3eqtrd wn wne neneqd iffalse syl 3eqtr4d
      nnne0 iftrue wo xp2nd elnn0 sylib mpjaodan eqtrd ) DFFUAGZDCHZIHDUBHZJKZD
      VODLHZTZUCZIHZDIHZVMVNVSIABCDEUDMVMVOUEGZVTWAKZVPVMWBUFZVOVQINZDUGHZVOINZ
      VTWAWDWEVOWFVOLNZINZWHVOINZWGWDVQWHVOIWDVQWFVOTZLHWHWDDWKLVMDWKKWBDFFUHOZ
      MWFVOLPQUIWDVORGZWHRGWIWJKWBWMVMVOUMSWDWHVMWBWFRGZWHFGWDWFVMWFFGWBDFFUJOU
      KZWFVOUNULUKVOWHUOUPVMWBWNWJWGKWOWFVOUQULURWDVTVRIHWEWDVSVRIWDVPUSVSVRKWD
      VOJWBVOJUTVMVOVESVAVPDVRVBVCMVOVQIPQWDWAWKIHWGWDDWKIWLMWFVOIPQVDVPWCVMVPV
      SDIVPDVRVFMSVMVOFGWBVPVGDFFVHVOVIVJVKVL $.

    $( The second member of the state decreases with each iteration of the step
       function ` E ` for Euclid's Algorithm.  (Contributed by Paul Chapman,
       31-Mar-2011.)  (Revised by Mario Carneiro, 29-May-2014.) $)
    eucalglt $p |- ( X e. ( NN0 X. NN0 ) ->
        ( ( 2nd ` ( E ` X ) ) =/= 0 -> ( 2nd ` ( E ` X ) ) < ( 2nd ` X ) ) ) $=
      ( cn0 cxp wcel cfv c2nd cc0 clt wbr cmo cop wceq adantr eqtrd fveq2d fvex
      wne wa c1st co eucalgval wn simpr iftrue eqeq2d fveq2 syl6bi eqeq2 sylibd
      cif syl5com necon3ad mpd iffalse op2nd syl6eq 1st2nd2 df-ov syl6eqr xp1st
      syl cr crp nn0red cn wo xp2nd elnn0 sylib ord nnrpd modlt syl2anc eqbrtrd
      mt3d ex ) DFFGHZDCIZJIZKUAZWCDJIZLMWAWDUBZWCDUCIZWENUDZWELWFWCDNIZWHWFWCW
      EWIOZJIWIWFWBWJJWFWBWEKPZDWJUNZWJWAWBWLPZWDABCDEUEQZWFWKUFZWLWJPWFWDWOWAW
      DUGWFWKWCKWFWMWKWCKPZWNWKWMWCWEPZWPWKWMWBDPWQWKWLDWBWKDWJUHUIWBDJUJUKWEKW
      CULUMUOUPUQZWKDWJURVERSWEWIDJTDNTUSUTWFWIWGWEOZNIWHWFDWSNWADWSPWDDFFVAQSW
      GWENVBVCRWFWGVFHWEVGHWHWELMWFWGWAWGFHWDDFFVDQVHWFWEWFWEVIHZWKWRWFWTWKWFWE
      FHZWTWKVJWAXAWDDFFVKQWEVLVMVNVSVOWGWEVPVQVRVT $.

    eucalg.2 $e |- R = seq 0 ( ( E o. 1st ) , ( NN0 X. { A } ) ) $.
    ${
      eucalgcvga.3 $e |- N = ( 2nd ` A ) $.
      $( Once Euclid's Algorithm halts after ` N ` steps, the second element of
         the state remains 0 .  (Contributed by Paul Chapman, 22-Jun-2011.)
         (Revised by Mario Carneiro, 29-May-2014.) $)
      eucalgcvga $p |- ( A e. ( NN0 X. NN0 ) ->
                         ( K e. ( ZZ>= ` N ) -> ( 2nd ` ( R ` K ) ) = 0 ) ) $=
        ( vz cn0 wcel cuz cfv c2nd cc0 wceq fvres clt cxp wa cres xp2nd eluznn0
        syl5eqel sylan nn0uz cz 0z a1i id wf eucalgf algrf ffvelrnda syldan syl
        simpl syl6eqr fveq2d eleq2d biimpar f2ndres cv eucalglt ffvelrni neeq1d
        wne wbr breq12d 3imtr4d eqid algcvga sylc eqtr3d ex ) CLLUAZMZFGNOZMZFD
        OZPOZQRVSWAUBZWBPVRUCZOZWCQWDWBVRMZWFWCRVSWAFLMZWGVSGLMWAWHVSGCPOZLJCLL
        UDUFFGUEUGVSLVRFDVSCDVREQLUHIQUIMVSUJUKVSULVRVREUMVSABEHUNZUKUOUPUQWBVR
        PSURWDVSFCWEOZNOZMZWFQRVSWAUSVSWMWAVSWLVTFVSWKGNVSWKWIGCVRPSJUTVAVBVCKC
        WEDVREFWKWJILLVDKVEZVRMZWNEOZPOZQVIWQWNPOZTVJWPWEOZQVIWSWNWEOZTVJABEWNH
        VFWOWSWQQWOWPVRMWSWQRVRVRWNEWJVGWPVRPSURZVHWOWSWQWTWRTXAWNVRPSVKVLWKVMV
        NVOVPVQ $.
    $}

    eucalg.3 $e |- A = <. M , N >. $.
    $( Euclid's Algorithm computes the greatest common divisor of two
       nonnegative integers by repeatedly replacing the larger of them with its
       remainder modulo the smaller until the remainder is 0.

       Upon halting, the 1st member of the final state ` ( R `` N ) ` is equal
       to the gcd of the values comprising the input state ` <. M , N >. ` .
       (Contributed by Paul Chapman, 31-Mar-2011.)  (Proof shortened by Mario
       Carneiro, 29-May-2014.) $)
    eucalg $p |- ( ( M e. NN0 /\ N e. NN0 ) ->
                   ( 1st ` ( R ` N ) ) = ( M gcd N ) ) $=
      ( cn0 wcel cfv cgcd cc0 c2nd wceq cz syl fveq2d vz wa co cop cxp wf nn0uz
      c1st 0z a1i opelxpi syl5eqel eucalgf algrf ffvelrn sylancom 1st2nd2 df-ov
      syl6eqr fveq2i op2ndg syl5eq cuz xp2nd uzid eqid eucalgcvga eqtr3d oveq2d
      nn0zd mpd xp1st nn0gcdid0 3syl 3eqtrrd cres wfn wss gcdf ffn ax-mp nn0ssz
      xpss12 mp2an fnssres eucalginv ffvelrni fvres 3eqtr4d alginv 0nn0 sylancl
      cv 3eqtr3d algr0 syl6eq 3eqtrd ) FKLZGKLZUBZGDMZUHMZXANMZODMZNMZFGNUCZWTX
      CXBXAPMZNUCZXBONUCZXBWTXCXBXGUDZNMXHWTXAXJNWTXAKKUEZLZXAXJQWRWSKXKDUFZXLW
      TCDXKEOKUGIORLWTUIUJZWTCFGUDZXKJFGKKUKULZXKXKEUFWTABEHUMZUJUNZKXKGDUOUPZX
      AKKUQSTXBXGNURUSWTXGOXBNWTCPMZDMZPMZXGOWTYAXAPWTXTGDWTXTXOPMGCXOPJUTFGKKV
      AVBTTWTCXKLZYBOQZXPYCXTXTVCMLZYDYCXTRLYEYCXTCKKVDVJXTVESABCDEXTXTHIXTVFVG
      VKSVHVIWTXLXBKLXIXBQXSXAKKVLXBVMVNVOWTXANXKVPZMZXDYFMZXCXEWRWSYCYGYHQXPUA
      CDXKEYFGIXQNRRUEZVQZXKYIVRZYFXKVQYIKNUFYJVSYIKNVTWAKRVRZYLYKWBWBKRKRWCWDY
      IXKNWEWDUAWMZXKLZYMEMZNMZYMNMYOYFMZYMYFMABEYMHWFYNYOXKLYQYPQXKXKYMEXQWGYO
      XKNWHSYMXKNWHWIWJUPWTXLYGXCQXSXAXKNWHSWTXDXKLZYHXEQWTXMOKLYRXRWKKXKODUOWL
      XDXKNWHSWNWTXEXONMXFWTXDXONWTXDCXOWTCDXKEOKUGIXNXPWOJWPTFGNURUSWQ $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                        Elementary prime number theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Elementary properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Prime $.

  $( Extend the definition of a class to include the set of prime numbers. $)
  cprime $a class Prime $.

  ${
    $d n p $.
    $( Define the set of prime numbers.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    df-prm $a |- Prime = { p e. NN | { n e. NN | n || p } ~~ 2o } $.
  $}

  ${
    $d P n p z $.
    $( The predicate "is a prime number".  A prime number is a positive integer
       with exactly two positive divisors.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    isprm $p |- ( P e. Prime <->
                  ( P e. NN /\ { n e. NN | n || P } ~~ 2o ) ) $=
      ( vp cv cdivides wbr crab c2o cen cprime wceq breq2 rabbidv breq1d df-prm
      cn elrab2 ) BDZCDZEFZBPGZHIFRAEFZBPGZHIFCAPJSAKZUAUCHIUDTUBBPSARELMNBCOQ
      $.

    $( A prime number is a positive integer.  (Contributed by Paul Chapman,
       22-Jun-2011.) $)
    prmnn $p |- ( P e. Prime -> P e. NN ) $=
      ( vz cprime wcel cn cv cdivides wbr crab c2o cen isprm simplbi ) ACDAEDBF
      AGHBEIJKHABLM $.

    $( A prime number is an integer.  (Contributed by Paul Chapman,
       22-Jun-2011.)  (Proof shortened by Jonathan Yan, 16-Jul-2017.) $)
    prmz $p |- ( P e. Prime -> P e. ZZ ) $=
      ( cprime wcel prmnn nnzd ) ABCAADE $.
  $}

  ${
    $d n z $.
    $( 1 is not a prime number.  (Contributed by Paul Chapman, 22-Jun-2011.)
       (Proof shortened by Fan Zheng, 3-Jul-2016.) $)
    1nprm $p |- -. 1 e. Prime $=
      ( vn vz c1 cprime wcel cv cdivides wbr cn crab c2o cen csdm wn c1o csn wa
      wceq 1nn eleq1 mpbiri cn0 nnnn0 dvds1 syl bicomd biadan2 elsn breq1 elrab
      wb 3bitr4ri eqriv ensn1 eqbrtri 1sdom2 ensdomtr mp2an sdomnen ax-mp isprm
      1ex mpbiran mtbir ) CDEZAFZCGHZAIJZKLHZVHKMHZVINVHOLHOKMHVJVHCPZOLBVHVKBF
      ZCRZVLIEZVLCGHZQVLVKEVLVHEVMVNVOVMVNCIEZSVLCITUAVNVOVMVNVLUBEVOVMUKVLUCVL
      UDUEUFUGBCUHVGVOAVLIVFVLCGUIUJULUMCVBUNUOUPVHOKUQURVHKUSUTVEVPVISCAVAVCVD
      $.
  $}

  ${
    $d N n $.
    $( The positive divisors of a positive integer include 1 and itself.
       (Contributed by Paul Chapman, 22-Jun-2011.) $)
    1idssfct $p |- ( N e. NN -> { 1 , N } C_ { n e. NN | n || N } ) $=
      ( cn wcel c1 cv cdivides wbr crab cpr wss 1nn cz nnz 1dvds wa breq1 elrab
      syl biimpri sylancr iddvds mpdan prssi syl2anc ) BCDZEAFZBGHZACIZDZBUIDZE
      BJUIKUFECDZEBGHZUJLUFBMDZUMBNZBOSUJULUMPUHUMAECUGEBGQRTUAUFBBGHZUKUFUNUPU
      OBUBSUKUFUPPUHUPABCUGBBGQRTUCEBUIUDUE $.
  $}

  ${
    $d n p z P $.
    $( Lemma for ~ isprm2 .  (Contributed by Paul Chapman, 22-Jun-2011.) $)
    isprm2lem $p |- ( ( P e. NN /\ P =/= 1 ) ->
      ( { n e. NN | n || P } ~~ 2o <-> { n e. NN | n || P } = { 1 , P } ) ) $=
      ( vp cn wcel c1 wne cv cdivides wbr crab c2o cen cpr wceq wb wi wa wn csn
      neeq1 breq2 rabbidv breq1d preq2 eqeq12d bibi12d imbi12d wss 1idssfct cun
      cin c0 disjsn c1o 1ex ensn1 pm54.43 mp2an bitr3i elsn xchnxbi df-ne df-pr
      vex breq1i 3bitr4i ensym entr sylan2 sylanb cfn prfi enfii sylancr adantl
      wpss dfpss2 pssinf sylanbr an32s ex mt4d syl2an eqcomd expr breq1 syl6bbr
      biimprcd impbid vtoclga imp ) ADEAFGZBHZAIJZBDKZLMJZWPFANZOZPZCHZFGZWNXAI
      JZBDKZLMJZXDFXANZOZPZQWMWTQCADXAAOZXBWMXHWTXAAFUAXIXEWQXGWSXIXDWPLMXIXCWO
      BDXAAWNIUBUCZUDXIXDWPXFWRXJXAAFUEUFUGUHXADEZXBXHXKXBRXEXGXKXBXEXGXKXBXERZ
      RXFXDXKXFXDUIZXFXDMJZXFXDOZXLBXAUJXBXFLMJZXEXNXAFOZSFTZXATZUKZLMJZXBXPXAX
      REZYAXQYBSXRXSULUMOZYAXRXAUNXRUOMJXSUOMJYCYAPFUPUQXACVEUQXRXSURUSUTCFVAVB
      XAFVCXFXTLMFXAVDVFVGZXEXPLXDMJXNXDLVHXFLXDVIVJVKXMXNRZXDVLEZXOXNYFXMXNXFV
      LEXDXFMJYFFXAVMXFXDVHXDXFVNVOVPYEXOSZYFSZXMYGXNYHXMYGRXFXDVQXNYHXFXDVRXFX
      DVSVTWAWBWCWDWEWFXBXGXEQXKXGXEXBXGXEXPXBXDXFLMWGYDWHWIVPWJWBWKWL $.

    $( The predicate "is a prime number".  A prime number is an integer greater
       than or equal to 2 whose only positive divisors are 1 and itself.
       (Contributed by Paul Chapman, 26-Oct-2012.) $)
    isprm2 $p |- ( P e. Prime <-> ( P e. ( ZZ>= ` 2 ) /\
                      A. z e. NN ( z || P -> ( z = 1 \/ z = P ) ) ) ) $=
      ( vn cprime wcel c1 wa cn cv cdivides wbr wss wceq wi wb bitri bitr4i wal
      ancom 3bitri wne crab cpr c2 cuz wo wral 1nprm eleq1 biimpcd mtoi neneqad
      cfv pm4.71i c2o cen isprm2lem eqss imbi2i 1idssfct jcab mpbiran2 pm5.74ri
      isprm adantr bitrd expcom pm5.32d syl5bb anass eluz2b3 anbi1i dfss2 breq1
      pm5.32ri elrab vex elpr imbi12i impexp albii df-ral anbi2i ) BDEZWDBFUAZG
      BHEZCIZBJKZCHUBZFBUCZLZGZWEGZBUDUEUMEZAIZBJKZWOFMWOBMUFZNZAHUGZGZWDWEWDBF
      WDBFMZFDEZUHXAWDXBBFDUIUJUKULUNWEWDWLWDWFWIUOUPKZGWEWLBCVDWEWFXCWKWFWEXCW
      KOWFWEGZXCWIWJMZWKBCUQWFXEWKOWEWFXEWKWFXENWFWKWJWILZGZNZWFWKNZXEXGWFWIWJU
      RUSXHXIWFXFNCBUTWFWKXFVAVBPVCVEVFVGVHVIVOWMWEWFGZWKGZWNWKGWTWMWEWLGXKWLWE
      SWEWFWKVJQXJWNWKXJXDWNWEWFSBVKQVLWKWSWNWKWOWIEZWOWJEZNZARZWSAWIWJVMXOWOHE
      ZWRNZARWSXNXQAXNXPWPGZWQNXQXLXRXMWQWHWPCWOHWGWOBJVNVPWOFBAVQVRVSXPWPWQVTP
      WAWRAHWBQPWCTT $.

    $( The predicate "is a prime number".  A prime number is an integer greater
       than or equal to 2 with no divisors strictly between 1 and itself.
       (Contributed by Paul Chapman, 26-Oct-2012.) $)
    isprm3 $p |- ( P e. Prime <-> ( P e. ( ZZ>= ` 2 ) /\
                      A. z e. ( 2 ... ( P - 1 ) ) -. z || P ) ) $=
      ( wcel c2 cuz cfv wbr c1 wceq wi cn wa wn co wb cle cz adantr cr syl2an
      cprime cv cdivides wo wral cmin cfz isprm2 iman clt 2nn elnnuz mpbi uztrn
      mpan2 sylibr nnz dvdsle sylan nnge1 jctild sylan2 wne zre nnre 1re leltne
      mp3an1 3adant2 3expia anim12d pm4.38 df-ne nesym ioran bitr4i syl6bb syl6
      anbi12i syld eluzelz caddc 1z zltp1le mpan breq1i syl6bbr zltlem1 anbi12d
      imp df-2 peano2zm elfz mp3an2 bitr4d bitr3d anasss expcom pm5.32d wss 2re
      2z fzssuz 1lt2 ltleii eluz mp2an mpbir uzss ax-mp sstri sseqtr4i pm4.71ri
      sseli notbid syl5bb pm5.74da bi2.04 con2b 3bitr3g ralbidv2 pm5.32i bitri
      nnuz ) BUACBDEFZCZAUBZBUCGZYGHIZYGBIZUDZJZAKUEZLYFYHMZADBHUFNZUGNZUEZLABU
      HYFYMYQYFYLYNAKYPYFYHYGKCZYKJZJYHYGYPCZMZJYRYLJYTYNJYFYHYSUUAYSYRYKMZLZMY
      FYHLZUUAYRYKUIUUDUUCYTUUDUUCYRYTLYTUUDYRUUBYTYRUUDUUBYTOZYRYFYHUUEYRYFLZY
      HLHYGUJGZYGBUJGZLZUUBYTUUFYHUUIUUBOZUUFYHHYGPGZYGBPGZLZUUJYFYRBKCZYHUUMJY
      FBHEFZCZUUNYFDUUOCZUUPDKCUUQUKDULUMDBHUNUOBULUPZYRUUNLYHUULUUKYRYGQCZUUNY
      HUULJYGUQZYGBURUSYRUUKUUNYGUTRVAVBYRUUSUUNUUMUUJJYFUUTUURUUSUUNLUUMUUGYGH
      VCZOZUUHBYGVCZOZLZUUJUUSYGSCZBSCZUUMUVEJUUNYGVDBVEUVFUVGLUUKUVBUULUVDUVFU
      VGUUKUVBUVFUUKUVBUVGHSCUVFUUKUVBVFHYGVGVHVIVJUVFUVGUULUVDYGBVGVJVKTUVEUUI
      UVAUVCLZUUBUUGUUHUVAUVCVLUVHYIMZYJMZLUUBUVAUVIUVCUVJYGHVMBYGVNVSYIYJVOVPV
      QVRTVTWJUUFUUIYTOZYHYRUUSBQCZUVKYFUUTDBWAUUSUVLLZUUIDYGPGZYGYOPGZLZYTUVMU
      UGUVNUUHUVOUUSUUGUVNOUVLUUSUUGHHWBNZYGPGZUVNHQCZUUSUUGUVROWCHYGWDWEDUVQYG
      PWKWFWGRYGBWHWIUVLUUSYOQCZYTUVPOZBWLUUSDQCZUVTUWAXBYGDYOWMWNVBWOTRWPWQWRW
      SYTYRYPKYGYPUUOKYPYEUUODYOXCUUQYEUUOWTUUQHDPGZHDVFXAXDXEUVSUWBUUQUWCOWCXB
      HDXFXGXHHDXIXJXKYDXLXNXMWGXOXPXQYHYRYKXRYHYTXSXTYAYBYC $.

    $( The predicate "is a prime number".  A prime number is an integer greater
       than or equal to 2 whose only divisor greater than or equal to 2 is
       itself.  (Contributed by Paul Chapman, 26-Oct-2012.) $)
    isprm4 $p |- ( P e. Prime <-> ( P e. ( ZZ>= ` 2 ) /\
                      A. z e. ( ZZ>= ` 2 ) ( z || P -> z = P ) ) ) $=
      ( cprime wcel c2 cuz cfv cv cdivides wbr c1 wceq wi cn wral imbi1i bitr4i
      wa imbi2i bitri wo isprm2 wne eluz2b3 impexp bi2.04 wn df-ne df-or anbi2i
      ralbii2 ) BCDBEFGZDZAHZBIJZUNKLZUNBLZUAZMZANOZRUMUOUQMZAULOZRABUBVBUTUMVA
      USAULNUNULDZVAMUNNDZUNKUCZRZVAMZVDUSMZVCVFVAUNUDPVGVDVEVAMZMVHVDVEVAUEVIU
      SVDVIUOVEUQMZMUSVEUOUQUFVJURUOVJUPUGZUQMURVEVKUQUNKUHPUPUQUIQSTSTTUKUJQ
      $.
  $}

  ${
    $d k x y $.  $d n x A $.  $d x z ch $.  $d x et $.  $d x ta $.  $d x th $.
    $d k n y z ph $.
    prmind.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    prmind.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    prmind.3 $e |- ( x = z -> ( ph <-> th ) ) $.
    prmind.4 $e |- ( x = ( y x. z ) -> ( ph <-> ta ) ) $.
    prmind.5 $e |- ( x = A -> ( ph <-> et ) ) $.
    prmind.6 $e |- ps $.
    ${
      prmind2.7 $e |- ( ( x e. Prime /\ A. y e. ( 1 ... ( x - 1 ) ) ch ) ->
        ph ) $.
      prmind2.8 $e |- ( ( y e. ( ZZ>= ` 2 ) /\ z e. ( ZZ>= ` 2 ) ) ->
        ( ( ch /\ th ) -> ta ) ) $.
      $( A variation on ~ prmind assuming complete induction for primes.
         (Contributed by Mario Carneiro, 20-Jun-2015.) $)
      prmind2 $p |- ( A e. NN -> et ) $=
        ( wcel c1 vn vk cn cfz co wral elfz1end biimpi caddc wceq oveq2 raleqdv
        cv weq wb elfz1eq syl mpbiri rgen csn wa wsbc cdivides wbr c2 cmin wrex
        cdiv cmul cuz cfv cz clt simprr cc0 wne elfzuz ad2antrl eluz2b2 simplbi
        nnzd peano2nn ad2antrr dvdsval2 syl3anc mpbid nncnd mulid2d cle elfzle2
        nnne0d cc nncn ax-1cn pncan sylancl breqtrd nnz zleltp1 syl2anc eqbrtrd
        1re a1i nnred nngt0d ltmuldiv syl112anc eluz2b1 sylanbrc fznn mpbir2and
        cr simplr rspcv sylc nnrpd rpdivcld rpgt0d elnnz dividd simprbi ltdiv23
        syl122anc mpbird cbvralv sylib vex sbcie dfsbcq syl5bbr jca anbi2d ovex
        wi imbi12d wn cprime oveq2d ex sylibrd imbi2d expcom vtoclga rexlimdvaa
        syl3c divcan2d ralnex simpl elnnuz eluzp1p1 df-2 fveq2i syl6eleqr baibr
        isprm3 simpr nfcv nfv nfsbc1v nfim oveq1 sbceq1a syl5com sylbid syl5bir
        vtoclgaf pm2.61d ralsnsg ancld cun fzsuc sylbi ralunb syl6bb nnind ) JU
        CSZJTJUDUEZSZAGUVQUFZFUVPUVRJUGUHAGTUAUMZUDUEZUFAGTTUDUEZUFAGTUBUMZUDUE
        ZUFZAGTUWCTUIUEZUDUEZUFZUVSUAUBJUVTTUJAGUWAUWBUVTTTUDUKULUAUBUNAGUWAUWD
        UVTUWCTUDUKULUVTUWFUJAGUWAUWGUVTUWFTUDUKULUVTJUJAGUWAUVQUVTJTUDUKULAGUW
        BGUMZUWBSZABPUWJUWITUJABUOUWITUPKUQURUSUWCUCSZUWEUWEAGUWFUTZUFZVAZUWHUW
        KUWEUWMUWKUWEAGUWFVBZUWMUWKUWEUWOUWKUWEVAZHUMZUWFVCVDZHVEUWFTVFUEZUDUEZ
        VGZUWOUWPUWRUWOHUWTUWPUWQUWTSZUWRVAZVAZAGUWQUWFUWQVHUEZVIUEZVBZUWOUXDUX
        EVEVJVKZSZUWQUXHSZCAGUXEVBZVAZUXGUXDUXEVLSZTUXEVMVDZUXIUXDUWRUXMUWPUXBU
        WRVNUXDUWQVLSZUWQVOVPUWFVLSUWRUXMUOUXDUWQUXDUXJUWQUCSZUXBUXJUWPUWRUWQVE
        UWSVQVRZUXJUXPTUWQVMVDZUWQVSZVTUQZWAZUXDUWQUXTWKZUXDUWFUWKUWFUCSZUWEUXC
        UWCWBZWCZWAUWQUWFWDWEWFZUXDTUWQVIUEZUWFVMVDZUXNUXDUYGUWQUWFVMUXDUWQUXDU
        WQUXTWGZWHUXDUWQUWCWIVDZUWQUWFVMVDZUXDUWQUWSUWCWIUXBUWQUWSWIVDUWPUWRUWQ
        VEUWSWJVRUXDUWCWLSZTWLSZUWSUWCUJZUWKUYLUWEUXCUWCWMWCWNUWCTWOZWPWQZUXDUX
        OUWCVLSZUYJUYKUOUYAUWKUYQUWEUXCUWCWRWCZUWQUWCWSWTWFXAUXDTXLSZUWFXLSZUWQ
        XLSZVOUWQVMVDZUYHUXNUOUYSUXDXBXCUXDUWFUYEXDZUXDUWQUXTXDZUXDUWQUXTXEZTUW
        FUWQXFXGWFUXEXHXIUXQUXDCUXKUXDUWQUWDSZUWECUXDVUFUXPUYJUXTUYPUXDUYQVUFUX
        PUYJVAUOUYRUWQUWCXJUQXKUWKUWEUXCXMZACGUWQUWDLXNXOUXDUXEUWDSZDIUWDUFZUXK
        UXDVUHUXEUCSZUXEUWCWIVDZUXDUXMVOUXEVMVDVUJUYFUXDUXEUXDUWFUWQUXDUWFUYEXP
        UXDUWQUXTXPXQXRUXEXSXIUXDVUKUXEUWFVMVDZUXDUWFUWFVHUEZUWQVMVDZVULUXDVUMT
        UWQVMUXDUWFUXDUWFUYEWGZUXDUWFUYEWKXTUXDUXJUXRUXQUXJUXPUXRUXSYAUQXAUXDUY
        TUYTVOUWFVMVDVUAVUBVUNVULUOVUCVUCUXDUWFUYEXEVUDVUEUWFUWFUWQYBYCWFUXDUXM
        UYQVUKVULUOUYFUYRUXEUWCWSWTYDUXDUYQVUHVUJVUKVAUOUYRUXEUWCXJUQXKUXDUWEVU
        IVUGADGIUWDMYEYFDUXKIUXEUWDDAGIUMZVBVUPUXEUJZUXKADGVUPIYGMYHAGVUPUXEYIY
        JZXNXOYKUXJCDVAZEYNZYNUXJUXLUXGYNZYNIUXEUXHVUQVUTVVAUXJVUQVUSUXLEUXGVUQ
        DUXKCVURYLEAGUWQVUPVIUEZVBZVUQUXGAEGVVBUWQVUPVIYMNYHVUQVVBUXFUJVVCUXGUO
        VUPUXEUWQVIUKAGVVBUXFYIUQYJYOUUAUXJVUPUXHSVUTRUUBUUCUUEUXDUXFUWFUJUXGUW
        OUOUXDUWFUWQVUOUYIUYBUUFAGUXFUWFYIUQWFUUDUXAYPUWRYPHUWTUFZUWPUWOUWRHUWT
        UUGUWPVVDUWFYQSZUWOUWPUWFUXHSZVVDVVEUOUWPUWFTTUIUEZVJVKZUXHUWPUWCTVJVKS
        ZUWFVVHSUWPUWKVVIUWKUWEUUHZUWCUUIZYFTUWCUUJUQVEVVGVJUUKUULUUMVVEVVFVVDH
        UWFUUOUUNUQUWPCHTUWSUDUEZUFZVVEUWOUWPVVMCHUWDUFZUWPUWEVVNUWKUWEUUPACGHU
        WDLYEYFUWPCHVVLUWDUWPUWSUWCTUDUWPUYLUYMUYNUWPUWCVVJWGWNUYOWPYRULYDCHTUW
        ITVFUEZUDUEZUFZAYNVVMUWOYNGUWFYQGUWFUUQVVMUWOGVVMGUURAGUWFUUSUUTUWIUWFU
        JZVVQVVMAUWOVVRCHVVPVVLVVRVVOUWSTUDUWIUWFTVFUVAYRULAGUWFUVBYOUWIYQSVVQA
        QYSUVFUVCUVDUVEUVGYSUWKUYCUWMUWOUOUYDAGUWFUCUVHUQYTUVIUWKUWHAGUWDUWLUVJ
        ZUFUWNUWKAGUWGVVSUWKVVIUWGVVSUJVVKTUWCUVKUVLULAGUWDUWLUVMUVNYTUVOAFGJUV
        QOXNXO $.
    $}

    prmind.7 $e |- ( x e. Prime -> ph ) $.
    prmind.8 $e |- ( ( y e. ( ZZ>= ` 2 ) /\ z e. ( ZZ>= ` 2 ) ) ->
      ( ( ch /\ th ) -> ta ) ) $.
    $( Perform induction over the multiplicative structure of ` NN ` .  If a
       property ` ph ( x ) ` holds for the primes and ` 1 ` and is preserved
       under multiplication, then it holds for every natural number.
       (Contributed by Mario Carneiro, 20-Jun-2015.) $)
    prmind $p |- ( A e. NN -> et ) $=
      ( c1 co cv cprime wcel cmin cfz wral adantr prmind2 ) ABCDEFGHIJKLMNOPGUA
      ZUBUCACHSUISUDTUETUFQUGRUH $.
  $}

  ${
    $d M m $.  $d P m $.
    $( If ` M ` divides a prime, then ` M ` is either the prime or one.
       (Contributed by Scott Fenton, 8-Apr-2014.) $)
    dvdsprime $p |- ( ( P e. Prime /\ M e. NN ) ->
       ( M || P <-> ( M = P \/ M = 1 ) ) ) $=
      ( vm cprime wcel cn wa cdivides wbr wceq c1 wo c2 cuz wi breq1 syl adantr
      eqeq1 syl5ibrcom cfv cv wral isprm2 orbi12d orcom imbi12d rspccva adantll
      syl6bb sylanb cz prmz iddvds 1dvds jaod impbid ) ADEZBFEZGZBAHIZBAJZBKJZL
      ZURAMNUAEZCUBZAHIZVFKJZVFAJZLZOZCFUCZGUSVAVDOZCAUDVLUSVMVEVKVMCBFVFBJZVGV
      AVJVDVFBAHPVNVJVCVBLVDVNVHVCVIVBVFBKSVFBASUEVCVBUFUJUGUHUIUKUTVBVAVCUTVAV
      BAAHIZURVOUSURAULEZVOAUMZAUNQRBAAHPTUTVAVCKAHIZURVRUSURVPVRVQAUOQRBKAHPTU
      PUQ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A product of two integers greater than one is composite.  (Contributed
       by Mario Carneiro, 20-Jun-2015.) $)
    nprm $p |- ( ( A e. ( ZZ>= ` 2 ) /\ B e. ( ZZ>= ` 2 ) ) ->
        -. ( A x. B ) e. Prime ) $=
      ( vx c2 wcel cz eluzelz adantr zred c1 clt wbr cn eluz2b2 adantl cdivides
      simprbi cr wceq wi cuz cfv wa cmul co wne cprime wn cc0 wb simplbi nngt0d
      ltmulgt11 syl3anc mpbid ltned dvdsmul1 syl2an cv wral breq1 eqeq1 imbi12d
      isprm4 rspcv syl5 mpid necon3ad mpd ) ADUAUBZEZBVJEZUCZAABUDUEZUFVNUGEZUH
      VMAVNVMAVKAFEZVLDAGZHIZVMJBKLZAVNKLZVLVSVKVLBMEVSBNQOVMAREBREUIAKLVSVTUJV
      RVMBVLBFEZVKDBGZOIVMAVKAMEZVLVKWCJAKLANUKHULABUMUNUOUPVMVOAVNVMVOAVNPLZAV
      NSZVKVPWAWDVLVQWBABUQURVKVOWDWETZTVLVOCUSZVNPLZWGVNSZTZCVJUTZVKWFVOVNVJEW
      KCVNVDQWJWFCAVJWGASWHWDWIWEWGAVNPVAWGAVNVBVCVEVFHVGVHVI $.
  $}

  ${
    $d x A $.  $d x N $.
    nprmi.1 $e |- A e. NN $.
    nprmi.2 $e |- B e. NN $.
    nprmi.3 $e |- 1 < A $.
    nprmi.4 $e |- 1 < B $.
    nprmi.5 $e |- ( A x. B ) = N $.
    $( An inference for compositeness.  (Contributed by Mario Carneiro,
       18-Feb-2014.)  (Revised by Mario Carneiro, 20-Jun-2015.) $)
    nprmi $p |- -. N e. Prime $=
      ( cmul co cprime wcel cn c1 clt wbr wn wa c2 eluz2b2 nprm syl2anbr eleq1i
      cuz cfv mp4an mtbi ) ABIJZKLZCKLAMLZNAOPZBMLZNBOPZUIQZDFEGUJUKRASUDUEZLBU
      OLUNULUMRATBTABUAUBUFUHCKHUCUG $.
  $}

  $( 2 is a prime number.  (Contributed by Paul Chapman, 22-Jun-2011.)  (Proof
     shortened by Fan Zheng, 16-Jun-2016.) $)
  2prm $p |- 2 e. Prime $=
    ( vz c2 cprime wcel cuz cfv cv cdivides wbr wn c1 cmin co cfz wral mpbir2an
    cz clt 2z c0 1lt2 eluz2b1 ral0 cin wss wceq fzssuz df-ss mpbi uzdisj eqtr3i
    raleqi mpbir isprm3 ) BCDBBEFZDZAGBHIJZABBKLMZNMZOZUPBQDKBRISUABUBPUTUQATOU
    QAUCUQAUSTUSUOUDZUSTUSUOUEVAUSUFBURUGUSUOUHUIBBUJUKULUMABUNP $.

  $( 3 is a prime number.  (Contributed by Paul Chapman, 22-Jun-2011.) $)
  3prm $p |- 3 e. Prime $=
    ( vz c3 cprime wcel c2 cuz cfv cv cdivides wbr wn c1 cmin cfz wral mpbir2an
    co cz clt 2z 3nn nnzi 1lt3 eluz2b1 wceq elfz1eq caddc iddvds cn wi 2nn 1lt2
    ndvdsp1 mp3an mp2b breq2i mtbir breq1 mtbiri syl 3m1e2 oveq2i eleq2s isprm3
    df-3 rgen ) BCDBEFGDZAHZBIJZKZAEBLMQZNQZOVGBRDLBSJBUAUBUCBUDPVJAVLVJVHEENQZ
    VLVHVMDVHEUEZVJVHEUFVNVIEBIJZVOEELUGQZIJZERDZEEIJZVQKZTEUHVREUIDLESJVSVTUJT
    UKULEEUMUNUOBVPEIVEUPUQVHEBIURUSUTVKEENVAVBVCVFABVDP $.

  ${
    $d P x $.
    $( A prime number is an integer greater than or equal to 2.  (Contributed
       by Paul Chapman, 17-Nov-2012.) $)
    prmuz2 $p |- ( P e. Prime -> P e. ( ZZ>= ` 2 ) ) $=
      ( vx cprime wcel c2 cuz cfv cv cdivides wbr wceq wi wral isprm4 simplbi )
      ACDAEFGZDBHZAIJQAKLBPMBANO $.
  $}

  ${
    $d x A $.  $d x N $.
    $( A square is never prime.  (Contributed by Mario Carneiro,
       20-Jun-2015.) $)
    sqnprm $p |- ( A e. ZZ -> -. ( A ^ 2 ) e. Prime ) $=
      ( cz wcel c2 cexp co cprime cfv wa cr adantr syl recnd c1 clt wbr eluz2b1
      cc0 cle syl2anc cabs cmul zre absresq abscld sqvald eqtr3d simpr eqeltrrd
      wceq cuz wn cn0 nn0abscl nn0zd prmuz2 adantl simprbi breqtrrd syl5eqbr wb
      sq1 absge0d 1re 0le1 lt2sq mpanl12 mpbird sylanbrc nprm pm2.65da ) ABCZAD
      EFZGCZAUAHZVOUBFZGCZVLVNIZVMVPGVRVODEFZVMVPVRAJCZVSVMUJVLVTVNAUCKZAUDLZVR
      VOVRVOVRAVRAWAMZUEZMUFUGVLVNUHUIVRVODUKHZCZWFVQULVRVOBCNVOOPZWFVRVOVLVOUM
      CVNAUNKUOVRWGNDEFZVSOPZVRWHNVSOVBVRNVMVSOVRVMWECZNVMOPZVNWJVLVMUPUQWJVMBC
      WKVMQURLWBUSUTVRVOJCZRVOSPZWGWIVAZWDVRAWCVCNJCRNSPWLWMIWNVDVENVOVFVGTVHVO
      QVIZWOVOVOVJTVK $.
  $}

  ${
    $d N z $.  $d P z $.
    $( An integer greater than or equal to 2 divides a prime number iff it is
       equal to it.  (Contributed by Paul Chapman, 26-Oct-2012.) $)
    dvdsprm $p |- ( ( N e. ( ZZ>= ` 2 ) /\ P e. Prime ) ->
                    ( N || P <-> N = P ) ) $=
      ( vz c2 cuz cfv wcel cprime wa cdivides wbr wceq wi cv wral simprbi breq1
      isprm4 eqeq1 imbi12d rspcv mpan9 ancoms cz eluzelz iddvds breq2 syl5ibcom
      syl adantr impbid ) BDEFZGZAHGZIBAJKZBALZUNUMUOUPMZUNCNZAJKZURALZMZCULOZU
      MUQUNAULGVBCARPVAUQCBULURBLUSUOUTUPURBAJQURBASTUAUBUCUMUPUOMZUNUMBUDGZVCD
      BUEVDBBJKUPUOBUFBABJUGUHUIUJUK $.
  $}

  ${
    $d N z $.  $d P z $.
    $( A prime number either divides an integer or is coprime to it, but not
       both.  (Contributed by Paul Chapman, 22-Jun-2011.) $)
    coprm $p |- ( ( P e. Prime /\ N e. ZZ ) ->
                  ( -. P || N <-> ( P gcd N ) = 1 ) ) $=
      ( vz wcel cz wa cdivides wbr wn c1 sylan simprd breq1 wo cn cc0 adantr wi
      wceq cr cprime cgcd co prmz gcddvds syl5ibcom con3d 0nnn prmnn eleq1 mtoi
      intnanrd gcdn0cl ex mpd simpld cv c2 cuz cfv isprm2 simprbi eqeq1 orbi12d
      wral imbi12d rspcv syl5com mp2d biorf orcom syl6bb syl5ibrcom cle clt wne
      syld iddvds syl w3a dvdslegcd 3anidm12 mpand eluz2b1 sylib zred nnred 1re
      prmuz2 ltletr mp3an1 syl2anc ltneOLD 3expia sylancr 3syld necon2bd impbid
      ) AUADZBEDZFZABGHZIZABUBUCZJSZXAXCXDASZIZXEXAXFXBXAXDBGHZXFXBXAXDAGHZXHWS
      AEDZWTXIXHFAUDZABUEKZLXDABGMUFUGXAXEXGXEXFNZXAXDODZXIXMXAAPSZBPSZFIZXNWSX
      QWTWSXOXPWSXOPODZUHWSAODXOXRAUIAPOUJUFUKULQZWSXJWTXQXNRXKXJWTFXQXNABUMUNK
      UOZXAXIXHXLUPWSXNXIXMRZRWTWSCUQZAGHZYBJSZYBASZNZRZCOVEZXNYAWSAURUSUTDZYHC
      AVAVBYGYACXDOYBXDSZYCXIYFXMYBXDAGMYJYDXEYEXFYBXDJVCYBXDAVCVDVFVGVHQVIXGXE
      XFXENXMXFXEVJXFXEVKVLVMVQXAXBXDJXAXBAXDVNHZJXDVOHZXDJVPZXAAAGHZXBYKWSYNWT
      WSXJYNXKAVRVSQXAXQYNXBFYKRZXSWSXJWTXQYORZXKXJWTYPXJXJWTVTXQYOAABWAUNWBKUO
      WCXAJAVOHZYKYLWSYQWTWSXJYQWSYIXJYQFAWIAWDWELQXAATDZXDTDZYQYKFYLRZWSYRWTWS
      AXKWFQXAXDXTWGZJTDZYRYSYTWHJAXDWJWKWLWCXAUUBYSYLYMRWHUUAUUBYSYLYMJXDWMWNW
      OWPWQWR $.
  $}

  $( Unequal prime numbers are relatively prime.  (Contributed by Mario
     Carneiro, 23-Feb-2014.) $)
  prmrp $p |- ( ( P e. Prime /\ Q e. Prime ) ->
                ( ( P gcd Q ) = 1 <-> P =/= Q ) ) $=
    ( cprime wcel wa cdivides wbr wn cgcd co c1 wceq cz wb prmz coprm sylan2 c2
    wne cuz cfv prmuz2 dvdsprm sylan necon3bbid bitr3d ) ACDZBCDZEZABFGZHZABIJK
    LZABSUHUGBMDUKULNBOABPQUIUJABUGARTUADUHUJABLNAUBBAUCUDUEUF $.

  $( If an integer divides the product of two integers and is coprime to one of
     them, then it divides the other.  (Contributed by Paul Chapman,
     22-Jun-2011.) $)
  coprmdvds $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                    ( ( K || ( M x. N ) /\ ( K gcd M ) = 1 ) -> K || N ) ) $=
    ( cz wcel cmul co cdivides wbr cgcd c1 wceq wi wa zcn ancoms 3adant2 adantr
    cc cabs w3a mulcom syl2an 3adant1 breq2d simp1 zmulcl dvdsgcd syl3anc mpand
    dvdsmul2 sylbid cfv absmulgcd 3coml oveq2 mulid1d sylan9eqr 3ad2antl3 eqtrd
    fveq2d wb dvdsabsb bitr4d sylibd ex com23 imp3a ) ADEZBDEZCDEZUAZABCFGZHIZA
    BJGZKLZACHIZVLVPVNVQVLVPVNVQMVLVPNZVNACAFGZCBFGZJGZHIZVQVLVNWBMVPVLVNAVTHIZ
    WBVLVMVTAHVJVKVMVTLZVIVJBSECSEWDVKBOCOZBCUBUCUDUEVLAVSHIZWCWBVIVKWFVJVKVIWF
    CAUKPQVLVIVSDEZVTDEZWFWCNWBMVIVJVKUFVIVKWGVJVKVIWGCAUGPQVJVKWHVIVKVJWHCBUGP
    UDAVSVTUHUIUJULRVRWBACTUMZHIZVQVRWAWIAHVRWACVOFGZTUMZWIVLWAWLLZVPVKVIVJWMCA
    BUNUORVKVIVPWLWILVJVKVPNWKCTVPVKWKCKFGCVOKCFUPVKCWEUQURVAUSUTUEVLVQWJVBZVPV
    IVKWNVJACVCQRVDVEVFVGVH $.

  ${
    $d x K $.  $d x M $.  $d x N $.
    $( If an integer is divisible by two coprime integers, then it is divisible
       by their product.  (Contributed by Mario Carneiro, 24-Feb-2014.) $)
    coprmdvds2 $p |- ( ( ( M e. ZZ /\ N e. ZZ /\ K e. ZZ ) /\
                         ( M gcd N ) = 1 ) ->
                       ( ( M || K /\ N || K ) -> ( M x. N ) || K ) ) $=
      ( vx cz wcel w3a cgcd co wceq wa cdivides wbr cmul wi cc zcn sylbid breq2
      syl3anc c1 cv wrex wb divides 3adant1 adantr simprr simpl2 mulcom syl2anc
      syl2an breq2d simprl simpl1 coprmdvds mpan2d dvdsmulc syl5ibcom rexlimdva
      syld imbi12d anassrs com23 imp3a ) BEFZCEFZAEFZGZBCHIUAJZKZBALMZCALMZBCNI
      ZALMZVKVMVLVOVKVMDUBZCNIZAJZDEUCZVLVOOZVIVMVSUDZVJVGVHWAVFDCAUEUFUGVKVRVT
      DEVIVJVPEFZVRVTOVIVJWBKZKZBVQLMZVNVQLMZOVRVTWDWEBVPLMZWFWDWEBCVPNIZLMZWGW
      DVQWHBLWDWBVGVQWHJZVIVJWBUHZVFVGVHWCUIZWBVPPFCPFWJVGVPQCQVPCUJULUKUMWDWIV
      JWGVIVJWBUNWDVFVGWBWIVJKWGOVFVGVHWCUOZWLWKBCVPUPTUQRWDVFWBVGWGWFOWMWKWLCB
      VPURTVAVRWEVLWFVOVQABLSVQAVNLSVBUSVCUTRVDVE $.
  $}

  $( One half of ~ rpmulgcd2 , which does not need the coprimality assumption.
     (Contributed by Mario Carneiro, 2-Jul-2015.) $)
  mulgcddvds $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
      ( K gcd ( M x. N ) ) || ( ( K gcd M ) x. ( K gcd N ) ) ) $=
    ( cz wcel cmul co cgcd cdivides wbr wa zmulcld nn0zd adantr syl2anc syl3anc
    cc0 wi mpd wb w3a simp1 simp2 simp3 gcdcld dvds0 syl oveq2 nn0cnd sylan9eqr
    wceq mul01d breqtrrd wne cdiv zcnd simpr divcan1d gcddvds simpld dvdsmultr1
    eqbrtrd simprd dvdsmultr2 dvdsgcd mp2and dvdsval2 mpbid dvdsmulcr syl112anc
    cabs cfv cn0 nn0abscl iddvds dvdsabsb dvdsmulc dvdstr nn0red nn0ge0d absidd
    oveq2d absmuld mulgcd 3eqtr4d mpbird eqbrtrrd pm2.61dane ) ADEZBDEZCDEZUAZA
    BCFGZHGZABHGZACHGZFGZIJWPQWLWPQUKZKWNQWQIWLWNQIJZWRWLWNDEZWSWLWNWLAWMWIWJWK
    UBZWLBCWIWJWKUCZWIWJWKUDZLZUEMZWNUFUGNWRWLWQWOQFGQWPQWOFUHWLWOWLWOWLABXAXBU
    EZUIULUJUMWLWPQUNZKZWNWPUOGZWPFGZWNWQIXHWNWPXHWNWLWTXGXENZUPXHWPWLWPDEZXGWL
    WPWLACXAXCUEZMZNZUPWLXGUQZURZXHXIWOIJZXJWQIJZXHXIAIJZXIBIJZXRXHXJAWPFGZIJZX
    TXHXJWNYBIXQWLWNYBIJZXGWLWNAIJZYDWLYEWNWMIJZWLWIWMDEZYEYFKXAXDAWMUSOZUTZWLW
    TWIXLYEYDRXEXAXNWNAWPVAPSNVBXHXIDEZWIXLXGYCXTTXHWPWNIJZYJWLYKXGWLWPAIJZWPWM
    IJZYKWLYLWPCIJZWLWIWKYLYNKXAXCACUSOZUTWLYNYMWLYLYNYOVCWLXLWJWKYNYMRXNXBXCWP
    BCVDPSWLXLWIYGYLYMKYKRXNXAXDWPAWMVEPVFNXHXLXGWTYKYJTXOXPXKWPWNVGPVHZWLWIXGX
    ANZXOXPWPXIAVIVJVHXHXJBWPFGZIJZYAXHXJWNYRIXQWLWNYRIJZXGWLYTWNYRVKVLZIJZWLWN
    BVKVLZAFGZUUCCFGZHGZUUAIWLWNUUDIJZWNUUEIJZWNUUFIJZWLYEUUGYIWLWTUUCDEZWIYEUU
    GRXEWLUUCWLWJUUCVMEZXBBVNUGZMZXAWNUUCAVDPSWLYFWMUUEIJZUUHWLYEYFYHVCWLBUUCIJ
    ZUUNWLBBIJZUUOWLWJUUPXBBVOUGWLWJWJUUPUUOTXBXBBBVPOVHWLWJUUJWKUUOUUNRXBUUMXC
    CBUUCVQPSWLWTYGUUEDEZYFUUNKUUHRXEXDWLUUCCUUMXCLZWNWMUUEVRPVFWLWTUUDDEUUQUUG
    UUHKUUIRXEWLUUCAUUMXALUURWNUUDUUEVEPVFWLUUCWPVKVLZFGUUCWPFGZUUAUUFWLUUSWPUU
    CFWLWPWLWPXMVSWLWPXMVTWAWBWLBWPWLBXBUPWLWPXMUIWCWLUUKWIWKUUFUUTUKUULXAXCUUC
    ACWDPWEUMWLWTYRDEYTUUBTXEWLBWPXBXNLWNYRVPOWFNVBXHYJWJXLXGYSYATYPWLWJXGXBNZX
    OXPWPXIBVIVJVHXHYJWIWJXTYAKXRRYPYQUVAXIABVEPVFXHYJWODEZXLXRXSRYPWLUVBXGWLWO
    XFMNXOWPXIWOVQPSWGWH $.

  $( If ` M ` is relatively prime to ` N ` , then the GCD of ` K ` with
     ` M x. N ` is the product of the GCDs with ` M ` and ` N ` respectively.
     (Contributed by Mario Carneiro, 2-Jul-2015.) $)
  rpmulgcd2 $p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\
                ( M gcd N ) = 1 ) ->
      ( K gcd ( M x. N ) ) = ( ( K gcd M ) x. ( K gcd N ) ) ) $=
    ( cz wcel cgcd co wceq cmul cn0 cdivides wbr zmulcld gcdcld gcddvds syl3anc
    c1 wa wi mp2and w3a simpl1 simpl2 simpl3 nn0mulcld mulgcddvds adantr simpld
    syl2anc nn0zd simprd dvdstr dvdsgcd simpr breqtrd wb dvds1 mpbid coprmdvds2
    syl syl31anc dvdscmul dvdsmulc syl2and dvdseq syl22anc ) ADEZBDEZCDEZUAZBCF
    GZQHZRZABCIGZFGZJEABFGZACFGZIGZJEVOVRKLZVRVOKLZVOVRHVMAVNVGVHVIVLUBZVMBCVGV
    HVIVLUCZVGVHVIVLUDZMZNVMVPVQVMABWAWBNZVMACWAWCNZUEVJVSVLABCUFUGVMVRAKLZVRVN
    KLZVTVMVPAKLZVQAKLZWGVMWIVPBKLZVMVGVHWIWKRWAWBABOUIZUHVMWJVQCKLZVMVGVIWJWMR
    WAWCACOUIZUHVMVPDEZVQDEZVGVPVQFGZQHZWIWJRWGSVMVPWEUJZVMVQWFUJZWAVMWQQKLZWRV
    MWQVKQKVMWQBKLZWQCKLZWQVKKLZVMWQVPKLZWKXBVMXEWQVQKLZVMWOWPXEXFRWSWTVPVQOUIZ
    UHVMWIWKWLUKZVMWQDEZWOVHXEWKRXBSVMWQVMVPVQWSWTNZUJZWSWBWQVPBULPTVMXFWMXCVMX
    EXFXGUKVMWJWMWNUKZVMXIWPVIXFWMRXCSXKWTWCWQVQCULPTVMXIVHVIXBXCRXDSXKWBWCWQBC
    UMPTVJVLUNUOVMWQJEXAWRUPXJWQUQUTURAVPVQUSVATVMWMWKWHXLXHVMWMVRVPCIGZKLZWKXM
    VNKLZWHVMWPVIWOWMXNSWTWCWSVPVQCVBPVMWOVHVIWKXOSWSWBWCCVPBVCPVMVRDEZXMDEVNDE
    ZXNXORWHSVMVPVQWSWTMZVMVPCWSWCMWDVRXMVNULPVDTVMXPVGXQWGWHRVTSXRWAWDVRAVNUMP
    TVOVRVEVF $.

  $( Two equal reduced fractions have the same numerator and denominator.
     (Contributed by Jeff Hankins, 29-Sep-2013.) $)
  qredeq $p |- ( ( ( M e. ZZ /\ N e. NN /\ ( M gcd N ) = 1 ) /\ ( P e. ZZ
    /\ Q e. NN /\ ( P gcd Q ) = 1 ) /\ ( M / N ) = ( P / Q ) ) -> ( M = P /\
    N = Q ) ) $=
    ( cz wcel cgcd co c1 wceq wa cmul adantr adantl 3adant3 3ad2ant2 syl2an wbr
    cc cdivides cn w3a cdiv zcn nncn cc0 wne nnne0 divcld mulcand eqeq1d bitr3d
    divcan2d 3ad2ant1 mulcl mulcan2d mulassd divcan1d oveq2d eqtrd eqeq2d bitrd
    cle nnz simp2 simpl1 3jca simp1 dvdsmul1 simpr breqtrrd gcdcom sylan ancoms
    anim12i simp3 ad2antrr coprmdvds sylc dvdsle simpr1 dvdsmul2 mulcom breqtrd
    jca ad2antlr nnre letri3d mpbir2and oveq2 anbi2d biimpa syl6bir com12 ancrd
    cr mpd ex sylbid 3impia ) CEFZDUAFZCDGHZIJZUBZAEFZBUAFZABGHZIJZUBZCDUCHZABU
    CHZJZCAJZDBJZKZXEXJKZXMCBLHZDALHZJZXPXQXMCDXLLHZJZXTXQDXKLHZYAJXMYBXQXKXLDX
    EXKSFZXJXAXBYDXDXAXBKZCDXACSFZXBCUDZMZXBDSFZXADUEZNZXBDUFUGZXADUHZNZUIOMXJX
    LSFZXEXFXGYOXIXFXGKZABXFASFZXGAUDZMZXGBSFZXFBUEZNZXGBUFUGZXFBUHZNZUIOZNZXEY
    IXJXBXAYIXDYJPZMZXEYLXJXBXAYLXDYMPMZUJXQYCCYAXEYCCJZXJXAXBUUKXDYECDYHYKYNUM
    OMUKULXQXRYABLHZJYBXTXQCYABXEYFXJXAXBYFXDYGUNMZXEYIYOYASFXJUUHUUFDXLUOQXJYT
    XEXGXFYTXIUUAPNZXJUUCXEXGXFUUCXIUUDPNUPXQUULXSXRXQUULDXLBLHZLHXSXQDXLBUUIUU
    GUUNUQXQUUOADLXJUUOAJZXEXFXGUUPXIYPABYSUUBUUEURONUSUTVAULVBXQXTXPXQXTKZXOXP
    UUQXODBVCRZBDVCRZUUQDEFZXGKZDBTRZUURXQUVAXTXEUUTXJXGXBXAUUTXDDVDZPZXFXGXIVE
    VOMUUQUUTXABEFZUBZDXRTRZDCGHZIJZKUVBXQUVFXTXQUUTXAUVEXEUUTXJUVDMZXAXBXDXJVF
    XJUVEXEXGXFUVEXIBVDZPZNZVGMUUQUVGUVIUUQDXSXRTXQDXSTRZXTXEUUTXFUVNXJUVDXFXGX
    IVHDAVIQMXQXTVJZVKXEUVIXJXTXEUVHXCIXAXBUVHXCJZXDXBXAUVPXBUUTXAUVPUVCDCVLVMV
    NOXAXBXDVPUTVQWEDCBVRVSDBVTVSUUQUVEXBKZBDTRZUUSXQUVQXTXJXEUVQXJUVEXEXBUVLXA
    XBXDVEVOVNMUUQUVEXFUUTUBZBADLHZTRZBAGHZIJZKUVRXQUVSXTXQUVEXFUUTUVMXEXFXGXIW
    AUVJVGMUUQUWAUWCUUQBXRUVTTXQBXRTRZXTXEXAUVEUWDXJXAXBXDVHUVLCBWBQMUUQXRXSUVT
    UVOXQXSUVTJZXTXEYIYQUWEXJUUHXFXGYQXIYRUNZDAWCQMUTWDXJUWCXEXTXJUWBXHIXFXGUWB
    XHJZXIXGXFUWGXGUVEXFUWGUVKBAVLVMVNOXFXGXIVPUTWFWEBADVRVSBDVTVSUUQDBXEDWPFZX
    JXTXBXAUWHXDDWGPVQXJBWPFZXEXTXGXFUWIXIBWGPWFWHWIUUQXOXNXOUUQXNXOUUQXQCDLHZX
    SJZKXNXOUWKXTXQXOUWJXRXSDBCLWJUKWKXQUWKXNXQUWKDCLHZXSJXNXQUWJUWLXSXEUWJUWLJ
    ZXJXAXBUWMXDXAYFYIUWMXBYGYJCDWCQOMUKXQCADUUMXJYQXEUWFNUUIUUJUJVBWLWMWNWOWQW
    RWSWT $.

  ${
    $d k n x y z A $.
    $( Every rational number has a unique reduced form.  (Contributed by Jeff
       Hankins, 29-Sep-2013.) $)
    qredeu $p |- ( A e. QQ -> E! x e. ( ZZ X. NN ) ( ( ( 1st ` x ) gcd ( 2nd `
    x ) ) = 1 /\ A = ( ( 1st ` x ) / ( 2nd ` x ) ) ) ) $=
      ( vz vn vy cv cdiv co wceq cn cz c1st cgcd c1 wcel wbr cc0 adantl oveq12d
      wa wrex cfv c2nd cxp wral wreu w3a cop cdivides nnz gcddvds simpld sylan2
      wi cq wne wb cn0 gcdcl nn0zd wn simpl neneqd intnand gcdn0cl syl21anc syl
      nnne0 dvdsval2 syl3anc mpbid 3adant3 clt simprd nnre nn0red nngt0 divgt0d
      cr jca elnnz sylibr opelxpi syl2anc gcdcld nn0cnd ax-1cn a1i cmul mulid1d
      cc adantr divcan2d nncn mulgcd 3eqtr2rd mulcanad divcan7d eqeq2d biimp3ar
      zcn ovex op1std op2ndd eqeq1d anbi12d rspcev syl12anc elxp6 simprl simprr
      ad2antrr simprll ad2antlr simprrl simprlr simprrr eqtr3d qredeq syl331anc
      fvex simplll simplrl 3eqtr4d ex syl2anb rgen2a jctir 3expia rexlimivv elq
      opth fveq2 reu4 3imtr4i ) BCFZDFZGHZIZDJUACKUAAFZLUBZYTUCUBZMHZNIZBUUAUUB
      GHZIZTZAKJUDZUAZUUGEFZLUBZUUJUCUBZMHZNIZBUUKUULGHZIZTZTZYTUUJIZUNZEUUHUEA
      UUHUEZTZBUOOUUGAUUHUFYSUVBCDKJYPKOZYQJOZYSUVBUVCUVDYSUGZUUIUVAUVEYPYPYQMH
      ZGHZYQUVFGHZUHZUUHOZUVGUVHMHZNIZBUVGUVHGHZIZUUIUVEUVGKOZUVHJOZUVJUVCUVDUV
      OYSUVCUVDTZUVFYPUIPZUVOUVDUVCYQKOZUVRYQUJZUVCUVSTZUVRUVFYQUIPZYPYQUKZULUM
      UVQUVFKOZUVFQUPZUVCUVRUVOUQUVQUVFUVDUVCUVSUVFUROZUVTYPYQUSUMZUTZUVQUVFJOZ
      UWEUVQUVCUVSYPQIZYQQIZTVAZUWIUVCUVDVBZUVDUVSUVCUVTRZUVDUWLUVCUVDUWKUWJUVD
      YQQYQVHZVCVDRYPYQVEVFZUVFVHVGZUWMUVFYPVIVJVKZVLUVEUVHKOZQUVHVMPZTZUVPUVCU
      VDUXAYSUVQUWSUWTUVQUWBUWSUVDUVCUVSUWBUVTUWAUVRUWBUWCVNUMUVQUWDUWEUVSUWBUW
      SUQUWHUWQUWNUVFYQVIVJVKZUVQYQUVFUVDYQVSOUVCYQVORUVQUVFUWGVPUVDQYQVMPUVCYQ
      VQRUVQUWIQUVFVMPUWPUVFVQVGVRVTVLUVHWAWBUVGUVHKJWCWDUVCUVDUVLYSUVQUVKNUVFU
      VQUVKUVQUVGUVHUWRUXBWEWFNWKOUVQWGWHUVQUVFUWGWFZUWQUVQUVFNWIHUVFUVFUVGWIHZ
      UVFUVHWIHZMHZUVFUVKWIHZUVQUVFUXCWJUVQUXDYPUXEYQMUVQYPUVFUVCYPWKOUVDYPXAWL
      ZUXCUWQWMUVQYQUVFUVDYQWKOUVCYQWNRZUXCUWQWMSUVQUWFUVOUWSUXFUXGIUWGUWRUXBUV
      FUVGUVHWOVJWPWQVLUVCUVDUVNYSUVQUVMYRBUVQYPYQUVFUXHUXIUXCUVDYQQUPUVCUWORUW
      QWRWSWTUUGUVLUVNTAUVIUUHYTUVIIZUUDUVLUUFUVNUXJUUCUVKNUXJUUAUVGUUBUVHMUVGU
      VHYTYPUVFGXBZYQUVFGXBZXCZUVGUVHYTUXKUXLXDZSXEUXJUUEUVMBUXJUUAUVGUUBUVHGUX
      MUXNSWSXFXGXHUUTAEUUHYTUUHOYTUUAUUBUHZIZUUAKOZUUBJOZTZTZUUJUUKUULUHZIZUUK
      KOZUULJOZTZTZUUTUUJUUHOYTKJXIUUJKJXIUXTUYFTZUURUUSUYGUURTZUXOUYAYTUUJUYHU
      UAUUKIUUBUULITZUXOUYAIUYHUXQUXRUUDUYCUYDUUNUUEUUOIUYIUXTUXQUYFUURUXPUXQUX
      RXJXLUXTUXRUYFUURUXPUXQUXRXKXLUYGUUDUUFUUQXMUYFUYCUXTUURUYBUYCUYDXJXNUYFU
      YDUXTUURUYBUYCUYDXKXNUYGUUGUUNUUPXOUYHBUUEUUOUYGUUDUUFUUQXPUYGUUGUUNUUPXQ
      XRUUKUULUUAUUBXSXTUUAUUBUUKUULYTLYAYTUCYAYLWBUXPUXSUYFUURYBUXTUYBUYEUURYC
      YDYEYFYGYHYIYJCDBYKUUGUUQAEUUHUUSUUDUUNUUFUUPUUSUUCUUMNUUSUUAUUKUUBUULMYT
      UUJLYMZYTUUJUCYMZSXEUUSUUEUUOBUUSUUAUUKUUBUULGUYJUYKSWSXFYNYO $.
  $}

  $( Euclid's lemma.  A prime number divides the product of two integers iff it
     divides at least one of them.  (Contributed by Paul Chapman,
     17-Nov-2012.) $)
  euclemma $p |- ( ( P e. Prime /\ M e. ZZ /\ N e. ZZ ) ->
                        ( P || ( M x. N ) <-> ( P || M \/ P || N ) ) ) $=
    ( cprime wcel cz w3a cmul co cdivides wbr wo wn wi wa cgcd c1 wceq syl3an1
    wb coprm 3adant3 anbi2d prmz coprmdvds sylbid exp3a df-or syl6ibr ordvdsmul
    impbid ) ADEZBFEZCFEZGZABCHIJKZABJKZACJKZLZUOUPUQMZURNUSUOUPUTURUOUPUTOUPAB
    PIQRZOZURUOUTVAUPULUMUTVATUNABUAUBUCULAFEZUMUNVBURNAUDZABCUESUFUGUQURUHUIUL
    VCUMUNUSUPNVDABCUJSUK $.

  ${
    $d x y z P $.
    $( A number is prime iff it satisfies Euclid's lemma ~ euclemma .
       (Contributed by Mario Carneiro, 6-Sep-2015.) $)
    isprm6 $p |- ( P e. Prime <-> ( P e. ( ZZ>= ` 2 ) /\ A. x e. ZZ
          A. y e. ZZ ( P || ( x x. y ) -> ( P || x \/ P || y ) ) ) ) $=
      ( vz wcel cmul co cdivides wbr wo wi cz wa wb c1 wceq clt adantr ad2antrl
      cn cprime c2 cuz cfv cv prmuz2 euclemma 3expb biimpd ralrimivva jca simpl
      wral cdiv eluz2b2 simplbi nnzd iddvds syl cc nncn nnne0 divcan1d breqtrrd
      cc0 wne simprr simprl nndivdvds syl2anc mpbid oveq1 breq2d orbi1d imbi12d
      nnz breq2 oveq2 orbi2d rspc2va sylan mpd dvdsle div1d breq1d sylibrd nnrp
      cle cr rpregt0d crp 1rp rpregt0 mp1i lediv2 syl3anc nnle1eq1 sylibd nnnn0
      cn0 simplrr simpr dvdseq syl22anc orim12d imp syldan an32s expr ralrimiva
      ex isprm2 sylanbrc impbii ) CUAEZCUBUCUDEZCAUEZBUEZFGZHIZCXQHIZCXRHIZJZKZ
      BLUMALUMZMZXOXPYECUFXOYDABLLXOXQLEZXRLEZMMXTYCXOYGYHXTYCNCXQXRUGUHUIUJUKY
      FXPDUEZCHIZYIOPZYICPZJZKZDTUMXOXPYEULYFYNDTYFYITEZYJYMXPYOYJMZYEYMXPYPMZY
      ECCYIUNGZHIZCYIHIZJZYMYQYEMCYRYIFGZHIZUUAYQUUCYEYQCCUUBHYQCLEZCCHIYQCXPCT
      EZYPXPUUEOCQICUOUPRZUQZCURUSYQCYIYQUUECUTEUUFCVAUSZYOYIUTEXPYJYIVASYOYIVE
      VFXPYJYIVBSVCVDRYQYRLEZYILEZMYEUUCUUAKZYQUUIUUJYQYRYQYJYRTEZXPYOYJVGYQUUE
      YOYJUULNUUFXPYOYJVHCYIVIVJVKZUQYOUUJXPYJYIVPSUKYDUUKCYRXRFGZHIZYSYBJZKABY
      RYILLXQYRPZXTUUOYCUUPUUQXSUUNCHXQYRXRFVLVMUUQYAYSYBXQYRCHVQVNVOXRYIPZUUOU
      UCUUPUUAUURUUNUUBCHXRYIYRFVRVMUURYBYTYSXRYICHVQVSVOVTWAWBYQUUAYMYQYSYKYTY
      LYQYSYIOWHIZYKYQYSCOUNGZYRWHIZUUSYQYSCYRWHIZUVAYQUUDUULYSUVBKUUGUUMCYRWCV
      JYQUUTCYRWHYQCUUHWDWEWFYQYIWIEVEYIQIMZOWIEVEOQIMZCWIEVECQIMUUSUVANYOUVCXP
      YJYOYIYIWGWJSOWKEUVDYQWLOWMWNYQCYQUUECWKEUUFCWGUSWJYIOCWOWPWFYOUUSYKNXPYJ
      YIWQSWRYQYTYLYQYTMYIWTEZCWTEZYJYTYLYQUVEYTYOUVEXPYJYIWSSRYQUVFYTYQUUEUVFU
      UFCWSUSRXPYOYJYTXAYQYTXBYICXCXDXKXEXFXGXHXIXJDCXLXMXN $.
  $}

  ${
    $d p x y z N $.
    $( Every integer greater than or equal to 2 has a prime factor.
       (Contributed by Paul Chapman, 26-Oct-2012.)  (Proof shortened by Mario
       Carneiro, 20-Jun-2015.) $)
    exprmfct $p |- ( N e. ( ZZ>= ` 2 ) -> E. p e. Prime p || N ) $=
      ( vx cn wcel c2 cv cdivides wbr cprime wrex c1 wceq eleq1 rexbidv imbi12d
      wi breq2 cz wa vy vz cuz cfv clt eluz2b2 simplbi cmul co imbi1d cc0 1m1e0
      cmin uz2m1nn syl5eqelr 0nnn pm2.21i syl prmz iddvds breq1 mpdan a1d simpl
      rspcev eluzelz ad2antrr ad2antlr dvdsmul1 syl2anc adantl zmulcld reximdva
      dvdstr syl3anc mpan2d embantd a1dd adantrd prmind mpcom ) ADEZAFUCUDZEZBG
      ZAHIZBJKZWDWBLAUEIAUFUGCGZWCEZWEWHHIZBJKZQLWCEZWKQUAGZWCEZWEWMHIZBJKZQZUB
      GZWCEZWEWRHIZBJKZQZWMWRUHUIZWCEZWEXCHIZBJKZQZWDWGQCUAUBAWHLMWIWLWKWHLWCNU
      JWHWMMZWIWNWKWPWHWMWCNXHWJWOBJWHWMWEHROPWHWRMZWIWSWKXAWHWRWCNXIWJWTBJWHWR
      WEHROPWHXCMZWIXDWKXFWHXCWCNXJWJXEBJWHXCWEHROPWHAMZWIWDWKWGWHAWCNXKWJWFBJW
      HAWEHROPWLUKDEZWKWLUKLLUMUIDULLUNUOXLWKUPUQURWHJEZWKWIXMWHWHHIZWKXMWHSEXN
      WHUSWHUTURWJXNBWHJWEWHWHHVAVEVBVCWNWSTZWQXGXBXOWQXFXDXOWNWPXFWNWSVDXOWOXE
      BJXOWEJEZTZWOWMXCHIZXEXQWMSEZWRSEZXRWNXSWSXPFWMVFVGZWSXTWNXPFWRVFVHZWMWRV
      IVJXQWESEZXSXCSEWOXRTXEQXPYCXOWEUSVKYAXQWMWRYAYBVLWEWMXCVNVOVPVMVQVRVSVTW
      A $.
  $}

  $( No prime number divides 1.  (Contributed by Paul Chapman, 17-Nov-2012.)
     (Proof shortened by Mario Carneiro, 2-Jul-2015.) $)
  nprmdvds1 $p |- ( P e. Prime -> -. P || 1 ) $=
    ( cprime wcel c1 cdivides wbr 1nprm wceq cn0 prmnn nnnn0d dvds1 syl biimpcd
    wb eleq1 sylbid mtoi ) ABCZADEFZDBCZGSTADHZUASAICTUBOSAAJKALMUBSUAADBPNQR
    $.

  ${
    $d x z P $.
    $( One need only check prime divisors of ` P ` up to ` sqr P ` in order to
       ensure primality.  (Contributed by Mario Carneiro, 18-Feb-2014.) $)
    isprm5 $p |- ( P e. Prime <-> ( P e. ( ZZ>= ` 2 ) /\
                    A. z e. Prime ( ( z ^ 2 ) <_ P -> -. z || P ) ) ) $=
      ( vx cprime wcel c2 cdivides wbr wceq wi wa co cle wn clt c1 cn cc0 mpbid
      cmul cuz cfv cv wral cexp isprm4 prmuz2 a1i eluz2b2 simprbi cr wb simplbi
      eluzelre nngt0d ltmulgt11 remulcld ltnled oveq12 anidms breq1d syl5ibrcom
      syl3anc notbid imim2d con2 syl6 imim12d ralimdv2 wrex annim breq1 anbi12d
      weq rspcev ancom2s expr ad2ant2lr cdiv simprl wne eluzelz ad2antlr nnne0d
      ad2antrr dvdsval2 recnd mulid2d dvdsle imp syl21anc simprr neneqad necomd
      cz ltlend mpbir2and eqbrtrd 1re zred nnre nngt0 jca syl ltmuldiv sylanbrc
      eluz2b1 crp nnmulcld nnrp rpdivcl syl2an syl2anc lemul1d divmuldivd nncnd
      divassd eqtrd divcan2d eqcomd bitr4d biimpd dvds0lem jctird ee12an letrid
      breq12d syl31anc mpjaod syl5bir rexlimdva exprmfct prmz ad2antrl ad3antlr
      ex ad3antrrr nnnn0d nn0ge0d rexnal le2msq syl22anc simplrl simplrr dvdstr
      nnnn0 letrd mp2and jc reximdva mpd 3imtr3g impcon4bid prmnn sqvald imbi1d
      syld ralbiia syl6bbr pm5.32i bitri ) BDEBFUAUBZEZAUCZBGHZUVDBIZJZAUVBUDZK
      UVCUVDFUELZBMHZUVENZJZADUDZKABUFUVCUVHUVMUVCUVHUVDUVDTLZBMHZUVKJZADUDZUVM
      UVCUVHUVQUVCUVGUVPAUVBDUVCUVDDEZUVDUVBEZUVGUVPUVRUVSJUVCUVDUGZUHUVCUVGUVE
      UVONZJUVPUVCUVFUWAUVEUVCUWAUVFBBTLZBMHZNZUVCBUWBOHZUWDUVCPBOHZUWEUVCBQEZU
      WFBUIZUJUVCBUKEZUWIRBOHUWFUWEULFBUNZUWJUVCBUVCUWGUWFUWHUMZUOBBUPVCSUVCBUW
      BUWJUVCBBUWJUWJUQURSUVFUVOUWCUVFUVNUWBBMUVFUVNUWBIUVDBUVDBTUSUTVAVDVBVEUV
      EUVOVFVGVHVIUVCUVGNZAUVBVJZUVPNZADVJZUVHNUVQNUVCUWMCUCZUWPTLZBMHZUWPBGHZK
      ZCUVBVJZUWOUVCUWLUXAAUVBUWLUVEUVFNZKZUVCUVSKZUXAUVEUVFVKUXDUXCUXAUXDUXCKZ
      UVOUXABUVNMHZUVSUVEUVOUXAJUVCUXBUVSUVEUVOUXAUVSUVOUVEUXAUWTUVOUVEKCUVDUVB
      CAVNZUWRUVOUWSUVEUXGUWQUVNBMUXGUWQUVNIUWPUVDUWPUVDTUSUTVAUWPUVDBGVLVMVOVP
      VQVRUXEBUVDVSLZUVBEZUXFUXHUXHTLZBMHZUXHBGHZKZUXAUXEUXHWOEZPUXHOHZUXIUXEUV
      EUXNUXDUVEUXBVTZUXEUVDWOEZUVDRWABWOEZUVEUXNULUVSUXQUVCUXCFUVDWBWCZUXEUVDU
      VSUVDQEZUVCUXCUVSUXTPUVDOHUVDUIUMZWCZWDZUVCUXRUVSUXCFBWBZWEZUVDBWFVCSZUXE
      PUVDTLZBOHZUXOUXEUYGUVDBOUXEUVDUXEUVDUVSUVDUKEZUVCUXCFUVDUNWCZWGZWHUXEUVD
      BOHUVDBMHZBUVDWAUXEUXQUWGUVEUYLUXSUVCUWGUVSUXCUWKWEZUXPUXQUWGKUVEUYLUVDBW
      IWJWKUXEUVDBUXEUVDBUXDUVEUXBWLWMWNUXEUVDBUYJUVCUWIUVSUXCUWJWEZWPWQWRUXEPU
      KEZUWIUYIRUVDOHZKZUYHUXOULUYOUXEWSUHUXEBUYEWTUXEUXTUYQUYBUXTUYIUYPUVDXAUV
      DXBXCXDPBUVDXEVCSUXHXGXFUXEUXFUXKUXLUXEUXFUXKUXEUXFBBUVNVSLZTLZUVNUYRTLZM
      HUXKUXEBUVNUYRUYNUXEUVDUVDUYJUYJUQZUXEUWGUVNQEZUYRXHEZUYMUXEUVDUVDUYBUYBX
      IZUWGBXHEUVNXHEVUCVUBBXJUVNXJBUVNXKXLXMXNUXEUXJUYSBUYTMUXEUXJUWBUVNVSLUYS
      UXEBUVDBUVDUXEBUYNWGZUYKVUEUYKUYCUYCXOUXEBBUVNVUEVUEUXEUVNVUDXPZUXEUVNVUD
      WDZXQXRUXEUYTBUXEBUVNVUEVUFVUGXSXTYGYAYBUXEUXQUXNUXRUVDUXHTLBIUXLUXSUYFUY
      EUXEBUVDVUEUYKUYCXSUVDUXHBYCYHYDUWTUXMCUXHUVBUWPUXHIZUWRUXKUWSUXLVUHUWQUX
      JBMVUHUWQUXJIUWPUXHUWPUXHTUSUTVAUWPUXHBGVLVMVOYEUXEUVNBVUAUYNYFYIYPYJYKUV
      CUWTUWOCUVBUVCUWPUVBEZKZUWTUWOVUJUWTKZUVDUWPGHZADVJZUWOVUIVUMUVCUWTUWPAYL
      WCVUKVULUWNADVUKUVRVULUWNVUKUVRVULKZKZUVOUVEVUOUVNUWQBVUOUVDUVDVUOUVDUVRU
      XQVUKVULUVDYMYNZWTZVUQUQVUOUWPUWPVUOUWPVUIUWPWOEZUVCUWTVUNFUWPWBYOZWTZVUT
      UQVUOBUVCUXRVUIUWTVUNUYDYQZWTVUOUVDUWPMHZUVNUWQMHZVUOUXQUWPQEZVULVVBVUPVU
      IVVDUVCUWTVUNVUIVVDPUWPOHUWPUIUMYOZVUKUVRVULWLZUXQVVDKVULVVBUVDUWPWIWJWKV
      UOUYIRUVDMHZUWPUKERUWPMHZVVBVVCULVUQUVRVVGVUKVULUVRUVSVVGUVTUVSUVDUVSUVDU
      YAYRYSXDYNVUTVUOVVDVVHVVEVVDUWPUWPUUFYSXDUVDUWPUUAUUBSVUJUWRUWSVUNUUCUUGV
      UOVULUWSUVEVVFVUJUWRUWSVUNUUDVUOUXQVURUXRVULUWSKUVEJVUPVUSVVAUVDUWPBUUEVC
      UUHUUIVQUUJUUKYPYKUUQUVGAUVBYTUVPADYTUULUUMUVLUVPADUVRUVJUVOUVKUVRUVIUVNB
      MUVRUVDUVRUVDUVDUUNXPUUOVAUUPUURUUSUUTUVA $.
  $}

  ${
    $d N x y $.  $d N y z $.  $d S x y $.
    maxprmfct.1 $e |- S = { z e. Prime | z || N } $.
    $( The set of prime factors of an integer greater than or equal to 2
       satisfies the conditions to have a supremum, and that supremum is a
       member of the set.  (Contributed by Paul Chapman, 17-Nov-2012.) $)
    maxprmfct $p |- ( N e. ( ZZ>= ` 2 ) ->
         ( ( S C_ ZZ /\ S =/= (/) /\ E. x e. ZZ A. y e. S y <_ x ) /\
         sup ( S , RR , < ) e. S ) ) $=
      ( c2 wcel cz wne cv cle wbr wral wrex cprime cdivides wex wa syl cuz csup
      cfv wss c0 w3a cr clt crab ssrab2 eqsstri prmz ssriv sstri exprmfct breq1
      elrab2 exbii n0 df-rex 3bitr4ri sylib eluzelz cn c1 eluz2b3 simplbi sylbi
      a1i anim1i wi dvdsle expcom imp3a syl5 ralrimiv wceq breq2 ralbidv rspcev
      syl2anc 3jca suprzcl2 jca ) EGUAUCHZDIUDZDUEJZBKZAKZLMZBDNZAIOZUFZDUGUHUB
      DHZWEWFWGWLWFWEDPIDCKZEQMZCPUIPFWPCPUJUKBPIWHULZUMUNVIWEWHEQMZBPOZWGEBUOW
      HDHZBRWHPHZWRSZBRWGWSWTXBBWPWRCWHPDWOWHEQUPFUQZURBDUSWRBPUTVAVBWEEIHWHELM
      ZBDNZWLGEVCWEEVDHZXEWEXFEVEJEVFVGXFXDBDWTWHIHZWRSZXFXDWTXBXHXCXAXGWRWQVJV
      HXFXGWRXDXGXFWRXDVKWHEVLVMVNVOVPTWKXEAEIWIEVQWJXDBDWIEWHLVRVSVTWAWBZWEWMW
      NXIABDWCTWD $.
  $}

  ${
    $d N m $.  $d P k m $.  $d A k m $.
    $( A prime divides a positive power of an integer iff it divides the
       integer.  (Contributed by Mario Carneiro, 24-Feb-2014.)  (Revised by
       Mario Carneiro, 17-Jul-2014.) $)
    prmdvdsexp $p |- ( ( P e. Prime /\ A e. ZZ /\ N e. NN ) ->
                       ( P || ( A ^ N ) <-> P || A ) ) $=
      ( vm vk wcel cz cn cexp co cdivides wbr wb wi c1 wceq oveq2 breq2d bibi1d
      imbi2d cprime wa cv caddc cc zcn adantl exp1d cmul cn0 nnnn0 expp1 syl2an
      wo simpll simpr zexpcl simplr euclemma bitrd orbi1 oridm syl6bb syl5ibcom
      syl3anc bibi2d expcom a2d nnind impcom 3impa ) BUAFZAGFZCHFZBACIJZKLZBAKL
      ZMZVNVLVMUBZVRVSBADUCZIJZKLZVQMZNVSBAOIJZKLZVQMZNVSBAEUCZIJZKLZVQMZNVSBAW
      GOUDJZIJZKLZVQMZNVSVRNDECVTOPZWCWFVSWOWBWEVQWOWAWDBKVTOAIQRSTVTWGPZWCWJVS
      WPWBWIVQWPWAWHBKVTWGAIQRSTVTWKPZWCWNVSWQWBWMVQWQWAWLBKVTWKAIQRSTVTCPZWCVR
      VSWRWBVPVQWRWAVOBKVTCAIQRSTVSWDABKVSAVMAUEFZVLAUFUGZUHRWGHFZVSWJWNVSXAWJW
      NNVSXAUBZWMWIVQUNZMWJWNXBWMBWHAUIJZKLZXCXBWLXDBKVSWSWGUJFZWLXDPXAWTWGUKZA
      WGULUMRXBVLWHGFZVMXEXCMVLVMXAUOVSVMXFXHXAVLVMUPXGAWGUQUMVLVMXAURBWHAUSVEU
      TWJXCVQWMWJXCVQVQUNVQWIVQVQVAVQVBVCVFVDVGVHVIVJVK $.
  $}

  $( A prime divides a positive power of another iff they are equal.
     (Contributed by Paul Chapman, 30-Nov-2012.)  (Revised by Mario Carneiro,
     24-Feb-2014.) $)
  prmdvdsexpb $p |- ( ( P e. Prime /\ Q e. Prime /\ N e. NN ) ->
                      ( P || ( Q ^ N ) <-> P = Q ) ) $=
    ( cprime wcel cn w3a cexp co cdivides wceq cz wb prmz prmdvdsexp syl3an2 c2
    wbr cuz cfv prmuz2 dvdsprm sylan 3adant3 bitrd ) ADEZBDEZCFEZGABCHIJRZABJRZ
    ABKZUGUFBLEUHUIUJMBNBACOPUFUGUJUKMZUHUFAQSTEUGULAUABAUBUCUDUE $.

  $( If a prime divides a nonnegative power of another, then they are equal.
     (Contributed by Mario Carneiro, 16-Jan-2015.) $)
  prmdvdsexpr $p |- ( ( P e. Prime /\ Q e. Prime /\ N e. NN0 ) ->
                      ( P || ( Q ^ N ) -> P = Q ) ) $=
    ( cprime wcel cn0 cexp co cdivides wbr wceq wi cn cc0 wo wa elnn0 c1 breq2d
    w3a prmdvdsexpb biimpd 3expia prmnn adantl nncnd exp0d pm2.21d adantr oveq2
    nprmdvds1 sylbid imbi1d syl5ibrcom jaod syl5bi 3impia ) ADEZBDEZCFEZABCGHZI
    JZABKZLZUTCMEZCNKZOURUSPZVDCQVGVEVDVFURUSVEVDURUSVETVBVCABCUAUBUCVGVDVFABNG
    HZIJZVCLVGVIARIJZVCVGVHRAIVGBVGBUSBMEURBUDUEUFUGSURVJVCLUSURVJVCAUKUHUIULVF
    VBVIVCVFVAVHAICNBGUJSUMUNUOUPUQ $.

  ${
    $d P z $.
    $( Two positive prime powers are equal iff the primes and the powers are
       equal.  (Contributed by Paul Chapman, 30-Nov-2012.) $)
    prmexpb $p |- ( ( ( P e. Prime /\ Q e. Prime ) /\ ( M e. NN /\ N e. NN ) )
                    -> ( ( P ^ M ) = ( Q ^ N ) <-> ( P = Q /\ M = N ) ) ) $=
      ( cprime wcel wa cn cexp co wceq w3a cdivides wbr cz prmz adantr 3ad2ant1
      wb nnzd simp2l iddvdsexp syl2anc breq2 3ad2ant3 simp1l simp1r prmdvdsexpb
      simp2r syl3anc bitrd mpbid zred c1 clt cuz cfv prmuz2 eluz2b1 simprbi syl
      c2 ad2antrr 3adant3 simp3 oveq1d eqtr4d expcand jca 3expia oveq12 impbid1
      ) AEFZBEFZGZCHFZDHFZGZGACIJZBDIJZKZABKZCDKZGZVOVRWAWDVOVRWALZWBWCWEAVSMNZ
      WBWEAOFZVPWFVOVRWGWAVMWGVNAPQRZVOVPVQWAUAZACUBUCWEWFAVTMNZWBWAVOWFWJSVRVS
      VTAMUDUEWEVMVNVQWJWBSVMVNVRWAUFVMVNVRWAUGVOVPVQWAUIZABDUHUJUKULZWEACDWEAW
      HUMWECWITWEDWKTVOVRUNAUONZWAVMWMVNVRVMAVBUPUQFZWMAURWNWGWMAUSUTVAVCVDWEVS
      VTADIJVOVRWAVEWEABDIWLVFVGVHVIVJABCDIVKVL $.
  $}

  ${
    $d P x k $.  $d N x $.
    $( The factorial of a number only contains primes less than the base.
       (Contributed by Mario Carneiro, 6-Mar-2014.) $)
    prmfac1 $p |- ( ( N e. NN0 /\ P e. Prime /\ P || ( ! ` N ) ) -> P <_ N ) $=
      ( wcel cfa cfv cdivides wbr cle wi cc0 c1 wceq fveq2 breq2d breq2 imbi12d
      imbi2d adantr cz cr vx vk cn0 cprime cv caddc co breq2i nprmdvds1 pm2.21d
      fac0 syl5bi wa wo cmul facp1 wb simpr faccl nnzd nn0p1nn euclemma syl3anc
      bitrd nn0re lep1d prmz adantl zred nnred letr mpan2d imim2d com23 syl2anc
      cn dvdsle a1dd jaod sylbid ex a2d nn0ind 3imp ) BUCCAUDCZABDEZFGZABHGZWEA
      UAUEZDEZFGZAWIHGZIZIWEAJDEZFGZAJHGZIZIWEAUBUEZDEZFGZAWRHGZIZIWEAWRKUFUGZD
      EZFGZAXCHGZIZIWEWGWHIZIUAUBBWIJLZWMWQWEXIWKWOWLWPXIWJWNAFWIJDMNWIJAHOPQWI
      WRLZWMXBWEXJWKWTWLXAXJWJWSAFWIWRDMNWIWRAHOPQWIXCLZWMXGWEXKWKXEWLXFXKWJXDA
      FWIXCDMNWIXCAHOPQWIBLZWMXHWEXLWKWGWLWHXLWJWFAFWIBDMNWIBAHOPQWOAKFGZWEWPWN
      KAFUKUHWEXMWPAUIUJULWRUCCZWEXBXGXNWEXBXGIXNWEUMZXEXBXFXOXEWTAXCFGZUNZXBXF
      IZXOXEAWSXCUOUGZFGZXQXOXDXSAFXNXDXSLWEWRUPRNXOWEWSSCXCSCXTXQUQXNWEURXOWSX
      NWSVPCWEWRUSRUTXOXCXNXCVPCZWEWRVARZUTAWSXCVBVCVDXOWTXRXPXOXBWTXFXOXAXFWTX
      OXAWRXCHGZXFXOWRXNWRTCZWEWRVERZVFXOATCYDXCTCXAYCUMXFIXOAWEASCZXNAVGVHZVIY
      EXOXCYBVJAWRXCVKVCVLVMVNXOXPXFXBXOYFYAXPXFIYGYBAXCVQVOVRVSVTVNWAWBWCWD $.
  $}

  $( Either ` A / ( A gcd B ) ` is odd or ` B / ( A gcd B ) ` is odd.
     (Contributed by Scott Fenton, 19-Apr-2014.) $)
  divgcdodd $p |- ( ( A e. NN /\ B e. NN ) ->
    ( -. 2 || ( A / ( A gcd B ) ) \/ -. 2 || ( B / ( A gcd B ) ) ) ) $=
    ( cn wcel wa c2 cgcd co cdiv cdivides wbr wn c1 nnz cc0 wceq adantr syl2anc
    cz wb wi wo cprime 2prm nprmdvds1 ax-mp gcddvds syl2an simpld anim12i nnne0
    neneqd intnanrd gcdn0cl nnzd nnne0d dvdsval2 syl3anc mpbid simprd adantl 2z
    wne dvdsgcdb mp3an1 gcddiv nncnd dividd eqtr3d breq2d biimpd sylbid expdimp
    syl31anc mtoi ex imor sylib ) ACDZBCDZEZFAABGHZIHZJKZFBWBIHZJKZLZUAWDLWGUBW
    AWDWGWAWDEWFFMJKZFUCDWHLUDFUEUFWAWDWFWHWAWDWFEZFWCWEGHZJKZWHWAWCSDZWESDZWIW
    KTZWAWBAJKZWLWAWOWBBJKZVSASDZBSDZWOWPEZVTANZBNZABUGUHZUIWAWBSDZWBOVCZWQWOWL
    TWAWBWAWQWREAOPZBOPZELZWBCDZVSWQVTWRWTXAUJVSXGVTVSXEXFVSAOAUKULUMQABUNRZUOZ
    WAWBXIUPZVSWQVTWTQZWBAUQURUSWAWPWMWAWOWPXBUTWAXCXDWRWPWMTXJXKVTWRVSXAVAZWBB
    UQURUSFSDWLWMWNVBFWCWEVDVERWAWKWHWAWJMFJWAWBWBIHZWJMWAWQWRXHWSXNWJPXLXMXIXB
    ABWBVFVNWAWBWAWBXIVGXKVHVIVJVKVLVMVOVPWDWGVQVR $.

  ${
    $d p A $.  $d p B $.  $d p N $.
    $( If two numbers ` A ` and ` B ` are relatively prime, then they are still
       relatively prime if raised to a power.  (Contributed by Mario Carneiro,
       24-Feb-2014.) $)
    rpexp $p |- ( ( A e. ZZ /\ B e. ZZ /\ N e. NN ) ->
                  ( ( ( A ^ N ) gcd B ) = 1 <-> ( A gcd B ) = 1 ) ) $=
      ( vp cz wcel cc0 wceq wa co cgcd c1 wb wi wn cdivides wbr syl2anc syl3anc
      cprime cn w3a cexp 0exp oveq1d eqeq1d oveq1 oveq12 sylan bibi12d 3ad2ant3
      syl5ibrcom c2 cuz cfv cv wrex exprmfct simpl1 simpl3 nnnn0d zexpcl adantr
      wne cn0 simpl2 gcddvds simpld prmz adantl simpr zcnd expeq0 anbi1d mtbird
      gcdn0cl syl21anc nnzd dvdstr mpan2d simpll1 prmdvdsexp sylibd simprd jcad
      cc dvdsgcd nprmdvds1 breq2 necon2ad 3syld rexlimdva 3adantl3 eluz2b3 baib
      notbid syl sylibrd syl5 iddvdsexp mp2and impbid 3bitr3d necon4bid pm2.61d
      ex ) AEFZBEFZCUAFZUBZAGHZBGHZIZACUCJZBKJZLHZABKJZLHZMZXIXGXMXSNXHXIXSXMGC
      UCJZGKJZLHZGGKJZLHZMXIYAYCLXIXTGGKCUDUEUFXMXPYBXRYDXMXOYALXKXNXTHXLXOYAHA
      GCUCUGXNXTBGKUHUIUFXMXQYCLAGBGKUHUFUJULUKXJXMOZXSXJYEIZXOLXQLYFXOUMUNUOZF
      ZXQYGFZXOLVDZXQLVDZYFYHYIYHDUPZXOPQZDTUQZYFYIXODURYFYNYKYIYFYMYKDTYFYLTFZ
      IZYMYLAPQZYLBPQZIZYLXQPQZYKYPYMYQYRYPYMYLXNPQZYQYPYMXOXNPQZUUAYPUUBXOBPQZ
      YPXNEFZXHUUBUUCIYFUUDYOYFXGCVEFUUDXGXHXIYEUSZYFCXGXHXIYEUTZVAACVBRZVCZYFX
      HYOXGXHXIYEVFZVCZXNBVGRZVHYPYLEFZXOEFZUUDYMUUBIUUANYOUULYFYLVIVJZYFUUMYOY
      FXOYFUUDXHXNGHZXLIZOXOUAFZUUGUUIYFUUPXMXJYEVKYFUUOXKXLYFAWFFXIUUOXKMYFAUU
      EVLUUFACVMRVNVOXNBVPVQZVRVCZUUHYLXOXNVSSVTYPYOXGXIUUAYQMYFYOVKXGXHXIYEYOW
      AZYFXIYOUUFVCZAYLCWBSWCYPYMUUCYRYPUUBUUCUUKWDYPUULUUMXHYMUUCIYRNUUNUUSUUJ
      YLXOBVSSVTWEYPUULXGXHYSYTNUUNUUTUUJYLABWGSYOYTYKNYFYOYTXQLYOYTOXRYLLPQZOZ
      YLWHZXRYTUVBXQLYLPWIWPULWJVJWKWLYFXQUAFZYIYKMXGXHYEUVEXIABVPWMZYIUVEYKXQW
      NWOWQZWRWSYIYTDTUQZYFYHXQDURYFUVHYJYHYFYTYJDTYPYTUUAYRIZYMYJYPYTUUAYRYPYT
      XQXNPQZUUAYPXQAPQZAXNPQZUVJYPUVKXQBPQZYPXGXHUVKUVMIUUTUUJABVGRZVHYPXGXIUV
      LUUTUVAACWTRYPXQEFZXGUUDUVKUVLIUVJNYFUVOYOYFXQUVFVRVCZUUTUUHXQAXNVSSXAYPU
      ULUVOUUDYTUVJIUUANUUNUVPUUHYLXQXNVSSVTYPYTUVMYRYPUVKUVMUVNWDYPUULUVOXHYTU
      VMIYRNUUNUVPUUJYLXQBVSSVTWEYPUULUUDXHUVIYMNUUNUUHUUJYLXNBWGSYOYMYJNYFYOYM
      XOLYOYMOXPUVCUVDXPYMUVBXOLYLPWIWPULWJVJWKWLYFUUQYHYJMUURYHUUQYJXOWNWOWQZW
      RWSXBUVQUVGXCXDXFXE $.
  $}

  $( Relative primality passes to asymmetric powers.  (Contributed by Stefan
     O'Rear, 27-Sep-2014.) $)
  rpexp1i $p |- ( ( A e. ZZ /\ B e. ZZ /\ M e. NN0 ) -> ( ( A gcd B ) = 1 -> (
      ( A ^ M ) gcd B ) = 1 ) ) $=
    ( cz wcel cn0 cgcd co c1 wceq cexp wi wa cn cc0 wo elnn0 w3a rpexp eqtrd cc
    biimprd 3expa simpr oveq2d zcn ad2antrr oveq1d 1gcd ad2antlr jaodan sylan2b
    exp0d a1d 3impa ) ADEZBDEZCFEZABGHIJZACKHZBGHZIJZLZURUPUQMZCNEZCOJZPVCCQVDV
    EVCVFUPUQVEVCUPUQVERVBUSABCSUBUCVDVFMZVBUSVGVAIBGHZIVGUTIBGVGUTAOKHIVGCOAKV
    DVFUDUEVGAUPAUAEUQVFAUFUGUMTUHUQVHIJUPVFBUIUJTUNUKULUO $.

  $( Relative primality passes to symmetric powers.  (Contributed by Stefan
     O'Rear, 27-Sep-2014.) $)
  rpexp12i $p |- ( ( A e. ZZ /\ B e. ZZ /\ ( M e. NN0 /\ N e. NN0 ) ) -> ( ( A
      gcd B ) = 1 -> ( ( A ^ M ) gcd ( B ^ N ) ) = 1 ) ) $=
    ( cz wcel cn0 wa w3a cgcd co wceq cexp rpexp1i zexpcl syl2anc gcdcom eqeq1d
    c1 wi 3adant3r simp2 simp1 simp3l simp3r syl3anc 3imtr4d syld ) AEFZBEFZCGF
    ZDGFZHZIZABJKSLZACMKZBJKZSLZUPBDMKZJKZSLZUIUJUKUOURTULABCNUAUNBUPJKZSLZUSUP
    JKZSLZURVAUNUJUPEFZULVCVETUIUJUMUBZUNUIUKVFUIUJUMUCUIUJUKULUDACOPZUIUJUKULU
    EZBUPDNUFUNUQVBSUNVFUJUQVBLVHVGUPBQPRUNUTVDSUNVFUSEFZUTVDLVHUNUJULVJVGVIBDO
    PUPUSQPRUGUH $.

  $( If ` K ` is relatively prime to ` M ` and to ` N ` , it is also relatively
     prime to their product.  (Contributed by Mario Carneiro, 24-Feb-2014.)
     (Proof shortened by Mario Carneiro, 2-Jul-2015.) $)
  rpmul $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) ->
                ( ( ( K gcd M ) = 1 /\ ( K gcd N ) = 1 ) ->
                  ( K gcd ( M x. N ) ) = 1 ) ) $=
    ( cz wcel w3a cgcd co c1 wceq wa cmul cdivides wbr mulgcddvds oveq12 syl6eq
    1t1e1 breq2d syl5ibcom cn0 wb simp1 zmulcl 3adant1 gcdcld dvds1 syl sylibd
    ) ADEZBDEZCDEZFZABGHZIJACGHZIJKZABCLHZGHZIMNZURIJZUMURUNUOLHZMNUPUSABCOUPVA
    IURMUPVAIILHIUNIUOILPRQSTUMURUAEUSUTUBUMAUQUJUKULUCUKULUQDEUJBCUDUEUFURUGUH
    UI $.

  $( If ` K ` is relatively prime to ` N ` then it is also relatively prime to
     any divisor ` M ` of ` N ` .  (Contributed by Mario Carneiro,
     19-Jun-2015.) $)
  rpdvds $p |- ( ( ( K e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\
    ( ( K gcd N ) = 1 /\ M || N ) ) -> ( K gcd M ) = 1 ) $=
    ( cz wcel cgcd co c1 wceq cdivides wbr wa cle syl2anc simprr wi cc0 wn wne
    wb w3a simpl1 simpl2 gcddvds simpld simprd cn ax-1ne0 simprl neeq1d simplrr
    mpbiri neneqd eqbrtrrd simpll3 0dvds syl mpbid jca ex simpl3 gcdeq0 sylibrd
    mtod gcdn0cl syl21anc nnzd dvdstr syl3anc mp2and dvdslegcd syl31anc breqtrd
    mtbid nnle1eq1 ) ADEZBDEZCDEZUAZACFGZHIZBCJKZLZLZABFGZHMKZWEHIZWDWEVTHMWDWE
    AJKZWECJKZWEVTMKZWDWHWEBJKZWDVPVQWHWKLVPVQVRWCUBZVPVQVRWCUCZABUDNZUEWDWKWBW
    IWDWHWKWNUFVSWAWBOWDWEDEZVQVRWKWBLWIPWDWEWDVPVQAQIZBQIZLZRWEUGEZWLWMWDWRVTQ
    IZWDVTQWDVTQSHQSUHWDVTHQVSWAWBUIZUJULUMZWDWRWPCQIZLZWTWDWRXDWDWRLZWPXCWDWPW
    QUIXEQCJKZXCXEBQCJWDWPWQOVSWAWBWRUKUNXEVRXFXCTVPVQVRWCWRUOCUPUQURUSUTWDVPVR
    WTXDTWLVPVQVRWCVAZACVBNZVCVDABVEVFZVGZWMXGWEBCVHVIVJWDWOVPVRXDRWHWILWJPXJWL
    XGWDWTXDXBXHVNWEACVKVLVJXAVMWDWSWFWGTXIWEVOUQUR $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Properties of the canonical representation of a rational
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c numer denom $.

  $( Extend class notation to include canonical numerator function. $)
  cnumer $a class numer $.
  $( Extend class notation to include canonical denominator function. $)
  cdenom $a class denom $.

  ${
    $d x y $.
    $( The canonical numerator of a rational is the numerator of the rational's
       reduced fraction representation (no common factors, denominator
       positive).  (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    df-numer $a |- numer = ( y e. QQ |-> ( 1st ` ( iota_ x e. ( ZZ X. NN ) ( (
        ( 1st ` x ) gcd ( 2nd ` x ) ) = 1 /\ y = ( ( 1st ` x ) / ( 2nd ` x ) )
        ) ) ) ) $.
    $( The canonical denominator of a rational is the denominator of the
       rational's reduced fraction representation (no common factors,
       denominator positive).  (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    df-denom $a |- denom = ( y e. QQ |-> ( 2nd ` ( iota_ x e. ( ZZ X. NN ) ( (
        ( 1st ` x ) gcd ( 2nd ` x ) ) = 1 /\ y = ( ( 1st ` x ) / ( 2nd ` x ) )
        ) ) ) ) $.
  $}

  ${
    $d A a b c d $.  $d B a b c d $.  $d C a b c d $.  $d x y a b c d $.

    ${
      $d A x $.
      $( Value of the canonical numerator function.  (Contributed by Stefan
         O'Rear, 13-Sep-2014.) $)
      qnumval $p |- ( A e. QQ -> ( numer ` A ) = ( 1st ` ( iota_ x e. ( ZZ X.
          NN ) ( ( ( 1st ` x ) gcd ( 2nd ` x ) ) = 1 /\ A = ( ( 1st ` x ) / (
          2nd ` x ) ) ) ) ) ) $=
        ( va cv c1st cfv c2nd cgcd co c1 wceq cdiv wa cz cn cxp cq cnumer eqeq1
        crio anbi2d riotabidv fveq2d df-numer fvex fvmpt ) CBADZEFZUGGFZHIJKZCD
        ZUHUILIZKZMZANOPZTZEFUJBULKZMZAUOTZEFQRUKBKZUPUSEUTUNURAUOUTUMUQUJUKBUL
        SUAUBUCACUDUSEUEUF $.

      $( Value of the canonical denominator function.  (Contributed by Stefan
         O'Rear, 13-Sep-2014.) $)
      qdenval $p |- ( A e. QQ -> ( denom ` A ) = ( 2nd ` ( iota_ x e. ( ZZ X.
          NN ) ( ( ( 1st ` x ) gcd ( 2nd ` x ) ) = 1 /\ A = ( ( 1st ` x ) / (
          2nd ` x ) ) ) ) ) ) $=
        ( va cv c1st cfv c2nd cgcd co c1 wceq cdiv wa cz cn cxp cq cdenom eqeq1
        crio anbi2d riotabidv fveq2d df-denom fvex fvmpt ) CBADZEFZUGGFZHIJKZCD
        ZUHUILIZKZMZANOPZTZGFUJBULKZMZAUOTZGFQRUKBKZUPUSGUTUNURAUOUTUMUQUJUKBUL
        SUAUBUCACUDUSGUEUF $.
    $}

    $( Lemma for ~ qnumcl and ~ qdencl .  (Contributed by Stefan O'Rear,
       13-Sep-2014.) $)
    qnumdencl $p |- ( A e. QQ -> ( ( numer ` A ) e. ZZ /\ ( denom ` A ) e. NN )
        ) $=
      ( va cq wcel cv c1st cfv c2nd cgcd co c1 wceq cdiv wa cz cn cnumer eleq1d
      cxp crio cdenom wreu qredeu riotacl syl cop elxp6 qnumval qdenval anbi12d
      biimprd adantld syl5bi mpd ) ACDZBEZFGZUPHGZIJKLAUQURMJLNZBOPSZTZUTDZAQGZ
      ODZAUAGZPDZNZUOUSBUTUBVBBAUCUSBUTUDUEVBVAVAFGZVAHGZUFLZVHODZVIPDZNZNUOVGV
      AOPUGUOVMVGVJUOVGVMUOVDVKVFVLUOVCVHOBAUHRUOVEVIPBAUIRUJUKULUMUN $.

    $( The canonical numerator of a rational is an integer.  (Contributed by
       Stefan O'Rear, 13-Sep-2014.) $)
    qnumcl $p |- ( A e. QQ -> ( numer ` A ) e. ZZ ) $=
      ( cq wcel cnumer cfv cz cdenom cn qnumdencl simpld ) ABCADEFCAGEHCAIJ $.

    $( The canonical denominator is a positive integer.  (Contributed by Stefan
       O'Rear, 13-Sep-2014.) $)
    qdencl $p |- ( A e. QQ -> ( denom ` A ) e. NN ) $=
      ( cq wcel cnumer cfv cz cdenom cn qnumdencl simprd ) ABCADEFCAGEHCAIJ $.

    $( Canonical numerator defines a function.  (Contributed by Stefan O'Rear,
       13-Sep-2014.) $)
    fnum $p |- numer : QQ --> ZZ $=
      ( va vb cq cz cv c1st cfv c2nd cgcd co c1 wceq cdiv wa cn cxp crio cnumer
      df-numer wcel qnumval qnumcl eqeltrrd fmpti ) ACDBEZFGZUEHGZIJKLAEZUFUGMJ
      LNBDOPQFGZRBASUHCTUHRGUIDBUHUAUHUBUCUD $.

    $( Canonical denominator defines a function.  (Contributed by Stefan
       O'Rear, 13-Sep-2014.) $)
    fden $p |- denom : QQ --> NN $=
      ( va vb cq cn cv c1st cfv c2nd cgcd co c1 wceq cdiv wa cz cxp crio cdenom
      df-denom wcel qdenval qdencl eqeltrrd fmpti ) ACDBEZFGZUEHGZIJKLAEZUFUGMJ
      LNBODPQHGZRBASUHCTUHRGUIDBUHUAUHUBUCUD $.

    $( Two numbers are the canonical representation of a rational iff they are
       coprime and have the right quotient.  (Contributed by Stefan O'Rear,
       13-Sep-2014.) $)
    qnumdenbi $p |- ( ( A e. QQ /\ B e. ZZ /\ C e. NN )
        -> ( ( ( B gcd C ) = 1 /\ A = ( B / C ) )
          <-> ( ( numer ` A ) = B /\ ( denom ` A ) = C ) ) ) $=
      ( va wcel cz cn cfv wceq wa c1st c2nd cgcd co c1 cdiv cop 3adant1 oveq12d
      eqeq1d cq w3a cnumer cdenom cv cxp crio wb qredeu riotacl 1st2nd2 qnumval
      wreu 3syl qdenval opeq12d eqtr4d 3ad2ant1 fvex opth syl6rbb opelxpi fveq2
      eqeq2d anbi12d riota2 syl2anc op1stg op2ndg 3bitr2rd ) AUAEZBFEZCGEZUBZAU
      CHZBIAUDHZCIJZDUEZKHZVRLHZMNZOIZAVSVTPNZIZJZDFGUFZUGZBCQZIZWHKHZWHLHZMNZO
      IZAWJWKPNZIZJZBCMNZOIZABCPNZIZJVNWIVOVPQZWHIZVQVKVLWIXBUHVMVKWGXAWHVKWGWG
      KHZWGLHZQZXAVKWEDWFUMZWGWFEWGXEIDAUIZWEDWFUJWGFGUKUNVKVOXCVPXDDAULDAUOUPU
      QTURVOVPBCAUCUSAUDUSUTVAVNWHWFEZXFWPWIUHVLVMXHVKBCFGVBRVKVLXFVMXGURWEWPDW
      FWHVRWHIZWBWMWDWOXIWAWLOXIVSWJVTWKMVRWHKVCZVRWHLVCZSTXIWCWNAXIVSWJVTWKPXJ
      XKSVDVEVFVGVNWMWRWOWTVNWLWQOVLVMWLWQIVKVLVMJWJBWKCMBCFGVHZBCFGVIZSRTVNWNW
      SAVNWJBWKCPVLVMWJBIVKXLRVLVMWKCIVKXMRSVDVEVJ $.

    $( The canonical representation of a rational is fully reduced.
       (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    qnumdencoprm $p |- ( A e. QQ
        -> ( ( numer ` A ) gcd ( denom ` A ) ) = 1 ) $=
      ( cq wcel cnumer cdenom cgcd co c1 wceq cdiv wa eqidd eqid jctir cz cn wb
      cfv qnumcl qdencl qnumdenbi mpd3an23 mpbird simpld ) ABCZADRZAERZFGHIZAUF
      UGJGIZUEUHUIKZUFUFIZUGUGIZKZUEUKULUEUFLUGMNUEUFOCUGPCUJUMQASATAUFUGUAUBUC
      UD $.

    $( Recover a rational number from its canonical representation.
       (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    qeqnumdivden $p |- ( A e. QQ -> A = ( ( numer ` A ) / ( denom ` A ) ) ) $=
      ( cq wcel cnumer cdenom cgcd co c1 wceq cdiv wa eqidd eqid jctir cz cn wb
      cfv qnumcl qdencl qnumdenbi mpd3an23 mpbird simprd ) ABCZADRZAERZFGHIZAUF
      UGJGIZUEUHUIKZUFUFIZUGUGIZKZUEUKULUEUFLUGMNUEUFOCUGPCUJUMQASATAUFUGUAUBUC
      UD $.

    $( Multiplying a rational by its denominator results in an integer.
       (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    qmuldeneqnum $p |- ( A e. QQ -> ( A x. ( denom ` A ) ) = ( numer ` A ) ) $=
      ( wcel cdenom cfv cmul cnumer cdiv qeqnumdivden oveq1d qnumcl zcnd qdencl
      cq co nncnd nnne0d divcan1d eqtrd ) AMBZAACDZENAFDZTGNZTENUASAUBTEAHISUAT
      SUAAJKSTALZOSTUCPQR $.

    $( Calculate the reduced form of a quotient using ` gcd ` .  (Contributed
       by Stefan O'Rear, 13-Sep-2014.) $)
    divnumden $p |- ( ( A e. ZZ /\ B e. NN ) -> ( ( numer ` ( A / B ) ) = ( A /
        ( A gcd B ) ) /\ ( denom ` ( A / B ) ) = ( B / ( A gcd B ) ) ) ) $=
      ( cz wcel cn wa cgcd co cdiv c1 wceq cfv cdivides wbr adantl wn sylan2 cc
      cc0 wb cnumer cdenom simpl neneqd intnand gcdn0cl syl21anc gcddvds gcddiv
      nnz nnne0 syl31anc nncnd nnne0d dividd eqtr3d wne zcn adantr nncn divcan7
      w3a eqcomd syl122anc znq simpld gcdcl nn0zd dvdsval2 syl3anc mpbid simprd
      cq simpr nndivdvds syl2anc qnumdenbi mpbi2and ) ACDZBEDZFZAABGHZIHZBWBIHZ
      GHZJKZABIHZWCWDIHZKZWGUALWCKWGUBLWDKFZWAWBWBIHZWEJWAVSBCDZWBEDZWBAMNZWBBM
      NZFZWKWEKVSVTUCZVTWLVSBUJZOZWAVSWLASKZBSKZFPWMWQWSWAXAWTVTXAPVSVTBSBUKZUD
      OUEABUFUGZVTVSWLWPWRABUHQZABWBUIULWAWBWAWBXCUMZWAWBXCUNZUOUPWAARDZBRDZBSU
      QZWBRDZWBSUQZWIVSXGVTAURUSVTXHVSBUTOVTXIVSXBOXEXFXGXHXIFXJXKFVBWHWGABWBVA
      VCVDWAWGVMDWCCDZWDEDZWFWIFWJTABVEWAWNXLWAWNWOXDVFWAWBCDZXKVSWNXLTVTVSWLXN
      WRVSWLFWBABVGVHQXFWQWBAVIVJVKWAWOXMWAWNWOXDVLWAVTWMWOXMTVSVTVNXCBWBVOVPVK
      WGWCWDVQVJVR $.

    $( Reducing a quotient never increases the denominator.  (Contributed by
       Stefan O'Rear, 13-Sep-2014.) $)
    divdenle $p |- ( ( A e. ZZ /\ B e. NN ) -> ( denom ` ( A / B ) ) <_ B ) $=
      ( cz wcel cn wa cdiv co cdenom cfv cle wceq c1 wbr cc0 wn adantl clt a1i
      cr cgcd cnumer divnumden simprd simpl nnz neneqd intnand gcdn0cl syl21anc
      nnne0 nnge1d 1re 0lt1 nnred nngt0d nnre nngt0 lediv2 syl222anc mpbid nncn
      wb cc div1d breqtrd eqbrtrd ) ACDZBEDZFZABGHZIJZBABUAHZGHZBKVJVKUBJAVMGHL
      VLVNLABUCUDVJVNBMGHZBKVJMVMKNZVNVOKNZVJVMVJVHBCDZAOLZBOLZFPVMEDVHVIUEVIVR
      VHBUFQVJVTVSVIVTPVHVIBOBUKUGQUHABUIUJZULVJMTDZOMRNZVMTDOVMRNBTDZOBRNZVPVQ
      VCWBVJUMSWCVJUNSVJVMWAUOVJVMWAUPVIWDVHBUQQVIWEVHBURQMVMBUSUTVAVJBVIBVDDVH
      BVBQVEVFVG $.

    $( A rational is positive iff its canonical numerator is.  (Contributed by
       Stefan O'Rear, 15-Sep-2014.) $)
    qnumgt0 $p |- ( A e. QQ -> ( 0 < A <-> 0 < ( numer ` A ) ) ) $=
      ( cq wcel cc0 clt wbr cdenom cfv co cnumer cr wb 0re a1i qre qdencl nnred
      cmul nngt0d ltmul1 syl112anc nncnd mul02d qmuldeneqnum breq12d bitrd ) AB
      CZDAEFZDAGHZRIZAUIRIZEFZDAJHZEFUGDKCZAKCUIKCDUIEFUHULLUNUGMNAOUGUIAPZQUGU
      IUOSDAUITUAUGUJDUKUMEUGUIUGUIUOUBUCAUDUEUF $.

    $( A rational is positive iff its canonical numerator is a natural number.
       (Contributed by Stefan O'Rear, 15-Sep-2014.) $)
    qgt0numnn $p |- ( ( A e. QQ /\ 0 < A ) -> ( numer ` A ) e. NN ) $=
      ( cq wcel cc0 clt wbr wa cnumer cfv cz qnumcl adantr qnumgt0 biimpa elnnz
      cn sylanbrc ) ABCZDAEFZGAHIZJCZDTEFZTPCRUASAKLRSUBAMNTOQ $.

    $( Squaring commutes with GCD, in particular two coprime numbers have
       coprime squares.  (Contributed by Stefan O'Rear, 15-Sep-2014.) $)
    nn0gcdsq $p |- ( ( A e. NN0 /\ B e. NN0 ) -> ( ( A gcd B ) ^ 2 ) = ( ( A ^
        2 ) gcd ( B ^ 2 ) ) ) $=
      ( cn0 wcel cn cc0 wceq wo cgcd co c2 cexp wa cabs cfv syl cz oveq1d oveq1
      sq0 elnn0 sqgcd nncn abssq nnz gcd0id a1i zsqcl 3syl eqtrd 3eqtr4d adantl
      cc eqeq12d adantr mpbird gcdid0 oveq2d oveq2 gcd0val oveq1i oveq12i eqtri
      wb 3eqtr4i oveq12 oveqan12d 3eqtr4a ccase syl2anb ) ACDAEDZAFGZHBEDZBFGZH
      ABIJZKLJZAKLJZBKLJZIJZGZBCDAUABUAVKVMVLVNVTABUBVLVMMVTFBIJZKLJZFKLJZVRIJZ
      GZVMWEVLVMBNOZKLJZVRNOZWBWDVMBUMDWGWHGBUCBUDPVMWAWFKLVMBQDZWAWFGBUEZBUFPR
      VMWDFVRIJZWHVMWCFVRIWCFGZVMTUGRVMWIVRQDWKWHGWJBUHVRUFUIUJUKULVLVTWEVDVMVL
      VPWBVSWDVLVOWAKLAFBISRVLVQWCVRIAFKLSZRUNUOUPVKVNMVTAFIJZKLJZVQWCIJZGZVKWQ
      VNVKANOZKLJZVQNOZWOWPVKAUMDWSWTGAUCAUDPVKWNWRKLVKAQDZWNWRGAUEZAUQPRVKWPVQ
      FIJZWTVKWCFVQIWLVKTUGURVKXAVQQDXCWTGXBAUHVQUQUIUJUKUOVNVTWQVDVKVNVPWOVSWP
      VNVOWNKLBFAIUSRVNVRWCVQIBFKLSZURUNULUPVLVNMZFFIJZKLJZWCWCIJZVPVSWCFXGXHTX
      FFKLUTVAXHXFFWCFWCFITTVBUTVCVEXEVOXFKLAFBFIVFRVLVNVQWCVRWCIWMXDVGVHVIVJ
      $.

    $( ~ nn0gcdsq extended to integers by symmetry.  (Contributed by Stefan
       O'Rear, 15-Sep-2014.) $)
    zgcdsq $p |- ( ( A e. ZZ /\ B e. ZZ ) -> ( ( A gcd B ) ^ 2 ) = ( ( A ^ 2 )
        gcd ( B ^ 2 ) ) ) $=
      ( cz wcel wa cgcd co c2 cexp cabs cfv gcdabs eqcomd cn0 wceq nn0abscl zre
      cr absresq syl oveq1d nn0gcdsq syl2an adantr adantl oveq12d 3eqtrd ) ACDZ
      BCDZEZABFGZHIGAJKZBJKZFGZHIGZULHIGZUMHIGZFGZAHIGZBHIGZFGUJUKUNHIUJUNUKABL
      MUAUHULNDUMNDUOUROUIAPBPULUMUBUCUJUPUSUQUTFUJARDZUPUSOUHVAUIAQUDASTUJBRDZ
      UQUTOUIVBUHBQUEBSTUFUG $.

    $( Squaring a rational squares its canonical components.  (Contributed by
       Stefan O'Rear, 15-Sep-2014.) $)
    numdensq $p |- ( A e. QQ -> ( ( numer ` ( A ^ 2 ) ) = ( ( numer ` A ) ^ 2 )
        /\ ( denom ` ( A ^ 2 ) ) = ( ( denom ` A ) ^ 2 ) ) ) $=
      ( cq wcel cnumer cfv c2 cexp co cdenom cgcd wceq cdiv qnumdencoprm oveq1d
      c1 wa cz qnumcl qdencl nnzd zgcdsq syl2anc sq1 3eqtr3d qeqnumdivden nncnd
      a1i zcnd nnne0d sqdivd eqtrd cn qsqcl zsqcl syl nnsqcld qnumdenbi syl3anc
      wb mpbi2and ) ABCZADEZFGHZAIEZFGHZJHZOKZAFGHZVCVELHZKZVHDEVCKVHIEVEKPZVAV
      BVDJHZFGHZOFGHZVFOVAVLOFGAMNVAVBQCZVDQCVMVFKARZVAVDASZTVBVDUAUBVNOKVAUCUG
      UDVAVHVBVDLHZFGHVIVAAVRFGAUENVAVBVDVAVBVPUHVAVDVQUFVAVDVQUIUJUKVAVHBCVCQC
      ZVEULCVGVJPVKUSAUMVAVOVSVPVBUNUOVAVDVQUPVHVCVEUQURUT $.

    $( Square commutes with canonical numerator.  (Contributed by Stefan
       O'Rear, 15-Sep-2014.) $)
    numsq $p |- ( A e. QQ -> ( numer ` ( A ^ 2 ) ) = ( ( numer ` A ) ^ 2 ) ) $=
      ( cq wcel c2 cexp co cnumer cfv wceq cdenom numdensq simpld ) ABCADEFZGHA
      GHDEFIMJHAJHDEFIAKL $.

    $( Square commutes with canonical denominator.  (Contributed by Stefan
       O'Rear, 15-Sep-2014.) $)
    densq $p |- ( A e. QQ -> ( denom ` ( A ^ 2 ) ) = ( ( denom ` A ) ^ 2 ) ) $=
      ( cq wcel c2 cexp co cnumer cfv wceq cdenom numdensq simprd ) ABCADEFZGHA
      GHDEFIMJHAJHDEFIAKL $.

    $( A rational is an integer iff it has denominator 1.  (Contributed by
       Stefan O'Rear, 15-Sep-2014.) $)
    qden1elz $p |- ( A e. QQ -> ( ( denom ` A ) = 1 <-> A e. ZZ ) ) $=
      ( cq wcel cdenom cfv c1 wceq cz wa cnumer cdiv co qeqnumdivden oveq2 zcnd
      adantr div1d cle wbr cn adantl qnumcl 3eqtrd eqeltrd simpr fveq2d sylancl
      1nn divdenle eqbrtrrd wb qdencl nnle1eq1 syl mpbid impbida ) ABCZADEZFGZA
      HCZUQUSIZAAJEZHVAAVBURKLZVBFKLZVBUQAVCGUSAMPUSVCVDGUQURFVBKNUAVAVBVAVBUQV
      BHCUSAUBPZOQUCVEUDUQUTIZURFRSZUSVFAFKLZDEZURFRVFVHADVFAVFAUQUTUEZOQUFVFUT
      FTCVIFRSVJUHAFUIUGUJVFURTCZVGUSUKUQVKUTAULPURUMUNUOUP $.

    $( If an integer has a rational square root, that root is must be an
       integer.  (Contributed by Stefan O'Rear, 15-Sep-2014.) $)
    zsqrelqelz $p |- ( ( A e. ZZ /\ ( sqr ` A ) e. QQ )
        -> ( sqr ` A ) e. ZZ ) $=
      ( cz wcel csqr cfv cq wa cdenom c1 wceq cn qdencl adantl a1i c2 co adantr
      cexp wb qden1elz nnred 1re nnnn0d nn0ge0d cc0 cle wbr 0le1 sq1 zcn sqsqrd
      cr fveq2d simpl zq syl mpbird eqtrd densq 3eqtr2rd sq11d mpbid ) ABCZADEZ
      FCZGZVDHEZIJZVDBCZVFVGIVFVGVEVGKCVCVDLMZUAIULCVFUBNVFVGVFVGVJUCUDUEIUFUGV
      FUHNVFIORPZIVDORPZHEZVGORPZVKIJVFUINVFVMAHEZIVFVLAHVCVLAJVEVCAAUJUKQUMVFV
      OIJZVCVCVEUNVFAFCZVPVCSVCVQVEAUOQATUPUQURVEVMVNJVCVDUSMUTVAVEVHVISVCVDTMV
      B $.

    $( Any integer strictly between two adjacent squares has an irrational
       square root.  (Contributed by Stefan O'Rear, 15-Sep-2014.) $)
    nonsq $p |- ( ( ( A e. NN0 /\ B e. NN0 ) /\ ( ( B ^ 2 ) < A /\ A < ( ( B +
        1 ) ^ 2 ) ) ) -> -. ( sqr ` A ) e. QQ ) $=
      ( cn0 wcel wa c2 cexp co clt wbr cz ad2antlr cr nn0re ad2antrr cc0 nn0ge0
      nn0z cle syl c1 caddc csqr cfv cq wn simprl recnd sqsqrd breqtrrd sqrge0d
      resqrcld lt2sqd mpbird simprr eqbrtrd peano2nn0 btwnnz syl3anc zsqrelqelz
      peano2re wi ex mtod ) ACDZBCDZEZBFGHZAIJZABUAUBHZFGHZIJZEZEZAUCUDZUEDZVOK
      DZVNBKDZBVOIJZVOVJIJZVQUFVFVRVEVMBRLVNVSVHVOFGHZIJVNVHAWAIVGVIVLUGVNAVNAV
      EAMDVFVMANOZUHUIZUJVNBVOVFBMDZVEVMBNLZVNAWBVEPASJVFVMAQOZULZVFPBSJVEVMBQL
      VNAWBWFUKZUMUNVNVTWAVKIJVNWAAVKIWCVGVIVLUOUPVNVOVJWGVNWDVJMDWEBVATWHVFPVJ
      SJZVEVMVFVJCDWIBUQVJQTLUMUNBVOURUSVNAKDZVPVQVBVEWJVFVMAROWJVPVQAUTVCTVD
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Euler's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c odZ $.
  $c phi $.

  $( Extend class notation with the order function on the class of integers mod
     N. $)
  codz $a class odZ $.

  $( Extend class notation with the Euler phi function. $)
  cphi $a class phi $.

  ${
    $d m n x $.
    $( Define the order function on the class of integers mod N. (Contributed
       by Mario Carneiro, 23-Feb-2014.) $)
    df-odz $a |- odZ = ( n e. NN |-> ( x e. { x e. ZZ | ( x gcd n ) = 1 } |->
                sup ( { m e. NN | n || ( ( x ^ m ) - 1 ) } , RR , `' < ) ) ) $.

    $( Define the Euler phi function, which counts the number of integers less
       than ` n ` and coprime to it.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    df-phi $a |- phi = ( n e. NN |-> ( # `
                         { x e. ( 1 ... n ) | ( x gcd n ) = 1 } ) ) $.
  $}

  ${
    $d n x N $.
    $( Value of the Euler ` phi ` function.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    phival $p |- ( N e. NN -> ( phi ` N ) = ( # `
                         { x e. ( 1 ... N ) | ( x gcd N ) = 1 } ) ) $=
      ( vn cv cgcd co c1 wceq cfz crab chash cfv cn cphi oveq2 eqeq1d rabeqbidv
      fveq2d df-phi fvex fvmpt ) CBADZCDZEFZGHZAGUCIFZJZKLUBBEFZGHZAGBIFZJZKLMN
      UCBHZUGUKKULUEUIAUFUJUCBGIOULUDUHGUCBUBEOPQRACSUKKTUA $.
  $}

  ${
    $d x N $.
    $( Bounds and closure for the value of the Euler ` phi ` function.
       (Contributed by Mario Carneiro, 23-Feb-2014.) $)
    phicl2 $p |- ( N e. NN -> ( phi ` N ) e. ( 1 ... N ) ) $=
      ( vx cn wcel cfv cgcd co c1 cfz chash cz cle wbr cfn cn0 wss mp2an cvv wb
      wceq cphi crab phival fzfi ssrab2 ssfi hashcl ax-mp nn0zi a1i csn hashsng
      cv 1z cdom ovex rabex cuz eluzfz1 nnuz eleq2s nnz 1gcd oveq1 eqeq1d elrab
      syl sylanbrc snssd ssdomg mpsyl snfi hashdom sylibr syl5eqbrr mpbir nnnn0
      mp2 hashfz1 syl5breq w3a elfz1 sylancr mpbir3and eqeltrd ) ACDZAUAEBUMZAF
      GZHTZBHAIGZUBZJEZWJBAUCWFWLWJDZWLKDZHWLLMZWLALMZWNWFWLWKNDZWLODWJNDZWKWJP
      ZWQHAUDZWIBWJUEZWJWKUFQZWKUGUHUIUJWFHHUKZJEZWLLHKDZXDHTUNHKULUHWFXCWKUOMZ
      XDWLLMZWKRDWFXCWKPXFWIBWJHAIUPZUQWFHWKWFHWJDZHAFGZHTZHWKDXIAHURECHAUSUTVA
      WFAKDZXKAVBZAVCVGWIXKBHWJWGHTWHXJHWGHAFVDVEVFVHVIXCWKRVJVKXCNDWQXGXFSHVLX
      BXCWKNVMQVNVOWFWLWJJEZALWLXNLMZWKWJUOMZWJRDWSXPXHXAWKWJRVJVRWQWRXOXPSXBWT
      WKWJNVMQVPWFAODXNATAVQAVSVGVTWFXEXLWMWNWOWPWASUNXMWLHAWBWCWDWE $.

    $( Closure for the value of the Euler ` phi ` function.  (Contributed by
       Mario Carneiro, 28-Feb-2014.) $)
    phicl $p |- ( N e. NN -> ( phi ` N ) e. NN ) $=
      ( cn wcel cphi cfv c1 cfz co phicl2 elfznn syl ) ABCADEZFAGHCLBCAILAJK $.

    $( Lemma for ~ phibnd .  (Contributed by Mario Carneiro, 23-Feb-2014.) $)
    phibndlem $p |- ( N e. ( ZZ>= ` 2 ) ->
             { x e. ( 1 ... N ) | ( x gcd N ) = 1 } C_ ( 1 ... ( N - 1 ) ) ) $=
      ( c2 cuz cfv wcel cv cgcd co c1 wceq cmin cfz wi wral wa wne cn syl cr wn
      crab wss clt wbr eluz2b2 simplbi wo wb fzm1 nnuz eleq2s biimpa sylan cabs
      ord cz eluzelz gcdid nnre nnnn0 nn0ge0d absidd eqtrd eluzelre simprbi 1re
      ltneOLD mp3an1 syl2anc eqnetrd oveq1 neeq1d syl5ibrcom necon4bd ralrimiva
      adantr syld rabss sylibr ) BCDEFZAGZBHIZJKZWBJBJLIMIZFZNZAJBMIZOWDAWHUBWE
      UCWAWGAWHWAWBWHFZPZWFWCJWJWFUAZWBBKZWCJQZWABRFZWIWKWLNWAWNJBUDUEZBUFZUGZW
      NWIPWFWLWNWIWFWLUHZWIWRUIBJDERWBJBUJUKULUMUPUNWAWLWMNWIWAWMWLBBHIZJQWAWSB
      JWAWSBUOEZBWABUQFWSWTKCBURBUSSWAWNWTBKWQWNBBUTWNBBVAVBVCSVDWABTFZWOBJQZCB
      VEWAWNWOWPVFJTFXAWOXBVGJBVHVIVJVKWLWCWSJWBBBHVLVMVNVQVRVOVPWDAWHWEVSVT $.

    $( A slightly tighter bound on the value of the Euler ` phi ` function.
       (Contributed by Mario Carneiro, 23-Feb-2014.) $)
    phibnd $p |- ( N e. ( ZZ>= ` 2 ) -> ( phi ` N ) <_ ( N - 1 ) ) $=
      ( vx c2 cuz cfv wcel cv cgcd co wceq cfz crab chash cle wbr cfn wss mp2an
      c1 fzfi cmin cphi cdom phibndlem ssdomg mpsyl wb ssrab2 hashdom sylibr cn
      ssfi clt eluz2b2 simplbi phival syl nnm1nn0 hashfz1 3syl eqcomd 3brtr4d
      cn0 ) ACDEFZBGAHISJZBSAKIZLZMEZSASUAIZKIZMEZAUBEZVINVDVGVJUCOZVHVKNOZVJPF
      ZVDVGVJQVMSVITZBAUDVGVJPUEUFVGPFZVOVNVMUGVFPFVGVFQVQSATVEBVFUHVFVGULRVPVG
      VJPUIRUJVDAUKFZVLVHJVDVRSAUMOAUNUOZBAUPUQVDVKVIVDVRVIVCFVKVIJVSAURVIUSUTV
      AVB $.

    phicld.1 $e |- ( ph -> N e. NN ) $.
    $( Closure for the value of the Euler ` phi ` function.  (Contributed by
       Mario Carneiro, 29-May-2016.) $)
    phicld $p |- ( ph -> ( phi ` N ) e. NN ) $=
      ( cn wcel cphi cfv phicl syl ) ABDEBFGDECBHI $.
  $}

  $( Value of the Euler ` phi ` function at 1.  (Contributed by Mario Carneiro,
     23-Feb-2014.) $)
  phi1 $p |- ( phi ` 1 ) = 1 $=
    ( c1 cphi cfv csn wcel wceq cfz co cn phicl2 ax-mp cz 1z fzsn eleqtri elsni
    1nn ) ABCZADZERAFRAAGHZSAIERTEQAJKALETSFMANKORAPK $.

  ${
    $d x N $.
    $( Alternate definition of the Euler ` phi ` function.  (Contributed by
       Mario Carneiro, 23-Feb-2014.)  (Revised by Mario Carneiro,
       2-May-2016.) $)
    dfphi2 $p |- ( N e. NN -> ( phi ` N ) = ( # `
                          { x e. ( 0 ..^ N ) | ( x gcd N ) = 1 } ) ) $=
      ( wcel c1 wceq c2 cfv cphi cgcd co cc0 cfzo crab chash cz wne syl cin wss
      ax-mp cn cuz wo cv elnn1uz2 csn phi1 0z hashsng rabid2 oveq1d gcd1 syl6eq
      elsni mprgbir fveq2i 3eqtr2i fveq2 oveq2 eqeq1d rabeqbidv 3eqtr4a eluz2b3
      fzo01 fveq2d cfz simplbi fzossfz a1i sseqin2 sylib cn0 1nn0 nn0uz eleqtri
      phival fzoss1 mpbi syl6eqr inrab2 3eqtr4g cmin phibndlem eluzelz sseqtr4d
      rabeq fzoval df-ss wi wral wa wn cabs gcd0id eluzelre nnnn0d absidd eqtrd
      nn0ge0d simprbi eqnetrd adantr eleq2s neeq1d syl5ibrcom necon2bd simpr 1z
      fzospliti sylancl ord syld ralrimiva rabss sylibr 3eqtr3d jaoi sylbi ) BU
      ACZBDEZBFUBGCZUCBHGZAUDZBIJZDEZAKBLJZMZNGZEZBUEXTYIYAXTDHGZYCDIJZDEZAKUFZ
      MZNGZYBYHYJDYMNGZYOUGKOCZYPDEUHKOUITYMYNNYMYNEYLAYMYLAYMUJYCYMCZYKKDIJZDY
      RYCKDIYCKUNZUKYQYSDEUHKULTUMUOUPUQBDHURXTYGYNNXTYEYLAYFYMXTYFKDLJZYMBDKLU
      SVDUMXTYDYKDBDYCIUSUTVAVEVBYAYBYEADBVFJZMZNGZYHYAXSYBUUDEYAXSBDPZBVCZVGZA
      BVPQYAUUCYGNYAUUCDBLJZRZYGUUHRZUUCYGYAYEAUUBUUHRZMZYEAYFUUHRZMZUUIUUJYAUU
      KUUMEUULUUNEYAUUKUUHUUMYAUUHUUBSZUUKUUHEUUOYADBVHVIUUHUUBVJVKUUHYFSZUUMUU
      HEDKUBGZCUUPDVLUUQVMVNVODKBVQTUUHYFVJVRVSYEAUUKUUMWFQYEAUUBUUHVTYEAYFUUHV
      TWAYAUUCUUHSUUIUUCEYAUUCDBDWBJVFJZUUHABWCYABOCZUUHUUREFBWDZDBWGQWEUUCUUHW
      HVKYAYGUUHSZUUJYGEYAYEYCUUHCZWIZAYFWJUVAYAUVCAYFYAYCYFCZWKZYEYCUUACZWLUVB
      UVEUVFYDDUVEYDDPUVFKBIJZDPZYAUVHUVDYAUVGBDYAUVGBWMGZBYAUUSUVGUVIEUUTBWNQY
      ABFBWOYABYABUUGWPWSWQWRYAXSUUEUUFWTXAXBUVFYDUVGDYDUVGEYCYMUUAYRYCKBIYTUKV
      DXCXDXEXFUVEUVFUVBUVEUVDDOCUVFUVBUCYAUVDXGXHYCKBDXIXJXKXLXMYEAYFUUHXNXOYG
      UUHWHVKXPVEWRXQXR $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z N $.  $d y z ph $.
    hashdvds.1 $e |- ( ph -> N e. NN ) $.
    hashdvds.2 $e |- ( ph -> A e. ZZ ) $.
    hashdvds.3 $e |- ( ph -> B e. ( ZZ>= ` ( A - 1 ) ) ) $.
    hashdvds.4 $e |- ( ph -> C e. ZZ ) $.
    $( The number of numbers in a given residue class in a finite set of
       integers.  (Contributed by Mario Carneiro, 12-Mar-2014.)  (Proof
       shortened by Mario Carneiro, 7-Jun-2016.) $)
    hashdvds $p |- ( ph -> ( # ` { x e. ( A ... B ) | N || ( x - C ) } ) =
       ( ( |_ ` ( ( B - C ) / N ) ) - ( |_ ` ( ( ( A - 1 ) - C ) / N ) ) ) ) $=
      ( co wbr cz wcel syl3anc cle wb cr adantr mpbid vz vy c1 cmin cfl cfv cfz
      cdiv chash cv cdivides crab cen wceq caddc 1z a1i cuz eluzelz syl zsubcld
      zred nndivred flcld peano2zm fzen cc ax-1cn addcom sylancr npcand oveq12d
      zcnd breqtrd cmul cvv ovex cfn fzfi rabexg mp1i wa elfzle1 adantl elfzelz
      clt zltp1le syl2an mpbird fllt cc0 nngt0d jca ltdivmul2 zmulcld ltsubaddd
      nnzd zaddcld zlem1lt syl2anc elfzle2 flge lemuldiv leaddsub elfz dvdsmul2
      nnred mpbir2and pncand breqtrrd oveq1 elrab sylanbrc ex ad2antrl ltsub1dd
      breq2d ltdiv1 simprr wne nnne0d dvdsval2 lesub1dd lediv1 peano2zd adantrl
      syl5bi anbi2i adantrr nncnd divmul3d subadd2d bitrd eqcom 3bitr4g sylan2b
      en3d entr mp2an zre wss ssrab2 hashen sylibr eluzle lesub1 syl3an flword2
      ssfi cn0 uznn0sub hashfz1 3syl eqtr3d ) AUCDEUDKZFUHKZUEUFZCUCUDKZEUDKZFU
      HKZUEUFZUDKZUGKZUIUFZFBUJZEUDKZUKLZBCDUGKZULZUIUFZUVBAUVCUVIUMLZUVDUVJUNZ
      AUVCUVAUCUOKZUUQUGKZUMLUVNUVIUMLUVKAUVCUCUVAUOKZUVBUVAUOKZUGKZUVNUMAUCMNZ
      UVBMNUVAMNZUVCUVQUMLUVRAUPUQAUUQUVAAUUPAUUOFAUUOADEADUURURUFNZDMNZIUURDUS
      UTZJVAVBZGVCZVDZAUUTAUUSFAUUSAUUREACMNZUURMNZHCVEUTZJVAVBZGVCZVDZVAUWKUVA
      UCUVBVFOAUVOUVMUVPUUQUGAUCVGNUVAVGNUVOUVMUNVHAUVAUWKVMZUCUVAVIVJAUUQUVAAU
      UQUWEVMUWLVKVLVNAUAUBUVNUVIUAUJZFVOKZEUOKZUBUJZEUDKZFUHKZUVNVPNAUVMUUQUGV
      QUQUVHVRNZUVIVPNACDVSZUVGBUVHVRVTWAAUWMUVNNZUWOUVINZAUXAWBZUWOUVHNZFUWOEU
      DKZUKLZUXBUXCUXDCUWOPLZUWODPLZUXCUXGUURUWOWFLZUXCUUSUWNWFLZUXIUXCUUTUWMWF
      LZUXJUXCUXKUVAUWMWFLZUXCUXLUVMUWMPLZUXAUXMAUWMUVMUUQWCWDAUVSUWMMNZUXLUXMQ
      UXAUWKUWMUVMUUQWEZUVAUWMWGWHWIAUUTRNZUXNUXKUXLQUXAUWJUXOUUTUWMWJWHWIUXCUU
      SRNZUWMRNZFRNZWKFWFLZWBZUXKUXJQAUXQUXAUWISUXCUWMUXAUXNAUXOWDZVBZAUYAUXAAU
      XSUXTAFGXGAFGWLWMZSZUUSUWMFWNOTUXCUUREUWNAUURRNZUXAAUURUWHVBZSAERNZUXAAEJ
      VBZSZUXCUWNUXCUWMFUYBAFMNZUXAAFGWQZSZWOZVBZWPTUXCUWFUWOMNZUXGUXIQAUWFUXAH
      SZUXCUWNEUYNAEMNZUXAJSWRZCUWOWSWTWIUXCUXHUWNUUOPLZUXCUYTUWMUUPPLZUXCVUAUW
      MUUQPLZUXAVUBAUWMUVMUUQXAWDAUUPRNZUXNVUAVUBQUXAUWDUXOUUPUWMXBWHWIUXCUXRUU
      ORNZUYAUYTVUAQUYCAVUDUXAUWCSUYEUWMUUOFXCOWIUXCUWNRNUYHDRNZUXHUYTQUYOUYJAV
      UEUXAADUWBVBZSUWNEDXDOWIUXCUYPUWFUWAUXDUXGUXHWBQUYSUYQAUWAUXAUWBSUWOCDXEO
      XHUXCFUWNUXEUKUXCUXNUYKFUWNUKLUYBUYMUWMFXFWTUXCUWNEUXCUWNUYNVMZAEVGNZUXAA
      EJVMZSXIXJUVGUXFBUWOUVHUVEUWOUNUVFUXEFUKUVEUWOEUDXKXQXLXMXNUWPUVINZUWPUVH
      NZFUWQUKLZWBZAUWRUVNNZUVGVULBUWPUVHUVEUWPUNUVFUWQFUKUVEUWPEUDXKXQXLZAVUMV
      UNAVUMWBZVUNUVMUWRPLZUWRUUQPLZVUPUVAUWRWFLZVUQVUPUUTUWRWFLZVUSVUPUUSUWQWF
      LZVUTVUPUURUWPEAUYFVUMUYGSVUPUWPVUKUWPMNZAVULUWPCDWEXOZVBZAUYHVUMUYISZVUP
      CUWPPLZUURUWPWFLZVUKVVFAVULUWPCDWCXOVUPUWFVVBVVFVVGQAUWFVUMHSVVCCUWPWSWTT
      XPVUPUXQUWQRNZUYAVVAVUTQAUXQVUMUWISVUPUWQVUPUWPEVVCAUYRVUMJSVAZVBZAUYAVUM
      UYDSZUUSUWQFXROTVUPUXPUWRMNZVUTVUSQAUXPVUMUWJSVUPVULVVLAVUKVULXSVUPUYKFWK
      XTZUWQMNVULVVLQAUYKVUMUYLSAVVMVUMAFGYAZSVVIFUWQYBOTZUUTUWRWJWTTVUPUVSVVLV
      USVUQQAUVSVUMUWKSVVOUVAUWRWGWTTVUPUWRUUPPLZVURVUPUWQUUOPLZVVPVUPUWPDEVVDA
      VUEVUMVUFSVVEVUKUWPDPLAVULUWPCDXAXOYCVUPVVHVUDUYAVVQVVPQVVJAVUDVUMUWCSVVK
      UWQUUOFYDOTVUPVUCVVLVVPVURQAVUCVUMUWDSVVOUUPUWRXBWTTVUPVVLUVMMNZUUQMNZVUN
      VUQVURWBQVVOAVVRVUMAUVAUWKYESAVVSVUMUWESUWRUVMUUQXEOXHXNYGAUXAVUJWBZUWMUW
      RUNZUWPUWOUNZQZVVTAUXAVUMWBZVWCVUJVUMUXAVUOYHAVWDWBZUWRUWMUNZUWOUWPUNZVWA
      VWBVWEVWFUWQUWNUNVWGVWEUWQUWMFAVUMUWQVGNUXAVUPUWQVVIVMYFAUXAUWMVGNVUMUXCU
      WMUYBVMYIAFVGNVWDAFGYJSAVVMVWDVVNSYKVWEUWPEUWNAVUMUWPVGNUXAVUPUWPVVCVMYFA
      VUHVWDVUISAUXAUWNVGNVUMVUGYIYLYMUWMUWRYNUWPUWOYNYOYPXNYQUVCUVNUVIYRWTUVCV
      RNUVIVRNZUVLUVKQUCUVBVSUWSUVIUVHUUAVWHUWTUVGBUVHUUBUVHUVIUUIYSUVCUVIUUCYS
      UUDAUUQUVAURUFNZUVBUUJNUVDUVBUNAUXPVUCUUTUUPPLZVWIUWJUWDAUUSUUOPLZVWJAUUR
      DPLZVWKAUVTVWLIUURDUUEUTAUWGUWAUYRVWLVWKQZUWHUWBJUWGUYFUWAVUEUYRUYHVWMUUR
      YTDYTEYTUURDEUUFUUGOTAUXQVUDUYAVWKVWJQUWIUWCUYDUUSUUOFYDOTUUTUUPUUHOUVAUU
      QUUKUVBUULUUMUUN $.
  $}

  ${
    $d x y z K $.  $d x y z P $.
    $( Value of the Euler ` phi ` function at a prime power.  (Contributed by
       Mario Carneiro, 24-Feb-2014.) $)
    phiprmpw $p |- ( ( P e. Prime /\ K e. NN ) -> ( phi ` ( P ^ K ) ) =
                     ( ( P ^ ( K - 1 ) ) x. ( P - 1 ) ) ) $=
      ( vx wcel cn wa co cfv c1 wceq crab chash cmin cn0 syl cc cc0 cz cdiv cfl
      cprime cexp cphi cv cgcd cfz cmul prmnn nnnn0 nnexpcl syl2an phival nncnd
      nnm1nn0 adantr ax-1cn subdi mp3an3 syl2anc mulid1d caddc cdivides wbr cun
      oveq2d cin c0 inrab wn wral wi wb elfzelz rpexp syl3an1 3expa an32s simpr
      prmz zexpcl gcdcom eqeq1d coprm adantlr 3bitr4d zcn adantl subid1d breq2d
      notbid bitr4d sylan2 biimpd imnan ralrimiva rabeq0 sylibr syl5eq cfn fzfi
      sylib ssrab2 ssfi mp2an hashun mp3an12 wo biimprd con1d orrd rabid2 unrab
      wss syl6reqr fveq2d nnnn0d hashfz1 expm1t 3eqtrd 1z a1i cuz subidi fveq2i
      sylan nn0uz eqtr4i syl6eleq hashdvds oveq1d nnne0d nnz expm1d eqtr4d nnzd
      0z flid eqtrd oveq1i ax-mp 0cn eqtri syl6eq oveq12d hashcl nn0cni sylancr
      div0d addcom 3eqtr3rd mulcld subaddd mpbird 3eqtrrd ) AUADZBEDZFZABUBGZUC
      HZCUDZUURUEGZIJZCIUURUFGZKZLHZABIMGZUBGZAIMGUGGZUUQUUREDZUUSUVEJUUOAEDZBN
      DZUVIUUPAUHZBUIZABUJUKZCUURULOUUQUVHUVGAUGGZUVGIUGGZMGZUVOUVGMGZUVEUUQUVG
      PDZAPDZUVHUVQJZUUQUVGUUOUVJUVFNDUVGEDUUPUVLBUNAUVFUJUKZUMZUUOUVTUUPUUOAUV
      LUMZUOZUVSUVTIPDUWAUPUVGAIUQURUSUUQUVPUVGUVOMUUQUVGUWCUTVEUUQUVRUVEJUVGUV
      EVAGZUVOJUUQUVDAUUTQMGZVBVCZCUVCKZVDZLHZUVEUWILHZVAGZUVOUWFUUQUVDUWIVFZVG
      JZUWKUWMJZUUQUWNUVBUWHFZCUVCKZVGUVBUWHCUVCVHUUQUWQVIZCUVCVJUWRVGJUUQUWSCU
      VCUUQUUTUVCDZFZUVBUWHVIZVKUWSUXAUVBUXBUWTUUQUUTRDZUVBUXBVLUUTIUURVMUUQUXC
      FZUVBAUUTVBVCZVIZUXBUXDUURUUTUEGZIJZAUUTUEGIJZUVBUXFUUOUXCUUPUXHUXIVLZUUO
      UXCUUPUXJUUOARDZUXCUUPUXJAVSZAUUTBVNVOVPVQUXDUVAUXGIUXDUXCUURRDZUVAUXGJUU
      QUXCVRUUQUXMUXCUUOUXKUVKUXMUUPUXLUVMABVTUKUOUUTUURWAUSWBUUOUXCUXFUXIVLUUP
      AUUTWCWDWEUXDUWHUXEUXDUWGUUTAVBUXDUUTUXCUUTPDUUQUUTWFWGWHWIWJWKWLZWMUVBUW
      HWNXAWOUWQCUVCWPWQWRUVDWSDZUWIWSDZUWOUWPUVCWSDZUVDUVCXMUXOIUURWTZUVBCUVCX
      BUVCUVDXCXDZUXQUWIUVCXMUXPUXRUWHCUVCXBUVCUWIXCXDUVDUWIXEXFOUUQUWKUVCLHZUU
      RUVOUUQUWJUVCLUUQUVCUVBUWHXGZCUVCKZUWJUUQUYACUVCVJUVCUYBJUUQUYACUVCUXAUVB
      UWHUXAUWHUVBUXAUVBUXBUXNXHXIXJWOUYACUVCXKWQUVBUWHCUVCXLXNXOUUQUURNDUXTUUR
      JUUQUURUVNXPZUURXQOUUOUVTUUPUURUVOJUWDABXRYEXSUUQUWMUVEUVGVAGZUWFUUQUWLUV
      GUVEVAUUQUWLUURQMGZASGZTHZIIMGZQMGZASGZTHZMGUVGQMGUVGUUQCIUURQAUUOUVJUUPU
      VLUOZIRDUUQXTYAUUQUURNUYHYBHZUYCNQYBHUYMYFUYHQYBIUPYCZYDYGYHQRDZUUQYPYAYI
      UUQUYGUVGUYKQMUUQUYGUVGTHZUVGUUQUYFUVGTUUQUYFUURASGUVGUUQUYEUURASUUQUURUU
      QUURUVNUMWHYJUUQABUWEUUQAUYLYKZUUPBRDUUOBYLWGYMYNXOUUQUVGRDUYPUVGJUUQUVGU
      WBYOUVGYQOYRUUQUYKQTHZQUUQUYJQTUUQUYJQASGQUYIQASUYIQQMGQUYHQQMUYNYSQUUAYC
      UUBYSUUQAUWEUYQUUHWRXOUYOUYRQJYPQYQYTUUCUUDUUQUVGUWCWHXSVEUUQUVEPDZUVSUYD
      UWFJUVEUXOUVENDUXSUVDUUEYTUUFZUWCUVEUVGUUIUUGYRUUJUUQUVOUVGUVEUUQUVGAUWCU
      WEUUKUWCUYSUUQUYTYAUULUUMUUNYR $.
  $}

  $( Value of the Euler ` phi ` function at a prime.  (Contributed by Mario
     Carneiro, 28-Feb-2014.) $)
  phiprm $p |- ( P e. Prime -> ( phi ` P ) = ( P - 1 ) ) $=
    ( cprime wcel c1 cexp co cphi cfv cmin cmul cn wceq 1nn phiprmpw mpan2 prmz
    zcnd exp1d cc0 cc fveq2d 1m1e0 oveq2i syl5eq oveq1d sylancl mulid2d 3eqtr3d
    exp0d ax-1cn subcl eqtrd ) ABCZADEFZGHZADDIFZEFZADIFZJFZAGHURUMDKCUOUSLMADN
    OUMUNAGUMAUMAAPQZRUAUMUSDURJFURUMUQDURJUMUQASEFDUPSAEUBUCUMAUTUIUDUEUMURUMA
    TCDTCURTCUTUJADUKUFUGULUH $.

  ${
    $d w y z F $.  $d w x y M $.  $d w x y z ph $.  $d w x y z S $.  $d x T $.
    $d w x y N $.  $d w z U $.  $d w z V $.  $d w z W $.
    crt.1 $e |- S = ( 0 ..^ ( M x. N ) ) $.
    crt.2 $e |- T = ( ( 0 ..^ M ) X. ( 0 ..^ N ) ) $.
    crt.3 $e |- F = ( x e. S |-> <. ( x mod M ) , ( x mod N ) >. ) $.
    crt.4 $e |- ( ph -> ( M e. NN /\ N e. NN /\ ( M gcd N ) = 1 ) ) $.
    $( The Chinese Remainder Theorem: the function that maps ` x ` to its
       remainder classes ` mod M ` and ` mod N ` is 1-1 and onto when ` M ` and
       ` N ` are coprime.  (Contributed by Mario Carneiro, 24-Feb-2014.)
       (Proof shortened by Mario Carneiro, 2-May-2016.) $)
    crt $p |- ( ph -> F : S -1-1-onto-> T ) $=
      ( cfv wceq cmo co wcel cz cc0 wbr syl vy vz wf1 wf1o wf cv wral cmul cfzo
      wi cop elfzoelz eleq2s wa cxp cn simpr cgcd simp1d adantr zmodfzo syl2anc
      simp2d opelxpi syl6eleqr fmptd oveq1 opeq12d opex fvmpt ad2antrl ad2antll
      sylan2 eqeq12d ovex opth syl6bb cmin cdivides nnzd simprl syl6eleq simprr
      c1 zsubcld simp3d coprmdvds2 syl31anc moddvds syl3anc anbi12d crp cle clt
      wb cr zred nnmulcld nnrpd elfzole1 elfzolt2 modid syl22anc bitr3d 3imtr4d
      ralrimivva dff13 sylanbrc cen cfn cn0 nnnn0 chash nn0mulcl hashfzo0 fzofi
      sylbid hashxp mp2an oveqan12d syl5eq eqtr4d hashen syl2an 3brtr4g eqeltri
      xpfi sylib f1finf1o sylancl mpbid ) ACDEUCZCDEUDZACDEUEUAUFZELZUBUFZELZMZ
      YNYPMZUJZUBCUGUACUGYLABCBUFZFNOZUUAGNOZUKZDEUUACPAUUAQPZUUDDPUUEUUARFGUHO
      ZUIOZCUUARUUFULHUMAUUEUNZUUDRFUIOZRGUIOZUOZDUUHUUBUUIPZUUCUUJPZUUDUUKPUUH
      UUEFUPPZUULAUUEUQZAUUNUUEAUUNGUPPZFGUROWDMZKUSZUTUUAFVAVBUUHUUEUUPUUMUUOA
      UUPUUEAUUNUUPUUQKVCZUTUUAGVAVBUUBUUCUUIUUJVDVBIVEVMJVFAYTUAUBCCAYNCPZYPCP
      ZUNZUNZYRYNFNOZYPFNOZMZYNGNOZYPGNOZMZUNZYSUVCYRUVDUVGUKZUVEUVHUKZMUVJUVCY
      OUVKYQUVLUUTYOUVKMAUVABYNUUDUVKCEUUAYNMUUBUVDUUCUVGUUAYNFNVGUUAYNGNVGVHJU
      VDUVGVIVJVKUVAYQUVLMAUUTBYPUUDUVLCEUUAYPMUUBUVEUUCUVHUUAYPFNVGUUAYPGNVGVH
      JUVEUVHVIVJVLVNUVDUVGUVEUVHYNFNVOYNGNVOVPVQUVCFYNYPVROZVSSZGUVMVSSZUNZUUF
      UVMVSSZUVJYSUVCFQPGQPUVMQPUUQUVPUVQUJUVCFAUUNUVBUURUTZVTUVCGAUUPUVBUUSUTZ
      VTUVCYNYPUVCYNUUGPZYNQPZUVCYNCUUGAUUTUVAWAHWBZYNRUUFULTZUVCYPUUGPZYPQPZUV
      CYPCUUGAUUTUVAWCHWBZYPRUUFULTZWEAUUQUVBAUUNUUPUUQKWFUTUVMFGWGWHUVCUVFUVNU
      VIUVOUVCUUNUWAUWEUVFUVNWOUVRUWCUWGYNYPFWIWJUVCUUPUWAUWEUVIUVOWOUVSUWCUWGY
      NYPGWIWJWKUVCYNUUFNOZYPUUFNOZMZYSUVQUVCUWHYNUWIYPUVCYNWPPUUFWLPZRYNWMSZYN
      UUFWNSZUWHYNMUVCYNUWCWQUVCUUFUVCFGUVRUVSWRZWSZUVCUVTUWLUWBYNRUUFWTTUVCUVT
      UWMUWBYNRUUFXATYNUUFXBXCUVCYPWPPUWKRYPWMSZYPUUFWNSZUWIYPMUVCYPUWGWQUWOUVC
      UWDUWPUWFYPRUUFWTTUVCUWDUWQUWFYPRUUFXATYPUUFXBXCVNUVCUUFUPPUWAUWEUWJUVQWO
      UWNUWCUWGYNYPUUFWIWJXDXEXQXFUAUBCDEXGXHACDXISDXJPYLYMWOAUUGUUKCDXIAUUNUUP
      UUGUUKXISZUURUUSUUNFXKPZGXKPZUWRUUPFXLGXLUWSUWTUNZUUGXMLZUUKXMLZMZUWRUXAU
      XBUUFUXCUXAUUFXKPUXBUUFMFGXNUUFXOTUXAUXCUUIXMLZUUJXMLZUHOZUUFUUIXJPZUUJXJ
      PZUXCUXGMRFXPZRGXPZUUIUUJXRXSUWSUWTUXEFUXFGUHFXOGXOXTYAYBUUGXJPUUKXJPZUXD
      UWRWORUUFXPUXHUXIUXLUXJUXKUUIUUJYGXSZUUGUUKYCXSYHYDVBHIYEDUUKXJIUXMYFCDEY
      IYJYK $.

    phimul.4 $e |- U = { y e. ( 0 ..^ M ) | ( y gcd M ) = 1 } $.
    phimul.5 $e |- V = { y e. ( 0 ..^ N ) | ( y gcd N ) = 1 } $.
    phimul.6 $e |- W = { y e. S | ( y gcd ( M x. N ) ) = 1 } $.
    $( Lemma for ~ phimul .  (Contributed by Mario Carneiro, 24-Feb-2014.) $)
    phimullem $p |- ( ph ->
                   ( phi ` ( M x. N ) ) = ( ( phi ` M ) x. ( phi ` N ) ) ) $=
      ( wcel wceq vw vz chash cfv cmul co cphi cxp cfn cv cgcd c1 cc0 cfzo crab
      wss fzofi ssrab2 ssfi mp2an eqeltri hashxp cen wbr cima wral wa cmo oveq1
      cop eqeq1d elrab2 simplbi opeq12d opex fvmpt syl adantl syl6eleq elfzoelz
      cz cn simp1d adantr zmodfzo syl2anc modgcd cdivides gcddvds simpld simprd
      cle nnzd simp2d dvdsmul1 wi wn nnne0 simpr necon3ai 3syl gcdn0cl syl21anc
      wne nnmulcld dvdstr syl3anc mp2and dvdslegcd syl31anc simprbi wb nnle1eq1
      breqtrd mpbid eqtrd sylanbrc dvdsmul2 opelxpi eqeltrd ralrimiva wfun wf1o
      cdm wfn crt f1ofn fnfun eqsstri fndm syl5sseqr syl2an cmpt eqtri eqeltrrd
      eqtr3d sylib dfphi2 fveq2i syl6eqr funimass4 mpbird xpss12 sseqtr4i sseli
      ccnv f1ocnvfv2 wf f1ocnv f1of ffvelrn cbvmptv opelxp funfvima2 imp syldan
      rpmul ex ssrdv eqssd wf1 f1of1 elexi f1imaen sylancl eqbrtrrd xpfi hashen
      sylibr syl5reqr rabeq ax-mp oveq12d 3eqtr4d ) AKUCUDZFUCUDZJUCUDZUEUFZHIU
      EUFZUGUDZHUGUDZIUGUDZUEUFAUVRFJUHZUCUDZUVOFUISZJUISZUWDUVRTFCUJZHUKUFZULT
      ZCUMHUNUFZUOZUIPUWJUISUWKUWJUPUWKUISUMHUQUWICUWJURZUWJUWKUSUTVAZJUWGIUKUF
      ZULTZCUMIUNUFZUOZUIQUWPUISUWQUWPUPUWQUISUMIUQUWOCUWPURZUWPUWQUSUTVAZFJVBU
      TAUWCKVCVDZUWDUVOTZAGKVEZUWCKVCAUXBUWCAUXBUWCUPZUAUJZGUDZUWCSZUAKVFZAUXFU
      AKAUXDKSZVGZUXEUXDHVHUFZUXDIVHUFZVJZUWCUXHUXEUXLTZAUXHUXDDSZUXMUXHUXNUXDU
      VSUKUFZULTZUWGUVSUKUFZULTZUXPCUXDDKUWGUXDTUXQUXOULUWGUXDUVSUKVIVKRVLZVMZB
      UXDBUJZHVHUFZUYAIVHUFZVJZUXLDGUYAUXDTUYBUXJUYCUXKUYAUXDHVHVIUYAUXDIVHVIVN
      ZNUXJUXKVOVPVQVRUXIUXJFSZUXKJSZUXLUWCSUXIUXJUWJSZUXJHUKUFZULTZUYFUXIUXDWA
      SZHWBSZUYHUXIUXDUMUVSUNUFZSZUYKUXHUYNAUXHUXDDUYMUXTLVSVRUXDUMUVSVTVQZAUYL
      UXHAUYLIWBSZHIUKUFULTZOWCZWDZUXDHWEWFUXIUYIUXDHUKUFZULUXIUYKUYLUYIUYTTUYO
      UYSUXDHWGWFUXIUYTULWLVDZUYTULTZUXIUYTUXOULWLUXIUYTUXDWHVDZUYTUVSWHVDZUYTU
      XOWLVDZUXIVUCUYTHWHVDZUXIUYKHWASZVUCVUFVGUYOUXIHUYSWMZUXDHWIWFZWJUXIVUFHU
      VSWHVDZVUDUXIVUCVUFVUIWKUXIVUGIWASZVUJVUHUXIIAUYPUXHAUYLUYPUYQOWNZWDZWMZH
      IWOWFUXIUYTWASZVUGUVSWASZVUFVUJVGVUDWPUXIUYTUXIUYKVUGUXDUMTZHUMTZVGZWQZUY
      TWBSZUYOVUHUXIUYLHUMXDVUTUYSHWRVUSHUMVUQVURWSWTXAUXDHXBXCZWMZVUHUXIUVSUXI
      HIUYSVUMXEZWMZUYTHUVSXFXGXHUXIVUOUYKVUPVUQUVSUMTZVGZWQZVUCVUDVGVUEWPVVCUY
      OVVEUXIUVSWBSZUVSUMXDVVHVVDUVSWRVVGUVSUMVUQVVFWSWTXAZUYTUXDUVSXIXJXHUXHUX
      PAUXHUXNUXPUXSXKVRZXNUXIVVAVUAVUBXLVVBUYTXMVQXOXPUWIUYJCUXJUWJFUWGUXJTUWH
      UYIULUWGUXJHUKVIVKPVLXQUXIUXKUWPSZUXKIUKUFZULTZUYGUXIUYKUYPVVLUYOVUMUXDIW
      EWFUXIVVMUXDIUKUFZULUXIUYKUYPVVMVVOTUYOVUMUXDIWGWFUXIVVOULWLVDZVVOULTZUXI
      VVOUXOULWLUXIVVOUXDWHVDZVVOUVSWHVDZVVOUXOWLVDZUXIVVRVVOIWHVDZUXIUYKVUKVVR
      VWAVGUYOVUNUXDIWIWFZWJUXIVWAIUVSWHVDZVVSUXIVVRVWAVWBWKUXIVUGVUKVWCVUHVUNH
      IXRWFUXIVVOWASZVUKVUPVWAVWCVGVVSWPUXIVVOUXIUYKVUKVUQIUMTZVGZWQZVVOWBSZUYO
      VUNUXIUYPIUMXDVWGVUMIWRVWFIUMVUQVWEWSWTXAUXDIXBXCZWMZVUNVVEVVOIUVSXFXGXHU
      XIVWDUYKVUPVVHVVRVVSVGVVTWPVWJUYOVVEVVJVVOUXDUVSXIXJXHVVKXNUXIVWHVVPVVQXL
      VWIVVOXMVQXOXPUWOVVNCUXKUWPJUWGUXKTUWNVVMULUWGUXKIUKVIVKQVLXQUXJUXKFJXSWF
      XTYAAGYBZKGYDZUPZUXCUXGXLADEGYCZGDYEZVWKABDEGHILMNOYFZDEGYGZDGYHXAZADKVWL
      KUXRCDUOZDRUXRCDURYIZAVWNVWOVWLDTVWPVWQDGYJXAYKZUAKUWCGUUAWFUUBAUBUWCUXBA
      UBUJZUWCSZVXBUXBSAVXCVGZVXBGUUFZUDZGUDZVXBUXBAVWNVXBESZVXGVXBTVXCVWPUWCEV
      XBUWCUWJUWPUHZEFUWJUPJUWPUPUWCVXIUPFUWKUWJPUWLYIJUWQUWPQUWRYIFUWJJUWPUUCU
      TMUUDUUEZDEVXBGUUGYLZAVXCVXFKSZVXGUXBSZVXDVXFDSZVXFUVSUKUFZULTZVXLAEDVXEU
      UHZVXHVXNVXCAVWNEDVXEYCVXQVWPDEGUUIEDVXEUUJXAVXJEDVXBVXEUUKYLZVXDVXFHUKUF
      ZULTZVXFIUKUFZULTZVXPVXDVXFHVHUFZHUKUFZVXSULVXDVXFWASZUYLVYDVXSTVXDVXFUYM
      SVYEVXDVXFDUYMVXRLVSVXFUMUVSVTVQZAUYLVXCUYRWDVXFHWGWFVXDVYCUWJSZVYDULTZVX
      DVYCFSZVYGVYHVGVXDVYIVXFIVHUFZJSZVXDVYCVYJVJZUWCSVYIVYKVGVXDVXBVYLUWCVXDV
      XGVXBVYLVXKVXDVXNVXGVYLTVXRUAVXFUXLVYLDGUXDVXFTUXJVYCUXKVYJUXDVXFHVHVIUXD
      VXFIVHVIVNGBDUYDYMUADUXLYMNBUADUYDUXLUYEUULYNVYCVYJVOVPVQYPAVXCWSYOVYCVYJ
      FJUUMYQZWJUWIVYHCVYCUWJFUWGVYCTUWHVYDULUWGVYCHUKVIVKPVLYQWKYPVXDVYJIUKUFZ
      VYAULVXDVYEUYPVYNVYATVYFAUYPVXCVULWDVXFIWGWFVXDVYJUWPSZVYNULTZVXDVYKVYOVY
      PVGVXDVYIVYKVYMWKUWOVYPCVYJUWPJUWGVYJTUWNVYNULUWGVYJIUKVIVKQVLYQWKYPVXDVY
      EVUGVUKVXTVYBVGVXPWPVYFAVUGVXCAHUYRWMWDAVUKVXCAIVULWMWDVXFHIUUQXGXHUXRVXP
      CVXFDKUWGVXFTUXQVXOULUWGVXFUVSUKVIVKRVLXQAVXLVXMAVWKVWMVXLVXMWPVWRVXAKVXF
      GUUNWFUUOUUPYOUURUUSUUTADEGUVAZKDUPZUXBKVCVDAVWNVYQVWPDEGUVBVQVWTDEKGKUID
      UISVYRKUISZDUYMUILUMUVSUQVAVWTDKUSUTZUVCUVDUVEUVFUWCUISZVYSUXAUWTXLUWEUWF
      WUAUWMUWSFJUVGUTVYTUWCKUVHUTUVIUVJAVVIUVTUVOTAHIUYRVULXEVVIUVTUXRCUYMUOZU
      CUDUVOCUVSYRKWUBUCKVWSWUBRDUYMTVWSWUBTLUXRCDUYMUVKUVLYNYSYTVQAUWAUVPUWBUV
      QUEAUYLUWAUVPTUYRUYLUWAUWKUCUDUVPCHYRFUWKUCPYSYTVQAUYPUWBUVQTVULUYPUWBUWQ
      UCUDUVQCIYRJUWQUCQYSYTVQUVMUVN $.
  $}

  ${
    $d x y M $.  $d x y N $.
    $( The Euler ` phi ` function is a multiplicative function, meaning that it
       distributes over multiplication at relatively prime arguments.
       (Contributed by Mario Carneiro, 24-Feb-2014.) $)
    phimul $p |- ( ( M e. NN /\ N e. NN /\ ( M gcd N ) = 1 ) ->
                   ( phi ` ( M x. N ) ) = ( ( phi ` M ) x. ( phi ` N ) ) ) $=
      ( vx vy cn wcel cgcd co c1 wceq w3a cc0 cmul cfzo cxp crab cmo cop eqid
      cv cmpt id phimullem ) AEFBEFABGHIJKZCDLABMHZNHZLANHZLBNHZOZDTZAGHIJDUGPZ
      CUFCTZAQHULBQHRUAZABUJBGHIJDUHPZUJUEGHIJDUFPZUFSUISUMSUDUBUKSUNSUOSUC $.
  $}

  ${
    $d x y z A $.  $d w x y z F $.  $d w x y z G $.  $d w x y z N $.  $d x S $.
    $d w x y z ph $.  $d x y z T $.
    eulerth.1 $e |- ( ph -> ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ) $.
    eulerth.2 $e |- S = { y e. ( 0 ..^ N ) | ( y gcd N ) = 1 } $.
    eulerth.3 $e |- T = ( 1 ... ( phi ` N ) ) $.
    eulerth.4 $e |- ( ph -> F : T -1-1-onto-> S ) $.
    eulerth.5 $e |- G = ( x e. T |-> ( ( A x. ( F ` x ) ) mod N ) ) $.
    $( Lemma for ~ eulerth .  (Contributed by Mario Carneiro, 8-May-2015.) $)
    eulerthlem1 $p |- ( ph -> G : T --> S ) $=
      ( co wcel cgcd c1 wceq syl2anc cv cfv cmul cmo wa cc0 cz cn simp2d adantr
      cfzo wf1o wf f1of syl ffvelrnda oveq1 eqeq1d elrab2 sylib simpld elfzoelz
      zmulcld simp1d zmodfzo modgcd gcdcom simp3d eqtrd simprd wi rpmul syl3anc
      nnzd mp2and 3eqtrd sylanbrc fmptd ) ABFDBUAZGUBZUCOZIUDOZEHAVSFPZUEZWBUFI
      UKOZPZWBIQOZRSZWBEPWDWAUGPZIUHPZWFWDDVTADUGPZWCAWJWKDIQOZRSZJUIZUJZWDVTWE
      PZVTUGPZWDWPVTIQOZRSZWDVTEPWPWSUEAFEVSGAFEGULFEGUMMFEGUNUOUPCUAZIQOZRSZWS
      CVTWEEWTVTSXAWRRWTVTIQUQURKUSUTZVAVTUFIVBUOZVCZAWJWCAWJWKWMJVDZUJZWAIVETW
      DWGWAIQOZIWAQOZRWDWIWJWGXHSXEXGWAIVFTWDWIIUGPZXHXISXEAXJWCAIXFVNZUJZWAIVG
      TWDIDQOZRSZIVTQOZRSZXIRSZAXNWCAXMWLRAXJWKXMWLSXKWNIDVGTAWJWKWMJVHVIUJWDXO
      WRRWDXJWQXOWRSXLXDIVTVGTWDWPWSXCVJVIWDXJWKWQXNXPUEXQVKXLWOXDIDVTVLVMVOVPX
      BWHCWBWEEWTWBSXAWGRWTWBIQUQURKUSVQNVR $.

    $( Lemma for ~ eulerth .  (Contributed by Mario Carneiro, 28-Feb-2014.) $)
    eulerthlem2 $p |- ( ph -> ( ( A ^ ( phi ` N ) ) mod N ) = ( 1 mod N ) ) $=
      ( co cmo c1 wceq cmul wcel vz vw cphi cfv cexp cmin cdivides wbr cseq cle
      cgcd wa cn cz simp1d phicld nnred adantr cv wi breq1 anbi2d oveq2 oveq12d
      fveq2 oveq1d eqeq12d oveq2d eqeq1d anbi12d imbi12d weq cr cc0 wf1o wf syl
      cfz nnuz syl6eleq syl6eleqr ffvelrnd oveq1 elrab2 simpld elfzoelz zmulcld
      cuz sylib zred modabs2 syl2anc ovex fvmpt zcnd a1i 3eqtr4rd gcdcom simprd
      1z eqtrd lep1d adantl syl3anc cn0 ad2antrl zexpcl wss wb mpbird ffvelrnda
      nnzd adantlr syldan seqcl sseldi mp3an2 modmul1 syl22anc cc seqp1 mulcomd
      eqtr4d sylibd mpan2d eleq2i sylan2br wf1 wral coprmdvds elfzole1 elfzolt2
      moddvds clt modid sylan cfn mp2an sylancl mpbid leidd caddc crp cfzo f1of
      simp2d eluzfz1 nnrpd seq1i exp1d seq1 ax-mp oveq2i jca nnre peano2re letr
      syl5eq mpand imdistanda imim1d nnnn0 simprl simprr letrd nnz fzss2 sselda
      eluz syl6sseqr zmulcl crab ssrab2 eulerthlem1 peano2nn nnge1d elfz 3expia
      eqsstri mpbir2and mul4d expp1d modcld recnd 3eqtr4d rpmul sylibrd anim12d
      syl221anc an12s ex a2d syld nnind mpcom mpdan nnnn0d ccnv ccom mulcom w3a
      mulass ssid f1ocnv adantrr adantrl eqeqan12d subdid breq2d 3bitr4d simp3d
      mulcl zsubcld f1of1 f1fveq 3bitr3d sylbid ralrimivva sylanbrc cen eqeltri
      dff13 cvv f1oen fzofi ssfi f1finf1o f1oco f1oeq23 fveq2d f1ocnvfv2 eqtr2d
      seqf1o eqeltrd mulid2d ax-1cn subdir zsubcl 3eqtr2d breqtrd mp2and mp3an3
      fvco3 ) ADIUCUDZUEOZIPOQIPORZIVUEQUFOZUGUHZAIVUDSGQUIZUDZVUGSOZUGUHZIVUJU
      KOZQRZVUHAIVUEVUJSOZVUDSHQUIZUDZUFOZVUKUGAVUOIPOZVUQIPOZRZIVURUGUHZAVVAVU
      NAVUDVUDUJUHZVVAVUNULZAVUDAVUDAIAIUMTZDUNTZDIUKOZQRZJUOZUPZUQZUUAVUDUMTZA
      VVCULZVVDAVVLVVCVVJURABUSZVUDUJUHZULZDVVNUEOZVVNVUIUDZSOZIPOZVVNVUPUDZIPO
      ZRZIVVRUKOZQRZULZUTAQVUDUJUHZULZDQUEOZQVUIUDZSOZIPOZQVUPUDZIPOZRZIVWJUKOZ
      QRZULZUTAUAUSZVUDUJUHZULZDVWSUEOZVWSVUIUDZSOZIPOZVWSVUPUDZIPOZRZIVXCUKOZQ
      RZULZUTZAVWSQUUBOZVUDUJUHZULZDVXMUEOZVXMVUIUDZSOZIPOZVXMVUPUDZIPOZRZIVXQU
      KOZQRZULZUTZVVMVVDUTBUAVUDVVNQRZVVPVWHVWFVWRVYGVVOVWGAVVNQVUDUJVAVBVYGVWC
      VWOVWEVWQVYGVVTVWLVWBVWNVYGVVSVWKIPVYGVVQVWIVVRVWJSVVNQDUEVCVVNQVUIVEZVDV
      FVYGVWAVWMIPVVNQVUPVEVFVGVYGVWDVWPQVYGVVRVWJIUKVYHVHVIVJVKBUAVLZVVPVXAVWF
      VXKVYIVVOVWTAVVNVWSVUDUJVAVBVYIVWCVXHVWEVXJVYIVVTVXEVWBVXGVYIVVSVXDIPVYIV
      VQVXBVVRVXCSVVNVWSDUEVCVVNVWSVUIVEZVDVFVYIVWAVXFIPVVNVWSVUPVEVFVGVYIVWDVX
      IQVYIVVRVXCIUKVYJVHVIVJVKVVNVXMRZVVPVXOVWFVYEVYKVVOVXNAVVNVXMVUDUJVAVBVYK
      VWCVYBVWEVYDVYKVVTVXSVWBVYAVYKVVSVXRIPVYKVVQVXPVVRVXQSVVNVXMDUEVCVVNVXMVU
      IVEZVDVFVYKVWAVXTIPVVNVXMVUPVEVFVGVYKVWDVYCQVYKVVRVXQIUKVYLVHVIVJVKVVNVUD
      RZVVPVVMVWFVVDVYMVVOVVCAVVNVUDVUDUJVAVBVYMVWCVVAVWEVUNVYMVVTVUSVWBVUTVYMV
      VSVUOIPVYMVVQVUEVVRVUJSVVNVUDDUEVCVVNVUDVUIVEZVDVFVYMVWAVUQIPVVNVUDVUPVEV
      FVGVYMVWDVUMQVYMVVRVUJIUKVYNVHVIVJVKAVWRVWGAVWOVWQADQGUDZSOZIPOZIPOZVYQVW
      NVWLAVYPVMTIUUCTZVYRVYQRAVYPADVYOAVVEVVFVVHJUUFZAVYOVNIUUDOZTZVYOUNTZAWUB
      VYOIUKOZQRZAVYOETWUBWUEULAFEQGAFEGVOZFEGVPZMFEGUUEVQZAQQVUDVROZFAVUDQWHUD
      ZTQWUITAVUDUMWUJVVJVSVTZQVUDUUGVQLWAZWBCUSZIUKOZQRZWUECVYOWUAEWUMVYORWUNW
      UDQWUMVYOIUKWCVIKWDWIZWEVYOVNIWFVQZWGWJAIVVIUUHZVYPIWKWLAVWMVYQIPAVYQSHQW
      TAQFTQHUDVYQRWULBQDVVNGUDZSOZIPOZVYQFHVYGWUTVYPIPVYGWUSVYODSVVNQGVEVHVFNV
      YPIPWMWNVQUUIVFAVWKVYPIPAVWIDVWJVYOSADADVYTWOZUUJVWJVYORZAQUNTZWVCWTSGQUU
      KUULZWPVDVFWQAVWPIVYOUKOZQVWJVYOIUKWVEUUMAWVFWUDQAIUNTZWUCWVFWUDRAIVVIXLZ
      WUQIVYOWRWLAWUBWUEWUPWSXAUURUUNURVWSUMTZVXLVXOVXKUTVYFWVIVXOVXAVXKWVIAVXN
      VWTWVIAULZVWSVXMUJUHZVXNVWTWVJVWSWVIVWSVMTZAVWSUUOZURZXBWVJWVLVXMVMTZVUDV
      MTZWVKVXNULVWTUTWVNWVJWVLWVOWVNVWSUUPZVQAWVPWVIVVKXCVWSVXMVUDUUQXDUUSUUTU
      VAWVIVXOVXKVYEWVIVXOVXKVYEUTZAWVIVXNWVRAWVIVXNULZULZVXHVYBVXJVYDWVTVXHVXD
      DVXMGUDZSOZSOZIPOZVXFWWBSOZIPOZRZVYBWVTVXDVMTZVXFVMTZWWBUNTZVYSVXHWWGUTWV
      TVXDWVTVXBVXCWVTVVFVWSXETZVXBUNTAVVFWVSVYTURZWVIWWKAVXNVWSUVBXFZDVWSXGWLZ
      WVTBCSUNGQVWSWVTVWSUMWUJAWVIVXNUVCVSVTZWVTVVNQVWSVROZTZVVNFTZWUSUNTZWVTWW
      PFVVNWVTWWPWUIFWVTVUDVWSWHUDTZWWPWUIXHWVTWWTVWTWVTVWSVXMVUDWVIWVLAVXNWVMX
      FZWVTWVLWVOWXAWVQVQAWVPWVSVVKURWVTVWSWXAXBAWVIVXNUVDZUVEWVTVWSUNTZVUDUNTZ
      WWTVWTXIWVIWXCAVXNVWSUVFXFAWXDWVSAVUDVVJXLURZVWSVUDUVIWLXJVWSQVUDUVGVQLUV
      JUVHZAWWRWWSWVSAWWRULZWUSWUATZWWSWXGWXHWUSIUKOZQRZWXGWUSETWXHWXJULAFEVVNG
      WUHXKWUOWXJCWUSWUAEWUMWUSRWUNWXIQWUMWUSIUKWCVIKWDWIWEWUSVNIWFVQZXMXNVVNUN
      TWUMUNTULZVVNWUMSOZUNTZWVTVVNWUMUVKZXCZXOZWGWJWVTVXFWVTBCSUNHQVWSWWOWVTWW
      QWWRVVNHUDZUNTZWXFAWWRWXSWVSWXGWXRWUATWXSWXGEWUAWXREWUOCWUAUVLWUAKWUOCWUA
      UVMUVSZAFEVVNHABCDEFGHIJKLMNUVNZXKXPWXRVNIWFVQXMXNWXPXOZWJWVTDWWAWWLWVTWW
      AWUATZWWAUNTZWVTWYCWWAIUKOZQRZWVTWWAETWYCWYFULWVTFEVXMGAWUGWVSWUHURWVTVXM
      WUIFWVTVXMWUITZQVXMUJUHZVXNWVTVXMWVIVXMUMTAVXNVWSUVOXFZUVPWXBWVTVXMUNTZWX
      DWYGWYHVXNULXIZWVTVXMWYIXLWXEWYJWVDWXDWYKWTVXMQVUDUVQXQWLUVTLWAZWBWUOWYFC
      WWAWUAEWUMWWARWUNWYEQWUMWWAIUKWCVIKWDWIZWEWWAVNIWFVQZWGZAVYSWVSWURURZWWHW
      WIULWWJVYSULVXHWWGVXDVXFWWBIXRUVRXSWVTWWDVXSWWFVYAWVTWWCVXRIPWVTWWCVXBDSO
      ZVXCWWASOZSOVXRWVTVXBVXCDWWAWVTVXBWWNWOWVTVXCWXQWOADXTTZWVSWVBURZWVTWWAWY
      NWOUWAWVTVXPWYQVXQWYRSWVTDVWSWYTWWMUWBWVTVWSWUJTZVXQWYRRWWOSGQVWSYAVQZVDY
      CVFWVTWWBIPOZVXFSOZIPOZWWBVXFSOZIPOZVYAWWFWVTXUCVMTWWBVMTZVXFUNTVYSXUCIPO
      XUCRZXUEXUGRWVTWWBIWVTWWBWYOWJZWYPUWCZXUJWYBWYPWVTXUHVYSXUIXUJWYPWWBIWKWL
      XUCWWBVXFIXRUWIWVTVXTXUDIPWVTVXFVXMHUDZSOZVXFXUCSOVXTXUDWVTXULXUCVXFSWVTV
      XMFTXULXUCRWYLBVXMWVAXUCFHVYKWUTWWBIPVYKWUSWWADSVVNVXMGVEVHVFNWWBIPWMWNVQ
      VHWVTXUAVXTXUMRWWOSHQVWSYAVQWVTXUCVXFWVTXUCXUKUWDWVTVXFWYBWOZYBUWEVFWVTWW
      EXUFIPWVTVXFWWBXUNWVTWWBWYOWOYBVFWQVGYDWVTVXJIWYRUKOZQRZVYDWVTVXJIWWAUKOZ
      QRZXUPWVTXUQWYEQWVTWVGWYDXUQWYERAWVGWVSWVHURZWYNIWWAWRWLWVTWYCWYFWYMWSXAW
      VTWVGVXCUNTWYDVXJXURULXUPUTXUSWXQWYNIVXCWWAUWFXDYEWVTVYCXUOQWVTVXQWYRIUKX
      UBVHVIUWGUWHUWJUWKUWLUWMUWNUWOUWPZWEAVVEVUOUNTVUQUNTVVAVVBXIVVIAVUEVUJAVV
      FVUDXETVUEUNTZVYTAVUDVVJUWQDVUDXGWLZABCSUNGQVUDWUKVVNWUITZAWWRWWSFWUIVVNL
      YFWXKYGZWXLWXNAWXOXCXOZWGAVUQVUJUNABCUAXTSXTUBGUWRZHUWSZGHQVUDVVNXTTZWUMX
      TTZULZWXMXTTAVVNWUMUXLXCXVJWXMWUMVVNSORAVVNWUMUWTXCXVHXVIVWSXTTUXAWXMVWSS
      OVVNWUMVWSSOSORAVVNWUMVWSUXBXCWUKXTXTXHAXTUXCWPAFFXVGVOZWUIWUIXVGVOZAEFXV
      FVOZFEHVOZXVKAWUFXVMMFEGUXDVQAFEHYHZXVNAFEHVPZWUMHUDZVWSHUDZRZCUAVLZUTZUA
      FYICFYIXVOWYAAXWACUAFFAWUMFTZVWSFTZULZULZXVSIDWUMGUDZVWSGUDZUFOZSOZUGUHZX
      VTXWEDXWFSOZIPOZDXWGSOZIPOZRZIXWKXWMUFOZUGUHZXVSXWJXWEVVEXWKUNTXWMUNTXWOX
      WQXIAVVEXWDVVIURZXWEDXWFAVVFXWDVYTURZXWEXWFWUATZXWFUNTZXWEEWUAXWFWXTAXWBX
      WFETXWCAFEWUMGWUHXKUXEXPZXWFVNIWFVQZWGXWEDXWGXWSXWEXWGWUATZXWGUNTZXWEEWUA
      XWGWXTAXWCXWGETXWBAFEVWSGWUHXKUXFXPZXWGVNIWFVQZWGXWKXWMIYMXDXWDXVSXWOXIAX
      WBXWCXVQXWLXVRXWNBWUMWVAXWLFHBCVLZWUTXWKIPXXHWUSXWFDSVVNWUMGVEVHVFNXWKIPW
      MWNBVWSWVAXWNFHVYIWUTXWMIPVYIWUSXWGDSVVNVWSGVEVHVFNXWMIPWMWNUXGXCXWEXWIXW
      PIUGXWEDXWFXWGAWYSXWDWVBURXWEXWFXXCWOXWEXWGXXGWOUXHUXIUXJXWEXWJIDUKOZQRZX
      VTAXXJXWDAXXIVVGQAWVGVVFXXIVVGRWVHVYTIDWRWLAVVEVVFVVHJUXKXAURXWEXWJXXJULZ
      IXWHUGUHZXVTXWEWVGVVFXWHUNTXXKXXLUTAWVGXWDWVHURXWSXWEXWFXWGXXCXXGUXMIDXWH
      YJXDXWEXWFIPOZXWGIPOZRZXWFXWGRZXXLXVTXWEXXMXWFXXNXWGXWEXWFVMTVYSVNXWFUJUH
      ZXWFIYNUHZXXMXWFRXWEXWFXXCWJAVYSXWDWURURZXWEXWTXXQXXBXWFVNIYKVQXWEXWTXXRX
      XBXWFVNIYLVQXWFIYOXSXWEXWGVMTVYSVNXWGUJUHZXWGIYNUHZXXNXWGRXWEXWGXXGWJXXSX
      WEXXDXXTXXFXWGVNIYKVQXWEXXDXYAXXFXWGVNIYLVQXWGIYOXSVGXWEVVEXXAXXEXXOXXLXI
      XWRXXCXXGXWFXWGIYMXDAFEGYHZXWDXXPXVTXIAWUFXYBMFEGUXNVQFEWUMVWSGUXOYPUXPYD
      YEUXQUXRCUAFEHUYBUXSAFEUXTUHZEYQTZXVOXVNXIAWUFXYCMFEGFWUIUYCLQVUDVRWMUYAU
      YDVQWUAYQTEWUAXHXYDVNIUYEWXTWUAEUYFYRFEHUYGYSYTFEFXVFHUYHWLFWUIRZXYEXVKXV
      LXILLFWUIFWUIXVGUYIYRWIAXVCULWUSXVDWOUBUSZWUITAXYFFTZXYFHUDZXYFXVGUDZGUDZ
      RFWUIXYFLYFAXYGULZXYJXYHXVFUDZGUDZXYHXYKXYIXYLGAXVPXYGXYIXYLRWYAFEXYFXVFH
      VUCYPUYJXYKWUFXYHETXYMXYHRAWUFXYGMURAFEXYFHWYAXKFEXYHGUYKWLUYLYGUYMZXVEUY
      NVUOVUQIYMXDYTAVURVUOQVUJSOZUFOZVUGVUJSOZVUKAVUQXYOVUOUFAVUQVUJXYOXYNAVUJ
      AVUJXVEWOZUYOYCVHAVUEXTTZVUJXTTZXYQXYPRZAVUEXVBWOXYRXYSQXTTXYTYUAUYPVUEQV
      UJUYQXQWLAVUGVUJAVUGAXVAWVDVUGUNTZXVBWTVUEQUYRYSZWOXYRYBUYSUYTAVVAVUNXUTW
      SAWVGVUJUNTYUBVULVUNULVUHUTWVHXVEYUCIVUJVUGYJXDVUAAVVEXVAVUFVUHXIZVVIXVBV
      VEXVAWVDYUDWTVUEQIYMVUBWLXJ $.
  $}

  ${
    $d f k x y A $.  $d f k x y N $.
    $( Euler's theorem, a generalization of Fermat's little theorem.  If ` A `
       and ` N ` are coprime, then ` A ^ phi ( N ) == 1 ` , mod ` N ` .
       (Contributed by Mario Carneiro, 28-Feb-2014.) $)
    eulerth $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
                    ( ( A ^ ( phi ` N ) ) mod N ) = ( 1 mod N ) ) $=
      ( vk vf vx vy wcel cgcd co c1 wceq cfv cc0 cmo chash cfn mp2an sylib cmul
      cv cn cz w3a cphi cfz cfzo crab wf1o cen wbr wex cn0 phicl nnnn0d hashfz1
      cexp syl dfphi2 eqtrd 3ad2ant1 wb fzfi fzofi ssrab2 ssfi hashen bren cmpt
      wss simpl oveq1 eqeq1d cbvrabv eqid simpr fveq2 oveq2d oveq1d eulerthlem2
      wa cbvmptv exlimddv ) BUAGZAUBGZABHIJKZUCZJBUDLZUEIZCTZBHIZJKZCMBUFIZUGZD
      TZUHZAWGUPIBNIJBNIKDWFWHWMUIUJZWODUKWFWHOLZWMOLZKZWPWCWDWSWEWCWQWGWRWCWGU
      LGWQWGKWCWGBUMUNWGUOUQCBURUSUTWHPGWMPGZWSWPVAJWGVBWLPGWMWLVIWTMBVCWKCWLVD
      WLWMVEQWHWMVFQRWHWMDVGRWFWOVTEFAWMWHWNCWHAWIWNLZSIZBNIZVHBWFWOVJWKFTZBHIZ
      JKCFWLWIXDKWJXEJWIXDBHVKVLVMWHVNWFWOVOCEWHXCAETZWNLZSIZBNIWIXFKZXBXHBNXIX
      AXGASWIXFWNVPVQVRWAVSWB $.
  $}

  $( Fermat's little theorem.  When ` P ` is prime, ` A ^ P == A ` , mod ` P `
     for any ` A ` .  (Contributed by Mario Carneiro, 28-Feb-2014.) $)
  fermltl $p |- ( ( P e. Prime /\ A e. ZZ ) ->
                  ( ( A ^ P ) mod P ) = ( A mod P ) ) $=
    ( wcel cz cexp co cmo wceq cc0 sylan w3a cn0 simp2 a1i nnnn0d eqtr4d oveq1d
    3ad2ant1 c1 cmul cprime wa cdivides wbr cn wb prmnn dvdsval3 0z nnrpd simp3
    crp 0mod syl modexp syl221anc 0expd 3expia sylbid wn cgcd coprm prmz gcdcom
    eqeq1d bitrd cphi cfv cr phicld zexpcl syl2anc zred eulerth syl3an1 modmul1
    1re cmin phiprm oveq2d cc zcnd expm1t mulid2d 3eqtr3d pm2.61d ) BUACZADCZUB
    ZBAUCUDZABEFZBGFZABGFZHZWIWJWMIHZWNWGBUECZWHWJWOUFBUGZBAUHJWGWHWOWNWGWHWOKZ
    WLIBEFZBGFZWMWRWHIDCZBLCBULCZWMIBGFZHWLWTHWGWHWOMXAWRUINWRBWGWHWPWOWQRZOWRB
    XDUJZWRWMIXCWGWHWOUKWRXBXCIHXEBUMUNPZAIBBUOUPWRWMXCWTXFWRWSIBGWRBXDUQQPPURU
    SWIWJUTZABVAFZSHZWNWIXGBAVAFZSHXIBAVBWIXJXHSWGBDCWHXJXHHBVCBAVDJVEVFWGWHXIW
    NWGWHXIKZABVGVHZEFZATFZBGFZSATFZBGFZWLWMXKXMVICSVICZWHXBXMBGFSBGFHZXOXQHXKX
    MXKWHXLLCXMDCWGWHXIMZXKXLXKBWGWHWPXIWQRZVJOAXLVKVLVMXRXKVQNXTXKBYAUJWGWPWHX
    IXSWQABVNVOXMSABVPUPXKXNWKBGXKXNABSVRFZEFZATFZWKXKXMYCATXKXLYBAEWGWHXLYBHXI
    BVSRVTQXKAWACWPWKYDHXKAXTWBZYAABWCVLPQXKXPABGXKAYEWDQWEURUSWF $.

  ${
    prmdiv.1 $e |- R = ( ( A ^ ( P - 2 ) ) mod P ) $.
    $( Show an explicit expression for the modular inverse of ` A mod P ` .
       (Contributed by Mario Carneiro, 24-Jan-2015.) $)
    prmdiv $p |- ( ( P e. Prime /\ A e. ZZ /\ -. P || A ) ->
      ( R e. ( 1 ... ( P - 1 ) ) /\ P || ( ( A x. R ) - 1 ) ) ) $=
      ( wcel cz cdivides wbr c1 cmin co cfz cmul cc0 wceq 3ad2ant1 syl2anc zcnd
      c2 cn0 cprime wn w3a caddc nprmdvds1 cphi cfv cexp cdiv cfl cn cgcd prmnn
      cmo simp2 prmz gcdcom coprm biimp3a eulerth syl3anc wb phiprm nnm1nn0 syl
      eqtrd eqeltrd zexpcl a1i moddvds mpbid cuz prmuz2 uznn0sub nndivred flcld
      1z zmulcld dvdsmul1 wa wi zsubcl sylancl dvds2sub mp2and subdid crp nnrpd
      zred cr modval syl5eq oveq2d 2m1e1 oveq2i syl6eqr nncnd cc ax-1cn subsubd
      expp1d mulcomd 3eqtrd mul12d oveq12d 3eqtr4d oveq1d sub32d breqtrrd oveq2
      breq2d syl5ibcom cneg mul01d df-neg dvdsnegb bitr4d sylibd mtod wo zmodfz
      2cn syl5eqel nn0uz syl6eleq elfzp12 ord mpd 1e0p1 oveq1i syl6eleqr jca )
      BUAEZAFEZBAGHUBZUCZCIBIJKZLKZEBACMKZIJKZGHZYPCNIUDKZYQLKZYRYPCNOZUBCUUCEZ
      YPUUDBIGHZYMYNUUFUBYOBUEPYPUUDBANMKZIJKZGHZUUFYPUUAUUDUUIYPBABUFUGZUHKZIJ
      KZBAABSJKZUHKZBUIKZUJUGZMKZMKZJKZYTGYPBUULGHZBUURGHZBUUSGHZYPUUKBUNKIBUNK
      OZUUTYPBUKEZYNABULKZIOUVCYMYNUVDYOBUMPZYMYNYOUOZYPUVEBAULKZIYPYNBFEZUVEUV
      HOUVGYMYNUVIYOBUPPZABUQQYMYNYOUVHIOBAURUSVFABUTVAYPUVDUUKFEZIFEZUVCUUTVBU
      VFYPYNUUJTEUVKUVGYPUUJYQTYMYNUUJYQOYOBVCPZYPUVDYQTEUVFBVDVEZVGAUUJVHQZUVL
      YPVQVIUUKIBVJVAVKYPUVIUUQFEUVAUVJYPAUUPUVGYPUUOYPUUNBYPUUNYPYNUUMTEZUUNFE
      ZUVGYPBSVLUGEZUVPYMYNUVRYOBVMPSBVNVEZAUUMVHQZWIZUVFVOVPZVRZBUUQVSQYPUVIUU
      LFEZUURFEUUTUVAVTUVBWAUVJYPUVKUVLUWDUVOVQUUKIWBWCYPBUUQUVJUWCVRZBUULUURWD
      VAWEYPYTUUKUURJKZIJKUUSYPYSUWFIJYPAUUNBUUPMKZJKZMKAUUNMKZAUWGMKZJKYSUWFYP
      AUUNUWGYPAUVGRZYPUUNUVTRZYPUWGYPBUUPUVJUWBVRRWFYPCUWHAMYPCUUNBUNKZUWHDYPU
      UNWJEBWGEUWMUWHOUWAYPBUVFWHUUNBWKQWLWMYPUUKUWIUURUWJJYPUUKAUUMIUDKZUHKUUN
      AMKUWIYPUUJUWNAUHYPUUJBSIJKZJKZUWNYPUUJYQUWPUVMUWOIBJWNWOWPYPBSIYPBUVFWQZ
      SWREYPYBVIIWREYPWSVIZWTVFWMYPAUUMUWKUVSXAYPUUNAUWLUWKXBXCYPBAUUPUWQUWKYPU
      UPUWBRXDXEXFXGYPUUKUURIYPUUKUVORYPUURUWERUWRXHVFXIZUUDYTUUHBGUUDYSUUGIJCN
      AMXJXGXKXLYPUUIBIXMZGHZUUFYPUUHUWTBGYPUUHNIJKUWTYPUUGNIJYPAUWKXNXGIXOWPXK
      YPUVIUVLUUFUXAVBUVJVQBIXPWCXQXRXSYPUUDUUEYPCNYQLKZEZUUDUUEXTZYPCUWMUXBDYP
      UVQUVDUWMUXBEUVTUVFUUNBYAQYCYPYQNVLUGZEUXCUXDVBYPYQTUXEUVNYDYECNYQYFVEVKY
      GYHIUUBYQLYIYJYKUWSYL $.

    $( The modular inverse of ` A mod P ` is unique.  (Contributed by Mario
       Carneiro, 24-Jan-2015.) $)
    prmdiveq $p |- ( ( P e. Prime /\ A e. ZZ /\ -. P || A ) ->
     ( ( S e. ( 0 ... ( P - 1 ) ) /\ P || ( ( A x. S ) - 1 ) ) <-> S = R ) ) $=
      ( wcel cz cdivides wbr cc0 c1 cmin co cfz cmul wa wceq cmo ad2antrl zcnd
      cprime wn w3a cgcd simprr prmdiv adantr simprd wi simpl1 prmz syl elfzelz
      simpl2 zmulcld 1z zsubcl sylancl simpld dvds2sub syl3anc mp2and cc ax-1cn
      a1i nnncan2d elfznn0 nn0red recnd subdid eqtr4d breqtrd simpl3 wb syl2anc
      cn0 coprm mpbid zsubcld coprmdvds cn prmnn moddvds mpbird crp cle elfzle1
      cr clt nnrpd elfzle2 zltlem1 modid syl22anc c2 cexp cuz cfv uznn0sub 3syl
      prmuz2 zexpcl modabs2 oveq1i 3eqtr4g 3eqtr3d ex caddc 1e0p1 wss 0z fzp1ss
      zred ax-mp eqsstri sseli eleq1 syl5ibr oveq2 oveq1d breq2d biimprd impbid
      anim12d syl5com ) BUAFZAGFZBAHIUBZUCZDJBKLMZNMZFZBADOMZKLMZHIZPZDCQZYIYPY
      QYIYPPZDBRMZCBRMZDCYRYSYTQZBDCLMZHIZYRBAUUBOMZHIZBAUDMKQZUUCYRBYNACOMZKLM
      ZLMZUUDHYRYOBUUHHIZBUUIHIZYIYLYOUEYRCKYJNMZFZUUJYIUUMUUJPZYPABCEUFZUGZUHY
      RBGFZYNGFZUUHGFZYOUUJPUUKUIYRYFUUQYFYGYHYPUJZBUKULZYRYMGFKGFZUURYRADYFYGY
      HYPUNZYLDGFZYIYODJYJUMSZUOZUPYMKUQURYRUUGGFUVBUUSYRACUVCYRUUMCGFZYRUUMUUJ
      UUPUSCKYJUMULZUOZUPUUGKUQURBYNUUHUTVAVBYRUUIYMUUGLMUUDYRYMUUGKYRYMUVFTYRU
      UGUVITKVCFYRVDVEVFYRADCYRAUVCTYRDYRDYLDVPFYIYODYJVGSVHZVIYRCUVHTVJVKVLYRY
      HUUFYFYGYHYPVMYRYFYGYHUUFVNUUTUVCBAVQVOVRYRUUQYGUUBGFUUEUUFPUUCUIUVAUVCYR
      DCUVEUVHVSBAUUBVTVAVBYRBWAFZUVDUVGUUAUUCVNYRYFUVKUUTBWBULZUVEUVHDCBWCVAWD
      YRDWHFBWEFZJDWFIZDBWIIZYSDQUVJYRBUVLWJZYLUVNYIYODJYJWGSYRUVODYJWFIZYLUVQY
      IYODJYJWKSYRUVDUUQUVOUVQVNUVEUVADBWLVOWDDBWMWNYRABWOLMZWPMZBRMZBRMZUVTYTC
      YRUVSWHFUVMUWAUVTQYRUVSYRYGUVRVPFZUVSGFUVCYRYFBWOWQWRFUWBUUTBXAWOBWSWTAUV
      RXBVOXMUVPUVSBXCVOCUVTBREXDEXEXFXGYIUUNYQYPUUOYQUUMYLUUJYOUUMYLYQCYKFUULY
      KCUULJKXHMZYJNMZYKKUWCYJNXIXDJGFUWDYKXJXKJYJXLXNXOXPDCYKXQXRYQYOUUJYQYNUU
      HBHYQYMUUGKLDCAOXSXTYAYBYDYEYC $.

    $( The (modular) inverse of the inverse of a number is itself.
       (Contributed by Mario Carneiro, 24-Jan-2015.) $)
    prmdivdiv $p |- ( ( P e. Prime /\ A e. ( 1 ... ( P - 1 ) ) ) ->
                      A = ( ( R ^ ( P - 2 ) ) mod P ) ) $=
      ( wcel c1 cmin co cfz wa cc0 cmul cdivides wbr cz wn cn fzm1ndvds syl3anc
      elfznn cprime c2 cexp cmo wceq caddc 1e0p1 oveq1i 0z fzp1ss ax-mp eqsstri
      wss simpr sseldi simpl adantl nnzd prmnn sylan prmdiv simprd nncnd simpld
      syl mulcomd oveq1d breqtrd elfzelz adantr syl2anc eqid prmdiveq mpbi2and
      wb ) BUAEZAFBFGHZIHZEZJZAKVQIHZEZBCALHZFGHZMNZACBUBGHUCHBUDHZUEZVTVRWAAVR
      KFUFHZVQIHZWAFWHVQIUGUHKOEWIWAUMUIKVQUJUKULVPVSUNUOVTBACLHZFGHZWDMVTCVREZ
      BWKMNZVTVPAOEBAMNPZWLWMJVPVSUPZVTAVSAQEVPAVQTUQZURVPBQEZVSWNBUSZBARUTABCD
      VASZVBVTWJWCFGVTACVTAWPVCVTCVTWLCQEVTWLWMWSVDZCVQTVEVCVFVGVHVTVPCOEZBCMNP
      ZWBWEJWGVOWOVTWLXAWTCFVQVIVEVTWQWLXBVPWQVSWRVJWTBCRVKCBWFAWFVLVMSVN $.
  $}

  $(
  @( A sum formula for the Euler ` phi ` function. @)
  phisum @p |- ( N e. NN -> sum_ k e. { x e. NN | x || N } ( phi ` k ) = N ) @=
    ? @.
    @( [28-Feb-2014] @)
  $)

  ${
    $d m n x N $.  $d n x A $.  $d n K $.
    $( Value of the order function.  This is a function of functions; the inner
       argument selects the base (i.e. mod ` N ` for some ` N ` , often prime)
       and the outer argument selects the integer or equivalence class (if you
       want to think about it that way) from the integers mod ` N ` .  In order
       to ensure the supremum is well-defined, we only define the expression
       when ` A ` and ` N ` are coprime.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    odzval $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
                  ( ( odZ ` N ) ` A ) = sup ( { n e. NN |
                    N || ( ( A ^ n ) - 1 ) } , RR , `' < ) ) $=
      ( vx vm cn wcel cz cgcd co c1 wceq cfv cv cexp cmin cdivides wbr crab cr
      codz ccnv csup wa cmpt oveq2 eqeq1d rabbidv oveq1 cbvrabv syl6eqr supeq1d
      clt breq1 mpteq12dv df-odz zex rabex mptex fvmpt fveq1d elrab oveq1d eqid
      breq2d wor ltso cnvso mpbi supex sylbir sylan9eq 3impb ) CFGZAHGZACIJZKLZ
      ACUAMZMZCABNZOJZKPJZQRZBFSZTUMUBZUCZLVNVOVQUDZVSADVTCIJZKLZBHSZCDNZVTOJZK
      PJZQRZBFSZTWEUCZUEZMZWFVNAVRWQECDWKENZIJZKLZDHSZWSWMQRZBFSZTWEUCZUEWQFUAW
      SCLZDXBXEWJWPXFXBWKCIJZKLZDHSWJXFXAXHDHXFWTXGKWSCWKIUFUGUHWIXHBDHVTWKLWHX
      GKVTWKCIUIUGUJUKXFTXDWOWEXFXCWNBFWSCWMQUNUHULUODBEUPDWJWPWIBHUQURUSUTVAWG
      AWJGWRWFLWIVQBAHVTALWHVPKVTACIUIUGVBDAWPWFWJWQWKALZTWOWDWEXIWNWCBFXIWMWBC
      QXIWLWAKPWKAVTOUIVCVEUHULWQVDTWDWETUMVFTWEVFVGTUMVHVIVJUTVKVLVM $.

    $( - Lemma for ~ odzcl , showing existence of a recurrent point for the
       exponential.  (Contributed by Mario Carneiro, 28-Feb-2014.) $)
    odzcllem $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
                    ( ( ( odZ ` N ) ` A ) e. NN /\
                      N || ( ( A ^ ( ( odZ ` N ) ` A ) ) - 1 ) ) ) $=
      ( vn cn wcel cz cgcd co wceq cfv cexp cmin cdivides wbr cmo syl2anc oveq2
      c1 oveq1d breq2d w3a codz cv crab wa cr clt ccnv odzval cuz wss c0 ssrab2
      csup wne nnuz sseqtri wrex cphi phicl 3ad2ant1 eulerth wb simp1 cn0 simp2
      nnnn0d zexpcl moddvds mp3an3 mpbid rspcev rabn0 sylibr infmssuzcl sylancr
      1z eqeltrd elrab sylib ) BDEZAFEZABGHRIZUAZABUBJJZBACUCZKHZRLHZMNZCDUDZEW
      EDEBAWEKHZRLHZMNZUEWDWEWJUFUGUHUNZWJACBUIWDWJRUJJZUKWJULUOZWNWJEWJDWOWICD
      UMUPUQWDWICDURZWPWDBUSJZDEZBAWRKHZRLHZMNZWQWAWBWSWCBUTVAZWDWTBOHRBOHIZXBA
      BVBWDWAWTFEZXDXBVCZWAWBWCVDWDWBWRVEEXEWAWBWCVFWDWRXCVGAWRVHPWAXERFEXFVQWT
      RBVIVJPVKWIXBCWRDWFWRIZWHXABMXGWGWTRLWFWRAKQSTVLPWICDVMVNWJRVOVPVRWIWMCWE
      DWFWEIZWHWLBMXHWGWKRLWFWEAKQSTVSVT $.

    $( The order of a group element is an integer.  (Contributed by Mario
       Carneiro, 28-Feb-2014.) $)
    odzcl $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
                 ( ( odZ ` N ) ` A ) e. NN ) $=
      ( cn wcel cz cgcd co c1 wceq w3a codz cfv cexp cmin cdivides wbr odzcllem
      simpld ) BCDAEDABFGHIJABKLLZCDBASMGHNGOPABQR $.

    $( Any element raised to the power of its order is ` 1 ` .  (Contributed by
       Mario Carneiro, 28-Feb-2014.) $)
    odzid $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
                      N || ( ( A ^ ( ( odZ ` N ) ` A ) ) - 1 ) ) $=
      ( cn wcel cz cgcd co c1 wceq w3a codz cfv cexp cmin cdivides wbr odzcllem
      simprd ) BCDAEDABFGHIJABKLLZCDBASMGHNGOPABQR $.

    $( The only powers of ` A ` that are congruent to ` 1 ` are the multiples
       of the order of ` A ` .  (Contributed by Mario Carneiro,
       28-Feb-2014.) $)
    odzdvds $p |- ( ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) /\ K e. NN0 )
      -> ( N || ( ( A ^ K ) - 1 ) <-> ( ( odZ ` N ) ` A ) || K ) ) $=
      ( vn cn wcel cz co wceq cn0 cmo cexp cmin cdivides wbr cc0 syl2anc oveq1d
      c1 cr cgcd w3a wa codz cfv wn cle clt crp nn0re adantl odzcl adantr nnrpd
      wi modlt nn0z zmodcld nn0red nnred ltnled mpbid cv crab ccnv oveq2 breq2d
      csup elrab cuz ssrab2 nnuz sseqtri infmssuzle sylbir ancoms odzval breq1d
      wss mpan syl5ibr mtod imnan sylibr elnn0 sylib ord syld simpl1 nnzd dvds0
      wo syl simpl2 zcnd exp0d 1m1e0 syl6eq breqtrrd syl5ibrcom impbid cdiv cfl
      nnnn0d nndivred nn0ge0 wb nngt0d ge0div syl3anc flge0nn0 nn0mulcld zexpcl
      cmul zred 1re expmuld 1z odzid moddvds mpbird modexp syl221anc flcld 1exp
      a1i 3eqtrd modmul1 caddc expaddd modval oveq2d nn0cnd recnd pncan3d eqtrd
      eqtr3d mulid2d 3eqtr3d eqeq1d sylancom 3bitr3d dvdsval3 3bitr4d ) CEFZAGF
      ZACUAHSIZUBZBJFZUCZCABACUDUEUEZKHZLHZSMHZNOZUULPIZCABLHZSMHNOZUUKBNOZUUJU
      UOUUPUUJUUOUULEFZUFZUUPUUJUUOUUTUCZUFUUOUVAUOUUJUVBUUKUULUGOZUUJUULUUKUHO
      ZUVCUFUUJBTFZUUKUIFZUVDUUIUVEUUHBUJUKZUUJUUKUUHUUKEFZUUIACULUMZUNZBUUKUPQ
      UUJUULUUKUUJUULUUJBUUKUUIBGFZUUHBUQUKZUVIURZUSUUJUUKUVIUTZVAVBUVBUVCUUJCA
      DVCZLHZSMHZNOZDEVDZTUHVEVHZUULUGOZUUTUUOUWAUUTUUOUCUULUVSFZUWAUVRUUODUULE
      UVOUULIZUVQUUNCNUWCUVPUUMSMUVOUULALVFRVGVIUVSSVJUEZVSUWBUWAUVSEUWDUVRDEVK
      VLVMUULUVSSVNVTVOVPUUJUUKUVTUULUGUUHUUKUVTIUUIADCVQUMVRWAWBUUOUUTWCWDUUJU
      UTUUPUUJUULJFZUUTUUPWLUVMUULWEWFWGWHUUJUUOUUPCAPLHZSMHZNOUUJCPUWGNUUJCGFC
      PNOUUJCUUEUUFUUGUUIWIZWJCWKWMUUJUWGSSMHPUUJUWFSSMUUJAUUJAUUEUUFUUGUUIWNZW
      OZWPRWQWRWSUUPUUNUWGCNUUPUUMUWFSMUULPALVFRVGWTXAUUJUUQCKHZSCKHZIZUUMCKHZU
      WLIZUURUUOUUJUWKUWNUWLUUJAUUKBUUKXBHZXCUEZXNHZLHZUUMXNHZCKHZSUUMXNHZCKHZU
      WKUWNUUJUWSTFSTFZUUMGFZCUIFZUWSCKHZUWLIUXAUXCIUUJUWSUUJUUFUWRJFUWSGFUWIUU
      JUUKUWQUUJUUKUVIXDZUUJUWPTFPUWPUGOZUWQJFZUUJBUUKUVGUVIXEZUUJPBUGOZUXIUUIU
      XLUUHBXFUKUUJUVEUUKTFPUUKUHOUXLUXIXGUVGUVNUUJUUKUVIXHBUUKXIXJVBUWPXKQZXLZ
      AUWRXMQXOUXDUUJXPYFUUJUUFUWEUXEUWIUVMAUULXMQZUUJCUWHUNZUUJUXGAUUKLHZUWQLH
      ZCKHZSUWQLHZCKHZUWLUUJUWSUXRCKUUJAUUKUWQUWJUXMUXHXQRUUJUXQGFZSGFZUXJUXFUX
      QCKHUWLIZUXSUYAIUUJUUFUUKJFUYBUWIUXHAUUKXMQZUYCUUJXRYFZUXMUXPUUJUYDCUXQSM
      HNOZUUHUYGUUIACXSUMUUJUUEUYBUYCUYDUYGXGUWHUYEUYFUXQSCXTXJYAUXQSUWQCYBYCUU
      JUXTSCKUUJUWQGFUXTSIUUJUWPUXKYDUWQYEWMRYGUWSSUUMCYHYCUUJUWTUUQCKUUJAUWRUU
      LYIHZLHUWTUUQUUJAUWRUULUWJUVMUXNYJUUJUYHBALUUJUYHUWRBUWRMHZYIHBUUJUULUYIU
      WRYIUUJUVEUVFUULUYIIUVGUVJBUUKYKQYLUUJUWRBUUJUWRUXNYMUUJBUVGYNYOYPYLYQRUU
      JUXBUUMCKUUJUUMUUJUUMUXOWOYRRYSYTUUJUUEUUQGFZUYCUWMUURXGUWHUUHUUIUUFUYJUW
      IABXMUUAUYFUUQSCXTXJUUJUUEUXEUYCUWOUUOXGUWHUXOUYFUUMSCXTXJUUBUUJUVHUVKUUS
      UUPXGUVIUVLUUKBUUCQUUD $.

    $( The order of any group element is a divisor of the Euler ` phi `
       function.  (Contributed by Mario Carneiro, 28-Feb-2014.) $)
    odzphi $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
                  ( ( odZ ` N ) ` A ) || ( phi ` N ) ) $=
      ( cn wcel cz cgcd co c1 wceq w3a cphi cfv cexp cmin cdivides wbr codz cmo
      wb mpbid eulerth simp1 cn0 simp2 phicld nnnn0d zexpcl syl2anc a1i moddvds
      1z syl3anc odzdvds mpdan ) BCDZAEDZABFGHIZJZBABKLZMGZHNGOPZABQLLUSOPZURUT
      BRGHBRGIZVAABUAURUOUTEDZHEDZVCVASUOUPUQUBZURUPUSUCDZVDUOUPUQUDURUSURBVFUE
      UFZAUSUGUHVEURUKUIUTHBUJULTURVGVAVBSVHAUSBUMUNT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Pythagorean Triples
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( If three numbers are coprime, and the square of one is the product of the
     other two, then there is a formula for the other two in terms of ` gcd `
     and square.  (Contributed by Scott Fenton, 2-Apr-2014.)  (Revised by Mario
     Carneiro, 19-Apr-2014.) $)
  coprimeprodsq $p |- ( ( ( A e. NN0 /\ B e. ZZ /\ C e. NN0 ) /\
    ( ( A gcd B ) gcd C ) = 1 ) -> ( ( C ^ 2 ) = ( A x. B ) ->
      A = ( ( A gcd C ) ^ 2 ) ) ) $=
    ( cn0 wcel cz w3a cgcd co c1 wceq cmul 3ad2ant1 nn0cnd nn0zd mulgcd syl3anc
    3eqtr3d oveq2d gcdass c2 cexp nn0z gcdcl syl2an 3adant2 sqvald simp13 nn0cn
    cc mulcomd simpl3 eqeq1d biimp3a oveq12d simp11 simp12 mulgcdr sylan ancoms
    wa 3adant1 cfv 3ad2ant3 gcdid syl oveq1d simp2 gcdabs1 syl2anc eqtrd gcdcom
    cabs 3eqtr4d biimpar 3adant3 mulid1d 3eqtrrd 3expia ) ADEZBFEZCDEZGZABHICHI
    ZJKZCUAUBIZABLIZKZAACHIZUAUBIZKWCWEWHGZWJWIWILIZAWICBHIZHIZLIZAWKWIWKWIWCWE
    WIDEZWHVTWBWPWAVTAFEZCFEZWPWBAUCZCUCZACUDUEUFMZNUGWKAWILIZCWILIZHIZXBAWMLIZ
    HIZWLWOWKXCXEXBHWKCALIZCCLIZHIZACLIZWGHIZXCXEWKXGXJXHWGHWKCAWKCVTWAWBWEWHUH
    ZNWCWEAUJEZWHVTWAXMWBAUIMMZUKWCWEWHXHWGKWCWEVAZWFXHWGXOCXOCVTWAWBWEULNUGUMU
    NUOWKWBWQWRXIXCKXLWKAVTWAWBWEWHUPZOZWKCXLOZCACPQWKVTWRWAXKXEKXPXRVTWAWBWEWH
    UQACBPQRSWKWQWRWPXDWLKXQXRXAACWIURQWKVTWIFEWMFEZXFWOKXPWKWIXAOWKWMWCWEWMDEZ
    WHWAWBXTVTWBWAXTWBWRWAXTWTCBUDUSUTVBZMOAWIWMPQRWKWOAJLIZAWCWEWOYBKWHXOWNJAL
    WCWNJKWEWCWNWDJWCACWMHIZHIZABCHIZHIZWNWDWCYCYEAHWCCCHIZBHIZWMYCYEWCYHCVMVCZ
    BHIZWMWCYGYIBHWCWRYGYIKWBVTWRWAWTVDZCVEVFVGWCWRWAYJWMKYKVTWAWBVHZBCVIVJVKWC
    WRWRWAYHYCKYKYKYLBCCTQWCWRWAWMYEKYKYLCBVLVJRSWCWQWRXSWNYDKVTWAWQWBWSMZYKWCW
    MYAOWMCATQWCWQWAWRWDYFKYMYLYKCBATQVNUMVOSVPWKAXNVQVKVRVS $.

  $( If three numbers are coprime, and the square of one is the product of the
     other two, then there is a formula for the other two in terms of ` gcd `
     and square.  (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by
     Mario Carneiro, 19-Apr-2014.) $)
  coprimeprodsq2 $p |- ( ( ( A e. ZZ /\ B e. NN0 /\ C e. NN0 ) /\
    ( ( A gcd B ) gcd C ) = 1 ) -> ( ( C ^ 2 ) = ( A x. B ) ->
      B = ( ( B gcd C ) ^ 2 ) ) ) $=
    ( cz wcel cn0 w3a cgcd co c1 wceq wa c2 cexp cmul zcn nn0cn mulcom 3adant3
    cc syl2an adantr eqeq2d wi simpl2 simpl1 simpl3 gcdcom oveq1d eqeq1d sylan2
    wb nn0z biimpa coprimeprodsq syl31anc sylbid ) ADEZBFEZCFEZGZABHIZCHIZJKZLZ
    CMNIZABOIZKVFBAOIZKZBBCHIMNIKZVEVGVHVFVAVGVHKZVDURUSVKUTURATEBTEVKUSAPBQABR
    UASUBUCVEUSURUTBAHIZCHIZJKZVIVJUDURUSUTVDUEURUSUTVDUFURUSUTVDUGVAVDVNURUSVD
    VNULZUTUSURBDEZVOBUMURVPLZVCVMJVQVBVLCHABUHUIUJUKSUNBACUOUPUQ $.

  ${
    $d A a b c $.  $d B a b c $.
    $( The sum of two odds is even.  (Contributed by Scott Fenton,
       7-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    opoe $p |- ( ( ( A e. ZZ /\ -. 2 || A ) /\ ( B e. ZZ /\ -. 2 || B ) ) ->
       2 || ( A + B ) ) $=
      ( va vb cz wcel c2 cdivides wbr wn caddc co wa cmul c1 wceq cc 2cn ax-1cn
      wrex cv odd2np1 bi2anan9 reeanv 2z zaddcl peano2zd dvdsmul1 sylancr addcl
      zcn adddi mp3an13 syl mp3an1 oveq1d eqtrd mulid1i df-2 eqtri oveq2i mulcl
      syl6eq mpan add4 mpanr12 syl2an breqtrd oveq12 breq2d syl5ibcom rexlimivv
      sylbir syl6bi imp an4s ) AEFZBEFZGAHIJZGBHIJZGABKLZHIZVQVRMZVSVTMZWBWCWDG
      CUAZNLZOKLZAPZCETZGDUAZNLZOKLZBPZDETZMZWBVQVSWIVRVTWNCAUBDBUBUCWOWHWMMZDE
      TCETWBWHWMCDEEUDWPWBCDEEWEEFZWJEFZMZGWGWLKLZHIWPWBWSGGWEWJKLZOKLZNLZWTHWS
      GEFXBEFGXCHIUEWSXAWEWJUFUGGXBUHUIWQWEQFZWJQFZXCWTPWRWEUKWJUKXDXEMZXCWFWKK
      LZOOKLZKLZWTXFXCXGGONLZKLZXIXFXCGXANLZXJKLZXKXFXAQFZXCXMPZWEWJUJGQFZXNOQF
      ZXORSGXAOULUMUNXFXLXGXJKXPXDXEXLXGPRGWEWJULUOUPUQXJXHXGKXJGXHGRURUSUTVAVC
      XDWFQFZWKQFZXIWTPZXEXPXDXRRGWEVBVDXPXEXSRGWJVBVDXRXSMXQXQXTSSWFWKOOVEVFVG
      UQVGVHWPWTWAGHWGAWLBKVIVJVKVLVMVNVOVP $.

    $( The difference of two odds is even.  (Contributed by Scott Fenton,
       7-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    omoe $p |- ( ( ( A e. ZZ /\ -. 2 || A ) /\ ( B e. ZZ /\ -. 2 || B ) ) ->
       2 || ( A - B ) ) $=
      ( va vb cz wcel c2 cdivides wbr wn cmin co wa cv cmul c1 wceq wrex cc 2cn
      caddc odd2np1 bi2anan9 reeanv 2z zsubcl dvdsmul1 sylancr zcn mulcl ax-1cn
      mpan pnpcan2 mp3an3 syl2an mp3an1 eqtr4d breqtrrd oveq12 breq2d syl5ibcom
      subdi rexlimivv sylbir syl6bi imp an4s ) AEFZBEFZGAHIJZGBHIJZGABKLZHIZVHV
      IMZVJVKMZVMVNVOGCNZOLZPUALZAQZCERZGDNZOLZPUALZBQZDERZMZVMVHVJVTVIVKWECAUB
      DBUBUCWFVSWDMZDERCERVMVSWDCDEEUDWGVMCDEEVPEFZWAEFZMZGVRWCKLZHIWGVMWJGGVPW
      AKLZOLZWKHWJGEFWLEFGWMHIUEVPWAUFGWLUGUHWHVPSFZWASFZWKWMQWIVPUIWAUIWNWOMWK
      VQWBKLZWMWNVQSFZWBSFZWKWPQZWOGSFZWNWQTGVPUJULWTWOWRTGWAUJULWQWRPSFWSUKVQW
      BPUMUNUOWTWNWOWMWPQTGVPWAVBUPUQUOURWGWKVLGHVRAWCBKUSUTVAVCVDVEVFVG $.

    $( The sum of an odd and an even is odd.  (Contributed by Scott Fenton,
       7-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    opeo $p |- ( ( ( A e. ZZ /\ -. 2 || A ) /\ ( B e. ZZ /\ 2 || B ) ) ->
      -. 2 || ( A + B ) ) $=
      ( vc va vb cz wcel c2 cdivides wbr wa caddc co cmul c1 wceq wrex mpan 2cn
      cc wn cv odd2np1 wb 2z divides bi2anan9 reeanv zaddcl adddi mp3an1 oveq1d
      mulcl ax-1cn add32 mp3an3 syl2an mulcom adantl oveq2d 3eqtrd oveq2 eqeq1d
      zcn rspcev syl2anc oveq12 eqeq2d rexbidv syl5ibcom sylbir syl6bi imp an4s
      rexlimivv ad2ant2r syl mpbird ) AFGZHAIJUAZKBFGZHBIJZKKZHABLMZIJUAZHCUBZN
      MZOLMZWDPZCFQZVSWAVTWBWJVSWAKZVTWBKZWJWKWLHDUBZNMZOLMZAPZDFQZEUBZHNMZBPZE
      FQZKZWJVSVTWQWAWBXADAUCHFGWAWBXAUDUEEHBUFRUGXBWPWTKZEFQDFQWJWPWTDEFFUHXCW
      JDEFFWMFGZWRFGZKZWHWOWSLMZPZCFQZXCWJXFWMWRLMZFGHXJNMZOLMZXGPZXIWMWRUIXDWM
      TGZWRTGZXMXEWMVDWRVDXNXOKZXLWNHWRNMZLMZOLMZWOXQLMZXGXPXKXROLHTGZXNXOXKXRP
      SHWMWRUJUKULXNWNTGZXQTGZXSXTPZXOYAXNYBSHWMUMRYAXOYCSHWRUMRYBYCOTGYDUNWNXQ
      OUOUPUQXPXQWSWOLXOXQWSPZXNYAXOYESHWRURRUSUTVAUQXHXMCXJFWFXJPZWHXLXGYFWGXK
      OLWFXJHNVBULVCVEVFXCXHWICFXCXGWDWHWOAWSBLVGVHVIVJVOVKVLVMVNWCWDFGZWEWJUDV
      SWAYGVTWBABUIVPCWDUCVQVR $.

    $( The difference of an odd and an even is odd.  (Contributed by Scott
       Fenton, 7-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    omeo $p |- ( ( ( A e. ZZ /\ -. 2 || A ) /\ ( B e. ZZ /\ 2 || B ) ) ->
      -. 2 || ( A - B ) ) $=
      ( vc va vb cz wcel c2 cdivides wa cmin co cmul c1 caddc wceq wrex mpan cc
      2cn wbr wn cv odd2np1 wb divides bi2anan9 reeanv zsubcl zcn mp3an1 oveq1d
      subdi mulcl ax-1cn addsub mp3an2 syl2an mulcom oveq2d adantl oveq2 eqeq1d
      2z 3eqtr2d rspcev syl2anc oveq12 eqeq2d syl5ibcom rexlimivv sylbir syl6bi
      rexbidv imp an4s ad2ant2r syl mpbird ) AFGZHAIUAUBZJBFGZHBIUAZJJZHABKLZIU
      AUBZHCUCZMLZNOLZWEPZCFQZVTWBWAWCWKVTWBJZWAWCJZWKWLWMHDUCZMLZNOLZAPZDFQZEU
      CZHMLZBPZEFQZJZWKVTWAWRWBWCXBDAUDHFGWBWCXBUEVDEHBUFRUGXCWQXAJZEFQDFQWKWQX
      ADEFFUHXDWKDEFFWNFGZWSFGZJZWIWPWTKLZPZCFQZXDWKXGWNWSKLZFGHXKMLZNOLZXHPZXJ
      WNWSUIXEWNSGZWSSGZXNXFWNUJWSUJXOXPJZXMWOHWSMLZKLZNOLZWPXRKLZXHXQXLXSNOHSG
      ZXOXPXLXSPTHWNWSUMUKULXOWOSGZXRSGZYAXTPZXPYBXOYCTHWNUNRYBXPYDTHWSUNRYCNSG
      YDYEUOWONXRUPUQURXPYAXHPXOXPXRWTWPKYBXPXRWTPTHWSUSRUTVAVEURXIXNCXKFWGXKPZ
      WIXMXHYFWHXLNOWGXKHMVBULVCVFVGXDXIWJCFXDXHWEWIWPAWTBKVHVIVNVJVKVLVMVOVPWD
      WEFGZWFWKUEVTWBYGWAWCABUIVQCWEUDVRVS $.
  $}

  $( A prime not equal to ` 2 ` is odd.  (Contributed by Mario Carneiro,
     4-Feb-2015.) $)
  oddprm $p |- ( N e. ( Prime \ { 2 } ) -> ( ( N - 1 ) / 2 ) e. NN ) $=
    ( cprime c2 wcel c1 co cz cc0 clt wbr cn cdivides wn wb 2z ax-mp wa mpanr12
    syl2anc 3syl csn cdif cmin cdiv eldifi prmz syl wceq eldifsni necomd neneqd
    cuz cfv uzid dvdsprm sylancr mtbird 1z 2prm nprmdvds1 omoe cn0 nnm1nn0 nn0z
    prmnn wne 2ne0 dvdsval2 mp3an12 mpbid prmuz2 uz2m1nn cr nnre nngt0 2re 2pos
    divgt0 4syl elnnz sylanbrc ) ABCUAZUBDZAEUCFZCUDFZGDZHWEIJZWEKDWCCWDLJZWFWC
    AGDZCALJZMZWHWCABDZWIABWBUEZAUFUGWCWJCAUHZWCCAWCACABCUIUJUKWCCCULUMZDZWLWJW
    NNCGDZWPOCUNPWMACUOUPUQWIWKQEGDCELJMZWHURCBDWRUSCUTPAEVARSWCWDVBDZWDGDZWHWF
    NZWCWLAKDWSWMAVEAVCTWDVDWQCHVFWTXAOVGCWDVHVITVJWCWLAWODWDKDZWGWMAVKAVLXBWDV
    MDZHWDIJZWGWDVNWDVOXCXDQCVMDHCIJWGVPVQWDCVRRSVSWEVTWA $.

  ${
    $d A n m k $.  $d B n m k $.  $d C n m k $.
    $( Lemma for ~ pythagtrip .  Prove a weaker version of one direction of the
       theorem.  (Contributed by Scott Fenton, 28-Mar-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    pythagtriplem1 $p |- (
       E. n e. NN E. m e. NN E. k e. NN
       ( A = ( k x. ( ( m ^ 2 ) - ( n ^ 2 ) ) ) /\
         B = ( k x. ( 2 x. ( m x. n ) ) ) /\
         C = ( k x. ( ( m ^ 2 ) + ( n ^ 2 ) ) ) ) ->
        ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) ) $=
      ( c2 cexp co cmin cmul wceq caddc cn wcel cc sqcld 2cn mulcl c4 cv w3a wa
      wrex wi nncn adantl syl2anr sylancr subcld adantr ancoms add32d subadd23d
      sqcl sqmul sq2 a1i oveq12d eqtrd oveq1d 4cn 2p2e4 subaddrii oveq1i subdir
      mp3an12 syl5reqr oveq2d binom2sub 3eqtr4d 3adant3 simp3 3ad2ant2 3ad2ant1
      syl binom2 sqmuld 3ad2ant3 adddid eqtr4d addcld syl3an eqeq12d syl5ibrcom
      oveq1 oveqan12d 3expa rexlimdva rexlimivv ) ADUAZEUAZGHIZFUAZGHIZJIZKIZLZ
      BWKGWLWNKIZKIZKIZLZCWKWMWOMIZKIZLZUBZDNUDAGHIZBGHIZMIZCGHIZLZFENNWNNOZWLN
      OZUCXFXKDNXLXMWKNOZXFXKUEXLXMXNUBXKXFWQGHIZXAGHIZMIZXDGHIZLZXLWNPOZXMWLPO
      ZXNWKPOZXSWNUFWLUFWKUFXTYAYBUBZWKGHIZWPGHIZWTGHIZMIZKIZYDXCGHIZKIXQXRYCYG
      YIYDKXTYAYGYILYBXTYAUCZWMGHIZGWMWOKIZKIZJIZWOGHIZMIZYFMIZYKYMMIZYOMIZYGYI
      YJYQYNYFMIZYOMIYSYJYNYOYFYJYKYMYJWMYAWMPOZXTWLUOZUGQZYJGPOZYLPOZYMPORYAUU
      AWOPOZUUEXTUUBWNUOZWMWOSUHZGYLSUIZUJYJWOXTUUFYAUUGUKQYJWTYJUUDWSPOZWTPOZR
      YAXTUUJWLWNSULZGWSSZUIQZUMYJYTYRYOMYJYTYKYFYMJIZMIYRYJYKYMYFUUCUUIUUNUNYJ
      UUOYMYKMYJUUOTYLKIZYMJIZYMYJYFUUPYMJYJYFGGHIZWSGHIZKIZUUPYJUUDUUJYFUUTLRU
      ULGWSUPUIYJUURTUUSYLKUURTLYJUQURYAXTUUSYLLWLWNUPULUSUTVAYJYMTGJIZYLKIZUUQ
      UVAGYLKTGGVBRRVCVDVEYJUUEUVBUUQLZUUHTPOUUDUUEUVCVBRTGYLVFVGVPVHUTVIUTVAUT
      YJYEYPYFMYAUUAUUFYEYPLXTUUBUUGWMWOVJUHVAYAUUAUUFYIYSLXTUUBUUGWMWOVQUHVKVL
      VIYCXQYDYEKIZYDYFKIZMIYHYCXOUVDXPUVEMYCWKWPXTYAYBVMZYCWMWOYAXTUUAYBUUBVNZ
      XTYAUUFYBUUGVOZUJZVRYCWKWTUVFYCUUDUUJUUKRXTYAUUJYBUULVLUUMUIZVRUSYCYDYEYF
      YBXTYDPOYAWKUOVSYCWPUVIQYCWTUVJQVTWAYCWKXCUVFYCWMWOUVGUVHWBVRVKWCXFXIXQXJ
      XRWRXBXIXQLXEWRXBXGXOXHXPMAWQGHWFBXAGHWFWGVLXEWRXJXRLXBCXDGHWFVSWDWEWHWIW
      J $.

    $( Lemma for ~ pythagtrip .  Prove the full version of one direction of the
       theorem.  (Contributed by Scott Fenton, 28-Mar-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    pythagtriplem2 $p |- ( ( A e. NN /\ B e. NN ) -> (
       E. n e. NN E. m e. NN E. k e. NN
       ( { A , B } = { ( k x. ( ( m ^ 2 ) - ( n ^ 2 ) ) ) ,
                       ( k x. ( 2 x. ( m x. n ) ) ) } /\
         C = ( k x. ( ( m ^ 2 ) + ( n ^ 2 ) ) ) ) ->
        ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) ) ) $=
      ( cn wcel wa cv c2 cexp co cmul wceq caddc wrex w3a wo cvv cpr wb mpanr12
      cmin preq12bg anbi1d df-3an orbi12i bitr4i syl6bb rexbidv 2rexbidv r19.43
      ovex andir 2rexbii rexbii 3bitri wi pythagtriplem1 a1i 3ancoma sylbi nncn
      cc sqcld addcom syl2an eqeq1d syl5ibr jaod sylbid ) AGHZBGHZIZABUADJZEJZK
      LMZFJZKLMZUDMZNMZVPKVQVSNMNMZNMZUAOZCVPVRVTPMNMOZIZDGQZEGQFGQZAWBOZBWDOZW
      FRZDGQZEGQZFGQZAWDOZBWBOZWFRZDGQZEGQZFGQZSZAKLMZBKLMZPMZCKLMZOZVOWIWLWRSZ
      DGQZEGQFGQZXBVOWHXIFEGGVOWGXHDGVOWGWJWKIZWPWQIZSZWFIZXHVOWEXMWFVOWBTHWDTH
      WEXMUBVPWANUNVPWCNUNABWBWDGGTTUEUCUFXNXKWFIZXLWFIZSXHXKXLWFUOWLXOWRXPWJWK
      WFUGWPWQWFUGUHUIUJUKULXJWMWSSZEGQZFGQWNWTSZFGQXBXIXQFEGGWLWRDGUMUPXRXSFGW
      MWSEGUMUQWNWTFGUMURUJVOWOXGXAWOXGUSVOABCDEFUTVAXAXGVOXDXCPMZXFOZXAWQWPWFR
      ZDGQZEGQFGQYAWSYCFEGGWRYBDGWPWQWFVBUQUPBACDEFUTVCVOXEXTXFVMXCVEHXDVEHXEXT
      OVNVMAAVDVFVNBBVDVFXCXDVGVHVIVJVKVL $.

  $}

  ${
    $( Lemma for ~ pythagtrip .  Show that ` C ` and ` B ` are relatively prime
       under some conditions.  (Contributed by Scott Fenton, 8-Apr-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem3 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) ->
       ( B gcd C ) = 1 ) $=
      ( cn wcel w3a c2 cexp co wceq c1 wbr wa cz nnz zsqcl syl 3ad2ant1 syl2anc
      cgcd caddc cdivides wn adantl 3ad2ant2 gcdadd gcdcom eqtr3d adantr simpl2
      oveq2 simpl3 sqgcd simpl1 3eqtr4d 3adant3 simp3l oveq1d eqtrd cr 3ad2ant3
      cc0 cle wb gcdcld nn0red nn0ge0d 1re 0le1 sq11 mpanr12 mpbid ) ADEZBDEZCD
      EZFZAGHIZBGHIZUAIZCGHIZJZABTIZKJZGAUBLUCZMZFZBCTIZGHIZKGHIZJZWGKJZWFWHWBG
      HIZWIVPWAWHWLJWEVPWAMZVRVTTIZVQVRTIZWHWLWMVRVSTIZWNWOWAWPWNJVPVSVTVRTUKUD
      VPWPWOJWAVPVRVQTIZWPWOVPVRNEZVQNEZWQWPJVNVMWRVOVNBNEZWRBOZBPQUEZVMVNWSVOV
      MANEWSAOAPQRZVRVQUFSVPWRWSWQWOJXBXCVRVQUGSUHUIUHWMVNVOWHWNJVMVNVOWAUJZVMV
      NVOWAULBCUMSWMVMVNWLWOJVMVNVOWAUNXDABUMSUOUPWFWBKGHVPWAWCWDUQURUSWFWGUTEZ
      VBWGVCLZWJWKVDZVPWAXEWEVPWGVPBCVNVMWTVOXAUEVOVMCNEVNCOVAVEZVFRVPWAXFWEVPW
      GXHVGRXEXFMKUTEVBKVCLXGVHVIWGKVJVKSVL $.
  $}

  ${
    $( Lemma for ~ pythagtrip .  Show that ` C - B ` and ` C + B ` are
       relatively prime.  (Contributed by Scott Fenton, 12-Apr-2014.)  (Revised
       by Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem4 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) ->
       ( ( C - B ) gcd ( C + B ) ) = 1 ) $=
      ( cn wcel c2 co caddc wceq cgcd c1 cdivides wbr wa cmin cmul nnzd syl2anc
      cz nncnd w3a cexp wn wo simp3r nnz zsubcl syl2anr 3adant1 3ad2ant1 simp13
      simp12 nnaddcld gcddvds simprd breq1 biimpd mpan9 simpl13 simpl12 zaddcld
      wi zsubcld 2z dvdsmultr1 mp3an1 mpd subsq breqtrrd simpl2 simpl11 nnsqcld
      cc oveq1d pncand eqtr3d breqtrd adantr cprime 2prm 2nn prmdvdsexp mp3an13
      wb syl mpbid mtand cneg 1nn0 nn0negzi pnncan 3anidm23 subcl mulm1d oveq2d
      gcdaddm addcl negsubd 2times adantl 3eqtr4d zmulcl sylancr eqbrtrd ppncan
      1z 3anidm13 mulid2d cc0 wne nnaddcl nnne0d ancoms neneqd intnand syl21anc
      gcdn0cl dvdsgcd syl3anc mp2and cn0 2nn0 mulgcd pythagtriplem3 2cn mulid1i
      eqtrd syl6eq dvdsprime orel1 sylc ) ADEZBDEZCDEZUAZAFUBGZBFUBGZHGZCFUBGZI
      ZABJGKIZFALMZUCZNZUAZCBOGZCBHGZJGZFIZUCUUIUUHKIZUDZUUJUUEUUIUUBYOYTUUAUUC
      UEUUEUUINZFYPLMZUUBUULFYSYQOGZYPLUULFUUGUUFPGZUUNLUULFUUGLMZFUUOLMZUUEUUH
      UUGLMZUUIUUPUUEUUHUUFLMZUURUUEUUFSEZUUGSEZUUSUURNYOYTUUTUUDYMYNUUTYLYNCSE
      ZBSEZUUTYMCUFBUFCBUGUHUIUJZUUEUUGUUECBYLYMYNYTUUDUKZYLYMYNYTUUDULZUMQZUUF
      UUGUNRUOUUIUURUUPUUHFUUGLUPUQURUULUVAUUTUUPUUQVBZUULCBUULCYLYMYNYTUUDUUIU
      SZQZUULBYLYMYNYTUUDUUIUTZQZVAUULCBUVJUVLVCFSEZUVAUUTUVHVDFUUGUUFVEVFRVGUU
      LCVMEZBVMEZUUNUUOIUULCUVITUULBUVKTCBVHRVIUULYRYQOGUUNYPUULYRYSYQOYOYTUUDU
      UIVJVNUULYPYQUULYPUULAYLYMYNYTUUDUUIVKVLTUULYQUULBUVKVLTVOVPVQUULASEZUUMU
      UBWDZUUEUVPUUIYOYTUVPUUDYLYMUVPYNAUFUJUJVRFVSEZUVPFDEUVQVTWAAFFWBWCWEWFWG
      UUEUUHFLMZUUKUUEUUHFBPGZFCPGZJGZFLUUEUUHUVTLMZUUHUWALMZUUHUWBLMZUUEUUHUUF
      UVTJGZUVTLUUEUUHUUFUUGKWHZUUFPGZHGZJGZUWFUUEUUTUVAUUHUWJIZUVDUVGUWGSEUUTU
      VAUWKKWIWJUWGUUFUUGWPVFRUUEUVNUVOUWJUWFIUUECUVETZUUEBUVFTZUVNUVONZUWIUVTU
      UFJUWNUUGUUFOGZBBHGZUWIUVTUVNUVOUWOUWPICBBWKWLUWNUWIUUGUUFWHZHGUWOUWNUWHU
      WQUUGHUWNUUFCBWMZWNWOUWNUUGUUFCBWQUWRWRYGUVOUVTUWPIUVNBWSWTXAWORYGUUEUWFU
      UFLMZUWFUVTLMZUUEUUTUVTSEZUWSUWTNUVDUUEUVMUVCUXAVDUUEBUVFQZFBXBXCZUUFUVTU
      NRUOXDUUEUUHUUFUWAJGZUWALUUEUUHUUFUUGKUUFPGZHGZJGZUXDUUEUUTUVAUUHUXGIZUVD
      UVGKSEUUTUVAUXHXFKUUFUUGWPVFRUUEUXFUWAUUFJUUEUVNUVOUXFUWAIUWLUWMUWNUUGUUF
      HGZCCHGZUXFUWAUVNUVOUXIUXJICBCXEXGUWNUXEUUFUUGHUWNUUFUWRXHWOUVNUWAUXJIUVO
      CWSVRXARWOYGUUEUXDUUFLMZUXDUWALMZUUEUUTUWASEZUXKUXLNUVDUUEUVMUVBUXMVDUUEC
      UVEQZFCXBXCZUUFUWAUNRUOXDUUEUUHSEUXAUXMUWCUWDNUWEVBUUEUUHUUEUUTUVAUUFXIIZ
      UUGXIIZNUCUUHDEZUVDUVGUUEUXQUXPUUEUUGXIYOYTUUGXIXJZUUDYMYNUXSYLYNYMUXSYNY
      MNUUGCBXKXLXMUIUJXNXOUUFUUGXQXPZQUXCUXOUUHUVTUWAXRXSXTUUEUWBFBCJGZPGZFUUE
      UVCUVBUWBUYBIZUXBUXNFYAEUVCUVBUYCYBFBCYCVFRUUEUYBFKPGFUUEUYAKFPABCYDWOFYE
      YFYHYGVQUUEUVRUXRUVSUUKWDVTUXTFUUHYIXCWFUUIUUJYJYK $.
  $}

  $( Lemma for ~ pythagtrip .  Show that ` C - B ` is positive.  (Contributed
     by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
     19-Apr-2014.) $)
  pythagtriplem10 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) ) -> 0 < ( C - B ) ) $=
    ( cn wcel c2 cexp co clt wbr cr nnre 3ad2ant1 resqcld 3ad2ant2 mpbid adantr
    cc0 3ad2ant3 cle w3a caddc wceq wa cmin wne nnne0 sqgt0d ltaddpos2d breqtrd
    simpr nnnn0 nn0ge0d lt2sqd mpbird posdifd ) ADEZBDEZCDEZUAZAFGHZBFGHZUBHZCF
    GHZUCZUDZBCIJZRCBUEHIJVFVGVBVDIJVFVBVCVDIUTVBVCIJZVEUTRVAIJVHUTAUQURAKEUSAL
    MZUQURARUFUSAUGMUHUTVAVBUTAVINUTBURUQBKEZUSBLOZNUIPQUTVEUKUJVFBCUTVJVEVKQZU
    TCKEZVEUSUQVMURCLSQZUTRBTJZVEURUQVOUSURBBULUMOQUTRCTJZVEUSUQVPURUSCCULUMSQU
    NUOVFBCVLVNUPP $.

  $( Lemma for ~ pythagtrip .  Calculate ` ( sqr `` ( C - B ) ) ` .
     (Contributed by Scott Fenton, 18-Apr-2014.)  (Revised by Mario Carneiro,
     19-Apr-2014.) $)
  pythagtriplem6 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) ->
       ( sqr ` ( C - B ) ) = ( ( C - B ) gcd A ) ) $=
    ( cn wcel w3a c2 cexp co caddc wceq cgcd c1 cmin csqr nnz 3ad2ant2 3ad2ant1
    cz eqtrd cdivides wbr cfv cn0 cmul cc0 clt 3ad2ant3 zsubcld pythagtriplem10
    wn wa 3adant3 elnnz sylanbrc simp3 simp2 nnaddcld nnzd nnnn0 pythagtriplem4
    nnnn0d 3jca oveq1d 1gcd syl jca oveq1 zcnd sqcld cc nncn pncand subsq nncnd
    syl2anc mulcomd 3eqtr3d coprimeprodsq fveq2d gcdcld nn0red nn0ge0d sqrsqd
    sylc ) ADEZBDEZCDEZFZAGHIZBGHIZJIZCGHIZKZABLIMKGAUAUBUKULZFZCBNIZOUCWQALIZG
    HIZOUCWRWPWQWSOWPWQUDEZCBJIZSEZAUDEZFZWQXALIZALIZMKZULWJWQXAUEIZKWQWSKWPXDX
    GWPWTXBXCWPWQWPWQSEZUFWQUGUBZWQDEWIWNXIWOWICBWHWFCSEWGCPUHWGWFBSEWHBPQUIZRZ
    WIWNXJWOABCUJUMWQUNUOVBWIWNXBWOWIXAWICBWFWGWHUPWFWGWHUQURZUSRWIWNXCWOWFWGXC
    WHAUTRRVCWPXFMALIZMWPXEMALABCVAVDWPASEZXNMKWIWNXOWOWFWGXOWHAPRZRZAVEVFTVGWP
    WLWKNIZWMWKNIZWJXHWNWIXRXSKWOWLWMWKNVHQWIWNXRWJKWOWIWJWKWIAWIAXPVIVJWIBWGWF
    BVKEZWHBVLQZVJVMRWIWNXSXHKWOWIXSXAWQUEIZXHWICVKEZXTXSYBKWHWFYCWGCVLUHYACBVN
    VPWIXAWQWIXAXMVOWIWQXKVIVQTRVRWQXAAVSWEVTWPWRWPWRWPWQAXLXQWAZWBWPWRYDWCWDT
    $.

  $( Lemma for ~ pythagtrip .  Calculate ` ( sqr `` ( C + B ) ) ` .
     (Contributed by Scott Fenton, 18-Apr-2014.)  (Revised by Mario Carneiro,
     19-Apr-2014.) $)
  pythagtriplem7 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) ->
       ( sqr ` ( C + B ) ) = ( ( C + B ) gcd A ) ) $=
    ( cn wcel c2 cexp co wceq cgcd c1 csqr cmin cz nnzd 3ad2ant1 eqtrd cc nncnd
    w3a caddc cdivides wbr wn wa cfv cn0 cmul simp3 simp2 nnaddcld nnnn0d nnnn0
    zsubcld 3jca pythagtriplem4 oveq1d nnz 1gcd syl oveq1 3ad2ant2 sqcld pncand
    nncn subsq syl2anc zcnd mulcomd 3eqtr3d coprimeprodsq2 fveq2d gcdcld nn0red
    jca sylc nn0ge0d sqrsqd ) ADEZBDEZCDEZTZAFGHZBFGHZUAHZCFGHZIZABJHKIFAUBUCUD
    UEZTZCBUAHZLUFWJAJHZFGHZLUFWKWIWJWLLWICBMHZNEZWJUGEZAUGEZTZWMWJJHZAJHZKIZUE
    WCWMWJUHHZIWJWLIWIWQWTWIWNWOWPWBWGWNWHWBCBWBCVSVTWAUIZOWBBVSVTWAUJZOUNZPWBW
    GWOWHWBWJWBCBXBXCUKZULPWBWGWPWHVSVTWPWAAUMPPUOWIWSKAJHZKWIWRKAJABCUPUQWIANE
    ZXFKIWBWGXGWHVSVTXGWAAURPPZAUSUTQVOWIWEWDMHZWFWDMHZWCXAWGWBXIXJIWHWEWFWDMVA
    VBWBWGXIWCIWHWBWCWDWBAVSVTAREWAAVEPVCWBBWBBXCSZVCVDPWBWGXJXAIWHWBXJWJWMUHHZ
    XAWBCREBREXJXLIWBCXBSXKCBVFVGWBWJWMWBWJXESWBWMXDVHVIQPVJWMWJAVKVPVLWIWKWIWK
    WIWJAWBWGWJNEWHWBWJXEOPXHVMZVNWIWKXMVQVRQ $.

  $( Lemma for ~ pythagtrip .  Show that ` ( sqr `` ( C - B ) ) ` is a natural
     number (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario
     Carneiro, 19-Apr-2014.) $)
  pythagtriplem8 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> ( sqr ` ( C - B ) ) e. NN ) $=
    ( cn wcel w3a c2 cexp co caddc wceq cgcd c1 cdivides wn wa cc0 nnz 3ad2ant1
    cz wbr cmin csqr pythagtriplem6 zsubcl syl2anr 3adant1 nnne0 neneqd intnand
    cfv gcdn0cl syl21anc eqeltrd ) ADEZBDEZCDEZFZAGHIBGHIJICGHIKZABLIMKGANUAOPZ
    FCBUBIZUCUKVAALIZDABCUDURUSVBDEZUTURVATEZATEZVAQKZAQKZPOZVCUPUQVDUOUQCTEBTE
    VDUPCRBRCBUEUFUGUOUPVEUQARSUOUPVHUQUOVGVFUOAQAUHUIUJSVAAULUMSUN $.

  $( Lemma for ~ pythagtrip .  Show that ` ( sqr `` ( C + B ) ) ` is a natural
     number (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario
     Carneiro, 19-Apr-2014.) $)
  pythagtriplem9 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> ( sqr ` ( C + B ) ) e. NN ) $=
    ( cn wcel w3a c2 cexp co caddc wceq cgcd c1 cdivides wn wa cc0 nnz 3ad2ant1
    cz wbr csqr cfv pythagtriplem7 zaddcl syl2anr 3adant1 nnne0 intnand gcdn0cl
    neneqd syl21anc eqeltrd ) ADEZBDEZCDEZFZAGHIBGHIJICGHIKZABLIMKGANUAOPZFZCBJ
    IZUBUCVAALIZDABCUDUTVATEZATEZVAQKZAQKZPOZVBDEUQURVCUSUOUPVCUNUPCTEBTEVCUOCR
    BRCBUEUFUGSUQURVDUSUNUOVDUPARSSUQURVGUSUNUOVGUPUNVFVEUNAQAUHUKUISSVAAUJULUM
    $.

  ${
    pythagtriplem11.1 $e |- M = ( ( ( sqr ` ( C + B ) ) + ( sqr ` ( C - B ) ) )
        / 2 ) $.
    $( Lemma for ~ pythagtrip .  Show that ` M ` (which will eventually be
       closely related to the ` m ` in the final statement) is a natural.
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    pythagtriplem11 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> M e. NN ) $=
      ( cn wcel c2 cexp co caddc cgcd cdivides wbr wn wa cz cc0 wb 3ad2ant1 w3a
      wceq c1 csqr cfv cmin cdiv clt pythagtriplem9 simp3r nnz 3ad2ant3 zaddcld
      nnzd 3ad2ant2 dvdsgcdb mp3an1 syl2anc biimpar simprd mtand pythagtriplem7
      breq2d mtbird pythagtriplem8 zsubcld pythagtriplem6 syl22anc nnaddcld wne
      2z opoe dvdsval2 mp3an12 syl mpbid nnred nngt0d addgt0d cr halfpos2 elnnz
      2ne0 sylanbrc syl5eqel ) AFGZBFGZCFGZUAZAHIJBHIJKJCHIJUBZABLJUCUBZHAMNZOZ
      PZUAZDCBKJZUDUEZCBUFJZUDUEZKJZHUGJZFEWOXAQGZRXAUHNZXAFGWOHWTMNZXBWOWQQGHW
      QMNZOWSQGHWSMNZOXDWOWQABCUIZUNWOXEHWPALJZMNZWOXIWLWIWJWKWMUJZWOXIPHWPMNZW
      LWOXKWLPZXIWOWPQGZAQGZXLXISZWIWJXMWNWICBWHWFCQGWGCUKULZWGWFBQGWHBUKUOZUMT
      WIWJXNWNWFWGXNWHAUKTTZHQGZXMXNXOVKHWPAUPUQURUSUTVAWOWQXHHMABCVBVCVDWOWSAB
      CVEZUNWOXFHWRALJZMNZWOYBWLXJWOYBPHWRMNZWLWOYCWLPZYBWOWRQGZXNYDYBSZWIWJYEW
      NWICBXPXQVFTXRXSYEXNYFVKHWRAUPUQURUSUTVAWOWSYAHMABCVGVCVDWQWSVLVHWOWTQGZX
      DXBSZWOWTWOWQWSXGXTVIZUNXSHRVJYGYHVKWCHWTVMVNVOVPWORWTUHNZXCWOWQWSWOWQXGV
      QWOWSXTVQWOWQXGVRWOWSXTVRVSWOWTVTGYJXCSWOWTYIVQWTWAVOVPXAWBWDWE $.

    $( Lemma for ~ pythagtrip .  Calculate the square of ` M ` .  (Contributed
       by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    pythagtriplem12 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> ( M ^ 2 ) = ( ( C + A ) / 2 ) ) $=
      ( wcel c2 cexp co caddc wceq wbr csqr cdiv cmul cc 3ad2ant1 cc0 2cn cr cn
      w3a cgcd c1 cdivides wn cfv cmin oveq1i nncn addcl syl2anr 3adant1 sqrcld
      wa subcl addcld wne sqdiv mp3an23 sqvali oveq2i syl6eq syl binom2 syl2anc
      2ne0 cle nnre readdcl clt 3ad2ant3 3ad2ant2 addgt0d wi 0re ltle mpan sylc
      nngt0 resqrth oveq1d resubcl pythagtriplem10 3adant3 oveq12d mulcld mulcl
      sylancr add32d adddi mp3an1 ppncand 2timesd eqtr4d pncand 3eqtr3rd fveq2d
      oveq1 sqrmuld nn0ge0d sqrsqd 3eqtr3d oveq2d 3eqtrd 3adant2 pm3.2i divdiv1
      sqcld subsq nnnn0 divcan3 syl5eq ) AUAFZBUAFZCUAFZUBZAGHIZBGHIZJIZCGHIZKZ
      ABUCIUDKGAUELUFUOZUBZDGHICBJIZMUGZCBUHIZMUGZJIZGNIZGHIZCAJIZGNIZDYJGHEUIY
      DYKYIGHIZGGOIZNIZGYLOIZGNIZGNIZYMYDYIPFZYKYPKXQYBYTYCXQYFYHXQYEXOXPYEPFZX
      NXPCPFZBPFZUUAXOCUJZBUJZCBUKULUMZUNZXQYGXOXPYGPFZXNXPUUBUUCUUHXOUUDUUECBU
      PULUMZUNZUQQYTYKYNGGHIZNIZYPYTGPFZGRURZYKUULKSVGYIGUSUTUUKYOYNNGSVAVBVCVD
      YDYPYQYONIZYSYDYNYQYONYDYNYFGHIZGYFYHOIZOIZJIZYHGHIZJIZYEUURJIZYGJIZYQYDY
      FPFZYHPFZYNUVAKXQYBUVDYCUUGQXQYBUVEYCUUJQYFYHVEVFYDUUSUVBUUTYGJYDUUPYEUUR
      JYDYETFZRYEVHLZUUPYEKXQYBUVFYCXOXPUVFXNXPCTFZBTFZUVFXOCVIZBVIZCBVJULUMQZY
      DUVFRYEVKLZUVGUVLXQYBUVMYCXQCBXPXNUVHXOUVJVLXOXNUVIXPUVKVMXPXNRCVKLXOCVTV
      LXOXNRBVKLXPBVTVMVNQRTFZUVFUVMUVGVOVPRYEVQVRVSZYEWAVFWBYDYGTFZRYGVHLZUUTY
      GKXQYBUVPYCXOXPUVPXNXPUVHUVIUVPXOUVJUVKCBWCULUMQZYDUVPRYGVKLZUVQUVRXQYBUV
      SYCABCWDWEUVNUVPUVSUVQVOVPRYGVQVRVSZYGWAVFWFYDUVCYEYGJIZUURJIZYQYDYEUURYG
      XQYBUUAYCUUFQXQYBUURPFZYCXQUUMUUQPFUWCSXQYFYHUUGUUJWGGUUQWHWIQXQYBUUHYCUU
      IQWJYDYQGCOIZGAOIZJIZUWBYDUUBAPFZYQUWFKZXQYBUUBYCXPXNUUBXOUUDVLQZXQYBUWGY
      CXNXOUWGXPAUJZQQZUUMUUBUWGUWHSGCAWKWLVFYDUWAUWDUURUWEJYDUWACCJIUWDYDCBCUW
      IXQYBUUCYCXOXNUUCXPUUEVMQZUWIWMYDCUWIWNWOYDUUQAGOYDYEYGOIZMUGXRMUGUUQAYDU
      WMXRMYDXTXSUHIZYAXSUHIZXRUWMYBXQUWNUWOKYCXTYAXSUHWSVMYDXRXSYDAUWKXIYDBUWL
      XIWPYDUUBUUCUWOUWMKUWIUWLCBXJVFWQWRYDYEYGUVLUVOUVRUVTWTYDAXQYBATFZYCXNXOU
      WPXPAVIQQXQYBRAVHLZYCXNXOUWQXPXNAAXKXAQQXBXCXDWFWOWOXEWBYDYQPFZYSUUOKZYDU
      UMYLPFZUWRSXQYBUWTYCXNXPUWTXOXPUUBUWGUWTXNUUDUWJCAUKULXFQZGYLWHWIUWRUUMUU
      NUOZUXBUWSUUMUUNSVGXGZUXCYQGGXHUTVDWOYDYRYLGNYDUWTYRYLKZUXAUWTUUMUUNUXDSV
      GYLGXLUTVDWBXEXM $.

  $}

  ${
    pythagtriplem13.1 $e |- N = ( ( ( sqr ` ( C + B ) ) - ( sqr ` ( C - B ) ) )
        / 2 ) $.
    $( Lemma for ~ pythagtrip .  Show that ` N ` (which will eventually be
       closely related to the ` n ` in the final statement) is a natural.
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    pythagtriplem13 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> N e. NN ) $=
      ( cn wcel c2 co cdivides wbr wa cz cc0 clt nnzd wb 3ad2ant1 cr mpbid cexp
      w3a caddc wceq cgcd c1 wn csqr cfv cmin pythagtriplem9 simp3r simp3 simp2
      cdiv nnaddcld nnz 2z dvdsgcdb mp3an1 syl2anc biimpar mtand pythagtriplem7
      simprd breq2d mtbird pythagtriplem8 3ad2ant3 3ad2ant2 pythagtriplem6 omoe
      syl22anc zred simp13 nnred crp nnrp ltsubrpd nngt0 simp12 ltaddposd lttrd
      zsubcld cle pythagtriplem10 3adant3 wi 0re ltle mpan addgt0d sqrltd nnsub
      sylc wne 2ne0 dvdsval2 mp3an12 nngt0d halfpos2 elnnz sylanbrc syl5eqel
      syl ) AFGZBFGZCFGZUBZAHUAIBHUAIUCICHUAIUDZABUEIUFUDZHAJKZUGZLZUBZDCBUCIZU
      HUIZCBUJIZUHUIZUJIZHUOIZFEXOYAMGZNYAOKZYAFGXOHXTJKZYBXOXQMGHXQJKZUGXSMGHX
      SJKZUGYDXOXQABCUKZPXOYEHXPAUEIZJKZXOYIXLXIXJXKXMULZXOYILHXPJKZXLXOYKXLLZY
      IXOXPMGZAMGZYLYIQZXIXJYMXNXIXPXICBXFXGXHUMXFXGXHUNUPZPRXIXJYNXNXFXGYNXHAU
      QRRZHMGZYMYNYOURHXPAUSUTVAVBVEVCXOXQYHHJABCVDVFVGXOXSABCVHZPXOYFHXRAUEIZJ
      KZXOUUAXLYJXOUUALHXRJKZXLXOUUBXLLZUUAXOXRMGZYNUUCUUAQZXIXJUUDXNXICBXHXFCM
      GXGCUQVIXGXFBMGXHBUQVJWDZRYQYRUUDYNUUEURHXRAUSUTVAVBVEVCXOXSYTHJABCVKVFVG
      XQXSVLVMXOXTMGZYDYBQZXOXTXOXSXQOKZXTFGZXOXRXPOKUUIXOXRCXPXIXJXRSGZXNXIXRU
      UFVNRZXOCXFXGXHXJXNVOVPZXIXJXPSGZXNXIXPYPVPRZXOCBUUMXIXJBVQGZXNXGXFUUPXHB
      VRVJRVSXONBOKZCXPOKXIXJUUQXNXGXFUUQXHBVTVJRZXOBCXOBXFXGXHXJXNWAVPZUUMWBTW
      CXOXRXPUULXOUUKNXROKZNXRWEKZUULXIXJUUTXNABCWFWGNSGZUUKUUTUVAWHWINXRWJWKWO
      UUOXOUUNNXPOKZNXPWEKZUUOXOCBUUMUUSXIXJNCOKZXNXHXFUVEXGCVTVIRUURWLUVBUUNUV
      CUVDWHWINXPWJWKWOWMTXOXSFGXQFGUUIUUJQYSYGXSXQWNVATZPYRHNWPUUGUUHURWQHXTWR
      WSXETXONXTOKZYCXOXTUVFWTXOXTSGUVGYCQXOXTUVFVPXTXAXETYAXBXCXD $.

    $( Lemma for ~ pythagtrip .  Calculate the square of ` N ` .  (Contributed
       by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    pythagtriplem14 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> ( N ^ 2 ) = ( ( C - A ) / 2 ) ) $=
      ( wcel c2 cexp caddc wceq wbr cmin cdiv 3adant1 3ad2ant1 cc0 cmul syl2anc
      co cc cn w3a cgcd c1 cdivides wn wa csqr oveq1i nncn addcl syl2anr sqrcld
      cfv subcl subcld wne 2cn sqdiv mp3an23 sqvali oveq2i sqcld pm3.2i divdiv1
      2ne0 simp12 simp13 binom2sub cr nnre readdcl recnd resubcl mulcld sylancr
      syl mulcl addsubd nncnd simp11 subdi mp3an1 ppncan 3anidm13 2times adantr
      eqtr4d subsq oveq1 3ad2ant2 pncand eqtr3d fveq2d cle adantl nngt0 addgt0d
      clt wi 0re ltle mpan pythagtriplem10 3adant3 sqrmuld nnnn0 nn0ge0d sqrsqd
      sylc oveq2d oveq12d resqrth oveq1d 3eqtr4rd eqtrd 3adant2 divcan3 syl5eq
      ) AUAFZBUAFZCUAFZUBZAGHSZBGHSZISZCGHSZJZABUCSUDJGAUEKUFUGZUBZDGHSCBISZUHU
      NZCBLSZUHUNZLSZGMSZGHSZCALSZGMSZDYPGHEUIYJYQYOGHSZGGHSZMSZYSYJYOTFZYQUUBJ
      ZYCYHUUCYIYAYBUUCXTYAYBUGZYLYNUUEYKYBCTFZBTFZYKTFYACUJZBUJZCBUKULUMZUUEYM
      YBUUFUUGYMTFYAUUHUUICBUOULUMZUPNOZUUCGTFZGPUQZUUDURVFYOGUSUTVQYJUUBYTGGQS
      ZMSZYSUUAUUOYTMGURVAVBYJYTGMSZGMSZUUPYSYJYTTFZUURUUPJZYJYOUULVCUUSUUMUUNU
      GZUVAUUTUUMUUNURVFVDZUVBYTGGVEUTVQYJUUQYRGMYJUUQGYRQSZGMSZYRYJYTUVCGMYJYT
      YLGHSZGYLYNQSZQSZLSZYNGHSZISZUVCYJYLTFZYNTFZYTUVJJYJYAYBUVKXTYAYBYHYIVGZX
      TYAYBYHYIVHZUUJRYJYAYBUVLUVMUVNUUKRYLYNVIRYJYKYMISZUVGLSZYKUVGLSZYMISUVCU
      VJYJYKYMUVGYJYKYCYHYKVJFZYIYAYBUVRXTYBCVJFZBVJFZUVRYACVKZBVKZCBVLULZNOZVM
      YJYMYCYHYMVJFZYIYAYBUWEXTYBUVSUVTUWEYAUWAUWBCBVNULNOZVMYCYHUVGTFZYIYCUUMU
      VFTFUWGURYCYLYNYAYBUVKXTUUJNYAYBUVLXTUUKNVOGUVFVRVPOVSYJUVCGCQSZGAQSZLSZU
      VPYJUUFATFZUVCUWJJZYJCUVNVTZYJAXTYAYBYHYIWAVTUUMUUFUWKUWLURGCAWBWCRYJUVOU
      WHUVGUWILYCYHUVOUWHJZYIYAYBUWNXTYBUUFUUGUWNYAUUHUUIUUFUUGUGUVOCCISZUWHUUF
      UUGUVOUWOJCBCWDWEUUFUWHUWOJUUGCWFWGWHULNOYJUVFAGQYJYDUHUNZUVFAYJYKYMQSZUH
      UNUWPUVFYJUWQYDUHYJYGYELSZUWQYDYJUUFUUGUWRUWQJUWMYJBUVMVTCBWIRYJYFYELSZUW
      RYDYHYCUWSUWRJYIYFYGYELWJWKYCYHUWSYDJYIYCYDYEXTYAYDTFYBXTAAUJZVCOYAXTYETF
      YBYABUUIVCWKWLOWMWMWNYJYKYMUWDYCYHPYKWOKZYIYAYBUXAXTUUEUVRPYKWSKZUXAUWCUU
      ECBYBUVSYAUWAWPYAUVTYBUWBWGYBPCWSKYACWQWPYAPBWSKYBBWQWGWRPVJFZUVRUXBUXAWT
      XAPYKXBXCXJNOZUWFYJUWEPYMWSKZPYMWOKZUWFYCYHUXEYIABCXDXEUXCUWEUXEUXFWTXAPY
      MXBXCXJZXFWMYJAYCYHAVJFZYIXTYAUXHYBAVKOOYCYHPAWOKZYIXTYAUXIYBXTAAXGXHOOXI
      WMXKXLWHYJUVHUVQUVIYMIYJUVEYKUVGLYJUVRUXAUVEYKJUWDUXDYKXMRXNYJUWEUXFUVIYM
      JUWFUXGYMXMRXLXOXPXNYJYRTFZUVDYRJZYCYHUXJYIXTYBUXJYAYBUUFUWKUXJXTUUHUWTCA
      UOULXQOUXJUUMUUNUXKURVFYRGXRUTVQXPXNWMXSXPXS $.
  $}

  ${
    pythagtriplem15.1 $e |- M = ( ( ( sqr ` ( C + B ) ) + ( sqr ` ( C - B ) ) )
        / 2 ) $.
    pythagtriplem15.2 $e |- N = ( ( ( sqr ` ( C + B ) ) - ( sqr ` ( C - B ) ) )
        / 2 ) $.
    $( Lemma for ~ pythagtrip .  Show the relationship between ` M ` , ` N ` ,
       and ` A ` .  (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem15 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> A = ( ( M ^ 2 ) - ( N ^ 2 ) ) ) $=
      ( cn wcel w3a c2 cexp co caddc wceq wa cmin cdiv cc 3ad2ant1 cdivides wbr
      cgcd c1 cmul pythagtriplem12 pythagtriplem14 oveq12d simp3 simp1 nnaddcld
      wn nncnd cz nnz 3ad2ant3 zsubcld zcnd cc0 wne 2cn pm3.2i divsubdir mp3an3
      2ne0 syl2anc eqtr4d nncn pnncand 2timesd oveq1d divcan3 mp3an23 3eqtrrd
      syl ) AHIZBHIZCHIZJZAKLMBKLMNMCKLMOZABUCMUDOKAUAUBULPZJZDKLMZEKLMZQMZCANM
      ZCAQMZQMZKRMZKAUEMZKRMZAWBWEWFKRMZWGKRMZQMZWIWBWCWLWDWMQABCDFUFABCEGUGUHW
      BWFSIZWGSIZWIWNOZVSVTWOWAVSWFVSCAVPVQVRUIVPVQVRUJUKUMTVSVTWPWAVSWGVSCAVRV
      PCUNIVQCUOUPVPVQAUNIVRAUOTUQURTWOWPKSIZKUSUTZPWQWRWSVAVEVBWFWGKVCVDVFVGWB
      WHWJKRWBWHAANMWJWBCAAVSVTCSIZWAVRVPWTVQCVHUPTVSVTASIZWAVPVQXAVRAVHTTZXBVI
      WBAXBVJVGVKWBXAWKAOZXBXAWRWSXCVAVEAKVLVMVOVN $.

    $( Lemma for ~ pythagtrip .  Show the relationship between ` M ` , ` N ` ,
       and ` B ` .  (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem16 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> B = ( 2 x. ( M x. N ) ) ) $=
      ( wcel c2 cexp co wceq wbr cmul cdiv cc syl2anc 3adant1 3ad2ant1 cc0 cgcd
      cn w3a caddc c1 cdivides wn wa csqr cfv cmin oveq12i addcl syl2anr sqrcld
      nncn subcl wne 2cn pm3.2i divmuldiv mpanr12 mulcld divdiv1 mp3an23 eqtr4d
      2ne0 syl cr cle nnre readdcl clt adantl adantr nngt0 addgt0d wi ltle mpan
      sylc resqrth resubcl pythagtriplem10 3adant3 oveq12d oveq1d simp12 simp13
      0re subsq pnncan 3anidm23 2times divcan3 3syl eqtrd 3eqtr3d syl5eq oveq2d
      divcan2 3ad2ant2 eqtr2d ) AUBHZBUBHZCUBHZUCZAIJKBIJKUDKCIJKLZABUAKUELIAUF
      MUGUHZUCZIDENKZNKIBIOKZNKZBXJXKXLINXJXKCBUDKZUIUJZCBUKKZUIUJZUDKZIOKZXOXQ
      UKKZIOKZNKZXLDXSEYANFGULXJYBXRXTNKZIOKZIOKZXLXJYBYCIINKOKZYEXJXRPHZXTPHZY
      BYFLZXGXHYGXIXEXFYGXDXEXFUHZXOPHZXQPHZYGYJXNXFCPHZBPHZXNPHXECUPZBUPZCBUMU
      NUOZYJXPXFYMYNXPPHXEYOYPCBUQUNUOZXOXQUMQZRSXGXHYHXIXEXFYHXDYJYKYLYHYQYRXO
      XQUQQZRSYGYHUHIPHZITURZUHZUUCYIUUAUUBUSVGUTZUUDXRXTIIVAVBQXJYCPHZYEYFLZXG
      XHUUEXIXEXFUUEXDYJXRXTYSYTVCRSUUEUUCUUCUUFUUDUUDYCIIVDVEVHVFXJYDBIOXJXOIJ
      KZXQIJKZUKKZIOKXNXPUKKZIOKZYDBXJUUIUUJIOXJUUGXNUUHXPUKXJXNVIHZTXNVJMZUUGX
      NLXGXHUULXIXEXFUULXDXFCVIHZBVIHZUULXECVKZBVKZCBVLUNZRSXGXHUUMXIXEXFUUMXDY
      JUULTXNVMMZUUMUURYJCBXFUUNXEUUPVNXEUUOXFUUQVOXFTCVMMXECVPVNXETBVMMXFBVPVO
      VQTVIHZUULUUSUUMVRWJTXNVSVTWARSXNWBQXJXPVIHZTXPVJMZUUHXPLXGXHUVAXIXEXFUVA
      XDXFUUNUUOUVAXEUUPUUQCBWCUNRSZXJUVATXPVMMZUVBUVCXGXHUVDXIABCWDWEUUTUVAUVD
      UVBVRWJTXPVSVTWAXPWBQWFWGXJUUIYCIOXJYKYLUUIYCLXJXEXFYKXDXEXFXHXIWHZXDXEXF
      XHXIWIZYQQXJXEXFYLUVEUVFYRQXOXQWKQWGXJUUKIBNKZIOKZBXJUUJUVGIOXGXHUUJUVGLZ
      XIXEXFUVIXDXFYMYNUVIXEYOYPYMYNUHUUJBBUDKZUVGYMYNUUJUVJLCBBWLWMYNUVGUVJLYM
      BWNVNVFUNRSWGXJXEYNUVHBLZUVEYPYNUUAUUBUVKUSVGBIWOVEWPWQWRWGWQWSWTXGXHXMBL
      ZXIXEXDUVLXFXEYNUVLYPYNUUAUUBUVLUSVGBIXAVEVHXBSXC $.

    $( Lemma for ~ pythagtrip .  Show the relationship between ` M ` , ` N ` ,
       and ` C ` .  (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem17 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) -> C = ( ( M ^ 2 ) + ( N ^ 2 ) ) ) $=
      ( cn wcel w3a c2 cexp co caddc wceq wa cdiv cc nncn 3ad2ant1 cdivides wbr
      cgcd c1 cmin cmul pythagtriplem12 pythagtriplem14 oveq12d 3ad2ant3 addcld
      wn subcld cc0 wne 2cn pm3.2i divdir mp3an3 syl2anc eqtr4d ppncand 2timesd
      2ne0 oveq1d divcan3 mp3an23 syl 3eqtrrd ) AHIZBHIZCHIZJZAKLMBKLMNMCKLMOZA
      BUCMUDOKAUAUBULPZJZDKLMZEKLMZNMZCANMZCAUEMZNMZKQMZKCUFMZKQMZCVPVSVTKQMZWA
      KQMZNMZWCVPVQWFVRWGNABCDFUGABCEGUHUIVPVTRIZWARIZWCWHOZVPCAVMVNCRIZVOVLVJW
      LVKCSUJTZVMVNARIZVOVJVKWNVLASTTZUKVPCAWMWOUMWIWJKRIZKUNUOZPWKWPWQUPVDUQVT
      WAKURUSUTVAVPWBWDKQVPWBCCNMWDVPCACWMWOWMVBVPCWMVCVAVEVPWLWECOZWMWLWPWQWRU
      PVDCKVFVGVHVI $.

  $}

  ${
    $d A m n $.  $d B m n $.  $d C m n $.
    $( Lemma for ~ pythagtrip .  Wrap the previous ` M ` and ` N ` up in
       quanitifers.  (Contributed by Scott Fenton, 18-Apr-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem18 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       ( ( A gcd B ) = 1 /\ -. 2 || A ) ) ->
       E. n e. NN E. m e. NN
       ( A = ( ( m ^ 2 ) - ( n ^ 2 ) ) /\
         B = ( 2 x. ( m x. n ) ) /\
         C = ( ( m ^ 2 ) + ( n ^ 2 ) ) ) ) $=
      ( cn wcel w3a c2 cexp caddc wceq csqr cfv cmin cmul oveq1 oveq2d eqeq2d
      co cgcd c1 cdivides wbr wn cdiv wrex eqid pythagtriplem13 pythagtriplem11
      wa pythagtriplem15 pythagtriplem16 pythagtriplem17 oveq2 3anbi123d oveq1d
      cv rspc2ev syl113anc ) AFGBFGCFGHAIJTBIJTKTCIJTLABUATUBLIAUCUDUEUKHCBKTMN
      ZCBOTMNZOTIUFTZFGVAVBKTIUFTZFGAVDIJTZVCIJTZOTZLZBIVDVCPTZPTZLZCVEVFKTZLZA
      DURZIJTZEURZIJTZOTZLZBIVNVPPTZPTZLZCVOVQKTZLZHZDFUGEFUGABCVCVCUHZUIABCVDV
      DUHZUJABCVDVCWGWFULABCVDVCWGWFUMABCVDVCWGWFUNWEVHVKVMHAVOVFOTZLZBIVNVCPTZ
      PTZLZCVOVFKTZLZHEDVCVDFFVPVCLZVSWIWBWLWDWNWOVRWHAWOVQVFVOOVPVCIJQZRSWOWAW
      KBWOVTWJIPVPVCVNPUORSWOWCWMCWOVQVFVOKWPRSUPVNVDLZWIVHWLVKWNVMWQWHVGAWQVOV
      EVFOVNVDIJQZUQSWQWKVJBWQWJVIIPVNVDVCPQRSWQWMVLCWQVOVEVFKWRUQSUPUSUT $.
  $}

  ${
    $d A m n k $.  $d B m n k $.  $d C m n k $.
    $( Lemma for ~ pythagtrip .  Introduce ` k ` and remove the relative
       primality requirement.  (Contributed by Scott Fenton, 18-Apr-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    pythagtriplem19 $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN ) /\
       ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) /\
       -. 2 || ( A / ( A gcd B ) ) ) ->
       E. n e. NN E. m e. NN E. k e. NN
       ( A = ( k x. ( ( m ^ 2 ) - ( n ^ 2 ) ) ) /\
         B = ( k x. ( 2 x. ( m x. n ) ) ) /\
         C = ( k x. ( ( m ^ 2 ) + ( n ^ 2 ) ) ) ) ) $=
      ( cn wcel c2 cexp co wceq cdiv cdivides wbr cmul wrex cz cc0 3ad2ant1 w3a
      caddc cgcd wn cv cmin wa nnz anim12i nnne0 neneqd intnanrd adantr gcdn0cl
      syl2anc 3adant3 c1 clt gcddvds syl2an simpld wne wb nnzd dvdsval2 syl3anc
      nnne0d mpbid cr nnred nngt0 nngt0d divgt0d elnnz sylanbrc simprd 3ad2ant2
      nnre dvdssq anbi12d wi nnsqcld nnsqcl dvds2add mpd simpr breqtrd 3ad2ant3
      mpbird cc nncn nncnd sqdivd oveq12d divdird eqtr4d gcddiv syl31anc dividd
      oveq1 eqtr3d simp3 pythagtriplem18 syl312anc divcan2d eqcomd oveq2 eqeq2d
      3anbi123d syl5ibcom reximdv 2rexbidv rspcev rexcom rexbii bitri sylib
      3jca ) AGHZBGHZCGHZUAZAIJKZBIJKZUBKZCIJKZLZIAABUCKZMKZNOUDZUAZADUEZEUEZIJ
      KZFUEZIJKZUFKZPKZLZBYLIYMYOPKPKZPKZLZCYLYNYPUBKZPKZLZUAZEGQZFGQZDGQZUUFDG
      QEGQZFGQZYKYHGHZAYHYQPKZLZBYHYTPKZLZCYHUUCPKZLZUAZEGQZFGQZUUIYBYGUULYJXSX
      TUULYAXSXTUGARHZBRHZUGASLZBSLZUGUDZUULXSUVBXTUVCAUHZBUHZUIXSUVFXTXSUVDUVE
      XSASAUJUKULUMABUNUOUPZTYKYIYQLZBYHMKZYTLZCYHMKZUUCLZUAZEGQZFGQZUVAYKYIGHZ
      UVKGHZUVMGHZYIIJKZUVKIJKZUBKZUVMIJKZLYIUVKUCKZUQLZYJUVQYBYGUVRYJYBYIRHZSY
      IUROUVRYBYHANOZUWGYBUWHYHBNOZXSXTUWHUWIUGZYAXSUVBUVCUWJXTUVGUVHABUSUTUPZV
      AYBYHRHZYHSVBZUVBUWHUWGVCYBYHUVIVDZYBYHUVIVGZXSXTUVBYAUVGTZYHAVEVFVHYBAYH
      XSXTAVIHYAAVRTYBYHUVIVJZXSXTSAUROYAAVKTYBYHUVIVLZVMYIVNVOTYBYGUVSYJYBUVKR
      HZSUVKUROUVSYBUWIUWSYBUWHUWIUWKVPYBUWLUWMUVCUWIUWSVCUWNUWOXTXSUVCYAUVHVQZ
      YHBVEVFVHYBBYHXTXSBVIHYABVRVQUWQXTXSSBUROYABVKVQUWRVMUVKVNVOTYBYGUVTYJYBY
      GUGZUVMRHZSUVMUROZUVTUXAYHCNOZUXBUXAUXDYHIJKZYFNOZUXAUXEYEYFNYBUXEYENOZYG
      YBUXEYCNOZUXEYDNOZUGZUXGYBUWJUXJUWKYBUWHUXHUWIUXIYBUWLUVBUWHUXHVCUWNUWPYH
      AVSUOYBUWLUVCUWIUXIVCUWNUWTYHBVSUOVTVHYBUXERHYCRHYDRHUXJUXGWAYBUXEYBYHUVI
      WBZVDYBYCXSXTYCGHYAAWCTZVDYBYDXTXSYDGHYABWCVQZVDUXEYCYDWDVFWEUMYBYGWFWGYB
      UXDUXFVCZYGYBUWLCRHZUXNUWNYAXSUXOXTCUHWHZYHCVSUOUMWIYBUXDUXBVCZYGYBUWLUWM
      UXOUXQUWNUWOUXPYHCVEVFUMVHYBUXCYGYBCYHYAXSCVIHXTCVRWHUWQYAXSSCUROXTCVKWHU
      WRVMUMUVMVNVOUPYKUWCYEUXEMKZUWDYKUWCYCUXEMKZYDUXEMKZUBKZUXRYBYGUWCUYALYJY
      BUWAUXSUWBUXTUBYBAYHXSXTAWJHYAAWKTZYBYHUVIWLZUWOWMYBBYHXTXSBWJHYABWKVQZUY
      CUWOWMWNTYBYGUXRUYALYJYBYCYDUXEYBYCUXLWLYBYDUXMWLYBUXEUXKWLYBUXEUXKVGWOTW
      PYKUWDYFUXEMKZUXRYBYGUWDUYELYJYBCYHYAXSCWJHXTCWKWHZUYCUWOWMTYGYBUXRUYELYJ
      YEYFUXEMWTVQWPWPYBYGUWFYJYBYHYHMKZUWEUQYBUVBUVCUULUWJUYGUWELUWPUWTUVIUWKA
      BYHWQWRYBYHUYCUWOWSXATYBYGYJXBYIUVKUVMEFXCXDYKUVPUUTFGYKUVOUUSEGYKAYHYIPK
      ZLZBYHUVKPKZLZCYHUVMPKZLZUAZUVOUUSYBYGUYNYJYBUYIUYKUYMYBUYHAYBAYHUYBUYCUW
      OXEXFYBUYJBYBBYHUYDUYCUWOXEXFYBUYLCYBCYHUYFUYCUWOXEXFXRTUVOUYIUUNUYKUUPUY
      MUURUVJUVLUYIUUNVCUVNUVJUYHUUMAYIYQYHPXGXHTUVLUVJUYKUUPVCUVNUVLUYJUUOBUVK
      YTYHPXGXHVQUVNUVJUYMUURVCUVLUVNUYLUUQCUVMUUCYHPXGXHWHXIXJXKXKWEUUHUVADYHG
      YLYHLZUUFUUSFEGGUYOYSUUNUUBUUPUUEUURUYOYRUUMAYLYHYQPWTXHUYOUUAUUOBYLYHYTP
      WTXHUYOUUDUUQCYLYHUUCPWTXHXIXLXMUOUUIUUGDGQZFGQUUKUUGDFGGXNUYPUUJFGUUFDEG
      GXNXOXPXQ $.
  $}

  ${
    $d A k m n $.  $d B k m n $.  $d C k m n $.
    $( Parameterize the Pythagorean triples.  If ` A ` , ` B ` , and ` C ` are
       naturals, then they obey the Pythagorean triple formula iff they are
       parameterized by three naturals.  This proof follows the Isabelle proof
       at ~ http://afp.sourceforge.net/entries/Fermat3_4.shtml .  (Contributed
       by Scott Fenton, 19-Apr-2014.) $)
    pythagtrip $p |- ( ( A e. NN /\ B e. NN /\ C e. NN ) ->
    ( ( ( A ^ 2 ) + ( B ^ 2 ) ) = ( C ^ 2 ) <->
       E. n e. NN E. m e. NN E. k e. NN
       ( { A , B } = { ( k x. ( ( m ^ 2 ) - ( n ^ 2 ) ) ) ,
                       ( k x. ( 2 x. ( m x. n ) ) ) } /\
         C = ( k x. ( ( m ^ 2 ) + ( n ^ 2 ) ) ) ) ) ) $=
      ( cn wcel w3a c2 cexp co wceq cmul wa wrex wo cdiv cdivides 3adant3 caddc
      cpr cv cmin cgcd wn divgcdodd adantr pythagtriplem19 3expia simp12 simp11
      wbr simp13 cc nnsqcl nncnd 3ad2ant1 3ad2ant2 addcomd eqeq1d biimpa cz nnz
      gcdcom syl2anc oveq2d breq2d notbid biimp3a syl311anc orim12d mpd wb ovex
      cvv preq12bg mpanr12 anbi1d rexbidv 2rexbidv andir df-3an orbi12i 3ancoma
      orbi2i 3bitr2i rexbii r19.43 bitri syl6bb mpbird ex pythagtriplem2 impbid
      2rexbii wi ) AGHZBGHZCGHZIZAJKLZBJKLZUALZCJKLZMZABUBDUCZEUCZJKLZFUCZJKLZU
      DLZNLZXGJXHXJNLNLZNLZUBMZCXGXIXKUALNLMZOZDGPZEGPFGPZXAXFXTXAXFOZXTAXMMZBX
      OMZXQIZDGPZEGPZFGPZBXMMZAXOMZXQIZDGPZEGPZFGPZQZYAJAABUELZRLSUMUFZJBYORLZS
      UMZUFZQZYNXAYTXFWRWSYTWTABUGTUHYAYPYGYSYMXAXFYPYGABCDEFUIUJXAXFYSYMXAXFYS
      IWSWRWTXCXBUALZXEMZJBBAUELZRLZSUMZUFZYMWRWSWTXFYSUKWRWSWTXFYSULWRWSWTXFYS
      UNXAXFUUBYSXAXFUUBXAXDUUAXEXAXBXCWRWSXBUOHWTWRXBAUPUQURWSWRXCUOHWTWSXCBUP
      UQUSUTVAVBTXAXFYSUUFYAYRUUEYAYQUUDJSYAYOUUCBRYAAVCHZBVCHZYOUUCMXAUUGXFWRW
      SUUGWTAVDURUHXAUUHXFWSWRUUHWTBVDUSUHABVEVFVGVHVIVJBACDEFUIVKUJVLVMXAXTYNV
      NZXFWRWSUUIWTWRWSOZXTYBYCOZYIYHOZQZXQOZDGPZEGPFGPZYNUUJXSUUOFEGGUUJXRUUND
      GUUJXPUUMXQUUJXMVPHXOVPHXPUUMVNXGXLNVOXGXNNVOABXMXOGGVPVPVQVRVSVTWAUUPYDY
      JQZDGPZEGPFGPZYNUUOUURFEGGUUNUUQDGUUNUUKXQOZUULXQOZQYDYIYHXQIZQUUQUUKUULX
      QWBYDUUTUVBUVAYBYCXQWCYIYHXQWCWDUVBYJYDYIYHXQWEWFWGWHWPUUSYEYKQZEGPZFGPZY
      NUURUVCFEGGYDYJDGWIWPUVEYFYLQZFGPYNUVDUVFFGYEYKEGWIWHYFYLFGWIWJWJWJWKTUHW
      LWMWRWSXTXFWQWTABCDEFWNTWO $.
  $}

  ${
    $d i j A $.  $d i j k B $.  $d i j n C $.  $d i j k m n ph $.
    iserodd.f $e |- ( ( ph /\ k e. NN0 ) -> C e. CC ) $.
    iserodd.h $e |- ( n = ( ( 2 x. k ) + 1 ) -> B = C ) $.
    $( Collect the odd terms in a sequence.  (Contributed by Mario Carneiro,
       7-Apr-2015.) $)
    iserodd $p |- ( ph -> ( seq 0 ( + , ( k e. NN0 |-> C ) ) ~~> A <->
      seq 1 ( + , ( n e. NN |-> if ( 2 || n , 0 , B ) ) ) ~~> A ) ) $=
      ( cn c2 wbr cc0 cn0 co c1 caddc wcel a1i wceq cc vi vj vm cv cdivides cif
      cmpt cmul nn0uz nnuz cz 0z 1z wa 2nn0 nn0mulcl sylan nn0p1nn syl eqid cfv
      fmptd clt nn0red peano2nn0 syl2an cr 1re nn0re adantl ltp1d wb 2re ltmul2
      2pos syl112anc mpbid ltadd1dd weq oveq2 oveq1d ovex 3brtr4d crn cdif wral
      fvmpt eldifi simpr 0cn wn wrex nnz odd2np1 cle cmin cdiv nnm1nn0 ad2antlr
      simprl nn0ge0d divge0 syl22anc simprr 2cn zcn ad2antrl mulcl ax-1cn pncan
      sylancr sylancl eqtr3d wne 2ne0 divcan3d eqtrd breqtrd elnn0z sylanbrc ex
      wi eqcomd jcad reximdv2 sylbid eleq1d syl5ibrcom fvmpt2 syl2anc ralrimiva
      cvv nfv nffvmpt1 nfeq1 fveq2 cbvral sylib r19.21bi fveq2d adantr syld imp
      rexlimdva ifclda sylan2 eldif cbvmptv elrnmpt ax-mp syl6ibr con1d sylan2b
      vex impr iftrue eqeq1d ffvelrnda nn0z dvdsmul1 nn0zd 1lt2 ndvdsp1 syl3anc
      2z 2nn mpd iffalse eqeltrd breq2 ifbieq2d fvmptg 3eqtrd eqeq12d isercoll2
      eqtr4d ) ABUAUBFIJFUDZUEKZLCUFZUGZUCMJUCUDZUHNZOPNZUGZEMDUGZLOIMUIUJLUKQA
      ULROUKQAUMRAUCMUWCIUWDAUWAMQZUNUWBMQZUWCIQAJMQZUWFUWGUWHAUORZJUWAUPUQUWBU
      RUSUWDUTZVBAUAUDZMQZUNZJUWKUHNZOPNZJUWKOPNZUHNZOPNZUWKUWDVAZUWPUWDVAZVCUW
      MUWNUWQOUWMUWNAUWHUWLUWNMQUWIJUWKUPUQVDUWMUWQAUWHUWPMQZUWQMQUWLUWIUWKVEZJ
      UWPUPVFVDOVGQUWMVHRUWMUWKUWPVCKZUWNUWQVCKZUWMUWKUWLUWKVGQZAUWKVIVJZVKUWMU
      XEUWPVGQJVGQZLJVCKZUXCUXDVLUXFUWMUWPUWLUXAAUXBVJZVDUXGUWMVMRUXHUWMVORUWKU
      WPJVNVPVQVRUWLUWSUWOSAUCUWKUWCUWOMUWDUCUAVSUWBUWNOPUWAUWKJUHVTWAUWJUWNOPW
      BWGVJUWMUXAUWTUWRSUXIUCUWPUWCUWRMUWDUWAUWPSUWBUWQOPUWAUWPJUHVTWAUWJUWQOPW
      BWGUSWCAUBUDZUVTVAZLSZUBIUWDWDZWEZAUVQUVTVAZLSZFUXNWFUXLUBUXNWFAUXPFUXNAU
      VQUXNQZUNZUXOUVSLUXQAUVQIQZUXOUVSSZUVQIUXMWHAUXSUNZUXSUVSTQUXTAUXSWIUYAUV
      RLCTLTQUYAUVRUNWJRUYAUVRWKZCTQZUYAUYBUVQJEUDZUHNZOPNZSZEMWLZUYCUYAUYBUYFU
      VQSZEUKWLZUYHUYAUVQUKQZUYBUYJVLUXSUYKAUVQWMVJEUVQWNUSUYAUYIUYGEUKMUYAUYDU
      KQZUYIUNZUYDMQZUYGUYAUYMUYNUYAUYMUNZUYLLUYDWOKUYNUYAUYLUYIWTUYOLUVQOWPNZJ
      WQNZUYDWOUYOUYPVGQLUYPWOKUXGUXHLUYQWOKUYOUYPUXSUYPMQAUYMUVQWRWSZVDUYOUYPU
      YRXAUXGUYOVMRUXHUYOVORUYPJXBXCUYOUYQUYEJWQNUYDUYOUYPUYEJWQUYOUYFOWPNZUYPU
      YEUYOUYFUVQOWPUYAUYLUYIXDWAUYOUYETQZOTQUYSUYESUYOJTQZUYDTQZUYTXEUYLVUBUYA
      UYIUYDXFXGZJUYDXHXKXIUYEOXJXLXMWAUYOUYDJVUCVUAUYOXERJLXNUYOXORXPXQXRUYDXS
      XTYAUYMUYGYBUYAUYMUYFUVQUYLUYIWIYCRYDYEYFZAUYHUYCYBUXSAUYGUYCEMAUYNUNZUYC
      UYGDTQZGUYGCDTHYGYHUUDUUAUUBUUCUUEZFIUVSTUVTUVTUTZYIYJUUFUXRUVRUVSLSUXQAU
      XSUVQUXMQZWKZUNUVRUVQIUXMUUGAUXSVUJUVRUYAUVRVUIUYAUYBUYHVUIVUDUVQYLQVUIUY
      HVLFUUNEMUYFUVQUWDYLUCEMUWCUYFUCEVSUWBUYEOPUWAUYDJUHVTWAZUUHUUIUUJUUKUULU
      UOUUMUVRLCUUPUSXQYKUXPUXLFUBUXNUXPUBYMFUXKLFIUVSUXJYNYOFUBVSUXOUXKLUVQUXJ
      UVTYPUUQYQYRYSAITUXJUVTAFIUVSTUVTVUGVUHVBUURAUWKUWEVAZUWSUVTVAZSZUAMAUYDU
      WEVAZUYDUWDVAZUVTVAZSZEMWFVUNUAMWFAVUREMVUEVUODVUQVUEUYNVUFVUODSAUYNWIGEM
      DTUWEUWEUTYIYJVUEVUQUYFUVTVAZJUYFUEKZLDUFZDVUEVUPUYFUVTUYNVUPUYFSAUCUYDUW
      CUYFMUWDVUKUWJUYEOPWBWGVJYTVUEUYFIQZVVATQVUSVVASVUEUYEMQZVVBAUWHUYNVVCUWI
      JUYDUPUQZUYEURUSVUEVVADTVUEVUTWKZVVADSVUEJUYEUEKZVVEVUEJUKQUYLVVFUVEUYNUY
      LAUYDUUSVJJUYDUUTXKVUEUYEUKQJIQZOJVCKZVVFVVEYBVUEUYEVVDUVAVVGVUEUVFRVVHVU
      EUVBRJUYEUVCUVDUVGVUTLDUVHUSZGUVIFUYFUVSVVAITUVTUYGUVRVUTCDLUVQUYFJUEUVJH
      UVKVUHUVLYJVVIUVMUVPYKVURVUNEUAMVURUAYMEVULVUMEMDUWKYNYOEUAVSZVUOVULVUQVU
      MUYDUWKUWEYPVVJVUPUWSUVTUYDUWKUWDYPYTUVNYQYRYSUVO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                           The prime count function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c pCnt $.

  $( Extend class notation with the prime count function. $)
  cpc $a class pCnt $.

  ${
    $d p r z x y n $.
    $( Define the prime count function, which returns the largest exponent of a
       given prime (or other natural number) that divides the number.  For
       rational numbers, it returns negative values according to the power of a
       prime in the denominator.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    df-pc $a |- pCnt = ( p e. Prime , r e. QQ |-> if ( r = 0 , +oo ,
      ( iota z E. x e. ZZ E. y e. NN ( r = ( x / y ) /\
        z = ( sup ( { n e. NN0 | ( p ^ n ) || x } , RR , < ) -
              sup ( { n e. NN0 | ( p ^ n ) || y } , RR , < ) ) ) ) ) ) $.
  $}

  ${
    $d x y z A $.  $d n x y z N $.  $d n x y z P $.  $d x S $.
    pclem.1 $e |- A = { n e. NN0 | ( P ^ n ) || N } $.
    $( - Lemma for the prime power pre-function's properties.  (Contributed by
       Mario Carneiro, 23-Feb-2014.) $)
    pclem $p |- ( ( P e. ( ZZ>= ` 2 ) /\ ( N e. ZZ /\ N =/= 0 ) ) ->
          ( A C_ ZZ /\ A =/= (/) /\ E. x e. ZZ A. y e. A y <_ x ) ) $=
      ( wcel cz cc0 wa wbr cn0 cexp co cdivides adantr ad2antrl cn cr c2 cuz c0
      cfv wne wss cv cle wral wrex crab ssrab2 eqsstri nn0ssz sstri a1i 0nn0 c1
      cc eluzelz zcnd exp0d 1dvds eqbrtrd wceq oveq2 breq1d elrab2 sylanbrc syl
      ne0i nnssz clt zcn abscld eluzelre eluz2b2 simprbi expnbnd syl3anc simprr
      cabs sylib simprd simplbi ad2antrr simpld nnexpcld nnzd simplrl dvdsleabs
      wi simplrr mpd nnred nnnn0 reexpcld lelttr mpand nn0zd nnz ltexp2d nn0red
      sylibrd nnre ltle syl2anc syld anassrs ralrimdva reximdva ssrexv mpsyl
      3jca ) DUAUBUDHZFIHZFJUEZKZKZCIUFZCUCUEZBUGZAUGZUHLZBCUIZAIUJZXTXSCMICDEU
      GZNOZFPLZEMUKMGYIEMULUMUNUOUPXSJCHZYAXSJMHZDJNOZFPLZYJYKXSUQUPXSYLURFPXSD
      XODUSHXRXODUADUTVAQVBXPURFPLXOXQFVCRVDYIYMEJMCYGJVEYHYLFPYGJDNVFVGGVHVICJ
      VKVJSIUFXSYEASUJZYFVLXSFWBUDZDYCNOZVMLZASUJZYNXSYOTHZDTHZURDVMLZYRXPYSXOX
      QXPFFVNVORZXOYTXRUADVPZQXOUUAXRXODSHZUUADVQZVRZQYODAVSVTXSYQYEASXSYCSHZKY
      QYDBCXSUUGYBCHZYQYDWLXSUUGUUHKZKZYQYBYCVMLZYDUUJYQDYBNOZYPVMLZUUKUUJUULYO
      UHLZYQUUMUUJUULFPLZUUNUUJYBMHZUUOUUJUUHUUPUUOKXSUUGUUHWAYIUUOEYBMCYGYBVEY
      HUULFPYGYBDNVFVGGVHWCZWDUUJUULIHXPXQUUOUUNWLUUJUULUUJDYBXOUUDXRUUIXOUUDUU
      AUUEWEWFUUJUUPUUOUUQWGZWHZWIXOXPXQUUIWJXOXPXQUUIWMUULFWKVTWNUUJUULTHYSYPT
      HUUNYQKUUMWLUUJUULUUSWOXSYSUUIUUBQUUJDYCXOYTXRUUIUUCWFZUUGYCMHXSUUHYCWPRW
      QUULYOYPWRVTWSUUJDYBYCUUTUUJYBUURWTUUGYCIHXSUUHYCXARXOUUAXRUUIUUFWFXBXDUU
      JYBTHYCTHZUUKYDWLUUJYBUURXCUUGUVAXSUUHYCXERYBYCXFXGXHXIXJXKWNYEASIXLXMXN
      $.

    pclem.2 $e |- S = sup ( A , RR , < ) $.
    $( Closure of the prime power pre-function.  (Contributed by Mario
       Carneiro, 23-Feb-2014.) $)
    pcprecl $p |- ( ( P e. ( ZZ>= ` 2 ) /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                    ( S e. NN0 /\ ( P ^ S ) || N ) ) $=
      ( vz vy vx wcel cz wne wa cn0 cexp co cdivides wbr cv c2 cuz cfv cc0 csup
      cr clt wss c0 cle wral wrex w3a pclem suprzcl2 syl5eqel wceq oveq2 breq1d
      syl crab cbvrabv eqtri elrab2 sylib ) BUAUBUCKELKEUDMNNZCAKCOKBCPQZERSZNV
      FCAUFUGUEZAGVFALUHAUIMHTITUJSHAUKILULUMVIAKIHABDEFUNIHAUOUTUPBJTZPQZERSZV
      HJCOAVJCUQVKVGERVJCBPURUSABDTZPQZERSZDOVAVLJOVAFVOVLDJOVMVJUQVNVKERVMVJBP
      URUSVBVCVDVE $.

    $( Non-divisibility property of the prime power pre-function.  (Contributed
       by Mario Carneiro, 23-Feb-2014.) $)
    pcprendvds $p |- ( ( P e. ( ZZ>= ` 2 ) /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                       -. ( P ^ ( S + 1 ) ) || N ) $=
      ( vy vx wcel cz wne co cexp cdivides wbr cle cn0 cr cv c2 cuz wa c1 caddc
      cfv cc0 wn pcprecl simpld nn0re clt ltp1 wb peano2re ltnle mpdan 3syl wss
      mpbid c0 wral wrex w3a pclem wi peano2nn0 wceq oveq2 breq1d cbvrabv eqtri
      crab elrab2 simplbi2 csup suprzub syl6breqr 3expia 3adant2 sylsyld mtod )
      BUAUBUFJEKJEUGLUCUCZBCUDUEMZNMZEOPZWDCQPZWCCRJZCSJZWGUHZWCWHBCNMEOPABCDEF
      GUIUJZCUKWICWDULPZWJCUMWIWDSJWLWJUNCUOCWDUPUQUTURWCAKUSZAVALZHTITZQPHAVBI
      KVCZVDWFWDAJZWGIHABDEFVEWCWHWDRJZWFWQVFWKCVGWQWRWFBWONMZEOPZWFIWDRAWOWDVH
      WSWEEOWOWDBNVIVJABDTZNMZEOPZDRVMWTIRVMFXCWTDIRXAWOVHXBWSEOXAWOBNVIVJVKVLV
      NVOURWMWPWQWGVFWNWMWPWQWGWMWPWQVDWDASULVPCQIHAWDVQGVRVSVTWAWB $.

    $( Non-divisibility property of the prime power pre-function.  (Contributed
       by Mario Carneiro, 23-Feb-2014.) $)
    pcprendvds2 $p |- ( ( P e. ( ZZ>= ` 2 ) /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                       -. P || ( N / ( P ^ S ) ) ) $=
      ( wcel cz cc0 wne wa cexp co cdivides wbr c1 cmul nnzd syl3anc c2 cuz cfv
      cdiv caddc pcprendvds wi cn clt eluz2b2 simplbi adantr cn0 pcprecl simprd
      simpld nnexpcld nnne0d simprl dvdsval2 mpbid dvdscmul nncnd expp1d eqcomd
      wb cc zcn ad2antrl divcan2d breq12d sylibd mtod ) BUAUBUCHZEIHZEJKZLZLZBE
      BCMNZUDNZOPZBCQUENMNZEOPZABCDEFGUFVRWAVSBRNZVSVTRNZOPZWCVRBIHVTIHZVSIHZWA
      WFUGVRBVNBUHHZVQVNWIQBUIPBUJUKULZSVRVSEOPZWGVRCUMHZWKABCDEFGUNZUOVRWHVSJK
      VOWKWGVFVRVSVRBCWJVRWLWKWMUPZUQZSZVRVSWOURZVNVOVPUSVSEUTTVAWPVSBVTVBTVRWD
      WBWEEOVRWBWDVRBCVRBWJVCWNVDVEVREVSVOEVGHVNVPEVHVIVRVSWOVCWQVJVKVLVM $.

    $( Value of the prime power pre-function at 1.  (Contributed by Mario
       Carneiro, 23-Feb-2014.)  (Revised by Mario Carneiro, 26-Apr-2016.) $)
    pcpre1 $p |- ( ( P e. ( ZZ>= ` 2 ) /\ N = 1 ) -> S = 0 ) $=
      ( wcel c1 wceq wa cc0 cle wbr cexp co cdivides cz wne mpbiri c2 cuz eleq1
      cfv cn0 ax-1ne0 neeq1 jca pcprecl sylan2 simprd simpr breqtrd clt eluz2b2
      1z cn wi simplbi adantr simpld nnexpcld nnzd 1nn dvdsle sylancl mpd nncnd
      exp0d breqtrrd nnred nn0zd 0z a1i simprbi leexp2d mpbird wb nn0le0eq0 syl
      mpbid ) BUAUBUDHZEIJZKZCLMNZCLJZWDWEBCOPZBLOPZMNWDWGIWHMWDWGIQNZWGIMNZWDW
      GEIQWDCUEHZWGEQNZWCWBERHZELSZKZWKWLKWCWMWNWCWMIRHUPEIRUCTWCWNILSUFEILUGTU
      HZABCDEFGUIZUJZUKWBWCULUMWDWGRHIUQHWIWJURWDWGWDBCWBBUQHZWCWBWSIBUNNZBUOZU
      SUTZWDWKWLWRVAZVBVCVDWGIVEVFVGWDBWDBXBVHVIVJWDBCLWDBXBVKWDCXCVLLRHWDVMVNW
      BWTWCWBWSWTXAVOUTVPVQWDWKWEWFVRWCWBWOWKWPWBWOKWKWLWQVAUJCVSVTWA $.
  $}

  ${
    $d n x y M $.  $d n x y N $.  $d n x y P $.  $d x S $.  $d x T $.
    pcpremul.1 $e |- S = sup ( { n e. NN0 | ( P ^ n ) || M } , RR , < ) $.
    pcpremul.2 $e |- T = sup ( { n e. NN0 | ( P ^ n ) || N } , RR , < ) $.
    pcpremul.3 $e |- U = sup (
                       { n e. NN0 | ( P ^ n ) || ( M x. N ) } , RR , < ) $.
    $( Multiplicative property of the prime count pre-function.  Note that the
       primality of ` P ` is essential for this property; ` ( 4 pCnt 2 ) = 0 `
       but ` ( 4 pCnt ( 2 x. 2 ) ) = 1 =/= 2 x. ( 4 pCnt 2 ) = 0 ` .  Since
       this is needed to show uniqueness for the real prime count function
       (over ` QQ ` ), we don't bother to define it off the primes.
       (Contributed by Mario Carneiro, 23-Feb-2014.) $)
    pcpremul $p |- ( ( P e. Prime /\ ( M e. ZZ /\ M =/= 0 ) /\
                     ( N e. ZZ /\ N =/= 0 ) ) -> ( S + T ) = U ) $=
      ( wcel cz wa co wbr cexp cmul cdivides cn0 syl3anc vy vx cprime cc0 caddc
      wne w3a wceq cle clt wn cv crab cr csup wss wral wrex c0 cuz cfv 3ad2ant1
      c2 prmuz2 zmulcl ad2ant2r 3adant1 zcn anim1i mulne0 syl2an pclem syl12anc
      cc eqid simp1d simp3d simp2l simp2r pcprecl simpld simp3l nn0addcld prmnn
      simp3r cn nncnd expaddd simprd wi nnexpcld nnzd dvdsmulc eqbrtrd dvdscmul
      mpd zmulcld dvdstr mp2and oveq2 elrab sylanbrc cbvrabv syl6eleq syl6breqr
      breq1d suprzub cdiv wo pcprendvds2 ioran wb simp1 dvdsval2 mpbid euclemma
      nnne0d mtbird nn0ltp1le syl2anc peano2nn0 syl dvdsexp 3expia mpan2d nn0zd
      c1 syld eluz expp1d zcnd mulcld divcan2d oveq2d divmuldivd eqtr4d breq12d
      eqtr3d dvdscmulr nn0red syl112anc bitrd 3imtr3d sylbid eqleltd mpbir2and
      mtod ) AUCKZFLKZFUDUFZMZGLKZGUDUFZMZUGZBCUENZDUHUUPDUIOUUPDUJOZUKUUOUUPAE
      ULZPNZFGQNZROZESUMZUNUJUOZDUIUUOUVBLUPZUAULUBULZUIOUAUVBUQUBLURZUUPUVBKUU
      PUVCUIOUUOUVDUVBUSUFZUVFUUOAVCUTVAKZUUTLKZUUTUDUFZUVDUVGUVFUGUUHUUKUVHUUN
      AVDVBZUUKUUNUVIUUHUUIUULUVIUUJUUMFGVEVFVGZUUKUUNUVJUUHUUKFVNKZUUJMGVNKZUU
      MMUVJUUNUUIUVMUUJFVHVIUULUVNUUMGVHVIFGVJVKVGZUBUAUVBAEUUTUVBVOZVLVMZVPUUO
      UVDUVGUVFUVQVQUUOUUPAUVEPNZUUTROZUBSUMZUVBUUOUUPSKZAUUPPNZUUTROZUUPUVTKUU
      OBCUUOBSKZABPNZFROZUUOUVHUUIUUJUWDUWFMUVKUUHUUIUUJUUNVRZUUHUUIUUJUUNVSZUU
      SFROESUMZABEFUWIVOZHVTVMZWAZUUOCSKZACPNZGROZUUOUVHUULUUMUWMUWOMUVKUUHUUKU
      ULUUMWBZUUHUUKUULUUMWEZUUSGROESUMZACEGUWRVOZIVTVMZWAZWCZUUOUWBFUWNQNZROZU
      XCUUTROZUWCUUOUWBUWEUWNQNZUXCRUUOABCUUOAUUHUUKAWFKUUNAWDVBZWGZUXAUWLWHZUU
      OUWFUXFUXCROZUUOUWDUWFUWKWIZUUOUWELKZUUIUWNLKZUWFUXJWJUUOUWEUUOABUXGUWLWK
      ZWLZUWGUUOUWNUUOACUXGUXAWKZWLZUWNUWEFWMTWPWNUUOUWOUXEUUOUWMUWOUWTWIZUUOUX
      MUULUUIUWOUXEWJUXQUWPUWGFUWNGWOTWPUUOUWBLKZUXCLKUVIUXDUXEMUWCWJUUOUWBUUOA
      UUPUXGUXBWKZWLZUUOFUWNUWGUXQWQUVLUWBUXCUUTWRTWSUVSUWCUBUUPSUVEUUPUHUVRUWB
      UUTRUVEUUPAPWTXFXAXBUVSUVAUBESUVEUURUHUVRUUSUUTRUVEUURAPWTXFXCXDUBUAUVBUU
      PXGTJXEUUOUUQAFUWEXHNZGUWNXHNZQNZROZUUOUYEAUYBROZAUYCROZXIZUUOUYFUKZUYGUK
      ZUYHUKUUOUVHUUIUUJUYIUVKUWGUWHUWIABEFUWJHXJVMUUOUVHUULUUMUYJUVKUWPUWQUWRA
      CEGUWSIXJVMUYFUYGXKXBUUOUUHUYBLKZUYCLKZUYEUYHXLUUHUUKUUNXMUUOUWFUYKUXKUUO
      UXLUWEUDUFUUIUWFUYKXLUXOUUOUWEUXNXQZUWGUWEFXNTXOZUUOUWOUYLUXRUUOUXMUWNUDU
      FUULUWOUYLXLUXQUUOUWNUXPXQZUWPUWNGXNTXOZAUYBUYCXPTXRUUOUUQUUPYGUENZDUIOZU
      YEUUOUWADSKZUUQUYRXLUXBUUOUYSADPNZUUTROZUUOUVHUVIUVJUYSVUAMUVKUVLUVOUVBAD
      EUUTUVPJVTVMZWAZUUPDXSXTUUODUYQUTVAKZAUYQPNZUUTROZUYRUYEUUOVUDVUEUYTROZVU
      FUUOALKZUYQSKZVUDVUGWJUUOAUXGWLZUUOUWAVUIUXBUUPYAYBZVUHVUIVUDVUGAUYQDYCYD
      XTUUOVUGVUAVUFUUOUYSVUAVUBWIUUOVUELKUYTLKUVIVUGVUAMVUFWJUUOVUEUUOAUYQUXGV
      UKWKWLUUOUYTUUOADUXGVUCWKWLUVLVUEUYTUUTWRTYEYHUUOUYQLKDLKVUDUYRXLUUOUYQVU
      KYFUUODVUCYFUYQDYIXTUUOVUFUWBAQNZUWBUYDQNZROZUYEUUOVUEVULUUTVUMRUUOAUUPUX
      HUXBYJUUOUWBUUTUWBXHNZQNUUTVUMUUOUUTUWBUUOFGUUOFUWGYKZUUOGUWPYKZYLUUOUWBU
      XTWGUUOUWBUXTXQZYMUUOVUOUYDUWBQUUOVUOUUTUXFXHNUYDUUOUWBUXFUUTXHUXIYNUUOFU
      WEGUWNVUPUUOUWEUXNWGVUQUUOUWNUXPWGUYMUYOYOYPYNYRYQUUOVUHUYDLKUXSUWBUDUFVU
      NUYEXLVUJUUOUYBUYCUYNUYPWQUYAVURUWBAUYDYSUUAUUBUUCUUDUUGUUOUUPDUUOUUPUXBY
      TUUODVUCYTUUEUUF $.
  $}

  ${
    $d n p r s t w x y z N $.  $d n p s t r w x y z P $.  $d p r s t w z S $.
    $d p r s t w z T $.  $d z ph $.
    pcval.1 $e |- S = sup ( { n e. NN0 | ( P ^ n ) || x } , RR , < ) $.
    pcval.2 $e |- T = sup ( { n e. NN0 | ( P ^ n ) || y } , RR , < ) $.
    $( The value of the prime power function.  (Contributed by Mario Carneiro,
       23-Feb-2014.)  (Revised by Mario Carneiro, 3-Oct-2014.) $)
    pcval $p |- ( ( P e. Prime /\ ( N e. QQ /\ N =/= 0 ) ) -> ( P pCnt N ) =
       ( iota z E. x e. ZZ E. y e. NN ( N = ( x / y ) /\ z = ( S - T ) ) ) ) $=
      ( cc0 co cv wceq wa cpnf cdivides cn0 cr clt vp vr cprime wcel cq wne cpc
      cdiv cmin cn wrex cz cio cif cexp wbr crab csup simpr eqeq1d eqeq1 breq1d
      oveq1 rabbidv supeq1d syl6eqr eqeq2d bi2anan9r 2rexbidv iotabidv ifbieq2d
      oveq12d df-pc pnfxr elexi iotaex ifex ovmpt2a ifnefalse sylan9eq anasss
      cxr ) DUCUDZHUEUDZHKUFZDHUGLZHAMZBMZUHLZNZCMZEFUILZNZOZBUJUKAULUKZCUMZNWC
      WDOWEWFHKNZPWPUNZWPUAUBDHUCUEUBMZKNZPWSWINZWKUAMZGMZUOLZWGQUPZGRUQZSTURZX
      DWHQUPZGRUQZSTURZUILZNZOZBUJUKAULUKZCUMZUNWRUGXBDNZWSHNZOZWTWQXOWPPXRWSHK
      XPXQUSUTXRXNWOCXRXMWNABULUJXQXAWJXPXLWMWSHWIVAXPXKWLWKXPXGEXJFUIXPXGDXCUO
      LZWGQUPZGRUQZSTUREXPSXFYATXPXEXTGRXPXDXSWGQXBDXCUOVCZVBVDVEIVFXPXJXSWHQUP
      ZGRUQZSTURFXPSXIYDTXPXHYCGRXPXDXSWHQYBVBVDVEJVFVLVGVHVIVJVKABCGUBUAVMWQPW
      PPWBVNVOWOCVPVQVRHKPWPVSVTWA $.

    ${
      pceu.3 $e |- U = sup ( { n e. NN0 | ( P ^ n ) || s } , RR , < ) $.
      pceu.4 $e |- V = sup ( { n e. NN0 | ( P ^ n ) || t } , RR , < ) $.
      pceu.5 $e |- ( ph -> P e. Prime ) $.
      pceu.6 $e |- ( ph -> N =/= 0 ) $.
      pceu.7 $e |- ( ph -> ( x e. ZZ /\ y e. NN ) ) $.
      pceu.8 $e |- ( ph -> N = ( x / y ) ) $.
      pceu.9 $e |- ( ph -> ( s e. ZZ /\ t e. NN ) ) $.
      pceu.10 $e |- ( ph -> N = ( s / t ) ) $.
      $( Lemma for ~ pceu .  (Contributed by Mario Carneiro, 23-Feb-2014.) $)
      pceulem $p |- ( ph -> ( S - T ) = ( U - V ) ) $=
        ( vz caddc co wceq cmin cv cexp cmul cdivides wbr cn0 crab cr csup wcel
        clt cz cn simprd nncnd simpld zcnd mulcomd cdiv eqtr3d nnne0d divmuleqd
        mpbid eqtrd breq2d rabbidv oveq2 breq1d cbvrabv 3eqtr4g supeq1d cc0 wne
        cprime nnzd div0d oveq1 eqeq1d syl5ibrcom sylibrd necon3d eqid pcpremul
        mpd syl122anc 3eqtr4d c2 cuz cfv prmuz2 syl pcprecl syl12anc addsubeq4d
        wa nn0cnd ) AGHUDUEZFKUDUEZUFFGUGUEHKUGUEUFAEIUHZUIUEZCUHZLUHZUJUEZUKUL
        ZIUMUNZUOURUPZXGBUHZDUHZUJUEZUKULZIUMUNZUOURUPZXDXEAUOXLXRURAEUCUHZUIUE
        ZXJUKULZUCUMUNYAXPUKULZUCUMUNXLXRAYBYCUCUMAXJXPYAUKAXJXIXHUJUEZXPAXHXIA
        XHAXNUSUQZXHUTUQZSVAZVBZAXIAXIUSUQZXOUTUQZUAVCZVDZVEAXIXOVFUEZXNXHVFUEZ
        UFYDXPUFAJYMYNUBTVGAXIXOXNXHYLAXOAYIYJUAVAZVBZAXNAYEYFSVCZVDYHAXOYOVHZA
        XHYGVHZVIVJVKVLVMXKYBIUCUMXFXTUFZXGYAXJUKXFXTEUIVNZVOVPXQYCIUCUMYTXGYAX
        PUKUUAVOVPVQVRAEWAUQZXHUSUQZXHVSVTZYIXIVSVTZXDXMUFQAXHYGWBZYSYKAJVSVTZU
        UERAXIVSJVSAXIVSUFZYMVSUFZJVSUFZAUUIUUHVSXOVFUEZVSUFAXOYPYRWCUUHYMUUKVS
        XIVSXOVFWDWEWFAJYMVSUBWEWGWHWKZEGHXMIXHXINOXMWIWJWLAUUBYEXNVSVTZXOUSUQZ
        XOVSVTZXEXSUFQYQAUUGUUMRAXNVSJVSAXNVSUFZYNVSUFZUUJAUUQUUPVSXHVFUEZVSUFA
        XHYHYSWCUUPYNUURVSXNVSXHVFWDWEWFAJYNVSTWEWGWHWKZAXOYOWBZYREFKXSIXNXOMPX
        SWIWJWLWMAGHFKAGAEWNWOWPUQZUUCUUDGUMUQZAUUBUVAQEWQWRZUUFYSUVAUUCUUDXBXB
        UVBEGUIUEXHUKULXGXHUKULIUMUNZEGIXHUVDWINWSVCWTXCAHAUVAYIUUEHUMUQZUVCYKU
        ULUVAYIUUEXBXBUVEEHUIUEXIUKULXGXIUKULIUMUNZEHIXIUVFWIOWSVCWTXCAFAUVAYEU
        UMFUMUQZUVCYQUUSUVAYEUUMXBXBUVGEFUIUEXNUKULXGXNUKULIUMUNZEFIXNUVHWIMWSV
        CWTXCAKAUVAUUNUUOKUMUQZUVCUUTYRUVAUUNUUOXBXBUVIEKUIUEXOUKULXGXOUKULIUMU
        NZEKIXOUVJWIPWSVCWTXCXAVJ $.
    $}

    $( Uniqueness for the prime power function.  (Contributed by Mario
       Carneiro, 23-Feb-2014.) $)
    pceu $p |- ( ( P e. Prime /\ ( N e. QQ /\ N =/= 0 ) ) ->
             E! z E. x e. ZZ E. y e. NN ( N = ( x / y ) /\ z = ( S - T ) ) ) $=
      ( wcel wa cv co wceq cmin cn wrex cz cdivides vs vt vw cprime cq cc0 cdiv
      wne wex cexp wbr cn0 crab cr clt csup wal weu simprl elq sylib ovex biidd
      wi ceqsexv exancom bitr3i rexbii rexcom4 bitri w3a simp11l simp11r simp12
      eqid simp13l simp3l pceulem simp13r simp3r 3eqtr4d 3exp rexlimdvv adantrl
      simp2 imp3a alrimivv anbi2d 2rexbidv eqeq2d rabbidv supeq1d syl5eq oveq1d
      eqeq1 oveq1 breq2 anbi12d rexbidv oveq2 oveq2d cbvrexv syl6bb sylanbrc
      eu4 ) DUDKZHUEKZHUFUHZLLZHAMZBMZUGNZOZCMZEFPNZOZLZBQRZASRZCUIZXSHUAMZUBMZ
      UGNZOZUCMZDGMUJNZYATUKZGULUMZUNUOUPZYFYBTUKZGULUMZUNUOUPZPNZOZLZUBQRZUASR
      ZLXNYEOZVDZUCUQCUQXSCURXIXMBQRZASRZXTXIXGUUAXFXGXHUSABHUTVAUUAXRCUIZASRXT
      YTUUBASYTXQCUIZBQRUUBXMUUCBQXMXPXMLCUIUUCXMXMCXOEFPVBXPXMVCVEXPXMCVFVGVHX
      QBCQVIVJVHXRACSVIVJVAXIYSCUCXIXSYQYRXIXQYQYRVDZABSQXFXHXJSKXKQKLZXQUUDVDV
      DXGXFXHLZUUEXQUUDUUFUUEXQVKZYOYRUAUBSQUUGYASKYBQKLZYOYRUUGUUHYOVKZXOYMXNY
      EUUIABUBDEFYIGHYLUAIJYIVOYLVOXFXHUUEXQUUHYOVLXFXHUUEXQUUHYOVMUUFUUEXQUUHY
      OVNXMXPUUFUUEUUHYOVPUUGUUHYOWEUUGUUHYDYNVQVRXMXPUUFUUEUUHYOVSUUGUUHYDYNVT
      WAWBWCWBWDWCWFWGXSYQCUCYRXSXMYEXOOZLZBQRZASRYQYRXQUUKABSQYRXPUUJXMXNYEXOW
      OWHWIUULYPAUASXJYAOZUULHYAXKUGNZOZYEYIFPNZOZLZBQRYPUUMUUKUURBQUUMXMUUOUUJ
      UUQUUMXLUUNHXJYAXKUGWPWJUUMXOUUPYEUUMEYIFPUUMEYFXJTUKZGULUMZUNUOUPYIIUUMU
      NUUTYHUOUUMUUSYGGULXJYAYFTWQWKWLWMWNWJWRWSUURYOBUBQXKYBOZUUOYDUUQYNUVAUUN
      YCHXKYBYAUGWTWJUVAUUPYMYEUVAFYLYIPUVAFYFXKTUKZGULUMZUNUOUPYLJUVAUNUVCYKUO
      UVAUVBYJGULXKYBYFTWQWKWLWMXAWJWRXBXCXBXCXEXD $.
  $}

  ${
    $d n x y z N $.  $d n x y z P $.  $d x y z S $.
    pczpre.1 $e |- S = sup ( { n e. NN0 | ( P ^ n ) || N } , RR , < ) $.
    $( Connect the prime count pre-function to the actual prime count function,
       when restricted to the integers.  (Contributed by Mario Carneiro,
       23-Feb-2014.)  (Proof shortened by Mario Carneiro, 24-Dec-2016.) $)
    pczpre $p |- ( ( P e. Prime /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                    ( P pCnt N ) = S ) $=
      ( vx vy vz wcel cz wa co wceq cdivides cn0 cr clt cmin eqid c1 cprime cc0
      wne cpc cv cdiv cexp wbr crab csup cn wrex cio cq zq pcval sylanr1 simprl
      div1d eqcomd c2 cuz cfv prmuz2 pcpre1 sylancl adantr oveq2d pcprecl sylan
      zcnd simpld nn0cnd subid1d eqtr2d 1nn oveq1 breq2 rabbidv supeq1d syl6eqr
      eqeq2d oveq1d anbi12d oveq2 rspc2ev mp3an2 syl12anc cvv weu wb ltso supex
      eqeltri pceu eqeq1 anbi2d 2rexbidv iota2 sylancr mpbid eqtrd ) AUAIZDJIZD
      UBUCZKZKZADUDLZDFUEZGUEZUFLZMZHUEZACUEUGLZXINUHZCOUIZPQUJZXNXJNUHZCOUIZPQ
      UJZRLZMZKZGUKULFJULZHUMZBXDXCDUNIZXEXHYEMDUOZFGHAXQXTCDXQSZXTSZUPUQXGXLBY
      AMZKZGUKULFJULZYEBMZXGXDDDTUFLZMZBBXNTNUHZCOUIZPQUJZRLZMZYLXCXDXEURZXGYND
      XGDXGDUUAVKUSUTXGYSBUBRLBXGYRUBBRXCYRUBMZXFXCAVAVBVCIZTTMUUBAVDZTSYQAYRCT
      YQSYRSVEVFVGVHXGBXGBXGBOIZABUGLDNUHZXCUUCXFUUEUUFKUUDXNDNUHZCOUIZABCDUUHS
      EVIVJVLVMVNVOXDTUKIYOYTKZYLVPYKUUIDDXJUFLZMZBBXTRLZMZKFGDTJUKXIDMZXLUUKYJ
      UUMUUNXKUUJDXIDXJUFVQWBUUNYAUULBUUNXQBXTRUUNXQUUHPQUJZBUUNPXPUUHQUUNXOUUG
      COXIDXNNVRVSVTEWAWCWBWDXJTMZUUKYOUUMYTUUPUUJYNDXJTDUFWEWBUUPUULYSBUUPXTYR
      BRUUPPXSYQQUUPXRYPCOXJTXNNVRVSVTVHWBWDWFWGWHXGBWIIYDHWJZYLYMWKBUUOWIEPUUH
      QWLWMWNXDXCYFXEUUQYGFGHAXQXTCDYHYIWOUQYDYLHBWIXMBMZYCYKFGJUKUURYBYJXLXMBY
      AWPWQWRWSWTXAXB $.
  $}

  ${
    $d x N $.  $d x P $.
    $( Closure of the prime power function.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    pczcl $p |- ( ( P e. Prime /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                  ( P pCnt N ) e. NN0 ) $=
      ( vx cprime wcel cz cc0 wne wa cpc co cexp cdivides wbr cn0 crab clt eqid
      cv cr csup pczpre c2 cuz cfv prmuz2 pcprecl sylan simpld eqeltrd ) ADEZBF
      EBGHIZIZABJKACSLKBMNCOPZTQUAZOAUOCBUORZUBUMUOOEZAUOLKBMNZUKAUCUDUEEULUQUR
      IAUFUNAUOCBUNRUPUGUHUIUJ $.
  $}

  $( Closure of the prime power function.  (Contributed by Mario Carneiro,
     23-Feb-2014.) $)
  pccl $p |- ( ( P e. Prime /\ N e. NN ) -> ( P pCnt N ) e. NN0 ) $=
    ( cn wcel cprime cz cc0 wne wa cpc co cn0 nnz nnne0 jca pczcl sylan2 ) BCDZ
    AEDBFDZBGHZIABJKLDRSTBMBNOABPQ $.

  ${
    pccld.1 $e |- ( ph -> P e. Prime ) $.
    pccld.2 $e |- ( ph -> N e. NN ) $.
    $( Closure of the prime power function.  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    pccld $p |- ( ph -> ( P pCnt N ) e. NN0 ) $=
      ( cprime wcel cn cpc co cn0 pccl syl2anc ) ABFGCHGBCIJKGDEBCLM $.
  $}

  ${
    $d n A $.  $d n B $.  $d n P $.
    $( Multiplication property of the prime power function.  (Contributed by
       Mario Carneiro, 23-Feb-2014.) $)
    pcmul $p |- ( ( P e. Prime /\ ( A e. ZZ /\ A =/= 0 ) /\
                                  ( B e. ZZ /\ B =/= 0 ) ) ->
                  ( P pCnt ( A x. B ) ) = ( ( P pCnt A ) + ( P pCnt B ) ) ) $=
      ( vn wcel cz cc0 wne wa co cdivides wbr cn0 crab clt csup caddc cpc eqid
      cr cprime w3a cv cexp cmul pcpremul pczpre 3adant3 3adant2 oveq12d zmulcl
      wceq ad2ant2r cc zcn anim1i mulne0 syl2an jca sylan2 3impb 3eqtr4rd ) CUA
      EZAFEZAGHZIZBFEZBGHZIZUBZCDUCUDJZAKLDMNTOPZVKBKLDMNTOPZQJVKABUEJZKLDMNTOP
      ZCARJZCBRJZQJCVNRJZCVLVMVODABVLSZVMSZVOSZUFVJVPVLVQVMQVCVFVPVLULVICVLDAVS
      UGUHVCVIVQVMULVFCVMDBVTUGUIUJVCVFVIVRVOULZVFVIIZVCVNFEZVNGHZIWBWCWDWEVDVG
      WDVEVHABUKUMVFAUNEZVEIBUNEZVHIWEVIVDWFVEAUOUPVGWGVHBUOUPABUQURUSCVODVNWAU
      GUTVAVB $.
  $}

  ${
    $d n x y z A $.  $d n x y z B $.  $d n x y z P $.
    $( Division property of the prime power function.  (Contributed by Mario
       Carneiro, 1-Mar-2014.) $)
    pcdiv $p |- ( ( P e. Prime /\ ( A e. ZZ /\ A =/= 0 ) /\ B e. NN ) ->
                  ( P pCnt ( A / B ) ) = ( ( P pCnt A ) - ( P pCnt B ) ) ) $=
      ( vx vy vz vn wcel cz wa cn cdiv co wceq cdivides cn0 cr clt cmin eqid cv
      cprime cc0 wne w3a cpc cexp wbr crab csup wrex cio simp1 simp2l simp3 znq
      cq syl2anc zcnd nncnd simp2r nnne0d divne0d pcval syl12anc pczpre 3adant3
      nnz nnne0 sylan2 3adant2 oveq12d jctil oveq1 eqeq2d breq2 rabbidv supeq1d
      jca oveq1d anbi12d oveq2 oveq2d rspc2ev syl3anc cvv weu ovex eqeq1 anbi2d
      wb pceu 2rexbidv iota2 sylancr mpbid eqtrd ) CUBHZAIHZAUCUDZJZBKHZUEZCABL
      MZUFMZXDDUAZEUAZLMZNZFUAZCGUAUGMZXFOUHZGPUIZQRUJZXKXGOUHZGPUIZQRUJZSMZNZJ
      ZEKUKDIUKZFULZCAUFMZCBUFMZSMZXCWRXDUQHZXDUCUDZXEYBNWRXAXBUMZXCWSXBYFWRWSW
      TXBUNZWRXAXBUOZABUPURZXCABXCAYIUSXCBYJUTWRWSWTXBVAXCBYJVBVCZDEFCXNXQGXDXN
      TZXQTZVDVEXCXIYEXRNZJZEKUKDIUKZYBYENZXCWSXBXDXDNZYEXKAOUHZGPUIZQRUJZXKBOU
      HZGPUIZQRUJZSMZNZJZYQYIYJXCUUGYSXCYCUUBYDUUESWRXAYCUUBNXBCUUBGAUUBTVFVGWR
      XBYDUUENZXAXBWRBIHZBUCUDZJUUIXBUUJUUKBVHBVIVSCUUEGBUUETVFVJVKVLXDTVMYPUUH
      XDAXGLMZNZYEUUBXQSMZNZJDEABIKXFANZXIUUMYOUUOUUPXHUULXDXFAXGLVNVOUUPXRUUNY
      EUUPXNUUBXQSUUPQXMUUARUUPXLYTGPXFAXKOVPVQVRVTVOWAXGBNZUUMYSUUOUUGUUQUULXD
      XDXGBALWBVOUUQUUNUUFYEUUQXQUUEUUBSUUQQXPUUDRUUQXOUUCGPXGBXKOVPVQVRWCVOWAW
      DWEXCYEWFHYAFWGZYQYRWKYCYDSWHXCWRYFYGUURYHYKYLDEFCXNXQGXDYMYNWLVEYAYQFYEW
      FXJYENZXTYPDEIKUUSXSYOXIXJYEXRWIWJWMWNWOWPWQ $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z P $.
    $( Multiplication property of the prime power function.  (Contributed by
       Mario Carneiro, 9-Sep-2014.) $)
    pcqmul $p |- ( ( P e. Prime /\ ( A e. QQ /\ A =/= 0 ) /\
                                   ( B e. QQ /\ B =/= 0 ) ) ->
                  ( P pCnt ( A x. B ) ) = ( ( P pCnt A ) + ( P pCnt B ) ) ) $=
      ( vx vy vz vw wcel cc0 wne wa cdiv co wceq cn wrex cz cpc caddc adantrr
      cprime cq w3a cv cmul simp2l elq simp3l reeanv simp2r simp3r jca ad2antrr
      sylib wi simp1 simprl nncnd nnne0d div0d eqeq1d syl5ibrcom necon3d simprr
      cmin simpll simplrl simplrr zmulcld zcnd simprrl simprrr mulne0d nnmulcld
      oveq1 pcdiv syl121anc pcmul syl122anc nnzd oveq12d cn0 pczcl nn0cnd pccld
      syl12anc addsub4d 3eqtrd cc divmuldivd oveq2d 3eqtr4d expr neeq1 bi2anan9
      syl2and oveq12 oveq2 oveqan12d eqeq12d imbi12d sylanl1 rexlimdvva syl5bir
      mpid mp2and ) CUAHZAUBHZAIJZKZBUBHZBIJZKZUCZADUDZEUDZLMZNZEOPZDQPZBFUDZGU
      DZLMZNZGOPZFQPZCABUEMZRMZCARMZCBRMZSMZNZXNXHXTXGXHXIXMUFDEAUGUNXNXKYFXGXJ
      XKXLUHFGBUGUNXTYFKXSYEKZFQPDQPXNYLXSYEDFQQUIXNYMYLDFQQYMXRYDKZGOPEOPXNXOQ
      HZYAQHZKZKZYLXRYDEGOOUIYRYNYLEGOOYRXPOHZYBOHZKZKYNXIXLKZYLXNUUBYQUUAXNXIX
      LXGXHXIXMUJXGXJXKXLUKULUMXNXGYQUUAYNUUBYLUOZUOXGXJXMUPXGYQKZUUAKZUUCYNXQI
      JZYCIJZKZCXQYCUEMZRMZCXQRMZCYCRMZSMZNZUOUUEUUFXOIJZUUGYAIJZUUNUUEXOIXQIUU
      EXQINXOINZIXPLMZINUUEXPUUEXPUUDYSYTUQZURZUUEXPUUSUSZUTUUQXQUURIXOIXPLVOVA
      VBVCUUEYAIYCIUUEYCINYAINZIYBLMZINUUEYBUUEYBUUDYSYTVDZURZUUEYBUVDUSZUTUVBY
      CUVCIYAIYBLVOVAVBVCUUDUUAUUOUUPKZUUNUUDUUAUVGKZKZCXOYAUEMZXPYBUEMZLMZRMZC
      XORMZCXPRMZVEMZCYARMZCYBRMZVEMZSMZUUJUUMUVIUVMCUVJRMZCUVKRMZVEMZUVNUVQSMZ
      UVOUVRSMZVEMUVTUVIXGUVJQHUVJIJUVKOHUVMUWCNXGYQUVHVFZUVIXOYAXGYOYPUVHVGZXG
      YOYPUVHVHZVIUVIXOYAUVIXOUWGVJZUVIYAUWHVJZUUDUUAUUOUUPVKZUUDUUAUUOUUPVLZVM
      UVIXPYBUUDUUAYSUVGUUSTZUUDUUAYTUVGUVDTZVNUVJUVKCVPVQUVIUWAUWDUWBUWEVEUVIX
      GYOUUOYPUUPUWAUWDNUWFUWGUWKUWHUWLXOYACVRVSUVIXGXPQHXPIJZYBQHYBIJZUWBUWENU
      WFUVIXPUWMVTUUDUUAUWOUVGUVATZUVIYBUWNVTUUDUUAUWPUVGUVFTZXPYBCVRVSWAUVIUVN
      UVQUVOUVRUVIUVNUVIXGYOUUOUVNWBHUWFUWGUWKCXOWCWFWDUVIUVQUVIXGYPUUPUVQWBHUW
      FUWHUWLCYAWCWFWDUVIUVOUVICXPUWFUWMWEWDUVIUVRUVICYBUWFUWNWEWDWGWHUVIUUIUVL
      CRUVIXOXPYAYBUWIUUDUUAXPWIHUVGUUTTUWJUUDUUAYBWIHUVGUVETUWQUWRWJWKUVIUUKUV
      PUULUVSSUVIXGYOUUOYSUUKUVPNUWFUWGUWKUWMXOXPCVPVQUVIXGYPUUPYTUULUVSNUWFUWH
      UWLUWNYAYBCVPVQWAWLWMWPYNUUBUUHYLUUNXRXIUUFYDXLUUGAXQIWNBYCIWNWOYNYHUUJYK
      UUMYNYGUUICRAXQBYCUEWQWKXRYDYIUUKYJUULSAXQCRWRBYCCRWRWSWTXAVBXBXEXCXDXCXD
      XF $.
  $}

  ${
    $d x y A $.  $d n p r x y z P $.  $d n x y N $.
    $( The value of the prime power function at zero.  (Contributed by Mario
       Carneiro, 3-Oct-2014.) $)
    pc0 $p |- ( P e. Prime -> ( P pCnt 0 ) = +oo ) $=
      ( vp vr vx vy vz vn cprime wcel cc0 cq cpc co cpnf cz cv cdivides wbr cn0
      wceq 0z zq ax-mp cdiv cexp crab cr clt csup cmin wa cn wrex iftrue adantl
      cio cif df-pc cxr pnfxr elexi ovmpt2a mpan2 ) AHIJKIZAJLMNTJOIVDUAJUBUCBC
      AJHKCPZJTZNVEDPZEPZUDMTFPBPZGPUEMZVGQRGSUFUGUHUIVJVHQRGSUFUGUHUIUJMTUKEUL
      UMDOUMFUPZUQZNLVFVLNTVIATVFNVKUNUODEFGCBURNUSUTVAVBVC $.

    $( Value of the prime count function at 1.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    pc1 $p |- ( P e. Prime -> ( P pCnt 1 ) = 0 ) $=
      ( vn cprime wcel c1 cpc co cv cexp cdivides wbr cn0 crab cr clt csup wceq
      cc0 cz eqid wne 1z ax-1ne0 pczpre mpanr12 c2 cuz cfv prmuz2 sylancl eqtrd
      pcpre1 ) ACDZAEFGZABHIGEJKBLMZNOPZRUMESDERUAUNUPQUBUCAUPBEUPTZUDUEUMAUFUG
      UHDEEQUPRQAUIETUOAUPBEUOTUQULUJUK $.

    $( Closure of the general prime count function.  (Contributed by Mario
       Carneiro, 23-Feb-2014.) $)
    pcqcl $p |- ( ( P e. Prime /\ ( N e. QQ /\ N =/= 0 ) ) ->
                 ( P pCnt N ) e. ZZ ) $=
      ( vx vy wcel cc0 wne wa cv cdiv co wceq cn wrex cz syl5ibrcom pczcl nn0zd
      cpc wi cprime cq simprl elq sylib nncn nnne0 div0d ad2antll oveq1 necon3d
      eqeq1d an32 w3a cmin pcdiv 3adant3 nnz jca sylan2 3adant2 zsubcld eqeltrd
      3expb sylan2b expr syld neeq1 oveq2 eleq1d imbi12d com23 impancom adantrl
      rexlimdvv mpd ) AUAEZBUBEZBFGZHHZBCIZDIZJKZLZDMNCONZABSKZOEZVTVRWEVQVRVSU
      CCDBUDUEVTWDWGCDOMVQVSWAOEZWBMEZHZWDWGTZTVRVQWJVSWKVQWJHZWDVSWGWLVSWGTWDW
      CFGZAWCSKZOEZTWLWMWAFGZWOWLWAFWCFWLWCFLWAFLZFWBJKZFLZWIWSVQWHWIWBWBUFWBUG
      ZUHUIWQWCWRFWAFWBJUJULPUKVQWJWPWOWJWPHVQWHWPHZWIHWOWHWIWPUMVQXAWIWOVQXAWI
      UNZWNAWASKZAWBSKZUOKOWAWBAUPXBXCXDVQXAXCOEWIVQXAHXCAWAQRUQVQWIXDOEZXAWIVQ
      WBOEZWBFGZHZXEWIXFXGWBURWTUSVQXHHXDAWBQRUTVAVBVCVDVEVFVGWDVSWMWGWOBWCFVHW
      DWFWNOBWCASVIVJVKPVLVMVNVOVP $.

    $( Division property of the prime power function.  (Contributed by Mario
       Carneiro, 10-Aug-2015.) $)
    pcqdiv $p |- ( ( P e. Prime /\ ( A e. QQ /\ A =/= 0 ) /\
                                   ( B e. QQ /\ B =/= 0 ) ) ->
                  ( P pCnt ( A / B ) ) = ( ( P pCnt A ) - ( P pCnt B ) ) ) $=
      ( cprime wcel cq cc0 wne wa w3a cpc co cmin cdiv cc qcn syl cz pcqcl zcnd
      caddc cmul simp2l simp3l simp3r divcan1d oveq2d wceq simp1 qdivcl syl3anc
      simp2r divne0d pcqmul syl122anc eqtr3d oveq1d syl12anc 3adant2 pncand
      eqtr2d ) CDEZAFEZAGHZIZBFEZBGHZIZJZCAKLZCBKLZMLCABNLZKLZVKUALZVKMLVMVIVJV
      NVKMVICVLBUBLZKLZVJVNVIVOACKVIABVIVCAOEVBVCVDVHUCZAPQZVIVFBOEVBVEVFVGUDZB
      PQZVBVEVFVGUEZUFUGVIVBVLFEZVLGHZVFVGVPVNUHVBVEVHUIZVIVCVFVGWBVQVSWAABUJUK
      ZVIABVRVTVBVCVDVHULWAUMZVSWAVLBCUNUOUPUQVIVMVKVIVMVIVBWBWCVMREWDWEWFCVLSU
      RTVIVKVBVHVKREVECBSUSTUTVA $.

    $( Prime power of a reciprocal.  (Contributed by Mario Carneiro,
       10-Aug-2015.) $)
    pcrec $p |- ( ( P e. Prime /\ ( A e. QQ /\ A =/= 0 ) ) ->
                  ( P pCnt ( 1 / A ) ) = -u ( P pCnt A ) ) $=
      ( cprime wcel cq cc0 wne wa c1 cdiv co cmin cneg wceq cz 1z ax-mp ax-1ne0
      cpc zq pm3.2i pcqdiv mp3an2 pc1 adantr oveq1d eqtrd df-neg syl6eqr ) BCDZ
      AEDAFGHZHZBIAJKSKZFBASKZLKZUNMULUMBISKZUNLKZUOUJIEDZIFGZHUKUMUQNURUSIODUR
      PITQRUAIABUBUCULUPFUNLUJUPFNUKBUDUEUFUGUNUHUI $.

    $( Prime power of an exponential.  (Contributed by Mario Carneiro,
       10-Aug-2015.) $)
    pcexp $p |- ( ( P e. Prime /\ ( A e. QQ /\ A =/= 0 ) /\ N e. ZZ ) ->
                  ( P pCnt ( A ^ N ) ) = ( N x. ( P pCnt A ) ) ) $=
      ( wcel cc0 wa cexp co cpc cmul wceq cneg caddc oveq2 oveq2d oveq1 eqeq12d
      c1 adantr cc vx vy cprime cq wne cz cv pc1 qcn ad2antrl exp0d zcnd mul02d
      pcqcl 3eqtr4d cn0 expp1 sylan simpll simplrl simplrr nn0z qexpclz syl3anc
      wi adantl expne0d pcqmul syl122anc eqtrd nn0cn ax-1cn a1i adddird mulid2d
      syl5ibr ex cn negeq cdiv nnnn0 expneg syl2an sylan2 syl12anc nncn mulneg1
      pcrec syl2anr zindd 3impia ) BUCDZAUDDZAEUEZFZCUFDBACGHZIHZCBAIHZJHZKZBAU
      AUGZGHZIHZXAWRJHZKBAEGHZIHZEWRJHZKBAUBUGZGHZIHZXHWRJHZKZBAXHLZGHZIHZXMWRJ
      HZKZBAXHRMHZGHZIHZXRWRJHZKZWTWLWOFZUAUBCXAEKZXCXFXDXGYDXBXEBIXAEAGNOXAEWR
      JPQXAXHKZXCXJXDXKYEXBXIBIXAXHAGNOXAXHWRJPQXAXRKZXCXTXDYAYFXBXSBIXAXRAGNOX
      AXRWRJPQXAXMKZXCXOXDXPYGXBXNBIXAXMAGNOXAXMWRJPQXACKZXCWQXDWSYHXBWPBIXACAG
      NOXACWRJPQYCBRIHZEXFXGWLYIEKWOBUHSYCXERBIYCAWMATDZWLWNAUIUJZUKOYCWRYCWRBA
      UNULZUMUOYCXHUPDZXLYBVEXLYBYCYMFZXJWRMHZXKWRMHZKXJXKWRMPYNXTYOYAYPYNXTBXI
      AJHZIHZYOYNXSYQBIYCYJYMXSYQKYKAXHUQUROYNWLXIUDDZXIEUEZWMWNYRYOKWLWOYMUSYN
      WMWNXHUFDZYSWLWMWNYMUTZWLWMWNYMVAZYMUUAYCXHVBVFZAXHVCVDZYNAXHYCYJYMYKSUUC
      UUDVGZUUBUUCXIABVHVIVJYNYAXKRWRJHZMHYPYNXHRWRYMXHTDZYCXHVKVFRTDYNVLVMYCWR
      TDZYMYLSZVNYNUUGWRXKMYNWRUUJVOOVJQVPVQYCXHVRDZXLXQVEXLXQYCUUKFZXJLZXKLZKX
      JXKVSUULXOUUMXPUUNUULXOBRXIVTHZIHZUUMUULXNUUOBIYCYJYMXNUUOKUUKYKXHWAZAXHW
      BWCOUULWLYSYTUUPUUMKWLWOUUKUSUUKYCYMYSUUQUUEWDUUKYCYMYTUUQUUFWDXIBWHWEVJU
      UKUUHUUIXPUUNKYCXHWFYLXHWRWGWIQVPVQWJWK $.

    $( Extended real closure of the general prime count function.  (Contributed
       by Mario Carneiro, 3-Oct-2014.) $)
    pcxcl $p |- ( ( P e. Prime /\ N e. QQ ) ->
                 ( P pCnt N ) e. RR* ) $=
      ( cprime wcel cq wa cpc cxr cc0 wceq cpnf pc0 pnfxr syl6eqel adantr oveq2
      co eleq1d syl5ibrcom wne pcqcl zred rexrd expr pm2.61dne ) ACDZBEDZFZABGQ
      ZHDZBIUHUJBIJZAIGQZHDZUFUMUGUFULKHALMNOUKUIULHBIAGPRSUFUGBITZUJUFUGUNFFZU
      IUOUIABUAUBUCUDUE $.

    $( The prime count of an integer is greater or equal to zero.  (Contributed
       by Mario Carneiro, 3-Oct-2014.) $)
    pcge0 $p |- ( ( P e. Prime /\ N e. ZZ ) -> 0 <_ ( P pCnt N ) ) $=
      ( cprime wcel cz wa cc0 cpc co cle wbr wceq cxr 0xr pnfge ax-mp oveq2 pc0
      cpnf adantr sylan9eqr syl5breqr wne pczcl nn0ge0d anassrs pm2.61dane ) AC
      DZBEDZFZGABHIZJKZBGUJBGLZFGSUKJGMDGSJKNGOPUMUJUKAGHIZSBGAHQUHUNSLUIARTUAU
      BUHUIBGUCZULUHUIUOFFUKABUDUEUFUG $.

    $( Defining property of the prime count function.  (Contributed by Mario
       Carneiro, 9-Sep-2014.) $)
    pczdvds $p |- ( ( P e. Prime /\ ( N e. ZZ /\ N =/= 0 ) ) ->
      ( P ^ ( P pCnt N ) ) || N ) $=
      ( vn cprime wcel cz cc0 wne wa cpc co cexp cdivides wbr cn0 crab clt eqid
      cv cr csup pczpre oveq2d c2 cuz cfv prmuz2 pcprecl simprd sylan eqbrtrd )
      ADEZBFEBGHIZIZAABJKZLKAACSLKBMNCOPZTQUAZLKZBMUNUOUQALAUQCBUQRZUBUCULAUDUE
      UFEZUMURBMNZAUGUTUMIUQOEVAUPAUQCBUPRUSUHUIUJUK $.

    $( Defining property of the prime count function.  (Contributed by Mario
       Carneiro, 23-Feb-2014.) $)
    pcdvds $p |- ( ( P e. Prime /\ N e. NN ) -> ( P ^ ( P pCnt N ) ) || N ) $=
      ( cn wcel cprime cz cc0 wne wa cpc co cexp cdivides wbr nnz nnne0 pczdvds
      jca sylan2 ) BCDZAEDBFDZBGHZIAABJKLKBMNTUAUBBOBPRABQS $.

    $( Defining property of the prime count function.  (Contributed by Mario
       Carneiro, 3-Oct-2014.) $)
    pczndvds $p |- ( ( P e. Prime /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                    -. ( P ^ ( ( P pCnt N ) + 1 ) ) || N ) $=
      ( vn cprime wcel cz cc0 wne wa cpc co c1 caddc cexp cdivides wbr cn0 crab
      cv eqid cr clt c2 cuz cfv wn prmuz2 pcprendvds sylan pczpre oveq1d oveq2d
      csup breq1d mtbird ) ADEZBFEBGHIZIZAABJKZLMKZNKZBOPAACSNKBOPCQRZUAUBUMZLM
      KZNKZBOPZUPAUCUDUEEUQVFUFAUGVBAVCCBVBTVCTZUHUIURVAVEBOURUTVDANURUSVCLMAVC
      CBVGUJUKULUNUO $.

    $( Defining property of the prime count function.  (Contributed by Mario
       Carneiro, 23-Feb-2014.) $)
    pcndvds $p |- ( ( P e. Prime /\ N e. NN ) ->
                    -. ( P ^ ( ( P pCnt N ) + 1 ) ) || N ) $=
      ( cn wcel cprime cz cc0 wne wa cpc co c1 caddc cexp cdivides wbr wn nnne0
      nnz jca pczndvds sylan2 ) BCDZAEDBFDZBGHZIAABJKLMKNKBOPQUCUDUEBSBRTABUAUB
      $.

    $( The remainder after dividing out all factors of ` P ` is not divisible
       by ` P ` .  (Contributed by Mario Carneiro, 9-Sep-2014.) $)
    pczndvds2 $p |- ( ( P e. Prime /\ ( N e. ZZ /\ N =/= 0 ) ) ->
                    -. P || ( N / ( P ^ ( P pCnt N ) ) ) ) $=
      ( vn cprime wcel cz cc0 wne wa cpc co cexp cdiv cdivides wbr cv crab eqid
      cn0 oveq2d cr clt csup c2 cuz cfv prmuz2 pcprendvds2 pczpre breq2d mtbird
      wn sylan ) ADEZBFEBGHIZIZABAABJKZLKZMKZNOABAACPLKBNOCSQZUAUBUCZLKZMKZNOZU
      NAUDUEUFEUOVDULAUGUTAVACBUTRVARZUHUMUPUSVCANUPURVBBMUPUQVAALAVACBVEUITTUJ
      UK $.

    $( The remainder after dividing out all factors of ` P ` is not divisible
       by ` P ` .  (Contributed by Mario Carneiro, 23-Feb-2014.) $)
    pcndvds2 $p |- ( ( P e. Prime /\ N e. NN ) ->
                    -. P || ( N / ( P ^ ( P pCnt N ) ) ) ) $=
      ( cn wcel cprime cz cc0 wne wa cpc co cexp cdiv cdivides wbr wn nnz nnne0
      jca pczndvds2 sylan2 ) BCDZAEDBFDZBGHZIABAABJKLKMKNOPUBUCUDBQBRSABTUA $.
  $}

  $( ` P ^ A ` divides ` N ` if and only if ` A ` is at most the count of
     ` P ` .  (Contributed by Mario Carneiro, 3-Oct-2014.) $)
  pcdvdsb $p |- ( ( P e. Prime /\ N e. ZZ /\ A e. NN0 ) ->
                  ( A <_ ( P pCnt N ) <-> ( P ^ A ) || N ) ) $=
    ( wcel cz cn0 cpc co cle wbr cexp cdivides wb cc0 wa syl2anc wi syl nnzd wn
    cprime w3a wceq oveq2 breq2d breq2 bibi12d wne cuz cfv simpl3 simpl1 simpl2
    nn0zd simpr pczcl syl12anc eluz prmnn dvdsexp sylbird pczdvds nnexpcl sylan
    cn 3expia 3adant2 adantr nnexpcld dvdstr syl3anc mpan2d syld c1 caddc nn0re
    clt cr ltnle syl2an nn0ltp1le bitr3d peano2nn0 pczndvds imnan sylibr sylbid
    mtod impcon4bid cpnf cxr 3ad2ant3 rexrd pc0 3ad2ant1 breqtrrd 2thd pm2.61ne
    pnfge dvds0 ) BUADZCEDZAFDZUBZABCGHZIJZBAKHZCLJZMABNGHZIJZXGNLJZMCNCNUCZXFX
    JXHXKXLXEXIAICNBGUDUECNXGLUFUGXDCNUHZOZXFXHXNXFXGBXEKHZLJZXHXNXFXEAUIUJDZXP
    XNAEDZXEEDXQXFMXNAXAXBXCXMUKZUNZXNXEXNXAXBXMXEFDZXAXBXCXMULZXAXBXCXMUMZXDXM
    UOZBCUPUQZUNAXEURPXNBEDZXCXQXPQXNBXNXABVEDZYBBUSZRZSZXSYFXCXQXPBAXEUTVFPVAX
    NXPXOCLJZXHXNXAXBXMYKYBYCYDBCVBUQXNXGEDZXOEDXBXPYKOXHQXDYLXMXDXGXAXCXGVEDZX
    BXAYGXCYMYHBAVCVDVGSZVHZXNXOXNBXEYIYEVISYCXGXOCVJVKVLVMXNXFTZXEVNVOHZAIJZXH
    TZXNYAXCYPYRMYEXSYAXCOXEAVQJZYPYRYAXEVRDAVRDZYTYPMXCXEVPAVPZXEAVSVTXEAWAWBP
    XNYRBYQKHZXGLJZYSXNYRAYQUIUJDZUUDXNYQEDXRUUEYRMXNYQXNYAYQFDZYEXEWCRZUNXTYQA
    URPXNYFUUFUUEUUDQYJUUGYFUUFUUEUUDBYQAUTVFPVAXNUUDXHOZTUUDYSQXNUUHUUCCLJZXNX
    AXBXMUUITYBYCYDBCWDUQXNUUCEDYLXBUUHUUIQXNUUCXNBYQYIUUGVISYOYCUUCXGCVJVKWHUU
    DXHWEWFVMWGWIXDXJXKXDAWJXIIXDAWKDAWJIJXDAXCXAUUAXBUUBWLWMAWSRXAXBXIWJUCXCBW
    NWOWPXDYLXKYNXGWTRWQWR $.

  $( There are a positive number of powers of a prime ` P ` in ` N ` iff ` P `
     divides ` N ` .  (Contributed by Mario Carneiro, 23-Feb-2014.) $)
  pcelnn $p |- ( ( P e. Prime /\ N e. NN ) ->
                  ( ( P pCnt N ) e. NN <-> P || N ) ) $=
    ( cprime wcel cn wa c1 cpc co cle wbr cexp cdivides cz nnz cn0 1nn0 pcdvdsb
    wb mp3an3 sylan2 pccl elnnnn0c baibr wceq prmnn nncnd adantr breq1d 3bitr3d
    syl exp1d ) ACDZBEDZFZGABHIZJKZAGLIZBMKZUPEDZABMKUNUMBNDZUQUSSZBOUMVAGPDVBQ
    GABRTUAUOUPPDZUQUTSABUBUTVCUQUPUCUDUKUOURABMUMURAUEUNUMAUMAAUFUGULUHUIUJ $.

  $( There are zero powers of a prime ` P ` in ` N ` iff ` P ` does not divide
     ` N ` .  (Contributed by Mario Carneiro, 23-Feb-2014.) $)
  pceq0 $p |- ( ( P e. Prime /\ N e. NN ) ->
                  ( ( P pCnt N ) = 0 <-> -. P || N ) ) $=
    ( cprime wcel cn wa cdivides wbr cpc co cc0 wne pcelnn cn0 wb pccl nnne0 wo
    wceq elnn0 biimpi ord necon1ad impbid2 syl bitr3d necon2bbid ) ACDBEDFZABGH
    ZABIJZKUHUJEDZUIUJKLZABMUHUJNDZUKULOABPUMUKULUJQUMUKUJKUMUKUJKSZUMUKUNRUJTU
    AUBUCUDUEUFUG $.

  $( The prime count of a prime power.  (Contributed by Mario Carneiro,
     12-Mar-2014.) $)
  pcidlem $p |- ( ( P e. Prime /\ A e. NN0 ) -> ( P pCnt ( P ^ A ) ) = A ) $=
    ( cprime wcel cn0 co cle wbr cdivides cn syl nnexpcld cz wb pcdvdsb syl3anc
    cexp nnzd adantl mpbird cpc wceq simpl prmnn simpr pccld nn0red leidd mpbid
    wa wi dvdsle syl2anc mpd nnred nn0zd nn0z c2 cuz cfv c1 clt eluz2b1 simprbi
    prmuz2 leexp2d iddvds cr nn0re letri3d mpbir2and ) BCDZAEDZUJZBBAQFZUAFZAUB
    VPAGHZAVPGHZVNVQBVPQFZVOGHZVNVSVOIHZVTVNVPVPGHZWAVNVPVNVPVNBVOVLVMUCZVNBAVN
    VLBJDWCBUDKZVLVMUEZLZUFZUGZUHVNVLVOMDZVPEDWBWANWCVNVOWFRZWGVPBVOOPUIVNVSMDV
    OJDWAVTUKVNVSVNBVPWDWGLRWFVSVOULUMUNVNBVPAVNBWDUOVNVPWGUPVMAMDVLAUQSVNBURUS
    UTDZVABVBHZVNVLWKWCBVEKWKBMDWLBVCVDKVFTVNVRVOVOIHZVNWIWMWJVOVGKVNVLWIVMVRWM
    NWCWJWEABVOOPTVNVPAWHVMAVHDVLAVISVJVK $.

  $( The prime count of a prime power.  (Contributed by Mario Carneiro,
     9-Sep-2014.) $)
  pcid $p |- ( ( P e. Prime /\ A e. ZZ ) -> ( P pCnt ( P ^ A ) ) = A ) $=
    ( cz wcel cn0 cneg cn wa cexp co cpc wceq pcidlem c1 cc adantr cmin cc0 a1i
    eqtrd cprime cr wo elznn0nn prmnn nncnd simprl recnd nnnn0 ad2antll expneg2
    syl3anc oveq2d wne simpl 1z ax-1ne0 nnexpcld pcdiv syl121anc syldan oveq12d
    cdiv pc1 df-neg negnegd syl5eqr jaodan sylan2b ) ACDBUADZAEDZAUBDZAFZGDZHZU
    CBBAIJZKJZALZAUDVJVKVRVOABMVJVOHZVQBNBVMIJZVCJZKJZAVSVPWABKVSBODAODVMEDZVPW
    ALVSBVJBGDVOBUEPZUFVSAVJVLVNUGUHZVNWCVJVLVMUIUJZBAUKULUMVSWBBNKJZBVTKJZQJZA
    VSVJNCDZNRUNZVTGDWBWILVJVOUOWJVSUPSWKVSUQSVSBVMWDWFURNVTBUSUTVSWIRVMQJZAVSW
    GRWHVMQVJWGRLVOBVDPVJVOWCWHVMLWFVMBMVAVBVSWLVMFAVMVEVSAWEVFVGTTTVHVI $.

  ${
    $d x y A $.  $d x y P $.
    $( The prime count of a negative number.  (Contributed by Mario Carneiro,
       13-Mar-2014.) $)
    pcneg $p |- ( ( P e. Prime /\ A e. QQ ) ->
                  ( P pCnt -u A ) = ( P pCnt A ) ) $=
      ( vx vy wcel cneg cpc co wceq cdiv cn cz wa cc0 wne oveq2d cmin cn0 clt
      cr cprime cq cv wrex elq cc zcn ad2antrl nncn ad2antll nnne0 divnegd neg0
      simpr negeqd 3eqtr4a oveq1d simpll simplrl znegcld negne0bd mpbid simplrr
      syl pcdiv syl121anc cexp cdivides wbr crab csup eqid pczpre syl12anc prmz
      wb zexpcl sylan simpl dvdsnegb syl2an an32s rabbidva supeq1d eqtrd eqtr4d
      pm2.61dane negeq oveq2 eqeq12d syl5ibrcom rexlimdvva syl5bi imp ) BUAEZAU
      BEZBAFZGHZBAGHZIZWPACUCZDUCZJHZIZDKUDCLUDWOWTCDAUEWOXDWTCDLKWOXALEZXBKEZM
      ZMZWTXDBXCFZGHZBXCGHZIXHXJBXAFZXBJHZGHZXKXHXIXMBGXHXAXBXEXAUFEWOXFXAUGZUH
      XFXBUFEWOXEXBUIUJXFXBNOWOXEXBUKUJULPXHXNXKIXANXHXANIZMZXMXCBGXQXLXAXBJXQN
      FNXLXAUMXQXANXHXPUNZUOXRUPUQPXHXANOZMZXNBXLGHZBXBGHZQHZXKXTWOXLLEZXLNOZXF
      XNYCIWOXGXSURZXTXAWOXEXFXSUSZUTZXTXSYEXHXSUNZXTXEXSYEVPYGXEXAXOVAVDVBZWOX
      EXFXSVCZXLXBBVEVFXTXKBXAGHZYBQHZYCXTWOXEXSXFXKYMIYFYGYIYKXAXBBVEVFXTYAYLY
      BQXTYABXBVGHZXLVHVIZDRVJZTSVKZYLXTWOYDYEYAYQIYFYHYJBYQDXLYQVLVMVNXTWOXEXS
      YLYQIYFYGYIWOXEXSMZMZYLYNXAVHVIZDRVJZTSVKZYQBUUBDXAUUBVLVMYSTUUAYPSYSYTYO
      DRWOXBREZYRYTYOVPZWOUUCMYNLEZXEUUDYRWOBLEUUCUUEBVOBXBVQVRXEXSVSYNXAVTWAWB
      WCWDWEVNWFUQWFWFWGWEXDWRXJWSXKXDWQXIBGAXCWHPAXCBGWIWJWKWLWMWN $.
  $}

  $( The prime count of an absolute value.  (Contributed by Mario Carneiro,
     13-Mar-2014.) $)
  pcabs $p |- ( ( P e. Prime /\ A e. QQ ) ->
                ( P pCnt ( abs ` A ) ) = ( P pCnt A ) ) $=
    ( cprime wcel cq wa cabs cfv wceq cpc co cneg wi oveq2 a1i pcneg syl5ibrcom
    eqeq1d cr qre adantl absord mpjaod ) BCDZAEDZFZAGHZAIZBUGJKZBAJKZIZUGALZIZU
    HUKMUFUGABJNOUFUKUMBULJKZUJIABPUMUIUNUJUGULBJNRQUFAUEASDUDATUAUBUC $.

  $( The prime count increases under the divisibility relation.  (Contributed
     by Mario Carneiro, 13-Mar-2014.) $)
  pcdvdstr $p |- ( ( P e. Prime /\ ( A e. ZZ /\ B e. ZZ /\ A || B ) ) ->
                ( P pCnt A ) <_ ( P pCnt B ) ) $=
    ( wcel cz cdivides wbr wa cpc cle cc0 wceq syl simpr oveq2d simplr3 simplr2
    co wb syl12anc cprime w3a cxr cq 0z zq ax-mp pcxcl xrleid ad2antrr eqbrtrrd
    mpan2 0dvds mpbid 3brtr4d wne cexp simpll simplr1 pczdvds wi cn prmnn pczcl
    cn0 nnexpcld nnzd dvdstr syl3anc mp2and pcdvdsb mpbird pm2.61dane ) CUADZAE
    DZBEDZABFGZUBZHZCAIRZCBIRZJGZAKVSAKLZHZCKIRZWEVTWAJVNWEWEJGZVRWCVNWEUCDZWFV
    NKUDDZWGKEDWHUEKUFUGCKUHULWEUIMUJWDAKCIVSWCNZOWDBKCIWDKBFGZBKLZWDAKBFWIVOVP
    VQVNWCPUKWDVPWJWKSVOVPVQVNWCQBUMMUNOUOVSAKUPZHZWBCVTUQRZBFGZWMWNAFGZVQWOWMV
    NVOWLWPVNVRWLURZVOVPVQVNWLUSZVSWLNZCAUTTVOVPVQVNWLPWMWNEDVOVPWPVQHWOVAWMWNW
    MCVTWMVNCVBDWQCVCMWMVNVOWLVTVEDZWQWRWSCAVDTZVFVGWRVOVPVQVNWLQZWNABVHVIVJWMV
    NVPWTWBWOSWQXBXAVTCBVKVIVLVM $.

  $( The prime count of a GCD is the minimum of the prime counts of the
     arguments.  (Contributed by Mario Carneiro, 3-Oct-2014.) $)
  pcgcd1 $p |- ( ( ( P e. Prime /\ A e. ZZ /\ B e. ZZ ) /\
  ( P pCnt A ) <_ ( P pCnt B ) ) -> ( P pCnt ( A gcd B ) ) = ( P pCnt A ) ) $=
    ( wcel cz cpc co cle wbr wa cgcd wceq cc0 cdivides wn syl2anc syl12anc cpnf
    syl cr cprime w3a oveq2 oveq2d eqeq1d wne simpl1 simp2 adantr simpl3 simprr
    cn necon3ai gcdn0cl syl21anc nnzd gcddvds simpld pcdvdstr syl13anc cexp cxr
    simpr cmnf clt cq zq pcxcl pczcl nn0red pcge0 ge0gtmnf simprl xrre syl22anc
    cn0 pnfnre neli pc0 eleq1d mtbiri notbid syl5ibrcom necon2ad mpd pczdvds wb
    pcdvdsb syl3anc mpbid wi prmnn nnexpcld dvdsgcd mp2and mpbird pccld letri3d
    mpbir2and anassrs cabs cfv gcdid0 pcabs sylan2 3adant3 eqtrd pm2.61ne ) CUA
    DZAEDZBEDZUBZCAFGZCBFGZHIZJCABKGZFGZXMLZCAMKGZFGZXMLZBMBMLZXQXTXMYBXPXSCFBM
    AKUCUDUEXLXOBMUFZXRXLXOYCJZJZXRXQXMHIZXMXQHIZYEXIXPEDZXJXPANIZYFXIXJXKYDUGZ
    YEXPYEXJXKAMLZYBJZOZXPULDXLXJYDXIXJXKUHZUIZXIXJXKYDUJZYEYCYMXLXOYCUKZYLBMYK
    YBVCUMSABUNUOZUPZYOYEYIXPBNIZYEXJXKYIYTJYOYPABUQPURXPACUSUTYEYGCXMVAGZXPNIZ
    YEUUAANIZUUABNIZUUBYEXIXJAMUFZUUCYJYOYEXMTDZUUEYEXMVBDZXNTDVDXMVEIZXOUUFYEX
    IAVFDZUUGYJYEXJUUIYOAVGZSCAVHPZYEXNYEXIXKYCXNVPDYJYPYQCBVIQVJYEUUGMXMHIZUUH
    UUKYEXIXJUULYJYOCAVKPXMVLPXLXOYCVMZXMXNVNVOZYEUUFAMYEUUFOYKCMFGZTDZOYEUUPRT
    DRTVQVRYEUUORTYEXIUUORLYJCVSSVTWAYKUUFUUPYKXMUUOTAMCFUCVTWBWCWDWEZCAWFQYEXO
    UUDUUMYEXIXKXMVPDZXOUUDWGYJYPYEXIXJUUEUURYJYOUUQCAVIQZXMCBWHWIWJYEUUAEDXJXK
    UUCUUDJUUBWKYEUUAYECXMYEXICULDYJCWLSUUSWMUPYOYPUUAABWNWIWOYEXIYHUURYGUUBWGY
    JYSUUSXMCXPWHWIWPYEXQXMYEXQYECXPYJYRWQVJUUNWRWSWTXLYAXOXLXTCAXAXBZFGZXMXLXS
    UUTCFXLXJXSUUTLYNAXCSUDXIXJUVAXMLZXKXJXIUUIUVBUUJACXDXEXFXGUIXH $.

  $( The prime count of a GCD is the minimum of the prime counts of the
     arguments.  (Contributed by Mario Carneiro, 3-Oct-2014.) $)
  pcgcd $p |- ( ( P e. Prime /\ A e. ZZ /\ B e. ZZ ) -> ( P pCnt ( A gcd B ) )
    = if ( ( P pCnt A ) <_ ( P pCnt B ) , ( P pCnt A ) , ( P pCnt B ) ) ) $=
    ( wcel cz w3a cpc co cle wbr cgcd wceq wa pcgcd1 adantl eqtr4d cxr cq pcxcl
    zq cprime cif iftrue wn gcdcom 3adant1 adantr oveq2d iffalse sylan2 3adant3
    wo 3adant2 xrletri syl2anc orcanai 3ancomb sylanb syldan pm2.61dan ) CUADZA
    EDZBEDZFZCAGHZCBGHZIJZCABKHZGHZVGVEVFUBZLVDVGMVIVEVJABCNVGVJVELVDVGVEVFUCOP
    VDVGUDZMZVICBAKHZGHZVJVLVHVMCGVDVHVMLZVKVBVCVOVAABUEUFUGUHVLVJVFVNVKVJVFLVD
    VGVEVFUIOVDVKVFVEIJZVNVFLZVDVGVPVDVEQDZVFQDZVGVPULVAVBVRVCVBVAARDVRATCASUJU
    KVAVCVSVBVCVABRDVSBTCBSUJUMVEVFUNUOUPVDVAVCVBFVPVQVAVBVCUQBACNURUSPPUT $.

  ${
    $d p x y A $.  $d p B $.
    $( A characterization of divisibility in terms of prime count.
       (Contributed by Mario Carneiro, 23-Feb-2014.)  (Revised by Mario
       Carneiro, 3-Oct-2014.) $)
    pc2dvds $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
                 ( A || B <-> A. p e. Prime ( p pCnt A ) <_ ( p pCnt B ) ) ) $=
      ( cz wcel wa cdivides wbr cpc co cle cprime cc0 wceq wn c1 wb adantr cpnf
      cr cv wral pcdvdstr ancoms ralrimiva 3expia wi oveq2 breq1d ralbidv breq1
      w3a imbi12d wne cabs cfv cgcd c2 cuz wo cn clt gcddvds simpld gcdcl nn0zd
      cdiv simpl dvdsabsb syl2anc mpbid necon3ai gcdn0cl sylan2 nnabscl adantlr
      nnzd nnne0d dvdsval2 nnre nngt0 jca divgt0 syl2an elnnz sylanbrc elnn1uz2
      syl3anc sylib simprd syl5ibcom nncnd cc ax-1cn a1i divmuld mulid1d eqeq1d
      cmul bitrd absdvdsb 3imtr4d wrex exprmfct cmin pcdiv syl121anc cq simplll
      simprl zq syl pcabs oveq1d eqtrd simprr pcelnn mpbird eqeltrrd cn0 simplr
      pccld syl12anc znnsub nn0red ltnled cif simpllr nprmdvds1 ad2antrl oveq2d
      pczcl breq2d mtbird mpd biantrurd expr syl5 cxr adantl gcdid0 lemin pcgcd
      dividd necon3bd leidd 3bitr4rd reximdva rexnal syl6ib orim12d ord c0 2prm
      con4d ne0i ax-mp r19.2z id pcxcl syl2anr pnfge pc0 pnfxr xrletri3 sylancl
      mpan 3bitr4d pnfnre neli eleq1 mtbiri adantll an4s sylbid rexlimdva 0dvds
      necon1bd sylibrd pm2.61ne impbid ) ADEZBDEZFZABGHZCUAZAIJZUWFBIJZKHZCLUBZ
      UWBUWCUWEUWJUWBUWCUWEULZUWICLUWFLEZUWKUWIABUWFUCUDUEUFUWDUWJUWEUGUWFMIJZU
      WHKHZCLUBZMBGHZUGAMAMNZUWJUWOUWEUWPUWQUWIUWNCLUWQUWGUWMUWHKAMUWFIUHUIUJAM
      BGUKUMUWDAMUNZFZUWEUWJUWSUWEUWJOZUWSAUOUPZABUQJZVGJZPNZUXCURUSUPEZUTZUWEU
      WTUTUWSUXCVAEZUXFUWSUXCDEZMUXCVBHZUXGUWSUXBUXAGHZUXHUWDUXJUWRUWDUXBAGHZUX
      JUWDUXKUXBBGHZABVCZVDUWDUXBDEZUWBUXKUXJQUWDUXBABVEVFUWBUWCVHUXBAVIVJVKRUW
      SUXNUXBMUNUXADEZUXJUXHQUWSUXBUWRUWDUWQBMNZFZOUXBVAEZUXQAMUWQUXPVHVLABVMVN
      ZVQUWSUXBUXSVRZUWSUXAUWBUWRUXAVAEZUWCAVOVPZVQUXBUXAVSWHVKUWSUYAUXRUXIUYBU
      XSUYAUXATEZMUXAVBHZFUXBTEZMUXBVBHZFUXIUXRUYAUYCUYDUXAVTUXAWAWBUXRUYEUYFUX
      BVTUXBWAWBUXAUXBWCWDVJUXCWEWFZUXCWGWIUWSUXDUWEUXEUWTUWSUXBUXANZUXABGHZUXD
      UWEUWSUXLUYHUYIUWDUXLUWRUWDUXKUXLUXMWJRUXBUXABGUKWKUWSUXDUXBPWSJZUXANUYHU
      WSUXAUXBPUWSUXAUYBWLZUWSUXBUXSWLZPWMEUWSWNWOUXTWPUWSUYJUXBUXAUWSUXBUYLWQW
      RWTUWDUWEUYIQUWRABXARXBUXEUWFUXCGHZCLXCZUWSUWTUXCCXDUWSUYNUWIOZCLXCUWTUWS
      UYMUYOCLUWSUWLUYMUYOUWSUWLUYMFZFZUWIUWGUWFUXBIJZKHZUYQUYRUWGVBHZUYSOUYQUY
      TUWGUYRXEJZVAEZUYQUWFUXCIJZVUAVAUYQVUCUWFUXAIJZUYRXEJZVUAUYQUWLUXOUXAMUNU
      XRVUCVUENUWSUWLUYMXJZUYQUXAUWSUYAUYPUYBRZVQUYQUXAVUGVRZUWSUXRUYPUXSRZUXAU
      XBUWFXFXGUYQVUDUWGUYRXEUYQUWLAXHEZVUDUWGNVUFUYQUWBVUJUWBUWCUWRUYPXIZAXKXL
      AUWFXMVJXNXOUYQVUCVAEZUYMUWSUWLUYMXPZUYQUWLUXGVULUYMQVUFUWSUXGUYPUYGRUWFU
      XCXQVJXRXSUYQUYRDEUWGDEUYTVUBQUYQUYRUYQUWFUXBVUFVUIYBZVFUYQUWGUYQUWLUWBUW
      RUWGXTEVUFVUKUWDUWRUYPYAUWFAYLYCZVFUYRUWGYDVJXRUYQUYRUWGUYQUYRVUNYEUYQUWG
      VUOYEZYFVKUYQUWGUWIUWGUWHYGZKHZUWGUWGKHZUWIFZUYSUWIUYQUWGTEZVVAUWHTEZVURV
      UTQVUPVUPUYQUWHUYQUWLUWCBMUNZUWHXTEVUFUWBUWCUWRUYPYHZUYQUWFUXAAMUQJZVGJZG
      HZOVVCUYQVVGUWFPGHZUWLVVHOUWSUYMUWFYIYJUYQVVFPUWFGUYQVVFUXAUXAVGJPUYQVVEU
      XAUXAVGUYQUWBVVEUXANVUKAUUAXLYKUYQUXAUWSUXAWMEUYPUYKRVUHUUDXOYMYNUYQVVGBM
      UYQUYMUXPVVGVUMUXPUXCVVFUWFGUXPUXBVVEUXAVGBMAUQUHYKYMWKUUEYOUWFBYLZYCYEUW
      GUWGUWHUUBWHUYQUYRVUQUWGKUYQUWLUWBUWCUYRVUQNVUFVUKVVDABUWFUUCWHYMUYQVUSUW
      IUYQUWGVUPUUFYPUUGYNYQUUHUWICLUUIUUJYRUUKYOUULUUOUWOUWNCLXCZUWDUWPLUUMUNZ
      UWOVVJURLEVVKUUNLURUUPUUQUWNCLUURUVGUWDVVJUXPUWPUWDUWNUXPCLUWDUWLFZUWNUWH
      SNZUXPVVLSUWHKHZUWHSKHZVVNFZUWNVVMVVLVVOVVNVVLUWHYSEZVVOUWLUWLBXHEZVVQUWD
      UWLUUSUWCVVRUWBBXKYTUWFBUUTUVAZUWHUVBXLYPVVLUWMSUWHKUWLUWMSNUWDUWFUVCYTUI
      VVLVVQSYSEVVMVVPQVVSUVDUWHSUVEUVFUVHVVMVVBOVVLUXPVVMVVBSTESTUVIUVJUWHSTUV
      KUVLVVLVVBBMUWDUWLVVCVVBUWBUWLUWCVVCVVBUWLUWCVVCFZVVBUWBUWLVVTFUWHVVIYEUV
      MUVNYQUVRYRUVOUVPUWCUWPUXPQUWBBUVQYTUVSYRUVTUWA $.

    $( The prime count function, viewed as a function from ` NN ` to
       ` ( NN ^m Prime ) ` , is one-to-one.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    pc11 $p |- ( ( A e. NN0 /\ B e. NN0 ) -> ( A = B <->
                 A. p e. Prime ( p pCnt A ) = ( p pCnt B ) ) ) $=
      ( cn0 wcel wa wceq cpc co cprime wral cdivides wbr cz wb nn0z cle cxr cq
      zq cv oveq2 ralrimivw pcxcl sylan2 anim12dan xrletri3 syl ancoms ralbidva
      r19.26 syl6bb pc2dvds anbi12d bitr4d syl2an dvdseq ex sylbid impbid2 ) AD
      EZBDEZFZABGZCUAZAHIZVEBHIZGZCJKZVDVHCJABVEHUBUCVCVIABLMZBALMZFZVDVAANEZBN
      EZVIVLOVBAPBPVMVNFZVIVFVGQMZCJKZVGVFQMZCJKZFZVLVOVIVPVRFZCJKVTVOVHWACJVEJ
      EZVOVHWAOZWBVOFVFREZVGREZFWCWBVMWDVNWEVMWBASEWDATVEAUDUEVNWBBSEWEBTVEBUDU
      EUFVFVGUGUHUIUJVPVRCJUKULVOVJVQVKVSABCUMVNVMVKVSOBACUMUIUNUOUPVCVLVDABUQU
      RUSUT $.

    $( The prime count function can be used as an indicator that a given
       rational number is an integer.  (Contributed by Mario Carneiro,
       23-Feb-2014.) $)
    pcz $p |- ( A e. QQ -> ( A e. ZZ <-> A. p e. Prime 0 <_ ( p pCnt A ) ) ) $=
      ( vx vy wcel cz cc0 cv cpc co cle cprime wral wceq cn wrex wi wa cdivides
      wbr pcge0 ancoms ralrimiva cdiv elq nnz dvds0 syl ad2antlr simpr breqtrrd
      a1d wne cmin simplll simplr simpllr pcdiv syl121anc breq2d pczcl syl12anc
      cq nn0red pccld subge0d bitrd ralbidva wb id pc2dvds adantr bitr4d biimpd
      cn0 syl2anr pm2.61dane adantl nnne0 simpl dvdsval2 syl3anc sylibd ralbidv
      oveq2 eleq1 imbi12d syl5ibrcom rexlimivv sylbi impbid2 ) AVCEZAFEZGBHZAIJ
      ZKTZBLMZWMWPBLWNLEZWMWPWNAUAUBUCWLACHZDHZUDJZNZDOPCFPWQWMQZCDAUEXBXCCDFOW
      SFEZWTOEZRZXCXBGWNXAIJZKTZBLMZXAFEZQXFXIWTWSSTZXJXFXIXKQWSGXFWSGNZRZXKXIX
      MWTGWSSXEWTGSTZXDXLXEWTFEZXNWTUFZWTUGUHUIXFXLUJUKULXFWSGUMZRZXIXKXRXIWNWT
      IJZWNWSIJZKTZBLMZXKXRXHYABLXRWRRZXHGXTXSUNJZKTYAYCXGYDGKYCWRXDXQXEXGYDNXR
      WRUJZXDXEXQWRUOZXFXQWRUPZXDXEXQWRUQZWSWTWNURUSUTYCXTXSYCXTYCWRXDXQXTVOEYE
      YFYGWNWSVAVBVDYCXSYCWNWTYEYHVEVDVFVGVHXFXKYBVIZXQXEXOXDYIXDXPXDVJWTWSBVKV
      PVLVMVNVQXFXOWTGUMZXDXKXJVIXEXOXDXPVRXEYJXDWTVSVRXDXEVTWTWSWAWBWCXBWQXIWM
      XJXBWPXHBLXBWOXGGKAXAWNIWEUTWDAXAFWFWGWHWIWJWK $.
  $}

  ${
    $d n p A $.  $d n p P $.
    $( Self-referential expression for a prime power.  (Contributed by Mario
       Carneiro, 16-Jan-2015.) $)
    pcprmpw2 $p |- ( ( P e. Prime /\ A e. NN ) ->
      ( E. n e. NN0 A || ( P ^ n ) <-> A = ( P ^ ( P pCnt A ) ) ) ) $=
      ( vp cprime wcel cn cdivides wbr cn0 cpc wceq ad2antrr adantr cle syl2anc
      wa co cz nnzd cv cexp wrex simplr nnnn0d prmnn pccl nnexpcld nn0red leidd
      wral simpll nn0zd pcid breqtrrd simpr oveq1d 3brtr4d wne cc0 simplrr prmz
      adantl simprl dvdstr syl3anc mpan2d simplrl prmdvdsexpr syld necon3ad imp
      wn wi wb pceq0 mpbird nn0ge0d eqbrtrd pm2.61dane ralrimiva pc2dvds pcdvds
      pccld dvdseq syl22anc rexlimdvaa iddvds oveq2 breq2d rspcev breq1 rexbidv
      syl syl5ibrcom impbid ) BEFZAGFZQZABCUAZUBRZHIZCJUCZABBAKRZUBRZLZWSXBXFCJ
      WSWTJFZXBQZQZAJFXEJFAXEHIZXEAHIZXFXIAWQWRXHUDZUEXIXEXIBXDWQBGFZWRXHBUFZMZ
      WSXDJFZXHBAUGZNZUHZUEXIXJDUAZAKRZXTXEKRZOIZDEUKZXIYCDEXIXTEFZQZYCXTBYFXTB
      LZQZXDBXEKRZYAYBOXIXDYIOIYEYGXIXDXDYIOXIXDXIXDXRUIUJXIWQXDSFYIXDLWQWRXHUL
      ZXIXDXRUMXDBUNPUOMYHXTBAKYFYGUPZUQYHXTBXEKYKUQURYFXTBUSZQZYAUTYBOYMYAUTLZ
      XTAHIZVMZYFYLYPYFYOXTBYFYOXTXAHIZYGYFYOXBYQWSXGXBYEVAYFXTSFZASFZXASFYOXBQ
      YQVNYEYRXIXTVBVCYFAXIWRYEXLNTYFXAXIXAGFYEXIBWTXOWSXGXBVDUHNTXTAXAVEVFVGYF
      YEWQXGYQYGVNXIYEUPXIWQYEYJNWSXGXBYEVHXTBWTVIVFVJVKVLYMYEWRYNYPVOXIYEYLUDZ
      XIWRYEYLXLMXTAVPPVQYMYBYMXTXEYTXIXEGFYEYLXSMWDVRVSVTWAXIYSXESFZXJYDVOXIAX
      LTXIXEXSTAXEDWBPVQWSXKXHBAWCNAXEWEWFWGWSXCXFXEXAHIZCJUCZWSXPXEXEHIZUUCXQW
      SUUAUUDWSXEWSBXDWQXMWRXNNXQUHTXEWHWNUUBUUDCXDJWTXDLXAXEXEHWTXDBUBWIWJWKPX
      FXBUUBCJAXEXAHWLWMWOWP $.

    $( Self-referential expression for a prime power.  (Contributed by Mario
       Carneiro, 16-Jan-2015.) $)
    pcprmpw $p |- ( ( P e. Prime /\ A e. NN ) ->
      ( E. n e. NN0 A = ( P ^ n ) <-> A = ( P ^ ( P pCnt A ) ) ) ) $=
      ( cprime wcel cn wa cv cexp co wceq cn0 wrex cpc cdivides wbr prmz adantr
      cz syl zexpcl sylan iddvds breq1 syl5ibrcom reximdva pcprmpw2 sylibd pccl
      wi oveq2 eqeq2d rspcev ex impbid ) BDEZAFEZGZABCHZIJZKZCLMZABBANJZIJZKZUR
      VBAUTOPZCLMVEURVAVFCLURUSLEZGZVFVAUTUTOPZVHUTSEZVIURBSEZVGVJUPVKUQBQRBUSU
      AUBUTUCTAUTUTOUDUEUFABCUGUHURVCLEZVEVBUJBAUIVLVEVBVAVECVCLUSVCKUTVDAUSVCB
      IUKULUMUNTUO $.
  $}

  ${
    pcaddlem.1 $e |- ( ph -> P e. Prime ) $.
    pcaddlem.2 $e |- ( ph -> A = ( ( P ^ M ) x. ( R / S ) ) ) $.
    pcaddlem.3 $e |- ( ph -> B = ( ( P ^ N ) x. ( T / U ) ) ) $.
    pcaddlem.4 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    pcaddlem.5 $e |- ( ph -> ( R e. ZZ /\ -. P || R ) ) $.
    pcaddlem.6 $e |- ( ph -> ( S e. NN /\ -. P || S ) ) $.
    pcaddlem.7 $e |- ( ph -> ( T e. ZZ /\ -. P || T ) ) $.
    pcaddlem.8 $e |- ( ph -> ( U e. NN /\ -. P || U ) ) $.
    $( Lemma for ~ pcadd .  The original numbers ` A ` and ` B ` have been
       decomposed using the prime count function as ` ( P ^ M ) x. ( R / S ) `
       where ` R , S ` are both not divisible by ` P ` and
       ` M = ( P pCnt A ) ` , and similarly for ` B ` .  (Contributed by Mario
       Carneiro, 9-Sep-2014.) $)
    pcaddlem $p |- ( ph -> M <_ ( P pCnt ( A + B ) ) ) $=
      ( co cc0 caddc cpc cle wbr wceq oveq2 breq2d wne cdiv cmin cexp cmul wcel
      wa cr cn0 cuz cfv cz eluzel2 syl zred adantr cprime cn prmnn nncnd nnne0d
      eluzelz zsubcld expclzd cdivides wn simpld zcnd divassd oveq2d divadddivd
      mulcld eqtr3d zmulcld uznn0sub nnexpcld zaddcld mul01d syl5ibrcom necon3d
      nnzd eqeq1d divcld adddid pncan3d expaddz syl22anc oveq1d mulassd oveq12d
      cc 3eqtrd eqtr4d neeq1d 3imtr3d nnmulcld div0d oveq1 syld pcdiv syl121anc
      pcmul syl122anc simprd wb pceq0 syl2anc mpbird 00id syl6eq eqtrd syl12anc
      imp pczcl nn0cnd subid1d eqeltrd nn0addge1 cq nnq qexpclz syl3anc expne0d
      znq qmulcl qaddcl sylbird pcqmul pcid 3eqtr3d breqtrrd cpnf cxr rexrd pc0
      pnfge pm2.61ne ) AIDBCUASZUBSZUCUDIDTUBSZUCUDUUETUUETUEUUFUUGIUCUUETDUBUF
      UGAUUETUHZUNZIIDEFUISZDJIUJSZUKSZGHUISZULSZUASZUBSZUASZUUFUCUUIIUOUMZUUPU
      PUMIUUQUCUDAUURUUHAIAJIUQURUMZIUSUMZNIJUTVAZVBZVCUUIUUPDEHULSZUULGULSZFUL
      SZUASZUBSZUPUUIUUPDUVFFHULSZUISZUBSZUVGDUVHUBSZUJSZUVGAUUPUVJUEUUHAUUOUVI
      DUBAUUJUVDHUISZUASUUOUVIAUVMUUNUUJUAAUULGHADUUKADADVDUMZDVEUMZKDVFVAZVGZA
      DUVPVHZAJIAUUSJUSUMNIJVIVAZUVAVJZVKZAGAGUSUMZDGVLUDVMQVNZVOZAHAHVEUMZDHVL
      UDVMZRVNZVGZAHUWGVHZVPVQAEFUVDHAEAEUSUMZDEVLUDVMOVNZVOZAFAFVEUMZDFVLUDVMZ
      PVNZVGZAUULGUWAUWDVSUWHAFUWOVHZUWIVRVTZVQVCUUIUVNUVFUSUMZUVFTUHZUVHVEUMZU
      VJUVLUEAUVNUUHKVCZAUWSUUHAUVCUVEAEHUWKAHUWGWHZWAAUVDFAUULGAUULADUUKUVPAUU
      SUUKUPUMNIJWBVAWCWHUWCWAAFUWOWHZWAWDVCZAUUHUWTAUUHUVITUHZUWTADIUKSZUUOULS
      ZTUHZUUOTUHZUUHUXFAUUOTUXHTAUXHTUEUUOTUEZUXGTULSZTUEAUXGADIUVQUVRUVAVKZWE
      UXKUXHUXLTUUOTUXGULUFWIWFWGZAUXHUUETAUXHUXGUUJULSZUXGUUNULSZUASUUEAUXGUUJ
      UUNUXMAEFUWLUWPUWQWJAUULUUMUWAAGHUWDUWHUWIWJZVSWKABUXOCUXPUALACDJUKSZUUMU
      LSUXGUULULSZUUMULSUXPMAUXRUXSUUMULADIUUKUASZUKSZUXRUXSAUXTJDUKAIJAIUVAVOA
      JUVSVOWLVQADWRUMDTUHZUUTUUKUSUMZUYAUXSUEUVQUVRUVAUVTDIUUKWMWNVTWOAUXGUULU
      UMUXMUWAUXQWPWSWQWTZXAZAUUOUVITUWRXAXBAUVFTUVITAUVITUEUVFTUEZTUVHUISZTUEA
      UVHAUVHAFHUWOUWGXCZVGAUVHUYHVHXDUYFUVIUYGTUVFTUVHUIXEWIWFWGXFXTZAUXAUUHUY
      HVCUVFUVHDXGXHUUIUVLUVGTUJSZUVGAUVLUYJUEUUHAUVKTUVGUJAUVKDFUBSZDHUBSZUASZ
      TAUVNFUSUMFTUHHUSUMHTUHUVKUYMUEKUXDUWQUXCUWIFHDXIXJAUYMTTUASTAUYKTUYLTUAA
      UYKTUEZUWNAUWMUWNPXKAUVNUWMUYNUWNXLKUWODFXMXNXOAUYLTUEZUWFAUWEUWFRXKAUVNU
      WEUYOUWFXLKUWGDHXMXNXOWQXPXQXRVQVCUUIUVGUUIUVGUUIUVNUWSUWTUVGUPUMUXBUXEUY
      IDUVFYAXSZYBYCXRWSUYPYDIUUPYEXNUUIDUXHUBSZDUXGUBSZUUPUASZUUFUUQUUIUVNUXGY
      FUMZUXGTUHZUUOYFUMZUXJUYQUYSUEUXBAUYTUUHADYFUMZUYBUUTUYTAUVOVUCUVPDYGVAZU
      VRUVADIYHYIVCAVUAUUHADIUVQUVRUVAYJVCAVUBUUHAUUJYFUMZUUNYFUMZVUBAUWJUWMVUE
      UWKUWOEFYKXNAUULYFUMZUUMYFUMZVUFAVUCUYBUYCVUGVUDUVRUVTDUUKYHYIAUWBUWEVUHU
      WCUWGGHYKXNUULUUMYLXNUUJUUNYMXNVCAUUHUXJAUUHUXIUXJUYEUXNYNXTUXGUUODYOXJAU
      YQUUFUEUUHAUXHUUEDUBUYDVQVCAUYSUUQUEUUHAUYRIUUPUAAUVNUUTUYRIUEKUVAIDYPXNW
      OVCYQYRAIYSUUGUCAIYTUMIYSUCUDAIUVBUUAIUUCVAAUVNUUGYSUEKDUUBVAYRUUD $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z P $.  $d w x y z ph $.
    pcadd.1 $e |- ( ph -> P e. Prime ) $.
    pcadd.2 $e |- ( ph -> A e. QQ ) $.
    pcadd.3 $e |- ( ph -> B e. QQ ) $.
    pcadd.4 $e |- ( ph -> ( P pCnt A ) <_ ( P pCnt B ) ) $.
    $( An inequality for the prime count of a sum.  This is the source of the
       ultrametric inequality for the p-adic metric.  (Contributed by Mario
       Carneiro, 9-Sep-2014.) $)
    pcadd $p |- ( ph -> ( P pCnt A ) <_ ( P pCnt ( A + B ) ) ) $=
      ( cdiv co wceq cn cz cpc wbr wcel wa cc0 oveq2d cmul vx vy vz vw cv caddc
      wrex cle cq elq sylib wi cxr cprime pcxcl syl2anc xrleid syl adantr oveq2
      cc qcn addid1d sylan9eqr breqtrrd a1d wne reeanv cexp ad3antrrr prmnn cn0
      simplrl simprrl wn cpnf cr simpllr pcqcl syl12anc zred clt ltpnf wb pnfxr
      rexr xrltnle sylancl mpbid pc0 breq1d syl5ibcom necon3bd eqnetrrd simprll
      mtbird mpd nncnd nnne0d div0d oveq1 eqeq1d necon3d pczcl nnexpcld mulcomd
      syl5ibrcom zcnd pccld divdivdivd cmin pcdiv syl121anc eqtrd nn0zd expsubd
      oveq1d 3eqtr4d expclzd expne0d divcan2d simplrr cdivides pczdvds dvdsval2
      3eqtrd eqtr2d nnzd syl3anc pczndvds2 pcdvds nnred nngt0d divgt0d sylanbrc
      jca elnnz pcndvds2 rexlimdvva syl5bir simprrr simprlr cuz cfv eluz mpbird
      pcaddlem expr pm2.61dane mp2and ) ABUAUEZUBUEZIJZKZUBLUGZUAMUGZCUCUEZUDUE
      ZIJZKZUDLUGZUCMUGZDBNJZDBCUFJZNJZUHOZABUIPZUUPFUAUBBUJUKACUIPZUVBGUCUDCUJ
      UKAUUPUVBQZUVFULCRACRKZQZUVFUVIUVKUVCUVCUVEUHAUVCUVCUHOZUVJAUVCUMPZUVLADU
      NPZUVGUVMEFDBUOUPUVCUQURUSUVKUVDBDNUVJAUVDBRUFJBCRBUFUTABAUVGBVAPZFBVBZUR
      VCVDSVEVFUVIUUOUVAQZUCMUGUAMUGACRVGZQZUVFUUOUVAUAUCMMVHUVSUVQUVFUAUCMMUVQ
      UUNUUTQZUDLUGUBLUGUVSUUKMPZUUQMPZQZQZUVFUUNUUTUBUDLLVHUWDUVTUVFUBUDLLUWDU
      ULLPZUURLPZQZUVTUVFUWDUWGUVTQZQZBCDUUKDDUUKNJZVIJZIJZUULDDUULNJZVIJZIJZUU
      QDDUUQNJZVIJZIJZUURDDUURNJZVIJZIJZUVCDCNJZAUVNUVRUWCUWHEVJZUWIDUVCVIJZUWL
      UWOIJZTJUXDBUXDIJZTJBUWIUXEUXFUXDTUWIUUKUWNTJZUWKUULTJZIJUXGUULUWKTJZIJZU
      XEUXFUWIUXHUXIUXGIUWIUWKUULUWIUWKUWIDUWJUWIUVNDLPUXCDVKURZUWIUVNUWAUUKRVG
      ZUWJVLPUXCUVSUWAUWBUWHVMZUWIUUMRVGUXLUWIBUUMRUWDUWGUUNUUTVNZUWIDRNJZUXBUH
      OZVOBRVGZUWIUXPVPUXBUHOZUWIUXBVQPZUXRVOZUWIUXBUWIUVNUVHUVRUXBMPZUXCAUVHUV
      RUWCUWHGVJZAUVRUWCUWHVRZDCVSVTZWAUXSUXBVPWBOZUXTUXBWCUXSUXBUMPVPUMPUYEUXT
      WDUXBWFWEUXBVPWGWHWIURUWIUXOVPUXBUHUWIUVNUXOVPKUXCDWJURWKWPUWIUXPBRUWIUVC
      UXBUHOZBRKZUXPAUYFUVRUWCUWHHVJZUYGUVCUXOUXBUHBRDNUTWKWLWMWQZWNUWIUUKRUUMR
      UWIUUMRKUUKRKZRUULIJZRKUWIUULUWIUULUWDUWEUWFUVTWOZWRZUWIUULUYLWSZWTUYJUUM
      UYKRUUKRUULIXAXBXGXCWQZDUUKXDVTZXEZWRZUYMXFSUWIUUKUWKUULUWNUWIUUKUXMXHZUY
      RUYMUWIUWNUWIDUWMUXKUWIDUULUXCUYLXIZXEZWRZUWIUWKUYQWSZUWIUWNVUAWSZUYNXJUW
      IUXFBUWKUWNIJZIJUUMVUEIJUXJUWIUXDVUEBIUWIUXDDUWJUWMXKJZVIJVUEUWIUVCVUFDVI
      UWIUVCDUUMNJZVUFUWIBUUMDNUXNSUWIUVNUWAUXLUWEVUGVUFKUXCUXMUYOUYLUUKUULDXLX
      MXNSUWIDUWJUWMUWIDUXKWRZUWIDUXKWSZUWIUWMUYTXOUWIUWJUYPXOXPXNSUWIBUUMVUEIU
      XNXQUWIUUKUULUWKUWNUYSUYMUYRVUBUYNVUDVUCXJYFXRSUWIBUXDUWIUVGUVOAUVGUVRUWC
      UWHFVJZUVPURUWIDUVCVUHVUIUWIUVNUVGUXQUVCMPZUXCVUJUYIDBVSVTZXSUWIDUVCVUHVU
      IVULXTYAYGUWIDUXBVIJZUWRUXAIJZTJVUMCVUMIJZTJCUWIVUNVUOVUMTUWIUUQUWTTJZUWQ
      UURTJZIJVUPUURUWQTJZIJZVUNVUOUWIVUQVURVUPIUWIUWQUURUWIUWQUWIDUWPUXKUWIUVN
      UWBUUQRVGZUWPVLPUXCUVSUWAUWBUWHYBZUWIUUSRVGVUTUWICUUSRUWDUWGUUNUUTUUAZUYC
      WNUWIUUQRUUSRUWIUUSRKUUQRKZRUURIJZRKUWIUURUWIUURUWDUWEUWFUVTUUBZWRZUWIUUR
      VVEWSZWTVVCUUSVVDRUUQRUURIXAXBXGXCWQZDUUQXDVTZXEZWRZVVFXFSUWIUUQUWQUURUWT
      UWIUUQVVAXHZVVKVVFUWIUWTUWIDUWSUXKUWIDUURUXCVVEXIZXEZWRZUWIUWQVVJWSZUWIUW
      TVVNWSZVVGXJUWIVUOCUWQUWTIJZIJUUSVVRIJVUSUWIVUMVVRCIUWIVUMDUWPUWSXKJZVIJV
      VRUWIUXBVVSDVIUWIUXBDUUSNJZVVSUWICUUSDNVVBSUWIUVNUWBVUTUWFVVTVVSKUXCVVAVV
      HVVEUUQUURDXLXMXNSUWIDUWPUWSVUHVUIUWIUWSVVMXOUWIUWPVVIXOXPXNSUWICUUSVVRIV
      VBXQUWIUUQUURUWQUWTVVLVVFVVKVVOVVGVVQVVPXJYFXRSUWICVUMUWIUVHCVAPUYBCVBURU
      WIDUXBVUHVUIUYDXSUWIDUXBVUHVUIUYDXTYAYGUWIUXBUVCUUCUUDPZUYFUYHUWIVUKUYAVW
      AUYFWDVULUYDUVCUXBUUEUPUUFUWIUWLMPZDUWLYCOVOZUWIUWKUUKYCOZVWBUWIUVNUWAUXL
      VWDUXCUXMUYODUUKYDVTUWIUWKMPUWKRVGUWAVWDVWBWDUWIUWKUYQYHVUCUXMUWKUUKYEYIW
      IUWIUVNUWAUXLVWCUXCUXMUYODUUKYJVTYPUWIUWOLPZDUWOYCOVOZUWIUWOMPZRUWOWBOVWE
      UWIUWNUULYCOZVWGUWIUVNUWEVWHUXCUYLDUULYKUPUWIUWNMPUWNRVGUULMPVWHVWGWDUWIU
      WNVUAYHVUDUWIUULUYLYHUWNUULYEYIWIUWIUULUWNUWIUULUYLYLUWIUWNVUAYLUWIUULUYL
      YMUWIUWNVUAYMYNUWOYQYOUWIUVNUWEVWFUXCUYLDUULYRUPYPUWIUWRMPZDUWRYCOVOZUWIU
      WQUUQYCOZVWIUWIUVNUWBVUTVWKUXCVVAVVHDUUQYDVTUWIUWQMPUWQRVGUWBVWKVWIWDUWIU
      WQVVJYHVVPVVAUWQUUQYEYIWIUWIUVNUWBVUTVWJUXCVVAVVHDUUQYJVTYPUWIUXALPZDUXAY
      COVOZUWIUXAMPZRUXAWBOVWLUWIUWTUURYCOZVWNUWIUVNUWFVWOUXCVVEDUURYKUPUWIUWTM
      PUWTRVGUURMPVWOVWNWDUWIUWTVVNYHVVQUWIUURVVEYHUWTUURYEYIWIUWIUURUWTUWIUURV
      VEYLUWIUWTVVNYLUWIUURVVEYMUWIUWTVVNYMYNUXAYQYOUWIUVNUWFVWMUXCVVEDUURYRUPY
      PUUGUUHYSYTYSYTUUIUUJ $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z P $.  $d w x y z ph $.
    pcadd2.1 $e |- ( ph -> P e. Prime ) $.
    pcadd2.2 $e |- ( ph -> A e. QQ ) $.
    pcadd2.3 $e |- ( ph -> B e. QQ ) $.
    pcadd2.4 $e |- ( ph -> ( P pCnt A ) < ( P pCnt B ) ) $.
    $( The inequality of ~ pcadd becomes an equality when one of the factors
       has prime count strictly less than the other.  (Contributed by Mario
       Carneiro, 16-Jan-2015.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    pcadd2 $p |- ( ph -> ( P pCnt A ) = ( P pCnt ( A + B ) ) ) $=
      ( cpc co caddc cle wbr cxr wcel cq pcxcl syl2anc cc0 oveq2d clt wi cprime
      wceq xrltle mpd pcadd cneg qaddcl qnegcl syl wn wb xrltnle mpbid wa pcneg
      adantr breq1d biimpar ex cc qcn negcld add12d addcomd negidd eqtrd 3eqtrd
      addid1d breq12d sylibd mpbird breqtrrd addassd breqtrd xrletri3 mpbir2and
      mtod ) ADBIJZDBCKJZIJZUDZVTWBLMZWBVTLMZABCDEFGAVTDCIJZUAMZVTWFLMZHAVTNOZW
      FNOZWGWHUBADUCOZBPOZWIEFDBQRZAWKCPOZWJEGDCQRZVTWFUERUFUGAWBDWACUHZKJZIJVT
      LAWAWPDEAWLWNWAPOZFGBCUIRZAWNWPPOZGCUJUKZAWBWFDWPIJZLAWBWFUAMZWBWFLMZAXCW
      FWBLMZULZAXEWFVTLMZAWGXGULZHAWIWJWGXHUMWMWOVTWFUNRUOAXEXBDWPWAKJZIJZLMZXG
      AXEXKAXEUPWPWADAWKXEEURAWTXEXAURAWRXEWSURAXBWBLMXEAXBWFWBLAWKWNXBWFUDEGCD
      UQRZUSUTUGVAAXBWFXJVTLXLAXIBDIAXIBWPCKJZKJBSKJZBAWPBCACAWNCVBOGCVCUKZVDZA
      WLBVBOFBVCUKZXOVEAXMSBKAXMCWPKJZSAWPCXPXOVFACXOVGZVHTABXQVJZVITVKVLVSAWBN
      OZWJXCXFUMAWKWRYAEWSDWAQRZWOWBWFUNRVMAYAWJXCXDUBYBWOWBWFUERUFXLVNUGAWQBDI
      AWQBXRKJXNBABCWPXQXOXPVOAXRSBKXSTXTVITVPAWIYAWCWDWEUPUMWMYBVTWBVQRVR $.
  $}

  ${
    $d k m p A $.  $d k n p B $.  $d k p F $.  $d p M $.  $d p N $.
    $d k n m p P $.  $d k p ph $.
    pcmpt.1 $e |- F = ( n e. NN |-> if ( n e. Prime , ( n ^ A ) , 1 ) ) $.
    pcmpt.2 $e |- ( ph -> A. n e. Prime A e. NN0 ) $.
    $( Closure for the prime power map.  (Contributed by Mario Carneiro,
       12-Mar-2014.) $)
    pcmptcl $p |- ( ph -> ( F : NN --> NN /\
                    seq 1 ( x. , F ) : NN --> NN ) ) $=
      ( vk vp cn wf cmul c1 cv cprime wcel co wral wi wa a1d cseq cexp cif wceq
      pm2.27 iftrue adantr prmnn nnexpcl sylan eqeltrd ex syld iffalse syl6eqel
      cn0 wn 1nn pm2.61i ralimi2 syl fmpt sylib nnuz cz 1z a1i ffvelrnda adantl
      nnmulcl seqf jca ) AIIDJZIIKDLUAJACMZNOZVNBUBPZLUCZIOZCIQZVMABUPOZCNQVSFV
      TVRCNIVOVTRZVRVNIOZVOWAVRRVOWAVTVRVOVTUEVOVTVRVOVTSVQVPIVOVQVPUDVTVOVPLUF
      UGVOWBVTVPIOVNUHVNBUIUJUKULUMVOUQZVRWAWCVQLIVOVPLUNURUOTUSTUTVACIIVQDEVBV
      CZAGHKIDLIVDLVEOAVFVGAIIGMZDWDVHWEIOHMZIOSWEWFKPIOAWEWFVJVIVKVL $.

    pcmpt.3 $e |- ( ph -> N e. NN ) $.
    ${
      pcmpt.4 $e |- ( ph -> P e. Prime ) $.
      pcmpt.5 $e |- ( n = P -> A = B ) $.
      $( Construct a function with given prime count characteristics.
         (Contributed by Mario Carneiro, 12-Mar-2014.) $)
      pcmpt $p |- ( ph -> ( P pCnt ( seq 1 ( x. , F ) ` N ) ) =
                          if ( P <_ N , B , 0 ) ) $=
        ( cn wcel c1 cpc co cc0 wceq syl vp vk cmul cfv cle wbr cif cv wi caddc
        cseq fveq2 oveq2d breq2 ifbid eqeq12d imbi2d cprime cz 1z seq1 1nn cexp
        ax-mp wn 1nprm eleq1 mtbiri iffalse 1ex fvmpt oveq2i pc1 syl5eq clt cuz
        eqtri c2 prmuz2 eluz2b2 simprbi cr wb 1re eluzelre ltnle sylancr eqtr4d
        mpbid wa adantr wf pcmptcl simpld peano2nn ffvelrn syl2an adantrr pccld
        nn0cnd addid2d csb cvv ad2antrl ovex ifex csbex fvmpts nfv nfcv nfcsb1v
        nfov nfif csbeq1a oveq12d ifbieq12d csbief syl6eq sylancl simprr iftrue
        id eqidd eqtrd 3eqtrd cn0 eleq1d sylc syl2anc simpr wne nnz jca syl3anc
        nnne0 nnred expr cdivides ad2antrr sylan9eq eqeltrd csbeq1d nfcvd rspcv
        csbiegf wral pcidlem oveq1 eqeq1d syl5ibrcom nnre peano2re mpdan breq1d
        ltp1 mtbid eqeq2d nnuz syl6eleq seqp1 simprd pcmul prmnn leidd breqtrrd
        ffvelrnda 3imtr4d simplrr necomd nfel1 rspc prmdvdsexpr necon3ad breq2d
        mtbird pceq0 mpbird pm2.61dan addid1d ltlend nnleltp1 biantrud 3bitr4rd
        mpd simprl biimprd pm2.61dne expcom a2d nnind mpcom ) GMNADGUCFOUKZUDZP
        QZDGUEUFZCRUGZSZJADUAUHZUWLUDZPQZDUWRUEUFZCRUGZSZUIADOUWLUDZPQZDOUEUFZC
        RUGZSZUIADUBUHZUWLUDZPQZDUXIUEUFZCRUGZSZUIADUXIOUJQZUWLUDZPQZDUXOUEUFZC
        RUGZSZUIAUWQUIUAUBGUWROSZUXCUXHAUYAUWTUXEUXBUXGUYAUWSUXDDPUWROUWLULUMUY
        AUXAUXFCRUWRODUEUNUOUPUQUWRUXISZUXCUXNAUYBUWTUXKUXBUXMUYBUWSUXJDPUWRUXI
        UWLULUMUYBUXAUXLCRUWRUXIDUEUNUOUPUQUWRUXOSZUXCUXTAUYCUWTUXQUXBUXSUYCUWS
        UXPDPUWRUXOUWLULUMUYCUXAUXRCRUWRUXODUEUNUOUPUQUWRGSZUXCUWQAUYDUWTUWNUXB
        UWPUYDUWSUWMDPUWRGUWLULUMUYDUXAUWOCRUWRGDUEUNUOUPUQADURNZUXHKUYEUXERUXG
        UYEUXEDOPQZRUXDODPUXDOFUDZOOUSNUXDUYGSUTUCFOVAVDOMNUYGOSVBEOEUHZURNZUYH
        BVCQZOUGZOMFUYHOSZUYIVEUYKOSUYLUYIOURNVFUYHOURVGVHUYIUYJOVITHVJVKVDVQVL
        DVMZVNUYEUXFVEZUXGRSUYEODVOUFZUYNUYEDVRVPUDNZUYODVSZUYPDMNZUYODVTWATUYE
        OWBNDWBNZUYOUYNWCWDUYEUYPUYSUYQVRDWETODWFWGWIUXFCRVITWHTUXIMNZAUXNUXTAU
        YTUXNUXTUIZAUYTWJZVUAUXODAUYTUXODSZVUAAUYTVUCWJZWJZUXKRSZUXKDUXOFUDZPQZ
        UJQZCSZUXNUXTVUEVUJVUFRVUHUJQZCSVUEVUKVUHDDCVCQZPQZCVUEVUHVUEVUHVUEDVUG
        AUYEVUDKWKZAUYTVUGMNZVUCAMMFWLZUXOMNZVUOUYTAVUPMMUWLWLZABEFHIWMZWNZUXIW
        OZMMUXOFWPZWQZWRWSWTXAVUEVUGVULDPVUEVUGUXOURNZUXOEUXOBXBZVCQZOUGZVVFVUL
        VUEVUQEUXOUYKXBZXCNZVUGVVGSZUYTVUQAVUCVVAXDEUXOUYKUYIUYJOUYHBVCXEVJXFXG
        ZVUQVVIWJVUGVVHVVGEUXOUYKMFXCHXHEUXOUYKVVGUXIOUJXEVVDEVVFOVVDEXIEUXOVVE
        VCEUXOXJEVCXJEUXOBXKZXLEOXJXMUYHUXOSZUYIVVDUYJOVVFOUYHUXOURVGVVMUYHUXOB
        VVEVCVVMYBEUXOBXNZXOVVMOYCXPXQXRZXSVUEVVDVVGVVFSVUEUXODURAUYTVUCXTZVUNU
        UAVVDVVFOYAZTVUEUXODVVECVCVVPVUEVVEEDBXBZCVUEEUXODBVVPUUBVUEUYEVVRCSVUN
        EDBCURUYEECUUCLUUETYDXOYEUMVUEUYECYFNZVUMCSVUNAVVSVUDAUYEBYFNZEURUUFZVV
        SKIVVTVVSEDURUYHDSBCYFLYGUUDYHWKCDUUGYIYEVUFVUIVUKCUXKRVUHUJUUHUUIUUJVU
        EUXMRUXKVUEUXLVEUXMRSVUEUXOUXIUEUFZUXLVUEUXIWBNZVWBVEZUYTVWCAVUCUXIUUKX
        DVWCUXIUXOVOUFZVWDUXIUUOVWCUXOWBNVWEVWDWCUXIUULUXIUXOWFUUMWITVUEUXODUXI
        UEVVPUUNUUPUXLCRVITUUQVUEUXQVUIUXSCAUYTUXQVUISZVUCVUBUXQDUXJVUGUCQZPQZV
        UIVUBUXPVWGDPVUBUXIOVPUDZNUXPVWGSVUBUXIMVWIAUYTYJUURUUSUCFOUXIUUTTUMVUB
        UYEUXJUSNZUXJRYKZWJZVUGUSNZVUGRYKZWJZVWHVUISAUYEUYTKWKVUBUXJMNZVWLAMMUX
        IUWLAVUPVURVUSUVAUVFZVWPVWJVWKUXJYLUXJYOYMTVUBVUOVWOVVCVUOVWMVWNVUGYLVU
        GYOYMTUXJVUGDUVBYNYDZWRVUEUXRUXSCSVUEDDUXOUEVUEDAUYSVUDADAUYEUYRKDUVCTZ
        YPWKUVDVVPUVEUXRCRYATUPUVGYQAUYTUXODYKZVUAAUYTVWTWJZWJZUXTUXNVXBUXQUXKU
        XSUXMVXBUXQVUIUXKRUJQUXKAUYTVWFVWTVWRWRVXBVUHRUXKUJVXBVVDVUHRSZVXBVVDWJ
        ZVXCDVUGYRUFZVEZVXDVXEDVVFYRUFZVXDDUXOYKVXGVEVXDUXODAUYTVWTVVDUVHUVIVXD
        VXGDUXOVXDUYEVVDVVEYFNZVXGDUXOSUIAUYEVXAVVDKYSZVXBVVDYJZVXDVVDVWAVXHVXJ
        AVWAVXAVVDIYSVVTVXHEUXOUREVVEYFVVLUVJVVMBVVEYFVVNYGUVKYHDUXOVVEUVLYNUVM
        UWDVXDVUGVVFDYRVXBVVDVUGVVGVVFVXBVUQVVIVVJUYTVUQAVWTVVAXDZVVKVVOXSZVVQY
        TUVNUVOVXDUYEVUOVXCVXFWCVXIVXBVUOVVDVXBVUPVUQVUOAVUPVXAVUTWKVXKVVBYIWKD
        VUGUVPYIUVQVXBVVDVEZWJZVUHUYFRVXNVUGODPVXBVXMVUGVVGOVXLVVDVVFOVIYTUMAUY
        FRSZVXAVXMAUYEVXOKUYMTYSYDUVRUMVXBUXKVXBUXKVXBDUXJAUYEVXAKWKAUYTVWPVWTV
        WQWRWSWTUVSYEVXBUXRUXLCRVXBDUXOVOUFZUXRVWTWJUXLUXRVXBDUXOVXBDAUYRVXAVWS
        WKZYPVXBUXOVXKYPUVTVXBUYRUYTUXLVXPWCVXQAUYTVWTUWEDUXIUWAYIVXBVWTUXRAUYT
        VWTXTUWBUWCUOUPUWFYQUWGUWHUWIUWJUWK $.

      pcmpt2.6 $e |- ( ph -> M e. ( ZZ>= ` N ) ) $.
      $( Dividing two prime count maps yields a number with all dividing primes
         confined to an interval.  (Contributed by Mario Carneiro,
         14-Mar-2014.) $)
      pcmpt2 $p |- ( ph -> ( P pCnt ( ( seq 1 ( x. , F ) ` M ) /
     ( seq 1 ( x. , F ) ` N ) ) ) = if ( ( P <_ M /\ -. P <_ N ) , B , 0 ) ) $=
        ( co cmin cc0 wcel cn wceq cmul c1 cseq cfv cdiv cpc cle wbr cif cprime
        wn wa cz wne wf pcmptcl simprd nnuz uztrn2 syl2anc ffvelrnd nnzd nnne0d
        cuz pcdiv syl121anc pcmpt oveq12d cn0 wral cv eleq1d sylc nn0cnd subidd
        rspcv adantr cr prmnn syl nnred simpr eluzle letrd iftrue nsyl3 iffalse
        adantl 3eqtr4d oveq2d 0cn ifcl sylancl subid1d sylan9eqr biantrud ifbid
        cc eqtrd pm2.61dan 3eqtrd ) ADGUAFUBUCZUDZHXBUDZUEOUFOZDXCUFOZDXDUFOZPO
        ZDGUGUHZCQUIZDHUGUHZCQUIZPOZXIXKUKZULZCQUIZADUJRZXCUMRXCQUNXDSRXEXHTLAX
        CASSGXBASSFUOSSXBUOABEFIJUPUQZAHSRGHVDUDRZGSRKNUBGHSURUSUTZVAZVBAXCYAVC
        ASSHXBXRKVAXCXDDVEVFAXFXJXGXLPABCDEFGIJXTLMVGABCDEFHIJKLMVGVHAXKXMXPTAX
        KULZCCPOZQXMXPAYCQTXKACACAXQBVIRZEUJVJCVIRZLJYDYEEDUJEVKDTBCVIMVLVPVMVN
        ZVOVQYBXJCXLCPYBXIXJCTYBDHGADVRRXKADAXQDSRLDVSVTWAVQAHVRRXKAHKWAVQAGVRR
        XKAGXTWAVQAXKWBZAHGUGUHZXKAXSYHNHGWCVTVQWDXICQWEVTXKXLCTAXKCQWEWHVHYBXO
        UKXPQTXOXKYBXIXNWBYGWFXOCQWGVTWIAXNULZXMXJXPXNAXMXJQPOXJXNXLQXJPXKCQWGW
        JAXJACWRRQWRRXJWRRYFWKXICQWRWLWMWNWOYIXIXOCQYIXNXIAXNWBWPWQWSWTXA $.
    $}

    $d k n p B $.  $d k p F $.  $d k n p P $.  $d k p ph $.  $d p A $.
    $d p N $.
    pcmptdvds.3 $e |- ( ph -> M e. ( ZZ>= ` N ) ) $.
    $( The partial products of the prime power map form a divisibility chain.
       (Contributed by Mario Carneiro, 12-Mar-2014.) $)
    pcmptdvds $p |- ( ph -> ( seq 1 ( x. , F ) ` N ) ||
                            ( seq 1 ( x. , F ) ` M ) ) $=
      ( vp vm c1 wbr wcel cc0 cle cprime cn0 cn cmul cseq cfv cdivides co cz cv
      cdiv cpc wral wa wn csb cif nfv nfcsb1v nfel1 csbeq1a eleq1d cbvral sylib
      weq csbeq1 rspcv mpan9 nn0ge0d 0le0 breq2 ifboth cexp cmpt nfcv nfov nfif
      sylancl eleq1 id oveq12d eqidd ifbieq12d cbvmpt eqtri adantr simpr pcmpt2
      cuz breqtrrd ralrimiva cq wb wf pcmptcl simprd nnuz syl2anc ffvelrnd nnzd
      uztrn2 znq pcz syl mpbird wne nnne0d dvdsval2 syl3anc ) AFUADMUBZUCZEXGUC
      ZUDNZXIXHUHUEZUFOZAXLPKUGZXKUIUEZQNZKRUJZAXOKRAXMROZUKZPXMEQNXMFQNULUKZCX
      MBUMZPUNZXNQXRPXTQNZPPQNZPYAQNZXRXTACLUGZBUMZSOZLRUJZXQXTSOZABSOZCRUJYHHY
      JYGCLRYJLUOCYFSCYEBUPZUQCLVBZBYFSCYEBURZUSUTVAZYGYILXMRLKVBYFXTSCYEXMBVCZ
      USVDVEVFVGXSYBYCYDXTPXTYAPQVHPYAPQVHVIVOXRYFXTXMLDEFDCTCUGZROZYPBVJUEZMUN
      ZVKLTYEROZYEYFVJUEZMUNZVKGCLTYSUUBLYSVLYTCUUAMYTCUOCYEYFVJCYEVLCVJVLYKVMC
      MVLVNYLYQYTYRMUUAMYPYERVPYLYPYEBYFVJYLVQYMVRYLMVSVTWAWBAYHXQYNWCAFTOZXQIW
      CAXQWDYOAEFWFUCOZXQJWCWEWGWHAXKWIOZXLXPWJAXIUFOZXHTOUUEAXIATTEXGATTDWKTTX
      GWKABCDGHWLWMZAUUCUUDETOIJMEFTWNWRWOWPWQZATTFXGUUGIWPZXIXHWSWOXKKWTXAXBAX
      HUFOXHPXCUUFXJXLWJAXHUUIWQAXHUUIXDUUHXHXIXEXFXB $.
  $}

  ${
    $d k p F $.  $d k n p N $.
    pcprod.1 $e |- F = ( n e. NN |->
                         if ( n e. Prime , ( n ^ ( n pCnt N ) ) , 1 ) ) $.
    $( The product of the primes taken to their respective powers reconstructs
       the original number.  (Contributed by Mario Carneiro, 12-Mar-2014.) $)
    pcprod $p |- ( N e. NN -> ( seq 1 ( x. , F ) ` N ) = N ) $=
      ( vp cn wcel wceq cv cpc co cprime wa wbr cc0 cn0 ancoms ralrimiva adantl
      wral cmul c1 cseq cfv cle cif pccl simpr simpl oveq1 pcmpt iftrue iffalse
      wn cdivides cz wi prmz dvdsle sylan con3and wb pceq0 adantr mpbird eqtr4d
      pm2.61dan eqtrd pcmptcl simprd ffvelrn mpancom nnnn0d nnnn0 pc11 syl2anc
      wf ) CFGZCUABUBUCZUDZCHZEIZVTJKZWBCJKZHZELTZVRWEELWBLGZVRWEWGVRMZWCWBCUEN
      ZWDOUFZWDWHAIZCJKZWDWBABCDVRWLPGZALTWGVRWMALWKLGVRWMWKCUGQRZSWGVRUHWGVRUI
      WKWBCJUJUKWHWIWJWDHZWIWOWHWIWDOULSWHWIUNZMZWJOWDWPWJOHWHWIWDOUMSWQWDOHZWB
      CUONZUNZWHWSWIWGWBUPGVRWSWIUQWBURWBCUSUTVAWHWRWTVBWPWBCVCVDVEVFVGVHQRVRVT
      PGCPGWAWFVBVRVTFFVSVQZVRVTFGVRFFBVQXAVRWLABDWNVIVJFFCVSVKVLVMCVNVTCEVOVPV
      E $.
  $}

  ${
    $d k A $.  $d k B $.
    $( The sum of 1 over a set is the size of the set.  (Contributed by Mario
       Carneiro, 8-Mar-2014.)  (Revised by Mario Carneiro, 20-May-2014.) $)
    sumhash $p |- ( ( B e. Fin /\ A C_ B ) ->
                   sum_ k e. B if ( k e. A , 1 , 0 ) = ( # ` A ) ) $=
      ( cC cfn wcel wss wa c1 csu chash cfv cmul co cv cc0 cif cc wceq ax-1cn
      ssfi fsumconst sylancl wral cuz wo simpr rgenw simpl olcd sumss2 syl21anc
      a1i cn0 hashcl syl nn0cnd mulid1d 3eqtr3d ) BEFZABGZHZAICJZAKLZIMNZBCOAFI
      PQCJZVDVBAEFZIRFZVCVESBAUAZTAICUBUCVBVAVHCAUDZBDUELGZUTUFVCVFSUTVAUGVJVBV
      HCATUHUMVBUTVKUTVAUIUJABICDUKULVBVDVBVDVBVGVDUNFVIAUOUPUQURUS $.
  $}

  $( The difference between the floors of adjacent fractions is either 1 or 0.
     (Contributed by Mario Carneiro, 8-Mar-2014.) $)
  fldivp1 $p |- ( ( M e. ZZ /\ N e. NN ) ->
                  ( ( |_ ` ( ( M + 1 ) / N ) ) - ( |_ ` ( M / N ) ) ) =
                    if ( N || ( M + 1 ) , 1 , 0 ) ) $=
    ( cz wcel wa c1 caddc co wbr cdiv cfl cfv cmin cc0 wceq wb adantl adantr cr
    clt cdivides cif wne nnz nnne0 peano2z dvdsval2 syl3anc biimpa flid syl cle
    cn nnm1nn0 nn0red nn0ge0d nnre nngt0 divge0 syl22anc ad2antlr ltm1d mulid1d
    cmul nncn breqtrrd 1re a1i ltdivmul syl112anc nndivre mpancom flbi2 syl2anc
    mpbird mpbir2and eqtr4d cc ax-1cn ppncand oveq1d zcnd subcl sylancl divdird
    zcn eqtr3d dividd oveq2d eqtrd fveq2d sylan 1z fladdz 3eqtrrd flcld subaddd
    zre iftrue wn cmo cn0 zmodcl resubcl wo elnn0 sylib ord id dvdsval3 syl2anr
    sylibrd con1d imp jca syl21anc crp nnrp modlt syl2an sylancom modval mulcld
    lttrd sub32d pncan divsubdird divcan3d recnd subeq0ad iffalse pm2.61dan
    mpbid ) ACDZBUMDZEZBAFGHZUAIZYQBJHZKLZABJHZKLZMHZYRFNUBZOYPYREZUUCFUUDUUEUU
    CFOZUUBFGHZYTOZUUEYTYSBFMHZBJHZGHZKLZUUAFGHZKLZUUGUUEYTYSUULUUEYSCDZYTYSOYP
    YRUUOYPBCDZBNUCZYQCDZYRUUOPYOUUPYNBUDQYOUUQYNBUEQZYNUURYOAUFZRZBYQUGUHUIZYS
    UJUKUUEUULYSOZNUUJULIZUUJFTIZYOUVDYNYRYOUUISDZNUUIULIBSDZNBTIZUVDYOUUIBUNZU
    OZYOUUIUVIUPBUQZBURZUUIBUSUTVAYOUVEYNYRYOUVEUUIBFVDHZTIZYOUUIBUVMTYOBUVKVBY
    OBBVEZVCVFYOUVFFSDZUVGUVHUVEUVNPUVJUVPYOVGVHUVKUVLUUIFBVIVJVOVAUUEUUOUUJSDZ
    UVCUVDUVEEPUVBYOUVQYNYRUVFYOUVQUVJUUIBVKVLVAUUJYSVMVNVPVQYPUULUUNOYRYPUUKUU
    MKYPUUKUUABBJHZGHZUUMYPABGHZBJHZUUKUVSYPYQUUIGHZBJHUWAUUKYPUWBUVTBJYPAFBYNA
    VRDZYOAWFRZFVRDZYPVSVHZYOBVRDZYNUVOQZVTWAYPYQUUIBYPYQUVAWBZYOUUIVRDZYNYOUWG
    UWEUWJUVOVSBFWCWDQUWHUUSWEWGYPABBUWDUWHUWHUUSWEWGYPUVRFUUAGYPBUWHUUSWHWIWJW
    KRYPUUNUUGOZYRYPUUASDZFCDUWKYNASDYOUWLAWRABVKWLZWMUUAFWNWDRWOYPUUFUUHPYRYPY
    TUUBFYPYTYPYSYNYQSDZYOYSSDYNUURUWNUUTYQWRUKZYQBVKWLWPZWBZYPUUBYPUUAUWMWPWBZ
    UWFWQRVOYRUUDFOYPYRFNWSQVQYPYRWTZEZUUCNUUDUWTUUCNOZYTUUBOZUWTYTYQBXAHZFMHZB
    JHZGHZKLZYTUUBUWTUXGYTOZNUXEULIZUXEFTIZUWTUXDSDZNUXDULIUVGUVHEZUXIYPUXKUWSY
    PUXCSDUVPUXKYPUXCYNUURYOUXCXBDZUUTYQBXCWLZUOZVGUXCFXDWDZRUWTUXDUWTUXCUMDZUX
    DXBDYPUWSUXQYPUXQYRYPUXQWTUXCNOZYRYPUXQUXRYPUXMUXQUXRXEUXNUXCXFXGXHYOYOUURY
    RUXRPYNYOXIUUTBYQXJXKXLXMXNUXCUNUKUPYOUXLYNUWSYOUVGUVHUVKUVLXOVAUXDBUSXPYPU
    XJUWSYPUXJUXDUVMTIZYPUXDBUVMTYPUXDUXCBUXPUXOYOUVGYNUVKQZYPUXCUXOVBYNUWNBXQD
    ZUXCBTIYOUWOBXRZYQBXSXTYDYPBUWHVCVFYPUXKUVPUVGUVHUXJUXSPUXPUVPYPVGVHUXTYOUV
    HYNUVLQUXDFBVIVJVORYPUXHUXIUXJEPZUWSYPYTCDUXESDZUYCUWPYNYOUXKUYDUXPUXDBVKYA
    ZUXEYTVMVNRVPUWTUXFUUAKYPUXFUUAOZUWSYPUUAYTMHZUXEOUYFYPUXEABYTVDHZMHZBJHUUA
    UYHBJHZMHUYGYPUXDUYIBJYPUXDYQFMHZUYHMHZUYIYPUXDYQUYHMHZFMHUYLYPUXCUYMFMYNUW
    NUYAUXCUYMOYOUWOUYBYQBYBXTWAYPYQFUYHUWIUWFYPBYTUWHUWQYCZYEVQYPUYKAUYHMYPUWC
    UWEUYKAOUWDVSAFYFWDWAWJWAYPAUYHBUWDUYNUWHUUSYGYPUYJYTUUAMYPYTBUWQUWHUUSYHWI
    WOYPUUAYTUXEYPUUAUWMYIUWQYPUXEUYEYIWQYMRWKWGYPUXAUXBPUWSYPYTUUBUWQUWRYJRVOU
    WSUUDNOYPYRFNYKQVQYL $.

  ${
    $d k n x P $.  $d k x N $.  $d k M $.  $d k K $.
    $( Lemma for ~ pcfac .  (Contributed by Mario Carneiro, 20-May-2014.) $)
    pcfaclem $p |- ( ( N e. NN0 /\ M e. ( ZZ>= ` N ) /\ P e. Prime ) ->
                     ( |_ ` ( N / ( P ^ M ) ) ) = 0 ) $=
      ( cn0 wcel cuz cfv cprime w3a cexp co cc0 cle wbr c1 3ad2ant1 cr 3ad2ant3
      clt wb cdiv cfl wceq caddc nn0ge0 nn0re cn prmnn eluznn0 3adant3 nnexpcld
      nnred nngt0d ge0div syl3anc mpbid cmul nn0red eluzle 3ad2ant2 c2 bernneq3
      prmuz2 syl2anc lelttrd mulid1d breqtrrd 1re a1i ltdivmul syl112anc mpbird
      nncnd 0p1e1 syl6breqr cz wa nndivred 0z flbi sylancl mpbir2and ) CDEZBCFG
      EZAHEZIZCABJKZUAKZUBGLUCZLWHMNZWHLOUDKZSNZWFLCMNZWJWCWDWMWECUEPWFCQEZWGQE
      ZLWGSNZWMWJTWCWDWNWECUFPZWFWGWFABWEWCAUGEWDAUHRWCWDBDEZWEBCUIUJZUKZULZWFW
      GWTUMZCWGUNUOUPWFWHOWKSWFWHOSNZCWGOUQKZSNZWFCWGXDSWFCBWGWQWFBWSURXAWDWCCB
      MNWECBUSUTWFAVAFGEZWRBWGSNWEWCXFWDAVCRWSABVBVDVEWFWGWFWGWTVMVFVGWFWNOQEZW
      OWPXCXETWQXGWFVHVIXAXBCOWGVJVKVLVNVOWFWHQELVPEWIWJWLVQTWFCWGWQWTVRVSWHLVT
      WAWB $.
  $}

  ${
    $d k m n x P $.  $d k m x N $.  $d k m M $.  $d k K $.
    $( Calculate the prime count of a factorial.  (Contributed by Mario
       Carneiro, 11-Mar-2014.)  (Revised by Mario Carneiro, 21-May-2014.) $)
    pcfac $p |- ( ( N e. NN0 /\ M e. ( ZZ>= ` N ) /\ P e. Prime ) ->
   ( P pCnt ( ! ` N ) ) = sum_ k e. ( 1 ... M ) ( |_ ` ( N / ( P ^ k ) ) ) ) $=
      ( vm cuz cfv wcel cfa cpc co c1 cdiv cfl csu wceq wa wi cc0 wbr vx vn cn0
      cprime cfz cv cexp wral caddc fveq2 oveq2d oveq1 fveq2d sumeq2sdv eqeq12d
      raleqbidv imbi2d cfn fzfid wss sumz olcs syl 0nn0 a1i elfznn nnnn0d nn0uz
      syl6eleq adantl simpll pcfaclem syl3anc sumeq2dv oveq2i pc1 syl5eq adantr
      fac0 3eqtr4rd ralrimiva cz nn0z uzid peano2uz 3syl uzss ssralv cmul facp1
      wne simplr cn faccl nnz nnne0 jca nn0p1nn pcmul eqtr2d cif cdivides nn0zd
      cmin prmnn ad2antlr nnexpcl syl2an fldivp1 syl2anc cle elfzuz pccld elfz5
      wb syl2anr simpllr pcdvdsb bitr2d ifbid eqtrd cr nn0red peano2re nndivred
      nnzd flcld zcnd fsumsub chash fzfi eluzelz zred clt c2 prmuz2 bernneq3 wn
      syld fsumcl letrid nnexpcld dvdsle nnred lenltd sylibd sylbid mt4d eluzle
      ord letrd eluz mpbird fzss2 sumhash sylancr hashfz1 3eqtr3d recnd subaddd
      mpbid syl5ib ralimdva ex a2d nn0ind imp oveq2 sumeq1d eqeq2d rspcv 3impib
      syl5 3com12 ) CDFGZHZDUCHZAUDHZADIGZJKZLCUEKZDABUFZUGKZMKZNGZBOZPZUVPUVQU
      VRUWGUVQUVRQUVTLEUFZUEKZUWEBOZPZEUVOUHZUVPUWGUVQUVRUWLUVRAUAUFZIGZJKZUWIU
      WMUWCMKZNGZBOZPZEUWMFGZUHZRUVRASIGZJKZUWISUWCMKZNGZBOZPZESFGZUHZRUVRAUBUF
      ZIGZJKZUWIUXJUWCMKZNGZBOZPZEUXJFGZUHZRUVRAUXJLUIKZIGZJKZUWIUXSUWCMKZNGZBO
      ZPZEUXSFGZUHZRUVRUWLRUAUBDUWMSPZUXAUXIUVRUYHUWSUXGEUWTUXHUWMSFUJUYHUWOUXC
      UWRUXFUYHUWNUXBAJUWMSIUJUKUYHUWIUWQUXEBUYHUWPUXDNUWMSUWCMULUMUNUOUPUQUWMU
      XJPZUXAUXRUVRUYIUWSUXPEUWTUXQUWMUXJFUJUYIUWOUXLUWRUXOUYIUWNUXKAJUWMUXJIUJ
      UKUYIUWIUWQUXNBUYIUWPUXMNUWMUXJUWCMULUMUNUOUPUQUWMUXSPZUXAUYGUVRUYJUWSUYE
      EUWTUYFUWMUXSFUJUYJUWOUYAUWRUYDUYJUWNUXTAJUWMUXSIUJUKUYJUWIUWQUYCBUYJUWPU
      YBNUWMUXSUWCMULUMUNUOUPUQUWMDPZUXAUWLUVRUYKUWSUWKEUWTUVOUWMDFUJUYKUWOUVTU
      WRUWJUYKUWNUVSAJUWMDIUJUKUYKUWIUWQUWEBUYKUWPUWDNUWMDUWCMULUMUNUOUPUQUVRUX
      GEUXHUVRUWHUXHHZQZUWISBOZSUXFUXCUYMUWIURHZUYNSPZUYMLUWHUSUWILFGZUTUYOUYPU
      WIBLVAVBVCUYMUWIUXESBUYMUWBUWIHZQZSUCHZUWBUXHHZUVRUXESPUYTUYSVDVEUYRVUAUY
      MUYRUWBUCUXHUYRUWBUWBUWHVFVGZVHVIVJUVRUYLUYRVKAUWBSVLVMVNUVRUXCSPUYLUVRUX
      CALJKSUXBLAJVSVOAVPVQVRVTWAUXJUCHZUVRUXRUYGVUCUVRUXRUYGRVUCUVRQZUXRUXPEUY
      FUHZUYGVUDUXSUXQHZUYFUXQUTUXRVUERVUDUXJWBHZUXJUXQHVUFVUCVUGUVRUXJWCVRUXJW
      DUXJUXJWEWFUXJUXSWGUXPEUYFUXQWHWFVUDUXPUYEEUYFUXPUXLAUXSJKZUIKZUXOVUHUIKZ
      PVUDUWHUYFHZQZUYEUXLUXOVUHUIULVULVUIUYAVUJUYDVULUYAAUXKUXSWIKZJKZVUIVULUX
      TVUMAJVULVUCUXTVUMPVUCUVRVUKVKZUXJWJVCUKVULUVRUXKWBHZUXKSWKZQZUXSWBHZUXSS
      WKZQZVUNVUIPVUCUVRVUKWLZVULVUCUXKWMHZVURVUOUXJWNVVCVUPVUQUXKWOUXKWPWQWFVU
      LVUCUXSWMHZVVAVUOUXJWRZVVDVUSVUTUXSWOUXSWPWQWFUXKUXSAWSVMWTVULUYDUXOXDKZV
      UHPVUJUYDPVULUWIUYCUXNXDKZBOUWIUWBLVUHUEKZHZLSXAZBOZVVFVUHVULUWIVVGVVJBVU
      LUYRQZVVGUWCUXSXBTZLSXAZVVJVVLVUGUWCWMHZVVGVVNPVVLUXJVULVUCUYRVUOVRZXCVUL
      AWMHZUWBUCHZVVOUYRUVRVVQVUCVUKAXEXFZVUBAUWBXGXHZUXJUWCXIXJVVLVVMVVILSVVLV
      VIUWBVUHXKTZVVMUYRUWBUYQHVUHWBHZVVIVWAXOVULUWBLUWHXLVULVUHVULAUXSVVBVULVU
      CVVDVUOVVEVCZXMZXCZUWBLVUHXNXPVVLUVRVUSVVRVWAVVMXOVUCUVRVUKUYRXQVVLUXSVVL
      VUCVVDVVPVVEVCYFUYRVVRVULVUBVJUWBAUXSXRVMXSXTYAVNVULUWIUYCUXNBVULLUWHUSZV
      VLUYCVVLUYBVVLUXSUWCVULUXSYBHZUYRVULUXJYBHZVWGVULUXJVUOYCZUXJYDVCZVRVVTYE
      YGYHZVVLUXNVVLUXMVVLUXJUWCVULVWHUYRVWIVRVVTYEYGYHZYIVULVVKVVHYJGZVUHVULUY
      OVVHUWIUTZVVKVWMPLUWHYKVULUWHVUHFGHZVWNVULVWOVUHUWHXKTZVULVUHUXSUWHVULVUH
      VWDYCZVWJVULUWHVUKUWHWBHZVUDUXSUWHYLVJZYMVULUXSAUXSUGKZYNTZVUHUXSXKTZVULA
      YOFGHZUXSUCHZVXAUVRVXCVUCVUKAYPXFVULUXSVWCVGZAUXSYQXJVULVXBYRUXSVUHXKTZVX
      AYRZVULVXBVXFVULVUHUXSVWQVWJUUAUUJVULVXFVWTUXSXBTZVXGVULUVRVUSVXDVXFVXHXO
      VVBVULUXSVWCYFVXEUXSAUXSXRVMVULVXHVWTUXSXKTZVXGVULVWTWBHVVDVXHVXIRVULVWTV
      ULAUXSVVSVXEUUBZYFVWCVWTUXSUUCXJVULVWTUXSVULVWTVXJUUDVWJUUEUUFUUGYSUUHVUK
      UXSUWHXKTVUDUXSUWHUUIVJUUKVULVWBVWRVWOVWPXOVWEVWSVUHUWHUULXJUUMVUHLUWHUUN
      VCVVHUWIBUUOUUPVULVUHUCHVWMVUHPVWDVUHUUQVCYAUURVULUYDUXOVUHVULUWIUYCBVWFV
      WKYTVULUWIUXNBVWFVWLYTVULVUHVWQUUSUUTUVAUOUVBUVCYSUVDUVEUVFUVGUWKUWGECUVO
      UWHCPZUWJUWFUVTVXKUWIUWAUWEBUWHCLUEUVHUVIUVJUVKUVMUVLUVN $.

    $( Calculate the prime count of a binomial coefficient.  (Contributed by
       Mario Carneiro, 11-Mar-2014.)  (Revised by Mario Carneiro,
       21-May-2014.) $)
    pcbc $p |- ( ( N e. NN /\ K e. ( 0 ... N ) /\ P e. Prime ) ->
   ( P pCnt ( N _C K ) ) = sum_ k e. ( 1 ... N ) ( ( |_ ` ( N / ( P ^ k ) ) ) -
     ( ( |_ ` ( ( N - K ) / ( P ^ k ) ) ) + ( |_ ` ( K / ( P ^ k ) ) ) ) ) ) $=
      ( cn wcel cc0 co cfa cfv cmin cdiv cpc caddc csu cz wceq cn0 syl 3ad2ant2
      cfz cprime w3a cmul cbc c1 cexp cfl wne simp3 nnnn0 3ad2ant1 faccl nnne0d
      cv nnzd fznn0sub elfznn0 nnmulcld pcdiv syl121anc bcval2 fzfid wa cr nnre
      oveq2d adantr simpl3 prmnn elfznn nnnn0d nnexpcld nndivred flcld resubcld
      adantl zcnd nn0red addcld fsumsub cuz nn0zd pcfac syl3anc cle wbr nn0ge0d
      uzid subge02d mpbid zsubcld eluz syl2anc mpbird elfzuz3 oveq12d syl122anc
      wb pcmul fsumadd 3eqtr4d eqtr4d ) DEFZCGDUAHFZAUBFZUCZADIJZDCKHZIJZCIJZUD
      HZLHZMHZAXHMHZAXLMHZKHZADCUEHZMHUFDUAHZDABUOZUGHZLHZUHJZXIYALHZUHJZCYALHZ
      UHJZNHZKHBOZXGXFXHPFXHGUIXLEFXNXQQXDXEXFUJZXGXHXGDRFZXHEFXDXEYKXFDUKULZDU
      MSZUPXGXHYMUNXGXJXKXGXIRFZXJEFXEXDYNXFCGDUQTZXIUMSZXGCRFZXKEFXEXDYQXFCDUR
      TZCUMSZUSXHXLAUTVAXGXRXMAMXEXDXRXMQXFCDVBTVGXGYIXSYCBOZXSYHBOZKHXQXGXSYCY
      HBXGUFDVCZXGXTXSFZVDZYCUUDYBUUDDYAXGDVEFZUUCXDXEUUEXFDVFULZVHUUDAXTUUDXFA
      EFXDXEXFUUCVIAVJSUUCXTRFXGUUCXTXTDVKVLVQVMZVNVOVRUUDYEYGUUDYEUUDYDUUDXIYA
      XGXIVEFUUCXGDCUUFXGCYRVSZVPVHUUGVNVOVRZUUDYGUUDYFUUDCYAXGCVEFUUCUUHVHUUGV
      NVOVRZVTWAXGXOYTXPUUAKXGYKDDWBJFZXFXOYTQYLXGDPFZUUKXGDYLWCZDWISYJABDDWDWE
      XGAXJMHZAXKMHZNHZXSYEBOZXSYGBOZNHXPUUAXGUUNUUQUUOUURNXGYNDXIWBJFZXFUUNUUQ
      QYOXGUUSXIDWFWGZXGGCWFWGUUTXGCYRWHXGDCUUFUUHWJWKXGXIPFUULUUSUUTWSXGDCUUMX
      GCYRWCWLUUMXIDWMWNWOYJABDXIWDWEXGYQDCWBJFZXFUUOUURQYRXEXDUVAXFCGDWPTYJABD
      CWDWEWQXGXFXJPFXJGUIXKPFXKGUIXPUUPQYJXGXJYPUPXGXJYPUNXGXKYSUPXGXKYSUNXJXK
      AWTWRXGXSYEYGBUUBUUIUUJXAXBWQXCXB $.
  $}

  ${
    $d p A $.  $d p N $.
    $( If a power of a rational number is an integer, then the number is an
       integer.  In other words, all n-th roots are irrational unless they are
       integers (so that the original number is an n-th power).  (Contributed
       by Mario Carneiro, 10-Aug-2015.) $)
    qexpz $p |- ( ( A e. QQ /\ N e. NN /\ ( A ^ N ) e. ZZ ) ->
        A e. ZZ ) $=
      ( vp wcel co cz cc0 wne wa cpc cle wbr cprime cmul syl syl12anc cr wb a1i
      mpbird cq cn cexp w3a eleq1 cv wral simpll2 nncnd mul01d simpr simpll3 cc
      cn0 simpll1 qcn simplr nnzd expne0d pczcl nn0ge0d pcexp syl121anc breqtrd
      wceq eqbrtrd clt 0re pcqcl nnred nngt0d lemul2 syl112anc ralrimiva simpl1
      zred pcz 0z pm2.61ne ) AUADZBUBDZABUCEZFDZUDZAFDZGFDZAGAGFUEWDAGHZIZWEGCU
      FZAJEZKLZCMUGZWHWKCMWHWIMDZIZWKBGNEZBWJNEZKLZWNWOGWPKWNBWNBVTWAWCWGWMUHZU
      IUJWNGWIWBJEZWPKWNWSWNWMWCWBGHWSUNDWHWMUKZVTWAWCWGWMULWNABWNVTAUMDVTWAWCW
      GWMUOZAUPOWDWGWMUQZWNBWRURZUSWIWBUTPVAWNWMVTWGBFDWSWPVEWTXAXBXCAWIBVBVCVD
      VFWNGQDZWJQDBQDGBVGLWKWQRXDWNVHSWNWJWNWMVTWGWJFDWTXAXBWIAVIPVPWNBWRVJWNBW
      RVKGWJBVLVMTVNWHVTWEWLRVTWAWCWGVOACVQOTWFWDVRSVS $.

    $( A second or higher power of a rational number is not a prime number.  Or
       by contraposition, the n-th root of a prime number is irrational.
       Suggested by Norm Megill.  (Contributed by Mario Carneiro,
       10-Aug-2015.) $)
    expnprm $p |- ( ( A e. QQ /\ N e. ( ZZ>= ` 2 ) ) ->
        -. ( A ^ N ) e. Prime ) $=
      ( cq wcel c2 wa c1 wne cexp co cn adantl cdivides wbr cpc cz ad2antlr cc0
      wceq syl cuz cfv cprime wn eluz2b3 simprbi cmul simpr simpll prmnn nnne0d
      eluzelz simplbi 0expd neeqtrrd oveq1 necon3i pcqcl syl12anc syl2anc nncnd
      dvdsmul1 exp1d oveq2d 1z pcid sylancl pcexp syl121anc 3eqtr3rd breqtrd ex
      cn0 wb nnnn0d dvds1 sylibd necon3ad mpd ) ACDZBEUAUBDZFZBGHZABIJZUCDZUDWA
      WCVTWABKDZWCBUEZUFLWBWEBGWBWEBGMNZBGSZWBWEWHWBWEFZBBWDAOJZUGJZGMWJBPDZWKP
      DZBWLMNWAWMVTWEEBULQZWJWEVTARHZWNWBWEUHZVTWAWEUIZWJWDRBIJZHWPWJWDRWSWJWDW
      EWDKDWBWDUJLZUKWJBWAWFVTWEWAWFWCWGUMZQUNUOARWDWSARBIUPUQTZWDAURUSBWKVBUTW
      JWDWDGIJZOJZWDWDOJZGWLWJXCWDWDOWJWDWJWDWTVAVCVDWJWEGPDXDGSWQVEGWDVFVGWJWE
      VTWPWMXEWLSWQWRXBWOAWDBVHVIVJVKVLWBBVMDWHWIVNWBBWAWFVTXALVOBVPTVQVRVS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                           Pocklington's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n x D $.  $d k K $.  $d k x N $.  $d k n x P $.
    $( A relation involving divisibility by a prime power.  (Contributed by
       Mario Carneiro, 2-Mar-2014.) $)
    prmpwdvds $p |- ( ( ( K e. ZZ /\ D e. ZZ ) /\ ( P e. Prime /\ N e. NN ) /\
         ( D || ( K x. ( P ^ N ) ) /\ -. D || ( K x. ( P ^ ( N - 1 ) ) ) ) ) ->
                   ( P ^ N ) || D ) $=
      ( vk cz wcel wa cexp co cmul cdivides wbr c1 wn wceq oveq2d breq2d notbid
      wi vx vn cprime cn cmin cv wral simpll caddc oveq2 anbi12d breq1d imbi12d
      oveq1 ralbidv imbi2d weq breq1 breq2 cgcd wb simplrl coprm syl2anc cc zcn
      ad2antll prmz ad2antrl zcnd mulcomd simpl gcdcom eqeq1d coprmdvds syl3anc
      simprr sylbid expdimp con1d expimpd vtoclga impl exp1d ad2antlr cc0 1m1e0
      oveq2i exp0d syl5eq adantl mulid1d eqtrd 3imtr4d ralrimiva imbi1d cbvralv
      ex zmulcld rspcv syl wrex cn0 nnnn0 ad2antrr zexpcl divides adantll prmnn
      simplr expp1d nnexpcld mulassd eqtr4d wne nnzd nnne0d dvdsmulcr syl112anc
      nncnd bitrd an32s syl5ibcom rexlimdva adantlr com23 nnm1nn0 expm1t ax-1cn
      a2d nncn pncan sylancl anbi2d syld anassrs ralrimdva syl5bi expl nnind
      com12 impr sylc 3impia ) CFGZAFGZHZBUCGZDUDGZHZACBDIJZKJZLMZACBDNUEJZIJZK
      JZLMZOZHZUUKALMZUUGUUJHUUEAEUFZUUKKJZLMZAUVAUUOKJZLMZOZHZUUTTZEFUGZUUSUUT
      TZUUEUUFUUJUHUUFUUJUVIUUEUUFUUHUUIUVIUUIUUFUUHHZUVIUVKAUVABUAUFZIJZKJZLMZ
      AUVABUVLNUEJZIJZKJZLMZOZHZUVMALMZTZEFUGZTUVKAUVABNIJZKJZLMZAUVABNNUEJZIJZ
      KJZLMZOZHZUWEALMZTZEFUGZTUVKAUVABUBUFZIJZKJZLMZAUVABUWQNUEJZIJZKJZLMZOZHZ
      UWRALMZTZEFUGZTUVKAUVABUWQNUIJZIJZKJZLMZAUVABUXJNUEJZIJZKJZLMZOZHZUXKALMZ
      TZEFUGZTUVKUVITUAUBDUVLNPZUWDUWPUVKUYCUWCUWOEFUYCUWAUWMUWBUWNUYCUVOUWGUVT
      UWLUYCUVNUWFALUYCUVMUWEUVAKUVLNBIUJZQRUYCUVSUWKUYCUVRUWJALUYCUVQUWIUVAKUY
      CUVPUWHBIUVLNNUEUNQQRSUKUYCUVMUWEALUYDULUMUOUPUAUBUQZUWDUXIUVKUYEUWCUXHEF
      UYEUWAUXFUWBUXGUYEUVOUWTUVTUXEUYEUVNUWSALUYEUVMUWRUVAKUVLUWQBIUJZQRUYEUVS
      UXDUYEUVRUXCALUYEUVQUXBUVAKUYEUVPUXABIUVLUWQNUEUNQQRSUKUYEUVMUWRALUYFULUM
      UOUPUVLUXJPZUWDUYBUVKUYGUWCUYAEFUYGUWAUXSUWBUXTUYGUVOUXMUVTUXRUYGUVNUXLAL
      UYGUVMUXKUVAKUVLUXJBIUJZQRUYGUVSUXQUYGUVRUXPALUYGUVQUXOUVAKUYGUVPUXNBIUVL
      UXJNUEUNQQRSUKUYGUVMUXKALUYHULUMUOUPUVLDPZUWDUVIUVKUYIUWCUVHEFUYIUWAUVGUW
      BUUTUYIUVOUVCUVTUVFUYIUVNUVBALUYIUVMUUKUVAKUVLDBIUJZQRUYIUVSUVEUYIUVRUVDA
      LUYIUVQUUOUVAKUYIUVPUUNBIUVLDNUEUNQQRSUKUYIUVMUUKALUYJULUMUOUPUVKUWOEFUVK
      UVAFGZHZAUVABKJZLMZAUVALMZOZHZBALMZUWMUWNUUFUUHUYKUYQUYRTZUUHUYKHZUVLUYML
      MZUVLUVALMZOZHZBUVLLMZTZTUYTUYSTUAAFUVLAPZVUFUYSUYTVUGVUDUYQVUEUYRVUGVUAU
      YNVUCUYPUVLAUYMLURVUGVUBUYOUVLAUVALURSUKUVLABLUSUMUPUVLFGZUYTVUFVUHUYTHZV
      UAVUCVUEVUIVUAHZVUEVUBVUJVUEOZBUVLUTJZNPZVUBVUJUUHVUHVUKVUMVAVUHUUHUYKVUA
      VBVUHUYTVUAUHBUVLVCVDVUIVUAVUMVUBVUIVUAVUMHUVLBUVAKJZLMZUVLBUTJZNPZHZVUBV
      UIVUAVUOVUMVUQVUIUYMVUNUVLLVUIUVABUYKUVAVEGZVUHUUHUVAVFZVGVUIBUUHBFGZVUHU
      YKBVHZVIZVJVKRVUIVULVUPNVUIVVAVUHVULVUPPVVCVUHUYTVLZBUVLVMVDVNUKVUIVUHVVA
      UYKVURVUBTVVDVVCVUHUUHUYKVQUVLBUVAVOVPVRVSVRVTWAZWRWBWCUYLUWGUYNUWLUYPUYL
      UWFUYMALUYLUWEBUVAKUUHUWEBPUUFUYKUUHBUUHBVVBVJWDWEQRUYLUWKUYOUYLUWJUVAALU
      YLUWJUVANKJUVAUYLUWINUVAKUYLUWIBWFIJNUWHWFBIWGWHUYLBUYLBUUHVVAUUFUYKVVBWE
      VJZWIWJQUYLUVAUYKVUSUVKVUTWKWLWMRSUKUYLUWEBALUYLBVVFWDULWNWOUWQUDGZUVKUXI
      UYBVVGUUFUUHUXIUYBTUXIAUVLUWRKJZLMZAUVLUXBKJZLMZOZHZUXGTZUAFUGZVVGUUFHZUU
      HHZUYBUXHVVNEUAFEUAUQZUXFVVMUXGVVRUWTVVIUXEVVLVVRUWSVVHALUVAUVLUWRKUNRVVR
      UXDVVKVVRUXCVVJALUVAUVLUXBKUNRSUKWPWQVVQVVOUYAEFVVPUUHUYKVVOUYATVVPUYTHZV
      VOAUYMUWRKJZLMZAUYMUXBKJZLMZOZHZUXGTZUYAVVSUYMFGZVVOVWFTVVSUVABVVPUUHUYKV
      QUUHVVAVVPUYKVVBVIZWSVVNVWFUAUYMFUVLUYMPZVVMVWEUXGVWIVVIVWAVVLVWDVWIVVHVV
      TALUVLUYMUWRKUNRVWIVVKVWCVWIVVJVWBALUVLUYMUXBKUNRSUKWPWTXAVVSUXMUWTOZHZUX
      GTVWKUXTTZVWFUYAVVSVWKUXGUXTVVSUXGVWKUXTVVSUXGVVHAPZUAFXBZVWLVVSUWRFGZUUF
      UXGVWNVAVVSVVAUWQXCGZVWOVWHVVGVWPUUFUYTUWQXDZXEZBUWQXFVDZVVGUUFUYTXJUAUWR
      AXGVDVVGUYTVWNVWLTUUFVVGUYTHZVWMVWLUAFVWTVUHHVVHUXLLMZVVHUWSLMZOZHZUXKVVH
      LMZTZVWMVWLVVGVUHUYTVXFVVGVUHHZUYTHZVUDVUEVXDVXEVUHUYTVUFVVGVVEXHVXHVXAVU
      AVXCVUCVXHVXAVVHVVTLMZVUAVXHUXLVVTVVHLVXHUXLUVABUWRKJZKJZVVTVXHUXKVXJUVAK
      VXHUXKUWRBKJZVXJVXHBUWQVXHBUUHBUDGVXGUYKBXIVIZXTZVVGVWPVUHUYTVWQXEZXKVXHU
      WRBVXHUWRVXHBUWQVXMVXOXLZXTZVXNVKWMZQVXHUVABUWRUYKVUSVXGUUHVUTVGVXNVXQXMX
      NRVXHVUHVWGVWOUWRWFXOZVXIVUAVAVVGVUHUYTXJZVXHUVABVXGUUHUYKVQZVXHBVXMXPZWS
      VXHUWRVXPXPZVXHUWRVXPXQZUWRUVLUYMXRXSYAVXHVXBVUBVXHVUHUYKVWOVXSVXBVUBVAVX
      TVYAVYCVYDUWRUVLUVAXRXSSUKVXHVXEVXJVVHLMZVUEVXHUXKVXJVVHLVXRULVXHVVAVUHVW
      OVXSVYEVUEVAVYBVXTVYCVYDUWRBUVLXRXSYAWNYBVWMVXDVWKVXEUXTVWMVXAUXMVXCVWJVV
      HAUXLLURVWMVXBUWTVVHAUWSLURSUKVVHAUXKLUSUMYCYDYEVRYFYJVVSVWEVWKUXGVVSVWAU
      XMVWDVWJVVSVVTUXLALVVSVVTVXKUXLVVSUVABUWRUYKVUSVVPUUHVUTVGZVVSBVWHVJZVVSU
      WRVWSVJZXMVVSVXJUXKUVAKVVSVXJVXLUXKVVSBUWRVYGVYHVKVVSBUWQVYGVWRXKXNQWMRVV
      SVWCUWTVVSVWBUWSALVVSVWBUVABUXBKJZKJUWSVVSUVABUXBVYFVYGVVSUXBVVSVVAUXAXCG
      ZUXBFGVWHVVGVYJUUFUYTUWQYGXEBUXAXFVDVJZXMVVSVYIUWRUVAKVVSVYIUXBBKJZUWRVVS
      BUXBVYGVYKVKVVSBVEGVVGUWRVYLPVYGVVGUUFUYTUHBUWQYHVDXNQWMRSUKWPVVSUXSVWKUX
      TVVSUXRVWJUXMVVSUXQUWTVVSUXPUWSALVVSUXOUWRUVAKVVSUXNUWQBIVVSUWQVEGZNVEGUX
      NUWQPVVGVYMUUFUYTUWQYKXEYIUWQNYLYMQQRSYNWPWNYOYPYQYRYSYJYTUUAUUBXHUVHUVJE
      CFUVACPZUVGUUSUUTVYNUVCUUMUVFUURVYNUVBUULALUVACUUKKUNRVYNUVEUUQVYNUVDUUPA
      LUVACUUOKUNRSUKWPWTUUCUUD $.
  $}

  ${
    pockthg.1 $e |- ( ph -> A e. NN ) $.
    pockthg.2 $e |- ( ph -> B e. NN ) $.
    pockthg.3 $e |- ( ph -> B < A ) $.
    pockthg.4 $e |- ( ph -> N = ( ( A x. B ) + 1 ) ) $.
    ${
      pockthlem.5 $e |- ( ph -> P e. Prime ) $.
      pockthlem.6 $e |- ( ph -> P || N ) $.
      pockthlem.7 $e |- ( ph -> Q e. Prime ) $.
      pockthlem.8 $e |- ( ph -> ( Q pCnt A ) e. NN ) $.
      pockthlem.9 $e |- ( ph -> C e. ZZ ) $.
      pockthlem.10 $e |- ( ph -> ( ( C ^ ( N - 1 ) ) mod N ) = 1 ) $.
      pockthlem.11 $e |- ( ph ->
                          ( ( ( C ^ ( ( N - 1 ) / Q ) ) - 1 ) gcd N ) = 1 ) $.
      $( Lemma for ~ pockthg .  (Contributed by Mario Carneiro, 2-Mar-2014.) $)
      pockthlem $p |- ( ph -> ( Q pCnt A ) <_ ( Q pCnt ( P - 1 ) ) ) $=
        ( c1 wcel cpc co cmin cle wbr cexp cdivides codz cdiv cz cprime cn cmul
        cfv wn pcdvds syl2anc nnzd dvdsmul1 caddc oveq1d cc wceq nnmulcld nncnd
        ax-1cn pncan sylancl eqtrd breqtrrd wa wi prmnn syl nnnn0d nnexpcld cuz
        nnuz syl6eleq eluzp1p1 eqeltrd eluzp1m1 sylancr syl6eleqr dvdstr mp2and
        1z syl3anc cc0 wne wb nnne0d dvdsval2 cgcd gcddvds simpld simprd gcdcld
        mpbid nn0zd clt c2 df-2 eluz2b2 sylib simpr necon3ai dvdslegcd syl31anc
        fveq2i cmo cn0 zexpcl modgcd gcdcom gcd1 3eqtr3d rpexp breqtrd syl21anc
        gcdn0cl nnle1eq1 odzcl cr 1mod eqtr4d moddvds peano2zm odzdvds divcan1d
        nnred nprmdvds1 iddvdsexp nn0ge0d nngt0d ge0div elnn0z sylanbrc breq2d
        a1i dvdsgcd mpan2d expm1d oveq2d nndivred recnd divassd 3eqtr2d 3imtr3d
        bitr4d mtod prmpwdvds syl222anc odzphi phiprm prmuz2 pcdvdsb mpbird
        cphi ) AFBUAUBZFESUCUBZUAUBUDUEZFUUTUFUBZUVAUGUEZAUVCDEUHUNUNZUGUEZUVEU
        VAUGUEZUVDAGSUCUBZUVCUIUBZUJTZUVEUJTZFUKTZUUTULTZUVEUVIUVCUMUBZUGUEUVEU
        VIFUUTSUCUBUFUBZUMUBZUGUEZUOUVFAUVCUVHUGUEZUVJAUVCBUGUEZBUVHUGUEZUVRAUV
        LBULTUVSNHFBUPUQABBCUMUBZUVHUGABUJTZCUJTBUWAUGUEABHURZACIURBCUSUQAUVHUW
        ASUTUBZSUCUBZUWAAGUWDSUCKVAAUWAVBTSVBTUWEUWAVCAUWAABCHIVDZVEVFUWASVGVHV
        IVJAUVCUJTZUWBUVHUJTZUVSUVTVKUVRVLAUVCAFUUTAUVLFULTNFVMVNZAUUTOVOZVPZUR
        ZUWCAUVHAUVHSVQUNZULASUJTZGSSUTUBZVQUNZTUVHUWMTWGAGUWDUWPKAUWAUWMTUWDUW
        PTAUWAULUWMUWFVRVSSUWAVTVNWAZSGWBWCVRWDZURZUVCBUVHWEWHWFZAUWGUVCWIWJUWH
        UVRUVJWKUWLAUVCUWKWLZUWSUVCUVHWMWHWSAUVEAEULTZDUJTZDEWNUBZSVCZUVEULTAEU
        KTZUXBLEVMVNZPAUXDSUDUEZUXEAUXDDGWNUBZSUDAUXDDUGUEZUXDGUGUEZUXDUXIUDUEZ
        AUXJUXDEUGUEZAUXCEUJTZUXJUXMVKPAEUXGURZDEWOUQZWPAUXMEGUGUEZUXKAUXJUXMUX
        PWQMAUXDUJTZUXNGUJTZUXMUXQVKUXKVLAUXDADEPUXOWRWTZUXOAGAGULTZSGXAUEZAGXB
        VQUNZTUYAUYBVKAGUWPUYCUWQXBUWOVQXCXJZWDGXDXEZWPZURZUXDEGWEWHWFAUXRUXCUX
        SDWIVCZGWIVCZVKZUOZUXJUXKVKUXLVLUXTPUYGAGWIWJUYKAGUYFWLUYJGWIUYHUYIXFXG
        VNUXDDGXHXIWFADUVHUFUBZGWNUBZSVCZUXISVCZAUYLGXKUBZGWNUBZSGWNUBZUYMSAUYP
        SGWNQVAAUYLUJTZUYAUYQUYMVCAUXCUVHXLTZUYSPAUVHUWRVOZDUVHXMUQZUYFUYLGXNUQ
        AUYRGSWNUBZSAUWNUXSUYRVUCVCWGUYGSGXOWCAUXSVUCSVCUYGGXPVNVIXQAUXCUXSUVHU
        LTUYNUYOWKPUYGUWRDGUVHXRWHWSXSAUXDULTZUXHUXEWKAUXCUXNUYHEWIVCZVKZUOZVUD
        PUXOAEWIWJVUGAEUXGWLVUFEWIUYHVUEXFXGVNDEYAXTUXDYBVNWSZDEYCWHURZNOAUVEUV
        HUVNUGAEUYLSUCUBZUGUEZUVEUVHUGUEZAUXQGVUJUGUEZVUKMAUYPSGXKUBZVCZVUMAUYP
        SVUNQAGYDTUYBVUNSVCAGUYFYKAUYAUYBUYEWQGYEUQYFAUYAUYSUWNVUOVUMWKUYFVUBUW
        NAWGYTUYLSGYGWHWSAUXNUXSVUJUJTZUXQVUMVKVUKVLUXOUYGAUYSVUPVUBUYLYHVNEGVU
        JWEWHWFAUXBUXCUXEUYTVUKVULWKUXGPVUHVUADUVHEYIXIWSAUVHUVCAUVHUWRVEAUVCUW
        KVEZUXAYJZVJAUVQESUGUEZAUXFVUSUOLEYLVNAEDUVHFUIUBZUFUBZSUCUBZUGUEZEVVBG
        WNUBZUGUEZUVQVUSAVVCUXQVVEMAUXNVVBUJTZUXSVVCUXQVKVVEVLUXOAVVAUJTZVVFAUX
        CVUTXLTZVVGPAVUTUJTZWIVUTUDUEZVVHAFUVHUGUEZVVIAFUVCUGUEZUVRVVKAFUJTZUVM
        VVLAFUWIURZOFUUTYMUQUWTAVVMUWGUWHVVLUVRVKVVKVLVVNUWLUWSFUVCUVHWEWHWFAVV
        MFWIWJUWHVVKVVIWKVVNAFUWIWLZUWSFUVHWMWHWSAWIUVHUDUEZVVJAUVHVUAYNAUVHYDT
        FYDTWIFXAUEVVPVVJWKAUVHUWRYKZAFUWIYKAFUWIYOUVHFYPWHWSVUTYQYRZDVUTXMUQVV
        AYHVNUYGEVVBGUUAWHUUBAVVCUVEVUTUGUEZUVQAUXBUXCUXEVVHVVCVVSWKUXGPVUHVVRD
        VUTEYIXIAUVPVUTUVEUGAUVPUVIUVCFUIUBZUMUBUVNFUIUBVUTAUVOVVTUVIUMAFUUTAFU
        WIVEZVVOAUUTOURUUCUUDAUVIUVCFAUVIAUVHUVCVVQUWKUUEUUFVUQVWAVVOUUGAUVNUVH
        FUIVURVAUUHYSUUJAVVDSEUGRYSUUIUUKUVEFUVIUUTUULUUMAUVEEUUSUNZUVAUGAUXBUX
        CUXEUVEVWBUGUEUXGPVUHDEUUNWHAUXFVWBUVAVCLEUUOVNXSAUWGUVKUVAUJTZUVFUVGVK
        UVDVLUWLVUIAUVAAUVAUWMULAUWNEUWPTUVAUWMTWGAEUYCUWPAUXFEUYCTLEUUPVNUYDVS
        SEWBWCVRWDURZUVCUVEUVAWEWHWFAUVLVWCUUTXLTUVBUVDWKNVWDUWJUUTFUVAUUQWHUUR
        $.
    $}

    $(
    pockthg @p |- ( ph -> ( N e. Prime <-> A. p e. Prime ( p || A -> E. x e. ZZ
                   ( ( ( x ^ ( N - 1 ) ) mod N ) = 1 /\
                     ( ( ( x ^ ( ( N - 1 ) / p ) ) - 1 ) gcd N ) = 1 ) ) ) ) @=
      ? @.
    $)

    $d p q x N $.  $d p x A $.  $d p q x ph $.
    pockthg.5 $e |- ( ph -> A. p e. Prime ( p || A -> E. x e. ZZ
                   ( ( ( x ^ ( N - 1 ) ) mod N ) = 1 /\
                     ( ( ( x ^ ( ( N - 1 ) / p ) ) - 1 ) gcd N ) = 1 ) ) ) $.
    $( The generalized Pocklington's theorem.  If ` N - 1 = A x. B ` where
       ` B < A ` , then ` N ` is prime if and only if for every prime factor
       ` p ` of ` A ` , there is an ` x ` such that
       ` x ^ ( N - 1 ) = 1 ( mod N ) ` and
       ` gcd ( x ^ ( ( N - 1 ) / p ) - 1 , N ) = 1 ` .  (Contributed by Mario
       Carneiro, 2-Mar-2014.) $)
    pockthg $p |- ( ph -> N e. Prime ) $=
      ( wcel co cle wbr cprime c1 cn wa adantr vq c2 cuz cv cexp cdivides wn wi
      cfv wral cmul caddc nnmulcld nnuz syl6eleq eluzp1p1 df-2 fveq2i syl6eleqr
      syl eqeltrd clt cr eluzelre nnred resqcld prmnn ad2antrl wb nngt0d ltmul2
      cc0 syl112anc mpbid nnltp1le syl2anc nncnd 3brtr4d cmin cpc cmo wceq cdiv
      sqvald cgcd cz wrex exp1d nnge1 ad2antll cn0 simprl nnzd ad2antrr pcdvdsb
      1nn0 a1i syl3anc eqbrtrrd simpl2l simpl2r simpl3l simpl3r simprrl simprrr
      w3a simpl1 pockthlem rexlimdvaa 3expa embantd expr id prmuz2 uz2m1nn pccl
      syl2anr nn0ge0d breq1 syl5ibrcom a1dd wo simpr pccld elnn0 sylib ralimdva
      mpjaod pc2dvds mpbird dvdsle nnnn0d nn0ltlem1 lt2sqd lelttrd ltnled con2d
      mpd ralrimiva isprm5 sylanbrc ) AEUBUCUIZLZUAUDZUBUEMZENOZUUDEUFOZUGUHZUA
      PUJEPLAECDUKMZQULMZUUBJAUUJQQULMZUCUIZUUBAUUIQUCUIZLUUJUULLAUUIRUUMACDGHU
      MZUNUOQUUIUPUTUBUUKUCUQURUSVAZAUUHUAPAUUDPLZSUUGUUFAUUPUUGUUFUGZAUUPUUGSZ
      SZEUUEVBOUUQUUSECUBUEMZUUEAEVCLZUURAUUCUVAUUOUBEVDUTTZAUUTVCLUURACACGVEZV
      FTUUSUUDUUSUUDUUPUUDRLAUUGUUDVGVHZVEZVFZAEUUTNOUURAUUJCCUKMZEUUTNAUUIUVGV
      BOZUUJUVGNOZADCVBOZUVHIADVCLCVCLZUVKVLCVBOUVJUVHVIADHVEUVCUVCACGVJDCCVKVM
      VNAUUIRLUVGRLUVHUVIVIUUNACCGGUMUUIUVGVOVPVNJACACGVQWDVRTUUSCUUDVBOZUUTUUE
      VBOUUSUVLCUUDQVSMZNOZUUSCUVMUFOZUVNUUSUVOFUDZCVTMZUVPUVMVTMZNOZFPUJZUUSUV
      PCUFOZBUDZEQVSMZUEMEWAMQWBZUWBUWCUVPWCMUEMQVSMEWEMQWBZSZBWFWGZUHZFPUJZUVT
      AUWIUURKTUUSUWHUVSFPUUSUVPPLZSZUVQRLZUWHUVSUHZUVQVLWBZUUSUWJUWLUWMUUSUWJU
      WLSZSZUWAUWGUVSUWPUVPQUEMZUVPCUFUWPUVPUWPUVPUWJUVPRLUUSUWLUVPVGVHVQWHUWPQ
      UVQNOZUWQCUFOZUWLUWRUUSUWJUVQWIWJUWPUWJCWFLZQWKLZUWRUWSVIUUSUWJUWLWLAUWTU
      URUWOACGWMZWNUXAUWPWPWQQUVPCWOWRVNWSAUURUWOUWGUVSUHAUURUWOXFZUWFUVSBWFUXC
      UWBWFLZUWFSZSZCDUWBUUDUVPEUXFACRLZAUURUWOUXEXGZGUTUXFADRLUXHHUTUXFAUVJUXH
      IUTUXFAEUUJWBUXHJUTUUPUUGAUWOUXEWTUUPUUGAUWOUXEXAUWJUWLAUURUXEXBUWJUWLAUU
      RUXEXCUXCUXDUWFWLUXCUXDUWDUWEXDUXCUXDUWDUWEXEXHXIXJXKXLUWKUWNUVSUWHUWKUVS
      UWNVLUVRNOUWKUVRUWJUWJUVMRLZUVRWKLUUSUWJXMUUPUXIAUUGUUPUUDUUBLUXIUUDXNUUD
      XOUTVHZUVPUVMXPXQXRUVQVLUVRNXSXTYAUWKUVQWKLUWLUWNYBUWKUVPCUUSUWJYCAUXGUUR
      UWJGWNYDUVQYEYFYHYGYRUUSUWTUVMWFLUVOUVTVIAUWTUURUXBTZUUSUVMUXJWMCUVMFYIVP
      YJUUSUWTUXIUVOUVNUHUXKUXJCUVMYKVPYRUUSCWKLZUUDWKLUVLUVNVIAUXLUURACGYLZTUU
      SUUDUVDYLZCUUDYMVPYJUUSCUUDAUVKUURUVCTUVEAVLCNOUURACUXMXRTUUSUUDUXNXRYNVN
      YOUUSEUUEUVBUVFYPVNXLYQYSUAEYTUUA $.
  $}

  ${
    $d x y D $.  $d x y E $.  $d x y N $.  $d x y P $.  $d y A $.
    pockthi.p $e |- P e. Prime $.
    pockthi.g $e |- G e. NN $.
    pockthi.m $e |- M = ( G x. P ) $.
    pockthi.n $e |- N = ( M + 1 ) $.
    pockthi.d $e |- D e. NN $.
    pockthi.e $e |- E e. NN $.
    pockthi.a $e |- A e. NN $.
    pockthi.fac $e |- M = ( D x. ( P ^ E ) ) $.
    pockthi.gt $e |- D < ( P ^ E ) $.
    pockthi.mod $e |- ( ( A ^ M ) mod N ) = ( 1 mod N ) $.
    pockthi.gcd $e |- ( ( ( A ^ G ) - 1 ) gcd N ) = 1 $.
    $( Pocklington's theorem, which gives a sufficient criterion for a number
       ` N ` to be prime.  This is the preferred method for verifying large
       primes, being much more efficient to compute than trial division.  This
       form has been optimized for application to specific large primes; see
       ~ pockthg for a more general closed-form version.  (Contributed by Mario
       Carneiro, 2-Mar-2014.) $)
    pockthi $p |- N e. Prime $=
      ( co c1 vy vx cn wcel cprime cexp cn0 prmnn ax-mp nnnn0i nnexpcl mp2an id
      a1i clt wbr cmul caddc wceq nncni mulcomi eqtri oveq1i cdivides cmin cdiv
      cv cgcd wa cz wrex wi wral wb prmdvdsexpb mp3an23 eqcomi nnmulcli eqeltri
      cmo peano2nn ax-1cn subadd2i mpbir oveq2i nnrei cc0 nngt0i ltaddpos2 mpbi
      cr breqtrri 1mod oveq2 3eqtrri subcli nnne0i divmuli syl6eq oveq2d oveq1d
      1re nnzi oveq1 eqeq1d anbi12d rspcev mpan sylancr syl6bi rgen pockthg ) B
      UCUDZGUEUDLXMUACDUFSZBGUBXNUCUDZXMCUCUDZDUGUDXOCUEUDZXPHCUHUIZDMUJCDUKULZ
      UNXMUMBXNUOUPXMPUNGXNBUQSZTURSZUSXMGFTURSZYAKFXTTURFBXNUQSXTOBXNBLUTXNXSU
      TVAVBVCVBUNUBVGZXNVDUPZUAVGZGTVESZUFSZGVTSZTUSZYEYFYCVFSZUFSZTVESZGVHSZTU
      SZVIZUAVJVKZVLZUBUEVMXMYQUBUEYCUEUDZYDYCCUSZYPYRXQDUCUDYDYSVNHMYCCDVOVPYS
      AYFUFSZGVTSZTUSZAYJUFSZTVESZGVHSZTUSZYPUUAAFUFSZGVTSZTYTUUGGVTYFFAUFYFFUS
      YBGUSGYBKVQGTFGGYBUCKFUCUDYBUCUDFECUQSZUCJECIXRVRVSZFWAUIVSZUTZWBFUUJUTWC
      WDZWEVCUUHTGVTSZTQGWKUDTGUOUPUUNTUSGUUKWFTYBGUOWGFUOUPZTYBUOUPZFUUJWHFWKU
      DTWKUDUUOUUPVNFUUJWFXBFTWIULWJKWLGWMULVBVBYSUUEAEUFSZTVESZGVHSTYSUUDUURGV
      HYSUUCUUQTVEYSYJEAUFYSYJYFCVFSZEYCCYFVFWNUUSEUSCEUQSZYFUSYFFUUIUUTUUMJECE
      IUTZCXRUTZVAWOYFCEGTUULWBWPUVBUVACXRWQWRWDWSWTXAXARWSAVJUDUUBUUFVIZYPANXC
      YOUVCUAAVJYEAUSZYIUUBYNUUFUVDYHUUATUVDYGYTGVTYEAYFUFXDXAXEUVDYMUUETUVDYLU
      UDGVHUVDYKUUCTVEYEAYJUFXDXAXAXEXFXGXHXIXJXKUNXLUI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Infinite primes theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d m n y A $.  $d m n y G $.
    unbenlem.1 $e |- G = ( rec ( ( x e. _V |-> ( x + 1 ) ) , 1 ) |` om ) $.
    $( Lemma for ~ unben .  (Contributed by NM, 5-May-2005.)  (Revised by Mario
       Carneiro, 15-Sep-2013.) $)
    unbenlem $p |-
        ( ( A C_ NN /\ A. m e. NN E. n e. A m < n ) -> A ~~ om ) $=
      ( vy cn clt wbr wrex wa com wcel wf1o c1 wceq wb wi syl cv wral ccnv cima
      wss cen cvv cres nnex ssex wf1 cuz cfv om2uzf1oi nnuz f1oeq3 ax-mp f1ocnv
      1z mpbir f1of1 mp2b f1ores f1oeng syl2anc adantr crn imassrn cdm dfdm4 wf
      mpan f1of fdmi eqtr3i sseqtri om2uzuzi syl6eleqr breq1 rexbidv rspcv wfun
      f1ofun funcnvres2 f1oeq1 sylib wfo f1ofo forn eleq2d f1ofn fvelrnb bitr3d
      wfn biimpa fvres eqeq1d adantll om2uzlt2i sylan2 sylan9bb syldan biimparc
      sseli breq2 exp44 imp31 reximdva syl5 exp4b com4l imp rexlimdv syld com3l
      ex ralrimiv unbnn3 sylancr entr ) BHUEZCUAZDUAZIJZDBKZCHUBZLZBEUCZBUDZUFJ
      ZYIMUFJZBMUFJYAYJYFYABUGNBYIYHBUHZOZYJBHUIUJHMYHUKZYAYMMHEOZHMYHOYNYOMPUL
      UMZEOZAPEUSFUNHYPQYOYQRUOHYPMEUPUQUTZMHEURHMYHVAVBHMBYHVCVLZBYIUGYLVDVEVF
      YGYIMUEGUAZYBNZCYIKZGMUBYKYIYHVGZMYHBVHEVIUUCMEVJMHEYOMHEVKYRMHEVMUQVNVOV
      PZYGUUBGMYAYFYTMNZUUBSUUEYAYFUUBUUEYAYFUUBSUUEYALZYFYTEUMZYCIJZDBKZUUBUUE
      YFUUISZYAUUEUUGHNUUJUUEUUGYPHAYTPEUSFVQUOVRYEUUICUUGHYBUUGQYDUUHDBYBUUGYC
      IVSVTWATVFUUFUUHUUBDBUUEYAYCBNZUUHUUBSSUUHUUEYAUUKUUBUUHUUEYAUUKUUBYAUUKL
      YBEYIUHZUMZYCQZCYIKZUUHUUELZUUBYAUUKUUOYAYIBUULOZUUKUUORYAYIBYLUCZOZUUQYA
      YMUUSYSBYIYLURTEWBZUURUULQUUSUUQRYOUUTYRMHEWCUQBEWDYIBUURUULWEVBWFUUQYCUU
      LVGZNZUUKUUOUUQUVABYCUUQYIBUULWGUVABQYIBUULWHYIBUULWITWJUUQUULYIWNUVBUUOR
      YIBUULWKCYIYCUULWLTWMTWOUUPUUNUUACYIUUHUUEYBYINZUUNUUASUUHUUEUVCUUNUUAUUE
      UVCLZUUNLUUAUUHUVDUUNYBEUMZYCQZUUAUUHRUVCUUNUVFUUEUVCUUNUVFUVCUUMUVEYCYBY
      IEWPWQWOWRUVDUUAUUGUVEIJZUVFUUHUVCUUEYBMNUUAUVGRYIMYBUUDXDAYTYBPEUSFWSWTU
      VEYCUUGIXEXAXBXCXFXGXHXIXJXKXLXMXNXPXOXLXQGCYIXRXSBYIMXTVE $.
  $}

  ${
    $d m n x y A $.
    $( An unbounded set of natural numbers is infinite.  (Contributed by NM,
       5-May-2005.)  (Revised by Mario Carneiro, 15-Sep-2013.) $)
    unben $p |- ( ( A C_ NN /\ A. m e. NN E. n e. A m < n ) -> A ~~ NN ) $=
      ( vx cn wss cv clt wbr wrex wral wa com cen cvv c1 caddc co cmpt crdg
      cres eqid unbenlem nnenom ensymi entr sylancl ) AEFBGCGHICAJBEKLAMNIMENIA
      ENIDABCDODGPQRSPTMUAZUHUBUCEMUDUEAMEUFUG $.
  $}

  ${
    $d j k N $.  $d j M $.  $d j k K $.
    infpnlem.1 $e |- K = ( ( ! ` N ) + 1 ) $.
    $( Lemma for ~ infpn .  The smallest divisor (greater than 1) ` M ` of
       ` N ! + 1 ` is a prime greater than ` N ` .  (Contributed by NM,
       5-May-2005.) $)
    infpnlem1 $p |- ( ( N e. NN /\ M e. NN ) ->
                        ( ( ( 1 < M /\ ( K / M ) e. NN ) /\
                  A. j e. NN ( ( 1 < j /\ ( K / j ) e. NN ) -> M <_ j ) ) ->
       ( N < M /\ A. j e. NN ( ( M / j ) e. NN -> ( j = 1 \/ j = M ) ) ) ) ) $=
      ( cn wcel wa c1 clt wbr cdiv co cle wi wral wceq wb cr nnre cv wo syl2anr
      wn lenlt adantr cn0 nnnn0 cfa cfv caddc facndiv oveq1i nnz syl5eqelr nsyl
      cz sylanl1 expr sylbird con4d expimpd adantrd cc faccl peano2nnd syl5eqel
      w3a syl nncnd nndivtr ex 3com13 3expa adantrl letri3 syl2an biimprd exp4b
      com3l imp32 adantll imim2d com23 sylan2d exp4d com24 exp32 imp31 ralimdva
      com14 3imp adantld imp3a prime adantl sylibrd jcad ) DFGZCFGZHZICJKZBCLMZ
      FGZHZIAUAZJKZBXFLMFGZHZCXFNKZOZAFPZHZDCJKZCXFLMFGZXFIQXFCQZUBOAFPZXAXEXNX
      LXAXBXDXNXAXBHZXNXDXRXNUDZCDNKZXDUDZXAXTXSRZXBWTCSGZDSGYBWSCTZDTCDUEUCUFX
      AXBXTYAWSDUGGZWTXBXTHZYADUHZYEWTHYFHDUIUJZIUKMZCLMZUQGXDDCULXDYJXCUQBYICL
      EUMXCUNUOUPURUSUTVAVBVCXAXMXGXFCNKZXOVHZXPOZAFPZXQXAXEXLYNXAXDXLYNOZXBXAX
      DYOXAXDHZXKYMAFYLYPXFFGZHZXKXPXGYKXOYRXKXPOZOYRYKXOXGYSXAXDYQYKXOXGYSOOZO
      XAYKYQXDYTXAYKYQXDYTOXAYKYQHZHZXGXOXDYSUUBXGXOXDYSUUBXOXDHZXHXGYSXAYQUUCX
      HOZYKWSBVDGZWTYQUUDWSBWSBYIFEWSYHWSYEYHFGYGDVEVIVFVGVJUUEWTYQUUDYQWTUUEUU
      DYQWTUUEVHUUCXHXFCBVKVLVMVNURVOUUBXKXIXPUUBXJXPXIWTUUAXJXPOZWSWTYKYQUUFYQ
      WTYKUUFYQWTYKXJXPYQWTHXPYKXJHZYQXFSGYCXPUUGRWTXFTYDXFCVPVQVRVSVTWAWBWCWDW
      EWFWGWHWGWIWKWLVTWJVLWMWNWTXQYNRWSACWOWPWQWR $.

    $( Lemma for ~ infpn .  For any natural number ` N ` , there exists a prime
       number ` j ` greater than ` N ` .  (Contributed by NM, 5-May-2005.) $)
    infpnlem2 $p |- ( N e. NN -> E. j e. NN ( N < j /\
                    A. k e. NN ( ( j / k ) e. NN -> ( k = 1 \/ k = j ) ) ) ) $=
      ( cn wcel c1 cv clt wbr cdiv co wa cle wi wral wrex wceq syl wo cfa caddc
      cfv cn0 nnnn0 peano2nnd syl5eqel nnge1d wb 1nn nnleltp1 sylancr syl6breqr
      faccl mpbid cc0 wne nncn nnne0 jca divid 3syl syl6eqel breq2 oveq2 eleq1d
      cc anbi12d rspcev syl12anc nnwos infpnlem1 reximdva mpd ) DFGZHAIZJKZCVQL
      MZFGZNZHBIZJKZCWBLMZFGZNZVQWBOKPBFQNZAFRZDVQJKVQWBLMFGWBHSWBVQSUAPBFQNZAF
      RVPWAAFRZWHVPCFGZHCJKZCCLMZFGZWJVPCDUBUDZHUCMZFEVPWOVPDUEGWOFGZDUFDUOTZUG
      UHZVPHWPCJVPHWOOKZHWPJKZVPWOWRUIVPHFGWQWTXAUJUKWRHWOULUMUPEUNVPWMHFVPWKCV
      HGZCUQURZNWMHSWSWKXBXCCUSCUTVACVBVCUKVDWAWLWNNACFVQCSZVRWLVTWNVQCHJVEXDVS
      WMFVQCCLVFVGVIVJVKWAWFABVQWBSZVRWCVTWEVQWBHJVEXEVSWDFVQWBCLVFVGVIVLTVPWGW
      IAFBCVQDEVMVNVO $.
  $}

  ${
    $d j k N $.
    $( There exist infinitely many prime numbers: for any natural number
       ` N ` , there exists a prime number ` j ` greater than ` N ` .  (See
       ~ infpn2 for the equinumerosity version.)  (Contributed by NM,
       1-Jun-2006.) $)
    infpn $p |- ( N e. NN -> E. j e. NN ( N < j /\
                    A. k e. NN ( ( j / k ) e. NN -> ( k = 1 \/ k = j ) ) ) ) $=
      ( cfa cfv c1 caddc co eqid infpnlem2 ) ABCDEFGHZCKIJ $.
  $}

  ${
    $d j k n m A $.  $d j k S $.
    infpn2.1 $e |- S = { n e. NN | ( 1 < n /\
                A. m e. NN ( ( n / m ) e. NN -> ( m = 1 \/ m = n ) ) ) } $.
    $( There exist infinitely many prime numbers: the set of all primes ` S `
       is unbounded by ~ infpn , so by ~ unben it is infinite.  (Contributed by
       NM, 5-May-2005.) $)
    infpn2 $p |- S ~~ NN $=
      ( vj vk cn cv clt wbr wrex wral c1 cdiv co wcel weq wi wa cr wss cen wceq
      wo crab ssrab2 eqsstri infpn nnge1 adantr nnre lelttr mp3an1 syl2an mpand
      cle 1re ancld anim1d anass syl6ib reximdva mpd breq2 oveq1 eleq1d equequ2
      orbi2d imbi12d ralbidv anbi12d elrab2 anbi1i anbi2i 3bitri rexbii2 sylibr
      ancom rgen unben mp2an ) AGUAEHZFHZIJZFAKZEGLAGUBJAMCHZIJZWFBHZNOZGPZWHMU
      CZBCQZUDZRZBGLZSZCGUEGDWPCGUFUGWEEGWBGPZWDMWCIJZWCWHNOZGPZWKBFQZUDZRZBGLZ
      SZSZFGKZWEWQWDXDSZFGKXGFBWBUHWQXHXFFGWQWCGPZSZXHWDWRSZXDSXFXJWDXKXDXJWDWR
      XJMWBUPJZWDWRWQXLXIWBUIUJWQWBTPZWCTPZXLWDSWRRZXIWBUKWCUKMTPXMXNXOUQMWBWCU
      LUMUNUOURUSWDWRXDUTVAVBVCWDXFFAGWCAPZWDSXIXESZWDSXIXEWDSZSXIXFSXPXQWDWPXE
      CWCGACFQZWGWRWOXDWFWCMIVDXSWNXCBGXSWJWTWMXBXSWIWSGWFWCWHNVEVFXSWLXAWKCFBV
      GVHVIVJVKDVLVMXIXEWDUTXRXFXIXEWDVRVNVOVPVQVSAEFVTWA $.
  $}

  ${
    $d N p $.
    $( The primes are unbounded.  (Contributed by Paul Chapman,
       28-Nov-2012.) $)
    prmunb $p |- ( N e. NN -> E. p e. Prime N < p ) $=
      ( cn wcel cn0 clt wbr cprime wrex cfv c1 caddc co cdivides c2 cuz 3syl wa
      wn cz cv nnnn0 faccl elnnuz eluzp1p1 df-2 fveq2i syl6eleqr sylbi exprmfct
      cfa wi wb prmz nn0z eluz syl2an prmuz2 eluz2b2 sylib adantr simpld nnnn0d
      cle eluznn0 sylancom nnz simprd dvdsfac w3a ndvdsp1 imp syl31anc ex con2d
      sylbird ancoms cr nn0re zred ltnle sylibrd reximdva mpd syl ) ACDAEDZABUA
      ZFGZBHIZAUBWFWGAUKJZKLMZNGZBHIZWIWFWJCDZWKOPJZDZWMAUCZWNWJKPJDZWPWJUDWRWK
      KKLMZPJWOKWJUEOWSPUFUGUHUIWKBUJQWFWLWHBHWFWGHDZRWLWGAVDGZSZWHWTWFWLXBULWT
      WFRZXAWLXCXAAWGPJDZWLSZWTWGTDATDXDXAUMWFWGUNZAUOWGAUPUQWTXDXEULWFWTXDXEWT
      XDRZWJTDZWGCDZKWGFGZWGWJNGZXEXGWFWNXHWTXDWGEDWFXGWGXGXIXJWTXIXJRZXDWTWGWO
      DXLWGURWGUSUTVAZVBZVCAWGVEVFWQWJVGQXNXGXIXJXMVHWTXDXIXKXNWGAVIVFXHXIXJVJX
      KXEWGWJVKVLVMVNVAVPVOVQWFAVRDWGVRDWHXBUMWTAVSWTWGXFVTAWGWAUQWBWCWDWE $.
  $}

  ${
    $d n p $.
    $( There are an infinite number of primes.  (Contributed by Paul Chapman,
       28-Nov-2012.) $)
    prminf $p |- Prime ~~ NN $=
      ( vn vp cprime cn wss clt wbr wrex wral cen prmnn ssriv prmunb rgen unben
      cv mp2an ) CDEAPZBPZFGBCHZADICDJGBCDSKLTADRBMNCABOQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Sum of prime reciprocals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d r x K $.  $d n r x z N $.  $d r x z Q $.
    prmreclem1.1 $e |- Q = ( n e. NN |->
      sup ( { r e. NN | ( r ^ 2 ) || n } , RR , < ) ) $.
    $( Lemma for ~ prmrec .  Properties of the "square part" function, which
       extracts the ` m ` of the decomposition ` N = r m ^ 2 ` , with ` m `
       maximal and ` r ` squarefree.  (Contributed by Mario Carneiro,
       5-Aug-2014.) $)
    prmreclem1 $p |- ( N e. NN -> ( ( Q ` N ) e. NN /\
      ( ( Q ` N ) ^ 2 ) || N /\
      ( K e. ( ZZ>= ` 2 ) -> -. ( K ^ 2 ) || ( N / ( ( Q ` N ) ^ 2 ) ) ) ) ) $=
      ( vz cn wcel c2 cexp co cdivides wbr cr clt wceq cz cle c1 vx cfv cdiv wn
      cuz wi cv crab ssrab2 csup breq2 rabbidv supeq1d ltso supex fvmpt wss wne
      wral wrex nnssz sstri a1i 1nn nnz 1dvds syl oveq1 sq1 syl6eq breq1d elrab
      c0 sylanbrc ne0i wa dvdsle syl2anr nnlesq adantl nnre resqcld adantr letr
      zsqcl syl3anc mpand syld ralrimiva ralrab sylibr ralbidv syl2anc suprzcl2
      id rspcev eqeltrd sseldi cbvrabv elrab2 sylib simprd cmul mulid1d eluz2b2
      nncnd simprbi cc0 wb simplbi nnred nngt0d ltmul2 syl112anc mpbid eqbrtrrd
      1re nnmulcl syl2an ltnled ad2antrr simpr nnsqcld nnne0d dvdsval2 dvdscmul
      mpd cc sqmuld eqcomd nncn divcan2d 3brtr3d suprzub breqtrrd mtand ex 3jca
      ) DHIZDAUBZHIZYTJKLZDMNZCJUEUBIZCJKLZDUUBUCLZMNZUDZUFYSEUGZJKLZDMNZEHUHZH
      YTUUKEHUIZYSYTUULOPUJZUULBDUUJBUGZMNZEHUHZOPUJUUNHAUUODQZOUUQUULPUURUUPUU
      KEHUUODUUJMUKULUMFOUULPUNUOUPZYSUULRUQZUULVMURZGUGZUAUGZSNZGUULUSZUARUTZU
      UNUULIUUTYSUULHRUUMVAVBZVCYSTUULIZUVAYSTHIZTDMNZUVHUVIYSVDVCYSDRIZUVJDVEZ
      DVFVGUUKUVJETHUUITQZUUJTDMUVMUUJTJKLTUUITJKVHVIVJVKVLVNUULTVOVGYSUVKUVBDS
      NZGUULUSZUVFUVLYSUVBJKLZDMNZUVNUFZGHUSUVOYSUVRGHYSUVBHIZVPZUVQUVPDSNZUVNU
      VSUVPRIZYSUVQUWAUFYSUVSUVBRIUWBUVBVEUVBWEVGYSWOUVPDVQVRUVTUVBUVPSNZUWAUVN
      UVSUWCYSUVBVSVTUVTUVBOIZUVPOIDOIZUWCUWAVPUVNUFUVSUWDYSUVBWAVTZUVTUVBUWFWB
      YSUWEUVSDWAWCUVBUVPDWDWFWGWHWIUUKUVQUVNGEHUUIUVBQUUJUVPDMUUIUVBJKVHVKZWJW
      KUVEUVOUADRUVCDQUVDUVNGUULUVCDUVBSUKWLWPWMZUAGUULWNWFWQZWRZYSUUAUUCYSYTUU
      LIUUAUUCVPUWIUVQUUCGYTHUULUVBYTQUVPUUBDMUVBYTJKVHVKUUKUVQEGHUWGWSWTXAXBZY
      SUUDUUHYSUUDVPZUUGYTCXCLZYTSNZUWLYTUWMPNUWNUDUWLYTTXCLZYTUWMPUWLYTUWLYTYS
      UUAUUDUWJWCZXFZXDUWLTCPNZUWOUWMPNZUUDUWRYSUUDCHIZUWRCXEZXGVTUWLTOIZCOIYTO
      IXHYTPNUWRUWSXIUXBUWLXQVCUWLCUUDUWTYSUUDUWTUWRUXAXJZVTZXKUWLYTUWPXKZUWLYT
      UWPXLTCYTXMXNXOXPUWLYTUWMUXEUWLUWMYSUUAUWTUWMHIZUUDUWJUXCYTCXRXSZXKXTXOUW
      LUUGVPZUWMUUNYTSUXHUUTUVFUWMUULIZUWMUUNSNUUTUXHUVGVCYSUVFUUDUUGUWHYAUXHUX
      FUWMJKLZDMNZUXIUWLUXFUUGUXGWCUXHUUBUUEXCLZUUBUUFXCLZUXJDMUXHUUGUXLUXMMNZU
      WLUUGYBUXHUUERIZUUFRIZUUBRIZUUGUXNUFUXHUUEHIUXOUXHCUWLUWTUUGUXDWCZYCUUEVE
      VGYSUXPUUDUUGYSUUCUXPUWKYSUXQUUBXHURZUVKUUCUXPXIYSHRUUBVAYSYTUWJYCZWRZYSU
      UBUXTYDZUVLUUBDYEWFXOYAYSUXQUUDUUGUYAYAUUBUUEUUFYFWFYGUXHUXJUXLUXHYTCUWLY
      TYHIUUGUWQWCUXHCUXRXFYIYJUXHDUUBYSDYHIUUDUUGDYKYAUXHUUBYSUUBHIUUDUUGUXTYA
      XFYSUXSUUDUUGUYBYAYLYMUUKUXKEUWMHUUIUWMQUUJUXJDMUUIUWMJKVHVKVLVNUAGUULUWM
      YNWFYSYTUUNQUUDUUGUUSYAYOYPYQYR $.
  $}

  ${
    $d j k m n p r w x y z F $.  $d j k n p q x y z K $.  $d k n p q x y z M $.
    $d r A $.  $d j k n p q x y z ph $.  $d n p r x y z Q $.  $d j k q x W $.
    $d j k n p q x y z N $.
    prmrec.1 $e |- F = ( n e. NN |-> if ( n e. Prime , ( 1 / n ) , 0 ) ) $.
    ${
      prmrec.2 $e |- ( ph -> K e. NN ) $.
      prmrec.3 $e |- ( ph -> N e. NN ) $.
      prmrec.4 $e |- M = { n e. ( 1 ... N ) |
        A. p e. ( Prime \ ( 1 ... K ) ) -. p || n } $.
      ${
        prmreclem2.5 $e |- Q = ( n e. NN |->
          sup ( { r e. NN | ( r ^ 2 ) || n } , RR , < ) ) $.
        $( Lemma for ~ prmrec .  There are at most ` 2 ^ K ` squarefree numbers
           which divide no primes larger than ` K ` .  (We could strengthen
           this to ` 2 ^ # ( Prime i^i ( 1 ... K ) ) ` but there's no reason
           to.)  We establish the inequality by showing that the prime counts
           of the number up to ` K ` completely determine it because all higher
           prime counts are zero, and they are all at most ` 1 ` because no
           square divides the number, so there are at most ` 2 ^ K `
           possibilities.  (Contributed by Mario Carneiro, 5-Aug-2014.) $)
        prmreclem2 $p |- ( ph ->
          ( # ` { x e. M | ( Q ` x ) = 1 } ) <_ ( 2 ^ K ) ) $=
          ( c1 cc0 co wcel cprime vy vz cv cfv wceq crab chash cpr cmap c2 cexp
          cfz cle wbr cdom cvv ovex cpc cif cmpt wa fveq2 eqeq1d elrab wf caddc
          weq clt wn cdiv cdivides cuz cdif wral ssrab2 eqsstri simprl ad2antrr
          cn sseldi elfznn simpr prmuz2 wi prmreclem1 simp3d sylc simprr oveq1d
          syl sq1 syl6eq oveq2d eqtrd cz cn0 wb a1i bitr4d cr sylancl mpbird 1z
          syl6eleq 1e0p1 c0ex eqid syl5bi wfn ifex fnmpti mp2an oveq1 ifbieq12d
          ex fvmpt eqeq12d ralbiia bitri cin breq2 notbid ralbidv simprbi pceq0
          elrab2 syl2anr cun inundif raleqi ralunb bitr3i iffalse iftrue nnnn0d
          cfn wss ssfi sylancr cc nncnd div1d breq2d nnzd pcdvdsb syl3anc mtbid
          2nn0 pccld nn0red 2re ltnle df-2 syl6breq nn0zd zleltp1 nn0uz 0z fzpr
          elfz5 ax-mp oveq2i preq2i prid1 ifclda fmptd prex elmap sylibr eqfnfv
          3eqtr4i anbi12i eleq1 eqidd simprll simprrl r19.26 eldifi ssriv sstri
          anbi12d syl6bir ralimdva syl5bir mp2and biantrud uneq1i eldifn eqtr4d
          eqtr3 incom eqtri rgen biantru inss1 sseli 3bitr4g pc11 syl2anc dom2d
          syl5bb mpi fzfi eqeltri prfi fzfid hashdom hashmap wne ax-1ne0 necomi
          mapfi 0cn ax-1cn hashprg mpbi hashfz1 oveq12d breqtrd ) ABUCZCUDZPUEZ
          BGUFZUGUDZQPUHZPFULRZUIRZUGUDZUJFUKRZUMAUYDUYHUMUNZUYCUYGUOUNZAUYGUPS
          UYKUYEUYFUIUQAUAUBUYCUYGDUYFDUCZTSZUYLUAUCZURRZQUSZUTZDUYFUYMUYLUBUCZ
          URRZQUSZUTZUPUYNUYCSZUYNGSZUYNCUDZPUEZVAZAUYQUYGSZUYBVUEBUYNGBUAVGUYA
          VUDPUXTUYNCVBVCVDZAVUFVUGAVUFVAZUYFUYEUYQVEVUGVUIDUYFUYPUYEUYQVUIUYLU
          YFSZVAZUYMUYOQUYEVUKUYMVAZUYOQPULRZUYEVULUYOVUMSZUYOPUMUNZVULVUOUYOPP
          VFRZVHUNZVULUYOUJVUPVHVULUYOUJVHUNZUJUYOUMUNZVIZVULUYLUJUKRZUYNVUDUJU
          KRZVJRZVKUNZVUSVULUYNVSSZUYLUJVLUDSZVVDVIZVULUYNPHULRZSZVVEVULGVVHUYN
          GJUCZUYLVKUNZVIZJTUYFVMZVNZDVVHUFZVVHNVVNDVVHVOZVPZVUIVUCVUJUYMAVUCVU
          EVQVRVTUYNHWAZWJZVULUYMVVFVUKUYMWBZUYLWCWJVVEVUDVSSVVBUYNVKUNVVFVVGWD
          CDUYLUYNIOWEWFWGVULVVDVVAUYNVKUNZVUSVULVVCUYNVVAVKVULVVCUYNPVJRUYNVUL
          VVBPUYNVJVULVVBPUJUKRPVULVUDPUJUKVUIVUEVUJUYMAVUCVUEWHVRWIWKWLWMVULUY
          NVULUYNVVSUUAUUBWNUUCVULUYMUYNWOSUJWPSZVUSVWAWQVVTVULUYNVVSUUDVWBVULU
          UHWRUJUYLUYNUUEUUFWSUUGVULUYOWTSUJWTSVURVUTWQVULUYOVULUYLUYNVVTVVSUUI
          ZUUJUUKUYOUJUULXAXBUUMUUNVULUYOWOSPWOSZVUOVUQWQVULUYOVWCUUOXCUYOPUUPX
          AXBVULUYOQVLUDZSVWDVUNVUOWQVULUYOWPVWEVWCUUQXDXCUYOQPUUTXAXBQQPVFRZUL
          RZQVWFUHZVUMUYEQWOSVWGVWHUEUURQUUSUVAPVWFQULXEUVBPVWFQXEUVCUVKXDQUYES
          VUKUYMVIVAQPXFUVDWRUVEUYQXGZUVFUYEUYFUYQQPUVGPFULUQUVHUVIXOXHVUBUYRUY
          CSZVAVUFUYRGSZUYRCUDZPUEZVAZVAZAUYQVUAUEZUAUBVGZWQZVUBVUFVWJVWNVUHUYB
          VWMBUYRGBUBVGUYAVWLPUXTUYRCVBVCVDUVLAVWOVWRVWPVVJTSZVVJUYNURRZQUSZVWS
          VVJUYRURRZQUSZUEZJUYFVNZAVWOVAZVWQVWPVVJUYQUDZVVJVUAUDZUEZJUYFVNZVXEU
          YQUYFXIVUAUYFXIVWPVXJWQDUYFUYPUYQUYMUYOQUYLUYNURUQXFXJVWIXKDUYFUYTVUA
          UYMUYSQUYLUYRURUQXFXJVUAXGZXKJUYFUYQVUAUVJXLVXIVXDJUYFVVJUYFSVXGVXAVX
          HVXCDVVJUYPVXAUYFUYQDJVGZUYMVWSUYOQVWTQUYLVVJTUVMZUYLVVJUYNURXMVXLQUV
          NZXNVWIVWSVWTQVVJUYNURUQXFXJXPDVVJUYTVXCUYFVUAVXLUYMVWSUYSQVXBQVXMUYL
          VVJUYRURXMVXNXNVXKVWSVXBQVVJUYRURUQXFXJXPXQXRXSVXFVXEVWTVXBUEZJTVNZVW
          QVXFVXOJTUYFXTZVNZVXRVXOJVVMVNZVAZVXEVXPVXFVXSVXRVXFVVJUYNVKUNZVIZJVV
          MVNZVVJUYRVKUNZVIZJVVMVNZVXSVXFVUCVYCAVUCVUEVWNUVOZVUCVVIVYCVVNVYCDUY
          NVVHGDUAVGZVVLVYBJVVMVYHVVKVYAUYLUYNVVJVKYAYBYCNYFYDWJVXFVWKVYFAVUFVW
          KVWMUVPZVWKUYRVVHSVYFVVNVYFDUYRVVHGDUBVGZVVLVYEJVVMVYJVVKVYDUYLUYRVVJ
          VKYAYBYCNYFYDWJVYCVYFVAVYBVYEVAZJVVMVNVXFVXSVYBVYEJVVMUVQVXFVYKVXOJVV
          MVXFVVJVVMSZVAZVYKVWTQUEZVXBQUEZVAVXOVYMVYNVYBVYOVYEVYLVWSVVEVYNVYBWQ
          VXFVVJTUYFUVRZVXFGVSUYNGVVHVSVVQUAVVHVSVVRUVSUVTZVYGVTZVVJUYNYEYGVYLV
          WSUYRVSSVYOVYEWQVXFVYPVXFGVSUYRVYQVYIVTZVVJUYRYEYGUWAVWTVXBQUWJUWBUWC
          UWDUWEUWFVXEVXDJVXQVNZVXDJUYFTVMZVNZVAZVXRVXEVXDJVXQWUAYHZVNWUCVXDJWU
          DUYFWUDUYFTXTZWUAYHUYFVXQWUEWUATUYFUWKUWGUYFTYIUWLYJVXDJVXQWUAYKYLWUC
          VYTVXRWUBVYTVXDJWUAVVJWUASVWSVIZVXDVVJUYFTUWHWUFVXAQVXCVWSVWTQYMVWSVX
          BQYMUWIWJUWMUWNVXDVXOJVXQVVJVXQSVWSVXDVXOWQVXQTVVJTUYFUWOUWPVWSVXAVWT
          VXCVXBVWSVWTQYNVWSVXBQYNXQWJXRYLXSVXPVXOJVXQVVMYHZVNVXTVXOJWUGTTUYFYI
          YJVXOJVXQVVMYKYLUWQVXFUYNWPSUYRWPSVWQVXPWQVXFUYNVYRYOVXFUYRVYSYOUYNUY
          RJUWRUWSWSUXAXOXHUWTUXBAUYCYPSZUYGYPSZUYJUYKWQGYPSUYCGYQWUHGVVOYPNVVH
          YPSVVOVVHYQVVOYPSPHUXCVVPVVHVVOYRXLUXDUYBBGVOGUYCYRXLAUYEYPSZUYFYPSZW
          UIQPUXEZAPFUXFZUYEUYFUXLYSUYCUYGYPUXGYSXBAUYHUYEUGUDZUYFUGUDZUKRZUYIA
          WUJWUKUYHWUPUEWULWUMUYEUYFUXHYSAWUNUJWUOFUKWUNUJUEZAQPUXIZWUQPQUXJUXK
          QYTSPYTSWURWUQWQUXMUXNQPYTUXOXLUXPWRAFWPSWUOFUEAFLYOFUXQWJUXRWNUXS $.

        $( Lemma for ~ prmrec .  The main inequality established here is
           ` # M <_ # { x e. M | ( Q `` x ) = 1 } x. sqr N ` , where
           ` { x e. M | ( Q `` x ) = 1 } ` is the set of squarefree numbers in
           ` M ` .  This is demonstrated by the map
           ` y |-> <. y / ( Q `` y ) ^ 2 , ( Q `` y ) >. ` where ` Q `` y ` is
           the largest number whose square divides ` y ` .  (Contributed by
           Mario Carneiro, 5-Aug-2014.) $)
        prmreclem3 $p |- ( ph -> ( # ` M ) <_ ( ( 2 ^ K ) x. ( sqr ` N ) ) ) $=
          ( c2 co wcel cdivides wbr cle vx vy vz cA chash cfv cexp csqr cmul cr
          cfl cfn cn0 c1 cfz wss fzfi cprime cdif wral crab ssrab2 eqsstri ssfi
          cv wn mp2an hashcl ax-mp nn0rei a1i cn 2nn nnnn0d nnexpcl sylancr cc0
          wa nnrpd rpsqrcld rprege0d flge0nn0 nn0mulcld nn0red nnred rpred wceq
          syl remulcld remulcl cxp cdom xpfi cop cz clt simpr sseldi elfznn cuz
          cdiv wi prmreclem1 simp2d wne wb simp1d nnsqcld nnzd dvdsval2 syl3anc
          nnne0d mpbid nnre nngt0 syl2an syl2anc sylanbrc adantr nncnd divcan1d
          jca breqtrd dvdsle mpd letrd nnuz syl6eleq elfz5 mpbird breq2 ralbidv
          weq notbid elrab2 sylib fveq2 crp rprege0 ex divgt0 elnnz simprd prmz
          dvdsmul1 elfzle2 eldifi adantl dvdstr mpan2d ralimdva wo elnn1uz2 ord
          con3d simp3d mt4d eqeq1d elrab recnd sqsqrd breqtrrd le2sq flge nn0zd
          sylsyld opelxpi ovex fvex opth oveq1 oveq12 sylbi adantrr ssriv sstri
          sylan2 simprr eqeq12d syl5ib oveq1d oveq12d opeq12d impbid1 dom2d mpi
          id hashdom sylibr hashxp hashfz1 oveq2d syl5eq nn0ge0d lemul1ad caddc
          prmreclem2 fllelt simpld lemul2a syl31anc ) AFUEUFZOEUGPZGUHUFZUKUFZU
          IPZUXCUXDUIPZUXBUJQAUXBFULQZUXBUMQUNGUOPZULQFUXIUPUXHUNGUQFIVEZCVEZRS
          ZVFZIURUNEUOPZUSZUTZCUXIVAUXIMUXPCUXIVBVCZUXIFVDVGZFVHVIVJVKZAUXFAUXC
          UXEAUXCAOVLQEUMQUXCVLQVMAEKVNOEVOVPZVNAUXDUJQZVQUXDTSVRZUXEUMQZAUXDAG
          AGLVSVTZWAUXDWBWHZWCWDZAUXCUXDAUXCUXTWEZAUXDUYDWFZWIAUXBUAVEZBUFZUNWG
          ZUAFVAZUEUFZUXEUIPZUXFUXSAUYMUJQZUXEUJQZUYNUJQUYMUYLULQZUYMUMQUXHUYLF
          UPUYQUXRUYKUAFVBFUYLVDVGZUYLVHVIVJZAUXEUYEWDZUYMUXEWJVPUYFAUXBUYLUNUX
          EUOPZWKZUEUFZUYNTAFVUBWLSZUXBVUCTSZAVUBULQZVUDUYQVUAULQZVUFUYRUNUXEUQ
          ZUYLVUAWMVGZAUBUCFVUBUBVEZVUJBUFZOUGPZXAPZVUKWNZUCVEZVUOBUFZOUGPZXAPZ
          VUPWNZULAVUJFQZVUNVUBQZAVUTVRZVUMUYLQZVUKVUAQZVVAVVBVUMFQZVUMBUFZUNWG
          ZVVCVVBVUMUXIQZUXJVUMRSZVFZIUXOUTZVVEVVBVVHVUMGTSZVVBVUMVUJGVVBVUMVVB
          VUMWOQZVQVUMWPSZVUMVLQZVVBVULVUJRSZVVMVVBVUJVLQZVVPVVBVUJUXIQZVVQVVBF
          UXIVUJUXQAVUTWQZWRZVUJGWSZWHZVVQVUKVLQZVVPUXKOWTUFZQUXKOUGPVUMRSVFXBZ
          BCUXKVUJHNXCZXDWHZVVBVULWOQZVULVQXEVUJWOQZVVPVVMXFVVBVULVVBVUKVVBVVQV
          WCVWBVVQVWCVVPVWEVWFXGWHZXHZXIZVVBVULVWKXLZVVBVUJVWBXIZVULVUJXJXKXMZV
          VBVVQVULVLQZVVNVWBVWKVVQVUJUJQZVQVUJWPSZVRVULUJQZVQVULWPSZVRVVNVWPVVQ
          VWQVWRVUJXNVUJXOYBVWPVWSVWTVULXNVULXOYBVUJVULUUAXPXQVUMUUBXRZWEVVBVUJ
          VWBWEZAGUJQVUTAGLWEXSZVVBVUMVUJRSZVUMVUJTSZVVBVUMVUMVULUIPZVUJRVVBVVM
          VWHVUMVXFRSVWOVWLVUMVULUUEXQVVBVUJVULVVBVUJVWBXTVVBVULVWKXTVWMYAZYCZV
          VBVVMVVQVXDVXEXBVWOVWBVUMVUJYDXQYEVVBVVRVUJGTSVVTVUJUNGUUFWHZYFVVBVUM
          UNWTUFZQGWOQZVVHVVLXFVVBVUMVLVXJVXAYGYHAVXKVUTAGLXIXSVUMUNGYIXQYJVVBU
          XJVUJRSZVFZIUXOUTZVVKVVBVVRVXNVVBVUTVVRVXNVRVVSUXPVXNCVUJUXIFCUBYMZUX
          MVXMIUXOVXOUXLVXLUXKVUJUXJRYKYNYLMYOYPUUCVVBVXMVVJIUXOVVBUXJUXOQZVRZV
          VIVXLVXQVVIVXDVXLVVBVXDVXPVXHXSVXQUXJWOQZVVMVWIVVIVXDVRVXLXBVXPVXRVVB
          VXPUXJURQVXRUXJURUXNUUGUXJUUDWHUUHVVBVVMVXPVWOXSVVBVWIVXPVWNXSUXJVUMV
          UJUUIXKUUJUUOUUKYEUXPVVKCVUMUXIFUXKVUMWGZUXMVVJIUXOVXSUXLVVIUXKVUMUXJ
          RYKYNYLMYOXRVVBVVFOUGPZVUMRSZVVGVVBVVOVYAVXAVVOVVFVLQZVYAUDVWDQUDOUGP
          VUMVXTXAPRSVFXBZBCUDVUMHNXCZXDWHVVBVVQVVGVFVVFVWDQZVYAVFZVWBVVBVVGVYE
          VVBVYBVVGVYEUULVVBVVOVYBVXAVVOVYBVYAVYCVYDXGWHVVFUUMYPUUNVVQVWCVVPVYE
          VYFXBBCVVFVUJHNXCUUPUVFUUQUYKVVGUAVUMFUYIVUMWGUYJVVFUNUYIVUMBYQUURUUS
          XRVVBVVDVUKUXETSZVVBVUKUXDTSZVYGVVBVYHVULUXDOUGPZTSZVVBVULGVYITVVBVUL
          VUJGVVBVULVWKWEVXBVXCVVBVVPVULVUJTSZVWGVVBVWHVVQVVPVYKXBVWLVWBVULVUJY
          DXQYEVXIYFVVBGVVBGVXCUUTUVAUVBVVBVUKYRQZUXDYRQZVYHVYJXFZVVBVUKVWJVSAV
          YMVUTUYDXSVYLVUKUJQVQVUKTSVRUYBVYNVYMVUKYSUXDYSVUKUXDUVCXPXQYJVVBUYAV
          UKWOQVYHVYGXFAUYAVUTUYHXSVVBVUKVWJXIUXDVUKUVDXQXMVVBVUKVXJQUXEWOQZVVD
          VYGXFVVBVUKVLVXJVWJYGYHAVYOVUTAUXEUYEUVEXSVUKUNUXEYIXQYJVUMVUKUYLVUAU
          VGXQYTAVUTVUOFQZVRZVUNVUSWGZUBUCYMZXFAVYQVRZVYRVYSVYRVXFVURVUQUIPZWGZ
          VYTVYSVYRVUMVURWGZVUKVUPWGZVRWUBVUMVUKVURVUPVUJVULXAUVHVUJBUVIUVJWUDW
          UCVULVUQWGWUBVUKVUPOUGUVKVUMVURVULVUQUIUVLUVQUVMVYTVXFVUJWUAVUOAVUTVX
          FVUJWGVYPVXGUVNVYTVUOVUQVYTVUOVYTFVLVUOFUXIVLUXQUBUXIVLVWAUVOUVPAVUTV
          YPUVRWRZXTVYTVUQVYTVUPVYTVUOVLQZVUPVLQZWUEWUFWUGVUQVUORSOVWDQOOUGPVUR
          RSVFXBBCOVUOHNXCXGWHXHZXTVYTVUQWUHXLYAUVSUVTVYSVUMVURVUKVUPVYSVUJVUOV
          ULVUQXAVYSUWGVYSVUKVUPOUGVUJVUOBYQZUWAUWBWUIUWCUWDYTUWEUWFUXHVUFVUEVU
          DXFUXRVUIFVUBULUWHVGUWIAVUCUYMVUAUEUFZUIPZUYNUYQVUGVUCWUKWGUYRVUHUYLV
          UAUWJVGAWUJUXEUYMUIAUYCWUJUXEWGUYEUXEUWKWHUWLUWMYCAUYMUXCUXEUYOAUYSVK
          UYGUYTAUXEUYEUWNAUABCDEFGHIJKLMNUWQUWOYFAUYPUYAUXCUJQVQUXCTSVRUXEUXDT
          SZUXFUXGTSUYTUYHAUXCAUXCUXTVSWAAWULUXDUXEUNUWPPWPSZAUYAWULWUMVRUYHUXD
          UWRWHUWSUXEUXDUXCUWTUXAYF $.
      $}

      prmrec.5 $e |- ( ph -> seq 1 ( + , F ) e. dom ~~> ) $.
      prmrec.6 $e |- ( ph -> sum_ k e. ( ZZ>= ` ( K + 1 ) )
        if ( k e. Prime , ( 1 / k ) , 0 ) < ( 1 / 2 ) ) $.
      prmrec.7 $e |- W = ( p e. NN |-> { n e. ( 1 ... N ) |
        ( p e. Prime /\ p || n ) } ) $.
      $( Lemma for ~ prmrec .  Show by induction that the indexed (nondisjoint)
         union ` W `` k ` is at most the size of the prime reciprocal series.
         The key counting lemma is ~ hashdvds , to show that the number of
         numbers in ` 1 ... N ` that divide ` k ` is at most ` N / k ` .
         (Contributed by Mario Carneiro, 6-Aug-2014.) $)
      prmreclem4 $p |- ( ph -> ( N e. ( ZZ>= ` K ) ->
        ( # ` U_ k e. ( ( K + 1 ) ... N ) ( W ` k ) ) <_
          ( N x. sum_ k e. ( ( K + 1 ) ... N )
            if ( k e. Prime , ( 1 / k ) , 0 ) ) ) ) $=
        ( wcel co cc0 cle vx vj cuz cfv c1 caddc cfz ciun chash cprime cdiv cif
        cv csu cmul wbr wceq oveq2 iuneq1d fveq2d sumeq1d oveq2d breq12d imbi2d
        wi weq cz 0le0 nncnd mul01d syl5breqr c0 clt nnred ltp1d syl2anc syl6eq
        hash0 3brtr4d a1i wa cfn cn0 wral elfzuz cn peano2nnd nnuz uztrn2 sylan
        wss cdivides crab eleq1 breq1 anbi12d rabbidv rabex fvmpt adantl sylan2
        ovex ralrimiva adantr iunss sylibr ssfi sylancr hashcl syl nn0red fzfid
        cr syl2an nnrecre sylancl fsumrecl remulcld wn cmin cc simpl recnd zcnd
        0re ax-1cn pncan oveq1d eqtrd breq2d cun simpr eqtri cfl subid1d fveq2i
        readdcld subidi 0z oveq1i nnzd peano2zd fzn mpbid 0iun sum0 fzfi ssrab2
        wb syl6eqss syldan prmnn ifclda leadd1d eluzp1p1 eqidd ifbieq12d fsumm1
        ifcl eluzelz adddid bitr4d fveq2 sseq1d sylc csn eleqtrrd fzsuc2 iunxun
        rspcv iunxsn uneq2i hashun2 eqbrtrd nndivred flle elfznn rabbiia nnnn0d
        1z nn0uz eqtr4i syl6eleq hashdvds 0cn nnne0d div0d syl5eq ax-mp oveq12d
        flid flcld 3eqtrd syl5eqr divrecd eqcomd biantrurd eqtr4d iftrue rabeq0
        con3i ralrimivw sylan9eq iffalse sylan9eqr pm2.61dan letrd letr syl3anc
        leadd2dd mpand sylbid expcom a2d uzind4 com12 ) GEUCUDZQABEUEUFRZGUGRZB
        UMZHUDZUHZUIUDZGUXSUXTUJQZUEUXTUKRZSULZBUNZUORZTUPZABUXRUAUMZUGRZUYAUHZ
        UIUDZGUYKUYFBUNZUORZTUPZVEABUXREUGRZUYAUHZUIUDZGUYQUYFBUNZUORZTUPZVEZAB
        UXRUBUMZUGRZUYAUHZUIUDZGVUEUYFBUNZUORZTUPZVEABUXRVUDUEUFRZUGRZUYAUHZUIU
        DZGVULUYFBUNZUORZTUPZVEAUYIVEUAUBEGUYJEUQZUYPVUBAVURUYMUYSUYOVUATVURUYL
        UYRUIVURBUYKUYQUYAUYJEUXRUGURZUSUTVURUYNUYTGUOVURUYKUYQUYFBVUSVAVBVCVDU
        AUBVFZUYPVUJAVUTUYMVUGUYOVUITVUTUYLVUFUIVUTBUYKVUEUYAUYJVUDUXRUGURZUSUT
        VUTUYNVUHGUOVUTUYKVUEUYFBVVAVAVBVCVDUYJVUKUQZUYPVUQAVVBUYMVUNUYOVUPTVVB
        UYLVUMUIVVBBUYKVULUYAUYJVUKUXRUGURZUSUTVVBUYNVUOGUOVVBUYKVULUYFBVVCVAVB
        VCVDUYJGUQZUYPUYIAVVDUYMUYCUYOUYHTVVDUYLUYBUIVVDBUYKUXSUYAUYJGUXRUGURZU
        SUTVVDUYNUYGGUOVVDUYKUXSUYFBVVEVAVBVCVDVUCEVGQZASGSUORZUYSVUATASSVVGTVH
        AGAGLVIZVJZVKAUYSVLUIUDZSAUYRVLUIAUYRBVLUYAUHVLABUYQVLUYAAEUXRVMUPZUYQV
        LUQZAEAEKVNVOAUXRVGQZVVFVVKVVLUUIAEAEKUUAZUUBZVVNUXREUUCVPUUDZUSBUYAUUE
        VQUTVRVQAUYTSGUOAUYTVLUYFBUNSAUYQVLUYFBVVPVAUYFBUUFVQVBVSVTVUDUXQQZAVUJ
        VUQAVVQVUJVUQVEAVVQWAZVUJVUGGVUKUJQZUEVUKUKRZSULZUORZUFRZVUPTUPZVUQVVRV
        UJVWCVUIVWBUFRZTUPVWDVVRVUGVUIVWBVVRVUGVVRVUFWBQZVUGWCQVVRUEGUGRZWBQZVU
        FVWGWKZVWFUEGUUGZVVRUYAVWGWKZBVUEWDZVWIAVWLVVQAVWKBVUEUXTVUEQZAUXTUXRUC
        UDZQZVWKUXTUXRVUDWEZAVWOUXTWFQZVWKAUXRWFQZVWOVWQAEKWGZUEUXTUXRWFWHWIZWJ
        ZAVWQWAUYAUYDUXTCUMZWLUPZWAZCVWGWMZVWGVWQUYAVXEUQAIUXTIUMZUJQZVXFVXBWLU
        PZWAZCVWGWMZVXEWFHIBVFZVXIVXDCVWGVXKVXGUYDVXHVXCVXFUXTUJWNVXFUXTVXBWLWO
        WPWQPVXDCVWGUEGUGXBZWRWSWTVXDCVWGUUHUUJZUUKZXAXCXDBVUEUYAVWGXEXFVWGVUFX
        GXHZVUFXIXJXKZVVRGVUHAGXMQVVQAGLVNXDZVVRVUEUYFBVVRUXRVUDXLVVRVWMWAVWQUY
        FXMQZVVRVWRVWOVWQVWMAVWRVVQVWSXDVWPVWTXNVWQUYEXMQSXMQZVXRUXTXOYEUYDUYES
        XMUUSXPZXJXQZXRVVRGVWAVXQVVRVVSVVTSXMVVSVVTXMQZVVRVVSVUKWFQZVYBVUKUULVU
        KXOXJWTVXSVVRVVSXSZWAZYEVTUUMZXRZUUNVVRVUPVWEVWCTVVRVUPGVUHVWAUFRZUORVW
        EVVRVUOVYHGUOVVRVUOUXRVUKUEXTRZUGRZUYFBUNZVWAUFRVYHVVRUYFVWABUXRVUKVVQV
        UKVWNQAEVUDUUOWTVVRAVWOUYFYAQZUXTVULQZAVVQYBZUXTUXRVUKWEZAVWOWAZVWQVYLV
        XAVWQUYFVXTYCXJXNUXTVUKUQZUYDVVSUYESVVTSUXTVUKUJWNUXTVUKUEUKURVYQSUUPUU
        QUURVVRVYKVUHVWAUFVVRVYJVUEUYFBVVRVYIVUDUXRUGVVRVUDYAQUEYAQZVYIVUDUQVVR
        VUDVVQVUDVGQAEVUDUUTWTYDYFVUDUEYGXPVBVAYHYIVBVVRGVUHVWAAGYAQVVQVVHXDZVV
        RVUHVYAYCVVRVWAVYFYCUVAYIYJUVBVVRVUNVWCTUPZVWDVUQVVRVUNVUGVUKHUDZUIUDZU
        FRZVWCVVRVUNVVRVUMWBQZVUNWCQVVRVWHVUMVWGWKZWUDVWJVVRVWKBVULWDZWUEAWUFVV
        QAVWKBVULVYMAVWOVWKVYOVXNXAXCXDBVULUYAVWGXEXFVWGVUMXGXHVUMXIXJXKZVVRVUG
        WUBVXPVVRWUBVVRWUAWBQZWUBWCQVVRVWHWUAVWGWKZWUHVWJVVRVYCVWKBWFWDZWUIVVRV
        UDAEWFQVVQVUDWFQKUEVUDEWFWHWIWJWGZAWUJVVQAVWKBWFVXMXCXDVWKWUIBVUKWFVYQU
        YAWUAVWGUXTVUKHUVCZUVDUVJUVEVWGWUAXGXHZWUAXIXJXKZYQVVRVUGVWBVXPVYGYQZVV
        RVUNVUFWUAYKZUIUDZWUCTVVRVUMWUPUIVVRVUMBVUEVUKUVFZYKZUYAUHZWUPVVRBVULWU
        SUYAVVRVVMVUDUXRUEXTRZUCUDZQVULWUSUQAVVMVVQVVOXDVVRVUDUXQWVBAVVQYLVVRWV
        AEUCVVREYAQZVYRWVAEUQAWVCVVQAEKVIXDYFEUEYGXPUTUVGUXRVUDUVHVPUSWUTVUFBWU
        RUYAUHZYKWUPBVUEWURUYAUVIWVDWUAVUFBVUKUYAWUAVUDUEUFXBWULUVKUVLYMVQUTVVR
        VWFWUHWUQWUCTUPVXOWUMVUFWUAUVMVPUVNVVRWUBVWBVUGWUNVYGVXPVVRVVSWUBVWBTUP
        VVRVVSWAZVUKVXBWLUPZCVWGWMZUIUDZGVVTUORZWUBVWBTVVRWVHWVITUPVVSVVRGVUKUK
        RZYNUDZWVJWVHWVITVVRWVJXMQWVKWVJTUPVVRGVUKVXQWUKUVOZWVJUVPXJVVRWVHVUKVX
        BSXTRZWLUPZCVWGWMZUIUDZWVKWVOWVGUIWVNWVFCVWGVXBVWGQZWVMVXBVUKWLWVQVXBWV
        QVXBVXBGUVQVIYOYJUVRYPVVRWVPGSXTRZVUKUKRZYNUDZUEUEXTRZSXTRZVUKUKRZYNUDZ
        XTRWVKSXTRWVKVVRCUEGSVUKWUKUEVGQVVRUVTVTAGWWAUCUDZQVVQAGWCWWEAGLUVSWCSU
        CUDWWEUWAWWASUCUEYFYRZYPUWBUWCXDSVGQZVVRYSVTUWDVVRWVTWVKWWDSXTVVRWVSWVJ
        YNVVRWVRGVUKUKVVRGVYSYOYHUTVVRWWDSYNUDZSVVRWWCSYNVVRWWCSVUKUKRSWWBSVUKU
        KWWBSSXTRSWWASSXTWWFYTSUWEYRYMYTVVRVUKVVRVUKWUKVIZVVRVUKWUKUWFZUWGUWHUT
        WWGWWHSUQYSSUWKUWIVQUWJVVRWVKVVRWVKVVRWVJWVLUWLYDYOUWMUWNVVRWVJWVIVVRGV
        UKVYSWWIWWJUWOUWPVSXDWVEWUAWVGUIWVEWUAVVSWVFWAZCVWGWMZWVGVVRWUAWWLUQZVV
        SVVRVYCWWMWUKIVUKVXJWWLWFHVXFVUKUQZVXIWWKCVWGWWNVXGVVSVXHWVFVXFVUKUJWNV
        XFVUKVXBWLWOWPWQPWWKCVWGVXLWRWSXJZXDWVEWVFWWKCVWGWVEVVSWVFVVRVVSYLUWQWQ
        UWRUTWVEVWAVVTGUOVVSVWAVVTUQVVRVVSVVTSUWSWTVBVSVYESSWUBVWBTSSTUPVYEVHVT
        VYEWUBVVJSVYEWUAVLUIVVRVYDWUAWWLVLWWOVYDWWKXSZCVWGWDWWLVLUQVYDWWPCVWGWW
        KVVSVVSWVFYBUXAUXBWWKCVWGUWTXFUXCUTVRVQVYDVVRVWBVVGSVYDVWASGUOVVSVVTSUX
        DVBAVVGSUQVVQVVIXDUXEVSUXFUXJUXGVVRVUNXMQVWCXMQVUPXMQVYTVWDWAVUQVEWUGWU
        OVVRGVUOVXQVVRVULUYFBVVRUXRVUKXLVVRAVWOVXRVYMVYNVYOVYPVWQVXRVXAVXTXJXNX
        QXRVUNVWCVUPUXHUXIUXKUXLUXMUXNUXOUXP $.

      $( Lemma for ~ prmrec .  Here we show the inequality ` N / 2 < # M ` by
         decomposing the set ` ( 1 ... N ) ` into the disjoint union of the set
         ` M ` of those numbers that are not divisible by any "large" primes
         (above ` K ` ) and the indexed union over ` K < k ` of the numbers
         ` W `` k ` that divide the prime ` k ` .  By ~ prmreclem4 the second
         of these has size less than ` N ` times the prime reciprocal series,
         which is less than ` 1 / 2 ` by assumption, we find that the
         complementary part ` M ` must be at least ` N / 2 ` large.
         (Contributed by Mario Carneiro, 6-Aug-2014.) $)
      prmreclem5 $p |- ( ph -> ( N / 2 ) < ( ( 2 ^ K ) x. ( sqr ` N ) ) ) $=
        ( wcel wbr cn cc0 vx vq vr c2 cdiv chash cexp csqr cmul nnred rehalfcld
        co cfv cr cfn cn0 c1 cfz wss fzfi cdivides cprime cdif wral crab ssrab2
        cv wn eqsstri ssfi mp2an hashcl ax-mp nn0rei a1i nnnn0d nnexpcl sylancr
        2nn nnrpd rpsqrcld remulcld clt caddc ciun recnd cuz nnuz wa wceq eleq1
        weq breq1 anbi12d rabbidv ovex rabex fvmpt adantl sylibr notbid ralbidv
        wi breq2 elrab2 ex wrex cle ad2antrl cz wb nnzd ad2antrr syl2anc mpbird
        syl mpbid ad2antlr simprr syl3anc anbi2d elrab eleq2d fveq2d c0 simprbi
        cin elin imnan sylnibr cif csu sylancl 0le0 syl6eq cseq cc lelttrd csup
        sylib rpred cun 2halvesd peano2nnd elfzuz uztrn2 syl2an syl6eqss syldan
        ralrimiva iunss unssd syl5bb elun1 sylbir dfrex2 eldifn eldifi syl6eleq
        cbvralv prmnn elfz5 mtbid ltnled prmz zltp1le elfznn dvdsle mpd elfzle2
        letrd peano2zd elfz mpbir2and simplr jca sylanbrc eleqtrrd fveq2 rspcev
        eliun elun2 rexlimdvaa syl5bir pm2.61d ssrdv hashfz1 eqtr2d noel simprl
        eqssd biantrud syl6bbr ltp1d fzdisj bitrd mtbiri eldifd rspcv sylc expr
        adantlr syl6bi mtod nrexdv eq0rdv hashun 3eqtrd fzfid sylan nnrecre 0re
        nn0red ifcl sylan2 fsumrecl prmreclem4 nnleltp1 3bitrd mul01d syl5breqr
        eluz fzn iuneq1 0iun hash0 sumeq1 sum0 oveq2d breq12d syl5ibrcom sylbid
        wo uztric mpjaod eqid oveq2 eqidd ifbieq12d c0ex cli cdm eqeltrd iserex
        ifex isumrecl 1re rehalfcli fzssuz nnrp rpreccld rpge0d ifboth isumless
        nngt0d ltmul2 syl112anc wne 2cn divrec mp3an23 breqtrrd eqbrtrd ltadd1d
        ltadd2dd oveq1 breq1d cbvrabv syl5eq supeq1d cbvmptv prmreclem3 ltletrd
        2ne0 cmpt ) AGUDUEULZFUFUMZUDEUGULZGUHUMZUIULAGAGLUJZUKZVVQUNQAVVQFUOQZ
        VVQUPQUQGURULZUOQZFVWCUSZVWBUQGUTZFIVGZCVGZVARZVHZIVBUQEURULZVCZVDZCVWC
        VEVWCMVWMCVWCVFVIZVWCFVJVKZFVLVMVNVOZAVVRVVSAVVRAUDSQEUPQVVRSQVSAEKVPUD
        EVQVRUJAVVSAGAGLVTWAUUAWBAVVPVVQWCRVVPVVPWDULZVVQVVPWDULZWCRAVWQVVQBEUQ
        WDULZGURULZBVGZHUMZWEZUFUMZWDULZVWRWCAVWQGFVXCUUBZUFUMZVXEAGAGVVTWFZUUC
        AVXGVWCUFUMZGAVXFVWCUFAVXFVWCAFVXCVWCVWEAVWNVOAVXBVWCUSZBVWTVDVXCVWCUSZ
        AVXJBVWTAVXAVWTQZVXASQZVXJAVWSSQZVXAVWSWGUMZQZVXMVXLAEKUUDZVXAVWSGUUEZU
        QVXAVWSSWHUUFZUUGZAVXMWIVXBVXAVBQZVXAVWHVARZWIZCVWCVEZVWCVXMVXBVYDWJZAI
        VXAVWGVBQZVWIWIZCVWCVEZVYDSHIBWLZVYGVYCCVWCVYIVYFVYAVWIVYBVWGVXAVBWKVWG
        VXAVWHVAWMWNWOPVYCCVWCUQGURWPZWQWRZWSVYCCVWCVFUUHUUIUUJBVWTVXBVWCUUKWTZ
        UULAUAVWCVXFAUAVGZVWCQZVYMVXFQZAVYNWIZUBVGZVYMVARZVHZUBVWLVDZVYOVYNVYTV
        YOXCAVYNVYTVYOVYNVYTWIVYMFQZVYOVWMVYTCVYMVWCFVWMVYQVWHVARZVHZUBVWLVDCUA
        WLZVYTVWJWUCIUBVWLIUBWLZVWIWUBVWGVYQVWHVAWMZXAUUTWUDWUCVYSUBVWLWUDWUBVY
        RVWHVYMVYQVAXDZXAXBUUMMXEVYMFVXCUUNUUOXFWSVYTVHVYRUBVWLXGVYPVYOVYRUBVWL
        UUPVYPVYRVYOUBVWLVYPVYQVWLQZVYRWIZWIZVYMVXCQZVYOWUJVYMVXBQZBVWTXGZWUKWU
        JVYQVWTQZVYMVYQHUMZQZWUMWUJWUNVWSVYQXHRZVYQGXHRZWUJEVYQWCRZWUQWUJWUSVYQ
        EXHRZVHWUJVYQVWKQZWUTWUHWVAVHVYPVYRVYQVBVWKUUQXIWUJVYQUQWGUMZQEXJQZWVAW
        UTXKWUJVYQSWVBWUJVYQVBQZVYQSQZWUHWVDVYPVYRVYQVBVWKUURXIZVYQUVAXPZWHUUSA
        WVCVYNWUIAEKXLZXMZVYQUQEUVBXNUVCWUJEVYQAEUNQVYNWUIAEKUJZXMWUJVYQWVGUJZU
        VDXOWUJWVCVYQXJQZWUSWUQXKWVIWUJWVDWVLWVFVYQUVEXPZEVYQUVFXNXQWUJVYQVYMGW
        VKWUJVYMVYNVYMSQZAWUIVYMGUVGXRZUJAGUNQZVYNWUIVVTXMWUJVYRVYQVYMXHRZVYPWU
        HVYRXSZWUJWVLWVNVYRWVQXCWVMWVOVYQVYMUVHXNUVIVYNVYMGXHRAWUIVYMUQGUVJXRUV
        KWUJWVLVWSXJQZGXJQZWUNWUQWURWIXKWVMAWVSVYNWUIAEWVHUVLZXMAWVTVYNWUIAGLXL
        ZXMVYQVWSGUVMXTUVNWUJVYMWVDWUBWIZCVWCVEZWUOWUJVYNWVDVYRWIZVYMWWDQAVYNWU
        IUVOWUJWVDVYRWVFWVRUVPWWCWWECVYMVWCWUDWUBVYRWVDWUGYAYBUVQWUJWVEWUOWWDWJ
        WVGIVYQVYHWWDSHWUEVYGWWCCVWCWUEVYFWVDVWIWUBVWGVYQVBWKWUFWNWOPWWCCVWCVYJ
        WQWRXPUVRWULWUPBVYQVWTBUBWLVXBWUOVYMVXAVYQHUVSYCUVTXNBVYMVWTVXBUWAZWTVY
        MVXCFUWBXPUWCUWDUWEXFUWFUWKYDAGUPQVXIGWJAGLVPGUWGXPUWHAVWBVXCUOQZFVXCYG
        ZYEWJVXGVXEWJVWBAVWOVOAVWDVXKWWGVWFVYLVWCVXCVJVRZAUAWWHAWUAWUKWIZVYMWWH
        QAWUAWUKVHZXCWWJVHAWUAWWKAWUAWIZWUMWUKWWLWULBVWTWWLVXLWIZWULVYAVXAVYMVA
        RZWIZWWMVYAWWNVHZXCWWOVHWWLVXLVYAWWPWWLVXLVYAWIZWIZVXAVWLQVWGVYMVARZVHZ
        IVWLVDZWWPWWRVXAVBVWKWWLVXLVYAXSWWRVXAVWKQZVXAYEQZVXAUWIWWRWXBVXAVWKVWT
        YGZQZWXCWWRWXBWXBVXLWIWXEWWRVXLWXBWWLVXLVYAUWJUWLVXAVWKVWTYHUWMWWRWXDYE
        VXAAWXDYEWJZWUAWWQAEVWSWCRWXFAEWVJUWNUQEVWSGUWOXPXMYCUWPUWQUWRWUAWXAAWW
        QWUAVYNWXAVWMWXACVYMVWCFWUDVWJWWTIVWLWUDVWIWWSVWHVYMVWGVAXDXAXBMXEYFXRW
        WTWWPIVXAVWLVYIWWSWWNVWGVXAVYMVAWMXAUWSUWTUXAVYAWWNYIYTWWMWULVYMVYDQZWW
        OWWMVXBVYDVYMWWMVXMVYEAVXLVXMWUAVXTUXBVYKXPYCWXGVYNWWOVYCWWOCVYMVWCWUDV
        YBWWNVYAVWHVYMVXAVAXDYAYBYFUXCUXDUXEWWFYJXFWUAWUKYIYTVYMFVXCYHYJUXFFVXC
        UXGXTUXHAVXDVVPVVQAVXDAWWGVXDUPQWWIVXCVLXPUXMZVWAVWPAVXDGVWTVYAUQVXAUEU
        LZTYKZBYLZUIULZVVPWXHAGWXKVVTAVWTWXJBAVWSGUXIZVXLAVXPWXJUNQZVXRAVXPWIZV
        XMWXNAVXNVXPVXMVXQVXSUXJZVXMWXIUNQTUNQWXNVXAUXKUXLVYAWXITUNUXNYMZXPZUXO
        UXPZWBVWAAGEWGUMQZVXDWXLXHRZEGWGUMQZABCDEFGHIJKLMNOPUXQAWYBVWTYEWJZWYAA
        WYBGEXHRZGVWSWCRZWYCAWVTWVCWYBWYDXKWWBWVHGEUYBXNAGSQESQWYDWYEXKLKGEUXRX
        NAWVSWVTWYEWYCXKWWAWWBVWSGUYCXNUXSAWYAWYCTGTUIULZXHRATTWYFXHYNAGVXHUXTU
        YAWYCVXDTWXLWYFXHWYCVXDYEUFUMTWYCVXCYEUFWYCVXCBYEVXBWEYEBVWTYEVXBUYDBVX
        BUYEYOYDUYFYOWYCWXKTGUIWYCWXKYEWXJBYLTVWTYEWXJBUYGWXJBUYHYOUYIUYJUYKUYL
        AWVCWVTWXTWYBUYMWVHWWBEGUYNXNUYOAWXLGUQUDUEULZUIULZVVPWCAWXKWYGWCRZWXLW
        YHWCRZAWXKVXOWXJBYLWYGWXSAWXJBDVWSVXOVXOUYPZWWAWXOVXMVXADUMZWXJWJWXPCVX
        AVWHVBQZUQVWHUEULZTYKWXJSDCBWLZWYMVYAWYNTWXITVWHVXAVBWKVWHVXAUQUEUYQWYO
        TUYRUYSJVYAWXITUQVXAUEWPUYTVUEWRZXPZWXRAWDDUQYPVUAVUBZQWDDVWSYPWYRQNABD
        UQVWSSWHVXQVXMWYLYQQAVXMWYLWXJYQWYPVXMWXJWXQWFVUCWSVUDXQZVUFWYGUNQZAUQV
        UGVUHVOZAVWTWXJBDVWSVXOWYKWWAWXMVWTVXOUSAVWSGVUIVOWYQWXRWXOVXMTWXJXHRZW
        XPVXMTWXIXHRZTTXHRZXUBVXMWXIVXMVXAVXAVUJVUKVULYNVYAXUCXUDXUBWXITWXIWXJT
        XHXDTWXJTXHXDVUMYMXPWYSVUNOYRAWXKUNQWYTWVPTGWCRWYIWYJXKWXSXUAVVTAGLVUOW
        XKWYGGVUPVUQXQAGYQQZVVPWYHWJZVXHXUEUDYQQUDTVURXUFVUSVVNGUDVUTVVAXPVVBYR
        VVEVVCAVVPVVQVVPVWAVWPVWAVVDXOAUASVXAUDUGULZVYMVARZBSVEZUNWCYSZVVOCDEFG
        UCIJKLMUACSXUJUCVGZUDUGULZVWHVARZUCSVEZUNWCYSUACWLZUNXUIXUNWCXUOXUIXULV
        YMVARZUCSVEXUNXUHXUPBUCSBUCWLXUGXULVYMVAVXAXUKUDUGVVFVVGVVHXUOXUPXUMUCS
        VYMVWHXULVAXDWOVVIVVJVVKVVLVVM $.
    $}

    $( Lemma for ~ prmrec .  If the series ` F ` was convergent, there would be
       some ` k ` such that the sum starting from ` k + 1 ` sums to less than
       ` 1 / 2 ` ; this is a sufficient hypothesis for ~ prmreclem5 to produce
       the contradictory bound ` N / 2 < ( 2 ^ k ) sqr N ` , which is false for
       ` N = 2 ^ ( 2 k + 2 ) ` .  (Contributed by Mario Carneiro,
       6-Aug-2014.) $)
    prmreclem6 $p |- -. seq 1 ( + , F ) e. dom ~~> $=
      ( vk vj caddc c1 wcel cr clt c2 co cv wbr cn cle wtru a1i cc0 wa vy vz vx
      vm vp vr vw cseq cli cdm crn csup cdiv cmin cfv wrex crp wss c0 wral nnuz
      wne wf cz 1z cprime cif nnrecre adantl 0re sylancl fmptd ffvelrnda serfre
      ifcl trud frn ax-mp 1nn fdmi eleqtrri ne0i dm0rn0 necon3bii climdm biimpi
      sylib climrecl simpr adantr wceq weq eleq1 oveq2 eqidd ifbieq12d nnrecred
      prmnn ifclda elexi fvmpt eqeltrd adantlr nnrp rpreccld rpge0d 0le0 ifboth
      wn breq2 breqtrrd climserle ralbidv wb breq1 mp2b mpbid cmul cexp cn0 2nn
      sylancr nnnn0d cuz csu cdivides cfz crab notbid eqid syl cc ax-1cn oveq2d
      oveq1d eqtrd breq12d 2cn nncnd addassd ralrimiva rspcev syl2anc wfn ralrn
      ffn rexbii sylibr suprcl syl3anc 2rp rpreccl ltsubrp rpre resubcl suprlub
      syl31anc rexrn 2re nnmulcl peano2nnd reexpcl ltnrd csqr cdif cmpt nnexpcl
      peano2nn nnsqcld cbvralv syl5bb cbvrabv simpll cbvsumv prmreclem5 ex nnzd
      syl5eqbr uztrn2 sylan simpl recni iserex isumrecl elfznn syl6eleq fsumser
      ltadd2d isumsplit nncn pncan sumeq1d breq1d bitr4d isumsup 3bitr2d adddid
      ltsubaddd mulcom 2timesi syl6eqr 3eqtr4d 2nn0 expmuld expp1 3eqtr3d expcl
      oveq2i 2ne0 divcan4 mp3an23 nnnn0 expaddd 2timesd nnrpd rprege0d 3eqtr4rd
      sqrsq 3imtr3d mtod nrexdv pm2.65i ) FBGUHZUIUJZHZUYCUKZIJULZGKUMLZUNLZDMZ
      UYCUOZJNZDOUPZUYEUYIUAMZJNZUAUYFUPZUYMUYEUYIUYGJNZUYPUYEUYGIHZUYHUQHZUYQU
      YEUYFIURZUYFUSVBZUBMZUCMZPNZUBUYFUTZUCIUPZUYRUYTUYEOIUYCVCZUYTVUGQEBGOVAG
      VDHZQVERQOIEMZBQAOAMZVFHZGVUJUMLZSVGZIBQVUJOHZTVULIHZSIHZVUMIHVUNVUOQVUJV
      HVIVJVUKVULSIVOVKCVLVMVNVPZOIUYCVQVRRZVUAUYEGUYCUJZHZVUAGOVUSVSOIUYCVUQVT
      WAVUTVUSUSVBVUAVUSGWBVUSUSUYFUSUYCWCWDWGVRRZUYEUYKVUCPNZDOUTZUCIUPZVUFUYE
      UYCUIUOZIHUYKVVEPNZDOUTZVVDUYEVVEDUYCGOVAVUHUYEVERZUYEUYCVVEUINZUYCWEWFZU
      YEOIUYJUYCVUGUYEVUQRVMZWHUYEVVFDOUYEUYJOHZTZVVEEBGUYJOVAUYEVVLWIZUYEVVIVV
      LVVJWJUYEVUIOHZVUIBUOZIHVVLUYEVVOTZVVPVUIVFHZGVUIUMLZSVGZIVVOVVPVVTWKZUYE
      AVUIVUMVVTOBAEWLZVUKVVRVULSVVSSVUJVUIVFWMVUJVUIGUMWNVWBSWOWPCVVTIVVTIHZQV
      VRVVSSIQVVRTVUIVVRVVOQVUIWRVIWQVUPQVVRXITVJRWSVPZWTXAZVIZVWCVVQVWDRZXBXCU
      YEVVOSVVPPNVVLVVQSVVTVVPPVVQSVVSPNZSSPNZSVVTPNZVVQVVSVVQVUIVVOVUIUQHUYEVU
      IXDVIXEXFXGVVRVWHVWIVWJVVSSVVSVVTSPXJSVVTSPXJXHVKZVWFXKXCXLUUAVVCVVGUCVVE
      IVUCVVEWKVVBVVFDOVUCVVEUYKPXJXMUUBUUCZVUEVVCUCIVUGUYCOUUDZVUEVVCXNVUQOIUY
      CUUFZVUDVVBUBDOUYCVUBUYKVUCPXOUUEXPUUGUUHZUCUBUYFUUIUUJZKUQHUYSUUKKUULVRZ
      UYGUYHUUMVKUYEUYTVUAVUFUYIIHZUYQUYPXNVURVVAVWOUYEUYRUYHIHZVWRVWPUYSVWSVWQ
      UYHUUNVRZUYGUYHUUOVKUCUBUAUYFUYIUUPUUQXQVUGVWMUYPUYMXNVUQVWNUYOUYLUADOUYC
      UYNUYKUYIJXJUURXPWGUYEUYLDOVVMUYLKKUYJXRLZGFLZXSLZVXCJNZVVMVXCVVMKIHVXBXT
      HZVXCIHUUSVVMVXBVVMVXAVVMKOHZVVLVXAOHYAVVNKUYJUUTYBZUVAYCZKVXBUVBYBUVCVVM
      UYJGFLZYDUOZVVTEYEZUYHJNZKVXIXSLZKXSLZKUMLZKUYJXSLZVXNUVDUOZXRLZJNZUYLVXD
      VVMVXLVXSVVMVXLTZUDABUYJUEMZUFMZYFNZXIZUEVFGUYJYGLZUVEZUTZUFGVXNYGLZYHVXN
      UGOUGMZVFHVYIVUJYFNZTAVYHYHUVFZUGCVVMVVLVXLVVNWJVVMVXNOHVXLVVMVXMVVMVXFVX
      IXTHVXMOHYAVVMVXIVVLVXIOHZUYEUYJUVHVIZYCZKVXIUVGYBZUVIWJVYGVYJXIZUGVYFUTZ
      UFAVYHVYGVYIVYBYFNZXIZUGVYFUTUFAWLZVYQVYDVYSUEUGVYFUEUGWLVYCVYRVYAVYIVYBY
      FXOYIUVJVYTVYSVYPUGVYFVYTVYRVYJVYBVUJVYIYFXJYIXMUVKUVLUYEVVLVXLUVMVXTVXJU
      DMZVFHZGWUAUMLZSVGZUDYEVXKUYHJVXJWUDVVTUDEUDEWLZWUBVVRWUCSVVSSWUAVUIVFWMW
      UAVUIGUMWNWUESWOWPUVNVVMVXLWIUVRVYKYJUVOUVPVVMVXLOVVTEYEZVYEVVTEYEZUYHFLZ
      JNZWUFUYHUNLZWUGJNUYLVVMVXLWUGVXKFLZWUHJNWUIVVMVXKUYHWUGVVMVVTEBVXIVXJVXJ
      YJZVVMVXIVYMUVQVVMVUIVXJHZTZVVOVWAVVMVYLWUMVVOVYMGVUIVXIOVAUVSUVTVWEYKVWC
      WUNVWDRVVMUYEFBVXIUHUYDHUYEVVLUWAZVVMEBGVXIOVAVYMVVMVVOTZVVPVVTYLVVOVWAVV
      MVWEVIZVVTYLHZWUPVVTVWDUWBZRZXBUWCXQUWDVWSVVMVWTRZVVMWUGUYKIVVMVVTEBGUYJV
      VMVUIVYEHZTZVVOVWAWVBVVOVVMVUIUYJUWEVIVWEYKVVMUYJOGYDUOVVNVAUWFWURWVCWUSR
      UWGZVVKXBZUWHVVMWUFWUKWUHJVVMWUFGVXIGUNLZYGLZVVTEYEZVXKFLWUKVVMVVTEBGVXIV
      XJOVAWULVYMWUQWUTWUOUWIVVMWVHWUGVXKFVVMWVGVYEVVTEVVMWVFUYJGYGVVMUYJYLHZGY
      LHZWVFUYJWKVVLWVIUYEUYJUWJVIZYMUYJGUWKVKYNUWLYOYPUWMUWNVVMWUFUYHWUGUYEWUF
      IHVVLUYEWUFUYGIUYEUCVVTDEBUYCGOVAUYCYJVVHVWFVWGVWKVWLUWOZVWPXBWJWVAWVEUWR
      VVMWUJUYIWUGUYKJVVMWUFUYGUYHUNUYEWUFUYGWKVVLWVLWJYOWVDYQUWPVVMVXOVXCVXRVX
      CJVVMVXOVXCKXRLZKUMLZVXCVVMVXNWVMKUMVVMKVXIKXRLZXSLKVXBGFLZXSLZVXNWVMVVMW
      VOWVPKXSVVMKVXIXRLZVXAKGXRLZFLZWVOWVPVVMKUYJGKYLHZVVMYRRZWVKWVJVVMYMRZUWQ
      VVMVXIYLHWWAWVOWVRWKVVMVXIVYMYSYRVXIKUWSVKVVMWVPVXAGGFLZFLWVTVVMVXAGGVVMV
      XAVXGYSWWCWWCYTWVSWWDVXAFGYMUWTUXHUXAUXBYNVVMKVXIKWWBKXTHVVMUXCRVYNUXDVVM
      WWAVXEWVQWVMWKYRVXHKVXBUXEYBUXFYOVVMVXCYLHZWVNVXCWKZVVMWWAVXEWWEYRVXHKVXB
      UXGYBWWEWWAKSVBWWFYRUXIVXCKUXJUXKYKYPVVMKUYJVXIFLZXSLVXPVXMXRLVXCVXRVVMKU
      YJVXIWWBVYNVVLUYJXTHUYEUYJUXLVIUXMVVMVXBWWGKXSVVMVXBUYJUYJFLZGFLWWGVVMVXA
      WWHGFVVMUYJWVKUXNYOVVMUYJUYJGWVKWVKWWCYTYPYNVVMVXQVXMVXPXRVVMVXMIHSVXMPNT
      VXQVXMWKVVMVXMVVMVXMVYOUXOUXPVXMUXRYKYNUXQYQUXSUXTUYAUYB $.
  $}

  ${
    $d k m n $.
    prmrec.f $e |- F = ( n e. NN |->
      sum_ k e. ( Prime i^i ( 1 ... n ) ) ( 1 / k ) ) $.
    $( The sum of the reciprocals of the primes diverges.  This is the "second"
       proof at ~ http://en.wikipedia.org/wiki/Prime_harmonic_series ,
       attributed to Paul Erd&#337;s.  (Contributed by Mario Carneiro,
       6-Aug-2014.) $)
    prmrec $p |- -. F e. dom ~~> $=
      ( vm wcel cn cv cprime c1 cdiv co cc0 cif cmpt wceq csu cfv cc wa cli cdm
      caddc cseq eleq1 oveq2 eqidd ifbieq12d cbvmptv prmreclem6 cfz cin wss cuz
      wral cfn wo inss2 sseli elfznn nnrecre recnd 3syl rgen pm3.2i fzfi sumss2
      olci mp2an elin rbaib ifbid sumeq2i eqtri adantl wtru prmnn syl wn ifclda
      0cn a1i trud fvmpt2 sylancl id syl6eleq fsumser syl5eq mpteq2ia wfn cz 1z
      nnuz seqfn ax-mp fneq2i mpbir dffn5 mpbi 3eqtr4i eleq1i mtbir ) CUAUBZFUC
      EGEHZIFZJXEKLZMNZOZJUDZXDFAXIEAGXHAHZIFZJXKKLZMNZXEXKPZXFXLXGMXMMXEXKIUEX
      EXKJKUFXOMUGUHUIZUJCXJXDBGIJBHZUKLZULZXMAQZOBGXQXJRZOZCXJBGXTYAXQGFZXTXRX
      NAQZYAXTXRXKXSFZXMMNZAQZYDXSXRUMZXMSFZAXSUOZTXRJUNRZUMZXRUPFZUQXTYGPYHYJI
      XRURZYIAXSYEXKXRFZXKGFZYIXSXRXKYNUSXKXQUTZYPXMXKVAVBZVCVDVEYMYLJXQVFVHXSX
      RXMAJVGVIXRYFXNAYOYEXLXMMYEXLYOXKIXRVJVKVLVMVNYCXNAXIJXQYCYOTZYPXNSFZXKXI
      RXNPYOYPYCYQVOYTVPXLXMMSXLYIVPXLYPYIXKVQYRVRVOMSFVPXLVSTWAWBVTWCZAGXNSXIX
      PWDWEYCXQGYKYCWFWNWGYTYSUUAWBWHWIWJDXJGWKZXJYBPUUBXJYKWKZJWLFUUCWMUCXIJWO
      WPGYKXJWNWQWRBGXJWSWTXAXBXC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Fundamental theorem of arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d e f g k n p q x y z $.  $d q x y F $.  $d e f g q x y M $.  $d q y ph $.
    $d n p q x G $.  $d n p q x N $.  $d p P $.  $d f g n q x y R $.
    1arith.1 $e |- M = ( n e. NN |-> ( p e. Prime |-> ( p pCnt n ) ) ) $.
    $( Lemma for ~ 1arith .  (Contributed by Mario Carneiro, 30-May-2014.) $)
    1arithlem1 $p |- ( N e. NN ->
                       ( M ` N ) = ( p e. Prime |-> ( p pCnt N ) ) ) $=
      ( cprime cv cpc co cmpt cn wceq oveq2 mpteq2dv zex prmz ssriv ssexi mptex
      cz fvmpt ) ACDFDGZAGZHIZJDFUBCHIZJKBUCCLDFUDUEUCCUBHMNEDFUEFTOAFTUCPQRSUA
      $.

    $( Lemma for ~ 1arith .  (Contributed by Mario Carneiro, 30-May-2014.) $)
    1arithlem2 $p |- ( ( N e. NN /\ P e. Prime ) ->
                       ( ( M ` N ) ` P ) = ( P pCnt N ) ) $=
      ( cn wcel cprime cfv cv cpc cmpt 1arithlem1 fveq1d oveq1 eqid ovex fvmpt
      co sylan9eq ) DGHZAIHADCJZJAEIEKZDLTZMZJADLTZUBAUCUFBCDEFNOEAUEUGIUFUDADL
      PUFQADLRSUA $.

    $( Lemma for ~ 1arith .  (Contributed by Mario Carneiro, 30-May-2014.) $)
    1arithlem3 $p |- ( N e. NN -> ( M ` N ) : Prime --> NN0 ) $=
      ( cn wcel cprime cn0 cfv wf cv cpc cmpt pccl ancoms eqid fmptd 1arithlem1
      co feq1d mpbird ) CFGZHICBJZKHIDHDLZCMTZNZKUCDHUFIUGUEHGUCUFIGUECOPUGQRUC
      HIUDUGABCDESUAUB $.

    ${
      1arithlem4.2 $e |- G = ( y e. NN |->
                               if ( y e. Prime , ( y ^ ( F ` y ) ) , 1 ) ) $.
      1arithlem4.3 $e |- ( ph -> F : Prime --> NN0 ) $.
      1arithlem4.4 $e |- ( ph -> N e. NN ) $.
      1arithlem4.5 $e |- ( ( ph /\ ( q e. Prime /\ N <_ q ) ) ->
                           ( F ` q ) = 0 ) $.
      $( Lemma for ~ 1arith .  (Contributed by Mario Carneiro, 30-May-2014.) $)
      1arithlem4 $p |- ( ph -> E. x e. NN F = ( M ` x ) ) $=
        ( cfv cn wceq cn0 cprime cmul c1 cseq wcel cv wrex wf ffvelrnda pcmptcl
        ralrimiva simprd ffvelrnd wral wa cpc cle wbr cc0 cif 1arithlem2 adantr
        co sylan simpr fveq2 pcmpt nnred prmz zred adantl ifid anassrs syl5reqr
        cr ifeq2d iftrue lecasei 3eqtrrd wb 1arithlem3 syl eqfnfv syl2an mpbird
        wfn ffn syl2anc eqeq2d rspcev ) AHUAFUBUCZPZQUDZEWKGPZRZEBUEZGPZRZBQUFA
        QQHWJAQQFUGQQWJUGACUEZEPZCFLAWSSUDZCTATSWREMUHUJZUIUKNULZAWNIUEZEPZXCWM
        PZRZITUMZAXFITAXCTUDZUNZXEXCWKUOVBZXCHUPUQZXDURUSZXDAWLXHXEXJRXBXCDGWKJ
        KUTVCXIWSXDXCCFHLAWTCTUMXHXAVAAHQUDXHNVAZAXHVDWRXCEVEVFXIXLXDRZHXCXIHXM
        VGXHXCVNUDAXHXCXCVHVIVJXIHXCUPUQZUNZXDXKXDXDUSXLXKXDVKXPXKXDURXDAXHXOXD
        URROVLVOVMXKXNXIXKXDURVPVJVQVRUJATSEUGZTSWMUGZWNXGVSZMAWLXRXBDGWKJKVTWA
        XQETWEWMTWEXSXRTSEWFTSWMWFITEWMWBWCWGWDWQWNBWKQWOWKRWPWMEWOWKGVEWHWIWG
        $.
    $}

    1arith.2 $e |- R = { e e. ( NN0 ^m Prime ) | ( `' e " NN ) e. Fin } $.
    $( Fundamental theorem of arithmetic, where a prime factorization is
       represented as a sequence of prime exponents, for which only finitely
       many primes have nonzero exponent.  The function ` M ` maps the set of
       positive integers one-to-one onto the set of prime factorizations
       ` R ` .  (Contributed by Paul Chapman, 17-Nov-2012.)  (Proof shortened
       by Mario Carneiro, 30-May-2014.) $)
    1arith $p |- M : NN -1-1-onto-> R $=
      ( vx vq cn cv cfv wceq wcel cprime cn0 wa wbr cle cr vy vf vk vg wf1o wf1
      wfo wf wi wral wfn cpc co cmpt cz prmz ssriv ssexi mptex fnmpti cmap ccnv
      zex cima cfn 1arithlem3 nn0ex elmap sylibr cfz wss fzfi ffn elpreima 3syl
      c1 wb 1arithlem2 eleq1d cdivides id dvdsle syl2anr pcelnn ancoms cuz nnuz
      prmnn syl6eleq nnz elfz5 3imtr4d expimpd ssrdv ssfi sylancr cnveq imaeq1d
      sylbid elrab2 sylanbrc rgen ffnfv mpbir2an adantlr adantll eqeq12d eqfnfv
      ralbidva syl2an nnnn0 pc11 3bitr4d biimpd dff13 wrex cdm cnvimass simplbi
      rgen2a sylib fdm syl zssre sstri syl6eqss syl5ss simprbi fimaxre2 syl2anc
      cexp cif cc0 cfl simplr 0re wn clt adantr mpd caddc eqid ad2antrr sylancl
      ifcl max1 flge0nn0 nn0p1nn nnred simprl sseldi max2 flltp1 lelttrd simprr
      ltletrd ltnled mpbid biantrurd bitr4d breq1 rspccv mtod wo ffvelrnd elnn0
      ord 1arithlem4 ex rexlimdva dffo3 df-f1o ) JADUEJADUFZJADUGZUVMJADUHZHKZD
      LZUAKZDLZMZUVPUVRMZUIZUAJUJHJUJUVODJUKUVQANZHJUJCJEOEKCKULUMZUNDEOUWDOUOV
      CIOUOIKZUPZUQZURZUSFUTUWCHJUVPJNZUVQPOVAUMZNZUVQVBZJVDZVENZUWCUWIOPUVQUHZ
      UWKCDUVPEFVFZPOUVQVGUWHVHVIUWIVPUVPVJUMZVENUWMUWQVKUWNVPUVPVLUWIIUWMUWQUW
      IUWEUWMNZUWEONZUWEUVQLZJNZQZUWEUWQNZUWIUWOUVQOUKZUWRUXBVQUWPOPUVQVMZOUWEJ
      UVQVNVOUWIUWSUXAUXCUWIUWSQZUXAUWEUVPULUMZJNZUXCUXFUWTUXGJUWECDUVPEFVRZVSU
      XFUWEUVPVTRZUWEUVPSRZUXHUXCUWSUWEUONUWIUXJUXKUIUWIUWFUWIWAUWEUVPWBWCUWSUW
      IUXHUXJVQUWEUVPWDWEUWSUWEVPWFLZNUVPUONUXCUXKVQUWIUWSUWEJUXLUWEWHWGWIUVPWJ
      UWEVPUVPWKWCWLWSWMWSWNUWQUWMWOWPBKZVBZJVDZVENZUWNBUVQUWJAUXMUVQMZUXOUWMVE
      UXQUXNUWLJUXMUVQWQWRVSGWTXAXBHJADXCXDZUWBHUAJUWIUVRJNZQZUVTUWAUXTUWTUWEUV
      SLZMZIOUJZUXGUWEUVRULUMZMZIOUJZUVTUWAUXTUYBUYEIOUXTUWSQUWTUXGUYAUYDUWIUWS
      UWTUXGMUXSUXIXEUXSUWSUYAUYDMUWIUWECDUVREFVRXFXGXIUWIUWOOPUVSUHZUVTUYCVQZU
      XSUWPCDUVREFVFUWOUXDUVSOUKUYHUYGUXEOPUVSVMIOUVQUVSXHXJXJUWIUVPPNUVRPNUWAU
      YFVQUXSUVPXKUVRXKUVPUVRIXLXJXMXNXTHUAJADXOXDUVNUVOUBKZUVQMHJXPZUBAUJUXRUY
      JUBAUYIANZUCKZUVRSRZUCUYIVBZJVDZUJZUATXPZUYJUYKUYOTVKUYOVENZUYQUYKUYOUYIX
      QZTUYIJXRUYKUYSOTUYKOPUYIUHZUYSOMUYKUYIUWJNZUYTUYKVUAUYRUXPUYRBUYIUWJAUXM
      UYIMZUXOUYOVEVUBUXNUYNJUXMUYIWQWRVSGWTZXSPOUYIVGUWHVHYAZOPUYIYBYCOUOTUWGY
      DYEZYFYGUYKVUAUYRVUCYHUAUCUYOYIYJUYKUYPUYJUATUYKUVRTNZQZUYPUYJVUGUYPQZHUD
      CUYIUDJUDKZONVUIVUIUYILYKUMVPYLUNZDYMUVRSRZUVRYMYLZYNLZVPUUAUMZIEFVUJUUBU
      YKUYTVUFUYPVUDUUCZVUHVUMPNZVUNJNZVUHVULTNZYMVULSRZVUPVUHVUFYMTNZVURUYKVUF
      UYPYOZYPVUKUVRYMTUUEUUDZVUHVUTVUFVUSYPVVAYMUVRUUFWPVULUUGYJVUMUUHYCZVUHUW
      SVUNUWESRZQZQZUWEUYILZJNZYQVVGYMMZVVFVVHUWEUVRSRZVVFUVRUWEYRRVVJYQVVFUVRV
      UNUWEVUHVUFVVEVVAYSZVVFVUNVUHVUQVVEVVCYSUUIZVVFOTUWEVUEVUHUWSVVDUUJZUUKZV
      VFUVRVULVUNVVKVUHVURVVEVVBYSZVVLVVFVUTVUFUVRVULSRYPVVKYMUVRUULWPVVFVURVUL
      VUNYRRVVOVULUUMYCUUNVUHUWSVVDUUOUUPVVFUVRUWEVVKVVNUUQUURVVFVVHUWEUYONZVVJ
      VVFVVHUWSVVHQZVVPVVFUWSVVHVVMUUSVVFUYTUYIOUKVVPVVQVQVUHUYTVVEVUOYSZOPUYIV
      MOUWEJUYIVNVOUUTVVFUYPVVPVVJUIVUGUYPVVEYOUYMVVJUCUWEUYOUYLUWEUVRSUVAUVBYC
      WSUVCVVFVVHVVIVVFVVGPNVVHVVIUVDVVFOPUWEUYIVVRVVMUVEVVGUVFYAUVGYTUVHUVIUVJ
      YTXBHUBJADUVKXDJADUVLXD $.

    $( Fundamental theorem of arithmetic, where a prime factorization is
       represented as a finite monotonic 1-based sequence of primes.  Every
       positive integer has a unique prime factorization.  (Contributed by Paul
       Chapman, 17-Nov-2012.)  (Revised by Mario Carneiro, 30-May-2014.) $)
    1arith2 $p |- A. z e. NN E! g e. R ( M ` z ) = g $=
      ( cv cfv wceq wreu cn wcel ccnv wf1o 1arith f1ocnv ax-mp f1ocnvfvb mp3an1
      f1ofveu mpan wb reubidva mpbird rgen ) AJZFKDJZLZDBMZANUINOZULUJFPZKUILZD
      BMZBNUNQZUMUPNBFQZUQBCEFGHIRZNBFSTDBNUIUNUCUDUMUKUODBURUMUJBOUKUOUEUSNBUI
      UJFUAUBUFUGUH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Lagrange's four-square theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Z[i] $.

  $( Extend class notation with the set of gaussian integers. $)
  cgz $a class Z[i] $.

  $( Define the set of gaussian integers, which are complex numbers whose real
     and imaginary parts are integers.  (Note that the ` [ _i ] ` is actually
     part of the symbol token and has no independent meaning.)  (Contributed by
     Mario Carneiro, 14-Jul-2014.) $)
  df-gz $a |- Z[i] = { x e. CC | ( ( Re ` x ) e. ZZ /\ ( Im ` x ) e. ZZ ) } $.

  ${
    $d x A $.
    $( Elementhood in the gaussian integers.  (Contributed by Mario Carneiro,
       14-Jul-2014.) $)
    elgz $p |- ( A e. Z[i] <->
      ( A e. CC /\ ( Re ` A ) e. ZZ /\ ( Im ` A ) e. ZZ ) ) $=
      ( vx cgz wcel cc cre cfv cz cim wa w3a cv wceq fveq2 eleq1d anbi12d df-gz
      elrab2 3anass bitr4i ) ACDAEDZAFGZHDZAIGZHDZJZJUAUCUEKBLZFGZHDZUGIGZHDZJU
      FBAECUGAMZUIUCUKUEULUHUBHUGAFNOULUJUDHUGAINOPBQRUAUCUEST $.
  $}

  $( A gaussian integer is a complex number.  (Contributed by Mario Carneiro,
     14-Jul-2014.) $)
  gzcn $p |- ( A e. Z[i] -> A e. CC ) $=
    ( cgz wcel cc cre cfv cz cim elgz simp1bi ) ABCADCAEFGCAHFGCAIJ $.

  $( An integer is a gaussian integer.  (Contributed by Mario Carneiro,
     14-Jul-2014.) $)
  zgz $p |- ( A e. ZZ -> A e. Z[i] ) $=
    ( cz wcel cc cre cfv cim cgz zcn zre rered eqeltrd cc0 reim0d syl6eqel elgz
    id 0z syl3anbrc ) ABCZADCAEFZBCAGFZBCAHCAITUAABTAAJZKTQLTUBMBTAUCNROAPS $.

  $( ` _i ` is a gaussian integer.  (Contributed by Mario Carneiro,
     14-Jul-2014.) $)
  igz $p |- _i e. Z[i] $=
    ( ci cgz wcel cc cre cfv cz cim ax-icn cc0 rei 0z eqeltri imi elgz mpbir3an
    c1 1z ) ABCADCAEFZGCAHFZGCISJGKLMTQGNRMAOP $.

  $( The gaussian integers are closed under negation.  (Contributed by Mario
     Carneiro, 14-Jul-2014.) $)
  gznegcl $p |- ( A e. Z[i] -> -u A e. Z[i] ) $=
    ( cgz wcel cneg cre cfv cim gzcn negcld renegd elgz simp2bi znegcld eqeltrd
    cc cz imnegd simp3bi syl3anbrc ) ABCZADZOCUAEFZPCUAGFZPCUABCTAAHZITUBAEFZDP
    TAUDJTUETAOCZUEPCZAGFZPCZAKZLMNTUCUHDPTAUDQTUHTUFUGUIUJRMNUAKS $.

  $( The gaussian integers are closed under conjugation.  (Contributed by Mario
     Carneiro, 14-Jul-2014.) $)
  gzcjcl $p |- ( A e. Z[i] -> ( * ` A ) e. Z[i] ) $=
    ( cgz wcel ccj cfv cc cre cz cim gzcn cjcld recjd elgz simp2bi eqeltrd cneg
    imcjd simp3bi znegcld syl3anbrc ) ABCZADEZFCUBGEZHCUBIEZHCUBBCUAAAJZKUAUCAG
    EZHUAAUELUAAFCZUFHCZAIEZHCZAMZNOUAUDUIPHUAAUEQUAUIUAUGUHUJUKRSOUBMT $.

  $( The gaussian integers are closed under addition.  (Contributed by Mario
     Carneiro, 14-Jul-2014.) $)
  gzaddcl $p |- ( ( A e. Z[i] /\ B e. Z[i] ) -> ( A + B ) e. Z[i] ) $=
    ( cgz wcel wa caddc co cc cre cfv cim gzcn syl2an wceq elgz simp2bi eqeltrd
    cz zaddcl simp3bi addcl readd imadd syl3anbrc ) ACDZBCDZEZABFGZHDZUHIJZRDUH
    KJZRDUHCDUEAHDZBHDZUIUFALZBLZABUAMUGUJAIJZBIJZFGZRUEULUMUJURNUFUNUOABUBMUEU
    PRDZUQRDZURRDUFUEULUSAKJZRDZAOZPUFUMUTBKJZRDZBOZPUPUQSMQUGUKVAVDFGZRUEULUMU
    KVGNUFUNUOABUCMUEVBVEVGRDUFUEULUSVBVCTUFUMUTVEVFTVAVDSMQUHOUD $.

  $( The gaussian integers are closed under multiplication.  (Contributed by
     Mario Carneiro, 14-Jul-2014.) $)
  gzmulcl $p |- ( ( A e. Z[i] /\ B e. Z[i] ) -> ( A x. B ) e. Z[i] ) $=
    ( cgz wcel wa cmul co cc cre cfv cz gzcn syl2an wceq simp2bi zmulcl simp3bi
    cim elgz eqeltrd mulcl cmin remul zsubcld caddc immul zaddcld syl3anbrc ) A
    CDZBCDZEZABFGZHDZULIJZKDULRJZKDULCDUIAHDZBHDZUMUJALZBLZABUAMUKUNAIJZBIJZFGZ
    ARJZBRJZFGZUBGZKUIUPUQUNVFNUJURUSABUCMUKVBVEUIUTKDZVAKDZVBKDUJUIUPVGVCKDZAS
    ZOZUJUQVHVDKDZBSZOZUTVAPMUIVIVLVEKDUJUIUPVGVIVJQZUJUQVHVLVMQZVCVDPMUDTUKUOU
    TVDFGZVCVAFGZUEGZKUIUPUQUOVSNUJURUSABUFMUKVQVRUIVGVLVQKDUJVKVPUTVDPMUIVIVHV
    RKDUJVOVNVCVAPMUGTULSUH $.

  $( Construct a gaussian integer from real and imaginary parts.  (Contributed
     by Mario Carneiro, 16-Jul-2014.) $)
  gzreim $p |- ( ( A e. ZZ /\ B e. ZZ ) -> ( A + ( _i x. B ) ) e. Z[i] ) $=
    ( cz wcel cgz ci cmul co caddc zgz igz gzmulcl sylancr gzaddcl syl2an ) ACD
    AEDFBGHZEDZAPIHEDBCDZAJRFEDBEDQKBJFBLMAPNO $.

  $( The gaussian integers are closed under subtraction.  (Contributed by Mario
     Carneiro, 14-Jul-2014.) $)
  gzsubcl $p |- ( ( A e. Z[i] /\ B e. Z[i] ) -> ( A - B ) e. Z[i] ) $=
    ( cgz wcel wa cneg caddc co cmin cc wceq gzcn negsub syl2an gznegcl gzaddcl
    sylan2 eqeltrrd ) ACDZBCDZEABFZGHZABIHZCSAJDBJDUBUCKTALBLABMNTSUACDUBCDBOAU
    APQR $.

  $( The squared norm of a gaussian integer is an integer.  (Contributed by
     Mario Carneiro, 16-Jul-2014.) $)
  gzabssqcl $p |- ( A e. Z[i] -> ( ( abs ` A ) ^ 2 ) e. NN0 ) $=
    ( cgz wcel cabs cfv c2 cexp co cre cim caddc cn0 gzcn absvalsq2d cz cc elgz
    simp2bi zsqcl2 syl simp3bi nn0addcld eqeltrd ) ABCZADEFGHAIEZFGHZAJEZFGHZKH
    LUDAAMNUDUFUHUDUEOCZUFLCUDAPCZUIUGOCZAQZRUESTUDUKUHLCUDUJUIUKULUAUGSTUBUC
    $.

  ${
    4sqlem5.2 $e |- ( ph -> A e. ZZ ) $.
    4sqlem5.3 $e |- ( ph -> M e. NN ) $.
    4sqlem5.4 $e |- B = ( ( ( A + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
    $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 15-Jul-2014.) $)
    4sqlem5 $p |- ( ph -> ( B e. ZZ /\ ( ( A - B ) / M ) e. ZZ ) ) $=
      ( cz wcel cmin co cdiv zcnd c2 caddc cmo cc recnd subcld eqeltrrd zred cr
      nnred readdcld nnrpd modcld syl5eqel nncand cmul nnne0d divcan1d subsub3d
      oveq2i syl5eq oveq1d crp moddifz syl2anc eqeltrd nnzd zmulcld zsubcld jca
      rehalfcld ) ACHIBCJKZDLKZHIABVEJKCHABCABEMZACBDNLKZOKZDPKZVHJKZQGAVJVHAVJ
      AVIDABVHABEUAADADFUCZVDZUDZADFUEZUFRZAVHVMRZSUGZUHABVEEAVFDUIKVEHAVEDABCV
      GVRSADVLRADFUJUKAVFDAVFVIVJJKZDLKZHAVEVSDLAVEBVKJKVSCVKBJGUMABVJVHVGVPVQU
      LUNUOAVIUBIDUPIVTHIVNVOVIDUQURUSZADFUTVATVBTWAVC $.

    $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 15-Jul-2014.) $)
    4sqlem6 $p |- ( ph -> ( -u ( M / 2 ) <_ B /\ B < ( M / 2 ) ) ) $=
      ( c2 cdiv co cneg cle wbr clt cc0 cmin caddc cr wcel syl2anc cmo 0re zred
      a1i nnred rehalfcld readdcld nnrpd modcld crp modge0 df-neg 3brtr4g modlt
      lesub1dd nncnd 2halvesd breqtrrd ltsubaddd mpbird syl5eqbr jca ) ADHIJZKZ
      CLMCVCNMAOVCPJBVCQJZDUAJZVCPJZVDCLAOVFVCORSAUBUDAVEDABVCABEUCADADFUEUFZUG
      ZADFUHZUIZVHAVERSZDUJSZOVFLMVIVJVEDUKTUOVCULGUMACVGVCNGAVGVCNMVFVCVCQJZNM
      AVFDVNNAVLVMVFDNMVIVJVEDUNTADADFUPUQURAVFVCVCVKVHVHUSUTVAVB $.

    $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 15-Jul-2014.) $)
    4sqlem7 $p |- ( ph -> ( B ^ 2 ) <_ ( ( ( M ^ 2 ) / 2 ) / 2 ) ) $=
      ( c2 cexp co cdiv cle wbr cneg cz wcel simpld cr cc0 a1i cmin nnrpd rpred
      4sqlem5 zred rphalfcld clt 4sqlem6 simprd ltled lenegcon1d rpge0d lenegsq
      wa wb syl3anc mpbi2and cmul 2cn sqvald oveq2d nncnd wne 2ne0 sqdivd sqcld
      cc divdiv1d 3eqtr4d breqtrd ) ACHIJZDHKJZHIJZDHIJZHKJHKJZLACVLLMZCNVLLMZV
      KVMLMZACVLACACOPBCUAJDKJOPABCDEFGUDQUEZAVLADADFUBUFZUCZAVLNCLMZCVLUGMZABC
      DEFGUHZUIUJAVLCWAVSAWBWCWDQUKACRPVLRPSVLLMVPVQUNVRUOVSWAAVLVTULCVLUMUPUQA
      VNHHIJZKJVNHHURJZKJVMVOAWEWFVNKAHHVGPAUSTZUTVAADHADFVBZWGHSVCAVDTZVEAVNHH
      ADWHVFWGWGWIWIVHVIVJ $.

    $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 15-Jul-2014.) $)
    4sqlem8 $p |- ( ph -> M || ( ( A ^ 2 ) - ( B ^ 2 ) ) ) $=
      ( cmin co cdivides wbr c2 cexp cz wcel zsubcld syl3anc syl2anc cc zcnd wb
      cdiv 4sqlem5 simprd cc0 wne nnzd nnne0d simpld dvdsval2 mpbird caddc cmul
      zaddcld dvdsmul2 wceq subsq breqtrrd wa wi zsqcl syl dvdstr mp2and ) ADBC
      HIZJKZVEBLMIZCLMIZHIZJKZDVIJKZAVFVEDUBINOZACNOZVLABCDEFGUCZUDADNOZDUEUFVE
      NOZVFVLUAADFUGZADFUHABCEAVMVLVNUIZPZDVEUJQUKAVEBCULIZVEUMIZVIJAVTNOVPVEWA
      JKABCEVRUNVSVTVEUORABSOCSOVIWAUPABETACVRTBCUQRURAVOVPVINOVFVJUSVKUTVQVSAV
      GVHABNOVGNOEBVAVBAVMVHNOVRCVAVBPDVEVIVCQVD $.

    ${
      4sqlem9.5 $e |- ( ( ph /\ ps ) -> ( B ^ 2 ) = 0 ) $.
      $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 15-Jul-2014.) $)
      4sqlem9 $p |- ( ( ph /\ ps ) -> ( M ^ 2 ) || ( A ^ 2 ) ) $=
        ( cdivides c2 cexp co cdiv cz wcel cmin cc0 wb adantr wa wbr cc 4sqlem5
        wceq simpld zcnd sqeq0 biimpa syldan oveq2d subid1d eqtrd oveq1d simprd
        syl eqeltrrd nnzd nnne0d dvdsval2 syl3anc mpbird dvdssq syl2anc mpbid
        wne ) ABUAZECJUBZEKLMCKLMJUBZVGVHCENMZOPZVGCDQMZENMZVJOVGVLCENVGVLCRQMC
        VGDRCQABDKLMRUEZDRUEZIAVNVOADUCPVNVOSADADOPZVMOPZACDEFGHUDZUFUGDUHUPUIU
        JUKVGCVGCACOPZBFTZUGULUMUNAVQBAVPVQVRUOTUQAVHVKSZBAEOPZERVFVSWAAEGURZAE
        GUSFECUTVATVBVGWBVSVHVISAWBBWCTVTECVCVDVE $.
    $}

    4sqlem10.5 $e |- ( ( ph /\ ps ) ->
      ( ( ( ( M ^ 2 ) / 2 ) / 2 ) - ( B ^ 2 ) ) = 0 ) $.
    $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 16-Jul-2014.) $)
    4sqlem10 $p |- ( ( ph /\ ps ) ->
      ( M ^ 2 ) || ( ( A ^ 2 ) - ( ( ( M ^ 2 ) / 2 ) / 2 ) ) ) $=
      ( c2 cexp co cdiv cmul cmin cdivides wbr cc0 cz wcel wa caddc wceq adantr
      cmo cneg cn nnred rehalfcld recnd negnegd 4sqlem5 simpld zred cle 4sqlem6
      wn clt simprd ltned neneqd wo 2cn a1i sqvald oveq2d nncnd wne 2ne0 sqdivd
      cc sqcld divdiv1d 3eqtr4d halfcld zcnd subeq0d eqtr2d wb sqeqor mpbid ord
      syl2anc mpd eqeltrrd znegcld zaddcld nnrpd modcld df-neg 3eqtr3g subcan2d
      0cn dvdsval3 mpbird nnzd dvdssq nnne0d dvdsmulcr syl112anc eqbrtrd wi syl
      zsqcl zmulcld dvds2sub syl3anc mp2and oveq1d subdid 2halvesd eqtr3d subsq
      pnpcan2d 3eqtr2d breqtrd ) ABUAZEJKLZCEJMLZUBLZJKLZXTENLZOLZCJKLZXRJMLZJM
      LZOLZPXQXRYAPQZXRYBPQZXRYCPQZXQEXTPQZYHXQYKXTEUELZRUCZXQYLRXSXQYLXQXTEXQX
      TXQCXSACSTBFUDZXQXSUFZUFXSSXQXSXQXSXQEXQEAEUGTZBGUDZUHUIUJZUKXQYOXQDYOSXQ
      DXSUCZUQDYOUCZXQDXSXQDXSXQDXQDSTZCDOLEMLSTZAUUAUUBUABACDEFGHULUDUMZUNXQYO
      DUOQZDXSURQZAUUDUUEUABACDEFGHUPUDUSUTVAXQYSYTXQDJKLZXSJKLZUCZYSYTVBZXQUUG
      YFUUFXQXRJJKLZMLXRJJNLZMLUUGYFXQUUJUUKXRMXQJJVKTXQVCVDZVEVFXQEJXQEYQVGZUU
      LJRVHXQVIVDZVJXQXRJJXQEUUMVLZUULUULUUNUUNVMVNZXQYFUUFXQYEXQXRUUOVOVOXQDXQ
      DUUCVPZVLIVQVRXQDVKTXSVKTZUUHUUIVSUUQYRDXSVTWCWAWBWDZUUCWEWFWEWGZUNXQEYQW
      HWIUJRVKTXQWMVDYRXQDYOYLXSOLRXSOLUUSHXSWJWKWLXQYPXTSTZYKYMVSYQUUTEXTWNWCW
      OZXQESTZUVAYKYHVSXQEYQWPZUUTEXTWQWCWAXQXREENLZYBPXQEUUMVEXQUVEYBPQZYKUVBX
      QUVCUVAUVCERVHUVFYKVSUVDUUTUVDXQEYQWREEXTWSWTWOXAXQXRSTZYASTZYBSTYHYIUAYJ
      XBXQUVCUVGUVDEXDXCXQUVAUVHUUTXTXDXCXQXTEUUTUVDXEXRYAYBXFXGXHXQYCXTXTNLZYB
      OLXTXTEOLZNLZYGXQYAUVIYBOXQXTXQXTUUTVPZVEXIXQXTXTEUVLUVLUUMXJXQUVKXTCXSOL
      ZNLZYDUUGOLZYGXQUVJUVMXTNXQXTXSXSUBLZOLUVJUVMXQUVPEXTOXQEUUMXKVFXQCXSXSXQ
      CYNVPZYRYRXNXLVFXQCVKTUURUVOUVNUCUVQYRCXSXMWCXQUUGYFYDOUUPVFXOXOXP $.
  $}

  ${
    $d a b c d n w x y z $.  $d a b c d n B $.  $d n E $.  $d n G $.  $d n H $.
    $d a b c d j k n v A $.  $d a b c d n C $.  $d a b c d n D $.  $d j n F $.
    $d a b c d i k n u M $.  $d k m n u v N $.  $d a b c d i j k m n u v P $.
    $d a b c d j k m n u v ph $.  $d a b c d i j k m n u v S $.  $d k u T $.
    $d i R $.
    4sq.1 $e |- S = { n | E. x e. ZZ E. y e. ZZ E. z e. ZZ E. w e. ZZ
      n = ( ( ( x ^ 2 ) + ( y ^ 2 ) ) + ( ( z ^ 2 ) + ( w ^ 2 ) ) ) } $.
    $( Lemma for ~ 4sq .  The set ` S ` is the set of all numbers that are
       expressible as a sum of four squares.  Our goal is to show that
       ` S = NN0 ` ; here we show one subset direction.  (Contributed by Mario
       Carneiro, 14-Jul-2014.) $)
    4sqlem1 $p |- S C_ NN0 $=
      ( cv c2 cexp co caddc cz wrex cn0 wcel wa zsqcl2 nn0addcl syl2an wceq cab
      wi eleq1a syl rexlimdvva rexlimivv abssi eqsstri ) EFHZAHZIJKZBHZIJKZLKZC
      HZIJKZDHZIJKZLKZLKZUAZDMNCMNZBMNAMNZFUBOGVDFOVCUJOPZABMMUKMPZUMMPZQZVBVEC
      DMMVHUPMPZURMPZQZQVAOPZVBVEUCVHUOOPZUTOPZVLVKVFULOPUNOPVMVGUKRUMRULUNSTVI
      UQOPUSOPVNVJUPRURRUQUSSTUOUTSTVAOUJUDUEUFUGUHUI $.

    $( Lemma for ~ 4sq .  Change bound variables in ` S ` .  (Contributed by
       Mario Carneiro, 14-Jul-2014.) $)
    4sqlem2 $p |- ( A e. S <-> E. a e. ZZ E. b e. ZZ E. c e. ZZ E. d e. ZZ
      A = ( ( ( a ^ 2 ) + ( b ^ 2 ) ) + ( ( c ^ 2 ) + ( d ^ 2 ) ) ) ) $=
      ( wcel cv c2 cexp co caddc cz wrex wceq cab eleq2i wa wi id ovex syl6eqel
      cvv a1i rexlimdvva rexlimivv oveq1 oveq1d eqeq2d 2rexbidv oveq2d cbvrex2v
      weq eqeq1 syl5bb elab3 bitri ) EFMEGNZANZOPQZBNZOPQZRQZCNZOPQZDNZOPQZRQZR
      QZUAZDSTCSTZBSTASTZGUBZMEHNZOPQZINZOPQZRQZJNZOPQZKNZOPQZRQZRQZUAZKSTJSTZI
      STHSTZFVSELUCVRWMGEWLEUIMZHISSVTSMWBSMUDZWKWNJKSSWKWNUEWOWESMWGSMUDUDWKEW
      JUIWKUFWDWIRUGUHUJUKULVRVDWDVNRQZUAZDSTCSTZISTHSTVDEUAZWMVQWRVDWAVHRQZVNR
      QZUAZDSTCSTABHISSAHUSZVPXBCDSSXCVOXAVDXCVIWTVNRXCVFWAVHRVEVTOPUMUNUNUOUPB
      IUSZXBWQCDSSXDXAWPVDXDWTWDVNRXDVHWCWARVGWBOPUMUQUNUOUPURWSWRWLHISSWRVDWJU
      AZKSTJSTWSWLWQXEVDWDWFVMRQZRQZUACDJKSSCJUSZWPXGVDXHVNXFWDRXHVKWFVMRVJWEOP
      UMUNUQUODKUSZXGWJVDXIXFWIWDRXIVMWHWFRVLWGOPUMUQUQUOURWSXEWKJKSSVDEWJUTUPV
      AUPVAVBVC $.

    $( Lemma for ~ 4sq .  Sufficient condition to be in ` S ` .  (Contributed
       by Mario Carneiro, 14-Jul-2014.) $)
    4sqlem3 $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ D e. ZZ ) ) ->
      ( ( ( A ^ 2 ) + ( B ^ 2 ) ) + ( ( C ^ 2 ) + ( D ^ 2 ) ) ) e. S ) $=
      ( vc vd cz c2 cexp co caddc wceq wrex va vb wcel wa cv eqid oveq1d oveq2d
      oveq1 eqeq2d rspc2ev mp3an3 2rexbidv 3expa 4sqlem2 sylibr sylan2 ) GNUCZH
      NUCZUDENUCZFNUCZUDZEOPQZFOPQZRQZGOPQZHOPQZRQZRQZVELUEZOPQZMUEZOPQZRQZRQZS
      ZMNTLNTZVIIUCZURUSVIVISZVQVIUFVPVSVIVEVFVMRQZRQZSLMGHNNVJGSZVOWAVIWBVNVTV
      ERWBVKVFVMRVJGOPUIUGUHUJVLHSZWAVIVIWCVTVHVERWCVMVGVFRVLHOPUIUHUHUJUKULVBV
      QUDVIUAUEZOPQZUBUEZOPQZRQZVNRQZSZMNTLNTZUBNTUANTZVRUTVAVQWLWKVQVIVCWGRQZV
      NRQZSZMNTLNTUAUBEFNNWDESZWJWOLMNNWPWIWNVIWPWHWMVNRWPWEVCWGRWDEOPUIUGUGUJU
      MWFFSZWOVPLMNNWQWNVOVIWQWMVEVNRWQWGVDVCRWFFOPUIUHUGUJUMUKUNABCDVIIJUAUBLM
      KUOUPUQ $.

    $( Lemma for ~ 4sqlem4 .  (Contributed by Mario Carneiro, 14-Jul-2014.) $)
    4sqlem4a $p |- ( ( A e. Z[i] /\ B e. Z[i] ) ->
      ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) ) e. S ) $=
      ( cgz wcel wa cabs cfv c2 cexp co caddc cre cz cim gzcn oveqan12d cc elgz
      absvalsq2d simp2bi simp3bi jca 4sqlem3 syl2an eqeltrd ) EJKZFJKZLEMNOPQZF
      MNOPQZRQESNZOPQEUANZOPQRQZFSNZOPQFUANZOPQRQZRQZGUMUNUOUSUPVBRUMEEUBUFUNFF
      UBUFUCUMUQTKZURTKZLUTTKZVATKZLVCGKUNUMVDVEUMEUDKZVDVEEUEZUGUMVHVDVEVIUHUI
      UNVFVGUNFUDKZVFVGFUEZUGUNVJVFVGVKUHUIABCDUQURUTVAGHIUJUKUL $.

    ${
      $d u A $.
      $( Lemma for ~ 4sq .  We can express the four-square property more
         compactly in terms of gaussian integers, because the norms of gaussian
         integers are exactly sums of two squares.  (Contributed by Mario
         Carneiro, 14-Jul-2014.) $)
      4sqlem4 $p |- ( A e. S <-> E. u e. Z[i] E. v e. Z[i]
        A = ( ( ( abs ` u ) ^ 2 ) + ( ( abs ` v ) ^ 2 ) ) ) $=
        ( wcel cfv c2 cexp co caddc wceq cgz wrex cz va vb vc cabs 4sqlem2 cmul
        vd cv wa ci gzreim adantr adantl cre cim cc gzcn syl absvalsq2d cr crre
        syl2an oveq1d crim oveq12d eqtrd oveqan12d eqcomd eqeq2d oveq2d rspc2ev
        zre fveq2 eqeq1 2rexbidv syl5ibrcom rexlimdvva rexlimivv sylbi 4sqlem4a
        syl3anc wi eleq1a impbii ) GHKZGFUHZUDLZMNOZEUHZUDLZMNOZPOZQZERSFRSZWEG
        UAUHZMNOZUBUHZMNOZPOZUCUHZMNOZUGUHZMNOZPOZPOZQZUGTSUCTSZUBTSUATSWNABCDG
        HIUAUBUCUGJUEXGWNUAUBTTWOTKZWQTKZUIZXFWNUCUGTTXJWTTKZXBTKZUIZUIZWNXFXEW
        LQZERSFRSZXNWOUJWQUFOPOZRKZWTUJXBUFOPOZRKZXEXQUDLZMNOZXSUDLZMNOZPOZQZXP
        XJXRXMWOWQUKZULXMXTXJWTXBUKZUMXNYEXEXJXMYBWSYDXDPXJYBXQUNLZMNOZXQUOLZMN
        OZPOWSXJXQXJXRXQUPKYGXQUQURUSXJYJWPYLWRPXJYIWOMNXHWOUTKZWQUTKZYIWOQXIWO
        VLZWQVLZWOWQVAVBVCXJYKWQMNXHYMYNYKWQQXIYOYPWOWQVDVBVCVEVFXMYDXSUNLZMNOZ
        XSUOLZMNOZPOXDXMXSXMXTXSUPKYHXSUQURUSXMYRXAYTXCPXMYQWTMNXKWTUTKZXBUTKZY
        QWTQXLWTVLZXBVLZWTXBVAVBVCXMYSXBMNXKUUAUUBYSXBQXLUUCUUDWTXBVDVBVCVEVFVG
        VHXOYFXEYBWKPOZQFEXQXSRRWFXQQZWLUUEXEUUFWHYBWKPUUFWGYAMNWFXQUDVMVCVCVIW
        IXSQZUUEYEXEUUGWKYDYBPUUGWJYCMNWIXSUDVMVCVJVIVKWAXFWMXOFERRGXEWLVNVOVPV
        QVRVSWMWEFERRWFRKWIRKUIWLHKWMWEWBABCDWFWIHIJVTWLHGWCURVRWD $.

      mul4sq.1 $e |- ( ph -> A e. Z[i] ) $.
      mul4sq.2 $e |- ( ph -> B e. Z[i] ) $.
      mul4sq.3 $e |- ( ph -> C e. Z[i] ) $.
      mul4sq.4 $e |- ( ph -> D e. Z[i] ) $.
      mul4sq.5 $e |- X = ( ( ( abs ` A ) ^ 2 ) + ( ( abs ` B ) ^ 2 ) ) $.
      mul4sq.6 $e |- Y = ( ( ( abs ` C ) ^ 2 ) + ( ( abs ` D ) ^ 2 ) ) $.
      mul4sq.7 $e |- ( ph -> M e. NN ) $.
      mul4sq.8 $e |- ( ph -> ( ( A - C ) / M ) e. Z[i] ) $.
      mul4sq.9 $e |- ( ph -> ( ( B - D ) / M ) e. Z[i] ) $.
      mul4sq.10 $e |- ( ph -> ( X / M ) e. NN0 ) $.
      $( Lemma for ~ mul4sq : algebraic manipulations.  The extra assumptions
         involving ` M ` are for a part of ~ 4sqlem17 which needs to know not
         just that the product is a sum of squares, but also that it preserves
         divisibility by ` M ` .  (Contributed by Mario Carneiro,
         14-Jul-2014.) $)
      mul4sqlem $p |- ( ph -> ( ( X / M ) x. ( Y / M ) ) e. S ) $=
        ( ccj cfv cmul co caddc cdiv cabs c2 cexp cmin cgz wcel gzcn syl mulcld
        absvalsqd cjcld eqeltrd addcld ppncand cjaddd cjmuld cjcjd oveq1d eqtrd
        oveq2d oveq12d adddid mul4d mulcomd 3eqtr4d eqtr4d 3eqtrd add42d subcld
        adddird wceq cjsub syl2anc subdird subdid subadd4d syl5eq nncnd absdivd
        nnne0d nnred nnnn0d nn0ge0d absidd abscld recnd sqdivd nnsqcld syl5eqel
        divdird divmuldivd sqvald nncand eqtr3d divsubdird divassd cjdivd cjred
        cc addsub4d nn0zd zgz gzcjcl gzmulcl gzaddcl nnncan1d 4sqlem4a eqeltrrd
        cz gzsubcl ) AFUFUGZHUHUIZGIUFUGZUHUIZUJUIZLUKUIZULUGZUMUNUIZYBIUHUIZGH
        UFUGZUHUIZUOUIZLUKUIZULUGZUMUNUIZUJUIZMLUKUIZNLUKUIUHUIZJAYFULUGZUMUNUI
        ZYMULUGZUMUNUIZUJUIZLUMUNUIZUKUIZMNUHUIZUUEUKUIZYQYSAUUDUUGUUEUKAFHUHUI
        ZULUGUMUNUIZGIUHUIZULUGUMUNUIZUJUIZYCGUFUGZIUHUIZUHUIZYLFYDUHUIZUHUIZUJ
        UIZUJUIZFIUHUIZULUGUMUNUIZGHUHUIZULUGUMUNUIZUJUIZUUSUOUIZUJUIUUMUVEUJUI
        ZUUDUUGAUUMUUSUVEAUUJUULAUUJUUIUUIUFUGZUHUIZXJAUUIAFHAFUPUQZFXJUQZPFURU
        SZAHUPUQHXJUQZRHURUSZUTZVAZAUUIUVHUVOAUUIUVOVBUTVCZAUULUUKUUKUFUGZUHUIZ
        XJAUUKAGIAGUPUQZGXJUQZQGURUSZAIUPUQIXJUQZSIURUSZUTZVAZAUUKUVRUWEAUUKUWE
        VBUTVCZVDZAUUPUURAYCUUOAYBHAFUVLVBZUVNUTZAUUNIAGUWBVBZUWDUTZUTZAYLUUQAG
        YKUWBAHUVNVBZUTZAFYDUVLAIUWDVBZUTZUTZVDZAUVBUVDAUVBUVAUVAUFUGZUHUIZXJAU
        VAAFIUVLUWDUTZVAZAUVAUWTUXBAUVAUXBVBUTVCZAUVDUVCUVCUFUGZUHUIZXJAUVCAGHU
        WBUVNUTZVAZAUVCUXEUXGAUVCUXGVBUTVCZVDZVEAUUAUUTUUCUVFUJAUUAYFYFUFUGZUHU
        IYFFYKUHUIZUUOUJUIZUHUIZUUTAYFAYCYEUWJAGYDUWBUWPUTZVDZVAAUXKUXMYFUHAUXK
        YCUFUGZYEUFUGZUJUIUXMAYCYEUWJUXOVFAUXQUXLUXRUUOUJAUXQYBUFUGZYKUHUIUXLAY
        BHUWIUVNVGAUXSFYKUHAFUVLVHZVIVJAUXRUUNYDUFUGZUHUIUUOAGYDUWBUWPVGAUYAIUU
        NUHAIUWDVHVKVJVLVJVKAYCUXMUHUIZYEUXMUHUIZUJUIUUJUUPUJUIZUURUULUJUIZUJUI
        UXNUUTAUYBUYDUYCUYEUJAUYBYCUXLUHUIZUUPUJUIUYDAYCUXLUUOUWJAFYKUVLUWNUTZU
        WLVMAUYFUUJUUPUJAUYFUVIUUJAHYBUHUIZUXLUHUIHFUHUIZYBYKUHUIZUHUIUYFUVIAHY
        BFYKUVNUWIUVLUWNVNAYCUYHUXLUHAYBHUWIUVNVOVIAUUIUYIUVHUYJUHAFHUVLUVNVOAF
        HUVLUVNVGZVLVPUVPVQVIVJAUYCYEUXLUHUIZYEUUOUHUIZUJUIUYEAYEUXLUUOUXOUYGUW
        LVMAUYLUURUYMUULUJAUYLYEYKFUHUIZUHUIYLYDFUHUIZUHUIUURAUXLUYNYEUHAFYKUVL
        UWNVOVKAGYDYKFUWBUWPUWNUVLVNAUYOUUQYLUHAYDFUWPUVLVOVKVRAUYMUVSUULAYEIUU
        NUHUIZUHUIUUKYDUUNUHUIZUHUIUYMUVSAGYDIUUNUWBUWPUWDUWKVNAUUOUYPYEUHAUUNI
        UWKUWDVOVKAUVRUYQUUKUHAUVRUUNYDUHUIZUYQAGIUWBUWDVGZAUUNYDUWKUWPVOVJVKVP
        UWFVQVLVJVLAYCYEUXMUWJUXOAUXLUUOUYGUWLVDWAAUUJUULUUPUURUVQUWGUWMUWRVSVP
        VRZAUUCYMYMUFUGZUHUIYMUUQUUNHUHUIZUOUIZUHUIZUVFAYMAYJYLAYBIUWIUWDUTZUWO
        VTZVAAVUAVUCYMUHAVUAYJUFUGZYLUFUGZUOUIZVUCAYJXJUQYLXJUQVUAVUIWBVUEUWOYJ
        YLWCWDAVUGUUQVUHVUBUOAVUGUXSYDUHUIUUQAYBIUWIUWDVGAUXSFYDUHUXTVIVJAVUHUU
        NYKUFUGZUHUIVUBAGYKUWBUWNVGAVUJHUUNUHAHUVNVHVKVJVLVJVKAVUDYJVUCUHUIZYLV
        UCUHUIZUOUIUVBUUPUOUIZUURUVDUOUIZUOUIUVFAYJYLVUCVUEUWOAUUQVUBUWQAUUNHUW
        KUVNUTZVTWEAVUKVUMVULVUNUOAVUKYJUUQUHUIZYJVUBUHUIZUOUIVUMAYJUUQVUBVUEUW
        QVUOWFAVUPUVBVUQUUPUOAVUPUXAUVBAIYBUHUIZUUQUHUIIFUHUIZYBYDUHUIZUHUIVUPU
        XAAIYBFYDUWDUWIUVLUWPVNAYJVURUUQUHAYBIUWIUWDVOVIAUVAVUSUWTVUTUHAFIUVLUW
        DVOAFIUVLUWDVGZVLVPUXCVQAVUQYJHUUNUHUIZUHUIYCUYPUHUIUUPAVUBVVBYJUHAUUNH
        UWKUVNVOZVKAYBIHUUNUWIUWDUVNUWKVNAUYPUUOYCUHAIUUNUWDUWKVOVKVRVLVJAVULUU
        RYLVUBUHUIZUOUIVUNAYLUUQVUBUWOUWQVUOWFAVVDUVDUURUOAVVDUXFUVDAVVDYLVVBUH
        UIUVCYKUUNUHUIZUHUIUXFAVUBVVBYLUHVVCVKAGYKHUUNUWBUWNUVNUWKVNAVVEUXEUVCU
        HAVVEUUNYKUHUIZUXEAYKUUNUWNUWKVOAGHUWBUVNVGZVQVKVRUXHVQVKVJVLAUVBUUPUUR
        UVDUXDUWMUWRUXIWGVRVRZVLAFYBUHUIZGUUNUHUIZUJUIZHYKUHUIZIYDUHUIZUJUIZUHU
        IZUUJUVBUJUIZUVDUULUJUIZUJUIZUUGUVGAVVOVVIVVNUHUIZVVJVVNUHUIZUJUIVVRAVV
        IVVJVVNAFYBUVLUWIUTZAGUUNUWBUWKUTZAVVLVVMAHYKUVNUWNUTZAIYDUWDUWPUTZVDZW
        AAVVPVVSVVQVVTUJAVVPVVIVVLUHUIZVVIVVMUHUIZUJUIVVSAUUJVWFUVBVWGUJAUUJUVI
        UUIUYJUHUIVWFUVPAUVHUYJUUIUHUYKVKAFHYBYKUVLUVNUWIUWNVNVRAUVBUXAUVAVUTUH
        UIVWGUXCAUWTVUTUVAUHVVAVKAFIYBYDUVLUWDUWIUWPVNVRVLAVVIVVLVVMVWAVWCVWDVM
        VQAVVQVVJVVLUHUIZVVJVVMUHUIZUJUIVVTAUVDVWHUULVWIUJAUVDUXFUVCVVFUHUIVWHU
        XHAUXEVVFUVCUHVVGVKAGHUUNYKUWBUVNUWKUWNVNVRAUULUVSUUKUYRUHUIVWIUWFAUVRU
        YRUUKUHUYSVKAGIUUNYDUWBUWDUWKUWPVNVRVLAVVJVVLVVMVWBVWCVWDVMVQVLVQAMVVKN
        VVNUHAMFULUGUMUNUIZGULUGUMUNUIZUJUIZVVKTAVWJVVIVWKVVJUJAFUVLVAZAGUWBVAZ
        VLWHZANHULUGUMUNUIZIULUGUMUNUIZUJUIVVNUAAVWPVVLVWQVVMUJAHUVNVAAIUWDVAVL
        WHZVLAUUJUULUVBUVDUVQUWGUXDUXIVSVPVPVIAYQUUAUUEUKUIZUUCUUEUKUIZUJUIUUFA
        YIVWSYPVWTUJAYIYTLUKUIZUMUNUIVWSAYHVXAUMUNAYHYTLULUGZUKUIVXAAYFLUXPALUB
        WIZALUBWKZWJAVXBLYTUKALALUBWLZALALUBWMWNWOZVKVJVIAYTLAYTAYFUXPWPWQVXCVX
        DWRVJAYPUUBLUKUIZUMUNUIVWTAYOVXGUMUNAYOUUBVXBUKUIVXGAYMLVUFVXCVXDWJAVXB
        LUUBUKVXFVKVJVIAUUBLAUUBAYMVUFWPWQVXCVXDWRVJVLAUUAUUCUUEAUUAUUTXJUYTAUU
        MUUSUWHUWSVDVCAUUCUVFXJVVHAUVEUUSUXJUWSVTVCAUUEALUBWSZWIAUUEVXHWKXAVQAY
        SUUGLLUHUIZUKUIUUHAMLNLAMVWLXJTAVWJVWKAVWJVVIXJVWMVWAVCAVWKVVJXJVWNVWBV
        CVDWTZVXCANVVNXJVWRVWEVCVXCVXDVXDXBAUUEVXIUUGUKALVXCXCVKVQVPAYGUPUQYNUP
        UQYQJUQAYGYRYBFHUOUIZLUKUIZUHUIZGGIUOUIZLUKUIZUFUGZUHUIZUJUIZUOUIZUPAYG
        MYBVXKUHUIZGVXNUFUGZUHUIZUJUIZUOUIZLUKUIYRVYCLUKUIZUOUIVXSAYFVYDLUKAMMY
        FUOUIZUOUIYFVYDAMYFVXJUXPXDAVYFVYCMUOAVVKYFUOUIVVIYCUOUIZVVJYEUOUIZUJUI
        VYFVYCAVVIVVJYCYEVWAVWBUWJUXOXKAMVVKYFUOVWOVIAVXTVYGVYBVYHUJAVXTYBFUHUI
        ZYCUOUIVYGAYBFHUWIUVLUVNWFAVYIVVIYCUOAYBFUWIUVLVOVIVJAVYBGUUNYDUOUIZUHU
        IVYHAVYAVYJGUHAUWAUWCVYAVYJWBUWBUWDGIWCWDVKAGUUNYDUWBUWKUWPWFVJVLVPVKXE
        VIAMVYCLVXJAVXTVYBAYBVXKUWIAFHUVLUVNVTZUTZAGVYAUWBAVXNAGIUWBUWDVTZVBZUT
        ZVDVXCVXDXFAVYEVXRYRUOAVYEVXTLUKUIZVYBLUKUIZUJUIVXRAVXTVYBLVYLVYOVXCVXD
        XAAVYPVXMVYQVXQUJAYBVXKLUWIVYKVXCVXDXGAVYQGVYALUKUIZUHUIVXQAGVYALUWBVYN
        VXCVXDXGAVXPVYRGUHAVXPVYALUFUGZUKUIVYRAVXNLVYMVXCVXDXHAVYSLVYAUKALVXEXI
        ZVKVJVKVQVLVJVKVRAYRUPUQZVXRUPUQZVXSUPUQAYRXTUQWUAAYRUEXLYRXMUSAVXMUPUQ
        ZVXQUPUQZWUBAYBUPUQZVXLUPUQZWUCAUVJWUEPFXNUSZUCYBVXLXOWDAUVTVXPUPUQZWUD
        QAVXOUPUQZWUHUDVXOXNUSGVXPXOWDVXMVXQXPWDYRVXRYAWDVCAYNGVXLUFUGZUHUIZYBV
        XOUHUIZUOUIZUPAGVXKUFUGZUHUIZLUKUIZYBVXNUHUIZLUKUIZUOUIZYNWUMAWUOWUQUOU
        IZLUKUIWUSYNAWUOWUQLAGWUNUWBAVXKVYKVBZUTAYBVXNUWIVYMUTVXCVXDXFAWUTYMLUK
        AWUTGYBUHUIZYLUOUIZWVBYJUOUIZUOUIYMAWUOWVCWUQWVDUOAWUOGYBYKUOUIZUHUIWVC
        AWUNWVEGUHAUVKUVMWUNWVEWBUVLUVNFHWCWDVKAGYBYKUWBUWIUWNWFVJAWUQYBGUHUIZY
        JUOUIWVDAYBGIUWIUWBUWDWFAWVFWVBYJUOAYBGUWIUWBVOVIVJVLAWVBYLYJAGYBUWBUWI
        UTUWOVUEXQVJVIXEAWUPWUKWURWULUOAWUPGWUNLUKUIZUHUIWUKAGWUNLUWBWVAVXCVXDX
        GAWUJWVGGUHAWUJWUNVYSUKUIWVGAVXKLVYKVXCVXDXHAVYSLWUNUKVYTVKVJVKVQAYBVXN
        LUWIVYMVXCVXDXGVLXEAWUKUPUQZWULUPUQZWUMUPUQAUVTWUJUPUQZWVHQAWUFWVJUCVXL
        XNUSGWUJXOWDAWUEWUIWVIWUGUDYBVXOXOWDWUKWULYAWDVCBCDEYGYNJKOXRWDXS $.
    $}

    $( Euler's four-square identity:  The product of two sums of four squares
       is also a sum of four squares.  This is usually quoted as an explicit
       formula involving eight real variables; we save some time by working
       with complex numbers (gaussian integers) instead, so that we only have
       to work with four variables, and also hiding the actual formula for the
       product in the proof of ~ mul4sqlem .  (For the curious, the explicit
       formula that is used is
       ` ( | a | ^ 2 + | b | ^ 2 ) ( | c | ^ 2 + | d | ^ 2 ) = `
       ` | a * x. c + b x. d * | ^ 2 + | a * x. d - b x. c * | ^ 2 ` .)
       (Contributed by Mario Carneiro, 14-Jul-2014.) $)
    mul4sq $p |- ( ( A e. S /\ B e. S ) -> ( A x. B ) e. S ) $=
      ( va vb vc vd wcel co cgz wrex wa c1 syl cv cabs cfv cexp caddc wceq cmul
      c2 4sqlem4 reeanv cdiv cn0 simpll gzabssqcl simprl nn0addcld nn0cnd div1d
      simplr simprr oveq12d eqid cn 1nn a1i cmin cc gzsubcl adantr gzcn eqeltrd
      adantl mul4sqlem eqeltrrd syl5ibrcom rexlimdvva syl5bir rexlimivv syl2anb
      oveq12 eleq1d sylbir ) EGNEJUAZUBUCUHUDOZKUAZUBUCUHUDOZUEOZUFZKPQZJPQZFLU
      AZUBUCUHUDOZMUAZUBUCUHUDOZUEOZUFZMPQZLPQZEFUGOZGNZFGNABCDKJEGHIUIABCDMLFG
      HIUIWJWRRWIWQRZLPQJPQWTWIWQJLPPUJXAWTJLPPXAWHWPRZMPQKPQWCPNZWKPNZRZWTWHWP
      KMPPUJXEXBWTKMPPXEWEPNZWMPNZRZRZWTXBWGWOUGOZGNXIWGSUKOZWOSUKOZUGOXJGXIXKW
      GXLWOUGXIWGXIWGXIWDWFXIXCWDULNXCXDXHUMZWCUNTXIXFWFULNXEXFXGUOZWEUNTUPZUQU
      RZXIWOXIWOXIWLWNXIXDWLULNXCXDXHUSZWKUNTXIXGWNULNXEXFXGUTZWMUNTUPUQURVAXIA
      BCDWCWEWKWMGHSWGWOIXMXNXQXRWGVBWOVBSVCNXIVDVEXIWCWKVFOZSUKOXSPXIXSXIXSPNZ
      XSVGNXEXTXHWCWKVHVIZXSVJTURYAVKXIWEWMVFOZSUKOYBPXIYBXIYBPNZYBVGNXHYCXEWEW
      MVHVLZYBVJTURYDVKXIXKWGULXPXOVKVMVNXBWSXJGEWGFWOUGVTWAVOVPVQVRWBVS $.

    ${
      4sq.2 $e |- ( ph -> N e. NN ) $.
      4sq.3 $e |- ( ph -> P = ( ( 2 x. N ) + 1 ) ) $.
      4sq.4 $e |- ( ph -> P e. Prime ) $.
      ${
        4sqlem11.5 $e |- A =
          { u | E. m e. ( 0 ... N ) u = ( ( m ^ 2 ) mod P ) } $.
        4sqlem11.6 $e |- F = ( v e. A |-> ( ( P - 1 ) - v ) ) $.
        $( Lemma for ~ 4sq .  Use the pigeonhole principle to show that the
           sets ` { m ^ 2 | m e. ( 0 ... N ) } ` and
           ` { -u 1 - n ^ 2 | n e. ( 0 ... N ) } ` have a common element,
           ` mod P ` .  (Contributed by Mario Carneiro, 15-Jul-2014.) $)
        4sqlem11 $p |- ( ph -> ( A i^i ran F ) =/= (/) ) $=
          ( vk crn cun chash cfv clt wbr wn cin c0 wne cle cc0 c1 cmin cfz cdom
          co cfn wcel wss fzfid cv c2 cexp cmo wceq wrex wa wi cz elfzelz zsqcl
          cab cn cprime prmnn zmodfz syl2anr eleq1a rexlimdva caddc zcnd oveq1d
          syl adantr sselda wb ssfi syl2anc mpbird cen fz01en hashen cn0 nnnn0d
          hashfz1 eqtrd breqtrd nn0red zred mpbid ltp1d ax-1cn a1i cmul sylancr
          cr cc 2timesd 3eqtrd cmpt wf1o wf1 cdivides ad2antrl ad2antll syl3anc
          ex weq elfzle2 breqtrrd cabs nn0zd sylanbrc 0cn subid1d fveq2d absidd
          elfzle1 oveq12d dvdsle mtod sylbid dom2lem f1f1orn ax-mp sylibr sstri
          necon4ad abssdv syl5eqss prmz peano2zm addid2d fzrev3i eqeltrrd fmptd
          frn unssd ssdomg sylc hashdom hashcl lenltd nncnd add4d mulcl addassd
          wf 2cn moddvds subsq breq2d zaddcld zsubcld euclemma 3bitrd 2re nnred
          remulcl le2addd lelttrd ltnled ad2antrr 1re nn0abscl subeq0ad biimpar
          necon3bid absrpcld rpgt0d elnnz nnge1d abs3difd abssub letrd dvdsabsb
          wo elnnz1 letr mpan2d jaod oveq1 impbid1 eqid rnmpt eqtr4i ovex f1oen
          f1oeq3 ensymd pncan sylancl oveq2d peano2nn0 eqbrtrrd entr cuz fzssuz
          uzssz zsscn syl6ss adantrr adantrl subcanad f1eq1 f1oeng eqtr3d simpr
          3eqtr4d hashun eqtr4d necon3bd mpd ) AIHMUBZUCZUDUEZUFUGZUHZHUYFUIZUJ
          UKAUYHIULUGUYJAUYHUMIUNUOURZUPURZUDUEZIULAUYHUYNULUGZUYGUYMUQUGZAUYMU
          SUTZUYGUYMVAZUYPAUMUYLVBZAHUYFUYMAHGVCZKVCZVDVEURZIVFURZVGZKUMNUPURZV
          HZGVNZUYMSAVUFGUYMAVUDUYTUYMUTZKVUEAVUAVUEUTZVIVUCUYMUTZVUDVUHVJVUIVU
          BVKUTZIVOUTZVUJAVUIVUAVKUTZVUKVUAUMNVLZVUAVMZWEAIVPUTZVULRIVQWEZVUBIV
          RVSZVUCUYMUYTVTWEWAUUAUUBZAHUYMMUUTUYFUYMVAZAFHUYLFVCZUOURZUYMMAVVAHU
          TZVIZUMUYLWBURZVVAUOURZVVBUYMAVVFVVBVGVVCAVVEUYLVVAUOAUYLAUYLAIVKUTZU
          YLVKUTAVUPVVGRIUUCZWEZIUUDWEWCZUUEWDWFVVDVVAUYMUTVVFUYMUTAHUYMVVAVUSW
          GVVAUMUYLUUFWEUUGZTUUHHUYMMUUIWEZUUJZUYGUYMUSUUKUULAUYGUSUTZUYQUYOUYP
          WHAUYQUYRVVNUYSVVMUYMUYGWIWJZUYSUYGUYMUSUUMWJWKAUYNUNIUPURZUDUEZIAUYN
          VVQVGZUYMVVPWLUGZAVVGVVSVVIIWMWEAUYQVVPUSUTVVRVVSWHUYSAUNIVBUYMVVPWNW
          JWKAIWOUTVVQIVGAIVUQWPIWQWEWRWSAUYHIAUYHAVVNUYHWOUTVVOUYGUUNWEWTAIVVI
          XAZUUOXBAUYIUYKUJAUYKUJVGZUYIAVWAVIZIIUNWBURZUYHUFVWBIAIXHUTZVWAVVTWF
          XCVWBVWCHUDUEZUYFUDUEZWBURZUYHAVWCVWGVGVWAANNWBURZUNUNWBURZWBURZNUNWB
          URZVWKWBURVWCVWGANNUNUNANPUUPZVWLUNXIUTZAXDXEZVWNUUQAVWCVDNXFURZUNWBU
          RZUNWBURVWOVWIWBURVWJAIVWPUNWBQWDAVWOUNUNAVDXIUTNXIUTZVWOXIUTUVAVWLVD
          NUURXGVWNVWNUUSAVWOVWHVWIWBANVWLXJWDXKAVWEVWKVWFVWKWBAVWEUNVWKUPURZUD
          UEZVWKAVWEVWSVGZHVWRWLUGZAHVUEWLUGVUEVWRWLUGVXAAVUEHAVUEHKVUEVUCXLZXM
          ZVUEHWLUGAVUEVXBUBZVXBXMZVXCAVUEUYMVXBXNVXEAKGVUEUYMVUCUYTVDVEURZIVFU
          RZAVUIVUJVURXSAVUIUYTVUEUTZVIZVUCVXGVGZKGXTZWHAVXIVIZVXJVXKVXLVXJIVUA
          UYTWBURZXOUGZIVUAUYTUOURZXOUGZUWIZVXKVXLVXJIVUBVXFUOURZXOUGZIVXMVXOXF
          URZXOUGZVXQVXLVULVUKVXFVKUTZVXJVXSWHAVULVXIVUQWFVXLVUMVUKVUIVUMAVXHVU
          NXPZVUOWEVXLUYTVKUTZVYBVXHVYDAVUIUYTUMNVLXQZUYTVMWEVUBVXFIUVBXRVXLVXR
          VXTIXOVXLVUAXIUTUYTXIUTZVXRVXTVGVXLVUAVYCWCZVXLUYTVYEWCZVUAUYTUVCWJUV
          DVXLVUPVXMVKUTZVXOVKUTZVYAVXQWHAVUPVXIRWFZVXLVUAUYTVYCVYEUVEZVXLVUAUY
          TVYCVYEUVFZIVXMVXOUVGXRUVHVXLVXNVXKVXPVXLVXNVUAUYTVXLVUAUYTUKZVXNUHVX
          LVYNVIZVXNIVXMULUGZVXLVYPUHZVYNVXLVXMIUFUGVYQVXLVXMVWOIVXLVXMVYLXAZAV
          WOXHUTZVXIAVDXHUTNXHUTZVYSUVIANPUVJZVDNUVKXGZWFVXLIVXLVUPVVGVYKVVHWEZ
          XAZVXLVXMVWHVWOULVXLVUAUYTNNVXLVUAVYCXAZVXLUYTVYEXAZAVYTVXIWUAWFZWUGV
          UIVUANULUGAVXHVUAUMNYAXPVXHUYTNULUGAVUIUYTUMNYAXQUVLVXLNAVWQVXIVWLWFX
          JYBAVWOIUFUGVXIAVWOVWPIUFAVWOWUBXCQYBWFUVMVXLVXMIVYRWUDUVNXBZWFVYOVVG
          VXMVOUTZVXNVYPVJAVVGVXIVYNVVIUVOVYOVYIUNVXMULUGWUIVXLVYIVYNVYLWFZVYOU
          NVXOYCUEZVXMUNXHUTVYOUVPXEVXLWUKXHUTZVYNVXLWUKVXLVYJWUKWOUTZVYMVXOUVQ
          WEZWTZWFVYOVXMWUJXAVYOWUKVYOWUKVKUTUMWUKUFUGWUKVOUTZVYOWUKVXLWUMVYNWU
          NWFYDVYOWUKVYOVXOVXLVXOXIUTVYNVXLVXOVYMWCWFVXLVXOUMUKVYNVXLVXOUMVUAUY
          TVXLVUAUYTVYGVYHUVRUVTUVSUWAUWBWUKUWCYEZUWDVXLWUKVXMULUGZVYNVXLWUKVUA
          UMUOURZYCUEZUMUYTUOURYCUEZWBURVXMULVXLVUAUYTUMVYGVYHUMXIUTZVXLYFXEUWE
          VXLWUTVUAWVAUYTWBVXLWUTVUAYCUEVUAVXLWUSVUAYCVXLVUAVYGYGYHVXLVUAWUEVUI
          UMVUAULUGAVXHVUAUMNYJXPYIWRVXLWVAUYTUMUOURZYCUEZUYTYCUEUYTVXLWVBVYFWV
          AWVDVGYFVYHUMUYTUWFXGVXLWVCUYTYCVXLUYTVYHYGYHVXLUYTWUFVXHUMUYTULUGAVU
          IUYTUMNYJXQYIXKYKWSZWFUWGVXMUWJYEIVXMYLWJYMXSYTVXLVXPIWUKXOUGZVXKVXLV
          VGVYJVXPWVFWHWUCVYMIVXOUWHWJVXLWVFVUAUYTVXLVYNWVFUHVYOWVFIWUKULUGZVXL
          WVGUHVYNVXLWVGVYPWUHVXLWVGWURVYPWVEVXLVWDWULVXMXHUTWVGWURVIVYPVJWUDWU
          OVYRIWUKVXMUWKXRUWLYMWFVYOVVGWUPWVFWVGVJVXLVVGVYNWUCWFWUQIWUKYLWJYMXS
          YTYNUWMYNVXKVUBVXFIVFVUAUYTVDVEUWNWDUWOXSYOVUEUYMVXBYPWEHVXDVGVXCVXEW
          HHVUGVXDSKGVUEVUCVXBVXBUWPUWQUWRHVXDVUEVXBUXAYQYRVUEHVXBUMNUPUWSUWTWE
          UXBAUMVWKUNUOURZUPURZVUEVWRWLAWVHNUMUPAVWQVWMWVHNVGVWLXDNUNUXCUXDUXEA
          VWKVKUTWVIVWRWLUGAVWKANWOUTVWKWOUTZANPWPNUXFWEZYDVWKWMWEUXGHVUEVWRUXH
          WJAHUSUTZVWRUSUTVWTVXAWHAUYQHUYMVAWVLUYSVUSUYMHWIWJZAUNVWKVBHVWRWNWJW
          KAWVJVWSVWKVGWVKVWKWQWEWRZAVWEVWFVWKAVWEVWFVGZHUYFWLUGZAWVLHUYFMXMZWV
          PWVMAHUYMMXNZWVQAHUYMFHVVBXLZXNZWVRAFUAHUYMVVBUYLUAVCZUOURZAVVCVVBUYM
          UTVVKXSAVVCWWAHUTZVIZVVBWWBVGFUAXTWHAWWDVIUYLVVAWWAAUYLXIUTWWDVVJWFAV
          VCVVAXIUTWWCAHXIVVAAHUYMXIVUSUYMUMUXIUEZXIUMUYLUXJWWEVKXIUMUXKUXLYSYS
          UXMZWGUXNAWWCWWAXIUTVVCAHXIWWAWWFWGUXOUXPXSYOMWVSVGWVRWVTWHTHUYMMWVSU
          XQYQYRHUYMMYPWEHUYFUSMUXRWJAWVLUYFUSUTZWVOWVPWHWVMAUYQVUTWWGUYSVVLUYM
          UYFWIWJZHUYFWNWJWKWVNUXSYKUYAWFVWBWVLWWGVWAUYHVWGVGAWVLVWAWVMWFAWWGVW
          AWWHWFAVWAUXTHUYFUYBXRUYCWSXSUYDUYE $.

        $( Lemma for ~ 4sq .  For any odd prime ` P ` , there is a ` k < P `
           such that ` k P - 1 ` is a sum of two squares.  (Contributed by
           Mario Carneiro, 15-Jul-2014.) $)
        4sqlem12 $p |- ( ph -> E. k e. ( 1 ... ( P - 1 ) ) E. u e. Z[i]
          ( ( ( abs ` u ) ^ 2 ) + 1 ) = ( k x. P ) ) $=
          ( vj cv crn cin wcel wex cabs cfv c2 cexp co caddc cmul wceq cgz wrex
          c1 cmin cfz c0 wne 4sqlem11 n0 sylib cmo wa cc0 vex weq eqeq1 rexbidv
          elab2 cab abid rexeqi oveq1 oveq1d eqeq2d cbvrexv syl5bb rexab 3bitri
          rnmpt eleq2i rexcom4 r19.41v exbii bitri 3bitr4i oveq2 ceqsexv rexbii
          ovex anbi12i elin reeanv w3a cz cle wbr clt cdivides crp cn0 3ad2ant1
          cr cn syl nn0red nnrpd nnred syl22anc elfzelz zsqcl2 syl2anc wb zsqcl
          nn0zd mpbid breqtrrd syl3anc nn0cnd subsub3d nncnd cc a1i mpbird nnrp
          eqtrd nnmulcl sylancr zred elfzle1 elfzle2 le2sq2 c4 nngt0d syl112anc
          2nn eqtr2 cdiv cprime prmnn nnm1nn0 nn0ge0d ltm1d modid modlt zmodcld
          simp2r prmz zltlem1 modsubdir simp3 3eqtr4rd simp2l zsubcld nn0addcld
          ci moddvds ax-1cn breqtrd nn0p1nn nnzd dvdssubr nnne0d rpdivcl syl2an
          dvdsval2 rpgt0d elnnz sylanbrc nnge1d resqcld nnsqcld le2addd 2timesd
          readdcld 1re 2re 4re ltmul1 mpbii 2cn sqmul sq2 oveq1i syl6eq lelttrd
          2lt4 ltaddrpd lttrd ltadd1dd sqvald binom21 3eqtr3d elfzm11 mpbir3and
          ltdivmul 1z gzreim cre cim gzcn absvalsq2d crred crimd oveq12d eqtr4d
          divcan1d fveq2 eqeq1d rspc2ev 3expia syl5 rexlimdvva syl5bi exlimdv
          mpd ) AUBUCZHNUDZUEZUFZUBUGZGUCZUHUIZUJUKULZURUMULZKUCZIUNULZUOZGUPUQ
          KURIURUSULZUTULZUQZAUYCVAVBUYEABCDEFGHIJLMNOPQRSTUAVCUBUYCVDVEAUYDUYO
          UBUYDUYALUCZUJUKULZIVFULZUOZUYAUYMMUCZUJUKULZIVFULZUSULZUOZVGZMVHOUTU
          LZUQLVUFUQZAUYOUYAHUFZUYAUYBUFZVGUYSLVUFUQZVUDMVUFUQZVGUYDVUGVUHVUJVU
          IVUKUYFUYRUOZLVUFUQZVUJGUYAHUBVIGUBVJVULUYSLVUFUYFUYAUYRVKVLTVMVUIFUC
          ZVUBUOZUYAUYMVUNUSULZUOZVGZFUGZMVUFUQZVUKUYAVUQFHUQZUBVNZUFZVUOMVUFUQ
          ZVUQVGZFUGZVUIVUTVVCVVAVUQFVUMGVNZUQVVFVVAUBVOVUQFHVVGTVPVUMVVDVUQFGV
          UMUYFVUBUOZMVUFUQGFVJZVVDVULVVHLMVUFLMVJZUYRVUBUYFVVJUYQVUAIVFUYPUYTU
          JUKVQVRVSVTVVIVVHVUOMVUFUYFVUNVUBVKVLWAWBWCUYBVVBUYAFUBHVUPNUAWDWEVUT
          VURMVUFUQZFUGVVFVURMFVUFWFVVKVVEFVUOVUQMVUFWGWHWIWJVUSVUDMVUFVUQVUDFV
          UBVUAIVFWNVUOVUPVUCUYAVUNVUBUYMUSWKVSWLWMWIWOUYAHUYBWPUYSVUDLMVUFVUFW
          QWJAVUEUYOLMVUFVUFVUEUYRVUCUOZAUYPVUFUFZUYTVUFUFZVGZVGUYOUYAUYRVUCUUA
          AVVOVVLUYOAVVOVVLWRZUYQVUAUMULZURUMULZIUUBULZUYNUFZUYPUUTUYTUNULUMULZ
          UPUFZVWAUHUIZUJUKULZURUMULZVVSIUNULZUOZUYOVVPVVTVVSWSUFZURVVSWTXAZVVS
          IXBXAZVVPIVVRXCXAZVWHVVPVWKIVVRIUSULZXCXAZVVPIUYQUYMVUAUSULZUSULZVWLX
          CVVPUYRVWNIVFULZUOZIVWOXCXAZVVPUYMIVFULZVUBUSULZVUCVWPUYRVVPVWSUYMVUB
          USVVPUYMXGUFZIXDUFZVHUYMWTXAUYMIXBXAVWSUYMUOVVPUYMVVPIXHUFZUYMXEUFVVP
          IUUCUFZVXCAVVOVXDVVLSXFZIUUDXIZIUUEXIZXJZVVPIVXFXKZVVPUYMVXGUUFVVPIVV
          PIVXFXLZUUGUYMIUUHXMZVRVVPVUBVWSWTXAZVWPVWTUOZVVPVUBUYMVWSWTVVPVUBIXB
          XAZVUBUYMWTXAZVVPVUAXGUFZVXBVXNVVPVUAVVPUYTWSUFZVUAXEUFVVPVVNVXQAVVMV
          VNVVLUUKZUYTVHOXNXIZUYTXOXIZXJZVXIVUAIUUIXPVVPVUBWSUFIWSUFZVXNVXOXQVV
          PVUBVVPVUAIVVPVXQVUAWSUFVXSUYTXRXIZVXFUUJXSVVPVXDVYBVXEIUULXIZVUBIUUM
          XPXTVXKYAVVPVXAVXPVXBVXLVXMXQVXHVYAVXIUYMVUAIUUNYBXTAVVOVVLUUOUUPVVPV
          XCUYQWSUFZVWNWSUFVWQVWRXQVXFVVPUYPWSUFZVYEVVPVVMVYFAVVMVVNVVLUUQZUYPV
          HOXNXIZUYPXRXIVVPUYMVUAVVPUYMVXGXSVYCUURUYQVWNIUVAYBXTVVPVWOVVQUYMUSU
          LVWLVVPUYQUYMVUAVVPUYQVVPVYFUYQXEUFVYHUYPXOXIZYCVVPUYMVXGYCVVPVUAVXTY
          CYDVVPVVQIURVVPVVQVVPUYQVUAVYIVXTUUSZYCVVPIVXFYEZURYFUFVVPUVBYGYDYJUV
          CVVPVYBVVRWSUFZVWKVWMXQVYDVVPVVRVVPVVQXEUFVVRXHUFZVYJVVQUVDXIZUVEZIVV
          RUVFXPYHVVPVYBIVHVBVYLVWKVWHXQVYDVVPIVXFUVGZVYOIVVRUVJYBXTZVVPVVSVVPV
          WHVHVVSXBXAVVSXHUFVYQVVPVVSVVPVYMVXCVVSXDUFZVYNVXFVYMVVRXDUFVXBVYRVXC
          VVRYIIYIVVRIUVHUVIXPUVKVVSUVLUVMUVNVVPVWJVVRIIUNULZXBXAZVVPVVRUJOUNUL
          ZUJUKULZUJWUAUNULZUMULZURUMULZVYSXBVVPVVQWUDURVVPVVQVYJXJZVVPWUBWUCVV
          PWUAVVPWUAVVPUJXHUFZOXHUFZWUAXHUFZYTAVVOWUHVVLQXFZUJOYKYLZXLUVOZVVPWU
          CVVPWUGWUIWUCXHUFYTWUKUJWUAYKYLZXLUVSZURXGUFVVPUVTYGVVPVVQWUBWUDWUFWU
          LWUNVVPVVQUJOUJUKULZUNULZWUBWUFVVPWUPVVPWUGWUOXHUFWUPXHUFYTVVPOWUJUVP
          ZUJWUOYKYLXLWULVVPVVQWUOWUOUMULWUPWTVVPUYQVUAWUOWUOVVPUYQVYIXJVYAVVPW
          UOWUQXLZWURVVPUYPXGUFVHUYPWTXAZOXGUFZUYPOWTXAZUYQWUOWTXAVVPUYPVYHYMZV
          VPVVMWUSVYGUYPVHOYNXIVVPOWUJXLZVVPVVMWVAVYGUYPVHOYOXIUYPOYPXMVVPUYTXG
          UFVHUYTWTXAZWUTUYTOWTXAZVUAWUOWTXAVVPUYTVXSYMZVVPVVNWVDVXRUYTVHOYNXIW
          VCVVPVVNWVEVXRUYTVHOYOXIUYTOYPXMUVQVVPWUOVVPWUOWUQYEUVRYAVVPWUPYQWUOU
          NULZWUBXBVVPUJYQXBXAZWUPWVGXBXAZUWKVVPUJXGUFZYQXGUFZWUOXGUFVHWUOXBXAW
          VHWVIXQWVJVVPUWAYGWVKVVPUWBYGWURVVPWUOWUQYRUJYQWUOUWCYSUWDVVPWUBUJUJU
          KULZWUOUNULZWVGVVPUJYFUFOYFUFWUBWVMUOUWEVVPOWUJYEUJOUWFYLWVLYQWUOUNUW
          GUWHUWIYAUWJVVPWUBWUCWULVVPWUCWUMXKUWLUWMUWNVVPIUJUKULWUAURUMULZUJUKU
          LZVYSWUEVVPIWVNUJUKAVVOIWVNUOVVLRXFVRVVPIVYKUWOVVPWUAYFUFWVOWUEUOVVPW
          UAWUKYEWUAUWPXIUWQYAVVPVVRXGUFIXGUFZWVPVHIXBXAVWJVYTXQVVPVVRVYNXLVXJV
          XJVVPIVXFYRVVRIIUWTYSYHVVPURWSUFVYBVVTVWHVWIVWJWRXQUXAVYDVVSURIUWRYLU
          WSVVPVYFVXQVWBVYHVXSUYPUYTUXBXPZVVPVWEVVRVWFVVPVWDVVQURUMVVPVWDVWAUXC
          UIZUJUKULZVWAUXDUIZUJUKULZUMULVVQVVPVWAVVPVWBVWAYFUFWVQVWAUXEXIUXFVVP
          WVSUYQWWAVUAUMVVPWVRUYPUJUKVVPUYPUYTWVBWVFUXGVRVVPWVTUYTUJUKVVPUYPUYT
          WVBWVFUXHVRUXIYJVRVVPVVRIVVPVVRVYNYEVYKVYPUXKUXJUYLVWGUYIVWFUOKGVVSVW
          AUYNUPUYJVVSUOUYKVWFUYIUYJVVSIUNVQVSUYFVWAUOZUYIVWEVWFWWBUYHVWDURUMWW
          BUYGVWCUJUKUYFVWAUHUXLVRVRUXMUXNYBUXOUXPUXQUXRUXSUXT $.
      $}

      4sq.5 $e |- ( ph -> ( 0 ... ( 2 x. N ) ) C_ S ) $.
      4sq.6 $e |- T = { i e. NN | ( i x. P ) e. S } $.
      4sq.7 $e |- M = sup ( T , RR , `' < ) $.
      $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 16-Jul-2014.) $)
      4sqlem13 $p |- ( ph -> ( T =/= (/) /\ M < P ) ) $=
        ( c1 vu vk vv vm cv cabs cfv c2 cexp co caddc cmul wceq cgz wrex cfz c0
        cmin wne clt wbr cmo cc0 cab cmpt eqid 4sqlem12 wcel simplrl elfznn syl
        wa cn simpr abs1 oveq1i sq1 eqtri oveq2i simplrr cz 1z 4sqlem4a sylancl
        ax-mp syl5eqelr eqeltrrd oveq1 eleq1d elrab2 sylanbrc ne0i crab eqsstri
        zgz ssrab2 cr ccnv csup cuz wss nnuz sseqtri infmssuzcl syl5eqel sseldi
        sylancr nnred cprime ad2antrr prmnn cle infmssuzle syl5eqbr w3a wb prmz
        elfzm11 mpbid simp3d lelttrd jca ex rexlimdvva mpd ) AUAUEZUFUGUHUIUJZT
        UKUJZUBUEZFULUJZUMZUAUNUOUBTFTURUJZUPUJZUOHUQUSZKFUTVAZVLZABCDEUCUAYFUD
        UEUHUIUJFVBUJUMUDVCLUPUJUOUAVDZFGUBUDJUCYQYLUCUEURUJVEZLMNOPYQVFYRVFVGA
        YKYPUBUAYMUNAYIYMVHZYFUNVHZVLZVLZYKYPUUBYKVLZYNYOUUCYIHVHZYNUUCYIVMVHZY
        JGVHZUUDUUCYSUUEAYSYTYKVIZYIYLVJVKZUUCYHYJGUUBYKVNUUCYHYGTUFUGZUHUIUJZU
        KUJZGUUJTYGUKUUJTUHUIUJTUUITUHUIVOVPVQVRVSUUCYTTUNVHZUUKGVHAYSYTYKVTTWA
        VHZUULWBTWOWEBCDEYFTGJMWCWDWFWGIUEZFULUJZGVHZUUFIYIVMHUUNYIUMUUOYJGUUNY
        IFULWHWIRWJWKZHYIWLVKZUUCKYIFUUCKUUCHVMKHUUPIVMWMVMRUUPIVMWPWNZUUCKHWQU
        TWRWSZHSUUCHTWTUGZXAZYNUUTHVHHVMUVAUUSXBXCZUURHTXDXGXEXFXHUUCYIUUHXHUUC
        FUUCFXIVHZFVMVHAUVDUUAYKPXJZFXKVKXHUUCKUUTYIXLSUUCUVBUUDUUTYIXLVAUVCUUQ
        YIHTXMXGXNUUCYIWAVHZTYIXLVAZYIFUTVAZUUCYSUVFUVGUVHXOZUUGUUCUUMFWAVHZYSU
        VIXPWBUUCUVDUVJUVEFXQVKYITFXRXGXSXTYAYBYCYDYE $.

      ${
        4sq.m $e |- ( ph -> M e. ( ZZ>= ` 2 ) ) $.
        4sq.a $e |- ( ph -> A e. ZZ ) $.
        4sq.b $e |- ( ph -> B e. ZZ ) $.
        4sq.c $e |- ( ph -> C e. ZZ ) $.
        4sq.d $e |- ( ph -> D e. ZZ ) $.
        4sq.e $e |- E = ( ( ( A + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
        4sq.f $e |- F = ( ( ( B + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
        4sq.g $e |- G = ( ( ( C + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
        4sq.h $e |- H = ( ( ( D + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
        4sq.r $e |- R =
          ( ( ( ( E ^ 2 ) + ( F ^ 2 ) ) + ( ( G ^ 2 ) + ( H ^ 2 ) ) ) / M ) $.
        4sq.p $e |- ( ph -> ( M x. P ) =
          ( ( ( A ^ 2 ) + ( B ^ 2 ) ) + ( ( C ^ 2 ) + ( D ^ 2 ) ) ) ) $.
        $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 16-Jul-2014.) $)
        4sqlem14 $p |- ( ph -> R e. NN0 ) $=
          ( c2 cexp co caddc cdiv cn0 cz wcel cc0 cle wbr cdivides cmul cmin cn
          cv crab ssrab2 eqsstri cr clt ccnv csup c1 cuz cfv wss c0 wne sseqtri
          nnuz 4sqlem13 simpld infmssuzcl sylancr syl5eqel sseldi nnzd prmz syl
          cprime dvdsmul1 syl2anc 4sqlem8 wa zsqcl 4sqlem5 zsqcl2 nn0zd zsubcld
          dvds2add syl3anc mp2and zcnd sqcld addsub4d breqtrrd nn0addcld oveq1d
          wi zaddcld addcld eqtrd zmulcld dvds2sub nncnd prmnn mulcld nncand wb
          breqtrd nnne0d dvdsval2 nn0red nn0ge0d nngt0d divge0 syl22anc elnn0z
          mpbid nnred sylanbrc ) AKPUTVAVBZQUTVAVBZVCVBZRUTVAVBZSUTVAVBZVCVBZVC
          VBZTVDVBZVEURAUUIVFVGZVHUUIVIVJZUUIVEVGATUUHVKVJZUUJATTJVLVBZUUMUUHVM
          VBZVMVBZUUHVKATUUMVKVJZTUUNVKVJZTUUOVKVJZATVFVGZJVFVGZUUPATAMVNTMNVOJ
          VLVBLVGZNVNVPVNUGUVANVNVQVRZATMVSVTWAWBZMUHAMWCWDWEZWFMWGWHZUVCMVGMVN
          UVDUVBWJWIAUVETJVTVJABCDEJLMNOTUAUBUCUDUEUFUGUHWKWLMWCWMWNWOWPZWQZAJW
          TVGZUUTUEJWRWSZTJXAXBATFUTVAVBZGUTVAVBZVCVBZUUDVMVBZHUTVAVBZIUTVAVBZV
          CVBZUUGVMVBZVCVBZUUNVKATUVMVKVJZTUVQVKVJZTUVRVKVJZATUVJUUBVMVBZUVKUUC
          VMVBZVCVBZUVMVKATUWBVKVJZTUWCVKVJZTUWDVKVJZAFPTUJUVFUNXCAGQTUKUVFUOXC
          AUUSUWBVFVGUWCVFVGUWEUWFXDUWGXSUVGAUVJUUBAFVFVGUVJVFVGUJFXEWSZAUUBAPV
          FVGZUUBVEVGAUWIFPVMVBTVDVBVFVGAFPTUJUVFUNXFWLZPXGWSZXHXIAUVKUUCAGVFVG
          UVKVFVGUKGXEWSZAUUCAQVFVGZUUCVEVGAUWMGQVMVBTVDVBVFVGAGQTUKUVFUOXFWLZQ
          XGWSZXHXITUWBUWCXJXKXLAUVJUVKUUBUUCAFAFUJXMXNZAGAGUKXMXNZAPAPUWJXMXNZ
          AQAQUWNXMXNZXOXPATUVNUUEVMVBZUVOUUFVMVBZVCVBZUVQVKATUWTVKVJZTUXAVKVJZ
          TUXBVKVJZAHRTULUVFUPXCAISTUMUVFUQXCAUUSUWTVFVGUXAVFVGUXCUXDXDUXEXSUVG
          AUVNUUEAHVFVGUVNVFVGULHXEWSZAUUEARVFVGZUUEVEVGAUXGHRVMVBTVDVBVFVGAHRT
          ULUVFUPXFWLZRXGWSZXHXIAUVOUUFAIVFVGUVOVFVGUMIXEWSZAUUFASVFVGZUUFVEVGA
          UXKISVMVBTVDVBVFVGAISTUMUVFUQXFWLZSXGWSZXHXITUWTUXAXJXKXLAUVNUVOUUEUU
          FAHAHULXMXNZAIAIUMXMXNZARARUXHXMXNZASASUXLXMXNZXOXPAUUSUVMVFVGUVQVFVG
          UVSUVTXDUWAXSUVGAUVLUUDAUVJUVKUWHUWLXTAUUDAUUBUUCUWKUWOXQZXHZXIAUVPUU
          GAUVNUVOUXFUXJXTAUUGAUUEUUFUXIUXMXQZXHZXITUVMUVQXJXKXLAUUNUVLUVPVCVBZ
          UUHVMVBUVRAUUMUYBUUHVMUSXRAUVLUVPUUDUUGAUVJUVKUWPUWQYAAUVNUVOUXNUXOYA
          AUUBUUCUWRUWSYAZAUUEUUFUXPUXQYAZXOYBXPAUUSUUMVFVGUUNVFVGUUPUUQXDUURXS
          UVGATJUVGUVIYCZAUUMUUHUYEAUUDUUGUXSUYAXTXITUUMUUNYDXKXLAUUMUUHATJATUV
          FYEAJAUVHJVNVGUEJYFWSYEYGAUUDUUGUYCUYDYAYHYJAUUSTVHWHUUHVFVGUULUUJYIU
          VGATUVFYKAUUHAUUDUUGUXRUXTXQZXHTUUHYLXKYSAUUHVSVGVHUUHVIVJTVSVGVHTVTV
          JUUKAUUHUYFYMAUUHUYFYNATUVFYTATUVFYOUUHTYPYQUUIYRUUAWO $.

        $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 16-Jul-2014.) $)
        4sqlem15 $p |- ( ( ph /\ R = M ) ->
          ( ( ( ( ( ( M ^ 2 ) / 2 ) / 2 ) - ( E ^ 2 ) ) = 0 /\
              ( ( ( ( M ^ 2 ) / 2 ) / 2 ) - ( F ^ 2 ) ) = 0 ) /\
            ( ( ( ( ( M ^ 2 ) / 2 ) / 2 ) - ( G ^ 2 ) ) = 0 /\
              ( ( ( ( M ^ 2 ) / 2 ) / 2 ) - ( H ^ 2 ) ) = 0 ) ) ) $=
          ( wceq wa c2 cexp co cdiv cmin cc0 caddc cuz cfv wcel clt wbr eluz2b2
          cn c1 simplbi syl nnred resqcld rehalfcld recnd cz 4sqlem5 zsqcl zred
          simpld addsub4d 2halvesd oveq1d eqtr3d adantr sqvald syl5eqr readdcld
          simpr nnne0d divcan1d 3eqtr2rd oveq12d subidd 3eqtr3d cr cle resubcld
          cmul wb 4sqlem7 le2addd breqtrd subge0d mpbird syl22anc biimpa syldan
          add20 eqtrd simprd jca ) AKTUTZVAZTVBVCVDZVBVEVDZVBVEVDZPVBVCVDZVFVDZ
          VGUTYDQVBVCVDZVFVDZVGUTVAZYDRVBVCVDZVFVDZVGUTYDSVBVCVDZVFVDZVGUTVAZAX
          TYFYHVHVDZVGUTZYIYAYOYCYEYGVHVDZVFVDZVGAYOYRUTXTAYDYDVHVDZYQVFVDYOYRA
          YDYDYEYGAYDAYCAYBATATATVBVIVJVKZTVOVKZUIYTUUAVPTVLVMTVNVQVRZVSZVTZWAZ
          WAZWBZUUGAYEAYEAPWCVKZYEWCVKAUUHFPVFVDTVEVDWCVKAFPTUJUUBUNWDWGPWEVRWF
          ZWBAYGAYGAQWCVKZYGWCVKAUUJGQVFVDTVEVDWCVKAGQTUKUUBUOWDWGQWEVRWFZWBWHA
          YSYCYQVFAYCAYCUUEWBZWIZWJWKWLYAYRVGUTZYCYJYLVHVDZVFVDZVGUTZAXTYRUUPVH
          VDZVGUTZUUNUUQVAZYAYCYCVHVDZYQUUOVHVDZVFVDZYBYBVFVDZUURVGYAUVAYBUVBYB
          VFAUVAYBUTXTAYBAYBUUDWBZWIWLYAYBTTXFVDZUVBTVEVDZTXFVDZUVBAYBUVFUTXTAT
          ATUUCWBZWMWLYAUVGTTXFYAUVGKTURAXTWPWNWJAUVHUVBUTXTAUVBTAUVBAYQUUOAYEY
          GUUIUUKWOZAYJYLAYJARWCVKZYJWCVKAUVKHRVFVDTVEVDWCVKAHRTULUUBUPWDWGRWEV
          RWFZAYLASWCVKZYLWCVKAUVMISVFVDTVEVDWCVKAISTUMUUBUQWDWGSWEVRWFZWOZWOWB
          UVIATUUBWQWRWLWSWTAUVCUURUTXTAYCYCYQUUOUULUULAYQUVJWBAUUOUVOWBWHWLAUV
          DVGUTXTAYBUVEXAWLXBAUUSUUTAYRXCVKVGYRXDVMZUUPXCVKVGUUPXDVMZUUSUUTXGAY
          CYQUUEUVJXEAUVPYQYCXDVMAYQYSYCXDAYEYGYDYDUUIUUKUUFUUFAFPTUJUUBUNXHZAG
          QTUKUUBUOXHZXIUUMXJAYCYQUUEUVJXKXLAYCUUOUUEUVOXEAUVQUUOYCXDVMAUUOYSYC
          XDAYJYLYDYDUVLUVNUUFUUFAHRTULUUBUPXHZAISTUMUUBUQXHZXIUUMXJAYCUUOUUEUV
          OXKXLYRUUPXPXMXNXOZWGXQAYPYIAYFXCVKVGYFXDVMZYHXCVKVGYHXDVMZYPYIXGAYDY
          EUUFUUIXEAUWCYEYDXDVMUVRAYDYEUUFUUIXKXLAYDYGUUFUUKXEAUWDYGYDXDVMUVSAY
          DYGUUFUUKXKXLYFYHXPXMXNXOAXTYKYMVHVDZVGUTZYNYAUWEUUPVGAUWEUUPUTXTAYSU
          UOVFVDUWEUUPAYDYDYJYLUUGUUGAYJUVLWBAYLUVNWBWHAYSYCUUOVFUUMWJWKWLYAUUN
          UUQUWBXRXQAUWFYNAYKXCVKVGYKXDVMZYMXCVKVGYMXDVMZUWFYNXGAYDYJUUFUVLXEAU
          WGYJYDXDVMUVTAYDYJUUFUVLXKXLAYDYLUUFUVNXEAUWHYLYDXDVMUWAAYDYLUUFUVNXK
          XLYKYMXPXMXNXOXS $.

        $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 16-Jul-2014.) $)
        4sqlem16 $p |- ( ph -> ( R <_ M /\
          ( ( R = 0 \/ R = M ) -> ( M ^ 2 ) || ( M x. P ) ) ) ) $=
          ( cle wbr wceq wo c2 cexp co cmul cdivides wi caddc cdiv cz wcel cmin
          cc0 cuz cfv cn c1 clt eluz2b2 simplbi syl 4sqlem5 zsqcl zred readdcld
          simpld nnred resqcld rehalfcld 4sqlem7 le2addd recnd 2halvesd breqtrd
          sqvald cr wb nngt0d ledivmul syl112anc mpbird syl5eqbr syl5eqr nnne0d
          wa simpr diveq0ad cn0 zsqcl2 nn0addcld nn0ge0d syl22anc biimpa syldan
          add20 bitrd 4sqlem9 simprd nnsqcld nnzd syl3anc adantr mp2and zaddcld
          dvds2add 4sqlem15 4sqlem10 zcnd subeq0ad mpbid eqeltrd zsubcld oveq2d
          addsub4d eqtr3d eqeltrrd dvdssubr syl2anc jaodan breqtrrd ex jca ) AK
          TUTVAKVOVBZKTVBZVCZTVDVEVFZTJVGVFZVHVAZVIAKPVDVEVFZQVDVEVFZVJVFZRVDVE
          VFZSVDVEVFZVJVFZVJVFZTVKVFZTUTURAUURTUTVAZUUQTTVGVFZUTVAZAUUQUUHUUTUT
          AUUQUUHVDVKVFZUVBVJVFZUUHUTAUUMUUPUVBUVBAUUKUULAUUKAPVLVMZUUKVLVMZAUV
          DFPVNVFTVKVFVLVMAFPTUJATVDVPVQVMZTVRVMZUIUVFUVGVSTVTVATWAWBWCZUNWDWHZ
          PWEWCZWFZAUULAQVLVMZUULVLVMAUVLGQVNVFTVKVFVLVMAGQTUKUVHUOWDWHZQWEWCWF
          ZWGZAUUNUUOAUUNARVLVMZUUNVLVMAUVPHRVNVFTVKVFVLVMAHRTULUVHUPWDWHZRWEWC
          WFZAUUOASVLVMZUUOVLVMAUVSISVNVFTVKVFVLVMAISTUMUVHUQWDWHZSWEWCWFZWGZAU
          UHATATUVHWIZWJZWKZUWEAUUMUVBVDVKVFZUWFVJVFZUVBUTAUUKUULUWFUWFUVKUVNAU
          VBUWEWKZUWHAFPTUJUVHUNWLAGQTUKUVHUOWLWMAUVBAUVBUWEWNZWOZWPAUUPUWGUVBU
          TAUUNUUOUWFUWFUVRUWAUWHUWHAHRTULUVHUPWLAISTUMUVHUQWLWMUWJWPWMAUUHAUUH
          UWDWNWOZWPATATUWCWNZWQWPAUUQWRVMTWRVMZUWMVOTVTVAUUSUVAWSAUUMUUPUVOUWB
          WGZUWCUWCATUVHWTUUQTTXAXBXCXDAUUGUUJAUUGXGUUHFVDVEVFZGVDVEVFZVJVFZHVD
          VEVFZIVDVEVFZVJVFZVJVFZUUIVHAUUEUUHUXAVHVAZUUFAUUEXGZUUHUWQVHVAZUUHUW
          TVHVAZUXBUXCUUHUWOVHVAZUUHUWPVHVAZUXDAUUEFPTUJUVHUNUXCUUKVOVBZUULVOVB
          ZAUUEUUMVOVBZUXHUXIXGZUXCUXJUUPVOVBZAUUEUURVOVBZUXJUXLXGZUXCUURKVOURA
          UUEXHXEAUXMUXNAUXMUUQVOVBZUXNAUUQTAUUQUWNWNUWLATUVHXFXIAUUMWRVMVOUUMU
          TVAUUPWRVMVOUUPUTVAUXOUXNWSUVOAUUMAUUKUULAUVDUUKXJVMUVIPXKWCZAUVLUULX
          JVMUVMQXKWCZXLXMUWBAUUPAUUNUUOAUVPUUNXJVMUVQRXKWCZAUVSUUOXJVMUVTSXKWC
          ZXLXMUUMUUPXQXNXRXOXPZWHAUXJUXKAUUKWRVMVOUUKUTVAUULWRVMVOUULUTVAUXJUX
          KWSUVKAUUKUXPXMUVNAUULUXQXMUUKUULXQXNXOXPZWHXSAUUEGQTUKUVHUOUXCUXHUXI
          UYAXTXSAUXFUXGXGUXDVIZUUEAUUHVLVMZUWOVLVMZUWPVLVMZUYBAUUHATUVHYAYBZAF
          VLVMUYDUJFWEWCZAGVLVMUYEUKGWEWCZUUHUWOUWPYGYCYDYEUXCUUHUWRVHVAZUUHUWS
          VHVAZUXEAUUEHRTULUVHUPUXCUUNVOVBZUUOVOVBZAUUEUXLUYKUYLXGZUXCUXJUXLUXT
          XTAUXLUYMAUUNWRVMVOUUNUTVAUUOWRVMVOUUOUTVAUXLUYMWSUVRAUUNUXRXMUWAAUUO
          UXSXMUUNUUOXQXNXOXPZWHXSAUUEISTUMUVHUQUXCUYKUYLUYNXTXSAUYIUYJXGUXEVIZ
          UUEAUYCUWRVLVMZUWSVLVMZUYOUYFAHVLVMUYPULHWEWCZAIVLVMUYQUMIWEWCZUUHUWR
          UWSYGYCYDYEAUXDUXEXGUXBVIZUUEAUYCUWQVLVMZUWTVLVMZUYTUYFAUWOUWPUYGUYHY
          FZAUWRUWSUYRUYSYFZUUHUWQUWTYGYCYDYEAUUFXGZUXBUUHUXAUUHVNVFZVHVAZVUEUU
          HUWQUVBVNVFZUWTUVBVNVFZVJVFZVUFVHVUEUUHVUHVHVAZUUHVUIVHVAZUUHVUJVHVAZ
          VUEUUHUWOUWFVNVFZUWPUWFVNVFZVJVFZVUHVHVUEUUHVUNVHVAZUUHVUOVHVAZUUHVUP
          VHVAZAUUFFPTUJUVHUNVUEUWFUUKVNVFVOVBZUWFUULVNVFVOVBZVUEVUTVVAXGZUWFUU
          NVNVFVOVBZUWFUUOVNVFVOVBZXGZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
          KULUMUNUOUPUQURUSYHZWHZWHZYIAUUFGQTUKUVHUOVUEVUTVVAVVGXTYIVUEUYCVUNVL
          VMVUOVLVMVUQVURXGVUSVIAUYCUUFUYFYDZVUEUWOUWFAUYDUUFUYGYDVUEUWFUUKVLVU
          EVUTUWFUUKVBZVVHAVUTVVJWSUUFAUWFUUKAUWFUWHWNZAUUKUVJYJYKYDYLAUVEUUFUV
          JYDYMZYNVUEUWPUWFAUYEUUFUYHYDVVLYNUUHVUNVUOYGYCYEAVUPVUHVBUUFAUWQUWGV
          NVFVUPVUHAUWOUWPUWFUWFAUWOUYGYJAUWPUYHYJVVKVVKYPAUWGUVBUWQVNUWJYOYQYD
          WPVUEUUHUWRUWFVNVFZUWSUWFVNVFZVJVFZVUIVHVUEUUHVVMVHVAZUUHVVNVHVAZUUHV
          VOVHVAZAUUFHRTULUVHUPVUEVVCVVDVUEVVBVVEVVFXTZWHYIAUUFISTUMUVHUQVUEVVC
          VVDVVSXTYIVUEUYCVVMVLVMVVNVLVMVVPVVQXGVVRVIVVIVUEUWRUWFAUYPUUFUYRYDVV
          LYNVUEUWSUWFAUYQUUFUYSYDVVLYNUUHVVMVVNYGYCYEAVVOVUIVBUUFAUWTUWGVNVFVV
          OVUIAUWRUWSUWFUWFAUWRUYRYJAUWSUYSYJVVKVVKYPAUWGUVBUWTVNUWJYOYQYDWPVUE
          UYCVUHVLVMVUIVLVMVUKVULXGVUMVIVVIVUEUWQUVBAVUAUUFVUCYDVUEUWGUVBVLAUWG
          UVBVBUUFUWJYDVUEUWFUWFVVLVVLYFYRZYNVUEUWTUVBAVUBUUFVUDYDVVTYNUUHVUHVU
          IYGYCYEAVUJVUFVBUUFAUXAUVCVNVFVUJVUFAUWQUWTUVBUVBAUWQVUCYJAUWTVUDYJUW
          IUWIYPAUVCUUHUXAVNUWKYOYQYDWPVUEUYCUXAVLVMZUXBVUGWSVVIAVWAUUFAUWQUWTV
          UCVUDYFYDUUHUXAYSYTXCUUAAUUIUXAVBUUGUSYDUUBUUCUUD $.

        $( Lemma for ~ 4sq .  (Contributed by Mario Carneiro, 16-Jul-2014.) $)
        4sqlem17 $p |- -. ph $=
          ( c2 cexp co cmul cdivides wbr cc0 wceq wo cle wi 4sqlem16 simpld clt
          cr ccnv csup c1 cuz cfv wss wcel cn cv crab ssrab2 eqsstri sseqtri wn
          wne c0 4sqlem13 infmssuzcl sylancr syl5eqel sseldi nnred simprd ltned
          nnuz nncnd sqvald breq1d cz wb nnzd syl syl2anc cn0 ci caddc cabs cre
          cdiv cim cgz cc gzreim gzcn absvalsq2d zred crred crimd oveq12d eqtrd
          oveq1d eqtr4d cmin 4sqlem5 ax-icn mulcl addsub4d subdid oveq2d subcld
          eqid zcnd divdird divassd 3eqtrd eqeltrd cprime prmz nnne0d dvdscmulr
          syl112anc dvdsprm 3bitrd necon3bbid 4sqlem14 elnn0 sylib ord orc syl5
          mpbird syld mt3d divcan3d eqtr3d syl6eqr mulcomd a1i nnnn0d mul4sqlem
          eqeltrrd eleq1d elrab2 sylanbrc infmssuzle syl5eqbr letri3d mpbir2and
          prmnn oveq1 olcd mpd pm2.65i ) ATUTVAVBZTJVCVBZVDVEZAKVFVGZKTVGZVHZUV
          TAUWBUWAAUWBKTVIVEZTKVIVEAUWDUWCUVTVJZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEU
          FUGUHUIUJUKULUMUNUOUPUQURUSVKZVLATMVNVMVOVPZKVIUHAMVQVRVSZVTZKMWAZUWG
          KVIVEMWBUWHMNWCZJVCVBZLWAZNWBWDWBUGUWMNWBWEWFZWSWGZAKWBWAZKJVCVBZLWAZ
          UWJAUWPUVTAUVTWHTJWIATJATAMWBTUWNATUWGMUHAUWIMWJWIZUWGMWAUWOAUWSTJVMV
          EZABCDEJLMNOTUAUBUCUDUEUFUGUHWKZVLMVQWLWMWNWOZWPZAUWSUWTUXAWQWRAUVTTJ
          AUVTTTVCVBZUVSVDVEZTJVDVEZTJVGZAUVRUXDUVSVDATATUXBWTZXAXBATXCWAZJXCWA
          ZUXITVFWIUXEUXFXDATUXBXEZAJUUAWAZUXJUEJUUBXFUXKATUXBUUCZTTJUUDUUEATUT
          VRVSWAUXLUXFUXGXDUIUEJTUUFXGUUGUUHUUOZAUWPWHUWAUVTAUWPUWAAKXHWAUWPUWA
          VHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUUIKUUJUU
          KUULUWAUWCAUVTUWAUWBUUMAUWDUWEUWFWQZUUNUUPUUQZAFXIGVCVBZXJVBZXKVSUTVA
          VBZHXIIVCVBZXJVBZXKVSUTVAVBZXJVBZTXMVBZPXIQVCVBZXJVBZXKVSUTVAVBZRXISV
          CVBZXJVBZXKVSUTVAVBZXJVBZTXMVBZVCVBZUWQLAUYMJKVCVBUWQAUYDJUYLKVCAUVST
          XMVBUYDJAUVSUYCTXMAUVSFUTVAVBZGUTVAVBZXJVBZHUTVAVBZIUTVAVBZXJVBZXJVBU
          YCUSAUXSUYPUYBUYSXJAUXSUXRXLVSZUTVAVBZUXRXNVSZUTVAVBZXJVBUYPAUXRAUXRX
          OWAZUXRXPWAAFXCWAGXCWAVUDUJUKFGXQXGZUXRXRXFXSAVUAUYNVUCUYOXJAUYTFUTVA
          AFGAFUJXTZAGUKXTZYAYEAVUBGUTVAAFGVUFVUGYBYEYCYDAUYBUYAXLVSZUTVAVBZUYA
          XNVSZUTVAVBZXJVBUYSAUYAAUYAXOWAZUYAXPWAAHXCWAIXCWAVULULUMHIXQXGZUYAXR
          XFXSAVUIUYQVUKUYRXJAVUHHUTVAAHIAHULXTZAIUMXTZYAYEAVUJIUTVAAHIVUNVUOYB
          YEYCYDYCYFYEAJTAJAUXLJWBWAUEJUVMXFZWTZUXHUXMUURUUSZAUYLPUTVAVBZQUTVAV
          BZXJVBZRUTVAVBZSUTVAVBZXJVBZXJVBZTXMVBKAUYKVVETXMAUYGVVAUYJVVDXJAUYGU
          YFXLVSZUTVAVBZUYFXNVSZUTVAVBZXJVBVVAAUYFAUYFXOWAZUYFXPWAAPXCWAZQXCWAZ
          VVJAVVKFPYGVBZTXMVBZXCWAZAFPTUJUXBUNYHZVLZAVVLGQYGVBZTXMVBZXCWAZAGQTU
          KUXBUOYHZVLZPQXQXGZUYFXRXFXSAVVGVUSVVIVUTXJAVVFPUTVAAPQAPVVQXTZAQVWBX
          TZYAYEAVVHQUTVAAPQVWDVWEYBYEYCYDAUYJUYIXLVSZUTVAVBZUYIXNVSZUTVAVBZXJV
          BVVDAUYIAUYIXOWAZUYIXPWAARXCWAZSXCWAZVWJAVWKHRYGVBZTXMVBZXCWAZAHRTULU
          XBUPYHZVLZAVWLISYGVBZTXMVBZXCWAZAISTUMUXBUQYHZVLZRSXQXGZUYIXRXFXSAVWG
          VVBVWIVVCXJAVWFRUTVAARSARVWQXTZASVXBXTZYAYEAVWHSUTVAARSVXDVXEYBYEYCYD
          YCYEURUUTYCAJKVUQAKUXPWTUVAYDABCDEUXRUYAUYFUYILOTUYCUYKUBVUEVUMVWCVXC
          UYCYOUYKYOUXBAUXRUYFYGVBZTXMVBZVVNXIVVSVCVBZXJVBZXOAVXGVVMXIVVRVCVBZX
          JVBZTXMVBVVNVXJTXMVBZXJVBVXIAVXFVXKTXMAVXFVVMUXQUYEYGVBZXJVBVXKAFUXQP
          UYEAFUJYPZAXIXPWAZGXPWAUXQXPWAYIAGUKYPZXIGYJWMAPVVQYPZAVXOQXPWAUYEXPW
          AYIAQVWBYPZXIQYJWMYKAVXJVXMVVMXJAXIGQVXOAYIUVBZVXPVXRYLYMYFYEAVVMVXJT
          AFPVXNVXQYNAVXOVVRXPWAVXJXPWAYIAGQVXPVXRYNZXIVVRYJWMUXHUXMYQAVXLVXHVV
          NXJAXIVVRTVXSVXTUXHUXMYRYMYSAVVOVVTVXIXOWAAVVKVVOVVPWQAVVLVVTVWAWQVVN
          VVSXQXGYTAUYAUYIYGVBZTXMVBZVWNXIVWSVCVBZXJVBZXOAVYBVWMXIVWRVCVBZXJVBZ
          TXMVBVWNVYETXMVBZXJVBVYDAVYAVYFTXMAVYAVWMUXTUYHYGVBZXJVBVYFAHUXTRUYHA
          HULYPZAVXOIXPWAUXTXPWAYIAIUMYPZXIIYJWMARVWQYPZAVXOSXPWAUYHXPWAYIASVXB
          YPZXISYJWMYKAVYEVYHVWMXJAXIISVXSVYJVYLYLYMYFYEAVWMVYETAHRVYIVYKYNAVXO
          VWRXPWAVYEXPWAYIAISVYJVYLYNZXIVWRYJWMUXHUXMYQAVYGVYCVWNXJAXIVWRTVXSVY
          MUXHUXMYRYMYSAVWOVWTVYDXOWAAVWKVWOVWPWQAVWLVWTVXAWQVWNVWSXQXGYTAUYDJX
          HVURAJVUPUVCYTUVDUVEUWMUWRNKWBMUWKKVGUWLUWQLUWKKJVCUVNUVFUGUVGUVHKMVQ
          UVIWMUVJAKTAKUXPWPUXCUVKUVLUVOUXOUVPUXNUVQ $.
      $}

      $( Lemma for ~ 4sq .  Inductive step, odd prime case.  (Contributed by
         Mario Carneiro, 16-Jul-2014.) $)
      4sqlem18 $p |- ( ph -> P e. S ) $=
        ( co va vb vc vd c1 cmul cprime wcel cn prmnn syl nncnd mulid2d wceq c2
        cuz cfv wa cv cexp caddc cz wrex wn cr clt ccnv csup wss c0 crab ssrab2
        wne eqsstri nnuz sseqtri wbr 4sqlem13 infmssuzcl sylancr syl5eqel oveq1
        simpld eleq1d elrab2 sylib simprd 4sqlem2 adantr wi w3a cdiv cmo simp1l
        cmin cc0 cfz simp1r simp2ll simp2lr simp2rl simp2rr eqid simp3 4sqlem17
        pm2.21i 3expia anassrs rexlimdvva mpd pm2.01da wo elnn1uz2 ord eqeltrrd
        mt3d simprbi ) AUEFUFTZFGAFAFAFUGUHZFUIUHPFUJUKULUMAUEHUHZXRGUHZAKUEHAK
        UEUNZKUOUPUQUHZAYCAYCURZKFUFTZUAUSZUOUTTUBUSZUOUTTVATUCUSZUOUTTUDUSZUOU
        TTVATVATUNZUDVBVCUCVBVCZUBVBVCUAVBVCZYCVDZAYLYCAYEGUHZYLAKUIUHZYNAKHUHY
        OYNURAKHVEVFVGVHZHSAHUEUPUQZVIHVJVMZYPHUHHUIYQHIUSZFUFTZGUHZIUIVKUIRUUA
        IUIVLVNVOVPAYRKFVFVQABCDEFGHIJKLMNOPQRSVRWCHUEVSVTWAZUUAYNIKUIHYSKUNYTY
        EGYSKFUFWBWDRWEWFZWGBCDEYEGJUAUBUCUDMWHWFWIYDYKYMUAUBVBVBYDYFVBUHZYGVBU
        HZURZURYJYMUCUDVBVBYDUUFYHVBUHZYIVBUHZURZYJYMWJYDUUFUUIURZYJYMYDUUJYJWK
        ZYMUUKBCDEYFYGYHYIFYFKUOWLTZVATKWMTUULWOTZUOUTTYGUULVATKWMTUULWOTZUOUTT
        VATYHUULVATKWMTUULWOTZUOUTTYIUULVATKWMTUULWOTZUOUTTVATVATKWLTZGHIJUUMUU
        NUUOUUPKLMUUKALUIUHAYCUUJYJWNZNUKUUKAFUOLUFTZUEVATUNUUROUKUUKAXSUURPUKU
        UKAWPUUSWQTGVIUURQUKRSAYCUUJYJWRUUDUUEUUIYDYJWSUUDUUEUUIYDYJWTUUGUUHUUF
        YDYJXAUUGUUHUUFYDYJXBUUMXCUUNXCUUOXCUUPXCUUQXCYDUUJYJXDXEXFXGXHXIXIXJXK
        AYBYCAYOYBYCXLAYOYNUUCWCKXMWFXNXPUUBXOXTUEUIUHYAUUAYAIUEUIHYSUEUNYTXRGY
        SUEFUFWBWDRWEXQUKXO $.
    $}

    $( Lemma for ~ 4sq .  The proof is by strong induction - we show that if
       all the integers less than ` k ` are in ` S ` , then ` k ` is as well.
       In this part of the proof we do the induction argument and dispense with
       all the cases except the odd prime case, which is sent to ~ 4sqlem18 .
       If ` k ` is ` 0 , 1 , 2 ` , we show ` k e. S ` directly; otherwise if
       ` k ` is composite, ` k ` is the product of two numbers less than it
       (and hence in ` S ` by assumption), so by ~ mul4sq ` k e. S ` .
       (Contributed by Mario Carneiro, 14-Jul-2014.)  (Revised by Mario
       Carneiro, 20-Jun-2015.) $)
    4sqlem19 $p |- NN0 = S $=
      ( wcel cn cc0 wceq c1 cmul co eleq1 c2 cexp caddc cfz wa vk vj vm vi cabs
      cn0 cv wo elnn0 cfv abs1 oveq1i sq1 eqtri abs0 sq0 oveq12i ax-1cn addid1i
      cgz cz 1z zgz ax-mp 4sqlem4a mp2an eqeltrri cprime cmin wral wne csn cdif
      0z eldifsn crab cr ccnv csup cdiv oddprm adantr cc eldifi prmnn nncn 3syl
      clt subcl sylancl 2cn a1i divcan2d oveq1d npcan eqtr2d cun oveq2d nnm1nn0
      2ne0 cuz elnn0uz sylib eluzfz1 fzsplit eqtrd wss fzsn snssi eqsstri 0p1e1
      00id simpr dfss3 sylibr syl5eqss unssd eqsstrd oveq1 eleq1d eqid 4sqlem18
      cbvrabv sylanbr an32s eqtr4i pm2.61ne wi mul4sq prmind2 id syl6eqel sylbi
      df-2 jaoi ssriv 4sqlem1 eqssi ) UFEUAUFEUAUGZUFHYSIHZYSJKZUHYSEHZYSUIYTUU
      BUUAUBUGZEHZLEHUCUGZEHZUDUGZEHZUUEUUGMNZEHZUUBUBUCUDYSUUCLEOUUCUUEEOUUCUU
      GEOUUCUUIEOUUCYSEOLUEUJZPQNZJUEUJZPQNZRNZLEUUOLJRNLUULLUUNJRUULLPQNLUUKLP
      QUKULUMUNZUUNJPQNJUUMJPQUOULUPUNZUQLURUSUNLUTHZJUTHZUUOEHLVAHUURVBLVCVDZJ
      VAHZUUSVNJVCVDZABCDLJEFGVEVFVGUUCVHHZUUFUCLUUCLVINZSNZVJZTZUUDPEHZUUCPUUC
      PEOUVCUUCPVKZUVFUUDUVCUVITUUCVHPVLZVMHZUVFUUDUUCVHPVOUVKUVFTZABCDUUCEYSUU
      CMNZEHZUAIVPZUDFUVOVQWHVRVSZUVDPVTNZGUVKUVQIHUVFUUCWAWBUVLPUVQMNZLRNUVDLR
      NZUUCUVLUVRUVDLRUVLUVDPUVLUUCWCHZLWCHZUVDWCHUVLUVCUUCIHZUVTUVKUVCUVFUUCVH
      UVJWDWBZUUCWEZUUCWFWGZURUUCLWIWJPWCHUVLWKWLPJVKUVLWTWLWMZWNUVLUVTUWAUVSUU
      CKUWEURUUCLWOWJWPUWCUVLJUVRSNZJJSNZJLRNZUVDSNZWQZEUVLUWGJUVDSNZUWKUVLUVRU
      VDJSUWFWRUVLUVDJXAUJHZJUWLHUWLUWKKUVLUVDUFHZUWMUVLUVCUWBUWNUWCUWDUUCWSWGU
      VDXBXCJUVDXDJJUVDXEWGXFUVLUWHUWJEUWHEXGUVLUWHJVLZEUVAUWHUWOKVNJXHVDJEHUWO
      EXGUUNUUNRNZJEUWPJJRNJUUNJUUNJRUUQUUQUQXLUNUUSUUSUWPEHUVBUVBABCDJJEFGVEVF
      VGZJEXIVDXJWLUVLUWJUVEEUWILUVDSXKULUVLUVFUVEEXGUVKUVFXMUCUVEEXNXOXPXQXRUV
      NUUGUUCMNZEHUAUDIYSUUGKUVMUWREYSUUGUUCMXSXTYCUVPYAYBYDYEUVHUVGUULUULRNZPE
      UWSLLRNPUULLUULLRUUPUUPUQYNYFUURUURUWSEHUUTUUTABCDLLEFGVEVFVGWLYGUUFUUHTU
      UJYHUUEPXAUJZHUUGUWTHTABCDUUEUUGEFGYIWLYJUUAYSJEUUAYKUWQYLYOYMYPABCDEFGYQ
      YR $.
  $}

  ${
    $d a b c d m n w x y z A $.
    $( Lagrange's four-square theorem, or Bachet's conjecture: every
       nonnegative integer is expressible as a sum of four squares.
       (Contributed by Mario Carneiro, 16-Jul-2014.) $)
    4sq $p |- ( A e. NN0 <-> E. a e. ZZ E. b e. ZZ E. c e. ZZ E. d e. ZZ
        A = ( ( ( a ^ 2 ) + ( b ^ 2 ) ) + ( ( c ^ 2 ) + ( d ^ 2 ) ) ) ) $=
      ( vx vy vz vw vm vn cv c2 cexp co caddc wceq cz wrex 2rexbidv cn0 4sqlem2
      cab eqeq1 cbvabv 4sqlem19 ) FGHIAUAJBCDEFGHIJLZFLMNOGLMNOPOHLMNOILMNOPOPO
      ZQZIRSHRSZGRSFRSZJUCKUKKLZUHQZIRSHRSZGRSFRSJKUGULQZUJUNFGRRUOUIUMHIRRUGUL
      UHUDTTUEUFUB $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Van der Waerden's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c AP $. $( Arithmetic progression $)
  $c MonoAP $. $( Monochromatic arithmetic progression $)
  $c PolyAP $. $( Polychromatic arithmetic progression $)

  $( The arithmetic progression function. $)
  cvdwa $a class AP $.

  $( The monochromatic arithmetic progression predicate. $)
  cvdwm $a class MonoAP $.

  $( The polychromatic arithmetic progression predicate. $)
  cvdwp $a class PolyAP $.

  ${
    $d a c d f i k m $.
    $( Define the arithmetic progression function, which takes as input a
       length ` k ` , a start point ` a ` , and a step ` d ` and outputs the
       set of points in this progression.  (Contributed by Mario Carneiro,
       18-Aug-2014.) $)
    df-vdwap $a |- AP = ( k e. NN0 |-> ( a e. NN , d e. NN |->
      ran ( m e. ( 0 ... ( k - 1 ) ) |-> ( a + ( m x. d ) ) ) ) ) $.

    $( Define the "contains a monochromatic AP" predicate.  (Contributed by
       Mario Carneiro, 18-Aug-2014.) $)
    df-vdwmc $a |- MonoAP = { <. k , f >. |
      E. c ( ran ( AP ` k ) i^i ~P ( `' f " { c } ) ) =/= (/) } $.

    $( Define the "contains a polychromatic colleciton of APs" predicate.  See
       ~ vdwpc for more information.  (Contributed by Mario Carneiro,
       18-Aug-2014.) $)
    df-vdwpc $a |- PolyAP = { <. <. m , k >. , f >. | E. a e. NN
      E. d e. ( NN ^m ( 1 ... m ) ) ( A. i e. ( 1 ... m )
      ( ( a + ( d ` i ) ) ( AP ` k ) ( d ` i ) ) C_
        ( `' f " { ( f ` ( a + ( d ` i ) ) ) } ) /\
      ( # ` ran ( i e. ( 1 ... m ) |-> ( f ` ( a + ( d ` i ) ) ) ) ) = m ) } $.
  $}

  ${
    $d a d m n x A $.  $d a d m n x D $.  $d a d k m n x K $.  $d m x X $.
    $( Define the arithmetic progression function, which takes as input a
       length ` k ` , a start point ` a ` , and a step ` d ` and outputs the
       set of points in this progression.  (Contributed by Mario Carneiro,
       18-Aug-2014.) $)
    vdwapfval $p |- ( K e. NN0 -> ( AP ` K ) = ( a e. NN , d e. NN |->
      ran ( m e. ( 0 ... ( K - 1 ) ) |-> ( a + ( m x. d ) ) ) ) ) $=
      ( vk cn cc0 cv c1 cmin co cfz cmul caddc cmpt crn cmpt2 cn0 wcel nnex w3a
      cvdwa simp1 oveq1d oveq2d mpteq1d rneqd mpt2eq3dva df-vdwap mpt2ex fvmpt
      wceq ) EBCDFFAGEHZIJKZLKZCHZAHDHZMKNKZOZPZQCDFFAGBIJKZLKZUROZPZQRUBUMBULZ
      CDFFUTVDVEUPFSZUQFSZUAZUSVCVHAUOVBURVHUNVAGLVHUMBIJVEVFVGUCUDUEUFUGUHEACD
      UICDFFVDTTUJUK $.

    $( The arithmetic progression function is a function.  (Contributed by
       Mario Carneiro, 18-Aug-2014.) $)
    vdwapf $p |- ( K e. NN0 -> ( AP ` K ) : ( NN X. NN ) --> ~P NN ) $=
      ( va vd vm cn0 wcel cn cxp cpw cvdwa cfv wf cc0 c1 cmin co cv wral eqid
      wa cfz cmul caddc cmpt crn cmpt2 wss simpll elfznn0 adantl nnnn0 ad2antlr
      nn0mulcld nnnn0addcl syl2anc fmptd frn syl nnex elpw2 sylibr rgen2a fmpt2
      mpbi vdwapfval feq1d mpbiri ) AEFZGGHZGIZAJKZLVIVJBCGGDMANOPZUAPZBQZDQZCQ
      ZUBPZUCPZUDZUEZUFZLZVTVJFZCGRBGRWBWCBCGVNGFZVPGFZTZVTGUGZWCWFVMGVSLWGWFDV
      MVRGVSWFVOVMFZTZWDVQEFVRGFWDWEWHUHWIVOVPWHVOEFWFVOVLUIUJWEVPEFWDWHVPUKULU
      MVNVQUNUOVSSUPVMGVSUQURVTGUSUTVAVBBCGGVTVJWAWASVCVDVHVIVJVKWADABCVEVFVG
      $.

    $( Value of the arithmetic progression function.  (Contributed by Mario
       Carneiro, 18-Aug-2014.) $)
    vdwapval $p |- ( ( K e. NN0 /\ A e. NN /\ D e. NN ) ->
      ( X e. ( A ( AP ` K ) D ) <->
        E. m e. ( 0 ... ( K - 1 ) ) X = ( A + ( m x. D ) ) ) ) $=
      ( vx va vd wcel cn co cv cmul caddc wceq cc0 cfz wrex cmpt crn cn0 w3a c1
      cvdwa cfv cab cmpt2 vdwapfval 3ad2ant1 oveqd oveq2 oveq12 sylan2 mpteq2dv
      cmin rneqd eqid ovex mptex rnex ovmpt2a 3adant1 eqtrd rnmpt syl6eq eleq2d
      wa cvv id syl6eqel rexlimivw eqeq1 rexbidv elab3 syl6bb ) DUAIZAJIZBJIZUB
      ZEABDUDUEZKZIEFLZACLZBMKZNKZOZCPDUCUOKZQKZRZFUFZIEWEOZCWHRZVSWAWJEVSWACWH
      WESZTZWJVSWAABGHJJCWHGLZWCHLZMKZNKZSZTZUGZKZWNVSVTXAABVPVQVTXAOVRCDGHUHUI
      UJVQVRXBWNOVPGHABJJWTWNXAWOAOZWPBOZVGZWSWMXECWHWRWEXDXCWQWDOWRWEOWPBWCMUK
      WOAWQWDNULUMUNUPXAUQWMCWHWEPWGQURUSUTVAVBVCCFWHWEWMWMUQVDVEVFWIWLFEWKEVHI
      CWHWKEWEVHWKVIAWDNURVJVKWBEOWFWKCWHWBEWEVLVMVNVO $.

    $( Remove the first element of an arithmetic progression.  (Contributed by
       Mario Carneiro, 11-Sep-2014.) $)
    vdwapun $p |- ( ( K e. NN0 /\ A e. NN /\ D e. NN ) ->
      ( A ( AP ` ( K + 1 ) ) D ) = ( { A } u. ( ( A + D ) ( AP ` K ) D ) ) ) $=
      ( vn vm wcel c1 caddc co cc0 wceq cmul wa wex cfz cmin cc oveq2d adantr
      cz vx cn0 cn w3a cvdwa cfv csn cun cv wo wrex wb peano2nn0 vdwapval simp1
      syl3an1 nn0cnd ax-1cn pncan sylancl eleq2d cuz nn0uz syl6eleq elfzp12 syl
      bitrd anbi1d andir syl6bb exbidv df-rex 19.43 bicomi nncn 3ad2ant3 mul02d
      3bitr4g 3ad2ant2 addid1d eqtrd eqeq2d c0ex oveq1 ceqsexv elsn simpr 0p1e1
      oveq1i a1i nn0zd elfzelz adantl fzsubel syl22anc mpbid 1m1e0 zcnd subdird
      mulid2d mulcld pncan3d eqtr2d subcl addassd eqtr4d rspcev syl2anc rexbidv
      eqeq1 syl5ibrcom expimpd exlimdv peano2zm fzaddel eleqtrd adddird addcomd
      1z npcan ovex eleq1 anbi12d spcev anbi2d rexlimdva impbid nnaddcl 3adant1
      0z syld3an2 bitr4d orbi12d elun syl6bbr eqrdv ) CUBFZAUCFZBUCFZUDZUAABCGH
      IZUEUFIZAUGZABHIZBCUEUFIZUHZYTUAUIZUUBFZDUIZJKZUUGAUUIBLIZHIZKZMZDNZUUIJG
      HIZCOIZFZUUMMZDNZUJZUUGUUFFZYTUUHUUMDJUUAGPIZOIZUKZUVAYQUUAUBFYRYSUUHUVEU
      LCUMABDUUAUUGUNUPYTUUIUVDFZUUMMZDNUUNUUSUJZDNZUVEUVAYTUVGUVHDYTUVGUUJUURU
      JZUUMMUVHYTUVFUVJUUMYTUVFUUIJCOIZFZUVJYTUVDUVKUUIYTUVCCJOYTCQFZGQFZUVCCKY
      TCYQYRYSUOZUQURCGUSUTRVAYTCJVBUFZFUVLUVJULYTCUBUVPUVOVCVDUUIJCVEVFVGVHUUJ
      UURUUMVIVJVKUUMDUVDVLUVIUVAUUNUUSDVMVNVRVGYTUVAUUGUUCFZUUGUUEFZUJUVBYTUUO
      UVQUUTUVRYTUUGAJBLIZHIZKZUUGAKUUOUVQYTUVTAUUGYTUVTAJHIAYTUVSJAHYTBYSYQBQF
      ZYRBVOVPZVQRYTAYRYQAQFZYSAVOVSZVTWAWBUUMUWADJWCUUJUULUVTUUGUUJUUKUVSAHUUI
      JBLWDRWBWEUAAWFVRYTUUTUUGUUDEUIZBLIZHIZKZEJCGPIZOIZUKZUVRYTUUTUWLYTUUSUWL
      DYTUURUUMUWLYTUURMZUWLUUMUULUWHKZEUWKUKZUWMUUIGPIZUWKFUULUUDUWPBLIZHIZKZU
      WOUWMUWPGGPIZUWJOIZUWKUWMUUIGCOIZFZUWPUXAFZUWMUUIUUQUXBYTUURWGUUPGCOWHWIV
      DUWMGTFZCTFZUUITFZUXEUXCUXDULUXEUWMXSWJZUWMCYTYQUURUVOSWKUURUXGYTUUIUUPCW
      LWMZUXHUUIGGCWNWOWPUWTJUWJOWQWIVDUWMUULABUWQHIZHIUWRUWMUUKUXJAHUWMUXJBUUK
      BPIZHIUUKUWMUWQUXKBHUWMUWQUUKGBLIZPIUXKUWMUUIGBUWMUUIUXIWRZUVNUWMURWJYTUW
      BUURUWCSZWSUWMUXLBUUKPUWMBUXNWTRWARUWMBUUKUXNUWMUUIBUXMUXNXAXBXCRUWMABUWQ
      YTUWDUURUWESUXNUWMUWPBUWMUUIQFUVNUWPQFUXMURUUIGXDUTUXNXAXEXFUWNUWSEUWPUWK
      UWFUWPKZUWHUWRUULUXOUWGUWQUUDHUWFUWPBLWDRWBXGXHUUMUWIUWNEUWKUUGUULUWHXJXI
      XKXLXMYTUWIUUTEUWKYTUWFUWKFZMZUUTUWIUURUWHUULKZMZDNZUXQUWFGHIZUUQFZUWHAUY
      ABLIZHIZKZUXTUXQUYAUUPUWJGHIZOIZUUQUXQUXPUYAUYGFZYTUXPWGUXQJTFZUWJTFZUWFT
      FZUXEUXPUYHULUYIUXQYJWJUXQUXFUYJUXQCYTYQUXPUVOSZWKCXNVFUXPUYKYTUWFJUWJWLW
      MZUXEUXQXSWJUWFGJUWJXOWOWPUXQUYFCUUPOUXQUVMUVNUYFCKUXQCUYLUQURCGXTUTRXPUX
      QUWHABUWGHIZHIUYDUXQABUWGYTUWDUXPUWESYTUWBUXPUWCSZUXQUWFBUXQUWFUYMWRZUYOX
      AZXEUXQUYCUYNAHUXQUYCUWGUXLHIZUYNUXQUWFGBUYPUVNUXQURWJUYOXQUXQUYNUWGBHIUY
      RUXQBUWGUYOUYQXRUXQUXLBUWGHUXQBUYOWTRXFXFRXFUXSUYBUYEMDUYAUWFGHYAUUIUYAKZ
      UURUYBUXRUYEUUIUYAUUQYBUYSUULUYDUWHUYSUUKUYCAHUUIUYABLWDRWBYCYDXHUWIUUSUX
      SDUWIUUMUXRUURUUGUWHUULXJYEVKXKYFYGYQUUDUCFZYRYSUVRUWLULYRYSUYTYQABYHYIUU
      DBECUUGUNYKYLYMUUGUUCUUEYNYOVGYP $.

    $( The first element of an arithmetic progression.  (Contributed by Mario
       Carneiro, 12-Sep-2014.) $)
    vdwapid1 $p |- ( ( K e. NN /\ A e. NN /\ D e. NN ) ->
      A e. ( A ( AP ` K ) D ) ) $=
      ( cn wcel w3a csn caddc co c1 cmin cvdwa cfv cun wss ssun1 wb snssg wceq
      cc 3ad2ant2 mpbiri 3ad2ant1 ax-1cn npcan sylancl fveq2d oveqd cn0 nnm1nn0
      nncn vdwapun syl3an1 eqtr3d eleqtrrd ) CDEZADEZBDEZFZAAGZABHIBCJKIZLMIZNZ
      ABCLMZIZUSAVCEZUTVCOZUTVBPUQUPVFVGQURAVCDRUAUBUSABVAJHIZLMZIZVEVCUSVIVDAB
      USVHCLUSCTEZJTEVHCSUPUQVKURCUKUCUDCJUEUFUGUHUPVAUIEUQURVJVCSCUJABVAULUMUN
      UO $.

    $( Value of a length-1 arithmetic progression.  (Contributed by Mario
       Carneiro, 18-Aug-2014.) $)
    vdwap0 $p |- ( ( A e. NN /\ D e. NN ) -> ( A ( AP ` 0 ) D ) = (/) ) $=
      ( vx vm cn wcel wa cc0 cvdwa cfv co cv cmul caddc wceq c0 ax-mp cz wb 0z
      c1 cmin cfz wrex wn noel pm2.21i clt wbr 0re ltm1 peano2zm fzn mp2an mpbi
      cr eleq2s nrex cn0 0nn0 vdwapval mp3an1 mtbiri eq0rdv ) AEFZBEFZGZCABHIJK
      ZVGCLZVHFZVIADLZBMKNKOZDHHUAUBKZUCKZUDZVLDVNVLUEZVKPVNVKPFVPVKUFUGVMHUHUI
      ZVNPOZHUPFVQUJHUKQHRFZVMRFZVQVRSTVSVTTHULQHVMUMUNUOUQURHUSFVEVFVJVOSUTABD
      HVIVAVBVCVD $.

    $( Value of a length-1 arithmetic progression.  (Contributed by Mario
       Carneiro, 18-Aug-2014.) $)
    vdwap1 $p |- ( ( A e. NN /\ D e. NN ) -> ( A ( AP ` 1 ) D ) = { A } ) $=
      ( cn wcel wa c1 cvdwa cfv co csn caddc cc0 cun 1e0p1 fveq2i cn0 wceq 0nn0
      oveqi c0 vdwapun mp3an1 syl5eq nnaddcl vdwap0 sylancom uneq2d un0 syl6eq
      eqtrd ) ACDZBCDZEZABFGHZIZAJZABKIZBLGHIZMZUPUMUOABLFKIZGHZIZUSUNVAABFUTGN
      OSLPDUKULVBUSQRABLUAUBUCUMUSUPTMUPUMURTUPUKULUQCDURTQABUDUQBUEUFUGUPUHUIU
      J $.
  $}

  ${
    $d a c d f i k m w x y z F $.  $d a c d f i k m w x y z K $.  $d c x ph $.
    $d d f i k m J $.  $d a d f i k m M $.
    vdwmc.1 $e |- X e. _V $.
    vdwmc.2 $e |- ( ph -> K e. NN0 ) $.
    vdwmc.3 $e |- ( ph -> F : X --> R ) $.
    $( The predicate " The ` <. R , N >. ` -coloring ` F ` contains a
       monochromatic AP of length ` K ` ".  (Contributed by Mario Carneiro,
       18-Aug-2014.) $)
    vdwmc $p |- ( ph -> ( K MonoAP F <-> E. c E. a e. NN E. d e. NN
                  ( a ( AP ` K ) d ) C_ ( `' F " { c } ) ) ) $=
      ( vz vw cfv cv wex cn wrex wcel cvv vk vf cvdwm wbr crn ccnv csn cima cpw
      cvdwa cin c0 wne co wss cn0 wb wf fex sylancl wceq wa fveq2 rneqd imaeq1d
      cnveq pweqd ineqan12d neeq1d exbidv brabga syl2anc cxp wfn vdwapf ffn vex
      df-vdwmc elpw sseq1 syl5bb rexrn 4syl elin exbii n0 df-rex 3bitr4ri df-ov
      cop syl6eqr sseq1d rexxp 3bitr3g bitrd ) ADCUCUDZDUJNZUEZCUFZGOUGZUHZUIZU
      KZULUMZGPZFOZHOZWQUNZXAUOZHQRFQRZGPADUPSZCTSZWPXEUQJAEBCURETSXLKIEBTCUSUT
      UAOZUJNZUEZUBOZUFZWTUHZUIZUKZULUMZGPXEUAUBDCUCUPTXMDVAZXPCVAZVBZYAXDGYDXT
      XCULYBYCXOWRXSXBYBXNWQXMDUJVCVDYCXRXAYCXQWSWTXPCVFVEVGVHVIVJUBUAGVRVKVLAX
      DXJGALOZXBSZLWRRZMOZWQNZXAUOZMQQVMZRZXDXJAXKYKQUIZWQURWQYKVNYGYLUQJDVOYKY
      MWQVPYFYJLMYKWQYFYEXAUOYEYIVAYJYEXALVQVSYEYIXAVTWAWBWCYEXCSZLPYEWRSYFVBZL
      PXDYGYNYOLYEWRXBWDWELXCWFYFLWRWGWHYJXIMFHQQYHXFXGWJZVAZYIXHXAYQYIYPWQNXHY
      HYPWQVCXFXGWQWIWKWLWMWNVJWO $.

    ${
      $d a c d R $.  $d a d ph $.
      vdwmc2.4 $e |- ( ph -> A e. X ) $.
      $( Expand out the definition of an arithmetic progression.  (Contributed
         by Mario Carneiro, 18-Aug-2014.) $)
      vdwmc2 $p |- ( ph -> ( K MonoAP F <-> E. c e. R E. a e. NN E. d e. NN
      A. m e. ( 0 ... ( K - 1 ) ) ( a + ( m x. d ) ) e. ( `' F " { c } ) ) ) $=
        ( vx cn wrex wcel wa c0 cvdwm wbr cv cvdwa cfv co ccnv csn cima wss wex
        cmul caddc cc0 c1 cmin cfz wral vdwmc wb wceq wne w3a vdwapid1 ne0i syl
        wi 3expb adantll ssn0 expcom wn disjsn wf adantr fimacnvdisj ex syl5bir
        cin necon1ad syld rexlimdvva pm4.71rd exbidv syl6bbr ffvelrnd 1nn ax-mp
        df-rex simpllr fveq2d oveqd vdwap0 eqtrd 0ss syl6eqss ralrimiva sylancr
        r19.2z ralrimivw syl2anc rexex cn0 wo elnn0 sylib mpjaodan wal vdwapval
        2thd sylan imbi1d albidv dfss2 ralcom4 ovex eleq1 ceqsalv r19.23v albii
        ralbii 3bitr3i 3bitr4g 2rexbidva rexbidv 3bitrd ) AFEUAUBHUCZJUCZFUDUEZ
        UFZEUGIUCZUHZUIZUJZJPQZHPQZIUKZYPICQZYGDUCYHULUFZUMUFZYMRZDUNFUOUPUFUQU
        FZURZJPQHPQZICQACEFGHIJKLMUSAFPRZYQYRUTFUNVAZAUUESZYQYKCRZYPSZIUKYRUUGY
        PUUIIUUGYPUUHUUGYNUUHHJPPUUGYGPRZYHPRZSZSZYNYMTVBZUUHUUMYJTVBZYNUUNVGUU
        EUULUUOAUUEUUJUUKUUOUUEUUJUUKVCYGYJRUUOYGYHFVDYJYGVEVFVHVIYNUUOUUNYJYMV
        JVKVFUUMUUHYMTUUHVLCYLVSTVAZUUMYMTVAZCYKVMUUGUUPUUQVGZUULUUGGCEVNZUURAU
        USUUEMVOUUSUUPUUQGCYLEVPVQVFVOVRVTWAWBWCWDYPICWIWEAUUFSZYQYRUUTYRYQUUTC
        TVBZYPICURYRAUVAUUFABEUEZCRUVAAGCBEMNWFCUVBVEVFVOUUTYPICUUTPTVBZYOHPURY
        PUOPRUVCWGPUOVEWHZUUTYOHPUUTUUJSZUVCYNJPURYOUVDUVEYNJPUVEUUKSZYJTYMUVFY
        JYGYHUNUDUEZUFZTUVFYIUVGYGYHUVFFUNUDAUUFUUJUUKWJWKWLUUJUUKUVHTVAUUTYGYH
        WMVIWNYMWOWPWQYNJPWSWRWQYOHPWSWRWTYPICWSXAZYPICXBVFUVIXJAFXCRZUUEUUFXDL
        FXEXFXGAYPUUDICAYNUUCHJPPAUULSZOUCZYJRZUVLYMRZVGZOXHUVLYTVAZDUUBQZUVNVG
        ZOXHZYNUUCUVKUVOUVROUVKUVMUVQUVNAUVJUULUVMUVQUTZLUVJUUJUUKUVTYGYHDFUVLX
        IVHXKXLXMOYJYMXNUVPUVNVGZOXHZDUUBURUWADUUBURZOXHUUCUVSUWADOUUBXOUWBUUAD
        UUBUVNUUAOYTYGYSUMXPUVLYTYMXQXRYAUWCUVROUVPUVNDUUBXSXTYBYCYDYEYF $.
    $}

    vdwpc.4 $e |- ( ph -> M e. NN ) $.
    vdwpc.5 $e |- J = ( 1 ... M ) $.
    $( The predicate " The coloring ` F ` contains a polychromatic ` M ` -tuple
       of AP's of length ` K ` ".  A polychromatic ` M ` -tuple of AP's is a
       set of AP's with the same base point but different step lengths, such
       that each individual AP is monochromatic, but the AP's all have mutually
       distinct colors.  (The common basepoint is not required to have the same
       color as any of the AP's.)  (Contributed by Mario Carneiro,
       18-Aug-2014.) $)
    vdwpc $p |- ( ph -> ( <. M , K >. PolyAP F <-> E. a e. NN
      E. d e. ( NN ^m J ) ( A. i e. J ( ( a + ( d ` i ) ) ( AP ` K )
          ( d ` i ) ) C_ ( `' F " { ( F ` ( a + ( d ` i ) ) ) } ) /\
      ( # ` ran ( i e. J |-> ( F ` ( a + ( d ` i ) ) ) ) ) = M ) ) ) $=
      ( cn wcel cv cfv co vk vf cn0 cvv cop cvdwp wbr caddc cvdwa ccnv csn cima
      vm wss wral cmpt crn chash wceq wa cmap wrex wb wf fex sylancl cfz coprab
      c1 w3a df-br df-vdwpc eleq2i bitri simp1 oveq2d syl6eqr simp2 oveqd simp3
      fveq2d cnveqd fveq1d imaeq12d sseq12d raleqbidv mpteq12dv eqeq12d anbi12d
      sneqd rneqd rexeqbidv rexbidv eloprabga syl5bb syl3anc ) AGPQZFUCQZDUDQZG
      FUEZDUFUGZIRCRJRSZUHTZXBFUISZTZDUJZXCDSZUKZULZUNZCEUOZCEXGUPZUQZURSZGUSZU
      TZJPEVATZVBZIPVBZVCNLAHBDVDHUDQWSMKHBUDDVEVFXAWTDUEZXCXBUARZUISZTZUBRZUJZ
      XCYDSZUKZULZUNZCVIUMRZVGTZUOZCYKYFUPZUQZURSZYJUSZUTZJPYKVATZVBZIPVBZUMUAU
      BVHZQZWQWRWSVJXSXAXTUFQUUBWTDUFVKUFUUAXTUBCUAUMIJVLVMVNYTXSUMUAUBGFDPUCUD
      YJGUSZYAFUSZYDDUSZVJZYSXRIPUUFYQXPJYRXQUUFYKEPVAUUFYKVIGVGTEUUFYJGVIVGUUC
      UUDUUEVOZVPOVQZVPUUFYLXKYPXOUUFYIXJCYKEUUHUUFYCXEYHXIUUFYBXDXCXBUUFYAFUIU
      UCUUDUUEVRWAVSUUFYEXFYGXHUUFYDDUUCUUDUUEVTZWBUUFYFXGUUFXCYDDUUIWCZWJWDWEW
      FUUFYOXNYJGUUFYNXMURUUFYMXLUUFCYKYFEXGUUHUUJWGWKWAUUGWHWIWLWMWNWOWP $.
  $}

  ${
    $d a c d i m A $.  $d d i m D $.  $d i G $.  $d d i I $.  $d a c d i m K $.
    $d a c d i F $.  $d i M $.  $d c i ph $.  $d i R $.  $d i W $.
    vdwlem1.r $e |- ( ph -> R e. Fin ) $.
    vdwlem1.k $e |- ( ph -> K e. NN ) $.
    vdwlem1.w $e |- ( ph -> W e. NN ) $.
    vdwlem1.f $e |- ( ph -> F : ( 1 ... W ) --> R ) $.
    vdwlem1.a $e |- ( ph -> A e. NN ) $.
    vdwlem1.m $e |- ( ph -> M e. NN ) $.
    vdwlem1.d $e |- ( ph -> D : ( 1 ... M ) --> NN ) $.
    vdwlem1.s $e |- ( ph -> A. i e. ( 1 ... M )
      ( ( A + ( D ` i ) ) ( AP ` K ) ( D ` i ) ) C_
      ( `' F " { ( F ` ( A + ( D ` i ) ) ) } ) ) $.
    vdwlem1.i $e |- ( ph -> I e. ( 1 ... M ) ) $.
    vdwlem1.e $e |- ( ph ->
      ( F ` A ) = ( F ` ( A + ( D ` I ) ) ) ) $.
    $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 12-Sep-2014.) $)
    vdwlem1 $p |- ( ph -> ( K + 1 ) MonoAP F ) $=
      ( va vd vc vm c1 caddc co cvdwm wbr cv cvdwa cfv ccnv csn cima wss cn wex
      wrex wcel cfz ffvelrnd cun cn0 wceq nnnn0d vdwapun syl3anc cle nnred nnuz
      cuz syl6eleq eluzfz1 nnaddcld nnrpd ltaddrpd ltled wral r19.21bi cnvimass
      syl wa cdm wf fdm syl5sseq adantr sstrd cmul cmin nnm1nn0 nn0uz ffvelrnda
      cc0 nncnd mul02d oveq2d addid1d eqtr2d oveq1 eqeq2d rspcev syl2anc mpbird
      wb vdwapval sseldd ralrimiva fveq2 rspcv sylc elfzle2 letrd cz nnzd elfz5
      eleq1d eqidd wfn ffn fniniseg 3syl mpbir2and snssd oveq12d fveq2d imaeq2d
      sneqd sseq12d sseqtr4d unssd eqsstrd sseq1d oveq2 rspc2ev sseq2d 2rexbidv
      fvex sneq spcev ovex peano2nn0 vdwmc ) AHUEUFUGZFUHUIUAUJZUBUJZUUEUKULZUG
      ZFUMZUCUJZUNZUOZUPZUBUQUSUAUQUSZUCURZAUUIUUJBFULZUNZUOZUPZUBUQUSUAUQUSZUU
      PABUQUTZGCULZUQUTZBUVCUUHUGZUUSUPZUVAOAUEIVAUGZUQGCQSVBZAUVEBUNZBUVCUFUGZ
      UVCHUKULZUGZVCZUUSAHVDUTZUVBUVDUVEUVMVEAHLVFZOUVHBUVCHVGVHAUVIUVLUUSABUUS
      ABUUSUTZBUEJVAUGZUTZUUQUUQVEZAUVRBJVIUIZABBUECULZUFUGZJABOVJZAUWBABUWAOAU
      VGUQUECQAIUEVLULZUTUEUVGUTZAIUQUWDPVKVMUEIVNWBZVBZVOVJZAJMVJABUWBUWCUWHAB
      UWAUWCAUWAUWGVPVQVRAUWBUVQUTZUWBJVIUIAUWEBEUJZCULZUFUGZUVQUTZEUVGVSUWIUWF
      AUWMEUVGAUWJUVGUTZWCZUWLUWKUVKUGZUVQUWLUWOUWPUUJUWLFULZUNZUOZUVQAUWPUWSUP
      ZEUVGRVTAUWSUVQUPUWNAFWDZUWSUVQFUWRWAAUVQDFWEZUXAUVQVENUVQDFWFWBWGWHWIUWO
      UWLUWPUTZUWLUWLUDUJZUWKWJUGZUFUGZVEZUDWOHUEWKUGZVAUGZUSZUWOWOUXIUTZUWLUWL
      WOUWKWJUGZUFUGZVEZUXJAUXKUWNAUXHWOVLULZUTUXKAUXHVDUXOAHUQUTZUXHVDUTLHWLWB
      WMVMWOUXHVNWBWHUWOUXMUWLWOUFUGUWLUWOUXLWOUWLUFUWOUWKUWOUWKAUVGUQUWJCQWNZW
      PWQWRUWOUWLUWOUWLUWOBUWKAUVBUWNOWHUXQVOZWPWSWTUXGUXNUDWOUXIUXDWOVEZUXFUXM
      UWLUXSUXEUXLUWLUFUXDWOUWKWJXAWRXBXCXDUWOUVNUWLUQUTUWKUQUTUXCUXJXFUWOHAUXP
      UWNLWHVFUXRUXQUWLUWKUDHUWLXGVHXEXHXIUWMUWIEUEUVGUWJUEVEZUWLUWBUVQUXTUWKUW
      ABUFUWJUECXJWRXRXKXLUWBUEJXMWBXNABUWDUTJXOUTUVRUVTXFABUQUWDOVKVMAJMXPBUEJ
      XQXDXEAUUQXSAUXBFUVQXTUVPUVRUVSWCXFNUVQDFYAUVQUUQBFYBYCYDYEAUVLUUJUVJFULZ
      UNZUOZUUSAGUVGUTUWTEUVGVSUVLUYCUPZSRUWTUYDEGUVGUWJGVEZUWPUVLUWSUYCUYEUWLU
      VJUWKUVCUVKUYEUWKUVCBUFUWJGCXJZWRZUYFYFUYEUWRUYBUUJUYEUWQUYAUYEUWLUVJFUYG
      YGYIYHYJXKXLAUURUYBUUJAUUQUYATYIYHYKYLYMUUTUVFBUUGUUHUGZUUSUPUAUBBUVCUQUQ
      UUFBVEUUIUYHUUSUUFBUUGUUHXAYNUUGUVCVEUYHUVEUUSUUGUVCBUUHYOYNYPVHUUOUVAUCU
      UQBFYSUUKUUQVEZUUNUUTUAUBUQUQUYIUUMUUSUUIUYIUULUURUUJUUKUUQYTYHYQYRUUAWBA
      DFUUEUVQUAUCUBUEJVAUUBAUVNUUEVDUTUVOHUUCWBNUUDXE $.
  $}

  ${
    $d a b c d m x F $.  $d a b c d m n x K $.  $d m x M $.  $d a c d m x ph $.
    $d a c d m x G $.  $d b d m x N $.  $d x R $.  $d x W $.
    vdwlem2.r $e |- ( ph -> R e. Fin ) $.
    vdwlem2.k $e |- ( ph -> K e. NN0 ) $.
    vdwlem2.w $e |- ( ph -> W e. NN ) $.
    vdwlem2.n $e |- ( ph -> N e. NN ) $.
    vdwlem2.f $e |- ( ph -> F : ( 1 ... M ) --> R ) $.
    vdwlem2.m $e |- ( ph -> M e. ( ZZ>= ` ( W + N ) ) ) $.
    vdwlem2.g $e |- G = ( x e. ( 1 ... W ) |-> ( F ` ( x + N ) ) ) $.
    $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 12-Sep-2014.) $)
    vdwlem2 $p |- ( ph -> ( K MonoAP G -> K MonoAP F ) ) $=
      ( cfv co cn wcel va vd vc vb vm vn cvdwa ccnv csn cima wss wrex wex cvdwm
      cv wbr wa caddc id nnaddcl syl2anr cmul wceq cc0 c1 cfz simpllr ad3antrrr
      cmin nncnd elfznn0 adantl nn0cnd simplrl mulcld add32d wral simplrr oveq1
      cn0 oveq2d eqeq2d rspcev mpan2 wb ad2antrr adantr vdwapval syl3anc mpbird
      eqid sseldd wfn wf cuz elfznn nnuz syl6eleq cz elfzuz3 nnzd eluzadd uztrn
      syl2anc elfzuzb sylanbrc ffvelrnda syldan fmptd ffn fniniseg mpbid simpld
      syl ralrimiva eleq1d rspcv sylc eqeltrd fveq2d fvmpt simprd 3eqtr2d eleq1
      fvex jca fveq2 eqeq1d anbi12d syl5ibrcom rexlimdva 3imtr4d ssrdv reximdva
      simprl expr sseq1d rexbidv ovex vdwmc ee12an eximdv ) AUAUOZUBUOZFUGQZRZE
      UHUCUOZUIZUJZUKZUBSULZUASULZUCUMUDUOZUUDUUERZDUHUUHUJZUKZUBSULZUDSULZUCUM
      FEUNUPFDUNUPAUULUURUCAUUKUURUASAUUCSTZUQZUUCHURRZSTZUUKUVAUUDUUERZUUOUKZU
      BSULZUURUUSUUSHSTZUVBAUUSUSMUUCHUTVAZUUTUUJUVDUBSUUTUUDSTZUUJUVDUUTUVHUUJ
      UQZUQZBUVCUUOUVJBUOZUVAUEUOZUUDVBRZURRZVCZUEVDFVEVIRZVFRZULZUVKVEGVFRZTZU
      VKDQZUUGVCZUQZUVKUVCTZUVKUUOTZUVJUVOUWCUEUVQUVJUVLUVQTZUQZUWCUVOUVNUVSTZU
      VNDQZUUGVCZUQUWGUWHUWJUWGUVNUUCUVMURRZHURRZUVSUWGUUCHUVMUWGUUCAUUSUVIUWFV
      GZVJUWGHAUVFUUSUVIUWFMVHVJUWGUVLUUDUWGUVLUWFUVLVTTUVJUVLUVPVKVLVMUWGUUDUU
      TUVHUUJUWFVNZVJVOVPZUWGUWKVEIVFRZTZUVKHURRZUVSTZBUWPVQZUWLUVSTZUWGUWQUWKE
      QZUUGVCZUWGUWKUUITZUWQUXCUQZUWGUUFUUIUWKUUTUVHUUJUWFVRUWGUWKUUFTZUWKUUCUF
      UOZUUDVBRZURRZVCZUFUVQULZUWFUXKUVJUWFUWKUWKVCZUXKUWKWKUXJUXLUFUVLUVQUXGUV
      LVCZUXIUWKUWKUXMUXHUVMUUCURUXGUVLUUDVBVSWAWBWCWDVLUWGFVTTZUUSUVHUXFUXKWEU
      VJUXNUWFAUXNUUSUVIKWFZWGUWMUWNUUCUUDUFFUWKWHWIWJWLUWGEUWPWMZUXDUXEWEAUXPU
      USUVIUWFAUWPCEWNUXPABUWPUWRDQZCEAUVKUWPTZUWSUXQCTAUXRUQZUWRVEWOQZTGUWRWOQ
      ZTZUWSUXSUWRSUXTUXRUVKSTUVFUWRSTAUVKIWPMUVKHUTVAWQWRUXSGIHURRZWOQTZUYCUYA
      TZUYBAUYDUXROWGUXRIUVKWOQTHWSTUYEAUVKVEIWTAHMXAHUVKIXBVAUYCGUWRXCXDUWRVEG
      XEXFZAUVSCUWRDNXGXHPXIZUWPCEXJXNVHUWPUUGUWKEXKXNXLZXMZAUWTUUSUVIUWFAUWSBU
      WPUYFXOVHUWSUXABUWKUWPUVKUWKVCZUWRUWLUVSUVKUWKHURVSZXPXQXRXSUWGUWIUWLDQZU
      XBUUGUWGUVNUWLDUWOXTUWGUWQUXBUYLVCUYIBUWKUXQUYLUWPEUYJUWRUWLDUYKXTPUWLDYE
      YAXNUWGUWQUXCUYHYBYCYFUVOUVTUWHUWBUWJUVKUVNUVSYDUVOUWAUWIUUGUVKUVNDYGYHYI
      YJYKUVJUXNUVBUVHUWDUVRWEUXOUUTUVBUVIUVGWGUUTUVHUUJYOUVAUUDUEFUVKWHWIUVJDU
      VSWMZUWEUWCWEAUYMUUSUVIAUVSCDWNUYMNUVSCDXJXNWFUVSUUGUVKDXKXNYLYMYPYNUUQUV
      EUDUVASUUMUVAVCZUUPUVDUBSUYNUUNUVCUUOUUMUVAUUDUUEVSYQYRWCUUAYKUUBACEFUWPU
      AUCUBVEIVFYSKUYGYTACDFUVSUDUCUBVEGVFYSKNYTYL $.
  $}

  ${
    $d k m n x y z A $.  $d a d i j k m x y z G $.  $d a d i j k m n x y z K $.
    $d i j m x J $.  $d d i x P $.  $d a d i j k m x y z ph $.  $d i k x y R $.
    $d i j m n x y z B $.  $d a d i k m x y z H $.  $d a d i j k m x y M $.
    $d j k m n x y z D $.  $d i j m n x y E $.  $d i j k m x y z W $.
    $d a d i x T $.  $d k m x y z V $.
    vdwlem3.v $e |- ( ph -> V e. NN ) $.
    vdwlem3.w $e |- ( ph -> W e. NN ) $.
    ${
      vdwlem3.a $e |- ( ph -> A e. ( 1 ... V ) ) $.
      vdwlem3.b $e |- ( ph -> B e. ( 1 ... W ) ) $.
      $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 13-Sep-2014.) $)
      vdwlem3 $p |- ( ph -> ( B + ( W x. ( ( A - 1 ) + V ) ) ) e.
        ( 1 ... ( W x. ( 2 x. V ) ) ) ) $=
        ( c1 co caddc cmul wcel cle wbr cn syl nnred cr cmin cfz elfznn nnm1nn0
        c2 cn0 nn0nnaddcl syl2anc nnmulcld nnaddcld 2nn nnmulcl sylancr elfzle2
        nnre leadd1 syl3an syl3anc mpbid nncnd ax-1cn a1i adddid nn0cnd addassd
        wb cc wceq pncan3 oveq1d eqtr3d oveq2d mulid1d 3eqtr3d breqtrrd 2timesd
        leadd1dd cc0 clt nngt0d lemul2 syl112anc letrd cuz cfv cz nnuz syl6eleq
        nnzd elfz5 mpbird ) ACEBJUAKZDLKZMKZLKZJEUEDMKZMKZUBKNZWOWQOPZAWOEBDLKZ
        MKZWQAWOACWNACJEUBKNZCQNZICEUCRZAEWMGAWLUFNZDQNZWMQNABQNZXEABJDUBKNZXGH
        BDUCRZBUDRZFWLDUGUHZUIZUJZSAXAAEWTGABDXIFUJZUISAWQAEWPGAUEQNXFWPQNUKFUE
        DULUMZUIZSAWOEWNLKZXAOACEOPZWOXQOPZAXBXRICJEUNRAXCEQNZWNQNZXRXSVFZXDGXL
        XCCTNXTETNZYAWNTNYBCUOEUOWNUOCEWNUPUQURUSAEJWMLKZMKEJMKZWNLKXAXQAEJWMAE
        GUTZJVGNZAVAVBZAWMXKUTVCAYDWTEMAJWLLKZDLKYDWTAJWLDYHAWLXJVDADFUTZVEAYIB
        DLAYGBVGNYIBVHVAABXIUTJBVIUMVJVKVLAYEEWNLAEYFVMVJVNVOAWTWPOPZXAWQOPZAWT
        DDLKWPOABDDABXISADFSZYMAXHBDOPHBJDUNRVQADYJVPVOAWTTNWPTNYCVREVSPYKYLVFA
        WTXNSAWPXOSAEGSAEGVTWTWPEWAWBUSWCAWOJWDWEZNWQWFNWRWSVFAWOQYNXMWGWHAWQXP
        WIWOJWQWJUHWK $.
    $}

    vdwlem4.r $e |- ( ph -> R e. Fin ) $.
    vdwlem4.h $e |- ( ph -> H : ( 1 ... ( W x. ( 2 x. V ) ) ) --> R ) $.
    vdwlem4.f $e |- F = ( x e. ( 1 ... V ) |-> ( y e. ( 1 ... W ) |->
      ( H ` ( y + ( W x. ( ( x - 1 ) + V ) ) ) ) ) ) $.
    $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 12-Sep-2014.) $)
    vdwlem4 $p |- ( ph -> F : ( 1 ... V ) --> ( R ^m ( 1 ... W ) ) ) $=
      ( c1 cfz co cv cmul wcel ad2antrr cmin caddc cmpt cmap wa wf c2 cn simplr
      cfv simpr vdwlem3 ffvelrnd eqid fmptd cfn wb adantr elmapg sylancl mpbird
      cvv ovex ) ABNGOPZCNHOPZCQZHBQZNUAPGUBPRPUBPZFUJZUCZDVEUDPZEAVGVDSZUEZVJV
      KSZVEDVJUFZVMCVEVIDVJVMVFVESZUEZNHUGGRPRPOPZDVHFAVRDFUFVLVPLTVQVGVFGHAGUH
      SVLVPITAHUHSVLVPJTAVLVPUIVMVPUKULUMVJUNUOVMDUPSZVEVBSVNVOUQAVSVLKURNHOVCD
      VEVJUPVBUSUTVAMUO $.

    vdwlem7.m $e |- ( ph -> M e. NN ) $.
    vdwlem7.g $e |- ( ph -> G : ( 1 ... W ) --> R ) $.
    vdwlem7.k $e |- ( ph -> K e. ( ZZ>= ` 2 ) ) $.
    vdwlem7.a $e |- ( ph -> A e. NN ) $.
    vdwlem7.d $e |- ( ph -> D e. NN ) $.
    vdwlem7.s $e |- ( ph -> ( A ( AP ` K ) D ) C_ ( `' F " { G } ) ) $.
    ${
      vdwlem6.b $e |- ( ph -> B e. NN ) $.
      vdwlem6.e $e |- ( ph -> E : ( 1 ... M ) --> NN ) $.
      vdwlem6.s $e |- ( ph -> A. i e. ( 1 ... M )
        ( ( B + ( E ` i ) ) ( AP ` K ) ( E ` i ) ) C_
          ( `' G " { ( G ` ( B + ( E ` i ) ) ) } ) ) $.
      vdwlem6.j $e |- J = ( i e. ( 1 ... M ) |->
        ( G ` ( B + ( E ` i ) ) ) ) $.
      vdwlem6.r $e |- ( ph -> ( # ` ran J ) = M ) $.
      vdwlem6.t $e |- T = ( B + ( W x. ( ( A + ( V - D ) ) - 1 ) ) ) $.
      vdwlem6.p $e |- P = ( j e. ( 1 ... ( M + 1 ) ) |->
        ( if ( j = ( M + 1 ) , 0 , ( E ` j ) ) + ( W x. D ) ) ) $.
      $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 12-Sep-2014.) $)
      vdwlem5 $p |- ( ph -> T e. NN ) $=
        ( cmin co caddc c1 cmul cn wcel cn0 nnnn0d nncnd subcld npcand subsub4d
        addcomd oveq2d eqtrd cuz cfv cfz ccnv csn cima cnvimass cmap wf vdwlem4
        cdm wceq fdm syl syl5sseq cvdwa ssun2 uz2m1nn nnaddcld vdwapid1 syl3anc
        cun c2 sseldi clt wbr eluz2b2 simplbi ax-1cn npcan sylancl fveq2d oveqd
        nnm1nn0 vdwapun eqtr3d eleqtrrd sseldd elfzuz3 uznn0sub eqeltrd syl2anc
        cc nn0nnaddcl eqeltrrd nn0mulcld nnnn0addcl syl5eqel ) AIETDSFUSUTZVAUT
        ZVBUSUTZVCUTZVAUTZVDUQAEVDVEYFVFVEYGVDVEULATYEATUBVGAYDVDVEYEVFVEADYCUI
        AYCDUSUTZDVAUTZYCVDAYCDASFASUAVHZAFUJVHZVIADUIVHZVJAYHVFVEDVDVEZYIVDVEA
        YHSDFVAUTZUSUTZVFAYHSFDVAUTZUSUTYOASFDYJYKYLVKAYPYNSUSAFDYKYLVLVMVNASYN
        VOVPVEZYOVFVEAYNVBSVQUTZVEYQAMVRNVSZVTZYRYNAMWEZYTYRMYSWAAYRHVBTVQUTWBU
        TZMWCUUAYRWFABCHMOSTUAUBUCUDUEWDYRUUBMWGWHWIADFQWJVPZUTZYTYNUKAYNDVSZYN
        FQVBUSUTZWJVPUTZWPZUUDAUUGUUHYNUUGUUEWKAUUFVDVEZYNVDVEFVDVEZYNUUGVEAQWQ
        VOVPVEZUUIUHQWLWHADFUIUJWMUJYNFUUFWNWOWRADFUUFVBVAUTZWJVPZUTZUUDUUHAUUM
        UUCDFAUULQWJAQXQVEVBXQVEUULQWFAQAUUKQVDVEZUHUUKUUOVBQWSWTQXAXBWHZVHXCQV
        BXDXEXFXGAUUFVFVEZYMUUJUUNUUHWFAUUOUUQUUPQXHWHUIUJDFUUFXIWOXJXKXLXLYNVB
        SXMWHYNSXNWHXOUIYHDXRXPXSWMYDXHWHXTEYFYAXPYB $.

      $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 13-Sep-2014.) $)
      vdwlem6 $p |- ( ph ->
        ( <. ( M + 1 ) , K >. PolyAP H \/ ( K + 1 ) MonoAP G ) ) $=
        ( vm va vd vn cfv crn wcel c1 caddc co wbr wo wa wceq cfz wrex wfn fvex
        cv wb cfn adantr cn cuz syl wf ccnv csn cima wss wral weq oveq2d fveq2d
        fveq2 fvmpt eqtr3d imp wn cmpt chash cc0 cn0 a1i biimpa ad2antrr nnnn0d
        cmul syldan syl2anc ovex cmin nncnd nn0cnd adantlr mulcld adddid ax-1cn
        addsubd oveq1d eqtrd eqid oveq1 eqeq2d vdwapval syl3anc sseldd fniniseg
        nnaddcld mpteq2dv fveq1d 3eqtr4rd eqeq1d anbi12d syl5ibrcom cle addassd
        cc oveq12d sneqd imaeq2d cab vz cop cvdwp cvdwm fnmpti fvelrnb ax-mp c2
        eluz2b2 simplbi cvdwa simprl simprr vdwlem1 rexlimdvaa syl5bi olcd cmap
        clt vdwlem5 cif 0nn0 nnuz syl6eleq elfzp1 ord ffvelrnda ifclda nnmulcld
        con1d nn0nnaddcl fmptd elmap sylibr addcld nnm1nn0 elfznn0 adantl add4d
        nn0mulcld add32d mul12d 3eqtr4d rspcev mpan2 biimpar sylan2 vdwlem4 ffn
        nnex simpld r19.21bi vdwlem3 eqeltrd simprd mptex jca rexlimdva 3imtr4d
        eleq1 ssrdv cun ssun1 fzsuc syl5sseqr sselda eqeq1 ifbieq2d nnred ltp1d
        elfzle2 cr peano2re ltnled mpbid breq1 notbid con2d syl5 iffalse add12d
        oveq1i subcld subcl sylancl npcand 3eqtr3d addcomd 3eqtr2d cdm cnvimass
        syl5eq 3eqtrd fdm syl5sseq vdwapid1 3sstr4d eqtr4d eluzfz1 ne0i elfzuz3
        ex c0 wne nnzd uzid uzaddcl uztrn eluzle ralrimiva r19.2z rexlimiv fznn
        cz idd mpbir2and peano2nnd eluzfz2 iftrue addid2d sseq12d jaod ralrimiv
        sylbid rexeqdv rexun rexbidva rexsn syl5bb orbi12d bitrd abbidv uneq12i
        rnmpt df-sn unab eqtri 3eqtr4g wfo fzfi dffn4 mpbi fofi mp2an hashunsng
        cvv wi sylan ralbidv rneqd fveq1 rspc2ev vdwpc mpbird orcd pm2.61dan )
        AENVCZPVDZVEZRVFVGVHZQUUBOUUCVIZQVFVGVHNUUDVIZVJAVWSVKVXBVXAAVWSVXBVWSU
        SVQZPVCZVWQVLZUSVFRVMVHZVNZAVXBPVXFVOZVWSVXGVRJVXFEJVQZLVCZVGVHZNVCZPVX
        KNVPUOUUEZUSVXFVWQPUUFUUGAVXEVXBUSVXFAVXCVXFVEZVXEVKZVKZELHJNVXCQRTAHVS
        VEVXOUCVTAQWAVEZVXOAQUUHWBVCVEZVXQUHVXRVXQVFQUUSVIQUUIUUJWCZVTATWAVEZVX
        OUBVTAVFTVMVHZHNWDZVXOUGVTAEWAVEZVXOULVTARWAVEZVXOUFVTAVXFWALWDZVXOUMVT
        AVXKVXJQUUKVCZVHZNWEVXLWFZWGZWHZJVXFWIVXOUNVTAVXNVXEUULZVXPVXDVWQEVXCLV
        CZVGVHZNVCZAVXNVXEUUMVXPVXNVXDVYNVLVYKJVXCVXLVYNVXFPJUSWJZVXKVYMNVYOVXJ
        VYLEVGVXIVXCLWMWKWLUOVYMNVPWNWCWOUUNUUOUUPWPUUQAVWSWQZVKZVXAVXBVYQVXAUT
        VQZVXIVAVQZVCZVGVHZVYTVYFVHZOWEZWUAOVCZWFZWGZWHZJVFVWTVMVHZWIZJWUHWUDWR
        ZVDZWSVCZVWTVLZVKZVAWAWUHUURVHZVNUTWAVNZVYQIWAVEZGWUOVEZIVXIGVCZVGVHZWU
        SVYFVHZWUCWUTOVCZWFZWGZWHZJWUHWIZJWUHWVBWRZVDZWSVCZVWTVLZVKZWUPAWUQVYPA
        BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUUTZVTVYQWUHWAGW
        DWURVYQKWUHKVQZVWTVLZWTWVMLVCZUVAZTFXFVHZVGVHZWAGVYQWVMWUHVEZVKZWVPXAVE
        WVQWAVEZWVRWAVEWVTWVNWTWVOXAWTXAVEWVTWVNVKUVBXBWVTWVNWQZWVMVXFVEZWVOXAV
        EWVTWWBWWCWVTWWCWVNWVTWWCWVNVYQWVSWWCWVNVJZVYQRVFWBVCZVEZWVSWWDVRAWWFVY
        PARWAWWEUFUVCUVDZVTWVMVFRUVEWCXCUVFUVJWPWVTWWCVKWVOWVTVXFWAWVMLAVYEVYPW
        VSUMXDUVGXEXGUVHAWWAVYPWVSATFUBUJUVIZXDWVPWVQUVKXHURUVLWAWUHGUWJVFVWTVM
        XIUVMUVNVYQWVFWVJAWVFVYPAWVEJWUHAVXIWUHVEZVXIVXFVEZVXIVWTVLZVJZWVEAWWFW
        WIWWLVRWWGVXIVFRUVEWCAWWJWVEWWKAWWJWVEAWWJVKZVXKTDVFXJVHZSVGVHZXFVHZVGV
        HZVXJWVQVGVHZVYFVHZWUCVYHWGZWVAWVDWWMBWWSWWTWWMBVQZWWQVXCWWRXFVHZVGVHZV
        LZUSWTQVFXJVHZVMVHZVNZWXAVFTUUHSXFVHXFVHZVMVHZVEZWXAOVCZVXLVLZVKZWXAWWS
        VEZWXAWWTVEZWWMWXDWXMUSWXFWWMVXCWXFVEZVKZWXMWXDWXCWXIVEZWXCOVCZVXLVLZVK
        WXQWXRWXTWXQWXCVXKVXCVXJXFVHZVGVHZTDVXCFXFVHZVGVHZVFXJVHZSVGVHZXFVHZVGV
        HZWXIWXQWWQWYAVXCWVQXFVHZVGVHZVGVHWYBWWPWYIVGVHZVGVHWXCWYHWXQVXKWWPWYAW
        YIWXQEVXJWWMEYPVEZWXPWWMEAVYCWWJULVTZXKZVTWWMVXJYPVEWXPWWMVXJAVXFWAVXIL
        UMUVGZXKZVTZUVOAWWPYPVEZWWJWXPAWWPATWWOUBAWWNXAVEZSWAVEZWWOWAVEADWAVEZW
        YSUIDUVPWCZUAWWNSUVKXHZUVIZXKZXDWXQVXCVXJAWXPVXCYPVEWWJAWXPVKZVXCWXPVXC
        XAVEAVXCWXEUVQUVRZXLZXMZWYQXNAWXPWYIYPVEWWJXUFWYIXUFVXCWVQXUGAWVQXAVEWX
        PAWVQWWHXEVTUVTXLZXMUVSWXQWXBWYJWWQVGWXQVXCVXJWVQXUIWYQAWVQYPVEZWWJWXPA
        WVQWWHXKZXDXOWKWXQWYGWYKWYBVGAWXPWYGWYKVLWWJXUFTWWOWYCVGVHZXFVHWWPTWYCX
        FVHZVGVHWYGWYKXUFTWWOWYCATYPVEWXPATUBXKZVTZAWWOYPVEWXPAWWOXUCXKVTXUFVXC
        FXUHAFYPVEWXPAFUJXKZVTZXNZXOXUFWYFXUMTXFXUFWYFWWNWYCVGVHZSVGVHXUMXUFWYE
        XUTSVGXUFDWYCVFADYPVEWXPADUIXKZVTXUSVFYPVEZXUFXPXBXQXRXUFWWNWYCSAWWNYPV
        EWXPAWWNXUBXLVTXUSASYPVEWXPASUAXKZVTUWAXSWKXUFWYIXUNWWPVGXUFVXCTFXUHXUP
        XURUWBWKUWCZXMWKUWCZWXQWYDWYBSTAWYTWWJWXPUAXDAVXTWWJWXPUBXDAWXPWYDVFSVM
        VHZVEZWWJXUFXVGWYDMVCZNVLZAWXPWYDMWENWFWGZVEZXVGXVIVKZXUFDFVYFVHZXVJWYD
        AXVMXVJWHWXPUKVTWXPAWYDDVBVQZFXFVHZVGVHZVLZVBWXFVNZWYDXVMVEZWXPWYDWYDVL
        ZXVRWYDXTXVQXVTVBVXCWXFVBUSWJZXVPWYDWYDXWAXVOWYCDVGXVNVXCFXFYAWKYBUWDUW
        EAXVSXVRAQXAVEZXUAFWAVEZXVSXVRVRAQVXSXEZUIUJDFVBQWYDYCYDUWFUWGYEAXVKXVL
        AMXVFVOZXVKXVLVRAXVFHVYAUURVHZMWDXWEABCHMOSTUAUBUCUDUEUWHXVFXWFMUWIWCZX
        VFNWYDMYFWCXCXGZUWKZXMWXQWYBVYAVEZWYBNVCZVXLVLZWWMWXPWYBVYIVEZXWJXWLVKZ
        WXQVYGVYIWYBWWMVYJWXPAVYJJVXFUNUWLZVTWXPWWMWYBVXKXVNVXJXFVHZVGVHZVLZVBW
        XFVNZWYBVYGVEZWXPWYBWYBVLZXWSWYBXTXWRXXAVBVXCWXFXWAXWQWYBWYBXWAXWPWYAVX
        KVGXVNVXCVXJXFYAWKYBUWDUWEWWMXWTXWSWWMXWBVXKWAVEZVXJWAVEZXWTXWSVRWWMQAV
        XQWWJVXSVTZXEZWWMEVXJWYMWYOYGZWYOVXKVXJVBQWYBYCYDUWFUWGYEWWMXWMXWNWWMNV
        YAVOZXWMXWNVRAXXGWWJAVYBXXGUGVYAHNUWIWCVTVYAVXLWYBNYFWCXCXGZUWKZUWMUWNW
        XQWYBCVYACVQZWYGVGVHZOVCZWRZVCZWYHOVCZVXLWXSWXQXWJXXNXXOVLXXICWYBXXLXXO
        VYAXXMXXJWYBVLXXKWYHOXXJWYBWYGVGYAWLXXMXTZWYHOVPWNWCWXQXWKVXLXXNWXQXWJX
        WLXXHUWOWXQWYBNXXMAWXPNXXMVLWWJXUFXVHNXXMXUFXVGXVIXWHUWOXUFXVGXVHXXMVLX
        WIBWYDCVYAXXJTWXAVFXJVHZSVGVHZXFVHZVGVHZOVCZWRZXXMXVFMWXAWYDVLZCVYAXYAX
        XLXYCXXTXXKOXYCXXSWYGXXJVGXYCXXRWYFTXFXYCXXQWYESVGWXAWYDVFXJYAXRWKWKWLY
        HUECVYAXXLVFTVMXIZUWPWNWCWOZXMYIWOWXQWXCWYHOXVEWLYJUWQWXDWXJWXRWXLWXTWX
        AWXCWXIUWTWXDWXKWXSVXLWXAWXCOWMYKYLYMUWRWWMXWBWWQWAVEWWRWAVEWXNWXGVRXXE
        WWMVXKWWPXXFAWWPWAVEWWJXUDVTYGWWMVXJWVQWYOAWWAWWJWWHVTYGWWQWWRUSQWXAYCY
        DWWMOWXIVOZWXOWXMVRAXYFWWJAWXIHOWDZXYFUDWXIHOUWIWCZVTWXIVXLWXAOYFWCUWSU
        XAWWMWUTWWQWUSWWRVYFWWMWUTIWWRVGVHVXJIWVQVGVHZVGVHZWWQWWMWUSWWRIVGWWMWU
        SWWKWTVXJUVAZWVQVGVHZWWRWWMWWIWUSXYLVLAVXFWUHVXIAVXFVWTWFZUXBZVXFWUHVXF
        XYMUXCAWWFWUHXYNVLWWGVFRUXDWCZUXEUXFKVXIWVRXYLWUHGKJWJZWVPXYKWVQVGXYPWV
        NWWKWVOVXJWTWVMVXIVWTUXGWVMVXILWMUXHXRURXYKWVQVGXIWNWCWWMWWKWQZXYLWWRVL
        AWWJXYQWWJVXIRYNVIZAXYQVXIVFRUXKAWWKXYRAXYRWQWWKVWTRYNVIZWQZARVWTUUSVIX
        YTARARUFUXIZUXJARVWTYUAARUXLVEVWTUXLVEYUARUXMWCUXNUXOWWKXYRXYSVXIVWTRYN
        UXPUXQYMUXRUXSWPXYQXYKVXJWVQVGWWKWTVXJUXTXRWCXSZWKWWMIVXJWVQAIYPVEWWJAI
        WVLXKVTWYPAXUKWWJXULVTUYAWWMXYJVXJEWWPVGVHZVGVHZVXJEVGVHZWWPVGVHWWQAXYJ
        YUDVLWWJAXYIYUCVXJVGAXYIETDSFXJVHZVGVHZVFXJVHZXFVHZVGVHZWVQVGVHZYUCIYUJ
        WVQVGUQUYBAYUKEYUIWVQVGVHZVGVHYUCAEYUIWVQAEULXKZATYUHXUOAYUGYPVEXVBYUHY
        PVEADYUFXVAASFXVCXUQUYCZUVOZXPYUGVFUYDUYEZXNXULYOAYULWWPEVGATYUHFVGVHZX
        FVHYULWWPATYUHFXUOYUPXUQXOAYUQWWOTXFAYUGFVGVHZVFXJVHDSVGVHZVFXJVHYUQWWO
        AYURYUSVFXJAYURDYUFFVGVHZVGVHYUSADYUFFXVAYUNXUQYOAYUTSDVGASFXVCXUQUYFWK
        XSXRAYUGFVFYUOXUQXVBAXPXBZXQADSVFXVAXVCYVAXQUYGWKWOWKXSUYLZWKVTWWMVXJEW
        WPWYPWYNAWYRWWJXUEVTYOWWMYUEVXKWWPVGWWMVXJEWYPWYNUYHXRUYIUYMZYUBYQWWMWV
        CVYHWUCWWMWVBVXLWWMVXKCVYAXXJWWPVGVHZOVCZWRZVCZWWQOVCZVXLWVBWWMVXKVYAVE
        ZYVGYVHVLWWMVYIVYAVXKAVYIVYAWHWWJANUYJZVYIVYANVYHUYKAVYBYVJVYAVLUGVYAHN
        UYNWCUYOVTWWMVYGVYIVXKXWOWWMVXQXXBXXCVXKVYGVEXXDXXFWYOVXKVXJQUYPYDYEYEZ
        CVXKYVEYVHVYAYVFXXJVXKVLYVDWWQOXXJVXKWWPVGYAWLYVFXTZWWQOVPWNWCAVXLYVGVL
        WWJAVXKNYVFADMVCZNYVFADXVFVEZYVMNVLZADXVJVEZYVNYVOVKZAXVMXVJDUKAVXQXUAX
        WCDXVMVEVXSUIUJDFQUYPYDYEAXWEYVPYVQVRXWGXVFNDMYFWCUXOZUWOAYVNYVMYVFVLAY
        VNYVOYVRUWKBDXYBYVFXVFMWXADVLZCVYAXYAYVEYVSXXTYVDOYVSXXSWWPXXJVGYVSXXRW
        WOTXFYVSXXQWWNSVGWXADVFXJYAXRWKWKWLYHUECVYAYVEXYDUWPWNWCWOZYIVTWWMWUTWW
        QOYVCWLYJZYRYSUYQVUBAWVEWWKIVWTGVCZVGVHZYWBVYFVHZWUCYWCOVCZWFZWGZWHAYUC
        WVQVYFVHZWUCVWQWFZWGZYWDYWGAUUAYWHYWJAUUAVQZYUCWYIVGVHZVLZUSWXFVNZYWKWX
        IVEZYWKOVCZVWQVLZVKZYWKYWHVEZYWKYWJVEZAYWMYWRUSWXFXUFYWRYWMYWLWXIVEZYWL
        OVCZVWQVLZVKXUFYXAYXCXUFYWLEWYGVGVHZWXIXUFYWLEWYKVGVHYXDXUFEWWPWYIAWYLW
        XPYUMVTAWYRWXPXUEVTXUJYOXUFWYGWYKEVGXVDWKUYRZXUFWYDESTAWYTWXPUAVTAVXTWX
        PUBVTXWIAEVYAVEZWXPAYXFVYCETYNVIZULAYXGJVXFVNZYXGAVXFVUCVUDZYXGJVXFWIYX
        HAVFVXFVEZYXIAWWFYXJWWGVFRUYSWCVXFVFUYTWCAYXGJVXFWWMTEWBVCZVEZYXGWWMTVX
        KWBVCVEZVXKYXKVEZYXLWWMYVIYXMYVKVXKVFTVUAWCWWMEYXKVEZVXJXAVEYXNAYXOWWJA
        EVUNVEYXOAEULVUEEVUFWCVTWWMVXJWYOXEVXJEEVUGXHVXKTEVUHXHETVUIWCVUJYXGJVX
        FVUKXHYXGYXGJVXFWWJYXGVUOVULWCATVUNVEYXFVYCYXGVKVRATUBVUEETVUMWCVUPZVTZ
        UWMUWNXUFEXXMVCZYXDOVCZVWQYXBXUFYXFYXRYXSVLYXQCEXXLYXSVYAXXMXXJEVLZXXKY
        XDOXXJEWYGVGYAWLXXPYXDOVPWNWCXUFENXXMXYEYIXUFYWLYXDOYXEWLYJUWQYWMYWOYXA
        YWQYXCYWKYWLWXIUWTYWMYWPYXBVWQYWKYWLOWMYKYLYMUWRAXWBYUCWAVEWWAYWSYWNVRX
        WDAEWWPULXUDYGWWHYUCWVQUSQYWKYCYDAXYFYWTYWRVRXYHWXIVWQYWKOYFWCUWSUXAAYW
        CYUCYWBWVQVYFAYWCXYIYUCAYWBWVQIVGAYWBWTWVQVGVHZWVQAVWTWUHVEZYWBYYAVLAVW
        TWWEVEYYBAVWTWAWWEARUFVUQUVCUVDVFVWTVURWCKVWTWVRYYAWUHGWVNWVPWTWVQVGWVN
        WTWVOVUSXRURWTWVQVGXIWNWCAWVQXULVUTXSZWKYVBXSZYYCYQAYWFYWIWUCAYWEVWQAEY
        VFVCZYUCOVCZVWQYWEAYXFYYEYYFVLYXPCEYVEYYFVYAYVFYXTYVDYUCOXXJEWWPVGYAWLY
        VLYUCOVPWNWCAENYVFYVTYIAYWCYUCOYYDWLYJZYRYSUYQWWKWVAYWDWVDYWGWWKWUTYWCW
        USYWBVYFWWKWUSYWBIVGVXIVWTGWMZWKZYYHYQWWKWVCYWFWUCWWKWVBYWEWWKWUTYWCOYY
        IWLZYRYSVVAYMVVBVVDVVCVTVYQWVIVWRYWIUXBZWSVCZVWRWSVCZVFVGVHZVWTVYQWVHYY
        KWSVYQWXAWVBVLZJWUHVNZBYTWXAVXLVLZJVXFVNZWXAVWQVLZVJZBYTZWVHYYKVYQYYPYY
        TBAYYPYYTVRVYPAYYPYYOJXYNVNZYYTAYYOJWUHXYNXYOVVEUUUBYYOJVXFVNZYYOJXYMVN
        ZVJAYYTYYOJVXFXYMVVFAUUUCYYRUUUDYYSAYYOYYQJVXFWWMWVBVXLWXAYWAYBVVGUUUDW
        XAYWEVLZAYYSYYOUUUEJVWTRVFVGXIWWKWVBYWEWXAYYJYBVVHAYWEVWQWXAYYGYBVVIVVJ
        VVIVVKVTVVLJBWUHWVBWVGWVGXTVVNYYKYYRBYTZYYSBYTZUXBUUUAVWRUUUFYWIUUUGJBV
        XFVXLPUOVVNBVWQVVOVVMYYRYYSBVVPVVQVVRWLAVWRVSVEZVYPYYLYYNVLZUUUHAVXFVSV
        EVXFVWRPVVSZUUUHVFRVVTVXHUUUJVXMVXFPVWAVWBVXFVWRPVWCVWDXBVWQVWFVEUUUHVY
        PVKUUUIVWGENVPVWRVWQVWFVWEUUGVWHVYQYYMRVFVGAYYMRVLVYPUPVTXRUYMUWQWUNWVK
        IVYTVGVHZVYTVYFVHZWUCUUUKOVCZWFZWGZWHZJWUHWIZJWUHUUUMWRZVDZWSVCZVWTVLZV
        KUTVAIGWAWUOVYRIVLZWUIUUUQWUMUUVAUUVBWUGUUUPJWUHUUVBWUBUUULWUFUUUOUUVBW
        UAUUUKVYTVYFVYRIVYTVGYAZXRUUVBWUEUUUNWUCUUVBWUDUUUMUUVBWUAUUUKOUUVCWLZY
        RYSVVAVWIUUVBWULUUUTVWTUUVBWUKUUUSWSUUVBWUJUUURUUVBJWUHWUDUUUMUUVDYHVWJ
        WLYKYLVYSGVLZUUUQWVFUUVAWVJUUVEUUUPWVEJWUHUUVEUUULWVAUUUOWVDUUVEUUUKWUT
        VYTWUSVYFUUVEVYTWUSIVGVXIVYSGVWKZWKZUUVFYQUUVEUUUNWVCWUCUUVEUUUMWVBUUVE
        UUUKWUTOUUVGWLZYRYSVVAVWIUUVEUUUTWVIVWTUUVEUUUSWVHWSUUVEUUURWVGUUVEJWUH
        UUUMWVBUUVHYHVWJWLYKYLVWLYDVYQHJOWUHQVWTWXIUTVAVFWXHVMXIVYQQAVXQVYPVXSV
        TXEAXYGVYPUDVTVYQRAVYDVYPUFVTVUQWUHXTVWMVWNVWOVWP $.
    $}

    $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 12-Sep-2014.) $)
    vdwlem7 $p |- ( ph -> ( <. M , K >. PolyAP G ->
      ( <. ( M + 1 ) , K >. PolyAP H \/ ( K + 1 ) MonoAP G ) ) ) $=
      ( va vi vd vj vk cop cvdwp wbr cv cfv caddc co cvdwa ccnv csn cima wss c1
      cfz wral cmpt crn chash wceq wa cn cmap wrex cvdwm ovex cn0 wcel cuz 2nn0
      wo c2 eluznn0 sylancr eqid cc0 cif cmul cmin ad2antrr cfn simplrl simplrr
      vdwpc nnex elmap sylib simprl fveq2 oveq2d oveq12d fveq2d imaeq2d sseq12d
      wf sneqd cbvralv cbvmptv simprr vdwlem6 ex rexlimdvva sylbid ) AKJUJHUKUL
      UEUMZUFUMZUGUMZUNZUOUPZXOJUQUNZUPZHURZXPHUNZUSZUTZVAZUFVBKVCUPZVDZUFYDXTV
      EZVFVGUNKVHZVIZUGVJYDVKUPZVLUEVJVLKVBUOUPZJUJIUKULJVBUOUPHVMULVSZAFUFHYDJ
      KVBMVCUPZUEUGVBMVCVNAVTVOVPJVTVQUNVPZJVOVPVRUAJVTWAWBTSYDWCWLAYHYKUEUGVJY
      IAXLVJVPZXNYIVPZVIZVIZYHYKYQYHVIZBCDXLEUHVBYJVCUPUHUMZYJVHWDYSXNUNWEMEWFU
      PUOUPVEZFXLMDLEWGUPUOUPVBWGUPWFUPUOUPZUIUHXNGHIYFJKLMALVJVPYPYHNWHAMVJVPY
      PYHOWHAFWIVPYPYHPWHAVBMVTLWFUPWFUPVCUPFIXCYPYHQWHRAKVJVPYPYHSWHAYLFHXCYPY
      HTWHAYMYPYHUAWHADVJVPYPYHUBWHAEVJVPYPYHUCWHADEXQUPGURHUSUTVAYPYHUDWHAYNYO
      YHWJYRYOYDVJXNXCAYNYOYHWKVJYDXNWMVBKVCVNWNWOYRYEXLUIUMZXNUNZUOUPZUUCXQUPZ
      XSUUDHUNZUSZUTZVAZUIYDVDYQYEYGWPYCUUIUFUIYDXMUUBVHZXRUUEYBUUHUUJXPUUDXOUU
      CXQUUJXOUUCXLUOXMUUBXNWQZWRZUUKWSUUJYAUUGXSUUJXTUUFUUJXPUUDHUULWTZXDXAXBX
      EWOUFUIYDXTUUFUUMXFYQYEYGXGUUAWCYTWCXHXIXJXK $.
  $}

  ${
    $d a d i m n x A $.  $d a d i m n x D $.  $d a d i m x F $.  $d i m x ph $.
    $d i m x C $.  $d a d i m n x K $.  $d a d i m x W $.
    vdwlem8.r $e |- ( ph -> R e. Fin ) $.
    vdwlem8.k $e |- ( ph -> K e. ( ZZ>= ` 2 ) ) $.
    vdwlem8.w $e |- ( ph -> W e. NN ) $.
    vdwlem8.f $e |- ( ph -> F : ( 1 ... ( 2 x. W ) ) --> R ) $.
    vdwlem8.c $e |- C e. _V $.
    vdwlem8.a $e |- ( ph -> A e. NN ) $.
    vdwlem8.d $e |- ( ph -> D e. NN ) $.
    vdwlem8.s $e |- ( ph -> ( A ( AP ` K ) D ) C_ ( `' G " { C } ) ) $.
    vdwlem8.g $e |- G = ( x e. ( 1 ... W ) |-> ( F ` ( x + W ) ) ) $.
    $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 18-Aug-2014.) $)
    vdwlem8 $p |- ( ph -> <. 1 , K >. PolyAP F ) $=
      ( wcel va vi vd vm vn c1 cop cvdwp wbr cv cfv caddc co cvdwa ccnv csn wss
      cima cfz wral cmpt chash wceq wa cn cmap wrex cmin nncnd addcomd subsub4d
      crn oveq2d eqtr4d subcld ppncand eqtrd cn0 nnaddcld cuz cdm cnvimass fvex
      dmmpti sseqtri syl6ss cun ssun2 c2 uz2m1nn syl vdwapid1 syl3anc sseldi cc
      clt eluz2b2 simplbi ax-1cn npcan sylancl fveq2d oveqd nnnn0d elfzuz3 3syl
      sseldd nnnn0addcl syl2anc wf 1nn sylancr cz ax-mp sylibr ovex cmul adantr
      1z eqid oveq1 wb vdwapval wfn fniniseg sylib simpld simprd 3eqtr2d eqeq1d
      fvmpt anbi12d oveq12d sneqd imaeq2d mpteq2dv rneqd syl6eq cvv sseq12d fss
      vdwapun eqtr3d eleqtrrd uznn0sub eqeltrrd wf1o f1of snssd fzsn feq2i nnex
      f1osng elmap elfznn0 nn0mulcl syl2anr nnuz syl6eleq eqeq2d rspcev biimpar
      mpan2 sylan2 fnmpti eluzelz eluzadd 2timesd nn0cnd add32d 3eltr4d elfzuzb
      cc0 mpdan sylanbrc jca eleq1 fveq2 syl5ibrcom rexlimdva ffn 3imtr4d ssrdv
      fvsng addassd npcand 3eqtrd 3sstr4d ralrimivw cxp fconstmpt syl6eqr elfz3
      wne ne0i mp2b rnxp hashsng oveq1d ralbidv fveq1 elfz1eq sylan9eq ralbidva
      c0 mpteq2dva rspc2ev syl112anc a1i vdwpc mpbird ) AUFIUGGUHUIUAUJZUBUJZUC
      UJZUKZULUMZUXOIUNUKZUMZGUOZUXPGUKZUPZURZUQZUBUFUFUSUMZUTZUBUYDUXTVAZVLZVB
      UKZUFVCZVDZUCVEUYDVFUMZVGUAVEVGZACJEVHUMZULUMZVETUFEUGUPZUYKTZUYNUFUYOUKZ
      ULUMZUYQUXQUMZUXSUYRGUKZUPZURZUQZUBUYDUTZUBUYDUYTVAZVLZVBUKZUFVCZUYLACCUL
      UMZJCEULUMZVHUMZULUMZUYNVEAVULVUIUYMCVHUMZULUMUYNAVUKVUMVUIULAVUKJECULUMZ
      VHUMVUMAVUJVUNJVHACEACPVIZAEQVIZVJVMAJECAJMVIZVUPVUOVKVNVMACCUYMVUOVUOAJE
      VUQVUPVOZVPVQAVUIVETVUKVRTZVULVETACCPPVSAVUJUFJUSUMZTJVUJVTUKTVUSACEUXQUM
      ZVUTVUJAVVAHUODUPZURZVUTRVVCHWAVUTHVVBWBBVUTBUJZJULUMZGUKZHVVEGWCZSWDWEWF
      AVUJCUPZVUJEIUFVHUMZUNUKUMZWGZVVAAVVJVVKVUJVVJVVHWHAVVIVETZVUJVETEVETZVUJ
      VVJTAIWIVTUKTZVVLLIWJWKZACEPQVSQVUJEVVIWLWMWNACEVVIUFULUMZUNUKZUMZVVAVVKA
      VVQUXQCEAVVPIUNAIWOTUFWOTVVPIVCAIAVVNIVETZLVVNVVSUFIWPUIIWQWRWKZVIWSIUFWT
      XAXBXCAVVIVRTCVETZVVMVVRVVKVCAVVIVVOXDPQCEVVIUUBWMUUCUUDXGVUJUFJXEVUJJUUE
      XFVUIVUKXHXIUUFAUYDVEUYOXJZUYPAUFUPZVEUYOXJZVWBAVWCEUPZUYOXJZVWEVEUQVWDAV
      WCVWEUYOUUGZVWFAUFVETZVVMVWGXKQUFEVEVEUUMXLVWCVWEUYOUUHWKAEVEQUUIVWCVWEVE
      UYOUUAXIUYDVWCVEUYOUFXMTZUYDVWCVCXSUFUUJXNUUKXOVEUYDUYOUULUFUFUSXPUUNXOAV
      UCUBUYDACJULUMZEUXQUMZUXSVVBURZUYSVUBABVWKVWLAVVDVWJUDUJZEXQUMZULUMZVCZUD
      UVMVVIUSUMZVGZVVDUFWIJXQUMZUSUMZTZVVDGUKZDVCZVDZVVDVWKTZVVDVWLTZAVWPVXDUD
      VWQAVWMVWQTZVDZVXDVWPVWOVWTTZVWOGUKZDVCZVDVXHVXIVXKVXHVWOUFVTUKZTVWSVWOVT
      UKZTVXIVXHVWOVEVXLVXHVWJVETZVWNVRTZVWOVETAVXNVXGACJPMVSZXRVXGVWMVRTEVRTVX
      OAVWMVVIUUOAEQXDVWMEUUPUUQZVWJVWNXHXIUURUUSVXHJJULUMZCVWNULUMZJULUMZVTUKZ
      VWSVXMVXHVXSVUTTZJVXSVTUKTZVXRVYATZVXHVYBVXSHUKZDVCZVXHVXSVVCTZVYBVYFVDZV
      XHVVAVVCVXSAVVAVVCUQVXGRXRVXGAVXSCUEUJZEXQUMZULUMZVCZUEVWQVGZVXSVVATZVXGV
      XSVXSVCZVYMVXSXTVYLVYOUEVWMVWQVYIVWMVCZVYKVXSVXSVYPVYJVWNCULVYIVWMEXQYAVM
      UUTUVAUVCAVYNVYMAIVRTZVWAVVMVYNVYMYBAIVVTXDZPQCEUEIVXSYCWMUVBUVDXGHVUTYDZ
      VYGVYHYBBVUTVVFHVVGSUVEZVUTDVXSHYEXNYFZYGZVXSUFJXEVYCJXMTVYDVXSJUVFJVXSJU
      VGUVNXFAVWSVXRVCVXGAJVUQUVHXRVXHVWOVXTVTVXHCJVWNACWOTVXGVUOXRAJWOTVXGVUQX
      RVXHVWNVXQUVIUVJZXBUVKVWOUFVWSUVLUVOVXHVXJVXTGUKZVYEDVXHVWOVXTGWUCXBVXHVY
      BVYEWUDVCWUBBVXSVVFWUDVUTHVVDVXSVCVVEVXTGVVDVXSJULYAXBSVXTGWCYKWKVXHVYBVY
      FWUAYHYIUVPVWPVXAVXIVXCVXKVVDVWOVWTUVQVWPVXBVXJDVVDVWOGUVRYJYLUVSUVTAVYQV
      XNVVMVXEVWRYBVYRVXPQVWJEUDIVVDYCWMAVWTFGXJGVWTYDVXFVXDYBNVWTFGUWAVWTDVVDG
      YEXFUWBUWCAUYRVWJUYQEUXQAUYRUYNEULUMCUYMEULUMZULUMVWJAUYQEUYNULAVWHVVMUYQ
      EVCXKQUFEVEVEUWDXLZVMACUYMEVUOVURVUPUWEAWUEJCULAJEVUQVUPUWFVMUWGZWUFYMAVU
      AVVBUXSAUYTDAUYTVWJGUKZCHUKZDAUYRVWJGWUGXBACVUTTZWUIWUHVCAWUJWUIDVCZACVVC
      TZWUJWUKVDZAVVAVVCCRAVVSVWAVVMCVVATVVTPQCEIWLWMXGVYSWULWUMYBVYTVUTDCHYEXN
      YFZYGBCVVFWUHVUTHVVDCVCVVEVWJGVVDCJULYAXBSVWJGWCYKWKAWUJWUKWUNYHYIZYNYOUW
      HUWIAVUGVVBVBUKZUFAVUFVVBVBAVUFUYDVVBUWJZVLZVVBAVUEWUQAVUEUBUYDDVAWUQAUBU
      YDUYTDWUOYPUBUYDDUWKUWLYQUYDUXEUWNZWURVVBVCVWIUFUYDTWUSXSUFUWMUYDUFUWOUWP
      UYDVVBUWQXNYRXBDYSTWUPUFVCODYSUWRXNYRUYJVUDVUHVDUYNUXOULUMZUXOUXQUMZUXSWU
      TGUKZUPZURZUQZUBUYDUTZUBUYDWVBVAZVLZVBUKZUFVCZVDUAUCUYNUYOVEUYKUXLUYNVCZU
      YEWVFUYIWVJWVKUYCWVEUBUYDWVKUXRWVAUYBWVDWVKUXPWUTUXOUXQUXLUYNUXOULYAZUWSW
      VKUYAWVCUXSWVKUXTWVBWVKUXPWUTGWVLXBZYNYOYTUWTWVKUYHWVIUFWVKUYGWVHVBWVKUYF
      WVGWVKUBUYDUXTWVBWVMYPYQXBYJYLUXNUYOVCZWVFVUDWVJVUHWVNWVEVUCUBUYDWVNUXMUY
      DTZVDZWVAUYSWVDVUBWVPWUTUYRUXOUYQUXQWVPUXOUYQUYNULWVNWVOUXOUXMUYOUKUYQUXM
      UXNUYOUXAWVOUXMUFUYOUXMUFUXBXBUXCZVMZWVQYMWVPWVCVUAUXSWVPWVBUYTWVPWUTUYRG
      WVRXBZYNYOYTUXDWVNWVIVUGUFWVNWVHVUFVBWVNWVGVUEWVNUBUYDWVBUYTWVSUXFYQXBYJY
      LUXGUXHAFUBGUYDIUFVWTUAUCUFVWSUSXPVYRNVWHAXKUXIUYDXTUXJUXK $.
  $}

  ${
    $d a c d g h i k m n u v w x y z ph $.  $d f x y z V $.  $d f x y z W $.
    $d a c d f g w x y z F $.  $d a c d f g h i k m n r s u v w x y z K $.
    $d a d f g n x y M $.  $d a c d f g h i k m n r s u v w x y z R $.
    $d a d g x y z H $.
    vdw.r $e |- ( ph -> R e. Fin ) $.
    ${
      vdwlem9.k $e |- ( ph -> K e. ( ZZ>= ` 2 ) ) $.
      vdwlem9.s $e |- ( ph -> A. s e. Fin E. n e. NN
        A. f e. ( s ^m ( 1 ... n ) ) K MonoAP f ) $.
      ${
        vdwlem9.m $e |- ( ph -> M e. NN ) $.
        vdwlem9.w $e |- ( ph -> W e. NN ) $.
        vdwlem9.g $e |- ( ph -> A. g e. ( R ^m ( 1 ... W ) )
          ( <. M , K >. PolyAP g \/ ( K + 1 ) MonoAP g ) ) $.
        vdwlem9.v $e |- ( ph -> V e. NN ) $.
        vdwlem9.a $e |- ( ph -> A. f e. ( ( R ^m ( 1 ... W ) ) ^m ( 1 ... V ) )
          K MonoAP f ) $.
        vdwlem9.h $e |- ( ph -> H : ( 1 ... ( W x. ( 2 x. V ) ) ) --> R ) $.
        vdwlem9.f $e |- F = ( x e. ( 1 ... V ) |-> ( y e. ( 1 ... W ) |->
          ( H ` ( y + ( W x. ( ( x - 1 ) + V ) ) ) ) ) ) $.
        $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 12-Sep-2014.) $)
        vdwlem9 $p |- ( ph ->
          ( <. ( M + 1 ) , K >. PolyAP H \/ ( K + 1 ) MonoAP H ) ) $=
          ( va vd vz cvdwm wbr c1 caddc co cop cvdwp cfz cmap wcel wral vdwlem4
          wo cv wf ovex elmap sylibr breq2 rspcv sylc cvdwa cfv ccnv csn wss cn
          cima wrex wex c2 cuz clt eluz2b2 simplbi syl nnnn0d vdwmc adantr wceq
          wa simprr simprll simprlr vdwapid1 syl3anc sseldd wfn wb ffn fniniseg
          mpbid simprd simpld ffvelrnd eqeltrrd rsp cfn cmul cvv elmapg sylancl
          vdwlem7 wi olc a1i jaod cmin cmpt oveq1 oveq1d oveq2d fveq2d mpteq2dv
          weq mptex fvmpt eqtr3d breq2d cn0 peano2nn0 nnm1nn0 nnmulcld cle nnzd
          cz sylancr nnred nncnd cr cc ax-1cn mpd syl2anc nnaddcld 2nn leadd1dd
          nn0nnaddcl nnmulcl elfzle2 breqtrrd cc0 nngt0d lemul2 syl112anc eluz2
          2timesd syl3anbrc nn0cnd addcld adddid addassd pncan3 mulid1d 3eqtr3d
          eleqtrd cbvmptv vdwlem2 sylbird orim2d syld rexlimdvva exlimdv sylbid
          expr ) AJHUHUIZKUJUKULJUMIUNUIZJUJUKULZIUHUIZUTZAHDUJMUOULZUPULZUJLUO
          ULZUPULZUQZJEVAZUHUIZEUWAURUVMAUVTUVSHVBZUWBABCDHILMUASOUCUDUSZUVSUVT
          HDUVRUPVCUJLUOVCZVDVEUBUWDUVMEHUWAUWCHJUHVFVGVHAUVMUEVAZUFVAZJVIVJULZ
          HVKFVAZVLVOZVMZUFVNVPUEVNVPZFVQUVQAUVSHJUVTUEFUFUWGAJAJVRVSVJUQZJVNUQ
          ZPUWOUWPUJJVTUIJWAWBWCZWDZUWFWEAUWNUVQFAUWMUVQUEUFVNVNAUWHVNUQZUWIVNU
          QZWHZUWMUVQAUXAUWMWHZWHZKJUMUWKUNUIZUVOUWKUHUIZUTZUVQUXCUXFFUVSURZUWK
          UVSUQZUXFAUXGUXBTWFUXCUWHHVJZUWKUVSUXCUWHUVTUQZUXIUWKWGZUXCUWHUWLUQZU
          XJUXKWHZUXCUWJUWLUWHAUXAUWMWIZUXCUWPUWSUWTUWHUWJUQAUWPUXBUWQWFAUWSUWT
          UWMWJZAUWSUWTUWMWKZUWHUWIJWLWMWNUXCHUVTWOZUXLUXMWPAUXQUXBAUWEUXQUWFUV
          TUVSHWQWCWFUVTUWKUWHHWRWCWSZWTZUXCUVTUVSUWHHAUWEUXBUWFWFUXCUXJUXKUXRX
          AZXBXCZUXFFUVSXDVHUXCUXFUVNUXEUTZUVQUXCUXDUYBUXEUXCBCUWHUWIDHUWKIJKLM
          ALVNUQZUXBUAWFZAMVNUQUXBSWFZADXEUQZUXBOWFZAUJMVRLXFULZXFULZUOULDIVBUX
          BUCWFZUDAKVNUQUXBRWFUXCUXHUVRDUWKVBZUYAUXCUYFUVRXGUQUXHUYKWPUYGUJMUOV
          CZDUVRUWKXEXGXHXIWSAUWOUXBPWFUXOUXPUXNXJUXEUYBXKUXCUXEUVNXLXMXNUXCUXE
          UVPUVNUXCUXEUVOCUVRCVAZMUWHUJXOULZLUKULZXFULZUKULZIVJZXPZUHUIUVPUXCUY
          SUWKUVOUHUXCUXIUYSUWKUXCUXJUXIUYSWGUXTBUWHCUVRUYMMBVAZUJXOULZLUKULZXF
          ULZUKULZIVJZXPUYSUVTHBUEYBZCUVRVUEUYRVUFVUDUYQIVUFVUCUYPUYMUKVUFVUBUY
          OMXFVUFVUAUYNLUKUYTUWHUJXOXQXRXSXSXTYAUDCUVRUYRUYLYCYDWCUXSYEYFUXCUGD
          IUYSUVOUYIUYPMUYGUXCJYGUQZUVOYGUQAVUGUXBUWRWFJYHWCUYEUXCMUYOUYEUXCUYN
          YGUQZUYCUYOVNUQUXCUWSVUHUXOUWHYIWCZUYDUYNLUUEUUAYJUYJUXCUYIMUWHLUKULZ
          XFULZVSVJZMUYPUKULZVSVJUXCVUKYMUQUYIYMUQZVUKUYIYKUIZUYIVULUQUXCVUKUXC
          MVUJUYEUXCUWHLUXOUYDUUBZYJYLAVUNUXBAUYIAMUYHSAVRVNUQUYCUYHVNUQUUCUAVR
          LUUFYNZYJYLWFUXCVUJUYHYKUIZVUOUXCVUJLLUKULUYHYKUXCUWHLLUXCUWHUXOYOUXC
          LUYDYOZVUSUXCUXJUWHLYKUIUXTUWHUJLUUGWCUUDUXCLUXCLUYDYPZUUNUUHUXCVUJYQ
          UQUYHYQUQZMYQUQUUIMVTUIVURVUOWPUXCVUJVUPYOAVVAUXBAUYHVUQYOWFUXCMUYEYO
          UXCMUYEUUJVUJUYHMUUKUULWSVUKUYIUUMUUOUXCVUKVUMVSUXCMUJUYOUKULZXFULMUJ
          XFULZUYPUKULVUKVUMUXCMUJUYOUXCMUYEYPZUJYRUQZUXCYSXMZUXCUYNLUXCUYNVUIU
          UPZVUTUUQUURUXCVVBVUJMXFUXCUJUYNUKULZLUKULVVBVUJUXCUJUYNLVVFVVGVUTUUS
          UXCVVHUWHLUKUXCVVEUWHYRUQVVHUWHWGYSUXCUWHUXOYPUJUWHUUTYNXRYEXSUXCVVCM
          UYPUKUXCMVVDUVAXRUVBXTUVCCUGUVRUYRUGVAZUYPUKULZIVJCUGYBUYQVVJIUYMVVIU
          YPUKXQXTUVDUVEUVFUVGUVHYTUVLUVIUVJUVKYT $.
      $}

      $d f ph $.
      ${
        vdwlem10.m $e |- ( ph -> M e. NN ) $.
        $( Lemma for ~ vdw .  Set up secondary induction on ` M ` .
           (Contributed by Mario Carneiro, 18-Aug-2014.) $)
        vdwlem10 $p |- ( ph -> E. n e. NN A. f e. ( R ^m ( 1 ... n ) )
          ( <. M , K >. PolyAP f \/ ( K + 1 ) MonoAP f ) ) $=
          ( cn wcel cv cvdwp wbr c1 caddc co wral vx vm vw vg vy va vd vc vv vh
          vz vu vk cop cvdwm wo cfz cmap wrex wi opeq1 breq1d orbi1d rexralbidv
          wceq imbi2d weq oveq1 raleqdv rexbidv rspcv sylc oveq2 oveq2d cbvrexv
          cfn sylib wa breq2 cbvralv c2 2nn simpr nnmulcl sylancr wf cvv adantr
          cmul wb ovex elmapg sylancl biimpa cfv simplr cle elfznn adantl nnred
          cmpt simpllr elfzle2 leadd1dd nncnd 2timesd breqtrrd cz nnaddcld nnuz
          cuz syl6eleq ad2antrr nnzd elfz5 syl2anc mpbird ffvelrnd fveq2d fmptd
          cbvmptv biimpar syldan syl cvdwa ccnv csn cima wss wex cn0 2nn0 vdwmc
          eluznn0 simprll rspcev syl5bi orbi12d syl5bb cmin vex simprlr vdwlem8
          simprr orcd expr rexlimdvva exlimdv sylbid ralrimdva ee12an rexlimdva
          syld mpd fzfi mapfi simprrl mpan sylan2 simp1l simp1r simp2ll simp2lr
          w3a simp2rl simp2rr simp3 mpbid oveq1d mpteq2dv syl5eq vdwlem9 3expia
          ralrimiv syl6bb anassrs rexlimddv rexlimdvaa expcom a2d nnind mpcom )
          FLMAFEUNZCNZOPZEQRSZUWDUOPZUPZCBQDNZUQSZURSZTDLUSZKAUANZEUNZUWDOPZUWG
          UPZCUWKTDLUSZUTAQEUNZUWDOPZUWGUPZCUWKTZDLUSZUTAUBNZEUNZUWDOPZUWGUPZCU
          WKTZDLUSZUTAUXCQRSZEUNZUWDOPZUWGUPZCUWKTZDLUSZUTAUWLUTUAUBFUWMQVEZUWQ
          UXBAUXOUWPUWTDCLUWKUXOUWOUWSUWGUXOUWNUWRUWDOUWMQEVAVBVCVDVFUAUBVGZUWQ
          UXHAUXPUWPUXFDCLUWKUXPUWOUXEUWGUXPUWNUXDUWDOUWMUXCEVAVBVCVDVFUWMUXIVE
          ZUWQUXNAUXQUWPUXLDCLUWKUXQUWOUXKUWGUXQUWNUXJUWDOUWMUXIEVAVBVCVDVFUWMF
          VEZUWQUWLAUXRUWPUWHDCLUWKUXRUWOUWEUWGUXRUWNUWCUWDOUWMFEVAVBVCVDVFAEUW
          DUOPZCBQUCNZUQSZURSZTZUCLUSZUXBAUXSCUWKTZDLUSZUYDABVPMZUXSCGNZUWJURSZ
          TZDLUSZGVPTZUYFHJUYKUYFGBVPUYHBVEZUYJUYEDLUYMUXSCUYIUWKUYHBUWJURVHVIV
          JVKVLUYEUYCDUCLDUCVGZUXSCUWKUYBUYNUWJUYABURUWIUXTQUQVMVNZVIVOVQAUYCUX
          BUCLUYCEUDNZUOPZUDUYBTZAUXTLMZVRZUXBUXSUYQCUDUYBUWDUYPEUOVSVTUYTWAUXT
          WISZLMZUYRUWTCBQVUAUQSZURSZTZUXBUYTWALMZUYSVUBWBAUYSWCWAUXTWDWEZUYTUY
          RUWTCVUDUYTUWDVUDMZVUCBUWDWFZUYRUWTUTUYTVUHVUIUYTUYGVUCWGMVUHVUIWJAUY
          GUYSHWHZQVUAUQWKBVUCUWDVPWGWLWMWNUYTVUIVRZUYREUAUYAUWMUXTRSZUWDWOZXAZ
          UOPZUWTVUKVUNUYBMZUYRVUOUTUYTVUIUYABVUNWFZVUPVUKUEUYAUENZUXTRSZUWDWOZ
          BVUNVUKVURUYAMZVRZVUCBVUSUWDUYTVUIVVAWPVVBVUSVUCMZVUSVUAWQPZVVBVUSUXT
          UXTRSVUAWQVVBVURUXTUXTVVBVURVVAVURLMVUKVURUXTWRWSZWTVVBUXTAUYSVUIVVAX
          BZWTZVVGVVAVURUXTWQPVUKVURQUXTXCWSXDVVBUXTVVBUXTVVFXEXFXGVVBVUSQXKWOZ
          MVUAXHMVVCVVDWJVVBVUSLVVHVVBVURUXTVVEVVFXIXJXLVVBVUAUYTVUBVUIVVAVUGXM
          XNVUSQVUAXOXPXQXRUAUEUYAVUMVUTUAUEVGVULVUSUWDUWMVURUXTRVHXSYAZXTZUYTV
          UPVUQUYTUYGUYAWGMVUPVUQWJVUJQUXTUQWKZBUYAVUNVPWGWLWMYBYCUYQVUOUDVUNUY
          BUYPVUNEUOVSVKYDVUKVUOUFNZUGNZEYEWOSVUNYFUHNZYGYHYIZUGLUSUFLUSZUHYJUW
          TVUKBVUNEUYAUFUHUGVVKVUKWAYKMEWAXKWOMZEYKMYLAVVQUYSVUIIXMZEWAYNWEVVJY
          MVUKVVPUWTUHVUKVVOUWTUFUGLLVUKVVLLMZVVMLMZVRZVVOUWTVUKVWAVVOVRZVRZUWS
          UWGVWCUEVVLVVNVVMBUWDVUNEUXTUYTUYGVUIVWBVUJXMVUKVVQVWBVVRWHAUYSVUIVWB
          XBUYTVUIVWBWPUHUUAVUKVVSVVTVVOYOVUKVVSVVTVVOUUBVUKVWAVVOUUDVVIUUCUUEU
          UFUUGUUHUUIUUMYCUUJUXAVUEDVUALUWIVUAVEZUWTCUWKVUDVWDUWJVUCBURUWIVUAQU
          QVMVNVIYPUUKYQUULUUNUXCLMZAUXHUXNAVWEUXHUXNUTUXHUXDUYPOPZUWFUYPUOPZUP
          ZUDUYBTZUCLUSAVWEVRZUXNUXGVWIDUCLUXGVWHUDUWKTUYNVWIUXFVWHCUDUWKCUDVGU
          XEVWFUWGVWGUWDUYPUXDOVSUWDUYPUWFUOVSYRVTUYNVWHUDUWKUYBUYOVIYSVOVWJVWI
          UXNUCLVWJUYSVWIVRZVRZUXSCUYBQUINZUQSZURSZTZUXNUILVWLUYBVPMZUYLVWPUILU
          SZVWLUYGUYAVPMVWQAUYGVWEVWKHXMQUXTUUOBUYAUUPWMAUYLVWEVWKJXMUYKVWRGUYB
          VPUYKUXSCUYHVWNURSZTZUILUSUYHUYBVEZVWRUYJVWTDUILDUIVGZUXSCUYIVWSVXBUW
          JVWNUYHURUWIVWMQUQVMVNVIVOVXAVWTVWPUILVXAUXSCVWSVWOUYHUYBVWNURVHVIVJY
          SVKVLVWJVWKVWMLMZVWPVRZUXNVWJVWKVXDVRZVRZUXTWAVWMWISZWISZLMZUXJUJNZOP
          ZUWFVXJUOPZUPZUJBQVXHUQSZURSZTZUXNVXFUYSVXCVXIVWJUYSVWIVXDYOVWJVWKVXC
          VWPUUQVXCUYSVXGLMZVXIVUFVXCVXQWBWAVWMWDUURUXTVXGWDUUSXPVXFVXMUJVXOVWJ
          VXEVXJVXOMZVXMVWJVXEVXRUVDZUKULBCUMDUAVWNUEUYAVURUXTUWMQYTSZVWMRSZWIS
          ZRSZVXJWOZXAZXAVXJEUXCVWMUXTGVXSAUYGAVWEVXEVXRUUTZHYDZVXSAVVQVYFIYDVX
          SAUYLVYFJYDAVWEVXEVXRUVAUYSVWIVXDVWJVXRUVBVXSVWIUXDUMNZOPZUWFVYHUOPZU
          PZUMUYBTUYSVWIVXDVWJVXRUVCVWHVYKUDUMUYBUDUMVGVWFVYIVWGVYJUYPVYHUXDOVS
          UYPVYHUWFUOVSYRVTVQVXCVWPVWKVWJVXRUVEVXCVWPVWKVWJVXRUVFVXSVXRVXNBVXJW
          FZVWJVXEVXRUVGVXSUYGVXNWGMVXRVYLWJVYGQVXHUQWKBVXNVXJVPWGWLWMUVHUAUKVW
          NVYEULUYAULNZUXTUKNZQYTSZVWMRSZWISZRSZVXJWOZXAZUAUKVGZVYEULUYAVYMVYBR
          SZVXJWOZXAVYTUEULUYAVYDWUCUEULVGVYCWUBVXJVURVYMVYBRVHXSYAWUAULUYAWUCV
          YSWUAWUBVYRVXJWUAVYBVYQVYMRWUAVYAVYPUXTWIWUAVXTVYOVWMRUWMVYNQYTVHUVIV
          NVNXSUVJUVKYAUVLUVMUVNUXMVXPDVXHLUWIVXHVEZUXMUXLCVXOTVXPWUDUXLCUWKVXO
          WUDUWJVXNBURUWIVXHQUQVMVNVIUXLVXMCUJVXOCUJVGUXKVXKUWGVXLUWDVXJUXJOVSU
          WDVXJUWFUOVSYRVTUVOYPXPUVPUVQUVRYQUVSUVTUWAUWB $.
      $}

      $( Lemma for ~ vdw .  (Contributed by Mario Carneiro, 18-Aug-2014.) $)
      vdwlem11 $p |- ( ph -> E. n e. NN
        A. f e. ( R ^m ( 1 ... n ) ) ( K + 1 ) MonoAP f ) $=
        ( vi c1 co cv wbr cn cfv wcel cfn syl wa va vd caddc cfz cmap wral wrex
        cvdwm chash cop cvdwp wo cn0 hashcl nn0p1nn vdwlem10 wf cvv adantr ovex
        wb elmapg sylancl biimpa wn nn0red ltp1d cr peano2re ltnled mpbid cvdwa
        cle clt ccnv csn cima wss cmpt crn c2 cuz eluz2b2 simplbi nnnn0d simprr
        wceq eqid vdwpc cdom ad3antrrr ad2antrr cdm cnvimass syl6ss fdm sseqtrd
        simpr simplrl elmap sylib ffvelrnda nnaddcld vdwapid1 syl3anc sseldd ex
        nnex ffvelrn ee12an ralimdva imp fmpt frn ssdomg syl2anc hashdom mpbird
        sylc ssfi breq1 syl5ibcom expimpd rexlimdvva sylbid mtod anassrs syldan
        biorf ralbidva rexbidva ) AEKUCLCMZUHNZCBKDMZUDLZUELZUFZDOUGBUIPZKUCLZE
        UJYLUKNZYMULZCYPUFZDOUGABCDEYSFGHIAYRUMQZYSOQZABRQZUUCGBUNSZYRUOSZUPAYQ
        UUBDOAYNOQZTZYMUUACYPUUIYLYPQZYOBYLUQZYMUUAVAZUUIUUJUUKUUIUUEYOURQUUJUU
        KVAAUUEUUHGUSKYNUDUTZBYOYLRURVBVCVDAUUHUUKUULAUUHUUKTZTZYTVEUULUUOYTYSY
        RVMNZAUUPVEZUUNAYRYSVNNUUQAYRAYRUUFVFZVGAYRYSUURAYRVHQYSVHQUURYRVISVJVK
        USUUOYTUAMZJMZUBMZPZUCLZUVBEVLPLZYLVOUVCYLPZVPZVQZVRZJKYSUDLZUFZJUVIUVE
        VSZVTZUIPZYSWGZTZUBOUVIUELZUGUAOUGUUPUUOBJYLUVIEYSYOUAUBUUMUUOEAEOQZUUN
        AEWAWBPQZUVQHUVRUVQKEVNNEWCWDSZUSWEAUUHUUKWFZAUUDUUNUUGUSUVIWHWIUUOUVOU
        UPUAUBOUVPUUOUUSOQZUVAUVPQZTZTZUVJUVNUUPUWDUVJTZUVMYRVMNZUVNUUPUWEUWFUV
        LBWJNZUWEUUEUVLBVRZUWGAUUEUUNUWCUVJGWKZUWEUVIBUVKUQZUWHUWEUVEBQZJUVIUFZ
        UWJUWDUVJUWLUWDUVHUWKJUVIUWDUUTUVIQZTZUUKUVHUVCYOQZUWKUUOUUKUWCUWMUVTWL
        UWNUVHUWOUWNUVHTZUVDYOUVCUWPUVDYLWMZYOUWPUVDUVGUWQUWNUVHWRYLUVFWNWOUWPU
        UKUWQYOWGUUOUUKUWCUWMUVHUVTWKYOBYLWPSWQUWNUVCUVDQZUVHUWNUVQUVCOQUVBOQUW
        RAUVQUUNUWCUWMUVSWKUWNUUSUVBUUOUWAUWBUWMWSUWDUVIOUUTUVAUWDUWBUVIOUVAUQU
        UOUWAUWBWFOUVIUVAXHKYSUDUTWTXAXBZXCUWSUVCUVBEXDXEUSXFXGYOBUVCYLXIXJXKXL
        JUVIBUVEUVKUVKWHXMXAUVIBUVKXNSZUVLBRXOXSUWEUVLRQZUUEUWFUWGVAUWEUUEUWHUX
        AUWIUWTBUVLXTXPUWIUVLBRXQXPXRUVMYSYRVMYAYBYCYDYEYFYTYMYISYGYHYJYKXR $.
    $}

    ${
      vdwlem12.f $e |- ( ph -> F : ( 1 ... ( ( # ` R ) + 1 ) ) --> R ) $.
      vdwlem12.2 $e |- ( ph -> -. 2 MonoAP F ) $.
      $( Lemma for ~ vdw . ` K = 2 ` base case of induction.  (Contributed by
         Mario Carneiro, 18-Aug-2014.) $)
      vdwlem12 $p |- -. ph $=
        ( vx vy va vd c1 cfv co wcel syl wceq cn cv weq wa vz vw vc chash caddc
        cfz wbr clt cfn cn0 hashcl nn0red ltp1d nn0p1nn nnnn0d hashfz1 breqtrrd
        csdm wb fzfi hashsdom sylancl mpbid cdom wn wf1 wf wral fveq2 eqeqan12d
        wi eqeq12 imbi12d eqcom syl6bb wss elfznn nnred ssriv a1i biidd cle w3a
        cr simplr3 c2 cvdwm ad2antrr 3simpa ccnv csn cima wrex wex cmin simplrl
        cvdwa simprr simplrr nnsub syl2anc cun df-2 fveq2i 1nn0 vdwapun syl3anc
        oveqi syl5eq simprl wfn ffn mpbir2and snssd nncnd pncan3d oveq1d vdwap1
        fniniseg eqtrd eqidd eqsstrd unssd oveq1 sseq1d oveq2 rspc2ev fvex sneq
        imaeq2d sseq2d 2rexbidv spcev ovex 2nn0 vdwmc mpbird sylanl2 expr mtod
        simplr1 simplr2 sseldi eqleltd ex wlogle ralrimivva dff13 sylanbrc sylc
        f1domg domnsym pm2.65i ) ABKBUDLZKUEMZUFMZURUGZAUUNUUPUDLZUHUGZUUQAUUNU
        UOUURUHAUUNAUUNABUINZUUNUJNZDBUKOZULUMAUUOUJNUURUUOPAUUOAUVAUUOQNUVBUUN
        UNOUOUUOUPOUQAUUTUUPUINUUSUUQUSDKUUOUTBUUPVAVBVCAUUPBVDUGZUUQVEAUUTUUPB
        CVFZUVCDAUUPBCVGZGRZCLZHRZCLZPZGHSZVKZHUUPVHGUUPVHUVDEAUVLGHUUPUUPAUARZ
        CLZUBRZCLZPZUAUBSZVKUVLUVLGHUAUBUUPUAGSZUBHSZTUVQUVJUVRUVKUVSUVTUVNUVGU
        VPUVIUVMUVFCVIUVOUVHCVIVJUVMUVFUVOUVHVLVMUAHSZUBGSZTZUVQUVJUVRUVKUWCUVQ
        UVIUVGPUVJUWAUWBUVNUVIUVPUVGUVMUVHCVIUVOUVFCVIVJUVIUVGVNVOUWCUVRHGSUVKU
        VMUVHUVOUVFVLUVHUVFVNVOVMUUPWDVPAGUUPWDUVFUUPNZUVFUVFUUOVQZVRZVSZVTAUWD
        UVHUUPNZTZTZUVLWAAUWDUWHUVFUVHWBUGZWCZTZUVJUVKUWMUVJTZUVKUWKUVFUVHUHUGZ
        VEUWDUWHUWKAUVJWEUWNUWOWFCWGUGZAUWPVEUWLUVJFWHUWMUVJUWOUWPUWLAUWIUVJUWO
        TZUWPUWDUWHUWKWIUWJUWQTZUWPIRZJRZWFWQLZMZCWJZUCRZWKZWLZVPZJQWMIQWMZUCWN
        ZUWRUXBUXCUVIWKZWLZVPZJQWMIQWMZUXIUWRUVFQNZUVHUVFWOMZQNZUVFUXOUXAMZUXKV
        PZUXMUWRUWDUXNAUWDUWHUWQWPZUWEOZUWRUWOUXPUWJUVJUWOWRUWRUXNUVHQNZUWOUXPU
        SUXTUWRUWHUYAAUWDUWHUWQWSZUVHUUOVQOZUVFUVHWTXAVCZUWRUXQUVFWKZUVFUXOUEMZ
        UXOKWQLZMZXBZUXKUWRUXQUVFUXOKKUEMZWQLZMZUYIUXAUYKUVFUXOWFUYJWQXCXDXHUWR
        KUJNZUXNUXPUYLUYIPUYMUWRXEVTUXTUYDUVFUXOKXFXGXIUWRUYEUYHUXKUWRUVFUXKUWR
        UVFUXKNZUWDUVJUXSUWJUVJUWOXJUWRCUUPXKZUYNUWDUVJTUSUWRUVEUYOAUVEUWIUWQEW
        HZUUPBCXLOZUUPUVIUVFCXSOXMXNUWRUYHUVHWKZUXKUWRUYHUVHUXOUYGMZUYRUWRUYFUV
        HUXOUYGUWRUVFUVHUWRUVFUXTXOUWRUVHUYCXOXPXQUWRUYAUXPUYSUYRPUYCUYDUVHUXOX
        RXAXTUWRUVHUXKUWRUVHUXKNZUWHUVIUVIPZUYBUWRUVIYAUWRUYOUYTUWHVUATUSUYQUUP
        UVIUVHCXSOXMXNYBYCYBUXLUXRUVFUWTUXAMZUXKVPIJUVFUXOQQIGSUXBVUBUXKUWSUVFU
        WTUXAYDYEUWTUXOPVUBUXQUXKUWTUXOUVFUXAYFYEYGXGUXHUXMUCUVIUVHCYHUXDUVIPZU
        XGUXLIJQQVUCUXFUXKUXBVUCUXEUXJUXCUXDUVIYIYJYKYLYMOUWRBCWFUUPIUCJKUUOUFY
        NWFUJNUWRYOVTUYPYPYQYRYSYTUWNUVFUVHUWNUWDUVFWDNUWDUWHUWKAUVJUUAUWFOUWNU
        UPWDUVHUWGUWDUWHUWKAUVJUUBUUCUUDXMUUEUUFUUGGHUUPBCUUHUUIUUPBUICUUKUUJUU
        PBUULOUUM $.
    $}

    $d f ph $.
    vdw.k $e |- ( ph -> K e. NN0 ) $.
    $( Lemma for ~ vdw .  Main induction on ` K ` ; ` K = 0 ` , ` K = 1 ` base
       cases.  (Contributed by Mario Carneiro, 18-Aug-2014.) $)
    vdwlem13 $p |- ( ph -> E. n e. NN
      A. f e. ( R ^m ( 1 ... n ) ) K MonoAP f ) $=
      ( vr cn wcel cv cvdwm c1 cfz co cmap wral wrex wceq cfn va vd vc vx vk vg
      vs vm wbr cc0 c2 cuz cfv wo elnn1uz2 cvdwa ccnv csn cima wss wf wb elmapg
      cvv ovex sylancl biimpa wa 1nn vdwap1 mp2an cz 1z elfz3 mp1i eqidd adantl
      wfn fniniseg mpbir2and snssd syl5eqss syldan ralrimiva fveq2 oveqd sseq1d
      ffn syl ralbidv syl5ibrcom wex oveq1 oveq2 rspc2ev mp3an12 imaeq2d sseq2d
      fvex sneq 2rexbidv spcev cn0 adantr vdwmc syl5ibr ralimdva oveq2d raleqdv
      rspcev mpan syl6 syld caddc breq1 rexralbidv weq hashcl nn0p1nn wi simpll
      chash wn simplr vex elmap sylib simpr vdwlem12 iman mpbir syl2anc rexbidv
      rgen a1i breq2 cbvralv syl6bb syl5bi c0 cbvrexv ralbii sylibr vdwlem11 ex
      ralrimdva uzind4 rspcv syl2im jaod vdwap0 syl6eq syl6eqss ralrimivw elnn0
      0ss syl5 mpjaod ) AEIJZECKZLUIZCBMDKZNOZPOZQZDIRZEUJSZUUSEMSZEUKULUMZJZUN
      AUVFEUOAUVHUVFUVJAUVHMMEUPUMZOZUUTUQZMUUTUMZURZUSZUTZCBMMNOZPOZQZUVFAUVTU
      VHMMMUPUMZOZUVPUTZCUVSQAUWCCUVSAUUTUVSJZUVRBUUTVAZUWCAUWDUWEABTJZUVRVDJUW
      DUWEVBFMMNVEZBUVRUUTTVDVCVFVGZAUWEVHZUWBMURZUVPMIJZUWKUWBUWJSVIVIMMVJVKUW
      IMUVPUWIMUVPJZMUVRJZUVNUVNSZMVLJUWMUWIVMMVNVOUWIUVNVPUWIUUTUVRVRZUWLUWMUW
      NVHVBUWEUWOAUVRBUUTWHVQUVRUVNMUUTVSWIVTWAWBWCWDUVHUVQUWCCUVSUVHUVLUWBUVPU
      VHUVKUWAMMEMUPWEWFWGWJWKAUVTUVACUVSQZUVFAUVQUVACUVSUVQUVAAUWDVHZUAKZUBKZU
      VKOZUVMUCKZURZUSZUTZUBIRUAIRZUCWLZUVQUWTUVPUTZUBIRUAIRZUXFUWKUWKUVQUXHVIV
      IUXGUVQMUWSUVKOZUVPUTUAUBMMIIUWRMSUWTUXIUVPUWRMUWSUVKWMWGUWSMSUXIUVLUVPUW
      SMMUVKWNWGWOWPUXEUXHUCUVNMUUTWSUXAUVNSZUXDUXGUAUBIIUXJUXCUVPUWTUXJUXBUVOU
      VMUXAUVNWTWQWRXAXBWIUWQBUUTEUVRUAUCUBUWGAEXCJZUWDGXDUWHXEXFXGUWKUWPUVFVIU
      VEUWPDMIUVBMSZUVACUVDUVSUXLUVCUVRBPUVBMMNWNXHXIXJXKXLZXMAUWFUVJUVACHKZUVC
      POZQZDIRZHTQZUVFFUDKZUUTLUIZCUXOQDIRZHTQUKUUTLUIZCUXOQZDIRZHTQZUEKZUUTLUI
      ZCUXOQZDIRZHTQZUYFMXNOZUUTLUIZCUXOQDIRZHTQZUXRUDUEUKEUXSUKSZUYAUYDHTUYOUX
      TUYBDCIUXOUXSUKUUTLXOXPWJUDUEXQZUYAUYIHTUYPUXTUYGDCIUXOUXSUYFUUTLXOXPWJUX
      SUYKSZUYAUYMHTUYQUXTUYLDCIUXOUXSUYKUUTLXOXPWJUXSESZUYAUXQHTUYRUXTUVADCIUX
      OUXSEUUTLXOXPWJUYEUKVLJUYDHTUXNTJZUXNYBUMZMXNOZIJZUYBCUXNMVUANOZPOZQZUYDU
      YSUYTXCJVUBUXNXRUYTXSWIUYSUYBCVUDUYSUUTVUDJZVHZUYBXTVUGUYBYCZVHZYCVUIUXNU
      UTUYSVUFVUHYAVUIVUFVUCUXNUUTVAUYSVUFVUHYDUXNVUCUUTHYEMVUANVEYFYGVUGVUHYHY
      IVUGUYBYJYKWDUYCVUEDVUAIUVBVUASZUYBCUXOVUDVUJUVCVUCUXNPUVBVUAMNWNXHXIXJYL
      YNYOUYJUYFUFKZLUIZUFUGKZMUHKZNOZPOZQZUHIRZUGTQZUYFUVIJZUYNUYIVURHUGTHUGXQ
      ZUYIUYGCVUMUVCPOZQZDIRZVURVVAUYHVVCDIVVAUYGCUXOVVBUXNVUMUVCPWMXIYMVVCVUQD
      UHIDUHXQZVVCUYGCVUPQVUQVVEUYGCVVBVUPVVEUVCVUOVUMPUVBVUNMNWNXHXIUYGVULCUFV
      UPUUTVUKUYFLYPYQYRUUAZYRYQVUTVUSUYMHTVUTUYSVHZVUSUYMVVGVUSVHZUXNCDUYFUGVU
      TUYSVUSYDVUTUYSVUSYAVVHVUSVVDUGTQVVGVUSYHVVDVURUGTVVFUUBUUCUUDUUEUUFYSUUG
      UXQUVFHBTUXNBSZUXPUVEDIVVIUVACUXOUVDUXNBUVCPWMXIYMUUHUUIUUJYSUVGUVTAUVFUV
      GUVQCUVSUVGUVLYTUVPUVGUVLMMUJUPUMZOZYTUVGUVKVVJMMEUJUPWEWFUWKUWKVVKYTSVIV
      IMMUUKVKUULUVPUUPUUMUUNUXMUUQAUXKUUSUVGUNGEUUOYGUUR $.
  $}

  ${
    $d a c d f m n x K $.  $d a c d f n x R $.
    $( Van der Waerden's theorem.  For any finite coloring ` R ` and integer
       ` K ` , there is an ` N ` such that every coloring function from
       ` 1 ... N ` to ` R ` contains a monochromatic arithmetic progression
       (which written out in full means that there is a color ` c ` and base,
       increment values ` a , d ` such that all the numbers
       ` a , a + d , ... , a + ( k - 1 ) d ` lie in the preimage of ` { c } ` ,
       i.e. they are all in ` 1 ... N ` and ` f ` evaluated at each one yields
       ` c ` ).  (Contributed by Mario Carneiro, 13-Sep-2014.) $)
    vdw $p |- ( ( R e. Fin /\ K e. NN0 ) -> E. n e. NN
      A. f e. ( R ^m ( 1 ... n ) ) E. c e. R E. a e. NN E. d e. NN
      A. m e. ( 0 ... ( K - 1 ) ) ( a + ( m x. d ) ) e. ( `' f " { c } ) ) $=
      ( cfn wcel cn0 wa cv c1 cfz co wral cn wrex cvv cvdwm wbr cmap cmul caddc
      ccnv csn cima cc0 cmin simpl simpr vdwlem13 ovex simpllr wf simpll elmapg
      sylancl biimpa cuz cfv simplr nnuz syl6eleq eluzfz1 syl ralbidva rexbidva
      wb vdwmc2 mpbid ) AIJZEKJZLZEBMZUAUBZBANDMZOPZUCPZQZDRSFMCMHMUDPUEPVPUFGM
      UGUHJCUIENUJPOPQHRSFRSGASZBVTQZDRSVOABDEVMVNUKVMVNULUMVOWAWCDRVOVRRJZLZVQ
      WBBVTWEVPVTJZLZNACVPEVSFGHNVROUNZVMVNWDWFUOWEWFVSAVPUPZWEVMVSTJWFWIVJVMVN
      WDUQWHAVSVPITURUSUTWGVRNVAVBZJNVSJWGVRRWJVOWDWFVCVDVENVRVFVGVKVHVIVL $.
  $}

  ${
    $d a d k m A $.  $d a c d f m n K $.  $d a c d x ph $.  $d a c d f n x R $.
    $d a d k m B $.  $d a c d f k m n F $.  $d a d k m x S $.
    $( Corollary of ~ vdw , and lemma for ~ vdwnn .  If ` F ` is a coloring of
       the integers, then there are arbitrarily long monochromatic APs in
       ` F ` .  (Contributed by Mario Carneiro, 13-Sep-2014.) $)
    vdwnnlem1 $p |- ( ( R e. Fin /\ F : NN --> R /\ K e. NN0 ) ->
      E. c e. R E. a e. NN E. d e. NN A. m e. ( 0 ... ( K - 1 ) )
        ( a + ( m x. d ) ) e. ( `' F " { c } ) ) $=
      ( vf vn wcel cn cv co ccnv cima c1 cfz wral wrex wss cfn wf cn0 w3a caddc
      cmul csn cc0 cmin cmap vdw 3adant2 wa cres simpl2 cuz cfv fzssuz sseqtr4i
      wi nnuz fssres sylancl cvv wb simpl1 ovex elmapg mpbird wceq cnveq eleq2d
      imaeq1d ralbidv 2rexbidv rexbidv rspcv syl resss cnvss imass1 mp2b ralimi
      sseli reximi syl6 rexlimdva mpd ) AUAJZKACUBZDUCJZUDZELBLGLUFMUEMZHLZNZFL
      UGZOZJZBUHDPUIMQMZRZGKSEKSZFASZHAPILZQMZUJMZRZIKSZWMCNZWPOZJZBWSRZGKSZEKS
      ZFASZWIWKXGWJAHBIDEFGUKULWLXFXNIKWLXCKJZUMZXFWMCXDUNZNZWPOZJZBWSRZGKSZEKS
      ZFASZXNXPXQXEJZXFYDUTXPYEXDAXQUBZXPWJXDKTYFWIWJWKXOUOXDPUPUQKPXCURVAUSKAX
      DCVBVCXPWIXDVDJYEYFVEWIWJWKXOVFPXCQVGAXDXQUAVDVHVCVIXBYDHXQXEWNXQVJZXAYCF
      AYGWTYAEGKKYGWRXTBWSYGWQXSWMYGWOXRWPWNXQVKVMVLVNVOVPVQVRYCXMFAYBXLEKYAXKG
      KXTXJBWSXSXIWMXQCTXRXHTXSXITCXDVSXQCVTXRXHWPWAWBWDWCWEWEWEWFWGWH $.

    vdwnn.1 $e |- ( ph -> R e. Fin ) $.
    vdwnn.2 $e |- ( ph -> F : NN --> R ) $.
    vdwnn.3 $e |- S = { k e. NN | -. E. a e. NN E. d e. NN
      A. m e. ( 0 ... ( k - 1 ) ) ( a + ( m x. d ) ) e. ( `' F " { c } ) } $.
    $( Lemma for ~ vdwnn .  The set of all "bad" ` k ` for the theorem is
       upwards-closed, because a long AP implies a short AP. (Contributed by
       Mario Carneiro, 13-Sep-2014.) $)
    vdwnnlem2 $p |- ( ( ph /\ B e. ( ZZ>= ` A ) ) -> ( A e. S -> B e. S ) ) $=
      ( wcel cn co cc0 c1 wrex cuz cfv wa cv cmul caddc ccnv csn cima cmin wral
      cfz wn wss wi cz eluzel2 peano2zm syl id cc wceq zcnd ax-1cn npcan fveq2d
      sylancl eleqtrrd eluzp1m1 syl2anc ad2antlr fzss2 3syl reximdv con3d simpr
      ssralv uztrn2 syl2anr jctild expimpd oveq1 oveq2d raleqdv 2rexbidv notbid
      nnuz elrab2 3imtr4g ) ACBUAUBZOZUCZBPOZIUDGUDKUDUEQUFQHUGJUDUHUIOZGRBSUJQ
      ZULQZUKZKPTZIPTZUMZUCCPOZWNGRCSUJQZULQZUKZKPTZIPTZUMZUCZBEOCEOWLWMWTXHWLW
      MUCZWTXGXAXIXFWSXIXEWRIPXIXDWQKPXIXBWOUAUBOZWPXCUNXDWQUOWKXJAWMWKWOUPOZCW
      OSUFQZUAUBZOXJWKBUPOXKBCUQZBURUSWKCWJXMWKUTWKXLBUAWKBVAOSVAOXLBVBWKBXNVCV
      DBSVEVGVFVHWOCVIVJVKWORXBVLWNGWPXCVQVMVNVNVOWMWMWKXAWLWMUTAWKVPSCBPWGVRVS
      VTWAWNGRFUDZSUJQZULQZUKZKPTIPTZUMZWTFBPEXOBVBZXSWSYAXRWQIKPPYAWNGXQWPYAXP
      WORULXOBSUJWBWCWDWEWFNWHXTXGFCPEXOCVBZXSXFYBXRXDIKPPYBWNGXQXCYBXPXBRULXOC
      SUJWBWCWDWEWFNWHWI $.

    vdwnn.4 $e |- ( ph -> A. c e. R S =/= (/) ) $.
    $( Lemma for ~ vdwnn .  (Contributed by Mario Carneiro, 13-Sep-2014.) $)
    vdwnnlem3 $p |- -. ph $=
      ( cr cv wrex wcel cn co c1 vx clt ccnv csup cle wbr wral cfn wa caddc csn
      cmul cima cc0 cmin cfz wn crab ssrab2 eqsstri cuz cfv wss c0 nnuz sseqtri
      wne r19.21bi infmssuzcl sylancr sseldi ralrimiva fimaxre3 syl2anc cfl cn0
      nnred wi 1nn ffvelrn sylancl ne0i syl adantr r19.2z simplr fllep1 adantlr
      wf ex flcld peano2zd zred letr syl3anc mpan2d cz wb nnzd simpll vdwnnlem2
      eluz impancom syld sseli nnnn0d syl6 rexlimdva simpr vdwnnlem1 3syld wceq
      sylbird oveq1 oveq2d raleqdv 2rexbidv notbid elrab2 simprbi ralnex syl6ib
      ralimdva pm2.65d nrexdv pm2.65i ) ACNUBUCUDZUAOZUEUFZHBUGZUANPZABUHQZYGNQ
      ZHBUGYKJAYMHBAHOZBQZUIZYGYPCRYGCGOEOIOULSUJSFUCYNUKUMQZEUNDOZTUOSZUPSZUGZ
      IRPGRPZUQZDRURRLUUCDRUSUTZYPCTVAVBZVCCVDVGZYGCQZCRUUEUUDVEVFAUUFHBMVHCTVI
      VJZVKZVQZVLUAHBYGVMVNAYJUANAYHNQZUIZYJYQEUNYHVOVBZTUJSZTUOSZUPSZUGZIRPGRP
      ZHBPZUULYJYIHBPZUUNVPQZUUSUULBVDVGZYJUUTVRAUVBUUKATFVBZBQZUVBARBFWIZTRQUV
      DKVSRBTFVTWABUVCWBWCWDUVBYJUUTYIHBWEWJWCUULYIUVAHBUULYOUIZYIUUNCQZUVAUVFY
      IYGUUNUEUFZUVGUVFYIYHUUNUEUFZUVHUVFUUKUVIAUUKYOWFZYHWGWCUVFYMUUKUUNNQYIUV
      IUIUVHVRAYOYMUUKUUJWHUVJUVFUUNUVFUUMUVFYHUVJWKWLZWMYGYHUUNWNWOWPUVFUVHUUN
      YGVAVBQZUVGUVFYGWQQUUNWQQUVLUVHWRUVFYGAYOYGRQUUKUUIWHWSUVKYGUUNXBVNUVFAUU
      GUVLUVGVRAUUKYOWTAYOUUGUUKUUHWHAUVLUUGUVGAYGUUNBCDEFGHIJKLXAXCVNXMXDZUVGU
      UNCRUUNUUDXEXFXGXHAUVAUUSVRUUKAUVAUUSAUVAUIYLUVEUVAUUSAYLUVAJWDAUVEUVAKWD
      AUVAXIBEFUUNGHIXJWOWJWDXKUULYJUURUQZHBUGUUSUQUULYIUVNHBUVFYIUVGUVNUVMUVGU
      UNRQUVNUUCUVNDUUNRCYRUUNXLZUUBUURUVOUUAUUQGIRRUVOYQEYTUUPUVOYSUUOUNUPYRUU
      NTUOXNXOXPXQXRLXSXTXGYCUURHBYAYBYDYEYF $.
  $}

  ${
    $d a c d k m u w x y z F $.  $d c u y z R $.
    $( Van der Waerden's theorem, infinitary version.  For any finite coloring
       ` F ` of the natural numbers, there is a color ` c ` that contains
       arbitrarily long arithmetic progressions.  (Contributed by Mario
       Carneiro, 13-Sep-2014.) $)
    vdwnn $p |- ( ( R e. Fin /\ F : NN --> R ) ->
      E. c e. R A. k e. NN E. a e. NN E. d e. NN A. m e. ( 0 ... ( k - 1 ) )
      ( a + ( m x. d ) ) e. ( `' F " { c } ) ) $=
      ( vu vw vy vz wcel cn cv cmul co caddc wral wrex wn vx cfn wf wa ccnv csn
      cima cc0 c1 cmin cfz crab simpll simplr weq oveq2d eleq1d cbvralv ralbidv
      wi oveq1 syl5bb oveq2 cbvrex2v raleqdv 2rexbidv notbid cbvrabv simpr sneq
      wne imaeq2d eleq2d cbvrexv sylnib rabn0 rexnal bitri ralbii ralnex sylibr
      c0 vdwnnlem3 iman mpbir ) AUBLZMADUCZUDZENZCNZGNZOPZQPZDUEZFNZUFZUGZLZCUH
      BNZUIUJPZUKPZRZGMSEMSZBMRZFASZUTWHXETZUDZTXGAWMWNHNZUFZUGZLZCXARZGMSEMSZT
      ZBMULZUAIDJHKWFWGXFUMWFWGXFUNXNJNZINZKNZOPZQPZXJLZIUHUANZUIUJPZUKPZRZKMSJ
      MSZTBUAMBUAUOZXMYFXMYAIXARZKMSJMSYGYFXLYHXPXQWKOPZQPZXJLZIXARZEGJKMMXLWIY
      IQPZXJLZIXAREJUOZYLXKYNCIXACIUOZWMYMXJYPWLYIWIQWJXQWKOVAUPUQURYOYNYKIXAYO
      YMYJXJWIXPYIQVAUQUSVBGKUOZYKYAIXAYQYJXTXJYQYIXSXPQWKXRXQOVCUPUQUSVDYGYHYE
      JKMMYGYAIXAYDYGWTYCUHUKWSYBUIUJVAUPVEVFVBVGVHXGXMBMRZHASZTZXOWBVKZHARZXGX
      EYSWHXFVIXDYRFHAFHUOZXCXMBMUUCXBXLEGMMUUCWRXKCXAUUCWQXJWMUUCWPXIWNWOXHVJV
      LVMUSVFUSVNVOUUBYRTZHARYTUUAUUDHAUUAXNBMSUUDXNBMVPXMBMVQVRVSYRHAVTVRWAWCW
      HXEWDWE $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ramsey's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ramsey $.

  $( Extend class notation with the Ramsey number function. $)
  cram $a class Ramsey $.

  ${
    $d n s M $.  $d n ph $.  $d n s T $.
    ramtlecl.t $e |- T = { n e. NN0 | A. s ( n <_ ( # ` s ) -> ph ) } $.
    $( The set ` T ` of numbers with the Ramsey number property is
       upward-closed.  (Contributed by Mario Carneiro, 21-Apr-2015.) $)
    ramtlecl $p |- ( M e. T -> ( ZZ>= ` M ) C_ T ) $=
      ( wcel cfv cv cle wbr wi wal cn0 wss wral wa cxr sseldi cvv cuz crab wceq
      chash breq1 imbi1d albidv elrab2 simplbi eluznn0 ssrdv syl simprbi eluzle
      ex adantl cr nn0ssre ressxr sstri adantr vex hashxrcl mp1i xrletr syl3anc
      sylan mpand imim1d ralrimdva alimdv mpd ralcom4 sylibr sylanbrc syl6sseqr
      ssrab ) DBGZDUAHZCIZEIZUDHZJKZALZEMZCNUBZBVRVSNOZWECVSPZVSWFOVRDNGZWGVRWI
      DWBJKZALZEMZWEWLCDNBVTDUCZWDWKEWMWCWJAVTDWBJUEUFUGFUHZUIZWICVSNWIVTVSGZVT
      NGZVTDUJZUOUKULVRWDCVSPZEMZWHVRWLWTVRWIWLWNUMVRWKWSEVRWKWDCVSVRWPQZWCWJAX
      ADVTJKZWCWJWPXBVRDVTUNUPXADRGVTRGWBRGZXBWCQWJLXANRDNUQRURUSUTZVRWIWPWOVAS
      XANRVTXDVRWIWPWQWOWRVGSWATGXCXAEVBWATVCVDDVTWBVEVFVHVIVJVKVLWDCEVSVMVNWEC
      NVSVQVOFVP $.
  $}

  ${
    $d c f x y C $.  $d c f m n r s x y z F $.  $d a b c f i m n r s x y z M $.
    $d a i x A $.  $d a i x B $.  $d c f m n r s x y z R $.  $d m r y z T $.
    $d a i x N $.  $d c f m n r s x y z V $.
    $( Define the Ramsey number function.  The input is a number ` m ` for the
       size of the edges of the hypergraph, and a tuple ` r ` from the finite
       color set to lower bounds for each color.  The Ramsey number
       ` ( M Ramsey R ) ` is the smallest number such that for any set ` S `
       with ` ( M Ramsey R ) <_ # S ` and any coloring ` F ` of the set of
       ` M ` -element subsets of ` S ` (with color set ` dom R ` ), there is a
       color ` c e. dom R ` and a subset ` x C_ S ` such that
       ` R ( c ) <_ # x ` and all the hyperedges of ` x ` (that is, subsets of
       ` x ` of size ` M ` ) have color ` c ` .  (Contributed by Mario
       Carneiro, 20-Apr-2015.) $)
    df-ram $a |- Ramsey = ( m e. NN0 , r e. _V |-> sup ( { n e. NN0 | A. s
      ( n <_ ( # ` s ) -> A. f e. ( dom r ^m { y e. ~P s | ( # ` y ) = m } )
        E. c e. dom r E. x e. ~P s ( ( r ` c ) <_ ( # ` x ) /\
      A. y e. ~P x ( ( # ` y ) = m -> ( f ` y ) = c ) ) ) } , RR* , `' < ) ) $.

    ramval.c $e |- C = ( a e. _V , i e. NN0 |->
      { b e. ~P a | ( # ` b ) = i } ) $.
    $( Value of the "binomial set", the set of all ` N ` -element subsets of
       ` A ` .  (Contributed by Mario Carneiro, 20-Apr-2015.) $)
    hashbcval $p |- ( ( A e. V /\ N e. NN0 ) ->
      ( A C N ) = { x e. ~P A | ( # ` x ) = N } ) $=
      ( wcel cvv cn0 co cv chash cfv wceq cpw crab wa pwexg adantr rabexg fveq2
      elex syl eqeq1d cbvrabv simpl pweqd simpr eqeq2d rabeqbidv syl5eq mpd3an3
      ovmpt2ga sylan ) BFJBKJZELJZBECMANZOPZEQZABRZSZQZBFUEURUSVDKJZVEURUSTVCKJ
      ZVFURVGUSBKUAUBVBAVCKUCUFGDBEKLHNZOPZDNZQZHGNZRZSZVDCKVLBQZVJEQZTZVNVAVJQ
      ZAVMSVDVKVRHAVMVHUTQVIVAVJVHUTOUDUGUHVQVRVBAVMVCVQVLBVOVPUIUJVQVJEVAVOVPU
      KULUMUNIUPUOUQ $.

    $( The binomial set is a finite set.  (Contributed by Mario Carneiro,
       20-Apr-2015.) $)
    hashbccl $p |- ( ( A e. Fin /\ N e. NN0 ) -> ( A C N ) e. Fin ) $=
      ( vx cfn wcel cn0 wa co cv chash cfv wceq cpw crab hashbcval simpl ssrab2
      wss pwfi sylib ssfi sylancl eqeltrd ) AIJZDKJZLZADBMHNOPDQZHARZSZIHABCDIE
      FGTUKUMIJZUNUMUCUNIJUKUIUOUIUJUAAUDUEULHUMUBUMUNUFUGUH $.

    $( Subset relation for the binomial set.  (Contributed by Mario Carneiro,
       20-Apr-2015.) $)
    hashbcss $p |- ( ( A e. V /\ B C_ A /\ N e. NN0 ) ->
      ( B C N ) C_ ( A C N ) ) $=
      ( vx wcel wss cn0 w3a wceq cpw crab co cvv hashbcval cv chash simp2 sspwb
      cfv sylib rabss2 syl simp1 ssexd simp3 syl2anc 3adant2 3sstr4d ) AFKZBALZ
      EMKZNZJUAUBUEEOZJBPZQZUSJAPZQZBECRZAECRZURUTVBLZVAVCLURUPVFUOUPUQUCZBAUDU
      FUSJUTVBUGUHURBSKUQVDVAOURBAFUOUPUQUIVGUJUOUPUQUKJBCDESGHITULUOUQVEVCOUPJ
      ACDEFGHITUMUN $.

    $( The set of subsets of size zero is the singleton of the empty set.
       (Contributed by Mario Carneiro, 22-Apr-2015.) $)
    hashbc0 $p |- ( A e. V -> ( A C 0 ) = { (/) } ) $=
      ( vx wcel cc0 co cv chash cfv wceq cpw c0 wa cab cvv crab hashbcval mpan2
      csn cn0 0nn0 wb vex hasheq0 ax-mp anbi2i id 0elpw syl6eqel pm4.71ri abbii
      bitr4i df-rab df-sn 3eqtr4i syl6eq ) ADIZAJBKZHLZMNJOZHAPZUAZQUDZVBJUEIVC
      VGOUFHABCJDEFGUBUCVDVFIZVERZHSVDQOZHSVGVHVJVKHVJVIVKRVKVEVKVIVDTIVEVKUGHU
      HVDTUIUJUKVKVIVKVDQVFVKULAUMUNUOUQUPVEHVFURHQUSUTVA $.

    $( The size of the binomial set is the binomial coefficient.  (Contributed
       by Mario Carneiro, 20-Apr-2015.) $)
    hashbc2 $p |- ( ( A e. Fin /\ N e. NN0 ) ->
      ( # ` ( A C N ) ) = ( ( # ` A ) _C N ) ) $=
      ( vx cfn wcel cn0 wa co chash cfv cv wceq cpw crab cbc fveq2d nn0z hashbc
      hashbcval cz sylan2 eqtr4d ) AIJZDKJZLZADBMZNOHPNODQHARSZNOZANODTMZUJUKUL
      NHABCDIEFGUDUAUIUHDUEJUNUMQDUBHADUCUFUG $.

    $( There are no subsets of the empty set with size greater than zero.
       (Contributed by Mario Carneiro, 22-Apr-2015.) $)
    0hashbc $p |- ( N e. NN -> ( (/) C N ) = (/) ) $=
      ( cn wcel c0 co chash cfv cc0 wceq cbc cfn cn0 0fin nnnn0 cvv oveq1i bc0k
      hashbc2 sylancr hash0 syl5eq eqtrd wb ovex hasheq0 ax-mp sylib ) CGHZICAJ
      ZKLZMNZUNINZUMUOIKLZCOJZMUMIPHCQHUOUSNRCSIABCDEFUCUDUMUSMCOJMURMCOUEUACUB
      UFUGUNTHUPUQUHICAUIUNTUJUKUL $.

    ramval.t $e |- T = { n e. NN0 | A. s ( n <_ ( # ` s ) ->
       A. f e. ( R ^m ( s C M ) ) E. c e. R E. x e. ~P s
        ( ( F ` c ) <_ ( # ` x ) /\ ( x C M ) C_ ( `' f " { c } ) ) ) } $.
    $( The value of the Ramsey number function.  (Contributed by Mario
       Carneiro, 21-Apr-2015.) $)
    ramval $p |- ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) ->
      ( M Ramsey F ) = sup ( T , RR* , `' < ) ) $=
      ( vy cn0 wcel wa vm vr wf w3a cvv cv chash cfv cle wbr wceq cpw wral wrex
      wi cdm crab cmap wal cxr clt ccnv csup cram cmpt2 df-ram a1i csn cima wss
      co simplrr dmeqd simpll3 fdm syl eqtrd simplrl eqeq2d rabbidv vex simpll1
      hashbcval sylancr eqtr4d oveq12d simpr 3ad2ant3 sylan9eqr ad2antrr fveq1d
      raleqdv breq1d oveq2d eqeltrd eqtr3d sseq1d rabss wfn elmapi ad3antlr ffn
      wb fniniseg 3syl eleq2d rabid syl6bb biimpar elpwi adantl hashbcss sselda
      syl3anc syldan biantrurd bitr4d anassrs pm5.74da ralbidva syl5bb rexbidva
      bitr2d anbi12d rexeqbidv bitrd imbi2d albidv rabbidva syl6eqr simp1 simp3
      supeq1d simp2 fex syl2anc wor xrltso cnvso mpbi supex ovmpt2d ) IRSZCJSZC
      RHUCZUDZUAUBIHRUEGUFZKUFZUGUHUIUJZNUFZUBUFZUHZAUFZUGUHZUIUJZQUFZUGUHZUAUF
      ZUKZUUPEUFZUHUUJUKZUOZQUUMULZUMZTZAUUHULZUNZNUUKUPZUNZEUVHUUSQUVFUQZURVKZ
      UMZUOZKUSZGRUQZUTVAVBZVCZDUTUVPVCZVDUEVDUAUBRUEUVQVEUKUUFAQEUAGKUBNVFVGUU
      FUURIUKZUUKHUKZTZTZUTUVODUVPUWBUVOUUIUUJHUHZUUNUIUJZUUMIBVKZUUTVBUUJVHVIZ
      VJZTZAUVFUNZNCUNZECUUHIBVKZURVKZUMZUOZKUSZGRUQDUWBUVNUWOGRUWBUUGRSZTZUVMU
      WNKUWQUVLUWMUUIUWQUVLUVIEUWLUMUWMUWQUVIEUVKUWLUWQUVHCUVJUWKURUWQUVHHUPZCU
      WQUUKHUUFUVSUVTUWPVLZVMUWQUUEUWRCUKZUUCUUDUUEUWAUWPVNCRHVOZVPVQUWQUVJUUQI
      UKZQUVFUQZUWKUWQUUSUXBQUVFUWQUURIUUQUUFUVSUVTUWPVRZVSVTUWQUUHUESZUUCUWKUX
      CUKKWAZUUCUUDUUEUWAUWPWBZQUUHBFIUELMOWCWDWEWFWLUWQUVIUWJEUWLUWQUUTUWLSZTZ
      UVGUWINUVHCUWBUVHCUKUWPUXHUWAUUFUVHUWRCUWAUUKHUVSUVTWGVMUUEUUCUWTUUDUXAWH
      WIWJUXIUVEUWHAUVFUXIUUMUVFSZTZUUOUWDUVDUWGUXKUULUWCUUNUIUXKUUJUUKHUWQUVTU
      XHUXJUWSWJWKWMUXKUWGUUSQUVCUQZUWFVJZUVDUXKUWEUXLUWFUXKUUMUURBVKZUWEUXLUXK
      UURIUUMBUWQUVSUXHUXJUXDWJZWNUXKUUMUESUURRSUXNUXLUKAWAUXKUURIRUXOUWQUUCUXH
      UXJUXGWJZWOQUUMBFUURUELMOWCWDWPZWQUXMUUSUUPUWFSZUOZQUVCUMUXKUVDUUSQUVCUWF
      WRUXKUXSUVBQUVCUXKUUPUVCSZTUUSUXRUVAUXKUXTUUSUXRUVAXCUXKUXTUUSTZTZUXRUUPU
      WKSZUVATZUVAUYBUWKCUUTUCZUUTUWKWSUXRUYDXCUXHUYEUWQUXJUYAUUTCUWKWTXAUWKCUU
      TXBUWKUUJUUPUUTXDXEUYBUYCUVAUXKUYAUUPUWESZUYCUXKUYFUYAUXKUYFUUPUXLSUYAUXK
      UWEUXLUUPUXQXFUUSQUVCXGXHXIUXKUWEUWKUUPUXKUXEUUMUUHVJZUUCUWEUWKVJUXEUXKUX
      FVGUXJUYGUXIUUMUUHXJXKUXPUUHUUMBFIUELMOXLXNXMXOXPXQXRXSXTYAYCYDYBYEXTYFYG
      YHYIPYJYMUUCUUDUUEYKUUFUUEUUDHUESUUCUUDUUEYLUUCUUDUUEYNCRJHYOYPUVRUESUUFU
      TDUVPUTVAYQUTUVPYQYRUTVAYSYTUUAVGUUB $.

    $( Lemma for extended real closure of the Ramsey number function.
       (Contributed by Mario Carneiro, 20-Apr-2015.) $)
    ramcl2lem $p |- ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) ->
      ( M Ramsey F ) = if ( T = (/) , +oo , sup ( T , RR , `' < ) ) ) $=
      ( cr clt cn0 cxr vz c0 wceq cram co cpnf ccnv csup cif wcel wf w3a ramval
      eqeq2 supeq1 xrinfm0 syl6eq sylan9eq wn wne df-ne adantr wor xrltso cnvso
      wa mpbi a1i cv chash cfv cle wbr csn cima wss cpw wrex cmap wral wal crab
      wi ssrab2 eqsstri nn0ssre sstri cc0 nn0uz sseqtri infmssuzcl sylan sseldi
      cuz rexrd simpr infmssuzle sylancr sselda lenltd mpbid ltso supex sylnibr
      vex brcnv supmax eqtrd sylan2br ifbothda ) DUBUCZIHUDUEZUFUCXLDQRUGZUHZUC
      ZXLXKUFXNUIZUCISUJCJUJCSHUKULZUFXNUFXPXLUNXNXPXLUNXQXKXLDTXMUHZUFABCDEFGH
      IJKLMNOPUMZXKXRUBTXMUHUFTDUBXMUOUPUQURXKUSXQDUBUTZXODUBVAXQXTVFZXLXRXNXQX
      LXRUCXTXSVBYAUATDXNXMTXMVCZYATRVCYBVDTRVEVGVHYAXNYADQXNDSQDGVIKVIZVJVKVLV
      MNVIZHVKAVIZVJVKVLVMYEIBUEEVIUGYDVNVOVPVFAYCVQVRNCVRECYCIBUEVSUEVTWCKWAZG
      SWBSPYFGSWDWEZWFWGZXQDWHWNVKZVPZXTXNDUJYJXQDSYIYGWIWJZVHDWHWKWLZWMZWOYLYA
      UAVIZDUJZVFZYNXNRVMZXNYNXMVMYPXNYNVLVMZYQUSYPYJYOYRYKYAYOWPYNDWHWQWRYPXNY
      NYAXNQUJYOYMVBYADQYNDQVPYAYHVHWSWTXAXNYNRQDXMQRVCQXMVCXBQRVEVGXCUAXEXFXDX
      GXHXIXJ $.

    $( The Ramsey number has the Ramsey number property if any number does.
       (Contributed by Mario Carneiro, 20-Apr-2015.) $)
    ramtcl $p |- ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) ->
      ( ( M Ramsey F ) e. T <-> T =/= (/) ) ) $=
      ( cn0 wcel co cv wf w3a cram c0 wne ne0i wa ccnv csup wceq cpnf ramcl2lem
      cr clt cif ifnefalse sylan9eq cc0 cuz cfv wss chash cle wbr csn cima wrex
      cpw cmap wral wi wal crab ssrab2 eqsstri nn0uz sseqtri infmssuzcl eqeltrd
      a1i sylan ex impbid2 ) IQRCJRCQHUAUBZIHUCSZDRZDUDUEZDWEUFWDWGWFWDWGUGWEDU
      MUNUHUIZDWDWGWEDUDUJUKWHUOWHABCDEFGHIJKLMNOPULDUDUKWHUPUQWDDURUSUTZVAZWGW
      HDRWJWDDQWIDGTKTZVBUTVCVDNTZHUTATZVBUTVCVDWMIBSETUHWLVEVFVAUGAWKVHVGNCVGE
      CWKIBSVISVJVKKVLZGQVMQPWNGQVNVOVPVQVTDURVRWAVSWBWC $.

    $( The Ramsey number is an integer iff there is a number with the Ramsey
       number property.  (Contributed by Mario Carneiro, 20-Apr-2015.) $)
    ramtcl2 $p |- ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) ->
      ( ( M Ramsey F ) e. NN0 <-> T =/= (/) ) ) $=
      ( cn0 wcel cpnf cv wf w3a cram co c0 wne wceq clt ccnv csup cif ramcl2lem
      eleq1d pnfnre neli iftrue nn0re syl6bi mtoi necon2ai ramtcl chash cfv cle
      cr wbr csn cima wss wa cpw wrex cmap wral wal crab ssrab2 eqsstri syl6bir
      wi sseli impbid ) IQRCJRCQHUAUBZIHUCUDZQRZDUEUFZWCWEDUEUGZSDVEUHUIUJZUKZQ
      RZWFWCWDWIQABCDEFGHIJKLMNOPULUMWJDUEWGWJSVERZSVEUNUOWGWJSQRWKWGWISQWGSWHU
      PUMSUQURUSUTURWCWFWDDRWEABCDEFGHIJKLMNOPVADQWDDGTKTZVBVCVDVFNTZHVCATZVBVC
      VDVFWNIBUDETUIWMVGVHVIVJAWLVKVLNCVLECWLIBUDVMUDVNVTKVOZGQVPQPWOGQVQVRWAVS
      WB $.

    $( The Ramsey number is a lower bound on the set of all numbers with the
       Ramsey number property.  (Contributed by Mario Carneiro,
       20-Apr-2015.) $)
    ramtub $p |- ( ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) /\ A e. T ) ->
      ( M Ramsey F ) <_ A ) $=
      ( cn0 co cv wcel wf w3a wa cram clt ccnv csup cle wceq cpnf cif ramcl2lem
      cr c0 wn n0i iffalse syl sylan9eq cc0 cuz cfv wss wbr chash csn cima wrex
      cpw cmap wral wi wal crab ssrab2 eqsstri nn0uz sseqtri infmssuzle eqbrtrd
      a1i sylan ) JRUADKUADRIUBUCZBEUAZUDJIUESZEUNUFUGUHZBUIWDWEWFEUOUJZUKWGULZ
      WGACDEFGHIJKLMNOPQUMWEWHUPWIWGUJEBUQWHUKWGURUSUTWDEVAVBVCZVDZWEWGBUIVEWKW
      DERWJEHTLTZVFVCUIVEOTZIVCATZVFVCUIVEWNJCSFTUGWMVGVHVDUDAWLVJVIODVIFDWLJCS
      VKSVLVMLVNZHRVORQWOHRVPVQVRVSWBBEVAVTWCWA $.
  $}

  ${
    $d c f g n s t x C $.  $d c f x G $.  $d c f g s t x ph $.  $d c f s x S $.
    $d c f g n s t x F $.  $d a b c f g i n s t x M $.  $d c f g n s t x R $.
    $d a c f g i n s t x N $.  $d c f g n s t x V $.
    rami.c $e |- C = ( a e. _V , i e. NN0 |->
      { b e. ~P a | ( # ` b ) = i } ) $.
    rami.m $e |- ( ph -> M e. NN0 ) $.
    rami.r $e |- ( ph -> R e. V ) $.
    rami.f $e |- ( ph -> F : R --> NN0 ) $.
    ${
      ramub.n $e |- ( ph -> N e. NN0 ) $.
      ramub.i $e |- ( ( ph /\ ( N <_ ( # ` s ) /\ f : ( s C M ) --> R ) ) ->
        E. c e. R E. x e. ~P s ( ( F ` c ) <_ ( # ` x ) /\
          ( x C M ) C_ ( `' f " { c } ) ) ) $.
      $( The Ramsey number is a lower bound on the set of all numbers with the
         Ramsey number property.  (Contributed by Mario Carneiro,
         22-Apr-2015.) $)
      ramub $p |- ( ph -> ( M Ramsey F ) <_ N ) $=
        ( vn cn0 wcel wf cv chash cfv cle wbr co ccnv csn cima wss wa wrex cmap
        cpw wral wi crab cram elmapi ancom2s expr sylan2 ralrimdva alrimiv wceq
        wal breq1 imbi1d albidv elrab sylanbrc eqid ramtub syl31anc ) AHUBUCDJU
        CDUBGUDIUAUEZKUEZUFUGZUHUIZNUEZGUGBUEZUFUGUHUIWDHCUJEUEZUKWCULUMUNUOBVT
        URUPNDUPZEDVTHCUJZUQUJZUSZUTZKVJZUAUBVAZUCZHGVBUJIUHUIPQRAIUBUCIWAUHUIZ
        WIUTZKVJZWMSAWOKAWNWFEWHWEWHUCAWGDWEUDZWNWFUTWEDWGVCAWQWNWFAWNWQWFTVDVE
        VFVGVHWKWPUAIUBVSIVIZWJWOKWRWBWNWIVSIWAUHVKVLVMVNVOBICDWLEFUAGHJKLMNOWL
        VPVQVR $.
    $}

    ${
      ramub2.n $e |- ( ph -> N e. NN0 ) $.
      ramub2.i $e |- ( ( ph /\ ( ( # ` s ) = N /\
        f : ( s C M ) --> R ) ) -> E. c e. R E. x e. ~P s
          ( ( F ` c ) <_ ( # ` x ) /\ ( x C M ) C_ ( `' f " { c } ) ) ) $.
      $( It is sufficient to check the Ramsey property on finite sets of size
         equal to the upper bound.  (Contributed by Mario Carneiro,
         23-Apr-2015.) $)
      ramub2 $p |- ( ph -> ( M Ramsey F ) <_ N ) $=
        ( vg vt cv chash cfv cle wbr co wf wa c1 cfz cen wss ccnv csn cima wrex
        cpw cdom wex cn0 wcel wceq adantr hashfz1 syl simprl eqbrtrd cfn cvv wb
        fzfid vex hashdom sylancl mpbid domen sylib cin simpll ad2antrl hasheni
        ensym ad2antrr eqtrd simplrr a1i simprr hashbcss syl3anc fssres syl2anc
        cres wi resex feq1 anbi2d cnveq imaeq1d cnvresima syl6eq sseq2d imbi12d
        2rexbidv vtocl syl12anc sstr expcom ad2antll elpw 3imtr4g syl6ss anim2d
        id inss1 anim12d reximdv2 reximdv mpd exlimddv ramub ) ABCDUAFGHIJUBLMN
        OPQRSAIUBUCZUDUEZUFUGZYCHCUHZDUAUCZUIZUJZUJZUKIULUHZKUCZUMUGZYLYCUNZUJZ
        NUCZGUEBUCZUDUEUFUGZYQHCUHZYGUOYPUPZUQZUNZUJZBYCUSZURZNDURZKYJYKYCUTUGZ
        YOKVAYJYKUDUEZYDUFUGZUUGYJUUHIYDUFYJIVBVCZUUHIVDZAUUJYISVEIVFZVGAYEYHVH
        VIYJYKVJVCYCVKVCZUUIUUGVLYJUKIVMUBVNZYKYCVKVOVPVQKYKYCUUNVRVSYJYOUJZYRY
        SUUAYLHCUHZVTZUNZUJZBYLUSZURZNDURZUUFUUOAYLUDUEZIVDZUUPDYGUUPWNZUIZUVBA
        YIYOWAUUOUVCUUHIUUOYLYKUMUGZUVCUUHVDYMUVGYJYNYKYLWDWBYLYKWCVGUUOUUJUUKA
        UUJYIYOSWEUULVGWFUUOYHUUPYFUNZUVFAYEYHYOWGUUOUUMYNHVBVCZUVHUUMUUOUUNWHY
        JYMYNWIAUVIYIYOPWEYCYLCFHVKLMOWJWKYFDUUPYGWLWMAUVDUUPDEUCZUIZUJZUJZYRYS
        UVJUOZYTUQZUNZUJZBUUTURNDURZWOAUVDUVFUJZUJZUVBWOEUVEYGUUPUAVNWPUVJUVEVD
        ZUVMUVTUVRUVBUWAUVLUVSAUWAUVKUVFUVDUUPDUVJUVEWQWRWRUWAUVQUUSNBDUUTUWAUV
        PUURYRUWAUVOUUQYSUWAUVOUVEUOZYTUQUUQUWAUVNUWBYTUVJUVEWSWTUUPYTYGXAXBXCW
        RXEXDTXFXGUUOUVAUUENDUUOUUSUUCBUUTUUDUUOYQUUTVCZYQUUDVCZUUSUUCUUOYQYLUN
        ZYQYCUNZUWCUWDYNUWEUWFWOYJYMUWEYNUWFYQYLYCXHXIXJYQYLBVNZXKYQYCUWGXKXLUU
        OUURUUBYRUURUUBWOUUOUURYSUUQUUAUURXOUUAUUPXPXMWHXNXQXRXSXTYAYB $.
    $}

    rami.x $e |- ( ph -> ( M Ramsey F ) e. NN0 ) $.
    rami.s $e |- ( ph -> S e. W ) $.
    rami.l $e |- ( ph -> ( M Ramsey F ) <_ ( # ` S ) ) $.
    rami.g $e |- ( ph -> G : ( S C M ) --> R ) $.
    $( The defining property of a Ramsey number.  (Contributed by Mario
       Carneiro, 22-Apr-2015.) $)
    rami $p |- ( ph -> E. c e. R E. x e. ~P S
        ( ( F ` c ) <_ ( # ` x ) /\ ( x C M ) C_ ( `' G " { c } ) ) ) $=
      ( vf vs vn co cmap wcel cfv chash cle wbr ccnv csn cima wss cpw wrex wral
      cv wa wf cvv wb ovex elmapg sylancl mpbird cram wal cn0 crab w3a wne eqid
      wi c0 ramtcl2 ramtcl bitr4d syl3anc mpbid wceq breq1 imbi1d elrab simprbi
      albidv syl fveq2 breq2d oveq1 oveq2d pweq rexeqdv rexbidv raleqbidv spcgv
      imbi12d syl3c cnveq imaeq1d sseq2d anbi2d 2rexbidv rspcv sylc ) AHDEICUFZ
      UGUFZUHZNUTZGUIBUTZUJUIUKULZXLICUFZUCUTZUMZXKUNZUOZUPZVAZBEUQZURZNDURZUCX
      IUSZXMXNHUMZXQUOZUPZVAZBYAURNDURZAXJXHDHVBZUBADJUHZXHVCUHXJYJVDQEICVEDXHH
      JVCVFVGVHAEKUHIGVIUFZUDUTZUJUIZUKULZXTBYMUQZURZNDURZUCDYMICUFZUGUFZUSZVPZ
      UDVJZYLEUJUIZUKULZYDTAYLUEUTZYNUKULZUUAVPZUDVJZUEVKVLZUHZUUCAYLVKUHZUUKSA
      IVKUHZYKDVKGVBZUULUUKVDPQRUUMYKUUNVMUULUUJVQVNUUKBCDUUJUCFUEGIJUDLMNOUUJV
      OZVRBCDUUJUCFUEGIJUDLMNOUUOVSVTWAWBUUKUULUUCUUIUUCUEYLVKUUFYLWCZUUHUUBUDU
      UPUUGYOUUAUUFYLYNUKWDWEWHWFWGWIUAUUBUUEYDVPUDEKYMEWCZYOUUEUUAYDUUQYNUUDYL
      UKYMEUJWJWKUUQYRYCUCYTXIUUQYSXHDUGYMEICWLWMUUQYQYBNDUUQXTBYPYAYMEWNWOWPWQ
      WSWRWTYCYIUCHXIXOHWCZXTYHNBDYAUURXSYGXMUURXRYFXNUURXPYEXQXOHXAXBXCXDXEXFX
      G $.
  $}

  ${
    $d c f n s x F $.  $d a b c f i n s x M $.  $d c f n s x R $.
    $d c f n s x V $.
    $( The Ramsey number is either a nonnegative integer or plus infinity.
       (Contributed by Mario Carneiro, 20-Apr-2015.) $)
    ramcl2 $p |- ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) ->
      ( M Ramsey F ) e. ( NN0 u. { +oo } ) ) $=
      ( vn vs vc vx va vi vb vf cn0 wcel co cpnf cv chash cfv wa wf w3a csn cun
      cram cle wbr cvv wceq cpw crab cmpt2 ccnv cima wss wrex cmap wi wal c0 cr
      wral clt csup eqid ramcl2lem iftrue sylan9eq ssun2 pnfxr elexi snss mpbir
      cif cxr syl6eqel wne ssun1 ramtcl2 biimpar sseldi pm2.61dane ) CMNADNAMBU
      AUBZCBUEOZMPUCZUDZNEQFQZRSUFUGGQZBSHQZRSUFUGWICIJUHMKQRSJQUIKIQUJUKULZOLQ
      UMWHUCUNUOTHWGUJUPGAUPLAWGCWJOUQOVBURFUSEMUKZUTWCWKUTUIZTWDPWFWCWLWDWLPWK
      VAVCUMVDZVNPHWJAWKLJEBCDFIKGWJVEZWKVEZVFWLPWMVGVHPWFNWEWFUOWEMVIPWFPVOVJV
      KVLVMVPWCWKUTVQZTMWFWDMWEVRWCWDMNWPHWJAWKLJEBCDFIKGWNWOVSVTWAWB $.
  $}

  $( The Ramsey number is an extended real number.  (This theorem does not
     imply Ramsey's theorem, unlike ~ ramcl .)  (Contributed by Mario Carneiro,
     20-Apr-2015.) $)
  ramxrcl $p |- ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) ->
    ( M Ramsey F ) e. RR* ) $=
    ( cn0 wcel wf w3a cpnf csn cun cxr cram co nn0ssre ressxr sstri wss pnfxr
    cr snssi ax-mp unssi ramcl2 sseldi ) CEFADFAEBGHEIJZKLCBMNEUFLETLOPQILFUFLR
    SILUAUBUCABCDUDUE $.

  $( If the Ramsey number is upper bounded, then it is an integer.
     (Contributed by Mario Carneiro, 20-Apr-2015.) $)
  ramubcl $p |- ( ( ( M e. NN0 /\ R e. V /\ F : R --> NN0 ) /\
    ( A e. NN0 /\ ( M Ramsey F ) <_ A ) ) -> ( M Ramsey F ) e. NN0 ) $=
    ( cn0 wcel wf w3a cram co cle wbr wa cpnf csn wceq wn cr cxr nn0re ltpnf wb
    rexr pnfxr xrltnle sylancl mpbid ad2antrl simprr breq1 syl5ibcom mtod elsni
    clt syl nsyl cun wo ramcl2 adantr elun sylib ord mt3d ) DFGBEGBFCHIZAFGZDCJ
    KZALMZNZNZVHFGZVHOPZGZVKVHOQZVNVKVOOALMZVGVPRZVFVIVGASGZVQAUAVRAOUOMZVQAUBV
    RATGOTGVSVQUCAUDUEAOUFUGUHUPUIVKVIVOVPVFVGVIUJVHOALUKULUMVHOUNUQVKVLVNVKVHF
    VMURGZVLVNUSVFVTVJBCDEUTVAVHFVMVBVCVDVE $.

  ${
    $d c x C $.  $d c x F $.  $d c x G $.  $d a b c i x M $.  $d c x ph $.
    $d c x N $.  $d c x R $.  $d c x V $.
    ramlb.c $e |- C = ( a e. _V , i e. NN0 |->
      { b e. ~P a | ( # ` b ) = i } ) $.
    ramlb.m $e |- ( ph -> M e. NN0 ) $.
    ramlb.r $e |- ( ph -> R e. V ) $.
    ramlb.f $e |- ( ph -> F : R --> NN0 ) $.
    ramlb.s $e |- ( ph -> N e. NN0 ) $.
    ramlb.g $e |- ( ph -> G : ( ( 1 ... N ) C M ) --> R ) $.
    ramlb.i $e |- ( ( ph /\ ( c e. R /\ x C_ ( 1 ... N ) ) ) ->
      ( ( x C M ) C_ ( `' G " { c } ) -> ( # ` x ) < ( F ` c ) ) ) $.
    $( Establish a lower bound on a Ramsey number.  (Contributed by Mario
       Carneiro, 22-Apr-2015.) $)
    ramlb $p |- ( ph -> N < ( M Ramsey F ) ) $=
      ( cram co clt wbr cle wn wa cv cfv chash ccnv csn cima wss c1 cfz cpw cfn
      wrex cn0 wcel adantr simpr ramubcl syl32anc fzfid wceq hashfz1 syl breq2d
      wf biimpar rami wi elpwi adantlr simprr ssfi syl2anc hashcl simpl ffvelrn
      nn0red syl2an ltnled sylibd sylanr2 con2d imnan sylib rexlimdvva pm2.01da
      pm2.21d mpd cxr wb rexrd ramxrcl syl3anc xrltnle mpbird ) AIHFUAUBZUCUDZX
      BIUEUDZUFZAXDAXDUGZMUHZFUIZBUHZUJUIZUEUDZXIHCUBGUKXGULUMUNZUGZBUOIUPUBZUQ
      ZUSMDUSXEXFBCDXNEFGHJURKLMNAHUTVAZXDOVBZADJVAZXDPVBZADUTFVKZXDQVBZXFXPXRX
      TIUTVAZXDXBUTVAXQXSYAAYBXDRVBAXDVCIDFHJVDVEXFUOIVFAXBXNUJUIZUEUDXDAYCIXBU
      EAYBYCIVGRIVHVIVJVLAXNHCUBDGVKXDSVBVMXFXMXEMBDXOXFXGDVAZXIXOVAZUGUGZXMXEY
      FXKXLUFVNXMUFYFXLXKYEXFYDXIXNUNZXLXKUFZVNXIXNVOXFYDYGUGZUGZXLXJXHUCUDZYHA
      YIXLYKVNXDTVPYJXJXHYJXJYJXIURVAZXJUTVAYJXNURVAYGYLYJUOIVFXFYDYGVQXNXIVRVS
      XIVTVIWCYJXHXFXTYDXHUTVAYIYAYDYGWADUTXGFWBWDWCWEWFWGWHXKXLWIWJWMWKWNWLAIW
      OVAXBWOVAZXCXEWPAIAIRWCWQAXPXRXTYMOPQDFHJWRWSIXBWTVSXA $.
  $}

  ${
    $d b d z $.  $d c f s x C $.  $d a b c f i s x M $.  $d c d f s x y z R $.
    $d a c d f i s x y z F $.  $d c d f s x z V $.
    $( The Ramsey number when ` M = 0 ` .  (Contributed by Mario Carneiro,
       22-Apr-2015.) $)
    0ram $p |- ( ( ( R e. V /\ R =/= (/) /\ F : R --> NN0 ) /\ E. x e. ZZ
      A. y e. ran F y <_ x ) -> ( 0 Ramsey F ) = sup ( ran F , RR , < ) ) $=
      ( va vc wcel c0 cn0 cv cle wbr wa cc0 wceq cvv cfv wss adantr vz vi vb vf
      vs vd wne wf w3a crn wral cz wrex cram co cr clt csup chash cpw crab eqid
      cmpt2 0nn0 a1i simpl1 simpl3 frn syl nn0ssz syl6ss cdm fdm simpl2 eqnetrd
      dm0rn0 necon3bii sylib simpr suprzcl2 syl3anc sseldd csn ccnv vex hashbc0
      cima ax-mp feq2i biimpi simprr 0ex snid ffvelrn sylancl pwid nn0red rexrd
      ffvelrnd cxr hashxrcl mp1i wfn fnfvelrn syl2anc suprzub simprl xrletrd wb
      fvex elpreima 3syl mpbir2and fveq2 breq1d sseq1i snss bitr4i sneq imaeq2d
      ffn eleq2d syl5bb anbi12d breq2d anbi1d rspc2ev syl112anc sylanr2 fvelrnb
      ramub mpbid cn c1 cmin cfz cfn mpbird syl5ibcom breq1 cop simpll1 simpll3
      nnm1nn0 ad2antll wf1o f1osn f1of snssd fss sylancr ovex sylibr cdom fzfid
      ssdomg sylc ssfi hashdom hashfz1 breqtrd ffvelrnda adantrr nn0ltlem1 fvsn
      hashcl f1ofn simprbi syl5eqelr elsni fveq2d syl5bi ramlb ramubcl syl32anc
      mp2b nn0lem1lt expr nn0ge0d syl5ibrcom elnn0 mpjaod rexlimdva mpd letri3d
      wo ) CEHZCIUGZCJDUHZUIZBKAKLMBDUJZUKAULUMZNZODUNUOZUWKUPUQURZPUWNUWOLMZUW
      OUWNLMZUWMUAFUBQJUCKUSRUBKPUCFKUTVAVCZCUDUBDOUWOEUEFUCGUWRVBZOJHZUWMVDVEZ
      UWGUWHUWIUWLVFZUWGUWHUWIUWLVGZUWMUWKJUWOUWMUWIUWKJSUXCCJDVHVIZUWMUWKULSZU
      WKIUGZUWLUWOUWKHZUWMUWKJULUXDVJVKZUWMDVLZIUGUXFUWMUXICIUWMUWIUXICPUXCCJDV
      MVIUWGUWHUWIUWLVNVOUXIIUWKIDVPVQVRUWJUWLVSZABUWKVTWAZWBZUEKZOUWRUOZCUDKZU
      HZUWMUWOUXMUSRZLMZIWCZCUXOUHZGKZDRZUAKZUSRZLMZUYCOUWRUOZUXOWDZUYAWCZWGZSZ
      NZUAUXMUTZUMGCUMZUXPUXTUXNUXSCUXOUXMQHZUXNUXSPUEWEZUXMUWRUBQFUCUWSWFWHWIW
      JUWMUXRUXTNZNZIUXORZCHZUXMUYLHZUYRDRZUXQLMZIUYGUYRWCZWGZHZUYMUYQUXTIUXSHZ
      UYSUWMUXRUXTWKZIWLWMZUXSCIUXOWNWOZUYTUYQUXMUYOWPVEUYQVUAUWOUXQUYQVUAUYQVU
      AUYQCJUYRDUWMUWIUYPUXCTZVUIWSWQWRUWMUWOWTHUYPUWMUWOUWMUWOUXLWQZWRTUYNUXQW
      THUYQUYOUXMQXAXBUYQUXEUWLVUAUWKHZVUAUWOLMUWMUXEUYPUXHTUWMUWLUYPUXJTUYQDCX
      CZUYSVULUYQUWIVUMVUJCJDYAZVIVUICUYRDXDXEABUWKVUAXFWAUWMUXRUXTXGXHUYQVUEVU
      FUYRVUCHZVUFUYQVUHVEVUOUYQUYRIUXOXJWMVEUYQUXTUXOUXSXCVUEVUFVUONXIVUGUXSCU
      XOYAUXSIVUCUXOXKXLXMUYKVUBVUENVUAUYDLMZVUENGUAUYRUXMCUYLUYAUYRPZUYEVUPUYJ
      VUEVUQUYBVUAUYDLUYAUYRDXNXOUYJIUYIHZVUQVUEUYJUXSUYISVURUYFUXSUYIUYCQHUYFU
      XSPUAWEUYCUWRUBQFUCUWSWFWHZXPIUYIWLXQXRVUQUYIVUDIVUQUYHVUCUYGUYAUYRXSXTYB
      YCYDUYCUXMPZVUPVUBVUEVUTUYDUXQVUALUYCUXMUSXNYEYFYGYHYIYKZUWMUYBUWOPZGCUMZ
      UWQUWMUXGVVCUXKUWMUWIVUMUXGVVCXIUXCVUNGCUWODYJXLYLUWMVVBUWQGCUWMUYACHZNZU
      YBUWNLMZVVBUWQVVEUYBYMHZVVFUYBOPZUWMVVDVVGVVFUWMVVDVVGNZNZVVFUYBYNYOUOZUW
      NUQMZVVJUAUWRCUBDIUYAUUAWCZOVVKEFUCUFUWSUWTVVJVDVEUWGUWHUWIUWLVVIUUBUWGUW
      HUWIUWLVVIUUCVVGVVKJHZUWMVVDUYBUUDUUEZVVJUXSCVVMUHZYNVVKYPUOZOUWRUOZCVVMU
      HVVJUXSUYHVVMUHZUYHCSVVPUXSUYHVVMUUFZVVSIUYAWLGWEZUUGZUXSUYHVVMUUHWHVVJUY
      ACUWMVVDVVGXGUUIUXSUYHCVVMUUJUUKVVRUXSCVVMVVQQHVVRUXSPYNVVKYPUULVVQUWRUBQ
      FUCUWSWFWHWIUUMUYFVVMWDUFKZWCZWGZSZIVWEHZVVJVWCCHZUYCVVQSZNZNZUYDVWCDRZUQ
      MZVWFUXSVWESVWGUYFUXSVWEVUSXPIVWEWLXQXRVWKUYDUYBUQMZVWGVWMVWKVWNUYDVVKLMZ
      VWKUYDVVQUSRZVVKLVWKUYDVWPLMZUYCVVQUUNMZVWKVVQYQHZVWIVWRVWKYNVVKUUOZVVJVW
      HVWIWKZUYCVVQYQUUPUUQVWKUYCYQHZVWSVWQVWRXIVWKVWSVWIVXBVWTVXAVVQUYCUURXEZV
      WTUYCVVQYQUUSXEYRVWKVVNVWPVVKPVVJVVNVWJVVOTVVKUUTVIUVAVWKUYDJHZUYBJHZVWNV
      WOXIVWKVXBVXDVXCUYCUVFVIVVJVXEVWJUWMVVDVXEVVGUWMCJUYADUXCUVBZUVCZTUYDUYBU
      VDXEYRVWGUYBVWLUYDUQVWGUYAVWCDVWGUYAVWDHUYAVWCPVWGUYAIVVMRZVWDIUYAWLVWAUV
      EVWGVUFVXHVWDHZVVTVVMUXSXCVWGVUFVXINXIVWBUXSUYHVVMUVGUXSIVWDVVMXKUVPUVHUV
      IUYAVWCUVJVIUVKYEYSUVLUVMVVJVXEUWNJHZVVFVVLXIVXGUWMVXJVVIUWMUWTUWGUWIUWOJ
      HUWPVXJUXAUXBUXCUXLVVAUWOCDOEUVNUVOZTUYBUWNUVQXEYRUVRVVEVVFVVHOUWNLMVVEUW
      NUWMVXJVVDVXKTUVSUYBOUWNLYTUVTVVEVXEVVGVVHUWFVXFUYBUWAVRUWBUYBUWOUWNLYTYS
      UWCUWDUWMUWNUWOUWMUWNVXKWQVUKUWEXM $.

    $( The Ramsey number when ` M = 0 ` .  (Contributed by Mario Carneiro,
       22-Apr-2015.) $)
    0ram2 $p |- ( ( R e. Fin /\ R =/= (/) /\ F : R --> NN0 ) ->
      ( 0 Ramsey F ) = sup ( ran F , RR , < ) ) $=
      ( vy vx cfn wcel c0 wne cn0 wf w3a cv cz wrex cr wceq wss 3ad2ant3 syl6ss
      sylib cle wbr crn wral cc0 cram clt csup frn nn0ssz nn0ssre wfo simp1 wfn
      co ffn dffn4 fofi syl2anc cdm fdm simp2 eqnetrd necon3bii fimaxre syl3anc
      dm0rn0 ssrexv sylc 0ram mpdan ) AEFZAGHZAIBJZKZCLDLUAUBCBUCZUDZDMNZUEBUFU
      OVPOUGUHPVOVPMQVQDVPNZVRVOVPIMVNVLVPIQVMAIBUIRZUJSVOVPOQVPEFZVPGHZVSVOVPI
      OVTUKSVOVLAVPBULZWAVLVMVNUMVOBAUNZWCVNVLWDVMAIBUPRABUQTAVPBURUSVOBUTZGHWB
      VOWEAGVNVLWEAPVMAIBVARVLVMVNVBVCWEGVPGBVGVDTDCVPVEVFVQDVPMVHVIDCABEVJVK
      $.

    $( The Ramsey number when ` R = (/) ` .  (Contributed by Mario Carneiro,
       22-Apr-2015.) $)
    ram0 $p |- ( M e. NN0 -> ( M Ramsey (/) ) = M ) $=
      ( vx va vi vb cn0 wcel c0 co wceq cle wbr cvv cv chash cfv a1i wa c1 cc0
      vf vs vc cram cpw crab cmpt2 eqid id 0ex wf f0 ccnv csn cima wss wrex f00
      vex simpl hashbcval sylancr wne wex cfz cen hashfz1 breq1d biimpar cfn wb
      cdom fzfid hashdom sylancl mpbid domen sylib simprr elpw hasheni ad2antrl
      sylibr ad2antrr eqtr3d jca eximdv mpd df-rex rabn0 eqnetrd neneqd pm2.21d
      ex adantld syl5bi impr ramub cn wi cmin clt nnnn0 nnm1nn0 hashbc2 syl2anc
      cbc syl oveq1d cz wo nnz nnre ltm1d olcd bcval4 syl3anc 3eqtrd ovex ax-mp
      hasheq0 feq2d mpbiri noel pm2.21i ramlb ramubcl syl32anc nn0lem1lt mpbird
      nn0ge0d breq1 syl5ibrcom elnn0 biimpi mpjaod nn0red letri3d mpbir2and
      nn0re ) AFGZAHUDIZAJUUBAKLZAUUBKLZUUABCDMFENOPDNJECNUEUFUGZHUADHAAMUBCEUC
      UUEUHZUUAUIZHMGZUUAUJQZHFHUKZUUAFULZQZUUGUUAAUBNZOPZKLZUUMAUUEIZHUANZUKZU
      CNZHPZBNZOPZKLUVAAUUEIZUUQUMUUSUNZUOUPRBUUMUEZUQUCHUQZUURUUQHJZUUPHJZRUUA
      UUORZUVFUUPUUQURUVIUVHUVFUVGUVIUVHUVFUVIUUPHUVIUUPUVBAJZBUVEUFZHUVIUUMMGZ
      UUAUUPUVKJUBUSZUUAUUOUTBUUMUUEDAMCEUUFVAVBUVIUVJBUVEUQZUVKHVCUVIUVAUVEGZU
      VJRZBVDZUVNUVISAVEIZUVAVFLZUVAUUMUPZRZBVDZUVQUVIUVRUUMVLLZUWBUVIUVROPZUUN
      KLZUWCUUAUWEUUOUUAUWDAUUNKAVGZVHVIUVIUVRVJGUVLUWEUWCVKUVISAVMUVMUVRUUMMVN
      VOVPBUVRUUMUVMVQVRUVIUWAUVPBUVIUWAUVPUVIUWARZUVOUVJUWGUVTUVOUVIUVSUVTVSUV
      AUUMBUSVTWCUWGUWDUVBAUVSUWDUVBJUVIUVTUVRUVAWAWBUUAUWDAJUUOUWAUWFWDWEWFWNW
      GWHUVJBUVEWIWCUVJBUVEWJWCWKWLWMWOWPWQWRZUUAAWSGZUUDATJZUWIUUDWTUUAUWIUUDA
      SXAIZUUBXBLZUWIBUUEHDHHAUWKMCEUCUUFAXCZUUHUWIUJQUUJUWIUUKQAXDZUWISUWKVEIZ
      AUUEIZHHUKHHHUKHULUWIUWPHHHUWIUWPOPZTJZUWPHJZUWIUWQUWOOPZAXGIZUWKAXGIZTUW
      IUWOVJGUUAUWQUXAJUWISUWKVMUWMUWOUUEDACEUUFXEXFUWIUWTUWKAXGUWIUWKFGZUWTUWK
      JUWNUWKVGXHXIUWIUXCAXJGATXBLZUWKAXBLZXKUXBTJUWNAXLUWIUXEUXDUWIAAXMXNXOAUW
      KXPXQXRUWPMGUWRUWSVKUWOAUUEXSUWPMYAXTVRYBYCUUSHGZUVCHUMUVDUOUPUVBUUTXBLWT
      ZUWIUVAUWOUPUXFUXGUUSYDYEWBYFUWIUUAUUBFGZUUDUWLVKUWMUWIUUAUXHUWMUUAUUAUUH
      UUJUUAUUCUXHUUGUUIUULUUGUWHAHHAMYGYHZXHAUUBYIXFYJQUUAUUDUWJTUUBKLUUAUUBUX
      IYKATUUBKYLYMUUAUWIUWJXKAYNYOYPUUAUUBAUUAUUBUXIYQAYTYRYS $.

    $( Lemma for ~ ramcl :  Existence of the Ramsey number when ` M = 0 ` .
       (Contributed by Mario Carneiro, 23-Apr-2015.) $)
    0ramcl $p |- ( ( R e. Fin /\ F : R --> NN0 ) -> ( 0 Ramsey F ) e. NN0 ) $=
      ( vy vx cfn wcel cn0 wa cc0 cram co c0 wceq wfo sylib wne cr wss 3ad2ant3
      cz wf crn wfn ffn dffn4 ad2antlr wb foeq2 adantl mpbid simplbi syl oveq2d
      fo00 0nn0 ram0 ax-mp eqeltri syl6eqel w3a clt csup 0ram2 frn cle wbr wral
      cv wrex nn0ssz syl6ss cdm fdm simp2 eqnetrd dm0rn0 necon3bii nn0ssre fofi
      simp1 syl2anc fimaxre syl3anc ssrexv sylc sseldd eqeltrd 3expa pm2.61dane
      suprzcl2 an32s ) AEFZAGBUAZHZIBJKZGFZALWNALMZHZWOILJKZGWRBLIJWRLBUBZBNZBL
      MZWRAWTBNZXAWMXCWLWQWMBAUCXCAGBUDABUEOZUFWQXCXAUGWNALWTBUHUIUJXAXBWTLMWTB
      UNUKULUMWSIGIGFWSIMUOIUPUQUOURUSWLALPZWMWPWLXEWMWPWLXEWMUTZWOWTQVAVBZGABV
      CXFWTGXGWMWLWTGRXEAGBVDSZXFWTTRZWTLPZCVHDVHVEVFCWTVGZDTVIZXGWTFXFWTGTXHVJ
      VKZXFBVLZLPXJXFXNALWMWLXNAMXEAGBVMSWLXEWMVNVOXNLWTLBVPVQOZXFXIXKDWTVIZXLX
      MXFWTQRWTEFZXJXPXFWTGQXHVRVKXFWLXCXQWLXEWMVTWMWLXCXEXDSAWTBVSWAXODCWTWBWC
      XKDWTTWDWEDCWTWJWCWFWGWHWKWI $.

    $( The Ramsey number when ` F ` has value zero for some color ` C ` .
       (Contributed by Mario Carneiro, 22-Apr-2015.) $)
    ramz2 $p |- ( ( ( M e. NN /\ R e. V /\ F : R --> NN0 ) /\
      ( C e. R /\ ( F ` C ) = 0 ) ) -> ( M Ramsey F ) = 0 ) $=
      ( vx va vi vb wcel cn0 cfv cc0 wceq wa cle wbr cv chash c0 vf vs vc cn wf
      w3a cram co cvv cpw crab cmpt2 eqid simpl1 nnnn0d simpl2 simpl3 0nn0 ccnv
      a1i csn cima wss wrex simplrl 0elpw simplrr 0le0 syl6eqbr simpll1 0hashbc
      syl syl6eqss fveq2 breq1d sneq imaeq2d sseq2d anbi12d hash0 syl6eq breq2d
      0ss oveq1 sseq1d rspc2ev syl112anc ramub ramubcl syl32anc nn0le0eq0 mpbid
      wb ) DUDJZBEJZBKCUEZUFZABJZACLZMNZOZOZDCUGUHZMPQZXCMNZXBFGHUIKIRSLHRNIGRU
      JUKULZBUAHCDMEUBGIUCXFUMZXBDWNWOWPXAUNUOZWNWOWPXAUPZWNWOWPXAUQZMKJZXBURUT
      ZXBMUBRZSLPQXMDXFUHBUARZUEOZOZWRTXMUJZJZWSMPQZTDXFUHZXNUSZAVAZVBZVCZUCRZC
      LZFRZSLZPQZYGDXFUHZYAYEVAZVBZVCZOZFXQVDUCBVDWQWRWTXOVEXRXPXMVFUTXPWSMMPWQ
      WRWTXOVGVHVIXPXTTYCXPWNXTTNWNWOWPXAXOVJXFHDGIXGVKVLYCWCVMYNXSYDOWSYHPQZYJ
      YCVCZOUCFATBXQYEANZYIYOYMYPYQYFWSYHPYEACVNVOYQYLYCYJYQYKYBYAYEAVPVQVRVSYG
      TNZYOXSYPYDYRYHMWSPYRYHTSLMYGTSVNVTWAWBYRYJXTYCYGTDXFWDWEVSWFWGWHZXBXCKJZ
      XDXEWMXBDKJWOWPXKXDYTXHXIXJXLYSMBCDEWIWJXCWKVLWL $.

    $( The Ramsey number when ` F ` is the zero function.  (Contributed by
       Mario Carneiro, 22-Apr-2015.) $)
    ramz $p |- ( ( M e. NN0 /\ R e. V /\ R =/= (/) ) ->
      ( M Ramsey ( R X. { 0 } ) ) = 0 ) $=
      ( vc vy vx cn0 wcel cc0 cram co wceq wa cv a1i cr clt cle wral cz wne csn
      c0 cxp cn wo wi elnn0 wex n0 wf cfv simpll simplr fconst6 simpr fvconst2g
      0nn0 sylancr ramz2 syl32anc ex exlimdv syl5bi expimpd crn csup wrex simpl
      wbr 0z elsni 0le0 syl6eqbr rgen rnxp adantl raleqdv mpbiri ralbidv rspcev
      breq2 0ram syl31anc supeq1d wor ltso 0re supsn mp2an 3eqtrd oveq1 syl5ibr
      eqeq1d jaoi sylbi 3impib ) BGHZACHZAUCUAZBAIUBZUDZJKZILZWRBUEHZBILZUFWSWT
      MZXDUGZBUHXEXHXFXEWSWTXDWTDNZAHZDUIXEWSMZXDDAUJXKXJXDDXKXJXDXKXJMZXEWSAGX
      BUKZXJXIXBULILZXDXEWSXJUMXEWSXJUNXMXLAIGURUOZOXKXJUPZXLIGHXJXNURXPAIXIGUQ
      USXIAXBBCUTVAVBVCVDVEXGXDXFIXBJKZILXGXQXBVFZPQVGZXAPQVGZIXGWSWTXMENZFNZRV
      JZEXRSZFTVHZXQXSLWSWTVIWSWTUPXMXGXOOXGITHYAIRVJZEXRSZYEVKXGYGYFEXASYFEXAY
      AXAHYAIIRYAIVLVMVNVOXGYFEXRXAWTXRXALWSAXAVPVQZVRVSYDYGFITYBILYCYFEXRYBIYA
      RWBVTWAUSFEAXBCWCWDXGPXRXAQYHWEXTILZXGPQWFIPHYIWGWHPIQWIWJOWKXFXCXQIBIXBJ
      WLWNWMWOWPWQ $.
  $}

  ${
    $d u x D $.  $d c d f s u v w x y z F $.  $d a b c d f i s u v w x y z M $.
    $d a c d f i s u v w x y z G $.  $d c d f s u v w x y z R $.  $d a i u W $.
    $d c d f s u v w x y z ph $.  $d a c d i u v w x y z S $.  $d a i x z V $.
    $d c d u v w x y z C $.  $d c d u v w x y z H $.  $d c d u v w x y z K $.
    $d x z E $.  $d a c d i u v w x y z X $.
    ramub1.m $e |- ( ph -> M e. NN ) $.
    ramub1.r $e |- ( ph -> R e. Fin ) $.
    ramub1.f $e |- ( ph -> F : R --> NN ) $.
    ramub1.g $e |- G = ( x e. R |-> ( M Ramsey ( y e. R |->
      if ( y = x , ( ( F ` x ) - 1 ) , ( F ` y ) ) ) ) ) $.
    ramub1.1 $e |- ( ph -> G : R --> NN0 ) $.
    ramub1.2 $e |- ( ph -> ( ( M - 1 ) Ramsey G ) e. NN0 ) $.
    ${
      ramub1.3 $e |- C = ( a e. _V , i e. NN0 |->
        { b e. ~P a | ( # ` b ) = i } ) $.
      ramub1.4 $e |- ( ph -> S e. Fin ) $.
      ramub1.5 $e |- ( ph -> ( # ` S ) = ( ( ( M - 1 ) Ramsey G ) + 1 ) ) $.
      ramub1.6 $e |- ( ph -> K : ( S C M ) --> R ) $.
      ramub1.x $e |- ( ph -> X e. S ) $.
      ramub1.h $e |- H = ( u e. ( ( S \ { X } ) C ( M - 1 ) ) |->
        ( K ` ( u u. { X } ) ) ) $.
      ${
        ramub1.d $e |- ( ph -> D e. R ) $.
        ramub1.w $e |- ( ph -> W C_ ( S \ { X } ) ) $.
        ramub1.7 $e |- ( ph -> ( G ` D ) <_ ( # ` W ) ) $.
        ramub1.8 $e |- ( ph -> ( W C ( M - 1 ) ) C_ ( `' H " { D } ) ) $.
        ramub1.e $e |- ( ph -> E e. R ) $.
        ramub1.v $e |- ( ph -> V C_ W ) $.
        ramub1.9 $e |- ( ph ->
          if ( E = D , ( ( F ` D ) - 1 ) , ( F ` E ) ) <_ ( # ` V ) ) $.
        ramub1.s $e |- ( ph -> ( V C M ) C_ ( `' K " { E } ) ) $.
        $( Lemma for ~ ramub1 .  (Contributed by Mario Carneiro,
           23-Apr-2015.) $)
        ramub1lem1 $p |- ( ph -> E. z e. ~P S
          ( ( F ` E ) <_ ( # ` z ) /\ ( z C M ) C_ ( `' K " { E } ) ) ) $=
          ( cfv cv chash cle wbr co ccnv csn cima wss wa cpw wrex wceq cun wcel
          cdif sstrd difss2d snssd unssd cfn wb elpw2g mpbird adantr caddc cmin
          syl c1 cif iftrue adantl eqbrtrrd ffvelrnd nnred 1re a1i ssfi syl2anc
          cn cr cn0 hashcl nn0re 3syl lesubaddd mpbid fveq2 wn hashunsng mp2and
          snidg wi crab sylancl hashbcval simpl1l eqsstr3d simpr rabid sylanbrc
          simpl3 sseldd elpw sylibr sylib cvv fveq2d eqtr3d eqeq1d elrab breq2d
          cc oveq1 sseq1d anbi12d rspcev syl12anc sseld eldifn syl6 mt2d nnnn0d
          breqan12rd snfi w3a simpl2 elpwid vex eleqtrrd nnm1nn0 uncom syl6sseq
          ssundif difexg ax-mp diffi nn0cn ax-1cn pncan neldifsnd undif1 eldifd
          unfi elpwunsn ssequn2 syl5req mptiniseg eleqtrd uneq1 simprbi simpl1r
          oveq1d 3eqtr4d wfn ffn fniniseg mpbir2and pm2.61dan rabssdv ifnefalse
          wf eqsstrd wne pm2.61dane ) AKLVBZDVCZVDVBZVEVFZUWIPFVGZOVHKVIVJZVKZV
          LZDIVMZVNZKGAKGVOZVLZQSVIZVPZUWPVQZUWHUXAVDVBZVEVFZUXAPFVGZUWMVKZUWQA
          UXBUWRAUXBUXAIVKZAQUWTIAQIUWTAQRIUWTVRZUSUOVSZVTZASIULWAWBZAIWCVQZUXB
          UXGWDUIUXAIWCWEWJWFWGUWSUXDGLVBZQVDVBZWKWHVGZVEVFZUWSUXMWKWIVGZUXNVEV
          FUXPUWSUWRUXQUWHWLZUXQUXNVEUWRUXRUXQVOAUWRUXQUWHWMWNAUXRUXNVEVFZUWRUT
          WGWOUWSUXMWKUXNUWSUXMAUXMXBVQUWRAHXBGLUDUNWPWGWQWKXCVQUWSWRWSAUXNXCVQ
          ZUWRAQWCVQZUXNXDVQUXTAUXLQIVKZUYAUIUXJIQWTXAZQXEUXNXFXGWGXHXIUWRAUWHU
          XMUXCUXOVEKGLXJAUYASQVQZXKZUXCUXOVOZUYCAUYDSUWTVQZASIVQZUYGULSIXNWJAU
          YDSUXHVQUYGXKAQUXHSUXIUUASIUWTUUBUUCUUDAUYHUYAUYEVLUYFXOULQSIXLWJXMUU
          FWFUWSUXEBVCZVDVBZPVOZBUXAVMZXPZUWMAUXEUYMVOZUWRAUXAWCVQZPXDVQZUYNAUY
          AUWTWCVQUYOUYCSUUGQUWTUVFXQAPUBUUEZBUXAFJPWCTUAUHXRXAWGUWSUYKBUYLUWMU
          WSUYIUYLVQZUYKUUHZUYIQVMZVQZUYIUWMVQZUYSVUAVLZUYKBUYTXPZUWMUYIVUCAVUD
          UWMVKAUWRUYRUYKVUAXSAVUDQPFVGZUWMAUYAUYPVUEVUDVOUYCUYQBQFJPWCTUAUHXRX
          AVAXTWJVUCVUAUYKUYIVUDVQUYSVUAYAUWSUYRUYKVUAYDUYKBUYTYBYCYEUYSVUAXKZV
          LZVUBUYIIPFVGZVQZUYIOVBZKVOZVUGUYIUYKBUWPXPZVUHVUGUYIUWPVQZUYKUYIVULV
          QVUGUYIIVKZVUMVUGUYIUXAIVUGUYIUXAUWSUYRUYKVUFUUIZUUJZVUGAUXGAUWRUYRUY
          KVUFXSZUXKWJVSZUYIIBUUKZYFYGUWSUYRUYKVUFYDZUYKBUWPYBYCVUGAVUHVULVOZVU
          QAUXLUYPVVAUIUYQBIFJPWCTUAUHXRXAWJUULVUGUYIUWTVRZUWTVPZOVBZGVUJKVUGVV
          BEVCZUWTVPZOVBZGVOZEUXHPWKWIVGZFVGZXPZVQZVVDGVOZVUGVVBNVHGVIVJZVVKVUG
          VVEVDVBZVVIVOZERVMZXPZVVNVVBVUGAVVRVVNVKVUQAVVRRVVIFVGZVVNARWCVQZVVIX
          DVQZVVSVVRVOAUXLRIVKVVTUIARIUWTUOVTIRWTXAAPXBVQVWAUBPUUMWJERFJVVIWCTU
          AUHXRXAUQXTWJVUGVVBVVQVQZVVBVDVBZVVIVOZVVBVVRVQVUGVVBRVKVWBVUGVVBQRVU
          GUYIUWTQVPZVKVVBQVKVUGUYIUXAVWEVUPQUWTUUNUUOUYIUWTQUUPYHVUGAQRVKVUQUS
          WJVSVVBRUYIYIVQVVBYIVQVUSUYIUWTYIUUQUURYFYGVUGVWCWKWHVGZWKWIVGZVWCVVI
          VUGVWCYOVQZWKYOVQVWGVWCVOVUGVVBWCVQZVWCXDVQVWHVUGUYIWCVQZVWIVUGUXLVUN
          VWJVUGAUXLVUQUIWJVURIUYIWTXAUYIUWTUUSWJZVVBXEVWCUUTXGUVAVWCWKUVBXQVUG
          VWFPWKWIVUGVVCVDVBZVWFPVUGVWISVVBVQXKZVWLVWFVOZVWKVUGSUYIUVCVUGAUYHVW
          IVWMVLVWNXOVUQULVVBSIXLXGXMVUGUYJVWLPVUGUYIVVCVDVUGVVCUYIUWTVPZUYIUYI
          UWTUVDVUGUWTUYIVKVWOUYIVOVUGSUYIVUGUYIUYLUYTVRVQSUYIVQVUGUYIUYLUYTVUO
          UYSVUFYAUVEUYIQSUVGWJWAUWTUYIUVHYHUVIZYJVUTYKYKUVOYKVVPVWDEVVBVVQVVEV
          VBVOZVVOVWCVVIVVEVVBVDXJYLYMYCYEVUGAGHVQVVNVVKVOVUQUNEVVJVVGGNHUMUVJX
          GUVKVVLVVBVVJVQVVMVVHVVMEVVBVVJVWQVVGVVDGVWQVVFVVCOVVEVVBUWTUVLYJYLYM
          UVMWJVUGUYIVVCOVWPYJAUWRUYRUYKVUFUVNUVPVUGAOVUHUVQZVUBVUIVUKVLWDVUQAV
          UHHOUWDVWRUKVUHHOUVRWJVUHKUYIOUVSXGUVTUWAUWBUWEUWOUXDUXFVLDUXAUWPUWIU
          XAVOZUWKUXDUWNUXFVWSUWJUXCUWHVEUWIUXAVDXJYNVWSUWLUXEUWMUWIUXAPFYPYQYR
          YSYTAKGUWFZVLZQUWPVQZUWHUXNVEVFZVUEUWMVKZUWQAVXBVWTAVXBUYBUXJAUXLVXBU
          YBWDUIQIWCWEWJWFWGVXAUXRUWHUXNVEVWTUXRUWHVOAKGUXQUWHUWCWNAUXSVWTUTWGW
          OAVXDVWTVAWGUWOVXCVXDVLDQUWPUWIQVOZUWKVXCUWNVXDVXEUWJUXNUWHVEUWIQVDXJ
          YNVXEUWLVUEUWMUWIQPFYPYQYRYSYTUWG $.
      $}

      $( Lemma for ~ ramub1 .  (Contributed by Mario Carneiro, 23-Apr-2015.) $)
      ramub1lem2 $p |- ( ph -> E. c e. R E. z e. ~P S
        ( ( F ` c ) <_ ( # ` z ) /\ ( z C M ) C_ ( `' K " { c } ) ) ) $=
        ( vd vw vv cv cfv chash cle wbr c1 cmin ccnv csn cima wss cdif cpw wrex
        co wa cfn cn wcel cn0 nnm1nn0 syl diffi cram nn0red leidd hashcl nn0cnd
        cc ax-1cn a1i cun caddc undif1 wceq snssd sylib syl5eq fveq2d neldifsnd
        ssequn2 wn hashunsng mp2and 3eqtr3d addcan2ad breqtrrd adantr hashbcval
        wi wf crab syl2anc eleq2d weq fveq2 eqeq1d elrab syl6bb simprbda elpwid
        difss2d unssd snex unex elpw sylibr ssfi ssneldd simplbda oveq1d nnnn0d
        vex ffvelrnd fmptd rami cif cmpt simprll fvmpt simprlr simprrl ad2antrr
        ovex simprrr expr mpd nncnd npcan sylancl 3eqtrd sylanbrc eleqtrrd cres
        ffvelrnda ifcl eqid equequ2 ifbieq12d mpteq2dv oveq2d eqeltrrd eqbrtrrd
        eqidd hashbcss syl3anc fssres ifbieq2d fvex ifex ad2antrl breq1d anbi1d
        equequ1 cin cnvresima inss1 eqsstri syl6ss ramub1lem1 anassrs rexlimdva
        sylbid reximdva rexlimdvva ) AUKUNZKUOZULUNZUPUOZUQURZUWANUSUTVHZFVHLVA
        UVSVBVCVDZVIZULHOVBZVEZVFZVGUKGVGRUNZJUOZDUNZUPUOUQURUWLNFVHMVAUWJVBZVC
        ZVDVIDHVFZVGZRGVGZAULFGUWHIKLUWDVJVJPQUKUEANVKVLZUWDVMVLZSNVNVOZTUCUDAH
        VJVLZUWHVJVLZUFHUWGVPVOZAUWDKVQVHZUXDUWHUPUOZUQAUXDAUXDUDVRVSAUXEUXDUSA
        UXEAUXBUXEVMVLUXCUWHVTVOWAAUXDUDWAUSWBVLZAWCWDAUWHUWGWEZUPUOZHUPUOZUXEU
        SWFVHZUXDUSWFVHZAUXGHUPAUXGHUWGWEZHHUWGWGAUWGHVDZUXLHWHAOHUIWIZUWGHWNWJ
        WKWLAUXBOUWHVLWOZUXHUXJWHZUXCAOHWMAOHVLZUXBUXOVIUXPXCUIUWHOHWPVOWQUGWRW
        SWTAEUWHUWDFVHZEUNZUWGWEZMUOGLAUXSUXRVLZVIZHNFVHZGUXTMAUYCGMXDZUYAUHXAU
        YBUXTBUNZUPUOZNWHZBUWOXEZUYCUYBUXTUWOVLZUXTUPUOZNWHZUXTUYHVLUYBUXTHVDUY
        IUYBUXSUWGHUYBUXSHUWGUYBUXSUWHAUYAUXSUWIVLZUXSUPUOZUWDWHZAUYAUXSUYFUWDW
        HZBUWIXEZVLUYLUYNVIAUXRUYPUXSAUXBUWSUXRUYPWHUXCUWTBUWHFIUWDVJPQUEXBXFXG
        UYOUYNBUXSUWIBEXHUYFUYMUWDUYEUXSUPXIXJXKXLZXMXNZXOAUXMUYAUXNXAXPUXTHUXS
        UWGEYFOXQXRXSXTUYBUYJUYMUSWFVHZUWDUSWFVHZNUYBUXSVJVLZOUXSVLWOZUYJUYSWHZ
        UYBUXBUXSUWHVDVUAAUXBUYAUXCXAUYRUWHUXSYAXFUYBUXSUWHOUYRUYBOHWMYBUYBUXQV
        UAVUBVIVUCXCAUXQUYAUIXAUXSOHWPVOWQUYBUYMUWDUSWFAUYAUYLUYNUYQYCYDAUYTNWH
        ZUYAANWBVLUXFVUDANSUUAWCNUSUUBUUCXAUUDUYGUYKBUXTUWOUYEUXTWHUYFUYJNUYEUX
        TUPXIXJXKUUEAUYCUYHWHZUYAAUXANVMVLZVUEUFANSYEZBHFINVJPQUEXBXFXAUUFYGUJY
        HYIAUWFUWQUKULGUWIAUVSGVLZUWAUWIVLZVIZUWFUWQAVUJUWFVIZVIZUWJCGCUKXHZUVS
        JUOZUSUTVHZCUNZJUOZYJZYKZUOZUMUNZUPUOZUQURZVVANFVHZMUWANFVHZUUGZVAUWMVC
        ZVDZVIZUMUWAVFZVGZRGVGUWQVULUMFGUWAIVUSVVFNVJUWIPQRUEAVUFVUKVUGXAZAGVJV
        LZVUKTXAVULCGVURVMVUSVULVUPGVLZVIZVUOVMVLZVUQVMVLVURVMVLVULVVPVVNVULVUN
        VKVLVVPVULGVKUVSJAGVKJXDZVUKUAXAZAVUHVUIUWFYLZYGVUNVNVOXAVVOVUQVULGVKVU
        PJVVRUUHYEVUMVUOVUQVMUUIXFVUSUUJZYHVULUVTNVUSVQVHZVMVULVUHUVTVWAWHVVSBU
        VSNCGCBXHZUYEJUOZUSUTVHZVUQYJZYKZVQVHVWAGKBUKXHZVWFVUSNVQVWGCGVWEVURVWG
        VWBVUMVWDVUQVUOVUQBUKCUUKVWGVWCVUNUSUTUYEUVSJXIYDVWGVUQUUQUULUUMUUNUBNV
        USVQYQYMVOZVULGVMUVSKAGVMKXDZVUKUCXAVVSYGUUOAVUHVUIUWFYNZVULUVTVWAUWBUQ
        VWHAVUJUWCUWEYOZUUPVULUYDVVEUYCVDZVVEGVVFXDAUYDVUKUHXAVULUXAUWAHVDVUFVW
        LAUXAVUKUFXAVULUWAHUWGVULUWAUWHVWJXNZXOVVLHUWAFINVJPQUEUURUUSUYCGVVEMUU
        TXFYIVULVVKUWPRGVULUWJGVLZVIVVIUWPUMVVJVULVWNVVAVVJVLZVVIUWPXCVULVWNVWO
        VIZVIZVVIRUKXHZVUOUWKYJZVVBUQURZVVHVIZUWPVWQVVCVWTVVHVWQVUTVWSVVBUQVWNV
        UTVWSWHVULVWOCUWJVURVWSGVUSCRXHVUMVWRVUQUWKVUOCRUKUVGVUPUWJJXIUVAVVTVWR
        VUOUWKVUNUSUTYQUWJJUVBUVCYMUVDUVEUVFVULVWPVXAUWPVULVWPVXAVIZVIZBCDEFUVS
        GHIUWJJKLMNVVAUWAOPQAUWRVUKVXBSYPAVVMVUKVXBTYPAVVQVUKVXBUAYPUBAVWIVUKVX
        BUCYPAUXDVMVLVUKVXBUDYPUEAUXAVUKVXBUFYPAUXIUXKWHVUKVXBUGYPAUYDVUKVXBUHY
        PAUXQVUKVXBUIYPUJVULVUHVXBVVSXAVULUWAUWHVDVXBVWMXAVULUWCVXBVWKXAVULUWEV
        XBAVUJUWCUWEYRXAVULVWNVWOVXAYLVXCVVAUWAVULVWNVWOVXAYNXNVULVWPVWTVVHYOVX
        CVVDVVGUWNVULVWPVWTVVHYRVVGUWNVVEUVHUWNVVEUWMMUVIUWNVVEUVJUVKUVLUVMYSUV
        PUVNUVOUVQYTYSUVRYT $.
    $}

    $( Inductive step for Ramsey's theorem, in the form of an explicit upper
       bound.  (Contributed by Mario Carneiro, 23-Apr-2015.) $)
    ramub1 $p |- ( ph -> ( M Ramsey F ) <_ ( ( ( M - 1 ) Ramsey G ) + 1 ) ) $=
      ( cn0 cv cfv co cn wcel adantr vz va vi vb vf vs vc vw vu vv cvv wceq cpw
      chash crab cmpt2 c1 cmin cram caddc cfn nnnn0d wf wss nnssnn0 fss sylancl
      eqid peano2nn0 syl wa wex cle wbr ccnv csn cima c0 simprl nn0p1nn eqeltrd
      wrex wne wb vex hashclb ax-mp sylibr hashnncl mpbid n0 sylib cdif adantrr
      cun cmpt simprll simprlr simprr uneq1 cbvmptv ramub1lem2 expr exlimdv mpd
      fveq2d ramub2 ) AUAUBUCUKNUDOUNPUCOULUDUBOUMUOUPZDUEUCEGGUQURQZFUSQZUQUTQ
      ZVAUFUBUDUGXHVHZAGHVBIADREVCZRNVDDNEVCJVEDRNEVFVGAXJNSZXKNSMXJVIVJAUFOZUN
      PZXKULZXOGXHQDUEOZVCZVKZVKZUHOZXOSZUHVLZUGOZEPUAOZUNPVMVNYFGXHQXRVOYEVPVQ
      VDVKUAXOUMWBUGDWBZYAXOVRWCZYDYAXPRSZYHYAXPXKRAXQXSVSYAXNXKRSAXNXTMTXJVTVJ
      WAZYAXOVASZYIYHWDYAXPNSZYKYAXPYJVBXOUKSYKYLWDUFWEXOUKWFWGWHZXOWIVJWJUHXOW
      KWLYAYCYGUHAXTYCYGAXTYCVKZVKBCUAUIXHDXOUCEFUJXOYBVPZWMXIXHQZUJOZYOWOZXRPZ
      WPXRGYBUBUDUGAGRSYNHTADVASYNITAXMYNJTKADNFVCYNLTAXNYNMTXLAXTYKYCYMWNAXQXS
      YCWQAXQXSYCWRAXTYCWSUJUIYPYSUIOZYOWOZXRPYQYTULYRUUAXRYQYTYOWTXFXAXBXCXDXE
      XG $.
  $}

  ${
    $d f F $.  $d f x M $.  $d f g h k m n w x y z R $.
    $( Ramsey's theorem: the Ramsey number is an integer for every finite
       coloring and set of upper bounds.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    ramcl $p |- ( ( M e. NN0 /\ R e. Fin /\ F : R --> NN0 ) ->
      ( M Ramsey F ) e. NN0 ) $=
      ( vf vx vh vk vy vw cn0 wcel cram co wa wi cc0 c1 wceq weq cmin vm vg cfn
      vn vz wf cmap cvv wb nn0ex simpr elmapg sylancr wral caddc eleq1d ralbidv
      cv oveq1 imbi2d elmapi 0ramcl sylan2 ralrimiva cbvralv cfv csu wal simpll
      oveq2 ad2antrl ffvelrnda fsumnn0cl eqeq2 anbi2d imbi1d albidv csn simplll
      cxp cmpt ffvelrn adantll nn0red nn0ge0d fsum00 rgenw mpteqb ax-mp syl6bbr
      fvex feqmptd fconstmpt a1i c0 oveq2d simpllr peano2nn0 syl adantr eqeltrd
      simp-4l syl3anc 0nn0 syl6eqel cn cif ad2antrr wss sylancl cc nn0cnd pncan
      ax-1cn oveq1d syl2anc eqid fmptd simplrr fveq2 sumeq2dv 3eqtrd feq1 fveq1
      equequ1 ifbieq2d eqeq1d anbi12d imbi12d sylc cbvmptv expr adantrl sylbird
      w3a simprl wn expcom a2d nn0ind eqeq12d bitr4d xpeq1 0xp syl6eq sylan9eqr
      ram0 wne ramz pm2.61dane syl5ibrcom sylbid expimpd alrimiv wfn ffnfv baib
      ffn cle wbr simplr simprr nnssnn0 fss mptexg nnm1nn0 ifcl 3ad2antl2 nncnd
      subid1d ifeq2d adantl ifeq1da eqtr2d ifsb syl6eqr simp1 0cn keepel elsncg
      fsumsub ifbid sumeq2i chash simp3 snssd sumhash hashsng eqtrd syl5eqr jca
      simplrl ovex ifex fvmpt sylan9eq spcgv syl3c mpbird rspcv eqidd ifbieq12d
      nn0p1nn mpteq2dv syl5eq ramub1 ramubcl syl32anc rexnal wo elnn0 sylib ord
      wrex 3jca ramz2 sylan syld rexlimdva syl5bir pm2.61d exp31 alrimdv cbvalv
      sumeq2sdv syl6ibr anassrs mpd biantrud bitr3d spv ralrimdva syl5bi rspccv
      com12 imp 3impia ) CJKZAUCKZAJBUFZCBLMZJKZUYRUYSNZUYTBJAUGMZKZVUBVUCJUHKZ
      UYSVUEUYTUIUJUYRUYSUKJABUHUCULUMVUCCDURZLMZJKZDVUDUNZVUEVUBOUYRUYSVUJUYSE
      URZVUGLMZJKZDVUDUNZOUYSPVUGLMZJKZDVUDUNZOUYSUAURZVUGLMZJKZDVUDUNZOUYSVURQ
      UOMZVUGLMZJKZDVUDUNZOUYSVUJOEUACVUKPRZVUNVUQUYSVVFVUMVUPDVUDVVFVULVUOJVUK
      PVUGLUSUPUQUTEUASZVUNVVAUYSVVGVUMVUTDVUDVVGVULVUSJVUKVURVUGLUSUPUQUTVUKVV
      BRZVUNVVEUYSVVHVUMVVDDVUDVVHVULVVCJVUKVVBVUGLUSUPUQUTVUKCRZVUNVUJUYSVVIVU
      MVUIDVUDVVIVULVUHJVUKCVUGLUSUPUQUTUYSVUPDVUDVUGVUDKZUYSAJVUGUFZVUPVUGJAVA
      ZAVUGVBVCVDVURJKZUYSVVAVVEUYSVVMVVAVVEOVVAVURUBURZLMZJKZUBVUDUNZUYSVVMNZV
      VEVUTVVPDUBVUDDUBSVUSVVOJVUGVVNVURLVJUPVEVVRVVQVVDDVUDVVRVVJVVQVVDVVRVVJV
      VQNZNZAJFURZUFZAGURZVWAVFZGVGZAVWCVUGVFZGVGZRZNZVVBVWALMZJKZOZFVHZVVKVVDV
      VTVWGJKZVWMVVTAVWFGUYSVVMVVSVIVVTAJVWCVUGVVJVVKVVRVVQVVLVKZVLVMVVRVVQVWNV
      WMOVVJVWNVVRVVQNZVWMVWPVWBVWEVUKRZNZVWKOZFVHZOVWPVWBVWEPRZNZVWKOZFVHZOVWP
      VWBVWEUDURZRZNZVWKOZFVHZOVWPVWBVWEVXEQUOMZRZNZVWKOZFVHZOVWPVWMOEUDVWGVVFV
      WTVXDVWPVVFVWSVXCFVVFVWRVXBVWKVVFVWQVXAVWBVUKPVWEVNVOVPVQUTEUDSZVWTVXIVWP
      VXOVWSVXHFVXOVWRVXGVWKVXOVWQVXFVWBVUKVXEVWEVNVOVPVQUTVUKVXJRZVWTVXNVWPVXP
      VWSVXMFVXPVWRVXLVWKVXPVWQVXKVWBVUKVXJVWEVNVOVPVQUTVUKVWGRZVWTVWMVWPVXQVWS
      VWLFVXQVWRVWIVWKVXQVWQVWHVWBVUKVWGVWEVNVOVPVQUTVWPVXCFVWPVWBVXAVWKVWPVWBN
      ZVXAVWAAPVRZVTZRZVWKVXRVXAGAVWDWAZGAPWAZRZVYAVXRVXAVWDPRGAUNZVYDVXRAVWDGU
      YSVVMVVQVWBVSVXRVWCAKZNZVWDVWBVYFVWDJKVWPAJVWCVWAWBWCZWDVYGVWDVYHWEWFVWDU
      HKZGAUNVYDVYEUIVYIGAVWCVWAWKWGGAVWDPUHWHWIWJVXRVWAVYBVXTVYCVXRGAJVWAVWPVW
      BUKWLVXTVYCRVXRGAPWMWNUUAUUBVXRVWKVYAVVBVXTLMZJKZVXRVYKAWOVXRAWORZNVYJVVB
      JVYLVXRVYJVVBWOLMZVVBVYLVXTWOVVBLVYLVXTWOVXSVTWOAWOVXSUUCVXSUUDUUEWPVXRVV
      BJKZVYMVVBRVXRVVMVYNUYSVVMVVQVWBWQVURWRZWSZVVBUUGWSUUFVXRVYNVYLVYPWTXAVXR
      AWOUUHZNZVYJPJVYRVYNUYSVYQVYJPRVXRVYNVYQVYPWTUYSVVMVVQVWBVYQXBVXRVYQUKAVV
      BUCUUIXCXDXEUUJVYAVWJVYJJVWAVXTVVBLVJUPUUKUULUUMUUNVXEJKZVWPVXIVXNVWPVYSV
      XIVXNOZVVRVVQVYSVYTVVRVVQVYSNZNZVXIVVKVWGVXJRZNZVVDOZDVHVXNWUBVXIWUEDWUBV
      XIWUDVVDWUBVXINZWUDNZVUKVUGVFZXFKZEAUNZVVDWUGWUJAXFVUGUFZVVDWUGVUGAUUOZWU
      KWUJUIVVKWULWUFWUCAJVUGUURVKWUKWULWUJEAXFVUGUUPUUQWSWUFWUCWUKVVDOVVKWUFWU
      CWUKVVDWUFWUCWUKNZNZVYNUYSVVKVVBQTMZEAVVBHAHESZWUHQTMZHURZVUGVFZXGZWAZLMZ
      WAZLMZQUOMZJKZVVCWVEUUSUUTVVDWUNVVMVYNWUBVVMVXIWUMUYSVVMWUAUVAZXHZVYOWSUY
      SVVMWUAVXIWUMXBZWUNWUKXFJXIVVKWUFWUCWUKUVBZUVCAXFJVUGUVDXJZWUNWVDJKWVFWUN
      WVDVURWVCLMZJWUNWUOVURWVCLWUNVURXKKQXKKZWUOVURRWUNVURWVHXLXNVURQXMXJXOWUN
      WVCVUDKZVVQWVLJKZWUNWVNAJWVCUFZWUNEAWVBJWVCWUNVUKAKZNZWVAUHKZVXIAJWVAUFZA
      GESZWUQVWFXGZGVGZVXERZNZWVBJKZWVRUYSWVSWUNUYSWVQWVIWTZHAWUTUCUVEWSWUBVXIW
      UMWVQWQWVRWVTWWDWVRHAWUTJWVAWVRWURAKZNWUQJKZWUSJKWUTJKWVRWWIWWHWVRWUIWWIW
      UNAXFVUKVUGWVJVLWUHUVFWSWTWVRAJWURVUGWUNVVKWVQWVKWTVLWUPWUQWUSJUVGXPWVAXQ
      ZXRWVRWWCVWGQTMZVXJQTMZVXEWVRUYSWUKWVQWWCWWKRWWGWUFWUCWUKWVQXSWUNWVQUKUYS
      WUKWVQYOZWWCAVWFWWAQPXGZTMZGVGVWGAWWNGVGZTMWWKWWMAWWBWWOGWWMVYFNZWWBWWAVW
      FQTMZVWFPTMZXGZWWOWWQWWTWWAWWRVWFXGWWBWWQWWAWWSVWFWWRWWQVWFWWQVWFWUKUYSVY
      FVWFXFKWVQAXFVWCVUGWBUVHUVIZUVJUVKWWQWWAWWRWUQVWFWWQWWANVWFWUHQTWWAVWFWUH
      RWWQVWCVUKVUGXTUVLXOUVMUVNWWAQPWWOWWRWWSWWNQVWFTVJWWNPVWFTVJUVOUVPYAWWMAV
      WFWWNGUYSWUKWVQUVQZWXAWWNXKKWWQWWAQPXKXNUVRUVSWNUWAWWMWWPQVWGTWWMWWPAVWCV
      UKVRZKZQPXGZGVGZQAWXEWWNGVYFWXDWWAQPVWCVUKAUVTUWBUWCWWMWXFWXCUWDVFZQWWMUY
      SWXCAXIWXFWXGRWXBWWMVUKAUYSWUKWVQUWEZUWFWXCAGUWGXPWWMWVQWXGQRWXHVUKAUWHWS
      UWIUWJWPYBXCWVRVWGVXJQTWUFWUCWUKWVQUWLXOWVRVXEXKKWVMWWLVXERWVRVXEWUFVYSWU
      MWVQVVRVVQVYSVXIXSXHXLXNVXEQXMXJYBUWKVXHWWEWWFOFWVAUHVWAWVARZVXGWWEVWKWWF
      WXIVWBWVTVXFWWDAJVWAWVAYCWXIVWEWWCVXEWXIAVWDWWBGWXIVYFVWDVWCWVAVFWWBVWCVW
      AWVAYDHVWCWUTWWBAWVAHGSWUPWWAWUSVWFWUQHGEYEWURVWCVUGXTYFWWJWWAWUQVWFWUHQT
      UWMVWCVUGWKUWNUWOUWPYAYGYHWXIVWJWVBJVWAWVAVVBLVJUPYIUWQUWRWVCXQXRZWUNVUFU
      YSWVNWVPUIUJWVIJAWVCUHUCULUMUWSWUBVVQVXIWUMVVRVVQVYSYPXHVVPWVOUBWVCVUDVVN
      WVCRVVOWVLJVVNWVCVURLVJUPUWTYJXAZWVDWRWSWUNUEIAVUGWVCVVBWUBVVBXFKZVXIWUMW
      UBVVMWXLWVGVURUXCWSZXHWVIWVJEUEAWVBVVBIAIUESZUEURZVUGVFZQTMZIURZVUGVFZXGZ
      WAZLMEUESZWVAWYAVVBLWYBWVAIAIESZWUQWXSXGZWAWYAHIAWUTWYDHISWUPWYCWUSWXSWUQ
      HIEYEWURWXRVUGXTYFYKWYBIAWYDWXTWYBWYCWXNWUQWXSWXQWXSVUKWXOWXRVNWYBWUHWXPQ
      TVUKWXOVUGXTXOWYBWXSUXAUXBUXDUXEWPYKWXJWXKUXFWVEAVUGVVBUCUXGUXHYLYMYNWUJY
      QWUIYQZEAUXNWUGVVDWUIEAUXIWUGWYEVVDEAWUGWVQNZWYEWUHPRZVVDWYFWUIWYGWYFWUHJ
      KWUIWYGUXJWUGAJVUKVUGWUFVVKWUCYPZVLWUHUXKUXLUXMWUGWVQWYGVVDWUGWVQWYGNZNVV
      CPJWUGWXLUYSVVKYOWYIVVCPRWUGWXLUYSVVKWUBWXLVXIWUDWXMXHUYSVVMWUAVXIWUDXBWY
      HUXOVUKAVUGVVBUCUXPUXQXDXEYLUXRUXSUXTUYAUYBUYCVXMWUEFDFDSZVXLWUDVWKVVDWYJ
      VWBVVKVXKWUCAJVWAVUGYCZWYJVWEVWGVXJWYJAVWDVWFGVWCVWAVUGYDUYEZYGYHWYJVWJVV
      CJVWAVUGVVBLVJUPZYIUYDUYFUYGYRYSYTUYOYMUYHVWOVWLVVKVVDOFDWYJVWIVVKVWKVVDW
      YJVWBVWIVVKWYJVWHVWBWYLUYIWYKUYJWYMYIUYKYJYLUYLUYMYRYSYTUYPVUIVUBDBVUDVUG
      BRVUHVUAJVUGBCLVJUPUYNWSYNUYQ $.
  $}

  ${
    $d c f n s x F $.  $d a b c f i n s x M $.  $d c f n s x R $.
    $d c f x C $.
    ramsey.c $e |- C = ( a e. _V , i e. NN0 |->
      { b e. ~P a | ( # ` b ) = i } ) $.
    $( Ramsey's theorem with the definition ` Ramsey ` eliminated.  If ` M ` is
       an integer, ` R ` is a specified finite set of colors, and
       ` F : R --> NN0 ` is a set of lower bounds for each color, then there is
       an ` n ` such that for every set ` s ` of size greater than ` n ` and
       every coloring ` f ` of the set ` ( s C M ) ` of all ` M ` -element
       subsets of ` s ` , there is a color ` c ` and a subset ` x C_ s ` such
       that ` x ` is larger than ` F ( c ) ` and the ` M ` -element subsets of
       ` x ` are monochromatic with color ` c ` .  This is the hypergraph
       version of Ramsey's theorem; the version for simple graphs is the case
       ` M = 2 ` .  (Contributed by Mario Carneiro, 23-Apr-2015.) $)
    ramsey $p |- ( ( M e. NN0 /\ R e. Fin /\ F : R --> NN0 ) -> E. n e. NN0
     A. s ( n <_ ( # ` s ) -> A. f e. ( R ^m ( s C M ) ) E. c e. R E. x e. ~P s
      ( ( F ` c ) <_ ( # ` x ) /\ ( x C M ) C_ ( `' f " { c } ) ) ) ) $=
      ( cn0 wcel cfn cv cfv co wrex wf w3a chash cle wbr ccnv csn cima wss cmap
      wa cpw wral wi wal crab c0 wne cram ramcl eqid ramtcl2 mpbid rabn0 sylib
      ) HNOCPOCNGUAUBZFQIQZUCRUDUELQZGRAQZUCRUDUEVIHBSDQUFVHUGUHUIUKAVGULTLCTDC
      VGHBSUJSUMUNIUOZFNUPZUQURZVJFNTVFHGUSSNOVLCGHUTABCVKDEFGHPIJKLMVKVAVBVCVJ
      FNVDVE $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Decimal arithmetic (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    dec2dvds.1 $e |- A e. NN0 $.
    dec2dvds.2 $e |- B e. NN0 $.
    dec2dvds.3 $e |- ( B x. 2 ) = C $.
    dec2dvds.4 $e |- D = ( C + 1 ) $.
    $( Divisibility by two is obvious in base 10.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    dec2dvds $p |- -. 2 || ; A D $=
      ( c2 c1 caddc co cdivides wbr c10 c5 cz wcel nn0zi 2z cdc cmul 5nn0 mp2an
      wn dvdsmul2 5t2e10 breqtri wi 10nn0 dvdsmultr1 mp3an ax-mp nn0mulcli 2nn0
      wa cn0 eqeltrri dvds2add df-dec breqtrri cn clt deccl 1lt2 ndvdsp1 eqcomi
      2nn eqid decsuc breq2i mtbi ) IACUAZJKLZMNZIADUAZMNIVMMNZVOUEZIOAUBLZCKLZ
      VMMIVSMNZICMNZIVTMNZIOMNZWAIPIUBLZOMPQRIQRZIWEMNPUCSTPIUFUDUGUHWFOQRAQRWD
      WAUITOUJSAESIOAUKULUMIBIUBLZCMBQRWFIWGMNBFSTBIUFUDGUHWFVSQRCQRWAWBUPWCUIT
      VSOAUJEUNSCWGCUQGBIFUOUNURZSIVSCUSULUDACUTVAVMQRIVBRJIVCNVQVRUIVMACEWHVDS
      VHVEIVMVFULUMVNVPIMACDVMEWHDCJKLHVGVMVIVJVKVL $.
  $}

  ${
    dec5dvds.1 $e |- A e. NN0 $.
    dec5dvds.2 $e |- B e. NN $.
    dec5dvds.3 $e |- B < 5 $.
    $( Divisibility by five is obvious in base 10.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    dec5dvds $p |- -. 5 || ; A B $=
      ( c5 cdc c2 cmul co 5nn 2nn0 nn0mulcli caddc c10 nncni 2cn nn0cni mulassi
      oveq1i 5t2e10 eqtr3i df-dec eqtr4i ndvdsi ) FABGZHAIJZBKHALCMDFUGIJZBNJOA
      IJZBNJUFUHUIBNFHIJZAIJUHUIFHAFKPQACRSUJOAIUATUBTABUCUDEUE $.

    dec5dvds2.4 $e |- ( 5 + B ) = C $.
    $( Divisibility by five is obvious in base 10.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    dec5dvds2 $p |- -. 5 || ; A C $=
      ( c5 cdc cdivides wbr dec5dvds caddc co cz wcel wb 5nn0 nn0zi nnnn0i 0nn0
      deccl dvdsadd mp2an dec0h eqid nn0cni addid2i decadd breq2i bitri mtbi
      cc0 ) HABIZJKZHACIZJKZABDEFLUOHHUNMNZJKZUQHOPUNOPUOUSQHRSUNABDBETZUBSHUNU
      CUDURUPHJUMHABACHUNUARDUTHRUEUNUFAADUGUHGUIUJUKUL $.
  $}

  ${
    dec2nprm.1 $e |- A e. NN $.
    $( Divisibility by five is obvious in base 10.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    dec5nprm $p |- -. ; A 5 e. Prime $=
      ( c2 cmul co c1 caddc c5 cdc cn wcel 2nn nnmulcli peano2nn ax-mp 5nn 1nn0
      1lt2 c10 nncni numlti mul32i 5t2e10 mulcomli oveq1i eqtri mulid2i oveq12i
      1lt5 ax-1cn adddiri df-dec 3eqtr4i nprmi ) CADEZFGEZHAHIZUOJKUPJKCALBMZUO
      NOPAFFCLBQQRUAUIUOHDEZFHDEZGESADEZHGEUPHDEUQUSVAUTHGUSCHDEZADEVACAHCLTZAB
      THPTZUBVBSADHCSVDVCUCUDUEUFHVDUGUHUOFHUOURTUJVDUKAHULUMUN $.

    dec2nprm.2 $e |- B e. NN0 $.
    dec2nprm.3 $e |- ( B x. 2 ) = C $.
    $( Divisibility by two is obvious in base 10.  (Contributed by Mario
       Carneiro, 19-Apr-2015.) $)
    dec2nprm $p |- -. ; A C e. Prime $=
      ( c5 cmul co caddc c2 cdc cn wcel cn0 5nn nnmulcli c10 nncni 2cn mp2an c1
      nnnn0addcl 2nn 1nn0 1lt5 numlti mul32i 5t2e10 oveq1i eqtri oveq12i nn0cni
      1lt2 adddiri df-dec 3eqtr4i nprmi ) GAHIZBJIZKACLZUSMNBONUTMNGAPDQZEUSBUC
      UAUDABUBGPDEUEUFUGUNUSKHIZBKHIZJIRAHIZCJIUTKHIVAVCVEVDCJVCGKHIZAHIVEGAKGP
      SADSTUHVFRAHUIUJUKFULUSBKUSVBSBEUMTUOACUPUQUR $.
  $}

  ${
    modxai.1 $e |- N e. NN $.
    modxai.2 $e |- A e. NN $.
    modxai.3 $e |- B e. NN0 $.
    modxai.4 $e |- D e. ZZ $.
    modxai.5 $e |- K e. NN0 $.
    modxai.6 $e |- M e. NN0 $.
    ${
      modxai.7 $e |- C e. NN0 $.
      modxai.8 $e |- L e. NN0 $.
      modxai.11 $e |- ( ( A ^ B ) mod N ) = ( K mod N ) $.
      modxai.12 $e |- ( ( A ^ C ) mod N ) = ( L mod N ) $.
      modxai.9 $e |- ( B + C ) = E $.
      modxai.10 $e |- ( ( D x. N ) + M ) = ( K x. L ) $.
      $( Add exponents in a power mod calculation.  (Contributed by Mario
         Carneiro, 21-Feb-2014.)  (Revised by Mario Carneiro, 5-Feb-2015.) $)
      modxai $p |- ( ( A ^ E ) mod N ) = ( M mod N ) $=
        ( cexp co cmo cmul caddc oveq2i wcel cn0 wceq nncni expadd mp3an eqtr3i
        cc oveq1i wtru cz nnexpcl mp2an nnzi a1i nn0zi crp nnrp ax-mp modmul12d
        cn trud zcn mulcli nn0cni addcomi eqtri cr nn0rei modcyc ) AEUBUCZIUDUC
        ABUBUCZACUBUCZUEUCZIUDUCZHIUDUCZVRWAIUDABCUFUCZUBUCZVRWAWDEAUBTUGAUOUHB
        UIUHZCUIUHZWEWAUJAKUKLPABCULUMUNUPWBHDIUEUCZUFUCZIUDUCZWCWBFGUEUCZIUDUC
        ZWJWBWLUJUQVSFVTGIVSURUHUQVSAVHUHZWFVSVHUHKLABUSUTVAVBFURUHUQFNVCVBVTUR
        UHUQVTWMWGVTVHUHKPACUSUTVAVBGURUHUQGQVCVBIVDUHZUQIVHUHWNJIVEVFZVBVSIUDU
        CFIUDUCUJUQRVBVTIUDUCGIUDUCUJUQSVBVGVIWKWIIUDWHHUFUCWKWIUAWHHDIDURUHZDU
        OUHMDVJVFIJUKVKHOVLVMUNUPVNHVOUHWNWPWJWCUJHOVPWOMHIDVQUMVNVN $.
    $}

    ${
      mod2xi.9 $e |- ( ( A ^ B ) mod N ) = ( K mod N ) $.
      mod2xi.7 $e |- ( 2 x. B ) = E $.
      mod2xi.8 $e |- ( ( D x. N ) + M ) = ( K x. K ) $.
      $( Double exponents in a power mod calculation.  (Contributed by Mario
         Carneiro, 21-Feb-2014.) $)
      mod2xi $p |- ( ( A ^ E ) mod N ) = ( M mod N ) $=
        ( c2 cmul co caddc nn0cni 2timesi eqtr3i modxai ) ABBCDEEFGHIJKLMJLNNQB
        RSBBTSDBBJUAUBOUCPUD $.
    $}

    ${
      modxp1i.9 $e |- ( ( A ^ B ) mod N ) = ( K mod N ) $.
      modxp1i.7 $e |- ( B + 1 ) = E $.
      modxp1i.8 $e |- ( ( D x. N ) + M ) = ( K x. A ) $.
      $( Add one to an exponent in a power mod calculation.  (Contributed by
         Mario Carneiro, 21-Feb-2014.) $)
      modxp1i $p |- ( ( A ^ E ) mod N ) = ( M mod N ) $=
        ( c1 1nn0 nnnn0i cexp co cmo wcel wceq nncni exp1 ax-mp oveq1i modxai
        cc ) ABQCDEAFGHIJKLMRAISNAQTUAZAGUBAUJUCUKAUDAIUEAUFUGUHOPUI $.
    $}
  $}

  ${
    mod2xnegi.1 $e |- A e. NN $.
    mod2xnegi.2 $e |- B e. NN0 $.
    mod2xnegi.3 $e |- D e. ZZ $.
    mod2xnegi.4 $e |- K e. NN $.
    mod2xnegi.5 $e |- M e. NN0 $.
    mod2xnegi.6 $e |- L e. NN0 $.
    mod2xnegi.10 $e |- ( ( A ^ B ) mod N ) = ( L mod N ) $.
    mod2xnegi.7 $e |- ( 2 x. B ) = E $.
    mod2xnegi.8 $e |- ( L + K ) = N $.
    mod2xnegi.9 $e |- ( ( D x. N ) + M ) = ( K x. K ) $.
    $( Version of ~ mod2xi with a negaive mod value.  (Contributed by Mario
       Carneiro, 21-Feb-2014.) $)
    mod2xnegi $p |- ( ( A ^ E ) mod N ) = ( M mod N ) $=
      ( caddc co cmin cn cn0 wcel nn0nnaddcl mp2an eqeltrri cz zaddcl nn0addcli
      nnzi nnnn0i nn0zi zsubcl cmul nncni cc ax-mp addcli subdiri oveq1i mulcli
      nn0cni addsubi oveq2i adddii oveq12i adddiri addassi eqtr2i eqtr3i mulsub
      zcn mulcomi wceq mp4an subadd2i mpbir 3eqtr2i mod2xi ) ABHCSTZEESTZUATZDF
      GHFESTZHUBQFUCUDEUBUDWDUBUDNLFEUEUFUGZIJWAUHUDZWBUHUDWCUHUDHUHUDCUHUDZWFH
      WEUKKHCUIUFWBEEELULZWHUJUMWAWBUNUFNMOPWCHUOTZGSTWAHUOTZWBHUOTZUATZGSTWJGS
      TZWKUATZFFUOTZWIWLGSWAWBHHCHWEUPZWGCUQUDKCVMURZUSZEEELUPZWSUSZWPUTVAWJGWK
      WAHWRWPVBGMVCZWBHWTWPVBVDHHUOTZEEUOTZSTZHEUOTZXESTZUATZWNWOXBCHUOTZGSTZST
      ZHWBUOTZUATXGWNXJXDXKXFUAXIXCXBSRVEHEEWPWSWSVFVGXJWMXKWKUAWMXBXHSTZGSTXJW
      JXLGSHCHWPWQWPVHVAXBXHGHHWPWPVBCHWQWPVBXAVIVJHWBWPWTVNVGVKHEUATZXMUOTZXGW
      OHUQUDZEUQUDZXOXPXNXGVOWPWSWPWSHEHEVLVPXMFXMFUOXMFVOWDHVOQHEFWPWSFNVCVQVR
      ZXQVGVKVKVSVT $.
  $}

  ${
    modsubi.1 $e |- N e. NN $.
    modsubi.2 $e |- A e. NN $.
    modsubi.3 $e |- B e. NN0 $.
    modsubi.4 $e |- M e. NN0 $.
    modsubi.6 $e |- ( A mod N ) = ( K mod N ) $.
    modsubi.5 $e |- ( M + B ) = K $.
    $( Subtract from within a mod calculation.  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    modsubi $p |- ( ( A - B ) mod N ) = ( M mod N ) $=
      ( caddc co cmo cmin cr wcel wa wceq nn0rei cneg crp nnrei eqeltrri pm3.2i
      nn0addcli renegcli cn nnrp ax-mp modadd1 mp3an nncni nn0cni negsubi recni
      oveq1i subadd2i mpbir eqtri 3eqtr3i ) ABUAZLMZENMZCVBLMZENMZABOMZENMDENMA
      PQZCPQZRVBPQZEUBQZRAENMCENMSVDVFSVHVIAGUCDBLMZCPKVLDBIHUFTUDZUEVJVKBBHTUG
      EUHQVKFEUIUJUEJACVBEUKULVCVGENABAGUMBHUNZUOUQVEDENVECBOMZDCBCVMUPZVNUOVOD
      SVLCSKCBDVPVNDIUNURUSUTUQVA $.
  $}

  ${
    gcdi.1 $e |- K e. NN0 $.
    gcdi.2 $e |- R e. NN0 $.
    ${
      gcdi.3 $e |- N e. NN0 $.
      gcdi.5 $e |- ( N gcd R ) = G $.
      gcdi.4 $e |- ( ( K x. N ) + R ) = M $.
      $( Calculate a GCD via Euclid's algorithm.  (Contributed by Mario
         Carneiro, 19-Feb-2014.) $)
      gcdi $p |- ( M gcd N ) = G $=
        ( cgcd co cmul caddc nn0mulcli nn0cni cz wcel wceq nn0zi oveq2i gcdaddm
        addcomli mp3an cn0 numcl eqeltrri gcdcom mp2an 3eqtr4i eqtr3i ) EAKLZDE
        KLZBEACEMLZNLZKLZEDKLZULUMUODEKUNADUNCEFHOPAGPJUCUACQREQRZAQRULUPSCFTEH
        TZAGTCEAUBUDDQRURUMUQSDUNANLDUEJEACFHGUFUGTUSDEUHUIUJIUK $.
    $}

    ${
      gcdmodi.3 $e |- N e. NN $.
      gcdmodi.4 $e |- ( K mod N ) = ( R mod N ) $.
      gcdmodi.5 $e |- ( N gcd R ) = G $.
      $( Calculate a GCD via Euclid's algorithm.  (Contributed by Mario
         Carneiro, 19-Feb-2014.) $)
      gcdmodi $p |- ( K gcd N ) = G $=
        ( cgcd co cmo oveq1i cz wcel cn wceq nn0zi modgcd mp2an 3eqtr3i gcdcom
        nnzi 3eqtri ) CDJKZADJKZDAJKZBCDLKZDJKZADLKZDJKZUEUFUHUJDJHMCNODPOZUIUE
        QCERGCDSTANOZULUKUFQAFRZGADSTUAUMDNOUFUGQUNDGUCADUBTIUD $.
    $}
  $}

  ${
    decexp2.1 $e |- M e. NN0 $.
    decexp2.2 $e |- ( M + 2 ) = N $.
    $( Calculate a power of two.  (Contributed by Mario Carneiro,
       19-Feb-2014.) $)
    decexp2 $p |- ( ( 4 x. ( 2 ^ M ) ) + 0 ) = ( 2 ^ N ) $=
      ( c4 c2 cexp co cmul c1 caddc 2cn nn0cni wcel cn0 wceq expp1 mp2an ax-1cn
      3eqtr4i 2nn0 nn0expcli mulcli cc mulcomi eqtr2i oveq1i mulcomli peano2nn0
      cc0 decbin0 ax-mp 4nn0 nn0mulcli addid1i addassi df-2 oveq2i 3eqtr2ri ) E
      FAGHZIHZFAJKHZJKHZGHZVAUJKHFBGHFFUTIHZIHFVBGHZFIHZVAVDVEFVGFUTLUTFAUACUBZ
      MZUCLVEVFFIVFUTFIHZVEFUDNZAONZVFVJPLCFAQRUTFVILUEUFUGUHUTVHUKVKVBONZVDVGP
      LVLVMCAUIULFVBQRTVAVAEUTUMVHUNMUOBVCFGVCAJJKHZKHAFKHBAJJACMSSUPFVNAKUQURD
      USURT $.
  $}

  ${
    numexp.1 $e |- A e. NN0 $.
    $( Calculate an integer power.  (Contributed by Mario Carneiro,
       17-Apr-2015.) $)
    numexp0 $p |- ( A ^ 0 ) = 1 $=
      ( cc wcel cc0 cexp co c1 wceq nn0cni exp0 ax-mp ) ACDAEFGHIABJAKL $.

    $( Calculate an integer power.  (Contributed by Mario Carneiro,
       17-Apr-2015.) $)
    numexp1 $p |- ( A ^ 1 ) = A $=
      ( cc wcel c1 cexp co wceq nn0cni exp1 ax-mp ) ACDAEFGAHABIAJK $.

    numexpp1.2 $e |- M e. NN0 $.
    ${
      numexpp1.3 $e |- ( M + 1 ) = N $.
      numexpp1.4 $e |- ( ( A ^ M ) x. A ) = C $.
      $( Calculate an integer power.  (Contributed by Mario Carneiro,
         17-Apr-2015.) $)
      numexpp1 $p |- ( A ^ N ) = C $=
        ( c1 caddc co cexp cmul cc wcel cn0 wceq nn0cni expp1 mp2an 3eqtr3i
        oveq2i ) ACIJKZLKZACLKAMKZADLKBANOCPOUDUEQAERFACSTUCDALGUBHUA $.
    $}

    ${
      numexp2x.3 $e |- ( 2 x. M ) = N $.
      numexp2x.4 $e |- ( A ^ M ) = D $.
      numexp2x.5 $e |- ( D x. D ) = C $.
      $( Double an integer power.  (Contributed by Mario Carneiro,
         17-Apr-2015.) $)
      numexp2x $p |- ( A ^ N ) = C $=
        ( cexp co cmul caddc c2 nn0cni 2timesi eqtr3i wcel eqtri oveq2i cc wceq
        cn0 expadd mp3an oveq12i ) AEKLZADKLZUIMLZBUHADDNLZKLZUJEUKAKODMLEUKHDD
        GPQRUAAUBSDUDSZUMULUJUCAFPGGADDUEUFTUJCCMLBUICUICMIIUGJTT $.
    $}
  $}

  ${
    decsplit0.1 $e |- A e. NN0 $.
    $( Split a decimal number into two parts.  Base case: ` N = 0 ` .
       (Contributed by Mario Carneiro, 16-Jul-2015.) $)
    decsplit0b $p |- ( ( A x. ( 10 ^ 0 ) ) + B ) = ( A + B ) $=
      ( c10 cc0 cexp co cmul caddc c1 10nn0 numexp0 oveq2i nn0cni mulid1i eqtri
      oveq1i ) ADEFGZHGZABISAJHGARJAHDKLMAACNOPQ $.

    $( Split a decimal number into two parts.  Base case: ` N = 0 ` .
       (Contributed by Mario Carneiro, 16-Jul-2015.) $)
    decsplit0 $p |- ( ( A x. ( 10 ^ 0 ) ) + 0 ) = A $=
      ( c10 cc0 cexp co cmul caddc decsplit0b nn0cni addid1i eqtri ) ACDEFGFDHF
      ADHFAADBIAABJKL $.

    $( Split a decimal number into two parts.  Base case: ` N = 1 ` .
       (Contributed by Mario Carneiro, 16-Jul-2015.) $)
    decsplit1 $p |- ( ( A x. ( 10 ^ 1 ) ) + B ) = ; A B $=
      ( c10 c1 cexp co cmul caddc cdc 10nn0 numexp1 oveq2i nn0cni eqtr4i oveq1i
      mulcomi df-dec ) ADEFGZHGZBIGDAHGZBIGABJTUABITADHGUASDAHDKLMDADKNACNQOPAB
      RO $.

    decsplit.2 $e |- B e. NN0 $.
    decsplit.3 $e |- D e. NN0 $.
    decsplit.4 $e |- M e. NN0 $.
    decsplit.5 $e |- ( M + 1 ) = N $.
    decsplit.6 $e |- ( ( A x. ( 10 ^ M ) ) + B ) = C $.
    $( Split a decimal number into two parts.  Inductive step.  (Contributed by
       Mario Carneiro, 16-Jul-2015.) $)
    decsplit $p |- ( ( A x. ( 10 ^ N ) ) + ; B D ) = ; C D $=
      ( c10 cexp co cmul caddc 10nn0 nn0cni wcel cdc cn0 expcl mulcli nn0mulcli
      cc mp2an addassi adddii oveq2i eqtr3i oveq1i numexpp1 mul12i eqtri df-dec
      mulcomi oveq12i 3eqtr4i ) MAMENOZPOZPOZMBPOZDQOZQOZMCPOZDQOZAMFNOZPOZBDUA
      ZQOCDUAVBVCQOZDQOVEVGVBVCDMVAMRSZAUTAGSZMUFTEUBTUTUFTVLJMEUCUGZUDZUDVCMBR
      HUESDISUHVKVFDQMVABQOZPOVKVFMVABVLVOBHSUIVPCMPLUJUKULUKVIVBVJVDQVIAMUTPOZ
      POVBVHVQAPMVQEFRJKUTMVNVLUQUMUJAMUTVMVLVNUNUOBDUPURCDUPUS $.
  $}

  ${
    karatsuba.a $e |- A e. NN0 $.
    karatsuba.b $e |- B e. NN0 $.
    karatsuba.c $e |- C e. NN0 $.
    karatsuba.d $e |- D e. NN0 $.
    karatsuba.s $e |- S e. NN0 $.
    karatsuba.m $e |- M e. NN0 $.
    karatsuba.r $e |- ( A x. C ) = R $.
    karatsuba.t $e |- ( B x. D ) = T $.
    karatsuba.e $e |- ( ( A + B ) x. ( C + D ) ) = ( ( R + S ) + T ) $.
    karatsuba.x $e |- ( ( A x. ( 10 ^ M ) ) + B ) = X $.
    karatsuba.y $e |- ( ( C x. ( 10 ^ M ) ) + D ) = Y $.
    karatsuba.w $e |- ( ( R x. ( 10 ^ M ) ) + S ) = W $.
    karatsuba.z $e |- ( ( W x. ( 10 ^ M ) ) + T ) = Z $.
    $( The Karatsuba multiplication algorithm.  If ` X ` and ` Y ` are
       decomposed into two groups of digits of length ` M ` (only the lower
       group is known to be this size but the algorithm is most efficient when
       the partition is chosen near the middle of the digit string), then
       ` X Y ` can be written in three groups of digits, where each group needs
       only one multiplication.  Thus, we can halve both inputs with only three
       multiplications on the smaller operands, yielding an asymptotic
       improvement of n^(log_2 3) instead of n^2 for the "naive" algorithm
       ~ decmul1c .  (Contributed by Mario Carneiro, 16-Jul-2015.) $)
    karatsuba $p |- ( X x. Y ) = Z $=
      ( c10 cexp co cmul caddc nn0cni wcel cn0 10nn0 expcl mp2an mulcli muladdi
      cc addcli add32i adddiri mul32i oveq1i eqtri mulassi wceq oveq12i 3eqtr2i
      mulcomli addcani mpbi 3eqtri 3eqtr3ri 3eqtr3i ) AUFHUGUHZUIUHZBUJUHZCVPUI
      UHZDUJUHZUIUHZIVPUIUHZGUJUHZJKUIUHLWAVQVSUIUHZDBUIUHZUJUHVQDUIUHZVSBUIUHZ
      UJUHZUJUHWDWHUJUHZWEUJUHWCVQBVSDAVPAMUKZUFUSULHUMULVPUSULUFUNUKRUFHUOUPZU
      QZBNUKZCVPCOUKZWKUQZDPUKZURWDWEWHVQVSWLWOUQDBWPWMUQZWFWGVQDWLWPUQVSBWOWMU
      QUTVAWIWBWEGUJVQCUIUHZFUJUHZVPUIUHWRVPUIUHZFVPUIUHZUJUHWBWIWRFVPVQCWLWNUQ
      FQUKZWKVBWSIVPUIWSEVPUIUHZFUJUHIWRXCFUJWRACUIUHZVPUIUHXCAVPCWJWKWNVCXDEVP
      UISVDVEVDUDVEVDWTWDXAWHUJVQCVPWLWNWKVFXAADUIUHZCBUIUHZUJUHZVPUIUHXEVPUIUH
      ZXFVPUIUHZUJUHWHFXGVPUIXDWEUJUHZFUJUHZXJXGUJUHZVGFXGVGXKEFUJUHZGUJUHZABUJ
      UHCDUJUHUIUHXLXKXDFUJUHZWEUJUHXNXDWEFACWJWNUQZWQXBVAXOXMWEGUJXDEFUJSVDBDG
      WMWPTVJZVHVEUAABCDWJWMWNWPURVIXJFXGXDWEXPWQUTXBXEXFADWJWPUQZCBWNWMUQZUTVK
      VLVDXEXFVPXRXSWKVBXHWFXIWGUJADVPWJWPWKVCCBVPWNWMWKVCVHVMVHVNXQVHVMVRJVTKU
      IUBUCVHUEVO $.
  $}

  $( Two to the fourth power is 16.  (Contributed by Mario Carneiro,
     20-Apr-2015.) $)
  2exp4 $p |- ( 2 ^ 4 ) = ; 1 6 $=
    ( c2 c1 c6 cdc c4 2nn0 2t2e4 sq2 4t4e16 numexp2x ) ABCDEAEFFGHIJ $.

  $( Two to the sixth power is 64.  (Contributed by Mario Carneiro,
     20-Apr-2015.) $)
  2exp6 $p |- ( 2 ^ 6 ) = ; 6 4 $=
    ( c2 c6 c4 cdc c5 2nn0 5nn0 cexp cmul 4nn0 oveq1i numexpp1 1nn0 6nn0 nn0cni
    co c1 2cn caddc eqtri 5p1e6 4p1e5 2exp4 deccl mulassi oveq2i mulid2i 6t4e24
    2t2e4 eqid 4p2e6 decmul1c ) ABCDZEBFGUAAEHPZAIPQBDZAIPZAIPZUMUNUPAIAUPCEFJU
    BACHPUOAIUCKLKUQUOAAIPZIPZUMUOAAUOQBMNUDORRUEUSUOCIPUMURCUOIUIUFQBBCCAUOJMN
    UOUJJFQCIPZASPCASPBUTCASCCJOUGKUKTUHULTTTL $.

  $( Two to the eighth power is 256.  (Contributed by Mario Carneiro,
     20-Apr-2015.) $)
  2exp8 $p |- ( 2 ^ 8 ) = ; ; 2 5 6 $=
    ( c2 c5 cdc c6 c1 c4 c8 2nn0 4nn0 nn0cni c9 1nn0 6nn0 9nn0 cmul co nncni c3
    2cn caddc 4t2e8 mulcomli 2exp4 deccl eqid mulid1i 1p1e2 5nn0 9nn 6nn 9p6e15
    addcomli decaddci 3nn0 oveq1i 6p3e9 eqtri 6t6e36 decmul1c decmul2c numexp2x
    mulid2i ) AABCZDCEDCZFGHIFAGFIJSUAUBUCEDVCDVDKVDEDLMUDZLMVDUEZMNEDBAVDEOPKL
    MNVDVDVEJUFUGUHKDEBCKUIQDUJQZUKULUMEDKDDRVDMLMVFMUNEDOPZRTPDRTPKVHDRTDVGVBU
    OUPUQURUSUTVA $.

  $( Two to the sixteenth power is 65536.  (Contributed by Mario Carneiro,
     20-Apr-2015.) $)
  2exp16 $p |- ( 2 ^ ; 1 6 ) = ; ; ; ; 6 5 5 3 6 $=
    ( c2 c6 c5 cdc c3 c8 c1 2nn0 5nn0 deccl 6nn0 eqid 1nn0 caddc co cc0 decaddi
    3nn0 0nn0 cmul 8nn0 nn0cni 2cn 8t2e16 mulcomli 2exp8 c4 4nn0 ax-1cn addid2i
    dec0h 2p1e3 decadd 3p1e4 5nn nncni 8p5e13 decaddc 4p1e5 2t2e4 1p1e2 oveq12i
    addcomli 4p2e6 eqtri c10 5t2e10 dec10 decmac 6t2e12 3cn 3p2e5 oveq2i 5t5e25
    5p3e8 6t5e30 decma2c 6nn 6t6e36 decmul1c decmul2c numexp2x ) ABCDZCDZEDZBDA
    CDZBDZFGBDZHUAFAWHFUAUBZUCUDUEUFWFBWEBWGGCDZEDZWGWFBACHIJZKJZWLKWGLZKWJEGCM
    IJZRJACWJEWGWDEGADZFDZWFWKHIWORWFLZWKLWMRWPFGAMHJZUAJWFBGUGDZEAWCCGWGWJWQNO
    WLKGUGMUHJRWNGCWPFWTEWJWQMIWSUAWJLWQLGEUGGWPNOGMRMPGGAGEGWPSMMHGMUKWPLGUIUJ
    AGEUCUIULVCUMUNQRFCGEDWICUOUPZUQVCURHIMACGCABCGWFWTGNOHIMIWRGUGCWTGMUHMWTLU
    SQHIMAATOZGGNOZNOUGANOBXBUGXCANUTVAVBVDVEGPCCATOZCMSIXDVFGPDZVGVHVECXAUJQVI
    GACBATOEMHRVJEACVKUCVLVCZQVIWFBPECWQEEWGEWLKSRWNERUKZIRRACPECWPFAWFPENOZHIS
    RWRXHEPEDEVKUJZXGVEIUAHACTOZPANOZNOXJANOWPXKAXJNAUCUJZVMGPAXJAMSHXJVFXECAVF
    XAUCVGUEVHVEXLQVEACFCCTOEHIRVNVOQVIEPEBCTOERSRVPXIQVIVQWFBWKBBEWGKWLKWNKRAC
    PEBWJEEWFEHISRWRXGKRRABTOZXHNOXMENOWJXHEXMNXIVMGACXMEMHRBAWPBVRUPZUCVJUEXFQ
    VEEPECBTOERSRBCEPDXNXAVPUEXIQVIVSVTWAWB $.

  $( Three to the third power is 27.  (Contributed by Mario Carneiro,
     20-Apr-2015.) $)
  3exp3 $p |- ( 3 ^ 3 ) = ; 2 7 $=
    ( c3 c2 c7 cdc 3nn0 2nn0 2p1e3 cexp co cmul c9 oveq1i 9t3e27 eqtri numexpp1
    sq3 ) ABCDZBAEFGABHIZAJIKAJIQRKAJPLMNO $.

  ${
    $d n x $.  $d x N $.
    $( The factorial grows faster than two to the power ` N ` .  (Contributed
       by Mario Carneiro, 15-Sep-2016.) $)
    2expltfac $p |- ( N e. ( ZZ>= ` 4 ) -> ( 2 ^ N ) < ( ! ` N ) ) $=
      ( c2 cexp co cfa cfv clt wbr c1 c4 wceq oveq2 fveq2 breq12d wcel a1i cmul
      cn nnred remulcld vx vn cv c6 caddc 2exp4 syl6eq fac4 1nn0 2nn0 6nn0 4nn0
      cdc cz 6lt10 1lt2 decltc cuz wa 2nn 4nn simpl nnuz uztrn2 nnnn0d nnexpcld
      sylancr 2re cn0 faccl syl 1re readdcld crp 2rp simpr ltmul1dd nn0ge0d cle
      cr df-2 nnge1d leadd1dd syl5eqbr lemul2ad ltletrd cc expp1d facp1 3brtr4d
      2cn ex uzind4 ) BUAUCZCDZWNEFZGHIUDUMZBJUMZGHZBUBUCZCDZWTEFZGHZBWTIUEDZCD
      ZXDEFZGHZBACDZAEFZGHUAUBJAWNJKZWOWQWPWRGXJWOBJCDWQWNJBCLUFUGXJWPJEFWRWNJE
      MUHUGNWNWTKWOXAWPXBGWNWTBCLWNWTEMNWNXDKWOXEWPXFGWNXDBCLWNXDEMNWNAKWOXHWPX
      IGWNABCLWNAEMNWSJUNOIBUDJUIUJUKULUOUPUQPWTJURFOZXCXGXKXCUSZXABQDZXBXDQDZX
      EXFGXLXMXBBQDXNXLXABXLXAXLBWTBROXLUTPXLWTXLJROXKWTROVAXKXCVBIWTJRVCVDVGZV
      EZVFSZBVTOXLVHPZTXLXBBXLXBXLWTVIOZXBROXPWTVJVKZSZXRTXLXBXDYAXLWTIXLWTXOSZ
      IVTOXLVLPZVMZTXLXAXBBXQYABVNOXLVOPXKXCVPVQXLBXDXBXRYDYAXLXBXLXBXTVEVRXLBI
      IUEDXDVSWAXLIWTIYCYBYCXLWTXOWBWCWDWEWFXLBWTBWGOXLWKPXPWHXLXSXFXNKXPWTWIVK
      WJWLWM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             Specific prime numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( 4 is not a prime number.  (Contributed by Paul Chapman, 22-Jun-2011.)
     (Proof shortened by Mario Carneiro, 18-Feb-2014.) $)
  4nprm $p |- -. 4 e. Prime $=
    ( c2 c4 2nn 1lt2 2t2e4 nprmi ) AABCCDDEF $.

  ${
    $d N x $.
    prmlem0.1 $e |- ( ( -. 2 || M /\ x e. ( ZZ>= ` M ) ) ->
            ( ( x e. ( Prime \ { 2 } ) /\ ( x ^ 2 ) <_ N ) -> -. x || N ) ) $.
    prmlem0.2 $e |- ( K e. Prime -> -. K || N ) $.
    prmlem0.3 $e |- ( K + 2 ) = M $.
    $( Lemma for ~ prmlem1 and ~ prmlem2 .  (Contributed by Mario Carneiro,
       18-Feb-2014.) $)
    prmlem0 $p |- ( ( -. 2 || K /\ x e. ( ZZ>= ` K ) ) ->
            ( ( x e. ( Prime \ { 2 } ) /\ ( x ^ 2 ) <_ N ) -> -. x || N ) ) $=
      ( c2 cdivides wbr wn cuz cfv wcel wa cprime co wi c1 caddc wceq cdif cexp
      cv csn cle eldifi eleq1 breq1 notbid imbi12d mpbiri syl5 adantrd a1i uzp1
      wo wb adantl wne eldifsn cz eluzel2 simpl 1z 2prm nprmdvds1 ax-mp mpanr12
      opoe syl2anc adantr uzid mp1i dvdsprm sylan mpbid eqcomd necon3ad expimpd
      2z a1d syl5bi sylbid ex zcnd ax-1cn addass mp3an23 syl 1p1e2 oveq2i eqtri
      cc syl6eq fveq2d eleq2d dvdsaddr sylancr breq2i syl6bb mtbid jaod mpjaod
      ) HBIJZKZAUDZBLMNZOZXGBUAZXGPHUEZUBZNZXGHUCQDUFJZOXGDIJZKZRZXGBSTQZLMNZXJ
      XQRXIXJXMXPXNXMXGPNZXJXPXGPXKUGXJXTXPRBPNZBDIJZKZRFXJXTYAXPYCXGBPUHXJXOYB
      XGBDIUIUJUKULUMUNUOXSXGXRUAZXGXRSTQZLMZNZUQXIXQXRXGUPXIYDXQYGXIYDXQXIYDOZ
      XMXPXNYHXMXRXLNZXPYDXMYIURXIXGXRXLUHUSXIYIXPRYDYIXRPNZXRHUTZOXIXPXRPHVAXI
      YJYKXPXIYJOZXOXRHYLXRHUAXOYLHXRYLHXRIJZHXRUAZXIYMYJXIBVBNZXFYMXHYOXFBXGVC
      USZXFXHVDZYOXFOSVBNHSIJKZYMVEHPNYRVFHVGVHBSVJVIVKVLXIHHLMNZYJYMYNURHVBNZY
      SXIWAHVMVNXRHVOVPVQVRWBVSVTWCVLWDUNWEXIYGXGCLMZNZXQXIYFUUAXGXIYECLXIYEBSS
      TQZTQZCXIBWNNZYEUUDUAZXIBYPWFUUESWNNZUUGUUFWGWGBSSWHWIWJUUDBHTQZCUUCHBTWK
      WLGWMWOWPWQXIHCIJZKZUUBXQRXIXEUUIYQXIXEHUUHIJZUUIXIYTYOXEUUKURWAYPHBWRWSU
      UHCHIGWTXAXBUUJUUBXQEWEWJWDXCUMXHXJXSUQXFBXGUPUSXD $.
  $}

  ${
    $d N x $.
    prmlem1.n $e |- N e. NN $.
    prmlem1.gt $e |- 1 < N $.
    prmlem1.2 $e |- -. 2 || N $.
    prmlem1.3 $e |- -. 3 || N $.
    ${
      prmlem1a.x $e |- ( ( -. 2 || 5 /\ x e. ( ZZ>= ` 5 ) ) ->
        ( ( x e. ( Prime \ { 2 } ) /\ ( x ^ 2 ) <_ N ) -> -. x || N ) ) $.
      $( A quick proof skeleton to show that the numbers less than 25 are
         prime, by trial division.  (Contributed by Mario Carneiro,
         18-Feb-2014.) $)
      prmlem1a $p |- N e. Prime $=
        ( cprime wcel c2 cuz cfv wbr cdivides wn wi cn c1 mpbir2an c3 cv co cle
        cexp wral clt eluz2b2 wceq breq1 notbid imbi2d wne wa prmnn adantr cdif
        csn eldifsn 2prm nprmdvds1 ax-mp c5 a1i 3p2e5 prmlem0 1nprm pm2.21i 2cn
        ax-1cn 2p1e3 addcomli mpan nnuz eleq2s exp3a syl5bir a1ii pm2.61ne rgen
        mpcom isprm5 ) BHIBJKLIZAUAZJUDUBBUCMZWCBNMZOZPZAHUEWBBQIRBUFMCDBUGSWGA
        HWCHIZWGWDJBNMZOZPWCJWCJUHZWFWJWDWKWEWIWCJBNUIUJUKWCQIZWHWCJULZUMZWGWHW
        LWMWCUNUOWNWCHJUQUPIZWLWGWCHJURWLWOWDWFWOWDUMWFPZWCRKLZQJRNMOZWCWQIWPJH
        IWRUSJUTVAARTBATVBBGTBNMOTHIFVCVDVERHIRBNMOVFVGJRTVHVIVJVKVEVLVMVNVOVPV
        TWHWDWJEVQVRVSABWAS $.
    $}

    prmlem1.lt $e |- N < ; 2 5 $.
    $( A quick proof skeleton to show that the numbers less than 25 are prime,
       by trial division.  (Contributed by Mario Carneiro, 18-Feb-2014.) $)
    prmlem1 $p |- N e. Prime $=
      ( vx c5 wcel c2 cexp co cle wbr wa cdivides wn clt cr 5re cv cuz cfv cdif
      cprime csn wi eluzelre resqcld eluzle 5nn0 nn0ge0i le2sq2 mpanl12 syl2anc
      cc0 nnrei resqcli w3a cdc recni sqvali 5t5e25 eqtri breqtrri ltletr mpani
      cmul mp3an12 sylc wb ltnle sylancr mpbid pm2.21d adantld adantl prmlem1a
      ) GABCDEGUAZHUBUCIZVSUEJUFUDIZVSJKLZAMNZOVSAPNQZUGJHPNQVTWCWDWAVTWCWDVTAW
      BRNZWCQZVTWBSIZHJKLZWBMNZWEVTVSHVSUHZUIZVTVSSIZHVSMNZWIWJHVSUJHSIUPHMNWLW
      MOWITHUKULHVSUMUNUOASIZWHSIZWGWIWEUGABUQZHTURWNWOWGUSAWHRNWIWEAJHUTZWHRFW
      HHHVHLWQHHTVAVBVCVDVEAWHWBVFVGVIVJVTWNWGWEWFVKWPWKAWBVLVMVNVOVPVQVR $.
  $}

  $( 5 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  5prm $p |- 5 e. Prime $=
    ( c5 5nn 1lt5 c2 c1 2nn 2nn0 cmul co caddc c4 2t2e4 oveq1i df-5 eqtr4i 1lt2
    1nn ndvdsi c3 5nn0 3nn 1nn0 mulid1i 3p2e5 eqtri 2lt3 5lt10 declti prmlem1
    3cn ) ABCDADEFGQDDHIZEJIKEJIAUKKEJLMNOPRSAEDUAUBFSEHIZDJISDJIAULSDJSUJUCMUD
    UEUFRDAAFTTUGUHUI $.

  $( 6 is not a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.) $)
  6nprm $p |- -. 6 e. Prime $=
    ( c3 c2 c6 3nn 2nn 1lt3 1lt2 3t2e6 nprmi ) ABCDEFGHI $.

  $( 7 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  7prm $p |- 7 e. Prime $=
    ( c7 7nn 1lt7 c2 c3 c1 2nn 3nn0 1nn cmul co caddc 3cn 2cn 3t2e6 oveq1i df-7
    c6 eqtr4i ndvdsi mulcomli 1lt2 3nn 2nn0 1lt3 5nn0 7nn0 7lt10 declti prmlem1
    c5 ) ABCDAEFGHIDEJKZFLKRFLKZAULRFLEDRMNOUAPQSUBTEADFUCUDIEDJKZFLKUMAUNRFLOP
    QSUETDUKAGUFUGUHUIUJ $.

  $( 8 is not a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.) $)
  8nprm $p |- -. 8 e. Prime $=
    ( c4 c2 c8 4nn 2nn 1lt4 1lt2 4t2e8 nprmi ) ABCDEFGHI $.

  $( 9 is not a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.) $)
  9nprm $p |- -. 9 e. Prime $=
    ( c3 c9 3nn 1lt3 3t3e9 nprmi ) AABCCDDEF $.

  $( 10 is not a prime number.  (Contributed by Mario Carneiro,
     18-Feb-2014.) $)
  10nprm $p |- -. 10 e. Prime $=
    ( c5 c2 c10 5nn 2nn 1lt5 1lt2 5t2e10 nprmi ) ABCDEFGHI $.

  $( 11 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  11prm $p |- ; 1 1 e. Prime $=
    ( c1 cdc 1nn0 1nn decnncl 1lt10 declti cc0 0nn0 c2 mul02i 1e0p1 dec2dvds c3
    2cn 3nn 3nn0 co caddc c9 cmul 3t3e9 oveq1i 9p2e11 eqtri 2lt3 ndvdsi c5 2nn0
    2nn 5nn0 1lt2 decltc prmlem1 ) AABZAACDEAAADCCFGAHHACIJOKLMNUONJPQUJNNUARZJ
    SRTJSRUOUPTJSUBUCUDUEUFUGAJAUHCUICUKFULUMUN $.

  $( 13 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  13prm $p |- ; 1 3 e. Prime $=
    ( c1 c3 cdc 1nn0 3nn decnncl 1nn 3nn0 1lt10 declti c2 mulid2i df-3 dec2dvds
    2cn c4 4nn0 cmul co 2nn0 4cn 3cn 4t3e12 mulcomli decsuc 1lt3 ndvdsi c5 5nn0
    2p1e3 3lt10 1lt2 decltc prmlem1 ) ABCZABDEFABAGHDIJAAKBDDKOLMNBUOPAEQGAKBBP
    RSDTUJPBAKCUAUBUCUDUEUFUGAKBUHDTHUIUKULUMUN $.

  $( 17 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  17prm $p |- ; 1 7 e. Prime $=
    ( c1 c7 cdc 1nn0 7nn decnncl 1nn 7nn0 1lt10 declti c3 c6 3nn0 df-7 dec2dvds
    3t2e6 c5 c2 5nn0 2nn0 3nn 2nn cmul nn0cni 3cn 5t3e15 mulcomli 5p2e7 decaddi
    co 2lt3 ndvdsi 7lt10 1lt2 decltc prmlem1 ) ABCZABDEFABAGHDIJAKLBDMPNOKUQQRU
    ASUBAQBKQUCUJRDSTQKAQCQSUDUEUFUGUHUIUKULARBQDTHSUMUNUOUP $.

  $( 19 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  19prm $p |- ; 1 9 e. Prime $=
    ( c1 c9 cdc 1nn0 9nn decnncl 1nn 9nn0 1lt10 declti c4 c8 4nn0 df-9 dec2dvds
    4t2e8 c3 c6 3nn 6nn0 cmul 8nn0 8p1e9 nn0cni 3cn 6t3e18 mulcomli decsuc 1lt3
    co ndvdsi c2 c5 2nn0 5nn0 9lt10 1lt2 decltc prmlem1 ) ABCZABDEFABAGHDIJAKLB
    DMPNOQUTRASTGALBQRUAUJDUBUCRQALCRTUDUEUFUGUHUIUKAULBUMDUNHUOUPUQURUS $.

  $( 23 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Revised by Mario Carneiro, 20-Apr-2015.) $)
  23prm $p |- ; 2 3 e. Prime $=
    ( c2 c3 cdc 2nn0 3nn decnncl c1 2nn 3nn0 1nn0 1lt10 declti mulid2i dec2dvds
    nncni df-3 c7 7nn0 cmul co nn0cni 7t3e21 mulcomli ax-1cn 2p1e3 decaddi 2lt3
    addcomli ndvdsi c5 5nn 3lt5 declt prmlem1 ) ABCZABDEFABGHIJKLAGABDJAAHOZMPN
    BUOQAERHAGBBQSTADJDQBAGCQRUABEOUBUCAGBUPUDUEUHUFUGUIABUJDIUKULUMUN $.

  ${
    $d x N $.
    prmlem2.n $e |- N e. NN $.
    prmlem2.lt $e |- N < ; ; 8 4 1 $.
    prmlem2.gt $e |- 1 < N $.
    prmlem2.2 $e |- -. 2 || N $.
    prmlem2.3 $e |- -. 3 || N $.
    prmlem2.5 $e |- -. 5 || N $.
    prmlem2.7 $e |- -. 7 || N $.
    prmlem2.11 $e |- -. ; 1 1 || N $.
    prmlem2.13 $e |- -. ; 1 3 || N $.
    prmlem2.17 $e |- -. ; 1 7 || N $.
    prmlem2.19 $e |- -. ; 1 9 || N $.
    prmlem2.23 $e |- -. ; 2 3 || N $.
    $( Our last proving session got as far as 25 because we started with the
       two "bootstrap" primes 2 and 3, and the next prime is 5, so knowing that
       2 and 3 are prime and 4 is not allows us to cover the numbers less than
       ` 5 ^ 2 = 2 5 ` .  Additionally, nonprimes are "easy", so we can extend
       this range of known prime/nonprimes all the way until 29, which is the
       first prime larger than 25.  Thus, in this lemma we extend another
       blanket out to ` 2 9 ^ 2 = 8 4 1 ` , from which we can prove even more
       primes.  If we wanted, we could keep doing this, but the goal is
       Bertrand's postulate, and for that we only need a few large primes - we
       don't need to find them all, as we have been doing thus far.  So after
       this blanket runs out, we'll have to switch to another method (see
       ~ 1259prm ).

       As a side note, you can see the pattern of the primes in the indentation
       pattern of this lemma!  (Contributed by Mario Carneiro, 18-Feb-2014.)
       (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
    prmlem2 $p |- N e. Prime $=
      ( c5 c9 c1 c2 wcel wbr 2nn0 vx c7 cdc c3 cuz cfv cprime csn cdif cexp cle
      cv co wa cdivides wn wi clt eluzelre resqcld eluzle cc0 9nn0 deccl nn0rei
      cr nn0ge0i le2sq2 mpanl12 syl2anc nnrei resqcli w3a c8 cmul nn0cni sqvali
      c4 eqid 1nn0 6nn0 5nn0 8nn0 caddc 2timesi 2p2e4 oveq1i 4p1e5 eqtri 9p9e18
      c6 decaddc 5p2e7 7p1e8 4nn0 8p6e14 9t2e18 8p8e16 decaddci 9t9e81 decmul2c
      1p1e2 decmul1c breqtrri mpani mp3an12 sylc wb ltnle sylancr mpbid pm2.21d
      ltletr adantld adantl 9nn 3nn 1lt9 1lt3 9t3e27 nprmi pm2.21i 7nn0 decaddi
      7p2e9 prmlem0 5nn 1lt5 5t5e25 a1i 3nn0 3p2e5 7nn 1lt7 7t3e21 ax-1cn 2p1e3
      2cn addcomli 9p2e11 5t3e15 9nprm prmlem1a ) UAABDEFUANUBAUAUBOAUAOPPUCZAU
      AUUDPUDUCZAUAUUEPNUCZAUAUUFPUBUCZAUAUUGPOUCZAUAUUHQPUCZAUAUUIQUDUCZAUAUUJ
      QNUCZAUAUUKQUBUCZAUAUULQOUCZAUAULZUUMUEUFRZUUNUGQUHUIRZUUNQUJUMZAUKSZUNUU
      NAUOSUPZUQQUUMUOSUPUUOUURUUSUUPUUOUURUUSUUOAUUQURSZUURUPZUUOUUQVFRZUUMQUJ
      UMZUUQUKSZUUTUUOUUNUUMUUNUSZUTZUUOUUNVFRZUUMUUNUKSZUVDUVEUUMUUNVAUUMVFRVB
      UUMUKSUVGUVHUNUVDUUMQOTVCVDZVEZUUMUVIVGUUMUUNVHVIVJAVFRZUVCVFRZUVBUVDUUTU
      QABVKZUUMUVJVLUVKUVLUVBVMAUVCURSUVDUUTAVNVRUCZPUCZUVCURCUVCUUMUUMVOUMUVOU
      UMUUMUVIVPZVQQOUVNPUUMQWKUCZUUMUVITVCUUMVSZVTQWKTWAVDNVNQWKVNVRQUUMVOUMZU
      VQWBWCTWAUVSUUMUUMWDUMNVNUCUUMUVPWEQOQONVNUUMUUMTVCTVCUVRUVRQQWDUMZPWDUMV
      RPWDUMNUVTVRPWDWFWGWHWIWCWJWLWIUVQVSNQWDUMZPWDUMUBPWDUMVNUWAUBPWDWMWGWNWI
      WOWPWLQOUVQPOVNUUMVCTVCUVRVTWCPVNWKQOQVOUMVNVTWCWCWQXBWAWRWSWTXAXCWIXDAUV
      CUUQXMXEXFXGUUOUVKUVBUUTUVAXHUVMUVFAUUQXIXJXKXLXNXOUULUGRUULAUOSUPOUDUULX
      PXQXRXSXTYAYBQUBOUULQTYCTUULVSYEYDYFUUKUGRUUKAUOSUPNNUUKYGYGYHYHYIYAYBQNU
      BUUKQTWBTUUKVSWMYDYFUUJAUOSUPUUJUGRMYJQUDNUUJQTYKTUUJVSYLYDYFUUIUGRUUIAUO
      SUPUBUDUUIYMXQYNXSYOYAYBQPUDUUIQTVTTUUIVSQPUDYRYPYQYSZYDYFUUHAUOSUPUUHUGR
      LYJPOPQUUHQVTVCTUUHVSXBVTYTWSYFUUGAUOSUPUUGUGRKYJPUBOUUGQVTYCTUUGVSYEYDYF
      UUFUGRUUFAUOSUPNUDUUFYGXQYHXSUUAYAYBPNUBUUFQVTWBTUUFVSWMYDYFUUEAUOSUPUUEU
      GRJYJPUDNUUEQVTYKTUUEVSYLYDYFUUDAUOSUPUUDUGRIYJPPUDUUDQVTVTTUUDVSUWBYDYFO
      UGROAUOSUPUUBYBYTYFUBAUOSUPUBUGRHYJYEYFNAUOSUPNUGRGYJWMYFUUC $.
  $}

  $( 37 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  37prm $p |- ; 3 7 e. Prime $=
    ( c3 c7 3nn0 decnncl c8 c4 c1 4nn0 7nn0 1nn0 c6 c2 2nn0 cmul co caddc eqtri
    cdc cc0 ndvdsi 7nn 8nn0 deccl 7lt10 8nn 3lt10 declti decltc 3nn 1lt10 3t2e6
    df-7 dec2dvds 1nn 6nn0 6p1e7 eqid 3cn mulid1i oveq1i addid1i dec0h decmul2c
    0nn0 decsuc 1lt3 2nn 2lt5 dec5dvds2 c5 5nn0 7t5e35 decaddi 2lt7 4nn mulid2i
    5p2e7 00id oveq12i nncni 4p3e7 addcomli decmac 4lt10 2cn 2p1e3 decadd declt
    decmul1c 0p1e1 7t2e14 c9 9nn 9nn0 1p1e2 9p8e17 decaddc 8lt9 1lt2 prmlem2 )
    ABRZABCUADAEFRBGCEFUBHUCIJUDEFAUEHCUFUGUHABGUIIJUJUGAAKBCCUKULUMAXAGLRZGUIG
    LJMUCUNAKBAXBNOCUOUPGLAKASXBCJMXBUQUOVDAGNOZSPOASPOZAXCASPAURUSUTAURVAZQALN
    OKSKRUKKUOVBQZVCVEVFTALBCVGVHVQVIBXAVJLUAVKVGAVJBBVJNOLCVKMVLVQVMVNTGGRZXAA
    FGGJUNDZCVOGGSFAABSXGFJJVDHXGUQZFHVBCIVDGANOZSSPOZPOXDAXJAXKSPAURVPZVRVSXEQ
    XJFPOZBSBRXMAFPOBXJAFPXLUTFABFVOVTURWAWBZQBIVBQWCGGFUNJHWDUGTGARZXALXGGAJUI
    DMXHLKGGABXOLNOXGMUOJJGALKLSXOMJCXOUQUOVDGLNOZSPOLSPOLXPLSPLWEVPZUTLWEVAQXF
    WIXIWFUPWGGGAJJUIVFWHTGBRZXALAGBJUADMUIGBSALABGXRAJIVDCXRUQACVBMIJXPSGPOZPO
    LGPOZAXPLXSGPXQWJVSWFQGFBBLNOAJHCWKWAVMWCGBAUNICUFUGTGWLRZXAGGERZGWLJWMDZJG
    EJUEDGWLGEABYAGNOYBJWNJUBYAYAYCVTUSYBUQGGPOZGPOXTAYDLGPWOUTWFQIWPWQGEWLJUBW
    MWRWHTLARZXAGGFRZLAMUIDZJGFJVODLAGFABYEGNOYFMCJHYEYEYGVTUSYFUQWFXNWGGLFAJMH
    CWDWSUHTWT $.

  $( 43 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  43prm $p |- ; 4 3 e. Prime $=
    ( c4 c3 cdc 4nn0 c1 3nn0 1nn0 c2 1nn 0nn0 eqid cmul co caddc 2nn0 ndvdsi c7
    cc0 c9 c5 3nn decnncl c8 8nn0 deccl 3lt10 8nn 4lt10 declti decltc 4nn 1lt10
    2cn mulid2i dec2dvds dec0h mulid1i ax-1cn addid2i oveq12i 3p1e4 eqtri 2p1e3
    df-3 3cn 4cn 4t3e12 mulcomli decsuc decma2c 1lt3 3lt5 dec5dvds c6 6nn0 1lt7
    7t6e42 decnncl2 addid1i oveq1i 3eqtri decmac 0lt1 declt 3t3e9 9p4e13 nnnn0i
    7nn 9nn 2p2e4 7t2e14 1p1e2 nncni addcomli 9lt10 5nn 9t2e18 8p5e13 5lt10 2nn
    decaddci decadd 3pos prmlem2 ) ABCZABDUAUBAUCACBEDUCAUDDUEFGUFUCAAUGDDUHUIU
    JABEUKFGULUIAEHBDGHUMUNZVDUOBXEEACZEUAEAGDUEIEAREBABEXGEGDJGXGKEGUPFFGBELMZ
    RENMZNMBENMZAXHBXIENBVEUQEURUSZUTVAVBEHBBALMGOVCABEHCVFVEVGVHVIVJVKPABDUAVL
    VMQXEVNEWHVOIAHBQVNLMDOVCVQVIVPPEECZXEBERCZEEGIUBFEIVREEERBABRXLXMGGGJXLKXM
    KFFJEBLMZERNMZNMXJAXNBXOENBVEUNZEURVSUTVAVBXNRNMBRNMBRBCXNBRNXPVTBVEVSZBFUP
    WAWBEREGJIWCWDPEBCZXEBAEBGUAUBFUKEBRABABEXRAGFJDXRKADUPFFGXNXINMXJAXNBXIENX
    PXKUTVAVBBBLMZANMSANMXRXSSANWEVTWFVBWBEBAIFDUHUIPEQCZXEHSEQGWHUBOWIEQRSHABH
    XTSGQWHWGZJSWIWGZXTKSYBUPOFOEHLMZRHNMZNMHHNMAYCHYDHNXFHUMUSUTWJVBZEABHQHLMS
    GDYBWKWLFSAXRSWIWMVFWFWNXAWBEQSIYAYBWOUIPESCZXEHTESGWIUBOWPESRTHABHYFTGYBJT
    WPWGZYFKTYGUPOFOYEEUCBHSHLMTGUDYGWQWLFWRXAWBESTIYBYGWSUIPHBCZXEEHRCZHBOUAUB
    ZGHWTVRHBHRABYHELMYIOFOJYHYHYJWMUQYIKWJXQXBHRBOJUAXCWDPXD $.

  $( 83 is a prime number.  (Contributed by Mario Carneiro, 18-Feb-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  83prm $p |- ; 8 3 e. Prime $=
    ( c8 c3 cdc 8nn0 decnncl c4 c1 4nn0 3nn0 1nn0 c2 c7 2nn0 7nn0 cmul co caddc
    c6 eqtri c5 3nn deccl 3lt10 8nn 8lt10 declti decltc 1lt10 2cn df-3 dec2dvds
    mulid2i 2nn cc0 0nn0 eqid dec0h 3t2e6 addid2i oveq12i 6p2e8 nn0cni mulcomli
    3cn 7t3e21 ax-1cn 2p1e3 addcomli decaddi decma2c 2lt3 3lt5 dec5dvds 7nn 6nn
    ndvdsi nnnn0i mulid1i 7p1e8 oveq1i 7p6e13 6lt7 1nn nncni mulcomi 5nn 6t3e18
    6lt10 1p1e2 8p5e13 decaddci decmac 5lt10 3p1e4 4p4e8 7t4e28 5lt7 declt 9nn0
    c9 9nn 9t4e36 7lt10 4nn 3t3e9 9p4e13 4lt10 1lt2 prmlem2 ) ABCZABDUAEAAFCBGD
    AFDHUBIJUCAFAUDHDUEUFUGABGUDIJUHUFAGKBDJKUIULUJUKBXJKLCZKUAKLMNUBUMKLUNKBAB
    KXKKMNUOMXKUPKMUQIIMBKOPZUNKQPZQPRKQPZAXLRXMKQURKUIUSZUTVASKGBBLOPKMJMLBKGC
    LNVBZVDVEVCKGBUIVFVGVHVIVJVKVPABDUAVLVMLXJGGCZRVNGGJJUBVOGGUNRLABGXQRJJUORV
    OVQZXQUPRXRUQNIJLGOPZUNGQPZQPLGQPAXSLXTGQLXPVRZGVFUSUTVSSXSRQPLRQPGBCZXSLRQ
    YAVTWASVJZWBVPXQXJLRGGJWCEZNVOXQLOPZRQPLXQOPZRQPXJYEYFRQXQLXQYDWDXPWEVTYCSG
    GRWCJXRWHUFVPYBXJRTGBJUAEXRWFGBUNTRABKYBTJIUOTWFVQZYBUPTYGUQXRIMGROPZXMQPXN
    AYHRXMKQRRVOWDZULXOUTVASGABKBROPTJDYGRBGACYIVDWGVCWIIWJWKWLGBTWCIYGWMUFVPGL
    CZXJFGTCZGLJVNEHGTJWFEGLGTFABBYJYKJNJYGYJUPYKUPHIIGFOPZGBQPZQPFFQPZAYLFYMFQ
    FFHVBZULZBGFVDVFWNVHUTWOSKABBLFOPTMDYGWPVGIWJWKWLGTLJYGVNWQWRVPGWTCZXJFLGWT
    JXAEHVNGWTUNLFABFYQLJWSUONYQUPLNUQHIHYLUNFQPZQPYNAYLFYRFQYPFYOUSUTWOSBRBFWT
    FOPLIXRNXBWNILRYBXPYIWAVHWKWLGWTLWCWSNXCUFVPKBCZXJBGFCZKBMUAEIGFJXDEKBGFBAB
    GYSYTMIJHYSUPYTUPIIJKBOPZGGQPZQPXNAUUARUUBKQBKRVDUIURVCWIUTVASBBOPZFQPWTFQP
    YBUUCWTFQXEVTXFSWLGKFBJMHIXGXHUGVPXI $.

  $( 139 is a prime number.  (Contributed by Mario Carneiro, 19-Feb-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  139prm $p |- ; ; 1 3 9 e. Prime $=
    ( c1 c3 cdc c9 1nn0 3nn0 c8 c4 9nn0 c6 6nn0 cc0 0nn0 cmul co caddc c2 eqtri
    2nn0 c7 deccl 9nn decnncl 8nn0 4nn0 9lt10 3lt10 1lt8 decltc 3nn 1lt10 4t2e8
    declti df-9 dec2dvds 1nn eqid dec0h ax-1cn addid2i oveq2i nn0cni 3cn 4t3e12
    2p1e3 mulcomli decsuc 8p1e9 6t3e18 decma2c 1lt3 ndvdsi 4lt5 5p4e9 dec5dvds2
    4nn 7nn 6nn 7nn0 nncni mulid1i oveq12i 7p6e13 9t7e63 6p3e9 addcomli decaddi
    6lt7 2cn mulid2i 00id addid1i oveq1i 7p2e9 3eqtri decmac 7lt10 10nn0 mul01i
    c10 dec10 c5 5nn0 8nn 5nn 8p5e13 8t7e56 6lt10 6t2e12 2nn prmlem2 ) ABCZDCZX
    LDABEFUAZUBUCXLGHCDAXNGHUDUEUAIEUFAGBHEUDFUEUGUHUIUIXLDAABEUJUCZIEUKUMXLHGD
    XNUEULUNUOBXMHJCZAUJHJUEKUAUPHJLABXLDAXPAUEKMEXPUQAEURZFIEBHNOZLAPOZPOXRAPO
    XLXSAXRPAUSUTZVAAQBXRESVEHBAQCZHUEVBVCVDVFVGRAGDBJNOEUDVHJBAGCJKVBZVCVIVFVG
    ZVJVKVLXLHDXNVPVMVNVOTXMADCZJVQADEIUAVRADLJTXLDJYDJEIMKYDUQZJKURZVSIKTANOZL
    JPOZPOTJPOZXLYGTYHJPTTVQVTZWAJYBUTZWBWCRJBDTDNOJKFKDTJBCDUBVTZYJWDVFJBDYBVC
    WEWFZWGVJWHVLAACZXMYATAAEUPUCZAQESUAVQAQLTYNXLDQYATESMVSYAUQTVSURZAAEEUAISY
    NANOZLQPOZPOYQQPOXLYRQYQPQWIUTVAAABYQQEESYNYNYOVTWAQABWIUSVEWFWGRAALTQQDLYN
    TEEMVSYNUQYPSIMAQNOZLLPOZPOQLPOQYSQYTLPQWIWJZWKWBQWIWLRYSTPOQTPODLDCZYSQTPU
    UAWMTQDYJWIWNWFDIURZWOWPVJAATUPEVSWQUMVLXLXMWTDXOWRUBALLDXLXLDLWTDEMMIXAUUC
    XNIMABLLAABLXLYTEFMMXLUQYTLLLCWKLMURREFMAANOZYTPOALPOAUUDAYTLPAUSWAWKWBAUSW
    LRBANOZLPOBLPOBLBCUUEBLPBVCWAWMBVCWLBFURZWOWPXLLNOZDPOLDPODUUBUUGLDPXLXLXNV
    BWSWMDYLUTUUCWOVJABDUPFIUFUMVLATCZXMGBATEVQUCUDUJATLBGXLDXBUUHBEVSMFUUHUQUU
    FUDIXCAGNOZLXBPOZPOGXBPOXLUUIGUUJXBPGGXDVTZWJXBXBXEVTUTWBXFRXBJDTGNOBXCKFGT
    XBJCUUKYJXGVFWEWGWPATBUPVSFUGUMVLYDXMTJADEUBUCVSVRADLJTXLDJYDJEIMKYEYFVSIKA
    TNOZYHPOYIXLUULTYHJPTYJWJYKWBWCRJBDDTNOJKFKWDYMWGWPADJUPIKXHUMVLQBCZXMJAQBS
    UJUCKUPQBLAJXLDAUUMASFMEUUMUQXQKIEQJNOZXSPOUUNAPOXLXSAUUNPXTVAAQBUUNESVEJQY
    AYBWIXIVFVGRYCWPQBAXJFEUKUMVLXK $.

  $( 163 is a prime number.  (Contributed by Mario Carneiro, 19-Feb-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  163prm $p |- ; ; 1 6 3 e. Prime $=
    ( c1 c6 cdc c3 1nn0 c8 c4 3nn0 c2 c5 cc0 0nn0 cmul co caddc eqtri 2nn0 7nn0
    c7 c9 6nn0 deccl 3nn decnncl 8nn0 4nn0 3lt10 6lt10 1lt8 decltc 1lt10 declti
    6nn 2cn mulid2i df-3 dec2dvds 5nn0 1nn eqid dec0h ax-1cn addid2i oveq2i 5nn
    5p1e6 nncni 3cn 5t3e15 mulcomli decsuc 2p1e3 4cn 4t3e12 decma2c 1lt3 ndvdsi
    3lt5 dec5dvds 7nn 2nn 7t2e14 4p2e6 decaddi 7t3e21 addcomli 2lt7 9nn mulid1i
    9nn0 oveq12i 4p1e5 oveq1i 9p4e13 decmac 9lt10 00id 3p3e6 3t2e6 7p6e13 7lt10
    addid1i c10 10nn dec10 6p1e7 9p7e16 9t7e63 clt 7pos declt eqbrtri 8nn 7p1e8
    nn0cni 8p8e16 9t8e72 1lt9 2lt10 prmlem2 ) ABCZDCZYADABEUAUBZUCUDYAFGCDAYCFG
    UEUFUBHEUGAFBGEUEUAUFUHUIUJUJYADAABEUMUDHEUKULYAAIDYCEIUNUOZUPUQDYBJGCZAUCJ
    GURUFUBUSJGKADYADAYEAURUFLEYEUTAEVAHHEDJMNZKAONZONYFAONYAYGAYFOAVBVCZVDAJBY
    FEURVFJDAJCJVEVGZVHVIVJVKPAIDDGMNEQVLGDAICZVMVHVNVJVKVOVPVQYADYCUCVRVSSYBID
    CZIVTIDQHUBWAIDKISYADIYKIQHLQYKUTZIQVAZRHQSIMNZKIONZONYNIONYAYOIYNOIUNVCZVD
    AGBYNIEUFQWBWCWDPIADSDMNIQEQWEIADUNVBVLWFZWDVOWGVQAACZYBAGCZTAAEUSUDZAGEUFU
    BWHAGKTYRYADJYSTEUFLWJYSUTTWJVAZAAEEUBHURYRAMNZKJONZONUUBJONYAUUCJUUBOJYIVC
    VDAABUUBJEEURYRYRYTVGWIJABYIVBVFWFWDPAAKTGJDAYRTEELWJYRUTZUUAUFHEAGMNZYGONG
    AONJUUEGYGAOGVMUOZYHWKWLPUUETONGTONADCZUUEGTOUUFWMTGUUGTWHVGZVMWNWFPWOVOAAT
    USEWJWPULVQUUGYBYJSADEUCUDAIEQUBVTAIKSUUGYADDYJSEQLRYJUTSRVAZADEHUBHHADKDAA
    BKUUGKDONZEHLHUUGUTZUUJDKDCDVHVCDHVAPEUALAAMNZKKONZONAKONAUULAUUMKOAVBWIWQW
    KAVBXBPDAMNZDONZBKBCUUODDONBUUNDDODVHWIWMWRPBUAVAPWOADKSIDDAUUGSEHLRUUKUUIQ
    HEAIMNZYGONIAONDUUPIYGAOYDYHWKVLPDIMNZSONBSONUUGUUQBSOWSWMSBUUGSVTVGZBUMVGZ
    WTWFPWOVOADSUSHRXAULVQASCZYBTXCASEVTUDWJXDASAKTYADBUUTXCERELUUTUTXEWJHUAATM
    NZABONZONTSONYAUVATUVBSOTUUHUOBASUUSVBXFWFWKXGPSTMNZKONBDCZKONUVDUVCUVDKOTS
    UVDUUHUURXHVJWMUVDUVDBDUAHUBXOXBPWOXCAKCUUTXIXEAKSELVTXJXKXLVQATCZYBFYRATEW
    HUDUEYTATAAFYADSUVEYREWJEEUVEUTUUDUEHRAFMNZASONZONFFONYAUVFFUVGFOFFXMVGUOSA
    FUURVBXNWFWKXPPSIDTFMNRQVLXQVKWOAATEEWHXRXKVQYKYBSIIDQUCUDRWAIDKISYADIYKIQH
    LQYLYMRHQISMNZYOONUVHIONYAYOIUVHOYPVDAGBUVHIEUFQSIYSUURUNWBVJWCWDPIADDSMNIQ
    EQSDIACUURVHWEVJYQWDWOIDIWAHQXSULVQXT $.

  $( 317 is a prime number.  (Contributed by Mario Carneiro, 19-Feb-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  317prm $p |- ; ; 3 1 7 e. Prime $=
    ( c3 c1 cdc c7 3nn0 1nn0 c8 c4 7nn0 c6 c5 c2 5nn0 cc0 2nn0 caddc eqtri cmul
    co c9 deccl 7nn decnncl 8nn0 4nn0 7lt10 1lt10 3lt8 decltc declti 3t2e6 df-7
    1nn dec2dvds c10 3nn 10nn0 2nn 0nn0 eqid dec0h dec10 ax-1cn addid2i mulid1i
    3cn oveq12i addid1i mul01i oveq1i decma2c 5nn nncni 5t3e15 mulcomli decaddi
    00id 5p2e7 2lt3 ndvdsi dec5dvds2 oveq2i 7t4e28 2p1e3 8p3e11 decaddci 7t5e35
    2lt5 2lt7 9nn 9nn0 mulid2i 9p2e11 addcomli decmac 8p1e9 9p8e17 9lt10 6p5e11
    2cn 8nn 4cn 4p1e5 4t3e12 5lt10 3p1e4 decadd 1p1e2 7p4e11 8p5e13 6nn0 8t7e56
    6p1e7 decsuc 1lt7 declt 6nn 9t6e54 4p3e7 3lt9 nnnn0i 7p1e8 3t3e9 8lt10 1lt2
    prmlem2 ) ABCZDCZYGDABEFUAZUBUCYGGHCDBYIGHUDUEUAIFUFAGBHEUDFUEUGUHUIUIYGDBA
    BEUMUCIFUGUJYGAJDYIEUKULUNAYHUOKCZLUPUOKUQMUAURUOKNLAYGDBYJLUQMUSOYJUTLOVAZ
    EIFBNNBAABNUONBPSZFUSUSFVBYLBNBCZBVCVDZBFVAZQEFUSABRSZNNPSZPSANPSAYPAYQNPAV
    FVEZVQVGAVFVHQANRSZBPSZBYMYTYLBYSNBPAVFVIVJYNQYOQVKBKDAKRSLFMOKABKCKVLVMZVF
    VNVOVRVPVKVSVTYGLDYIURWHVRWADYHHKCZLUBHKUEMUAURHKNLDYGDAUUBLUEMUSOUUBUTYKII
    EDHRSZNAPSZPSUUCAPSYGUUDAUUCPAVFVDWBLGBAUUCAOUDEWCWDFWEWFQAKDDKRSLEMOWGVRVP
    VKWIVTBBCZYHLGCZTBBFUMUCZLGOUDUAWJLGNTUUEYGDTUUFTOUDUSWKUUFUTTWKVAZBBFFUAZI
    WKBBNTLABBUUENTPSZFFUSWKUUEUTZUUJTNTCTTWJVMZVDUUHQOFFBLRSZYLPSLBPSZAUUMLYLB
    PLWTWLZYNVGWDQZUUMTPSLTPSUUEUUMLTPUUOVJTLUUEUULWTWMWNQWOBBNTGTDBUUETFFUSWKU
    UKUUHUDIFBGRSZYLPSGBPSTUUQGYLBPGGXAVMZWLZYNVGWPQUUQTPSGTPSBDCZUUQGTPUUSVJTG
    UUTUULUURWQWNQWOVKBBTUMFWKWRUJVTBACZYHLHCZKBAFUPUCZLHOUEUAVLLHNKUVAYGDKUVBK
    OUEUSMUVBUTKMVAZBAFEUAZIMBANKLABBUVANKPSZFEUSMUVAUTZUVFKNKCKUUAVDZUVDQOFFUU
    PALRSZKPSJKPSZUUEUVIJKPUKVJWSQWOBANKHKDBUVAKFEUSMUVGUVDUEIFBHRSZYLPSHBPSKUV
    KHYLBPHXBWLYNVGXCQBLDAHRSKFOMHABLCXBVFXDVOKLDUUAWTVRWNVPWOVKBAKUMEMXEUJVTUU
    TYHBGCZUUEBDFUBUCBGFUDUAUUGBGBBUUTYGDUVAUVLUUEFUDFFUVLUTZUUKBDFIUAIUVEBDBHB
    ABBUUTBUVAPSFIFUEUUTUTZNBBABHBUVAUSFFEYOUVGYNABHVFVCXFWNXGFFFBBRSZBBPSZPSBL
    PSAUVOBUVPLPBVCVEXHVGLBAWTVCWDWNQZDBRSZHPSDHPSUUEUVRDHPDDUBVMZVEVJXIQWOBDNB
    GUVADKUUTBFIUSFUVNYOUDIMUUQUVFPSGKPSUVAUUQGUVFKPUUSUVHVGXJQKJDDGRSMXKXMGDKJ
    CUURUVSXLVOXNWOVKBBDFFUBXOXPVTBTCZYHBJCZUVABTFWJUCBJFXKUAUVCBJBAUVTYGDUUEUW
    AUVAFXKFEUWAUTUVGBTFWKUAIUUIBTBLBABBUVTBUUEPSFWKFOUVTUTZNBBBBLBUUEUSFFFYOUU
    KYNXHXGFFFUVQTBRSZLPSTLPSUUEUWCTLPTUULVEVJWMQWOBTNAJUUEDKUVTAFWKUSEUWBAEVAX
    KIMBJRSZUVFPSUVJUUEUWDJUVFKPJJXQVMWLUVHVGWSQKHDTJRSAMUEEXRXSVPWOVKBATFEWJXT
    XPVTLACZYHUVAUVLLAOUPUCUVAUVCYABGFXAUCBABGUWEYGDDUVAUVLFEFUDUVGUVMLAOEUAIIL
    ANGBABBUWEBDPSZOEUSUDUWEUTZUWFGNGCDBGUVSVCYBWNGUDVAZQFFFLBRSZYLPSUUNAUWILYL
    BPLWTVEYNVGWDQYPGPSAGPSUUEYPAGPYRVJGAUUEUURVFWEWNQWOLANGADDBUWEGOEUSUDUWGUW
    HEIFLARSZYLPSJBPSDUWJJYLBPALJVFWTUKVOYNVGXMQAARSZGPSTGPSUUTUWKTGPYCVJWQQWOV
    KBLGAFOUDEYDYEUIVTYF $.

  $( 631 is a prime number.  (Contributed by Mario Carneiro, 1-Mar-2014.)
     (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
  631prm $p |- ; ; 6 3 1 e. Prime $=
    ( c6 c3 cdc c1 3nn0 deccl c8 c4 4nn0 1nn0 cc0 0nn0 c2 2nn0 caddc co cmul c7
    7nn0 c5 6nn0 1nn decnncl 8nn0 1lt10 3lt10 6lt8 decltc 3nn declti 2cn mul02i
    1e0p1 dec2dvds eqid dec0h eqtri 3t2e6 oveq12i 6nn nncni addid1i 3cn mulid1i
    00id oveq1i 3eqtri decma2c mul01i 0p1e1 1lt3 ndvdsi 1lt5 dec5dvds c9 oveq2i
    7nn 9nn0 9nn 9t7e63 mulcomli nn0cni 1lt7 5nn0 4nn 8nn addid2i mulid2i 5p1e6
    5nn 8p5e13 addcomli decmac 7p1e8 7p4e11 4lt10 4cn 1p1e2 4p2e6 2p1e3 decaddi
    4t3e12 8p3e11 8t3e24 decaddci 7lt10 ax-1cn 3p3e6 7t3e21 7p5e12 7t7e49 4p1e5
    2nn 9p2e11 2lt10 9t3e27 7p6e13 c10 dec10 6p1e7 decadd 2t2e4 7t2e14 decmul1c
    10nn clt 10pos 1lt2 eqbrtri prmlem2 ) ABCZDCZYKDABUAEFZUBUCYKGHCDDYMGHUDIFJ
    JUEAGBHUAUDEIUFUGUHUHYKDDABUAUIUCJJUEUJYKKKDYMLMUKULUMUNBYLMDCZKCZDUIYNKMDN
    JFZLFUBYNKKDBYKDKYODYPLLJYOUODJUPZEJLMDKKBABKYNKKOPZNJLLYNUOYRKKKCVEKLUPUQE
    ELBMQPZYROPAKOPAYSAYRKOURVEUSAAUTVAZVBUQBDQPZKOPBKOPBKBCUUABKOBVCVDVFBVCVBB
    EUPVGVHBKQPZDOPKDOPZDKDCZUUBKDOBVCVIVFVJYQVGVHVKVLYKDYMUBVMVNRYLVOKCZDVQVOK
    VRLFUBVOKKDRYKDKUUEDVRLLJUUEUOYQSJLRVOQPZYROPUUFKOPYKKOPYKYRKUUFOVEVPUUFYKK
    OVORYKVOVSVARVQVAZVTWAVFYKYKYMWBVBVGRKQPZDOPUUCDUUDUUHKDORUUGVIVFVJYQVGVHWC
    VLDDCZYLTRCZHDDJUBUCTRWDSFWETRKHUUIYKDGUUJHWDSLIUUJUOHIUPZDDJJFZJUDDDKGTABD
    UUIKGOPZJJLUDUUIUOZUUMGKGCGGWFVAZWGGUDUPUQWDEJDTQPZUUCOPTDOPAUUPTUUCDOTTWJV
    AZWHZVJUSWIUQUUPGOPTGOPDBCZUUPTGOUURVFGTUUSUUOUUQWKWLUQWMDDKHRGDDUUIHJJLIUU
    NUUKSJJDRQPZUUCOPRDOPGUUTRUUCDORUUGWHZVJUSWNUQUUTHOPRHOPUUIUUTRHOUVAVFWOUQW
    MVHDDHUBJIWPUJVLUUSYLHGCZRDBJUIUCHGIUDFVQHGKRUUSYKDUUIUVBRIUDLSUVBUORSUPZDB
    JEFJUULDBDDHABDUUSKUUIOPJEJJUUSUOZUUIUUIUULWBWGIEJDHQPZDDOPZOPHMOPZAUVEHUVF
    MOHWQWHWRUSWSUQDMBBHQPDJNJHBDMCZWQVCXBWAWTXAWMDBKRGUUIDBUUSRJELSUVDUVCUDJED
    GQPZKBOPZOPGBOPUUIUVIGUVJBOGUUOWHBVCWGZUSXCUQMHDBBGQPRNISGBMHCUUOVCXDWAWTJR
    HUUIUUGWQWOWLXEWMVHDBRUBESXFUJVLDRCZYLBRCZMDRJVQUCBRESFXMBRKMUVLYKDUVHUVMME
    SLNUVMUOMNUPZDRJSFJDMJNFZDRDMBABMUVLKUVHOPJSJNUVLUOZUVHUVHUVOWBWGEENDBQPZDM
    OPZOPBBOPZAUVQBUVRBOBVCWHZMDBUKXGWTWLZUSXHUQMDBRBQPMNJNXIUWAXAWMDRKMRUVHDTU
    VLMJSLNUVPUVNSJWDUUTKTOPZOPRTOPUVHUUTRUWBTOUVATUUQWGUSXJUQHVODTRRQPMIVRNXKX
    LJXNXEWMVHDRMUBSNXOUJVLDVOCZYLBBCZHDVOJVSUCBBEEFWEBBKHUWCYKDAUWDHEELIUWDUOU
    UKDVOJVRFJUADVOKABABBUWCKAOPZJVRLUAUWCUOZUWEAKACAYTWGAUAUPUQEEEUVQUVJOPUVSA
    UVQBUVJBOUVTUVKUSXHUQZMRBBVOBQPZANSUAXPWTEXQXEWMDVOKHBADBUWCHJVRLIUWFUUKEJE
    UWGMRDBUWHHNSIXPWTJWOXEWMVHDVOHUBVRIWPUJVLMBCZYLMRCZXRMBNUIUCMRNSFYEMRDKUWI
    YKDDACZUWJXRNSJLUWJUOXSMBNEFJDAJUAFZMBDRMABDUWIDUWKOPNEJSUWIUOZKDDADRDUWKLJ
    JUAYQUWKUOVJADRYTXGXTWLYANEJMMQPZUVFOPUVGAUWNHUVFMOYBWRUSWSUQYSROPAROPUUSYS
    AROURVFRAUUSUUGYTXQWLUQWMUWIRQPZKOPUWKDCZKOPUWPUWOUWPKOMBUWKDRMUWISNEUWMJND
    HAMRQPMJINRMDHCUUGUKYCWAWSXARBYNUUGVCXIWAYDVFUWPUWPUWKDUWLJFWBVBUQVHXRDKCUW
    IYFXSDMKBJNLEYGYHUHYIVLYJ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             Very large primes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z $.
    ${
      1259prm.1 $e |- N = ; ; ; 1 2 5 9 $.
      $( Lemma for ~ 1259prm .  Calculate a power mod.  In decimal, we
         calculate ` 2 ^ 1 6 = 5 2 N + 6 8 == 6 8 ` and
         ` 2 ^ 1 7 == 6 8 x. 2 = 1 3 6 ` in this lemma.  (Contributed by Mario
         Carneiro, 22-Feb-2014.)  (Revised by Mario Carneiro, 20-Apr-2015.) $)
      1259lem1 $p |- ( ( 2 ^ ; 1 7 ) mod N ) = ( ; ; 1 3 6 mod N ) $=
        ( c2 c1 c6 cdc cc0 c8 c3 c5 1nn0 2nn0 5nn0 6nn0 8nn0 3nn0 co cmul caddc
        c10 c7 c9 cn deccl 9nn decnncl eqeltri 2nn 0z cexp nn0zi nn0expcli eqid
        cmo nn0cni 2cn 8t2e16 mulcomli c4 9nn0 4nn0 7nn0 0nn0 dec0h 4cn addid2i
        oveq1i 4p1e5 eqtri 7nn nncni 7p6e13 addcomli decaddc 2p1e3 6p5e11 10nn0
        6nn 5nn dec10 ax-1cn addid1i decadd mulid1i oveq12i 5p1e6 3eqtri decmac
        3cn 3p2e5 5t2e10 00id 2t2e4 decma2c oveq2i 5t5e25 decsuc decaddi 9t5e45
        5p2e7 9t2e18 1p1e2 8p8e16 decaddci 2exp16 numexp2x 3eqtr2i mod2xi 6p1e7
        10nn mul02i 6t2e12 decmul1c 3eqtr4i modxp1i ) CDEFZGDUAFEHFZDIFZEFZAADC
        FZJFZUBFUCBYAUBXTJDCKLUDZMUDZUEUFUGZUHDEKNUDUIEHNOUDZXREDIKPUDNUDZCHJCF
        ZXPCHUJQZXQAYDUHOYGJCMLUDZUKCHLOULYEYHAUNQUMHCXPHOUOUPUQURZYGARQXQSQEJF
        ZJFZIFZEFCXPUJQYHYHRQZYAUBEHYGYMEUSUAFZAXQYCUTNOBXQUMZYINUSUAVAVBUDXTJJ
        IYGYLICEFZYAEYOSQYBMMPYAUMGEUSUAJIEYOVCNVAVBENVDYOUMGUSSQZDSQUSDSQZJYRU
        SDSUSVEVFVGVHVIPUAEXRUAVJVKEVRVKZVLVMVNYIPCELNUDDCIDYGYKJTXTJYQSQKLPKXT
        UMGJCEIDJYQVCMLNJMVDZYQUMGCSQZDSQCDSQIUUBCDSCUPVFZVGVOVIKEJDDFYTJVSVKZV
        PVMVNYIMVQJCDIDEJGYGITSQMLKPYGUMZGIDGDIITVCPKVCIPVDZVTDWAVFZIWIWBWCKMVC
        JDRQZDGSQZSQJDSQEUUHJUUIDSJUUDWDDWAWBWEWFVICDRQZISQCISQJGJFZUUJCISCUPWD
        VGICJWIUPWJVMUUAWGWHJCGDCTJGYGDMLVCKUUEDKVDLMVCJCRQZGGSQZSQTGSQTUULTUUM
        GSWKWLWETTXJVKWBVICCRQZDSQYSJUUKUUNUSDSWMVGVHUUAWGWHWNJCGIJYQIDYGIMLVCP
        UUEUUFMPKJJRQZGDSQZSQUUODSQYQUUPDUUOSUUGWOCJEUUOLMWFWPWQVIDGICJRQZIKVCP
        UUQTDGFJCTUUDUPWKURVTVIIWIVFWRWHWNJCGHUBYOECYGHMLVCOUUEHOVDUTNLJUBRQZUU
        BSQUURCSQYOUUBCUURSUUCWOUSJUAUURCVAMLUBJUSJFUBUEVKZUUDWSURWTWRVIDHECCUB
        RQHKOOUBCDHFUUSUPXAURXBNXCXDWHWNXECYNYHHXPLOYJYHUMYNUMXFXGXHDEUAXPKNXIX
        PUMWQGXSSQXSGARQZXSSQXQCRQXSXSYFUOVFUUTGXSSAAYDVKXKVGEHXRECDXQLNOYPNKDC
        IECRQKLVOXLWQUQXMXNXO $.

      $( Lemma for ~ 1259prm .  Calculate a power mod.  In decimal, we
         calculate
         ` 2 ^ 3 4 = ( 2 ^ 1 7 ) ^ 2 == 1 3 6 ^ 2 == 1 4 N + 8 7 0 ` .
         (Contributed by Mario Carneiro, 22-Feb-2014.)  (Revised by Mario
         Carneiro, 20-Apr-2015.) $)
      1259lem2 $p |- ( ( 2 ^ ; 3 4 ) mod N ) = ( ; ; 8 7 0 mod N ) $=
        ( c2 c1 cdc c4 c3 c6 c8 cc0 c5 c9 1nn0 4nn0 3nn0 6nn0 0nn0 cmul caddc
        co c7 2nn0 deccl 5nn0 9nn decnncl eqeltri 7nn0 nn0zi 8nn0 1259lem1 eqid
        cn 2nn 2cn mulid1i oveq1i 2p1e3 eqtri 7nn 7t2e14 mulcomli decmul2c 9nn0
        nncni 8p1e9 7p2e9 decadd 9p7e16 3cn ax-1cn 3p1e4 addcomli dec0h oveq12i
        00id addid1i 4cn 4p4e8 3eqtri decmac mulid2i addid2i 8p6e14 decma2c 5nn
        4t2e8 5p2e7 5t4e20 decaddi 9p3e12 9t4e36 nn0cni 8nn 4p1e5 5p3e8 6nn c10
        decmul1c 3t3e9 9p1e10 dec10 6t3e18 8p3e11 decaddci 6t6e36 eqtr4i mod2xi
        6p2e8 1p1e2 ) CDUAEZDFEZGFEDGEZHEZIUAEZJEZAADCEZKEZLEUMBXRLXQKDCMUBUCZU
        DUCZUEUFUGUNDUAMUHUCXLDFMNUCZUIXMHDGMOUCZPUCZXOJIUAUJUHUCZQUCABUKDUAGFC
        DXKUBMUHXKULNMCDRTZDSTCDSTZGYECDSCUOUPUQURUSUACXLUAUTVEUOVAVBVCXLARTXPS
        TDIEZFEZLEZHEXNXNRTXRLXOJXLYIHXQAXPXTVDYDQBXPULYAPXSXQKLLXLYHLUAXRXOXQS
        TXSUDVDVDXRULIUADCLLXOXQUJUHMUBXOULXQULZVFVGVHYAVDUHDCDHXLYGFGXQLUASTMU
        BMPYJVIYANODFJFDDIJXLDGSTZMNQNXLULZYKFJFEGDFVJVKVLVMFNVNUSMUJQDDRTZJJST
        ZSTDJSTDYMDYNJSDVKUPVPVODVKVQUSZFDRTZFSTFFSTIJIEZYPFFSFVRUPUQVSIUJVNZVT
        WADFJHCGFDXLHMNQPYLHPVNUBNMDCRTZJDSTZSTYFGYSCYTDSCUOWBDVKWCZVOURUSFCRTZ
        HSTIHSTXLUUBIHSWGUQWDUSWAWEDFJLKUALCXLLMNQVDYLLVDVNUDVDUBDKRTZJCSTZSTKC
        STUAUUCKUUDCSKKWFVEZWBCUOWCZVOWHUSCJLFKRTLUBQVDKFCJEUUEVRWIVBLLUEVEZWCW
        JWAWEXLLRTZJSTXQHEZJSTUUIUUHUUIJSDFXQHLGXLVDMNYLPODLRTZGSTLGSTXQUUJLGSL
        UUGWBUQWKUSLFGHEUUGVRWLVBWSUQUUIUUIXQHXSPUCWMVQUSWEXMHYIHXNIDEZXNYCYBPX
        NULZPIDUJMUCDGIDXNYHLFJEZXMUUKMOUJMXMULZUUKULYCVDFJNQUCXMHFIDYGFDXNIUUM
        STYBPNUJUULJIFJFIIUUMQUJNQYRUUMULFVRWCIIWNVEZVQVHMNMDGJKDDIJXMFDSTZMOQU
        DUUNUUPKJKEWOKUDVNUSMUJQYOGDRTZKSTGKSTIYQUUQGKSGVJUPUQKGIUUEVJWPVMYRVTW
        AHDRTZISTHISTXLUURHISHHWQVEZUPUQIHXLUUOUUSWDVMUSWAXMHJDGUUMLDXNDYBPQMUU
        LDMVNZOVDMDGJDGFJDXMYTMOQMUUNYTDJDEUUAUUTUSOQMDGRTZYTSTGDSTFUVAGYTDSGVJ
        WBUUAVOVLUSGGRTZDSTLDSTWRDJEUVBLDSWTUQXAXBVTWADILHGRTDMUJMXCVFWJWAWEXMH
        UUKHHGXNPYBPUULPODGJGHIDCXMGMOQOUUNGOVNPMUBDHRTZUUDSTHCSTIUVCHUUDCSHUUS
        WBUUFVOXIUSDIDCGHRTGMUJOHGYGUUSVJXCVBXJMXDXEWAXFWSVCXGXH $.

      $( Lemma for ~ 1259prm .  Calculate a power mod.  In decimal, we
         calculate ` 2 ^ 3 8 = 2 ^ 3 4 x. 2 ^ 4 == 8 7 0 x. 1 6 = 1 1 N + 7 1 `
         and ` 2 ^ 7 6 = ( 2 ^ 3 4 ) ^ 2 == 7 1 ^ 2 = 4 N + 5 == 5 ` .
         (Contributed by Mario Carneiro, 22-Feb-2014.)  (Revised by Mario
         Carneiro, 20-Apr-2015.) $)
      1259lem3 $p |- ( ( 2 ^ ; 7 6 ) mod N ) = ( 5 mod N ) $=
        ( c2 c3 c8 cdc c4 c7 c6 c1 c5 c9 1nn0 2nn0 cc0 4nn0 0nn0 co cmul caddc
        cn deccl 5nn0 9nn decnncl eqeltri 2nn 3nn0 8nn0 4nn nnzi nn0zi 1259lem2
        7nn0 6nn0 cexp cmo 2exp4 oveq1i eqid 4p4e8 decaddi c10 9nn0 10nn0 dec0h
        dec10 0p1e1 7nn nncni addid1i decadd 6nn ax-1cn 6p1e7 eqtri 2cn addid2i
        addcomli mulid1i 00id oveq12i 2p1e3 3eqtri decmac mulid2i 7p2e9 decma2c
        5nn 5p1e6 7p5e12 9p1e10 nn0cni 8nn 8p5e13 mul02i 8t6e48 8p4e12 decaddci
        4p1e5 7t6e42 decmul1c decmul2c eqtr4i modxai 3cn 3t2e6 8t2e16 4cn 4t2e8
        mulcomli 8p2e10 5t4e20 9t4e36 3p1e4 6p5e11 oveq2i 7t7e49 decsucc 7p7e14
        mod2xi ) CDEFZGHIFHJFZKAAJCFZKFZLFUABYELYDKJCMNUBZUCUBZUDUEUFZUGDEUHUIU
        BGUJUKHJUNMUBZUCCDGFZGJJFZYBEHFZOFZJIFZYCAYHUGDGUHPUBYKJJMMUBZULYLOEHUI
        UNUBZQUBZYIPJIMUOUBABUMCGUPRYNAUQURUSDGEYJGUHPPYJUTVAVBYKASRYCTRJDFZLFZ
        CFZOFYMYNSRYELHJYKYTOVCAYCYGVDUNMBYCUTZYOQVEYDKJHYKYSCIYEHVCTRYFUCMUNYE
        UTZOHJOJHHVCQUNMQHUNVFZVGVHHHVIVJZVKVLYONUOJCOHYKYRLCYDJITRZMNQUNYDUTZU
        UEHOHFIJHIVMVJZVNVOVSUUCVPYOVDNJJOCJJDOYKOCTRZMMQNYKUTZUUHCOCFZCVQVRZCN
        VFZVPZMUHQJJSRZOOTRZTRJOTRJUUNJUUOOTJVNVTZWAWBJVNVKVPUUNCTRJCTRDODFUUNJ
        CTUUPUSCJDVQVNWCVSDUHVFWDWEJJOHCCLOYKHMMQUNUUIUUCNVDQJCSRZUUOTRCOTRCUUQ
        CUUOOTCVQWFZWAWBCVQVKVPUUQHTRCHTRLOLFZUUQCHTUURUSHCLUUDVQWGVSLVDVFZWDWE
        WHJJOHKICJYKHMMQUNUUIUUCUCNMJKSRZOJTRZTRKJTRIUVAKUVBJTKKWIVJZWFZVHWBWJV
        PUVAHTRKHTRYDUVAKHTUVDUSHKYDUUDUVCWKVSVPWEWHJJOJLVCOJYKJMMQMUUIJMVFVDQM
        JLSRZUVBTRLJTRZVCUVELUVBJTLLUDVJZWFZVHWBWLVPUVEJTRUVFVCJOFZUVELJTUVHUSW
        LVGWDWEWHJIYTOYMKCFZCFZYNYQMUOYNUTQUVJCKCUCNUBZNUBZYLOUVJCJYSCOYMUVKYPQ
        UVLNYMUTZUVKUTMNQEHKCJYRLOYLUVJOTRUIUNUCNYLUTZUVJUVJUVLWMVKMVDQEJSRZKOT
        RZTREKTRYRUVPEUVQKTEEWNVJZVTKUVCVKWBWOVPHJSRZCTRHCTRLUUSUVSHCTHUUDVTUSW
        GUUTWDWEOJSRZCTRUUHCUUJUVTOCTJVNWPUSUUKUULWDWEYLOUVKOIOYMUOYPQUVNQQYLIS
        RZOTRUVKOTRUVKUWAUVKOTEHUVJCIGYLUOUIUNUVONPGECKEISRGPUIPWQWTNWRWSXAXBUS
        UVKUVKUVMWMVKVPOISROOOFIUUGWPOQVFVPXBXCXDXEDEHICJYBNUHUIYBUTUOMCDSRZJTR
        IJTRHUWBIJTDCIXFVQXGXKUSVOVPECYNUVRVQXHXKXCGASRKTRKOFZGFZJFYCYCSRYELOKG
        UWDJGAKYGVDQUCBKUCVFPMPYDKOGGUWCGCYEOGTRZYFUCQPUUBUWEGOGFGXIVRZGPVFVPPP
        NJCOCGKOJYDUUHMNQNUUFUUMPQMGJSRZUVBTRGJTRKUWGGUVBJTGXIVTVHWBWTVPGCSRZCT
        RECTRVCUVIUWHECTXJUSXLVGWDWHCOGGKSRGNQPKGCOFUVCXIXMXKUWFVBWHDIJGGLSRKUH
        UOUCLGDIFUVGXIXNXKXOMXPWSWHHJUWDJYCHYCYIUNMUUAMUNHJOHHUWCGJYCHUNMQUNUUA
        UUCUNPMHHSRZUVBTRUWIJTRUWCUVBJUWITVHXQGKUWIPWTXRXSVPJHSRZHTRHHTRJGFUWJH
        HTHUUDWFUSXTVPWEYCYCYIWMVTXCXDYA $.

      $( Lemma for ~ 1259prm .  Calculate a power mod.  In decimal, we
         calculate
         ` 2 ^ 3 0 6 = ( 2 ^ 7 6 ) ^ 4 x. 4 == 5 ^ 4 x. 4 = 2 N - 1 8 ` ,
         ` 2 ^ 6 1 2 = ( 2 ^ 3 0 6 ) ^ 2 == 1 8 ^ 2 = 3 2 4 ` ,
         ` 2 ^ 6 2 9 = 2 ^ 6 1 2 x. 2 ^ 1 7 == 3 2 4 x. 1 3 6 = 3 5 N - 1 ` and
         finally ` 2 ^ ( N - 1 ) = ( 2 ^ 6 2 9 ) ^ 2 == 1 ^ 2 = 1 ` .
         (Contributed by Mario Carneiro, 22-Feb-2014.)  (Revised by Mario
         Carneiro, 20-Apr-2015.) $)
      1259lem4 $p |- ( ( 2 ^ ( N - 1 ) ) mod N ) = ( 1 mod N ) $=
        ( c2 c6 cdc c9 cc0 c1 co 2nn0 deccl 1nn0 c5 c8 caddc c3 4nn0 0nn0 cmul
        c4 cmin 2nn 6nn0 9nn0 1nn cn0 5nn0 8nn0 8p1e9 eqid decsuc eqtr4i oveq1i
        0z cc wcel wceq nn0cni ax-1cn pncan mp2an eqtri eqeltri c7 decnncl 3nn0
        cn 9nn nn0zi 8nn 1z 1259lem3 4p1e5 7nn nncni 2cn 7t2e14 mulcomli 6t2e12
        7nn0 6nn decmul2c addid2i mul02i 5t5e25 3eqtr4i mod2xi 2p1e3 c10 5t2e10
        2t2e4 dec10 modxp1i mulid1i 5nn addid1i 3t2e6 dec0h mulid2i 1p1e2 2p2e4
        decmul1c decadd 5p4e9 decsucc 9p1e10 decaddc2 mul01i 00id oveq12i 0p1e1
        3cn 3eqtri decma2c addcomli 8p4e12 decmac 8p6e14 8t8e64 mod2xnegi 7p2e9
        1259lem1 3p2e5 decaddi 5p1e6 7p5e12 7p3e10 3p1e4 4cn 6p1e7 4t2e8 8p2e10
        decaddc oveq2i 5t3e15 5p2e7 5t4e20 9t3e27 7p4e11 decaddci 9t4e36 9p7e16
        6p4e10 3t3e9 4t3e12 4p2e6 6t3e18 6t4e24 modxai 9t2e18 npcan ) CDCEZFEZG
        AHUAIZHUUNHAUBUULFDCUCJKZUDKUNUELUUNHCEZMEZNEZUFUUNUURHOIZHUAIZUURAUUSH
        UAAUUQFEZUUSBUUQNFUURUUPMHCLJKZUGKZUHUIUURUJUKULUMUURUOUPHUOUPZUUTUURUQ
        UURUUQNUVCUHKZURUSUURHUTVAVBZUVEVCZCDHEZCEZHVDEZPTEZUUMPCEZTEZHPEZDEZUU
        NAAUVAVGBUUQFUVCVHVEVCZUBUVHCDHUCLKZJKUVKPTVFQKZVIUVLTPCVFJKZQKZUVGHVDL
        VTKZUVNDHPLVFKZUCKCPGEZDEZGUVIHNEZUUPTEZHEZUVMAUBUWCDPGVFRKZUCKUNHNLVJV
        EUVTUWFHUUPTUVBQKZLKZCHMEZPEZHUWDMGEZUWGAUVPUBUWKPHMLUGKZVFKVKMGUGRKZUW
        JCUWKCEZGUWLCMEZUWMAUVPUBUWKCUWNJKUNCMJUGKZUWOCVDDEZGUWPMUWQAUVPUBVDDVT
        UCKUNUGUWRABVLVDDUWKCCHUWSJVTUCUWSUJJLHTMCVDSILQVMVDCHTEZVDVNVOZVPVQVRU
        KDCUUPDWAVOZVPVSVRZWBGUWQOIUWQGASIZUWQOIMMSIZUWQUWQUWRURZWCUXDGUWQOAAUV
        PVOZWDZUMWEWFWGUWKCPUWPUWNJWHUWPUJUKGUWMOIUWMUXDUWMOIUWQCSIUWMUWMUWOURZ
        WCUXDGUWMOUXHUMCMMGCHUWQJJUGUWQUJRLCCSIZHOIZTHOIZMUXJTHOWKUMZVMVBMCSIWI
        HGEZWJWLVBXBWFWMUWKPUWCDCGUWLJUWNVFUWLUJUCRCUWKSIZGOIUWCGOIUWCUXOUWCGOH
        MPGCHUWKJLUGUWKUJZRLCHSIZHOICHOIZPUXQCHOCVPWNZUMWHVBCMSIWIUXNMCWIMWOVOZ
        VPWJVRWLVBWBUMUWCUWCUWHURWPVBCPSIZDGDEPCDXLVPWQVRZDUCWRZVBWBHASIZUWGOIU
        WQGEZGEUWMUWMSIUUQFUWFHUYEUYDUWGUVCUDUWILUYDAUVAAUXGWSBVBUWGUJZCTEZUWQU
        UQUWFOICTJQKCTMUYGJQVMUYGUJUKUUPMUUPTUYGFUUQUWFUVBUGUVBQUUQUJZUWFUJZHCH
        CCTUUPUUPLJLJUUPUJZUYJWTXAXCXDXCXEXFXGMGUYEGUWMGUWMUWOUGRUWMUJZRRUWMMSI
        ZGOIUYEGOIUYEUYLUYEGOMGUWQGMGUWMUGUGRUYKRRUXEGOIUWQGOIUWQUXEUWQGOWEUMUW
        QUXFWPVBGMSIGGGEZMUXTWDGRWRZVBXBUMUYEUYEUWQGUWRRKURWPVBUWMGSIGUYMUWMUXI
        XHUYNVBWBULWGUWCDUVHCCHUWDJUWHUCUWDUJJLPGGHCDHGUWCHVFRRLUWCUJHLWRZJLRUY
        AGGOIZOIDGOIDUYADUYPGOUYBXIXJDUXBWPVBCGSIZHOIGHOIZHGHEZUYQGHOCVPXHUMXKU
        YOXMXNUXCWBUWGUWEOIUVAAUWFHHNUUQFUWGUWEUWILLUHUYFUWEUJZUUPTMUWFUVBQVMUY
        IUKNHFNVJVOZUSUIXOXCBULGUVMOIUVMUXDUVMOIUWEUWESIUVMUVMUVTURWCUXDGUVMOUX
        HUMHNUVLTUWEUWTUWEHNLUHKLUHUYTQHTLQKHNHTHPCHUWEUWTLUHLQUYTUWTUJLJLHHSIZ
        HHOIZOIHCOIPVUBHVUCCOHUSWNZWTXJCHPVPUSWHXOVBNHSIZTOINTOIUUPVUENTONVUAWN
        UMXPVBXQHNUWTTNDUWEUHLUHUYTQUCHNSIZDOINDOIUWTVUFNDONVUAWSUMXRVBXSXBWBWF
        XTABYBUVHCHVDUULFUVIUVJUVQJLVTUVIUJUVJUJZDHCUVHUCLWTUVHUJUKVDCFUXAVPYAX
        OXCUVKASIUUNOITTEZGEZDEZTEUVMUVOSIUUQFUUQNUVKVUJTPHEZAUUNUVCUDUVCUHBUVF
        UVRQPHVFLKUUPMUWKDUVKVUIDUVJUUQUUQVUKOIUVBUGUWNUCUYHUUPMPHUWKDUUQVUKUVB
        UGVFLUYHVUKUJHCMUUPPLJVFUYJPCMXLVPYCXOYDYEXCUVRUCUWAHCPCUVKVUHGVDUUPUWK
        UVJOILJVFJUYJHMHVDPCUWKUVJLUGLVTUXPVUGVUCHOIUXRPVUCCHOWTUMWHVBJVDMUUPUX
        AUXTYFXOYMUVRRVTPTHGHTTGUVKPVDOIZVFQLRUVKUJZVULWIUXNVDPWIUXAXLYGXOWLVBL
        QRPHSIZHGOIZOIPHOITVUNPVUOHOPXLWNHUSWPXJYHVBZTHSIZGOITGOITGTEZVUQTGOTYI
        WNZUMTYIWPTQWRZXMXQPTGCCVDGHUVKCVFQRJVUMCJWRZJRLPCSIZUYROIDHOIZVDVVBDUY
        RHOWQXKXJYJVBTCSIZCOINCOIWIUXNVVDNCOYKUMYLWLXMXQXNPTGDMUVJDCUVKDVFQRUCV
        UMUYCUGUCJPMSIZGCOIZOIVVECOIUVJVVFCVVEOCVPWCYNHMVDVVECLUGJMPUWKUXTXLYOV
        RYPYDVBCGDTMSIDJRUCMTCGEUXTYIYQVRDUXBWCYDXQXNPTGNFVUKTTUVKNVFQRUHVUMNUH
        WRUDQQPFSIZGTOIZOIVVGTOIVUKVVHTVVGOTYIWCYNCVDHPVVGTJVTQFPCVDEFVHVOZXLYR
        VRWHLYSYTVBPDTTTFSINVFUCUHFTPDEVVIYIUUAVRYHQNDUWTVUAUXBXRXOYTXQXNUVNDVU
        JTUVMHFEZTEZUVOUVTUWBUCUVOUJQVVJTHFLUDKZQKHPVVJTUVMVUIDFVDEZUVNVVKLVFVV
        LQUVNUJVVKUJUVTUCFVDUDVTKUVLTHHEZDHVUHGHUVMVVJVVMOIUVSQHHLLKUCUVMUJZHFF
        VDVVNDVVJVVMLUDUDVTVVJUJVVMUJHGHHFOIZLRXKVVPWIUXNFHWIVVIUSXFXOWLVBUKUCU
        UBYMLRLPCHCHTTGUVLVVNHOIVFJLJUVLUJZHHCVVNLLWTVVNUJUKLQRVUPUXQCOICCOITVU
        RUXQCCOUXSUMXAVUTXMXQVUQDOITDOIWIUXNVUQTDOVUSUMDTWIUXBYIUUCXOWLXMXQUVLT
        GTPVVMDHUVMTUVSQRQVVOVUTVFUCLPCGHPFVDGUVLUYRVFJRLVVQUYRHUYSXKUYOVBVFVTR
        PPSIZUYPOIFGOIFVVRFUYPGOUUDXIXJFVVIWPVBUYAHOIVVCVDGVDEUYADHOUYBUMYJVDVT
        WRXMXQHCDTPSITLJQUUETCDYIVPUUFXOYDXQXNUVLTVVKTDCUVMUCUVSQVVOQJPCGCDVVJT
        HUVLCVFJRJVVQVVAUCQLPDSIZUYROIVVSHOIVVJUYRHVVSOXKYNHNFVVSLUHUIDPUWEUXBX
        LUUGVRUKVBHCTCDSIZCLJJUXCXAYDXQDTUYGUXBYIUUHVRXBWBULUUICUUMSIUURUUNUULF
        UUQNCHUUMJUUOUDUUMUJUHLDCGHCUUPMGUULHUCJRLUULUJUYOJUGRVVTUYPOIVVTGOIUUP
        GOIUUPUYPGVVTOXIYNVVTUUPGOUXCUMUUPUUPUVBURWPXMUXKUXLMGMEUXMVMMUGWRXMXNF
        CUWEVVIVPUUJVRWBUVFULAUOUPUVDUUNHOIAUQUXGUSAHUUKVAUYRHUXDHOIVUBXKUXDGHO
        UXHUMVUDWFXT $.

      $( Lemma for ~ 1259prm .  Calculate the GCD of ` 2 ^ 3 4 - 1 == 8 6 9 `
         with ` N = 1 2 5 9 ` .  (Contributed by Mario Carneiro, 22-Feb-2014.)
         (Revised by Mario Carneiro, 20-Apr-2015.) $)
      1259lem5 $p |- ( ( ( 2 ^ ; 3 4 ) - 1 ) gcd N ) = 1 $=
        ( c8 c6 cdc c9 c1 c2 c3 c4 co 3nn0 deccl 8nn0 9nn0 1nn0 2nn0 cmul caddc
        cc0 cexp cmin cn wcel cn0 4nn0 nnexpcl mp2an nnm1nn0 ax-mp 6nn0 c5 5nn0
        2nn 9nn decnncl eqeltri 1259lem2 6p1e7 eqid decsuc decsucc modsubi 0nn0
        c7 cgcd cz wceq nn0zi gcdcom cdivides wbr 3nn 8nn dec0h mulid1i addid2i
        wn ax-1cn oveq12i 1p1e2 eqtri oveq1i nncni 8p3e11 addcomli decmac 8lt10
        3cn 1nn declti ndvdsi cprime 13prm coprm mpbi 2cn mulid2i addid1i 2p1e3
        wb 3p1e4 3eqtri decma2c gcdi 3t2e6 mulcomli 6p2e8 4cn 4t2e8 8p1e9 4p3e7
        oveq2i 8t4e32 7nn 7p2e9 decaddi 9t4e36 6p4e10 decaddci2 9t2e18 decaddci
        7nn0 8p8e16 mul01i nn0cni 8p4e12 6nn 9p6e15 eqtr4i gcdmodi ) CDEZFEZGHI
        JEZUAKZGUBKZAYOUCUDZYPUEUDHUCUDYNUEUDYQUNIJLUFMZHYNUGUHZYOUIUJYLFCDNUKM
        ZOMZAGHEZULEZFEZUCBUUCFUUBULGHPQMUMMUOUPUQZYOGCVEEZTEYMAUUEYSPUUAABURYL
        UUFYMYTCDVEYLNUKUSYLUTZVAYMUTZVBVCIFEZTEZGGAYMPUUITIFLOMZVDMZUUACFEZGHY
        MUUJQCFNOMZUULYNGJUUJUUMUFYRUUNHGEZGHUUMYNQHGQPMZYRGIEZGGYNUUOPGIPLMZUU
        PUUOUUQVFKZUUQUUOVFKZGUUOVGUDZUUQVGUDUUSUUTVHUUOUUPVIZUUQUURVIUUOUUQVJU
        HUUQUUOVKVLVRZUUTGVHZUUQUUOGCGIPVMUPPVNGITCGHGGUUQCPLVDNUUQUTZCNVOZPPPG
        GRKZTGSKZSKGGSKHUVGGUVHGSGVSVPZGVSVQVTWAWBIGRKZCSKICSKGGEZUVJICSIWIVPWC
        CIUVKCVNWDZWIWEWFWBWGGICWJLNWHWKWLUUQWMUDUVAUVCUVDXAWNUVBUUQUUOWOUHWPWB
        HGGIGIJTUUOUUQQPPLUUOUTZUVEPUFVDGHRKZGTSKZSKHGSKIUVNHUVOGSHWQWRGVSWSVTW
        TWBUVGISKGISKJTJEUVGGISUVIWCIGJWIVSXBWFJUFVOXCXDXEIJHGHCFTYNUUOLUFQPYNU
        TZUVMQOVDHIRKZHTSKZSKDHSKZCUVQDUVRHSIHDWIWQXFXGZHWQWSVTXHWBHJRKZGSKCGSK
        FTFEZUWACGSJHCXIWQXJXGWCXKFOVOZXCXDXECFIJJUUITJUUMYNNOLUFUUMUTZUVPUFVDU
        FJCRKZIJSKZSKUWEVESKUUIUWFVEUWESJIVEXIWIXLWFXMIHFUWEVELQYCCJIHEUVLXIXNX
        GVEHFVEXOWDWQXPWFXQWBIDJJFRKJLUKUFFJIDEFUOWDZXIXRXGXBXSXTXDXEUUITCFHYLF
        TUUJUUMUUKVDNOUUJUTZUWDQOVDIFTCHCDHUUICTSKZLOVDNUUIUTUWICTCECUVLWSUVFWB
        QUKQUVQTHSKZSKUVSCUVQDUWJHSUVTHWQVQVTXHWBGCDHHFRKCPNNFHGCEUWGWQYAXGWAUK
        YDYBXDHTRKZFSKTFSKFUWBUWKTFSHWQYEWCFUWGVQUWCXCXDXEGYMRKUUJSKUUDAYLFUUIT
        GUUCFTYMUUJYTOUUKVDUUHUWHPOVDCDIFGUUBULGYLUUITSKNUKLOUUGUUIUUIUUKYFWSPU
        MPGCRKZIGSKZSKCJSKUUBUWLCUWMJSCUVLWRXBVTYGWBGDRKZFSKDFSKGULEZUWNDFSDDYH
        WDZWRWCFDUWOUWGUWPYIWFWBXDGFRKZTSKFTSKFUWBUWQFTSFUWGWRWCFUWGWSUWCXCXDBY
        JXEYK $.

      $( 1259 is a prime number.  (Contributed by Mario Carneiro,
         22-Feb-2014.)  (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
      1259prm $p |- N e. Prime $=
        ( c2 c3 c4 cdc c7 c1 co 3nn0 c5 c8 cmul caddc 1nn0 2nn0 deccl 8nn0 eqid
        c9 cmin 37prm 4nn decnncl 5nn0 8p1e9 decaddi eqtr4i oveq1i cc wcel wceq
        nn0cni ax-1cn pncan mp2an eqtri 4nn0 7nn0 3t3e9 2p1e3 9p3e12 4t3e12 3cn
        oveq12i 2cn 3p2e5 addcomli decmac nncni 7t3e21 mulcomli 7t4e28 decmul1c
        7nn decmul2c cn0 9nn0 eqeltri npcan eqcomi 1nn cexp numexp1 oveq2i 4lt7
        2nn clt declt breqtrri 1259lem4 1259lem5 pockthi ) CDEFZDGFZHWNAHUAIZAU
        BDEJUCUDZWPHCFZKFZLFZWNWOMIZWPWTHNIZHUAIZWTAXBHUAAWSTFZXBBWSLTWTHWRKHCO
        PQUEQZROWTSUFUGUHUIWTUJUKHUJUKZXCWTULWTWSLXERQUMUNWTHUOUPUQDGWSLWNCDFZW
        ODEJURQJUSWOSRCDPJQDECDDWRKHWNXGJURPJWNSZXGSJUEODDMIZCHNIZNITDNIWRXITXJ
        DNUTVAVEVBUQHCKEDMIDOPJVCDCKVDVFVGVHUGVIDEXGLGCWNUSJURXHRPCHDDGMICPOPGD
        CHFGVOVJZVDVKVLCHDVFUNVAVHUGGECLFXKEUCVJVMVLVNVPUHZWPHNIZAAUJUKXFXMAULA
        AXDVQBWSTXEVRQVSUMUNAHVTUPWAWQWBWGWPXAWNWOHWCIZMIXLXNWOWNMWODGJUSQWDZWE
        UHWNWOXNWHDEGJURVOWFWIXOWJABWKABWLWM $.
    $}

    ${
      2503prm.1 $e |- N = ; ; ; 2 5 0 3 $.
      $( Lemma for ~ 2503prm .  Calculate a power mod.  In decimal, we
         calculate ` 2 ^ 1 8 = 5 1 2 ^ 2 = 1 0 4 N + 1 8 3 2 == 1 8 3 2 ` .
         (Contributed by Mario Carneiro, 3-Mar-2014.)  (Revised by Mario
         Carneiro, 20-Apr-2015.) $)
      2503lem1 $p |- ( ( 2 ^ ; 1 8 ) mod N ) = ( ; ; ; 1 8 3 2 mod N ) $=
        ( c2 c10 c4 cdc c1 c5 c3 cc0 2nn0 5nn0 0nn0 4nn0 1nn0 co c6 caddc eqtri
        cmul c9 c8 cn deccl 3nn decnncl eqeltri 9nn0 10nn0 nn0zi 8nn0 3nn0 cexp
        2nn cmo 8p1e9 6nn0 2exp8 eqid dec0h 2t2e4 ax-1cn addid2i oveq12i 5t2e10
        4p1e5 dec10 decsuc decmac 6t2e12 decmul1c numexpp1 oveq1i 9nn nncni 2cn
        9t2e18 mulcomli 1p1e2 8p3e11 decaddci 3p1e4 decadd nn0cni addid1i 2p2e4
        5nn 5p1e6 mulid2i 00id mul02i 6nn 3eqtri 4t2e8 8p4e12 4cn 5t4e20 mul01i
        decma2c 3cn 4t3e12 decaddi addcomli 7nn0 6p1e7 oveq2i 5t5e25 7nn 7p5e12
        c7 mulid1i 10nn decmul2c eqtr4i mod2xi ) CUADEFZGUBFZHGFZCFZXQIFZCFZAAC
        HFZJFZIFUCBYCIYBJCHKLUDZMUDZUEUFUGUNUHXPDEUINUDZUJXRCHGLOUDZKUDZXTCXQIG
        UBOUKUDZULUDZKUDCUAUMPXSAUOCXSUBUAKUKUPYBQXRCCGCUBUMPKYDUQURKOCHJGCHGGY
        BGKLMOYBUSZGOUTZKOOCCTPZJGRPZRPEGRPHYMEYNGRVAGVBVCZVDVFSGJGHCTPZOMYOYPD
        GJFZVEVGSVHVIVJVKVLVMUACXQUAVNVOVPVQVRXPATPYARPCQFZCFZGFZEFZEFXSXSTPYCI
        XTCXPUUAEIGFZAYAYEULYJKBYAUSYFNIGULOUDYBJCGFZEXPYTEJYCXTUUBRPYDMCGKOUDZ
        NYCUSXQIIGUUCEXTUUBYIULULOXTUSUUBUSGUBGCXQIOUKULXQUSVSOVTWAWBWCYFNMCHCG
        XPYSGHCFZYBUUCJRPKLKOYKUUCUUCUUDWDWEYFOHCLKUDDEHECYRCGXPCUUERPUINLNXPUS
        ZJCHCHECUUEMKLKCKUTZUUEUSHHWGVOZVCWFWCKKOGJJQCCQJDHGRPZOMMUQVGUUIQJQFZW
        HQUQUTZSKUQMGCTPZJJRPZRPCJRPCUULCUUMJRCVPWIZWJVDCVPWESJCTPZQRPJQRPQUUJU
        UOJQRCVPWKVMQQWLVOVCUUKWMVIECTPZERPUBERPGCFZUUPUBERWNVMWOSVIDEJGHUUEGCX
        PGUINMOUUFYLLOKGJJCHHCJDJCRPZOMMKVGUURCJCFZCVPVCZUUGSLKMGHTPZUUMRPHJRPZ
        HUVAHUUMJRHUUHWIZWJVDHUUHWEZSJHTPZCRPUURCUUSUVEJCRHUUHWKVMUUTUUGWMVICJG
        EHTPKMYOHECJFUUHWPWQVRVHVIWSXPJTPZERPJERPEJEFZUVFJERXPXPYFWDWRVMEWPVCEN
        UTZWMWSDEJCIUUBEGXPCUINMKUUFUUGULNOGJJGIIGJDYNOMMOVGYNGJGFZYOYLSULOMGIT
        PZUUMRPIJRPIUVJIUUMJRIWTWIWJVDIWTWESJITPZGRPYNGUVIUVKJGRIWTWKVMYOYLWMVI
        GCEEITPCOKKXAWFXBVIWSXRCUUAEXSDCFZXSYHYGKXSUSZNDCUIKUDZHGDCXSYTEXRXRUVL
        LOUIKXRUSZUVLUSYHNYGXRCQGHYSGGXSDXRRPYGKUQOUVMGJHGQGDXROMLOVGUVOHGQUUHV
        BWHXCYOWCLOOHGJXJHYRCGXRQGRPZLOMXDUVOUVPXJJXJFXEXJXDUTSLKOHHTPZYNRPUVQG
        RPYRYNGUVQRYOXFCHQUVQKLWHXGVHSUVAXJRPHXJRPUUQUVAHXJRUVCVMXJHUUQXJXHVOUU
        HXIXCSVIGJGCHTPZOMYOUVRDYQHCDUUHVPVEVRVGSVHVIXRCJCGXREJXSCYGKMKUVMUUGON
        MHGJJGHGJXRUUMLOMMUVOUUMJJJFWJJMUTSOOMHGTPZUUMRPUVBHUVSHUUMJRHUUHXKWJVD
        UVDSGGTPZJRPGJRPGUVIUVTGJRGVBXKVMGVBWEYLWMVICGTPZCRPCCRPEUVGUWACCRCVPXK
        VMWFUVHWMVIWSXRCUVLECJXSKYGKUVMNMXRCTPZJRPUVLJRPUVLUWBUVLJRHGDCCJXRKLOU
        VOKMYPJRPDJRPDYPDJRVEVMDDXLVOWESUULCUUSUUNUUGSVKVMUVLUVLUVNWDWESYMEUVGV
        AUVHSVKXMXNXO $.

      $( Lemma for ~ 2503prm .  Calculate a power mod.  We calculate
         ` 2 ^ 1 9 = 2 ^ 1 8 x. 2 == 1 8 3 2 x. 2 = N + 1 1 6 1 ` ,
         ` 2 ^ 3 8 = ( 2 ^ 1 9 ) ^ 2 == 1 1 6 1 ^ 2 = 5 3 8 N + 1 3 0 7 ` ,
         ` 2 ^ 3 9 = 2 ^ 3 8 x. 2 == 1 3 0 7 x. 2 = N + 1 1 1 ` ,
         ` 2 ^ 7 8 = ( 2 ^ 3 9 ) ^ 2 == 1 1 1 ^ 2 = 5 N - 1 9 4 ` ,
         ` 2 ^ 1 5 6 = ( 2 ^ 7 8 ) ^ 2 == 1 9 4 ^ 2 = 1 5 N + 9 1 ` ,
         ` 2 ^ 3 1 2 = ( 2 ^ 1 5 6 ) ^ 2 == 9 1 ^ 2 = 3 N + 7 7 2 ` ,
         ` 2 ^ 6 2 4 = ( 2 ^ 3 1 2 ) ^ 2 == 7 7 2 ^ 2 = 2 3 8 N + 2 7 0 ` ,
         ` 2 ^ 1 2 4 8 = ( 2 ^ 6 2 4 ) ^ 2 == 2 7 0 ^ 2 = 2 9 N + 3 1 3 ` ,
         ` 2 ^ 1 2 5 1 = 2 ^ 1 2 4 8 x. 8 == 3 1 3 x. 8 = N + 1 ` and finally
         ` 2 ^ ( N - 1 ) = ( 2 ^ 1 2 5 1 ) ^ 2 == 1 ^ 2 = 1 ` .  (Contributed
         by Mario Carneiro, 3-Mar-2014.)  (Revised by Mario Carneiro,
         20-Apr-2015.) $)
      2503lem2 $p |- ( ( 2 ^ ( N - 1 ) ) mod N ) = ( 1 mod N ) $=
        ( c2 c1 cdc c5 cc0 co c3 2nn0 0nn0 1nn0 c4 c8 4nn0 c6 c9 c7 cmul caddc
        cmin cn 5nn0 deccl 3nn decnncl eqeltri 2nn 0z 8nn0 3nn0 6nn0 9nn0 nn0zi
        1z 7nn0 4nn 2503lem1 8p1e9 decsuc nn0cni addid1i mulid2i ax-1cn oveq12i
        eqid 2cn 2p1e3 eqtri 5nn nncni oveq1i 5p1e6 dec0h 3eqtri decma2c mul01i
        6nn addid2i 3cn 3p1e4 8t2e16 decmul1c 3t2e6 2t2e4 eqtr4i modxp1i 9t2e18
        mulid1i 9nn mulcomli decmul2c 1p1e2 6p3e9 addcomli decadd 6p1e7 decaddc
        9p2e11 7p1e8 oveq2i c10 5t2e10 dec10 decaddi 8p6e14 decmac 0p1e1 5t5e25
        8nn 4cn 5t3e15 5p4e9 8t5e40 3t3e9 9p3e12 8t3e24 7nn decaddci 1t1e1 00id
        7p4e11 mod2xi mul02i 7t2e14 4t2e8 8p4e12 4p1e5 decsucc 9p4e13 decaddci2
        7p5e12 9p8e17 9t9e81 9t4e36 4p3e7 9p6e15 7t7e49 cc wcel 9p1e10 decaddc2
        decma 6t6e36 6p6e12 2p2e4 5t4e20 4t3e12 5p2e7 4p2e6 7p6e13 4t4e16 6p2e8
        mod2xnegi 6t2e12 9p9e18 7p2e9 5p5e10 9p5e14 4p4e8 9t5e45 9t3e27 cmo cu2
        7p3e10 cexp 8p3e11 8p2e10 modxai wceq pncan mp2an ) CDCEZFEZDEZGADUAHZD
        DAACFEZGEZIEZUBBUVRIUVQGCFJUCUDZKUDZUEUFUGZUHUVNDUVMFDCLJUDZUCUDZLUDUIL
        LCUVMMEZNEZIDUVOIDEZIEZNDAUWBUHUWENUVMMUWCOUDZUJUDUOUWGIIDUKLUDZUKUDZLU
        KUJCPCEZMEZCQEZUWFCREZGEZUWHAUWBUHUWLMPCULJUDZOUDUWNCQJUMUDZUNUWOGCRJUP
        UDZKUDZUWKCUWGCEZCIEZNEZUWMRREZCEZUWPAUWBUHUWGCUWJJUDUXCUXBNCIJUKUDZUJU
        DZUNUXDCRRUPUPUDZJUDZUWTCDFEZPEZIUXAQDEZUXEAUWBUHUXJPDFLUCUDZULUDIUKUNQ
        DUMLUDZUXICRNEZUXJUXKDQEZMEZUXBGEZQEZUXLAUHRNUPUJUDUXJUXMUNUXPMDQLUMUDZ
        UQUFUXNUXRQUXBGUXFKUDZUMUDZCIQEZMUXODDEZDEZUXSAUWBUHIQUKUMUDMOUNUYDDDDL
        LUDZLUDZUYBCINEZDUYCDIEZGEZREZUYEAUWBUHINUKUJUDUOUYJRUYIGDILUKUDZKUDZUP
        UDZUYGCUXPFIEZNEZUYHUYDPEZDEZUYKAUWBUHUXTUYPUYONFIUCUKUDZUJUDZUNUYQDUYD
        PUYFULUDZLUDZUYNCDNEZDUXPVUCIEZCEZUYRAUWBUHDNLUJUDZUOVUDCVUCIVUFUKUDZJU
        DVUBABURDNQVUCLUJUSVUCVFZUTDASHZUYRTHIPEZPEZMEVUECSHUVRIUYQDDVUKMGAUYRU
        WAUKVUALBUYRVFZLOKUVQGUYDPDVUJPGUVRUYQGTHUVTKUYFULUVRVFZUYQUYQVUAVAVBLU
        LKCFDDDIPGUVQUYDGTHZJUCLLUVQVFZUYDUYDUYFVAVBZLULKDCSHZDGTHZTHCDTHZIVUQC
        VURDTCVGVCZDVDVBZVEVHVIDFSHZDTHFDTHPGPEZVVBFDTFFVJVKZVCZVLVMPULVNZVOZVP
        DGSHZPTHGPTHZPVVCVVHGPTDVDVQZVLPPVRVKZVSZVVFVOVPDISHZDTHIDTHZMGMEZVVMID
        TIVTVCZVLWAMOVNZVOZVPVUDCVUKMCGVUEJVUGJVUEVFOKVUDCSHZGTHVUKGTHVUKVVSVUK
        GTVUCIVUJPCGVUDJVUFUKVUDVFULKVUCCSHZGTHVUJGTHVUJVVTVUJGTDNIPCDVUCJLUJVU
        HULLVUQDTHVUSIVUQCDTVUTVLVHVIWBWCVLVUJVUJIPUKULUDZVAVBVIICSHZPVVCWDVVFV
        IWCVLVUKVUKVUJPVWAULUDVAVBVICCSHZMVVOWEVVQVIZWCWFWGDQINCDUXPJLUMUXPVFZU
        JLCDSHZDTHVUSIVWFCDTCVGWIZVLVHVIQCVUCQWJVKZVGWHWKZWLUYPASHUYKTHUYIMEZRE
        ZQEZCEZDEUYRUYRSHUVRIUYJRUYPVWMDDPEZCEZAUYKUWAUKUYMUPBUYKVFZUYTLVWNCDPL
        ULUDZJUDUVQGUWNCUYPVWLCGUVRUYJVWOTHUVTKUWRJVUMUYIGVWNCUWNCUYJVWOUYLKVWQ
        JUYJVFZVWOVFDIDPCQUYIVWNLUKLULUYIVFZVWNVFWMPIQVVKVTWNWOWPCVGVSZWPUYTJKC
        FCQUYPVWKQCPEZQEZUVQUWNGTHJUCJUMVUOUWNUWNUWRVAZVBUYTUMVXAQCPJULUDZUMUDU
        YONUWODCVWJRDUYPCVXBTHUYSUJUWSLUYPVFZGCVXAQUWODCVXBKJVXDUMCJVNZVXBVFCPR
        GVXATHJULWQVXAVXAVXDVAVSUTLQCUYDVWHVGWSWOZWRJUPLFICNCUYIMDUYOUWODTHUCUK
        JUJUYOVFZCRNUWOJUPWTUWOVFZUTJOLFCSHZVUSTHVXJITHUYIVUSIVXJTVHXADGIVXJILK
        UKVXJXBDGEZXCXDVIZIVTVSZXEVIVWBNTHPNTHZDMEZVWBPNTWDVLNPVXONXJVKZVVKXFWO
        ZVIXGDPRNCSHZLULWQWBUTXGUYONGQFVXBQMUYPQUYSUJKUMVXEQUMVNZUCUMOFIGMFVXAQ
        DUYOGMTHZUCUKKOVXHVXTMVVOMXKVSZVVQVIZUCUMLFFSHZGDTHZTHVYCDTHVXAVYDDVYCT
        XHXACFPVYCJUCVMXIUTZVIDFQIFSHZMLUCOFIUXJVVDVTXLWKZXMXEZXGMGQNFSHQOKUMXN
        QVWHVSZXEZXGVPUYPGSHZCTHGCTHZCGCEZVYKGCTUYPUYPUYTVAVQVLVWTVXFVOVPUYONGR
        IVWODIUYPRUYSUJKUPVXERUPVNZUKLUKFIGIIVWNCDUYOGITHZUCUKKUKVXHVYOIGIEZVXM
        IUKVNZVIZUKJLFISHZVYDTHVYSDTHVWNVYDDVYSTXHXADFPVYSLUCVMXLUTZVIIISHZITHQ
        ITHUVMWUAQITXOVLXPVIXGCMDINISHRJOUPXQVHLRMUYDRXRVKZXKYBWOXSXGVPUYQDVWMD
        UYRUYQUYRVUBVUALVULLVUAUYDPUYDPUYRVWLCPQEZREZUYQUYQUYFULUYFULUYQVFZWUEV
        UBJWUCRPQULUMUDZUPUDDDRGEZNUYRVWKQUYQUYDUYDWUDTHLLRGUPKUDUJUYDVFZDDWUCR
        WUGNUYDWUDLLWUFUPWUHWUDVFGDPQRDWUCKLULUMDLVNZWUCVFVVIDTHPDTHZRVVIPDTVVL
        VLWQVIQDXBVWHVDUUAWOZUUBRDNWUBVDWTWOWPVUBUMVUAUYQDVUCPDVWJRGUYRWUGUYQTH
        VUALVUFULVULRGUYDPVUCPWUGUYQUPKUYFULWUGVFWUEGRDDDNRUYDKUPLLVYNWUHXHWTWP
        VVLWPLUPKUYDPDNDUYIMDUYQVUCGTHZUYFULLUJWUEVUCVUCVUFVAVBZLOLDDGCDDIGUYDD
        DTHZLLKJWUHWUNCVYMWMVXFVILUKKDDSHZGGTHZTHVURDWUODWUPGTXTYAVEVVAVIZWUOCT
        HDCTHZIVYPWUODCTXTVLCDIVGVDVHWOZVYQVOZXGPDSHZNTHVXNVXOWVAPNTPVVKWIZVLVX
        QVIXGWUOPTHDPTHRGREZWUODPTXTVLPDRVVKVDWQWOVYNVOXGUYQDGNDUYQQGUYRNVUALKU
        JVULNUJVNZLUMKUYDPGGDUYDPGUYQWUPUYFULKKWUEWUPGGGEZYAGKVNZVIZLULKDDGGDDD
        UYDWUPLLKKWUHWVGLWUOGTHVURDWUODGTXTVLVVAVIZWVHUUCZWVAGTHPGTHZPVVCWVAPGT
        WVBVLPVVKVBZVVFVOXGWUONTHDNTHQGQEZWUODNTXTVLNDQVXPVDUSWOVXSVOXGVPUYQDGP
        PWUDCDUYRPVUALKULVULVVFULJLUYDPGDPWUCRIUYQVYDUYFULKLWUEVYDDGDEZXHWUIVIZ
        ULUPUKDDGIPPQGUYDVYOLLKUKWUHVYRULUMKDPSHZWUPTHWVJPWVOPWUPGTPVVKVCZYAVEW
        VKVIWVOITHPITHZQWVLWVOPITWVPVLWNVXSVOXGIPRPPSHUKULWQUUDUTXGWVOPTHPPTHUV
        MWVOPPTWVPVLUUEVIXGVPUYRUYRVUBVAWIWLWFYCINQUYHUKUJUSUYHVFUTVUIUYETHVXAD
        EZMEUYKCSHUVRIUYDDDWVRMGAUYEUWAUKUYFLBUYEVFZLOKUVQGDDDVXADGUVRVUNUVTKLL
        VUMVUPLLKCFGDDCPGUVQVURJUCKLVUOVURDWVMVVAWUIVIZLULKVUQWUPTHCGTHZCVUQCWU
        PGTVUTYAVECVGVBZVIZVVGVPVVHDTHVYDDWVMVVHGDTVVJVLXHWUIVOVPVVRVPUYJRWVRMC
        DUYKJUYMUPVWPOLUYIGGDCVXADGUYJDUYLKKLVWRWUIJLKDIGGCCPGUYIWUPLUKKKVWSWVG
        JULKWWCVWBGTHWVJPVVCVWBPGTWDVLWVKVVFVOXGGCSHZDTHVYDDWVMWWDGDTCVGYDZVLXH
        WUIVOXGYEWCWFWGIQRNCDUYCJUKUMUYCVFUJLCISHZDTHWUJRWWFPDTICPVTVGWDWKZVLWQ
        VIVWIWLMASHUXSTHUVMIEZCEZDEUYEUYESHUVRIUXRQMWWIDCAUXSUWAUKUYAUMBUXSVFZO
        LJUVQGUXBCMWWHCGUVRUXRCTHUVTKUXFJVUMUXBGCUXRCUXFKJUXRVFZVWTXEOJKCFCIMUV
        MICUVQUXBGTHJUCJUKVUOUXBUXBUXFVAVBOUKJMCSHZCCTHZTHNMTHUVMWWLNWWMMTYFUUF
        VEYGVICGIMFSHIJKUKFMCGEVVDXKUUGWKVXMXEVPMGSHZCTHVYLCVYMWWNGCTMXKVQVLVWT
        VXFVOVPDCDCMISHQLJUMUUHWMLVXGXSVPUYDDWWIDUYEUYDUYEUYGUYFLWVSLUYFDDDDUYE
        WWHCUYDUYDUYDLLLLWUHWUHUYGJUYFUYDDDCDUVMIGUYEDUYDTHUYFLLJWVSGDDDDCDUYDK
        LLLWUIWUHXHWMWPLUKKDDGDDDCGUYDVURLLKLWUHWVTLJKWUQWUODTHWUNCVYMWUODDTXTV
        LWMVXFVOZXGWUTXGUYDDGDDUYDCGUYEDUYFLKLWVSWUILJKWVIWWOXGVPUYEUYEUYGVAWIW
        LWFYCRNUXJPCDUXOJUPUJUXOVFULLDMFCRSHZLOYHRCVXOWUBVGYEWKZUTNCVWNVXPVGWBW
        KWLUXSUXQTHUVSAUXRQUXPMUVRIUXSUXQUYAUMUXTOWWJUXQVFZCMEZUVQUXRUXPTHCMJOU
        DCMFWWSJOYHWWSVFUTUXBGDQWWSQUXRUXPUXFKLUMWWKVWECIMUXBJUKWAUXBVFZUTVYIWP
        YIUKYJWRBWFUXJASHUXLTHIREZPEZIEZPEUXQUXQSHUVRIQDUXJWXCPMAUXLUWAUKUMLBUX
        LVFZUXMULOUVQGDIUXJWXBIGUVRQMTHUVTKLUKVUMYJUXMUKKCFGDUXJWXAPRUVQVURJUCK
        LVUOWVTUXMULUPDFGRCIRDUXJGRTHZLUCKUPUXJVFZWXERWVCRWUBVSZVYNVIJUPLVUQVYD
        THVUSIVUQCVYDDTVUTXHVEVHVIDGRVXJRLKUPVXLWXGXEXGDFGDFRPCUXJDLUCKLWXFWUIU
        CULJVVBVYLTHFCTHRVVBFVYLCTVVEVWTVEUUIVIVYEXGVPUXJGSHZITHVYOIVYPWXHGITUX
        JUXJUXMVAVQVLVXMVYQVOVPDFGDIMPDUXJDLUCKLWXFWUIUKULLVVMVYDTHVVNMVVMIVYDD
        TVVPXHVEWAVIVYTXGVPUXPMWXCPUXQUXDUXQUXPMUXTOUDZUXTOWWRULUXHDQRRUXQWXBID
        REZFEZUXPUXDLUMUPUPVWEUXDVFZWXIUKWXJFDRLUPUDZUCUDUXPMVUCCDWXAPGUXQRWXKT
        HUXTOVUFJWWRGRWXJFVUCCRWXKKUPWXMUCVYNWXKVFDRNGWXJTHLUPWTWXJWXJWXMVAVSUT
        JYLWRLULKDQDNDIRDUXPWULLUMLUJVWEWUMLUPLWUOWUNTHWURIWUODWUNCTXTWMVEWUSVI
        QDSHZNTHQNTHZWXJWXNQNTQVWHWIVLYMVIXGMDSHZCTHMCTHPVVCWXPMCTMXKWIVLUUJVVF
        VOXGUXPMGRQWXKIMUXQRUXTOKUPWWRVYNUMUKODQGMQWXJFNUXPVXTLUMKOVWEVYBUMUCUJ
        DQSHZGNTHZTHWXOWXJWXQQWXRNTQVWHVCZNVXPVSZVEYMVINDFQQSHZMUJLOYNMDFXKVDYH
        WOZXEXGIPIMMQSHRUKULUPQMVUJVWHXKYOWKWAUKRPUYIWUBVVKUUKWOXSXGVPUXPMUXDPM
        DUXQOUXTOWWRULLDQGDMRRIUXPDLUMKLVWEWUIOUPUKDMSHZVYOTHMITHZRWYCMVYOITMXK
        VCVXMVEYPVIIPRQMSHUKULWQYOUTXGUULWCWLWFUUNUXJPUWGCCDUXKJUXMULUXKVFJLDFG
        DCIDDUXJDLUCKLWXFWUIJLLVWFVYDTHVUSIVWFCVYDDTVWGXHVEVHVIDGDCFSHZLKXHWYEX
        BVXKFCXBVVDVGXCWKXDVIZUTZVPPCUVMVVKVGUUOWKZWLIASHUXETHNCEZNEZDEUXLUXLSH
        UVRIUXDCIWYJDDAUXEUWAUKUXHJBUXEVFZUKLLUVQGRNIWYINGUVRUXDDTHUVTKUPUJVUMR
        RNUXDUPUPWTWXLUTUKUJKCFGRINCCUVQRGTHZJUCKUPVUOWYLRWVCRWUBVBVYNVIUKJJVWB
        VYLTHPCTHNVWBPVYLCTWDVWTVEUUMVIDFCCVYFRLUCUPVYGWMJRFUVMWUBVVDYLWOXSVPIG
        SHZNTHWXRNGNEZWYMGNTIVTVQVLWXTWVDVOVPWUACTHQCTHUYDWUAQCTXOVLWSVIZVPQDWY
        JDUXLQUXLUXNUMLWXDLUMQDGQQWYINDUXLQUMLKUMWXDVXSUMUJLWYAVYDTHWYADTHWYIVY
        DDWYATXHXANDCWYAUJLWMYNUTVIWXQQTHQQTHVUCWXQQQTWXSVLUUPVIXGUXLUXLUXNVAWI
        WLWFYCUWGCUWLMCGUXAJUWJJUXAVFOKCUWGSHZGTHUWLGTHUWLWYPUWLGTIDPCCGUWGJUKL
        UWGVFZJKWWFGTHWVJPWWFPGTWWGVLWVKVIVWFCVYMVWGVXFVIZWLVLUWLUWLUWQVAVBVIVW
        DWLUXCASHUWPTHFQEZFEZQEZNEZMEUXEUXESHUVRIUWOGUXCXUBMRDEZAUWPUWAUKUWSKBU
        WPVFZUXGORDUPLUDZUVQGQNUXCXUANGUVRUWOXUCTHUVTKUMUJVUMCRRDQNUWOXUCJUPUPL
        VXIXUCVFRCQWUBVGUUQWOWTWPUXGUJKCFGQUXCWYTQUYDQEZUVQQGTHZJUCKUMVUOXUGQWV
        LQVWHVBZVXSVIUXGUMUYDQUYFUMUDZUXBNUYDQCWYSFCUXCGXUFTHUXFUJUYFUMUXCVFZXU
        FXUFXUIVAVSJUCJCIDICFQGUXBUYDCTHJUKLUKWWTDDIUYDCLLJWUHWUSXEJUMKVWCVURTH
        MDTHZFVWCMVURDTWEVVAVEYHVIVWBITHWVQQWVLVWBPITWDVLWNVXSVOXGDPFCVXRQLULUM
        WBWMUCQPUXJVWHVVKYQWOXSXGUXBNGQFXUFQMUXCQUXFUJKUMXUJVXSUCUMOCIGMFUYDQDU
        XBVXTJUKKOWWTVYBUCUMLWYEVYDTHWYEDTHUYDVYDDWYETXHXAWYGVIVYHXGVYJXGVPUXCG
        SHZNTHWXRNWYNXULGNTUXCUXCUXGVAVQVLWXTWVDVOVPUXCISHZGTHXUCMEZGTHXUNXUMXU
        NGTUXBNXUCMICUXCUKUXFUJXUJOJCIGCIRDDUXBCJUKKJWWTVXFUKLLWWFVYDTHWUJRWWFP
        VYDDTWWGXHVEWQVIWYOXGXQWCVLXUNXUNXUCMXUEOUDVAVBVIVPUXDCXUBMUXEUXJMEZUXE
        UXIUXHJWYKOUXJMUXMOUDZRRUXJMUXEXUANFMEZGEZUXDXUOUPUPUXMOWXLXUOVFUXIUJXU
        QGFMUCOUDZKUDUXDCFFEZFRWYTQDUXEUXJXURTHUXHJFFUCUCUDUCWYKDFXUQGXUTFUXJXU
        RLUCXUSKWXFXURVFGDFMFFDXUQKLUCOWUIXUQVFFVVDVSZWYBWPFVVDVBWPUPUMLRRFPRWY
        SFFUXDXUTDTHUPUPUCULWXLFFPXUTUCUCVMXUTVFUTUPUCUCMQDGFQRRSHZFFTHZOUMLKYR
        XVCXBVXKUURXDVIYHXUHWPMQFFXVBPOUMULYRYHUCYQXSXGDMQWWPFLOUCWWQFMQVVDXKXM
        WOXEXGUXDCGMRXURNDUXEMUXHJKOWYKVVQUPUJLRRGDRXUQGFUXDVYDUPUPKLWXLWVNUPKU
        CXVBGFTHZTHXVBFTHXUQXVDFXVBTXVAXAMQMFXVBFOUMUCYRYHOUUSXSVIMFXVBOYHYRYIX
        GDMNWWPMLOOWWQUUTXEZXGVPUXDCXUOMCGUXEJUXHJWYKOKUXDCSHZGTHXUOGTHXUOXVFXU
        OGTRRUXJMCDUXDJUPUPWXLOLDMFRCSHZLOYHYEUTYEWCVLXUOXUOXUPVAVBVIVWDWCWLWFY
        CUWLMUWENCGUWMJUWQOUWMVFUJKCUWLSHZGTHUWEGTHUWEXVHUWEGTPCUVMMCGUWLJULJUW
        LVFOKCPSHZGTHUVMGTHUVMXVIUVMGTWYHVLUVMUVMUWCVAVBVIVWDWLVLUWEUWEUWIVAVBV
        ICMSHNWYNMCNXKVGYFWKWVDVIWLUWNASHUWHTHRCEZQEZGEZGEUWPUWPSHUVRIUWGIUWNXV
        LGQAUWHUWAUKUWJUKBUWHVFZUWRKUMUVQGMGUWNXVKGGUVRUWGQTHUVTKOKVUMIDMUWGQUK
        LUMWYQWAWUKYKUWRKKCFGMUWNXVJQVXOUVQMGTHZJUCKOVUOXVNMVVOMXKVBVVQVIUWRUMD
        MLOUDZCQDMCRCCUWNGVXOTHJUMLOUWNVFZVXOVXOXVOVAVSJJJVWCWURTHWYDRVWCMWURIT
        WEWUSVEYPVIZDNCCQCSHMLUJOWHWMJYGXSXGCQGMFVXOQMUWNMJUMKOXVPVVQUCUMOWYEVX
        TTHWYEMTHVXOVXTMWYETVYAXADGMWYEMLKOWYFVYAXEVIMFQQFSHMOUCOUVAXMXEXGVPUWN
        GSHZGTHWUPGWVEXVRGGTUWNVXCVQVLYAWVFVOVPCQGIIQGIUWNIJUMKUKXVPVYQUKKUKWWF
        VYOTHWVQQWWFPVYOITWWGVXMVEWNVICRIQISHIJUPUKUVBVHUVEYKXGVPUWOGXVLGUWPGUW
        PUWTUWSKXUDKKUWPUWOSHZGTHXVLGTHXVLXVSXVLGTCRXVKGUWPVUCQEZUWOUWTJUPVXIKV
        UCQVUFUMUDZUWOGVUCQCXVJQGUWPXVTUWSKVUFUMXUDXVTVFJUMKCRDNCRCCUWOWULJUPLU
        JVXIWUMJJJXVQDMCCXVGNLOUJYEWMJNMUVMVXPXKYGWOXSXGWWDQTHGQTHQWVLWWDGQTWWE
        VLVYIVXSVOXGUWOGXVTGRGUWPUPUWSKXUDKKUWORSHZGTHXVTGTHXVTXWBXVTGTCRVUCQRM
        UWOUPJUPVXIUMOXVEYRWCVLXVTXVTXWAVAVBVIGRSHGWVERWUBYDWVFVIWCWLVLXVLXVLXV
        KGXVJQRCUPJUDUMUDKUDVAVBVIUWPGSHGWVEUWPUWPUWTVAVQWVFVIWLWFYCCIUVFHNAUVC
        UVDVLUWENDUVNUWFIUWIUJUKUWFVFUVMMFUWEUWCOYHUWEVFUTLUVGXSVUIDTHUVRMEUWHN
        SHUVRIMVUIUWAUKWAVUIAUVSAAUWBVKZVCBVIUTUWGIUVRMNCUWHUJUWJUKXVMOJIDGCNUV
        QGDUWGCUKLKJWYQVXFUJKLINSHZVYDTHXWDDTHUVQVYDDXWDTXHXACMFXWDJOYHNIWWSVXP
        VTXQWKZUTVIDNSHZCTHNCTHXBVXKXWFNCTNVXPVCVLUVHXDVOXGXWEWCWFUVICUVOSHUVRC
        EZUVPUVNDUVRCCGUVOJUWDLUVOVFJKUVQGGCUVNSHGUVTKKUVMFUVQGCDUVNJUWCUCUVNVF
        KLDCGDCCFGUVMDLJKLUVMVFWUIJUCKVWFWUPTHWWACVWFCWUPGTVWGYAVEWWBVIVWCDTHXU
        KFGFEVWCMDTWEVLYHFUCVNVOVPWYFWLYAXEWYRWLUVPXWGDTHZDUAHZXWGAXWHDUAAUVSXW
        HBUVRCIXWGUWAJVHXWGVFUTWFVLXWGYSYTDYSYTXWIXWGUVJXWGUVRCUWAJUDVAVDXWGDUV
        KUVLVIWFGASHZDTHVYDWUOXWJGDTAXWCYDVLWUODVYDXTXHWFWFYC $.

      $( Lemma for ~ 2503prm .  Calculate the GCD of ` 2 ^ 1 8 - 1 == 1 8 3 1 `
         with ` N = 2 5 0 3 ` .  (Contributed by Mario Carneiro, 3-Mar-2014.)
         (Revised by Mario Carneiro, 20-Apr-2015.) $)
      2503lem3 $p |- ( ( ( 2 ^ ; 1 8 ) - 1 ) gcd N ) = 1 $=
        ( c1 c8 cdc c3 c2 co 1nn0 c5 cc0 2nn0 c6 c7 7nn0 c4 c9 cmul caddc eqtri
        cexp cmin wcel cn0 2nn 8nn0 deccl nnexpcl mp2an nnm1nn0 ax-mp 3nn0 5nn0
        cn 0nn0 3nn decnncl eqeltri 2503lem1 eqid decsuc modsubi 6nn0 4nn0 9nn0
        1p1e2 cgcd cz wceq nn0zi gcdcom cdivides wbr wn 9nn 1nn mulid2i oveq12i
        2cn 2p2e4 8p1e9 9t2e18 decmac 1lt9 declt ndvdsi cprime 19prm coprm mpbi
        wb 4cn 4p2e6 nncni oveq1i 9p9e18 decma2c gcdi 6nn 4p1e5 6p5e11 addcomli
        8nn 9p8e17 6p1e7 dec0h ax-1cn mulid1i 00id addid1i 3eqtri 8p7e15 8t2e16
        7nn 7p1e8 mulcomli 6p2e8 decaddi c10 5t2e10 dec10 addid2i 7p5e12 oveq2i
        5nn 6t2e12 7t2e14 9p4e13 decaddci 2t2e4 7p4e11 nn0cni 3cn 7p3e10 eqtr4i
        2p1e3 gcdmodi ) CDEZFEZCEZCGYRUAHZCUBHZAUUAUNUCZUUBUDUCGUNUCYRUDUCUUCUE
        CDIUFUGZGYRUHUIZUUAUJUKYSCYRFUUDULUGZIUGZAGJEZKEZFEZUNBUUIFUUHKGJLUMUGU
        OUGUPUQURZUUACYSGEYTAUUKUUEIUUGABUSYSCGYTUUFIVFYTUTZVAVBMNEZGEZCCAYTIUU
        MGMNVCOUGZLUGZUUGPDEZNEZCGYTUUNLUUQNPDVDUFUGZOUGZUUPYRJEZCCUUNUURIYRJUU
        DUMUGZUUTCCEZNEZCGUURUVALUVCNCCIIUGZOUGZUVBMDEZCCUVAUVDIMDVCUFUGZUVFPQE
        ZCCUVDUVGIPQVDVEUGZUVHCQEZCCUVGUVIICQIVEUGZUVJUVIUVKVGHZUVKUVIVGHZCUVIV
        HUCZUVKVHUCUVMUVNVIUVIUVJVJZUVKUVLVJUVIUVKVKUIUVKUVIVLVMVNZUVNCVIZUVKUV
        IGUVCCQIVOUQLCCIVPUQCQCCGPQCUVKUVCIVEIIUVKUTZUVCUTZLVEICGRHZCCSHZSHGGSH
        ZPUWAGUWBGSGVSVQVFVRVTTCDQQGRHIUFWAWBVAWCCCQIIVOWDWEWFUVKWGUCUVOUVQUVRW
        KWHUVPUVKUVIWIUIWJTPQCQCMDCUVIUVKVDVEIVEUVIUTZUVSIUFICPRHZUWBSHPGSHZMUW
        EPUWBGSPWLVQVFVRWMTZCQRHZQSHQQSHYRUWHQQSQQVOWNZVQWOWPTWQWRMDPQCUVCNCUVG
        UVIVCUFVDVEUVGUTZUWDIOICMRHZPCSHZSHMJSHUVCUWKMUWLJSMMWSWNZVQWTVRXATCDRH
        ZQSHDQSHCNEZUWNDQSDDXCWNZVQZWOQDUWOUWIUWPXDXBTZWQWRUVCNMDCYRJCUVDUVGUVE
        OVCUFUVDUTZUWJIUMICCKNCCDKUVCMCSHZIIUOOUVTUWTNKNEXENOXFTZIUFUOCCRHZKKSH
        ZSHCKSHCUXBCUXCKSCXGXHZXIVRCXGXJTUXBNSHCNSHDKDEUXBCNSUXDWONCDNXNWNZXGXO
        XBDUFXFXKWQCNRHZDSHNDSHCJEZUXFNDSNUXEVQZWODNUXGUWPUXEXLXBTWQWRYRJUVCNGU
        UQNCUVAUVDUUDUMUVEOUVAUTZUWSLOICDCGGPDCYRUVCCSHIUFILYRUTZCCGUVCIIVFUVTV
        ALUFIGCRHZUWBSHUWCPUXKGUWBGSGVSXHVFVRVTTCMDGDRHGIVCLDGCMEUWPVSXMXPXQXRW
        QCKNGJRHZNIUOOUXLXSCKEZJGXSJYEWNVSXTXPYATNUXEYBXRWQWRUUQNYRJCUUMGCUURUV
        AUUSOUUDUMUURUTZUXIILIPDCQCMNCUUQYRCSHVDUFIVEUUQUTZCDQYRIUFWAUXJVAIOIUW
        GUWRWQUXFJSHNJSHCGEZUXFNJSUXHWOYCTWQWRUUMGUUQNGYSCCUUNUURUUOLUUSOUUNUTZ
        UXNLIIMNPQGYRFGUUMUUQCSHVCOVDVEUUMUTPDQUUQVDUFWAUXOVALULLGMRHZUWFSHUXRM
        SHYRUWFMUXRSWMYDCGDUXRMILVCMGUXPUWMVSYFXPMGDUWMVSXQXBXRTCPFGGNRHQIVDVEN
        GCPEUXEVSYGXPVFULQPCFEUWIWLYHXBYIWQGGRHZNSHPNSHUVCUXSPNSYJWONPUVCUXEWLY
        KXBTWQWRCYTRHUUNSHUUJAYSCUUMGCUUIFKYTUUNUUFIUUOLUULUXQIULUOYRFMNCUUHKCY
        SUUMKSHUUDULVCOYSUTUUMUUMUUOYLXJIUOICDKNCGJCYRUWTIUFUOOUXJUXAIUMIUXBKCS
        HZSHUWBGUXBCUXTCSUXDCXGYBVRVFTUWNNSHDNSHUXGUWNDNSUWQWOXLTWQCFRHZNSHFNSH
        XSUXMUYAFNSFYMVQWONFXSUXEYMYNXBYAXKWQUXBGSHCGSHFKFEUXBCGSUXDWOGCFVSXGYP
        XBFULXFXKWQBYOWRYQ $.

      $( 2503 is a prime number.  (Contributed by Mario Carneiro, 3-Mar-2014.)
         (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
      2503prm $p |- N e. Prime $=
        ( c2 c1 c8 cdc c3 c9 co 1nn0 caddc cmul 2nn0 deccl 0nn0 c6 3nn0 6nn0 c7
        cc0 cmin 139prm 8nn decnncl c5 5nn0 eqid decsuc eqtr4i oveq1i 8nn0 9nn0
        2p1e3 7nn0 6nn nncni 6p1e7 addcomli dec0h eqtri mulid1i addid2i oveq12i
        ax-1cn 1p1e2 8p7e15 decmac 3cn mulid2i 3p3e6 4nn0 8t3e24 c10 4cn 6p4e10
        c4 decaddci2 decma2c 9p7e16 9t8e72 mulcomli decmul1c decmul2c wcel wceq
        9nn cc nn0cni pncan mp2an cn0 eqeltri npcan eqcomi 1nn 2nn cexp numexp1
        oveq2i clt 8lt10 1lt10 declti decltc breqtrri 2503lem2 2503lem3 pockthi
        ) CDEFZDGFZHFZDXIADUAIZAUBDEJUCUDZXLCUEFZTFZCFZDKIZDUAIZXIXKLIZAXQDUAAX
        OGFZXQBXOCGXPXNTCUEMUFNONZMUMXPUGUHUIUJXSXPXRXJHXOCXIDPFZXKDEJUKNZDGJQN
        ZULXKUGMDPJRNDGDPXIXNTPXJYBJQJRXJUGYBUGYCORDETSDCUEDXIDPKIZJUKOUNXIUGZY
        ESTSFPDSPUOUPZVDUQURSUNUSUTJUFJDDLIZTDKIZKIDDKICYHDYIDKDVDVADVDVBVCVEUT
        EDLIZSKIESKIDUEFYJESKEEUCUPZVAUJVFUTVGDETPGPTGXIPJUKORYFPRUSQOQDGLIZTGK
        IZKIGGKIPYLGYMGKGVHVIGVHVBVCVJUTCVPGEGLIPMVKRVLUMPVPVMYGVNVOURVQVGVRDEY
        BCHSXIULJUKYFMUNDHLIZSKIHSKIYBYNHSKHHWFUPZVIUJVSUTHESCFYOYKVTWAWBWCXPWG
        WDDWGWDZXRXPWEXPXOCYAMNWHVDXPDWIWJUIUIZXLDKIZAAWGWDYPYRAWEAAXTWKBXOGYAQ
        NWLWHVDADWMWJWNXMWOWPXLXSXIXKDWQIZLIYQYSXKXILXKXJHYDULNWRZWSUIXIXKYSWTD
        XJEHJYDUKULXADGDWOQJXBXCXDYTXEABXFABXGXH $.
    $}

    ${
      4001prm.1 $e |- N = ; ; ; 4 0 0 1 $.
      $( Lemma for ~ 4001prm .  Calculate a power mod.  In decimal, we
         calculate ` 2 ^ 1 2 = 4 0 9 6 = N + 9 5 ` ,
         ` 2 ^ 2 4 = ( 2 ^ 1 2 ) ^ 2 == 9 5 ^ 2 = 2 N + 1 0 2 3 ` ,
         ` 2 ^ 2 5 = 2 ^ 2 4 x. 2 == 1 0 2 3 x. 2 = 2 0 4 6 ` ,
         ` 2 ^ 5 0 = ( 2 ^ 2 5 ) ^ 2 == 2 0 4 6 ^ 2 = 1 0 4 6 N + 1 0 7 0 ` ,
         ` 2 ^ 1 0 0 = ( 2 ^ 5 0 ) ^ 2 == 1 0 7 0 ^ 2 = 2 8 6 N + 6 1 4 ` and
         ` 2 ^ 2 0 0 = ( 2 ^ 1 0 0 ) ^ 2 == 6 1 4 ^ 2 = 9 4 N + 9 0 2 `
         ` == 9 0 2 ` .  (Contributed by Mario Carneiro, 3-Mar-2014.)  (Revised
         by Mario Carneiro, 20-Apr-2015.) $)
      4001lem1 $p |- ( ( 2 ^ ; ; 2 0 0 ) mod N ) = ( ; ; 9 0 2 mod N ) $=
        ( c2 cc0 c9 c4 c6 c1 4nn0 0nn0 6nn0 1nn0 2nn0 c5 c7 co cmul caddc eqtri
        cdc c10 cn deccl 1nn decnncl eqeltri 10nn0 9nn0 nn0zi c8 5nn0 8nn0 7nn0
        2nn c3 0z 3nn0 2z 1z cexp cmo 2exp6 oveq1i 6nn 2cn 6t2e12 mulcomli eqid
        nncni 9nn addid1i dec0h 00id 4cn mulid2i oveq12i ax-1cn decma2c addid2i
        mul01i mulid1i 5nn 5p1e6 addcomli oveq2i 6t6e36 6p4e10 decaddci2 6t4e24
        2p2e4 3p1e4 5p4e9 decaddi decmac decsuc 4t4e16 decmul1c decmul2c eqtr4i
        4p1e5 mod2xi 2t2e4 nn0cni dec10p 4t2e8 8p1e9 3p2e5 9t9e81 9p1e10 9t5e45
        3cn 7nn 7p5e12 decaddci 5p2e7 5t5e25 mul02i dec0u 3t2e6 3eqtr4i modxp1i
        5t2e10 dec10 0p1e1 10p10e20 7p4e11 decaddc 6p2e8 4p2e6 8nn 2p1e3 decadd
        9p2e11 6p3e9 decma 4p3e7 10nn decaddc2 8p3e11 6p1e7 8t4e32 7p7e14
        7t7e49 9t4e36 8p2e10 ) CUADTZEFTZCDTZDTGHTZFTZEDTZCTZAAFDTZDTZHTUBBUUNH
        UUMDFDIJUCZJUCZUDUEUFZUNUADUGJUCUUGEFUHIUCZUIUUIFGHKLUCZIUCZUUKCEDUHJUC
        ZMUCCNDTZCUJTZGTZUUFUAOTZDTZUUJAUUQUNNDUKJUCUVDUVCGCUJMULUCZKUCZUIUVEDU
        AOUGUMUCZJUCZUUTCCNTZUAFTZGTZUVBUUHFTZGTZUVFAUUQUNCNMUKUCZUVMUVLGUAFUGI
        UCZKUCZUIUVNGUUHFCDMJUCZIUCZKUCZUVJCCFTZDUVKUACTZUOTZUVOAUUQUNCFMIUCZUP
        UWCUOUACUGMUCZUQUCZUWACHCTZCUWBENTZUWDAUUQUNHCLMUCZURENUHUKUCZUWGCGHUWH
        GFTZUWIAUUQUNKUSGFKIUCZUWKCGUTPUWLAVAVBVCGCUWHGVDVIZVEVFVGZHAQPUWIRPUUM
        ETZGTUWLUWLQPUUNHENHUWPGDAUWIUUPLUHUKBUWIVHZLKJUUMDDEHUUMEDUUNEDRPZUUOJ
        JUHUUNVHZUWREDETZEEVJVIZVKZEUHVLZSZLUHJFDDDHFDDUUMDDRPZIJJJUUMVHZUXEDDD
        TZVMDJVLZSZLJJHFQPZUXERPFDRPZFUXJFUXEDRFVNVOZVMVPFVNVKZSZHDQPZDRPUXEUXG
        UXODDRHVQVTZVCUXISVRUXOERPDERPZUWTUXODERUXPVCUXQEUWTEUXAVSZUXCSZSVRHHQP
        ZNRPHNRPZDGTZUXTHNRHVQWAZVCUYAGUYBNHGNWBVIZVQWCWDGKVLZSSVRGFUWPGUWLUVKU
        WLUWMKIUWLVHZKUVPGFCNGUUMECUWLUVKKIMUKUYFUVKVHZKUHMGGQPZCCRPZRPUYHFRPUU
        MUYIFUYHRWJWEUOGFUYHFUQKIWFWKWGWHSCFEFGQPZNMIUKGFUWBUWNVNWIVGZNFEUYDVNW
        LWDZWMZWNGFUVKGFHUWLIKIUYFKLCFNGFQPZMIWTWIWOWPWQWRWSXAHCCFCDUWHMLMUWHVH
        ZIJCHQPZDRPCDRPZCUYPCDRCVEWAZVCCVEVKZSZCCQPZFDFTZXBFIVLZSZWRCAQPUWDRPUU
        LNTUWIUWIQPUUNHUWCUOCUULNDAUWDUUPLUWFUQBUWDVHZMUKJUUMDUACCUUKCDUUNUWCDR
        PUUOJUGMUWSUWCUWCUWFXCVKMMJFDHDCEDDUUMUADRPZIJLJUXFDXDMJJCFQPZHDRPZRPUJ
        HRPZEVUGUJVUHHRFCUJVNVEXEVGZHVQVKZVPXFSCDQPZDRPUXEUXGVULDDRCVEVTZVCUXIS
        VRVULCRPDCRPZDCTZVULDCRVUMVCVUNCVUOCVEVSZCMVLZSZSVRUYPUORPCUORPZDNTZUYP
        CUORUYRVCVUSNVUTUOCNXKVEXGWDNUKVLZSSVRENUULNUWIFOTZUWIUWKUHUKUWQUKFOIUM
        UCENFOEUUKCNUWIVVBUHUKIUMUWQVVBVHUHMUKEEQPZFNRPZRPVVCERPUUKVVDEVVCRUYLW
        EUJHEVVCEULLUHXHXFEHUAUXAVQXIWDZWHSFNCNNEQPOIUKUMENFNTUXAUYDXJVGWTMONUW
        HOXLVIZUYDXMWDXNWNENVVBNNCUWIUKUHUKUWQUKMFNOENQPCIUKMXJXOWMXPWQWRWSXACF
        NUWBMIWTUWBVHZWODUVORPUVODAQPZUVORPUWDCQPUVOUVOUWAXCZVSVVHDUVORAAUUQVIX
        QVCUWCUOUVNGCDUWDMUWFUQVUEKJUWCCQPZDRPUVNDRPUVNVVJUVNDRUACUUHFCDUWCMUGM
        UWCVHIJUACQPZDRPUUHDRPZUUHVVKUUHDRCMXRVCUUHUUHUVSXCVKZSVUDWQVCUVNUVNUVT
        XCVKSUOCQPGUYBXSUYESWQXTYACNNDCHUVKMMUKUYGJLVUAHRPFHRPZNVUAFHRXBVCWTSCN
        QPZUAHDTZNCUAUYDVEYBVGZYCSWRUVMAQPUVFRPFHTZUJTZGTZHTZHTZGTUVOUVOQPUUNHU
        VEDUVMVWBGUVLAUVFUUPLUVIJBUVFVHZUVRKUVQUUMDCHTZHUVMVWAHDUUNUVEUVLRPUUOJ
        CHMLUCZLUWSUAOUAFVWDHUVEUVLUGUMUGIUVEVHZUVLVHZCDHUAUARPMJYDYEWOLYFYGUVR
        LJFDCHUVMVVTHDUUMVWDDRPIJMLUXFVWDVWDVWEXCVKUVRLJUVLGDCFVVSGCUVMUYQUVQKJ
        MUVMVHUYQCVUOUYSVUQSIKMUAFDCFVVRUJHUVLVUNUGIJMVWGVURIULLHDDHFFHDUADHRPZ
        LJJLYCVWHHDHTZYDHLVLZSZILJUXNDFQPZHRPVWHVWIVWLDHRFVNXQVCVWKSZWNHGUJFFQP
        ZCLKMWPYHWMWNCFGUYNCMIMWIYIWMWNUVMDQPZHRPVWHVWIVWODHRUVMUVMUVRXCZVTVCVW
        KSZVRVWQVRUVMHQPZDRPUVMDRPUVMVWRUVMDRUVMVWPWAVCUVMVWPVKSVRUVNGVWBGUVOUW
        HCTZOTZUVOUWAUVTKUVOVHZKVWSOUWHCUWJMUCZUMUCUUHFVWSOUVOVWAHUJHTZETZUVNVW
        TUVSIVXBUMUVNVHZVWTVHUWALVXCEUJHULLUCZUHUCCDUUGHUVOVVTHDUUHVWSVXDRPMJUU
        RLUUHVHZUWHCVXCEUUGHVWSVXDUWJMVXFUHVWSVHVXDVHEUOFUWHVXCRPUHUQWKHCUJHEUO
        UWHVXCLMULLUYOVXCVHUJHEUJYJVIZVQXFWDYKYLWOLECHHTZUXAVEYMWDYGUWALJUVNGEF
        CVVSGHUVOUUGDRPUVTKUHIVXAUUGUUGUURXCZVKMKLUUHFHDCVVRUJDUVNEHRPZUVSILJVX
        EVXKUAVVPXIYCSMULJCDDHCFHDUUHVUHMJJLVXGVUHHVWIVUKVWJSZMLJVUAUXERPUXKFVU
        AFUXEDRXBVMVPUXMSDCQPZHRPVWHVWIVXMDHRCVEXQVCVWKSWNFCQPZDRPUJDRPZDUJTZVX
        NUJDRXEVCVXOUJVXPUJVXHVKZUJULVLSSWNHCGGCQPFLMIVFFCGVNVEYIWDWMWNUVODQPZH
        RPVWHVWIVXRDHRUVOVVIVTVCVWKSVRUVNGDOFVXDHUOUVOOUVTKJUMVXAOUMVLZILUQUUHF
        DUOFVXCEHUVNDUORPZUVSIJUQVXEVXTUODUOTUOXKVSZUOUQVLZSIUHLCDDHFUJHDUUHVWH
        MJJLVXGVWKILJVUGUXERPVXOUJVUGUJUXEDRVUJVMVPVXQSVWMWNHGEVWNUOLKUQWPYNWMW
        NCFHUOUYNOMIUMWIYKLOFVXIVVFVNYFWDXNWNVRUVNGVWTGGUOUVOKUVTKVXAKUQUUHFDUO
        GVWSOCUVNUOUVSIJUQVXEVYBKUMMCDDCGUWHCUUHVUNMJJMVXGVURKCGQPZDRPUWHDRPUWH
        VYCUWHDRUWOVCUWHUWHUWJXCVKSDGQPZCRPVUNCVYDDCRGUWNXQVCVUPSYOCFOUYJUOMIUQ
        UYKYPWMWNWFWQWRWSXANDUADCDUVBMUKJUVBVHJJVVODRPVUFUAVVOUADRVVQVCUAUAYQVI
        VKSVULDUXGVUMUXHSZWRUVDAQPUUJRPVXIFTZFTZETZDTZDTUVFUVFQPUUNHUUIFUVDVYID
        CETZAUUJUUPLUUSIBUUJVHZUVHJCEMUHUCUUMDEDUVDVYHDDUUNUUIVYJRPUUOJUHJUWSGH
        CEEUUIVYJKLMUHUUIVHZVYJVHGCRPZHRPVUIEVYMUJHRYHVCXFSVVEYRUVHJJFDDEUVDVYG
        EDUUMUWRIJJUHUXFUXDUVHUHJUVCGDDFVYFFCUVDUXEUVGKJJUVDVHZUXIIIMCUJDCFVXIF
        UOUVCVUNMULJMUVCVHZVURIIUQVUGVXTRPUJUORPVXIVUGUJVXTUORVUJVYAVPYSSUOCFUJ
        FQPCUQMMUUAWJWMWNUYNDRPUWBDRPUWBUYNUWBDRWIVCUWBUWBUWEXCVKSZWNUVDDQPZERP
        UXQUWTVYQDERUVDUVDUVHXCVTZVCUXSSVRVYQDRPUXEUXGVYQDDRVYRVCUXISVRUVCGDFHV
        YJDHUVDFUVGKJIVYNVUCLJLCUJDHHCEDUVCVWHMULJLVYOVWKLUHJUYPUXERPUYQCUYPCUX
        EDRUYRVMVPUYSSUJHQPZHRPVUIUWTVYSUJHRUJVXHWAVCVUIEUWTXFUXCSSWNGHQPZFRPGF
        RPZVVPVYTGFRGUWNWAZVCWUAUAVVPWGYCSSWNVRUVEDVYIDUVFDUVFUVJUVIJVWCJJVYHDD
        UVFUVEQPDVYGEVYFFVXIFHHLLUCIUCIUCUHUCJJUAOVYHDUVFOFTZETZUVEUVJUGUMVWFJW
        UCEOFUMIUCZUHUCZHDWUCEUVFVYGEDUAWUDLJWUEUHYCWUDVHUVJUHJUVEDOFHVYFFDUVFW
        UCDRPUVIJUMIVWCWUCWUCWUEXCVKLIJUAODOHVXIFHUVEODRPZUGUMJUMVWFWUGODOTOVVF
        VKZVXSSLILHDDHHHHDUAVWHLJJLYCVWKLLJUXTUXERPVUHHUXTHUXEDRUYCVMVPVUKSDHQP
        ZHRPVWHVWIWUIDHRHVQXQZVCVWKSWNOHQPZORPOORPHFTWUKOOROVVFWAVCUUBSWNWUIFRP
        DFRPZVUBWUIDFRWUJVCWULFVUBFVNVSVUCSZSWNUVFDQPZERPUXQUWTWUNDERUVFUVFUVJX
        CVTZVCUXSSVRUVEDWUDDODUVFUMUVIJVWCJJUVEOQPZDRPWUDDRPWUDWUPWUDDRUAOWUCEO
        FUVEUMUGUMVWFUHIHDDFOOFDUAFLJJIYCVUCUMIJHOQPZUXERPWUGOWUQOUXEDROVVFVOVM
        VPWUHSDOQPZFRPWULVUBWURDFROVVFXQZVCWUMSWNUUCWQVCWUDWUDWUFXCVKSWURDUXGWU
        SUXHSWQWRVMWMWUNDUXGWUOUXHSWRWSXAUADUUHDCDUUFMUGJUUFVHJJCUAQPZDRPVVLUUH
        WUTUUHDRHDCDCDUAMLJYCJJUYTVYEWRVCVVMSVYEWRUUGAQPUULRPUOOTZGTZETZETZGTUU
        JUUJQPUUNHUUKCUUGWVDGEAUULUUPLUVAMBUULVHUURKUHUUMDEEUUGWVCEDUUNUUKERPUU
        OJUHUHUWSEDEUUKEUHJUHUUKVHUXRWMUURUHJFDDEUUGWVBEDUUMUWRIJJUHUXFUXDUURUH
        JEFDDFWVAGHUUGUXEUHIJJUUGVHZUXIIKLEFQPZVWHRPWVFHRPWVAVWHHWVFRYDWEUOGOWV
        FUQKYTUUDWOSVWNDRPHGTZDRPWVGVWNWVGDRWPVCWVGWVGHGLKUCXCVKSWNUUGDQPZERPUX
        QUWTWVHDERUUGVXJVTVCUXSSZVRWVIVREFDCHEGDUUGCUHIJMWVEVUQLKJEHQPZUXERPUWR
        EWVJEUXEDREUXAWAVMVPUXBSFHQPZCRPFCRPZUYBWVKFCRFVNWAZVCWVLGUYBYIUYESSWNV
        RUUIFWVDGUUJUWBNTZUUJUUTUUSIVYKKUWBNUWEUKUCGHUWBNUUJWVCEUUIUUIWVNKLUWEU
        KVYLWVNVHUUTUHUUSUUIFUJNGWVBECUUJUWBUUIRPUUSIULUKVYKCFGHUJNUWBUUIMIKLVV
        GVYLGCUJUWNVEYHWDWTYLKUHMGHHDGWVAGUUIUJCRPZKLLJVYLWVOUAVVPUUEYCSKUOGOUY
        HUQKYTWFWOHGQPZDRPGDRPZGWVPGDRGUWNVOVCGUWNVKZSYOUYMWNUUIFDNHUUIEDUUJNUU
        SIJUKVYKVVALUHJGHDDHGHDUUIUXEKLJJVYLUXILLJVYTUXERPWVQGVYTGUXEDRWUBVMVPW
        VRSUXTDRPVUHVWIUXTHDRUYCVCVXLSWNWVKNRPVVDUWTWVKFNRWVMVCVVDEUWTUYLUXCSSW
        NVRUUIFWVNGFHUUJIUUSIVYKKLGHDHFUWBNUUIHKLJLVYLVWJIVYPUXJHRPVVNNUXJFHRUX
        LVCWTSYOWPWQWRWSXA $.

      $( Lemma for ~ 2503prm .  Calculate a power mod.  In decimal, we
         calculate
         ` 2 ^ 4 0 0 = ( 2 ^ 2 0 0 ) ^ 2 == 9 0 2 ^ 2 = 2 0 3 N + 1 4 0 1 ` and
         ` 2 ^ 8 0 0 = ( 2 ^ 4 0 0 ) ^ 2 == 1 4 0 1 ^ 2 = 4 9 0 N + 2 3 1 1 `
         ` == 2 3 1 1 ` .  (Contributed by Mario Carneiro, 3-Mar-2014.)
         (Revised by Mario Carneiro, 20-Apr-2015.) $)
      4001lem2 $p |- ( ( 2 ^ ; ; 8 0 0 ) mod N ) = ( ; ; ; 2 3 1 1 mod N ) $=
        ( c2 c4 cc0 cdc c9 c8 c1 c3 4nn0 0nn0 1nn0 2nn0 cmul caddc oveq1i eqtri
        co c6 deccl 1nn decnncl eqeltri 2nn 9nn0 nn0zi 3nn0 4001lem1 eqid 2t2e4
        cn 4cn addid1i 2cn mul01i dec0h decmul2c nn0cni 6nn0 4p2e6 decaddi 00id
        decadd ax-1cn addid2i 4t2e8 mulcomli oveq12i nncni mul02i 3eqtri decmac
        8nn 2p1e3 3cn 4t3e12 decsuc 6nn decma2c mulid1i 3p1e4 8nn0 addcomli 9nn
        9t9e81 decma 9t2e18 1p1e2 8p8e16 decaddci decmul1c eqtr4i c7 7nn0 7p1e8
        mod2xi 4p3e7 c10 9p1e10 decaddc2 oveq2i 4t4e16 6p3e9 9t4e36 c5 5nn0 5nn
        5p4e9 mulid2i 4p1e5 4p4e8 ) CDEFZEFZDGFZEFZHEFZEFIDFZEFZIFZCJFZIFZIFZAA
        XNIFULBXNIXMEDEKLUAZLUAZUBUCUDZUEYEXPXOEDGKUFUAZLUAZUGXSIXREIDMKUAZLUAZ
        MUAZYBIYAICJNUHUAZMUAZMUACCEFZEFZYNJFZXNGEFZCFZXTAYFUEYNECENLUAZLUAYPYN
        JYSUHUAZUGYQCGEUFLUAZNUAZYKABUIYNEXMECEYONYSLYOUJLLCYNOSZEPSXMEPSXMUUCX
        MEPCEDECEYNNNLYNUJZLLCCOSZEPSDEPSZDUUEDEPUKQDUMUNZRCEOSEEEFZCUOUPELUQZR
        ZURQXMXMYDUSUNRUUJURYPAOSXTPSHIFZJFZTFZEFZDFYRYROSXNIXSIYPUUNDYNAXTYEMY
        JMBXTUJZYTKYSXMEITFZEYPUUMEEXNXSYNPSYDLITMUTUAZLXNUJZXRECEUUPEXSYNYILNL
        XSUJZUUDIDTXRCMKNXRUJZVAVBVCVDYTLLDEITYPUULTEXMUUPEPSZKLMUTXMUJZUUPUUPU
        UQUSUNZYTUTLYNJEIDUUKJIYPIEPSZYSUHLMYPUJZUVDIEIFZIVEUNZIMUQZRKUHMCEEIDH
        IEYNEIPSZNLLMUUDUVIIUVFIVEVFZUVHRKMLCDOSZEEPSZPSHEPSZHUVKHUVLEPDCHUMUOV
        GVHZVCVIHHVNVJZUNZREDOSZIPSUVIIUVFUVQEIPDUMVKZQUVJUVHVLVMICJJDOSMNVODJI
        CFUMVPVQVHVRVMYPEOSZTPSETPSZTETFZUVSETPYPYPYTUSUPZQTTVSVJVFZTUTUQZVLVTU
        VSEPSUVLEUUHUVSEEPUWBQVCUUIVLVTYNJEIIYNDEYPIYSUHLMUVEUVHMKLCEEEICEEYNUV
        LNLLLUUDUVLEUUHVCUUIRZMLLCIOSZUVLPSCEPSZCUWFCUVLEPCUOWAVCVICUOUNZREIOSZ
        EPSUVLEUUHUWIEEPIVEVKZQVCUUIVLVMJIOSZIPSJIPSDEDFZUWKJIPJVPWAQWBDKUQZVLV
        MVTYQCUUNDYRIHFZEFZYRUUBUUANYRUJZKUWNEIHMWCUAZLUAZGEUWNEYRUUMEEYQUWOUFL
        UWQLYQUJZUWOUJUUBLLYQCIHGUULTCYRUWNEPSZUUANMWCUWPUWNUWNUWQUSUNZUFUTNGEE
        JGUUKJYQICPSZUFLLUHUWSUXBJEJFCIJUOVEVOWDJUHUQRUFGGOSZEPSUUKEPSUUKUXCUUK
        EPWFQUUKUUKHIWCMUAUSUNREGOSZJPSEJPSZJUXDEJPGGWEVJZVKQJVPVFZRWGIHTCCGOSH
        MWCWCGCUWNUXFUOWHVHWIUTWJWKVMYREOSZEPSUVLEUUHUXHEEPYRYRUUBUSUPQVCUUIVLV
        TYQCUWODCEYRNUUANUWPKLYQCOSZEPSUWOEPSUWOUXIUWOEPGEUWNECEYQNUFLUWSLLGCOS
        ZEPSUWTUWNUXJUWNEPWHQUXARECOSEUUHCUOVKUUIRWLQUWOUWOUWRUSUNRUUEDUWLUKUWM
        RWLURWMWQXMEXQECEXNNYDLUURLLCXMOSZEPSXQEPSXQUXKXQEPDEHECEXMNKLUVBLLUVKE
        PSUVMHUVKHEPUVNQUVPRUUJURQXQXQHEWCLUAUSUNRUUJURXPAOSYCPSIGFZTFZCFZHFZEF
        ZIFXTXTOSXNIYBIXPUXPIXOAYCYEMYMMBYCUJYHMYGXMECHFZEXPUXOEEXNYBXOPSYDLCHN
        WCUAZLUURYAIDGUXQYBXOYLMKUFYBUJXOUJZCWNHYADPSNWOWPCJWNYADNUHKYAUJDJWNUM
        VPWRWDVBVRGIWSUXFVEWTWDXAYHLLDECHXPUXNHEXMUXQEPSKLNWCUVBUXQUXQUXRUSUNYH
        WCLXOEECDUXMCEXPUWGYGLLNXPUJZUWGCECFZUWHCNUQZRKNLDGEEDUXLTJXOUVLKUFLLUX
        SUWEKUTUHDDOSZUXEPSUYCJPSUXLUXEJUYCPUXGXBITGUYCJMUTUHXCXDVBRGDOSZEPSJTF
        ZEPSUYEUYDUYEEPXEQUYEUYEJTUHUTUAUSUNRVMUVQCPSECPSCUYAUVQECPUVRQCUOVFUYB
        VLVMXPEOSZHPSEHPSHEHFZUYFEHPXPXPYHUSUPZQHUVOVFHWCUQZVLVTUYFEPSUVLEUUHUY
        FEEPUYHQVCUUIVLVTXOEEIIXOIEXPIYGLLMUXTUVHMMLDGEEIDGEXOUVLKUFLLUXSUWEMUF
        LDIOSZUVLPSUUFDUYJDUVLEPDUMWAZVCVIUUGRGIOSZEPSGEPSGEGFZUYLGEPGUXFWAQGUX
        FUNGUFUQZVLVMUWIIPSUVIIUVFUWIEIPUWJQUVJUVHVLVMVTXSIUXPIXTXSXTYKYJMUUOMY
        JXREXREXTUXOEEXSXSYILYILUUSUUSYKLLIDIDXTUXNHXFTFZEFZXRXREPSMKMKUUTXRXRY
        IUSUNYKWCUYOEXFTXGUTUAZLUAXSIUYOIIUXMCEXTIUYPPSYJMUYQMUUOEIUYOEUYOIIUYP
        LMUYQLUVHUYPUJUYOUYOUYQUSZVFUVGVDMNLXREXFTIUXLTEXSUYOEPSYILXGUTUUSUYOUY
        RUNMUTLIDEXFIIGEXRXFEPSZMKLXGUUTUYSXFEXFFXFXFXHVJZUNXFXGUQRMUFLIIOSZUVL
        PSUVDIVUAIUVLEPIVEWAZVCVIUVGRUYJXFPSDXFPSGUYMUYJDXFPUYKQXFDGUYTUMXIWDUY
        NVLVMUWITPSUVTTUWAUWIETPUWJQUWCUWDVLVMVUAIPSIIPSCUYAVUAIIPVUBQWIUYBVLVM
        XSIEDDUYPHEXTDYJMLKUUOUWMKWCLXREEEDUYOEEXSUVLYILLLUUSUWEKLLIDEEDXFTIXRU
        VLMKLLUUTUWEKUTMIDOSZUVIPSDIPSXFVUCDUVIIPDUMXJZUVJVIXKRUYCEPSUVAUUPUYCU
        UPEPXCQUVCRVMUVQEPSUVLEUUHUVQEEPUVRQVCUUIVLVMVUCDPSDDPSHUYGVUCDDPVUDQXL
        UYIVLVMVTXTEOSZEPSUVLEUUHVUEEEPXTXTYKUSZUPQVCUUIVLVTXTVUFWAURWMWQ $.

      $( Lemma for ~ 4001prm .  Calculate a power mod.  In decimal, we
         calculate ` 2 ^ 1 0 0 0 = 2 ^ 8 0 0 x. 2 ^ 2 0 0 == 2 3 1 1 x. 9 0 2 `
         ` = 5 2 1 N + 1 ` and finally
         ` 2 ^ ( N - 1 ) = ( 2 ^ 1 0 0 0 ) ^ 4 == 1 ^ 4 = 1 ` .  (Contributed
         by Mario Carneiro, 3-Mar-2014.)  (Revised by Mario Carneiro,
         20-Apr-2015.) $)
      4001lem3 $p |- ( ( 2 ^ ( N - 1 ) ) mod N ) = ( 1 mod N ) $=
        ( c2 cc0 cdc c1 co c4 0nn0 deccl 2nn0 1nn0 c8 c5 eqid cmul caddc oveq1i
        c9 eqtri cmin cn 4nn0 1nn decnncl eqeltri 2nn 0z c10 10nn0 c3 8nn0 5nn0
        nn0zi 3nn0 9nn0 4001lem2 4001lem1 8p2e10 00id decadd nn0cni addid2i 5nn
        dec0h nncni addid1i 5t4e20 4cn 2cn 4t2e8 mulcomli mulid2i 3eqtri decmac
        8nn decma mul01i decma2c mulid1i oveq12i ax-1cn 1p1e2 6nn0 4p1e5 oveq2i
        c6 9nn 9t2e18 decaddci2 c7 7nn0 7p1e8 9t3e27 decsuc 9p5e14 9p6e15 2t2e4
        3cn 3t2e6 decmul1c decmul2c eqtr4i modxai dec10 mul02i mod2xi wcel wceq
        cc pncan mp2an ) CCDEZDEZDEZDAFUAGZFFAAHDEZDEZFEZUBBXRFXQDHDUCIJZIJZUDU
        EUFZUGXNDXMDCDKIJZIJZIJUHLLCUIDEZDEZDXOFFAYBUGYEDUIDUJIJZIJUHLLCMDEZDEZ
        XNNCEZFEZYFCUKEZFEZFEZSDEZCEZFAYBUGYHDMDULIJZIJYKYJFNCUMKJZLJZUNYMFYLFC
        UKKUOJZLJZLJZLYDYOCSDUPIJZKJABUQABURYHDXMDYEDYIXNYQIYCIYIOXNOZMDCDUIDYH
        XMULIKIYHOXMOZUSUTVAUTVAYKAPGFQGXMMEZHEZNEZCEZCEYNYPPGXRFDFYKUUICYJAFYA
        LILBFLVEZYSKYRXQDNCYKUUHCDXRDYJQGXTIUMKXROYJYJYRVBVCYSKIHDDNYKUUGNDXQND
        QGZUCIIUMXQOUUKNDNEZNNVDVFZVGZNUMVEZTYSUMIYJFDDHUUFHDYKDDQGZYRLIIYKOZUU
        PDDDEZUTDIVEZTZUCUCINCDDHXMMYJUUPUMKIIYJOZUUTUCNHPGZDQGXMDQGZXMUVBXMDQV
        HRXMXMYCVBVGZTCHPGZDQGMDQGMUVEMDQHCMVIVJVKVLRMMVPVFVGTVQFHPGZDQGHDQGZHD
        HEUVFHDQHVIVMRHVIVGZHUCVEVNVOYKDPGZNQGDNQGNUULUVIDNQYKYKYSVBVRZRNUUMVCU
        UOVNVSUVICQGDCQGZCDCEZUVIDCQUVJRCVJVCZCKVEZVNVSYJFDFFYJCDYKFYRLILUUQUUJ
        LKINCDDFNCDYJUUPUMKIIUVAUUTLKINFPGZUUPQGUUKNUVONUUPDQNUUMVTUTWAUUNTCFPG
        ZDQGZCDQGZCUVLUVPCDQCVJVTRZCVJVGZUVNVNVOFFPGZFQGFFQGCUVLUWAFFQFWBVMZRWC
        UVNVNVOVSYOCUUICYNHWGEZCEZYPUUBUUCKYPOKUWCCHWGUCWDJZKJZSDUWCCYNUUHCDYOU
        WDUPIUWEKYOOUWDOUUBKIYMFHWGSUUGNFYNUWCDQGZUUALUCWDYNOZUWCUWCUWEVBVGZUPU
        MLYLFDNSUUFHFYMHFQGZYTLIUMYMOZUWJNUULWEUUOTUPUCLCUKDFSXMMCYLDFQGZKUOILY
        LOZUWLFDFEFWBVCZUUJTUPULKCSPGZUVKQGUWOCQGXMUVKCUWOQUVMWFFMCUWOCLULKSCFM
        ESWHVFZVJWIVLWCUSWJTCWKMUKSPGKWLWMSUKCWKEUWPWSWNVLWOVOFSPGZNQGSNQGFHEUW
        QSNQSUWPVMZRWPTVOUWQWGQGSWGQGFNEUWQSWGQUWRRWQTVOYNDPGZCQGUVKCUVLUWSDCQY
        NYNUUBVBVRRUVMUVNVNVSYMFUWDCCDYNKUUALUWHKIYMCPGZDQGUWDDQGUWDUWTUWDDQYLF
        UWCCCDYMKYTLUWKKIYLCPGZDQGUWGUWCUXAUWCDQCUKHWGCDYLKKUOUWMWDICCPGZDQGUVG
        HUXBHDQWRRUVHTZUKCPGWGDWGEWTWGWDVETXARUWITFCPGCUVLCVJVMUVNTZXARUWDUWDUW
        FVBVGTUXDXAXBXCXDYEDXNDCDYFKYGIYFOIICYEPGZDQGXNDQGXNUXEXNDQUIDXMDCDYEKU
        JIYEOIICUIPGZDQGUVCXMUXFXMDQFDCDCDUIKLIXEIIUVQUVRCUVSUVTTCDPGDUURCVJVRU
        USTZXBRUVDTUXGXBRXNXNYDVBVGTUXGXBDAPGZFQGUWLUWAUXHDFQAAYBVFXFRUWAFUWLUW
        BUWNXCXCZXGCXOPGXRDEZXPXNDXRDCDXOKYDIXOOIICXNPGZDQGXRDQGXRUXKXRDQXMDXQD
        CDXNKYCIUUDIICXMPGZDQGXQDQGXQUXLXQDQCDHDCDXMKKIUUEIIUXCUXGXBRXQXQXTVBVG
        TUXGXBRXRXRYAVBVGTUXGXBXPUXJFQGZFUAGZUXJAUXMFUAAXSUXMBXRDFUXJYAIUWNUXJO
        WOXCRUXJXJXHFXJXHUXNUXJXIUXJXRDYAIJVBWBUXJFXKXLTXCUXIXG $.

      $( Lemma for ~ 4001prm .  Calculate the GCD of
         ` 2 ^ 8 0 0 - 1 == 2 3 1 0 ` with ` N = 4 0 0 1 ` .  (Contributed by
         Mario Carneiro, 3-Mar-2014.)  (Revised by Mario Carneiro,
         20-Apr-2015.) $)
      4001lem4 $p |- ( ( ( 2 ^ ; ; 8 0 0 ) - 1 ) gcd N ) = 1 $=
        ( c2 c3 cdc c1 cc0 co 0nn0 deccl 2nn0 3nn0 1nn0 c4 c6 c9 c5 eqtri caddc
        c7 c8 cexp cmin cn wcel cn0 2nn 8nn0 nnexpcl mp2an nnm1nn0 4nn0 decnncl
        ax-mp eqeltri 4001lem2 0p1e1 eqid decsuc modsubi 6nn0 9nn0 5nn0 cgcd cz
        1nn wceq nn0zi gcdcom cdivides wbr wn 3nn 4cn 3cn 4t3e12 mulcomli 2p2e4
        cmul decaddi 2lt3 ndvdsi cprime wb 3prm coprm dec0h 2cn mulid1i oveq12i
        mpbi 2p1e3 4t2e8 oveq1i 8p3e11 decma2c gcdi mulid2i addid1i 3p1e4 1t1e1
        ax-1cn 4p1e5 addcomli 3eqtri 8p4e12 nncni 5t2e10 dec10 00id 4p2e6 5p1e6
        c10 5nn 1p1e2 6nn 6t2e12 3p2e5 nn0cni 6p5e11 6p3e9 7nn0 5p2e7 7nn 7p2e9
        oveq2i 9t2e18 decaddci 6p1e7 7p6e13 9p2e11 9p1e10 7p3e10 mul01i gcdmodi
        9nn eqtr4i ) CDEZFEZGEZFCUAGEZGEZUBHZFUCHZAUUCUDUEZUUDUFUECUDUEUUBUFUEU
        UEUGUUAGUAGUHIJIJCUUBUIUJZUUCUKUNYSGYRFCDKLJZMJZIJZANGEZGEZFEZUDBUUKFUU
        JGNGULIJIJVFUMUOZUUCFYSFEYTAUUMUUFMUUIABUPYSGFYTUUHIUQYTURZUSUTFOEZPEZF
        EZFFAYTMUUPFUUOPFOMVAJZVBJZMJZUUIOFEZPEZFFYTUUQMUVAPOFVAMJZVBJZUUTNQEZD
        EZFCUUQUVBKUVEDNQULVCJZLJZUVDUUOOEZFFUVBUVFMUUOOUURVAJZUVHFCEZFEZFCUVFU
        VIKUVKFFCMKJZMJZUVJUVEFFUVIUVLMUVGUVNDFEZFCUVLUVEKDFLMJZUVGFNEZFFUVEUVO
        MFNMULJZUVPDFCUVOUVQKLUVRUVQDVDHZDUVQVDHZFUVQVEUEZDVEUEUVSUVTVGUVQUVRVH
        ZDLVHUVQDVIUJDUVQVJVKVLZUVTFVGZDUVQNCVMULUGFCNDNVSHCMKKNDUVKVNVOVPVQVRV
        TWAWBDWCUEUWAUWCUWDWDWEUWBDUVQWFUJWKRFNGDCDFFUVQDMULILUVQURZDLWGKMMCFVS
        HZGFSHZSHCFSHDUWFCUWGFSCWHWIZUQWJWLRCNVSHZDSHUADSHFFEZUWIUADSNCUAVNWHWM
        VQZWNWORWPWQDFFNFNQGUVOUVQLMMULUVOURZUWEMVCIFDVSHZFGSHZSHDFSHZNUWMDUWNF
        SDVOWRZFXBWSZWJWTRFFVSHZNSHFNSHQGQEUWRFNSXAWNNFQVNXBXCXDQVCWGXEWPWQNQDF
        CUVKFFUVEUVOULVCLMUVEURZUWLKMMUWIUWOSHUANSHUVKUWIUAUWONSUWKWTWJXFRFGFCQ
        VSHZMIUQUWTXMFGEZQCXMQXNXGZWHXHVQXIRUSWPWQUVKFNQFUUOOGUVLUVEUVMMULVCUVL
        URZUWSMVAIFCGNFFOGUVKNGSHZMKIULUVKURZUXDNGNENVNWSZNULWGRMVAIUWRGGSHZSHU
        WNFUWRFUXGGSXAXJWJUWQRFCVSHZNSHCNSHOGOEZUXHCNSCWHWRZWNNCOVNWHXKXDZOVAWG
        ZXEWPUWRQSHFQSHOUXIUWRFQSXAWNQFOUXBXBXLXDUXLXEWPWQUUOOUVKFCUVEDFUVIUVLU
        URVAUVMMUVIURZUXCKLMFOFDCNQFUUOUVKFSHMVAMLUUOURZFCDUVKMKWLUXEUSKVCMUWFF
        FSHZSHCCSHZNUWFCUXOCSUWHXOWJVRRFCQCOVSHZDMKLOCUVKOXPXGZWHXQVQZDCQVOWHXR
        XDVTWPFCDUXQMKWLUXSUSWPWQUVEDUUOOFUVAPGUVFUVIUVGLUURVAUVFURZUXMMVBINQFO
        FOFFUVEUUOGSHULVCMVAUWSUUOUUOUURXSWSMMMFNVSHZUXOSHNCSHOUYANUXOCSNVNWRXO
        WJXKRFQVSHZOSHQOSHUWJUYBQOSQUXBWRWNOQUWJUXRUXBXTXDRWPUWMOSHDOSHPGPEZUWM
        DOSUWPWNODPUXRVOYAXDPVBWGZXEWPWQUVAPUVEDCUUPFCUVBUVFUVCVBUVGLUVBURZUXTK
        MKOFNTCUUOPGUVAUVECSHVAMULYBUVAURZNQTUVECULVCKUWSYCVTKVBIUXQUXDSHUXQNSH
        UUOUXDNUXQSUXFYFFCOUXQNMKULUXSUXKVTRUWFTSHCTSHPUYCUWFCTSUWHWNTCPTYDXGZW
        HYEXDUYDXEWPFUAFCCPVSHDMUHLPCFUAEPYPXGZWHYGVQXOMWOYHWPWQUUPFUVAPFYSGFUU
        QUVBUUSMUVCVBUUQURZUYEMIMUUOPOCFYRFFUUPUVAFSHUURVBVAKUUPUROFCUVAVAMXOUY
        FUSMMMFOGTFCDFUUOOFSHZMVAIYBUXNUYJTGTEYITYBWGRMLMUWRUWGSHUXOCUWRFUWGFSX
        AUQWJXORFOVSHZTSHOTSHFDEZUYKOTSOUXRWRWNTOUYLUYGUXRYJXDRWPFPVSHZCSHPCSHU
        WJUYMPCSPUYHWRWNYKRWPUWRPSHFPSHXMUXAUWRFPSXAWNPFXMUYHXBYLXDXIXEZWPWQFYT
        VSHUUQSHUULAYSGUUPFFUUKFGYTUUQUUHIUUSMUUNUYIMMIYRFUUOPFUUJGFYSUUPGSHUUG
        MUURVBYSURUUPUUPUUSXSWSMIMCDFTFNGFYRUUOFSHKLMYBYRURFOTUUOMVAYIUXNUSMIMU
        XHUXOSHUXPNUXHCUXOCSUXJXOWJVRRUWMTSHDTSHXMUXAUWMDTSUWPWNTDXMUYGVOYMXDXI
        XEWPUYNWPFGVSHZFSHUWGFGFEUYOGFSFXBYNWNUQFMWGXEWPBYQWQYO $.

      $( 4001 is a prime number.  (Contributed by Mario Carneiro, 3-Mar-2014.)
         (Proof shortened by Mario Carneiro, 20-Apr-2015.) $)
      4001prm $p |- N e. Prime $=
        ( c2 c3 cdc c5 c8 cc0 c1 co c4 cmul caddc 0nn0 deccl eqtri 5nn0 1nn0 c6
        2nn0 cmin 5prm 8nn decnncl2 4nn0 ax-1cn addid2i decsuc eqtr4i oveq1i cc
        eqid wcel wceq nn0cni pncan mp2an 8t5e40 addid1i 5nn nncni mul02i dec0h
        8nn0 decmul1c cn0 eqeltri npcan eqcomi 3nn0 2nn decnncl 3nn cexp sqvali
        2p1e3 5t5e25 c10 2cn 5t2e10 mulcomli dec10 decaddi numexpp1 6nn0 c7 7nn
        7nn0 7p1e8 addcomli 3cn mulid1i oveq12i 3p1e4 8p2e10 3eqtri 3t2e6 6p1e7
        decmac 2t2e4 6nn 4cn 6p4e10 decma2c 5p1e6 5t3e15 decmul2c clt 2lt10 1nn
        3lt10 declti decltc breqtrri 4001lem3 4001lem4 pockthi ) CDCEZFDGHEZHEZ
        AIUAJZAUBXSGUCUDUDYAKHEZHEZHEZXTFLJYAYDIMJZIUAJZYDAYEIUAAYCIEZYEBYCHIYD
        YBHKHUENOZNOZNIUFUGZYDULUHUIUJYDUKUMIUKUMZYFYDUNYDYCHYINOUOUFYDIUPUQPZX
        SHYCHFHXTQGHVDNONXTULNNXSFLJZHMJYCHMJYCYMYCHMGHYBHFHXSQVDNXSULNNGFLJZHM
        JYBHMJYBYNYBHMURUJYBYBYHUOUSPHFLJHHHEFFUTVAZVBHNVCPZVEUJYCYCYIUOUSPYPVE
        UIYAIMJZAAUKUMYKYQAUNAAYGVFBYCIYIROVGUOUFAIVHUQVIDCVJVKVLVMVKYAYDXRFDVN
        JZLJYLICEZFYCHXRISEZYRDCVJTOZICRTOZQFYSFEZCDQTVPCFYSFFCFCVNJZQTQUUDFFLJ
        CFEFYOVOVQPQTIHCCFLJZCRNTUUEVRIHEZFCVRYOVSVTWAWBPZCVSUGWCVQVEWDZNISRWEO
        ICISXRYBHWFYSYTRTRWEYSULYTULUUANWHDCHGIKHIXRIWFMJZVJTNVDXRULZUUIGHGEWFI
        GWFWGVAUFWIWJGVDVCPRNRDILJZHIMJZMJDIMJKUUKDUULIMDWKWLYJWMWNPCILJZGMJCGM
        JVRUUFUUMCGMCVSWLUJGCVRGUCVAVSWOWJWBWPWSDCHSCWFHIXRSVJTNWEUUJSWEVCTNRDC
        LJZUULMJSIMJWFUUNSUULIMWQYJWMWRPCCLJZSMJKSMJVRUUFUUOKSMWTUJSKVRSXAVAXBX
        CWJWBWPWSXDDCYTHFIXRQVJTUUJNRIFSDFLJRQXEFDIFEYOWKXFWAUHUUGVEXGUIXRUUCYR
        XHDYSCFVJUUBTQXIICDXJTVJXKXLXMUUHXNABXOABXPXQ $.
    $}
  $}


$(
###############################################################################
                     BASIC STRUCTURES
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                    Extensible structures
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Basic definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  An "extensible structure" is a function (set of ordered pairs) on a finite
  (and not necessarily sequential) subset of ` NN ` , used to define a specific
  group, ring, poset, etc.  The function's argument is the index of a structure
  component (such as ` 1 ` for the base set of a group), and its value is the
  component (such as the base set).  A group will have at least two components
  (base set and operation), although it can be further specialized by adding
  other components such as a multiplicative operation for rings (and still
  remain a group per our definition).  Thus, every ring is also a group.  This
  allows theorems from more general structures (groups) to be reused for more
  specialized structures (rings) without having to reprove them.

$)

  $c Struct $.
  $c ndx $.
  $c sSet $.
  $c Slot $.
  $c Base $.
  $c |`s $.

  $( Extend class notation with the class of structures with components
     numbered below ` A ` . $)
  cstr $a class Struct $.

  $( Extend class notation with the structure component index extractor. $)
  cnx $a class ndx $.

  $( Set components of a structure. $)
  csts $a class sSet $.

  $( Extend class notation with the slot function. $)
  cslot $a class Slot A $.

  $( Extend class notation with the class of all base set extractors. $)
  cbs $a class Base $.

  $( Extend class notation with the extensible structure builder restriction
     operator. $)
  cress $a class |`s $.

  ${
    $d f x $.
    $( Define a structure with components in ` M ... N ` .  This is not a
       requirement for groups, posets, etc., but it is a useful assumption for
       component extraction theorems.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    df-struct $a |- Struct = { <. f , x >. | ( x e. ( <_ i^i ( NN X. NN ) ) /\
       Fun ( f \ { (/) } ) /\ dom f C_ ( ... ` x ) ) } $.
  $}

  $( Define the structure component index extractor.  See theorem ~ ndxarg to
     understand its purpose.  The restriction to ` NN ` allows ` ndx ` to exist
     as a set, since ` _I ` is a proper class.  In principle, we could have
     chosen ` CC ` or (if we revise all structure component definitions such as
     ~ df-base ) another set such as the natural ordinal numbers ` om `
     ( ~ df-om ).  (Contributed by NM, 4-Sep-2011.) $)
  df-ndx $a |- ndx = ( _I |` NN ) $.

  ${
    $d x A $.
    $( Define slot extractor for posets and related structures.  Note that the
       function argument can be any set, although it is meaningful only if it
       is a member of ` Poset ` ( ~ df-poset ) when used for posets or of
       ` Grp ` ( ~ df-grp ) when used from groups.  (Contributed by Mario
       Carneiro, 22-Sep-2015.) $)
    df-slot $a |- Slot A = ( x e. _V |-> ( x ` A ) ) $.
  $}

  $( Define the base set (also called underlying set or carrier set) extractor
     for posets and related structures.  (Contributed by NM, 4-Sep-2011.)
     (Revised by Mario Carneiro, 14-Aug-2015.) $)
  df-base $a |- Base = Slot 1 $.

  ${
    $d e s w x $.
    $( Set one or more components of a structure.  This function is useful for
       taking an existing structure and "overriding" one of its components.
       For example, ~ df-ress adjusts the base set to match its second
       argument, which has the effect of making subgroups, subspaces, subrings
       etc. from the original structures.  Or ~ df-mgp , which takes a ring and
       overrides its addition operation with the multiplicative operation, so
       that we can consider the "multiplicative group" using group and monoid
       theorems, which expect the operation to be in the ` +g ` slot instead of
       the ` .r ` slot.  (Contributed by Mario Carneiro, 1-Dec-2014.) $)
    df-sets $a |- sSet = ( s e. _V , e e. _V |->
      ( ( s |` ( _V \ dom { e } ) ) u. { e } ) ) $.

    $( Define a multifunction restriction operator for extensible structures,
       which can be used to turn statements about rings into statements about
       subrings, modules into submodules, etc.  This definition knows nothing
       about individual structures and merely truncates the ` Base ` set while
       leaving operators alone; individual kinds of structures will need to
       handle this behavior, by ignoring operators' values outside the range
       (like ` Ring ` ), defining a function using the base set and applying
       that (like ` TopGrp ` ), or explicitly truncating the slot before use
       (like ` MetSp ` ).

       (Credit for this operator goes to Mario Carneiro).

       See ~ ressbas for the altered base set, and ~ resslem ( ~ subrg0 ,
       ~ ressplusg , ~ subrg1 , ~ ressmulr ) for the (un)altered other
       operations.  (Contributed by Stefan O'Rear, 29-Nov-2014.) $)
    df-ress $a |- |`s = ( w e. _V , x e. _V |-> if ( ( Base ` w ) C_ x , w ,
        ( w sSet <. ( Base ` ndx ) , ( x i^i ( Base ` w ) ) >. ) ) ) $.
  $}

  ${
    $d f x F $.  $d f x X $.
    $( The structure relation is a relation.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    brstruct $p |- Rel Struct $=
      ( vx vf cv cle cn cxp cin wcel c0 csn cdif wfun cdm cfz cfv wss df-struct
      w3a cstr relopabi ) ACZDEEFGHBCZIJKLUBMUANOPRBASABQT $.

    $( The property of being a structure with components in
       ` ( 1st `` X ) ... ( 2nd `` X ) ` .  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    isstruct2 $p |- ( F Struct X <-> ( X e. ( <_ i^i ( NN X. NN ) ) /\
        Fun ( F \ { (/) } ) /\ dom F C_ ( ... ` X ) ) ) $=
      ( vx vf cstr cvv wcel wa cle cdif wfun cdm cfz cfv wss w3a cun cfn wceq
      cn wbr cxp cin csn wrel brstruct brrelex12 mpan ssun1 undif1 sseqtr4i wfn
      c0 simp2 funfn sylib c1st c2nd cop inss2 sseli 1st2nd2 3ad2ant1 fveq2d co
      syl df-ov fzfi eqeltrri syl6eqel difss dmss ax-mp simp3 ssfi syl2anc fnfi
      syl5ss p0ex unexg sylancl ssexg sylancr jca cv simpr eleq1d simpl difeq1d
      elex funeqd dmeqd sseq12d 3anbi123d df-struct brabga pm5.21nii ) ABEUAZAF
      GZBFGZHZBITTUBZUCZGZAUMUDZJZKZALZBMNZOZPZEUEWRXAUFABEUGUHXKWSWTXKAXFXEQZO
      XLFGZWSAAXEQXLAXEUIAXEUJUKXKXFRGZXEFGXMXKXFXFLZULZXORGZXNXKXGXPXDXGXJUNXF
      UOUPXKXIRGXOXIOXQXKXIBUQNZBURNZUSZMNZRXKBXTMXDXGBXTSZXJXDBXBGYBXCXBBIXBUT
      VABTTVBVFVCVDXRXSMVEYARXRXSMVGXRXSVHVIVJXKXOXHXIXFAOXOXHOAXEVKXFAVLVMXDXG
      XJVNVRXIXOVOVPXOXFVQVPVSXFXERFVTWAAXLFWBWCXDXGWTXJBXCWJVCWDCWEZXCGZDWEZXE
      JZKZYELZYCMNZOZPXKDCABEFFYEASZYCBSZHZYDXDYGXGYJXJYMYCBXCYKYLWFZWGYMYFXFYM
      YEAXEYKYLWHZWIWKYMYHXHYIXIYMYEAYOWLYMYCBMYNVDWMWNCDWOWPWQ $.
  $}

  $( The property of being a structure with components in ` M ... N ` .
     (Contributed by Mario Carneiro, 29-Aug-2015.) $)
  isstruct $p |- ( F Struct <. M , N >. <->
    ( ( M e. NN /\ N e. NN /\ M <_ N ) /\
      Fun ( F \ { (/) } ) /\ dom F C_ ( M ... N ) ) ) $=
    ( cop cstr wbr cle cn cxp cin wcel c0 csn cdif wfun cdm cfz cfv wss w3a co
    isstruct2 brinxp2 df-br bitr3i biid df-ov sseq2i 3anbi123i bitr4i ) ABCDZEF
    UKGHHIJZKZALMNOZAPZUKQRZSZTBHKCHKBCGFTZUNUOBCQUAZSZTAUKUBURUMUNUNUTUQURBCUL
    FUMBCHHGUCBCULUDUEUNUFUSUPUOBCQUGUHUIUJ $.

  $( Two ways to express the relational part of a structure.  (Contributed by
     Mario Carneiro, 29-Aug-2015.) $)
  structcnvcnv $p |- ( F Struct X -> `' `' F = ( F \ { (/) } ) ) $=
    ( cstr wbr ccnv c0 csn cdif wss cin wceq wcel wn cvv 0nelxp cnvcnv inss2 cn
    cxp cnvss eqsstri sseli mto disjsn mpbir wb cnvcnvss reldisj ax-mp mpbi a1i
    wrel wfun cle cdm cfz isstruct2 simp2bi funrel dfrel2 sylib difss syl6eqssr
    cfv syl mp2b eqssd ) ABCDZAEZEZAFGZHZVJVLIZVHVJVKJFKZVMVNFVJLZMVOFNNSZLNNOV
    JVPFVJAVPJVPAPAVPQUAUBUCVJFUDUEVJAIVNVMUFAUGVJVKAUHUIUJUKVHVLVLEZEZVJVHVLUL
    ZVRVLKVHVLUMZVSVHBUNRRSJLVTAUOBUPVDIABUQURVLUSVEVLUTVAVLAIVQVIIVRVJIAVKVBVL
    ATVQVITVFVCVG $.

  ${
    structfun.1 $e |- F Struct X $.
    $( Convert between two kinds of structure closure.  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    structfun $p |- Fun `' `' F $=
      ( ccnv wfun c0 csn cdif cstr wbr cle cxp cin wcel cdm cfz cfv wss ax-mp
      cn isstruct2 simp2bi wceq structcnvcnv funeqi mpbir ) ADDZEAFGHZEZABIJZUI
      CUJBKTTLMNUIAOBPQRABUAUBSUGUHUJUGUHUCCABUDSUEUF $.
  $}

  ${
    structfn.1 $e |- F Struct <. M , N >. $.
    $( Convert between two kinds of structure closure.  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    structfn $p |- ( Fun `' `' F /\ dom F C_ ( 1 ... N ) ) $=
      ( ccnv wfun cdm c1 cfz co wss cop structfun wcel cle wbr w3a mpbi simp1i
      cn csn cdif cstr isstruct simp3i cuz cfv elnnuz fzss1 ax-mp sstri pm3.2i
      c0 ) AEEFAGZHCIJZKABCLZDMUNBCIJZUOBTNZCTNZBCOPZQZAUMUAUBFZUNUQKZAUPUCPVAV
      BVCQDABCUDRZUEBHUFUGNZUQUOKURVEURUSUTVAVBVCVDSSBUHRBHCUIUJUKUL $.
  $}

  ${
    $d x N $.  $d x S $.
    strfvnd.c $e |- E = Slot N $.
    $( A slot is a function on sets, treated as structures.  (Contributed by
       Mario Carneiro, 22-Sep-2015.) $)
    slotfn $p |- E Fn _V $=
      ( vx cvv cv cfv fvex cslot cmpt df-slot eqtri fnmpti ) DEBDFZGZABNHABIDEO
      JCDBKLM $.

    strfvnd.f $e |- ( ph -> S e. V ) $.
    $( Deduction version of ~ strfvn .  (Contributed by Mario Carneiro,
       15-Nov-2014.) $)
    strfvnd $p |- ( ph -> ( E ` S ) = ( S ` N ) ) $=
      ( vx wcel cvv cfv wceq elex cv fveq1 cslot cmpt df-slot eqtri fvex fvmpt
      3syl ) ABEIBJIBCKDBKZLGBEMHBDHNZKZUCJCDUDBOCDPHJUEQFHDRSDBTUAUB $.
  $}

  ${
    wunndx.1 $e |- ( ph -> U e. WUni ) $.
    wunndx.2 $e |- ( ph -> om e. U ) $.
    $( Closure of the index extractor in an infinite weak universe.
       (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    wunndx $p |- ( ph -> ndx e. U ) $=
      ( cnx cid cn cres df-ndx cc wuncn wss nnsscn wunss wf1o wf f1oi f1of mp1i
      a1i wunf syl5eqel ) AEFGHZBIAGGBUCCAJGBCABCDKGJLAMTNZUDGGUCOGGUCPAGQGGUCR
      SUAUB $.
  $}

  ${
    strfvn.f $e |- S e. _V $.
    strfvn.c $e |- E = Slot N $.
    $( Value of a structure component extractor ` E ` .  Normally, ` E ` is a
       defined constant symbol such as ` Base ` ( ~ df-base ) and ` N ` is a
       fixed integer such as ` 1 ` . ` S ` is a structure, i.e. a specific
       member of a class of structures such as ` Poset ` ( ~ df-poset ) where
       ` S e. Poset ` .

       Note:  Normally, this theorem shouldn't be used outside of this section,
       because it requires hard-coded index values.  Instead, use ~ strfv .
       (Contributed by NM, 9-Sep-2011.)  (Revised by Mario Carneiro,
       6-Oct-2013.)  (New usage is discouraged.) $)
    strfvn $p |- ( E ` S ) = ( S ` N ) $=
      ( cfv wceq wtru cvv wcel a1i strfvnd trud ) ABFCAFGHABCIEAIJHDKLM $.
  $}

  ${
    ndxarg.1 $e |- E = Slot N $.
    $( A structure component extractor produces a value which is contained in a
       set dependent on ` S ` , but not ` E ` .  This is sometimes useful for
       showing sethood.  (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    strfvss $p |- ( E ` S ) C_ U. ran S $=
      ( cvv wcel cfv crn cuni wss id strfvnd fvssunirn syl6eqss wn c0 fvprc 0ss
      pm2.61i ) AEFZABGZAHIZJTUACAGUBTABCEDTKLACMNTOUAPUBABQUBRNS $.

    ${
      wunstr.2 $e |- ( ph -> U e. WUni ) $.
      wunstr.3 $e |- ( ph -> S e. U ) $.
      $( Closure of a structure index in a weak universe.  (Contributed by
         Mario Carneiro, 12-Jan-2017.) $)
      wunstr $p |- ( ph -> ( E ` S ) e. U ) $=
        ( crn cuni cfv wunrn wununi wss strfvss a1i wunss ) ABIZJZBDKZCGARCGABC
        GHLMTSNABDEFOPQ $.
    $}

    ndxarg.2 $e |- N e. NN $.
    $( Get the numeric argument from a defined structure component extractor
       such as ~ df-base .  (Contributed by Mario Carneiro, 6-Oct-2013.) $)
    ndxarg $p |- ( E ` ndx ) = N $=
      ( cnx cfv cid cn cres cvv df-ndx wcel resiexg ax-mp eqeltri strfvn fveq1i
      nnex wceq fvresi 3eqtri ) EAFBEFBGHIZFZBEABEUBJKHJLUBJLRHJMNOCPBEUBKQBHLU
      CBSDHBTNUA $.

    $d x N $.  $d x E $.
    $( A structure component extractor is defined by its own index.  This
       theorem, together with ~ strfv below, is useful for avoiding direct
       reference to the hard-coded numeric index in component extractor
       definitions, such as the ` 1 ` in ~ df-base and the ` 10 ` in ~ df-ple ,
       making it easier to change should the need arise.  For example, we can
       refer to a specific poset with base set ` B ` and order relation ` L `
       using ` { <. ( Base `` ndx ) , B >. , <. ( le `` ndx ) , L >. } ` rather
       than ` { <. 1 , B >. , <. 10 , L >. } ` .  The latter, while shorter to
       state, requires revision if we later change ` 10 ` to some other number,
       and it may also be harder to remember.  (Contributed by NM,
       19-Oct-2012.)  (Revised by Mario Carneiro, 6-Oct-2013.) $)
    ndxid $p |- E = Slot ( E ` ndx ) $=
      ( vx cslot cnx cfv cvv cv cmpt df-slot ndxarg fveq2i mpteq2i eqtr4i ) ABF
      ZGAHZFZCSEIREJZHZKZQERLQEIBTHZKUBEBLEIUAUCRBTABCDMNOPPP $.
  $}

  ${
    $d e s A $.  $d e s B $.  $d e s S $.
    $( The structure override operator is a proper operator.  (Contributed by
       Stefan O'Rear, 29-Jan-2015.) $)
    reldmsets $p |- Rel dom sSet $=
      ( vs ve cvv cv csn cdm cdif cres cun csts df-sets reldmmpt2 ) ABCCADCBDEZ
      FGHMIJBAKL $.

    $( Value of the structure replacement function.  (Contributed by Mario
       Carneiro, 30-Apr-2015.) $)
    setsvalg $p |- ( ( S e. V /\ A e. W ) -> ( S sSet A ) =
      ( ( S |` ( _V \ dom { A } ) ) u. { A } ) ) $=
      ( vs ve wcel cvv csts co csn cdm cdif cres cun wceq elex wa resexg cv
      adantr snex unexg sylancl simpl simpr sneqd dmeqd difeq2d uneq12d df-sets
      reseq12d ovmpt2ga mpd3an3 syl2an ) BCGBHGZAHGZBAIJBHAKZLZMZNZUROZPZADGBCQ
      ADQUPUQVBHGZVCUPUQRVAHGZURHGVDUPVEUQBUTHSUAAUBVAURHHUCUDEFBAHHETZHFTZKZLZ
      MZNZVHOVBIHVFBPZVGAPZRZVKVAVHURVNVFBVJUTVLVMUEVNVIUSHVNVHURVNVGAVLVMUFUGZ
      UHUIULVOUJFEUKUMUNUO $.

    $( Value of the structure replacement function.  (Contributed by Mario
       Carneiro, 1-Dec-2014.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    setsval $p |- ( ( S e. V /\ B e. W ) -> ( S sSet <. A , B >. ) =
      ( ( S |` ( _V \ { A } ) ) u. { <. A , B >. } ) ) $=
      ( wcel cop csts co cvv csn cdm cdif cres wceq opex setsvalg mpan2 dmsnopg
      cun difeq2d reseq2d uneq1d sylan9eq ) CDFZBEFZCABGZHIZCJUGKZLZMZNZUITZCJA
      KZMZNZUITUEUGJFUHUMOABPUGCDJQRUFULUPUIUFUKUOCUFUJUNJABESUAUBUCUD $.
  $}

  ${
    wunsets.1 $e |- ( ph -> U e. WUni ) $.
    wunsets.2 $e |- ( ph -> S e. U ) $.
    wunsets.3 $e |- ( ph -> A e. U ) $.
    $( Closure of structure replacement in a weak universe.  (Contributed by
       Mario Carneiro, 12-Jan-2017.) $)
    wunsets $p |- ( ph -> ( S sSet A ) e. U ) $=
      ( csts co cvv csn cdm cdif cres cun wcel wceq setsvalg syl2anc wunres
      wunsn wunun eqeltrd ) ACBHIZCJBKZLMZNZUEOZDACDPBDPUDUHQFGBCDDRSAUGUEDEACU
      FDEFTABDEGUAUBUC $.
  $}

  $( The structure replacement function does not affect the value of ` S ` away
     from ` A ` .  (Contributed by Mario Carneiro, 1-Dec-2014.)  (Revised by
     Mario Carneiro, 30-Apr-2015.) $)
  setsres $p |- ( S e. V ->
    ( ( S sSet <. A , B >. ) |` ( _V \ { A } ) ) = ( S |` ( _V \ { A } ) ) ) $=
    ( wcel cop csts co cvv csn cdif cres cdm cun wceq c0 wss ax-mp mpbir eqtri
    opex setsvalg mpan2 reseq1d resundir dmsnopss sscon resabs1 cin dmres disj2
    wrel wb relres reldm0 uneq12i un0 syl6eq ) CDEZCABFZGHZIAJZKZLCIUTJZMZKZLZV
    DNZVCLZCVCLZUSVAVHVCUSUTIEVAVHOABUAUTCDIUBUCUDVIVGVCLZVDVCLZNZVJVGVDVCUEVMV
    JPNVJVKVJVLPVCVFQZVKVJOVEVBQVNABUFVEVBIUGRZCVCVFUHRVLPOZVLMZPOZVQVCVEUIZPVD
    VCUJVSPOVNVOVCVEUKSTVLULVPVRUMVDVCUNVLUORSUPVJUQTTUR $.

  $( Replacing the same components twice yields the same as the second setting
     only.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
  setsabs $p |- ( ( S e. V /\ C e. W ) ->
    ( ( S sSet <. A , B >. ) sSet <. A , C >. ) = ( S sSet <. A , C >. ) ) $=
    ( wcel wa cop csts co cvv csn cdif cres cun wceq setsres adantr setsval a1i
    uneq1d ovex sylan 3eqtr4d ) DEGZCFGZHZDABIZJKZLAMNZOZACIZMZPZDUKOZUNPUJUMJK
    ZDUMJKUHULUPUNUFULUPQUGABDERSUBUFUJLGZUGUQUOQURUFDUIJUCUAACUJLFTUDACDEFTUE
    $.

  ${
    setscom.1 $e |- A e. _V $.
    setscom.2 $e |- B e. _V $.
    $( Component-setting is commutative when the x-values are different.
       (Contributed by Mario Carneiro, 5-Dec-2014.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    setscom $p |- ( ( ( S e. V /\ A =/= B ) /\ ( C e. W /\ D e. X ) ) ->
       ( ( S sSet <. A , C >. ) sSet <. B , D >. ) =
       ( ( S sSet <. B , D >. ) sSet <. A , C >. ) ) $=
      ( wcel wa csts co cvv csn cres cun wceq wss cdif rescom uneq1i un23 eqtri
      wne cop setsval ad2ant2r reseq1d resundir wrel cdm cxp elex ad2antrl opex
      opelxpi sylancr relsn sylibr dmsnopss cin c0 disjsn2 ad2antlr disj2 sylib
      syl5ss relssres syl2anc uneq2d syl5eq eqtrd uneq1d ad2ant2rl ad2antll ssv
      wb ssconb mp2an 3eqtr4a ovex simprr simprl 3eqtr4d ) EFKZABUFZLZCGKZDHKZL
      ZLZEACUGZMNZOBPZUAZQZBDUGZPZRZEWSMNZOAPZUAZQZWNPZRZWOWSMNZXBWNMNZWMEXDQZW
      QQZXFRZWTRZEWQQZXDQZWTRZXFRZXAXGXMXOXFRZWTRXQXLXRWTXKXOXFEXDWQUBUCUCXOXFW
      TUDUEWMWRXLWTWMWRXJXFRZWQQZXLWMWOXSWQWGWJWOXSSWHWKACEFGUHUIUJWMXTXKXFWQQZ
      RXLXJXFWQUKWMYAXFXKWMXFULZXFUMZWQTYAXFSWMWNOOUNZKZYBWMAOKCOKZYEIWJYFWIWKC
      GUOUPACOOURUSWNACUQUTVAWMYCXCWQACVBWMXCWPVCVDSZXCWQTZWHYGWGWLABVEVFXCWPVG
      VHZVIXFWQVJVKVLVMVNVOWMXEXPXFWMXEXNWTRZXDQZXPWGWKXEYKSWHWJWGWKLXBYJXDBDEF
      HUHUJVPWMYKXOWTXDQZRXPXNWTXDUKWMYLWTXOWMWTULZWTUMZXDTYLWTSWMWSYDKZYMWMBOK
      DOKZYOJWKYPWIWJDHUOVQBDOOURUSWSBDUQUTVAWMYNWPXDBDVBWMYHWPXDTZYIXCOTWPOTYH
      YQVSXCVRWPVRXCWPOVTWAVHVIWTXDVJVKVLVMVNVOWBWMWOOKWKXHXASEWNMWCWIWJWKWDBDW
      OOHUHUSWMXBOKWJXIXGSEWSMWCWIWJWKWEACXBOGUHUSWF $.
  $}

  ${
    $d s E $.
    strfvd.e $e |- E = Slot ( E ` ndx ) $.
    strfvd.s $e |- ( ph -> S e. V ) $.
    strfvd.f $e |- ( ph -> Fun S ) $.
    strfvd.n $e |- ( ph -> <. ( E ` ndx ) , C >. e. S ) $.
    $( Deduction version of ~ strfv .  (Contributed by Mario Carneiro,
       15-Nov-2014.) $)
    strfvd $p |- ( ph -> C = ( E ` S ) ) $=
      ( cfv cnx strfvnd wfun cop wcel wceq funopfv sylc eqtr2d ) ACDJKDJZCJZBAC
      DTEFGLACMTBNCOUABPHITBCQRS $.
  $}

  ${
    strfv2d.e $e |- E = Slot ( E ` ndx ) $.
    strfv2d.s $e |- ( ph -> S e. V ) $.
    strfv2d.f $e |- ( ph -> Fun `' `' S ) $.
    strfv2d.n $e |- ( ph -> <. ( E ` ndx ) , C >. e. S ) $.
    strfv2d.c $e |- ( ph -> C e. W ) $.
    $( Deduction version of ~ strfv .  (Contributed by Mario Carneiro,
       30-Apr-2015.) $)
    strfv2d $p |- ( ph -> C = ( E ` S ) ) $=
      ( cfv cnx strfvnd ccnv cvv cres cnvcnv2 wcel wceq fveq1i fvex fvres ax-mp
      eqtri wfun cop cxp cin elex syl opelxpi sylancr sylanbrc cnvcnv syl6eleqr
      elin funopfv sylc syl5eqr eqtr2d ) ACDLMDLZCLZBACDVBEGHNAVCVBCOOZLZBVEVBC
      PQZLZVCVBVDVFCRUAVBPSZVGVCTMDUBZVBPCUCUDUEAVDUFVBBUGZVDSVEBTIAVJCPPUHZUIZ
      VDAVJCSVJVKSZVJVLSJAVHBPSZVMVIABFSVNKBFUJUKVBBPPULUMVJCVKUQUNCUOUPVBBVDUR
      USUTVA $.
  $}

  ${
    $d s E $.
    strfv2.s $e |- S e. _V $.
    strfv2.f $e |- Fun `' `' S $.
    strfv2.e $e |- E = Slot ( E ` ndx ) $.
    strfv2.n $e |- <. ( E ` ndx ) , C >. e. S $.
    $( A variation on ~ strfv to avoid asserting that ` S ` itself is a
       function, which involves sethood of all the ordered pair components of
       ` S ` .  (Contributed by Mario Carneiro, 30-Apr-2015.) $)
    strfv2 $p |- ( C e. V -> C = ( E ` S ) ) $=
      ( wcel cvv a1i ccnv wfun cnx cfv cop id strfv2d ) ADIZABCJDGBJISEKBLLMSFK
      NCOAPBISHKSQR $.
  $}

  ${
    strfv.s $e |- S Struct X $.
    strfv.e $e |- E = Slot ( E ` ndx ) $.
    strfv.n $e |- { <. ( E ` ndx ) , C >. } C_ S $.
    $( Extract a structure component ` C ` (such as the base set) from a
       structure ` S ` (such as a member of ` Poset ` , ~ df-poset ) with a
       component extractor ` E ` (such as the base set extractor ~ df-base ).
       By virtue of ~ ndxid , this can be done without having to refer to the
       hard-coded numeric index of ` E ` .  (Contributed by Mario Carneiro,
       6-Oct-2013.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    strfv $p |- ( C e. V -> C = ( E ` S ) ) $=
      ( cstr wbr cvv wcel brstruct brrelexi ax-mp structfun cnx cfv cop csn wss
      opex snss mpbir strfv2 ) ABCDBEIJBKLFBEIMNOBEFPGQCRZASZBLUGTBUAHUGBUFAUBU
      CUDUE $.
  $}

  ${
    strfv3.u $e |- ( ph -> U = S ) $.
    strfv3.s $e |- S Struct X $.
    strfv3.e $e |- E = Slot ( E ` ndx ) $.
    strfv3.n $e |- { <. ( E ` ndx ) , C >. } C_ S $.
    strfv3.c $e |- ( ph -> C e. V ) $.
    strfv3.a $e |- A = ( E ` U ) $.
    $( Variant on ~ strfv for large structures.  (Contributed by Mario
       Carneiro, 10-Jan-2017.) $)
    strfv3 $p |- ( ph -> A = C ) $=
      ( cfv wcel wceq strfv syl fveq2d eqtr4d syl6reqr ) ACEFOZBACDFOZUCACGPCUD
      QMCDFGHJKLRSAEDFITUANUB $.
  $}

  ${
    $d s E $.
    strssd.e $e |- E = Slot ( E ` ndx ) $.
    strssd.t $e |- ( ph -> T e. V ) $.
    strssd.f $e |- ( ph -> Fun T ) $.
    strssd.s $e |- ( ph -> S C_ T ) $.
    strssd.n $e |- ( ph -> <. ( E ` ndx ) , C >. e. S ) $.
    $( Deduction version of ~ strss .  (Contributed by Mario Carneiro,
       15-Nov-2014.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    strssd $p |- ( ph -> ( E ` T ) = ( E ` S ) ) $=
      ( cfv cnx cop sseldd strfvd cvv ssexd wss wfun funss sylc eqtr3d ) ABDELC
      ELABDEFGHIACDMELBNJKOPABCEQGACDFHJRACDSDTCTJICDUAUBKPUC $.
  $}

  ${
    $d s E $.
    strss.t $e |- T e. _V $.
    strss.f $e |- Fun T $.
    strss.s $e |- S C_ T $.
    strss.e $e |- E = Slot ( E ` ndx ) $.
    strss.n $e |- <. ( E ` ndx ) , C >. e. S $.
    $( Propagate component extraction to a structure ` T ` from a subset
       structure ` S ` .  (Contributed by Mario Carneiro, 11-Oct-2013.)
       (Revised by Mario Carneiro, 15-Jan-2014.) $)
    strss $p |- ( E ` T ) = ( E ` S ) $=
      ( cfv wceq wtru cvv wcel a1i wfun wss cnx cop strssd trud ) CDJBDJKLABCDM
      HCMNLEOCPLFOBCQLGORDJASBNLIOTUA $.
  $}

  ${
    str0.a $e |- F = Slot I $.
    $( All components of the empty set are empty sets.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro, 7-Dec-2014.) $)
    str0 $p |- (/) = ( F ` (/) ) $=
      ( c0 cfv 0ex strfvn 0fv eqtr2i ) DAEBDEDDABFCGBHI $.
  $}

  $( The base set of the empty structure.  (Contributed by David A. Wheeler,
     7-Jul-2016.) $)
  base0 $p |- (/) = ( Base ` (/) ) $=
    ( cbs c1 df-base str0 ) ABCD $.

  ${
    strfvi.e $e |- E = Slot N $.
    strfvi.x $e |- X = ( E ` S ) $.
    $( Structure slot extractors cannot distinguish between proper classes and
       ` (/) ` , so they can be protected using the identity function.
       (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
    strfvi $p |- X = ( E ` ( _I ` S ) ) $=
      ( cfv cid cvv wcel wceq fvi eqcomd fveq2d wn str0 fvprc 3eqtr4a pm2.61i
      c0 eqtri ) DABGZAHGZBGZFAIJZUBUDKUEAUCBUEUCAAILMNUEOZTTBGUBUDBCEPABQUFUCT
      BAHQNRSUA $.
  $}

  ${
    setsid.e $e |- E = Slot ( E ` ndx ) $.
    $( Value of the structure replacement function at a replaced index.
       (Contributed by Mario Carneiro, 1-Dec-2014.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    setsid $p |- ( ( W e. A /\ C e. V ) ->
      C = ( E ` ( W sSet <. ( E ` ndx ) , C >. ) ) ) $=
      ( wcel wa cnx cfv cvv csn cres cun sylancl wceq c0 cin eqtri a1i cop csts
      co cdif setsval fveq2d resexg adantr snex unexg strfvnd fvex fvres resres
      snid ax-mp incom disjdif reseq2i res0 wrel cdm wss adantl opelxpi sylancr
      cxp elex relsn sylibr dmsnopss relssres uneq12d resundir un0 uncom eqtr3i
      opex 3eqtr4g fveq1d syl5eqr fvsng sylancom eqtrd 3eqtrrd ) EAGZBDGZHZEICJ
      ZBUAZUBUCZCJEKWILZUDZMZWJLZNZCJWIWPJZBWHWKWPCWIBEADUEUFWHWPCWIKFWHWNKGZWO
      KGWPKGWFWRWGEWMAUGUHWJUIWNWOKKUJOUKWHWQWIWOJZBWHWQWIWPWLMZJZWSWIWLGXAWQPW
      IICULZUOWIWLWPUMUPWHWIWTWOWHWNWLMZWOWLMZNQWONZWTWOWHXCQXDWOXCQPWHXCEWMWLR
      ZMZQEWMWLUNXGEQMQXFQEXFWLWMRQWMWLUQWLKURSUSEUTSSTWHWOVAZWOVBWLVCXDWOPWHWJ
      KKVGGZXHWHWIKGZBKGZXIXBWGXKWFBDVHVDWIBKKVEVFWJWIBVRVIVJWIBVKWOWLVLOVMWNWO
      WLVNWOQNWOXEWOVOWOQVPVQVSVTWAWFWGXJWSBPXJWHXBTWIBKDWBWCWDWE $.

    $d x y $.
    setsnid.n $e |- ( E ` ndx ) =/= D $.
    $( Value of the structure replacement function at an untouched index.
       (Contributed by Mario Carneiro, 1-Dec-2014.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    setsnid $p |- ( E ` W ) = ( E ` ( W sSet <. D , C >. ) ) $=
      ( cvv wcel cfv cop csts co wceq cnx id strfvnd cres fvres ax-mp c0 strfvn
      ovex csn cdif setsres fveq1d wne fvex eldifsn mpbir2an syl5eq eqtr4d str0
      3eqtr3g wn fvprc reldmsets ovprc1 fveq2d 3eqtr4a pm2.61i ) DGHZDCIZDBAJZK
      LZCIZMVBVCNCIZDIZVFVBDCVGGEVBOPVBVFVGVEIZVHVECVGDVDKUBEUAVBVGVEGBUCUDZQZI
      ZVGDVJQZIZVIVHVBVGVKVMBADGUEUFVGVJHZVLVIMVOVGGHVGBUGNCUHFVGGBUIUJZVGVJVER
      SVOVNVHMVPVGVJDRSUNUKULVBUOZTTCIVCVFCVGEUMDCUPVQVETCDVDKUQURUSUTVA $.
  $}

  ${
    baseval.k $e |- K e. _V $.
    $( Value of the base set extractor.  (Normally it is preferred to work with
       ` ( Base `` ndx ) ` rather than the hard-coded ` 1 ` in order to make
       structure theorems portable.  This is an example of how to obtain it
       when needed.)  (New usage is discouraged.)  (Contributed by NM,
       4-Sep-2011.) $)
    baseval $p |- ( Base ` K ) = ( K ` 1 ) $=
      ( cbs c1 df-base strfvn ) ACDBEF $.
  $}

  $( Utility theorem: index-independent form of ~ df-base .  (Contributed by
     NM, 20-Oct-2012.) $)
  baseid $p |- Base = Slot ( Base ` ndx ) $=
    ( cbs c1 df-base 1nn ndxid ) ABCDE $.

  ${
    elbasfv.s $e |- S = ( F ` Z ) $.
    elbasfv.b $e |- B = ( Base ` S ) $.
    $( Utility theorem: reverse closure for any structure defined as a
       function.  (Contributed by Stefan O'Rear, 24-Aug-2015.) $)
    elbasfv $p |- ( X e. B -> Z e. _V ) $=
      ( wcel c0 wceq cvv n0i wn cbs cfv fvprc syl5eq fveq2d base0 3eqtr4g nsyl2
      ) DAHAIJEKHZADLUBMZBNOINOAIUCBINUCBECOIFECPQRGSTUA $.
  $}

  ${
    elbasov.o $e |- Rel dom O $.
    elbasov.s $e |- S = ( X O Y ) $.
    elbasov.b $e |- B = ( Base ` S ) $.
    $( Utility theorem: reverse closure for any structure defined as a
       two-argument function.  (Contributed by Mario Carneiro, 3-Oct-2015.) $)
    elbasov $p |- ( A e. B -> ( X e. _V /\ Y e. _V ) ) $=
      ( wcel c0 wceq cvv wa n0i wn cbs cfv co ovprc syl5eq fveq2d base0 3eqtr4g
      nsyl2 ) ABJBKLEMJFMJNZBAOUFPZCQRKQRBKUGCKQUGCEFDSKHEFDGTUAUBIUCUDUE $.
  $}

  $( Index value of the base set extractor.  (Normally it is preferred to work
     with ` ( Base `` ndx ) ` rather than the hard-coded ` 1 ` in order to make
     structure theorems portable.  This is an example of how to obtain it when
     needed.)  (New usage is discouraged.)  (Contributed by Mario Carneiro,
     2-Aug-2013.) $)
  basendx $p |- ( Base ` ndx ) = 1 $=
    ( cbs c1 df-base 1nn ndxarg ) ABCDE $.

  ${
    $d a w A $.  $d a w W $.
    $( The structure restriction is a proper operator, so it can be used with
       ~ ovprc1 .  (Contributed by Stefan O'Rear, 29-Nov-2014.) $)
    reldmress $p |- Rel dom |`s $=
      ( vw va cvv cv cbs cfv wss cnx cin cop csts cif cress df-ress reldmmpt2
      co ) ABCCADZEFZBDZGQQHEFSRIJKPLMBANO $.
  $}

  ${
    $d a s w A $.  $d a s w B $.  $d a s w W $.
    ressbas.r $e |- R = ( W |`s A ) $.
    ressbas.b $e |- B = ( Base ` W ) $.
    $( Value of structure restriction.  (Contributed by Stefan O'Rear,
       29-Nov-2014.) $)
    ressval $p |- ( ( W e. X /\ A e. Y ) -> R = if ( B C_ A , W ,
            ( W sSet <. ( Base ` ndx ) , ( A i^i B ) >. ) ) ) $=
      ( vw va wcel wa cress co wss cbs cfv csts cvv wceq cnx cin cop elex simpl
      cif ovex ifcl sylancl fveq2d syl6eqr simpr sseq12d ineq12d opeq2d oveq12d
      cv ifbieq12d df-ress ovmpt2ga mpd3an3 syl2an syl5eq ) DEKZAFKZLCDAMNZBAOZ
      DDUAPQZABUBZUCZRNZUFZGVDDSKZASKZVFVLTZVEDEUDAFUDVMVNVLSKZVOVMVNLVMVKSKVPV
      MVNUEDVJRUGVGDVKSUHUIIJDASSIUQZPQZJUQZOZVQVQVHVSVRUBZUCZRNZUFVLMSVQDTZVSA
      TZLZVTVGVQWCDVKWFVRBVSAWFVRDPQBWFVQDPWDWEUEZUJHUKZWDWEULZUMWGWFVQDWBVJRWG
      WFWAVIVHWFVSAVRBWIWHUNUOUPURJIUSUTVAVBVC $.

    $( General behavior of trivial restriction.  (Contributed by Stefan O'Rear,
       29-Nov-2014.) $)
    ressid2 $p |- ( ( B C_ A /\ W e. X /\ A e. Y ) -> R = W ) $=
      ( wss wcel wceq wa cnx cbs cfv cin cop csts co cif iftrue sylan9eqr 3impb
      ressval ) BAIZDEJZAFJZCDKUFUGLUECUEDDMNOABPQRSZTDABCDEFGHUDUEDUHUAUBUC $.

    $( Value of nontrivial structure restriction.  (Contributed by Stefan
       O'Rear, 29-Nov-2014.) $)
    ressval2 $p |- ( ( -. B C_ A /\ W e. X /\ A e. Y ) -> R = ( W sSet
        <. ( Base ` ndx ) , ( A i^i B ) >. ) ) $=
      ( wss wn wcel cnx cbs cfv cin cop csts co wceq wa ressval sylan9eqr 3impb
      cif iffalse ) BAIZJZDEKZAFKZCDLMNABOPQRZSUHUITUGCUFDUJUDUJABCDEFGHUAUFDUJ
      UEUBUC $.

    $( Base set of a structure restriction.  (Contributed by Stefan O'Rear,
       26-Nov-2014.) $)
    ressbas $p |- ( A e. V -> ( A i^i B ) = ( Base ` R ) ) $=
      ( cvv wcel cin cbs cfv wceq w3a fveq2d 3eqtr4a 3expib wn co c0 wa sseqin2
      wss wi simp1 sylib ressid2 cnx cop csts simp2 eqeltri inex2 baseid setsid
      fvex sylancl ressval2 eqtr4d pm2.61i 0fv 0ex strfvn 3eqtr4ri fvprc syl5eq
      in0 ineq2d cress reldmress ovprc1 adantr pm2.61ian ) EHIZADIZABJZCKLZMZBA
      UCZVNVOUAVRUDVSVNVOVRVSVNVONZBEKLZVPVQGVTVSVPBMVSVNVOUEBAUBUFVTCEKABCEHDF
      GUGOPQVSRZVNVOVRWBVNVONZVPEUHKLZVPUIUJSZKLZVQWCVNVPHIVPWFMWBVNVOUKBABWAHG
      EKUPULUMHVPKHEUNUOUQWCCWEKABCEHDFGUROUSQUTVNRZVRVOWGATJZTKLZVPVQWDTLTWIWH
      WDVATKWDVBUNVCAVGVDWGBTAWGBWATGEKVEVFVHWGCTKWGCEAVISTFEAVIVJVKVFOPVLVM $.

    $( Base set of a structure restriction.  (Contributed by Mario Carneiro,
       2-Dec-2014.) $)
    ressbas2 $p |- ( A C_ B -> A = ( Base ` R ) ) $=
      ( wss cin cbs cfv wceq df-ss biimpi cvv wcel fvex eqeltri ssex ressbas
      syl eqtr3d ) ABGZABHZACIJZUBUCAKABLMUBANOUCUDKABBDIJNFDIPQRABCNDEFSTUA $.

    $( The base set of a restriction is a subset of the base set of the
       original structure.  (Contributed by Stefan O'Rear, 27-Nov-2014.)
       (Revised by Mario Carneiro, 30-Apr-2015.) $)
    ressbasss $p |- ( Base ` R ) C_ B $=
      ( cvv wcel cbs cfv wss cin ressbas inss2 syl6eqssr wn c0 cress reldmress
      co ovprc2 syl5eq fveq2d base0 0ss eqsstr3i syl6eqss pm2.61i ) AGHZCIJZBKU
      IUJABLBABCGDEFMABNOUIPZUJQIJZBUKCQIUKCDARTQEDARSUAUBUCULQBUDBUEUFUGUH $.
  $}

  ${
    $d s A $.  $d s E $.  $d s N $.  $d s W $.
    resslem.r $e |- R = ( W |`s A ) $.
    resslem.e $e |- C = ( E ` W ) $.
    resslem.f $e |- E = Slot N $.
    resslem.n $e |- N e. NN $.
    resslem.b $e |- 1 < N $.
    $( Other elements of a structure restriction.  (Contributed by Mario
       Carneiro, 26-Nov-2014.)  (Revised by Mario Carneiro, 2-Dec-2014.) $)
    resslem $p |- ( A e. V -> C = ( E ` R ) ) $=
      ( wcel cfv cvv cbs w3a fveq2d c1 c0 wceq wss wa wi eqid ressid2 3expib wn
      cnx cin cop csts co ressval2 ndxid ndxarg gtneii eqnetri basendx neeqtrri
      setsnid syl6eqr pm2.61i cress reldmress ovprc1 syl5eq fvprc eqtr4d adantr
      1re str0 pm2.61ian syl6reqr ) AFMZCDNZGDNZBGOMZVOVPVQUAZGPNZAUBZVRVOUCVSU
      DWAVRVOVSWAVRVOQCGDAVTCGOFHVTUEZUFRUGWAUHZVRVOVSWCVRVOQZVPGUIPNZAVTUJZUKU
      LUMZDNVQWDCWGDAVTCGOFHWBUNRWFWEDGDEJKUOUIDNZSWEWHESDEJKUPSEVKLUQURUSUTVAV
      BUGVCVRUHZVSVOWIVPTVQWIVPTDNTWICTDWICGAVDUMTHGAVDVEVFVGRDEJVLVBGDVHVIVJVM
      IVN $.
  $}

  $( All restrictions of the null set are trivial.  (Contributed by Stefan
     O'Rear, 29-Nov-2014.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
  ress0 $p |- ( (/) |`s A ) = (/) $=
    ( cvv wcel c0 cress co wceq wss 0ss 0ex eqid base0 ressid2 reldmress ovprc2
    mp3an12 pm2.61i ) ABCZDAEFZDGZDAHDBCRTAIJADSDBBSKLMPDAENOQ $.

  ${
    ressid.1 $e |- B = ( Base ` W ) $.
    $( Behavior of trivial restriction.  (Contributed by Stefan O'Rear,
       29-Nov-2014.) $)
    ressid $p |- ( W e. X -> ( W |`s B ) = W ) $=
      ( wss wcel cvv cress wceq ssid cbs cfv fvex eqeltri eqid ressid2 mp3an13
      co ) AAEBCFAGFBAHRZBIAJABKLGDBKMNAASBCGSODPQ $.

    $( Restriction only cares about the part of the second set which intersects
       the base of the first.  (Contributed by Stefan O'Rear, 29-Nov-2014.) $)
    ressinbas $p |- ( A e. X -> ( W |`s A ) = ( W |`s ( A i^i B ) ) ) $=
      ( wcel cvv cress co cin wceq elex wss w3a eqid ressid2 syl3an eqtr4d csts
      wn wa ssid incom df-ss biimpi syl5eq syl5sseqr inex1g 3expb cnx cbs inass
      cfv cop inidm ineq2i eqtr2i opeq2i oveq2i ressval2 inss1 sstr mpan2 con3i
      3eqtr4a pm2.61ian c0 reldmress ovprc1 adantr syl ) ADFAGFZCAHIZCABJZHIZKZ
      ADLCGFZVLVPBAMZVQVLUAVPVRVQVLVPVRVQVLNVMCVOABVMCGGVMOZEPVRBVNMZVQVQVLVNGF
      ZVOCKVRBBVNBUBVRVNBAJZBABUCVRWBBKBAUDUEUFUGCGLZABGUHZVNBVOCGGVOOZEPQRUIVR
      TZVQVLVPWFVQVLNCUJUKUMZVNUNZSICWGVNBJZUNZSIZVMVOWHWJCSVNWIWGWIABBJZJVNABB
      ULWLBABUOUPUQURUSABVMCGGVSEUTWFVTTVQVQVLWAVOWKKVTVRVTVNAMVRABVABVNAVBVCVD
      WCWDVNBVOCGGWEEUTQVEUIVFVQTZVPVLWMVMVGVOCAHVHVICVNHVHVIRVJVFVK $.
  $}

  $( Restriction composition law.  (Contributed by Stefan O'Rear,
     29-Nov-2014.)  (Proof shortened by Mario Carneiro, 2-Dec-2014.) $)
  ressress $p |- ( ( A e. X /\ B e. Y ) ->
    ( ( W |`s A ) |`s B ) = ( W |`s ( A i^i B ) ) ) $=
    ( cvv wcel wa cress co cin wceq cbs cfv wss wn cop csts eqid syl wi w3a cnx
    simplr simpr1 simpr2 syl3anc inass in12 eqtri ressbas ineq2d syl5req opeq2d
    ressval2 oveq12d fvex inex2 setsabs eqtrd simpll ovex a1i simpr3 inss1 sstr
    sylancl mpan2 nsyl inex1g 3eqtr4d exp31 ressid2 mp3an2 3ad2antr3 in32 simpl
    eqsstrd df-ss sylib oveq2d ressinbas 3syl ex 3adant3r3 oveq1d inss2 sseqin2
    syl5ss pm2.61ii 3expib c0 ress0 reldmress ovprc1 3eqtr4a a1d pm2.61i ) CFGZ
    ADGZBEGZHZCAIJZBIJZCABKZIJZLZUAWSWTXAXGXCMNZBOZCMNZAOZWSWTXAUBZXGUAXIPZXKPZ
    XLXGXMXNHZXLHZXCUCMNZBXHKZQZRJZCXQXEXJKZQZRJZXDXFXPXTCXQAXJKZQRJZYBRJZYCXPX
    CYEXSYBRXPXNWSWTXCYELXMXNXLUDZXOWSWTXAUEZXOWSWTXAUFZAXJXCCFDXCSZXJSZUOUGXPX
    RYAXQXPYABYDKZXRYAABXJKZKZYLABXJUHZABXJUIUJXPYDXHBXPWTYDXHLZYIAXJXCDCYJYKUK
    ZTULUMUNUPXPWSYAFGYFYCLYHXJXECMUQURXQYDYACFFUSVGUTXPXMXCFGZXAXDXTLXMXNXLVAY
    RXPCAIVBZVCXOWSWTXAVDBXHXDXCFEXDSZXHSZUOUGXPXJXEOZPWSXEFGZXFYCLXPXKUUBYGUUB
    XEAOXKABVEXJXEAVFVHVIYHXPWTUUCYIABDVJZTXEXJXFCFFXFSYKUOUGVKVLXIXLXGXIXLHZXD
    XCXFXIWSXAXDXCLZWTXIYRXAUUFYSBXHXDXCFEYTUUAVMVNVOUUECYDIJZCYAIJZXCXFUUEYDYA
    CIUUEYAYDBKZYDABXJVPUUEYDBOUUIYDLUUEYDXHBUUEWTYPXIWSWTXAUFZYQTXIXLVQVRYDBVS
    VTUMWAUUEWTXCUUGLUUJAXJCDYKWBTUUEWTUUCXFUUHLZUUJUUDXEXJCFYKWBZWCVKUTWDXKXLX
    GXKXLHZXDCBIJZXFUUMXCCBIXKWSWTXCCLXAAXJXCCFDYJYKVMWEWFUUMCYMIJZUUHUUNXFUUMY
    MYACIUUMYAYNYMYOUUMYMAOYNYMLUUMYMXJABXJWGXKXLVQWIYMAWHVTUMWAUUMXAUUNUUOLXKW
    SWTXAVDBXJCEYKWBTUUMWTUUCUUKXKWSWTXAUFUUDUULWCVKUTWDWJWKWSPZXGXBUUPWLBIJWLX
    DXFBWMUUPXCWLBICAIWNWOWFCXEIWNWOWPWQWR $.

  $( Restriction absorption law.  (Contributed by Mario Carneiro,
     12-Jun-2015.) $)
  ressabs $p |- ( ( A e. X /\ B C_ A ) ->
    ( ( W |`s A ) |`s B ) = ( W |`s B ) ) $=
    ( wcel wss wa cress co cin cvv wceq ssexg ancoms ressress simpr dfss1 sylib
    syldan oveq2d eqtrd ) ADEZBAFZGZCAHIBHIZCABJZHIZCBHIUBUCBKEZUEUGLUCUBUHBADM
    NABCDKOSUDUFBCHUDUCUFBLUBUCPBAQRTUA $.

  ${
    wunress.1 $e |- ( ph -> U e. WUni ) $.
    wunress.2 $e |- ( ph -> om e. U ) $.
    wunress.3 $e |- ( ph -> W e. U ) $.
    $( Closure of structure restriction in a weak universe.  (Contributed by
       Mario Carneiro, 12-Jan-2017.) $)
    wunress $p |- ( ph -> ( W |`s A ) e. U ) $=
      ( cvv wcel cress co cbs cfv cnx cin eqid c1 df-base wunstr c0 wa wss csts
      cop cif wceq ressval sylan wunndx incom wunin syl5eqel wunop wunsets ifcl
      syl2anc adantr eqeltrd ex wun0 reldmress ovprc2 eleq1d syl5ibrcom pm2.61d
      wn ) ABHIZDBJKZCIZAVGVIAVGUAVHDLMZBUBZDDNLMZBVJOZUDZUCKZUEZCADCIZVGVHVPUF
      GBVJVHDCHVHPVJPUGUHAVPCIZVGAVQVOCIVRGAVNDCEGAVLVMCEANCLQREACEFUISAVMVJBOC
      BVJUJAVJBCEADCLQREGSUKULUMUNVKDVOCUOUPUQURUSAVIVGVFZTCIACEUTVSVHTCDBJVAVB
      VCVDVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Slot definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c +g $.
  $c .r $.
  $c *r $.
  $c Scalar $.
  $c .s $.
  $c .i $.
  $c TopSet $.
  $c le $.
  $c oc $.
  $c dist $.
  $c UnifSet $.
  $c Hom $.
  $c comp $.

  $( Extend class notation with group (addition) operation. $)
  cplusg $a class +g $.

  $( Extend class notation with ring multiplication. $)
  cmulr $a class .r $.

  $( Extend class notation with involution. $)
  cstv $a class *r $.

  $( Extend class notation with scalar field. $)
  csca $a class Scalar $.

  $( Extend class notation with scalar product. $)
  cvsca $a class .s $.

  $( Extend class notation with Hermitian form (inner product). $)
  cip $a class .i $.

  $( Extend class notation with the topology component of a topological
     space. $)
  cts $a class TopSet $.

  $( Extend class notation with less-than-or-equal for posets. $)
  cple $a class le $.

  $( Extend class notation with the class of orthocomplementation
     extractors. $)
  coc $a class oc $.

  $( Extend class notation with the metric space distance function. $)
  cds $a class dist $.

  $( Extend class notation with the uniform structure. $)
  cunif $a class UnifSet $.

  $( Extend class notation with the hom-set structure. $)
  chom $a class Hom $.

  $( Extend class notation with the composition operation. $)
  cco $a class comp $.

  $( Define group operation.  (Contributed by NM, 4-Sep-2011.)  (Revised by
     Mario Carneiro, 14-Aug-2015.) $)
  df-plusg $a |- +g = Slot 2 $.

  $( Define ring multiplication.  (Contributed by NM, 4-Sep-2011.)  (Revised by
     Mario Carneiro, 14-Aug-2015.) $)
  df-mulr $a |- .r = Slot 3 $.

  $( Define the involution function of a *-ring.  (Contributed by NM,
     4-Sep-2011.)  (Revised by Mario Carneiro, 14-Aug-2015.) $)
  df-starv $a |- *r = Slot 4 $.

  $( Define scalar field component of a vector space ` v ` .  (Contributed by
     NM, 4-Sep-2011.)  (Revised by Mario Carneiro, 14-Aug-2015.) $)
  df-sca $a |- Scalar = Slot 5 $.

  $( Define scalar product.  (Contributed by NM, 4-Sep-2011.)  (Revised by
     Mario Carneiro, 14-Aug-2015.) $)
  df-vsca $a |- .s = Slot 6 $.

  $( Define Hermitian form (inner product).  (Contributed by NM, 4-Sep-2011.)
     (Revised by Mario Carneiro, 14-Aug-2015.) $)
  df-ip $a |- .i = Slot 8 $.

  $( Define the topology component of a topological space (structure).
     (Contributed by NM, 4-Sep-2011.)  (Revised by Mario Carneiro,
     14-Aug-2015.) $)
  df-tset $a |- TopSet = Slot 9 $.

  $( Define less-than-or-equal ordering extractor for posets and related
     structures.  We use ` 10 ` for the index to avoid conflict with ` 1 `
     through ` 9 ` used for other purposes.  (Contributed by NM, 4-Sep-2011.)
     (Revised by Mario Carneiro, 14-Aug-2015.) $)
  df-ple $a |- le = Slot 10 $.

  $( Define the orthocomplementation extractor for posets and related
     structures.  (Contributed by NM, 4-Sep-2011.)  (Revised by Mario Carneiro,
     14-Aug-2015.) $)
  df-ocomp $a |- oc = Slot ; 1 1 $.

  $( Define the distance function component of a metric space (structure).
     (Contributed by NM, 4-Sep-2011.)  (Revised by Mario Carneiro,
     14-Aug-2015.) $)
  df-ds $a |- dist = Slot ; 1 2 $.

  $( Define the uniform structure component of a uniform space.  (Contributed
     by Mario Carneiro, 14-Aug-2015.) $)
  df-unif $a |- UnifSet = Slot ; 1 3 $.

  $( Define the hom-set component of a category.  (Contributed by Mario
     Carneiro, 2-Jan-2017.) $)
  df-hom $a |- Hom = Slot ; 1 4 $.

  $( Define the composition operation of a category.  (Contributed by Mario
     Carneiro, 2-Jan-2017.) $)
  df-cco $a |- comp = Slot ; 1 5 $.

  $( Structure definition utility lemma.  To prove that an explicit function is
     a function using O(n) steps, exploit the order properties of the index
     set.  Zero-pair case.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
  strlemor0 $p |- ( Fun `' `' (/) /\ dom (/) C_ ( 1 ... 0 ) ) $=
    ( c0 ccnv wfun cdm c1 cc0 cfz co wss funcnvcnv ax-mp dm0 0ss eqsstri pm3.2i
    fun0 ) ABBCZADZEFGHZIACQPAJKRASLSMNO $.

  ${
    strlemor.f $e |- ( Fun `' `' F /\ dom F C_ ( 1 ... I ) ) $.
    strlemor.i $e |- I e. NN0 $.
    strlemor.o $e |- I < J $.
    strlemor.j $e |- J e. NN $.
    strlemor.a $e |- A = J $.
    ${
      strlemor1.g $e |- G = ( F u. { <. A , X >. } ) $.
      $( Add one element to the end of a structure.  (Contributed by Stefan
         O'Rear, 3-Jan-2015.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
      strlemor1 $p |- ( Fun `' `' G /\ dom G C_ ( 1 ... J ) ) $=
        ( ccnv wfun cdm c1 wss cun wcel eqtri cfz co cop csn wa cin wceq simpli
        c0 funcnvsn pm3.2i cnvcnvss dmss ax-mp cnvcnvsn eqsstr3i dmsnopss sstri
        ss2in mp2an wn cle wbr clt nn0rei nnrei ltnlei elfzle2 mto simpri sseli
        mpbi disjsn mpbir sseq0 funun opeq1i sneqi uneq2i cnveqi cnvun dmun cuz
        funeqi dmeqi cfv cz nn0zi ltleii eluz2 mpbir3an fzss2 cn elfz1end snssi
        nnzi unssi eqsstri ) CMZMZNZCOZPEUAUBZQXABMZMZFEUCUDMZRZNZXENZXFNZUEXEO
        ZXFOZUFZUIUGZXHXIXJXIBOZPDUAUBZQZGUHFEUJUKXMXOEUDZUFZQZXSUIUGZXNXKXOQZX
        LXRQXTXEBQYBBULXEBUMUNXLEFUCZUDZOZXRXFYDQXLYEQXFYDMZMZYDEFUOZYDULUPXFYD
        UMUNEFUQZURXKXOXLXRUSUTYAEXOSZVAYJEXPSZYKEDVBVCZDEVDVCYLVAIDEDHVEZEJVFZ
        VGVLEPDVHVIXOXPEXIXQGVJZVKVIXOEVMVNXMXSVOUTXEXFVPUTWTXGWTXDYFRZMZXGWSYP
        WSBYDRZMYPCYRCBAFUCZUDZRYRLYTYDBYSYCAEFKVQVRVSTZVTBYDWATVTYQXEYGRXGXDYF
        WAYGXFXEYHVSTTWDVNXBXOYERZXCXBYROUUBCYRUUAWEBYDWBTXOYEXCXOXPXCYOEDWCWFS
        ZXPXCQUUCDWGSEWGSDEVBVCDHWHEJWPDEYMYNIWIDEWJWKDPEWLUNURYEXRXCYIEXCSZXRX
        CQEWMSUUDJEWNVLEXCWOUNURWQWRUK $.
    $}

    strlemor2.o $e |- J < K $.
    strlemor2.k $e |- K e. NN $.
    strlemor2.b $e |- B = K $.
    ${
      strlemor2.g $e |- G = ( F u. { <. A , X >. , <. B , Y >. } ) $.
      $( Add two elements to the end of a structure.  (Contributed by Stefan
         O'Rear, 3-Jan-2015.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
      strlemor2 $p |- ( Fun `' `' G /\ dom G C_ ( 1 ... K ) ) $=
        ( cop cun csn eqid strlemor1 nnnn0i cpr df-pr uneq2i unass 3eqtr4i ) BC
        AHSZUAZTZDFGIACULEFHJKLMNULUBUCFMUDOPQCUJBISZUEZTCUKUMUAZTZTDULUOTUNUPC
        UJUMUFUGRCUKUOUHUIUC $.
    $}

    strlemor3.o $e |- K < L $.
    strlemor3.l $e |- L e. NN $.
    strlemor3.c $e |- C = L $.
    ${
      strlemor3.g $e |- G = ( F u. { <. A , X >. , <. B , Y >. ,
          <. C , Z >. } ) $.
      $( Add three elements to the end of a structure.  (Contributed by Stefan
         O'Rear, 3-Jan-2015.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
      strlemor3 $p |- ( Fun `' `' G /\ dom G C_ ( 1 ... L ) ) $=
        ( cop cpr cun strlemor2 nnnn0i ctp df-tp uneq2i unass 3eqtr4i strlemor1
        eqid csn ) CDAJUEZBKUEZUFZUGZEHILABDVAFGHJKMNOPQRSTVAUPUHHSUIUAUBUCDURU
        SCLUEZUJZUGDUTVBUQZUGZUGEVAVDUGVCVEDURUSVBUKULUDDUTVDUMUNUO $.
    $}
  $}

  ${
    strleun.f $e |- F Struct <. A , B >. $.
    strleun.g $e |- G Struct <. C , D >. $.
    strleun.l $e |- B < C $.
    $( Combine two structures into one.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    strleun $p |- ( F u. G ) Struct <. A , D >. $=
      ( wbr cn wcel cle w3a wfun cdm wss simp1i mp2an ax-mp cun cop cstr c0 csn
      cdif cfz co isstruct mpbi simp2i simp3i nnrei ltleii letri 3pm3.2i wa cin
      wceq pm3.2i difss dmss sstri ss2in clt fzdisj sseq0 funun difundir funeqi
      mpbir dmun cuz cfv cz nnzi eluz2 mpbir3an fzss2 fzss1 unssi eqsstri ) EFU
      AZADUBUCJAKLZDKLZADMJZNWCUDUEZUFZOZWCPZADUGUHZQWDWEWFWDBKLZABMJZWDWLWMNZE
      WGUFZOZEPZABUGUHZQZEABUBUCJWNWPWSNGEABUIUJZRZRZCKLZWECDMJZXCWEXDNZFWGUFZO
      ZFPZCDUGUHZQZFCDUBUCJXEXGXJNHFCDUIUJZRZUKZACMJZXDWFWMBCMJZXNWDWLWMXAULBCB
      WDWLWMXAUKZUMZCXCWEXDXLRZUMZIUNZABCAXBUMZXQXSUOSZXCWEXDXLULZACDYAXSDXMUMZ
      UOSUPWIWOXFUAZOZWPXGUQWOPZXFPZURZUDUSZYFWPXGWNWPWSWTUKXEXGXJXKUKUTYIWRXIU
      RZQZYKUDUSZYJYGWRQYHXIQYLYGWQWRWOEQYGWQQEWGVAWOEVBTWNWPWSWTULZVCYHXHXIXFF
      QYHXHQFWGVAXFFVBTXEXGXJXKULZVCYGWRYHXIVDSBCVEJYMIABCDVFTYIYKVGSWOXFVHSWHY
      EEFWGVIVJVKWJWQXHUAWKEFVLWQXHWKWQWRWKYNDBVMVNLZWRWKQYPBVOLDVOLBDMJZBXPVPD
      XMVPXOXDYQXTYCBCDXQXSYDUOSBDVQVRBADVSTVCXHXIWKYOCAVMVNLZXIWKQYRAVOLCVOLXN
      AXBVPCXRVPYBACVQVRCADVTTVCWAWBWCADUIVR $.
  $}

  ${
    strle1.i $e |- I e. NN $.
    strle1.a $e |- A = I $.
    $( Make a structure from a singleton.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    strle1 $p |- { <. A , X >. } Struct <. I , I >. $=
      ( cop csn cstr wbr cn wcel cle w3a c0 cdif wfun cdm cfz wss cvv co funsng
      nnrei leidi 3pm3.2i difss eqeltri mpan funss mpsyl wn fun0 opprc2 difeq1d
      sneqd difid syl6eq funeqd mpbiri pm2.61i dmsnopss sneqi cz wceq nnzi fzsn
      ax-mp eqtr4i sseqtri isstruct mpbir3an ) ACFZGZBBFHIBJKZVNBBLIZMVMNGZOZPZ
      VMQZBBRUAZSVNVNVODDBBDUCUDUECTKZVRVQVMSWAVMPZVRVMVPUFAJKWAWBABJEDUGACJTUB
      UHVQVMUIUJWAUKZVRNPULWCVQNWCVQVPVPONWCVMVPVPWCVLNACUMUOUNVPUPUQURUSUTVSAG
      ZVTACVAWDBGZVTABEVBBVCKVTWEVDBDVEBVFVGVHVIVMBBVJVK $.

    strle2.j $e |- I < J $.
    strle2.k $e |- J e. NN $.
    strle2.b $e |- B = J $.
    $( Make a structure from a pair.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    strle2 $p |- { <. A , X >. , <. B , Y >. } Struct <. I , J >. $=
      ( cop cpr csn cun cstr df-pr strle1 strleun eqbrtri ) AELZBFLZMUANZUBNZOC
      DLPUAUBQCCDDUCUDACEGHRBDFJKRIST $.

    strle3.k $e |- J < K $.
    strle3.l $e |- K e. NN $.
    strle3.c $e |- C = K $.
    $( Make a structure from a triple.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    strle3 $p |- { <. A , X >. , <. B , Y >. , <. C , Z >. }
        Struct <. I , K >. $=
      ( cop ctp cpr csn cun cstr df-tp strle2 strle1 strleun eqbrtri ) AGRZBHRZ
      CIRZSUIUJTZUKUAZUBDFRUCUIUJUKUDDEFFULUMABDEGHJKLMNUECFIPQUFOUGUH $.
  $}

  $( Index value of the ~ df-plusg slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  plusgndx $p |- ( +g ` ndx ) = 2 $=
    ( cplusg c2 df-plusg 2nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of ~ df-plusg .  (Contributed by
     NM, 20-Oct-2012.) $)
  plusgid $p |- +g = Slot ( +g ` ndx ) $=
    ( cplusg c2 df-plusg 2nn ndxid ) ABCDE $.

  ${
    2str.g $e |- G = { <. ( Base ` ndx ) , B >. , <. ( E ` ndx ) , .+ >. } $.
    2str.e $e |- E = Slot N $.
    2str.l $e |- 1 < N $.
    2str.n $e |- N e. NN $.
    $( A constructed two-slot structure.  (Contributed by Mario Carneiro,
       29-Aug-2015.) $)
    2strstr $p |- G Struct <. 1 , N >. $=
      ( cnx cbs cfv cop cpr c1 cstr 1nn basendx ndxarg strle2 eqbrtri ) DJKLZAM
      JCLZBMNOEMPFUBUCOEABQRHICEGISTUA $.

    $( The base set of a constructed two-slot structure.  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    2strbas $p |- ( B e. V -> B = ( Base ` G ) ) $=
      ( cbs c1 cop 2strstr baseid cnx cfv csn cpr snsspr1 sseqtr4i strfv ) ADKF
      LEMABCDEGHIJNOPKQAMZRUCPCQBMZSDUCUDTGUAUB $.

    $( The other slot of a constructed two-slot structure.  (Contributed by
       Mario Carneiro, 29-Aug-2015.) $)
    2strop $p |- ( .+ e. V -> .+ = ( E ` G ) ) $=
      ( c1 cop 2strstr ndxid cnx cfv csn cbs cpr snsspr2 sseqtr4i strfv ) BDCFK
      ELABCDEGHIJMCEHJNOCPBLZQORPALZUCSDUDUCTGUAUB $.
  $}

  ${
    grpfn.g $e |- G = { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. } $.
    $( A constructed group is a structure on ` 1 ... 2 ` .  (Contributed by
       Mario Carneiro, 28-Sep-2013.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    grpstr $p |- G Struct <. 1 , 2 >. $=
      ( cplusg c2 df-plusg 1lt2 2nn 2strstr ) ABECFDGHIJ $.

    $( The base set of a constructed group.  (Contributed by Mario Carneiro,
       2-Aug-2013.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    grpbase $p |- ( B e. V -> B = ( Base ` G ) ) $=
      ( cplusg c2 df-plusg 1lt2 2nn 2strbas ) ABFCGDEHIJK $.

    $( The operation of a constructed group.  (Contributed by Mario Carneiro,
       2-Aug-2013.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    grpplusg $p |- ( .+ e. V -> .+ = ( +g ` G ) ) $=
      ( cplusg c2 df-plusg 1lt2 2nn 2strop ) ABFCGDEHIJK $.
  $}

  ${
    ressplusg.1 $e |- H = ( G |`s A ) $.
    ressplusg.2 $e |- .+ = ( +g ` G ) $.
    $( ` +g ` is unaffected by restriction.  (Contributed by Stefan O'Rear,
       27-Nov-2014.) $)
    ressplusg $p |- ( A e. V -> .+ = ( +g ` H ) ) $=
      ( cplusg c2 df-plusg 2nn 1lt2 resslem ) ABDHIECFGJKLM $.
  $}

  ${
    grpstrx.b $e |- B e. _V $.
    grpstrx.p $e |- .+ e. _V $.
    grpstrx.g $e |- G = { <. 1 , B >. , <. 2 , .+ >. } $.
    $( The base of an explicitly given group.  Note:  This theorem has
       hard-coded structure indices for demonstration purposes.  It is not
       intended for general use; use ~ grpbase instead.
       (New usage is discouraged.)  (Contributed by NM, 17-Oct-2012.) $)
    grpbasex $p |- B = ( Base ` G ) $=
      ( cvv wcel cbs cfv wceq c1 cop c2 cpr cnx cplusg basendx opeq1i plusgndx
      preq12i eqtr4i grpbase ax-mp ) AGHACIJKDABCGCLAMZNBMZOPIJZAMZPQJZBMZOFUHU
      EUJUFUGLARSUINBTSUAUBUCUD $.

    $( The operation of an explicitly given group.  Note:  This theorem has
       hard-coded structure indices for demonstration purposes.  It is not
       intended for general use; use ~ grpplusgx instead.
       (New usage is discouraged.)  (Contributed by NM, 17-Oct-2012.) $)
    grpplusgx $p |- .+ = ( +g ` G ) $=
      ( cvv wcel cplusg cfv wceq c1 cop c2 cpr cnx cbs basendx opeq1i plusgndx
      preq12i eqtr4i grpplusg ax-mp ) BGHBCIJKEABCGCLAMZNBMZOPQJZAMZPIJZBMZOFUH
      UEUJUFUGLARSUINBTSUAUBUCUD $.
  $}

  $( Index value of the ~ df-mulr slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  mulrndx $p |- ( .r ` ndx ) = 3 $=
    ( cmulr c3 df-mulr 3nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of ~ df-mulr .  (Contributed by
     Mario Carneiro, 8-Jun-2013.) $)
  mulrid $p |- .r = Slot ( .r ` ndx ) $=
    ( cmulr c3 df-mulr 3nn ndxid ) ABCDE $.

  ${
    rngfn.r $e |- R
               = { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. ,
                   <. ( .r ` ndx ) , .x. >. } $.
    $( A constructed ring is a structure.  (Contributed by Mario Carneiro,
       28-Sep-2013.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    rngstr $p |- R Struct <. 1 , 3 >. $=
      ( cnx cbs cfv cop cplusg cmulr ctp c1 c3 cstr c2 1nn basendx 1lt2 2nn 3nn
      plusgndx 2lt3 mulrndx strle3 eqbrtri ) CFGHZAIFJHZBIFKHZDILMNIOEUGUHUIMPN
      ABDQRSTUBUCUAUDUEUF $.

    $( The base set of a constructed ring.  (Contributed by Mario Carneiro,
       2-Oct-2013.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    rngbase $p |- ( B e. V -> B = ( Base ` R ) ) $=
      ( cbs c1 cop rngstr baseid cnx cfv csn cplusg cmulr ctp snsstp1 sseqtr4i
      c3 strfv ) ACGEHTIABCDFJKLGMAIZNUBLOMBIZLPMDIZQCUBUCUDRFSUA $.

    $( The additive operation of a constructed ring.  (Contributed by Mario
       Carneiro, 2-Oct-2013.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    rngplusg $p |- ( .+ e. V -> .+ = ( +g ` R ) ) $=
      ( cplusg c1 cop rngstr plusgid cnx cfv csn cbs cmulr ctp snsstp2 sseqtr4i
      c3 strfv ) BCGEHTIABCDFJKLGMBIZNLOMAIZUBLPMDIZQCUCUBUDRFSUA $.

    $( The muliplicative operation of a constructed ring.  (Contributed by
       Mario Carneiro, 2-Oct-2013.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    rngmulr $p |- ( .x. e. V -> .x. = ( .r ` R ) ) $=
      ( cmulr c1 cop rngstr mulrid cnx cfv csn cbs cplusg ctp snsstp3 sseqtr4i
      c3 strfv ) DCGEHTIABCDFJKLGMDIZNLOMAIZLPMBIZUBQCUCUDUBRFSUA $.
  $}

  $( Index value of the ~ df-starv slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  starvndx $p |- ( *r ` ndx ) = 4 $=
    ( cstv c4 df-starv 4nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of ~ df-starv .  (Contributed by
     Mario Carneiro, 6-Oct-2013.) $)
  starvid $p |- *r = Slot ( *r ` ndx ) $=
    ( cstv c4 df-starv 4nn ndxid ) ABCDE $.

  ${
    ressmulr.1 $e |- S = ( R |`s A ) $.
    ${
      ressmulr.2 $e |- .x. = ( .r ` R ) $.
      $( ` .r ` is unaffected by restriction.  (Contributed by Stefan O'Rear,
         27-Nov-2014.) $)
      ressmulr $p |- ( A e. V -> .x. = ( .r ` S ) ) $=
        ( cmulr c3 df-mulr 3nn 1lt3 resslem ) ADCHIEBFGJKLM $.
    $}

    ${
      ressstarv.2 $e |- .* = ( *r ` R ) $.
      $( ` *r ` is unaffected by restriction.  (Contributed by Mario Carneiro,
         9-Oct-2015.) $)
      ressstarv $p |- ( A e. V -> .* = ( *r ` S ) ) $=
        ( cstv c4 df-starv 4nn 1lt4 resslem ) ADCHIEBFGJKLM $.
    $}
  $}

  ${
    srngfn.r $e |- R = ( { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. ,
         <. ( .r ` ndx ) , .x. >. } u. { <. ( *r ` ndx ) , .* >. } ) $.
    $( A constructed star ring is a function with domain contained in ` 1 `
       thru ` 4 ` .  (Contributed by Mario Carneiro, 18-Nov-2013.)  (Revised by
       Mario Carneiro, 14-Aug-2015.) $)
    srngfn $p |- R Struct <. 1 , 4 >. $=
      ( cnx cbs cfv cop cplusg cmulr ctp cstv csn cun c1 c4 cstr c3 eqid rngstr
      4nn starvndx strle1 3lt4 strleun eqbrtri ) CGHIAJGKIBJGLIDJMZGNIZEJOZPQRJ
      SFQTRRUIUKABUIDUIUAUBUJREUCUDUEUFUGUH $.

    $( The base set of a constructed star ring.  (Contributed by Mario
       Carneiro, 18-Nov-2013.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    srngbase $p |- ( B e. X -> B = ( Base ` R ) ) $=
      ( cbs c1 c4 cop srngfn baseid cnx cfv csn cplusg cmulr ctp snsstp1 ssun1
      cstv cun sseqtr4i sstri strfv ) ACHFIJKABCDEGLMNHOAKZPUGNQOBKZNRODKZSZCUG
      UHUITUJUJNUBOEKPZUCCUJUKUAGUDUEUF $.

    $( The addition operation of a constructed star ring.  (Contributed by
       Mario Carneiro, 20-Jun-2015.) $)
    srngplusg $p |- ( .+ e. X -> .+ = ( +g ` R ) ) $=
      ( cplusg c1 c4 cop srngfn plusgid cnx cfv csn cbs cmulr ctp snsstp2 ssun1
      cstv cun sseqtr4i sstri strfv ) BCHFIJKABCDEGLMNHOBKZPNQOAKZUGNRODKZSZCUH
      UGUITUJUJNUBOEKPZUCCUJUKUAGUDUEUF $.

    $( The multiplication operation of a constructed star ring.  (Contributed
       by Mario Carneiro, 20-Jun-2015.) $)
    srngmulr $p |- ( .x. e. X -> .x. = ( .r ` R ) ) $=
      ( cmulr c1 c4 cop srngfn mulrid cnx cfv csn cbs cplusg ctp snsstp3 ssun1
      cstv cun sseqtr4i sstri strfv ) DCHFIJKABCDEGLMNHODKZPNQOAKZNROBKZUGSZCUH
      UIUGTUJUJNUBOEKPZUCCUJUKUAGUDUEUF $.

    $( The involution function of a constructed star ring.  (Contributed by
       Mario Carneiro, 20-Jun-2015.) $)
    srnginvl $p |- ( .* e. X -> .* = ( *r ` R ) ) $=
      ( cstv c1 c4 cop srngfn starvid cnx cfv csn cbs cplusg cmulr ctp sseqtr4i
      cun ssun2 strfv ) ECHFIJKABCDEGLMNHOEKPZNQOAKNROBKNSODKTZUEUBCUEUFUCGUAUD
      $.
  $}

  $( Index value of the ~ df-sca slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  scandx $p |- ( Scalar ` ndx ) = 5 $=
    ( csca c5 df-sca 5nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of scalar ~ df-sca .  (Contributed
     by Mario Carneiro, 19-Jun-2014.) $)
  scaid $p |- Scalar = Slot ( Scalar ` ndx ) $=
    ( csca c5 df-sca 5nn ndxid ) ABCDE $.

  $( Index value of the ~ df-vsca slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  vscandx $p |- ( .s ` ndx ) = 6 $=
    ( cvsca c6 df-vsca 6nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of scalar product ~ df-vsca .
     (Contributed by Mario Carneiro, 2-Oct-2013.)  (Revised by Mario Carneiro,
     19-Jun-2014.) $)
  vscaid $p |- .s = Slot ( .s ` ndx ) $=
    ( cvsca c6 df-vsca 6nn ndxid ) ABCDE $.

  ${
    lvecfn.w $e |- W = ( { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. ,
              <. ( Scalar ` ndx ) , F >. } u. { <. ( .s ` ndx ) , .x. >. } ) $.
    $( A constructed left module or left vector space is a function.
       (Contributed by Mario Carneiro, 1-Oct-2013.)  (Revised by Mario
       Carneiro, 29-Aug-2015.) $)
    lmodstr $p |- W Struct <. 1 , 6 >. $=
      ( cnx cbs cfv cop cplusg csca ctp cvsca csn cun c1 c6 cstr c5 1nn basendx
      c2 1lt2 2nn plusgndx 5nn scandx strle3 6nn vscandx strle1 strleun eqbrtri
      2lt5 5lt6 ) EGHIZAJGKIZBJGLIZDJMZGNIZCJOZPQRJSFQTRRUTVBUQURUSQUCTABDUAUBU
      DUEUFUOUGUHUIVARCUJUKULUPUMUN $.

    $( The base set of a constructed left vector space.  (Contributed by Mario
       Carneiro, 2-Oct-2013.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    lmodbase $p |- ( B e. X -> B = ( Base ` W ) ) $=
      ( cbs c1 c6 cop lmodstr baseid cnx cfv csn cplusg csca ctp snsstp1 cvsca
      cun ssun1 sseqtr4i sstri strfv ) AEHFIJKABCDEGLMNHOAKZPUGNQOBKZNRODKZSZEU
      GUHUITUJUJNUAOCKPZUBEUJUKUCGUDUEUF $.

    $( The additive operation of a constructed left vector space.  (Contributed
       by Mario Carneiro, 2-Oct-2013.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    lmodplusg $p |- ( .+ e. X -> .+ = ( +g ` W ) ) $=
      ( cplusg c1 c6 cop lmodstr plusgid cnx cfv csn cbs csca ctp snsstp2 cvsca
      cun ssun1 sseqtr4i sstri strfv ) BEHFIJKABCDEGLMNHOBKZPNQOAKZUGNRODKZSZEU
      HUGUITUJUJNUAOCKPZUBEUJUKUCGUDUEUF $.

    $( The set of scalars of a constructed left vector space.  (Contributed by
       Mario Carneiro, 2-Oct-2013.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    lmodsca $p |- ( F e. X -> F = ( Scalar ` W ) ) $=
      ( csca c1 c6 cop lmodstr scaid cnx cfv csn cbs cplusg ctp snsstp3 cvsca
      cun ssun1 sseqtr4i sstri strfv ) DEHFIJKABCDEGLMNHODKZPNQOAKZNROBKZUGSZEU
      HUIUGTUJUJNUAOCKPZUBEUJUKUCGUDUEUF $.

    $( The scalar product operation of a constructed left vector space.
       (Contributed by Mario Carneiro, 2-Oct-2013.)  (Revised by Mario
       Carneiro, 29-Aug-2015.) $)
    lmodvsca $p |- ( .x. e. X -> .x. = ( .s ` W ) ) $=
      ( cvsca c1 c6 cop lmodstr vscaid cnx cfv csn cbs cplusg csca ctp sseqtr4i
      cun ssun2 strfv ) CEHFIJKABCDEGLMNHOCKPZNQOAKNROBKNSODKTZUEUBEUEUFUCGUAUD
      $.
  $}

  ${
    algpart.a $e |- A = ( { <. ( Base ` ndx ) , B >. ,
       <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
     { <. ( Scalar ` ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) $.
    $( Lemma to shorten proofs of ~ algbase through ~ algvsca .  (Contributed
       by Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    algstr $p |- A Struct <. 1 , 6 >. $=
      ( cnx cbs cfv cop cplusg cmulr ctp csca cvsca cpr c1 c6 c5 cstr c3 rngstr
      cun eqid 5nn scandx 5lt6 6nn vscandx strle2 3lt5 strleun eqbrtri ) AHIJBK
      HLJCKHMJFKNZHOJZDKHPJZEKQZUDRSKUAGRUBTSUOURBCUOFUOUEUCUPUQTSDEUFUGUHUIUJU
      KULUMUN $.

    $( The base set of a constructed algebra.  (Contributed by Stefan O'Rear,
       27-Nov-2014.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    algbase $p |- ( B e. V -> B = ( Base ` A ) ) $=
      ( cbs c1 c6 cop algstr baseid cnx cfv csn cplusg cmulr ctp csca cvsca cpr
      snsstp1 cun ssun1 sseqtr4i sstri strfv ) BAIGJKLABCDEFHMNOIPBLZQUJORPCLZO
      SPFLZTZAUJUKULUDUMUMOUAPDLOUBPELUCZUEAUMUNUFHUGUHUI $.

    $( The additive operation of a constructed algebra.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    algaddg $p |- ( .+ e. V -> .+ = ( +g ` A ) ) $=
      ( cplusg c1 c6 cop algstr plusgid cnx cfv csn cbs cmulr ctp snsstp2 cvsca
      csca cpr cun ssun1 sseqtr4i sstri strfv ) CAIGJKLABCDEFHMNOIPCLZQORPBLZUJ
      OSPFLZTZAUKUJULUAUMUMOUCPDLOUBPELUDZUEAUMUNUFHUGUHUI $.

    $( The multiplicative operation of a constructed algebra.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    algmulr $p |- ( .X. e. V -> .X. = ( .r ` A ) ) $=
      ( cmulr c1 c6 cop algstr mulrid cnx cfv csn cbs cplusg ctp csca cvsca cpr
      snsstp3 cun ssun1 sseqtr4i sstri strfv ) FAIGJKLABCDEFHMNOIPFLZQORPBLZOSP
      CLZUJTZAUKULUJUDUMUMOUAPDLOUBPELUCZUEAUMUNUFHUGUHUI $.

    $( The set of scalars of a constructed algebra.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    algsca $p |- ( S e. V -> S = ( Scalar ` A ) ) $=
      ( csca c1 c6 cop algstr scaid cnx cfv csn cvsca cpr snsspr1 cbs cmulr ctp
      cplusg cun ssun2 sseqtr4i sstri strfv ) DAIGJKLABCDEFHMNOIPDLZQUJORPELZSZ
      AUJUKTULOUAPBLOUDPCLOUBPFLUCZULUEAULUMUFHUGUHUI $.

    $( The scalar product operation of a constructed algebra.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    algvsca $p |- ( .x. e. V -> .x. = ( .s ` A ) ) $=
      ( cvsca c1 c6 cop algstr vscaid cnx cfv csn csca cpr snsspr2 cplusg cmulr
      cbs ctp cun ssun2 sseqtr4i sstri strfv ) EAIGJKLABCDEFHMNOIPELZQORPDLZUJS
      ZAUKUJTULOUCPBLOUAPCLOUBPFLUDZULUEAULUMUFHUGUHUI $.
  $}

  ${
    resssca.1 $e |- H = ( G |`s A ) $.
    ${
      resssca.2 $e |- F = ( Scalar ` G ) $.
      $( ` Scalar ` is unaffected by restriction.  (Contributed by Mario
         Carneiro, 7-Dec-2014.) $)
      resssca $p |- ( A e. V -> F = ( Scalar ` H ) ) $=
        ( csca c5 df-sca 5nn 1lt5 resslem ) ABDHIECFGJKLM $.
    $}

    ressvsca.2 $e |- .x. = ( .s ` G ) $.
    $( ` .s ` is unaffected by restriction.  (Contributed by Mario Carneiro,
       7-Dec-2014.) $)
    ressvsca $p |- ( A e. V -> .x. = ( .s ` H ) ) $=
      ( cvsca c6 df-vsca 6nn 1lt6 resslem ) ABDHIECFGJKLM $.
  $}

  $( Index value of the ~ df-ip slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  ipndx $p |- ( .i ` ndx ) = 8 $=
    ( cip c8 df-ip 8nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of ~ df-ip .  (Contributed by
     Mario Carneiro, 6-Oct-2013.) $)
  ipid $p |- .i = Slot ( .i ` ndx ) $=
    ( cip c8 df-ip 8nn ndxid ) ABCDE $.

  ${
    phlfn.h $e |- H = ( { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. ,
               <. ( Scalar ` ndx ) , T >. }
            u. { <. ( .s ` ndx ) , .x. >. , <. ( .i ` ndx ) , ., >. } ) $.
    $( A constructed pre-Hilbert space is a structure.  Starting from ~ lmodstr
       (which has 4 members), we chain ~ strleun once more, adding an ordered
       pair to the function, to get all 5 members.  (Contributed by Mario
       Carneiro, 1-Oct-2013.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    phlstr $p |- H Struct <. 1 , 8 >. $=
      ( cnx cbs cfv cop cplusg csca ctp cvsca csn cun cip c1 c8 cstr cpr uneq2i
      df-pr unass 3eqtr4i c6 eqid lmodstr 8nn ipndx strle1 6lt8 strleun eqbrtri
      ) EHIJAKHLJBKHMJCKNZHOJDKZPZQZHRJZFKZPZQZSTKUAUPUQVAUBZQUPURVBQZQEVCVDVEU
      PUQVAUDUCGUPURVBUEUFSUGTTUSVBABDCUSUSUHUIUTTFUJUKULUMUNUO $.

    $( The base set of a constructed pre-Hilbert space.  (Contributed by Mario
       Carneiro, 6-Oct-2013.)  (Revised by Mario Carneiro, 29-Aug-2015.) $)
    phlbase $p |- ( B e. X -> B = ( Base ` H ) ) $=
      ( cbs c1 c8 cop phlstr baseid cnx cfv csn cplusg csca ctp snsstp1 cip cpr
      cvsca cun ssun1 sseqtr4i sstri strfv ) AEIGJKLABCDEFHMNOIPALZQUJORPBLZOSP
      CLZTZEUJUKULUAUMUMOUDPDLOUBPFLUCZUEEUMUNUFHUGUHUI $.

    $( The additive operation of a constructed pre-Hilbert space.  (Contributed
       by Mario Carneiro, 6-Oct-2013.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    phlplusg $p |- ( .+ e. X -> .+ = ( +g ` H ) ) $=
      ( cplusg c1 c8 cop phlstr plusgid cnx cfv csn cbs csca ctp cvsca sseqtr4i
      snsstp2 cip cpr cun ssun1 sstri strfv ) BEIGJKLABCDEFHMNOIPBLZQORPALZUJOS
      PCLZTZEUKUJULUCUMUMOUAPDLOUDPFLUEZUFEUMUNUGHUBUHUI $.

    $( The ring of scalars of a constructed pre-Hilbert space.  (Contributed by
       Mario Carneiro, 6-Oct-2013.)  (Revised by Mario Carneiro,
       29-Aug-2015.) $)
    phlsca $p |- ( T e. X -> T = ( Scalar ` H ) ) $=
      ( csca c1 c8 cop phlstr scaid cnx cfv csn cbs cplusg ctp snsstp3 sseqtr4i
      cvsca cip cpr cun ssun1 sstri strfv ) CEIGJKLABCDEFHMNOIPCLZQORPALZOSPBLZ
      UJTZEUKULUJUAUMUMOUCPDLOUDPFLUEZUFEUMUNUGHUBUHUI $.

    $( The scalar product operation of a constructed pre-Hilbert space.
       (Contributed by Mario Carneiro, 6-Oct-2013.)  (Revised by Mario
       Carneiro, 29-Aug-2015.) $)
    phlvsca $p |- ( .x. e. X -> .x. = ( .s ` H ) ) $=
      ( cvsca c1 c8 cop phlstr vscaid cnx cfv csn cip cpr snsspr1 cbs ctp ssun2
      cplusg csca cun sseqtr4i sstri strfv ) DEIGJKLABCDEFHMNOIPDLZQUJORPFLZSZE
      UJUKTULOUAPALOUDPBLOUEPCLUBZULUFEULUMUCHUGUHUI $.

    $( The inner product (Hermitian form) operation of a constructed
       pre-Hilbert space.  (Contributed by Mario Carneiro, 6-Oct-2013.)
       (Revised by Mario Carneiro, 29-Aug-2015.) $)
    phlip $p |- ( ., e. X -> ., = ( .i ` H ) ) $=
      ( cip c1 c8 cop phlstr ipid cnx cfv csn cvsca cpr snsspr2 cbs cplusg csca
      ctp cun ssun2 sseqtr4i sstri strfv ) FEIGJKLABCDEFHMNOIPFLZQORPDLZUJSZEUK
      UJTULOUAPALOUBPBLOUCPCLUDZULUEEULUMUFHUGUHUI $.
  $}

  $( Index value of the ~ df-tset slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  tsetndx $p |- ( TopSet ` ndx ) = 9 $=
    ( cts c9 df-tset 9nn ndxarg ) ABCDE $.

  $( Utility theorem: index-independent form of ~ df-tset .  (Contributed by
     NM, 20-Oct-2012.) $)
  tsetid $p |- TopSet = Slot ( TopSet ` ndx ) $=
    ( cts c9 df-tset 9nn ndxid ) ABCDE $.

  ${
    topgrpfn.w $e |- W = { <. ( Base ` ndx ) , B >. ,
       <. ( +g ` ndx ) , .+ >. , <. ( TopSet ` ndx ) , J >. } $.
    $( A constructed topological group is a structure.  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    topgrpstr $p |- W Struct <. 1 , 9 >. $=
      ( cnx cbs cfv cop cplusg cts ctp c1 c9 cstr c2 1nn basendx 1lt2 2nn 2lt9
      plusgndx 9nn tsetndx strle3 eqbrtri ) DFGHZAIFJHZBIFKHZCILMNIOEUGUHUIMPNA
      BCQRSTUBUAUCUDUEUF $.

    $( The base set of a constructed topological group.  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    topgrpbas $p |- ( B e. X -> B = ( Base ` W ) ) $=
      ( cbs c1 cop topgrpstr baseid cnx cfv csn cplusg cts ctp snsstp1 sseqtr4i
      c9 strfv ) ADGEHTIABCDFJKLGMAIZNUBLOMBIZLPMCIZQDUBUCUDRFSUA $.

    $( The additive operation of a constructed topological group.  (Contributed
       by Mario Carneiro, 29-Aug-2015.) $)
    topgrpplusg $p |- ( .+ e. X -> .+ = ( +g ` W ) ) $=
      ( cplusg c1 c9 cop topgrpstr plusgid cnx cfv csn cbs cts snsstp2 sseqtr4i
      ctp strfv ) BDGEHIJABCDFKLMGNBJZOMPNAJZUBMQNCJZTDUCUBUDRFSUA $.

    $( The topology of a constructed topological group.  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    topgrptset $p |- ( J e. X -> J = ( TopSet ` W ) ) $=
      ( cts c1 cop topgrpstr tsetid cnx cfv csn cbs cplusg ctp snsstp3 sseqtr4i
      c9 strfv ) CDGEHTIABCDFJKLGMCIZNLOMAIZLPMBIZUBQDUCUDUBRFSUA $.
  $}

  ${
    resstset.1 $e |- H = ( G |`s A ) $.
    resstset.2 $e |- J = ( TopSet ` G ) $.
    $( ` TopSet ` is unaffected by restriction.  (Contributed by Mario
       Carneiro, 13-Aug-2015.) $)
    resstset $p |- ( A e. V -> J = ( TopSet ` H ) ) $=
      ( cts c9 df-tset 9nn 1lt9 resslem ) ADCHIEBFGJKLM $.
  $}

  $( Index value of the ~ df-ple slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  plendx $p |- ( le ` ndx ) = 10 $=
    ( cple c10 df-ple 10nn ndxarg ) ABCDE $.

  $( Utility theorem: self-referencing, index-independent form of ~ df-ple .
     (Contributed by NM, 9-Nov-2012.) $)
  pleid $p |- le = Slot ( le ` ndx ) $=
    ( cple c10 df-ple 10nn ndxid ) ABCDE $.

  ${
    otpsstr.w $e |- K = { <. ( Base ` ndx ) , B >. ,
      <. ( TopSet ` ndx ) , J >. , <. ( le ` ndx ) , .<_ >. } $.
    $( Functionality of a topological ordered space.  (Contributed by Mario
       Carneiro, 12-Nov-2015.) $)
    otpsstr $p |- K Struct <. 1 , 10 >. $=
      ( cnx cbs cfv cop cts cple ctp c1 c10 cstr c9 1nn basendx 1lt9 9nn plendx
      tsetndx 9lt10 10nn strle3 eqbrtri ) CFGHZAIFJHZBIFKHZDILMNIOEUGUHUIMPNABD
      QRSTUBUCUDUAUEUF $.

    $( The base set of a topological ordered space.  (Contributed by Mario
       Carneiro, 12-Nov-2015.) $)
    otpsbas $p |- ( B e. V -> B = ( Base ` K ) ) $=
      ( cbs c1 c10 cop otpsstr baseid cnx cfv csn cts cple ctp snsstp1 sseqtr4i
      strfv ) ACGEHIJABCDFKLMGNAJZOUBMPNBJZMQNDJZRCUBUCUDSFTUA $.

    $( The open sets of a topological ordered space.  (Contributed by Mario
       Carneiro, 12-Nov-2015.) $)
    otpstset $p |- ( J e. V -> J = ( TopSet ` K ) ) $=
      ( cts c1 c10 cop otpsstr tsetid cnx cfv csn cbs cple ctp snsstp2 sseqtr4i
      strfv ) BCGEHIJABCDFKLMGNBJZOMPNAJZUBMQNDJZRCUCUBUDSFTUA $.

    $( The order of a topological ordered space.  (Contributed by Mario
       Carneiro, 12-Nov-2015.) $)
    otpsle $p |- ( .<_ e. V -> .<_ = ( le ` K ) ) $=
      ( cple c1 c10 cop otpsstr pleid cnx cfv csn cbs cts ctp snsstp3 sseqtr4i
      strfv ) DCGEHIJABCDFKLMGNDJZOMPNAJZMQNBJZUBRCUCUDUBSFTUA $.

  $}

  ${
    ressle.1 $e |- W = ( K |`s A ) $.
    ressle.2 $e |- .<_ = ( le ` K ) $.
    $( ` le ` is unaffected by restriction.  (Contributed by Mario Carneiro,
       3-Nov-2015.) $)
    ressle $p |- ( A e. V -> .<_ = ( le ` W ) ) $=
      ( cple c10 df-ple 10nn 1lt10 resslem ) ACEHIDBFGJKLM $.
  $}

  $( Index value of the ~ df-ocomp slot.  (Contributed by Mario Carneiro,
     25-Oct-2015.) $)
  ocndx $p |- ( oc ` ndx ) = ; 1 1 $=
    ( coc c1 cdc df-ocomp 1nn0 1nn decnncl ndxarg ) ABBCDBBEFGH $.

  $( Utility theorem: index-independent form of ~ df-ocomp .  (Contributed by
     Mario Carneiro, 25-Oct-2015.) $)
  ocid $p |- oc = Slot ( oc ` ndx ) $=
    ( coc c1 cdc df-ocomp 1nn0 1nn decnncl ndxid ) ABBCDBBEFGH $.

  $( Index value of the ~ df-ds slot.  (Contributed by Mario Carneiro,
     14-Aug-2015.) $)
  dsndx $p |- ( dist ` ndx ) = ; 1 2 $=
    ( cds c1 c2 cdc df-ds 1nn0 2nn decnncl ndxarg ) ABCDEBCFGHI $.

  $( Utility theorem: index-independent form of ~ df-ds .  (Contributed by
     Mario Carneiro, 23-Dec-2013.) $)
  dsid $p |- dist = Slot ( dist ` ndx ) $=
    ( cds c1 c2 cdc df-ds 1nn0 2nn decnncl ndxid ) ABCDEBCFGHI $.

  $( Index value of the ~ df-unif slot.  (Contributed by Thierry Arnoux,
     17-Dec-2017.) $)
  unifndx $p |- ( UnifSet ` ndx ) = ; 1 3 $=
    ( cunif c1 c3 cdc df-unif 1nn0 3nn decnncl ndxarg ) ABCDEBCFGHI $.

  $( Utility theorem: index-independent form of ~ df-unif .  (Contributed by
     Thierry Arnoux, 17-Dec-2017.) $)
  unifid $p |- UnifSet = Slot ( UnifSet ` ndx ) $=
    ( cunif c1 c3 cdc df-unif 1nn0 3nn decnncl ndxid ) ABCDEBCFGHI $.

  ${
    odrngstr.w $e |- W = ( { <. ( Base ` ndx ) , B >. ,
       <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .x. >. } u.
     { <. ( TopSet ` ndx ) , J >. , <. ( le ` ndx ) , .<_ >. ,
       <. ( dist ` ndx ) , D >. } ) $.
    $( Functionality of an ordered metric ring.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    odrngstr $p |- W Struct <. 1 , ; 1 2 >. $=
      ( cnx cfv cop ctp c1 c2 cdc c9 c10 cc0 1nn0 2nn cbs cplusg cmulr cts cple
      cds cun cstr c3 eqid rngstr 9nn tsetndx 9lt10 10nn plendx dec10 0nn0 2pos
      clt declt eqbrtri decnncl dsndx strle3 3lt9 strleun ) GIUAJAKIUBJCKIUCJDK
      LZIUDJZEKIUEJZFKIUFJZBKLZUGMMNOZKUHHMUIPVMVHVLACVHDVHUJUKVIVJVKPQVMEFBULU
      MUNUOUPQMROVMUTUQMRNSURTUSVAVBMNSTVCVDVEVFVGVB $.

    $( The base set of an ordered metric ring.  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    odrngbas $p |- ( B e. V -> B = ( Base ` W ) ) $=
      ( cbs c1 c2 cdc cop odrngstr baseid cnx cfv csn ctp cplusg cmulr cts cple
      snsstp1 cds cun ssun1 sseqtr4i sstri strfv ) AHJGKKLMNABCDEFHIOPQJRANZSUL
      QUARCNZQUBRDNZTZHULUMUNUEUOUOQUCRENQUDRFNQUFRBNTZUGHUOUPUHIUIUJUK $.

    $( The addition operation of an ordered metric ring.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    odrngplusg $p |- ( .+ e. V -> .+ = ( +g ` W ) ) $=
      ( cplusg c1 c2 cdc cop odrngstr plusgid cnx cfv csn ctp cbs cmulr snsstp2
      cts cple cds cun ssun1 sseqtr4i sstri strfv ) CHJGKKLMNABCDEFHIOPQJRCNZSQ
      UARANZULQUBRDNZTZHUMULUNUCUOUOQUDRENQUERFNQUFRBNTZUGHUOUPUHIUIUJUK $.

    $( The multiplication operation of an ordered metric ring.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    odrngmulr $p |- ( .x. e. V -> .x. = ( .r ` W ) ) $=
      ( cmulr c1 c2 cdc cop odrngstr mulrid cnx cfv csn ctp cplusg snsstp3 cple
      cbs cts cds cun ssun1 sseqtr4i sstri strfv ) DHJGKKLMNABCDEFHIOPQJRDNZSQU
      DRANZQUARCNZULTZHUMUNULUBUOUOQUERENQUCRFNQUFRBNTZUGHUOUPUHIUIUJUK $.

    $( The open sets of an ordered metric ring.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    odrngtset $p |- ( J e. V -> J = ( TopSet ` W ) ) $=
      ( cts c1 c2 cdc cop odrngstr tsetid cnx cfv csn ctp cds snsstp1 cbs cmulr
      cple cplusg cun ssun2 sseqtr4i sstri strfv ) EHJGKKLMNABCDEFHIOPQJRENZSUL
      QUERFNZQUARBNZTZHULUMUNUBUOQUCRANQUFRCNQUDRDNTZUOUGHUOUPUHIUIUJUK $.

    $( The order of an ordered metric ring.  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    odrngle $p |- ( .<_ e. V -> .<_ = ( le ` W ) ) $=
      ( cple c1 c2 cdc cop odrngstr pleid cnx cfv csn ctp cts cds snsstp2 cmulr
      cbs cplusg cun ssun2 sseqtr4i sstri strfv ) FHJGKKLMNABCDEFHIOPQJRFNZSQUA
      RENZULQUBRBNZTZHUMULUNUCUOQUERANQUFRCNQUDRDNTZUOUGHUOUPUHIUIUJUK $.

    $( The metric of an ordered metric ring.  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    odrngds $p |- ( D e. V -> D = ( dist ` W ) ) $=
      ( cds c1 c2 cdc cop odrngstr dsid cnx cfv csn ctp cts cple snsstp3 cplusg
      cbs cmulr cun ssun2 sseqtr4i sstri strfv ) BHJGKKLMNABCDEFHIOPQJRBNZSQUAR
      ENZQUBRFNZULTZHUMUNULUCUOQUERANQUDRCNQUFRDNTZUOUGHUOUPUHIUIUJUK $.
  $}

  ${
    ressds.1 $e |- H = ( G |`s A ) $.
    ressds.2 $e |- D = ( dist ` G ) $.
    $( ` dist ` is unaffected by restriction.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    ressds $p |- ( A e. V -> D = ( dist ` H ) ) $=
      ( cds c1 c2 cdc df-ds 1nn0 2nn decnncl 1nn 2nn0 1lt10 declti resslem ) AB
      DHIJKECFGLIJMNOIJIPQMRST $.
  $}

  $( Index value of the ~ df-hom slot.  (Contributed by Mario Carneiro,
     7-Jan-2017.) $)
  homndx $p |- ( Hom ` ndx ) = ; 1 4 $=
    ( chom c1 c4 cdc df-hom 1nn0 4nn decnncl ndxarg ) ABCDEBCFGHI $.

  $( Utility theorem: index-independent form of ~ df-hom .  (Contributed by
     Mario Carneiro, 7-Jan-2017.) $)
  homid $p |- Hom = Slot ( Hom ` ndx ) $=
    ( chom c1 c4 cdc df-hom 1nn0 4nn decnncl ndxid ) ABCDEBCFGHI $.

  $( Index value of the ~ df-cco slot.  (Contributed by Mario Carneiro,
     7-Jan-2017.) $)
  ccondx $p |- ( comp ` ndx ) = ; 1 5 $=
    ( cco c1 c5 cdc df-cco 1nn0 5nn decnncl ndxarg ) ABCDEBCFGHI $.

  $( Utility theorem: index-independent form of ~ df-cco .  (Contributed by
     Mario Carneiro, 7-Jan-2017.) $)
  ccoid $p |- comp = Slot ( comp ` ndx ) $=
    ( cco c1 c5 cdc df-cco 1nn0 5nn decnncl ndxid ) ABCDEBCFGHI $.

  ${
    resshom.1 $e |- D = ( C |`s A ) $.
    ${
      resshom.2 $e |- H = ( Hom ` C ) $.
      $( ` Hom ` is unaffected by restriction.  (Contributed by Mario Carneiro,
         5-Jan-2017.) $)
      resshom $p |- ( A e. V -> H = ( Hom ` D ) ) $=
        ( chom c1 c4 cdc df-hom 1nn0 4nn decnncl 1nn 4nn0 1lt10 declti resslem
        ) ADCHIJKEBFGLIJMNOIJIPQMRST $.
    $}

    ${
      ressco.2 $e |- .x. = ( comp ` C ) $.
      $( ` comp ` is unaffected by restriction.  (Contributed by Mario
         Carneiro, 5-Jan-2017.) $)
      ressco $p |- ( A e. V -> .x. = ( comp ` D ) ) $=
        ( cco c1 c5 cdc df-cco 1nn0 5nn decnncl 1nn 5nn0 1lt10 declti resslem )
        ADCHIJKEBFGLIJMNOIJIPQMRST $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Definition of the structure product
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c |`t $. $( Function returning a subspace topology. $)
  $c TopOpen $.

  $( Extend class notation with the function returning a subspace topology. $)
  crest $a class |`t $.

  $( Extend class notation with the topology extractor function. $)
  ctopn $a class TopOpen $.

  ${
    $d j x y $.
    $( Function returning the subspace topology induced by the topology ` y `
       and the set ` x ` .  (Contributed by FL, 20-Sep-2010.)  (Revised by
       Mario Carneiro, 1-May-2015.) $)
    df-rest $a |- |`t = ( j e. _V , x e. _V |->
      ran ( y e. j |-> ( y i^i x ) ) ) $.

    $( Define the topology extractor function.  This differs from ~ df-tset
       when a structure has been restricted using ~ df-ress ; in this case the
       ` TopSet ` component will still have a topology over the larger set, and
       this function fixes this by restricting the topology as well.
       (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    df-topn $a |- TopOpen = ( w e. _V |->
      ( ( TopSet ` w ) |`t ( Base ` w ) ) ) $.

    $( The subspace topology operator is a function on pairs.  (Contributed by
       Mario Carneiro, 1-May-2015.) $)
    restfn $p |- |`t Fn ( _V X. _V ) $=
      ( vj vx vy cvv cv cin cmpt crn crest df-rest vex mptex rnex fnmpt2i ) ABD
      DCAEZCEBEFZGZHIBCAJQCOPAKLMN $.

    $( The topology extractor function is a function on the universe.
       (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    topnfn $p |- TopOpen Fn _V $=
      ( vw cvv cv cts cfv cbs crest co ctopn ovex df-topn fnmpti ) ABACZDEZMFEZ
      GHINOGJAKL $.
  $}

  ${
    $d j x y A $.  $d x B $.  $d j x y J $.  $d x S $.
    $( The subspace topology induced by the topology ` J ` on the set ` A ` .
       (Contributed by FL, 20-Sep-2010.)  (Revised by Mario Carneiro,
       1-May-2015.) $)
    restval $p |- ( ( J e. V /\ A e. W )
       -> ( J |`t A ) = ran ( x e. J |-> ( x i^i A ) ) ) $=
      ( vj vy wcel cvv crest co cv cin cmpt crn wceq elex mptexg rnexg syl wa
      adantr simpl simpr ineq2d mpteq12dv rneqd df-rest ovmpt2ga mpd3an3 syl2an
      ) CDHCIHZBIHZCBJKACALZBMZNZOZPZBEHCDQBEQULUMUQIHZURULUSUMULUPIHUSACUOIRUP
      ISTUBFGCBIIAFLZUNGLZMZNZOUQJIUTCPZVABPZUAZVCUPVFAUTVBCUOVDVEUCVFVABUNVDVE
      UDUEUFUGGAFUHUIUJUK $.

    $( The predicate "is an open set of a subspace topology".  (Contributed by
       FL, 5-Jan-2009.)  (Revised by Mario Carneiro, 15-Dec-2013.) $)
    elrest $p |- ( ( J e. V /\ B e. W ) ->
      ( A e. ( J |`t B ) <-> E. x e. J A = ( x i^i B ) ) ) $=
      ( wcel wa crest co cv cin cmpt crn wceq wrex restval eleq2d eqid vex
      inex1 elrnmpti syl6bb ) DEGCFGHZBDCIJZGBADAKZCLZMZNZGBUGOADPUDUEUIBACDEFQ
      RADUGBUHUHSUFCATUAUBUC $.

    $( Sufficient condition for being an open set in a subspace.  (Contributed
       by Jeff Hankins, 11-Jul-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.) $)
    elrestr $p |- ( ( J e. V /\ S e. W /\ A e. J ) ->
                  ( A i^i S ) e. ( J |`t S ) ) $=
      ( vx wcel cin crest co wa wceq wrex eqid ineq1 eqeq2d rspcev mpan2 elrest
      cv syl5ibr 3impia ) CDGZBEGZACGZABHZCBIJGZUEUGUCUDKUFFTZBHZLZFCMZUEUFUFLZ
      UKUFNUJULFACUHALUIUFUFUHABOPQRFUFBCDESUAUB $.

    $( Value of the structure restriction when the topology input is empty.
       (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    0rest $p |- ( (/) |`t A ) = (/) $=
      ( vx cvv wcel c0 crest co wceq cv cin cmpt crn 0ex restval mpan rneqi rn0
      mpt0 eqtri wrel syl6eq cdm cxp relxp wfn restfn ax-mp releqi mpbir ovprc2
      fndm pm2.61i ) ACDZEAFGZEHUMUNBEBIAJZKZLZEECDUMUNUQHMBAECCNOUQELEUPEBUORP
      QSUAEAFFUBZTCCUCZTCCUDURUSFUSUEURUSHUFUSFUKUGUHUIUJUL $.
  $}

  ${
    $d f x y z A $.  $d f x y z J $.  $d x V $.
    $( The subspace topology over a subset of the base set is the original
       topology.  (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    restid2 $p |- ( ( A e. V /\ J C_ ~P A ) -> ( J |`t A ) = J ) $=
      ( vx wcel cpw wss wa crest co cv cin cmpt crn cvv wceq pwexg adantr simpr
      syl6eq ssexd simpl restval syl2anc cid cres sselda elpwid df-ss mpteq2dva
      sylib mptresid rneqd rnresi eqtrd ) ACEZBAFZGZHZBAIJZDBDKZALZMZNZBUSBOEUP
      UTVDPUSBUQOUPUQOEURACQRUPURSZUAUPURUBDABOCUCUDUSVDUEBUFZNBUSVCVFUSVCDBVAM
      VFUSDBVBVAUSVABEHZVAAGVBVAPVGVAAUSBUQVAVEUGUHVAAUIUKUJDBULTUMBUNTUO $.

    $( The subspace topology is a collection of subsets of the restriction
       set.  (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    restsspw $p |- ( J |`t A ) C_ ~P A $=
      ( vx vy crest co cpw cv wcel wss cin wceq wrex cvv wa wb c0 n0i cxp syl
      wfn cdm restfn fndm ax-mp ndmov nsyl2 elrest inss2 sseq1 mpbiri rexlimivw
      ibi vex elpw sylibr ssriv ) CBAEFZAGZCHZURIZUTAJZUTUSIVAUTDHZAKZLZDBMZVBV
      AVFVABNIANIOZVAVFPVAURQLVGURUTRBANEENNSZUAEUBVHLUCVHEUDUEUFUGDUTABNNUHTUM
      VEVBDBVEVBVDAJVCAUIUTVDAUJUKULTUTACUNUOUPUQ $.

    $( The finite intersections operator commutes with restriction.
       (Contributed by Mario Carneiro, 30-Aug-2015.) $)
    firest $p |- ( fi ` ( J |`t A ) ) = ( ( fi ` J ) |`t A ) $=
      ( vy vf vz cvv wcel wa crest cfi cfv wceq cv cin c0 wrex wral adantl syl
      wb vx co cint cpw cfn csn cdif ovex elfi2 ax-mp wf wex eldifi wss simprbi
      elfpw simplbi sseld elrest adantr sylibd ineq1 eqeq2d ac6sfi syl2anc ciin
      ralrimiv wne eldifsni ad2antlr iinin1 a1i simpllr crn wfn fniinfv simplll
      fvex intrnfi syl13anc eqeltrd elrestr syl3anc intiin iineq2 syl5eq eleq1d
      ffn simpr syl5ibrcom expimpd exlimdv mpd eleq1 rexlimdva syl5bi wi ineq1i
      sylancr 3expa ralrimiva ssralv sylc iinfi eqeltrrd imbi1d sylbid rexlimdv
      syl6eqr impbid eqrdv wn fi0 cdm wrel relxp restfn fndm releqi mpbir ovprc
      cxp fveq2d wo ianor fvprc oveq1d 0rest syl6eq ovprc2 jaoi 3eqtr4a pm2.61i
      sylbi ) BFGZAFGZHZBAIUBZJKZBJKZAIUBZLYQUAYSUUAYQUAMZYSGZUUBUUAGZUUCUUBCMZ
      UCZLZCYRUDUENZOUFZUGZPZYQUUDYRFGZUUCUUKTBAIUHZCUUBYRFUIUJYQUUGUUDCUUJYQUU
      EUUJGZHZUUDUUGUUFUUAGZUUOUUEBDMZUKZEMZUUSUUQKZANZLZEUUEQZHZDULZUUPUUOUUEU
      EGZUUSUUEANZLZCBPZEUUEQUVEUUOUUEUUHGZUVFUUNUVJYQUUEUUHUUIUMRZUVJUUEYRUNZU
      VFUUEYRUPZUOSZUUOUVIEUUEUUOUUSUUEGUUSYRGZUVIUUOUUEYRUUSUUOUVJUVLUVKUVJUVL
      UVFUVMUQSURYQUVOUVITUUNCUUSABFFUSUTVAVGUVHUVBECUUEBDUUEUUTLUVGUVAUUSUUEUU
      TAVBVCVDVEUUOUVDUUPDUUOUURUVCUUPUUOUURHZUUPUVCEUUEUVAVFZUUAGUVPUVQEUUEUUT
      VFZANZUUAUVPUUEOVHZUVQUVSLUUNUVTYQUURUUEUUHOVIVJZEUUEAUUTVKSUVPYTFGZYPUVR
      YTGUVSUUAGUWBUVPBJVRZVLYOYPUUNUURVMUVPUVRUUQVNUCZYTUVPUUQUUEVOZUVRUWDLUUR
      UWEUUOUUEBUUQWHREUUEUUQVPSUVPYOUURUVTUVFUWDYTGYOYPUUNUURVQUUOUURWIUWAUUOU
      VFUURUVNUTUUEBUUQFVSVTWAUVRAYTFFWBWCWAUVCUUFUVQUUAUVCUUFEUUEUUSVFZUVQEUUE
      WDZEUUEUUSUVAWEWFWGWJWKWLWMUUBUUFUUAWNWJWOWPYQUUDUUBUUSANZLZEYTPZUUCYQUWB
      YPUUDUWJTUWCYOYPWIEUUBAYTFFUSWSYQUWIUUCEYTYQUUSYTGZUUSUUFLZCBUDUENZUUIUGZ
      PZUWIUUCWQZYOUWKUWOTYPCUUSBFUIUTYQUWLUWPCUWNYQUUEUWNGZHZUWPUWLUUBUUFANZLZ
      UUCWQUWRUUCUWTUWSYSGUWREUUEUWHVFZUWSYSUWRUXAUWFANZUWSUWRUVTUXAUXBLUWQUVTY
      QUUEUWMOVIRZEUUEAUUSVKSUUFUWFAUWGWRXIUWRUULUWHYRGZEUUEQZUVTUVFUXAYSGUULUW
      RUUMVLUWRUUEBUNZUXDEBQZUXEUWRUUEUWMGZUXFUWQUXHYQUUEUWMUUIUMRZUXHUXFUVFUUE
      BUPZUQSYQUXGUWQYQUXDEBYOYPUUSBGUXDUUSABFFWBWTXAUTUXDEUUEBXBXCUXCUWRUXHUVF
      UXIUXHUXFUVFUXJUOSEUUEUWHYRFXDVTXEUUBUWSYSWNWJUWLUWIUWTUUCUWLUWHUWSUUBUUS
      UUFAVBVCXFWJWOXGXHXGXJXKYQXLZOJKOYSUUAXMUXKYROJBAIIXNZXOFFYBZXOFFXPUXLUXM
      IUXMVOUXLUXMLXQUXMIXRUJXSXTZYAYCUXKYOXLZYPXLZYDUUAOLZYOYPYEUXOUXQUXPUXOUU
      AOAIUBOUXOYTOAIBJYFYGAYHYIYTAIUXNYJYKYNYLYM $.

    restid.1 $e |- X = U. J $.
    $( The subspace topology of the base set is the original topology.
       (Contributed by Jeff Hankins, 9-Jul-2009.)  (Revised by Mario Carneiro,
       13-Aug-2015.) $)
    restid $p |- ( J e. V -> ( J |`t X ) = J ) $=
      ( wcel cvv cpw wss crest wceq cuni uniexg syl5eqel eqimss2i sspwuni mpbir
      co restid2 sylancl ) ABEZCFEACGHZACIQAJTCAKZFDABLMUAUBCHCUBDNACOPCAFRS $.
  $}

  ${
    $d w B $.  $d w J $.  $d w W $.
    topnval.1 $e |- B = ( Base ` W ) $.
    topnval.2 $e |- J = ( TopSet ` W ) $.
    $( Value of the topology extractor function.  (Contributed by Mario
       Carneiro, 13-Aug-2015.) $)
    topnval $p |- ( J |`t B ) = ( TopOpen ` W ) $=
      ( vw cvv wcel crest co ctopn cfv wceq cv cts cbs fveq2 syl6eqr c0 fvprc
      oveq12d df-topn ovex fvmpt eqcomd wn 0rest syl5eq oveq1d 3eqtr4a pm2.61i
      ) CGHZBAIJZCKLZMULUNUMFCFNZOLZUOPLZIJUMGKUOCMZUPBUQAIURUPCOLZBUOCOQERURUQ
      CPLAUOCPQDRUAFUBBAIUCUDUEULUFZSAIJSUMUNAUGUTBSAIUTBUSSECOTUHUICKTUJUK $.

    $( Value of the topology extractor function when the topology is defined
       over the same set as the base.  (Contributed by Mario Carneiro,
       13-Aug-2015.) $)
    topnid $p |- ( J C_ ~P B -> J = ( TopOpen ` W ) ) $=
      ( cpw wss ctopn cfv crest topnval cvv wcel wceq fvex eqeltri restid2 mpan
      co cbs syl5reqr ) BAFGZCHIBAJSZBABCDEKALMUBUCBNACTILDCTOPABLQRUA $.
  $}

  ${
    topnpropd.1 $e |- ( ph -> ( Base ` K ) = ( Base ` L ) ) $.
    topnpropd.2 $e |- ( ph -> ( TopSet ` K ) = ( TopSet ` L ) ) $.
    $( The topology extractor function depends only on the base and topology
       components.  (Contributed by NM, 18-Jul-2006.) $)
    topnpropd $p |- ( ph -> ( TopOpen ` K ) = ( TopOpen ` L ) ) $=
      ( cts cfv cbs crest co ctopn oveq12d eqid topnval 3eqtr3g ) ABFGZBHGZIJCF
      GZCHGZIJBKGCKGAPRQSIEDLQPBQMPMNSRCSMRMNO $.
  $}

  $c topGen $.
  $c Xt_ $.

  $( Extend class notation with a function that converts a basis to its
     corresponding topology. $)
  ctg $a class topGen $.

  $( Extend class notation with a function whose value is a product
     topology. $)
  cpt $a class Xt_ $.

  ${
    $d f g x y z $.
    $( Define a function that converts a basis to its corresponding topology.
       Equivalent to the definition of a topology generated by a basis in
       [Munkres] p. 78 (see ~ tgval2 ).  See ~ tgval3 for an alternate
       expression for the value.  (Contributed by NM, 16-Jul-2006.) $)
    df-topgen $a |- topGen = ( x e. _V |->
                               { y | y C_ U. ( x i^i ~P y ) } ) $.

    $( Define the product topology on a collection of topologies.  For
       convenience, it is defined on arbitrary collections of sets, expressed
       as a function from some index set to the subbases of each factor space.
       (Contributed by Mario Carneiro, 3-Feb-2015.) $)
    df-pt $a |- Xt_ = ( f e. _V |-> ( topGen ` { x | E. g ( ( g Fn dom f /\
      A. y e. dom f ( g ` y ) e. ( f ` y ) /\ E. z e. Fin A. y e. ( dom f \ z )
       ( g ` y ) = U. ( f ` y ) ) /\ x = X_ y e. dom f ( g ` y ) ) } ) ) $.
  $}

  $c Xs_ ^s $.

  $( The function constructing structure products. $)
  cprds $a class Xs_ $.

  $( The function constructing structure powers. $)
  cpws $a class ^s $.

  ${
    $d a c d e f g h s r x v $.
    $( Define a structure product.  This can be a product of groups, rings,
       modules, or ordered topological fields; any unused components will have
       garbage in them but this usually not relevant for the purpose of
       inheriting the structures present in the factors.  (Contributed by
       Stefan O'Rear, 3-Jan-2015.) $)
    df-prds $a |- Xs_ = ( s e. _V , r e. _V |->
      [_ X_ x e. dom r ( Base ` ( r ` x ) ) / v ]_
      [_ ( f e. v , g e. v |-> X_ x e. dom r
           ( ( f ` x ) ( Hom ` ( r ` x ) ) ( g ` x ) ) ) / h ]_
  ( ( { <. ( Base ` ndx ) , v >. ,
        <. ( +g ` ndx ) , ( f e. v , g e. v |-> ( x e. dom r |->
          ( ( f ` x ) ( +g ` ( r ` x ) ) ( g ` x ) ) ) ) >. ,
        <. ( .r ` ndx ) , ( f e. v , g e. v |-> ( x e. dom r |->
          ( ( f ` x ) ( .r ` ( r ` x ) ) ( g ` x ) ) ) ) >. } u.
      { <. ( Scalar ` ndx ) , s >. ,
        <. ( .s ` ndx ) , ( f e. ( Base ` s ) , g e. v |->
        ( x e. dom r |-> ( f ( .s ` ( r ` x ) ) ( g ` x ) ) ) ) >. } ) u.
    ( { <. ( TopSet ` ndx ) , ( Xt_ ` ( TopOpen o. r ) ) >. ,
        <. ( le ` ndx ) , { <. f , g >. | ( { f , g } C_ v /\
        A. x e. dom r ( f ` x ) ( le ` ( r ` x ) ) ( g ` x ) ) } >. ,
        <. ( dist ` ndx ) , ( f e. v , g e. v |-> sup (
         ( ran ( x e. dom r |-> ( ( f ` x ) ( dist ` ( r ` x ) ) ( g ` x ) ) )
           u. { 0 } ) , RR* , < ) ) >. } u.
      { <. ( Hom ` ndx ) , h >. ,
        <. ( comp ` ndx ) , ( a e. ( v X. v ) , c e. v |->
          ( d e. ( c h ( 2nd ` a ) ) , e e. ( h ` a ) |-> ( x e. dom r |->
            ( ( d ` x ) ( <. ( ( 1st ` a ) ` x ) , ( ( 2nd ` a ) ` x ) >.
            ( comp ` ( r ` x ) ) ( c ` x ) ) ( e ` x ) ) ) ) ) >. } ) ) ) $.

    $( The structure product is a well-behaved binary operator.  (Contributed
       by Stefan O'Rear, 7-Jan-2015.) $)
    reldmprds $p |- Rel dom Xs_ $=
      ( vs vr vv vx vh vf vg va vc vd ve cv cfv cbs co cmpt2 cnx cop cmpt cun
      cvv cdm cixp chom cplusg cmulr ctp csca cvsca cpr cts ctopn ccom cpt cple
      wss wbr wral wa copab cds crn cc0 csn cxr clt csup cco cxp c2nd csb cprds
      c1st df-prds reldmmpt2 ) ABUAUACDBLZUBZDLZVPMZNMUCEFGCLZVTDVQVRFLZMZVRGLZ
      MZVSUDMOUCPQNMVTRQUEMFGVTVTDVQWBWDVSUEMOSPRQUFMFGVTVTDVQWBWDVSUFMOSPRUGQU
      HMALZRQUIMFGWENMVTDVQWAWDVSUIMOSPRUJTQUKMULVPUMUNMRQUOMWAWCUJVTUPWBWDVSUO
      MUQDVQURUSFGUTRQVAMFGVTVTDVQWBWDVSVAMOSVBVCVDTVEVFVGPRUGQUDMELZRQVHMHIVTV
      TVIVTJKILZHLZVJMZWFOWHWFMDVQVRJLMVRKLMVRWHVMMMVRWIMRVRWGMVSVHMOOSPPRUJTTV
      KVKVLDCKFGEABHIJVNVO $.

    $d r i $.
    $( Define a structure power, which is just a structure product where all
       the factors are the same.  (Contributed by Mario Carneiro,
       11-Jan-2015.) $)
    df-pws $a |- ^s = ( r e. _V , i e. _V |->
      ( ( Scalar ` r ) Xs_ ( i X. { r } ) ) ) $.
  $}

  ${
    $d x R $.
    prdsbasex.b $e |- B = X_ x e. dom R ( Base ` ( R ` x ) ) $.
    $( Lemma for structure products.  (Contributed by Mario Carneiro,
       3-Jan-2015.) $)
    prdsbasex $p |- B e. _V $=
      ( cdm cv cfv cbs cixp cvv wcel ixpexg fvex a1i mprg eqeltri ) BACEZAFZCGZ
      HGZIZJDTJKZUAJKAQAQTJLUBRQKSHMNOP $.
  $}

  ${
    imasvalstr.u $e |- U = ( ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
        { <. ( Scalar ` ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) u.
        { <. ( TopSet ` ndx ) , O >. , <. ( le ` ndx ) , L >. ,
        <. ( dist ` ndx ) , D >. } ) $.
    $( Structure product value is a structure.  (Contributed by Stefan O'Rear,
       3-Jan-2015.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    imasvalstr $p |- U Struct <. 1 , ; 1 2 >. $=
      ( cnx cfv cop ctp cun c1 c2 cdc c9 c10 cbs cplusg cmulr csca cpr cts cple
      cvsca cds cstr c6 eqid algstr 9nn tsetndx 9lt10 10nn plendx cc0 clt dec10
      1nn0 0nn0 2nn 2pos declt eqbrtri decnncl dsndx strle3 6lt9 strleun ) GKUA
      LAMKUBLCMKUCLFMNKUDLDMKUHLEMUEOZKUFLZIMKUGLZHMKUILZBMNZOPPQRZMUJJPUKSVRVM
      VQVMACDEFVMULUMVNVOVPSTVRIHBUNUOUPUQURTPUSRVRUTVAPUSQVBVCVDVEVFVGPQVBVDVH
      VIVJVKVLVG $.
  $}

  $( Structure product value is a structure.  (Contributed by Stefan O'Rear,
     3-Jan-2015.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
  prdsvalstr $p |- ( ( { <. ( Base ` ndx ) , B >. ,
      <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
      { <. ( Scalar ` ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) u.
    ( { <. ( TopSet ` ndx ) , O >. , <. ( le ` ndx ) , L >. ,
        <. ( dist ` ndx ) , D >. } u.
      { <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .xb >. } ) )
      Struct <. 1 , ; 1 5 >. $=
    ( cnx cfv cop ctp cun c1 c5 cdc c4 1nn0 cbs cplusg cmulr csca cvsca cpr cts
    cple cds chom cco cstr unass c2 eqid imasvalstr 4nn decnncl homndx 4nn0 5nn
    4lt5 declt ccondx strle2 2nn0 2lt4 strleun eqbrtrri ) KUALAMKUBLCMKUCLGMNKU
    DLDMKUELFMUFOZKUGLJMKUHLIMKUILBMNZOZKUJLZHMKUKLZEMUFZOVJVKVOOOPPQRZMULVJVKV
    OUMPPUNRPSRZVPVLVOABCDFGVLIJVLUOUPVMVNVQVPHEPSTUQURUSPSQTUTVAVBVCPQTVAURVDV
    EPUNSTVFUQVGVCVHVI $.

  ${
    prdsvallem.u $e |- ( ph -> U = ( ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
        { <. ( Scalar ` ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) u.
      ( { <. ( TopSet ` ndx ) , O >. , <. ( le ` ndx ) , L >. ,
          <. ( dist ` ndx ) , D >. } u.
        { <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .xb >. } ) ) ) $.
    prdsvallem.1 $e |- A = ( E ` U ) $.
    prdsvallem.2 $e |- E = Slot ( E ` ndx ) $.
    prdsvallem.3 $e |- ( ph -> T e. _V ) $.
    prdsvallem.4 $e |- { <. ( E ` ndx ) , T >. } C_
      ( ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
        { <. ( Scalar ` ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) u.
      ( { <. ( TopSet ` ndx ) , O >. , <. ( le ` ndx ) , L >. ,
          <. ( dist ` ndx ) , D >. } u.
        { <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .xb >. } ) ) $.
    $( Lemma for ~ prdsbas and similar theorems.  (Contributed by Mario
       Carneiro, 7-Jan-2017.) $)
    prdsvallem $p |- ( ph -> A = T ) $=
      ( cnx cbs cfv cop cplusg cmulr ctp csca cpr cun cts cple cds chom cco cvv
      cvsca c1 c5 cdc prdsvalstr strfv3 ) ABHUAUBUCCUDUAUEUCEUDUAUFUCJUDUGUAUHU
      CFUDUAUQUCIUDUIUJUAUKUCOUDUAULUCNUDUAUMUCDUDUGUAUNUCMUDUAUOUCGUDUIUJUJKLU
      PURURUSUTUDPCDEFGIJMNOVARTSQVB $.
  $}

  ${
    $d h r s v .+ $.  $d h r s v .<_ $.  $d a c d e f g h r s v B $.  $d x I $.
    $d a c d e h r s v H $.  $d a c d e f g h r s v x ph $.  $d h r s v .x. $.
    $d h r s v D $.  $d h r s v O $.  $d h r s v .X. $.  $d h r s v .xb $.
    $d a c d e f g h r s v x R $.  $d a c d e f g h r s v x S $.
    prdsval.p $e |- P = ( S Xs_ R ) $.
    prdsval.k $e |- K = ( Base ` S ) $.
    prdsval.i $e |- ( ph -> dom R = I ) $.
    prdsval.b $e |- ( ph -> B = X_ x e. I ( Base ` ( R ` x ) ) ) $.
    prdsval.a $e |- ( ph -> .+ = ( f e. B , g e. B |-> ( x e. I |->
        ( ( f ` x ) ( +g ` ( R ` x ) ) ( g ` x ) ) ) ) ) $.
    prdsval.t $e |- ( ph -> .X. = ( f e. B , g e. B |-> ( x e. I |->
        ( ( f ` x ) ( .r ` ( R ` x ) ) ( g ` x ) ) ) ) ) $.
    prdsval.m $e |- ( ph -> .x. = ( f e. K , g e. B |-> ( x e. I |->
        ( f ( .s ` ( R ` x ) ) ( g ` x ) ) ) ) ) $.
    prdsval.o $e |- ( ph -> O = ( Xt_ ` ( TopOpen o. R ) ) ) $.
    prdsval.l $e |- ( ph -> .<_ = { <. f , g >. | ( { f , g } C_ B /\
        A. x e. I ( f ` x ) ( le ` ( R ` x ) ) ( g ` x ) ) } ) $.
    prdsval.d $e |- ( ph -> D = ( f e. B , g e. B |-> sup ( ( ran ( x e. I |->
   ( ( f ` x ) ( dist ` ( R ` x ) ) ( g ` x ) ) ) u. { 0 } ) , RR* , < ) ) ) $.
    prdsval.h $e |- ( ph -> H = ( f e. B , g e. B |-> X_ x e. I
           ( ( f ` x ) ( Hom ` ( R ` x ) ) ( g ` x ) ) ) ) $.
    prdsval.x $e |- ( ph -> .xb = ( a e. ( B X. B ) , c e. B |->
        ( d e. ( c H ( 2nd ` a ) ) , e e. ( H ` a ) |-> ( x e. I |->
          ( ( d ` x ) ( <. ( ( 1st ` a ) ` x ) , ( ( 2nd ` a ) ` x ) >.
            ( comp ` ( R ` x ) ) ( c ` x ) ) ( e ` x ) ) ) ) ) ) $.
    prdsval.s $e |- ( ph -> S e. W ) $.
    prdsval.r $e |- ( ph -> R e. Z ) $.
    $( Value of the structure product.  (Contributed by Stefan O'Rear,
       3-Jan-2015.)  (Revised by Mario Carneiro, 7-Jan-2017.) $)
    prdsval $p |- ( ph -> P = ( ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
        { <. ( Scalar ` ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) u.
      ( { <. ( TopSet ` ndx ) , O >. , <. ( le ` ndx ) , .<_ >. ,
          <. ( dist ` ndx ) , D >. } u.
        { <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .xb >. } ) ) ) $=
      ( vs vr vv vh cprds co cnx cbs cfv cop cplusg cmulr ctp csca cpr cun cple
      cvsca cds chom cco cvv cv cdm cixp cmpt2 cmpt ctopn ccom cpt wss wbr wral
      copab crn cxr clt csup cxp csb wceq a1i cmap wcel cuni rnex uniex strfvss
      wa vex rnss uniss mp2b sstri rgenw mpbir ax-mp ovex simpr fveq1d ixpeq2dv
      fveq2d ad2antrr eqtrd ixpeq1d adantr mpt2eq123dv eqtr4d mpteq12dv ad4antr
      oveqd opeq2d tpeq123d simpllr preq12d uneq12d csbied2 elex tpex prex unex
      syl cts cc0 csn c2nd c1st df-prds baseid fvssunirn iunss ssexi ixpssmap2g
      ciun ssex dmeqd 3eqtr4d cpw wf ovssunirn c1 c4 cdc df-hom ss2ixp ixpconst
      mp1i dmex sseqtri elpw2 rgen2w eqid fmpt2 mpbi xpex pwex ad3antrrr simplr
      fex2 mp3an simp-4r syl6eqr coeq2d sseq2d breqd raleqbidv anbi12d opabbidv
      wb rneqd uneq1d supeq1d xpeq12d anasss ovmpt2d syl5eq ) AEHGVCVDVEVFVGZCV
      HZVEVIVGZFVHZVEVJVGZKVHZVKZVEVLVGZHVHZVEVPVGZJVHZVMZVNZVEUUAVGZSVHZVEVOVG
      ZRVHZVEVQVGZDVHZVKZVEVRVGZOVHZVEVSVGZIVHZVMZVNZVNZUEAUSUTHGVTVTVABUTWAZWB
      ZBWAZUYBVGZVFVGZWCZVBMNVAWAZUYHBUYCUYDMWAZVGZUYDNWAZVGZUYEVRVGZVDZWCZWDZU
      WOUYHVHZUWQMNUYHUYHBUYCUYJUYLUYEVIVGZVDZWEZWDZVHZUWSMNUYHUYHBUYCUYJUYLUYE
      VJVGZVDZWEZWDZVHZVKZUXBUSWAZVHZUXDMNVUIVFVGZUYHBUYCUYIUYLUYEVPVGZVDZWEZWD
      ZVHZVMZVNZUXHWFUYBWGZWHVGZVHZUXJUYIUYKVMZUYHWIZUYJUYLUYEVOVGZWJZBUYCWKZXG
      ZMNWLZVHZUXLMNUYHUYHBUYCUYJUYLUYEVQVGZVDZWEZWMZUUBUUCZVNZWNWOWPZWDZVHZVKZ
      UXOVBWAZVHZUXQUBUCUYHUYHWQZUYHUDLUCWAZUBWAZUUDVGZVVTVDZVWDVVTVGZBUYCUYDUD
      WAVGZUYDLWAVGZUYDVWDUUEVGVGUYDVWEVGVHZUYDVWCVGZUYEVSVGZVDZVDZWEZWDZWDZVHZ
      VMZVNZVNZWRZWRZUYAVCVTVCUSUTVTVTVXCWDWSABVALMNVBUSUTUBUCUDUUFWTAVUIHWSZUY
      BGWSZVXCUYAWSAVXDXGZVXEXGZVAUYGCVXBUYAVTUYGBUYCUYFUULZUYCXAVDZWIZUYGVTXBV
      XGVXHVTXBVXJVXHUYBWMZXCZWMZXCZVXMVXLVXKUYBUTXHZXDXEXDXEZVXHVXNWIUYFVXNWIZ
      BUYCWKVXQBUYCUYFUYEWMZXCZVXNUYEVFUWOUUGXFUYEVXLWIVXRVXMWIVXSVXNWIUYBUYDUU
      HUYEVXLXIVXRVXMXJXKZXLXMBUYCUYFVXNUUIXNUUJBUYCUYFVTUUKXOUYGVXIVXHUYCXAXPU
      UMUVEVXGBPUYFWCBPUYDGVGZVFVGZWCZUYGCVXGBPUYFVYBVXGUYEVYAVFVXGUYDUYBGVXFVX
      EXQZXRZXTXSVXGBUYCPUYFVXGUYCGWBZPVXGUYBGVYDUUNAVYFPWSVXDVXEUGYAYBZYCACVYC
      WSVXDVXEUHYAUUOVXGUYHCWSZXGZVBUYPOVXAUYAVTUYPVTXBZVYIVWBVXNWMZXCZUYCXAVDZ
      UUPZUYPUUQZVWBVTXBVYNVTXBVYJUYOVYNXBZNUYHWKMUYHWKVYOVYPMNUYHUYHVYPUYOVYMW
      IUYOBUYCVYLWCZVYMUYNVYLWIZBUYCWKUYOVYQWIVYRBUYCUYNUYMWMZXCZVYLUYMUYJUYLUU
      RUYMVXNWIVYSVYKWIVYTVYLWIUYMVXSVXNUYEVRUUSUUTUVAUVBXFVXTXLUYMVXNXIVYSVYKX
      JXKXLXMBUYCUYNVYLUVCXOBUYCVYLUYBVXOUVFVYKVXNVXPXDXEUVDUVGUYOVYMVYLUYCXAXP
      ZUVHXNUVIMNUYHUYHUYOVYNUYPUYPUVJUVKUVLUYHUYHVAXHZWUBUVMVYMWUAUVNVWBVYNUYP
      VTVTUVQUVRWTVYIUYPMNCCBPUYJUYLVYAVRVGZVDZWCZWDZOVYIMNUYHUYHUYOCCWUEVXGVYH
      XQZWUGVYIUYOBPUYNWCZWUEVYIBUYCPUYNVXGUYCPWSVYHVYGYDYCVXGWUHWUEWSVYHVXGBPU
      YNWUDVXGUYMWUCUYJUYLVXGUYEVYAVRVYEXTYIXSYDYBYEAOWUFWSVXDVXEVYHUOUVOYFVYIV
      VTOWSZXGZVURUXGVWTUXTWUJVUHUXAVUQUXFWUJUYQUWPVUBUWRVUGUWTWUJUYHCUWOVXGVYH
      WUIUVPZYJWUJVUAFUWQWUJVUAMNCCBPUYJUYLVYAVIVGZVDZWEZWDZFVYIVUAWUOWSWUIVYIM
      NUYHUYHUYTCCWUNWUGWUGVXGUYTWUNWSVYHVXGBUYCUYSPWUMVYGVXGUYRWULUYJUYLVXGUYE
      VYAVIVYEXTYIYGYDYEYDAFWUOWSVXDVXEVYHWUIUIYHYFYJWUJVUFKUWSWUJVUFMNCCBPUYJU
      YLVYAVJVGZVDZWEZWDZKVYIVUFWUSWSWUIVYIMNUYHUYHVUECCWURWUGWUGVXGVUEWURWSVYH
      VXGBUYCVUDPWUQVYGVXGVUCWUPUYJUYLVXGUYEVYAVJVYEXTYIYGYDYEYDAKWUSWSVXDVXEVY
      HWUIUJYHYFYJYKWUJVUJUXCVUPUXEWUJVUIHUXBAVXDVXEVYHWUIUVSYJWUJVUOJUXDWUJVUO
      MNQCBPUYIUYLVYAVPVGZVDZWEZWDZJVYIVUOWVCWSWUIVYIMNVUKUYHVUNQCWVBVYIVUKHVFV
      GQVYIVUIHVFAVXDVXEVYHYLXTUFUVTWUGVXGVUNWVBWSVYHVXGBUYCVUMPWVAVYGVXGVULWUT
      UYIUYLVXGUYEVYAVPVYEXTYIYGYDYEYDAJWVCWSVXDVXEVYHWUIUKYHYFYJYMYNWUJVVSUXNV
      WSUXSWUJVVAUXIVVIUXKVVRUXMWUJVUTSUXHWUJVUTWFGWGZWHVGZSWUJVUSWVDWHWUJUYBGW
      FVXFVXEVYHWUIYLUWAXTASWVEWSVXDVXEVYHWUIULYHYFYJWUJVVHRUXJWUJVVHVVBCWIZUYJ
      UYLVYAVOVGZWJZBPWKZXGZMNWLZRVYIVVHWVKWSWUIVYIVVGWVJMNVYIVVCWVFVVFWVIVYIUY
      HCVVBWUGUWBVXGVVFWVIUWGVYHVXGVVEWVHBUYCPVYGVXGVVDWVGUYJUYLVXGUYEVYAVOVYEX
      TUWCUWDYDUWEUWFYDARWVKWSVXDVXEVYHWUIUMYHYFYJWUJVVQDUXLWUJVVQMNCCBPUYJUYLV
      YAVQVGZVDZWEZWMZVVNVNZWNWOWPZWDZDVYIVVQWVRWSWUIVYIMNUYHUYHVVPCCWVQWUGWUGV
      YIWNVVOWVPWOVYIVVMWVOVVNVYIVVLWVNVXGVVLWVNWSVYHVXGBUYCVVKPWVMVYGVXGVVJWVL
      UYJUYLVXGUYEVYAVQVYEXTYIYGYDUWHUWIUWJYEYDADWVRWSVXDVXEVYHWUIUNYHYFYJYKWUJ
      VWAUXPVWRUXRWUJVVTOUXOVYIWUIXQZYJWUJVWQIUXQWUJVWQUBUCCCWQZCUDLVWCVWEOVDZV
      WDOVGZBPVWHVWIVWJVWKVYAVSVGZVDZVDZWEZWDZWDZIWUJUBUCVWBUYHVWPWVTCWWGWUJUYH
      CUYHCWUKWUKUWKWUKWUJUDLVWFVWGVWOWWAWWBWWFWUJVVTOVWCVWEWVSYIWUJVWDVVTOWVSX
      RVXGVWOWWFWSVYHWUIVXGBUYCVWNPWWEVYGVXGVWMWWDVWHVWIVXGVWLWWCVWJVWKVXGUYEVY
      AVSVYEXTYIYIYGYAYEYEAIWWHWSVXDVXEVYHWUIUPYHYFYJYMYNYNYOYOUWLAHTXBHVTXBUQH
      TYPYTAGUAXBGVTXBURGUAYPYTUYAVTXBAUXGUXTUXAUXFUWPUWRUWTYQUXCUXEYRYSUXNUXSU
      XIUXKUXMYQUXPUXRYRYSYSWTUWMUWN $.
  $}

  ${
    $d a c d e f g x B $.  $d a c d e H $.  $d f g K $.  $d a c d e f g x ph $.
    $d a c d e f g w x y z I $.  $d f g x P $.  $d a c d e f g w x y z R $.
    $d a c d e f g x S $.
    prdsbas.p $e |- P = ( S Xs_ R ) $.
    prdsbas.s $e |- ( ph -> S e. V ) $.
    prdsbas.r $e |- ( ph -> R e. W ) $.
    $( Scalar ring of a structure product.  (Contributed by Stefan O'Rear,
       5-Jan-2015.)  (Revised by Mario Carneiro, 15-Aug-2015.) $)
    prdssca $p |- ( ph -> S = ( Scalar ` P ) ) $=
      ( vx vf vg cfv cv co cmpt cmpt2 cop eqidd cnx va vc csca cdm cbs cixp cds
      vd crn cc0 csn cun cxr clt csup cplusg cxp c2nd chom c1st cco cvsca cmulr
      ve cpr wss cple wbr wral copab ctopn ccom cpt eqid prdsval scaid wcel cvv
      wa elex syl ctp cts snsspr1 ssun2 sstri ssun1 prdsvallem eqcomd ) ABUCMZD
      AWJJCUDZJNZCMZUEMUFZKLWNWNJWKWLKNZMZWLLNZMZWMUGMOPUIUJUKULUMUNUOQZKLWNWNJ
      WKWPWRWMUPMOPQZDUAUBWNWNUQWNUHVDUBNZUANZURMZKLWNWNJWKWPWRWMUSMOUFQZOXBXDM
      JWKWLUHNMWLVDNMWLXBUTMMWLXCMRWLXAMWMVAMOOPQQZDKLDUEMZWNJWKWOWRWMVBMOPQZKL
      WNWNJWKWPWRWMVCMOPQZBUCXDWOWQVEWNVFWPWRWMVGMVHJWKVIVSKLVJZVKCVLVMMZAJWNWS
      BWTCDXEXGXHVDKLXDWKXFXIXJEFUAUBUHGXFVNAWKSAWNSAWTSAXHSAXGSAXJSAXISAWSSAXD
      SAXESHIVOWJVNVPADEVQDVRVQHDEVTWATUCMDRZUKZTUEMWNRTUPMWTRTVCMXHRWBZXKTVBMX
      GRZVEZULZXPTWCMXJRTVGMXIRTUGMWSRWBTUSMXDRTVAMXERVEULZULXLXOXPXKXNWDXOXMWE
      WFXPXQWGWFWHWI $.

    prdsbas.b $e |- B = ( Base ` P ) $.
    prdsbas.i $e |- ( ph -> dom R = I ) $.
    $( Base set of a structure product.  (Contributed by Stefan O'Rear,
       3-Jan-2015.)  (Revised by Mario Carneiro, 15-Aug-2015.) $)
    prdsbas $p |- ( ph -> B = X_ x e. I ( Base ` ( R ` x ) ) ) $=
      ( cfv co cop eqidd cvv cnx vf vg va vc vd ve cv cbs cixp cds cmpt crn cc0
      csn cun cxr clt csup cmpt2 cplusg cxp c2nd chom c1st cco cvsca cmulr cple
      cpr wss wbr wral wa copab ctopn ccom cpt eqid prdsval ciun wcel cmap cuni
      baseid strfvss fvssunirn uniss sstri rgenw iunss mpbir rnexg uniexg ssexg
      rnss mp2b 3syl sylancr ixpssmap2g ovex ssex ctp csca cts ssun1 prdsvallem
      snsstp1 ) ACBGBUGZEOZUHOZUIZUAUBXKXKBGXHUAUGZOZXHUBUGZOZXIUJOPUKULUMUNUOU
      PUQURUSZUAUBXKXKBGXMXOXIUTOPUKUSZFUCUDXKXKVAXKUEUFUDUGZUCUGZVBOZUAUBXKXKB
      GXMXOXIVCOPUIUSZPXSYAOBGXHUEUGOXHUFUGOXHXSVDOOXHXTOQXHXROXIVEOPPUKUSUSZXK
      UAUBFUHOZXKBGXLXOXIVFOPUKUSZUAUBXKXKBGXMXOXIVGOPUKUSZDUHYAXLXNVIXKVJXMXOX
      IVHOVKBGVLVMUAUBVNZVOEVPVQOZABXKXPDXQEFYBYDYEUFUAUBYAGYCYFYGHIUCUDUEJYCVR
      NAXKRAXQRAYERAYDRAYGRAYFRAXPRAYARAYBRKLVSMWDABGXJVTZSWAZXKYHGWBPZVJXKSWAA
      YHEULZWCZULZWCZVJZYNSWAZYIYOXJYNVJZBGVLYQBGXJXIULZWCZYNXIUHTUHOZWDWEXIYLV
      JYRYMVJYSYNVJEXHWFXIYLWOYRYMWGWPWHWIBGXJYNWJWKAYLSWAZYMSWAYPAEIWAYKSWAUUA
      LEIWLYKSWMWQYLSWLYMSWMWQYHYNSWNWRBGXJSWSXKYJYHGWBWTXAWQYTXKQZUNZUUBTUTOXQ
      QZTVGOYEQZXBZTXCOFQTVFOYDQVIZUOZUUHTXDOYGQTVHOYFQTUJOXPQXBTVCOYAQTVEOYBQV
      IUOZUOUUCUUFUUHUUBUUDUUEXGUUFUUGXEWHUUHUUIXEWHXF $.

    ${
      prdsplusg.b $e |- .+ = ( +g ` P ) $.
      $( Addition in a structure product.  (Contributed by Stefan O'Rear,
         3-Jan-2015.)  (Revised by Mario Carneiro, 15-Aug-2015.) $)
      prdsplusg $p |- ( ph -> .+ = ( f e. B , g e. B |-> ( x e. I |->
            ( ( f ` x ) ( +g ` ( R ` x ) ) ( g ` x ) ) ) ) ) $=
        ( cfv cvv va vc vd ve cv cds co cmpt crn cc0 csn cun cxr clt csup cmpt2
        cplusg cxp c2nd chom cixp c1st cop cco cbs cvsca cmulr cpr wss cple wbr
        wral wa copab ctopn ccom cpt eqid prdsbas prdsval plusgid cuni cpw cmap
        eqidd wf wcel ovssunirn cnx strfvss fvssunirn rnss uniss mp2b ovex elpw
        sstri mpbir a1i fmptd wb rnexg uniexg 3syl pwexg cdm dmexg syl eqeltrrd
        4syl elmapg syl2anc mpbird ralrimivw fmpt2 sylib fvex eqeltri xpex fex2
        mp3an23 ctp csca cts snsstp2 ssun1 prdsvallem ) AECHICCBJBUEZHUEZSZYHIU
        EZSZYHFSZUFSUGUHUIUJUKULUMUNUOUPZHICCBJYJYLYMUQSZUGZUHZUPZGUAUBCCURZCUC
        UDUBUEZUAUEZUSSZHICCBJYJYLYMUTSUGVAUPZUGUUAUUCSBJYHUCUESYHUDUESYHUUAVBS
        SYHUUBSVCYHYTSYMVDSUGUGUHUPUPZYRHIGVESZCBJYIYLYMVFSUGUHUPZHICCBJYJYLYMV
        GSUGUHUPZDUQUUCYIYKVHCVIYJYLYMVJSVKBJVLVMHIVNZVOFVPVQSZABCYNDYRFGUUDUUF
        UUGUDHIUUCJUUEUUHUUIKLUAUBUCMUUEVRQABCDFGJKLMNOPQVSAYRWEAUUGWEAUUFWEAUU
        IWEAUUHWEAYNWEAUUCWEAUUDWENOVTRWAAYSFUIZWBZUIZWBZUIZWBZWCZJWDUGZYRWFZYR
        TWGZAYQUUQWGZICVLZHCVLUURAUVAHCAUUTICAUUTJUUPYQWFZABJYPUUPYQYPUUPWGZAYH
        JWGVMUVCYPUUOVIYPYOUIZWBZUUOYOYJYLWHYOUUMVIUVDUUNVIUVEUUOVIYOYMUIZWBZUU
        MYMUQWIUQSZWAWJYMUUKVIUVFUULVIUVGUUMVIFYHWKYMUUKWLUVFUULWMWNWQYOUUMWLUV
        DUUNWMWNWQYPUUOYJYLYOWOWPWRWSYQVRWTAUUPTWGZJTWGUUTUVBXAAUUMTWGZUUNTWGUU
        OTWGUVIAUUKTWGZUULTWGUVJAFLWGZUUJTWGUVKOFLXBUUJTXCXDUUKTXBUULTXCXDUUMTX
        BUUNTXCUUOTXEXJAFXFZJTQAUVLUVMTWGOFLXGXHXIUUPJYQTTXKXLXMXNXNHICCYQUUQYR
        YRVRXOXPUURYSTWGUUQTWGUUSCCCDVESTPDVEXQXRZUVNXSUUPJWDWOYSUUQYRTTXTYAXHU
        VHYRVCZUKZWIVESCVCZUVOWIVGSUUGVCZYBZWIYCSGVCWIVFSUUFVCVHZULZUWAWIYDSUUI
        VCWIVJSUUHVCWIUFSYNVCYBWIUTSUUCVCWIVDSUUDVCVHULZULUVPUVSUWAUVQUVOUVRYEU
        VSUVTYFWQUWAUWBYFWQYG $.
    $}

    ${
      prdsmulr.t $e |- .x. = ( .r ` P ) $.
      $( Multiplication in a structure product.  (Contributed by Mario
         Carneiro, 11-Jan-2015.)  (Revised by Mario Carneiro, 15-Aug-2015.) $)
      prdsmulr $p |- ( ph -> .x. = ( f e. B , g e. B |-> ( x e. I |->
            ( ( f ` x ) ( .r ` ( R ` x ) ) ( g ` x ) ) ) ) ) $=
        ( cfv cvv va vc vd ve cv cds co cmpt crn cc0 csn cun cxr clt csup cmpt2
        cplusg cxp c2nd chom cixp c1st cop cco cmulr cbs cvsca cpr wss cple wbr
        wral wa copab ctopn ccom cpt eqid prdsbas prdsplusg prdsval mulrid cuni
        eqidd cpw cmap wf wcel ovssunirn cnx strfvss fvssunirn rnss uniss sstri
        mp2b ovex elpw mpbir a1i fmptd wb rnexg uniexg 3syl pwexg syl cdm dmexg
        eqeltrrd elmapg syl2anc ralrimivw fmpt2 sylib fvex eqeltri xpex mp3an23
        mpbird fex2 ctp csca cts snsstp3 ssun1 prdsvallem ) AGCHICCBJBUEZHUEZSZ
        YHIUEZSZYHESZUFSUGUHUIUJUKULUMUNUOUPZDUQSZFUAUBCCURZCUCUDUBUEZUAUEZUSSZ
        HICCBJYJYLYMUTSUGVAUPZUGYRYTSBJYHUCUESYHUDUESYHYRVBSSYHYSSVCYHYQSYMVDSU
        GUGUHUPUPZHICCBJYJYLYMVESZUGZUHZUPZHIFVFSZCBJYIYLYMVGSUGUHUPZUUEDVEYTYI
        YKVHCVIYJYLYMVJSVKBJVLVMHIVNZVOEVPVQSZABCYNDYOEFUUAUUGUUEUDHIYTJUUFUUHU
        UIKLUAUBUCMUUFVRQABCDEFJKLMNOPQVSABCDYOEFHIJKLMNOPQYOVRVTAUUEWDAUUGWDAU
        UIWDAUUHWDAYNWDAYTWDAUUAWDNOWARWBAYPEUIZWCZUIZWCZUIZWCZWEZJWFUGZUUEWGZU
        UETWHZAUUDUUQWHZICVLZHCVLUURAUVAHCAUUTICAUUTJUUPUUDWGZABJUUCUUPUUDUUCUU
        PWHZAYHJWHVMUVCUUCUUOVIUUCUUBUIZWCZUUOUUBYJYLWIUUBUUMVIUVDUUNVIUVEUUOVI
        UUBYMUIZWCZUUMYMVEWJVESZWBWKYMUUKVIUVFUULVIUVGUUMVIEYHWLYMUUKWMUVFUULWN
        WPWOUUBUUMWMUVDUUNWNWPWOUUCUUOYJYLUUBWQWRWSWTUUDVRXAAUUPTWHZJTWHUUTUVBX
        BAUUOTWHZUVIAUUMTWHZUUNTWHUVJAUUKTWHZUULTWHUVKAELWHZUUJTWHUVLOELXCUUJTX
        DXEUUKTXCUULTXDXEUUMTXCUUNTXDXEUUOTXFXGAEXHZJTQAUVMUVNTWHOELXIXGXJUUPJU
        UDTTXKXLXTXMXMHICCUUDUUQUUEUUEVRXNXOUURYPTWHUUQTWHUUSCCCDVFSTPDVFXPXQZU
        VOXRUUPJWFWQYPUUQUUETTYAXSXGUVHUUEVCZUKZWJVFSCVCZWJUQSYOVCZUVPYBZWJYCSF
        VCWJVGSUUGVCVHZULZUWBWJYDSUUIVCWJVJSUUHVCWJUFSYNVCYBWJUTSYTVCWJVDSUUAVC
        VHULZULUVQUVTUWBUVRUVSUVPYEUVTUWAYFWOUWBUWCYFWOYG $.
    $}

    ${
      prdsvsca.k $e |- K = ( Base ` S ) $.
      prdsvsca.m $e |- .x. = ( .s ` P ) $.
      $( Scalar multiplication in a structure product.  (Contributed by Stefan
         O'Rear, 5-Jan-2015.)  (Revised by Mario Carneiro, 15-Aug-2015.) $)
      prdsvsca $p |- ( ph -> .x. = ( f e. K , g e. B |-> ( x e. I |->
            ( f ( .s ` ( R ` x ) ) ( g ` x ) ) ) ) ) $=
        ( va vc vd ve cv cfv cds cmpt crn cc0 csn cun cxr clt csup cmpt2 cplusg
        co cxp c2nd chom cixp c1st cop cco cvsca cmulr cpr wss cple wbr wral wa
        copab ctopn ccom cpt prdsbas eqid prdsplusg prdsmulr eqidd prdsval cuni
        vscaid cpw cmap wf cvv wcel ovssunirn strfvss fvssunirn rnss uniss mp2b
        cnx sstri ovex elpw mpbir a1i fmptd wb rnexg uniexg 3syl pwexg 4syl cdm
        dmexg syl eqeltrrd elmapg syl2anc mpbird ralrimivw fmpt2 sylib cbs fvex
        eqeltri xpex fex2 mp3an23 ctp csca cts snsspr2 ssun2 ssun1 prdsvallem )
        AGCHICCBJBUEZHUEZUFZYMIUEZUFZYMEUFZUGUFURUHUIUJUKULUMUNUOUPZDUQUFZFUAUB
        CCUSCUCUDUBUEZUAUEZUTUFZHICCBJYOYQYRVAUFURVBUPZURUUBUUDUFBJYMUCUEUFYMUD
        UEUFYMUUBVCUFUFYMUUCUFVDYMUUAUFYRVEUFURURUHUPUPZHIKCBJYNYQYRVFUFZURZUHZ
        UPZUUIDVGUFZDVFUUDYNYPVHCVIYOYQYRVJUFVKBJVLVMHIVNZVOEVPVQUFZABCYSDYTEFU
        UEUUIUUJUDHIUUDJKUUKUULLMUAUBUCNSRABCDEFJLMNOPQRVRABCDYTEFHIJLMNOPQRYTV
        SVTABCDEFUUJHIJLMNOPQRUUJVSWAAUUIWBAUULWBAUUKWBAYSWBAUUDWBAUUEWBOPWCTWE
        AKCUSZEUIZWDZUIZWDZUIZWDZWFZJWGURZUUIWHZUUIWIWJZAUUHUVAWJZICVLZHKVLUVBA
        UVEHKAUVDICAUVDJUUTUUHWHZABJUUGUUTUUHUUGUUTWJZAYMJWJVMUVGUUGUUSVIUUGUUF
        UIZWDZUUSUUFYNYQWKUUFUUQVIUVHUURVIUVIUUSVIUUFYRUIZWDZUUQYRVFWQVFUFZWEWL
        YRUUOVIUVJUUPVIUVKUUQVIEYMWMYRUUOWNUVJUUPWOWPWRUUFUUQWNUVHUURWOWPWRUUGU
        USYNYQUUFWSWTXAXBUUHVSXCAUUTWIWJZJWIWJUVDUVFXDAUUQWIWJZUURWIWJUUSWIWJUV
        MAUUOWIWJZUUPWIWJUVNAEMWJZUUNWIWJUVOPEMXEUUNWIXFXGUUOWIXEUUPWIXFXGUUQWI
        XEUURWIXFUUSWIXHXIAEXJZJWIRAUVPUVQWIWJPEMXKXLXMUUTJUUHWIWIXNXOXPXQXQHIK
        CUUHUVAUUIUUIVSXRXSUVBUUMWIWJUVAWIWJUVCKCKFXTUFWISFXTYAYBCDXTUFWIQDXTYA
        YBYCUUTJWGWSUUMUVAUUIWIWIYDYEXLUVLUUIVDZUKZWQXTUFCVDWQUQUFYTVDWQVGUFUUJ
        VDYFZWQYGUFFVDZUVRVHZULZUWCWQYHUFUULVDWQVJUFUUKVDWQUGUFYSVDYFWQVAUFUUDV
        DWQVEUFUUEVDVHULZULUVSUWBUWCUWAUVRYIUWBUVTYJWRUWCUWDYKWRYL $.
    $}

    ${
      prdsle.l $e |- .<_ = ( le ` P ) $.
      $( Structure product weak ordering.  (Contributed by Mario Carneiro,
         15-Aug-2015.) $)
      prdsle $p |- ( ph -> .<_ = { <. f , g >. | ( { f , g } C_ B /\
        A. x e. I ( f ` x ) ( le ` ( R ` x ) ) ( g ` x ) ) } ) $=
        ( cfv cop va vc vd ve cv cds co cmpt crn cc0 csn cun cxr clt csup cmpt2
        cplusg cxp c2nd chom cixp c1st cco cpr wss cple wbr wral wa copab cvsca
        cmulr ctopn ccom cpt cbs eqid prdsbas prdsplusg prdsmulr prdsvsca eqidd
        prdsval pleid cvv wcel fvex eqeltri xpex prss opabbii opabssxp eqsstr3i
        vex anbi1i ssexi a1i cnx cts csca snsstp2 ssun1 sstri ssun2 prdsvallem
        ctp ) AJCGHCCBIBUEZGUEZSZXGHUEZSZXGESZUFSUGUHUIUJUKULUMUNUOUPZDUQSZFUAU
        BCCURZCUCUDUBUEZUAUEZUSSZGHCCBIXIXKXLUTSUGVAUPZUGXQXSSBIXGUCUESXGUDUESX
        GXQVBSSXGXRSTXGXPSXLVCSUGUGUHUPUPZXHXJVDCVEZXIXKXLVFSVGBIVHZVIZGHVJZDVK
        SZDVLSZDVFXSYDVMEVNVOSZABCXMDXNEFXTYEYFUDGHXSIFVPSZYDYGKLUAUBUCMYHVQZQA
        BCDEFIKLMNOPQVRABCDXNEFGHIKLMNOPQXNVQVSABCDEFYFGHIKLMNOPQYFVQVTABCDEFYE
        GHIYHKLMNOPQYIYEVQWAAYGWBAYDWBAXMWBAXSWBAXTWBNOWCRWDYDWEWFAYDXOCCCDVPSW
        EPDVPWGWHZYJWIYDXHCWFXJCWFVIZYBVIZGHVJXOYLYCGHYKYAYBXHXJCGWNHWNWJWOWKYB
        GHCCWLWMWPWQWRVFSYDTZUKZWRWSSYGTZYMWRUFSXMTZXFZWRUTSXSTWRVCSXTTVDZULZWR
        VPSCTWRUQSXNTWRVLSYFTXFWRWTSFTWRVKSYETVDULZYSULYNYQYSYOYMYPXAYQYRXBXCYS
        YTXDXCXE $.

      $( Closure of the order relation on a structure product.  (Contributed by
         Mario Carneiro, 16-Aug-2015.) $)
      prdsless $p |- ( ph -> .<_ C_ ( B X. B ) ) $=
        ( vf vg vx cv cfv cpr wss cple wbr wral wa copab cxp prdsle wcel anbi1i
        vex prss opabbii opabssxp eqsstr3i syl6eqss ) AGPSZQSZUABUBZRSZURTVAUST
        VADTUCTUDRFUEZUFZPQUGZBBUHZARBCDEPQFGHIJKLMNOUIVDURBUJUSBUJUFZVBUFZPQUG
        VEVGVCPQVFUTVBURUSBPULQULUMUKUNVBPQBBUOUPUQ $.
    $}

    ${
      prdsds.l $e |- D = ( dist ` P ) $.
      $( Structure product distance function.  (Contributed by Mario Carneiro,
         15-Aug-2015.) $)
      prdsds $p |- ( ph -> D = ( f e. B , g e. B |-> sup ( ( ran ( x e. I |->
   ( ( f ` x ) ( dist ` ( R ` x ) ) ( g ` x ) ) ) u. { 0 } ) , RR* , < ) ) ) $=
        ( cfv cop va vc vd ve vy vz vw cv cds cmpt crn cc0 csn cun cxr clt csup
        co cmpt2 cplusg cxp c2nd chom cixp c1st cco cvsca cmulr cple ctopn ccom
        cpt cbs eqid prdsbas prdsplusg prdsmulr prdsvsca eqidd prdsval dsid cvv
        prdsle wcel cuni cpw wf wral wbr wn wrex wi wa df-sup wss ssrab2 unissi
        crab xrex uniex elpw2 mpbir rgen2w fmpt2 mpbi fvex xpex pwex fex2 mp3an
        eqeltri a1i cnx cts ctp cpr csca snsstp3 ssun1 sstri ssun2 prdsvallem )
        ADCHICCBJBUHZHUHSZYCIUHSZYCFSZUISURUJUKULUMUNZUOUPUQZUSZEUTSZGUAUBCCVAZ
        CUCUDUBUHZUAUHZVBSZHICCBJYDYEYFVCSURVDUSZURYMYOSBJYCUCUHSYCUDUHSYCYMVES
        SYCYNSTYCYLSYFVFSURURUJUSUSZYIEVGSZEVHSZEUIYOEVISZVJFVKVLSZABCYIEYJFGYP
        YQYRUDHIYOJGVMSZYSYTKLUAUBUCMUUAVNZQABCEFGJKLMNOPQVOABCEYJFGHIJKLMNOPQY
        JVNVPABCEFGYRHIJKLMNOPQYRVNVQABCEFGYQHIJUUAKLMNOPQUUBYQVNVRAYTVSABCEFGH
        IJYSKLMNOPQYSVNWCAYIVSAYOVSAYPVSNOVTRWAYIWBWDZAYKUOWEZWFZYIWGZYKWBWDUUE
        WBWDUUCYHUUEWDZICWHHCWHUUFUUGHICCYHUEUHZUFUHZUPWIWJUFYGWHUUIUUHUPWIUUIU
        GUHUPWIUGYGWKWLUFUOWHWMZUEUOWRZWEZUUEUEUFUGYGUOUPWNUULUUEWDUULUUDWOUUKU
        OUUJUEUOWPWQUULUUDUOWSWTZXAXBXKXCHICCYHUUEYIYIVNXDXECCCEVMSWBPEVMXFXKZU
        UNXGUUDUUMXHYKUUEYIWBWBXIXJXLXMUISYITZUMZXMXNSYTTZXMVISYSTZUUOXOZXMVCSY
        OTXMVFSYPTXPZUNZXMVMSCTXMUTSYJTXMVHSYRTXOXMXQSGTXMVGSYQTXPUNZUVAUNUUPUU
        SUVAUUQUURUUOXRUUSUUTXSXTUVAUVBYAXTYB $.

      $( Structure product distance function.  (Contributed by Mario Carneiro,
         15-Sep-2015.) $)
      prdsdsfn $p |- ( ph -> D Fn ( B X. B ) ) $=
        ( vf vg vx cv cfv cxp wfn cds co cmpt crn cc0 csn cun cxr clt csup eqid
        cmpt2 xrltso supex fnmpt2i prdsds fneq1d mpbiri ) ACBBUAZUBPQBBRGRSZPST
        VBQSTVBETUCTUDUEUFUGUHUIZUJUKULZUNZVAUBPQBBVDVEVEUMUJVCUKUOUPUQAVACVEAR
        BCDEFPQGHIJKLMNOURUSUT $.
    $}

    ${
      prdstset.l $e |- O = ( TopSet ` P ) $.
      $( Structure product topology.  (Contributed by Mario Carneiro,
         15-Aug-2015.) $)
      prdstset $p |- ( ph -> O = ( Xt_ ` ( TopOpen o. R ) ) ) $=
        ( vf vx cfv cop cnx va vc vd ve vg cds cplusg cxp cv c2nd chom co cmpt2
        cixp c1st cco cmpt ctopn ccom cpt cvsca cmulr cts cple cbs eqid prdsbas
        prdsplusg prdsmulr prdsvsca eqidd prdsle prdsds prdsval tsetid cvv wcel
        fvex a1i csn ctp cpr cun csca snsstp1 ssun1 sstri ssun2 prdsvallem ) AG
        BCUFRZCUGRZEUAUBBBUHBUCUDUBUIZUAUIZUJRZPUEBBQFQUIZPUIRWOUEUIRWODRZUKRUL
        UNUMZULWMWQRQFWOUCUIRWOUDUIRWOWMUORRWOWNRSWOWLRWPUPRULULUQUMUMZURDUSZUT
        RZCVARZCVBRZCVCWQCVDRZWTAQBWJCWKDEWRXAXBUDPUEWQFEVERZXCWTHIUAUBUCJXDVFZ
        NAQBCDEFHIJKLMNVGAQBCWKDEPUEFHIJKLMNWKVFVHAQBCDEXBPUEFHIJKLMNXBVFVIAQBC
        DEXAPUEFXDHIJKLMNXEXAVFVJAWTVKAQBCDEPUEFXCHIJKLMNXCVFVLAQBWJCDEPUEFHIJK
        LMNWJVFVMAWQVKAWRVKKLVNOVOWTVPVQAWSUTVRVSTVCRWTSZVTZXFTVDRXCSZTUFRWJSZW
        AZTUKRWQSTUPRWRSWBZWCZTVERBSTUGRWKSTVBRXBSWATWDRESTVARXASWBWCZXLWCXGXJX
        LXFXHXIWEXJXKWFWGXLXMWHWGWI $.
    $}

    ${
      prdshom.h $e |- H = ( Hom ` P ) $.
      $( Structure product hom-sets.  (Contributed by Mario Carneiro,
         7-Jan-2017.) $)
      prdshom $p |- ( ph -> H = ( f e. B , g e. B |->
          X_ x e. I ( ( f ` x ) ( Hom ` ( R ` x ) ) ( g ` x ) ) ) ) $=
        ( cfv cvv va vc vd ve cds cplusg cxp cv c2nd chom co cixp cmpt2 cop cco
        c1st cmpt cvsca cmulr cple cts eqid prdsbas prdsplusg prdsmulr prdsvsca
        cbs prdstset prdsle prdsds eqidd prdsval crn cuni cmap cpw wf wcel wral
        homid wss ovssunirn cnx strfvss fvssunirn rnss uniss sstri rgenw ss2ixp
        mp2b ax-mp wceq cdm dmexg eqeltrrd rnexg uniexg 3syl ixpconstg syl5sseq
        syl syl2anc ovex elpw2 ralrimivw fmpt2 sylib fvex eqeltri xpex a1i pwex
        sylibr fex2 syl3anc csn ctp cpr cun csca snsspr1 ssun2 prdsvallem ) AIC
        DUESZDUFSZFUAUBCCUGZCUCUDUBUHZUAUHZUISZGHCCBJBUHZGUHSZYKHUHSZYKESZUJSZU
        KZULZUMZUKYIYRSBJYKUCUHSYKUDUHSYKYIUPSSYKYJSUNYKYHSYNUOSUKUKUQUMUMZYRDU
        RSZDUSSZDUJYRDUTSZDVASZABCYEDYFEFYSYTUUAUDGHYRJFVGSZUUBUUCKLUAUBUCMUUDV
        BZQABCDEFJKLMNOPQVCABCDYFEFGHJKLMNOPQYFVBVDABCDEFUUAGHJKLMNOPQUUAVBVEAB
        CDEFYTGHJUUDKLMNOPQUUEYTVBVFACDEFJUUCKLMNOPQUUCVBVHABCDEFGHJUUBKLMNOPQU
        UBVBVIABCYEDEFGHJKLMNOPQYEVBVJAYRVKAYSVKNOVLRVTAYGEVMZVNZVMZVNZVMZVNZJV
        OUKZVPZYRVQZYGTVRZUUMTVRZYRTVRAYQUUMVRZHCVSZGCVSUUNAUURGCAUUQHCAYQUULWA
        UUQABJUUKULZYQUULYPUUKWAZBJVSYQUUSWAUUTBJYPYOVMZVNZUUKYOYLYMWBYOUUIWAUV
        AUUJWAUVBUUKWAYOYNVMZVNZUUIYNUJWCUJSZVTWDYNUUGWAUVCUUHWAUVDUUIWAEYKWEYN
        UUGWFUVCUUHWGWKWHYOUUIWFUVAUUJWGWKWHWIBJYPUUKWJWLAJTVRUUKTVRZUUSUULWMAE
        WNZJTQAELVRZUVGTVROELWOXBWPAUUITVRZUUJTVRUVFAUUGTVRZUUHTVRUVIAUVHUUFTVR
        UVJOELWQUUFTWRWSUUGTWQUUHTWRWSUUITWQUUJTWRWSBJUUKTTWTXCXAYQUULUUKJVOXDZ
        XEXNXFXFGHCCYQUUMYRYRVBXGXHUUOACCCDVGSTPDVGXIXJZUVLXKXLUUPAUULUVKXMXLYG
        UUMYRTTXOXPUVEYRUNZXQZWCVASUUCUNWCUTSUUBUNWCUESYEUNXRZUVMWCUOSYSUNZXSZX
        TZWCVGSCUNWCUFSYFUNWCUSSUUAUNXRWCYASFUNWCURSYTUNXSXTZUVRXTUVNUVQUVRUVMU
        VPYBUVQUVOYCWHUVRUVSYCWHYD $.

      prdsco.o $e |- .xb = ( comp ` P ) $.
      $( Structure product composition operation.  (Contributed by Mario
         Carneiro, 7-Jan-2017.) $)
      prdsco $p |- ( ph -> .xb = ( a e. ( B X. B ) , c e. B |->
        ( d e. ( c H ( 2nd ` a ) ) , e e. ( H ` a ) |-> ( x e. I |->
          ( ( d ` x ) ( <. ( ( 1st ` a ) ` x ) , ( ( 2nd ` a ) ` x ) >.
            ( comp ` ( R ` x ) ) ( c ` x ) ) ( e ` x ) ) ) ) ) ) $=
        ( vf vg cds cfv cplusg cxp cv c2nd c1st cop cmpt cmpt2 cvsca cmulr cple
        co cco cts cbs eqid prdsbas prdsplusg prdsmulr prdsvsca prdstset prdsle
        prdsds prdshom eqidd prdsval ccoid cvv wcel fvex eqeltri mpt2ex a1i cnx
        xpex csn ctp chom cpr cun csca snsspr2 ssun2 sstri prdsvallem ) AGCDUEU
        FZDUGUFZFMNCCUHZCOHNUIZMUIZUJUFZIURWPIUFBJBUIZOUIUFWRHUIUFWRWPUKUFUFWRW
        QUFULWRWOUFWREUFUSUFURURUMUNZUNZWTDUOUFZDUPUFZDUSIDUQUFZDUTUFZABCWLDWME
        FWTXAXBHUCUDIJFVAUFZXCXDKLMNOPXEVBZTABCDEFJKLPQRSTVCABCDWMEFUCUDJKLPQRS
        TWMVBVDABCDEFXBUCUDJKLPQRSTXBVBVEABCDEFXAUCUDJXEKLPQRSTXFXAVBVFACDEFJXD
        KLPQRSTXDVBVGABCDEFUCUDJXCKLPQRSTXCVBVHABCWLDEFUCUDJKLPQRSTWLVBVIABCDEF
        UCUDIJKLPQRSTUAVJAWTVKQRVLUBVMWTVNVOAMNWNCWSCCCDVAUFVNSDVAVPVQZXGWAXGVR
        VSVTUSUFWTULZWBZVTUTUFXDULVTUQUFXCULVTUEUFWLULWCZVTWDUFIULZXHWEZWFZVTVA
        UFCULVTUGUFWMULVTUPUFXBULWCVTWGUFFULVTUOUFXAULWEWFZXMWFXIXLXMXKXHWHXLXJ
        WIWJXMXNWIWJWK $.
    $}
  $}

  ${
    $d f g x y z B $.  $d f g x y z F $.  $d f g x y z G $.  $d f g x y z ph $.
    $d f g x y z I $.  $d x J $.  $d y z K $.  $d x P $.  $d x T $.  $d x V $.
    $d f g x y z R $.  $d f g x y z S $.  $d x W $.  $d f g x y z Y $.
    prdsbasmpt.y $e |- Y = ( S Xs_ R ) $.
    prdsbasmpt.b $e |- B = ( Base ` Y ) $.
    ${
      prdsbasmpt.s $e |- ( ph -> S e. V ) $.
      prdsbasmpt.i $e |- ( ph -> I e. W ) $.
      prdsbasmpt.r $e |- ( ph -> R Fn I ) $.
      $( The base set of a structure product is an indexed set product.
         (Contributed by Stefan O'Rear, 10-Jan-2015.)  (Revised by Mario
         Carneiro, 15-Aug-2015.) $)
      prdsbas2 $p |- ( ph -> B = X_ x e. I ( Base ` ( R ` x ) ) ) $=
        ( cvv wfn wcel fnex syl2anc cdm wceq fndm syl prdsbas ) ABCIDEFGOJLADFP
        ZFHQDOQNMFHDRSKAUEDTFUANFDUBUCUD $.

      $( A constructed tuple is a point in a structure product iff each
         coordinate is in the proper base set.  (Contributed by Stefan O'Rear,
         10-Jan-2015.) $)
      prdsbasmpt $p |- ( ph -> ( ( x e. I |-> U ) e. B <->
          A. x e. I U e. ( Base ` ( R ` x ) ) ) ) $=
        ( cmpt wcel cv cfv cbs cixp wral prdsbas2 eleq2d wb mptelixpg syl bitrd
        ) ABGFPZCQUIBGBRDSTSZUAZQZFUJQBGUBZACUKUIABCDEGHIJKLMNOUCUDAGIQULUMUENB
        GFUJIUFUGUH $.

      ${
        prdsbasmpt.t $e |- ( ph -> T e. B ) $.
        $( Points in the structure product are functions; use this with ~ dffn5
           to establish equalities.  (Contributed by Stefan O'Rear,
           10-Jan-2015.) $)
        prdsbasfn $p |- ( ph -> T Fn I ) $=
          ( vx cv cfv cbs cixp wcel wfn prdsbas2 eleqtrd ixpfn syl ) AEPFPQCRSR
          ZTZUAEFUBAEBUHOAPBCDFGHIJKLMNUCUDPFUGEUEUF $.

        prdsbasprj.j $e |- ( ph -> J e. I ) $.
        $( Each point in a structure product restricts on each coordinate to
           the relevant base set.  (Contributed by Stefan O'Rear,
           10-Jan-2015.) $)
        prdsbasprj $p |- ( ph -> ( T ` J ) e. ( Base ` ( R ` J ) ) ) $=
          ( vx wcel cfv cv cbs wral prdsbas2 eleqtrd cvv wfn elixp2 simp3bi syl
          cixp wceq fveq2 fveq2d eleq12d rspcva syl2anc ) AGFSRUAZETZURCTZUBTZS
          ZRFUCZGETZGCTZUBTZSZQAERFVAUKZSZVCAEBVHPARBCDFHIJKLMNOUDUEVIEUFSEFUGV
          CRFVAEUHUIUJVBVGRGFURGULZUSVDVAVFURGEUMVJUTVEUBURGCUMUNUOUPUQ $.
      $}

      prdsplusgval.f $e |- ( ph -> F e. B ) $.
      prdsplusgval.g $e |- ( ph -> G e. B ) $.
      ${
        prdsplusgval.p $e |- .+ = ( +g ` Y ) $.
        $( Value of a componentwise sum in a structure product.  (Contributed
           by Stefan O'Rear, 10-Jan-2015.)  (Revised by Mario Carneiro,
           15-Aug-2015.) $)
        prdsplusgval $p |- ( ph -> ( F .+ G ) = ( x e. I |-> ( ( F ` x )
            ( +g ` ( R ` x ) ) ( G ` x ) ) ) ) $=
          ( vy vz cv cfv cplusg co cmpt cvv wfn wcel fnex syl2anc cdm wceq fndm
          syl prdsplusg wa fveq1 oveqan12d adantl mpteq2dv mptexg ovmpt2d ) AUA
          UBGHCCBIBUCZUAUCZUDZVEUBUCZUDZVEEUDUEUDZUFZUGBIVEGUDZVEHUDZVJUFZUGZDU
          HABCLDEFUAUBIJUHMOAEIUIZIKUJZEUHUJQPIKEUKULNAVPEUMIUNQIEUOUPTUQAVFGUN
          ZVHHUNZURZURBIVKVNVTVKVNUNAVRVSVGVLVIVMVJVEVFGUSVEVHHUSUTVAVBRSAVQVOU
          HUJPBIVNKVCUPVD $.

        prdsplusgfval.j $e |- ( ph -> J e. I ) $.
        $( Value of a structure product sum at a single coordinate.
           (Contributed by Stefan O'Rear, 10-Jan-2015.) $)
        prdsplusgfval $p |- ( ph -> ( ( F .+ G ) ` J ) = ( ( F ` J )
            ( +g ` ( R ` J ) ) ( G ` J ) ) ) $=
          ( vx co cfv cv cplusg cmpt prdsplusgval fveq1d wcel wceq fveq2 fveq2d
          oveq123d eqid ovex fvmpt syl eqtrd ) AIFGCUCZUDIUBHUBUEZFUDZVAGUDZVAD
          UDZUFUDZUCZUGZUDZIFUDZIGUDZIDUDZUFUDZUCZAIUTVGAUBBCDEFGHJKLMNOPQRSTUH
          UIAIHUJVHVMUKUAUBIVFVMHVGVAIUKZVBVIVCVJVEVLVNVDVKUFVAIDULUMVAIFULVAIG
          ULUNVGUOVIVJVLUPUQURUS $.
      $}

      ${
        prdsmulrval.t $e |- .x. = ( .r ` Y ) $.
        $( Value of a componentwise ring product in a structure product.
           (Contributed by Mario Carneiro, 11-Jan-2015.) $)
        prdsmulrval $p |- ( ph -> ( F .x. G ) = ( x e. I |-> ( ( F ` x )
            ( .r ` ( R ` x ) ) ( G ` x ) ) ) ) $=
          ( vy vz cv cfv cmulr cmpt cvv wfn wcel fnex syl2anc cdm wceq fndm syl
          co prdsmulr wa fveq1 oveqan12d adantl mpteq2dv mptexg ovmpt2d ) AUAUB
          GHCCBIBUCZUAUCZUDZVEUBUCZUDZVEDUDUEUDZUPZUFBIVEGUDZVEHUDZVJUPZUFZFUGA
          BCLDEFUAUBIJUGMOADIUHZIKUIZDUGUIQPIKDUJUKNAVPDULIUMQIDUNUOTUQAVFGUMZV
          HHUMZURZURBIVKVNVTVKVNUMAVRVSVGVLVIVMVJVEVFGUSVEVHHUSUTVAVBRSAVQVOUGU
          IPBIVNKVCUOVD $.

        prdsmulrfval.j $e |- ( ph -> J e. I ) $.
        $( Value of a structure product's ring product at a single coordinate.
           (Contributed by Mario Carneiro, 11-Jan-2015.) $)
        prdsmulrfval $p |- ( ph -> ( ( F .x. G ) ` J ) = ( ( F ` J )
            ( .r ` ( R ` J ) ) ( G ` J ) ) ) $=
          ( vx co cfv cv cmulr cmpt prdsmulrval fveq1d wcel wceq fveq2 oveq123d
          fveq2d eqid ovex fvmpt syl eqtrd ) AIFGEUCZUDIUBHUBUEZFUDZVAGUDZVACUD
          ZUFUDZUCZUGZUDZIFUDZIGUDZICUDZUFUDZUCZAIUTVGAUBBCDEFGHJKLMNOPQRSTUHUI
          AIHUJVHVMUKUAUBIVFVMHVGVAIUKZVBVIVCVJVEVLVNVDVKUFVAICULUNVAIFULVAIGUL
          UMVGUOVIVJVLUPUQURUS $.
      $}

      ${
        prdsleval.l $e |- .<_ = ( le ` Y ) $.
        $( Value of the product ordering in a structure product.  (Contributed
           by Mario Carneiro, 15-Aug-2015.) $)
        prdsleval $p |- ( ph -> ( F .<_ G <->
          A. x e. I ( F ` x ) ( le ` ( R ` x ) ) ( G ` x ) ) ) $=
          ( vf vg wbr cop cv wcel wa cfv cple wral copab df-br cpr wss cvv fnex
          wfn syl2anc cdm wceq fndm syl prdsle vex anbi1i opabbii eleq2d syl5bb
          prss syl6eqr wb fveq1 breqan12d ralbidv opelopab2a bitrd ) AFGIUCZFGU
          DZUAUEZCUFUBUEZCUFUGZBUEZVSUHZWBVTUHZWBDUHUIUHZUCZBHUJZUGZUAUBUKZUFZW
          BFUHZWBGUHZWEUCZBHUJZVQVRIUFAWJFGIULAIWIVRAIVSVTUMCUNZWGUGZUAUBUKWIAB
          CLDEUAUBHIJUOMOADHUQZHKUFDUOUFQPHKDUPURNAWQDUSHUTQHDVAVBTVCWHWPUAUBWA
          WOWGVSVTCUAVDUBVDVIVEVFVJVGVHAFCUFGCUFWJWNVKRSWGWNUAUBFGCCVSFUTZVTGUT
          ZUGWFWMBHWRWSWCWKWDWLWEWBVSFVLWBVTGVLVMVNVOURVP $.
      $}

      ${
        prdsdsval.d $e |- D = ( dist ` Y ) $.
        $( Value of the metric in a structure product.  (Contributed by Mario
           Carneiro, 20-Aug-2015.) $)
        prdsdsval $p |- ( ph -> ( F D G ) = sup ( ( ran ( x e. I |->
     ( ( F ` x ) ( dist ` ( R ` x ) ) ( G ` x ) ) ) u. { 0 } ) , RR* , < ) ) $=
          ( vf vg cv cfv cds co cmpt crn cc0 csn cun cxr clt csup cvv wcel fnex
          wfn syl2anc cdm wceq syl prdsds fveq1 oveqan12d adantl mpteq2dv rneqd
          fndm wa uneq1d supeq1d xrltso supex a1i ovmpt2d ) AUAUBGHCCBIBUCZUAUC
          ZUDZVQUBUCZUDZVQEUDUEUDZUFZUGZUHZUIUJZUKZULUMUNBIVQGUDZVQHUDZWBUFZUGZ
          UHZWFUKZULUMUNZDUOABCDLEFUAUBIJUOMOAEIURZIKUPEUOUPQPIKEUQUSNAWOEUTIVA
          QIEVIVBTVCAVRGVAZVTHVAZVJZVJZULWGWMUMWSWEWLWFWSWDWKWSBIWCWJWRWCWJVAAW
          PWQVSWHWAWIWBVQVRGVDVQVTHVDVEVFVGVHVKVLRSWNUOUPAULWMUMVMVNVOVP $.
      $}
    $}

    prdsvscaval.t $e |- .x. = ( .s ` Y ) $.
    prdsvscaval.k $e |- K = ( Base ` S ) $.
    prdsvscaval.s $e |- ( ph -> S e. V ) $.
    prdsvscaval.i $e |- ( ph -> I e. W ) $.
    prdsvscaval.r $e |- ( ph -> R Fn I ) $.
    prdsvscaval.f $e |- ( ph -> F e. K ) $.
    prdsvscaval.g $e |- ( ph -> G e. B ) $.
    $( Scalar multiplication in a structure product is pointwise.  (Contributed
       by Stefan O'Rear, 10-Jan-2015.) $)
    prdsvscaval $p |- ( ph -> ( F .x. G ) = ( x e. I |->
        ( F ( .s ` ( R ` x ) ) ( G ` x ) ) ) ) $=
      ( vy vz cv cfv cvsca co cmpt cvv wfn wcel fnex syl2anc wceq fndm prdsvsca
      cdm syl wa id fveq1 oveqan12d adantl mpteq2dv mptexg ovmpt2d ) AUCUDGHJCB
      IUCUEZBUEZUDUEZUFZVIDUFUGUFZUHZUIBIGVIHUFZVLUHZUIZFUJABCMDEFUCUDIJKUJNRAD
      IUKZILULZDUJULTSILDUMUNOAVQDURIUOTIDUPUSQPUQAVHGUOZVJHUOZUTZUTBIVMVOWAVMV
      OUOAVSVTVHGVKVNVLVSVAVIVJHVBVCVDVEUAUBAVRVPUJULSBIVOLVFUSVG $.

    prdsvscafval.j $e |- ( ph -> J e. I ) $.
    $( Scalar multiplication of a single coordinate in a structure product.
       (Contributed by Stefan O'Rear, 10-Jan-2015.) $)
    prdsvscafval $p |- ( ph -> ( ( F .x. G ) ` J ) =
        ( F ( .s ` ( R ` J ) ) ( G ` J ) ) ) $=
      ( vx cv cfv cvsca cvv prdsvscaval wceq fveq2 fveq2d eqidd oveq123d adantl
      co wcel ovex a1i fvmptd ) AUDIFUDUEZGUFZVACUFZUGUFZUPZFIGUFZICUFZUGUFZUPZ
      HFGEUPUHAUDBCDEFGHJKLMNOPQRSTUAUBUIVAIUJZVEVIUJAVJFFVBVFVDVHVJVCVGUGVAICU
      KULVJFUMVAIGUKUNUOUCVIUHUQAFVFVHURUSUT $.
  $}

  ${
    $d y B $.  $d x y z F $.  $d x y z G $.  $d y ph $.  $d y S $.  $d y V $.
    $d x y z I $.  $d y z R $.  $d y W $.  $d y Y $.
    prdsbasmpt2.y $e |- Y = ( S Xs_ ( x e. I |-> R ) ) $.
    prdsbasmpt2.b $e |- B = ( Base ` Y ) $.
    prdsbasmpt2.s $e |- ( ph -> S e. V ) $.
    prdsbasmpt2.i $e |- ( ph -> I e. W ) $.
    prdsbasmpt2.r $e |- ( ph -> A. x e. I R e. X ) $.
    ${
      prdsbasmpt2.k $e |- K = ( Base ` R ) $.
      $( The base set of an indexed structure product.  (Contributed by Mario
         Carneiro, 13-Sep-2015.) $)
      prdsbas3 $p |- ( ph -> B = X_ x e. I K ) $=
        ( vy cfv cbs cv cmpt cixp wcel wral wfn eqid syl prdsbas2 nfcv nffvmpt1
        fnmpt nffv fveq2 fveq2d cbvixp syl6eq wa fvmpt2 syl6eqr ralimiaa ixpeq2
        wceq 3syl eqtrd ) ACBFBUAZBFDUBZSZTSZUCZBFGUCZACRFRUAZVGSZTSZUCVJARCVGE
        FHIKLMNOADJUDZBFUEZVGFUFPBFDVGJVGUGZULUHUIRBFVNVIBVMTBTUJBFDVLUKUMRVIUJ
        VLVFVCVMVHTVLVFVGUNUOUPUQAVPVIGVCZBFUEVJVKVCPVOVRBFVFFUDVOURZVIDTSGVSVH
        DTBFDJVGVQUSUOQUTVABFVIGVBVDVE $.

      $( A constructed tuple is a point in a structure product iff each
         coordinate is in the proper base set.  (Contributed by Mario Carneiro,
         3-Jul-2015.)  (Revised by Mario Carneiro, 13-Sep-2015.) $)
      prdsbasmpt2 $p |- ( ph ->
          ( ( x e. I |-> U ) e. B <-> A. x e. I U e. K ) ) $=
        ( cmpt wcel cixp wral prdsbas3 eleq2d wb mptelixpg syl bitrd ) ABGFSZCT
        UIBGHUAZTZFHTBGUBZACUJUIABCDEGHIJKLMNOPQRUCUDAGJTUKULUEPBGFHJUFUGUH $.

      prdsbascl.f $e |- ( ph -> F e. B ) $.
      $( An element of the base has projections closed in the factors.
         (Contributed by Mario Carneiro, 27-Aug-2015.) $)
      prdsbascl $p |- ( ph -> A. x e. I ( F ` x ) e. K ) $=
        ( wcel cfv cmpt wral wfn wceq eqid fnmpt prdsbasfn dffn5 sylib eqeltrrd
        cv syl prdsbasmpt2 mpbid ) ABGBULFUAZUBZCTUPHTBGUCAFUQCAFGUDFUQUEACBGDU
        BZEFGIJLMNOPADKTBGUCURGUDQBGDURKURUFUGUMSUHBGFUIUJSUKABCDEUPGHIJKLMNOPQ
        RUNUO $.
    $}

    prdsdsval2.f $e |- ( ph -> F e. B ) $.
    prdsdsval2.g $e |- ( ph -> G e. B ) $.
    ${
      prdsdsval2.e $e |- E = ( dist ` R ) $.
      prdsdsval2.d $e |- D = ( dist ` Y ) $.
      $( Value of the metric in a structure product.  (Contributed by Mario
         Carneiro, 20-Aug-2015.) $)
      prdsdsval2 $p |- ( ph -> ( F D G ) = sup ( ( ran ( x e. I |->
        ( ( F ` x ) E ( G ` x ) ) ) u. { 0 } ) , RR* , < ) ) $=
        ( vy co cv cfv cmpt cds crn cc0 csn cun cxr clt csup wcel wral wfn eqid
        fnmpt syl prdsdsval nfcv nffvmpt1 nffv nfov wceq fveq2d oveq123d cbvmpt
        fveq2 eqidd fvmpt2 syl6eqr oveqd ralimiaa mpteq12 syl2anc syl5eq uneq1d
        wa rneqd supeq1d eqtrd ) AHIDUEUDJUDUFZHUGZWFIUGZWFBJEUHZUGZUIUGZUEZUHZ
        UJZUKULZUMZUNUOUPBJBUFZHUGZWQIUGZGUEZUHZUJZWOUMZUNUOUPAUDCDWIFHIJKLNOPQ
        RAEMUQZBJURZWIJUSSBJEWIMWIUTZVAVBTUAUCVCAUNWPXCUOAWNXBWOAWMXAAWMBJWRWSW
        QWIUGZUIUGZUEZUHZXAUDBJWLXIBWGWHWKBWGVDBWJUIBUIVDBJEWFVEVFBWHVDVGUDXIVD
        WFWQVHZWGWRWHWSWKXHXKWJXGUIWFWQWIVLVIWFWQHVLWFWQIVLVJVKAJJVHXIWTVHZBJUR
        ZXJXAVHAJVMAXEXMSXDXLBJWQJUQXDWBZXHGWRWSXNXHEUIUGGXNXGEUIBJEMWIXFVNVIUB
        VOVPVQVBBJXIJWTVRVSVTWCWAWDWE $.
    $}

    ${
      prdsdsval3.k $e |- K = ( Base ` R ) $.
      prdsdsval3.e $e |- E = ( ( dist ` R ) |` ( K X. K ) ) $.
      prdsdsval3.d $e |- D = ( dist ` Y ) $.
      $( Value of the metric in a structure product.  (Contributed by Mario
         Carneiro, 27-Aug-2015.) $)
      prdsdsval3 $p |- ( ph -> ( F D G ) = sup ( ( ran ( x e. I |->
        ( ( F ` x ) E ( G ` x ) ) ) u. { 0 } ) , RR* , < ) ) $=
        ( co cv cfv cds cmpt crn cc0 csn cun cxr csup eqid prdsdsval2 wceq wral
        clt eqidd wcel prdsbascl wa cxp cres oveqi ovres syl5eq ex ral2imi sylc
        mpteq12 syl2anc rneqd uneq1d supeq1d eqtr4d ) AHIDUFBJBUGZHUHZVTIUHZEUI
        UHZUFZUJZUKZULUMZUNZUOVAUPBJWAWBGUFZUJZUKZWGUNZUOVAUPABCDEFWCHIJLMNOPQR
        STUAUBWCUQUEURAUOWLWHVAAWKWFWGAWJWEAJJUSWIWDUSZBJUTZWJWEUSAJVBAWAKVCZBJ
        UTWBKVCZBJUTWNABCEFHJKLMNOPQRSTUCUAVDABCEFIJKLMNOPQRSTUCUBVDWOWPWMBJWOW
        PWMWOWPVEWIWAWBWCKKVFVGZUFWDGWQWAWBUDVHWAWBKKWCVIVJVKVLVMBJWIJWDVNVOVPV
        QVRVS $.
    $}
  $}

  ${
    $d i r F $.  $d i r I $.  $d i r R $.
    pwsval.y $e |- Y = ( R ^s I ) $.
    pwsval.f $e |- F = ( Scalar ` R ) $.
    $( Value of a structure power.  (Contributed by Mario Carneiro,
       11-Jan-2015.) $)
    pwsval $p |- ( ( R e. V /\ I e. W ) -> Y = ( F Xs_ ( I X. { R } ) ) ) $=
      ( vr vi wcel wa cpws co csn cxp cprds cvv wceq csca elex cfv simpl fveq2d
      cv syl6eqr sneq xpeq12 syl2anr oveq12d df-pws ovex ovmpt2a syl2an syl5eq
      id ) ADKZCEKZLFACMNZBCAOZPZQNZGUQARKCRKUSVBSURADUACEUAIJACRRIUEZTUBZJUEZV
      COZPZQNVBMVCASZVECSZLZVDBVGVAQVJVDATUBBVJVCATVHVIUCUDHUFVIVIVFUTSVGVASVHV
      IUPVCAUGVECVFUTUHUIUJJIUKBVAQULUMUNUO $.
  $}

  ${
    $d x I $.  $d x R $.  $d x V $.  $d x W $.
    pwsbas.y $e |- Y = ( R ^s I ) $.
    pwsbas.f $e |- B = ( Base ` R ) $.
    $( Base set of a structure power.  (Contributed by Mario Carneiro,
       11-Jan-2015.) $)
    pwsbas $p |- ( ( R e. V /\ I e. W ) -> ( B ^m I ) = ( Base ` Y ) ) $=
      ( vx wcel wa cbs cfv csca co cixp cmap eqid cvv wceq csn cxp cprds pwsval
      fveq2d cv fvex a1i simpr snex xpexg sylancl wne cdm snnzg adantr dmxp syl
      c0 prdsbas wral fvconst2g ralrimiva ixpeq2 eqtrd ixpconstg oveq1i syl6eqr
      3eqtrrd ) BDJZCEJZKZFLMBNMZCBUAZUBZUCOZLMZICBLMZPZACQOZVLFVPLBVMCDEFGVMRU
      DUEVLVQICIUFZVOMZLMZPZVSVLIVQVPVOVMCSSVPRVMSJVLBNUGUHVLVKVNSJVOSJVJVKUIZB
      UJCVNESUKULVQRVLVNUSUMZVOUNCTVJWFVKBDUOUPCVNUQURUTVLWCVRTZICVAZWDVSTVJWHV
      KVJWGICVJWACJKWBBLCBWADVBUEVCUPICWCVRVDURVEVLVSVRCQOZVTVLVKVRSJVSWITWEBLU
      GICVRESVFULAVRCQHVGVHVI $.

    pwselbas.v $e |- V = ( Base ` Y ) $.
    $( Membership in the base set of a structure product.  (Contributed by
       Stefan O'Rear, 24-Jan-2015.) $)
    pwselbasb $p |- ( ( R e. W /\ I e. Z ) -> ( X e. V <-> X : I --> B ) ) $=
      ( wcel wa cmap co wf cbs cfv pwsbas cvv syl6eqr eleq2d fvex elmapg adantl
      wb eqeltri mpan bitr3d ) BELZCHLZMZFACNOZLZFDLCAFPZULUMDFULUMGQRDABCEHGIJ
      SKUAUBUKUNUOUFZUJATLUKUPABQRTJBQUCUGACFTHUDUHUEUI $.

    pwselbas.r $e |- ( ph -> R e. W ) $.
    pwselbas.i $e |- ( ph -> I e. Z ) $.
    pwselbas.x $e |- ( ph -> X e. V ) $.
    $( An element of a structure power is a function from the index set to the
       base set of the structure.  (Contributed by Mario Carneiro,
       11-Jan-2015.)  (Revised by Mario Carneiro, 5-Jun-2015.) $)
    pwselbas $p |- ( ph -> X : I --> B ) $=
      ( wcel wf wb pwselbasb syl2anc mpbid ) AGEPZDBGQZOACFPDIPUBUCRMNBCDEFGHIJ
      KLSTUA $.
  $}

  ${
    $d x .+ $.  $d x F $.  $d x G $.  $d x I $.  $d x ph $.  $d x .x. $.
    $d x R $.  $d x W $.
    pwsplusgval.y $e |- Y = ( R ^s I ) $.
    pwsplusgval.b $e |- B = ( Base ` Y ) $.
    pwsplusgval.r $e |- ( ph -> R e. V ) $.
    pwsplusgval.i $e |- ( ph -> I e. W ) $.
    pwsplusgval.f $e |- ( ph -> F e. B ) $.
    pwsplusgval.g $e |- ( ph -> G e. B ) $.
    ${
      pwsplusgval.a $e |- .+ = ( +g ` R ) $.
      pwsplusgval.p $e |- .+b = ( +g ` Y ) $.
      $( Value of addition in a structure power.  (Contributed by Mario
         Carneiro, 11-Jan-2015.) $)
      pwsplusgval $p |- ( ph -> ( F .+b G ) = ( F oF .+ G ) ) $=
        ( cfv vx csca csn cxp cprds co cplusg cv cmpt cof cbs cvv eqid wcel a1i
        fvex wfn fnconstg syl pwsval syl2anc fveq2d syl5eq eleqtrd prdsplusgval
        wceq wa fvconst2g sylan syl6eqr oveqd mpteq2dva feqmptd offval2 3eqtr4d
        eqtrd pwselbas ) AFGEUBTZHEUCUDZUEUFZUGTZUFZUAHUAUHZFTZWCGTZCUFZUIZFGDU
        FFGCUJUFAWBUAHWDWEWCVSTZUGTZUFZUIWGAUAVTUKTZWAVSVRFGHULJVTVTUMWKUMVRULU
        NAEUBUPUOOAEIUNZVSHUQNHEIURUSAFBWKPABKUKTWKMAKVTUKAWLHJUNKVTVFNOEVRHIJK
        LVRUMUTVAZVBVCZVDAGBWKQWNVDWAUMVEAUAHWJWFAWCHUNZVGZWICWDWEWPWIEUGTCWPWH
        EUGAWLWOWHEVFNHEWCIVHVIVBRVJVKVLVPADWAFGADKUGTWASAKVTUGWMVBVCVKAUAHWDWE
        CFGJULULOWDULUNWPWCFUPUOWEULUNWPWCGUPUOAUAHEUKTZFAWQEHBIFKJLWQUMZMNOPVQ
        VMAUAHWQGAWQEHBIGKJLWRMNOQVQVMVNVO $.
    $}

    ${
      pwsmulrval.a $e |- .x. = ( .r ` R ) $.
      pwsmulrval.p $e |- .xb = ( .r ` Y ) $.
      $( Value of multiplication in a structure power.  (Contributed by Mario
         Carneiro, 11-Jan-2015.) $)
      pwsmulrval $p |- ( ph -> ( F .xb G ) = ( F oF .x. G ) ) $=
        ( cfv vx csca csn cxp cprds co cmulr cv cmpt cof cbs cvv eqid wcel fvex
        a1i wfn fnconstg syl pwsval syl2anc fveq2d syl5eq prdsmulrval fvconst2g
        eleqtrd wa sylan syl6eqr oveqd mpteq2dva eqtrd pwselbas feqmptd offval2
        wceq 3eqtr4d ) AFGCUBTZHCUCUDZUEUFZUGTZUFZUAHUAUHZFTZWCGTZEUFZUIZFGDUFF
        GEUJUFAWBUAHWDWEWCVSTZUGTZUFZUIWGAUAVTUKTZVSVRWAFGHULJVTVTUMWKUMVRULUNA
        CUBUOUPOACIUNZVSHUQNHCIURUSAFBWKPABKUKTWKMAKVTUKAWLHJUNKVTVPNOCVRHIJKLV
        RUMUTVAZVBVCZVFAGBWKQWNVFWAUMVDAUAHWJWFAWCHUNZVGZWIEWDWEWPWICUGTEWPWHCU
        GAWLWOWHCVPNHCWCIVEVHVBRVIVJVKVLADWAFGADKUGTWASAKVTUGWMVBVCVJAUAHWDWEEF
        GJULULOWDULUNWPWCFUOUPWEULUNWPWCGUOUPAUAHCUKTZFAWQCHBIFKJLWQUMZMNOPVMVN
        AUAHWQGAWQCHBIGKJLWRMNOQVMVNVOVQ $.
    $}
  $}


  ${
    $d f g x B $.  $d f g x I $.  $d f g x O $.  $d f g x R $.  $d f g x V $.
    $d x F $.  $d x G $.  $d x ph $.  $d f g x W $.
    pwsle.y $e |- Y = ( R ^s I ) $.
    pwsle.v $e |- B = ( Base ` Y ) $.
    pwsle.o $e |- O = ( le ` R ) $.
    pwsle.l $e |- .<_ = ( le ` Y ) $.
    $( Ordering in a structure power.  (Contributed by Mario Carneiro,
       16-Aug-2015.) $)
    pwsle $p |- ( ( R e. V /\ I e. W ) -> .<_ = ( oR O i^i ( B X. B ) ) ) $=
      ( vf vg vx wcel wa cfv cple cvv cv cpr csca csn cxp cprds co cbs wss wral
      wbr cofr cin vex prss eqid pwsval fveq2d syl5eq sseq2d syl5bb anbi1d wceq
      copab simpll fvconst2g sylan breqd ralbidva wf wfn simplr simprl pwselbas
      syl6eqr ffn syl simprr inidm eqidd ofrfval bitr4d pm5.32da brinxp2 df-3an
      w3a bitri syl6bbr bitr3d opabbidv fvex a1i simpr xpexg sylancl c0 wne cdm
      snex snnzg adantr dmxp prdsle eqtrd inss2 relxp relss mp2 dfrel4v 3eqtr4d
      wrel sylib ) BFPZCGPZQZMUAZNUAZUBZBUCRZCBUDZUEZUFUGZUHRZUIZOUAZXPRZYEXQRZ
      YEYARZSRZUKZOCUJZQZMNVDZXPXQEULZAAUEZUMZUKZMNVDZDYPXOYLYQMNXOXPAPZXQAPZQZ
      YKQZYLYQXOUUAYDYKUUAXRAUIXOYDXPXQAMUNNUNUOXOAYCXRXOAHUHRYCJXOHYBUHBXSCFGH
      IXSUPUQZURUSUTVAVBXOUUBUUAXPXQYNUKZQZYQXOUUAYKUUDXOUUAQZYKYFYGEUKZOCUJUUD
      UUFYJUUGOCUUFYECPZQZYIEYFYGUUIYIBSREUUIYHBSUUFXMUUHYHBVCXMXNUUAVEZCBYEFVF
      VGURKVOVHVIUUFOCCYFYGECXPXQGGUUFCBUHRZXPVJXPCVKUUFUUKBCAFXPHGIUUKUPZJUUJX
      MXNUUAVLZXOYSYTVMVNCUUKXPVPVQUUFCUUKXQVJXQCVKUUFUUKBCAFXQHGIUULJUUJUUMXOY
      SYTVRVNCUUKXQVPVQUUMUUMCVSUUIYFVTUUIYGVTWAWBWCYQYSYTUUDWFUUEXPXQAAYNWDYSY
      TUUDWEWGWHWIWJXODYBSRZYMXODHSRUUNLXOHYBSUUCURUSXOOYCYBYAXSMNCUUNTTYBUPXST
      PXOBUCWKWLXOXNXTTPYATPXMXNWMBWSCXTGTWNWOYCUPXOXTWPWQZYAWRCVCXMUUOXNBFWTXA
      CXTXBVQUUNUPXCXDXOYPXKZYPYRVCUUPXOYPYOUIYOXKUUPYNYOXEAAXFYPYOXGXHWLMNYPXI
      XLXJ $.

    pwsleval.r $e |- ( ph -> R e. V ) $.
    pwsleval.i $e |- ( ph -> I e. W ) $.
    pwsleval.a $e |- ( ph -> F e. B ) $.
    pwsleval.b $e |- ( ph -> G e. B ) $.
    $( Ordering in a structure power.  (Contributed by Mario Carneiro,
       16-Aug-2015.) $)
    pwsleval $p |- ( ph -> ( F .<_ G <-> A. x e. I ( F ` x ) O ( G ` x ) ) ) $=
      ( wbr cofr cxp cin cv cfv wral wcel wceq pwsle syl2anc breqd wb brinxp wf
      cbs wfn eqid pwselbas ffn syl inidm wa eqidd ofrfval 3bitr2d ) AEFHUAEFIU
      BZCCUCUDZUAZEFVGUAZBUEZEUFZVKFUFZIUABGUGAHVHEFADJUHGKUHHVHUIQRCDGHIJKLMNO
      PUJUKULAECUHFCUHVJVIUMSTEFCCVGUNUKABGGVLVMIGEFKKAGDUPUFZEUOEGUQAVNDGCJELK
      MVNURZNQRSUSGVNEUTVAAGVNFUOFGUQAVNDGCJFLKMVONQRTUSGVNFUTVARRGVBAVKGUHVCZV
      LVDVPVMVDVEVF $.
  $}

  ${
    $d x A $.  $d x F $.  $d x I $.  $d x K $.  $d x R $.  $d x W $.  $d x X $.
    $d x ph $.  $d x .x. $.
    pwsvscaval.y $e |- Y = ( R ^s I ) $.
    pwsvscaval.b $e |- B = ( Base ` Y ) $.
    pwsvscaval.s $e |- .x. = ( .s ` R ) $.
    pwsvscaval.t $e |- .xb = ( .s ` Y ) $.
    pwsvscaval.f $e |- F = ( Scalar ` R ) $.
    pwsvscaval.k $e |- K = ( Base ` F ) $.
    pwsvscaval.r $e |- ( ph -> R e. V ) $.
    pwsvscaval.i $e |- ( ph -> I e. W ) $.
    pwsvscaval.a $e |- ( ph -> A e. K ) $.
    pwsvscaval.x $e |- ( ph -> X e. B ) $.
    $( Scalar multiplication in a structure power is pointwise.  (Contributed
       by Mario Carneiro, 11-Jan-2015.) $)
    pwsvscafval $p |- ( ph -> ( A .xb X ) = ( ( I X. { A } ) oF .x. X ) ) $=
      ( vx co csn cxp cprds cvsca cfv cv cmpt wcel pwsval syl2anc fveq2d syl5eq
      cof wceq oveqd cbs cvv eqid csca eqeltri a1i wfn fnconstg syl prdsvscaval
      fvex eleqtrd wa fvconst2g sylan syl6eqr mpteq2dva adantr pwselbas feqmptd
      fconstmpt offval2 eqtr4d 3eqtrd ) ABLEUEBLGHDUFUGZUHUEZUIUJZUEUDHBUDUKZLU
      JZWHWEUJZUIUJZUEZULZHBUFUGZLFURUEZAEWGBLAEMUIUJWGQAMWFUIADJUMZHKUMMWFUSTU
      ADGHJKMNRUNUOZUPUQUTAUDWFVAUJZWEGWGBLHIVBKWFWFVCWRVCWGVCSGVBUMAGDVDUJVBRD
      VDVKVEVFUAAWPWEHVGTHDJVHVIUBALCWRUCACMVAUJWROAMWFVAWQUPUQVLVJAWMUDHBWIFUE
      ZULWOAUDHWLWSAWHHUMZVMZWKFBWIXAWKDUIUJFXAWJDUIAWPWTWJDUSTHDWHJVNVOUPPVPUT
      VQAUDHBWIFWNLKIVBUAABIUMWTUBVRWIVBUMXAWHLVKVFWNUDHBULUSAUDHBWAVFAUDHDVAUJ
      ZLAXBDHCJLMKNXBVCOTUAUCVSVTWBWCWD $.

    pwsvscaval.j $e |- ( ph -> J e. I ) $.
    $( Scalar multiplication of a single coordinate in a structure power.
       (Contributed by Mario Carneiro, 11-Jan-2015.) $)
    pwsvscaval $p |- ( ph -> ( ( A .xb X ) ` J ) = ( A .x. ( X ` J ) ) ) $=
      ( co cfv csn cxp cof pwsvscafval fveq1d wcel wceq cbs wf wfn pwselbas ffn
      eqid syl wa eqidd ofc1 mpdan eqtrd ) AIBMEUFZUGIHBUHUIMFUJUFZUGZBIMUGZFUF
      ZAIVGVHABCDEFGHJKLMNOPQRSTUAUBUCUDUKULAIHUMZVIVKUNUEAHBVJFMLJIUBUCAHDUOUG
      ZMUPMHUQAVMDHCKMNLOVMUTPUAUBUDURHVMMUSVAAVLVBVJVCVDVEVF $.
  $}

  ${
    pwssca.y $e |- Y = ( R ^s I ) $.
    pwssca.s $e |- S = ( Scalar ` R ) $.
    $( The ring of scalars of a structure product.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    pwssca $p |- ( ( R e. V /\ I e. W ) -> S = ( Scalar ` Y ) ) $=
      ( wcel wa csn cxp cprds co csca cfv cvv eqid fvex eqeltri a1i simpr xpexg
      snex sylancl prdssca pwsval fveq2d eqtr4d ) ADIZCEIZJZBBCAKZLZMNZOPFOPULU
      OUNBQQUORBQIULBAOPQHAOSTUAULUKUMQIUNQIUJUKUBAUDCUMEQUCUEUFULFUOOABCDEFGHU
      GUHUI $.
  $}

  ${
    pwsdiagel.y $e |- Y = ( R ^s I ) $.
    pwsdiagel.b $e |- B = ( Base ` R ) $.
    pwsdiagel.c $e |- C = ( Base ` Y ) $.
    $( Membership of diagonal elements in the structure power base set.
       (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    pwsdiagel $p |- ( ( ( R e. V /\ I e. W ) /\ A e. B ) ->
        ( I X. { A } ) e. C ) $=
      ( wcel wa csn cxp wf fconst6g adantl wb pwselbasb adantr mpbird ) DFLEGLM
      ZABLZMEANOZCLZEBUEPZUDUGUCEABQRUCUFUGSUDBDECFUEHGIJKTUAUB $.
  $}

  ${
    $d Y x $.  $d R x $.  $d I x $.  $d B x $.  $d C x $.  $d W x $.
    pwssnf1o.y $e |- Y = ( R ^s { I } ) $.
    pwssnf1o.b $e |- B = ( Base ` R ) $.
    pwssnf1o.f $e |- F = ( x e. B |-> ( { I } X. { x } ) ) $.
    pwssnf1o.c $e |- C = ( Base ` Y ) $.
    $( Triviality of singleton powers: set equipollence.  (Contributed by
       Stefan O'Rear, 24-Jan-2015.) $)
    pwssnf1o $p |- ( ( R e. V /\ I e. W ) -> F : B -1-1-onto-> C ) $=
      ( wcel wa wf1o cvv cbs cfv wceq csn cmap co fvex eqeltri mapsnf1o sylancr
      simpr wb snex pwsbas mpan2 adantr syl6reqr f1oeq3 syl mpbird ) DGNZFHNZOZ
      BCEPZBBFUAZUBUCZEPZUTBQNUSVDBDRSQKDRUDUEURUSUHABEFQHLUFUGUTCVCTVAVDUIUTVC
      IRSZCURVCVETZUSURVBQNVFFUJBDVBGQIJKUKULUMMUNCVCBEUOUPUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Definition of the structure quotient
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ordTop $.
  $c RR*s $.
  $c 0g $.
  $c gsum $.

  $( Extend class notation with the order topology. $)
  cordt $a class ordTop $.

  $( Extend class notation with the extended real number structure. $)
  cxrs $a class RR*s $.

  $( Extend class notation with group identity element. $)
  c0g $a class 0g $.

  $( Extend class notation to include finitely supported group sums. $)
  cgsu $a class gsum $.

  ${
    $d r x y z $.
    $( Define the order topology, given an order ` <_ ` , written as ` r `
       below.  A closed subbasis for the order topology is given by the closed
       rays ` [ y , +oo ) = { z e. X | y <_ z } ` and
       ` ( -oo , y ] = { z e. X | z <_ y } ` , along with ` ( -oo , +oo ) = X `
       itself.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    df-ordt $a |- ordTop = ( r e. _V |-> ( topGen ` ( fi ` ( { dom r } u. ran
       ( ( x e. dom r |-> { y e. dom r | -. y r x } ) u.
         ( x e. dom r |-> { y e. dom r | -. x r y } ) ) ) ) ) ) $.

    $( The extended real number structure.  Unlike ~ df-cnfld , the extended
       real numbers do not have good algebraic properties, so this is not
       actually a group or anything higher, even though it has just as many
       operations as ~ df-cnfld .  The main interest in this structure is in
       its ordering, which is complete and compact.  The metric described here
       is an extension of the absolute value metric, but it is not itself a
       metric because ` +oo ` is infinitely far from all other points.  The
       topology is based on the order and not the extended metric (which would
       make ` +oo ` an isolated point since there is nothing else in the ` 1 `
       -ball around it).  All components of this structure agree with ` CCfld `
       when restricted to ` RR ` .  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    df-xrs $a |- RR*s = ( { <. ( Base ` ndx ) , RR* >. ,
        <. ( +g ` ndx ) , +e >. , <. ( .r ` ndx ) , *e >. } u.
        { <. ( TopSet ` ndx ) , ( ordTop ` <_ ) >. ,
          <. ( le ` ndx ) , <_ >. ,
          <. ( dist ` ndx ) , ( x e. RR* , y e. RR* |->
            if ( x <_ y , ( y +e -e x ) , ( x +e -e y ) ) ) >. } ) $.
  $}

  ${
    $d e f g j m n o w x y z $.
    $( Define group identity element.  (Contributed by NM, 20-Aug-2011.) $)
    df-0g $a |- 0g = ( g e. _V |-> ( iota e ( e e. ( Base ` g ) /\
      A. x e. ( Base ` g )
        ( ( e ( +g ` g ) x ) = x /\ ( x ( +g ` g ) e ) = x ) ) ) ) $.

    $( Define the group sum for the structure ` G ` of a finite sequence of
       elements whose values are defined by the expression ` B ` and whose set
       of indices is ` A ` .  It may be viewed as a product (if ` G ` is a
       multiplication), a sum (if ` G ` is an addition) or whatever.  The
       variable ` k ` is normally a free variable in ` B ` ( i.e. ` B ` can be
       thought of as ` B ( k ) ` ).  The definition is meaningful in three
       contexts, depending on the size of the index set ` A ` and each
       demanding different properties of ` G ` .

       1.  If ` A = (/) ` and ` G ` has an identity element, then the sum
       equals this identity.

       2.  If ` A = ( M ... N ) ` and ` G ` is any magma, then the sum is the
       sum of the elements, evaluated left-to-right, i.e.
       ` ( B ( 1 ) + B ( 2 ) ) + B ( 3 ) ` etc.

       3.  If ` A ` is a finite set (or is non-zero for finitely many indices)
       and ` G ` is a commutative monoid, then the sum adds up these elements
       in some order, which is then uniquely defined.

       4.  If ` A ` is an infinite set and ` G ` is a Hausdorff topological
       group, then there is a meaningful sum, but ` gsum ` cannot handle this
       case.  See ~ df-tsms .  (Contributed by FL, 5-Sep-2010.)  (Revised by
       FL, 17-Oct-2011.)  (Revised by Mario Carneiro, 7-Dec-2014.) $)
    df-gsum $a |- gsum = ( w e. _V , f e. _V |-> [_ { x e. ( Base ` w ) |
        A. y e. ( Base ` w )
          ( ( x ( +g ` w ) y ) = y /\ ( y ( +g ` w ) x ) = y ) } / o ]_
      if ( ran f C_ o , ( 0g ` w ) ,
      if ( dom f e. ran ... ,
        ( iota x E. m E. n e. ( ZZ>= ` m ) ( dom f = ( m ... n ) /\
          x = ( seq m ( ( +g ` w ) , f ) ` n ) ) ) ,
      ( iota x E. g [. ( `' f " ( _V \ o ) ) / y ].
        ( g : ( 1 ... ( # ` y ) ) -1-1-onto-> y /\
          x = ( seq 1 ( ( +g ` w ) , ( f o. g ) ) ` ( # ` y ) ) ) ) ) ) ) $.
  $}

  $c "s $. $( Image structure $)
  $c /s $. $( Quotient structure $)
  $c qTop $. $( Quotient topology $)
  $c Xs. $. $( Binary structure $)

  $( Extend class notation with the quotient topology function. $)
  cqtop $a class qTop $.

  $( Image structure function. $)
  cimas $a class "s $.

  $( Quotient structure function. $)
  cqus $a class /s $.

  $( Binary product structure function. $)
  cxps $a class Xs. $.

  ${
    $d e f g h i j n p q r s v x y $.
    $( Define the quotient topology given a function ` f ` and topology ` j `
       on the domain of ` f ` .  (Contributed by Mario Carneiro,
       23-Mar-2015.) $)
    df-qtop $a |- qTop = ( j e. _V , f e. _V |->
       { s e. ~P ( f " U. j ) | ( ( `' f " s ) i^i U. j ) e. j } ) $.

    $( Define an image structure, which takes a structure and a function on the
       base set, and maps all the operations via the function.  For this to
       work properly ` f ` must either be injective or satisfy the
       well-definedness condition ` f ( a ) = f ( c ) /\ f ( b ) = f ( d ) -> `
       ` f ( a + b ) = f ( c + d ) ` for each relevant operation.

       Note that although we call this an "image" by association to ~ df-ima ,
       in order to keep the definition simple we consider only the case when
       the domain of ` F ` is equal to the base set of ` R ` .  Other cases can
       be achieved by restricting ` F ` (with ~ df-res ) and/or ` R ` ( with
       ~ df-ress ) to their common domain.  (Contributed by Mario Carneiro,
       23-Feb-2015.) $)
    df-imas $a |- "s = ( f e. _V , r e. _V |-> [_ ( Base ` r ) / v ]_
  ( ( { <. ( Base ` ndx ) , ran f >. ,
        <. ( +g ` ndx ) , U_ p e. v U_ q e. v
     { <. <. ( f ` p ) , ( f ` q ) >. , ( f ` ( p ( +g ` r ) q ) ) >. } >. ,
        <. ( .r ` ndx ) , U_ p e. v U_ q e. v
     { <. <. ( f ` p ) , ( f ` q ) >. , ( f ` ( p ( .r ` r ) q ) ) >. } >. } u.
      { <. ( Scalar ` ndx ) , ( Scalar ` r ) >. ,
        <. ( .s ` ndx ) , U_ q e. v ( p e. ( Base ` ( Scalar ` r ) ) ,
           x e. { ( f ` q ) } |-> ( f ` ( p ( .s ` r ) q ) ) ) >. } ) u.
      { <. ( TopSet ` ndx ) , ( ( TopOpen ` r ) qTop f ) >. ,
        <. ( le ` ndx ) , ( ( f o. ( le ` r ) ) o. `' f ) >. ,
        <. ( dist ` ndx ) , ( x e. ran f , y e. ran f |-> sup ( U_ n e. NN
         ran ( g e. { h e. ( ( v X. v ) ^m ( 1 ... n ) ) |
        ( ( f ` ( 1st ` ( h ` 1 ) ) ) = x /\ ( f ` ( 2nd ` ( h ` n ) ) ) = y /\
         A. i e. ( 1 ... ( n - 1 ) ) ( f ` ( 2nd ` ( h ` i ) ) ) =
           ( f ` ( 1st ` ( h ` ( i + 1 ) ) ) ) ) } |->
           ( RR*s gsum ( ( dist ` r ) o. g ) ) ) , RR* , `' < ) ) >. } ) ) $.

    $( Define a quotient ring (or quotient group), which is a special case of
       an image structure ~ df-imas where the image function is
       ` x |-> [ x ] e ` .  (Contributed by Mario Carneiro, 23-Feb-2015.) $)
    df-divs $a |- /s = ( r e. _V , e e. _V |->
      ( ( x e. ( Base ` r ) |-> [ x ] e ) "s r ) ) $.

    $( Define a binary product on structures.  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    df-xps $a |- Xs. = ( r e. _V , s e. _V |->
      ( `' ( x e. ( Base ` r ) , y e. ( Base ` s ) |-> `' ( { x } +c { y } ) )
        "s ( ( Scalar ` r ) Xs_ `' ( { r } +c { s } ) ) ) ) $.
  $}

  ${
    $d f r v .<_ $.  $d f r v B $.  $d f r v D $.  $d f r v G $.  $d f r v O $.
    $d f g h i n p q r v x y F $.  $d f g h i n p q r v x y R $.  $d h p q V $.
    $d f r v .+b $.  $d f g h i n p q r v x y ph $.  $d f r v .(x) $.
    $d f r v .xb $.
    imasval.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasval.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasval.p $e |- .+ = ( +g ` R ) $.
    imasval.m $e |- .X. = ( .r ` R ) $.
    imasval.g $e |- G = ( Scalar ` R ) $.
    imasval.k $e |- K = ( Base ` G ) $.
    imasval.q $e |- .x. = ( .s ` R ) $.
    imasval.j $e |- J = ( TopOpen ` R ) $.
    imasval.e $e |- E = ( dist ` R ) $.
    imasval.n $e |- N = ( le ` R ) $.
    imasval.a $e |- ( ph -> .+b = U_ p e. V U_ q e. V
     { <. <. ( F ` p ) , ( F ` q ) >. , ( F ` ( p .+ q ) ) >. } ) $.
    imasval.t $e |- ( ph -> .xb = U_ p e. V U_ q e. V
     { <. <. ( F ` p ) , ( F ` q ) >. , ( F ` ( p .X. q ) ) >. } ) $.
    imasval.s $e |- ( ph -> .(x) = U_ q e. V ( p e. K ,
           x e. { ( F ` q ) } |-> ( F ` ( p .x. q ) ) ) ) $.
    imasval.o $e |- ( ph -> O = ( J qTop F ) ) $.
    imasval.d $e |- ( ph -> D = ( x e. B , y e. B |-> sup ( U_ n e. NN
         ran ( g e. { h e. ( ( V X. V ) ^m ( 1 ... n ) ) |
        ( ( F ` ( 1st ` ( h ` 1 ) ) ) = x /\ ( F ` ( 2nd ` ( h ` n ) ) ) = y /\
         A. i e. ( 1 ... ( n - 1 ) ) ( F ` ( 2nd ` ( h ` i ) ) ) =
           ( F ` ( 1st ` ( h ` ( i + 1 ) ) ) ) ) } |->
         ( RR*s gsum ( E o. g ) ) ) , RR* , `' < ) ) ) $.
    imasval.l $e |- ( ph -> .<_ = ( ( F o. N ) o. `' F ) ) $.
    imasval.f $e |- ( ph -> F : V -onto-> B ) $.
    imasval.r $e |- ( ph -> R e. Z ) $.
    $( Value of an image structure.  (Contributed by Mario Carneiro,
       23-Feb-2015.)  (Revised by Mario Carneiro, 11-Jul-2015.) $)
    imasval $p |- ( ph -> U = ( ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+b >. , <. ( .r ` ndx ) , .xb >. } u.
        { <. ( Scalar ` ndx ) , G >. , <. ( .s ` ndx ) , .(x) >. } ) u.
        { <. ( TopSet ` ndx ) , O >. , <. ( le ` ndx ) , .<_ >. ,
        <. ( dist ` ndx ) , D >. } ) ) $=
      ( vf vr vv cimas cnx cbs cfv cop cplusg cmulr ctp csca cvsca cpr cun cple
      co cts cds cvv cv crn csn ciun cmpt2 ctopn cqtop ccom ccnv c1st wceq c2nd
      cn caddc cfz wral w3a cxp cmap crab cxrs cgsu cmpt cxr csup a1i wcel fvex
      c1 wa rneqd syl ad2antrr eqtrd opeq2d fveq2d 3eqtr4d fveq1d opeq12d oveqd
      syl6eqr fveq12d sneqd iuneq12d eqtr4d mpt2eq123dv iuneq2d uneq12d coeq12d
      tpeq123d eqeq1d tpex unex cmin clt csb df-imas simplrl forn simplrr simpr
      iuneq1d preq12d oveq12d cnveqd xpeq12d oveq1d eqeq12d 3anbi123d rabeqbidv
      wfo ralbidv coeq1d oveq2d mpteq12dv supeq1d fof syl6eqel fex syl2anc elex
      csbied wf prex ovmpt2d ) AMSHVKWDVLVMVNZDVOZVLVPVNZGVOZVLVQVNZIVOZVRZVLVS
      VNZTVOZVLVTVNZLVOZWAZWBZVLWEVNZUEVOZVLWCVNZUCVOZVLWFVNZEVOZVRZWBZUJAVHVIS
      HWGWGVJVIWHZVMVNZUVMVHWHZWIZVOZUVOUIVJWHZUHUWSUIWHZUWPVNZUHWHZUWPVNZVOZUW
      TUXBUWNVPVNZWDZUWPVNZVOZWJZWKZWKZVOZUVQUIUWSUHUWSUXDUWTUXBUWNVQVNZWDZUWPV
      NZVOZWJZWKZWKZVOZVRZUVTUWNVSVNZVOZUWBUHUWSUIBUYBVMVNZUXCWJZUWTUXBUWNVTVNZ
      WDZUWPVNZWLZWKZVOZWAZWBZUWFUWNWMVNZUWPWNWDZVOZUWHUWPUWNWCVNZWOZUWPWPZWOZV
      OZUWJBCUWQUWQQWTNXPOWHZVNWQVNZUWPVNZBWHZWRZQWHZVUBVNWSVNZUWPVNZCWHZWRZPWH
      ZVUBVNWSVNZUWPVNZVULXPXAWDVUBVNWQVNZUWPVNZWRZPXPVUGXPUUAWDXBWDZXCZXDZOUWS
      UWSXEZXPVUGXBWDZXFWDZXGZXHUWNWFVNZNWHZWOZXIWDZXJZWIZWKZXKUUBWPZXLZWLZVOZV
      RZWBZUUCZUWMVKWGVKVHVIWGWGVVRWLWRABCVJVHNOPQVIUHUIUUDXMAUWPSWRZUWNHWRZXQZ
      XQZVJUWOVVQUWMWGUWOWGXNVWBUWNVMXOXMVWBUWSUWOWRZXQZUYMUWEVVPUWLVWDUYAUVSUY
      LUWDVWDUWRUVNUXLUVPUXTUVRVWDUWQDUVMVWDUWQSWIZDVWDUWPSAVVSVVTVWCUUEZXRAVWE
      DWRZVWAVWCAUFDSUURZVWGVFUFDSUUFXSXTYAZYBVWDUXKGUVOVWDUXKUIUFUHUFUWTSVNZUX
      BSVNZVOZUWTUXBFWDZSVNZVOZWJZWKZWKZGVWDUIUWSUFUXJVWQVWDUWOHVMVNZUWSUFVWDUW
      NHVMAVVSVVTVWCUUGZYCVWBVWCUUHAUFVWSWRVWAVWCUKXTYDZVWDUHUWSUFUXIVWPVXAVWDU
      XHVWOVWDUXDVWLUXGVWNVWDUXAVWJUXCVWKVWDUWTUWPSVWFYEVWDUXBUWPSVWFYEZYFZVWDU
      XFVWMUWPSVWFVWDUXEFUWTUXBVWDUXEHVPVNFVWDUWNHVPVWTYCULYHYGYIYFYJYKYKAGVWRW
      RVWAVWCUTXTYLYBVWDUXSIUVQVWDUXSUIUFUHUFVWLUWTUXBKWDZSVNZVOZWJZWKZWKZIVWDU
      IUWSUFUXRVXHVXAVWDUHUWSUFUXQVXGVXAVWDUXPVXFVWDUXDVWLUXOVXEVXCVWDUXNVXDUWP
      SVWFVWDUXMKUWTUXBVWDUXMHVQVNKVWDUWNHVQVWTYCUMYHYGYIYFYJYKYKAIVXIWRVWAVWCV
      AXTYLYBYQVWDUYCUWAUYKUWCVWDUYBTUVTVWDUYBHVSVNTVWDUWNHVSVWTYCUNYHZYBVWDUYJ
      LUWBVWDUHUFUYIWKUHUFUIBUBVWKWJZUWTUXBJWDZSVNZWLZWKZUYJLVWDUHUFUYIVXNVWDUI
      BUYDUYEUYHUBVXKVXMVWDUYDTVMVNUBVWDUYBTVMVXJYCUOYHVWDUXCVWKVXBYJVWDUYGVXLU
      WPSVWFVWDUYFJUWTUXBVWDUYFHVTVNJVWDUWNHVTVWTYCUPYHYGYIYMYNVWDUHUWSUFUYIVXA
      UUIALVXOWRVWAVWCVBXTYDYBUUJYOVWDUYPUWGVUAUWIVVOUWKVWDUYOUEUWFVWDUYOUASWNW
      DZUEVWDUYNUAUWPSWNVWDUYNHWMVNUAVWDUWNHWMVWTYCUQYHVWFUUKAUEVXPWRVWAVWCVCXT
      YLYBVWDUYTUCUWHVWDUYTSUDWOZSWPZWOZUCVWDUYRVXQUYSVXRVWDUWPSUYQUDVWFVWDUYQH
      WCVNUDVWDUWNHWCVWTYCUSYHYPVWDUWPSVWFUULYPAUCVXSWRVWAVWCVEXTYLYBVWDVVNEUWJ
      VWDVVNBCDDQWTNVUCSVNZVUEWRZVUHSVNZVUJWRZVUMSVNZVUOSVNZWRZPVURXCZXDZOUFUFX
      EZVVBXFWDZXGZXHRVVFWOZXIWDZXJZWIZWKZXKVVLXLZWLZEVWDBCUWQUWQVVMDDVYQVWIVWI
      VWDXKVVKVYPVVLVWDQWTVVJVYOVWDVVIVYNVWDNVVDVVHVYKVYMVWDVUTVYHOVVCVYJVWDVVA
      VYIVVBXFVWDUWSUFUWSUFVXAVXAUUMUUNVWDVUFVYAVUKVYCVUSVYGVWDVUDVXTVUEVWDVUCU
      WPSVWFYEYRVWDVUIVYBVUJVWDVUHUWPSVWFYEYRVWDVUQVYFPVURVWDVUNVYDVUPVYEVWDVUM
      UWPSVWFYEVWDVUOUWPSVWFYEUUOUUSUUPUUQVWDVVGVYLXHXIVWDVVERVVFVWDVVEHWFVNRVW
      DUWNHWFVWTYCURYHUUTUVAUVBXRYNUVCYMAEVYRWRVWAVWCVDXTYLYBYQYOUVIAUFDSUVJZUF
      WGXNSWGXNAVWHVYSVFUFDSUVDXSAUFVWSWGUKHVMXOUVEUFDWGSUVFUVGAHUGXNHWGXNVGHUG
      UVHXSUWMWGXNAUWEUWLUVSUWDUVNUVPUVRYSUWAUWCUVKYTUWGUWIUWKYSYTXMUVLYA $.
  $}

  ${
    $d g h i n p q u v w x y z F $.  $d g h i n p q u v w x y z R $.  $d x U $.
    $d x y B $.  $d x y E $.  $d g h i n p q u v w x y z ph $.  $d h n x y X $.
    $d p x K $.  $d g x y S $.  $d g h p q w z V $.  $d h n x y Y $.
    imasbas.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasbas.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasbas.f $e |- ( ph -> F : V -onto-> B ) $.
    imasbas.r $e |- ( ph -> R e. Z ) $.
    $( The base set of an image structure.  (Contributed by Mario Carneiro,
       23-Feb-2015.)  (Revised by Mario Carneiro, 11-Jul-2015.) $)
    imasbas $p |- ( ph -> B = ( Base ` U ) ) $=
      ( cbs cfv cnx cop cv co ciun c1 eqid vp vq vx vy vn vg vh vi cplusg cmulr
      csn ctp csca cvsca cmpt2 cpr cun cts ctopn cqtop cple ccom ccnv c1st wceq
      cds c2nd caddc cmin cfz wral w3a cxp cmap crab cxrs cgsu cmpt crn cxr clt
      cn csup cvv c2 cdc eqidd imasval imasvalstr baseid snsstp1 ssun1 wcel wfo
      sstri fvex syl6eqel fornex sylc strfv3 eqcomd ) ADLMZBAXBBNLMBOZNUIMUAFUB
      FUAPZEMUBPZEMZOZXDXECUIMZQEMOUKRRZOZNUJMUAFUBFXGXDXECUJMZQEMOUKRRZOZULZNU
      MMCUMMZONUNMUBFUAUCXOLMZXFUKXDXECUNMZQEMUORZOUPZUQZNURMCUSMZEUTQZONVAMECV
      AMZVBEVCVBZONVFMUCUDBBUEWBUFSUGPZMVDMEMUCPVEUEPZYEMVGMEMUDPVEUHPZYEMVGMEM
      YGSVHQYEMVDMEMVEUHSYFSVIQVJQVKVLUGFFVMSYFVJQVNQVOVPCVFMZUFPVBVQQVRVSRVTWA
      VCWCUOZOULZUQZDLWDSSWEWFOAUCUDBYIXHXICXLXQXKXRDUFUGUHUEYHEXOYAXPYDYCYBFGU
      BUAHIXHTXKTXOTXPTXQTYATYHTYCTAXIWGAXLWGAXRWGAYBWGAYIWGAYDWGJKWHBYIXIXOXRX
      LYKYDYBYKTWIWJXCUKZXTYKYLXNXTXCXJXMWKXNXSWLWOXTYJWLWOAFWDWMFBEWNBWDWMAFCL
      MWDICLWPWQJFBWDEWRWSXBTWTXA $.

    ${
      imasds.e $e |- E = ( dist ` R ) $.
      imasds.d $e |- D = ( dist ` U ) $.
      $( The distance function of an image structure.  (Contributed by Mario
         Carneiro, 23-Feb-2015.)  (Revised by Mario Carneiro, 11-Jul-2015.) $)
      imasds $p |- ( ph -> D = ( x e. B , y e. B |-> sup ( U_ n e. NN
         ran ( g e. { h e. ( ( V X. V ) ^m ( 1 ... n ) ) |
        ( ( F ` ( 1st ` ( h ` 1 ) ) ) = x /\ ( F ` ( 2nd ` ( h ` n ) ) ) = y /\
         A. i e. ( 1 ... ( n - 1 ) ) ( F ` ( 2nd ` ( h ` i ) ) ) =
           ( F ` ( 1st ` ( h ` ( i + 1 ) ) ) ) ) } |->
         ( RR*s gsum ( E o. g ) ) ) , RR* , `' < ) ) ) $=
        ( vp vq cn c1 cv cfv c1st wceq c2nd caddc co cmin cfz wral w3a cxp cmap
        crab cxrs ccom cgsu cmpt crn ciun cxr clt ccnv cmpt2 cnx cbs cop cplusg
        csup csn cmulr ctp csca cvsca cpr cun cts ctopn cqtop cple cds cvv eqid
        cdc eqidd imasval imasvalstr dsid snsstp3 ssun2 sstri wcel wfo syl6eqel
        c2 fvex fornex sylc mpt2exga syl2anc strfv3 ) AEBCDDKUDHUEIUFZUGUHUGMUG
        BUFUIKUFZXGUGUJUGMUGCUFUIJUFZXGUGUJUGMUGXIUEUKULXGUGUHUGMUGUIJUEXHUEUMU
        LUNULUOUPINNUQUEXHUNULURULUSUTLHUFVAVBULVCVDVEVFVGVHVNZVIZVJVKUGDVLVJVM
        UGUBNUCNUBUFZMUGUCUFZMUGZVLZXLXMFVMUGZULMUGVLVOVEVEZVLVJVPUGUBNUCNXOXLX
        MFVPUGZULMUGVLVOVEVEZVLVQVJVRUGFVRUGZVLVJVSUGUCNUBBXTVKUGZXNVOXLXMFVSUG
        ZULMUGVIVEZVLVTWAZVJWBUGFWCUGZMWDULZVLZVJWEUGMFWEUGZVAMVHVAZVLZVJWFUGXK
        VLZVQZWAZGWFWGUEUEWTWIVLABCDXKXPXQFXSYBXRYCGHIJKLMXTYEYAYIYHYFNOUCUBPQX
        PWHXRWHXTWHYAWHYBWHYEWHTYHWHAXQWJAXSWJAYCWJAYFWJAXKWJAYIWJRSWKDXKXQXTYC
        XSYMYIYFYMWHWLWMYKVOYLYMYGYJYKWNYLYDWOWPADWGWQZYNXKWGWQANWGWQNDMWRYNANF
        VKUGWGQFVKXAWSRNDWGMXBXCZYOBCDDXJWGWGXDXEUAXF $.

      $( The distance function is a function on the base set.  (Contributed by
         Mario Carneiro, 20-Aug-2015.) $)
      imasdsfn $p |- ( ph -> D Fn ( B X. B ) ) $=
        ( c1 cv cfv co cxr vx vy vn vg vh vi cxp wfn cn c1st wceq c2nd cmin cfz
        caddc wral w3a cmap crab cxrs ccom cgsu cmpt crn ciun clt ccnv csup wor
        cmpt2 eqid xrltso cnvso mpbi supex fnmpt2i imasds fneq1d mpbiri ) ACBBU
        GZUHUAUBBBUCUIUDPUEQZRUJRGRUAQUKUCQZWARULRGRUBQUKUFQZWARULRGRWCPUOSWARU
        JRGRUKUFPWBPUMSUNSUPUQUEHHUGPWBUNSURSUSUTFUDQVAVBSVCVDVEZTVFVGZVHZVJZVT
        UHUAUBBBWFWGWGVKTWDWETVFVITWEVIVLTVFVMVNVOVPAVTCWGAUAUBBCDEUDUEUFUCFGHI
        JKLMNOVQVRVS $.

      imasdsval.x $e |- ( ph -> X e. B ) $.
      imasdsval.y $e |- ( ph -> Y e. B ) $.
      imasdsval.s $e |- S = { h e. ( ( V X. V ) ^m ( 1 ... n ) ) |
        ( ( F ` ( 1st ` ( h ` 1 ) ) ) = X /\ ( F ` ( 2nd ` ( h ` n ) ) ) = Y /\
         A. i e. ( 1 ... ( n - 1 ) ) ( F ` ( 2nd ` ( h ` i ) ) ) =
           ( F ` ( 1st ` ( h ` ( i + 1 ) ) ) ) ) } $.
      $( The distance function of an image structure.  (Contributed by Mario
         Carneiro, 20-Aug-2015.) $)
      imasdsval $p |- ( ph -> ( X D Y ) = sup ( U_ n e. NN
        ran ( g e. S |-> ( RR*s gsum ( E o. g ) ) ) , RR* , `' < ) ) $=
        ( vx vy cn c1 cv cfv c1st wceq c2nd caddc co cmin cfz wral w3a cxp cmap
        crab cxrs ccom cgsu cmpt crn ciun cxr clt ccnv csup imasds wcel simplrl
        cvv wa eqeq2d simplrr 3anbi12d rabbidv syl6eqr mpteq1d iuneq2dv supeq1d
        rneqd wor xrltso cnvso mpbi supex a1i ovmpt2d ) AUFUGNOBBJUHGUIHUJZUKUL
        UKLUKZUFUJZUMZJUJZWOUKUNUKLUKZUGUJZUMZIUJZWOUKUNUKLUKXCUIUOUPWOUKULUKLU
        KUMIUIWSUIUQUPURUPUSZUTZHMMVAUIWSURUPVBUPZVCZVDKGUJVEVFUPZVGZVHZVIZVJVK
        VLZVMJUHGEXHVGZVHZVIZVJXLVMZCVQAUFUGBCDFGHIJKLMPQRSTUAUBVNAWQNUMZXAOUMZ
        VRVRZVJXKXOXLXSJUHXJXNXSWSUHVOZVRZXIXMYAGXGEXHYAXGWPNUMZWTOUMZXDUTZHXFV
        CEYAXEYDHXFYAWRYBXBYCXDYAWQNWPAXQXRXTVPVSYAXAOWTAXQXRXTVTVSWAWBUEWCWDWG
        WEWFUCUDXPVQVOAVJXOXLVJVKWHVJXLWHWIVJVKWJWKWLWMWN $.

      imasds.u $e |- T = ( E |` ( V X. V ) ) $.
      $( The distance function of an image structure.  (Contributed by Mario
         Carneiro, 20-Aug-2015.) $)
      imasdsval2 $p |- ( ph -> ( X D Y ) = sup ( U_ n e. NN
        ran ( g e. S |-> ( RR*s gsum ( T o. g ) ) ) , RR* , `' < ) ) $=
        ( co cxrs ccom cgsu cmpt crn ciun cxr clt ccnv csup imasdsval wceq wcel
        cn cv cxp cres coeq1i c1 cfz cmap wss cfv c1st c2nd caddc cmin wral w3a
        crab ssrab2 eqsstri sseli elmapi frn cores syl5eq oveq2d mpteq2ia rneqi
        wf 4syl a1i iuneq2i supeq1i syl6eqr ) AOPCUHKVBHEUILHVCZUJZUKUHZULZUMZU
        NZUOUPUQZURKVBHEUIFWOUJZUKUHZULZUMZUNZUOXAURABCDEGHIJKLMNOPQRSTUAUBUCUD
        UEUFUSUOXFWTXAKVBXEWSXEWSUTKVCZVBVAXDWRHEXCWQWOEVAZXBWPUIUKXHXBLNNVDZVE
        ZWOUJZWPFXJWOUGVFXHWOXIVGXGVHUHZVIUHZVAXLXIWOWIWOUMXIVJXKWPUTEXMWOEVGIV
        CZVKVLVKMVKOUTXGXNVKVMVKMVKPUTJVCZXNVKVMVKMVKXOVGVNUHXNVKVLVKMVKUTJVGXG
        VGVOUHVHUHVPVQZIXMVRXMUFXPIXMVSVTWAWOXIXLWBXLXIWOWCLWOXIWDWJWEWFWGWHWKW
        LWMWN $.
    $}

    ${
      imasplusg.p $e |- .+ = ( +g ` R ) $.
      imasplusg.a $e |- .+b = ( +g ` U ) $.
      $( The group operation in an image structure.  (Contributed by Mario
         Carneiro, 23-Feb-2015.)  (Revised by Mario Carneiro, 11-Jul-2015.) $)
      imasplusg $p |- ( ph -> .+b = U_ p e. V U_ q e. V
        { <. <. ( F ` p ) , ( F ` q ) >. , ( F ` ( p .+ q ) ) >. } ) $=
        ( cfv cop cvv vx vy vg vh vi vn cv co csn ciun cnx cbs cplusg cmulr ctp
        csca cvsca cmpt2 cpr cun cts ctopn cqtop cple ccom ccnv cds c1 cdc eqid
        c2 eqidd imasds imasval imasvalstr plusgid snsstp2 ssun1 wcel wral fvex
        sstri syl6eqel snex rgenw iunexg sylancl ralrimivw syl2anc strfv3 ) ADK
        HJHKUGZGRJUGZGRZSZWKWLCUHGRSZUIZUJZUJZUKULRBSZUKUMRWRSZUKUNRKHJHWNWKWLE
        UNRZUHGRSUIUJUJZSZUOZUKUPREUPRZSUKUQRJHKUAXEULRZWMUIWKWLEUQRZUHGRURUJZS
        USZUTZUKVAREVBRZGVCUHZSUKVDRGEVDRZVEGVFVEZSUKVGRFVGRZSUOZUTZFUMTVHVHVKV
        ISAUAUBBXOCWREXBXGXAXHFUCUDUEUFEVGRZGXEXKXFXNXMXLHIJKLMPXAVJXEVJXFVJXGV
        JXKVJXRVJZXMVJAWRVLAXBVLAXHVLAXLVLAUAUBBXOEFUCUDUEUFXRGHILMNOXSXOVJVMAX
        NVLNOVNBXOWRXEXHXBXQXNXLXQVJVOVPWTUIZXJXQXTXDXJWSWTXCVQXDXIVRWBXJXPVRWB
        AHTVSZWQTVSZKHVTWRTVSAHEULRTMEULWAWCZAYBKHAYAWPTVSZJHVTYBYCYDJHWOWDWEJH
        WPTTWFWGWHKHWQTTWFWIQWJ $.
    $}

    ${
      imasmulr.p $e |- .x. = ( .r ` R ) $.
      imasmulr.t $e |- .xb = ( .r ` U ) $.
      $( The ring multiplication in an image structure.  (Contributed by Mario
         Carneiro, 23-Feb-2015.)  (Revised by Mario Carneiro, 11-Jul-2015.) $)
      imasmulr $p |- ( ph -> .xb = U_ p e. V U_ q e. V
        { <. <. ( F ` p ) , ( F ` q ) >. , ( F ` ( p .x. q ) ) >. } ) $=
        ( cfv cop cvv vx vy vg vh vi vn cv co csn ciun cnx cbs cplusg cmulr ctp
        csca cvsca cmpt2 cpr cun cts ctopn cqtop cple ccom ccnv cds c1 cdc eqid
        c2 imasplusg eqidd imasds imasval imasvalstr mulrid snsstp3 ssun1 sstri
        wcel wral fvex syl6eqel rgenw iunexg sylancl ralrimivw syl2anc strfv3
        snex ) ADKHJHKUGZGRJUGZGRZSWLWMEUHGRSZUIZUJZUJZUKULRBSZUKUMRFUMRZSZUKUN
        RWRSZUOZUKUPRCUPRZSUKUQRJHKUAXDULRZWNUIWLWMCUQRZUHGRURUJZSUSZUTZUKVARCV
        BRZGVCUHZSUKVDRGCVDRZVEGVFVEZSUKVGRFVGRZSUOZUTZFUNTVHVHVKVISAUAUBBXNCUM
        RZWTCWRXFEXGFUCUDUEUFCVGRZGXDXJXEXMXLXKHIJKLMXQVJZPXDVJXEVJXFVJXJVJXRVJ
        ZXLVJABXQWTCFGHIJKLMNOXSWTVJVLAWRVMAXGVMAXKVMAUAUBBXNCFUCUDUEUFXRGHILMN
        OXTXNVJVNAXMVMNOVOBXNWTXDXGWRXPXMXKXPVJVPVQXBUIZXIXPYAXCXIWSXAXBVRXCXHV
        SVTXIXOVSVTAHTWAZWQTWAZKHWBWRTWAAHCULRTMCULWCWDZAYCKHAYBWPTWAZJHWBYCYDY
        EJHWOWKWEJHWPTTWFWGWHKHWQTTWFWIQWJ $.
    $}

    ${
      imassca.g $e |- G = ( Scalar ` R ) $.
      $( The scalar field of an image structure.  (Contributed by Mario
         Carneiro, 23-Feb-2015.) $)
      imassca $p |- ( ph -> G = ( Scalar ` U ) ) $=
        ( vq vp csca cfv cnx cop eqid vx vy vg vh vi cbs cplusg cmulr ctp cvsca
        vn cv csn co cmpt2 ciun cpr cun cts ctopn cqtop cple ccom cds imasplusg
        ccnv imasmulr eqidd imasds imasval fveq2d cvv wcel wceq fvex eqeltri c1
        c2 cdc imasvalstr scaid snsspr1 ssun2 sstri ssun1 strfv ax-mp syl6reqr
        ) ADPQRUFQBSRUGQDUGQZSRUHQDUHQZSUIZRPQFSZRUJQNGOUAFUFQZNULZEQUMOULWNCUJ
        QZUNEQUOUPZSZUQZURZRUSQCUTQZEVAUNZSRVBQECVBQZVCEVFVCZSRVDQDVDQZSUIZURZP
        QZFADXFPAUAUBBXDCUGQZWICWJWOCUHQZWPDUCUDUEUKCVDQZEFWTWMXCXBXAGHNOIJXHTZ
        XITZMWMTWOTWTTXJTZXBTABXHWICDEGHNOIJKLXKWITVEABCWJXIDEGHNOIJKLXLWJTVGAW
        PVHAXAVHAUAUBBXDCDUCUDUEUKXJEGHIJKLXMXDTVIAXCVHKLVJVKFVLVMFXGVNFCPQVLMC
        PVOVPFXFPVLVQVQVRVSSBXDWIFWPWJXFXCXAXFTVTWAWLUMZWSXFXNWRWSWLWQWBWRWKWCW
        DWSXEWEWDWFWGWH $.

      imasvsca.k $e |- K = ( Base ` G ) $.
      imasvsca.q $e |- .x. = ( .s ` R ) $.
      imasvsca.s $e |- .xb = ( .s ` U ) $.
      $( The scalar multiplication operation of an image structure.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      imasvsca $p |- ( ph -> .xb = U_ q e. V ( p e. K ,
           x e. { ( F ` q ) } |-> ( F ` ( p .x. q ) ) ) ) $=
        ( vy vz vw vv vu cv cfv csn co cmpt2 ciun cnx cbs cop cplusg cmulr csca
        ctp cvsca cpr cun cts ctopn cqtop cple ccom ccnv cds cvv c1 c2 cdc eqid
        imasplusg imasmulr eqidd imasds imasval imasvalstr vscaid snsspr2 ssun2
        sstri ssun1 wcel wral fvex syl6eqel eqeltri mpt2ex rgenw iunexg sylancl
        snex strfv3 ) AEMKNBJMUHZHUIZUJZNUHWRFUKHUIZULZUMZUNUOUICUPUNUQUIGUQUIZ
        UPUNURUIGURUIZUPUTZUNUSUIIUPZUNVAUIXCUPZVBZVCZUNVDUIDVEUIZHVFUKZUPUNVGU
        IHDVGUIZVHHVIVHZUPUNVJUIGVJUIZUPUTZVCZGVAVKVLVLVMVNUPABUCCXODUQUIZXDDXE
        FDURUIZXCGUDUEUFUGDVJUIZHIXKJXNXMXLKLMNOPXRVOZXSVOZSTUAXKVOXTVOZXMVOACX
        RXDDGHKLMNOPQRYAXDVOVPACDXEXSGHKLMNOPQRYBXEVOVQAXCVRAXLVRABUCCXODGUDUEU
        FUGXTHKLOPQRYCXOVOVSAXNVRQRVTCXOXDIXCXEXQXNXLXQVOWAWBXHUJZXJXQYDXIXJXGX
        HWCXIXFWDWEXJXPWFWEAKVKWGXBVKWGZMKWHXCVKWGAKDUOUIVKPDUOWIWJYEMKNBJWTXAJ
        IUOUIVKTIUOWIWKWSWPWLWMMKXBVKVKWNWOUBWQ $.
    $}

    ${
      imastset.j $e |- J = ( TopOpen ` R ) $.
      imastset.o $e |- O = ( TopSet ` U ) $.
      $( The topology of an image structure.  (Contributed by Mario Carneiro,
         23-Feb-2015.) $)
      imastset $p |- ( ph -> O = ( J qTop F ) ) $=
        ( cts cfv cnx cop eqid vx vy vz vw vv vu vq cbs cplusg cmulr csca cvsca
        vp ctp cpr cun cqtop co cple ccom cds imasplusg imasmulr imasvsca eqidd
        ccnv imasds imasval fveq2d cvv wcel wceq ovex cdc imasvalstr tsetid csn
        c1 c2 snsstp1 ssun2 sstri strfv ax-mp 3eqtr4g ) ADPQRUHQBSRUIQDUIQZSRUJ
        QDUJQZSUNRUKQCUKQZSRULQDULQZSUOUPZRPQFEUQURZSZRUSQECUSQZUTEVFUTZSZRVAQD
        VAQZSZUNZUPZPQZGWKADWSPAUAUBBWPCUIQZWFCWGCULQZCUJQZWIDUCUDUEUFCVAQZEWHF
        WHUHQZWNWMWKHIUGUMJKXATZXCTZWHTZXETZXBTZNXDTZWMTABXAWFCDEHIUGUMJKLMXFWF
        TVBABCWGXCDEHIUGUMJKLMXGWGTVCAUABCWIXBDEWHXEHIUGUMJKLMXHXIXJWITVDAWKVEA
        UAUBBWPCDUCUDUEUFXDEHIJKLMXKWPTVGAWNVELMVHVIOWKVJVKWKWTVLFEUQVMWKWSPVJV
        RVRVSVNSBWPWFWHWIWGWSWNWKWSTVOVPWLVQWRWSWLWOWQVTWRWJWAWBWCWDWE $.
    $}

    ${
      imasle.n $e |- N = ( le ` R ) $.
      imasle.l $e |- .<_ = ( le ` U ) $.
      $( The ordering of an image structure.  (Contributed by Mario Carneiro,
         23-Feb-2015.) $)
      imasle $p |- ( ph -> .<_ = ( ( F o. N ) o. `' F ) ) $=
        ( cnx cfv cop cvv eqid vx vy vz vw vv vu vq vp ccom ccnv cbs cplusg ctp
        cmulr csca cvsca cpr cun cts cple cds c1 c2 cdc ctopn imasmulr imasvsca
        imasplusg imasds eqidd imasval imasvalstr pleid csn snsstp2 ssun2 sstri
        imastset wcel wf wfo fof syl syl6eqel fex syl2anc eqeltri coexg sylancl
        fvex cnvexg strfv3 ) AFEGUIZEUJZUIZPUKQBRPULQDULQZRPUNQDUNQZRUMPUOQCUOQ
        ZRPUPQDUPQZRUQURZPUSQDUSQZRZPUTQWORZPVAQDVAQZRZUMZURZDUTSVBVBVCVDRAUAUB
        BXDCULQZWPCWQCUPQZCUNQZWSDUCUDUEUFCVAQZEWRCVEQZWRUKQZWOGXAHIUGUHJKXHTZX
        JTZWRTZXMTZXITZXLTZXKTZNABXHWPCDEHIUGUHJKLMXNWPTVHABCWQXJDEHIUGUHJKLMXO
        WQTVFAUABCWSXIDEWRXMHIUGUHJKLMXPXQXRWSTVGABCDEXLXAHIJKLMXSXATVRAUAUBBXD
        CDUCUDUEUFXKEHIJKLMXTXDTVIAWOVJLMVKBXDWPWRWSWQXGWOXAXGTVLVMXCVNXFXGXBXC
        XEVOXFWTVPVQAWMSVSZWNSVSZWOSVSAESVSZGSVSYAAHBEVTZHSVSYCAHBEWAYDLHBEWBWC
        AHCUKQSKCUKWJWDHBSEWEWFZGCUTQSNCUTWJWGEGSSWHWIAYCYBYEESWKWCWMWNSSWHWFOW
        L $.
    $}
  $}

  ${
    f1ocpbl.f $e |- ( ph -> F : V -1-1-onto-> X ) $.
    $( Lemma for ~ f1ocpbl .  (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    f1ocpbllem $p |- ( ( ph /\ ( A e. V /\ B e. V ) /\ ( C e. V /\ D e. V ) )
      -> ( ( ( F ` A ) = ( F ` C ) /\ ( F ` B ) = ( F ` D ) )
        <-> ( A = C /\ B = D ) ) ) $=
      ( wcel wa w3a cfv wceq wf1 wb wf1o f1of1 f1fveq syl12anc 3ad2ant1 anbi12d
      syl simp2l simp3l simp2r simp3r ) ABGJZCGJZKZDGJZEGJZKZLZBFMDFMNZBDNZCFME
      FMNZCENZUNGHFOZUHUKUOUPPAUJUSUMAGHFQUSIGHFRUCUAZAUHUIUMUDAUJUKULUEGHBDFST
      UNUSUIULUQURPUTAUHUIUMUFAUJUKULUGGHCEFSTUB $.

    $( An injection is compatible with any operations on the base set.
       (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    f1ocpbl $p |- ( ( ph /\ ( A e. V /\ B e. V ) /\ ( C e. V /\ D e. V ) ) ->
      ( ( ( F ` A ) = ( F ` C ) /\ ( F ` B ) = ( F ` D ) ) ->
        ( F ` ( A .+ B ) ) = ( F ` ( C .+ D ) ) ) ) $=
      ( wcel wa w3a cfv wceq co f1ocpbllem oveq12 fveq2d syl6bi ) ABHKCHKLDHKEH
      KLMBGNDGNOCGNEGNOLBDOCEOLZBCFPZGNDEFPZGNOABCDEGHIJQUAUBUCGBDCEFRST $.

    $( An injection is compatible with any operations on the base set.
       (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    f1ovscpbl $p |- ( ( ph /\ ( A e. K /\ B e. V /\ C e. V ) ) ->
      ( ( F ` B ) = ( F ` C ) -> ( F ` ( A .+ B ) ) = ( F ` ( A .+ C ) ) ) ) $=
      ( wcel w3a wa cfv wceq co wf1 wb wf1o f1of1 adantr simpr2 simpr3 syl12anc
      syl f1fveq oveq2 fveq2d syl6bi ) ABGKZCHKZDHKZLZMZCFNDFNOZCDOZBCEPZFNBDEP
      ZFNOUNHIFQZUKULUOUPRAUSUMAHIFSUSJHIFTUEUAAUJUKULUBAUJUKULUCHICDFUFUDUPUQU
      RFCDBEUGUHUI $.

    $( An injection is compatible with any relations on the base set.
       (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    f1olecpbl $p |- ( ( ph /\ ( A e. V /\ B e. V ) /\ ( C e. V /\ D e. V ) ) ->
      ( ( ( F ` A ) = ( F ` C ) /\ ( F ` B ) = ( F ` D ) ) ->
        ( A N B <-> C N D ) ) ) $=
      ( wcel wa w3a cfv wceq wbr wb f1ocpbllem breq12 syl6bi ) ABHKCHKLDHKEHKLM
      BFNDFNOCFNEFNOLBDOCEOLBCGPDEGPQABCDEFHIJRBDCEGST $.
  $}

  ${
    $d p q B $.  $d p q R $.  $d a b p q w y z V $.  $d p q w .x. $.  $d p X $.
    $d a b p q w x y z F $.  $d a b p q w ph $.  $d a b p q w x y z .xb $.
    $d p q Y $.
    imasaddf.f $e |- ( ph -> F : V -onto-> B ) $.
    imasaddf.e $e |- ( ( ph /\ ( a e. V /\ b e. V ) /\ ( p e. V /\ q e. V ) )
      -> ( ( ( F ` a ) = ( F ` p ) /\ ( F ` b ) = ( F ` q ) )
        -> ( F ` ( a .x. b ) ) = ( F ` ( p .x. q ) ) ) ) $.
    ${
      imasaddflem.a $e |- ( ph -> .xb = U_ p e. V U_ q e. V
          { <. <. ( F ` p ) , ( F ` q ) >. , ( F ` ( p .x. q ) ) >. } ) $.
      $( The image structure operation is a function if the original operation
         is compatible with the function.  (Contributed by Mario Carneiro,
         23-Feb-2015.) $)
      imasaddfnlem $p |- ( ph -> .xb Fn ( B X. B ) ) $=
        ( vw vz wceq wral wss wcel syl vx wfun cdm cxp wfn wrel wbr wmo cfv cop
        vy cv co csn ciun opex relsnop rgenw reliun mpbir releqd mpbiri crn cvv
        fvex wa wfo fof ffvelrn anim12dan sylan opelxpi sylancl snssd ralrimiva
        wf anassrs iunss sylibr eqsstrd dmss c0 wne dmxp ax-mp syl6sseq xpeq12d
        vn0 forn sseqtr4d wi wal wrex eleq2d adantr df-br rexbii bitr2i 3bitr4g
        wb eliun w3a elsnc vex opth syl5bi eqeq2 biimprd imp3a 3expa rexlimdvva
        syl6 sylbid alrimiv mo2icl ralrimivva opeq2 breq1d mobidv ralrn ralbidv
        fofn mpbird opeq1 breq1 ralxp ssralv sylc dffun7 sylanbrc eqimss2 sylib
        snss opeldm sylbir ralimi sylbi eleq1d eleq1 dfss3 eqsstr3d eqssd df-fn
        ) ACUBZCUCZBBUDZPCUUFUEACUFZUAULZNULZCUGZNUHZUAUUEQZUUDAUUGHFGFHULZEUIZ
        GULZEUIZUJZUUMUUODUMZEUIZUJZUNZUOZUOZUFZUVDUVBUFZHFQUVEHFUVEUVAUFZGFQUV
        FGFUUQUUSUUNUUPUPZUUREVEZUQURGFUVAUSUTURHFUVBUSUTACUVCMVAVBAUUEEVCZUVIU
        DZRUUKUAUVJQZUULAUUEUUFUVJAUUEUUFVDUDZUCZUUFACUVLRUUEUVMRACUVCUVLMAUVBU
        VLRZHFQUVCUVLRAUVNHFAUUMFSZVFZUVAUVLRZGFQUVNUVPUVQGFAUVOUUOFSZUVQAUVOUV
        RVFZVFZUUTUVLUVTUUQUUFSZUUSVDSUUTUVLSUVTUUNBSZUUPBSZVFZUWAAFBEVPZUVSUWD
        AFBEVGZUWEKFBEVHTUWEUVOUWBUVRUWCFBUUMEVIFBUUOEVIVJVKUUNUUPBBVLTUVHUUQUU
        SUUFVDVLVMVNVQVOGFUVAUVLVRVSVOHFUVBUVLVRVSVTCUVLWATVDWBWCUVMUUFPWHUUFVD
        WDWEWFZAUVIBUVIBAUWFUVIBPKFBEWITZUWHWGZWJAUKULZOULZUJZUUICUGZNUHZOUVIQZ
        UKUVIQZUVKAUWPIULZEUIZUWKUJZUUICUGZNUHZOUVIQZIFQZAUXCUWRJULZEUIZUJZUUIC
        UGZNUHZJFQZIFQAUXHIJFFAUWQFSUXDFSVFZVFZUXGUUIUWQUXDDUMEUIZPZWKZNWLUXHUX
        KUXNNUXKUXGUXFUUIUJZUVASZGFWMZHFWMZUXMUXKUXOCSZUXOUVCSZUXGUXRAUXSUXTWTU
        XJACUVCUXOMWNWOUXFUUICWPUXTUXOUVBSZHFWMUXRHUXOFUVBXAUYAUXQHFGUXOFUVAXAW
        QWRWSUXKUXPUXMHGFFAUXJUVSUXPUXMWKUXPUXOUUTPZAUXJUVSXBZUXMUXOUUTUXFUUIUP
        XCUYBUXFUUQPZUUIUUSPZVFUYCUXMUXFUUIUUQUUSUWRUXEUPNXDXEUYCUYDUYEUXMUYCUY
        DUXLUUSPZUYEUXMWKUYDUWRUUNPUXEUUPPVFUYCUYFUWRUXEUUNUUPUWQEVEUXDEVEXELXF
        UYFUXMUYEUXLUUSUUIXGXHXLXIXFXFXJXKXMXNUXGNUXLXOTXPAUXBUXIIFAEFUEZUXBUXI
        WTAUWFUYGKFBEYBTZUXAUXHOJFEUWKUXEPZUWTUXGNUYIUWSUXFUUICUWKUXEUWRXQXRXSX
        TTYAYCAUYGUWPUXCWTUYHUWOUXBUKIFEUWJUWRPZUWNUXAOUVIUYJUWMUWTNUYJUWLUWSUU
        ICUWJUWRUWKYDXRXSYAXTTYCUUKUWNUAUKOUVIUVIUUHUWLPUUJUWMNUUHUWLUUICYEXSYF
        VSUUKUAUUEUVJYGYHUANCYIYJAUUEUUFUWGAUUFUVJUUEUWIAUUHUUESZUAUVJQZUVJUUER
        AUWLUUESZOUVIQZUKUVIQZUYLAUYOUUNUWKUJZUUESZOUVIQZHFQZAUYSUUQUUESZGFQZHF
        QZAUVBCRZHFQZVUBAUVCCRZVUDACUVCPVUEMUVCCYKTHFUVBCVRYLVUCVUAHFVUCUVACRZG
        FQVUAGFUVACVRVUFUYTGFVUFUUTCSUYTUUTCUUQUUSUPYMUUQUUSCUVGUVHYNYOYPYQYPTA
        UYRVUAHFAUYGUYRVUAWTUYHUYQUYTOGFEUWKUUPPUYPUUQUUEUWKUUPUUNXQYRXTTYAYCAU
        YGUYOUYSWTUYHUYNUYRUKHFEUWJUUNPZUYMUYQOUVIVUGUWLUYPUUEUWJUUNUWKYDYRYAXT
        TYCUYKUYMUAUKOUVIUVIUUHUWLUUEYSYFVSUAUVJUUEYTVSUUAUUBCUUFUUCYJ $.

      $( The operation of an image structure is defined to distribute over the
         mapping function.  (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      imasaddvallem $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
        ( ( F ` X ) .xb ( F ` Y ) ) = ( F ` ( X .x. Y ) ) ) $=
        ( cfv co cop wceq wss wcel w3a df-ov wfun cxp wfn imasaddfnlem 3ad2ant1
        fnfun syl csn cv ciun fveq2 opeq1d oveq1 opeq12d sneqd ssiun2s 3ad2ant2
        fveq2d wral opeq2d oveq2 ralrimivw ss2iun 3ad2ant3 sseqtr4d opex sylibr
        sstrd snss funopfv sylc syl5eq ) AGFUAZHFUAZUBZGEPZHEPZCQVSVTRZCPZGHDQZ
        EPZVSVTCUCVRCUDZWAWDRZCUAZWBWDSAVPWEVQACBBUEZUFWEABCDEFIJKLMNOUGWHCUIUJ
        UHVRWFUKZCTWGVRWIJFIFJULZEPZIULZEPZRZWJWLDQZEPZRZUKZUMZUMZCVRWIJFWKVTRZ
        WJHDQZEPZRZUKZUMZWTVPAWIXFTVQJFXEGWIWJGSZXDWFXGXAWAXCWDXGWKVSVTWJGEUNUO
        XGXBWCEWJGHDUPVAUQURUSUTVQAXFWTTZVPVQXEWSTZJFVBXHVQXIJFIFWRHXEWLHSZWQXD
        XJWNXAWPXCXJWMVTWKWLHEUNVCXJWOXBEWLHWJDVDVAUQURUSVEJFXEWSVFUJVGVKAVPCWT
        SVQOUHVHWFCWAWDVIVLVJWAWDCVMVNVO $.

      imasaddflem.c $e |- ( ( ph /\ ( p e. V /\ q e. V ) ) ->
        ( p .x. q ) e. V ) $.
      $( The image set operations are closed if the original operation is.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      imasaddflem $p |- ( ph -> .xb : ( B X. B ) --> B ) $=
        ( cxp wss cfv wcel wa ffvelrn wfn wf imasaddfnlem cop csn ciun wral wfo
        cv fof syl anim12dan opelxpi sylan syldan syl2anc snssd ralrimiva iunss
        co anassrs sylibr eqsstrd dff2 sylanbrc ) ACBBOZUACVFBOZPVFBCUBABCDEFGH
        IJKLMUCACHFGFHUIZEQZGUIZEQZUDZVHVJDUTZEQZUDZUEZUFZUFZVGMAVQVGPZHFUGVRVG
        PAVSHFAVHFRZSZVPVGPZGFUGVSWAWBGFAVTVJFRZWBAVTWCSZSZVOVGWEVLVFRZVNBRZVOV
        GRAFBEUBZWDWFAFBEUHWHKFBEUJUKZWHWDSVIBRZVKBRZSWFWHVTWJWCWKFBVHETFBVJETU
        LVIVKBBUMUKUNAWDVMFRZWGNAWHWLWGWIFBVMETUNUOVLVNVFBUMUPUQVAURGFVPVGUSVBU
        RHFVQVGUSVBVCVFBCVDVE $.
    $}

    imasaddf.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasaddf.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasaddf.r $e |- ( ph -> R e. Z ) $.
    ${
      imasaddf.p $e |- .x. = ( +g ` R ) $.
      imasaddf.a $e |- .xb = ( +g ` U ) $.
      $( The image structure's group operation is a function.  (Contributed by
         Mario Carneiro, 23-Feb-2015.)  (Revised by Mario Carneiro,
         10-Jul-2015.) $)
      imasaddfn $p |- ( ph -> .xb Fn ( B X. B ) ) $=
        ( imasplusg imasaddfnlem ) ABDEGHJKLMNOABEDCFGHIJKPQNRSTUAUB $.

      $( The value of an image structure's group operation.  (Contributed by
         Mario Carneiro, 23-Feb-2015.) $)
      imasaddval $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
        ( ( F ` X ) .xb ( F ` Y ) ) = ( F ` ( X .x. Y ) ) ) $=
        ( imasplusg imasaddvallem ) ABDEGHIJLMNOPQABEDCFGHKLMRSPTUAUBUCUD $.

      imasaddf.c $e |- ( ( ph /\ ( p e. V /\ q e. V ) ) ->
        ( p .x. q ) e. V ) $.
      $( The image structure's group operation is closed in the base set.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      imasaddf $p |- ( ph -> .xb : ( B X. B ) --> B ) $=
        ( imasplusg imasaddflem ) ABDEGHJKLMNOABEDCFGHIJKPQNRSTUBUAUC $.
    $}

    ${
      imasmulf.p $e |- .x. = ( .r ` R ) $.
      imasmulf.a $e |- .xb = ( .r ` U ) $.
      $( The image structure's ring multiplication is a function.  (Contributed
         by Mario Carneiro, 23-Feb-2015.) $)
      imasmulfn $p |- ( ph -> .xb Fn ( B X. B ) ) $=
        ( imasmulr imasaddfnlem ) ABDEGHJKLMNOABCDEFGHIJKPQNRSTUAUB $.

      $( The value of an image structure's ring multiplication.  (Contributed
         by Mario Carneiro, 23-Feb-2015.) $)
      imasmulval $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
        ( ( F ` X ) .xb ( F ` Y ) ) = ( F ` ( X .x. Y ) ) ) $=
        ( imasmulr imasaddvallem ) ABDEGHIJLMNOPQABCDEFGHKLMRSPTUAUBUCUD $.

      imasmulf.c $e |- ( ( ph /\ ( p e. V /\ q e. V ) ) ->
        ( p .x. q ) e. V ) $.
      $( The image structure's ring multiplication is closed in the base set.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      imasmulf $p |- ( ph -> .xb : ( B X. B ) --> B ) $=
        ( imasmulr imasaddflem ) ABDEGHJKLMNOABCDEFGHIJKPQNRSTUBUAUC $.
    $}
  $}

  ${
    $d a p q w x y z F $.  $d a p q w x y z K $.  $d a p q w x ph $.  $d x U $.
    $d p q x B $.  $d p q x R $.  $d p q w x y z .x. $.  $d a p q w x y .xb $.
    $d a p q w x y V $.  $d p x X $.  $d p q x Y $.
    imasvscaf.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasvscaf.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasvscaf.f $e |- ( ph -> F : V -onto-> B ) $.
    imasvscaf.r $e |- ( ph -> R e. Z ) $.
    imasvscaf.g $e |- G = ( Scalar ` R ) $.
    imasvscaf.k $e |- K = ( Base ` G ) $.
    imasvscaf.q $e |- .x. = ( .s ` R ) $.
    imasvscaf.s $e |- .xb = ( .s ` U ) $.
    imasvscaf.e $e |- ( ( ph /\ ( p e. K /\ a e. V /\ q e. V ) ) ->
    ( ( F ` a ) = ( F ` q ) -> ( F ` ( p .x. a ) ) = ( F ` ( p .x. q ) ) ) ) $.
    $( The image structure's scalar multiplication is a function.  (Contributed
       by Mario Carneiro, 24-Feb-2015.) $)
    imasvscafn $p |- ( ph -> .xb Fn ( K X. B ) ) $=
      ( vx vw vy vz wfun cdm cxp wceq wfn wrel cv wbr wmo wral cfv csn co cmpt2
      ciun eqid fvex fnmpt2i fnrel ax-mp rgenw reliun mpbir imasvsca releqd crn
      mpbiri wss cvv wcel wa dffn2 mpbi fssxp wfo fof syl ffvelrnda snssd xpss2
      wf xpss1 3syl syl5ss ralrimiva iunss sylibr eqsstrd dmss wne vn0 syl6sseq
      c0 dmxp forn xpeq2d sseqtr4d cop wi wal df-br wb eleq2d adantr wrex eliun
      w3a df-3an mpt2fun funopfv df-ov opex opeldm dmmpt2 syl6eleq opelxp sylib
      vex weq oveq1 fveq2d eqidd equcoms eqcomd syl5bi ralrimivva opeq2 ralbidv
      mobidv ralrn mpbird ralxp sylanbrc ovmpt2 syl5eqr eqtr3d adantl elsni imp
      cbvmpt2v simprd sylan2 eqtr4d ex sylan2br anassrs rexlimdva sylbid mo2icl
      alrimiv fofn breq1d ssralv sylc dffun7 eqimss2 r19.21bi adantrl syl5eqssr
      breq1 simprl snid opelxpi sylancl sseldd eleq1 dfss3 eqsstr3d eqssd df-fn
      eleq1d ) ADUHZDUIZIBUJZUKDUWAULADUMZUDUNZUEUNZDUOZUEUPZUDUVTUQZUVSAUWBLJM
      UDILUNZGURZUSZMUNZUWHEUTZGURZVAZVBZUMZUWPUWNUMZLJUQUWQLJUWNIUWJUJZULZUWQM
      UDIUWJUWMUWNUWNVCZUWLGVDZVEZUWRUWNVFVGVHLJUWNVIVJADUWOAUDBCDEFGHIJKLMOPQR
      STUAUBVKZVLVNAUVTIGVMZUJZVOUWFUDUXEUQZUWGAUVTUWAUXEAUVTUWAVPUJZUIZUWAADUX
      GVOUVTUXHVOADUWOUXGUXCAUWNUXGVOZLJUQUWOUXGVOAUXILJAUWHJVQZVRZUWNUWRVPUJZU
      XGUWRVPUWNWHZUWNUXLVOUWSUXMUXBUWRUWNVSVTUWRVPUWNWAVGUXKUWJBVOUWRUWAVOUXLU
      XGVOUXKUWIBAJBUWHGAJBGWBZJBGWHQJBGWCWDWEWFUWJBIWGUWRUWAVPWIWJWKWLLJUWNUXG
      WMWNWODUXGWPWDVPWTWQUXHUWAUKWRUWAVPXAVGWSZAUXDBIAUXNUXDBUKQJBGXBWDXCZXDAU
      WKUFUNZXEZUWDDUOZUEUPZUFUXDUQZMIUQZUXFAUYBUWKNUNZGURZXEZUWDDUOZUEUPZNJUQZ
      MIUQAUYGMNIJAUWKIVQZUYCJVQZVRZVRZUYFUWDUWKUYCEUTGURZUKZXFZUEXGUYGUYLUYOUE
      UYFUYEUWDXEZDVQZUYLUYNUYEUWDDXHUYLUYQUYPUWOVQZUYNAUYQUYRXIUYKADUWOUYPUXCX
      JXKUYRUYPUWNVQZLJXLUYLUYNLUYPJUWNXMUYLUYSUYNLJAUYKUXJUYSUYNXFZUYKUXJVRAUY
      IUYJUXJXNZUYTUYIUYJUXJXOAVUAVRZUYSUYNVUBUYSVRUWDUWMUYMUYSUWDUWMUKVUBUYSUY
      EUWNURZUWDUWMUWNUHUYSVUCUWDUKXFMUDIUWJUWMUWNUWTXPUYEUWDUWNXQVGUYSVUCUWKUY
      DUWNUTZUWMUWKUYDUWNXRUYSUYIUYDUWJVQZVRZVUDUWMUKUYSUYEUWRVQVUFUYSUYEUWNUIZ
      UWRUYEUWDUWNUWKUYDXSUEYEXTMUDIUWJUWMUWNUWTUXAYAZYBUWKUYDIUWJYCYDZUGUFUWKU
      YDIUWJUGUNZUWHEUTZGURZUWMUWNUWMUGMYFVUKUWLGVUJUWKUWHEYGYHZUXQUYDUKZUWMYIM
      UDUGUFIUWJUWMVULVULMUGYFVULUWMVULUWMUKUGMVUMYJYKUDUFYFVULYIUUGUXAUUAWDUUB
      UUCUUDUYSVUBUYDUWIUKZUYMUWMUKZUYSVUEVUOUYSUYIVUEVUIUUHUYDUWIUUEWDVUBVUOVU
      PUCUUFUUIUUJUUKUULUUMUUNYLUUOYLUUQUYFUEUYMUUPWDYMAUYAUYHMIAUXNGJULZUYAUYH
      XIQJBGUURZUXTUYGUFNJGVUNUXSUYFUEVUNUXRUYEUWDDUXQUYDUWKYNUUSYPYQWJYOYRUWFU
      XTUDMUFIUXDUWCUXRUKUWEUXSUEUWCUXRUWDDUVGYPYSWNUWFUDUVTUXEUUTUVAUDUEDUVBYT
      AUVTUWAUXOAUWAUXEUVTUXPAUWCUVTVQZUDUXEUQZUXEUVTVOAUXRUVTVQZUFUXDUQZMIUQZV
      UTAVVCUWKUWIXEZUVTVQZLJUQZMIUQAVVEMLIJAUYIUXJVRVRZUWRUVTVVDVVGUWRVUGUVTVU
      HVVGUWNDVOZVUGUVTVOAUXJVVHUYIAVVHLJAUWODVOZVVHLJUQADUWOUKVVIUXCUWODUVCWDL
      JUWNDWMYDUVDUVEUWNDWPWDUVFVVGUYIUWIUWJVQVVDUWRVQAUYIUXJUVHUWIUWHGVDUVIUWK
      UWIIUWJUVJUVKUVLYMAVVBVVFMIAUXNVUQVVBVVFXIQVURVVAVVEUFLJGUXQUWIUKUXRVVDUV
      TUXQUWIUWKYNUVRYQWJYOYRVUSVVAUDMUFIUXDUWCUXRUVTUVMYSWNUDUXEUVTUVNWNUVOUVP
      DUWAUVQYT $.

    $( The value of an image structure's scalar multiplication.  (Contributed
       by Mario Carneiro, 24-Feb-2015.) $)
    imasvscaval $p |- ( ( ph /\ X e. K /\ Y e. V ) ->
      ( X .xb ( F ` Y ) ) = ( F ` ( X .x. Y ) ) ) $=
      ( vx wcel w3a cfv co csn cmpt2 cop wfun wss cdm wceq cxp imasvscafn fnfun
      wfn syl 3ad2ant1 ciun eqidd fveq2 sneqd oveq2 fveq2d mpt2eq123dv 3ad2ant3
      ssiun2s imasvsca sseqtr4d fvex snid opelxpi sylancl eqid dmmpt2 syl6eleqr
      cv simp2 funssfv syl3anc df-ov 3eqtr4g oveq1 ovmpt2 eqtrd ) AKIUGZLJUGZUH
      ZKLGUIZDUJZKWNOUFIWNUKZOWBZLEUJZGUIZULZUJZKLEUJZGUIZWMKWNUMZDUIZXDWTUIZWO
      XAWMDUNZWTDUOXDWTUPZUGXEXFUQAWKXGWLADIBURZVAXGABCDEFGHIJMNOPQRSTUAUBUCUDU
      EUSXIDUTVBVCWMWTNJOUFINWBZGUIZUKZWQXJEUJZGUIZULZVDZDWLAWTXPUOWKNJXOLWTXJL
      UQZOUFIXLXNIWPWSXQIVEXQXKWNXJLGVFVGXQXMWRGXJLWQEVHVIVJVLVKAWKDXPUQWLAUFBC
      DEFGHIJMNOQRSTUAUBUCUDVMVCVNWMXDIWPURZXHWMWKWNWPUGZXDXRUGAWKWLWCZWNLGVOVP
      ZKWNIWPVQVROUFIWPWSWTWTVSZWRGVOVTWAXDDWTWDWEKWNDWFKWNWTWFWGWMWKXSXAXCUQXT
      YAOUFKWNIWPWSXCWTXCWQKUQWRXBGWQKLEWHVIUFWBWNUQXCVEYBXBGVOWIVRWJ $.

    imasvscaf.c $e |- ( ( ph /\ ( p e. K /\ q e. V ) ) -> ( p .x. q ) e. V ) $.
    $( The image structure's scalar multiplication is closed in the base set.
       (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    imasvscaf $p |- ( ph -> .xb : ( K X. B ) --> B ) $=
      ( vx cxp wfn wss wf imasvscafn cv cfv co cmpt2 ciun imasvsca wral wcel wa
      csn wfo fof syl ffvelrnda syldan ralrimivw anass1rs ralrimiva fmpt2 sylib
      eqid fssxp snssd xpss2 xpss1 3syl sstrd iunss sylibr eqsstrd sylanbrc
      dff2 ) ADIBUFZUGDWCBUFZUHWCBDUIABCDEFGHIJKLMNOPQRSTUAUBUCUJADLJMUEILUKZGU
      LZUTZMUKZWEEUMZGULZUNZUOZWDAUEBCDEFGHIJKLMOPQRSTUAUBUPAWKWDUHZLJUQWLWDUHA
      WMLJAWEJURZUSZWKIWGUFZBUFZWDWOWPBWKUIZWKWQUHWOWJBURZUEWGUQZMIUQWRWOWTMIAW
      HIURZWNWTAXAWNUSZUSWSUEWGAXBWIJURWSUDAJBWIGAJBGVAJBGUIQJBGVBVCZVDVEVFVGVH
      MUEIWGWJBWKWKVKVIVJWPBWKVLVCWOWGBUHWPWCUHWQWDUHWOWFBAJBWEGXCVDVMWGBIVNWPW
      CBVOVPVQVHLJWKWDVRVSVTWCBDWBWA $.
  $}

  ${
    imasless.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasless.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasless.f $e |- ( ph -> F : V -onto-> B ) $.
    imasless.r $e |- ( ph -> R e. Z ) $.
    imasless.l $e |- .<_ = ( le ` U ) $.
    $( The order relation defined on an image set is a subset of the base set.
       (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    imasless $p |- ( ph -> .<_ C_ ( B X. B ) ) $=
      ( ccom ccnv cxp cdm crn wss cima cple cfv eqid wrel relco relssdmrn ax-mp
      imasle dmco wceq wfo wf fof frel 3syl sylib imaeq1d imassrn forn syl5sseq
      dfrel2 syl eqsstrd syl5eqss rncoss rnco2 syl5ss xpss12 syl2anc ) AFECUAUB
      ZNZEOZNZBBPZABCDEFVJGHIJKLVJUCMUHAVMVMQZVMRZPZVNVMUDVMVQSVKVLUEVMUFUGAVOB
      SVPBSVQVNSAVOVLOZVKQZTZBVKVLUIAVTEVSTZBAVREVSAEUDZVREUJAGBEUKZGBEULWBKGBE
      UMGBEUNUOEVAUPUQAERZWABEVSURAWCWDBUJKGBEUSVBZUTVCVDAVPVKRZBVKVLVEAWFEVJRZ
      TZBEVJVFAWDWHBEWGURWEUTVDVGVOBVPBVHVIVGVC $.

    $d c d .<_ $.  $d a b c d F $.  $d a b c d N $.  $d a b c d V $.  $d d Y $.
    $d a b c d ph $.  $d c d X $.
    imasleval.n $e |- N = ( le ` R ) $.
    imasleval.e $e |- ( ( ph /\ ( a e. V /\ b e. V ) /\ ( c e. V /\ d e. V ) )
      -> ( ( ( F ` a ) = ( F ` c ) /\ ( F ` b ) = ( F ` d ) )
        -> ( a N b <-> c N d ) ) ) $.
    $( The value of the image structure's ordering when the order is compatible
       with the mapping function.  (Contributed by Mario Carneiro,
       24-Feb-2015.) $)
    imasleval $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
      ( ( F ` X ) .<_ ( F ` Y ) <-> X N Y ) ) $=
      ( wcel cfv wbr wb wa cv wi fveq2 breq1d breq1 bibi12d imbi2d breq2d breq2
      wceq ccom ccnv wrex cdm wfn wfo fofn syl adantr fndm rexeqdv sylan anbi1d
      fnbrfvb wex ancom vex breldm pm4.71ri bitri exbii df-rex 3bitr4i ad2antrr
      fvex brco 3expa an32s anassrs impl pm5.32da bitr3d rexbidva syl6bb simprr
      r19.41v eqeq1d rspcev sylancl biantrurd 3bitr4d syl5bb bitrd brcnv anbi1i
      eqid 3bitr4ri 3bitr3g imasle breqd simprl expcom vtocl2ga com12 3impib )
      AIHUCZJHUCZIEUDZJEUDZFUEZIJGUEZUFZXMXNUGAXSANUHZEUDZOUHZEUDZFUEZXTYBGUEZU
      FZUIAXOYCFUEZIYBGUEZUFZUIAXSUINOIJHHXTIUQZYFYIAYJYDYGYEYHYJYAXOYCFXTIEUJU
      KXTIYBGULUMUNYBJUQZYIXSAYKYGXQYHXRYKYCXPXOFYBJEUJUOYBJIGUPUMUNAXTHUCZYBHU
      CZUGZYFAYNUGZYAYCEGURZEUSZURZUEZLUHZEUDZYAUQZLHUTZYEUGZYDYEYOYTYAEUEZYTYC
      YPUEZUGZLEVAZUTZUUBYEUGZLHUTZYSUUDYOUUIUUGLHUTUUKYOUUGLUUHHYOEHVBZUUHHUQA
      UULYNAHBEVCUULRHBEVDVEVFZHEVGVEZVHYOUUGUUJLHYOYTHUCZUGZUUBUUFUGUUGUUJUUPU
      UBUUEUUFYOUULUUOUUBUUEUFUUMHYTYAEVKVIVJUUPUUBUUFYEUUFMUHZYCEUEZYTUUQGUEZU
      GZMUUHUTZUUPUUBUGZYEUUSUURUGZMVLUUQUUHUCZUUTUGZMVLUUFUVAUVCUVEMUVCUUTUVEU
      USUURVMUUTUVDUURUVDUUSUUQYCEMVNYBEWBZVOVFVPVQVRMYTYCEGLVNZUVFWCUUTMUUHVSV
      TUVBUUTMHUTZUUQEUDZYCUQZMHUTZYEUGZUVAYEUVBUVHUVJYEUGZMHUTUVLUVBUUTUVMMHUV
      BUUQHUCZUGZUVJUUSUGZUUTUVMUVOUVJUURUUSUVBUULUVNUVJUURUFYOUULUUOUUBUUMWAHU
      UQYCEVKVIVJUUPUVNUUBUVPUVMUFUUPUVNUGZUUBUGUVJUUSYEUVQUUBUVJUUSYEUFZYOUUOU
      VNUUBUVJUGUVRUIZAUUOUVNUGZYNUVSAUVTYNUVSUBWDWEWFWGWHWEWIWJUVJYEMHWMWKYOUV
      AUVHUFUUOUUBYOUUTMUUHHUUNVHWAYOYEUVLUFUUOUUBYOUVKYEYOYMYCYCUQZUVKAYLYMWLY
      CXCUVJUWAMYBHUUQYBUQUVIYCYCUUQYBEUJWNWOWPWQWAWRWSWHWIWJWTYAYTYQUEZUUFUGZL
      VLYTUUHUCZUUGUGZLVLYSUUIUWCUWELUWCUUGUWEUWBUUEUUFYAYTEXTEWBZUVGXAXBUUGUWD
      UUEUWDUUFYTYAEUVGUWFVOVFVPVQVRLYAYCYPYQUWFUVFWCUUGLUUHVSXDUUBYELHWMXEYOFY
      RYAYCAFYRUQYNABCDEFGHKPQRSUATXFVFXGYOUUCYEYOYLYAYAUQZUUCAYLYMXHYAXCUUBUWG
      LXTHYTXTUQUUAYAYAYTXTEUJWNWOWPWQWRXIXJXKXL $.
  $}

  ${
    $d e r x y .~ $.  $d e r F $.  $d e r x ph $.  $d e r x R $.  $d x y V $.
    divsval.u $e |- ( ph -> U = ( R /s .~ ) ) $.
    divsval.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divsval.f $e |- F = ( x e. V |-> [ x ] .~ ) $.
    divsval.e $e |- ( ph -> .~ e. W ) $.
    divsval.r $e |- ( ph -> R e. Z ) $.
    $( Value of a quotient structure.  (Contributed by Mario Carneiro,
       23-Feb-2015.) $)
    divsval $p |- ( ph -> U = ( F "s R ) ) $=
      ( vr ve cimas cvv wceq wcel cqus co cv cbs cfv cec cmpt cmpt2 df-divs a1i
      simprl fveq2d adantr eqtr4d eceq2 ad2antll mpteq12dv syl6eqr oveq12d elex
      wa syl ovex ovmpt2d eqtrd ) AEDCUAUBFDQUBZJAOPDCRRBOUCZUDUEZBUCZPUCZUFZUG
      ZVGQUBZVFUARUAOPRRVMUHSABPOUIUJAVGDSZVJCSZVAZVAZVLFVGDQVQVLBGVICUFZUGFVQB
      VHVKGVRVQVHDUDUEZGVQVGDUDAVNVOUKZULAGVSSVPKUMUNVOVKVRSAVNVJCVIUOUPUQLURVT
      USADITDRTNDIUTVBACHTCRTMCHUTVBVFRTAFDQVCUJVDVE $.

    $( The function in ~ divsval is a surjection onto a quotient set.
       (Contributed by Mario Carneiro, 23-Feb-2015.) $)
    divslem $p |- ( ph -> F : V -onto-> ( V /. .~ ) ) $=
      ( vy wfo cv cvv wcel syl crn cqs wfn cec wral ecexg ralrimivw fnmpt dffn4
      sylib wceq wb wrex cab rnmpt df-qs eqtr4i foeq3 ax-mp ) AGFUAZFPZGGCUBZFP
      ZAFGUCZVAABQZCUDZRSZBGUEVDAVGBGACHSVGMVEHCUFTUGBGVFFRLUHTGFUIUJUTVBUKVAVC
      ULUTOQVFUKBGUMOUNVBBOGVFFLUOBOGCUPUQUTVBGFURUSUJ $.
  $}

  ${
    $d e r x y .~ $.  $d e r F $.  $d e r x ph $.  $d e r x R $.  $d x y V $.
    divsin.u $e |- ( ph -> U = ( R /s .~ ) ) $.
    divsin.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divsin.e $e |- ( ph -> .~ e. W ) $.
    divsin.r $e |- ( ph -> R e. Z ) $.
    divsin.s $e |- ( ph -> ( .~ " V ) C_ V ) $.
    $( Restrict the equivalence relation in a quotient structure to the base
       set.  (Contributed by Mario Carneiro, 23-Feb-2015.) $)
    divsin $p |- ( ph -> U = ( R /s ( .~ i^i ( V X. V ) ) ) ) $=
      ( vx cec cmpt cimas co wcel eqid divsval cv cxp cin cqus cima wceq ecinxp
      wss sylan mpteq2dva oveq1d cvv eqidd inex1g syl 3eqtr4d ) AMEMUAZBNZOZCPQ
      MEUQBEEUBZUCZNZOZCPQDCVAUDQZAUSVCCPAMEURVBABEUEEUHUQERURVBUFLEUQBUGUIUJUK
      AMBCDUSEFGHIUSSJKTAMVACVDVCEULGAVDUMIVCSABFRVAULRJBUTFUNUOKTUP $.
  $}

  ${
    $d x .~ $.  $d x ph $.  $d x R $.  $d x V $.
    divsbas.u $e |- ( ph -> U = ( R /s .~ ) ) $.
    divsbas.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divsbas.e $e |- ( ph -> .~ e. W ) $.
    divsbas.r $e |- ( ph -> R e. Z ) $.
    $( Base set of a quotient structure.  (Contributed by Mario Carneiro,
       23-Feb-2015.) $)
    divsbas $p |- ( ph -> ( V /. .~ ) = ( Base ` U ) ) $=
      ( vx cqs cv cec cmpt eqid divsval divslem imasbas ) AEBMCDLELNBOPZEGALBCD
      UAEFGHIUAQZJKRIALBCDUAEFGHIUBJKSKT $.

    divssca.k $e |- K = ( Scalar ` R ) $.
    $( The scalar field of a quotient structure.  (Contributed by Mario
       Carneiro, 24-Feb-2015.) $)
    divssca $p |- ( ph -> K = ( Scalar ` U ) ) $=
      ( vx cqs cv cec cmpt eqid divsval divslem imassca ) AFBOCDNFNPBQRZEFHANBC
      DUCFGHIJUCSZKLTJANBCDUCFGHIJUDKLUALMUB $.
  $}

  ${
    $d x .~ $.  $d a b x A $.  $d b x B $.  $d x C $.  $d x D $.  $d a b x V $.
    $d a b x .+ $.  $d a b x ph $.
    ercpbl.r $e |- ( ph -> .~ Er V ) $.
    ercpbl.v $e |- ( ph -> V e. _V ) $.
    ercpbl.f $e |- F = ( x e. V |-> [ x ] .~ ) $.
    $( Value of the function in ~ divsval .  (Contributed by Mario Carneiro,
       24-Feb-2015.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    divsfval $p |- ( ph -> ( F ` A ) = [ A ] .~ ) $=
      ( wcel cec wceq cvv ecss ssexd wn c0 cdm syl eleq2d cfv eceq1 fvmptg cmpt
      cv sylan2 expcom wa dmeqi wral ralrimivw dmmptg syl5eq notbid syl6bir wne
      ndmfv ecdmn0 wer erdm biimpd syl5bir necon1bd jcad eqtr3 syl6 pm2.61d ) A
      CFJZCEUAZCDKZLZVHAVKAVHVJMJVKAVJFMHACDFGNOBCBUEZDKZVJFMEVLCDUBIUCUFUGAVHP
      ZVIQLZVJQLZUHVKAVNVOVPAVNCERZJZPVOAVRVHAVQFCAVQBFVMUDZRZFEVSIUIAVMMJZBFUJ
      VTFLAWABFAVMFMHAVLDFGNOUKBFVMMULSUMTUNCEUQUOAVHVJQVJQUPCDRZJZAVHCDURAWCVH
      AWBFCAFDUSWBFLGFDUTSTVAVBVCVDVIVJQVEVFVG $.

    ${
      ercpbllem.1 $e |- ( ph -> A e. V ) $.
      $( Lemma for ~ ercpbl .  (Contributed by Mario Carneiro, 24-Feb-2015.) $)
      ercpbllem $p |- ( ph -> ( ( F ` A ) = ( F ` B ) <-> A .~ B ) ) $=
        ( cfv wceq cec wbr divsfval eqeq12d erth bitr4d ) ACFLZDFLZMCENZDENZMCD
        EOATUBUAUCABCEFGHIJPABDEFGHIJPQACDEGHKRS $.
    $}

    ${
      ercpbl.c $e |- ( ( ph /\ ( a e. V /\ b e. V ) ) -> ( a .+ b ) e. V ) $.
      ercpbl.e $e |- ( ph ->
        ( ( A .~ C /\ B .~ D ) -> ( A .+ B ) .~ ( C .+ D ) ) ) $.
      $( Translate the function compatiblity relation to a quotient set.
         (Contributed by Mario Carneiro, 24-Feb-2015.)  (Revised by Mario
         Carneiro, 12-Aug-2015.) $)
      ercpbl $p |- ( ( ph /\ ( A e. V /\ B e. V ) /\ ( C e. V /\ D e. V ) ) ->
        ( ( ( F ` A ) = ( F ` C ) /\ ( F ` B ) = ( F ` D ) ) ->
          ( F ` ( A .+ B ) ) = ( F ` ( C .+ D ) ) ) ) $=
        ( wcel wa cfv w3a wbr co wceq 3ad2ant1 wer cvv simp2l ercpbllem anbi12d
        wi simp2r caovclg 3adant3 3imtr4d ) ACJRZDJRZSZEJRFJRSZUAZCEHUBZDFHUBZS
        ZCDGUCZEFGUCZHUBZCITEITUDZDITFITUDZSVDITVEITUDAURVCVFUKUSQUEUTVGVAVHVBU
        TBCEHIJAURJHUFUSMUEZAURJUGRUSNUEZOAUPUQUSUHUIUTBDFHIJVIVJOAUPUQUSULUIUJ
        UTBVDVEHIJVIVJOAURVDJRUSAKLCDJJJGPUMUNUIUO $.
    $}

    erlecpbl.e $e |- ( ph ->
      ( ( A .~ C /\ B .~ D ) -> ( A N B <-> C N D ) ) ) $.
    $( Translate the relation compatiblity relation to a quotient set.
       (Contributed by Mario Carneiro, 24-Feb-2015.)  (Revised by Mario
       Carneiro, 12-Aug-2015.) $)
    erlecpbl $p |- ( ( ph /\ ( A e. V /\ B e. V ) /\ ( C e. V /\ D e. V ) ) ->
      ( ( ( F ` A ) = ( F ` C ) /\ ( F ` B ) = ( F ` D ) ) ->
        ( A N B <-> C N D ) ) ) $=
      ( wcel wa cfv wceq wbr 3ad2ant1 w3a wb wer cvv simp2l ercpbllem simp2r wi
      anbi12d sylbid ) ACJOZDJOZPZEJOFJOPZUAZCHQEHQRZDHQFHQRZPCEGSZDFGSZPZCDISE
      FISUBZUOUPURUQUSUOBCEGHJAUMJGUCUNKTZAUMJUDOUNLTZMAUKULUNUEUFUOBDFGHJVBVCM
      AUKULUNUGUFUIAUMUTVAUHUNNTUJ $.
  $}

  ${
    $d a b p q x .~ $.  $d a b p q F $.  $d a b p q x ph $.  $d a b p q x V $.
    $d p q x R $.  $d p q x .x. $.  $d p q x X $.  $d a b p q .xb $.
    $d p q x Y $.
    divsaddf.u $e |- ( ph -> U = ( R /s .~ ) ) $.
    divsaddf.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divsaddf.r $e |- ( ph -> .~ Er V ) $.
    divsaddf.z $e |- ( ph -> R e. Z ) $.
    divsaddf.e $e |- ( ph ->
      ( ( a .~ p /\ b .~ q ) -> ( a .x. b ) .~ ( p .x. q ) ) ) $.
    divsaddf.c $e |- ( ( ph /\ ( p e. V /\ q e. V ) ) ->
      ( p .x. q ) e. V ) $.
    ${
      divsaddflem.f $e |- F = ( x e. V |-> [ x ] .~ ) $.
      divsaddflem.g $e |- ( ph -> .xb = U_ p e. V U_ q e. V
          { <. <. ( F ` p ) , ( F ` q ) >. , ( F ` ( p .x. q ) ) >. } ) $.
      $( Value of an operation defined on a quotient structure.  (Contributed
         by Mario Carneiro, 24-Feb-2015.) $)
      divsaddvallem $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
        ( [ X ] .~ .xb [ Y ] .~ ) = [ ( X .x. Y ) ] .~ ) $=
        ( wcel w3a cfv co cec cqs cvv wer cbs fvex syl6eqel erex divslem ercpbl
        sylc cv imasaddvallem 3ad2ant1 divsfval oveq12d 3eqtr3d ) AJIUEZKIUEZUF
        ZJHUGZKHUGZEUHJKFUHZHUGJCUIZKCUIZEUHVKCUIAICUJEFHIJKMNOPABCDGHIUKLQRUCA
        ICULZIUKUEZCUKUESAIDUMUGUKRDUMUNUOZICUKUPUSTUQABOUTPUTNUTMUTFCHINMSVPUC
        UBUAURUDVAVHVIVLVJVMEVHBJCHIAVFVNVGSVBZAVFVOVGVPVBZUCVCVHBKCHIVQVRUCVCV
        DVHBVKCHIVQVRUCVCVE $.

      $( The operation of a quotient structure is a function.  (Contributed by
         Mario Carneiro, 24-Feb-2015.) $)
      divsaddflem $p |- ( ph ->
        .xb : ( ( V /. .~ ) X. ( V /. .~ ) ) --> ( V /. .~ ) ) $=
        ( cqs cvv wer wcel cbs fvex syl6eqel erex divslem cv ercpbl imasaddflem
        cfv sylc ) AICUCEFHIKLMNABCDGHIUDJOPUAAICUEIUDUFCUDUFQAIDUGUOUDPDUGUHUI
        ZICUDUJUPRUKABMULNULLULKULFCHILKQUQUATSUMUBTUN $.
    $}

    ${
      divsaddf.p $e |- .x. = ( +g ` R ) $.
      divsaddf.a $e |- .xb = ( +g ` U ) $.
      $( The base set of an image structure.  (Contributed by Mario Carneiro,
         24-Feb-2015.) $)
      divsaddval $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
        ( [ X ] .~ .xb [ Y ] .~ ) = [ ( X .x. Y ) ] .~ ) $=
        ( vx cec cmpt eqid cqs cvv wer wcel cbs fvex syl6eqel erex sylc divsval
        cv cfv divslem imasplusg divsaddvallem ) AUCBCDEFUCGUCUQBUDUEZGHIJKLMNO
        PQRSTVBUFZAGBUGEDCFVBGJKLAUCBCFVBGUHJOPVCAGBUIGUHUJBUHUJQAGCUKURUHPCUKU
        LUMGBUHUNUOZRUPPAUCBCFVBGUHJOPVCVDRUSRUAUBUTVA $.

      $( The base set of an image structure.  (Contributed by Mario Carneiro,
         24-Feb-2015.) $)
      divsaddf $p |- ( ph ->
        .xb : ( ( V /. .~ ) X. ( V /. .~ ) ) --> ( V /. .~ ) ) $=
        ( vx cec cmpt eqid cqs cvv wer wcel cbs fvex syl6eqel erex sylc divsval
        cv cfv divslem imasplusg divsaddflem ) AUABCDEFUAGUAUOBUBUCZGHIJKLMNOPQ
        RUTUDZAGBUEEDCFUTGHIJAUABCFUTGUFHMNVAAGBUGGUFUHBUFUHOAGCUIUPUFNCUIUJUKG
        BUFULUMZPUNNAUABCFUTGUFHMNVAVBPUQPSTURUS $.
    $}

    ${
      divsmulf.p $e |- .x. = ( .r ` R ) $.
      divsmulf.a $e |- .xb = ( .r ` U ) $.
      $( The base set of an image structure.  (Contributed by Mario Carneiro,
         24-Feb-2015.) $)
      divsmulval $p |- ( ( ph /\ X e. V /\ Y e. V ) ->
        ( [ X ] .~ .xb [ Y ] .~ ) = [ ( X .x. Y ) ] .~ ) $=
        ( vx cec cmpt eqid cqs cvv wer wcel cbs fvex syl6eqel erex sylc divsval
        cv cfv divslem imasmulr divsaddvallem ) AUCBCDEFUCGUCUQBUDUEZGHIJKLMNOP
        QRSTVBUFZAGBUGCDEFVBGJKLAUCBCFVBGUHJOPVCAGBUIGUHUJBUHUJQAGCUKURUHPCUKUL
        UMGBUHUNUOZRUPPAUCBCFVBGUHJOPVCVDRUSRUAUBUTVA $.

      $( The base set of an image structure.  (Contributed by Mario Carneiro,
         24-Feb-2015.) $)
      divsmulf $p |- ( ph ->
        .xb : ( ( V /. .~ ) X. ( V /. .~ ) ) --> ( V /. .~ ) ) $=
        ( vx cec cmpt eqid cqs cvv wer wcel cbs fvex syl6eqel erex sylc divsval
        cv cfv divslem imasmulr divsaddflem ) AUABCDEFUAGUAUOBUBUCZGHIJKLMNOPQR
        UTUDZAGBUECDEFUTGHIJAUABCFUTGUFHMNVAAGBUGGUFUHBUFUHOAGCUIUPUFNCUIUJUKGB
        UFULUMZPUNNAUABCFUTGUFHMNVAVBPUQPSTURUS $.
    $}
  $}

  $( A short expression for the pair function mapping ` 0 ` to ` A ` and ` 1 `
     to ` B ` .  (Contributed by Mario Carneiro, 14-Aug-2015.) $)
  xpsc $p |- `' ( { A } +c { B } ) =
    ( ( { (/) } X. { A } ) u. ( { 1o } X. { B } ) ) $=
    ( csn ccda co ccnv cxp c1o cun cvv wcel wceq snex cdaval mp2an cnveqi cnvun
    c0 cnvxp uneq12i 3eqtri ) ACZBCZDEZFUBRCZGZUCHCZGZIZFUFFZUHFZIUEUBGZUGUCGZI
    UDUIUBJKUCJKUDUILAMBMUBUCJJNOPUFUHQUJULUKUMUBUESUCUGSTUA $.

  $( A short expression for the pair function mapping ` 0 ` to ` A ` and ` 1 `
     to ` B ` .  (Contributed by Mario Carneiro, 14-Aug-2015.) $)
  xpscg $p |- ( ( A e. V /\ B e. W ) ->
    `' ( { A } +c { B } ) = { <. (/) , A >. , <. 1o , B >. } ) $=
    ( wcel wa c0 csn cxp c1o cun cop ccda co ccnv wceq cvv xpsng mpan con0 xpsc
    cpr 0ex 1on uneq12 syl2an df-pr 3eqtr4g ) ACEZBDEZFGHAHZIZJHBHZIZKZGALZHZJB
    LZHZKZUKUMMNOUPURUBUIULUQPZUNUSPZUOUTPUJGQEUIVAUCGAQCRSJTEUJVBUDJBTDRSULUQU
    NUSUEUFABUAUPURUGUH $.

  $( The pair function is a function on ` 2o = { (/) , 1o } ` .  (Contributed
     by Mario Carneiro, 14-Aug-2015.) $)
  xpscfn $p |- ( ( A e. V /\ B e. W ) -> `' ( { A } +c { B } ) Fn 2o ) $=
    ( wcel wa csn ccda co ccnv c2o wfn c0 cop c1o cpr cvv con0 0ex 1on wne 1n0
    necomi fnprg mp3an3 mpanl12 df2o3 fneq2i sylibr xpscg fneq1d mpbird ) ACEBD
    EFZAGBGHIJZKLMANOBNPZKLZUMUOMOPZLZUPMQEZOREZUMURSTUSUTFUMMOUAUROMUBUCMOABQR
    CDUDUEUFKUQUOUGUHUIUMKUNUOABCDUJUKUL $.

  ${
    $d x A $.  $d x B $.
    $( The pair function maps ` 0 ` to ` A ` .  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    xpsc0 $p |- ( A e. V -> ( `' ( { A } +c { B } ) ` (/) ) = A ) $=
      ( vx wcel c0 csn cfv cxp c1o wfn cin wceq wfun cid cop wss cvv ax-mp a1i
      ccda co ccnv cun xpsc fveq1i cdm fnconstg cv vex fvi elsni fveq2d syl5eqr
      elsn sylibr ssriv xpss2 con0 1on elexi fvex sseqtri funsn funss mp2 funfn
      xpsn mpbi dmxpss sslin wne 1n0 necomi disjsn2 sseq0 mp2an fvun1 syl112anc
      0ex snid syl5eq wa xpsng fveq1d fvsng eqtrd mpan ) ACEZFAGZBGZUAUBUCZHZFF
      GZWJIZHZAWIWMFWOJGZWKIZUDZHZWPFWLWSABUEUFWIWOWNKWRWRUGZKZWNXALZFMZFWNEZWT
      WPMWNACUHXBWIWRNZXBWRJBOHZPGZQXHNXFWRWQXGGZIZXHWKXIQWRXJQDWKXIDUIZWKEZXKX
      GMXKXIEXLXKXKOHZXGXKREXMXKMDUJXKRUKSXLXKBOXKBULUMUNDXGUOUPUQWKXIWQURSJXGJ
      USUTVAZBOVBZVHVCJXGXNXOVDWRXHVEVFWRVGVITXDWIXCWNWQLZQZXPFMZXDXAWQQXQWQWKV
      JXAWQWNVKSFJVLXRJFVMVNFJVOSXCXPVPVQTXEWIFVTWATWNXAWOWRFVRVSWBFREZWIWPAMVT
      XSWIWCZWPFFAPGZHAXTFWOYAFARCWDWEFARCWFWGWHWG $.

    $( The pair function maps ` 1 ` to ` B ` .  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    xpsc1 $p |- ( B e. V -> ( `' ( { A } +c { B } ) ` 1o ) = B ) $=
      ( vx wcel c1o csn cfv cxp c0 wfn cin wceq wfun cid cop wss ax-mp a1i con0
      ccda co ccnv cun xpsc fveq1i cdm cv cvv vex fvi elsni fveq2d syl5eqr elsn
      sylibr ssriv xpss2 0ex fvex sseqtri funsn funss mp2 funfn fnconstg dmxpss
      xpsn mpbi ssrin wne necomi disjsn2 sseq0 mp2an elexi snid fvun2 syl112anc
      1n0 1on syl5eq wa xpsng fveq1d fvsng eqtrd mpan ) BCEZFAGZBGZUAUBUCZHZFFG
      ZWKIZHZBWIWMFJGZWJIZWOUDZHZWPFWLWSABUEUFWIWRWRUGZKZWOWNKXAWNLZJMZFWNEZWTW
      PMXBWIWRNZXBWRJAOHZPGZQXHNXFWRWQXGGZIZXHWJXIQWRXJQDWJXIDUHZWJEZXKXGMXKXIE
      XLXKXKOHZXGXKUIEXMXKMDUJXKUIUKRXLXKAOXKAULUMUNDXGUOUPUQWJXIWQURRJXGUSAOUT
      ZVHVAJXGUSXNVBWRXHVCVDWRVEVISWNBCVFXDWIXCWQWNLZQZXOJMZXDXAWQQXPWQWJVGXAWQ
      WNVJRJFVKXQFJVTVLJFVMRXCXOVNVOSXEWIFFTWAVPVQSXAWNWRWOFVRVSWBFTEZWIWPBMWAX
      RWIWCZWPFFBPGZHBXSFWOXTFBTCWDWEFBTCWFWGWHWG $.
  $}

  $( The value of the pair function at an element of ` 2o ` .  (Contributed by
     Mario Carneiro, 14-Aug-2015.) $)
  xpscfv $p |- ( ( A e. V /\ B e. W /\ C e. 2o ) ->
      ( `' ( { A } +c { B } ) ` C ) = if ( C = (/) , A , B ) ) $=
    ( wcel c2o csn ccda co ccnv cfv wceq cif c1o fveq2 eqeq12d syl5ibrcom wne
    c0 wo wa cpr elpri df2o3 eleq2s xpsc0 adantr iftrue xpsc1 adantl 1n0 mpbiri
    neeq1 ifnefalse syl jaod syl5 3impia ) ADFZBEFZCGFZCAHBHIJKZLZCTMZABNZMZVBV
    ECOMZUAZUTVAUBZVGVICTOUCGCTOUDUEUFVJVEVGVHVJVGVETVCLZAMZUTVLVAABDUGUHVEVDVK
    VFACTVCPVEABUIQRVJVGVHOVCLZBMZVAVNUTABEUJUKVHVDVMVFBCOVCPVHCTSZVFBMVHVOOTSU
    LCOTUNUMCTABUOUPQRUQURUS $.

  ${
    $d k A $.  $d k B $.  $d k G $.  $d k X $.  $d k Y $.
    $( Elementhood in the target space of the function ` F ` appearing in
       ~ xpsval .  (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    xpsfrnel $p |- ( G e. X_ k e. 2o if ( k = (/) , A , B ) <-> ( G Fn 2o /\
       ( G ` (/) ) e. A /\ ( G ` 1o ) e. B ) ) $=
      ( c2o c0 wceq wcel cfv wral w3a c1o wa fveq2 eleq12d wne syl bitri 3anass
      cfn cv cif cixp cvv wfn elixp2 3ancoma cpr df2o3 raleqi con0 elexi iftrue
      0ex 1on neeq1 mpbiri ifnefalse ralpr 2onn nnfi ax-mp fnfi mpan2 biantrurd
      1n0 com elex syl5rbbr pm5.32i 3bitr4i ) DCECUAZFGZABUBZUCHDUDHZDEUEZVLDIZ
      VNHZCEJZKZVPFDIZAHZLDIZBHZKZCEVNDUFVTVPVOVSKZWEVOVPVSUGVPVOVSMZMVPWBWDMZM
      WFWEVPWGWHWHVSVPWGVSVRCFLUHZJWHVRCEWIUIUJVRWBWDCFLUNLUKUOULVMVQWAVNAVLFDN
      VMABUMOVLLGZVQWCVNBVLLDNWJVLFPZVNBGWJWKLFPVFVLLFUPUQVLFABURQOUSRVPVOVSVPD
      THZVOVPETHZWLEVGHWMUTEVAVBEDVCVDDTVHQVEVIVJVPVOVSSVPWBWDSVKRR $.

    $( A function on ` 2o ` is determined by its values at zero and one.
       (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    xpsfeq $p |- ( G Fn 2o ->
       `' ( { ( G ` (/) ) } +c { ( G ` 1o ) } ) = G ) $=
      ( vk c2o wfn c0 cfv csn c1o ccda co ccnv cvv wcel fvex xpscfn mp2an ax-mp
      wceq fveq2 3eqtr4a a1i id cv wo cpr elpri df2o3 eleq2s xpsc0 xpsc1 adantl
      jaoi syl eqfnfvd ) ACDZBCEAFZGHAFZGIJKZAURCDZUOUPLMZUQLMZUSEANZHANZUPUQLL
      OPUAUOUBBUCZCMZVDURFZVDAFZRZUOVEVDERZVDHRZUDZVHVKVDEHUECVDEHUFUGUHVIVHVJV
      IEURFZUPVFVGUTVLUPRVBUPUQLUIQVDEURSVDEASTVJHURFZUQVFVGVAVMUQRVCUPUQLUJQVD
      HURSVDHASTULUMUKUN $.

    $( Elementhood in the target space of the function ` F ` appearing in
       ~ xpsval .  (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    xpsfrnel2 $p |- ( `' ( { X } +c { Y } ) e.
       X_ k e. 2o if ( k = (/) , A , B ) <-> ( X e. A /\ Y e. B ) ) $=
      ( csn c2o c0 wceq wcel cfv c1o wa cvv cxp cdm cun 0ex elsni sylbi ccda co
      ccnv cv cif cixp wfn w3a xpsfrnel cpr prid1 df2o3 eleqtrri fndm syl5eleqr
      xpsc dmeqi dmun eqtri syl6eleq wo elun wbr wex eldm brxp syl6eqelr adantl
      vex exlimiv dmxpss sseli 1n0 neii pm2.21i eqcoms 3syl jaoi syl con0 elexi
      1on prid2 jca 3ad2ant1 anim12i 3anass xpscfn biantrurd xpsc0 eleq1d xpsc1
      elex bi2anan9 bitr3d syl5bb pm5.21nii bitri ) DFZEFZUAUBUCZCGCUDZHIABUEUF
      JXAGUGZHXAKZAJZLXAKZBJZUHZDAJZEBJZMZABCXAUIXHDNJZENJZMZXKXCXEXNXGXCXLXMXC
      HHFZWSOZPZLFZWTOZPZQZJZXLXCHXAPZYAXCHGYCHHLUJZGHLRUKULUMGXAUNZUOYCXPXSQZP
      YAXAYFDEUPUQXPXSURUSZUTYBHXQJZHXTJZVAXLHXQXTVBYHXLYIYHHXBXPVCZCVDXLCHXPRV
      EYJXLCYJHXOJZXBWSJZMXLHXBXOWSVFYLXLYKYLDXBNXBDSCVIZVGVHTVJTYIHXRJHLIXLXTX
      RHXRWTVKVLHLSXLLHLHIZXLLHVMVNZVOVPVQVRTVSXCLYAJZXMXCLYCYAXCLGYCLYDGHLLVTW
      BWAZWCULUMYEUOYGUTYPLXQJZLXTJZVAXMLXQXTVBYRXMYSYRLXOJYNXMXQXOLXOWSVKVLLHS
      YNXMYOVOVQYSLXBXSVCZCVDXMCLXSYQVEYTXMCYTLXRJZXBWTJZMXMLXBXRWTVFUUBXMUUAUU
      BEXBNXBESYMVGVHTVJTVRTVSWDWEXIXLXJXMDAWMEBWMWFXHXCXEXGMZMZXNXKXCXEXGWGXNU
      UCUUDXKXNXCUUCDENNWHWIXLXEXIXMXGXJXLXDDADENWJWKXMXFEBDENWLWKWNWOWPWQWR $.

    $( Equivalent condition for the pair function to be a proper function on
       ` A ` .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xpscf $p |- ( `' ( { X } +c { Y } ) : 2o --> A <->
        ( X e. A /\ Y e. A ) ) $=
      ( vk c2o csn ccda co ccnv wf cv c0 wceq cif cixp wcel wa wfn cfv wral
      ifid eleq2i ralbii anbi2i ovex cnvex elixp ffnfv 3bitr4i xpsfrnel2 bitr3i
      ) EABFZCFZGHZIZJZUODEDKZLMZAANZOPZBAPCAPQUOERZUQUOSZUSPZDETZQVAVBAPZDETZQ
      UTUPVDVFVAVCVEDEUSAVBURAUAUBUCUDDEUSUOUNULUMGUEUFUGDEAUOUHUIAADBCUJUK $.
  $}

  ${
    $d a b k w x y z A $.  $d a b w z F $.  $d k V $.  $d x y X $.  $d x y Y $.
    $d a b k w x y z B $.  $d k W $.
    xpsff1o.f $e |- F = ( x e. A , y e. B |-> `' ( { x } +c { y } ) ) $.
    $( The value of the function appearing in ~ xpsval .  (Contributed by Mario
       Carneiro, 15-Aug-2015.) $)
    xpsfval $p |- ( ( X e. A /\ Y e. B ) ->
      ( X F Y ) = `' ( { X } +c { Y } ) ) $=
      ( cv csn ccda co ccnv wceq wa sneq oveqan12d cnveqd ovex cnvex ovmpt2a )
      ABFGCDAIZJZBIZJZKLZMFJZGJZKLZMEUBFNZUDGNZOUFUIUJUKUCUGUEUHKUBFPUDGPQRHUIU
      GUHKSTUA $.

    $( The function appearing in ~ xpsval is a bijection from the cartesian
       product to the indexed cartesian product indexed on the pair
       ` 2o = { (/) , 1o } ` .  (Contributed by Mario Carneiro,
       15-Aug-2015.) $)
    xpsff1o $p |- F : ( A X. B ) -1-1-onto->
      X_ k e. 2o if ( k = (/) , A , B ) $=
      ( vz vw va vb cv c0 wceq cfv wral csn co wcel cvv cxp c2o cif cixp wf1 wf
      wf1o wfo wi ccda ccnv wa xpsfrnel2 biimpri rgen2 fmpt2 mpbi c1st c2nd cop
      1st2nd2 fveq2d df-ov xp1st xp2nd xpsfval syl2anc syl5eqr eqtrd fveq1 fvex
      eqeqan12d xpsc0 ax-mp 3eqtr3g xpsc1 opeq12d syl5ibr sylbid dff13 mpbir2an
      c1o wrex wfn xpsfrnel simp2bi simp3bi ixpfn xpsfeq eqtr2d rspceov syl3anc
      syl rgen foov df-f1o ) CDUAZEUBELMNCDUCZUDZFUGWQWSFUEZWQWSFUHZWTWQWSFUFZH
      LZFOZILZFOZNZXCXENZUIZIWQPHWQPALZQBLZQUJRUKZWSSZBDPACPXBXMABCDXMXJCSXKDSU
      LCDEXJXKUMUNUOABCDXLWSFGUPUQZXIHIWQWQXCWQSZXEWQSZULZXGXCUROZQXCUSOZQUJRUK
      ZXEUROZQXEUSOZQUJRUKZNZXHXOXPXDXTXFYCXOXDXRXSUTZFOZXTXOXCYEFXCCDVAZVBXOYF
      XRXSFRZXTXRXSFVCXOXRCSXSDSYHXTNXCCDVDXCCDVEABCDFXRXSGVFVGVHVIXPXFYAYBUTZF
      OZYCXPXEYIFXECDVAZVBXPYJYAYBFRZYCYAYBFVCXPYACSYBDSYLYCNXECDVDXECDVEABCDFY
      AYBGVFVGVHVIVLYDXHXQYEYINYDXRYAXSYBYDMXTOZMYCOZXRYAMXTYCVJXRTSYMXRNXCURVK
      XRXSTVMVNYATSYNYANXEURVKYAYBTVMVNVOYDWBXTOZWBYCOZXSYBWBXTYCVJXSTSYOXSNXCU
      SVKXRXSTVPVNYBTSYPYBNXEUSVKYAYBTVPVNVOVQXOXPXCYEXEYIYGYKVLVRVSUOHIWQWSFVT
      WAXAXBXCJLKLFRNKDWCJCWCZHWSPXNYQHWSXCWSSZMXCOZCSZWBXCOZDSZXCYSUUAFRZNYQYR
      XCUBWDZYTUUBCDEXCWEZWFZYRUUDYTUUBUUEWGZYRUUCYSQUUAQUJRUKZXCYRYTUUBUUCUUHN
      UUFUUGABCDFYSUUAGVFVGYRUUDUUHXCNEUBWRXCWHXCWIWMWJJKCDYSUUAXCFWKWLWNJKHCDW
      SFWOWAWQWSFWPWA $.

    $( A short expression for the indexed cartesian product on two indexes.
       (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    xpsfrn $p |- ran F = X_ k e. 2o if ( k = (/) , A , B ) $=
      ( cxp c2o cv c0 wceq cif cixp wf1o wfo crn xpsff1o f1ofo forn mp2b ) CDHZ
      EIEJKLCDMNZFOUBUCFPFQUCLABCDEFGRUBUCFSUBUCFTUA $.

    $( A short expression for the indexed cartesian product on two indexes.
       (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    xpsfrn2 $p |- ( ( A e. V /\ B e. W ) ->
      ran F = X_ k e. 2o ( `' ( { A } +c { B } ) ` k ) ) $=
      ( wcel wa c2o cv csn ccda co ccnv cfv cixp wceq c0 xpscfv 3expa ixpeq2dva
      cif crn xpsfrn syl6reqr ) CGJZDHJZKZELEMZCNDNOPQRZSELULUATCDUEZSFUFUKELUM
      UNUIUJULLJUMUNTCDULGHUBUCUDABCDEFIUGUH $.

    $( The function appearing in ~ xpsval is a bijection from the cartesian
       product to the indexed cartesian product indexed on the pair
       ` 2o = { (/) , 1o } ` .  (Contributed by Mario Carneiro,
       24-Jan-2015.) $)
    xpsff1o2 $p |- F : ( A X. B ) -1-1-onto-> ran F $=
      ( vk cxp c2o cv c0 wceq cif cixp wf1o wf1 crn xpsff1o f1of1 f1f1orn mp2b
      ) CDHZGIGJKLCDMNZEOUBUCEPUBEQEOABCDGEFRUBUCESUBUCETUA $.
  $}

  ${
    $d r s y $.  $d c k x y A $.  $d c k x y B $.  $d c d k x y C $.  $d k G $.
    $d c d k x y D $.  $d r s F $.  $d c d k r s S $.  $d k r s U $.  $d x W $.
    $d a b c d k ph $.  $d k x y .x. $.  $d k x y .X. $.  $d a b c d k x y X $.
    $d c d k r s x R $.  $d a b c d .xb $.  $d a b c d k x y Y $.
    xpsval.t $e |- T = ( R Xs. S ) $.
    xpsval.x $e |- X = ( Base ` R ) $.
    xpsval.y $e |- Y = ( Base ` S ) $.
    xpsval.1 $e |- ( ph -> R e. V ) $.
    xpsval.2 $e |- ( ph -> S e. W ) $.
    ${
      xpsval.f $e |- F = ( x e. X , y e. Y |-> `' ( { x } +c { y } ) ) $.
      xpsval.k $e |- G = ( Scalar ` R ) $.
      xpsval.u $e |- U = ( G Xs_ `' ( { R } +c { S } ) ) $.
      $( Value of the binary structure product function.  (Contributed by Mario
         Carneiro, 14-Aug-2015.) $)
      xpsval $p |- ( ph -> T = ( `' F "s U ) ) $=
        ( vr vs cxps co ccnv cimas cvv wcel wceq elex syl cv cbs cfv ccda cmpt2
        csn csca cprds wa fveq2 syl6eqr mpt2eq12 syl2an cnveqd adantr oveqan12d
        sneq oveq12d df-xps ovex ovmpt2a syl2anc syl5eq ) AFDEUDUEZHUFZGUGUEZNA
        DUHUIZEUHUIZVPVRUJADJUIVSQDJUKULAEKUIVTREKUKULUBUCDEUHUHBCUBUMZUNUOZUCU
        MZUNUOZBUMURCUMURUPUEUFZUQZUFZWAUSUOZWAURZWCURZUPUEZUFZUTUEZUGUEVRUDWAD
        UJZWCEUJZVAZWGVQWMGUGWPWFHWPWFBCLMWEUQZHWNWBLUJWDMUJWFWQUJWOWNWBDUNUOLW
        ADUNVBOVCWOWDEUNUOMWCEUNVBPVCBCWBWDLMWEVDVESVCVFWPWMIDURZEURZUPUEZUFZUT
        UEGWPWHIWLXAUTWPWHDUSUOZIWNWHXBUJWOWADUSVBVGTVCWPWKWTWNWOWIWRWJWSUPWADV
        IWCEVIVHVFVJUAVCVJBCUCUBVKVQGUGVLVMVNVO $.

      $( The indexed structure product that appears in ~ xpsval has the same
         base as the target of the function ` F ` .  (Contributed by Mario
         Carneiro, 15-Aug-2015.) $)
      xpslem $p |- ( ph -> ran F = ( Base ` U ) ) $=
        ( vk cbs cfv c2o cv csn ccda ccnv cixp crn cvv con0 eqid wcel csca fvex
        co eqeltri a1i 2on wfn xpscfn syl2anc prdsbas2 c0 wceq cif wa wi xpscfv
        3expia fveq2d ifeq12 mp2an fvif eqtr4i syl6eqr ixpeq2dva xpsfrn eqtr2d
        imp ) AGUCUDZUBUEUBUFZDUGEUGUHURUIZUDZUCUDZUJZHUKZAUBWCWEIUEULUMGUAWCUN
        IULUOAIDUPUDULTDUPUQUSUTUEUMUOAVAUTADJUOZEKUOZWEUEVBQRDEJKVCVDVEAWHUBUE
        WDVFVGZLMVHZUJWIAUBUEWGWMAWDUEUOZVIZWGWLDEVHZUCUDZWMWOWFWPUCAWNWFWPVGZA
        WJWKWNWRVJQRWJWKWNWRDEWDJKVKVLVDWBVMWMWLDUCUDZEUCUDZVHZWQLWSVGMWTVGWMXA
        VGOPWLLWSMWTVNVOWLDEUCVPVQVRVSBCLMUBHSVTVRWA $.
    $}

    $( The base set of the binary structure product.  (Contributed by Mario
       Carneiro, 15-Aug-2015.) $)
    xpsbas $p |- ( ph -> ( X X. Y ) = ( Base ` T ) ) $=
      ( vx vy csn ccda co ccnv eqid cxp csca cfv cprds cv crn cvv xpsval xpslem
      cmpt2 wf1o wfo xpsff1o2 f1ocnv ax-mp f1ofo mp1i wcel ovex a1i imasbas ) A
      GHUAZBUBUCZBPCPQRSZUDRZDNOGHNUEPOUEPQRSUJZSZVFUFZUGANOBCDVEVFVCEFGHIJKLMV
      FTZVCTZVETZUHANOBCDVEVFVCEFGHIJKLMVIVJVKUIVHVBVGUKZVHVBVGULAVBVHVFUKVLNOG
      HVFVIUMVBVHVFUNUOVHVBVGUPUQVEUGURAVCVDUDUSUTVA $.

    xpsadd.3 $e |- ( ph -> A e. X ) $.
    xpsadd.4 $e |- ( ph -> B e. Y ) $.
    xpsadd.5 $e |- ( ph -> C e. X ) $.
    xpsadd.6 $e |- ( ph -> D e. Y ) $.
    xpsadd.7 $e |- ( ph -> ( A .x. C ) e. X ) $.
    xpsadd.8 $e |- ( ph -> ( B .X. D ) e. Y ) $.
    ${
      xpsaddlem.m $e |- .x. = ( E ` R ) $.
      xpsaddlem.n $e |- .X. = ( E ` S ) $.
      xpsaddlem.p $e |- .xb = ( E ` T ) $.
      xpsaddlem.f $e |- F = ( x e. X , y e. Y |-> `' ( { x } +c { y } ) ) $.
      xpsaddlem.u $e |- U = ( ( Scalar ` R ) Xs_ `' ( { R } +c { S } ) ) $.
      xpsaddlem.1 $e |- ( ( ph /\
        `' ( { A } +c { B } ) e. ran F /\ `' ( { C } +c { D } ) e. ran F ) ->
    ( ( `' F ` `' ( { A } +c { B } ) ) .xb ( `' F ` `' ( { C } +c { D } ) ) ) =
      ( `' F ` ( `' ( { A } +c { B } ) ( E ` U ) `' ( { C } +c { D } ) ) ) ) $.
      xpsaddlem.2 $e |- ( ( `' ( { R } +c { S } ) Fn 2o /\
        `' ( { A } +c { B } ) e. ( Base ` U ) /\
        `' ( { C } +c { D } ) e. ( Base ` U ) ) ->
      ( `' ( { A } +c { B } ) ( E ` U ) `' ( { C } +c { D } ) ) =
        ( k e. 2o |-> ( ( `' ( { A } +c { B } ) ` k )
  ( E ` ( `' ( { R } +c { S } ) ` k ) ) ( `' ( { C } +c { D } ) ` k ) ) ) ) $.
      $( Lemma for ~ xpsadd and ~ xpsmul .  (Contributed by Mario Carneiro,
         15-Aug-2015.) $)
      xpsaddlem $p |- ( ph ->
        ( <. A , B >. .xb <. C , D >. ) = <. ( A .x. C ) , ( B .X. D ) >. ) $=
        ( csn ccda ccnv cfv cop crn wcel wceq df-ov xpsfval syl2anc syl5eqr cxp
        co opelxpi wf1o xpsff1o2 f1of ax-mp ffvelrni eqeltrrd mpd3an23 f1ocnvfv
        wf syl wi sylancr mpd oveq12d c2o cmpt wfn cbs xpscfn csca eqid eleqtrd
        cv xpslem syl3anc dffn5 sylib cif iftrue fveq2d syl6eqr oveq123d eqtr4d
        wa c0 wn iffalse pm2.61i adantr simpr xpscfv 3eqtr4a mpteq2dva 3eqtr3d
        eqtrd ) ADUTEUTVAVMVBZQVBZVCZFUTGUTVAVMVBZYAVCZJVMZXTYCNPVCVMZYAVCZDEVD
        ZFGVDZJVMDFLVMZEGMVMZVDZAXTQVEZVFYCYMVFYEYGVGAYHQVCZXTYMAYNDEQVMZXTDEQV
        HADTVFZEUAVFZYOXTVGUGUHBCTUAQDEUPVIVJVKZAYHTUAVLZVFZYNYMVFAYPYQYTUGUHDE
        TUAVNVJZYSYMYHQYSYMQVOZYSYMQWCBCTUAQUPVPZYSYMQVQVRZVSWDVTZAYIQVCZYCYMAU
        UFFGQVMZYCFGQVHAFTVFZGUAVFZUUGYCVGUIUJBCTUAQFGUPVIVJVKZAYIYSVFZUUFYMVFA
        UUHUUIUUKUIUJFGTUAVNVJZYSYMYIQUUDVSWDVTZURWAAYBYHYDYIJAYNXTVGZYBYHVGZYR
        AUUBYTUUNUUOWEUUCUUAYSYMYHXTQWBWFWGAUUFYCVGZYDYIVGZUUJAUUBUUKUUPUUQWEUU
        CUULYSYMYIYCQWBWFWGWHAYGYJUTYKUTVAVMVBZYAVCZYLAYFUURYAAYFOWIOWQZXTVCZUU
        TYCVCZUUTHUTIUTVAVMVBZVCZPVCZVMZWJZUURAUVCWIWKZXTNWLVCZVFYCUVIVFYFUVGVG
        AHRVFZISVFZUVHUEUFHIRSWMVJAXTYMUVIUUEABCHIKNQHWNVCZRSTUAUBUCUDUEUFUPUVL
        WOUQWRZWPAYCYMUVIUUMUVMWPUSWSAUUROWIUUTUURVCZWJZUVGAUURWIWKZUURUVOVGAYJ
        TVFZYKUAVFZUVPUKULYJYKTUAWMVJOWIUURWTXAAOWIUVFUVNAUUTWIVFZXHZUUTXIVGZDE
        XBZUWAFGXBZUWAHIXBZPVCZVMZUWAYJYKXBZUVFUVNUWAUWFUWGVGUWAUWFYJUWGUWAUWBD
        UWCFUWELUWAUWEHPVCLUWAUWDHPUWAHIXCXDUMXEUWADEXCUWAFGXCXFUWAYJYKXCXGUWAX
        JZUWFYKUWGUWHUWBEUWCGUWEMUWHUWEIPVCMUWHUWDIPUWAHIXKXDUNXEUWADEXKUWAFGXK
        XFUWAYJYKXKXGXLUVTUVAUWBUVBUWCUVEUWEUVTUVDUWDPUVTUVJUVKUVSUVDUWDVGAUVJU
        VSUEXMAUVKUVSUFXMAUVSXNZHIUUTRSXOWSXDUVTYPYQUVSUVAUWBVGAYPUVSUGXMAYQUVS
        UHXMUWIDEUUTTUAXOWSUVTUUHUUIUVSUVBUWCVGAUUHUVSUIXMAUUIUVSUJXMUWIFGUUTTU
        AXOWSXFUVTUVQUVRUVSUVNUWGVGAUVQUVSUKXMAUVRUVSULXMUWIYJYKUUTTUAXOWSXPXQX
        GXGXDAYLQVCZUURVGZUUSYLVGZAUWJYJYKQVMZUURYJYKQVHAUVQUVRUWMUURVGUKULBCTU
        AQYJYKUPVIVJVKAUUBYLYSVFZUWKUWLWEUUCAUVQUVRUWNUKULYJYKTUAVNVJYSYMYLUURQ
        WBWFWGXSXR $.
    $}

    ${
      xpsadd.m $e |- .x. = ( +g ` R ) $.
      xpsadd.n $e |- .X. = ( +g ` S ) $.
      xpsadd.p $e |- .xb = ( +g ` T ) $.
      $( Value of the addition operation in a binary structure product.
         (Contributed by Mario Carneiro, 15-Aug-2015.) $)
      xpsadd $p |- ( ph ->
        ( <. A , B >. .xb <. C , D >. ) = <. ( A .x. C ) , ( B .X. D ) >. ) $=
        ( vx vy vk vd vc va vb csca cfv ccda co ccnv cprds cplusg cv cmpt2 eqid
        csn cxp crn cvv wf1o wfo xpsff1o2 f1ocnv mp1i syl f1ocpbl xpsval xpslem
        f1ofo wcel ovex a1i imasaddval c2o wfn cbs con0 fvex simp1 prdsplusgval
        w3a 2on simp2 simp3 xpsaddlem ) AUJUKBCDEFGHIJKFUQURZFVGGVGUSUTVAZVBUTZ
        ULVCUJUKNOUJVDVGUKVDVGUSUTVAVEZLMNOPQRSTUAUBUCUDUEUFUGUHUIWTVFZWSVFZANO
        VHZWSHWSVCURZIWTVAZWTVIZBVGCVGUSUTVAZDVGEVGUSUTVAZVJUMUNUOUPAXFXCXEVKZX
        FXCXEVLXCXFWTVKXIAUJUKNOWTXAVMXCXFWTVNVOZXFXCXEVTVPAUOVDUPVDUNVDUMVDXDX
        EXFXCXJVQAUJUKFGIWSWTWQLMNOPQRSTXAWQVFZXBVRAUJUKFGIWSWTWQLMNOPQRSTXAXKX
        BVSWSVJWAAWQWRVBWBWCXDVFZUIWDWRWEWFZXGWSWGURZWAZXHXNWAZWLZULXNXDWRWQXGX
        HWEVJWHWSXBXNVFWQVJWAXQFUQWIWCWEWHWAXQWMWCXMXOXPWJXMXOXPWNXMXOXPWOXLWKW
        P $.
    $}

    ${
      xpsmul.m $e |- .x. = ( .r ` R ) $.
      xpsmul.n $e |- .X. = ( .r ` S ) $.
      xpsmul.p $e |- .xb = ( .r ` T ) $.
      $( Value of the multiplication operation in a binary structure product.
         (Contributed by Mario Carneiro, 15-Aug-2015.) $)
      xpsmul $p |- ( ph ->
        ( <. A , B >. .xb <. C , D >. ) = <. ( A .x. C ) , ( B .X. D ) >. ) $=
        ( vx vy vk vd vc va vb csca cfv csn ccda co ccnv cprds cmulr cmpt2 eqid
        cv cxp crn cvv wf1o wfo xpsff1o2 f1ocnv f1ofo syl f1ocpbl xpsval xpslem
        mp1i wcel ovex a1i imasmulval c2o wfn cbs w3a con0 fvex 2on simp1 simp2
        simp3 prdsmulrval xpsaddlem ) AUJUKBCDEFGHIJKFUQURZFUSGUSUTVAVBZVCVAZUL
        VDUJUKNOUJVGUSUKVGUSUTVAVBVEZLMNOPQRSTUAUBUCUDUEUFUGUHUIWTVFZWSVFZANOVH
        ZWSHWSVDURZIWTVBZWTVIZBUSCUSUTVAVBZDUSEUSUTVAVBZVJUMUNUOUPAXFXCXEVKZXFX
        CXEVLXCXFWTVKXIAUJUKNOWTXAVMXCXFWTVNVTZXFXCXEVOVPAUOVGUPVGUNVGUMVGXDXEX
        FXCXJVQAUJUKFGIWSWTWQLMNOPQRSTXAWQVFZXBVRAUJUKFGIWSWTWQLMNOPQRSTXAXKXBV
        SWSVJWAAWQWRVCWBWCXDVFZUIWDWRWEWFZXGWSWGURZWAZXHXNWAZWHZULXNWRWQXDXGXHW
        EVJWIWSXBXNVFWQVJWAXQFUQWJWCWEWIWAXQWKWCXMXOXPWLXMXOXPWMXMXOXPWNXLWOWP
        $.
    $}
  $}

  ${
    $d a k x y A $.  $d a c k x y B $.  $d a c k G $.  $d a b c K $.  $d x W $.
    $d a c k x y C $.  $d a c k x y R $.  $d a c k x y S $.  $d a b c x y X $.
    $d a b c k ph $.  $d k x y .x. $.  $d k x y .X. $.  $d a b c x y Y $.
    $d a b c .xb $.
    xpssca.t $e |- T = ( R Xs. S ) $.
    xpssca.g $e |- G = ( Scalar ` R ) $.
    xpssca.1 $e |- ( ph -> R e. V ) $.
    xpssca.2 $e |- ( ph -> S e. W ) $.
    $( Value of the scalar field of a binary structure product.  For
       concreteness, we choose the scalar field to match the left argument, but
       in most cases where this slot is meaningful both factors will have the
       same scalar field, so that it doesn't matter which factor is chosen.
       (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    xpssca $p |- ( ph -> G = ( Scalar ` T ) ) $=
      ( vx vy cfv csn ccda co ccnv cvv eqid cbs cxp cprds cmpt2 crn xpsval wf1o
      cv xpslem wfo xpsff1o2 f1ocnv mp1i f1ofo syl wcel ovex a1i csca wceq wtru
      fvex eqeltri cnvex prdssca trud imassca ) ABUANZCUANZUBZEBOZCOZPQZRZUCQZD
      LMVHVILUHOMUHOPQRUDZRZEVPUEZSALMBCDVOVPEFGVHVIHVHTZVITZJKVPTZIVOTZUFALMBC
      DVOVPEFGVHVIHVSVTJKWAIWBUIAVRVJVQUGZVRVJVQUJVJVRVPUGWCALMVHVIVPWAUKVJVRVP
      ULUMVRVJVQUNUOVOSUPAEVNUCUQUREVOUSNUTVAVOVNESSWBESUPVAEBUSNSIBUSVBVCURVNS
      UPVAVMVKVLPUQVDURVEVFVG $.

    xpsvsca.x $e |- X = ( Base ` R ) $.
    xpsvsca.y $e |- Y = ( Base ` S ) $.
    xpsvsca.k $e |- K = ( Base ` G ) $.
    xpsvsca.m $e |- .x. = ( .s ` R ) $.
    xpsvsca.n $e |- .X. = ( .s ` S ) $.
    xpsvsca.p $e |- .xb = ( .s ` T ) $.
    xpsvsca.3 $e |- ( ph -> A e. K ) $.
    xpsvsca.4 $e |- ( ph -> B e. X ) $.
    xpsvsca.5 $e |- ( ph -> C e. Y ) $.
    xpsvsca.6 $e |- ( ph -> ( A .x. B ) e. X ) $.
    xpsvsca.7 $e |- ( ph -> ( A .X. C ) e. Y ) $.
    $( Value of the scalar multiplication function in a binary structure
       product.  (Contributed by Mario Carneiro, 15-Aug-2015.) $)
    xpsvsca $p |- ( ph ->
        ( A .xb <. B , C >. ) = <. ( A .x. B ) , ( A .X. C ) >. ) $=
      ( vx vy vc va vb vk csn ccda co ccnv cv cmpt2 cfv cprds cop wcel crn wceq
      cvsca df-ov eqid xpsfval syl2anc syl5eqr opelxpi wf1o xpsff1o2 f1of ax-mp
      cxp wf ffvelrni syl eqeltrrd cvv xpsval xpslem wfo f1ocnv mp1i f1ofo ovex
      a1i csca wtru fvex eqeltri prdssca trud f1ovscpbl imasvscaval mpd3an23 wi
      cnvex f1ocnvfv sylancr mpd oveq2d c2o cmpt wa c0 cif iftrue syl6eqr eqidd
      fveq2d oveq123d eqtr4d wn iffalse pm2.61i adantr xpscfv syl3anc mpteq2dva
      simpr 3eqtr4a cbs con0 2on xpscfn eleqtrd prdsvscaval dffn5 sylib 3eqtr4d
      wfn eqtrd 3eqtr3d ) ABCURDURUSUTVAZULUMOPULVBURUMVBURUSUTVAVCZVAZVDZGUTZB
      UUBKEURZFURZUSUTZVAZVEUTZVJVDZUTZUUDVDZBCDVFZGUTBCIUTZBDJUTZVFZABLVGUUBUU
      CVHZVGUUFUUNVIUGAUUOUUCVDZUUBUUSAUUTCDUUCUTZUUBCDUUCVKACOVGZDPVGZUVAUUBVI
      UHUIULUMOPUUCCDUUCVLZVMVNVOZAUUOOPWAZVGZUUTUUSVGAUVBUVCUVGUHUICDOPVPVNZUV
      FUUSUUOUUCUVFUUSUUCVQZUVFUUSUUCWBULUMOPUUCUVDVRZUVFUUSUUCVSVTWCWDWEZAUVFU
      UKGUULHUUDKLUUSBUUBWFUNUOUPAULUMEFHUUKUUCKMNOPQUAUBSTUVDRUUKVLZWGAULUMEFH
      UUKUUCKMNOPQUAUBSTUVDRUVLWHZAUUSUVFUUDVQZUUSUVFUUDWIUVIUVNAUVJUVFUUSUUCWJ
      WKZUUSUVFUUDWLWDUUKWFVGAKUUJVEWMWNKUUKWOVDVIWPUUKUUJKWFWFUVLKWFVGZWPKEWOV
      DWFREWOWQWRZWNUUJWFVGWPUUIUUGUUHUSWMXEWNWSWTUCUULVLZUFAUOVBUPVBUNVBUULUUD
      LUUSUVFUVOXAXBXCAUUEUUOBGAUUTUUBVIZUUEUUOVIZUVEAUVIUVGUVSUVTXDUVJUVHUVFUU
      SUUOUUBUUCXFXGXHXIAUUNUUPURUUQURUSUTVAZUUDVDZUURAUUMUWAUUDAUQXJBUQVBZUUBV
      DZUWCUUJVDZVJVDZUTZXKUQXJUWCUWAVDZXKZUUMUWAAUQXJUWGUWHAUWCXJVGZXLZBUWCXMV
      IZCDXNZUWLEFXNZVJVDZUTZUWLUUPUUQXNZUWGUWHUWLUWPUWQVIUWLUWPUUPUWQUWLBBUWMC
      UWOIUWLUWOEVJVDIUWLUWNEVJUWLEFXOXRUDXPUWLBXQUWLCDXOXSUWLUUPUUQXOXTUWLYAZU
      WPUUQUWQUWRBBUWMDUWOJUWRUWOFVJVDJUWRUWNFVJUWLEFYBXRUEXPUWRBXQUWLCDYBXSUWL
      UUPUUQYBXTYCUWKBBUWDUWMUWFUWOUWKUWEUWNVJUWKEMVGZFNVGZUWJUWEUWNVIAUWSUWJSY
      DAUWTUWJTYDAUWJYHZEFUWCMNYEYFXRUWKBXQUWKUVBUVCUWJUWDUWMVIAUVBUWJUHYDAUVCU
      WJUIYDUXACDUWCOPYEYFXSUWKUUPOVGZUUQPVGZUWJUWHUWQVIAUXBUWJUJYDAUXCUWJUKYDU
      XAUUPUUQUWCOPYEYFYIYGAUQUUKYJVDZUUJKUULBUUBXJLWFYKUUKUVLUXDVLUVRUCUVPAUVQ
      WNXJYKVGAYLWNAUWSUWTUUJXJYSSTEFMNYMVNUGAUUBUUSUXDUVKUVMYNYOAUWAXJYSZUWAUW
      IVIAUXBUXCUXEUJUKUUPUUQOPYMVNUQXJUWAYPYQYRXRAUURUUCVDZUWAVIZUWBUURVIZAUXF
      UUPUUQUUCUTZUWAUUPUUQUUCVKAUXBUXCUXIUWAVIUJUKULUMOPUUCUUPUUQUVDVMVNVOAUVI
      UURUVFVGZUXGUXHXDUVJAUXBUXCUXJUJUKUUPUUQOPVPVNUVFUUSUURUWAUUCXFXGXHYTUUA
      $.
  $}

  ${
    $d c d k x y A $.  $d d k x y C $.  $d a b c d k ph $.  $d a b c d k x R $.
    $d c d k x y B $.  $d d k x y D $.  $d a b c d k S $.  $d a b c d x y X $.
    $d c d .<_ $.  $d x W $.  $d a b c d x y Y $.
    xpsle.t $e |- T = ( R Xs. S ) $.
    xpsle.x $e |- X = ( Base ` R ) $.
    xpsle.y $e |- Y = ( Base ` S ) $.
    xpsle.1 $e |- ( ph -> R e. V ) $.
    xpsle.2 $e |- ( ph -> S e. W ) $.
    xpsle.p $e |- .<_ = ( le ` T ) $.
    $( Closure of the ordering in a binary structure product.  (Contributed by
       Mario Carneiro, 15-Aug-2015.) $)
    xpsless $p |- ( ph -> .<_ C_ ( ( X X. Y ) X. ( X X. Y ) ) ) $=
      ( vx vy csn co ccnv cxp csca cfv ccda cprds cv crn cvv eqid xpsval xpslem
      cmpt2 wf1o wfo xpsff1o2 f1ocnv mp1i f1ofo syl wcel ovex a1i imasless ) AH
      IUAZBUBUCZBRCRUDSTZUESZDPQHIPUFRQUFRUDSTULZTZEVHUGZUHAPQBCDVGVHVEFGHIJKLM
      NVHUIZVEUIZVGUIZUJAPQBCDVGVHVEFGHIJKLMNVKVLVMUKAVJVDVIUMZVJVDVIUNVDVJVHUM
      VNAPQHIVHVKUOVDVJVHUPUQVJVDVIURUSVGUHUTAVEVFUEVAVBOVC $.

    xpsle.m $e |- M = ( le ` R ) $.
    xpsle.n $e |- N = ( le ` S ) $.
    xpsle.3 $e |- ( ph -> A e. X ) $.
    xpsle.4 $e |- ( ph -> B e. Y ) $.
    xpsle.5 $e |- ( ph -> C e. X ) $.
    xpsle.6 $e |- ( ph -> D e. Y ) $.
    $( Value of the ordering in a binary structure product.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    xpsle $p |- ( ph ->
        ( <. A , B >. .<_ <. C , D >. <-> ( A M C /\ B N D ) ) ) $=
      ( vx vy va vb vc vd vk csn ccda co ccnv cmpt2 cfv wbr csca cprds cple cop
      cv wa crn wcel wb df-ov wceq eqid xpsfval syl2anc syl5eqr opelxpi wf1o wf
      cxp xpsff1o2 f1of ffvelrni syl eqeltrrd cvv xpsval xpslem wfo f1ocnv mp1i
      ax-mp f1ofo ovex a1i f1olecpbl imasleval mpd3an23 wi f1ocnvfv sylancr mpd
      breq12d c2o wral cbs con0 fvex 2on wfn xpscfn eleqtrd prdsleval c1o df2o3
      c0 cpr raleqi 0ex 1on elexi fveq2 fveq2d breq123d ralpr bitri xpsc0 xpsc1
      syl6eqr anbi12d syl5bb bitrd 3bitr3d ) ABUOCUOUPUQURZUHUINOUHVFUOUIVFUOUP
      UQURUSZURZUTZDUOEUOUPUQURZYPUTZIVAZYNYRFVBUTZFUOGUOUPUQURZVCUQZVDUTZVAZBC
      VEZDEVEZIVABDJVAZCEKVAZVGZAYNYOVHZVIYRUUKVIYTUUEVJAUUFYOUTZYNUUKAUULBCYOU
      QZYNBCYOVKABNVIZCOVIZUUMYNVLUDUEUHUINOYOBCYOVMZVNVOVPZAUUFNOVTZVIZUULUUKV
      IAUUNUUOUUSUDUEBCNOVQVOZUURUUKUUFYOUURUUKYOVRZUURUUKYOVSUHUINOYOUUPWAZUUR
      UUKYOWBWLZWCWDWEZAUUGYOUTZYRUUKAUVEDEYOUQZYRDEYOVKADNVIZEOVIZUVFYRVLUFUGU
      HUINOYODEUUPVNVOVPZAUUGUURVIZUVEUUKVIAUVGUVHUVJUFUGDENOVQVOZUURUUKUUGYOUV
      CWCWDWEZAUURUUCHYPIUUDUUKYNYRWFUJUKULUMAUHUIFGHUUCYOUUALMNOPQRSTUUPUUAVMZ
      UUCVMZWGAUHUIFGHUUCYOUUALMNOPQRSTUUPUVMUVNWHZAUUKUURYPVRZUUKUURYPWIUVAUVP
      AUVBUURUUKYOWJWKZUUKUURYPWMWDUUCWFVIAUUAUUBVCWNWOUAUUDVMZAUJVFUKVFULVFUMV
      FYPUUDUUKUURUVQWPWQWRAYQUUFYSUUGIAUULYNVLZYQUUFVLZUUQAUVAUUSUVSUVTWSUVBUU
      TUURUUKUUFYNYOWTXAXBAUVEYRVLZYSUUGVLZUVIAUVAUVJUWAUWBWSUVBUVKUURUUKUUGYRY
      OWTXAXBXCAUUEUNVFZYNUTZUWCYRUTZUWCUUBUTZVDUTZVAZUNXDXEZUUJAUNUUCXFUTZUUBU
      UAYNYRXDUUDWFXGUUCUVNUWJVMUUAWFVIAFVBXHWOXDXGVIAXIWOAFLVIZGMVIZUUBXDXJSTF
      GLMXKVOAYNUUKUWJUVDUVOXLAYRUUKUWJUVLUVOXLUVRXMUWIXPYNUTZXPYRUTZXPUUBUTZVD
      UTZVAZXNYNUTZXNYRUTZXNUUBUTZVDUTZVAZVGZAUUJUWIUWHUNXPXNXQZXEUXCUWHUNXDUXD
      XOXRUWHUWQUXBUNXPXNXSXNXGXTYAUWCXPVLZUWDUWMUWEUWNUWGUWPUWCXPYNYBUXEUWFUWO
      VDUWCXPUUBYBYCUWCXPYRYBYDUWCXNVLZUWDUWRUWEUWSUWGUXAUWCXNYNYBUXFUWFUWTVDUW
      CXNUUBYBYCUWCXNYRYBYDYEYFAUWQUUHUXBUUIAUWMBUWNDUWPJAUUNUWMBVLUDBCNYGWDAUW
      PFVDUTJAUWOFVDAUWKUWOFVLSFGLYGWDYCUBYIAUVGUWNDVLUFDENYGWDYDAUWRCUWSEUXAKA
      UUOUWRCVLUEBCOYHWDAUXAGVDUTKAUWTGVDAUWLUWTGVLTFGMYHWDYCUCYIAUVHUWSEVLUGDE
      OYHWDYDYJYKYLYM $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
    Moore spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $c Moore mrCls mrInd ACS $.

  $( The class of Moore systems. $)
  cmre $a class Moore $.

  $( The class function generating Moore closures. $)
  cmrc $a class mrCls $.

  $( ` mrInd ` is a class function which takes a Moore system to its set of
     independent sets. $)
  cmri $a class mrInd $.

  $( The class of algebraic closure (Moore) systems. $)
  cacs $a class ACS $.

  ${
    $d c f s x $.

    $( Define a _Moore collection_, which is a family of subsets of a base set
       which preserve arbitrary intersection.  Elements of a Moore collection
       are termed _closed_; Moore collections generalize the notion of
       closedness from topologies ( ~ cldmre ) and vector spaces ( ~ lssmre )
       to the most general setting in which such concepts make sense.
       Definition of Moore collection of sets in [Schechter] p. 78.  A Moore
       collection may also be called a _closure system_ (Section 0.6 in
       [Gratzer] p. 23.)  The name _Moore collection_ is after Eliakim Hastings
       Moore, who discussed these systems in Part I of [Moore] p. 53 to 76.

       See ~ ismre , ~ mresspw , ~ mre1cl and ~ mreintcl for the major
       properties of a Moore collection.  Note that a Moore collection uniquely
       determines its base set ( ~ mreuni ); as such the disjoint union of all
       Moore collections is sometimes considered as ` U. ran Moore ` ,
       justified by ~ mreunirn .  (Contributed by Stefan O'Rear, 30-Jan-2015.)
       (Revised by David Moews, 1-May-2017.) $)
    df-mre $a |- Moore = ( x e. _V |-> { c e. ~P ~P x | ( x e. c /\
        A. s e. ~P c ( s =/= (/) -> |^| s e. c ) ) } ) $.

    $( Define the _Moore closure_ of a generating set, which is the smallest
       closed set containing all generating elements.  Definition of Moore
       closure in [Schechter] p. 79.  This generalizes topological closure
       ( ~ mrccls ) and linear span ( ~ mrclsp ).

       A Moore closure operation ` N ` is (1) extensive, i.e.,
       ` x C_ ( N `` x ) ` for all subsets ` x ` of the base set ( ~ mrcssid ),
       (2) isotone, i.e., ` x C_ y ` implies that ` ( N `` x ) C_ ( N `` y ) `
       for all subsets ` x ` and ` y ` of the base set ( ~ mrcss ), and (3)
       idempotent, i.e., ` ( N `` ( N `` x ) ) = ( N `` x ) ` for all subsets
       ` x ` of the base set ( ~ mrcidm .)  Operators satisfying these three
       properties are in bijective correspondence with Moore collections, so
       these properties may be used to give an alternate characterization of a
       Moore collection by providing a closure operation ` N ` on the set of
       subsets of a given base set which satisfies (1), (2), and (3); the
       closed sets can be recovered as those sets which equal their closures
       (Section 4.5 in [Schechter] p. 82.)  (Contributed by Stefan O'Rear,
       31-Jan-2015.)  (Revised by David Moews, 1-May-2017.) $)
    df-mrc $a |- mrCls = ( c e. U. ran Moore |-> ( x e. ~P U. c |->
        |^| { s e. c | x C_ s } ) ) $.

    $( In a Moore system, a set is _independent_ if no element of the set is in
       the closure of the set with the element removed (Section 0.6 in
       [Gratzer] p. 27; Definition 4.1.1 in [FaureFrolicher] p. 83.) ` mrInd `
       is a class function which takes a Moore system to its set of independent
       sets.  (Contributed by David Moews, 1-May-2017.) $)
    df-mri $a |- mrInd = ( c e. U. ran Moore |->
                 { s e. ~P U. c |
                   A. x e. s -. x e. ( ( mrCls ` c ) ` ( s \ { x } ) ) } ) $.

    $( An important subclass of Moore systems are those which can be
       interpreted as closure under some collection of operators of finite
       arity (the collection itself is not required to be finite).  These are
       termed _algebraic closure systems_; similar to definition (A) of an
       algebraic closure system in [Schechter] p. 84, but to avoid the
       complexity of an arbitrary mixed collection of functions of various
       arities (especially if the axiom of infinity ~ omex is to be avoided),
       we consider a single function defined on finite sets instead.
       (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    df-acs $a |- ACS = ( x e. _V |-> { c e. ( Moore ` x ) |
            E. f ( f : ~P x --> ~P x /\ A. s e. ~P x ( s e. c <->
                    U. ( f " ( ~P s i^i Fin ) ) C_ s ) ) } ) $.
  $}

  ${
    $d C c s x $.  $d X c s x $.  $d S c s x $.
    $( Property of being a Moore collection on some base set.  (Contributed by
       Stefan O'Rear, 30-Jan-2015.) $)
    ismre $p |- ( C e. ( Moore ` X ) <-> ( C C_ ~P X /\ X e. C /\
        A. s e. ~P C ( s =/= (/) -> |^| s e. C ) ) ) $=
      ( vc vx cmre wcel cvv cpw cv wi wral wa crab wceq pweq anbi1d pwex eleq2
      wb cfv wss c0 wne cint w3a elfvex elex 3ad2ant2 wel pweqd eleq1 rabeqbidv
      df-mre vex rabex fvmpt3i eleq2d imbi2d raleqbidv anbi12d elrab a1i elpw2g
      pwexg syl 3anass syl6bbr 3bitrd pm5.21nii ) ABFUAZGZBHGZABIZUBZBAGZCJZUCU
      DZVQUEZAGZKZCAIZLZUFZABFUGVPVOVMWCBAUHUIVMVLABDJZGZVRVSWEGZKZCWEIZLZMZDVN
      IZNZGZAWLGZVPWCMZMZWDVMVKWMAEBEDUJZWJMZDEJZIZIZNWMHFWTBOZWSWKDXBWLXCXAVNW
      TBPUKXCWRWFWJWTBWEULQUMECDUNWSDXBXAWTEUORRUPUQURWNWQTVMWKWPDAWLWEAOZWFVPW
      JWCWEABSXDWHWACWIWBWEAPXDWGVTVRWEAVSSUSUTVAVBVCVMWQVOWPMWDVMWOVOWPVMVNHGW
      OVOTBHVEAVNHVDVFQVOVPWCVGVHVIVJ $.

    $( The Moore collection generator is a well-behaved function.  (Contributed
       by Stefan O'Rear, 30-Jan-2015.) $)
    fnmre $p |- Moore Fn _V $=
      ( vx vc vs cvv wel cv c0 wne cint wcel wi cpw wral wa crab cmre vex rabex
      pwex df-mre fnmpti ) ADABECFZGHUBIBFZJKCUCLMNZBAFZLZLZOPUDBUGUFUEAQSSRACB
      TUA $.

    $( A Moore collection is a subset of the power of the base set; each closed
       subset of the system is actually a subset of the base.  (Contributed by
       Stefan O'Rear, 30-Jan-2015.) $)
    mresspw $p |- ( C e. ( Moore ` X ) -> C C_ ~P X ) $=
      ( vs cmre cfv wcel cpw wss cv c0 wne cint wi wral ismre simp1bi ) ABDEFAB
      GHBAFCIZJKQLAFMCAGNABCOP $.

    $( A Moore-closed subset is a subset.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mress $p |- ( ( C e. ( Moore ` X ) /\ S e. C ) -> S C_ X ) $=
      ( cmre cfv wcel wa cpw mresspw sselda elpwid ) ACDEFZBAFGBCLACHBACIJK $.

    $( In any Moore collection the base set is closed.  (Contributed by Stefan
       O'Rear, 30-Jan-2015.) $)
    mre1cl $p |- ( C e. ( Moore ` X ) -> X e. C ) $=
      ( vs cmre cfv wcel cpw wss cv c0 wne cint wi wral ismre simp2bi ) ABDEFAB
      GHBAFCIZJKQLAFMCAGNABCOP $.

    $( A nonempty collection of closed sets has a closed intersection.
       (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    mreintcl $p |- ( ( C e. ( Moore ` X ) /\ S C_ C /\ S =/= (/) ) ->
        |^| S e. C ) $=
      ( vs cmre cfv wcel wss c0 wne w3a cpw cv cint wral elpw2g biimpar 3adant3
      wi ismre simp3bi 3ad2ant1 simp3 neeq1 inteq eleq1d imbi12d rspcva syl3anc
      wceq 3impia ) ACEFZGZBAHZBIJZKBALZGZDMZIJZURNZAGZSZDUPOZUOBNZAGZUMUNUQUOU
      MUQUNBAULPQRUMUNVCUOUMACLHCAGVCACDTUAUBUMUNUOUCUQVCUOVEVBUOVESDBUPURBUJZU
      SUOVAVEURBIUDVFUTVDAURBUEUFUGUHUKUI $.

    $d I c s y $.  $d X y $.  $d C y $.
    $( A nonempty indexed intersection of closed sets is closed.  (Contributed
       by Stefan O'Rear, 1-Feb-2015.) $)
    mreiincl $p |- ( ( C e. ( Moore ` X ) /\ I =/= (/) /\
          A. y e. I S e. C ) -> |^|_ y e. I S e. C ) $=
      ( vs cmre cfv wcel c0 wne wral w3a ciin cv wceq wrex cab 3ad2ant3 wex wss
      cint dfiin2g simp1 uniiunlem ibi wi nfra1 nfre1 nfab nfcv nfne nfim com12
      n0 rsp elisset rspe ex syl5 rexcom4 syl6ib syld abn0 syl6ibr exlimi sylbi
      imp 3adant1 mreintcl syl3anc eqeltrd ) BEGHIZDJKZCBIZADLZMZADCNZFOCPZADQZ
      FRZUBZBVPVMVRWBPVNAFDCBUCSVQVMWABUAZWAJKZWBBIVMVNVPUDVPVMWCVNVPWCAFDCBBUE
      UFSVNVPWDVMVNVPWDVNAODIZATVPWDUGZADUOWEWFAVPWDAVOADUHAWAJVTAFVSADUIUJAJUK
      ULUMWEVPVTFTZWDWEVPVOWGVPWEVOVOADUPUNWEVOVSFTZADQZWGVOWHWEWIFCBUQWEWHWIWH
      ADURUSUTVSAFDVAVBVCVTFVDVEVFVGVHVIBWAEVJVKVL $.

    $( The relative intersection of a set of closed sets is closed.
       (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    mrerintcl $p |- ( ( C e. ( Moore ` X ) /\ S C_ C ) ->
        ( X i^i |^| S ) e. C ) $=
      ( cmre cfv wcel wss wa cint cin wceq rint0 adantl mre1cl ad2antrr eqeltrd
      c0 wne w3a cpw simp2 mresspw 3ad2ant1 sstrd simp3 rintn0 syl2anc mreintcl
      3expa pm2.61dane ) ACDEFZBAGZHZCBIZJZAFZBQUMBQKZHUOCAUQUOCKUMCBLMUKCAFULU
      QACNOPUKULBQRZUPUKULURSZUOUNAUSBCTZGURUOUNKUSBAUTUKULURUAUKULAUTGURACUBUC
      UDUKULURUECBUFUGABCUHPUIUJ $.

    $( The relative intersection of a family of closed sets is closed.
       (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    mreriincl $p |- ( ( C e. ( Moore ` X ) /\ A. y e. I S e. C ) ->
        ( X i^i |^|_ y e. I S ) e. C ) $=
      ( cmre cfv wcel wral wa ciin c0 wceq riin0 adantl mre1cl ad2antrr eqeltrd
      cin wne wss mress ex ralimdv imp riinn0 sylan simpll simpr simplr syl3anc
      mreiincl pm2.61dane ) BEFGHZCBHZADIZJZEADCKZSZBHDLUQDLMZJUSEBUTUSEMUQAECD
      NOUNEBHUPUTBEPQRUQDLTZJZUSURBUQCEUAZADIZVAUSURMUNUPVDUNUOVCADUNUOVCBCEUBU
      CUDUEAECDUFUGVBUNVAUPURBHUNUPVAUHUQVAUIUNUPVAUJABCDEULUKRUM $.

    $( Two closed sets have a closed intersection.  (Contributed by Stefan
       O'Rear, 30-Jan-2015.) $)
    mreincl $p |- ( ( C e. ( Moore ` X ) /\ A e. C /\ B e. C ) ->
        ( A i^i B ) e. C ) $=
      ( cmre cfv wcel w3a cpr cint cin wceq intprg 3adant1 c0 simp1 prssi prnzg
      wss wne 3ad2ant2 mreintcl syl3anc eqeltrrd ) CDEFGZACGZBCGZHZABIZJZABKZCU
      FUGUJUKLUEABCCMNUHUEUICSZUIOTZUJCGUEUFUGPUFUGULUEABCQNUFUEUMUGABCRUACUIDU
      BUCUD $.

    $( Since the entire base set of a Moore collection is the greatest element
       of it, the base set can be recovered from a Moore collection by set
       union.  (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    mreuni $p |- ( C e. ( Moore ` X ) -> U. C = X ) $=
      ( cmre cfv wcel cpw wss cuni wceq mre1cl mresspw elpwuni biimpa syl2anc )
      ABCDEBAEZABFGZAHBIZABJABKOPQABLMN $.

    $( Two ways to express the notion of being a Moore collection on an
       unspecified base.  (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    mreunirn $p |- ( C e. U. ran Moore <-> C e. ( Moore ` U. C ) ) $=
      ( vx cmre crn cuni wcel cfv cv cvv wrex wfn wb fnmre fnunirn ax-mp mreuni
      fveq2d eleq2d ibir rexlimivw sylbi fvssunirn sseli impbii ) ACDEZFZAAEZCG
      ZFZUFABHZCGZFZBIJZUICIKUFUMLMBACINOULUIBIULUIULUHUKAULUGUJCAUJPQRSTUAUHUE
      ACUGUBUCUD $.
  $}

  ${
    $d ph s $.  $d C s $.  $d X s $.
    ismred.ss $e |- ( ph -> C C_ ~P X ) $.
    ismred.ba $e |- ( ph -> X e. C ) $.
    ismred.in $e |- ( ( ph /\ s C_ C /\ s =/= (/) ) -> |^| s e. C ) $.
    $( Properties that determine a Moore collection.  (Contributed by Stefan
       O'Rear, 30-Jan-2015.) $)
    ismred $p |- ( ph -> C e. ( Moore ` X ) ) $=
      ( cpw wss wcel cv c0 wne cint wi wral cmre cfv vex elpw sylan2b ralrimiva
      3expia ismre syl3anbrc ) ABCHICBJDKZLMZUFNBJZOZDBHZPBCQRJEFAUIDUJUFUJJAUF
      BIZUIUFBDSTAUKUGUHGUCUAUBBCDUDUE $.
  $}

  ${
    $d ph s $.  $d C s $.  $d X s $.
    ismred2.ss $e |- ( ph -> C C_ ~P X ) $.
    ismred2.in $e |- ( ( ph /\ s C_ C ) -> ( X i^i |^| s ) e. C ) $.
    $( Properties that determine a Moore collection, using restricted
       intersection.  (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    ismred2 $p |- ( ph -> C e. ( Moore ` X ) ) $=
      ( c0 cint cin wceq eqid rint0 ax-mp wss wcel 0ss cv wa wi 0ex sseq1 inteq
      anbi2d ineq2d eleq1d imbi12d vtocl mpan2 syl5eqelr wne w3a simp2 3ad2ant1
      cpw sstrd simp3 rintn0 syl2anc 3adant3 eqeltrrd ismred ) ABCDEACCGHZIZBGG
      JVCCJGKCGLMAGBNZVCBOZBPADQZBNZRZCVFHZIZBOZSAVDRZVESDGTVFGJZVHVLVKVEVMVGVD
      AVFGBUAUCVMVJVCBVMVIVBCVFGUBUDUEUFFUGUHUIAVGVFGUJZUKZVJVIBVOVFCUNZNVNVJVI
      JVOVFBVPAVGVNULAVGBVPNVNEUMUOAVGVNUPCVFUQURAVGVKVNFUSUTVA $.
  $}

  ${
    $d V a b c $.  $d X a b c $.

    $( The Moore collections of subsets of a space, viewed as a kind of subset
       of the power set, form a Moore collection in their own right on the
       power set.  (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    mremre $p |- ( X e. V -> ( Moore ` X ) e. ( Moore ` ~P X ) ) $=
      ( va vb vc wcel cpw wss cv mresspw a1i c0 wne w3a wb mpbird ismred sselda
      cint wa cmre cfv vex elpw sylibr ssriv ssid pwidg intssuni2 3adant1 unipw
      cuni syl6sseq elpw2g 3ad2ant1 wel wex n0 intss1 adantl simpr syl sstrd ex
      exlimdv syl5bi 3impia wral mre1cl ralrimiva elintg simp12 simpl2 mreintcl
      simp2 simpl3 syl3anc cvv intex sylbi 3ad2ant3 ) BAFZBUAUBZBGZCWCWDGZHWBCW
      CWECIZWCFWFWDHZWFWEFWFBJWFWDCUCUDUEUFKWBWDBCWDWDHWBWDUGKBAUHWBWGWFLMZNZWF
      SZWDFZWJBHZWIWJWDULZBWGWHWJWMHWBWFWDUIUJBUKUMWBWGWKWLOWHWJBAUNUOPQWBWFWCH
      ZWHNZWJBDWBWNWHWJWDHZWHDCUPZDUQWBWNTZWPDWFURWRWQWPDWRWQWPWRWQTZWJDIZWDWQW
      JWTHWRWTWFUSUTWSWTWCFZWTWDHWRWFWCWTWBWNVARWTBJVBVCVDVEVFVGWOBWJFZBWTFZDWF
      VHZWOXCDWFWOWQTXAXCWOWFWCWTWBWNWHVORWTBVIVBVJWBWNXBXDOWHDBWFAVKUOPWOWTWJH
      ZWTLMZNZWTSZWJFZXHEIZFZEWFVHZXGXKEWFXGECUPZTZXJWCFWTXJHXFXKXGWFWCXJWBWNWH
      XEXFVLRXNWTWJXJWOXEXFXMVMXMWJXJHXGXJWFUSUTVCWOXEXFXMVPXJWTBVNVQVJXFWOXIXL
      OZXEXFXHVRFXOWTVSEXHWFVRVKVTWAPQQ $.
  $}

  ${
    $d A x $.  $d C x $.  $d X x $.
    $( The subcollection of a closed set system below a given closed set is
       itself a closed set system.  (Contributed by Stefan O'Rear,
       9-Mar-2015.) $)
    submre $p |- ( ( C e. ( Moore ` X ) /\ A e. C ) ->
        ( C i^i ~P A ) e. ( Moore ` A ) ) $=
      ( vx cmre cfv wcel cpw cin wss inss2 a1i simpr adantl elin sylanbrc mpan2
      wa sstr 3ad2ant2 pwidg cv c0 wne cint simp1l inss1 simp3 mreintcl syl3anc
      w3a cuni intssuni2 syl2anc unipw syl6sseq elpw2g 3ad2ant1 mpbird ismred
      wb ) BCEFGZABGZRZBAHZIZADVFVEJZVDBVEKZLVDVCAVEGZAVFGVBVCMVCVIVBABUANABVEO
      PVDDUBZVFJZVJUCUDZUKZVJUEZBGZVNVEGZVNVFGVMVBVJBJZVLVOVBVCVKVLUFVKVDVQVLVK
      VFBJVQBVEUGVJVFBSQTVDVKVLUHZBVJCUIUJVMVPVNAJZVMVNVEULZAVMVJVEJZVLVNVTJVKV
      DWAVLVKVGWAVHVJVFVESQTVRVJVEUMUNAUOUPVDVKVPVSVAZVLVCWBVBVNABUQNURUSVNBVEO
      PUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Moore closures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F c x s $.  $d C c x s $.  $d X c x s $.  $d U c x s $.  $d V c x s $.
    $( The domain and range of the function expression for Moore closures.
       (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    mrcflem $p |- ( C e. ( Moore ` X ) ->
        ( x e. ~P X |-> |^| { s e. C | x C_ s } ) : ~P X --> C ) $=
      ( cmre cfv wcel cpw cv wss crab cint cmpt wa wne simpl ssrab2 a1i mre1cl
      c0 adantr elpwi sseq2 elrab sylanbrc ne0i syl mreintcl syl3anc eqid fmptd
      adantl ) BCEFGZACHZAIZDIZJZDBKZLZBAUNUSMZUMUOUNGZNZUMURBJZURTOZUSBGUMVAPV
      CVBUQDBQRVBCURGZVDVBCBGZUOCJZVEUMVFVABCSUAVAVGUMUOCUBULUQVGDCBUPCUOUCUDUE
      URCUFUGBURCUHUIUTUJUK $.

    $( Moore-closure is a well-behaved function.  (Contributed by Stefan
       O'Rear, 1-Feb-2015.) $)
    fnmrc $p |- mrCls Fn U. ran Moore $=
      ( vx vc vs cv cuni cpw wss crab cint cmpt cvv wcel cmrc cmre df-mrc fnmpt
      crn wfn cfv mreunirn cxp wf mrcflem fssxp syl vex uniex pwex xpex sylancl
      ssexg sylbi mprg ) ABDZEZFZADCDGCUNHIJZKLZMNQEZRBUSBUSUQMKACBOPUNUSLUNUON
      SLZURUNTUTUQUPUNUAZGZVAKLURUTUPUNUQUBVBAUNUOCUCUPUNUQUDUEUPUNUOUNBUFZUGUH
      VCUIUQVAKUKUJULUM $.

    mrcfval.f $e |- F = ( mrCls ` C ) $.
    $( Value of the function expression for the Moore closure.  (Contributed by
       Stefan O'Rear, 31-Jan-2015.) $)
    mrcfval $p |- ( C e. ( Moore ` X ) -> F =
        ( x e. ~P X |-> |^| { s e. C | x C_ s } ) ) $=
      ( vc cmre cfv wcel cmrc cpw cv wss crab cint cmpt cuni wceq cvv fvssunirn
      crn sseli unieq pweqd rabeq inteqd mpteq12dv df-mrc cxp wf mreunirn sylbi
      mrcflem fssxp syl vex uniex pwex xpex ssexg sylancl fvmpt3 mreuni mpteq1d
      eqtrd syl5eq ) BDHIZJZCBKIZADLZAMEMNZEBOZPZQZFVIVJABRZLZVNQZVOVIBHUBRZJVJ
      VRSVHVSBHDUAUCGBAGMZRZLZVLEVTOZPZQZVRVSKTVTBSZAWBWDVQVNWFWAVPVTBUDUEWFWCV
      MVLEVTBUFUGUHAEGUIVTVSJZWEWBVTUJZNZWHTJWETJWGWBVTWEUKZWIWGVTWAHIJWJVTULAV
      TWAEUNUMWBVTWEUOUPWBVTWAVTGUQZURUSWKUTWEWHTVAVBVCUPVIAVQVKVNVIVPDBDVDUEVE
      VFVG $.

    $( The Moore closure is a function mapping arbitrary subsets to closed
       sets.  (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    mrcf $p |- ( C e. ( Moore ` X ) -> F : ~P X --> C ) $=
      ( vx vs cmre cfv wcel cpw wf cv wss crab cint cmpt mrcflem mrcfval mpbird
      feq1d ) ACGHIZCJZABKUBAEUBELFLMFANOPZKEACFQUAUBABUCEABCFDRTS $.

    $( Evaluation of the Moore closure of a set.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.)  (Proof shortened by Fan Zheng, 6-Jun-2016.) $)
    mrcval $p |- ( ( C e. ( Moore ` X ) /\ U C_ X ) -> ( F ` U ) =
        |^| { s e. C | U C_ s } ) $=
      ( vx cmre cfv wcel wss wa cv crab cint cpw cvv wceq adantr syl cmpt sseq1
      mrcfval rabbidv inteqd adantl wb mre1cl elpw2g biimpar c0 wne simpr sseq2
      elrab sylanbrc ne0i intex sylib fvmptd ) ADHIJZBDKZLZGBGMZEMZKZEANZOZBVEK
      ZEANZOZDPZCQVACGVLVHUARVBGACDEFUCSVDBRZVHVKRVCVMVGVJVMVFVIEAVDBVEUBUDUEUF
      VABVLJZVBVADAJZVNVBUGADUHZBDAUITUJVCVJUKULZVKQJVCDVJJZVQVCVOVBVRVAVOVBVPS
      VAVBUMVIVBEDAVEDBUNUOUPVJDUQTVJURUSUT $.

    $( The Moore closure of a set is a closed set.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.) $)
    mrccl $p |- ( ( C e. ( Moore ` X ) /\ U C_ X ) -> ( F ` U ) e. C ) $=
      ( cmre cfv wcel wss wa cpw mrcf adantr mre1cl elpw2g syl biimpar ffvelrnd
      wf wb ) ADFGHZBDIZJDKZABCUAUCACSUBACDELMUABUCHZUBUADAHUDUBTADNBDAOPQR $.

    $( The Moore closure of a singleton is a closed set.  (Contributed by
       Stefan O'Rear, 31-Jan-2015.) $)
    mrcsncl $p |- ( ( C e. ( Moore ` X ) /\ U e. X ) -> ( F ` { U } ) e. C ) $=
      ( wcel cmre cfv csn wss snssi mrccl sylan2 ) BDFADGHFBIZDJNCHAFBDKANCDELM
      $.

    $( The closure of a closed set is itself.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mrcid $p |- ( ( C e. ( Moore ` X ) /\ U e. C ) -> ( F ` U ) = U ) $=
      ( vs cmre cfv wcel wa cv crab cint wceq mress mrcval syldan intmin adantl
      wss eqtrd ) ADGHIZBAIZJBCHZBFKTFALMZBUBUCBDTUDUENABDOABCDFEPQUCUEBNUBFBAR
      SUA $.

    $( The closure of a set is a subset of the base.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.) $)
    mrcssv $p |- ( C e. ( Moore ` X ) -> ( F ` U ) C_ X ) $=
      ( cmre cfv wcel crn cuni fvssunirn cpw wf wss mrcf frn uniss 3syl sseqtrd
      mreuni syl5ss ) ADFGHZBCGCIZJZDCBKUBUDAJZDUBDLZACMUCANUDUENACDEOUFACPUCAQ
      RADTSUA $.

    $( A set is closed iff it is equal to its closure.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.) $)
    mrcidb $p |- ( C e. ( Moore ` X ) -> ( U e. C <-> ( F ` U ) = U ) ) $=
      ( cmre cfv wcel wceq mrcid wa simpr mrcssv adantr eqsstr3d mrccl eqeltrrd
      wss syldan impbida ) ADFGHZBAHBCGZBIZABCDEJUAUCKZUBBAUAUCLZUAUCBDRUBAHUDB
      UBDUEUAUBDRUCABCDEMNOABCDEPSQT $.

    $( Closure preserves subset ordering.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mrcss $p |- ( ( C e. ( Moore ` X ) /\ U C_ V /\ V C_ X ) ->
        ( F ` U ) C_ ( F ` V ) ) $=
      ( vs cmre cfv wcel wss w3a cv crab cint wi sstr2 adantr wceq mrcval intss
      ss2rabdv syl 3ad2ant2 simp1 sstr 3adant1 syl2anc 3adant2 3sstr4d ) AEHIJZ
      BDKZDEKZLZBGMZKZGANZOZDUOKZGANZOZBCIZDCIZULUKURVAKZUMULUTUQKVDULUSUPGAULU
      SUPPUOAJBDUOQRUBUTUQUAUCUDUNUKBEKZVBURSUKULUMUEULUMVEUKBDEUFUGABCEGFTUHUK
      UMVCVASULADCEGFTUIUJ $.

    $( The closure of a set is a superset.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mrcssid $p |- ( ( C e. ( Moore ` X ) /\ U C_ X ) -> U C_ ( F ` U ) ) $=
      ( vs cmre cfv wcel wss wa cv crab cint ssintub mrcval syl5sseqr ) ADGHIBD
      JKBFLJFAMNBBCHFBAOABCDFEPQ $.

    $( A set is closed iff it contains its closure.  (Contributed by Stefan
       O'Rear, 2-Apr-2015.) $)
    mrcidb2 $p |- ( ( C e. ( Moore ` X ) /\ U C_ X ) ->
        ( U e. C <-> ( F ` U ) C_ U ) ) $=
      ( cmre cfv wcel wss wa wceq mrcidb adantr mrcssid biantrud syl6rbbr bitrd
      wb eqss ) ADFGHZBDIZJZBAHZBCGZBKZUDBIZTUCUERUAABCDELMUBUFUFBUDIZJUEUBUGUF
      ABCDENOUDBSPQ $.

    $( The closure operation is idempotent.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mrcidm $p |- ( ( C e. ( Moore ` X ) /\ U C_ X ) ->
        ( F ` ( F ` U ) ) = ( F ` U ) ) $=
      ( cmre cfv wcel wss wceq mrccl mrcid syldan ) ADFGHBDIBCGZAHNCGNJABCDEKAN
      CDELM $.

    $( The closure is the minimal closed set; any closed set which contains the
       generators is a superset of the closure.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mrcsscl $p |- ( ( C e. ( Moore ` X ) /\ U C_ V /\ V e. C ) ->
        ( F ` U ) C_ V ) $=
      ( cmre cfv wcel wss w3a mress 3adant2 mrcss syld3an3 wceq mrcid sseqtrd )
      AEGHIZBDJZDAIZKBCHZDCHZDSTUADEJZUBUCJSUAUDTADELMABCDEFNOSUAUCDPTADCEFQMR
      $.

    $( Idempotence of closure under a general union.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.) $)
    mrcuni $p |- ( ( C e. ( Moore ` X ) /\ U C_ ~P X ) ->
        ( F ` U. U ) = ( F ` U. ( F " U ) ) ) $=
      ( vs vx cfv wcel wss wa cuni wral syl2anc syl adantr unissb mrcss syl3anc
      sylibr cmre cpw cima simpl cv simpll ssel2 elpwid adantll mrcssid wfun wi
      cdm wf mrcf ffun fdm sseq2d biimpar funfvima2 imp elssuni sstrd ralrimiva
      wceq mrcssv ralrimivw wfn wb ffn sseq1 ralima sylan mpbird adantl sspwuni
      biimpi mrcidm sseqtrd eqssd ) ADUAHIZBDUBZJZKZBLZCHZCBUCZLZCHZWDWAWEWHJZW
      HDJZWFWIJWAWCUDZWDFUEZWHJZFBMWJWDWNFBWDWMBIZKZWMWMCHZWHWPWAWMDJZWMWQJWAWC
      WOUFWCWOWRWAWCWOKWMDBWBWMUGUHUIAWMCDEUJNWPWQWGIZWQWHJWDWOWSWDCUKZBCUMZJZW
      OWSULWAWTWCWAWBACUNZWTACDEUOZWBACUPOPWAXBWCWAXAWBBWAXCXAWBVEXDWBACUQOURUS
      BWMCUTNVAWQWGVBOVCVDFBWHQTWDWRFWGMZWKWDXEGUEZCHZDJZGBMZWDXHGBWAXHWCAXFCDE
      VFPVGWACWBVHZWCXEXIVIWAXCXJXDWBACVJOZWRXHFGWBBCWMXGDVKVLVMVNFWGDQTAWECWHD
      ERSWDWIWFCHZWFWDWAWHWFJZWFDJZWIXLJWLWDWMWFJZFWGMZXMWDXPXGWFJZGBMZWDXQGBWD
      XFBIZKWAXFWEJZWEDJZXQWAWCXSUFXSXTWDXFBVBVOWDYAXSWCYAWAWCYABDVPVQVOZPAXFCW
      EDERSVDWAXJWCXPXRVIXKXOXQFGWBBCWMXGWFVKVLVMVNFWGWFQTWAXNWCAWECDEVFPAWHCWF
      DERSWDWAYAXLWFVEWLYBAWECDEVRNVSVT $.

    $( Idempotence of closure under a pair union.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.) $)
    mrcun $p |- ( ( C e. ( Moore ` X ) /\ U C_ X /\ V C_ X ) ->
        ( F ` ( U u. V ) ) = ( F ` ( ( F ` U ) u. ( F ` V ) ) ) ) $=
      ( cfv wcel wss cpr cuni cun wceq elpw2g syl biimpar syl2anc fveq2d fvex
      wb cmre w3a cima cpw simp1 mre1cl 3adant3 3adant2 prssi mrcuni uniprg wfn
      wf mrcf ffn 3ad2ant1 fnimapr syl3anc unieqd unipr syl6eq 3eqtr3d ) AEUAGH
      ZBEIZDEIZUBZBDJZKZCGZCVGUCZKZCGZBDLZCGBCGZDCGZLZCGVFVCVGEUDZIZVIVLMVCVDVE
      UEVFBVQHZDVQHZVRVCVDVSVEVCVSVDVCEAHZVSVDTAEUFZBEANOPUGZVCVEVTVDVCVTVEVCWA
      VTVETWBDEANOPUHZBDVQUIQAVGCEFUJQVFVHVMCVFVSVTVHVMMWCWDBDVQVQUKQRVFVKVPCVF
      VKVNVOJZKVPVFVJWEVFCVQULZVSVTVJWEMVCVDWFVEVCVQACUMWFACEFUNVQACUOOUPWCWDVQ
      BDCUQURUSVNVOBCSDCSUTVARVB $.
  $}

  ${
    mrcssd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrcssd.2 $e |- N = ( mrCls ` A ) $.
    $( The Moore closure of a set is a subset of the base.  Deduction form of
       ~ mrcssv .  (Contributed by David Moews, 1-May-2017.) $)
    mrcssvd $p |- ( ph -> ( N ` B ) C_ X ) $=
      ( cmre cfv wcel wss mrcssv syl ) ABEHIJCDIEKFBCDEGLM $.

    mrcssd.3 $e |- ( ph -> U C_ V ) $.
    mrcssd.4 $e |- ( ph -> V C_ X ) $.
    $( Moore closure preserves subset ordering.  Deduction form of ~ mrcss .
       (Contributed by David Moews, 1-May-2017.) $)
    mrcssd $p |- ( ph -> ( N ` U ) C_ ( N ` V ) ) $=
      ( cmre cfv wcel wss mrcss syl3anc ) ABFKLMCENEFNCDLEDLNGIJBCDEFHOP $.
  $}

  ${
    mrcssidd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrcssidd.2 $e |- N = ( mrCls ` A ) $.
    mrcssidd.3 $e |- ( ph -> U C_ X ) $.
    $( A set is contained in its Moore closure.  Deduction form of ~ mrcssid .
       (Contributed by David Moews, 1-May-2017.) $)
    mrcssidd $p |- ( ph -> U C_ ( N ` U ) ) $=
      ( cmre cfv wcel wss mrcssid syl2anc ) ABEIJKCELCCDJLFHBCDEGMN $.

    $( Moore closure is idempotent.  Deduction form of ~ mrcidm .  (Contributed
       by David Moews, 1-May-2017.) $)
    mrcidmd $p |- ( ph -> ( N ` ( N ` U ) ) = ( N ` U ) ) $=
      ( cmre cfv wcel wss wceq mrcidm syl2anc ) ABEIJKCELCDJZDJPMFHBCDEGNO $.
  $}

  ${
    mressmrcd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mressmrcd.2 $e |- N = ( mrCls ` A ) $.
    mressmrcd.3 $e |- ( ph -> S C_ ( N ` T ) ) $.
    mressmrcd.4 $e |- ( ph -> T C_ S ) $.
    $( In a Moore system, if a set is between another set and its closure, the
       two sets have the same closure.  Deduction form.  (Contributed by David
       Moews, 1-May-2017.) $)
    mressmrcd $p |- ( ph -> ( N ` S ) = ( N ` T ) ) $=
      ( cfv mrcssvd mrcssd sstrd mrcidmd sseqtrd eqssd ) ACEKZDEKZARSEKSABCESFG
      HIABDEFGHLZMABDEFGHADCFJACSFITNZNOPABDECFGHJUAMQ $.
  $}

  ${
    submrc.f $e |- F = ( mrCls ` C ) $.
    submrc.g $e |- G = ( mrCls ` ( C i^i ~P D ) ) $.
    $( In a closure system which is cut off above some level, closures below
       that level act as normal.  (Contributed by Stefan O'Rear,
       9-Mar-2015.) $)
    submrc $p |- ( ( C e. ( Moore ` X ) /\ D e. C /\ U C_ D ) ->
        ( G ` U ) = ( F ` U ) ) $=
      ( cmre cfv wcel wss w3a 3adant3 mrcssidd mrccl syl2anc mrcsscl syl3anc
      cpw cin submre simp1 simp3 mress sstrd 3com23 fvex elpw sylibr elin inss1
      sylanbrc sseldi eqssd ) AFIJKZBAKZCBLZMZCEJZCDJZUSABTZUAZBIJKZCVALVAVCKZU
      TVALUPUQVDURBAFUBNZUSACDFUPUQURUCZGUSCBFUPUQURUDZUPUQBFLURABFUENUFZOUSVAA
      KZVAVBKZVEUSUPCFLVJVGVIACDFGPQUSVABLZVKUPURUQVLACDBFGRUGVABCDUHUIUJVAAVBU
      KUMVCCEVABHRSUSUPCUTLUTAKVAUTLVGUSVCCEBVFHVHOUSVCAUTAVBULUSVDURUTVCKVFVHV
      CCEBHPQUNACDUTFGRSUO $.
  $}

  ${
    mrieqvlemd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrieqvlemd.2 $e |- N = ( mrCls ` A ) $.
    mrieqvlemd.3 $e |- ( ph -> S C_ X ) $.
    mrieqvlemd.4 $e |- ( ph -> Y e. S ) $.
    $( In a Moore system, if ` Y ` is a member of ` S ` , ` ( S \ { Y } ) ` and
       ` S ` have the same closure if and only if ` Y ` is in the closure of
       ` ( S \ { Y } ) ` .  Used in the proof of ~ mrieqvd and ~ mrieqv2d .
       Deduction form.  (Contributed by David Moews, 1-May-2017.) $)
    mrieqvlemd $p |- ( ph -> ( Y e. ( N ` ( S \ { Y } ) ) <->
                               ( N ` ( S \ { Y } ) ) = ( N ` S ) ) ) $=
      ( csn cdif cfv wcel wceq wa adantr cun mrcssidd simpr undif1 wss ssdifssd
      cmre snssd unssd syl5eqssr unssad difssd mressmrcd eqcomd sseldd eleqtrrd
      impbida ) AFCFKZLZDMZNZUQCDMZOZAURPZUSUQVABCUPDEABEUDMNURGQZHVACUOUQVACUO
      RUPUORUQCUOUAVAUPUOUQVABUPDEVBHVACEUOACEUBURIQUCSVAFUQAURTUEUFUGUHVACUOUI
      UJUKAUTPFUSUQAFUSNUTACUSFABCDEGHISJULQAUTTUMUN $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Independent sets in a Moore system
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A c s x $.  $d c N $.  $d s X $.
    mrisval.1 $e |- N = ( mrCls ` A ) $.
    mrisval.2 $e |- I = ( mrInd ` A ) $.
    $( Value of the set of independent sets of a Moore system.  (Contributed by
       David Moews, 1-May-2017.) $)
    mrisval $p |- ( A e. ( Moore ` X ) -> I = { s e. ~P X |
                    A. x e. s -. x e. ( N ` ( s \ { x } ) ) } ) $=
      ( vc cmre cfv wcel cv wn wral cuni cpw crab wceq cmrc cdif cmri fvssunirn
      csn sseli unieq pweqd fveq2 syl6eqr fveq1d eleq2d notbid rabeqbidv df-mri
      crn ralbidv vex uniex pwex rabex fvmpt3i syl syl5eq mreuni rabeq eqtrd )
      BEJKZLZCAMZFMZVIUDUAZDKZLZNZAVJOZFBPZQZRZVOFEQZRZVHCBUBKZVRHVHBJUOPZLWAVR
      SVGWBBJEUCUEIBVIVKIMZTKZKZLZNZAVJOZFWCPZQZRVRWBUBWCBSZWHVOFWJVQWKWIVPWCBU
      FUGWKWGVNAVJWKWFVMWKWEVLVIWKVKWDDWKWDBTKDWCBTUHGUIUJUKULUPUMAFIUNWHFWJWIW
      CIUQURUSUTVAVBVCVHVQVSSVRVTSVHVPEBEVDUGVOFVQVSVEVBVF $.
  $}

  ${
    $d A s x $.  $d s S x $.  $d s X $.  $d s N $.
    ismri.1 $e |- N = ( mrCls ` A ) $.
    ismri.2 $e |- I = ( mrInd ` A ) $.
    $( Criterion for a set to be an independent set of a Moore system.
       (Contributed by David Moews, 1-May-2017.) $)
    ismri $p |- ( A e. ( Moore ` X ) -> ( S e. I <->
                  ( S C_ X /\ A. x e. S -. x e. ( N ` ( S \ { x } ) ) ) ) ) $=
      ( vs cmre cfv wcel cpw cv cdif wn wral wa eleq2d cvv csn wss crab mrisval
      wceq difeq1 fveq2d notbid raleqbi1dv elrab syl6bb wb elfvex elpw2g anbi1d
      syl bitrd ) BFJKLZCDLZCFMZLZANZCVBUAZOZEKZLZPZACQZRZCFUBZVHRURUSCVBINZVCO
      ZEKZLZPZAVKQZIUTUCZLVIURDVQCABDEFIGHUDSVPVHICUTVOVGAVKCVKCUEZVNVFVRVMVEVB
      VRVLVDEVKCVCUFUGSUHUIUJUKURVAVJVHURFTLVAVJULBFJUMCFTUNUPUOUQ $.
  $}

  ${
    $d A x $.  $d S x $.
    ismri2.1 $e |- N = ( mrCls ` A ) $.
    ismri2.2 $e |- I = ( mrInd ` A ) $.
    $( Criterion for a subset of the base set in a Moore system to be
       independent.  (Contributed by David Moews, 1-May-2017.) $)
    ismri2 $p |- ( ( A e. ( Moore ` X ) /\ S C_ X ) ->
                   ( S e. I <-> A. x e. S -. x e. ( N ` ( S \ { x } ) ) ) ) $=
      ( cmre cfv wcel wss cv csn cdif wn wral ismri baibd ) BFIJKCDKCFLAMZCTNOE
      JKPACQABCDEFGHRS $.

    ismri2d.3 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    ismri2d.4 $e |- ( ph -> S C_ X ) $.
    $( Criterion for a subset of the base set in a Moore system to be
       independent.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    ismri2d $p |- ( ph ->
                    ( S e. I <-> A. x e. S -. x e. ( N ` ( S \ { x } ) ) ) ) $=
      ( cmre cfv wcel wss cv csn cdif wn wral wb ismri2 syl2anc ) ACGLMNDGODENB
      PZDUDQRFMNSBDTUAJKBCDEFGHIUBUC $.

    ismri2dd.5 $e |- ( ph -> A. x e. S -. x e. ( N ` ( S \ { x } ) ) ) $.
    $( Definition of independence of a subset of the base set in a Moore
       system.  One-way deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    ismri2dd $p |- ( ph -> S e. I ) $=
      ( wcel cv csn cdif cfv wn wral ismri2d mpbird ) ADEMBNZDUBOPFQMRBDSLABCDE
      FGHIJKTUA $.
  $}

  ${
    $d A x $.  $d S x $.
    mriss.1 $e |- I = ( mrInd ` A ) $.
    $( An independent set of a Moore system is a subset of the base set.
       (Contributed by David Moews, 1-May-2017.) $)
    mriss $p |- ( ( A e. ( Moore ` X ) /\ S e. I ) -> S C_ X ) $=
      ( vx cmre cfv wcel wss cv csn cdif cmrc wn wral eqid ismri simprbda ) ADG
      HIBCIBDJFKZBTLMANHZHIOFBPFABCUADUAQERS $.

    mrissd.2 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrissd.3 $e |- ( ph -> S e. I ) $.
    $( An independent set of a Moore system is a subset of the base set.
       Deduction form.  (Contributed by David Moews, 1-May-2017.) $)
    mrissd $p |- ( ph -> S C_ X ) $=
      ( cmre cfv wcel wss mriss syl2anc ) ABEIJKCDKCELGHBCDEFMN $.
  $}

  ${
    $d A x $.  $d S x $.  $d x ph $.  $d x Y $.  $d x N $.
    ismri2dad.1 $e |- N = ( mrCls ` A ) $.
    ismri2dad.2 $e |- I = ( mrInd ` A ) $.
    ismri2dad.3 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    ismri2dad.4 $e |- ( ph -> S e. I ) $.
    ismri2dad.5 $e |- ( ph -> Y e. S ) $.
    $( Consequence of a set in a Moore system being independent.  Deduction
       form.  (Contributed by David Moews, 1-May-2017.) $)
    ismri2dad $p |- ( ph -> -. Y e. ( N ` ( S \ { Y } ) ) ) $=
      ( vx cv csn cdif cfv wcel wn wral mrissd ismri2d mpbid wceq simpr difeq2d
      wa sneqd fveq2d eleq12d notbid rspcdv mpd ) AMNZCUNOZPZEQZRZSZMCTZGCGOZPZ
      EQZRZSZACDRUTKAMBCDEFHIJABCDFIJKUAUBUCAUSVEMGCLAUNGUDZUGZURVDVGUNGUQVCAVF
      UEZVGUPVBEVGUOVACVGUNGVHUHUFUIUJUKULUM $.
  $}

  ${
    $d A x $.  $d S x $.  $d x ph $.
    mrieqvd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrieqvd.2 $e |- N = ( mrCls ` A ) $.
    mrieqvd.3 $e |- I = ( mrInd ` A ) $.
    mrieqvd.4 $e |- ( ph -> S C_ X ) $.
    $( In a Moore system, a set is independent if and only if, for all elements
       of the set, the closure of the set with the element removed is unequal
       to the closure of the original set.  Part of Proposition 4.1.3 in
       [FaureFrolicher] p. 83.  (Contributed by David Moews, 1-May-2017.) $)
    mrieqvd $p |- ( ph -> ( S e. I <->
                          A. x e. S ( N ` ( S \ { x } ) ) =/= ( N ` S ) ) ) $=
      ( wcel cv csn cdif cfv wn wral wne adantr ismri2d wa wss simpr mrieqvlemd
      cmre necon3bbid ralbidva bitrd ) ADELBMZDUJNOFPZLZQZBDRUKDFPZSZBDRABCDEFG
      IJHKUAAUMUOBDAUJDLZUBZULUKUNUQCDFGUJACGUFPLUPHTIADGUCUPKTAUPUDUEUGUHUI $.

    $d s S x $.  $d s x ph $.  $d s x I $.  $d s x N $.
    $( In a Moore system, a set is independent if and only if all its proper
       subsets have closure properly contained in the closure of the set.  Part
       of Proposition 4.1.3 in [FaureFrolicher] p. 83.  (Contributed by David
       Moews, 1-May-2017.) $)
    mrieqv2d $p |- ( ph -> ( S e. I <->
                             A. s ( s C. S -> ( N ` s ) C. ( N ` S ) ) ) ) $=
      ( vx wcel wpss cfv wa w3a 3ad2ant1 adantr cvv cv wi wal wn wex pssnel csn
      3ad2ant3 cdif cmre wceq simprr difsnb sylib simpl3 pssssd ssdifd eqsstr3d
      simpl2 mrissd ssdifssd mrcssd difssd mrcssidd ismri2dad sspsstrd exlimddv
      simprl sseldd ssnelpssd 3expia alrimiv ex wral wne elfvexd wss difexg syl
      ssexd simp1r difsnpss simp2 psseq1d mpbird simp3 mpd fveq2d mpbid spcimdv
      3impia pssned 3com23 mrieqvlemd necon3bbid ralrimiv ismri2d sylibrd
      impbid ) ACDMZGUAZCNZXAEOZCEOZNZUBZGUCZAWTXGAWTPXFGAWTXBXEAWTXBQZLUAZCMZX
      IXAMUDZPZXELXBAXLLUEWTLXACUFUHXHXLPZXCCXIUGZUIZEOZXDXMBXAEXOFXHBFUJOMZXLA
      WTXQXBHRSZIXMXAXAXNUIZXOXMXKXSXAUKXHXJXKULXIXAUMUNXMXACXNXMXACAWTXBXLUOUP
      UQURXMCFXNXMBCDFJXRAWTXBXLUSZUTZVAVBXMXPXDXIXMBXOECFXRIXMCXNVCYAVBXMCXDXI
      XMBCEFXRIYAVDXHXJXKVHZVIXMBCDEFXIIJXRXTYBVEVJVFVGVKVLVMAXGXIXPMZUDZLCVNZW
      TAXGYEAXGPYDLCAXGXJYDAXGXJQZYDXPXDVOZAXJXGYGAXJXGQXPXDAXJXGXPXDNZAXJPZXFY
      HGXOTYICTMXOTMYICFTYIBUJFAXQXJHSVPACFVQZXJKSVTCXNTVRVSYIXAXOUKZXFYHYIYKXF
      QZXEYHYLXBXEYLXBXOCNZYLXJYMAXJYKXFWAXICWBUNYLXAXOCYIYKXFWCZWDWEYIYKXFWFWG
      YLXCXPXDYLXAXOEYNWHWDWIVKWJWKWLWMYFYCXPXDYFBCEFXIAXGXQXJHRIAXGYJXJKRAXGXJ
      WFWNWOWEVKWPVMALBCDEFIJHKWQWRWS $.
  $}

  ${
    $d A s $.  $d s S $.  $d s T $.  $d s X $.  $d s ph $.  $d s I $.
    $d s N $.
    mrissmrcd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrissmrcd.2 $e |- N = ( mrCls ` A ) $.
    mrissmrcd.3 $e |- I = ( mrInd ` A ) $.
    mrissmrcd.4 $e |- ( ph -> S C_ ( N ` T ) ) $.
    mrissmrcd.5 $e |- ( ph -> T C_ S ) $.
    mrissmrcd.6 $e |- ( ph -> S e. I ) $.
    $( In a Moore system, if an independent set is between a set and its
       closure, the two sets are equal (since the two sets must have equal
       closures by ~ mressmrcd , and so are equal by ~ mrieqv2d .)
       (Contributed by David Moews, 1-May-2017.) $)
    mrissmrcd $p |- ( ph -> S = T ) $=
      ( vs wpss wn wceq cfv wi psseq1d mressmrcd pssne necomd necon2bi syl wcel
      cv wal mrissd mrieqv2d mpbid cvv ssexd wa simpr fveq2d imbi12d spcdv mtod
      mpd wss wo sspss sylib ord eqcomd ) ADCADCOZPDCQZAVGDFRZCFRZOZAVJVIQVKPAB
      CDFGHIKLUAVKVJVIVKVIVJVIVJUBUCUDUEANUGZCOZVLFRZVJOZSZNUHZVGVKSZACEUFVQMAB
      CEFGNHIJABCEGJHMUIUJUKAVPVRNDULADCEMLUMAVLDQZUNZVMVGVOVKVTVLDCAVSUOZTVTVN
      VIVJVTVLDFWAUPTUQURUTUSAVGVHADCVAVGVHVBLDCVCVDVEUTVF $.
  $}

  ${
    $d A x $.  $d S x $.  $d T x $.  $d x ph $.
    mrissmrid.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mrissmrid.2 $e |- N = ( mrCls ` A ) $.
    mrissmrid.3 $e |- I = ( mrInd ` A ) $.
    mrissmrid.4 $e |- ( ph -> S e. I ) $.
    mrissmrid.5 $e |- ( ph -> T C_ S ) $.
    $( In a Moore system, subsets of independent sets are independent.
       (Contributed by David Moews, 1-May-2017.) $)
    mrissmrid $p |- ( ph -> T e. I ) $=
      ( vx mrissd sstrd cdif cfv wcel wn wral cv csn ismri2d mpbid sseld ssdifd
      ssdifssd mrcssd ssneld imim12d ralimdv2 mpd ismri2dd ) AMBDEFGIJHADCGLABC
      EGJHKNZOAMUAZCUOUBZPZFQZRSZMCTZUODUPPZFQZRSZMDTACERUTKAMBCEFGIJHUNUCUDAUS
      VCMCDAUODRUOCRUSVCADCUOLUEAVBURUOABVAFUQGHIADCUPLUFACGUPUNUGUHUIUJUKULUM
      $.
  $}

  ${
    $d s X y $.  $d s S y z $.  $d s ph y z $.  $d s y Y z $.  $d s y z Z $.
    $d s y z N $.
    mreexd.1 $e |- ( ph -> X e. V ) $.
    mreexd.2 $e |- ( ph -> A. s e. ~P X A. y e. X
                     A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                     y e. ( N ` ( s u. { z } ) ) ) $.
    mreexd.3 $e |- ( ph -> S C_ X ) $.
    mreexd.4 $e |- ( ph -> Y e. X ) $.
    mreexd.5 $e |- ( ph -> Z e. ( N ` ( S u. { Y } ) ) ) $.
    mreexd.6 $e |- ( ph -> -. Z e. ( N ` S ) ) $.
    $( In a Moore system, the closure operator is said to have the _exchange
       property_ if, for all elements ` y ` and ` z ` of the base set and
       subsets ` S ` of the base set such that ` z ` is in the closure of
       ` ( S u. { y } ) ` but not in the closure of ` S ` , ` y ` is in the
       closure of ` ( S u. { z } ) ` (Definition 3.1.9 in [FaureFrolicher]
       p. 57 to 58.)  This theorem allows us to construct substitution
       instances of this definition.  (Contributed by David Moews,
       1-May-2017.) $)
    mreexd $p |- ( ph -> Y e. ( N ` ( S u. { Z } ) ) ) $=
      ( csn cun cfv wcel cv cdif wral cpw wss wb elpw2g mpbird wceq wa ad2antrr
      syl adantr simplr simpr sneqd uneq12d fveq2d eleqtrrd wn neleqtrrd eldifd
      simpllr eleq12d rspcdv rspcimdv mpd ) ABUAZJUAZCUAZQZRZESZTZCVIVHQZRZESZV
      IESZUBZUCZBGUCZJGUDZUCHDIQZRZESZTZLAWAWFJDWBADWBTZDGUEZMAGFTWGWHUFKDGFUGU
      LUHAVIDUIZUJZVTWFBHGAHGTWINUMWJVHHUIZUJZVNWFCIVSWLIVQVRWLIDHQZRZESZVQAIWO
      TWIWKOUKWLVPWNEWLVIDVOWMAWIWKUNZWLVHHWJWKUOUPUQURUSWLVRDESZIAIWQTUTWIWKPU
      KWLVIDEWPURVAVBWLVJIUIZUJZVHHVMWEWJWKWRUNWSVLWDEWSVIDVKWCAWIWKWRVCWSVJIWL
      WRUOUPUQURVDVEVFVFVG $.
  $}

  ${
    $d A x $.  $d s X y $.  $d s S x y z $.  $d s x ph y z $.  $d s x y Y z $.
    $d s y z N $.
    mreexmrid.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mreexmrid.2 $e |- N = ( mrCls ` A ) $.
    mreexmrid.3 $e |- I = ( mrInd ` A ) $.
    mreexmrid.4 $e |- ( ph -> A. s e. ~P X A. y e. X
                        A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                        y e. ( N ` ( s u. { z } ) ) ) $.
    mreexmrid.5 $e |- ( ph -> S e. I ) $.
    mreexmrid.6 $e |- ( ph -> Y e. X ) $.
    mreexmrid.7 $e |- ( ph -> -. Y e. ( N ` S ) ) $.
    $( In a Moore system whose closure operator has the exchange property, if a
       set is independent and an element is not in its closure, then adding the
       element to the set gives another independent set.  Lemma 4.1.5 in
       [FaureFrolicher] p. 84.  (Contributed by David Moews, 1-May-2017.) $)
    mreexmrid $p |- ( ph -> ( S u. { Y } ) e. I ) $=
      ( cun cfv wcel vx csn mrissd snssd unssd cv cdif wn w3a cvv cmre 3ad2ant1
      wa elfvexd wral cpw ssdifssd simp3 difundir simp2 mrcssidd ssneldd nelneq
      wceq syl2anc elsni nsyl difsnb uneq2d syl5eq fveq2d eleqtrd mreexd undif1
      ismri2dad wss ssequn2 neleqtrrd pm2.65i df-3an mtbi imnani adantlr adantl
      sylib ad2antrr eqneltrd sneqd difeq2d difun2 eqtrd wo simpr elun mpjaodan
      syl6eq ralrimiva ismri2dd ) AUADEIUBZRZFGHLMKAEWSHADEFHMKOUCZAIHPUDUEAUAU
      FZWTXBUBZUGZGSZTZUHZUAWTAXBWTTZUMZXBETZXGXBWSTZAXJXGXHAXJUMZXFAXJXFUIZXLX
      FUMXMIEXCUGZXCRZGSZTXMBCXNGUJHIXBJXMDUKHAXJDHUKSTXFKULZUNAXJBUFZJUFZCUFUB
      RGSTCXSXRUBRGSXSGSUGUOBHUOJHUPUOXFNULXMEHXCXMDEFHMXQAXJEFTXFOULZUCUQAXJIH
      TXFPULXMXBXEXNWSRZGSAXJXFURXMXDYAGXMXDXNWSXCUGZRYAEWSXCUSXMYBWSXNXMXKUHYB
      WSVDXMXBIVDZXKXMXJIETUHZYCUHAXJXFUTZAXJYDXFAEEGSZIADEGHKLXAVAQVBZULXBIEVC
      VEXBIVFZVGXBWSVHWEVIVJVKVLXMDEFGHXBLMXQXTYEVOVMXMXPYFIAXJIYFTUHZXFQULXMXO
      EGXMXOEXCRZEEXCVNXMXCEVPYJEVDXMXBEYEUDXCEVQWEVJVKVRVSAXJXFVTWAWBWCXIXKUMZ
      XEYFXBYKXBIYFXKYCXIYHWDZAYIXHXKQWFWGYKXDEGYKXDEWSUGZEYKXDWTWSUGYMYKXCWSWT
      YKXBIYLWHWIEWSWJWPAYMEVDZXHXKAYDYNYGIEVHWEWFWKVKVRXIXHXJXKWLAXHWMXBEWSWNW
      EWOWQWR $.
  $}

  ${
    $d f F g h j $.  $d f g G h j $.  $d f g h H j $.  $d f g h ph j $.
    $d t u f v g h i I j $.  $d t u f v g h K $.  $d t u f v g h N $.
    $d t u f v g h X $.
    mreexexlemd.1 $e |- ( ph -> X e. J ) $.
    mreexexlemd.2 $e |- ( ph -> F C_ ( X \ H ) ) $.
    mreexexlemd.3 $e |- ( ph -> G C_ ( X \ H ) ) $.
    mreexexlemd.4 $e |- ( ph -> F C_ ( N ` ( G u. H ) ) ) $.
    mreexexlemd.5 $e |- ( ph -> ( F u. H ) e. I ) $.
    mreexexlemd.6 $e |- ( ph -> ( F ~~ K \/ G ~~ K ) ) $.
    mreexexlemd.7 $e |- ( ph -> A. t A. u e. ~P ( X \ t ) A. v e. ~P ( X \ t )
                                ( ( ( u ~~ K \/ v ~~ K ) /\
                                  u C_ ( N ` ( v u. t ) ) /\ ( u u. t ) e. I )
                           -> E. i e. ~P v ( u ~~ i /\ ( i u. t ) e. I ) ) ) $.
    $( This lemma is used to generate substitution instances of the induction
       hypothesis in ~ mreexexd .  (Contributed by David Moews, 1-May-2017.) $)
    mreexexlemd $p |- ( ph -> E. j e. ~P G ( F ~~ j /\ ( j u. H ) e. I ) ) $=
      ( vf vg vh cen wbr wo cun cfv wss wcel cv wa cpw wrex w3a wi cdif wal weq
      wral simplr breq1d orbi12d simpll uneq12d fveq2d sseq12d eleq1d 3anbi123d
      simpr simpllr breq12d simplll anbi12d pweqd cbvrexdva2 imbi12d wceq simpl
      difeq2d adantr cbvraldva2 cbvalv sylib cvv ssun2 a1i wb difexg syl mpbird
      ssexd elpwg eleqtrrd ad2antrr uneq2d rexeqbidv rspcdv rspcimdv mpd mp3and
      spcimdv ) AGLUEUFZHLUEUFZUGZGHIUHZMUIZUJZGIUHZJUKZGFULZUEUFZXLIUHZJUKZUMZ
      FHUNZUOZTRSAUBULZLUEUFZUCULZLUEUFZUGZXSYAUDULZUHZMUIZUJZXSYDUHZJUKZUPZXSX
      LUEUFZXLYDUHZJUKZUMZFYAUNZUOZUQZUCNYDURZUNZVAZUBYSVAZUDUSZXFXIXKUPZXRUQZA
      CULZLUEUFZBULZLUEUFZUGZUUEUUGDULZUHZMUIZUJZUUEUUJUHZJUKZUPZUUEEULZUEUFZUU
      QUUJUHZJUKZUMZEUUGUNZUOZUQZBNUUJURZUNZVAZCUVFVAZDUSUUBUAUVHUUADUDDUDUTZUV
      GYTCUBUVFYSUVICUBUTZUMZUVDYQBUCUVFYSUVKBUCUTZUMZUUPYJUVCYPUVMUUIYCUUMYGUU
      OYIUVMUUFXTUUHYBUVMUUEXSLUEUVIUVJUVLVBZVCUVMUUGYALUEUVKUVLVKZVCVDUVMUUEXS
      UULYFUVNUVMUUKYEMUVMUUGYAUUJYDUVOUVIUVJUVLVEZVFVGVHUVMUUNYHJUVMUUEXSUUJYD
      UVNUVPVFVIVJUVMUVAYNEFUVBYOUVMEFUTZUMZUURYKUUTYMUVRUUEXSUUQXLUEUVIUVJUVLU
      VQVLUVMUVQVKZVMUVRUUSYLJUVRUUQXLUUJYDUVSUVIUVJUVLUVQVNVFVIVOUVRUUGYAUVKUV
      LUVQVBVPVQVRUVKUVFYSVSUVLUVKUVEYRUVKUUJYDNUVIUVJVTWAVPZWBWCUVTWCWDWEAUUAU
      UDUDIWFAIXJJSIXJUJAIGWGWHWMAYDIVSZUMZYTUUDUBGYSUWBGNIURZUNZYSAGUWDUKZUWAA
      UWEGUWCUJZPAGWFUKUWEUWFWIAGUWCWFANKUKUWCWFUKONIKWJWKZPWMGUWCWFWNWKWLWBUWB
      YRUWCUWBYDINAUWAVKWAVPZWOUWBXSGVSZUMZYQUUDUCHYSUWJHUWDYSAHUWDUKZUWAUWIAUW
      KHUWCUJZQAHWFUKUWKUWLWIAHUWCWFUWGQWMHUWCWFWNWKWLWPUWBYSUWDVSUWIUWHWBWOUWJ
      YAHVSZUMZYJUUCYPXRUWNYCXFYGXIYIXKUWNXTXDYBXEUWNXSGLUEUWBUWIUWMVBZVCUWNYAH
      LUEUWJUWMVKZVCVDUWNXSGYFXHUWOUWNYEXGMUWNYAHYDIUWPAUWAUWIUWMVLZVFVGVHUWNYH
      XJJUWNXSGYDIUWOUWQVFVIVJUWNYNXPFYOXQUWNYAHUWPVPUWNYKXMYMXOUWNXSGXLUEUWOVC
      UWNYLXNJUWNYDIXLUWQWQVIVOWRVRWSWTXCXAXB $.
  $}

  ${
    mreexexlem2d.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mreexexlem2d.2 $e |- N = ( mrCls ` A ) $.
    mreexexlem2d.3 $e |- I = ( mrInd ` A ) $.
    mreexexlem2d.4 $e |- ( ph -> A. s e. ~P X A. y e. X
                           A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                           y e. ( N ` ( s u. { z } ) ) ) $.
    mreexexlem2d.5 $e |- ( ph -> F C_ ( X \ H ) ) $.
    mreexexlem2d.6 $e |- ( ph -> G C_ ( X \ H ) ) $.
    mreexexlem2d.7 $e |- ( ph -> F C_ ( N ` ( G u. H ) ) ) $.
    mreexexlem2d.8 $e |- ( ph -> ( F u. H ) e. I ) $.
    ${
      $d s F g y z $.  $d s g G y z $.  $d s g H y z $.  $d s g ph y z $.
      $d s g y Y z $.  $d s g y z N $.  $d s X y $.
      mreexexlem2d.9 $e |- ( ph -> Y e. F ) $.
      $( Used in ~ mreexexlem4d to prove the induction step in ~ mreexexd .
         See the proof of Proposition 4.2.1 in [FaureFrolicher] p. 86 to 87.
         (Contributed by David Moews, 1-May-2017.) $)
      mreexexlem2d $p |- ( ph -> E. g e. G
                              ( -. g e. ( F \ { Y } ) /\
                                ( ( F \ { Y } ) u. ( H u. { g } ) ) e. I ) ) $=
        ( cv wcel csn cdif wn cun wa wex wrex cfv wss cmre simpr ssun2 difundir
        adantr wceq cin c0 incom ssdifin0 syl syl5eqr minel difsnb sylib uneq2d
        syl2anc syl5eq syl5sseqr mrissd ssdifssd mrcssidd sstrd mrcssvd mrcidmd
        unssd mrcssd sseqtrd sseldd sseldi ismri2dad pm2.65da nss simprl simprr
        ssun1 ssneldd unass wral cpw difss unss1 mp1i mrissmrid fveq2d neleqtrd
        difss2d mreexmrid syl5eqelr jca32 ex eximdv mpd df-rex sylibr ) AEUCZGU
        DZXIFLUEZUFZUDUGZXLHXIUEZUHUHZIUDZUIZUIZEUJZXQEGUKAXJXIFHUHZXKUFZJULZUD
        UGZUIZEUJZXSAGYBUMZUGYEAYFLYBUDAYFUIZFYBLYGFGHUHZJULZYBAFYIUMYFTURYGYIY
        BJULYBYGDYHJYBKADKUNULUDZYFNURZOYGGHYBAYFUOAHYBUMYFAHYAYBAXLHUHZHYAHXLU
        PAYAXLHXKUFZUHYLFHXKUQAYMHXLALHUDUGZYMHUSALFUDZHFUTZVAUSYNUBAYPFHUTZVAF
        HVBAFKHUFZUMYQVAUSRFKHVCVDVELFHVFVJLHVGVHVIVKZVLADYAJKNOAXTKXKADXTIKPNU
        AVMVNZVOZVPURVSYGDYAJKYKOVQVTYGDYAJKYKOAYAKUMYFYTURVRWAVPAYOYFUBURZWBYG
        DXTIJKLOPYKAXTIUDZYFUAURYGFXTLFHWIUUBWCWDWEEGYBWFVHAYDXREAYDXRAYDUIZXJX
        MXPAXJYCWGZUUDXLYBXIAXLYBUMYDAXLYAYBAYLXLYAXLHWIYSVLUUAVPURAXJYCWHZWJUU
        DXOYLXNUHIXLHXNWKUUDBCDYLIJKXIMAYJYDNURZOPABUCZMUCZCUCUEUHJULUDCUUIUUHU
        EUHJULUUIJULUFWLBKWLMKWMWLYDQURUUDDXTYLIJKUUGOPAUUCYDUAURXLFUMYLXTUMUUD
        FXKWNXLFHWOWPWQUUDGKXIUUDGKHAGYRUMYDSURWTUUEWBUUDYBYLJULXIUUFUUDYAYLJAY
        AYLUSYDYSURWRWSXAXBXCXDXEXFXQEGXGXH $.
    $}

    ${
      $d F i $.  $d G i $.  $d H i $.  $d i I $.
      mreexexlem3d.9 $e |- ( ph -> ( F = (/) \/ G = (/) ) ) $.
      $( Base case of the induction in ~ mreexexd .  (Contributed by David
         Moews, 1-May-2017.) $)
      mreexexlem3d $p |- ( ph ->
                           E. i e. ~P G ( F ~~ i /\ ( i u. H ) e. I ) ) $=
        ( cpw wcel cen wbr cun cv wa wrex c0 wceq simpr wss cdif cin cfv adantr
        cmre uneq1d uncom un0 eqtr3i syl6eq fveq2d mrissd unssbd mrcssidd unssd
        sseqtrd ssun2 a1i mrissmrcd ssequn1 sylibr ssind disjdif syl6sseq sylib
        ss0b mpjaodan 0elpw syl6eqel cvv elfvexd difss2d ssexd enrefg syl breq2
        uneq1 eleq1d anbi12d rspcev syl12anc ) AFGUBZUCFFUDUEZFHUFZIUCZFEUGZUDU
        EZWSHUFZIUCZUHZEWOUIAFUJWOAFUJUKZXDGUJUKZAXDULAXEUHZFUJUMXDXFFHKHUNZUOU
        JXFFHXGXFWQHUKFHUMXFDWQHIJKADKURUPUCXEMUQZNOXFFHHJUPZXFFGHUFZJUPZXIAFXK
        UMXESUQXFXJHJXFXJUJHUFZHXFGUJHAXEULUSHUJUFXLHHUJUTHVAVBVCVDVIXFDHJKXHNX
        FFHKXFDWQIKOXHAWRXETUQZVEVFVGVHHWQUMXFHFVJVKXMVLFHVMVNAFXGUMXEQUQVOHKVP
        VQFVSVRUAVTGWAWBAFWCUCWPAFKWCADURKMWDAFKHQWEWFFWCWGWHTXCWPWRUHEFWOWSFUK
        ZWTWPXBWRWSFFUDWIXNXAWQIWSFHWJWKWLWMWN $.
    $}

    ${
      $d f g h X $.  $d f g h I i j $.  $d f g h L $.  $d f g h N $.
      $d q s y z N $.  $d q r s F y z $.  $d q r s G y z $.  $d q r s H y z $.
      $d q r s ph y z $.  $d q r I i j $.  $d q r ph i $.  $d q r F i j $.
      $d q r G i j $.  $d q r H i j $.  $d s X y $.
      mreexexlem4d.9 $e |- ( ph -> L e. om ) $.
      mreexexlem4d.A $e |- ( ph ->
                             A. h A. f e. ~P ( X \ h ) A. g e. ~P ( X \ h )
                             ( ( ( f ~~ L \/ g ~~ L ) /\
                               f C_ ( N ` ( g u. h ) ) /\ ( f u. h ) e. I ) ->
                              E. j e. ~P g ( f ~~ j /\ ( j u. h ) e. I ) ) ) $.
      mreexexlem4d.B $e |- ( ph -> ( F ~~ suc L \/ G ~~ suc L ) ) $.
      $( Induction step of the induction in ~ mreexexd .  (Contributed by David
         Moews, 1-May-2017.) $)
      mreexexlem4d $p |- ( ph ->
                           E. j e. ~P G ( F ~~ j /\ ( j u. H ) e. I ) ) $=
        ( vr vq vi cv cen wbr cun wcel wa cpw wrex c0 wceq cmre cfv adantr cdif
        csn wral wss simpr orcd mreexexlem3d wne wex biimpi adantl mreexexlem2d
        n0 wn w3a 3anass ad2antrr elfvexd simpr2 difsnb sylib ssdifssd eqsstr3d
        ssdifd difun1 syl6sseqr simpr1 uncom uneq2i unass difsnid uneq1d syl5eq
        cvv syl5eqr syl fveq2d sseqtr4d simpr3 csuc wo wi simplr 3anan12 dif1en
        com sylbir expcom syl2anc orim12d mpd mreexexlemd simprl elpwid difss2d
        wal simplr1 snssd unssd wb ad3antrrr elpw2g mpbird ad3antlr cin simprrl
        ssexd vex en2sn mp2an a1i incom disjdif eqtri ssdifin0 unen rexlimddv
        syl22anc eqbrtrrd eqtr2i simprrr syl5eqelr breq2 uneq1 anbi12d syl12anc
        eleq1d rspcev sylan2br adantlr exlimddv pm2.61dane ) AIHUKZULUMZUUPKUNZ
        LUOZUPZHJUQZURZIUSAIUSUTZUPZBCDHIJKLNOPADOVAVBUOZUVCQVCRSABUKZPUKZCUKVE
        UNNVBUOCUVGUVFVEUNNVBUVGNVBVDVFBOVFPOUQVFZUVCTVCAIOKVDZVGZUVCUAVCAJUVIV
        GZUVCUBVCAIJKUNZNVBZVGZUVCUCVCAIKUNLUOZUVCUDVCUVDUVCJUSUTAUVCVHVIVJAIUS
        VKZUPUHUKZIUOZUVBUHUVPUVRUHVLZAUVPUVSUHIVPVMVNAUVRUVBUVPAUVRUPZUIUKZIUV
        QVEZVDZUOVQZUWCKUWAVEZUNZUNLUOZUPZUVBUIJUVTBCDUIIJKLNOUVQPAUVEUVRQVCRSA
        UVHUVRTVCAUVJUVRUAVCAUVKUVRUBVCAUVNUVRUCVCAUVOUVRUDVCAUVRVHVOUWAJUOZUWH
        UPUVTUWIUWDUWGVRZUVBUWIUWDUWGVSUVTUWJUPZUWCUJUKZULUMZUWLUWFUNZLUOZUPZUV
        BUJJUWEVDZUQZUWKFEGHUJUWCUWQUWFLWQMNOUWKDVAOAUVEUVRUWJQVTWAZUWKUWCUVIUW
        EVDZOUWFVDZUWKUWCUWCUWEVDZUWTUWKUWDUXBUWCUTUVTUWIUWDUWGWBUWAUWCWCWDUWKU
        WCUVIUWEUWKIUVIUWBAUVJUVRUWJUAVTWEWGWFOKUWEWHZWIUWKUWQUWTUXAUWKJUVIUWEA
        UVKUVRUWJUBVTWGUXCWIUWKIUWQUWFUNZNVBZUWBUWKIUVMUXEAUVNUVRUWJUCVTUWKUXDU
        VLNUWKUWIUXDUVLUTUVTUWIUWDUWGWJZUWIUXDUWQUWEKUNZUNZUVLUWFUXGUWQKUWEWKWL
        UWIUXHUWQUWEUNZKUNUVLUWQUWEKWMUWIUXIJKJUWAWNWOWRWPWSWTXAWEUVTUWIUWDUWGX
        BUWKIMXCZULUMZJUXJULUMZXDZUWCMULUMZUWQMULUMZXDAUXMUVRUWJUGVTUWKUXKUXNUX
        LUXOUWKMXIUOZUVRUXKUXNXEAUXPUVRUWJUEVTZAUVRUWJXFUXKUXPUVRUPZUXNUXKUXRUP
        UXPUXKUVRVRUXNUXPUXKUVRXGIMUVQXHXJXKXLUWKUXPUWIUXLUXOXEUXQUXFUXLUXPUWIU
        PZUXOUXLUXSUPUXPUXLUWIVRUXOUXPUXLUWIXGJMUWAXHXJXKXLXMXNAEUKZMULUMFUKZMU
        LUMXDUXTUYAGUKZUNNVBVGUXTUYBUNLUOVRUXTUUPULUMUUPUYBUNLUOUPHUYAUQURXEFOU
        YBVDUQZVFEUYCVFGXSUVRUWJUFVTXOUWKUWLUWRUOZUWPUPZUPZUWLUWEUNZUVAUOZIUYGU
        LUMZUYGKUNZLUOZUVBUYFUYHUYGJVGZUYFUWLUWEJUYFUWLJUWEUYFUWLUWQUWKUYDUWPXP
        XQZXRUYFUWAJUWIUWDUWGUVTUYEXTYAYBUYFJWQUOUYHUYLYCUYFJOWQUWKOWQUOUYEUWSV
        CUYFJOKAUVKUVRUWJUYEUBYDXRYJUYGJWQYEWSYFUYFUWCUWBUNZIUYGULUVRUYNIUTAUWJ
        UYEIUVQWNYGUYFUWMUWBUWEULUMZUWCUWBYHZUSUTZUWLUWEYHUSUTZUYNUYGULUMUWKUYD
        UWMUWOYIUYOUYFUVQWQUOUWAWQUOUYOUHYKUIYKUVQUWAWQWQYLYMYNUYQUYFUYPUWBUWCY
        HUSUWCUWBYOUWBIYPYQYNUYFUWLUWQVGUYRUYMUWLJUWEYRWSUWCUWLUWBUWEYSUUAUUBUY
        FUYJUWNLUYJUWLUXGUNUWNUWLUWEKWMUXGUWFUWLUWEKWKWLUUCUWKUYDUWMUWOUUDUUEUU
        TUYIUYKUPHUYGUVAUUPUYGUTZUUQUYIUUSUYKUUPUYGIULUUFUYSUURUYJLUUPUYGKUUGUU
        JUUHUUKUUIYTUULYTUUMUUNUUO $.
    $}

    $d q f F g h $.  $d f F g h l $.  $d q f g G h $.  $d f g G h l $.
    $d s f g h X y z k $.  $d s f g h ph y z k $.  $d s f g h y I i z k $.
    $d s f g h y z k N $.  $d f g h X k l $.  $d f g h ph k l $.
    $d f g h I i k l $.  $d f g h k l N $.  $d q f g h ph $.  $d q f g h I i $.
    $d q H $.
    mreexexd.9 $e |- ( ph -> ( F e. Fin \/ G e. Fin ) ) $.
    $( Exchange-type theorem.  In a Moore system whose closure operator has the
       exchange property, if ` F ` and ` G ` are disjoint from ` H ` ,
       ` ( F u. H ) ` is independent, ` F ` is contained in the closure of
       ` ( G u. H ) ` , and either ` F ` or ` G ` is finite, then there is a
       subset ` q ` of ` G ` equinumerous to ` F ` such that ` ( q u. H ) ` is
       independent.  This implies the case of Proposition 4.2.1 in
       [FaureFrolicher] p. 86 where either ` ( A \ B ) ` or ` ( B \ A ) ` is
       finite.  The theorem is proven by induction using ~ mreexexlem3d for the
       base case and ~ mreexexlem4d for the induction step.  (Contributed by
       David Moews, 1-May-2017.) $)
    mreexexd $p |- ( ph -> E. q e. ~P G ( F ~~ q /\ ( q u. H ) e. I ) ) $=
      ( vg vf vh vi vl vk cvv ccrd cfv cin cmre elfvexd wceq wo cen word cardon
      wbr onordi ordtri2or3 mp2an difss2d ssexd cardidd breq2 syl5ibcom orim12d
      ensymd mpi com wcel cv cun wss w3a wa cpw wrex cdif wral wal cfn ficardom
      wi orim12i wb ordom ordelinel mp3an sylibr c0 csuc orbi12d 3anbi1d imbi1d
      syl 2ralbidv albidv imbi2d ad2antrr csn simplrl elpwid simplrr simpr2 en0
      simpr3 simpr1 orbi12i sylib mreexexlem3d ex ralrimivva alrimiv nfa1 nf3an
      nfv nfra1 nfal nfra2 3ad2ant1 simpll2 simpll3 mreexexlem4d ralrimi alrimi
      nfan expr 3exp com12 a2d finds mpcom mreexexlemd ) AUBUCUDUELEFGHUHEUIUJZ
      FUIUJZUKZIJADULJMUMZQRSTAYPYRUNZYQYRUNZUOZEYRUPUSZFYRUPUSZUOYPUQZYQUQZUUB
      YPEURUTZYQFURUTZYPYQVAVBAYTUUCUUAUUDAEYPUPUSYTUUCAYPEAEUHAEJUHYSAEJGQVCVD
      VEVIYPYREUPVFVGAFYQUPUSUUAUUDAYQFAFUHAFJUHYSAFJGRVCVDVEVIYQYRFUPVFVGVHVJY
      RVKVLZAUCVMZYRUPUSZUBVMZYRUPUSZUOZUUJUULUDVMZVNIUJVOZUUJUUOVNHVLZVPZUUJUE
      VMZUPUSUUSUUOVNHVLVQUEUULVRVSZWEZUBJUUOVTZVRZWAUCUVCWAZUDWBZAYPVKVLZYQVKV
      LZUOZUUIAEWCVLZFWCVLZUOUVHUAUVIUVFUVJUVGEWDFWDWFWQUUEUUFVKUQUUIUVHWGUUGUU
      HWHYPYQVKWIWJWKAUUJUFVMZUPUSZUULUVKUPUSZUOZUUPUUQVPZUUTWEZUBUVCWAUCUVCWAZ
      UDWBZWEAUUJWLUPUSZUULWLUPUSZUOZUUPUUQVPZUUTWEZUBUVCWAUCUVCWAZUDWBZWEAUUJU
      GVMZUPUSZUULUWFUPUSZUOZUUPUUQVPZUUTWEZUBUVCWAZUCUVCWAZUDWBZWEAUUJUWFWMZUP
      USZUULUWOUPUSZUOZUUPUUQVPZUUTWEZUBUVCWAZUCUVCWAZUDWBZWEAUVEWEUFUGYRUVKWLU
      NZUVRUWEAUXDUVQUWDUDUXDUVPUWCUCUBUVCUVCUXDUVOUWBUUTUXDUVNUWAUUPUUQUXDUVLU
      VSUVMUVTUVKWLUUJUPVFUVKWLUULUPVFWNWOWPWRWSWTUVKUWFUNZUVRUWNAUXEUVQUWMUDUX
      EUVPUWKUCUBUVCUVCUXEUVOUWJUUTUXEUVNUWIUUPUUQUXEUVLUWGUVMUWHUVKUWFUUJUPVFU
      VKUWFUULUPVFWNWOWPWRWSWTUVKUWOUNZUVRUXCAUXFUVQUXBUDUXFUVPUWTUCUBUVCUVCUXF
      UVOUWSUUTUXFUVNUWRUUPUUQUXFUVLUWPUVMUWQUVKUWOUUJUPVFUVKUWOUULUPVFWNWOWPWR
      WSWTUVKYRUNZUVRUVEAUXGUVQUVDUDUXGUVPUVAUCUBUVCUVCUXGUVOUURUUTUXGUVNUUNUUP
      UUQUXGUVLUUKUVMUUMUVKYRUUJUPVFUVKYRUULUPVFWNWOWPWRWSWTAUWDUDAUWCUCUBUVCUV
      CAUUJUVCVLZUULUVCVLZVQZVQZUWBUUTUXKUWBVQZBCDUEUUJUULUUOHIJKADJULUJVLZUXJU
      WBMXANOABVMZKVMZCVMXBVNIUJVLCUXOUXNXBVNIUJUXOIUJVTWABJWAKJVRWAZUXJUWBPXAU
      XLUUJUVBAUXHUXIUWBXCXDUXLUULUVBAUXHUXIUWBXEXDUXKUWAUUPUUQXFUXKUWAUUPUUQXH
      UXLUWAUUJWLUNZUULWLUNZUOUXKUWAUUPUUQXIUVSUXQUVTUXRUUJXGUULXGXJXKXLXMXNXOU
      WFVKVLZAUWNUXCAUXSUWNUXCWEAUXSUWNUXCAUXSUWNVPZUXBUDAUXSUWNUDAUDXRUXSUDXRU
      WMUDXPXQUXTUXAUCUVCAUXSUWNUCAUCXRUXSUCXRUWMUCUDUWLUCUVCXSXTXQUXTUXHUXAUXT
      UXHVQUWTUBUVCUXTUXHUBAUXSUWNUBAUBXRUXSUBXRUWMUBUDUWKUCUBUVCUVCYAXTXQUXHUB
      XRYHUXTUXHUXIUWTUXTUXJVQZUWSUUTUYAUWSVQZBCDUCUBUDUEUUJUULUUOHUWFIJKUXTUXM
      UXJUWSAUXSUXMUWNMYBXANOUXTUXPUXJUWSAUXSUXPUWNPYBXAUYBUUJUVBUXTUXHUXIUWSXC
      XDUYBUULUVBUXTUXHUXIUWSXEXDUYAUWRUUPUUQXFUYAUWRUUPUUQXHAUXSUWNUXJUWSYCAUX
      SUWNUXJUWSYDUYAUWRUUPUUQXIYEXMYIYFXMYFYGYJYKYLYMYNYO $.
  $}

  ${
    $d s X y z $.  $d s ph y z $.  $d s y I z $.  $d s y z N $.  $d S i $.
    $d T i $.  $d ph i $.  $d i I $.
    mreexdomd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mreexdomd.2 $e |- N = ( mrCls ` A ) $.
    mreexdomd.3 $e |- I = ( mrInd ` A ) $.
    mreexdomd.4 $e |- ( ph -> A. s e. ~P X A. y e. X
                        A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                        y e. ( N ` ( s u. { z } ) ) ) $.
    mreexdomd.5 $e |- ( ph -> S C_ ( N ` T ) ) $.
    mreexdomd.6 $e |- ( ph -> T C_ X ) $.
    mreexdomd.7 $e |- ( ph -> ( S e. Fin \/ T e. Fin ) ) $.
    mreexdomd.8 $e |- ( ph -> S e. I ) $.
    $( In a Moore system whose closure operator has the exchange property, if
       ` S ` is independent and contained in the closure of ` T ` , and either
       ` S ` or ` T ` is finite, then ` T ` dominates ` S ` .  This is an
       immediate consequence of ~ mreexexd .  (Contributed by David Moews,
       1-May-2017.) $)
    mreexdomd $p |- ( ph -> S ~<_ T ) $=
      ( vi c0 cv cen wbr cun wcel wa cdom cpw cdif mrissd dif0 syl6sseqr fveq2i
      cfv un0 syl5eqel mreexexd simprrl wss simprl elpwid wi cmre elfvexd ssexd
      cvv ssdomg syl adantr mpd endomtr syl2anc rexlimddv ) AESUAZUBUCZVNTUDGUE
      ZUFZEFUGUCZSFUHZABCDEFTGHIJSKLMNAEIITUIZADEGIMKRUJIUKZULAFIVTPWAULAEFHUNF
      TUDZHUNOWBFHFUOUMULAETUDEGEUORUPQUQAVNVSUEZVQUFZUFZVOVNFUGUCZVRAWCVOVPURW
      EVNFUSZWFWEVNFAWCVQUTVAAWGWFVBZWDAFVFUEWHAFIVFADVCIKVDPVEVNFVFVGVHVIVJEVN
      FVKVLVM $.
  $}

  ${
    $d s X y z $.  $d s ph y z $.  $d s y I z $.  $d s y z N $.
    mreexfidimd.1 $e |- ( ph -> A e. ( Moore ` X ) ) $.
    mreexfidimd.2 $e |- N = ( mrCls ` A ) $.
    mreexfidimd.3 $e |- I = ( mrInd ` A ) $.
    mreexfidimd.4 $e |- ( ph -> A. s e. ~P X A. y e. X
                          A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                          y e. ( N ` ( s u. { z } ) ) ) $.
    mreexfidimd.5 $e |- ( ph -> S e. I ) $.
    mreexfidimd.6 $e |- ( ph -> T e. I ) $.
    mreexfidimd.7 $e |- ( ph -> S e. Fin ) $.
    mreexfidimd.8 $e |- ( ph -> ( N ` S ) = ( N ` T ) ) $.
    $( In a Moore system whose closure operator has the exchange property, if
       two independent sets have equal closure and one is finite, then they are
       equinumerous.  Proven by using ~ mreexdomd twice.  This implies a
       special case of Theorem 4.2.2 in [FaureFrolicher] p. 87.  (Contributed
       by David Moews, 1-May-2017.) $)
    mreexfidimd $p |- ( ph -> S ~~ T ) $=
      ( cdom wbr cen cfv mrcssidd sseqtrd cfn wcel orcd mreexdomd sseqtr4d olcd
      mrissd sbth syl2anc ) AEFSTFESTEFUATABCDEFGHIJKLMNAEEHUBZFHUBZADEHIKLADEG
      IMKOUKZUCRUDADFGIMKPUKZAEUEUFZFUEUFZQUGOUHABCDFEGHIJKLMNAFUOUNADFHIKLUQUC
      RUIUPAURUSQUJPUHEFULUM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Algebraic closure systems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d C c f s $.  $d C t y $.  $d F f s t y z $.  $d S s y $.  $d X c f s x $.
    $d X t y $.
    $( A set is an algebraic closure system iff it is specified by some
       function of the finite subsets, such that a set is closed iff it does
       not expand under the operation.  (Contributed by Stefan O'Rear,
       2-Apr-2015.) $)
    isacs $p |- ( C e. ( ACS ` X ) <-> ( C e. ( Moore ` X ) /\
          E. f ( f : ~P X --> ~P X /\ A. s e. ~P X ( s e. C <->
                  U. ( f " ( ~P s i^i Fin ) ) C_ s ) ) ) ) $=
      ( vc vx cacs cfv wcel cvv cmre cpw cv wf wb wral wa wex elfvex crab fveq2
      cfn cin cima cuni wss adantr wceq feq23d raleqdv anbi12d exbidv rabeqbidv
      wel pweq df-acs fvex rabex fvmpt eleq2d eleq2 bibi1d ralbidv anbi2d elrab
      syl6bb pm5.21nii ) ACGHZIZCJIZACKHZIZCLZVMBMZNZDMZAIZVNVPLUBUCUDUEVPUFZOZ
      DVMPZQZBRZQZACGSVLVJWBACKSUGVJVIAVODEUNZVROZDVMPZQZBRZEVKTZIWCVJVHWIAFCFM
      ZLZWKVNNZWEDWKPZQZBRZEWJKHZTWIJGWJCUHZWOWHEWPVKWJCKUAWQWNWGBWQWLVOWMWFWQW
      KWKVMVMVNWJCUOZWRUIWQWEDWKVMWRUJUKULUMFBDEUPWHEVKCKUQURUSUTWHWBEAVKEMZAUH
      ZWGWABWTWFVTVOWTWEVSDVMWTWDVQVRWSAVPVAVBVCVDULVEVFVG $.

    $( Algebraic closure systems are closure systems.  (Contributed by Stefan
       O'Rear, 2-Apr-2015.) $)
    acsmre $p |- ( C e. ( ACS ` X ) -> C e. ( Moore ` X ) ) $=
      ( vf vs cacs cfv wcel cmre cpw cv wf cfn cin cima cuni wss wb wral wa wex
      isacs simplbi ) ABEFGABHFGBIZUCCJZKDJZAGUDUEILMNOUEPQDUCRSCTACBDUAUB $.

    isacs2.f $e |- F = ( mrCls ` C ) $.
    $( In the definition of an algebraic closure system, we may always take the
       operation being closed over as the Moore closure.  (Contributed by
       Stefan O'Rear, 2-Apr-2015.) $)
    isacs2 $p |- ( C e. ( ACS ` X ) <-> ( C e. ( Moore ` X ) /\
          A. s e. ~P X ( s e. C <->
              A. y e. ( ~P s i^i Fin ) ( F ` y ) C_ s ) ) ) $=
      ( vf vt vz cfv wcel cpw cv cfn wss wb wral wa sseq1d syl2anc cacs cmre wf
      cin cima cuni wex isacs ciun iunss wfun wceq funiunfv syl syl5rbbr bibi2d
      ffun ralbidv pm5.32i exbii simpll inss1 sseli elpwi adantl simplr mrcsscl
      syl3anc ralrimiva adantlr adantllr wi simplll ad2antlr sstrd mrcssidd vex
      elpw sylibr inss2 sylanbrc mrccl mresspw ad3antrrr sseldd simprr ad2antrr
      elin eleq1 ineq1d sseq2 raleqbidv bibi12d rspcva mpbid weq fveq2 ralimdva
      pweq sstr2 imp cbvralv sylib mpbird impbida ex exlimdv mrcf fss cmrc fvex
      cvv eqeltri feq1 fveq1 syl6bb anbi12d spcev sylan impbid syl5bb bitri ) B
      DUAJKBDUBJKZDLZYDGMZUCZHMZBKZYEYGLZNUDZUEUFZYGOZPZHYDQZRZGUGZRYCEMZBKZAMZ
      CJZYQOZAYQLZNUDZQZPZEYDQZRBGDHUHYCYPUUFYPYFYHIMZYEJZYGOZIYJQZPZHYDQZRZGUG
      ZYCUUFYOUUMGYFYNUULYFYMUUKHYDYFYLUUJYHUUJIYJUUHUIZYGOYFYLIYJUUHYGUJYFUUOY
      KYGYFYEUKUUOYKULYDYDYEUQIYJYEUMUNSUOUPURUSUTYCUUNUUFYCUUMUUFGYCUUMUUFYCUU
      MRZUUEEYDUUPYQYDKZRZYRUUDYCUUQYRUUDUUMYCYRUUDUUQYCYRRZUUAAUUCUUSYSUUCKZRY
      CYSYQOZYRUUAYCYRUUTVAUUTUVAUUSUUTYSUUBKUVAUUCUUBYSUUBNVBVCYSYQVDUNZVEYCYR
      UUTVFBYSCYQDFVGVHVIVJVKUURUUDRZYRUUHYQOZIUUCQZUVCYSYEJZYQOZAUUCQZUVEUURUU
      DUVHUURUUAUVGAUUCUURUUTRZUVFYTOZUUAUVGVLUVIYSYTLZNUDZKZUUHYTOZIUVLQZUVJUV
      IYSUVKKZYSNKZUVMUVIYSYTOUVPUVIBYSCDYCUUMUUQUUTVMZFUVIYSYQDUUTUVAUURUVBVEU
      UQYQDOUUPUUTYQDVDVNVOZVPYSYTAVQVRVSUUTUVQUURUUCNYSUUBNVTVCVEYSUVKNWHWAUVI
      YTBKZUVOUVIYCYSDOUVTUVRUVSBYSCDFWBTZUVIYTYDKUULUVTUVOPZUVIBYDYTYCBYDOZUUM
      UUQUUTBDWCZWDUWAWEUUPUULUUQUUTYCYFUULWFZWGUUKUWBHYTYDYGYTULZYHUVTUUJUVOYG
      YTBWIUWFUUIUVNIYJUVLUWFYIUVKNYGYTWSWJYGYTUUHWKWLWMWNTWOUVNUVJIYSUVLIAWPZU
      UHUVFYTUUGYSYEWQSWNTUVFYTYQWTUNWRXAUVGUVDAIUUCAIWPUVFUUHYQYSUUGYEWQSXBXCU
      VCUUQUULYRUVEPZUUPUUQUUDVFUUPUULUUQUUDUWEWGUUKUWHHYQYDHEWPZYHYRUUJUVEYGYQ
      BWIZUWIUUIUVDIYJUUCUWIYIUUBNYGYQWSWJZYGYQUUHWKWLWMWNTXDXEVIXFXGYCUUFUUNYC
      YDYDCUCZUUFUUNYCYDBCUCUWCUWLBCDFXHUWDYDBYDCXITUUMUWLUUFRGCCBXJJXLFBXJXKXM
      YECULZYFUWLUULUUFYDYDYECXNUWMUULYHYTYGOZAYJQZPZHYDQUUFUWMUUKUWPHYDUWMUUJU
      WOYHUWMUUJUUGCJZYGOZIYJQUWOUWMUUIUWRIYJUWMUUHUWQYGUUGYECXOSURUWRUWNIAYJUW
      GUWQYTYGUUGYSCWQSXBXPUPURUWPUUEHEYDUWIYHYRUWOUUDUWJUWIUWNUUAAYJUUCUWKYGYQ
      YTWKWLWMXBXPXQXRXSXFXTYAUSYB $.

    $( A set is closed in an algebraic closure system iff it contains all
       closures of finite subsets.  (Contributed by Stefan O'Rear,
       2-Apr-2015.) $)
    acsfiel $p |- ( C e. ( ACS ` X ) -> ( S e. C <->
          ( S C_ X /\ A. y e. ( ~P S i^i Fin ) ( F ` y ) C_ S ) ) ) $=
      ( vs cacs cfv wcel wss wa cv cpw cfn cin wral cmre acsmre wb mress ex cdm
      sylan pm4.71rd elfvdm elpw2g syl biimpar isacs2 simprbi adantr wceq eleq1
      pweq ineq1d sseq2 raleqbidv bibi12d rspcva syl2anc pm5.32da bitrd ) BEHIJ
      ZCBJZCEKZVELVFAMDIZCKZACNZOPZQZLVDVEVFVDVEVFVDBERIJZVEVFBESBCEUAUDUBUEVDV
      FVEVKVDVFLCENZJZGMZBJZVGVOKZAVONZOPZQZTZGVMQZVEVKTZVDVNVFVDEHUCZJVNVFTBEH
      UFCEWDUGUHUIVDWBVFVDVLWBABDEGFUJUKULWAWCGCVMVOCUMZVPVEVTVKVOCBUNWEVQVHAVS
      VJWEVRVIOVOCUOUPVOCVGUQURUSUTVAVBVC $.

    $( A set is closed in an algebraic closure system iff it contains all
       closures of finite subsets.  (Contributed by Stefan O'Rear,
       3-Apr-2015.) $)
    acsfiel2 $p |- ( ( C e. ( ACS ` X ) /\ S C_ X ) -> ( S e. C <->
          A. y e. ( ~P S i^i Fin ) ( F ` y ) C_ S ) ) $=
      ( cacs cfv wcel wss cv cpw cfn cin wral acsfiel baibd ) BEGHICBICEJAKDHCJ
      ACLMNOABCDEFPQ $.
  $}

  ${
    acsmred.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    $( An algebraic closure system is also a Moore system.  Deduction form of
       ~ acsmre .  (Contributed by David Moews, 1-May-2017.) $)
    acsmred $p |- ( ph -> A e. ( Moore ` X ) ) $=
      ( cacs cfv wcel cmre acsmre syl ) ABCEFGBCHFGDBCIJ $.
  $}

  ${
    $d F a s t $.  $d F f $.  $d V a t $.  $d X a s t $.  $d X f $.
    $d f s t $.
    $( A closure system determined by a function is a closure system and
       algebraic.  (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    isacs1i $p |- ( ( X e. V /\ F : ~P X --> ~P X ) ->
        { s e. ~P X | U. ( F " ( ~P s i^i Fin ) ) C_ s } e. ( ACS ` X ) ) $=
      ( vf vt va wcel cpw wa cv cfn cin cima cuni wss wral syl unieqd cvv wf wb
      crab cmre cfv wex cacs ssrab2 a1i cint elpw2g mpbiri ad2antrr crn imassrn
      inss1 adantl syl5ss unissd unipw syl6sseq adantr inss2 intss1 sspwb sylib
      frn wel ssrin imass2 ssel2 pweq ineq1d imaeq2d id sseq12d simprbi adantll
      weq elrab sstrd ralrimiva ssint sylibr ssind sylanbrc ismred2 fssxp pwexg
      wceq cxp xpexg syl2anc ssexg syl2anr simpr elrab3 rgen feq1 imaeq1 sseq1d
      jctir bibi2d ralbidv anbi12d spcegv sylc isacs ) CBHZCIZXJAUAZJZADKZIZLMZ
      NZOZXMPZDXJUCZCUDUEHXJXJEKZUAZFKZXSHZXTYBIZLMZNZOZYBPZUBZFXJQZJZEUFZXSCUG
      UEHXLXSCFXSXJPXLXRDXJUHUIXLYBXSPZJZCYBUJZMZXJHZAYPIZLMZNZOZYPPZYPXSHXIYQX
      KYMXIYQYPCPCYOUPYPCBUKULUMYNUUACYOXLUUACPYMXLUUAXJOCXLYTXJXLYTAUNZXJAYSUO
      XKUUCXJPXIXJXJAVGUQURUSCUTVAVBYNUUAGKZPZGYBQUUAYOPYNUUEGYBYNGFVHZJZUUAAUU
      DIZLMZNZOZUUDUUGYTUUJUUGYSUUIPZYTUUJPUUGYRUUHPZUULUUGYPUUDPZUUMUUFUUNYNUU
      FYPYOUUDCYOVCUUDYBVDURUQYPUUDVEVFYRUUHLVIRYSUUIAVJRUSYMUUFUUKUUDPZXLYMUUF
      JUUDXSHZUUOYBXSUUDVKUUPUUDXJHUUOXRUUODUUDXJDGVSZXQUUKXMUUDUUQXPUUJUUQXOUU
      IAUUQXNUUHLXMUUDVLVMVNSUUQVOVPVTVQRVRWAWBGUUAYBWCWDWEXRUUBDYPXJXMYPWJZXQU
      UAXMYPUURXPYTUURXOYSAUURXNYRLXMYPVLVMVNSUURVOVPVTWFWGXLATHZXKYCAYENZOZYBP
      ZUBZFXJQZJZYLXKAXJXJWKZPUVFTHZUUSXIXJXJAWHXIXJTHZUVHUVGCBWIZUVIXJXJTTWLWM
      AUVFTWNWOXLXKUVDXIXKWPUVCFXJXRUVBDYBXJDFVSZXQUVAXMYBUVJXPUUTUVJXOYEAUVJXN
      YDLXMYBVLVMVNSUVJVOVPWQWRXBYKUVEEATXTAWJZYAXKYJUVDXJXJXTAWSUVKYIUVCFXJUVK
      YHUVBYCUVKYGUVAYBUVKYFUUTXTAYEWTSXAXCXDXEXFXGXSECFXHWF $.
  $}

  ${
    $d K a b c $.  $d T a b c $.  $d V a b c $.  $d X a b c x $.  $d a d e $.
    $d a f $.  $d b d e $.  $d b f $.  $d c d e $.  $d c f $.  $d d f x $.
    $d e x $.
    $( Algebraicity is a composible property; combining several algebraic
       closure properties gives another.  (Contributed by Stefan O'Rear,
       3-Apr-2015.) $)
    mreacs $p |- ( X e. V -> ( ACS ` X ) e. ( Moore ` ~P X ) ) $=
      ( va vf vb vc vd ve cv cfv cpw cmre wcel wceq wss sylibr wb wral wa cvv
      cacs fveq2 pweq fveq2d eleq12d wtru acsmre mresspw syl vex elpw ssriv a1i
      vx cint cin wf cfn cima cuni wex mremre mp1i sstr mpan2 mrerintcl syl2anc
      cmrc ciun cmpt cxp wel ssel2 acsmred mrcssvd ralrimiva adantr iunss elpw2
      eqid fmptd fssxp pwex xpex ssexg sylancl elpwi ad2antlr acsfiel2 ralbidva
      adantlr ralbii ralcom bitri syl6bbr elrint2 adantl funmpt funiunfv sseq1i
      wfun ax-mp inss1 sspwb sylib syl5ss sselda ad2antrr iuneq2d fvmptg sseq1d
      weq syl5bb syl5bbr 3bitr4d feq1 imaeq1 unieqd bibi2d ralbidv anbi12d sylc
      jca spcegv isacs sylanbrc ismred2 trud vtoclg ) UNIZUAJZYJKZLJZMZBUAJZBKZ
      LJZMUNBAYJBNZYKYOYMYQYJBUAUBYRYLYPLYJBUCUDUEYNUFYKYLCYKYLKZOUFCYKYSCIZYKM
      ZYTYLOZYTYSMUUAYTYJLJZMUUBYTYJUGZYTYJUHUIYTYLCUJUKPULUMYTYKOZYLYTUOUPZYKM
      ZUFUUEUUFUUCMZYLYLDIZUQZEIZUUFMZUUIUUKKZURUPZUSZUTZUUKOZQZEYLRZSZDVAZUUGU
      UEUUCYMMZYTUUCOZUUHYJTMZUVBUUEUNUJZTYJVBVCUUEYKUUCOUVCCYKUUCUUDULYTYKUUCV
      DVEUUCYTYLVFVGUUEFYLGYTFIZGIZVHJZJZVIZVJZTMZYLYLUVKUQZUULUVKUUNUSZUTZUUKO
      ZQZEYLRZSZUVAUUEUVKYLYLVKZOZUVTTMUVLUUEUVMUWAUUEFYLUVJYLUVKUUEUVFYLMZSZUV
      JYJOZUVJYLMUWCUVIYJOZGYTRZUWDUUEUWFUWBUUEUWEGYTUUEGCVLZSZUVGUVFUVHYJUWHUV
      GYJYTYKUVGVMZVNZUVHVTZVOVPVQGYTUVIYJVRPUVJYJUVEVSPUVKVTZWAZYLYLUVKWBUIYLY
      LYJUVEWCZUWNWDUVKUVTTWEWFUUEUVMUVRUWMUUEUVQEYLUUEUUKYLMZSZEGVLZGYTRZGYTHI
      ZUVHJZVIZUUKOZHUUNRZUULUVPUWPUWRUWTUUKOZHUUNRZGYTRZUXCUWPUWQUXEGYTUWPUWGS
      UVGYKMZUUKYJOZUWQUXEQUUEUWGUXGUWOUWIWKUWOUXHUUEUWGUUKYJWGZWHHUVGUUKUVHYJU
      WKWIVGWJUXCUXDGYTRZHUUNRUXFUXBUXJHUUNGYTUWTUUKVRWLUXDHGUUNYTWMWNWOUWOUULU
      WRQUUEGYLYTUUKWPWQUVPHUUNUWSUVKJZVIZUUKOZUWPUXCUXLUVOUUKUVKXAUXLUVONFYLUV
      JWRHUUNUVKWSXBWTUXMUXKUUKOZHUUNRUWPUXCHUUNUXKUUKVRUWPUXNUXBHUUNUWPUWSUUNM
      ZSZUXKUXAUUKUXPUWSYLMUXATMZUXKUXANUWPUUNYLUWSUWPUUNUUMYLUUMURXCUWOUUMYLOZ
      UUEUWOUXHUXRUXIUUKYJXDXEWQXFXGUXPUXAYJOZUVDUXQUXPUWTYJOZGYTRZUXSUUEUYAUWO
      UXOUUEUXTGYTUWHUVGUWSUVHYJUWJUWKVOVPXHGYTUWTYJVRPUVEUXAYJTWEWFFUWSUVJUXAY
      LTUVKFHXLGYTUVIUWTUVFUWSUVHUBXIUWLXJVGXKWJXMXNXOVPYCUUTUVSDUVKTUUIUVKNZUU
      JUVMUUSUVRYLYLUUIUVKXPUYBUURUVQEYLUYBUUQUVPUULUYBUUPUVOUUKUYBUUOUVNUUIUVK
      UUNXQXRXKXSXTYAYDYBUUFDYJEYEYFWQYGYHYI $.

    $( Algebraicity of a conditional point closure condition.  (Contributed by
       Stefan O'Rear, 3-Apr-2015.) $)
    acsfn $p |- ( ( ( X e. V /\ K e. X ) /\ ( T C_ X /\ T e. Fin ) ) ->
        { a e. ~P X | ( T C_ a -> K e. a ) } e. ( ACS ` X ) ) $=
      ( vb vc wcel wa wss cfn cv wi cpw wceq c0 wral syl wb adantl crab csn cif
      cmpt cin cima cuni cacs ciun wfun funmpt funiunfv mp1i inss1 sseli elpwid
      cfv elpwi sylan9ssr vex elpw sylibr adantll weq eqeq1 ifbid eqid snex 0ex
      fvmpt iuneq2dv eqtr3d sseq1d iunss sseq1 bibi1d snssg adantr biimt bitr3d
      ifex wn 0ss a1i pm2.21 2thd ifbothda ralbidv ad3antlr syl5bb sspwb syl5ss
      sylib ralss bi2.04 ralbii elpwg biimparc ad2antlr imbi1d ceqsralv simplrr
      eleq1 elpw2 biantrud elin syl6bbr syl5rbbr 3bitrd 3bitrrd rabbidva simpll
      wf snelpwi 0elpw ifcl sylancl fmptd isacs1i syl2anc eqeltrd ) DCHZBDHZIZA
      DJZAKHZIZIZAELZJZBYIHZMZEDNZUAFYMFLZAOZBUBZPUCZUDZYINZKUEZUFUGZYIJZEYMUAZ
      DUHUQZYHYLUUBEYMYHYIYMHZIZUUBGYTGLZAOZYPPUCZUIZYIJZUUHYKMZGYTQZYLUUFUUAUU
      JYIUUFGYTUUGYRUQZUIZUUAUUJYRUJUUOUUAOUUFFYMYQUKGYTYRULUMUUFGYTUUNUUIUUFUU
      GYTHZIUUGYMHZUUNUUIOUUEUUPUUQYHUUEUUPIUUGDJUUQUUPUUEUUGYIDUUPUUGYIYTYSUUG
      YSKUNZUOUPYIDURZUSUUGDGUTVAVBVCFUUGYQUUIYMYRFGVDYOUUHYPPYNUUGAVEVFYRVGZUU
      HYPPBVHVIWAVJRVKVLVMUUKUUIYIJZGYTQZUUFUUMGYTUUIYIVNYCUVBUUMSYBYGUUEYCUVAU
      ULGYTUUHYPYIJZUULSPYIJZUULSZUVAUULSYCYPPYPUUIOUVCUVAUULYPUUIYIVOVPPUUIOUV
      DUVAUULPUUIYIVOVPYCUUHIYKUVCUULYCYKUVCSUUHBYIDVQVRUUHYKUULSYCUUHYKVSTVTUU
      HWBZUVEYCUVFUVDUULUVDUVFYIWCWDUUHYKWEWFTWGWHWIWJUUFUUMUUPUULMZGYMQZAYTHZY
      KMZYLUUFYTYMJZUUMUVHSUUEUVKYHUUEYTYSYMUURUUEYIDJYSYMJUUSYIDWKWMWLTUULGYTY
      MWNRUVHUUHUUPYKMZMZGYMQZUUFUVJUVGUVMGYMUUPUUHYKWOWPUUFAYMHZUVNUVJSYGUVOYD
      UUEYFUVOYEADKWQWRWSUVLUVJGAYMUUHUUPUVIYKUUGAYTXCWTXARWJUUFUVIYJYKYJAYSHZU
      UFUVIAYIEUTXDUUFUVPUVPYFIUVIUUFYFUVPYDYEYFUUEXBXEAYSKXFXGXHWTXIXJXKYHYBYM
      YMYRXMUUCUUDHYBYCYGXLYHFYMYQYMYRYHYQYMHZYNYMHYHYPYMHZPYMHUVQYCUVRYBYGBDXN
      WSDXOYOYPPYMXPXQVRUUTXRYRCDEXSXTYA $.

    $( Algebraicity of a point closure condition.  (Contributed by Stefan
       O'Rear, 3-Apr-2015.) $)
    acsfn0 $p |- ( ( X e. V /\ K e. X ) ->
        { a e. ~P X | K e. a } e. ( ACS ` X ) ) $=
      ( wcel wa cv cpw crab c0 wss wi cacs cfv wb 0ss a1bi a1i rabbiia cfn 0fin
      acsfn mpanr12 syl5eqel ) CBEACEFZADGZEZDCHZIJUFKZUGLZDUHIZCMNZUGUJDUHUGUJ
      OUFUHEUIUGUFPQRSUEJCKJTEUKULECPUAJABCDUBUCUD $.

    $d E a $.
    $( Algebraicity of a one-argument closure condition.  (Contributed by
       Stefan O'Rear, 3-Apr-2015.) $)
    acsfn1 $p |- ( ( X e. V /\ A. b e. X E e. X ) ->
        { a e. ~P X | A. b e. a E e. a } e. ( ACS ` X ) ) $=
      ( wcel wral wa cv cpw crab csn wss wi ciin cin cacs cfv wel wb elpwi snss
      ralss syl vex imbi1i ralbii syl6bb rabbiia riinrab eqtr4i cmre mreacs cfn
      adantr simpll simpr snssi ad2antlr snfi acsfn syl22anc ralimdva mreriincl
      a1i ex imp syl2anc syl5eqel ) CBFZACFZECGZHZADIZFZEVNGZDCJZKZVQECEIZLZVNM
      ZVONZDVQKZOPZCQRZVRWBECGZDVQKWDVPWFDVQVNVQFZVPEDSZVONZECGZWFWGVNCMVPWJTVN
      CUAVOEVNCUCUDWIWBECWHWAVOVSVNEUEUBUFUGUHUIWBEDVQCUJUKVMWEVQULRFZWCWEFZECG
      ZWDWEFVJWKVLBCUMUOVJVLWMVJVKWLECVJVSCFZHZVKWLWOVKHZVJVKVTCMZVTUNFZWLVJWNV
      KUPWOVKUQWNWQVJVKVSCURUSWRWPVSUTVEVTABCDVAVBVFVCVGEWEWCCVQVDVHVI $.

    $( Algebraicity of a one-argument closure condition with additional
       constant.  (Contributed by Stefan O'Rear, 3-Apr-2015.) $)
    acsfn1c $p |- ( ( X e. V /\ A. b e. K A. c e. X E e. X ) ->
        { a e. ~P X | A. b e. K A. c e. a E e. a } e. ( ACS ` X ) ) $=
      ( wcel wral wa cv cpw crab ciin cin cacs cfv riinrab cmre mreacs ralimdv
      adantr acsfn1 ex imp mreriincl syl2anc syl5eqelr ) DCHZADHGDIZFBIZJZAEKZH
      GUMIZFBIEDLZMUOFBUNEUOMZNOZDPQZUNFEUOBRULURUOSQHZUPURHZFBIZUQURHUIUSUKCDT
      UBUIUKVAUIUJUTFBUIUJUTACDEGUCUDUAUEFURUPBUOUFUGUH $.

    $( Algebraicity of a two-argument closure condition.  (Contributed by
       Stefan O'Rear, 3-Apr-2015.) $)
    acsfn2 $p |- ( ( X e. V /\ A. b e. X A. c e. X E e. X ) ->
        { a e. ~P X | A. b e. a A. c e. a E e. a } e. ( ACS ` X ) ) $=
      ( wcel wral wa cv crab wss wi ciin cin cfv wel ralss vex riinrab cpw cacs
      cpr wb elpwi r19.21v impexp prss imbi1i bitr3i ralbii 3bitr3g ralbidv syl
      bitrd rabbiia eqtr4i cmre mreacs adantr ad2antrr cfn simpll simprr ancoms
      prssi ad2ant2lr prfi a1i acsfn syl22anc expr ralimdva mreriincl syl5eqelr
      imp syl2anc ex syl5eqel ) CBGZACGZFCHZECHZIZADJZGZFWEHZEWEHZDCUAZKZWIECFJ
      ZEJZUCZWELZWFMZFCHZDWIKZNOZCUBPZWJWPECHZDWIKWRWHWTDWIWEWIGWECLZWHWTUDWECU
      EXAWHEDQZWGMZECHWTWGEWECRXAXCWPECXAXBWFMZFWEHFDQZXDMZFCHXCWPXDFWECRXBWFFW
      EUFXFWOFCXFXEXBIZWFMWOXEXBWFUGXGWNWFWKWLWEFSESUHUIUJUKULUMUOUNUPWPEDWICTU
      QWDWSWIURPGZWQWSGZECHZWRWSGVTXHWCBCUSZUTVTWCXJVTWBXIECVTWLCGZIZWBXIXMWBIZ
      WQWIFCWODWIKZNOZWSWOFDWICTXNXHXOWSGZFCHZXPWSGVTXHXLWBXKVAXMWBXRXMWAXQFCXM
      WKCGZWAXQXMXSWAIZIZVTWAWMCLZWMVBGZXQVTXLXTVCXMXSWAVDXLXSYBVTWAXSXLYBWKWLC
      VFVEVGYCYAWKWLVHVIWMABCDVJVKVLVMVPFWSXOCWIVNVQVOVRVMVPEWSWQCWIVNVQVS $.
  $}

$(
###############################################################################
                       BASIC CATEGORY THEORY
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
    Categories
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Categories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Cat $. $( The class of all categories. $)
  $c Id $. $( The identity arrow in a category. $)
  $c Homf $. $( The functionalized hom-set operation. $)
  $c comf $. $( The functionalized composition operation. $)

  $( Extend class notation with the class of categories. $)
  ccat $a class Cat $.

  $( Extend class notation with the identity arrow of a category. $)
  ccid $a class Id $.

  $( Extend class notation to include functionalized Hom-set extractor. $)
  chomf $a class Homf $.

  $( Extend class notation to include functionalized composition operation. $)
  ccomf $a class comf $.

  ${
    $d b c f g h i k o w x y z .1. $.  $d b c f g h i k o w x y z .x. $.
    $d b c f g h i k o w x y z B $.  $d b c f g h i k o w x y z C $.
    $d b c f g h i k o w x y z H $.
    $( A category is an abstraction of a structure (a group, a topology, an
       order...)  Category theory consists in finding new formulation of the
       concepts associated to those structures (product, substructure...) using
       morphisms instead of the belonging relation.  That trick has the
       interesting property that heterogeneous structures like topologies or
       groups for instance become comparable.  (Note: in category theory
       morphisms are also called arrows.)  (Contributed by FL, 24-Oct-2007.)
       (Revised by Mario Carneiro, 2-Jan-2017.) $)
    df-cat $a |- Cat = { c | [. ( Base ` c ) / b ]. [. ( Hom ` c ) / h ].
      [. ( comp ` c ) / o ]. A. x e. b
      ( E. g e. ( x h x ) A. y e. b
        ( A. f e. ( y h x ) ( g ( <. y , x >. o x ) f ) = f /\
          A. f e. ( x h y ) ( f ( <. x , x >. o y ) g ) = f ) /\
        A. y e. b A. z e. b A. f e. ( x h y ) A. g e. ( y h z )
      ( ( g ( <. x , y >. o z ) f ) e. ( x h z ) /\ A. w e. b A. k e. ( z h w )
         ( ( k ( <. y , z >. o w ) g ) ( <. x , y >. o w ) f ) =
         ( k ( <. x , z >. o w ) ( g ( <. x , y >. o z ) f ) ) ) ) } $.

    $( Define the category identity arrow.  Since it is uniquely defined when
       it exists, we do not need to add it to the data of the category, and
       instead extract it by uniqueness.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    df-cid $a |- Id = ( c e. Cat |->
      [_ ( Base ` c ) / b ]_ [_ ( Hom ` c ) / h ]_ [_ ( comp ` c ) / o ]_
      ( x e. b |-> ( iota_ g e. ( x h x ) A. y e. b
        ( A. f e. ( y h x ) ( g ( <. y , x >. o x ) f ) = f /\
          A. f e. ( x h y ) ( f ( <. x , x >. o y ) g ) = f ) ) ) ) $.

    $( Define the functionalized Hom-set operator, which is exactly like
       ` Hom ` but is guaranteed to be a function on the base.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    df-homf $a |- Homf = ( c e. _V |->
      ( x e. ( Base ` c ) , y e. ( Base ` c ) |-> ( x ( Hom ` c ) y ) ) ) $.

    $( Define the functionalized composition operator, which is exactly like
       ` comp ` but is guaranteed to be a function of the proper type.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    df-comf $a |- comf = ( c e. _V |->
      ( x e. ( ( Base ` c ) X. ( Base ` c ) ) , y e. ( Base ` c ) |->
      ( g e. ( ( 2nd ` x ) ( Hom ` c ) y ) , f e. ( ( Hom ` c ) ` x ) |->
        ( g ( x ( comp ` c ) y ) f ) ) ) ) $.

    iscat.b $e |- B = ( Base ` C ) $.
    iscat.h $e |- H = ( Hom ` C ) $.
    iscat.o $e |- .x. = ( comp ` C ) $.
    $( The predicate "is a category".  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    iscat $p |- ( C e. V -> ( C e. Cat <-> A. x e. B
      ( E. g e. ( x H x ) A. y e. B
          ( A. f e. ( y H x ) ( g ( <. y , x >. .x. x ) f ) = f /\
            A. f e. ( x H y ) ( f ( <. x , x >. .x. y ) g ) = f ) /\
        A. y e. B A. z e. B A. f e. ( x H y ) A. g e. ( y H z )
        ( ( g ( <. x , y >. .x. z ) f ) e. ( x H z ) /\
          A. w e. B A. k e. ( z H w )
         ( ( k ( <. y , z >. .x. w ) g ) ( <. x , y >. .x. w ) f ) =
         ( k ( <. x , z >. .x. w ) ( g ( <. x , y >. .x. z ) f ) ) ) ) ) ) $=
      ( cv co wceq wral oveqd vo vh vb cop wrex wcel cco cfv wsbc chom cbs ccat
      vc wa cvv fvex a1i fveq2 syl6eqr simpl fveq2d simpll simpllr simplr simpr
      eqeq1d raleqbidv anbi12d rexeqbidv eleq12d eqidd oveq123d eqeq12d sbcied2
      df-cat elab2g ) IPZHPZBPZAPZUDZVTUAPZQZQZVRRZHVSVTUBPZQZSZVRVQVTVTUDZVSWB
      QZQZVRRZHVTVSWFQZSZUNZBUCPZSZIVTVTWFQZUEZVQVRVTVSUDZCPZWBQZQZVTXAWFQZUFZJ
      PZVQVSXAUDZDPZWBQZQZVRWTXHWBQZQZXFXCVTXAUDZXHWBQZQZRZJXAXHWFQZSZDWPSZUNZI
      VSXAWFQZSZHWMSZCWPSZBWPSZUNZAWPSZUAUMPZUGUHZUIZUBYHUJUHZUIZUCYHUKUHZUIVQV
      RWAVTGQZQZVRRZHVSVTKQZSZVRVQWIVSGQZQZVRRZHVTVSKQZSZUNZBESZIVTVTKQZUEZVQVR
      WTXAGQZQZVTXAKQZUFZXFVQXGXHGQZQZVRWTXHGQZQZXFUUIXMXHGQZQZRZJXAXHKQZSZDESZ
      UNZIVSXAKQZSZHUUBSZCESZBESZUNZAESZUMFULLYHFRZYLUVIUCYMEUOYMUOUFUVJYHUKUPU
      QUVJYMFUKUHEYHFUKURMUSUVJWPERZUNZYJUVIUBYKKUOYKUOUFUVLYHUJUPUQUVLYKFUJUHK
      UVLYHFUJUVJUVKUTVANUSUVLWFKRZUNZYGUVIUAYIGUOYIUOUFUVNYHUGUPUQUVNYIFUGUHGU
      VNYHFUGUVJUVKUVMVBVAOUSUVNWBGRZUNZYFUVHAWPEUVJUVKUVMUVOVCZUVPWSUUGYEUVGUV
      PWQUUEIWRUUFUVPWFKVTVTUVLUVMUVOVDZTUVPWOUUDBWPEUVQUVPWHYRWNUUCUVPWEYPHWGY
      QUVPWFKVSVTUVRTUVPWDYOVRUVPWCYNVQVRUVPWBGWAVTUVNUVOVEZTTVFVGUVPWLUUAHWMUU
      BUVPWFKVTVSUVRTZUVPWKYTVRUVPWJYSVRVQUVPWBGWIVSUVSTTVFVGVHVGVIUVPYDUVFBWPE
      UVQUVPYCUVECWPEUVQUVPYBUVDHWMUUBUVTUVPXTUVBIYAUVCUVPWFKVSXAUVRTUVPXEUUKXS
      UVAUVPXCUUIXDUUJUVPXBUUHVQVRUVPWBGWTXAUVSTTZUVPWFKVTXAUVRTVJUVPXRUUTDWPEU
      VQUVPXPUURJXQUUSUVPWFKXAXHUVRTUVPXLUUOXOUUQUVPXJUUMVRVRXKUUNUVPWBGWTXHUVS
      TUVPXIUULXFVQUVPWBGXGXHUVSTTUVPVRVKVLUVPXFXFXCUUIXNUUPUVPWBGXMXHUVSTUVPXF
      VKUWAVLVMVGVGVHVGVGVGVGVHVGVNVNVNABCDHIUBJUAUCUMVOVP $.
  $}

  ${
    $d f g y .1. $.  $d f g k w x y z B $.  $d f g k w x y z ph $.  $d g .x. $.
    $d f g k w x y z C $.  $d f g k w H $.
    iscatd.b $e |- ( ph -> B = ( Base ` C ) ) $.
    iscatd.h $e |- ( ph -> H = ( Hom ` C ) ) $.
    iscatd.o $e |- ( ph -> .x. = ( comp ` C ) ) $.
    iscatd.c $e |- ( ph -> C e. V ) $.
    iscatd.1 $e |- ( ( ph /\ x e. B ) -> .1. e. ( x H x ) ) $.
    iscatd.2 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ f e. ( y H x ) ) ) ->
      ( .1. ( <. y , x >. .x. x ) f ) = f ) $.
    iscatd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ f e. ( x H y ) ) ) ->
      ( f ( <. x , x >. .x. y ) .1. ) = f ) $.
    iscatd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) /\
      ( f e. ( x H y ) /\ g e. ( y H z ) ) ) ->
        ( g ( <. x , y >. .x. z ) f ) e. ( x H z ) ) $.
    iscatd.5 $e |- ( ( ph /\ ( ( x e. B /\ y e. B ) /\ ( z e. B /\ w e. B ) )
      /\ ( f e. ( x H y ) /\ g e. ( y H z ) /\ k e. ( z H w ) ) ) ->
       ( ( k ( <. y , z >. .x. w ) g ) ( <. x , y >. .x. w ) f ) =
         ( k ( <. x , z >. .x. w ) ( g ( <. x , y >. .x. z ) f ) ) ) $.
    $( Properties that determine a category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    iscatd $p |- ( ph -> C e. Cat ) $=
      ( ccat wcel cv cop cco cfv co wceq chom wral wa wrex 3exp2 imp31 ralrimiv
      cbs wi ralrimiva oveq1 eqeq1d ralbidv oveq2 anbi12d rspcev syl2anc 3expia
      jca w3a imp43 3expa imp32 expr exp3a imp42 ralrimdva ralrimivv ralrimivva
      ex jcad oveqd raleqbidv rexeqbidv eleq12d eqidd oveq123d eqeq12d mpbid wb
      eqid iscat syl mpbird ) AGUDUEZKUFZJUFZCUFZBUFZUGZWTGUHUIZUJZUJZWRUKZJWSW
      TGULUIZUJZUMZWRWQWTWTUGZWSXBUJZUJZWRUKZJWTWSXFUJZUMZUNZCGUSUIZUMZKWTWTXFU
      JZUOZWQWRWTWSUGZDUFZXBUJZUJZWTYAXFUJZUEZLUFZWQWSYAUGZEUFZXBUJZUJZWRXTYHXB
      UJZUJZYFYCWTYAUGZYHXBUJZUJZUKZLYAYHXFUJZUMZEXPUMZUNZKWSYAXFUJZUMZJXMUMZDX
      PUMZCXPUMZUNZBXPUMZAWQWRXAWTHUJZUJZWRUKZJWSWTMUJZUMZWRWQXIWSHUJZUJZWRUKZJ
      WTWSMUJZUMZUNZCFUMZKWTWTMUJZUOZWQWRXTYAHUJZUJZWTYAMUJZUEZYFWQYGYHHUJZUJZW
      RXTYHHUJZUJZYFUVCYMYHHUJZUJZUKZLYAYHMUJZUMZEFUMZUNZKWSYAMUJZUMZJUUPUMZDFU
      MZCFUMZUNZBFUMUUGAUWBBFAWTFUEZUNZUVAUWAUWDIUUTUEIWRUUHUJZWRUKZJUUKUMZWRIU
      UMUJZWRUKZJUUPUMZUNZCFUMZUVASUWDUWKCFUWDWSFUEZUNZUWGUWJUWNUWFJUUKAUWCUWMW
      RUUKUEZUWFUTAUWCUWMUWOUWFTUPUQURUWNUWIJUUPAUWCUWMWRUUPUEZUWIUTAUWCUWMUWPU
      WIUAUPUQURVJVAUUSUWLKIUUTWQIUKZUURUWKCFUWQUULUWGUUQUWJUWQUUJUWFJUUKUWQUUI
      UWEWRWQIWRUUHVBVCVDUWQUUOUWIJUUPUWQUUNUWHWRWQIWRUUMVEVCVDVFVDVGVHUWDUVSCD
      FFUWDUWMYAFUEZUNUNZUVPJKUUPUVQUWSUWPWQUVQUEZUNZUVEUVOAUWCUWMUWRUXAUVEUTZA
      UWCUWMUWRUXBAUWCUWMUWRVKUXAUVEUBVIUPVLUWSUXAUVNEFUWDUWMUWRYHFUEZUXAUVNUTZ
      AUWCUWMUWRUXCUXDUTUTAUWCUWMUNZUNUWRUXCUXDAUXEUWRUXCUNZUXDAUXEUXFUNZUNZUXA
      UVNUXHUXAUNUVLLUVMUXHUWPUWTYFUVMUEZUVLUTUXHUWPUWTUXIUVLAUXGUWPUWTUXIVKUVL
      UCVMUPVNURWAVOVPVOVQVRWBVSVTVJVAAUWBUUFBFXPOAUVAXSUWAUUEAUUSXQKUUTXRAMXFW
      TWTPWCAUURXOCFXPOAUULXHUUQXNAUUJXEJUUKXGAMXFWSWTPWCAUUIXDWRAUUHXCWQWRAHXB
      XAWTQWCWCVCWDAUUOXLJUUPXMAMXFWTWSPWCZAUUNXKWRAUUMXJWRWQAHXBXIWSQWCWCVCWDV
      FWDWEAUVTUUDCFXPOAUVSUUCDFXPOAUVRUUBJUUPXMUXJAUVPYTKUVQUUAAMXFWSYAPWCAUVE
      YEUVOYSAUVCYCUVDYDAUVBYBWQWRAHXBXTYAQWCWCZAMXFWTYAPWCWFAUVNYREFXPOAUVLYPL
      UVMYQAMXFYAYHPWCAUVIYLUVKYOAUVGYJWRWRUVHYKAHXBXTYHQWCAUVFYIYFWQAHXBYGYHQW
      CWCAWRWGWHAYFYFUVCYCUVJYNAHXBYMYHQWCAYFWGUXKWHWIWDWDVFWDWDWDWDVFWDWJAGNUE
      WPUUGWKRBCDEXPGXBJKLXFNXPWLXFWLXBWLWMWNWO $.
  $}

  ${
    $d f g k w x y z B $.  $d f g k w x y z C $.  $d g ph $.  $d f g h x y X $.
    $d f g h k w x y z H $.  $d f g h k w x y z .x. $.
    catidex.b $e |- B = ( Base ` C ) $.
    catidex.h $e |- H = ( Hom ` C ) $.
    catidex.o $e |- .x. = ( comp ` C ) $.
    catidex.c $e |- ( ph -> C e. Cat ) $.
    catidex.x $e |- ( ph -> X e. B ) $.
    $( Each object in a category has an associated identity arrow.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    catidex $p |- ( ph -> E. g e. ( X H X ) A. y e. B
          ( A. f e. ( y H X ) ( g ( <. y , X >. .x. X ) f ) = f /\
            A. f e. ( X H y ) ( f ( <. X , X >. .x. y ) g ) = f ) ) $=
      ( vx cv cop co wceq wral vz vk vw wcel wa wrex ccat iscat ibi ralimi 3syl
      simpl id oveq12d oveq2 opeq2 oveqd eqeq1d raleqbidv oveq1 opeq12d anbi12d
      oveq1d ralbidv rexeqbidv rspcv sylc ) AICUDGPZFPZBPZOPZQZVKERZRZVISZFVJVK
      HRZTZVIVHVKVKQZVJERZRZVISZFVKVJHRZTZUEZBCTZGVKVKHRZUFZOCTZVHVIVJIQZIERZRZ
      VISZFVJIHRZTZVIVHIIQZVJERZRZVISZFIVJHRZTZUEZBCTZGIIHRZUFZNADUGUDZWGVHVIVK
      VJQZUAPZERRZVKXGHRUDUBPZVHVJXGQUCPZERRVIXFXJERRXIXHVKXGQXJERRSUBXGXJHRTUC
      CTUEGVJXGHRTFWBTUACTBCTZUEZOCTZWHMXEXMOBUAUCCDEFGUBHUGJKLUHUIXLWGOCWGXKUL
      UJUKWGXDOICVKISZWEXBGWFXCXNVKIVKIHXNUMZXOUNXNWDXABCXNVQWNWCWTXNVOWLFVPWMV
      KIVJHUOXNVNWKVIXNVMWJVHVIXNVLWIVKIEVKIVJUPXOUNUQURUSXNWAWRFWBWSVKIVJHUTXN
      VTWQVIXNVSWPVIVHXNVRWOVJEXNVKIVKIXOXOVAVCUQURUSVBVDVEVFVG $.

    $( Each object in a category has a unique identity arrow.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    catideu $p |- ( ph -> E! g e. ( X H X ) A. y e. B
          ( A. f e. ( y H X ) ( g ( <. y , X >. .x. X ) f ) = f /\
            A. f e. ( X H y ) ( f ( <. X , X >. .x. y ) g ) = f ) ) $=
      ( vh cv co wceq wral wa wrex wrmo wreu catidex wi wcel oveq1 opeq1 oveq1d
      cop oveqd eqeq1d raleqbidv oveq2 anbi12d rspcv syl ralrimivw id ad2ant2rl
      weq eqeq12d im2anan9r eqtr2 eqcomd syl56 rgen2a ralbidv rmo4 sylibr rmoim
      a1i sylc reu5 sylanbrc ) AGPZFPZBPZIUJZIEQZQZVQRZFVRIHQZSZVQVPIIUJZVREQZQ
      ZVQRZFIVRHQZSZTZBCSZGIIHQZUAWLGWMUBZWLGWMUCABCDEFGHIJKLMNUDAWLVPVQWEIEQZQ
      ZVQRZFWMSZVQVPWOQZVQRZFWMSZTZUEZGWMSXBGWMUBZWNAXCGWMAICUFXCNWKXBBICVRIRZW
      DWRWJXAXEWBWQFWCWMVRIIHUGXEWAWPVQXEVTWOVPVQXEVSWEIEVRIIUHUIUKULUMXEWHWTFW
      IWMVRIIHUNXEWGWSVQXEWFWOVQVPVRIWEEUNUKULUMUOUPUQURAXBOPZVQWOQZVQRZFWMSZVQ
      XFWOQZVQRZFWMSZTZTZGOVAZUEZOWMSGWMSZXDXQAXPGOWMXNWRXLTZVPWMUFZXFWMUFZTVPX
      FWOQZXFRZYAVPRZTZXOWRXLXRXAXIXRUSUTXTWRYBXSXLYCWQYBFXFWMFOVAZWPYAVQXFVQXF
      VPWOUNYEUSVBUPXKYCFVPWMFGVAZXJYAVQVPVQVPXFWOUGYFUSVBUPVCYDXFVPYAXFVPVDVEV
      FVGVLXBXMGOWMXOWRXIXAXLXOWQXHFWMXOWPXGVQVPXFVQWOUGULVHXOWTXKFWMXOWSXJVQVP
      XFVQWOUNULVHUOVIVJWLXBGWMVKVMWLGWMVNVO $.
  $}

  ${
    $d b c f g h o x y B $.  $d b c f g h o x y C $.  $d b c f g h o x y .x. $.
    $d b c f g h o x y H $.  $d f g x y ph $.  $d f g x y X $.
    cidfval.b $e |- B = ( Base ` C ) $.
    cidfval.h $e |- H = ( Hom ` C ) $.
    cidfval.o $e |- .x. = ( comp ` C ) $.
    cidfval.c $e |- ( ph -> C e. Cat ) $.
    cidfval.i $e |- .1. = ( Id ` C ) $.
    $( Each object in a category has an associated identity arrow.
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    cidfval $p |- ( ph -> .1. = ( x e. B |-> ( iota_ g e. ( x H x ) A. y e. B
      ( A. f e. ( y H x ) ( g ( <. y , x >. .x. x ) f ) = f /\
        A. f e. ( x H y ) ( f ( <. x , x >. .x. y ) g ) = f ) ) ) ) $=
      ( cfv cv co wceq cvv vc vb vh vo ccid cop wral wa crio cmpt ccat wcel cbs
      chom cco csb fveq2 syl6eqr simpl fveq2d simpll simpllr simplr oveqd simpr
      a1i eqeq1d raleqbidv anbi12d riotaeqbidv mpteq12dv csbied2 df-cid eqeltri
      fvex mptex fvmpt syl syl5eq ) AGEUEPZBDIQZHQZCQZBQZUFZWDFRZRZWBSZHWCWDJRZ
      UGZWBWAWDWDUFZWCFRZRZWBSZHWDWCJRZUGZUHZCDUGZIWDWDJRZUIZUJZOAEUKULVTXASNUA
      EUBUAQZUMPZUCXBUNPZUDXBUOPZBUBQZWAWBWEWDUDQZRZRZWBSZHWCWDUCQZRZUGZWBWAWKW
      CXGRZRZWBSZHWDWCXKRZUGZUHZCXFUGZIWDWDXKRZUIZUJZUPZUPZUPXAUKUEXBESZUBXCDYE
      XATXCTULYFXBUMVOVFYFXCEUMPZDXBEUMUQKURYFXFDSZUHZUCXDJYDXATXDTULYIXBUNVOVF
      YIXDEUNPJYIXBEUNYFYHUSUTLURYIXKJSZUHZUDXEFYCXATXETULYKXBUOVOVFYKXEEUOPFYK
      XBEUOYFYHYJVAUTMURYKXGFSZUHZBXFYBDWTYFYHYJYLVBZYMXTWRIYAWSYMXKJWDWDYIYJYL
      VCZVDYMXSWQCXFDYNYMXMWJXRWPYMXJWHHXLWIYMXKJWCWDYOVDYMXIWGWBYMXHWFWAWBYMXG
      FWEWDYKYLVEZVDVDVGVHYMXPWNHXQWOYMXKJWDWCYOVDYMXOWMWBYMXNWLWBWAYMXGFWKWCYP
      VDVDVGVHVIVHVJVKVLVLVLBCHIUCUDUBUAVMBDWTDYGTKEUMVOVNVPVQVRVS $.

    cidval.x $e |- ( ph -> X e. B ) $.
    $( Each object in a category has an associated identity arrow.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    cidval $p |- ( ph -> ( .1. ` X ) = ( iota_ g e. ( X H X ) A. y e. B
      ( A. f e. ( y H X ) ( g ( <. y , X >. .x. X ) f ) = f /\
        A. f e. ( X H y ) ( f ( <. X , X >. .x. y ) g ) = f ) ) ) $=
      ( cv co wceq wral vx cop wa cvv cidfval simpr oveq12d oveq2d opeq2d oveqd
      crio eqeq1d raleqbidv oveq1d opeq12d anbi12d ralbidv riotaeqbidv wcel a1i
      riotaex fvmptd ) AUAJHQZGQZBQZUAQZUBZVFERZRZVDSZGVEVFIRZTZVDVCVFVFUBZVEER
      ZRZVDSZGVFVEIRZTZUCZBCTZHVFVFIRZUKVCVDVEJUBZJERZRZVDSZGVEJIRZTZVDVCJJUBZV
      EERZRZVDSZGJVEIRZTZUCZBCTZHJJIRZUKZCFUDAUABCDEFGHIKLMNOUEAVFJSZUCZVTWOHWA
      WPWSVFJVFJIAWRUFZWTUGWSVSWNBCWSVLWGVRWMWSVJWEGVKWFWSVFJVEIWTUHWSVIWDVDWSV
      HWCVCVDWSVGWBVFJEWSVFJVEWTUIWTUGUJULUMWSVPWKGVQWLWSVFJVEIWTUNWSVOWJVDWSVN
      WIVDVCWSVMWHVEEWSVFJVFJWTWTUOUNUJULUMUPUQURPWQUDUSAWOHWPVAUTVB $.
  $}

  ${
    $d b c f g h o x y B $.  $d b c f g h o x y C $.  $d b c f g h o x y .x. $.
    $d b c f g h o x y H $.  $d f g x y ph $.  $d f g x y X $.
    $( The identity arrow construction is a function on categories.
       (Contributed by Mario Carneiro, 17-Jan-2017.) $)
    cidffn $p |- Id Fn Cat $=
      ( vc vb vh vo vx vg vf vy ccat cv cbs cfv chom cco cop co wceq wral csbex
      csb wa crio cmpt ccid vex mptex df-cid fnmpti ) AIBAJZKLZCUIMLZDUINLZEBJZ
      FJZGJZHJZEJZOUQDJZPPUOQGUPUQCJZPRUOUNUQUQOUPURPPUOQGUQUPUSPRUAHUMRFUQUQUS
      PUBZUCZTZTZTUDBUJVCCUKVBDULVAEUMUTBUEUFSSSEHGFCDBAUGUH $.

    cidfn.b $e |- B = ( Base ` C ) $.
    cidfn.i $e |- .1. = ( Id ` C ) $.
    $( The identity arrow operator is a function from objects to arrows.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    cidfn $p |- ( C e. Cat -> .1. Fn B ) $=
      ( vx vg vf vy ccat wcel wfn cv cop cco cfv co wceq wral eqid chom wa crio
      cmpt riotaex fnmpti id cidfval fneq1d mpbiri ) BJKZCALFAGMZHMZIMZFMZNUOBO
      PZQQUMRHUNUOBUAPZQSUMULUOUONUNUPQQUMRHUOUNUQQSUBIASZGUOUOUQQZUCZUDZALFAUT
      VAURGUSUEVATUFUKACVAUKFIABUPCHGUQDUQTUPTUKUGEUHUIUJ $.
  $}

  ${
    $d f g y .1. $.  $d x B $.  $d f g x y C $.  $d f g x y ph $.
    catidd.b $e |- ( ph -> B = ( Base ` C ) ) $.
    catidd.h $e |- ( ph -> H = ( Hom ` C ) ) $.
    catidd.o $e |- ( ph -> .x. = ( comp ` C ) ) $.
    catidd.c $e |- ( ph -> C e. Cat ) $.
    catidd.1 $e |- ( ( ph /\ x e. B ) -> .1. e. ( x H x ) ) $.
    catidd.2 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ f e. ( y H x ) ) ) ->
      ( .1. ( <. y , x >. .x. x ) f ) = f ) $.
    catidd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ f e. ( x H y ) ) ) ->
      ( f ( <. x , x >. .x. y ) .1. ) = f ) $.
    $( Deduce the identity arrow in a category.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    catidd $p |- ( ph -> ( Id ` C ) = ( x e. B |-> .1. ) ) $=
      ( co wceq wcel oveqd vg cbs cfv cv cop cco chom wral wa crio cmpt ccid ex
      w3a eleq2d 3anbi123d eqeq1d 3imtr3d 3expd imp41 ralrimiva jca wreu wb imp
      eqid ccat adantr simpr catideu oveq1 ralbidv oveq2 anbi12d riota2 syl2anc
      mpbid mpteq2dva cidfval mpteq1d 3eqtr4d ) ABEUBUCZUAUDZHUDZCUDZBUDZUEZWFE
      UFUCZQZQZWDRZHWEWFEUGUCZQZUHZWDWCWFWFUEZWEWHQZQZWDRZHWFWEWLQZUHZUIZCWBUHZ
      UAWFWFWLQZUJZUKBWBGUKEULUCZBDGUKABWBXDGAWFWBSZUIZGWDWIQZWDRZHWMUHZWDGWPQZ
      WDRZHWSUHZUIZCWBUHZXDGRZXGXNCWBXGWEWBSZUIZXJXMXRXIHWMAXFXQWDWMSZXIAXFXQXS
      XIAWFDSZWEDSZWDWEWFIQZSZUNZGWDWGWFFQZQZWDRZXFXQXSUNXIAYDYGOUMAXTXFYAXQYCX
      SADWBWFJUOZADWBWEJUOZAYBWMWDAIWLWEWFKTUOUPAYFXHWDAYEWIGWDAFWHWGWFLTTUQURU
      SUTVAXRXLHWSAXFXQWDWSSZXLAXFXQYJXLAXTYAWDWFWEIQZSZUNZWDGWOWEFQZQZWDRZXFXQ
      YJUNXLAYMYPPUMAXTXFYAXQYLYJYHYIAYKWSWDAIWLWFWEKTUOUPAYOXKWDAYNWPWDGAFWHWO
      WELTTUQURUSUTVAVBVAXGGXCSZXBUAXCVCXOXPVDAXFYQAXTGWFWFIQZSZXFYQAXTYSNUMYHA
      YRXCGAIWLWFWFKTUOURVEXGCWBEWHHUAWLWFWBVFZWLVFZWHVFZAEVGSXFMVHAXFVIVJXBXOU
      AXCGWCGRZXAXNCWBUUCWNXJWTXMUUCWKXIHWMUUCWJXHWDWCGWDWIVKUQVLUUCWRXLHWSUUCW
      QXKWDWCGWDWPVMUQVLVNVLVOVPVQVRABCWBEWHXEHUAWLYTUUAUUBMXEVFVSABDWBGJVTWA
      $.
  $}

  ${
    $d a f g k r w x z .1. $.  $d a f g k r w x y z B $.  $d a g k r w y z C $.
    $d f g k r w x y z H $.  $d a f g k r w x y z ph $.
    $d f g k w x y z .x. $.
    iscatd2.b $e |- ( ph -> B = ( Base ` C ) ) $.
    iscatd2.h $e |- ( ph -> H = ( Hom ` C ) ) $.
    iscatd2.o $e |- ( ph -> .x. = ( comp ` C ) ) $.
    iscatd2.c $e |- ( ph -> C e. V ) $.
    iscatd2.ps $e |- ( ps <-> ( ( x e. B /\ y e. B ) /\ ( z e. B /\ w e. B )
      /\ ( f e. ( x H y ) /\ g e. ( y H z ) /\ k e. ( z H w ) ) ) ) $.
    iscatd2.1 $e |- ( ( ph /\ y e. B ) -> .1. e. ( y H y ) ) $.
    iscatd2.2 $e |- ( ( ph /\ ps ) -> ( .1. ( <. x , y >. .x. y ) f ) = f ) $.
    iscatd2.3 $e |- ( ( ph /\ ps ) -> ( g ( <. y , y >. .x. z ) .1. ) = g ) $.
    iscatd2.4 $e |- ( ( ph /\ ps ) ->
       ( g ( <. x , y >. .x. z ) f ) e. ( x H z ) ) $.
    iscatd2.5 $e |- ( ( ph /\ ps ) ->
       ( ( k ( <. y , z >. .x. w ) g ) ( <. x , y >. .x. w ) f ) =
         ( k ( <. x , z >. .x. w ) ( g ( <. x , y >. .x. z ) f ) ) ) $.
    $( Version of ~ iscatd2 with a uniform assumption list, for increased proof
       sharing capabilities.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    iscatd2 $p |- ( ph -> ( C e. Cat /\ ( Id ` C ) = ( y e. B |-> .1. ) ) ) $=
      ( va vr ccat wcel ccid cfv cmpt wceq cv co w3a wa wex cop c0 wne ne0i syl
      3ad2antr1 n0 sylib eeanv simpll simplr2 simplr1 jca simplr3 simprl simprr
      3jca wsb simplll eleq1d anbi1d simpllr simplr anbi12d anidm syl6bb oveq1d
      simpr eleq12d oveq2d eleq2d 3anbi123d syl5bb anbi2d opeq1d eqidd oveq123d
      wi oveq12d eqeq12d imbi12d sbiedv sbt chvarv syl13anc ex exlimdvv syl5bir
      mp2and wral simpr2 ralrimiva adantr id neeq1d rspcv sylc 3ad2ant1 rspccva
      simp23 syl2anc eleq1 3anbi1d oveq1 opeq1 oveqd df-3an bitri syl6bbr exp45
      opeq2d 3imp exlimdv 3anbi23d simpl 3anbi12d 3anbi13d 3anass iscatd catidd
      mpd ) AHUHUIHUJUKDGJULUMADUFEFGHIJUGLMNOPQRSUAADUNZGUIZUFUNZGUIZUGUNZUUBY
      TNUOZUIZUPZUQZLUNZYTYTNUOZUIZLURZMUNZUUJUIZMURZJUUDUUBYTUSZYTIUOZUOZUUDUM
      ZUUHUUJUTVAZUULAUUCUUAUUTUUFAUUAUQJUUJUIUUTUAUUJJVBVCZVDZLUUJVEVFUUHUUTUU
      OUVBMUUJVEVFUULUUOUQUUKUUNUQZMURLURUUHUUSUUKUUNLMVGUUHUVCUUSLMUUHUVCUUSUU
      HUVCUQZAUUCUUAUQZUUAUUFUUKUUNUPZUUSAUUGUVCVHUVDUUCUUAUUAUUCUUFAUVCVIUUAUU
      CUUFAUVCVJZVKUVGUVDUUFUUKUUNUUAUUCUUFAUVCVLUUHUUKUUNVMUUHUUKUUNVNVOABUQZJ
      KUNZCUNZYTUSZYTIUOZUOZUVIUMZWPZKUGVPZFDVPZEDVPAUVEUUAUVFUPZUQZUUSWPZCUFUV
      JUUBUMZUVQUVTEDUWAEUNZYTUMZUQZUVPUVTFDUWDFUNZYTUMZUQZUVOUVTKUGUWGUVIUUDUM
      ZUQZUVHUVSUVNUUSUWIBUVRABUVJGUIZUUAUQZUWBGUIZUWEGUIZUQZUVIUVJYTNUOZUIZUUI
      YTUWBNUOZUIZUUMUWBUWENUOZUIZUPZUPZUWIUVRTUWIUWKUVEUWNUUAUXAUVFUWIUWJUUCUU
      AUWIUVJUUBGUWAUWCUWFUWHVQZVRVSUWIUWNUUAUUAUQZUUAUWIUWLUUAUWMUUAUWIUWBYTGU
      WAUWCUWFUWHVTZVRUWIUWEYTGUWDUWFUWHWAZVRWBUUAWCZWDUWIUWPUUFUWRUUKUWTUUNUWI
      UVIUUDUWOUUEUWGUWHWFZUWIUVJUUBYTNUXCWEWGUWIUWQUUJUUIUWIUWBYTYTNUXEWHWIUWI
      UWSUUJUUMUWIUWBYTUWEYTNUXEUXFWQWIWJWJWKWLUWIUVMUURUVIUUDUWIJJUVIUUDUVLUUQ
      UWIUVKUUPYTIUWIUVJUUBYTUXCWMWEUWIJWNUXHWOUXHWRWSWTWTWTUVQEDUVPFDUVOKUGUBX
      AXAXAXBXCXDXEXFXGZAUUAUUCUUDYTUUBNUOZUIZUPZUQZUVIUUJUIZKURZUUMUUBUUBNUOZU
      IZMURZUUDJYTYTUSZUUBIUOZUOZUUDUMZUXMUUTUXOAUUCUUAUUTUXKUVAVDKUUJVEVFUXMUX
      PUTVAZUXRUXMUUCUUTDGXHZUYCAUUAUUCUXKXIAUYDUXLAUUTDGUVAXJZXKUUTUYCDUUBGYTU
      UBUMZUUJUXPUTUYFYTUUBYTUUBNUYFXLZUYGWQXMXNXOMUXPVEVFUXOUXRUQUXNUXQUQZMURK
      URUXMUYBUXNUXQKMVGUXMUYHUYBKMUXMUYHUYBUXMUYHUQZAUUAUUCUXNUXKUXQUPZUYBAUXL
      UYHVHUUAUUCUXKAUYHVJUUAUUCUXKAUYHVIUYIUXNUXKUXQUXMUXNUXQVMUUAUUCUXKAUYHVL
      UXMUXNUXQVNVOUVHUUIJUXSUWBIUOZUOZUUIUMZWPZLUGVPZFUFVPZEUFVPAUUAUUCUYJUPZU
      QZUYBWPZCDUVJYTUMZUYPUYSEUFUYTUWBUUBUMZUQZUYOUYSFUFVUBUWEUUBUMZUQZUYNUYSL
      UGVUDUUIUUDUMZUQZUVHUYRUYMUYBVUFBUYQABUXBVUFUYQTVUFUWKUUAUWNUUCUXAUYJVUFU
      WKUXDUUAVUFUWJUUAUUAVUFUVJYTGUYTVUAVUCVUEVQZVRVSUXGWDVUFUWNUUCUUCUQUUCVUF
      UWLUUCUWMUUCVUFUWBUUBGUYTVUAVUCVUEVTZVRVUFUWEUUBGVUBVUCVUEWAZVRWBUUCWCWDV
      UFUWPUXNUWRUXKUWTUXQVUFUWOUUJUVIVUFUVJYTYTNVUGWEWIVUFUUIUUDUWQUXJVUDVUEWF
      ZVUFUWBUUBYTNVUHWHWGVUFUWSUXPUUMVUFUWBUUBUWEUUBNVUHVUIWQWIWJWJWKWLVUFUYLU
      YAUUIUUDVUFUUIUUDJJUYKUXTVUFUWBUUBUXSIVUHWHVUJVUFJWNWOVUJWRWSWTWTWTUYPEUF
      UYOFUFUYNLUGUCXAXAXAXBXCXDXEXFXGZAUUAUUCUWLUPZUXKUUIUUBUWBNUOZUIZUQZUPZUU
      MUWBUWBNUOZUIZMURZUUIUUDYTUUBUSZUWBIUOZUOZUWQUIZVUPVUQUTVAZVUSVUPUYDUWLVV
      DAVULUYDVUOUYEXPAUUAUUCUWLVUOXRUUTVVDDUWBGYTUWBUMZUUJVUQUTVVEYTUWBYTUWBNV
      VEXLZVVFWQXMXQXSMVUQVEVFVUPVURVVCMAVULVUOVURVVCWPAVULVUOVURVVCAUWJUUCUWLU
      PZUUDUVJUUBNUOZUIZVUNUQZVURUQZUQZUQZUUIUUDUVJUUBUSZUWBIUOZUOZUVJUWBNUOZUI
      ZWPZAVULVUOVURUQZUQZUQZVVCWPCDUYTVVMVWBVVRVVCUYTVVLVWAAUYTVVGVULVVKVVTUYT
      UWJUUAUUCUWLUVJYTGXTZYAUYTVVJVUOVURUYTVVIUXKVUNUYTVVHUXJUUDUVJYTUUBNYBWIZ
      VSVSWBWLUYTVVPVVBVVQUWQUYTVVOVVAUUIUUDUYTVVNVUTUWBIUVJYTUUBYCZWEYDZUVJYTU
      WBNYBWGWSUVHUUIUVIUVKUWBIUOZUOZVVQUIZWPZKUGVPZFEVPVVSDUFUYFVWKVVSFEUYFUWE
      UWBUMZUQZVWJVVSKUGVWMUWHUQZUVHVVMVWIVVRVWNBVVLABUWKUWNUQZUXAUQZVWNVVLBUXB
      VWPTUWKUWNUXAYEYFVWNVWOVVGUXAVVKVWNVWOUWJUUCUQZUWLUQVVGVWNUWKVWQUWNUWLVWN
      UUAUUCUWJVWNYTUUBGUYFVWLUWHVHZVRWLVWNUWNUWLUWLUQUWLVWNUWMUWLUWLVWNUWEUWBG
      UYFVWLUWHWAZVRWLUWLWCWDWBUWJUUCUWLYEYGVWNUXAVVIVUNVURUPVVKVWNUWPVVIUWRVUN
      UWTVURVWNUVIUUDUWOVVHVWMUWHWFZVWNYTUUBUVJNVWRWHWGVWNUWQVUMUUIVWNYTUUBUWBN
      VWRWEWIVWNUWSVUQUUMVWNUWEUWBUWBNVWSWHWIWJVVIVUNVURYEWDWBWKWLVWNVWHVVPVVQV
      WNUUIUUIUVIUUDVWGVVOVWNUVKVVNUWBIVWNYTUUBUVJVWRYIWEVWNUUIWNVWTWOVRWSWTWTV
      WKFEVWJKUGUDXAXAXBXBYHYJYKYSAVWQUWNUQZVVIVUNUWTUPZUPZUUMUUIUUBUWBUSZUWEIU
      OZUOZUUDVVNUWEIUOZUOZUUMVVPUVJUWBUSZUWEIUOZUOZUMZWPZAUUAUUCUQZUWNUQZUXKVU
      NUWTUPZUPZVXFUUDVUTUWEIUOZUOZUUMVVBYTUWBUSZUWEIUOZUOZUMZWPCDUYTVXCVXQVXLV
      YCUYTVXAVXOVXBVXPAUYTVWQVXNUWNUYTUWJUUAUUCVWCVSVSUYTVVIUXKVUNUWTVWDYAYLUY
      TVXHVXSVXKVYBUYTVXGVXRVXFUUDUYTVVNVUTUWEIVWEWEYDUYTUUMUUMVVPVVBVXJVYAUYTV
      XIVXTUWEIUVJYTUWBYCWEUYTUUMWNVWFWOWRWSUVHUUMUUIVYAUOZUVIUVKUWEIUOZUOZUUMV
      WHVXJUOZUMZWPZKUGVPVXMDUFUYFVYIVXMKUGUYFUWHUQZUVHVXCVYHVXLVYJUVHAVXAVXBUQ
      ZUQVXCVYJBVYKAVYJBVWQUWNVXBUPZVYKBUXBVYJVYLTVYJUWKVWQUXAVXBUWNVYJUUAUUCUW
      JVYJYTUUBGUYFUWHYMZVRWLVYJUWPVVIUWRVUNUWTVYJUVIUUDUWOVVHUYFUWHWFZVYJYTUUB
      UVJNVYMWHWGVYJUWQVUMUUIVYJYTUUBUWBNVYMWEWIYNYOWKVWQUWNVXBYEWDWLAVXAVXBYPY
      GVYJVYFVXHVYGVXKVYJVYDVXFUVIUUDVYEVXGVYJUVKVVNUWEIVYJYTUUBUVJVYMYIZWEVYJV
      YAVXEUUMUUIVYJVXTVXDUWEIVYJYTUUBUWBVYMWMWEYDVYNWOVYJVWHVVPUUMVXJVYJUUIUUI
      UVIUUDVWGVVOVYJUVKVVNUWBIVYOWEVYJUUIWNVYNWOWHWRWSWTVYIKUGUEXAXBXBYQZADUFG
      HIJUGNPQRVYPUAUXIVUKYRVK $.
  $}

  ${
    $d f g x y .1. $.  $d f g x y B $.  $d f g x y ph $.  $d f g x y .x. $.
    $d f g x y C $.  $d f g x y H $.  $d f g x y X $.  $d f g x y Y $.
    $d f F $.
    catidcl.b $e |- B = ( Base ` C ) $.
    catidcl.h $e |- H = ( Hom ` C ) $.
    catidcl.i $e |- .1. = ( Id ` C ) $.
    catidcl.c $e |- ( ph -> C e. Cat ) $.
    catidcl.x $e |- ( ph -> X e. B ) $.
    $( Each object in a category has an associated identity arrow.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    catidcl $p |- ( ph -> ( .1. ` X ) e. ( X H X ) ) $=
      ( vg vf vy cfv cv cop co wceq wral cco crio eqid cidval wreu wcel catideu
      wa riotacl syl eqeltrd ) AFDOLPZMPZNPZFQFCUAOZRRUMSMUNFERTUMULFFQUNUORRUM
      SMFUNERTUHNBTZLFFERZUBZUQANBCUODMLEFGHUOUCZJIKUDAUPLUQUEURUQUFANBCUOMLEFG
      HUSJKUGUPLUQUIUJUK $.

    catlid.o $e |- .x. = ( comp ` C ) $.
    catlid.y $e |- ( ph -> Y e. B ) $.
    catlid.f $e |- ( ph -> F e. ( X H Y ) ) $.
    $( Left identity property of an identity arrow.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    catlid $p |- ( ph -> ( ( .1. ` Y ) ( <. X , Y >. .x. Y ) F ) = F ) $=
      ( vf vg co vx wcel cfv cv cop wceq wral crab wa simpl ralimi ss2rabi crio
      a1i cidval wreu catideu riotacl2 syl eqeltrd sseldi oveq1 eqeq1d 2ralbidv
      wi elrab simprbi opeq1 oveq1d oveqd raleqbidv rspcv sylc oveq2 id eqeq12d
      ) AFHIGTZUBIEUCZRUDZHIUEZIDTZTZVSUFZRVQUGZVRFWATZFUFZQAHBUBVRVSUAUDZIUEZI
      DTZTZVSUFZRWGIGTZUGZUABUGZWDNAVRSUDZVSWITZVSUFZRWLUGZUABUGZSIIGTZUHZUBZWN
      AWRVSWOIIUEWGDTTVSUFRIWGGTUGZUIZUABUGZSWTUHZXAVRXEWSSWTXEWSVEWOWTUBXDWRUA
      BWRXCUJUKUNULAVRXESWTUMZXFAUABCDERSGIJKOMLPUOAXESWTUPXGXFUBAUABCDRSGIJKOM
      PUQXESWTURUSUTVAXBVRWTUBWNWSWNSVRWTWOVRUFZWQWKUARBWLXHWPWJVSWOVRVSWIVBVCV
      DVFVGUSWMWDUAHBWGHUFZWKWCRWLVQWGHIGVBXIWJWBVSXIWIWAVRVSXIWHVTIDWGHIVHVIVJ
      VCVKVLVMWCWFRFVQVSFUFZWBWEVSFVSFVRWAVNXJVOVPVLVM $.

    $( Right identity property of an identity arrow.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    catrid $p |- ( ph -> ( F ( <. X , X >. .x. Y ) ( .1. ` X ) ) = F ) $=
      ( vf vg co vy wcel cv cfv cop wceq wral crab wa simpr ralimi ss2rabi crio
      a1i cidval wreu catideu riotacl2 syl eqeltrd sseldi oveq2 eqeq1d 2ralbidv
      wi elrab simprbi oveqd raleqbidv rspcv sylc oveq1 id eqeq12d ) AFHIGTZUBR
      UCZHEUDZHHUEZIDTZTZVPUFZRVOUGZFVQVSTZFUFZQAIBUBVPVQVRUAUCZDTZTZVPUFZRHWEG
      TZUGZUABUGZWBPAVQVPSUCZWFTZVPUFZRWIUGZUABUGZSHHGTZUHZUBZWKAWLVPWEHUEHDTTV
      PUFRWEHGTUGZWOUIZUABUGZSWQUHZWRVQXBWPSWQXBWPVEWLWQUBXAWOUABWTWOUJUKUNULAV
      QXBSWQUMZXCAUABCDERSGHJKOMLNUOAXBSWQUPXDXCUBAUABCDRSGHJKOMNUQXBSWQURUSUTV
      AWSVQWQUBWKWPWKSVQWQWLVQUFZWNWHUARBWIXEWMWGVPWLVQVPWFVBVCVDVFVGUSWJWBUAIB
      WEIUFZWHWARWIVOWEIHGVBXFWGVTVPXFWFVSVPVQWEIVRDVBVHVCVIVJVKWAWDRFVOVPFUFZV
      TWCVPFVPFVQVSVLXGVMVNVJVK $.
  $}

  ${
    $d f g k v w x y z B $.  $d f g k v w x y z C $.  $d f g k v w x y z .x. $.
    $d f g k w x y z F $.  $d f g k v w x y z H $.  $d f g k w x y z ph $.
    $d f g k w x y z G $.  $d f g k w x y z K $.  $d f g k w x y z W $.
    $d f g k w x y z X $.  $d f g k w x y z Y $.  $d f g k w x y z Z $.
    catcocl.b $e |- B = ( Base ` C ) $.
    catcocl.h $e |- H = ( Hom ` C ) $.
    catcocl.o $e |- .x. = ( comp ` C ) $.
    catcocl.c $e |- ( ph -> C e. Cat ) $.
    catcocl.x $e |- ( ph -> X e. B ) $.
    catcocl.y $e |- ( ph -> Y e. B ) $.
    catcocl.z $e |- ( ph -> Z e. B ) $.
    catcocl.f $e |- ( ph -> F e. ( X H Y ) ) $.
    catcocl.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    $( Closure of a composition arrow.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    catcocl $p |- ( ph -> ( G ( <. X , Y >. .x. Z ) F ) e. ( X H Z ) ) $=
      ( co vg vf vx vy vz vv vw cv cop wcel wral ccat wceq wrex iscat ibi simpl
      ralimi adantl 3syl adantr ad2antrr ad3antrrr simpllr simplr oveq12d simpr
      wa eleqtrrd simp-5r simp-4r opeq12d oveq123d eleq12d rspcdv rspcimdv mpd
      ) AUAUHZUBUHZUCUHZUDUHZUIZUEUHZDTZTZVTWCGTZUJZUAWAWCGTZUKZUBVTWAGTZUKZUEB
      UKZUDBUKZUCBUKZFEHIUIZJDTZTZHJGTZUJZACULUJZVRVSWAVTUIVTDTTVSUMUBWAVTGTUKV
      SVRVTVTUIWADTTVSUMUBWJUKVHUDBUKUAVTVTGTUNZWGUFUHZVRWAWCUIUGUHZDTTVSWBXCDT
      TXBWEVTWCUIXCDTTUMUFWCXCGTUKUGBUKZVHZUAWHUKZUBWJUKZUEBUKZUDBUKZVHZUCBUKZW
      NNWTXKUCUDUEUGBCDUBUAUFGULKLMUOUPXJWMUCBXIWMXAXHWLUDBXGWKUEBXFWIUBWJXEWGU
      AWHWGXDUQURURURURUSURUTAWMWSUCHBOAVTHUMZVHZWLWSUDIBAIBUJXLPVAXMWAIUMZVHZW
      KWSUEJBAJBUJXLXNQVBXOWCJUMZVHZWIWSUBEWJXQEHIGTZWJAEXRUJXLXNXPRVCXQVTHWAIG
      AXLXNXPVDXMXNXPVEZVFVIXQVSEUMZVHZWGWSUAFWHXQFWHUJXTXQFIJGTZWHAFYBUJXLXNXP
      SVCXQWAIWCJGXSXOXPVGVFVIVAYAVRFUMZVHZWEWQWFWRYDVRFVSEWDWPYDWBWOWCJDYDVTHW
      AIAXLXNXPXTYCVJZXMXNXPXTYCVKVLXOXPXTYCVDZVFYAYCVGXQXTYCVEVMYDVTHWCJGYEYFV
      FVNVOVPVPVPVPVQ $.

    catass.w $e |- ( ph -> W e. B ) $.
    catass.g $e |- ( ph -> K e. ( Z H W ) ) $.
    $( Associativity of composition in a category.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    catass $p |- ( ph ->
       ( ( K ( <. Y , Z >. .x. W ) G ) ( <. X , Y >. .x. W ) F ) =
         ( K ( <. X , Z >. .x. W ) ( G ( <. X , Y >. .x. Z ) F ) ) ) $=
      ( vg vf vy vx vz vk vw cv cop co wceq wral wa wrex wcel ccat iscat adantr
      ibi syl ad2antrr ad3antrrr simpllr simplr oveq12d ad4antr ad5antr ad6antr
      eleqtrrd simp-4r simp-7r simp-6r opeq12d simp-5r oveq123d rspcdv rspcimdv
      simpr eqeq12d adantld mpd ) AUDUKZUEUKZUFUKZUGUKZULWHDUMUMWFUNUEWGWHGUMUO
      WFWEWHWHULWGDUMUMWFUNUEWHWGGUMZUOUPUFBUOUDWHWHGUMUQZWEWFWHWGULZUHUKZDUMZU
      MZWHWLGUMURZUIUKZWEWGWLULZUJUKZDUMZUMZWFWKWRDUMZUMZWPWNWHWLULZWRDUMZUMZUN
      ZUIWLWRGUMZUOZUJBUOZUPZUDWGWLGUMZUOZUEWIUOZUHBUOZUFBUOZUPZUGBUOZHFKLULZID
      UMZUMZEJKULZIDUMZUMZHFEYALDUMZUMZJLULZIDUMZUMZUNZACUSURZXQPYJXQUGUFUHUJBC
      DUEUDUIGUSMNOUTVBVCAXPYIUGJBQAWHJUNZUPZXOYIWJYLXNYIUFKBAKBURYKRVAYLWGKUNZ
      UPZXMYIUHLBALBURYKYMSVDYNWLLUNZUPZXLYIUEEWIYPEJKGUMZWIAEYQURYKYMYOTVEYPWH
      JWGKGAYKYMYOVFYLYMYOVGVHVLYPWFEUNZUPZXJYIUDFXKYSFKLGUMZXKAFYTURYKYMYOYRUA
      VIYSWGKWLLGYLYMYOYRVFYNYOYRVGVHVLYSWEFUNZUPZXIYIWOUUBXHYIUJIBAIBURYKYMYOY
      RUUAUBVJUUBWRIUNZUPZXFYIUIHXGUUDHLIGUMZXGAHUUEURYKYMYOYRUUAUUCUCVKUUDWLLW
      RIGYNYOYRUUAUUCVMUUBUUCWAVHVLUUDWPHUNZUPZXBYCXEYHUUGWTXTWFEXAYBUUGWKYAWRI
      DUUGWHJWGKAYKYMYOYRUUAUUCUUFVNZYLYMYOYRUUAUUCUUFVOZVPZUUBUUCUUFVGZVHUUGWP
      HWEFWSXSUUGWQXRWRIDUUGWGKWLLUUIYNYOYRUUAUUCUUFVQZVPUUKVHUUDUUFWAZYSUUAUUC
      UUFVFZVRYPYRUUAUUCUUFVMZVRUUGWPHWNYEXDYGUUGXCYFWRIDUUGWHJWLLUUHUULVPUUKVH
      UUMUUGWEFWFEWMYDUUGWKYAWLLDUUJUULVHUUNUUOVRVRWBVSVTWCVTVTVTVTWCVTWD $.
  $}

  ${
    $d f g h w x y z C $.  $d f g h w x y z V $.
    $( Any structure with an empty set of objects is a category.  (Contributed
       by Mario Carneiro, 3-Jan-2017.) $)
    0catg $p |- ( ( C e. V /\ (/) = ( Base ` C ) ) -> C e. Cat ) $=
      ( vx vy vz vw vf vg vh wcel c0 cfv wceq wa cv co pm2.21i w3a cop syl chom
      cbs cco simpr eqidd simpl noel adantl simpr1 simp21 simp2ll iscatd ) ABJZ
      KAUBLMZNZCDEFKAAUCLZKGHIAUALZBUMUNUDUOUQUEUOUPUEUMUNUFCOZKJZKURURUQPJZUOU
      SUTURUGZQUHUOUSDOZKJZGOZVBURUQPJZRNUSKVDVBURSURUPPPVDMZUOUSVCVEUIUSVFVAQT
      UOUSVCVDURVBUQPJZRNUSVDKURURSVBUPPPVDMZUOUSVCVGUIUSVHVAQTUOUSVCEOZKJZRVGH
      OZVBVIUQPJZNZRUSVKVDURVBSZVIUPPPZURVIUQPJZUOUSVCVJVMUJUSVPVAQTUOUSVCNVJFO
      ZKJNZNVGVLIOZVIVQUQPJRZRUSVSVKVBVISVQUPPPVDVNVQUPPPVSVOURVISVQUPPPMZUSVCV
      RUOVTUKUSWAVAQTUL $.
  $}

  $( The empty set is a category.  (Contributed by Mario Carneiro,
     3-Jan-2017.) $)
  0cat $p |- (/) e. Cat $=
    ( c0 cvv wcel cbs cfv wceq ccat 0ex base0 0catg mp2an ) ABCAADEFAGCHIABJK
    $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y F $.  $d x y ph $.  $d y Y $.
    $d x y G $.  $d x y X $.
    $( Lemma for ~ mndpropd .  (Contributed by Mario Carneiro, 6-Dec-2014.) $)
    proplem2 $p |- ( ( ( X e. A /\ Y e. B ) /\
      A. x e. A A. y e. B ( x F y ) e. C ) -> ( X F Y ) e. C ) $=
      ( cv co wcel wceq oveq1 eleq1d oveq2 rspc2va ) AIZBIZFJZEKGHFJZEKGRFJZEKA
      BGHCDQGLSUAEQGRFMNRHLUATERHGFONP $.

    proplem.1 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) ->
                         ( x F y ) = ( x G y ) ) $.
    $( Lemma for ~ mndpropd .  (Contributed by Mario Carneiro, 6-Dec-2014.) $)
    proplem $p |- ( ( ph /\ ( X e. A /\ Y e. B ) ) ->
                         ( X F Y ) = ( X G Y ) ) $=
      ( cv co wceq wral wcel wa ralrimivva oveq1 eqeq12d oveq2 rspc2v mpan9 ) A
      BKZCKZFLZUCUDGLZMZCENBDNHDOIEOPHIFLZHIGLZMZAUGBCDEJQUGUJHUDFLZHUDGLZMBCHI
      DEUCHMUEUKUFULUCHUDFRUCHUDGRSUDIMUKUHULUIUDIHFTUDIHGTSUAUB $.
  $}

  ${
    proplem3.1 $e |- ( ph -> F = G ) $.
    $( Lemma for property theorems.  (Contributed by Mario Carneiro,
       29-Jun-2015.) $)
    proplem3 $p |- ( ( ph /\ ps ) -> ( x F y ) = ( x G y ) ) $=
      ( cv co wceq oveqd adantr ) ACHZDHZEIMNFIJBAEFMNGKL $.
  $}

  ${
    $d c x y B $.  $d c x y C $.  $d c x y H $.  $d x y ph $.  $d x y X $.
    $d x y Y $.
    homffval.f $e |- F = ( Homf ` C ) $.
    homffval.b $e |- B = ( Base ` C ) $.
    homffval.h $e |- H = ( Hom ` C ) $.
    $( Value of the functionalized Hom-set operation.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    homffval $p |- F = ( x e. B , y e. B |-> ( x H y ) ) $=
      ( vc chomf cfv cv co cmpt2 cvv wceq cbs chom c0 fveq2 syl6eqr mpt2eq123dv
      wcel oveqd df-homf fvex eqeltri mpt2ex fvmpt wn mpt20 eqcomi fvprc syl5eq
      mpt2eq12 syl2anc 3eqtr4a pm2.61i eqtri ) EDKLZABCCAMZBMZFNZOZGDPUDZVAVEQJ
      DABJMZRLZVHVBVCVGSLZNZOVEPKVGDQZABVHVHVJCCVDVKVHDRLZCVGDRUAHUBZVMVKVIFVBV
      CVKVIDSLFVGDSUAIUBUEUCABJUFABCCVDCVLPHDRUGUHZVNUIUJVFUKZTABTTVDOZVAVEVPTA
      BTVDULUMDKUNVOCTQZVQVEVPQVOCVLTHDRUNUOZVRABCCTTVDUPUQURUSUT $.

    homfval.x $e |- ( ph -> X e. B ) $.
    homfval.y $e |- ( ph -> Y e. B ) $.
    $( Value of the functionalized Hom-set operation.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    homfval $p |- ( ph -> ( X F Y ) = ( X H Y ) ) $=
      ( vx vy cv co cvv cmpt2 wceq a1i homffval oveq12 adantl wcel ovex ovmpt2d
      wa ) AMNFGBBMOZNOZEPZFGEPZDQDMNBBUJRSAMNBCDEHIJUATUHFSUIGSUGUJUKSAUHFUIGE
      UBUCKLUKQUDAFGEUETUF $.
  $}

  ${
    $d x y B $.  $d x y C $.
    homffn.f $e |- F = ( Homf ` C ) $.
    homffn.b $e |- B = ( Base ` C ) $.
    $( The functionalized Hom-set operation is a function.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    homffn $p |- F Fn ( B X. B ) $=
      ( vx vy cv chom cfv co eqid homffval ovex fnmpt2i ) FGAAFHZGHZBIJZKCFGABC
      RDERLMPQRNO $.
  $}

  ${
    $d x y B $.  $d x y C $.  $d x y D $.  $d x y H $.  $d x y ph $.
    $d x y J $.
    homfeq.h $e |- H = ( Hom ` C ) $.
    homfeq.j $e |- J = ( Hom ` D ) $.
    homfeq.1 $e |- ( ph -> B = ( Base ` C ) ) $.
    homfeq.2 $e |- ( ph -> B = ( Base ` D ) ) $.
    $( Condition for two categories with the same base to have the same
       hom-sets.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    homfeq $p |- ( ph -> ( ( Homf ` C ) = ( Homf ` D ) <->
      A. x e. B A. y e. B ( x H y ) = ( x J y ) ) ) $=
      ( chomf cfv wceq cv co cmpt2 wral eqid eqidd mpt2eq123dv homffval eqeq12d
      cbs syl6reqr cvv wcel wb ovex rgen2w mpt22eqb ax-mp syl6bb ) AEMNZFMNZOBC
      DDBPZCPZGQZRZBCDDUQURHQZRZOZUSVAOCDSBDSZAUOUTUPVBAUTBCEUENZVEUSRUOABCDDUS
      VEVEUSKKAUSUAUBBCVEEUOGUOTVETIUCUFAVBBCFUENZVFVARUPABCDDVAVFVFVALLAVAUAUB
      BCVFFUPHUPTVFTJUCUFUDUSUGUHZCDSBDSVCVDUIVGBCDDUQURGUJUKBCDDUSVAUGULUMUN
      $.
  $}

  ${
    $d x y C $.  $d x y D $.  $d x y ph $.
    homfeqd.1 $e |- ( ph -> ( Base ` C ) = ( Base ` D ) ) $.
    homfeqd.2 $e |- ( ph -> ( Hom ` C ) = ( Hom ` D ) ) $.
    $( If two structures have the same ` Hom ` slot, they have the same
       Hom-sets.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    homfeqd $p |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $=
      ( vx vy chomf cfv wceq cv chom cbs wral oveqd ralrimivw eqid eqidd homfeq
      co mpbird ) ABHICHIJFKZGKZBLIZTUBUCCLIZTJZGBMIZNZFUGNAUHFUGAUFGUGAUDUEUBU
      CEOPPAFGUGBCUDUEUDQUEQAUGRDSUA $.
  $}

  ${
    homfeqbas.1 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    $( Deduce equality of base sets from equality of Hom-sets.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    homfeqbas $p |- ( ph -> ( Base ` C ) = ( Base ` D ) ) $=
      ( cbs cfv cxp cdm chomf dmeqd wceq eqid homffn fndm ax-mp 3eqtr3g dmxpid
      wfn ) ABEFZSGZHCEFZUAGZHSUAATUBABIFZHZCIFZHZTUBAUCUEDJUCTRUDTKSBUCUCLSLMT
      UCNOUEUBRUFUBKUACUEUELUALMUBUENOPJSQUAQP $.
  $}

  ${
    homfeqval.b $e |- B = ( Base ` C ) $.
    homfeqval.h $e |- H = ( Hom ` C ) $.
    homfeqval.j $e |- J = ( Hom ` D ) $.
    homfeqval.1 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    homfeqval.x $e |- ( ph -> X e. B ) $.
    homfeqval.y $e |- ( ph -> Y e. B ) $.
    $( Value of the functionalized Hom-set operation.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    homfeqval $p |- ( ph -> ( X H Y ) = ( X J Y ) ) $=
      ( chomf cfv co eqid homfval cbs oveqd homfeqbas syl5eq eleqtrd 3eqtr3d )
      AGHCOPZQGHDOPZQGHEQGHFQAUFUGGHLUAABCUFEGHUFRIJMNSADTPZDUGFGHUGRUHRKAGBUHM
      ABCTPUHIACDLUBUCZUDAHBUHNUIUDSUE $.
  $}

  ${
    $d c x y z B $.  $d c f g x y z C $.  $d f g x z ph $.  $d c f g x z .x. $.
    $d f g F $.  $d f g G $.  $d f g x z X $.  $d f g x z Y $.  $d f g x z Z $.
    $d c f g x z H $.
    comfffval.o $e |- O = ( comf ` C ) $.
    comfffval.b $e |- B = ( Base ` C ) $.
    comfffval.h $e |- H = ( Hom ` C ) $.
    comfffval.x $e |- .x. = ( comp ` C ) $.
    $( Value of the functionalized composition operation.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comfffval $p |- O = ( x e. ( B X. B ) , y e. B |->
     ( g e. ( ( 2nd ` x ) H y ) , f e. ( H ` x ) |-> ( g ( x .x. y ) f ) ) ) $=
      ( cfv cv co cmpt2 wceq cbs c0 vc ccomf cxp c2nd cvv wcel chom cco syl6eqr
      fveq2 xpeq12d oveqd fveq1d mpt2eq123dv df-comf fvex eqeltri xpex fvmpt wn
      mpt2ex fvprc syl5eq xpeq2d xp0 syl6eq mpt2eq12 syl2anc mpt20 eqtr4d eqtri
      pm2.61i ) IDUBNZABCCUCZCGFAOZUDNZBOZHPZVOHNZGOZFOZVOVQEPZPZQZQZJDUEUFZVMW
      ERUADABUAOZSNZWHUCZWHGFVPVQWGUGNZPZVOWJNZVTWAVOVQWGUHNZPZPZQZQWEUEUBWGDRZ
      ABWIWHWPVNCWDWQWHCWHCWQWHDSNZCWGDSUJKUIZWSUKWSWQGFWKWLWOVRVSWCWQWJHVPVQWQ
      WJDUGNHWGDUGUJLUIZULWQVOWJHWTUMWQWNWBVTWAWQWMEVOVQWQWMDUHNEWGDUHUJMUIULUL
      UNUNABFGUAUOABVNCWDCCCWRUEKDSUPUQZXAURXAVAUSWFUTZVMTWEDUBVBXBWEABTTWDQZTX
      BVNTRCTRWEXCRXBVNCTUCTXBCTCXBCWRTKDSVBVCZVDCVEVFXDABVNCTTWDVGVHABTWDVIVFV
      JVLVK $.

    comffval.x $e |- ( ph -> X e. B ) $.
    comffval.y $e |- ( ph -> Y e. B ) $.
    comffval.z $e |- ( ph -> Z e. B ) $.
    $( Value of the functionalized composition operation.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comffval $p |- ( ph -> ( <. X , Y >. O Z ) =
     ( g e. ( Y H Z ) , f e. ( X H Y ) |-> ( g ( <. X , Y >. .x. Z ) f ) ) ) $=
      ( vx co vz cop cxp cv c2nd cfv cmpt2 cvv wceq comfffval a1i simprl fveq2d
      wcel op2ndg syl2anc adantr eqtrd simprr oveq12d df-ov syl6eqr mpt2eq123dv
      wa oveqd opelxpi ovex mpt2ex ovmpt2d ) ASUAIJUBZKBBUCZBFESUDZUEUFZUAUDZGT
      ZVLGUFZFUDZEUDZVLVNDTZTZUGZFEJKGTZIJGTZVQVRVJKDTZTZUGZHUHHSUAVKBWAUGUIASU
      ABCDEFGHLMNOUJUKAVLVJUIZVNKUIZVDZVDZFEVOVPVTWBWCWEWJVMJVNKGWJVMVJUEUFZJWJ
      VLVJUEAWGWHULZUMAWKJUIZWIAIBUNZJBUNZWMPQIJBBUOUPUQURAWGWHUSZUTWJVPVJGUFWC
      WJVLVJGWLUMIJGVAVBWJVSWDVQVRWJVLVJVNKDWLWPUTVEVCAWNWOVJVKUNPQIJBBVFUPRWFU
      HUNAFEWBWCWEJKGVGIJGVGVHUKVI $.

    comfval.f $e |- ( ph -> F e. ( X H Y ) ) $.
    comfval.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    $( Value of the functionalized composition operation.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comfval $p |- ( ph ->
      ( G ( <. X , Y >. O Z ) F ) = ( G ( <. X , Y >. .x. Z ) F ) ) $=
      ( vg vf co cv cop cvv comffval wceq oveq12 adantl wcel ovex a1i ovmpt2d
      wa ) AUAUBFEJKGUCIJGUCUAUDZUBUDZIJUEZKDUCZUCZFEUSUCZURKHUCUFABCDUBUAGHIJK
      LMNOPQRUGUPFUHUQEUHUOUTVAUHAUPFUQEUSUIUJTSVAUFUKAFEUSULUMUN $.
  $}

  ${
    $d f g x y B $.  $d f g x y C $.  $d f g x .x. $.  $d f g X $.  $d f g Y $.
    $d f g ph $.  $d f g Z $.
    comfffval2.o $e |- O = ( comf ` C ) $.
    comfffval2.b $e |- B = ( Base ` C ) $.
    comfffval2.h $e |- H = ( Homf ` C ) $.
    comfffval2.x $e |- .x. = ( comp ` C ) $.
    $( Value of the functionalized composition operation.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comfffval2 $p |- O = ( x e. ( B X. B ) , y e. B |->
     ( g e. ( ( 2nd ` x ) H y ) , f e. ( H ` x ) |-> ( g ( x .x. y ) f ) ) ) $=
      ( cv cfv co cmpt2 wcel adantr homfval cxp c2nd chom comfffval xp2nd simpr
      eqid c1st cop xp1st df-ov 3eqtr3g wceq 1st2nd2 fveq2d 3eqtr4d mpt2eq123dv
      wa eqidd mpt2eq3ia eqtr4i ) IABCCUAZCGFANZUBOZBNZDUCOZPZVCVFOZGNFNVCVEEPP
      ZQZQABVBCGFVDVEHPZVCHOZVIQZQABCDEFGVFIJKVFUGZMUDABVBCVMVJVCVBRZVECRZURZGF
      VKVLVIVGVHVIVQCDHVFVDVELKVNVOVDCRVPVCCCUESZVOVPUFTVQVCUHOZVDUIZHOZVTVFOZV
      LVHVQVSVDHPVSVDVFPWAWBVQCDHVFVSVDLKVNVOVSCRVPVCCCUJSVRTVSVDHUKVSVDVFUKULV
      QVCVTHVOVCVTUMVPVCCCUNSZUOVQVCVTVFWCUOUPVQVIUSUQUTVA $.

    comffval2.x $e |- ( ph -> X e. B ) $.
    comffval2.y $e |- ( ph -> Y e. B ) $.
    comffval2.z $e |- ( ph -> Z e. B ) $.
    $( Value of the functionalized composition operation.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comffval2 $p |- ( ph -> ( <. X , Y >. O Z ) =
     ( g e. ( Y H Z ) , f e. ( X H Y ) |-> ( g ( <. X , Y >. .x. Z ) f ) ) ) $=
      ( co cv cop chom cfv cmpt2 eqid comffval homfval eqidd mpt2eq123dv eqtr4d
      ) AIJUAZKHSFEJKCUBUCZSZIJULSZFTETUKKDSSZUDFEJKGSZIJGSZUOUDABCDEFULHIJKLMU
      LUEZOPQRUFAFEUPUQUOUMUNUOABCGULJKNMURQRUGABCGULIJNMURPQUGAUOUHUIUJ $.

    comfval2.f $e |- ( ph -> F e. ( X H Y ) ) $.
    comfval2.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    $( Value of the functionalized composition operation.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comfval2 $p |- ( ph ->
      ( G ( <. X , Y >. O Z ) F ) = ( G ( <. X , Y >. .x. Z ) F ) ) $=
      ( chom cfv eqid co homfval eleqtrd comfval ) ABCDEFCUAUBZHIJKLMUHUCZOPQRA
      EIJGUDIJUHUDSABCGUHIJNMUIPQUEUFAFJKGUDJKUHUDTABCGUHJKNMUIQRUEUFUG $.
  $}

  ${
    $d x y B $.  $d f g x y C $.  $d f g H $.  $d f g ph $.  $d f g X $.
    $d f g Y $.  $d f g Z $.
    comfffn.o $e |- O = ( comf ` C ) $.
    comfffn.b $e |- B = ( Base ` C ) $.
    $( The functionalized composition operation is a function.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comfffn $p |- O Fn ( ( B X. B ) X. B ) $=
      ( vx vy vg vf cxp cv c2nd cfv chom co cco cmpt2 eqid comfffval ovex fvex
      mpt2ex fnmpt2i ) FGAAJAHIFKZLMZGKZBNMZOZUDUGMZHKIKUDUFBPMZOOZQCFGABUJIHUG
      CDEUGRUJRSHIUHUIUKUEUFUGTUDUGUAUBUC $.

    comffn.h $e |- H = ( Hom ` C ) $.
    comffn.x $e |- ( ph -> X e. B ) $.
    comffn.y $e |- ( ph -> Y e. B ) $.
    comffn.z $e |- ( ph -> Z e. B ) $.
    $( The functionalized composition operation is a function.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    comffn $p |- ( ph -> ( <. X , Y >. O Z ) Fn ( ( Y H Z ) X. ( X H Y ) ) ) $=
      ( vg vf co wfn cv eqid cop cxp cco cfv cmpt2 ovex fnmpt2i comffval fneq1d
      mpbiri ) AFGUAZHEQZGHDQZFGDQZUBZROPUMUNOSZPSZUKHCUCUDZQZQZUEZUOROPUMUNUTV
      AVATUPUQUSUFUGAUOULVAABCURPODEFGHIJKURTLMNUHUIUJ $.
  $}

  ${
    $d f g u x y z B $.  $d f g u z C $.  $d f g u z ph $.  $d f g u x y .x. $.
    $d f g u z D $.  $d f g u x y H $.  $d f g u x y .xb $.
    comfeq.1 $e |- .x. = ( comp ` C ) $.
    comfeq.2 $e |- .xb = ( comp ` D ) $.
    comfeq.h $e |- H = ( Hom ` C ) $.
    comfeq.3 $e |- ( ph -> B = ( Base ` C ) ) $.
    comfeq.4 $e |- ( ph -> B = ( Base ` D ) ) $.
    comfeq.5 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    $( Condition for two categories with the same hom-sets to have the same
       composition.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    comfeq $p |- ( ph -> ( ( comf ` C ) = ( comf ` D ) <->
      A. x e. B A. y e. B A. z e. B A. f e. ( x H y ) A. g e. ( y H z )
      ( g ( <. x , y >. .x. z ) f ) = ( g ( <. x , y >. .xb z ) f ) ) ) $=
      ( vu wral cv cop co wceq cxp c2nd cfv cmpt2 ccomf cvv wcel wb ovex mpt2ex
      rgen2w mpt22eqb ax-mp vex op2ndd oveq1d fveq2 df-ov syl6eqr oveq1 eqeq12d
      fvex oveqd raleqbidv ralcom 3bitr4g ralbidv ralxp bitri cbs xpeq12d eqidd
      mpt2eq123dv eqid comfffval chom w3a chomf 3ad2ant1 xp2nd 3ad2ant2 eleqtrd
      simp3 c1st xp1st 3eqtr3g 1st2nd2 fveq2d 3eqtr4d mpt2eq3dva eqtrd syl5rbbr
      homfeqval ) KUAZJUAZBUAZCUAZUBZDUAZIUCZUCZWRWSXBXCHUCZUCZUDZKXAXCLUCZTJWT
      XALUCZTZDETZCETBETZSDEEUEZEKJSUAZUFUGZXCLUCZXOLUGZWRWSXOXCIUCZUCZUHZUHZSD
      XNEKJXQXRWRWSXOXCHUCZUCZUHZUHZUDZAFUIUGZGUIUGZUDYGYAYEUDZDETZSXNTZXMYAUJU
      KZDETSXNTYGYLULYMSDXNEKJXQXRXTXPXCLUMXOLVFUNUOSDXNEYAYEUJUPUQYKXLSBCEEXOX
      BUDZYJXKDEYNXTYDUDZJXRTZKXQTZXHJXJTZKXITYJXKYNYPYRKXQXIYNXPXAXCLWTXAXOBUR
      CURUSUTYNYOXHJXRXJYNXRXBLUGXJXOXBLVAWTXALVBVCYNXTXEYDXGYNXSXDWRWSXOXBXCIV
      DVGYNYCXFWRWSXOXBXCHVDVGVEVHVHXTUJUKZJXRTKXQTYJYQULYSKJXQXRWRWSXSUMUOKJXQ
      XRXTYDUJUPUQXHJKXJXIVIVJVKVLVMAYBYHYFYIAYBSDFVNUGZYTUEZYTYAUHYHASDXNEYAUU
      AYTYAAEYTEYTPPVOPAYAVPVQSDYTFIJKLYHYHVRYTVRZOMVSVCAYFSDGVNUGZUUCUEZUUCKJX
      PXCGVTUGZUCZXOUUEUGZYDUHZUHZYIAYFSDXNEUUHUHUUIASDXNEYEUUHAXOXNUKZXCEUKZWA
      ZKJXQXRYDUUFUUGYDUULYTFGLUUEXPXCUUBOUUEVRZAUUJFWBUGGWBUGUDUUKRWCZUULXPEYT
      UUJAXPEUKUUKXOEEWDWEAUUJEYTUDUUKPWCZWFZUULXCEYTAUUJUUKWGUUOWFWQUULXOWHUGZ
      XPUBZLUGZUURUUEUGZXRUUGUULUUQXPLUCUUQXPUUEUCUUSUUTUULYTFGLUUEUUQXPUUBOUUM
      UUNUULUUQEYTUUJAUUQEUKUUKXOEEWIWEUUOWFUUPWQUUQXPLVBUUQXPUUEVBWJUULXOUURLU
      UJAXOUURUDUUKXOEEWKWEZWLUULXOUURUUEUVAWLWMUULYDVPVQWNASDXNEUUHUUDUUCUUHAE
      UUCEUUCQQVOQAUUHVPVQWOSDUUCGHJKUUEYIYIVRUUCVRUUMNVSVCVEWP $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z ph $.
    comfeqd.1 $e |- ( ph -> ( comp ` C ) = ( comp ` D ) ) $.
    comfeqd.2 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    $( Condition for two categories with the same hom-sets to have the same
       composition.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    comfeqd $p |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $=
      ( vg vf vx vy vz ccomf cfv wceq cv cco co wral oveqd ralrimivw eqid eqidd
      cop chom cbs homfeqbas comfeq mpbird ) ABKLCKLMFNZGNZHNZINZUBZJNZBOLZPZPU
      HUIULUMCOLZPZPMZFUKUMBUCLZPZQZGUJUKUSPZQZJBUDLZQZIVDQZHVDQAVFHVDAVEIVDAVC
      JVDAVAGVBAURFUTAUOUQUHUIAUNUPULUMDRRSSSSSAHIJVDBCUPUNGFUSUNTUPTUSTAVDUAAB
      CEUEEUFUG $.
  $}

  ${
    comfeqval.b $e |- B = ( Base ` C ) $.
    comfeqval.h $e |- H = ( Hom ` C ) $.
    comfeqval.1 $e |- .x. = ( comp ` C ) $.
    comfeqval.2 $e |- .xb = ( comp ` D ) $.
    comfeqval.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    comfeqval.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    comfeqval.x $e |- ( ph -> X e. B ) $.
    comfeqval.y $e |- ( ph -> Y e. B ) $.
    comfeqval.z $e |- ( ph -> Z e. B ) $.
    comfeqval.f $e |- ( ph -> F e. ( X H Y ) ) $.
    comfeqval.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    $( Equality of two compositions.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    comfeqval $p |- ( ph ->
      ( G ( <. X , Y >. .x. Z ) F ) = ( G ( <. X , Y >. .xb Z ) F ) ) $=
      ( cop ccomf cfv co oveqd eqid comfval cbs chom homfeqbas syl5eq homfeqval
      eleqtrd 3eqtr3d ) AHGJKUDZLCUEUFZUGZUGHGURLDUEUFZUGZUGHGURLFUGUGHGURLEUGU
      GAUTVBHGAUSVAURLRUHUHABCFGHIUSJKLUSUIMNOSTUAUBUCUJADUKUFZDEGHDULUFZVAJKLV
      AUIVCUIVDUIZPAJBVCSABCUKUFVCMACDQUMUNZUPAKBVCTVFUPALBVCUAVFUPAGJKIUGJKVDU
      GUBABCDIVDJKMNVEQSTUOUPAHKLIUGKLVDUGUCABCDIVDKLMNVEQTUAUOUPUJUQ $.
  $}

  ${
    $d f g h w x y z C $.  $d f g h w x y z D $.  $d f g h w x y z ph $.
    catpropd.1 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    catpropd.2 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    catpropd.3 $e |- ( ph -> C e. V ) $.
    catpropd.4 $e |- ( ph -> D e. W ) $.
    $( Two structures with the same base, hom-sets and composition operation
       are either both categories or neither.  (Contributed by Mario Carneiro,
       5-Jan-2017.) $)
    catpropd $p |- ( ph -> ( C e. Cat <-> D e. Cat ) ) $=
      ( vg vf vy vz vh vw co wceq wral wa wcel vx cv cop cco cfv chom wrex ccat
      cbs wi simpl ralimi adantl a1i wb nfra1 oveq1 eleq1d cbvralv oveq2 syl5bb
      nfv ralbidv cbvral oveqd raleqbidv opeq2 oveq1d opeq1 ralcom syl6bb ancri
      eleq12d biimpi r19.26 chomf adantr ad4antr ccomf ad5antr simpllr ad2antrr
      eqid simp-4r simpr comfeqval eqeq12d ex ralimdva ralbi syl6 impancom impr
      simplr syl anbi2d syl5bir expdimp an32s expimpd an4s expr syl56 pm5.21ndd
      imp homfeqbas homfeqval eqeq1d raleqbidva anbi12d rexeqbidva oveq2d bitrd
      ad7antr iscat 3bitr4d ) AJUBZKUBZLUBZUAUBZUCZXTBUDUEZPPZXRQZKXSXTBUFUEZPZ
      RZXRXQXTXTUCZXSYBPPZXRQZKXTXSYEPZRZSZLBUIUEZRZJXTXTYEPZUGZXQXRXTXSUCZMUBZ
      YBPZPZXTYSYEPZTZNUBZXQXSYSUCZOUBZYBPZPZXRYRUUFYBPZPZUUDUUAXTYSUCZUUFYBPZP
      ZQZNYSUUFYEPZRZOYNRZSZJXSYSYEPZRZKYKRZMYNRZLYNRZSZUAYNRZXQXRYAXTCUDUEZPPZ
      XRQZKXSXTCUFUEZPZRZXRXQYHXSUVFPPZXRQZKXTXSUVIPZRZSZLCUIUEZRZJXTXTUVIPZUGZ
      XQXRYRYSUVFPPZXTYSUVIPZTZUUDXQUUEUUFUVFPPZXRYRUUFUVFPZPZUUDUWAUUKUUFUVFPZ
      PZQZNYSUUFUVIPZRZOUVQRZSZJXSYSUVIPZRZKUVNRZMUVQRZLUVQRZSZUAUVQRZBUHTZCUHT
      ZAUVEYQUUCUUHXRUWEPZUUDUUAUWGPZQZNUUORZOYNRZSZJUUSRZKYKRZMYNRZLYNRZSZUAYN
      RZUWTAUUCJUUSRZKYKRZMYNRZLYNRZUAYNRZUVEUXNUVEUXSUJAUVDUXRUAYNUVCUXRYQUVBU
      XQLYNUVAUXPMYNUUTUXOKYKUURUUCJUUSUUCUUQUKULULULULUMULUNUXNUXSUJAUXMUXRUAY
      NUXLUXRYQUXKUXQLYNUXJUXPMYNUXIUXOKYKUXHUUCJUUSUUCUXGUKULULULULUMULUNUXSUU
      HXSUUFYEPZTZNUUORZOYNRZJUUSRZMYNRZLYNRZUXSSAUVDUXMUOZUAYNRZUVEUXNUOUXSUYF
      UXSUYFUXRUYEUALYNUXQLYNUPUYEUAVBUXRUUDXQUULPZXTUUFYEPZTZNUUORZJUUBRZOYNRZ
      MYNRXTXSQZUYEUXQUYNLMYNUXPMYNUPUYNLVBUXQUUDXQUUIPZUYJTZNUXTRZJYKRZOYNRXSY
      SQZUYNUXPUYSMOYNUXPUUDXQYTPZUUBTZNUUSRZJYKRYSUUFQZUYSUXOVUCKJYKUUCJUUSUPV
      UCKVBUXOUUDXRYTPZUUBTZNUUSRXRXQQZVUCUUCVUFJNUUSXQUUDQUUAVUEUUBXQUUDXRYTUQ
      URUSVUGVUFVUBNUUSVUGVUEVUAUUBXRXQUUDYTUTURVCVAVDVUDVUCUYRJYKVUDVUBUYQNUUS
      UXTYSUUFXSYEUTVUDVUAUYPUUBUYJVUDYTUUIUUDXQYSUUFYRYBUTVEYSUUFXTYEUTVMVFVCV
      AUSUYTUYSUYMOYNUYTUYRUYLJYKUUBXSYSXTYEUTUYTUYQUYKNUXTUUOXSYSUUFYEUQUYTUYP
      UYIUYJUYTUUIUULUUDXQUYTYRUUKUUFYBXSYSXTVGVHVEURVFVFVCVAVDUYOUYNUYDMYNUYOU
      YNUYBJUUSRZOYNRUYDUYOUYMVUHOYNUYOUYLUYBJUUBUUSXTXSYSYEUQUYOUYKUYANUUOUYOU
      YIUUHUYJUXTUYOUULUUGUUDXQUYOUUKUUEUUFYBXTXSYSVIVHVEXTXSUUFYEUQVMVCVFVCUYB
      OJYNUUSVJVKVCVAVDVNVLAUYFUXSUYHAUYFSZUXRUYGUAYNVUIXTYNTZUXRUYGVUIVUJUXRSS
      UVCUXLYQAVUJUYFUXRUVCUXLUOZAVUJSZUYFUXRSZVUKVUMUYEUXQSZLYNRZVULVUKUYEUXQL
      YNVOVULVUOUVBUXKUOZLYNRVUKVULVUNVUPLYNVUNUYDUXPSZMYNRZVULXSYNTZSZVUPUYDUX
      PMYNVOVUTVURUVAUXJUOZMYNRVUPVUTVUQVVAMYNVUTYSYNTZSZUYDUXPVVAVVCUYDSZUXPUU
      TUXIUOZKYKRVVAVVDUXOVVEKYKVVCXRYKTZUYDUXOVVEUJVVCVVFSZUYDSUXOUURUXHUOZJUU
      SRZVVEVVGUYDUXOVVIUYDUXOSUYCUUCSZJUUSRVVGVVIUYCUUCJUUSVOVVGVVJVVHJUUSVVGX
      QUUSTZSZVVJVVHVVLVVJSZUUQUXGUUCVVMUUPUXFUOZOYNRZUUQUXGUOVVLUYCUUCVVOVVLUU
      CUYCVVOVVLUUCSZUYBVVNOYNVVPUUFYNTZSZUYBUUNUXEUOZNUUORVVNVVRUYAVVSNUUOVVRU
      UDUUOTZSZUYAVVSVWAUYASZUUJUXCUUMUXDVWBYNBCUVFYBXRUUHYEXTXSUUFYNWCZYEWCZYB
      WCZUVFWCZVVLBVPUECVPUEQZUUCVVQVVTUYAVULVWGVUSVVBVVFVVKAVWGVUJFVQZVRZVRZVV
      LBVSUECVSUEQZUUCVVQVVTUYAAVWKVUJVUSVVBVVFVVKGVTZVRZVVLVUJUUCVVQVVTUYAVVCV
      UJVVFVVKAVUJVUSVVBWAZWBZVRZVVLVUSUUCVVQVVTUYAVULVUSVVBVVFVVKWDZVRVVPVVQVV
      TUYAWAZVVLVVFUUCVVQVVTUYAVVCVVFVVKWNZVRVWAUYAWEWFVWBYNBCUVFYBUUAUUDYEXTYS
      UUFVWCVWDVWEVWFVWJVWMVWPVVLVVBUUCVVQVVTUYAVUTVVBVVFVVKWAZVRVWRVVLUUCVVQVV
      TUYAWDVVRVVTUYAWNWFWGWHWIUUNUXENUUOWJWKWIWLWMUUPUXFOYNWJWOWPWHWIWQWRUURUX
      HJUUSWJWKWSWIUUTUXIKYKWJWKWTWIUVAUXJMYNWJWKWQWIUVBUXKLYNWJWKWQXEXAWPXBWIW
      TUVDUXMUAYNWJXCXDAUXMUWSUAYNUVQABCFXFZVULYQUVTUXLUWRVULYOUVRJYPUVSVULYNBC
      YEUVIXTXTVWCVWDUVIWCZVWHAVUJWEZVXCXGVULXQYPTZSZYMUVPLYNUVQAYNUVQQZVUJVXDV
      XAWBVXEVUSSZYGUVKYLUVOVXGYDUVHKYFUVJVXGYNBCYEUVIXSXTVWCVWDVXBVULVWGVXDVUS
      VWHWBZVXEVUSWEZAVUJVXDVUSWAZXGVXGXRYFTZSZYCUVGXRVXLYNBCUVFYBXRXQYEXSXTXTV
      WCVWDVWEVWFAVWGVUJVXDVUSVXKFVRAVWKVUJVXDVUSVXKGVRVXEVUSVXKWNAVUJVXDVUSVXK
      WDZVXMVXGVXKWEVULVXDVUSVXKWAWFXHXIVXGYJUVMKYKUVNVXGYNBCYEUVIXTXSVWCVWDVXB
      VXHVXJVXIXGVXGVVFSZYIUVLXRVXNYNBCUVFYBXQXRYEXTXTXSVWCVWDVWEVWFAVWGVUJVXDV
      USVVFFVRAVWKVUJVXDVUSVVFGVRAVUJVXDVUSVVFWDZVXOVXEVUSVVFWNVULVXDVUSVVFWAVX
      GVVFWEWFXHXIXJXIXKVULUXKUWQLYNUVQAVXFVUJVXAVQZVUTUXJUWPMYNUVQVULVXFVUSVXP
      VQVVCUXIUWOKYKUVNVVCYNBCYEUVIXTXSVWCVWDVXBVULVWGVUSVVBVWHWBZVWNVULVUSVVBW
      NZXGVVGUXHUWMJUUSUWNVVCUUSUWNQVVFVVCYNBCYEUVIXSYSVWCVWDVXBVXQVXRVUTVVBWEZ
      XGVQVVLUUCUWCUXGUWLVVLUUAUWAUUBUWBVVLYNBCUVFYBXRXQYEXTXSYSVWCVWDVWEVWFVWI
      VWLVWOVWQVWTVWSVVGVVKWEWFVVCUUBUWBQVVFVVKVVCYNBCYEUVIXTYSVWCVWDVXBVXQVWNV
      XSXGWBVMVVLUXFUWKOYNUVQVULVXFVUSVVBVVFVVKVXPVRVVLVVQSZUXEUWINUUOUWJVXTYNB
      CYEUVIYSUUFVWCVWDVXBVVLVWGVVQVWIVQVUTVVBVVFVVKVVQWDVVLVVQWEXGVXTVVTSZUXCU
      WFUXDUWHVYAUUHUWDXRUWEVYAYNBCUVFYBXQUUDYEXSYSUUFVWCVWDVWEVWFVVCVWGVVFVVKV
      VQVVTVXQVRZAVWKVUJVUSVVBVVFVVKVVQVVTGXNZVVCVUSVVFVVKVVQVVTVXRVRZVVCVVBVVF
      VVKVVQVVTVXSVRZVVLVVQVVTWNVVGVVKVVQVVTWAZVXTVVTWEWFVHVYAUUAUWAUUDUWGVYAYN
      BCUVFYBXRXQYEXTXSYSVWCVWDVWEVWFVYBVYCVVCVUJVVFVVKVVQVVTVWNVRVYDVYEVVCVVFV
      VKVVQVVTWDVYFWFXLWGXIXIXJXIXIXIXIXJXIXMABDTUXAUVEUOHUALMOYNBYBKJNYEDVWCVW
      DVWEXOWOACETUXBUWTUOIUALMOUVQCUVFKJNUVIEUVQWCVXBVWFXOWOXP $.

    $( Two structures with the same base, hom-sets and composition operation
       have the same identity function.  (Contributed by Mario Carneiro,
       17-Jan-2017.) $)
    cidpropd $p |- ( ph -> ( Id ` C ) = ( Id ` D ) ) $=
      ( vg vf vy ccat wcel ccid cfv wceq wa co eqid vx cbs cv cop cco chom wral
      crio homfeqbas adantr chomf ad4antr simpr simpllr homfeqval ad5antr ccomf
      cmpt simplr simp-4r comfeqval eqeq1d raleqbidva anbi12d ralbidva ad2antrr
      riotabidva raleqdv riotaeqbidv mpteq12dva cidfval catpropd biimpa 3eqtr4d
      eqtrd wn c0 cdm wfn cidffn fndm ax-mp eleq2i sylnibr ndmfv syl6bbr notbid
      syl eqtr4d pm2.61dan ) ABMNZBOPZCOPZQAWKRZUABUBPZJUCZKUCZLUCZUAUCZUDZWSBU
      EPZSSZWQQZKWRWSBUFPZSZUGZWQWPWSWSUDZWRXASSZWQQZKWSWRXDSZUGZRZLWOUGZJWSWSX
      DSZUHZURUACUBPZWPWQWTWSCUEPZSSZWQQZKWRWSCUFPZSZUGZWQWPXGWRXQSSZWQQZKWSWRX
      TSZUGZRZLXPUGZJWSWSXTSZUHZURWLWMWNUAWOXOXPYJAWOXPQZWKABCFUIZUJWNWSWONZRZX
      OYGLWOUGZJXNUHYJYNXMYOJXNYNWPXNNZRZXLYGLWOYQWRWONZRZXFYBXKYFYSXCXSKXEYAYS
      WOBCXDXTWRWSWOTZXDTZXTTZABUKPCUKPQZWKYMYPYRFULZYQYRUMZWNYMYPYRUNZUOYSWQXE
      NZRZXBXRWQUUHWOBCXQXAWQWPXDWRWSWSYTUUAXATZXQTZAUUCWKYMYPYRUUGFUPABUQPCUQP
      QZWKYMYPYRUUGGUPYQYRUUGUSWNYMYPYRUUGUTZUULYSUUGUMYNYPYRUUGUNVAVBVCYSXIYDK
      XJYEYSWOBCXDXTWSWRYTUUAUUBUUDUUFUUEUOYSWQXJNZRZXHYCWQUUNWOBCXQXAWPWQXDWSW
      SWRYTUUAUUIUUJYSUUCUUMUUDUJAUUKWKYMYPYRUUMGUPYSYMUUMUUFUJZUUOYQYRUUMUSYNY
      PYRUUMUNYSUUMUMVAVBVCVDVEVGYNYOYHJXNYIYNWOBCXDXTWSWSYTUUAUUBAUUCWKYMFVFWN
      YMUMZUUPUOYNYGLWOXPAYKWKYMYLVFVHVIVOVJWNUALWOBXAWLKJXDYTUUAUUIAWKUMWLTVKW
      NUALXPCXQWMKJXTXPTUUBUUJAWKCMNZABCDEFGHIVLZVMWMTVKVNAWKVPZRZWLVQWMUUTBOVR
      ZNZVPWLVQQUUTWKUVBAUUSUMUVAMBOMVSUVAMQVTMOWAWBZWCWDBOWEWHUUTCUVANZVPZWMVQ
      QAUUSUVEAWKUVDAWKUUQUVDUURUVAMCUVCWCWFWGVMCOWEWHWIWJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Opposite category
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c oppCat $. $( Opposite category $)

  $( The opposite category operation. $)
  coppc $a class oppCat $.

  ${
    $d f u z $.
    $( Define an opposite category, which is the same as the original category
       but with the direction of arrows the other way around.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    df-oppc $a |- oppCat = ( f e. _V |-> ( ( f sSet
      <. ( Hom ` ndx ) , tpos ( Hom ` f ) >. ) sSet <. ( comp ` ndx ) ,
        ( u e. ( ( Base ` f ) X. ( Base ` f ) ) , z e. ( Base ` f ) |->
          tpos ( <. z , ( 2nd ` u ) >. ( comp ` f ) ( 1st ` u ) ) ) >. ) ) $.
  $}

  ${
    $d c B $.  $d c u z C $.  $d c H $.  $d c .x. $.
    oppcval.b $e |- B = ( Base ` C ) $.
    oppcval.h $e |- H = ( Hom ` C ) $.
    oppcval.x $e |- .x. = ( comp ` C ) $.
    oppcval.o $e |- O = ( oppCat ` C ) $.
    $( Value of the opposite category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    oppcval $p |- ( C e. V -> O = ( ( C sSet <. ( Hom ` ndx ) , tpos H >. )
      sSet <. ( comp ` ndx ) , ( u e. ( B X. B ) , z e. B |->
        tpos ( <. z , ( 2nd ` u ) >. .x. ( 1st ` u ) ) ) >. ) ) $=
      ( vc cfv chom ctpos cop csts co cco wcel coppc cnx cxp cv c2nd c1st cmpt2
      cvv wceq elex id fveq2 syl6eqr tposeqd opeq2d oveq12d xpeq12d mpt2eq123dv
      cbs oveqd df-oppc ovex fvmpt syl syl5eq ) DHUAZGDUBNZDUCONZFPZQZRSZUCTNZB
      ACCUDZCAUEBUEZUFNQZVOUGNZESZPZUHZQZRSZLVGDUIUAVHWBUJDHUKMDMUEZVIWCONZPZQZ
      RSZVMBAWCUTNZWHUDZWHVPVQWCTNZSZPZUHZQZRSWBUIUBWCDUJZWGVLWNWARWOWCDWFVKRWO
      ULWOWEVJVIWOWDFWOWDDONFWCDOUMJUNUOUPUQWOWMVTVMWOBAWIWHWLVNCVSWOWHCWHCWOWH
      DUTNCWCDUTUMIUNZWPURWPWOWKVRWOWJEVPVQWOWJDTNEWCDTUMKUNVAUOUSUPUQABMVBVLWA
      RVCVDVEVF $.
  $}

  ${
    $d u z C $.
    oppchom.h $e |- H = ( Hom ` C ) $.
    oppchom.o $e |- O = ( oppCat ` C ) $.
    $( Hom-sets of the opposite category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    oppchomfval $p |- tpos H = ( Hom ` O ) $=
      ( vu vz cvv wcel ctpos chom cfv wceq cnx cop csts co c1 c4 c0 cco cbs cxp
      cv c2nd c1st cmpt2 homid wne cdc c5 1nn0 4nn decnncl nnrei 4nn0 5nn declt
      4lt5 ltneii homndx ccondx neeq12i mpbir setsnid fvex eqeltri tposex mpan2
      setsid eqid oppcval fveq2d 3eqtr4a tpos0 fvprc syl5eq tposeqd df-hom str0
      wn coppc syl6eqr pm2.61i ) AHIZBJZCKLZMWEANKLZWFOPQZKLZWINUALZFGAUBLZWLUC
      WLGUDFUDZUELOWMUFLAUALZQJUGZOPQZKLWFWGWOWKKWIUHWHWKUIRSUJZRUKUJZUIWQWRWQR
      SULUMUNUORSUKULUPUQUSURUTWHWQWKWRVAVBVCVDVEWEWFHIWFWJMBBAKLZHDAKVFVGVHHWF
      KHAUHVJVIWECWPKGFWLAWNBCHWLVKDWNVKEVLVMVNWEWAZTJTWFWGVOWTBTWTBWSTDAKVPVQV
      RWTWGTKLTWTCTKWTCAWBLTEAWBVPVQVMKWQVSVTWCVNWD $.

    $( Hom-sets of the opposite category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    oppchom $p |- ( X ( Hom ` O ) Y ) = ( Y H X ) $=
      ( ctpos co chom cfv oppchomfval oveqi ovtpos eqtr3i ) DEBHZIDECJKZIEDBIPQ
      DEABCFGLMDEBNO $.
  $}

  ${
    $d u z B $.  $d u z C $.  $d u z ph $.  $d u z .x. $.  $d u z X $.
    $d u z Y $.  $d u z Z $.
    oppcco.b $e |- B = ( Base ` C ) $.
    oppcco.c $e |- .x. = ( comp ` C ) $.
    oppcco.o $e |- O = ( oppCat ` C ) $.
    oppcco.x $e |- ( ph -> X e. B ) $.
    oppcco.y $e |- ( ph -> Y e. B ) $.
    oppcco.z $e |- ( ph -> Z e. B ) $.
    $( Composition in the opposite category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    oppccofval $p |- ( ph ->
      ( <. X , Y >. ( comp ` O ) Z ) = tpos ( <. Z , Y >. .x. X ) ) $=
      ( vu vz cfv cvv wcel wceq cop cxp cv c2nd c1st co ctpos cco cnx chom csts
      cmpt2 cbs elfvex eleq2s eqid oppcval 3syl fveq2d ovex fvex eqeltri mpt2ex
      xpex ccoid setsid mp2an syl6eqr simprr simprl adantr op2ndg syl2anc eqtrd
      wa opeq12d op1stg oveq12d tposeqd opelxpi tposex a1i ovmpt2d ) AOPFGUAZHB
      BUBZBPUCZOUCZUDQZUAZWGUEQZDUFZUGZHGUAZFDUFZUGZEUHQZRAWPCUIUJQCUJQZUGUAZUK
      UFZUIUHQOPWEBWLULZUAUKUFZUHQZWTAEXAUHAFBSZCRSZEXATLXDFCUMQZBFCUMUNIUOPOBC
      DWQERIWQUPJKUQURUSWSRSWTRSWTXBTCWRUKUTOPWEBWLBBBXERICUMVAVBZXFVDXFVCRWTUH
      RWSVEVFVGVHAWGWDTZWFHTZVOZVOZWKWNXJWIWMWJFDXJWFHWHGAXGXHVIXJWHWDUDQZGXJWG
      WDUDAXGXHVJZUSXJXCGBSZXKGTAXCXILVKZAXMXIMVKZFGBBVLVMVNVPXJWJWDUEQZFXJWGWD
      UEXLUSXJXCXMXPFTXNXOFGBBVQVMVNVRVSAXCXMWDWESLMFGBBVTVMNWORSAWNWMFDUTWAWBW
      C $.

    $( Composition in the opposite category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    oppcco $p |- ( ph ->
    ( G ( <. X , Y >. ( comp ` O ) Z ) F ) = ( F ( <. Z , Y >. .x. X ) G ) ) $=
      ( cop cco cfv co ctpos oppccofval oveqd ovtpos syl6eq ) AFEHIQJGRSTZTFEJI
      QHDTZUAZTEFUGTAUFUHFEABCDGHIJKLMNOPUBUCFEUGUDUE $.
  $}

  ${
    $d f g h u w x y z C $.  $d f g h w x y z O $.
    oppcbas.1 $e |- O = ( oppCat ` C ) $.
    ${
      oppcbas.2 $e |- B = ( Base ` C ) $.
      $( Base set of an opposite category.  (Contributed by Mario Carneiro,
         2-Jan-2017.) $)
      oppcbas $p |- B = ( Base ` O ) $=
        ( vu vz cbs cfv cnx cop co eqid wne c1 c4 1re 1nn0 c5 c0 wcel wceq chom
        cvv ctpos csts cco cxp cv c2nd c1st cmpt2 oppcval fveq2d baseid cdc 1nn
        4nn0 1lt10 declti ltneii basendx neeq12i mpbir setsnid clt wbr 5nn 4lt5
        homndx declt 4nn nnrei lttri mp2an ccondx eqtri syl6reqr wn base0 fvprc
        decnncl coppc syl5eq 3eqtr4a pm2.61i ) ABHIZCHIZEBUDUAZWGWHUBWIWHBJUCIZ
        BUCIZUEZKUFLZJUGIZFGWGWGUHWGGUIFUIZUJIKWOUKIBUGIZLUEULZKUFLZHIZWGWICWRH
        GFWGBWPWKCUDWGMWKMWPMDUMUNWGWMHIWSWLWJHBUOJHIZWJNOOPUPZNOXAQOPOUQURRUSU
        TZVAWTOWJXAVBVJVCVDVEWQWNHWMUOWTWNNOOSUPZNOXCQOXAVFVGXAXCVFVGOXCVFVGXBO
        PSRURVHVIVKOXAXCQXAOPRVLWBVMXCOSRVHWBVMVNVOVAWTOWNXCVBVPVCVDVEVQVRWIVSZ
        TTHIWGWHVTBHWAXDCTHXDCBWCITDBWCWAWDUNWEWFVQ $.
    $}

    $( Lemma for ~ oppccat .  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    oppccatid $p |- ( C e. Cat -> ( O e. Cat /\ ( Id ` O ) = ( Id ` C ) ) ) $=
      ( vy vx vz vw vf wcel cfv wceq wa cv cvv eqid oppchom cop oppcco syl6eleq
      co vg vh ccat ccid cbs cmpt chom w3a cco oppcbas eqidd coppc fvex eqeltri
      biid simpl simpr catidcl syl6eleqr simpr1l simpr1r simpr31 catrid simpr2l
      a1i simpr32 catlid catcocl eqeltrd simpr2r simpr33 catass 3eqtr4rd oveq1d
      eqtrd oveq2d 3eqtr4d iscatd2 wfn cidfn dffn5 sylib eqeq2d anbi2d mpbird )
      AUCIZBUCIZBUDJZAUDJZKZLWGWHDAUEJZDMZWIJZUFZKZLWFEMZWKIZWLWKIZLZFMZWKIZGMZ
      WKIZLZHMZWPWLBUGJZTZIZUAMZWLWTXFTZIZUBMZWTXBXFTZIZUHZUHZEDFGWKBBUIJZWMHUA
      UBXFNWKBUEJKWFWKABCWKOZUJVEWFXFUKWFXQUKBNIWFBAULJNCAULUMUNVEXPUOWFWRLZWMW
      LWLAUGJZTWLWLXFTXSWKAWIXTWLXRXTOZWIOZWFWRUPWFWRUQURAXTBWLWLYACPUSWFXPLZWM
      XEWPWLQZWLXQTTXEWMWLWLQZWPAUIJZTTXEYCWKAYFXEWMBWPWLWLXRYFOZCWQWRXDXOWFUTZ
      WQWRXDXOWFVAZYIRYCWKAYFWIXEXTWLWPXRYAYBWFXPUPZYIYGYHYCXEXGWLWPXTTXHXKXNWS
      XDWFVBAXTBWPWLYACPSZVCVOYCXIWMYEWTXQTTWMXIWTWLQZWLYFTTXIYCWKAYFWMXIBWLWLW
      TXRYGCYIYIXAXCWSXOWFVDZRYCWKAYFWIXIXTWTWLXRYAYBYJYMYGYIYCXIXJWTWLXTTXHXKX
      NWSXDWFVFAXTBWLWTYACPSZVGVOYCXIXEYDWTXQTTZWTWPXTTZWPWTXFTYCYOXEXIYLWPYFTT
      ZYPYCWKAYFXEXIBWPWLWTXRYGCYHYIYMRZYCWKAYFXIXEXTWTWLWPXRYAYGYJYMYIYHYNYKVH
      VIAXTBWPWTYACPUSYCXIXLXBWTQZWLYFTTZXEYDXBXQTZTZXLYQWPWTQXBXQTZTZXLXIWLWTQ
      XBXQTTZXEUUATXLYOUUCTYCYQXLYSWPYFTTXEYTXBWLQWPYFTTUUDUUBYCWKAYFXLXIXTXEWP
      XBWTWLXRYAYGYJXAXCWSXOWFVJZYMYIYCXLXMXBWTXTTXHXKXNWSXDWFVKAXTBWTXBYACPSYN
      YHYKVLYCWKAYFYQXLBWPWTXBXRYGCYHYMUUFRYCWKAYFXEYTBWPWLXBXRYGCYHYIUUFRVMYCU
      UEYTXEUUAYCWKAYFXIXLBWLWTXBXRYGCYIYMUUFRVNYCYOYQXLUUCYRVPVQVRWFWJWOWGWFWI
      WNWHWFWIWKVSWIWNKWKAWIXRYBVTDWKWIWAWBWCWDWE $.

    ${
      oppchomf.h $e |- H = ( Homf ` C ) $.
      $( Hom-sets of the opposite category.  (Contributed by Mario Carneiro,
         17-Jan-2017.) $)
      oppchomf $p |- tpos H = ( Homf ` O ) $=
        ( vy vx cbs cfv cv chom co cmpt2 chomf ctpos wceq wcel wa eqid homffval
        oppchom a1i mpt2eq3ia oppcbas tposmpt2 3eqtr4ri ) FGAHIZUGFJZGJZCKIZLZM
        FGUGUGUIUHAKIZLZMCNIZBOFGUGUGUKUMUKUMPUHUGQUIUGQRAULCUHUIULSZDUAUBUCFGU
        GCUNUJUNSUGACDUGSZUDUJSTGFUGUGUMBGFUGABULEUPUOTUEUF $.
    $}

    ${
      oppcid.2 $e |- B = ( Id ` C ) $.
      $( Identity function of an opposite category.  (Contributed by Mario
         Carneiro, 2-Jan-2017.) $)
      oppcid $p |- ( C e. Cat -> ( Id ` O ) = B ) $=
        ( ccat wcel ccid cfv wceq oppccatid simprd syl6eqr ) BFGZCHIZBHIZANCFGO
        PJBCDKLEM $.
    $}

    $( An opposite category is a category.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    oppccat $p |- ( C e. Cat -> O e. Cat ) $=
      ( ccat wcel ccid cfv wceq oppccatid simpld ) ADEBDEBFGAFGHABCIJ $.

    ${
      2oppcco.2 $e |- B = ( Base ` C ) $.
      $( The double opposite category has the same objects as the original
         category.  Intended for use with property lemmas such as ~ monpropd .
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      2oppcbas $p |- B = ( Base ` ( oppCat ` O ) ) $=
        ( coppc cfv eqid oppcbas ) ACCFGZJHABCDEII $.
    $}

    $( The double opposite category has the same morphisms as the original
       category.  Intended for use with property lemmas such as ~ monpropd .
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    2oppchomf $p |- ( Homf ` C ) = ( Homf ` ( oppCat ` O ) ) $=
      ( chomf cfv ctpos coppc wrel cdm wceq cbs cxp wfn eqid homffn fnrel ax-mp
      relxp fndm oppchomf releqi mpbir tpostpos2 mp2an eqtr3i ) ADEZFZFZUFBGEZD
      EUFHZUFIZHZUHUFJUFAKEZUMLZMZUJUMAUFUFNZUMNOZUNUFPQULUNHUMUMRUKUNUOUKUNJUQ
      UNUFSQUAUBUFUCUDBUGUIUINAUFBCUPTTUE $.

    $( The double opposite category has the same composition as the original
       category.  Intended for use with property lemmas such as ~ monpropd .
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    2oppccomf $p |- ( comf ` C ) = ( comf ` ( oppCat ` O ) ) $=
      ( vg vf vx vy vz ccomf cfv wceq wtru cv cop cco co wral cbs wcel eqid w3a
      coppc wa oppcbas simpr1 simpr2 simpr3 oppcco eqtr2d ralrimivw ralrimivvva
      chom eqidd 2oppcbas a1i chomf 2oppchomf comfeq mpbird trud ) AIJBUBJZIJKZ
      LVBDMZEMZFMZGMZNZHMZAOJZPPZVCVDVGVHVAOJZPPZKZDVFVHAULJZPZQZEVEVFVNPZQZHAR
      JZQGVSQFVSQLVRFGHVSVSVSLVEVSSZVFVSSZVHVSSZUAUCZVPEVQWCVMDVOWCVLVDVCVHVFNV
      EBOJZPPVJWCVSBWDVDVCVAVEVFVHVSABCVSTZUDWDTVATLVTWAWBUEZLVTWAWBUFZLVTWAWBU
      GZUHWCVSAVIVCVDBVHVFVEWEVITZCWHWGWFUHUIUJUJUKLFGHVSAVAVKVIEDVNWIVKTVNTLVS
      UMVSVARJKLVSABCWEUNUOAUPJVAUPJKLABCUQUOURUSUT $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z ph $.
    oppchomfpropd.1 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    $( If two categories have the same hom-sets, so do their opposites.
       (Contributed by Mario Carneiro, 26-Jan-2017.) $)
    oppchomfpropd $p |- ( ph ->
      ( Homf ` ( oppCat ` C ) ) = ( Homf ` ( oppCat ` D ) ) ) $=
      ( chomf cfv ctpos coppc tposeqd eqid oppchomf 3eqtr3g ) ABEFZGCEFZGBHFZEF
      CHFZEFAMNDIBMOOJMJKCNPPJNJKL $.

    oppccomfpropd.1 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    $( If two categories have the same hom-sets and composition, so do their
       opposites.  (Contributed by Mario Carneiro, 26-Jan-2017.) $)
    oppccomfpropd $p |- ( ph ->
      ( comf ` ( oppCat ` C ) ) = ( comf ` ( oppCat ` D ) ) ) $=
      ( vg vf vx vy vz cfv ccomf wceq cv cco co wral cbs wcel eqid cop chom w3a
      coppc wa chomf ad2antrr simplr3 simplr2 simplr1 simprr syl6eleq comfeqval
      oppchom simprl oppcco homfeqbas eleqtrd 3eqtr4d ralrimivva oppcbas syl6eq
      ralrimivvva a1i oppchomfpropd comfeq mpbird ) ABUDKZLKCUDKZLKMFNZGNZHNZIN
      ZUAZJNZVHOKZPPZVJVKVNVOVIOKZPPZMZFVMVOVHUBKZPZQGVLVMWAPZQZJBRKZQIWEQHWEQA
      WDHIJWEWEWEAVLWESZVMWESZVOWESZUCZUEZVTGFWCWBWJVKWCSZVJWBSZUEZUEZVKVJVOVMU
      AZVLBOKZPPVKVJWOVLCOKZPPVQVSWNWEBCWQWPVJVKBUBKZVOVMVLWETZWRTZWPTZWQTZABUF
      KCUFKMWIWMDUGABLKCLKMWIWMEUGWFWGWHAWMUHZWFWGWHAWMUIZWFWGWHAWMUJZWNVJWBVOV
      MWRPWJWKWLUKBWRVHVMVOWTVHTZUNULWNVKWCVMVLWRPWJWKWLUOBWRVHVLVMWTXFUNULUMWN
      WEBWPVKVJVHVLVMVOWSXAXFXEXDXCUPWNCRKZCWQVKVJVIVLVMVOXGTZXBVITZWNVLWEXGXEA
      WEXGMWIWMABCDUQZUGZURWNVMWEXGXDXKURWNVOWEXGXCXKURUPUSUTVCAHIJWEVHVIVRVPGF
      WAVPTVRTWATWEVHRKMAWEBVHXFWSVAVDAWEXGVIRKXJXGCVIXIXHVAVBABCDVEVFVG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Monomorphisms and epimorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Mono $. $( The class of all monomorphisms. $)
  $c Epi $. $( The class of all epimorphisms. $)

  $( Extend class notation with the class of all monomorphisms. $)
  cmon $a class Mono $.

  $( Extend class notation with the class of all epimorphisms. $)
  cepi $a class Epi $.

  ${
    $d b c f g h x y z $.
    $( Function returning the monomorphisms of the category ` c ` .  JFM CAT_1
       def. 10.  (Contributed by FL, 5-Dec-2007.)  (Revised by Mario Carneiro,
       2-Jan-2017.) $)
    df-mon $a |- Mono = ( c e. Cat |->
      [_ ( Base ` c ) / b ]_ [_ ( Hom ` c ) / h ]_
      ( x e. b , y e. b |-> { f e. ( x h y ) | A. z e. b Fun `'
        ( g e. ( z h x ) |-> ( f ( <. z , x >. ( comp ` c ) y ) g ) ) } ) ) $.

    $( Function returning the epimorphisms of the category ` c ` .  JFM CAT_1
       def. 11.  (Contributed by FL, 8-Aug-2008.)  (Revised by Mario Carneiro,
       2-Jan-2017.) $)
    df-epi $a |- Epi = ( c e. Cat |-> tpos ( Mono ` ( oppCat ` c ) ) ) $.
  $}

  ${
    $d b c f g h x y z B $.  $d g h z G $.  $d g h z K $.  $d f g h x y z ph $.
    $d b c f g h x y z C $.  $d b c f g h x y z H $.  $d b c f g h x y z .x. $.
    $d f g h z F $.  $d f g h x y z X $.  $d f g h x y z Y $.  $d g h z Z $.
    $d f M $.
    ismon.b $e |- B = ( Base ` C ) $.
    ismon.h $e |- H = ( Hom ` C ) $.
    ismon.o $e |- .x. = ( comp ` C ) $.
    ismon.s $e |- M = ( Mono ` C ) $.
    ismon.c $e |- ( ph -> C e. Cat ) $.
    $( Definition of a monomorphism in a category.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    monfval $p |- ( ph -> M = ( x e. B , y e. B |-> { f e. ( x H y ) |
 A. z e. B Fun `' ( g e. ( z H x ) |-> ( f ( <. z , x >. .x. y ) g ) ) } ) ) $=
      ( cfv cv co cbs vc vb vh cmon cop cmpt ccnv wfun wral crab ccat wcel wceq
      cmpt2 chom cco csb cvv fvex a1i fveq2 syl6eqr wa simpl fveq2d simpr oveqd
      simplr simpll mpteq12dv cnveqd funeqd raleqbidv rabeqbidv csbied2 eqeltri
      mpt2eq123dv df-mon mpt2ex fvmpt syl syl5eq ) AKFUDQZBCEEIDRZBRZJSZHRZIRZW
      DWEUEZCRZGSZSZUFZUGZUHZDEUIZHWEWJJSZUJZUNZOAFUKULWCWSUMPUAFUBUARZTQZUCWTU
      OQZBCUBRZXCIWDWEUCRZSZWGWHWIWJWTUPQZSZSZUFZUGZUHZDXCUIZHWEWJXDSZUJZUNZUQZ
      UQWSUKUDWTFUMZUBXAEXPWSURXAURULXQWTTUSUTXQXAFTQZEWTFTVALVBXQXCEUMZVCZUCXB
      JXOWSURXBURULXTWTUOUSUTXTXBFUOQJXTWTFUOXQXSVDVEMVBXTXDJUMZVCZBCXCXCXNEEWR
      XQXSYAVHZYCYBXLWPHXMWQYBXDJWEWJXTYAVFZVGYBXKWODXCEYCYBXJWNYBXIWMYBIXEXHWF
      WLYBXDJWDWEYDVGYBXGWKWGWHYBXFGWIWJYBXFFUPQGYBWTFUPXQXSYAVIVENVBVGVGVJVKVL
      VMVNVQVOVOBCDHIUCUBUAVRBCEEWREXRURLFTUSVPZYEVSVTWAWB $.

    ismon.x $e |- ( ph -> X e. B ) $.
    ismon.y $e |- ( ph -> Y e. B ) $.
    $( Definition of a monomorphism in a category.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    ismon $p |- ( ph -> ( F e. ( X M Y ) <-> ( F e. ( X H Y ) /\ A. z e. B
      Fun `' ( g e. ( z H X ) |-> ( F ( <. z , X >. .x. Y ) g ) ) ) ) ) $=
      ( vf co vx vy wcel cv cop cmpt ccnv wfun wral crab wa monfval wceq simprl
      cvv simprr oveq12d oveq2d opeq2d oveqd mpteq12dv cnveqd ralbidv rabeqbidv
      funeqd ovex rabex a1i ovmpt2d eleq2d oveq1 mpteq2dv elrab syl6bb ) AGJKIT
      ZUCGFBUDZJHTZSUDZFUDZVPJUEZKETZTZUFZUGZUHZBCUIZSJKHTZUJZUCGWGUCFVQGVSWATZ
      UFZUGZUHZBCUIZUKAVOWHGAUAUBJKCCFVPUAUDZHTZVRVSVPWNUEZUBUDZETZTZUFZUGZUHZB
      CUIZSWNWQHTZUJWHIUOAUAUBBCDESFHILMNOPULAWNJUMZWQKUMZUKUKZXCWFSXDWGXGWNJWQ
      KHAXEXFUNZAXEXFUPZUQXGXBWEBCXGXAWDXGWTWCXGFWOWSVQWBXGWNJVPHXHURXGWRWAVRVS
      XGWPVTWQKEXGWNJVPXHUSXIUQUTVAVBVEVCVDQRWHUOUCAWFSWGJKHVFVGVHVIVJWFWMSGWGV
      RGUMZWEWLBCXJWDWKXJWCWJXJFVQWBWIVRGVSWAVKVLVBVEVCVMVN $.

    $( Write out the monomorphism property directly.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    ismon2 $p |- ( ph -> ( F e. ( X M Y ) <-> ( F e. ( X H Y ) /\ A. z e. B
      A. g e. ( z H X ) A. h e. ( z H X )
        ( ( F ( <. z , X >. .x. Y ) g ) =
          ( F ( <. z , X >. .x. Y ) h ) -> g = h ) ) ) ) $=
      ( wcel co cv cmpt ccnv wfun wral wa wceq wi ismon wb ccat ad2antrr simprl
      cop simprr simplr catcocl anassrs ralrimiva wf eqid fmpt df-f1 baib sylbi
      wf1 oveq2 f1mpt bitr3d syl ralbidva pm5.32da bitrd ) AHKLJUATHKLIUATZFBUB
      ZKIUAZHFUBZVPKUOLEUAZUAZUCZUDUEZBCUFZUGVOVTHGUBZVSUAZUHVRWDUHUIGVQUFFVQUF
      ZBCUFZUGABCDEFHIJKLMNOPQRSUJAVOWCWGAVOUGZWBWFBCWHVPCTZUGZVTVPLIUAZTZFVQUF
      ZWBWFUKWJWLFVQWHWIVRVQTZWLWHWIWNUGZUGCDEVRHIVPKLMNOADULTVOWOQUMWHWIWNUNAK
      CTVOWORUMALCTVOWOSUMWHWIWNUPAVOWOUQURUSUTWMVQWKWAVGZWBWFWMVQWKWAVAZWPWBUK
      FVQWKVTWAWAVBZVCWPWQWBVQWKWAVDVEVFWPWMWFFGVQWKVTWEWAWRVRWDHVSVHVIVEVJVKVL
      VMVN $.

    $( A monomorphism is a morphism.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    monhom $p |- ( ph -> ( X M Y ) C_ ( X H Y ) ) $=
      ( vf vg vz co cv wcel cop cmpt ccnv wfun wral wa ismon simpl syl6bi ssrdv
      ) APGHFSZGHESZAPTZULUAUNUMUAZQRTZGESUNQTUPGUBHDSSUCUDUERBUFZUGUOARBCDQUNE
      FGHIJKLMNOUHUOUQUIUJUK $.

    moni.z $e |- ( ph -> Z e. B ) $.
    moni.f $e |- ( ph -> F e. ( X M Y ) ) $.
    moni.g $e |- ( ph -> G e. ( Z H X ) ) $.
    moni.k $e |- ( ph -> K e. ( Z H X ) ) $.
    $( Property of a monomorphism.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    moni $p |- ( ph -> ( ( F ( <. Z , X >. .x. Y ) G ) =
                         ( F ( <. Z , X >. .x. Y ) K ) <-> G = K ) ) $=
      ( vg vz vh cop co wceq cv wi wral ismon2 mpbid simprd adantr simpr oveq1d
      wcel eleqtrrd simpllr opeq1d eqidd simplr oveq123d eqeq12d imbi12d rspcdv
      wa rspcimdv mpd oveq2 impbid1 ) AEFLJUGZKDUHZUHZEHVOUHZUIZFHUIZAEUDUJZUEU
      JZJUGZKDUHZUHZEUFUJZWCUHZUIZVTWEUIZUKZUFWAJGUHZULZUDWJULZUEBULZVRVSUKZAEJ
      KGUHUSZWMAEJKIUHUSWOWMVIUAAUEBCDUDUFEGIJKMNOPQRSUMUNUOAWLWNUELBTAWALUIZVI
      ZWKWNUDFWJWQFLJGUHZWJAFWRUSWPUBUPWQWALJGAWPUQURZUTWQVTFUIZVIZWIWNUFHWJWQH
      WJUSWTWQHWRWJAHWRUSWPUCUPWSUTUPXAWEHUIZVIZWGVRWHVSXCWDVPWFVQXCEEVTFWCVOXC
      WBVNKDXCWALJAWPWTXBVAVBURZXCEVCZWQWTXBVDZVEXCEEWEHWCVOXDXEXAXBUQZVEVFXCVT
      FWEHXFXGVFVGVHVJVJVKFHEVOVLVM $.
  $}

  ${
    $d a b c f g x y z B $.  $d a b c f g x y z C $.  $d a b c f g x y z ph $.
    $d a b c f g x y z D $.
    monpropd.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    monpropd.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    monpropd.c $e |- ( ph -> C e. Cat ) $.
    monpropd.d $e |- ( ph -> D e. Cat ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same monomorphisms.  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    monpropd $p |- ( ph -> ( Mono ` C ) = ( Mono ` D ) ) $=
      ( va vb vg vc vf cfv cv co wral wcel wceq wa eqid cbs chom cmpt ccnv wfun
      cop crab cmpt2 cmon chomf ad2antrr simpr simp-4r homfeqval ad5antr simplr
      cco simp-5r simpllr comfeqval mpteq12dva cnveqd funeqd ralbidva homfeqbas
      ccomf rabbidva raleqdv rabeqbidv eqtrd mpt2eq3dva syl2anc monfval 3eqtr4d
      3impa mpt2eq12 ) AHIBUAMZVQJKNZHNZBUBMZOZLNZJNZVRVSUFZINZBUQMZOOZUCZUDZUE
      ZKVQPZLVSWEVTOZUGZUHZHICUAMZWOJVRVSCUBMZOZWBWCWDWECUQMZOOZUCZUDZUEZKWOPZL
      VSWEWPOZUGZUHZBUIMZCUIMZAWNHIVQVQXEUHZXFAHIVQVQWMXEAVSVQQZWEVQQZWMXERAXJS
      ZXKSZWMXBKVQPZLWLUGXEXMWKXNLWLXMWBWLQZSZWJXBKVQXPVRVQQZSZWIXAXRWHWTXRJWAW
      GWQWSXRVQBCVTWPVRVSVQTZVTTZWPTZXMBUJMCUJMRZXOXQAYBXJXKDUKZUKXPXQULAXJXKXO
      XQUMUNXRWCWAQZSVQBCWRWFWCWBVTVRVSWEXSXTWFTZWRTZAYBXJXKXOXQYDDUOABVFMCVFMR
      XJXKXOXQYDEUOXPXQYDUPAXJXKXOXQYDURXLXKXOXQYDUMXRYDULXMXOXQYDUSUTVAVBVCVDV
      GXMXNXCLWLXDXMVQBCVTWPVSWEXSXTYAYCAXJXKUPXLXKULUNXMXBKVQWOAVQWORZXJXKABCD
      VEZUKVHVIVJVOVKAYGYGXIXFRYHYHHIVQVQWOWOXEVPVLVJAHIKVQBWFLJVTXGXSXTYEXGTFV
      MAHIKWOCWRLJWPXHWOTYAYFXHTGVMVN $.
  $}

  ${
    $d c x y z C $.  $d c M $.  $d x y z O $.  $d x y z ph $.
    oppcmon.o $e |- O = ( oppCat ` C ) $.
    oppcmon.c $e |- ( ph -> C e. Cat ) $.
    ${
      oppcmon.m $e |- M = ( Mono ` O ) $.
      oppcmon.e $e |- E = ( Epi ` C ) $.
      $( A monomorphism in the opposite category is an epimorphism.
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      oppcmon $p |- ( ph -> ( X M Y ) = ( Y E X ) ) $=
        ( vc co ctpos cepi cfv ccat wceq coppc cmon wcel syl6eqr fveq2d tposeqd
        cv fveq2 df-epi cvv fvex eqeltri tposex fvmpt syl syl5eq ovtpos syl6req
        oveqd ) AGFCMGFDNZMFGDMACURGFACBOPZURKABQUAUSURRILBLUEZSPZTPZNURQOUTBRZ
        VBDVCVBETPZDVCVAETVCVABSPEUTBSUFHUBUCJUBUDLUGDDVDUHJETUIUJUKULUMUNUQGFD
        UOUP $.
    $}

    ${
      oppcepi.e $e |- E = ( Epi ` O ) $.
      oppcepi.m $e |- M = ( Mono ` C ) $.
      $( An epimorphism in the opposite category is a monomorphism.
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      oppcepi $p |- ( ph -> ( X E Y ) = ( Y M X ) ) $=
        ( co cfv cmon chomf wceq a1i ccomf ccat wcel 2oppchomf oppccat syl eqid
        coppc 2oppccomf monpropd syl5eq oveqd oppcmon eqtr2d ) AGFDLGFEUEMZNMZL
        FGCLADUMGFADBNMUMKABULBOMULOMPABEHUAQBRMULRMPABEHUFQIAESTZULSTABSTUNIBE
        HUBUCZEULULUDZUBUCUGUHUIAECUMULGFUPUOUMUDJUJUK $.
    $}
  $}

  ${
    $d g z B $.  $d g z C $.  $d f g h z H $.  $d g h z .x. $.  $d f g h z X $.
    $d f E $.  $d g h z F $.  $d f g z ph $.  $d f g h z Y $.
    isepi.b $e |- B = ( Base ` C ) $.
    isepi.h $e |- H = ( Hom ` C ) $.
    isepi.o $e |- .x. = ( comp ` C ) $.
    isepi.e $e |- E = ( Epi ` C ) $.
    isepi.c $e |- ( ph -> C e. Cat ) $.
    isepi.x $e |- ( ph -> X e. B ) $.
    isepi.y $e |- ( ph -> Y e. B ) $.
    $( Definition of an epimorphism in a category.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    isepi $p |- ( ph -> ( F e. ( X E Y ) <-> ( F e. ( X H Y ) /\ A. z e. B
      Fun `' ( g e. ( Y H z ) |-> ( g ( <. X , Y >. .x. z ) F ) ) ) ) ) $=
      ( co wcel coppc cfv cmon chom cv cop cco cmpt ccnv wfun wral eqid oppcbas
      wa ccat oppccat syl ismon oppcmon eleq2d wceq oppchom simpr adantr oppcco
      a1i mpteq12dv cnveqd funeqd ralbidva anbi12d 3bitr3d ) AHKJDUAUBZUCUBZSZT
      HKJVMUDUBZSZTZFBUEZKVPSZHFUEZVSKUFJVMUGUBZSSZUHZUIZUJZBCUKZUNHJKGSZTHJKIS
      ZTZFKVSISZWAHJKUFVSESSZUHZUIZUJZBCUKZUNABCVMWBFHVPVNKJCDVMVMULZLUMVPULWBU
      LVNULZADUOTVMUOTPDVMWQUPUQRQURAVOWHHADGVNVMKJWQPWROUSUTAVRWJWGWPAVQWIHVQW
      IVAADIVMKJMWQVBVFUTAWFWOBCAVSCTZUNZWEWNWTWDWMWTFVTWCWKWLVTWKVAWTDIVMVSKMW
      QVBVFWTCDEWAHVMVSKJLNWQAWSVCAKCTWSRVDAJCTWSQVDVEVGVHVIVJVKVL $.

    $( Write out the epimorphism property directly.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    isepi2 $p |- ( ph -> ( F e. ( X E Y ) <-> ( F e. ( X H Y ) /\ A. z e. B
      A. g e. ( Y H z ) A. h e. ( Y H z )
        ( ( g ( <. X , Y >. .x. z ) F ) =
          ( h ( <. X , Y >. .x. z ) F ) -> g = h ) ) ) ) $=
      ( wcel co cv cmpt ccnv wfun wral wa wceq wi isepi wb ccat ad2antrr simprl
      cop simplr simprr catcocl anassrs ralrimiva wf eqid fmpt df-f1 baib sylbi
      wf1 oveq1 f1mpt bitr3d syl ralbidva pm5.32da bitrd ) AIKLHUATIKLJUATZFLBU
      BZJUAZFUBZIKLUOVPEUAZUAZUCZUDUEZBCUFZUGVOVTGUBZIVSUAZUHVRWDUHUIGVQUFFVQUF
      ZBCUFZUGABCDEFHIJKLMNOPQRSUJAVOWCWGAVOUGZWBWFBCWHVPCTZUGZVTKVPJUAZTZFVQUF
      ZWBWFUKWJWLFVQWHWIVRVQTZWLWHWIWNUGZUGCDEIVRJKLVPMNOADULTVOWOQUMAKCTVOWORU
      MALCTVOWOSUMWHWIWNUNAVOWOUPWHWIWNUQURUSUTWMVQWKWAVGZWBWFWMVQWKWAVAZWPWBUK
      FVQWKVTWAWAVBZVCWPWQWBVQWKWAVDVEVFWPWMWFFGVQWKVTWEWAWRVRWDIVSVHVIVEVJVKVL
      VMVN $.

    $( An epimorphism is a morphism.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    epihom $p |- ( ph -> ( X E Y ) C_ ( X H Y ) ) $=
      ( vf vg vz co cv wcel cop cmpt ccnv wfun wral wa isepi simpl syl6bi ssrdv
      ) APGHESZGHFSZAPTZULUAUNUMUAZQHRTZFSQTUNGHUBUPDSSUCUDUERBUFZUGUOARBCDQEUN
      FGHIJKLMNOUHUOUQUIUJUK $.

    epii.z $e |- ( ph -> Z e. B ) $.
    epii.f $e |- ( ph -> F e. ( X E Y ) ) $.
    epii.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    epii.k $e |- ( ph -> K e. ( Y H Z ) ) $.
    $( Property of an epimorphism.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    epii $p |- ( ph -> ( ( G ( <. X , Y >. .x. Z ) F ) =
                         ( K ( <. X , Y >. .x. Z ) F ) <-> G = K ) ) $=
      ( cop coppc cfv cco co wceq eqid oppcco eqeq12d chom cmon oppcbas oppccat
      ccat wcel syl oppcmon eleqtrrd oppchom syl6eleqr moni bitr3d ) AFGLKUDJCU
      EUFZUGUFZUHZUHZFIVHUHZUIGFJKUDLDUHZUHZIFVKUHZUIGIUIAVIVLVJVMABCDGFVFLKJMO
      VFUJZTSRUKABCDIFVFLKJMOVNTSRUKULABVFVGFGVFUMUFZIVFUNUFZKJLBCVFVNMUOVOUJVG
      UJVPUJZACUQURVFUQURQCVFVNUPUSSRTAFJKEUHKJVPUHUAACEVPVFKJVNQVQPUTVAAGKLHUH
      ZLKVOUHZUBCHVFLKNVNVBZVCAIVRVSUCVTVCVDVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Sections, inverses, isomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Sect $. $( Sections of a morphism. $)
  $c Inv $. $( The inverse of a morphism. $)
  $c Iso $. $( The class of all isomorphisms. $)

  $( Extend class notation with the sections of a morphism. $)
  csect $a class Sect $.

  $( Extend class notation with the inverses of a morphism. $)
  cinv $a class Inv $.

  $( Extend class notation with the class of all isomorphisms. $)
  ciso $a class Iso $.

  ${
    $d c f g h x y $.
    $( Function returning the section relation in a category.  Given arrows
       ` f : X --> Y ` and ` g : Y --> X ` , we say ` f Sect g ` , that is,
       ` f ` is a section of ` g ` , if ` g o. f = 1 `` X ` .  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    df-sect $a |- Sect = ( c e. Cat |->
     ( x e. ( Base ` c ) , y e. ( Base ` c ) |-> { <. f , g >. |
       [. ( Hom ` c ) / h ]. ( ( f e. ( x h y ) /\ g e. ( y h x ) ) /\
         ( g ( <. x , y >. ( comp ` c ) x ) f ) = ( ( Id ` c ) ` x ) ) } ) ) $.

    $( The inverse relation in a category.  Given arrows ` f : X --> Y ` and
       ` g : Y --> X ` , we say ` g Inv f ` , that is, ` g ` is an inverse of
       ` f ` , if ` g ` is a section of ` f ` and ` f ` is a section of
       ` g ` .  (Contributed by FL, 22-Dec-2008.)  (Revised by Mario Carneiro,
       2-Jan-2017.) $)
    df-inv $a |- Inv = ( c e. Cat |-> ( x e. ( Base ` c ) , y e. ( Base ` c )
      |-> ( ( x ( Sect ` c ) y ) i^i `' ( y ( Sect ` c ) x ) ) ) ) $.

    $( Function returning the isomorphisms of the category ` c ` .  The Joy of
       Cats p. 28.  (Contributed by FL, 9-Jun-2014.)  (Revised by Mario
       Carneiro, 2-Jan-2017.) $)
    df-iso $a |- Iso = ( c e. Cat |->
      ( ( x e. _V |-> dom x ) o. ( Inv ` c ) ) ) $.
  $}

  ${
    $d c f g h x y .1. $.  $d c x y B $.  $d c f g h x y C $.  $d f g x y ph $.
    $d f g F $.  $d c f g h x y H $.  $d c f g h x y .x. $.  $d f g x y X $.
    $d f g G $.  $d f g x y Y $.
    issect.b $e |- B = ( Base ` C ) $.
    issect.h $e |- H = ( Hom ` C ) $.
    issect.o $e |- .x. = ( comp ` C ) $.
    issect.i $e |- .1. = ( Id ` C ) $.
    issect.s $e |- S = ( Sect ` C ) $.
    issect.c $e |- ( ph -> C e. Cat ) $.
    issect.x $e |- ( ph -> X e. B ) $.
    issect.y $e |- ( ph -> Y e. B ) $.
    $( Value of the section operation.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    sectffval $p |- ( ph -> S = ( x e. B , y e. B |-> { <. f , g >. |
      ( ( f e. ( x H y ) /\ g e. ( y H x ) ) /\
        ( g ( <. x , y >. .x. x ) f ) = ( .1. ` x ) ) } ) ) $=
      ( vc vh csect cfv cv co wcel cop wceq copab cmpt2 ccat cbs ccid chom wsbc
      wa cco fveq2 syl6eqr cvv fvex a1i simpr oveqd eleq2d anbi12d simpl fveq2d
      fveq1d eqeq12d sbcied2 opabbidv mpt2eq123dv df-sect eqeltri mpt2ex syl5eq
      fvmpt syl ) AFEUDUEZBCDDIUFZBUFZCUFZKUGZUHZJUFZWEWDKUGZUHZURZWHWCWDWEUIZW
      DGUGZUGZWDHUEZUJZURZIJUKZULZRAEUMUHWBWSUJSUBEBCUBUFZUNUEZXAWCWDWEUCUFZUGZ
      UHZWHWEWDXBUGZUHZURZWHWCWLWDWTUSUEZUGZUGZWDWTUOUEZUEZUJZURZUCWTUPUEZUQZIJ
      UKZULWSUMUDWTEUJZBCXAXAXQDDWRXRXAEUNUEZDWTEUNUTNVAZXTXRXPWQIJXRXNWQUCXOKV
      BXOVBUHXRWTUPVCVDXRXOEUPUEKWTEUPUTOVAXRXBKUJZURZXGWKXMWPYBXDWGXFWJYBXCWFW
      CYBXBKWDWEXRYAVEZVFVGYBXEWIWHYBXBKWEWDYCVFVGVHYBXJWNXLWOYBXIWMWHWCYBXHGWL
      WDYBXHEUSUEGYBWTEUSXRYAVIZVJPVAVFVFYBWDXKHYBXKEUOUEHYBWTEUOYDVJQVAVKVLVHV
      MVNVOBCIJUCUBVPBCDDWRDXSVBNEUNVCVQZYEVRVTWAVS $.

    $( Value of the section relation.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    sectfval $p |- ( ph -> ( X S Y ) = { <. f , g >. |
        ( ( f e. ( X H Y ) /\ g e. ( Y H X ) ) /\
          ( g ( <. X , Y >. .x. X ) f ) = ( .1. ` X ) ) } ) $=
      ( co vx vy cv wcel cop cfv wceq copab cvv sectffval simprl simprr oveq12d
      wa eleq2d anbi12d opeq12d oveqd fveq2d eqeq12d opabbidv cxp ovex opabssxp
      xpex ssexi a1i ovmpt2d ) AUAUBJKBBGUCZUAUCZUBUCZITZUDZHUCZVKVJITZUDZUNZVN
      VIVJVKUEZVJETZTZVJFUFZUGZUNZGHUHVIJKITZUDZVNKJITZUDZUNZVNVIJKUEZJETZTZJFU
      FZUGZUNZGHUHZDUIAUAUBBCDEFGHIJJLMNOPQRRUJAVJJUGZVKKUGZUNUNZWCWNGHWRVQWHWB
      WMWRVMWEVPWGWRVLWDVIWRVJJVKKIAWPWQUKZAWPWQULZUMUOWRVOWFVNWRVKKVJJIWTWSUMU
      OUPWRVTWKWAWLWRVSWJVNVIWRVRWIVJJEWRVJJVKKWSWTUQWSUMURWRVJJFWSUSUTUPVARSWO
      UIUDAWOWDWFVBWDWFJKIVCKJIVCVEWMGHWDWFVDVFVGVH $.

    $( The section relation is a relation between morphisms from ` X ` to ` Y `
       and morphisms from ` Y ` to ` X ` .  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    sectss $p |- ( ph -> ( X S Y ) C_ ( ( X H Y ) X. ( Y H X ) ) ) $=
      ( vf vg co cv wcel wa cop cfv wceq copab cxp sectfval opabssxp syl6eqss )
      AHIDTRUAZHIGTZUBSUAZIHGTZUBUCUNULHIUDHETTHFUEUFZUCRSUGUMUOUHABCDEFRSGHIJK
      LMNOPQUIUPRSUMUOUJUK $.

    $( The property " ` F ` is a section of ` G ` ".  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    issect $p |- ( ph -> ( F ( X S Y ) G <-> ( F e. ( X H Y ) /\
        G e. ( Y H X ) /\ ( G ( <. X , Y >. .x. X ) F ) = ( .1. ` X ) ) ) ) $=
      ( co vf vg wbr cv wcel wa cop cfv wceq copab sectfval breqd oveq12 ancoms
      w3a eqeq1d eqid brab2a df-3an bitr4i syl6bb ) AGHJKDTZUCGHUAUDZJKITZUEUBU
      DZKJITZUEUFVEVCJKUGJETZTZJFUHZUIZUFUAUBUJZUCZGVDUEZHVFUEZHGVGTZVIUIZUOZAV
      BVKGHABCDEFUAUBIJKLMNOPQRSUKULVLVMVNUFVPUFVQVJVPUAUBGHVDVFVKVCGUIZVEHUIZU
      FVHVOVIVSVRVHVOUIVEHVCGVGUMUNUPVKUQURVMVNVPUSUTVA $.

    issect.f $e |- ( ph -> F e. ( X H Y ) ) $.
    issect.g $e |- ( ph -> G e. ( Y H X ) ) $.
    $( Property of being a section.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    issect2 $p |- ( ph ->
      ( F ( X S Y ) G <-> ( G ( <. X , Y >. .x. X ) F ) = ( .1. ` X ) ) ) $=
      ( co wcel wa wbr cop cfv wceq wb jca w3a issect df-3an syl6bb baibd mpdan
      ) AGJKIUBUCZHKJIUBUCZUDZGHJKDUBUEZHGJKUFJEUBUBJFUGUHZUIAUQURTUAUJAUTUSVAA
      UTUQURVAUKUSVAUDABCDEFGHIJKLMNOPQRSULUQURVAUMUNUOUP $.
  $}

  ${
    sectcan.b $e |- B = ( Base ` C ) $.
    sectcan.s $e |- S = ( Sect ` C ) $.
    sectcan.c $e |- ( ph -> C e. Cat ) $.
    sectcan.x $e |- ( ph -> X e. B ) $.
    sectcan.y $e |- ( ph -> Y e. B ) $.
    sectcan.1 $e |- ( ph -> G ( X S Y ) F ) $.
    sectcan.2 $e |- ( ph -> F ( Y S X ) H ) $.
    $( If ` G ` is a section of ` F ` and ` F ` is a section of ` H ` , then
       ` G = H ` .  Proposition 3.10 of [Adamek] p. 28.  (Contributed by Mario
       Carneiro, 2-Jan-2017.) $)
    sectcan $p |- ( ph -> G = H ) $=
      ( cfv cop co eqid ccid cco chom wcel wceq wbr issect simp1d simp2d catass
      w3a mpbid simp3d oveq1d oveq2d 3eqtr3d catlid catrid ) AICUAQZQZFHIRZICUB
      QZSZSZGHUSQZHHRIVBSZSZFGAGEIHRIVBSSZFVCSGEFVAHVBSSZVFSVDVGABCVBFECUCQZGIH
      IHJVJTZVBTZLMNMAFHIVJSZUDZEIHVJSUDZVIVEUEZAFEHIDSUFVNVOVPUKOABCDVBUSFEVJH
      IJVKVLUSTZKLMNUGULZUHZAVOGVMUDZVHUTUEZAEGIHDSUFVOVTWAUKPABCDVBUSEGVJIHJVK
      VLVQKLNMUGULZUHNAVOVTWAWBUIZUJAVHUTFVCAVOVTWAWBUMUNAVIVEGVFAVNVOVPVRUMUOU
      PABCVBUSFVJHIJVKVQLMVLNVSUQABCVBUSGVJHIJVKVQLMVLNWCURUP $.
  $}

  ${
    sectco.b $e |- B = ( Base ` C ) $.
    sectco.o $e |- .x. = ( comp ` C ) $.
    sectco.s $e |- S = ( Sect ` C ) $.
    sectco.c $e |- ( ph -> C e. Cat ) $.
    sectco.x $e |- ( ph -> X e. B ) $.
    sectco.y $e |- ( ph -> Y e. B ) $.
    sectco.z $e |- ( ph -> Z e. B ) $.
    sectco.1 $e |- ( ph -> F ( X S Y ) G ) $.
    sectco.2 $e |- ( ph -> H ( Y S Z ) K ) $.
    $( Composition of two sections.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    sectco $p |- ( ph ->
     ( H ( <. X , Y >. .x. Z ) F ) ( X S Z ) ( G ( <. Z , Y >. .x. X ) K ) ) $=
      ( cop co wbr ccid cfv wceq chom eqid wcel w3a issect mpbid simp1d catcocl
      simp2d catass simp3d oveq1d catlid 3eqtr3d oveq2d 3eqtrd issect2 mpbird )
      AHFJKUBZLEUCUCZGILKUBJEUCUCZJLDUCUDVHVGJLUBZJEUCUCZJCUEUFZUFZUGAVJGIVGVIK
      EUCUCZVFJEUCZUCGFVNUCZVLABCEVGICUHUFZGJJLKMVPUIZNPQSRABCEFHVPJKLMVQNPQRSA
      FJKVPUCUJZGKJVPUCUJZVOVLUGZAFGJKDUCUDVRVSVTUKTABCDEVKFGVPJKMVQNVKUIZOPQRU
      LUMZUNZAHKLVPUCUJZILKVPUCUJZIHKLUBKEUCUCZKVKUFZUGZAHIKLDUCUDWDWEWHUKUAABC
      DEVKHIVPKLMVQNWAOPRSULUMZUNZUOZAWDWEWHWIUPZQAVRVSVTWBUPZUQAVMFGVNAWFFVFKE
      UCZUCWGFWNUCVMFAWFWGFWNAWDWEWHWIURUSABCEFHVPIKJKLMVQNPQRSWCWJRWLUQABCEVKF
      VPJKMVQWAPQNRWCUTVAVBAVRVSVTWBURVCABCDEVKVGVHVPJLMVQNWAOPQSWKABCEIGVPLKJM
      VQNPSRQWLWMUOVDVE $.
  $}

  ${
    $d c x y B $.  $d f g h x y ph $.  $d f g h x y z X $.  $d f g h x y z Y $.
    $d c x y C $.  $d c f g h z N $.  $d c x y S $.
    invfval.b $e |- B = ( Base ` C ) $.
    invfval.n $e |- N = ( Inv ` C ) $.
    invfval.c $e |- ( ph -> C e. Cat ) $.
    invfval.x $e |- ( ph -> X e. B ) $.
    invfval.y $e |- ( ph -> Y e. B ) $.
    ${
      invfval.s $e |- S = ( Sect ` C ) $.
      $( Value of the inverse relation.  (Contributed by Mario Carneiro,
         2-Jan-2017.) $)
      invffval $p |- ( ph -> N =
        ( x e. B , y e. B |-> ( ( x S y ) i^i `' ( y S x ) ) ) ) $=
        ( vc cfv cv co cbs cinv ccnv cin cmpt2 ccat wcel wceq csect fveq2 oveqd
        syl6eqr cnveqd ineq12d mpt2eq123dv df-inv cvv fvex eqeltri mpt2ex fvmpt
        syl syl5eq ) AGEUAQZBCDDBRZCRZFSZVEVDFSZUBZUCZUDZKAEUEUFVCVJUGLPEBCPRZT
        QZVLVDVEVKUHQZSZVEVDVMSZUBZUCZUDVJUEUAVKEUGZBCVLVLVQDDVIVRVLETQZDVKETUI
        JUKZVTVRVNVFVPVHVRVMFVDVEVRVMEUHQFVKEUHUIOUKZUJVRVOVGVRVMFVEVDWAUJULUMU
        NBCPUOBCDDVIDVSUPJETUQURZWBUSUTVAVB $.

      $( Value of the inverse relation.  (Contributed by Mario Carneiro,
         2-Jan-2017.) $)
      invfval $p |- ( ph -> ( X N Y ) = ( ( X S Y ) i^i `' ( Y S X ) ) ) $=
        ( vx vy cv co ccnv cin cvv wceq wa simprl simprr oveq12d cnveqd ineq12d
        invffval wcel ovex inex1 a1i ovmpt2d ) ANOFGBBNPZOPZDQZUOUNDQZRZSFGDQZG
        FDQZRZSZETANOBCDEFFHIJKKMUHAUNFUAZUOGUAZUBUBZUPUSURVAVEUNFUOGDAVCVDUCZA
        VCVDUDZUEVEUQUTVEUOGUNFDVGVFUEUFUGKLVBTUIAUSVAFGDUJUKULUM $.

      $( Value of the inverse relation.  (Contributed by Mario Carneiro,
         2-Jan-2017.) $)
      isinv $p |- ( ph ->
        ( F ( X N Y ) G <-> ( F ( X S Y ) G /\ G ( Y S X ) F ) ) ) $=
        ( co wbr wa cfv eqid ccnv cin invfval breqd brin syl6bb wrel wb cxp wss
        chom cco ccid sectss relxp relss ee10 relbrcnvg syl anbi2d bitrd ) AEFH
        IGPZQZEFHIDPZQZEFIHDPZUAZQZRZVEFEVFQZRAVCEFVDVGUBZQVIAVBVKEFABCDGHIJKLM
        NOUCUDEFVDVGUEUFAVHVJVEAVFUGZVHVJUHAVFIHCUKSZPZHIVMPZUIZUJVPUGVLABCDCUL
        SZCUMSZVMIHJVMTVQTVRTOLNMUNVNVOUOVFVPUPUQEFVFURUSUTVA $.
    $}

    ${
      invss.h $e |- H = ( Hom ` C ) $.
      $( The inverse relation is a relation between morphisms ` F : X --> Y `
         and their inverses ` G : Y --> X ` .  (Contributed by Mario Carneiro,
         2-Jan-2017.) $)
      invss $p |- ( ph -> ( X N Y ) C_ ( ( X H Y ) X. ( Y H X ) ) ) $=
        ( co csect cfv cxp ccnv cin eqid invfval inss1 syl6eqss cco ccid sectss
        sstrd ) AFGENZFGCOPZNZFGDNGFDNQAUHUJGFUINRZSUJABCUIEFGHIJKLUITZUAUJUKUB
        UCABCUICUDPZCUEPZDFGHMUMTUNTULJKLUFUG $.
    $}

    $( The inverse relation is symmetric.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    invsym $p |- ( ph -> ( F ( X N Y ) G <-> G ( Y N X ) F ) ) $=
      ( co wbr csect cfv wa eqid isinv ancom syl6bb bitr4d ) ADEGHFNOZEDHGCPQZN
      OZDEGHUENOZRZEDHGFNOAUDUGUFRUHABCUEDEFGHIJKLMUESZTUGUFUAUBABCUEEDFHGIJKML
      UITUC $.

    $( The inverse relation is symmetric.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    invsym2 $p |- ( ph -> `' ( X N Y ) = ( Y N X ) ) $=
      ( vg vf co wrel cv wbr wcel vex df-br ccnv wa wceq chom cfv cxp wss invss
      eqid relxp relss ee10 relcnv jctil invsym brcnv 3bitr3g eqrelrdv2 mpancom
      cop bitr3i ) EFDNZUAZOZFEDNZOZUBAVCVEUCAVFVDAVEFECUDUEZNZEFVGNZUFZUGVJOVF
      ABCVGDFEGHIKJVGUIUHVHVIUJVEVJUKULVBUMUNALMVCVEAMPZLPZVBQZVLVKVEQVLVKUTZVC
      RZVNVERABCVKVLDEFGHIJKUOVMVLVKVCQVOVLVKVBLSMSUPVLVKVCTVAVLVKVETUQURUS $.

    $( The inverse relation is a function, which is to say that every morphism
       has at most one inverse.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    invfun $p |- ( ph -> Fun ( X N Y ) ) $=
      ( vf vg vh co cv wbr wal wcel adantr wrel wa weq wi wfun chom cfv cxp wss
      eqid invss relxp relss ee10 csect isinv simplbda adantrr simprbda adantrl
      ccat sectcan ex alrimiv alrimivv dffun2 sylanbrc ) AEFDOZUAZLPZMPZVHQZVJN
      PZVHQZUBZMNUCZUDZNRZMRLRVHUEAVHEFCUFUGZOZFEVSOZUHZUIWBUAVIABCVSDEFGHIJKVS
      UJUKVTWAULVHWBUMUNAVRLMAVQNAVOVPAVOUBBCCUOUGZVJVKVMFEGWCUJZACVASVOITAFBSV
      OKTAEBSVOJTAVLVKVJFEWCOZQZVNAVLVJVKEFWCOZQWFABCWCVJVKDEFGHIJKWDUPUQURAVNV
      JVMWGQZVLAVNWHVMVJWEQABCWCVJVMDEFGHIJKWDUPUSUTVBVCVDVELMNVHVFVG $.

    isoval.n $e |- I = ( Iso ` C ) $.
    $( The inverse relation is a function, which is to say that every morphism
       has at most one inverse.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    isoval $p |- ( ph -> ( X I Y ) = dom ( X N Y ) ) $=
      ( vz vx vy co cvv cfv wcel vc cmpt ccom ciso ccat wceq cinv fveq2 syl6eqr
      cv cdm coeq2d df-iso wfun funmpt fvex eqeltri cofunexg mp2an fvmpt syl5eq
      syl oveqd cop cxp wfn csect ccnv cin cmpt2 eqid ovex inex1 fnmpt2i fneq1d
      invffval mpbiri opelxpi syl2anc fvco2 df-ov dmeq dmex ax-mp fveq2i eqtr3i
      3eqtr4g eqtrd ) AFGDQFGNRNUJZUKZUBZEUCZQZFGEQZUKZADWLFGADCUDSZWLMACUETWPW
      LUFJUACWKUAUJZUGSZUCWLUEUDWQCUFZWREWKWSWRCUGSZEWQCUGUHIUIULNUAUMWKUNERTWL
      RTNRWJUOEWTRICUGUPUQWKERURUSUTVBVAVCAFGVDZWLSZXAESZWKSZWMWOAEBBVEZVFZXAXE
      TZXBXDUFAXFOPBBOUJZPUJZCVGSZQZXIXHXJQVHZVIZVJZXEVFOPBBXMXNXNVKXKXLXHXIXJV
      LVMVNAXEEXNAOPBCXJEFGHIJKLXJVKVPVOVQAFBTGBTXGKLFGBBVRVSXEWKEXAVTVSFGWLWAW
      NWKSZWOXDWNRTXOWOUFFGEVLZNWNWJWORWKWIWNWBWKVKWNXPWCUTWDWNXCWKFGEWAWEWFWGW
      H $.

    ${
      inviso1.1 $e |- ( ph -> F ( X N Y ) G ) $.
      $( If ` G ` is an inverse to ` F ` , then ` F ` is an isomorphism.
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      inviso1 $p |- ( ph -> F e. ( X I Y ) ) $=
        ( co cdm wrel wbr wcel wfun invfun funrel syl releldm syl2anc eleqtrrd
        isoval ) ADHIGQZRZHIFQAUJSZDEUJTDUKUAAUJUBULABCGHIJKLMNUCUJUDUEPDEUJUFU
        GABCFGHIJKLMNOUIUH $.

      $( If ` G ` is an inverse to ` F ` , then ` G ` is an isomorphism.
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      inviso2 $p |- ( ph -> G e. ( Y I X ) ) $=
        ( co wbr invsym mpbid inviso1 ) ABCEDFGIHJKLNMOADEHIGQREDIHGQRPABCDEGHI
        JKLMNSTUA $.
    $}

    $( The inverse relation is a function from isomorphisms to isomorphisms.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    invf $p |- ( ph -> ( X N Y ) : ( X I Y ) --> ( Y I X ) ) $=
      ( co wfn crn wss wf cdm isoval wfun invfun funfn sylib fneq2d mpbird wceq
      ccnv df-rn invsym2 dmeqd eqtr4d syl5eq eqimss syl df-f sylanbrc ) AFGENZF
      GDNZOZURPZGFDNZQZUSVBURRAUTURURSZOZAURUAVEABCEFGHIJKLUBURUCUDAUSVDURABCDE
      FGHIJKLMTUEUFAVAVBUGVCAVAURUHZSZVBURUIAVGGFENZSVBAVFVHABCEFGHIJKLUJUKABCD
      EGFHIJLKMTULUMVAVBUNUOUSVBURUPUQ $.

    $( The inverse relation is a bijection from isomorphisms to isomorphisms.
       (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    invf1o $p |- ( ph -> ( X N Y ) : ( X I Y ) -1-1-onto-> ( Y I X ) ) $=
      ( co wfn ccnv wf invf ffn syl wf1o invsym2 fneq1d mpbird dff1o4 sylanbrc
      ) AFGENZFGDNZOZUGPZGFDNZOZUHUKUGUAAUHUKUGQUIABCDEFGHIJKLMRUHUKUGSTAULGFEN
      ZUKOZAUKUHUMQUNABCDEGFHIJLKMRUKUHUMSTAUKUJUMABCEFGHIJKLUBUCUDUHUKUGUEUF
      $.

    invinv.f $e |- ( ph -> F e. ( X I Y ) ) $.
    $( The inverse of the inverse of an isomorphism is itself.  Proposition
       3.14(1) of [Adamek] p. 29.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    invinv $p |- ( ph -> ( ( Y N X ) ` ( ( X N Y ) ` F ) ) = F ) $=
      ( co cfv ccnv invsym2 fveq1d wf1o wcel invf1o f1ocnvfv1 syl2anc eqtr3d
      wceq ) ADGHFPZQZUHRZQZUIHGFPZQDAUIUJULABCFGHIJKLMSTAGHEPZHGEPZUHUADUMUBUK
      DUGABCEFGHIJKLMNUCOUMUNDUHUDUEUF $.

    invco.o $e |- .x. = ( comp ` C ) $.
    invco.z $e |- ( ph -> Z e. B ) $.
    invco.f $e |- ( ph -> G e. ( Y I Z ) ) $.
    $( The composition of two isomorphisms is an isomorphism, and the inverse
       is the composition of the individual inverses.  Proposition 3.14(2) of
       [Adamek] p. 29.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    invco $p |- ( ph -> ( G ( <. X , Y >. .x. Z ) F ) ( X N Z )
      ( ( ( X N Y ) ` F ) ( <. Z , Y >. .x. X ) ( ( Y N Z ) ` G ) ) ) $=
      ( cop co cfv wbr csect eqid wa cdm wcel isoval eleqtrd wb invfun funfvbrb
      wfun syl mpbid isinv simpld sectco simprd mpbir2and ) AFEIJUBKDUCUCZEIJHU
      CZUDZFJKHUCZUDZKJUBIDUCUCZIKHUCUEVDVIIKCUFUDZUCUEVIVDKIVJUCUEABCVJDEVFFVH
      IJKLSVJUGZNOPTAEVFIJVJUCUEZVFEJIVJUCUEZAEVFVEUEZVLVMUHAEVEUIZUJZVNAEIJGUC
      VORABCGHIJLMNOPQUKULAVEUPVPVNUMABCHIJLMNOPUNEVEUOUQURABCVJEVFHIJLMNOPVKUS
      URZUTAFVHJKVJUCUEZVHFKJVJUCUEZAFVHVGUEZVRVSUHAFVGUIZUJZVTAFJKGUCWAUAABCGH
      JKLMNPTQUKULAVGUPWBVTUMABCHJKLMNPTUNFVGUOUQURABCVJFVHHJKLMNPTVKUSURZUTVAA
      BCVJDVHFVFEKJILSVKNTPOAVRVSWCVBAVLVMVQVBVAABCVJVDVIHIKLMNOTVKUSVC $.
  $}

  ${
    isohom.b $e |- B = ( Base ` C ) $.
    isohom.h $e |- H = ( Hom ` C ) $.
    isohom.i $e |- I = ( Iso ` C ) $.
    isohom.c $e |- ( ph -> C e. Cat ) $.
    isohom.x $e |- ( ph -> X e. B ) $.
    isohom.y $e |- ( ph -> Y e. B ) $.
    $( An isomorphism is a homomorphism.  (Contributed by Mario Carneiro,
       27-Jan-2017.) $)
    isohom $p |- ( ph -> ( X I Y ) C_ ( X H Y ) ) $=
      ( co cxp cdm cinv cfv eqid wss isoval invss dmss eqsstrd dmxpss syl6ss
      syl ) AFGENZFGDNZGFDNZOZPZUIAUHFGCQRZNZPZULABCEUMFGHUMSZKLMJUAAUNUKTUOULT
      ABCDUMFGHUPKLMIUBUNUKUCUGUDUIUJUEUF $.
  $}

  ${
    isoco.b $e |- B = ( Base ` C ) $.
    isoco.o $e |- .x. = ( comp ` C ) $.
    isoco.n $e |- I = ( Iso ` C ) $.
    isoco.c $e |- ( ph -> C e. Cat ) $.
    isoco.x $e |- ( ph -> X e. B ) $.
    isoco.y $e |- ( ph -> Y e. B ) $.
    isoco.z $e |- ( ph -> Z e. B ) $.
    isoco.f $e |- ( ph -> F e. ( X I Y ) ) $.
    isoco.g $e |- ( ph -> G e. ( Y I Z ) ) $.
    $( The composition of two isomorphisms is an isomorphism.  Proposition
       3.14(2) of [Adamek] p. 29.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    isoco $p |- ( ph -> ( G ( <. X , Y >. .x. Z ) F ) e. ( X I Z ) ) $=
      ( co cop cinv cfv eqid invco inviso1 ) ABCFEHIUAJDTTEHICUBUCZTUCFIJUGTUCJ
      IUAHDTTGUGHJKUGUDZNOQMABCDEFGUGHIJKUHNOPMRLQSUEUF $.
  $}

  ${
    $d f g ph $.  $d f g S $.  $d f g T $.  $d f g X $.  $d f g Y $.
    oppcsect.b $e |- B = ( Base ` C ) $.
    oppcsect.o $e |- O = ( oppCat ` C ) $.
    oppcsect.c $e |- ( ph -> C e. Cat ) $.
    oppcsect.x $e |- ( ph -> X e. B ) $.
    oppcsect.y $e |- ( ph -> Y e. B ) $.
    ${
      oppcsect.s $e |- S = ( Sect ` C ) $.
      oppcsect.t $e |- T = ( Sect ` O ) $.
      $( A section in the opposite category.  (Contributed by Mario Carneiro,
         3-Jan-2017.) $)
      oppcsect $p |- ( ph -> ( F ( X T Y ) G <-> G ( X S Y ) F ) ) $=
        ( cfv co wcel chom cop cco ccid wceq w3a wbr wa eqid adantr oppcco ccat
        oppcid syl fveq1d eqeq12d pm5.32da df-3an oppchom eleq2i anbi12ci bitri
        anbi1i 3bitr4g oppcbas oppccat issect 3bitr4d ) AFIJHUARZSZTZGJIVISZTZG
        FIJUBZIHUCRZSSZIHUDRZRZUEZUFZGIJCUARZSZTZFJIWASZTZFGVNICUCRZSSZICUDRZRZ
        UEZUFZFGIJESUGGFIJDSUGAWCWEUHZVSUHZWLWJUHVTWKAWLVSWJAWLUHZVPWGVRWIWNBCW
        FFGHIJIKWFUIZLAIBTWLNUJZAJBTWLOUJWPUKWNIVQWHWNCULTZVQWHUEAWQWLMUJWHCHLW
        HUIZUMUNUOUPUQVTVKVMUHZVSUHWMVKVMVSURWSWLVSVKWEVMWCVJWDFCWAHIJWAUIZLUSU
        TVLWBGCWAHJIWTLUSUTVAVCVBWCWEWJURVDABHEVOVQFGVIIJBCHLKVEVIUIVOUIVQUIQAW
        QHULTMCHLVFUNNOVGABCDWFWHGFWAIJKWTWOWRPMNOVGVH $.

      $( A section in the opposite category.  (Contributed by Mario Carneiro,
         3-Jan-2017.) $)
      oppcsect2 $p |- ( ph -> ( X T Y ) = `' ( X S Y ) ) $=
        ( vf vg co cfv wrel ccnv chom cxp wss cco ccid oppcbas eqid oppccat syl
        ccat wcel sectss relxp relss ee10 relcnv a1i wbr oppcsect brcnv syl6bbr
        cv vex eqbrrdv ) APQGHERZGHDRZUAZAVFGHFUBSZRZHGVIRZUCZUDVLTVFTABFEFUESZ
        FUFSZVIGHBCFJIUGVIUHVMUHVNUHOACUKULFUKULKCFJUIUJLMUMVJVKUNVFVLUOUPVHTAV
        GUQURAPVCZQVCZVFUSVPVOVGUSVOVPVHUSABCDEVOVPFGHIJKLMNOUTVOVPVGPVDQVDVAVB
        VE $.
    $}

    ${
      oppcinv.s $e |- I = ( Inv ` C ) $.
      oppcinv.t $e |- J = ( Inv ` O ) $.
      $( An inverse in the opposite category.  (Contributed by Mario Carneiro,
         3-Jan-2017.) $)
      oppcinv $p |- ( ph -> ( X J Y ) = ( Y I X ) ) $=
        ( cfv co ccnv cin eqid csect incom oppcsect2 wrel wceq chom cxp wss cco
        cnveqd ccid sectss relxp relss ee10 dfrel2 sylib ineq12d syl5eq oppcbas
        eqtrd ccat wcel oppccat syl invfval 3eqtr4d ) AGHFUAPZQZHGVHQZRZSZHGCUA
        PZQZGHVMQRZSZGHEQHGDQAVLVKVISVPVIVKUBAVKVNVIVOAVKVNRZRZVNAVJVQABCVMVHFH
        GIJKMLVMTZVHTZUCUJAVNUDZVRVNUEAVNHGCUFPZQZGHWBQZUGZUHWEUDWAABCVMCUIPZCU
        KPZWBHGIWBTWFTWGTVSKMLULWCWDUMVNWEUNUOVNUPUQVAABCVMVHFGHIJKLMVSVTUCURUS
        ABFVHEGHBCFJIUTOACVBVCFVBVCKCFJVDVELMVTVFABCVMDHGINKMLVSVFVG $.
    $}

    ${
      oppciso.s $e |- I = ( Iso ` C ) $.
      oppciso.t $e |- J = ( Iso ` O ) $.
      $( An isomorphism in the opposite category.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      oppciso $p |- ( ph -> ( X J Y ) = ( Y I X ) ) $=
        ( cinv cfv co cdm eqid oppcinv oppcbas ccat wcel oppccat isoval 3eqtr4d
        dmeqd syl ) AGHFPQZRZSHGCPQZRZSGHERHGDRAUKUMABCULUJFGHIJKLMULTZUJTZUAUH
        ABFEUJGHBCFJIUBUOACUCUDFUCUDKCFJUEUILMOUFABCDULHGIUNKMLNUFUG $.
    $}
  $}

  ${
    $d g h x B $.  $d g h x C $.  $d g h x F $.  $d g h x ph $.  $d g h x X $.
    $d g h x Y $.
    sectmon.b $e |- B = ( Base ` C ) $.
    sectmon.m $e |- M = ( Mono ` C ) $.
    sectmon.s $e |- S = ( Sect ` C ) $.
    sectmon.c $e |- ( ph -> C e. Cat ) $.
    sectmon.x $e |- ( ph -> X e. B ) $.
    sectmon.y $e |- ( ph -> Y e. B ) $.
    ${
      sectmon.1 $e |- ( ph -> F ( X S Y ) G ) $.
      $( If ` F ` is a section of ` G ` , then ` F ` is a monomorphism.  A
         monomorphism that arises from a section is also known as a _split
         monomorphism_.  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      sectmon $p |- ( ph -> F e. ( X M Y ) ) $=
        ( vg co wcel ad2antrr vx vh chom cfv cv cop cco wceq wral ccid wbr eqid
        wi issect mpbid simp1d wa oveq2 simp3d oveq1d ccat simplr simprl simp2d
        catass catlid 3eqtr3d simprr eqeq12d syl5ib ralrimivva ralrimiva ismon2
        w3a mpbir2and ) AEHIGRSEHICUCUDZRSZEQUEZUAUEZHUFZICUGUDZRZRZEUBUEZWBRZU
        HZVRWDUHZUMZUBVSHVPRZUIQWIUIZUABUIAVQFIHVPRSZFEHIUFHWARRZHCUJUDZUDZUHZA
        EFHIDRUKVQWKWOVNPABCDWAWMEFVPHIJVPULZWAULZWMULZLMNOUNUOZUPZAWJUABAVSBSZ
        UQZWHQUBWIWIWFFWCVSIUFHWARZRZFWEXCRZUHXBVRWISZWDWISZUQZUQZWGWCWEFXCURXI
        XDVRXEWDXIWLVRVTHWARZRWNVRXJRXDVRXIWLWNVRXJAWOXAXHAVQWKWOWSUSTZUTXIBCWA
        VREVPFHVSHIJWPWQACVASXAXHMTZAXAXHVBZAHBSXAXHNTZAIBSXAXHOTZXBXFXGVCZAVQX
        AXHWTTZXNAWKXAXHAVQWKWOWSVDTZVEXIBCWAWMVRVPVSHJWPWRXLXMWQXNXPVFVGXIWLWD
        XJRWNWDXJRXEWDXIWLWNWDXJXKUTXIBCWAWDEVPFHVSHIJWPWQXLXMXNXOXBXFXGVHZXQXN
        XRVEXIBCWAWMWDVPVSHJWPWRXLXMWQXNXSVFVGVIVJVKVLAUABCWAQUBEVPGHIJWPWQKMNO
        VMVO $.
    $}

    monsect.n $e |- N = ( Inv ` C ) $.
    monsect.1 $e |- ( ph -> F e. ( X M Y ) ) $.
    monsect.2 $e |- ( ph -> G ( Y S X ) F ) $.
    $( If ` F ` is a monomorphism and ` G ` is a section of ` F ` , then ` G `
       is an inverse of ` F ` and they are both isomorphisms.  This is also
       stated as "a monomorphism which is also a split epimorphism is an
       isomorphism".  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    monsect $p |- ( ph -> F ( X N Y ) G ) $=
      ( co wbr cop cco cfv ccid wceq chom wcel eqid issect simp3d oveq1d simp2d
      w3a mpbid simp1d catass catlid catrid eqtr4d 3eqtr3d catcocl catidcl moni
      issect2 mpbird isinv mpbir2and ) AEFIJHTUAEFIJDTUAZFEJIDTUAZAVIFEIJUBZICU
      CUDZTTZICUEUDZUDZUFZAEVMIIUBJVLTZTZEVOVQTZUFVPAEFJIUBJVLTTZEVKJVLTZTJVNUD
      ZEWATZVRVSAVTWBEWAAFJICUGUDZTUHZEIJWDTUHZVTWBUFZAVJWEWFWGUNSABCDVLVNFEWDJ
      IKWDUIZVLUIZVNUIZMNPOUJUOZUKULABCVLEFWDEJIJIKWHWINOPOAWEWFWGWKUMZAWEWFWGW
      KUPZPWLUQAWCEVSABCVLVNEWDIJKWHWJNOWIPWLURABCVLVNEWDIJKWHWJNOWIPWLUSUTVAAB
      CVLEVMWDVOGIJIKWHWILNOPORABCVLEFWDIJIKWHWINOPOWLWMVBABCVNWDIKWHWJNOVCVDUO
      ABCDVLVNEFWDIJKWHWIWJMNOPWLWMVEVFSABCDEFHIJKQNOPMVGVH $.
  $}

  ${
    sectepi.b $e |- B = ( Base ` C ) $.
    sectepi.e $e |- E = ( Epi ` C ) $.
    sectepi.s $e |- S = ( Sect ` C ) $.
    sectepi.c $e |- ( ph -> C e. Cat ) $.
    sectepi.x $e |- ( ph -> X e. B ) $.
    sectepi.y $e |- ( ph -> Y e. B ) $.
    ${
      sectepi.1 $e |- ( ph -> F ( X S Y ) G ) $.
      $( If ` F ` is a section of ` G ` , then ` G ` is an epimorphism.  An
         epimorphism that arises from a section is also known as a _split
         epimorphism_.  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      sectepi $p |- ( ph -> G e. ( Y E X ) ) $=
        ( cfv co eqid ccat coppc cmon csect oppcbas wcel oppccat syl wbr mpbird
        oppcsect sectmon oppcmon eleqtrd ) AGHICUAQZUBQZRIHERABUNUNUCQZGFUOHIBC
        UNUNSZJUDUOSZUPSZACTUEUNTUEMCUNUQUFUGNOAGFHIUPRUHFGHIDRUHPABCDUPGFUNHIJ
        UQMNOLUSUJUIUKACEUOUNHIUQMURKULUM $.
    $}

    episect.n $e |- N = ( Inv ` C ) $.
    episect.1 $e |- ( ph -> F e. ( X E Y ) ) $.
    episect.2 $e |- ( ph -> F ( X S Y ) G ) $.
    $( If ` F ` is an epimorphism and ` F ` is a section of ` G ` , then ` G `
       is an inverse of ` F ` and they are both isomorphisms.  This is also
       stated as "an epimorphism which is also a split monomorphism is an
       isomorphism".  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    episect $p |- ( ph -> F ( X N Y ) G ) $=
      ( co coppc cfv cinv wbr csect cmon eqid oppcbas ccat wcel oppccat oppcmon
      syl eleqtrrd oppcsect mpbird monsect oppcinv breqd mpbid ) AFGJICUAUBZUCU
      BZTZUDFGIJHTZUDABVAVAUEUBZFGVAUFUBZVBJIBCVAVAUGZKUHVFUGZVEUGZACUIUJVAUIUJ
      NCVAVGUKUMPOVBUGZAFIJETJIVFTRACEVFVAJIVGNVHLULUNAGFIJVETUDFGIJDTUDSABCDVE
      GFVAIJKVGNOPMVIUOUPUQAVCVDFGABCHVBVAJIKVGNPOQVJURUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Subcategories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c C_cat $.
  $c |`cat $.
  $c Subcat $.

  $( Extend class notation to include the subset relation for subcategories. $)
  cssc $a class C_cat $.

  $( Extend class notation to include category restriction (which is like
     structure restriction but also allows limiting the collection of
     morphisms). $)
  cresc $a class |`cat $.

  $( Extend class notation to include the collection of subcategories of a
     category. $)
  csubc $a class Subcat $.

  ${
    $d c f g h j s t x y z $.  $d h j s t x H $.  $d h j s t x J $.
    $( Define the subset relation for subcategories.  Despite the name, this is
       not really a "category-aware" definition, which is to say it makes no
       explicit references to homsets or composition; instead this is a
       subset-like relation on the functions that are used as subcategory
       specifications in ~ df-subc , which makes it play an analogous role to
       the subset relation applied to the subgroups of a group.  (Contributed
       by Mario Carneiro, 6-Jan-2017.) $)
    df-ssc $a |- C_cat = { <. h , j >. | E. t ( j Fn ( t X. t ) /\
      E. s e. ~P t h e. X_ x e. ( s X. s ) ~P ( j ` x ) ) } $.

    $( Define the restriction of a category to a given set of arrows.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    df-resc $a |- |`cat = ( c e. _V , h e. _V |->
      ( ( c |`s dom dom h ) sSet <. ( Hom ` ndx ) , h >. ) ) $.

    $( ` ( Subcat `` C ) ` is the set of all the subcategory specifications of
       the category ` C ` .  Like ~ df-subg , this is not actually a collection
       of categories, but only sets which when given operations from the base
       category (using ~ df-resc ) form a category.  All the objects and all
       the morphisms of the subcategory belong to the supercategory.  The
       identity of an object, the domain and the codomain of a morphism are the
       same in the subcategory and the supercategory.  The composition of the
       subcategory is a restriction of the composition of the supercategory.
       (Contributed by FL, 17-Sep-2009.)  (Revised by Mario Carneiro,
       4-Jan-2017.) $)
    df-subc $a |- Subcat = ( c e. Cat |-> { h | ( h C_cat ( Homf ` c ) /\
      [. dom dom h / s ]. A. x e. s ( ( ( Id ` c ) ` x ) e. ( x h x ) /\
        A. y e. s A. z e. s A. f e. ( x h y ) A. g e. ( y h z )
          ( g ( <. x , y >. ( comp ` c ) z ) f ) e. ( x h z ) ) ) } ) $.

    $( The subcategory subset relation is a relation.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    sscrel $p |- Rel C_cat $=
      ( vj vt vh vx vs cv cxp wfn cfv cpw cixp wcel wrex wa wex df-ssc relopabi
      cssc ) AFZBFZTGHCFDEFZUAGDFSIJKLETJMNBOCARDBCAEPQ $.

    $( The subcategory subset relation is a relation.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    brssc $p |- ( H C_cat J <-> E. t ( J Fn ( t X. t ) /\
        E. s e. ~P t H e. X_ x e. ( s X. s ) ~P ( J ` x ) ) ) $=
      ( vj vh cssc cvv wcel wa cv cxp wfn cfv cpw cixp wrex wex wceq wbr sscrel
      wrel brrelex12 mpan xpex fnex mpan2 elex rexlimivw anim12ci exlimiv simpr
      fneq1d simpl fveq1d ixpeq2dv eleq12d rexbidv anbi12d exbidv df-ssc brabga
      vex pweqd pm5.21nii ) CDHUAZCIJZDIJZKZDBLZVKMZNZCAELZVNMZALZDOZPZQZJZEVKP
      ZRZKZBSZHUCVGVJUBCDHUDUEWCVJBVMVIWBVHVMVLIJVIVKVKBVDZWEUFVLIDUGUHVTVHEWAC
      VSUIUJUKULFLZVLNZGLZAVOVPWFOZPZQZJZEWARZKZBSWDGFCDHIIWHCTZWFDTZKZWNWCBWQW
      GVMWMWBWQVLWFDWOWPUMZUNWQWLVTEWAWQWHCWKVSWOWPUOWQAVOWJVRWQWIVQWQVPWFDWRUP
      VEUQURUSUTVAABGFEVBVCVF $.

    $( An analogue of ~ pwex for the subcategory subset relation:  The
       collection of subcategory subsets of a given set ` J ` is a set.
       (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    sscpwex $p |- { h | h C_cat J } e. _V $=
      ( vt vx vs cv cssc wbr cab crn cuni cpw cpm cxp cixp wcel wa cvv wss vex
      cdm co ovex wfn cfv wrex wex brssc wf simpl xpex fnex sylancl rnexg pwexg
      uniexg 4syl wceq fndm adantr syl6eqel ss2ixp fvssunirn mpbi simprr sseldi
      sspwb mprg elixpconst sylib elpwi ad2antrl xpss12 syl2anc sseqtr4d elpm2r
      a1i syl22anc rexlimdvaa imp exlimiv sylbi abssi ssexi ) AFZBGHZAIBJZKZLZB
      UAZMUBZWIWJMUCWFAWKWFBCFZWLNZUDZWEDEFZWONZDFZBUEZLZOZPZEWLLZUFZQZCUGWEWKP
      ZDCWEBEUHXDXECWNXCXEWNXAXEEXBWNWOXBPZXAQZQZWIRPZWJRPWPWIWEUIZWPWJSXEXHBRP
      ZWGRPWHRPXIXHWNWMRPXKWNXGUJWLWLCTZXLUKZWMRBULUMBRUNWGRUPWHRUOUQXHWJWMRWNW
      JWMURXGWMBUSUTZXMVAXHWEDWPWIOZPXJXHWTXOWEWSWISZWTXOSDWPDWPWSWIVBXPWQWPPWR
      WHSXPBWQVCWRWHVGVDVQVHWNXFXAVEVFDWPWIWEATVIVJXHWPWMWJXHWOWLSZXQWPWMSXFXQW
      NXAWOWLVKVLZXRWOWLWOWLVMVNXNVOWIWJWPWERRVPVRVSVTWAWBWCWD $.

    $( Reverse closure for the subcategory predicate.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    subcrcl $p |- ( H e. ( Subcat ` C ) -> C e. Cat ) $=
      ( vc vh vx vg vf vy vz vs csubc cfv wcel cdm ccat cv chomf co wral wa wbr
      cssc ccid cop cco wsbc cab df-subc dmmptss elfvdm sseldi ) BAKLMKNOACODPZ
      CPZQLUBUAEPZUMUCLLUNUNULRMFPGPUNHPZUDIPZUMUELRRUNUPULRMFUOUPULRSGUNUOULRS
      IJPZSHUQSTEUQSJULNNUFTDUGKEHIGFDJCUHUIBAKUJUK $.
  $}

  ${
    $d s t x y H $.  $d s t x y J $.  $d s t ph $.  $d s t S $.  $d t T $.
    sscfn1.1 $e |- ( ph -> H C_cat J ) $.
    ${
      sscfn1.2 $e |- ( ph -> S = dom dom H ) $.
      $( The subcategory subset relation is defined on functions with square
         domain.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
      sscfn1 $p |- ( ph -> H Fn ( S X. S ) ) $=
        ( vt vx vs cv cxp wfn cfv cpw cixp wcel wrex wa cdm wceq wex cssc brssc
        sylib ixpfn simpr adantr fndm adantl dmeqd dmxpid syl6eq eqtr2d xpeq12d
        wbr fneq2d mpbid ex syl5 rexlimdvw adantld exlimdv mpd ) ADGJZVDKLZCHIJ
        ZVFKZHJDMNZOPZIVDNZQZRZGUAZCBBKZLZACDUBUOVMEHGCDIUCUDAVLVOGAVKVOVEAVIVO
        IVJVICVGLZAVOHVGVHCUEAVPVOAVPRZVPVOAVPUFVQVGVNCVQVFBVFBVQBCSZSZVFABVSTV
        PFUGVQVSVGSVFVQVRVGVPVRVGTAVGCUHUIUJVFUKULUMZVTUNUPUQURUSUTVAVBVC $.
    $}

    ${
      sscfn2.2 $e |- ( ph -> T = dom dom J ) $.
      $( The subcategory subset relation is defined on functions with square
         domain.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
      sscfn2 $p |- ( ph -> J Fn ( T X. T ) ) $=
        ( vt vx vy cv cxp wfn cfv cpw cixp wcel wrex wa cdm wceq wex cssc brssc
        wbr sylib simpr adantr adantl dmeqd dmxpid syl6eq eqtr2d xpeq12d fneq2d
        fndm mpbid ex adantrd exlimdv mpd ) ADGJZVAKZLZCHIJZVDKHJDMNOPIVANQZRZG
        UAZDBBKZLZACDUBUDVGEHGCDIUCUEAVFVIGAVCVIVEAVCVIAVCRZVCVIAVCUFVJVBVHDVJV
        ABVABVJBDSZSZVAABVLTVCFUGVJVLVBSVAVJVKVBVCVKVBTAVBDUOUHUIVAUJUKULZVMUMU
        NUPUQURUSUT $.
    $}
  $}

  ${
    $d s t x y z H $.  $d s t x y z J $.  $d s t ph $.  $d s x y z S $.
    $d s t T $.
    isssc.1 $e |- ( ph -> H Fn ( S X. S ) ) $.
    $( Lemma for ~ ssc1 and similar theorems.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    ssclem $p |- ( ph -> ( H e. _V <-> S e. _V ) ) $=
      ( cvv wcel cxp cdm dmxpid wceq wfn fndm syl adantr dmexg adantl syl5eqelr
      wa eqeltrrd xpexg anidms fnex syl2an impbida ) ACEFZBEFZAUERZBBBGZHZEBIUG
      UHEFZUIEFUGCHZUHEAUKUHJZUEACUHKZULDUHCLMNUEUKEFACEOPSUHEOMQAUMUJUEUFDUFUJ
      BBEETUAUHECUBUCUD $.

    isssc.2 $e |- ( ph -> J Fn ( T X. T ) ) $.
    ${
      isssc.3 $e |- ( ph -> T e. V ) $.
      $( Value of the subcategory subset relation when the arguments are known
         functions.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
      isssc $p |- ( ph -> ( H C_cat J <-> ( S C_ T /\
        A. x e. S A. y e. S ( x H y ) C_ ( x J y ) ) ) ) $=
        ( vz vs vt cv wcel wceq wa wex cdm cssc wbr cxp cfv cpw cixp wss co wfn
        wrex wral brssc fndm adantl adantr syl eqtr3d dmxpid 3eqtr3g ex xpeq12d
        dmeqd id fneq2d syl5ibrcom impbid anbi1d exbidv syl5bb wb pweq ceqsexgv
        rexeqdv bitrd df-rex cvv w3a 3anass elixp2 vex xpex fnex mpan2 pm4.71ri
        3bitr4i anbi2d an12 syl6bb wi exsimpl isset sylibr ssexg expcom adantrd
        a1i elpw sseq1 raleqdv fvex fveq2 df-ov syl6eqr sseq12d ralxp pm5.21ndd
        cop anbi12d 3bitrd ) AFGUAUBZFLMOZXKUCZLOZGUDZUEZUFPZMEUEZUJZXKDQZXKXQP
        ZXMFUDZXOPZLXLUKZRZRZMSZDEUGZBOZCOZFUHZYHYIGUHZUGZCDUKBDUKZRZAXJNOZEQZX
        PMYOUEZUJZRZNSZXRXJGYOYOUCZUIZYRRZNSAYTLNFGMULAUUCYSNAUUBYPYRAUUBYPAUUB
        YPAUUBRZUUATEEUCZTYOEUUDUUAUUEUUDGTZUUAUUEUUBUUFUUAQAUUAGUMUNUUDGUUEUIZ
        UUFUUEQAUUGUUBJUOUUEGUMUPUQVBYOUREURUSUTAUUBYPUUGJYPUUAUUEGYPYOEYOEYPVC
        ZUUHVAVDVEVFVGVHVIAEHPZYTXRVJKYRXRNEHYPXPMYQXQYOEVKVMVLUPVNXRXTXPRZMSAY
        FXPMXQVOAUUJYEMAUUJXTXSYCRZRYEAXPUUKXTXPFXLUIZYCRZAUUKFVPPZUULYCVQUUNUU
        MRXPUUMUUNUULYCVRLXLXOFVSUUMUUNUULUUNYCUULXLVPPUUNXKXKMVTZUUOWAXLVPFWBW
        CUOWDWEAUULXSYCAUULXSAUULXSAUULRZXLTDDUCZTXKDUUPXLUUQUUPFTZXLUUQUULUURX
        LQAXLFUMUNUUPFUUQUIZUURUUQQAUUSUULIUOUUQFUMUPUQVBXKURDURUSUTAUULXSUUSIX
        SXLUUQFXSXKDXKDXSVCZUUTVAZVDVEVFVGVIWFXTXSYCWGWHVHVIADVPPZYFYNYFUVBWIAY
        FXSMSUVBXSYDMWJMDWKWLWPAYGUVBYMAUUIYGUVBWIKYGUUIUVBDEHWMWNUPWOUVBYFYNVJ
        WIAYDYNMDVPXSXTYGYCYMXTXKEUGXSYGXKEUUOWQXKDEWRVIXSYCYBLUUQUKYMXSYBLXLUU
        QUVAWSYBYLLBCDDYBYAXNUGXMYHYIXGZQZYLYAXNXMFWTWQUVDYAYJXNYKUVDYAUVCFUDYJ
        XMUVCFXAYHYIFXBXCUVDXNUVCGUDYKXMUVCGXAYHYIGXBXCXDVIXEWHXHVLWPXFXI $.
    $}

    ssc1.3 $e |- ( ph -> H C_cat J ) $.
    $( Infer subset relation on objects from the subcategory subset relation.
       (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    ssc1 $p |- ( ph -> S C_ T ) $=
      ( vx vy wss cv co wral cssc wbr wa cvv wcel mpbid sscrel brrelex2i ssclem
      syl isssc simpld ) ABCKZILZJLZDMUHUIEMKJBNIBNZADEOPZUGUJQHAIJBCDERFGAERSZ
      CRSAUKULHDEOUAUBUDACEGUCTUETUF $.
  $}

  ${
    $d x y H $.  $d x y J $.  $d x y S $.  $d x y X $.  $d y Y $.
    ssc2.1 $e |- ( ph -> H Fn ( S X. S ) ) $.
    ssc2.2 $e |- ( ph -> H C_cat J ) $.
    ssc2.3 $e |- ( ph -> X e. S ) $.
    ssc2.4 $e |- ( ph -> Y e. S ) $.
    $( Infer subset relation on morphisms from the subcategory subset
       relation.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    ssc2 $p |- ( ph -> ( X H Y ) C_ ( X J Y ) ) $=
      ( vx vy wcel cv co wss wral cdm cssc cvv wa eqidd sscfn2 sscrel brrelex2i
      dmexg 4syl isssc mpbid simprd wceq oveq1 sseq12d oveq2 rspc2va syl21anc
      wbr ) AEBMFBMKNZLNZCOZURUSDOZPZLBQKBQZEFCOZEFDOZPZIJABDRZRZPZVCACDSUQZVIV
      CUAHAKLBVHCDTGAVHCDHAVHUBUCAVJDTMVGTMVHTMHCDSUDUEDTUFVGTUFUGUHUIUJVBVFEUS
      COZEUSDOZPKLEFBBUREUKUTVKVAVLUREUSCULUREUSDULUMUSFUKVKVDVLVEUSFECUNUSFEDU
      NUMUOUP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y H $.  $d x y S $.
    $d x y T $.
    $( Any function restricted to a square domain is a subcategory subset of
       the original.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    sscres $p |- ( ( H Fn ( S X. S ) /\ S e. V ) ->
      ( H |` ( T X. T ) ) C_cat H ) $=
      ( vx vy cxp wfn wcel wa cres cin wss cv co wral inss1 wceq simpl sseldi
      cssc wbr inss2 ovresd eqimss rgen2a pm3.2i fnssres sylancl resres fnresdm
      simpr syl adantr reseq1d syl5eqr inxp a1i fneq12d mpbid isssc mpbiri ) CA
      AGZHZADIZJZCBBGZKZCUAUBABLZAMZENZFNZVHOZVKVLCOZMZFVIPEVIPZJVJVPABQVOEFVIV
      KVIIZVLVIIZJZVMVNRVOVSVKVLCBVSVIBVKABUCZVQVRSTVSVIBVLVTVQVRULTUDVMVNUEUMU
      FUGVFEFVIAVHCDVFCVCVGLZKZWAHZVHVIVIGZHVFVDWAVCMWCVDVESZVCVGQVCWACUHUIVFWA
      WDWBVHVFWBCVCKZVGKVHCVCVGUJVFWFCVGVDWFCRVEVCCUKUNUOUPWAWDRVFAABBUQURUSUTW
      EVDVEULVAVB $.

    $( The subcategory subset relation is reflexive.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    sscid $p |- ( ( H Fn ( S X. S ) /\ S e. V ) -> H C_cat H ) $=
      ( cxp wfn wcel wa cres cssc wceq fnresdm adantr sscres eqbrtrrd ) BAADZEZ
      ACFZGBOHZBBIPRBJQOBKLAABCMN $.

    $( The subcategory subset relation is transitive.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    ssctr $p |- ( ( A C_cat B /\ B C_cat C ) -> A C_cat C ) $=
      ( vx vy cssc wbr wa cdm wss cv co wral eqidd sscfn2 ssc1 sstrd adantr cvv
      wcel simpl sscfn1 simpr cxp wfn simprl simprr sseldd ralrimivva brrelex2i
      ssc2 sscrel adantl dmexg 3syl isssc mpbir2and ) ABFGZBCFGZHZACFGAIIZCIZIZ
      JDKZEKZALZVDVECLZJZEVAMDVAMUTVABIIZVCUTVAVIABUTVAABURUSUAZUTVANUBZUTVIABV
      JUTVINOZVJPZUTVIVCBCVLUTVCBCURUSUCZUTVCNOZVNPQUTVHDEVAVAUTVDVATZVEVATZHZH
      ZVFVDVEBLVGVSVAABVDVEUTAVAVAUDUEVRVKRUTURVRVJRUTVPVQUFZUTVPVQUGZUKVSVIBCV
      DVEUTBVIVIUDUEVRVLRUTUSVRVNRVSVAVIVDUTVAVIJVRVMRZVTUHVSVAVIVEWBWAUHUKQUIU
      TDEVAVCACSVKVOUTCSTZVBSTVCSTUSWCURBCFULUJUMCSUNVBSUNUOUPUQ $.

    $( The subcategory subset relation is antisymmetric.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    ssceq $p |- ( ( A C_cat B /\ B C_cat A ) -> A = B ) $=
      ( vx vy cssc wbr wa wceq cdm cxp cv wral eqidd sscfn1 ssc1 eqssd wcel wfn
      co adantr simpl simpr xpeq12d simprl simprr ssc2 wss sseldd ralrimivva wb
      eqfnov syl2anc mpbir2and ) ABEFZBAEFZGZABHZAIIZURJZBIIZUTJZHZCKZDKZASZVCV
      DBSZHZDURLCURLZUPURUTURUTUPURUTUPURUTABUPURABUNUOUAZUPURMNZUPUTBAUNUOUBZU
      PUTMNZVIOZUPUTURBAVLVJVKOPZVNUCUPVGCDURURUPVCURQZVDURQZGZGZVEVFVRURABVCVD
      UPAUSRZVQVJTUPUNVQVITUPVOVPUDZUPVOVPUEZUFVRUTBAVCVDUPBVARZVQVLTUPUOVQVKTV
      RURUTVCUPURUTUGVQVMTZVTUHVRURUTVDWCWAUHUFPUIUPVSWBUQVBVHGUJVJVLCDURURUTUT
      ABUKULUM $.
  $}

  ${
    $d c h C $.  $d c h H $.
    rescval.1 $e |- D = ( C |`cat H ) $.
    $( Value of the category restriction.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    rescval $p |- ( ( C e. V /\ H e. W ) -> D =
      ( ( C |`s dom dom H ) sSet <. ( Hom ` ndx ) , H >. ) ) $=
      ( vc vh wcel wa cresc co cdm cress cop csts cvv wceq elex cv cnx chom cfv
      simpl simpr dmeqd oveq12d opeq2d df-resc ovex ovmpt2a syl2an syl5eq ) ADI
      ZCEIZJBACKLZACMZMZNLZUAUBUCZCOZPLZFUNAQICQIUPVBRUOADSCESGHACQQGTZHTZMZMZN
      LZUTVDOZPLVBKVCARZVDCRZJZVGUSVHVAPVKVCAVFURNVIVJUDVKVEUQVKVDCVIVJUEZUFUFU
      GVKVDCUTVLUHUGHGUIUSVAPUJUKULUM $.

    rescval2.1 $e |- ( ph -> C e. V ) $.
    rescval2.2 $e |- ( ph -> S e. W ) $.
    rescval2.3 $e |- ( ph -> H Fn ( S X. S ) ) $.
    $( Value of the category restriction.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    rescval2 $p |- ( ph ->
      D = ( ( C |`s S ) sSet <. ( Hom ` ndx ) , H >. ) ) $=
      ( cdm cress co cnx csts wcel cvv wceq syl2anc chom cfv cop cxp xpexg fnex
      wfn rescval fndm syl dmeqd dmxpid syl6eq oveq2d oveq1d eqtrd ) ACBELZLZMN
      ZOUAUBEUCZPNZBDMNZUTPNABFQERQZCVASIAEDDUDZUGZVDRQZVCKADGQZVGVFJJDDGGUETVD
      REUFTBCEFRHUHTAUSVBUTPAURDBMAURVDLDAUQVDAVEUQVDSKVDEUIUJUKDULUMUNUOUP $.
  $}

  ${
    $d x y D $.
    rescbas.d $e |- D = ( C |`cat H ) $.
    rescbas.b $e |- B = ( Base ` C ) $.
    rescbas.c $e |- ( ph -> C e. V ) $.
    rescbas.h $e |- ( ph -> H Fn ( S X. S ) ) $.
    rescbas.s $e |- ( ph -> S C_ B ) $.
    $( Base set of the category restriction.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    rescbas $p |- ( ph -> S = ( Base ` D ) ) $=
      ( co cbs cfv cnx wne c1 c4 cvv chom cop csts baseid cdc 1re 1nn 4nn0 1nn0
      cress 1lt10 declti ltneii basendx neeq12i mpbir setsnid wss wceq ressbas2
      homndx eqid syl wcel fvex eqeltri ssex rescval2 fveq2d 3eqtr4a ) ACEUJMZN
      OZVKPUAOZFUBUCMZNOEDNOFVMNVKUDPNOZVMQRRSUEZQRVPUFRSRUGUHUIUKULUMVORVMVPUN
      VAUOUPUQAEBURZEVLUSLEBVKCVKVBIUTVCADVNNACDEFGTHJAVQETVDLEBBCNOTICNVEVFVGV
      CKVHVIVJ $.

    $( Hom-sets of the category restriction.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    reschom $p |- ( ph -> H = ( Hom ` D ) ) $=
      ( cress co chom cfv cvv wcel cbs syl2anc cnx cop csts cxp wfn wss eqeltri
      wceq ovex fvex ssex syl xpexg homid setsid sylancr rescval2 fveq2d eqtr4d
      fnex ) AFCEMNZUAOPFUBUCNZOPZDOPAVAQRFQRZFVCUHCEMUIAFEEUDZUEVEQRZVDKAEQRZV
      GVFAEBUFVGLEBBCSPQICSUJUGUKULZVHEEQQUMTVEQFUTTQFOQVAUNUOUPADVBOACDEFGQHJV
      HKUQURUS $.

    $( Hom-sets of the category restriction.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    reschomf $p |- ( ph -> H = ( Homf ` D ) ) $=
      ( vx vy cbs cfv cv cxp wfn eqid chom reschom wceq rescbas xpeq12d fneq12d
      co cmpt2 chomf mpbid fnov sylib eqtrd homffval syl6eqr ) AFMNDOPZUPMQNQDU
      APZUGUHZDUIPZAFUQURABCDEFGHIJKLUBZAUQUPUPRZSZUQURUCAFEERZSVBKAVCVAFUQUTAE
      UPEUPABCDEFGHIJKLUDZVDUEUFUJMNUPUPUQUKULUMMNUPDUSUQUSTUPTUQTUNUO $.

    rescco.o $e |- .x. = ( comp ` C ) $.
    $( Composition in the category restriction.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    rescco $p |- ( ph -> .x. = ( comp ` D ) ) $=
      ( co cco cfv c1 c4 cvv cress cnx chom cop csts ccoid wne cdc 1nn0 decnncl
      c5 4nn nnrei 4nn0 5nn 4lt5 declt gtneii ccondx neeq12i mpbir setsnid wcel
      homndx wceq wss cbs fvex eqeltri ssex eqid ressco rescval2 fveq2d 3eqtr4a
      syl ) ACEUAOZPQZVQUBUCQZGUDUEOZPQFDPQGVSPVQUFUBPQZVSUGRUKUHZRSUHZUGWCWBWC
      RSUIULUJUMRSUKUIUNUOUPUQURWAWBVSWCUSVDUTVAVBAETVCZFVRVEAEBVFWDMEBBCVGQTJC
      VGVHVIVJVPZECVQFTVQVKNVLVPADVTPACDEGHTIKWELVMVNVO $.
  $}

  ${
    rescabs.c $e |- ( ph -> C e. V ) $.
    rescabs.h $e |- ( ph -> H Fn ( S X. S ) ) $.
    rescabs.j $e |- ( ph -> J Fn ( T X. T ) ) $.
    rescabs.s $e |- ( ph -> S e. W ) $.
    rescabs.t $e |- ( ph -> T C_ S ) $.
    $( Restriction absorption law.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    rescabs $p |- ( ph -> ( ( C |`cat H ) |`cat J ) = ( C |`cat J ) ) $=
      ( cress co csts cvv wcel wceq adantr cnx chom cfv cop cresc eqid ovex a1i
      ssexd rescval2 cbs wss wa simpr baseid wne c1 cdc 1re 1nn 4nn0 1nn0 1lt10
      declti ltneii basendx homndx neeq12i mpbir setsnid ressid2 syl3anc oveq1d
      cxp wfn xpexg syl2anc fnex setsabs sylancr cin ressbas syl sseq1d biimpar
      c4 inss2 ssind ssrin eqssd oveq2d ressinbas 3eqtr4d 3eqtrd wn necomi fvex
      ressval2 inex2 setscom syl22anc ressabs eqtr3d eqtrd pm2.61dan ) ABCNOZUA
      UBUCZEUDZPOZFUEOZBDNOZXGFUDZPOZBEUEOZFUEOBFUEOZAXJXIDNOZXLPOZXMAXIXJDFQQX
      JUFXIQRZAXFXHPUGZUHADCHLMUIZKUJAXFUKUCZDULZXQXMSAYBUMZXQXIXLPOZXFXLPOZXMY
      CXPXIXLPYCYBXRDQRZXPXISAYBUNXRYCXSUHAYFYBXTTZDYAXPXIQQXPUFZEXGUKXFUOUAUKU
      CZXGUPUQUQWFURZUPUQYJUSUQWFUQUTVAVBVCVDVEYIUQXGYJVFVGVHVIZVJZVKVLVMYCXFQR
      ZFQRZYDYESBCNUGZAYNYBAFDDVNZVOYPQRZYNKAYFYFYQXTXTDDQQVPVQYPQFVRVQZTXGEFXF
      QQVSVTYCXFXKXLPYCBCBUKUCZWAZNOZBDYSWAZNOZXFXKYCYTUUBBNYCYTUUBYCYTDYSAYTDU
      LYBAYTYADACHRZYTYASLCYSXFHBXFUFYSUFZWBWCWDWEYTYSULYCCYSWGUHWHYCDCULZUUBYT
      ULAUUFYBMTDCYSWIWCWJWKYCUUDXFUUASAUUDYBLTCYSBHUUEWLWCYCYFXKUUCSYGDYSBQUUE
      WLWCWMVMWNAYBWOZUMZXQXKXHPOZXLPOZXMUUHXPUUIXLPUUHXPXIYIDYAWAZUDZPOZXFUULP
      OZXHPOZUUIUUHUUGXRYFXPUUMSAUUGUNZXRUUHXSUHAYFUUGXTTZDYAXPXIQQYHYLWRVLUUHY
      MXGYIUPZEQRZUUKQRZUUMUUOSYMUUHYOUHZUURUUHYIXGYKWPUHAUUSUUGAECCVNZVOUVBQRZ
      UUSJAUUDUUDUVCLLCCHHVPVQUVBQEVRVQTUUTUUHYADXFUKWQWSUHXGYIEUUKXFQQQUAUBWQU
      AUKWQWTXAUUHUUNXKXHPUUHXFDNOZUUNXKUUHUUGYMYFUVDUUNSUUPUVAUUQDYAUVDXFQQUVD
      UFYAUFWRVLUUHUUDUUFUVDXKSAUUDUUGLTAUUFUUGMTCDBHXBVQXCVMWNVMUUHXKQRYNUUJXM
      SBDNUGAYNUUGYRTXGEFXKQQVSVTXDXEXDAXNXIFUEABXNCEGHXNUFILJUJVMABXODFGQXOUFI
      XTKUJWM $.
  $}

  ${
    rescabs2.c $e |- ( ph -> C e. V ) $.
    rescabs2.j $e |- ( ph -> J Fn ( T X. T ) ) $.
    rescabs2.s $e |- ( ph -> S e. W ) $.
    rescabs2.t $e |- ( ph -> T C_ S ) $.
    $( Restriction absorption law.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    rescabs2 $p |- ( ph -> ( ( C |`s S ) |`cat J ) = ( C |`cat J ) ) $=
      ( cress co cnx csts cresc wcel cvv eqid rescval2 chom cfv cop wss ressabs
      wceq syl2anc oveq1d ovex a1i ssexd 3eqtr4d ) ABCLMZDLMZNUAUBEUCZOMBDLMZUO
      OMUMEPMZBEPMZAUNUPUOOACGQDCUDUNUPUFJKCDBGUEUGUHAUMUQDERRUQSUMRQABCLUIUJAD
      CGJKUKZITABURDEFRURSHUSITUL $.
  $}

  ${
    $d c f g j s x y z C $.  $d c f g j s x y z J $.  $d c f g j s x y z S $.
    $d c j s .1. $.  $d c j H $.  $d c j s .x. $.
    issubc.h $e |- H = ( Homf ` C ) $.
    issubc.i $e |- .1. = ( Id ` C ) $.
    issubc.o $e |- .x. = ( comp ` C ) $.
    issubc.c $e |- ( ph -> C e. Cat ) $.
    ${
      issubc.s $e |- ( ph -> S = dom dom J ) $.
      $( Elementhood in the set of subcategories.  (Contributed by Mario
         Carneiro, 4-Jan-2017.) $)
      issubc $p |- ( ph -> ( J e. ( Subcat ` C ) <-> ( J C_cat H /\
         A. x e. S ( ( .1. ` x ) e. ( x J x ) /\ A. y e. S A. z e. S
          A. f e. ( x J y ) A. g e. ( y J z )
            ( g ( <. x , y >. .x. z ) f ) e. ( x J z ) ) ) ) ) $=
        ( vj wcel co vc vs ccat cdm wceq csubc cfv cssc wbr cv wral wa wb chomf
        cop ccid cco wsbc cab csb cvv simpl sscpwex ss2abi ssexi df-subc fvmpts
        csbex syl2anc eleq2d sbcel2 wi elex sscrel brrelexi adantr df-sbc simpr
        a1i fveq2d syl6eqr breq12d vex dmeqd simpllr eqtr4d fveq1d simplr oveqd
        dmex eleq12d raleqbidv anbi12d sbcied2 adantlr sbcied syl5bbr pm5.21ndd
        ex 3bitr2d ) AEUCSZFLUDZUDZUEZLEUFUGZSZLKUHUIZBUJZHUGZXHXHLTZSZJUJZIUJZ
        XHCUJZUOZDUJZGTZTZXHXPLTZSZJXNXPLTZUKZIXHXNLTZUKZDFUKZCFUKZULZBFUKZULZU
        MPQXAXDULZXFLUAERUJZUAUJZUNUGZUHUIZXHYLUPUGZUGZXHXHYKTZSZXLXMXOXPYLUQUG
        ZTZTZXHXPYKTZSZJXNXPYKTZUKZIXHXNYKTZUKZDUBUJZUKZCUUHUKZULZBUUHUKZUBYKUD
        ZUDZURZULZRUSZUTZSZLUUQSZUAEURZYIYJXEUURLYJXAUURVASZXEUURUEXAXDVBZUVBYJ
        UAEUUQUUQYNRUSRYMVCUUPYNRYNUUOVBVDVEVHVSUAEUUQUCUFVABCDIJRUBUAVFVGVIVJU
        VAUUSUMYJUAELUUQVKVSYJUUTYIUAEUCUVCYJYLEUEZULZLVASZUUTYIUUTUVFVLUVELUUQ
        VMVSYIUVFVLUVEXGUVFYHLKUHVNVOVPVSUVEUVFUUTYIUMUUTUUPRLURUVEUVFULZYIUUPR
        LVQUVGUUPYIRLVAUVEUVFVRUVEYKLUEZUUPYIUMUVFUVEUVHULZYNXGUUOYHUVIYKLYMKUH
        UVEUVHVRZUVEYMKUEUVHUVEYMEUNUGKUVEYLEUNYJUVDVRVTMWAVPWBUVIUULYHUBUUNFVA
        UUNVASUVIUUMYKRWCWJWJVSUVIUUNXCFUVIUUMXBUVIYKLUVJWDWDXAXDUVDUVHWEWFUVIU
        UHFUEZULZUUKYGBUUHFUVIUVKVRZUVLYRXKUUJYFUVLYPXIYQXJUVLXHYOHUVLYOEUPUGHU
        VLYLEUPYJUVDUVHUVKWEZVTNWAWGUVLYKLXHXHUVEUVHUVKWHZWIWKUVLUUIYECUUHFUVMU
        VLUUGYDDUUHFUVMUVLUUEYBIUUFYCUVLYKLXHXNUVOWIUVLUUCXTJUUDYAUVLYKLXNXPUVO
        WIUVLUUAXRUUBXSUVLYTXQXLXMUVLYSGXOXPUVLYSEUQUGGUVLYLEUQUVNVTOWAWIWIUVLY
        KLXHXPUVOWIWKWLWLWLWLWMWLWNWMWOWPWQWSWRWPWTVI $.
    $}

    issubc2.a $e |- ( ph -> J Fn ( S X. S ) ) $.
    $( Elementhood in the set of subcategories.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    issubc2 $p |- ( ph -> ( J e. ( Subcat ` C ) <-> ( J C_cat H /\ A. x e. S
      ( ( .1. ` x ) e. ( x J x ) /\ A. y e. S A. z e. S A. f e. ( x J y )
        A. g e. ( y J z ) ( g ( <. x , y >. .x. z ) f ) e. ( x J z ) ) ) ) ) $=
      ( cdm cxp wfn wceq fndm syl dmeqd dmxpid syl6req issubc ) ABCDEFGHIJKLMNO
      PALRZRFFSZRFAUHUIALUITUHUIUAQUILUBUCUDFUEUFUG $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z J $.  $d f g x y z ph $.
    subcixp.1 $e |- ( ph -> J e. ( Subcat ` C ) ) $.
    ${
      subcssc.h $e |- H = ( Homf ` C ) $.
      $( An element in the set of subcategories is a subset of the category.
         (Contributed by Mario Carneiro, 6-Jan-2017.) $)
      subcssc $p |- ( ph -> J C_cat H ) $=
        ( vx vg vf vy vz cssc cv cfv co wcel wral cdm wa eqid wbr cop cco csubc
        ccid ccat subcrcl syl eqidd issubc mpbid simpld ) ADCLUAZGMZBUENZNUNUND
        OPHMIMUNJMZUBKMZBUCNZOOUNUQDOPHUPUQDOQIUNUPDOQKDRRZQJUSQSGUSQZADBUDNPZU
        MUTSEAGJKBUSURUOIHCDFUOTURTAVABUFPEBDUGUHAUSUIUJUKUL $.
    $}

    subcfn.2 $e |- ( ph -> S = dom dom J ) $.
    $( An element in the set of subcategories is a binary function.
       (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    subcfn $p |- ( ph -> J Fn ( S X. S ) ) $=
      ( chomf cfv eqid subcssc sscfn1 ) ACDBGHZABLDELIJFK $.
  $}

  ${
    $d f g x y z C $.  $d x y z H $.  $d f g x y z J $.  $d x y X $.  $d y Y $.
    $d x y z S $.
    subcss1.1 $e |- ( ph -> J e. ( Subcat ` C ) ) $.
    subcss1.2 $e |- ( ph -> J Fn ( S X. S ) ) $.
    ${
      subcss1.b $e |- B = ( Base ` C ) $.
      $( The objects of a subcategory are a subset of the objects of the
         original.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
      subcss1 $p |- ( ph -> S C_ B ) $=
        ( chomf cfv cxp wfn eqid homffn a1i subcssc ssc1 ) ADBECIJZGRBBKLABCRRM
        ZHNOACREFSPQ $.
    $}

    ${
      subcss2.h $e |- H = ( Hom ` C ) $.
      subcss2.x $e |- ( ph -> X e. S ) $.
      subcss2.y $e |- ( ph -> Y e. S ) $.
      $( The morphisms of a subcategory are a subset of the morphisms of the
         original.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
      subcss2 $p |- ( ph -> ( X J Y ) C_ ( X H Y ) ) $=
        ( co chomf cfv eqid subcssc ssc2 cbs sseldd subcss1 homfval sseqtrd ) A
        FGEMFGBNOZMFGDMACEUDFGIABUDEHUDPZQKLRABSOZBUDDFGUEUFPZJACUFFAUFBCEHIUGU
        AZKTACUFGUHLTUBUC $.
    $}
  $}

  ${
    $d f g x y z C $.  $d f g x y z F $.  $d f g x y z G $.  $d f g x y z ph $.
    $d f g x y z J $.  $d f g x y z S $.  $d f g x y z X $.  $d f g x y z Y $.
    $d x .1. $.  $d f g x y z .x. $.  $d f g x y z Z $.
    subcidcl.j $e |- ( ph -> J e. ( Subcat ` C ) ) $.
    subcidcl.2 $e |- ( ph -> J Fn ( S X. S ) ) $.
    subcidcl.x $e |- ( ph -> X e. S ) $.
    ${
      subcidcl.1 $e |- .1. = ( Id ` C ) $.
      $( The identity of the original category is contained in each
         subcategory.  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
      subcidcl $p |- ( ph -> ( .1. ` X ) e. ( X J X ) ) $=
        ( vx vg vf vy vz wcel cv cfv co wral cop cco chomf cssc csubc eqid ccat
        wa wbr subcrcl syl issubc2 mpbid simprd simpl ralimi wceq fveq2 oveq12d
        id eleq12d rspcv sylc ) AFCPKQZDRZVDVDESZPZKCTZFDRZFFESZPZIAVGLQMQVDNQZ
        UAOQZBUBRZSSVDVMESPLVLVMESTMVDVLESTOCTNCTZUHZKCTZVHAEBUCRZUDUIZVQAEBUER
        PZVSVQUHGAKNOBCVNDMLVREVRUFJVNUFAVTBUGPGBEUJUKHULUMUNVPVGKCVGVOUOUPUKVG
        VKKFCVDFUQZVEVIVFVJVDFDURWAVDFVDFEWAUTZWBUSVAVBVC $.
    $}

    subccocl.o $e |- .x. = ( comp ` C ) $.
    subccocl.y $e |- ( ph -> Y e. S ) $.
    subccocl.z $e |- ( ph -> Z e. S ) $.
    subccocl.f $e |- ( ph -> F e. ( X J Y ) ) $.
    subccocl.g $e |- ( ph -> G e. ( Y J Z ) ) $.
    $( A subcategory is closed under composition.  (Contributed by Mario
       Carneiro, 4-Jan-2017.) $)
    subccocl $p |- ( ph -> ( G ( <. X , Y >. .x. Z ) F ) e. ( X J Z ) ) $=
      ( co wcel vx vg vf vy vz cv ccid cfv cop wral wa chomf cssc wbr eqid ccat
      csubc subcrcl issubc2 mpbid simprd wceq adantr ad2antrr ad3antrrr simpllr
      syl simplr oveq12d eleqtrrd ad4antr simp-5r simp-4r opeq12d simpr eleq12d
      oveq123d rspcdv rspcimdv adantld mpd ) AUAUFZBUGUHZUHWBWBGSTZUBUFZUCUFZWB
      UDUFZUIZUEUFZDSZSZWBWIGSZTZUBWGWIGSZUJZUCWBWGGSZUJZUECUJZUDCUJZUKZUACUJZF
      EHIUIZJDSZSZHJGSZTZAGBULUHZUMUNZXAAGBUQUHTZXHXAUKKAUAUDUEBCDWCUCUBXGGXGUO
      WCUONAXIBUPTKBGURVGLUSUTVAAWTXFUAHCMAWBHVBZUKZWSXFWDXKWRXFUDICAICTXJOVCXK
      WGIVBZUKZWQXFUEJCAJCTXJXLPVDXMWIJVBZUKZWOXFUCEWPXOEHIGSZWPAEXPTXJXLXNQVEX
      OWBHWGIGAXJXLXNVFXKXLXNVHVIVJXOWFEVBZUKZWMXFUBFWNXRFIJGSZWNAFXSTXJXLXNXQR
      VKXRWGIWIJGXKXLXNXQVFXMXNXQVHVIVJXRWEFVBZUKZWKXDWLXEYAWEFWFEWJXCYAWHXBWIJ
      DYAWBHWGIAXJXLXNXQXTVLZXKXLXNXQXTVMVNXMXNXQXTVFZVIXRXTVOXOXQXTVHVQYAWBHWI
      JGYBYCVIVPVRVSVSVSVTVSWA $.
  $}

  ${
    $d f g h w x y z C $.  $d g h x y z D $.  $d f g h w x y z ph $.  $d x X $.
    $d f g h w x y z .1. $.  $d f g h w x y z J $.  $d f g h w x y z S $.
    subccat.1 $e |- D = ( C |`cat J ) $.
    subccat.j $e |- ( ph -> J e. ( Subcat ` C ) ) $.
    ${
      subccatid.1 $e |- ( ph -> J Fn ( S X. S ) ) $.
      subccatid.2 $e |- .1. = ( Id ` C ) $.
      $( A subcategory is a category.  (Contributed by Mario Carneiro,
         4-Jan-2017.) $)
      subccatid $p |- ( ph ->
        ( D e. Cat /\ ( Id ` D ) = ( x e. S |-> ( .1. ` x ) ) ) ) $=
        ( cv wcel wa co cfv cvv ccat adantr sseldd vw vy vz vf w3a cco cbs eqid
        vg vh csubc subcrcl syl subcss1 rescbas reschom rescco ovex eqeltri a1i
        cresc biid cxp wfn subcidcl chom simpr1l simpr1r subcss2 simpr31 catlid
        simpr simpr2l simpr32 catrid subccocl simpr2r simpr33 catass iscatd2
        wss ) AUALZEMZBLZEMZNZUBLZEMZUCLZEMZNZUDLZWBWDGOZMZUILZWDWGGOZMZUJLZWGW
        IGOZMZUEZUEZUABUBUCEDCUFPZWDFPUDUIUJGQACUGPZCDEGRHXDUHZAGCUKPMZCRMZICGU
        LUMZJAXDCEGIJXEUNZUOAXDCDEGRHXEXHJXIUPAXDCDEXCGRHXEXHJXIXCUHZUQDQMADCGV
        AOQHCGVAURUSUTXBVBAWENCEFGWDAXFWEISAGEEVCVDZWEJSAWEVLKVEAXBNZXDCXCFWLCV
        FPZWBWDXEXMUHZKAXGXBXHSZXLEXDWBAEXDWAXBXISZWCWEWKXAAVGZTZXJXLEXDWDXPWCW
        EWKXAAVHZTZXLWMWBWDXMOWLXLCEXMGWBWDAXFXBISZAXKXBJSZXNXQXSVIWNWQWTWFWKAV
        JZTZVKXLXDCXCFWOXMWDWGXEXNKXOXTXJXLEXDWGXPWHWJWFXAAVMZTZXLWPWDWGXMOWOXL
        CEXMGWDWGYAYBXNXSYEVIWNWQWTWFWKAVNZTZVOXLCEXCWLWOGWBWDWGYAYBXQXJXSYEYCY
        GVPXLXDCXCWLWOXMWRWIWBWDWGXEXNXJXOXRXTYFYDYHXLEXDWIXPWHWJWFXAAVQZTXLWSW
        GWIXMOWRXLCEXMGWGWIYAYBXNYEYIVIWNWQWTWFWKAVRTVSVT $.

      subcid.x $e |- ( ph -> X e. S ) $.
      $( The identity in a subcategory is the same as the original category.
         (Contributed by Mario Carneiro, 4-Jan-2017.) $)
      subcid $p |- ( ph -> ( .1. ` X ) = ( ( Id ` D ) ` X ) ) $=
        ( vx ccid cfv cv cvv ccat wcel wceq cmpt subccatid simprd wa simpr fvex
        fveq2d a1i fvmptd eqcomd ) AGCNOZOGEOZAMGMPZEOZULDUKQACRSUKMDUNUATAMBCD
        EFHIJKUBUCAUMGTZUDUMGEAUOUEUGLULQSAGEUFUHUIUJ $.
    $}

    $( A subcategory is a category.  (Contributed by Mario Carneiro,
       4-Jan-2017.) $)
    subccat $p |- ( ph -> D e. Cat ) $=
      ( vx ccat wcel ccid cfv cdm cmpt wceq eqidd subcfn eqid subccatid simpld
      cv ) ACHICJKGDLLZGTBJKZKMNAGBCUAUBDEFABUADFAUAOPUBQRS $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z H $.  $d f g x y z ph $.
    $d f g x y z J $.  $d f g x y z S $.
    issubc3.h $e |- H = ( Homf ` C ) $.
    issubc3.i $e |- .1. = ( Id ` C ) $.
    issubc3.1 $e |- D = ( C |`cat J ) $.
    issubc3.c $e |- ( ph -> C e. Cat ) $.
    issubc3.a $e |- ( ph -> J Fn ( S X. S ) ) $.
    $( Alternate definition of a subcategory, as a subset of the category which
       is itself a category.  The assumption that the identity be closed is
       necessary just as in the case of a monoid, ~ issubm2 , for the same
       reasons, since categories are a generalization of monoids.  (Contributed
       by Mario Carneiro, 6-Jan-2017.) $)
    issubc3 $p |- ( ph -> ( J e. ( Subcat ` C ) <-> ( J C_cat H /\
      A. x e. S ( .1. ` x ) e. ( x J x ) /\ D e. Cat ) ) ) $=
      ( cfv wcel cv co wral ccat wa vg vf vy vz csubc cssc wbr w3a simpr adantr
      subcssc cxp wfn ad2antrr subcidcl ralrimiva subccat cop cco simpr1 simpr2
      3jca chom cbs eqid simplrr simprl1 homffn simplrl rescbas eleqtrd simprl2
      ssc1 simprl3 simprrl reschom oveqd simprrr catcocl rescco 3eltr4d anassrs
      ralrimivva ralrimivvva 3adantr2 r19.26 sylanbrc issubc2 mpbir2and impbida
      a1i ) AHCUENOZHGUFUGZBPZFNWNWNHQOZBERZDSOZUHZAWLTZWMWPWQWSCGHAWLUIZIUKWSW
      OBEWSWNEOZTCEFHWNWSWLXAWTUJAHEEULUMZWLXAMUNWSXAUIJUOUPWSCDHKWTUQVBAWRTZWL
      WMWOUAPZUBPZWNUCPZURZUDPZCUSNZQZQZWNXHHQZOZUAXFXHHQZRUBWNXFHQZRZUDERUCERZ
      TBERZAWMWPWQUTXCWPXQBERZXRAWMWPWQVAAWMWQXSWPAWMWQTZTZXPBUCUDEEEYAXAXFEOZX
      HEOZUHZTXMUBUAXOXNYAYDXEXOOZXDXNOZTZXMYAYDYGTZTZXDXEXGXHDUSNZQZQWNXHDVCNZ
      QXKXLYIDVDNZDYJXEXDYLWNXFXHYMVEYLVEYJVEAWMWQYHVFYIWNEYMXAYBYCYGYAVGYICVDN
      ZCDEHSKYNVEZACSOZXTYHLUNZAXBXTYHMUNZYIEYNHGYRGYNYNULUMYIYNCGIYOVHWKAWMWQY
      HVIVMZVJZVKYIXFEYMXAYBYCYGYAVLYTVKYIXHEYMXAYBYCYGYAVNYTVKYIXEXOWNXFYLQYAY
      DYEYFVOYIHYLWNXFYIYNCDEHSKYOYQYRYSVPZVQVKYIXDXNXFXHYLQYAYDYEYFVRYIHYLXFXH
      UUAVQVKVSYIXJYKXDXEYIXIYJXGXHYIYNCDEXIHSKYOYQYRYSXIVEZVTVQVQYIHYLWNXHUUAV
      QWAWBWCWDWEWOXQBEWFWGXCBUCUDCEXIFUBUAGHIJUUBAYPWRLUJAXBWRMUJWHWIWJ $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z H $.  $d f g x y z ph $.  $d f g x y z S $.
    $d x y D $.  $d x y E $.
    fullsubc.b $e |- B = ( Base ` C ) $.
    fullsubc.h $e |- H = ( Homf ` C ) $.
    fullsubc.c $e |- ( ph -> C e. Cat ) $.
    fullsubc.s $e |- ( ph -> S C_ B ) $.
    $( The full subcategory generated by a subset of objects is the category
       with these objects and the same morphisms as the original.  The result
       is always a subcategory (and it is full, meaning that all morphisms of
       the original category between objects in the subcategory is also in the
       subcategory).  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    fullsubc $p |- ( ph -> ( H |` ( S X. S ) ) e. ( Subcat ` C ) ) $=
      ( vx vg vf vy cfv wcel cv co wral wa adantr vz cxp cres cssc wbr ccid cop
      csubc cco wfn cvv homffn cbs fvex eqeltri sscres mp2an a1i chom eqid ccat
      sselda catidcl simpr ovresd homfval eleqtrrd ad3antrrr wss simprl catcocl
      eqtrd simprr simplr ralrimivva wceq raleqbidv mpbird ralrimiva jca xpss12
      raleqdv syl2anc fnssres sylancr issubc2 mpbir2and ) AEDDUBZUCZCUHNOWIEUDU
      EZJPZCUFNZNZWKWKWIQZOZKPZLPZWKMPZUGUAPZCUINZQQZWKWSWIQZOZKWRWSWIQZRZLWKWR
      WIQZRZUADRZMDRZSZJDRWJAEBBUBZUJZBUKOWJBCEGFULZBCUMNUKFCUMUNUOBDEUKUPUQURA
      XJJDAWKDOZSZWOXIXOWMWKWKCUSNZQZWNXOBCWLXPWKFXPUTZWLUTZACVAOZXNHTZADBWKIVB
      ZVCXOWNWKWKEQXQXOWKWKEDAXNVDZYCVEXOBCEXPWKWKGFXRYBYBVFVLVGXOXHMDXOWRDOZSZ
      XGUADYEWSDOZSZXGXCKWRWSXPQZRZLWKWRXPQZRYGXCLKYJYHYGWQYJOZWPYHOZSZSZXAWKWS
      XPQZXBYNBCWTWQWPXPWKWRWSFXRWTUTZXOXTYDYFYMYAVHXOWKBOZYDYFYMYBVHZYGWRBOZYM
      YEYSYFXODBWRADBVIZXNITZVBZTZTYGWSBOYMYEDBWSXOYTYDUUATVBZTZYGYKYLVJYGYKYLV
      MVKYNXBWKWSEQYOYNWKWSEDXOXNYDYFYMYCVHYEYFYMVNVEYNBCEXPWKWSGFXRYRUUEVFVLVG
      VOYGXEYILXFYJYEXFYJVPYFYEXFWKWREQYJYEWKWREDAXNYDVNXOYDVDVEYEBCEXPWKWRGFXR
      XOYQYDYBTUUBVFVLTYGXCKXDYHYGXDWRWSEQYHYGWRWSEDXOYDYFVNYEYFVDVEYGBCEXPWRWS
      GFXRUUCUUDVFVLWBVQVRVSVSVTVSAJMUACDWTWLLKEWIGXSYPHAXLWHXKVIZWIWHUJXMAYTYT
      UUFIIDBDBWAWCXKWHEWDWEWFWG $.

    fullsubc.d $e |- D = ( C |`s S ) $.
    fullsubc.e $e |- E = ( C |`cat ( H |` ( S X. S ) ) ) $.
    $( The category formed by structure restriction is the same as the category
       restriction.  (Contributed by Mario Carneiro, 5-Jan-2017.) $)
    fullresc $p |- ( ph -> ( ( Homf ` D ) = ( Homf ` E ) /\
                             ( comf ` D ) = ( comf ` E ) ) ) $=
      ( vx vy cfv wceq co eqid cvv chomf ccomf chom wral wcel wss adantr simprl
      cv wa sseldd simprr homfval cxp cres ovresd homffn xpss12 syl2anc fnssres
      ccat wfn sylancr reschom proplem3 cbs ressbas2 syl fvex syl6eqel 3eqtr3rd
      eqtr3d resshom ralrimivva rescbas homfeq mpbird cco ressco rescco comfeqd
      jca ) ADUAPFUAPQZDUBPFUBPQAWCNUIZOUIZDUCPZRZWDWEFUCPZRZQZOEUDNEUDAWJNOEEA
      WDEUEZWEEUEZUJZUJZWDWEGRZWDWECUCPZRWIWGWNBCGWPWDWEIHWPSZWNEBWDAEBUFZWMKUG
      ZAWKWLUHZUKWNEBWEWSAWKWLULZUKUMWNWDWEGEEUNZUOZRWOWIWNWDWEGEWTXAUPAWMNOXCW
      HABCFEXCVAMHJAGBBUNZVBXBXDUFZXCXBVBBCGIHUQAWRWRXEKKEBEBURUSXDXBGUTVCZKVDV
      EVLAWMNOWPWFAETUEZWPWFQAEDVFPZTAWREXHQKEBDCLHVGVHZDVFVIVJZECDWPTLWQVMVHVE
      VKVNANOEDFWFWHWFSWHSXIABCFEXCVAMHJXFKVOVPVQZADFACVRPZDVRPZFVRPAXGXLXMQXJE
      CDXLTLXLSZVSVHABCFEXLXCVAMHJXFKXNVTVLXKWAWB $.
  $}

  $( A category restricted to a smaller set of objects is a category.
     (Contributed by Mario Carneiro, 6-Jan-2017.) $)
  resscat $p |- ( ( C e. Cat /\ S e. V ) -> ( C |`s S ) e. Cat ) $=
    ( ccat wcel wa cress co cbs cfv cin wceq ressinbas adantl chomf cxp a1i cvv
    eqid ccomf cres cresc simpl wss inss2 fullsubc subccat fullresc simpld ovex
    simprd catpropd mpbird eqeltrd ) ADEZBCEZFZABGHZABAIJZKZGHZDUPURVALUOBUSACU
    SSZMNUQVADEAAOJZUTUTPUAZUBHZDEUQAVEVDVESZUQUSAUTVCVBVCSZUOUPUCZUTUSUDUQBUSU
    EQZUFUGZUQVAVERDUQVAOJVEOJLZVATJVETJLZUQUSAVAUTVEVCVBVGVHVIVASVFUHZUIUQVKVL
    VMUKVAREUQAUTGUJQVJULUMUN $.

  ${
    $d x C $.  $d x D $.  $d x H $.  $d x J $.
    subsubc.d $e |- D = ( C |`cat H ) $.
    $( A subcategory of a subcategory is a subcategory.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    subsubc $p |- ( H e. ( Subcat ` C ) -> ( J e. ( Subcat ` D ) <->
      ( J e. ( Subcat ` C ) /\ J C_cat H ) ) ) $=
      ( vx csubc cfv wcel cssc wbr wa chomf eqid cdm ccat co cresc adantr cvv
      subcssc cbs subcrcl eqidd subcfn subcss1 reschomf breq2d syl5ibr pm4.71rd
      id cv ccid wral w3a simpr simpl ssctr syl2anc biimpa 2thd cxp sscfn1 ssc1
      wfn sselda subcid eleq1d ralbidva dmexg rescabs syl5req 3anbi123d issubc3
      oveq1i syl subccat 3bitr4rd pm5.32da bitrd ancom syl6bb ) CAGHZIZDBGHIZDC
      JKZDWCIZLZWGWFLWDWEWFWELWHWDWEWFWEWFWDDBMHZJKZWEBWIDWEUKWINZUAWDCWIDJWDAU
      BHZABCOZOZCPEWLNZACUCZWDAWNCWDUKZWDWNUDUEZWDWLAWNCWQWRWOUFUGUHZUIUJWDWFWE
      WGWDWFLZDAMHZJKZFULZAUMHZHZXCXCDQZIZFDOOZUNZADRQZPIZUOWJXCBUMHZHZXFIZFXHU
      NZBDRQZPIZUOWGWEWTXBWJXIXOXKXQWTXBWJWTWFCXAJKXBWDWFUPZWTAXACWDWFUQZXANZUA
      DCXAURUSWDWFWJWSUTVAWTXGXNFXHWTXCXHIZLZXEXMXFYBABWNXDCXCEWTWDYAXSSWTCWNWN
      VBVEZYAWDYCWFWRSZSXDNZWTXHWNXCWTXHWNDCWTXHDCXRWTXHUDVCZYDXRVDZVFVGVHVIWTX
      JXPPWTXPACRQZDRQXJBYHDREVOWTAWNXHCDPTWDAPIWFWPSZYDYFWDWNTIZWFWDWMTIYJCWCV
      JWMTVJVPSYGVKVLVHVMWTFAXJXHXDXADXTYEXJNYIYFVNWTFBXPXHXLWIDWKXLNXPNWDBPIWF
      WDABCEWQVQSYFVNVRVSVTWFWGWAWB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Functors
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Func $.  $( The class of all functors. $)
  $c idFunc $.  $( Identity functor. $)
  $c o.func $.  $( Functor composition. $)
  $c |`f $.  $( Functor restriction. $)

  $( Extend class notation with the class of all functors. $)
  cfunc $a class Func $.

  $( Extend class notation with identity functor. $)
  cidfu $a class idFunc $.

  $( Extend class notation with functor composition. $)
  ccofu $a class o.func $.

  $( Extend class notation to include restriction of a functor to a
     subcategory. $)
  cresf $a class |`f $.

  ${
    $d b f g h m n t u x y z $.
    $( Function returning all the functors from a category ` t ` to a category
       ` u ` .  Intuitively a functor associates any morphism of ` t ` to a
       morphism of ` u ` , any object of ` t ` to an object of ` u ` , and
       respects the identity, the composition, the domain and the codomain.
       Here to capture the idea that a functor associates any object of ` t `
       to an object of ` u ` we write it associates any identity of ` t ` to an
       identity of ` u ` which simplifies the definition.  (Contributed by FL,
       10-Feb-2008.)  (Revised by Mario Carneiro, 2-Jan-2017.) $)
    df-func $a |- Func = ( t e. Cat , u e. Cat |-> { <. f , g >. |
     [. ( Base ` t ) / b ]. ( f : b --> ( Base ` u ) /\ g e. X_ z e. ( b X. b )
      ( ( ( f ` ( 1st ` z ) ) ( Hom ` u )
          ( f ` ( 2nd ` z ) ) ) ^m ( ( Hom ` t ) ` z ) ) /\ A. x e. b
      ( ( ( x g x ) ` ( ( Id ` t ) ` x ) ) = ( ( Id ` u ) ` ( f ` x ) ) /\
    A. y e. b A. z e. b A. m e. ( x ( Hom ` t ) y ) A. n e. ( y ( Hom ` t ) z )
      ( ( x g z ) ` ( n ( <. x , y >. ( comp ` t ) z ) m ) ) =
      ( ( ( y g z ) ` n ) ( <. ( f ` x ) , ( f ` y ) >.
          ( comp ` u ) ( f ` z ) ) ( ( x g y ) ` m ) ) ) ) } ) $.

    $( Define the identity functor.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    df-idfu $a |- idFunc = ( t e. Cat |-> [_ ( Base ` t ) / b ]_ <.
    ( _I |` b ) , ( z e. ( b X. b ) |-> ( _I |` ( ( Hom ` t ) ` z ) ) ) >. ) $.

    $( Define the composition of two functors.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    df-cofu $a |- o.func = ( g e. _V , f e. _V |->
      <. ( ( 1st ` g ) o. ( 1st ` f ) ) , ( x e. dom dom ( 2nd ` f ) ,
      y e. dom dom ( 2nd ` f ) |-> ( ( ( ( 1st ` f ) ` x ) ( 2nd ` g )
        ( ( 1st ` f ) ` y ) ) o. ( x ( 2nd ` f ) y ) ) ) >. ) $.

    $( Define the restriction of a functor to a subcategory (analogue of
       ~ df-res ).  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    df-resf $a |- |`f = ( f e. _V , h e. _V |->
      <. ( ( 1st ` f ) |` dom dom h ) , ( x e. dom h |->
        ( ( ( 2nd ` f ) ` x ) |` ( h ` x ) ) ) >. ) $.

    $( The set of functors is a relation.  (Contributed by Mario Carneiro,
       2-Jan-2017.) $)
    relfunc $p |- Rel ( D Func E ) $=
      ( vb vu vf vg vz vt vx vn vm vy cv cbs cfv chom co ccid wceq wral wf c1st
      cxp c2nd cmap cixp wcel cop cco w3a wsbc ccat cfunc df-func relmpt2opab
      wa ) CMZDMZNOEMZUAFMZGUQUQUCGMZUBOUSOVAUDOUSOURPOQVAHMZPOZOUEQUFUGIMZVBRO
      OVDVDUTQOVDUSOZURROOSJMZKMZVDLMZUHVAVBUIOQQVDVAUTQOVFVHVAUTQOVGVDVHUTQOVE
      VHUSOUHVAUSOURUIOQQSJVHVAVCQTKVDVHVCQTGUQTLUQTUPIUQTUJCVBNOUKHDEFULULABUM
      ILGDHEFKJCUNUO $.

    $( Reverse closure for a functor.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    funcrcl $p |- ( F e. ( D Func E ) -> ( D e. Cat /\ E e. Cat ) ) $=
      ( vt vu vb vf vg vz vx vn vm vy ccat cv cbs cfv chom co wral wf c1st c2nd
      cxp cmap cixp wcel ccid wceq cop cco wa wsbc copab cfunc df-func elmpt2cl
      w3a ) DENNFOZEOZPQGOZUAHOZIUSUSUDIOZUBQVAQVCUCQVAQUTRQSVCDOZRQZQUESUFUGJO
      ZVDUHQQVFVFVBSQVFVAQZUTUHQQUIKOZLOZVFMOZUJVCVDUKQSSVFVCVBSQVHVJVCVBSQVIVF
      VJVBSQVGVJVAQUJVCVAQUTUKQSSUIKVJVCVESTLVFVJVESTIUSTMUSTULJUSTURFVDPQUMGHU
      NABUOCJMIEDGHLKFUPUQ $.
  $}

  ${
    $d b d e f g m n x y z B $.  $d b d e f g C $.  $d b d e f g m n x y z D $.
    $d b d e f g m n x y z E $.  $d b d e f g m n x y z H $.  $d b d e f g I $.
    $d f g m n x y z F $.  $d f g m n x y z G $.  $d b d e f g x y z J $.
    $d b d e f g .1. $.  $d m n x y z ph $.  $d b d e f g .x. $.
    $d b d e f g O $.
    isfunc.b $e |- B = ( Base ` D ) $.
    isfunc.c $e |- C = ( Base ` E ) $.
    isfunc.h $e |- H = ( Hom ` D ) $.
    isfunc.j $e |- J = ( Hom ` E ) $.
    isfunc.1 $e |- .1. = ( Id ` D ) $.
    isfunc.i $e |- I = ( Id ` E ) $.
    isfunc.x $e |- .x. = ( comp ` D ) $.
    isfunc.o $e |- O = ( comp ` E ) $.
    isfunc.d $e |- ( ph -> D e. Cat ) $.
    isfunc.e $e |- ( ph -> E e. Cat ) $.
    $( Value of the set of functors between two categories.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    isfunc $p |- ( ph -> ( F ( D Func E ) G <-> ( F : B --> C /\
      G e. X_ z e. ( B X. B ) ( ( ( F ` ( 1st ` z ) ) J
                ( F ` ( 2nd ` z ) ) ) ^m ( H ` z ) ) /\ A. x e. B
      ( ( ( x G x ) ` ( .1. ` x ) ) = ( I ` ( F ` x ) ) /\
    A. y e. B A. z e. B A. m e. ( x H y ) A. n e. ( y H z )
      ( ( x G z ) ` ( n ( <. x , y >. .x. z ) m ) ) =
      ( ( ( y G z ) ` n ) ( <. ( F ` x ) , ( F ` y ) >.
          O ( F ` z ) ) ( ( x G y ) ` m ) ) ) ) ) ) $=
      ( vf vg vd ve vb cfunc co wbr cv cmap wcel cxp c1st cfv c2nd cixp wa wceq
      cop wral copab w3a ccat cbs chom ccid cco wsbc cvv fvex a1i simpl syl6eqr
      wf fveq2d simpr simplr feq23d eqeltri elmap syl6bbr xpeq12d ixpeq1d oveqd
      simpll fveq1d oveq12d ixpeq2dv eleq2d eqeq12d raleqbidv anbi12d 3anbi123d
      eqtrd df-3an syl6bb sbcied2 opabbidv df-func ciun ovex rgenw ixpexg ax-mp
      csn snex xpex iunex wex anim2i 2eximi eliunxp 3imtr4i ssriv ssexi ovmpt2a
      elopab syl2anc breqd brabv anim12i 3adant3 eleq1d oveq1d eleq12d oveq123d
      elex opeq12d 2ralbidv ralbidv syl5bbr eqid brabga pm5.21nii 3anbi1i bitri
      ) AMNGLUNUOZUPMNUIUQZFEURUOZUSZUJUQZDEEUTZDUQZVAVBZUUFVBZUUKVCVBZUUFVBZQU
      OZUUKOVBZURUOZVDZUSZVEZBUQZIVBZUVBUVBUUIUOZVBZUVBUUFVBZPVBZVFZKUQZJUQZUVB
      CUQZVGZUUKHUOZUOZUVBUUKUUIUOZVBZUVIUVKUUKUUIUOZVBZUVJUVBUVKUUIUOZVBZUVFUV
      KUUFVBZVGZUUKUUFVBZRUOZUOZVFZKUVKUUKOUOZVHZJUVBUVKOUOZVHZDEVHZCEVHZVEZBEV
      HZVEZUIUJVIZUPZEFMWBZNDUUJUULMVBZUUNMVBZQUOZUUQURUOZVDZUSZUVCUVBUVBNUOZVB
      ZUVBMVBZPVBZVFZUVNUVBUUKNUOZVBZUVIUVKUUKNUOZVBZUVJUVBUVKNUOZVBZUXGUVKMVBZ
      VGZUUKMVBZRUOZUOZVFZKUWGVHJUWIVHZDEVHCEVHZVEZBEVHZVJZAUUEUWPMNAGVKUSLVKUS
      UUEUWPVFUGUHUKULGLVKVKUMUQZULUQZVLVBZUUFWBZUUIDUYGUYGUTZUUMUUOUYHVMVBZUOZ
      UUKUKUQZVMVBZVBZURUOZVDZUSZUVBUYNVNVBZVBZUVDVBZUVFUYHVNVBZVBZVFZUVIUVJUVL
      UUKUYNVOVBZUOZUOZUVOVBZUVRUVTUWBUWCUYHVOVBZUOZUOZVFZKUVKUUKUYOUOZVHZJUVBU
      VKUYOUOZVHZDUYGVHZCUYGVHZVEZBUYGVHZVJZUMUYNVLVBZVPZUIUJVIUWPUNUYNGVFZUYHL
      VFZVEZVVDUWOUIUJVVGVVBUWOUMVVCEVQVVCVQUSVVGUYNVLVRVSVVGVVCGVLVBZEVVGUYNGV
      LVVEVVFVTWCSWAVVGUYGEVFZVEZVVBUUHUUTUWNVJZUWOVVJUYJUUHUYSUUTVVAUWNVVJUYJE
      FUUFWBUUHVVJUYGUYIEFUUFVVGVVIWDZVVJUYILVLVBZFVVJUYHLVLVVEVVFVVIWEZWCTWAWF
      FEUUFFVVMVQTLVLVRWGZEVVHVQSGVLVRWGZWHWIVVJUYRUUSUUIVVJUYRDUUJUYQVDUUSVVJD
      UYKUUJUYQVVJUYGEUYGEVVLVVLWJWKVVJDUUJUYQUURVVJUYMUUPUYPUUQURVVJUYLQUUMUUO
      VVJUYLLVMVBQVVJUYHLVMVVNWCUBWAWLVVJUUKUYOOVVJUYOGVMVBOVVJUYNGVMVVEVVFVVIW
      MZWCUAWAZWNWOWPXBWQVVJVUTUWMBUYGEVVLVVJVUEUVHVUSUWLVVJVUBUVEVUDUVGVVJVUAU
      VCUVDVVJUVBUYTIVVJUYTGVNVBIVVJUYNGVNVVQWCUCWAWNWCVVJUVFVUCPVVJVUCLVNVBPVV
      JUYHLVNVVNWCUDWAWNWRVVJVURUWKCUYGEVVLVVJVUQUWJDUYGEVVLVVJVUOUWHJVUPUWIVVJ
      UYOOUVBUVKVVRWLVVJVUMUWFKVUNUWGVVJUYOOUVKUUKVVRWLVVJVUIUVPVULUWEVVJVUHUVN
      UVOVVJVUGUVMUVIUVJVVJVUFHUVLUUKVVJVUFGVOVBHVVJUYNGVOVVQWCUEWAWLWLWCVVJVUK
      UWDUVRUVTVVJVUJRUWBUWCVVJVUJLVOVBRVVJUYHLVOVVNWCUFWAWLWLWRWSWSWSWSWTWSXAU
      UHUUTUWNXCZXDXEXFBCDULUKUIUJJKUMXGUWPUIUUGUUFXMZUUSUTZXHZUIUUGVWAFEURXIVV
      TUUSUUFXNUURVQUSZDUUJVHUUSVQUSVWCDUUJUUPUUQURXIXJDUUJUURVQXKXLXOXPUKUWPVW
      BUYNUUFUUIVGVFZUWOVEZUJXQUIXQVWDUVAVEZUJXQUIXQUYNUWPUSUYNVWBUSVWEVWFUIUJU
      WOUVAVWDUVAUWNVTXRXSUWOUIUJUYNYEUIUJUUGUUSUYNXTYAYBYCYDYFYGUWQMUUGUSZUXDU
      YEVJZUYFUWQMVQUSZNVQUSZVEZVWHUWOUIUJMNYHVWGUXDVWKUYEVWGVWIUXDVWJMUUGYONUX
      CYOYIYJUWOVWHUIUJMNUWPVQVQUWOVVKUUFMVFZUUINVFZVEZVWHVVSVWNUUHVWGUUTUXDUWN
      UYEVWNUUFMUUGVWLVWMVTZYKVWNUUINUUSUXCVWLVWMWDZVWNDUUJUURUXBVWNUUPUXAUUQUR
      VWNUUMUWSUUOUWTQVWNUULUUFMVWOWNVWNUUNUUFMVWOWNWOYLWPYMVWNUWMUYDBEVWNUVHUX
      IUWLUYCVWNUVEUXFUVGUXHVWNUVCUVDUXEVWNUUINUVBUVBVWPWLWNVWNUVFUXGPVWNUVBUUF
      MVWOWNZWCWRVWNUWJUYBCDEEVWNUWFUYAJKUWIUWGVWNUVPUXKUWEUXTVWNUVNUVOUXJVWNUU
      INUVBUUKVWPWLWNVWNUVRUXMUVTUXOUWDUXSVWNUWBUXQUWCUXRRVWNUVFUXGUWAUXPVWQVWN
      UVKUUFMVWOWNYPVWNUUKUUFMVWOWNWOVWNUVIUVQUXLVWNUUINUVKUUKVWPWLWNVWNUVJUVSU
      XNVWNUUINUVBUVKVWPWLWNYNWRYQYQWTYRXAYSUWPYTUUAUUBVWGUWRUXDUYEFEMVVOVVPWHU
      UCUUDXD $.

    isfuncd.1 $e |- ( ph -> F : B --> C ) $.
    isfuncd.2 $e |- ( ph -> G Fn ( B X. B ) ) $.
    isfuncd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x G y ) : ( x H y ) --> ( ( F ` x ) J ( F ` y ) ) ) $.
    isfuncd.4 $e |- ( ( ph /\ x e. B ) ->
      ( ( x G x ) ` ( .1. ` x ) ) = ( I ` ( F ` x ) ) ) $.
    isfuncd.5 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) /\
      ( m e. ( x H y ) /\ n e. ( y H z ) ) ) ->
        ( ( x G z ) ` ( n ( <. x , y >. .x. z ) m ) ) =
        ( ( ( y G z ) ` n ) ( <. ( F ` x ) , ( F ` y ) >.
            O ( F ` z ) ) ( ( x G y ) ` m ) ) ) $.
    $( Deduce that an operation is a functor of categories.  (Contributed by
       Mario Carneiro, 4-Jan-2017.) $)
    isfuncd $p |- ( ph -> F ( D Func E ) G ) $=
      ( cfunc co wbr wf cxp cv c1st cfv c2nd cmap cixp wcel wceq cop wa cvv wfn
      wral cbs fvex eqeltri xpex fnex sylancl ovex elmap ralrimivva fveq2 df-ov
      sylibr syl6eqr vex op1std fveq2d op2ndd oveq12d ralxp elixp2 syl3anbrc wi
      eleq12d w3a 3expia 3exp2 imp43 ralrimivv jca ralrimiva isfunc mpbir3and )
      AMNGLUNUOUPEFMUQNDEEURZDUSZUTVAZMVAZXEVBVAZMVAZQUOZXEOVAZVCUOZVDVEZBUSZIV
      AXNXNNUOVAXNMVAZPVAVFZKUSZJUSZXNCUSZVGZXEHUOUOXNXENUOVAXQXSXENUOVAXRXNXSN
      UOZVAXOXSMVAZVGXEMVARUOUOVFZKXSXEOUOZVKJXNXSOUOZVKZDEVKCEVKZVHZBEVKUIANVI
      VEZNXDVJZXENVAZXLVEZDXDVKZXMAYJXDVIVEYIUJEEEGVLVAVISGVLVMVNZYNVOXDVINVPVQ
      UJAYAXOYBQUOZYEVCUOZVEZCEVKBEVKYMAYQBCEEAXNEVEZXSEVEZVHVHYEYOYAUQYQUKYOYE
      YAXOYBQVRXNXSOVRVSWCVTYLYQDBCEEXEXTVFZYKYAXLYPYTYKXTNVAYAXEXTNWAXNXSNWBWD
      YTXJYOXKYEVCYTXGXOXIYBQYTXFXNMXNXSXEBWEZCWEZWFWGYTXHXSMXNXSXEUUAUUBWHWGWI
      YTXKXTOVAYEXEXTOWAXNXSOWBWDWIWNWJWCDXDXLNWKWLAYHBEAYRVHZXPYGULUUCYFCDEEUU
      CYSXEEVEZVHVHYCJKYEYDAYRYSUUDXRYEVEXQYDVEVHZYCWMZAYRYSUUDUUFAYRYSUUDWOUUE
      YCUMWPWQWRWSVTWTXAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHXBXC $.
  $}

  ${
    $d m n x y z B $.  $d m n x y z D $.  $d m n x y z E $.  $d m n x y z ph $.
    $d m n x y z F $.  $d m n x y z G $.
    funcf1.b $e |- B = ( Base ` D ) $.
    funcf1.c $e |- C = ( Base ` E ) $.
    funcf1.f $e |- ( ph -> F ( D Func E ) G ) $.
    $( The object part of a functor is a function on objects.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    funcf1 $p |- ( ph -> F : B --> C ) $=
      ( vz vx vn vm cv cfv co wcel wral eqid vy wf cxp c1st c2nd chom cmap cixp
      ccid wceq cop cco wa cfunc wbr w3a ccat df-br sylib funcrcl simpld simprd
      syl isfunc mpbid simp1d ) ABCFUBZGKBBUCKOZUDPFPVHUEPFPEUFPZQVHDUFPZPUGQUH
      RZLOZDUIPZPVLVLGQPVLFPZEUIPZPUJMOZNOZVLUAOZUKVHDULPZQQVLVHGQPVPVRVHGQPVQV
      LVRGQPVNVRFPUKVHFPEULPZQQUJMVRVHVJQSNVLVRVJQSKBSUABSUMLBSZAFGDEUNQZUOZVGV
      KWAUPJALUAKBCDVSVMNMEFGVJVOVIVTHIVJTVITVMTVOTVSTVTTADUQRZEUQRZAFGUKZWBRZW
      DWEUMAWCWGJFGWBURUSDEWFUTVCZVAAWDWEWHVBVDVEVF $.
  $}

  ${
    $d m n x y z B $.  $d m n x y z D $.  $d m n x y z E $.  $d m n x y z ph $.
    $d m n x y z F $.  $d m n x y z G $.  $d x y z J $.  $d z X $.  $d z Y $.
    $d m n x y z H $.
    funcixp.b $e |- B = ( Base ` D ) $.
    funcixp.h $e |- H = ( Hom ` D ) $.
    funcixp.j $e |- J = ( Hom ` E ) $.
    funcixp.f $e |- ( ph -> F ( D Func E ) G ) $.
    $( The morphism part of a functor is a function on homsets.  (Contributed
       by Mario Carneiro, 2-Jan-2017.) $)
    funcixp $p |- ( ph -> G e. X_ z e. ( B X. B )
      ( ( ( F ` ( 1st ` z ) ) J ( F ` ( 2nd ` z ) ) ) ^m ( H ` z ) ) ) $=
      ( vx cfv cv co wcel wral eqid vn vm cbs cxp c1st c2nd cmap cixp ccid wceq
      vy wf cop cco wa cfunc wbr w3a ccat df-br sylib funcrcl syl simpld simprd
      isfunc mpbid simp2d ) ACEUCOZFULZGBCCUDBPZUEOFOVKUFOFOIQVKHOUGQUHRZNPZDUI
      OZOVMVMGQOVMFOZEUIOZOUJUAPZUBPZVMUKPZUMVKDUNOZQQVMVKGQOVQVSVKGQOVRVMVSGQO
      VOVSFOUMVKFOEUNOZQQUJUAVSVKHQSUBVMVSHQSBCSUKCSUONCSZAFGDEUPQZUQZVJVLWBURM
      ANUKBCVIDVTVNUBUAEFGHVPIWAJVITKLVNTVPTVTTWATADUSRZEUSRZAFGUMZWCRZWEWFUOAW
      DWHMFGWCUTVADEWGVBVCZVDAWEWFWIVEVFVGVH $.

    funcf2.x $e |- ( ph -> X e. B ) $.
    funcf2.y $e |- ( ph -> Y e. B ) $.
    $( The morphism part of a functor is a function on homsets.  (Contributed
       by Mario Carneiro, 2-Jan-2017.) $)
    funcf2 $p |- ( ph ->
      ( X G Y ) : ( X H Y ) --> ( ( F ` X ) J ( F ` Y ) ) ) $=
      ( co cfv cmap wcel vz wf cop c1st c2nd df-ov cixp funcixp opelxpi syl2anc
      cxp wceq fveq2 fveq2d oveq12d syl6eqr fvixp syl5eqel op1stg op2ndg oveq1d
      cv wa eleqtrd elmapi syl ) AIJFQZIERZJERZHQZIJGQZSQZTVKVJVGUBAVGIJUCZUDRZ
      ERZVMUERZERZHQZVKSQZVLAVGVMFRZVSIJFUFAFUABBUKZUAVBZUDRZERZWBUERZERZHQZWBG
      RZSQZUGTVMWATZVTVSTAUABCDEFGHKLMNUHAIBTZJBTZWJOPIJBBUIUJUAWAWIVMVSFWBVMUL
      ZWGVRWHVKSWMWDVOWFVQHWMWCVNEWBVMUDUMUNWMWEVPEWBVMUEUMUNUOWMWHVMGRVKWBVMGU
      MIJGUFUPUOUQUJURAVRVJVKSAWKWLVRVJULOPWKWLVCZVOVHVQVIHWNVNIEIJBBUSUNWNVPJE
      IJBBUTUNUOUJVAVDVGVJVKVEVF $.
  $}

  ${
    $d x B $.  $d x D $.  $d x E $.  $d x F $.  $d x G $.  $d x ph $.
    funcfn2.b $e |- B = ( Base ` D ) $.
    funcfn2.f $e |- ( ph -> F ( D Func E ) G ) $.
    $( The morphism part of a functor is a function.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    funcfn2 $p |- ( ph -> G Fn ( B X. B ) ) $=
      ( vx cxp cv c1st cfv c2nd chom co cmap cixp wcel eqid wfn funcixp ixpfn
      syl ) AFIBBJZIKZLMEMUFNMEMDOMZPUFCOMZMQPZRSFUEUAAIBCDEFUHUGGUHTUGTHUBIUEU
      IFUCUD $.
  $}

  ${
    $d m n x y z B $.  $d m n x y z D $.  $d m n x y z E $.  $d m n x y z ph $.
    $d x .1. $.  $d m n x y z F $.  $d m n x y z G $.  $d x I $.  $d x X $.
    funcid.b $e |- B = ( Base ` D ) $.
    funcid.1 $e |- .1. = ( Id ` D ) $.
    funcid.i $e |- I = ( Id ` E ) $.
    funcid.f $e |- ( ph -> F ( D Func E ) G ) $.
    funcid.x $e |- ( ph -> X e. B ) $.
    $( A functor maps each identity to the corresponding identity in the target
       category.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    funcid $p |- ( ph -> ( ( X G X ) ` ( .1. ` X ) ) = ( I ` ( F ` X ) ) ) $=
      ( vx wcel cv cfv co wral vn vm vy vz wceq cop cco chom wa cbs wf cxp c1st
      c2nd cmap cixp cfunc wbr w3a eqid ccat df-br funcrcl simpld simprd isfunc
      sylib syl mpbid simp3d simpl ralimi id oveq12d fveq2 fveq12d fveq2d rspcv
      eqeq12d sylc ) AIBPOQZDRZWAWAGSZRZWAFRZHRZUEZOBTZIDRZIIGSZRZIFRZHRZUEZNAW
      GUAQZUBQZWAUCQZUFUDQZCUGRZSSWAWRGSRWOWQWRGSRWPWAWQGSRWEWQFRUFWRFREUGRZSSU
      EUAWQWRCUHRZSTUBWAWQXASTUDBTUCBTZUIZOBTZWHABEUJRZFUKZGUDBBULWRUMRFRWRUNRF
      REUHRZSWRXARUOSUPPZXDAFGCEUQSZURZXFXHXDUSMAOUCUDBXECWSDUBUAEFGXAHXGWTJXEU
      TXAUTXGUTKLWSUTWTUTACVAPZEVAPZAFGUFZXIPZXKXLUIAXJXNMFGXIVBVGCEXMVCVHZVDAX
      KXLXOVEVFVIVJXCWGOBWGXBVKVLVHWGWNOIBWAIUEZWDWKWFWMXPWBWIWCWJXPWAIWAIGXPVM
      ZXQVNWAIDVOVPXPWEWLHWAIFVOVQVSVRVT $.
  $}

  ${
    $d m n x y z B $.  $d m n x y z D $.  $d m n x y z E $.  $d m n x y z ph $.
    $d m n x y z F $.  $d m n x y z G $.  $d m n x y z H $.  $d m n x y z M $.
    $d m n x y z N $.  $d m n x y z O $.  $d m n x y z X $.  $d m n x y z Y $.
    $d m n x y z .x. $.  $d m n x y z Z $.
    funcco.b $e |- B = ( Base ` D ) $.
    funcco.h $e |- H = ( Hom ` D ) $.
    funcco.o $e |- .x. = ( comp ` D ) $.
    funcco.O $e |- O = ( comp ` E ) $.
    funcco.f $e |- ( ph -> F ( D Func E ) G ) $.
    funcco.x $e |- ( ph -> X e. B ) $.
    funcco.y $e |- ( ph -> Y e. B ) $.
    funcco.z $e |- ( ph -> Z e. B ) $.
    funcco.m $e |- ( ph -> M e. ( X H Y ) ) $.
    funcco.n $e |- ( ph -> N e. ( Y H Z ) ) $.
    $( A functor maps composition in the source category to composition in the
       target.  (Contributed by Mario Carneiro, 2-Jan-2017.) $)
    funcco $p |- ( ph -> ( ( X G Z ) ` ( N ( <. X , Y >. .x. Z ) M ) ) =
      ( ( ( Y G Z ) ` N ) ( <. ( F ` X ) , ( F ` Y ) >.
          O ( F ` Z ) ) ( ( X G Y ) ` M ) ) ) $=
      ( vx vn vm vy vz cv ccid cfv co wceq cop wral cbs cxp c1st c2nd chom cmap
      wa wf cixp wcel cfunc wbr w3a eqid ccat df-br sylib funcrcl simpld simprd
      syl isfunc mpbid simp3d adantr ad2antrr ad3antrrr simpllr simplr eleqtrrd
      oveq12d ad4antr simp-5r simp-4r opeq12d oveq123d fveq12d eqeq12d rspcimdv
      simpr fveq2d rspcdv adantld mpd ) AUEUJZCUKULZULXAXAGUMULXAFULZEUKULZULUN
      ZUFUJZUGUJZXAUHUJZUOZUIUJZDUMZUMZXAXJGUMZULZXFXHXJGUMZULZXGXAXHGUMZULZXCX
      HFULZUOZXJFULZKUMZUMZUNZUFXHXJHUMZUPZUGXAXHHUMZUPZUIBUPZUHBUPZVCZUEBUPZJI
      LMUOZNDUMZUMZLNGUMZULZJMNGUMZULZILMGUMZULZLFULZMFULZUOZNFULZKUMZUMZUNZABE
      UQULZFVDZGUIBBURXJUSULFULXJUTULFULEVAULZUMXJHULVBUMVEVFZYLAFGCEVGUMZVHZUU
      JUULYLVISAUEUHUIBUUICDXBUGUFEFGHXDUUKKOUUIVJPUUKVJXBVJXDVJQRACVKVFZEVKVFZ
      AFGUOZUUMVFZUUOUUPVCAUUNUURSFGUUMVLVMCEUUQVNVQZVOAUUOUUPUUSVPVRVSVTAYKUUH
      UELBTAXALUNZVCZYJUUHXEUVAYIUUHUHMBAMBVFUUTUAWAUVAXHMUNZVCZYHUUHUINBANBVFU
      UTUVBUBWBUVCXJNUNZVCZYFUUHUGIYGUVEILMHUMZYGAIUVFVFUUTUVBUVDUCWCUVEXALXHMH
      AUUTUVBUVDWDUVAUVBUVDWEWGWFUVEXGIUNZVCZYDUUHUFJYEUVHJMNHUMZYEAJUVIVFUUTUV
      BUVDUVGUDWHUVHXHMXJNHUVAUVBUVDUVGWDUVCUVDUVGWEWGWFUVHXFJUNZVCZXNYQYCUUGUV
      KXLYOXMYPUVKXALXJNGAUUTUVBUVDUVGUVJWIZUVCUVDUVGUVJWDZWGUVKXFJXGIXKYNUVKXI
      YMXJNDUVKXALXHMUVLUVAUVBUVDUVGUVJWJZWKUVMWGUVHUVJWPZUVEUVGUVJWEZWLWMUVKXP
      YSXRUUAYBUUFUVKXTUUDYAUUEKUVKXCUUBXSUUCUVKXALFUVLWQUVKXHMFUVNWQWKUVKXJNFU
      VMWQWGUVKXFJXOYRUVKXHMXJNGUVNUVMWGUVOWMUVKXGIXQYTUVKXALXHMGUVLUVNWGUVPWMW
      LWNWRWOWOWOWSWOWT $.
  $}

  ${
    funcsect.b $e |- B = ( Base ` D ) $.
    funcsect.s $e |- S = ( Sect ` D ) $.
    funcsect.t $e |- T = ( Sect ` E ) $.
    funcsect.f $e |- ( ph -> F ( D Func E ) G ) $.
    funcsect.x $e |- ( ph -> X e. B ) $.
    funcsect.y $e |- ( ph -> Y e. B ) $.
    funcsect.m $e |- ( ph -> M ( X S Y ) N ) $.
    $( The image of a section under a functor is a section.  (Contributed by
       Mario Carneiro, 2-Jan-2017.) $)
    funcsect $p |- ( ph ->
      ( ( X G Y ) ` M ) ( ( F ` X ) T ( F ` Y ) ) ( ( Y G X ) ` N ) ) $=
      ( cfv co wbr cop cco ccid wceq chom wcel eqid ccat cfunc wa df-br funcrcl
      w3a sylib simpld issect simp3d fveq2d simp1d simp2d funcco funcid 3eqtr3d
      syl mpbid cbs simprd funcf1 ffvelrnd funcf2 issect2 mpbird ) AIKLHUAZTZJL
      KHUAZTZKGTZLGTZEUAUBVRVPVSVTUCVSFUDTZUAUAZVSFUETZTZUFAJIKLUCKCUDTZUAUAZKK
      HUAZTKCUETZTZWGTWBWDAWFWIWGAIKLCUGTZUAZUHZJLKWJUAZUHZWFWIUFZAIJKLDUAUBWLW
      NWOUOSABCDWEWHIJWJKLMWJUIZWEUIZWHUIZNACUJUHZFUJUHZAGHUCZCFUKUAZUHZWSWTULA
      GHXBUBXCPGHXBUMUPCFXAUNVFZUQQRURVGZUSUTABCWEFGHWJIJWAKLKMWPWQWAUIZPQRQAWL
      WNWOXEVAZAWLWNWOXEVBZVCABCWHFGHWCKMWRWCUIZPQVDVEAFVHTZFEWAWCVPVRFUGTZVSVT
      XJUIZXKUIZXFXIOAWSWTXDVIABXJKGABXJCFGHMXLPVJZQVKABXJLGXNRVKAWKVSVTXKUAIVO
      ABCFGHWJXKKLMWPXMPQRVLXGVKAWMVTVSXKUAJVQABCFGHWJXKLKMWPXMPRQVLXHVKVMVN $.
  $}

  ${
    funcinv.b $e |- B = ( Base ` D ) $.
    funcinv.s $e |- I = ( Inv ` D ) $.
    funcinv.t $e |- J = ( Inv ` E ) $.
    funcinv.f $e |- ( ph -> F ( D Func E ) G ) $.
    funcinv.x $e |- ( ph -> X e. B ) $.
    funcinv.y $e |- ( ph -> Y e. B ) $.
    funcinv.m $e |- ( ph -> M ( X I Y ) N ) $.
    $( The image of an inverse under a functor is an inverse.  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    funcinv $p |- ( ph ->
      ( ( X G Y ) ` M ) ( ( F ` X ) J ( F ` Y ) ) ( ( Y G X ) ` N ) ) $=
      ( co cfv wbr csect eqid wa ccat wcel cop cfunc df-br sylib funcrcl simpld
      syl isinv mpbid funcsect simprd cbs funcf1 ffvelrnd mpbir2and ) AIKLFTUAZ
      JLKFTUAZKEUAZLEUAZHTUBVCVDVEVFDUCUAZTUBVDVCVFVEVGTUBABCCUCUAZVGDEFIJKLMVH
      UDZVGUDZPQRAIJKLVHTUBZJILKVHTUBZAIJKLGTUBVKVLUESABCVHIJGKLMNACUFUGZDUFUGZ
      AEFUHZCDUITZUGZVMVNUEAEFVPUBVQPEFVPUJUKCDVOULUNZUMQRVIUOUPZUMUQABCVHVGDEF
      JILKMVIVJPRQAVKVLVSURUQADUSUAZDVGVCVDHVEVFVTUDZOAVMVNVRURABVTKEABVTCDEFMW
      APUTZQVAABVTLEWBRVAVJUOVB $.
  $}

  ${
    funciso.b $e |- B = ( Base ` D ) $.
    funciso.s $e |- I = ( Iso ` D ) $.
    funciso.t $e |- J = ( Iso ` E ) $.
    funciso.f $e |- ( ph -> F ( D Func E ) G ) $.
    funciso.x $e |- ( ph -> X e. B ) $.
    funciso.y $e |- ( ph -> Y e. B ) $.
    funciso.m $e |- ( ph -> M e. ( X I Y ) ) $.
    $( The image of an isomorphism under a functor is an isomorphism.
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    funciso $p |- ( ph -> ( ( X G Y ) ` M ) e. ( ( F ` X ) J ( F ` Y ) ) ) $=
      ( cfv co cbs cinv eqid ccat wcel cop cfunc wa wbr df-br sylib funcrcl syl
      simprd funcf1 ffvelrnd cdm simpld isoval eleqtrd wb invfun funfvbrb mpbid
      wfun funcinv inviso1 ) ADUASZDIJKFTSIJKCUBSZTZSZKJFTSHDUBSZJESKESVHUCZVLU
      CZACUDUEZDUDUEZAEFUFZCDUGTZUEZVOVPUHAEFVRUIVSOEFVRUJUKCDVQULUMZUNABVHJEAB
      VHCDEFLVMOUOZPUPABVHKEWAQUPNABCDEFVIVLIVKJKLVIUCZVNOPQAIVJUQZUEZIVKVJUIZA
      IJKGTWCRABCGVIJKLWBAVOVPVTURZPQMUSUTAVJVEWDWEVAABCVIJKLWBWFPQVBIVJVCUMVDV
      FVG $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z F $.  $d f g x y z G $.  $d f g x y z ph $.
    $d f g x y z O $.  $d f g x y z P $.
    funcoppc.o $e |- O = ( oppCat ` C ) $.
    funcoppc.p $e |- P = ( oppCat ` D ) $.
    funcoppc.f $e |- ( ph -> F ( C Func D ) G ) $.
    $( A functor on categories yields a functor on the opposite categories (in
       the same direction).  (Contributed by Mario Carneiro, 4-Jan-2017.) $)
    funcoppc $p |- ( ph -> F ( O Func P ) tpos G ) $=
      ( cfv cco ccid eqid wcel cop co wa syl cv vx vy vz vf vg cbs chom oppcbas
      ctpos ccat cfunc wbr df-br sylib funcrcl simpld oppccat simprd funcf1 cxp
      funcfn2 tposfn wf adantr simprr simprl funcf2 ovtpos feq1i oppchom feq23i
      wfn bitri sylibr simpr funcid wceq oppcid fveq1d fveq12d 3eqtr4d 3ad2ant1
      simp23 simp22 simp21 simp3r syl6eleq simp3l funcco oppcco fveq2d ffvelrnd
      a1i w3a fveq1i oveq12i 3eqtr4g isfuncd ) AUAUBUCBUFKZCUFKZGGLKZGMKZUDUEDE
      FUIZGUGKZDMKZDUGKZDLKZWSBGHWSNZUHWTCDIWTNZUHXDNXFNXBNXENXANXGNABUJOZGUJOA
      XJCUJOZAEFPZBCUKQZOZXJXKRAEFXMULZXNJEFXMUMUNBCXLUOSZUPZBGHUQSAXKDUJOAXJXK
      XPURZCDIUQSAWSWTBCEFXHXIJUSZAFWSWSUTZVLXCXTVLAWSBCEFXHJVAWSWSFVBSAUATZWSO
      ZUBTZWSOZRZRZYCYABUGKZQZYCEKZYAEKZCUGKZQZYCYAFQZVCZYAYCXDQZYJYIXFQZYAYCXC
      QZVCZYFWSBCEFYGYKYCYAXHYGNZYKNZAXOYEJVDAYBYDVEAYBYDVFVGYRYOYPYMVCYNYOYPYQ
      YMYAYCFVHZVIYOYPYHYLYMBYGGYAYCYSHVJZCYKDYJYIYTIVJVKVMVNAYBRZYABMKZKZYAYAF
      QZKYJCMKZKYAXBKZYAYAXCQZKYJXEKUUCWSBUUDCEFUUGYAXHUUDNZUUGNZAXOYBJVDAYBVOV
      PUUCUUHUUEUUIUUFUUIUUFVQUUCYAYAFVHWMUUCYAXBUUDAXBUUDVQZYBAXJUULXQUUDBGHUU
      JVRSVDVSVTUUCYJXEUUGAXEUUGVQZYBAXKUUMXRUUGCDIUUKVRSVDVSWAAYBYDUCTZWSOZWNZ
      UDTZYOOZUETZYCUUNXDQZOZRZWNZUUSUUQYAYCPUUNXAQQZUUNYAFQZKZUUSUUNYCFQZKZUUQ
      YMKZYJYIPUUNEKZXGQZQZUVDYAUUNXCQZKUUSYCUUNXCQZKZUUQYQKZUVKQUVCUUQUUSUUNYC
      PYABLKZQQZUVEKUVIUVHUVJYIPYJCLKZQQUVFUVLUVCWSBUVQCEFYGUUSUUQUVSUUNYCYAXHY
      SUVQNZUVSNZAUUPXOUVBJWBAYBYDUUOUVBWCZAYBYDUUOUVBWDZAYBYDUUOUVBWEZUVCUUSUU
      TUUNYCYGQAUUPUURUVAWFBYGGYCUUNYSHVJWGUVCUUQYOYHAUUPUURUVAWHUUBWGWIUVCUVDU
      VRUVEUVCWSBUVQUUQUUSGYAYCUUNXHUVTHUWDUWCUWBWJWKUVCWTCUVSUVIUVHDYJYIUVJXIU
      WAIUVCWSWTYAEAUUPWSWTEVCUVBXSWBZUWDWLUVCWSWTYCEUWEUWCWLUVCWSWTUUNEUWEUWBW
      LWJWAUVDUVMUVEYAUUNFVHWOUVOUVHUVPUVIUVKUUSUVNUVGYCUUNFVHWOUUQYQYMUUAWOWPW
      QWR $.
  $}

  ${
    $d b c z B $.  $d b c z C $.  $d b c z H $.  $d z ph $.  $d z X $.
    $d z Y $.
    idfuval.i $e |- I = ( idFunc ` C ) $.
    idfuval.b $e |- B = ( Base ` C ) $.
    idfuval.c $e |- ( ph -> C e. Cat ) $.
    ${
      idfuval.h $e |- H = ( Hom ` C ) $.
      $( Value of the composition of two functors.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      idfuval $p |- ( ph -> I =
        <. ( _I |` B ) , ( z e. ( B X. B ) |-> ( _I |` ( H ` z ) ) ) >. ) $=
        ( vc vb cidfu cfv cid cres cv wceq cbs chom cxp cmpt cop ccat wcel fvex
        csb cvv a1i fveq2 syl6eqr simpr reseq2d xpeq12d fveq2d fveq1d mpteq12dv
        wa simpl opeq12d csbied2 df-idfu opex fvmpt syl syl5eq ) AFDMNZOCPZBCCU
        AZOBQZENZPZUBZUCZGADUDUEVGVNRIKDLKQZSNZOLQZPZBVQVQUAZOVJVOTNZNZPZUBZUCZ
        UGVNUDMVODRZLVPCWDVNUHVPUHUEWEVOSUFUIWEVPDSNCVODSUJHUKWEVQCRZURZVRVHWCV
        MWGVQCOWEWFULZUMWGBVSWBVIVLWGVQCVQCWHWHUNWGWAVKOWGVJVTEWGVTDTNEWGVODTWE
        WFUSUOJUKUPUMUQUTVABKLVBVHVMVCVDVEVF $.

      idfu2nd.x $e |- ( ph -> X e. B ) $.
      idfu2nd.y $e |- ( ph -> Y e. B ) $.
      $( Value of the morphism part of the identity functor.  (Contributed by
         Mario Carneiro, 3-Jan-2017.) $)
      idfu2nd $p |- ( ph -> ( X ( 2nd ` I ) Y ) = ( _I |` ( X H Y ) ) ) $=
        ( vz c2nd cfv cid cres cvv wcel co cop df-ov cv cxp cmpt idfuval fveq2d
        cbs fvex eqeltri resiexg ax-mp xpex mptex op2nd syl6eq wa simpr syl6eqr
        wceq reseq2d opelxpi syl2anc ovex mp1i fvmptd syl5eq ) AFGEOPZUAFGUBZVI
        PQFGDUAZRZFGVIUCANVJQNUDZDPZRZVLBBUEZVISAVIQBRZNVPVOUFZUBZOPVRAEVSOANBC
        DEHIJKUGUHVQVRBSTVQSTBCUIPSICUIUJUKZBSULUMNVPVOBBVTVTUNUOUPUQAVMVJVAZUR
        ZVNVKQWBVNVJDPVKWBVMVJDAWAUSUHFGDUCUTVBAFBTGBTVJVPTLMFGBBVCVDVKSTVLSTAF
        GDVEVKSULVFVGVH $.

      idfu2.f $e |- ( ph -> F e. ( X H Y ) ) $.
      $( Value of the morphism part of the identity functor.  (Contributed by
         Mario Carneiro, 28-Jan-2017.) $)
      idfu2 $p |- ( ph -> ( ( X ( 2nd ` I ) Y ) ` F ) = F ) $=
        ( c2nd cfv co cid cres idfu2nd fveq1d wcel wceq fvresi syl eqtrd ) ADGH
        FPQRZQDSGHERZTZQZDADUHUJABCEFGHIJKLMNUAUBADUIUCUKDUDOUIDUEUFUG $.
    $}

    $( Value of the object part of the identity functor.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    idfu1st $p |- ( ph -> ( 1st ` I ) = ( _I |` B ) ) $=
      ( vz c1st cfv cid cres cxp cv chom cmpt cop cvv wcel cbs eqid fveq2d fvex
      idfuval eqeltri resiexg ax-mp xpex mptex op1st syl6eq ) ADIJKBLZHBBMZKHNC
      OJZJLZPZQZIJULADUQIAHBCUNDEFGUNUAUDUBULUPBRSULRSBCTJRFCTUCUEZBRUFUGHUMUOB
      BURURUHUIUJUK $.

    idfu1.x $e |- ( ph -> X e. B ) $.
    $( Value of the object part of the identity functor.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    idfu1 $p |- ( ph -> ( ( 1st ` I ) ` X ) = X ) $=
      ( c1st cfv cid cres idfu1st fveq1d wcel wceq fvresi syl eqtrd ) AEDJKZKEL
      BMZKZEAEUAUBABCDFGHNOAEBPUCEQIBERST $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z I $.
    idfucl.i $e |- I = ( idFunc ` C ) $.
    $( The identity functor is a functor.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    idfucl $p |- ( C e. Cat -> I e. ( C Func C ) ) $=
      ( vz vx vg vf vy wcel cid cfv cop co cv cvv wceq wral wa fvresi syl cfunc
      ccat cbs cres c2nd cxp chom cmpt eqid id idfuval fveq2d fvex resiexg xpex
      ax-mp mptex syl6eq opeq2d eqtr4d wbr wf c1st cmap cixp ccid cco wf1o f1oi
      op2nd f1of elmap mpbir xp1st adantl xp2nd oveq12d df-ov 1st2nd2 syl5eleqr
      mp1i oveq1d ralrimiva mptelixpg sylibr eqeltrd simpl simpr catidcl fveq1d
      wb idfu2nd 3eqtr4d ad2antrr simplrl simplrr simprl simprr catcocl opeq12d
      idfu2 oveq123d ralrimivva jca isfunc mpbir3and df-br sylib ) AUBIZBJAUCKZ
      UDZBUEKZLZAAUAMZXIBXKDXJXJUFZJDNZAUGKZKZUDZUHZLZXMXIDXJAXQBCXJUIZXIUJZXQU
      IZUKZXIXLXTXKXIXLYAUEKXTXIBYAUEYEULXKXTXJOIXKOIAUCUMZXJOUNUPDXOXSXJXJYFYF
      UOZUQVJURZUSUTXIXKXLXNVAZXMXNIXIYIXJXJXKVBZXLDXOXPVCKZXKKZXPUEKZXKKZXQMZX
      RVDMZVEZIENZAVFKZKZYRYRXLMZKZYRXKKZYSKZPZFNZGNZYRHNZLZXPAVGKZMZMZYRXPXLMZ
      KZUUFUUHXPXLMKZUUGYRUUHXLMKZUUCUUHXKKZLZXPXKKZUUJMZMZPZFUUHXPXQMZQGYRUUHX
      QMZQZDXJQHXJQZRZEXJQXJXJXKVHYJXIXJVIXJXJXKVKWAXIXLXTYQYHXIXSYPIZDXOQZXTYQ
      IZXIUVHDXOXIXPXOIZRZXSXRXRVDMZYPXSUVMIXRXRXSVBZXRXRXSVHUVNXRVIXRXRXSVKUPX
      RXRXSXPXQUMZUVOVLVMUVLYOXRXRVDUVLYOYKYMLZXQKZXRUVLYOYKYMXQMUVQUVLYLYKYNYM
      XQUVLYKXJIZYLYKPUVKUVRXIXPXJXJVNVOXJYKSTUVLYMXJIZYNYMPUVKUVSXIXPXJXJVPVOX
      JYMSTVQYKYMXQVRURUVLXPUVPXQUVKXPUVPPXIXPXJXJVSVOULUTWBVTWCXOOIUVJUVIWKYGD
      XOXSYPOWDUPWEWFXIUVGEXJXIYRXJIZRZUUEUVFUWAYTJYRYRXQMZUDZKZYTUUBUUDUWAYTUW
      BIUWDYTPUWAXJAYSXQYRYBYDYSUIZXIUVTWGZXIUVTWHZWIUWBYTSTUWAYTUUAUWCUWAXJAXQ
      BYRYRCYBUWFYDUWGUWGWLWJUWAUUCYRYSUVTUUCYRPZXIXJYRSZVOULWMUWAUVEHDXJXJUWAU
      UHXJIZXPXJIZRZRZUVBGFUVDUVCUWMUUGUVDIZUUFUVCIZRZRZUULJYRXPXQMZUDZKZUULUUN
      UVAUWQUULUWRIUWTUULPUWQXJAUUJUUGUUFXQYRUUHXPYBYDUUJUIZUWAXIUWLUWPUWFWNZUW
      AUVTUWLUWPUWGWNZUWAUWJUWKUWPWOZUWAUWJUWKUWPWPZUWMUWNUWOWQZUWMUWNUWOWRZWSU
      WRUULSTUWQUULUUMUWSUWQXJAXQBYRXPCYBUXBYDUXCUXEWLWJUWQUUOUUFUUPUUGUUTUUKUW
      QUURUUIUUSXPUUJUWQUUCYRUUQUUHUWQUVTUWHUXCUWITUWQUWJUUQUUHPUXDXJUUHSTWTUWQ
      UWKUUSXPPUXEXJXPSTVQUWQXJAUUFXQBUUHXPCYBUXBYDUXDUXEUXGXAUWQXJAUUGXQBYRUUH
      CYBUXBYDUXCUXDUXFXAXBWMXCXCXDWCXIEHDXJXJAUUJYSGFAXKXLXQYSXQUUJYBYBYDYDUWE
      UWEUXAUXAYCYCXEXFXKXLXNXGXHWF $.
  $}

  ${
    $d f g x y z B $.  $d z C $.  $d z D $.  $d f g x y z F $.  $d f g x y G $.
    $d f g x y ph $.  $d x y X $.  $d x y Y $.
    cofuval.b $e |- B = ( Base ` C ) $.
    cofuval.f $e |- ( ph -> F e. ( C Func D ) ) $.
    cofuval.g $e |- ( ph -> G e. ( D Func E ) ) $.
    $( Value of the composition of two functors.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    cofuval $p |- ( ph -> ( G o.func F ) =
      <. ( ( 1st ` G ) o. ( 1st ` F ) ) ,
         ( x e. B , y e. B |-> ( ( ( ( 1st ` F ) ` x ) ( 2nd ` G )
           ( ( 1st ` F ) ` y ) ) o. ( x ( 2nd ` F ) y ) ) ) >. ) $=
      ( vg vf cvv c1st cfv c2nd co wcel cv ccom cdm cmpt2 cop ccofu df-cofu a1i
      wceq wa simprl fveq2d simprr coeq12d cxp dmeqd wfn cfunc wrel wbr relfunc
      1st2ndbr sylancr funcfn2 fndm syl adantr eqtrd dmxpid syl6eq fveq1d oveqd
      oveq123d mpt2eq123dv opeq12d elex opex ovmpt2d ) AMNIHOOMUAZPQZNUAZPQZUBZ
      BCWARQZUCZUCZWFBUAZWBQZCUAZWBQZVSRQZSZWGWIWDSZUBZUDZUEZIPQZHPQZUBZBCDDWGW
      RQZWIWRQZIRQZSZWGWIHRQZSZUBZUDZUEZUFOUFMNOOWPUDUIABCNMUGUHAVSIUIZWAHUIZUJ
      ZUJZWCWSWOXGXLVTWQWBWRXLVSIPAXIXJUKZULXLWAHPAXIXJUMZULZUNXLBCWFWFWNDDXFXL
      WFDDUOZUCDXLWEXPXLWEXDUCZXPXLWDXDXLWAHRXNULZUPAXQXPUIZXKAXDXPUQXSADEFWRXD
      JAEFURSZUSHXTTZWRXDXTUTEFVAKHXTVBVCVDXPXDVEVFVGVHUPDVIVJZYBXLWLXCWMXEXLWH
      WTWJXAWKXBXLVSIRXMULXLWGWBWRXOVKXLWIWBWRXOVKVMXLWDXDWGWIXRVLUNVNVOAIFGURS
      ZTIOTLIYCVPVFAYAHOTKHXTVPVFXHOTAWSXGVQUHVR $.

    $( Value of the object part of the functor composition.  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    cofu1st $p |- ( ph ->
      ( 1st ` ( G o.func F ) ) = ( ( 1st ` G ) o. ( 1st ` F ) ) ) $=
      ( vx vy co c1st cfv ccom cv c2nd fvex cbs ccofu cmpt2 cofuval fveq2d coex
      cop cvv eqeltri mpt2ex op1st syl6eq ) AGFUAMZNOGNOZFNOZPZKLBBKQZUNOLQZUNO
      GROMUPUQFROMPZUBZUFZNOUOAULUTNAKLBCDEFGHIJUCUDUOUSUMUNGNSFNSUEKLBBURBCTOU
      GHCTSUHZVAUIUJUK $.

    cofu2nd.x $e |- ( ph -> X e. B ) $.
    $( Value of the object part of the functor composition.  (Contributed by
       Mario Carneiro, 28-Jan-2017.) $)
    cofu1 $p |- ( ph -> ( ( 1st ` ( G o.func F ) ) ` X ) =
      ( ( 1st ` G ) ` ( ( 1st ` F ) ` X ) ) ) $=
      ( ccofu co c1st cfv ccom cofu1st fveq1d wcel wf wceq c2nd eqid cfunc wrel
      cbs wbr relfunc 1st2ndbr sylancr funcf1 fvco3 syl2anc eqtrd ) AHGFMNOPZPH
      GOPZFOPZQZPZHURPUQPZAHUPUSABCDEFGIJKRSABDUGPZURUAHBTUTVAUBABVBCDURFUCPZIV
      BUDACDUENZUFFVDTURVCVDUHCDUIJFVDUJUKULLBVBHUQURUMUNUO $.

    cofu2nd.y $e |- ( ph -> Y e. B ) $.
    $( Value of the morphism part of the functor composition.  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    cofu2nd $p |- ( ph ->
      ( X ( 2nd ` ( G o.func F ) ) Y ) = ( ( ( ( 1st ` F ) ` X ) ( 2nd ` G )
           ( ( 1st ` F ) ` Y ) ) o. ( X ( 2nd ` F ) Y ) ) ) $=
      ( vx vy c1st cfv c2nd co cv ccom ccofu cvv cmpt2 cofuval fveq2d fvex coex
      cop cbs eqeltri mpt2ex op2nd syl6eq wceq wa simprl simprr oveq12d coeq12d
      wcel ovex a1i ovmpt2d ) AOPHIBBOUAZFQRZRZPUAZVGRZGSRZTZVFVIFSRZTZUBZHVGRZ
      IVGRZVKTZHIVMTZUBZGFUCTZSRZUDAWBGQRZVGUBZOPBBVOUEZUJZSRWEAWAWFSAOPBCDEFGJ
      KLUFUGWDWEWCVGGQUHFQUHUIOPBBVOBCUKRUDJCUKUHULZWGUMUNUOAVFHUPZVIIUPZUQUQZV
      LVRVNVSWJVHVPVJVQVKWJVFHVGAWHWIURZUGWJVIIVGAWHWIUSZUGUTWJVFHVIIVMWKWLUTVA
      MNVTUDVBAVRVSVPVQVKVCHIVMVCUIVDVE $.

    cofu2.h $e |- H = ( Hom ` C ) $.
    cofu2.y $e |- ( ph -> R e. ( X H Y ) ) $.
    $( Value of the morphism part of the functor composition.  (Contributed by
       Mario Carneiro, 28-Jan-2017.) $)
    cofu2 $p |- ( ph -> ( ( X ( 2nd ` ( G o.func F ) ) Y ) ` R ) =
      ( ( ( ( 1st ` F ) ` X ) ( 2nd ` G ) ( ( 1st ` F ) ` Y ) ) `
        ( ( X ( 2nd ` F ) Y ) ` R ) ) ) $=
      ( co cfv ccofu c2nd c1st ccom cofu2nd fveq1d chom wf wcel wceq eqid cfunc
      wrel wbr relfunc 1st2ndbr sylancr funcf2 fvco3 syl2anc eqtrd ) AEJKHGUASU
      BTSZTEJGUCTZTZKVCTZHUBTSZJKGUBTZSZUDZTZEVHTVFTZAEVBVIABCDFGHJKLMNOPUEUFAJ
      KISZVDVEDUGTZSZVHUHEVLUIVJVKUJABCDVCVGIVMJKLQVMUKACDULSZUMGVOUIVCVGVOUNCD
      UOMGVOUPUQOPURRVLVNEVFVHUSUTVA $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y G $.  $d x y H $.  $d x y ph $.
    $d x y K $.
    cofuval2.b $e |- B = ( Base ` C ) $.
    cofuval2.f $e |- ( ph -> F ( C Func D ) G ) $.
    cofuval2.x $e |- ( ph -> H ( D Func E ) K ) $.
    $( Value of the composition of two functors.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    cofuval2 $p |- ( ph -> ( <. H , K >. o.func <. F , G >. ) = <. ( H o. F ) ,
     ( x e. B , y e. B |-> ( ( ( F ` x ) K ( F ` y ) ) o. ( x G y ) ) ) >. ) $=
      ( cop co cfv ccom wcel cvv ccofu c1st cv c2nd cmpt2 cfunc wbr df-br sylib
      cofuval wceq wrel relfunc brrelex12 sylancr op1stg syl coeq12d w3a op2ndg
      wa 3ad2ant1 fveq1d oveq123d oveqd mpt2eq3dva opeq12d eqtrd ) AJKOZHIOZUAP
      VIUBQZVJUBQZRZBCDDBUCZVLQZCUCZVLQZVIUDQZPZVNVPVJUDQZPZRZUEZOJHRZBCDDVNHQZ
      VPHQZKPZVNVPIPZRZUEZOABCDEFGVJVILAHIEFUFPZUGZVJWKSMHIWKUHUIAJKFGUFPZUGZVI
      WMSNJKWMUHUIUJAVMWDWCWJAVKJVLHAJTSKTSVAZVKJUKAWMULWNWOFGUMNJKWMUNUOZJKTTU
      PUQAHTSITSVAZVLHUKZAWKULWLWQEFUMMHIWKUNUOZHITTUPUQZURABCDDWBWIAVNDSZVPDSZ
      USZVSWGWAWHXCVOWEVQWFVRKAXAVRKUKZXBAWOXDWPJKTTUTUQVBXCVNVLHAXAWRXBWTVBZVC
      XCVPVLHXEVCVDXCVTIVNVPAXAVTIUKZXBAWQXFWSHITTUTUQVBVEURVFVGVH $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z E $.  $d f g x y z F $.  $d f g x y z ph $.
    $d f g x y z G $.
    cofucl.f $e |- ( ph -> F e. ( C Func D ) ) $.
    cofucl.g $e |- ( ph -> G e. ( D Func E ) ) $.
    $( The composition of two functors is a functor.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    cofucl $p |- ( ph -> ( G o.func F ) e. ( C Func E ) ) $=
      ( vx vy vz co cfv c2nd eqid wcel wf wral wa adantr vg vf ccofu c1st cfunc
      cop ccom cbs cmpt2 cofuval cofu1st fveq2d fvex coex mpt2ex syl6eq opeq12d
      cv op2nd eqtr4d wbr cxp chom cmap cixp ccid wceq cco wrel relfunc sylancr
      1st2ndbr funcf1 fco syl2anc feq1d mpbird wfn fnmpt2i fneq1d mpbiri simprl
      ovex ffvelrnd simprr funcf2 elmap sylibr cofu2nd cofu1 oveq12d ralrimivva
      oveq1d 3eltr4d fveq2 df-ov syl6eqr vex op1std op2ndd ralxp elixp sylanbrc
      eleq12d simpr funcid ffvelrnda eqtrd funcrcl simpld catidcl cofu2 3eqtr4d
      simplr simprlr simprll simprrl simprrr catcocl fvco3 funcco 3eqtrd fveq1d
      ccat syl oveq123d anassrs ralrimiva simprd isfunc mpbir3and df-br eqeltrd
      jca sylib ) AFEUCLZYPUDMZYPNMZUFZBDUELZAYPFUDMZEUDMZUGZIJBUHMZUUDIURZUUBM
      ZJURZUUBMZFNMZLZUUEUUGENMZLZUGZUIZUFZYSAIJUUDBCDEFUUDOZGHUJZAYQUUCYRUUNAU
      UDBCDEFUUPGHUKZAYRUUONMUUNAYPUUONUUQULUUCUUNUUAUUBFUDUMEUDUMUNIJUUDUUDUUM
      BUHUMZUUSUOUSUPZUQUTAYQYRYTVAZYSYTPAUVAUUDDUHMZYQQZYRKUUDUUDVBZKURZUDMZYQ
      MZUVENMZYQMZDVCMZLZUVEBVCMZMZVDLZVEPZUUEBVFMZMZUUEUUEYRLMZUUEYQMZDVFMZMZV
      GZUAURZUBURZUUEUUGUFZUVEBVHMZLLZUUEUVEYRLZMZUWCUUGUVEYRLMZUWDUUEUUGYRLZMZ
      UVSUUGYQMZUFZUVEYQMZDVHMZLZLZVGZUAUUGUVEUVLLZRUBUUEUUGUVLLZRZKUUDRJUUDRZS
      ZIUUDRAUVCUUDUVBUUCQZACUHMZUVBUUAQUUDUXFUUBQZUXEAUXFUVBCDUUAUUIUXFOZUVBOZ
      ACDUELZVIFUXJPZUUAUUIUXJVAZCDVJHFUXJVLVKZVMAUUDUXFBCUUBUUKUUPUXHABCUELZVI
      EUXNPZUUBUUKUXNVAZBCVJGEUXNVLVKZVMZUUDUXFUVBUUAUUBVNVOAUUDUVBYQUUCUURVPVQ
      AYRUVDVRZUVEYRMZUVNPZKUVDRZUVOAUXSUUNUVDVRIJUUDUUDUUMUUNUUNOUUJUULUUFUUHU
      UIWCUUEUUGUUKWCUNVSAUVDYRUUNUUTVTWAAUWKUVSUWMUVJLZUXAVDLZPZJUUDRIUUDRUYBA
      UYEIJUUDUUDAUUEUUDPZUUGUUDPZSZSZUUMUUFUUAMZUUHUUAMZUVJLZUXAVDLZUWKUYDUYIU
      XAUYLUUMQZUUMUYMPUYIUUFUUHCVCMZLZUYLUUJQUXAUYPUULQUYNUYIUXFCDUUAUUIUYOUVJ
      UUFUUHUXHUYOOZUVJOZAUXLUYHUXMTUYIUUDUXFUUEUUBAUXGUYHUXRTZAUYFUYGWBZWDUYIU
      UDUXFUUGUUBUYSAUYFUYGWEZWDWFUYIUUDBCUUBUUKUVLUYOUUEUUGUUPUVLOZUYQAUXPUYHU
      XQTUYTVUAWFUXAUYPUYLUUJUULVNVOUYLUXAUUMUYJUYKUVJWCUUEUUGUVLWCWGWHUYIUUDBC
      DEFUUEUUGUUPAUXOUYHGTZAUXKUYHHTZUYTVUAWIUYIUYCUYLUXAVDUYIUVSUYJUWMUYKUVJU
      YIUUDBCDEFUUEUUPVUCVUDUYTWJUYIUUDBCDEFUUGUUPVUCVUDVUAWJWKWMWNWLUYAUYEKIJU
      UDUUDUVEUWEVGZUXTUWKUVNUYDVUEUXTUWEYRMUWKUVEUWEYRWOUUEUUGYRWPWQVUEUVKUYCU
      VMUXAVDVUEUVGUVSUVIUWMUVJVUEUVFUUEYQUUEUUGUVEIWRZJWRZWSULVUEUVHUUGYQUUEUU
      GUVEVUFVUGWTULWKVUEUVMUWEUVLMUXAUVEUWEUVLWOUUEUUGUVLWPWQWKXDXAWHKUVDUVNYR
      YPNUMXBXCAUXDIUUDAUYFSZUWBUXCVUHUVQUUEUUEUUKLMZUUFUUFUUILZMZUYJUVTMZUVRUW
      AVUHVUKUUFCVFMZMZVUJMVULVUHVUIVUNVUJVUHUUDBUVPCUUBUUKVUMUUEUUPUVPOZVUMOZA
      UXPUYFUXQTZAUYFXEZXFULVUHUXFCVUMDUUAUUIUVTUUFUXHVUPUVTOZAUXLUYFUXMTZAUUDU
      XFUUEUUBUXRXGZXFXHVUHUUDBCUVQDEFUVLUUEUUEUUPAUXOUYFGTZAUXKUYFHTZVURVURVUB
      VUHUUDBUVPUVLUUEUUPVUBVUOABYDPZUYFAVVDCYDPZAUXOVVDVVESGBCEXIYEXJZTZVURXKX
      LVUHUVSUYJUVTVUHUUDBCDEFUUEUUPVVBVVCVURWJZULXMVUHUXBJKUUDUUDVUHUYGUVEUUDP
      ZSZSUWSUBUAUXAUWTVUHVVJUWDUXAPZUWCUWTPZSZUWSVUHVVJVVMSZSZUWGUUFUVEUUBMZUU
      ILZUUEUVEUUKLZUGZMZUWCUUGUVEUUKLZMZUUHVVPUUILMZUWDUULMZUUJMZUYJUYKUFZVVPU
      UAMZUWPLZLZUWIUWRVVOVVTUWGVVRMZVVQMZVWBVWDUUFUUHUFVVPCVHMZLLZVVQMVWIVVOUU
      EUVEUVLLZUUFVVPUYOLZVVRQUWGVWNPVVTVWKVGVVOUUDBCUUBUUKUVLUYOUUEUVEUUPVUBUY
      QVUHUXPVVNVUQTZAUYFVVNXNZVUHUYGVVIVVMXOZWFVVOUUDBUWFUWDUWCUVLUUEUUGUVEUUP
      VUBUWFOZVUHVVDVVNVVGTVWQVUHUYGVVIVVMXPZVWRVUHVVJVVKVVLXQZVUHVVJVVKVVLXRZX
      SVWNVWOUWGVVQVVRXTVOVVOVWJVWMVVQVVOUUDBUWFCUUBUUKUVLUWDUWCVWLUUEUUGUVEUUP
      VUBVWSVWLOZVWPVWQVWTVWRVXAVXBYAULVVOUXFCVWLDUUAUUIUYOVWDVWBUWPUUFUUHVVPUX
      HUYQVXCUWPOZVUHUXLVVNVUTTVUHUUFUXFPVVNVVATVVOUUDUXFUUGUUBVUHUXGVVNAUXGUYF
      UXRTTZVWTWDVVOUUDUXFUVEUUBVXEVWRWDVVOUXAUYPUWDUULVVOUUDBCUUBUUKUVLUYOUUEU
      UGUUPVUBUYQVWPVWQVWTWFVXAWDVVOUWTUUHVVPUYOLUWCVWAVVOUUDBCUUBUUKUVLUYOUUGU
      VEUUPVUBUYQVWPVWTVWRWFVXBWDYAYBVVOUWGUWHVVSVVOUUDBCDEFUUEUVEUUPVUHUXOVVNV
      VBTZVUHUXKVVNVVCTZVWQVWRWIYCVVOUWJVWCUWLVWEUWQVWHVVOUWNVWFUWOVWGUWPVVOUVS
      UYJUWMUYKVUHUVSUYJVGVVNVVHTVVOUUDBCDEFUUGUUPVXFVXGVWTWJUQVVOUUDBCDEFUVEUU
      PVXFVXGVWRWJWKVVOUUDBCUWCDEFUVLUUGUVEUUPVXFVXGVWTVWRVUBVXBXLVVOUUDBCUWDDE
      FUVLUUEUUGUUPVXFVXGVWQVWTVUBVXAXLYFXMYGWLWLYNYHAIJKUUDUVBBUWFUVPUBUADYQYR
      UVLUVTUVJUWPUUPUXIVUBUYRVUOVUSVWSVXDVVFAVVEDYDPZAUXKVVEVXHSHCDFXIYEYIYJYK
      YQYRYTYLYOYM $.
  $}

  ${
    $d x y C $.  $d x y G $.  $d x y H $.  $d x y K $.  $d x y ph $.
    cofuass.g $e |- ( ph -> G e. ( C Func D ) ) $.
    cofuass.h $e |- ( ph -> H e. ( D Func E ) ) $.
    cofuass.k $e |- ( ph -> K e. ( E Func F ) ) $.
    $( Functor composition is associative.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    cofuass $p |- ( ph ->
      ( ( K o.func H ) o.func G ) = ( K o.func ( H o.func G ) ) ) $=
      ( vx vy ccofu co c1st cfv ccom c2nd wcel cbs cmpt2 cop coass eqid cofu1st
      cv coeq1d coeq2d 3eqtr4a w3a cfunc 3ad2ant1 wrel relfunc 1st2ndbr sylancr
      wbr simp2 ffvelrnd simp3 cofu2nd cofu1 oveq12d coeq12d mpt2eq3dva opeq12d
      funcf1 cofucl cofuval 3eqtr4d ) AHGNOZPQZFPQZRZLMBUAQZVPLUGZVNQZMUGZVNQZV
      LSQOZVQVSFSQZOZRZUBZUCHPQZGFNOZPQZRZLMVPVPVQWHQZVSWHQZHSQZOZVQVSWGSQOZRZU
      BZUCVLFNOHWGNOAVOWIWEWPAWFGPQZRZVNRWFWQVNRZRVOWIWFWQVNUDAVMWRVNACUAQZCDEG
      HWTUEZJKUFUHAWHWSWFAVPBCDFGVPUEZIJUFUIUJALMVPVPWDWOAVQVPTZVSVPTZUKZVRWQQZ
      VTWQQZWLOZVRVTGSQOZRZWCRXHXIWCRZRWDWOXHXIWCUDXEWAXJWCXEWTCDEGHVRVTXAAXCGC
      DULOTXDJUMZAXCHDEULOTXDKUMXEVPWTVQVNXEVPWTBCVNWBXBXAAXCVNWBBCULOZURZXDAXM
      UNFXMTZXNBCUOIFXMUPUQUMVHZAXCXDUSZUTXEVPWTVSVNXPAXCXDVAZUTVBUHXEWMXHWNXKX
      EWJXFWKXGWLXEVPBCDFGVQXBAXCXOXDIUMZXLXQVCXEVPBCDFGVSXBXSXLXRVCVDXEVPBCDFG
      VQVSXBXSXLXQXRVBVEUJVFVGALMVPBCEFVLXBIACDEGHJKVIVJALMVPBDEWGHXBABCDFGIJVI
      KVJVK $.
  $}

  ${
    $d x y z C $.  $d x z D $.  $d x y z F $.  $d x y I $.  $d x y ph $.
    cofulid.g $e |- ( ph -> F e. ( C Func D ) ) $.
    ${
      cofulid.1 $e |- I = ( idFunc ` D ) $.
      $( The identity functor is a left identity for composition.  (Contributed
         by Mario Carneiro, 3-Jan-2017.) $)
      cofulid $p |- ( ph -> ( I o.func F ) = F ) $=
        ( vx vy c1st cfv ccom cbs cv c2nd co eqid wcel syl wceq cmpt2 cop ccofu
        cid cres ccat cfunc funcrcl simprd idfu1st coeq1d wrel relfunc 1st2ndbr
        wa wf wbr sylancr funcf1 fcoi2 eqtrd w3a chom ffvelrnda 3adant3 3adant2
        3ad2ant1 idfu2nd simp2 simp3 funcf2 mpt2eq3dva cxp funcfn2 sylib eqtr4d
        wfn fnov opeq12d idfucl cofuval 1st2nd 3eqtr4d ) AEJKZDJKZLZHIBMKZWGHNZ
        WEKZINZWEKZEOKPZWHWJDOKZPZLZUAZUBWEWMUBZEDUCPDAWFWEWPWMAWFUDCMKZUEZWELZ
        WEAWDWSWEAWRCEGWRQZABUFRZCUFRZADBCUGPZRZXBXCUOFBCDUHSUIZUJUKAWGWRWEUPWT
        WETAWGWRBCWEWMWGQZXAAXDULZXEWEWMXDUQZBCUMZFDXDUNURZUSZWGWRWEUTSVAAWPHIW
        GWGWNUAZWMAHIWGWGWOWNAWHWGRZWJWGRZVBZWOUDWIWKCVCKZPZUEZWNLZWNXPWLXSWNXP
        WRCXQEWIWKGXAAXNXCXOXFVGXQQZAXNWIWRRXOAWGWRWHWEXLVDVEAXOWKWRRXNAWGWRWJW
        EXLVDVFVHUKXPWHWJBVCKZPZXRWNUPXTWNTXPWGBCWEWMYBXQWHWJXGYBQYAAXNXIXOXKVG
        AXNXOVIAXNXOVJVKYCXRWNUTSVAVLAWMWGWGVMVQWMXMTAWGBCWEWMXGXKVNHIWGWGWMVRV
        OVPVSAHIWGBCCDEXGFAXCECCUGPRXFCEGVTSWAAXHXEDWQTXJFDXDWBURWC $.
    $}

    ${
      cofurid.1 $e |- I = ( idFunc ` C ) $.
      $( The identity functor is a right identity for composition.
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      cofurid $p |- ( ph -> ( F o.func I ) = F ) $=
        ( vx vy c1st cfv ccom cbs co eqid wcel syl wceq eqtrd 3ad2ant1 cv cmpt2
        c2nd cop ccofu cres ccat cfunc wa funcrcl simpld idfu1st coeq2d wf wrel
        cid wbr relfunc 1st2ndbr sylancr funcf1 w3a chom fveq1d fvresi 3ad2ant2
        fcoi1 oveq12d simp2 simp3 idfu2nd coeq12d funcf2 mpt2eq3dva cxp funcfn2
        3ad2ant3 wfn fnov sylib eqtr4d opeq12d idfucl cofuval 1st2nd 3eqtr4d )
        ADJKZEJKZLZHIBMKZWJHUAZWHKZIUAZWHKZDUCKZNZWKWMEUCKNZLZUBZUDWGWOUDZDEUEN
        DAWIWGWSWOAWIWGUPWJUFZLZWGAWHXAWGAWJBEGWJOZABUGPZCUGPZADBCUHNZPZXDXEUIF
        BCDUJQUKZULZUMAWJCMKZWGUNXBWGRAWJXJBCWGWOXCXJOAXFUOZXGWGWOXFUQZBCURZFDX
        FUSUTZVAWJXJWGVGQSAWSHIWJWJWKWMWONZUBZWOAHIWJWJWRXOAWKWJPZWMWJPZVBZWRXO
        UPWKWMBVCKZNZUFZLZXOXSWPXOWQYBXSWLWKWNWMWOXSWLWKXAKZWKXSWKWHXAAXQWHXARX
        RXITZVDXQAYDWKRXRWJWKVEVFSXSWNWMXAKZWMXSWMWHXAYEVDXRAYFWMRXQWJWMVEVQSVH
        XSWJBXTEWKWMGXCAXQXDXRXHTXTOZAXQXRVIZAXQXRVJZVKVLXSYAWKWGKWMWGKCVCKZNZX
        OUNYCXORXSWJBCWGWOXTYJWKWMXCYGYJOAXQXLXRXNTYHYIVMYAYKXOVGQSVNAWOWJWJVOV
        RWOXPRAWJBCWGWOXCXNVPHIWJWJWOVSVTWAWBAHIWJBBCEDXCAXDEBBUHNPXHBEGWCQFWDA
        XKXGDWTRXMFDXFWEUTWF $.
    $}
  $}

  ${
    $d f h x z F $.  $d x y z G $.  $d f h x y z H $.  $d f h x z ph $.
    $d x y z S $.
    resfval.c $e |- ( ph -> F e. V ) $.
    resfval.d $e |- ( ph -> H e. W ) $.
    $( Value of the functor restriction operator.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    resfval $p |- ( ph -> ( F |`f H ) =
      <. ( ( 1st ` F ) |` dom dom H ) , ( x e. dom H |->
        ( ( ( 2nd ` F ) ` x ) |` ( H ` x ) ) ) >. ) $=
      ( vf vh cvv cv c1st cfv cdm cres c2nd cmpt wceq wcel cop cresf df-resf wa
      cmpt2 a1i simprl fveq2d simprr reseq12d fveq1d mpteq12dv opeq12d elex syl
      dmeqd opex ovmpt2d ) AIJCDKKILZMNZJLZOZOZPZBVBBLZUSQNZNZVEVANZPZRZUAZCMNZ
      DOZOZPZBVMVECQNZNZVEDNZPZRZUAZUBKUBIJKKVKUESABIJUCUFAUSCSZVADSZUDUDZVDVOV
      JVTWDUTVLVCVNWDUSCMAWBWCUGZUHWDVBVMWDVADAWBWCUIZUPZUPUJWDBVBVIVMVSWGWDVGV
      QVHVRWDVEVFVPWDUSCQWEUHUKWDVEVADWFUKUJULUMACETCKTGCEUNUOADFTDKTHDFUNUOWAK
      TAVOVTUQUFUR $.

    resfval2.g $e |- ( ph -> G e. X ) $.
    resfval2.d $e |- ( ph -> H Fn ( S X. S ) ) $.
    $( Value of the functor restriction operator.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    resfval2 $p |- ( ph -> ( <. F , G >. |`f H ) = <. ( F |` S ) ,
      ( x e. S , y e. S |-> ( ( x G y ) |` ( x H y ) ) ) >. ) $=
      ( vz cop co cfv cres wceq cresf c1st cdm cv c2nd cmpt cmpt2 cvv wcel opex
      a1i resfval op1stg syl2anc cxp wfn fndm syl dmxpid syl6eq reseq12d op2ndg
      dmeqd fveq1d reseq1d mpteq12dv fveq2 df-ov syl6eqr mpt2mpt opeq12d eqtrd
      ) AEFPZGUAQVMUBRZGUCZUCZSZOVOOUDZVMUERZRZVRGRZSZUFZPEDSZBCDDBUDZCUDZFQZWE
      WFGQZSZUGZPAOVMGUHIVMUHUIAEFUJUKLULAVQWDWCWJAVNEVPDAEHUIZFJUIZVNETKMEFHJU
      MUNAVPDDUOZUCDAVOWMAGWMUPVOWMTNWMGUQURZVCDUSUTVAAWCOWMVRFRZWASZUFWJAOVOWB
      WMWPWNAVTWOWAAVRVSFAWKWLVSFTKMEFHJVBUNVDVEVFBCODDWPWIVRWEWFPZTZWOWGWAWHWR
      WOWQFRWGVRWQFVGWEWFFVHVIWRWAWQGRWHVRWQGVGWEWFGVHVIVAVJUTVKVL $.
  $}

  ${
    $d z F $.  $d z H $.  $d z ph $.  $d z X $.  $d z Y $.
    resf1st.f $e |- ( ph -> F e. V ) $.
    resf1st.h $e |- ( ph -> H e. W ) $.
    resf1st.s $e |- ( ph -> H Fn ( S X. S ) ) $.
    $( Value of the functor restriction operator on objects.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    resf1st $p |- ( ph -> ( 1st ` ( F |`f H ) ) = ( ( 1st ` F ) |` S ) ) $=
      ( vz cresf co c1st cfv cdm cres cv cvv wcel wceq c2nd cmpt resfval fveq2d
      cop fvex resex dmexg mptexg 3syl op1stg sylancr cxp wfn fndm dmeqd dmxpid
      syl syl6eq reseq2d 3eqtrd ) ACDKLZMNCMNZDOZOZPZJVDJQZCUANNVGDNPZUBZUEZMNZ
      VFVCBPAVBVJMAJCDEFGHUCUDAVFRSVIRSZVKVFTVCVECMUFUGADFSVDRSVLHDFUHJVDVHRUIU
      JVFVIRRUKULAVEBVCAVEBBUMZOBAVDVMADVMUNVDVMTIVMDUOURUPBUQUSUTVA $.

    resf2nd.x $e |- ( ph -> X e. S ) $.
    resf2nd.y $e |- ( ph -> Y e. S ) $.
    $( Value of the functor restriction operator on morphisms.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    resf2nd $p |- ( ph ->
      ( X ( 2nd ` ( F |`f H ) ) Y ) = ( ( X ( 2nd ` F ) Y ) |` ( X H Y ) ) ) $=
      ( vz co c2nd cfv cres cvv wcel cresf cop df-ov cv cdm c1st resfval fveq2d
      cmpt wceq fvex resex dmexg mptexg 3syl op2ndg sylancr eqtrd simpr syl6eqr
      reseq12d cxp opelxpi syl2anc wfn fndm syl eleqtrrd ovex a1i fvmptd syl5eq
      wa ) AGHCDUAOZPQZOGHUBZVOQGHCPQZOZGHDOZRZGHVOUCANVPNUDZVQQZWADQZRZVTDUEZV
      OSAVOCUFQZWEUEZRZNWEWDUIZUBZPQZWIAVNWJPANCDEFIJUGUHAWHSTWISTZWKWIUJWFWGCU
      FUKULADFTWESTWLJDFUMNWEWDSUNUOWHWISSUPUQURAWAVPUJZVMZWBVRWCVSWNWBVPVQQVRW
      NWAVPVQAWMUSZUHGHVQUCUTWNWCVPDQVSWNWAVPDWOUHGHDUCUTVAAVPBBVBZWEAGBTHBTVPW
      PTLMGHBBVCVDADWPVEWEWPUJKWPDVFVGVHVTSTAVRVSGHVQVIULVJVKVL $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z F $.  $d f g x y z ph $.
    $d f g x y z H $.
    funcres.f $e |- ( ph -> F e. ( C Func D ) ) $.
    funcres.h $e |- ( ph -> H e. ( Subcat ` C ) ) $.
    $( A functor restricted to a subcategory is a functor.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    funcres $p |- ( ph -> ( F |`f H ) e. ( ( C |`cat H ) Func D ) ) $=
      ( vz co cfv wcel wceq eqid syl wf adantr eleqtrrd sseldd fvres 3ad2ant1
      vx vy vf vg cresf c1st cdm cres c2nd cop cresc cfunc cv cmpt csubc fveq2d
      resfval cvv fvex resex dmexg mptexg 3syl op2ndg sylancr opeq2d eqtr4d wbr
      eqtrd cbs cco ccid chom subccat ccat funcrcl simprd wrel relfunc 1st2ndbr
      wss funcf1 eqidd subcfn subcss1 fssres syl2anc simpld rescbas feq2d mpbid
      wa wfn cxp fnmpti eqcomd fndm xpeq12d fneq12d mpbii simprl simprr subcss2
      funcf2 resf2nd feq1d mpbird reschom oveq12d feq23d eleq2d biimpar fveq12d
      oveqd subcid eqsstr3d sselda funcid subcidcl 3eqtr4d simp21 simp22 simp23
      simp3l simp3r subccocl funcco rescco opeq12d oveq123d isfuncd df-br sylib
      w3a fveq1d eqeltrd ) ADEUEIZDUFJZEUGZUGZUHZYQUIJZUJZBEUKIZCULIZAYQUUAHYSH
      UMZDUIJZJZUUFEJZUHZUNZUJZUUCAHDEBCULIZBUOJZFGUQZAUUBUUKUUAAUUBUULUIJZUUKA
      YQUULUIUUOUPAUUAURKUUKURKZUUPUUKLYRYTDUFUSUTAEUUNKZYSURKUUQGEUUNVAHYSUUJU
      RVBVCUUAUUKURURVDVEVIZVFVGAUUAUUBUUEVHUUCUUEKAUAUBHUUDVJJZCVJJZUUDUUDVKJZ
      UUDVLJZUCUDCUUAUUBUUDVMJZCVLJZCVMJZCVKJZUUTMUVAMZUVDMUVFMZUVCMUVEMZUVBMUV
      GMZABUUDEUUDMZGVNABVOKZCVOKZADUUMKZUVMUVNWLFBCDVPNZVQAYTUVAUUAOZUUTUVAUUA
      OABVJJZUVAYROYTUVRWAZUVQAUVRUVABCYRUUGUVRMZUVHAUUMVRUVOYRUUGUUMVHZBCVSFDU
      UMVTVEZWBAUVRBYTEGABYTEGAYTWCWDZUVTWEZUVRUVAYTYRWFWGAYTUUTUVAUUAAUVRBUUDY
      TEVOUVLUVTAUVMUVNUVPWHZUWCUWDWIZWJWKAUUKYSWMUUBUUTUUTWNZWMHYSUUJUUKUUHUUI
      UUFUUGUSUTUUKMWOAYSUWGUUKUUBAUUBUUKUUSWPAYSYTYTWNZUWGAEUWHWMZYSUWHLUWCUWH
      EWQNAYTUUTYTUUTUWFUWFWRVIWSWTAUAUMZUUTKZUBUMZUUTKZWLZWLZUWJUWLEIZUWJYRJZU
      WLYRJZUVFIZUWJUWLUUBIZOZUWJUWLUVDIZUWJUUAJZUWLUUAJZUVFIZUWTOUWOUXAUWPUWSU
      WJUWLUUGIZUWPUHZOZUWOUWJUWLBVMJZIZUWSUXFOUWPUXJWAUXHUWOUVRBCYRUUGUXIUVFUW
      JUWLUVTUXIMZUVIAUWAUWNUWBPUWOYTUVRUWJAUVSUWNUWDPZUWOUWJUUTYTAUWKUWMXAAYTU
      UTLZUWNUWFPZQZRUWOYTUVRUWLUXLUWOUWLUUTYTAUWKUWMXBUXNQZRXDUWOBYTUXIEUWJUWL
      AUURUWNGPZAUWIUWNUWCPZUXKUXOUXPXCUXJUWSUWPUXFWFWGUWOUWPUWSUWTUXGUWOYTDEUU
      MUUNUWJUWLAUVOUWNFPUXQUXRUXOUXPXEXFXGUWOUWPUWSUXBUXEUWTUWOEUVDUWJUWLAEUVD
      LZUWNAUVRBUUDYTEVOUVLUVTUWEUWCUWDXHZPXNUWOUXEUWSUWOUXCUWQUXDUWRUVFUWOUWJY
      TKZUXCUWQLZUXOUWJYTYRSZNUWOUWLYTKZUXDUWRLZUXPUWLYTYRSZNXIWPXJWKAUWKWLZUWJ
      UVCJZUWJUWJUUBIZJUWJBVLJZJZUWJUWJUUGIZUWJUWJEIZUHZJZUXCUVEJZUYGUYHUYKUYIU
      YNUYGYTDEUUMUUNUWJUWJAUVOUWKFPAUURUWKGPZAUWIUWKUWCPZAUYAUWKAYTUUTUWJUWFXK
      XLZUYSXEUYGUYKUYHUYGBUUDYTUYJEUWJUVLUYQUYRUYJMZUYSXOWPXMUYGUYKUYLJZUWQUVE
      JUYOUYPUYGUVRBUYJCYRUUGUVEUWJUVTUYTUVJAUWAUWKUWBPAUUTUVRUWJAUUTYTUVRUWFUW
      DXPXQXRUYGUYKUYMKUYOVUALUYGBYTUYJEUWJUYQUYRUYSUYTXSUYKUYMUYLSNUYGUXCUWQUV
      EUYGUYAUYBUYSUYCNUPXTVIAUWKUWMUUFUUTKZYNZUCUMZUXBKZUDUMZUWLUUFUVDIZKZWLZY
      NZVUFVUDUWJUWLUJZUUFBVKJZIZIZUWJUUFUUGIZUWJUUFEIZUHZJZVUFUWLUUFUUGIZJZVUD
      UXFJZUWQUWRUJZUUFYRJZUVGIZIZVUFVUDVUKUUFUVBIZIZUWJUUFUUBIZJVUFUWLUUFUUBIZ
      JZVUDUWTJZUXCUXDUJZUUFUUAJZUVGIZIVUJVURVUNVUOJZVVEVUJVUNVUPKVURVVOLVUJBYT
      VULVUDVUFEUWJUWLUUFAVUCUURVUIGTZAVUCUWIVUIUWCTZVUJUWJUUTYTAUWKUWMVUBVUIYA
      AVUCUXMVUIUWFTZQZVULMZVUJUWLUUTYTAUWKUWMVUBVUIYBVVRQZVUJUUFUUTYTAUWKUWMVU
      BVUIYCVVRQZVUJVUDUXBUWPAVUCVUEVUHYDVUJEUVDUWJUWLAVUCUXSVUIUXTTZXNQZVUJVUF
      VUGUWLUUFEIZAVUCVUEVUHYEVUJEUVDUWLUUFVWCXNQZYFVUNVUPVUOSNVUJUVRBVULCYRUUG
      UXIVUDVUFUVGUWJUWLUUFUVTUXKVVTUVKAVUCUWAVUIUWBTVUJYTUVRUWJAVUCUVSVUIUWDTZ
      VVSRVUJYTUVRUWLVWGVWARVUJYTUVRUUFVWGVWBRVUJUWPUXJVUDVUJBYTUXIEUWJUWLVVPVV
      QUXKVVSVWAXCVWDRVUJVWEUWLUUFUXIIVUFVUJBYTUXIEUWLUUFVVPVVQUXKVWAVWBXCVWFRY
      GVIVUJVVGVUNVVHVUQVUJYTDEUUMUUNUWJUUFAVUCUVOVUIFTZVVPVVQVVSVWBXEVUJVVFVUM
      VUFVUDVUJUVBVULVUKUUFVUJVULUVBAVUCVULUVBLVUIAUVRBUUDYTVULEVOUVLUVTUWEUWCU
      WDVVTYHTWPXNXNXMVUJVVJVUTVVKVVAVVNVVDVUJVVLVVBVVMVVCUVGVUJUXCUWQUXDUWRVUJ
      UYAUYBVVSUYCNVUJUYDUYEVWAUYFNYIVUJUUFYTKVVMVVCLVWBUUFYTYRSNXIVUJVVJVUFVUS
      VWEUHZJZVUTVUJVUFVVIVWIVUJYTDEUUMUUNUWLUUFVWHVVPVVQVWAVWBXEYOVUJVUFVWEKVW
      JVUTLVWFVUFVWEVUSSNVIVUJVVKVUDUXGJZVVAVUJVUDUWTUXGVUJYTDEUUMUUNUWJUWLVWHV
      VPVVQVVSVWAXEYOVUJVUDUWPKVWKVVALVWDVUDUWPUXFSNVIYJXTYKUUAUUBUUEYLYMYP $.
  $}

  ${
    $d f g x y z A $.  $d f g x y z C $.  $d f g x y z D $.  $d f g x y z ph $.
    $d f g x y z F $.  $d f g x y z G $.  $d f g x y z H $.  $d f g x y z R $.
    funcres2b.a $e |- A = ( Base ` C ) $.
    funcres2b.h $e |- H = ( Hom ` C ) $.
    funcres2b.r $e |- ( ph -> R e. ( Subcat ` D ) ) $.
    funcres2b.s $e |- ( ph -> R Fn ( S X. S ) ) $.
    funcres2b.1 $e |- ( ph -> F : A --> S ) $.
    funcres2b.2 $e |- ( ( ph /\ ( x e. A /\ y e. A ) ) ->
      ( x G y ) : Y --> ( ( F ` x ) R ( F ` y ) ) ) $.
    $( Condition for a functor to also be a functor into the restriction.
       (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    funcres2b $p |- ( ph ->
      ( F ( C Func D ) G <-> F ( C Func ( D |`cat R ) ) G ) ) $=
      ( co cfv vz vg vf ccat wcel cfunc wbr cresc wi cop wa df-br funcrcl sylbi
      simpld a1i wb cbs cxp c1st c2nd chom cmap cixp ccid wceq cco wral w3a wss
      wf cv eqid subcss1 fss syl2anc csubc subcrcl syl rescbas feq3 2thd adantr
      mpbid cvv wfn crn adantlr frn ad2antrr simprl simprr subcss2 sstrd anbi2d
      ffvelrnd df-f 3bitr4g reschom oveqd bitrd ralrimivva fveq2 syl6eqr op1std
      df-ov vex fveq2d op2ndd oveq12d eleq12d elmap syl6bb bibi12d ralxp sylibr
      ovex ralbi 3anbi3d elixp2 ffvelrnda subcid eqeq2d rescco 2ralbidv anbi12d
      ralbidva 3anbi123d simpr isfunc subccat 3bitr4d ex pm5.21ndd ) AEUDUEZIJE
      FUFSZUGZIJEFGUHSZUFSZUGZYQYOUIAYQYOFUDUEZYQIJUJZYPUEYOUUAUKIJYPULEFUUBUMU
      NUOUPYTYOUIAYTYOYRUDUEZYTUUBYSUEYOUUCUKIJYSULEYRUUBUMUNUOUPAYOYQYTUQAYOUK
      ZDFURTZIVKZJUADDUSZUAVLZUTTZITZUUHVATZITZFVBTZSZUUHKTZVCSZVDUEZBVLZEVETZT
      UURUURJSTZUURITZFVETZTZVFZUBVLZUCVLZUURCVLZUJZUUHEVGTZSSUURUUHJSTZUVEUVGU
      UHJSTZUVFUURUVGJSZTZUVAUVGITZUJZUUHITZFVGTZSZSZVFZUBUVGUUHKSZVHUCUURUVGKS
      ZVHZUADVHCDVHZUKZBDVHZVIDYRURTZIVKZJUAUUGUUJUULYRVBTZSZUUOVCSZVDUEZUUTUVA
      YRVETZTZVFZUVJUVKUVMUVOUVPYRVGTZSZSZVFZUBUWAVHUCUWBVHZUADVHCDVHZUKZBDVHZV
      IYQYTUUDUUFUWHUUQUWLUWFUXCAUUFUWHUQYOAUUFUWHADHIVKZHUUEVJUUFQAUUEFHGOPUUE
      VMZVNZDHUUEIVOVPAUXDUWHQAHUWGVFUXDUWHUQAUUEFYRHGUDYRVMZUXEAGFVQTUEZUUAOFG
      VRVSZPUXFVTHUWGDIWAVSWDWBWCUUDJWEUEZJUUGWFZUUHJTZUUPUEZUAUUGVHZVIUXJUXKUX
      LUWKUEZUAUUGVHZVIUUQUWLUUDUXNUXPUXJUXKUUDUXMUXOUQZUAUUGVHZUXNUXPUQUUDUWBU
      VAUVNUUMSZUVLVKZUWBUVAUVNUWISZUVLVKZUQZCDVHBDVHUXRUUDUYCBCDDUUDUURDUEZUVG
      DUEZUKZUKZUXTUWBUVAUVNGSZUVLVKZUYBUYGUVLUWBWFZUVLWGZUXSVJZUKUYJUYKUYHVJZU
      KUXTUYIUYGUYLUYMUYJUYGUYLUYMUYGUYKUYHUXSUYGLUYHUVLVKZUYMAUYFUYNYORWHLUYHU
      VLWIVSZUYGFHUUMGUVAUVNAUXHYOUYFOWJAGHHUSWFZYOUYFPWJUUMVMZUYGDHUURIAUXDYOU
      YFQWJZUUDUYDUYEWKWPUYGDHUVGIUYRUUDUYDUYEWLWPWMWNUYOWBWOUWBUXSUVLWQUWBUYHU
      VLWQWRUYGUYHUYAVFUYIUYBUQUYGGUWIUVAUVNAGUWIVFYOUYFAUUEFYRHGUDUXGUXEUXIPUX
      FWSWJWTUYHUYAUWBUVLWAVSXAXBUXQUYCUABCDDUUHUVHVFZUXMUXTUXOUYBUYSUXMUVLUXSU
      WBVCSZUEUXTUYSUXLUVLUUPUYTUYSUXLUVHJTUVLUUHUVHJXCUURUVGJXFXDZUYSUUNUXSUUO
      UWBVCUYSUUJUVAUULUVNUUMUYSUUIUURIUURUVGUUHBXGZCXGZXEXHZUYSUUKUVGIUURUVGUU
      HVUBVUCXIXHZXJUYSUUOUVHKTUWBUUHUVHKXCUURUVGKXFXDZXJXKUXSUWBUVLUVAUVNUUMXQ
      UURUVGKXQZXLXMUYSUXOUVLUYAUWBVCSZUEUYBUYSUXLUVLUWKVUHVUAUYSUWJUYAUUOUWBVC
      UYSUUJUVAUULUVNUWIVUDVUEXJVUFXJXKUYAUWBUVLUVAUVNUWIXQVUGXLXMXNXOXPUXMUXOU
      AUUGXRVSXSUAUUGUUPJXTUAUUGUWKJXTWRUUDUWEUXBBDUUDUYDUKZUVDUWOUWDUXAVUIUVCU
      WNUUTVUIFYRHUVBGUVAUXGAUXHYOUYDOWJAUYPYOUYDPWJUVBVMZUUDDHUURIAUXDYOQWCYAY
      BYCVUIUWCUWTCUADDVUIUVTUWSUCUBUWBUWAVUIUVSUWRUVJVUIUVRUWQUVKUVMVUIUVQUWPU
      VOUVPAUVQUWPVFYOUYDAUUEFYRHUVQGUDUXGUXEUXIPUXFUVQVMZYDWJWTWTYCYEYEYFYGYHU
      UDBCUADUUEEUVIUUSUCUBFIJKUVBUUMUVQMUXENUYQUUSVMZVUJUVIVMZVUKAYOYIZAUUAYOU
      XIWCYJUUDBCUADUWGEUVIUUSUCUBYRIJKUWMUWIUWPMUWGVMNUWIVMVULUWMVMVUMUWPVMVUN
      AUUCYOAFYRGUXGOYKWCYJYLYMYN $.
  $}

  ${
    $d f g x y C $.  $d f g x y D $.  $d f g x y R $.
    $( A functor into a restricted category is also a functor into the whole
       category.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    funcres2 $p |- ( R e. ( Subcat ` D ) ->
      ( C Func ( D |`cat R ) ) C_ ( C Func D ) ) $=
      ( vf vg vx vy cfv wcel co cfunc cv wbr wa cbs eqid wf wceq ccat mpbird wb
      csubc cresc wrel relfunc a1i cop simpr cdm chom simpl eqidd subcfn funcf1
      subcrcl adantr subcss1 rescbas feq3 syl simplr simprl simprr funcf2 oveqd
      reschom funcres2b ex df-br 3imtr3g relssdv ) CBUBHIZDEABCUCJZKJZABKJZVNUD
      VLAVMUEUFVLDLZELZVNMZVPVQVOMZVPVQUGZVNIVTVOIVLVRVSVLVRNZVSVRVLVRUHZWAFGAO
      HZABCCUIUIZVPVQAUJHZFLZGLZWEJZWCPZWEPZVLVRUKZWABWDCWKWAWDULUMZWAWCWDVPQZW
      CVMOHZVPQZWAWCWNAVMVPVQWIWNPWBUNWAWDWNRWMWOUAWABOHZBVMWDCSVMPZWPPZVLBSIVR
      BCUOUPZWLWAWPBWDCWKWLWRUQZURWDWNWCVPUSUTTWAWFWCIZWGWCIZNZNZWHWFVPHZWGVPHZ
      CJZWFWGVQJZQZWHXEXFVMUJHZJZXHQZXDWCAVMVPVQWEXJWFWGWIWJXJPVLVRXCVAWAXAXBVB
      WAXAXBVCVDXDXGXKRXIXLUAXDCXJXEXFWACXJRXCWAWPBVMWDCSWQWRWSWLWTVFUPVEXGXKWH
      XHUSUTTVGTVHVPVQVNVIVPVQVOVIVJVK $.
  $}

  ${
    $d f g z C $.  $d f g z D $.  $d f g z ph $.
    wunfunc.1 $e |- ( ph -> U e. WUni ) $.
    wunfunc.2 $e |- ( ph -> C e. U ) $.
    wunfunc.3 $e |- ( ph -> D e. U ) $.
    $( A weak universe is closed under the functor set operation.  (Contributed
       by Mario Carneiro, 12-Jan-2017.) $)
    wunfunc $p |- ( ph -> ( C Func D ) e. U ) $=
      ( vz cbs cfv cmap co chom cxp c1 wunstr wcel eqid fvex wss vf vg crn cuni
      cpw cfunc df-base wunmap cdc df-hom wunrn wununi wunxp wunpw wrel relfunc
      c4 a1i cv cop wbr df-br wa wf simpr funcf1 elmap sylibr c1st c2nd mapsspw
      cixp wral fvssunirn ovssunirn xpss12 mp2an sspwb sstri rgenw ss2ixp ax-mp
      mpbi xpex rnex uniex pwex ixpconst sseqtri funcixp sseldi opelxpi syl2anc
      ex syl5bir relssdv wunss ) ACIJZBIJZKLZBMJZUCZUDZCMJZUCZUDZNZUEZWSWSNZKLZ
      NZBCUFLZDEAWTXJDEAWRWSDEACDIOUGEGPABDIOUGEFPZUHAXHXIDEAXGDEAXCXFDEAXBDEAX
      ADEABDMOUQUIZUJEFPUKULAXEDEAXDDEACDMXNUJEGPUKULUMUNAWSWSDEXMXMUMUHUMAUAUB
      XLXKXLUOABCUPURUAUSZUBUSZUTZXLQXOXPXLVAZAXQXKQZXOXPXLVBAXRXSAXRVCZXOWTQZX
      PXJQXSXTWSWRXOVDYAXTWSWRBCXOXPWSRZWRRAXRVEZVFWRWSXOCISBISZVGVHXTHXIHUSZVI
      JXOJZYEVJJXOJZXDLZYEXAJZKLZVLZXJXPYKHXIXHVLZXJYJXHTZHXIVMYKYLTYMHXIYJYIYH
      NZUEZXHYHYIVKYNXGTZYOXHTYIXCTYHXFTYPXAYEVNXDYFYGVOYIXCYHXFVPVQYNXGVRWCVSV
      THXIYJXHWAWBHXIXHWSWSYDYDWDXGXCXFXBXABMSWEWFXEXDCMSWEWFWDWGWHWIXTHWSBCXOX
      PXAXDYBXARXDRYCWJWKXOXPWTXJWLWMWNWOWPWQ $.
  $}

  ${
    $d f g m n w x y z A $.  $d f g m n w x y z C $.  $d f g m n x y z ph $.
    $d f g m n x y z B $.  $d f g m n x y z D $.
    funcpropd.1 $e |- ( ph -> ( Homf ` A ) = ( Homf ` B ) ) $.
    funcpropd.2 $e |- ( ph -> ( comf ` A ) = ( comf ` B ) ) $.
    funcpropd.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    funcpropd.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    funcpropd.a $e |- ( ph -> A e. V ) $.
    funcpropd.b $e |- ( ph -> B e. V ) $.
    funcpropd.c $e |- ( ph -> C e. V ) $.
    funcpropd.d $e |- ( ph -> D e. V ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same functors.  (Contributed by Mario
       Carneiro, 17-Jan-2017.) $)
    funcpropd $p |- ( ph -> ( A Func C ) = ( B Func D ) ) $=
      ( vz co wcel wa cfv eqid vf vg vx vn vm vy vw cfunc relfunc cbs cv wf cxp
      ccat c1st c2nd chom cmap cixp ccid wceq cop cco wral w3a catpropd anbi12d
      wbr wb fveq2 fveq2d oveq12d cbvixpv eleq2i anbi2i chomf ad2antrr cidpropd
      ccomf fveq1d eqeq12d ad6antr simp-5r simp-4r simpllr simplr simpr ad5antr
      comfeqval simprl df-ov simprr ad3antrrr adantr opelxpi syl2anc vex op1std
      ffvelrnd op2ndd syl6eqr fvixp syl5eqel elmapi adantll ffvelrnda homfeqval
      syl ralbidva raleqdv raleqbidv bitrd sylan2b pm5.32da xp1st xp2nd 3eqtr3g
      adantl 1st2nd2 3eqtr4d ixpeq2dva xpeq12d ixpeq1d eleq2d feq23d raleqbidva
      homfeqbas eqtrd anbi1d anbi2d df-3an 3bitr4g df-br funcrcl isfunc biadan2
      sylbi simpl eqbrrdiv ) AUAUBBDUHPZCEUHPZBDUICEUIABUNQZDUNQZRZBUJSZDUJSZUA
      UKZULZUBUKZOUUEUUEUMZOUKZUOSZUUGSZUUKUPSZUUGSZDUQSZPZUUKBUQSZSZURPZUSZQZU
      CUKZBUTSZSZUVCUVCUUIPZSZUVCUUGSZDUTSZSZVAZUDUKZUEUKZUVCUFUKZVBZUUKBVCSZPP
      ZUVCUUKUUIPZSZUVLUVNUUKUUIPZSZUVMUVCUVNUUIPZSZUVHUVNUUGSZVBZUUKUUGSZDVCSZ
      PPZVAZUDUVNUUKUURPZVDZUEUVCUVNUURPZVDZOUUEVDZUFUUEVDZRZUCUUEVDZVEZRCUNQZE
      UNQZRZCUJSZEUJSZUUGULZUUIOUXBUXBUMZUUMUUOEUQSZPZUUKCUQSZSZURPZUSZQZUVCCUT
      SZSZUVFSZUVHEUTSZSZVAZUVLUVMUVOUUKCVCSZPPZUVRSZUWAUWCUWEUWFEVCSZPPZVAZUDU
      VNUUKUXHPZVDZUEUVCUVNUXHPZVDZOUXBVDZUFUXBVDZRZUCUXBVDZVEZRUUGUUIYTVHZUUGU
      UIUUAVHZAUUDUXAUWRUYMAUUBUWSUUCUWTABCFFGHKLVFADEFFIJMNVFVGAUUHUVBRZUWQRZU
      XDUXLRZUYLRZUWRUYMAUYQUYPUXRUYHOUUEVDZUFUUEVDZRZUCUUEVDZRUYSAUYPUWQVUCUYP
      AUUHUUIUGUUJUGUKZUOSZUUGSZVUDUPSZUUGSZUUPPZVUDUURSZURPZUSZQZRZUWQVUCVIUVB
      VUMUUHUVAVULUUIOUGUUJUUTVUKUUKVUDVAZUUQVUIUUSVUJURVUOUUMVUFUUOVUHUUPVUOUU
      LVUEUUGUUKVUDUOVJVKVUOUUNVUGUUGUUKVUDUPVJVKVLUUKVUDUURVJVLVMVNVOAVUNRZUWP
      VUBUCUUEVUPUVCUUEQZRZUVKUXRUWOVUAVURUVGUXOUVJUXQVURUVEUXNUVFVURUVCUVDUXMV
      URBCFFABVPSCVPSVAZVUNVUQGVQZABVSSCVSSVAZVUNVUQHVQABFQVUNVUQKVQACFQVUNVUQL
      VQVRVTVKVURUVHUVIUXPAUVIUXPVAVUNVUQADEFFIJMNVRVQVTWAVURUWNUYTUFUUEVURUVNU
      UEQZRZUWMUYHOUUEVVCUUKUUEQZRZUWMUYDUDUWJVDZUEUWLVDUYHVVEUWKVVFUEUWLVVEUVM
      UWLQZRZUWIUYDUDUWJVVHUVLUWJQZRZUVSUYAUWHUYCVVJUVQUXTUVRVVJUUEBCUXSUVPUVMU
      VLUURUVCUVNUUKUUETZUURTZUVPTZUXSTZAVUSVUNVUQVVBVVDVVGVVIGWBAVVAVUNVUQVVBV
      VDVVGVVIHWBVUPVUQVVBVVDVVGVVIWCZVURVVBVVDVVGVVIWDZVVCVVDVVGVVIWEZVVEVVGVV
      IWFZVVHVVIWGWIVKVVJUUFDEUYBUWGUWCUWAUUPUVHUWDUWFUUFTZUUPTZUWGTZUYBTZADVPS
      EVPSVAZVUNVUQVVBVVDVVGVVIIWBADVSSEVSSVAVUNVUQVVBVVDVVGVVIJWBVVJUUEUUFUVCU
      UGVUPUUHVUQVVBVVDVVGVVIAUUHVUMWJWHZVVOWSVVJUUEUUFUVNUUGVWDVVPWSVVJUUEUUFU
      UKUUGVWDVVQWSVVJUWLUVHUWDUUPPZUVMUWBVVHUWLVWEUWBULZVVIVVHUWBVWEUWLURPZQVW
      FVVHUWBUVOUUISZVWGUVCUVNUUIWKVVHVUMUVOUUJQZVWHVWGQVVEVUMVVGVUPVUMVUQVVBVV
      DAUUHVUMWLWMZWNVVHVUQVVBVWIVUPVUQVVBVVDVVGWDVURVVBVVDVVGWEUVCUVNUUEUUEWOW
      PUGUUJVUKUVOVWGUUIVUDUVOVAZVUIVWEVUJUWLURVWKVUFUVHVUHUWDUUPVWKVUEUVCUUGUV
      CUVNVUDUCWQZUFWQZWRVKVWKVUGUVNUUGUVCUVNVUDVWLVWMWTVKVLVWKVUJUVOUURSUWLVUD
      UVOUURVJUVCUVNUURWKXAVLXBWPXCUWBVWEUWLXDXHWNVVRWSVVHUWJUWDUWFUUPPZUVLUVTV
      VEUWJVWNUVTULZVVGVVEUVTVWNUWJURPZQVWOVVEUVTUVNUUKVBZUUISZVWPUVNUUKUUIWKVV
      EVUMVWQUUJQZVWRVWPQVWJVVBVVDVWSVURUVNUUKUUEUUEWOXEUGUUJVUKVWQVWPUUIVUDVWQ
      VAZVUIVWNVUJUWJURVWTVUFUWDVUHUWFUUPVWTVUEUVNUUGUVNUUKVUDVWMOWQZWRVKVWTVUG
      UUKUUGUVNUUKVUDVWMVXAWTVKVLVWTVUJVWQUURSUWJVUDVWQUURVJUVNUUKUURWKXAVLXBWP
      XCUVTVWNUWJXDXHWNXFWIWAXIXIVVEVVFUYFUEUWLUYGVVEUUEBCUURUXHUVCUVNVVKVVLUXH
      TZVURVUSVVBVVDVUTVQZVUPVUQVVBVVDWEVURVVBVVDWFZXGVVEUYDUDUWJUYEVVEUUEBCUUR
      UXHUVNUUKVVKVVLVXBVXCVXDVVCVVDWGXGXJXKXLXIXIVGXIXMXNAUYPUYRVUCUYLAUYPUUHU
      XLRUYRAUUHUVBUXLAUUHRZUVAUXKUUIVXEUVAOUUJUXJUSUXKVXEOUUJUUTUXJVXEUUKUUJQZ
      RZUUQUXGUUSUXIURVXGUUFDEUUPUXFUUMUUOVVSVVTUXFTZAVWCUUHVXFIVQVXGUUEUUFUULU
      UGAUUHVXFWFZVXFUULUUEQVXEUUKUUEUUEXOXRZWSVXGUUEUUFUUNUUGVXIVXFUUNUUEQVXEU
      UKUUEUUEXPXRZWSXGVXGUULUUNVBZUURSZVXLUXHSZUUSUXIVXGUULUUNUURPUULUUNUXHPVX
      MVXNVXGUUEBCUURUXHUULUUNVVKVVLVXBAVUSUUHVXFGVQVXJVXKXGUULUUNUURWKUULUUNUX
      HWKXQVXGUUKVXLUURVXFUUKVXLVAVXEUUKUUEUUEXSXRZVKVXGUUKVXLUXHVXOVKXTVLYAVXE
      OUUJUXEUXJAUUJUXEVAUUHAUUEUXBUUEUXBABCGYGZVXPYBWNYCYHYDXNAUUHUXDUXLAUUEUU
      FUXBUXCUUGVXPADEIYGYEYIXLAVUBUYKUCUUEUXBVXPAVUQRZVUAUYJUXRVXQUYTUYIUFUUEU
      XBAUUEUXBVAVUQVXPWNZVXQUYHOUUEUXBVXRXJXKYJYFVGXLUUHUVBUWQYKUXDUXLUYLYKYLV
      GUYNUUDUWRUYNUUGUUIVBZYTQUUDUUGUUIYTYMBDVXSYNYQUUDUCUFOUUEUUFBUVPUVDUEUDD
      UUGUUIUURUVIUUPUWGVVKVVSVVLVVTUVDTUVITVVMVWAUUBUUCYRUUBUUCWGYOYPUYOUXAUYM
      UYOVXSUUAQUXAUUGUUIUUAYMCEVXSYNYQUXAUCUFOUXBUXCCUXSUXMUEUDEUUGUUIUXHUXPUX
      FUYBUXBTUXCTVXBVXHUXMTUXPTVVNVWBUWSUWTYRUWSUWTWGYOYPYLYS $.
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y D $.  $d x y E $.  $d x y ph $.
    $d x y F $.  $d x y G $.  $d x y S $.
    funcres2c.a $e |- A = ( Base ` C ) $.
    funcres2c.e $e |- E = ( D |`s S ) $.
    funcres2c.d $e |- ( ph -> D e. Cat ) $.
    funcres2c.r $e |- ( ph -> S e. V ) $.
    funcres2c.1 $e |- ( ph -> F : A --> S ) $.
    $( Condition for a functor to also be a functor into the restriction.
       (Contributed by Mario Carneiro, 30-Jan-2017.) $)
    funcres2c $p |- ( ph -> ( F ( C Func D ) G <-> F ( C Func E ) G ) ) $=
      ( co wa cfv eqid wcel wf vx vy cfunc wbr wo wi orc a1i olc wb cbs cin cxp
      chomf cres cresc chom cv csubc wss inss2 fullsubc adantr wfn homffn mp2an
      xpss12 fnssres crn ffn syl frn simpr funcf1 ressbasss syl6ss jaodan ssind
      df-f sylanbrc simplrl simplrr funcf2 eqidd resshom ad2antrr feq23d mpbird
      wceq oveqd an32s simprl ffvelrnd simprr ovresd sseldi eqtrd funcres2b cvv
      ccomf cress ressinbas syl5eq fveq2d fullresc simpld simprd ccat cop df-br
      homfval funcrcl sylbi jaoi elex adantl eqeltri funcpropd bitr4d pm5.21ndd
      ovex breqd ex ) AGHCDUCOZUDZGHCFUCOZUDZUEZYEYGYEYHUFAYEYGUGUHYGYHUFAYGYEU
      IUHAYHYEYGUJAYHPZYEGHCDDUNQZEDUKQZULZYLUMZUOZUPOZUCOZUDYGYIUAUBBCDYNYLGHC
      UQQZUAURZUBURZYQOZJYQRZAYNDUSQSYHAYKDYLYJYKRZYJRZLYLYKUTZAEYKVAZUHZVBVCYN
      YMVDZYIYJYKYKUMZVDYMUUHUTZUUGYKDYJUUCUUBVEUUDUUDUUIUUEUUEYLYKYLYKVGVFUUHY
      MYJVHVFUHYIGBVDZGVIZYLUTBYLGTZYIBEGTZUUJAUUMYHNVCZBEGVJVKYIUUKEYKYIUUMUUK
      EUTUUNBEGVLVKAYEUUKYKUTZYGAYEPZBYKGTUUOUUPBYKCDGHJUUBAYEVMVNBYKGVLVKAYGPZ
      UUKFUKQZYKUUQBUURGTUUKUURUTUUQBUURCFGHJUURRAYGVMVNBUURGVLVKEYKFDKUUBVOVPV
      QVRBYLGVSVTZYIYRBSZYSBSZPZPZYTYRGQZYSGQZYNOZYRYSHOZTYTUVDUVEDUQQZOZUVGTZA
      UVBYHUVJAUVBPZYEUVJYGUVKYEPBCDGHYQUVHYRYSJUUAUVHRZUVKYEVMAUUTUVAYEWAAUUTU
      VAYEWBWCUVKYGPZUVJYTUVDUVEFUQQZOZUVGTUVMBCFGHYQUVNYRYSJUUAUVNRUVKYGVMAUUT
      UVAYGWAAUUTUVAYGWBWCUVMYTUVIYTUVOUVGUVMYTWDUVMUVHUVNUVDUVEAUVHUVNWIZUVBYG
      AEISZUVPMEDFUVHIKUVLWEVKWFWJWGWHVQWKUVCYTUVFYTUVIUVGUVCYTWDUVCUVFUVDUVEYJ
      OUVIUVCUVDUVEYJYLUVCBYLYRGYIUULUVBUUSVCZYIUUTUVAWLWMZUVCBYLYSGUVRYIUUTUVA
      WNWMZWOUVCYKDYJUVHUVDUVEUUCUUBUVLUVCYLYKUVDUUEUVSWPUVCYLYKUVEUUEUVTWPXKWQ
      WGWHWRYIYFYPGHYICCFYOWSYICUNQWDYICWTQWDAFUNQZYOUNQZWIYHAUWADYLXAOZUNQZUWB
      AFUWCUNAFDEXAOZUWCKAUVQUWEUWCWIMEYKDIUUBXBVKXCZXDAUWDUWBWIZUWCWTQZYOWTQZW
      IZAYKDUWCYLYOYJUUBUUCLUUFUWCRYORXEZXFWQVCAFWTQZUWIWIYHAUWLUWHUWIAFUWCWTUW
      FXDAUWGUWJUWKXGWQVCYHCWSSZAYHCXHSZUWMYEUWNYGYEUWNDXHSZYEGHXIZYDSUWNUWOPGH
      YDXJCDUWPXLXMXFYGUWNFXHSZYGUWPYFSUWNUWQPGHYFXJCFUWPXLXMXFXNCXHXOVKXPZUWRF
      WSSYIFUWEWSKDEXAYAXQUHYOWSSYIDYNUPYAUHXRYBXSYCXT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Full & faithful functors
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Full $.  $( The class of full functors. $)
  $c Faith $.  $( The class of faithful functors. $)

  $( Extend class notation with the class of all full functors. $)
  cful $a class Full $.

  $( Extend class notation with the class of all faithful functors. $)
  cfth $a class Faith $.

  ${
    $d c d f g x y $.  $d c d C $.  $d d D $.
    $( Function returning all the full functors from a category ` C ` to a
       category ` D ` .  A full functor is a functor in which all the morphism
       maps ` G ( X , Y ) ` between objects ` X , Y e. C ` are surjections.
       (Contributed by Mario Carneiro, 26-Jan-2017.) $)
    df-full $a |- Full = ( c e. Cat , d e. Cat |->
      { <. f , g >. | ( f ( c Func d ) g /\
        A. x e. ( Base ` c ) A. y e. ( Base ` c )
        ran ( x g y ) = ( ( f ` x ) ( Hom ` d ) ( f ` y ) ) ) } ) $.

    $( Function returning all the faithful functors from a category ` C ` to a
       category ` D ` .  A full functor is a functor in which all the morphism
       maps ` G ( X , Y ) ` between objects ` X , Y e. C ` are injections.
       (Contributed by Mario Carneiro, 26-Jan-2017.) $)
    df-fth $a |- Faith = ( c e. Cat , d e. Cat |->
      { <. f , g >. | ( f ( c Func d ) g /\
        A. x e. ( Base ` c ) A. y e. ( Base ` c ) Fun `' ( x g y ) ) } ) $.

    $( A full functor is a functor.  (Contributed by Mario Carneiro,
       26-Jan-2017.) $)
    fullfunc $p |- ( C Full D ) C_ ( C Func D ) $=
      ( vc vd vf vg vx vy ccat wcel wa cful co cfunc wss wceq oveq1 sseq12d cfv
      cv oveq2 wbr crn chom cbs wral copab cvv ovex simpl ssopab2i opabss sstri
      ssexi df-full ovmpt4g mp3an3 syl6eqss vtocl2ga wn c0 mpt2ndm0 0ss pm2.61i
      ) AIJBIJKZABLMZABNMZOZCTZDTZLMZVIVJNMZOAVJLMZAVJNMZOVHCDABIIVIAPVKVMVLVNV
      IAVJLQVIAVJNQRVJBPVMVFVNVGVJBALUAVJBANUARVIIJZVJIJZKVKETZFTZVLUBZGTZHTZVR
      MUCVTVQSWAVQSVJUDSMPHVIUESZUFGWBUFZKZEFUGZVLVOVPWEUHJVKWEPWEVLVIVJNUIWEVS
      EFUGVLWDVSEFVSWCUJUKEFVLULUMZUNCDIIWELUHGHEFCDUOZUPUQWFURUSVEUTVFVAVGCDWE
      LABIIWGVBVGVCURVD $.

    $( A faithful functor is a functor.  (Contributed by Mario Carneiro,
       26-Jan-2017.) $)
    fthfunc $p |- ( C Faith D ) C_ ( C Func D ) $=
      ( vc vd vf vg vx vy ccat wcel wa cfth co cfunc wss cv oveq1 sseq12d oveq2
      wceq wbr ccnv wfun cbs cfv wral copab cvv ovex simpl ssopab2i sstri ssexi
      opabss df-fth ovmpt4g mp3an3 syl6eqss vtocl2ga wn c0 mpt2ndm0 0ss pm2.61i
      ) AIJBIJKZABLMZABNMZOZCPZDPZLMZVIVJNMZOAVJLMZAVJNMZOVHCDABIIVIATVKVMVLVNV
      IAVJLQVIAVJNQRVJBTVMVFVNVGVJBALSVJBANSRVIIJZVJIJZKVKEPFPZVLUAZGPHPVQMUBUC
      HVIUDUEZUFGVSUFZKZEFUGZVLVOVPWBUHJVKWBTWBVLVIVJNUIWBVREFUGVLWAVREFVRVTUJU
      KEFVLUNULZUMCDIIWBLUHGHEFCDUOZUPUQWCURUSVEUTVFVAVGCDWBLABIIWDVBVGVCURVD
      $.
  $}

  $( The set of full functors is a relation.  (Contributed by Mario Carneiro,
     26-Jan-2017.) $)
  relfull $p |- Rel ( C Full D ) $=
    ( cful co cfunc wss wrel fullfunc relfunc relss mp2 ) ABCDZABEDZFMGLGABHABI
    LMJK $.

  $( The set of faithful functors is a relation.  (Contributed by Mario
     Carneiro, 26-Jan-2017.) $)
  relfth $p |- Rel ( C Faith D ) $=
    ( cfth co cfunc wss wrel fthfunc relfunc relss mp2 ) ABCDZABEDZFMGLGABHABIL
    MJK $.

  ${
    $d c d f g x y B $.  $d c d f g x y C $.  $d c d f g x y D $.  $d x y ph $.
    $d f x y H $.  $d c d f g x y J $.  $d f R $.  $d f x y X $.  $d f x y Y $.
    $d f g x y F $.  $d f g x y G $.
    isfull.b $e |- B = ( Base ` C ) $.
    isfull.j $e |- J = ( Hom ` D ) $.
    $( Value of the set of full functors between two categories.  (Contributed
       by Mario Carneiro, 27-Jan-2017.) $)
    isfull $p |- ( F ( C Full D ) G <-> ( F ( C Func D ) G /\
      A. x e. B A. y e. B ran ( x G y ) = ( ( F ` x ) J ( F ` y ) ) ) ) $=
      ( vf vg co wbr cv cfv wceq wral wa wcel vc cfunc crn fullfunc ssbri copab
      vd cful ccat cop df-br funcrcl sylbi chom cbs oveq12 breqd fveq2d syl6eqr
      simpl simpr oveqd eqeq2d raleqbidv anbi12d opabbidv df-full ovex ssopab2i
      opabss sstri ssexi ovmpt2a syl cvv wb wrel relfunc brrelex12 breq12 rneqd
      mpan fveq1d oveq12d eqeq12d 2ralbidv eqid brabga bitrd bianabs biadan2 )
      FGDEUHMZNZFGDEUBMZNZAOZBOZGMZUCZWPFPZWQFPZHMZQZBCRACRZWLWNFGDEUDUEWOWMXDW
      OWMFGKOZLOZWNNZWPWQXFMZUCZWPXEPZWQXEPZHMZQZBCRZACRZSZKLUFZNZWOXDSZWOWLXQF
      GWODUITEUITSZWLXQQWOFGUJZWNTXTFGWNUKDEYAULUMUAUGDEUIUIXEXFUAOZUGOZUBMZNZX
      IXJXKYCUNPZMZQZBYBUOPZRZAYIRZSZKLUFXQUHYBDQZYCEQZSZYLXPKLYOYEXGYKXOYOYDWN
      XEXFYBDYCEUBUPUQYOYJXNAYICYOYIDUOPCYOYBDUOYMYNUTURIUSZYOYHXMBYICYPYOYGXLX
      IYOYFHXJXKYOYFEUNPHYOYCEUNYMYNVAURJUSVBVCVDVDVEVFABKLUAUGVGXQWNDEUBVHXQXG
      KLUFWNXPXGKLXGXOUTVIKLWNVJVKVLVMVNUQWOFVOTGVOTSZXRXSVPWNVQWOYQDEVRFGWNVSW
      BXPXSKLFGXQVOVOXEFQZXFGQZSZXGWOXOXDXEFXFGWNVTYTXMXCABCCYTXIWSXLXBYTXHWRYT
      XFGWPWQYRYSVAVBWAYTXJWTXKXAHYTWPXEFYRYSUTZWCYTWQXEFUUAWCWDWEWFVEXQWGWHVNW
      IWJWK $.

    isfull.h $e |- H = ( Hom ` C ) $.
    $( Equivalent condition for a full functor.  (Contributed by Mario
       Carneiro, 27-Jan-2017.) $)
    isfull2 $p |- ( F ( C Full D ) G <-> ( F ( C Func D ) G /\
      A. x e. B A. y e. B
        ( x G y ) : ( x H y ) -onto-> ( ( F ` x ) J ( F ` y ) ) ) ) $=
      ( co wbr cv cfv wral wa wcel ralbidva cful cfunc crn wfo isfull wf wfn wb
      wceq simpll simplr simpr funcf2 ffn df-fo baib 3syl pm5.32i bitr4i ) FGDE
      UAMNFGDEUBMNZAOZBOZGMZUCVAFPVBFPIMZUIZBCQZACQZRUTVAVBHMZVDVCUDZBCQZACQZRA
      BCDEFGIJKUEUTVKVGUTVJVFACUTVACSZRZVIVEBCVMVBCSZRZVHVDVCUFVCVHUGZVIVEUHVOC
      DEFGHIVAVBJLKUTVLVNUJUTVLVNUKVMVNULUMVHVDVCUNVIVPVEVHVDVCUOUPUQTTURUS $.

    fullfo.f $e |- ( ph -> F ( C Full D ) G ) $.
    fullfo.x $e |- ( ph -> X e. B ) $.
    fullfo.y $e |- ( ph -> Y e. B ) $.
    $( The morphism map of a full functor is a surjection.  (Contributed by
       Mario Carneiro, 27-Jan-2017.) $)
    fullfo $p |- ( ph ->
      ( X G Y ) : ( X H Y ) -onto-> ( ( F ` X ) J ( F ` Y ) ) ) $=
      ( vx vy co cfv cv wfo wral cful wbr cfunc isfull2 simprbi syl wceq adantr
      wa wcel simplr simpr oveq12d fveq2d foeq123d rspcdv rspcimdv mpd ) AQUAZR
      UAZGSZVBETZVCETZHSZVBVCFSZUBZRBUCZQBUCZIJGSZIETZJETZHSZIJFSZUBZAEFCDUDSUE
      ZVKNVREFCDUFSUEVKQRBCDEFGHKLMUGUHUIAVJVQQIBOAVBIUJZULZVIVQRJBAJBUMVSPUKVT
      VCJUJZULZVDVLVGVOVHVPWBVBIVCJFAVSWAUNZVTWAUOZUPWBVBIVCJGWCWDUPWBVEVMVFVNH
      WBVBIEWCUQWBVCJEWDUQUPURUSUTVA $.

    fulli.r $e |- ( ph -> R e. ( ( F ` X ) J ( F ` Y ) ) ) $.
    $( The morphism map of a full functor is a surjection.  (Contributed by
       Mario Carneiro, 27-Jan-2017.) $)
    fulli $p |- ( ph -> E. f e. ( X H Y ) R = ( ( X G Y ) ` f ) ) $=
      ( co cfv wfo wcel cv wceq wrex fullfo foelrn syl2anc ) AKLITZKGUALGUAJTZK
      LHTZUBEUKUCEFUDULUAUEFUJUFABCDGHIJKLMNOPQRUGSFUJUKEULUHUI $.
  $}

  ${
    $d c d f g x y B $.  $d c d f g x y C $.  $d c d f g x y D $.  $d x y ph $.
    $d f g x y F $.  $d f g x y G $.  $d x y H $.  $d x y J $.  $d x y X $.
    $d x y Y $.
    isfth.b $e |- B = ( Base ` C ) $.
    $( Value of the set of faithful functors between two categories.
       (Contributed by Mario Carneiro, 27-Jan-2017.) $)
    isfth $p |- ( F ( C Faith D ) G <-> ( F ( C Func D ) G /\
      A. x e. B A. y e. B Fun `' ( x G y ) ) ) $=
      ( vf vg co wbr cfunc cv wral wa ccat wcel wceq cvv cfth ccnv wfun fthfunc
      vc ssbri copab cop df-br funcrcl sylbi cbs cfv oveq12 breqd simpl syl6eqr
      vd fveq2d raleqdv raleqbidv anbi12d opabbidv df-fth ssopab2i opabss sstri
      ovex ssexi ovmpt2a syl wb wrel relfunc brrelex12 mpan breq12 simpr cnveqd
      oveqd funeqd 2ralbidv eqid brabga bitrd bianabs biadan2 ) FGDEUAKZLZFGDEM
      KZLZANZBNZGKZUBZUCZBCOACOZWHWJFGDEUDUFWKWIWQWKWIFGINZJNZWJLZWLWMWSKZUBZUC
      ZBCOZACOZPZIJUGZLZWKWQPZWKWHXGFGWKDQREQRPZWHXGSWKFGUHZWJRXJFGWJUIDEXKUJUK
      UEURDEQQWRWSUENZURNZMKZLZXCBXLULUMZOZAXPOZPZIJUGXGUAXLDSZXMESZPZXSXFIJYBX
      OWTXRXEYBXNWJWRWSXLDXMEMUNUOYBXQXDAXPCYBXPDULUMCYBXLDULXTYAUPUSHUQZYBXCBX
      PCYCUTVAVBVCABIJUEURVDXGWJDEMVHXGWTIJUGWJXFWTIJWTXEUPVEIJWJVFVGVIVJVKUOWK
      FTRGTRPZXHXIVLWJVMWKYDDEVNFGWJVOVPXFXIIJFGXGTTWRFSZWSGSZPZWTWKXEWQWRFWSGW
      JVQYGXCWPABCCYGXBWOYGXAWNYGWSGWLWMYEYFVRVTVSWAWBVBXGWCWDVKWEWFWG $.

    isfth.h $e |- H = ( Hom ` C ) $.
    isfth.j $e |- J = ( Hom ` D ) $.
    $( Equivalent condition for a faithful functor.  (Contributed by Mario
       Carneiro, 27-Jan-2017.) $)
    isfth2 $p |- ( F ( C Faith D ) G <-> ( F ( C Func D ) G /\
      A. x e. B A. y e. B
        ( x G y ) : ( x H y ) -1-1-> ( ( F ` x ) J ( F ` y ) ) ) ) $=
      ( co wbr cv wral wa cfv wcel ralbidva cfth cfunc ccnv wf1 isfth wf simpll
      wfun wb simplr simpr funcf2 df-f1 baib syl pm5.32i bitr4i ) FGDEUAMNFGDEU
      BMNZAOZBOZGMZUCUHZBCPZACPZQURUSUTHMZUSFRUTFRIMZVAUDZBCPZACPZQABCDEFGJUEUR
      VIVDURVHVCACURUSCSZQZVGVBBCVKUTCSZQZVEVFVAUFZVGVBUIVMCDEFGHIUSUTJKLURVJVL
      UGURVJVLUJVKVLUKULVGVNVBVEVFVAUMUNUOTTUPUQ $.

    $( A fully faithful functor is a functor which is bijective on hom-sets.
       (Contributed by Mario Carneiro, 27-Jan-2017.) $)
    isffth2 $p |- ( F ( ( C Full D ) i^i ( C Faith D ) ) G <->
      ( F ( C Func D ) G /\ A. x e. B A. y e. B
        ( x G y ) : ( x H y ) -1-1-onto-> ( ( F ` x ) J ( F ` y ) ) ) ) $=
      ( cful co wbr wa cv cfv wral bitri cfth cfunc wfo wf1 wf1o isfull2 isfth2
      cin anbi12i brin df-f1o ancom 2ralbii r19.26-2 anbi2i anandi 3bitr4i ) FG
      DEMNZOZFGDEUANZOZPFGDEUBNOZAQZBQZHNZVCFRVDFRINZVCVDGNZUCZBCSACSZPZVBVEVFV
      GUDZBCSACSZPZPZFGURUTUHOVBVEVFVGUEZBCSACSZPZUSVJVAVMABCDEFGHIJLKUFABCDEFG
      HIJKLUGUIFGURUTUJVQVBVIVLPZPVNVPVRVBVPVHVKPZBCSACSVRVOVSABCCVOVKVHPVSVEVF
      VGUKVKVHULTUMVHVKABCCUNTUOVBVIVLUPTUQ $.

    ${
      fthf1.f $e |- ( ph -> F ( C Faith D ) G ) $.
      fthf1.x $e |- ( ph -> X e. B ) $.
      fthf1.y $e |- ( ph -> Y e. B ) $.
      $( The morphism map of a faithful functor is an injection.  (Contributed
         by Mario Carneiro, 27-Jan-2017.) $)
      fthf1 $p |- ( ph ->
        ( X G Y ) : ( X H Y ) -1-1-> ( ( F ` X ) J ( F ` Y ) ) ) $=
        ( vx vy co cfv cv wf1 wral cfth wbr cfunc isfth2 simprbi wceq wa adantr
        syl wcel simplr simpr oveq12d fveq2d f1eq123d rspcdv rspcimdv mpd ) AQU
        AZRUAZGSZVBETZVCETZHSZVBVCFSZUBZRBUCZQBUCZIJGSZIETZJETZHSZIJFSZUBZAEFCD
        UDSUEZVKNVREFCDUFSUEVKQRBCDEFGHKLMUGUHULAVJVQQIBOAVBIUIZUJZVIVQRJBAJBUM
        VSPUKVTVCJUIZUJZVDVLVGVOVHVPWBVBIVCJFAVSWAUNZVTWAUOZUPWBVBIVCJGWCWDUPWB
        VEVMVFVNHWBVBIEWCUQWBVCJEWDUQUPURUSUTVA $.

      fthi.r $e |- ( ph -> R e. ( X H Y ) ) $.
      fthi.s $e |- ( ph -> S e. ( X H Y ) ) $.
      $( The morphism map of a faithful functor is an injection.  (Contributed
         by Mario Carneiro, 27-Jan-2017.) $)
      fthi $p |- ( ph ->
        ( ( ( X G Y ) ` R ) = ( ( X G Y ) ` S ) <-> R = S ) ) $=
        ( co cfv wf1 wcel wceq wb fthf1 f1fveq syl12anc ) AKLIUAZKGUBLGUBJUAZKL
        HUAZUCEUJUDFUJUDEULUBFULUBUEEFUEUFABCDGHIJKLMNOPQRUGSTUJUKEFULUHUI $.
    $}

    ffthf1o.f $e |- ( ph -> F ( ( C Full D ) i^i ( C Faith D ) ) G ) $.
    ffthf1o.x $e |- ( ph -> X e. B ) $.
    ffthf1o.y $e |- ( ph -> Y e. B ) $.
    $( The morphism map of a fully faithful functor is a bijection.
       (Contributed by Mario Carneiro, 29-Jan-2017.) $)
    ffthf1o $p |- ( ph ->
      ( X G Y ) : ( X H Y ) -1-1-onto-> ( ( F ` X ) J ( F ` Y ) ) ) $=
      ( co cfv wf1 wbr wfo wf1o cful cfth cin wa brin sylib simprd fthf1 simpld
      fullfo df-f1o sylanbrc ) AIJGQZIERJERHQZIJFQZSUOUPUQUAUOUPUQUBABCDEFGHIJK
      LMAEFCDUCQZTZEFCDUDQZTZAEFURUTUETUSVAUFNEFURUTUGUHZUIOPUJABCDEFGHIJKMLAUS
      VAVBUKOPULUOUPUQUMUN $.
  $}

  ${
    $d f g x y A $.  $d f g x y B $.  $d f g x y C $.  $d f g x y ph $.
    $d f g x y D $.
    fullpropd.1 $e |- ( ph -> ( Homf ` A ) = ( Homf ` B ) ) $.
    fullpropd.2 $e |- ( ph -> ( comf ` A ) = ( comf ` B ) ) $.
    fullpropd.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    fullpropd.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    fullpropd.a $e |- ( ph -> A e. V ) $.
    fullpropd.b $e |- ( ph -> B e. V ) $.
    fullpropd.c $e |- ( ph -> C e. V ) $.
    fullpropd.d $e |- ( ph -> D e. V ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same full functors.  (Contributed by
       Mario Carneiro, 27-Jan-2017.) $)
    fullpropd $p |- ( ph -> ( A Full C ) = ( B Full D ) ) $=
      ( vx vy co cfv wa eqid vf vg cful relfull cv cfunc wbr crn chom wceq wral
      cbs homfeqbas adantr chomf ad3antrrr simpllr funcf1 simplr ffvelrnd simpr
      homfeqval eqeq2d raleqbidva pm5.32da funcpropd breqd anbi1d bitrd 3bitr4g
      wcel isfull eqbrrdiv ) AUAUBBDUCQZCEUCQZBDUDCEUDAUAUEZUBUEZBDUFQZUGZOUEZP
      UEZVQQUHZVTVPRZWAVPRZDUIRZQZUJZPBULRZUKZOWHUKZSZVPVQCEUFQZUGZWBWCWDEUIRZQ
      ZUJZPCULRZUKZOWQUKZSZVPVQVNUGVPVQVOUGAWKVSWSSWTAVSWJWSAVSSZWIWROWHWQAWHWQ
      UJZVSABCGUMUNZXAVTWHVKZSZWGWPPWHWQXAXBXDXCUNXEWAWHVKZSZWFWOWBXGDULRZDEWEW
      NWCWDXHTZWETZWNTZADUOREUORUJVSXDXFIUPXGWHXHVTVPXGWHXHBDVPVQWHTZXIAVSXDXFU
      QURZXAXDXFUSUTXGWHXHWAVPXMXEXFVAUTVBVCVDVDVEAVSWMWSAVRWLVPVQABCDEFGHIJKLM
      NVFVGVHVIOPWHBDVPVQWEXLXJVLOPWQCEVPVQWNWQTXKVLVJVM $.

    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same full functors.  (Contributed by
       Mario Carneiro, 27-Jan-2017.) $)
    fthpropd $p |- ( ph -> ( A Faith C ) = ( B Faith D ) ) $=
      ( vx vy co cv wbr wral vf vg cfth relfth cfunc ccnv wfun cbs wa funcpropd
      cfv breqd homfeqbas raleqdv raleqbidv anbi12d eqid isfth 3bitr4g eqbrrdiv
      ) AUAUBBDUCQZCEUCQZBDUDCEUDAUARZUBRZBDUEQZSZORPRVDQUFUGZPBUHUKZTZOVHTZUIV
      CVDCEUEQZSZVGPCUHUKZTZOVMTZUIVCVDVASVCVDVBSAVFVLVJVOAVEVKVCVDABCDEFGHIJKL
      MNUJULAVIVNOVHVMABCGUMZAVGPVHVMVPUNUOUPOPVHBDVCVDVHUQUROPVMCEVCVDVMUQURUS
      UT $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z F $.  $d f g x y z G $.  $d f g x y z ph $.
    $d f g x y z O $.  $d f g x y z P $.
    fulloppc.o $e |- O = ( oppCat ` C ) $.
    fulloppc.p $e |- P = ( oppCat ` D ) $.
    ${
      fulloppc.f $e |- ( ph -> F ( C Full D ) G ) $.
      $( The opposite functor of a full functor is also full.  (Contributed by
         Mario Carneiro, 27-Jan-2017.) $)
      fulloppc $p |- ( ph -> F ( O Full P ) tpos G ) $=
        ( vx vy cfunc co wbr cv crn cfv chom eqid ctpos wceq wral cful fullfunc
        cbs ssbri syl funcoppc wcel wfo adantr simprr simprl fullfo forn ovtpos
        wa rneqi oppchom 3eqtr4g ralrimivva oppcbas isfull sylanbrc ) AEFUAZGDM
        NOKPZLPZVFNZQZVGERZVHERZDSRZNZUBZLBUFRZUCKVPUCEVFGDUDNOABCDEFGHIAEFBCUD
        NZOZEFBCMNZOJVQVSEFBCUEUGUHUIAVOKLVPVPAVGVPUJZVHVPUJZURZURZVHVGFNZQZVLV
        KCSRZNZVJVNWCVHVGBSRZNZWGWDUKWEWGUBWCVPBCEFWHWFVHVGVPTZWFTZWHTAVRWBJULA
        VTWAUMAVTWAUNUOWIWGWDUPUHVIWDVGVHFUQUSCWFDVKVLWKIUTVAVBKLVPGDEVFVMVPBGH
        WJVCVMTVDVE $.
    $}

    ${
      fthoppc.f $e |- ( ph -> F ( C Faith D ) G ) $.
      $( The opposite functor of a faithful functor is also faithful.
         (Contributed by Mario Carneiro, 27-Jan-2017.) $)
      fthoppc $p |- ( ph -> F ( O Faith P ) tpos G ) $=
        ( vx vy cfunc co wbr cv ccnv wfun cfv eqid ctpos cbs wral fthfunc ssbri
        cfth syl funcoppc wcel wa chom adantr simprr simprl fthf1 df-f1 simprbi
        wf1 wf ovtpos cnveqi funeqi sylibr ralrimivva oppcbas isfth sylanbrc )
        AEFUAZGDMNOKPZLPZVHNZQZRZLBUBSZUCKVNUCEVHGDUFNOABCDEFGHIAEFBCUFNZOZEFBC
        MNZOJVOVQEFBCUDUEUGUHAVMKLVNVNAVIVNUIZVJVNUIZUJZUJZVJVIFNZQZRZVMWAVJVIB
        UKSZNZVJESVIESCUKSZNZWBURZWDWAVNBCEFWEWGVJVIVNTZWETWGTAVPVTJULAVRVSUMAV
        RVSUNUOWIWFWHWBUSWDWFWHWBUPUQUGVLWCVKWBVIVJFUTVAVBVCVDKLVNGDEVHVNBGHWJV
        EVFVG $.
    $}

    ${
      ffthoppc.f $e |- ( ph -> F ( ( C Full D ) i^i ( C Faith D ) ) G ) $.
      $( The opposite functor of a fully faithful functor is also full and
         faithful.  (Contributed by Mario Carneiro, 27-Jan-2017.) $)
      ffthoppc $p |- ( ph -> F ( ( O Full P ) i^i ( O Faith P ) ) tpos G ) $=
        ( ctpos cful co wbr cfth cin wa brin sylib simpld fulloppc sylanbrc
        simprd fthoppc ) AEFKZGDLMZNEUEGDOMZNEUEUFUGPNABCDEFGHIAEFBCLMZNZEFBCOM
        ZNZAEFUHUJPNUIUKQJEFUHUJRSZTUAABCDEFGHIAUIUKULUCUDEUEUFUGRUB $.
    $}
  $}

  ${
    fthsect.b $e |- B = ( Base ` C ) $.
    fthsect.h $e |- H = ( Hom ` C ) $.
    fthsect.f $e |- ( ph -> F ( C Faith D ) G ) $.
    fthsect.x $e |- ( ph -> X e. B ) $.
    fthsect.y $e |- ( ph -> Y e. B ) $.
    fthsect.m $e |- ( ph -> M e. ( X H Y ) ) $.
    fthsect.n $e |- ( ph -> N e. ( Y H X ) ) $.
    ${
      fthsect.s $e |- S = ( Sect ` C ) $.
      fthsect.t $e |- T = ( Sect ` D ) $.
      $( A faithful functor reflects sections.  (Contributed by Mario Carneiro,
         27-Jan-2017.) $)
      fthsect $p |- ( ph -> ( M ( X S Y ) N <->
        ( ( X G Y ) ` M ) ( ( F ` X ) T ( F ` Y ) ) ( ( Y G X ) ` N ) ) ) $=
        ( cop cco cfv co ccid wceq chom eqid ccat wcel cfunc cfth fthfunc ssbri
        wbr wa df-br sylib funcrcl simpld catcocl catidcl funcco funcid eqeq12d
        syl fthi bitr3d issect2 cbs simprd funcf1 ffvelrnd funcf2 3bitr4d ) AKJ
        LMUCLCUDUEZUFUFZLCUGUEZUEZUHZKMLHUFZUEZJLMHUFZUEZLGUEZMGUEZUCWGDUDUEZUF
        UFZWGDUGUEZUEZUHZJKLMEUFUQWFWDWGWHFUFUQAVSLLHUFZUEZWAWNUEZUHWBWMABCDVSW
        AGHIDUIUEZLLNOWQUJZPQQABCVRJKILMLNOVRUJZACUKULZDUKULZAGHUCZCDUMUFZULZWT
        XAURAGHXCUQZXDAGHCDUNUFZUQXEPXFXCGHCDUOUPVHZGHXCUSUTCDXBVAVHZVBZQRQSTVC
        ABCVTILNOVTUJZXIQVDVIAWOWJWPWLABCVRDGHIJKWILMLNOWSWIUJZXGQRQSTVEABCVTDG
        HWKLNXJWKUJZXGQVFVGVJABCEVRVTJKILMNOWSXJUAXIQRSTVKADVLUEZDFWIWKWFWDWQWG
        WHXMUJZWRXKXLUBAWTXAXHVMABXMLGABXMCDGHNXNXGVNZQVOABXMMGXORVOALMIUFWGWHW
        QUFJWEABCDGHIWQLMNOWRXGQRVPSVOAMLIUFWHWGWQUFKWCABCDGHIWQMLNOWRXGRQVPTVO
        VKVQ $.
    $}

    ${
      fthinv.s $e |- I = ( Inv ` C ) $.
      fthinv.t $e |- J = ( Inv ` D ) $.
      $( A faithful functor reflects inverses.  (Contributed by Mario Carneiro,
         27-Jan-2017.) $)
      fthinv $p |- ( ph -> ( M ( X I Y ) N <->
        ( ( X G Y ) ` M ) ( ( F ` X ) J ( F ` Y ) ) ( ( Y G X ) ` N ) ) ) $=
        ( csect cfv co wbr wa eqid fthsect anbi12d ccat wcel cfunc cfth fthfunc
        cop ssbri syl df-br sylib funcrcl simpld simprd funcf1 ffvelrnd 3bitr4d
        isinv cbs ) AJKLMCUCUDZUEUFZKJMLVIUEUFZUGJLMFUEUDZKMLFUEUDZLEUDZMEUDZDU
        CUDZUEUFZVMVLVOVNVPUEUFZUGJKLMHUEUFVLVMVNVOIUEUFAVJVQVKVRABCDVIVPEFGJKL
        MNOPQRSTVIUHZVPUHZUIABCDVIVPEFGKJMLNOPRQTSVSVTUIUJABCVIJKHLMNUAACUKULZD
        UKULZAEFUPZCDUMUEZULZWAWBUGAEFWDUFZWEAEFCDUNUEZUFWFPWGWDEFCDUOUQURZEFWD
        USUTCDWCVAURZVBQRVSVGADVHUDZDVPVLVMIVNVOWJUHZUBAWAWBWIVCABWJLEABWJCDEFN
        WKWHVDZQVEABWJMEWLRVEVTVGVF $.
    $}
  $}

  ${
    $d f g z B $.  $d f g z C $.  $d f g z H $.  $d f g z ph $.  $d f g z R $.
    $d f D $.  $d f F $.  $d f G $.  $d f I $.  $d f g z X $.  $d f g z Y $.
    $d f J $.
    fthmon.b $e |- B = ( Base ` C ) $.
    fthmon.h $e |- H = ( Hom ` C ) $.
    fthmon.f $e |- ( ph -> F ( C Faith D ) G ) $.
    fthmon.x $e |- ( ph -> X e. B ) $.
    fthmon.y $e |- ( ph -> Y e. B ) $.
    fthmon.r $e |- ( ph -> R e. ( X H Y ) ) $.
    ${
      fthmon.m $e |- M = ( Mono ` C ) $.
      fthmon.n $e |- N = ( Mono ` D ) $.
      fthmon.1 $e |- ( ph ->
        ( ( X G Y ) ` R ) e. ( ( F ` X ) N ( F ` Y ) ) ) $.
      $( A faithful functor reflects monomorphisms.  (Contributed by Mario
         Carneiro, 27-Jan-2017.) $)
      fthmon $p |- ( ph -> R e. ( X M Y ) ) $=
        ( vf vz vg co wcel cv cop cco cfv wceq wi wral w3a chom eqid ccat cfunc
        cbs wbr cfth fthfunc ssbri syl df-br sylib funcrcl simprd adantr funcf1
        ffvelrnd simpr1 funcf2 simpr2 simpr3 moni funcco eqeq12d simpld catcocl
        wa fthi bitr3d 3bitr3d biimpd ralrimivvva ismon2 mpbir2and ) AEKLIUEUFE
        KLHUEUFZEUBUGZUCUGZKUHLCUIUJZUEZUEZEUDUGZWMUEZUKZWJWOUKZULZUDWKKHUEZUMU
        BWTUMUCBUMRAWSUCUBUDBWTWTAWKBUFZWJWTUFZWOWTUFZUNZWAZWQWRXEEKLGUEUJZWJWK
        KGUEZUJZWKFUJZKFUJZUHLFUJZDUIUJZUEZUEZXFWOXGUJZXMUEZUKZXHXOUKWQWRXEDUSU
        JZDXLXFXHDUOUJZXOJXJXKXIXRUPZXSUPZXLUPZTADUQUFZXDACUQUFZYCAFGUHZCDURUEZ
        UFZYDYCWAAFGYFUTZYGAFGCDVAUEZUTZYHOYIYFFGCDVBVCVDZFGYFVEVFCDYEVGVDZVHVI
        XEBXRKFXEBXRCDFGMXTAYHXDYKVIZVJZAKBUFXDPVIZVKXEBXRLFYNALBUFXDQVIZVKXEBX
        RWKFYNAXAXBXCVLZVKAXFXJXKJUEUFXDUAVIXEWTXIXJXSUEZWJXGXEBCDFGHXSWKKMNYAY
        MYQYOVMZAXAXBXCVNZVKXEWTYRWOXGYSAXAXBXCVOZVKVPXEWNWKLGUEZUJZWPUUBUJZUKX
        QWQXEUUCXNUUDXPXEBCWLDFGHWJEXLWKKLMNWLUPZYBYMYQYOYPYTAWIXDRVIZVQXEBCWLD
        FGHWOEXLWKKLMNUUEYBYMYQYOYPUUAUUFVQVRXEBCDWNWPFGHXSWKLMNYAAYJXDOVIZYQYP
        XEBCWLWJEHWKKLMNUUEAYDXDAYDYCYLVSZVIZYQYOYPYTUUFVTXEBCWLWOEHWKKLMNUUEUU
        IYQYOYPUUAUUFVTWBWCXEBCDWJWOFGHXSWKKMNYAUUGYQYOYTUUAWBWDWEWFAUCBCWLUBUD
        EHIKLMNUUESUUHPQWGWH $.
    $}

    ${
      fthepi.e $e |- E = ( Epi ` C ) $.
      fthepi.p $e |- P = ( Epi ` D ) $.
      fthepi.1 $e |- ( ph ->
        ( ( X G Y ) ` R ) e. ( ( F ` X ) P ( F ` Y ) ) ) $.
      $( A faithful functor reflects epimorphisms.  (Contributed by Mario
         Carneiro, 27-Jan-2017.) $)
      fthepi $p |- ( ph -> R e. ( X E Y ) ) $=
        ( coppc cfv cmon co ctpos chom oppcbas fthoppc oppchom syl6eleqr ovtpos
        eqid fveq1i syl5eqel ccat wcel cop cfunc wa wbr fthfunc ssbri syl df-br
        cfth sylib funcrcl simprd oppcmon eleqtrrd fthmon simpld eleqtrd ) AFLK
        CUBUCZUDUCZUEKLGUEABVODUBUCZFHIUFZVOUGUCZVPVQUDUCZLKBCVOVOUMZMUHVSUMACD
        VQHIVOWAVQUMZOUIQPAFKLJUELKVSUERCJVOLKNWAUJUKVPUMZVTUMZAFLKVRUEZUCZKHUC
        ZLHUCZEUEZWHWGVTUEAWFFKLIUEZUCWIFWEWJLKIULUNUAUOADEVTVQWHWGWBACUPUQZDUP
        UQZAHIURZCDUSUEZUQZWKWLUTAHIWNVAZWOAHICDVFUEZVAWPOWQWNHICDVBVCVDHIWNVEV
        GCDWMVHVDZVIWDTVJVKVLACGVPVOLKWAAWKWLWRVMWCSVJVN $.
    $}

    ${
      ffthiso.f $e |- ( ph -> F ( C Full D ) G ) $.
      ffthiso.s $e |- I = ( Iso ` C ) $.
      ffthiso.t $e |- J = ( Iso ` D ) $.
      $( A fully faithful functor reflects isomorphisms.  (Contributed by Mario
         Carneiro, 27-Jan-2017.) $)
      ffthiso $p |- ( ph -> ( R e. ( X I Y ) <->
        ( ( X G Y ) ` R ) e. ( ( F ` X ) J ( F ` Y ) ) ) ) $=
        ( vf co wcel cfv wa cfunc wbr cfth fthfunc ssbri syl simpr funciso cinv
        adantr cv wceq wrex chom eqid cful wss cbs ccat cop df-br sylib funcrcl
        simprd funcf1 ffvelrnd isohom invf ffvelrnda sseldd fulli ad3antrrr cdm
        simpld isoval eleq2d biimpa wfun invfun funfvbrb mpbid ad2antrr breqtrd
        wb simplr fthinv mpbird inviso1 ex rexlimdva mpd impbida ) AEKLIUCUDZEK
        LGUCUEZKFUEZLFUEZJUCZUDZAWSUFBCDFGIJEKLMTUAAFGCDUGUCZUHZWSAFGCDUIUCZUHZ
        XFOXGXEFGCDUJUKULZUPAKBUDZWSPUPALBUDZWSQUPAWSUMUNAXDUFZWTXAXBDUOUEZUCZU
        EZUBUQZLKGUCUEZURZUBLKHUCZUSWSXLBCDXOUBFGHDUTUEZLKMXTVAZNAFGCDVBUCUHXDS
        UPAXKXDQUPAXJXDPUPXLXBXAJUCZXBXAXTUCZXOAYBYCVCXDADVDUEZDXTJXBXAYDVAZYAU
        AACVEUDZDVEUDZAFGVFZXEUDZYFYGUFAXFYIXIFGXEVGVHCDYHVIULZVJZABYDLFABYDCDF
        GMYEXIVKZQVLZABYDKFYLPVLZVMUPAXCYBWTXNAYDDJXMXAXBYEXMVAZYKYNYMUAVNVOVPV
        QXLXRWSUBXSXLXPXSUDZUFZXRWSYQXRUFZBCEXPICUOUEZKLMYSVAZAYFXDYPXRAYFYGYJV
        TVRAXJXDYPXRPVRZAXKXDYPXRQVRZTYREXPKLYSUCUHWTXQXNUHYRWTXOXQXNXLWTXOXNUH
        ZYPXRXLWTXNVSZUDZUUCAXDUUEAXCUUDWTAYDDJXMXAXBYEYOYKYNYMUAWAWBWCXLXNWDZU
        UEUUCWJAUUFXDAYDDXMXAXBYEYOYKYNYMWEUPWTXNWFULWGWHYQXRUMWIYRBCDFGHYSXMEX
        PKLMNAXHXDYPXROVRUUAUUBAEKLHUCUDXDYPXRRVRXLYPXRWKYTYOWLWMWNWOWPWQWR $.
    $}
  $}

  ${
    $d f g x y z A $.  $d f g x y z C $.  $d f g x y z D $.  $d f g x y z ph $.
    $d f g x y z F $.  $d f g x y z G $.  $d f g x y z H $.  $d f g x y z R $.
    fthres2b.a $e |- A = ( Base ` C ) $.
    fthres2b.h $e |- H = ( Hom ` C ) $.
    fthres2b.r $e |- ( ph -> R e. ( Subcat ` D ) ) $.
    fthres2b.s $e |- ( ph -> R Fn ( S X. S ) ) $.
    fthres2b.1 $e |- ( ph -> F : A --> S ) $.
    fthres2b.2 $e |- ( ( ph /\ ( x e. A /\ y e. A ) ) ->
      ( x G y ) : Y --> ( ( F ` x ) R ( F ` y ) ) ) $.
    $( Condition for a faithful functor to also be a faithful functor into the
       restriction.  (Contributed by Mario Carneiro, 27-Jan-2017.) $)
    fthres2b $p |- ( ph ->
      ( F ( C Faith D ) G <-> F ( C Faith ( D |`cat R ) ) G ) ) $=
      ( co wbr cfunc cv ccnv wfun wral wa cresc funcres2b anbi1d isfth 3bitr4g
      cfth ) AIJEFUASTZBUBCUBJSUCUDCDUEBDUEZUFIJEFGUGSZUASTZUNUFIJEFULSTIJEUOUL
      STAUMUPUNABCDEFGHIJKLMNOPQRUHUIBCDEFIJMUJBCDEUOIJMUJUK $.
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y D $.  $d x y E $.  $d x y F $.
    $d x y G $.
    fthres2c.a $e |- A = ( Base ` C ) $.
    fthres2c.e $e |- E = ( D |`s S ) $.
    fthres2c.d $e |- ( ph -> D e. Cat ) $.
    fthres2c.r $e |- ( ph -> S e. V ) $.
    fthres2c.1 $e |- ( ph -> F : A --> S ) $.
    $( Condition for a faithful functor to also be a faithful functor into the
       restriction.  (Contributed by Mario Carneiro, 30-Jan-2017.) $)
    fthres2c $p |- ( ph -> ( F ( C Faith D ) G <-> F ( C Faith E ) G ) ) $=
      ( vx vy cfunc co wbr cv ccnv wfun wral wa funcres2c anbi1d isfth 3bitr4g
      cfth ) AGHCDQRSZOTPTHRUAUBPBUCOBUCZUDGHCFQRSZUKUDGHCDUIRSGHCFUIRSAUJULUKA
      BCDEFGHIJKLMNUEUFOPBCDGHJUGOPBCFGHJUGUH $.
  $}

  ${
    $d f g x y C $.  $d f g x y D $.  $d f g x y R $.
    $( A functor into a restricted category is also a functor into the whole
       category.  (Contributed by Mario Carneiro, 27-Jan-2017.) $)
    fthres2 $p |- ( R e. ( Subcat ` D ) ->
      ( C Faith ( D |`cat R ) ) C_ ( C Faith D ) ) $=
      ( vf vg vx vy csubc cfv wcel cresc co cfth cv wbr cfunc wral isfth df-br
      wa wrel relfth a1i cop ccnv wfun cbs funcres2 anim1d eqid 3imtr4g 3imtr3g
      ssbrd relssdv ) CBHIJZDEABCKLZMLZABMLZUQUAUOAUPUBUCUODNZENZUQOZUSUTUROZUS
      UTUDZUQJVCURJUOUSUTAUPPLZOZFNGNUTLUEUFGAUGIZQFVFQZTUSUTABPLZOZVGTVAVBUOVE
      VIVGUOVDVHUSUTABCUHUMUIFGVFAUPUSUTVFUJZRFGVFABUSUTVJRUKUSUTUQSUSUTURSULUN
      $.
  $}

  ${
    $d x y C $.  $d x y I $.
    idffth.i $e |- I = ( idFunc ` C ) $.
    $( The identity functor is a fully faithful functor.  (Contributed by Mario
       Carneiro, 27-Jan-2017.) $)
    idffth $p |- ( C e. Cat -> I e. ( ( C Full C ) i^i ( C Faith C ) ) ) $=
      ( vx vy ccat wcel c1st cfv c2nd cop co wbr cv wf1o wral df-br eqid idfu1
      wa cful cfth cin cfunc wrel wceq relfunc idfucl sylancr chom cbs eqeltrrd
      1st2nd sylibr cid cres f1oi simpl simprl simprr idfu2nd oveq12d f1oeq123d
      eqidd mpbiri ralrimivva isffth2 sylanbrc sylib eqeltrd ) AFGZBBHIZBJIZKZA
      AUALAAUBLUCZVKAAUDLZUEBVPGBVNUFAAUGABCUHZBVPUMUIZVKVLVMVOMZVNVOGVKVLVMVPM
      ZDNZENZAUJIZLZWAVLIZWBVLIZWCLZWAWBVMLZOZEAUKIZPDWJPVSVKVNVPGVTVKBVNVPVRVQ
      ULVLVMVPQUNVKWIDEWJWJVKWAWJGZWBWJGZTZTZWIWDWDUOWDUPZOWDUQWNWDWDWGWDWHWOWN
      WJAWCBWAWBCWJRZVKWMURZWCRZVKWKWLUSZVKWKWLUTZVAWNWDVDWNWEWAWFWBWCWNWJABWAC
      WPWQWSSWNWJABWBCWPWQWTSVBVCVEVFDEWJAAVLVMWCWCWPWRWRVGVHVLVMVOQVIVJ $.
  $}

  ${
    $d x y C $.  $d x y E $.  $d x y F $.  $d x y G $.  $d x y ph $.
    cofull.f $e |- ( ph -> F e. ( C Full D ) ) $.
    cofull.g $e |- ( ph -> G e. ( D Full E ) ) $.
    $( The composition of two full functors is full.  (Contributed by Mario
       Carneiro, 28-Jan-2017.) $)
    cofull $p |- ( ph -> ( G o.func F ) e. ( C Full E ) ) $=
      ( vx vy co cfv wrel wcel sylancr wbr wfo 1st2ndbr eqid adantr ccofu cfunc
      c1st c2nd cop cful wceq relfunc fullfunc sseldi cofucl 1st2nd cv chom cbs
      wral wa ccom relfull funcf1 simprl ffvelrnd simprr fullfo syl2anc cofu2nd
      foco eqidd cofu1 oveq12d foeq123d ralrimivva isfull2 sylanbrc df-br sylib
      mpbird eqeltrd ) AFEUAKZVSUCLZVSUDLZUEZBDUFKZABDUBKZMZVSWDNZVSWBUGBDUHZAB
      CDEFABCUFKZBCUBKZEBCUIGUJZACDUFKZCDUBKZFCDUIHUJZUKZVSWDULOAVTWAWCPZWBWCNA
      VTWAWDPZIUMZJUMZBUNLZKZWQVTLZWRVTLZDUNLZKZWQWRWAKZQZJBUOLZUPIXGUPWOAWEWFW
      PWGWNVSWDROAXFIJXGXGAWQXGNZWRXGNZUQZUQZXFWTWQEUCLZLZFUCLZLZWRXLLZXNLZXCKZ
      XMXPFUDLZKZWQWREUDLZKZURZQZXKXMXPCUNLZKZXRXTQWTYFYBQYDXKCUOLZCDXNXSYEXCXM
      XPYGSZXCSZYESZXKWKMFWKNZXNXSWKPCDUSAYKXJHTFWKROXKXGYGWQXLXKXGYGBCXLYAXGSZ
      YHXKWIMEWINZXLYAWIPBCUHAYMXJWJTZEWIROUTZAXHXIVAZVBXKXGYGWRXLYOAXHXIVCZVBV
      DXKXGBCXLYAWSYEWQWRYLYJWSSZXKWHMEWHNZXLYAWHPBCUSAYSXJGTEWHROYPYQVDWTYFXRX
      TYBVGVEXKWTWTXDXRXEYCXKXGBCDEFWQWRYLYNAFWLNXJWMTZYPYQVFXKWTVHXKXAXOXBXQXC
      XKXGBCDEFWQYLYNYTYPVIXKXGBCDEFWRYLYNYTYQVIVJVKVQVLIJXGBDVTWAWSXCYLYIYRVMV
      NVTWAWCVOVPVR $.
  $}

  ${
    $d x y C $.  $d x y E $.  $d x y F $.  $d x y G $.  $d x y ph $.
    cofth.f $e |- ( ph -> F e. ( C Faith D ) ) $.
    cofth.g $e |- ( ph -> G e. ( D Faith E ) ) $.
    $( The composition of two faithful functors is faithful.  (Contributed by
       Mario Carneiro, 28-Jan-2017.) $)
    cofth $p |- ( ph -> ( G o.func F ) e. ( C Faith E ) ) $=
      ( vx vy co cfv wrel wcel sylancr wbr wf1 1st2ndbr eqid adantr ccofu cfunc
      c1st c2nd cop cfth wceq relfunc fthfunc sseldi cofucl 1st2nd cv chom wral
      cbs wa ccom relfth funcf1 simprl ffvelrnd simprr fthf1 f1co syl2anc eqidd
      cofu2nd cofu1 oveq12d f1eq123d mpbird isfth2 sylanbrc df-br sylib eqeltrd
      ralrimivva ) AFEUAKZVSUCLZVSUDLZUEZBDUFKZABDUBKZMZVSWDNZVSWBUGBDUHZABCDEF
      ABCUFKZBCUBKZEBCUIGUJZACDUFKZCDUBKZFCDUIHUJZUKZVSWDULOAVTWAWCPZWBWCNAVTWA
      WDPZIUMZJUMZBUNLZKZWQVTLZWRVTLZDUNLZKZWQWRWAKZQZJBUPLZUOIXGUOWOAWEWFWPWGW
      NVSWDROAXFIJXGXGAWQXGNZWRXGNZUQZUQZXFWTWQEUCLZLZFUCLZLZWRXLLZXNLZXCKZXMXP
      FUDLZKZWQWREUDLZKZURZQZXKXMXPCUNLZKZXRXTQWTYFYBQYDXKCUPLZCDXNXSYEXCXMXPYG
      SZYESZXCSZXKWKMFWKNZXNXSWKPCDUSAYKXJHTFWKROXKXGYGWQXLXKXGYGBCXLYAXGSZYHXK
      WIMEWINZXLYAWIPBCUHAYMXJWJTZEWIROUTZAXHXIVAZVBXKXGYGWRXLYOAXHXIVCZVBVDXKX
      GBCXLYAWSYEWQWRYLWSSZYIXKWHMEWHNZXLYAWHPBCUSAYSXJGTEWHROYPYQVDWTYFXRXTYBV
      EVFXKWTWTXDXRXEYCXKXGBCDEFWQWRYLYNAFWLNXJWMTZYPYQVHXKWTVGXKXAXOXBXQXCXKXG
      BCDEFWQYLYNYTYPVIXKXGBCDEFWRYLYNYTYQVIVJVKVLVRIJXGBDVTWAWSXCYLYRYJVMVNVTW
      AWCVOVPVQ $.
  $}

  ${
    coffth.f $e |- ( ph -> F e. ( ( C Full D ) i^i ( C Faith D ) ) ) $.
    coffth.g $e |- ( ph -> G e. ( ( D Full E ) i^i ( D Faith E ) ) ) $.
    $( The composition of two fully faithful functors is fully faithful.
       (Contributed by Mario Carneiro, 28-Jan-2017.) $)
    coffth $p |- ( ph ->
      ( G o.func F ) e. ( ( C Full E ) i^i ( C Faith E ) ) ) $=
      ( ccofu co cful wcel cfth cin inss1 sseldi cofull inss2 cofth elin
      sylanbrc ) AFEIJZBDKJZLUBBDMJZLUBUCUDNLABCDEFABCKJZBCMJZNZUEEUEUFOGPACDKJ
      ZCDMJZNZUHFUHUIOHPQABCDEFAUGUFEUEUFRGPAUJUIFUHUIRHPSUBUCUDTUA $.
  $}

  ${
    rescfth.d $e |- D = ( C |`cat J ) $.
    rescfth.i $e |- I = ( idFunc ` D ) $.
    $( The inclusion functor from a subcategory is a faithful functor.
       (Contributed by Mario Carneiro, 27-Jan-2017.) $)
    rescfth $p |- ( J e. ( Subcat ` C ) -> I e. ( D Faith C ) ) $=
      ( csubc cfv wcel cfth co cresc oveq2i fthres2 syl5eqss cful inss2 ccat id
      cin subccat idffth syl sseldi sseldd ) DAGHIZBBJKZBAJKZCUFUGBADLKZJKUHBUI
      BJEMBADNOUFBBPKZUGTZUGCUJUGQUFBRICUKIUFABDEUFSUABCFUBUCUDUE $.
  $}

  ${
    $d x y C $.  $d x y D $.  $d x y I $.  $d x y S $.  $d x y V $.
    ressffth.d $e |- D = ( C |`s S ) $.
    ressffth.i $e |- I = ( idFunc ` D ) $.
    $( The inclusion functor from a full subcategory is a full and faithful
       functor.  (Contributed by Mario Carneiro, 27-Jan-2017.) $)
    ressffth $p |- ( ( C e. Cat /\ S e. V ) ->
      I e. ( ( D Full C ) i^i ( D Faith C ) ) ) $=
      ( vx vy ccat wcel wa cfv co cfunc wceq chomf cvv ccomf eqid c1st c2nd cop
      cful cfth cin wrel relfunc resscat syl5eqel idfucl syl 1st2nd sylancr wbr
      cress cv chom wf1o cbs wral cxp cres cresc ressinbas adantl syl5eq fveq2d
      eqidd simpl wss inss2 fullresc simpld eqtrd simprd ovex eqeltri funcpropd
      a1i csubc fullsubc funcres2 eqsstrd sseldd eqeltrrd df-br sylibr cid f1oi
      adantr simprl simprr idfu2nd ad2antlr idfu1 oveq123d f1oeq123d ralrimivva
      resshom mpbiri isffth2 sylanbrc sylib eqeltrd ) AJKZCEKZLZDDUAMZDUBMZUCZB
      AUDNBAUENUFZXHBBONZUGDXMKZDXKPBBUHXHBJKZXNXHBACUPNZJFACEUIUJZBDGUKULZDXMU
      MUNZXHXIXJXLUOZXKXLKXHXIXJBAONZUOZHUQZIUQZBURMZNZYCXIMZYDXIMZAURMZNZYCYDX
      JNZUSZIBUTMZVAHYMVAXTXHXKYAKYBXHDXKYAXSXHXMYADXHXMBAAQMZCAUTMZUFZYPVBVCZV
      DNZONZYAXHBBBYRRXHBQMZVIXHBSMZVIXHYTAYPUPNZQMZYRQMZXHBUUBQXHBXPUUBFXGXPUU
      BPXFCYOAEYOTZVEVFVGZVHXHUUCUUDPZUUBSMZYRSMZPZXHYOAUUBYPYRYNUUEYNTZXFXGVJZ
      YPYOVKXHCYOVLVTZUUBTYRTVMZVNVOXHUUAUUHUUIXHBUUBSUUFVHXHUUGUUJUUNVPVOBRKXH
      BXPRFACUPVQVRVTZUUOUUOYRRKXHAYQVDVQVTVSXHYQAWAMKYSYAVKXHYOAYPYNUUEUUKUULU
      UMWBBAYQWCULWDXRWEWFXIXJYAWGWHXHYLHIYMYMXHYCYMKZYDYMKZLZLZYLYFYFWIYFVCZUS
      YFWJUUSYFYFYJYFYKUUTUUSYMBYEDYCYDGYMTZXHXOUURXQWKZYETZXHUUPUUQWLZXHUUPUUQ
      WMZWNUUSYFVIUUSYGYCYHYDYIYEXGYIYEPXFUURCABYIEFYITZWTWOUUSYMBDYCGUVAUVBUVD
      WPUUSYMBDYDGUVAUVBUVEWPWQWRXAWSHIYMBAXIXJYEYIUVAUVCUVFXBXCXIXJXLWGXDXE $.
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y D $.  $d x y E $.  $d x y ph $.
    $d x y F $.  $d x y G $.
    ffthres2c.a $e |- A = ( Base ` C ) $.
    ffthres2c.e $e |- E = ( D |`s S ) $.
    ffthres2c.d $e |- ( ph -> D e. Cat ) $.
    ffthres2c.r $e |- ( ph -> S e. V ) $.
    ffthres2c.1 $e |- ( ph -> F : A --> S ) $.
    $( Condition for a full functor to also be a full functor into the
       restriction.  (Contributed by Mario Carneiro, 30-Jan-2017.) $)
    fullres2c $p |- ( ph -> ( F ( C Full D ) G <-> F ( C Full E ) G ) ) $=
      ( vx vy co wbr cfv wral cfunc cv chom wceq wa cful funcres2c wcel resshom
      crn eqid syl oveqd eqeq2d 2ralbidv anbi12d isfull 3bitr4g ) AGHCDUAQRZOUB
      ZPUBZHQUJZUTGSZVAGSZDUCSZQZUDZPBTOBTZUEGHCFUAQRZVBVCVDFUCSZQZUDZPBTOBTZUE
      GHCDUFQRGHCFUFQRAUSVIVHVMABCDEFGHIJKLMNUGAVGVLOPBBAVFVKVBAVEVJVCVDAEIUHVE
      VJUDMEDFVEIKVEUKZUIULUMUNUOUPOPBCDGHVEJVNUQOPBCFGHVJJVJUKUQUR $.

    $( Condition for a fully faithful functor to also be a fully faithful
       functor into the restriction.  (Contributed by Mario Carneiro,
       27-Jan-2017.) $)
    ffthres2c $p |- ( ph -> ( F ( ( C Full D ) i^i ( C Faith D ) ) G <->
      F ( ( C Full E ) i^i ( C Faith E ) ) G ) ) $=
      ( cful co wbr cfth wa cin fullres2c fthres2c anbi12d brin 3bitr4g ) AGHCD
      OPZQZGHCDRPZQZSGHCFOPZQZGHCFRPZQZSGHUFUHTQGHUJULTQAUGUKUIUMABCDEFGHIJKLMN
      UAABCDEFGHIJKLMNUBUCGHUFUHUDGHUJULUDUE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Natural transformations and the functor category
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Nat $.
  $c FuncCat $.

  $( Extend class notation to include the collection of natural
     transformations. $)
  cnat $a class Nat $.

  $( Extend class notation to include the functor category. $)
  cfuc $a class FuncCat $.

  ${
    $d a b f g h r s t u v x y z $.  $d a h x y A $.  $d a f g r s t u x y B $.
    $d a f g h r s t u x y C $.  $d a f g h r s x y F $.  $d a f g r s t u J $.
    $d a f g h r s x y G $.  $d a f g h r s t u H $.  $d a f g h r s x y ph $.
    $d a f g h r s x y K $.  $d a f g h r s x y L $.  $d a f g r s t u .x. $.
    $d a f g h r s t u x y D $.
    $( Definition of a natural transformation between two functors.  A natural
       transformation ` A : F --> G ` is a collection of arrows
       ` A ( x ) : F ( x ) --> G ( x ) ` , such that
       ` A ( y ) o. F ( h ) = G ( h ) o. A ( x ) ` for each morphism
       ` h : x --> y ` .  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    df-nat $a |- Nat = ( t e. Cat , u e. Cat |->
      ( f e. ( t Func u ) , g e. ( t Func u ) |->
        [_ ( 1st ` f ) / r ]_ [_ ( 1st ` g ) / s ]_
          { a e. X_ x e. ( Base ` t ) ( ( r ` x ) ( Hom ` u ) ( s ` x ) ) |
        A. x e. ( Base ` t ) A. y e. ( Base ` t ) A. h e. ( x ( Hom ` t ) y )
      ( ( a ` y ) ( <. ( r ` x ) , ( r ` y ) >.
          ( comp ` u ) ( s ` y ) ) ( ( x ( 2nd ` f ) y ) ` h ) ) =
      ( ( ( x ( 2nd ` g ) y ) ` h ) ( <. ( r ` x ) , ( s ` x ) >.
          ( comp ` u ) ( s ` y ) ) ( a ` x ) ) } ) ) $.

    $( Definition of the category of functors between two fixed categories,
       with the objects being functors and the morphisms being natural
       transformations.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    df-fuc $a |- FuncCat = ( t e. Cat , u e. Cat |->
      { <. ( Base ` ndx ) , ( t Func u ) >. ,
        <. ( Hom ` ndx ) , ( t Nat u ) >. ,
        <. ( comp ` ndx ) ,
          ( v e. ( ( t Func u ) X. ( t Func u ) ) , h e. ( t Func u ) |->
            [_ ( 1st ` v ) / f ]_ [_ ( 2nd ` v ) / g ]_
          ( b e. ( g ( t Nat u ) h ) , a e. ( f ( t Nat u ) g ) |->
            ( x e. ( Base ` t ) |-> ( ( b ` x )
              ( <. ( ( 1st ` f ) ` x ) , ( ( 1st ` g ) ` x ) >. ( comp ` u )
                   ( ( 1st ` h ) ` x ) ) ( a ` x ) ) ) ) ) >. } ) $.

    $( The ` FuncCat ` operation is a well-defined function on categories.
       (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    fnfuc $p |- FuncCat Fn ( Cat X. Cat ) $=
      ( vt vu vv vh vf vg vb va vx ccat cnx cbs cfv cv cop cco c1st cmpt2 csb
      co cfunc chom cnat cxp c2nd cmpt ctp cfuc df-fuc tpex fnmpt2i ) ABJJKLMAN
      ZBNZUATZOZKUBMULUMUCTZOZKPMCDUNUNUDUNECNZQMFURUEMGHFNZDNZUPTENZUSUPTIULLM
      INZGNMVBHNMVBVAQMMVBUSQMMOVBUTQMMUMPMTTUFRSSROZUGUHICBAEFDHGUIUOUQVCUJUK
      $.

    natfval.1 $e |- N = ( C Nat D ) $.
    natfval.b $e |- B = ( Base ` C ) $.
    natfval.h $e |- H = ( Hom ` C ) $.
    natfval.j $e |- J = ( Hom ` D ) $.
    natfval.o $e |- .x. = ( comp ` D ) $.
    $( Value of the function giving natural transformations between two
       categories.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    natfval $p |- N = ( f e. ( C Func D ) , g e. ( C Func D ) |->
        [_ ( 1st ` f ) / r ]_ [_ ( 1st ` g ) / s ]_
          { a e. X_ x e. B ( ( r ` x ) J ( s ` x ) ) |
        A. x e. B A. y e. B A. h e. ( x H y )
      ( ( a ` y ) ( <. ( r ` x ) , ( r ` y ) >.
          .x. ( s ` y ) ) ( ( x ( 2nd ` f ) y ) ` h ) ) =
      ( ( ( x ( 2nd ` g ) y ) ` h ) ( <. ( r ` x ) , ( s ` x ) >.
          .x. ( s ` y ) ) ( a ` x ) ) } ) $=
      ( vt vu cnat co cfunc cv c1st cfv c2nd cop wceq wral cixp crab cmpt2 ccat
      csb wcel wa cco chom cbs oveq12 simpl fveq2d syl6eqr simpr oveqd ixpeq2dv
      ixpeq1d eqtrd raleqbidv rabeqbidv csbeq2dv mpt2eq123dv df-nat ovex mpt2ex
      eqeq12d ovmpt2a wn c0 mpt2ndm0 funcrcl con3i eq0rdv mpt2eq12 mpt20 syl6eq
      syl2anc eqtr4d pm2.61i eqtri ) LDEUCUDZGHDEUEUDZWONGUFZUGUHZMHUFZUGUHZBUF
      ZOUFZUHZIUFZAUFZWTWPUIUHUDUHZXDNUFZUHZWTXFUHUJZWTMUFZUHZFUDZUDZXCXDWTWRUI
      UHUDUHZXDXAUHZXGXDXIUHZUJZXJFUDZUDZUKZIXDWTJUDZULZBCULZACULZOACXGXOKUDZUM
      ZUNZUQZUQZUOZPDUPUREUPURUSZWNYIUKUAUBDEUPUPGHUAUFZUBUFZUEUDZYMNWQMWSXBXEX
      HXJYLUTUHZUDZUDZXMXNXPXJYNUDZUDZUKZIXDWTYKVAUHZUDZULZBYKVBUHZULZAUUCULZOA
      UUCXGXOYLVAUHZUDZUMZUNZUQZUQZUOZYIUCYKDUKZYLEUKZUSZGHYMYMUUKWOWOYHYKDYLEU
      EVCZUUPUUONWQUUJYGUUOMWSUUIYFUUOUUEYCOUUHYEUUOUUHACUUGUMYEUUOAUUCCUUGUUOU
      UCDVBUHCUUOYKDVBUUMUUNVDZVEQVFZVJUUOACUUGYDUUOUUFKXGXOUUOUUFEVAUHKUUOYLEV
      AUUMUUNVGZVESVFVHVIVKUUOUUDYBAUUCCUURUUOUUBYABUUCCUURUUOYSXSIUUAXTUUOYTJX
      DWTUUOYTDVAUHJUUOYKDVAUUQVERVFVHUUOYPXLYRXRUUOYOXKXBXEUUOYNFXHXJUUOYNEUTU
      HFUUOYLEUTUUSVETVFZVHVHUUOYQXQXMXNUUOYNFXPXJUUTVHVHVSVLVLVLVMVNVNVOABUBUA
      GHIMNOVPZGHWOWOYHDEUEVQZUVBVRVTYJWAZWNWBYIUAUBUULUCDEUPUPUVAWCUVCYIGHWBWB
      YHUOZWBUVCWOWBUKZUVEYIUVDUKUVCGWOWPWOURYJDEWPWDWEWFZUVFGHWOWOWBWBYHWGWJGH
      WBYHWHWIWKWLWM $.

    ${
      isnat.f $e |- ( ph -> F ( C Func D ) G ) $.
      isnat.g $e |- ( ph -> K ( C Func D ) L ) $.
      $( Property of being a natural transformation.  (Contributed by Mario
         Carneiro, 6-Jan-2017.) $)
      isnat $p |- ( ph -> ( A e. ( <. F , G >. N <. K , L >. ) <->
            ( A e. X_ x e. B ( ( F ` x ) J ( K ` x ) ) /\
          A. x e. B A. y e. B A. h e. ( x H y )
        ( ( A ` y ) ( <. ( F ` x ) , ( F ` y ) >.
            .x. ( K ` y ) ) ( ( x G y ) ` h ) ) =
        ( ( ( x L y ) ` h ) ( <. ( F ` x ) , ( K ` x ) >.
            .x. ( K ` y ) ) ( A ` x ) ) ) ) ) $=
        ( va vf vg vr vs cop co wcel cv cfv wceq wral cixp crab cfunc c1st c2nd
        csb cvv cmpt2 natfval a1i fvex simprl fveq2d wrel wbr relfunc brrelex12
        wa sylancr op1stg syl adantr eqtrd simplrr ad2antrr simplr fveq1d simpr
        oveq12d ixpeq2dv opeq12d eqidd ad3antrrr oveqd oveq123d eqeq12d ralbidv
        op2ndg 2ralbidv rabeqbidv csbied2 df-br sylib ovex rgenw ixpexg ovmpt2d
        ax-mp rabex eleq2d fveq1 oveq1d oveq2d elrab syl6bb ) ADJKUIZNOUIZPUJZU
        KDCULZUDULZUMZIULZBULZXNKUJZUMZXRJUMZXNJUMZUIZXNNUMZHUJZUJZXQXRXNOUJZUM
        ZXRXOUMZYAXRNUMZUIZYDHUJZUJZUNZIXRXNLUJZUOZCEUOBEUOZUDBEYAYJMUJZUPZUQZU
        KDYSUKXNDUMZXTYEUJZYHXRDUMZYLUJZUNZIYOUOZCEUOBEUOZVMAXMYTDAUEUFXKXLFGUR
        UJZUUHUGUEULZUSUMZUHUFULZUSUMZXPXQXRXNUUIUTUMZUJZUMZXRUGULZUMZXNUUPUMZU
        IZXNUHULZUMZHUJZUJZXQXRXNUUKUTUMZUJZUMZYIUUQXRUUTUMZUIZUVAHUJZUJZUNZIYO
        UOZCEUOBEUOZUDBEUUQUVGMUJZUPZUQZVAZVAZYTPVBPUEUFUUHUUHUVRVCUNABCEFGHUEU
        FILMPUHUGUDQRSTUAVDVEAUUIXKUNZUUKXLUNZVMZVMZUGUUJJUVQYTVBUUJVBUKUWBUUIU
        SVFVEUWBUUJXKUSUMZJUWBUUIXKUSAUVSUVTVGZVHAUWCJUNZUWAAJVBUKKVBUKVMZUWEAU
        UHVIZJKUUHVJZUWFFGVKZUBJKUUHVLVNZJKVBVBVOVPVQVRUWBUUPJUNZVMZUHUULNUVPYT
        VBUULVBUKUWLUUKUSVFVEUWLUULXLUSUMZNUWLUUKXLUSAUVSUVTUWKVSZVHAUWMNUNZUWA
        UWKANVBUKOVBUKVMZUWOAUWGNOUUHVJZUWPUWIUCNOUUHVLVNZNOVBVBVOVPVTVRUWLUUTN
        UNZVMZUVMYQUDUVOYSUWTBEUVNYRUWTUUQYAUVGYJMUWTXRUUPJUWBUWKUWSWAZWBZUWTXR
        UUTNUWLUWSWCZWBZWDWEUWTUVLYPBCEEUWTUVKYNIYOUWTUVCYFUVJYMUWTXPXPUUOXTUVB
        YEUWTUUSYCUVAYDHUWTUUQYAUURYBUXBUWTXNUUPJUXAWBWFUWTXNUUTNUXCWBZWDUWTXPW
        GUWTXQUUNXSUWTUUMKXRXNUWTUUMXKUTUMZKUWTUUIXKUTUWBUVSUWKUWSUWDVTVHAUXFKU
        NZUWAUWKUWSAUWFUXGUWJJKVBVBWMVPWHVRWIWBWJUWTUVFYHYIYIUVIYLUWTUVHYKUVAYD
        HUWTUUQYAUVGYJUXBUXDWFUXEWDUWTXQUVEYGUWTUVDOXRXNUWTUVDXLUTUMZOUWTUUKXLU
        TUWLUVTUWSUWNVQVHAUXHOUNZUWAUWKUWSAUWPUXIUWRNOVBVBWMVPWHVRWIWBUWTYIWGWJ
        WKWLWNWOWPWPAUWHXKUUHUKUBJKUUHWQWRAUWQXLUUHUKUCNOUUHWQWRYTVBUKAYQUDYSYR
        VBUKZBEUOYSVBUKUXJBEYAYJMWSWTBEYRVBXAXCXDVEXBXEYQUUGUDDYSXODUNZYPUUFBCE
        EUXKYNUUEIYOUXKYFUUBYMUUDUXKXPUUAXTYEXNXODXFXGUXKYIUUCYHYLXRXODXFXHWKWL
        WNXIXJ $.
    $}

    isnat2.f $e |- ( ph -> F e. ( C Func D ) ) $.
    isnat2.g $e |- ( ph -> G e. ( C Func D ) ) $.
    $( Property of being a natural transformation.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    isnat2 $p |- ( ph -> ( A e. ( F N G ) <->
          ( A e. X_ x e. B ( ( ( 1st ` F ) ` x ) J ( ( 1st ` G ) ` x ) ) /\
        A. x e. B A. y e. B A. h e. ( x H y )
      ( ( A ` y ) ( <. ( ( 1st ` F ) ` x ) , ( ( 1st ` F ) ` y ) >.
          .x. ( ( 1st ` G ) ` y ) ) ( ( x ( 2nd ` F ) y ) ` h ) ) =
      ( ( ( x ( 2nd ` G ) y ) ` h ) ( <. ( ( 1st ` F ) ` x ) ,
        ( ( 1st ` G ) ` x ) >. .x. ( ( 1st ` G ) ` y ) ) ( A ` x ) ) ) ) ) $=
      ( co wcel c1st cfv c2nd cv cixp wceq wral wa cfunc relfunc 1st2nd sylancr
      cop wrel oveq12d eleq2d wbr 1st2ndbr isnat bitrd ) ADJKNUBZUCDJUDUEZJUFUE
      ZUPZKUDUEZKUFUEZUPZNUBZUCDBEBUGZVEUEZVLVHUEZMUBUHUCCUGZDUEIUGZVLVOVFUBUEV
      MVOVEUEUPVOVHUEZHUBUBVPVLVOVIUBUEVLDUEVMVNUPVQHUBUBUIIVLVOLUBUJCEUJBEUJUK
      AVDVKDAJVGKVJNAFGULUBZUQZJVRUCZJVGUIFGUMZTJVRUNUOAVSKVRUCZKVJUIWAUAKVRUNU
      OURUSABCDEFGHIVEVFLMVHVINOPQRSAVSVTVEVFVRUTWATJVRVAUOAVSWBVHVIVRUTWAUAKVR
      VAUOVBVC $.
  $}

  ${
    $d f x y z A $.  $d f x y z F $.  $d f x y z G $.  $d f H $.  $d f x y R $.
    $d a f g h r s x y z C $.  $d f x y z K $.  $d f x y z ph $.  $d f x y X $.
    $d a f g h r s x y z D $.  $d f x y z L $.  $d f x y .x. $.  $d f x y Y $.
    $d x y B $.  $d x J $.
    natrcl.1 $e |- N = ( C Nat D ) $.
    $( The natural transformation set operation is a well-defined function.
       (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    natffn $p |- N Fn ( ( C Func D ) X. ( C Func D ) ) $=
      ( vf vg vr vs vy va vh vx co cv c1st cfv c2nd wral eqid cvv cfunc cop cco
      wceq chom cbs cixp crab csb natfval wcel rgenw ixpexg ax-mp rabex fnmpt2i
      ovex csbex ) EFABUAMZUSGENZOPZHFNZOPZINZJNZPKNZLNZVDUTQPMPVGGNZPZVDVHPUBV
      DHNZPZBUCPZMMVFVGVDVBQPMPVGVEPVIVGVJPZUBVKVLMMUDKVGVDAUEPZMRIAUFPZRLVORZJ
      LVOVIVMBUEPZMZUGZUHZUIZUICLIVOABVLEFKVNVQCHGJDVOSVNSVQSVLSUJGVAWAHVCVTVPJ
      VSVRTUKZLVORVSTUKWBLVOVIVMVQUQULLVOVRTUMUNUOURURUP $.

    $( Reverse closure for a natural transformation.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    natrcl $p |- ( A e. ( F N G ) ->
      ( F e. ( C Func D ) /\ G e. ( C Func D ) ) ) $=
      ( vf vg vr vs vy va vh vx co cv cfv wral eqid c1st c2nd cop cco wceq chom
      cfunc cbs cixp crab csb natfval elmpt2cl ) HIBCUGPZUNJHQZUARKIQZUARLQZMQZ
      RNQZOQZUQUOUBRPRUTJQZRZUQVARUCUQKQZRZCUDRZPPUSUTUQUPUBRPRUTURRVBUTVCRZUCV
      DVEPPUENUTUQBUFRZPSLBUHRZSOVHSMOVHVBVFCUFRZPUIUJUKUKDEFAOLVHBCVEHINVGVIFK
      JMGVHTVGTVITVETULUM $.

    ${
      nat1st2nd.2 $e |- ( ph -> A e. ( F N G ) ) $.
      $( Rewrite the natural transformation predicate with separated functor
         parts.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
      nat1st2nd $p |- ( ph -> A e. ( <. ( 1st ` F ) , ( 2nd ` F ) >. N
          <. ( 1st ` G ) , ( 2nd ` G ) >. ) ) $=
        ( co c1st cfv c2nd cop cfunc wrel wcel wceq 1st2nd sylancr relfunc syl
        wa natrcl simpld simprd oveq12d eleqtrd ) ABEFGJZEKLEMLNZFKLFMLNZGJIAEU
        JFUKGACDOJZPZEULQZEUJRCDUAZAUNFULQZABUIQUNUPUCIBCDEFGHUDUBZUEEULSTAUMUP
        FUKRUOAUNUPUQUFFULSTUGUH $.
    $}

    natixp.2 $e |- ( ph -> A e. ( <. F , G >. N <. K , L >. ) ) $.
    natixp.b $e |- B = ( Base ` C ) $.
    ${
      natixp.j $e |- J = ( Hom ` D ) $.
      $( A natural transformation is a function from the objects of ` C ` to
         homomorphisms from ` F ( x ) ` to ` G ( x ) ` .  (Contributed by Mario
         Carneiro, 6-Jan-2017.) $)
      natixp $p |- ( ph -> A e. X_ x e. B ( ( F ` x ) J ( K ` x ) ) ) $=
        ( cfv co wcel cop vy vz cv cixp cco wceq chom wral wa eqid cfunc natrcl
        wbr syl simpld df-br sylibr simprd isnat mpbid ) ACBDBUCZGQZVAJQZIRUDSZ
        UAUCZCQUBUCZVAVEHRQVBVEGQTVEJQZFUEQZRRVFVAVEKRQVACQVBVCTVGVHRRUFUBVAVEE
        UGQZRUHUADUHBDUHZACGHTZJKTZLRSZVDVJUINABUACDEFVHUBGHVIIJKLMOVIUJPVHUJAV
        KEFUKRZSZGHVNUMAVOVLVNSZAVMVOVPUINCEFVKVLLMULUNZUOGHVNUPUQAVPJKVNUMAVOV
        PVQURJKVNUPUQUSUTUO $.

      natcl.1 $e |- ( ph -> X e. B ) $.
      $( A component of a natural transformation is a morphism.  (Contributed
         by Mario Carneiro, 6-Jan-2017.) $)
      natcl $p |- ( ph -> ( A ` X ) e. ( ( F ` X ) J ( K ` X ) ) ) $=
        ( vx cfv wcel cv co cixp natixp wceq fveq2 oveq12d fvixp syl2anc ) ABRC
        RUAZFSZUJISZHUBZUCTLCTLBSLFSZLISZHUBZTARBCDEFGHIJKMNOPUDQRCUMLUPBUJLUEU
        KUNULUOHUJLFUFUJLIUFUGUHUI $.
    $}

    $( A natural transformation is a function on the objects of ` C ` .
       (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    natfn $p |- ( ph -> A Fn B ) $=
      ( vx cv cfv chom co cixp wcel wfn eqid natixp ixpfn syl ) ABNCNOZFPUFHPEQ
      PZRZSTBCUAANBCDEFGUGHIJKLMUGUBUCNCUHBUDUE $.

    nati.h $e |- H = ( Hom ` C ) $.
    nati.o $e |- .x. = ( comp ` D ) $.
    nati.x $e |- ( ph -> X e. B ) $.
    nati.y $e |- ( ph -> Y e. B ) $.
    nati.r $e |- ( ph -> R e. ( X H Y ) ) $.
    $( Naturality property of a natural transformation.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    nati $p |- ( ph ->
        ( ( A ` Y ) ( <. ( F ` X ) , ( F ` Y ) >.
            .x. ( K ` Y ) ) ( ( X G Y ) ` R ) ) =
        ( ( ( X L Y ) ` R ) ( <. ( F ` X ) , ( K ` X ) >.
            .x. ( K ` Y ) ) ( A ` X ) ) ) $=
      ( vy vf vx cv cfv co cop wceq wral chom cixp wcel wa cfunc wbr natrcl syl
      eqid simpld df-br sylibr simprd isnat mpbid adantr ad2antrr simpr oveq12d
      simplr eleqtrrd simpllr fveq2d opeq12d fveq12d oveq123d eqeq12d rspcimdv
      rspcdv mpd ) AUDUGZBUHZUEUGZUFUGZWCIUIZUHZWFHUHZWCHUHZUJZWCKUHZGUIZUIZWEW
      FWCLUIZUHZWFBUHZWIWFKUHZUJZWLGUIZUIZUKZUEWFWCJUIZULZUDCULZUFCULZOBUHZFNOI
      UIZUHZNHUHZOHUHZUJZOKUHZGUIZUIZFNOLUIZUHZNBUHZXJNKUHZUJZXMGUIZUIZUKZABUFC
      WIWREUMUHZUIUNUOZXFABHIUJZKLUJZMUIUOZYEXFUPQAUFUDBCDEGUEHIJYDKLMPRSYDVATA
      YFDEUQUIZUOZHIYIURAYJYGYIUOZAYHYJYKUPQBDEYFYGMPUSUTZVBHIYIVCVDAYKKLYIURAY
      JYKYLVEKLYIVCVDVFVGVEAXEYCUFNCUAAWFNUKZUPZXDYCUDOCAOCUOYMUBVHYNWCOUKZUPZX
      BYCUEFXCYPFNOJUIZXCAFYQUOYMYOUCVIYPWFNWCOJAYMYOVLYNYOVJVKVMYPWEFUKZUPZWNX
      OXAYBYSWDXGWHXIWMXNYSWKXLWLXMGYSWIXJWJXKYSWFNHAYMYOYRVNZVOZYSWCOHYNYOYRVL
      ZVOVPYSWCOKUUBVOZVKYSWCOBUUBVOYSWEFWGXHYSWFNWCOIYTUUBVKYPYRVJZVQVRYSWPXQW
      QXRWTYAYSWSXTWLXMGYSWIXJWRXSUUAYSWFNKYTVOVPUUCVKYSWEFWOXPYSWFNWCOLYTUUBVK
      UUDVQYSWFNBYTVOVRVSWAVTVTWB $.
  $}

  ${
    $d a f g r s x y z C $.  $d a f g r s x y z D $.
    wunnat.1 $e |- ( ph -> U e. WUni ) $.
    wunnat.2 $e |- ( ph -> C e. U ) $.
    wunnat.3 $e |- ( ph -> D e. U ) $.
    $( A weak universe is closed under the natural transformation operation.
       (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    wunnat $p |- ( ph -> ( C Nat D ) e. U ) $=
      ( vr vf vs vg va vx co cfv cv wral wcel cvv eqid vy vz cfunc cxp chom crn
      cuni cbs cmap cpw cnat wunfunc wunxp c1 c4 cdc df-hom wunstr wunrn wununi
      df-base wunmap wunpw wf c1st c2nd cop cco wceq cixp crab fvex wsbc ssrab2
      csb wss ovssunirn rgenw ss2ixp ax-mp rnex uniex ixpconst sstri ovex elpw2
      sseqtri mpbir sbcth sbcel1g mpbid rgen2w natfval fmpt2 mpbi a1i wunf ) AB
      CUCNZWRUDZCUEOZUFZUGZBUHOZUINZUJZDBCUKNZEAWRWRDEABCDEFGULZXGUMAXDDEAXBXCD
      EAXADEAWTDEACDUEUNUOUPUQEGURUSUTABDUHUNVAEFURVBVCWSXEXFVDZAHIPZVEOZJKPZVE
      OZUAPZLPZOUBPZMPZXMXIVFONOXPHPZOZXMXQOVGXMJPZOZCVHOZNNXOXPXMXKVFONOXPXNOX
      RXPXSOZVGXTYANNVIUBXPXMBUEOZNQUAXCQMXCQZLMXCXRYBWTNZVJZVKZVOZVOZXERZKWRQI
      WRQXHYJIKWRWRXJSRZYJXIVEVLYKYHXERZHXJVMYJYLHXJSXLSRZYLXKVEVLYMYGXERZJXLVM
      YLYNJXLSYNYGXDVPYGYFXDYDLYFVNYFMXCXBVJZXDYEXBVPZMXCQYFYOVPYPMXCWTXRYBVQVR
      MXCYEXBVSVTMXCXBBUHVLXAWTCUEVLWAWBWCWGWDYGXDXBXCUIWEWFWHWIJXLYGXESWJWKVTW
      IHXJYHXESWJWKVTWLIKWRWRYIXEXFMUAXCBCYAIKUBYCWTXFJHLXFTXCTYCTWTTYATWMWNWOW
      PWQ $.
  $}

  $( A category structure is a structure.  (Contributed by Mario Carneiro,
     3-Jan-2017.) $)
  catstr $p |- { <. ( Base ` ndx ) , U >. ,
                 <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .x. >. }
                Struct <. 1 , ; 1 5 >. $=
    ( cnx cbs cfv chom cco c1 c4 cdc 1nn basendx 4nn0 1nn0 1lt10 declti decnncl
    c5 5nn 4nn homndx 4lt5 declt ccondx strle3 ) DEFDGFDHFIIJKISKBCALMIJILNOPQI
    JOUARUBIJSONTUCUDISOTRUEUF $.

  ${
    $d h t u v B $.  $d t u N $.  $d a b f g h t u v x ph $.  $d t u .xb $.
    $d a b f g h t u v x C $.  $d a b f g h t u v x D $.
    fucval.q $e |- Q = ( C FuncCat D ) $.
    fucval.b $e |- B = ( C Func D ) $.
    fucval.n $e |- N = ( C Nat D ) $.
    fucval.a $e |- A = ( Base ` C ) $.
    fucval.o $e |- .x. = ( comp ` D ) $.
    fucval.c $e |- ( ph -> C e. Cat ) $.
    fucval.d $e |- ( ph -> D e. Cat ) $.
    ${
      fucval.x $e |- ( ph -> .xb = ( v e. ( B X. B ) , h e. B |->
              [_ ( 1st ` v ) / f ]_ [_ ( 2nd ` v ) / g ]_
            ( b e. ( g N h ) , a e. ( f N g ) |->
              ( x e. A |-> ( ( b ` x )
                ( <. ( ( 1st ` f ) ` x ) , ( ( 1st ` g ) ` x ) >. .x.
                     ( ( 1st ` h ) ` x ) ) ( a ` x ) ) ) ) ) ) $.
      $( Value of the functor category.  (Contributed by Mario Carneiro,
         6-Jan-2017.) $)
      fucval $p |- ( ph -> Q = { <. ( Base ` ndx ) , B >. ,
        <. ( Hom ` ndx ) , N >. , <. ( comp ` ndx ) , .xb >. } ) $=
        ( vt vu cfuc co cnx cbs cfv cop chom cco ctp ccat cv cnat cxp c1st c2nd
        cfunc cmpt csb cvv wceq df-fuc a1i simprl simprr oveq12d syl6eqr opeq2d
        cmpt2 xpeq12d oveqd fveq2d mpteq12dv mpt2eq123dv csbeq2dv adantr eqtr4d
        wa tpeq123d wcel tpex ovmpt2d syl5eq ) AHFGUGUHUIUJUKZEULZUIUMUKZNULZUI
        UNUKZIULZUOZQAUEUFFGUPUPWIUEUQZUFUQZVBUHZULZWKWPWQURUHZULZWMCMWRWRUSZWR
        KCUQZUTUKZLXCVAUKZPOLUQZMUQZWTUHZKUQZXFWTUHZBWPUJUKZBUQZPUQUKZXLOUQUKZX
        LXIUTUKUKXLXFUTUKUKULZXLXGUTUKUKZWQUNUKZUHZUHZVCZVNZVDZVDZVNZULZUOZWOUG
        VEUGUEUFUPUPYFVNVFABCUFUEKLMOPVGVHAWPFVFZWQGVFZWCZWCZWSWJXAWLYEWNYJWREW
        IYJWRFGVBUHEYJWPFWQGVBAYGYHVIZAYGYHVJZVKRVLZVMYJWTNWKYJWTFGURUHNYJWPFWQ
        GURYKYLVKSVLZVMYJYDIWMYJYDCMEEUSZEKXDLXEPOXFXGNUHZXIXFNUHZBDXMXNXOXPJUH
        ZUHZVCZVNZVDZVDZVNZIYJCMXBWRYCYOEUUCYJWREWREYMYMVOYMYJKXDYBUUBYJLXEYAUU
        AYJPOXHXJXTYPYQYTYJWTNXFXGYNVPYJWTNXIXFYNVPYJBXKXSDYSYJXKFUJUKDYJWPFUJY
        KVQTVLYJXRYRXMXNYJXQJXOXPYJXQGUNUKJYJWQGUNYLVQUAVLVPVPVRVSVTVTVSAIUUDVF
        YIUDWAWBVMWDUBUCWOVEWEAWJWLWNWFVHWGWH $.
    $}

    fuccofval.x $e |- .xb = ( comp ` Q ) $.
    $( Value of the functor category.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    fuccofval $p |- ( ph -> .xb = ( v e. ( B X. B ) , h e. B |->
            [_ ( 1st ` v ) / f ]_ [_ ( 2nd ` v ) / g ]_
          ( b e. ( g N h ) , a e. ( f N g ) |->
            ( x e. A |-> ( ( b ` x )
              ( <. ( ( 1st ` f ) ` x ) , ( ( 1st ` g ) ` x ) >. .x.
                   ( ( 1st ` h ) ` x ) ) ( a ` x ) ) ) ) ) ) $=
      ( cco cfv cnx cbs cop chom cxp cv c1st c2nd co cmpt2 csb ctp eqidd fucval
      cmpt fveq2d cvv wcel wceq cfunc ovex eqeltri xpex mpt2ex c1 c5 cdc catstr
      ccoid snsstp3 strfv ax-mp 3eqtr4g ) AHUEUFUGUHUFEUIZUGUJUFNUIZUGUEUFCMEEU
      KZEKCULZUMUFLWCUNUFPOLULZMULZNUOKULZWDNUOBDBULZPULUFWGOULUFWGWFUMUFUFWGWD
      UMUFUFUIWGWEUMUFUFJUOUOVAUPUQUQZUPZUIZURZUEUFZIWIAHWKUEABCDEFGHWIJKLMNOPQ
      RSTUAUBUCAWIUSUTVBUDWIVCVDWIWLVECMWBEWHEEEFGVFUOVCRFGVFVGVHZWMVIWMVJWIWKU
      EVCVKVKVLVMUIWIENVNVOVTWAWJVPVQVRVS $.
  $}

  ${
    $d a b f g h v x C $.  $d a b f g h v x D $.  $d a b f g h v x ph $.
    fucbas.q $e |- Q = ( C FuncCat D ) $.
    $( The objects of the functor category are functors from ` C ` to ` D ` .
       (Contributed by Mario Carneiro, 6-Jan-2017.)  (Revised by Mario
       Carneiro, 12-Jan-2017.) $)
    fucbas $p |- ( C Func D ) = ( Base ` Q ) $=
      ( vx vv vf vg vh ccat wcel co cbs cfv cnx cop cco eqid c0 cfuc va vb wceq
      wa cfunc chom cnat ctp cvv c1 c5 cdc simpl fuccofval fucval catstr baseid
      simpr snsstp1 ovex a1i strfv3 eqcomd wn base0 cv funcrcl con3i eq0rdv cxp
      wfn cdm fnfuc fndm ax-mp ndmov syl5eq fveq2d 3eqtr4a pm2.61i ) AJKZBJKZUD
      ZABUELZCMNZUCWCWEWDWCWEWDOMNWDPZOUFNABUGLZPZOQNCQNZPZUHCMUIUJUJUKULPWCEFA
      MNZWDABCWIBQNZGHIWGUAUBDWDRZWGRZWKRZWLRZWAWBUMZWAWBURZWCEFWKWDABCWIWLGHIW
      GUAUBDWMWNWOWPWQWRWIRUNUOWIWDWGUPUQWFWHWJUSWDUIKWCABUEUTVAWERVBVCWCVDZSSM
      NWDWEVEWSGWDGVFZWDKWCABWTVGVHVIWSCSMWSCABTLSDABJTTJJVJZVKTVLXAUCVMXATVNVO
      VPVQVRVSVT $.

    fuchom.n $e |- N = ( C Nat D ) $.
    $( The morphisms in the functor category are natural transformations.
       (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    fuchom $p |- N = ( Hom ` Q ) $=
      ( vf ccat wcel chom cfv wceq cnx co cop cco cvv eqid c0 cfuc vx vv vg cbs
      vh va vb wa cfunc ctp c1 c5 cdc simpl simpr fuccofval fucval catstr homid
      snsstp2 cnat ovex eqeltri a1i strfv3 eqcomd wn df-hom str0 wfn cxp natffn
      c4 cv funcrcl con3i eq0rdv xpeq2d xp0 syl6eq fneq2d mpbii fn0 sylib fnfuc
      cdm fndm ax-mp ndmov syl5eq fveq2d 3eqtr4a pm2.61i ) AHIZBHIZUHZDCJKZLWPW
      QDWPWQDMUDKABUINZOZMJKDOZMPKCPKZOZUJCJQUKUKULUMOWPUAUBAUDKZWRABCXABPKZGUC
      UEDUFUGEWRRZFXCRZXDRZWNWOUNZWNWOUOZWPUAUBXCWRABCXAXDGUCUEDUFUGEXEFXFXGXHX
      IXARUPUQXAWRDURUSWSWTXBUTDQIWPDABVANQFABVAVBVCVDWQRVEVFWPVGZSSJKDWQJUKVMU
      MVHVIXJDSVJZDSLXJDWRWRVKZVJXKABDFVLXJXLSDXJXLWRSVKSXJWRSWRXJGWRGVNZWRIWPA
      BXMVOVPVQVRWRVSVTWAWBDWCWDXJCSJXJCABTNSEABHTTHHVKZVJTWFXNLWEXNTWGWHWIWJWK
      WLWM $.
  $}

  ${
    $d a b f g h v x A $.  $d a b f g h v x ph $.  $d a b x R $.  $d a b x S $.
    $d a b f g h v x C $.  $d a b f g h v x D $.  $d a b f g h v x .x. $.
    $d a b f g h v x F $.  $d a b f g h v x G $.  $d a b f g h v x H $.
    $d a b f g h v N $.  $d x X $.
    fucco.q $e |- Q = ( C FuncCat D ) $.
    fucco.n $e |- N = ( C Nat D ) $.
    fucco.a $e |- A = ( Base ` C ) $.
    fucco.o $e |- .x. = ( comp ` D ) $.
    fucco.x $e |- .xb = ( comp ` Q ) $.
    fucco.f $e |- ( ph -> R e. ( F N G ) ) $.
    fucco.g $e |- ( ph -> S e. ( G N H ) ) $.
    $( Value of the composition of natural transformations.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    fucco $p |- ( ph -> ( S ( <. F , G >. .xb H ) R ) = ( x e. A |->
      ( ( S ` x ) ( <. ( ( 1st ` F ) ` x ) , ( ( 1st ` G ) ` x ) >. .x.
        ( ( 1st ` H ) ` x ) ) ( R ` x ) ) ) ) $=
      ( vb va vv vh vf vg co cv cfv c1st cop cmpt cvv cfunc cxp c2nd cmpt2 eqid
      csb ccat wcel wa natrcl syl simpld funcrcl simprd fuccofval wceq fvex a1i
      simprl fveq2d op1stg adantr op2ndg ad2antrr simprr oveq12d simplr opeq12d
      eqtrd simpr fveq1d oveqd mpteq2dv mpt2eq123dv csbied2 opelxpi ovex mpt2ex
      ovmpt2d cbs eqeltri mptex ) AUBUCHGLMNUHZKLNUHZBCBUIZUBUIZUJZWSUCUIZUJZWS
      KUKUJZUJZWSLUKUJZUJZULZWSMUKUJZUJZJUHZUHZUMZBCWSHUJZWSGUJZXKUHZUMZKLULZMI
      UHUNAUDUEXRMDEUOUHZXSUPZXSUFUDUIZUKUJZUGYAUQUJZUBUCUGUIZUEUIZNUHZUFUIZYDN
      UHZBCXAXCWSYGUKUJZUJZWSYDUKUJZUJZULZWSYEUKUJZUJZJUHZUHZUMZURZUTZUTUBUCWQW
      RXMURZIUNABUDCXSDEFIJUFUGUENUCUBOXSUSPQRADVAVBZEVAVBZAKXSVBZUUBUUCVCAUUDL
      XSVBZAGWRVBUUDUUEVCZTGDEKLNPVDVEZVFDEKVGVEZVFAUUBUUCUUHVHSVIAYAXRVJZYEMVJ
      ZVCZVCZUFYBKYTUUAUNYBUNVBUULYAUKVKVLUULYBXRUKUJZKUULYAXRUKAUUIUUJVMZVNAUU
      MKVJZUUKAUUFUUOUUGKLXSXSVOVEVPWCUULYGKVJZVCZUGYCLYSUUAUNYCUNVBUUQYAUQVKVL
      UUQYCXRUQUJZLUUQYAXRUQUULUUIUUPUUNVPVNAUURLVJZUUKUUPAUUFUUSUUGKLXSXSVQVEV
      RWCUUQYDLVJZVCZUBUCYFYHYRWQWRXMUVAYDLYEMNUUQUUTWDZUULUUJUUPUUTAUUIUUJVSVR
      ZVTUVAYGKYDLNUULUUPUUTWAZUVBVTUVABCYQXLUVAYPXKXAXCUVAYMXHYOXJJUVAYJXEYLXG
      UVAWSYIXDUVAYGKUKUVDVNWEUVAWSYKXFUVAYDLUKUVBVNWEWBUVAWSYNXIUVAYEMUKUVCVNW
      EVTWFWGWHWIWIAUUFXRXTVBUUGKLXSXSWJVEAUUEMXSVBZAHWQVBUUEUVEVCUAHDELMNPVDVE
      VHUUAUNVBAUBUCWQWRXMLMNWKKLNWKWLVLWMAWTHVJZXBGVJZVCVCZBCXLXPUVHXAXNXCXOXK
      UVHWSWTHAUVFUVGVMWEUVHWSXBGAUVFUVGVSWEVTWGUATXQUNVBABCXPCDWNUJUNQDWNVKWOW
      PVLWM $.

    fuccoval.f $e |- ( ph -> X e. A ) $.
    $( Value of the functor category.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    fuccoval $p |- ( ph -> ( ( S ( <. F , G >. .xb H ) R ) ` X ) =
      ( ( S ` X ) ( <. ( ( 1st ` F ) ` X ) , ( ( 1st ` G ) ` X ) >. .x.
        ( ( 1st ` H ) ` X ) ) ( R ` X ) ) ) $=
      ( vx cv cfv c1st cop co cvv fucco wceq wa fveq2d opeq12d oveq12d oveq123d
      simpr wcel ovex a1i fvmptd ) AUCNUCUDZGUEZVBFUEZVBJUFUEZUEZVBKUFUEZUEZUGZ
      VBLUFUEZUEZIUHZUHNGUEZNFUEZNVEUEZNVGUEZUGZNVJUEZIUHZUHZBGFJKUGLHUHUHUIAUC
      BCDEFGHIJKLMOPQRSTUAUJAVBNUKZULZVCVMVDVNVLVSWBVIVQVKVRIWBVFVOVHVPWBVBNVEA
      WAUQZUMWBVBNVGWCUMUNWBVBNVJWCUMUOWBVBNGWCUMWBVBNFWCUMUPUBVTUIURAVMVNVSUSU
      TVA $.
  $}

  ${
    $d f x y C $.  $d f x y D $.  $d f x y F $.  $d f x y G $.  $d f x y .xb $.
    $d f x y H $.  $d f x y ph $.  $d f x y R $.  $d f x y S $.
    fuccocl.q $e |- Q = ( C FuncCat D ) $.
    fuccocl.n $e |- N = ( C Nat D ) $.
    fuccocl.x $e |- .xb = ( comp ` Q ) $.
    fuccocl.r $e |- ( ph -> R e. ( F N G ) ) $.
    fuccocl.s $e |- ( ph -> S e. ( G N H ) ) $.
    $( The composition of two natural transformations is a natural
       transformation.  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    fuccocl $p |- ( ph -> ( S ( <. F , G >. .xb H ) R ) e. ( F N H ) ) $=
      ( co wcel cfv adantr vx vy cop cbs c1st chom cixp c2nd cco wceq wral cmpt
      vf cv eqid fucco ccat cfunc natrcl syl simpld funcrcl simprd wrel relfunc
      wa wbr 1st2ndbr sylancr ffvelrnda nat1st2nd simpr natcl catcocl ralrimiva
      funcf1 cvv fvex mptelixpg ax-mp sylibr eqeltrd w3a simpr1 ffvelrnd simpr2
      wb wf funcf2 simpr3 catass nati oveq2d oveq1d 3eqtrd fuccoval ralrimivvva
      3eqtr2d 3eqtr4d isnat2 mpbir2and ) AFEHIUCJGQQZHJKQRXBUABUDSZUAUNZHUESZSZ
      XDJUESZSZCUFSZQZUGZRUBUNZXBSZUMUNZXDXLHUHSZQZSZXFXLXESZUCZXLXGSZCUISZQZQZ
      XNXDXLJUHSZQZSZXDXBSZXFXHUCXTYAQZQZUJZUMXDXLBUFSZQZUKUBXCUKUAXCUKAXBUAXCX
      DFSZXDESZXFXDIUESZSZUCZXHYAQQZULZXKAUAXCBCDEFGYAHIJKLMXCUOZYAUOZNOPUPAYRX
      JRZUAXCUKZYSXKRZAUUBUAXCAXDXCRZVFZCUDSZCYAYNYMXIXFYPXHUUGUOZXIUOZUUAACUQR
      ZUUEABUQRZUUJAHBCURQZRZUUKUUJVFAUUMIUULRZAEHIKQRZUUMUUNVFOEBCHIKMUSUTVAZB
      CHVBUTVCZTAXCUUGXDXEAXCUUGBCXEXOYTUUHAUULVDZUUMXEXOUULVGZBCVEZUUPHUULVHVI
      ZVPZVJAXCUUGXDYOAXCUUGBCYOIUHSZYTUUHAUURUUNYOUVCUULVGZUUTAUUNJUULRZAFIJKQ
      RZUUNUVEVFPFBCIJKMUSUTZVAIUULVHVIZVPZVJAXCUUGXDXGAXCUUGBCXGYDYTUUHAUURUVE
      XGYDUULVGZUUTAUUNUVEUVGVCZJUULVHVIZVPZVJUUFEXCBCXEXOXIYOUVCKXDMAEXEXOUCYO
      UVCUCZKQRZUUEAEBCHIKMOVKZTYTUUIAUUEVLZVMUUFFXCBCYOUVCXIXGYDKXDMAFUVNXGYDU
      CKQRZUUEAFBCIJKMPVKZTYTUUIUVQVMVNVOXCVQRUUDUUCWGBUDVRUAXCYRXJVQVSVTWAWBAY
      JUAUBUMXCXCYLAUUEXLXCRZXNYLRZWCZVFZXLFSZXLESZXRXLYOSZUCXTYAQQZXQYBQZYFYRY
      HQZYCYIUWCUWHUWDUWEXQXSUWFYAQQZXFUWFUCXTYAQZQZYFYMYPXHUCXTYAQQZYNYQXTYAQZ
      QZUWIUWCUUGCYAXQUWEXIUWDXTXFXRUWFUUHUUIUUAAUUJUWBUUQTZUWCXCUUGXDXEAXCUUGX
      EWHUWBUVBTZAUUEUVTUWAWDZWEZUWCXCUUGXLXEUWQAUUEUVTUWAWFZWEUWCXCUUGXLYOAXCU
      UGYOWHUWBUVITZUWTWEZUWCYLXFXRXIQXNXPUWCXCBCXEXOYKXIXDXLYTYKUOZUUIAUUSUWBU
      VATUWRUWTWIAUUEUVTUWAWJZWEUWCEXCBCXEXOXIYOUVCKXLMAUVOUWBUVPTZYTUUIUWTVMUW
      CXCUUGXLXGAXCUUGXGWHUWBUVMTZUWTWEZUWCFXCBCYOUVCXIXGYDKXLMAUVRUWBUVSTZYTUU
      IUWTVMZWKUWCUWLUWDXNXDXLUVCQZSZYNYQUWFYAQQZUWKQUWDUXKYPUWFUCXTYAQQZYNUWNQ
      UWOUWCUWJUXLUWDUWKUWCEXCBCXNYAXEXOYKYOUVCKXDXLMUXEYTUXCUUAUWRUWTUXDWLWMUW
      CUUGCYAYNUXKXIUWDXTXFYPUWFUUHUUIUUAUWPUWSUWCXCUUGXDYOUXAUWRWEZUXBUWCEXCBC
      XEXOXIYOUVCKXDMUXEYTUUIUWRVMZUWCYLYPUWFXIQXNUXJUWCXCBCYOUVCYKXIXDXLYTUXCU
      UIAUVDUWBUVHTUWRUWTWIUXDWEUXGUXIWKUWCUXMUWMYNUWNUWCFXCBCXNYAYOUVCYKXGYDKX
      DXLMUXHYTUXCUUAUWRUWTUXDWLWNWRUWCUUGCYAYNYMXIYFXTXFYPXHUUHUUIUUAUWPUWSUXN
      UWCXCUUGXDXGUXFUWRWEUXOUWCFXCBCYOUVCXIXGYDKXDMUXHYTUUIUWRVMUXGUWCYLXHXTXI
      QXNYEUWCXCBCXGYDYKXIXDXLYTUXCUUIAUVJUWBUVLTUWRUWTWIUXDWEWKWOUWCXMUWGXQYBU
      WCXCBCDEFGYAHIJKXLLMYTUUANAUUOUWBOTZAUVFUWBPTZUWTWPWNUWCYGYRYFYHUWCXCBCDE
      FGYAHIJKXDLMYTUUANUXPUXQUWRWPWMWSWQAUAUBXBXCBCYAUMHJYKXIKMYTUXCUUIUUAUUPU
      VKWTXA $.
  $}

  ${
    $d f x y .1. $.  $d f x y C $.  $d f x y D $.  $d f x y ph $.
    $d f x y F $.
    fucidcl.q $e |- Q = ( C FuncCat D ) $.
    fucidcl.n $e |- N = ( C Nat D ) $.
    fucidcl.x $e |- .1. = ( Id ` D ) $.
    fucidcl.f $e |- ( ph -> F e. ( C Func D ) ) $.
    $( The identity natural transformation.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    fucidcl $p |- ( ph -> ( .1. o. ( 1st ` F ) ) e. ( F N F ) ) $=
      ( vx vy vf cfv co wcel wceq wral eqid c1st ccom cbs cv chom cixp c2nd cop
      cco cmpt cvv wf wfn ccat cfunc wa funcrcl syl simprd cidfn dffn2 wrel wbr
      relfunc 1st2ndbr sylancr funcf1 fcompt syl2anc adantr ffvelrnda ralrimiva
      sylib catidcl wb fvex mptelixpg ax-mp sylibr eqeltrd simpr1 syldan simpr2
      w3a ffvelrnd funcf2 simpr3 catlid catrid eqtr4d oveq1d oveq2d ralrimivvva
      fvco3 3eqtr4d isnat2 mpbir2and ) AEFUAOZUBZFFGPQWSLBUCOZLUDZWROZXBCUEOZPZ
      UFZQMUDZWSOZNUDZXAXFFUGOZPZOZXBXFWROZUHXLCUIOZPZPZXKXAWSOZXBXBUHXLXMPZPZR
      ZNXAXFBUEOZPZSMWTSLWTSAWSLWTXBEOZUJZXEACUCOZUKEULZWTYDWRULZWSYCRAEYDUMZYE
      ACUNQZYGABUNQZYHAFBCUOPZQZYIYHUPKBCFUQURUSZYDCEYDTZJUTURYDEVAVMAWTYDBCWRX
      IWTTZYMAYJVBYKWRXIYJVCZBCVDKFYJVEVFZVGZLEWRWTYDUKVHVIAYBXDQZLWTSZYCXEQZAY
      RLWTAXAWTQZUPYDCEXCXBYMXCTZJAYHUUAYLVJAWTYDXAWRYQVKZVNVLWTUKQYTYSVOBUCVPL
      WTYBXDUKVQVRVSVTAXSLMNWTWTYAAUUAXFWTQZXHYAQZWDZUPZXLEOZXKXNPZXKYBXQPZXOXR
      UUGUUIXKUUJUUGYDCXMEXKXCXBXLYMUUBJAYHUUFYLVJZAUUFUUAXBYDQAUUAUUDUUEWAZUUC
      WBZXMTZUUGWTYDXFWRAYFUUFYQVJZAUUAUUDUUEWCZWEZUUGYAXBXLXCPXHXJUUGWTBCWRXIX
      TXCXAXFYNXTTZUUBAYOUUFYPVJUULUUPWFAUUAUUDUUEWGWEZWHUUGYDCXMEXKXCXBXLYMUUB
      JUUKUUMUUNUUQUUSWIWJUUGXGUUHXKXNUUGYFUUDXGUUHRUUOUUPWTYDXFEWRWNVIWKUUGXPY
      BXKXQUUGYFUUAXPYBRUUOUULWTYDXAEWRWNVIWLWOWMALMWSWTBCXMNFFXTXCGIYNUURUUBUU
      NKKWPWQ $.
  $}

  ${
    $d x .1. $.  $d x C $.  $d x D $.  $d x F $.  $d x G $.  $d x ph $.
    $d x R $.
    fuclid.q $e |- Q = ( C FuncCat D ) $.
    fuclid.n $e |- N = ( C Nat D ) $.
    fuclid.x $e |- .xb = ( comp ` Q ) $.
    fuclid.1 $e |- .1. = ( Id ` D ) $.
    fuclid.r $e |- ( ph -> R e. ( F N G ) ) $.
    $( Left identity of natural transformations.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    fuclid $p |- ( ph ->
      ( ( .1. o. ( 1st ` G ) ) ( <. F , G >. .xb G ) R ) = R ) $=
      ( vx cfv cop co wcel cbs cv c1st ccom cco cmpt wa wf wceq c2nd eqid cfunc
      wrel wbr relfunc natrcl simprd 1st2ndbr sylancr funcf1 fvco3 sylan oveq1d
      syl chom ccat simpld funcrcl adantr ffvelrnda nat1st2nd simpr natcl eqtrd
      catlid mpteq2dva fucidcl fucco wfn natfn dffn5 sylib 3eqtr4d ) APBUAQZPUB
      ZGIUCQZUDZQZWEEQZWEHUCQZQZWEWFQZRWLCUEQZSZSZUFPWDWIUFZWGEHIRIFSSEAPWDWOWI
      AWEWDTZUGZWOWLGQZWIWNSWIWRWHWSWIWNAWDCUAQZWFUHWQWHWSUIAWDWTBCWFIUJQZWDUKZ
      WTUKZABCULSZUMZIXDTZWFXAXDUNBCUOZAHXDTZXFAEHIJSTXHXFUGOEBCHIJLUPVDZUQZIXD
      URUSUTZWDWTWEGWFVAVBVCWRWTCWMGWICVEQZWKWLXCXLUKZNACVFTZWQABVFTZXNAXHXOXNU
      GAXHXFXIVGZBCHVHVDUQVIAWDWTWEWJAWDWTBCWJHUJQZXBXCAXEXHWJXQXDUNXGXPHXDURUS
      UTVJWMUKZAWDWTWEWFXKVJWREWDBCWJXQXLWFXAJWELAEWJXQRWFXARJSTWQAEBCHIJLOVKZV
      IXBXMAWQVLVMVOVNVPAPWDBCDEWGFWMHIIJKLXBXRMOABCDGIJKLNXJVQVRAEWDVSEWPUIAEW
      DBCWJXQWFXAJLXSXBVTPWDEWAWBWC $.

    $( Right identity of natural transformations.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    fucrid $p |- ( ph ->
      ( R ( <. F , F >. .xb G ) ( .1. o. ( 1st ` F ) ) ) = R ) $=
      ( vx cfv cop co wcel cbs cv c1st ccom cco cmpt wa wf wceq c2nd eqid cfunc
      wrel wbr relfunc natrcl simpld 1st2ndbr sylancr funcf1 fvco3 sylan oveq2d
      syl chom ccat funcrcl simprd adantr ffvelrnda nat1st2nd simpr natcl eqtrd
      catrid mpteq2dva fucidcl fucco wfn natfn dffn5 sylib 3eqtr4d ) APBUAQZPUB
      ZEQZWEGHUCQZUDZQZWEWGQZWJRWEIUCQZQZCUEQZSZSZUFPWDWFUFZEWHHHRIFSSEAPWDWOWF
      AWEWDTZUGZWOWFWJGQZWNSWFWRWIWSWFWNAWDCUAQZWGUHWQWIWSUIAWDWTBCWGHUJQZWDUKZ
      WTUKZABCULSZUMZHXDTZWGXAXDUNBCUOZAXFIXDTZAEHIJSTXFXHUGOEBCHIJLUPVDZUQZHXD
      URUSUTZWDWTWEGWGVAVBVCWRWTCWMGWFCVEQZWJWLXCXLUKZNACVFTZWQABVFTZXNAXFXOXNU
      GXJBCHVGVDVHVIAWDWTWEWGXKVJWMUKZAWDWTWEWKAWDWTBCWKIUJQZXBXCAXEXHWKXQXDUNX
      GAXFXHXIVHIXDURUSUTVJWREWDBCWGXAXLWKXQJWELAEWGXARWKXQRJSTWQAEBCHIJLOVKZVI
      XBXMAWQVLVMVOVNVPAPWDBCDWHEFWMHHIJKLXBXPMABCDGHJKLNXJVQOVRAEWDVSEWPUIAEWD
      BCWGXAWKXQJLXRXBVTPWDEWAWBWC $.
  $}

  ${
    $d x C $.  $d x D $.  $d x F $.  $d x G $.  $d x H $.  $d x K $.  $d x R $.
    $d x ph $.  $d x S $.  $d x T $.  $d x .xb $.
    fucass.q $e |- Q = ( C FuncCat D ) $.
    fucass.n $e |- N = ( C Nat D ) $.
    fucass.x $e |- .xb = ( comp ` Q ) $.
    fucass.r $e |- ( ph -> R e. ( F N G ) ) $.
    fucass.s $e |- ( ph -> S e. ( G N H ) ) $.
    fucass.t $e |- ( ph -> T e. ( H N K ) ) $.
    $( Associativity of natural transformation composition.  (Contributed by
       Mario Carneiro, 6-Jan-2017.) $)
    fucass $p |- ( ph ->
      ( ( T ( <. G , H >. .xb K ) S ) ( <. F , G >. .xb K ) R ) =
      ( T ( <. F , H >. .xb K ) ( S ( <. F , G >. .xb H ) R ) ) ) $=
      ( co vx cbs cfv cv cop c1st cco cmpt wcel chom eqid ccat cfunc natrcl syl
      wa simpld funcrcl simprd adantr c2nd wrel relfunc 1st2ndbr sylancr funcf1
      wbr ffvelrnda nat1st2nd simpr natcl catass fuccoval oveq1d oveq2d 3eqtr4d
      mpteq2dva fuccocl fucco ) AUABUBUCZUAUDZHFJKUELGTTZUCZWAEUCZWAIUFUCZUCZWA
      JUFUCZUCZUEZWALUFUCZUCZCUGUCZTZTZUHUAVTWAHUCZWAFEIJUEZKGTTZUCZWFWAKUFUCZU
      CZUEWKWLTZTZUHWBEWPLGTTHWQIKUELGTTAUAVTWNXBAWAVTUIZUPZWOWAFUCZWHWTUEWKWLT
      TZWDWMTWOXEWDWIWTWLTTZXATWNXBXDCUBUCZCWLWDXECUJUCZWOWKWFWHWTXHUKZXIUKZWLU
      KZACULUIZXCABULUIZXMAIBCUMTZUIZXNXMUPAXPJXOUIZAEIJMTUIZXPXQUPQEBCIJMOUNUO
      ZUQZBCIURUOUSUTAVTXHWAWEAVTXHBCWEIVAUCZVTUKZXJAXOVBZXPWEYAXOVGBCVCZXTIXOV
      DVEVFVHAVTXHWAWGAVTXHBCWGJVAUCZYBXJAYCXQWGYEXOVGYDAXPXQXSUSJXOVDVEVFVHAVT
      XHWAWSAVTXHBCWSKVAUCZYBXJAYCKXOUIZWSYFXOVGYDAYGLXOUIZAHKLMTUIZYGYHUPSHBCK
      LMOUNUOZUQKXOVDVEVFVHXDEVTBCWEYAXIWGYEMWAOAEWEYAUEWGYEUEZMTUIXCAEBCIJMOQV
      IUTYBXKAXCVJZVKXDFVTBCWGYEXIWSYFMWAOAFYKWSYFUEZMTUIXCAFBCJKMORVIUTYBXKYLV
      KAVTXHWAWJAVTXHBCWJLVAUCZYBXJAYCYHWJYNXOVGYDAYGYHYJUSLXOVDVEVFVHXDHVTBCWS
      YFXIWJYNMWAOAHYMWJYNUEMTUIXCAHBCKLMOSVIUTYBXKYLVKVLXDWCXFWDWMXDVTBCDFHGWL
      JKLMWANOYBXLPAFJKMTUIXCRUTZAYIXCSUTYLVMVNXDWRXGWOXAXDVTBCDEFGWLIJKMWANOYB
      XLPAXRXCQUTYOYLVMVOVPVQAUAVTBCDEWBGWLIJLMNOYBXLPQABCDFHGJKLMNOPRSVRVSAUAV
      TBCDWQHGWLIKLMNOYBXLPABCDEFGIJKMNOPQRVRSVSVP $.
  $}

  ${
    $d e g h r s t .1. $.  $d e f g h r s t C $.  $d e f g h r s t ph $.
    $d e f g h r s t D $.  $d e f g h r s t Q $.
    fuccat.q $e |- Q = ( C FuncCat D ) $.
    fuccat.r $e |- ( ph -> C e. Cat ) $.
    fuccat.s $e |- ( ph -> D e. Cat ) $.
    ${
      fuccatid.1 $e |- .1. = ( Id ` D ) $.
      $( The functor category is a category.  (Contributed by Mario Carneiro,
         6-Jan-2017.) $)
      fuccatid $p |- ( ph -> ( Q e. Cat /\ ( Id ` Q ) =
          ( f e. ( C Func D ) |-> ( .1. o. ( 1st ` f ) ) ) ) ) $=
        ( ve vg vh cv co wcel wa cfv cvv a1i vr vs cfunc cnat w3a cco c1st ccom
        vt cbs wceq fucbas chom eqid eqidd cfuc ovex eqeltri biid simpr fucidcl
        fuchom simpr31 fuclid simpr32 fucrid fuccocl simpr33 fucass iscatd2 ) A
        KNZBCUCOZPFNZVLPZQZLNZVLPMNZVLPQZUANZVKVMBCUDOZOPZUBNZVMVPVTOPZUINZVPVQ
        VTOPZUEUEZKFLMVLDDUFRZEVMUGRUHUAUBUIVTSVLDUJRUKABCDGULTVTDUMRUKABCDVTGV
        TUNZVBTAWGUODSPADBCUPOSGBCUPUQURTWFUSAVNQBCDEVMVTGWHJAVNUTVAAWFQZBCDVSW
        GEVKVMVTGWHWGUNZJWAWCWEVOVRAVCZVDWIBCDWBWGEVMVPVTGWHWJJWAWCWEVOVRAVEZVF
        WIBCDVSWBWGVKVMVPVTGWHWJWKWLVGWIBCDVSWBWGWDVKVMVPVQVTGWHWJWKWLWAWCWEVOV
        RAVHVIVJ $.
    $}

    $( The functor category is a category.  (Contributed by Mario Carneiro,
       6-Jan-2017.) $)
    fuccat $p |- ( ph -> Q e. Cat ) $=
      ( vf ccat wcel ccid cfv cfunc co cv c1st ccom cmpt wceq eqid fuccatid
      simpld ) ADIJDKLHBCMNCKLZHOPLQRSABCDUCHEFGUCTUAUB $.
  $}

  ${
    $d f .1. $.  $d f C $.  $d f D $.  $d f F $.  $d f ph $.  $d f Q $.
    fucid.q $e |- Q = ( C FuncCat D ) $.
    fucid.i $e |- I = ( Id ` Q ) $.
    fucid.1 $e |- .1. = ( Id ` D ) $.
    fucid.f $e |- ( ph -> F e. ( C Func D ) ) $.
    $( The identity morphism in the functor category.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    fucid $p |- ( ph -> ( I ` F ) = ( .1. o. ( 1st ` F ) ) ) $=
      ( vf c1st cfv ccom cvv ccid ccat wcel wceq cv cfunc co cmpt wa syl simpld
      funcrcl simprd fuccatid syl5eq fveq2d coeq2d fvex eqeltri coex a1i fvmptd
      simpr ) ALFELUAZMNZOZEFMNZOZBCUBUCZGPAGDQNZLVEVBUDZIADRSVFVGTABCDELHABRSZ
      CRSZAFVESVHVIUEKBCFUHUFZUGAVHVIVJUIJUJUIUKAUTFTZUEZVAVCEVLUTFMAVKUSULUMKV
      DPSAEVCECQNPJCQUNUOFMUNUPUQUR $.
  $}

  ${
    $d x y A $.  $d f x y z B $.  $d f x y z C $.  $d f x y z D $.  $d x y I $.
    $d f x y z F $.  $d f x y z G $.  $d x y J $.  $d x y N $.  $d f x y z V $.
    $d f x y z ph $.  $d x y Q $.  $d x y U $.  $d f y z X $.
    fuciso.q $e |- Q = ( C FuncCat D ) $.
    fuciso.b $e |- B = ( Base ` C ) $.
    fuciso.n $e |- N = ( C Nat D ) $.
    fuciso.f $e |- ( ph -> F e. ( C Func D ) ) $.
    fuciso.g $e |- ( ph -> G e. ( C Func D ) ) $.
    ${
      fucsect.s $e |- S = ( Sect ` Q ) $.
      fucsect.t $e |- T = ( Sect ` D ) $.
      $( Two natural transformations are in a section iff all the components
         are in a section relation.  (Contributed by Mario Carneiro,
         28-Jan-2017.) $)
      fucsect $p |- ( ph -> ( U ( F S G ) V <->
        ( U e. ( F N G ) /\ V e. ( G N F ) /\ A. x e. B
     ( U ` x ) ( ( ( 1st ` F ) ` x ) T ( ( 1st ` G ) ` x ) ) ( V ` x ) ) ) ) $=
        ( co wbr wcel cop cco cfv ccid wceq w3a cv c1st wral fucbas fuchom eqid
        cfunc ccat wa funcrcl syl simpld simprd fuccat issect cmpt cvv wb rgenw
        ovex mpteqb mp1i simprl simprr fucco ccom adantr fucid cbs wf wfn cidfn
        dffn2 sylib c2nd relfunc 1st2ndbr sylancr funcf1 fcompt syl2anc eqeq12d
        wrel eqtrd chom ffvelrnda simpr natcl issect2 ralbidva 3bitr4d pm5.32da
        nat1st2nd df-3an 3bitr4g bitrd ) AIMJKGUAUBIJKLUAUCZMKJLUAUCZMIJKUDJFUE
        UFZUAUAZJFUGUFZUFZUHZUIZXFXGBUJZIUFZXNMUFZXNJUKUFZUFZXNKUKUFZUFZHUAUBZB
        CULZUIZADEUPUAZFGXHXJIMLJKDEFNUMDEFLNPUNXHUOZXJUOZSADEFNADUQUCZEUQUCZAJ
        YDUCZYGYHURQDEJUSUTZVAAYGYHYJVBZVCQRVDAXFXGURZXLURYLYBURXMYCAYLXLYBAYLU
        RZBCXPXOXRXTUDXREUEUFZUAZUAZVEZBCXREUGUFZUFZVEZUHZYPYSUHZBCULZXLYBYPVFU
        CZBCULUUAUUCVGYMUUDBCXPXOYOVIVHBCYPYSVFVJVKYMXIYQXKYTYMBCDEFIMXHYNJKJLN
        POYNUOZYEAXFXGVLZAXFXGVMZVNYMXKYRXQVOZYTYMDEFYRJXJNYFYRUOZAYIYLQVPVQYME
        VRUFZVFYRVSZCUUJXQVSZUUHYTUHYMYRUUJVTZUUKYMYHUUMAYHYLYKVPZUUJEYRUUJUOZU
        UIWAUTUUJYRWBWCAUULYLACUUJDEXQJWDUFZOUUOAYDWLZYIXQUUPYDUBDEWEZQJYDWFWGW
        HVPZBYRXQCUUJVFWIWJWMWKYMYAUUBBCYMXNCUCZURZUUJEHYNYRXOXPEWNUFZXRXTUUOUV
        BUOZUUEUUITYMYHUUTUUNVPYMCUUJXNXQUUSWOYMCUUJXNXSACUUJXSVSYLACUUJDEXSKWD
        UFZOUUOAUUQKYDUCXSUVDYDUBUURRKYDWFWGWHVPWOUVAICDEXQUUPUVBXSUVDLXNPUVAID
        EJKLPYMXFUUTUUFVPXBOUVCYMUUTWPZWQUVAMCDEXSUVDUVBXQUUPLXNPUVAMDEKJLPYMXG
        UUTUUGVPXBOUVCUVEWQWRWSWTXAXFXGXLXCXFXGYBXCXDXE $.
    $}

    ${
      fucinv.i $e |- I = ( Inv ` Q ) $.
      fucinv.j $e |- J = ( Inv ` D ) $.
      $( Two natural transformations are inverses of each other iff all the
         components are inverse.  (Contributed by Mario Carneiro,
         28-Jan-2017.) $)
      fucinv $p |- ( ph -> ( U ( F I G ) V <->
        ( U e. ( F N G ) /\ V e. ( G N F ) /\ A. x e. B
     ( U ` x ) ( ( ( 1st ` F ) ` x ) J ( ( 1st ` G ) ` x ) ) ( V ` x ) ) ) ) $=
        ( csect cfv co wbr wa wcel cv c1st wral w3a eqid fucsect anbi12d fucbas
        cfunc ccat funcrcl syl simpld simprd fuccat isinv cbs c2nd wrel relfunc
        adantr 1st2ndbr sylancr funcf1 ffvelrnda ralbidva r19.26 syl6bb 3ancoma
        anbi2d df-3an bitri anbi12i anandi bitr4i 3bitr4g 3bitr4d ) AGMHIFUAUBZ
        UCUDZMGIHWDUCUDZUEGHILUCUFZMIHLUCUFZBUGZGUBZWIMUBZWIHUHUBZUBZWIIUHUBZUB
        ZEUAUBZUCUDZBCUIZUJZWHWGWKWJWOWMWPUCUDZBCUIZUJZUEZGMHIJUCUDWGWHWJWKWMWO
        KUCUDZBCUIZUJZAWEWSWFXBABCDEFWDWPGHILMNOPQRWDUKZWPUKZULABCDEFWDWPMIHLGN
        OPRQXGXHULUMADEUOUCZFWDGMJHIDEFNUNSADEFNADUPUFZEUPUFZAHXIUFZXJXKUEQDEHU
        QURZUSAXJXKXMUTZVAQRXGVBAWGWHUEZXEUEXOWRXAUEZUEZXFXCAXEXPXOAXEWQWTUEZBC
        UIXPAXDXRBCAWICUFZUEEVCUBZEWPWJWKKWMWOXTUKZTAXKXSXNVGACXTWIWLACXTDEWLHV
        DUBZOYAAXIVEZXLWLYBXIUDDEVFZQHXIVHVIVJVKACXTWIWNACXTDEWNIVDUBZOYAAYCIXI
        UFWNYEXIUDYDRIXIVHVIVJVKXHVBVLWQWTBCVMVNVPWGWHXEVQXCXOWRUEZXOXAUEZUEXQW
        SYFXBYGWGWHWRVQXBWGWHXAUJYGWHWGXAVOWGWHXAVQVRVSXOWRXAVTWAWBWC $.

      invfuc.u $e |- ( ph -> U e. ( F N G ) ) $.
      invfuc.v $e |- ( ( ph /\ x e. B ) ->
        ( U ` x ) ( ( ( 1st ` F ) ` x ) J ( ( 1st ` G ) ` x ) ) X ) $.
      $( If ` V ( x ) ` is an inverse to ` U ( x ) ` for each ` x ` , and ` U `
         is a natural transformation, then ` V ` is also a natural
         transformation, and they are inverse in the functor category.
         (Contributed by Mario Carneiro, 28-Jan-2017.) $)
      invfuc $p |- ( ph -> U ( F I G ) ( x e. B |-> X ) ) $=
        ( vy vz vf cmpt co wbr wcel cv cfv c1st wral chom cixp c2nd cop wceq wa
        cco cxp cbs eqid ccat cfunc funcrcl simprd adantr wrel relfunc 1st2ndbr
        syl sylancr funcf1 ffvelrnda invss ssbrd mpd brxp simprbi ralrimiva cvv
        wb fvex eqeltri mptelixpg ax-mp sylibr weq oveq12d cbvixpv syl6eleq w3a
        fveq2 ccid csect simpr2 simpr fvmpt2 syl2anc breqtrrd nffvmpt1 breq123d
        nfcv nfbr rspc sylc wf ffvelrnd isinv mpbid simpld issect simp3d oveq1d
        simpr1 funcf2 simpr3 catlid eqtr2d nat1st2nd natcl simp2d catass oveq2d
        nati 3eqtrd simp1d catcocl catrid 3eqtrrd ralrimivvva isnat2 nfv cbvral
        mpbir2and sylib fucinv mpbir3and ) AGBCMUFZHIJUGUHGHILUGUIZYTIHLUGUIZUC
        UJZGUKZUUCYTUKZUUCHULUKZUKZUUCIULUKZUKZKUGZUHZUCCUMZUAAUUBYTUCCUUIUUGEU
        NUKZUGZUOZUIUDUJZYTUKZUEUJZUUCUUPIUPUKZUGZUKZUUIUUPUUHUKZUQUUPUUFUKZEUT
        UKZUGZUGZUURUUCUUPHUPUKZUGZUKZUUEUUIUUGUQZUVCUVDUGZUGZURZUEUUCUUPDUNUKZ
        UGZUMUDCUMUCCUMAYTBCBUJZUUHUKZUVPUUFUKZUUMUGZUOZUUOAMUVSUIZBCUMZYTUVTUI
        ZAUWABCAUVPCUIZUSZUVPGUKZMUVRUVQUUMUGZUVSVAZUHZUWAUWEUWFMUVRUVQKUGZUHUW
        IUBUWEUWJUWHUWFMUWEEVBUKZEUUMKUVRUVQUWKVCZTAEVDUIZUWDADVDUIZUWMAHDEVEUG
        ZUIZUWNUWMUSQDEHVFVLVGZVHACUWKUVPUUFACUWKDEUUFUVGOUWLAUWOVIZUWPUUFUVGUW
        OUHZDEVJZQHUWOVKVMZVNZVOACUWKUVPUUHACUWKDEUUHUUSOUWLAUWRIUWOUIUUHUUSUWO
        UHZUWTRIUWOVKVMZVNZVOUUMVCZVPVQVRUWIUWFUWGUIUWAUWFMUWGUVSVSVTVLZWACWBUI
        UWCUWBWCCDVBUKWBODVBWDWEBCMUVSWBWFWGWHBUCCUVSUUNBUCWIZUVQUUIUVRUUGUUMUV
        PUUCUUHWNZUVPUUCUUFWNZWJWKWLAUVMUCUDUECCUVOAUUCCUIZUUPCUIZUURUVOUIZWMZU
        SZUVLUUQUVAUUDUUGUUIUQUVBUVDUGUGZUUGUVBUQUVCUVDUGZUGZUUEUVKUGUUQUXPUUEU
        VJUVBUVDUGUGZUVEUGUVFUXOUVIUXRUUEUVKUXOUVIUUQUUPGUKZUVCUVBUQUVCUVDUGUGZ
        UVIUUGUVCUQZUVCUVDUGZUGZUUQUXTUVIUYBUVBUVDUGUGZUXQUGUXRUXOUYDUVCEWOUKZU
        KZUVIUYCUGUVIUXOUYAUYGUVIUYCUXOUXTUVCUVBUUMUGUIZUUQUVBUVCUUMUGUIZUYAUYG
        URZUXOUXTUUQUVCUVBEWPUKZUGUHZUYHUYIUYJWMUXOUYLUUQUXTUVBUVCUYKUGUHZUXOUX
        TUUQUVCUVBKUGZUHZUYLUYMUSUXOUXLUWFUVPYTUKZUWJUHZBCUMZUYOAUXKUXLUXMWQZAU
        YRUXNAUYQBCUWEUWFMUYPUWJUBUWEUWDUWAUYPMURAUWDWRUXGBCMUVSYTYTVCWSWTXAWAZ
        VHZUYQUYOBUUPCBUXTUUQUYNBUXTXDBUYNXDBCMUUPXBXEBUDWIZUWFUXTUYPUUQUWJUYNU
        VPUUPGWNVUBUVRUVCUVQUVBKUVPUUPUUFWNUVPUUPUUHWNWJUVPUUPYTWNXCXFXGUXOUWKE
        UYKUXTUUQKUVCUVBUWLTAUWMUXNUWQVHZUXOCUWKUUPUUFACUWKUUFXHUXNUXBVHZUYSXIZ
        UXOCUWKUUPUUHACUWKUUHXHUXNUXEVHZUYSXIZUYKVCZXJXKXLUXOUWKEUYKUVDUYFUXTUU
        QUUMUVCUVBUWLUXFUVDVCZUYFVCZVUHVUCVUEVUGXMXKZXNXOUXOUWKEUVDUYFUVIUUMUUG
        UVCUWLUXFVUJVUCUXOCUWKUUCUUFVUDAUXKUXLUXMXPZXIZVUIVUEUXOUVOUUGUVCUUMUGU
        URUVHUXOCDEUUFUVGUVNUUMUUCUUPOUVNVCZUXFAUWSUXNUXAVHVULUYSXQAUXKUXLUXMXR
        ZXIZXSXTUXOUWKEUVDUVIUXTUUMUUQUVCUUGUVCUVBUWLUXFVUIVUCVUMVUEVUGVUPUXOGC
        DEUUFUVGUUMUUHUUSLUUPPUXOGDEHILPAUUAUXNUAVHYAZOUXFUYSYBVUEUXOUYHUYIUYJV
        UKYCZYDUXOUYEUXPUUQUXQUXOGCDEUURUVDUUFUVGUVNUUHUUSLUUCUUPPVUQOVUNVUIVUL
        UYSVUOYFYEYGXOUXOUWKEUVDUUEUXPUUMUUQUVCUUIUUGUVBUWLUXFVUIVUCUXOCUWKUUCU
        UHVUFVULXIZVUMVUGUXOUUEUUNUIZUUDUUGUUIUUMUGUIZUUDUUEUVJUUIUVDUGUGZUUIUY
        FUKZURZUXOUUEUUDUUIUUGUYKUGUHZVUTVVAVVDWMUXOUUDUUEUUGUUIUYKUGUHZVVEUXOU
        UKVVFVVEUSUXOUXKUYRUUKVULVUAUYQUUKBUUCCBUUDUUEUUJBUUDXDBUUJXDBCMUUCXBXE
        ZUXHUWFUUDUYPUUEUWJUUJUVPUUCGWNUXHUVRUUGUVQUUIKUXJUXIWJUVPUUCYTWNXCZXFX
        GUXOUWKEUYKUUDUUEKUUGUUIUWLTVUCVUMVUSVUHXJXKVGUXOUWKEUYKUVDUYFUUEUUDUUM
        UUIUUGUWLUXFVUIVUJVUHVUCVUSVUMXMXKZYHZUXOUWKEUVDUUDUVAUUMUUGUUIUVBUWLUX
        FVUIVUCVUMVUSVUGUXOVUTVVAVVDVVIYCUXOUVOUUIUVBUUMUGUURUUTUXOCDEUUHUUSUVN
        UUMUUCUUPOVUNUXFAUXCUXNUXDVHVULUYSXQVUOXIZYIVUEVURYDUXOUXSUVAUUQUVEUXOU
        XSUVAVVBUUIUUIUQUVBUVDUGZUGUVAVVCVVLUGUVAUXOUWKEUVDUUEUUDUUMUVAUVBUUIUU
        GUUIUWLUXFVUIVUCVUSVUMVUSVVJUXOGCDEUUFUVGUUMUUHUUSLUUCPVUQOUXFVULYBVUGV
        VKYDUXOVVBVVCUVAVVLUXOVUTVVAVVDVVIXNYEUXOUWKEUVDUYFUVAUUMUUIUVBUWLUXFVU
        JVUCVUSVUIVUGVVKYJYGYEYKYLAUCUDYTCDEUVDUEIHUVNUUMLPOVUNUXFVUIRQYMYPAUYR
        UULUYTUYQUUKBUCCUYQUCYNVVGVVHYOYQAUCCDEFGHIJKLYTNOPQRSTYRYS $.
    $}

    ${
      fuciso.i $e |- I = ( Iso ` Q ) $.
      fuciso.j $e |- J = ( Iso ` D ) $.
      $( A natural transformation is an isomorphism of functors iff all its
         components are isomorphisms.  (Contributed by Mario Carneiro,
         28-Jan-2017.) $)
      fuciso $p |- ( ph -> ( A e. ( F I G ) <-> ( A e. ( F N G ) /\
  A. x e. B ( A ` x ) e. ( ( ( 1st ` F ) ` x ) J ( ( 1st ` G ) ` x ) ) ) ) ) $=
        ( cfv vy co wcel cv c1st wral wa cfunc fucbas fuchom funcrcl syl simpld
        ccat simprd fuccat isohom sselda cbs cinv eqid ad2antrr wf c2nd relfunc
        wrel wbr 1st2ndbr sylancr funcf1 adantr ffvelrnda w3a cdm isoval eleq2d
        wfun invfun funfvbrb bitrd biimpa fucinv mpbid simp3d inviso1 ralrimiva
        r19.21bi jca cmpt simprl simprr weq fveq2 oveq12d eleq12d rspccva sylan
        wb eleqtrd invfuc impbida ) ACHIJUBZUCZCHILUBZUCZBUDZCTZXFHUETZTZXFIUET
        ZTZKUBZUCZBDUFZUGZAXCUGZXEXNAXBXDCAEFUHUBZGLJHIEFGMUIZEFGLMOUJRAEFGMAEU
        NUCZFUNUCZAHXQUCZXSXTUGPEFHUKULZUMAXSXTYBUOZUPZPQUQURXPXMBDXPXFDUCZUGFU
        STZFXGXFCHIGUTTZUBZTZTZKFUTTZXIXKYFVAZYKVAZAXTXCYEYCVBXPDYFXFXHADYFXHVC
        ZXCADYFEFXHHVDTZNYLAXQVFZYAXHYOXQVGEFVEZPHXQVHVIVJZVKVLXPDYFXFXJADYFXJV
        CZXCADYFEFXJIVDTZNYLAYPIXQUCZXJYTXQVGYQQIXQVHVIVJZVKVLSXPXGYJXIXKYKUBVG
        ZBDXPXEYIIHLUBUCZUUCBDUFZXPCYIYHVGZXEUUDUUEVMZAXCUUFAXCCYHVNZUCZUUFAXBU
        UHCAXQGJYGHIXRYGVAZYDPQRVOVPAYHVQUUIUUFWRAXQGYGHIXRUUJYDPQVRCYHVSULVTWA
        AUUFUUGWRXCABDEFGCHIYGYKLYIMNOPQUUJYMWBVKWCWDWGWEWFWHAXOUGZXQGCUADUAUDZ
        CTZUULXHTZUULXJTZYKUBZTZWIJYGHIXRUUJAGUNUCXOYDVKAYAXOPVKZAUUAXOQVKZRUUK
        UADEFGCHIYGYKLUUQMNOUURUUSUUJYMAXEXNWJUUKUULDUCZUGZUUMUUPVNZUCZUUMUUQUU
        PVGZUVAUUMUUNUUOKUBZUVBUUKXNUUTUUMUVEUCZAXEXNWKXMUVFBUULDBUAWLZXGUUMXLU
        VEXFUULCWMUVGXIUUNXKUUOKXFUULXHWMXFUULXJWMWNWOWPWQUVAYFFKYKUUNUUOYLYMAX
        TXOUUTYCVBZUUKDYFUULXHAYNXOYRVKVLZUUKDYFUULXJAYSXOUUBVKVLZSVOWSUVAUUPVQ
        UVCUVDWRUVAYFFYKUUNUUOYLYMUVHUVIUVJVRUUMUUPVSULWCWTWEXA $.
    $}
  $}

  ${
    $d a b f g h r s v x y z A $.  $d a b f g h r s v x y z C $.
    $d a b f g h r s v x y B $.  $d a b f g h r s v x y ph $.
    $d a b f g h r s v x y D $.
    fucpropd.1 $e |- ( ph -> ( Homf ` A ) = ( Homf ` B ) ) $.
    fucpropd.2 $e |- ( ph -> ( comf ` A ) = ( comf ` B ) ) $.
    fucpropd.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    fucpropd.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    fucpropd.a $e |- ( ph -> A e. Cat ) $.
    fucpropd.b $e |- ( ph -> B e. Cat ) $.
    fucpropd.c $e |- ( ph -> C e. Cat ) $.
    fucpropd.d $e |- ( ph -> D e. Cat ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same natural transformations.
       (Contributed by Mario Carneiro, 26-Jan-2017.) $)
    natpropd $p |- ( ph -> ( A Nat C ) = ( B Nat D ) ) $=
      ( vr vx co cfv wceq wcel eqid vf vg vs vy va vh vz cfunc cv c1st c2nd cop
      cco chom wral cbs cixp crab csb cmpt2 cnat ccat funcpropd adantr cvv wnfc
      nfv nfcsb1v a1i fvex chomf ad4antr simplr wrel wbr relfunc simpllr simpld
      wa 1st2ndbr sylancr eqbrtrd ffvelrnda simpr homfeqval ixpeq2dva homfeqbas
      funcf1 simprd ad3antrrr ixpeq1d wb oveq12d cbvixpv eleq2i ad6antr ad7antr
      eqtrd fveq2 ccomf adantlr ad2antrr funcf2 fvixp comfeqval adantll eqeq12d
      raleqbidva sylan2b rabeqbidva csbeq1a adantl csbiedf mpt2eq123dva natfval
      wf sylan 3eqtr4g ) AUAUBBDUHPZXSNUAUIZUJQZUCUBUIZUJQZUDUIZUEUIZQZUFUIZOUI
      ZYDXTUKQZPZQZYHNUIZQZYDYLQZULZYDUCUIZQZDUMQZPPZYGYHYDYBUKQZPZQZYHYEQZYMYH
      YPQZULZYQYRPPZRZUFYHYDBUNQZPZUOZUDBUPQZUOZOUUKUOZUEOUUKYMUUDDUNQZPZUQZURZ
      USZUSZUTUAUBCEUHPZUUTNYAUCYCYFYKYOYQEUMQZPPZUUBUUCUUEYQUVAPPZRZUFYHYDCUNQ
      ZPZUOZUDCUPQZUOZOUVHUOZUEOUVHYMUUDEUNQZPZUQZURZUSZUSZUTBDVAPZCEVAPZAUAUBX
      SXSUUSUUTUUTUVPABCDEVBFGHIJKLMVCZAXSUUTRXTXSSZUVSVDAUVTYBXSSZVSZVSZNYAUUR
      UVPVEUWCNVGNUVPVFUWCNYAUVOVHVIYAVESUWCXTUJVJVIUWCYLYARZVSZUURUVOUVPUWEUCY
      CUUQUVOVEUWEUCVGUCUVOVFUWEUCYCUVNVHVIYCVESUWEYBUJVJVIUWEYPYCRZVSZUUQUVNUV
      OUWGUUMUVJUEUUPUVMUWGUUPOUUKUVLUQUVMUWGOUUKUUOUVLUWGYHUUKSZVSDUPQZDEUUNUV
      KYMUUDUWITZUUNTZUVKTZADVKQEVKQRZUWBUWDUWFUWHHVLUWGUUKUWIYHYLUWGUUKUWIBDYL
      YIUUKTZUWJUWGYLYAYIXSUWCUWDUWFVMUWGXSVNZUVTYAYIXSVOBDVPZUWGUVTUWAAUWBUWDU
      WFVQZVRXTXSVTWAWBZWHZWCZUWGUUKUWIYHYPUWGUUKUWIBDYPYTUWNUWJUWGYPYCYTXSUWEU
      WFWDUWGUWOUWAYCYTXSVOUWPUWGUVTUWAUWQWIYBXSVTWAWBZWHZWCZWEWFUWGOUUKUVHUVLA
      UUKUVHRZUWBUWDUWFABCFWGWJZWKWRYEUUPSUWGYEUGUUKUGUIZYLQZUXFYPQZUUNPZUQZSZU
      UMUVJWLUUPUXJYEOUGUUKUUOUXIYHUXFRYMUXGUUDUXHUUNYHUXFYLWSYHUXFYPWSWMWNWOUW
      GUXKVSZUULUVIOUUKUVHUWGUXDUXKUXEVDZUXLUWHVSZUUJUVGUDUUKUVHUXLUXDUWHUXMVDU
      XNYDUUKSZVSZUUGUVDUFUUIUVFUXPUUKBCUUHUVEYHYDUWNUUHTZUVETZABVKQCVKQRUWBUWD
      UWFUXKUWHUXOFWPUXLUWHUXOVMZUXNUXOWDZWEUXPYGUUISZVSZYSUVBUUFUVCUYBUWIDEUVA
      YRYKYFUUNYMYNYQUWJUWKYRTZUVATZAUWMUWBUWDUWFUXKUWHUXOUYAHWQZADWTQEWTQRUWBU
      WDUWFUXKUWHUXOUYAIWQZUXNYMUWISZUXOUYAUWGUWHUYGUXKUWTXAXBZUXPYNUWISUYAUXNU
      UKUWIYDYLUWGUUKUWIYLXPUXKUWHUWSXBWCVDUXPYQUWISUYAUXNUUKUWIYDYPUWGUUKUWIYP
      XPUXKUWHUXBXBWCVDZUXPUUIYMYNUUNPYGYJUXPUUKBDYLYIUUHUUNYHYDUWNUXQUWKUWGYLY
      IXSVOUXKUWHUXOUWRWJUXSUXTXCWCUXPYFYNYQUUNPZSZUYAUXNUXKUXOUYKUWGUXKUWHVMUG
      UUKUXIYDUYJYEUXFYDRUXGYNUXHYQUUNUXFYDYLWSUXFYDYPWSWMXDXQVDXEUYBUWIDEUVAYR
      UUCUUBUUNYMUUDYQUWJUWKUYCUYDUYEUYFUYHUXNUUDUWISZUXOUYAUWGUWHUYLUXKUXCXAXB
      UYIUXNUUCUUOSZUXOUYAUXKUWHUYMUWGUGUUKUXIYHUUOYEUXFYHRUXGYMUXHUUDUUNUXFYHY
      LWSUXFYHYPWSWMXDXFXBUXPUUIUUDYQUUNPYGUUAUXPUUKBDYPYTUUHUUNYHYDUWNUXQUWKUW
      GYPYTXSVOUXKUWHUXOUXAWJUXSUXTXCWCXEXGXHXHXHXIXJUWFUVNUVORUWEUCYCUVNXKXLWR
      XMUWDUVOUVPRUWCNYAUVOXKXLWRXMXNOUDUUKBDYRUAUBUFUUHUUNUVQUCNUEUVQTUWNUXQUW
      KUYCXOOUDUVHCEUVAUAUBUFUVEUVKUVRUCNUEUVRTUVHTUXRUWLUYDXOXR $.

    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same functor categories.  (Contributed
       by Mario Carneiro, 26-Jan-2017.) $)
    fucpropd $p |- ( ph -> ( A FuncCat C ) = ( B FuncCat D ) ) $=
      ( vf vg cfv co wceq wcel eqid vv vh vb va cnx cbs cfunc cop chom cnat cco
      vx cxp cv c1st c2nd cmpt cmpt2 csb ctp cfuc ccat funcpropd opeq2d xpeq12d
      natpropd adantr wa cvv nfv wnfc nfcsb1v a1i fvex ad3antrrr oveqd proplem3
      homfeqbas ad4antr chomf ad5antr ccomf wrel relfunc simpllr simp-4r simpld
      wbr xp1st eqeltrd 1st2ndbr sylancr funcf1 ffvelrnda simplr simprd simplrr
      syl xp2nd nat1st2nd simpr natcl simplrl comfeqval mpteq12dva mpt2eq123dva
      csbeq1a adantl eqtrd csbiedf tpeq123d eqidd fucval 3eqtr4d ) AUEUFPZBDUGQ
      ZUHZUEUIPZBDUJQZUHZUEUKPZUAUBXPXPUMZXPNUAUNZUOPZOYCUPPZUCUDOUNZUBUNZXSQZN
      UNZYFXSQZULBUFPZULUNZUCUNZPZYLUDUNZPZYLYIUOPZPZYLYFUOPZPZUHZYLYGUOPZPZDUK
      PZQQZUQZURZUSZUSZURZUHZUTXOCEUGQZUHZXRCEUJQZUHZYAUAUBUULUULUMZUULNYDOYEUC
      UDYFYGUUNQZYIYFUUNQZULCUFPZYNYPUUAUUCEUKPZQQZUQZURZUSZUSZURZUHZUTBDVAQZCE
      VAQZAXQUUMXTUUOUUKUVGAXPUULXOABCDEVBFGHIJKLMVCZVDAXSUUNXRABCDEFGHIJKLMVFZ
      VDAUUJUVFYAAUAUBYBXPUUIUUPUULUVEAXPUULXPUULUVJUVJVEAXPUULRYCYBSZUVJVGAUVL
      YGXPSZVHZVHZNYDUUHUVEVIUVONVJNUVEVKUVONYDUVDVLVMYDVISUVOYCUOVNVMUVOYIYDRZ
      VHZUUHUVDUVEUVQOYEUUGUVDVIUVQOVJOUVDVKUVQOYEUVCVLVMYEVISUVQYCUPVNVMUVQYFY
      ERZVHZUUGUVCUVDUVSUCUDYHYJUUFUUQUURUVBUVSXSUUNYFYGAXSUUNRUVNUVPUVRUVKVOZV
      PUVSYMYHSZNOXSUUNUVTVQUVSUWAYOYJSZVHZVHZULYKUUEUUSUVAAYKUUSRUVNUVPUVRUWCA
      BCFVRVSUWDYLYKSZVHZDUFPZDEUUTUUDYPYNDUIPZYRYTUUCUWGTZUWHTZUUDTZUUTTZADVTP
      EVTPRUVNUVPUVRUWCUWEHWAADWBPEWBPRUVNUVPUVRUWCUWEIWAUWDYKUWGYLYQUWDYKUWGBD
      YQYIUPPZYKTZUWIUWDXPWCZYIXPSYQUWMXPWHBDWDZUWDYIYDXPUVOUVPUVRUWCWEUWDUVLYD
      XPSUWDUVLUVMAUVNUVPUVRUWCWFZWGZYCXPXPWIWRWJYIXPWKWLWMWNUWDYKUWGYLYSUWDYKU
      WGBDYSYFUPPZUWNUWIUWDUWOYFXPSYSUWSXPWHUWPUWDYFYEXPUVQUVRUWCWOUWDUVLYEXPSU
      WRYCXPXPWSWRWJYFXPWKWLWMWNUWDYKUWGYLUUBUWDYKUWGBDUUBYGUPPZUWNUWIUWDUWOUVM
      UUBUWTXPWHUWPUWDUVLUVMUWQWPYGXPWKWLWMWNUWFYOYKBDYQUWMUWHYSUWSXSYLXSTZUWFY
      OBDYIYFXSUXAUVSUWAUWBUWEWQWTUWNUWJUWDUWEXAZXBUWFYMYKBDYSUWSUWHUUBUWTXSYLU
      XAUWFYMBDYFYGXSUXAUVSUWAUWBUWEXCWTUWNUWJUXBXBXDXEXFUVRUVCUVDRUVQOYEUVCXGX
      HXIXJUVPUVDUVERUVONYDUVDXGXHXIXJXFVDXKAULUAYKXPBDUVHUUJUUDNOUBXSUDUCUVHTX
      PTUXAUWNUWKJLAUUJXLXMAULUAUUSUULCEUVIUVFUUTNOUBUUNUDUCUVITUULTUUNTUUSTUWL
      KMAUVFXLXMXN $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Arrows (disjointified hom-sets)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $c domA $.
  $c codA $.
  $c Arrow $.
  $c HomA $.

  $( Extend class notation to include the domain extractor for an arrow. $)
  cdoma $a class domA $.

  $( Extend class notation to include the codomain extractor for an arrow. $)
  ccoda $a class codA $.

  $( Extend class notation to include the collection of all arrows of a
     category. $)
  carw $a class Arrow $.

  $( Extend class notation to include the set of all arrows with a specific
     domain and codomain. $)
  choma $a class HomA $.

  ${
    $d c x z B $.  $d c x z C $.  $d c z J $.  $d x z ph $.  $d z X $.
    $d z Y $.
    $( Definition of the domain extractor for an arrow.  (Contributed by FL,
       24-Oct-2007.)  (Revised by Mario Carneiro, 11-Jan-2017.) $)
    df-doma $a |- domA = ( 1st o. 1st ) $.

    $( Definition of the codomain extractor for an arrow.  (Contributed by FL,
       26-Oct-2007.)  (Revised by Mario Carneiro, 11-Jan-2017.) $)
    df-coda $a |- codA = ( 2nd o. 1st ) $.

    $( Definition of the hom-set extractor for arrows, which tags the morphisms
       of the underlying hom-set with domain and codomain, which can then be
       extracted using ~ df-doma and ~ df-coda .  (Contributed by FL,
       6-May-2007.)  (Revised by Mario Carneiro, 11-Jan-2017.) $)
    df-homa $a |- HomA = ( c e. Cat |-> ( x e. ( ( Base ` c ) X. ( Base ` c ) )
      |-> ( { x } X. ( ( Hom ` c ) ` x ) ) ) ) $.

    $( Definition of the set of arrows of a category.  We will use the term
       "arrow" to denote a morphism tagged with its domain and codomain, as
       opposed to ` Hom ` , which allows hom-sets for distinct objects to
       overlap.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    df-arw $a |- Arrow = ( c e. Cat |-> U. ran ( HomA ` c ) ) $.

    homarcl.h $e |- H = ( HomA ` C ) $.
    $( Reverse closure for an arrow.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    homarcl $p |- ( F e. ( X H Y ) -> C e. Cat ) $=
      ( vc vx co wcel c0 wceq ccat n0i wn choma cfv cdm cv cxp cbs chom df-homa
      csn dmmptss sseli con3i ndmfv syl syl5eq oveqd cop df-ov 0fv eqtri syl6eq
      cmpt nsyl2 ) BDECIZJUSKLAMJZUSBNUTOZUSDEKIZKVACKDEVACAPQZKFVAAPRZJZOVCKLV
      EUTVDMAGMHGSZUAQZVGTHSZUDVHVFUBQQTUQPHGUCUEUFUGAPUHUIUJUKVBDEULZKQKDEKUMV
      IUNUOUPUR $.

    homafval.b $e |- B = ( Base ` C ) $.
    homafval.c $e |- ( ph -> C e. Cat ) $.
    ${
      homafval.j $e |- J = ( Hom ` C ) $.
      $( Value of the disjointified hom-set function.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      homafval $p |- ( ph -> H =
        ( x e. ( B X. B ) |-> ( { x } X. ( J ` x ) ) ) ) $=
        ( vc choma cfv cxp cv cmpt ccat wceq cbs chom csn fveq2 syl6eqr xpeq12d
        wcel fveq1d xpeq2d mpteq12dv df-homa cvv fvex eqeltri xpex mptex syl5eq
        fvmpt syl ) AEDLMZBCCNZBOZUAZUTFMZNZPZGADQUEURVDRIKDBKOZSMZVFNZVAUTVETM
        ZMZNZPVDQLVEDRZBVGVJUSVCVKVFCVFCVKVFDSMZCVEDSUBHUCZVMUDVKVIVBVAVKUTVHFV
        KVHDTMFVEDTUBJUCUFUGUHBKUIBUSVCCCCVLUJHDSUKULZVNUMUNUPUQUO $.
    $}

    $( Functionality of the disjointified hom-set function.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    homaf $p |- ( ph -> H : ( B X. B ) --> ~P ( ( B X. B ) X. _V ) ) $=
      ( vx cxp cvv cpw wf cv csn chom cfv cmpt wcel wss eqid adantl ssv sylancl
      wa snssi xpss12 snex fvex xpex elpw sylibr fmptd homafval feq1d mpbird )
      ABBIZUPJIZKZDLUPURHUPHMZNZUSCOPZPZIZQZLAHUPVCURVDAUSUPRZUDZVCUQSZVCURRVFU
      TUPSZVBJSVGVEVHAUSUPUEUAVBUBUTUPVBJUFUCVCUQUTVBUSUGUSVAUHUIUJUKVDTULAUPUR
      DVDAHBCDVAEFGVATUMUNUO $.

    homaval.j $e |- J = ( Hom ` C ) $.
    homaval.x $e |- ( ph -> X e. B ) $.
    homaval.y $e |- ( ph -> Y e. B ) $.
    $( Value of the disjointified hom-set function.  (Contributed by Mario
       Carneiro, 11-Jan-2017.) $)
    homaval $p |- ( ph -> ( X H Y ) = ( { <. X , Y >. } X. ( X J Y ) ) ) $=
      ( vz co cfv csn cxp df-ov wcel cop cv homafval wceq wa simpr sneqd fveq2d
      cvv syl6eqr xpeq12d opelxpi syl2anc snex ovex xpex a1i fvmptd syl5eq ) AF
      GDOFGUAZDPUTQZFGEOZRZFGDSANUTNUBZQZVDEPZRVCBBRZDUIANBCDEHIJKUCAVDUTUDZUEZ
      VEVAVFVBVIVDUTAVHUFZUGVIVFUTEPVBVIVDUTEVJUHFGESUJUKAFBTGBTUTVGTLMFGBBULUM
      VCUITAVAVBUTUNFGEUOUPUQURUS $.

    $( Value of the disjointified hom-set function.  (Contributed by Mario
       Carneiro, 11-Jan-2017.) $)
    elhoma $p |- ( ph -> ( Z ( X H Y ) F <->
      ( Z = <. X , Y >. /\ F e. ( X J Y ) ) ) ) $=
      ( co wbr cop wcel wa csn wceq homaval breqd brxp opex elsnc2 anbi1i bitri
      cxp syl6bb ) AIDGHEPZQIDGHRZUAZGHFPZUJZQZIUMUBZDUOSZTZAULUPIDABCEFGHJKLMN
      OUCUDUQIUNSZUSTUTIDUNUOUEVAURUSIUMGHUFUGUHUIUK $.

    elhomai.f $e |- ( ph -> F e. ( X J Y ) ) $.
    $( Produce an arrow from a morphism.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    elhomai $p |- ( ph -> <. X , Y >. ( X H Y ) F ) $=
      ( cop co wbr wceq wcel eqidd elhoma mpbir2and ) AGHPZDGHEQRUDUDSDGHFQTAUD
      UAOABCDEFGHUDIJKLMNUBUC $.

    $( Produce an arrow from a morphism.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    elhomai2 $p |- ( ph -> <. X , Y , F >. e. ( X H Y ) ) $=
      ( cotp cop co df-ot wbr wcel elhomai df-br sylib syl5eqel ) AGHDPGHQZDQZG
      HERZGHDSAUFDUHTUGUHUAABCDEFGHIJKLMNOUBUFDUHUCUDUE $.
  $}

  ${
    $d f H $.  $d f X $.  $d f Y $.
    homahom.h $e |- H = ( HomA ` C ) $.
    ${
      homarcl2.b $e |- B = ( Base ` C ) $.
      $( Reverse closure for the domain and codomain of an arrow.  (Contributed
         by Mario Carneiro, 11-Jan-2017.) $)
      homarcl2 $p |- ( F e. ( X H Y ) -> ( X e. B /\ Y e. B ) ) $=
        ( co wcel cop cxp wa cdm cfv elfvdm df-ov eleq2s cvv cpw wf homarcl fdm
        wceq homaf syl eleqtrd opelxp sylib ) CEFDIZJZEFKZAALZJEAJFAJMUKULDNZUM
        ULUNJCULDOUJCULDPEFDQRUKUMUMSLTZDUAUNUMUDUKABDGHBCDEFGUBUEUMUODUCUFUGEF
        AAUHUI $.
    $}

    $( An arrow is an ordered pair.  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    homarel $p |- Rel ( X H Y ) $=
      ( vf co wrel cvv cxp wss cv wcel cbs cfv xpss cpw eqid homarcl homaf
      homarcl2 simpld simprd fovrnd elelpwi mpdan sseldi ssriv df-rel mpbir ) C
      DBGZHUKIIJZKFUKULFLZUKMZANOZUOJZIJZULUMUPIPUNUKUQQZMUMUQMUNCDURUOUOBUNUOA
      BEUORZAUMBCDESTUNCUOMZDUOMZUOAUMBCDEUSUAZUBUNUTVAVBUCUDUMUKUQUEUFUGUHUKUI
      UJ $.

    $( The first component of an arrow is the ordered pair of domain and
       codomain.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    homa1 $p |- ( Z ( X H Y ) F -> Z = <. X , Y >. ) $=
      ( co wbr cop wceq chom cfv wcel wa wb df-br cbs eqid simpld simprd elhoma
      homarcl homarcl2 sylbi ibi ) FBDECHZIZFDEJKZBDEALMZHNZUHUIUKOZUHFBJZUGNZU
      HULPFBUGQUNARMZABCUJDEFGUOSZAUMCDEGUCUJSUNDUONZEUONZUOAUMCDEGUPUDZTUNUQUR
      USUAUBUEUFT $.

    ${
      homahom.j $e |- J = ( Hom ` C ) $.
      $( The second component of an arrow is the corresponding morphism
         (without the domain/codomain tag).  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      homahom2 $p |- ( Z ( X H Y ) F -> F e. ( X J Y ) ) $=
        ( co wbr cop wceq wcel wa wb df-br cbs cfv simprd eqid homarcl homarcl2
        simpld elhoma sylbi ibi ) GBEFCJZKZGEFLMZBEFDJNZUIUJUKOZUIGBLZUHNZUIULP
        GBUHQUNARSZABCDEFGHUOUAZAUMCEFHUBIUNEUONZFUONZUOAUMCEFHUPUCZUDUNUQURUST
        UEUFUGT $.

      $( The second component of an arrow is the corresponding morphism
         (without the domain/codomain tag).  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      homahom $p |- ( F e. ( X H Y ) -> ( 2nd ` F ) e. ( X J Y ) ) $=
        ( co wcel c1st cfv c2nd wbr wrel homarel 1st2ndbr mpan homahom2 syl ) B
        EFCIZJZBKLZBMLZUANZUDEFDIJUAOUBUEACEFGPBUAQRAUDCDEFUCGHST $.
    $}

    $( The domain of an arrow with known domain and codomain.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    homadm $p |- ( F e. ( X H Y ) -> ( domA ` F ) = X ) $=
      ( co wcel cdoma cfv c1st cop ccom df-doma fveq1i cvv wf wceq wfo syl elex
      fo1st fof ax-mp fvco3 sylancr syl5eq c2nd wbr wrel homarel 1st2ndbr homa1
      mpan fveq2d cbs wa eqid homarcl2 op1stg 3eqtrd ) BDECGZHZBIJZBKJZKJZDELZK
      JZDVCVDBKKMZJZVFBIVINOVCPPKQZBPHVJVFRPPKSVKUBPPKUCUDBVBUAPPBKKUEUFUGVCVEV
      GKVCVEBUHJZVBUIZVEVGRVBUJVCVMACDEFUKBVBULUNAVLCDEVEFUMTUOVCDAUPJZHEVNHUQV
      HDRVNABCDEFVNURUSDEVNVNUTTVA $.

    $( The codomain of an arrow with known domain and codomain.  (Contributed
       by Mario Carneiro, 11-Jan-2017.) $)
    homacd $p |- ( F e. ( X H Y ) -> ( codA ` F ) = Y ) $=
      ( co wcel ccoda cfv c1st c2nd cop ccom df-coda fveq1i cvv wf wceq syl wfo
      fo1st fof ax-mp elex fvco3 sylancr syl5eq wbr wrel homarel 1st2ndbr homa1
      mpan fveq2d cbs wa eqid homarcl2 op2ndg 3eqtrd ) BDECGZHZBIJZBKJZLJZDEMZL
      JZEVCVDBLKNZJZVFBIVIOPVCQQKRZBQHVJVFSQQKUAVKUBQQKUCUDBVBUEQQBLKUFUGUHVCVE
      VGLVCVEBLJZVBUIZVEVGSVBUJVCVMACDEFUKBVBULUNAVLCDEVEFUMTUOVCDAUPJZHEVNHUQV
      HESVNABCDEFVNURUSDEVNVNUTTVA $.

    $( Decompose an arrow into domain, codomain, and morphism.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    homadmcd $p |- ( F e. ( X H Y ) -> F = <. X , Y , ( 2nd ` F ) >. ) $=
      ( wcel cop c2nd cfv cotp c1st wrel wceq homarel 1st2nd mpan wbr 1st2ndbr
      co homa1 syl opeq1d eqtrd df-ot syl6eqr ) BDECTZGZBDEHZBIJZHZDEUJKUHBBLJZ
      UJHZUKUGMZUHBUMNACDEFOZBUGPQUHULUIUJUHULUJUGRZULUINUNUHUPUOBUGSQAUJCDEULF
      UAUBUCUDDEUJUEUF $.
  $}

  ${
    $d c x $.  $d c C $.  $d c H $.
    arwval.a $e |- A = ( Arrow ` C ) $.
    arwval.h $e |- H = ( HomA ` C ) $.
    $( The set of arrows is the union of all the disjointified hom-sets.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    arwval $p |- A = U. ran H $=
      ( vc vx carw cfv crn cuni ccat wcel wceq cv choma rneqd unieqd wn c0 fvex
      fveq2 syl6eqr df-arw cvv eqeltri rnex uniex fvmpt cdm dmmptss sseli con3i
      ndmfv syl cbs cxp csn chom cmpt df-homa syl5eq syl6eq uni0 eqtr4d pm2.61i
      rn0 eqtri ) ABHIZCJZKZDBLMZVIVKNFBFOZPIZJZKZVKLHVMBNZVOVJVQVNCVQVNBPIZCVM
      BPUBEUCQRFUDZVJCCVRUEEBPUAUFUGUHUIVLSZVITVKVTBHUJZMZSVITNWBVLWALBFLVPHVSU
      KULUMBHUNUOVTVKTKTVTVJTVTVJTJTVTCTVTCVRTEVTBPUJZMZSVRTNWDVLWCLBFLGVMUPIZW
      EUQGOZURWFVMUSIIUQUTPGFVAUKULUMBPUNUOVBQVGVCRVDVCVEVFVH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x y z C $.  $d x y z F $.  $d x y z H $.
    arwrcl.a $e |- A = ( Arrow ` C ) $.
    $( The first component of an arrow is the ordered pair of domain and
       codomain.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    arwrcl $p |- ( F e. A -> C e. Cat ) $=
      ( vc wcel carw cdm ccat cv choma cfv crn cuni df-arw elfvdm eleq2s sseldi
      dmmptss ) CAFGHZIBEIEJKLMNGEOSBTFCBGLACBGPDQR $.

    ${
      arwhoma.h $e |- H = ( HomA ` C ) $.
      $( An arrow is contained in the hom-set corresponding to its domain and
         codomain.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      arwhoma $p |- ( F e. A -> F e. ( ( domA ` F ) H ( codA ` F ) ) ) $=
        ( vx vy vz wcel cv co cbs cfv wrex cdoma ccoda cxp crn rexlimivw arwval
        cuni eleq2i biimpi cvv cpw wf wfn wb eqid arwrcl homaf ffn fnunirn 3syl
        mpbid cop wceq fveq2 df-ov syl6eqr eleq2d rexxp sylib id homadm oveq12d
        homacd eleqtrrd syl ) CAJZCGKZHKZDLZJZHBMNZOZGVPOZCCPNZCQNZDLZJZVKCIKZD
        NZJZIVPVPRZOZVRVKCDSUBZJZWGVKWIAWHCABDEFUAUCUDVKWFWFUERUFZDUGDWFUHWIWGU
        IVKVPBDFVPUJABCEUKULWFWJDUMICDWFUNUOUPWEVOIGHVPVPWCVLVMUQZURZWDVNCWLWDW
        KDNVNWCWKDUSVLVMDUTVAVBVCVDVQWBGVPVOWBHVPVOCVNWAVOVEVOVSVLVTVMDBCDVLVMF
        VFBCDVLVMFVHVGVITTVJ $.

      $( A hom-set is a subset of the collection of all arrows.  (Contributed
         by Mario Carneiro, 11-Jan-2017.) $)
      homarw $p |- ( X H Y ) C_ A $=
        ( co crn cuni ovssunirn arwval sseqtr4i ) DECHCIJACDEKABCFGLM $.
    $}

    ${
      arwdm.b $e |- B = ( Base ` C ) $.
      $( The domain of an arrow is an object.  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      arwdm $p |- ( F e. A -> ( domA ` F ) e. B ) $=
        ( wcel cdoma cfv ccoda choma co wa eqid arwhoma homarcl2 syl simpld ) D
        AGZDHIZBGZDJIZBGZSDTUBCKIZLGUAUCMACDUDEUDNZOBCDUDTUBUEFPQR $.

      $( The codomain of an arrow is an object.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      arwcd $p |- ( F e. A -> ( codA ` F ) e. B ) $=
        ( wcel cdoma cfv ccoda choma co wa eqid arwhoma homarcl2 syl simprd ) D
        AGZDHIZBGZDJIZBGZSDTUBCKIZLGUAUCMACDUDEUDNZOBCDUDTUBUEFPQR $.

      $( The domain function is a function from arrows to objects.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      dmaf $p |- ( domA |` A ) : A --> B $=
        ( vx cdoma cres wf wfn cv cfv wcel wral cvv wss c1st fo1st ax-mp mp2an
        ccom wfo fof fnfco df-doma fneq1i mpbir ssv fnssres fvres arwdm eqeltrd
        fofn rgen ffnfv mpbir2an ) ABGAHZIUQAJZFKZUQLZBMZFANGOJZAOPURVBQQUAZOJZ
        QOJZOOQIZVDOOQUBZVEROOQUMSVGVFROOQUCSOOQQUDTOGVCUEUFUGAUHOAGUITVAFAUSAM
        UTUSGLBUSAGUJABCUSDEUKULUNFABUQUOUP $.

      $( The codomain function is a function from arrows to objects.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      cdaf $p |- ( codA |` A ) : A --> B $=
        ( vx ccoda cres wf wfn cv cfv wcel wral cvv c2nd c1st wfo ax-mp mp2an
        wss ccom fo2nd fo1st fof fnfco df-coda fneq1i mpbir fnssres fvres arwcd
        fofn ssv eqeltrd rgen ffnfv mpbir2an ) ABGAHZIUSAJZFKZUSLZBMZFANGOJZAOU
        AUTVDPQUBZOJZPOJZOOQIZVFOOPRVGUCOOPUMSOOQRVHUDOOQUESOOPQUFTOGVEUGUHUIAU
        NOAGUJTVCFAVAAMVBVAGLBVAAGUKABCVADEULUOUPFABUSUQUR $.
    $}

    ${
      arwhom.j $e |- J = ( Hom ` C ) $.
      $( The second component of an arrow is the corresponding morphism
         (without the domain/codomain tag).  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      arwhom $p |- ( F e. A ->
        ( 2nd ` F ) e. ( ( domA ` F ) J ( codA ` F ) ) ) $=
        ( wcel cdoma cfv ccoda choma co c2nd eqid arwhoma homahom syl ) CAGCCHI
        ZCJIZBKIZLGCMIRSDLGABCTETNZOBCTDRSUAFPQ $.
    $}

    $( Decompose an arrow into domain, codomain, and morphism.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    arwdmcd $p |- ( F e. A -> F =
      <. ( domA ` F ) , ( codA ` F ) , ( 2nd ` F ) >. ) $=
      ( wcel cdoma cfv ccoda choma co c2nd cotp wceq eqid arwhoma homadmcd syl
      ) CAECCFGZCHGZBIGZJECRSCKGLMABCTDTNZOBCTRSUAPQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Identity and composition for arrows
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c IdA $.
  $c compA $.

  $( Extend class notation to include identity for arrows. $)
  cida $a class IdA $.

  $( Extend class notation to include composition for arrows. $)
  ccoa $a class compA $.

  ${
    $d c f g h x $.
    $( Definition of the identity arrow, which is just the identity morphism
       tagged with its domain and codomain.  (Contributed by FL, 26-Oct-2007.)
       (Revised by Mario Carneiro, 11-Jan-2017.) $)
    df-ida $a |- IdA = ( c e. Cat |-> ( x e. ( Base ` c ) |->
      <. x , x , ( ( Id ` c ) ` x ) >. ) ) $.

    $( Definition of the composition of arrows.  Since arrows are tagged with
       domain and codomain, this does not need to be a 5-ary operation like the
       regular composition in a category ` comp ` .  Instead, it is a partial
       binary operation on arrows, which is defined when the domain of the
       first arrow matches the codomain of the second.  (Contributed by Mario
       Carneiro, 11-Jan-2017.) $)
    df-coa $a |- compA = ( c e. Cat |-> ( g e. ( Arrow ` c ) , f e.
      { h e. ( Arrow ` c ) | ( codA ` h ) = ( domA ` g ) } |->
      <. ( domA ` f ) , ( codA ` g ) , ( ( 2nd ` g ) ( <. ( domA ` f ) ,
        ( domA ` g ) >. ( comp ` c ) ( codA ` g ) ) ( 2nd ` f ) ) >. ) ) $.
  $}

  ${
    $d c x .1. $.  $d x A $.  $d c x B $.  $d c x C $.  $d x I $.  $d x ph $.
    $d x X $.
    idafval.i $e |- I = ( IdA ` C ) $.
    idafval.b $e |- B = ( Base ` C ) $.
    idafval.c $e |- ( ph -> C e. Cat ) $.
    ${
      idafval.1 $e |- .1. = ( Id ` C ) $.
      $( Value of the identity arrow function.  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      idafval $p |- ( ph -> I = ( x e. B |-> <. x , x , ( .1. ` x ) >. ) ) $=
        ( vc cida cfv cv cotp cmpt ccat wceq cbs ccid wcel fveq2 syl6eqr fveq1d
        oteq3d mpteq12dv df-ida cvv fvex eqeltri mptex fvmpt syl syl5eq ) AFDLM
        ZBCBNZUPUPEMZOZPZGADQUAUOUSRIKDBKNZSMZUPUPUPUTTMZMZOZPUSQLUTDRZBVAVDCUR
        VEVADSMZCUTDSUBHUCVEVCUQUPUPVEUPVBEVEVBDTMEUTDTUBJUCUDUEUFBKUGBCURCVFUH
        HDSUIUJUKULUMUN $.

      idaval.x $e |- ( ph -> X e. B ) $.
      $( Value of the identity arrow function.  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      idaval $p |- ( ph -> ( I ` X ) = <. X , X , ( .1. ` X ) >. ) $=
        ( vx cv cfv cotp cvv idafval wceq wa simpr fveq2d oteq123d wcel fvmptd
        otex a1i ) ALFLMZUGUGDNZOFFFDNZOZBEPALBCDEGHIJQAUGFRZSZUGFUGFUHUIAUKTZU
        MULUGFDUMUAUBKUJPUCAFFUIUEUFUD $.

      $( Morphism part of the identity arrow.  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      ida2 $p |- ( ph -> ( 2nd ` ( I ` X ) ) = ( .1. ` X ) ) $=
        ( cfv c2nd cotp idaval fveq2d cvv wcel wceq fvex ot3rdg ax-mp syl6eq )
        AFELZMLFFFDLZNZMLZUEAUDUFMABCDEFGHIJKOPUEQRUGUESFDTFFUEQUAUBUC $.
    $}

    ${
      idahom.x $e |- ( ph -> X e. B ) $.
      ${
        idahom.h $e |- H = ( HomA ` C ) $.
        $( Domain and codomain of the identity arrow.  (Contributed by Mario
           Carneiro, 11-Jan-2017.) $)
        idahom $p |- ( ph -> ( I ` X ) e. ( X H X ) ) $=
          ( cfv ccid cotp co eqid idaval chom catidcl elhomai2 eqeltrd ) AFELFF
          FCMLZLZNFFDOABCUBEFGHIUBPZJQABCUCDCRLZFFKHIUEPZJJABCUBUEFHUFUDIJSTUA
          $.
      $}

      $( Domain of the identity arrow.  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      idadm $p |- ( ph -> ( domA ` ( I ` X ) ) = X ) $=
        ( cfv choma co wcel cdoma wceq eqid idahom homadm syl ) AEDJZEECKJZLMTN
        JEOABCUADEFGHIUAPZQCTUAEEUBRS $.

      $( Codomain of the identity arrow.  (Contributed by Mario Carneiro,
         11-Jan-2017.) $)
      idacd $p |- ( ph -> ( codA ` ( I ` X ) ) = X ) $=
        ( cfv choma co wcel ccoda wceq eqid idahom homacd syl ) AEDJZEECKJZLMTN
        JEOABCUADEFGHIUAPZQCTUAEEUBRS $.
    $}

    idaf.a $e |- A = ( Arrow ` C ) $.
    $( The identity arrow function is a function from objects to arrows.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    idaf $p |- ( ph -> I : B --> A ) $=
      ( vx cv ccid cfv cotp cvv wcel wa otex a1i eqid idafval choma homarw ccat
      co adantr simpr idahom sseldi fmpt2d ) AJJCJKZUKUKDLMZMZNZBEOUNOPAUKCPZQZ
      UKUKUMRSAJCDULEFGHULTUAUPUKUKDUBMZUEBUKEMBDUQUKUKIUQTZUCUPCDUQEUKFGADUDPU
      OHUFAUOUGURUHUIUJ $.
  $}

  ${
    $d c f g h A $.  $d c f g h C $.  $d g h F $.  $d g h G $.  $d c .xb $.
    coafval.o $e |- .x. = ( compA ` C ) $.
    coafval.a $e |- A = ( Arrow ` C ) $.
    ${
      coafval.x $e |- .xb = ( comp ` C ) $.
      $( The value of the composition of arrows.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      coafval $p |- .x. = ( g e. A , f e.
        { h e. A | ( codA ` h ) = ( domA ` g ) } |->
        <. ( domA ` f ) , ( codA ` g ) , ( ( 2nd ` g ) ( <. ( domA ` f ) ,
          ( domA ` g ) >. .xb ( codA ` g ) ) ( 2nd ` f ) ) >. ) $=
        ( vc ccoa cfv cv wceq co cmpt2 ccat carw c0 crab c2nd cop cotp wcel cco
        ccoda cdoma fveq2 syl6eqr biidd rabeqbidv oteq3d mpt2eq123dv df-coa cvv
        oveqd fvex eqeltri rabex mpt2ex fvmpt cdm dmmptss sseli con3i ndmfv syl
        wn arwrcl eq0rdv eqidd mpt20 syl6eq eqtr4d pm2.61i eqtri ) DBLMZFEAGNUG
        MFNZUHMZOZGAUAZENZUHMZVSUGMZVSUBMZWCUBMZWDVTUCZWECPZPZUDZQZHBRUEZVRWLOK
        BFEKNZSMZWAGWOUAZWDWEWFWGWHWEWNUFMZPZPZUDZQZWLRLWNBOZFEWOWPWTAWBWKXBWOB
        SMZAWNBSUIIUJZXBWAWAGWOAXDXBWAUKULXBWSWJWDWEXBWRWIWFWGXBWQCWHWEXBWQBUFM
        CWNBUFUIJUJUQUQUMUNEFGKUOZFEAWBWKAXCUPIBSURUSZWAGAXFUTVAVBWMVIZVRTWLXGB
        LVCZUEZVIVRTOXIWMXHRBKRXALXEVDVEVFBLVGVHXGWLFETWBWKQTXGFEAWBWKTWBWKXGEA
        WCAUEWMABWCIVJVFVKXGWBVLXGWKVLUNFEWBWKVMVNVOVPVQ $.
    $}

    $( A pair ` <. G , F >. ` is in the domain of the arrow composition, if the
       domain of ` G ` equals the codomain of ` F ` .  (In this case we say
       ` G ` and ` F ` are composable.)  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    eldmcoa $p |- ( G dom .x. F <->
      ( F e. A /\ G e. A /\ ( codA ` F ) = ( domA ` G ) ) ) $=
      ( vg vh vf cop wcel cv ccoda cfv cdoma wceq crab cvv wa cdm wbr csn df-br
      cxp ciun w3a c2nd cco cotp wral otex rgen2w eqid coafval fmpt2x mpbi fdmi
      co eleq2i fveq2 eqeq2d rabbidv opeliunxp2 eqeq1d elrab anbi2i an12 3anass
      wf bitr4i 3bitri ) EDCUAZUBEDKZVMLVNHAHMZUCIMZNOZVOPOZQZIARZUEUFZLZDALZEA
      LZDNOZEPOZQZUGZEDVMUDVMWAVNWASCJMZPOZVONOZVOUHOWIUHOWJVRKWKBUIOZUSUSZUJZS
      LZJVTUKHAUKWASCVJWOHJAVTWJWKWMULUMHJAVTWNSCABWLCJHIFGWLUNUOUPUQURUTWBWDDV
      QWFQZIARZLZTWDWCWGTZTZWHHAVTEDWQVOEQZVSWPIAXAVRWFVQVOEPVAVBVCVDWRWSWDWPWG
      IDAVPDQVQWEWFVPDNVAVEVFVGWTWCWDWGTTWHWDWCWGVHWCWDWGVIVKVLVL $.

    $( The domain of composition is a collection of pairs of arrows.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    dmcoass $p |- dom .x. C_ ( A X. A ) $=
      ( vg vh vf cdm cv csn ccoda cfv cdoma wceq crab cxp c2nd co wss ciun cotp
      cop eqid coafval dmmpt2ssx iunss wcel snssi ssrab2 xpss12 sylancl mprgbir
      cco sstri ) CIFAFJZKZGJLMUPNMZOZGAPZQZUAZAAQZFHAUTHJZNMZUPLMZUPRMVDRMVEUR
      UCVFBUNMZSSUBCABVGCHFGDEVGUDUEUFVBVCTVAVCTZFAFAVAVCUGUPAUHUQATUTATVHUPAUI
      USGAUJUQAUTAUKULUMUO $.
  $}

  ${
    $d z A $.  $d f g G $.  $d f g ph $.  $d z .x. $.  $d f g X $.  $d f g Y $.
    $d f g h C $.  $d f g h F $.  $d f g .xb $.  $d f g Z $.
    homdmcoa.o $e |- .x. = ( compA ` C ) $.
    homdmcoa.h $e |- H = ( HomA ` C ) $.
    homdmcoa.f $e |- ( ph -> F e. ( X H Y ) ) $.
    homdmcoa.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    $( If ` F : X --> Y ` and ` G : Y --> Z ` , then ` G ` and ` F ` are
       composable.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    homdmcoa $p |- ( ph -> G dom .x. F ) $=
      ( cfv wcel wceq co homarw sseldi syl carw ccoda cdoma cdm wbr eqid homacd
      homadm eqtr4d eldmcoa syl3anbrc ) ADBUANZOEULODUBNZEUCNZPEDCUDUEAGHFQZULD
      ULBFGHULUFZKRLSAHIFQZULEULBFHIUPKRMSAUMHUNADUOOUMHPLBDFGHKUGTAEUQOUNHPMBE
      FHIKUHTUIULBCDEJUPUJUK $.

    ${
      coaval.x $e |- .xb = ( comp ` C ) $.
      $( Value of composition for composable arrows.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      coaval $p |- ( ph -> ( G .x. F ) =
        <. X , Z , ( ( 2nd ` G ) ( <. X , Y >. .xb Z ) ( 2nd ` F ) ) >. ) $=
        ( cfv ccoda cdoma wceq co vg vf vh carw cv crab c2nd cotp cmpt2 coafval
        cop eqid cvv homarw sseldi wa wcel adantr homacd syl simpr fveq2d eqtrd
        homadm eqtr4d fveq2 eqeq1d sylanbrc otex simprr adantrr opeq12d oveq12d
        elrab a1i simprl oveq123d oteq123d ovmpt2dv2 mpi ) ADUAUBBUDPZUCUEZQPZU
        AUEZRPZSZUCWAUFZUBUEZRPZWDQPZWDUGPZWHUGPZWIWEUKZWJCTZTZUHZUISFEDTHJFUGP
        ZEUGPZHIUKZJCTZTZUHZSWABCDUBUAUCKWAULZOUJAUAUBFEWAWGWPXBDUMAIJGTZWAFWAB
        GIJXCLUNNUOAWDFSZUPZEWAUQEQPZWESZEWGUQXFHIGTZWAEWABGHIXCLUNAEXIUQZXEMUR
        ZUOXFXGIWEXFXJXGISXKBEGHILUSUTXFWEFRPZIXFWDFRAXEVAZVBXFFXDUQZXLISAXNXEN
        URZBFGIJLVDUTVCZVEWFXHUCEWAWBESWCXGWEWBEQVFVGVNVHWPUMUQAXEWHESZUPUPZWIW
        JWOVIVOXRWIHWJJWOXAXRWIERPZHXRWHERAXEXQVJZVBAXEXSHSZXQXFXJYAXKBEGHILVDU
        TVKVCZAXEWJJSXQXFWJFQPZJXFWDFQXMVBXFXNYCJSXOBFGIJLUSUTVCVKZXRWKWQWLWRWN
        WTXRWMWSWJJCXRWIHWEIYBAXEWEISXQXPVKVLYDVMXRWDFUGAXEXQVPVBXRWHEUGXTVBVQV
        RVSVT $.

      $( The morphism part of arrow composition.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      coa2 $p |- ( ph -> ( 2nd ` ( G .x. F ) ) =
        ( ( 2nd ` G ) ( <. X , Y >. .xb Z ) ( 2nd ` F ) ) ) $=
        ( co c2nd cfv cop cvv cotp coaval fveq2d wcel wceq ot3rdg ax-mp syl6eq
        ovex ) AFEDPZQRHJFQRZEQRZHISJCPZPZUAZQRZUNAUJUOQABCDEFGHIJKLMNOUBUCUNTU
        DUPUNUEUKULUMUIHJUNTUFUGUH $.
    $}

    $( The composition of two composable arrows is an arrow.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    coahom $p |- ( ph -> ( G .x. F ) e. ( X H Z ) ) $=
      ( co c2nd cfv eqid wcel syl wa cop cco cotp coaval cbs chom ccat homarcl2
      homarcl simpld simprd homahom catcocl elhomai2 eqeltrd ) AEDCNGIEOPZDOPZG
      HUAIBUBPZNNZUCGIFNABURCDEFGHIJKLMURQZUDABUEPZBUSFBUFPZGIKVAQZADGHFNRZBUGR
      LBDFGHKUISZVBQZAGVARZHVARZAVDVGVHTLVABDFGHKVCUHSZUJZAVHIVARZAEHIFNRZVHVKT
      MVABEFHIKVCUHSUKZAVABURUQUPVBGHIVCVFUTVEVJAVGVHVIUKVMAVDUQGHVBNRLBDFVBGHK
      VFULSAVLUPHIVBNRMBEFVBHIKVFULSUMUNUO $.
  $}

  ${
    $d f g h z A $.  $d f g h C $.  $d z .x. $.
    coapm.o $e |- .x. = ( compA ` C ) $.
    coapm.a $e |- A = ( Arrow ` C ) $.
    $( Composition of arrows is a partial binary operation on arrows.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    coapm $p |- .x. e. ( A ^pm ( A X. A ) ) $=
      ( vz vg vf vh co wcel cv cfv ccoda cdoma wceq c2nd cop eqid syl wral wfun
      cxp cpm cdm wss wfn crab cco cotp coafval mpt2fun funfn mpbi c1st dmcoass
      wf sseli 1st2nd2 fveq2d df-ov syl6eqr choma homarw wbr w3a eqeltrrd df-br
      id sylibr eldmcoa sylib simp1d arwhoma simp3d oveq2d simp2d coahom sseldi
      eleqtrd eqeltrd rgen ffnfv mpbir2an carw cvv fvex eqeltri xpex elpm2 ) CA
      AAUCZUDJKCUEZACUQZWLWKUFWMCWLUGZFLZCMZAKZFWLUACUBWNGHAILNMGLZOMZPIAUHHLZO
      MZWRNMZWRQMWTQMXAWSRXBBUIMZJJUJCABXCCHGIDEXCSUKULCUMUNWQFWLWOWLKZWPWOUOMZ
      WOQMZCJZAXDWPXEXFRZCMXGXDWOXHCXDWOWKKWOXHPWLWKWOABCDEUPZURWOAAUSTZUTXEXFC
      VAVBXDXFOMZXENMZBVCMZJAXGABXMXKXLEXMSZVDXDBCXFXEXMXKXEOMZXLDXNXDXFXKXFNMZ
      XMJZXKXOXMJXDXFAKZXFXQKXDXRXEAKZXPXOPZXDXEXFWLVEZXRXSXTVFXDXHWLKYAXDWOXHW
      LXJXDVIVGXEXFWLVHVJABCXFXEDEVKVLZVMABXFXMEXNVNTXDXPXOXKXMXDXRXSXTYBVOVPVT
      XDXSXEXOXLXMJKXDXRXSXTYBVQABXEXMEXNVNTVRVSWAWBFWLACWCWDXIAWKCABWEMWFEBWEW
      GWHZAAYCYCWIWJWD $.
  $}

  ${
    arwlid.h $e |- H = ( HomA ` C ) $.
    arwlid.o $e |- .x. = ( compA ` C ) $.
    arwlid.a $e |- .1. = ( IdA ` C ) $.
    arwlid.f $e |- ( ph -> F e. ( X H Y ) ) $.
    $( Left identity of a category using arrow notation.  (Contributed by Mario
       Carneiro, 11-Jan-2017.) $)
    arwlid $p |- ( ph -> ( ( .1. ` Y ) .x. F ) = F ) $=
      ( cfv c2nd cop co cotp eqid wcel syl cco ccid cbs homarcl homarcl2 simprd
      ccat wa ida2 oveq1d chom simpld homahom catlid eqtrd oteq3d idahom coaval
      wceq homadmcd 3eqtr4d ) AGHHDMZNMZENMZGHOHBUAMZPZPZQGHVDQZVBECPEAVGVDGHAV
      GHBUBMZMZVDVFPVDAVCVJVDVFABUCMZBVIDHKVKRZAEGHFPSZBUGSLBEFGHIUDTZVIRZAGVKS
      ZHVKSZAVMVPVQUHLVKBEFGHIVLUETZUFZUIUJAVKBVEVIVDBUKMZGHVLVTRZVOVNAVPVQVRUL
      VERZVSAVMVDGHVTPSLBEFVTGHIWAUMTUNUOUPABVECEVBFGHHJILAVKBFDHKVLVNVSIUQWBUR
      AVMEVHUSLBEFGHIUTTVA $.

    $( Right identity of a category using arrow notation.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    arwrid $p |- ( ph -> ( F .x. ( .1. ` X ) ) = F ) $=
      ( c2nd cfv cop co cotp eqid wcel syl cco ccid cbs homarcl homarcl2 simpld
      ccat wa ida2 oveq2d chom simprd homahom catrid eqtrd oteq3d idahom coaval
      wceq homadmcd 3eqtr4d ) AGHEMNZGDNZMNZGGOHBUANZPZPZQGHVBQZEVCCPEAVGVBGHAV
      GVBGBUBNZNZVFPVBAVDVJVBVFABUCNZBVIDGKVKRZAEGHFPSZBUGSLBEFGHIUDTZVIRZAGVKS
      ZHVKSZAVMVPVQUHLVKBEFGHIVLUETZUFZUIUJAVKBVEVIVBBUKNZGHVLVTRZVOVNVSVERZAVP
      VQVRULAVMVBGHVTPSLBEFVTGHIWAUMTUNUOUPABVECVCEFGGHJIAVKBFDGKVLVNVSIUQLWBUR
      AVMEVHUSLBEFGHIUTTVA $.

    arwass.g $e |- ( ph -> G e. ( Y H Z ) ) $.
    arwass.k $e |- ( ph -> K e. ( Z H W ) ) $.
    $( Associativity of composition in a category using arrow notation.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    arwass $p |- ( ph -> ( ( K .x. G ) .x. F ) = ( K .x. ( G .x. F ) ) ) $=
      ( co wcel c2nd cfv cop cco cotp cbs chom eqid homarcl syl homarcl2 simpld
      ccat wa simprd homahom catass oveq1d oveq2d 3eqtr4d oteq3d coahom coaval
      coa2 ) AJIHFCSZUAUBZEUAUBZJKUCZIBUDUBZSZSZUEJIHUAUBZFECSZUAUBZJLUCIVISZSZ
      UEVEECSHVMCSAVKVPJIAVLFUAUBZKLUCIVISSZVGVJSVLVQVGVHLVISSZVOSVKVPABUFUBZBV
      IVGVQBUGUBZVLIJKLVTUHZWAUHZVIUHZAEJKGSTZBUMTPBEGJKMUIUJAJVTTZKVTTZAWEWFWG
      UNPVTBEGJKMWBUKUJZULAWFWGWHUOALVTTZIVTTZAHLIGSTZWIWJUNRVTBHGLIMWBUKUJZULA
      WEVGJKWASTPBEGWAJKMWCUPUJAFKLGSTVQKLWASTQBFGWAKLMWCUPUJAWIWJWLUOAWKVLLIWA
      STRBHGWALIMWCUPUJUQAVFVRVGVJABVICFHGKLINMQRWDVDURAVNVSVLVOABVICEFGJKLNMPQ
      WDVDUSUTVAABVICEVEGJKINMPABCFHGKLINMQRVBWDVCABVICVMHGJLINMABCEFGJKLNMPQVB
      RWDVCUT $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Examples of categories
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   The category of sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SetCat $.

  $( Extend class notation to include the category Set. $)
  csetc $a class SetCat $.

  ${
    $d f g u v x y z $.
    $( Definition of the category Set, relativized to a subset ` u ` .  This is
       the category of all sets in ` u ` and functions between these sets.
       Generally, we will take ` u ` to be a weak universe or Grothendieck's
       universe, because these sets have closure properties as good as the real
       thing.  (Contributed by FL, 8-Nov-2013.)  (Revised by Mario Carneiro,
       3-Jan-2017.) $)
    df-setc $a |- SetCat = ( u e. _V |-> { <. ( Base ` ndx ) , u >. ,
     <. ( Hom ` ndx ) , ( x e. u , y e. u |-> ( y ^m x ) ) >. ,
     <. ( comp ` ndx ) , ( v e. ( u X. u ) , z e. u |->
      ( g e. ( z ^m ( 2nd ` v ) ) , f e. ( ( 2nd ` v ) ^m ( 1st ` v ) ) |->
        ( g o. f ) ) ) >. } ) $.
  $}

  ${
    $d f g u v x y z $.  $d u v x y z ph $.  $d u v x y z U $.  $d u .x. $.
    $d u H $.
    setcval.c $e |- C = ( SetCat ` U ) $.
    setcval.u $e |- ( ph -> U e. V ) $.
    setcval.h $e |- ( ph -> H = ( x e. U , y e. U |-> ( y ^m x ) ) ) $.
    setcval.o $e |- ( ph -> .x. = ( v e. ( U X. U ) , z e. U |->
      ( g e. ( z ^m ( 2nd ` v ) ) , f e. ( ( 2nd ` v ) ^m ( 1st ` v ) ) |->
        ( g o. f ) ) ) ) $.
    $( Value of the category of sets (in a universe).  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    setcval $p |- ( ph -> C = { <. ( Base ` ndx ) , U >. ,
      <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .x. >. } ) $=
      ( cfv cop cv cmpt2 csetc cnx cbs chom cco ctp cmap cxp c2nd c1st ccom cvv
      vu co cmpt wceq df-setc a1i simpr opeq2d eqidd mpt2eq123dv adantr xpeq12d
      wa eqtr4d tpeq123d wcel elex syl tpex fvmptd syl5eq ) AFHUAQUBUCQZHRZUBUD
      QZKRZUBUEQZGRZUFZMAUMHVNUMSZRZVPBCWAWACSBSUGUNZTZRZVREDWAWAUHZWAJIDSESZUI
      QZUGUNWHWGUJQUGUNJSISUKTZTZRZUFZVTULUAULUAUMULWLUOUPABCDEUMIJUQURAWAHUPZV
      EZWBVOWEVQWKVSWNWAHVNAWMUSZUTWNWDKVPWNWDBCHHWCTZKWNBCWAWAWCHHWCWOWOWNWCVA
      VBAKWPUPWMOVCVFUTWNWJGVRWNWJEDHHUHZHWITZGWNEDWFWAWIWQHWIWNWAHWAHWOWOVDWOW
      NWIVAVBAGWRUPWMPVCVFUTVGAHLVHHULVHNHLVIVJVTULVHAVOVQVSVKURVLVM $.
  $}

  ${
    $d f g F $.  $d f g v x y z ph $.  $d f g v x y z X $.  $d f g v x y z Y $.
    $d f g G $.  $d v x y z U $.  $d f g v z Z $.
    setcbas.c $e |- C = ( SetCat ` U ) $.
    setcbas.u $e |- ( ph -> U e. V ) $.
    $( Set of objects of the category of sets (in a universe).  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    setcbas $p |- ( ph -> U = ( Base ` C ) ) $=
      ( vx vy vv vz vg vf cnx cbs cfv cop cv cmap co cmpt2 chom cco cxp c2nd c1
      c1st ccom ctp wcel wceq cdc catstr baseid snsstp1 strfv syl eqidd setcval
      c5 fveq2d eqtr4d ) ACMNOCPZMUAOGHCCHQGQRSTZPZMUBOIJCCUCCKLJQIQZUDOZRSVFVE
      UFORSKQLQUGTTZPZUHZNOZBNOACDUICVJUJFCVINDUEUEUSUKPVGCVCULUMVBVDVHUNUOUPAB
      VINAGHJIBVGCLKVCDEFAVCUQAVGUQURUTVA $.

    ${
      setchomfval.h $e |- H = ( Hom ` C ) $.
      $( Set of arrows of the category of sets (in a universe).  (Contributed
         by Mario Carneiro, 3-Jan-2017.) $)
      setchomfval $p |- ( ph -> H = ( x e. U , y e. U |-> ( y ^m x ) ) ) $=
        ( vv vz vg vf cv cmap co cmpt2 cfv cop cnx cbs chom cco cxp c2nd ctp c1
        c1st ccom cvv c5 cdc eqidd setcval catstr snsstp2 wcel mpt2exga syl2anc
        homid strfv3 ) AFBCEECOBOPQZRZUAUBSETZUAUCSVDTZUAUDSKLEEUEEMNLOKOZUFSZP
        QVHVGUISPQMONOUJRRZTZUGDUCUKUHUHULUMTABCLKDVIENMVDGHIAVDUNAVIUNUOVIEVDU
        PVAVEVFVJUQAEGURZVKVDUKURIIBCEEVCGGUSUTJVB $.

      setchom.x $e |- ( ph -> X e. U ) $.
      setchom.y $e |- ( ph -> Y e. U ) $.
      $( Set of arrows of the category of sets (in a universe).  (Contributed
         by Mario Carneiro, 3-Jan-2017.) $)
      setchom $p |- ( ph -> ( X H Y ) = ( Y ^m X ) ) $=
        ( vx vy cv cmap co cvv wceq wa setchomfval simprr oveq12d wcel ovex a1i
        simprl ovmpt2d ) AMNFGCCNOZMOZPQGFPQZDRAMNBCDEHIJUAAUJFSZUIGSZTTUIGUJFP
        AULUMUBAULUMUGUCKLUKRUDAGFPUEUFUH $.

      $( A morphism of sets is a function.  (Contributed by Mario Carneiro,
         3-Jan-2017.) $)
      elsetchom $p |- ( ph -> ( F e. ( X H Y ) <-> F : X --> Y ) ) $=
        ( co wcel cmap wf setchom eleq2d wb elmapg syl2anc bitrd ) ADGHENZODHGP
        NZOZGHDQZAUDUEDABCEFGHIJKLMRSAHCOGCOUFUGTMLHGDCCUAUBUC $.
    $}

    ${
      setcco.o $e |- .x. = ( comp ` C ) $.
      $( Composition in the category of sets.  (Contributed by Mario Carneiro,
         3-Jan-2017.) $)
      setccofval $p |- ( ph -> .x. = ( v e. ( U X. U ) , z e. U |->
      ( g e. ( z ^m ( 2nd ` v ) ) , f e. ( ( 2nd ` v ) ^m ( 1st ` v ) ) |->
        ( g o. f ) ) ) ) $=
        ( vx vy cv cfv cnx cop cvv wcel cxp c2nd cmap co c1st ccom cbs chom cco
        cmpt2 ctp c1 c5 cdc eqid setchomfval eqidd setcval catstr ccoid snsstp3
        xpexg syl2anc mpt2exga strfv3 ) AECBFFUAZFHGBOCOZUBPZUCUDVHVGUEPUCUDHOG
        OUFUJZUJZQUGPFRZQUHPDUHPZRZQUIPVJRZUKDUISULULUMUNRAMNBCDVJFGHVLIJKAMNDF
        VLIJKVLUOUPAVJUQURVJFVLUSUTVKVMVNVAAVFSTZFITZVJSTAVPVPVOKKFFIIVBVCKCBVF
        FVISIVDVCLVE $.

      setcco.x $e |- ( ph -> X e. U ) $.
      setcco.y $e |- ( ph -> Y e. U ) $.
      setcco.z $e |- ( ph -> Z e. U ) $.
      setcco.f $e |- ( ph -> F : X --> Y ) $.
      setcco.g $e |- ( ph -> G : Y --> Z ) $.
      $( Composition in the category of sets.  (Contributed by Mario Carneiro,
         3-Jan-2017.) $)
      setcco $p |- ( ph -> ( G ( <. X , Y >. .x. Z ) F ) = ( G o. F ) ) $=
        ( cmap wcel vg vf vv vz co cv ccom cop cvv cxp c2nd cfv c1st setccofval
        cmpt2 wceq wa simprr simprl fveq2d op2ndg syl2anc adantr oveq12d op1stg
        eqtrd eqidd mpt2eq123dv opelxpi mpt2ex a1i ovmpt2d coeq12d wf wb elmapg
        ovex mpbird coexg ) AUAUBFEJISUEZIHSUEZUAUFZUBUFZUGZFEUGZHIUHZJCUEUIAUC
        UDWFJDDUJZDUAUBUDUFZUCUFZUKULZSUEZWJWIUMULZSUEZWDUOUAUBVTWAWDUOZCUIAUDU
        CBCDUBUAGKLMUNAWIWFUPZWHJUPZUQZUQZUAUBWKWMWDVTWAWDWRWHJWJISAWOWPURWRWJW
        FUKULZIWRWIWFUKAWOWPUSZUTAWSIUPZWQAHDTZIDTZXANOHIDDVAVBVCVFZVDWRWJIWLHS
        XDWRWLWFUMULZHWRWIWFUMWTUTAXEHUPZWQAXBXCXFNOHIDDVEVBVCVFVDWRWDVGVHAXBXC
        WFWGTNOHIDDVIVBPWNUITAUAUBVTWAWDJISVQIHSVQVJVKVLAWBFUPZWCEUPZUQUQWBFWCE
        AXGXHUSAXGXHURVMAFVTTZIJFVNZRAJDTXCXIXJVOPOJIFDDVPVBVRZAEWATZHIEVNZQAXC
        XBXLXMVOONIHEDDVPVBVRZAXIXLWEUITXKXNFEVTWAVSVBVL $.
    $}
  $}

  ${
    $d f g h w x y z C $.  $d f g h w x y z U $.  $d f g h w x y z V $.
    $d x ph $.  $d x X $.
    setccat.c $e |- C = ( SetCat ` U ) $.
    $( Lemma for ~ setccat .  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    setccatid $p |- ( U e. V ->
      ( C e. Cat /\ ( Id ` C ) = ( x e. U |-> ( _I |` x ) ) ) ) $=
      ( vw vy vz wcel cv wa cfv co cvv wf elsetchom cop ccom mpbid setcco vf vg
      vh chom w3a cco cid cres id setcbas eqidd fvex eqeltri a1i biid wf1o f1oi
      csetc f1of mp1i simpl eqid simpr mpbird simpr1l simpr1r simpr31 fcoi2 syl
      eqtrd simpr2l simpr32 fcoi1 syl2anc eqeltrd coass simpr2r simpr33 3eqtr4a
      wceq fco oveq1d oveq2d 3eqtr4d iscatd2 ) CDIZFJZCIZAJZCIZKZGJZCIZHJZCIZKZ
      UAJZWGWIBUDLZMIZUBJZWIWLWRMIZUCJZWLWNWRMIZUEZUEZFAGHCBBUFLZUGWIUHZUAUBUCW
      RNWFBCDEWFUIUJWFWRUKWFXFUKBNIWFBCURLNECURULUMUNXEUOWFWJKZXGWIWIWRMIWIWIXG
      OZWIWIXGUPZXIXHWIUQZWIWIXGUSZUTXHBCXGWRDWIWIEWFWJVAWRVBZWFWJVCZXNPVDWFXEK
      ZXGWQWGWIQZWIXFMMXGWQRZWQXOBXFCWQXGDWGWIWIEWFXEVAZXFVBZWHWJWPXDWFVEZWHWJW
      PXDWFVFZYAXOWSWGWIWQOZWSXAXCWKWPWFVGXOBCWQWRDWGWIEXRXMXTYAPSZXJXIXOXKXLUT
      ZTXOYBXQWQVTYCWGWIWQVHVIVJXOWTXGWIWIQWLXFMMWTXGRZWTXOBXFCXGWTDWIWIWLEXRXS
      YAYAWMWOWKXDWFVKZYDXOXAWIWLWTOZWSXAXCWKWPWFVLXOBCWTWRDWIWLEXRXMYAYFPSZTXO
      YGYEWTVTYHWIWLWTVMVIVJXOWTWQXPWLXFMMZWTWQRZWGWLWRMZXOBXFCWQWTDWGWIWLEXRXS
      XTYAYFYCYHTZXOYJYKIWGWLYJOZXOYGYBYMYHYCWGWIWLWTWQWAVNZXOBCYJWRDWGWLEXRXMX
      TYFPVDVOXOXBWTRZWQXPWNXFMZMZXBYJWGWLQWNXFMZMZXBWTWIWLQWNXFMMZWQYPMXBYIYRM
      XOYOWQRXBYJRYQYSXBWTWQVPXOBXFCWQYODWGWIWNEXRXSXTYAWMWOWKXDWFVQZYCXOWLWNXB
      OZYGWIWNYOOXOXCUUBWSXAXCWKWPWFVRXOBCXBWRDWLWNEXRXMYFUUAPSZYHWIWLWNXBWTWAV
      NTXOBXFCYJXBDWGWLWNEXRXSXTYFUUAYNUUCTVSXOYTYOWQYPXOBXFCWTXBDWIWLWNEXRXSYA
      YFUUAYHUUCTWBXOYIYJXBYRYLWCWDWE $.

    $( The category of sets is a category.  (Contributed by Mario Carneiro,
       3-Jan-2017.) $)
    setccat $p |- ( U e. V -> C e. Cat ) $=
      ( vx wcel ccat ccid cfv cid cv cres cmpt wceq setccatid simpld ) BCFAGFAH
      IEBJEKLMNEABCDOP $.

    setcid.o $e |- .1. = ( Id ` C ) $.
    setcid.u $e |- ( ph -> U e. V ) $.
    setcid.x $e |- ( ph -> X e. U ) $.
    $( The identity arrow in the category of sets is the identity function.
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    setcid $p |- ( ph -> ( .1. ` X ) = ( _I |` X ) ) $=
      ( vx cid cv cres cvv ccid wcel wceq wa syl cfv cmpt ccat setccatid simprd
      syl5eq simpr reseq2d resiexg fvmptd ) AKFLKMZNZLFNZCDOADBPUAZKCULUBZHABUC
      QZUNUORZACEQUPUQSIKBCEGUDTUEUFAUKFRZSUKFLAURUGUHJAFCQUMOQJFCUITUJ $.
  $}

  ${
    $d x E $.  $d a g h x y z F $.  $d x y M $.  $d g h U $.  $d g h x y z X $.
    $d g h z C $.  $d g h x y z ph $.  $d a g h x y z Y $.
    setcmon.c $e |- C = ( SetCat ` U ) $.
    setcmon.u $e |- ( ph -> U e. V ) $.
    setcmon.x $e |- ( ph -> X e. U ) $.
    setcmon.y $e |- ( ph -> Y e. U ) $.
    ${
      setcmon.h $e |- M = ( Mono ` C ) $.
      $( A monomorphism of sets is an injection.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      setcmon $p |- ( ph -> ( F e. ( X M Y ) <-> F : X -1-1-> Y ) ) $=
        ( co wcel wa cfv wceq syl ad2antrr vx vy vg vz vh wf1 wf cv wi wral cbs
        chom eqid setccat setcbas eleqtrd monhom sselda elsetchom biimpa syldan
        cco ccat csn cxp cop ccom simprr xpeq2d wfn adantr ffn simprll fcoconst
        sneqd syl2anc simprlr 3eqtr4d fconst6g setcco simplr mpbird moni fveq1d
        mpbid vex fvconst2 3eqtr3d ralrimivva dff13 sylanbrc f1f biimpar sylan2
        eleq2d simprl simprrl ad2antlr simprrr eqeq12d wb cocan1 syl3anc biimpd
        expr sylbid anassrs ex sylbird ralrimiv ismon2 mpbir2and impbida ) ADGH
        ENZOZGHDUFZAXOPZGHDUGZUAUHZDQZUBUHZDQZRZXSYARZUIZUBGUJUAGUJXPAXODGHBULQ
        ZNZOZXRAXNYGDABUKQZBBVBQZYFEGHYIUMZYFUMZYJUMZMACFOZBVCOZJBCFIUNSZAGCYIK
        ABCFIJUOZUPZAHCYILYQUPZUQURAYHXRABCDYFFGHIJYLKLUSZUTVAZXQYEUAUBGGXQXSGO
        ZYAGOZPZYCYDXQUUDYCPZPZXSGXSVDVEZQZXSGYAVDVEZQZXSYAUUFXSUUGUUIUUFDUUGGG
        VFHYJNZNZDUUIUUKNZRUUGUUIRUUFDUUGVGZDUUIVGZUULUUMUUFGXTVDZVEZGYBVDZVEZU
        UNUUOUUFUUPUURGUUFXTYBXQUUDYCVHVOVIUUFDGVJZUUBUUNUUQRUUFXRUUTXQXRUUEUUA
        VKZGHDVLSZXQUUBUUCYCVMZDGGXSVNVPUUFUUTUUCUUOUUSRUVBXQUUBUUCYCVQZDGGYAVN
        VPVRUUFBYJCUUGDFGGHIAYNXOUUEJTZYMAGCOZXOUUEKTZUVGAHCOZXOUUELTZUUFUUBGGU
        UGUGZUVCGXSGVSSZUVAVTUUFBYJCUUIDFGGHIUVEYMUVGUVGUVIUUFUUCGGUUIUGZUVDGYA
        GVSSZUVAVTVRUUFYIBYJDUUGYFUUIEGHGYKYLYMMAYOXOUUEYPTAGYIOXOUUEYRTZAHYIOX
        OUUEYSTUVNAXOUUEWAUUFUUGGGYFNZOUVJUVKUUFBCUUGYFFGGIUVEYLUVGUVGUSWBUUFUU
        IUVOOUVLUVMUUFBCUUIYFFGGIUVEYLUVGUVGUSWBWCWEWDUUFUUBUUHXSRUVCGXSXSUAWFW
        GSUUFUUBUUJYARUVCGYAXSUBWFWGSWHXEWIUAUBGHDWJWKAXPPZXOYHDUCUHZUDUHZGVFHY
        JNZNZDUEUHZUVSNZRZUVQUWARZUIZUEUVRGYFNZUJUCUWFUJZUDYIUJZXPAXRYHGHDWLZAY
        HXRYTWMWNUVPUWGUDYIUVPUVRYIOUVRCOZUWGUVPCYIUVRACYIRXPYQVKWOUVPUWJUWGUVP
        UWJPUWEUCUEUWFUWFUVPUWJUVQUWFOZUWAUWFOZPZUWEUVPUWJUWMPZPZUWCDUVQVGZDUWA
        VGZRZUWDUWOUVTUWPUWBUWQUWOBYJCUVQDFUVRGHIAYNXPUWNJTZYMUVPUWJUWMWPZAUVFX
        PUWNKTZAUVHXPUWNLTZUWOUWKUVRGUVQUGZUVPUWJUWKUWLWQUWOBCUVQYFFUVRGIUWSYLU
        WTUXAUSWEZXPXRAUWNUWIWRZVTUWOBYJCUWADFUVRGHIUWSYMUWTUXAUXBUWOUWLUVRGUWA
        UGZUVPUWJUWKUWLWSUWOBCUWAYFFUVRGIUWSYLUWTUXAUSWEZUXEVTWTUWOUWRUWDUWOXPU
        XCUXFUWRUWDXAAXPUWNWAUXDUXGUVRGHDUVQUWAXBXCXDXFXGWIXHXIXJAXOYHUWHPXAXPA
        UDYIBYJUCUEDYFEGHYKYLYMMYPYRYSXKVKXLXM $.
    $}

    ${
      setcepi.h $e |- E = ( Epi ` C ) $.
      setcepi.2 $e |- ( ph -> 2o e. U ) $.
      $( An epimorphism of sets is a surjection.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      setcepi $p |- ( ph -> ( F e. ( X E Y ) <-> F : X -onto-> Y ) ) $=
        ( va wcel wceq c1o c0 c2o vx vg vz vh co wfo wa wf crn chom cfv cbs cco
        eqid ccat setccat setcbas eleqtrd epihom sselda elsetchom biimpa syldan
        syl wss frn cv wral cif cmpt csn cxp cop ccom wfn fnfvelrn sylan iftrue
        ffn mpteq2dva ffvelrnda feqmptd eqidd eleq1 ifbid fconstmpt a1i 3eqtr4d
        fmptco adantr cpr com elexi prid2 df2o3 eleqtrri 0ex prid1 keepel fmpti
        1onn setcco fconst6g mp1i simpr mpbird epii mpbid syl6eq wb rgenw ax-mp
        mpteqb sylib 1n0 nesymi iffalse eqeq1d mtbiri con4i ralimi dfss3 sylibr
        eqssd dffo2 sylanbrc fof adantl biimpar eleq2d ad2antrr simprrl simprrr
        wn wi simprl eqeq12d simplr cocan2 syl3anc biimpd anassrs ralrimivva ex
        sylbid sylbird ralrimiv isepi2 mpbir2and impbida ) AEGHDUEZPZGHEUFZAUUL
        UGZGHEUHZEUIZHQUUMAUULEGHBUJUKZUEZPZUUOAUUKUUREABULUKZBBUMUKZDUUQGHUUTU
        NZUUQUNZUVAUNZMACFPZBUOPZJBCFIUPVDZAGCUUTKABCFIJUQZURZAHCUUTLUVHURZUSUT
        AUUSUUOABCEUUQFGHIJUVCKLVAZVBVCZUUNUUPHUUNUUOUUPHVEUVLGHEVFVDUUNOVGZUUP
        PZOHVHZHUUPVEUUNUVNRSVIZRQZOHVHZUVOUUNOHUVPVJZOHRVJZQZUVRUUNUVSHRVKVLZU
        VTUUNUVSEGHVMZTUVAUEZUEZUWBEUWDUEZQUVSUWBQUUNUVSEVNZUWBEVNZUWEUWFUUNUAG
        UAVGZEUKZUUPPZRSVIZVJUAGRVJUWGUWHUUNUAGUWLRUUNUWIGPZUGUWKUWLRQUUNEGVOZU
        WMUWKUUNUUOUWNUVLGHEVSVDGUWIEVPVQUWKRSVRVDVTUUNUAOGHUWJUVPUWLEUVSUUNGHU
        WIEUVLWAZUUNUAGHEUVLWBZUUNUVSWCUVMUWJQZUVNUWKRSUVMUWJUUPWDWEWIUUNUAOGHU
        WJRREUWBUWOUWPUWBUVTQUUNOHRWFZWGUWQRWCWIWHUUNBUVACEUVSFGHTIAUVEUULJWJZU
        VDAGCPZUULKWJZAHCPZUULLWJZATCPUULNWJZUVLHTUVSUHZUUNOHTUVPUVSUVSUNUVPTPZ
        UVMHPUVNRSTRSRWKZTSRRWLXAWMWNWOWPZSUXGTSRWQWRWOWPWSZWGWTWGZXBUUNBUVACEU
        WBFGHTIUWSUVDUXAUXCUXDUVLRTPHTUWBUHZUUNUXHHRTXCXDZXBWHUUNUUTBUVADEUVSUU
        QUWBGHTUVBUVCUVDMAUVFUULUVGWJAGUUTPUULUVIWJAHUUTPUULUVJWJATUUTPUULATCUU
        TNUVHURWJAUULXEUUNUVSHTUUQUEZPUXEUXJUUNBCUVSUUQFHTIUWSUVCUXCUXDVAXFUUNU
        WBUXMPUXKUXLUUNBCUWBUUQFHTIUWSUVCUXCUXDVAXFXGXHUWRXIUXFOHVHUWAUVRXJUXFO
        HUXIXKOHUVPRTXMXLXNUVQUVNOHUVNUVQUVNYNZUVQSRQRSXOXPUXNUVPSRUVNRSXQXRXSX
        TYAVDOHUUPYBYCYDGHEYEYFAUUMUGZUULUUSUBVGZEUWCUCVGZUVAUEZUEZUDVGZEUXRUEZ
        QZUXPUXTQZYOZUDHUXQUUQUEZVHUBUYEVHZUCUUTVHZAUUMUUOUUSUUMUUOAGHEYGYHZAUU
        SUUOUVKYIVCUXOUYFUCUUTUXOUXQUUTPUXQCPZUYFUXOCUUTUXQACUUTQUUMUVHWJYJUXOU
        YIUYFUXOUYIUGUYDUBUDUYEUYEUXOUYIUXPUYEPZUXTUYEPZUGZUYDUXOUYIUYLUGZUGZUY
        BUXPEVNZUXTEVNZQZUYCUYNUXSUYOUYAUYPUYNBUVACEUXPFGHUXQIAUVEUUMUYMJYKZUVD
        AUWTUUMUYMKYKZAUXBUUMUYMLYKZUXOUYIUYLYPZUXOUUOUYMUYHWJZUYNUYJHUXQUXPUHZ
        UXOUYIUYJUYKYLUYNBCUXPUUQFHUXQIUYRUVCUYTVUAVAXHZXBUYNBUVACEUXTFGHUXQIUY
        RUVDUYSUYTVUAVUBUYNUYKHUXQUXTUHZUXOUYIUYJUYKYMUYNBCUXTUUQFHUXQIUYRUVCUY
        TVUAVAXHZXBYQUYNUYQUYCUYNUUMUXPHVOZUXTHVOZUYQUYCXJAUUMUYMYRUYNVUCVUGVUD
        HUXQUXPVSVDUYNVUEVUHVUFHUXQUXTVSVDGHEUXPUXTYSYTUUAUUEUUBUUCUUDUUFUUGAUU
        LUUSUYGUGXJUUMAUCUUTBUVAUBUDDEUUQGHUVBUVCUVDMUVGUVIUVJUUHWJUUIUUJ $.
    $}

    ${
      setcsect.n $e |- S = ( Sect ` C ) $.
      $( A section in the category of sets, written out.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      setcsect $p |- ( ph -> ( F ( X S Y ) G <->
        ( F : X --> Y /\ G : Y --> X /\ ( G o. F ) = ( _I |` X ) ) ) ) $=
        ( co cfv wcel eqid wa adantr wbr chom cop cco ccid wceq w3a wf ccom cid
        cres cbs setccat setcbas eleqtrd issect elsetchom anbi12d anbi1d simprl
        ccat syl simprr setcco setcid eqeq12d pm5.32da bitrd df-3an 3bitr4g ) A
        EFHICOUAEHIBUBPZOQZFIHVKOQZFEHIUCHBUDPZOOZHBUEPZPZUFZUGZHIEUHZIHFUHZFEU
        IZUJHUKZUFZUGZABULPZBCVNVPEFVKHIWFRVKRZVNRZVPRZNADGQZBVAQKBDGJUMVBAHDWF
        LABDGJKUNZUOAIDWFMWKUOUPAVLVMSZVRSZVTWASZWDSZVSWEAWMWNVRSWOAWLWNVRAVLVT
        VMWAABDEVKGHIJKWGLMUQABDFVKGIHJKWGMLUQURUSAWNVRWDAWNSZVOWBVQWCWPBVNDEFG
        HIHJAWJWNKTWHAHDQWNLTZAIDQWNMTWQAVTWAUTAVTWAVCVDAVQWCUFWNABDVPGHJWIKLVE
        TVFVGVHVLVMVRVIVTWAWDVIVJVH $.
    $}

    ${
      setcinv.n $e |- N = ( Inv ` C ) $.
      $( An inverse in the category of sets is the converse operation.
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      setcinv $p |- ( ph ->
        ( F ( X N Y ) G <-> ( F : X -1-1-onto-> Y /\ G = `' F ) ) ) $=
        ( co wbr wa ccom wceq ad2antrl csect cfv wf cid cres wf1o ccnv cbs eqid
        wcel ccat setccat syl setcbas eleqtrd isinv w3a setcsect df-3an 3ancoma
        syl6bb bitri anbi12d anandi syl6bbr fcof1o anbi2i ancom2s adantl f1ocnv
        eqcom sylib f1oeq1 ad2antll mpbird simprr coeq1d f1ococnv1 eqtrd coeq2d
        f1of wb f1ococnv2 jca jca31 impbida 3bitrd ) ADEHIFOPDEHIBUAUBZOPZEDIHW
        HOPZQZHIDUCZIHEUCZQZEDRZUDHUEZSZDERZUDIUEZSZQZQZHIDUFZEDUGZSZQZABUHUBZB
        WHDEFHIXGUINACGUJBUKUJKBCGJULUMAHCXGLABCGJKUNZUOAICXGMXHUOWHUIZUPAWKWNW
        QQZWNWTQZQXBAWIXJWJXKAWIWLWMWQUQXJABWHCDEGHIJKLMXIURWLWMWQUSVAAWJWMWLWT
        UQZXKABWHCEDGIHJKMLXIURXLWLWMWTUQXKWMWLWTUTWLWMWTUSVBVAVCWNWQWTVDVEAXBX
        FXBXFAWNWTWQXFWNWTWQQQXCXDESZQXFHIDEVFXMXEXCXDEVKVGVLVHVIAXFQZWLWMXAXCW
        LAXEHIDWATXNIHEUFZWMXNXOIHXDUFZXCXPAXEHIDVJTXEXOXPWBAXCIHEXDVMVNVOIHEWA
        UMXNWQWTXNWOXDDRZWPXNEXDDAXCXEVPZVQXCXQWPSAXEHIDVRTVSXNWRDXDRZWSXNEXDDX
        RVTXCXSWSSAXEHIDWCTVSWDWEWFWG $.
    $}

    ${
      setciso.n $e |- I = ( Iso ` C ) $.
      $( An isomorphism in the category of sets is a bijection.  (Contributed
         by Mario Carneiro, 3-Jan-2017.) $)
      setciso $p |- ( ph -> ( F e. ( X I Y ) <-> F : X -1-1-onto-> Y ) ) $=
        ( co wcel cfv eqid syl eleqtrd wbr cinv cdm wf1o setccat setcbas isoval
        cbs ccat eleq2d wfun wb invfun funfvbrb ccnv wceq setcinv syl6bi sylbid
        wa simpl wrel wi funrel releldm ex sylbird mpan2i impbid bitrd ) ADGHEN
        ZODGHBUAPZNZUBZOZGHDUCZAVJVMDABUGPZBEVKGHVPQZVKQZACFOBUHOJBCFIUDRZAGCVP
        KABCFIJUEZSZAHCVPLVTSZMUFUIAVNVOAVNDDVLPZVLTZVOAVLUJZVNWDUKAVPBVKGHVQVR
        VSWAWBULZDVLUMRAWDVOWCDUNZUOZUSVOABCDWCVKFGHIJKLVRUPVOWHUTUQURAVOWGWGUO
        ZVNWGQAVOWIUSDWGVLTZVNABCDWGVKFGHIJKLVRUPAVLVAZWJVNVBAWEWKWFVLVCRWKWJVN
        DWGVLVDVERVFVGVHVI $.
    $}
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z ph $.  $d f g x y z V $.
    $d f E $.
    resssetc.c $e |- C = ( SetCat ` U ) $.
    resssetc.d $e |- D = ( SetCat ` V ) $.
    resssetc.1 $e |- ( ph -> U e. W ) $.
    resssetc.2 $e |- ( ph -> V C_ U ) $.
    $( The restriction of the category of sets to a subset is the category of
       sets in the subset.  Thus, the ` SetCat `` U ` categories for different
       ` U ` are full subcategories of each other.  (Contributed by Mario
       Carneiro, 6-Jan-2017.) $)
    resssetc $p |- ( ph -> ( ( Homf ` ( C |`s V ) ) = ( Homf ` D ) /\
                             ( comf ` ( C |`s V ) ) = ( comf ` D ) ) ) $=
      ( vx vy co cfv wceq cv wral wcel cvv eqid vg vf vz cress chomf ccomf chom
      wa cmap adantr simprl simprr setchom wss sseldd resshom proplem3 3eqtr2rd
      ssexd syl ralrimivva cbs setcbas sseqtrd ressbas2 homfeq cop cco w3a ccom
      mpbird ad2antrr simplr1 simplr2 simplr3 wf elsetchom mpbid setcco 3eqtr2d
      ressco oveqd ralrimivvva eqcomd comfeq jca ) ABEUDMZUENZCUENZOZWGUFNZCUFN
      ZOAWJKPZLPZWGUGNZMZWMWNCUGNZMZOZLEQKEQAWSKLEEAWMERZWNERZUHZUHZWRWNWMUIMWM
      WNBUGNZMWPXCCEWQSWMWNHAESRZXBAEDFIJUSZUJWQTZAWTXAUKZAWTXAULZUMXCBDXDFWMWN
      GADFRZXBIUJXDTZXCEDWMAEDUNZXBJUJZXHUOXCEDWNXMXIUOUMAXBKLXDWOAXEXDWOOXFEBW
      GXDSWGTZXKUPUTUQURVAAKLEWGCWOWQWOTXGAEBVBNZUNEWGVBNOAEDXOJABDFGIVCVDEXOWG
      BXNXOTVEUTZACESHXFVCZVFVKZAWLWKAWLWKOUAPZUBPZWMWNVGZUCPZCVHNZMMZXSXTYAYBW
      GVHNZMZMZOZUAWNYBWQMZQUBWRQZUCEQLEQKEQAYJKLUCEEEAWTXAYBERZVIZUHZYHUBUAWRY
      IYMXTWRRZXSYIRZUHZUHZYDXSXTVJXSXTYAYBBVHNZMZMYGYQCYCEXTXSSWMWNYBHAXEYLYPX
      FVLZYCTZWTXAYKAYPVMZWTXAYKAYPVNZWTXAYKAYPVOZYQYNWMWNXTVPYMYNYOUKYQCEXTWQS
      WMWNHYTXGUUBUUCVQVRZYQYOWNYBXSVPYMYNYOULYQCEXSWQSWNYBHYTXGUUCUUDVQVRZVSYQ
      BYRDXTXSFWMWNYBGAXJYLYPIVLYRTZYQEDWMAXLYLYPJVLZUUBUOYQEDWNUUHUUCUOYQEDYBU
      UHUUDUOUUEUUFVSYQYSYFXSXTYQYRYEYAYBAYRYEOZYLYPAXEUUIXFEBWGYRSXNUUGWAUTVLW
      BWBVTVAWCAKLUCECWGYEYCUBUAWQUUAYETXGXQXPAWHWIXRWDWEVKWDWF $.

    $( A functor into a smaller category of sets is a functor into the larger
       category.  (Contributed by Mario Carneiro, 28-Jan-2017.) $)
    funcsetcres2 $p |- ( ph -> ( E Func D ) C_ ( E Func C ) ) $=
      ( cfunc co wcel chomf cfv ccat ccomf wceq eqid vf cv cxp cres cresc eqidd
      cress cbs setccat syl adantr wss setcbas sseqtrd fullresc simpld resssetc
      wa eqtr3d simprd funcrcl adantl fullsubc subccat funcpropd csubc funcres2
      eqsstr3d simpr sseldd ex ssrdv ) AUAECLMZEBLMZAUAUBZVMNZVOVNNAVPURZVMVNVO
      VQVMEBBOPZFFUCUDZUEMZLMZVNVQEEVTCQVQEOPUFVQERPUFVQBFUGMZOPZVTOPZCOPZVQWCW
      DSZWBRPZVTRPZSZVQBUHPZBWBFVTVRWJTZVRTZABQNZVPADGNWMJBDGHUIUJUKZAFWJULVPAF
      DWJKABDGHJUMUNUKZWBTVTTZUOZUPVQWCWESZWGCRPZSZAWRWTURVPABCDFGHIJKUQUKZUPUS
      VQWGWHWSVQWFWIWQUTVQWRWTXAUTUSVQEQNZCQNZVPXBXCURAECVOVAVBZUPZXEVQBVTVSWPV
      QWJBFVRWKWLWNWOVCZVDVQXBXCXDUTVEVQVSBVFPNWAVNULXFEBVSVGUJVHAVPVIVJVKVL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   The category of categories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CatCat $.

  $( Extend class notation to include the category Cat. $)
  ccatc $a class CatCat $.

  ${
    $d b f g u v x y z $.
    $( Definition of the category Cat, which consists of all categories in the
       universe ` u ` , with functors as the morphisms.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    df-catc $a |- CatCat = ( u e. _V |-> [_ ( u i^i Cat ) / b ]_
      { <. ( Base ` ndx ) , b >. ,
        <. ( Hom ` ndx ) , ( x e. b , y e. b |-> ( x Func y ) ) >. ,
        <. ( comp ` ndx ) , ( v e. ( b X. b ) , z e. b |->
          ( g e. ( ( 2nd ` v ) Func z ) , f e. ( Func ` v ) |->
            ( g o.func f ) ) ) >. } ) $.
  $}

  ${
    $d b u v x y z B $.  $d b u H $.  $d b u v x y z ph $.  $d b u v x y z U $.
    $d b f g u v x y z $.  $d b u .x. $.
    catcval.c $e |- C = ( CatCat ` U ) $.
    catcval.u $e |- ( ph -> U e. V ) $.
    catcval.b $e |- ( ph -> B = ( U i^i Cat ) ) $.
    catcval.h $e |- ( ph -> H = ( x e. B , y e. B |-> ( x Func y ) ) ) $.
    catcval.o $e |- ( ph -> .x. = ( v e. ( B X. B ) , z e. B |->
      ( g e. ( ( 2nd ` v ) Func z ) , f e. ( Func ` v ) |->
            ( g o.func f ) ) ) ) $.
    $( Value of the category of categories (in a universe).  (Contributed by
       Mario Carneiro, 3-Jan-2017.) $)
    catcval $p |- ( ph -> C = { <. ( Base ` ndx ) , B >. ,
      <. ( Hom ` ndx ) , H >. , <. ( comp ` ndx ) , .x. >. } ) $=
      ( cv cvv vu vb ccatc cfv cnx cbs cop chom cco ctp ccat cin cfunc co cmpt2
      cxp c2nd ccofu csb cmpt wceq df-catc a1i wa vex inex1 simpr ineq1d adantr
      wcel eqtr4d opeq2d mpt2eq123dv ad2antrr xpeq12d tpeq123d csbied2 elex syl
      eqidd tpex fvmptd syl5eq ) AGIUCUDUEUFUDZFUGZUEUHUDZLUGZUEUIUDZHUGZUJZNAU
      AIUBUASZUKULZWDUBSZUGZWFBCWMWMBSCSUMUNZUOZUGZWHEDWMWMUPZWMKJESZUQUDDSUMUN
      WSUMUDKSJSURUNUOZUOZUGZUJZUSZWJTUCTUCUATXDUTVAABCDEUAJKUBVBVCAWKIVAZVDZUB
      WLFXCWJTWLTVJXFWKUKUAVEVFVCXFWLIUKULZFXFWKIUKAXEVGVHAFXGVAXEPVIVKXFWMFVAZ
      VDZWNWEWQWGXBWIXIWMFWDXFXHVGZVLXIWPLWFXIWPBCFFWOUOZLXIBCWMWMWOFFWOXJXJXIW
      OVTVMALXKVAXEXHQVNVKVLXIXAHWHXIXAEDFFUPZFWTUOZHXIEDWRWMWTXLFWTXIWMFWMFXJX
      JVOXJXIWTVTVMAHXMVAXEXHRVNVKVLVPVQAIMVJITVJOIMVRVSWJTVJAWEWGWIWAVCWBWC $.
  $}

  ${
    $d v x y z B $.  $d f g v x y z ph $.  $d v x y z U $.  $d f g v x y z X $.
    $d f g F $.  $d f g G $.  $d f g v x y z Y $.  $d f g v z Z $.
    catcbas.c $e |- C = ( CatCat ` U ) $.
    catcbas.b $e |- B = ( Base ` C ) $.
    catcbas.u $e |- ( ph -> U e. V ) $.
    $( Set of objects of the category of categories.  (Contributed by Mario
       Carneiro, 3-Jan-2017.) $)
    catcbas $p |- ( ph -> B = ( U i^i Cat ) ) $=
      ( vx vy vv vz vg vf cnx cfv cop cv cfunc co ccat cin cbs chom cmpt2 ccofu
      cco cxp c2nd ctp cvv c1 c5 cdc eqidd catcval catstr baseid snsstp1 inex1g
      wcel syl strfv3 ) ABDUAUBZOUCPVDQZOUDPIJVDVDIRJRSTUEZQZOUGPKLVDVDUHVDMNKR
      ZUIPLRSTVHSPMRNRUFTUEUEZQZUJCUCUKULULUMUNQAIJLKVDCVIDNMVFEFHAVDUOAVFUOAVI
      UOUPVIVDVFUQURVEVGVJUSADEVAVDUKVAHDUAEUTVBGVC $.

    ${
      catchomfval.h $e |- H = ( Hom ` C ) $.
      $( Set of arrows of the category of categories (in a universe).
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      catchomfval $p |- ( ph -> H = ( x e. B , y e. B |-> ( x Func y ) ) ) $=
        ( vv vz vg vf cfv cop chom cv cnx cbs cfunc co cmpt2 cco cxp c2nd ccofu
        ctp catcbas eqidd catcval fveq2d syl5eq cvv wcel wceq eqeltri mpt2ex c1
        fvex c5 cdc catstr homid snsstp2 strfv mp1i eqtr4d ) AGUAUBQDRZUASQBCDD
        BTCTUCUDZUEZRZUAUFQMNDDUGDOPMTZUHQNTUCUDVOUCQOTPTUIUDUEUEZRZUJZSQZVMAGE
        SQVSLAEVRSABCNMDEVPFPOVMHIKADEFHIJKUKAVMULAVPULUMUNUOVMUPUQVMVSURABCDDV
        LDEUBQUPJEUBVBUSZVTUTVMVRSUPVAVAVCVDRVPDVMVEVFVKVNVQVGVHVIVJ $.

      catchom.x $e |- ( ph -> X e. B ) $.
      catchom.y $e |- ( ph -> Y e. B ) $.
      $( Set of arrows of the category of categories (in a universe).
         (Contributed by Mario Carneiro, 3-Jan-2017.) $)
      catchom $p |- ( ph -> ( X H Y ) = ( X Func Y ) ) $=
        ( vx vy cv cfunc co wceq cvv catchomfval wa oveq12 adantl wcel ovex a1i
        ovmpt2d ) AOPGHBBOQZPQZRSZGHRSZEUAAOPBCDEFIJKLUBUJGTUKHTUCULUMTAUJGUKHR
        UDUEMNUMUAUFAGHRUGUHUI $.
    $}

    ${
      catcco.o $e |- .x. = ( comp ` C ) $.
      $( Composition in the category of categories.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      catccofval $p |- ( ph -> .x. = ( v e. ( B X. B ) , z e. B |->
      ( g e. ( ( 2nd ` v ) Func z ) , f e. ( Func ` v ) |->
            ( g o.func f ) ) ) ) $=
        ( cco cfv cnx cbs cop cv vx vy chom cxp c2nd cfunc co ccofu ctp catcbas
        cmpt2 eqid catchomfval eqidd catcval fveq2d wcel wceq fvex eqeltri xpex
        cvv mpt2ex c1 c5 cdc catstr ccoid snsstp3 strfv ax-mp 3eqtr4g ) AEOPQRP
        DSZQUCPEUCPZSZQOPCBDDUDZDIHCTZUEPBTUFUGVQUFPITHTUHUGUKZUKZSZUIZOPZFVSAE
        WAOAUAUBBCDEVSGHIVNJKMADEGJKLMUJAUAUBDEGVNJKLMVNULUMAVSUNUOUPNVSVBUQVSW
        BURCBVPDVRDDDERPVBLERUSUTZWCVAWCVCVSWAOVBVDVDVEVFSVSDVNVGVHVMVOVTVIVJVK
        VL $.

      catcco.x $e |- ( ph -> X e. B ) $.
      catcco.y $e |- ( ph -> Y e. B ) $.
      catcco.z $e |- ( ph -> Z e. B ) $.
      catcco.f $e |- ( ph -> F e. ( X Func Y ) ) $.
      catcco.g $e |- ( ph -> G e. ( Y Func Z ) ) $.
      $( Composition in the category of categories.  (Contributed by Mario
         Carneiro, 3-Jan-2017.) $)
      catcco $p |- ( ph -> ( G ( <. X , Y >. .x. Z ) F ) = ( G o.func F ) ) $=
        ( vg vf vv vz cfunc co ccofu cop cvv cxp c2nd cfv cmpt2 catccofval wceq
        cv simprl fveq2d wcel op2ndg syl2anc adantr eqtrd oveq12d df-ov syl6eqr
        simprr eqidd mpt2eq123dv opelxpi ovex mpt2ex a1i ovmpt2d oveq12 adantl
        wa ) AUAUBGFJKUEUFZIJUEUFZUAUPZUBUPZUGUFZGFUGUFZIJUHZKDUFUIAUCUDWDKBBUJ
        ZBUAUBUCUPZUKULZUDUPZUEUFZWFUEULZWBUMUAUBVRVSWBUMZDUIAUDUCBCDEUBUAHLMNO
        UNAWFWDUOZWHKUOZVQZVQZUAUBWIWJWBVRVSWBWOWGJWHKUEWOWGWDUKULZJWOWFWDUKAWL
        WMUQZURAWPJUOZWNAIBUSZJBUSZWRPQIJBBUTVAVBVCAWLWMVGVDWOWJWDUEULVSWOWFWDU
        EWQURIJUEVEVFWOWBVHVIAWSWTWDWEUSPQIJBBVJVARWKUIUSAUAUBVRVSWBJKUEVKIJUEV
        KVLVMVNVTGUOWAFUOVQWBWCUOAVTGWAFUGVOVPTSWCUIUSAGFUGVKVMVN $.
    $}
  $}

  ${
    $d f g h w x y z B $.  $d f g h w x y z C $.  $d f g h w x y z U $.
    $d x ph $.  $d f g h w x y z V $.  $d x X $.
    catccatid.c $e |- C = ( CatCat ` U ) $.
    catccatid.b $e |- B = ( Base ` C ) $.
    $( Lemma for ~ catccat .  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    catccatid $p |- ( U e. V ->
      ( C e. Cat /\ ( Id ` C ) = ( x e. B |-> ( idFunc ` x ) ) ) ) $=
      ( wcel cv wa cfv co cvv cfunc ccat eqid catchom cop ccofu catcco vw vy vz
      vf vg vh chom w3a cco cidfu cbs wceq a1i eqidd ccatc fvex eqeltri biid id
      cin catcbas inss2 syl6eqss sselda idfucl syl simpl simpr eleqtrrd simpr1l
      simpr1r simpr31 eleqtrd syldan cofulid eqtrd simpr2l cofucl oveq1d oveq2d
      simpr32 cofurid 3eltr4d simpr33 simpr2r cofuass 3eqtr4d iscatd2 ) DEHZUAI
      ZBHZAIZBHZJZUBIZBHZUCIZBHZJZUDIZWJWLCUGKZLZHZUEIZWLWOXALZHZUFIZWOWQXALZHZ
      UHZUHZUAAUBUCBCCUIKZWLUJKZUDUEUFXAMBCUKKULWIGUMWIXAUNWIXLUNCMHWICDUOKMFDU
      OUPUQUMXKURWIWMJZXMWLWLNLZWLWLXALXNWLOHXMXOHZWIBOWLWIBDOUTOWIBCDEFGWIUSVA
      DOVBVCVDWLXMXMPZVEVFZXNBCDXAEWLWLFGWIWMVGXAPZWIWMVHZXTQVIWIXKJZXMWTWJWLRZ
      WLXLLLXMWTSLWTYABCXLDWTXMEWJWLWLFGWIXKVGZXLPZWKWMWSXJWIVJZWKWMWSXJWIVKZYF
      YAWTXBWJWLNLXCXFXIWNWSWIVLYABCDXAEWJWLFGYCXSYEYFQVMZWIXKWMXPYFXRVNZTYAWJW
      LWTXMYGXQVOVPYAXDXMWLWLRWOXLLLXDXMSLXDYABCXLDXMXDEWLWLWOFGYCYDYFYFWPWRWNX
      JWIVQZYHYAXDXEWLWONLXCXFXIWNWSWIWAYABCDXAEWLWOFGYCXSYFYIQVMZTYAWLWOXDXMYJ
      XQWBVPYAXDWTSLZWJWONLXDWTYBWOXLLLZWJWOXALYAWJWLWOWTXDYGYJVRZYABCXLDWTXDEW
      JWLWOFGYCYDYEYFYIYGYJTZYABCDXAEWJWOFGYCXSYEYIQWCYAXGXDSLZWTYBWQXLLZLZXGYK
      WJWORWQXLLZLZXGXDWLWORWQXLLLZWTYPLXGYLYRLYAYOWTSLXGYKSLYQYSYAWJWLWOWQWTXD
      XGYGYJYAXGXHWOWQNLXCXFXIWNWSWIWDYABCDXAEWOWQFGYCXSYIWPWRWNXJWIWEZQVMZWFYA
      BCXLDWTYOEWJWLWQFGYCYDYEYFUUAYGYAWLWOWQXDXGYJUUBVRTYABCXLDYKXGEWJWOWQFGYC
      YDYEYIUUAYMUUBTWGYAYTYOWTYPYABCXLDXDXGEWLWOWQFGYCYDYFYIUUAYJUUBTVSYAYLYKX
      GYRYNVTWGWH $.

    catcid.o $e |- .1. = ( Id ` C ) $.
    catcid.i $e |- I = ( idFunc ` X ) $.
    catcid.u $e |- ( ph -> U e. V ) $.
    catcid.x $e |- ( ph -> X e. B ) $.
    $( The identity arrow in the category of categories is the identity
       functor.  (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    catcid $p |- ( ph -> ( .1. ` X ) = I ) $=
      ( vx cfv cidfu cvv wcel wceq cv ccid cmpt ccat wa catccatid simprd syl5eq
      syl simpr fveq2d fvex a1i fvmptd syl6eqr ) AHEPHQPZFAOHOUAZQPZUPBERAECUBP
      ZOBURUCZKACUDSZUSUTTZADGSVAVBUEMOBCDGIJUFUIUGUHAUQHTZUEUQHQAVCUJUKNUPRSAH
      QULUMUNLUO $.
  $}

  ${
    $d x C $.  $d x U $.  $d x V $.
    catccat.c $e |- C = ( CatCat ` U ) $.
    $( The category of categories is a category.  (Clearly it cannot be an
       element of itself, hence it is "large" with respect to ` U ` .)
       (Contributed by Mario Carneiro, 3-Jan-2017.) $)
    catccat $p |- ( U e. V -> C e. Cat ) $=
      ( vx wcel ccat ccid cfv cbs cv cidfu cmpt wceq eqid catccatid simpld ) BC
      FAGFAHIEAJIZEKLIMNERABCDROPQ $.
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z ph $.  $d f g x y z V $.
    resscatc.c $e |- C = ( CatCat ` U ) $.
    resscatc.d $e |- D = ( CatCat ` V ) $.
    resscatc.1 $e |- ( ph -> U e. W ) $.
    resscatc.2 $e |- ( ph -> V C_ U ) $.
    $( The restriction of the category of categories to a subset is the
       category of categories in the subset.  Thus, the ` CatCat `` U `
       categories for different ` U ` are full subcategories of each other.
       (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    resscatc $p |- ( ph -> ( ( Homf ` ( C |`s V ) ) = ( Homf ` D ) /\
                             ( comf ` ( C |`s V ) ) = ( comf ` D ) ) ) $=
      ( vx vy co cfv wceq cin wral wcel cvv eqid vg vf vz cress chomf chom ccat
      ccomf cv wa cfunc cbs ssexd adantr simprl catcbas eleqtrrd simprr catchom
      wss ineq2d inass syl6reqr df-ss sylib ineq1d ressbas syl 3eqtr3d syl6eqss
      ressbasss sseldd resshom proplem3 ralrimivva eqcomd homfeq mpbird cop cco
      3eqtr2rd w3a ccofu ad2antrr simplr1 simplr2 simplr3 eleqtrd catcco ressco
      oveqd 3eqtr2d ralrimivvva comfeq jca ) ABEUDMZUENZCUENZOZWPUHNZCUHNZOAWSK
      UIZLUIZWPUFNZMZXBXCCUFNZMZOZLEUGPZQKXIQAXHKLXIXIAXBXIRZXCXIRZUJZUJZXGXBXC
      UKMZXBXCBUFNZMXEXMCULNZCEXFSXBXCHXPTZAESRZXLAEDFIJUMZUNXFTZXMXBXIXPAXJXKU
      OZAXPXIOZXLAXPCESHXQXSUPZUNZUQXMXCXIXPAXJXKURZYDUQUSXMBULNZBDXOFXBXCGYFTZ
      ADFRZXLIUNXOTZXMXIYFXBAXIYFUTZXLAXIWPULNZYFAEDPZUGPZEYFPZXIYKAYNEDUGPZPYM
      AYFYOEAYFBDFGYGIUPVAEDUGVBVCAYLEUGAEDUTYLEOJEDVDVEVFAXRYNYKOXSEYFWPSBWPTZ
      YGVGVHVIZEYFWPBYPYGVKVJZUNZYAVLXMXIYFXCYSYEVLUSAXLKLXOXDAXRXOXDOXSEBWPXOS
      YPYIVMVHVNWAVOAKLXIWPCXDXFXDTXTYQAXPXIYCVPZVQVRZAXAWTAXAWTOUAUIZUBUIZXBXC
      VSZUCUIZCVTNZMMZUUBUUCUUDUUEWPVTNZMZMZOZUAXCUUEXFMZQUBXGQZUCXIQLXIQKXIQAU
      UMKLUCXIXIXIAXJXKUUEXIRZWBZUJZUUKUBUAXGUULUUPUUCXGRZUUBUULRZUJZUJZUUGUUBU
      UCWCMUUBUUCUUDUUEBVTNZMZMUUJUUTXPCUUFEUUCUUBSXBXCUUEHXQAXRUUOUUSXSWDZUUFT
      ZUUTXBXIXPXJXKUUNAUUSWEZAYBUUOUUSYCWDZUQZUUTXCXIXPXJXKUUNAUUSWFZUVFUQZUUT
      UUEXIXPXJXKUUNAUUSWGZUVFUQZUUTUUCXGXNUUPUUQUURUOUUTXPCEXFSXBXCHXQUVCXTUVG
      UVIUSWHZUUTUUBUULXCUUEUKMUUPUUQUURURUUTXPCEXFSXCUUEHXQUVCXTUVIUVKUSWHZWIU
      UTYFBUVADUUCUUBFXBXCUUEGYGAYHUUOUUSIWDUVATZUUTXIYFXBAYJUUOUUSYRWDZUVEVLUU
      TXIYFXCUVOUVHVLUUTXIYFUUEUVOUVJVLUVLUVMWIUUTUVBUUIUUBUUCUUTUVAUUHUUDUUEAU
      VAUUHOZUUOUUSAXRUVPXSEBWPUVASYPUVNWJVHWDWKWKWLVOWMAKLUCXICWPUUHUUFUBUAXFU
      VDUUHTXTYTYQAWQWRUUAVPWNVRVPWO $.
  $}

  ${
    $d x y C $.  $d f g u v x y z F $.  $d u v x y G $.  $d f g u v x y z ph $.
    $d f g u v z H $.  $d x y I $.  $d u v x y z R $.  $d f g u v x y z S $.
    $d f g u v x y z X $.  $d f g u v x y z Y $.
    catciso.c $e |- C = ( CatCat ` U ) $.
    catciso.b $e |- B = ( Base ` C ) $.
    catciso.r $e |- R = ( Base ` X ) $.
    catciso.s $e |- S = ( Base ` Y ) $.
    catciso.u $e |- ( ph -> U e. V ) $.
    catciso.x $e |- ( ph -> X e. B ) $.
    catciso.y $e |- ( ph -> Y e. B ) $.
    ${
      catcisolem.i $e |- I = ( Inv ` C ) $.
      catcisolem.g $e |- H = ( x e. S , y e. S |->
        `' ( ( `' F ` x ) G ( `' F ` y ) ) ) $.
      catcisolem.1 $e |- ( ph -> F ( ( X Full Y ) i^i ( X Faith Y ) ) G ) $.
      catcisolem.2 $e |- ( ph -> F : R -1-1-onto-> S ) $.
      $( Lemma for ~ catciso .  (Contributed by Mario Carneiro,
         29-Jan-2017.) $)
      catcisolem $p |- ( ph -> <. F , G >. ( X I Y ) <. `' F , H >. ) $=
        ( vu vv vz vf vg cop ccnv co wbr csect cfv cco ccid wceq ccofu cidfu cv
        ccom cmpt2 cid cres cxp chom cmpt wf1o f1ococnv1 syl wcel 3ad2ant1 f1of
        wf simp2 ffvelrnd simp3 wa simpl fveq2d simpr oveq12d cnveqd ovex cnvex
        w3a ovmpt2a syl2anc f1ocnvfv1 eqtrd coeq1d eqid cful ffthf1o mpt2eq3dva
        cfth cin fveq2 df-ov syl6eqr reseq2d mpt2mpt cfunc inss1 fullfunc sstri
        opeq12d ssbri ccat catcbas inss2 sseldd f1ocnv 3syl ffvelrnda f1ocnvfv2
        adantr weq mpbird fveq1d wi f1ocnvfv wb f1oeq3 3eqtr4d cofuval2 idfuval
        mpd mpbid df-br sylib catcco catcid catchom eleqtrrd issect2 f1ococnv2
        syl6eqss wfn fnmpt2i adantrr adantrl adantl simprl simprr eqcomd feq12d
        funcid sylan catidcl simp21 simp22 simp23 simp3l simp3r funcco oveq123d
        a1i catcocl isfuncd catccat 3adant1 coeq2d 3adant3 3adant2 3impb isinv
        mpbir2and ) AIJULZIUMZKULZNOLUNUOUVLUVNNOEUPUQZUNUOZUVNUVLONUVOUNUOZAUV
        PUVNUVLNOULNEURUQZUNUNZNEUSUQZUQZUTAUVNUVLVAUNZNVBUQZUVSUWAAUVMIVDZUGUH
        FFUGVCZIUQZUHVCZIUQZKUNZUWEUWGJUNZVDZVEZULVFFVGZUIFFVHVFUIVCZNVIUQZUQZV
        GZVJZULUWBUWCAUWDUWMUWLUWRAFGIVKZUWDUWMUTUFFGIVLVMAUWLUGUHFFVFUWEUWGUWO
        UNZVGZVEUWRAUGUHFFUWKUXAAUWEFVNZUWGFVNZWIZUWKUWJUMZUWJVDZUXAUXDUWIUXEUW
        JUXDUWIUWFUVMUQZUWHUVMUQZJUNZUMZUXEUXDUWFGVNUWHGVNUWIUXJUTUXDFGUWEIUXDU
        WSFGIVQAUXBUWSUXCUFVOZFGIVPVMZAUXBUXCVRZVSUXDFGUWGIUXLAUXBUXCVTZVSBCUWF
        UWHGGBVCZUVMUQZCVCZUVMUQZJUNZUMZUXJKUXOUWFUTZUXQUWHUTZWAZUXSUXIUYCUXPUX
        GUXRUXHJUYCUXOUWFUVMUYAUYBWBWCUYCUXQUWHUVMUYAUYBWDWCWEWFUDUXIUXGUXHJWGW
        HWJWKUXDUXIUWJUXDUXGUWEUXHUWGJUXDUWSUXBUXGUWEUTUXKUXMFGUWEIWLWKUXDUWSUX
        CUXHUWGUTUXKUXNFGUWGIWLWKWEWFWMWNUXDUWTUWFUWHOVIUQZUNZUWJVKUXFUXAUTUXDF
        NOIJUWOUYDUWEUWGRUWOWOZUYDWOZAUXBIJNOWPUNZNOWSUNZWTZUOZUXCUEVOUXMUXNWQU
        WTUYEUWJVLVMWMWRUGUHUIFFUWQUXAUWNUWEUWGULZUTZUWPUWTVFUYMUWPUYLUWOUQUWTU
        WNUYLUWOXAUWEUWGUWOXBXCXDXEXCXJAUGUHFNONIJUVMKRAUYKIJNOXFUNZUOZUEUYJUYN
        IJUYJUYHUYNUYHUYIXGNOXHXIXKVMZAUGUHUIGFOOURUQZOUSUQZUJUKNUVMKUYDNUSUQZU
        WONURUQZSRUYGUYFUYRWOZUYSWOZUYQWOZUYTWOZADXLOADHXLWTXLADEHMPQTXMHXLXNUU
        AZUBXOZADXLNVUEUAXOZAUWSGFUVMVKGFUVMVQZUFFGIXPGFUVMVPXQZKGGVHZUUBABCGGU
        XTKUDUXSUXPUXRJWGWHUUCUVAAUWEGVNZUWGGVNZWAZWAZUWEUWGUYDUNZUWEUVMUQZUWGU
        VMUQZUWOUNZUWEUWGKUNZVQVUPIUQZVUQIUQZUYDUNZVURVUPVUQJUNZUMZVQZVUNVURVVB
        VVCVKZVVBVURVVDVKVVEVUNFNOIJUWOUYDVUPVUQRUYFUYGAUYKVUMUEXTAVUKVUPFVNZVU
        LAGFUWEUVMVUIXRZUUDAVULVUQFVNZVUKAGFUWGUVMVUIXRZUUEWQVURVVBVVCXPVVBVURV
        VDVPXQVUNVUOVVBVURVUSVVDVUMVUSVVDUTZABCUWEUWGGGUXTVVDKBUGYAZCUHYAZWAZUX
        SVVCVVNUXPVUPUXRVUQJVVNUXOUWEUVMVVLVVMWBWCVVNUXQUWGUVMVVLVVMWDWCWEWFUDV
        VCVUPVUQJWGWHWJZUUFVUNVVBVUOVUNVUTUWEVVAUWGUYDVUNUWSVUKVUTUWEUTZAUWSVUM
        UFXTZAVUKVULUUGFGUWEIXSZWKVUNUWSVULVVAUWGUTZVVQAVUKVULUUHFGUWGIXSZWKWEZ
        UUIUUJYBAVUKWAZUWEUYRUQZUWEUWEKUNZUQVWCVUPVUPJUNZUMZUQZVUPUYSUQZVWBVWCV
        WDVWFVWBVUKVUKVWDVWFUTAVUKWDZVWIBCUWEUWEGGUXTVWFKVVLCUGYAZWAZUXSVWEVWKU
        XPVUPUXRVUPJVWKUXOUWEUVMVVLVWJWBWCVWKUXQUWEUVMVVLVWJWDWCWEWFUDVWEVUPVUP
        JWGWHWJWKYCVWBVWHVWEUQZVWCUTZVWGVWHUTZVWBVWLVUTUYRUQVWCVWBFNUYSOIJUYRVU
        PRVUBVUAAUYOVUKUYPXTVVHUUKVWBVUTUWEUYRAUWSVUKVVPUFVVRUULWCWMVWBVUPVUPUW
        OUNZVUTVUTUYDUNZVWEVKVWHVWOVNVWMVWNYDVWBFNOIJUWOUYDVUPVUPRUYFUYGAUYKVUK
        UEXTVVHVVHWQVWBFNUYSUWOVUPRUYFVUBANXLVNZVUKVUGXTVVHUUMVWOVWPVWHVWCVWEYE
        WKYKWMAVUKVULUWNGVNZWIZUJVCZVUOVNZUKVCZUWGUWNUYDUNZVNZWAZWIZVXBVWTUYLUW
        NUYQUNZUNZVUPUWNUVMUQZJUNZUMZUQZVXBVUQVXIJUNZUMZUQZVWTVVDUQZVUPVUQULVXI
        UYTUNZUNZVXHUWEUWNKUNZUQVXBUWGUWNKUNZUQZVWTVUSUQZVXQUNVXFVXRVXJUQZVXHUT
        ZVXLVXRUTZVXFVYCVXOVXMUQZVXPVVCUQZVUTVVAULZVXIIUQZUYQUNZUNVXHVXFFNUYTOI
        JUWOVXPVXOUYQVUPVUQVXIRUYFVUDVUCAVWSUYOVXEUYPVOVXFGFUWEUVMAVWSVUHVXEVUI
        VOZAVUKVULVWRVXEUUNZVSZVXFGFUWGUVMVYKAVUKVULVWRVXEUUOZVSZVXFGFUWNUVMVYK
        AVUKVULVWRVXEUUPZVSZVXFVUOVURVWTVVDVXFVURVUOVVCVKZVUOVURVVDVKVUOVURVVDV
        QVXFVVFVYRVXFFNOIJUWOUYDVUPVUQRUYFUYGAVWSUYKVXEUEVOZVYMVYOWQVXFVVBVUOUT
        ZVVFVYRYFZVXFVUTUWEVVAUWGUYDVXFUWSVUKVVPAVWSUWSVXEUFVOZVYLVVRWKZVXFUWSV
        ULVVSWUBVYNVVTWKZWEVVBVUOVURVVCYGZVMYLZVURVUOVVCXPVUOVURVVDVPXQAVWSVXAV
        XDUUQZVSZVXFVXCVUQVXIUWOUNZVXBVXNVXFWUIVXCVXMVKZVXCWUIVXNVKVXCWUIVXNVQV
        XFWUIVVAVYIUYDUNZVXMVKZWUJVXFFNOIJUWOUYDVUQVXIRUYFUYGVYSVYOVYQWQVXFWUKV
        XCUTWULWUJYFVXFVVAUWGVYIUWNUYDWUDVXFUWSVWRVYIUWNUTWUBVYPFGUWNIXSWKZWEWU
        KVXCWUIVXMYGVMYLZWUIVXCVXMXPVXCWUIVXNVPXQAVWSVXAVXDUURZVSZUUSVXFVYFVXBV
        YGVWTVYJVXGVXFVYHUYLVYIUWNUYQVXFVUTUWEVVAUWGWUCWUDXJWUMWEVXFWUJVXDVYFVX
        BUTWUNWUOWUIVXCVXBVXMXSWKVXFVYRVXAVYGVWTUTWUFWUGVURVUOVWTVVCXSWKUUTWMVX
        FVUPVXIUWOUNZUWEUWNUYDUNZVXJVKZVXRWUQVNVYDVYEYDVXFWUQVUTVYIUYDUNZVXJVKZ
        WUSVXFFNOIJUWOUYDVUPVXIRUYFUYGVYSVYMVYQWQVXFWUTWURUTWVAWUSYFVXFVUTUWEVY
        IUWNUYDWUCWUMWEWUTWURWUQVXJYGVMYLVXFFNUYTVXPVXOUWOVUPVUQVXIRUYFVUDAVWSV
        WQVXEVUGVOVYMVYOVYQWUHWUPUVBWUQWURVXRVXHVXJYEWKYKVXFVXHVXSVXKVXFVUKVWRV
        XSVXKUTVYLVYPBCUWEUWNGGUXTVXKKVVLCUIYAZWAZUXSVXJWVCUXPVUPUXRVXIJWVCUXOU
        WEUVMVVLWVBWBWCWVCUXQUWNUVMVVLWVBWDWCWEWFUDVXJVUPVXIJWGWHWJWKYCVXFVYAVX
        OVYBVXPVXQVXFVXBVXTVXNVXFVULVWRVXTVXNUTVYNVYPBCUWGUWNGGUXTVXNKBUHYAZWVB
        WAZUXSVXMWVEUXPVUQUXRVXIJWVEUXOUWGUVMWVDWVBWBWCWVEUXQUWNUVMWVDWVBWDWCWE
        WFUDVXMVUQVXIJWGWHWJWKYCVXFVWTVUSVVDVXFVUKVULVVKVYLVYNVVOWKYCWEYHUVCZYI
        AUIFNUWOUWCUWCWOZRVUGUYFYJYHADEUVRHUVLUVNMNONPQTUVRWOZUAUBUAAUYOUVLUYNV
        NUYPIJUYNYMYNZAUVMKONXFUNZUOUVNWVJVNWVFUVMKWVJYMYNZYOADEHUVTUWCMNPQUVTW
        OZWVGTUAYPYHADEUVOUVRUVTUVLUVNEVIUQZNOQWVMWOZWVHWVLUVOWOZAHMVNEXLVNTEHM
        PUVDVMZUAUBAUVLUYNNOWVMUNWVIADEHWVMMNOPQTWVNUAUBYQYRZAUVNWVJONWVMUNWVKA
        DEHWVMMONPQTWVNUBUAYQYRZYSYBAUVQUVLUVNONULOUVRUNUNZOUVTUQZUTAUVLUVNVAUN
        ZOVBUQZWVSWVTAIUVMVDZUGUHGGVVCVUSVDZVEZULVFGVGZUIVUJVFUWNUYDUQZVGZVJZUL
        WWAWWBAWWCWWFWWEWWIAUWSWWCWWFUTUFFGIYTVMAWWEUGUHGGVFVUOVGZVEWWIAUGUHGGW
        WDWWJAVUKVULWIZWWDVVCVVDVDZWWJWWKVUSVVDVVCVUKVULVVKAVVOUVEUVFWWKVYRWWLW
        WJUTWWKVVFVYRWWKFNOIJUWOUYDVUPVUQRUYFUYGAVUKUYKVULUEVOAVUKVVGVULVVHUVGA
        VULVVIVUKVVJUVHWQWWKVYTWUAAVUKVULVYTVWAUVIWUEVMYLVURVUOVVCYTVMWMWRUGUHU
        IGGWWHWWJUYMWWGVUOVFUYMWWGUYLUYDUQVUOUWNUYLUYDXAUWEUWGUYDXBXCXDXEXCXJAU
        GUHGONOUVMKIJSWVFUYPYIAUIGOUYDWWBWWBWOZSVUFUYGYJYHADEUVRHUVNUVLMONOPQTW
        VHUBUAUBWVKWVIYOADEHUVTWWBMOPQWVLWWMTUBYPYHADEUVOUVRUVTUVNUVLWVMONQWVNW
        VHWVLWVOWVPUBUAWVRWVQYSYBADEUVOUVLUVNLNOQUCWVPUAUBWVOUVJUVK $.
    $}

    catciso.i $e |- I = ( Iso ` C ) $.
    $( A functor is an isomorphism of categories if and only if it is full and
       faithful, and is a bijection on the objects.  (Contributed by Mario
       Carneiro, 29-Jan-2017.) $)
    catciso $p |- ( ph -> ( F e. ( X I Y ) <->
      ( F e. ( ( X Full Y ) i^i ( X Faith Y ) ) /\
        ( 1st ` F ) : R -1-1-onto-> S ) ) ) $=
      ( cfv vx vy co wcel cful cfth cin c1st wf1o wa c2nd cop wrel wceq relfunc
      cfunc chom cinv cco ccid csect wbr w3a cdm eqid catccat syl isoval eleq2d
      ccat biimpa wfun adantr invfun funfvbrb mpbid isinv simpld issect catchom
      wb simp1d eleqtrd 1st2nd sylancr cv wral 1st2ndbr ccnv wf ccom cid simprl
      cres simprr funcf2 simp2d funcf1 ffvelrnd eqidd ccofu cidfu simp3d catcco
      catcid 3eqtr3d fveq2d fveq1d cofu1 catcbas inss2 syl6eqss sseldd ad2antrr
      idfu1 oveq12d feq23d simprd oveqd cofu2nd coeq1d eqtrd wss idfu2nd fcof1o
      syl22anc ralrimivva isffth2 df-br sylib eqeltrd cofu1st idfu1st jca cmpt2
      sylanbrc inss1 fullfunc sstri sseldi eqeltrrd catcisolem eqbrtrd inviso1
      sylibr impbida ) AGJKHUCZUDZGJKUEUCZJKUFUCZUGZUDZDEGUHTZUIZUJZAUUHUJZUULU
      UNUUPGUUMGUKTZULZUUKUUPJKUPUCZUMZGUUSUDZGUURUNZJKUOZUUPGJKCUQTZUCZUUSUUPG
      UVEUDZGJKCURTZUCZTZKJUVDUCZUDZUVIGJKULJCUSTZUCUCZJCUTTZTZUNZUUPGUVIJKCVAT
      ZUCVBZUVFUVKUVPVCUUPUVRUVIGKJUVQUCVBZUUPGUVIUVHVBZUVRUVSUJUUPGUVHVDZUDZUV
      TAUUHUWBAUUGUWAGABCHUVGJKMUVGVEZAFIUDZCVJUDZPCFILVFVGZQRSVHVIVKUUPUVHVLUW
      BUVTWAUUPBCUVGJKMUWCAUWEUUHUWFVMZAJBUDZUUHQVMZAKBUDZUUHRVMZVNGUVHVOVGVPUU
      PBCUVQGUVIUVGJKMUWCUWGUWIUWKUVQVEZVQVPZVRUUPBCUVQUVLUVNGUVIUVDJKMUVDVEZUV
      LVEZUVNVEZUWLUWGUWIUWKVSVPZWBAUVEUUSUNUUHABCFUVDIJKLMPUWNQRVTVMWCZGUUSWDZ
      WEUUPUUMUUQUUKVBZUURUUKUDZUUPUUMUUQUUSVBZUAWFZUBWFZJUQTZUCZUXCUUMTZUXDUUM
      TZKUQTZUCZUXCUXDUUQUCZUIZUBDWGUADWGUWTUUPUUTUVAUXBUVCUWRGUUSWHWEZUUPUXLUA
      UBDDUUPUXCDUDZUXDDUDZUJZUJZUXLUXKWIUXGUXHUVIUKTZUCZUNZUXQUXFUXJUXKWJUXJUX
      FUXSWJZUXKUXSWKZWLUXJWNZUNUXSUXKWKZWLUXFWNZUNUXLUXTUJUXQDJKUUMUUQUXEUXIUX
      CUXDNUXEVEZUXIVEZUUPUXBUXPUXMVMZUUPUXNUXOWMZUUPUXNUXOWOZWPUXQUXJUXGUVIUHT
      ZTZUXHUYKTZUXEUCZUXSWJUYAUXQEKJUYKUXRUXIUXEUXGUXHOUYGUYFUUPUYKUXRKJUPUCZV
      BZUXPUUPUYOUMUVIUYOUDZUYPKJUOUUPUVIUVJUYOUUPUVFUVKUVPUWQWQAUVJUYOUNUUHABC
      FUVDIKJLMPUWNRQVTVMWCZUVIUYOWHWEZVMUXQDEUXCUUMUXQDEJKUUMUUQNOUYHWRZUYIWSZ
      UXQDEUXDUUMUYTUYJWSZWPUXQUXJUYNUXJUXFUXSUXQUXJWTUXQUYLUXCUYMUXDUXEUXQUXCU
      VIGXAUCZUHTZTUXCJXBTZUHTZTUYLUXCUXQUXCVUDVUFUXQVUCVUEUHUUPVUCVUEUNUXPUUPU
      VMUVOVUCVUEUUPUVFUVKUVPUWQXCUUPBCUVLFGUVIIJKJLMAUWDUUHPVMZUWOUWIUWKUWIUWR
      UYRXDAUVOVUEUNUUHABCFUVNVUEIJLMUWPVUEVEZPQXEVMXFZVMZXGZXHUXQDJKJGUVIUXCNU
      UPUVAUXPUWRVMZUUPUYQUXPUYRVMZUYIXIUXQDJVUEUXCVUHNAJVJUDZUUHUXPABVJJABFVJU
      GVJABCFILMPXJFVJXKXLZQXMZXNZUYIXOXFZUXQUXDVUDTUXDVUFTUYMUXDUXQUXDVUDVUFVU
      KXHUXQDJKJGUVIUXDNVULVUMUYJXIUXQDJVUEUXDVUHNVUQUYJXOXFZXPXQVPUXQUXGUXHGUV
      IXAUCZUKTZUCZUXGUXHKXBTZUKTZUCUYBUYCUXQVVAVVDUXGUXHUXQVUTVVCUKUUPVUTVVCUN
      UXPUUPGUVIKJULKUVLUCUCZKUVNTZVUTVVCUUPUVKUVFVVEVVFUNZUUPUVSUVKUVFVVGVCUUP
      UVRUVSUWMXRUUPBCUVQUVLUVNUVIGUVDKJMUWNUWOUWPUWLUWGUWKUWIVSVPXCUUPBCUVLFUV
      IGIKJKLMVUGUWOUWKUWIUWKUYRUWRXDAVVFVVCUNUUHABCFUVNVVCIKLMUWPVVCVEZPRXEVMX
      FZVMXGXSUXQVVBUYLUYMUUQUCZUXSWKUYBUXQEKJKUVIGUXGUXHOVUMVULVUAVUBXTUXQVVJU
      XKUXSUXQUYLUXCUYMUXDUUQVURVUSXPYAYBUXQEKUXIVVCUXGUXHVVHOUXQBVJKABVJYCUUHU
      XPVUOXNAUWJUUHUXPRXNXMUYGVUAVUBYDXFUXQUXCUXDVUCUKTZUCUXCUXDVUEUKTZUCUYDUY
      EUXQVVKVVLUXCUXDUXQVUCVUEUKVUJXGXSUXQDJKJGUVIUXCUXDNVULVUMUYIUYJXTUXQDJUX
      EVUEUXCUXDVUHNVUQUYFUYIUYJYDXFUXFUXJUXKUXSYEYFVRYGUAUBDJKUUMUUQUXEUXINUYF
      UYGYHYPUUMUUQUUKYIZYJYKUUPUUNUUMWIZUYKUNZUUPDEUUMWJEDUYKWJUUMUYKWKZWLEWNZ
      UNUYKUUMWKZWLDWNZUNUUNVVOUJUUPDEJKUUMUUQNOUXMWRUUPEDKJUYKUXRONUYSWRUUPVUT
      UHTVVCUHTVVPVVQUUPVUTVVCUHVVIXGUUPEKJKUVIGOUYRUWRYLUUPEKVVCVVHOAKVJUDUUHA
      BVJKVUORXMVMYMXFUUPVUDVUFVVRVVSUUPVUCVUEUHVUIXGUUPDJKJGUVINUWRUYRYLUUPDJV
      UEVUHNAVUNUUHVUPVMYMXFDEUUMUYKYEYFVRYNAUUOUJZBCGVVNUAUBEEUXCVVNTUXDVVNTUU
      QUCWIYOZULZHUVGJKMUWCAUWEUUOUWFVMAUWHUUOQVMZAUWJUUORVMZSVVTGUURVWBUVHVVTU
      UTUVAUVBUVCVVTUUKUUSGUUKUUIUUSUUIUUJYQJKYRYSAUULUUNWMZYTUWSWEZVVTUAUBBCDE
      FUUMUUQVWAUVGIJKLMNOAUWDUUOPVMVWCVWDUWCVWAVEVVTUXAUWTVVTGUURUUKVWFVWEUUAV
      VMUUEAUULUUNWOUUBUUCUUDUUF $.
  $}

  ${
    $d x y ph $.  $d x y X $.
    catcoppccl.c $e |- C = ( CatCat ` U ) $.
    catcoppccl.b $e |- B = ( Base ` C ) $.
    catcoppccl.o $e |- O = ( oppCat ` X ) $.
    catcoppccl.1 $e |- ( ph -> U e. WUni ) $.
    catcoppccl.2 $e |- ( ph -> om e. U ) $.
    catcoppccl.3 $e |- ( ph -> X e. B ) $.
    $( The category of categories for a weak universe is closed under taking
       opposites.  (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    catcoppccl $p |- ( ph -> O e. B ) $=
      ( vx vy ccat wcel cnx cfv wunstr wss cin chom ctpos cop co cco cbs cxp cv
      csts c2nd c1st cmpt2 wceq eqid oppcval syl cwun catcbas eleqtrd sseldi c1
      inss1 c4 cdc df-hom wunndx wuntpos wunop wunsets df-cco crn cuni cdm ccnv
      c5 c0 csn cun cpw df-base wunxp wunrn wununi wundm wun0 wunsn wunun wunpw
      wuncnv wral wf tposssxp ovssunirn dmss ax-mp cnvss unss1 mp2b rnss xpss12
      mp2an sstri elpw2g mpbiri ralrimivw fmpt2 sylib wunf eqeltrd oppccat elin
      wb inss2 sylanbrc eleqtrrd ) AEDOUAZBAEDPEOPZEXQPAEFQUBRZFUBRZUCZUDZUJUEZ
      QUFRZMNFUGRZYEUHZYENUIMUIZUKRUDZYGULRZFUFRZUEZUCZUMZUDZUJUEZDAFBPEYOUNLNM
      YEFYJXTEBYEUOXTUOYJUOIUPUQAYNYCDJAYBFDJAXQDFDOVCAFBXQLABCDURGHJUSZUTZVAZA
      XSYADJAQDUBVBVDVEZVFJADJKVGZSAXTDJAFDUBYSVFJYRSVHVIVJAYDYMDJAQDUFVBVPVEZV
      KJYTSAYFYEUHZYJVLZVMZVNZVOZVQVRZVSZUUDVLZUHZVTZDYMJAYFYEDJAYEYEDJAFDUGVBW
      AJYRSZUULWBUULWBAUUJDJAUUHUUIDJAUUFUUGDJAUUEDJAUUDDJAUUCDJAYJDJAFDUFUUAVK
      JYRSWCWDZWEWJAVQDJADJWFWGWHAUUDDJUUMWCWBZWIAYLUUKPZNYEWKZMYFWKUUBUUKYMWLA
      UUPMYFAUUONYEAUUOYLUUJTZYLYKVNZVOZUUGVSZYKVLZUHZUUJYKWMUUTUUHTZUVAUUITZUV
      BUUJTUURUUETZUUSUUFTUVCYKUUDTZUVEYJYHYIWNZYKUUDWOWPUURUUEWQUUSUUFUUGWRWSU
      VFUVDUVGYKUUDWTWPUUTUUHUVAUUIXAXBXCAUUJDPUUOUUQXMUUNYLUUJDXDUQXEXFXFMNYFY
      EYLUUKYMYMUOXGXHXIVIVJXJAFOPXRAXQOFDOXNYQVAFEIXKUQEDOXLXOYPXP $.
  $}

  ${
    $d a b f g h v x ph $.  $d a b f g h v x X $.  $d a b f g h v x Y $.
    catcfuccl.c $e |- C = ( CatCat ` U ) $.
    catcfuccl.b $e |- B = ( Base ` C ) $.
    catcfuccl.o $e |- Q = ( X FuncCat Y ) $.
    catcfuccl.u $e |- ( ph -> U e. WUni ) $.
    catcfuccl.1 $e |- ( ph -> om e. U ) $.
    catcfuccl.x $e |- ( ph -> X e. B ) $.
    catcfuccl.y $e |- ( ph -> Y e. B ) $.
    $( The category of categories for a weak universe is closed under the
       functor category operation.  (Contributed by Mario Carneiro,
       12-Jan-2017.) $)
    catcfuccl $p |- ( ph -> Q e. B ) $=
      ( ccat wcel cfv co cv cvv vv vh vf vg vb va vx cin cnx cbs cfunc cop chom
      cnat cco cxp c1st c2nd cmpt cmpt2 csb ctp eqid inss2 cwun catcbas eleqtrd
      sseldi eqidd fucval c1 df-base wunndx wunstr inss1 wunop c4 df-hom wunnat
      wunfunc cdc c5 df-cco crn cuni cmap wunxp wunrn wununi wunpw wunmap wunpm
      cpw cpm wral fvex wsbc wss ovex rnex uniex xpex ovssunirn rnss uniss mp2b
      wf sstri elpw mpbir a1i fmpti pwex elmap rgen2w fmpt2 xpss12 mp2an elpm2r
      mpbi mp4an sbcth sbcel1g mpbid ax-mp wunf wuntp eqeltrd sylanbrc eleqtrrd
      fuccat elin ) ADEOUHZBADEPDOPDYMPADUIUJQZFGUKRZULZUIUMQZFGUNRZULZUIUOQZUA
      UBYOYOUPZYOUCUASZUQQZUDUUBURQZUEUFUDSZUBSZYRRZUCSZUUEYRRZUGFUJQZUGSZUESQZ
      UUKUFSQZUUKUUHUQQQUUKUUEUQQQULZUUKUUFUQQQZGUOQZRZRZUSZUTZVAZVAZUTZULZVBEA
      UGUAUUJYOFGDUVCUUPUCUDUBYRUFUEJYOVCYRVCUUJVCUUPVCAYMOFEOVDZAFBYMMABCEVEHI
      KVFZVGZVHZAYMOGUVEAGBYMNUVFVGZVHZAUVCVIVJAYPYSUVDEKAYNYOEKAUIEUJVKVLKAEKL
      VMZVNAFGEKAYMEFEOVOZUVGVHZAYMEGUVLUVIVHZVTZVPAYQYREKAUIEUMVKVQWAVRKUVKVNA
      FGEKUVMUVNVSZVPAYTUVCEKAUIEUOVKWBWAZWCKUVKVNAUUAYOUPZUUPWDZWEZWDZWEZWMZUU
      JWFRZYRWDZWEZUWFUPZWNRZEUVCKAUUAYOEKAYOYOEKUVOUVOWGUVOWGAUWDUWGEKAUWCUUJE
      KAUWBEKAUWAEKAUVTEKAUVSEKAUUPEKAGEUOUVQWCKUVNVNWHWIWHWIWJAFEUJVKVLKUVMVNW
      KAUWFUWFEKAUWEEKAYREKUVPWHWIZUWIWGWLUVRUWHUVCXGZAUVBUWHPZUBYOWOUAUUAWOUWJ
      UWKUAUBUUAYOUUCTPZUWKUUBUQWPUWLUVAUWHPZUCUUCWQUWKUWMUCUUCTUUDTPZUWMUUBURW
      PUWNUUTUWHPZUDUUDWQUWMUWOUDUUDTUWDTPUWGTPUUGUUIUPZUWDUUTXGZUWPUWGWRZUWOUW
      CUUJWFWSUWFUWFUWEYRFGUNWSWTXAZUWSXBUUSUWDPZUFUUIWOUEUUGWOUWQUWTUEUFUUGUUI
      UWTUUJUWCUUSXGUGUUJUWCUURUUSUUSVCUURUWCPZUUKUUJPUXAUURUWBWRUURUUQWDZWEZUW
      BUUQUULUUMXCUUQUVTWRUXBUWAWRUXCUWBWRUUPUUNUUOXCUUQUVTXDUXBUWAXEXFXHUURUWB
      UULUUMUUQWSXIXJXKXLUWCUUJUUSUWBUWAUVTUVSUUPGUOWPWTXAWTXAXMFUJWPXNXJXOUEUF
      UUGUUIUUSUWDUUTUUTVCXPXTUUGUWFWRUUIUWFWRUWRYRUUEUUFXCYRUUHUUEXCUUGUWFUUIU
      WFXQXRUWDUWGUWPUUTTTXSYAYBUDUUDUUTUWHTYCYDYEYBUCUUCUVAUWHTYCYDYEXOUAUBUUA
      YOUVBUWHUVCUVCVCXPXTXKYFVPYGYHAFGDJUVHUVJYKDEOYLYIUVFYJ $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Categorical constructions
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Product of categories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Xc. $.
  $c 1stF $.
  $c 2ndF $.
  $c pairF $.

  $( Extend class notation with the product of two categories. $)
  cxpc $a class Xc. $.

  $( Extend class notation with the first projection functor. $)
  c1stf $a class 1stF $.

  $( Extend class notation with the second projection functor. $)
  c2ndf $a class 2ndF $.

  $( Extend class notation with the functor pairing operation. $)
  cprf $a class pairF $.

  ${
    $d b f g h r s u v x y $.
    $( Define the binary product of categories, which has objects for each pair
       of objects of the factors, and morphisms for each pair of morphisms of
       the factors.  Composition is componentwise.  (Contributed by Mario
       Carneiro, 10-Jan-2017.) $)
    df-xpc $a |- Xc. = ( r e. _V , s e. _V |->
    [_ ( ( Base ` r ) X. ( Base ` s ) ) / b ]_
    [_ ( u e. b , v e. b |-> ( ( ( 1st ` u ) ( Hom ` r ) ( 1st ` v ) ) X.
        ( ( 2nd ` u ) ( Hom ` s ) ( 2nd ` v ) ) ) ) / h ]_
    { <. ( Base ` ndx ) , b >. ,
      <. ( Hom ` ndx ) , h >. ,
      <. ( comp ` ndx ) , ( x e. ( b X. b ) , y e. b |->
        ( g e. ( ( 2nd ` x ) h y ) , f e. ( h ` x ) |->
        <. ( ( 1st ` g ) ( <. ( 1st ` ( 1st ` x ) ) ,
          ( 1st ` ( 2nd ` x ) ) >. ( comp ` r ) ( 1st ` y ) ) ( 1st ` f ) ) ,
           ( ( 2nd ` g ) ( <. ( 2nd ` ( 1st ` x ) ) ,
          ( 2nd ` ( 2nd ` x ) ) >. ( comp ` s ) ( 2nd ` y ) ) ( 2nd ` f ) ) >.
          ) ) >. } ) $.

    $( Define the first projection functor out of the product of categories.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    df-1stf $a |- 1stF = ( r e. Cat , s e. Cat |->
    [_ ( ( Base ` r ) X. ( Base ` s ) ) / b ]_
      <. ( 1st |` b ) , ( x e. b , y e. b |->
        ( 1st |` ( x ( Hom ` ( r Xc. s ) ) y ) ) ) >. ) $.

    $( Define the second projection functor out of the product of categories.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    df-2ndf $a |- 2ndF = ( r e. Cat , s e. Cat |->
    [_ ( ( Base ` r ) X. ( Base ` s ) ) / b ]_
      <. ( 2nd |` b ) , ( x e. b , y e. b |->
        ( 2nd |` ( x ( Hom ` ( r Xc. s ) ) y ) ) ) >. ) $.

    $( Define the pairing operation for functors (which takes two functors
       ` F : C --> D ` and ` G : C --> E ` and produces
       ` ( F pairF G ) : C --> ( D Xc. E ) ` ).  (Contributed by Mario
       Carneiro, 11-Jan-2017.) $)
    df-prf $a |- pairF = ( f e. _V , g e. _V |-> [_ dom ( 1st ` f ) / b ]_
      <. ( x e. b |-> <. ( ( 1st ` f ) ` x ) , ( ( 1st ` g ) ` x ) >. ) ,
         ( x e. b , y e. b |-> ( h e. dom ( x ( 2nd ` f ) y ) |->
    <. ( ( x ( 2nd ` f ) y ) ` h ) , ( ( x ( 2nd ` g ) y ) ` h ) >. ) ) >. ) $.

    $( The binary product of categories is a two-argument function.
       (Contributed by Mario Carneiro, 10-Jan-2017.) $)
    fnxpc $p |- Xc. Fn ( _V X. _V ) $=
      ( vr vs vb vh vu vv vx vy vg vf cv cbs cfv cxp c1st chom c2nd cmpt2 cop
      co cvv cnx cco ctp csb cxpc df-xpc tpex csbex fnmpt2i ) ABUAUACAKZLMBKZLM
      NZDEFCKZUNEKZOMFKZOMUKPMTUOQMUPQMULPMTNRZUBLMUNSZUBPMDKZSZUBUCMGHUNUNNUNI
      JGKZQMZHKZUSTVAUSMIKZOMJKZOMVAOMZOMVBOMSVCOMUKUCMTTVDQMVEQMVFQMVBQMSVCQMU
      LUCMTTSRRSZUDZUEZUEUFGHFEJIDBACUGCUMVIDUQVHURUTVGUHUIUIUJ $.
  $}

  ${
    $d b f g h r s u v x y B $.  $d b h r s O $.  $d b f g h r s u v x y ph $.
    $d b f g h r s u v x y C $.  $d b f g h r s u v x y D $.
    $d b f g h r s x y K $.
    xpcval.t $e |- T = ( C Xc. D ) $.
    xpcval.x $e |- X = ( Base ` C ) $.
    xpcval.y $e |- Y = ( Base ` D ) $.
    xpcval.h $e |- H = ( Hom ` C ) $.
    xpcval.j $e |- J = ( Hom ` D ) $.
    xpcval.o1 $e |- .x. = ( comp ` C ) $.
    xpcval.o2 $e |- .xb = ( comp ` D ) $.
    xpcval.c $e |- ( ph -> C e. V ) $.
    xpcval.d $e |- ( ph -> D e. W ) $.
    xpcval.b $e |- ( ph -> B = ( X X. Y ) ) $.
    xpcval.k $e |- ( ph -> K = ( u e. B , v e. B |->
      ( ( ( 1st ` u ) H ( 1st ` v ) ) X. ( ( 2nd ` u ) J ( 2nd ` v ) ) ) ) ) $.
    xpcval.o $e |- ( ph -> O =
      ( x e. ( B X. B ) , y e. B |->
        ( g e. ( ( 2nd ` x ) K y ) , f e. ( K ` x ) |->
        <. ( ( 1st ` g ) ( <. ( 1st ` ( 1st ` x ) ) ,
          ( 1st ` ( 2nd ` x ) ) >. .x. ( 1st ` y ) ) ( 1st ` f ) ) ,
           ( ( 2nd ` g ) ( <. ( 2nd ` ( 1st ` x ) ) ,
          ( 2nd ` ( 2nd ` x ) ) >. .xb ( 2nd ` y ) ) ( 2nd ` f ) ) >. ) ) ) $.
    $( Value of the binary product of categories.  (Contributed by Mario
       Carneiro, 10-Jan-2017.) $)
    xpcval $p |- ( ph -> T = { <. ( Base ` ndx ) , B >. ,
        <. ( Hom ` ndx ) , K >. , <. ( comp ` ndx ) , O >. } ) $=
      ( vr vs vb vh cxpc co cnx cbs cfv cop chom cco ctp cvv cv c1st c2nd cmpt2
      cxp csb wceq df-xpc a1i wa wcel fvex simprl fveq2d syl6eqr simprr xpeq12d
      adantr eqtr4d vex mpt2ex simpr simplrl oveqd simplrr mpt2eq123dv ad2antrr
      xpex simplr opeq2d fveq1d opeq12d ad3antrrr tpeq123d csbied2 elex ovmpt2d
      syl tpex syl5eq ) AJGHURUSUTVAVBZFVCZUTVDVBZPVCZUTVEVBZQVCZVFZUBAUNUOGHVG
      VGUPUNVHZVAVBZUOVHZVAVBZVLZUQEDUPVHZXTEVHZVIVBZDVHZVIVBZXOVDVBZUSZYAVJVBZ
      YCVJVBZXQVDVBZUSZVLZVKZXHXTVCZXJUQVHZVCZXLBCXTXTVLZXTMLBVHZVJVBZCVHZYNUSZ
      YQYNVBZMVHZVIVBZLVHZVIVBZYQVIVBZVIVBYRVIVBVCZYSVIVBZXOVEVBZUSZUSZUUBVJVBZ
      UUDVJVBZUUFVJVBYRVJVBVCZYSVJVBZXQVEVBZUSZUSZVCZVKZVKZVCZVFZVMZVMZXNURVGUR
      UNUOVGVGUVEVKVNABCDELMUQUOUNUPVOVPAXOGVNZXQHVNZVQZVQZUPXSFUVDXNVGXSVGVRUV
      IXPXRXOVAVSXQVAVSWOVPUVIXSTUAVLZFUVIXPTXRUAUVIXPGVAVBTUVIXOGVAAUVFUVGVTWA
      UCWBUVIXRHVAVBUAUVIXQHVAAUVFUVGWCWAUDWBWDAFUVJVNUVHUKWEWFUVIXTFVNZVQZUQYL
      PUVCXNVGYLVGVRUVLEDXTXTYKUPWGZUVMWHVPUVLYLEDFFYBYDNUSZYGYHOUSZVLZVKZPUVLE
      DXTXTYKFFUVPUVIUVKWIZUVRUVLYFUVNYJUVOUVLYENYBYDUVLYEGVDVBNUVLXOGVDAUVFUVG
      UVKWJZWAUEWBWKUVLYIOYGYHUVLYIHVDVBOUVLXQHVDAUVFUVGUVKWLZWAUFWBWKWDWMAPUVQ
      VNUVHUVKULWNWFUVLYNPVNZVQZYMXIYOXKUVBXMUWBXTFXHUVIUVKUWAWPZWQUWBYNPXJUVLU
      WAWIZWQUWBUVAQXLUWBUVABCFFVLZFMLYRYSPUSZYQPVBZUUCUUEUUGUUHKUSZUSZUULUUMUU
      NUUOIUSZUSZVCZVKZVKZQUWBBCYPXTUUTUWEFUWMUWBXTFXTFUWCUWCWDUWCUWBMLYTUUAUUS
      UWFUWGUWLUWBYNPYRYSUWDWKUWBYQYNPUWDWRUWBUUKUWIUURUWKUWBUUJUWHUUCUUEUWBUUI
      KUUGUUHUWBUUIGVEVBKUWBXOGVEUVLUVFUWAUVSWEWAUGWBWKWKUWBUUQUWJUULUUMUWBUUPI
      UUNUUOUWBUUPHVEVBIUWBXQHVEUVLUVGUWAUVTWEWAUHWBWKWKWSWMWMAQUWNVNUVHUVKUWAU
      MWTWFWQXAXBXBAGRVRGVGVRUIGRXCXEAHSVRHVGVRUJHSXCXEXNVGVRAXIXKXMXFVPXDXG $.
  $}

  ${
    $d f g u v x y C $.  $d f g u v x y D $.  $d f g u v x y X $.
    $d f g u v x y Y $.
    xpcbas.t $e |- T = ( C Xc. D ) $.
    xpcbas.x $e |- X = ( Base ` C ) $.
    xpcbas.y $e |- Y = ( Base ` D ) $.
    $( Set of objects of the binary product of categories.  (Contributed by
       Mario Carneiro, 10-Jan-2017.) $)
    xpcbas $p |- ( X X. Y ) = ( Base ` T ) $=
      ( cvv cbs cfv wceq cop cv c1st co c2nd eqid c0 cxpc vu vv vx vy vg vf cxp
      wcel wa cnx chom cmpt2 cco ctp c1 c5 cdc simpl simpr xpcval catstr baseid
      eqidd snsstp1 fvex eqeltri xpex a1i strfv3 eqcomd wn base0 syl5eq orim12i
      fvprc ianor xpeq0 3imtr4i wfn cdm fnxpc fndm ax-mp fveq2d 3eqtr4a pm2.61i
      wo ndmov ) AIUHZBIUHZUIZDEUGZCJKZLWKWMWLWKWMWLUJJKWLMZUJUKKUAUBWLWLUANZOK
      UBNZOKAUKKZPWOQKWPQKBUKKZPUGULZMZUJUMKUCUDWLWLUGWLUEUFUCNZQKZUDNZWSPXAWSK
      UENZOKUFNZOKXAOKZOKXBOKMXCOKAUMKZPPXDQKXEQKXFQKXBQKMXCQKBUMKZPPMULULZMZUN
      CJIUOUOUPUQMWKUCUDUBUAWLABXHCXGUFUEWQWRWSXIIIDEFGHWQRWRRXGRXHRWIWJURWIWJU
      SWKWLVCWKWSVCWKXIVCUTXIWLWSVAVBWNWTXJVDWLIUHWKDEDAJKZIGAJVEVFEBJKZIHBJVEV
      FVGVHWMRVIVJWKVKZSSJKWLWMVLWIVKZWJVKZWGDSLZESLZWGXMWLSLXNXPXOXQXNDXKSGAJV
      OVMXOEXLSHBJVOVMVNWIWJVPDEVQVRXMCSJXMCABTPSFABITTIIUGZVSTVTXRLWAXRTWBWCWH
      VMWDWEWF $.
  $}

  ${
    $d f g u v x y B $.  $d f g u v x y C $.  $d f g u v x y D $.  $d u v X $.
    $d f g u v x y H $.  $d f g u v x y J $.  $d u v Y $.
    xpchomfval.t $e |- T = ( C Xc. D ) $.
    xpchomfval.y $e |- B = ( Base ` T ) $.
    xpchomfval.h $e |- H = ( Hom ` C ) $.
    xpchomfval.j $e |- J = ( Hom ` D ) $.
    xpchomfval.k $e |- K = ( Hom ` T ) $.
    $( Set of morphisms of the binary product of categories.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    xpchomfval $p |- K = ( u e. B , v e. B |->
      ( ( ( 1st ` u ) H ( 1st ` v ) ) X. ( ( 2nd ` u ) J ( 2nd ` v ) ) ) ) $=
      ( cvv c1st cfv co c2nd c0 vx vy vg vf wcel wa cxp cmpt2 wceq cnx cbs chom
      cv cop cco ctp c1 c5 cdc eqid simpl simpr xpcbas eqtr4i a1i xpcval catstr
      eqidd homid snsstp2 fvex eqeltri mpt2ex strfv3 wn mpt20 eqcomi cxpc fnxpc
      wfn fndm ax-mp ndmov syl5eq fveq2d str0 3eqtr4g base0 mpt2eq123dv 3eqtr4a
      cdm pm2.61i ) DOUEZEOUEZUFZIBACCBUMZPQAUMZPQGRWPSQWQSQHRUGZUHZUIWOIWSUJUK
      QCUNZUJULQZWSUNZUJUOQUAUBCCUGCUCUDUAUMZSQZUBUMZWSRXCWSQUCUMZPQUDUMZPQXCPQ
      ZPQXDPQUNXEPQDUOQZRRXFSQXGSQXHSQXDSQUNXESQEUOQZRRUNUHUHZUNZUPFULOUQUQURUS
      UNWOUAUBABCDEXJFXIUDUCGHWSXKOODUKQZEUKQZJXMUTZXNUTZLMXIUTXJUTWMWNVAWMWNVB
      CXMXNUGZUIWOCFUKQZXQKDEFXMXNJXOXPVCVDVEWOWSVHWOXKVHVFXKCWSVGVIWTXBXLVJWSO
      UEWOBACCWRCXROKFUKVKVLZXSVMVENVNWOVOZTBATTWRUHZIWSYATBATWRVPVQXTFULQTULQI
      TXTFTULXTFDEVRRTJDEOVRVROOUGZVTVRWKYBUIVSYBVRWAWBWCWDZWENULXAVIWFWGXTBACC
      WRTTWRXTXRTUKQCTXTFTUKYCWEKWHWGZYDXTWRVHWIWJWL $.

    xpchom.x $e |- ( ph -> X e. B ) $.
    xpchom.y $e |- ( ph -> Y e. B ) $.
    $( Set of morphisms of the binary product of categories.  (Contributed by
       Mario Carneiro, 11-Jan-2017.) $)
    xpchom $p |- ( ph -> ( X K Y ) =
      ( ( ( 1st ` X ) H ( 1st ` Y ) ) X. ( ( 2nd ` X ) J ( 2nd ` Y ) ) ) ) $=
      ( c1st cfv c2nd vu vv wcel co cxp wceq cv wa simpl fveq2d oveq12d xpeq12d
      simpr xpchomfval ovex xpex ovmpt2a syl2anc ) AIBUCJBUCIJHUDIRSZJRSZFUDZIT
      SZJTSZGUDZUEZUFPQUAUBIJBBUAUGZRSZUBUGZRSZFUDZVFTSZVHTSZGUDZUEVEHVFIUFZVHJ
      UFZUHZVJVAVMVDVPVGUSVIUTFVPVFIRVNVOUIZUJVPVHJRVNVOUMZUJUKVPVKVBVLVCGVPVFI
      TVQUJVPVHJTVRUJUKULUBUABCDEFGHKLMNOUNVAVDUSUTFUOVBVCGUOUPUQUR $.
  $}

  ${
    $d u v C $.  $d u v D $.  $d u v T $.
    relxpchom.t $e |- T = ( C Xc. D ) $.
    relxpchom.k $e |- K = ( Hom ` T ) $.
    $( A hom-set in the binary product of categories is a relation.
       (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    relxpchom $p |- Rel ( X K Y ) $=
      ( vu vv co cvv cxp wss cv c1st cfv chom c2nd eqid wrel cbs rgen2w ovmptss
      wral xpss xpchomfval ax-mp df-rel mpbir ) EFDKZUAUKLLMZNZIOZPQJOZPQARQZKZ
      UNSQUOSQBRQZKZMZULNZJCUBQZUEIVBUEUMVAIJVBVBUQUSUFUCIJVBVBUTEDFULJIVBABCUP
      URDGVBTUPTURTHUGUDUHUKUIUJ $.
  $}

  ${
    $d f g u v x y B $.  $d f g u v x y C $.  $d f g x y F $.  $d f g x y ph $.
    $d f g u v x y D $.  $d f g x y G $.  $d f g x y .x. $.  $d f g x y .xb $.
    $d f g x y K $.  $d f g x y X $.  $d f g x y Y $.  $d f g x y Z $.
    $d x y O $.
    xpccofval.t $e |- T = ( C Xc. D ) $.
    xpccofval.b $e |- B = ( Base ` T ) $.
    xpccofval.k $e |- K = ( Hom ` T ) $.
    xpccofval.o1 $e |- .x. = ( comp ` C ) $.
    xpccofval.o2 $e |- .xb = ( comp ` D ) $.
    xpccofval.o $e |- O = ( comp ` T ) $.
    $( Value of composition in the binary product of categories.  (Contributed
       by Mario Carneiro, 11-Jan-2017.) $)
    xpccofval $p |- O = ( x e. ( B X. B ) , y e. B |->
        ( g e. ( ( 2nd ` x ) K y ) , f e. ( K ` x ) |->
        <. ( ( 1st ` g ) ( <. ( 1st ` ( 1st ` x ) ) ,
          ( 1st ` ( 2nd ` x ) ) >. .x. ( 1st ` y ) ) ( 1st ` f ) ) ,
           ( ( 2nd ` g ) ( <. ( 2nd ` ( 1st ` x ) ) ,
          ( 2nd ` ( 2nd ` x ) ) >. .xb ( 2nd ` y ) ) ( 2nd ` f ) ) >. ) ) $=
      ( cfv c0 vv vu cvv wcel wa cxp cv c2nd co c1st cop cmpt2 wceq cnx cbs cco
      chom ctp c1 c5 cdc eqid simpl simpr xpcbas eqtr4i xpchomfval eqidd xpcval
      catstr ccoid snsstp3 fvex eqeltri xpex mpt2ex strfv3 wn mpt20 eqcomi cxpc
      a1i wfn cdm fnxpc fndm ax-mp ndmov syl5eq fveq2d 3eqtr4g base0 xpeq2d xp0
      str0 syl6eq mpt2eq123dv 3eqtr4a pm2.61i ) DUCUDZEUCUDZUEZLABCCUFZCJIAUGZU
      HSZBUGZKUIXDKSJUGZUJSIUGZUJSXDUJSZUJSXEUJSUKXFUJSHUIUIXGUHSXHUHSXIUHSXEUH
      SUKXFUHSFUIUIUKULZULZUMXBLXKUNUOSCUKZUNUQSKUKZUNUPSZXKUKZURGUPUCUSUSUTVAU
      KXBABUAUBCDEFGHIJDUQSZEUQSZKXKUCUCDUOSZEUOSZMXRVBZXSVBZXPVBZXQVBZPQWTXAVC
      WTXAVDCXRXSUFZUMXBCGUOSZYDNDEGXRXSMXTYAVEVFWBKUBUACCUBUGZUJSUAUGZUJSXPUIY
      FUHSYGUHSXQUIUFULUMXBUAUBCDEGXPXQKMNYBYCOVGWBXBXKVHVIXKCKVJVKXLXMXOVLXKUC
      UDXBABXCCXJCCCYEUCNGUOVMVNZYHVOYHVPWBRVQXBVRZTABTTXJULZLXKYJTABTXJVSVTYIG
      UPSTUPSLTYIGTUPYIGDEWAUITMDEUCWAWAUCUCUFZWCWAWDYKUMWEYKWAWFWGWHWIZWJRUPXN
      VKWOWKYIABXCCXJTTXJYIXCCTUFTYICTCYIYETUOSCTYIGTUOYLWJNWLWKZWMCWNWPYMYIXJV
      HWQWRWS $.

    xpcco.x $e |- ( ph -> X e. B ) $.
    xpcco.y $e |- ( ph -> Y e. B ) $.
    xpcco.z $e |- ( ph -> Z e. B ) $.
    xpcco.f $e |- ( ph -> F e. ( X K Y ) ) $.
    xpcco.g $e |- ( ph -> G e. ( Y K Z ) ) $.
    $( Value of composition in the binary product of categories.  (Contributed
       by Mario Carneiro, 11-Jan-2017.) $)
    xpcco $p |- ( ph -> ( G ( <. X , Y >. O Z ) F ) =
        <. ( ( 1st ` G ) ( <. ( 1st ` X ) ,
          ( 1st ` Y ) >. .x. ( 1st ` Z ) ) ( 1st ` F ) ) ,
           ( ( 2nd ` G ) ( <. ( 2nd ` X ) ,
          ( 2nd ` Y ) >. .xb ( 2nd ` Z ) ) ( 2nd ` F ) ) >. ) $=
      ( vx vy vg vf cxp cv c2nd cfv co c1st cop wceq xpccofval cvv wcel opelxpi
      cmpt2 syl2anc adantr wa ovex mpt2ex a1i simprl fveq2d op2ndg eqtrd simprr
      fvex oveq12d eleqtrrd df-ov syl6eqr opex op1stg opeq12d simplrr ovmpt2dv2
      oveq123d ovmpt2dv mpi ) AKUFUGBBUJZBUHUIUFUKZULUMZUGUKZJUNZWHJUMZUHUKZUOU
      MZUIUKZUOUMZWHUOUMZUOUMZWIUOUMZUPZWJUOUMZGUNZUNZWMULUMZWOULUMZWQULUMZWIUL
      UMZUPZWJULUMZEUNZUNZUPZVBZVBUQIHLMUPZNKUNZUNIUOUMZHUOUMZLUOUMZMUOUMZUPZNU
      OUMZGUNZUNZIULUMZHULUMZLULUMZMULUMZUPZNULUMZEUNZUNZUPZUQZUFUGBCDEFGUIUHJK
      OPQRSTURAYMUFUGXNNWGBXMKUSALBUTZMBUTZXNWGUTUAUBLMBBVAVCANBUTWHXNUQZUCVDXM
      USUTAYPWJNUQZVEZVEZUHUIWKWLXLWIWJJVFWHJVNVGVHYSUHUIIHWKWLXLYLXOUSYSIMNJUN
      ZWKAIYTUTYRUEVDYSWIMWJNJYSWIXNULUMZMYSWHXNULAYPYQVIZVJAUUAMUQZYRAYNYOUUCU
      AUBLMBBVKVCVDVLZAYPYQVMVOVPYSHWLUTWMIUQZYSHLMJUNZWLAHUUFUTYRUDVDYSWLXNJUM
      UUFYSWHXNJUUBVJLMJVQVRVPVDXLUSUTYSUUEWOHUQZVEZVEZXCXKVSVHUUIXCYCXKYKUUIWN
      XPWPXQXBYBUUIWTXTXAYAGUUIWRXRWSXSUUIWQLUOYSWQLUQUUHYSWQXNUOUMZLYSWHXNUOUU
      BVJAUUJLUQZYRAYNYOUUKUAUBLMBBVTVCVDVLVDZVJUUIWIMUOYSWIMUQUUHUUDVDZVJWAUUI
      WJNUOAYPYQUUHWBZVJVOUUIWMIUOYSUUEUUGVIZVJUUIWOHUOYSUUEUUGVMZVJWDUUIXDYDXE
      YEXJYJUUIXHYHXIYIEUUIXFYFXGYGUUIWQLULUULVJUUIWIMULUUMVJWAUUIWJNULUUNVJVOU
      UIWMIULUUOVJUUIWOHULUUPVJWDWAWCWEWF $.
  $}

  ${
    xpcco1st.t $e |- T = ( C Xc. D ) $.
    xpcco1st.b $e |- B = ( Base ` T ) $.
    xpcco1st.k $e |- K = ( Hom ` T ) $.
    xpcco1st.o $e |- O = ( comp ` T ) $.
    xpcco1st.x $e |- ( ph -> X e. B ) $.
    xpcco1st.y $e |- ( ph -> Y e. B ) $.
    xpcco1st.z $e |- ( ph -> Z e. B ) $.
    xpcco1st.f $e |- ( ph -> F e. ( X K Y ) ) $.
    xpcco1st.g $e |- ( ph -> G e. ( Y K Z ) ) $.
    ${
      xpcco1st.1 $e |- .x. = ( comp ` C ) $.
      $( Value of composition in the binary product of categories.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      xpcco1st $p |- ( ph -> ( 1st ` ( G ( <. X , Y >. O Z ) F ) ) =
        ( ( 1st ` G ) ( <. ( 1st ` X ) ,
          ( 1st ` Y ) >. .x. ( 1st ` Z ) ) ( 1st ` F ) ) ) $=
        ( cop co c1st cfv c2nd cco wceq eqid xpcco ovex op1std syl ) AHGKLUDMJU
        EUEZHUFUGZGUFUGZKUFUGLUFUGUDMUFUGFUEZUEZHUHUGZGUHUGZKUHUGLUHUGUDMUHUGDU
        IUGZUEZUEZUDUJUPUFUGUTUJABCDVCEFGHIJKLMNOPUCVCUKQRSTUAUBULUTVEUPUQURUSU
        MVAVBVDUMUNUO $.
    $}

    ${
      xpcco2nd.1 $e |- .x. = ( comp ` D ) $.
      $( Value of composition in the binary product of categories.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      xpcco2nd $p |- ( ph -> ( 2nd ` ( G ( <. X , Y >. O Z ) F ) ) =
        ( ( 2nd ` G ) ( <. ( 2nd ` X ) ,
          ( 2nd ` Y ) >. .x. ( 2nd ` Z ) ) ( 2nd ` F ) ) ) $=
        ( cop co c1st cfv cco c2nd wceq eqid xpcco ovex op2ndd syl ) AHGKLUDMJU
        EUEZHUFUGZGUFUGZKUFUGLUFUGUDMUFUGCUHUGZUEZUEZHUIUGZGUIUGZKUIUGLUIUGUDMU
        IUGFUEZUEZUDUJUPUIUGVEUJABCDFEUSGHIJKLMNOPUSUKUCQRSTUAUBULVAVEUPUQURUTU
        MVBVCVDUMUNUO $.
    $}
  $}

  ${
    xpcco2.t $e |- T = ( C Xc. D ) $.
    xpcco2.x $e |- X = ( Base ` C ) $.
    xpcco2.y $e |- Y = ( Base ` D ) $.
    xpcco2.h $e |- H = ( Hom ` C ) $.
    xpcco2.j $e |- J = ( Hom ` D ) $.
    xpcco2.m $e |- ( ph -> M e. X ) $.
    xpcco2.n $e |- ( ph -> N e. Y ) $.
    xpcco2.p $e |- ( ph -> P e. X ) $.
    xpcco2.q $e |- ( ph -> Q e. Y ) $.
    ${
      xpchom2.k $e |- K = ( Hom ` T ) $.
      $( Value of the set of morphisms in the binary product of categories.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      xpchom2 $p |- ( ph ->
        ( <. M , N >. K <. P , Q >. ) = ( ( M H P ) X. ( N J Q ) ) ) $=
        ( cop c1st cfv c2nd cxp xpcbas wcel opelxpi syl2anc xpchom wceq oveq12d
        co op1stg op2ndg xpeq12d eqtrd ) AJKUDZDEUDZIUPVAUEUFZVBUEUFZGUPZVAUGUF
        ZVBUGUFZHUPZUHJDGUPZKEHUPZUHALMUHZBCFGHIVAVBNBCFLMNOPUIQRUCAJLUJZKMUJZV
        AVKUJSTJKLMUKULADLUJZEMUJZVBVKUJUAUBDELMUKULUMAVEVIVHVJAVCJVDDGAVLVMVCJ
        UNSTJKLMUQULAVNVOVDDUNUAUBDELMUQULUOAVFKVGEHAVLVMVFKUNSTJKLMURULAVNVOVG
        EUNUAUBDELMURULUOUSUT $.
    $}

    xpcco2.o1 $e |- .x. = ( comp ` C ) $.
    xpcco2.o2 $e |- .xb = ( comp ` D ) $.
    xpcco2.o $e |- O = ( comp ` T ) $.
    xpcco2.r $e |- ( ph -> R e. X ) $.
    xpcco2.s $e |- ( ph -> S e. Y ) $.
    xpcco2.f $e |- ( ph -> F e. ( M H P ) ) $.
    xpcco2.g $e |- ( ph -> G e. ( N J Q ) ) $.
    xpcco2.k $e |- ( ph -> K e. ( P H R ) ) $.
    xpcco2.l $e |- ( ph -> L e. ( Q J S ) ) $.
    $( Value of composition in the binary product of categories.  (Contributed
       by Mario Carneiro, 11-Jan-2017.) $)
    xpcco2 $p |- ( ph -> ( <. K , L >. ( <. <. M , N >. ,
      <. P , Q >. >. O <. R , S >. ) <. F , G >. ) =
        <. ( K ( <. M , P >. .x. R ) F ) ,
           ( L ( <. N , Q >. .xb S ) G ) >. ) $=
      ( cop co c1st cfv c2nd cxp chom xpcbas eqid wcel opelxpi syl2anc eleqtrrd
      xpchom2 xpcco wceq op1stg opeq12d oveq12d oveq123d op2ndg eqtrd ) AOPUTZK
      LUTZQRUTZDEUTZUTFGUTZSVAVAWBVBVCZWCVBVCZWDVBVCZWEVBVCZUTZWFVBVCZJVAZVAZWB
      VDVCZWCVDVCZWDVDVCZWEVDVCZUTZWFVDVCZHVAZVAZUTOKQDUTZFJVAZVAZPLREUTZGHVAZV
      AZUTATUAVEZBCHIJWCWBIVFVCZSWDWEWFUBBCITUAUBUCUDVGXJVHZUKULUMAQTVIZRUAVIZW
      DXIVIUGUHQRTUAVJVKADTVIZEUAVIZWEXIVIUIUJDETUAVJVKAFTVIZGUAVIZWFXIVIUNUOFG
      TUAVJVKAWCQDMVAZRENVAZVEZWDWEXJVAAKXRVIZLXSVIZWCXTVIUPUQKLXRXSVJVKABCDEIM
      NXJQRTUAUBUCUDUEUFUGUHUIUJXKVMVLAWBDFMVAZEGNVAZVEZWEWFXJVAAOYCVIZPYDVIZWB
      YEVIURUSOPYCYDVJVKABCFGIMNXJDETUAUBUCUDUEUFUIUJUNUOXKVMVLVNAWNXEXBXHAWGOW
      HKWMXDAWKXCWLFJAWIQWJDAXLXMWIQVOUGUHQRTUAVPVKAXNXOWJDVOUIUJDETUAVPVKVQAXP
      XQWLFVOUNUOFGTUAVPVKVRAYFYGWGOVOURUSOPYCYDVPVKAYAYBWHKVOUPUQKLXRXSVPVKVSA
      WOPWPLXAXGAWSXFWTGHAWQRWREAXLXMWQRVOUGUHQRTUAVTVKAXNXOWREVOUIUJDETUAVTVKV
      QAXPXQWTGVOUNUOFGTUAVTVKVRAYFYGWOPVOURUSOPYCYDVTVKAYAYBWPLVOUPUQKLXRXSVTV
      KVSVQWA $.
  $}

  ${
    $d f g h s t u v x y I $.  $d f g h s t u v x y J $.  $d f g h s t u v T $.
    $d x y C $.  $d f g h s t u v x y ph $.  $d f g h s t u v x y X $.
    $d x y D $.  $d x y R $.  $d x y S $.  $d f g h s t u v x y Y $.
    xpccat.t $e |- T = ( C Xc. D ) $.
    xpccat.c $e |- ( ph -> C e. Cat ) $.
    xpccat.d $e |- ( ph -> D e. Cat ) $.
    ${
      xpccat.x $e |- X = ( Base ` C ) $.
      xpccat.y $e |- Y = ( Base ` D ) $.
      xpccat.i $e |- I = ( Id ` C ) $.
      xpccat.j $e |- J = ( Id ` D ) $.
      $( The product of two categories is a category.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      xpccatid $p |- ( ph -> ( T e. Cat /\ ( Id ` T ) = ( x e. X , y e. Y |->
        <. ( I ` x ) , ( J ` y ) >. ) ) ) $=
        ( wcel cfv co vt vs vu vv vf vg vh ccat ccid cxp cv c1st c2nd cmpt wceq
        cop cmpt2 chom w3a cco cvv cbs xpcbas eqidd cxpc ovex eqeltri biid eqid
        wa a1i adantr xp1st adantl catidcl xp2nd opelxpi syl2anc simpr eleqtrrd
        xpchom op1st oveq1i simpr1l simpr1r simpr31 eleqtrd catlid syl5eq op2nd
        fvex opeq12d syldan xpcco 1st2nd2 3eqtr4d oveq2i simpr2l simpr32 catrid
        syl catcocl 3eltr4d simpr2r simpr33 catass fveq2d syl6eq oveq1d iscatd2
        oveq2d vex op1std op2ndd mpt2mpt eqeq2i anbi2i sylib ) AFUHRZFUISZUAIJU
        JZUAUKZULSZGSZYBUMSZHSZUPZUNZUOZVJXSXTBCIJBUKZGSZCUKZHSZUPZUQZUOZVJAUBU
        KZYARZYBYARZVJZUCUKZYARZUDUKZYARZVJZUEUKZYQYBFURSZTZRZUFUKZYBUUAUUGTZRZ
        UGUKZUUAUUCUUGTZRZUSZUSZUBUAUCUDYAFFUTSZYGUEUFUGUUGVAYAFVBSUOADEFIJKNOV
        CZVKAUUGVDAUURVDFVARAFDEVETVAKDEVEVFVGVKUUQVHAYSVJZYGYCYCDURSZTZYEYEEUR
        SZTZUJZYBYBUUGTZUUTYDUVBRYFUVDRYGUVERUUTIDGUVAYCNUVAVIZPADUHRZYSLVLYSYC
        IRZAYBIJVMZVNVOUUTJEHUVCYEOUVCVIZQAEUHRZYSMVLYSYEJRZAYBIJVPZVNVOYDYFUVB
        UVDVQVRUUTYADEFUVAUVCUUGYBYBKUUSUVGUVKUUGVIZAYSVSZUVPWAVTZAUUQVJZYGULSZ
        UUFULSZYQULSZYCUPZYCDUTSZTZTZYGUMSZUUFUMSZYQUMSZYEUPZYEEUTSZTZTZUPUVTUW
        GUPZYGUUFYQYBUPZYBUURTTUUFUVRUWEUVTUWLUWGUVRUWEYDUVTUWDTUVTUVSYDUVTUWDY
        DYFYCGWKZYEHWKZWBZWCUVRIDUWCGUVTUVAUWAYCNUVGPAUVHUUQLVLZUVRYRUWAIRYRYSU
        UEUUPAWDZYQIJVMXAZUWCVIZUVRYSUVIYRYSUUEUUPAWEZUVJXAZUVRUUFUWAYCUVATZUWH
        YEUVCTZUJZRZUVTUXDRUVRUUFUUHUXFUUIUULUUOYTUUEAWFZUVRYADEFUVAUVCUUGYQYBK
        UUSUVGUVKUVOUWSUXBWAWGZUUFUXDUXEVMXAZWHWIUVRUWLYFUWGUWKTUWGUWFYFUWGUWKY
        DYFUWOUWPWJZWCUVRJEUWJHUWGUVCUWHYEOUVKQAUVLUUQMVLZUVRYRUWHJRUWSYQIJVPXA
        ZUWJVIZUVRYSUVMUXBUVNXAZUVRUXGUWGUXERUXIUUFUXDUXEVPXAZWHWIWLUVRYADEUWJF
        UWCUUFYGUUGUURYQYBYBKUUSUVOUXAUXNUURVIZUWSUXBUXBUXHAUUQYSYGUVFRUXBUVQWM
        ZWNUVRUXGUUFUWMUOUXIUUFUXDUXEWOXAWPUVRUUJULSZUVSYCYCUPUUAULSZUWCTZTZUUJ
        UMSZUWFYEYEUPUUAUMSZUWJTZTZUPUXSUYCUPZUUJYGYBYBUPUUAUURTTUUJUVRUYBUXSUY
        FUYCUVRUYBUXSYDUYATUXSUVSYDUXSUYAUWQWQUVRIDUWCGUXSUVAYCUXTNUVGPUWRUXCUX
        AUVRUUBUXTIRUUBUUDYTUUPAWRZUUAIJVMXAZUVRUUJYCUXTUVATZYEUYDUVCTZUJZRZUXS
        UYJRUVRUUJUUKUYLUUIUULUUOYTUUEAWSZUVRYADEFUVAUVCUUGYBUUAKUUSUVGUVKUVOUX
        BUYHWAWGZUUJUYJUYKVMXAZWTWIUVRUYFUYCYFUYETUYCUWFYFUYCUYEUXKWQUVRJEUWJHU
        YCUVCYEUYDOUVKQUXLUXOUXNUVRUUBUYDJRUYHUUAIJVPXAZUVRUYMUYCUYKRUYOUUJUYJU
        YKVPXAZWTWIWLUVRYADEUWJFUWCYGUUJUUGUURYBYBUUAKUUSUVOUXAUXNUXQUXBUXBUYHU
        XRUYNWNUVRUYMUUJUYGUOUYOUUJUYJUYKWOXAWPUVRUXSUVTUWBUXTUWCTZTZUYCUWGUWIU
        YDUWJTZTZUPZUWAUXTUVATZUWHUYDUVCTZUJZUUJUUFUWNUUAUURTTZYQUUAUUGTUVRUYTV
        UDRVUBVUERVUCVUFRUVRIDUWCUVTUXSUVAUWAYCUXTNUVGUXAUWRUWTUXCUYIUXJUYPXBUV
        RJEUWJUWGUYCUVCUWHYEUYDOUVKUXNUXLUXMUXOUYQUXPUYRXBUYTVUBVUDVUEVQVRUVRYA
        DEUWJFUWCUUFUUJUUGUURYQYBUUAKUUSUVOUXAUXNUXQUWSUXBUYHUXHUYNWNZUVRYADEFU
        VAUVCUUGYQUUAKUUSUVGUVKUVOUWSUYHWAXCZUVRUUMUUJYBUUAUPUUCUURTTZULSZUVTUW
        BUUCULSZUWCTZTZVUJUMSZUWGUWIUUCUMSZUWJTZTZUPUUMULSZVUGULSZUWAUXTUPVULUW
        CTZTZUUMUMSZVUGUMSZUWHUYDUPVUPUWJTZTZUPVUJUUFUWNUUCUURTTUUMVUGYQUUAUPUU
        CUURTTUVRVUNVVBVURVVFUVRVUSUXSYCUXTUPVULUWCTZTZUVTVUMTVUSUYTVVATVUNVVBU
        VRIDUWCUVTUXSUVAVUSVULUWAYCUXTNUVGUXAUWRUWTUXCUYIUXJUYPUVRUUDVULIRUUBUU
        DYTUUPAXDZUUCIJVMXAZUVRUUMUXTVULUVATZUYDVUPUVCTZUJZRZVUSVVKRUVRUUMUUNVV
        MUUIUULUUOYTUUEAXEZUVRYADEFUVAUVCUUGUUAUUCKUUSUVGUVKUVOUYHVVIWAWGZUUMVV
        KVVLVMXAZXFUVRVUKVVHUVTVUMUVRVUKVVHVVCUYCYEUYDUPVUPUWJTZTZUPZULSVVHUVRV
        UJVVTULUVRYADEUWJFUWCUUJUUMUUGUURYBUUAUUCKUUSUVOUXAUXNUXQUXBUYHVVIUYNVV
        OWNZXGVVHVVSVUSUXSVVGVFZVVCUYCVVRVFZWBXHXIUVRVUTUYTVUSVVAUVRVUTVUCULSUY
        TUVRVUGVUCULVUHXGUYTVUBUXSUVTUYSVFZUYCUWGVUAVFZWBXHXKWPUVRVVSUWGVUQTVVC
        VUBVVETVURVVFUVRJEUWJUWGUYCUVCVVCVUPUWHYEUYDOUVKUXNUXLUXMUXOUYQUXPUYRUV
        RUUDVUPJRVVIUUCIJVPXAZUVRVVNVVCVVLRVVPUUMVVKVVLVPXAZXFUVRVUOVVSUWGVUQUV
        RVUOVVTUMSVVSUVRVUJVVTUMVWAXGVVHVVSVWBVWCWJXHXIUVRVVDVUBVVCVVEUVRVVDVUC
        UMSVUBUVRVUGVUCUMVUHXGUYTVUBVWDVWEWJXHXKWPWLUVRYADEUWJFUWCUUFVUJUUGUURY
        QYBUUCKUUSUVOUXAUXNUXQUWSUXBVVIUXHUVRVVTYCVULUVATZYEVUPUVCTZUJZVUJYBUUC
        UUGTUVRVVHVWHRVVSVWIRVVTVWJRUVRIDUWCUXSVUSUVAYCUXTVULNUVGUXAUWRUXCUYIVV
        JUYPVVQXBUVRJEUWJUYCVVCUVCYEUYDVUPOUVKUXNUXLUXOUYQVWFUYRVWGXBVVHVVSVWHV
        WIVQVRVWAUVRYADEFUVAUVCUUGYBUUCKUUSUVGUVKUVOUXBVVIWAXCWNUVRYADEUWJFUWCV
        UGUUMUUGUURYQUUAUUCKUUSUVOUXAUXNUXQUWSUYHVVIVUIVVOWNWPXJYIYPXSYHYOXTBCU
        AIJYGYNYBYJYLUPUOZYDYKYFYMVWKYCYJGYJYLYBBXLZCXLZXMXGVWKYEYLHYJYLYBVWLVW
        MXNXGWLXOXPXQXR $.

      xpcid.1 $e |- .1. = ( Id ` T ) $.
      xpcid.r $e |- ( ph -> R e. X ) $.
      xpcid.s $e |- ( ph -> S e. Y ) $.
      $( The identity morphism in the product of categories.  (Contributed by
         Mario Carneiro, 11-Jan-2017.) $)
      xpcid $p |- ( ph ->
        ( .1. ` <. R , S >. ) = <. ( I ` R ) , ( J ` S ) >. ) $=
        ( vx vy cop cfv co df-ov cv cvv ccid cmpt2 ccat wcel wceq simprd syl5eq
        xpccatid wa simprl fveq2d simprr opeq12d opex a1i ovmpt2d syl5eqr ) ADE
        UDGUEDEGUFDHUEZEIUEZUDZDEGUGAUBUCDEJKUBUHZHUEZUCUHZIUEZUDZVIGUIAGFUJUEZ
        UBUCJKVNUKZSAFULUMVOVPUNAUBUCBCFHIJKLMNOPQRUQUOUPAVJDUNZVLEUNZURURZVKVG
        VMVHVSVJDHAVQVRUSUTVSVLEIAVQVRVAUTVBTUAVIUIUMAVGVHVCVDVEVF $.
    $}

    $( The product of two categories is a category.  (Contributed by Mario
       Carneiro, 11-Jan-2017.) $)
    xpccat $p |- ( ph -> T e. Cat ) $=
      ( vx vy ccat wcel ccid cfv cbs cv cop cmpt2 wceq eqid xpccatid simpld ) A
      DJKDLMHIBNMZCNMZHOBLMZMIOCLMZMPQRAHIBCDUDUEUBUCEFGUBSUCSUDSUESTUA $.
  $}

  ${
    $d b c d x y B $.  $d b c d x y C $.  $d b c d x y D $.  $d b c d x y H $.
    $d x y ph $.  $d x y R $.  $d x y S $.
    1stfval.t $e |- T = ( C Xc. D ) $.
    1stfval.b $e |- B = ( Base ` T ) $.
    1stfval.h $e |- H = ( Hom ` T ) $.
    1stfval.c $e |- ( ph -> C e. Cat ) $.
    1stfval.d $e |- ( ph -> D e. Cat ) $.
    ${
      1stfval.p $e |- P = ( C 1stF D ) $.
      $( Value of the first projection functor.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      1stfval $p |- ( ph -> P = <. ( 1st |` B ) ,
        ( x e. B , y e. B |-> ( 1st |` ( x H y ) ) ) >. ) $=
        ( co c1st cv cbs cfv vc vd c1stf cres cmpt2 cop ccat wcel wceq cxp cxpc
        vb chom csb wa cvv fvex xpex a1i simpl fveq2d simpr xpeq12d eqid xpcbas
        eqtr4i syl6eq reseq2d simpll simplr oveq12d syl6eqr mpt2eq123dv opeq12d
        oveqd csbied2 df-1stf opex ovmpt2a syl2anc syl5eq ) AGEFUCPZQDUDZBCDDQB
        RZCRZIPZUDZUEZUFZOAEUGUHFUGUHWBWIUIMNUAUBEFUGUGULUARZSTZUBRZSTZUJZQULRZ
        UDZBCWOWOQWDWEWJWLUKPZUMTZPZUDZUEZUFZUNWIUCWJEUIZWLFUIZUOZULWNDXBWIUPWN
        UPUHXEWKWMWJSUQWLSUQURUSXEWNESTZFSTZUJZDXEWKXFWMXGXEWJESXCXDUTVAXEWLFSX
        CXDVBVAVCXHHSTDEFHXFXGJXFVDXGVDVEKVFVGXEWODUIZUOZWPWCXAWHXJWODQXEXIVBZV
        HXJBCWOWOWTDDWGXKXKXJWSWFQXJWRIWDWEXJWRHUMTIXJWQHUMXJWQEFUKPHXJWJEWLFUK
        XCXDXIVIXCXDXIVJVKJVLVALVLVOVHVMVNVPBCUBUAULVQWCWHVRVSVTWA $.

      1stf1.p $e |- ( ph -> R e. B ) $.
      $( Value of the first projection on an object.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      1stf1 $p |- ( ph -> ( ( 1st ` P ) ` R ) = ( 1st ` R ) ) $=
        ( vx vy c1st cfv cvv cres cv cmpt2 cop wceq 1stfval wfun wcel wfo fo1st
        co fofun ax-mp cbs fvex eqeltri resfunexg mp2an mpt2ex op1std syl fvres
        fveq1d eqtrd ) AFERSZSFRBUAZSZFRSZAFVEVFAEVFPQBBRPUBQUBHUKUAZUCZUDUEVEV
        FUEAPQBCDEGHIJKLMNUFVFVJERUGZBTUHVFTUHTTRUIVKUJTTRULUMBGUNSTJGUNUOUPZRB
        TUQURPQBBVIVLVLUSUTVAVCAFBUHVGVHUEOFBRVBVAVD $.

      1stf2.p $e |- ( ph -> S e. B ) $.
      $( Value of the first projection on a morphism.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      1stf2 $p |- ( ph -> ( R ( 2nd ` P ) S ) = ( 1st |` ( R H S ) ) ) $=
        ( vx c1st cvv vy cv co cres c2nd cfv cmpt2 wceq 1stfval wfun wcel fo1st
        cop wfo fofun ax-mp cbs fvex eqeltri resfunexg mpt2ex op2ndd syl simprl
        mp2an wa simprr oveq12d reseq2d ovex a1i ovmpt2d ) ARUAFGBBSRUBZUAUBZIU
        CZUDZSFGIUCZUDZEUEUFZTAESBUDZRUABBVPUGZUMUHVSWAUHARUABCDEHIJKLMNOUIVTWA
        ESUJZBTUKVTTUKTTSUNWBULTTSUOUPZBHUQUFTKHUQURUSZSBTUTVERUABBVPWDWDVAVBVC
        AVMFUHZVNGUHZVFVFZVOVQSWGVMFVNGIAWEWFVDAWEWFVGVHVIPQVRTUKZAWBVQTUKWHWCF
        GIVJSVQTUTVEVKVL $.
    $}

    ${
      2ndfval.p $e |- Q = ( C 2ndF D ) $.
      $( Value of the first projection functor.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      2ndfval $p |- ( ph -> Q = <. ( 2nd |` B ) ,
        ( x e. B , y e. B |-> ( 2nd |` ( x H y ) ) ) >. ) $=
        ( co c2nd cv cbs cfv vc vd c2ndf cres cmpt2 cop ccat wcel wceq cxp cxpc
        vb chom csb wa cvv fvex xpex a1i simpl fveq2d simpr xpeq12d eqid xpcbas
        eqtr4i syl6eq reseq2d simpll simplr oveq12d syl6eqr mpt2eq123dv opeq12d
        oveqd csbied2 df-2ndf opex ovmpt2a syl2anc syl5eq ) AGEFUCPZQDUDZBCDDQB
        RZCRZIPZUDZUEZUFZOAEUGUHFUGUHWBWIUIMNUAUBEFUGUGULUARZSTZUBRZSTZUJZQULRZ
        UDZBCWOWOQWDWEWJWLUKPZUMTZPZUDZUEZUFZUNWIUCWJEUIZWLFUIZUOZULWNDXBWIUPWN
        UPUHXEWKWMWJSUQWLSUQURUSXEWNESTZFSTZUJZDXEWKXFWMXGXEWJESXCXDUTVAXEWLFSX
        CXDVBVAVCXHHSTDEFHXFXGJXFVDXGVDVEKVFVGXEWODUIZUOZWPWCXAWHXJWODQXEXIVBZV
        HXJBCWOWOWTDDWGXKXKXJWSWFQXJWRIWDWEXJWRHUMTIXJWQHUMXJWQEFUKPHXJWJEWLFUK
        XCXDXIVIXCXDXIVJVKJVLVALVLVOVHVMVNVPBCUBUAULVQWCWHVRVSVTWA $.

      2ndf1.p $e |- ( ph -> R e. B ) $.
      $( Value of the first projection on an object.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      2ndf1 $p |- ( ph -> ( ( 1st ` Q ) ` R ) = ( 2nd ` R ) ) $=
        ( vx vy cfv c2nd cvv c1st cres cv co cmpt2 wceq 2ndfval wfun wcel fo2nd
        cop wfo fofun ax-mp cbs fvex eqeltri resfunexg mpt2ex op1std syl fveq1d
        mp2an fvres eqtrd ) AFEUARZRFSBUBZRZFSRZAFVFVGAEVGPQBBSPUCQUCHUDUBZUEZU
        KUFVFVGUFAPQBCDEGHIJKLMNUGVGVKESUHZBTUIVGTUITTSULVLUJTTSUMUNBGUORTJGUOU
        PUQZSBTURVCPQBBVJVMVMUSUTVAVBAFBUIVHVIUFOFBSVDVAVE $.

      2ndf2.p $e |- ( ph -> S e. B ) $.
      $( Value of the first projection on a morphism.  (Contributed by Mario
         Carneiro, 11-Jan-2017.) $)
      2ndf2 $p |- ( ph -> ( R ( 2nd ` Q ) S ) = ( 2nd |` ( R H S ) ) ) $=
        ( vx c2nd cvv vy cv cres cfv cmpt2 cop wceq 2ndfval wfun wcel wfo fo2nd
        co fofun ax-mp cbs fvex eqeltri resfunexg mp2an mpt2ex op2ndd wa simprl
        syl simprr oveq12d reseq2d ovex a1i ovmpt2d ) ARUAFGBBSRUBZUAUBZIUMZUCZ
        SFGIUMZUCZESUDZTAESBUCZRUABBVOUEZUFUGVRVTUGARUABCDEHIJKLMNOUHVSVTESUIZB
        TUJVSTUJTTSUKWAULTTSUNUOZBHUPUDTKHUPUQURZSBTUSUTRUABBVOWCWCVAVBVEAVLFUG
        ZVMGUGZVCVCZVNVPSWFVLFVMGIAWDWEVDAWDWEVFVGVHPQVQTUJZAWAVPTUJWGWBFGIVISV
        PTUSUTVJVK $.
    $}
  $}

  ${
    $d f g x y z C $.  $d f g x y z D $.  $d f g x y z P $.  $d f g x y z ph $.
    $d f g x y z Q $.  $d f g x y z T $.
    1stfcl.t $e |- T = ( C Xc. D ) $.
    1stfcl.c $e |- ( ph -> C e. Cat ) $.
    1stfcl.d $e |- ( ph -> D e. Cat ) $.
    ${
      1stfcl.p $e |- P = ( C 1stF D ) $.
      $( The first projection functor is a functor onto the left argument.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      1stfcl $p |- ( ph -> P e. ( T Func C ) ) $=
        ( vx c1st cfv cop co eqid wceq cvv wcel syl fvres vy vz vf cbs cxp cres
        vg c2nd cfunc chom cmpt2 xpcbas 1stfval wfun wfo fo1st fofun ax-mp fvex
        cv xpex resfunexg mp2an mpt2ex op2ndd opeq2d eqtr4d wbr cco ccid xpccat
        wf f1stres a1i wfn ovex fnmpt2i fneq1d mpbiri ccat adantr simprl simprr
        1stf2 xpchom reseq2d eqtrd feq1d ad2antrl ad2antll oveq12d feq23d simpr
        wa mpbird catidcl 1st2nd2 adantl fveq2d xp1st xp2nd xpcid op1std fveq1d
        3eqtr4d w3a 3ad2ant1 simp21 simp22 simp23 simp3l simp3r catcocl opeq12d
        xpcco1st oveq123d isfuncd df-br sylib eqeltrd ) ADKBUDLZCUDLZUEZUFZDUHL
        ZMZEBUINZADYDJUAYCYCKJUTZUAUTZEUJLZNZUFZUKZMZYFAJUAYCBCDEYJFBCEYAYBFYAO
        ZYBOZULZYJOZGHIUMZAYEYMYDADYNPYEYMPYSYDYMDKUNZYCQRYDQRQQKUOYTUPQQKUQURZ
        YAYBBUDUSCUDUSVAZKYCQVBVCJUAYCYCYLUUBUUBVDVESZVFVGAYDYEYGVHYFYGRAJUAUBY
        CYAEEVILZEVJLZUCUGBYDYEYJBVJLZBUJLZBVILZYQYOYRUUGOZUUEOZUUFOZUUDOZUUHOZ
        ABCEFGHVKZGYCYAYDVLAYAYBVMVNAYEYCYCUEZVOYMUUOVOJUAYCYCYLYMYMOYTYKQRYLQR
        UUAYHYIYJVPKYKQVBVCVQAUUOYEYMUUCVRVSAYHYCRZYIYCRZWNZWNZYKYHYDLZYIYDLZUU
        GNZYHYIYENZVLYHKLZYIKLZUUGNZYHUHLZYIUHLCUJLZNZUEZUVFUVCVLZUUSUVKUVJUVFK
        UVJUFZVLUVFUVIVMUUSUVJUVFUVCUVLUUSUVCYLUVLUUSYCBCDYHYIEYJFYQYRABVTRZUUR
        GWAACVTRZUURHWAIAUUPUUQWBZAUUPUUQWCZWDUUSYKUVJKUUSYCBCEUUGUVHYJYHYIFYQU
        UIUVHOYRUVOUVPWEZWFWGWHVSUUSYKUVBUVJUVFUVCUVQUUSUUTUVDUVAUVEUUGUUPUUTUV
        DPZAUUQYHYCKTZWIUUQUVAUVEPZAUUPYIYCKTZWJWKWLWOAUUPWNZYHUUELZKYHYHYJNZUF
        ZLZUVDUUFLZUWCYHYHYENZLUUTUUFLUWBUWFUWCKLZUWGUWBUWCUWDRUWFUWIPUWBYCEUUE
        YJYHYQYRUUJAEVTRZUUPUUNWAAUUPWMZWPUWCUWDKTSUWBUWCUWGUVGCVJLZLZMZPUWIUWG
        PUWBUWCUVDUVGMZUUELUWNUWBYHUWOUUEUUPYHUWOPAYHYAYBWQWRWSUWBBCUVDUVGEUUEU
        UFUWLYAYBFAUVMUUPGWAZAUVNUUPHWAZYOYPUUKUWLOUUJUUPUVDYARAYHYAYBWTWRUUPUV
        GYBRAYHYAYBXAWRXBWGUWGUWMUWCUVDUUFUSUVGUWLUSXCSWGUWBUWCUWHUWEUWBYCBCDYH
        YHEYJFYQYRUWPUWQIUWKUWKWDXDUWBUUTUVDUUFUUPUVRAUVSWRWSXEAUUPUUQUBUTZYCRZ
        XFZUCUTZYKRZUGUTZYIUWRYJNZRZWNZXFZUXCUXAYHYIMUWRUUDNNZKYHUWRYJNZUFZLZUX
        CKLZUXAKLZUVDUVEMZUWRKLZUUHNZNZUXHYHUWRYENZLUXCYIUWRYENZLZUXAUVCLZUUTUV
        AMZUWRYDLZUUHNZNUXGUXKUXHKLZUXQUXGUXHUXIRUXKUYEPUXGYCEUUDUXAUXCYJYHYIUW
        RYQYRUULAUWTUWJUXFUUNXGAUUPUUQUWSUXFXHZAUUPUUQUWSUXFXIZAUUPUUQUWSUXFXJZ
        AUWTUXBUXEXKZAUWTUXBUXEXLZXMUXHUXIKTSUXGYCBCEUUHUXAUXCYJUUDYHYIUWRFYQYR
        UULUYFUYGUYHUYIUYJUUMXOWGUXGUXHUXRUXJUXGYCBCDYHUWREYJFYQYRAUWTUVMUXFGXG
        ZAUWTUVNUXFHXGZIUYFUYHWDXDUXGUXTUXLUYAUXMUYDUXPUXGUYBUXNUYCUXOUUHUXGUUT
        UVDUVAUVEUXGUUPUVRUYFUVSSUXGUUQUVTUYGUWASXNUXGUWSUYCUXOPUYHUWRYCKTSWKUX
        GUXTUXCKUXDUFZLZUXLUXGUXCUXSUYMUXGYCBCDYIUWREYJFYQYRUYKUYLIUYGUYHWDXDUX
        GUXEUYNUXLPUYJUXCUXDKTSWGUXGUYAUXAYLLZUXMUXGUXAUVCYLUXGYCBCDYHYIEYJFYQY
        RUYKUYLIUYFUYGWDXDUXGUXBUYOUXMPUYIUXAYKKTSWGXPXEXQYDYEYGXRXSXT $.
    $}

    ${
      2ndfcl.p $e |- Q = ( C 2ndF D ) $.
      $( The second projection functor is a functor onto the right argument.
         (Contributed by Mario Carneiro, 11-Jan-2017.) $)
      2ndfcl $p |- ( ph -> Q e. ( T Func D ) ) $=
        ( vx c2nd cfv cop co eqid wceq cvv wcel syl fvres vy vz vf cbs cxp cres
        vg cfunc chom cmpt2 xpcbas 2ndfval wfun wfo fo2nd fofun ax-mp fvex xpex
        resfunexg mp2an mpt2ex op2ndd opeq2d eqtr4d wbr cco ccid xpccat f2ndres
        cv wf a1i wfn ovex fnmpt2i fneq1d mpbiri c1st ccat adantr simprl simprr
        2ndf2 xpchom reseq2d eqtrd feq1d ad2antrl ad2antll oveq12d feq23d simpr
        mpbird catidcl 1st2nd2 adantl fveq2d xp1st xp2nd xpcid 3eqtr4d 3ad2ant1
        fveq1d w3a simp21 simp22 simp23 simp3l simp3r catcocl xpcco2nd oveq123d
        wa opeq12d isfuncd df-br sylib eqeltrd ) ADKBUDLZCUDLZUEZUFZDKLZMZECUHN
        ZADYCJUAYBYBKJVKZUAVKZEUILZNZUFZUJZMZYEAJUAYBBCDEYIFBCEXTYAFXTOZYAOZUKZ
        YIOZGHIULZAYDYLYCADYMPYDYLPYRYCYLDKUMZYBQRYCQRQQKUNYSUOQQKUPUQZXTYABUDU
        RCUDURUSZKYBQUTVAJUAYBYBYKUUAUUAVBVCSZVDVEAYCYDYFVFYEYFRAJUAUBYBYAEEVGL
        ZEVHLZUCUGCYCYDYICVHLZCUILZCVGLZYPYOYQUUFOZUUDOZUUEOZUUCOZUUGOZABCEFGHV
        IZHYBYAYCVLAXTYAVJVMAYDYBYBUEZVNYLUUNVNJUAYBYBYKYLYLOYSYJQRYKQRYTYGYHYI
        VOKYJQUTVAVPAUUNYDYLUUBVQVRAYGYBRZYHYBRZXNZXNZYJYGYCLZYHYCLZUUFNZYGYHYD
        NZVLYGVSLZYHVSLBUILZNZYGKLZYHKLZUUFNZUEZUVHUVBVLZUURUVJUVIUVHKUVIUFZVLU
        VEUVHVJUURUVIUVHUVBUVKUURUVBYKUVKUURYBBCDYGYHEYIFYPYQABVTRZUUQGWAACVTRZ
        UUQHWAIAUUOUUPWBZAUUOUUPWCZWDUURYJUVIKUURYBBCEUVDUUFYIYGYHFYPUVDOUUHYQU
        VNUVOWEZWFWGWHVRUURYJUVAUVIUVHUVBUVPUURUUSUVFUUTUVGUUFUUOUUSUVFPZAUUPYG
        YBKTZWIUUPUUTUVGPZAUUOYHYBKTZWJWKWLWNAUUOXNZYGUUDLZKYGYGYINZUFZLZUVFUUE
        LZUWBYGYGYDNZLUUSUUELUWAUWEUWBKLZUWFUWAUWBUWCRUWEUWHPUWAYBEUUDYIYGYPYQU
        UIAEVTRZUUOUUMWAAUUOWMZWOUWBUWCKTSUWAUWBUVCBVHLZLZUWFMZPUWHUWFPUWAUWBUV
        CUVFMZUUDLUWMUWAYGUWNUUDUUOYGUWNPAYGXTYAWPWQWRUWABCUVCUVFEUUDUWKUUEXTYA
        FAUVLUUOGWAZAUVMUUOHWAZYNYOUWKOUUJUUIUUOUVCXTRAYGXTYAWSWQUUOUVFYARAYGXT
        YAWTWQXAWGUWLUWFUWBUVCUWKURUVFUUEURVCSWGUWAUWBUWGUWDUWAYBBCDYGYGEYIFYPY
        QUWOUWPIUWJUWJWDXDUWAUUSUVFUUEUUOUVQAUVRWQWRXBAUUOUUPUBVKZYBRZXEZUCVKZY
        JRZUGVKZYHUWQYINZRZXNZXEZUXBUWTYGYHMUWQUUCNNZKYGUWQYINZUFZLZUXBKLZUWTKL
        ZUVFUVGMZUWQKLZUUGNZNZUXGYGUWQYDNZLUXBYHUWQYDNZLZUWTUVBLZUUSUUTMZUWQYCL
        ZUUGNZNUXFUXJUXGKLZUXPUXFUXGUXHRUXJUYDPUXFYBEUUCUWTUXBYIYGYHUWQYPYQUUKA
        UWSUWIUXEUUMXCAUUOUUPUWRUXEXFZAUUOUUPUWRUXEXGZAUUOUUPUWRUXEXHZAUWSUXAUX
        DXIZAUWSUXAUXDXJZXKUXGUXHKTSUXFYBBCEUUGUWTUXBYIUUCYGYHUWQFYPYQUUKUYEUYF
        UYGUYHUYIUULXLWGUXFUXGUXQUXIUXFYBBCDYGUWQEYIFYPYQAUWSUVLUXEGXCZAUWSUVMU
        XEHXCZIUYEUYGWDXDUXFUXSUXKUXTUXLUYCUXOUXFUYAUXMUYBUXNUUGUXFUUSUVFUUTUVG
        UXFUUOUVQUYEUVRSUXFUUPUVSUYFUVTSXOUXFUWRUYBUXNPUYGUWQYBKTSWKUXFUXSUXBKU
        XCUFZLZUXKUXFUXBUXRUYLUXFYBBCDYHUWQEYIFYPYQUYJUYKIUYFUYGWDXDUXFUXDUYMUX
        KPUYIUXBUXCKTSWGUXFUXTUWTYKLZUXLUXFUWTUVBYKUXFYBBCDYGYHEYIFYPYQUYJUYKIU
        YEUYFWDXDUXFUXAUYNUXLPUYHUWTYJKTSWGXMXBXPYCYDYFXQXRXS $.
    $}
  $}

  ${
    $d b f g h x y B $.  $d x y C $.  $d b f g h x y F $.  $d b f g h x y ph $.
    $d x y D $.  $d b f g h x y G $.  $d h K $.  $d h x y X $.  $d h x y Y $.
    $d b f g h x y H $.
    prfval.k $e |- P = ( F pairF G ) $.
    prfval.b $e |- B = ( Base ` C ) $.
    prfval.h $e |- H = ( Hom ` C ) $.
    prfval.c $e |- ( ph -> F e. ( C Func D ) ) $.
    prfval.d $e |- ( ph -> G e. ( C Func E ) ) $.
    $( Value of the pairing functor.  (Contributed by Mario Carneiro,
       12-Jan-2017.) $)
    prfval $p |- ( ph -> P = <. ( x e. B |->
      <. ( ( 1st ` F ) ` x ) , ( ( 1st ` G ) ` x ) >. ) ,
       ( x e. B , y e. B |-> ( h e. ( x H y ) |->
    <. ( ( x ( 2nd ` F ) y ) ` h ) , ( ( x ( 2nd ` G ) y ) ` h ) >. ) ) >. ) $=
      ( co cfv cvv vf vg vb cprf cv c1st cop cmpt c2nd cmpt2 cdm csb df-prf a1i
      wceq wa wcel fvex dmex simprl fveq2d dmeqd cbs wf eqid cfunc wrel relfunc
      wbr 1st2ndbr sylancr funcf1 fdm adantr eqtrd simpr simplrl fveq1d simplrr
      syl opeq12d mpteq12dv eqidd mpt2eq123dv ad2antrr oveqd chom simplr funcf2
      ad4antr 3impa mpt2eq3dva csbied2 elex opex ovmpt2d syl5eq ) AGJKUDRBDBUEZ
      JUFSZSZWRKUFSZSZUGZUHZBCDDHWRCUEZLRZHUEZWRXEJUISZRZSZXGWRXEKUISZRZSZUGZUH
      ZUJZUGZMAUAUBJKTTUCUAUEZUFSZUKZBUCUEZWRXSSZWRUBUEZUFSZSZUGZUHZBCYAYAHWRXE
      XRUISZRZUKZXGYISZXGWRXEYCUISZRZSZUGZUHZUJZUGZULZXQUDTUDUAUBTTYSUJUOABCUAU
      BHUCUMUNAXRJUOZYCKUOZUPZUPZUCXTDYRXQTXTTUQUUCXSXRUFURUSUNUUCXTWSUKZDUUCXS
      WSUUCXRJUFAYTUUAUTVAVBAUUDDUOZUUBADFVCSZWSVDUUEADUUFEFWSXHNUUFVEAEFVFRZVG
      JUUGUQZWSXHUUGVIZEFVHPJUUGVJVKZVLDUUFWSVMVTVNVOUUCYADUOZUPZYGXDYQXPUULBYA
      YFDXCUUCUUKVPZUULYBWTYEXBUULWRXSWSUULXRJUFAYTUUAUUKVQZVAVRUULWRYDXAUULYCK
      UFAYTUUAUUKVSZVAVRWAWBUULYQBCDDYPUJXPUULBCYAYAYPDDYPUUMUUMUULYPWCWDUULBCD
      DYPXOUULWRDUQZXEDUQZYPXOUOUULUUPUPZUUQUPZHYJYOXFXNUUSYJXIUKZXFUUSYIXIUUSY
      HXHWRXEUUSXRJUIUULYTUUPUUQUUNWEVAWFZVBUUSXFWTXEWSSFWGSZRZXIVDUUTXFUOUUSDE
      FWSXHLUVBWRXENOUVBVEAUUIUUBUUKUUPUUQUUJWJUULUUPUUQWHUURUUQVPWIXFUVCXIVMVT
      VOUUSYKXJYNXMUUSXGYIXIUVAVRUUSXGYMXLUUSYLXKWRXEUUSYCKUIUULUUAUUPUUQUUOWEV
      AWFVRWAWBWKWLVOWAWMAUUHJTUQPJUUGWNVTAKEIVFRZUQKTUQQKUVDWNVTXQTUQAXDXPWOUN
      WPWQ $.

    prf1.x $e |- ( ph -> X e. B ) $.
    $( Value of the pairing functor on objects.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    prf1 $p |- ( ph -> ( ( 1st ` P ) ` X ) =
      <. ( ( 1st ` F ) ` X ) , ( ( 1st ` G ) ` X ) >. ) $=
      ( vx vy cfv cop vh cv c1st cvv cmpt co c2nd cmpt2 wceq prfval cbs eqeltri
      fvex mptex mpt2ex op1std syl wa simpr fveq2d opeq12d wcel opex a1i fvmptd
      ) AQJQUBZGUCSZSZVFHUCSZSZTZJVGSZJVISZTZBEUCSZUDAEQBVKUEZQRBBUAVFRUBZIUFUA
      UBZVFVQGUGSUFSVRVFVQHUGSUFSTUEZUHZTUIVOVPUIAQRBCDEUAFGHIKLMNOUJVPVTEQBVKB
      CUKSUDLCUKUMULZUNQRBBVSWAWAUOUPUQAVFJUIZURZVHVLVJVMWCVFJVGAWBUSZUTWCVFJVI
      WDUTVAPVNUDVBAVLVMVCVDVE $.

    prf2.y $e |- ( ph -> Y e. B ) $.
    $( Value of the pairing functor on morphisms.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    prf2fval $p |- ( ph -> ( X ( 2nd ` P ) Y ) = ( h e. ( X H Y ) |->
    <. ( ( X ( 2nd ` F ) Y ) ` h ) , ( ( X ( 2nd ` G ) Y ) ` h ) >. ) ) $=
      ( cfv vx vy cv co c2nd cop cmpt cvv c1st cmpt2 wceq prfval cbs fvex mptex
      eqeltri mpt2ex op2ndd syl wa simprl simprr oveq12d opeq12d mpteq12dv wcel
      fveq1d ovex a1i ovmpt2d ) AUAUBKLBBFUAUCZUBUCZJUDZFUCZVKVLHUETZUDZTZVNVKV
      LIUETZUDZTZUFZUGZFKLJUDZVNKLVOUDZTZVNKLVRUDZTZUFZUGZEUETZUHAEUABVKHUITTVK
      IUITTUFZUGZUAUBBBWBUJZUFUKWJWMUKAUAUBBCDEFGHIJMNOPQULWLWMEUABWKBCUMTUHNCU
      MUNUPZUOUAUBBBWBWNWNUQURUSAVKKUKZVLLUKZUTUTZFVMWAWCWHWQVKKVLLJAWOWPVAZAWO
      WPVBZVCWQVQWEVTWGWQVNVPWDWQVKKVLLVOWRWSVCVGWQVNVSWFWQVKKVLLVRWRWSVCVGVDVE
      RSWIUHVFAFWCWHKLJVHUOVIVJ $.

    prf2.k $e |- ( ph -> K e. ( X H Y ) ) $.
    $( Value of the pairing functor on morphisms.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    prf2 $p |- ( ph -> ( ( X ( 2nd ` P ) Y ) ` K ) =
      <. ( ( X ( 2nd ` F ) Y ) ` K ) , ( ( X ( 2nd ` G ) Y ) ` K ) >. ) $=
      ( vh cv c2nd cfv co cop cvv prf2fval wceq wa fveq2d opeq12d wcel opex a1i
      simpr fvmptd ) AUAJUAUBZKLGUCUDUEZUDZURKLHUCUDUEZUDZUFJUSUDZJVAUDZUFZKLIU
      EKLEUCUDUEUGABCDEUAFGHIKLMNOPQRSUHAURJUIZUJZUTVCVBVDVGURJUSAVFUPZUKVGURJV
      AVHUKULTVEUGUMAVCVDUNUOUQ $.
  $}

  ${
    $d f g h x y z C $.  $d x y D $.  $d f g h x y z P $.  $d f g h x y z ph $.
    $d x E $.  $d h x y F $.  $d h x y G $.  $d f g h x y z T $.
    prfcl.p $e |- P = ( F pairF G ) $.
    prfcl.t $e |- T = ( D Xc. E ) $.
    prfcl.c $e |- ( ph -> F e. ( C Func D ) ) $.
    prfcl.d $e |- ( ph -> G e. ( C Func E ) ) $.
    $( The pairing of functors ` F : C --> D ` and ` G : C --> D ` is a functor
       ` <. F , G >. : C --> ( D X. E ) ` .  (Contributed by Mario Carneiro,
       12-Jan-2017.) $)
    prfcl $p |- ( ph -> P e. ( C Func T ) ) $=
      ( vx cfv cop co eqid wcel adantr ffvelrnd vy vh vz vf c1st c2nd cfunc cbs
      vg cv cmpt chom cmpt2 prfval wceq fvex mptex mpt2ex op1std op2ndd opeq12d
      syl eqtr4d wbr cxp cco ccid xpcbas ccat funcrcl simpld simprd xpccat wrel
      wa relfunc 1st2ndbr sylancr funcf1 ffvelrnda opelxpi syl2anc fmptd mpbird
      wf feq1d wfn ovex fnmpt2i fneq1d mpbiri simprl simprr funcf2 prf1 oveq12d
      adantrr adantrl xpchom2 eqtrd eleqtrrd cvv ovmpt4g mp3an3 sylan9eq funcid
      oveqd simpr catidcl prf2 fveq2d 3eqtr4d w3a 3ad2ant1 simp21 simp22 simp23
      xpcid simp3l simp3r funcco catcocl oveq123d xpcco2 isfuncd df-br eqeltrd
      sylib ) ADDUENZDUFNZOZBEUGPZADMBUHNZMUJZGUENZNZYNHUENZNZOZUKZMUAYMYMUBYNU
      AUJZBULNZPZUBUJZYNUUAGUFNZPZNZUUDYNUUAHUFNZPZNZOZUKZUMZOZYKAMUAYMBCDUBFGH
      UUBIYMQZUUBQZKLUNZAYIYTYJUUMADUUNUOZYIYTUOUUQYTUUMDMYMYSBUHUPZUQZMUAYMYMU
      ULUUSUUSURZUSVBZAUURYJUUMUOUUQYTUUMDUUTUVAUTVBZVAVCAYIYJYLVDYKYLRAMUAUCYM
      CUHNZFUHNZVEZBBVFNZBVGNZUDUIEYIYJUUBEVGNZEULNZEVFNZUUOCFEUVDUVEJUVDQZUVEQ
      ZVHUUPUVJQZUVHQZUVIQZUVGQZUVKQZABVIRZCVIRZAGBCUGPZRZUVSUVTVOKBCGVJVBZVKZA
      CFEJAUVSUVTUWCVLZAUVSFVIRZAHBFUGPZRZUVSUWFVOLBFHVJVBVLZVMAYMUVFYIWEYMUVFY
      TWEAMYMYSUVFYTAYNYMRZVOZYPUVDRZYRUVERZYSUVFRAYMUVDYNYOAYMUVDBCYOUUEUUOUVL
      AUWAVNUWBYOUUEUWAVDZBCVPKGUWAVQVRZVSZVTZAYMUVEYNYQAYMUVEBFYQUUHUUOUVMAUWG
      VNZUWHYQUUHUWGVDZBFVPZLHUWGVQZVRZVSZVTZYPYRUVDUVEWAWBYTQWCAYMUVFYIYTUVBWF
      WDAYJYMYMVEZWGUUMUXEWGMUAYMYMUULUUMUUMQZUBUUCUUKYNUUAUUBWHUQZWIAUXEYJUUMU
      VCWJWKAUWJUUAYMRZVOZVOZUUCYNYINZUUAYINZUVJPZYNUUAYJPZWEUUCUXMUULWEUXJUBUU
      CUUKUXMUULUXJUUDUUCRZVOZUUKYPUUAYONZCULNZPZYRUUAYQNZFULNZPZVEZUXMUXPUUGUX
      SRUUJUYBRUUKUYCRUXJUUCUXSUUDUUFUXJYMBCYOUUEUUBUXRYNUUAUUOUUPUXRQZAUWNUXIU
      WOSAUWJUXHWLZAUWJUXHWMZWNVTUXJUUCUYBUUDUUIUXJYMBFYQUUHUUBUYAYNUUAUUOUUPUY
      AQZAUWSUXIUXBSUYEUYFWNVTUUGUUJUXSUYBWAWBUXJUXMUYCUOUXOUXJUXMYSUXQUXTOZUVJ
      PUYCUXJUXKYSUXLUYHUVJUXJYMBCDFGHUUBYNIUUOUUPAUWBUXIKSZAUWHUXILSZUYEWOUXJY
      MBCDFGHUUBUUAIUUOUUPUYIUYJUYFWOWPUXJCFUXQUXTEUXRUYAUVJYPYRUVDUVEJUVLUVMUY
      DUYGAUWJUWLUXHUWQWQAUWJUWMUXHUXDWQAUXHUXQUVDRUWJAYMUVDUUAYOUWPVTWRAUXHUXT
      UVERUWJAYMUVEUUAYQUXCVTWRUVNWSWTSXAUULQWCUXJUUCUXMUXNUULAUXIUXNYNUUAUUMPZ
      UULAYJUUMYNUUAUVCXGUWJUXHUULXBRUYKUULUOUXGMUAYMYMUULUUMXBUXFXCXDXEWFWDUWK
      YNUVHNZYNYNUUEPNZUYLYNYNUUHPNZOYPCVGNZNZYRFVGNZNZOZUYLYNYNYJPNUXKUVINZUWK
      UYMUYPUYNUYRUWKYMBUVHCYOUUEUYOYNUUOUVOUYOQZAUWNUWJUWOSAUWJXHZXFUWKYMBUVHF
      YQUUHUYQYNUUOUVOUYQQZAUWSUWJUXBSVUBXFVAUWKYMBCDFGHUUBUYLYNYNIUUOUUPAUWBUW
      JKSZAUWHUWJLSZVUBVUBUWKYMBUVHUUBYNUUOUUPUVOAUVSUWJUWDSVUBXIXJUWKUYTYSUVIN
      UYSUWKUXKYSUVIUWKYMBCDFGHUUBYNIUUOUUPVUDVUEVUBWOXKUWKCFYPYREUVIUYOUYQUVDU
      VEJAUVTUWJUWESAUWFUWJUWISUVLUVMVUAVUCUVPUWQUXDXRWTXLAUWJUXHUCUJZYMRZXMZUD
      UJZUUCRZUIUJZUUAVUFUUBPZRZVOZXMZVUKVUIYNUUAOVUFUVGPPZYNVUFUUEPNZVUPYNVUFU
      UHPNZOVUKUUAVUFUUEPZNZVUIUUFNZYPUXQOVUFYONZCVFNZPPZVUKUUAVUFUUHPZNZVUIUUI
      NZYRUXTOVUFYQNZFVFNZPPZOZVUPYNVUFYJPNVUKUUAVUFYJPNZVUIUXNNZUXKUXLOZVUFYIN
      ZUVKPZPZVUOVUQVVDVURVVJVUOYMBUVGCYOUUEUUBVUIVUKVVCYNUUAVUFUUOUUPUVQVVCQZA
      VUHUWNVUNUWOXNZAUWJUXHVUGVUNXOZAUWJUXHVUGVUNXPZAUWJUXHVUGVUNXQZAVUHVUJVUM
      XSZAVUHVUJVUMXTZYAVUOYMBUVGFYQUUHUUBVUIVUKVVIYNUUAVUFUUOUUPUVQVVIQZVUOUWR
      UWHUWSUWTAVUHUWHVUNLXNZUXAVRZVVTVWAVWBVWCVWDYAVAVUOYMBCDFGHUUBVUPYNVUFIUU
      OUUPAVUHUWBVUNKXNZVWFVVTVWBVUOYMBUVGVUIVUKUUBYNUUAVUFUUOUUPUVQAVUHUVSVUNU
      WDXNVVTVWAVWBVWCVWDYBXJVUOVVQVUTVVFOZVVAVVGOZYSUYHOZVVBVVHOZUVKPZPVVKVUOV
      VLVWIVVMVWJVVPVWMVUOVVNVWKVVOVWLUVKVUOUXKYSUXLUYHVUOYMBCDFGHUUBYNIUUOUUPV
      WHVWFVVTWOVUOYMBCDFGHUUBUUAIUUOUUPVWHVWFVWAWOVAVUOYMBCDFGHUUBVUFIUUOUUPVW
      HVWFVWBWOWPVUOYMBCDFGHUUBVUKUUAVUFIUUOUUPVWHVWFVWAVWBVWDXJVUOYMBCDFGHUUBV
      UIYNUUAIUUOUUPVWHVWFVVTVWAVWCXJYCVUOCFUXQUXTVVBVVHVVIEVVCVVAVVGUXRUYAVUTV
      VFYPYRUVKUVDUVEJUVLUVMUYDUYGVUOYMUVDYNYOAVUHYMUVDYOWEVUNUWPXNZVVTTVUOYMUV
      EYNYQAVUHYMUVEYQWEVUNUXCXNZVVTTVUOYMUVDUUAYOVWNVWATVUOYMUVEUUAYQVWOVWATVV
      RVWEUVRVUOYMUVDVUFYOVWNVWBTVUOYMUVEVUFYQVWOVWBTVUOUUCUXSVUIUUFVUOYMBCYOUU
      EUUBUXRYNUUAUUOUUPUYDVVSVVTVWAWNVWCTVUOUUCUYBVUIUUIVUOYMBFYQUUHUUBUYAYNUU
      AUUOUUPUYGVWGVVTVWAWNVWCTVUOVULUXQVVBUXRPVUKVUSVUOYMBCYOUUEUUBUXRUUAVUFUU
      OUUPUYDVVSVWAVWBWNVWDTVUOVULUXTVVHUYAPVUKVVEVUOYMBFYQUUHUUBUYAUUAVUFUUOUU
      PUYGVWGVWAVWBWNVWDTYDWTXLYEYIYJYLYFYHYG $.
  $}

  ${
    $d f h x y C $.  $d f h u x y F $.  $d f h u x y G $.  $d f h x y ph $.
    $d f u x y D $.  $d f u x y E $.  $d f x y P $.
    prf1st.p $e |- P = ( F pairF G ) $.
    prf1st.c $e |- ( ph -> F e. ( C Func D ) ) $.
    prf1st.d $e |- ( ph -> G e. ( C Func E ) ) $.
    $( Cancellation of pairing with first projection.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    prf1st $p |- ( ph -> ( ( D 1stF E ) o.func P ) = F ) $=
      ( vx vy vf co c1st cfv wcel eqid adantr wceq vu vh c1stf ccom cbs cv c2nd
      cmpt2 cop ccofu cmpt wa cxp cxpc chom xpcbas ccat funcrcl syl simprd wrel
      cfunc wbr relfunc 1st2ndbr sylancr funcf1 ffvelrnda opelxpi syl2anc 1stf1
      fvex op1st syl6eq prfval mptex mpt2ex op1std 1stfcl feqmptd fveq2 3eqtr4d
      mpteq2dva fmptco cres ad2antrr prfcl adantrr adantrl fveq1d simprl simprr
      1stf2 funcf2 fvres simpr fveq2d 3eqtrd wf fcompt 3impb mpt2eq3dva funcfn2
      prf2 wfn fnov sylib eqtr4d opeq12d cofuval 1st2nd ) ACEUCNZOPZDOPZUDZKLBU
      EPZXPKUFZXNPZLUFZXNPZXLUGPZNZXQXSDUGPZNZUDZUHZUIFOPZFUGPZUIZXLDUJNFAXOYGY
      FYHAKXPXQYGPZXQGOPZPZUIZXMPZUKKXPYJUKXOYGAKXPYNYJAXQXPQZULZYNYMOPYJYPCUEP
      ZEUEPZUMZCEXLYMCEUNNZYTUOPZYTRZCEYTYQYRUUBYQRZYRRZUPZUUARZACUQQZYOABUQQZU
      UGAFBCVBNZQZUUHUUGULIBCFURUSUTZSAEUQQZYOAUUHUULAGBEVBNZQZUUHUULULJBEGURUS
      UTZSXLRZYPYJYQQYLYRQYMYSQAXPYQXQYGAXPYQBCYGYHXPRZUUCAUUIVAZUUJYGYHUUIVCZB
      CVDZIFUUIVEVFZVGZVHAXPYRXQYKAXPYRBEYKGUGPZUUQUUDAUUMVAUUNYKUVCUUMVCBEVDJG
      UUMVEVFVGVHYJYLYQYRVIVJZVKYJYLXQYGVLXQYKVLVMVNWCAKUAXPYSYMUAUFZXMPYNXNXMU
      VDADKXPYMUKZKLXPXPUBXQXSBUOPZNZUBUFZXQXSYHNZPUVIXQXSUVCNZPUIUKZUHZUITXNUV
      FTAKLXPBCDUBEFGUVGHUUQUVGRZIJVOUVFUVMDKXPYMBUEVLZVPKLXPXPUVLUVOUVOVQVRUSA
      UAYSYQXMAYSYQYTCXMYAUUEUUCAYTCVBNZVAXLUVPQXMYAUVPVCZYTCVDACEXLYTUUBUUKUUO
      UUPVSZXLUVPVEVFZVGVTUVEYMXMWAWDAKXPYQYGUVBVTWBAYFKLXPXPUVJUHZYHAKLXPXPYEU
      VJAYOXSXPQZYEUVJTAYOUWAULZULZMUVHMUFZYDPZYBPZUKZMUVHUWDUVJPZUKYEUVJUWCMUV
      HUWFUWHUWCUWDUVHQZULZUWFUWEOXRXTUUANZWEZPZUWEOPZUWHUWJUWEYBUWLUWJYSCEXLXR
      XTYTUUAUUBUUEUUFAUUGUWBUWIUUKWFAUULUWBUWIUUOWFUUPUWCXRYSQZUWIAYOUWOUWAAXP
      YSXQXNAXPYSBYTXNYCUUQUUEABYTVBNZVADUWPQXNYCUWPVCZBYTVDABCDYTEFGHUUBIJWGZD
      UWPVEVFZVGZVHWHZSUWCXTYSQZUWIAUWAUXBYOAXPYSXSXNUWTVHWIZSWMWJUWJUWEUWKQUWM
      UWNTUWCUVHUWKUWDYDUWCXPBYTXNYCUVGUUAXQXSUUQUVNUUFAUWQUWBUWSSAYOUWAWKZAYOU
      WAWLZWNZVHUWEUWKOWOUSUWJUWNUWHUWDUVKPZUIZOPUWHUWJUWEUXHOUWJXPBCDEFGUVGUWD
      XQXSHUUQUVNAUUJUWBUWIIWFAUUNUWBUWIJWFUWCYOUWIUXDSUWCUWAUWIUXESUWCUWIWPXDW
      QUWHUXGUWDUVJVLUWDUVKVLVMVNWRWCUWCUWKXRXMPXTXMPCUOPZNZYBWSUVHUWKYDWSYEUWG
      TUWCYSYTCXMYAUUAUXIXRXTUUEUUFUXIRZAUVQUWBUVSSUXAUXCWNUXFMYBYDUVHUWKUXJWTV
      JUWCMUVHYJXSYGPUXINUVJUWCXPBCYGYHUVGUXIXQXSUUQUVNUXKAUUSUWBUVASUXDUXEWNVT
      WBXAXBAYHXPXPUMXEYHUVTTAXPBCYGYHUUQUVAXCKLXPXPYHXFXGXHXIAKLXPBYTCDXLUUQUW
      RUVRXJAUURUUJFYITUUTIFUUIXKVFWB $.

    $( Cancellation of pairing with second projection.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    prf2nd $p |- ( ph -> ( ( D 2ndF E ) o.func P ) = G ) $=
      ( vx vy vf co cfv c2nd wcel eqid adantr wceq vu vh c2ndf c1st ccom cbs cv
      cmpt2 cop ccofu cmpt wa cxp cxpc chom xpcbas ccat funcrcl syl simprd wrel
      cfunc wbr relfunc 1st2ndbr sylancr funcf1 ffvelrnda opelxpi syl2anc 2ndf1
      fvex op2nd syl6eq prfval mptex mpt2ex op1std 2ndfcl feqmptd fveq2 3eqtr4d
      mpteq2dva fmptco cres ad2antrr prfcl adantrr adantrl fveq1d simprl simprr
      2ndf2 funcf2 fvres simpr fveq2d 3eqtrd wf fcompt 3impb mpt2eq3dva funcfn2
      prf2 wfn fnov sylib eqtr4d opeq12d cofuval 1st2nd ) ACEUCNZUDOZDUDOZUEZKL
      BUFOZXPKUGZXNOZLUGZXNOZXLPOZNZXQXSDPOZNZUEZUHZUIGUDOZGPOZUIZXLDUJNGAXOYGY
      FYHAKXPXQFUDOZOZXQYGOZUIZXMOZUKKXPYLUKXOYGAKXPYNYLAXQXPQZULZYNYMPOYLYPCUF
      OZEUFOZUMZCEXLYMCEUNNZYTUOOZYTRZCEYTYQYRUUBYQRZYRRZUPZUUARZACUQQZYOABUQQZ
      UUGAFBCVBNZQZUUHUUGULIBCFURUSUTZSAEUQQZYOAUUHUULAGBEVBNZQZUUHUULULJBEGURU
      SUTZSXLRZYPYKYQQYLYRQYMYSQAXPYQXQYJAXPYQBCYJFPOZXPRZUUCAUUIVAUUJYJUUQUUIV
      CBCVDIFUUIVEVFVGVHAXPYRXQYGAXPYRBEYGYHUURUUDAUUMVAZUUNYGYHUUMVCZBEVDZJGUU
      MVEVFZVGZVHYKYLYQYRVIVJZVKYKYLXQYJVLXQYGVLVMVNWCAKUAXPYSYMUAUGZXMOYNXNXMU
      VDADKXPYMUKZKLXPXPUBXQXSBUOOZNZUBUGZXQXSUUQNZOUVIXQXSYHNZOUIUKZUHZUITXNUV
      FTAKLXPBCDUBEFGUVGHUURUVGRZIJVOUVFUVMDKXPYMBUFVLZVPKLXPXPUVLUVOUVOVQVRUSA
      UAYSYRXMAYSYRYTEXMYAUUEUUDAYTEVBNZVAXLUVPQXMYAUVPVCZYTEVDACEXLYTUUBUUKUUO
      UUPVSZXLUVPVEVFZVGVTUVEYMXMWAWDAKXPYRYGUVCVTWBAYFKLXPXPUVKUHZYHAKLXPXPYEU
      VKAYOXSXPQZYEUVKTAYOUWAULZULZMUVHMUGZYDOZYBOZUKZMUVHUWDUVKOZUKYEUVKUWCMUV
      HUWFUWHUWCUWDUVHQZULZUWFUWEPXRXTUUANZWEZOZUWEPOZUWHUWJUWEYBUWLUWJYSCEXLXR
      XTYTUUAUUBUUEUUFAUUGUWBUWIUUKWFAUULUWBUWIUUOWFUUPUWCXRYSQZUWIAYOUWOUWAAXP
      YSXQXNAXPYSBYTXNYCUURUUEABYTVBNZVADUWPQXNYCUWPVCZBYTVDABCDYTEFGHUUBIJWGZD
      UWPVEVFZVGZVHWHZSUWCXTYSQZUWIAUWAUXBYOAXPYSXSXNUWTVHWIZSWMWJUWJUWEUWKQUWM
      UWNTUWCUVHUWKUWDYDUWCXPBYTXNYCUVGUUAXQXSUURUVNUUFAUWQUWBUWSSAYOUWAWKZAYOU
      WAWLZWNZVHUWEUWKPWOUSUWJUWNUWDUVJOZUWHUIZPOUWHUWJUWEUXHPUWJXPBCDEFGUVGUWD
      XQXSHUURUVNAUUJUWBUWIIWFAUUNUWBUWIJWFUWCYOUWIUXDSUWCUWAUWIUXESUWCUWIWPXDW
      QUXGUWHUWDUVJVLUWDUVKVLVMVNWRWCUWCUWKXRXMOXTXMOEUOOZNZYBWSUVHUWKYDWSYEUWG
      TUWCYSYTEXMYAUUAUXIXRXTUUEUUFUXIRZAUVQUWBUVSSUXAUXCWNUXFMYBYDUVHUWKUXJWTV
      JUWCMUVHYLXSYGOUXINUVKUWCXPBEYGYHUVGUXIXQXSUURUVNUXKAUUTUWBUVBSUXDUXEWNVT
      WBXAXBAYHXPXPUMXEYHUVTTAXPBEYGYHUURUVBXCKLXPXPYHXFXGXHXIAKLXPBYTEDXLUURUW
      RUVRXJAUUSUUNGYITUVAJGUUMXKVFWB $.
  $}

  ${
    $d f x y C $.  $d f x y D $.  $d f x y E $.  $d f x y F $.  $d f x y ph $.
    1st2ndprf.t $e |- T = ( D Xc. E ) $.
    1st2ndprf.f $e |- ( ph -> F e. ( C Func T ) ) $.
    1st2ndprf.d $e |- ( ph -> D e. Cat ) $.
    1st2ndprf.e $e |- ( ph -> E e. Cat ) $.
    $( Break a functor into a product category into first and second
       projections.  (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    1st2ndprf $p |- ( ph -> F =
      ( ( ( D 1stF E ) o.func F ) pairF ( ( D 2ndF E ) o.func F ) ) ) $=
      ( vx vy c1st cfv c2nd co eqid wcel wceq adantr vf cop cv c1stf ccofu cmpt
      cbs c2ndf chom cmpt2 cprf cxp xpcbas wrel relfunc 1st2ndbr sylancr funcf1
      cfunc wbr feqmptd wa ffvelrnda 1st2nd2 syl 1stfcl simpr cofu1 1stf1 eqtrd
      ccat 2ndfcl 2ndf1 opeq12d eqtr4d mpteq2dva wfn funcfn2 fnov simprl simprr
      sylib funcf2 relxpchom 1st2nd ad2antrr cofu2 adantrr adantrl 1stf2 fveq1d
      cres fvres 3eqtrd 2ndf2 3impb mpt2eq3dva cofucl prfval 3eqtr4d ) AFMNZFON
      ZUBZKBUGNZKUCZCEUDPZFUEPZMNNZXECEUHPZFUEPZMNNZUBZUFZKLXDXDUAXELUCZBUINZPZ
      UAUCZXEXNXGONPNZXQXEXNXJONPNZUBZUFZUJZUBFXGXJUKPZAXAXMXBYBAXAKXDXEXANZUFX
      MAKXDCUGNZEUGNZULZXAAXDYGBDXAXBXDQZCEDYEYFGYEQYFQUMZABDUSPZUNZFYJRZXAXBYJ
      UTZBDUOZHFYJUPUQZURZVAAKXDYDXLAXEXDRZVBZYDYDMNZYDONZUBZXLYRYDYGRZYDUUASAX
      DYGXEXAYPVCZYDYEYFVDVEYRXHYSXKYTYRXHYDXFMNNYSYRXDBDCFXFXEYHAYLYQHTZAXFDCU
      SPRZYQACEXFDGIJXFQZVFZTAYQVGZVHYRYGCEXFYDDDUINZGYIUUIQZACVKRZYQITZAEVKRZY
      QJTZUUFUUCVIVJYRXKYDXIMNNYTYRXDBDEFXIXEYHUUDAXIDEUSPRZYQACEXIDGIJXIQZVLZT
      UUHVHYRYGCEXIYDDUUIGYIUUJUULUUNUUPUUCVMVJVNVOVPVJAXBKLXDXDXEXNXBPZUJZYBAX
      BXDXDULVQXBUUSSAXDBDXAXBYHYOVRKLXDXDXBVSWBAKLXDXDUURYAAYQXNXDRZUURYASAYQU
      UTVBZVBZUURUAXPXQUURNZUFYAUVBUAXPYDXNXANZUUIPZUURUVBXDBDXAXBXOUUIXEXNYHXO
      QZUUJAYMUVAYOTAYQUUTVTZAYQUUTWAZWCZVAUVBUAXPUVCXTUVBXQXPRZVBZUVCUVCMNZUVC
      ONZUBZXTUVKUVEUNUVCUVERZUVCUVNSCEDUUIYDUVDGUUJWDUVBXPUVEXQUURUVIVCZUVCUVE
      WEUQUVKXRUVLXSUVMUVKXRUVCYDUVDXFONPZNUVCMUVEWLZNZUVLUVKXDBDXQCFXFXOXEXNYH
      AYLUVAUVJHWFZAUUEUVAUVJUUGWFUVBYQUVJUVGTZUVBUUTUVJUVHTZUVFUVBUVJVGZWGUVKU
      VCUVQUVRUVBUVQUVRSUVJUVBYGCEXFYDUVDDUUIGYIUUJAUUKUVAITZAUUMUVAJTZUUFAYQUU
      BUUTUUCWHZAUUTUVDYGRYQAXDYGXNXAYPVCWIZWJTWKUVKUVOUVSUVLSUVPUVCUVEMWMVEWNU
      VKXSUVCYDUVDXIONPZNUVCOUVEWLZNZUVMUVKXDBDXQEFXIXOXEXNYHUVTAUUOUVAUVJUUQWF
      UWAUWBUVFUWCWGUVKUVCUWHUWIUVBUWHUWISUVJUVBYGCEXIYDUVDDUUIGYIUUJUWDUWEUUPU
      WFUWGWOTWKUVKUVOUWJUVMSUVPUVCUVEOWMVEWNVNVOVPVJWPWQVJVNAYKYLFXCSYNHFYJWEU
      QAKLXDBCYCUAEXGXJXOYCQYHUVFABDCFXFHUUGWRABDEFXIHUUQWRWSWT $.
  $}

  ${
    $d f g u v x y ph $.  $d f g u v x y X $.  $d f g u v x y Y $.
    $d f g x y T $.
    catcxpccl.c $e |- C = ( CatCat ` U ) $.
    catcxpccl.b $e |- B = ( Base ` C ) $.
    catcxpccl.o $e |- T = ( X Xc. Y ) $.
    catcxpccl.u $e |- ( ph -> U e. WUni ) $.
    catcxpccl.1 $e |- ( ph -> om e. U ) $.
    catcxpccl.x $e |- ( ph -> X e. B ) $.
    catcxpccl.y $e |- ( ph -> Y e. B ) $.
    $( The category of categories for a weak universe is closed under the
       product category operation.  (Contributed by Mario Carneiro,
       12-Jan-2017.) $)
    catcxpccl $p |- ( ph -> T e. B ) $=
      ( wcel cfv eqid wunstr crn wss vx vy vg vf vv vu ccat cin cnx cbs cxp cop
      chom cco cv c2nd co c1st cmpt2 ctp eqidd wceq xpcbas xpchomfval xpcval c1
      a1i df-base wunndx inss1 catcbas eleqtrd sseldi wunxp wunop c4 cdc df-hom
      cwun cuni cpw wunrn wununi wunpw wf wral ovssunirn xpss12 mp2an ovex xpex
      elpw mpbir rgen2w fmpt2 mpbi wunf syl5eqel df-cco cpm wunpm cvv fvex rnex
      c5 uniex pwex rnss uniss mp2b sstri opelxpi fvssunirn mp4an wuntp eqeltrd
      elpm2r inss2 xpccat elin sylanbrc eleqtrrd ) ADEUGUHZBADEODUGODYCOADUIUJP
      ZFUJPZGUJPZUKZULZUIUMPZDUMPZULZUIUNPZUAUBYGYGUKZYGUCUDUAUOZUPPZUBUOZYJUQZ
      YNYJPZUCUOZURPZUDUOZURPZYNURPZURPYOURPULZYPURPZFUNPZUQZUQZYSUPPZUUAUPPZUU
      CUPPYOUPPULZYPUPPZGUNPZUQZUQZULZUSZUSZULZUTEAUAUBUEUFYGFGUUMDUUFUDUCFUMPZ
      GUMPZYJUURBBYEYFJYEQZYFQZUUTQZUVAQZUUFQUUMQMNAYGVAYJUFUEYGYGUFUOZURPZUEUO
      ZURPZUUTUQZUVFUPPZUVHUPPZUVAUQZUKZUSZVBAUEUFYGFGDUUTUVAYJJFGDYEYFJUVBUVCV
      CUVDUVEYJQVDZVGAUURVAVEAYHYKUUSEKAYDYGEKAUIEUJVFVHKAEKLVIZRAYEYFEKAFEUJVF
      VHKAYCEFEUGVJZAFBYCMABCEVSHIKVKZVLZVMZRAGEUJVFVHKAYCEGUVRAGBYCNUVSVLZVMZR
      VNZVOAYIYJEKAUIEUMVFVPVQZVRKUVQRAYJUVOEUVPAYMUUTSZVTZUVASZVTZUKZWAZEUVOKA
      YGYGEKUWDUWDVNZAUWJEKAUWGUWIEKAUWFEKAUUTEKAFEUMUWEVRKUWARWBWCAUWHEKAUVAEK
      AGEUMUWEVRKUWCRWBWCVNWDYMUWKUVOWEZAUVNUWKOZUEYGWFUFYGWFUWMUWNUFUEYGYGUWNU
      VNUWJTZUVJUWGTUVMUWITUWOUUTUVGUVIWGUVAUVKUVLWGUVJUWGUVMUWIWHWIUVNUWJUVJUV
      MUVGUVIUUTWJUVKUVLUVAWJWKWLWMWNUFUEYGYGUVNUWKUVOUVOQWOWPVGWQWRZVOAYLUUREK
      AUIEUNVFXEVQZWSKUVQRAYMYGUKZUUFSZVTZSZVTZWAZUUMSZVTZSZVTZWAZUKZYJSZVTZUXK
      UKZWTUQZEUURKAYMYGEKUWLUWDVNAUXIUXLEKAUXCUXHEKAUXBEKAUXAEKAUWTEKAUWSEKAUU
      FEKAFEUNUWQWSKUWARWBWCWBWCWDAUXGEKAUXFEKAUXEEKAUXDEKAUUMEKAGEUNUWQWSKUWCR
      WBWCWBWCWDVNAUXKUXKEKAUXJEKAYJEKUWPWBWCZUXNVNXAUWRUXMUURWEZAUUQUXMOZUBYGW
      FUAYMWFUXOUXPUAUBYMYGUXIXBOUXLXBOYQYRUKZUXIUUQWEZUXQUXLTZUXPUXCUXHUXBUXAU
      WTUWSUUFFUNXCXDXFXDXFXGUXGUXFUXEUXDUUMGUNXCXDXFXDXFXGWKUXKUXKUXJYJDUMXCXD
      XFZUXTWKUUPUXIOZUDYRWFUCYQWFUXRUYAUCUDYQYRUUHUXCOZUUOUXHOZUYAUYBUUHUXBTUU
      HUUGSZVTZUXBUUGYTUUBWGUUGUWTTUYDUXATUYEUXBTUUFUUDUUEWGUUGUWTXHUYDUXAXIXJX
      KUUHUXBYTUUBUUGWJWLWMUYCUUOUXGTUUOUUNSZVTZUXGUUNUUIUUJWGUUNUXETUYFUXFTUYG
      UXGTUUMUUKUULWGUUNUXEXHUYFUXFXIXJXKUUOUXGUUIUUJUUNWJWLWMUUHUUOUXCUXHXLWIW
      NUCUDYQYRUUPUXIUUQUUQQWOWPYQUXKTYRUXKTUXSYJYOYPWGYJYNXMYQUXKYRUXKWHWIUXIU
      XLUXQUUQXBXBXQXNWNUAUBYMYGUUQUXMUURUURQWOWPVGWQVOXOXPAFGDJAYCUGFEUGXRZUVT
      VMAYCUGGUYHUWBVMXSDEUGXTYAUVSYB $.
  $}

  ${
    $d f g u v x y A $.  $d f g u v x y B $.  $d f g u v x y ph $.
    $d f g u v x y C $.  $d f g u v x y D $.
    xpcpropd.1 $e |- ( ph -> ( Homf ` A ) = ( Homf ` B ) ) $.
    xpcpropd.2 $e |- ( ph -> ( comf ` A ) = ( comf ` B ) ) $.
    xpcpropd.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    xpcpropd.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    xpcpropd.a $e |- ( ph -> A e. V ) $.
    xpcpropd.b $e |- ( ph -> B e. V ) $.
    xpcpropd.c $e |- ( ph -> C e. V ) $.
    xpcpropd.d $e |- ( ph -> D e. V ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same product category.  (Contributed by
       Mario Carneiro, 17-Jan-2017.) $)
    xpcpropd $p |- ( ph -> ( A Xc. C ) = ( B Xc. D ) ) $=
      ( co cfv cop eqid wcel syl vx vy vg vf vv vu cxpc cnx cbs cxp chom cco cv
      c2nd c1st cmpt2 ctp eqidd wceq xpcbas xpchomfval xpcval homfeqbas xpeq12d
      a1i w3a chomf 3ad2ant1 xp1st 3ad2ant2 3ad2ant3 homfeqval xp2nd mpt2eq3dva
      syl5eq wa ad4antr ccomf simp-4r simpllr simpr 1st2nd2 fveq2d df-ov xpchom
      syl6eqr eqtrd eleqtrd simplr comfeqval opeq12d 3impa eqtr4d ) ABDUGOZUHUI
      PBUIPZDUIPZUJZQUHUKPWNUKPZQUHULPUAUBWQWQUJZWQUCUDUAUMZUNPZUBUMZWROZWTWRPZ
      UCUMZUOPZUDUMZUOPZWTUOPZUOPZXAUOPZQZXBUOPZBULPZOOZXEUNPZXGUNPZXIUNPZXAUNP
      ZQZXBUNPZDULPZOOZQZUPZUPZQUQCEUGOZAUAUBUEUFWQBDYBWNXNUDUCBUKPZDUKPZWRYFFF
      WOWPWNRZWORZWPRZYHRZYIRZXNRZYBRZKMAWQURWRUFUEWQWQUFUMZUOPZUEUMZUOPZYHOZYQ
      UNPZYSUNPZYIOZUJZUPZUSAUEUFWQBDWNYHYIWRYJBDWNWOWPYJYKYLUTZYMYNWRRZVAZVEAY
      FURVBAUAUBUEUFWQCEEULPZYGCULPZUDUCCUKPZEUKPZWRYFFFCUIPZEUIPZYGRUUNRUUORUU
      LRZUUMRZUUKRZUUJRZLNAWOUUNWPUUOABCGVCADEIVCVDAWRUUFUFUEWQWQYRYTUULOZUUBUU
      CUUMOZUJZUPUUIAUFUEWQWQUUEUVBAYQWQSZYSWQSZVFZUUAUUTUUDUVAUVEWOBCYHUULYRYT
      YKYMUUPAUVCBVGPCVGPUSZUVDGVHUVCAYRWOSUVDYQWOWPVIVJUVDAYTWOSUVCYSWOWPVIVKV
      LUVEWPDEYIUUMUUBUUCYLYNUUQAUVCDVGPEVGPUSZUVDIVHUVCAUUBWPSUVDYQWOWPVMVJUVD
      AUUCWPSUVCYSWOWPVMVKVLVDVNVOAUAUBWSWQYEUCUDXCXDXFXHXLXMUUKOOZXPXQXTYAUUJO
      OZQZUPZAWTWSSZXBWQSZYEUVKUSAUVLVPZUVMVPZUCUDXCXDYDUVJUVOXEXCSZXGXDSZYDUVJ
      USUVOUVPVPZUVQVPZXOUVHYCUVIUVSWOBCUUKXNXHXFYHXJXKXMYKYMYOUURAUVFUVLUVMUVP
      UVQGVQABVRPCVRPUSUVLUVMUVPUVQHVQUVSXIWQSZXJWOSUVSUVLUVTAUVLUVMUVPUVQVSZWT
      WQWQVITZXIWOWPVITUVSXAWQSZXKWOSUVSUVLUWCUWAWTWQWQVMTZXAWOWPVITUVSUVMXMWOS
      UVNUVMUVPUVQVTZXBWOWPVITUVSXGXJXKYHOZXRXSYIOZUJZSZXHUWFSUVSXGXDUWHUVRUVQW
      AUVSXDXIXAWROZUWHUVSXDXIXAQZWRPUWJUVSWTUWKWRUVSUVLWTUWKUSUWAWTWQWQWBTWCXI
      XAWRWDWFUVSWQBDWNYHYIWRXIXAYJUUGYMYNUUHUWBUWDWEWGWHZXGUWFUWGVITUVSXEXKXMY
      HOZXSYAYIOZUJZSZXFUWMSUVSXEXCUWOUVOUVPUVQWIUVSWQBDWNYHYIWRXAXBYJUUGYMYNUU
      HUWDUWEWEWHZXEUWMUWNVITWJUVSWPDEUUJYBXQXPYIXRXSYAYLYNYPUUSAUVGUVLUVMUVPUV
      QIVQADVRPEVRPUSUVLUVMUVPUVQJVQUVSUVTXRWPSUWBXIWOWPVMTUVSUWCXSWPSUWDXAWOWP
      VMTUVSUVMYAWPSUWEXBWOWPVMTUVSUWIXQUWGSUWLXGUWFUWGVMTUVSUWPXPUWNSUWQXEUWMU
      WNVMTWJWKWLVNWLVNVBWM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Functor evaluation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c evalF $.
  $c curryF $.
  $c uncurryF $.
  $c DiagFunc $.

  $( Extend class notation with the evaluation functor. $)
  cevlf $a class evalF $.

  $( Extend class notation with the currying of a functor. $)
  ccurf $a class curryF $.

  $( Extend class notation with the uncurrying of a functor. $)
  cuncf $a class uncurryF $.

  $( Extend class notation to include the diagonal functor. $)
  cdiag $a class DiagFunc $.

  ${
    $d a c d f g m n x y C $.  $d a c d f g m n x y D $.  $d c d g m n x y H $.
    $d a c d e f g h m n x y z $.  $d a g m n x y F $.  $d a c d g m n x y N $.
    $d a g m n x y G $.  $d a c d f g m n x y ph $.  $d a c d g m n x y .x. $.
    $d a g A $.  $d c d x y B $.  $d a g m n x y X $.  $d a g m n x y Y $.
    $d a g K $.
    $( Define the evaluation functor, which is the extension of the evaluation
       map ` f , x |-> ( f `` x ) ` of functors, to a functor
       ` ( C --> D ) X. C --> D ` .  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    df-evlf $a |- evalF = ( c e. Cat , d e. Cat |->
      <. ( f e. ( c Func d ) , x e. ( Base ` c ) |-> ( ( 1st ` f ) ` x ) ) ,
         ( x e. ( ( c Func d ) X. ( Base ` c ) ) ,
           y e. ( ( c Func d ) X. ( Base ` c ) ) |->
           [_ ( 1st ` x ) / m ]_ [_ ( 1st ` y ) / n ]_
           ( a e. ( m ( c Nat d ) n ) ,
             g e. ( ( 2nd ` x ) ( Hom ` c ) ( 2nd ` y ) ) |->
       ( ( a ` ( 2nd ` y ) )
          ( <. ( ( 1st ` m ) ` ( 2nd ` x ) ) ,
               ( ( 1st ` m ) ` ( 2nd ` y ) ) >. ( comp ` d )
               ( ( 1st ` n ) ` ( 2nd ` y ) ) )
         ( ( ( 2nd ` x ) ( 2nd ` m ) ( 2nd ` y ) ) ` g ) ) ) ) >. ) $.

    $( Define the curry functor, which maps a functor ` F : C X. D --> E ` to
       ` curryF ( F ) : C --> ( D --> E ) ` .  (Contributed by Mario Carneiro,
       11-Jan-2017.) $)
    df-curf $a |- curryF = ( e e. _V , f e. _V |-> [_ ( 1st ` e ) / c ]_
      [_ ( 2nd ` e ) / d ]_ <. ( x e. ( Base ` c ) |->
        <. ( y e. ( Base ` d ) |-> ( x ( 1st ` f ) y ) ) ,
           ( y e. ( Base ` d ) , z e. ( Base ` d ) |->
             ( g e. ( y ( Hom ` d ) z ) |-> ( ( ( Id ` c ) ` x )
               ( <. x , y >. ( 2nd ` f ) <. x , z >. ) g ) ) ) >. ) ,
        ( x e. ( Base ` c ) , y e. ( Base ` c ) |->
          ( g e. ( x ( Hom ` c ) y ) |-> ( z e. ( Base ` d ) |->
            ( g ( <. x , z >. ( 2nd ` f ) <. y , z >. )
              ( ( Id ` d ) ` z ) ) ) ) ) >. ) $.

    $( Define the uncurry functor, which can be defined equationally using
       ` evalF ` .  Strictly speaking, the third category argument is not
       needed, since the resulting functor is extensionally equal regardless,
       but it is used in the equational definition and is too much work to
       remove.  (Contributed by Mario Carneiro, 13-Jan-2017.) $)
    df-uncf $a |- uncurryF = ( c e. _V , f e. _V |->
      ( ( ( c ` 1 ) evalF ( c ` 2 ) ) o.func
        ( ( f o.func ( ( c ` 0 ) 1stF ( c ` 1 ) ) )
          pairF ( ( c ` 0 ) 2ndF ( c ` 1 ) ) ) ) ) $.

    $( Define the diagonal functor, which is the functor ` C --> ( D Func C ) `
       whose object part is ` x e. C |-> ( y e. D |-> x ) ` .  The value of the
       functor at an object ` x ` is the constant functor which maps all
       objects in ` D ` to ` x ` and all morphisms to ` 1 ( x ) ` .  The
       morphism part is a natural transformation between these functors, which
       takes ` f : x --> y ` to the natural transformation with every component
       equal to ` f ` .  (Contributed by Mario Carneiro, 6-Jan-2017.) $)
    df-diag $a |- DiagFunc = ( c e. Cat , d e. Cat |->
      ( <. c , d >. curryF ( c 1stF d ) ) ) $.

    evlfval.e $e |- E = ( C evalF D ) $.
    evlfval.c $e |- ( ph -> C e. Cat ) $.
    evlfval.d $e |- ( ph -> D e. Cat ) $.
    evlfval.b $e |- B = ( Base ` C ) $.
    evlfval.h $e |- H = ( Hom ` C ) $.
    evlfval.o $e |- .x. = ( comp ` D ) $.
    evlfval.n $e |- N = ( C Nat D ) $.
    $( Value of the evaluation functor.  (Contributed by Mario Carneiro,
       12-Jan-2017.) $)
    evlfval $p |- ( ph -> E =
      <. ( f e. ( C Func D ) , x e. B |-> ( ( 1st ` f ) ` x ) ) ,
         ( x e. ( ( C Func D ) X. B ) , y e. ( ( C Func D ) X. B ) |->
           [_ ( 1st ` x ) / m ]_ [_ ( 1st ` y ) / n ]_
           ( a e. ( m N n ) , g e. ( ( 2nd ` x ) H ( 2nd ` y ) ) |->
       ( ( a ` ( 2nd ` y ) )
          ( <. ( ( 1st ` m ) ` ( 2nd ` x ) ) ,
               ( ( 1st ` m ) ` ( 2nd ` y ) ) >. .x.
               ( ( 1st ` n ) ` ( 2nd ` y ) ) )
         ( ( ( 2nd ` x ) ( 2nd ` m ) ( 2nd ` y ) ) ` g ) ) ) ) >. ) $=
      ( vc vd cevlf co cfunc c1st cfv cmpt2 cxp c2nd cop csb ccat cbs cnat chom
      cv cco cvv wceq df-evlf a1i wa simprl simprr oveq12d fveq2d syl6eqr eqidd
      mpt2eq123dv xpeq12d oveqd csbeq2dv opeq12d wcel opex ovmpt2d syl5eq ) ALE
      FUEUFHBEFUGUFZDBUSZHUSUHUIUIZUJZBCWADUKZWEJWBUHUIZKCUSZUHUIZOIJUSZKUSZNUF
      ZWBULUIZWGULUIZMUFZWMOUSUIZIUSWLWMWIULUIUFUIZWLWIUHUIZUIWMWQUIUMZWMWJUHUI
      UIZGUFZUFZUJZUNZUNZUJZUMZPAUCUDEFUOUOHBUCUSZUDUSZUGUFZXGUPUIZWCUJZBCXIXJU
      KZXLJWFKWHOIWIWJXGXHUQUFZUFZWLWMXGURUIZUFZWOWPWRWSXHUTUIZUFZUFZUJZUNZUNZU
      JZUMZXFUEVAUEUCUDUOUOYDUJVBABCHIJKOUCUDVCVDAXGEVBZXHFVBZVEVEZXKWDYCXEYGHB
      XIXJWCWADWCYGXGEXHFUGAYEYFVFZAYEYFVGZVHZYGXJEUPUIDYGXGEUPYHVISVJZYGWCVKVL
      YGBCXLXLYBWEWEXDYGXIWAXJDYJYKVMZYLYGJWFYAXCYGKWHXTXBYGOIXNXPXSWKWNXAYGXMN
      WIWJYGXMEFUQUFNYGXGEXHFUQYHYIVHUBVJVNYGXOMWLWMYGXOEURUIMYGXGEURYHVITVJVNY
      GXRWTWOWPYGXQGWRWSYGXQFUTUIGYGXHFUTYIVIUAVJVNVNVLVOVOVLVPQRXFVAVQAWDXEVRV
      DVSVT $.

    evlf2.f $e |- ( ph -> F e. ( C Func D ) ) $.
    evlf2.g $e |- ( ph -> G e. ( C Func D ) ) $.
    evlf2.x $e |- ( ph -> X e. B ) $.
    evlf2.y $e |- ( ph -> Y e. B ) $.
    evlf2.l $e |- L = ( <. F , X >. ( 2nd ` E ) <. G , Y >. ) $.
    $( Value of the evaluation functor at a morphism.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    evlf2 $p |- ( ph -> L = ( a e. ( F N G ) , g e. ( X H Y ) |->
      ( ( a ` Y ) ( <. ( ( 1st ` F ) ` X ) , ( ( 1st ` F ) ` Y ) >. .x.
        ( ( 1st ` G ) ` Y ) ) ( ( X ( 2nd ` F ) Y ) ` g ) ) ) ) $=
      ( vx vy vm vn vf cop c2nd cfv co cv c1st cmpt2 cfunc cxp csb wceq evlfval
      cvv ovex cbs fvex eqeltri mpt2ex xpex op2ndd wa wcel simprl fveq2d op1stg
      syl a1i syl2anc adantr eqtrd simplrr ad2antrr simplr simpr oveq12d op2ndg
      ad3antrrr fveq12d opeq12d oveq123d fveq1d csbied2 opelxpi ovmpt2d syl5eq
      mpt2eq123dv ) AKHMUMZINUMZGUNUOZUPOFHILUPZMNJUPZNOUQZUOZFUQZMNHUNUOZUPZUO
      ZMHURUOZUOZNXJUOZUMZNIURUOZUOZEUPZUPZUSZUGAUHUIWSWTCDUTUPZBVAZXTUJUHUQZUR
      UOZUKUIUQZURUOZOFUJUQZUKUQZLUPZYAUNUOZYCUNUOZJUPZYIXDUOZXFYHYIYEUNUOZUPZU
      OZYHYEURUOZUOZYIYOUOZUMZYIYFURUOZUOZEUPZUPZUSZVBZVBZXRXAVEAGULUHXSBYAULUQ
      URUOUOZUSZUHUIXTXTUUEUSZUMVCXAUUHVCAUHUIBCDEULFUJUKGJLOPQRSTUAUBVDUUGUUHG
      ULUHXSBUUFCDUTVFZBCVGUOVESCVGVHVIZVJUHUIXTXTUUEXSBUUIUUJVKZUUKVJVLVRAYAWS
      VCZYCWTVCZVMZVMZUJYBHUUDXRVEYBVEVNUUOYAURVHVSUUOYBWSURUOZHUUOYAWSURAUULUU
      MVOZVPAUUPHVCZUUNAHXSVNZMBVNZUURUCUEHMXSBVQVTWAWBUUOYEHVCZVMZUKYDIUUCXRVE
      YDVEVNUVBYCURVHVSUVBYDWTURUOZIUVBYCWTURAUULUUMUVAWCZVPAUVCIVCZUUNUVAAIXSV
      NZNBVNZUVEUDUFINXSBVQVTWDWBUVBYFIVCZVMZOFYGYJUUBXBXCXQUVIYEHYFILUUOUVAUVH
      WEZUVBUVHWFZWGUVIYHMYINJUVIYHWSUNUOZMUVIYAWSUNUUOUULUVAUVHUUQWDVPAUVLMVCZ
      UUNUVAUVHAUUSUUTUVMUCUEHMXSBWHVTWIWBZUVIYIWTUNUOZNUVIYCWTUNUVBUUMUVHUVDWA
      VPAUVONVCZUUNUVAUVHAUVFUVGUVPUDUFINXSBWHVTWIWBZWGUVIYKXEYNXIUUAXPUVIYRXMY
      TXOEUVIYPXKYQXLUVIYHMYOXJUVIYEHURUVJVPZUVNWJUVIYINYOXJUVRUVQWJWKUVIYINYSX
      NUVIYFIURUVKVPUVQWJWGUVIYINXDUVQVPUVIXFYMXHUVIYHMYINYLXGUVIYEHUNUVJVPUVNU
      VQWLWMWLWRWNWNAUUSUUTWSXTVNUCUEHMXSBWOVTAUVFUVGWTXTVNUDUFINXSBWOVTXRVEVNA
      OFXBXCXQHILVFMNJVFVJVSWPWQ $.

    evlf2val.a $e |- ( ph -> A e. ( F N G ) ) $.
    evlf2val.k $e |- ( ph -> K e. ( X H Y ) ) $.
    $( Value of the evaluation natural transformation at an object.
       (Contributed by Mario Carneiro, 12-Jan-2017.) $)
    evlf2val $p |- ( ph -> ( A L K ) =
      ( ( A ` Y ) ( <. ( ( 1st ` F ) ` X ) , ( ( 1st ` F ) ` Y ) >. .x.
        ( ( 1st ` G ) ` Y ) ) ( ( X ( 2nd ` F ) Y ) ` K ) ) ) $=
      ( va vg co cv cfv c2nd c1st cop evlf2 wceq wa simprl fveq1d simprr fveq2d
      cvv oveq12d wcel ovex a1i ovmpt2d ) AUJUKBKHIMULNOJULOUJUMZUNZUKUMZNOHUOU
      NULZUNZNHUPUNZUNOVPUNUQOIUPUNUNFULZULOBUNZKVNUNZVQULZLVEACDEFUKGHIJLMNOUJ
      PQRSTUAUBUCUDUEUFUGURAVKBUSZVMKUSZUTUTZVLVRVOVSVQWCOVKBAWAWBVAVBWCVMKVNAW
      AWBVCVDVFUHUIVTVEVGAVRVSVQVHVIVJ $.
  $}

  ${
    $d x y B $.  $d a f g m n x y C $.  $d f x F $.  $d a f g m n x y ph $.
    $d a f g m n x y D $.  $d f x X $.
    evlf1.e $e |- E = ( C evalF D ) $.
    evlf1.c $e |- ( ph -> C e. Cat ) $.
    evlf1.d $e |- ( ph -> D e. Cat ) $.
    evlf1.b $e |- B = ( Base ` C ) $.
    evlf1.f $e |- ( ph -> F e. ( C Func D ) ) $.
    evlf1.x $e |- ( ph -> X e. B ) $.
    $( Value of the evaluation functor at an object.  (Contributed by Mario
       Carneiro, 12-Jan-2017.) $)
    evlf1 $p |- ( ph -> ( F ( 1st ` E ) X ) = ( ( 1st ` F ) ` X ) ) $=
      ( vf vx vy co cv c1st cfv vm vn va cfunc cvv cmpt2 cxp cnat c2nd chom cop
      vg cco csb wceq eqid evlfval ovex cbs fvex eqeltri mpt2ex xpex op1std syl
      wa simprl fveq2d simprr fveq12d wcel a1i ovmpt2d ) ANOFGCDUDQZBORZNRZSTZT
      ZGFSTZTZESTZUEAENOVNBVRUFZOPVNBUGZWCUAVOSTUBPRZSTUCULUARZUBRZCDUHQZQVOUIT
      ZWDUITZCUJTZQWIUCRTULRWHWIWEUITQTWHWESTZTWIWKTUKWIWFSTTDUMTZQQUFUNUNZUFZU
      KUOWAWBUOAOPBCDWLNULUAUBEWJWGUCHIJKWJUPWLUPWGUPUQWBWNENOVNBVRCDUDURZBCUST
      UEKCUSUTVAZVBOPWCWCWMVNBWOWPVCZWQVBVDVEAVPFUOZVOGUOZVFVFZVOGVQVSWTVPFSAWR
      WSVGVHAWRWSVIVJLMVTUEVKAGVSUTVLVM $.
  $}

  ${
    $d a f g h m n u v x y z C $.  $d f g u v x y z E $.  $d f g u v x y z Q $.
    $d a f g h m n u v x y z D $.  $d a f g h m n u v x y z ph $.
    evlfcl.e $e |- E = ( C evalF D ) $.
    evlfcl.q $e |- Q = ( C FuncCat D ) $.
    evlfcl.c $e |- ( ph -> C e. Cat ) $.
    evlfcl.d $e |- ( ph -> D e. Cat ) $.
    ${
      evlfcl.n $e |- N = ( C Nat D ) $.
      evlfcl.f $e |- ( ph -> ( F e. ( C Func D ) /\ X e. ( Base ` C ) ) ) $.
      evlfcl.g $e |- ( ph -> ( G e. ( C Func D ) /\ Y e. ( Base ` C ) ) ) $.
      evlfcl.h $e |- ( ph -> ( H e. ( C Func D ) /\ Z e. ( Base ` C ) ) ) $.
      evlfcl.a $e |- ( ph ->
        ( A e. ( F N G ) /\ K e. ( X ( Hom ` C ) Y ) ) ) $.
      evlfcl.b $e |- ( ph ->
        ( B e. ( G N H ) /\ L e. ( Y ( Hom ` C ) Z ) ) ) $.
      $( Lemma for ~ evlfcl .  (Contributed by Mario Carneiro, 12-Jan-2017.) $)
      evlfcllem $p |- ( ph ->
      ( ( <. F , X >. ( 2nd ` E ) <. H , Z >. ) `
        ( <. B , L >. ( <. <. F , X >. , <. G , Y >. >.
          ( comp ` ( Q Xc. C ) ) <. H , Z >. ) <. A , K >. ) ) =
      ( ( ( <. G , Y >. ( 2nd ` E ) <. H , Z >. ) ` <. B , L >. )
        ( <. ( ( 1st ` E ) ` <. F , X >. ) , ( ( 1st ` E ) ` <. G , Y >. ) >.
          ( comp ` D ) ( ( 1st ` E ) ` <. H , Z >. ) )
        ( ( <. F , X >. ( 2nd ` E ) <. G , Y >. ) ` <. A , K >. ) ) ) $=
        ( cop cco cfv co c2nd c1st cxpc cbs chom eqid cfunc wcel simpld fuccocl
        simprd catcocl evlf2val fuccoval oveq1d wrel wbr relfunc sylancr funcco
        1st2ndbr oveq2d nat1st2nd funcf1 ffvelrnd funcf2 catass 3eqtr4d 3eqtr3d
        nati natcl eqtrd 3eqtrd fucbas fuchom xpcco2 fveq2d df-ov syl6eqr evlf1
        syl5eqr opeq12d oveq12d oveq123d ) ACBHIUGJFUHUIZUJUJZLKNOUGPDUHUIZUJUJ
        ZHNUGZJPUGZGUKUIZUJZUJZPCUIZLOPIUKUIZUJZUIZOIULUIZUIZPXHUIZUGPJULUIZUIZ
        EUHUIZUJUJZOBUIZKNOHUKUIZUJZUIZNHULUIZUIZOXSUIZUGZXIXMUJUJZXTXIUGZXLXMU
        JZUJZCLUGZBKUGZWSIOUGZUGWTFDUMUJZUHUIZUJUJZXBUIZYGYIWTXAUJZUIZYHWSYIXAU
        JZUIZWSGULUIZUIZYIYRUIZUGZWTYRUIZXMUJZUJAXCPWPUIZWRNPXPUJUIZXTPXSUIZUGX
        LXMUJZUJXDPBUIZUUFXJUGXLXMUJUJZUUEUUGUJZYFAWPDUNUIZDEXMGHJDUOUIZWRXBMNP
        QSTUUKUPZUULUPZXMUPZUAAHDEUQUJZURZNUUKURZUBUSZAJUUPURZPUUKURZUDUSZAUUQU
        URUBVAZAUUTUVAUDVAZXBUPADEFBCWOHIJMRUAWOUPZABHIMUJURZKNOUULUJZURZUEUSZA
        CIJMUJURZLOPUULUJZURZUFUSZUTAUUKDWQKLUULNOPUUMUUNWQUPZSUVCAIUUPURZOUUKU
        RZUCVAZUVDAUVFUVHUEVAZAUVJUVLUFVAZVBVCAUUDUUIUUEUUGAUUKDEFBCWOXMHIJMPRU
        AUUMUUOUVEUVIUVMUVDVDVEAUUJUUILOPXPUJZUIZXRYBUUFXMUJUJZUUGUJZYFAUUEUWBU
        UIUUGAUUKDWQEXSXPUULKLXMNOPUUMUUNUVNUUOAUUPVFZUUQXSXPUUPVGDEVHZUUSHUUPV
        KVIZUVCUVQUVDUVRUVSVJVLAUUIUWAYAUUFUGZXLXMUJUJZXRYBXLXMUJZUJXNXOYAXIUGZ
        XLXMUJUJZXRUWIUJUWCYFAUWHUWKXRUWIAXDUUHUWAUWGXJXMUJUJZYAXJUGXLXMUJZUJXD
        XGXOUWJXJXMUJUJZUWMUJUWHUWKAUWLUWNXDUWMABUUKDELXMXSXPUULXHXEMOPUAABDEHI
        MUAUVIVMZUUMUUNUUOUVQUVDUVSVTVLAEUNUIZEXMUWAUUHEUOUIZXDXLYAUUFXJUWPUPZU
        WQUPZUUOTAUUKUWPOXSAUUKUWPDEXSXPUUMUWRUWFVNZUVQVOZAUUKUWPPXSUWTUVDVOZAU
        UKUWPPXHAUUKUWPDEXHXEUUMUWRAUWDUVOXHXEUUPVGUWEAUVOUVPUCUSZIUUPVKVIZVNZU
        VDVOZAUVKYAUUFUWQUJLUVTAUUKDEXSXPUULUWQOPUUMUUNUWSUWFUVQUVDVPUVSVOZABUU
        KDEXSXPUWQXHXEMPUAUWOUUMUWSUVDWAZAUUKUWPPXKAUUKUWPDEXKJUKUIZUUMUWRAUWDU
        UTXKUXIUUPVGUWEUVBJUUPVKVIVNUVDVOZACUUKDEXHXEUWQXKUXIMPUAACDEIJMUAUVMVM
        UUMUWSUVDWAZVQAUWPEXMXOXGUWQXDXLYAXIXJUWRUWSUUOTUXAAUUKUWPOXHUXEUVQVOZU
        XFABUUKDEXSXPUWQXHXEMOUAUWOUUMUWSUVQWAZAUVKXIXJUWQUJLXFAUUKDEXHXEUULUWQ
        OPUUMUUNUWSUXDUVQUVDVPUVSVOZUXJUXKVQVRVEAUWPEXMXRUWAUWQUUIXLXTYAUUFUWRU
        WSUUOTAUUKUWPNXSUWTUVCVOZUXAUXBAUVGXTYAUWQUJKXQAUUKDEXSXPUULUWQNOUUMUUN
        UWSUWFUVCUVQVPUVRVOZUXGUXJAUWPEXMUUHXDUWQUUFXJXLUWRUWSUUOTUXBUXFUXJUXHU
        XKVBVQAUWPEXMXRXOUWQXNXLXTYAXIUWRUWSUUOTUXOUXAUXLUXPUXMUXJAUWPEXMXGXDUW
        QXIXJXLUWRUWSUUOTUXLUXFUXJUXNUXKVBVQVSWBWCAYMWPWRUGZXBUIXCAYLUXQXBAFDIO
        JPWQYJWOBKMUULCLHNYKUUPUUKYJUPDEFRWDUUMDEFMRUAWEUUNUUSUVCUXCUVQUVEUVNYK
        UPUVBUVDUVIUVRUVMUVSWFWGWPWRXBWHWIAYOXNYQYCUUCYEAUUAYDUUBXLXMAYSXTYTXIA
        YSHNYRUJXTHNYRWHAUUKDEGHNQSTUUMUUSUVCWJWKAYTIOYRUJXIIOYRWHAUUKDEGIOQSTU
        UMUXCUVQWJWKWLAUUBJPYRUJXLJPYRWHAUUKDEGJPQSTUUMUVBUVDWJWKWMAYOCLYNUJXNC
        LYNWHACUUKDEXMGIJUULLYNMOPQSTUUMUUNUUOUAUXCUVBUVQUVDYNUPUVMUVSVCWKAYQBK
        YPUJYCBKYPWHABUUKDEXMGHIUULKYPMNOQSTUUMUUNUUOUAUUSUXCUVCUVQYPUPUVIUVRVC
        WKWNVR $.
    $}

    $( The evaluation functor is a bifunctor (a two-argument functor) with the
       first parameter taking values in the set of functors ` C --> D ` , and
       the second parameter in ` D ` .  (Contributed by Mario Carneiro,
       12-Jan-2017.) $)
    evlfcl $p |- ( ph -> E e. ( ( Q Xc. C ) Func D ) ) $=
      ( vf vx cfv cop co wcel wceq cv eqid wral wa vy vm vn va vg vz vu vv c1st
      vh c2nd cxpc cfunc cvv cxp cbs cnat chom cco csb evlfval ovex fvex mpt2ex
      cmpt2 xpex opelvv syl6eqel 1st2nd2 syl wbr fucbas xpcbas fuccat xpccat wf
      ccid wrel relfunc simpr 1st2ndbr sylancr funcf1 ffvelrnda ralrimiva fmpt2
      sylib op1std feq1d mpbird wfn csbex fnmpt2i op2ndd fneq1d mpbiri ad2antrr
      ccat adantr simplrl simplrr ffvelrnd simprl simprr funcf2 nat1st2nd natcl
      catcocl ralrimivva evlf2 fuchom xpchom2 evlf1 oveq12d oveq2 fveq2 syl6eqr
      feq23d df-ov oveq2d feq123d oveq1d 2ralbidv syl5bb sylibr r19.21bi fveq2d
      ralxp catidcl 3eqtr4d fveq12d w3a 3ad2ant1 eqeltrrd opelxp xpchom eleqtrd
      oveq1 opeq12d oveq123d anasss xpcid catlid ccom fucid fvco3 syl2anc eqtrd
      fveq1d funcid 3eqtrd eqeq12d simp21 simp22 simp23 simp3l simp3r evlfcllem
      evlf2val id isfuncd df-br eqeltrd ) AEEUILZEUKLZMZDBULNZCUMNZAEUNUNUOZOEU
      VFPAEJKBCUMNZBUPLZKQZJQZUILZLZVEZKUAUVJUVKUOZUVQUBUVLUILZUCUAQZUILZUDUEUB
      QZUCQZBCUQNZNZUVLUKLZUVSUKLZBURLZNZUWFUDQZLUEQZUWEUWFUWAUKLNLUWEUWAUILZLU
      WFUWKLMUWFUWBUILLCUSLZNNZVEZUTZUTZVEZMZUVIAKUAUVKBCUWLJUEUBUCEUWGUWCUDFHI
      UVKRZUWGRZUWLRZUWCRZVAZUVPUWQJKUVJUVKUVOBCUMVBZBUPVCZVDZKUAUVQUVQUWPUVJUV
      KUXDUXEVFZUXGVDZVGVHEUNUNVIVJAUVDUVEUVHVKUVFUVHOAKUAUFUVQCUPLZUVGUVGUSLZU
      VGVQLZJUECUVDUVEUVGURLZCVQLZCURLZUWLDBUVGUVJUVKUVGRZBCDGVLZUWSVMZUXIRZUXL
      RZUXNRZUXKRZUXMRZUXJRUXAADBUVGUXOABCDGHIVNZHVOIAUVQUXIUVDVPUVQUXIUVPVPZAU
      VOUXIOZKUVKSZJUVJSUYDAUYFJUVJAUVMUVJOZTZUYEKUVKUYHUVKUXIUVLUVNUYHUVKUXIBC
      UVNUVMUKLZUWSUXRUYHUVJVRZUYGUVNUYIUVJVKZBCVSZAUYGVTUVMUVJWAZWBWCWDWEWEJKU
      VJUVKUVOUXIUVPUVPRWFWGAUVQUXIUVDUVPAEUWRPZUVDUVPPUXCUVPUWQEUXFUXHWHVJWIWJ
      AUVEUVQUVQUOZWKUWQUYOWKKUAUVQUVQUWPUWQUWQRUBUVRUWOUCUVTUWNUDUEUWDUWHUWMUW
      AUWBUWCVBUWEUWFUWGVBVDWLWLWMAUYOUVEUWQAUYNUVEUWQPUXCUVPUWQEUXFUXHWNVJWOWP
      AUVLUVQOZUVSUVQOZUVLUVSUXLNZUVLUVDLZUVSUVDLZUXNNZUVLUVSUVENZVPZAUYPTVUCUA
      UVQAVUCUAUVQSZKUVQAUVMUGQZMZUWJUHQZMZUXLNZUVMVUEUVDNZUWJVUGUVDNZUXNNZVUFV
      UHUVENZVPZUHUVKSUEUVJSZUGUVKSJUVJSVUDKUVQSAVUOJUGUVJUVKAUYGVUEUVKOZTZTZVU
      NUEUHUVJUVKVURUWJUVJOZVUGUVKOZTZTZVUNUVMUWJUWCNZVUEVUGUWGNZUOZVUEUVNLZVUG
      UWJUILZLZUXNNZVUMVPZVVBVVJVVEVVIUDUJVVCVVDVUGUWILZUJQZVUEVUGUYINZLZVVFVUG
      UVNLZMVVHUWLNNZVEZVPZVVBVVPVVIOZUJVVDSUDVVCSVVRVVBVVSUDUJVVCVVDVVBUWIVVCO
      ZVVLVVDOZTZTZUXICUWLVVNVVKUXNVVFVVOVVHUXRUXTUXAVVBCWROZVWBAVWDVUQVVAIWQZW
      SVWCUVKUXIVUEUVNVVBUVKUXIUVNVPZVWBVVBUVKUXIBCUVNUYIUWSUXRVVBUYJUYGUYKUYLA
      UYGVUPVVAWTZUYMWBZWCWSZVVBVUPVWBAUYGVUPVVAXAZWSXBVWCUVKUXIVUGUVNVWIVURVUS
      VUTVWBXAZXBVWCUVKUXIVUGVVGVVBUVKUXIVVGVPVWBVVBUVKUXIBCVVGUWJUKLZUWSUXRVVB
      UYJVUSVVGVWLUVJVKUYLVURVUSVUTXCZUWJUVJWAWBWCWSVWKXBVWCVVDVVFVVOUXNNZVVLVV
      MVVBVVDVWNVVMVPVWBVVBUVKBCUVNUYIUWGUXNVUEVUGUWSUWTUXTVWHVWJVURVUSVUTXDZXE
      WSVVBVVTVWAXDXBVWCUWIUVKBCUVNUYIUXNVVGVWLUWCVUGUXBVWCUWIBCUVMUWJUWCUXBVVB
      VVTVWAXCXFUWSUXTVWKXGXHXIUDUJVVCVVDVVPVVIVVQVVQRWFWGVVBVVEVVIVUMVVQVVBUVK
      BCUWLUJEUVMUWJUWGVUMUWCVUEVUGUDFABWROZVUQVVAHWQZVWEUWSUWTUXAUXBVWGVWMVWJV
      WOVUMRXJWIWJVVBVUIVULVVEVVIVUMVVBDBUWJVUGUVGUWCUWGUXLUVMVUEUVJUVKUXOUXPUW
      SBCDUWCGUXBXKZUWTVWGVWJVWMVWOUXSXLVVBVUJVVFVUKVVHUXNVVBUVKBCEUVMVUEFVWQVW
      EUWSVWGVWJXMVVBUVKBCEUWJVUGFVWQVWEUWSVWMVWOXMXNXRWJXIXIVUDVUOKJUGUVJUVKVU
      DUVLVUHUXLNZUYSVUKUXNNZUVLVUHUVENZVPZUHUVKSUEUVJSUVLVUFPZVUOVUCVXBUAUEUHU
      VJUVKUVSVUHPZUYRVWSVUAVWTVUBVXAUVSVUHUVLUVEXOUVSVUHUVLUXLXOVXDUYTVUKUYSUX
      NVXDUYTVUHUVDLVUKUVSVUHUVDXPUWJVUGUVDXSXQXTYAYHVXCVXBVUNUEUHUVJUVKVXCVWSV
      UIVWTVULVXAVUMUVLVUFVUHUVEYRUVLVUFVUHUXLYRVXCUYSVUJVUKUXNVXCUYSVUFUVDLVUJ
      UVLVUFUVDXPUVMVUEUVDXSXQZYBYAYCYDYHYEYFYFUUAAUVLUXKLZUVLUVLUVENZLZUYSUXML
      ZPZKUVQAVUFUXKLZVUFVUFUVENZLZVUJUXMLZPZUGUVKSJUVJSVXJKUVQSAVXOJUGUVJUVKVU
      RVXMUVMDVQLZLZVUEBVQLZLZVXLNZVUEVXQLZVXSVUEVUEUYINLZVVFVVFMVVFUWLNZNZVXNV
      URVXMVXQVXSMZVXLLVXTVURVXKVYEVXLVURDBUVMVUEUVGUXKVXPVXRUVJUVKUXOADWROVUQU
      YCWSZAVWPVUQHWSZUXPUWSVXPRZVXRRZUYAAUYGVUPXCZAUYGVUPXDZUUBYGVXQVXSVXLXSXQ
      VURVXQUVKBCUWLEUVMUVMUWGVXSVXLUWCVUEVUEFVYGAVWDVUQIWSZUWSUWTUXAUXBVYJVYJV
      YKVYKVXLRVURUVJDVXPUWCUVMUXPVWRVYHVYFVYJYIVURUVKBVXRUWGVUEUWSUWTVYIVYGVYK
      YIUUSVURVVFUXMLZVYMVYCNVYMVYDVXNVURUXICUWLUXMVYMUXNVVFVVFUXRUXTUYBVYLVURU
      VKUXIVUEUVNVURUVKUXIBCUVNUYIUWSUXRVURUYJUYGUYKUYLVYJUYMWBZWCZVYKXBZUXAVYP
      VURUXICUXMUXNVVFUXRUXTUYBVYLVYPYIUUCVURVYAVYMVYBVYMVYCVURVYAVUEUXMUVNUUDZ
      LZVYMVURVUEVXQVYQVURBCDUXMUVMVXPGVYHUYBVYJUUEUUIVURVWFVUPVYRVYMPVYOVYKUVK
      UXIVUEUXMUVNUUFUUGUUHVURUVKBVXRCUVNUYIUXMVUEUWSVYIUYBVYNVYKUUJXNVURVUJVVF
      UXMVURUVKBCEUVMVUEFVYGVYLUWSVYJVYKXMYGYJUUKXIVXJVXOKJUGUVJUVKVXCVXHVXMVXI
      VXNVXCVXFVXKVXGVXLVXCUVLVUFUVLVUFUVEVXCUUTZVYSXNUVLVUFUXKXPYKVXCUYSVUJUXM
      VXEYGUULYHYEYFAUYPUYQUFQZUVQOZYLZUVMUYROZUWJUVSVYTUXLNZOZTZYLZVVGVWLMZUVN
      UYIMZUVRUWEMZUVTUWFMZMZVYTUILZVYTUKLZMZUXJNZNZWUJWUOUVENZLWUHWUKWUOUVENZL
      ZWUIWUJWUKUVENZLZWUJUVDLZWUKUVDLZMZWUOUVDLZUWLNZNUWJUVMUVLUVSMZVYTUXJNZNZ
      UVLVYTUVENZLUWJUVSVYTUVENZLZUVMVUBLZUYSUYTMZVYTUVDLZUWLNZNWUGUVNVVGBCDEUV
      RUVTWUMUYIVWLUWCUWEUWFWUNFGAWUBVWPWUFHYMAWUBVWDWUFIYMUXBWUGWUJUVQOUVRUVJO
      UWEUVKOTWUGUVLWUJUVQWUGUYPUVLWUJPAUYPUYQWUAWUFUUMZUVLUVJUVKVIVJZWVRYNUVRU
      WEUVJUVKYOWGWUGWUKUVQOUVTUVJOUWFUVKOTWUGUVSWUKUVQWUGUYQUVSWUKPAUYPUYQWUAW
      UFUUNZUVSUVJUVKVIVJZWVTYNUVTUWFUVJUVKYOWGWUGWUOUVQOWUMUVJOWUNUVKOTWUGVYTW
      UOUVQWUGWUAVYTWUOPAUYPUYQWUAWUFUUOZVYTUVJUVKVIVJZWWBYNWUMWUNUVJUVKYOWGWUG
      WUIUVRUVTUWCNZUWHUOZOUVNWWDOUYIUWHOTWUGUVMWUIWWEWUGUVMWWEOUVMWUIPWUGUVMUY
      RWWEAWUBWUCWUEUUPWUGUVQDBUVGUWCUWGUXLUVLUVSUXOUXQVWRUWTUXSWVRWVTYPYQZUVMW
      WDUWHVIVJZWWFYNUVNUYIWWDUWHYOWGWUGWUHUVTWUMUWCNZUWFWUNUWGNZUOZOVVGWWHOVWL
      WWIOTWUGUWJWUHWWJWUGUWJWWJOUWJWUHPWUGUWJWUDWWJAWUBWUCWUEUUQWUGUVQDBUVGUWC
      UWGUXLUVSVYTUXOUXQVWRUWTUXSWVTWWBYPYQZUWJWWHWWIVIVJZWWKYNVVGVWLWWHWWIYOWG
      UURWUGWVJWUQWVKWURWUGUVLWUJVYTWUOUVEWVSWWCXNWUGUWJWUHUVMWUIWVIWUPWUGWVHWU
      LVYTWUOUXJWUGUVLWUJUVSWUKWVSWWAYSWWCXNWWLWWGYTYKWUGWVMWUTWVNWVBWVQWVGWUGW
      VOWVEWVPWVFUWLWUGUYSWVCUYTWVDWUGUVLWUJUVDWVSYGWUGUVSWUKUVDWWAYGYSWUGVYTWU
      OUVDWWCYGXNWUGUWJWUHWVLWUSWUGUVSWUKVYTWUOUVEWWAWWCXNWWLYKWUGUVMWUIVUBWVAW
      UGUVLWUJUVSWUKUVEWVSWWAXNWWGYKYTYJUVAUVDUVEUVHUVBWGUVC $.
  $}

  ${
    $d c d e f g x y z .1. $.  $d c d e f x y A $.  $d c d e f g h w x y z B $.
    $d c d e f g x y z C $.  $d c d e f g h w x y z D $.  $d c d e f g y z H $.
    $d c d e f I $.  $d c d e f g h w x y z ph $.  $d g y z Y $.  $d g y z Z $.
    $d g h w y z E $.  $d c d e f g x J $.  $d g h w y z K $.  $d g x y z X $.
    $d c d e f g x y z F $.
    curfval.g $e |- G = ( <. C , D >. curryF F ) $.
    curfval.a $e |- A = ( Base ` C ) $.
    curfval.c $e |- ( ph -> C e. Cat ) $.
    curfval.d $e |- ( ph -> D e. Cat ) $.
    curfval.f $e |- ( ph -> F e. ( ( C Xc. D ) Func E ) ) $.
    curfval.b $e |- B = ( Base ` D ) $.
    ${
      curfval.j $e |- J = ( Hom ` D ) $.
      curfval.1 $e |- .1. = ( Id ` C ) $.
      ${
        curfval.h $e |- H = ( Hom ` C ) $.
        curfval.i $e |- I = ( Id ` D ) $.
        $( Value of the curry functor.  (Contributed by Mario Carneiro,
           12-Jan-2017.) $)
        curfval $p |- ( ph -> G = <. ( x e. A |->
     <. ( y e. B |-> ( x ( 1st ` F ) y ) ) ,
        ( y e. B , z e. B |-> ( g e. ( y J z ) |->
          ( ( .1. ` x ) ( <. x , y >. ( 2nd ` F ) <. x , z >. ) g ) ) ) >. ) ,
        ( x e. A , y e. A |-> ( g e. ( x H y ) |-> ( z e. B |->
          ( g ( <. x , z >. ( 2nd ` F ) <. y , z >. ) ( I ` z ) ) ) ) ) >. ) $=
          ( ve vf vc vd cop ccurf co c1st cfv cmpt c2nd cmpt2 cvv cbs chom ccid
          cv csb wceq df-curf a1i wa wcel fvex simprl fveq2d ccat op1stg adantr
          syl2anc eqtrd op2ndg ad2antrr simplr syl6eqr simpr simprr oveqd eqidd
          mpteq12dv fveq1d oveq123d mpt2eq123dv opeq12d csbied2 opex cxpc cfunc
          elex syl ovmpt2d syl5eq ) AMGHUKZLULUMBECFBVCZCVCZLUNUOZUMZUPZCDFFJXA
          DVCZPUMZWTIUOZJVCZWTXAUKZWTXEUKZLUQUOZUMZUMZUPZURZUKZUPZBCEEJWTXANUMZ
          DFXHXEOUOZXJXAXEUKZXKUMZUMZUPZUPZURZUKZQAUGUHWSLUSUSUIUGVCZUNUOZUJYGU
          QUOZBUIVCZUTUOZCUJVCZUTUOZWTXAUHVCZUNUOZUMZUPZCDYMYMJXAXEYLVAUOZUMZWT
          YJVBUOZUOZXHXIXJYNUQUOZUMZUMZUPZURZUKZUPZBCYKYKJWTXAYJVAUOZUMZDYMXHXE
          YLVBUOZUOZXJXTUUBUMZUMZUPZUPZURZUKZVDZVDZYFULUSULUGUHUSUSUUTURVEABCDU
          GUHJUIUJVFVGAYGWSVEZYNLVEZVHZVHZUIYHGUUSYFUSYHUSVIUVDYGUNVJVGUVDYHWSU
          NUOZGUVDYGWSUNAUVAUVBVKZVLAUVEGVEZUVCAGVMVIZHVMVIZUVGSTGHVMVMVNVPVOVQ
          UVDYJGVEZVHZUJYIHUURYFUSYIUSVIUVKYGUQVJVGUVKYIWSUQUOZHUVKYGWSUQUVDUVA
          UVJUVFVOVLAUVLHVEZUVCUVJAUVHUVIUVMSTGHVMVMVRVPVSVQUVKYLHVEZVHZUUHXQUU
          QYEUVOBYKUUGEXPUVOYKGUTUOEUVOYJGUTUVDUVJUVNVTZVLRWAZUVOYQXDUUFXOUVOCY
          MYPFXCUVOYMHUTUOFUVOYLHUTUVKUVNWBZVLUBWAZUVOYOXBWTXAUVOYNLUNUVDUVBUVJ
          UVNAUVAUVBWCVSZVLWDWFUVOCDYMYMUUEFFXNUVSUVSUVOJYSUUDXFXMUVOYRPXAXEUVO
          YRHVAUOPUVOYLHVAUVRVLUCWAWDUVOUUAXGXHXHUUCXLUVOUUBXKXIXJUVOYNLUQUVTVL
          ZWDUVOWTYTIUVOYTGVBUOIUVOYJGVBUVPVLUDWAWGUVOXHWEZWHWFWIWJWFUVOBCYKYKU
          UPEEYDUVQUVQUVOJUUJUUOXRYCUVOUUINWTXAUVOUUIGVAUONUVOYJGVAUVPVLUEWAWDU
          VODYMUUNFYBUVSUVOXHXHUULXSUUMYAUVOUUBXKXJXTUWAWDUWBUVOXEUUKOUVOUUKHVB
          UOOUVOYLHVBUVRVLUFWAWGWHWFWFWIWJWKWKWSUSVIAGHWLVGALGHWMUMKWNUMZVILUSV
          IUALUWCWOWPYFUSVIAXQYEWLVGWQWR $.
      $}

      $( Value of the object part of the curry functor.  (Contributed by Mario
         Carneiro, 12-Jan-2017.) $)
      curf1fval $p |- ( ph -> ( 1st ` G ) = ( x e. A |->
   <. ( y e. B |-> ( x ( 1st ` F ) y ) ) ,
      ( y e. B , z e. B |-> ( g e. ( y J z ) |->
        ( ( .1. ` x ) ( <. x , y >. ( 2nd ` F ) <. x , z >. ) g ) ) ) >. ) ) $=
        ( cv c1st cfv co cmpt cop c2nd chom ccid wceq eqid curfval cbs cvv fvex
        cmpt2 eqeltri mptex mpt2ex op1std syl ) AMBECFBUCZCUCZLUDUEUFUGCDFFJVED
        UCZNUFVDIUEJUCZVDVEUHVDVFUHZLUIUEZUFUFUGURUHZUGZBCEEJVDVEGUJUEZUFDFVGVF
        HUKUEZUEVHVEVFUHVIUFUFUGUGZURZUHULMUDUEVKULABCDEFGHIJKLMVLVMNOPQRSTUAUB
        VLUMVMUMUNVKVOMBEVJEGUOUEUPPGUOUQUSZUTBCEEVNVPVPVAVBVC $.
    $}

    curf1.x $e |- ( ph -> X e. A ) $.
    curf1.k $e |- K = ( ( 1st ` G ) ` X ) $.
    ${
      curf1.j $e |- J = ( Hom ` D ) $.
      curf1.1 $e |- .1. = ( Id ` C ) $.
      $( Value of the object part of the curry functor.  (Contributed by Mario
         Carneiro, 12-Jan-2017.) $)
      curf1 $p |- ( ph -> K = <. ( y e. B |-> ( X ( 1st ` F ) y ) ) ,
       ( y e. B , z e. B |-> ( g e. ( y J z ) |->
         ( ( .1. ` X ) ( <. X , y >. ( 2nd ` F ) <. X , z >. ) g ) ) ) >. ) $=
        ( vx c1st cfv cv co cmpt cop c2nd cmpt2 cvv curf1fval wceq simpr oveq1d
        wa mpteq2dv wcel simp1r opeq1d oveq12d fveq2d eqidd oveq123d mpt2eq3dva
        w3a opeq12d opex a1i fvmptd syl5eq ) ANOLUGUHZUHBEOBUIZKUGUHZUJZUKZBCEE
        IVQCUIZMUJZOHUHZIUIZOVQULZOWAULZKUMUHZUJZUJZUKZUNZULZUCAUFOBEUFUIZVQVRU
        JZUKZBCEEIWBWMHUHZWDWMVQULZWMWAULZWGUJZUJZUKZUNZULWLDVPUOAUFBCDEFGHIJKL
        MPQRSTUAUDUEUPAWMOUQZUTZWOVTXBWKXDBEWNVSXDWMOVQVRAXCURUSVAXDBCEEXAWJXDV
        QEVBZWAEVBZVJZIWBWTWIXGWPWCWDWDWSWHXGWQWEWRWFWGXGWMOVQAXCXEXFVCZVDXGWMO
        WAXHVDVEXGWMOHXHVFXGWDVGVHVAVIVKUBWLUOVBAVTWKVLVMVNVO $.
    $}

    ${
      curf11.y $e |- ( ph -> Y e. B ) $.
      $( Value of the double evaluated curry functor.  (Contributed by Mario
         Carneiro, 12-Jan-2017.) $)
      curf11 $p |- ( ph -> ( ( 1st ` K ) ` Y ) = ( X ( 1st ` F ) Y ) ) $=
        ( vy vz vg cv c1st cfv co cvv cmpt chom ccid c2nd cmpt2 wceq eqid curf1
        cop cbs fvex eqeltri mptex mpt2ex op1std syl simpr oveq2d wcel ovex a1i
        wa fvmptd ) AUAKJUAUDZGUEUFZUGZJKVMUGZCIUEUFZUHAIUACVNUIZUAUBCCUCVLUBUD
        ZEUJUFZUGJDUKUFZUFUCUDJVLUQJVRUQGULUFUGUGUIZUMZUQUNVPVQUNAUAUBBCDEVTUCF
        GHVSIJLMNOPQRSVSUOVTUOUPVQWBIUACVNCEURUFUHQEURUSUTZVAUAUBCCWAWCWCVBVCVD
        AVLKUNZVJVLKJVMAWDVEVFTVOUHVGAJKVMVHVIVK $.

      curf12.j $e |- J = ( Hom ` D ) $.
      curf12.1 $e |- .1. = ( Id ` C ) $.
      curf12.y $e |- ( ph -> Z e. B ) $.
      curf12.g $e |- ( ph -> H e. ( Y J Z ) ) $.
      $( The partially evaluated curry functor at a morphism.  (Contributed by
         Mario Carneiro, 12-Jan-2017.) $)
      curf12 $p |- ( ph -> ( ( Y ( 2nd ` K ) Z ) ` H ) =
        ( ( .1. ` X ) ( <. X , Y >. ( 2nd ` F ) <. X , Z >. ) H ) ) $=
        ( vy vz vg c2nd cfv cv co cop cmpt cmpt2 wceq c1st cbs cvv fvex eqeltri
        curf1 mptex mpt2ex op2ndd syl wcel adantr wa ovex simprl simprr oveq12d
        a1i eleqtrrd simplrl simplrr eqidd simpr oveq123d fvmptdv2 ovmpt2dv mpd
        opeq2d ) ALULUMZUIUJCCUKUIUNZUJUNZKUOZMFUMZUKUNZMWIUPZMWJUPZHULUMZUOZUO
        ZUQZURZUSZJNOWHUOZUMWLJMNUPZMOUPZWPUOZUOZUSZALUICMWIHUTUMUOZUQZWTUPUSXA
        AUIUJBCDEFUKGHIKLMPQRSTUAUBUCUEUFVEXIWTLUICXHCEVAUMVBUAEVAVCVDZVFUIUJCC
        WSXJXJVGVHVIAXGUIUJNOCCWSWHVBUDAOCVJWINUSZUGVKWSVBVJAXKWJOUSZVLZVLZUKWK
        WRWIWJKVMVFVQXNUKJWRXFWKXBVBXNJNOKUOZWKAJXOVJXMUHVKXNWINWJOKAXKXLVNAXKX
        LVOVPVRWRVBVJXNWMJUSZVLZWLWMWQVMVQXQWLWLWMJWQXEXQWNXCWOXDWPXQWINMAXKXLX
        PVSWGXQWJOMAXKXLXPVTWGVPXQWLWAXNXPWBWCWDWEWF $.
    $}

    $( The partially evaluated curry functor is a functor.  (Contributed by
       Mario Carneiro, 13-Jan-2017.) $)
    curf1cl $p |- ( ph -> K e. ( D Func E ) ) $=
      ( cfv co vy vz vg vw vh c1st c2nd cop cfunc cv cmpt chom ccid cmpt2 curf1
      eqid wceq cbs cvv fvex eqeltri mptex mpt2ex op1std syl op2ndd opeq12d wbr
      eqtr4d wcel cco cxpc ccat funcrcl simprd cxp xpcbas wrel relfunc 1st2ndbr
      wa sylancr funcf1 adantr simpr fovrnd fmptd feq1d mpbird wfn ovex fnmpt2i
      fneq1d mpbiri ad2antrr simplrl opelxpi syl2anc funcf2 xpchom curf11 df-ov
      simplrr syl6req oveq12d feq23d mpbid catidcl op1stg eleqtrrd op2ndg oveqd
      wf ovmpt4g mp3an3 sylan9eq xpcid fveq2d sylan funcid eqtr3d curf12 syl6eq
      syl6eqr 3eqtr4d 3ad2ant1 simp21 simp22 simp23 simp3l simp3r xpcco2 catlid
      w3a opeq1d eqtrd xpchom2 funcco catcocl oveq123d isfuncd df-br eqeltrd
      sylib ) AIIUFSZIUGSZUHZEFUITZAIUACJUAUJZGUFSZTZUKZUAUBCCUCUUIUBUJZEULSZTZ
      JDUMSZSZUCUJZJUUIUHZJUUMUHZGUGSZTZTZUKZUNZUHZUUGAUAUBBCDEUUPUCFGHUUNIJKLM
      NOPQRUUNUPZUUPUPZUOZAUUEUULUUFUVEAIUVFUQZUUEUULUQUVIUULUVEIUACUUKCEURSUSP
      EURUTVAZVBZUAUBCCUVDUVKUVKVCZVDVEZAUVJUUFUVEUQUVIUULUVEIUVLUVMVFVEZVGVIAU
      UEUUFUUHVHUUGUUHVJAUAUBUDCFURSZEEVKSZEUMSZUCUEFUUEUUFUUNFUMSZFULSZFVKSZPU
      VPUPZUVGUVTUPZUVRUPZUVSUPZUVQUPZUWAUPZNADEVLTZVMVJZFVMVJZAGUWHFUITZVJZUWI
      UWJWAOUWHFGVNVEVOACUVPUUEXMCUVPUULXMAUACUUKUVPUULAUUICVJZWAZJUUIUVPBCUUJA
      BCVPZUVPUUJXMUWMAUWOUVPUWHFUUJUVADEUWHBCUWHUPZLPVQZUWBAUWKVRUWLUUJUVAUWKV
      HZUWHFVSOGUWKVTWBZWCWDAJBVJZUWMQWDZAUWMWEZWFUULUPWGACUVPUUEUULUVNWHWIAUUF
      CCVPZWJUVEUXCWJUAUBCCUVDUVEUVEUPZUCUUOUVCUUIUUMUUNWKVBZWLAUXCUUFUVEUVOWMW
      NAUWMUUMCVJZWAZWAZUUOUUIUUESZUUMUUESZUVTTZUUIUUMUUFTZXMUUOUXKUVDXMUXHUCUU
      OUVCUXKUVDUXHUURUUOVJZWAZUUQUURUXKUUSUFSZUUTUFSZDULSZTZUUSUGSZUUTUGSZUUNT
      ZUVBUXNUUSUUTUWHULSZTZUUSUUJSZUUTUUJSZUVTTZUVBXMUXRUYAVPZUXKUVBXMUXNUWOUW
      HFUUJUVAUYBUVTUUSUUTUWQUYBUPZUWCAUWRUXGUXMUWSWOUXNUWTUWMUUSUWOVJZAUWTUXGU
      XMQWOZAUWMUXFUXMWPZJUUIBCWQZWRZUXNUWTUXFUUTUWOVJZUYJAUWMUXFUXMXCZJUUMBCWQ
      ZWRZWSUXNUYCUYFUYGUXKUVBUXNUWODEUWHUXQUUNUYBUUSUUTUWPUWQUXQUPZUVGUYHUYMUY
      QWTUXNUYDUXIUYEUXJUVTUXNUXIUUKUYDUXNBCDEFGHIJUUIKLADVMVJZUXGUXMMWOZAEVMVJ
      ZUXGUXMNWOZAUWLUXGUXMOWOZPUYJRUYKXAJUUIUUJXBZXDUXNUXJJUUMUUJTZUYEUXNBCDEF
      GHIJUUMKLUYTVUBVUCPUYJRUYOXAJUUMUUJXBZXDXEXFXGUXNUUQJJUXQTZUXRUXNBDUUPUXQ
      JLUYRUVHUYTUYJXHUXNUXOJUXPJUXQUXNUWTUWMUXOJUQUYJUYKJUUIBCXIWRUXNUWTUXFUXP
      JUQUYJUYOJUUMBCXIWRXEXJUXNUURUUOUYAUXHUXMWEUXNUXSUUIUXTUUMUUNUXNUWTUWMUXS
      UUIUQUYJUYKJUUIBCXKWRUXNUWTUXFUXTUUMUQUYJUYOJUUMBCXKWRXEXJWFUVDUPWGUXHUUO
      UXKUXLUVDAUXGUXLUUIUUMUVETZUVDAUUFUVEUUIUUMUVOXLUWMUXFUVDUSVJVUHUVDUQUXEU
      AUBCCUVDUVEUSUXDXNXOXPWHWIUWNUUQUUIUVRSZUUSUUSUVATZTZUYDUVSSZVUIUUIUUIUUF
      TSUXIUVSSUWNUUSUWHUMSZSZVUJSZVUKVULUWNVUOUUQVUIUHZVUJSVUKUWNVUNVUPVUJUWND
      EJUUIUWHVUMUUPUVRBCUWPAUYSUWMMWDZAVUAUWMNWDZLPUVHUWDVUMUPZUXAUXBXQXRUUQVU
      IVUJXBYDUWNUWOUWHVUMFUUJUVAUVSUUSUWQVUSUWEAUWRUWMUWSWDAUWTUWMUYIQUYLXSXTY
      AUWNBCDEUUPFGHVUIUUNIJUUIUUIKLVUQVURAUWLUWMOWDZPUXARUXBUVGUVHUXBUWNCEUVRU
      UNUUIPUVGUWDVURUXBXHYBUWNUXIUYDUVSUWNUXIUUKUYDUWNBCDEFGHIJUUIKLVUQVURVUTP
      UXARUXBXAVUDYCXRYEAUWMUXFUDUJZCVJZYNZUXMUEUJZUUMVVAUUNTZVJZWAZYNZUUQVVDUU
      RUUIUUMUHVVAUVQTTZUUSJVVAUHZUVATZTZUUQVVDUHZUUTVVJUVATZSZUUQUURUHZUVBSZUY
      DUYEUHZVVJUUJSZUWATZTZVVIUUIVVAUUFTSVVDUUMVVAUUFTSZUURUXLSZUXIUXJUHZVVAUU
      ESZUWATZTVVHVVMVVPUUSUUTUHVVJUWHVKSZTTZVVKSZVVLVWAVVHVWIUUQVVIUHZVVKSVVLV
      VHVWHVWJVVKVVHVWHUUQUUQJJUHJDVKSZTTZVVIUHVWJVVHDEJUUMJVVAUVQUWHVWKUUQUURU
      XQUUNUUQVVDJUUIVWGBCUWPLPUYRUVGAVVCUWTVVGQYFZAUWMUXFVVBVVGYGZVWMAUWMUXFVV
      BVVGYHZVWKUPZUWFVWGUPZVWMAUWMUXFVVBVVGYIZVVHBDUUPUXQJLUYRUVHAVVCUYSVVGMYF
      ZVWMXHZAVVCUXMVVFYJZVWTAVVCUXMVVFYKZYLVVHVWLUUQVVIVVHBDVWKUUPUUQUXQJJLUYR
      UVHVWSVWMVWPVWMVWTYMYOYPXRUUQVVIVVKXBYDVVHUWOUWHVWGFUUJUVAUYBVVPVVMUWAUUS
      UUTVVJUWQUYHVWQUWGAVVCUWRVVGUWSYFVVHUWTUWMUYIVWMVWNUYLWRVVHUWTUXFUYNVWMVW
      OUYPWRVVHUWTVVBVVJUWOVJVWMVWRJVVABCWQWRVVHVVPVUGUUOVPZUYCVVHUUQVUGVJZUXMV
      VPVXCVJVWTVXAUUQUURVUGUUOWQWRVVHDEJUUMUWHUXQUUNUYBJUUIBCUWPLPUYRUVGVWMVWN
      VWMVWOUYHYQXJVVHVVMVUGVVEVPZUUTVVJUYBTVVHVXDVVFVVMVXEVJVWTVXBUUQVVDVUGVVE
      WQWRVVHDEJVVAUWHUXQUUNUYBJUUMBCUWPLPUYRUVGVWMVWOVWMVWRUYHYQXJYRYAVVHBCDEU
      UPFGHVVIUUNIJUUIVVAKLVWSAVVCVUAVVGNYFZAVVCUWLVVGOYFZPVWMRVWNUVGUVHVWRVVHC
      EUVQUURVVDUUNUUIUUMVVAPUVGUWFVXFVWNVWOVWRVXAVXBYSYBVVHVWBVVOVWCVVQVWFVVTV
      VHVWDVVRVWEVVSUWAVVHUXIUYDUXJUYEVVHUXIUUKUYDVVHBCDEFGHIJUUIKLVWSVXFVXGPVW
      MRVWNXAVUDYCVVHUXJVUEUYEVVHBCDEFGHIJUUMKLVWSVXFVXGPVWMRVWOXAVUFYCVGVVHVWE
      JVVAUUJTVVSVVHBCDEFGHIJVVAKLVWSVXFVXGPVWMRVWRXAJVVAUUJXBYCXEVVHVWBUUQVVDV
      VNTVVOVVHBCDEUUPFGHVVDUUNIJUUMVVAKLVWSVXFVXGPVWMRVWOUVGUVHVWRVXBYBUUQVVDV
      VNXBYCVVHVWCUVCVVQVVHBCDEUUPFGHUURUUNIJUUIUUMKLVWSVXFVXGPVWMRVWNUVGUVHVWO
      VXAYBUUQUURUVBXBYCYTYEUUAUUEUUFUUHUUBUUDUUC $.
  $}

  ${
    $d x y A $.  $d g x y z C $.  $d g x y z F $.  $d g y z H $.  $d f w z L $.
    $d f g w y z E $.  $d f w x y z G $.  $d g x y z I $.  $d f g w x y z ph $.
    $d f g w x y z B $.  $d f g w x y z D $.  $d f g w x y z X $.  $d z Z $.
    $d g x y z K $.  $d f g w x y z Y $.
    curf2.g $e |- G = ( <. C , D >. curryF F ) $.
    curf2.a $e |- A = ( Base ` C ) $.
    curf2.c $e |- ( ph -> C e. Cat ) $.
    curf2.d $e |- ( ph -> D e. Cat ) $.
    curf2.f $e |- ( ph -> F e. ( ( C Xc. D ) Func E ) ) $.
    curf2.b $e |- B = ( Base ` D ) $.
    curf2.h $e |- H = ( Hom ` C ) $.
    curf2.i $e |- I = ( Id ` D ) $.
    curf2.x $e |- ( ph -> X e. A ) $.
    curf2.y $e |- ( ph -> Y e. A ) $.
    curf2.k $e |- ( ph -> K e. ( X H Y ) ) $.
    curf2.l $e |- L = ( ( X ( 2nd ` G ) Y ) ` K ) $.
    $( Value of the curry functor at a morphism.  (Contributed by Mario
       Carneiro, 13-Jan-2017.) $)
    curf2 $p |- ( ph -> L = ( z e. B |->
      ( K ( <. X , z >. ( 2nd ` F ) <. Y , z >. ) ( I ` z ) ) ) ) $=
      ( vx vy vg c2nd cfv co cv cop cmpt cmpt2 wceq c1st chom ccid eqid curfval
      cbs cvv fvex eqeltri mptex mpt2ex op2ndd syl wcel adantr wa simprl simprr
      a1i oveq12d eleqtrrd simplrl opeq1d simplrr simpr eqidd oveq123d mpteq2dv
      ovex fvmptdv2 ovmpt2dv mpd syl5eq ) AMLNOIUKULZUMZULZBDLBUNZKULZNWOUOZOWO
      UOZHUKULZUMZUMZUPZUGAWLUHUICCUJUHUNZUIUNZJUMZBDUJUNZWPXCWOUOZXDWOUOZWSUMZ
      UMZUPZUPZUQZURZWNXBURZAIUHCUIDXCXDHUSULUMUPUIBDDUJXDWOFUTULZUMXCEVAULZULX
      FXCXDUOXGWSUMUMUPUQUOZUPZXMUOURXNAUHUIBCDEFXQUJGHIJKXPPQRSTUAXPVBXQVBUBUC
      VCXSXMIUHCXRCEVDULVEQEVDVFVGZVHUHUICCXLXTXTVIVJVKAXOUHUINOCCXLWLVEUDAOCVL
      XCNURZUEVMXLVEVLAYAXDOURZVNZVNZUJXEXKXCXDJWGVHVQYDUJLXKXBXEWMVEYDLNOJUMZX
      EALYEVLYCUFVMYDXCNXDOJAYAYBVOAYAYBVPVRVSXKVEVLYDXFLURZVNZBDXJDFVDULVEUAFV
      DVFVGVHVQYGBDXJXAYGXFLWPWPXIWTYGXGWQXHWRWSYGXCNWOAYAYBYFVTWAYGXDOWOAYAYBY
      FWBWAVRYDYFWCYGWPWDWEWFWHWIWJWK $.

    ${
      curf2.z $e |- ( ph -> Z e. B ) $.
      $( Value of a component of the curry functor natural transformation.
         (Contributed by Mario Carneiro, 13-Jan-2017.) $)
      curf2val $p |- ( ph -> ( L ` Z ) =
        ( K ( <. X , Z >. ( 2nd ` F ) <. Y , Z >. ) ( I ` Z ) ) ) $=
        ( vz cv cfv cop c2nd co curf2 wceq wa simpr opeq2d oveq12d eqidd fveq2d
        cvv oveq123d wcel ovex a1i fvmptd ) AUIOKUIUJZJUKZMVIULZNVIULZGUMUKZUNZ
        UNKOJUKZMOULZNOULZVMUNZUNZCLVCAUIBCDEFGHIJKLMNPQRSTUAUBUCUDUEUFUGUOAVIO
        UPZUQZKKVJVOVNVRWAVKVPVLVQVMWAVIOMAVTURZUSWAVIONWBUSUTWAKVAWAVIOJWBVBVD
        UHVSVCVEAKVOVRVFVGVH $.
    $}

    curf2.n $e |- N = ( D Nat E ) $.
    $( The curry functor at a morphism is a natural transformation.
       (Contributed by Mario Carneiro, 13-Jan-2017.) $)
    curf2cl $p |- ( ph ->
      L e. ( ( ( 1st ` G ) ` X ) N ( ( 1st ` G ) ` Y ) ) ) $=
      ( vz vw vf c1st cfv co wcel cv chom cixp c2nd cop wceq wral cmpt curf2 wa
      cco cxpc wf cxp eqid xpcbas cfunc wbr wrel relfunc sylancr adantr opelxpi
      1st2ndbr sylan funcf2 simpr xpchom2 feq2d mpbid ccat catidcl fovrnd df-ov
      curf11 syl6eq oveq12d eleqtrrd ralrimiva cvv fvex eqeltri mptelixpg ax-mp
      wb cbs sylibr eqeltrd w3a ccid catrid catlid eqtr4d simpr1 simpr2 opeq12d
      simpr3 xpcco2 3ad2antr1 3eqtr4d fveq2d syl2anc funcco 3eqtr3d ralrimivvva
      curf2val curf12 oveq123d curf1cl isnat2 mpbir2and ) ALNHULUMZUMZOYGUMZMUN
      UOLUICUIUPZYHULUMZUMZYJYIULUMZUMZFUQUMZUNZURZUOUJUPZLUMZUKUPZYJYRYHUSUMUN
      UMZYLYRYKUMZUTZYRYMUMZFVFUMZUNZUNZYTYJYRYIUSUMUNUMZYJLUMZYLYNUTZUUDUUEUNZ
      UNZVAZUKYJYREUQUMZUNZVBUJCVBUICVBALUICKYJJUMZNYJUTZOYJUTZGUSUMZUNZUNZVCZY
      QAUIBCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGVDAUVAYPUOZUICVBZUVBYQUOZAUVCUICAYJCU
      OZVEZUVAUUQGULUMZUMZUURUVHUMZYOUNZYPUVGKUUPUVKNOIUNZYJYJUUNUNZUUTUVGUUQUU
      RDEVGUNZUQUMZUNZUVKUUTVHUVLUVMVIZUVKUUTVHUVGBCVIZUVNFUVHUUSUVOYOUUQUURDEU
      VNBCUVNVJZQUAVKZUVOVJZYOVJZAUVHUUSUVNFVLUNZVMZUVFAUWCVNGUWCUOZUWDUVNFVOTG
      UWCVSVPZVQANBUOZUVFUUQUVRUOZUDNYJBCVRVTZAOBUOZUVFUURUVRUOZUEOYJBCVRVTZWAU
      VGUVPUVQUVKUUTUVGDEOYJUVNIUUNUVONYJBCUVSQUAUBUUNVJZAUWGUVFUDVQZAUVFWBZAUW
      JUVFUEVQZUWOUWAWCWDWEAKUVLUOZUVFUFVQUVGCEJUUNYJUAUWMUCAEWFUOZUVFSVQZUWOWG
      ZWHUVGYLUVIYNUVJYOUVGYLNYJUVHUNZUVIUVGBCDEFGHYHNYJPQADWFUOZUVFRVQZUWSAUWE
      UVFTVQZUAUWNYHVJZUWOWJNYJUVHWIZWKUVGYNOYJUVHUNZUVJUVGBCDEFGHYIOYJPQUXCUWS
      UXDUAUWPYIVJZUWOWJOYJUVHWIZWKWLWMWNCWOUOUVEUVDWTCEXAUMWOUAEXAWPWQUICUVAYP
      WOWRWSXBXCAUUMUIUJUKCCUUOAUVFYRCUOZYTUUOUOZXDZVEZKYRJUMZUTZNYRUTZOYRUTZUU
      SUNZUMZNDXEUMZUMZYTUTZUUQUXPUUSUNZUMZUVIUXPUVHUMZUTZUXQUVHUMZUUEUNZUNZOUX
      TUMZYTUTZUURUXQUUSUNZUMZKUUPUTZUUTUMZUVIUVJUTZUYGUUEUNZUNZUUGUULUXMUXOUYB
      UUQUXPUTUXQUVNVFUMZUNUNZUUQUXQUUSUNZUMUYKUYNUUQUURUTUXQUYSUNUNZVUAUMUYIUY
      RUXMUYTVUBVUAUXMKUYANNUTODVFUMZUNUNZUXNYTYJYRUTYREVFUMZUNUNZUTUYJKNOUTOVU
      CUNUNZYTUUPYJYJUTYRVUEUNUNZUTUYTVUBUXMVUDVUGVUFVUHUXMVUDKVUGUXMBDVUCUXTKI
      NOQUBUXTVJZAUXBUXLRVQZAUWGUXLUDVQZVUCVJZAUWJUXLUEVQZAUWQUXLUFVQZXFUXMBDVU
      CUXTKINOQUBVUIVUJVUKVULVUMVUNXGXHUXMVUFYTVUHUXMCEVUEJYTUUNYJYRUAUWMUCAUWR
      UXLSVQZAUVFUXJUXKXIZVUEVJZAUVFUXJUXKXJZAUVFUXJUXKXLZXGUXMCEVUEJYTUUNYJYRU
      AUWMUCVUOVUPVUQVURVUSXFXHXKUXMDENYROYRVUEUVNVUCUYAYTIUUNKUXNNYJUYSBCUVSQU
      AUBUWMVUKVUPVUKVURVULVUQUYSVJZVUMVURUXMBDUXTINQUBVUIVUJVUKWGZVUSVUNUXMCEJ
      UUNYRUAUWMUCVUOVURWGZXMUXMDEOYJOYRVUEUVNVUCKUUPIUUNUYJYTNYJUYSBCUVSQUAUBU
      WMVUKVUPVUMVUPVULVUQVUTVUMVURVUNAUXJUVFUUPUVMUOZUXKUWTXNZUXMBDUXTIOQUBVUI
      VUJVUMWGZVUSXMXOXPUXMUVRUVNUYSFUVHUUSUVOUYBUXOUUEUUQUXPUXQUVTUWAVUTUUEVJZ
      AUWDUXLUWFVQZAUXJUVFUWHUXKUWIXNZUXMUWGUXJUXPUVRUOVUKVURNYRBCVRXQUXMUWJUXJ
      UXQUVRUOVUMVUROYRBCVRXQZUXMUYBNNIUNZUUOVIZUUQUXPUVOUNUXMUYAVVJUOUXKUYBVVK
      UOVVAVUSUYAYTVVJUUOVRXQUXMDENYRUVNIUUNUVONYJBCUVSQUAUBUWMVUKVUPVUKVURUWAW
      CWMUXMUXOUVLYRYRUUNUNZVIZUXPUXQUVOUNUXMUWQUXNVVLUOUXOVVMUOVUNVVBKUXNUVLVV
      LVRXQUXMDEOYRUVNIUUNUVONYRBCUVSQUAUBUWMVUKVURVUMVURUWAWCWMXRUXMUVRUVNUYSF
      UVHUUSUVOUYNUYKUUEUUQUURUXQUVTUWAVUTVVFVVGVVHAUXJUVFUWKUXKUWLXNVVIUXMUYNU
      VQUVPUXMUWQVVCUYNUVQUOVUNVVDKUUPUVLUVMVRXQUXMDEOYJUVNIUUNUVONYJBCUVSQUAUB
      UWMVUKVUPVUMVUPUWAWCWMUXMUYKOOIUNZUUOVIZUURUXQUVOUNUXMUYJVVNUOUXKUYKVVOUO
      VVEVUSUYJYTVVNUUOVRXQUXMDEOYRUVNIUUNUVOOYJBCUVSQUAUBUWMVUMVUPVUMVURUWAWCW
      MXRXSUXMYSUXSUUAUYDUUFUYHUXMUUCUYFUUDUYGUUEUXMYLUVIUUBUYEUXMYLUXAUVIUXMBC
      DEFGHYHNYJPQVUJVUOAUWEUXLTVQZUAVUKUXEVUPWJUXFWKZUXMUUBNYRUVHUNUYEUXMBCDEF
      GHYHNYRPQVUJVUOVVPUAVUKUXEVURWJNYRUVHWIWKXKUXMUUDOYRUVHUNUYGUXMBCDEFGHYIO
      YRPQVUJVUOVVPUAVUMUXHVURWJOYRUVHWIWKZWLUXMYSKUXNUXRUNUXSUXMBCDEFGHIJKLNOY
      RPQVUJVUOVVPUAUBUCVUKVUMVUNUGVURYAKUXNUXRWIWKUXMUUAUYAYTUYCUNUYDUXMBCDEUX
      TFGHYTUUNYHNYJYRPQVUJVUOVVPUAVUKUXEVUPUWMVUIVURVUSYBUYAYTUYCWIWKYCUXMUUHU
      YMUUIUYOUUKUYQUXMUUJUYPUUDUYGUUEUXMYLUVIYNUVJVVQUXMYNUXGUVJUXMBCDEFGHYIOY
      JPQVUJVUOVVPUAVUMUXHVUPWJUXIWKXKVVRWLUXMUUHUYJYTUYLUNUYMUXMBCDEUXTFGHYTUU
      NYIOYJYRPQVUJVUOVVPUAVUMUXHVUPUWMVUIVURVUSYBUYJYTUYLWIWKUXMUUIUVAUYOUXMBC
      DEFGHIJKLNOYJPQVUJVUOVVPUAUBUCVUKVUMVUNUGVUPYAKUUPUUTWIWKYCXOXTAUIUJLCEFU
      UEUKYHYIUUNYOMUHUAUWMUWBVVFABCDEFGHYHNPQRSTUAUDUXEYDABCDEFGHYIOPQRSTUAUEU
      XHYDYEYF $.
  $}

  ${
    $d g w x y z D $.  $d g w x y z E $.  $d g w x y z F $.  $d f g x y z Q $.
    $d f g w x y z C $.  $d f g w x y z G $.  $d f g w x y z ph $.
    curfcl.g $e |- G = ( <. C , D >. curryF F ) $.
    curfcl.q $e |- Q = ( D FuncCat E ) $.
    curfcl.c $e |- ( ph -> C e. Cat ) $.
    curfcl.d $e |- ( ph -> D e. Cat ) $.
    curfcl.f $e |- ( ph -> F e. ( ( C Xc. D ) Func E ) ) $.
    $( The curry functor of a functor ` F : C X. D --> E ` is a functor
       ` curryF ( F ) : C --> ( D --> E ) ` .  (Contributed by Mario Carneiro,
       13-Jan-2017.) $)
    curfcl $p |- ( ph -> G e. ( C Func Q ) ) $=
      ( vx vy cfv cop co eqid wcel adantr vz vg vf vw c1st c2nd cfunc cmpt chom
      cbs cv ccid cmpt2 curfval wceq fvex mptex mpt2ex op1std syl op2ndd eqtr4d
      opeq12d wbr cco cnat fucbas fuchom cxpc ccat wa funcrcl simprd fuccat cvv
      opex a1i simpr curf1cl fmpt2d cxp wfn fnmpt2i fneq1d mpbiri oveqd ovmpt4g
      ovex mp3an3 sylan9eq ad2antrr simplrl simplrr curf2cl ccom xpcbas relfunc
      1st2ndbr sylancr opelxpi adantll funcid xpcid fveq2d df-ov syl6eqr curf11
      wrel syl6req 3eqtr3d mpteq2dva wf cidfn dffn2 sylib funcf1 fcompt syl2anc
      catidcl curf2 3eqtr4d 3ad2ant1 simp21 syl6eq simp22 simp23 oveq12d simp3r
      fucid curf2val simp3l oveq123d sylan eleqtrrd funcco xpcco2 catlid opeq2d
      w3a xpchom2 eqtrd 3eqtr2rd catcocl fucco isfuncd df-br eqeltrd ) AGGUEOZG
      UFOZPZBDUGQZAGMBUJOZNCUJOZMUKZNUKZFUEOZQZUHZNUAUUMUUMUBUUOUAUKZCUIOZQUUNB
      ULOZOZUBUKZUUNUUOPZUUNUUSPZFUFOZQQUHUMZPZUHZMNUULUULUBUUNUUOBUIOZQZUAUUMU
      VCUUSCULOZOUVEUUOUUSPUVFQQZUHZUHZUMZPZUUJAMNUAUULUUMBCUVAUBEFGUVJUVLUUTHU
      ULRZJKLUUMRZUUTRZUVARZUVJRZUVLRZUNZAUUHUVIUUIUVPAGUVQUOZUUHUVIUOUWDUVIUVP
      GMUULUVHBUJUPZUQZMNUULUULUVOUWFUWFURZUSUTZAUWEUUIUVPUOUWDUVIUVPGUWGUWHVAU
      TZVCVBAUUHUUIUUKVDUUJUUKSAMNUAUULCEUGQZBBVEOZUVAUCUBDUUHUUIUVJDULOZCEVFQZ
      DVEOZUVRCEDIVGUWBCEDUWNIUWNRZVHUWAUWMRZUWLRZUWORZJACEDIKABCVIQZVJSZEVJSZA
      FUWTEUGQZSZUXAUXBVKLUWTEFVLUTVMZVNAMMUULUVHUWKUUHVOUVHVOSAUUNUULSZVKZUURU
      VGVPVQUWIUXGUULUUMBCEFGUUNUUHOZUUNHUVRABVJSZUXFJTZACVJSZUXFKTZAUXDUXFLTZU
      VSAUXFVRZUXHRZVSZVTAUUIUULUULWAZWBUVPUXQWBMNUULUULUVOUVPUVPRZUBUVKUVNUUNU
      UOUVJWHUQZWCAUXQUUIUVPUWJWDWEAUXFUUOUULSZVKZVKZUBUBUVKUVNUXHUUOUUHOZUWNQU
      UNUUOUUIQZVOUVNVOSUYBUVCUVKSZVKZUAUUMUVMCUJUPUQVQAUYAUYDUUNUUOUVPQZUVOAUU
      IUVPUUNUUOUWJWFUXFUXTUVOVOSUYGUVOUOUXSMNUULUULUVOUVPVOUXRWGWIWJUYFUULUUMB
      CEFGUVJUVLUVCUVCUYDOZUWNUUNUUOHUVRAUXIUYAUYEJWKAUXKUYAUYEKWKAUXDUYAUYELWK
      UVSUWBUWCAUXFUXTUYEWLAUXFUXTUYEWMUYBUYEVRUYHRUWPWNVTUXGNUUMUVBUUOUVLOZUVD
      UVDUVFQZQZUHZEULOZUXHUEOZWOZUVBUUNUUNUUIQOZUXHUWMOUXGUYLNUUMUUOUYNOZUYMOZ
      UHZUYOUXGNUUMUYKUYRUXGUUOUUMSZVKZUVDUWTULOZOZUYJOZUVDUUPOZUYMOUYKUYRVUAUU
      LUUMWAZUWTVUBEUUPUVFUYMUVDBCUWTUULUUMUWTRZUVRUVSWPZVUBRZUYMRZAUUPUVFUXCVD
      ZUXFUYTAUXCXHZUXDVUKUWTEWQZLFUXCWRZWSWKUXFUYTUVDVUFSAUUNUUOUULUUMWTXAXBVU
      AVUDUVBUYIPZUYJOUYKVUAVUCVUOUYJVUABCUUNUUOUWTVUBUVAUVLUULUUMVUGAUXIUXFUYT
      JWKZAUXKUXFUYTKWKZUVRUVSUWAUWCVUIUXGUXFUYTUXNTZUXGUYTVRZXCXDUVBUYIUYJXEXF
      VUAVUEUYQUYMVUAUYQUUQVUEVUAUULUUMBCEFGUXHUUNUUOHUVRVUPVUQAUXDUXFUYTLWKUVS
      VURUXOVUSXGUUNUUOUUPXEXIXDXJXKUXGEUJOZVOUYMXLZUUMVUTUYNXLUYOUYSUOUXGUYMVU
      TWBZVVAUXGUXBVVBAUXBUXFUXETVUTEUYMVUTRZVUJXMUTVUTUYMXNXOUXGUUMVUTCEUYNUXH
      UFOZUVSVVCUXGUWKXHUXHUWKSUYNVVDUWKVDCEWQUXPUXHUWKWRWSXPNUYMUYNUUMVUTVOXQX
      RVBUXGNUULUUMBCEFGUVJUVLUVBUYPUUNUUNHUVRUXJUXLUXMUVSUWBUWCUXNUXNUXGUULBUV
      AUVJUUNUVRUWBUWAUXJUXNXSUYPRXTUXGCEDUYMUXHUWMIUWQVUJUXPYIYAAUXFUXTUUSUULS
      ZYSZUCUKZUVKSZUVCUUOUUSUVJQZSZVKZYSZUDUUMUVCVVGUVDUUSUWLQQZUDUKZUVLOZUUNV
      VNPZUUSVVNPZUVFQZQZUHUDUUMVVNUVCUUOUUSUUIQOZOZVVNVVGUYDOZOZVVNUYNOZVVNUYC
      UEOOZPZVVNUUSUUHOZUEOOZEVEOZQZQZUHVVMUUNUUSUUIQOZVVTVWBUXHUYCPVWGUWOQQVVL
      UDUUMVVSVWKVVLVVNUUMSZVKZVWKUVCVVOPZUUOVVNPZVVQUVFQZOZVVGVVOPZVVPVWPUVFQZ
      OZVVPUUPOZVWPUUPOZPZVVQUUPOZVWIQZQVWOVWSVVPVWPPVVQUWTVEOZQQZVVROZVVSVWNVW
      AVWRVWCVXAVWJVXFVWNVWFVXDVWHVXEVWIVWNVWDVXBVWEVXCVWNVWDUUNVVNUUPQVXBVWNUU
      LUUMBCEFGUXHUUNVVNHUVRVVLUXIVWMAVVFUXIVVKJYBZTZVVLUXKVWMAVVFUXKVVKKYBZTZV
      VLUXDVWMAVVFUXDVVKLYBZTZUVSVVLUXFVWMAUXFUXTVVEVVKYCZTZUXOVVLVWMVRZXGUUNVV
      NUUPXEYDVWNVWEUUOVVNUUPQVXCVWNUULUUMBCEFGUYCUUOVVNHUVRVXKVXMVXOUVSVVLUXTV
      WMAUXFUXTVVEVVKYEZTZUYCRVXRXGUUOVVNUUPXEYDVCVWNVWHUUSVVNUUPQVXEVWNUULUUMB
      CEFGVWGUUSVVNHUVRVXKVXMVXOUVSVVLVVEVWMAUXFUXTVVEVVKYFZTZVWGRVXRXGUUSVVNUU
      PXEYDYGVWNVWAUVCVVOVWQQVWRVWNUULUUMBCEFGUVJUVLUVCVVTUUOUUSVVNHUVRVXKVXMVX
      OUVSUWBUWCVXTVYBVVLVVJVWMAVVFVVHVVJYHZTZVVTRZVXRYJUVCVVOVWQXEYDVWNVWCVVGV
      VOVWTQVXAVWNUULUUMBCEFGUVJUVLVVGVWBUUNUUOVVNHUVRVXKVXMVXOUVSUWBUWCVXQVXTV
      VLVVHVWMAVVFVVHVVJYKZTZVWBRZVXRYJVVGVVOVWTXEYDYLVWNVUFUWTVXGEUUPUVFUWTUIO
      ZVWSVWOVWIVVPVWPVVQVUHVYIRZVXGRZVWIRZVWNVULUXDVUKVUMVXOVUNWSVVLUXFVWMVVPV
      UFSVXPUUNVVNUULUUMWTYMVVLUXTVWMVWPVUFSVXSUUOVVNUULUUMWTYMVVLVVEVWMVVQVUFS
      VYAUUSVVNUULUUMWTYMVWNVWSUVKVVNVVNUUTQZWAZVVPVWPVYIQVWNVVHVVOVYMSZVWSVYNS
      VYGVWNUUMCUVLUUTVVNUVSUVTUWCVXMVXRXSZVVGVVOUVKVYMWTXRVWNBCUUOVVNUWTUVJUUT
      VYIUUNVVNUULUUMVUGUVRUVSUWBUVTVXQVXRVXTVXRVYJYTYNVWNVWOVVIVYMWAZVWPVVQVYI
      QVWNVVJVYOVWOVYQSVYDVYPUVCVVOVVIVYMWTXRVWNBCUUSVVNUWTUVJUUTVYIUUOVVNUULUU
      MVUGUVRUVSUWBUVTVXTVXRVYBVXRVYJYTYNYOVWNVXIVVMVVOPZVVROVVSVWNVXHVYRVVRVWN
      VXHVVMVVOVVOVVNVVNPVVNCVEOZQQZPVYRVWNBCUUOVVNUUSVVNVYSUWTUWLVVGVVOUVJUUTU
      VCVVOUUNVVNVXGUULUUMVUGUVRUVSUWBUVTVXQVXRVXTVXRUWRVYSRZVYKVYBVXRVYGVYPVYD
      VYPYPVWNVYTVVOVVMVWNUUMCVYSUVLVVOUUTVVNVVNUVSUVTUWCVXMVXRWUAVXRVYPYQYRUUA
      XDVVMVVOVVRXEXFUUBXKVVLUDUULUUMBCEFGUVJUVLVVMVWLUUNUUSHUVRVXJVXLVXNUVSUWB
      UWCVXPVYAVVLUULBUWLVVGUVCUVJUUNUUOUUSUVRUWBUWRVXJVXPVXSVYAVYFVYCUUCVWLRXT
      VVLUDUUMCEDVWBVVTUWOVWIUXHUYCVWGUWNIUWPUVSVYLUWSVVLUULUUMBCEFGUVJUVLVVGVW
      BUWNUUNUUOHUVRVXJVXLVXNUVSUWBUWCVXPVXSVYFVYHUWPWNVVLUULUUMBCEFGUVJUVLUVCV
      VTUWNUUOUUSHUVRVXJVXLVXNUVSUWBUWCVXSVYAVYCVYEUWPWNUUDYAUUEUUHUUIUUKUUFXOU
      UG $.
  $}

  ${
    $d g x y z A $.  $d g x y z B $.  $d g x y z C $.  $d g x y z ph $.
    $d g x y z D $.  $d g y z E $.  $d g x y z F $.
    curfpropd.1 $e |- ( ph -> ( Homf ` A ) = ( Homf ` B ) ) $.
    curfpropd.2 $e |- ( ph -> ( comf ` A ) = ( comf ` B ) ) $.
    curfpropd.3 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    curfpropd.4 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    curfpropd.a $e |- ( ph -> A e. Cat ) $.
    curfpropd.b $e |- ( ph -> B e. Cat ) $.
    curfpropd.c $e |- ( ph -> C e. Cat ) $.
    curfpropd.d $e |- ( ph -> D e. Cat ) $.
    curfpropd.f $e |- ( ph -> F e. ( ( A Xc. C ) Func E ) ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they curry the same functor to the same result.
       (Contributed by Mario Carneiro, 26-Jan-2017.) $)
    curfpropd $p |- ( ph ->
      ( <. A , C >. curryF F ) = ( <. B , D >. curryF F ) ) $=
      ( vy cfv co eqid vx vz vg cbs cv c1st cmpt chom ccid cop c2nd cmpt2 ccurf
      homfeqbas wcel wceq adantr mpteq1d chomf ad2antrr simprl simprr homfeqval
      wa ccat fveq1d oveq1d mpteq12dv mpt2eq123dva opeq12d mpteq12dva ad3antrrr
      cidpropd oveq2d curfval cxpc cfunc xpcpropd eleqtrd 3eqtr4d ) AUABUDRZQDU
      DRZUAUEZQUEZGUFRSZUGZQUBWBWBUCWDUBUEZDUHRZSZWCBUIRZRZUCUEZWCWDUJWCWGUJZGU
      KRZSZSZUGZULZUJZUGZUAQWAWAUCWCWDBUHRZSZUBWBWLWGDUIRZRZWMWDWGUJWNSZSZUGZUG
      ZULZUJUACUDRZQEUDRZWEUGZQUBXKXKUCWDWGEUHRZSZWCCUIRZRZWLWOSZUGZULZUJZUGZUA
      QXJXJUCWCWDCUHRZSZUBXKWLWGEUIRZRZXESZUGZUGZULZUJBDUJGUMSZCEUJGUMSZAWTYAXI
      YIAUAWAWSXJXTABCHUNZAWCWAUOZVDZWFXLWRXSYNQWBXKWEAWBXKUPZYMADEJUNZUQZURYNQ
      UBWBWBWQXKXKXRYQYNYOWDWBUOZYQUQYNYRWGWBUOZVDZVDZUCWIWPXNXQUUAWBDEWHXMWDWG
      WBTZWHTZXMTZADUSREUSRUPYMYTJUTYNYRYSVAYNYRYSVBVCUUAWKXPWLWOUUAWCWJXOAWJXO
      UPYMYTABCVEVEHILMVMUTVFVGVHVIVJVKAUAQWAWAXHXJXJYHYLAWAXJUPYMYLUQAYMWDWAUO
      ZVDZVDZUCXBXGYCYGUUGWABCXAYBWCWDWATZXATZYBTZABUSRCUSRUPUUFHUQAYMUUEVAAYMU
      UEVBVCUUGWLXBUOZVDZUBWBXFXKYFAYOUUFUUKYPUTUULYSVDZXDYEWLXEUUMWGXCYDAXCYDU
      PUUFUUKYSADEVEVEJKNOVMVLVFVNVKVKVIVJAUAQUBWAWBBDWJUCFGYJXAXCWHYJTUUHLNPUU
      BUUCWJTUUIXCTVOAUAQUBXJXKCEXOUCFGYKYBYDXMYKTXJTMOAGBDVPSZFVQSCEVPSZFVQSPA
      UUNUUOFVQABCDEVEHIJKLMNOVRVGVSXKTUUDXOTUUJYDTVOVT $.
  $}

  ${
    $d c f g x y z C $.  $d c f g x y z D $.  $d c f g x y z ph $.
    $d c f g y z E $.  $d g x y z F $.  $d c f g x y z G $.
    uncfval.g $e |- F = ( <" C D E "> uncurryF G ) $.
    uncfval.c $e |- ( ph -> D e. Cat ) $.
    uncfval.d $e |- ( ph -> E e. Cat ) $.
    uncfval.f $e |- ( ph -> G e. ( C Func ( D FuncCat E ) ) ) $.
    $( Value of the uncurry functor, which is the reverse of the curry functor,
       taking ` G : C --> ( D --> E ) ` to ` uncurryF ( G ) : C X. D --> E ` .
       (Contributed by Mario Carneiro, 13-Jan-2017.) $)
    uncfval $p |- ( ph -> F = ( ( D evalF E ) o.func
        ( ( G o.func ( C 1stF D ) ) pairF ( C 2ndF D ) ) ) ) $=
      ( vc co ccofu cvv cfv wceq ccat wcel syl oveq12d vf cs3 cuncf cevlf c1stf
      c2ndf cprf c1 cv c2 cc0 cmpt2 df-uncf wa simprl fveq1d s3fv1 adantr eqtrd
      a1i s3fv2 simprr cfuc cfunc funcrcl simpld s3fv0 cword s3cli elex ovmpt2d
      mp1i ovex syl5eq ) AEBCDUBZFUCLCDUDLZFBCUELZMLZBCUFLZUGLZMLZGAKUAVOFNNUHK
      UIZOZUJWBOZUDLZUAUIZUKWBOZWCUELZMLZWGWCUFLZUGLZMLZWAUCNUCKUANNWLULPAUAKUM
      UTAWBVOPZWFFPZUNZUNZWEVPWKVTMWPWCCWDDUDWPWCUHVOOZCWPUHWBVOAWMWNUOZUPAWQCP
      ZWOACQRWSHBCDQUQSURUSZWPWDUJVOOZDWPUJWBVOWRUPAXADPZWOADQRXBIBCDQVASURUSTW
      PWIVRWJVSUGWPWFFWHVQMAWMWNVBWPWGBWCCUEWPWGUKVOOZBWPUKWBVOWRUPAXCBPZWOABQR
      ZXDAXECDVCLZQRZAFBXFVDLZRZXEXGUNJBXFFVESVFBCDQVGSURUSZWTTTWPWGBWCCUFXJWTT
      TTVONVHZRVONRABCDVIVOXKVJVLAXIFNRJFXHVJSWANRAVPVTMVMUTVKVN $.

    $( The uncurry operation takes a functor ` F : C --> ( D --> E ) ` to a
       functor ` uncurryF ( F ) : C X. D --> E ` .  (Contributed by Mario
       Carneiro, 13-Jan-2017.) $)
    uncfcl $p |- ( ph -> F e. ( ( C Xc. D ) Func E ) ) $=
      ( cevlf co c1stf ccofu cxpc cfunc eqid ccat wcel cofucl cprf uncfval cfuc
      c2ndf wa funcrcl syl simpld 1stfcl 2ndfcl prfcl evlfcl eqeltrd ) AECDKLZF
      BCMLZNLZBCUDLZUALZNLBCOLZDPLABCDEFGHIJUBAUSCDUCLZCOLZDURUNAUSUTURVACUPUQU
      RQVAQAUSBUTUOFABCUOUSUSQZABRSZUTRSZAFBUTPLSVCVDUEJBUTFUFUGUHZHUOQUIJTABCU
      QUSVBVEHUQQUJUKACDUTUNUNQUTQHIULTUM $.

    ${
      uncf1.a $e |- A = ( Base ` C ) $.
      uncf1.b $e |- B = ( Base ` D ) $.
      uncf1.x $e |- ( ph -> X e. A ) $.
      uncf1.y $e |- ( ph -> Y e. B ) $.
      $( Value of the uncurry functor on an object.  (Contributed by Mario
         Carneiro, 13-Jan-2017.) $)
      uncf1 $p |- ( ph -> ( X ( 1st ` F ) Y ) =
        ( ( 1st ` ( ( 1st ` G ) ` X ) ) ` Y ) ) $=
        ( cfv co c1st cevlf c1stf ccofu c2ndf cprf cop uncfval fveq2d oveqd cxp
        df-ov cxpc cfuc eqid xpcbas ccat wcel cfunc wa syl simpld 1stfcl cofucl
        funcrcl 2ndfcl prfcl evlfcl opelxpi syl2anc cofu1 syl5eq chom prf1 wceq
        1stf1 op1stg eqtrd c2nd 2ndf1 op2ndg opeq12d syl6eqr fucbas wbr relfunc
        wrel 1st2ndbr sylancr funcf1 ffvelrnd evlf1 3eqtrd ) AIJGUASZTIJEFUBTZH
        DEUCTZUDTZDEUETZUFTZUDTZUASZTZIJUGZWSUASSZWOUASZSZJIHUASZSZUASSZAWNXAIJ
        AGWTUAADEFGHKLMNUHUIUJAXBXCXASXFIJXAULABCUKZDEUMTZEFUNTZEUMTZFWSWOXCDEX
        KBCXKUOZOPUPZAXKXLWSXMEWQWRWSUOZXMUOAXKDXLWPHADEWPXKXNADUQURZXLUQURZAHD
        XLUSTZURZXQXRUTNDXLHVEVAVBZLWPUOZVCZNVDZADEWRXKXNYALWRUOZVFZVGAEFXLWOWO
        UOZXLUOZLMVHAIBURZJCURZXCXJURQRIJBCVIVJZVKVLAXFXHJXETZXIAXFXHJUGZXESYLA
        XDYMXEAXDXCWQUASSZXCWRUASSZUGYMAXJXKXLWSEWQWRXKVMSZXCXPXOYPUOZYDYFYKVNA
        YNXHYOJAYNXCWPUASSZXGSXHAXJXKDXLWPHXCXOYCNYKVKAYRIXGAYRXCUASZIAXJDEWPXC
        XKYPXNXOYQYALYBYKVPAYIYJYSIVOQRIJBCVQVJVRUIVRAYOXCVSSZJAXJDEWRXCXKYPXNX
        OYQYALYEYKVTAYIYJYTJVOQRIJBCWAVJVRWBVRUIXHJXEULWCACEFWOXHJYGLMPABEFUSTZ
        IXGABUUADXLXGHVSSZOEFXLYHWDAXSWGXTXGUUBXSWEDXLWFNHXSWHWIWJQWKRWLVRWM $.

      uncf2.h $e |- H = ( Hom ` C ) $.
      uncf2.j $e |- J = ( Hom ` D ) $.
      uncf2.z $e |- ( ph -> Z e. A ) $.
      uncf2.w $e |- ( ph -> W e. B ) $.
      uncf2.r $e |- ( ph -> R e. ( X H Z ) ) $.
      uncf2.s $e |- ( ph -> S e. ( Y J W ) ) $.
      $( Value of the uncurry functor on a morphism.  (Contributed by Mario
         Carneiro, 13-Jan-2017.) $)
      uncf2 $p |- ( ph -> ( R ( <. X , Y >. ( 2nd ` F ) <. Z , W >. ) S ) =
        ( ( ( ( X ( 2nd ` G ) Z ) ` R ) ` W )
          ( <. ( ( 1st ` ( ( 1st ` G ) ` X ) ) ` Y ) ,
               ( ( 1st ` ( ( 1st ` G ) ` X ) ) ` W ) >. ( comp ` E )
               ( ( 1st ` ( ( 1st ` G ) ` Z ) ) ` W ) )
          ( ( Y ( 2nd ` ( ( 1st ` G ) ` X ) ) W ) ` S ) ) ) $=
        ( cop c2nd cfv co c1stf ccofu c2ndf cprf cevlf cco uncfval fveq2d oveqd
        c1st df-ov cxpc cfuc chom eqid xpcbas ccat wcel cfunc wa funcrcl simpld
        cxp syl 1stfcl cofucl 2ndfcl prfcl evlfcl opelxpi syl2anc xpchom2 cofu2
        eleqtrrd syl5eq eqtrd prf1 cofu1 1stf1 wceq op1stg 2ndf1 op2ndg opeq12d
        oveq12d prf2 cres 1stf2 fveq1d fvres 3eqtrd fveq12d syl6eqr cnat fucbas
        2ndf2 wrel wbr relfunc 1st2ndbr sylancr funcf1 ffvelrnd fuchom evlf2val
        funcf2 ) AFGNOUKZPMUKZIULUMZUNZUNZFGUKZYAYBJDEUOUNZUPUNZDEUQUNZURUNZULU
        MUNUMZYAYJVDUMZUMZYBYLUMZEHUSUNZULUMZUNZUMZFNPJULUMZUNZUMZGNJVDUMZUMZOU
        KZPUUBUMZMUKZYPUNZUNZMUUAUMGOMUUCULUMUNUMOUUCVDUMZUMMUUIUMUKMUUEVDUMUMH
        UTUMZUNUNAYEFGYAYBYOYJUPUNZULUMZUNZUNZYRAYDUUMFGAYCUULYAYBAIUUKULADEHIJ
        QRSTVAVBVCVCAUUNYFUUMUMYRFGUUMVEABCVQZDEVFUNZEHVGUNZEVFUNZYFHYJYOUUPVHU
        MZYAYBDEUUPBCUUPVIZUAUBVJZAUUPUUQYJUUREYHYIYJVIZUURVIAUUPDUUQYGJADEYGUU
        PUUTADVKVLZUUQVKVLZAJDUUQVMUNZVLZUVCUVDVNTDUUQJVOVRVPZRYGVIZVSZTVTZADEY
        IUUPUUTUVGRYIVIZWAZWBAEHUUQYOYOVIZUUQVIZRSWCANBVLZOCVLZYAUUOVLUCUDNOBCW
        DWEZAPBVLZMCVLZYBUUOVLUGUHPMBCWDWEZUUSVIZAYFNPKUNZOMLUNZVQZYAYBUUSUNZAF
        UWBVLZGUWCVLZYFUWDVLUIUJFGUWBUWCWDWEADEPMUUPKLUUSNOBCUUTUAUBUEUFUCUDUGU
        HUWAWFWHZWGWIWJAYRUUAGUKZUUGUMUUHAYKUWIYQUUGAYMUUDYNUUFYPAYMYAYHVDUMZUM
        ZYAYIVDUMZUMZUKUUDAUUOUUPUUQYJEYHYIUUSYAUVBUVAUWAUVJUVLUVQWKAUWKUUCUWMO
        AUWKYAYGVDUMZUMZUUBUMUUCAUUOUUPDUUQYGJYAUVAUVITUVQWLAUWONUUBAUWOYAVDUMZ
        NAUUODEYGYAUUPUUSUUTUVAUWAUVGRUVHUVQWMAUVOUVPUWPNWNUCUDNOBCWOWEWJZVBWJA
        UWMYAULUMZOAUUODEYIYAUUPUUSUUTUVAUWAUVGRUVKUVQWPAUVOUVPUWROWNUCUDNOBCWQ
        WEWJWRWJAYNYBUWJUMZYBUWLUMZUKUUFAUUOUUPUUQYJEYHYIUUSYBUVBUVAUWAUVJUVLUV
        TWKAUWSUUEUWTMAUWSYBUWNUMZUUBUMUUEAUUOUUPDUUQYGJYBUVAUVITUVTWLAUXAPUUBA
        UXAYBVDUMZPAUUODEYGYBUUPUUSUUTUVAUWAUVGRUVHUVTWMAUVRUVSUXBPWNUGUHPMBCWO
        WEWJZVBWJAUWTYBULUMZMAUUODEYIYBUUPUUSUUTUVAUWAUVGRUVKUVTWPAUVRUVSUXDMWN
        UGUHPMBCWQWEWJWRWJWSAYKYFYAYBYHULUMUNUMZYFYAYBYIULUMUNZUMZUKUWIAUUOUUPU
        UQYJEYHYIUUSYFYAYBUVBUVAUWAUVJUVLUVQUVTUWHWTAUXEUUAUXGGAUXEYFYAYBYGULUM
        UNZUMZUWOUXAYSUNZUMUUAAUUOUUPDYFUUQYGJUUSYAYBUVAUVITUVQUVTUWAUWHWGAUXIF
        UXJYTAUWONUXAPYSUWQUXCWSAUXIYFVDUWEXAZUMZYFVDUMZFAYFUXHUXKAUUODEYGYAYBU
        UPUUSUUTUVAUWAUVGRUVHUVQUVTXBXCAYFUWEVLZUXLUXMWNUWHYFUWEVDXDVRAUWFUWGUX
        MFWNUIUJFGUWBUWCWOWEXEXFWJAUXGYFULUWEXAZUMZYFULUMZGAYFUXFUXOAUUODEYIYAY
        BUUPUUSUUTUVAUWAUVGRUVKUVQUVTXJXCAUXNUXPUXQWNUWHYFUWEULXDVRAUWFUWGUXQGW
        NUIUJFGUWBUWCWQWEXEWRWJXFUUAGUUGVEXGAUUACEHUUJYOUUCUUELGUUGEHXHUNZOMUVM
        RSUBUFUUJVIUXRVIZABEHVMUNZNUUBABUXTDUUQUUBYSUAEHUUQUVNXIAUVEXKUVFUUBYSU
        VEXLDUUQXMTJUVEXNXOZXPZUCXQABUXTPUUBUYBUGXQUDUHUUGVIAUWBUUCUUEUXRUNFYTA
        BDUUQUUBYSKUXRNPUAUEEHUUQUXRUVNUXSXRUYAUCUGXTUIXQUJXSXE $.
    $}

    $( Cancellation of curry with uncurry.  (Contributed by Mario Carneiro,
       13-Jan-2017.) $)
    curfuncf $p |- ( ph -> ( <. C , D >. curryF F ) = G ) $=
      ( vx vy vz vg cfv co cmpt cop wcel eqid cbs cv c1st chom ccid cmpt2 ccurf
      c2nd wa ccat ad2antrr cfuc cfunc simplr simpr uncf1 mpteq2dva wbr relfunc
      wrel fucbas 1st2ndbr sylancr funcf1 ffvelrnda feqmptd eqtr4d wceq simpllr
      cco ad3antrrr simplrl simprr adantr funcrcl syl simpld catidcl uncf2 ccom
      funcid fucid eqtrd fveq1d wf syl2anc oveq1d ffvelrnd simprl funcf2 catlid
      fvco3 3eqtrd 3impb mpt2eq3dva cxp wfn funcfn2 fnov opeq12d 1st2nd adantrr
      sylib oveq2d adantrl cnat fuchom natcl catrid natfn dffn5 curfval 3eqtr4d
      nat1st2nd uncfcl ) AKBUAOZLCUAOZKUBZLUBZEUCOPZQZLMXQXQNXSMUBZCUDOZPZXRBUE
      OZOZNUBZXRXSRXRYBRZEUHOZPPZQZUFZRZQZKLXPXPNXRXSBUDOZPZMXQYGYBCUEOZOZYHXSY
      BRYIPPZQZQZUFZRFUCOZFUHOZRZBCREUGPZFAYNUUCUUBUUDAYNKXPXRUUCOZQUUCAKXPYMUU
      GAXRXPSZUIZYMUUGUCOZUUGUHOZRZUUGUUIYAUUJYLUUKUUIYALXQXSUUJOZQUUJUUILXQXTU
      UMUUIXSXQSZUIXPXQBCDEFXRXSGACUJSZUUHUUNHUKADUJSZUUHUUNIUKAFBCDULPZUMPZSZU
      UHUUNJUKXPTZXQTZAUUHUUNUNUUIUUNUOUPUQUUILXQDUAOZUUJUUIXQUVBCDUUJUUKUVAUVB
      TZUUICDUMPZUTZUUGUVDSZUUJUUKUVDURZCDUSZAXPUVDXRUUCAXPUVDBUUQUUCUUDUUTCDUU
      QUUQTZVAAUURUTZUUSUUCUUDUURURZBUUQUSZJFUURVBVCZVDZVEZUUGUVDVBZVCZVDZVFVGU
      UIYLLMXQXQXSYBUUKPZUFZUUKUUILMXQXQYKUVSUUIUUNYBXQSZYKUVSVHUUIUUNUWAUIZUIZ
      YKNYDYGUVSOZQUVSUWCNYDYJUWDUWCYGYDSZUIZYJYBYFXRXRUUDPOZOZUWDUUMYBUUJOZRUW
      IDVJOZPZPUWIDUEOZOZUWDUWKPUWDUWFXPXQBCYFYGDEFYOYCYBXRXSXRGAUUOUUHUWBUWEHV
      KAUUPUUHUWBUWEIVKZAUUSUUHUWBUWEJVKUUTUVAAUUHUWBUWEVIZUUIUUNUWAUWEVLZYOTZY
      CTZUWOUWCUWAUWEUUIUUNUWAVMZVNZUWFXPBYEYOXRUUTUWQYETZABUJSZUUHUWBUWEAUXBUU
      QUJSZAUUSUXBUXCUIJBUUQFVOVPVQZVKUWOVRUWCUWEUOVSUWFUWHUWMUWDUWKUWFUWHYBUWL
      UUJVTZOZUWMUWFYBUWGUXEUWFUWGUUGUUQUEOZOUXEUWFXPBYEUUQUUCUUDUXGXRUUTUXAUXG
      TZAUVKUUHUWBUWEUVMVKUWOWAUWFCDUUQUWLUUGUXGUVIUXHUWLTZUUIUVFUWBUWEUVOUKWBW
      CWDUWFXQUVBUUJWEZUWAUXFUWMVHUUIUXJUWBUWEUVRUKZUWTXQUVBYBUWLUUJWLWFWCWGUWF
      UVBDUWJUWLUWDDUDOZUUMUWIUVCUXLTZUXIUWNUWFXQUVBXSUUJUXKUWPWHUWJTZUWFXQUVBY
      BUUJUXKUWTWHUWCYDUUMUWIUXLPZYGUVSUWCXQCDUUJUUKYCUXLXSYBUVAUWRUXMUUIUVGUWB
      UVQVNUUIUUNUWAWIUWSWJZVEWKWMUQUWCNYDUXOUVSUXPVFVGWNWOUUIUUKXQXQWPWQUUKUVT
      VHUUIXQCDUUJUUKUVAUVQWRLMXQXQUUKWSXCVGWTUUIUVEUVFUUGUULVHUVHUVOUUGUVDXAVC
      VGUQAKXPUVDUUCUVNVFVGAUUBKLXPXPXRXSUUDPZUFZUUDAKLXPXPUUAUXQAUUHXSXPSZUUAU
      XQVHAUUHUXSUIZUIZUUANYPYGUXQOZQUXQUYANYPYTUYBUYAYGYPSZUIZYTMXQYBUYBOZQZUY
      BUYDMXQYSUYEUYDUWAUIZYSUYEYRYBYBUUKPOZUWIUWIRYBXSUUCOZUCOZOZUWJPZPUYEUWMU
      YLPUYEUYGXPXQBCYGYRDEFYOYCYBXRYBXSGAUUOUXTUYCUWAHVKZAUUPUXTUYCUWAIVKZAUUS
      UXTUYCUWAJVKUUTUVAUYAUUHUYCUWAAUUHUXSWIZUKZUYDUWAUOZUWQUWRUYAUXSUYCUWAAUU
      HUXSVMZUKZUYQUYAUYCUWAUNZUYGXQCYQYCYBUVAUWRYQTZUYMUYQVRVSUYGUYHUWMUYEUYLU
      YGXQCYQDUUJUUKUWLYBUVAVUAUXIUYDUVGUWAUYDUVEUVFUVGUVHUYAUVFUYCAUUHUVFUXSUV
      OXBVNUVPVCZVNUYQWAXDUYGUVBDUWJUWLUYEUXLUWIUYKUVCUXMUXIUYNUYDXQUVBYBUUJUYD
      XQUVBCDUUJUUKUVAUVCVUBVDVEUXNUYDXQUVBYBUYJUYDXQUVBCDUYJUYIUHOZUVAUVCUYDUV
      EUYIUVDSZUYJVUCUVDURUVHUYAVUDUYCAUXSVUDUUHAXPUVDXSUUCUVNVEXEVNUYIUVDVBVCV
      DVEUYGUYBXQCDUUJUUKUXLUYJVUCCDXFPZYBVUETZUYGUYBCDUUGUYIVUEVUFUYGYPUUGUYIV
      UEPZYGUXQUYGXPBUUQUUCUUDYOVUEXRXSUUTUWQCDUUQVUEUVIVUFXGZAUVKUXTUYCUWAUVMV
      KUYPUYSWJUYTWHXNUVAUXMUYQXHXIWMUQUYDUYBXQWQUYBUYFVHUYDUYBXQCDUUJUUKUYJVUC
      VUEVUFUYDUYBCDUUGUYIVUEVUFUYAYPVUGYGUXQUYAXPBUUQUUCUUDYOVUEXRXSUUTUWQVUHA
      UVKUXTUVMVNUYOUYRWJZVEXNUVAXJMXQUYBXKXCVGUQUYANYPVUGUXQVUIVFVGWNWOAUUDXPX
      PWPWQUUDUXRVHAXPBUUQUUCUUDUUTUVMWRKLXPXPUUDWSXCVGWTAKLMXPXQBCYENDEUUFYOYQ
      YCUUFTUUTUXDHABCDEFGHIJXOUVAUWRUXAUWQVUAXLAUVJUUSFUUEVHUVLJFUURXAVCXM $.
  $}

  ${
    $d f g u v w x y z C $.  $d f g u v w x y z D $.  $d f g u v w x y z E $.
    $d f g u v w x y z F $.  $d f g u v w x y z G $.  $d f g w x y z ph $.
    uncfcurf.g $e |- G = ( <. C , D >. curryF F ) $.
    uncfcurf.c $e |- ( ph -> C e. Cat ) $.
    uncfcurf.d $e |- ( ph -> D e. Cat ) $.
    uncfcurf.f $e |- ( ph -> F e. ( ( C Xc. D ) Func E ) ) $.
    $( Cancellation of uncurry with curry.  (Contributed by Mario Carneiro,
       13-Jan-2017.) $)
    uncfcurf $p |- ( ph -> ( <" C D E "> uncurryF G ) = F ) $=
      ( vx co cfv cop wceq cv wral wcel eqid adantr vy vu vv vz vw vf cs3 cuncf
      vg c1st c2nd cbs wa ccat cxpc cfunc funcrcl syl simprd cfuc curfcl simprl
      simprr uncf1 curf11 eqtrd ralrimivva cxp wfn wb wf xpcbas wrel wbr uncfcl
      relfunc 1st2ndbr sylancr funcf1 ffn eqfnov2 syl2anc mpbird chom ad3antrrr
      uncf2 ccid df-ov syl6eq opeq12d oveq12d curf2val curf12 oveq123d ad2antrr
      cco opelxpi ad2antlr adantl catidcl xpchom2 eleqtrrd funcco xpcco2 fveq2d
      syl6eqr catrid catlid 3eqtr2d funcf2 feq2d mpbid oveq2 ralxp oveq1 syl5bb
      eqeq12d 2ralbidv sylibr funcfn2 1st2nd 3eqtr4d ) ABCDUGFUHLZUJMZYCUKMZNZE
      UJMZEUKMZNZYCEAYDYGYEYHAYDYGOZKPZUAPZYDLZYKYLYGLZOZUACULMZQKBULMZQZAYOKUA
      YQYPAYKYQRZYLYPRZUMZUMZYMYLYKFUJMZMZUJMZMZYNUUBYQYPBCDYCFYKYLYCSZACUNRZUU
      AITZADUNRZUUAABCUOLZUNRZUUJAEUUKDUPLZRZUULUUJUMJUUKDEUQURUSZTAFBCDUTLZUPL
      RZUUAABCUUPDEFGUUPSHIJVAZTYQSZYPSZAYSYTVBZAYSYTVCZVDUUBYQYPBCDEFUUDYKYLGU
      USABUNRZUUAHTUUIAUUNUUAJTUUTUVAUUDSZUVBVEVFVGAYDYQYPVHZVIZYGUVEVIZYJYRVJA
      UVEDULMZYDVKUVFAUVEUVHUUKDYDYEBCUUKYQYPUUKSZUUSUUTVLZUVHSZAUUMVMZYCUUMRZY
      DYEUUMVNZUUKDVPZABCDYCFUUGIUUOUURVOZYCUUMVQVRZVSUVEUVHYDVTURAUVEUVHYGVKUV
      GAUVEUVHUUKDYGYHUVJUVKAUVLUUNYGYHUUMVNZUVOJEUUMVQVRZVSUVEUVHYGVTURKUAYQYP
      YDYGWAWBWCAYEYHOZUBPZUCPZYELZUWAUWBYHLZOZUCUVEQZUBUVEQZAYKYLNZUDPZUEPZNZY
      ELZUWHUWKYHLZOZUEYPQUDYQQZUAYPQKYQQUWGAUWOKUAYQYPUUBUWNUDUEYQYPUUBUWIYQRZ
      UWJYPRZUMZUMZUWNUFPZUIPZUWLLZUWTUXAUWMLZOZUIYLUWJCWDMZLZQUFYKUWIBWDMZLZQZ
      UWSUXDUFUIUXHUXFUWSUWTUXHRZUXAUXFRZUMZUMZUXBUWJUWTYKUWIFUKMLMZMZUXAYLUWJU
      UDUKMLMZUUFUWJUUEMZNZUWJUWIUUCMZUJMMZDWPMZLZLZUXCUXMYQYPBCUWTUXADYCFUXGUX
      EUWJYKYLUWIUUGAUUHUUAUWRUXLIWEZAUUJUUAUWRUXLUUOWEAUUQUUAUWRUXLUURWEUUSUUT
      UWSYSUXLUUBYSUWRUVATZTZUWSYTUXLUUBYTUWRUVBTZTZUXGSZUXESZUWSUWPUXLUUBUWPUW
      QVBZTZUWSUWQUXLUUBUWPUWQVCZTZUWSUXJUXKVBZUWSUXJUXKVCZWFUXMUYCUWTUWJCWGMZM
      ZNZYKUWJNZUWKYHLZMZYKBWGMZMZUXANZUWHUYTYHLZMZUWHYGMZUYTYGMZNZUWKYGMZUYALZ
      LUYSVUEUWHUYTNUWKUUKWPMZLLZUWMMZUXCUXMUXOVUBUXPVUGUYBVULUXMUXRVUJUXTVUKUY
      AUXMUUFVUHUXQVUIUXMUUFYNVUHUXMYQYPBCDEFUUDYKYLGUUSAUVCUUAUWRUXLHWEZUYDAUU
      NUUAUWRUXLJWEZUUTUYFUVDUYHVEYKYLYGWHWIUXMUXQYKUWJYGLVUIUXMYQYPBCDEFUUDYKU
      WJGUUSVUPUYDVUQUUTUYFUVDUYNVEYKUWJYGWHWIWJUXMUXTUWIUWJYGLVUKUXMYQYPBCDEFU
      XSUWIUWJGUUSVUPUYDVUQUUTUYLUXSSUYNVEUWIUWJYGWHWIWKUXMUXOUWTUYRVUALVUBUXMY
      QYPBCDEFUXGUYQUWTUXNYKUWIUWJGUUSVUPUYDVUQUUTUYIUYQSZUYFUYLUYOUXNSUYNWLUWT
      UYRVUAWHWIUXMUXPVUDUXAVUFLVUGUXMYQYPBCVUCDEFUXAUXEUUDYKYLUWJGUUSVUPUYDVUQ
      UUTUYFUVDUYHUYJVUCSZUYNUYPWMVUDUXAVUFWHWIWNUXMUVEUUKVUMDYGYHUUKWDMZVUEUYS
      UYAUWHUYTUWKUVJVUTSZVUMSZUYASUWSUVRUXLAUVRUUAUWRUVSWOZTUWSUWHUVERZUXLUUAV
      VDAUWRYKYLYQYPWQWRZTUXMYSUWQUYTUVERUYFUYNYKUWJYQYPWQWBUWSUWKUVERZUXLUWRVV
      FUUBUWIUWJYQYPWQWSZTUXMVUEYKYKUXGLZUXFVHZUWHUYTVUTLUXMVUDVVHRUXKVUEVVIRUX
      MYQBVUCUXGYKUUSUYIVUSVUPUYFWTZUYPVUDUXAVVHUXFWQWBUXMBCYKUWJUUKUXGUXEVUTYK
      YLYQYPUVIUUSUUTUYIUYJUYFUYHUYFUYNVVAXAXBUXMUYSUXHUWJUWJUXELZVHZUYTUWKVUTL
      UXMUXJUYRVVKRUYSVVLRUYOUXMYPCUYQUXEUWJUUTUYJVURUYDUYNWTZUWTUYRUXHVVKWQWBU
      XMBCUWIUWJUUKUXGUXEVUTYKUWJYQYPUVIUUSUUTUYIUYJUYFUYNUYLUYNVVAXAXBXCUXMVUO
      UWTVUDYKYKNUWIBWPMZLLZUYRUXAYLUWJNUWJCWPMZLLZUWMLZUXCUXMVUOVVOVVQNZUWMMVV
      RUXMVUNVVSUWMUXMBCYKUWJUWIUWJVVPUUKVVNVUDUXAUXGUXEUWTUYRYKYLVUMYQYPUVIUUS
      UUTUYIUYJUYFUYHUYFUYNVVNSZVVPSZVVBUYLUYNVVJUYPUYOVVMXDXEVVOVVQUWMWHXFUXMV
      VOUWTVVQUXAUWMUXMYQBVVNVUCUWTUXGYKUWIUUSUYIVUSVUPUYFVVTUYLUYOXGUXMYPCVVPU
      YQUXAUXEYLUWJUUTUYJVURUYDUYHVWAUYNUYPXHWKVFXIVFVGUWSUWLUXHUXFVHZVIZUWMVWB
      VIZUWNUXIVJUWSVWBUWHYDMUWKYDMDWDMZLZUWLVKZVWCUWSUWHUWKVUTLZVWFUWLVKVWGUWS
      UVEUUKDYDYEVUTVWEUWHUWKUVJVVAVWESZAUVNUUAUWRUVQWOVVEVVGXJUWSVWHVWBVWFUWLU
      WSBCUWIUWJUUKUXGUXEVUTYKYLYQYPUVIUUSUUTUYIUYJUYEUYGUYKUYMVVAXAZXKXLVWBVWF
      UWLVTURUWSVWBVUHVUKVWELZUWMVKZVWDUWSVWHVWKUWMVKVWLUWSUVEUUKDYGYHVUTVWEUWH
      UWKUVJVVAVWIVVCVVEVVGXJUWSVWHVWBVWKUWMVWJXKXLVWBVWKUWMVTURUFUIUXHUXFUWLUW
      MWAWBWCVGVGUWFUWOUBKUAYQYPUWFUWAUWKYELZUWAUWKYHLZOZUEYPQUDYQQUWAUWHOZUWOU
      WEVWOUCUDUEYQYPUWBUWKOUWCVWMUWDVWNUWBUWKUWAYEXMUWBUWKUWAYHXMXQXNVWPVWOUWN
      UDUEYQYPVWPVWMUWLVWNUWMUWAUWHUWKYEXOUWAUWHUWKYHXOXQXRXPXNXSAYEUVEUVEVHZVI
      YHVWQVIUVTUWGVJAUVEUUKDYDYEUVJUVQXTAUVEUUKDYGYHUVJUVSXTUBUCUVEUVEYEYHWAWB
      WCWJAUVLUVMYCYFOUVOUVPYCUUMYAVRAUVLUUNEYIOUVOJEUUMYAVRYB $.
  $}

  ${
    $d c d C $.  $d c d D $.  $d c d ph $.
    diagval.l $e |- L = ( C DiagFunc D ) $.
    diagval.c $e |- ( ph -> C e. Cat ) $.
    diagval.d $e |- ( ph -> D e. Cat ) $.
    $( Define the diagonal functor, which is the functor ` C --> ( D Func C ) `
       whose object part is ` x e. C |-> ( y e. D |-> x ) ` .  We can define
       this equationally as the currying of the first projection functor, and
       by expressing it this way we get a quick proof of functoriality.
       (Contributed by Mario Carneiro, 6-Jan-2017.)  (Revised by Mario
       Carneiro, 15-Jan-2017.) $)
    diagval $p |- ( ph -> L = ( <. C , D >. curryF ( C 1stF D ) ) ) $=
      ( vc vd cdiag co cop c1stf ccurf ccat cv cvv wceq a1i wa simprl wcel ovex
      cmpt2 df-diag simprr opeq12d oveq12d ovmpt2d syl5eq ) ADBCJKBCLZBCMKZNKZE
      AHIBCOOHPZIPZLZUNUOMKZNKZUMJQJHIOOURUDRAHIUESAUNBRZUOCRZTTZUPUKUQULNVAUNB
      UOCAUSUTUAZAUSUTUFZUGVAUNBUOCMVBVCUHUHFGUMQUBAUKULNUCSUIUJ $.

    ${
      diagcl.q $e |- Q = ( D FuncCat C ) $.
      $( The diagonal functor is a functor from the base category to the
         functor category.  Another way of saying this is that the constant
         functor ` ( y e. D |-> X ) ` is a construction that is natural in
         ` X ` (and covariant).  (Contributed by Mario Carneiro, 7-Jan-2017.)
         (Revised by Mario Carneiro, 15-Jan-2017.) $)
      diagcl $p |- ( ph -> L e. ( C Func Q ) ) $=
        ( cop c1stf co ccurf cfunc diagval eqid cxpc 1stfcl curfcl eqeltrd ) AE
        BCJBCKLZMLZBDNLABCEFGHOABCDBUAUBUBPIGHABCUABCQLZUCPGHUAPRST $.
    $}

    diag11.a $e |- A = ( Base ` C ) $.
    diag11.c $e |- ( ph -> X e. A ) $.
    diag11.k $e |- K = ( ( 1st ` L ) ` X ) $.
    $( The constant functor of ` X ` is a functor.  (Contributed by Mario
       Carneiro, 6-Jan-2017.)  (Revised by Mario Carneiro, 15-Jan-2017.) $)
    diag1cl $p |- ( ph -> K e. ( D Func C ) ) $=
      ( c1st cfv cfunc co cfuc c2nd eqid fucbas wrel wbr relfunc diagcl sylancr
      wcel 1st2ndbr funcf1 ffvelrnd syl5eqel ) AEGFNOZODCPQZMABUMGULABUMCDCRQZU
      LFSOZKDCUNUNTZUAACUNPQZUBFUQUGULUOUQUCCUNUDACDUNFHIJUPUEFUQUHUFUILUJUK $.

    diag11.b $e |- B = ( Base ` D ) $.
    diag11.y $e |- ( ph -> Y e. B ) $.
    $( Value of the constant functor at an object.  (Contributed by Mario
       Carneiro, 7-Jan-2017.)  (Revised by Mario Carneiro, 15-Jan-2017.) $)
    diag11 $p |- ( ph -> ( ( 1st ` K ) ` Y ) = X ) $=
      ( c1st cfv eqid c1stf co ccurf diagval fveq2d fveq1d syl5eq 1stfcl curf11
      cop cxpc df-ov chom xpcbas wcel opelxpi syl2anc 1stf1 op1stg eqtrd 3eqtrd
      cxp wceq ) AIFRSZSIHDEUJDEUAUBZUCUBZRSZSZRSZSHIVERSZUBZHAIVDVIAFVHRAFHGRS
      ZSVHOAHVLVGAGVFRADEGJKLUDUEUFUGUEUFABCDEDVEVFVHHIVFTMKLADEVEDEUKUBZVMTZKL
      VETZUHPNVHTQUIAVKHIUJZRSZHAVKVPVJSVQHIVJULABCVBZDEVEVPVMVMUMSZVNDEVMBCVNM
      PUNVSTKLVOAHBUOZICUOZVPVRUONQHIBCUPUQURUGAVTWAVQHVCNQHIBCUSUQUTVA $.

    diag12.j $e |- J = ( Hom ` D ) $.
    diag12.i $e |- .1. = ( Id ` C ) $.
    diag12.z $e |- ( ph -> Z e. B ) $.
    diag12.f $e |- ( ph -> F e. ( Y J Z ) ) $.
    $( Value of the constant functor at a morphism.  (Contributed by Mario
       Carneiro, 6-Jan-2017.)  (Revised by Mario Carneiro, 15-Jan-2017.) $)
    diag12 $p |- ( ph -> ( ( Y ( 2nd ` K ) Z ) ` F ) = ( .1. ` X ) ) $=
      ( c2nd cfv co cop c1stf ccurf c1st diagval fveq2d fveq1d syl5eq eqid cxpc
      oveqd 1stfcl curf12 chom cres df-ov cxp xpcbas wcel opelxpi syl2anc 1stf2
      wceq catidcl xpchom2 eleqtrrd fvres syl op1stg 3eqtrd ) AGLMIUFUGZUHZUGGL
      MKDEUIDEUJUHZUKUHZULUGZUGZUFUGZUHZUGKFUGZGKLUIZKMUIZWAUFUGUHZUHZWGAGVTWFA
      VSWELMAIWDUFAIKJULUGZUGWDSAKWLWCAJWBULADEJNOPUMUNUOUPUNUSUOABCDEFDWAWBGHW
      DKLMWBUQQOPADEWADEURUHZWMUQZOPWAUQZUTTRWDUQUAUBUCUDUEVAAWKWGGUIZULWHWIWMV
      BUGZUHZVCZUGZWPULUGZWGAWKWPWJUGWTWGGWJVDAWPWJWSABCVEZDEWAWHWIWMWQWNDEWMBC
      WNQTVFWQUQZOPWOAKBVGZLCVGWHXBVGRUAKLBCVHVIAXDMCVGWIXBVGRUDKMBCVHVIVJUOUPA
      WPWRVGWTXAVKAWPKKDVBUGZUHZLMHUHZVEZWRAWGXFVGZGXGVGZWPXHVGABDFXEKQXEUQZUCO
      RVLZUEWGGXFXGVHVIADEKMWMXEHWQKLBCWNQTXKUBRUARUDXCVMVNWPWRULVOVPAXIXJXAWGV
      KXLUEWGGXFXGVQVIVRVR $.
  $}

  ${
    $d x B $.  $d x C $.  $d x D $.  $d x F $.  $d x H $.  $d x X $.  $d x Y $.
    $d x ph $.
    diag2.l $e |- L = ( C DiagFunc D ) $.
    diag2.a $e |- A = ( Base ` C ) $.
    diag2.b $e |- B = ( Base ` D ) $.
    diag2.h $e |- H = ( Hom ` C ) $.
    diag2.c $e |- ( ph -> C e. Cat ) $.
    diag2.d $e |- ( ph -> D e. Cat ) $.
    diag2.x $e |- ( ph -> X e. A ) $.
    diag2.y $e |- ( ph -> Y e. A ) $.
    diag2.f $e |- ( ph -> F e. ( X H Y ) ) $.
    $( Value of the diagonal functor at a morphism.  (Contributed by Mario
       Carneiro, 7-Jan-2017.) $)
    diag2 $p |- ( ph -> ( ( X ( 2nd ` L ) Y ) ` F ) = ( B X. { F } ) ) $=
      ( cfv vx c2nd co cop c1stf ccurf cv ccid cmpt csn cxp fveq2d oveqd fveq1d
      diagval eqid cxpc 1stfcl curf2 wcel wa c1st chom cres xpcbas ccat opelxpi
      adantr sylan 1stf2 df-ov simpr catidcl syl2anc xpchom2 eleqtrrd fvres syl
      wceq syl5eq op1stg 3eqtrd mpteq2dva fconstmpt syl6eqr ) AFIJHUBTZUCZTFIJD
      EUDDEUEUCZUFUCZUBTZUCZTZUACFUAUGZEUHTZTZIWMUDZJWMUDZWHUBTUCZUCZUIZCFUJUKZ
      AFWGWKAWFWJIJAHWIUBADEHKOPUOULUMUNAUABCDEDWHWIGWNFWLIJWIUPLOPADEWHDEUQUCZ
      XBUPZOPWHUPZURMNWNUPZQRSWLUPUSAWTUACFUIXAAUACWSFAWMCUTZVAZWSFWOVBWPWQXBVC
      TZUCZVDZUCZFWOUDZVBTZFXGWRXJFWOXGBCUKZDEWHWPWQXBXHXCDEXBBCXCLMVEXHUPZADVF
      UTXFOVHAEVFUTXFPVHZXDAIBUTZXFWPXNUTQIWMBCVGVIAJBUTZXFWQXNUTRJWMBCVGVIVJUM
      XGXKXLXJTZXMFWOXJVKXGXLXIUTXSXMVSXGXLIJGUCZWMWMEVCTZUCZUKZXIXGFXTUTZWOYBU
      TZXLYCUTAYDXFSVHZXGCEWNYAWMMYAUPZXEXPAXFVLZVMZFWOXTYBVGVNXGDEJWMXBGYAXHIW
      MBCXCLMNYGAXQXFQVHYHAXRXFRVHYHXOVOVPXLXIVBVQVRVTXGYDYEXMFVSYFYIFWOXTYBWAV
      NWBWCUACFWDWEWB $.

    diag2cl.h $e |- N = ( D Nat C ) $.
    $( The diagonal functor at a morphism is a natural transformation between
       constant functors.  (Contributed by Mario Carneiro, 7-Jan-2017.) $)
    diag2cl $p |- ( ph ->
      ( B X. { F } ) e. ( ( ( 1st ` L ) ` X ) N ( ( 1st ` L ) ` Y ) ) ) $=
      ( c2nd cfv co csn cxp c1st diag2 cfuc eqid fuchom cfunc wrel wcel relfunc
      wbr diagcl 1st2ndbr sylancr funcf2 ffvelrnd eqeltrrd ) AFJKHUBUCZUDZUCCFU
      EUFJHUGUCZUCKVEUCIUDZABCDEFGHJKLMNOPQRSTUHAJKGUDVFFVDABDEDUIUDZVEVCGIJKMO
      EDVGIVGUJZUAUKADVGULUDZUMHVIUNVEVCVIUPDVGUOADEVGHLPQVHUQHVIURUSRSUTTVAVB
      $.
  $}

  ${
    $d f u x y z C $.  $d f u x y z D $.  $d f u x y z ph $.  $d f x y Q $.
    curf2ndf.q $e |- Q = ( D FuncCat D ) $.
    curf2ndf.c $e |- ( ph -> C e. Cat ) $.
    curf2ndf.d $e |- ( ph -> D e. Cat ) $.
    $( As shown in ~ diagval , the currying of the first projection is the
       diagonal functor.  On the other hand, the currying of the second
       projection is ` x e. C |-> ( y e. D |-> y ) ` , which is a constant
       functor of the identity functor at ` D ` .  (Contributed by Mario
       Carneiro, 15-Jan-2017.) $)
    curf2ndf $p |- ( ph -> ( <. C , D >. curryF ( C 2ndF D ) ) =
      ( ( 1st ` ( Q DiagFunc C ) ) ` ( idFunc ` D ) ) ) $=
      ( vx vy vz vf cop co cfv c2nd cmpt wcel eqid ad2antrr adantr vu c2ndf cbs
      ccurf c1st cidfu cdiag cv wa chom ccid cmpt2 cid cres cxp df-ov cxpc ccat
      xpcbas opelxpi adantll 2ndf1 vex syl6eq syl5eq mpteq2dva mptresid simp-4r
      op2nd simplr syl2anc 2ndf2 fveq1d simpr catidcl ad3antrrr simpllr xpchom2
      wceq eleqtrrd fvres syl fvex eqtrd 3impa mpt2eq3dva fveq2 syl6eqr reseq2d
      mpt2mpt opeq12d 2ndfcl idfuval 3eqtr4d fuccat fucbas idfucl diag11 eqtr4d
      cfunc curf1 wrel wbr relfunc curfcl 1st2ndbr sylancr feqmptd diag1cl ccom
      funcf1 idfu1st coeq2d fucid cvv wfn cidfn dffn2 sylib fcoi1 simplrl sylan
      wf simplrr oveqd 3eqtr4rd diag12 cnat fuchom simprl simprr funcf2 funcfn2
      curf2 3impb fnov 1st2nd ) ABCLBCUBMZUDMZUENZYSONZLZCUFNZDBUGMZUENNZUENZUU
      EONZLZYSUUEAYTUUFUUAUUGAHBUCNZHUHZYTNZPHUUIUUJUUFNZPYTUUFAHUUIUUKUULAUUJU
      UIQZUIZUUKUUCUULUUNICUCNZUUJIUHZYRUENZMZPZIJUUOUUOKUUPJUHZCUJNZMZUUJBUKNZ
      NZKUHZUUJUUPLZUUJUUTLZYRONZMZMZPZULZLUMUUOUNZUAUUOUUOUOUMUAUHZUVANZUNZPZL
      UUKUUCUUNUUSUVMUVLUVQUUNUUSIUUOUUPPUVMUUNIUUOUURUUPUUNUUPUUOQZUIZUURUVFUU
      QNZUUPUUJUUPUUQUPUVSUVTUVFONUUPUVSUUIUUOUOZBCYRUVFBCUQMZUWBUJNZUWBRZBCUWB
      UUIUUOUWDUUIRZUUORZUSZUWCRZABURQZUUMUVRFSZACURQZUUMUVRGSZYRRZUUMUVRUVFUWA
      QZAUUJUUPUUIUUOUTVAZVBUUJUUPHVCIVCVIVDVEVFIUUOVGVDUUNUVLIJUUOUUOUMUVBUNZU
      LUVQUUNIJUUOUUOUVKUWPUUNUVRUUTUUOQZUVKUWPVSUVSUWQUIZUVKKUVBUVEPUWPUWRKUVB
      UVJUVEUWRUVEUVBQZUIZUVJUVDUVELZOUVFUVGUWCMZUNZNZUVEUWTUVJUXAUVINUXDUVDUVE
      UVIUPUWTUXAUVIUXCUWTUWABCYRUVFUVGUWBUWCUWDUWGUWHUVSUWIUWQUWSUWJSUVSUWKUWQ
      UWSUWLSUWMUVSUWNUWQUWSUWOSUWTUUMUWQUVGUWAQZAUUMUVRUWQUWSVHZUVSUWQUWSVJZUU
      JUUTUUIUUOUTZVKVLVMVEUWTUXDUXAONZUVEUWTUXAUXBQUXDUXIVSUWTUXAUUJUUJBUJNZMZ
      UVBUOZUXBUWTUVDUXKQZUWSUXAUXLQUUNUXMUVRUWQUWSUUNUUIBUVCUXJUUJUWEUXJRZUVCR
      ZAUWIUUMFTZAUUMVNZVOVPUWRUWSVNUVDUVEUXKUVBUTVKUWTBCUUJUUTUWBUXJUVAUWCUUJU
      UPUUIUUOUWDUWEUWFUXNUVARZUXFUUNUVRUWQUWSVQUXFUXGUWHVRVTUXAUXBOWAWBUVDUVEU
      UJUVCWCKVCZVIVDWDVFKUVBVGVDWEWFIJUAUUOUUOUVPUWPUVNUUPUUTLZVSZUVOUVBUMUYAU
      VOUXTUVANUVBUVNUXTUVAWGUUPUUTUVAUPWHWIWJWHWKUUNIJUUIUUOBCUVCKCYRYSUVAUUKU
      UJYSRZUWEUXPAUWKUUMGTZAYRUWBCWTMQZUUMABCYRUWBUWDFGUWMWLZTUWFUXQUUKRUXRUXO
      XAUUNUAUUOCUVAUUCUUCRZUWFUYCUXRWMWNUUNCCWTMZUUIDBUUEUUDUUCUUJUUDRZADURQZU
      UMACCDEGGWOZTUXPCCDEWPZAUUCUYGQZUUMAUWKUYLGCUUCUYFWQWBZTUUERZUWEUXQWRWSVF
      AHUUIUYGYTAUUIUYGBDYTUUAUWEUYKABDWTMZXBZYSUYOQZYTUUAUYOXCZBDXDZABCDCYRYSU
      YBEFGUYEXEZYSUYOXFXGZXKXHAHUUIUYGUUFAUUIUYGBDUUFUUGUWEUYKAUYPUUEUYOQZUUFU
      UGUYOXCZUYSAUYGDBUUEUUDUUCUYHUYJFUYKUYMUYNXIZUUEUYOXFXGZXKXHWNAHIUUIUUIUU
      JUUPUUAMZULZHIUUIUUIUUJUUPUUGMZULZUUAUUGAHIUUIUUIVUFVUHAUUMUUPUUIQZVUFVUH
      VSAUUMVUJUIZUIZKUUJUUPUXJMZUVEVUFNZPKVUMUVEVUHNZPVUFVUHVULKVUMVUNVUOVULUV
      EVUMQZUIZJUUOUVEUUTCUKNZNZUVGUXTUVHMZMZPZUUCDUKNZNZVUNVUOVUQVURUUCUENZXJV
      URUVMXJZVVDVVBVUQVVEUVMVURVUQUUOCUUCUYFUWFAUWKVUKVUPGSZXLXMVUQCCDVURUUCVV
      CEVVCRZVURRZAUYLVUKVUPUYMSZXNVUQVURJUUOVUSPVVFVVBVUQJUUOXOVURVUQVURUUOXPZ
      UUOXOVURYCZVUQUWKVVKVVGUUOCVURUWFVVIXQWBUUOVURXRXSZXHVUQVVLVVFVURVSVVMUUO
      XOVURXTWBVUQJUUOVVAVUSVUQUWQUIZVVAUVEVUSOUVGUXTUWCMZUNZMZVUSVVNVUTVVPUVEV
      USVVNUWABCYRUVGUXTUWBUWCUWDUWGUWHVUQUWIUWQAUWIVUKVUPFSZTVUQUWKUWQVVGTZUWM
      VUQUUMUWQUXEAUUMVUJVUPYAZUXHYBVUQVUJUWQUXTUWAQAUUMVUJVUPYDZUUPUUTUUIUUOUT
      YBVLYEVVNVVQUVEVUSLZONZVUSVVNVVQVWBVVPNZVWCUVEVUSVVPUPVVNVWBVVOQVWDVWCVSV
      VNVWBVUMUUTUUTUVAMZUOZVVOVVNVUPVUSVWEQVWBVWFQVULVUPUWQVJVVNUUOCVURUVAUUTU
      WFUXRVVIVVSVUQUWQVNZVOUVEVUSVUMVWEUTVKVVNBCUUPUUTUWBUXJUVAUWCUUJUUTUUIUUO
      UWDUWEUWFUXNUXRVUQUUMUWQVVTTVWGVUQVUJUWQVWATVWGUWHVRVTVWBVVOOWAWBVEUVEVUS
      UXSUUTVURWCVIVDWDVFYFYFVUQJUUIUUOBCCYRYSUXJVURUVEVUNUUJUUPUYBUWEVVRVVGAUY
      DVUKVUPUYESUWFUXNVVIVVTVWAVULVUPVNZVUNRYNVUQUYGUUIDBVVCUVEUXJUUEUUDUUCUUJ
      UUPUYHAUYIVUKVUPUYJSVVRUYKVVJUYNUWEVVTUXNVVHVWAVWHYGWNVFVULKVUMUUKUUPYTNC
      CYHMZMVUFVULUUIBDYTUUAUXJVWIUUJUUPUWEUXNCCDVWIEVWIRYIZAUYRVUKVUATAUUMVUJY
      JZAUUMVUJYKZYLXHVULKVUMUULUUPUUFNVWIMVUHVULUUIBDUUFUUGUXJVWIUUJUUPUWEUXNV
      WJAVUCVUKVUETVWKVWLYLXHWNYOWFAUUAUUIUUIUOZXPUUAVUGVSAUUIBDYTUUAUWEVUAYMHI
      UUIUUIUUAYPXSAUUGVWMXPUUGVUIVSAUUIBDUUFUUGUWEVUEYMHIUUIUUIUUGYPXSWNWKAUYP
      UYQYSUUBVSUYSUYTYSUYOYQXGAUYPVUBUUEUUHVSUYSVUDUUEUYOYQXGWN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
           Hom functor
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c HomF $.
  $c Yon $.

  $( Extend class notation with the Hom functor. $)
  chof $a class HomF $.

  $( Extend class notation with the Yoneda embedding. $)
  cyon $a class Yon $.

  ${
    $d b c f g h x y B $.  $d f g h F $.  $d f g h G $.  $d b c f g h x y ph $.
    $d b c f g h x y C $.  $d b c f g h x y H $.  $d h K $.  $d f g h x y W $.
    $d b c f g h x y .x. $.  $d f g h x y X $.  $d f g h x y Y $.
    $d f g h x y Z $.
    $( Define the Hom functor, which is a bifunctor (a functor of two
       arguments), contravariant in the first argument and covariant in the
       second, from ` ( oppCat `` C ) X. C ` to ` SetCat ` , whose object part
       is the hom-function ` Hom ` , and with morphism part given by pre- and
       post-composition.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    df-hof $a |- HomF = ( c e. Cat |-> <. ( Homf ` c ) , [_ ( Base ` c ) / b ]_
       ( x e. ( b X. b ) , y e. ( b X. b ) |->
         ( f e. ( ( 1st ` y ) ( Hom ` c ) ( 1st ` x ) ) ,
           g e. ( ( 2nd ` x ) ( Hom ` c ) ( 2nd ` y ) ) |->
           ( h e. ( ( Hom ` c ) ` x ) |->
             ( ( g ( x ( comp ` c ) ( 2nd ` y ) ) h ) ( <. ( 1st ` y ) ,
               ( 1st ` x ) >. ( comp ` c ) ( 2nd ` y ) ) f ) ) ) ) >. ) $.

    $( Define the Yoneda embedding, which is the currying of the (opposite) Hom
       functor.  (Contributed by Mario Carneiro, 11-Jan-2017.) $)
    df-yon $a |- Yon = ( c e. Cat |->
      ( <. c , ( oppCat ` c ) >. curryF ( HomF ` ( oppCat ` c ) ) ) ) $.


    hofval.m $e |- M = ( HomF ` C ) $.
    hofval.c $e |- ( ph -> C e. Cat ) $.
    ${
      hofval.b $e |- B = ( Base ` C ) $.
      hofval.h $e |- H = ( Hom ` C ) $.
      hofval.o $e |- .x. = ( comp ` C ) $.
      $( Value of the Hom functor, which is a bifunctor (a functor of two
         arguments), contravariant in the first argument and covariant in the
         second, from ` ( oppCat `` C ) X. C ` to ` SetCat ` , whose object
         part is the hom-function ` Hom ` , and with morphism part given by
         pre- and post-composition.  (Contributed by Mario Carneiro,
         15-Jan-2017.) $)
      hofval $p |- ( ph -> M = <. ( Homf ` C ) ,
         ( x e. ( B X. B ) , y e. ( B X. B ) |->
           ( f e. ( ( 1st ` y ) H ( 1st ` x ) ) ,
             g e. ( ( 2nd ` x ) H ( 2nd ` y ) ) |->
             ( h e. ( H ` x ) |->
               ( ( g ( x .x. ( 2nd ` y ) ) h ) ( <. ( 1st ` y ) ,
                 ( 1st ` x ) >. .x. ( 2nd ` y ) ) f ) ) ) ) >. ) $=
        ( cfv cv co oveqd vc vb chof chomf cxp c1st c2nd cop cmpt cmpt2 cbs cco
        chom csb ccat cvv wceq df-hof wa simpr fveq2d wcel fvex syl6eqr xpeq12d
        simplr fveq1d eqidd oveq123d mpteq12dv mpt2eq123dv csbied2 opeq12d opex
        a1i fvmptd syl5eq ) AKEUCQEUDQZBCDDUEZVSGHCRZUFQZBRZUFQZJSZWBUGQZVTUGQZ
        JSZIWBJQZHRZIRZWBWFFSZSZGRZWAWCUHZWFFSZSZUIZUJZUJZUHZLAUAEUARZUDQZUBXAU
        KQZBCUBRZXDUEZXEGHWAWCXAUMQZSZWEWFXFSZIWBXFQZWIWJWBWFXAULQZSZSZWMWNWFXJ
        SZSZUIZUJZUJZUNZUHZWTUOUCUPUCUAUOXSUIUQABCGHIUBUAURVOAXAEUQZUSZXBVRXRWS
        YAXAEUDAXTUTZVAYAUBXCDXQWSUPXCUPVBYAXAUKVCVOYAXCEUKQDYAXAEUKYBVANVDYAXD
        DUQZUSZBCXEXEXPVSVSWRYDXDDXDDYAYCUTZYEVEZYFYDGHXGXHXOWDWGWQYDXFJWAWCYDX
        FEUMQJYDXAEUMAXTYCVFZVAOVDZTYDXFJWEWFYHTYDIXIXNWHWPYDWBXFJYHVGYDXLWLWMW
        MXMWOYDXJFWNWFYDXJEULQFYDXAEULYGVAPVDZTYDXKWKWIWJYDXJFWBWFYITTYDWMVHVIV
        JVKVKVLVMMWTUPVBAVRWSVNVOVPVQ $.
    $}

    $( The object part of the Hom functor is the ` Homf ` operation, which is
       just a functionalized version of ` Hom ` .  That is, it is a two
       argument function, which maps ` X , Y ` to the set of morphisms from
       ` X ` to ` Y ` .  (Contributed by Mario Carneiro, 15-Jan-2017.) $)
    hof1fval $p |- ( ph -> ( 1st ` M ) = ( Homf ` C ) ) $=
      ( vx vy vf vg vh chomf cfv cbs cv c1st co c2nd cop cmpt2 eqid chom hofval
      cxp cco cmpt wceq fvex xpex mpt2ex op1std syl ) ACBKLZFGBMLZUMUCZUNHIGNZO
      LZFNZOLZBUALZPUQQLUOQLZUSPJUQUSLINJNUQUTBUDLZPPHNUPURRUTVAPPUESZSZRUFCOLU
      LUFAFGUMBVAHIJUSCDEUMTUSTVATUBULVCCBKUGFGUNUNVBUMUMBMUGZVDUHZVEUIUJUK $.

    hof1.b $e |- B = ( Base ` C ) $.
    hof1.h $e |- H = ( Hom ` C ) $.
    hof1.x $e |- ( ph -> X e. B ) $.
    hof1.y $e |- ( ph -> Y e. B ) $.
    $( The object part of the Hom functor maps ` X , Y ` to the set of
       morphisms from ` X ` to ` Y ` .  (Contributed by Mario Carneiro,
       15-Jan-2017.) $)
    hof1 $p |- ( ph -> ( X ( 1st ` M ) Y ) = ( X H Y ) ) $=
      ( c1st cfv co chomf hof1fval oveqd eqid homfval eqtrd ) AFGENOZPFGCQOZPFG
      DPAUCUDFGACEHIRSABCUDDFGUDTJKLMUAUB $.

    hof2.z $e |- ( ph -> Z e. B ) $.
    hof2.w $e |- ( ph -> W e. B ) $.
    hof2.o $e |- .x. = ( comp ` C ) $.
    $( The morphism part of the Hom functor, for morphisms
       ` <. f , g >. : <. X , Y >. --> <. Z , W >. ` (which since the first
       argument is contravariant means morphisms ` f : Z --> X ` and
       ` g : Y --> W ` ), yields a function (a morphism of ` SetCat ` ) mapping
       ` h : X --> Y ` to ` g o. h o. f : Z --> W ` .  (Contributed by Mario
       Carneiro, 15-Jan-2017.) $)
    hof2fval $p |- ( ph -> ( <. X , Y >. ( 2nd ` M ) <. Z , W >. ) =
      ( f e. ( Z H X ) , g e. ( Y H W ) |-> ( h e. ( X H Y ) |->
        ( ( g ( <. X , Y >. .x. W ) h ) ( <. Z , X >. .x. W ) f ) ) ) ) $=
      ( vx vy cop cxp cv c1st cfv co c2nd cmpt cmpt2 cvv chomf wceq hofval fvex
      cbs eqeltri xpex mpt2ex op2ndd syl wa simprr fveq2d op1stg syl2anc adantr
      wcel eqtrd simprl oveq12d op2ndg df-ov syl6eqr opeq12d oveq123d mpteq12dv
      oveqd eqidd mpt2eq123dv opelxpi ovex a1i ovmpt2d ) AUCUDKLUEZMJUEZBBUFZWJ
      EFUDUGZUHUIZUCUGZUHUIZHUJZWMUKUIZWKUKUIZHUJZGWMHUIZFUGZGUGZWMWQDUJZUJZEUG
      ZWLWNUEZWQDUJZUJZULZUMZEFMKHUJZLJHUJZGKLHUJZWTXAWHJDUJZUJZXDMKUEZJDUJZUJZ
      ULZUMZIUKUIZUNAICUOUIZUCUDWJWJXIUMZUEUPXTYBUPAUCUDBCDEFGHINOPQUBUQYAYBICU
      OURUCUDWJWJXIBBBCUSUIUNPCUSURUTZYCVAZYDVBVCVDAWMWHUPZWKWIUPZVEZVEZEFWOWRX
      HXJXKXRYHWLMWNKHYHWLWIUHUIZMYHWKWIUHAYEYFVFZVGAYIMUPZYGAMBVKZJBVKZYKTUAMJ
      BBVHVIVJVLZYHWNWHUHUIZKYHWMWHUHAYEYFVMZVGAYOKUPZYGAKBVKZLBVKZYQRSKLBBVHVI
      VJVLZVNYHWPLWQJHYHWPWHUKUIZLYHWMWHUKYPVGAUUALUPZYGAYRYSUUBRSKLBBVOVIVJVLY
      HWQWIUKUIZJYHWKWIUKYJVGAUUCJUPZYGAYLYMUUDTUAMJBBVOVIVJVLZVNYHGWSXGXLXQYHW
      SWHHUIXLYHWMWHHYPVGKLHVPVQYHXCXNXDXDXFXPYHXEXOWQJDYHWLMWNKYNYTVRUUEVNYHXB
      XMWTXAYHWMWHWQJDYPUUEVNWAYHXDWBVSVTWCAYRYSWHWJVKRSKLBBWDVIAYLYMWIWJVKTUAM
      JBBWDVIXSUNVKAEFXJXKXRMKHWELJHWEVBWFWG $.

    hof2.f $e |- ( ph -> F e. ( Z H X ) ) $.
    hof2.g $e |- ( ph -> G e. ( Y H W ) ) $.
    $( The morphism part of the Hom functor, for morphisms
       ` <. f , g >. : <. X , Y >. --> <. Z , W >. ` (which since the first
       argument is contravariant means morphisms ` f : Z --> X ` and
       ` g : Y --> W ` ), yields a function (a morphism of ` SetCat ` ) mapping
       ` h : X --> Y ` to ` g o. h o. f : Z --> W ` .  (Contributed by Mario
       Carneiro, 15-Jan-2017.) $)
    hof2val $p |- ( ph -> ( F ( <. X , Y >. ( 2nd ` M ) <. Z , W >. ) G ) =
      ( h e. ( X H Y ) |->
        ( ( G ( <. X , Y >. .x. W ) h ) ( <. Z , X >. .x. W ) F ) ) ) $=
      ( vf vg co cv cop cmpt c2nd cfv cvv hof2fval wceq wa wcel simplrr simplrl
      oveq1d oveq12d mpteq2dva ovex mptex a1i ovmpt2d ) AUEUFFGMKHUGLJHUGEKLHUG
      ZUFUHZEUHZKLUIZJDUGZUGZUEUHZMKUIJDUGZUGZUJEVGGVIVKUGZFVNUGZUJZVJMJUIIUKUL
      UGUMABCDUEUFEHIJKLMNOPQRSTUAUBUNAVMFUOZVHGUOZUPUPZEVGVOVQWAVIVGUQZUPZVLVP
      VMFVNWCVHGVIVKAVSVTWBURUTAVSVTWBUSVAVBUCUDVRUMUQAEVGVQKLHVCVDVEVF $.

    hof2.k $e |- ( ph -> K e. ( X H Y ) ) $.
    $( The morphism part of the Hom functor, for morphisms
       ` <. f , g >. : <. X , Y >. --> <. Z , W >. ` (which since the first
       argument is contravariant means morphisms ` f : Z --> X ` and
       ` g : Y --> W ` ), yields a function (a morphism of ` SetCat ` ) mapping
       ` h : X --> Y ` to ` g o. h o. f : Z --> W ` .  (Contributed by Mario
       Carneiro, 15-Jan-2017.) $)
    hof2 $p |- ( ph ->
      ( ( F ( <. X , Y >. ( 2nd ` M ) <. Z , W >. ) G ) ` K ) =
        ( ( G ( <. X , Y >. .x. W ) K ) ( <. Z , X >. .x. W ) F ) ) $=
      ( vh cv cop co c2nd cfv cvv hof2val wceq wa simpr oveq2d oveq1d wcel ovex
      a1i fvmptd ) AUFHFUFUGZKLUHZJDUIZUIZEMKUHJDUIZUIFHVEUIZEVGUIZKLGUIEFVDMJU
      HIUJUKUIUIULABCDUFEFGIJKLMNOPQRSTUAUBUCUDUMAVCHUNZUOZVFVHEVGVKVCHFVEAVJUP
      UQURUEVIULUSAVHEVGUTVAVB $.
  $}

  ${
    $d f g B $.  $d f g x y z D $.  $d f g H $.  $d f g K $.  $d f g x y z M $.
    $d f g h x y z C $.  $d f g L $.  $d f g x y z O $.  $d f g h x y z ph $.
    $d f g P $.  $d f g Q $.  $d f g S $.  $d f g T $.  $d f g W $.
    $d f g X $.  $d f g Y $.  $d f g Z $.
    hofcl.m $e |- M = ( HomF ` C ) $.
    hofcl.o $e |- O = ( oppCat ` C ) $.
    hofcl.d $e |- D = ( SetCat ` U ) $.
    hofcl.c $e |- ( ph -> C e. Cat ) $.
    hofcl.u $e |- ( ph -> U e. V ) $.
    hofcl.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    ${
      hofcllem.b $e |- B = ( Base ` C ) $.
      hofcllem.h $e |- H = ( Hom ` C ) $.
      hofcllem.x $e |- ( ph -> X e. B ) $.
      hofcllem.y $e |- ( ph -> Y e. B ) $.
      hofcllem.z $e |- ( ph -> Z e. B ) $.
      hofcllem.w $e |- ( ph -> W e. B ) $.
      hofcllem.s $e |- ( ph -> S e. B ) $.
      hofcllem.t $e |- ( ph -> T e. B ) $.
      hofcllem.m $e |- ( ph -> K e. ( Z H X ) ) $.
      hofcllem.n $e |- ( ph -> L e. ( Y H W ) ) $.
      hofcllem.p $e |- ( ph -> P e. ( S H Z ) ) $.
      hofcllem.q $e |- ( ph -> Q e. ( W H T ) ) $.
      $( Lemma for ~ hofcl .  (Contributed by Mario Carneiro, 15-Jan-2017.) $)
      hofcllem $p |- ( ph ->
        ( ( K ( <. S , Z >. ( comp ` C ) X ) P )
          ( <. X , Y >. ( 2nd ` M ) <. S , T >. )
          ( Q ( <. Y , W >. ( comp ` C ) T ) L ) ) =
        ( ( P ( <. Z , W >. ( 2nd ` M ) <. S , T >. ) Q )
          ( <. ( X H Y ) , ( Z H W ) >. ( comp ` D ) ( S H T ) )
          ( K ( <. X , Y >. ( 2nd ` M ) <. Z , W >. ) L ) ) ) $=
        ( vf vg co cop cco cfv cv cmpt c2nd wcel eqid ccat adantr simpr catcocl
        catass oveq1d eqtrd eqtr3d mpteq2dva hof2val ccom oveq12d chomf homfval
        wa cxp wfn crn wss wf homffn df-f sylanbrc fovrnd eqeltrrd fmptd setcco
        a1i eqidd wceq oveq2 fmptco 3eqtrd 3eqtr4d ) AURQRJUTZFLRPVAHCVBVCZUTUT
        ZURVDZQRVAZHXDUTUTZKEGSVAZQXDUTUTZGQVAHXDUTUTZVEURXCFLXFXGPXDUTUTZKSQVA
        ZPXDUTUTZSPVAZHXDUTZUTZEXIHXDUTZUTZVEZXJXEXGGHVAZMVFVCZUTUTEFXOYAYBUTUT
        ZKLXGXOYBUTUTZXCSPJUTZVAGHJUTZDVBVCZUTZUTZAURXCXKXSAXFXCVGZWCZXHKXMHXDU
        TZUTZEXRUTXKXSYKBCXDEKJXHHGSQUFUGXDVHZACVIVGZYJUCVJZAGBVGZYJULVJASBVGZY
        JUJVJZAQBVGYJUHVJZAEGSJUTVGZYJUPVJAKSQJUTVGYJUNVJZAHBVGZYJUMVJZYKBCXDXF
        XEJQRHUFUGYNYPYTARBVGYJUIVJZUUDAYJVKZAXERHJUTVGYJABCXDLFJRPHUFUGYNUCUIU
        KUMUOUQVLZVJVLVMYKYMXQEXRYKYMFXLQPVAHXDUTUTZKYLUTXQYKXHUUHKYLYKBCXDXFLJ
        FHQRPUFUGYNYPYTUUEAPBVGZYJUKVJZUUFALRPJUTVGYJUOVJZUUDAFPHJUTVGZYJUQVJZV
        MVNYKBCXDKXLJFHSQPUFUGYNYPYSYTUUJUUBYKBCXDXFLJQRPUFUGYNYPYTUUEUUJUUFUUK
        VLZUUDUUMVMVOVNVPVQABCXDURXJXEJMHQRGTUCUFUGUHUIULUMYNABCXDEKJGSQUFUGYNU
        CULUJUHUPUNVLUUGVRAYIUSYEFUSVDZXPUTZEXRUTZVEZURXCXNVEZYHUTUURUUSVSXTAYC
        UURYDUUSYHABCXDUSEFJMHSPGTUCUFUGUJUKULUMYNUPUQVRABCXDURKLJMPQRSTUCUFUGU
        HUIUJUKYNUNUOVRVTADYGIUUSUUROXCYEYFUBUDYGVHAQRCWAVCZUTXCIABCUUTJQRUUTVH
        ZUFUGUHUIWBAQRIBBUUTAUUTBBWDZWEZUUTWFIWGUVBIUUTWHUVCABCUUTUVAUFWIWPUEUV
        BIUUTWJWKZUHUIWLWMASPUUTUTYEIABCUUTJSPUVAUFUGUJUKWBASPIBBUUTUVDUJUKWLWM
        AGHUUTUTYFIABCUUTJGHUVAUFUGULUMWBAGHIBBUUTUVDULUMWLWMAURXCXNYEUUSYKBCXD
        KXLJSQPUFUGYNYPYSYTUUJUUBUUNVLZUUSVHWNAUSYEUUQYFUURAUUOYEVGZWCZBCXDEUUP
        JGSHUFUGYNAYOUVFUCVJZAYQUVFULVJAYRUVFUJVJZAUUCUVFUMVJZAUUAUVFUPVJUVGBCX
        DUUOFJSPHUFUGYNUVHUVIAUUIUVFUKVJUVJAUVFVKAUULUVFUQVJVLVLUURVHWNWOAURUSX
        CYEXNUUQXSUUSUURUVEAUUSWQAUURWQUUOXNWRUUPXQEXRUUOXNFXPWSVNWTXAXB $.
    $}

    $( Closure of the Hom functor.  Note that the codomain is the category
       ` SetCat `` U ` for any universe ` U ` which contains each Hom-set.
       This corresponds to the assertion that ` C ` be locally small (with
       respect to ` U ` ).  (Contributed by Mario Carneiro, 15-Jan-2017.) $)
    hofcl $p |- ( ph -> M e. ( ( O Xc. C ) Func D ) ) $=
      ( vf cfv cop co eqid syl wcel vx vy vg vh vz chomf c2nd cxpc cfunc cbs cv
      cxp c1st chom cco cmpt cmpt2 hofval wceq fvex mpt2ex op2ndd opeq2d eqtr4d
      xpex wbr ccid oppcbas xpcbas oppccat xpccat setccat wf wfn crn wss homffn
      ccat a1i df-f sylanbrc setcbas feq3 mpbid ovex fnmpt2i fneq1d mpbiri wral
      wb ad3antrrr simplrr xp1st adantr simplrl xp2nd oveq1d oveqd fveq2d df-ov
      wa 1st2nd2 syl6eqr eleq2d catcocl eqeltrd eleqtrrd fmptd ad2antrr homfval
      biimpa 3eqtr4d ffvelrnd eqeltrrd elsetchom oveq12d ralrimivva fmpt2 sylib
      mpbird cvv ovmpt4g mp3an3 sylan9eq xpchom oppchom cid cres adantl catidcl
      eqtrd opeq1d 3eqtrd fveq12d 3ad2ant1 eleqtrd syl6eleq opeq12d oveq123d
      w3a simprl simprr xpeq1i syl6eq feq12d mpteq2dva hof2val syl5eqr mptresid
      catlid catrid reseq2d oppcid fveq1d ffvelrnda setcid simp21 simp22 simp23
      simpr xpcid simp3l simp3r hofcllem xpcco2 oppcco isfuncd df-br ) AEBUFOZE
      UGOZPZFBUHQZCUIQZAEUVIUAUBBUJOZUVNULZUVONUCUBUKZUMOZUAUKZUMOZBUNOZQZUVRUG
      OZUVPUGOZUVTQZUDUVRUVTOZUCUKZUDUKZUVRUWCBUOOZQZQZNUKZUVQUVSPUWCUWHQQZUPZU
      QZUQZPZUVKAUAUBUVNBUWHNUCUDUVTEHKUVNRZUVTRZUWHRZURZAUVJUWOUVIAEUWPUSUVJUW
      OUSUWTUVIUWOEBUFUTUAUBUVOUVOUWNUVNUVNBUJUTZUXAVEZUXBVAVBSZVCVDAUVIUVJUVMV
      FUVKUVMTAUAUBUEUVOCUJOZUVLUVLUOOZUVLVGOZNUCCUVIUVJUVLUNOZCVGOZCUNOZCUOOZF
      BUVLUVNUVNUVLRZUVNBFIUWQVHZUWQVIZUXDRUXGRZUXIRZUXFRZUXHRZUXERZUXJRAFBUVLU
      XKABVRTZFVRTZKBFIVJSZKVKADGTZCVRTLCDGJVLSAUVODUVIVMZUVOUXDUVIVMZAUVIUVOVN
      ZUVIVODVPZUYCUYEAUVNBUVIUVIRZUWQVQVSMUVODUVIVTWAZADUXDUSUYCUYDWJACDGJLWBD
      UXDUVOUVIWCSWDAUVJUVOUVOULZVNUWOUYIVNUAUBUVOUVOUWNUWOUWORZNUCUWAUWDUWMUVQ
      UVSUVTWEUWBUWCUVTWEVAZWFAUYIUVJUWOUXCWGWHAUVRUVOTZUVPUVOTZXAZXAZUVRUVPUXG
      QZUVRUVIOZUVPUVIOZUXIQZUVRUVPUVJQZVMUWAUWDULZUYSUWNVMZUYOUWMUYSTZUCUWDWIN
      UWAWIVUBUYOVUCNUCUWAUWDUYOUWKUWATZUWFUWDTZXAZXAZUWMUWEUVPUVTOZUXIQZUYSVUG
      UWMVUITUWEVUHUWMVMVUGUDUWEUWLVUHUWMVUGUWGUWETZXAZUWLUVQUWCUVTQZVUHVUKUVNB
      UWHUWKUWJUVTUVQUVSUWCUWQUWRUWSAUXSUYNVUFVUJKWKZVUGUVQUVNTZVUJVUGUYMVUNAUY
      LUYMVUFWLZUVPUVNUVNWMZSZWNVUGUVSUVNTZVUJVUGUYLVURAUYLUYMVUFWOZUVRUVNUVNWM
      ZSZWNZVUGUWCUVNTZVUJVUGUYMVVCVUOUVPUVNUVNWPZSZWNZUYOVUDVUEVUJWOVUKUWJUWFU
      WGUVSUWBPZUWCUWHQZQUVSUWCUVTQVUKUWIVVHUWFUWGVUKUVRVVGUWCUWHVUGUVRVVGUSZVU
      JVUGUYLVVIVUSUVRUVNUVNXBZSZWNWQWRVUKUVNBUWHUWGUWFUVTUVSUWBUWCUWQUWRUWSVUM
      VVBVUGUWBUVNTZVUJVUGUYLVVLVUSUVRUVNUVNWPZSZWNVVFVUGVUJUWGUVSUWBUVTQZTVUGU
      WEVVOUWGVUGUWEVVGUVTOVVOVUGUVRVVGUVTVVKWSUVSUWBUVTWTXCZXDXKUYOVUDVUEVUJWL
      XEXFXEVUGVUHVULUSVUJVUGVUHUVQUWCPZUVTOVULVUGUVPVVQUVTVUGUYMUVPVVQUSZVUOUV
      PUVNUVNXBZSZWSUVQUWCUVTWTXCZWNXGUWMRXHVUGCDUWMUXIGUWEVUHJAUYBUYNVUFLXIUXO
      VUGUYQUWEDVUGUVSUWBUVIQZVVOUYQUWEVUGUVNBUVIUVTUVSUWBUYGUWQUWRVVAVVNXJVUGU
      YQVVGUVIOZVWBVUGUVRVVGUVIVVKWSUVSUWBUVIWTZXCVVPXLZVUGUVODUVRUVIAUYCUYNVUF
      UYHXIZVUSXMXNVUGUYRVUHDVUGUVQUWCUVIQZVULUYRVUHVUGUVNBUVIUVTUVQUWCUYGUWQUW
      RVUQVVEXJVUGUYRVVQUVIOZVWGVUGUVPVVQUVIVVTWSUVQUWCUVIWTZXCVWAXLZVUGUVODUVP
      UVIVWFVUOXMXNXOXTVUGUYQUWEUYRVUHUXIVWEVWJXPXGXQNUCUWAUWDUWMUYSUWNUWNRXRXS
      UYOUYPVUAUYSUYTUWNAUYNUYTUVRUVPUWOQZUWNAUVJUWOUVRUVPUXCWRUYLUYMUWNYATVWKU
      WNUSUYKUAUBUVOUVOUWNUWOYAUYJYBYCYDUYOUYPUVSUVQFUNOZQZUWDULZVUAUYOUVOFBUVL
      VWLUVTUXGUVRUVPUXKUXMVWLRZUWRUXNAUYLUYMUUAAUYLUYMUUBYEVWMUWAUWDBUVTFUVSUV
      QUWRIYFZUUCUUDUUEXTAUYLXAZUVSBVGOZOZUWBVWROZPZVVGVVGUVJQZOZYGUYQYHZUVRUXF
      OZUVRUVRUVJQZOUYQUXHOVWQNVVOVWTUWKVVGUWBUWHQQZVWSUVSUVSPUWBUWHQZQZUPZNVVO
      UWKUPZVXCVXDVWQNVVOVXIUWKVWQUWKVVOTZXAZVXIUWKVWSVXHQUWKVXMVXGUWKVWSVXHVXM
      UVNBUWHVWRUWKUVTUVSUWBUWQUWRVWRRZAUXSUYLVXLKXIZVWQVURVXLUYLVURAVUTYIZWNZU
      WSVWQVVLVXLUYLVVLAVVMYIZWNZVWQVXLUUTZUUJWQVXMUVNBUWHVWRUWKUVTUVSUWBUWQUWR
      VXNVXOVXQUWSVXSVXTUUKYKUUFVWQVXCVWSVWTVXBQVXJVWSVWTVXBWTVWQUVNBUWHNVWSVWT
      UVTEUWBUVSUWBUVSHAUXSUYLKWNZUWQUWRVXPVXRVXPVXRUWSVWQUVNBVWRUVTUVSUWQUWRVX
      NVYAVXPYJVWQUVNBVWRUVTUWBUWQUWRVXNVYAVXRYJUUGUUHVWQVXDYGVVOYHVXKVWQUYQVVO
      YGVWQUYQVWBVVOVWQUYQVWCVWBVWQUVRVVGUVIUYLVVIAVVJYIZWSVWDXCVWQUVNBUVIUVTUV
      SUWBUYGUWQUWRVXPVXRXJYKUULNVVOUUIXCXLVWQVXEVXAVXFVXBVWQUVRVVGUVRVVGUVJVYB
      VYBXPVWQVXEVVGUXFOUVSFVGOZOZVWTPVXAVWQUVRVVGUXFVYBWSVWQFBUVSUWBUVLUXFVYCV
      WRUVNUVNUXKAUXTUYLUYAWNVYAUXLUWQVYCRVXNUXPVXPVXRUVAVWQVYDVWSVWTVWQUVSVYCV
      WRVWQUXSVYCVWRUSVYAVWRBFIVXNUUMSUUNYLYMYNVWQCDUXHGUYQJUXQAUYBUYLLWNAUVODU
      VRUVIUYHUUOUUPXLAUYLUYMUEUKZUVOTZYTZUWKUYPTZUWFUVPVYEUXGQZTZXAZYTZUWKUMOZ
      UWFUMOZVYEUMOZUVQPUVSUWHQQZUWFUGOZUWKUGOZUWBUWCPVYEUGOZUWHQQZVVGVYOVYSPZU
      VJQZQZVYNVYQVVQWUAUVJQZQZVYMVYRVVGVVQUVJQZQZVVOVULPZVYOVYSUVTQZUXJQZQUWFU
      WKUVRUVPPZVYEUXEQZQZUVRVYEUVJQZOZUWFUVPVYEUVJQZOZUWKUYTOZUYQUYRPZVYEUVIOZ
      UXJQZQVYLUVNBCVYNVYQVYOVYSDUVTVYMVYREFGUWCUVSUWBUVQHIJAVYGUXSVYKKYOAVYGUY
      BVYKLYOAVYGUYFVYKMYOUWQUWRVYLUYLVURAUYLUYMVYFVYKUUQZVUTSZVYLUYLVVLWVBVVMS
      ZVYLUYMVUNAUYLUYMVYFVYKUURZVUPSZVYLUYMVVCWVEVVDSZVYLVYFVYOUVNTAUYLUYMVYFV
      YKUUSZVYEUVNUVNWMSZVYLVYFVYSUVNTWVHVYEUVNUVNWPSZVYLVYMVWMUWAVYLUWKVWNTZVY
      MVWMTVYLUWKUYPVWNAVYGVYHVYJUVBVYLUVOFBUVLVWLUVTUXGUVRUVPUXKUXMVWOUWRUXNWV
      BWVEYEYPZUWKVWMUWDWMSZVWPYQVYLWVKVYRUWDTWVLUWKVWMUWDWPSZVYLVYNUVQVYOVWLQZ
      VYOUVQUVTQVYLUWFWVOUWCVYSUVTQZULZTZVYNWVOTVYLUWFVYIWVQAVYGVYHVYJUVCVYLUVO
      FBUVLVWLUVTUXGUVPVYEUXKUXMVWOUWRUXNWVEWVHYEYPZUWFWVOWVPWMSZBUVTFUVQVYOUWR
      IYFYQVYLWVRVYQWVPTWVSUWFWVOWVPWPSZUVDVYLWUOVYPVYTPZWUBOWUCVYLWUMWWBWUNWUB
      VYLUVRVVGVYEWUAUVJVYLUYLVVIWVBVVJSZVYLVYFVYEWUAUSWVHVYEUVNUVNXBSZXPVYLWUM
      VYNVYQPZVYMVYRPZVVGVVQPZWUAUXEQZQVYNVYMUVSUVQPVYOFUOOZQQZVYTPWWBVYLUWFWWE
      UWKWWFWULWWHVYLWUKWWGVYEWUAUXEVYLUVRVVGUVPVVQWWCVYLUYMVVRWVEVVSSZYRWWDXPV
      YLWVRUWFWWEUSWVSUWFWVOWVPXBSZVYLWVKUWKWWFUSWVLUWKVWMUWDXBSZYSVYLFBUVQUWCV
      YOVYSUWHUVLWWIVYMVYRVWLUVTVYNVYQUVSUWBUXEUVNUVNUXKUXLUWQVWOUWRWVCWVDWVFWV
      GWWIRUWSUXRWVIWVJWVMWVNWVTWWAUVEVYLWWJVYPVYTVYLUVNBUWHVYMVYNFUVSUVQVYOUWQ
      UWSIWVCWVFWVIUVFYLYMYNVYPVYTWUBWTXCVYLWUQWUEWURWUGWVAWUJVYLWUSWUHWUTWUIUX
      JVYLUYQVVOUYRVULVYLUYQVWBVVOVYLUYQVWCVWBVYLUVRVVGUVIWWCWSVWDXCVYLUVNBUVIU
      VTUVSUWBUYGUWQUWRWVCWVDXJYKVYLUYRVWGVULVYLUYRVWHVWGVYLUVPVVQUVIWWKWSVWIXC
      VYLUVNBUVIUVTUVQUWCUYGUWQUWRWVFWVGXJYKYRVYLWUTVYOVYSUVIQZWUIVYLWUTWUAUVIO
      WWNVYLVYEWUAUVIWWDWSVYOVYSUVIWTXCVYLUVNBUVIUVTVYOVYSUYGUWQUWRWVIWVJXJYKXP
      VYLWUQWWEWUDOWUEVYLUWFWWEWUPWUDVYLUVPVVQVYEWUAUVJWWKWWDXPWWLYNVYNVYQWUDWT
      XCVYLWURWWFWUFOWUGVYLUWKWWFUYTWUFVYLUVRVVGUVPVVQUVJWWCWWKXPWWMYNVYMVYRWUF
      WTXCYSXLUVGUVIUVJUVMUVHXSXF $.
  $}

  ${
    oppchofcl.o $e |- O = ( oppCat ` C ) $.
    oppchofcl.m $e |- M = ( HomF ` O ) $.
    oppchofcl.d $e |- D = ( SetCat ` U ) $.
    oppchofcl.c $e |- ( ph -> C e. Cat ) $.
    oppchofcl.u $e |- ( ph -> U e. V ) $.
    oppchofcl.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    $( Closure of the opposite Hom functor.  (Contributed by Mario Carneiro,
       17-Jan-2017.) $)
    oppchofcl $p |- ( ph -> M e. ( ( C Xc. O ) Func D ) ) $=
      ( cfv co cfunc eqid ccat wcel wceq coppc cxpc oppccat syl chomf crn ctpos
      oppchomf rneqi cdm wrel cbs cxp relxp wfn homffn fndm ax-mp releqi rntpos
      mpbir eqtr3i syl5eqss hofcl 2oppchomf a1i ccomf 2oppccomf xpcpropd oveq1d
      eqidd eleqtrrd ) AEFUANZFUBOZCPOBFUBOZCPOAFCDEVMGIVMQZJABRSFRSZKBFHUCUDZL
      AFUENZUFZBUENZUFZDWAUGZUFZVTWBWCVSBWAFHWAQZUHUIWAUJZUKZWDWBTWGBULNZWHUMZU
      KWHWHUNWFWIWAWIUOWFWITWHBWAWEWHQUPWIWAUQURUSVAWAUTURVBMVCVDAVOVNCPABVMFFR
      WAVMUENTABFHVEVFBVGNVMVGNTABFHVHVFAVSVKAFVGNVKKAVQVMRSVRFVMVPUCUDVRVRVIVJ
      VL $.
  $}

  ${
    $d c C $.  $d c M $.  $d c O $.  $d c ph $.
    yonval.y $e |- Y = ( Yon ` C ) $.
    yonval.c $e |- ( ph -> C e. Cat ) $.
    yonval.o $e |- O = ( oppCat ` C ) $.
    ${
      yonval.m $e |- M = ( HomF ` O ) $.
      $( Value of the Yoneda embedding.  (Contributed by Mario Carneiro,
         17-Jan-2017.) $)
      yonval $p |- ( ph -> Y = ( <. C , O >. curryF M ) ) $=
        ( vc cyon cfv cop ccurf co coppc chof ccat cvv wceq cv df-yon a1i simpr
        cmpt wa fveq2d syl6eqr opeq12d oveq12d wcel ovex fvmptd syl5eq ) AEBKLB
        DMZCNOZFAJBJUAZUQPLZMZURQLZNOZUPRKSKJRVAUETAJUBUCAUQBTZUFZUSUOUTCNVCUQB
        URDAVBUDZVCURBPLDVCUQBPVDUGHUHZUIVCUTDQLCVCURDQVEUGIUHUJGUPSUKAUOCNULUC
        UMUN $.
    $}

    yoncl.s $e |- S = ( SetCat ` U ) $.
    yoncl.q $e |- Q = ( O FuncCat S ) $.
    yoncl.u $e |- ( ph -> U e. V ) $.
    yoncl.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    $( The Yoneda embedding is a functor from the category to the category
       ` Q ` of presheaves on ` C ` .  (Contributed by Mario Carneiro,
       17-Jan-2017.) $)
    yoncl $p |- ( ph -> Y e. ( C Func Q ) ) $=
      ( cop co eqid ccat wcel chof cfv ccurf cfunc yonval oppccat syl oppchofcl
      curfcl eqeltrd ) AHBFPFUAUBZUCQZBCUDQABUKFHIJKUKRZUEABFCDUKULULRMJABSTFST
      JBFKUFUGABDEUKFGKUMLJNOUHUIUJ $.
  $}

  ${
    yon11.y $e |- Y = ( Yon ` C ) $.
    yon11.b $e |- B = ( Base ` C ) $.
    yon11.c $e |- ( ph -> C e. Cat ) $.
    yon11.p $e |- ( ph -> X e. B ) $.
    ${
      yon1cl.o $e |- O = ( oppCat ` C ) $.
      yon1cl.s $e |- S = ( SetCat ` U ) $.
      yon1cl.u $e |- ( ph -> U e. V ) $.
      yon1cl.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
      $( The Yoneda embedding at an object of ` C ` is a presheaf on ` C ` ,
         also known as the contravariant Hom functor.  (Contributed by Mario
         Carneiro, 17-Jan-2017.) $)
      yon1cl $p |- ( ph -> ( ( 1st ` Y ) ` X ) e. ( O Func S ) ) $=
        ( cfunc co cfv c1st cfuc c2nd eqid wrel wcel wbr relfunc yoncl 1st2ndbr
        fucbas sylancr funcf1 ffvelrnd ) ABFDRSZHIUATZABUOCFDUBSZUPIUCTZKFDUQUQ
        UDZUKACUQRSZUEIUTUFUPURUTUGCUQUHACUQDEFGIJLNOUSPQUIIUTUJULUMMUN $.
    $}

    yon11.h $e |- H = ( Hom ` C ) $.
    yon11.z $e |- ( ph -> Z e. B ) $.
    $( Value of the Yoneda embedding at an object.  The partially evaluated
       Yoneds embedding is also the contravariant Hom functor.  (Contributed by
       Mario Carneiro, 17-Jan-2017.) $)
    yon11 $p |- ( ph ->
      ( ( 1st ` ( ( 1st ` Y ) ` X ) ) ` Z ) = ( Z H X ) ) $=
      ( c1st cfv co eqid fveq2d fveq1d wcel coppc chof ccurf yonval chomf csetc
      cop crn ccat oppccat syl cvv fvex rnex a1i wss ssid oppchofcl curf11 chom
      oppcbas hof1 oppchom syl6eq 3eqtrd ) AGEFNOZOZNOZOGECCUAOZUGVIUBOZUCPZNOZ
      OZNOZOEGVJNOPZGEDPZAGVHVNAVGVMNAEVFVLAFVKNACVJVIFHJVIQZVJQZUDRSRSABBCVICU
      EOZUHZUFOZVJVKVMEGVKQIJACUITVIUITJCVIVQUJUKZACWAVTVJVIULVQVRWAQJVTULTAVSC
      UEUMUNUOVTVTUPAVTUQUOURBCVIVQIVAZKVMQMUSAVOEGVIUTOZPVPABVIWDVJEGVRWBWCWDQ
      KMVBCDVIEGLVQVCVDVE $.

    yon12.x $e |- .x. = ( comp ` C ) $.
    yon12.w $e |- ( ph -> W e. B ) $.
    ${
      yon12.f $e |- ( ph -> F e. ( W H Z ) ) $.
      yon12.g $e |- ( ph -> G e. ( Z H X ) ) $.
      $( Value of the Yoneda embedding at a morphism.  The partially evaluated
         Yoneds embedding is also the contravariant Hom functor.  (Contributed
         by Mario Carneiro, 17-Jan-2017.) $)
      yon12 $p |- ( ph -> ( ( ( Z ( 2nd ` ( ( 1st ` Y ) ` X ) ) W ) ` F ) ` G )
        = ( G ( <. W , Z >. .x. X ) F ) ) $=
        ( c1st cfv c2nd ccid cop coppc chof cco ccurf eqid yonval fveq2d fveq1d
        oveqd chomf crn csetc chom ccat wcel oppccat syl cvv fvex rnex a1i ssid
        co oppchofcl oppcbas oppchom syl6eleqr curf12 eqtrd catidcl hof2 oppcco
        wss oveq1d catcocl catlid 3eqtrd ) AFEKHIJUBUCZUCZUDUCZVIZUCZUCFICUEUCZ
        UCZEIKUFZIHUFCUGUCZUHUCZUDUCVIVIZUCEFWKHWLUIUCZVIVIZWJIIUFHWOVIZVIZFEHK
        UFIDVIVIZAFWHWNAWHEKHICWLUFWMUJVIZUBUCZUCZUDUCZVIZUCWNAEWGXDAWFXCKHAWEX
        BUDAIWDXAAJWTUBACWMWLJLNWLUKZWMUKZULUMUNUMUOUNABBCWLWICUPUCZUQZURUCZWMW
        TEWLUSUCZXBIKHWTUKMNACUTVAWLUTVANCWLXEVBVCZACXIXHWMWLVDXEXFXIUKNXHVDVAA
        XGCUPVEVFVGXHXHVSAXHVHVGVJBCWLXEMVKZOXBUKQXJUKZWIUKZSAEHKGVIKHXJVITCGWL
        KHPXEVLVMZVNVOUNABWLWOWJEXJFWMHIKIXFXKXLXMOQOSWOUKAWJIIGVIIIXJVIABCWIGI
        MPXNNOVPCGWLIIPXEVLVMXOAFKIGVIIKXJVIUACGWLIKPXEVLVMVQAWRWSWJWQVIWJWSHIU
        FIDVIVIWSAWPWSWJWQABCDFEWLIKHMRXEOQSVRVTABCDWJWSWLIIHMRXEOOSVRABCDWIWSG
        HIMPXNNSROABCDEFGHKIMPRNSQOTUAWAWBWCWC $.
    $}

    yon2.f $e |- ( ph -> F e. ( X H Z ) ) $.
    yon2.g $e |- ( ph -> G e. ( W H X ) ) $.
    $( Value of the Yoneda embedding at a morphism.  (Contributed by Mario
       Carneiro, 17-Jan-2017.) $)
    yon2 $p |- ( ph -> ( ( ( ( X ( 2nd ` Y ) Z ) ` F ) ` W ) ` G )
      = ( F ( <. W , X >. .x. Z ) G ) ) $=
      ( c2nd cfv coppc ccid cop chof cco ccurf yonval fveq2d oveqd fveq1d chomf
      eqid crn csetc ccat wcel oppccat syl cvv fvex rnex a1i wss ssid oppchofcl
      oppcbas curf2val chom oppchom syl6eleqr catidcl hof2 catlid oveq1d oppcco
      co eqtrd 3eqtrd ) AFHEIKJUBUCZVSZUCZUCZUCFEHCUDUCZUEUCZUCZIHUFZKHUFWFUGUC
      ZUBUCVSVSZUCWHFWIHWFUHUCZVSVSZEKIUFHWLVSZVSZEFHIUFKDVSVSZAFWEWKAWEHEIKCWF
      UFWJUIVSZUBUCZVSZUCZUCWKAHWDWTAEWCWSAWBWRIKAJWQUBACWJWFJLNWFUOZWJUOZUJUKU
      LUMUMABBCWFCUNUCZUPZUQUCZWJWQGWGEWTIKHWQUOMNACURUSWFURUSNCWFXAUTVAZACXEXD
      WJWFVBXAXBXEUONXDVBUSAXCCUNVCVDVEXDXDVFAXDVGVEVHBCWFXAMVIZPWGUOZOQTWTUOSV
      JVTUMABWFWLEWHWFVKUCZFWJHIHKXBXFXGXIUOZOSQSWLUOZAEIKGVSKIXIVSTCGWFKIPXAVL
      VMABWFWGXIHXGXJXHXFSVNAFHIGVSIHXIVSUACGWFIHPXAVLVMZVOAWOFEWNVSWPAWMFEWNAB
      WFWLWGFXIIHXGXJXHXFOXKSXLVPVQABCDEFWFKIHMRXAQOSVRVTWA $.
  $}

  ${
    $d f g h x y C $.  $d f g h x y D $.  $d f g h x y ph $.
    hofpropd.1 $e |- ( ph -> ( Homf ` C ) = ( Homf ` D ) ) $.
    hofpropd.2 $e |- ( ph -> ( comf ` C ) = ( comf ` D ) ) $.
    hofpropd.c $e |- ( ph -> C e. Cat ) $.
    hofpropd.d $e |- ( ph -> D e. Cat ) $.
    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same Hom functor.  (Contributed by
       Mario Carneiro, 26-Jan-2017.) $)
    hofpropd $p |- ( ph -> ( HomF ` C ) = ( HomF ` D ) ) $=
      ( vx vy vf vg vh cfv cv co wceq wcel adantr eqid ad2antrr chomf c1st chom
      cbs cxp c2nd cco cop cmpt cmpt2 homfeqbas xpeq12d xp1st ad2antll ad2antrl
      chof homfeqval xp2nd df-ov 3eqtr3g 1st2nd2 fveq2d 3eqtr4d ccomf ad3antrrr
      simplrl oveq1d oveqd ccat syl6eqr eleq2d biimpa simplrr catcocl comfeqval
      wa eqeltrd eqtrd mpteq12dva mpt2eq123dva opeq12d hofval ) ABUAMZHIBUDMZWD
      UEZWEJKINZUBMZHNZUBMZBUCMZOZWHUFMZWFUFMZWJOZLWHWJMZKNZLNZWHWMBUGMZOZOZJNZ
      WGWIUHZWMWROOZUIZUJZUJZUHCUAMZHICUDMZXHUEZXIJKWGWICUCMZOZWLWMXJOZLWHXJMZW
      PWQWHWMCUGMZOZOZXAXBWMXNOZOZUIZUJZUJZUHBUPMZCUPMZAWCXGXFYADAHIWEWEXEXIXIX
      TAWDXHWDXHABCDUKZYDULZAWEXIPWHWEQZYERAYFWFWEQZVPZVPZJKWKWNXDXKXLXSYIWDBCW
      JXJWGWIWDSZWJSZXJSZAWCXGPZYHDRZYGWGWDQZAYFWFWDWDUMUNZYFWIWDQZAYGWHWDWDUMU
      OZUQYIWNXLPXAWKQZYIWDBCWJXJWLWMYJYKYLYNYFWLWDQZAYGWHWDWDURUOZYGWMWDQZAYFW
      FWDWDURUNZUQRYIYSWPWNQZVPZVPZLWOXCXMXRYIWOXMPUUEYIWIWLUHZWJMZUUGXJMZWOXMY
      IWIWLWJOZWIWLXJOUUHUUIYIWDBCWJXJWIWLYJYKYLYNYRUUAUQWIWLWJUSZWIWLXJUSUTYIW
      HUUGWJYFWHUUGPZAYGWHWDWDVAUOZVBZYIWHUUGXJUUMVBVCRUUFWQWOQZVPZXCWTXAXQOXRU
      UPWDBCXNWRXAWTWJWGWIWMYJYKWRSZXNSZYIYMUUEUUOYNTZABVDMCVDMPYHUUEUUOEVEZYIY
      OUUEUUOYPTYIYQUUEUUOYRTZYIUUBUUEUUOUUCTZYIYSUUDUUOVFUUPWTWPWQUUGWMWROZOZW
      IWMWJOUUPWSUVCWPWQUUPWHUUGWMWRYIUULUUEUUOUUMTZVGVHZUUPWDBWRWQWPWJWIWLWMYJ
      YKUUQABVIQYHUUEUUOFVEUVAYIYTUUEUUOUUATZUVBUUFUUOWQUUJQUUFWOUUJWQUUFWOUUHU
      UJYIWOUUHPUUEUUNRUUKVJVKVLZYIYSUUDUUOVMZVNVQVOUUPWTXPXAXQUUPUVDWPWQUUGWMX
      NOZOWTXPUUPWDBCXNWRWQWPWJWIWLWMYJYKUUQUURUUSUUTUVAUVGUVBUVHUVIVOUVFUUPXOU
      VJWPWQUUPWHUUGWMXNUVEVGVHVCVGVRVSVTVTWAAHIWDBWRJKLWJYBYBSFYJYKUUQWBAHIXHC
      XNJKLXJYCYCSGXHSYLUURWBVC $.

    $( If two categories have the same set of objects, morphisms, and
       compositions, then they have the same Yoneda functor.  (Contributed by
       Mario Carneiro, 26-Jan-2017.) $)
    yonpropd $p |- ( ph -> ( Yon ` C ) = ( Yon ` D ) ) $=
      ( coppc cfv cop chof ccurf co cyon chomf ccat wcel eqid oppccat syl csetc
      crn oppchomfpropd oppccomfpropd cvv fvex rnex a1i wss oppchofcl curfpropd
      ssid hofpropd oveq2d eqtrd yonval 3eqtr4d ) ABBHIZJURKIZLMZCCHIZJZVAKIZLM
      ZBNIZCNIZAUTVBUSLMVDABCURVABOIZUBZUAIZUSDEABCDUCZABCDEUDZFGABPQURPQFBURUR
      RZSTZACPQVAPQGCVAVARZSTZABVIVHUSURUEVLUSRZVIRFVHUEQAVGBOUFUGUHVHVHUIAVHUL
      UHUJUKAUSVCVBLAURVAVJVKVMVOUMUNUOABUSURVEVERFVLVPUPACVCVAVFVFRGVNVCRUPUQ
      $.
  $}

  ${
    oppcyon.o $e |- O = ( oppCat ` C ) $.
    oppcyon.y $e |- Y = ( Yon ` O ) $.
    oppcyon.m $e |- M = ( HomF ` C ) $.
    oppcyon.c $e |- ( ph -> C e. Cat ) $.
    $( Value of the opposite Yoneda embedding.  (Contributed by Mario Carneiro,
       26-Jan-2017.) $)
    oppcyon $p |- ( ph -> Y = ( <. O , C >. curryF M ) ) $=
      ( cfv cop ccurf co chof chomf a1i ccomf ccat wcel eqid coppc wceq oppccat
      2oppchomf 2oppccomf syl hofpropd syl5eq crn csetc eqidd cvv fvex rnex wss
      oveq2d ssid hofcl curfpropd yonval 3eqtr4rd ) ADDUAJZKZCLMVCVBNJZLMDBKCLM
      EACVDVCLACBNJVDHABVBBOJZVBOJUBABDFUDPZBQJVBQJUBABDFUEPZIADRSZVBRSABRSVHIB
      DFUCUFZDVBVBTZUCUFZUGUHUPADDBVBVEUIZUJJZCADOJUKADQJUKVFVGVIVIIVKABVMVLCDU
      LHFVMTIVLULSAVEBOUMUNPVLVLUOAVLUQPURUSADVDVBEGVIVJVDTUTVA $.
  $}

  ${
    oyoncl.o $e |- O = ( oppCat ` C ) $.
    oyoncl.y $e |- Y = ( Yon ` O ) $.
    oyoncl.c $e |- ( ph -> C e. Cat ) $.
    oyoncl.s $e |- S = ( SetCat ` U ) $.
    oyoncl.u $e |- ( ph -> U e. V ) $.
    oyoncl.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    ${
      oyoncl.q $e |- Q = ( C FuncCat S ) $.
      $( The opposite Yoneda embedding is a functor from ` oppCat `` C ` to the
         functor category ` C -> SetCat ` .  (Contributed by Mario Carneiro,
         26-Jan-2017.) $)
      oyoncl $p |- ( ph -> Y e. ( O Func Q ) ) $=
        ( cfv co ccat wcel eqid coppc cfuc cfunc oppccat syl chomf crn oppchomf
        ctpos rneqi cdm wrel wceq cbs cxp relxp homffn fndm ax-mp releqi rntpos
        wfn mpbir eqtr3i syl5eqss yoncl 2oppchomf ccomf 2oppccomf eqidd setccat
        a1i fucpropd syl5eq oveq2d eleqtrrd ) AHFFUAPZDUBQZUCQFCUCQAFVRDEVQGHJA
        BRSFRSZKBFIUDUEZVQTZLVRTMAFUFPZUGZBUFPZUGZEWDUIZUGZWCWEWFWBBWDFIWDTZUHU
        JWDUKZULZWGWEUMWJBUNPZWKUOZULWKWKUPWIWLWDWLVBWIWLUMWKBWDWHWKTUQWLWDURUS
        UTVCWDVAUSVDNVEVFACVRFUCACBDUBQVROABVQDDWDVQUFPUMABFIVGVLBVHPVQVHPUMABF
        IVIVLADUFPVJADVHPVJKAVSVQRSVTFVQWAUDUEAEGSDRSMDEGLVKUEZWMVMVNVOVP $.
    $}

    oyon1cl.b $e |- B = ( Base ` C ) $.
    oyon1cl.p $e |- ( ph -> X e. B ) $.
    $( The opposite Yoneda embedding at an object of ` C ` is a functor from
       ` C ` to Set, also known as the covariant Hom functor.  (Contributed by
       Mario Carneiro, 17-Jan-2017.) $)
    oyon1cl $p |- ( ph -> ( ( 1st ` Y ) ` X ) e. ( C Func S ) ) $=
      ( cfunc co cfv c1st cfuc c2nd oppcbas eqid fucbas wrel wbr relfunc oyoncl
      wcel 1st2ndbr sylancr funcf1 ffvelrnd ) ABCDRSZHIUATZABUPFCDUBSZUQIUCTZBC
      FJPUDCDURURUEZUFAFURRSZUGIVAUKUQUSVAUHFURUIACURDEFGIJKLMNOUTUJIVAULUMUNQU
      O $.
  $}

  ${
    $d a b f g x y .1. $.  $d a b g h k u w y z A $.  $d a f g h u w x y z C $.
    $d a b f g h k u v w y z E $.  $d a b f g h k u w x y z F $.  $d a b y K $.
    $d a b f g h k u v w x y z B $.  $d a b f g x y G $.  $d a b h k v w z N $.
    $d z I $.  $d a b f g h k u v w x y z O $.  $d a b f g h k u v w x y z S $.
    $d b g h k u w y z M $.  $d a b f g u v w x z Q $.  $d f g h u v w y z T $.
    $d a b f g x y P $.  $d a b f g h k u v w x y z ph $.  $d u v z R $.
    $d a b f g h k u v w x y z Y $.  $d a b f g h k u v w x y z Z $.
    $d a b f g h k u w x y z X $.
    yoneda.y $e |- Y = ( Yon ` C ) $.
    yoneda.b $e |- B = ( Base ` C ) $.
    yoneda.1 $e |- .1. = ( Id ` C ) $.
    yoneda.o $e |- O = ( oppCat ` C ) $.
    yoneda.s $e |- S = ( SetCat ` U ) $.
    yoneda.t $e |- T = ( SetCat ` V ) $.
    yoneda.q $e |- Q = ( O FuncCat S ) $.
    yoneda.h $e |- H = ( HomF ` Q ) $.
    yoneda.r $e |- R = ( ( Q Xc. O ) FuncCat T ) $.
    yoneda.e $e |- E = ( O evalF S ) $.
    yoneda.z $e |- Z = ( H o.func ( ( <. ( 1st ` Y ) , tpos ( 2nd ` Y ) >.
      o.func ( Q 2ndF O ) ) pairF ( Q 1stF O ) ) ) $.
    yoneda.c $e |- ( ph -> C e. Cat ) $.
    yoneda.w $e |- ( ph -> V e. W ) $.
    yoneda.u $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    yoneda.v $e |- ( ph -> ( ran ( Homf ` Q ) u. U ) C_ V ) $.
    $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro, 28-Jan-2017.) $)
    yonedalem1 $p |- ( ph ->
      ( Z e. ( ( Q Xc. O ) Func T ) /\ E e. ( ( Q Xc. O ) Func T ) ) ) $=
      ( cxpc co cfunc wcel c1st cfv c2nd ctpos cop c2ndf ccofu c1stf cprf coppc
      eqid ccat oppccat syl cvv chomf crn unssbd setccat fuccat 2ndfcl wbr wrel
      ssexd relfunc yoncl 1st2ndbr df-br sylib cofucl 1stfcl prfcl unssad hofcl
      sylancr funcoppc syl5eqel funcsetcres2 evlfcl sseldd jca ) APDLULUMZGUNUM
      ZUOJWRUOAPKOUPUQZOURUQZUSZUTZDLVAUMZVBUMZDLVCUMZVDUMZVBUMWRUGAWQDVEUQZDUL
      UMZGXFKAWQXGXFXHDXDXEXFVFXHVFAWQLXGXCXBADLXCWQWQVFZALFDUCACVGUOLVGUOUHCLT
      VHVIZAHVJUOFVGUOAHMNUIADVKUQVLZHMUKVMZVSZFHVJUAVNVIZVOZXJXCVFVPAWSXALXGUN
      UMZVQXBXPUOACDXGWSWTLTXGVFZACDUNUMZVROXRUOWSWTXRVQCDVTACDFHLVJOQUHTUAUCXM
      UJWAOXRWBWJWKWSXAXPWCWDWEADLXEWQXIXOXJXEVFWFWGADGMKXGNUDXQUBXOUIAXKHMUKWH
      WIWEWLAWQFUNUMWRJAGFMWQHNUBUAUIXLWMALFDJUFUCXJXNWNWOWP $.

    ${
      yonedalem21.f $e |- ( ph -> F e. ( O Func S ) ) $.
      yonedalem21.x $e |- ( ph -> X e. B ) $.
      $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro, 28-Jan-2017.) $)
      yonedalem21 $p |- ( ph -> ( F ( 1st ` Z ) X ) =
        ( ( ( 1st ` Y ) ` X ) ( O Nat S ) F ) ) $=
        ( c1st cfv co c2nd ctpos c2ndf ccofu c1stf cprf cnat fveq2i oveqi df-ov
        cop eqtri cfunc cxpc coppc eqid fucbas oppcbas xpcbas ccat wcel oppccat
        cxp syl cvv chomf crn unssbd ssexd setccat fuccat 2ndfcl wbr wrel yoncl
        relfunc 1st2ndbr sylancr funcoppc df-br sylib cofucl 1stfcl prfcl hofcl
        unssad opelxpi syl2anc cofu1 syl5eq chom prf1 wceq fvex op1st a1i 2ndf1
        tposex op2ndg eqtrd fveq12d op1stg opeq12d fveq2d syl6eqr fuchom yon1cl
        1stf1 hof1 3eqtrd ) AKPRUPUQZURZKPVIZQUPUQZQUSUQZUTZVIZDMVAURZVBURZDMVC
        URZVDURZUPUQUQZLUPUQZUQZPYLUQZKUUAURZUUCKMFVEURZURAYJYKLYSVBURZUPUQZUQZ
        UUBYJKPUUGURUUHYIUUGKPRUUFUPUIVFVGKPUUGVHVJAMFVKURZBWAZDMVLURZDVMUQZDVL
        URZGYSLYKDMUUKUUIBUUKVNZMFDUEVOZBCMUBTVPVQZAUUKUULYSUUMDYQYRYSVNZUUMVNA
        UUKMUULYPYOADMYPUUKUUNAMFDUEACVRVSMVRVSUJCMUBVTWBZAHWCVSFVRVSAHNOUKADWD
        UQWEZHNUMWFWGZFHWCUCWHWBWIZUURYPVNZWJZAYLYNMUULVKURZWKYOUVDVSACDUULYLYM
        MUBUULVNZACDVKURZWLQUVFVSYLYMUVFWKCDWNACDFHMWCQSUJUBUCUEUUTULWMQUVFWOWP
        WQYLYNUVDWRWSZWTZADMYRUUKUUNUVAUURYRVNZXAZXBADGNLUULOUFUVEUDUVAUKAUUSHN
        UMXDXCAKUUIVSZPBVSZYKUUJVSUNUOKPUUIBXEXFZXGXHAUUBUUCKVIZUUAUQUUDAYTUVNU
        UAAYTYKYQUPUQUQZYKYRUPUQUQZVIUVNAUUJUUKUULYSDYQYRUUKXIUQZYKUUQUUPUVQVNZ
        UVHUVJUVMXJAUVOUUCUVPKAUVOYKYPUPUQUQZYOUPUQZUQUUCAUUJUUKMUULYPYOYKUUPUV
        CUVGUVMXGAUVSPUVTYLUVTYLXKAYLYNQUPXLYMQUSXLXPXMXNAUVSYKUSUQZPAUUJDMYPYK
        UUKUVQUUNUUPUVRUVAUURUVBUVMXOAUVKUVLUWAPXKUNUOKPUUIBXQXFXRXSXRAUVPYKUPU
        QZKAUUJDMYRYKUUKUVQUUNUUPUVRUVAUURUVIUVMYFAUVKUVLUWBKXKUNUOKPUUIBXTXFXR
        YAXRYBUUCKUUAVHYCAUUIDUUELUUCKUFUVAUUOMFDUUEUEUUEVNYDABCFHMWCPQSTUJUOUB
        UCUUTULYEUNYGYH $.

      ${
        yonedalem3a.m $e |- M = ( f e. ( O Func S ) , x e. B |->
          ( a e. ( ( ( 1st ` Y ) ` x ) ( O Nat S ) f ) |->
            ( ( a ` x ) ` ( .1. ` x ) ) ) ) $.
        $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro,
           29-Jan-2017.) $)
        yonedalem3a $p |- ( ph -> ( ( F M X ) =
          ( a e. ( ( ( 1st ` Y ) ` X ) ( O Nat S ) F ) |->
            ( ( a ` X ) ` ( .1. ` X ) ) ) /\
            ( F M X ) : ( F ( 1st ` Z ) X ) --> ( F ( 1st ` E ) X ) ) ) $=
          ( co c1st cfv cnat cv cmpt wceq wf cfunc wcel wa simpr fveq2d oveq12d
          simpl fveq12d mpteq12dv ovex ovmpt2a syl2anc chom c2nd eqid nat1st2nd
          mptex oppcbas adantr natcl cvv chomf crn unssbd ssexd cbs wbr relfunc
          wrel yon1cl 1st2ndbr sylancr funcf1 ffvelrnd eleqtrrd elsetchom mpbid
          setcbas catidcl yon11 fmptd yonedalem21 oppccat setccat evlf1 feq123d
          ccat syl mpbird jca ) AMSOVAZUBSTVBVCZVCZMPGVDVAZVAZSJVCZSUBVEZVCZVCZ
          VFZVGZMSUAVBVCVAZMSLVBVCVAZXSVHZAMPGVIVAZVJZSCVJZYIURUSKBMSYMCUBBVEZX
          TVCZKVEZYBVAZYPJVCZYPYEVCZVCZVFYHOYRMVGZYPSVGZVKZUBYSUUBYCYGUUEYQYAYR
          MYBUUEYPSXTUUCUUDVLZVMUUCUUDVOVNUUEYTYDUUAYFUUEYPSYEUUFVMUUEYPSJUUFVM
          VPVQUTUBYCYGYAMYBVRWEVSVTZAYLYCSMVBVCZVCZYHVHAUBYCYGUUIYHAYEYCVJZVKZS
          YAVBVCZVCZUUIYDYFUUKYFUUMUUIGWAVCZVAVJUUMUUIYFVHUUKYECPGUULYAWBVCZUUN
          UUHMWBVCZYBSYBWCZUUKYEPGYAMYBUUQAUUJVLWDCDPUFUDWFZUUNWCZAYOUUJUSWGWHU
          UKGIYFUUNWIUUMUUIUGAIWIVJZUUJAIQRUOAEWJVCWKIQUQWLWMZWGUUSAUUMIVJUUJAU
          UMGWNVCZIACUVBSUULACUVBPGUULUUOUURUVBWCZAYMWQZYAYMVJUULUUOYMWOPGWPZAC
          DGIPWISTUCUDUNUSUFUGUVAUPWRYAYMWSWTXAUSXBAGIWIUGUVAXFZXCWGAUUIIVJUUJA
          UUIUVBIACUVBSUUHACUVBPGUUHUUPUURUVCAUVDYNUUHUUPYMWOUVEURMYMWSWTXAUSXB
          UVFXCWGXDXEAYDUUMVJUUJAYDSSDWAVCZVAUUMACDJUVGSUDUVGWCZUEUNUSXGACDUVGS
          TSUCUDUNUSUVHUSXHXCWGXBYHWCXIAYJYCYKUUIXSYHUUGACDEFGHIJLMNPQRSTUAUCUD
          UEUFUGUHUIUJUKULUMUNUOUPUQURUSXJACPGLMSULADXOVJPXOVJUNDPUFXKXPAUUTGXO
          VJUVAGIWIUGXLXPUURURUSXMXNXQXR $.
      $}

      ${
        yonedalem4.n $e |- N =
          ( f e. ( O Func S ) , x e. B |-> ( u e. ( ( 1st ` f ) ` x ) |->
            ( y e. B |-> ( g e. ( y ( Hom ` C ) x ) |->
              ( ( ( x ( 2nd ` f ) y ) ` g ) ` u ) ) ) ) ) $.
        yonedalem4.p $e |- ( ph -> A e. ( ( 1st ` F ) ` X ) ) $.
        $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro,
           29-Jan-2017.) $)
        yonedalem4a $p |- ( ph -> ( ( F N X ) ` A ) =
          ( y e. B |-> ( g e. ( y ( Hom ` C ) X ) |->
              ( ( ( X ( 2nd ` F ) y ) ` g ) ` A ) ) ) ) $=
          ( cv chom cfv co c2nd cmpt c1st cvv cfunc cmpt2 wceq wa simprl fveq2d
          a1i simprr fveq12d wcel simplrr oveq2d simplrl eqidd fveq1d mpteq12dv
          oveq123d mpteq2dva fvex mptex ovmpt2d simpr mpteq2dv eqeltri fvmptd
          cbs ) ADECFOCVEZUCGVFVGZVHZDVEZOVEZUCWSQVIVGZVHZVGZVGZVJZVJZCFOXAEXFV
          GZVJZVJZUCQVKVGZVGZQUCSVHVLANBQUCTJVMVHZFDBVEZNVEZVKVGZVGZCFOWSXPWTVH
          ZXBXCXPWSXQVIVGZVHZVGZVGZVJZVJZVJZDXNXIVJZSVLSNBXOFYGVNVOAVCVSAXQQVOZ
          XPUCVOZVPVPZDXSYFXNXIYKXPUCXRXMYKXQQVKAYIYJVQVRAYIYJVTWAYKCFYEXHYKWSF
          WBZVPZOXTYDXAXGYMXPUCWSWTAYIYJYLWCZWDYMXBYCXFYMXCYBXEYMXPUCWSWSYAXDYM
          XQQVIAYIYJYLWEVRYNYMWSWFWIWGWGWHWJWHVAVBYHVLWBADXNXIUCXMWKWLVSWMAXBEV
          OZVPZCFXHXKYPOXAXGXJYPXBEXFAYOWNVRWOWOVDXLVLWBACFXKFGWRVGVLUGGWRWKWPW
          LVSWQ $.

        ${
          yonedalem4b.p $e |- ( ph -> P e. B ) $.
          yonedalem4b.g $e |- ( ph -> G e. ( P ( Hom ` C ) X ) ) $.
          $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro,
             29-Jan-2017.) $)
          yonedalem4b $p |- ( ph -> ( ( ( ( F N X ) ` A ) ` P ) ` G ) =
            ( ( ( X ( 2nd ` F ) P ) ` G ) ` A ) ) $=
            ( co cfv chom c2nd cmpt yonedalem4a fveq1d wceq eqidd cvv wcel ovex
            cv wa mptex adantr simpr oveq1d eleqtrrd fvex simplr oveq2d fveq12d
            a1i fvmptdv2 nfmpt1 nffvmpt1 nfcv nffv nfeq1 fvmptdf mpd eqtrd ) AS
            HERUEUAVIVJZVJZVJSHCFPCWAZUEGVKVJZVIZEPWAZUEXDRVLVJZVIZVJZVJZVMZVMZ
            VJZVJZESUEHXHVIZVJZVJZASXCXNAHXBXMABCDEFGIJKLMNOPQRTUAUBUCUDUEUFUGU
            HUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVNVOVOAXMXMVPXOXRVPZAXMVQAXSCH
            XLFXMVRVGXLVRVSAXDHVPZWBZPXFXKXDUEXEVTWCWLYAPSXKXRXFXNVRYASHUEXEVIZ
            XFASYBVSXTVHWDYAXDHUEXEAXTWEWFWGXKVRVSYAXGSVPZWBZEXJWHWLYDEXJXQYDXG
            SXIXPYDXDHUEXHAXTYCWIWJYAYCWEWKVOWMCFXLWNCXOXRCSXNCFXLHWOCSWPWQWRWS
            WTXA $.
        $}

        $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro,
           29-Jan-2017.) $)
        yonedalem4c $p |- ( ph ->
          ( ( F N X ) ` A ) e. ( ( ( 1st ` Y ) ` X ) ( O Nat S ) F ) ) $=
          ( vz vw vh vk co cfv c1st cnat wcel chom cixp c2nd cop wceq wral cmpt
          cv cco yonedalem4a weq oveq1 oveq2 fveq1d mpteq12dv cbvmptv syl6eq wa
          wf oppcbas eqid cfunc wbr wrel relfunc 1st2ndbr sylancr adantr funcf2
          simpr oppchom syl6eleqr ffvelrnd cvv chomf crn unssbd ssexd cbs eqidd
          funcf1 setcbas feq23d mpbird ad2antrr ffvelrnda elsetchom mpbid fmptd
          ccat yon11 yon1cl ralrimiva fvex ccom fveq2d 3ad2antr1 setcco syl2anc
          feq2d wb eqtrd wss yonedalem4b 3eqtr4d fveq2 fcompt eqeltri mptelixpg
          ax-mp sylibr eqeltrd simpr1 eleq2d biimpa simpr2 funcco oppcco simpr3
          w3a simplr3 3eqtr3d fvco3 syl6eleq yon12 cun catcocl syldan mpteq2dva
          ovex mptex fvmpt2 mpan2 sylan9eq feq1d feq123d rspcv sylc ralrimivvva
          isnat2 mpbir2and ) AEQUCSVIVJZUCUDVKVJVJZQTJVLVIZVIVMUVOVEFVEWAZUVPVK
          VJZVJZUVRQVKVJZVJZJVNVJZVIZVOZVMVFWAZUVOVJZVGWAZUVRUWFUVPVPVJZVIZVJZU
          VTUWFUVSVJZVQUWFUWAVJZJWBVJZVIVIZUWHUVRUWFQVPVJZVIZVJZUVRUVOVJZUVTUWB
          VQUWMUWNVIVIZVRZVGUVRUWFTVNVJZVIZVSVFFVSVEFVSAUVOVEFOUVRUCGVNVJZVIZEO
          WAZUCUVRUWPVIZVJZVJZVTZVTZUWEAUVOCFOCWAZUCUXDVIZEUXFUCUXLUWPVIZVJZVJZ
          VTZVTUXKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTV
          AVBVCVDWCCVEFUXQUXJCVEWDZOUXMUXPUXEUXIUXLUVRUCUXDWEUXREUXOUXHUXRUXFUX
          NUXGUXLUVRUCUWPWFWGWGWHWIWJZAUXJUWDVMZVEFVSZUXKUWEVMZAUXTVEFAUVRFVMZW
          KZUXTUVTUWBUXJWLZUYDUYEUXEUWBUXJWLUYDOUXEUXIUWBUXJUYDUXFUXEVMZWKZUCUW
          AVJZUWBEUXHUYGUXHUYHUWBUWCVIZVMUYHUWBUXHWLUYGUCUVRUXBVIZUYIUXFUXGUYDU
          YJUYIUXGWLZUYFUYDFTJUWAUWPUXBUWCUCUVRFGTUIUGWMZUXBWNZUWCWNZAUWAUWPTJW
          OVIZWPZUYCAUYOWQZQUYOVMZUYPTJWRZVAQUYOWSWTZXAAUCFVMZUYCVBXAZAUYCXCZXB
          XAUYGUXFUXEUYJUYDUYFXCGUXDTUCUVRUXDWNZUIXDZXEXFUYGJLUXHUWCXGUYHUWBUJU
          YDLXGVMZUYFAVUFUYCALUAUBURAHXHVJXIZLUAUTXJXKZXAZXAUYNAUYHLVMZUYCUYFAF
          LUCUWAAFLUWAWLZFJXLVJZUWAWLAFVULTJUWAUWPUYLVULWNZUYTXNAFLFVULUWAAFXMZ
          AJLXGUJVUHXOZXPXQZVBXFZXRUYDUWBLVMZUYFAFLUVRUWAVUPXSZXAXTYAAEUYHVMZUY
          CUYFVDXRXFUXJWNYBUYDUVTUXEUWBUXJUYDFGUXDUCUDUVRUFUGAGYCVMZUYCUQXAVUBV
          UDVUCYDYMXQZUYDJLUXJUWCXGUVTUWBUJVUIUYNAFLUVRUVSAFLUVSWLZFVULUVSWLAFV
          ULTJUVSUWIUYLVUMAUYQUVPUYOVMUVSUWIUYOWPZUYSAFGJLTXGUCUDUFUGUQVBUIUJVU
          HUSYEZUVPUYOWSWTZXNAFLFVULUVSVUNVUOXPXQZXSZVUSXTXQYFFXGVMUYBUYAYNFGXL
          VJXGUGGXLYGUUAVEFUXJUWDXGUUBUUCUUDUUEAUXAVEVFVGFFUXCAUYCUWFFVMZUWHUXC
          VMZUUMZWKZUWGUWKYHZUWRUWSYHZUWOUWTVVLVHUVTVHWAZUWKVJZUWGVJZVTZVHUVTVV
          OUWSVJZUWRVJZVTZVVMVVNVVLVHUVTVVQVVTVVLVVOUVTVMZVVOUXEVMZVVQVVTVRVVLV
          WBVWCVVLUVTUXEVVOVVLFGUXDUCUDUVRUFUGAVVAVVKUQXAZAVUAVVKVBXAZVUDAUYCVV
          IVVJUUFZYDUUGUUHVVLVWCWKZEVVOUWHUWFUVRVQUCGWBVJZVIVIZUCUWFUWPVIZVJZVJ
          ZEVVOUXGVJZVJZUWRVJZVVQVVTVWGVWLEUWRVWMYHZVJZVWOVWGEVWKVWPVWGUWHVVOUC
          UVRVQUWFTWBVJZVIVIZVWJVJUWRVWMUYHUWBVQUWMUWNVIVIVWKVWPVWGFTVWRJUWAUWP
          UXBVVOUWHUWNUCUVRUWFUYLUYMVWRWNUWNWNZVVLUYPVWCAUYPVVKUYTXAZXAVVLVUAVW
          CVWEXAZVVLUYCVWCVWFXAZVVLVVIVWCAUYCVVIVVJUUIZXAZVWGVVOUXEUYJVVLVWCXCZ
          VUEXEZUYCVVIVVJAVWCUUNZUUJVWGVWSVWIVWJVWGFGVWHVVOUWHTUCUVRUWFUGVWHWNZ
          UIVXBVXCVXEUUKYIVWGJUWNLVWMUWRXGUYHUWBUWMUJVVLVUFVWCAVUFVVKVUHXAZXAZV
          WTAVUJVVKVWCVUQXRZVVLVURVWCAVVIUYCVURVVJVUSYJZXAZVVLUWMLVMVWCVVLFLUWF
          UWAAVUKVVKVUPXAVXDXFZXAVWGVWMUYIVMUYHUWBVWMWLZVWGUYJUYIVVOUXGVVLUYKVW
          CVVLFTJUWAUWPUXBUWCUCUVRUYLUYMUYNVXAVWEVWFXBXAVXGXFVWGJLVWMUWCXGUYHUW
          BUJVXKUYNVXLVXNXTYAZVVLUWBUWMUWRWLZVWCVVLUWRUWBUWMUWCVIZVMVXRVVLUXCVX
          SUWHUWQVVLFTJUWAUWPUXBUWCUVRUWFUYLUYMUYNVXAVWFVXDXBAUYCVVIVVJUULZXFVV
          LJLUWRUWCXGUWBUWMUJVXJUYNVXMVXOXTYAZXAYKUUOWGVWGVXPVUTVWQVWOVRVXQAVUT
          VVKVWCVDXRZUYHUWBEUWRVWMUUPYLYOVWGVVQVWIUWGVJVWLVWGVVPVWIUWGVWGFGVWHU
          WHVVOUXDUWFUCUDUVRUFUGVVLVVAVWCVWDXAZVXBVUDVXCVXIVXEVWGUWHUXCUWFUVRUX
          DVIVXHGUXDTUVRUWFVUDUIXDUUQZVXFUURYIVWGBCDEFGUWFHIJKLMNOPQVWIRSTUAUBU
          CUDUEUFUGUHUIUJUKULUMUNUOUPVYCAUAUBVMVVKVWCURXRZAGXHVJXILYPVVKVWCUSXR
          ZAVUGLUUSUAYPVVKVWCUTXRZAUYRVVKVWCVAXRZVXBVCVYBVXEVWGFGVWHUWHVVOUXDUW
          FUVRUCUGVUDVXIVYCVXEVXCVXBVYDVXFUUTYQYOVWGVVSVWNUWRVWGBCDEFGUVRHIJKLM
          NOPQVVORSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVYCVYEVYFVYGVYHVXBVCVYBVXCV
          XFYQYIYRUVAUVBVVLUWLUWMUWGWLZUVTUWLUWKWLZVVMVVRVRVVLVVIUVTUWBUWSWLZVE
          FVSZVYIVXDAVYLVVKAVYKVEFUYDVYKUYEVVBUYDUVTUWBUWSUXJAUYCUWSUVRUXKVJZUX
          JAUVRUVOUXKUXSWGUYCUXJXGVMVYMUXJVROUXEUXIUVRUCUXDUVCUVDVEFUXJXGUXKUXK
          WNUVEUVFUVGUVHXQZYFXAVYKVYIVEUWFFVEVFWDUVTUWLUWBUWMUWSUWGUVRUWFUVOYSU
          VRUWFUVSYSUVRUWFUWAYSUVIUVJUVKZVVLUWKUVTUWLUWCVIZVMVYJVVLUXCVYPUWHUWJ
          VVLFTJUVSUWIUXBUWCUVRUWFUYLUYMUYNAVVDVVKVVFXAVWFVXDXBVXTXFVVLJLUWKUWC
          XGUVTUWLUJVXJUYNAVVIUYCUVTLVMVVJVVHYJZVVLFLUWFUVSAVVCVVKVVGXAVXDXFZXT
          YAZVHUWGUWKUVTUWLUWMYTYLVVLVXRVYKVVNVWAVRVYAAVVIUYCVYKVVJVYNYJZVHUWRU
          WSUVTUWBUWMYTYLYRVVLJUWNLUWKUWGXGUVTUWLUWMUJVXJVWTVYQVYRVXOVYSVYOYKVV
          LJUWNLUWSUWRXGUVTUWBUWMUJVXJVWTVYQVXMVXOVYTVYAYKYRUVLAVEVFUVOFTJUWNVG
          UVPQUXBUWCUVQUVQWNUYLUYMUYNVWTVVEVAUVMUVN $.
      $}

      yonedalem22.g $e |- ( ph -> G e. ( O Func S ) ) $.
      yonedalem22.p $e |- ( ph -> P e. B ) $.
      yonedalem22.a $e |- ( ph -> A e. ( F ( O Nat S ) G ) ) $.
      yonedalem22.k $e |- ( ph -> K e. ( P ( Hom ` C ) X ) ) $.
      $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro, 29-Jan-2017.) $)
      yonedalem22 $p |- ( ph ->
        ( A ( <. F , X >. ( 2nd ` Z ) <. G , P >. ) K ) =
        ( ( ( P ( 2nd ` Y ) X ) ` K ) ( <. ( ( 1st ` Y ) ` X ) , F >.
          ( 2nd ` H ) <. ( ( 1st ` Y ) ` P ) , G >. ) A ) ) $=
        ( cop c2nd cfv co c1st ctpos c2ndf ccofu c1stf fveq2i oveqi df-ov eqtri
        cprf cfunc cxpc coppc chom eqid fucbas oppcbas xpcbas ccat wcel oppccat
        cxp syl cvv chomf crn unssbd ssexd setccat fuccat 2ndfcl wbr wrel yoncl
        relfunc 1st2ndbr sylancr funcoppc df-br sylib cofucl 1stfcl prfcl hofcl
        unssad opelxpi syl2anc oppchom syl6eleqr fuchom xpchom2 eleqtrrd syl5eq
        cnat cofu2 prf1 cofu1 wceq fvex tposex op1st 2ndf1 op2ndg eqtrd fveq12d
        1stf1 op1stg opeq12d oveq12d cres fveq1d fvres 3eqtrd prf2 op2nd ovtpos
        a1i 2ndf2 1stf2 syl6eqr ) ABPMTVDZNEVDZUBVEVFZVGZVGZBPVDZUUHUUIUAVHVFZU
        AVEVFZVIZVDZFQVJVGZVKVGZFQVLVGZVQVGZVEVFVGVFZUUHUVAVHVFZVFZUUIUVCVFZOVE
        VFZVGZVFZPETUUOVGZVFZBTUUNVFZMVDZEUUNVFZNVDZUVFVGZVGZAUULUUMUUHUUIOUVAV
        KVGZVEVFZVGZVFZUVHUULBPUVSVGUVTUUKUVSBPUUJUVRUUHUUIUBUVQVEUMVMVNVNBPUVS
        VOVPAQHVRVGZCWIZFQVSVGZFVTVFZFVSVGZUUMIUVAOUWCWAVFZUUHUUIFQUWCUWACUWCWB
        ZQHFUIWCZCDQUFUDWDZWEZAUWCUWDUVAUWEFUUSUUTUVAWBZUWEWBAUWCQUWDUURUUQAFQU
        URUWCUWGAQHFUIADWFWGQWFWGUNDQUFWHWJZAJWKWGHWFWGAJRSUOAFWLVFWMZJRUQWNWOZ
        HJWKUGWPWJWQZUWLUURWBZWRZAUUNUUPQUWDVRVGZWSUUQUWRWGADFUWDUUNUUOQUFUWDWB
        ZADFVRVGZWTUAUWTWGUUNUUOUWTWSDFXBADFHJQWKUAUCUNUFUGUIUWNUPXAUAUWTXCXDXE
        UUNUUPUWRXFXGZXHZAFQUUTUWCUWGUWOUWLUUTWBZXIZXJAFIROUWDSUJUWSUHUWOUOAUWM
        JRUQXLXKAMUWAWGZTCWGZUUHUWBWGURUSMTUWACXMXNZANUWAWGZECWGZUUIUWBWGUTVANE
        UWACXMXNZUWFWBZAUUMMNQHYAVGZVGZTEQWAVFZVGZWIZUUHUUIUWFVGZABUXMWGZPUXOWG
        UUMUXPWGVBAPETDWAVFZVGZUXOVCDUXSQTEUXSWBUFXOXPBPUXMUXOXMXNAFQNEUWCUXLUX
        NUWFMTUWACUWGUWHUWIQHFUXLUIUXLWBXQUXNWBURUSUTVAUXKXRXSZYBXTAUVHUVJBVDZU
        VOVFUVPAUVBUYBUVGUVOAUVDUVLUVEUVNUVFAUVDUUHUUSVHVFZVFZUUHUUTVHVFZVFZVDU
        VLAUWBUWCUWDUVAFUUSUUTUWFUUHUWKUWJUXKUXBUXDUXGYCAUYDUVKUYFMAUYDUUHUURVH
        VFZVFZUUQVHVFZVFUVKAUWBUWCQUWDUURUUQUUHUWJUWQUXAUXGYDAUYHTUYIUUNUYIUUNY
        EAUUNUUPUAVHYFZUUOUAVEYFYGZYHUUDZAUYHUUHVEVFZTAUWBFQUURUUHUWCUWFUWGUWJU
        XKUWOUWLUWPUXGYIAUXEUXFUYMTYEURUSMTUWACYJXNYKZYLYKAUYFUUHVHVFZMAUWBFQUU
        TUUHUWCUWFUWGUWJUXKUWOUWLUXCUXGYMAUXEUXFUYOMYEURUSMTUWACYNXNYKYOYKAUVEU
        UIUYCVFZUUIUYEVFZVDUVNAUWBUWCUWDUVAFUUSUUTUWFUUIUWKUWJUXKUXBUXDUXJYCAUY
        PUVMUYQNAUYPUUIUYGVFZUYIVFUVMAUWBUWCQUWDUURUUQUUIUWJUWQUXAUXJYDAUYREUYI
        UUNUYLAUYRUUIVEVFZEAUWBFQUURUUIUWCUWFUWGUWJUXKUWOUWLUWPUXJYIAUXHUXIUYSE
        YEUTVANEUWACYJXNYKZYLYKAUYQUUIVHVFZNAUWBFQUUTUUIUWCUWFUWGUWJUXKUWOUWLUX
        CUXJYMAUXHUXIVUANYEUTVANEUWACYNXNYKYOYKYPAUVBUUMUUHUUIUUSVEVFVGVFZUUMUU
        HUUIUUTVEVFVGZVFZVDUYBAUWBUWCUWDUVAFUUSUUTUWFUUMUUHUUIUWKUWJUXKUXBUXDUX
        GUXJUYAUUAAVUBUVJVUDBAVUBUUMUUHUUIUURVEVFVGZVFZUYHUYRUUQVEVFZVGZVFUVJAU
        WBUWCQUUMUWDUURUUQUWFUUHUUIUWJUWQUXAUXGUXJUXKUYAYBAVUFPVUHUVIAVUHUYRUYH
        UUOVGZUVIVUHUYHUYRUUPVGVUIVUGUUPUYHUYRUUNUUPUYJUYKUUBVNUYHUYRUUOUUCVPAU
        YREUYHTUUOUYTUYNYPXTAVUFUUMVEUXQYQZVFZUUMVEVFZPAUUMVUEVUJAUWBFQUURUUHUU
        IUWCUWFUWGUWJUXKUWOUWLUWPUXGUXJUUEYRAUUMUXQWGZVUKVULYEUYAUUMUXQVEYSWJAU
        XRPUXTWGZVULPYEVBVCBPUXMUXTYJXNYTYLYKAVUDUUMVHUXQYQZVFZUUMVHVFZBAUUMVUC
        VUOAUWBFQUUTUUHUUIUWCUWFUWGUWJUXKUWOUWLUXCUXGUXJUUFYRAVUMVUPVUQYEUYAUUM
        UXQVHYSWJAUXRVUNVUQBYEVBVCBPUXMUXTYNXNYTYOYKYLUVJBUVOVOUUGYK $.

      yonedalem3.m $e |- M = ( f e. ( O Func S ) , x e. B |->
        ( a e. ( ( ( 1st ` Y ) ` x ) ( O Nat S ) f ) |->
          ( ( a ` x ) ` ( .1. ` x ) ) ) ) $.
      $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro, 29-Jan-2017.) $)
      yonedalem3b $p |- ( ph -> ( ( G M P )
         ( <. ( F ( 1st ` Z ) X ) , ( G ( 1st ` Z ) P ) >.
              ( comp ` T ) ( G ( 1st ` E ) P ) )
         ( A ( <. F , X >. ( 2nd ` Z ) <. G , P >. ) K ) ) =
       ( ( A ( <. F , X >. ( 2nd ` E ) <. G , P >. ) K )
          ( <. ( F ( 1st ` Z ) X ) , ( F ( 1st ` E ) X ) >.
              ( comp ` T ) ( G ( 1st ` E ) P ) ) ( F M X ) ) ) $=
        ( vb vy co cop c2nd cfv ccom c1st cnat cv cmpt wceq oveq2 oveq1d fveq1d
        cco cbvmptv wcel wa eqid oppcbas chom wrel wbr relfunc 1st2ndbr sylancr
        cvv funcf2 ffvelrnd adantr fuccoval wf cbs funcf1 setcbas feq23d mpbird
        cfunc nat1st2nd natcl elsetchom mpbid setcco eqtrd syl2anc 3eqtrd yon11
        eleqtrrd catidcl fvco3 ccat fveq2d 3eqtr3d simpld opelxpi df-ov oveq12i
        wral cxp eqcomi a1i fovrnd yonedalem21 feq123d fmpt yonedalem3a fmptcof
        syl sylibr simprd 3eqtr4d fuchom chomf unssbd ssexd yoncl simpr fuccocl
        crn fucbas eqidd fco yon2 catrid oppchom syl6eleqr yon12 catlid 3eqtr2d
        nati mpteq2dva syl5eq cxpc xpcbas yonedalem1 xpchom2 xpeq2i yonedalem22
        syl6eq oppccat setccat fuccat hof2val fveq1 evlf2val coeq1d evlf1 fveq2
        fcompt ) APFSVKZCROUCVLZPFVLZUEVMVNZVKZVKZVOZCRUVTUWANVMVNZVKZVKZOUCSVK
        ZVOZUVSUWDOUCUEVPVNZVKZPFUWKVKZVLPFNVPVNZVKZJWDVNZVKVKUWHUWIUWLOUCUWNVK
        ZVLUWOUWPVKVKAVIUCUDVPVNZVNZOTIVQVKZVKZFLVNZFCVIVRZUWSOVLZPGWDVNZVKZVKZ
        RFUCUDVMVNZVKZVNZFUWRVNZUWSVLPUXEVKZVKZVNZVNZVSZUFUXAUCLVNZUCUFVRZVNZVN
        ZRUCFOVMVNZVKZVNZVNZFCVNZVNZVSZUWEUWJAUXPUFUXAUXBFCUXRUXFVKZUXJUXLVKZVN
        ZVNZVSUYGVIUFUXAUXOUYKUXCUXRVTZUXBUXNUYJUYLFUXMUYIUYLUXGUYHUXJUXLUXCUXR
        CUXFWAWBWCWCWEAUFUXAUYKUYFAUXRUXAWFZWGZUYKUXBUYEFUXRVNZVOZFUXJVNZVOZVNZ
        UXBUYQVNZUYPVNZUYFUYNUXBUYJUYRUYNUYJFUYHVNZUYQFUXKVPVNZVNZFUWSVPVNZVNZV
        LFPVPVNZVNZIWDVNZVKZVKUYPUYQVUJVKUYRUYNDTIGUXJUYHUXEVUIUXKUWSPUWTFUMUWT
        WHZDETUJUHWIZVUIWHZUXEWHZAUXJUXKUWSUWTVKZWFUYMAFUCEWJVNZVKZVUORUXIADEGU
        WRUXHVUPUWTFUCUHVUPWHZTIGUWTUMVUKUUAZAEGXGVKZWKUDVUTWFUWRUXHVUTWLEGWMAE
        GIKTWPUDUGURUJUKUMAKUAUBUSAGUUBVNUUHKUAVAUUCUUDZUTUUEUDVUTWNWOZVEVCWQVG
        WRZWSUYNTIGUXRCUXEUWSOPUWTUMVUKVUNAUYMUUFZACOPUWTVKZWFUYMVFWSZUUGAFDWFZ
        UYMVEWSZWTUYNVUBUYPUYQVUJUYNVUBUYEUYOVUFFOVPVNZVNZVLVUHVUIVKVKUYPUYNDTI
        GUXRCUXEVUIUWSOPUWTFUMVUKVULVUMVUNVVDVVFVVHWTUYNIVUIKUYOUYEWPVUFVVJVUHU
        KAKWPWFZUYMVVAWSZVUMAVUFKWFUYMADKFVUEADKVUEXADIXBVNZVUEXAADVVMTIVUEUWSV
        MVNZVULVVMWHZATIXGVKZWKZUWSVVPWFVUEVVNVVPWLTIWMZADVVPUCUWRADVVPEGUWRUXH
        UHTIGUMUUIZVVBXCZVCWRZUWSVVPWNWOZXCADKDVVMVUEADUUJZAIKWPUKVVAXDZXEXFZVE
        WRZWSZAVVJKWFUYMADKFVVIADKVVIXADVVMVVIXAADVVMTIVVIUYAVULVVOAVVQOVVPWFZV
        VIUYAVVPWLVVRVBOVVPWNWOZXCADKDVVMVVIVWCVWDXEXFZVEWRZWSZAVUHKWFUYMAVUHVV
        MKADVVMFVUGADVVMTIVUGPVMVNZVULVVOAVVQPVVPWFZVUGVWMVVPWLVVRVDPVVPWNWOXCV
        EWRVWDXQZWSZUYNUYOVUFVVJIWJVNZVKWFVUFVVJUYOXAZUYNUXRDTIVUEVVNVWQVVIUYAU
        WTFVUKUYNUXRTIUWSOUWTVUKVVDXHZVULVWQWHZVVHXIUYNIKUYOVWQWPVUFVVJUKVVLVWT
        VWGVWLXJXKZAVVJVUHUYEXAZUYMAUYEVVJVUHVWQVKWFVXBACDTIVVIUYAVWQVUGVWMUWTF
        VUKACTIOPUWTVUKVFXHVULVWTVEXIAIKUYEVWQWPVVJVUHUKVVAVWTVWKVWOXJXKZWSZXLX
        MWBUYNIVUIKUYQUYPWPVUDVUFVUHUKVVLVUMAVUDKWFUYMAVUDVVMKADVVMFVUCADVVMTIV
        UCUXKVMVNZVULVVOAVVQUXKVVPWFVUCVXEVVPWLVVRADVVPFUWRVVTVEWRZUXKVVPWNWOXC
        VEWRVWDXQZWSVWGVWPAVUDVUFUYQXAZUYMAUYQVUDVUFVWQVKWFVXHAUXJDTIVUCVXEVWQV
        UEVVNUWTFVUKAUXJTIUXKUWSUWTVUKVVCXHVULVWTVEXIAIKUYQVWQWPVUDVUFUKVVAVWTV
        XGVWFXJXKWSZUYNVXBVWRVUFVUHUYPXAVXDVXAVUFVVJVUHUYEUYOUUKXNXLXOWCUYNVXHU
        XBVUDWFZUYSVUAVTVXIAVXJUYMAUXBFFVUPVKZVUDADELVUPFUHVURUIURVEXRZADEVUPFU
        DFUGUHURVEVURVEXPXQWSZVUDVUFUXBUYPUYQXSXNUYNVUAUYTUYOVNZUYEVNZUYFUYNVWR
        UYTVUFWFVUAVXOVTVXAUYNVUDVUFUXBUYQVXIVXMWRVUFVVJUYTUYEUYOXSXNUYNVXNUYDU
        YEUYNVXNRUYOVNZUXQUYCUXSVOZVNZUYDUYNUYTRUYOUYNUYTRUXBFFVLUCEWDVNZVKVKRU
        YNDEVXSRUXBVUPFFUDUCUGUHAEXTWFZUYMURWSZVVHVURAUCDWFZUYMVCWSZVXSWHZVVHAR
        VUQWFUYMVGWSZAUXBVXKWFUYMVXLWSUULUYNDEVXSLRVUPFUCUHVURUIVYAVVHVYDVYCVYE
        UUMXMYAUYNUXQUYORUCFVVNVKZVNZVOZVNZUXQVYGVNZUYOVNZVXRVXPUYNUCVUEVNZVUFV
        YGXAZUXQVYLWFZVYIVYKVTAVYMUYMAVYGVYLVUFVWQVKZWFVYMAUCFTWJVNZVKZVYORVYFA
        DTIVUEVVNVYPVWQUCFVULVYPWHZVWTVWBVCVEWQARVUQVYQVGEVUPTUCFVURUJUUNZUUOZW
        RAIKVYGVWQWPVYLVUFUKVVAVWTADKUCVUEVWEVCWRZVWFXJXKWSZAVYNUYMAUXQUCUCVUPV
        KZVYLADELVUPUCUHVURUIURVCXRZADEVUPUCUDUCUGUHURVCVURVCXPXQWSZVYLVUFUXQUY
        OVYGXSXNUYNUXQVYHVXQUYNUYOVYGVYLVUFVLVVJVUIVKVKUYCUXSVYLUCVVIVNZVLVVJVU
        IVKVKVYHVXQUYNUXRDTIRVUIVUEVVNVYPVVIUYAUWTUCFVUKVWSVULVYRVUMVYCVVHARVYQ
        WFUYMVYTWSUUSUYNIVUIKVYGUYOWPVYLVUFVVJUKVVLVUMAVYLKWFUYMWUAWSZVWGVWLWUB
        VXAXLUYNIVUIKUXSUYCWPVYLWUFVVJUKVVLVUMWUGAWUFKWFUYMADKUCVVIVWJVCWRZWSZV
        WLUYNUXSVYLWUFVWQVKWFVYLWUFUXSXAZUYNUXRDTIVUEVVNVWQVVIUYAUWTUCVUKVWSVUL
        VWTVYCXIUYNIKUXSVWQWPVYLWUFUKVVLVWTWUGWUIXJXKZAWUFVVJUYCXAZUYMAUYCWUFVV
        JVWQVKZWFWULAVYQWUMRUYBADTIVVIUYAVYPVWQUCFVULVYRVWTVWIVCVEWQVYTWRAIKUYC
        VWQWPWUFVVJUKVVAVWTWUHVWKXJXKZWSXLYBWCUYNVYJRUYOUYNVYJUXQRFUCVLUCVXSVKV
        KRUYNDEVXSRUXQVUPFUCUDUCUGUHVYAVYCVURVYCVYDVVHVYEAUXQWUCWFUYMWUDWSUUPUY
        NDEVXSLRVUPFUCUHVURUIVYAVVHVYDVYCVYEUUQXMYAYBUYNWUJVYNVXRUYDVTWUKWUEVYL
        WUFUXQUYCUXSXSXNUURYAXMXOUUTUVAAVIUFUXAUXKPUWTVKZUXMUXBUYOVNZUXOUWDUVSA
        UXAWUOVIUXAUXMVSZXAZUXMWUOWFVIUXAYGAUWLUWMUWDXAZWURAUWDUWLUWMJWJVNZVKZW
        FWUSACRWVAVVEVUQUWCAUVTUWAGTUVBVKZWJVNZVKZUVTUWKVNZUWAUWKVNZWUTVKZUWCXA
        VVEVUQYHZWVAUWCXAAVVPDYHZWVBJUWKUWBWVCWUTUVTUWAGTWVBVVPDWVBWHZVVSVULUVC
        ZWVCWHZWUTWHZAWVBJXGVKZWKZUEWVNWFZUWKUWBWVNWLWVBJWMZAWVPNWVNWFZADEGHIJK
        LNQTUAUBUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAUVDZYCUEWVNWNWOZAVWHVYBUVTWVI
        WFVBVCOUCVVPDYDXNZAVWNVVGUWAWVIWFVDVEPFVVPDYDXNZWQAWVDWVGWVHWVAUWCAWVDV
        VEVYQYHWVHAGTPFWVBUWTVYPWVCOUCVVPDWVJVVSVULVUSVYRVBVCVDVEWVLUVEVYQVUQVV
        EVYSUVFUVHZWVGWVAVTAWVAWVGUWLWVEUWMWVFWUTOUCUWKYEPFUWKYEYFYIYJXEXKVFVGY
        KAJUAUWDWUTUBUWLUWMULUSWVMAUWLJXBVNZUAAOUCWWDVVPDUWKAWVIWWDWVBJUWKUWBWV
        KWWDWHZWVTXCZVBVCYKAJUAUBULUSXDZXQZAUWMWWDUAAPFWWDVVPDUWKWWFVDVEYKWWGXQ
        ZXJXKZAUWLUXAUWMWUOUWDWUQAUWDUXJCUXDUXKPVLQVMVNVKVKWUQACDEFGHIJKLNOPQRT
        UAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGUVGAVVPGUXEVIUXJCUW
        TQPUWSOUXKUNATIGUMAVXTTXTWFURETUJUVIYQZAVVKIXTWFVVAIKWPUKUVJYQZUVKVVSVU
        SVWAVBVXFVDVUNVVCVFUVLXMZADEGHIJKLNOQTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQU
        RUSUTVAVBVCYLZADEGHIJKLNPQTUAUBFUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVDVEY
        LYMXKVIUXAWUOUXMWUQWUQWHYNYRWWMAUVSUFWUOWUPVSVTZUWMUWOUVSXAZABDEGHIJKLM
        NPQSTUAUBFUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVDVEVHYOZYCUXRUXMVTUXBUYO
        UXNFUXRUXMUVMWCYPAUWJUYEUYCVOZUWIVOUYGAUWHWWRUWIAUWHUYEUYCWUFVVJVLVUHVU
        IVKVKWWRACDTIVUINOPVYPRUWGUWTUCFUPWWKWWLVULVYRVUMVUKVBVDVCVEUWGWHVFVYTU
        VNAIVUIKUYCUYEWPWUFVVJVUHUKVVAVUMWUHVWKVWOWUNVXCXLXMUVOAUFVJUXAWUFUXTVJ
        VRZUYCVNZUYEVNZUYFUWIWWRAUXAWUFUFUXAUXTVSZXAZUXTWUFWFUFUXAYGAUWLUWQUWIX
        AZWXCAUWIWXBVTZWXDABDEGHIJKLMNOQSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURU
        SUTVAVBVCVHYOZYSZAUWLUXAUWQWUFUWIWXBAWXEWXDWXFYCZWWNADTINOUCUPWWKWWLVUL
        VBVCUVPYMXKUFUXAWUFUXTWXBWXBWHYNYRWXHAVXBWULWWRVJWUFWXAVSVTVXCWUNVJUYEU
        YCWUFVVJVUHUVRXNWWSUXTVTWWTUYDUYEWWSUXTUYCUVQYAYPXMYTAJUWPUAUWDUVSUBUWL
        UWMUWOULUSUWPWHZWWHWWIAUWOWWDUAAPFWWDVVPDUWNAWVIWWDWVBJUWNUWFWVKWWEAWVO
        WVRUWNUWFWVNWLWVQAWVPWVRWVSYSNWVNWNWOZXCZVDVEYKWWGXQZWWJAWWOWWPWWQYSXLA
        JUWPUAUWIUWHUBUWLUWQUWOULUSWXIWWHAUWQWWDUAAOUCWWDVVPDUWNWXKVBVCYKWWGXQZ
        WXLWXGAUWHUWQUWOWUTVKZWFUWQUWOUWHXAACRWXNVVEVUQUWGAWVDUVTUWNVNZUWAUWNVN
        ZWUTVKZUWGXAWVHWXNUWGXAAWVIWVBJUWNUWFWVCWUTUVTUWAWVKWVLWVMWXJWWAWWBWQAW
        VDWXQWVHWXNUWGWWCWXQWXNVTAWXNWXQUWQWXOUWOWXPWUTOUCUWNYEPFUWNYEYFYIYJXEX
        KVFVGYKAJUAUWHWUTUBUWQUWOULUSWVMWXMWXLXJXKXLYT $.
    $}

    yoneda.m $e |- M = ( f e. ( O Func S ) , x e. B |->
      ( a e. ( ( ( 1st ` Y ) ` x ) ( O Nat S ) f ) |->
        ( ( a ` x ) ` ( .1. ` x ) ) ) ) $.
    $( Lemma for ~ yoneda .  (Contributed by Mario Carneiro, 28-Jan-2017.) $)
    yonedalem3 $p |- ( ph -> M e. ( Z ( ( Q Xc. O ) Nat T ) E ) ) $=
      ( vz vw vg vy cxpc co cnat wcel cfunc cxp c1st cfv chom cixp c2nd cop cco
      cv wceq wral wfn cmpt ovex mptex fnmpt2i a1i wa ccat adantr chomf crn wss
      wf cun simprl simprr yonedalem3a simprd cbs fucbas oppcbas xpcbas relfunc
      eqid wrel wbr yonedalem1 simpld 1st2ndbr sylancr fovrnda setcbas eleqtrrd
      funcf1 mpbird ralrimivva fveq2 df-ov syl6eqr oveq12d eleq12d ralxp sylibr
      elsetchom cmpt2 cvv fvex eqeltri mpt2ex elixp sylanbrc simpr1 xp1st xp2nd
      w3a syl simpr2 simpr3 fuchom 1st2nd2 fveq2d opeq12d fveq12d oveq123d
      xpchom oppchom xpeq2i syl6eq eleqtrd yonedalem3b 3eqtr4d isnat2 mpbir2and
      ralrimivvva ) ANSLEOVAVBZHVCVBZVBVDNUQOGVEVBZCVFZUQVNZSVGVHZVHZUUOLVGVHZV
      HZHVIVHZVBZVJVDZURVNZNVHZUSVNZUUOUVCSVKVHZVBZVHZUUQUVCUUPVHZVLZUVCUURVHZH
      VMVHZVBZVBZUVEUUOUVCLVKVHZVBZVHZUUONVHZUUQUUSVLZUVKUVLVBZVBZVOZUSUUOUVCUU
      KVIVHZVBZVPURUUNVPUQUUNVPANUUNVQZUVRUVAVDZUQUUNVPZUVBUWEAKBUUMCTBVNZRVGVH
      ZVHZKVNZOGVCVBZVBZUWHJVHUWHTVNZVHVHZVRZNUPTUWMUWOUWJUWKUWLVSVTWAWBAUVEUTV
      NZNVBZUVEUWQUUPVBZUVEUWQUURVBZUUTVBZVDZUTCVPUSUUMVPUWGAUXBUSUTUUMCAUVEUUM
      VDZUWQCVDZWCZWCZUXBUWSUWTUWRWIZUXFUWRTUWQUWIVHUVEUWLVBUWQJVHUWQUWNVHVHVRV
      OUXGUXFBCDEFGHIJKLUVEMNOPQUWQRSTUAUBUCUDUEUFUGUHUIUJUKADWDVDZUXEULWEAPQVD
      ZUXEUMWEZADWFVHWGIWHZUXEUNWEAEWFVHWGIWJPWHZUXEUOWEAUXCUXDWKAUXCUXDWLUPWMW
      NUXFHPUWRUUTQUWSUWTUFUXJUUTWTZUXFUWSHWOVHZPAUVEUWQUXNUUMCUUPAUUNUXNUUKHUU
      PUVFEOUUKUUMCUUKWTZOGEUGWPCDOUDUBWQWRZUXNWTZAUUKHVEVBZXAZSUXRVDZUUPUVFUXR
      XBUUKHWSZAUXTLUXRVDZACDEFGHIJLMOPQRSUAUBUCUDUEUFUGUHUIUJUKULUMUNUOXCZXDZS
      UXRXEXFXJXGUXFHPQUFUXJXHZXIUXFUWTUXNPAUVEUWQUXNUUMCUURAUUNUXNUUKHUURUVOUX
      PUXQAUXSUYBUURUVOUXRXBUYAAUXTUYBUYCWNZLUXRXEXFXJXGUYEXIXTXKXLUWFUXBUQUSUT
      UUMCUUOUVEUWQVLZVOZUVRUWRUVAUXAUYHUVRUYGNVHUWRUUOUYGNXMUVEUWQNXNXOUYHUUQU
      WSUUSUWTUUTUYHUUQUYGUUPVHUWSUUOUYGUUPXMUVEUWQUUPXNXOUYHUUSUYGUURVHUWTUUOU
      YGUURXMUVEUWQUURXNXOXPXQXRXSUQUUNUVANNKBUUMCUWPYAYBUPKBUUMCUWPOGVEVSCDWOV
      HYBUBDWOYCYDYEYDYFYGAUWBUQURUSUUNUUNUWDAUUOUUNVDZUVCUUNVDZUVEUWDVDZYKZWCZ
      UVCVGVHZUVCVKVHZNVBZUVEVGVHZUVEVKVHZUUOVGVHZUUOVKVHZVLZUYNUYOVLZUVFVBZVBZ
      UYSUYTUUPVBZUYNUYOUUPVBZVLZUYNUYOUURVBZUVLVBZVBUYQUYRVUAVUBUVOVBZVBZUYSUY
      TNVBZVUEUYSUYTUURVBZVLZVUHUVLVBZVBUVNUWAUYMBUYQCDUYOEFGHIJKLUYSUYNMUYRNOP
      QUYTRSTUAUBUCUDUEUFUGUHUIUJUKAUXHUYLULWEAUXIUYLUMWEAUXKUYLUNWEAUXLUYLUOWE
      UYMUYIUYSUUMVDAUYIUYJUYKYHZUUOUUMCYIYLUYMUYIUYTCVDVUPUUOUUMCYJYLUYMUYJUYN
      UUMVDAUYIUYJUYKYMZUVCUUMCYIYLUYMUYJUYOCVDVUQUVCUUMCYJYLUYMUVEUYSUYNUWLVBZ
      UYOUYTDVIVHZVBZVFZVDZUYQVURVDUYMUVEUWDVVAAUYIUYJUYKYNUYMUWDVURUYTUYOOVIVH
      ZVBZVFVVAUYMUUNEOUUKUWLVVCUWCUUOUVCUXOUXPOGEUWLUGUWLWTYOVVCWTUWCWTZVUPVUQ
      UUAVVDVUTVURDVUSOUYTUYOVUSWTUDUUBUUCUUDUUEZUVEVURVUTYIYLUYMVVBUYRVUTVDVVF
      UVEVURVUTYJYLUPUUFUYMUVDUYPUVHVUDUVMVUIUYMUVJVUGUVKVUHUVLUYMUUQVUEUVIVUFU
      YMUUQVUAUUPVHVUEUYMUUOVUAUUPUYMUYIUUOVUAVOVUPUUOUUMCYPYLZYQUYSUYTUUPXNXOZ
      UYMUVIVUBUUPVHVUFUYMUVCVUBUUPUYMUYJUVCVUBVOVUQUVCUUMCYPYLZYQUYNUYOUUPXNXO
      YRUYMUVKVUBUURVHVUHUYMUVCVUBUURVVIYQUYNUYOUURXNXOZXPUYMUVDVUBNVHUYPUYMUVC
      VUBNVVIYQUYNUYONXNXOUYMUVHUYQUYRVLZVUCVHVUDUYMUVEVVKUVGVUCUYMUUOVUAUVCVUB
      UVFVVGVVIXPUYMVVBUVEVVKVOVVFUVEVURVUTYPYLZYSUYQUYRVUCXNXOYTUYMUVQVUKUVRVU
      LUVTVUOUYMUVSVUNUVKVUHUVLUYMUUQVUEUUSVUMVVHUYMUUSVUAUURVHVUMUYMUUOVUAUURV
      VGYQUYSUYTUURXNXOYRVVJXPUYMUVQVVKVUJVHVUKUYMUVEVVKUVPVUJUYMUUOVUAUVCVUBUV
      OVVGVVIXPVVLYSUYQUYRVUJXNXOUYMUVRVUANVHVULUYMUUOVUANVVGYQUYSUYTNXNXOYTUUG
      UUJAUQURNUUNUUKHUVLUSSLUWCUUTUULUULWTUXPVVEUXMUVLWTUYDUYFUUHUUI $.

    ${
      yonedainv.i $e |- I = ( Inv ` R ) $.
      yonedainv.n $e |- N =
        ( f e. ( O Func S ) , x e. B |-> ( u e. ( ( 1st ` f ) ` x ) |->
          ( y e. B |-> ( g e. ( y ( Hom ` C ) x ) |->
            ( ( ( x ( 2nd ` f ) y ) ` g ) ` u ) ) ) ) ) $.
      $( The Yoneda Lemma with explicit inverse.  (Contributed by Mario
         Carneiro, 29-Jan-2017.) $)
      yonedainv $p |- ( ph -> M ( Z I E ) N ) $=
        ( vz vh vw vb vk cfunc co cv cfv cmpt cnat eqid wcel simpld simprd c1st
        wbr wral wa wceq wf ccom cid cres ccat adantr chomf crn wss yonedalem3a
        simplrl simplrr simpr yonedalem4c wfn chom c2nd cbs cvv fvex weq fveq2d
        mptex simplr eqidd fveq1d mpteq12dv mpteq2dva adantl dffn5 sylib mpbird
        syl fcompt syl2anc eleq2d biimpa wrel relfunc 1st2ndbr sylancr ad2antrr
        ffvelrnda funcf1 setcbas feq23d ffvelrnd 3eqtr3d 3eqtrd eqtrd mpbid cop
        elsetchom natcl fveq2 df-ov syl6eqr cxp cxpc cinv fucbas oppcbas xpcbas
        yonedalem1 yonedalem3 wf1o cun simprl simprr fmptd eqeltri fnmpti simpl
        ccnv fveq12d oveq2d simpll oveq123d ovmpt2a fneq1d mpbiri oppccat ssexd
        unssbd setccat evlf1 yonedalem21 feq123d a1i fmpt2d fveq1 fvmpt catidcl
        yonedalem4b funcid oppcid setcid fvresi syldan mptresid nat1st2nd natfn
        ccid syl6eq yon11 cco syl6eleqr nati yoncl funcf2 setcco eleqtrrd fvco3
        oppchom yon12 catlid eqtr3d feqmptd 3eqtr4d eqfnfvd fcof1o eqcom anbi2i
        syl22anc fovrnda setcinv oveq12d breq123d ralxp sylibr r19.21bi fnmpt2i
        ralrimivva invfuc mpbi syl6breqr ) ARVDTIVIVJZEUUAZVDVKZSVLZVMZSUDOQVJA
        VDUYAGTUUBVJZJHRUDOQJUUCVLZUYEJVNVJZUYCUNGTUYEUXTEUYEVOTIGULUUDZEFTUIUG
        UUEZUUFZUYGVOAUDUYEJVIVJZVPZOUYKVPZAEFGHIJKLOPTUAUBUCUDUFUGUHUIUJUKULUM
        UNUOUPUQURUSUTUUGZVQZAUYLUYMUYNVRZVBUYFVOZABEFGHIJKLMOPRTUAUBUCUDUEUFUG
        UHUIUJUKULUMUNUOUPUQURUSUTVAUUHAUYBRVLZUYCUYBUDVSVLZVLZUYBOVSVLZVLZUYFV
        JZVTZVDUYAAVEVKZVFVKZRVJZVUEVUFSVJZVUEVUFUYSVJZVUEVUFVUAVJZUYFVJZVTZVFE
        WAVEUXTWAVUDVDUYAWAAVULVEVFUXTEAVUEUXTVPZVUFEVPZWBZWBZVULVUIVUJVUGUUIZV
        UHVUGUUQZWCZWBZVUPVUQVURVUHWCZWBZVUTVUPVUIVUJVUGWDZVUJVUIVUHWDZVUGVUHWE
        ZWFVUJWGZWCVUHVUGWEZWFVUIWGZWCVVBVUPVUGUEVUFUCVSVLZVLZVUETIVNVJZVJZVUFL
        VLZVUFUEVKZVLZVLZVMZWCZVVCVUPBEFGHIJKLMOVUEPRTUAUBVUFUCUDUEUFUGUHUIUJUK
        ULUMUNUOUPAFWHVPZVUOUQWIZAUAUBVPZVUOURWIZAFWJVLWKKWLZVUOUSWIZAGWJVLWKZK
        UUJUAWLZVUOUTWIZAVUMVUNUUKZAVUMVUNUULZVAWMVRZVUPVVDVUFVUEVSVLZVLZVVLVGV
        WLVGVKZVUHVLZVMZWDVUPVGVWLVWNVVLVWOVUPVWMVWLVPZWBZBCDVWMEFGHIJKLMNOVUEP
        STUAUBVUFUCUDUFUGUHUIUJUKULUMUNUOUPVUPVVSVWPVVTWIVUPVWAVWPVWBWIVUPVWCVW
        PVWDWIVUPVWFVWPVWGWIAVUMVUNVWPWNAVUMVUNVWPWOVCVUPVWPWPWQZVWOVOUUMVUPVUJ
        VWLVUIVVLVUHVWOVUPVUHVWLWRZVUHVWOWCVUPVWSDVWLCENCVKZVUFFWSVLZVJZDVKZNVK
        ZVUFVWTVUEWTVLZVJZVLZVLZVMZVMZVMZVWLWRDVWLVXJVXKCEVXIEFXAVLXBUGFXAXCUUN
        XFVXKVOUUOVUPVWLVUHVXKVUOVUHVXKWCAMBVUEVUFUXTEDBVKZMVKZVSVLZVLZCENVWTVX
        LVXAVJZVXCVXDVXLVWTVXMWTVLZVJZVLZVLZVMZVMZVMZVXKSMVEXDZBVFXDZWBZDVXOVYB
        VWLVXJVYFVXLVUFVXNVWKVYFVXMVUEVSVYDVYEUUPXEVYDVYEWPUURVYFCEVYAVXIVYFVWT
        EVPZWBZNVXPVXTVXBVXHVYHVXLVUFVWTVXAVYDVYEVYGXGZUUSVYHVXCVXSVXGVYHVXDVXR
        VXFVYHVXLVUFVWTVWTVXQVXEVYHVXMVUEWTVYDVYEVYGUUTXEVYIVYHVWTXHUVAXIXIXJXK
        XJVCDVWLVXJVUFVWKXCXFUVBXLUVCUVDVGVWLVUHXMXNZVUPETIOVUEVUFUOATWHVPZVUOA
        VVSVYKUQFTUIUVEXPWIAIWHVPZVUOAKXBVPZVYLAKUAUBURAVWEKUAUTUVGUVFZIKXBUJUV
        HXPWIUYIVWHVWIUVIZVUPEFGHIJKLOVUEPTUAUBVUFUCUDUFUGUHUIUJUKULUMUNUOUPVVT
        VWBVWDVWGVWHVWIUVJZUVKXOZVUPVVEVHVUJVHVKZVUHVLZVUGVLZVMZVVFVUPVVCVVDVVE
        WUAWCVWJVYQVHVUGVUHVUJVUIVUJXQXRVUPWUAVHVUJVYRVMVVFVUPVHVUJVYTVYRVUPVYR
        VUJVPZVYRVWLVPZVYTVYRWCVUPWUBWUCVUPVUJVWLVYRVYOXSXTVUPWUCWBZVYTVYSVVQVL
        ZVVMVUFVYSVLZVLZVYRWUDVYSVUGVVQWUDVVRVVCWUDBEFGHIJKLMOVUEPRTUAUBVUFUCUD
        UEUFUGUHUIUJUKULUMUNUOUPVUPVVSWUCVVTWIZVUPVWAWUCVWBWIZVUPVWCWUCVWDWIZVU
        PVWFWUCVWGWIZAVUMVUNWUCWNZAVUMVUNWUCWOZVAWMVQXIWUDVYSVVLVPWUEWUGWCVUPVW
        LVVLVYRVUHVUPVGVGVWLVWNVVLVUHXBVWNXBVPVWQVWMVUHXCUVLVYJVWRUVMYFUEVYSVVP
        WUGVVLVVQVVNVYSWCVVMVVOWUFVUFVVNVYSUVNXIVVQVOZVVMWUFXCUVOXPWUDWUGVYRVVM
        VUFVUFVXEVJZVLZVLVYRWFVWLWGZVLZVYRWUDBCDVYREFVUFGHIJKLMNOVUEVVMPSTUAUBV
        UFUCUDUFUGUHUIUJUKULUMUNUOUPWUHWUIWUJWUKWULWUMVCVUPWUCWPWUMWUDEFLVXAVUF
        UGVXAVOZUHWUHWUMUVPUVQWUDVYRWUPWUQWUDVUFTUWFVLZVLZWUOVLVWLIUWFVLZVLWUPW
        UQWUDETWUTIVWKVXEWVBVUFUYIWUTVOWVBVOZWUDUXTYAZVUMVWKVXEUXTVTZTIYBZWULVU
        EUXTYCZYDZWUMUVRWUDWVAVVMWUOWUDVUFWUTLWUDVVSWUTLWCWUHLFTUIUHUVSXPXIXEWU
        DIKWVBXBVWLUJWVCAVYMVUOWUCVYNYEZWUDEKVUFVWKWUDEKVWKWDZEIXAVLZVWKWDZWUDE
        WVKTIVWKVXEUYIWVKVOZWVHYGWUDEKEWVKVWKWUDEXHWUDIKXBUJWVIYHYIXOWUMYJUVTYK
        XIWUCWURVYRWCVUPVWLVYRUWAXLYLYLUWBXKVHVUJUWCUWGYMVUPVVGVGVUIVWMVUGVLZVU
        HVLZVMZVVHVUPVVDVVCVVGWVPWCVYQVWJVGVUHVUGVUIVUJVUIXQXRVUPWVPVGVUIVWMVMV
        VHVUPVGVUIWVOVWMVUPVWMVUIVPZWBZVDEWVOVWMWVRWVOETIVVJVSVLZVVJWTVLZVWKVXE
        VVKVVKVOZWVRWVOTIVVJVUEVVKWWAWVRBCDWVNEFGHIJKLMNOVUEPSTUAUBVUFUCUDUFUGU
        HUIUJUKULUMUNUOUPVUPVVSWVQVVTWIZVUPVWAWVQVWBWIZVUPVWCWVQVWDWIZVUPVWFWVQ
        VWGWIZAVUMVUNWVQWNZAVUMVUNWVQWOZVCVUPVUIVWLVWMVUGVUPVVCVUIVWLVUGWDVWJVU
        PVUIVUJVUIVWLVUGVUPVUIXHVYOYIYNYFZWQUWDZUYIUWEWVRVWMETIWVSWVTVWKVXEVVKW
        WAWVRVWMTIVVJVUEVVKWWAVUPWVQVWMVVLVPZVUPVUIVVLVWMVYPXSXTZUWDZUYIUWEWVRU
        YBEVPZWBZVHUYBWVSVLZVYRUYBWVOVLZVLZVMVHWWOVYRUYBVWMVLZVLZVMWWPWWRWWNVHW
        WOWWQWWSWWNVYRWWOVPZVYRUYBVUFVXAVJZVPZWWQWWSWCWWNWWTWXBWWNWWOWXAVYRWWNE
        FVXAVUFUCUYBUFUGWVRVVSWWMWWBWIZWVRVUNWWMWWGWIZWUSWVRWWMWPZUWHXSXTWWNWXB
        WBZWWQWVNVYRVUFUYBVXEVJZVLZVLVVMVUFVWMVLZVLZWXHVLZWWSWXFBCDWVNEFUYBGHIJ
        KLMNOVUEVYRPSTUAUBVUFUCUDUFUGUHUIUJUKULUMUNUOUPWWNVVSWXBWXCWIZWVRVWAWWM
        WXBWWCYEZWVRVWCWWMWXBWWDYEZWVRVWFWWMWXBWWEYEZWVRVUMWWMWXBWWFYEZWWNVUNWX
        BWXDWIZVCWVRWVNVWLVPWWMWXBWWHYEWVRWWMWXBXGZWWNWXBWPZUVQWXFWVNWXJWXHWXFW
        VNVWMVVQVLZWXJWXFVWMVUGVVQWXFVVRVVCWXFBEFGHIJKLMOVUEPRTUAUBVUFUCUDUEUFU
        GUHUIUJUKULUMUNUOUPWXLWXMWXNWXOWXPWXQVAWMVQXIWXFWWJWXTWXJWCWVRWWJWWMWXB
        WWKYEUEVWMVVPWXJVVLVVQUEVGXDVVMVVOWXIVUFVVNVWMUVNXIWUNVVMWXIXCUVOXPYMXE
        WXFVVMVYRVUFUYBWVTVJZVLZVLZWWRVLZWXKWWSWXFVVMWWRWYBWEZVLZVVMWXHWXIWEZVL
        ZWYDWXKWXFVVMWYEWYGWXFWWRWYBVUFWVSVLZWWOYOUYBVWKVLZIUWIVLZVJVJWXHWXIWYI
        VWLYOWYJWYKVJVJWYEWYGWXFVWMETIVYRWYKWVSWVTTWSVLZVWKVXEVVKVUFUYBWWAWVRVW
        MWVSWVTYOVWKVXEYOVVKVJZVPZWWMWXBWWLYEUYIWYLVOZWYKVOZWXQWXRWXFVYRWXAVUFU
        YBWYLVJZWXSFVXATVUFUYBWUSUIUWQUWJZUWKWXFIWYKKWYBWWRXBWYIWWOWYJUJWWNVYMW
        XBWVRVYMWWMAVYMVUOWVQVYNYEZWIZWIZWYPWVRWYIKVPWWMWXBWVREKVUFWVSWVREKWVSW
        DEWVKWVSWDWVREWVKTIWVSWVTUYIWVMWVRWVDVVJUXTVPWVSWVTUXTVTZWVFWVREUXTVUFV
        VIAEUXTVVIWDVUOWVQAEUXTFGVVIUCWTVLZUGUYHAFGVIVJZYAUCXUDVPVVIXUCXUDVTFGY
        BAFGIKTXBUCUFUQUIUJULVYNUSUWLUCXUDYCYDYGYEWWGYJVVJUXTYCYDZYGWVREKEWVKWV
        SWVREXHZWVRIKXBUJWYSYHZYIXOZWWGYJZYEZWWNWWOKVPWXBWVREKUYBWVSXUHYFZWIZWW
        NWYJKVPWXBWVREKUYBVWKWVRWVJWVLWVREWVKTIVWKVXEUYIWVMWVRWVDVUMWVEWVFWWFWV
        GYDYGWVREKEWVKVWKXUFXUGYIXOZYFZWIZWXFWYBWYIWWOIWSVLZVJZVPWYIWWOWYBWDZWX
        FWYQXUQVYRWYAWXFETIWVSWVTWYLXUPVUFUYBUYIWYOXUPVOZWVRXUBWWMWXBXUEYEWXQWX
        RUWMWYRYJWXFIKWYBXUPXBWYIWWOUJXUAXUSXUJXULYPYNZWWNWWOWYJWWRWDZWXBWWNWWR
        WWOWYJXUPVJZVPXVAWWNVWMETIWVSWVTXUPVWKVXEVVKUYBWWAWVRWYNWWMWWLWIUYIXUSW
        XEYQWWNIKWWRXUPXBWWOWYJUJWYTXUSXUKXUNYPYNZWIUWNWXFIWYKKWXIWXHXBWYIVWLWY
        JUJXUAWYPXUJWVRVWLKVPWWMWXBWVREKVUFVWKXUMWWGYJZYEZXUOWVRWYIVWLWXIWDZWWM
        WXBWVRWXIWYIVWLXUPVJVPXVFWVRVWMETIWVSWVTXUPVWKVXEVVKVUFWWAWWLUYIXUSWWGY
        QWVRIKWXIXUPXBWYIVWLUJWYSXUSXUIXVDYPYNZYEWXFWXHVWLWYJXUPVJZVPVWLWYJWXHW
        DWXFWYQXVHVYRWXGWXFETIVWKVXEWYLXUPVUFUYBUYIWYOXUSWXFWVDVUMWVEWVFWXPWVGY
        DWXQWXRUWMWYRYJWXFIKWXHXUPXBVWLWYJUJXUAXUSXVEXUOYPYNUWNYKXIWXFXURVVMWYI
        VPZWYFWYDWCXUTWVRXVIWWMWXBWVRVVMVUFVUFVXAVJZWYIWVREFLVXAVUFUGWUSUHWWBWW
        GUVPZWVREFVXAVUFUCVUFUFUGWWBWWGWUSWWGUWHUWOZYEWYIWWOVVMWWRWYBUWPXRWVRWY
        HWXKWCZWWMWXBWVRXVFXVIXVMXVGXVLWYIVWLVVMWXHWXIUWPXRYEYKWXFWYCVYRWWRWXFW
        YCVVMVYRUYBVUFYOVUFFUWIVLZVJVJVYRWXFEFXVNVYRVVMVXAUYBVUFUCVUFUFUGWXLWXQ
        WUSWXQXVNVOZWXRWXSWVRVVMXVJVPWWMWXBXVKYEUWRWXFEFXVNLVYRVXAUYBVUFUGWUSUH
        WXLWXRXVOWXQWXSUWSYMXEUWTYLUWBXKWWNVHWWOWYJWWPWWNWWPXVBVPWWOWYJWWPWDWWN
        WVOETIWVSWVTXUPVWKVXEVVKUYBWWAWVRWVOWYMVPWWMWWIWIUYIXUSWXEYQWWNIKWWPXUP
        XBWWOWYJUJWYTXUSXUKXUNYPYNUXAWWNVHWWOWYJWWRXVCUXAUXBUXCXKVGVUIUWCUWGYMV
        UIVUJVUGVUHUXDUXGVVAVUSVUQVURVUHUXEUXFXNVUPJUAVUGVUHUYFUBVUIVUJUKVWBAVU
        EVUFUAUXTEUYSAUYAUAUYSWDUYAJXAVLZUYSWDAUYAXVPUYEJUYSUDWTVLZUYJXVPVOZAUY
        KYAZUYLUYSXVQUYKVTUYEJYBZUYOUDUYKYCYDYGAUYAUAUYAXVPUYSAUYAXHZAJUAUBUKUR
        YHZYIXOUXHAVUEVUFUAUXTEVUAAUYAUAVUAWDUYAXVPVUAWDAUYAXVPUYEJVUAOWTVLZUYJ
        XVRAXVSUYMVUAXWCUYKVTXVTUYPOUYKYCYDYGAUYAUAUYAXVPVUAXWAXWBYIXOUXHUYQUXI
        XOUXPVUDVULVDVEVFUXTEUYBVUEVUFYOZWCZUYRVUGUYCVUHVUCVUKXWEUYRXWDRVLVUGUY
        BXWDRYRVUEVUFRYSYTXWEUYTVUIVUBVUJUYFXWEUYTXWDUYSVLVUIUYBXWDUYSYRVUEVUFU
        YSYSYTXWEVUBXWDVUAVLVUJUYBXWDVUAYRVUEVUFVUAYSYTUXJXWEUYCXWDSVLVUHUYBXWD
        SYRVUEVUFSYSYTUXKUXLUXMUXNUXQSUYAWRSUYDWCMBUXTEVYCSVCDVXOVYBVXLVXNXCXFU
        XOVDUYASXMUXRUXS $.

      $( Lemma for ~ yonffth .  (Contributed by Mario Carneiro,
         29-Jan-2017.) $)
      yonffthlem $p |- ( ph -> Y e. ( ( C Full Q ) i^i ( C Faith Q ) ) ) $=
        ( vz vw vv vh c1st cfv c2nd cop cful co cfth cin wrel wcel wceq relfunc
        cfunc cvv chomf crn unssbd ssexd yoncl 1st2nd sylancr cv chom cnat wf1o
        wbr wral 1st2ndbr wa cxp wf fucbas funcf1 adantr simprr ffvelrnd simprl
        ciso opelxpi syl2anc cxpc ccat yonedalem1 simpld syl simprd fuccat eqid
        funcrcl yonedainv inviso2 oppcbas mpbid fveq2 df-ov syl6eqr oveq12d wss
        xpcbas yon11 eleqtrrd eqeltrrd sseldd wfn cmpt simpr ffvelrnda ad2antrr
        eqtr4d feqmptd mpteq2dva sylib 3eqtr4d eleq12d rspcv sylc oppccat evlf1
        fuciso setccat eqtrd cun yonedalem21 eleqtrd cbs setcbas fuchom homfval
        unssad homffn a1i fnovrn syl3anc setciso eqcomd ad3antrrr simpllr yon12
        cco yon2 mpteq12dva funcf2 nat1st2nd natcl elsetchom eleq2d yonedalem4a
        wb biimpar natfn dffn5 f1oeq1 ralrimivva isffth2 sylanbrc df-br eqeltrd
        f1of ) AUCUCVHVIZUCVJVIZVKZFGVLVMFGVNVMVOZAFGVTVMZVPZUCUWJVQZUCUWHVRFGV
        SZAFGIKTWAUCUFUQUIUJULAKUAUBURAGWBVIZWCZKUAUTWDZWEZUSWFZUCUWJWGWHAUWFUW
        GUWIWMZUWHUWIVQAUWFUWGUWJWMZVDWIZVEWIZFWJVIZVMZUXAUWFVIZUXBUWFVIZTIWKVM
        ZVMZUXAUXBUWGVMZWLZVEEWNVDEWNUWSAUWKUWLUWTUWMUWRUCUWJWOWHZAUXJVDVEEEAUX
        AEVQZUXBEVQZWPZWPZUXDUXHUXFUXASVMZWLZUXJUXOUXPUXDUXHJXEVIZVMZVQUXQUXOUX
        PUXFUXAOVHVIZVMZUXFUXAUDVHVIZVMZUXRVMZUXSUXOUXFUXAVKZTIVTVMZEWQZVQZVFWI
        ZSVIZUYIUXTVIZUYIUYBVIZUXRVMZVQZVFUYGWNZUXPUYDVQZUXOUXFUYFVQZUXLUYHUXOE
        UYFUXBUWFAEUYFUWFWRZUXNAEUYFFGUWFUWGUGTIGULWSZUXKWTZXAZAUXLUXMXBZXCZAUX
        LUXMXDZUXFUXAUYFEXFXGAUYOUXNASOUDGTXHVMZJWKVMZVMVQZUYOASOUDHXEVIZVMVQVU
        GUYOWPAVUEJVTVMZHRSVUHQUDOVUEJHUNWSVBAVUEJHUNAVUEXIVQZJXIVQZAUDVUIVQZVU
        JVUKWPAVULOVUIVQZAEFGHIJKLOPTUAUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTXJZX
        KZVUEJUDXPXLZXKAVUJVUKVUPXMXNVUOAVULVUMVUNXMZVUHXOZABCDEFGHIJKLMNOPQRST
        UAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCXQXRAVFSUYGVUEJHOUDVUHUXR
        VUFUNGTVUEUYFEVUEXOUYSEFTUIUGXSZYFVUFXOVUQVUOVURUXRXOZUUFXTXMXAUYNUYPVF
        UYEUYGUYIUYEVRZUYJUXPUYMUYDVVAUYJUYESVIUXPUYIUYESYAUXFUXASYBYCVVAUYKUYA
        UYLUYCUXRVVAUYKUYEUXTVIUYAUYIUYEUXTYAUXFUXAUXTYBYCVVAUYLUYEUYBVIUYCUYIU
        YEUYBYAUXFUXAUYBYBYCYDUUAUUBUUCUXOUYAUXDUYCUXHUXRUXOUYAUXAUXFVHVIZVIZUX
        DUXOETIOUXFUXAUOATXIVQZUXNAFXIVQZVVDUQFTUIUUDXLXAAIXIVQZUXNAKWAVQZVVFUW
        QIKWAUJUUGXLXAVUSVUCVUDUUEUXOEFUXCUXBUCUXAUFUGAVVEUXNUQXAZVUBUXCXOZVUDY
        GZUUHUXOEFGHIJKLOUXFPTUAUBUXAUCUDUFUGUHUIUJUKULUMUNUOUPVVHAUAUBVQZUXNUR
        XAZAFWBVIWCKYEZUXNUSXAZAUWOKUUIUAYEZUXNUTXAZVUCVUDUUJYDUUKUXOJUAUXPUXRU
        BUXDUXHUKVVLUXOKUAUXDAKUAYEUXNUWPXAUXOVVCUXDKVVJUXOVVCIUULVIZKUXOEVVQUX
        AVVBUXOEVVQTIVVBUXFVJVIZVUSVVQXOZUXOUYFVPZUYQVVBVVRUYFWMTIVSZVUCUXFUYFW
        OWHWTZVUDXCAKVVQVRZUXNAIKWAUJUWQUUMXAZYHYIYJUXOUXEUXFUWNVMZUXHUAUXOUYFG
        UWNUXGUXEUXFUWNXOZUYSTIGUXGULUXGXOZUUNZUXOEUYFUXAUWFVUAVUDXCZVUCUUOUXOU
        WOUAVWEAUWOUAYEUXNAUWOKUAUTUUPXAUXOUWNUYFUYFWQYKZUXEUYFVQZUYQVWEUWOVQVW
        JUXOUYFGUWNVWFUYSUUQUURVWIVUCUYFUYFUXEUXFUWNUUSUUTYJYIVUTUVAXTZUXOUXPUX
        IVRUXQUXJUVOUXOVGUXDVGWIZUXPVIZYLVGUXDVWMUXIVIZYLUXPUXIUXOVGUXDVWNVWOUX
        OVWMUXDVQZWPZCENCWIZUXAUXCVMZVWMNWIZUXAVWRVVRVMVIVIZYLZYLCEVWRVWOVIZYLZ
        VWNVWOVWQCEVXBVXCVWQVWREVQZWPZVXBNVWRUXEVHVIZVIZVWTVXCVIZYLVXCVXFNVWSVX
        AVXHVXIVXFVXHVWSVXFEFUXCUXAUCVWRUFUGVWQVVEVXEUXOVVEVWPVVHXAZXAZVWQUXLVX
        EUXOUXLVWPVUDXAZXAZVVIVWQVXEYMZYGUVBVXFVWTVWSVQZWPZVXAVWMVWTVWRUXAVKUXB
        FUVFVIZVMVMVXIVXPEFVXQVWTVWMUXCVWRUXBUCUXAUFUGVXFVVEVXOVXKXAZUXOUXMVWPV
        XEVXOVUBUVCZVVIVXFUXLVXOVXMXAZVXQXOZVXFVXEVXOVXNXAZVXFVXOYMZUXOVWPVXEVX
        OUVDZUVEVXPEFVXQVWMVWTUXCVWRUXAUCUXBUFUGVXRVXTVVIVXSVYAVYBVYDVYCUVGYPUV
        HVXFNVXHVWRVVBVIZVXCVXFVXCVXHVYEIWJVIZVMVQVXHVYEVXCWRVXFVWOETIVXGUXEVJV
        IZVYFVVBVVRUXGVWRVWGVWQVWOVXGVYGVKVVBVVRVKUXGVMVQVXEVWQVWOTIUXEUXFUXGVW
        GUXOUXDUXHVWMUXIUXOEFGUWFUWGUXCUXGUXAUXBUGVVIVWHAUWTUXNUXKXAVUDVUBUVIZY
        NUVJZXAVUSVYFXOZVXNUVKVXFIKVXCVYFWAVXHVYEUJUXOVVGVWPVXEAVVGUXNUWQXAYOVY
        JVXFVXHVVQKVWQEVVQVWRVXGVWQEVVQTIVXGVYGVUSVVSVWQVVTVWKVXGVYGUYFWMVWAVWQ
        EUYFUXAUWFAUYRUXNVWPUYTYOVXLXCUXEUYFWOWHWTYNUXOVWCVWPVXEVWDYOZYHVXFVYEV
        VQKVWQEVVQVWRVVBUXOEVVQVVBWRVWPVWBXAYNVYKYHUVLXTYQYPYRVWQBCDVWMEFGHIJKL
        MNOUXFPSTUAUBUXAUCUDUFUGUHUIUJUKULUMUNUOUPVXJUXOVVKVWPVVLXAUXOVVMVWPVVN
        XAUXOVVOVWPVVPXAUXOUYQVWPVUCXAVXLVCUXOVWMVVCVQVWPUXOVVCUXDVWMVVJUVMUVPU
        VNVWQVWOEYKVWOVXDVRVWQVWOETIVXGVYGVVBVVRUXGVWGVYIVUSUVQCEVWOUVRYSYTYRUX
        OVGUXDUXHUXPUXOUXQUXDUXHUXPWRVWLUXDUXHUXPUWEXLYQUXOVGUXDUXHUXIVYHYQYTUX
        DUXHUXPUXIUVSXLXTUVTVDVEEFGUWFUWGUXCUXGUGVVIVWHUWAUWBUWFUWGUWIUWCYSUWD
        $.
    $}

    yoneda.i $e |- I = ( Iso ` R ) $.
    $( The Yoneda Lemma.  There is a natural isomorphism between the functors
       ` Z ` and ` E ` , where ` Z ( F , X ) ` is the natural transformations
       from ` Yon ( X ) = Hom ( - , X ) ` to ` F ` , and
       ` E ( F , X ) = F ( X ) ` is the evaluation functor.  Here we need two
       universes to state the claim: the smaller universe ` U ` is used for
       forming the functor category
       ` Q = C ` <HTML><sup>op</sup></HTML> ` -> SetCat ( U ) ` , which itself
       does not (necessarily) live in ` U ` but instead is an element of the
       larger universe ` V ` . (If ` U ` is a Grothendieck universe, then it
       will be closed under this "presheaf" operation, and so we can set
       ` U = V ` in this case.)
       (Contributed by Mario Carneiro, 29-Jan-2017.) $)
    yoneda $p |- ( ph -> M e. ( Z I E ) ) $=
      ( vu vy vg cxpc co cfunc cv c1st cfv chom c2nd cmpt cinv fucbas eqid ccat
      cmpt2 wcel yonedalem1 simpld funcrcl syl simprd fuccat yonedainv inviso1
      wa ) AEPVBVCZHVDVCZFOKBPGVDVCCUSBVEZKVEZVFVGVGUTCVAUTVEZWHDVHVGVCUSVEVAVE
      WHWJWIVIVGVCVGVGVJVJVJVOZNFVKVGZTLWFHFUJVLWLVMZAWFHFUJAWFVNVPZHVNVPZATWGV
      PZWNWOWEAWPLWGVPZACDEFGHIJLMPQRSTUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVQZVRZWFHT
      VSVTZVRAWNWOWTWAWBWSAWPWQWRWAURABUTUSCDEFGHIJKVALMWLOWKPQRSTUAUBUCUDUEUFU
      GUHUIUJUKULUMUNUOUPUQWMWKVMWCWD $.
  $}

  ${
    $d a f g u x y C $.  $d a f g u x y O $.  $d a f g u x y ph $.
    $d a f g u x y Q $.  $d a f g u x y S $.  $d a f g u x y Y $.
    $d f g u y U $.
    yonffth.y $e |- Y = ( Yon ` C ) $.
    yonffth.o $e |- O = ( oppCat ` C ) $.
    yonffth.s $e |- S = ( SetCat ` U ) $.
    yonffth.q $e |- Q = ( O FuncCat S ) $.
    yonffth.c $e |- ( ph -> C e. Cat ) $.
    yonffth.u $e |- ( ph -> U e. V ) $.
    yonffth.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    $( The Yoneda Lemma.  The Yoneda embedding, the curried Hom functor, is
       full and faithful, and hence is a representation of the category ` C `
       as a full subcategory of the category ` Q ` of presheaves on ` C ` .
       (Contributed by Mario Carneiro, 29-Jan-2017.) $)
    yonffth $p |- ( ph -> Y e. ( ( C Full Q ) i^i ( C Faith Q ) ) ) $=
      ( vx cfv co cv eqid vy vu vf vg va cbs cxpc chomf crn cun csetc cfuc ccid
      cevlf chof cinv cfunc c1st cnat cmpt cmpt2 chom cvv ctpos cop c2ndf ccofu
      c2nd c1stf cprf wcel fvex rnex unexg sylancr wss ssid a1i yonffthlem ) AP
      UAUBBUFQZBCCFUGRCUHQZUIZEUJZUKQZULRZDWDEBUMQZUCUDFDUNRZCUOQZWEUPQZUCPFDUQ
      RZVTUEPSZHURQZQUCSZFDUSRRWKWFQWKUESQQUTVAZUCPWJVTUBWKWMURQQUAVTUDUASZWKBV
      BQRUBSUDSWKWOWMVHQRQQUTUTUTVAZFWCVCHWHWLHVHQVDVECFVFRVGRCFVIRVJRVGRZUEIVT
      TWFTJKWDTLWHTWETWGTWQTMAWBVCVKEGVKWCVCVKWACUHVLVMNWBEVCGVNVOOWCWCVPAWCVQV
      RWNTWITWPTVS $.
  $}

  ${
    $d x y C $.  $d y F $.  $d x y ph $.  $d x y Y $.
    yoniso.y $e |- Y = ( Yon ` C ) $.
    yoniso.o $e |- O = ( oppCat ` C ) $.
    yoniso.s $e |- S = ( SetCat ` U ) $.
    yoniso.d $e |- D = ( CatCat ` V ) $.
    yoniso.b $e |- B = ( Base ` D ) $.
    yoniso.i $e |- I = ( Iso ` D ) $.
    yoniso.q $e |- Q = ( O FuncCat S ) $.
    yoniso.e $e |- E = ( Q |`s ran ( 1st ` Y ) ) $.
    yoniso.v $e |- ( ph -> V e. X ) $.
    yoniso.c $e |- ( ph -> C e. B ) $.
    yoniso.u $e |- ( ph -> U e. W ) $.
    yoniso.h $e |- ( ph -> ran ( Homf ` C ) C_ U ) $.
    yoniso.eb $e |- ( ph -> E e. B ) $.
    yoniso.1 $e |- ( ( ph /\ ( x e. ( Base ` C ) /\ y e. ( Base ` C ) ) ) ->
      ( F ` ( x ( Hom ` C ) y ) ) = y ) $.
    $( If the codomain is recoverable from a hom-set, then the Yoneda embedding
       is injective on objects, and hence is an isomorphism from ` C ` into a
       full subcategory of a presheaf category.  (Contributed by Mario
       Carneiro, 30-Jan-2017.) $)
    yoniso $p |- ( ph -> Y e. ( C I E ) ) $=
      ( co wcel cful cfth cin cbs cfv c1st wf1o c2nd cop wrel wceq relfunc ccat
      cfunc catcbas inss2 syl6eqss sseldd yoncl 1st2nd sylancr yonffth eqeltrrd
      wbr crn cvv eqid oppccat syl setccat fuccat fvex rnex a1i wfn wf 1st2ndbr
      fucbas funcf1 ffn dffn3 sylib ffthres2c df-br 3bitr3g mpbid eqeltrd cv wi
      wf1 weq wral wa fveq2 fveq1d fveq2d simpl eleq1 anbi2d id eqeq12d imbi12d
      jca chom adantr simprr simprl yon11 eqtrd chvarv sylan2 syl5ib ralrimivva
      dff13 sylanbrc f1f1orn wb wss frn ressbas2 f1oeq3 catciso mpbir2and ) AQE
      JLULUMQEJUNULEJUOULUPZUMEUQURZJUQURZQUSURZUTZAQYTQVAURZVBZYQAEGVGULZVCZQU
      UDUMZQUUCVDEGVEZAEGHIMOQRADVFEADNVFUPVFADFNPUAUBUFVHNVFVIVJUGVKZSTUDUHUIV
      LZQUUDVMVNZAUUCEGUNULEGUOULUPZUMZUUCYQUMZAQUUCUUKUUJAEGHIMOQRSTUDUUHUHUIV
      OVPAYTUUBUUKVQYTUUBYQVQUULUUMAYREGYTVRZJYTUUBVSYRVTZUEAMHGUDAEVFUMZMVFUMU
      UHEMSWAWBAIOUMHVFUMUHHIOTWCWBWDUUNVSUMAYTQUSWEWFWGAYTYRWHZYRUUNYTWIAYRMHV
      GULZYTWIZUUQAYRUUREGYTUUBUUOMHGUDWKZAUUEUUFYTUUBUUDVQUUGUUIQUUDWJVNWLZYRU
      URYTWMWBYRYTWNWOWPYTUUBUUKWQYTUUBYQWQWRWSWTAYRUUNYTUTZUUAAYRUURYTXCZUVBAU
      USBXAZYTURZCXAZYTURZVDZBCXDZXBZCYRXEBYRXEUVCUVAAUVJBCYRYRUVHUVDUVEUSURZUR
      ZKURZUVDUVGUSURZURZKURZVDAUVDYRUMZUVFYRUMZXFZXFZUVIUVHUVLUVOKUVHUVDUVKUVN
      UVEUVGUSXGXHXIUVTUVMUVDUVPUVFUVSAUVQUVQXFZUVMUVDVDZUVSUVQUVQUVQUVRXJZUWCX
      PUVTUVPUVFVDZXBAUWAXFZUWBXBCBCBXDZUVTUWEUWDUWBUWFUVSUWAAUWFUVRUVQUVQUVFUV
      DYRXKXLXLUWFUVPUVMUVFUVDUWFUVOUVLKUWFUVDUVNUVKUWFUVGUVEUSUVFUVDYTXGXIXHXI
      UWFXMXNXOUVTUVPUVDUVFEXQURZULZKURUVFUVTUVOUWHKUVTYREUWGUVFQUVDRUUOAUUPUVS
      UUHXRAUVQUVRXSUWGVTAUVQUVRXTYAXIUKYBZYCYDUWIXNYEYFBCYRUURYTYGYHYRUURYTYIW
      BAUUNYSVDZUVBUUAYJAUUNUURYKZUWJAUUSUWKUVAYRUURYTYLWBUUNUURJGUEUUTYMWBUUNY
      SYRYTYNWBWSADFYRYSNQLPEJUAUBUUOYSVTUFUGUJUCYOYP $.
  $}

$(
###############################################################################
                       BASIC ORDER THEORY
###############################################################################
$)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Presets and directed sets using extensible structures
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $c Preset Dirset $.

  $( Extend class notation with the class of all presets. $)
  cpreset $a class Preset $.

  $( Extend class notation with the class of all directed sets. $)
  cdrs $a class Dirset $.

  ${
    $d f b r x y z $.
    $( Define the class of preordered sets (presets).  A preset is a set
       equipped with a transitive and reflexive relation.

       Preorders are a natural generalization of order for sets where there is
       a well-defined ordering, but it in some sense "fails to capture the
       whole story", in that there may be pairs of elements which are
       indistinguishable under the order.  Two elements which are not equal but
       are less-or-equal to each other behave the same under all order
       operations and may be thought of as "tied".

       A preorder can naturally be strengthened by requiring that there are no
       ties, resulting in a partial order, or by stating that all comparable
       pairs of elements _are_ tied, resulting in an equivalence relation.
       Every preorder naturally factors into these two types; the tied relation
       on a preorder is an equivalence relation and the quotient under that
       relation is a partial order.  (Contributed by FL, 17-Nov-2014.)
       (Revised by Stefan O'Rear, 31-Jan-2015.) $)
    df-preset $a |- Preset = { f | [. ( Base ` f ) / b ].
          [. ( le ` f ) / r ].
                A. x e. b A. y e. b A. z e. b ( x r x
                 /\ ( ( x r y /\ y r z ) -> x r z ) ) } $.

    $( Define the class of directed sets.  A directed set is a nonempty
       preordered set where every pair of elements have some upper bound.  Note
       that it is not required that there exist a _least_ upper bound.

       There is no consensus in the literature over whether directed sets are
       allowed to be empty.  It is slightly more convenient for us if they are
       not.  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    df-drs $a |- Dirset = { f e. Preset | [. ( Base ` f ) / b ].
        [. ( le ` f ) / r ]. ( b =/= (/) /\ A. x e. b A. y e. b E. z e. b
            ( x r z /\ y r z ) ) } $.
  $}

  ${
    $d K f b r x y z $.  $d B f b r x y z $.  $d .<_ f b r x y z $.
    $d X x y z $.  $d Y x y z $.  $d Z x y z $.
    isprs.b $e |- B = ( Base ` K ) $.
    isprs.l $e |- .<_ = ( le ` K ) $.
    $( Property of being a preordered set.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    isprs $p |- ( K e. Preset <-> ( K e. _V /\ A. x e. B A. y e. B A. z e. B
          ( x .<_ x /\ ( ( x .<_ y /\ y .<_ z ) -> x .<_ z ) ) ) ) $=
      ( vr vb cv wbr wa wral cple cfv wsbc cbs wceq wb vf wi cpreset dfsbcq syl
      fveq2 sbcbidv bitrd eqtr3 mpan2 raleq raleqbi1dv anbi12d imbi12d 2ralbidv
      fvex breq ralbidv sylan9bb sbc2ie syl6bb df-preset elab4g ) AKZVDIKZLZVDB
      KZVELZVGCKZVELZMZVDVIVELZUBZMZCJKZNZBVONZAVONZIUAKZOPZQZJVSRPZQZVDVDFLZVD
      VGFLZVGVIFLZMZVDVIFLZUBZMZCDNZBDNADNZUAEUCVSESZWCVRIEOPZQZJERPZQZWLWMWCWA
      JWPQZWQWMWBWPSWCWRTVSERUFWAJWBWPUDUEWMWAWOJWPWMVTWNSWAWOTVSEOUFVRIVTWNUDU
      EUGUHVRWLJIWPWNERUPEOUPVOWPSZVRVNCDNZBDNZADNZVEWNSZWLWSVODSZVRXBTWSDWPSXD
      GVODWPUIUJVQXAAVODVPWTBVODVNCVODUKULULUEXCVEFSZXBWLTXCFWNSXEHVEFWNUIUJXEW
      TWKABDDXEVNWJCDXEVFWDVMWIVDVDVEFUQXEVKWGVLWHXEVHWEVJWFVDVGVEFUQVGVIVEFUQU
      MVDVIVEFUQUNUMURUOUEUSUTVAABCUAIJVBVC $.

    $( Lemma for ~ prsref and ~ prstr .  (Contributed by Mario Carneiro,
       1-Feb-2015.) $)
    prslem $p |- ( ( K e. Preset /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( X .<_ X /\ ( ( X .<_ Y /\ Y .<_ Z ) -> X .<_ Z ) ) ) $=
      ( vx vy vz wcel cv wbr wa wi wral wceq breq1 breq2 cpreset w3a simprbi wb
      cvv isprs breq12 anidms anbi1d imbi12d anbi12d imbi1d anbi2d rspc3v mpan9
      ) BUALZIMZUQCNZUQJMZCNZUSKMZCNZOZUQVACNZPZOZKAQJAQIAQZDALEALFALUBDDCNZDEC
      NZEFCNZOZDFCNZPZOZUPBUELVGIJKABCGHUFUCVFVNVHDUSCNZVBOZDVACNZPZOVHVIEVACNZ
      OZVQPZOIJKDEFAAAUQDRZURVHVEVRWBURVHUDUQDUQDCUGUHWBVCVPVDVQWBUTVOVBUQDUSCS
      UIUQDVACSUJUKUSERZVRWAVHWCVPVTVQWCVOVIVBVSUSEDCTUSEVACSUKULUMVAFRZWAVMVHW
      DVTVKVQVLWDVSVJVIVAFECTUMVAFDCTUJUMUNUO $.

    $( Less-or-equal is reflexive in a preset.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    prsref $p |- ( ( K e. Preset /\ X e. B ) -> X .<_ X ) $=
      ( cpreset wcel wa wbr wi w3a id 3jca prslem sylan2 simpld ) BGHZDAHZIDDCJ
      ZTTITKZSRSSSLTUAISSSSSMZUBUBNABCDDDEFOPQ $.

    $( Less-or-equal is transitive in a preset.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    prstr $p |- ( ( K e. Preset /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
          ( X .<_ Y /\ Y .<_ Z ) ) -> X .<_ Z ) $=
      ( cpreset wcel w3a wbr wa wi prslem simprd 3impia ) BIJZDAJEAJFAJKZDECLEF
      CLMZDFCLZRSMDDCLTUANABCDEFGHOPQ $.
  $}

  ${
    $d K f b r x y z $.  $d B f b r x y z $.  $d .<_ f b r x y z $.
    $d X x y z $.  $d Y x y z $.
    isdrs.b $e |- B = ( Base ` K ) $.
    isdrs.l $e |- .<_ = ( le ` K ) $.
    $( Property of being a directed set.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    isdrs $p |- ( K e. Dirset <-> ( K e. Preset /\ B =/= (/) /\
          A. x e. B A. y e. B E. z e. B ( x .<_ z /\ y .<_ z ) ) ) $=
      ( vb vr vf cv wbr wa wral cple cfv wsbc cbs wceq cdrs wcel cpreset c0 wne
      wrex w3a wb fveq2 syl6eqr dfsbcq syl sbcbidv bitrd cvv fvex eqeltri neeq1
      adantr rexeq raleqbi1dv breq anbi12d 2ralbidv sbc2ie syl6bb df-drs elrab2
      rexbidv sylan9bb 3anass bitr4i ) EUAUBEUCUBZDUDUEZALZCLZFMZBLZVPFMZNZCDUF
      ZBDOADOZNZNVMVNWBUGILZUDUEZVOVPJLZMZVRVPWFMZNZCWDUFZBWDOZAWDOZNZJKLZPQZRZ
      IWNSQZRZWCKEUCUAWNETZWRWMJFRZIDRZWCWSWRWPIDRZXAWSWQDTWRXBUHWSWQESQZDWNESU
      IGUJWPIWQDUKULWSWPWTIDWSWOFTWPWTUHWSWOEPQZFWNEPUIHUJWMJWOFUKULUMUNWMWCIJD
      FDXCUOGESUPUQFXDUOHEPUPUQWDDTZWFFTZNWEVNWLWBXEWEVNUHXFWDDUDURUSXEWLWICDUF
      ZBDOZADOXFWBWKXHAWDDWJXGBWDDWICWDDUTVAVAXFXGWAABDDXFWIVTCDXFWGVQWHVSVOVPW
      FFVBVRVPWFFVBVCVIVDVJVCVEVFABCKJIVGVHVMVNWBVKVL $.

    $( Direction of a directed set.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    drsdir $p |- ( ( K e. Dirset /\ X e. B /\ Y e. B ) ->
        E. z e. B ( X .<_ z /\ Y .<_ z ) ) $=
      ( vx vy cdrs wcel cv wbr wa wrex wral wceq breq1 rexbidv cpreset c0 isdrs
      wne simp3bi anbi1d anbi2d rspc2v syl5com 3impib ) CKLZEBLZFBLZEAMZDNZFUND
      NZOZABPZUKIMZUNDNZJMZUNDNZOZABPZJBQIBQZULUMOURUKCUALBUBUDVEIJABCDGHUCUEVD
      URUOVBOZABPIJEFBBUSERZVCVFABVGUTUOVBUSEUNDSUFTVAFRZVFUQABVHVBUPUOVAFUNDSU
      GTUHUIUJ $.
  $}

  ${
    $d K x y z $.  $d B x y z $.

    $( A directed set is a preset.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    drsprs $p |- ( K e. Dirset -> K e. Preset ) $=
      ( vx vz vy cdrs wcel cpreset cbs cfv c0 wne cv cple wbr wa wrex wral eqid
      isdrs simp1bi ) AEFAGFAHIZJKBLCLZAMIZNDLUBUCNOCUAPDUAQBUAQBDCUAAUCUARUCRS
      T $.

    drsbn0.b $e |- B = ( Base ` K ) $.
    $( The base of a directed set is not empty.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    drsbn0 $p |- ( K e. Dirset -> B =/= (/) ) $=
      ( vx vz vy cdrs wcel cpreset c0 wne cv cple cfv wbr wrex wral eqid isdrs
      wa simp2bi ) BGHBIHAJKDLELZBMNZOFLUBUCOTEAPFAQDAQDFEABUCCUCRSUA $.

    drsdirfi.l $e |- .<_ = ( le ` K ) $.
    $d K a b c x y z $.  $d .<_ a b c x y z $.  $d B a b c x y z $.
    $d X a b c x y z $.
    $( Any _finite_ number of elements in a directed set have a common upper
       bound.  Here is where the non-emptiness constraint in ~ df-drs first
       comes into play; without it we would need an additional constraint that
       ` X ` not be empty.  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    drsdirfi $p |- ( ( K e. Dirset /\ X C_ B /\ X e. Fin ) ->
        E. y e. B A. z e. X z .<_ y ) $=
      ( va wcel wss cv wbr wral wrex wa wi c0 wceq sseq1 vb vc cdrs cfn csn cun
      anbi2d raleq rexbidv imbi12d wne drsbn0 ral0 jctr eximi n0 df-rex 3imtr4i
      wex syl adantr ssun1 sstr mpan anim2i breq2 ralbidv cbvrexv simpll simprl
      snss sylibr ad2antlr drsdir syl3anc simplrr cpreset drsprs ad5antr sselda
      ssun2 simp-4r ad2antrr simpr simprrl prstr syl132anc ex ralimdva adantlrr
      vex mpd simprrr breq1 ralsn ralun syl2anc expr reximdva rexlimdvaa syl5bi
      embantd com12 a1i findcard2 3impia ) DUCJZFCKZFUDJZBLZALZEMZBFNZACOZXIXGX
      HPZXNXGILZCKZPZXLBXPNZACOZQXGRCKZPZXLBRNZACOZQXGUALZCKZPZXLBYENZACOZQZXGY
      EUBLZUEZUFZCKZPZXLBYMNZACOZQZXOXNQIUAUBFXPRSZXRYBXTYDYSXQYAXGXPRCTUGYSXSY
      CACXLBXPRUHUIUJXPYESZXRYGXTYIYTXQYFXGXPYECTUGYTXSYHACXLBXPYEUHUIUJXPYMSZX
      RYOXTYQUUAXQYNXGXPYMCTUGUUAXSYPACXLBXPYMUHUIUJXPFSZXRXOXTXNUUBXQXHXGXPFCT
      UGUUBXSXMACXLBXPFUHUIUJXGYDYAXGCRUKZYDCDGULXKCJZAUSUUDYCPZAUSUUCYDUUDUUEA
      UUDYCXLBUMUNUOACUPYCACUQURUTVAYJYRQYEUDJYOYJYQYOYGYIYQYNYFXGYEYMKYNYFYEYL
      VBYEYMCVCVDZVEYIXJXPEMZBYENZICOYOYQYHUUHAICXKXPSXLUUGBYEXKXPXJEVFVGVHYOUU
      HYQICYOXPCJZUUHPZPZXPXKEMZYKXKEMZPZACOZYQUUKXGUUIYKCJZUUOXGYNUUJVIYOUUIUU
      HVJYNUUPXGUUJYNYLCKZUUPYLYMKYNUUQYLYEWAYLYMCVCVDYKCUBWKZVKVLVMACDEXPYKGHV
      NVOUUKUUNYPACUUKUUDUUNYPUUKUUDUUNPZPZYHXLBYLNZYPUUTUUHYHYOUUIUUHUUSVPYOUU
      IUUSUUHYHQUUHYOUUIPZUUSPZUUGXLBYEUVCXJYEJZPZUUGXLUVEUUGPDVQJZXJCJZUUIUUDU
      UGUULXLXGUVFYNUUIUUSUVDUUGDVRVSUVEUVGUUGUVCYECXJUVBYFUUSYNYFXGUUIUUFVMVAV
      TVAYOUUIUUSUVDUUGWBUVCUUDUVDUUGUVBUUDUUNVJWCUVEUUGWDUVCUULUVDUUGUVBUUDUUL
      UUMWEWCCDEXJXPXKGHWFWGWHWIWJWLUUTUUMUVAUUKUUDUULUUMWMXLUUMBYKUURXJYKXKEWN
      WOVLXLBYEYLWPWQWRWSWLWTXAXBXCXDXEXCXF $.

    $( Directed sets may be defined in terms of finite subsets.  Again, without
       nonemptiness we would need to restrict to nonempty subsets here.
       (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    isdrs2 $p |- ( K e. Dirset <-> ( K e. Preset /\
          A. x e. ( ~P B i^i Fin ) E. y e. B A. z e. x z .<_ y ) ) $=
      ( va vb wcel cv wbr wral wrex cfn wa simpl adantl c0 cdrs cpreset cpw cin
      drsprs wss inss1 sseli elpwid inss2 drsdirfi syl3anc ralrimiva jca wne wi
      0elpw 0fin elin mpbir2an wceq raleq rexbidv rspcv ax-mp rexn0 syl prelpwi
      cpr prfi a1i sylanbrc simplr rspcva syl2anc breq1 ralpr rexbii ralrimivva
      vex sylib isdrs syl3anbrc impbii ) EUAKZEUBKZCLZBLZFMZCALZNZBDOZADUCZPUDZ
      NZQZWEWFWOEUEWEWLAWNWEWJWNKZQWEWJDUFZWJPKZWLWEWQRWQWRWEWQWJDWNWMWJWMPUGUH
      UISWQWSWEWNPWJWMPUJUHSBCDEFWJGHUKULUMUNWPWFDTUOZILZWHFMZJLZWHFMZQZBDOZJDN
      IDNWEWFWORWOWTWFWOWICTNZBDOZWTTWNKZWOXHUPXITWMKTPKDUQURTWMPUSUTWLXHATWNWJ
      TVAWKXGBDWICWJTVBVCVDVEXGBDVFVGSWPXFIJDDWPXADKXCDKQZQZWICXAXCVIZNZBDOZXFX
      KXLWNKZWOXNXJXOWPXJXLWMKXLPKZXOXAXCDVHXPXJXAXCVJVKXLWMPUSVLSWFWOXJVMWLXNA
      XLWNWJXLVAWKXMBDWICWJXLVBVCVNVOXMXEBDWIXBXDCXAXCIVTJVTWGXAWHFVPWGXCWHFVPV
      QVRWAVSIJBDEFGHWBWCWD $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Posets and lattices using extensible structures
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Posets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Poset $.
  $c lt $.
  $c lub $.
  $c glb $.
  $c join $.
  $c meet $.

  $( Extend class notation with the class of posets. $)
  cpo $a class Poset $.

  $( Extend class notation with less-than for posets. $)
  cplt $a class lt $.

  $( Extend class notation with poset least upper bound. $)
  club $a class lub $.

  $( Extend class notation with poset greatest lower bound. $)
  cglb $a class glb $.

  $( Extend class notation with poset join. $)
  cjn $a class join $.

  $( Extend class notation with poset meet. $)
  cmee $a class meet $.

  ${
    $d f b r x y z $.
    $( Define the class of posets.  Definition of poset in [Crawley] p. 1.
       Note that Crawley-Dilworth require that a poset base set be nonempty,
       but we follow the convention of most authors who don't make this a
       requirement.

       The quantifiers ` E. b E. r ` provide a notational shorthand to allow us
       to refer to the base and ordering relation as ` b ` and ` r ` the
       definition rather than having to repeat ` ( Base `` f ) ` and
       ` ( le `` f ) ` throughout.  These quantifiers can be eliminated with
       ~ ceqsex2v and related theorems.  (Contributed by NM, 18-Oct-2012.) $)
    df-poset $a |- Poset = { f | E. b E. r
              ( b = ( Base ` f )
               /\ r = ( le ` f )
               /\ A. x e. b A. y e. b A. z e. b ( x r x
                 /\ ( ( x r y /\ y r x ) -> x = y )
                 /\ ( ( x r y /\ y r z ) -> x r z ) ) ) } $.
  $}

  ${
    $d b p r x y z B $.  $d b p r K $.  $d b p r x y z .<_ $.
    ispos.b $e |- B = ( Base ` K ) $.
    ispos.l $e |- .<_ = ( le ` K ) $.
    $( The predicate "is a poset."  (Contributed by NM, 18-Oct-2012.)  (Revised
       by Mario Carneiro, 4-Nov-2013.) $)
    ispos $p |- ( K e. Poset <-> ( K e. _V
            /\ A. x e. B A. y e. B A. z e. B ( x .<_ x
                 /\ ( ( x .<_ y /\ y .<_ x ) -> x = y )
                 /\ ( ( x .<_ y /\ y .<_ z ) -> x .<_ z ) ) ) ) $=
      ( vb vr cv wceq wbr wa wi w3a wral wex cbs breq vp cpo wcel cvv cfv fveq2
      cple syl6eqr eqeq2d 3anbi12d 2exbidv elab4g fvex eqeltri raleq raleqbi1dv
      df-poset anbi12d imbi1d imbi12d 3anbi123d ralbidv 2ralbidv ceqsex2v bitri
      anbi2i ) EUBUCEUDUCZIKZDLZJKZFLZAKZVLVJMZVLBKZVJMZVNVLVJMZNZVLVNLZOZVOVNC
      KZVJMZNZVLVTVJMZOZPZCVHQZBVHQZAVHQZPZJRIRZNVGVLVLFMZVLVNFMZVNVLFMZNZVROZW
      LVNVTFMZNZVLVTFMZOZPZCDQZBDQADQZNVHUAKZSUEZLZVJXCUGUEZLZWHPZJRIRWJUAEUBXC
      ELZXHWIIJXIXEVIXGVKWHXIXDDVHXIXDESUEZDXCESUFGUHUIXIXFFVJXIXFEUGUEZFXCEUGU
      FHUHUIUJUKABCUAJIUQULWJXBVGWHWECDQZBDQZADQXBIJDFDXJUDGESUMUNFXKUDHEUGUMUN
      WGXMAVHDWFXLBVHDWECVHDUOUPUPVKXLXAABDDVKWEWTCDVKVMWKVSWOWDWSVLVLVJFTVKVQW
      NVRVKVOWLVPWMVLVNVJFTZVNVLVJFTURUSVKWBWQWCWRVKVOWLWAWPXNVNVTVJFTURVLVTVJF
      TUTVAVBVCVDVFVE $.
  $}

  ${
    $d K f b r x y z $.  $d B f b r x y z $.  $d .<_ f b r x y z $.
    $d X x y z $.  $d Y x y z $.  $d Z x y z $.
    ispos2.b $e |- B = ( Base ` K ) $.
    ispos2.l $e |- .<_ = ( le ` K ) $.
    $( A poset is an antisymmetric preset.

       _EDITORIAL_: could become the definition of poset.  (Contributed by
       Stefan O'Rear, 1-Feb-2015.) $)
    ispos2 $p |- ( K e. Poset <-> ( K e. Preset /\ A. x e. B A. y e. B
          ( ( x .<_ y /\ y .<_ x ) -> x = y ) ) ) $=
      ( vz cvv wcel cv wbr wa weq wi w3a wral ralbii bitri anbi2i cpreset ispos
      cpo 3anan32 r19.26 2ralbii r19.26-2 rr19.3v isprs anbi1i anass 3bitr4i )
      DIJZAKZUNELZUNBKZELZUPUNELMABNOZUQUPHKZELMUNUSELOZPZHCQZBCQACQZMUMUOUTMZH
      CQZBCQACQZURBCQZACQZMZMZDUCJDUAJZVHMZVCVIUMVCVEURHCQZMZBCQACQZVIVBVNABCCV
      BVDURMZHCQVNVAVPHCUOURUTUDRVDURHCUESUFVOVFVMBCQZACQZMVIVEVMABCCUGVRVHVFVQ
      VGACURBHCUHRTSSTABHCDEFGUBVLUMVFMZVHMVJVKVSVHABHCDEFGUIUJUMVFVHUKSUL $.
  $}

  ${
    $d K x y z $.
    $( A poset is a preset.  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    posprs $p |- ( K e. Poset -> K e. Preset ) $=
      ( vx vy cpo wcel cpreset cv cple cfv wbr weq cbs wral eqid ispos2 simplbi
      wa wi ) ADEAFEBGZCGZAHIZJTSUAJQBCKRCALIZMBUBMBCUBAUAUBNUANOP $.
  $}

  ${
    $d p x y z B $.  $d p K $.  $d p x y z .<_ $.  $d x y z X $.  $d y z Y $.
    $d z Z $.
    posi.b $e |- B = ( Base ` K ) $.
    posi.l $e |- .<_ = ( le ` K ) $.
    $( Lemma for poset properties.  (Contributed by NM, 11-Sep-2011.) $)
    posi $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                -> ( X .<_ X
                 /\ ( ( X .<_ Y /\ Y .<_ X ) -> X = Y )
                 /\ ( ( X .<_ Y /\ Y .<_ Z ) -> X .<_ Z ) ) ) $=
      ( vx vy vz wcel wbr wa wceq wi w3a breq1 breq2 imbi12d cpo wral cvv ispos
      simprbi bitrd anbi12d eqeq1 anbi1d 3anbi123d eqeq2 imbi1d 3anbi23d anbi2d
      cv 3anbi3d rspc3v mpan9 ) BUALZIUOZUTCMZUTJUOZCMZVBUTCMZNZUTVBOZPZVCVBKUO
      ZCMZNZUTVHCMZPZQZKAUBJAUBIAUBZDALEALFALQDDCMZDECMZEDCMZNZDEOZPZVPEFCMZNZD
      FCMZPZQZUSBUCLVNIJKABCGHUDUEVMWEVODVBCMZVBDCMZNZDVBOZPZWFVINZDVHCMZPZQVOV
      TVPEVHCMZNZWLPZQIJKDEFAAAUTDOZVAVOVGWJVLWMWQVADUTCMVOUTDUTCRUTDDCSUFWQVEW
      HVFWIWQVCWFVDWGUTDVBCRZUTDVBCSUGUTDVBUHTWQVJWKVKWLWQVCWFVIWRUIUTDVHCRTUJV
      BEOZWJVTWMWPVOWSWHVRWIVSWSWFVPWGVQVBEDCSZVBEDCRUGVBEDUKTWSWKWOWLWSWFVPVIW
      NWTVBEVHCRUGULUMVHFOZWPWDVOVTXAWOWBWLWCXAWNWAVPVHFECSUNVHFDCSTUPUQUR $.

    $( A poset ordering is reflexive.  (Contributed by NM, 11-Sep-2011.) $)
    posref $p |- ( ( K e. Poset /\ X e. B ) -> X .<_ X ) $=
      ( cpo wcel wa wbr wceq wi w3a id 3jca posi sylan2 simp1d ) BGHZDAHZIDDCJZ
      UAUAIZDDKLZUBUALZTSTTTMUAUCUDMTTTTTNZUEUEOABCDDDEFPQR $.

    $( A poset ordering is asymetric.  (Contributed by NM, 21-Oct-2011.) $)
    posasymb $p |- ( ( K e. Poset /\ X e. B /\ Y e. B )
                -> ( ( X .<_ Y /\ Y .<_ X ) <-> X = Y ) ) $=
      ( cpo wcel w3a wbr wa wceq wi simp1 simp2 simp3 posi syl13anc syl5ibcom
      simp2d posref breq2 breq1 jcad 3adant3 impbid ) BHIZDAIZEAIZJZDECKZEDCKZL
      ZDEMZUKDDCKZUNUONZULEECKLULNZUKUHUIUJUJUPUQURJUHUIUJOUHUIUJPUHUIUJQZUSABC
      DEEFGRSUAUHUIUOUNNUJUHUILZUOULUMUTUPUOULABCDFGUBZDEDCUCTUTUPUOUMVADEDCUDT
      UEUFUG $.

    $( A poset ordering is transitive.  (Contributed by NM, 11-Sep-2011.) $)
    postr $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                -> ( ( X .<_ Y /\ Y .<_ Z ) -> X .<_ Z ) ) $=
      ( cpo wcel w3a wa wbr wceq wi posi simp3d ) BIJDAJEAJFAJKLDDCMDECMZEDCMLD
      ENOREFCMLDFCMOABCDEFGHPQ $.
  $}

  ${
    $d a b c $.
    $( Technical lemma to simplify the statement of ~ ipopos .  The empty set
       is (rather pathologically) a poset under our definitions, since it has
       an empty base set ( ~ str0 ) and any relation partially orders an empty
       set.  (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    0pos $p |- (/) e. Poset $=
      ( va vb vc c0 cpo wcel cvv cv wbr wa weq w3a wral 0ex ral0 base0 cple c10
      wi df-ple str0 ispos mpbir2an ) DEFDGFAHZUDDIUDBHZDIZUEUDDIJABKSUFUECHZDI
      JUDUGDISLCDMBDMZADMNUHAOABCDDDPQRTUAUBUC $.
  $}

  ${
    $d x y z B $.  $d x y z K $.  $d x y z ph $.
    isposd.k $e |- ( ph -> K e. _V ) $.
    isposd.b $e |- ( ph -> B = ( Base ` K ) ) $.
    isposd.l $e |- ( ph -> .<_ = ( le ` K ) ) $.
    isposd.1 $e |- ( ( ph /\ x e. B ) -> x .<_ x ) $.
    isposd.2 $e |- ( ( ph /\ x e. B /\ y e. B ) ->
                   ( ( x .<_ y /\ y .<_ x ) -> x = y ) ) $.
    isposd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) ) ->
                   ( ( x .<_ y /\ y .<_ z ) -> x .<_ z ) ) $.
    $( Properties that determine a poset (implicit structure version).
       (Contributed by Mario Carneiro, 29-Apr-2014.) $)
    isposd $p |- ( ph -> K e. Poset ) $=
      ( wcel cv wbr wa wi wral breqd cvv cple cfv weq w3a cbs cpo adantrr 3expb
      adantr 3exp2 3jca ralrimiva ralrimivva anbi12d imbi1d 3anbi123d raleqbidv
      imp42 imbi12d anbi2d mpbi2and eqid ispos sylibr ) AFUANZBOZVGFUBUCZPZVGCO
      ZVHPZVJVGVHPZQZBCUDZRZVKVJDOZVHPZQZVGVPVHPZRZUEZDFUFUCZSZCWBSZBWBSZQZFUGN
      AVFVGVGGPZVGVJGPZVJVGGPZQZVNRZWHVJVPGPZQZVGVPGPZRZUEZDESZCESZBESZWFHAWQBC
      EEAVGENZVJENZQQZWPDEXBVPENZQWGWKWOXBWGXCAWTWGXAKUHUJXBWKXCAWTXAWKLUIUJAWT
      XAXCWOAWTXAXCWOMUKUSULUMUNAWSWEVFAWRWDBEWBIAWQWCCEWBIAWPWADEWBIAWGVIWKVOW
      OVTAGVHVGVGJTAWJVMVNAWHVKWIVLAGVHVGVJJTZAGVHVJVGJTUOUPAWMVRWNVSAWHVKWLVQX
      DAGVHVJVPJTUOAGVHVGVPJTUTUQURURURVAVBBCDWBFVHWBVCVHVCVDVE $.
  $}

  ${
    $d x y z B $.  $d x y z .<_ $.
    isposi.k $e |- K e. _V $.
    isposi.b $e |- B = ( Base ` K ) $.
    isposi.l $e |- .<_ = ( le ` K ) $.
    isposi.1 $e |- ( x e. B -> x .<_ x ) $.
    isposi.2 $e |- ( ( x e. B /\ y e. B ) ->
                   ( ( x .<_ y /\ y .<_ x ) -> x = y ) ) $.
    isposi.3 $e |- ( ( x e. B /\ y e. B /\ z e. B ) ->
                   ( ( x .<_ y /\ y .<_ z ) -> x .<_ z ) ) $.
    $( Properties that determine a poset (implicit structure version).
       (Contributed by NM, 11-Sep-2011.) $)
    isposi $p |- K e. Poset $=
      ( cpo wcel cv wbr wa wi w3a wral cvv 3ad2ant1 3adant3 3jca rgen3 mpbir2an
      weq ispos ) EMNEUANAOZUIFPZUIBOZFPZUKUIFPQABUGRZULUKCOZFPQUIUNFPRZSZCDTBD
      TADTGUPABCDDDUIDNZUKDNZUNDNZSUJUMUOUQURUJUSJUBUQURUMUSKUCLUDUEABCDEFHIUHU
      F $.
  $}

  ${
    $d p x y z B $.  $d p K $.  $d p x y z .<_ $.
    isposix.a $e |- B e. _V $.
    isposix.b $e |- .<_ e. _V $.
    isposix.k $e |- K = { <. ( Base ` ndx ) , B >. ,
         <. ( le ` ndx ) , .<_ >. } $.
    isposix.1 $e |- ( x e. B -> x .<_ x ) $.
    isposix.2 $e |- ( ( x e. B /\ y e. B ) ->
                   ( ( x .<_ y /\ y .<_ x ) -> x = y ) ) $.
    isposix.3 $e |- ( ( x e. B /\ y e. B /\ z e. B ) ->
                   ( ( x .<_ y /\ y .<_ z ) -> x .<_ z ) ) $.
    $( Properties that determine a poset (explicit structure version).  Note
       that the numeric indices of the structure components are not mentioned
       explicitly in either the theorem or its proof.  (Contributed by NM,
       9-Nov-2012.) $)
    isposix $p |- K e. Poset $=
      ( cnx cbs cfv cop cple cvv wcel wceq cpr eqeltri c10 df-ple 1lt10 2strbas
      prex 10nn ax-mp 2strop isposi ) ABCDEFEMNODPZMQOFPZUARIULUMUGUBDRSDENOTGD
      FQEUCRIUDUEUHUFUIFRSFEQOTHDFQEUCRIUDUEUHUJUIJKLUK $.
  $}

  $( Define less-than ordering for posets and related structures.  Unlike
     ~ df-base and ~ df-ple , this is a derived component extractor and not an
     extensible structure component extractor that defines the poset.
     (Contributed by NM, 12-Oct-2011.)  (Revised by Mario Carneiro,
     8-Feb-2015.) $)
  df-plt $a |- lt = ( p e. _V |-> ( ( le ` p ) \ _I ) ) $.

  ${
    $d p K $.  $d p .<_ $.
    pltval.l $e |- .<_ = ( le ` K ) $.
    pltval.s $e |- .< = ( lt ` K ) $.
    $( Value of the less-than relation.  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    pltfval $p |- ( K e. A -> .< = ( .<_ \ _I ) ) $=
      ( vp wcel cplt cfv cid cdif cvv wceq elex cv cple fveq2 syl6eqr difeq1d
      df-plt fvex eqeltri difexg ax-mp fvmpt syl syl5eq ) CAHZBCIJZDKLZFUICMHUJ
      UKNCAOGCGPZQJZKLUKMIULCNZUMDKUNUMCQJZDULCQRESTGUADMHUKMHDUOMECQUBUCDKMUDU
      EUFUGUH $.

    $( Less-than relation.  ( ~ df-pss analog.)  (Contributed by NM,
       12-Oct-2011.) $)
    pltval $p |- ( ( K e. A /\ X e. B /\ Y e. C )
        -> ( X .< Y <-> ( X .<_ Y /\ X =/= Y ) ) ) $=
      ( wcel wbr wne wa wb cid cdif pltfval breqd wn brdif adantl anbi2d syl5bb
      ideqg necon3bbid sylan9bb 3impb ) EAKZGBKZHCKZGHDLZGHFLZGHMZNZOUIULGHFPQZ
      LZUJUKNZUOUIDUPGHADEFIJRSUQUMGHPLZTZNURUOGHFPUAURUTUNUMUKUTUNOUJUKUSGHGHC
      UEUFUBUCUDUGUH $.

    $( Less-than implies less-than-or-equal.  ( ~ pssss analog.)  (Contributed
       by NM, 4-Dec-2011.) $)
    pltle $p |- ( ( K e. A /\ X e. B /\ Y e. C ) -> ( X .< Y -> X .<_ Y ) ) $=
      ( wcel w3a wbr wne pltval simprbda ex ) EAKGBKHCKLZGHDMZGHFMZRSTGHNABCDEF
      GHIJOPQ $.
  $}

  ${
    pltne.s $e |- .< = ( lt ` K ) $.
    $( Less-than relation.  ( ~ df-pss analog.)  (Contributed by NM,
       2-Dec-2011.) $)
    pltne $p |- ( ( K e. A /\ X e. B /\ Y e. C )
        -> ( X .< Y -> X =/= Y ) ) $=
      ( wcel w3a wbr wne cple cfv eqid pltval simplbda ex ) EAIFBIGCIJZFGDKZFGL
      ZSTFGEMNZKUAABCDEUBFGUBOHPQR $.

    $( The less-than relation is not reflexive.  ( ~ pssirr analog.)
       (Contributed by NM, 7-Feb-2012.) $)
    pltirr $p |- ( ( K e. A /\ X e. B ) -> -. X .< X ) $=
      ( wcel wa wceq wbr wn eqid wne wi pltne 3anidm23 necon2bd mpi ) DAGZEBGZH
      ZEEIEECJZKELUAUBEESTUBEEMNABBCDEEFOPQR $.
  $}

  ${
    pleval2.b $e |- B = ( Base ` K ) $.
    pleval2.l $e |- .<_ = ( le ` K ) $.
    pleval2.s $e |- .< = ( lt ` K ) $.
    $( One direction of ~ pleval2 .  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    pleval2i $p |- ( ( X e. B /\ Y e. B ) ->
      ( X .<_ Y -> ( X .< Y \/ X = Y ) ) ) $=
      ( wcel wa wbr wceq wo wne cbs cdm wb cfv elfvdm eleq2s adantr pltval expr
      3expb mpancom biimpar necon1bd orrd ex ) EAJZFAJZKZEFDLZEFBLZEFMZNUMUNKZU
      OUPUQUOEFUMUNEFOZUOUMUOUNURKZCPQZJZUMUOUSRZUKVAULVAECPSAECPTGUAUBVAUKULVB
      UTAABCDEFHIUCUEUFUGUDUHUIUJ $.

    $( Less-than-or-equal in terms of less-than.  ( ~ sspss analog.)
       (Contributed by NM, 17-Oct-2011.)  (Revised by Mario Carneiro,
       8-Feb-2015.) $)
    pleval2 $p |- ( ( K e. Poset /\ X e. B /\ Y e. B )
        -> ( X .<_ Y <-> ( X .< Y \/ X = Y ) ) ) $=
      ( cpo wcel w3a wbr wceq wo wi pleval2i 3adant1 pltle posref 3adant3 breq2
      syl5ibcom jaod impbid ) CJKZEAKZFAKZLZEFDMZEFBMZEFNZOZUGUHUJUMPUFABCDEFGH
      IQRUIUKUJULJAABCDEFHISUIEEDMZULUJUFUGUNUHACDEGHTUAEFEDUBUCUDUE $.

    $( Less-than implies not inverse less-than-or-equal.  (Contributed by NM,
       18-Oct-2011.) $)
    pltnle $p |- ( ( ( K e. Poset /\ X e. B /\ Y e. B ) /\ X .< Y )
                    -> -. Y .<_ X ) $=
      ( cpo wcel w3a wbr wn wne wa pltval wceq posasymb biimpd expdimp necon3ad
      expimpd sylbid imp ) CJKEAKFAKLZEFBMZFEDMZNZUFUGEFDMZEFOZPUIJAABCDEFHIQUF
      UJUKUIUFUJPUHEFUFUJUHEFRZUFUJUHPULACDEFGHSTUAUBUCUDUE $.

    $( Alternate expression for less-than relation.  ( ~ dfpss3 analog.)
       (Contributed by NM, 4-Nov-2011.) $)
    pltval3 $p |- ( ( K e. Poset /\ X e. B /\ Y e. B )
        -> ( X .< Y <-> ( X .<_ Y /\ -. Y .<_ X ) ) ) $=
      ( cpo wcel w3a wbr wne wa wn pltval wceq wi posref breq1 syl5ibcom adantr
      3adant3 posasymb biimpd expdimp impbid necon3abid pm5.32da bitrd ) CJKZEA
      KZFAKZLZEFBMEFDMZEFNZOUPFEDMZPZOJAABCDEFHIQUOUPUQUSUOUPOZUREFUTEFRZURUOVA
      URSUPUOEEDMZVAURULUMVBUNACDEGHTUDEFEDUAUBUCUOUPURVAUOUPUROVAACDEFGHUEUFUG
      UHUIUJUK $.
  $}

  ${
    pltnlt.b $e |- B = ( Base ` K ) $.
    pltnlt.s $e |- .< = ( lt ` K ) $.
    $( The less-than relation implies the negation of its inverse.
       (Contributed by NM, 18-Oct-2011.) $)
    pltnlt $p |- ( ( ( K e. Poset /\ X e. B /\ Y e. B ) /\ X .< Y )
                  -> -. Y .< X ) $=
      ( cpo wcel w3a wbr wa cple cfv eqid pltnle wi pltle 3com23 adantr mtod )
      CHIZDAIZEAIZJZDEBKZLEDBKZEDCMNZKZABCUHDEFUHOZGPUEUGUIQZUFUBUDUCUKHAABCUHE
      DUJGRSTUA $.

    $( The less-than relation has no 2-cycle loops.  ( ~ pssn2lp analog.)
       (Contributed by NM, 2-Dec-2011.) $)
    pltn2lp $p |- ( ( K e. Poset /\ X e. B /\ Y e. B )
        -> -. ( X .< Y /\ Y .< X ) ) $=
      ( cpo wcel w3a wbr wn wi wa cple cfv eqid pltnle ex pltle 3com23 nsyld
      imnan sylib ) CHIZDAIZEAIZJZDEBKZEDBKZLMUIUJNLUHUIEDCOPZKZUJUHUIULLABCUKD
      EFUKQZGRSUEUGUFUJULMHAABCUKEDUMGTUAUBUIUJUCUD $.

    $( The less-than relation is transitive.  ( ~ psstr analog.)  (Contributed
       by NM, 2-Dec-2011.) $)
    plttr $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) )
        -> ( ( X .< Y /\ Y .< Z ) -> X .< Z ) ) $=
      ( cpo wcel w3a wa wbr cple cfv wne wi pltle 3adant3r3 wn eqid postr breq2
      3adant3r1 syl2and wceq pltn2lp anbi2d notbid syl5ibcom necon2ad wb pltval
      jcad 3adant3r2 sylibrd ) CIJZDAJZEAJZFAJZKLZDEBMZEFBMZLZDFCNOZMZDFPZLZDFB
      MZVAVDVFVGVAVBDEVEMZVCEFVEMZVFUQURUSVBVJQUTIAABCVEDEVEUAZHRSUQUSUTVCVKQUR
      IAABCVEEFVLHRUDACVEDEFGVLUBUEVAVDDFVAVBEDBMZLZTZDFUFZVDTUQURUSVOUTABCDEGH
      UGSVPVNVDVPVMVCVBDFEBUCUHUIUJUKUNUQURUTVIVHULUSIAABCVEDFVLHUMUOUP $.
  $}

  ${
    pltletr.b $e |- B = ( Base ` K ) $.
    pltletr.l $e |- .<_ = ( le ` K ) $.
    pltletr.s $e |- .< = ( lt ` K ) $.
    $( Transitive law for chained less-than and less-than-or-equal.
       ( ~ psssstr analog.)  (Contributed by NM, 2-Dec-2011.) $)
    pltletr $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) )
        -> ( ( X .< Y /\ Y .<_ Z ) -> X .< Z ) ) $=
      ( cpo wcel w3a wa wbr wceq wo wb pleval2 3adant3r1 plttr expdimp wi breq2
      adantr biimpcd adantl jaod sylbid expimpd ) CKLZEALZFALZGALZMNZEFBOZFGDOZ
      EGBOZUOUPNZUQFGBOZFGPZQZURUOUQVBRZUPUKUMUNVCULABCDFGHIJSTUEUSUTURVAUOUPUT
      URABCEFGHJUAUBUPVAURUCUOVAUPURFGEBUDUFUGUHUIUJ $.

    $( Transitive law for chained less-than-or-equal and less-than.
       ( ~ sspsstr analog.)  (Contributed by NM, 2-May-2012.) $)
    plelttr $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) )
        -> ( ( X .<_ Y /\ Y .< Z ) -> X .< Z ) ) $=
      ( cpo wcel w3a wa wbr wceq wo wi wb pleval2 3adant3r3 plttr exp3a biimprd
      breq1 a1i jaod sylbid imp3a ) CKLZEALZFALZGALZMNZEFDOZFGBOZEGBOZUNUOEFBOZ
      EFPZQZUPUQRZUJUKULUOUTSUMABCDEFHIJTUAUNURVAUSUNURUPUQABCEFGHJUBUCUSVARUNU
      SUQUPEFGBUEUDUFUGUHUI $.
  $}

  ${
    $d x y z .< $.  $d x y z .<_ $.  $d x y z B $.  $d x y z K $.
    $d x y z V $.
    pospo.b $e |- B = ( Base ` K ) $.
    pospo.l $e |- .<_ = ( le ` K ) $.
    pospo.s $e |- .< = ( lt ` K ) $.
    $( Write a poset structure in terms of the proper-class poset predicate
       (strict less than version).  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    pospo $p |- ( K e. V ->
      ( K e. Poset <-> ( .< Po B /\ ( _I |` B ) C_ .<_ ) ) ) $=
      ( vx vy vz wcel wa cv a1i wceq wbr syl2anc wo wi cpo wpo cid pltirr plttr
      cres wss ispod wrel relres cop copab opabresid eleq2i opabid bitr3i df-br
      posref breq2 syl5bbr syl5ibrcom expimpd syl5bi relssdv jca cvv adantr cbs
      elex cfv cple equid wb simpr resieq mpbiri simplrr ssbrd mpd w3a pleval2i
      3adant1 ancoms wn simprl po2nr 3impb syl3an1 pm2.21d simpl eqcomd syl2and
      ccased simpr1 simpr2 simpr3 potr sylan simpll pltle syl3anc breq1 biimpar
      syld syl5 biimpac syldan eqtr breq2d syl5ibcom isposd ex impbid2 ) CELZCU
      ALZABUBZUCAUFZDUGZMZXOXPXRXOIJKABUAABCINZHUDABCXTJNZKNZFHUEUHXOIJXQDXQUIX
      OUCAUJOXTYAUKZXQLZXTALZYAXTPZMZXOYCDLZYDYCYGIJULZLYGYIXQYCIJAUMUNYGIJUOUP
      XOYEYFYHXOYEMYHYFXTXTDQZACDXTFGURYHXTYADQZYFYJXTYADUQYAXTXTDUSUTVAVBVCVDV
      EXNXSXOXNXSMZIJKACDXNCVFLXSCEVIVGACVHVJPYLFODCVKVJPYLGOYLYEMZXTXTXQQZYJYM
      YNXTXTPZIVLYMYEYEYNYOVMYLYEVNZYPAXTXTVORVPYMXQDXTXTXNXPXRYEVQVRVSZYLYEYAA
      LZVTZYKXTYABQZXTYAPZSZYAXTDQZYAXTBQZYFSZUUAYEYRYKUUBTZYLABCDXTYAFGHWAZWBY
      EYRUUCUUETZYLYRYEUUHABCDYAXTFGHWAWCWBYSYTUUDUUAYFUUAYSYTUUDMZUUAYLXPYEYRU
      UIWDZXNXPXRWEZXPYEYRUUJAXTYABWFWGWHWIUUAUUDMUUATYSUUAUUDWJOYTYFMZUUATYSUU
      LYAXTYTYFVNWKOUUAYFMUUATYSUUAYFWJOWMWLYLYEYRYBALZVTZMZYKUUBYAYBDQZYAYBBQZ
      YAYBPZSZXTYBDQZUUOYEYRUUFYLYEYRUUMWNZYLYEYRUUMWOZUUGRUUOYRUUMUUPUUSTUVBYL
      YEYRUUMWPZABCDYAYBFGHWARUUOYTUUQUUAUURUUTUUOYTUUQMZXTYBBQZUUTYLXPUUNUVDUV
      ETUUKAXTYAYBBWQWRUUOXNYEUUMUVEUUTTXNXSUUNWSUVAUVCEAABCDXTYBGHWTXAZXDUUAUU
      QMUVEUUOUUTUUAUVEUUQXTYAYBBXBXCUVFXEYTUURMUVEUUOUUTUURYTUVEYAYBXTBUSXFUVF
      XEUUOYJUUAUURMZUUTYLUUNYEYJUVAYQXGUVGXTYBXTDXTYAYBXHXIXJWMWLXKXLXM $.
  $}

  ${
    $d p s t u x y z $.
    $( Define poset least upper bound.  If it doesn't exist, an undefined value
       not in the base set is returned.  (Contributed by NM, 12-Sep-2011.) $)
    df-lub $a |- lub = ( p e. _V |-> ( s e. ~P ( Base ` p ) |->
        ( iota_ x e. ( Base ` p ) ( A. y e. s y ( le ` p ) x
                          /\ A. z e. ( Base ` p )
                  ( A. y e. s y ( le ` p ) z -> x ( le ` p ) z ) ) ) ) ) $.

    $( Define poset least upper bound.  If it doesn't exist, an undefined value
       not in the base set is returned. $)
    $(
    df-lubOLD $a |- lub = ( p e. _V |-> ( s e. ~P ( Base ` p ) |->
     { t | E. u ( u = { x e. ( Base ` p ) | ( A. y e. s y ( le ` p ) x
                          /\ A. z e. ( Base ` p )
                             ( A. y e. s y ( le ` p ) z -> x ( le ` p ) z ) ) }
      /\ t = if ( E. v u = { v } , U. u , ( Undef ` ( Base ` p ) ) ) ) } ) ) $.
    $)

    $( Define poset greatest lower bound.  (Contributed by NM, 19-Jul-2012.) $)
    df-glb $a |- glb = ( p e. _V |-> ( s e. ~P ( Base ` p ) |->
        ( iota_ x e. ( Base ` p ) ( A. y e. s x ( le ` p ) y
                          /\ A. z e. ( Base ` p )
                  ( A. y e. s z ( le ` p ) y -> z ( le ` p ) x ) ) ) ) ) $.

    $( Define poset join.  (Contributed by NM, 12-Sep-2011.) $)
    df-join $a |- join = ( p e. _V |-> ( x e. ( Base ` p ) , y e. ( Base ` p )
        |-> ( ( lub ` p ) ` { x , y } ) ) ) $.

    $( Define poset meet.  (Contributed by NM, 12-Sep-2011.) $)
    df-meet $a |- meet = ( p e. _V |-> ( x e. ( Base ` p ) , y e. ( Base ` p )
        |-> ( ( glb ` p ) ` { x , y } ) ) ) $.
  $}

  ${
    $d p s x z B $.  $d p s x y z K $.  $d p .<_ $.
    lubfval.b $e |- B = ( Base ` K ) $.
    lubfval.l $e |- .<_ = ( le ` K ) $.
    lubfval.u $e |- U = ( lub ` K ) $.
    $( Value of the least upper bound function of a poset.  (Contributed by NM,
       12-Sep-2011.) $)
    lubfval $p |- ( K e. A -> U = ( s e. ~P B |-> ( iota_ x e. B
   ( A. y e. s y .<_ x /\ A. z e. B ( A. y e. s y .<_ z -> x .<_ z ) ) ) ) ) $=
      ( vp cvv cv wbr wral cfv cbs cple wcel cpw wi wa crio cmpt wceq elex club
      fveq2 syl6eqr pweqd breqd ralbidv imbi12d raleqbidv riotaeqbidv mpteq12dv
      anbi12d df-lub fvex eqeltri pwex mptex fvmpt syl5eq syl ) GDUAGNUAZFIEUBZ
      BOZAOZHPZBIOZQZVJCOZHPZBVMQZVKVOHPZUCZCEQZUDZAEUEZUFZUGGDUHVHFGUIRWCLMGIM
      OZSRZUBZVJVKWDTRZPZBVMQZVJVOWGPZBVMQZVKVOWGPZUCZCWEQZUDZAWEUEZUFWCNUIWDGU
      GZIWFWPVIWBWQWEEWQWEGSRZEWDGSUJJUKZULWQWOWAAWEEWSWQWIVNWNVTWQWHVLBVMWQWGH
      VJVKWQWGGTRHWDGTUJKUKZUMUNWQWMVSCWEEWSWQWKVQWLVRWQWJVPBVMWQWGHVJVOWTUMUNW
      QWGHVKVOWTUMUOUPUSUQURABCIMUTIVIWBEEWRNJGSVAVBVCVDVEVFVG $.
  $}

  ${
    $d s x z B $.  $d s x y z K $.  $d s .<_ $.  $d s x y z S $.
    lubval.b $e |- B = ( Base ` K ) $.
    lubval.l $e |- .<_ = ( le ` K ) $.
    lubval.u $e |- U = ( lub ` K ) $.
    $( Value of the least upper bound of a poset.  (Contributed by NM,
       12-Sep-2011.) $)
    lubval $p |- ( ( K e. A /\ S C_ B ) -> ( U ` S ) = ( iota_ x e. B
     ( A. y e. S y .<_ x /\ A. z e. B ( A. y e. S y .<_ z -> x .<_ z ) ) ) ) $=
      ( vs wcel cfv cv wbr wral wi wa wss cpw crio cmpt lubfval fveq1d wceq cbs
      cvv fvex eqeltri elpw2 raleq ralbidv anbi12d riotabidv eqid riotaex fvmpt
      imbi1d sylbir sylan9eq ) HDNZFEUAZFGOFMEUBZBPZAPZIQZBMPZRZVFCPZIQZBVIRZVG
      VKIQZSZCERZTZAEUCZUDZOZVHBFRZVLBFRZVNSZCERZTZAEUCZVCFGVSABCDEGHIMJKLUEUFV
      DFVENVTWFUGFEEHUHOUIJHUHUJUKULMFVRWFVEVSVIFUGZVQWEAEWGVJWAVPWDVHBVIFUMWGV
      OWCCEWGVMWBVNVLBVIFUMUTUNUOUPVSUQWEAEURUSVAVB $.

    $d w B $.  $d w x .<_ $.  $d w S $.  $d w x y z U $.
    $( Properties of greatest lower bound of a poset.  (Contributed by NM,
       22-Oct-2011.) $)
    lubprop $p |- ( ( K e. A /\ S C_ B /\ ( U ` S ) e. B ) ->
         ( A. y e. S y .<_ ( U ` S )
               /\ A. z e. B ( A. y e. S y .<_ z -> ( U ` S ) .<_ z ) ) ) $=
      ( vx wcel cfv cv wbr wral wi wa wceq wss crio lubval 3adant3 eqcomd simp3
      w3a wreu wb eqeltrrd cbs fvex eqeltri riotaclb sylibr breq2 ralbidv breq1
      cvv imbi2d anbi12d riota2 syl2anc mpbird ) GCMZEDUAZEFNZDMZUGZAOZVGHPZAEQ
      ZVJBOZHPAEQZVGVMHPZRZBDQZSZVJLOZHPZAEQZVNVSVMHPZRZBDQZSZLDUBZVGTZVIVGWFVE
      VFVGWFTVHLABCDEFGHIJKUCUDZUEVIVHWELDUHZVRWGUIVEVFVHUFZVIWFDMWIVIVGWFDWHWJ
      UJWELDDGUKNUSIGUKULUMUNUOWEVRLDVGVSVGTZWAVLWDVQWKVTVKAEVSVGVJHUPUQWKWCVPB
      DWKWBVOVNVSVGVMHURUTUQVAVBVCVD $.
  $}

  ${
    $d z B $.  $d y z K $.  $d y .<_ $.  $d y z S $.  $d y z U $.  $d y X $.
    luble.b $e |- B = ( Base ` K ) $.
    luble.l $e |- .<_ = ( le ` K ) $.
    luble.u $e |- U = ( lub ` K ) $.
    $( The greatest lower bound is the least element.  (Contributed by NM,
       22-Oct-2011.) $)
    luble $p |- ( ( ( K e. A /\ S C_ B ) /\ ( ( U ` S ) e. B /\ X e. S ) )
                   -> X .<_ ( U ` S ) ) $=
      ( vy vz wcel wss cfv wbr wi w3a cv wral lubprop simpld breq1 rspccv imp43
      syl 3exp ) EAMZCBNZCDOZBMZGCMZGUJFPZUHUIUKULUMQZUHUIUKRZKSZUJFPZKCTZUNUOU
      RUPLSZFPKCTUJUSFPQLBTKLABCDEFHIJUAUBUQUMKGCUPGUJFUCUDUFUGUE $.
  $}

  ${
    $d w x y z B $.  $d w x z K $.  $d w x y z .<_ $.  $d w x y z X $.
    lubid.b $e |- B = ( Base ` K ) $.
    lubid.l $e |- .<_ = ( le ` K ) $.
    lubid.u $e |- U = ( lub ` K ) $.
    $( The LUB of elements less than or equal to a fixed value equals that
       value.  (Contributed by NM, 19-Oct-2011.) $)
    lubid $p |- ( ( K e. Poset /\ X e. B )
                      -> ( U ` { y e. B | y .<_ X } ) = X ) $=
      ( vz vx vw wcel wa cv wbr wral wi wceq breq1 cpo crab cfv crio wss ssrab2
      lubval mpan2 adantr simpr ralrab imbi1i ralbii anbi12i posref imbi12d idd
      rspcva syl5com mpand rgen breq2 imbi2d ralbidv mpii ad2antlr w3a posasymb
      rspcv biimpd 3com23 3expa ancomsd syl2and biimprd ralrimivw adantl simplr
      wb pm5.5 syl bicomd sylan9bb syl5ib adantlr ex impbid syl5bb riota5 eqtrd
      jca ) DUAMZFBMZNZAOZFEPZABUBZCUCZJOZKOZEPZJWQQZWSLOZEPZJWQQZWTXCEPZRZLBQZ
      NZKBUDZFWLWRXJSZWMWLWQBUEXKWPABUFKJLUABWQCDEGHIUGUHUIWNXIKBFWLWMUJZXIWSFE
      PZXARZJBQZXMXDRZJBQZXFRZLBQZNZWNWTBMZNZWTFSZXBXOXHXSWPXMXAJABWOWSFETZUKXG
      XRLBXEXQXFWPXMXDJABYDUKULUMUNYBXTYCYBXOFWTEPZXSWTFEPZYCWNXOYERYAWNWMXOYEX
      LWNFFEPZWMXONYEBDEFGHUOZXNYGYERJFBWSFSZXMYGXAYEWSFFETZWSFWTETUPURUSUTUIWM
      XSYFRWLYAWMXSXMXMRZJBQZYFYKJBWSBMXMUQVAXRYLYFRLFBXCFSZXQYLXFYFYMXPYKJBYMX
      DXMXMXCFWSEVBVCVDXCFWTEVBUPVIVEVFYBYFYEYCWLWMYAYFYENZYCRZWLYAWMYOWLYAWMVG
      YNYCBDEWTFGHVHVJVKVLVMVNYBYCXTYBYCNXOXSYCXOYBYCXNJBYCXAXMWTFWSEVBVOVPVQWN
      YCXSYAWNYCNZXRLBYPWMXQXFWLWMYCVRWMXQNYGFXCEPZRZYPXFXPYRJFBYIXMYGXDYQYJWSF
      XCETUPURWNYRYQYCXFWNYGYRYQVSYHYGYQVTWAYCXFYQWTFXCETWBWCWDUTVPWEWKWFWGWHWI
      WJ $.
  $}

  ${
    $d k s x z B $.  $d k s x y z K $.  $d k .<_ $.
    glbfval.b $e |- B = ( Base ` K ) $.
    glbfval.l $e |- .<_ = ( le ` K ) $.
    glbfval.g $e |- G = ( glb ` K ) $.
    $( Value of the least upper bound function of a poset.  (Contributed by NM,
       19-Jul-2012.) $)
    glbfval $p |- ( K e. A -> G = ( s e. ~P B |-> ( iota_ x e. B
   ( A. y e. s x .<_ y /\ A. z e. B ( A. y e. s z .<_ y -> z .<_ x ) ) ) ) ) $=
      ( vk cvv cv wbr wral cfv cbs cple wcel cpw wi wa crio cmpt wceq elex cglb
      fveq2 syl6eqr pweqd breqd ralbidv imbi12d raleqbidv riotaeqbidv mpteq12dv
      anbi12d df-glb fvex eqeltri pwex mptex fvmpt syl5eq syl ) GDUAGNUAZFIEUBZ
      AOZBOZHPZBIOZQZCOZVKHPZBVMQZVOVJHPZUCZCEQZUDZAEUEZUFZUGGDUHVHFGUIRWCLMGIM
      OZSRZUBZVJVKWDTRZPZBVMQZVOVKWGPZBVMQZVOVJWGPZUCZCWEQZUDZAWEUEZUFWCNUIWDGU
      GZIWFWPVIWBWQWEEWQWEGSRZEWDGSUJJUKZULWQWOWAAWEEWSWQWIVNWNVTWQWHVLBVMWQWGH
      VJVKWQWGGTRHWDGTUJKUKZUMUNWQWMVSCWEEWSWQWKVQWLVRWQWJVPBVMWQWGHVOVKWTUMUNW
      QWGHVOVJWTUMUOUPUSUQURABCIMUTIVIWBEEWRNJGSVAVBVCVDVEVFVG $.
  $}

  ${
    $d s x z B $.  $d s x y z K $.  $d s .<_ $.  $d s x y z S $.
    glbval.b $e |- B = ( Base ` K ) $.
    glbval.l $e |- .<_ = ( le ` K ) $.
    glbval.g $e |- G = ( glb ` K ) $.
    $( Value of greatest lower bound of a poset.  (Contributed by NM,
       19-Jul-2012.) $)
    glbval $p |- ( ( K e. A /\ S C_ B ) -> ( G ` S ) = ( iota_ x e. B
     ( A. y e. S x .<_ y /\ A. z e. B ( A. y e. S z .<_ y -> z .<_ x ) ) ) ) $=
      ( vs wcel cfv cv wbr wral wi wa wss cpw crio cmpt glbfval fveq1d wceq cbs
      cvv fvex eqeltri elpw2 raleq ralbidv anbi12d riotabidv eqid riotaex fvmpt
      imbi1d sylbir sylan9eq ) HDNZFEUAZFGOFMEUBZAPZBPZIQZBMPZRZCPZVGIQZBVIRZVK
      VFIQZSZCERZTZAEUCZUDZOZVHBFRZVLBFRZVNSZCERZTZAEUCZVCFGVSABCDEGHIMJKLUEUFV
      DFVENVTWFUGFEEHUHOUIJHUHUJUKULMFVRWFVEVSVIFUGZVQWEAEWGVJWAVPWDVHBVIFUMWGV
      OWCCEWGVMWBVNVLBVIFUMUTUNUOUPVSUQWEAEURUSVAVB $.

    $d w B $.  $d w x y z G $.  $d w x .<_ $.  $d w S $.
    $( Properties of greatest lower bound of a poset.  (Contributed by NM,
       19-Jul-2012.) $)
    glbprop $p |- ( ( K e. A /\ S C_ B /\ ( G ` S ) e. B ) ->
         ( A. y e. S ( G ` S ) .<_ y
               /\ A. z e. B ( A. y e. S z .<_ y -> z .<_ ( G ` S ) ) ) ) $=
      ( vx wcel cfv cv wbr wral wi wa wceq wss crio glbval 3adant3 eqcomd simp3
      w3a wreu wb eqeltrrd cbs fvex eqeltri riotaclb sylibr breq1 ralbidv breq2
      cvv imbi2d anbi12d riota2 syl2anc mpbird ) GCMZEDUAZEFNZDMZUGZVGAOZHPZAEQ
      ZBOZVJHPAEQZVMVGHPZRZBDQZSZLOZVJHPZAEQZVNVMVSHPZRZBDQZSZLDUBZVGTZVIVGWFVE
      VFVGWFTVHLABCDEFGHIJKUCUDZUEVIVHWELDUHZVRWGUIVEVFVHUFZVIWFDMWIVIVGWFDWHWJ
      UJWELDDGUKNUSIGUKULUMUNUOWEVRLDVGVSVGTZWAVLWDVQWKVTVKAEVSVGVJHUPUQWKWCVPB
      DWKWBVOVNVSVGVMHURUTUQVAVBVCVD $.

    $d y .<_ $.  $d y X $.
    $( The greatest lower bound is the least element.  (Contributed by NM,
       12-Oct-2011.) $)
    glble $p |- ( ( ( K e. A /\ S C_ B ) /\ ( ( G ` S ) e. B /\ X e. S ) )
                   -> ( G ` S ) .<_ X ) $=
      ( vy vz wcel wss cfv wbr wi w3a cv wral glbprop simpld breq2 rspccv imp43
      syl 3exp ) EAMZCBNZCDOZBMZGCMZUJGFPZUHUIUKULUMQZUHUIUKRZUJKSZFPZKCTZUNUOU
      RLSZUPFPKCTUSUJFPQLBTKLABCDEFHIJUAUBUQUMKGCUPGUJFUCUDUFUGUE $.
  $}

  ${
    $d p x y B $.  $d p x y K $.  $d p U $.
    joinfval.b $e |- B = ( Base ` K ) $.
    joinfval.u $e |- U = ( lub ` K ) $.
    joinfval.j $e |- .\/ = ( join ` K ) $.
    $( Value of join function for a poset.  (Contributed by NM,
       12-Sep-2011.) $)
    joinfval $p |- ( K e. A
               -> .\/ = ( x e. B , y e. B |-> ( U ` { x , y } ) ) ) $=
      ( vp wcel cvv cv cfv cmpt2 wceq cjn cbs club cpr elex syl6eqr mpt2eq123dv
      fveq2 fveq1d df-join fvex eqeltri mpt2ex fvmpt syl5eq syl ) GCLGMLZFABDDA
      NBNUAZEOZPZQGCUBUNFGROUQJKGABKNZSOZUSUOURTOZOZPUQMRURGQZABUSUSVADDUPVBUSG
      SOZDURGSUEHUCZVDVBUOUTEVBUTGTOEURGTUEIUCUFUDABKUGABDDUPDVCMHGSUHUIZVEUJUK
      ULUM $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y U $.  $d x y X $.  $d x y Y $.
    joinval.b $e |- B = ( Base ` K ) $.
    joinval.u $e |- U = ( lub ` K ) $.
    joinval.j $e |- .\/ = ( join ` K ) $.
    $( Value of join for a poset.  (Contributed by NM, 12-Sep-2011.) $)
    joinval $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X .\/ Y ) =
              ( U ` { X , Y } ) ) $=
      ( vx vy wcel co cpr cfv wceq wa cv fveq2d cmpt2 joinfval oveqd preq1 eqid
      preq2 fvex ovmpt2 sylan9eq 3impb ) EAMZFBMZGBMZFGDNZFGOZCPZQUKULUMRUNFGKL
      BBKSZLSZOZCPZUAZNUPUKDVAFGKLABCDEHIJUBUCKLFGBBUTUPVAFUROZCPUQFQUSVBCUQFUR
      UDTURGQVBUOCURGFUFTVAUEUOCUGUHUIUJ $.
  $}

  ${
    $d x z B $.  $d x z .\/ $.  $d x y z K $.  $d x y z .<_ $.  $d x y z X $.
    $d x y z Y $.  $d z Z $.
    joinval2.b $e |- B = ( Base ` K ) $.
    joinval2.l $e |- .<_ = ( le ` K ) $.
    joinval2.j $e |- .\/ = ( join ` K ) $.
    $( Value of join for a poset with GLB expanded.  (Contributed by NM,
       16-Sep-2011.) $)
    joinval2 $p |- ( ( K e. A /\ X e. B /\ Y e. B ) ->
      ( X .\/ Y ) = ( iota_ x e. B ( ( X .<_ x /\ Y .<_ x )
              /\ A. z e. B ( ( X .<_ z /\ Y .<_ z ) -> x .<_ z ) ) ) ) $=
      ( vy wcel cv wbr wa wral wceq breq1 w3a co cpr club cfv crio eqid joinval
      wi wss prssi lubval sylan2 ralprg imbi1d ralbidv anbi12d riotabidv adantl
      eqtrd 3impb ) FCNZHDNZIDNZUAHIEUBHIUCZFUDUEZUEZHAOZGPZIVHGPZQZHBOZGPZIVLG
      PZQZVHVLGPZUIZBDRZQZADUFZCDVFEFHIJVFUGZLUHVBVCVDVGVTSVBVCVDQZQVGMOZVHGPZM
      VERZWCVLGPZMVERZVPUIZBDRZQZADUFZVTWBVBVEDUJVGWKSHIDUKAMBCDVEVFFGJKWAULUMW
      BWKVTSVBWBWJVSADWBWEVKWIVRWDVIVJMHIDDWCHVHGTWCIVHGTUNWBWHVQBDWBWGVOVPWFVM
      VNMHIDDWCHVLGTWCIVLGTUNUOUPUQURUSUTVAUT $.

    $( Lemma for join properties.  (Contributed by NM, 16-Sep-2011.) $)
    joinlem $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ ( X .\/ Y ) e. B )
           -> ( ( X .<_ ( X .\/ Y ) /\ Y .<_ ( X .\/ Y ) )
            /\ A. z e. B ( ( X .<_ z /\ Y .<_ z ) -> ( X .\/ Y ) .<_ z ) ) ) $=
      ( vx wcel wbr wa cv wi wral wsbc cbs w3a co crio joinval2 eleq1d wreu cfv
      cvv fvex eqeltri riotaclb riotasbc sylbir syl6bi wceq dfsbcq sylibrd ovex
      wb syl breq2 anbi12d breq1 imbi2d ralbidv sbcie syl6ib imp ) EBMGCMHCMUAZ
      GHDUBZCMZGVJFNZHVJFNZOZGAPZFNHVOFNOZVJVOFNZQZACRZOZVIVKGLPZFNZHWAFNZOZVPW
      AVOFNZQZACRZOZLVJSZVTVIVKWHLWHLCUCZSZWIVIVKWJCMZWKVIVJWJCLABCDEFGHIJKUDZU
      EWLWHLCUFWKWHLCCETUGUHIETUIUJUKWHLCULUMUNVIVJWJUOWIWKUSWMWHLVJWJUPUTUQWHV
      TLVJGHDURWAVJUOZWDVNWGVSWNWBVLWCVMWAVJGFVAWAVJHFVAVBWNWFVRACWNWEVQVPWAVJV
      OFVCVDVEVBVFVGVH $.

    $( A join's first argument is less than or equal to the join.  (Contributed
       by NM, 16-Sep-2011.) $)
    lejoin1 $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ ( X .\/ Y ) e. B )
            -> X .<_ ( X .\/ Y ) ) $=
      ( vz wcel w3a co wa wbr cv wi wral simpld joinlem ) DALFBLGBLMFGCNZBLOZFU
      BEPZGUBEPZUCUDUEOFKQZEPGUFEPOUBUFEPRKBSKABCDEFGHIJUATT $.

    $( A join's second argument is less than or equal to the join.
       (Contributed by NM, 16-Sep-2011.) $)
    lejoin2 $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ ( X .\/ Y ) e. B )
            -> Y .<_ ( X .\/ Y ) ) $=
      ( vz wcel w3a co wa wbr cv wi wral joinlem simpld simprd ) DALFBLGBLMFGCN
      ZBLOZFUCEPZGUCEPZUDUEUFOFKQZEPGUGEPOUCUGEPRKBSKABCDEFGHIJTUAUB $.

    $( A join is less than or equal to a third value iff each argument is less
       than or equal to the third value.  (Contributed by NM, 16-Sep-2011.) $)
    joinle $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
    ( X .\/ Y ) e. B ) -> ( ( X .<_ Z /\ Y .<_ Z ) <-> ( X .\/ Y ) .<_ Z ) ) $=
      ( vz cpo wcel w3a wbr wa wi breq2 ex 3impia co cv joinlem anbi12d imbi12d
      wral simprd wceq rspccv syl com23 3exp 3impd 3imp lejoin1 3adant3r3 postr
      3exp2 com34 imp32 3adantr2 mpand lejoin2 3adant3r1 jcad impbid ) CLMZEAMZ
      FAMZGAMZNZEFBUAZAMZNZEGDOZFGDOZPZVLGDOZVGVKVMVQVRQZVGVHVIVJVMVSQZVGVHVIVJ
      VTQVGVHVINZVMVJVSWAVMVJVSQZWAVMPZEKUBZDOZFWDDOZPZVLWDDOZQZKAUFZWBWCEVLDOZ
      FVLDOZPWJKLABCDEFHIJUCUGWIVSKGAWDGUHZWGVQWHVRWMWEVOWFVPWDGEDRWDGFDRUDWDGV
      LDRUEUIUJSUKULUMUNVNVRVOVPVNWKVRVOVGVKVMWKVGVHVIVMWKQVJWAVMWKLABCDEFHIJUO
      SUPTVGVKVMWKVRPVOQZVGVHVJVMWNQZVIVGVHVJWOVGVHVMVJWNVGVHVMVJWNACDEVLGHIUQU
      RUSUTVATVBVNWLVRVPVGVKVMWLVGVHVIVMWLQVJWAVMWLLABCDEFHIJVCSUPTVGVKVMWLVRPV
      PQZVGVIVJVMWPQZVHVGVIVJWQVGVIVMVJWPVGVIVMVJWPACDFVLGHIUQURUSUNVDTVBVEVF
      $.
  $}

  ${
    $d p x y B $.  $d p x y K $.  $d p G $.
    meetfval.b $e |- B = ( Base ` K ) $.
    meetfval.g $e |- G = ( glb ` K ) $.
    meetfval.m $e |- ./\ = ( meet ` K ) $.
    $( Value of meet function for a poset.  (Contributed by NM,
       12-Sep-2011.) $)
    meetfval $p |- ( K e. A
               -> ./\ = ( x e. B , y e. B |-> ( G ` { x , y } ) ) ) $=
      ( vp wcel cvv cv cfv cmpt2 wceq cmee cbs cglb cpr elex fveq1d mpt2eq123dv
      fveq2 syl6eqr df-meet fvex eqeltri mpt2ex fvmpt syl5eq syl ) FCLFMLZGABDD
      ANBNUAZEOZPZQFCUBUNGFROUQJKFABKNZSOZUSUOURTOZOZPUQMRURFQZABUSUSVADDUPVBUS
      FSOZDURFSUEHUFZVDVBUOUTEVBUTFTOEURFTUEIUFUCUDABKUGABDDUPDVCMHFSUHUIZVEUJU
      KULUM $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y G $.  $d x y X $.  $d x y Y $.
    meetval.b $e |- B = ( Base ` K ) $.
    meetval.g $e |- G = ( glb ` K ) $.
    meetval.m $e |- ./\ = ( meet ` K ) $.
    $( Value of meet for a poset.  (Contributed by NM, 12-Sep-2011.) $)
    meetval $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X ./\ Y ) =
              ( G ` { X , Y } ) ) $=
      ( vx vy wcel co cpr cfv wceq wa cv fveq2d cmpt2 meetfval oveqd preq1 eqid
      preq2 fvex ovmpt2 sylan9eq 3impb ) DAMZFBMZGBMZFGENZFGOZCPZQUKULUMRUNFGKL
      BBKSZLSZOZCPZUAZNUPUKEVAFGKLABCDEHIJUBUCKLFGBBUTUPVAFUROZCPUQFQUSVBCUQFUR
      UDTURGQVBUOCURGFUFTVAUEUOCUGUHUIUJ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z K $.  $d x y z .<_ $.  $d x y z X $.
    $d x y z Y $.
    meetval2.b $e |- B = ( Base ` K ) $.
    meetval2.s $e |- .<_ = ( le ` K ) $.
    meetval2.m $e |- ./\ = ( meet ` K ) $.
    $( Value of meet for a poset with GLB expanded.  (Contributed by NM,
       19-Jul-2012.) $)
    meetval2 $p |- ( ( K e. A /\ X e. B /\ Y e. B ) ->
      ( X ./\ Y ) = ( iota_ x e. B ( ( x .<_ X /\ x .<_ Y )
              /\ A. z e. B ( ( z .<_ X /\ z .<_ Y ) -> z .<_ x ) ) ) ) $=
      ( vy wcel cv wbr wa wral wceq breq2 w3a co cpr cglb cfv crio eqid meetval
      wi wss prssi glbval sylan2 ralprg imbi1d ralbidv anbi12d riotabidv adantl
      eqtrd 3impb ) ECNZHDNZIDNZUAHIGUBHIUCZEUDUEZUEZAOZHFPZVHIFPZQZBOZHFPZVLIF
      PZQZVLVHFPZUIZBDRZQZADUFZCDVFEGHIJVFUGZLUHVBVCVDVGVTSVBVCVDQZQVGVHMOZFPZM
      VERZVLWCFPZMVERZVPUIZBDRZQZADUFZVTWBVBVEDUJVGWKSHIDUKAMBCDVEVFEFJKWAULUMW
      BWKVTSVBWBWJVSADWBWEVKWIVRWDVIVJMHIDDWCHVHFTWCIVHFTUNWBWHVQBDWBWGVOVPWFVM
      VNMHIDDWCHVLFTWCIVLFTUNUOUPUQURUSUTVAUT $.

    $d x ./\ $.  $d z ./\ $.
    $( Lemma for meet properties.  (Contributed by NM, 19-Jul-2012.) $)
    meetlem $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ ( X ./\ Y ) e. B )
           -> ( ( ( X ./\ Y ) .<_ X /\ ( X ./\ Y ) .<_ Y )
            /\ A. z e. B ( ( z .<_ X /\ z .<_ Y ) -> z .<_ ( X ./\ Y ) ) ) ) $=
      ( vx wcel wbr wa cv wi wral wsbc cbs w3a co crio meetval2 eleq1d wreu cfv
      cvv fvex eqeltri riotaclb riotasbc sylbir syl6bi wceq dfsbcq sylibrd ovex
      wb syl breq1 anbi12d breq2 imbi2d ralbidv sbcie syl6ib imp ) DBMGCMHCMUAZ
      GHFUBZCMZVJGENZVJHENZOZAPZGENVOHENOZVOVJENZQZACRZOZVIVKLPZGENZWAHENZOZVPV
      OWAENZQZACRZOZLVJSZVTVIVKWHLWHLCUCZSZWIVIVKWJCMZWKVIVJWJCLABCDEFGHIJKUDZU
      EWLWHLCUFWKWHLCCDTUGUHIDTUIUJUKWHLCULUMUNVIVJWJUOWIWKUSWMWHLVJWJUPUTUQWHV
      TLVJGHFURWAVJUOZWDVNWGVSWNWBVLWCVMWAVJGEVAWAVJHEVAVBWNWFVRACWNWEVQVPWAVJV
      OEVCVDVEVBVFVGVH $.

    $( A meet's first argument is greater than or equal to the meet.
       (Contributed by NM, 19-Jul-2012.) $)
    lemeet1 $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ ( X ./\ Y ) e. B )
            -> ( X ./\ Y ) .<_ X ) $=
      ( vz wcel w3a co wa wbr cv wi wral simpld meetlem ) CALFBLGBLMFGENZBLOZUB
      FDPZUBGDPZUCUDUEOKQZFDPUFGDPOUFUBDPRKBSKABCDEFGHIJUATT $.

    $( A meet's second argument is greater than or equal to the meet.
       (Contributed by NM, 19-Jul-2012.) $)
    lemeet2 $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ ( X ./\ Y ) e. B )
            -> ( X ./\ Y ) .<_ Y ) $=
      ( vz wcel w3a co wa wbr cv wi wral meetlem simpld simprd ) CALFBLGBLMFGEN
      ZBLOZUCFDPZUCGDPZUDUEUFOKQZFDPUGGDPOUGUCDPRKBSKABCDEFGHIJTUAUB $.

    $d z Z $.
    $( A meet is greater than or equal to a third value iff each argument is
       greater than or equal to the third value.  (Contributed by NM,
       19-Jul-2012.) $)
    meetle $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
    ( X ./\ Y ) e. B ) -> ( Z .<_ ( X ./\ Y ) <-> ( Z .<_ X /\ Z .<_ Y ) ) ) $=
      ( vz cpo wcel w3a wbr wa wi ex 3adant3r3 breq1 lemeet1 3impia simp1 simp3
      co simp23 simp21 postr syl13anc mpan2d lemeet2 simp22 jcad cv wral simprd
      meetlem wceq anbi12d imbi12d rspccv syl com23 3exp 3impd 3imp impbid ) BL
      MZEAMZFAMZGAMZNZEFDUEZAMZNZGVMCOZGECOZGFCOZPZVOVPVQVRVOVPVMECOZVQVHVLVNVT
      VHVIVJVNVTQVKVHVIVJNZVNVTLABCDEFHIJUARSUBVOVHVKVNVIVPVTPVQQVHVLVNUCZVHVIV
      JVKVNUFZVHVLVNUDZVHVIVJVKVNUGABCGVMEHIUHUIUJVOVPVMFCOZVRVHVLVNWEVHVIVJVNW
      EQVKWAVNWELABCDEFHIJUKRSUBVOVHVKVNVJVPWEPVRQWBWCWDVHVIVJVKVNULABCGVMFHIUH
      UIUJUMVHVLVNVSVPQZVHVIVJVKVNWFQZVHVIVJVKWGQWAVNVKWFWAVNVKWFQZWAVNPZKUNZEC
      OZWJFCOZPZWJVMCOZQZKAUOZWHWIVTWEPWPKLABCDEFHIJUQUPWOWFKGAWJGURZWMVSWNVPWQ
      WKVQWLVRWJGECTWJGFCTUSWJGVMCTUTVAVBRVCVDVEVFVG $.
  $}

  ${
    joincom.b $e |- B = ( Base ` K ) $.
    joincom.j $e |- .\/ = ( join ` K ) $.
    $( The join of a poset commutes.  (This may not be a theorem under other
       definitions of meet.)  (Contributed by NM, 16-Sep-2011.)
       (New usage is discouraged.) $)
    joincomALT $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X .\/ Y ) =
              ( Y .\/ X ) ) $=
      ( wcel w3a cpr club cfv co wceq prcom fveq2i a1i eqid joinval 3eqtr4rd
      3com23 ) DAIZEBIZFBIZJZFEKZDLMZMZEFKZUHMZFECNZEFCNUIUKOUFUGUJUHFEPQRUCUEU
      DULUIOABUHCDFEGUHSZHTUBABUHCDEFGUMHTUA $.

    $( The join of a poset commutes.  (The antecedent
       ` ( X .\/ Y ) e. B /\ ( Y .\/ X ) e. B ` i.e.  "the joins exist" could
       be omitted as an artifact of our particular join definition, but other
       definitions may require it.)  (Contributed by NM, 16-Sep-2011.) $)
    joincom $p |- ( ( ( K e. Poset /\ X e. B /\ Y e. B ) /\
   ( ( X .\/ Y ) e. B /\ ( Y .\/ X ) e. B ) ) -> ( X .\/ Y ) = ( Y .\/ X ) ) $=
      ( cpo wcel w3a co wceq wa joincomALT adantr ) CHIDAIEAIJDEBKZEDBKZLPAIQAI
      MHABCDEFGNO $.
  $}

  ${
    meetcom.b $e |- B = ( Base ` K ) $.
    meetcom.m $e |- ./\ = ( meet ` K ) $.
    $( The meet of a poset commutes.  (This may not be a theorem under other
       definitions of meet.)  (Contributed by NM, 17-Sep-2011.)
       (New usage is discouraged.) $)
    meetcomALT $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X ./\ Y ) =
              ( Y ./\ X ) ) $=
      ( wcel w3a cpr cglb cfv co wceq prcom fveq2i a1i eqid meetval 3eqtr4rd
      3com23 ) CAIZEBIZFBIZJZFEKZCLMZMZEFKZUHMZFEDNZEFDNUIUKOUFUGUJUHFEPQRUCUEU
      DULUIOABUHCDFEGUHSZHTUBABUHCDEFGUMHTUA $.

    $( The meet of a poset commutes.  (The antecedent
       ` ( X ./\ Y ) e. B /\ ( Y ./\ X ) e. B ` i.e.  "the meets exist" could
       be omitted as an artifact of our particular join definition, but other
       definitions may require it.)  (Contributed by NM, 17-Sep-2011.) $)
    meetcom $p |- ( ( ( K e. Poset /\ X e. B /\ Y e. B ) /\
   ( ( X ./\ Y ) e. B /\ ( Y ./\ X ) e. B ) ) -> ( X ./\ Y ) = ( Y ./\ X ) ) $=
      ( cpo wcel w3a co wceq wa meetcomALT adantr ) BHIDAIEAIJDECKZEDCKZLPAIQAI
      MHABCDEFGNO $.
  $}

  $c Toset $.

  $( Extend class notation with the class of all tosets. $)
  ctos $a class Toset $.

  ${
    $d f b r x y $.
    $( Define the class of totally ordered sets (tosets).  (Contributed by FL,
       17-Nov-2014.) $)
    df-toset $a |- Toset = { f e. Poset | [. ( Base ` f ) / b ].
      [. ( le ` f ) / r ]. A. x e. b A. y e. b ( x r y \/ y r x ) } $.
  $}

  ${
    $d b f r x y B $.  $d b f r K $.  $d b f r x y .<_ $.
    istos.b $e |- B = ( Base ` K ) $.
    istos.l $e |- .<_ = ( le ` K ) $.
    $( The predicate "is a toset."  (Contributed by FL, 17-Nov-2014.) $)
    istos $p |- ( K e. Toset <-> ( K e. Poset
               /\ A. x e. B A. y e. B ( x .<_ y \/ y .<_ x ) ) ) $=
      ( vr vb vf cv wbr wral cple cfv wsbc cbs wceq wb wi cpo ctos fveq2 dfsbcq
      wo syl sbcbidv bitrd fvex wa eqtr breq 2ralbidv raleq raleqbi1dv sylan9bb
      orbi12d ex expcom eqcoms ax-mp syl5com imp sbc2ie syl6bb df-toset elrab2
      ) AKZBKZHKZLZVIVHVJLZUEZBIKZMAVNMZHJKZNOZPZIVPQOZPZVHVIELZVIVHELZUEZBCMZA
      CMZJDUAUBVPDRZVTVOHDNOZPZIDQOZPZWEWFVTWHIVSPZWJWFVRWHIVSWFVQWGRVRWHSVPDNU
      CVOHVQWGUDUFUGWFVSWIRWKWJSVPDQUCWHIVSWIUDUFUHVOWEIHWIWGDQUIDNUIVNWIRZVJWG
      RZVOWESZCWIRWLWMWNTZTZFWPWICWLWICRZWOWLWQUJVNCRZWMWNVNWICUKEWGRWMWRWNTZTZ
      GWTWGEWMWGERZWSWMXAUJVJERZWSVJWGEUKXBWRWNXBVOWCBVNMZAVNMWRWEXBVMWCABVNVNX
      BVKWAVLWBVHVIVJEULVIVHVJEULUQUMXCWDAVNCWCBVNCUNUOUPURUFUSUTVAVBUSUTVAVCVD
      VEABJHIVFVG $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y .<_ $.  $d x y .< $.
    tosso.b $e |- B = ( Base ` K ) $.
    tosso.l $e |- .<_ = ( le ` K ) $.
    tosso.s $e |- .< = ( lt ` K ) $.
    $( Write the totally ordered set structure predicate in terms of the proper
       class strict order predicate.  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    tosso $p |- ( K e. V ->
      ( K e. Toset <-> ( .< Or B /\ ( _I |` B ) C_ .<_ ) ) ) $=
      ( vx vy wcel cv wbr wo wral wa weq wb pleval2 bitri cpo wpo cid cres ctos
      wss w3o wor 3expb equcom orbi2i syl6bb 3com23 orbi12d df-3or or32 orordir
      w3a syl6bbr 2ralbidva pm5.32i pospo anbi1d syl5bb istos df-so anbi1i an32
      3bitr4g ) CEKZCUAKZILZJLZDMZVMVLDMZNZJAOIAOZPZABUBZUCAUDDUFZPZVLVMBMZIJQZ
      VMVLBMZUGZJAOIAOZPZCUEKABUHZVTPZVRVKWFPVJWGVKVQWFVKVPWEIJAAVKVLAKZVMAKZPP
      ZVPWBWCNZWDWCNZNZWEWLVNWMVOWNVKWJWKVNWMRABCDVLVMFGHSUIVKWJWKVOWNRZVKWKWJW
      PVKWKWJURVOWDJIQZNWNABCDVMVLFGHSWQWCWDJIUJUKULUMUIUNWEWMWDNZWOWBWCWDUOWRW
      BWDNWCNWOWBWCWDUPWBWDWCUQTTUSUTVAVJVKWAWFABCDEFGHVBVCVDIJACDFGVEWIVSWFPZV
      TPWGWHWSVTIJABVFVGVSWFVTVHTVI $.
  $}

  $c 1. $.
  $c 0. $.
  $c Lat $.

  $( Extend class notation with poset zero. $)
  cp0 $a class 0. $.

  $( Extend class notation with poset unit. $)
  cp1 $a class 1. $.

  $( Define poset zero.  (Contributed by NM, 12-Oct-2011.) $)
  df-p0 $a |- 0. = ( p e. _V |-> ( ( glb ` p ) ` ( Base ` p ) ) ) $.

  $( Define poset unit.  (Contributed by NM, 22-Oct-2011.) $)
  df-p1 $a |- 1. = ( p e. _V |-> ( ( lub ` p ) ` ( Base ` p ) ) ) $.

  ${
    $d p B $.  $d p G $.  $d p K $.
    p0val.b $e |- B = ( Base ` K ) $.
    p0val.g $e |- G = ( glb ` K ) $.
    p0val.z $e |- .0. = ( 0. ` K ) $.
    $( Value of poset zero.  (Contributed by NM, 12-Oct-2011.) $)
    p0val $p |- ( K e. V -> .0. = ( G ` B ) ) $=
      ( vp wcel cvv cfv wceq elex cp0 cv cbs cglb fveq2 syl6eqr df-p0 fvmpt syl
      fveq12d fvex syl5eq ) CDJCKJZEABLZMCDNUGECOLUHHICIPZQLZUIRLZLUHKOUICMZUJA
      UKBULUKCRLBUICRSGTULUJCQLAUICQSFTUDIUAABUEUBUFUC $.
  $}

  ${
    $d k B $.  $d k K $.  $d k U $.
    p1val.b $e |- B = ( Base ` K ) $.
    p1val.u $e |- U = ( lub ` K ) $.
    p1val.t $e |- .1. = ( 1. ` K ) $.
    $( Value of poset zero.  (Contributed by NM, 22-Oct-2011.) $)
    p1val $p |- ( K e. V -> .1. = ( U ` B ) ) $=
      ( vk wcel cvv cfv wceq elex cp1 cv cbs club fveq2 syl6eqr df-p1 fvmpt syl
      fveq12d fvex syl5eq ) DEJDKJZCABLZMDENUGCDOLUHHIDIPZQLZUIRLZLUHKOUIDMZUJA
      UKBULUKDRLBUIDRSGTULUJDQLAUIDQSFTUDIUAABUEUBUFUC $.
  $}

  ${
    p0le.b $e |- B = ( Base ` K ) $.
    p0le.l $e |- .<_ = ( le ` K ) $.
    p0le.z $e |- .0. = ( 0. ` K ) $.
    $( Poset zero (if defined) is less than any element.  (Contributed by NM,
       22-Oct-2011.) $)
    p0le $p |- ( ( K e. Poset /\ .0. e. B /\ X e. B ) -> .0. .<_ X ) $=
      ( cpo wcel w3a cglb cfv wceq eqid p0val 3ad2ant1 wss wbr simp1 a1i adantr
      ssid wa simpr eqeltrrd 3adant3 simp3 glble syl22anc eqbrtrd ) BIJZEAJZDAJ
      ZKZEABLMZMZDCULUMEUQNZUNAUPBIEFUPOZHPZQUOULAARZUQAJZUNUQDCSULUMUNTVAUOAUC
      UAULUMVBUNULUMUDEUQAULURUMUTUBULUMUEUFUGULUMUNUHIAAUPBCDFGUSUIUJUK $.
  $}

  ${
    ple1.b $e |- B = ( Base ` K ) $.
    ple1.l $e |- .<_ = ( le ` K ) $.
    ple1.u $e |- .1. = ( 1. ` K ) $.
    $( Any element is less than or equal to poset one (if defined).
       (Contributed by NM, 22-Oct-2011.) $)
    ple1 $p |- ( ( K e. Poset /\ X e. B /\ .1. e. B ) -> X .<_ .1. ) $=
      ( cpo wcel w3a club cfv wss wbr simp1 ssid a1i wa wceq p1val adantr simpr
      eqid eqeltrrd 3adant2 simp2 luble syl22anc 3ad2ant1 breqtrrd ) CIJZEAJZBA
      JZKZEACLMZMZBDUOULAANZUQAJZUMEUQDOULUMUNPURUOAQRULUNUSUMULUNSBUQAULBUQTZU
      NAUPBCIFUPUDZHUAZUBULUNUCUEUFULUMUNUGIAAUPCDEFGVAUHUIULUMUTUNVBUJUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Lattices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Extend class notation with the class of all lattices. $)
  clat $a class Lat $.

  ${
    $d p s x y $.
    $( Define the class of all lattices.  A lattice is a poset in which the
       join and meet of any two elements always exists.  (Contributed by NM,
       18-Oct-2012.) $)
    df-lat $a |- Lat = { p e. Poset | A. x e. ( Base ` p )
       A. y e. ( Base ` p ) ( ( x ( join ` p ) y ) e. ( Base ` p )
          /\ ( x ( meet ` p ) y ) e. ( Base ` p ) ) } $.
  $}

  ${
    $d l x y B $.  $d l .\/ $.  $d l x y K $.  $d l ./\ $.
    islat.b $e |- B = ( Base ` K ) $.
    islat.j $e |- .\/ = ( join ` K ) $.
    islat.m $e |- ./\ = ( meet ` K ) $.
    $( The predicate "is a lattice."  (Contributed by NM, 18-Oct-2012.) $)
    islat $p |- ( K e. Lat <-> ( K e. Poset /\
            A. x e. B A. y e. B ( ( x .\/ y ) e. B /\ ( x ./\ y ) e. B ) ) ) $=
      ( vl cv cjn cfv co cbs wcel cmee wral fveq2 syl6eqr cpo clat wceq raleqdv
      wa raleqbidv oveqd eleq12d anbi12d 2ralbidv bitrd df-lat elrab2 ) AKZBKZJ
      KZLMZNZUPOMZPZUNUOUPQMZNZUSPZUEZBUSRZAUSRZUNUODNZCPZUNUOFNZCPZUEZBCRACRZJ
      EUAUBUPEUCZVFVDBCRZACRVLVMVEVNAUSCVMUSEOMCUPEOSGTZVMVDBUSCVOUDUFVMVDVKABC
      CVMUTVHVCVJVMURVGUSCVMUQDUNUOVMUQELMDUPELSHTUGVOUHVMVBVIUSCVMVAFUNUOVMVAE
      QMFUPEQSITUGVOUHUIUJUKABJULUM $.
  $}

  ${
    $d x y .\/ $.  $d x y ./\ $.  $d x y B $.  $d x y K $.  $d x y X $.
    $d y Y $.
    latlem.b $e |- B = ( Base ` K ) $.
    latlem.j $e |- .\/ = ( join ` K ) $.
    latlem.m $e |- ./\ = ( meet ` K ) $.
    $( Lemma for lattice properties.  (Contributed by NM, 14-Sep-2011.) $)
    latlem $p |- ( ( K e. Lat /\ X e. B /\ Y e. B ) ->
           ( ( X .\/ Y ) e. B /\ ( X ./\ Y ) e. B ) ) $=
      ( vx vy wcel co wa cv wral wceq oveq1 eleq1d anbi12d clat cpo islat oveq2
      simprbi rspc2v syl5com 3impib ) CUALZEALZFALZEFBMZALZEFDMZALZNZUIJOZKOZBM
      ZALZUQURDMZALZNZKAPJAPZUJUKNUPUICUBLVDJKABCDGHIUCUEVCUPEURBMZALZEURDMZALZ
      NJKEFAAUQEQZUTVFVBVHVIUSVEAUQEURBRSVIVAVGAUQEURDRSTURFQZVFUMVHUOVJVEULAUR
      FEBUDSVJVGUNAURFEDUDSTUFUGUH $.
  $}

  ${
    $d x y K $.
    $( A lattice is a poset.  (Contributed by NM, 17-Sep-2011.) $)
    latpos $p |- ( K e. Lat -> K e. Poset ) $=
      ( vx vy clat wcel cpo cv cjn cfv co cbs cmee wa wral eqid islat simplbi )
      ADEAFEBGZCGZAHIZJAKIZERSALIZJUAEMCUANBUANBCUATAUBUAOTOUBOPQ $.
  $}

  ${
    latjcl.b $e |- B = ( Base ` K ) $.
    latjcl.j $e |- .\/ = ( join ` K ) $.
    $( Closure of join operation in a lattice.  ( ~ chjcom analog.)
       (Contributed by NM, 14-Sep-2011.) $)
    latjcl $p |- ( ( K e. Lat /\ X e. B /\ Y e. B ) -> ( X .\/ Y ) e. B ) $=
      ( clat wcel w3a co cmee cfv eqid latlem simpld ) CHIDAIEAIJDEBKAIDECLMZKA
      IABCQDEFGQNOP $.
  $}

  ${
    latmcl.b $e |- B = ( Base ` K ) $.
    latmcl.m $e |- ./\ = ( meet ` K ) $.
    $( Closure of meet operation in a lattice.  ( ~ incom analog.)
       (Contributed by NM, 14-Sep-2011.) $)
    latmcl $p |- ( ( K e. Lat /\ X e. B /\ Y e. B ) -> ( X ./\ Y ) e. B ) $=
      ( clat wcel w3a cjn cfv co eqid latlem simprd ) BHIDAIEAIJDEBKLZMAIDECMAI
      AQBCDEFQNGOP $.
  $}

  ${
    $d x y B $.  $d x y K $.
    islati.1 $e |- K e. Poset $.
    islati.b $e |- B = ( Base ` K ) $.
    islati.j $e |- .\/ = ( join ` K ) $.
    islati.m $e |- ./\ = ( meet ` K ) $.
    islati.5 $e |- ( ( x e. B /\ y e. B ) -> ( x .\/ y ) e. B ) $.
    islati.6 $e |- ( ( x e. B /\ y e. B ) -> ( x ./\ y ) e. B ) $.
    $( Properties that determine a lattice.  (Contributed by NM,
       12-Sep-2011.) $)
    islati $p |- K e. Lat $=
      ( clat wcel cpo cv co wa wral jca rgen2a islat mpbir2an ) EMNEONAPZBPZDQC
      NZUDUEFQCNZRZBCSACSGUHABCUDCNUECNRUFUGKLTUAABCDEFHIJUBUC $.
  $}

  ${
    latref.b $e |- B = ( Base ` K ) $.
    latref.l $e |- .<_ = ( le ` K ) $.
    $( A lattice ordering is reflexive.  ( ~ ssid analog.)  (Contributed by NM,
       8-Oct-2011.) $)
    latref $p |- ( ( K e. Lat /\ X e. B ) -> X .<_ X ) $=
      ( clat wcel cpo wbr latpos posref sylan ) BGHBIHDAHDDCJBKABCDEFLM $.

    $( A lattice ordering is asymetric.  ( ~ eqss analog.)  (Contributed by NM,
       22-Oct-2011.) $)
    latasymb $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
                -> ( ( X .<_ Y /\ Y .<_ X ) <-> X = Y ) ) $=
      ( clat wcel cpo wbr wa wceq wb latpos posasymb syl3an1 ) BHIBJIDAIEAIDECK
      EDCKLDEMNBOABCDEFGPQ $.

    $( A lattice ordering is asymetric.  ( ~ eqss analog.)  (Contributed by NM,
       8-Oct-2011.) $)
    latasym $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
                -> ( ( X .<_ Y /\ Y .<_ X ) -> X = Y ) ) $=
      ( clat wcel w3a wbr wa wceq latasymb biimpd ) BHIDAIEAIJDECKEDCKLDEMABCDE
      FGNO $.

    $( A lattice ordering is transitive.  ( ~ sstr analog.)  (Contributed by
       NM, 17-Nov-2011.) $)
    lattr $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                -> ( ( X .<_ Y /\ Y .<_ Z ) -> X .<_ Z ) ) $=
      ( clat wcel cpo w3a wbr wa wi latpos postr sylan ) BIJBKJDAJEAJFAJLDECMEF
      CMNDFCMOBPABCDEFGHQR $.
  $}

  ${
    latasymd.b $e |- B = ( Base ` K ) $.
    latasymd.l $e |- .<_ = ( le ` K ) $.
    latasymd.3 $e |- ( ph -> K e. Lat ) $.
    latasymd.4 $e |- ( ph -> X e. B ) $.
    latasymd.5 $e |- ( ph -> Y e. B ) $.
    latasymd.6 $e |- ( ph -> X .<_ Y ) $.
    latasymd.7 $e |- ( ph -> Y .<_ X ) $.
    $( Deduce equality from lattice ordering.  ( ~ eqssd analog.)  (Contributed
       by NM, 18-Nov-2011.) $)
    latasymd $p |- ( ph -> X = Y ) $=
      ( wbr wceq clat wcel wa wb latasymb syl3anc mpbi2and ) AEFDNZFEDNZEFOZLMA
      CPQEBQFBQUCUDRUESIJKBCDEFGHTUAUB $.
  $}

  ${
    lattrd.b $e |- B = ( Base ` K ) $.
    lattrd.l $e |- .<_ = ( le ` K ) $.
    lattrd.1 $e |- ( ph -> K e. Lat ) $.
    lattrd.2 $e |- ( ph -> X e. B ) $.
    lattrd.3 $e |- ( ph -> Y e. B ) $.
    lattrd.4 $e |- ( ph -> Z e. B ) $.
    lattrd.5 $e |- ( ph -> X .<_ Y ) $.
    lattrd.6 $e |- ( ph -> Y .<_ Z ) $.
    $( A lattice ordering is transitive.  Deduction version of ~ lattr .
       (Contributed by NM, 3-Sep-2012.) $)
    lattrd $p |- ( ph -> X .<_ Z ) $=
      ( wbr clat wcel wa wi lattr syl13anc mp2and ) AEFDPZFGDPZEGDPZNOACQREBRFB
      RGBRUDUESUFTJKLMBCDEFGHIUAUBUC $.
  $}

  ${
    latjcom.b $e |- B = ( Base ` K ) $.
    latjcom.j $e |- .\/ = ( join ` K ) $.
    $( The join of a lattice commutes.  ( ~ chjcom analog.)  (Contributed by
       NM, 16-Sep-2011.) $)
    latjcom $p |- ( ( K e. Lat /\ X e. B /\ Y e. B ) -> ( X .\/ Y ) =
              ( Y .\/ X ) ) $=
      ( clat wcel w3a co wa wceq latjcl 3com23 jca cpo latpos joincom syl3anl1
      mpdan ) CHIZDAIZEAIZJZDEBKZAIZEDBKZAIZLZUFUHMZUEUGUIABCDEFGNUBUDUCUIABCED
      FGNOPUBCQIUCUDUJUKCRABCDEFGSTUA $.
  $}

  ${
    latlej.b $e |- B = ( Base ` K ) $.
    latlej.l $e |- .<_ = ( le ` K ) $.
    latlej.j $e |- .\/ = ( join ` K ) $.
    $( A join's first argument is less than or equal to the join.  ( ~ chub1
       analog.)  (Contributed by NM, 17-Sep-2011.) $)
    latlej1 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> X .<_ ( X .\/ Y ) ) $=
      ( clat wcel w3a co wbr latjcl lejoin1 mpdan ) CJKEAKFAKLEFBMZAKERDNABCEFG
      IOJABCDEFGHIPQ $.

    $( A join's second argument is less than or equal to the join.  ( ~ chub2
       analog.)  (Contributed by NM, 17-Sep-2011.) $)
    latlej2 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> Y .<_ ( X .\/ Y ) ) $=
      ( clat wcel w3a co wbr latjcl lejoin2 mpdan ) CJKEAKFAKLEFBMZAKFRDNABCEFG
      IOJABCDEFGHIPQ $.

    $( A join is less than or equal to a third value iff each argument is less
       than or equal to the third value.  ( ~ chlub analog.)  (Contributed by
       NM, 17-Sep-2011.) $)
    latjle12 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                      -> ( ( X .<_ Z /\ Y .<_ Z ) <-> ( X .\/ Y ) .<_ Z ) ) $=
      ( clat wcel w3a co wbr wa wb latjcl 3adant3r3 cpo latpos syl3an1 mpd3an3
      joinle ) CKLZEALZFALZGALZMZEFBNZALZEGDOFGDOPUJGDOQZUEUFUGUKUHABCEFHJRSUEC
      TLUIUKULCUAABCDEFGHIJUDUBUC $.

    $( Less-than-or-equal-to in terms of join.  ( ~ chlejb1 analog.)
       (Contributed by NM, 21-Oct-2011.) $)
    latleeqj1 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( X .<_ Y <-> ( X .\/ Y ) = Y ) ) $=
      ( clat wcel w3a wbr co wa wceq latref biantrud wb bitrd simp1 simp2 simp3
      3adant2 latjle12 syl13anc latlej2 latpos 3ad2ant1 latjcl posasymb syl3anc
      cpo ) CJKZEAKZFAKZLZEFDMZEFBNZFDMZFUSDMZOZUSFPZUQURUTVBUQURURFFDMZOZUTUQV
      DURUNUPVDUOACDFGHQUDRUQUNUOUPUPVEUTSUNUOUPUAUNUOUPUBUNUOUPUCZVFABCDEFFGHI
      UEUFTUQVAUTABCDEFGHIUGRTUQCUMKZUSAKUPVBVCSUNUOVGUPCUHUIABCEFGIUJVFACDUSFG
      HUKULT $.

    $( Less-than-or-equal-to in terms of join.  ( ~ chlejb2 analog.)
       (Contributed by NM, 14-Nov-2011.) $)
    latleeqj2 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( X .<_ Y <-> ( Y .\/ X ) = Y ) ) $=
      ( clat wcel w3a wbr co wceq latleeqj1 latjcom eqeq1d bitrd ) CJKEAKFAKLZE
      FDMEFBNZFOFEBNZFOABCDEFGHIPTUAUBFABCEFGIQRS $.

    $( Add join to both sides of a lattice ordering.  ( ~ chlej1i analog.)
       (Contributed by NM, 8-Nov-2011.) $)
    latjlej1 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
       -> ( X .<_ Y -> ( X .\/ Z ) .<_ ( Y .\/ Z ) ) ) $=
      ( clat wcel w3a wa wbr co latlej1 3adant3r1 wi simpl simpr1 simpr2 latjcl
      lattr syl13anc mpan2d latlej2 jctird simpr3 3jca latjle12 syldan sylibd
      wb ) CKLZEALZFALZGALZMZNZEFDOZEFGBPZDOZGVBDOZNZEGBPVBDOZUTVAVCVDUTVAFVBDO
      ZVCUOUQURVGUPABCDFGHIJQRUTUOUPUQVBALZVAVGNVCSUOUSTUOUPUQURUAZUOUPUQURUBUO
      UQURVHUPABCFGHJUCRZACDEFVBHIUDUEUFUOUQURVDUPABCDFGHIJUGRUHUOUSUPURVHMVEVF
      UNUTUPURVHVIUOUPUQURUIVJUJABCDEGVBHIJUKULUM $.

    $( Add join to both sides of a lattice ordering.  ( ~ chlej2i analog.)
       (Contributed by NM, 8-Nov-2011.) $)
    latjlej2 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
       -> ( X .<_ Y -> ( Z .\/ X ) .<_ ( Z .\/ Y ) ) ) $=
      ( clat wcel w3a wa wbr co latjlej1 wceq latjcom 3adant3r2 breq12d sylibd
      3adant3r1 ) CKLZEALZFALZGALZMNZEFDOEGBPZFGBPZDOGEBPZGFBPZDOABCDEFGHIJQUHU
      IUKUJULDUDUEUGUIUKRUFABCEGHJSTUDUFUGUJULRUEABCFGHJSUCUAUB $.

    $( Add join to both sides of a lattice ordering.  ( ~ chlej12i analog.)
       (Contributed by NM, 8-Nov-2011.) $)
    latjlej12 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B )
          /\ ( Z e. B /\ W e. B ) ) -> ( ( X .<_ Y /\ Z .<_ W )
             -> ( X .\/ Z ) .<_ ( Y .\/ W ) ) ) $=
      ( clat wcel wa wbr co wi syl13anc latjcl syl3anc w3a simp2l simp2r simp3l
      simp1 latjlej1 simp3r latjlej2 lattr syl2and ) CLMZFAMZGAMZNZHAMZEAMZNZUA
      ZFGDOZFHBPZGHBPZDOZHEDOZVAGEBPZDOZUTVDDOZURUKULUMUOUSVBQUKUNUQUEZUKULUMUQ
      UBZUKULUMUQUCZUKUNUOUPUDZABCDFGHIJKUFRURUKUOUPUMVCVEQVGVJUKUNUOUPUGZVIABC
      DHEGIJKUHRURUKUTAMZVAAMZVDAMZVBVENVFQVGURUKULUOVLVGVHVJABCFHIKSTURUKUMUOV
      MVGVIVJABCGHIKSTURUKUMUPVNVGVIVKABCGEIKSTACDUTVAVDIJUIRUJ $.

    $( An idiom to express that a lattice element differs from two others.
       (Contributed by NM, 28-May-2012.) $)
    latnlej $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B )
         /\ -. X .<_ ( Y .\/ Z ) ) -> ( X =/= Y /\ X =/= Z ) ) $=
      ( clat wcel wbr wne wa wceq 3adant3r1 breq1 syl5ibrcom necon3bd w3a co wn
      latlej1 latlej2 jcad 3impia ) CKLZEALZFALZGALZUAZEFGBUBZDMZUCZEFNZEGNZOUH
      ULOZUOUPUQURUNEFURUNEFPFUMDMZUHUJUKUSUIABCDFGHIJUDQEFUMDRSTURUNEGURUNEGPG
      UMDMZUHUJUKUTUIABCDFGHIJUEQEGUMDRSTUFUG $.

    $( An idiom to express that a lattice element differs from two others.
       (Contributed by NM, 19-Jul-2012.) $)
    latnlej1l $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B )
         /\ -. X .<_ ( Y .\/ Z ) ) -> X =/= Y ) $=
      ( clat wcel w3a co wbr wn wne latnlej simpld ) CKLEALFALGALMEFGBNDOPMEFQE
      GQABCDEFGHIJRS $.

    $( An idiom to express that a lattice element differs from two others.
       (Contributed by NM, 19-Jul-2012.) $)
    latnlej1r $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B )
         /\ -. X .<_ ( Y .\/ Z ) ) -> X =/= Z ) $=
      ( clat wcel w3a co wbr wn wne latnlej simprd ) CKLEALFALGALMEFGBNDOPMEFQE
      GQABCDEFGHIJRS $.

    $( An idiom to express that a lattice element differs from two others.
       (Contributed by NM, 10-Jul-2012.) $)
    latnlej2 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B )
         /\ -. X .<_ ( Y .\/ Z ) ) -> ( -. X .<_ Y /\ -. X .<_ Z ) ) $=
      ( wcel wbr wn wa 3adant3r1 wi lattr syl13anc mpan2d con3d clat co latlej1
      w3a simpl simpr1 simpr2 latjcl latlej2 simpr3 jcad 3impia ) CUAKZEAKZFAKZ
      GAKZUDZEFGBUBZDLZMZEFDLZMZEGDLZMZNUMUQNZUTVBVDVEVAUSVEVAFURDLZUSUMUOUPVFU
      NABCDFGHIJUCOVEUMUNUOURAKZVAVFNUSPUMUQUEZUMUNUOUPUFZUMUNUOUPUGUMUOUPVGUNA
      BCFGHJUHOZACDEFURHIQRSTVEVCUSVEVCGURDLZUSUMUOUPVKUNABCDFGHIJUIOVEUMUNUPVG
      VCVKNUSPVHVIUMUNUOUPUJVJACDEGURHIQRSTUKUL $.

    $( An idiom to express that a lattice element differs from two others.
       (Contributed by NM, 19-Jul-2012.) $)
    latnlej2l $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B )
         /\ -. X .<_ ( Y .\/ Z ) ) -> -. X .<_ Y ) $=
      ( clat wcel w3a co wbr wn latnlej2 simpld ) CKLEALFALGALMEFGBNDOPMEFDOPEG
      DOPABCDEFGHIJQR $.

    $( An idiom to express that a lattice element differs from two others.
       (Contributed by NM, 19-Jul-2012.) $)
    latnlej2r $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B )
         /\ -. X .<_ ( Y .\/ Z ) ) -> -. X .<_ Z ) $=
      ( clat wcel w3a co wbr wn latnlej2 simprd ) CKLEALFALGALMEFGBNDOPMEFDOPEG
      DOPABCDEFGHIJQR $.
  $}

  ${
    latidm.b $e |- B = ( Base ` K ) $.
    latidm.j $e |- .\/ = ( join ` K ) $.
    $( Lattice join is idempotent.  ( ~ chjidm analog.)  (Contributed by NM,
       8-Oct-2011.) $)
    latjidm $p |- ( ( K e. Lat /\ X e. B ) -> ( X .\/ X ) = X ) $=
      ( clat wcel wa cple cfv co eqid simpl latjcl 3anidm23 simpr wbr latref wb
      latjle12 syl13anc mpbi2and latlej1 latasymd ) CGHZDAHZIZACCJKZDDBLZDEUIMZ
      UFUGNZUFUGUJAHABCDDEFOPUFUGQZUHDDUIRZUNUJDUIRZACUIDEUKSZUPUHUFUGUGUGUNUNI
      UOTULUMUMUMABCUIDDDEUKFUAUBUCUFUGDUJUIRABCUIDDEUKFUDPUE $.
  $}

  ${
    latmcom.b $e |- B = ( Base ` K ) $.
    latmcom.m $e |- ./\ = ( meet ` K ) $.
    $( The join of a lattice commutes.  ( ~ incom analog.)  (Contributed by NM,
       6-Nov-2011.) $)
    latmcom $p |- ( ( K e. Lat /\ X e. B /\ Y e. B ) -> ( X ./\ Y ) =
              ( Y ./\ X ) ) $=
      ( clat wcel w3a co wa wceq latmcl 3com23 jca cpo latpos meetcom syl3anl1
      mpdan ) BHIZDAIZEAIZJZDECKZAIZEDCKZAIZLZUFUHMZUEUGUIABCDEFGNUBUDUCUIABCED
      FGNOPUBBQIUCUDUJUKBRABCDEFGSTUA $.
  $}

  ${
    latmle.b $e |- B = ( Base ` K ) $.
    latmle.l $e |- .<_ = ( le ` K ) $.
    latmle.m $e |- ./\ = ( meet ` K ) $.
    $( A meet is less than or equal to its first argument.  ( ~ inss1 analog.)
       (Contributed by NM, 21-Oct-2011.) $)
    latmle1 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( X ./\ Y ) .<_ X ) $=
      ( clat wcel w3a co wbr latmcl lemeet1 mpdan ) BJKEAKFAKLEFDMZAKRECNABDEFG
      IOJABCDEFGHIPQ $.

    $( A meet is less than or equal to its second argument.  ( ~ inss2
       analog.)  (Contributed by NM, 21-Oct-2011.) $)
    latmle2 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( X ./\ Y ) .<_ Y ) $=
      ( clat wcel w3a co wbr latmcl lemeet2 mpdan ) BJKEAKFAKLEFDMZAKRFCNABDEFG
      IOJABCDEFGHIPQ $.

    $( An element is less than or equal to a meet iff the element is less than
       or equal to each argument of the meet.  ( ~ ssin analog.)  (Contributed
       by NM, 21-Oct-2011.) $)
    latlem12 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                      -> ( ( X .<_ Y /\ X .<_ Z ) <-> X .<_ ( Y ./\ Z ) ) ) $=
      ( wcel w3a clat wbr wa co wb 3anrot latmcl 3adant3r3 latpos meetle bicomd
      cpo syl3an1 mpd3an3 sylan2b ) EAKZFAKZGAKZLBMKZUIUJUHLZEFCNEGCNOZEFGDPZCN
      ZQZUHUIUJRUKULUNAKZUPUKUIUJUQUHABDFGHJSTUKBUDKZULUQUPBUAURULUQLUOUMABCDFG
      EHIJUBUCUEUFUG $.

    $( Less-than-or-equal-to in terms of meet.  ( ~ df-ss analog.)
       (Contributed by NM, 7-Nov-2011.) $)
    latleeqm1 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( X .<_ Y <-> ( X ./\ Y ) = X ) ) $=
      ( clat wcel w3a wbr co wa wceq latref biantrurd wb bitrd 3adant3 latlem12
      simp1 simp2 syl13anc latmle1 cpo latpos 3ad2ant1 latmcl posasymb syl3anc
      simp3 ) BJKZEAKZFAKZLZEFCMZEFDNZECMZEUSCMZOZUSEPZUQURVAVBUQUREECMZUROZVAU
      QVDURUNUOVDUPABCEGHQUARUQUNUOUOUPVEVASUNUOUPUCUNUOUPUDZVFUNUOUPUMABCDEEFG
      HIUBUETUQUTVAABCDEFGHIUFRTUQBUGKZUSAKUOVBVCSUNUOVGUPBUHUIABDEFGIUJVFABCUS
      EGHUKULT $.

    $( Less-than-or-equal-to in terms of meet.  ( ~ sseqin2 analog.)
       (Contributed by NM, 7-Nov-2011.) $)
    latleeqm2 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( X .<_ Y <-> ( Y ./\ X ) = X ) ) $=
      ( clat wcel w3a wbr co wceq latleeqm1 latmcom eqeq1d bitrd ) BJKEAKFAKLZE
      FCMEFDNZEOFEDNZEOABCDEFGHIPTUAUBEABDEFGIQRS $.

    $( Add meet to both sides of a lattice ordering.  ( ~ ssrin analog.)
       (Contributed by NM, 10-Nov-2011.) $)
    latmlem1 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
       -> ( X .<_ Y -> ( X ./\ Z ) .<_ ( Y ./\ Z ) ) ) $=
      ( clat wcel w3a wa wbr co latmle1 3adant3r2 wi simpl latmcl simpr1 simpr2
      lattr syl13anc mpand latmle2 jctird wb simpr3 3jca latlem12 syldan sylibd
      ) BKLZEALZFALZGALZMZNZEFCOZEGDPZFCOZVBGCOZNZVBFGDPCOZUTVAVCVDUTVBECOZVAVC
      UOUPURVGUQABCDEGHIJQRUTUOVBALZUPUQVGVANVCSUOUSTUOUPURVHUQABDEGHJUARZUOUPU
      QURUBUOUPUQURUCZABCVBEFHIUDUEUFUOUPURVDUQABCDEGHIJUGRUHUOUSVHUQURMVEVFUIU
      TVHUQURVIVJUOUPUQURUJUKABCDVBFGHIJULUMUN $.

    $( Add meet to both sides of a lattice ordering.  ( ~ sslin analog.)
       (Contributed by NM, 10-Nov-2011.) $)
    latmlem2 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) )
       -> ( X .<_ Y -> ( Z ./\ X ) .<_ ( Z ./\ Y ) ) ) $=
      ( clat wcel w3a wa wbr co latmlem1 wceq latmcom 3adant3r2 breq12d sylibd
      3adant3r1 ) BKLZEALZFALZGALZMNZEFCOEGDPZFGDPZCOGEDPZGFDPZCOABCDEFGHIJQUHU
      IUKUJULCUDUEUGUIUKRUFABDEGHJSTUDUFUGUJULRUEABDFGHJSUCUAUB $.

    $( Add join to both sides of a lattice ordering.  ( ~ ss2in analog.)
       (Contributed by NM, 10-Nov-2011.) $)
    latmlem12 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B )
          /\ ( Z e. B /\ W e. B ) ) -> ( ( X .<_ Y /\ Z .<_ W )
             -> ( X ./\ Z ) .<_ ( Y ./\ W ) ) ) $=
      ( clat wcel wa wbr co wi syl13anc latmcl syl3anc w3a simp2l simp2r simp3l
      simp1 latmlem1 simp3r latmlem2 lattr syl2and ) BLMZFAMZGAMZNZHAMZEAMZNZUA
      ZFGCOZFHDPZGHDPZCOZHECOZVAGEDPZCOZUTVDCOZURUKULUMUOUSVBQUKUNUQUEZUKULUMUQ
      UBZUKULUMUQUCZUKUNUOUPUDZABCDFGHIJKUFRURUKUOUPUMVCVEQVGVJUKUNUOUPUGZVIABC
      DHEGIJKUHRURUKUTAMZVAAMZVDAMZVBVENVFQVGURUKULUOVLVGVHVJABDFHIKSTURUKUMUOV
      MVGVIVJABDGHIKSTURUKUMUPVNVGVIVKABDGEIKSTABCUTVAVDIJUIRUJ $.
  $}

  ${
    latnlemlt.b $e |- B = ( Base ` K ) $.
    latnlemlt.l $e |- .<_ = ( le ` K ) $.
    latnlemlt.s $e |- .< = ( lt ` K ) $.
    latnlemlt.m $e |- ./\ = ( meet ` K ) $.
    $( Negation of less-than-or-equal-to expressed in terms of meet and
       less-than.  ( ~ nssinpss analog.)  (Contributed by NM, 5-Feb-2012.) $)
    latnlemlt $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
            -> ( -. X .<_ Y <-> ( X ./\ Y ) .< X ) ) $=
      ( clat wcel w3a co wne wbr wa wn latmle1 biantrurd latleeqm1 simp1 latmcl
      necon3bbid wb simp2 pltval syl3anc 3bitr4d ) CLMZFAMZGAMZNZFGEOZFPZUOFDQZ
      UPRZFGDQZSUOFBQZUNUQUPACDEFGHIKTUAUNUSUOFACDEFGHIKUBUEUNUKUOAMULUTURUFUKU
      LUMUCACEFGHKUDUKULUMUGLAABCDUOFIJUHUIUJ $.
  $}

  ${
    latnle.b $e |- B = ( Base ` K ) $.
    latnle.l $e |- .<_ = ( le ` K ) $.
    latnle.s $e |- .< = ( lt ` K ) $.
    latnle.j $e |- .\/ = ( join ` K ) $.
    $( Equivalent expressions for "not less than" in a lattice.  ( ~ chnle
       analog.)  (Contributed by NM, 16-Nov-2011.) $)
    latnle $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
       -> ( -. Y .<_ X <-> X .< ( X .\/ Y ) ) ) $=
      ( clat wcel w3a co wne wbr wa wceq wb wn biantrurd latleeqj1 3com23 eqcom
      latlej1 syl6bb latjcom eqeq2d bitr4d necon3bbid latjcl syld3an3 3bitr4d
      pltval ) DLMZFAMZGAMZNZFFGCOZPZFUTEQZVARZGFEQZUAFUTBQZUSVBVAACDEFGHIKUFUB
      USVDFUTUSVDFGFCOZSZFUTSUSVDVFFSZVGUPURUQVDVHTACDEGFHIKUCUDVFFUEUGUSUTVFFA
      CDFGHKUHUIUJUKUPUQURUTAMVEVCTACDFGHKULLAABDEFUTIJUOUMUN $.
  $}

  ${
    latmidm.b $e |- B = ( Base ` K ) $.
    latmidm.m $e |- ./\ = ( meet ` K ) $.
    $( Lattice join is idempotent.  ( ~ inidm analog.)  (Contributed by NM,
       8-Nov-2011.) $)
    latmidm $p |- ( ( K e. Lat /\ X e. B ) -> ( X ./\ X ) = X ) $=
      ( clat wcel wa cple cfv co simpl latmcl 3anidm23 simpr wbr latmle1 latref
      eqid wb latlem12 syl13anc mpbi2and latasymd ) BGHZDAHZIZABBJKZDDCLZDEUITZ
      UFUGMZUFUGUJAHABCDDEFNOUFUGPZUFUGUJDUIQABUICDDEUKFROUHDDUIQZUNDUJUIQZABUI
      DEUKSZUPUHUFUGUGUGUNUNIUOUAULUMUMUMABUICDDDEUKFUBUCUDUE $.
  $}

  ${
    latabs1.b $e |- B = ( Base ` K ) $.
    latabs1.j $e |- .\/ = ( join ` K ) $.
    latabs1.m $e |- ./\ = ( meet ` K ) $.
    $( Lattice absorption law.  From definition of lattice in [Kalmbach]
       p. 14.  ( ~ chabs1 analog.)  (Contributed by NM, 8-Nov-2011.) $)
    latabs1 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
              -> ( X .\/ ( X ./\ Y ) ) = X ) $=
      ( clat wcel w3a co cple cfv wbr wceq eqid latmle1 wb latmcl 3com23 mpbid
      latleeqj2 syld3an3 ) CJKZEAKZFAKZLEFDMZECNOZPZEUIBMEQZACUJDEFGUJRZISUFUGU
      HUIAKZUKULTZACDEFGIUAUFUNUGUOABCUJUIEGUMHUDUBUEUC $.

    $( Lattice absorption law.  From definition of lattice in [Kalmbach]
       p. 14.  ( ~ chabs2 analog.)  (Contributed by NM, 8-Nov-2011.) $)
    latabs2 $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
              -> ( X ./\ ( X .\/ Y ) ) = X ) $=
      ( clat wcel w3a co cple cfv wbr wceq eqid latlej1 wb latleeqm1 syld3an3
      latjcl mpbid ) CJKZEAKZFAKZLEEFBMZCNOZPZEUHDMEQZABCUIEFGUIRZHSUEUFUGUHAKU
      JUKTABCEFGHUCACUIDEUHGULIUAUBUD $.
  $}

  ${
    latledi.b $e |- B = ( Base ` K ) $.
    latledi.l $e |- .<_ = ( le ` K ) $.
    latledi.j $e |- .\/ = ( join ` K ) $.
    latledi.m $e |- ./\ = ( meet ` K ) $.
    $( An ortholattice is distributive in one ordering direction.  ( ~ ledi
       analog.)  (Contributed by NM, 7-Nov-2011.) $)
    latledi $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                 ( ( X ./\ Y ) .\/ ( X ./\ Z ) ) .<_ ( X ./\ ( Y .\/ Z ) ) ) $=
      ( wcel w3a wa co wbr latmle1 3adant3r3 3adant3r2 latmcl latjle12 mpbi2and
      clat wb simpr1 syldan latmle2 wi simpr2 simpr3 latjlej12 syl122anc mp2and
      3jca simpl latjcl syl3anc 3adant3r1 latlem12 syl13anc ) CUDMZFAMZGAMZHAMZ
      NZOZFGEPZFHEPZBPZFDQZVJGHBPZDQZVJFVLEPDQZVGVHFDQZVIFDQZVKVBVCVDVOVEACDEFG
      IJLRSVBVCVEVPVDACDEFHIJLRTVBVFVHAMZVIAMZVCNVOVPOVKUEVGVQVRVCVBVCVDVQVEACE
      FGILUASZVBVCVEVRVDACEFHILUATZVBVCVDVEUFZUOABCDVHVIFIJKUBUGUCVGVHGDQZVIHDQ
      ZVMVBVCVDWBVEACDEFGIJLUHSVBVCVEWCVDACDEFHIJLUHTVGVBVQVDVRVEWBWCOVMUIVBVFU
      PZVSVBVCVDVEUJVTVBVCVDVEUKABCDHVHGVIIJKULUMUNVGVBVJAMZVCVLAMZVKVMOVNUEWDV
      GVBVQVRWEWDVSVTABCVHVIIKUQURWAVBVDVEWFVCABCGHIKUQUSACDEVJFVLIJLUTVAUC $.

    $( Ordering of a meet and join with a common variable.  (Contributed by NM,
       4-Oct-2012.) $)
    latmlej11 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
      ( X ./\ Y ) .<_ ( X .\/ Z ) ) $=
      ( clat wcel w3a wa co 3adant3r3 3adant3r2 wbr simpl latmcl simpr1 latmle1
      latjcl latlej1 lattrd ) CMNZFANZGANZHANZOZPACDFGEQZFFHBQZIJUHULUAUHUIUJUM
      ANUKACEFGILUBRUHUIUJUKUCUHUIUKUNANUJABCFHIKUESUHUIUJUMFDTUKACDEFGIJLUDRUH
      UIUKFUNDTUJABCDFHIJKUFSUG $.

    $( Ordering of a meet and join with a common variable.  (Contributed by NM,
       4-Oct-2012.) $)
    latmlej12 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
      ( X ./\ Y ) .<_ ( Z .\/ X ) ) $=
      ( clat wcel w3a wa co latmlej11 wceq latjcom 3adant3r2 breqtrd ) CMNZFANZ
      GANZHANZOPFGEQFHBQZHFBQZDABCDEFGHIJKLRUCUDUFUGUHSUEABCFHIKTUAUB $.

    $( Ordering of a meet and join with a common variable.  (Contributed by NM,
       4-Oct-2012.) $)
    latmlej21 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
      ( Y ./\ X ) .<_ ( X .\/ Z ) ) $=
      ( clat wcel w3a wa co wceq latmcom 3adant3r3 latmlej11 eqbrtrrd ) CMNZFAN
      ZGANZHANZOPFGEQZGFEQZFHBQDUCUDUEUGUHRUFACEFGILSTABCDEFGHIJKLUAUB $.

    $( Ordering of a meet and join with a common variable.  (Contributed by NM,
       4-Oct-2012.) $)
    latmlej22 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
      ( Y ./\ X ) .<_ ( Z .\/ X ) ) $=
      ( clat wcel w3a wa co wceq latmcom 3adant3r3 latmlej12 eqbrtrrd ) CMNZFAN
      ZGANZHANZOPFGEQZGFEQZHFBQDUCUDUEUGUHRUFACEFGILSTABCDEFGHIJKLUAUB $.
  $}

  ${
    lubsn.b $e |- B = ( Base ` K ) $.
    lubsn.u $e |- U = ( lub ` K ) $.
    $( The least upper bound of a singleton.  ( ~ chsupsn analog.)
       (Contributed by NM, 20-Oct-2011.) $)
    lubsn $p |- ( ( K e. Lat /\ X e. B ) -> ( U ` { X } ) = X ) $=
      ( clat wcel wa csn cfv cjn co cpr wceq eqid joinval 3anidm23 dfsn2 fveq2i
      syl6reqr latjidm eqtrd ) CGHZDAHZIZDJZBKZDDCLKZMZDUFUJDDNZBKZUHUDUEUJULOG
      ABUICDDEFUIPZQRUGUKBDSTUAAUICDEUMUBUC $.
  $}

  ${
    latjass.b $e |- B = ( Base ` K ) $.
    latjass.j $e |- .\/ = ( join ` K ) $.
    $( Lattice join is associative.  Lemma 2.2 in [MegPav2002] p. 362.
       ( ~ chjass analog.)  (Contributed by NM, 17-Sep-2011.) $)
    latjass $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X .\/ Y ) .\/ Z ) = ( X .\/ ( Y .\/ Z ) ) ) $=
      ( wcel wa co latjcl syl3anc wbr latlej1 latlej2 lattrd latjle12 syl13anc
      wb clat cple eqid simpl 3adant3r3 simpr3 simpr1 3adant3r1 simpr2 mpbi2and
      w3a cfv latasymd ) CUAIZDAIZEAIZFAIZUKZJZACCUBULZDEBKZFBKZDEFBKZBKZGUTUCZ
      UNURUDZUSUNVAAIZUQVBAIZVFUNUOUPVGUQABCDEGHLUEZUNUOUPUQUFZABCVAFGHLMZUSUNU
      OVCAIZVDAIZVFUNUOUPUQUGZUNUPUQVLUOABCEFGHLUHZABCDVCGHLMZUSVAVDUTNZFVDUTNZ
      VBVDUTNZUSDVDUTNZEVDUTNZVQUSUNUOVLVTVFVNVOABCUTDVCGVEHOMUSACUTEVCVDGVEVFU
      NUOUPUQUIZVOVPUNUPUQEVCUTNUOABCUTEFGVEHOUHUSUNUOVLVCVDUTNVFVNVOABCUTDVCGV
      EHPMZQUSUNUOUPVMVTWAJVQTVFVNWBVPABCUTDEVDGVEHRSUJUSACUTFVCVDGVEVFVJVOVPUN
      UPUQFVCUTNUOABCUTEFGVEHPUHWCQUSUNVGUQVMVQVRJVSTVFVIVJVPABCUTVAFVDGVEHRSUJ
      USDVBUTNZVCVBUTNZVDVBUTNZUSACUTDVAVBGVEVFVNVIVKUNUOUPDVAUTNUQABCUTDEGVEHO
      UEUSUNVGUQVAVBUTNVFVIVJABCUTVAFGVEHOMZQUSEVBUTNZFVBUTNZWEUSACUTEVAVBGVEVF
      WBVIVKUNUOUPEVAUTNUQABCUTDEGVEHPUEWGQUSUNVGUQWIVFVIVJABCUTVAFGVEHPMUSUNUP
      UQVHWHWIJWETVFWBVJVKABCUTEFVBGVEHRSUJUSUNUOVLVHWDWEJWFTVFVNVOVKABCUTDVCVB
      GVEHRSUJUM $.

    $( Swap 1st and 2nd members of lattice join.  ( ~ chj12 analog.)
       (Contributed by NM, 4-Jun-2012.) $)
    latj12 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( X .\/ ( Y .\/ Z ) ) = ( Y .\/ ( X .\/ Z ) ) ) $=
      ( clat wcel w3a wa co wceq latjcom 3adant3r3 oveq1d latjass simpl simpr2
      simpr1 simpr3 syl13anc 3eqtr3d ) CIJZDAJZEAJZFAJZKZLZDEBMZFBMEDBMZFBMZDEF
      BMBMEDFBMBMZUJUKULFBUEUFUGUKULNUHABCDEGHOPQABCDEFGHRUJUEUGUFUHUMUNNUEUISU
      EUFUGUHTUEUFUGUHUAUEUFUGUHUBABCEDFGHRUCUD $.

    $( Swap 2nd and 3rd members of lattice join.  Lemma 2.2 in [MegPav2002]
       p. 362.  (Contributed by NM, 2-Dec-2011.) $)
    latj32 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X .\/ Y ) .\/ Z ) = ( ( X .\/ Z ) .\/ Y ) ) $=
      ( clat wcel w3a wa co wceq latjcom 3adant3r1 oveq2d latjass simpr1 simpr3
      simpr2 3jca syldan 3eqtr4d ) CIJZDAJZEAJZFAJZKZLZDEFBMZBMDFEBMZBMZDEBMFBM
      DFBMEBMZUJUKULDBUEUGUHUKULNUFABCEFGHOPQABCDEFGHRUEUIUFUHUGKUNUMNUJUFUHUGU
      EUFUGUHSUEUFUGUHTUEUFUGUHUAUBABCDFEGHRUCUD $.

    $( Swap 1sd and 3rd members of lattice join.  (Contributed by NM,
       4-Jun-2012.) $)
    latj13 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( X .\/ ( Y .\/ Z ) ) = ( Z .\/ ( Y .\/ X ) ) ) $=
      ( clat wcel w3a wa co wceq simpl simpr2 simpr3 latjcl latjcom syl3anc
      simpr1 latj32 syl13anc 3adant3r1 3eqtr4d ) CIJZDAJZEAJZFAJZKZLZEFBMZDBMZE
      DBMZFBMZDULBMZFUNBMZUKUFUHUIUGUMUONUFUJOZUFUGUHUIPZUFUGUHUIQZUFUGUHUIUAZA
      BCEFDGHUBUCUKUFUGULAJZUPUMNURVAUFUHUIVBUGABCEFGHRUDABCDULGHSTUKUFUIUNAJZU
      QUONURUTUKUFUHUGVCURUSVAABCEDGHRTABCFUNGHSTUE $.

    $( Swap 2nd and 3rd members of lattice join.  Lemma 2.2 in [MegPav2002]
       p. 362.  (Contributed by NM, 23-Jun-2012.) $)
    latj31 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X .\/ Y ) .\/ Z ) = ( ( Z .\/ Y ) .\/ X ) ) $=
      ( clat wcel w3a wa co wceq simpl simpr3 simpr1 latjcl latjcom syl3anc
      simpr2 latj12 syl13anc 3adant3r3 3eqtr4d ) CIJZDAJZEAJZFAJZKZLZFDEBMZBMZD
      FEBMZBMZULFBMZUNDBMZUKUFUIUGUHUMUONUFUJOZUFUGUHUIPZUFUGUHUIQZUFUGUHUIUAZA
      BCFDEGHUBUCUKUFULAJZUIUPUMNURUFUGUHVBUIABCDEGHRUDUSABCULFGHSTUKUFUNAJZUGU
      QUONURUKUFUIUHVCURUSVAABCFEGHRTUTABCUNDGHSTUE $.

    $( Rotate lattice join of 3 classes.  (Contributed by NM, 23-Jul-2012.) $)
    latjrot $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X .\/ Y ) .\/ Z ) = ( ( Z .\/ X ) .\/ Y ) ) $=
      ( clat wcel w3a wa co latj31 wceq simpl simpr3 simpr2 simpr1 latj32 eqtrd
      syl13anc ) CIJZDAJZEAJZFAJZKZLZDEBMFBMFEBMDBMZFDBMEBMZABCDEFGHNUHUCUFUEUD
      UIUJOUCUGPUCUDUEUFQUCUDUEUFRUCUDUEUFSABCFEDGHTUBUA $.

    $( Rearrangement of lattice join of 4 classes.  ( ~ chj4 analog.)
       (Contributed by NM, 14-Jun-2012.) $)
    latj4 $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B )
               /\ ( Z e. B /\ W e. B ) )
      -> ( ( X .\/ Y ) .\/ ( Z .\/ W ) ) = ( ( X .\/ Z ) .\/ ( Y .\/ W ) ) ) $=
      ( clat wcel wa w3a co wceq simp1 syl13anc latjcl syl3anc latjass 3eqtr4d
      simp2r simp3l simp3r latj12 oveq2d simp2l ) CJKZEAKZFAKZLZGAKZDAKZLZMZEFG
      DBNZBNZBNZEGFDBNZBNZBNZEFBNUPBNZEGBNUSBNZUOUQUTEBUOUHUJULUMUQUTOUHUKUNPZU
      HUIUJUNUBZUHUKULUMUCZUHUKULUMUDZABCFGDHIUEQUFUOUHUIUJUPAKZVBUROVDUHUIUJUN
      UGZVEUOUHULUMVHVDVFVGABCGDHIRSABCEFUPHITQUOUHUIULUSAKZVCVAOVDVIVFUOUHUJUM
      VJVDVEVGABCFDHIRSABCEGUSHITQUA $.

    $( Rotate lattice join of 4 classes.  (Contributed by NM, 11-Jul-2012.) $)
    latj4rot $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B )
               /\ ( Z e. B /\ W e. B ) )
      -> ( ( X .\/ Y ) .\/ ( Z .\/ W ) ) = ( ( W .\/ X ) .\/ ( Y .\/ Z ) ) ) $=
      ( clat wcel wa w3a co wceq simp1 simp3l simp3r latjcom syl3anc oveq2d jca
      latj4 syld3an3 simp2l oveq1d 3eqtrd ) CJKZEAKZFAKZLZGAKZDAKZLZMZEFBNZGDBN
      ZBNUPDGBNZBNZEDBNZFGBNZBNZDEBNZVABNUOUQURUPBUOUHULUMUQUROUHUKUNPZUHUKULUM
      QZUHUKULUMRZABCGDHISTUAUHUKUNUMULLUSVBOUOUMULVFVEUBABCGEFDHIUCUDUOUTVCVAB
      UOUHUIUMUTVCOVDUHUIUJUNUEVFABCEDHISTUFUG $.

    $( Lattice join distributes over itself.  (Contributed by NM,
       30-Jul-2012.) $)
    latjjdi $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( X .\/ ( Y .\/ Z ) ) = ( ( X .\/ Y ) .\/ ( X .\/ Z ) ) ) $=
      ( clat wcel w3a wa co wceq simpr1 latjidm syldan oveq1d simpl simpr2
      simpr3 latj4 syl122anc eqtr3d ) CIJZDAJZEAJZFAJZKZLZDDBMZEFBMZBMZDULBMDEB
      MDFBMBMZUJUKDULBUEUIUFUKDNUEUFUGUHOZABCDGHPQRUJUEUFUFUGUHUMUNNUEUISUOUOUE
      UFUGUHTUEUFUGUHUAABCFDDEGHUBUCUD $.

    $( Lattice join distributes over itself.  (Contributed by NM,
       2-Aug-2012.) $)
    latjjdir $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X .\/ Y ) .\/ Z ) = ( ( X .\/ Z ) .\/ ( Y .\/ Z ) ) ) $=
      ( clat wcel w3a wa co wceq latjidm 3ad2antr3 oveq2d simpl simpr1 simpr2
      simpr3 latj4 syl122anc eqtr3d ) CIJZDAJZEAJZFAJZKZLZDEBMZFFBMZBMZUKFBMDFB
      MEFBMBMZUJULFUKBUEUFUHULFNUGABCFGHOPQUJUEUFUGUHUHUMUNNUEUIRUEUFUGUHSUEUFU
      GUHTUEUFUGUHUAZUOABCFDEFGHUBUCUD $.
  $}

  ${
    modle.b $e |- B = ( Base ` K ) $.
    modle.l $e |- .<_ = ( le ` K ) $.
    modle.j $e |- .\/ = ( join ` K ) $.
    modle.m $e |- ./\ = ( meet ` K ) $.
    $( The weak direction of the modular law (e.g. ~ pmod1i , ~ atmod1i1 ) that
       holds in any lattice.  (Contributed by NM, 11-May-2012.) $)
    mod1ile $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( X .<_ Z -> ( X .\/ ( Y ./\ Z ) ) .<_ ( ( X .\/ Y ) ./\ Z ) ) ) $=
      ( wcel wa wbr co syl3anc wb syl13anc mpbi2and clat simpll simplr1 simplr2
      w3a latlej1 latjcl simplr3 latlem12 latmlej12 latmle2 latmcl latjle12 ex
      simpr ) CUAMZFAMZGAMZHAMZUEZNZFHDOZFGHEPZBPFGBPZHEPZDOZVAVBNZFVEDOZVCVEDO
      ZVFVGFVDDOZVBVHVGUPUQURVJUPUTVBUBZUQURUSUPVBUCZUQURUSUPVBUDZABCDFGIJKUFQV
      AVBUOVGUPUQVDAMZUSVJVBNVHRVKVLVGUPUQURVNVKVLVMABCFGIKUGQZUQURUSUPVBUHZACD
      EFVDHIJLUISTVGVCVDDOZVCHDOZVIVGUPURUSUQVQVKVMVPVLABCDEGHFIJKLUJSVGUPURUSV
      RVKVMVPACDEGHIJLUKQVGUPVCAMZVNUSVQVRNVIRVKVGUPURUSVSVKVMVPACEGHILULQZVOVP
      ACDEVCVDHIJLUISTVGUPUQVSVEAMZVHVINVFRVKVLVTVGUPVNUSWAVKVOVPACEVDHILULQABC
      DFVCVEIJKUMSTUN $.

    $( The weak direction of the modular law (e.g. ~ pmod2iN ) that holds in
       any lattice.  (Contributed by NM, 11-May-2012.) $)
    mod2ile $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( Z .<_ X -> ( ( X ./\ Y ) .\/ Z ) .<_ ( X ./\ ( Y .\/ Z ) ) ) ) $=
      ( wcel w3a wa wbr co wceq latmcom syl3anc clat simpll simplr3 simplr2 jca
      simplr1 3jca simpr mod1ile sylc oveq1d latmcl latjcom eqtrd oveq2d latjcl
      3brtr4d ex ) CUAMZFAMZGAMZHAMZNZOZHFDPZFGEQZHBQZFGHBQZEQZDPVDVEOZHGFEQZBQ
      ZHGBQZFEQZVGVIDVJUSVBVAUTNZOVEVLVNDPVJUSVOUSVCVEUBZVJVBVAUTUTVAVBUSVEUCZU
      TVAVBUSVEUDZUTVAVBUSVEUFZUGUEVDVEUHABCDEHGFIJKLUIUJVJVGVKHBQZVLVJVFVKHBVJ
      USUTVAVFVKRVPVSVRACEFGILSTUKVJUSVKAMZVBVTVLRVPVJUSVAUTWAVPVRVSACEGFILULTV
      QABCVKHIKUMTUNVJVIFVMEQZVNVJVHVMFEVJUSVAVBVHVMRVPVRVQABCGHIKUMTUOVJUSUTVM
      AMZWBVNRVPVSVJUSVBVAWCVPVQVRABCHGIKUPTACEFVMILSTUNUQUR $.
  $}

  $c CLat $.

  $( Extend class notation with complete lattices. $)
  ccla $a class CLat $.

  ${
    $d p s x y $.
    $( Define the class of all complete lattices.  (Contributed by NM,
       18-Oct-2012.) $)
    df-clat $a |- CLat = { p e. Poset | A. s ( s C_ ( Base ` p )
      -> ( ( ( lub ` p ) ` s ) e. ( Base ` p ) /\
           ( ( glb ` p ) ` s ) e. ( Base ` p ) ) ) } $.
  $}

  ${
    $d l B $.  $d l G $.  $d l s K $.  $d l U $.
    isclat.b $e |- B = ( Base ` K ) $.
    isclat.u $e |- U = ( lub ` K ) $.
    isclat.g $e |- G = ( glb ` K ) $.
    $( The predicate "is a complete lattice."  (Contributed by NM,
       18-Oct-2012.) $)
    isclat $p |- ( K e. CLat <-> ( K e. Poset /\
             A. s ( s C_ B -> ( ( U ` s ) e. B /\ ( G ` s ) e. B ) ) ) ) $=
      ( vl cv cbs cfv wss club wcel cglb wa wi fveq2 syl6eqr ccla sseq2d fveq1d
      wal cpo wceq eleq12d anbi12d imbi12d albidv df-clat elrab2 ) EJZIJZKLZMZU
      MUNNLZLZUOOZUMUNPLZLZUOOZQZRZEUDUMAMZUMBLZAOZUMCLZAOZQZRZEUDIDUEUAUNDUFZV
      DVKEVLUPVEVCVJVLUOAUMVLUODKLAUNDKSFTZUBVLUSVGVBVIVLURVFUOAVLUMUQBVLUQDNLB
      UNDNSGTUCVMUGVLVAVHUOAVLUMUTCVLUTDPLCUNDPSHTUCVMUGUHUIUJEIUKUL $.
  $}

  ${
    $d s B $.  $d s U $.  $d s G $.  $d s K $.  $d s S $.
    clatlem.b $e |- B = ( Base ` K ) $.
    clatlem.u $e |- U = ( lub ` K ) $.
    clatlem.g $e |- G = ( glb ` K ) $.
    $( Lemma for properties of a complete lattice.  (Contributed by NM,
       14-Sep-2011.) $)
    clatlem $p |- ( ( K e. CLat /\ S C_ B ) ->
           ( ( U ` S ) e. B /\ ( G ` S ) e. B ) ) $=
      ( vs ccla wcel cv wss cfv wa wi wal cbs fveq2 eleq1d cpo simprbi cpw fvex
      isclat cvv eqeltri elpw2 sseq1 anbi12d imbi12d spcgv sylbir pm2.43a mpan9
      wceq ) EJKZILZAMZURCNZAKZURDNZAKZOZPZIQZBAMZBCNZAKZBDNZAKZOZUQEUAKVFACDEI
      FGHUEUBVFVGVLVGBAUCZKVFVGVLPZPBAAERNUFFERUDUGUHVEVNIBVMURBUPZUSVGVDVLURBA
      UIVOVAVIVCVKVOUTVHAURBCSTVOVBVJAURBDSTUJUKULUMUNUO $.
  $}

  ${
    clatlubcl.b $e |- B = ( Base ` K ) $.
    clatlubcl.u $e |- U = ( lub ` K ) $.
    $( LUB always exists in a complete lattice.  ( ~ chsupcl analog.)
       (Contributed by NM, 14-Sep-2011.) $)
    clatlubcl $p |- ( ( K e. CLat /\ S C_ B ) -> ( U ` S ) e. B ) $=
      ( ccla wcel wss wa cfv cglb eqid clatlem simpld ) DGHBAIJBCKAHBDLKZKAHABC
      PDEFPMNO $.
  $}

  ${
    clatglbcl.b $e |- B = ( Base ` K ) $.
    clatglbcl.g $e |- G = ( glb ` K ) $.
    $( GLB always exists in a complete lattice.  ( ~ chintcl analog.)
       (Contributed by NM, 14-Sep-2011.) $)
    clatglbcl $p |- ( ( K e. CLat /\ S C_ B ) -> ( G ` S ) e. B ) $=
      ( ccla wcel wss wa club cfv eqid clatlem simprd ) DGHBAIJBDKLZLAHBCLAHABP
      CDEPMFNO $.
  $}

  ${
    $d s K $.
    isclati.1 $e |- K e. Poset $.
    isclati.b $e |- B = ( Base ` K ) $.
    isclati.u $e |- U = ( lub ` K ) $.
    isclati.g $e |- G = ( glb ` K ) $.
    isclati.5 $e |- ( s C_ B -> ( U ` s ) e. B ) $.
    isclati.6 $e |- ( s C_ B -> ( G ` s ) e. B ) $.
    $( Properties that determine a complete lattice.  (Contributed by NM,
       12-Sep-2011.) $)
    isclati $p |- K e. CLat $=
      ( ccla wcel cpo cv wss cfv wa wi wal jca ax-gen isclat mpbir2an ) DLMDNME
      OZAPZUEBQAMZUECQAMZRSZETFUIEUFUGUHJKUAUBABCDEGHIUCUD $.
  $}

  ${
    $d s x y K $.
    $( A complete lattice is a lattice.  (Contributed by NM, 18-Sep-2011.) $)
    clatl $p |- ( K e. CLat -> K e. Lat ) $=
      ( vs vx vy cpo wcel cv cbs cfv wss wa wi co wral w3a fveq2 eleq1d anbi12d
      vex eqid club cglb wal cjn cmee ccla clat cpr prss zfpair wceq sseq1 spcv
      imbi12d sylan2b 3adant1 wb joinval meetval 3expb 3adant2 mpbird ralrimdvv
      imp 3exp imdistani isclat islat 3imtr4i ) AEFZBGZAHIZJZVKAUAIZIZVLFZVKAUB
      IZIZVLFZKZLZBUCZKVJCGZDGZAUDIZMZVLFZWCWDAUEIZMZVLFZKZDVLNCVLNZKAUFFAUGFVJ
      WBWLVJWBWKCDVLVLVJWBWCVLFZWDVLFZKZWKVJWBWOOWKWCWDUHZVNIZVLFZWPVQIZVLFZKZW
      BWOXAVJWOWBWPVLJZXAWCWDVLCSDSUIWBXBXAWAXBXALBWPCDUJVKWPUKZVMXBVTXAVKWPVLU
      LXCVPWRVSWTXCVOWQVLVKWPVNPQXCVRWSVLVKWPVQPQRUNUMVDUOUPVJWOWKXAUQZWBVJWMWN
      XDVJWMWNOZWGWRWJWTXEWFWQVLEVLVNWEAWCWDVLTZVNTZWETZURQXEWIWSVLEVLVQAWHWCWD
      XFVQTZWHTZUSQRUTVAVBVEVCVFVLVNVQABXFXGXIVGCDVLWEAWHXFXHXJVHVI $.
  $}

  ${
    $d h w .<_ $.  $d h w x B $.  $d h w x y H $.  $d h x y K $.  $d x y ph $.
    $d h w x y S $.
    isglbd.b $e |- B = ( Base ` K ) $.
    isglbd.l $e |- .<_ = ( le ` K ) $.
    isglbd.g $e |- G = ( glb ` K ) $.
    isglbd.1 $e |- ( ( ph /\ y e. S ) -> H .<_ y ) $.
    isglbd.2 $e |- ( ( ph /\ x e. B /\ A. y e. S x .<_ y ) -> x .<_ H ) $.
    isglbd.3 $e |- ( ph -> K e. CLat ) $.
    isglbd.4 $e |- ( ph -> S C_ B ) $.
    isglbd.5 $e |- ( ph -> H e. B ) $.
    $( Properties that determine the greatest lower bound of a complete
       lattice.  (Contributed by Mario Carneiro, 19-Mar-2014.) $)
    isglbd $p |- ( ph -> ( G ` S ) = H ) $=
      ( vh wbr wral cfv cv wi wa crio ccla wcel wss wceq syl2anc ralrimiva 3exp
      glbval ralrimiv wreu wb clatglbcl eqeltrrd cbs cvv eqeltri riotaclb breq1
      fvex sylibr ralbidv breq2 imbi2d anbi12d riota2 mpbi2and eqtrd ) AEFUAZRU
      BZCUBZISZCETZBUBZVOISCETZVRVNISZUCZBDTZUDZRDUEZGAHUFUGZEDUHZVMWDUIOPRCBUF
      DEFHIJKLUMUJZAGVOISZCETZVSVRGISZUCZBDTZWDGUIZAWHCEMUKAWKBDAVRDUGVSWJNULUN
      AGDUGWCRDUOZWIWLUDZWMUPQAWDDUGWNAVMWDDWGAWEWFVMDUGOPDEFHJLUQUJURWCRDDHUSU
      AUTJHUSVDVAVBVEWCWORDGVNGUIZVQWIWBWLWPVPWHCEVNGVOIVCVFWPWAWKBDWPVTWJVSVNG
      VRIVGVHVFVIVJUJVKVL $.
  $}

  ${
    $d z B $.  $d y z K $.  $d y z S $.  $d y z U $.
    lublem.b $e |- B = ( Base ` K ) $.
    lublem.l $e |- .<_ = ( le ` K ) $.
    lublem.u $e |- U = ( lub ` K ) $.
    $( Lemma for the least upper bound properties in a complete lattice.
       (Contributed by NM, 19-Oct-2011.) $)
    lublem $p |- ( ( K e. CLat /\ S C_ B ) -> ( A. y e. S y .<_ ( U ` S )
                  /\ A. z e. B ( A. y e. S y .<_ z -> ( U ` S ) .<_ z ) ) ) $=
      ( ccla wcel wss cfv cv wbr wral wi wa clatlubcl lubprop mpd3an3 ) FKLDCMD
      ENZCLAOZUCGPADQUDBOZGPADQUCUEGPRBCQSCDEFHJTABKCDEFGHIJUAUB $.

    $d y z .<_ $.  $d y z X $.
    $( The LUB of a complete lattice subset is an upper bound.  (Contributed by
       NM, 19-Oct-2011.) $)
    lubub $p |- ( ( K e. CLat /\ S C_ B /\ X e. S ) -> X .<_ ( U ` S ) ) $=
      ( vy vz ccla wcel wss cfv wbr wa cv wral wi lublem simpld breq1 rspccva
      sylan 3impa ) DLMZBANZFBMZFBCOZEPZUGUHQZJRZUJEPZJBSZUIUKULUOUMKRZEPJBSUJU
      PEPTKASJKABCDEGHIUAUBUNUKJFBUMFUJEUCUDUEUF $.

    $( The LUB of a complete lattice subset is the least bound.  (Contributed
       by NM, 19-Oct-2011.) $)
    lubl $p |- ( ( K e. CLat /\ S C_ B /\ X e. B )
          -> ( A. y e. S y .<_ X -> ( U ` S ) .<_ X ) ) $=
      ( vz ccla wcel wss cv wbr wral cfv wi breq2 wa lublem simprd wceq ralbidv
      imbi12d rspccva sylan 3impa ) ELMZCBNZGBMZAOZGFPZACQZCDRZGFPZSZUJUKUAZUMK
      OZFPZACQZUPUTFPZSZKBQZULURUSUMUPFPACQVEAKBCDEFHIJUBUCVDURKGBUTGUDZVBUOVCU
      QVFVAUNACUTGUMFTUEUTGUPFTUFUGUHUI $.

    $d y B $.  $d y T $.
    $( Subset law for least upper bounds.  ( ~ chsupss analog.)  (Contributed
       by NM, 20-Oct-2011.) $)
    lubss $p |- ( ( K e. CLat /\ T C_ B /\ S C_ T )
          -> ( U ` S ) .<_ ( U ` T ) ) $=
      ( vy ccla wcel wss w3a cfv cv wbr wral simp1 sstr2 impcom 3adant1 3adant3
      clatlubcl 3jca simpl1 simpl2 ssel2 3ad2antl3 lubub syl3anc ralrimiva lubl
      wa sylc ) EKLZCAMZBCMZNZUPBAMZCDOZALZNJPZVAFQZJBRBDOVAFQUSUPUTVBUPUQURSUQ
      URUTUPURUQUTBCATUAUBUPUQVBURACDEGIUDUCUEUSVDJBUSVCBLZUNUPUQVCCLZVDUPUQURV
      EUFUPUQURVEUGURUPVEVFUQBCVCUHUIACDEFVCGHIUJUKULJABDEFVAGHIUMUO $.

    $( An element of a set is less than or equal to the least upper bound of
       the set.  (Contributed by NM, 21-Oct-2011.) $)
    lubel $p |- ( ( K e. CLat /\ X e. S /\ S C_ B ) -> X .<_ ( U ` S ) ) $=
      ( ccla wcel wss w3a csn cfv wceq clat wa clatl ssel lubsn 3impb wbr snssi
      impcom syl2an lubss syl3an3 3com23 eqbrtrrd ) DJKZFBKZBALZMFNZCOZFBCOZEUK
      ULUMUOFPZUKDQKFAKZUQULUMRDSUMULURBAFTUEACDFGIUAUFUBUKUMULUOUPEUCZULUKUMUN
      BLUSFBUDAUNBCDEGHIUGUHUIUJ $.
  $}

  ${
    $d x y z B $.  $d x y z .\/ $.  $d x y z K $.  $d y z .<_ $.  $d x y z S $.
    $d x y z T $.  $d x y z U $.
    lubun.b $e |- B = ( Base ` K ) $.
    lubun.j $e |- .\/ = ( join ` K ) $.
    lubun.u $e |- U = ( lub ` K ) $.
    $( The LUB of a union.  (Contributed by NM, 5-Mar-2012.) $)
    lubun $p |- ( ( K e. CLat /\ S C_ B /\ T C_ B )
                      -> ( U ` ( S u. T ) ) = ( ( U ` S ) .\/ ( U ` T ) ) ) $=
      ( vy vx vz wcel wbr wral wi wa syl2anc syl3anc adantr ccla wss w3a cun cv
      cfv cple crio co wceq simp1 unss biimpi 3adant1 eqid lubval clat 3ad2ant1
      clatl clatlubcl 3adant3 3adant2 latjcl simpl1 simpl2 simpr sseldd latlej1
      syl simpl3 lubel lattrd ralrimiva latlej2 ralunb sylanbrc ralbidv imbi12d
      breq2 rspcv mpid imp ad2ant2rl anim12d wb latjle12 syl13anc sylibd syl5bi
      lubl adantrr latasymb mpbi2and ex wo jaodan sylan2b breq1 imbi2d biimprcd
      elun anbi12d impbid riota5 eqtrd ) FUAMZBAUBZCAUBZUCZBCUDZDUFZJUEZKUEZFUG
      UFZNZJXJOZXLLUEZXNNZJXJOZXMXQXNNZPZLAOZQZKAUHZBDUFZCDUFZEUIZXIXFXJAUBZXKY
      DUJXFXGXHUKXGXHYHXFXGXHQYHBCAULUMUNKJLUAAXJDFXNGXNUOZIUPRXIYCKAYGXIFUQMZY
      EAMZYFAMZYGAMZXFXGYJXHFUSZURZXFXGYKXHABDFGIUTZVAZXFXHYLXGACDFGIUTZVBZAEFY
      EYFGHVCZSZXIXMAMZQZYCXMYGUJZUUCYCUUDUUCYCQXMYGXNNZYGXMXNNZUUDXIYBUUEUUBXP
      XIYBUUEXIYBXLYGXNNZJXJOZUUEXIUUGJBOUUGJCOUUHXIUUGJBXIXLBMZQZAFXNXLYEYGGYI
      UUJXFYJXFXGXHUUIVDZYNVIZUUJBAXLXFXGXHUUIVEZXIUUIVFZVGUUJXFXGYKUUKUUMYPRZU
      UJYJYKYLYMUULUUOUUJXFXHYLUUKXFXGXHUUIVJYRRZYTSUUJXFUUIXGXLYEXNNUUKUUNUUMA
      BDFXNXLGYIIVKSUUJYJYKYLYEYGXNNUULUUOUUPAEFXNYEYFGYIHVHSVLZVMXIUUGJCXIXLCM
      ZQZAFXNXLYFYGGYIXIYJUURYOTZUUSCAXLXFXGXHUURVJZXIUURVFZVGUUSXFXHYLXFXGXHUU
      RVDZUVAYRRZXIYMUURUUATUUSXFUURXHXLYFXNNUVCUVBUVAACDFXNXLGYIIVKSUUSYJYKYLY
      FYGXNNUUTUUSXFXGYKUVCXFXGXHUURVEYPRUVDAEFXNYEYFGYIHVNSVLZVMUUGJBCVOVPXIYM
      YBUUHUUEPZPUUAYAUVFLYGAXQYGUJZXSUUHXTUUEUVGXRUUGJXJXQYGXLXNVSVQXQYGXMXNVS
      VRVTVIWAWBWCUUCXPUUFYBUUCXPUUFXPXOJBOZXOJCOZQZUUCUUFXOJBCVOUUCUVJYEXMXNNZ
      YFXMXNNZQZUUFUUCUVHUVKUVIUVLUUCXFXGUUBUVHUVKPXFXGXHUUBVDZXFXGXHUUBVEXIUUB
      VFZJABDFXNXMGYIIWJSUUCXFXHUUBUVIUVLPUVNXFXGXHUUBVJUVOJACDFXNXMGYIIWJSWDUU
      CYJYKYLUUBUVMUUFWEUUCXFYJUVNYNVIZXIYKUUBYQTXIYLUUBYSTUVOAEFXNYEYFXMGYIHWF
      WGWHWIWBWKUUCUUEUUFQUUDWEZYCUUCYJUUBYMUVQUVPUVOXIYMUUBUUATAFXNXMYGGYIWLST
      WMWNXIUUDYCPZUUBXIUUHXSYGXQXNNZPZLAOZUVRXIUUGJXJXLXJMXIUUIUURWOUUGXLBCXAX
      IUUIUUGUURUUQUVEWPWQVMXIUVTLAXIXQAMZQZXSYEXQXNNZYFXQXNNZQZUVSXSXRJBOZXRJC
      OZQUWCUWFXRJBCVOUWCUWGUWDUWHUWEUWCXFXGUWBUWGUWDPXFXGXHUWBVDZXFXGXHUWBVEZX
      IUWBVFZJABDFXNXQGYIIWJSUWCXFXHUWBUWHUWEPUWIXFXGXHUWBVJZUWKJACDFXNXQGYIIWJ
      SWDWIUWCYJYKYLUWBUWFUVSWEUWCXFYJUWIYNVIUWCXFXGYKUWIUWJYPRUWCXFXHYLUWIUWLY
      RRUWKAEFXNYEYFXQGYIHWFWGWHVMUUDYCUUHUWAQUUDXPUUHYBUWAUUDXOUUGJXJXMYGXLXNV
      SVQUUDYAUVTLAUUDXTUVSXSXMYGXQXNWRWSVQXBWTRTXCXDXE $.
  $}

  ${
    $d y z B $.  $d y z G $.  $d y z K $.  $d y z .<_ $.  $d y z S $.
    clatglb.b $e |- B = ( Base ` K ) $.
    clatglb.l $e |- .<_ = ( le ` K ) $.
    clatglb.g $e |- G = ( glb ` K ) $.
    $( Properties of greatest lower bound of a complete lattice.  (Contributed
       by NM, 5-Dec-2011.) $)
    clatglb $p |- ( ( K e. CLat /\ S C_ B ) -> ( A. y e. S ( G ` S ) .<_ y
               /\ A. z e. B ( A. y e. S z .<_ y -> z .<_ ( G ` S ) ) ) ) $=
      ( ccla wcel wss cfv cv wbr wral wi wa clatglbcl glbprop mpd3an3 ) FKLDCMD
      ENZCLUCAOZGPADQBOZUDGPADQUEUCGPRBCQSCDEFHJTABKCDEFGHIJUAUB $.

    $d y z X $.
    $( The greatest lower bound is the least element.  (Contributed by NM,
       5-Dec-2011.) $)
    clatglble $p |- ( ( K e. CLat /\ S C_ B /\ X e. S )
          -> ( G ` S ) .<_ X ) $=
      ( ccla wcel wss cfv wbr wa wi clatglbcl glble exp32 mpd 3impia ) DJKZBALZ
      FBKZBCMZFENZUBUCOZUEAKZUDUFPABCDGIQUGUHUDUFJABCDEFGHIRSTUA $.

    $( Two ways of expressing "less than or equal to the greatest lower
       bound."  (Contributed by NM, 5-Dec-2011.) $)
    clatleglb $p |- ( ( K e. CLat /\ X e. B /\ S C_ B )
     -> ( X .<_ ( G ` S ) <-> A. y e. S X .<_ y ) ) $=
      ( vz ccla wcel wbr cv wral wa wi syl breq1 wss w3a cfv clatglble 3adantl2
      3expa clat simpl1 clatl simpl2 clatglbcl 3adant2 adantr ssel 3ad2ant3 imp
      lattr syl13anc mpan2d ralrimdva clatglb simprd wceq ralbidv imbi12d com23
      rspccv ex 3imp impbid ) ELMZGBMZCBUAZUBZGCDUCZFNZGAOZFNZACPZVNVPVRACVNVQC
      MZQZVPVOVQFNZVRVKVMVTWBVLVKVMVTWBBCDEFVQHIJUDUFUEWAEUGMZVLVOBMZVQBMZVPWBQ
      VRRWAVKWCVKVLVMVTUHEUISVKVLVMVTUJVNWDVTVKVMWDVLBCDEHJUKULUMVNVTWEVMVKVTWE
      RVLCBVQUNUOUPBEFGVOVQHIUQURUSUTVKVLVMVSVPRZVKVMVLWFVKVMVLWFRZVKVMQZKOZVQF
      NZACPZWIVOFNZRZKBPZWGWHWBACPWNAKBCDEFHIJVAVBWMWFKGBWIGVCZWKVSWLVPWOWJVRAC
      WIGVQFTVDWIGVOFTVEVGSVHVFVIVJ $.

    $d y T $.
    $( Subset law for greatest lower bound.  (Contributed by Mario Carneiro,
       16-Apr-2014.) $)
    clatglbss $p |- ( ( K e. CLat /\ T C_ B /\ S C_ T )
          -> ( G ` T ) .<_ ( G ` S ) ) $=
      ( vy ccla wcel wss w3a cfv wbr cv wral wa syl3anc simpl1 simpl2 clatglble
      simp3 sselda ralrimiva wb clatglbcl 3adant3 sstr ancoms 3adant1 clatleglb
      simp1 mpbird ) EKLZCAMZBCMZNZCDOZBDOFPZUTJQZFPZJBRZUSVCJBUSVBBLZSUPUQVBCL
      VCUPUQURVEUAUPUQURVEUBUSBCVBUPUQURUDUEACDEFVBGHIUCTUFUSUPUTALZBAMZVAVDUGU
      PUQURUNUPUQVFURACDEGIUHUIUQURVGUPURUQVGBCAUJUKULJABDEFUTGHIUMTUO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The dual of an ordered set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ODual $.

  $( Class function defining dual orders. $)
  codu $a class ODual $.

  $( Define the dual of an ordered structure, which replaces the order
     component of the structure with its reverse.  See ~ odubas , ~ oduleval ,
     and ~ oduleg for its principal properties.

     _EDITORIAL_: likely usable to simplify many lattice proofs, as it allows
     for duality arguments to be formalized; for instance ~ latmass .
     (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
  df-odu $a |- ODual = ( w e. _V |->
      ( w sSet <. ( le ` ndx ) , `' ( le ` w ) >. ) ) $.

  ${
    $d D a $.  $d .<_ a $.  $d O a $.  $d G a $.  $d A a $.  $d B a $.
    oduval.d $e |- D = ( ODual ` O ) $.

    ${
      oduval.l $e |- .<_ = ( le ` O ) $.
      $( Value of an order dual structure.  (Contributed by Stefan O'Rear,
         29-Jan-2015.) $)
      oduval $p |- D = ( O sSet <. ( le ` ndx ) , `' .<_ >. ) $=
        ( va codu cfv cnx cple ccnv cop csts co cvv wcel wceq cv id fveq2 fvmpt
        cnveqd opeq2d oveq12d df-odu ovex wn c0 reldmsets ovprc1 eqtr4d pm2.61i
        fvprc cnveqi opeq2i oveq2i 3eqtr4i ) CGHZCIJHZCJHZKZLZMNZACUSBKZLZMNCOP
        ZURVCQFCFRZUSVGJHZKZLZMNVCOGVGCQZVGCVJVBMVKSVKVIVAUSVKVHUTVGCJTUBUCUDFU
        ECVBMUFUAVFUGURUHVCCGUMCVBMUIUJUKULDVEVBCMVDVAUSBUTEUNUOUPUQ $.

      $( Value of the less-equal relation in an order dual structure.
         (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
      oduleval $p |- `' .<_ = ( le ` D ) $=
        ( cple cfv ccnv cnx cop csts co cvv wcel wceq fvex cnvex pleid setsid
        c0 mpan2 str0 fvprc cnveqd cnv0 syl6eq reldmsets ovprc1 3eqtr4a pm2.61i
        wn fveq2d cnveqi eqid oduval fveq2i 3eqtr4i ) CFGZHZCIFGZUSJZKLZFGZBHAF
        GCMNZUSVCOZVDUSMNVEURCFPQMUSFMCRSUAVDUKZTTFGUSVCFUTRUBVFUSTHTVFURTCFUCU
        DUEUFVFVBTFCVAKUGUHULUIUJBUREUMAVBFAURCDURUNUOUPUQ $.

      oduleg.g $e |- G = ( le ` D ) $.
      $( Truth of the less-equal relation in an order dual structure.
         (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
      oduleg $p |- ( ( A e. V /\ B e. W ) -> ( A G B <-> B .<_ A ) ) $=
        ( wbr ccnv wcel wa cple cfv oduleval eqtr4i breqi brcnvg syl5bb ) ABDLA
        BEMZLAGNBHNOBAELABDUCDCPQUCKCEFIJRSTABGHEUAUB $.
    $}

    odubas.b $e |- B = ( Base ` O ) $.
    $( Base set of an order dual structure.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    odubas $p |- B = ( Base ` D ) $=
      ( cbs cfv cnx cple ccnv cop csts co baseid wne c1 c10 1re 1lt10 ltneii
      basendx plendx neeq12i mpbir setsnid eqid oduval fveq2i 3eqtr4i ) CFGCHIG
      ZCIGZJZKLMZFGABFGULUJFCNHFGZUJOPQOPQRSTUNPUJQUAUBUCUDUEEBUMFBUKCDUKUFUGUH
      UI $.
  $}

  ${
    $d B x y a b c $.  $d ph x y a b c $.  $d K x y a b c $.  $d L x y a b c $.
    pospropd.kv $e |- ( ph -> K e. V ) $.
    pospropd.lv $e |- ( ph -> L e. W ) $.
    pospropd.kb $e |- ( ph -> B = ( Base ` K ) ) $.
    pospropd.lb $e |- ( ph -> B = ( Base ` L ) ) $.
    pospropd.xy $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( le ` K ) y <-> x ( le ` L ) y ) ) $.
    $( Posethood is determined only by structure components and only by the
       value of the relation within the base set.  (Contributed by Stefan
       O'Rear, 29-Jan-2015.) $)
    pospropd $p |- ( ph -> ( K e. Poset <-> L e. Poset ) ) $=
      ( va vb vc wbr wa wral wb cvv wcel cv cple cfv weq w3a cbs cpo ralrimivva
      simp1 jca breq1 bibi12d breq2 rspc2va sylan 3adantl3 3simpb 3comr anbi12d
      wi imbi1d 3adantl1 3anbi123d sylan2 ancoms 3exp2 imp42 ralbidva 2ralbidva
      imbi12d wceq raleq raleqbi1dv 3bitr3d elex biantrurd eqid ispos 3bitr4g
      syl ) AEUAUBZNUCZWDEUDUEZQZWDOUCZWEQZWGWDWEQZRZNOUFZVBZWHWGPUCZWEQZRZWDWM
      WEQZVBZUGZPEUHUEZSZOWSSZNWSSZRZFUAUBZWDWDFUDUEZQZWDWGXEQZWGWDXEQZRZWKVBZX
      GWGWMXEQZRZWDWMXEQZVBZUGZPFUHUEZSZOXPSZNXPSZRZEUIUBFUIUBAXBXSXCXTAWRPDSZO
      DSZNDSZXOPDSZODSZNDSZXBXSAYAYDNODDAWDDUBZWGDUBZRRWRXOPDAYGYHWMDUBZWRXOTZA
      YGYHYIYJYGYHYIUGZAYJAYKBUCZCUCZWEQZYLYMXEQZTZCDSBDSZYJAYPBCDDMUJYKYQRZWFX
      FWLXJWQXNYKYGYGRYQWFXFTZYKYGYGYGYHYIUKZYTULYPYSWDYMWEQZWDYMXEQZTZBCWDWDDD
      BNUFYNUUAYOUUBYLWDYMWEUMYLWDYMXEUMUNZCNUFZUUAWFUUBXFYMWDWDWEUOYMWDWDXEUOU
      NUPUQYRWJXIWKYRWHXGWIXHYGYHYQWHXGTZYIYPUUFUUCBCWDWGDDUUDCOUFUUAWHUUBXGYMW
      GWDWEUOYMWGWDXEUOUNUPURZYKYHYGRZYQWIXHTZYHYIYGUUHYHYIYGUSUTYPUUIWGYMWEQZW
      GYMXEQZTZBCWGWDDDBOUFYNUUJYOUUKYLWGYMWEUMYLWGYMXEUMUNZUUEUUJWIUUKXHYMWDWG
      WEUOYMWDWGXEUOUNUPUQVAVCYRWOXLWPXMYRWHXGWNXKUUGYHYIYQWNXKTZYGYPUUNUULBCWG
      WMDDUUMCPUFZUUJWNUUKXKYMWMWGWEUOYMWMWGXEUOUNUPVDVAYKYGYIRYQWPXMTZYGYHYIUS
      YPUUPUUCBCWDWMDDUUDUUOUUAWPUUBXMYMWMWDWEUOYMWMWDXEUOUNUPUQVLVEVFVGVHVIVJV
      KADWSVMYCXBTKYBXANDWSYAWTODWSWRPDWSVNVOVOWBADXPVMYFXSTLYEXRNDXPYDXQODXPXO
      PDXPVNVOVOWBVPAWCXBAEGUBWCIEGVQWBVRAXDXSAFHUBXDJFHVQWBVRVPNOPWSEWEWSVSWEV
      SVTNOPXPFXEXPVSXEVSVTWA $.
  $}

  ${
    $d D a b c $.  $d O a b c $.  $d V a b c $.
    odupos.d $e |- D = ( ODual ` O ) $.
    $( Being a poset is a self-dual property.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    odupos $p |- ( O e. Poset -> D e. Poset ) $=
      ( va vb vc wcel cbs cfv cple cvv codu a1i wceq cv wa wbr vex brcnv w3a wi
      cpo ccnv fvex eqeltri odubas oduleval posref sylibr weq anbi12ci posasymb
      eqid biimpd syl5bi 3anrev postr sylan2b 3imtr4g isposd ) BUBGZDEFBHIZABJI
      ZUCZAKGVAABLIKCBLUDUEMVBAHINVAVBABCVBUMZUFMVDAJINVAAVCBCVCUMZUGMVADOZVBGZ
      PVGVGVCQVGVGVDQVBBVCVGVEVFUHVGVGVCDRZVISUIVGEOZVDQZVJVGVDQZPVGVJVCQZVJVGV
      CQZPZVAVHVJVBGZTZDEUJZVKVNVLVMVGVJVCVIERZSZVJVGVCVSVISUKVQVOVRVBBVCVGVJVE
      VFULUNUOVAVHVPFOZVBGZTZPWAVJVCQZVNPZWAVGVCQZVKVJWAVDQZPVGWAVDQWCVAWBVPVHT
      WEWFUAVHVPWBUPVBBVCWAVJVGVEVFUQURVKVNWGWDVTVJWAVCVSFRZSUKVGWAVCVIWHSUSUT
      $.

    $( Being a poset is a self-dual property.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    oduposb $p |- ( O e. V -> ( O e. Poset <-> D e. Poset ) ) $=
      ( va vb wcel cpo odupos codu cfv eqid cbs cvv a1i odubas cv cple wbr wa
      fvex id wceq eqidd oduleval eqcomi breqi vex brcnv 3bitri pospropd syl5ib
      wb ccnv impbid2 ) BCGZBHGZAHGZABDIURAJKZHGUPUQUSAUSLZIUPEFBMKZUSBNCUSNGUP
      AJUAOUPUBVAUSMKUCUPVAUSAUTVAABDVALPPOUPVAUDEQZFQZUSRKZSZVBVCBRKZSZUMUPVBV
      AGVCVAGTTVEVBVCVFUNZUNZSVCVBVHSVGVBVCVDVIVIVDUSVHAUTAVFBDVFLUEUEUFUGVBVCV
      HEUHZFUHZUIVCVBVFVKVJUIUJOUKULUO $.
  $}

  ${
    $d a b $.

    $( Lemma for ~ odujoin .  (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
    meet0 $p |- ( meet ` (/) ) = (/) $=
      ( va vb c0 cmee cfv cpr cglb cmpt2 cvv wcel wceq 0ex base0 meetfval ax-mp
      cv eqid mpt20 eqtri ) CDEZABCCAPBPFCGEZEZHZCCIJTUCKLABICUACTMUAQTQNOABCUB
      RS $.

    $( Lemma for ~ odumeet .  (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
    join0 $p |- ( join ` (/) ) = (/) $=
      ( va vb c0 cjn cfv cpr club cmpt2 cvv wcel wceq base0 eqid joinfval ax-mp
      cv 0ex mpt20 eqtri ) CDEZABCCAPBPFCGEZEZHZCCIJTUCKQABICUATCLUAMTMNOABCUBR
      S $.
  $}

  ${
    $d D a b c d $.  $d L a b c d $.  $d U a b c d $.  $d O a b c d $.
    $d V a b c d $.  $d .\/ a b $.  $d ./\ a b $.
    oduglb.d $e |- D = ( ODual ` O ) $.

    ${
      oduglb.l $e |- U = ( lub ` O ) $.
      $( Greatest lower bounds in a dual order are least upper bounds in the
         original order.  (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
      oduglb $p |- ( O e. V -> U = ( glb ` D ) ) $=
        ( va vc vb vd wcel cfv cv wbr wral vex brcnv ralbii eqid cvv cbs cpw wi
        club cglb cple wa crio cmpt wb imbi12i anbi12i riotabiia mpteq2i eqcomi
        ccnv a1i lubfval wceq codu fvex eqeltri odubas oduleval glbfval 3eqtr4a
        mp1i syl5eq ) CDKZBCUDLZAUELZFVIGCUALZUBZHMZIMZCUFLZNZHGMZOZVNJMZVPNZHV
        ROZVOVTVPNZUCZJVLOZUGZIVLUHZUIZGVMVOVNVPUPZNZHVROZVTVNWINZHVROZVTVOWINZ
        UCZJVLOZUGZIVLUHZUIZVJVKWSWHGVMWRWGWQWFIVLWQWFUJVOVLKWKVSWPWEWJVQHVRVOV
        NVPIPZHPZQRWOWDJVLWMWBWNWCWLWAHVRVTVNVPJPZXAQRVTVOVPXBWTQUKRULUQUMUNUOI
        HJDVLVJCVPGVLSZVPSZVJSURATKVKWSUSVIACUTLTECUTVAVBIHJTVLVKAWIGVLACEXCVCA
        VPCEXDVDVKSVEVGVFVH $.
    $}

    ${
      odumeet.j $e |- .\/ = ( join ` O ) $.
      $( Meets in a dual order are joins in the original.  (Contributed by
         Stefan O'Rear, 29-Jan-2015.) $)
      odumeet $p |- .\/ = ( meet ` D ) $=
        ( va vb cjn cfv cmee cvv wcel wceq cv cmpt2 eqid codu eqtr4d c0 fvprc
        cbs cpr club joinfval cglb fvex eqeltri odubas meetfval oduglb 3ad2ant1
        mp1i fveq1d mpt2eq3dva wn syl5eq fveq2d meet0 syl6eq pm2.61i eqtri ) BC
        HIZAJIZECKLZVBVCMVDVBFGCUAIZVEFNZGNZUBZCUCIZIZOZVCFGKVEVIVBCVEPZVIPZVBP
        UDVDVCFGVEVEVHAUEIZIZOZVKAKLVCVPMVDACQIZKDCQUFUGFGKVEVNAVCVEACDVLUHVNPV
        CPUIULVDFGVEVEVJVOVDVFVELVJVOMVGVELVDVHVIVNAVICKDVMUJUMUKUNRRVDUOZVBSVC
        CHTVRVCSJISVRASJVRAVQSDCQTUPUQURUSRUTVA $.
    $}

    ${
      odulub.l $e |- L = ( glb ` O ) $.
      $( Least upper bounds in a dual order are greatest lower bounds in the
         original order.  (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
      odulub $p |- ( O e. V -> L = ( lub ` D ) ) $=
        ( va vb vc vd wcel cfv cv wbr wral vex brcnv ralbii eqid cvv cbs cpw wi
        cglb club cple wa crio cmpt wb imbi12i anbi12i riotabiia mpteq2i eqcomi
        ccnv a1i glbfval wceq codu fvex eqeltri odubas oduleval lubfval 3eqtr4a
        mp1i syl5eq ) CDKZBCUDLZAUELZFVIGCUALZUBZHMZIMZCUFLZNZIGMZOZJMZVOVPNZIV
        ROZVTVNVPNZUCZJVLOZUGZHVLUHZUIZGVMVOVNVPUPZNZIVROZVOVTWINZIVROZVNVTWINZ
        UCZJVLOZUGZHVLUHZUIZVJVKWSWHGVMWRWGWQWFHVLWQWFUJVNVLKWKVSWPWEWJVQIVRVOV
        NVPIPZHPZQRWOWDJVLWMWBWNWCWLWAIVRVOVTVPWTJPZQRVNVTVPXAXBQUKRULUQUMUNUOH
        IJDVLVJCVPGVLSZVPSZVJSURATKVKWSUSVIACUTLTECUTVAVBHIJTVLVKAWIGVLACEXCVCA
        VPCEXDVDVKSVEVGVFVH $.
    $}

    ${
      odujoin.m $e |- ./\ = ( meet ` O ) $.
      $( Joins in a dual order are meets in the original.  (Contributed by
         Stefan O'Rear, 29-Jan-2015.) $)
      odujoin $p |- ./\ = ( join ` D ) $=
        ( va vb cmee cfv cjn cvv wcel wceq cv cmpt2 eqid codu eqtr4d c0 fvprc
        cbs cpr cglb meetfval club fvex eqeltri odubas joinfval odulub 3ad2ant1
        mp1i fveq1d mpt2eq3dva wn syl5eq fveq2d join0 syl6eq pm2.61i eqtri ) BC
        HIZAJIZECKLZVBVCMVDVBFGCUAIZVEFNZGNZUBZCUCIZIZOZVCFGKVEVICVBVEPZVIPZVBP
        UDVDVCFGVEVEVHAUEIZIZOZVKAKLVCVPMVDACQIZKDCQUFUGFGKVEVNVCAVEACDVLUHVNPV
        CPUIULVDFGVEVEVJVOVDVFVELVJVOMVGVELVDVHVIVNAVICKDVMUJUMUKUNRRVDUOZVBSVC
        CHTVRVCSJISVRASJVRAVQSDCQTUPUQURUSRUTVA $.
    $}

    $( Being a lattice is self-dual.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    odulatb $p |- ( O e. V -> ( O e. Lat <-> D e. Lat ) ) $=
      ( va vb wcel cpo cv cjn cfv co cbs cmee wa wral clat oduposb eqid islat
      wb ancom 2ralbii a1i anbi12d odubas odujoin odumeet 3bitr4g ) BCGZBHGZEIZ
      FIZBJKZLBMKZGZULUMBNKZLUOGZOZFUOPEUOPZOAHGZURUPOZFUOPEUOPZOBQGAQGUJUKVAUT
      VCABCDRUTVCUAUJUSVBEFUOUOUPURUBUCUDUEEFUOUNBUQUOSZUNSZUQSZTEFUOUQAUNUOABD
      VDUFAUQBDVFUGAUNBDVEUHTUI $.

    $( Being a complete lattice is self-dual.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    oduclatb $p |- ( O e. CLat <-> D e. CLat ) $=
      ( va ccla wcel cvv c0 club cfv wss eqid codu eleq1d cpo cglb wa wi fveq1d
      wal elex wn noel ssid base0 clatlubcl mpan2 mto fvprc syl5eq mtbiri con4i
      cv oduposb ancom odulub oduglb anbi12d syl5bb imbi2d albidv isclat odubas
      cbs 3bitr4g pm5.21nii ) BEFZBGFZAEFZBEUAVHVIVHUBZVIHEFZVKHHIJZJZHFZVMUCVK
      HHKVNHUDHHVLHUEVLLUFUGUHVJAHEVJABMJHCBMUIUJNUKULVHBOFZDUMZBVDJZKZVPBIJZJZ
      VQFZVPBPJZJZVQFZQZRZDTZQAOFZVRVPAIJZJZVQFZVPAPJZJZVQFZQZRZDTZQVGVIVHVOWHW
      GWQABGCUNVHWFWPDVHWEWOVRWEWDWAQVHWOWAWDUOVHWDWKWAWNVHWCWJVQVHVPWBWIAWBBGC
      WBLZUPSNVHVTWMVQVHVPVSWLAVSBGCVSLZUQSNURUSUTVAURVQVSWBBDVQLZWSWRVBVQWIWLA
      DVQABCWTVCWILWLLVBVEVF $.

    $( Being a lattice is self-dual.  (Contributed by Stefan O'Rear,
       29-Jan-2015.) $)
    odulat $p |- ( O e. Lat -> D e. Lat ) $=
      ( clat wcel odulatb ibi ) BDEADEABDCFG $.
  $}

  ${
    $d .<_ x y z w $.  $d B x y z w $.  $d K x y z w $.  $d S x y z w $.
    poslubmo.l $e |- .<_ = ( le ` K ) $.
    poslubmo.b $e |- B = ( Base ` K ) $.
    $( Least upper bounds in a poset are unique if they exist.  (Contributed by
       Stefan O'Rear, 31-Jan-2015.)  (Revised by NM, 16-Jun-2017.) $)
    poslubmo $p |- ( ( K e. Poset /\ S C_ B ) -> E* x e. B
  ( A. y e. S y .<_ x /\ A. z e. B ( A. y e. S y .<_ z -> x .<_ z ) ) ) $=
      ( vw wcel wa cv wbr wral wi weq breq2 ralbidv imbi12d cpo simplrr simprlr
      wss simprrl rspcv syl3c simplrl simprrr simprll wb posasymb 3expb adantlr
      wrmo adantr mpbi2and ex ralrimivva breq1 imbi2d anbi12d rmo4 sylibr ) FUA
      KZEDUDZLZBMZAMZGNZBEOZVHCMZGNZBEOZVIVLGNZPZCDOZLZVHJMZGNZBEOZVNVSVLGNZPZC
      DOZLZLZAJQZPZJDOADOVRADUOVGWHAJDDVGVIDKZVSDKZLZLZWFWGWLWFLZVIVSGNZVSVIGNZ
      WGWMWJVQWAWNVGWIWJWFUBWLVKVQWEUCWLVRWAWDUEVPWAWNPCVSDCJQZVNWAVOWNWPVMVTBE
      VLVSVHGRSVLVSVIGRTUFUGWMWIWDVKWOVGWIWJWFUHWLVRWAWDUIWLVKVQWEUJWCVKWOPCVID
      CAQZVNVKWBWOWQVMVJBEVLVIVHGRSVLVIVSGRTUFUGWLWNWOLWGUKZWFVEWKWRVFVEWIWJWRD
      FGVIVSIHULUMUNUPUQURUSVRWEAJDWGVKWAVQWDWGVJVTBEVIVSVHGRSWGVPWCCDWGVOWBVNV
      IVSVLGUTVASVBVCVD $.
  $}

  ${
    $d .<_ x y z w $.  $d B x y z w $.  $d K x y z w $.  $d S x y z w $.
    $d U x y z w $.  $d T x y z w $.  $d ph x y z w $.
    poslubd.l $e |- .<_ = ( le ` K ) $.
    poslubd.b $e |- B = ( Base ` K ) $.
    poslubd.u $e |- U = ( lub ` K ) $.
    poslubd.k $e |- ( ph -> K e. Poset ) $.
    poslubd.s $e |- ( ph -> S C_ B ) $.
    poslubd.t $e |- ( ph -> T e. B ) $.
    poslubd.ub $e |- ( ( ph /\ x e. S ) -> x .<_ T ) $.
    poslubd.le $e |- ( ( ph /\ y e. B /\ A. x e. S x .<_ y ) -> T .<_ y ) $.
    $( Properties which determine the least upper bound in a poset.
       (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    poslubd $p |- ( ph -> ( U ` S ) = T ) $=
      ( vz wbr wral cfv cv wi wa crio cpo wcel wss wceq lubval ralrimiva 3expia
      syl2anc jca wreu wb wrex wrmo breq2 ralbidv breq1 imbi2d anbi12d poslubmo
      rspcev reu5 sylanbrc riota2 mpbid eqtrd ) AEGUAZBUBZRUBZISZBETZVLCUBZISBE
      TZVMVPISZUCZCDTZUDZRDUEZFAHUFUGZEDUHZVKWBUIMNRBCUFDEGHIKJLUJUMAVLFISZBETZ
      VQFVPISZUCZCDTZUDZWBFUIZAWFWIAWEBEPUKAWHCDAVPDUGVQWGQULUKUNZAFDUGZWARDUOZ
      WJWKUPOAWARDUQZWARDURZWNAWMWJWOOWLWAWJRFDVMFUIZVOWFVTWIWQVNWEBEVMFVLIUSUT
      WQVSWHCDWQVRWGVQVMFVPIVAVBUTVCZVEUMAWCWDWPMNRBCDEHIJKVDUMWARDVFVGWAWJRDFW
      RVHUMVIVJ $.
  $}

  ${
    $d .<_ x y $.  $d B x y $.  $d K x y $.  $d S x y $.  $d U x y $.
    $d T x y $.  $d ph x y $.
    poslubdg.l $e |- .<_ = ( le ` K ) $.
    poslubdg.b $e |- ( ph -> B = ( Base ` K ) ) $.
    poslubdg.u $e |- ( ph -> U = ( lub ` K ) ) $.
    poslubdg.k $e |- ( ph -> K e. Poset ) $.
    poslubdg.s $e |- ( ph -> S C_ B ) $.
    poslubdg.t $e |- ( ph -> T e. B ) $.
    poslubdg.ub $e |- ( ( ph /\ x e. S ) -> x .<_ T ) $.
    poslubdg.le $e |- ( ( ph /\ y e. B /\ A. x e. S x .<_ y ) -> T .<_ y ) $.
    $( Properties which determine the least upper bound in a poset.
       (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    poslubdg $p |- ( ph -> ( U ` S ) = T ) $=
      ( cfv eqid cv club fveq1d cbs sseqtrd eleqtrd wcel eleq2d biimpar 3adant3
      wbr wral syld3an2 poslubd eqtrd ) AEGREHUARZRFAEGUOLUBABCHUCRZEFUOHIJUPSU
      OSMAEDUPNKUDAFDUPOKUEPACTZDUFZUQUPUFZBTUQIUJBEUKZFUQIUJAUSURUTAURUSADUPUQ
      KUGUHUIQULUMUN $.
  $}

  ${
    $d .<_ x y $.  $d B x y $.  $d K x y $.  $d S x y $.  $d G x y $.
    $d T x y $.  $d ph x y $.
    posglbd.l $e |- .<_ = ( le ` K ) $.
    posglbd.b $e |- ( ph -> B = ( Base ` K ) ) $.
    posglbd.g $e |- ( ph -> G = ( glb ` K ) ) $.
    posglbd.k $e |- ( ph -> K e. Poset ) $.
    posglbd.s $e |- ( ph -> S C_ B ) $.
    posglbd.t $e |- ( ph -> T e. B ) $.
    posglbd.lb $e |- ( ( ph /\ x e. S ) -> T .<_ x ) $.
    posglbd.gt $e |- ( ( ph /\ y e. B /\ A. x e. S y .<_ x ) -> y .<_ T ) $.
    $( Properties which determine the greatest lower bound in a poset.
       (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    posglbd $p |- ( ph -> ( G ` S ) = T ) $=
      ( cfv wcel wbr codu ccnv eqid oduleval cbs odubas syl6eq cglb club odulub
      cpo wceq syl eqtrd odupos cv wa cvv vex brcnvg sylancr adantr mpbird wral
      wb w3a brcnv ralbii syl3an3b sylancl 3ad2ant1 poslubdg ) ABCDEFGHUARZIUBZ
      VMIHVMUCZJUDADHUERZVMUERKVPVMHVOVPUCUFUGAGHUHRZVMUIRZLAHUKSZVQVRULMVMVQHU
      KVOVQUCUJUMUNAVSVMUKSMVMHVOUOUMNOABUPZESZUQVTFVNTZFVTITZPAWBWCVEZWAAVTURS
      FDSZWDBUSZOVTFURDIUTVAVBVCACUPZDSZVTWGVNTZBEVDZVFFWGVNTZWGFITZWJAWHWGVTIT
      ZBEVDWLWIWMBEVTWGIWFCUSZVGVHQVIAWHWKWLVEZWJAWEWGURSWOOWNFWGDURIUTVJVKVCVL
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Subset order structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c toInc $.

  $( Class function defining inclusion posets. $)
  cipo $a class toInc $.

  ${
    $d f o x y $.
    $( For any family of sets, define the poset of that family ordered by
       inclusion.  See ~ ipobas , ~ ipolerval , and ~ ipole for its contract.

       _EDITORIAL_:  I'm not thrilled with the name.  Any suggestions?
       (Contributed by Stefan O'Rear, 30-Jan-2015.)
       (New usage is discouraged.) $)
    df-ipo $a |- toInc = ( f e. _V |-> [_ { <. x , y >. |
            ( { x , y } C_ f /\ x C_ y ) } / o ]_
    ( { <. ( Base ` ndx ) , f >. , <. ( TopSet ` ndx ) , ( ordTop ` o ) >. } u.
      { <. ( le ` ndx ) , o >. , <. ( oc ` ndx ) , ( x e. f |->
           U. { y e. f | ( y i^i x ) = (/) } ) >. } ) ) $.
  $}

  ${
    $( The structure of ~ df-ipo is a structure defining indexes up to 11.
       (Contributed by Mario Carneiro, 25-Oct-2015.) $)
    ipostr $p |- ( { <. ( Base ` ndx ) , B >. , <. ( TopSet ` ndx ) , J >. } u.
                   { <. ( le ` ndx ) , .<_ >. , <. ( oc ` ndx ) , ._|_ >. } )
                 Struct <. 1 , ; 1 1 >. $=
      ( c1 c9 c10 cdc cnx cbs cfv cop cts cpr cple coc 1nn strle2 cc0 1nn0 1lt9
      basendx 9nn tsetndx 10nn plendx clt dec10 0nn0 0lt1 declt eqbrtri decnncl
      ocndx 9lt10 strleun ) EFGEEHZIJKZALIMKZBLNIOKZCLIPKZDLNURUSEFABQUBUAUCUDR
      UTVAGUQCDUEUFGESHUQUGUHESETUIQUJUKULEETQUMUNRUOUP $.
  $}

  ${
    $d f o x y F $.  $d x y I $.  $d f o .<_ $.  $d x y V $.  $d x y X $.
    $d x y Y $.
    ipoval.i $e |- I = ( toInc ` F ) $.
    ${
      ipoval.l $e |- .<_ = { <. x , y >. | ( { x , y } C_ F /\ x C_ y ) } $.
      $( Value of the inclusion poset.  (Contributed by Stefan O'Rear,
         30-Jan-2015.) $)
      ipoval $p |- ( F e. V -> I = ( { <. ( Base ` ndx ) , F >. ,
          <. ( TopSet ` ndx ) , ( ordTop ` .<_ ) >. } u.
        { <. ( le ` ndx ) , .<_ >. , <. ( oc ` ndx ) , ( x e. F |->
           U. { y e. F | ( y i^i x ) = (/) } ) >. } ) ) $=
        ( vf vo wcel cvv cnx cfv cop cpr cv wceq wa opeq2d cbs cts cple coc cin
        cordt c0 crab cuni cmpt cun elex cipo wss copab csb cxp xpex simpl prss
        vex sylibr ssopab2i df-xp sseqtr4i ssexi a1i sseq2 anbi1d syl6eqr simpr
        opabbidv fveq2d preq12d id rabeq unieqd mpteq12dv adantr uneq12d df-ipo
        csbied2 prex unex fvmpt syl5eq syl ) CFKCLKZDMUANZCOZMUBNZEUFNZOZPZMUCN
        ZEOZMUDNZACBQZAQZUEUGRZBCUHZUIZUJZOZPZUKZRCFULWHDCUMNXFGICJWSWRPZIQZUNZ
        WSWRUNZSZABUOZWIXHOZWKJQZUFNZOZPZWOXNOZWQAXHWTBXHUHZUIZUJZOZPZUKZUPXFLU
        MXHCRZJXLEYDXFLXLLKYEXLXHXHUQZXHXHIVAZYGURXLWSXHKWRXHKSZABUOYFXKYHABXKX
        IYHXIXJUSWSWRXHAVABVAUTVBVCABXHXHVDVEVFVGYEXLXGCUNZXJSZABUOEYEXKYJABYEX
        IYIXJXHCXGVHVIVLHVJYEXNERZSZXQWNYCXEYLXMWJXPWMYLXHCWIYEYKUSTYLXOWLWKYLX
        NEUFYEYKVKZVMTVNYLXRWPYBXDYLXNEWOYMTYLYAXCWQYEYAXCRYKYEAXHXTCXBYEVOYEXS
        XAWTBXHCVPVQVRVSTVNVTWBABIJWAWNXEWJWMWCWPXDWCWDWEWFWG $.
    $}

    $( Base set of the inclusion poset.  (Contributed by Stefan O'Rear,
       30-Jan-2015.)  (Revised by Mario Carneiro, 25-Oct-2015.) $)
    ipobas $p |- ( F e. V -> F = ( Base ` I ) ) $=
      ( vx vy wcel cnx cbs cfv cop cts cv cpr wss wa copab cordt cple c1 coc c0
      cin wceq crab cuni cmpt cun cdc ipostr csn snsspr1 ssun1 sstri strfv eqid
      baseid ipoval fveq2d eqtr4d ) ACGZAHIJAKZHLJEMZFMZNAOVCVDOPEFQZRJZKZNZHSJ
      VEKHUAJEAVDVCUCUBUDFAUEUFUGZKNZUHZIJBIJAVKICTTTUIKAVFVEVIUJUQVBUKVHVKVBVG
      ULVHVJUMUNUOVABVKIEFABVECDVEUPURUSUT $.

    $( Relation of the inclusion poset.  (Contributed by Stefan O'Rear,
       30-Jan-2015.) $)
    ipolerval $p |- ( F e. V ->
          { <. x , y >. | ( { x , y } C_ F /\ x C_ y ) } = ( le ` I ) ) $=
      ( wcel cv cpr wss wa copab cnx cfv cop cple wceq cvv vex c1 cbs cts cordt
      coc cin crab cuni cmpt cun cxp simpl sylibr ssopab2i df-xp sseqtr4i xpexg
      c0 prss anidms ssexg sylancr cdc ipostr pleid csn snsspr1 ssun2 sstri syl
      strfv eqid ipoval fveq2d eqtr4d ) CEGZAHZBHZICJZVPVQJZKZABLZMUANCOMUBNWAU
      CNZOIZMPNWAOZMUDNACVQVPUEUQQBCUFUGUHZOZIZUIZPNZDPNVOWARGZWAWIQVOWACCUJZJW
      KRGZWJWAVPCGVQCGKZABLWKVTWMABVTVRWMVRVSUKVPVQCASBSURULUMABCCUNUOVOWLCCEEU
      PUSWAWKRUTVAWAWHPRTTTVBOCWBWAWEVCVDWDVEWGWHWDWFVFWGWCVGVHVJVIVODWHPABCDWA
      EFWAVKVLVMVN $.

    ipole.l $e |- .<_ = ( le ` I ) $.
    $( Topology of the inclusion poset.  (Contributed by Mario Carneiro,
       24-Oct-2015.) $)
    ipotset $p |- ( F e. V -> ( ordTop ` .<_ ) = ( TopSet ` I ) ) $=
      ( vx vy wcel cv cpr wss cordt cfv cnx cop cts cple wceq c1 wa cbs coc cin
      copab c0 crab cuni cmpt cun cvv cdc ipostr tsetid csn snsspr2 ssun1 sstri
      fvex strfv ax-mp ipolerval syl6reqr fveq2d eqid ipoval 3eqtr4a ) ADIZGJZH
      JZKALVIVJLUAGHUEZMNZOUBNAPZOQNVLPZKZORNVKPOUCNGAVJVIUDUFSHAUGUHUIZPKZUJZQ
      NZCMNBQNVLUKIVLVSSVKMUSVLVRQUKTTTULPAVLVKVPUMUNVNUOVOVRVMVNUPVOVQUQURUTVA
      VHCVKMVHVKBRNCGHABDEVBFVCVDVHBVRQGHABVKDEVKVEVFVDVG $.

    $d .<_ x y $.  $d X x y $.  $d Y x y $.
    $( Weak order condition of the inclusion poset.  (Contributed by Stefan
       O'Rear, 30-Jan-2015.) $)
    ipole $p |- ( ( F e. V /\ X e. F /\ Y e. F ) -> ( X .<_ Y <-> X C_ Y ) ) $=
      ( vx vy wcel w3a cv cpr wss wa wbr wb wceq 3adant1 copab preq12 eqid cple
      sseq1d sseq12 anbi12d brabga cfv ipolerval syl6reqr breqd prssi biantrurd
      3ad2ant1 3bitr4d ) ADKZEAKZFAKZLZEFIMZJMZNZAOZVAVBOZPZIJUAZQZEFNZAOZEFOZP
      ZEFCQZVKURUSVHVLRUQVFVLIJEFVGAAVAESVBFSPZVDVJVEVKVNVCVIAVAVBEFUBUEVAEVBFU
      FUGVGUCUHTUQURVMVHRUSUQCVGEFUQVGBUDUICIJABDGUJHUKULUOUTVJVKURUSVJUQEFAUMT
      UNUP $.
  $}

  ${
    ipolt.i $e |- I = ( toInc ` F ) $.
    ipolt.l $e |- .< = ( lt ` I ) $.
    $( Strict order condition of the inclusion poset.  (Contributed by Stefan
       O'Rear, 30-Jan-2015.) $)
    ipolt $p |- ( ( F e. V /\ X e. F /\ Y e. F ) -> ( X .< Y <-> X C. Y ) ) $=
      ( wcel w3a cple cfv wbr wne wa wss wpss wb cvv cipo anbi1d eqeltri pltval
      eqid ipole fvex mp3an1 3adant1 df-pss a1i 3bitr4d ) BDIZEBIZFBIZJZEFCKLZM
      ZEFNZOZEFPZUROZEFAMZEFQZUOUQUTURBCUPDEFGUPUDZUEUAUMUNVBUSRZULCSIUMUNVECBT
      LSGBTUFUBSBBACUPEFVDHUCUGUHVCVARUOEFUIUJUK $.
  $}

  ${
    $d F a b c $.  $d I a b c $.
    ipopos.i $e |- I = ( toInc ` F ) $.
    $( The inclusion poset on a family of sets is actually a poset.
       (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    ipopos $p |- I e. Poset $=
      ( va vb vc cvv wcel cpo cfv cipo a1i cv wa wbr wss wb ipole w3a anbi12d
      cple fvex eqeltri ipobas eqidd ssid eqid 3anidm23 mpbiri weq 3com23 simpl
      simpr eqssd syl6bi wi sstr 3adant3r3 3adant3r1 3adant3r2 3imtr4d wn fvprc
      isposd c0 syl5eq 0pos syl6eqel pm2.61i ) AGHZBIHVJDEFABBUAJZBGHVJBAKJZGCA
      KUBUCLABGCUDVJVKUEVJDMZAHZNVMVMVKOZVMVMPZVMUFVJVNVOVPQABVKGVMVMCVKUGZRUHU
      IVJVNEMZAHZSZVMVRVKOZVRVMVKOZNVMVRPZVRVMPZNZDEUJVTWAWCWBWDABVKGVMVRCVQRZV
      JVSVNWBWDQABVKGVRVMCVQRUKTWEVMVRWCWDULWCWDUMUNUOVJVNVSFMZAHZSNZWCVRWGPZNZ
      VMWGPZWAVRWGVKOZNVMWGVKOZWKWLUPWIVMVRWGUQLWIWAWCWMWJVJVNVSWAWCQWHWFURVJVS
      WHWMWJQVNABVKGVRWGCVQRUSTVJVNWHWNWLQVSABVKGVMWGCVQRUTVAVDVJVBZBVEIWOBVLVE
      CAKVCVFVGVHVI $.
  $}

  ${
    $d A a $.  $d A w z $.  $d A x y $.  $d X w z $.  $d x z $.  $d y z $.
    $( Condition for a family of sets to be directed by inclusion.
       (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    isipodrs $p |- ( ( toInc ` A ) e. Dirset <-> ( A e. _V /\ A =/= (/) /\
            A. x e. A A. y e. A E. z e. A ( x u. y ) C_ z ) ) $=
      ( cipo cfv wcel cvv c0 wne cv wss wrex wral w3a cbs eqid wa wb anbi12d wn
      cdrs cun wceq drsbn0 neneqd fvprc fveq2d base0 syl6eqr nsyl2 cpreset cple
      simp1 wbr isdrs cpo ipopos posprs mp1i 2thd ipobas neeq1 rexeq raleqbi1dv
      id syl simpll simplrl simpr ipole syl3anc simplrr unss rexbidva 2ralbidva
      syl6bb anbi2d bitr3d 3anass 3bitr4g syl5bb pm5.21nii ) DEFZUBGZDHGZWFDIJZ
      AKZBKZUCCKZLZCDMZBDNADNZOZWEWDPFZIUDWFWEWOIWOWDWOQZUEUFWFUAZWOIPFIWQWDIPD
      EUGUHUIUJUKWFWGWMUNWEWDULGZWOIJZWHWJWDUMFZUOZWIWJWTUOZRZCWOMZBWONZAWONZOZ
      WFWNABCWOWDWTWPWTQZUPWFWRWSXFRZRWFWGWMRZRXGWNWFWRWFXIXJWFWRWFWDUQGWRWFDWD
      WDQZURWDUSUTWFVFVAWFWGXCCDMZBDNZADNZRZXIXJWFDWOUDZXOXISDWDHXKVBXPWGWSXNXF
      DWOIVCXMXEADWOXLXDBDWOXCCDWOVDVEVETVGWFXNWMWGWFXLWLABDDWFWHDGZWIDGZRZRZXC
      WKCDXTWJDGZRZXCWHWJLZWIWJLZRWKYBXAYCXBYDYBWFXQYAXAYCSWFXSYAVHZWFXQXRYAVIX
      TYAVJZDWDWTHWHWJXKXHVKVLYBWFXRYAXBYDSYEWFXQXRYAVMYFDWDWTHWIWJXKXHVKVLTWHW
      IWJVNVQVOVPVRVSTWRWSXFVTWFWGWMVTWAWBWC $.

    $( Direction by inclusion as used here implies sethood.  (Contributed by
       Stefan O'Rear, 2-Apr-2015.) $)
    ipodrscl $p |- ( ( toInc ` A ) e. Dirset -> A e. _V ) $=
      ( vx vy vz cipo cfv cdrs wcel cvv c0 wne cv cun wss wrex isipodrs simp1bi
      wral ) AEFGHAIHAJKBLCLMDLNDAOCARBARBCDAPQ $.

    $( Finite upper bound property for directed collections of sets.
       (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    ipodrsfi $p |- ( ( ( toInc ` A ) e. Dirset /\ X C_ A /\ X e. Fin ) ->
        E. z e. A U. X C_ z ) $=
      ( vw cipo cfv cdrs wcel wss cfn w3a cv cple wbr wral wrex cvv 3ad2ant1 wa
      eqid cbs cuni simp2 ipodrscl ipobas syl sseqtrd drsdirfi syld3an2 rexeqdv
      wceq wb adantr sselda adantrl simprl ipole syl3anc anassrs unissb syl6bbr
      ralbidva rexbidva bitr3d mpbid ) BEFZGHZCBIZCJHZKZDLZALZVFMFZNZDCOZAVFUAF
      ZPZCUBVLIZABPZVGCVPIVHVIVQVJCBVPVGVHVIUCZVGVHBVPUKZVIVGBQHZWABUDZBVFQVFTZ
      UEUFRZUGADVPVFVMCVPTVMTZUHUIVJVOABPVQVSVJVOABVPWEUJVJVOVRABVJVLBHZSZVOVKV
      LIZDCOVRWHVNWIDCVJWGVKCHZVNWIULZVJWGWJSZSWBVKBHZWGWKVJWBWLVGVHWBVIWCRUMVJ
      WJWMWGVJCBVKVTUNUOVJWGWJUPBVFVMQVKVLWDWFUQURUSVBDCVLUTVAVCVDVE $.

    $( The finite subsets of any set are directed by inclusion.  (Contributed
       by Stefan O'Rear, 2-Apr-2015.) $)
    fpwipodrs $p |- ( A e. V -> ( toInc ` ( ~P A i^i Fin ) ) e. Dirset ) $=
      ( vx vy vz wcel cpw cfn cin cvv c0 wne cv cun wss wral elin wa elpwi vex
      wrex cipo cfv cdrs pwexg inex1g syl 0elpw 0fin mpbir2an ne0i mp1i anim12i
      unss unex elpw bitr4i sylib ad2ant2r unfi ad2ant2l sylanbrc syl2anb sseq2
      ssid rspcev sylancl rgen2a a1i isipodrs syl3anbrc ) ABFZAGZHIZJFZVNKLZCMZ
      DMZNZEMZOZEVNUAZDVNPCVNPZVNUBUCUDFVLVMJFVOABUEVMHJUFUGKVNFZVPVLWDKVMFKHFA
      UHUIKVMHQUJVNKUKULWCVLWBCDVNVQVNFZVRVNFZRVSVNFZVSVSOZWBWEVQVMFZVQHFZRZVRV
      MFZVRHFZRZWGWFVQVMHQVRVMHQWKWNRVSVMFZVSHFZWGWIWLWOWJWMWIWLRVQAOZVRAOZRZWO
      WIWQWLWRVQASVRASUMWSVSAOWOVQVRAUNVSAVQVRCTDTUOUPUQURUSWJWMWPWIWLVQVRUTVAV
      SVMHQVBVCVSVEWAWHEVSVNVTVSVSVDVFVGVHVICDEVNVJVK $.
  $}

  ${
    $d ph a b c u v $.  $d A a b c u v $.  $d A x y z $.  $d B a b c z $.
    $d B x y $.  $d F a b c u v $.  $d F x y z $.  $d a x y $.  $d b y $.
    ipodrsima.f $e |- ( ph -> F Fn ~P A ) $.
    ipodrsima.m $e |- ( ( ph /\ ( u C_ v /\ v C_ A ) ) ->
        ( F ` u ) C_ ( F ` v ) ) $.
    ipodrsima.d $e |- ( ph -> ( toInc ` B ) e. Dirset ) $.
    ipodrsima.s $e |- ( ph -> B C_ ~P A ) $.
    ipodrsima.a $e |- ( ph -> ( F " B ) e. V ) $.
    $( The monotone image of a directed set.  (Contributed by Stefan O'Rear,
       2-Apr-2015.) $)
    ipodrsima $p |- ( ph -> ( toInc ` ( F " B ) ) e. Dirset ) $=
      ( vz va vb vc wcel wss wral wa vx vy cima cvv c0 wne cv cun wrex cipo cfv
      cdrs elex syl w3a isipodrs sylib simp2d cpw wfn wceq wb syl2anc necon3bid
      fnimaeq0 mpbird simp3d simplll simpr ad2antrr simprr sseldd elpwid adantr
      wi vex weq sseq12 sseq1 adantl anbi12d anbi2d fveq2 syl2an imbi12d vtocl2
      syl12anc anim12d unss 3imtr3g anassrs reximdva ralimdva mpd uneq1 rexbidv
      ex sseq1d ralbidv ralima uneq2 sseq2 rexima bitrd syl3anbrc ) AFEUCZUDQZX
      FUEUFZUAUGZUBUGZUHZMUGZRZMXFUIZUBXFSZUAXFSZXFUJUKULQAXFGQXGLXFGUMUNAXHEUE
      UFZAEUDQZXQNUGZOUGZUHPUGZRZPEUIZOESZNESZAEUJUKULQXRXQYEUOJNOPEUPUQZURAXFU
      EEUEAFDUSZUTZEYGRZXFUEVAEUEVAVBHKYGEFVEVCVDVFAXPXSFUKZXTFUKZUHZYAFUKZRZPE
      UIZOESZNESZAYEYQAXRXQYEYFVGAYDYPNEAXSEQZTZYCYOOEYSXTEQZTYBYNPEYSYTYAEQZYB
      YNVOYSYTUUATZTZXSYARZXTYARZTYJYMRZYKYMRZTYBYNUUCUUDUUFUUEUUGUUCUUDUUFUUCU
      UDTAUUDYADRZUUFAYRUUBUUDVHUUCUUDVIUUCUUHUUDUUCYADUUCEYGYAAYIYRUUBKVJYSYTU
      UAVKVLVMZVNACUGZBUGZRZUUKDRZTZTZUUJFUKZUUKFUKZRZVOZAUUDUUHTZTZUUFVOCBXSYA
      NVPPVPZCNVQZBPVQZTZUUOUVAUURUUFUVEUUNUUTAUVEUULUUDUUMUUHUUJXSUUKYAVRUVDUU
      MUUHVBZUVCUUKYADVSZVTWAWBUVCUUPYJVAUUQYMVAZUURUUFVBUVDUUJXSFWCUUKYAFWCZUU
      PYJUUQYMVRWDWEIWFWGWQUUCUUEUUGUUCUUETAUUEUUHUUGAYRUUBUUEVHUUCUUEVIUUCUUHU
      UEUUIVNUUSAUUEUUHTZTZUUGVOCBXTYAOVPUVBCOVQZUVDTZUUOUVKUURUUGUVMUUNUVJAUVM
      UULUUEUUMUUHUUJXTUUKYAVRUVDUVFUVLUVGVTWAWBUVLUUPYKVAUVHUURUUGVBUVDUUJXTFW
      CUVIUUPYKUUQYMVRWDWEIWFWGWQWHXSXTYAWIYJYKYMWIWJWKWLWMWMWNAXPYJXJUHZXLRZMX
      FUIZUBXFSZNESZYQAYHYIXPUVRVBHKXOUVQUANYGEFXIYJVAZXNUVPUBXFUVSXMUVOMXFUVSX
      KUVNXLXIYJXJWOWRWPWSWTVCAUVQYPNEAUVQYLXLRZMXFUIZOESZYPAYHYIUVQUWBVBHKUVPU
      WAUBOYGEFXJYKVAZUVOUVTMXFUWCUVNYLXLXJYKYJXAWRWPWTVCAUWAYOOEAYHYIUWAYOVBHK
      UVTYNMPYGEFXLYMYLXBXCVCWSXDWSXDVFUAUBMXFUPXE $.
  $}

  ${
    $d C s t x y $.  $d F s t x y $.  $d X s t x y $.  $d Y s t $.  $d S s $.
    $( An algebraic closure system satisfies ~ isacs3 .  (Contributed by Stefan
       O'Rear, 2-Apr-2015.) $)
    isacs3lem $p |- ( C e. ( ACS ` X ) -> ( C e. ( Moore ` X ) /\
          A. s e. ~P C ( ( toInc ` s ) e. Dirset -> U. s e. C ) ) ) $=
      ( vx vy cfv wcel cv cuni cpw wral wss cfn cin elpwid sseli ad2antrr sstrd
      wa adantl cacs cmre cipo cdrs acsmre cmrc mresspw syl sspwb sylib sspwuni
      wi sselda adantr wrex inss1 inss2 fissuni syl2anc ad2antll ad3antrrr eqid
      simprr unissd ad2antrl mrcssd simpl ipodrsfi syl3anc elpwi simprl mrcsscl
      wel sseldd elssuni rexlimddv anassrs adantrr adantlrr ralrimiva mpbir2and
      wb acsfiel ex jca ) ABUAFGZABUBFGZCHZUCFUDGZWHIZAGZULZCAJZKABUEZWFWLCWMWF
      WHWMGZSZWIWKWPWISZWKWJBLZDHZAUFFZFZWJLZDWJJZMNZKZWPWRWIWPWHBJZLWRWPWHXFWF
      WMXFJZWHWFAXFLZWMXGLWFWGXHWNABUGUHAXFUIUJUMOWHBUKUJZUNWQXBDXDWPWIWSXDGZXB
      WPWIXJSZSZWSEHZIZLZXBEWHJZMNZXJXOEXQUOZWPWIXJWSWJLZWSMGXRXJWSWJXDXCWSXCMU
      PPOXDMWSXCMUQPWSWHEURUSUTXLXMXQGZXOSZSZXAXNWTFZWJYBAWSWTXNBWFWGWOXKYAWNVA
      WTVBZXLXTXOVCYBXNWJBXTXNWJLXLXOXTXMWHXTXMWHXQXPXMXPMUPPOZVDVEWPWRXKYAXIQR
      VFWPWIYAYCWJLZXJWQXTYFXOWPWIXTYFWPWIXTSZSZXNWSLZYFDWHYGYIDWHUOZWPYGWIXMWH
      LZXMMGZYJWIXTVGXTYKWIYETXTYLWIXQMXMXPMUQPTDWHXMVHVITYHDCVMZYISZSZYCWSWJYO
      WGYIWSAGYCWSLWFWGWOYGYNWNVAYHYMYIVCYOWHAWSWPWHALZYGYNWOYPWFWHAVJTQYHYMYIV
      KVNAXNWTWSBYDVLVIYMXSYHYIWSWHVOVERVPVQVRVSRVPVQVTWFWKWRXESWBWOWIDAWJWTBYD
      WCQWAWDVTWE $.

    $( An algebraic closure system contains all directed unions of closed
       sets.  (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    acsdrsel $p |- ( ( C e. ( ACS ` X ) /\ Y C_ C /\
          ( toInc ` Y ) e. Dirset ) -> U. Y e. C ) $=
      ( vs cacs cfv wcel wss cipo cdrs cuni wa cv wi wral elpw2g biimpar eleq1d
      cpw cmre isacs3lem simprd adantr wceq fveq2 imbi12d rspcva syl2anc 3impia
      unieq ) ABEFZGZCAHZCIFZJGZCKZAGZULUMLCASZGZDMZIFZJGZUTKZAGZNZDUROZUOUQNZU
      LUSUMCAUKPQULVFUMULABTFGVFABDUAUBUCVEVGDCURUTCUDZVBUOVDUQVHVAUNJUTCIUERVH
      VCUPAUTCUJRUFUGUHUI $.

    acsdrscl.f $e |- F = ( mrCls ` C ) $.
    $( In a closure system in which directed unions of closed sets are closed,
       closure commutes with directed unions.  (Contributed by Stefan O'Rear,
       2-Apr-2015.) $)
    isacs4lem $p |- ( ( C e. ( Moore ` X ) /\
          A. s e. ~P C ( ( toInc ` s ) e. Dirset -> U. s e. C ) ) ->
        ( C e. ( Moore ` X ) /\ A. t e. ~P ~P X ( ( toInc ` t ) e. Dirset ->
              ( F ` U. t ) = U. ( F " t ) ) ) ) $=
      ( vy cfv wcel cv cipo cdrs cuni wi cpw wceq wa wss syl2anc cvv cmre elpwi
      vx wral cima simpll ad2antrl mrcuni wfn mrcf ffn syl adantr simprl simprr
      wf mrcssd cmrc fvex eqeltri imaexg mp1i ipodrsima adantlr crn imassrn frn
      syl5ss ax-mp sylibr ad2antrr simplr fveq2 eleq1d unieq imbi12d rspcva mpd
      elpw mrcid eqtrd exp32 ralrimiv ex imdistani ) BDUAHIZEJZKHZLIZWGMZBIZNZE
      BOZUDZAJZKHLIZWOMCHZCWOUEZMZPZNZADOZOZUDZWFWNXDWFWNQZXAAXCXEWOXCIZWPWTXEX
      FWPQZQZWQWSCHZWSXHWFWOXBRZWQXIPWFWNXGUFZXFXJXEWPWOXBUBZUGBWOCDFUHSXHWFWSB
      IZXIWSPXKXHWRKHZLIZXMWFXGXOWNWFXGQZGUCDWOCTWFCXBUIZXGWFXBBCUPZXQBCDFUJZXB
      BCUKULUMXPUCJZGJZRZYADRZQZQBXTCYADWFXGYDUFFXPYBYCUNXPYBYCUOUQWFXFWPUOXFXJ
      WFWPXLUGCTIZWRTIZXPCBURHTFBURUSUTZCWOTVAZVBVCVDXHWRWMIZWNXOXMNZWFYIWNXGWF
      WRBRYIWFWRCVEZBCWOVFWFXRYKBRXSXBBCVGULVHWRBYEYFYGYHVIVSVJVKWFWNXGVLWLYJEW
      RWMWGWRPZWIXOWKXMYLWHXNLWGWRKVMVNYLWJWSBWGWRVOVNVPVQSVRBWSCDFVTSWAWBWCWDW
      E $.

    $( If closure commutes with directed unions, then the closure of a set is
       the closure of its finite subsets.  (Contributed by Stefan O'Rear,
       2-Apr-2015.) $)
    isacs5lem $p |- ( ( C e. ( Moore ` X ) /\
          A. t e. ~P ~P X ( ( toInc ` t ) e. Dirset ->
              ( F ` U. t ) = U. ( F " t ) ) ) -> ( C e. ( Moore ` X ) /\
          A. s e. ~P X ( F ` s ) = U. ( F " ( ~P s i^i Fin ) ) ) ) $=
      ( cfv wcel cv cipo cdrs cuni cima wceq wi cpw wral cfn wa wss cmre unifpw
      cin fveq2i cvv fpwipodrs mp1i inss1 elpwi sspwb sylib adantl syl5ss inex1
      pwex elpw sylibr adantlr simplr fveq2 eleq1d fveq2d imaeq2 unieqd eqeq12d
      vex unieq imbi12d rspcva syl2anc mpd syl5eqr ralrimiva ex imdistani ) BDU
      AGHZAIZJGZKHZVQLZCGZCVQMZLZNZOZADPZPZQZEIZCGZCWIPZRUCZMZLZNZEWFQZVPWHWPVP
      WHSZWOEWFWQWIWFHZSZWJWLLZCGZWNWTWICWIUBUDWSWLJGZKHZXAWNNZWIUEHXCWSEVFZWIU
      EUFUGWSWLWGHZWHXCXDOZVPWRXFWHVPWRSZWLWFTXFXHWLWKWFWKRUHWRWKWFTZVPWRWIDTXI
      WIDUIWIDUJUKULUMWLWFWKRWIXEUOUNUPUQURVPWHWRUSWEXGAWLWGVQWLNZVSXCWDXDXJVRX
      BKVQWLJUTVAXJWAXAWCWNXJVTWTCVQWLVGVBXJWBWMVQWLCVCVDVEVHVIVJVKVLVMVNVO $.

    $( In an algebraic closure system, closure commutes with directed unions.
       (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    acsdrscl $p |- ( ( C e. ( ACS ` X ) /\ Y C_ ~P X /\
          ( toInc ` Y ) e. Dirset ) -> ( F ` U. Y ) = U. ( F " Y ) ) $=
      ( vt vs cacs cfv wcel cpw cipo cdrs cuni cima wceq wa cv wi wral wb pwexg
      wss cdm elfvdm elpw2g 3syl biimpar cmre isacs3lem isacs4lem simprd adantr
      cvv fveq2 eleq1d unieq fveq2d imaeq2 unieqd eqeq12d imbi12d rspcva 3impia
      syl syl2anc ) ACHIJZDCKZUCZDLIZMJZDNZBIZBDOZNZPZVGVIQDVHKZJZFRZLIZMJZVSNZ
      BIZBVSOZNZPZSZFVQTZVKVPSZVGVRVIVGCHUDZJVHUNJVRVIUAACHUECWJUBDVHUNUFUGUHVG
      WHVIVGACUIIJZWHVGWKGRZLIMJWLNAJSGAKTQWKWHQACGUJFABCGEUKVEULUMWGWIFDVQVSDP
      ZWAVKWFVPWMVTVJMVSDLUOUPWMWCVMWEVOWMWBVLBVSDUQURWMWDVNVSDBUSUTVAVBVCVFVD
      $.

    $( A closure in an algebraic closure system is the union of the closures of
       finite subsets.  (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    acsficl $p |- ( ( C e. ( ACS ` X ) /\ S C_ X ) ->
        ( F ` S ) = U. ( F " ( ~P S i^i Fin ) ) ) $=
      ( vs vt cacs cfv wcel wa cpw cv cfn cin cima cuni wceq wral cipo wss cmre
      cdm wb elfvdm elpw2g biimpar cdrs wi isacs3lem isacs4lem isacs5lem simprd
      syl 3syl adantr fveq2 pweq ineq1d imaeq2d unieqd eqeq12d rspcva syl2anc )
      ADHIJZBDUAZKBDLZJZFMZCIZCVILZNOZPZQZRZFVGSZBCIZCBLZNOZPZQZRZVEVHVFVEDHUCZ
      JVHVFUDADHUEBDWCUFUNUGVEVPVFVEADUBIJZVPVEWDVITIUHJVIQAJUIFALSKWDGMZTIUHJW
      EQCICWEPQRUIGVGLSKWDVPKADFUJGACDFEUKGACDFEULUOUMUPVOWBFBVGVIBRZVJVQVNWAVI
      BCUQWFVMVTWFVLVSCWFVKVRNVIBURUSUTVAVBVCVD $.

    $( A closure system is algebraic iff the closure of a generating set is the
       union of the closures of its finite subsets.  (Contributed by Stefan
       O'Rear, 2-Apr-2015.) $)
    isacs5 $p |- ( C e. ( ACS ` X ) <-> ( C e. ( Moore ` X ) /\
          A. s e. ~P X ( F ` s ) = U. ( F " ( ~P s i^i Fin ) ) ) ) $=
      ( vt cfv wcel cv cpw cima cuni wceq wral wa cipo cdrs wi 3syl wss cfn cin
      cacs cmre isacs3lem isacs4lem isacs5lem simpl elpwi mrcidb2 sylan2 adantr
      wb ciun simpr wfun mrcf ffun funiunfv ad2antrr eqtr4d sseq1d iunss syl6bb
      wf bitrd ex ralimdva imp isacs2 sylanbrc impbii ) ACUCGHZACUDGHZDIZBGZBVO
      JUAUBZKLZMZDCJZNZOZVMVNVOPGQHVOLAHRDAJNOVNFIZPGQHWCLBGBWCKLMRFVTJNOWBACDU
      EFABCDEUFFABCDEUGSWBVNVOAHZWCBGZVOTFVQNZUMZDVTNZVMVNWAUHVNWAWHVNVSWGDVTVN
      VOVTHZOZVSWGWJVSOZWDVPVOTZWFWJWDWLUMZVSWIVNVOCTWMVOCUIAVOBCEUJUKULWKWLFVQ
      WEUNZVOTWFWKVPWNVOWKVPVRWNWJVSUOVNWNVRMZWIVSVNVTABVEBUPWOABCEUQVTABURFVQB
      USSUTVAVBFVQWEVOVCVDVFVGVHVIFABCDEVJVKVL $.

    $( A closure system is algebraic iff closure commutes with directed
       unions.  (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    isacs4 $p |- ( C e. ( ACS ` X ) <-> ( C e. ( Moore ` X ) /\
          A. s e. ~P ~P X ( ( toInc ` s ) e. Dirset ->
              ( F ` U. s ) = U. ( F " s ) ) ) ) $=
      ( vt cacs cfv wcel cmre cv cipo cdrs cuni cima wceq wi cpw wral wa isacs5
      isacs3lem isacs4lem syl cfn cin isacs5lem sylibr impbii ) ACGHIZACJHIZDKZ
      LHMIULNBHBULONPQDCRZRSTZUJUKFKZLHMIUONAIQFARSTUNACFUBDABCFEUCUDUNUKUOBHBU
      ORUEUFONPFUMSTUJDABCFEUGABCFEUAUHUI $.
  $}

  ${
    $d C s t $.  $d X s t $.
    $( A closure system is algebraic iff directed unions of closed sets are
       closed.  (Contributed by Stefan O'Rear, 2-Apr-2015.) $)
    isacs3 $p |- ( C e. ( ACS ` X ) <-> ( C e. ( Moore ` X ) /\
          A. s e. ~P C ( ( toInc ` s ) e. Dirset -> U. s e. C ) ) ) $=
      ( vt cacs cfv wcel cmre cv cipo cdrs cuni wi cpw wral isacs3lem cmrc cima
      wa wceq eqid isacs4lem isacs4 sylibr impbii ) ABEFGZABHFGZCIZJFKGUHLAGMCA
      NOSZABCPUIUGDIZJFKGUJLAQFZFUKUJRLTMDBNNOSUFDAUKBCUKUAZUBAUKBDULUCUDUE $.
  $}

  ${
    acsficld.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    acsficld.2 $e |- N = ( mrCls ` A ) $.
    acsficld.3 $e |- ( ph -> S C_ X ) $.
    $( In an algebraic closure system, the closure of a set is the union of the
       closures of its finite subsets.  Deduction form of ~ acsficl .
       (Contributed by David Moews, 1-May-2017.) $)
    acsficld $p |- ( ph -> ( N ` S ) = U. ( N " ( ~P S i^i Fin ) ) ) $=
      ( cacs cfv wcel wss cpw cfn cin cima cuni wceq acsficl syl2anc ) ABEIJKCE
      LCDJDCMNOPQRFHBCDEGST $.

    $d S x $.  $d A w z $.  $d w X z $.  $d w z N $.  $d x Y $.  $d x N $.
    $( In an algebraic closure system, an element is in the closure of a set if
       and only if it is in the closure of a finite subset.  Alternate form of
       ~ acsficl .  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    acsficl2d $p |- ( ph -> ( Y e. ( N ` S ) <->
                              E. x e. ( ~P S i^i Fin ) Y e. ( N ` x ) ) ) $=
      ( vz vw cfv wcel cpw cfn cin cima cv wfun cuni wrex acsficld cmre acsmred
      eleq2d wb crab cint cmpt funmpt mrcfval funeqd mpbiri eluniima 3syl bitrd
      wss ) AGDEMZNGEDOPQZRUAZNZGBSEMNBUTUBZAUSVAGACDEFHIJUCUFACFUDMNZETZVBVCUG
      ACFHUEVDVEKFOZKSLSURLCUHUIZUJZTKVFVGUKVDEVHKCEFLIULUMUNBUTGEUOUPUQ $.
  $}

  ${
    $d A x $.  $d s S t x $.  $d s t x ph $.  $d s t x I $.  $d s t N $.
    acsfiindd.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    acsfiindd.2 $e |- N = ( mrCls ` A ) $.
    acsfiindd.3 $e |- I = ( mrInd ` A ) $.
    acsfiindd.4 $e |- ( ph -> S C_ X ) $.
    $( In an algebraic closure system, a set is independent if and only if all
       its finite subsets are independent.  Part of Proposition 4.1.3 in
       [FaureFrolicher] p. 83.  (Contributed by David Moews, 1-May-2017.) $)
    acsfiindd $p |- ( ph -> ( S e. I <-> ( ~P S i^i Fin ) C_ I ) ) $=
      ( vs vt wcel cfn wss wa cfv simpr adantr wn vx cpw cin wral cmre ad2antrr
      cv acsmred simplr inss1 sseldi elpwid mrissmrid ralrimiva sylibr csn cdif
      dfss3 cun elfpw sylib simpld difss2d snssd unssd simprd snfi unfi sylancl
      sylanbrc wceq ad4antr simpllr snidg elun2 eleqtrrd ismri2dad wi ad3antrrr
      neldifsnd ssneldd difsnb ssun1 syl5sseqr ssdifd eqsstr3d eqsstrd ssdifssd
      3syl sstrd mrcssd sseld mtod ex rspcimdv syl5bi impancom ralrimiv wb wrex
      acsficl2d notbid ralnex syl6bbr mpbird an32s ismri2dd impbida ) ACDMZCUBZ
      NUCZDOZAXIPZKUGZDMZKXKUDZXLXMXOKXKXMXNXKMZPZBCXNDEFABFUEQMZXIXQABFGUHZUFH
      IAXIXQUIXRXNCXRXKXJXNXJNUJXMXQRUKULUMUNKXKDURZUOAXLPZUABCDEFHIAXSXLXTSACF
      OZXLJSYBUAUGZCYDUPZUQZEQMZTZUACAYDCMZXLYHAYIPZXLPZYHYDLUGZEQZMZTZLYFUBNUC
      ZUDZYKYOLYPYJYLYPMZXLYOXLXPYJYRPZYOYAYSXOYOKYLYEUSZXKYSYTCOZYTNMZYTXKMYSY
      LYECYSYLCYEYSYLYFOZYLNMZYSYRUUCUUDPYJYRRYLYFUTVAZVBZVCYSYDCAYIYRUIVDVEZYS
      UUDYENMUUBYSUUCUUDUUEVFYDVGYLYEVHVIYTCUTVJYSXNYTVKZPZXOYOUUIXOPZYNYDXNYEU
      QZEQZMZUUJBXNDEFYDHIAXSYIYRUUHXOXTVLUUIXORUUIYDXNMXOUUIYDYTXNUUIYIYDYEMYD
      YTMAYIYRUUHVMYDCVNYDYEYLVOWIYSUUHRZVPSVQUUIYNUUMVRXOUUIYMUULYDUUIBYLEUUKF
      AXSYIYRUUHXTVSHUUIYLYLYEUQZUUKUUIYDYLMTUUOYLVKUUIYLYFYDYSUUCUUHUUFSUUIYDC
      VTWAYDYLWBVAUUIYLXNYEUUIYTYLXNYLYEWCUUNWDWEWFUUIXNFYEUUIXNYTFUUNUUIYTCFYS
      UUAUUHUUGSAYCYIYRUUHJVSWJWGWHWKWLSWMWNWOWPWQWRAYHYQWSYIXLAYHYNLYPWTZTYQAY
      GUUPALBYFEFYDGHACFYEJWHXAXBYNLYPXCXDUFXEXFUNXGXH $.
  $}

  ${
    $d T f x $.  $d f x ph $.  $d S f x y $.  $d f x y N $.
    acsmapd.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    acsmapd.2 $e |- N = ( mrCls ` A ) $.
    acsmapd.3 $e |- ( ph -> S C_ X ) $.
    acsmapd.4 $e |- ( ph -> T C_ ( N ` S ) ) $.
    $( In an algebraic closure system, if ` T ` is contained in the closure of
       ` S ` , there is a map ` f ` from ` T ` into the set of finite subsets
       of ` S ` such that the closure of ` U. ran f ` contains ` T ` .  This is
       proven by applying ~ acsficl2d to each element of ` T ` .  See Section
       II.5 in [Cohn] p. 81 to 82.  (Contributed by David Moews,
       1-May-2017.) $)
    acsmapd $p |- ( ph -> E. f
                   ( f : T --> ( ~P S i^i Fin ) /\ T C_ ( N ` U. ran f ) ) ) $=
      ( vx vy cv cfv wcel wa cuni wss syl cpw cfn cin wf wral wex crn wrex fvex
      cvv ssex sseld acsficl2d sylibd ralrimiv wceq fveq2 eleq2d sylc simprl wi
      ac6sg wal nfv nfan csn ad2antrr acsmred wfn simplrl ffn fnfvelrn sylancom
      nfra1 snssd unissd frn unifpw syl6sseq sstrd mrcssd simprr r19.21bi unisn
      cacs fveq2i syl6eleqr sseldd ex alrimi dfss2 sylibr jca eximdv mpd ) ADCU
      AUBUCZENZUDZLNZWSWQOZFOZPZLDUEZQZEUFZWRDWQUGZRZFOZSZQZEUFADUJPZWSMNZFOZPZ
      MWPUHZLDUEXEADCFOZSXKKDXPCFUIUKTAXOLDAWSDPZWSXPPXOADXPWSKULAMBCFGWSHIJUMU
      NUOXNXBLMDWPEUJXLWTUPXMXAWSXLWTFUQURVBUSAXDXJEAXDXJAXDQZWRXIAWRXCUTXRXQWS
      XHPZVAZLVCXIXRXTLAXDLALVDWRXCLWRLVDXBLDVNVEVEXRXQXSXRXQQZWTVFZRZFOZXHWSYA
      BYCFXGGYABGABGWEOPXDXQHVGVHIYAYBXFYAWTXFXRXQWQDVIZWTXFPYAWRYEAWRXCXQVJZDW
      PWQVKTDWSWQVLVMVOVPYAXGCGYAWRXGCSYFWRXGWPRCWRXFWPDWPWQVQVPCVRVSTACGSXDXQJ
      VGVTWAYAWSXAYDXRXBLDAWRXCWBWCYCWTFWTWSWQUIWDWFWGWHWIWJLDXHWKWLWMWIWNWO $.
  $}

  ${
    $d S f $.  $d T f $.  $d f ph $.  $d f N $.
    acsmap2d.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    acsmap2d.2 $e |- N = ( mrCls ` A ) $.
    acsmap2d.3 $e |- I = ( mrInd ` A ) $.
    acsmap2d.4 $e |- ( ph -> S e. I ) $.
    acsmap2d.5 $e |- ( ph -> T C_ X ) $.
    acsmap2d.6 $e |- ( ph -> ( N ` S ) = ( N ` T ) ) $.
    $( In an algebraic closure system, if ` S ` and ` T ` have the same closure
       and ` S ` is independent, then there is a map ` f ` from ` T ` into the
       set of finite subsets of ` S ` such that ` S ` equals the union of
       ` ran f ` .  This is proven by taking the map ` f ` from ~ acsmapd and
       observing that, since ` S ` and ` T ` have the same closure, the closure
       of ` U. ran f ` must contain ` S ` .  Since ` S ` is independent, by
       ~ mrissmrcd , ` U. ran f ` must equal ` S ` .  See Section II.5 in
       [Cohn] p. 81 to 82.  (Contributed by David Moews, 1-May-2017.) $)
    acsmap2d $p |- ( ph -> E. f
                     ( f : T --> ( ~P S i^i Fin ) /\ S = U. ran f ) ) $=
      ( cuni cfv wss wa wex adantr cpw cfn cin crn wceq acsmred mrissd mrcssidd
      sseqtr4d acsmapd simprl cmre wcel simprr mrcssvd mrcssd frn unissd unifpw
      cv wf syl6sseq ad2antrl sstrd mrcidmd sseqtrd eqsstrd mrissmrcd ex eximdv
      jca mpd ) ADCUAUBUCZEUTZVAZDVNUDZOZGPZQZRZESVOCVQUEZRZESABCDEGHIJABCFHKAB
      HIUFZLUGADDGPZCGPZABDGHWCJMUHNUIUJAVTWBEAVTWBAVTRZVOWAAVOVSUKWFBCVQFGHABH
      ULPUMVTWCTZJKWFCWEVRWFBCGHWGJWFBCFHKWGACFUMVTLTZUGZUHWFWEWDVRAWEWDUEVTNTW
      FWDVRGPVRWFBDGVRHWGJAVOVSUNWFBVQGHWGJUOUPWFBVQGHWGJWFVQCHVOVQCQAVSVOVQVMO
      CVOVPVMDVMVNUQURCUSVBVCZWIVDVEVFVGVDWJWHVHVKVIVJVL $.

    acsinfd.7 $e |- ( ph -> -. S e. Fin ) $.
    $( In an algebraic closure system, if ` S ` and ` T ` have the same closure
       and ` S ` is infinite independent, then ` T ` is infinite.  This follows
       from applying ~ unirnffid to the map given in ~ acsmap2d .  See Section
       II.5 in [Cohn] p. 81 to 82.  (Contributed by David Moews,
       1-May-2017.) $)
    acsinfd $p |- ( ph -> -. T e. Fin ) $=
      ( vf cfn wf wa wcel wn cpw cin crn cuni wceq acsmap2d simplrr wss simplrl
      cv inss2 fss sylancl simpr unirnffid eqeltrd ad2antrr pm2.65da exlimddv )
      ADCUAZPUBZOUJZQZCVBUCUDZUEZRZDPSZTOABCDOEFGHIJKLMUFAVFRZVGCPSZVHVGRZCVDPA
      VCVEVGUGVJDVBVJVCVAPUHDPVBQAVCVEVGUIUTPUKDVAPVBULUMVHVGUNUOUPAVITVFVGNUQU
      RUS $.

    $( In an algebraic closure system, if ` S ` and ` T ` have the same closure
       and ` S ` is infinite independent, then ` T ` dominates ` S ` .  This
       follows from applying ~ acsinfd and then applying ~ unirnfdomd to the
       map given in ~ acsmap2d .  See Section II.5 in [Cohn] p. 81 to 82.
       (Contributed by David Moews, 1-May-2017.) $)
    acsdomd $p |- ( ph -> S ~<_ T ) $=
      ( vf cfn wf wa cdom adantr cpw cin cv crn cuni wbr acsmap2d simprr simprl
      wceq cvv wss inss2 fss sylancl wcel acsinfd cacs elfvexd ssexd unirnfdomd
      wn cfv eqbrtrd exlimddv ) ADCUAZPUBZOUCZQZCVHUDUEZUJZRZCDSUFOABCDOEFGHIJK
      LMUGAVLRZCVJDSAVIVKUHVMDVHUKVMVIVGPULDPVHQAVIVKUIVFPUMDVGPVHUNUOADPUPVBVL
      ABCDEFGHIJKLMNUQTVMDGUKVMBURGABGURVCUPVLHTUSADGULVLLTUTVAVDVE $.
  $}

  ${
    acsinfdimd.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    acsinfdimd.2 $e |- N = ( mrCls ` A ) $.
    acsinfdimd.3 $e |- I = ( mrInd ` A ) $.
    acsinfdimd.4 $e |- ( ph -> S e. I ) $.
    acsinfdimd.5 $e |- ( ph -> T e. I ) $.
    acsinfdimd.6 $e |- ( ph -> ( N ` S ) = ( N ` T ) ) $.
    acsinfdimd.7 $e |- ( ph -> -. S e. Fin ) $.
    $( In an algebraic closure system, if two independent sets have equal
       closure and one is infinite, then they are equinumerous.  This is proven
       by using ~ acsdomd twice with ~ acsinfd .  See Section II.5 in [Cohn]
       p. 81 to 82.  (Contributed by David Moews, 1-May-2017.) $)
    acsinfdimd $p |- ( ph -> S ~~ T ) $=
      ( cdom wbr cen mrissd acsdomd cfv acsmred eqcomd acsinfd sbth syl2anc ) A
      CDOPDCOPCDQPABCDEFGHIJKABDEGJABGHUAZLRZMNSABDCEFGHIJLABCEGJUFKRACFTDFTMUB
      ABCDEFGHIJKUGMNUCSCDUDUE $.
  $}

  ${
    $d s S y z $.  $d s X y z $.  $d s ph y z $.  $d s y I z $.  $d s y z N $.
    acsexdimd.1 $e |- ( ph -> A e. ( ACS ` X ) ) $.
    acsexdimd.2 $e |- N = ( mrCls ` A ) $.
    acsexdimd.3 $e |- I = ( mrInd ` A ) $.
    acsexdimd.4 $e |- ( ph -> A. s e. ~P X A. y e. X
                        A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                        y e. ( N ` ( s u. { z } ) ) ) $.
    acsexdimd.5 $e |- ( ph -> S e. I ) $.
    acsexdimd.6 $e |- ( ph -> T e. I ) $.
    acsexdimd.7 $e |- ( ph -> ( N ` S ) = ( N ` T ) ) $.
    $( In an algebraic closure system whose closure operator has the exchange
       property, if two independent sets have equal closure, they are
       equinumerous.  See ~ mreexfidimd for the finite case and ~ acsinfdimd
       for the infinite case.  This is a special case of Theorem 4.2.2 in
       [FaureFrolicher] p. 87.  (Contributed by David Moews, 1-May-2017.) $)
    acsexdimd $p |- ( ph -> S ~~ T ) $=
      ( wcel cfv adantr cfn cen wbr wa cmre acsmred csn cun cdif wral cpw simpr
      cv wceq mreexfidimd wn cacs acsinfdimd pm2.61dan ) AEUARZEFUBUCAUTUDBCDEF
      GHIJADIUESRUTADIKUFTLMABUMZJUMZCUMUGUHHSRCVBVAUGUHHSVBHSUIUJBIUJJIUKUJUTN
      TAEGRZUTOTAFGRZUTPTAUTULAEHSFHSUNZUTQTUOAUTUPZUDDEFGHIADIUQSRVFKTLMAVCVFO
      TAVDVFPTAVEVFQTAVFULURUS $.
  $}

  ${
    $d I x y $.  $d C x y $.  $d G x y $.  $d L x y $.  $d U x y $.
    $d F x y $.  $d X x y $.
    mreclat.i $e |- I = ( toInc ` C ) $.

    ${
      mrelatglb.g $e |- G = ( glb ` I ) $.
      $( Greatest lower bounds in a Moore space are realized by intersections.
         (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
      mrelatglb $p |- ( ( C e. ( Moore ` X ) /\ U C_ C /\ U =/= (/) ) ->
          ( G ` U ) = |^| U ) $=
        ( vx vy cfv wcel wss w3a wceq 3ad2ant1 wa wbr wb ipole syl3anc cmre wne
        c0 cint cple eqid cbs ipobas cglb a1i cpo ipopos mreintcl intss1 adantl
        simp2 cv simpl1 adantr sselda mpbird wral simplr simpl2 biimpd ralimdva
        simpll1 3impia ssint sylibr simp11 posglbd ) AEUAJZKZBALZBUCUBZMZHIABBU
        DZCDDUEJZVSUFZVNVOADUGJNVPADVMFUHOCDUIJNVQGUJDUKKVQADFULUJVNVOVPUPZABEU
        MZVQHUQZBKZPZVRWCVSQZVRWCLZWDWGVQWCBUNUOWEVNVRAKZWCAKZWFWGRVNVOVPWDURVQ
        WHWDWBUSVQBAWCWAUTADVSVMVRWCFVTSTVAVQIUQZAKZWJWCVSQZHBVBZMZWJVRVSQZWJVR
        LZWNWJWCLZHBVBZWPVQWKWMWRVQWKPZWLWQHBWSWDPZWLWQWTVNWKWIWLWQRVNVOVPWKWDV
        GVQWKWDVCWSBAWCVNVOVPWKVDUTADVSVMWJWCFVTSTVEVFVHHWJBVIVJWNVNWKWHWOWPRVN
        VOVPWKWMVKVQWKWMUPVQWKWHWMWBOADVSVMWJVRFVTSTVAVL $.

      $( The empty intersection in a Moore space is realized by the base set.
         (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
      mrelatglb0 $p |- ( C e. ( Moore ` X ) -> ( G ` (/) ) = X ) $=
        ( vx vy cmre cfv wcel c0 cple eqid ipobas cglb a1i wss cv wbr wceq ral0
        cpo ipopos 0ss mre1cl rspec adantl wral wa mress wb adantr ipole mpbird
        mpd3an3 3adant3 posglbd ) ADIJZKZGHALDBCCMJZVANZACUSEOBCPJUAUTFQCUCKUTA
        CEUDQLARUTAUEQADUFZGSZLKDVDVATZUTVEGLVEGUBUGUHUTHSZAKZVFDVATZVFVDVATGLU
        IUTVGUJVHVFDRZAVFDUKUTVGDAKZVHVIULUTVJVGVCUMACVAUSVFDEVBUNUPUOUQUR $.
    $}

    ${
      mrelatlub.f $e |- F = ( mrCls ` C ) $.
      mrelatlub.l $e |- L = ( lub ` I ) $.
      $( Least upper bounds in a Moore space are realized by the closure of the
         union.  (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
      mrelatlub $p |- ( ( C e. ( Moore ` X ) /\ U C_ C ) ->
          ( L ` U ) = ( F ` U. U ) ) $=
        ( vx cfv wcel wss wa wceq adantr wbr wb ipole syl3anc vy cmre cuni cple
        eqid cbs ipobas club a1i ipopos simpr uniss adantl mreuni sseqtrd mrccl
        cpo syldan cv elssuni mrcssid sylan9ssr simpll sselda mpbird w3a simp1l
        wral simplll simplr biimpd ralimdva 3impia unissb sylibr simp2 3ad2ant1
        mrcsscl poslubdg ) AFUBKZLZBAMZNZJUAABBUCZCKZEDDUDKZWFUEZWAADUFKOWBADVT
        GUGPEDUHKOWCIUIDUQLWCADGUJUIWAWBUKZWAWBWDFMZWEALZWCWDAUCZFWBWDWKMWABAUL
        UMWAWKFOWBAFUNPUOZAWDCFHUPURZWCJUSZBLZNZWNWEWFQZWNWEMZWOWCWNWDWEWNBUTWA
        WBWIWDWEMWLAWDCFHVAURVBWPWAWNALZWJWQWRRWAWBWOVCWCBAWNWHVDWCWJWOWMPADWFV
        TWNWEGWGSTVEWCUAUSZALZWNWTWFQZJBVHZVFZWEWTWFQZWEWTMZXDWAWDWTMZXAXFWAWBX
        AXCVGZXDWNWTMZJBVHZXGWCXAXCXJWCXANZXBXIJBXKWONZXBXIXLWAWSXAXBXIRWAWBXAW
        OVIXKBAWNWAWBXAVJVDWCXAWOVJADWFVTWNWTGWGSTVKVLVMJBWTVNVOWCXAXCVPZAWDCWT
        FHVRTXDWAWJXAXEXFRXHWCXAWJXCWMVQXMADWFVTWEWTGWGSTVEVS $.
    $}

    $( A Moore space is a complete lattice under inclusion.  (Contributed by
       Stefan O'Rear, 31-Jan-2015.) $)
    mreclat $p |- ( C e. ( Moore ` X ) -> I e. CLat ) $=
      ( vx cmre cfv wcel cpo wa wi cuni eqid adantl wceq eqeltrd ad2antrr eleq2
      wss c0 cv cbs club cglb wal ccla ipopos a1i mrelatlub uniss mreuni adantr
      cmrc sseqtrd mrccl syldan fveq2 mrelatglb0 eqtrd mre1cl wne w3a mrelatglb
      cint mreintcl 3expa pm2.61dane jca ex wb ipobas sseq2 anbi12d imbi12d syl
      mpbid alrimiv isclat sylanbrc ) ACFGZHZBIHZEUAZBUBGZSZWCBUCGZGZWDHZWCBUDG
      ZGZWDHZJZKZEUEBUFHWBWAABDUGUHWAWMEWAWCASZWGAHZWJAHZJZKZWMWAWNWQWAWNJZWOWP
      WSWGWCLZAUMGZGZAAWCXABWFCDXAMZWFMZUIWAWNWTCSXBAHWSWTALZCWNWTXESWAWCAUJNWA
      XECOWNACUKULUNAWTXACXCUOUPPWSWPWCTWSWCTOZJZWJCAXGWJTWIGZCXFWJXHOWSWCTWIUQ
      NWAXHCOWNXFAWIBCDWIMZURQUSWACAHWNXFACUTQPWAWNWCTVAZWPWAWNXJVBWJWCVDAAWCWI
      BCDXIVCAWCCVEPVFVGVHVIWAAWDOZWRWMVJABVTDVKXKWNWEWQWLAWDWCVLXKWOWHWPWKAWDW
      GRAWDWJRVMVNVOVPVQWDWFWIBEWDMXDXIVRVS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Distributive lattices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    latmass.b $e |- B = ( Base ` K ) $.
    latmass.m $e |- ./\ = ( meet ` K ) $.
    $( Lattice meet is associative.  (Contributed by Stefan O'Rear,
       30-Jan-2015.) $)
    latmass $p |- ( ( K e. Lat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( ( X ./\ Y ) ./\ Z ) = ( X ./\ ( Y ./\ Z ) ) ) $=
      ( clat wcel codu cfv w3a co wceq eqid odulat odubas odujoin latjass sylan
      ) BIJBKLZIJDAJEAJFAJMDECNFCNDEFCNCNOUBBUBPZQACUBDEFAUBBUCGRUBCBUCHSTUA $.
  $}

  ${
    $d u v w x y z K $.  $d u v w x y z B $.  $d u v w x y z .\/ $.
    $d u v w x y z ./\ $.
    latdisd.b $e |- B = ( Base ` K ) $.
    latdisd.j $e |- .\/ = ( join ` K ) $.
    latdisd.m $e |- ./\ = ( meet ` K ) $.
    $( Lemma for ~ latdisd .  (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    latdisdlem $p |- ( K e. Lat ->
        ( A. u e. B A. v e. B A. w e. B ( u .\/ ( v ./\ w ) ) =
          ( ( u .\/ v ) ./\ ( u .\/ w ) ) ->
        A. x e. B A. y e. B A. z e. B ( x ./\ ( y .\/ z ) ) =
          ( ( x ./\ y ) .\/ ( x ./\ z ) ) ) ) $=
      ( wcel cv co wceq oveq1 oveq2d syl3anc clat wa wi latmcl 3adant3r3 simpr1
      wral w3a simpr3 oveq12d eqeq12d weq oveq2 oveq1d rspc3v imp simpl latjcom
      latabs1 eqtrd adantr simpr2 latjcl latmass syl13anc latabs2 3eqtrrd an32s
      eqtr3d ralrimivvva ex ) IUANZFOZEOZDOZJPZHPZVMVNHPZVMVOHPZJPZQZDGUGEGUGFG
      UGZAOZBOZCOZHPZJPZWCWDJPZWCWEJPZHPZQZCGUGBGUGAGUGVLWBUBWKABCGGGVLWCGNZWDG
      NZWEGNZUHZWBWKVLWOUBZWBUBZWJWHWCHPZWHWEHPZJPZWCWEWHHPZJPZWGWPWBWJWTQZWPWH
      GNZWLWNWBXCUCVLWLWMXDWNGIJWCWDKMUDUEZVLWLWMWNUFZVLWLWMWNUIZWAXCWHVPHPZWHV
      NHPZWHVOHPZJPZQWHWCVOJPZHPZWRXJJPZQFEDWHWCWEGGGVMWHQZVQXHVTXKVMWHVPHRXOVR
      XIVSXJJVMWHVNHRVMWHVOHRUJUKEAULZXHXMXKXNXPVPXLWHHVNWCVOJRZSXPXIWRXJJVNWCW
      HHUMUNUKDCULZXMWJXNWTXRXLWIWHHVOWEWCJUMSXRXJWSWRJVOWEWHHUMSUKUOTUPWPWTXBQ
      WBWPWRWCWSXAJWPWRWCWHHPZWCWPVLXDWLWRXSQVLWOUQZXEXFGHIWHWCKLURTVLWLWMXSWCQ
      WNGHIJWCWDKLMUSUEUTWPVLXDWNWSXAQXTXEXGGHIWHWEKLURTUJVAWQXBWCWEWCHPZWEWDHP
      ZJPZJPZWGWQXAYCWCJWPWBXAYCQZWPWNWLWMWBYEUCXGXFVLWLWMWNVBZWAYEWEVPHPZWEVNH
      PZWEVOHPZJPZQWEXLHPZYAYIJPZQFEDWEWCWDGGGFCULZVQYGVTYJVMWEVPHRYMVRYHVSYIJV
      MWEVNHRVMWEVOHRUJUKXPYGYKYJYLXPVPXLWEHXQSXPYHYAYIJVNWCWEHUMUNUKDBULZYKXAY
      LYCYNXLWHWEHVOWDWCJUMSYNYIYBYAJVOWDWEHUMSUKUOTUPSWPYDWGQWBWPWCYAJPZYBJPZY
      DWGWPVLWLYAGNZYBGNZYPYDQXTXFWPVLWNWLYQXTXGXFGHIWEWCKLVCTWPVLWNWMYRXTXGYFG
      HIWEWDKLVCTGIJWCYAYBKMVDVEWPYOWCYBWFJWPYOWCWCWEHPZJPZWCWPYAYSWCJWPVLWNWLY
      AYSQXTXGXFGHIWEWCKLURTSWPVLWLWNYTWCQXTXFXGGHIJWCWEKLMVFTUTWPVLWNWMYBWFQXT
      XGYFGHIWEWDKLURTUJVIVAUTVGVHVJVK $.

    $( In a lattice, joins distribute over meets if and only if meets
       distribute over joins; the distributive property is self-dual.
       (Contributed by Stefan O'Rear, 29-Jan-2015.) $)
    latdisd $p |- ( K e. Lat ->
        ( A. x e. B A. y e. B A. z e. B ( x .\/ ( y ./\ z ) ) =
          ( ( x .\/ y ) ./\ ( x .\/ z ) ) <->
        A. x e. B A. y e. B A. z e. B ( x ./\ ( y .\/ z ) ) =
          ( ( x ./\ y ) .\/ ( x ./\ z ) ) ) ) $=
      ( vu vv vw cv co wceq wral weq oveq1 eqeq12d clat wcel latdisdlem codu wi
      cfv eqid odulat odubas odujoin odumeet impbid oveq12d oveq2d oveq2 oveq1d
      syl cbvral3v syl6bb ) FUAUBZANZBNZCNZGOEOVAVBEOVAVCEOGOPCDQBDQADQZKNZLNZM
      NZEOZGOZVEVFGOZVEVGGOZEOZPZMDQLDQKDQZVAVBVCEOZGOZVAVBGOZVAVCGOZEOZPZCDQBD
      QADQUTVDVNKLMCBADEFGHIJUCUTFUDUFZUAUBVNVDUEWAFWAUGZUHABCMLKDGWAEDWAFWBHUI
      WAGFWBJUJWAEFWBIUKUCUQULVMVTVAVHGOZVAVFGOZVAVGGOZEOZPVAVBVGEOZGOZVQWEEOZP
      KLMABCDDDKARZVIWCVLWFVEVAVHGSWJVJWDVKWEEVEVAVFGSVEVAVGGSUMTLBRZWCWHWFWIWK
      VHWGVAGVFVBVGESUNWKWDVQWEEVFVBVAGUOUPTMCRZWHVPWIVSWLWGVOVAGVGVCVBEUOUNWLW
      EVRVQEVGVCVAGUOUNTURUS $.
  $}

  $c DLat $.

  $( The class of distributive lattices. $)
  cdlat $a class DLat $.

  ${
    $d k b j m x y z $.
    $( A _distributive lattice_ is a lattice in which meets distribute over
       joins, or equivalently ( ~ latdisd ) joins distribute over meets.
       (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    df-dlat $a |- DLat = { k e. Lat | [. ( Base ` k ) / b ].
        [. ( join ` k ) / j ]. [. ( meet ` k ) / m ]. A. x e. b A. y e. b
          A. z e. b ( x m ( y j z ) ) = ( ( x m y ) j ( x m z ) ) } $.
  $}

  ${
    $d k b j m x y z K $.  $d k b j m x y z B $.  $d k b j m x y z .\/ $.
    $d k b j m x y z ./\ $.
    isdlat.b $e |- B = ( Base ` K ) $.
    isdlat.j $e |- .\/ = ( join ` K ) $.
    isdlat.m $e |- ./\ = ( meet ` K ) $.
    $( Property of being a distributive lattice.  (Contributed by Stefan
       O'Rear, 30-Jan-2015.) $)
    isdlat $p |- ( K e. DLat <-> ( K e. Lat /\ A. x e. B A. y e. B A. z e. B
        ( x ./\ ( y .\/ z ) ) = ( ( x ./\ y ) .\/ ( x ./\ z ) ) ) ) $=
      ( vj vm vb cv co wceq wral cmee cfv wsbc vk cjn cbs clat cdlat wb syl6eqr
      fveq2 dfsbcq syl sbcbidv bitrd cvv fvex eqeltri wa raleq raleqbi1dv simpr
      eqidd simpl oveqd oveq123d eqeq12d ralbidv 2ralbidv sylan9bb 3impb sbc3ie
      syl6bb df-dlat elrab2 ) ANZBNZCNZKNZOZLNZOZVMVNVROZVMVOVROZVPOZPZCMNZQZBW
      DQZAWDQZLUANZRSZTZKWHUBSZTZMWHUCSZTZVMVNVOEOZGOZVMVNGOZVMVOGOZEOZPZCDQZBD
      QADQZUAFUDUEWHFPZWNWGLGTZKETZMDTZXBXCWNWLMDTZXFXCWMDPWNXGUFXCWMFUCSZDWHFU
      CUHHUGWLMWMDUIUJXCWLXEMDXCWLWJKETZXEXCWKEPWLXIUFXCWKFUBSZEWHFUBUHIUGWJKWK
      EUIUJXCWJXDKEXCWIGPWJXDUFXCWIFRSZGWHFRUHJUGWGLWIGUIUJUKULUKULWGXBMKLDEGDX
      HUMHFUCUNUOEXJUMIFUBUNUOGXKUMJFRUNUOWDDPZVPEPZVRGPZWGXBUFXLWGWCCDQZBDQZAD
      QXMXNUPZXBWFXPAWDDWEXOBWDDWCCWDDUQURURXQXOXAABDDXQWCWTCDXQVSWPWBWSXQVMVMV
      QWOVRGXMXNUSZXQVMUTXQVPEVNVOXMXNVAZVBVCXQVTWQWAWRVPEXSXQVRGVMVNXRVBXQVRGV
      MVOXRVBVCVDVEVFVGVHVIVJABCKUALMVKVL $.

    $d X x y z $.  $d Y x y z $.  $d Z x y z $.

    $( In a distributive lattice, meets distribute over joins.  (Contributed by
       Stefan O'Rear, 30-Jan-2015.) $)
    dlatmjdi $p |- ( ( K e. DLat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( X ./\ ( Y .\/ Z ) ) = ( ( X ./\ Y ) .\/ ( X ./\ Z ) ) ) $=
      ( vx vy vz wcel cv co wceq wral oveq1 eqeq12d clat isdlat simprbi oveq12d
      cdlat w3a oveq2d oveq2 oveq1d rspc3v mpan9 ) CUENZKOZLOZMOZBPZDPZUMUNDPZU
      MUODPZBPZQZMARLARKARZEANFANGANUFEFGBPZDPZEFDPZEGDPZBPZQZULCUANVBKLMABCDHI
      JUBUCVAVHEUPDPZEUNDPZEUODPZBPZQEFUOBPZDPZVEVKBPZQKLMEFGAAAUMEQZUQVIUTVLUM
      EUPDSVPURVJUSVKBUMEUNDSUMEUODSUDTUNFQZVIVNVLVOVQUPVMEDUNFUOBSUGVQVJVEVKBU
      NFEDUHUITUOGQZVNVDVOVGVRVMVCEDUOGFBUHUGVRVKVFVEBUOGEDUHUGTUJUK $.
  $}

  ${
    $d K x y z $.
    $( A distributive lattice is a lattice.  (Contributed by Stefan O'Rear,
       30-Jan-2015.) $)
    dlatl $p |- ( K e. DLat -> K e. Lat ) $=
      ( vx vy vz cdlat wcel clat cjn cfv cmee wceq cbs wral eqid isdlat simplbi
      cv co ) AEFAGFBQZCQZDQZAHIZRAJIZRSTUCRSUAUCRUBRKDALIZMCUDMBUDMBCDUDUBAUCU
      DNUBNUCNOP $.
  $}

  ${
    $d K x y z $.  $d D x y z $.  $d V x y z $.
    odudlat.d $e |- D = ( ODual ` K ) $.
    $( The dual of a distributive lattice is a distributive lattice and
       conversely.  (Contributed by Stefan O'Rear, 30-Jan-2015.) $)
    odudlatb $p |- ( K e. V -> ( K e. DLat <-> D e. DLat ) ) $=
      ( vx vy vz wcel clat cv cjn cfv co cmee wceq wral wa cdlat eqid isdlat
      cbs latdisd bicomd pm5.32i odulatb anbi1d syl5bb odujoin odumeet 3bitr4g
      odubas ) BCHZBIHZEJZFJZGJZBKLZMBNLZMUNUOURMUNUPURMUQMOGBUALZPFUSPEUSPZQZA
      IHZUNUOUPURMUQMUNUOUQMUNUPUQMURMOGUSPFUSPEUSPZQZBRHARHVAUMVCQULVDUMUTVCUM
      VCUTEFGUSUQBURUSSZUQSZURSZUBUCUDULUMVBVCABCDUEUFUGEFGUSUQBURVEVFVGTEFGUSU
      RAUQUSABDVEUKAURBDVGUHAUQBDVFUITUJ $.
  $}

  ${
    dlatjmdi.b $e |- B = ( Base ` K ) $.
    dlatjmdi.j $e |- .\/ = ( join ` K ) $.
    dlatjmdi.m $e |- ./\ = ( meet ` K ) $.
    $( In a distributive lattice, joins distribute over meets.  (Contributed by
       Stefan O'Rear, 30-Jan-2015.) $)
    dlatjmdi $p |- ( ( K e. DLat /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( X .\/ ( Y ./\ Z ) ) = ( ( X .\/ Y ) ./\ ( X .\/ Z ) ) ) $=
      ( cdlat wcel codu cfv w3a co wceq eqid odudlatb ibi odujoin odumeet sylan
      odubas dlatmjdi ) CKLZCMNZKLZEALFALGALOEFGDPBPEFBPEGBPDPQUFUHUGCKUGRZSTAD
      UGBEFGAUGCUIHUDUGDCUIJUAUGBCUIIUBUEUC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Posets and lattices as relations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c PosetRel $.
  $c TosetRel $.
$( Obsolete as of 28-Aug-2018. (Delete this and uses after a year.) -NM
  @c supw @.
  @c infw @.
  @c LatRel @.
$)

  $( Extend class notation with the class of all posets. $)
  cps $a class PosetRel $.

  $( Extend class notation with the class of all totally ordered sets. $)
  ctsr $a class TosetRel $.

$(
  @( Extend class notation with the supremum of an ordered set. @)
  cspw @a class supw @.

  @( Extend class notation with the infimum of an ordered set. @)
  cinf @a class infw @.

  @( Extend class notation with the class of all lattices. @)
  cla @a class LatRel @.
$)

  $( Define the class of all posets (partially ordered sets) with weak ordering
     (e.g.  "less than or equal to" instead of "less than").  A poset is a
     relation which is transitive, reflexive, and antisymmetric.  (Contributed
     by NM, 11-May-2008.) $)
  df-ps $a |- PosetRel = { r | ( Rel r /\ ( r o. r ) C_ r /\
              ( r i^i `' r ) = ( _I |` U. U. r ) ) } $.

  $( Define the class of all totally ordered sets.  (Contributed by FL,
     1-Nov-2009.) $)
  df-tsr $a |- TosetRel = { r e. PosetRel |
                ( dom r X. dom r ) C_ ( r u. `' r ) } $.

$(
  @{
    @d r x y z w @.
    @( Define suprema under weak orderings.  Unlike ~ df-sup for strong
       orderings, ` supw ` is evaluates to a member of the field of ` R ` iff
       the supremum exists.  Read ` R supw A ` as the ` R ` -supremum of set
       ` A ` .  (Contributed by NM, 13-May-2008.) @)
    df-spw @a |- supw = ( r e. PosetRel , x e. _V |-> ( iota_ y e. U. U. r
     ( A. z e. x z r y /\ A. z e. U. U. r ( A. w e. x w r z -> y r z ) ) ) ) @.

    @( Define the class of all infima of a weak ordering relation.
       (Contributed by FL, 6-Sep-2009.) @)
    df-nfw @a |- infw = ( r e. _V , x e. _V |-> ( `' r supw x ) ) @.

    @( Define the class of all lattices, which are posets in which every two
       elements have upper and lower bounds.  (Contributed by NM,
       12-Jun-2008.) @)
    df-lar @a |- LatRel = { r e. PosetRel | A. x e. dom r A. y e. dom r
        ( ( r supw { x , y } ) e. dom r /\ ( r infw { x , y } ) e. dom r ) } @.
  @}
$)

  ${
    $d r x y R $.
    $( The predicate "is a poset" i.e. a transitive, reflexive, antisymmetric
       relation.  (Contributed by NM, 11-May-2008.) $)
    isps $p |- ( R e. A -> ( R e. PosetRel <-> ( Rel R /\ ( R o. R ) C_ R /\
                ( R i^i `' R ) = ( _I |` U. U. R ) ) ) ) $=
      ( vr cv wrel ccom wss ccnv cin cid cuni cres wceq releq coeq1 coeq2 eqtrd
      w3a cps id sseq12d cnveq ineq12d unieqd reseq2d eqeq12d 3anbi123d elab2g
      unieq df-ps ) CDZEZUKUKFZUKGZUKUKHZIZJUKKZKZLZMZRBEZBBFZBGZBBHZIZJBKZKZLZ
      MZRCBSAUKBMZULVAUNVCUTVIUKBNVJUMVBUKBVJUMBUKFVBUKBUKOUKBBPQVJTZUAVJUPVEUS
      VHVJUKBUOVDVKUKBUBUCVJURVGJVJUQVFUKBUIUDUEUFUGCUJUH $.
  $}

  $( A poset is a relation.  (Contributed by NM, 12-May-2008.) $)
  psrel $p |- ( A e. PosetRel -> Rel A ) $=
    ( cps wcel wrel ccom wss ccnv cin cid cuni cres wceq w3a isps ibi simp1d )
    ABCZADZAAEAFZAAGHIAJJKLZQRSTMBANOP $.

  $( A poset is antisymmetric and reflexive.  (Contributed by FL,
     3-Aug-2009.) $)
  psref2 $p |- ( R e. PosetRel -> ( R i^i `' R ) = ( _I |` U. U. R ) ) $=
    ( cps wcel wrel ccom wss ccnv cin cid cuni cres wceq w3a isps ibi simp3d )
    ABCZADZAAEAFZAAGHIAJJKLZQRSTMBANOP $.

  $( A poset is transitive.  (Contributed by FL, 3-Aug-2009.) $)
  pstr2 $p |- ( R e. PosetRel -> ( R o. R ) C_ R ) $=
    ( cps wcel wrel ccom wss ccnv cin cid cuni cres wceq w3a isps ibi simp2d )
    ABCZADZAAEAFZAAGHIAJJKLZQRSTMBANOP $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    $( Lemma for ~ psref and others.  (Contributed by NM, 12-May-2008.)
       (Revised by Mario Carneiro, 30-Apr-2015.) $)
    pslem $p |- ( R e. PosetRel -> ( ( ( A R B /\ B R C ) -> A R C ) /\
      ( A e. U. U. R -> A R A ) /\ ( ( A R B /\ B R A ) -> A = B ) ) ) $=
      ( vx vy vz wcel wbr wa wi cuni wceq cvv cv wal sylan adantr wb breq12 cps
      wrel psrel brrelex12 brrelex2 anim12dan ccom wss pstr2 cotr sylib 3adant3
      simpr w3a 3adant1 anbi12d 3adant2 imbi12d spc3gv 3expa syl3c ccnv cin cid
      ex cres wral psref2 asymref2 simplbi anidms rspccv adantrr simprbi ancoms
      3syl syl eqeq12 spc2gv 3jca ) DUAHZABDIZBCDIZJZACDIZKZADLLZHAADIZKZWBBADI
      ZJZABMZKZWAWDWEWAWDJANHZBNHZJZCNHZJEOZFOZDIZWSGOZDIZJZWRXADIZKZGPFPEPZWDW
      EWAWBWPWCWQWADUBZWBWPDUCZABDUDQZWAXGWCWQXHBCDUEQUFWAXFWDWADDUGDUHXFDUIEFG
      DUJUKRWAWDUMWNWOWQXFWFKXEWFEFGABCNNNWRAMZWSBMZXACMZUNZXCWDXDWEXMWTWBXBWCX
      JXKWTWBSXLWRAWSBDTZULXKXLXBWCSXJWSBXACDTUOUPXJXLXDWESXKWRAXACDTUQURUSUTVA
      VEWADDVBVCVDWGVFMZWRWRDIZEWGVGZWIDVHZXOXQWTWSWRDIZJZWRWSMZKZFPEPZEFDVIZVJ
      XPWHEAWGXJXPWHSWRAWRADTVKVLVPWAWKWLWAWKJWPYCWKWLWAWBWPWJXIVMWAYCWKWAXOYCX
      RXOXQYCYDVNVQRWAWKUMYBWMEFABNNXJXKJZXTWKYAWLYEWTWBXSWJXNXKXJXSWJSWSBWRADT
      VOUPWRAWSBVRURVSVAVEVT $.

    $( The domain and range of a poset equal its field.  (Contributed by NM,
       13-May-2008.) $)
    psdmrn $p |- ( R e. PosetRel -> ( dom R = U. U. R /\ ran R = U. U. R ) ) $=
      ( vx cps wcel cdm cuni wceq crn wss cun ssun1 dmrnssfld sstri a1i cv syl6
      wbr wi ssrdv eqssd wa pslem simp2d vex breldm ssun2 brelrn jca ) ACDZAEZA
      FFZGAHZUKGUIUJUKUJUKIUIUJUJULJZUKUJULKALZMNUIBUKUJUIBOZUKDZUOUOAQZUOUJDUI
      UQUQUAZUQRUPUQRURUOUOGRUOUOUOAUBUCZUOUOABUDZUTUEPSTUIULUKULUKIUIULUMUKULU
      JUFUNMNUIBUKULUIUPUQUOULDUSUOUOAUTUTUGPSTUH $.
  $}

  ${
    psref.1 $e |- X = dom R $.
    $( A poset is reflexive.  (Contributed by NM, 13-May-2008.) $)
    psref $p |- ( ( R e. PosetRel /\ A e. X ) -> A R A ) $=
      ( cps wcel wbr cuni cdm wceq crn psdmrn simpld syl5eq eleq2d wa wi simp2d
      pslem sylbid imp ) BEFZACFZAABGZUBUCABHHZFZUDUBCUEAUBCBIZUEDUBUGUEJBKUEJB
      LMNOUBUDUDPZUDQUFUDQUHAAJQAAABSRTUA $.

    $( The range of a poset equals it domain.  (Contributed by NM,
       7-Jul-2008.) $)
    psrn $p |- ( R e. PosetRel -> X = ran R ) $=
      ( cps wcel cdm crn cuni wceq wa psdmrn eqtr3 syl syl5eq ) ADEZBAFZAGZCOPA
      HHZIQRIJPQIAKPQRLMN $.
  $}

  $( A poset is antisymmetric.  (Contributed by NM, 12-May-2008.) $)
  psasym $p |- ( ( R e. PosetRel /\ A R B /\ B R A ) -> A = B ) $=
    ( cps wcel wbr wceq wa wi cuni pslem simp3d 3impib ) CDEZABCFZBACFZABGZNOPH
    ZAACFZIACJJESIRQIABACKLM $.

  $( A poset is transitive.  (Contributed by NM, 12-May-2008.)  (Revised by
     Mario Carneiro, 30-Apr-2015.) $)
  pstr $p |- ( ( R e. PosetRel /\ A R B /\ B R C ) -> A R C ) $=
    ( cps wcel wbr wa wi cuni wceq pslem simp1d 3impib ) DEFZABDGZBCDGZACDGZOPQ
    HRIADJJFAADGIPBADGHABKIABCDLMN $.

  $( The converse of a poset is a poset.  In the general case
     ` ( ``' R e. PosetRel -> R e. PosetRel ) ` is not true.  See ~ cnvpsb for
     a special case where the property holds.  (Contributed by FL,
     5-Jan-2009.)  (Proof shortened by Mario Carneiro, 3-Sep-2015.) $)
  cnvps $p |- ( R e. PosetRel -> `' R e. PosetRel ) $=
    ( cps wcel ccnv wrel ccom wss cin cid cuni cres wceq relcnv a1i cnvco pstr2
    cnvss syl syl5eqssr cvv psrel dfrel2 ineq2d syl6eq psref2 relcnvfld reseq2d
    sylib incom 3eqtrd w3a wb cnvexg isps mpbir3and ) ABCZADZBCZUQEZUQUQFZUQGZU
    QUQDZHZIUQJJZKZLZUSUPAMNUPUTAAFZDZUQAAOUPVGAGVHUQGAPVGAQRSUPVCAUQHZIAJJZKVE
    UPVCUQAHVIUPVBAUQUPAEZVBALAUAZAUBUHUCUQAUIUDAUEUPVJVDIUPVKVJVDLVLAUFRUGUJUP
    UQTCURUSVAVFUKULABUMTUQUNRUO $.

  $( The converse of a poset is a poset.  (Contributed by FL, 5-Jan-2009.) $)
  cnvpsb $p |- ( Rel R -> ( R e. PosetRel <-> `' R e. PosetRel ) ) $=
    ( wrel cps wcel ccnv cnvps wceq wi dfrel2 eleq1 biimpd sylbi syl5 impbid2 )
    ABZACDZAEZCDZAFRQEZCDZOPQFOSAGZTPHAIUATPSACJKLMN $.

  ${
    $d A x y $.  $d R x y $.  $d R x z $.
    $( Any subset of a partially ordered set is partially ordered.
       (Contributed by FL, 24-Jan-2010.) $)
    psss $p |- ( R e. PosetRel -> ( R i^i ( A X. A ) ) e. PosetRel ) $=
      ( vx vy cps wcel cin wrel ccom wss cuni wceq mpsyl syl cv wbr wral wa wal
      uniin cxp ccnv cid inss1 psrel relss pstr2 trinxp wi unissi sstri unixpid
      cres elin eleq2i simprr cdm crn psdmrn simpld eleq2d biimpar psref syldan
      eqid adantrr brinxp2 syl3anbrc expr syl5bi expimpd ralrimiv ssralv psasym
      ssbri 3expib syl2ani alrimivv asymref2 sylanbrc cvv w3a wb isps mpbir3and
      inex1g ) BEFZBAAUAZGZEFZWIHZWIWIIWIJZWIWIUBGUCWIKZKZUMLZWIBJWGBHWKBWHUDZB
      UEWIBUFMWGBBIBJWLBUGABUHNWGCOZWQWIPZCWNQZWQDOZWIPZWTWQWIPZRWQWTLZUIZDSCSW
      OWNBKZKZWHKZKZGZJWGWRCXIQWSWNXEXGGZKXIWMXJBWHTUJXEXGTUKWGWRCXIWQXIFWQXFFZ
      WQXHFZRWGWRWQXFXHUNWGXKXLWRXLWQAFZWGXKRWRXHAWQAULUOWGXKXMWRWGXKXMRRXMXMWQ
      WQBPZWRWGXKXMUPZXOWGXKXNXMWGXKWQBUQZFZXNWGXQXKWGXPXFWQWGXPXFLBURXFLBUSUTV
      AVBWQBXPXPVEVCVDVFWQWQAABVGVHVIVJVKVJVLWRCWNXIVMMWGXDCDXAWGWQWTBPZWTWQBPZ
      XCXBWIBWQWTWPVOWIBWTWQWPVOWGXRXSXCWQWTBVNVPVQVRCDWIVSVTWGWIWAFWJWKWLWOWBW
      CBWHEWFWAWIWDNWE $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d X x $.
    psssdm.1 $e |- X = dom R $.
    $( Field of a subposet.  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    psssdm2 $p |- ( R e. PosetRel ->
      dom ( R i^i ( A X. A ) ) = ( X i^i A ) ) $=
      ( vx cps wcel cxp cin cdm wss eqcomi dmxpid ineq12i sseqtri a1i cv wa wbr
      dmin inss2 simpr sseldi inss1 sseli psref sylan2 brinxp2 syl3anbrc breldm
      vex syl ex ssrdv eqssd ) BFGZBAAHZIZJZCAIZUSUTKUPUSBJZUQJZIUTBUQTVACVBACV
      ADLAMNOPUPEUTUSUPEQZUTGZVCUSGZUPVDRZVCVCURSZVEVFVCAGZVHVCVCBSZVGVFUTAVCCA
      UAUPVDUBUCZVJVDUPVCCGVIUTCVCCAUDUEVCBCDUFUGVCVCAABUHUIVCVCUREUKZVKUJULUMU
      NUO $.

    $( Field of a subposet.  (Contributed by FL, 19-Sep-2011.)  (Revised by
       Mario Carneiro, 9-Sep-2015.) $)
    psssdm $p |- ( ( R e. PosetRel /\ A C_ X )
      -> dom ( R i^i ( A X. A ) ) = A ) $=
      ( cps wcel wss cxp cin cdm psssdm2 wceq dfss1 biimpi sylan9eq ) BEFACGZBA
      AHIJCAIZAABCDKPQALACMNO $.
  $}

  ${
    $d x y A $.  $d y B $.  $d r x y R $.  $d r x y X $.
    istsr.1 $e |- X = dom R $.
    $( The predicate is a toset.  (Contributed by FL, 1-Nov-2009.)  (Revised by
       Mario Carneiro, 22-Nov-2013.) $)
    istsr $p |- ( R e. TosetRel <->
        ( R e. PosetRel /\ ( X X. X ) C_ ( R u. `' R ) ) ) $=
      ( vr cv cdm cxp ccnv cun wss ctsr wceq dmeq syl6eqr xpeq12d cnveq uneq12d
      cps id sseq12d df-tsr elrab2 ) DEZFZUDGZUCUCHZIZJBBGZAAHZIZJDARKUCALZUEUH
      UGUJUKUDBUDBUKUDAFBUCAMCNZULOUKUCAUFUIUKSUCAPQTDUAUB $.

    $( The predicate is a toset.  (Contributed by FL, 1-Nov-2009.)  (Revised by
       Mario Carneiro, 22-Nov-2013.) $)
    istsr2 $p |- ( R e. TosetRel <->
        ( R e. PosetRel /\ A. x e. X A. y e. X ( x R y \/ y R x ) ) ) $=
      ( ctsr wcel cps cxp ccnv cun wss wa cv wbr wo wral istsr qfto anbi2i
      bitri ) CFGCHGZDDICCJKLZMUBANZBNZCOUEUDCOPBDQADQZMCDERUCUFUBABDDCSTUA $.

    $( A toset is a linear order.  (Contributed by Mario Carneiro,
       9-Sep-2015.) $)
    tsrlin $p |- ( ( R e. TosetRel /\ A e. X /\ B e. X ) ->
      ( A R B \/ B R A ) ) $=
      ( vx vy ctsr wcel wbr wo cv wral wa cps istsr2 wceq breq1 breq2 orbi12d
      simprbi rspc2v syl5com 3impib ) CHIZADIZBDIZABCJZBACJZKZUEFLZGLZCJZULUKCJ
      ZKZGDMFDMZUFUGNUJUECOIUPFGCDEPUAUOUJAULCJZULACJZKFGABDDUKAQUMUQUNURUKAULC
      RUKAULCSTULBQUQUHURUIULBACSULBACRTUBUCUD $.

    $( Two ways of saying a number is less than or equal to the maximum of two
       others.  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    tsrlemax $p |- ( ( R e. TosetRel /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
        ( A R if ( B R C , C , B ) <-> ( A R B \/ A R C ) ) ) $=
      ( wbr wo wb wcel wa wceq breq2 bibi1d wi pstr 3expib syl adantr expdimp
      cif ctsr w3a olc cps cdm cxp ccnv cun wss eqid istsr simplbi impancom idd
      jaod impbid2 wn orc tsrlin 3adant3r1 orcanai syldan ifbothda ) BCDGZACDGZ
      ABDGZVFHZIVGVHIAVECBUAZDGZVHIDUBJZAEJZBEJZCEJZUCZKZCBCVILVFVJVHCVIADMNBVI
      LVGVJVHBVIADMNVPVEKZVFVHVFVGUDVQVGVFVFVPVGVEVFVPVGVEVFVKVGVEKVFOZVOVKDUEJ
      ZVRVKVSDUFZVTUGDDUHUIUJDVTVTUKULUMZVSVGVEVFABCDPQRSTUNVQVFUOUPUQVPVEURZKZ
      VGVHVGVFUSWCVGVGVFWCVGUOVPWBCBDGZVFVGOVPVEWDVKVMVNVEWDHVLBCDEFUTVAVBVPVFW
      DVGVPVFWDVGVKVFWDKVGOZVOVKVSWEWAVSVFWDVGACBDPQRSTUNVCUPUQVD $.
  $}

  $( A toset is a poset.  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
  tsrps $p |- ( R e. TosetRel -> R e. PosetRel ) $=
    ( ctsr wcel cps cdm cxp ccnv cun wss eqid istsr simplbi ) ABCADCAEZMFAAGHIA
    MMJKL $.

  $( The converse of a toset is a toset.  (Contributed by Mario Carneiro,
     3-Sep-2015.) $)
  cnvtsr $p |- ( R e. TosetRel -> `' R e. TosetRel ) $=
    ( ctsr wcel ccnv cps crn cxp cun wss tsrps cnvps syl cdm eqid istsr simprbi
    wceq psrn xpeq12d wrel psrel dfrel2 sylib uneq2d syl6req 3sstr3d sylanbrc
    uncom df-rn ) ABCZADZECZAFZUMGZUKUKDZHZIUKBCUJAECZULAJZAKLUJAMZUSGZAUKHZUNU
    PUJUQUTVAIAUSUSNZOPUJUSUMUSUMUJUQUSUMQURAUSVBRLZVCSUJUPUKAHVAUJUOAUKUJATZUO
    AQUJUQVDURAUALAUBUCUDUKAUHUEUFUKUMAUIOUG $.

  ${
    $d A x y $.  $d R x y $.
    $( Any subset of a totally ordered set is totally ordered.  (Contributed by
       FL, 24-Jan-2010.)  (Proof shortened by Mario Carneiro, 21-Nov-2013.) $)
    tsrss $p |- ( R e. TosetRel -> ( R i^i ( A X. A ) ) e. TosetRel ) $=
      ( vx vy cps wcel cv wbr wo cdm wral wa ctsr wss wi dmss ssralv mp2b sseli
      wb cxp cin psss inss1 ralimi syl inss2 ax-mp dmxpid sseqtri brinxp ancoms
      orbi12d syl2an ralbidva ralbiia sylib anim12i eqid istsr2 3imtr4i ) BEFZC
      GZDGZBHZVDVCBHZIZDBJZKZCVHKZLBAAUAZUBZEFZVCVDVLHZVDVCVLHZIZDVLJZKZCVQKZLB
      MFVLMFVBVMVJVSABUCVJVGDVQKZCVQKZVSVJVICVQKZWAVLBNZVQVHNZVJWBOBVKUDZVLBPZV
      ICVQVHQRVIVTCVQWCWDVIVTOWEWFVGDVQVHQRUEUFVTVRCVQVCVQFZVGVPDVQWGVCAFZVDAFZ
      VGVPTVDVQFVQAVCVQVKJZAVLVKNVQWJNBVKUGVLVKPUHAUIUJZSVQAVDWKSWHWILVEVNVFVOV
      CVDAABUKWIWHVFVOTVDVCAABUKULUMUNUOUPUQURCDBVHVHUSUTCDVLVQVQUSUTVA $.
  $}

$(
  @{
    @d r w x y z R @.  @d r w x y z X @.  @d r w x y z A @.
    spwval2.1 @e |- X = U. U. R @.
    @( Value of supremum under a weak ordering.  Read ` R supw A ` as "the
       ` R ` -supremum of ` A ` ." ` U. U. R ` is the field of a relation ` R `
       by ~ relfld .  Unlike ~ df-sup for strong orderings, the supremum exists
       iff ` R supw A ` belongs to the field.  (Contributed by NM,
       13-May-2008.)  (Revised by Mario Carneiro, 20-Nov-2013.) @)
    spwval2 @p |- ( ( R e. PosetRel /\ A e. V ) -> ( R supw A ) =
                    ( iota_ x e. X ( A. y e. A y R x /\
                      A. y e. X ( A. z e. A z R y -> x R y ) ) ) ) @=
      ( vr vw wcel cv wbr wral wi wa crio wceq cuni breq cps cspw co elex unieq
      unieqd syl6eqr ralbidv imbi12d raleqbidv anbi12d riotaeqbidv raleq imbi1d
      cvv riotabidv df-spw riotaex ovmpt2 sylan2 ) DFKEUAKDUOKEDUBUCBLZALZEMZBD
      NZCLZVAEMZCDNZVBVAEMZOZBGNZPZAGQZRDFUDIJEDUAUOVAVBILZMZBJLZNZVEVAVMMZCVON
      ZVBVAVMMZOZBVMSZSZNZPZAWBQVLUBVCBVONZVFCVONZVHOZBGNZPZAGQVMERZWDWIAWBGWJW
      BESZSGWJWAWKVMEUEUFHUGZWJVPWEWCWHWJVNVCBVOVAVBVMETUHWJVTWGBWBGWLWJVRWFVSV
      HWJVQVFCVOVEVAVMETUHVBVAVMETUIUJUKULVODRZWIVKAGWMWEVDWHVJVCBVODUMWMWGVIBG
      WMWFVGVHVFCVODUMUNUHUKUPJABCIUQVKAGURUSUT @.
  @}

  @{
    @d r w x y z R @.  @d r w x y X @.  @d w x y z A @.
    spwval.1 @e |- X = dom R @.
    @( Value of supremum under a weak ordering.  Read ` R supw A ` as "the
       ` R ` -supremum of ` A ` ." ` U. U. R ` is the field of a relation ` R `
       by ~ relfld .  Unlike ~ df-sup for strong orderings, the supremum exists
       iff ` R supw A ` belongs to the field.  (Contributed by NM,
       13-May-2008.)  (Revised by Mario Carneiro, 20-Nov-2013.) @)
    spwval @p |- ( ( R e. PosetRel /\ A e. V ) -> ( R supw A ) =
                    ( iota_ x e. X ( A. y e. A y R x /\
                      A. y e. X ( A. z e. A z R y -> x R y ) ) ) ) @=
      ( cps wcel wa cspw co cv wbr wral wi cuni crio wceq spwval2 psdmrn simpld
      eqid cdm crn syl5eq raleqdv anbi2d riotaeqbidv adantr eqtr4d ) EIJZDFJZKE
      DLMBNZANZEOBDPZCNUOEOCDPUPUOEOQZBERRZPZKZAUSSZUQURBGPZKZAGSZABCDEFUSUSUDU
      AUMVEVBTUNUMVDVAAGUSUMGEUEZUSHUMVFUSTEUFUSTEUBUCUGZUMVCUTUQUMURBGUSVGUHUI
      UJUKUL @.
  @}

  @{
    @d w x y z A @.  @d y z B @.  @d y z C @.  @d w x y z R @.  @d w x y X @.
    @d y U @.  @d y W @.
    spwmo.1 @e |- ( ph
         <-> ( A. y e. A y R x /\ A. y e. X ( A. z e. A z R y -> x R y ) ) ) @.
    @( A poset has at most one supremum.  (Contributed by NM, 13-May-2008.)
       (Revised by NM, 16-Jun-2017.) @)
    spwmo @p |- ( R e. PosetRel -> E* x e. X ph ) @=
      ( vw wcel cv wa wmo wbr wral wi weq breq1 breq2 ralbidv cps cbvralv rspcv
      wrmo wal imp3a im2anan9r psasym 3expib syl9 com13 exp43 com4r sylbi imp43
      imbi12d com3r imp com12 alrimivv anbi2i mobii eleq1 syl6bb imbi2d anbi12d
      an4s mo4 bitri sylibr df-rmo ) FUAJZBKZGJZALZBMZABGUDVLVNCKZVMFNZCEOZDKZV
      QFNZDEOZVMVQFNZPZCGOZLZLZIKZGJZVTWHFNZDEOZWBWHVQFNZPZCGOZLZLZLZBIQZPZIUEB
      UEZVPVLWSBIWQVLWRVNWIWFWOVLWRPZVNWILZWFWOLZXAXCVLXBWRVSWEWKWNVLXBWRPPZVSV
      TVMFNZDEOZWEWKWNXDPPPVRXECDEVQVTVMFRUBWEWKWNXFXDWEWKWNXFXDXBVLWEWKLZWNXFL
      ZLZWRXBXIVMWHFNZWHVMFNZLVLWRWIXGXJVNXHXKWIWEWKXJWDWKXJPCWHGCIQZWBWKWCXJXL
      WAWJDEVQWHVTFSTVQWHVMFSUPUCUFVNWNXFXKWMXFXKPCVMGCBQZWBXFWLXKXMWAXEDEVQVMV
      TFSTVQVMWHFSUPUCUFUGVLXJXKWRVMWHFUHUIUJUKULUMUNUOUQURVGUSUTVPWGBMWTVOWGBA
      WFVNHVAVBWGWPBIWRVNWIWFWOVMWHGVCWRVSWKWEWNWRVSVQWHFNZCEOWKWRVRXNCEVMWHVQF
      STXNWJCDEVQVTWHFRUBVDWRWDWMCGWRWCWLWBVMWHVQFRVETVFVFVHVIVJABGVKVJ @.

    @( A supremum is unique.  (Contributed by NM, 15-May-2008.) @)
    spweu @p |- ( ( R e. PosetRel /\ E. x e. X ph ) -> E! x e. X ph ) @=
      ( wrex cps wcel wreu wa wrmo spwmo anim2i reu5 sylibr ancoms ) ABGIZFJKZA
      BGLZTUAMTABGNZMUBUAUCTABCDEFGHOPABGQRS @.

    @( Property of supremum defining condition for an unordered pair.
       (Contributed by NM, 24-Jun-2008.) @)
    spwpr2 @p |- ( ( ( R e. T /\ A = { B , C } ) /\ ( B e. U /\ C e. W ) )
       -> ( ph <->
     ( ( B R x /\ C R x ) /\ A. y e. X ( ( B R y /\ C R y ) -> x R y ) ) ) ) @=
      ( cv wbr wral wi wa wcel breq1 cpr wceq wb ralprg sylan9bb imbi1d ralbidv
      raleq anbi12d adantll syl5bb ) ACNZBNZHOZCEPZDNZULHOZDEPZUMULHOZQZCLPZRZH
      ISZEFGUAZUBZRFJSGKSRZRFUMHOZGUMHOZRZFULHOZGULHOZRZUSQZCLPZRZMVEVFVBVOUCVC
      VEVFRZUOVIVAVNVEUOUNCVDPVFVIUNCEVDUHUNVGVHCFGJKULFUMHTULGUMHTUDUEVPUTVMCL
      VPURVLUSVEURUQDVDPVFVLUQDEVDUHUQVJVKDFGJKUPFULHTUPGULHTUDUEUFUGUIUJUK @.
  @}

  @{
    @d x y z A @.  @d x y z R @.  @d x y X @.
    spwex.1 @e |- X = dom R @.
    spwex.2 @e |- ( ph <->
         ( A. y e. A y R x /\ A. y e. X ( A. z e. A z R y -> x R y ) ) ) @.
    @( A supremum exists iff ` R supw A ` belongs to the domain of ` R ` .
       (Contributed by NM, 15-May-2008.)  (Revised by Mario Carneiro,
       20-Nov-2013.) @)
    spwex @p |- ( ( R e. PosetRel /\ A e. V )
               -> ( E. x e. X ph <-> ( R supw A ) e. X ) ) @=
      ( cps wcel wa wreu cv wbr wral wb cvv adantr wi crio wrex cspw reubii cdm
      co dmexg syl5eqel riotaclbg syl syl5bb spweu reurex impbid1 spwval eleq1d
      ex 3bitr4d ) FKLZEGLZMZABHNZCOZBOZFPCEQDOVDFPDEQVEVDFPUACHQMZBHUBZHLZABHU
      CZFEUDUGZHLUTVCVHRVAVCVFBHNZUTVHAVFBHJUEUTHSLVKVHRUTHFUFSIFKUHUIVFBHSUJUK
      ULTUTVIVCRVAUTVIVCUTVIVCABCDEFHJUMURABHUNUOTVBVJVGHBCDEFGHIUPUQUS @.

    @( Closure of a supremum.  (Contributed by NM, 15-May-2008.)  (Revised by
       Mario Carneiro, 20-Nov-2013.) @)
    spwcl @p |- ( ( R e. PosetRel /\ A e. V /\ E. x e. X ph )
           -> ( R supw A ) e. X ) @=
      ( cps wcel wrex cspw co spwex biimp3a ) FKLEGLABHMFENOHLABCDEFGHIJPQ @.
  @}

  @{
    @d x y z A @.  @d x y z B @.  @d x y z C @.  @d x y z R @.  @d x y z X @.
    spwpr4.1 @e |- X = dom R @.
    @( Supremum of an unordered pair.  (Contributed by NM, 7-Jul-2008.)
       (Revised by Mario Carneiro, 20-Nov-2013.) @)
    spwpr4 @p |- ( ( R e. PosetRel /\ ( A R C /\ B R C ) /\
   A. x e. X ( ( A R x /\ B R x ) -> C R x ) ) -> ( R supw { A , B } ) = C ) @=
      ( vy vz wcel wa wbr cv wi wral wceq 3adant3 cvv wb syl2anc cps cspw simpl
      cpr co crn wrel psrel relelrn sylan psrn adantr eleqtrrd adantrr jca crio
      w3a simp1l prex spwval sylancl simpll brrelex ex anim12d syl adantlr eqid
      biid spwpr2 mpanl2 riotabidv 3simpc wreu simp1r wrex breq2 anbi12d imbi2d
      imp breq1 ralbidv rspcev 3impb 3adant1l rexbidv mpbird spweu mpbid riota2
      reubidv 3eqtrd syld3an1 ) EUAJZDFJZKZBDELZCDELZKZWNBAMZELCWTELKZDWTELZNZA
      FOZEBCUDZUBUEZDPWNWSWPXDWNWSKWNWOWNWSUCWNWQWOWRWNWQKDEUFZFWNEUGZWQDXGJEUH
      ZBDEUIUJWNFXGPWQEFGUKULUMUNUOQWPWSXDUQZXFWTHMZELAXEOIMWTELIXEOXKWTELZNAFO
      KZHFUPZBXKELZCXKELZKZXAXLNZAFOZKZHFUPZDXJWNXERJXFXNPWNWOWSXDURZBCUSHAIXEE
      RFGUTVAWPWSXNYAPXDWPWSKZXMXTHFYCWNBRJZCRJZKZXMXTSZWNWOWSVBWNWSYFWOWNWSYFW
      NXHWSYFNXIXHWQYDWRYEXHWQYDBDEVCVDXHWRYECDEVCVDVEVFVTVGWNXEXEPYFYGXEVHXMHA
      IXEBCEUARRFXMVIZVJVKTZVLQXJWSXDKZYADPZWPWSXDVMXJWOXTHFVNZYJYKSWNWOWSXDVOX
      JXMHFVNZYLXJWNXMHFVPZYMYBXJYNXTHFVPZWOWSXDYOWNWOWSXDYOXTYJHDFXKDPZXQWSXSX
      DYPXOWQXPWRXKDBEVQXKDCEVQVRYPXRXCAFYPXLXBXAXKDWTEWAVSWBVRZWCWDWEWPWSYNYOS
      XDYCXMXTHFYIWFQWGXMHAIXEEFYHWHTWPWSYMYLSXDYCXMXTHFYIWKQWIXTYJHFDYQWJTWIWL
      WM @.
  @}

  @{
    @d x A @.  @d x B @.  @d x R @.
    @( Supremum of an unordered pair of comparable elements.  (Contributed by
       NM, 7-Jul-2008.) @)
    spwpr4c @p |- ( ( R e. PosetRel /\ A R B ) -> ( R supw { A , B } ) = B ) @=
      ( vx cps wcel wbr wa cv wi cdm wral cpr cspw co wceq simpl simpr crn wrel
      psrel relelrn sylan eqid adantr eleqtrrd psref syldan rgenw a1i syl121anc
      psrn spwpr4 ) CEFZABCGZHZUNUOBBCGZADIZCGZBURCGZHUTJZDCKZLZCABMNOBPUNUOQUN
      UORUNUOBVBFUQUPBCSZVBUNCTUOBVDFCUAABCUBUCUNVBVDPUOCVBVBUDZULUEUFBCVBVEUGU
      HVCUPVADVBUSUTRUIUJDABBCVBVEUMUK @.
  @}

  @{
    @d x y A @.  @d y B @.  @d r x y R @.  @d r x y X @.
    isla.1 @e |- X = dom R @.
    @( The predicate "is a lattice" i.e. a poset in which any two elements have
       upper and lower bounds.  (Contributed by NM, 12-Jun-2008.) @)
    isla @p |- ( R e. LatRel <-> ( R e. PosetRel /\ A. x e. X A. y e. X
      ( ( R supw { x , y } ) e. X /\ ( R infw { x , y } ) e. X ) ) ) @=
      ( vr cv cpr cspw co cdm wcel cinf wa wral cps cla oveq1 eleq12d raleqbidv
      wceq dmeq syl6eqr anbi12d df-lar elrab2 ) FGZAGBGHZIJZUGKZLZUGUHMJZUJLZNZ
      BUJOZAUJOCUHIJZDLZCUHMJZDLZNZBDOZADOFCPQUGCUAZUOVAAUJDVBUJCKDUGCUBEUCZVBU
      NUTBUJDVCVBUKUQUMUSVBUIUPUJDUGCUHIRVCSVBULURUJDUGCUHMRVCSUDTTABFUEUF @.

    @( Closure of the supremum (join) of two lattice elements.  (Contributed by
       NM, 12-Jun-2008.) @)
    laspwcl @p |- ( ( R e. LatRel /\ A e. X /\ B e. X )
                -> ( R supw { A , B } ) e. X ) @=
      ( vx vy cla wcel cpr cspw co cv wral wa cps ralimi wceq oveq2d eleq1d
      cinf isla simpl adantl sylbi preq1 preq2 rspc2v mpan9 3impb ) CHIZADIZBDI
      ZCABJZKLZDIZUKCFMZGMZJZKLZDIZGDNZFDNZULUMOUPUKCPIZVACUSUALDIZOZGDNZFDNZOV
      CFGCDEUBVHVCVDVGVBFDVFVAGDVAVEUCQQUDUEVAUPCAURJZKLZDIFGABDDUQARZUTVJDVKUS
      VICKUQAURUFSTURBRZVJUODVLVIUNCKURBAUGSTUHUIUJ @.

    @( Closure of the infimum (meet) of two lattice elements.  (Contributed by
       NM, 20-Jun-2008.) @)
    lanfwcl @p |- ( ( R e. LatRel /\ A e. X /\ B e. X )
                -> ( R infw { A , B } ) e. X ) @=
      ( vx vy cla wcel cpr cinf co cv wral wa cps ralimi wceq oveq2d eleq1d
      cspw isla simpr adantl sylbi preq1 preq2 rspc2v mpan9 3impb ) CHIZADIZBDI
      ZCABJZKLZDIZUKCFMZGMZJZKLZDIZGDNZFDNZULUMOUPUKCPIZCUSUALDIZVAOZGDNZFDNZOV
      CFGCDEUBVHVCVDVGVBFDVFVAGDVEVAUCQQUDUEVAUPCAURJZKLZDIFGABDDUQARZUTVJDVKUS
      VICKUQAURUFSTURBRZVJUODVLVIUNCKURBAUGSTUHUIUJ @.
  @}

  @{
    @d x y R @.
    @( A lattice is a poset.  (Contributed by NM, 12-Jun-2008.) @)
    laps @p |- ( R e. LatRel -> R e. PosetRel ) @=
      ( vx vy cla wcel cps cv cpr cspw co cdm cinf wa wral eqid isla simplbi )
      ADEAFEABGCGHZIJAKZEARLJSEMCSNBSNBCASSOPQ @.
  @}
$)

  $( domain of ` <_ ` is ` RR* ` .  (Contributed by FL, 2-Aug-2009.)  (Revised
     by Mario Carneiro, 4-May-2015.) $)
  ledm $p |- RR* = dom <_ $=
    ( vx cxr cle cdm cv wcel wbr xrleid lerel releldmi syl cxp wss lerelxr dmss
    ssriv ax-mp dmxpss sstri eqssi ) BCDZABUAAEZBFUBUBCGUBUAFUBHUBUBCIJKPUABBLZ
    DZBCUCMUAUDMNCUCOQBBRST $.

  $( The range of ` <_ ` is ` RR* ` .  (Contributed by FL, 2-Aug-2009.)
     (Revised by Mario Carneiro, 3-Sep-2015.) $)
  lern $p |- RR* = ran <_ $=
    ( vx cxr cle crn cv wcel wbr xrleid lerel relelrni syl cxp wss lerelxr rnss
    ssriv ax-mp rnxpss sstri eqssi ) BCDZABUAAEZBFUBUBCGUBUAFUBHUBUBCIJKPUABBLZ
    DZBCUCMUAUDMNCUCOQBBRST $.

  $( The field of the 'less or equal to' relationship on the extended real.
     (Contributed by FL, 2-Aug-2009.)  (Revised by Mario Carneiro,
     4-May-2015.) $)
  lefld $p |- RR* = U. U. <_ $=
    ( cle cuni cdm crn cun wrel wceq lerel relfld ax-mp ledm lern uneq12i unidm
    cxr 3eqtr2ri ) ABBZACZADZEZOOEOAFQTGHAIJOROSKLMONP $.

  ${
    $d x y z $.
    $( The "less than or equal to" relationship on the extended reals is a
       toset.  (Contributed by FL, 2-Aug-2009.)  (Revised by Mario Carneiro,
       3-Sep-2015.) $)
    letsr $p |- <_ e. TosetRel $=
      ( vx vy vz cle wcel cxr wss cuni wceq cv wbr wa wal lerelxr simpld simprd
      w3a brel adantl wb ctsr cps cxp ccnv cun wrel ccom cin cid cres wi adantr
      lerel 3jca xrletr mpcom ax-gen mpbir asymref simpr xrletri3 sylan2 mpbird
      gen2 cotr ex xrleid jca breq2 breq1 anbi12d syl5ibcom impbid lefld eqcomi
      alrimiv eleq2s mprgbir cvv xrex xpex ssexi isps ax-mp mpbir3an wo xrletri
      wral rgen2a qfto ledm istsr mpbir2an ) DUAEDUBEZFFUCZDDUDZUEGZWNDUFZDDUGD
      GZDWPUHUIDHHZUJIZUMWSAJZBJZDKZXCCJZDKZLZXBXEDKZUKZCMZBMAMXJABXICXBFEZXCFE
      ZXEFEZQXGXHXGXKXLXMXGXKXLXDXKXLLXFXBXCFFDNRULZOXGXKXLXNPXFXMXDXFXLXMXCXEF
      FDNRPSUNXBXCXEUOUPUQVDABCDVEURXAXDXCXBDKZLZXBXCIZTZBMZAWTABDUSXSXBFWTXKXR
      BXKXPXQXKXPXQXKXPLXQXPXKXPUTXPXKXLXQXPTXOXLXDXOXLXKXCXBFFDNROSXBXCVAVBVCV
      FXKXBXBDKZXTLXQXPXKXTXTXBVGZYAVHXQXTXDXTXOXBXCXBDVIXBXCXBDVJVKVLVMVPFWTVN
      VOVQVRDVSEWNWRWSXAQTDWOFFVTVTWANWBVSDWCWDWEWQXDXOWFZBFWHAFWHYBABFXBXCWGWI
      ABFFDWJURDFWKWLWM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Directed sets, nets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c DirRel $.
  $( Extend class notation with the class of all directed sets. $)
  cdir $a class DirRel $.

  $c tail $.
  $( Extend class notation with the tail function. $)
  ctail $a class tail $.

  $( Define the class of all directed sets/directions.  (Contributed by Jeff
     Hankins, 25-Nov-2009.) $)
  df-dir $a |- DirRel = { r | ( ( Rel r /\ ( _I |` U. U. r ) C_ r ) /\
     ( ( r o. r ) C_ r /\ ( U. U. r X. U. U. r ) C_ ( `' r o. r ) ) ) } $.

  ${
    $d r x $.
    $( Define the tail function for directed sets.  (Contributed by Jeff
       Hankins, 25-Nov-2009.) $)
    df-tail $a |- tail = ( r e. DirRel |->
                  ( x e. U. U. r |-> ( r " { x } ) ) ) $.
  $}

  ${
    $d r A $.  $d r R $.
    isdir.1 $e |- A = U. U. R $.
    $( A condition for a relation to be a direction.  (Contributed by Jeff
       Hankins, 25-Nov-2009.)  (Revised by Mario Carneiro, 22-Nov-2013.) $)
    isdir $p |- ( R e. V -> ( R e. DirRel <-> ( ( Rel R /\ ( _I |` A ) C_ R )
                 /\ ( ( R o. R ) C_ R /\ ( A X. A ) C_ ( `' R o. R ) ) ) ) ) $=
      ( vr cv wrel cid cuni cres wss wa ccom cxp ccnv cdir wceq sseq12d anbi12d
      coeq12d releq unieq unieqd syl6eqr reseq2d id xpeq12d cnveq df-dir elab2g
      ) EFZGZHUKIZIZJZUKKZLZUKUKMZUKKZUNUNNZUKOZUKMZKZLZLBGZHAJZBKZLZBBMZBKZAAN
      ZBOZBMZKZLZLEBPCUKBQZUQVHVDVOVPULVEUPVGUKBUAVPUOVFUKBVPUNAHVPUNBIZIAVPUMV
      QUKBUBUCDUDZUEVPUFZRSVPUSVJVCVNVPURVIUKBVPUKBUKBVSVSTVSRVPUTVKVBVMVPUNAUN
      AVRVRUGVPVAVLUKBUKBUHVSTRSSEUIUJ $.
  $}

  $( A direction is a relation.  (Contributed by Jeff Hankins, 25-Nov-2009.)
     (Revised by Mario Carneiro, 22-Nov-2013.) $)
  reldir $p |- ( R e. DirRel -> Rel R ) $=
    ( cdir wcel wrel cid cuni cres wss wa ccom cxp ccnv eqid isdir ibi simpld )
    ABCZADZEAFFZGAHZQRTIZAAJAHSSKALAJHIZQUAUBISABSMNOPP $.

  $( A direction's domain is equal to its field.  (Contributed by Jeff Hankins,
     25-Nov-2009.)  (Revised by Mario Carneiro, 22-Nov-2013.) $)
  dirdm $p |- ( R e. DirRel -> dom R = U. U. R ) $=
    ( cdir wcel cdm cuni wss crn cun ssun1 dmrnssfld sstri a1i cres dmresi wrel
    cid wa ccom cxp ccnv eqid isdir ibi simpld simprd dmss syl syl5eqssr eqssd
    ) ABCZADZAEEZUKULFUJUKUKAGZHULUKUMIAJKLUJULPULMZDZUKULNUJUNAFZUOUKFUJAOZUPU
    JUQUPQZAARAFULULSATARFQZUJURUSQULABULUAUBUCUDUEUNAUFUGUHUI $.

  ${
    $d x y z A $.  $d x y z R $.  $d x y z X $.
    dirref.1 $e |- X = dom R $.
    $( A direction is reflexive.  (Contributed by Jeff Hankins, 25-Nov-2009.)
       (Revised by Mario Carneiro, 22-Nov-2013.) $)
    dirref $p |- ( ( R e. DirRel /\ A e. X ) -> A R A ) $=
      ( cdir wcel wbr cid cres wceq eqid resieq anidms mpbiri cuni cdm wss ccom
      wb wa dirdm syl5eq reseq2d wrel cxp isdir ibi simpld simprd eqsstrd ssbrd
      ccnv syl5 imp ) BEFZACFZAABGZUPAAHCIZGZUOUQUPUSAAJZAKUPUSUTSCAALMNUOURBAA
      UOURHBOOZIZBUOCVAHUOCBPVADBUAUBUCUOBUDZVBBQZUOVCVDTZBBRBQVAVAUEBULBRQTZUO
      VEVFTVABEVAKUFUGUHUIUJUKUMUN $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.
    $( A direction is transitive.  (Contributed by Jeff Hankins, 25-Nov-2009.)
       (Revised by Mario Carneiro, 22-Nov-2013.) $)
    dirtr $p |- ( ( ( R e. DirRel /\ C e. V ) /\ ( A R B /\ B R C ) )
               -> A R C ) $=
      ( vx vy vz cdir wcel wbr wa cvv wi cv wal wss wceq wb breq12 wrel brrelex
      reldir ex anim12d syl w3a ccom cuni cxp ccnv cid cres isdir simprd simpld
      eqid ibi cotr sylib 3adant3 3adant1 anbi12d 3adant2 imbi12d spc3gv 3expia
      syl5 com4t mpdd imp31 an32s ) DIJZABDKZBCDKZLZCEJZACDKZVMVPVQVRVMVPAMJZBM
      JZLZVQVRNVMDUAZVPWANDUCWBVNVSVOVTWBVNVSABDUBUDWBVOVTBCDUBUDUEUFWAVQVMVPVR
      VSVTVQVMVPVRNZNVMFOZGOZDKZWEHOZDKZLZWDWGDKZNZHPGPFPZVSVTVQUGWCVMDDUHDQZWL
      VMWMDUIUIZWNUJDUKDUHQZVMWBULWNUMDQLZWMWOLZVMWPWQLWNDIWNUQUNURUOUPFGHDUSUT
      WKWCFGHABCMMEWDARZWEBRZWGCRZUGZWIVPWJVRXAWFVNWHVOWRWSWFVNSWTWDAWEBDTVAWSW
      TWHVOSWRWEBWGCDTVBVCWRWTWJVRSWSWDAWGCDTVDVEVFVHVGVIVJVKVL $.
  $}

  ${

    $d x y z A $.  $d x y z B $.  $d x y z R $.  $d x y z X $.
    dirge.1 $e |- X = dom R $.
    $( For any two elements of a directed set, there exists a third element
       greater than or equal to both.  (Note that this does not say that the
       two elements have a _least_ upper bound.)  (Contributed by Jeff Hankins,
       25-Nov-2009.)  (Revised by Mario Carneiro, 22-Nov-2013.) $)
    dirge $p |- ( ( R e. DirRel /\ A e. X /\ B e. X )
              -> E. x e. X ( A R x /\ B R x ) ) $=
      ( vy vz cdir wcel cv wbr wa wex cuni eleq2d wral ccom wss simprd wrex cdm
      dirdm syl5eq anbi12d cxp ccnv wrel cres eqid isdir codir sylib wceq breq1
      cid ibi anbi1d exbidv anbi2d rspc2v syl5com sylbid crn reldir relelrn cun
      sylan ex ssun2 dmrnssfld sstri syl5sseqr sseld syld adantrd eximdv df-rex
      ancrd syl6ibr 3impib ) DIJZBEJZCEJZBAKZDLZCWEDLZMZAEUAZWBWCWDMZWHANZWIWBW
      JBDOOZJZCWLJZMZWKWBWCWMWDWNWBEWLBWBEDUBZWLFDUCUDZPWBEWLCWQPUEWBGKZWEDLZHK
      ZWEDLZMZANZHWLQGWLQZWOWKWBWLWLUFDUGDRSZXDWBDDRDSZXEWBDUHZUPWLUIDSMZXFXEMZ
      WBXHXIMWLDIWLUJUKUQTTGHAWLWLDULUMXCWKWFXAMZANGHBCWLWLWRBUNZXBXJAXKWSWFXAW
      RBWEDUOURUSWTCUNZXJWHAXLXAWGWFWTCWEDUOUTUSVAVBVCWBWKWEEJZWHMZANWIWBWHXNAW
      BWHXMWBWFXMWGWBWFWEDVDZJZXMWBWFXPWBXGWFXPDVEBWEDVFVHVIWBXOEWEWBWLXOEXOWPX
      OVGWLXOWPVJDVKVLWQVMVNVOVPVSVQWHAEVRVTVOWA $.
  $}

  ${
    $d t x y z $.
    $( A totally ordered set is a directed set.  (Contributed by Jeff Hankins,
       25-Nov-2009.)  (Revised by Mario Carneiro, 22-Nov-2013.) $)
    tsrdir $p |- ( A e. TosetRel -> A e. DirRel ) $=
      ( ctsr wcel cdir wrel cid cuni cres wss wa ccom cxp ccnv cps syl jca wceq
      eqid syl5eqssr eqsstr3d tsrps psrel cin psref2 inss1 syl6eqssr cdm psdmrn
      pstr2 crn simpld xpeq12d cun istsr simprbi relcoi2 cnvresid cnvss relcoi1
      coss1 relcnv ax-mp relcnvfld reseq2d coss2 unssd sstrd isdir mpbir2and )
      ABCZADCAEZFAGGZHZAIZJAAKAIZVLVLLZAMZAKZIZJVJVKVNVJANCZVKAUAZAUBOZVJVTVNWA
      VTVMAVQUCAAUDAVQUEUFOZPVJVOVSVJVTVOWAAUIOVJVPAUGZWDLZVRVJWDVLWDVLVJWDVLQZ
      AUJVLQZVJVTWFWGJWAAUHOUKZWHULVJWEAVQUMZVRVJVTWEWIIAWDWDRUNUOVJAVQVRVJAVMA
      KZVRVJVKWJAQWBAUPOVJVMVQIWJVRIVJVMVMMZVQVLUQVJVNWKVQIWCVMAUROSVMVQAUTOTVJ
      VQVQFVQGGZHZKZVRVQEWNVQQAVAVQUSVBVJWMAIWNVRIVJWMVMAVJVLWLFVJVKVLWLQWBAVCO
      VDWCTWMAVQVEOSVFVGTPVLABVLRVHVI $.
  $}


$(
###############################################################################
                         BASIC ALGEBRAIC STRUCTURES
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Monoids
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Mnd $.
  $c Grp $.
  $c invg $.
  $c +f $.
  $c -g $.
  $c .g $.

  $( Extend class notation with class of all monoids. $)
  cmnd $a class Mnd $.

  $( Extend class notation with class of all groups. $)
  cgrp $a class Grp $.

  $( Extend class notation with inverse of group element. $)
  cminusg $a class invg $.

  $( Extend class notation with group addition as a function. $)
  cplusf $a class +f $.

  $( Extend class notation with group subtraction (or division) operation. $)
  csg $a class -g $.

  $( Extend class notation with a function mapping a group operation to the
     power operation for the group. $)
  cmg $a class .g $.

  ${
    $d b e g p x y z $.
    $( Definition of a monoid.  A monoid is a set equipped with an everywhere
       defined internal operation (so, a magma, see ~ mndcl ), whose operation
       is associative (so, a semigroup, see ~ mndass ) and has a two-sided
       neutral element (see ~ mndid ).  (Contributed by Mario Carneiro,
       6-Jan-2015.) $)
    df-mnd $a |- Mnd = { g | [. ( Base ` g ) / b ]. [. ( +g ` g ) / p ].
       ( A. x e. b A. y e. b A. z e. b ( ( x p y ) e. b
            /\ ( ( x p y ) p z ) = ( x p ( y p z ) ) )
            /\ E. e e. b A. x e. b ( ( e p x ) = x /\ ( x p e ) = x ) ) } $.

    $( Define group addition function.  Usually we will use ` +g ` directly
       instead of ` +f ` , and they have the same behavior in most cases.  The
       main advantage of ` +f ` is that it is a guaranteed function
       ( ~ mndplusf ), while ` +g ` only has closure ( ~ mndcl ).  (Contributed
       by Mario Carneiro, 14-Aug-2015.) $)
    df-plusf $a |- +f = ( g e. _V |->
      ( x e. ( Base ` g ) , y e. ( Base ` g ) |-> ( x ( +g ` g ) y ) ) ) $.
  $}

  ${
    $d a b c e g p v B $.  $d a b c e g p v G $.  $d a b c e g p v .+ $.
    ismnd.b $e |- B = ( Base ` G ) $.
    ismnd.p $e |- .+ = ( +g ` G ) $.
    $( The predicate "is a monoid."  (Contributed by Mario Carneiro,
       6-Jan-2015.) $)
    ismnd $p |- ( G e. Mnd <-> ( A. a e. B A. b e. B A. c e. B
            ( ( a .+ b ) e. B /\ ( ( a .+ b ) .+ c ) = ( a .+ ( b .+ c ) ) )
   /\ E. e e. B A. a e. B ( ( e .+ a ) = a /\ ( a .+ e ) = a ) ) ) $=
      ( vp vv vg wcel cv co wceq wa wral cbs cvv cmnd wrex cplusg df-mnd eleq2i
      cfv wsbc cab c0 wne rexn0 fvprc syl5eq necon1ai syl adantl fvex a1i fveq2
      wn syl6eqr simpl fveq2d simplr simpr oveqd eleq12d eqidd oveq123d eqeq12d
      anbi12d raleqbidv eqeq1d rexeqbidv sbcied2 elab3 bitri ) DUAMDENZFNZJNZOZ
      KNZMZWAGNZVTOZVRVSWDVTOZVTOZPZQZGWBRZFWBRZEWBRZCNZVRVTOZVRPZVRWMVTOZVRPZQ
      ZEWBRZCWBUBZQZJLNZUCUFZUGZKXBSUFZUGZLUHZMVRVSBOZAMZXHWDBOZVRVSWDBOZBOZPZQ
      ZGARZFARZEARZWMVRBOZVRPZVRWMBOZVRPZQZEARZCAUBZQZUAXGDEFGCLJKUDUEXFYELDYDD
      TMZXQYDAUIUJYFYCCAUKYFAUIYFUTADSUFZUIHDSULUMUNUOUPXBDPZXDYEKXEATXETMYHXBS
      UQURYHXEYGAXBDSUSHVAYHWBAPZQZXAYEJXCBTXCTMYJXBUCUQURYJXCDUCUFBYJXBDUCYHYI
      VBVCIVAYJVTBPZQZWLXQWTYDYLWKXPEWBAYHYIYKVDZYLWJXOFWBAYMYLWIXNGWBAYMYLWCXI
      WHXMYLWAXHWBAYLVTBVRVSYJYKVEZVFZYMVGYLWEXJWGXLYLWAXHWDWDVTBYNYOYLWDVHVIYL
      VRVRWFXKVTBYNYLVRVHYLVTBVSWDYNVFVIVJVKVLVLVLYLWSYCCWBAYMYLWRYBEWBAYMYLWOX
      SWQYAYLWNXRVRYLVTBWMVRYNVFVMYLWPXTVRYLVTBVRWMYNVFVMVKVLVNVKVOVOVPVQ $.
  $}

  ${
    $d u w x B $.  $d u w x .+ $.
    $( A two-sided identity element is unique (if it exists) in any magma.
       (Contributed by Mario Carneiro, 7-Dec-2014.)  (Revised by NM,
       17-Jun-2017.) $)
    mgmidmo $p |- E* u e. B A. x e. B ( ( u .+ x ) = x /\ ( x .+ u ) = x ) $=
      ( vw cv co wceq wa wral wrmo weq wcel ralimi oveq1 id rspcva oveq2 eqeq1d
      eqeq12d wi simpl simpr sylan9req an42s syl2ani anbi12d ralbidv rmo4 mpbir
      ex rgen2a ) BFZAFZDGZUNHZUNUMDGZUNHZIZACJZBCKUTEFZUNDGZUNHZUNVADGZUNHZIZA
      CJZIBELZUAZECJBCJVIBECUTUMCMZVACMZIZUPACJZVEACJZVHVGUSUPACUPURUBNVFVEACVC
      VEUCNVLVMVNIVHVJVNVKVMVHVJVNIVKVMIUMUMVADGZVAVEVOUMHAUMCABLZVDVOUNUMUNUMV
      ADOVPPTQUPVOVAHAVACAELZUOVOUNVAUNVAUMDRVQPTQUDUEUKUFULUTVGBECVHUSVFACVHUP
      VCURVEVHUOVBUNUMVAUNDOSVHUQVDUNUMVAUNDRSUGUHUIUJ $.
  $}

  ${
    $d u w x y z B $.  $d u w x y z G $.  $d x y z X $.  $d y z Y $.  $d z Z $.
    $d u w x y z .+ $.
    mndlem1.b $e |- B = ( Base ` G ) $.
    mndlem1.p $e |- .+ = ( +g ` G ) $.
    $( Lemma for monoid properties.  (Contributed by NM, 14-Aug-2011.)
       (Revised by Mario Carneiro, 6-Jan-2015.) $)
    mndlem1 $p |- ( ( G e. Mnd /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
       ( ( X .+ Y ) e. B /\ ( ( X .+ Y ) .+ Z ) = ( X .+ ( Y .+ Z ) ) ) ) $=
      ( vx vy vz vw wcel cv co wceq wa wral oveq1 eqeq12d cmnd w3a wrex simplbi
      ismnd eleq1d oveq1d anbi12d oveq2 oveq2d anbi2d rspc3v mpan9 ) CUAMZINZJN
      ZBOZAMZUQKNZBOZUOUPUSBOZBOZPZQZKARJARIARZDAMEAMFAMUBDEBOZAMZVFFBOZDEFBOZB
      OZPZQZUNVELNZUOBOUOPUOVMBOUOPQIARLAUCABLCIJKGHUEUDVDVLDUPBOZAMZVNUSBOZDVA
      BOZPZQVGVFUSBOZDEUSBOZBOZPZQIJKDEFAAAUODPZURVOVCVRWCUQVNAUODUPBSZUFWCUTVP
      VBVQWCUQVNUSBWDUGUODVABSTUHUPEPZVOVGVRWBWEVNVFAUPEDBUIZUFWEVPVSVQWAWEVNVF
      USBWFUGWEVAVTDBUPEUSBSUJTUHUSFPZWBVKVGWGVSVHWAVJUSFVFBUIWGVTVIDBUSFEBUIUJ
      TUKULUM $.

    $( Closure of the operation of a monoid.  (Contributed by NM,
       14-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    mndcl $p |- ( ( G e. Mnd /\ X e. B /\ Y e. B ) -> ( X .+ Y ) e. B ) $=
      ( cmnd wcel co w3a df-3an anabs1 bitri wceq mndlem1 simpld sylan2br 3impb
      wa ) CHIZDAIZEAIZDEBJZAIZUBUCTZUAUBUCUBKZUEUGUFUBTUFUBUCUBLUBUCMNUAUGTUEU
      DDBJDEDBJBJOABCDEDFGPQRS $.

    $( A monoid operation is associative.  (Contributed by NM, 14-Aug-2011.) $)
    mndass $p |- ( ( G e. Mnd /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
              ( ( X .+ Y ) .+ Z ) = ( X .+ ( Y .+ Z ) ) ) $=
      ( cmnd wcel w3a wa co wceq mndlem1 simprd ) CIJDAJEAJFAJKLDEBMZAJQFBMDEFB
      MBMNABCDEFGHOP $.

    $( A monoid has a two-sided identity element.  (Contributed by NM,
       16-Aug-2011.) $)
    mndid $p |- ( G e. Mnd ->
         E. u e. B A. x e. B ( ( u .+ x ) = x /\ ( x .+ u ) = x ) ) $=
      ( vy vz cmnd wcel cv co wceq wa wral wrex ismnd simprbi ) EJKALZHLZDMZCKU
      BILZDMTUAUCDMDMNOICPHCPACPBLZTDMTNTUDDMTNOACPBCQCDBEAHIFGRS $.

    $( The two-sided identity element of a monoid is unique.  Lemma 2.2.1(a) of
       [Herstein] p. 55.  (Contributed by Mario Carneiro, 8-Dec-2014.) $)
    mndideu $p |- ( G e. Mnd ->
      E! u e. B A. x e. B ( ( u .+ x ) = x /\ ( x .+ u ) = x ) ) $=
      ( cmnd wcel cv co wceq wa wral wrex wrmo wreu mndid mgmidmo a1i sylanbrc
      reu5 ) EHIZBJZAJZDKUELUEUDDKUELMACNZBCOUFBCPZUFBCQABCDEFGRUGUCABCDSTUFBCU
      BUA $.

    mnd4g.1 $e |- ( ph -> G e. Mnd ) $.
    mnd4g.2 $e |- ( ph -> X e. B ) $.
    mnd4g.3 $e |- ( ph -> Y e. B ) $.
    mnd4g.4 $e |- ( ph -> Z e. B ) $.
    ${
      mnd32g.5 $e |- ( ph -> ( Y .+ Z ) = ( Z .+ Y ) ) $.
      $( Commutative/associative law for monoids, with an explicit
         commutativity hypothesis.  (Contributed by Mario Carneiro,
         21-Apr-2016.) $)
      mnd32g $p |- ( ph -> ( ( X .+ Y ) .+ Z ) = ( ( X .+ Z ) .+ Y ) ) $=
        ( co oveq2d wcel wceq mndass syl13anc cmnd 3eqtr4d ) AEFGCOZCOZEGFCOZCO
        ZEFCOGCOZEGCOFCOZAUCUEECNPADUAQZEBQZFBQZGBQZUGUDRJKLMBCDEFGHISTAUIUJULU
        KUHUFRJKMLBCDEGFHISTUB $.
    $}

    ${
      mnd12g.5 $e |- ( ph -> ( X .+ Y ) = ( Y .+ X ) ) $.
      $( Commutative/associative law for monoids, with an explicit
         commutativity hypothesis.  (Contributed by Mario Carneiro,
         21-Apr-2016.) $)
      mnd12g $p |- ( ph -> ( X .+ ( Y .+ Z ) ) = ( Y .+ ( X .+ Z ) ) ) $=
        ( co oveq1d wcel wceq mndass syl13anc cmnd 3eqtr3d ) AEFCOZGCOZFECOZGCO
        ZEFGCOCOZFEGCOCOZAUCUEGCNPADUAQZEBQZFBQZGBQZUDUGRJKLMBCDEFGHISTAUIUKUJU
        LUFUHRJLKMBCDFEGHISTUB $.
    $}

    mnd4g.5 $e |- ( ph -> W e. B ) $.
    mnd4g.6 $e |- ( ph -> ( Y .+ Z ) = ( Z .+ Y ) ) $.
    $( Commutative/associative law for commutative monoids, with an explicit
       commutativity hypothesis.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    mnd4g $p |- ( ph ->
      ( ( X .+ Y ) .+ ( Z .+ W ) ) = ( ( X .+ Z ) .+ ( Y .+ W ) ) ) $=
      ( co wcel wceq mndcl mnd12g oveq2d cmnd syl3anc mndass syl13anc 3eqtr4d )
      AFGHECQZCQZCQZFHGECQZCQZCQZFGCQUHCQZFHCQUKCQZAUIULFCABCDGHEIJKMNOPUAUBADU
      CRZFBRZGBRZUHBRZUNUJSKLMAUPHBRZEBRZUSKNOBCDHEIJTUDBCDFGUHIJUEUFAUPUQUTUKB
      RZUOUMSKLNAUPURVAVBKMOBCDGEIJTUDBCDFHUKIJUEUFUG $.
  $}

  ${
    $d g x y B $.  $d g x y G $.  $d g x y .+ $.  $d x y X $.  $d x y Y $.
    plusffval.1 $e |- B = ( Base ` G ) $.
    plusffval.2 $e |- .+ = ( +g ` G ) $.
    plusffval.3 $e |- .+^ = ( +f ` G ) $.
    $( The group addition operation as a function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    plusffval $p |- .+^ = ( x e. B , y e. B |-> ( x .+ y ) ) $=
      ( vg cplusf cfv cv cmpt2 cvv wcel wceq cbs cplusg c0 co fveq2 mpt2eq123dv
      syl6eqr oveqd df-plusf cxp crn csn cun wf wral df-ov fvrn0 eqeltri rgen2w
      cop eqid fmpt2 mpbi fvex xpex rnex p0ex unex fex2 mp3an fvmpt fvprc mpt20
      wn syl5eq mpt2eq12 syl2anc eqtr4d pm2.61i eqtri ) EFKLZABCCAMZBMZDUAZNZIF
      OPZVRWBQJFABJMZRLZWEVSVTWDSLZUAZNWBOKWDFQZABWEWEWGCCWAWHWEFRLZCWDFRUBGUDZ
      WJWHWFDVSVTWHWFFSLZDWDFSUBHUDUEUCABJUFCCUGZDUHZTUIZUJZWBUKZWLOPWOOPWBOPWA
      WOPZBCULACULWPWQABCCWAVSVTUQZDLWOVSVTDUMDWRUNUOUPABCCWAWOWBWBURUSUTCCCWIO
      GFRVAUOZWSVBWMWNDDWKOHFSVAUOVCVDVEWLWOWBOOVFVGVHWCVKZVRABTTWANZWBWTVRTXAF
      KVIABTWAVJUDWTCTQZXBWBXAQWTCWITGFRVIVLZXCABCCTTWAVMVNVOVPVQ $.

    $( The group addition operation as a function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    plusfval $p |- ( ( X e. B /\ Y e. B ) -> ( X .+^ Y ) = ( X .+ Y ) ) $=
      ( vx vy cv co oveq12 plusffval ovex ovmpt2a ) JKEFAAJLZKLZBMEFBMCRESFBNJK
      ABCDGHIOEFBPQ $.

    $( If the addition operation is already a function, the functionalization
       of it is equal to the original operation.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    plusfeq $p |- ( .+ Fn ( B X. B ) -> .+^ = .+ ) $=
      ( vx vy cxp wfn cv co cmpt2 wceq fnov biimpi plusffval syl6reqr ) BAAJKZB
      HIAAHLILBMNZCTBUAOHIAABPQHIABCDEFGRS $.
  $}

  ${
    $d x y B $.  $d x y G $.
    mndplusf.1 $e |- B = ( Base ` G ) $.
    mndplusf.2 $e |- .+^ = ( +f ` G ) $.
    $( The group addition operation is a function.  (Contributed by Mario
       Carneiro, 20-Sep-2015.) $)
    plusffn $p |- .+^ Fn ( B X. B ) $=
      ( vx vy cv cplusg cfv co eqid plusffval ovex fnmpt2i ) FGAAFHZGHZCIJZKBFG
      ARBCDRLEMPQRNO $.

    $( The group addition operation is a function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    mndplusf $p |- ( G e. Mnd -> .+^ : ( B X. B ) --> B ) $=
      ( vx vy cmnd wcel cv cplusg cfv co wral cxp eqid mndcl 3expb ralrimivva
      wf plusffval fmpt2 sylib ) CHIZFJZGJZCKLZMZAIZGANFANAAOABTUDUIFGAAUDUEAIU
      FAIUIAUGCUEUFDUGPZQRSFGAAUHABFGAUGBCDUJEUAUBUC $.
  $}

  ${
    $d e g x B $.  $d e g x G $.  $d g .+ $.
    grpidval.b $e |- B = ( Base ` G ) $.
    grpidval.p $e |- .+ = ( +g ` G ) $.
    grpidval.o $e |- .0. = ( 0g ` G ) $.
    $( The value of the identity element of a group.  (Contributed by NM,
       20-Aug-2011.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    grpidval $p |- .0. =
     ( iota e ( e e. B /\ A. x e. B ( ( e .+ x ) = x /\ ( x .+ e ) = x ) ) ) $=
      ( vg c0g cfv cv wcel co wceq wa cbs cplusg c0 wral cio cvv syl6eqr eleq2d
      fveq2 oveqd eqeq1d anbi12d raleqbidv iotabidv df-0g iotaex fvmpt wn fvprc
      weu wex euex n0i syl5eq nsyl2 adantr exlimiv con3i iotanul eqtr4d pm2.61i
      syl eqtri ) FEKLZDMZBNZVLAMZCOZVNPZVNVLCOZVNPZQZABUAZQZDUBZIEUCNZVKWBPJEV
      LJMZRLZNZVLVNWDSLZOZVNPZVNVLWGOZVNPZQZAWEUAZQZDUBWBUCKWDEPZWNWADWOWFVMWMV
      TWOWEBVLWOWEERLZBWDERUFGUDZUEWOWLVSAWEBWQWOWIVPWKVRWOWHVOVNWOWGCVLVNWOWGE
      SLCWDESUFHUDZUGUHWOWJVQVNWOWGCVNVLWRUGUHUIUJUIUKADJULWADUMUNWCUOZVKTWBEKU
      PWSWADUQZUOWBTPWTWCWTWADURWCWADUSWAWCDVMWCVTVMBTPWCBVLUTWSBWPTGERUPVAVBVC
      VDVIVEWADVFVIVGVHVJ $.
  $}

  ${
    $d e g x $.
    $( The group zero extractor is a function.  (Contributed by Stefan O'Rear,
       10-Jan-2015.) $)
    fn0g $p |- 0g Fn _V $=
      ( vg ve vx cvv cv cbs cfv wcel cplusg co wceq wa wral iotaex df-0g fnmpti
      cio c0g ) ADBEZAEZFGZHSCEZTIGZJUBKUBSUCJUBKLCUAMLZBQRUDBNCBAOP $.

    $( The identity element function evaluates to the empty set on an empty
       structure.  (Contributed by Stefan O'Rear, 2-Oct-2015.) $)
    0g0 $p |- (/) = ( 0g ` (/) ) $=
      ( ve vx c0 c0g cfv cv wcel cplusg co wceq wa wral cio base0 eqid grpidval
      weu wn wex noel intnanr nex euex mto iotanul ax-mp eqtr2i ) CDEZAFZCGZUIB
      FZCHEZIUKJUKUIULIUKJKBCLZKZAMZCBCULACUHNULOUHOPUNAQZRUOCJUPUNASUNAUJUMUIT
      UAUBUNAUCUDUNAUEUFUG $.
  $}

  ${
    $d e x y .+ $.  $d e x y .0. $.  $d e x y B $.  $d e x y G $.  $d x X $.
    $d e x y U $.
    mndidcl.b $e |- B = ( Base ` G ) $.
    mndidcl.o $e |- .0. = ( 0g ` G ) $.
    ${
      mgmidcl.p $e |- .+ = ( +g ` G ) $.
      mgmidcl.e $e |- ( ph ->
        E. e e. B A. x e. B ( ( e .+ x ) = x /\ ( x .+ e ) = x ) ) $.
      $( The identity element of a magma, if it exists, belongs to the base
         set.  (Contributed by Mario Carneiro, 27-Dec-2014.) $)
      ismgmid $p |- ( ph -> ( ( U e. B /\
        A. x e. B ( ( U .+ x ) = x /\ ( x .+ U ) = x ) ) <-> .0. = U ) ) $=
        ( wcel cv co wceq wa wral eqeq1d syl crio wreu wb wrex wrmo mgmidmo a1i
        id sylanbrc oveq1 oveq2 anbi12d ralbidv riota2 syl2anr pm5.32da riotacl
        reu5 eleq1 syl5ibcom pm4.71rd cio riotaiota grpidval syl6eqr 3bitr2d )
        AECMZEBNZDOZVHPZVHEDOZVHPZQZBCRZQVGFNZVHDOZVHPZVHVODOZVHPZQZBCRZFCUAZEP
        ZQWCHEPAVGVNWCVGVGWAFCUBZVNWCUCAVGUHAWAFCUDWAFCUEZWDLWEABFCDUFUGWAFCURU
        IZWAVNFCEVOEPZVTVMBCWGVQVJVSVLWGVPVIVHVOEVHDUJSWGVRVKVHVOEVHDUKSULUMUNU
        OUPAWCVGAWBCMZWCVGAWDWHWFWAFCUQTWBECUSUTVAAWBHEAWBVOCMWAQFVBZHAWDWBWIPW
        FWAFCVCTBCDFGHIKJVDVESVF $.

      $( The identity element of a magma, if it exists, belongs to the base
         set.  (Contributed by Mario Carneiro, 27-Dec-2014.) $)
      mgmidcl $p |- ( ph -> .0. e. B ) $=
        ( wcel cv co wceq wa wral eqid ismgmid mpbiri simpld ) AGCLZGBMZDNUCOUC
        GDNUCOPBCQZAUBUDPGGOGRABCDGEFGHIJKSTUA $.

      $( The identity element of a magma, if it exists, is a left and right
         identity.  (Contributed by Mario Carneiro, 27-Dec-2014.) $)
      mgmlrid $p |- ( ( ph /\ X e. B ) ->
        ( ( .0. .+ X ) = X /\ ( X .+ .0. ) = X ) ) $=
        ( cv co wceq wa wral wcel eqid eqeq12d ismgmid mpbiri simprd id anbi12d
        oveq2 oveq1 rspccva sylan ) AHBMZDNZUJOZUJHDNZUJOZPZBCQZGCRHGDNZGOZGHDN
        ZGOZPZAHCRZUPAVBUPPHHOHSABCDHEFHIJKLUAUBUCUOVABGCUJGOZULURUNUTVCUKUQUJG
        UJGHDUFVCUDZTVCUMUSUJGUJGHDUGVDTUEUHUI $.
    $}

    ${
      $d x ph $.
      ismgmid2.p $e |- .+ = ( +g ` G ) $.
      ismgmid2.u $e |- ( ph -> U e. B ) $.
      ismgmid2.l $e |- ( ( ph /\ x e. B ) -> ( U .+ x ) = x ) $.
      ismgmid2.r $e |- ( ( ph /\ x e. B ) -> ( x .+ U ) = x ) $.
      $( Show that a given element is the identity element of a magma.
         (Contributed by Mario Carneiro, 27-Dec-2014.) $)
      ismgmid2 $p |- ( ph -> U = .0. ) $=
        ( ve wcel cv co wceq wa wral jca ralrimiva oveq1 eqeq1d anbi12d ralbidv
        wrex oveq2 rspcev syl2anc ismgmid mpbi2and eqcomd ) AGEAECOZEBPZDQZUORZ
        UOEDQZUORZSZBCTZGERKAUTBCAUOCOSUQUSLMUAUBZABCDENFGHIJAUNVANPZUODQZUORZU
        OVCDQZUORZSZBCTZNCUGKVBVIVANECVCERZVHUTBCVJVEUQVGUSVJVDUPUOVCEUODUCUDVJ
        VFURUOVCEUODUHUDUEUFUIUJUKULUM $.
    $}

    $( The identity element of a monoid belongs to the monoid.  (Contributed by
       NM, 27-Aug-2011.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
    mndidcl $p |- ( G e. Mnd -> .0. e. B ) $=
      ( vy vx cmnd wcel cplusg cfv eqid mndid mgmidcl ) BHIFABJKZGBCDEOLZFGAOBD
      PMN $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y .0. $.  $d x y .+ $.  $d x X $.
    mndlrid.b $e |- B = ( Base ` G ) $.
    mndlrid.p $e |- .+ = ( +g ` G ) $.
    mndlrid.o $e |- .0. = ( 0g ` G ) $.
    $( A monoid's identity element is a two-sided identity.  (Contributed by
       NM, 18-Aug-2011.) $)
    mndlrid $p |- ( ( G e. Mnd /\ X e. B ) -> ( ( .0. .+ X ) = X /\
         ( X .+ .0. ) = X ) ) $=
      ( vx vy cmnd wcel mndid mgmlrid ) CKLIABJCDEFHGIJABCFGMN $.

    $( The identity element of a monoid is a left identity.  (Contributed by
       NM, 18-Aug-2011.) $)
    mndlid $p |- ( ( G e. Mnd /\ X e. B ) -> ( .0. .+ X ) = X ) $=
      ( cmnd wcel wa co wceq mndlrid simpld ) CIJDAJKEDBLDMDEBLDMABCDEFGHNO $.

    $( The identity element of a monoid is a right identity.  (Contributed by
       NM, 18-Aug-2011.) $)
    mndrid $p |- ( ( G e. Mnd /\ X e. B ) -> ( X .+ .0. ) = X ) $=
      ( cmnd wcel wa co wceq mndlrid simprd ) CIJDAJKEDBLDMDEBLDMABCDEFGHNO $.
  $}

  ${
    $d x y G $.  $d x ph $.  $d x y .0. $.
    grpidd.b $e |- ( ph -> B = ( Base ` G ) ) $.
    grpidd.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    grpidd.z $e |- ( ph -> .0. e. B ) $.
    grpidd.i $e |- ( ( ph /\ x e. B ) -> ( .0. .+ x ) = x ) $.
    grpidd.j $e |- ( ( ph /\ x e. B ) -> ( x .+ .0. ) = x ) $.
    $( Deduce the identity element of a monoid from its properties.
       (Contributed by Mario Carneiro, 6-Jan-2015.) $)
    grpidd $p |- ( ph -> .0. = ( 0g ` G ) ) $=
      ( cbs cfv eqid wcel co wceq oveqd eqtr3d syldan cplusg c0g eleqtrd eleq2d
      cv biimpar wa adantr ismgmid2 ) ABELMZEUAMZFEEUBMZUJNULNUKNAFCUJIGUCABUEZ
      UJOZUMCOZFUMUKPZUMQAUOUNACUJUMGUDUFZAUOUGZFUMDPUPUMURDUKFUMADUKQUOHUHZRJS
      TAUNUOUMFUKPZUMQUQURUMFDPUTUMURDUKUMFUSRKSTUI $.
  $}

  ${
    $d x y z B $.  $d u x y z G $.  $d x y z ph $.  $d u x .0. $.
    ismndd.b $e |- ( ph -> B = ( Base ` G ) ) $.
    ismndd.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    ismndd.c $e |- ( ( ph /\ x e. B /\ y e. B ) -> ( x .+ y ) e. B ) $.
    ismndd.a $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) ) ->
                   ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    ismndd.z $e |- ( ph -> .0. e. B ) $.
    ismndd.i $e |- ( ( ph /\ x e. B ) -> ( .0. .+ x ) = x ) $.
    ismndd.j $e |- ( ( ph /\ x e. B ) -> ( x .+ .0. ) = x ) $.
    $( Deduce a monoid from its properties.  (Contributed by Mario Carneiro,
       6-Jan-2015.) $)
    ismndd $p |- ( ph -> G e. Mnd ) $=
      ( co wcel wceq wa wral cplusg cfv cbs wrex cmnd w3a 3adant3r3 ralrimivvva
      vu cv oveqd eleq12d eqidd oveq123d eqeq12d anbi12d raleqbidv mpbid eleq2d
      eleqtrd biimpar adantr eqtr3d syldan ralrimiva oveq1 eqeq1d oveq2 ralbidv
      jca rspcev syl2anc eqid ismnd sylanbrc ) ABUJZCUJZGUAUBZPZGUCUBZQZVSDUJZV
      RPZVPVQWBVRPZVRPZRZSZDVTTZCVTTZBVTTZUIUJZVPVRPZVPRZVPWKVRPZVPRZSZBVTTZUIV
      TUDZGUEQAVPVQFPZEQZWSWBFPZVPVQWBFPZFPZRZSZDETZCETZBETWJAXEBCDEEEAVPEQZVQE
      QZWBEQZUFSWTXDAXHXIWTXJKUGLVJUHAXGWIBEVTIAXFWHCEVTIAXEWGDEVTIAWTWAXDWFAWS
      VSEVTAFVRVPVQJUKZIULAXAWCXCWEAWSVSWBWBFVRJXKAWBUMUNAVPVPXBWDFVRJAVPUMAFVR
      VQWBJUKUNUOUPUQUQUQURAHVTQHVPVRPZVPRZVPHVRPZVPRZSZBVTTZWRAHEVTMIUTAXPBVTA
      VPVTQZXHXPAXHXRAEVTVPIUSVAAXHSZXMXOXSHVPFPXLVPXSFVRHVPAFVRRXHJVBZUKNVCXSV
      PHFPXNVPXSFVRVPHXTUKOVCVJVDVEWQXQUIHVTWKHRZWPXPBVTYAWMXMWOXOYAWLXLVPWKHVP
      VRVFVGYAWNXNVPWKHVPVRVHVGUPVIVKVLVTVRUIGBCDVTVMVRVMVNVO $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z .+ $.
    mndfo.b $e |- B = ( Base ` G ) $.
    mndfo.p $e |- .+ = ( +g ` G ) $.
    $( The addition operation of a monoid is an onto function (assuming it is a
       function).  (Contributed by Mario Carneiro, 11-Oct-2013.) $)
    mndfo $p |- ( ( G e. Mnd /\ .+ Fn ( B X. B ) ) ->
      .+ : ( B X. B ) -onto-> B ) $=
      ( vx vy vz cmnd wcel cxp wa cv co wceq wrex wral simpr adantr sylanbrc wf
      wfn wfo mndcl 3expb ralrimivva c0g cfv eqid mndidcl mndrid eqcomd rspceov
      ffnov syl3anc ralrimiva foov ) CIJZBAAKZUBZLZUSABUAZFMZGMZHMBNOHAPGAPZFAQ
      ZUSABUCVAUTVCVDBNAJZGAQFAQZVBURUTRURVHUTURVGFGAAURVCAJZVDAJVGABCVCVDDEUDU
      EUFSFGAAABUNTURVFUTURVEFAURVILZVICUGUHZAJZVCVCVKBNZOVEURVIRURVLVIACVKDVKU
      IZUJSVJVMVCABCVCVKDEVNUKULGHAAVCVKVCBUMUOUPSGHFAAABUQT $.
  $}

  ${
    $d s u v w x y z B $.  $d s u v w x y z K $.  $d s u v w x y z ph $.
    $d s u v w x y z L $.
    mndpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    mndpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    mndpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    $( If two structures have the same group components (properties), one is a
       monoid iff the other one is.  (Contributed by Mario Carneiro,
       6-Jan-2015.) $)
    mndpropd $p |- ( ph -> ( K e. Mnd <-> L e. Mnd ) ) $=
      ( vu vv vw vs cv co wcel wral wa wceq proplem cplusg cmnd simplr ad2antrr
      cfv cbs simprl eleqtrd simprr eqid syl3anc eleqtrrd ralrimivva ex adantlr
      mndcl 3eltr4d wb simplll simplrl simplrr syl12anc eleq1d simpllr proplem2
      wrex syl21anc simpr oveq1d eqtrd oveq2d eqeq12d ralbidva 2ralbidva adantr
      anbi12d eleq2d anbi1d raleqbidv 3bitr3d eqeq1d rexbidva raleqdv rexeqbidv
      ismnd 3bitr4g pm5.21ndd ) ABNZCNZEUAUEZOZDPZCDQBDQZEUBPZFUBPZAWNWMAWNRZWL
      BCDDWPWHDPZWIDPZRZRZWKEUFUEZDWTWNWHXAPWIXAPWKXAPAWNWSUCWTWHDXAWPWQWRUGADX
      ASZWNWSGUDZUHWTWIDXAWPWQWRUIXCUHXAWJEWHWIXAUJZWJUJZUPUKXCULUMUNAWOWMAWORZ
      WLBCDDXFWSRZWHWIFUAUEZOZFUFUEZWKDXGWOWHXJPWIXJPXIXJPAWOWSUCXGWHDXJXFWQWRU
      GADXJSZWOWSHUDZUHXGWIDXJXFWQWRUIXLUHXJXHFWHWIXJUJZXHUJZUPUKAWSWKXISWOIUOX
      LUQUMUNAWMWNWOURAWMRZJNZKNZWJOZXAPZXRLNZWJOZXPXQXTWJOZWJOZSZRZLXAQZKXAQZJ
      XAQZMNZXPWJOZXPSZXPYIWJOZXPSZRZJXAQZMXAVFZRXPXQXHOZXJPZYQXTXHOZXPXQXTXHOZ
      XHOZSZRZLXJQZKXJQZJXJQZYIXPXHOZXPSZXPYIXHOZXPSZRZJXJQZMXJVFZRWNWOXOYHUUFY
      PUUMXOXRDPZYDRZLDQZKDQZJDQYQDPZUUBRZLDQZKDQZJDQYHUUFXOUUPUUTJKDDXOXPDPZXQ
      DPZRZRZUUOUUSLDUVEXTDPZRZUUNUURYDUUBUVGXRYQDUVGAUVBUVCXRYQSAWMUVDUVFUSZXO
      UVBUVCUVFUTZXOUVBUVCUVFVAZABCDDWJXHXPXQITVBZVCUVGYAYSYCUUAUVGYAXRXTXHOZYS
      UVGAUUNUVFYAUVLSUVHUVGUVBUVCWMUUNUVIUVJAWMUVDUVFVDZBCDDDWJXPXQVEVGUVEUVFV
      HZABCDDWJXHXRXTITVBUVGXRYQXTXHUVKVIVJUVGYCXPYBXHOZUUAUVGAUVBYBDPZYCUVOSUV
      HUVIUVGUVCUVFWMUVPUVJUVNUVMBCDDDWJXQXTVEVGABCDDWJXHXPYBITVBUVGYBYTXPXHUVG
      AUVCUVFYBYTSUVHUVJUVNABCDDWJXHXQXTITVBVKVJVLVPVMVNXOUUQYGJDXAAXBWMGVOZXOU
      UPYFKDXAUVQXOUUOYELDXAUVQXOUUNXSYDXODXAXRUVQVQVRVSVSVSXOUVAUUEJDXJAXKWMHV
      OZXOUUTUUDKDXJUVRXOUUSUUCLDXJUVRXOUURYRUUBXODXJYQUVRVQVRVSVSVSVTXOYNJDQZM
      DVFUUKJDQZMDVFYPUUMXOUVSUVTMDXOYIDPZRZYNUUKJDUWBUVBRZYKUUHYMUUJUWCYJUUGXP
      UWCAUWAUVBYJUUGSAWMUWAUVBUSZXOUWAUVBUCZUWBUVBVHZABCDDWJXHYIXPITVBWAUWCYLU
      UIXPUWCAUVBUWAYLUUISUWDUWFUWEABCDDWJXHXPYIITVBWAVPVMWBXOUVSYOMDXAUVQXOYNJ
      DXAUVQWCWDXOUVTUULMDXJUVRXOUUKJDXJUVRWCWDVTVPXAWJMEJKLXDXEWEXJXHMFJKLXMXN
      WEWFUNWG $.

    $( If two structures have the same group components (properties), they have
       the same identity element.  (Contributed by Mario Carneiro,
       27-Nov-2014.) $)
    grpidpropd $p |- ( ph -> ( 0g ` K ) = ( 0g ` L ) ) $=
      ( vz vw cv cfv wcel co wceq wa wral anbi12d eqid cbs cplusg cio wb eqeq1d
      proplem ancom2s anassrs ralbidva pm5.32da eleq2d raleqdv 3bitr3d iotabidv
      c0g grpidval 3eqtr4g ) ABLZEUAMZNZURCLZEUBMZOZVAPZVAURVBOZVAPZQZCUSRZQZBU
      CURFUAMZNZURVAFUBMZOZVAPZVAURVLOZVAPZQZCVJRZQZBUCEUOMZFUOMZAVIVSBAURDNZVG
      CDRZQWBVQCDRZQVIVSAWBWCWDAWBQVGVQCDAWBVADNZVGVQUDAWBWEQQZVDVNVFVPWFVCVMVA
      IUEWFVEVOVAAWEWBVEVOPAJKDDVBVLVAURABCDDVBVLJLKLIUFUFUGUESUHUIUJAWBUTWCVHA
      DUSURGUKAVGCDUSGULSAWBVKWDVRADVJURHUKAVQCDVJHULSUMUNCUSVBBEVTUSTVBTVTTUPC
      VJVLBFWAVJTVLTWATUPUQ $.
  $}

  ${
    $d x y K $.  $d x y L $.
    mndprop.b $e |- ( Base ` K ) = ( Base ` L ) $.
    mndprop.p $e |- ( +g ` K ) = ( +g ` L ) $.
    $( If two structures have the same group components (properties), one is a
       group iff the other one is.  (Contributed by Mario Carneiro,
       11-Oct-2013.) $)
    mndprop $p |- ( K e. Mnd <-> L e. Mnd ) $=
      ( vx vy cmnd wcel wb wtru cbs cfv eqidd wceq a1i cv cplusg co wa oveqi
      mndpropd trud ) AGHBGHIJEFAKLZABJUCMUCBKLNJCOEPZFPZAQLZRUDUEBQLZRNJUDUCHU
      EUCHSSUFUGUDUEDTOUAUB $.
  $}

  ${
    $d u v w x y B $.  $d u v w x y G $.  $d u v w x y H $.  $d u v w x y .+ $.
    $d u v w x y S $.  $d u v w x y .0. $.
    issubmnd.b $e |- B = ( Base ` G ) $.
    issubmnd.p $e |- .+ = ( +g ` G ) $.
    issubmnd.z $e |- .0. = ( 0g ` G ) $.
    issubmnd.h $e |- H = ( G |`s S ) $.
    $( Characterize a submonoid by closure properties.  (Contributed by Mario
       Carneiro, 10-Jan-2015.) $)
    issubmnd $p |- ( ( G e. Mnd /\ S C_ B /\ .0. e. S ) ->
      ( H e. Mnd <-> A. x e. S A. y e. S ( x .+ y ) e. S ) ) $=
      ( wcel w3a cv co wa cfv cbs wceq vu vv cmnd wss wral cplusg simplr simprl
      vw simpll2 ressbas2 syl eleqtrd simprr eqid syl3anc cvv fvex eqeltri ssex
      mndcl 3ad2ant2 ressplusg ad2antrr oveqd ralrimivva simpl2 adantr proplem2
      3eltr4d ancoms 3impb 3adant1l sseld 3anim123d simpl1 mndass syldan simpl3
      imp sylan sselda mndlid mndrid ismndd impbida ) FUCMZECUDZHEMZNZGUCMZAOZB
      OZDPZEMZBEUEAEUEZWJWKQZWOABEEWQWLEMZWMEMZQZQZWLWMGUFRZPZGSRZWNEXAWKWLXDMW
      MXDMXCXDMWJWKWTUGXAWLEXDWQWRWSUHXAWHEXDTZWGWHWIWKWTUJECGFLIUKZULZUMXAWMEX
      DWQWRWSUNXGUMXDXBGWLWMXDUOXBUOVAUPXADXBWLWMWJDXBTZWKWTWJEUQMZXHWHWGXIWIEC
      CFSRUQIFSURUSUTVBEDFGUQLJVCULZVDVEXGVJVFWJWPQZUAUBUIEDGHXKWHXEWGWHWIWPVGZ
      XFULWJXHWPXJVHWPUAOZEMZUBOZEMZXMXODPZEMZWJWPXNXPXRXNXPQWPXRABEEEDXMXOVIVK
      VLVMXKXNXPUIOZEMZNZXMCMZXOCMZXSCMZNZXQXSDPXMXOXSDPDPTZXKYAYEXKXNYBXPYCXTY
      DXKECXMXLVNXKECXOXLVNXKECXSXLVNVOVTXKWGYEYFWGWHWIWPVPZCDFXMXOXSIJVQWAVRWG
      WHWIWPVSXKXNYBHXMDPXMTZXKECXMXLWBZXKWGYBYHYGCDFXMHIJKWCWAVRXKXNYBXMHDPXMT
      ZYIXKWGYBYJYGCDFXMHIJKWDWAVRWEWF $.
  $}

  ${
    $d x B $.  $d x G $.  $d x H $.  $d x S $.  $d x .0. $.
    submnd0.b $e |- B = ( Base ` G ) $.
    submnd0.z $e |- .0. = ( 0g ` G ) $.
    submnd0.h $e |- H = ( G |`s S ) $.
    $( The zero of a submonoid is the same as the zero in the parent monoid.
       (Note that we must add the condition that the zero of the parent monoid
       is actually contained in the submonoid, because it is possible to have
       "subsets that are monoids" which are not submonoids because they have a
       different identity element.)  (Contributed by Mario Carneiro,
       10-Jan-2015.) $)
    submnd0 $p |- ( ( ( G e. Mnd /\ H e. Mnd ) /\ ( S C_ B /\ .0. e. S ) ) ->
      .0. = ( 0g ` H ) ) $=
      ( vx cmnd wcel wa cbs cfv cplusg eqid wceq co cvv oveqd ressbas2 ad2antrl
      wss c0g simprr eleqtrd cv fvex syl6eqel adantr ressplusg simpll ressbasss
      syl sseli mndlid syl2an eqtr3d mndrid ismgmid2 ) CJKZDJKZLZBAUCZEBKZLZLZI
      DMNZDONZEDDUDNZVHPVJPVIPVGEBVHVCVDVEUEVDBVHQVCVEBADCHFUAUBZUFVGIUGZVHKZLZ
      EVLCONZRZEVLVIRVLVNVOVIEVLVNBSKZVOVIQVGVQVMVGBVHSVKDMUHUIUJBVOCDSHVOPZUKU
      NZTVGVAVLAKZVPVLQVMVAVBVFULZVHAVLBADCHFUMUOZAVOCVLEFVRGUPUQURVNVLEVORZVLE
      VIRVLVNVOVIVLEVSTVGVAVTWCVLQVMWAWBAVOCVLEFVRGUSUQURUT $.
  $}

  ${
    $d x y .+ $.  $d y .0. $.  $d x y B $.  $d x F $.  $d x y I $.  $d x y R $.
    $d x G $.  $d x y ph $.  $d x y S $.  $d x y V $.  $d x y W $.  $d x y Y $.
    prdsplusgcl.y $e |- Y = ( S Xs_ R ) $.
    prdsplusgcl.b $e |- B = ( Base ` Y ) $.
    prdsplusgcl.p $e |- .+ = ( +g ` Y ) $.
    prdsplusgcl.s $e |- ( ph -> S e. V ) $.
    prdsplusgcl.i $e |- ( ph -> I e. W ) $.
    prdsplusgcl.r $e |- ( ph -> R : I --> Mnd ) $.
    ${
      prdsplusgcl.f $e |- ( ph -> F e. B ) $.
      prdsplusgcl.g $e |- ( ph -> G e. B ) $.
      $( Structure product pointwise sums are closed when the factors are
         monoids.  (Contributed by Stefan O'Rear, 10-Jan-2015.) $)
      prdsplusgcl $p |- ( ph -> ( F .+ G ) e. B ) $=
        ( wcel vx co cv cfv cplusg cmpt cmnd wf wfn ffn syl prdsplusgval cbs wa
        wral ffvelrnda simpr prdsbasprj eqid mndcl syl3anc ralrimiva prdsbasmpt
        adantr mpbird eqeltrd ) AFGCUBUAHUAUCZFUDZVGGUDZVGDUDZUEUDZUBZUFZBAUABC
        DEFGHIJKLMOPAHUGDUHDHUIZQHUGDUJUKZRSNULAVMBTVLVJUMUDZTZUAHUOAVQUAHAVGHT
        ZUNZVJUGTVHVPTVIVPTVQAHUGVGDQUPVSBDEFHVGIJKLMAEITVROVDZAHJTVRPVDZAVNVRV
        OVDZAFBTVRRVDAVRUQZURVSBDEGHVGIJKLMVTWAWBAGBTVRSVDWCURVPVKVJVHVIVPUSVKU
        SUTVAVBAUABDEVLHIJKLMOPVOVCVEVF $.
    $}

    prdsidlem.z $e |- .0. = ( 0g o. R ) $.
    $( Characterization of identity in a structure product.  (Contributed by
       Mario Carneiro, 10-Jan-2015.) $)
    prdsidlem $p |- ( ph -> ( .0. e. B /\ A. x e. B ( ( .0. .+ x ) = x /\
        ( x .+ .0. ) = x ) ) ) $=
      ( vy wcel cv co wceq wral cfv c0g cmpt ccom cvv fvex a1i cmnd feqmptd wfn
      fn0g dffn5 sylib fveq2 fmptco syl5eq cbs ffvelrnda eqid mndidcl ralrimiva
      wa syl wf ffn prdsbasmpt mpbird eqeltrd cplusg fveq1i fvco2 sylan adantlr
      oveq1d adantr ad2antrr simplr simpr prdsbasprj syl2anc eqtrd prdsplusgval
      mndlid mpteq2dva prdsbasfn 3eqtr4d oveq2d mndrid jca ) AKCTZKBUAZDUBZWOUC
      ZWOKDUBZWOUCZVFZBCUDAKSGSUAZEUEZUFUEZUGZCAKUFEUHZXDRASBGUIXBWOUFUEZXCEUFX
      BUITAXAGTZVFZXAEUJUKASGULEQUMAUFUIUNZUFBUIXFUGUCXIAUOUKBUIUFUPUQWOXBUFURU
      SUTAXDCTXCXBVAUEZTZSGUDAXKSGXHXBULTZXKAGULXAEQVBXJXBXCXJVCZXCVCZVDVGVEASC
      EFXCGHIJLMOPAGULEVHZEGUNZQGULEVIVGZVJVKVLZAWTBCAWOCTZVFZWQWSXTSGXAKUEZXAW
      OUEZXBVMUEZUBZUGSGYBUGZWPWOXTSGYDYBXTXGVFZYDXCYBYCUBZYBYFYAXCYBYCAXGYAXCU
      CXSXHYAXAXEUEZXCXAKXERVNAXPXGYHXCUCXQGUFEXAVOVPUTVQZVRYFXLYBXJTZYGYBUCXTG
      ULXAEAXOXSQVSVBZYFCEFWOGXAHIJLMAFHTZXSXGOVTAGITZXSXGPVTAXPXSXGXQVTAXSXGWA
      XTXGWBWCZXJYCXBYBXCXMYCVCZXNWGWDWEWHXTSCDEFKWOGHIJLMAYLXSOVSZAYMXSPVSZAXP
      XSXQVSZAWNXSXRVSZAXSWBZNWFXTWOGUNWOYEUCXTCEFWOGHIJLMYPYQYRYTWISGWOUPUQZWJ
      XTSGYBYAYCUBZUGYEWRWOXTSGUUBYBYFUUBYBXCYCUBZYBYFYAXCYBYCYIWKYFXLYJUUCYBUC
      YKYNXJYCXBYBXCXMYOXNWLWDWEWHXTSCDEFWOKGHIJLMYPYQYRYTYSNWFUUAWJWMVEWM $.
  $}

  ${
    $d a b y I $.  $d a b c y ph $.  $d a b y R $.  $d a b c y Y $.
    $d a b y S $.
    prdsmndd.y $e |- Y = ( S Xs_ R ) $.
    prdsmndd.i $e |- ( ph -> I e. W ) $.
    prdsmndd.s $e |- ( ph -> S e. V ) $.
    prdsmndd.r $e |- ( ph -> R : I --> Mnd ) $.
    $( The product of a family of monoids is a monoid.  (Contributed by Stefan
       O'Rear, 10-Jan-2015.) $)
    prdsmndd $p |- ( ph -> Y e. Mnd ) $=
      ( va vy cfv wcel co wa cvv eqid adantr vb vc cbs cplusg c0g ccom eqidd cv
      elex syl cmnd simprl simprr prdsplusgcl 3impb cmpt wceq ffvelrnda adantlr
      wf w3a ad2antrr wfn ffn simplr1 simpr prdsbasprj simplr2 simplr3 syl13anc
      mndass prdsplusgfval oveq1d oveq2d mpteq2dva 3adantr3 simpr3 prdsplusgval
      3eqtr4d simpr1 simpr2 wral prdsidlem simpld simprd r19.21bi ismndd ) ALUA
      UBGUCNZGUDNZGUEBUFZAWHUGAWIUGALUHZWHOZUAUHZWHOZWKWMWIPZWHOZAWLWNQZQWHWIBC
      WKWMDRRGHWHSZWISZACROZWQACEOWTJCEUIUJZTADROZWQADFOXBIDFUIUJZTADUKBUTZWQKT
      AWLWNULAWLWNUMUNZUOAWLWNUBUHZWHOZVAZQZMDMUHZWONZXJXFNZXJBNZUDNZPZUPMDXJWK
      NZXJWMXFWIPZNZXNPZUPWOXFWIPWKXQWIPXIMDXOXSXIXJDOZQZXPXJWMNZXNPZXLXNPZXPYB
      XLXNPZXNPZXOXSYAXMUKOZXPXMUCNZOYBYHOXLYHOYDYFUQAXTYGXHADUKXJBKURUSYAWHBCW
      KDXJRRGHWRAWTXHXTXAVBZAXBXHXTXCVBZABDVCZXHXTAXDYKKDUKBVDUJZVBZWLWNXGAXTVE
      ZXIXTVFZVGYAWHBCWMDXJRRGHWRYIYJYMWLWNXGAXTVHZYOVGYAWHBCXFDXJRRGHWRYIYJYMW
      LWNXGAXTVIZYOVGYHXNXMXPYBXLYHSXNSVKVJYAXKYCXLXNYAWHWIBCWKWMDXJRRGHWRYIYJY
      MYNYPWSYOVLVMYAXRYEXPXNYAWHWIBCWMXFDXJRRGHWRYIYJYMYPYQWSYOVLVNVSVOXIMWHWI
      BCWOXFDRRGHWRAWTXHXATZAXBXHXCTZAYKXHYLTZAWLWNWPXGXEVPAWLWNXGVQZWSVRXIMWHW
      IBCWKXQDRRGHWRYRYSYTAWLWNXGVTXIWHWIBCWMXFDRRGHWRWSYRYSAXDXHKTAWLWNXGWAUUA
      UNWSVRVSAWJWHOZWJWKWIPWKUQZWKWJWIPWKUQZQZLWHWBZALWHWIBCDRRGWJHWRWSXAXCKWJ
      SWCZWDAWLQZUUCUUDAUUELWHAUUBUUFUUGWEWFZWDUUHUUCUUDUUIWEWG $.

    $( Zero in a product of monoids.  (Contributed by Stefan O'Rear,
       10-Jan-2015.) $)
    prds0g $p |- ( ph -> ( 0g o. R ) = ( 0g ` Y ) ) $=
      ( vb va cfv wcel co wceq wa cvv eqid c0g ccom cbs cv cplusg wral elex syl
      prdsidlem cmnd wrex prdsmndd mndid ismgmid mpbid eqcomd ) AGUANZUABUBZAUR
      GUCNZOURLUDZGUENZPUTQUTURVAPUTQRLUSUFRUQURQALUSVABCDSSGURHUSTZVATZACEOCSO
      JCEUGUHADFODSOIDFUGUHKURTUIALUSVAURMGUQVBUQTVCAGUJOMUDZUTVAPUTQUTVDVAPUTQ
      RLUSUFMUSUKABCDEFGHIJKULLMUSVAGVBVCUMUHUNUOUP $.
  $}

  ${
    $d x I $.  $d r x R $.  $d x V $.  $d r x .0. $.
    pwsmnd.y $e |- Y = ( R ^s I ) $.
    $( The structure power of a monoid is a monoid.  (Contributed by Mario
       Carneiro, 11-Jan-2015.) $)
    pwsmnd $p |- ( ( R e. Mnd /\ I e. V ) -> Y e. Mnd ) $=
      ( cmnd wcel wa csca cfv csn cxp cprds co eqid pwsval cvv simpr fvex a1i
      wf fconst6g adantr prdsmndd eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUIO
      PUHUJUIBQCUKUKOUFUGRUIQGUHAISTUFBFUJUAUGBAFUBUCUDUE $.

    pws0g.z $e |- .0. = ( 0g ` R ) $.
    $( Zero in a product of monoids.  (Contributed by Mario Carneiro,
       11-Jan-2015.) $)
    pws0g $p |- ( ( R e. Mnd /\ I e. V ) -> ( I X. { .0. } ) = ( 0g ` Y ) ) $=
      ( vx vr cmnd wcel c0g csn cxp csca cfv cvv a1i cmpt wceq wa ccom cprds co
      eqid simpr fvex wf fconst6g adantr prds0g cv elex ad2antrr fconstmpt fn0g
      wfn dffn5 sylib fveq2 syl6eqr fmptco syl6reqr pwsval fveq2d 3eqtr4d ) AJK
      ZBCKZUAZLBAMNZUBZAOPZVJUCUDZLPBEMNZDLPVIVJVLBQCVMVMUEVGVHUFVLQKVIAOUGRVGB
      JVJUHVHBAJUIUJUKVIVKHBESVNVIHIBQAIULZLPZEVJLVGAQKVHHULBKAJUMUNVJHBASTVIHB
      AUORVILQUQZLIQVPSTVQVIUPRIQLURUSVOATVPALPEVOALUTGVAVBHBEUOVCVIDVMLAVLBJCD
      FVLUEVDVEVF $.
  $}

  ${
    $d p q x y .+ $.  $d a b p q u v w x y z ph $.  $d a b p q u v w x y z U $.
    $d p q u x .0. $.  $d p q u v w B $.  $d a b p q u x y z F $.  $d p q R $.
    $d a b p q x y z V $.
    imasmnd.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasmnd.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasmnd.p $e |- .+ = ( +g ` R ) $.
    imasmnd.f $e |- ( ph -> F : V -onto-> B ) $.
    imasmnd.e $e |- ( ( ph /\ ( a e. V /\ b e. V ) /\ ( p e. V /\ q e. V ) )
      -> ( ( ( F ` a ) = ( F ` p ) /\ ( F ` b ) = ( F ` q ) )
        -> ( F ` ( a .+ b ) ) = ( F ` ( p .+ q ) ) ) ) $.
    ${
      imasmnd2.r $e |- ( ph -> R e. W ) $.
      imasmnd2.1 $e |- ( ( ph /\ x e. V /\ y e. V ) -> ( x .+ y ) e. V ) $.
      imasmnd2.2 $e |- ( ( ph /\ ( x e. V /\ y e. V /\ z e. V ) ) ->
        ( F ` ( ( x .+ y ) .+ z ) ) = ( F ` ( x .+ ( y .+ z ) ) ) ) $.
      imasmnd2.3 $e |- ( ph -> .0. e. V ) $.
      imasmnd2.4 $e |- ( ( ph /\ x e. V ) ->
        ( F ` ( .0. .+ x ) ) = ( F ` x ) ) $.
      imasmnd2.5 $e |- ( ( ph /\ x e. V ) ->
        ( F ` ( x .+ .0. ) ) = ( F ` x ) ) $.
      $( The image structure of a monoid is a monoid.  (Contributed by Mario
         Carneiro, 24-Feb-2015.) $)
      imasmnd2 $p |- ( ph -> ( U e. Mnd /\ ( F ` .0. ) = ( 0g ` U ) ) ) $=
        ( vu vv vw cmnd wcel cfv c0g wceq cplusg imasbas eqidd wf cv eqid 3expb
        cxp co caovclg imasaddf fovrn syl3an1 w3a wrex crn wfo eleq2d 3anbi123d
        forn syl wfn wb fofn fvelrnb bitr3d 3reeanv syl6bbr wa 3adant3r3 simpr3
        simpl imasaddval syl3anc simpr1 3adantr1 3eqtr4d oveq1d 3adant3r1 simp1
        wi oveq2d simp2 oveq12d simp3 syl5ibcom 3exp2 imp32 rexlimdv rexlimdvva
        eqeq12d sylbid imp fof ffvelrnd adantr simpr eqtrd id rexlimdva mpd3an3
        oveq2 oveq1 ismndd grpidd jca ) AHUKULLIUMZHUNUMUOAUHUIUJEHUPUMZHYBAEGH
        IJKQRTUBUQZAYCURZAEEVCEYCUSUHUTZEULZUIUTZEULZYFYHYCVDZEULAEGYCFHIJKMNOP
        TUAQRUBSYCVAZABCNUTMUTJJJFABUTZJULZCUTZJULZYLYNFVDZJULZUCVBVEZVFYFYHEEE
        YCVGVHAYGYIUJUTZEULZVIZYJYSYCVDZYFYHYSYCVDZYCVDZUOZAUUAYLIUMZYFUOZYNIUM
        ZYHUOZDUTZIUMZYSUOZVIZDJVJZCJVJBJVJZUUEAUUAUUGBJVJZUUICJVJZUULDJVJZVIZU
        UOAYFIVKZULZYHUUTULZYSUUTULZVIZUUAUUSAUVAYGUVBYIUVCYTAUUTEYFAJEIVLZUUTE
        UOTJEIVOVPZVMZAUUTEYHUVFVMAUUTEYSUVFVMVNAIJVQZUVDUUSVRAUVEUVHTJEIVSVPZU
        VHUVAUUPUVBUUQUVCUURBJYFIVTZCJYHIVTDJYSIVTVNVPWAUUGUUIUULBCDJJJWBWCAUUN
        UUEBCJJAYMYOWDWDUUMUUEDJAYMYOUUJJULZUUMUUEWPZWPAYMYOUVKUVLAYMYOUVKVIZWD
        ZUUFUUHYCVDZUUKYCVDZUUFUUHUUKYCVDZYCVDZUOUUMUUEUVNYPIUMZUUKYCVDZUUFYNUU
        JFVDZIUMZYCVDZUVPUVRUVNYPUUJFVDIUMZYLUWAFVDIUMZUVTUWCUDUVNAYQUVKUVTUWDU
        OAUVMWGZAYMYOYQUVKUCWEAYMYOUVKWFAEGYCFHIJYPUUJKMNOPTUAQRUBSYKWHWIUVNAYM
        UWAJULZUWCUWEUOUWFAYMYOUVKWJAYOUVKUWGYMANMYNUUJJJJFYRVEWKAEGYCFHIJYLUWA
        KMNOPTUAQRUBSYKWHWIWLUVNUVOUVSUUKYCAYMYOUVOUVSUOUVKAEGYCFHIJYLYNKMNOPTU
        AQRUBSYKWHWEWMUVNUVQUWBUUFYCAYOUVKUVQUWBUOYMAEGYCFHIJYNUUJKMNOPTUAQRUBS
        YKWHWNWQWLUUMUVPUUBUVRUUDUUMUVOYJUUKYSYCUUMUUFYFUUHYHYCUUGUUIUULWOZUUGU
        UIUULWRZWSUUGUUIUULWTZWSUUMUUFYFUVQUUCYCUWHUUMUUHYHUUKYSYCUWIUWJWSWSXFX
        AXBXCXDXEXGXHAJELIAUVEJEIUSTJEIXIVPUEXJZAYGYBYFYCVDZYFUOZAYGUUPUWMAUVAY
        GUUPUVGAUVHUVAUUPVRUVIUVJVPWAZAUUGUWMBJAYMWDZYBUUFYCVDZUUFUOUUGUWMUWOUW
        PLYLFVDIUMZUUFUWOALJULZYMUWPUWQUOAYMWGAUWRYMUEXKZAYMXLAEGYCFHIJLYLKMNOP
        TUAQRUBSYKWHWIUFXMUUGUWPUWLUUFYFUUFYFYBYCXQUUGXNZXFXAXOXGXHZAYGYFYBYCVD
        ZYFUOZAYGUUPUXCUWNAUUGUXCBJUWOUUFYBYCVDZUUFUOUUGUXCUWOUXDYLLFVDIUMZUUFA
        YMUWRUXDUXEUOUWSAEGYCFHIJYLLKMNOPTUAQRUBSYKWHXPUGXMUUGUXDUXBUUFYFUUFYFY
        BYCXRUWTXFXAXOXGXHZXSAUHEYCHYBYDYEUWKUXAUXFXTYA $.
    $}

    ${
      imasmnd.r $e |- ( ph -> R e. Mnd ) $.
      imasmnd.z $e |- .0. = ( 0g ` R ) $.
      $( The image structure of a monoid is a monoid.  (Contributed by Mario
         Carneiro, 24-Feb-2015.) $)
      imasmnd $p |- ( ph -> ( U e. Mnd /\ ( F ` .0. ) = ( 0g ` U ) ) ) $=
        ( wcel vx vy vz cmnd cv w3a co cbs cfv 3ad2ant1 simp2 wceq eleqtrd eqid
        simp3 mndcl syl3anc eleqtrrd wa adantr 3adant3r3 simpr3 mndass syl13anc
        fveq2d mndidcl syl eleq2d biimpa mndlid syl2anc mndrid imasmnd2 ) AUAUB
        UCBCDEFGUDHIJKLMNOPQRAUAUEZGTZUBUEZGTZUFZVNVPCUGZDUHUIZGVRDUDTZVNVTTZVP
        VTTZVSVTTAVOWAVQRUJVRVNGVTAVOVQUKAVOGVTULZVQNUJZUMZVRVPGVTAVOVQUOWEUMZV
        TCDVNVPVTUNZOUPUQWEURAVOVQUCUEZGTZUFZUSZVSWICUGZVNVPWICUGCUGZFWLWAWBWCW
        IVTTWMWNULAWAWKRUTAVOVQWBWJWFVAAVOVQWCWJWGVAWLWIGVTAVOVQWJVBAWDWKNUTUMV
        TCDVNVPWIWHOVCVDVEAHVTGAWAHVTTRVTDHWHSVFVGNURAVOUSZHVNCUGZVNFWOWAWBWPVN
        ULAWAVORUTZAVOWBAGVTVNNVHVIZVTCDVNHWHOSVJVKVEWOVNHCUGZVNFWOWAWBWSVNULWQ
        WRVTCDVNHWHOSVLVKVEVM $.
    $}
  $}

  ${
    $d a b p q B $.  $d a b p q F $.  $d a b p q R $.  $d a b p q U $.
    $d a b p q V $.
    imasmndf1.u $e |- U = ( F "s R ) $.
    imasmndf1.v $e |- V = ( Base ` R ) $.
    $( The image of a monoid under an injection is a monoid.  (Contributed by
       Mario Carneiro, 24-Feb-2015.) $)
    imasmndf1 $p |- ( ( F : V -1-1-> B /\ R e. Mnd ) -> U e. Mnd ) $=
      ( vq vp va vb wf1 cmnd wcel c0g cfv wceq a1i eqid cv crn cplusg cimas cbs
      wa co wf1o wfo f1f1orn adantr f1ofo syl f1ocpbl simpr imasmnd simpld ) EA
      DLZBMNZUEZCMNBOPZDPCOPQUSDUAZBUBPZBCDEUTHIJKCDBUCUFQUSFREBUDPQUSGRVBSUSEV
      ADUGZEVADUHUQVCUREADUIUJZEVADUKULUSJTKTITHTVBDEVAVDUMUQURUNUTSUOUP $.
  $}

  ${
    $d x y R $.  $d x y S $.
    xpsmnd.t $e |- T = ( R Xs. S ) $.
    $( The binary product of monoids is a monoid.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xpsmnd $p |- ( ( R e. Mnd /\ S e. Mnd ) -> T e. Mnd ) $=
      ( vx vy cmnd wcel cbs cfv cv csn ccda co ccnv csca eqid wf1o c2o cvv wceq
      wa cmpt2 cprds cimas simpl simpr xpsval cxp wf1 xpsff1o2 wb xpslem f1oeq3
      crn syl mpbii f1ocnv f1of1 3syl con0 2on a1i fvex xpscf biimpri imasmndf1
      wf prdsmndd syl2anc eqeltrd ) AGHZBGHZUBZCEFAIJZBIJZEKLFKLMNOUCZOZAPJZALB
      LMNOZUDNZUENZGVNEFABCWAVQVSGGVOVPDVOQZVPQZVLVMUFZVLVMUGZVQQZVSQZWAQZUHVNW
      AIJZVOVPUIZVRUJZWAGHWBGHVNWKWJVQRZWJWKVRRWLVNWKVQUOZVQRZWMEFVOVPVQWGUKVNW
      NWJUAWOWMULVNEFABCWAVQVSGGVOVPDWCWDWEWFWGWHWIUMWNWJWKVQUNUPUQWKWJVQURWJWK
      VRUSUTVNVTVSSTVAWAWISVAHVNVBVCVSTHVNAPVDVCSGVTVHVNGABVEVFVIWKWAWBVRWJWBQW
      JQVGVJVK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Monoid homomorphisms and submonoids
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c MndHom $.
  $c SubMnd $.

  $( Hom-set generator class for monoids. $)
  cmhm $a class MndHom $.

  $( Class function taking a monoid to its lattice of submonoids. $)
  csubmnd $a class SubMnd $.

  ${
    $d s t f x y $.
    $( A monoid homomorphism is a function on the base sets which preserves the
       binary operation and the identity.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    df-mhm $a |- MndHom = ( s e. Mnd , t e. Mnd |->
          { f e. ( ( Base ` t ) ^m ( Base ` s ) ) |
            ( A. x e. ( Base ` s ) A. y e. ( Base ` s )
                  ( f ` ( x ( +g ` s ) y ) ) =
                    ( ( f ` x ) ( +g ` t ) ( f ` y ) ) /\
              ( f ` ( 0g ` s ) ) = ( 0g ` t ) ) } ) $.

    $( A submonoid is a subset of a monoid which contains the identity and is
       closed under the operation.  Such subsets are themselves monoids with
       the same identity.  (Contributed by Mario Carneiro, 7-Mar-2015.) $)
    df-submnd $a |- SubMnd = ( s e. Mnd |-> { t e. ~P ( Base ` s ) |
            ( ( 0g ` s ) e. t /\
              A. x e. t A. y e. t ( x ( +g ` s ) y ) e. t ) } ) $.
  $}

  ${
    $d f s t .+^ $.  $d f s t x y B $.  $d f s t x y S $.  $d f s t x y T $.
    $d f s t .+ $.  $d f s t .0. $.  $d f s t C $.  $d f x y F $.
    $d f s t Y $.
    ismhm.b $e |- B = ( Base ` S ) $.
    ismhm.c $e |- C = ( Base ` T ) $.
    ismhm.p $e |- .+ = ( +g ` S ) $.
    ismhm.q $e |- .+^ = ( +g ` T ) $.
    ismhm.z $e |- .0. = ( 0g ` S ) $.
    ismhm.y $e |- Y = ( 0g ` T ) $.
    $( Property of a monoid homomorphism.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    ismhm $p |- ( F e. ( S MndHom T ) <-> ( ( S e. Mnd /\ T e. Mnd ) /\
          ( F : B --> C /\ A. x e. B A. y e. B ( F ` ( x .+ y ) ) =
                  ( ( F ` x ) .+^ ( F ` y ) ) /\ ( F ` .0. ) = Y ) ) ) $=
      ( co cfv wceq vs vt vf cmhm wcel cmnd wa wf wral w3a cplusg cbs cmap crab
      cv df-mhm elmpt2cl fveq2 syl6eqr oveqan12rd adantr oveqd fveq2d eqeqan12d
      c0g raleqbidv anbi12d rabeqbidv ovex rabex ovmpt2a cvv fvex eqeltri elmap
      eleq2d anbi1i fveq1 oveq12d eqeq12d 2ralbidv eqeq1d 3anass 3bitr4i syl6bb
      elrab biadan2 ) IGHUDRZUEZGUFUEHUFUEUGZCDIUHZAUOZBUOZERZISZWLISZWMISZFRZT
      ZBCUIACUIZKISZJTZUJZUAUBUFUFWLWMUAUOZUKSZRZUCUOZSZWLXGSZWMXGSZUBUOZUKSZRZ
      TZBXDULSZUIZAXOUIZXDVESZXGSZXKVESZTZUGZUCXKULSZXOUMRZUNZGHUDIABUBUCUAUPZU
      QWJWIIWNXGSZXIXJFRZTZBCUIZACUIZKXGSZJTZUGZUCDCUMRZUNZUEZXCWJWHYPIUAUBGHUF
      UFYEYPUDXDGTZXKHTZUGZYBYNUCYDYOYSYRYCDXOCUMYSYCHULSZDXKHULURMUSYRXOGULSZC
      XDGULURLUSZUTYTXQYKYAYMYTXPYJAXOCYRXOCTYSUUCVAZYTXNYIBXOCUUDYRYSXHYGXMYHY
      RXFWNXGYRXEEWLWMYRXEGUKSEXDGUKURNUSVBVCYSXLFXIXJYSXLHUKSFXKHUKUROUSVBVDVF
      VFYRYSXSYLXTJYRXRKXGYRXRGVESKXDGVEURPUSVCYSXTHVESJXKHVEURQUSVDVGVHYFYNUCY
      ODCUMVIVJVKVPIYOUEZWTXBUGZUGWKUUFUGYQXCUUEWKUUFDCIDUUAVLMHULVMVNCUUBVLLGU
      LVMVNVOVQYNUUFUCIYOXGITZYKWTYMXBUUGYIWSABCCUUGYGWOYHWRWNXGIVRUUGXIWPXJWQF
      WLXGIVRWMXGIVRVSVTWAUUGYLXAJKXGIVRWBVGWFWKWTXBWCWDWEWG $.
  $}

  ${
    $d f s t x y B $.  $d x y F $.  $d x y S $.  $d x y T $.
    $( Reverse closure of a monoid homomorphism.  (Contributed by Mario
       Carneiro, 7-Mar-2015.) $)
    mhmrcl1 $p |- ( F e. ( S MndHom T ) -> S e. Mnd ) $=
      ( vs vt vx vy vf cmnd cv cplusg cfv co wceq cbs wral c0g wa cmap crab
      cmhm df-mhm elmpt2cl1 ) DEIIFJZGJZDJZKLMHJZLUDUGLUEUGLEJZKLMNGUFOLZPFUIPU
      FQLUGLUHQLNRHUHOLUISMTABUACFGEHDUBUC $.

    $( Reverse closure of a monoid homomorphism.  (Contributed by Mario
       Carneiro, 7-Mar-2015.) $)
    mhmrcl2 $p |- ( F e. ( S MndHom T ) -> T e. Mnd ) $=
      ( vs vt vx vy vf cmnd cv cplusg cfv co wceq cbs wral c0g wa cmap crab
      cmhm df-mhm elmpt2cl2 ) DEIIFJZGJZDJZKLMHJZLUDUGLUEUGLEJZKLMNGUFOLZPFUIPU
      FQLUGLUHQLNRHUHOLUISMTABUACFGEHDUBUC $.

    mhmf.b $e |- B = ( Base ` S ) $.
    mhmf.c $e |- C = ( Base ` T ) $.
    $( A monoid homomorphism is a function.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    mhmf $p |- ( F e. ( S MndHom T ) -> F : B --> C ) $=
      ( vx vy cmhm co wcel cv cplusg cfv wceq wral c0g cmnd eqid wf w3a simprbi
      wa ismhm simp1d ) ECDJKLZABEUAZHMZIMZCNOZKEOUIEOUJEODNOZKPIAQHAQZCROZEODR
      OZPZUGCSLDSLUDUHUMUPUBHIABUKULCDEUOUNFGUKTULTUNTUOTUEUCUF $.
  $}

  ${
    $d x y B $.  $d w x y z C $.  $d f x y J $.  $d f x y L $.  $d f x y ph $.
    $d f w x y z K $.  $d f w x y z M $.
    mhmpropd.a $e |- ( ph -> B = ( Base ` J ) ) $.
    mhmpropd.b $e |- ( ph -> C = ( Base ` K ) ) $.
    mhmpropd.c $e |- ( ph -> B = ( Base ` L ) ) $.
    mhmpropd.d $e |- ( ph -> C = ( Base ` M ) ) $.
    mhmpropd.e $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` J ) y ) = ( x ( +g ` L ) y ) ) $.
    mhmpropd.f $e |- ( ( ph /\ ( x e. C /\ y e. C ) ) ->
        ( x ( +g ` K ) y ) = ( x ( +g ` M ) y ) ) $.
    $( Monoid homomorphism depends only on the monoidal attributes of
       structures.  (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by
       Mario Carneiro, 7-Nov-2015.) $)
    mhmpropd $p |- ( ph -> ( J MndHom K ) = ( L MndHom M ) ) $=
      ( co wcel wa cfv wceq vf vw vz cmhm cmnd cbs cv wf cplusg wral c0g w3a wb
      adantlr ffvelrn anim12dan ralrimivva oveq1 eqeq12d oveq2 cbvral2v rspc2va
      fveq2d sylib syl2anr anassrs 2ralbidva raleq raleqbi1dv adantr grpidpropd
      adantrl syl 3bitr3d anbi12d pm5.32da feq23d anbi1d 3bitr4g mndpropd bitrd
      3anass eqid ismhm eqrdv ) AUAFGUDPZHIUDPZAFUEQZGUEQZRZFUFSZGUFSZUAUGZUHZB
      UGZCUGZFUISZPZWMSZWOWMSZWPWMSZGUISZPZTZCWKUJZBWKUJZFUKSZWMSZGUKSZTZULZRZH
      UEQZIUEQZRZHUFSZIUFSZWMUHZWOWPHUISZPZWMSZWTXAIUISZPZTZCXPUJZBXPUJZHUKSZWM
      SZIUKSZTZULZRZWMWFQWMWGQAXLWJYKRYLAWJXKYKAWJRZWNXFXJRZRZXRYFYJRZRZXKYKYMD
      EWMUHZYNRYRYPRYOYQYMYRYNYPAWJYRYNYPUMAWJYRRZRZXFYFXJYJYTXDCDUJZBDUJZYDCDU
      JZBDUJZXFYFAYRUUBUUDUMWJAYRRZXDYDBCDDUUEWODQZWPDQZRZRWSYAXCYCAUUHWSYATYRA
      UUHRWRXTWMNVCUNAYRUUHXCYCTZYRUUHRWTEQZXAEQZRUBUGZUCUGZXBPZUULUUMYBPZTZUCE
      UJUBEUJZUUIAYRUUFUUJUUGUUKDEWOWMUODEWPWMUOUPAWOWPXBPZWOWPYBPZTZCEUJBEUJUU
      QAUUTBCEEOUQUUTUUPUULWPXBPZUULWPYBPZTBCUBUCEEWOUULTUURUVAUUSUVBWOUULWPXBU
      RWOUULWPYBURUSWPUUMTUVAUUNUVBUUOWPUUMUULXBUTWPUUMUULYBUTUSVAVDUUPUUIWTUUM
      XBPZWTUUMYBPZTUBUCWTXAEEUULWTTUUNUVCUUOUVDUULWTUUMXBURUULWTUUMYBURUSUUMXA
      TUVCXCUVDYCUUMXAWTXBUTUUMXAWTYBUTUSVBVEVFUSVGVLAUUBXFUMZYSADWKTZUVEJUUAXE
      BDWKXDCDWKVHVIVMVJAUUDYFUMZYSADXPTZUVGLUUCYEBDXPYDCDXPVHVIVMVJVNYTXHYHXIY
      IYTXGYGWMYTBCDFHAUVFYSJVJAUVHYSLVJAUUHWRXTTYSNUNVKVCYTBCEGIAEWLTYSKVJAEXQ
      TYSMVJAWOEQWPEQRUUTYSOUNVKUSVOVFVPYMYRWNYNAYRWNUMWJADEWKWLWMJKVQVJVRYMYRX
      RYPAYRXRUMWJADEXPXQWMLMVQVJVRVNWNXFXJWBXRYFYJWBVSVPAWJXOYKAWHXMWIXNABCDFH
      JLNVTABCEGIKMOVTVOVRWABCWKWLWQXBFGWMXIXGWKWCWLWCWQWCXBWCXGWCXIWCWDBCXPXQX
      SYBHIWMYIYGXPWCXQWCXSWCYBWCYGWCYIWCWDVSWE $.
  $}

  ${
    $d B x y $.  $d F x y $.  $d .+ x y $.  $d .+^ x y $.  $d S x y $.
    $d T x y $.  $d X x y $.  $d Y x y $.
    mhmlin.b $e |- B = ( Base ` S ) $.
    mhmlin.p $e |- .+ = ( +g ` S ) $.
    mhmlin.q $e |- .+^ = ( +g ` T ) $.
    $( A monoid homomorphism commutes with composition.  (Contributed by Mario
       Carneiro, 7-Mar-2015.) $)
    mhmlin $p |- ( ( F e. ( S MndHom T ) /\ X e. B /\ Y e. B ) ->
        ( F ` ( X .+ Y ) ) = ( ( F ` X ) .+^ ( F ` Y ) ) ) $=
      ( vx vy co wcel cfv wceq cv wral eqid cmhm wa cbs wf c0g cmnd w3a simprbi
      ismhm simp2d oveq1 fveq2d fveq2 oveq1d eqeq12d oveq2 oveq2d rspc2v 3impib
      syl5com ) FDEUANOZGAOZHAOZGHBNZFPZGFPZHFPZCNZQZVALRZMRZBNZFPZVJFPZVKFPZCN
      ZQZMASLASZVBVCUBVIVAAEUCPZFUDZVRDUEPZFPEUEPZQZVADUFOEUFOUBVTVRWCUGLMAVSBC
      DEFWBWAIVSTJKWATWBTUIUHUJVQVIGVKBNZFPZVFVOCNZQLMGHAAVJGQZVMWEVPWFWGVLWDFV
      JGVKBUKULWGVNVFVOCVJGFUMUNUOVKHQZWEVEWFVHWHWDVDFVKHGBUPULWHVOVGVFCVKHFUMU
      QUOURUTUS $.
  $}

  ${
    $d F x y $.  $d S x y $.  $d T x y $.
    mhm0.z $e |- .0. = ( 0g ` S ) $.
    mhm0.y $e |- Y = ( 0g ` T ) $.
    $( A monoid homorphism preserves zero.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    mhm0 $p |- ( F e. ( S MndHom T ) -> ( F ` .0. ) = Y ) $=
      ( vx vy cmhm co wcel cbs cfv cv cplusg wceq wral cmnd eqid wf w3a simprbi
      wa ismhm simp3d ) CABJKLZAMNZBMNZCUAZHOZIOZAPNZKCNUKCNULCNBPNZKQIUHRHUHRZ
      ECNDQZUGASLBSLUDUJUOUPUBHIUHUIUMUNABCDEUHTUITUMTUNTFGUEUCUF $.
  $}

  ${
    $d M m t x y $.  $d S t x y $.  $d s t x y $.
    $( Reverse closure for submonoids.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    submrcl $p |- ( S e. ( SubMnd ` M ) -> M e. Mnd ) $=
      ( vs vt vx vy csubmnd cfv wcel cdm cmnd cv c0g cplusg co wral wa cbs crab
      cpw df-submnd dmmptss elfvdm sseldi ) ABGHIGJKBCKCLZMHDLZIELFLUENHOUFIFUF
      PEUFPQDUERHTSGEFDCUAUBABGUCUD $.

    issubm.b $e |- B = ( Base ` M ) $.
    issubm.z $e |- .0. = ( 0g ` M ) $.
    issubm.p $e |- .+ = ( +g ` M ) $.
    $( Expand definition of a submonoid.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    issubm $p |- ( M e. Mnd -> ( S e. ( SubMnd ` M ) <->
          ( S C_ B /\ .0. e. S /\ A. x e. S A. y e. S ( x .+ y ) e. S ) ) ) $=
      ( vt vm wcel cfv c0g cv cplusg wral wa cbs cmnd csubmnd cpw crab wss wceq
      co w3a fveq2 pweqd eleq1d oveqd 2ralbidv anbi12d rabeqbidv df-submnd fvex
      pwex rabex fvmpt eleq2d eleq2 raleqbi1dv elrab sseq2i eleq1i oveqi 3anass
      2ralbii anbi12i elpw2 anbi1i 3bitr4ri bitri syl6bb ) FUAMZEFUBNZMEFONZKPZ
      MZAPZBPZFQNZUGZVSMZBVSRZAVSRZSZKFTNZUCZUDZMZECUEZGEMZWAWBDUGZEMZBERAERZUH
      ZVPVQWKELFLPZONZVSMZWAWBWSQNZUGZVSMZBVSRAVSRZSZKWSTNZUCZUDWKUAUBWSFUFZXFW
      HKXHWJXIXGWIWSFTUIUJXIXAVTXEWGXIWTVRVSWSFOUIUKXIXDWEABVSVSXIXCWDVSXIXBWCW
      AWBWSFQUIULUKUMUNUOABKLUPWHKWJWIFTUQZURUSUTVAWLEWJMZVREMZWDEMZBERZAERZSZS
      ZWRWHXPKEWJVSEUFVTXLWGXOVSEVRVBWFXNAVSEWEXMBVSEVSEWDVBVCVCUNVDWMWNWQSZSEW
      IUEZXPSWRXQWMXSXRXPCWIEHVEWNXLWQXOGVREIVFWPXMABEEWOWDEDWCWAWBJVGVFVIVJVJW
      MWNWQVHXKXSXPEWIXJVKVLVMVNVO $.
  $}

  ${
    $d B x y $.  $d H x y $.  $d M x y $.  $d S x y $.  $d .0. x y $.
    issubm2.b $e |- B = ( Base ` M ) $.
    issubm2.z $e |- .0. = ( 0g ` M ) $.
    issubm2.h $e |- H = ( M |`s S ) $.
    $( Submonoids are subsets that are also monoids with the same zero.
       (Contributed by Mario Carneiro, 7-Mar-2015.) $)
    issubm2 $p |- ( M e. Mnd -> ( S e. ( SubMnd ` M ) <->
          ( S C_ B /\ .0. e. S /\ H e. Mnd ) ) ) $=
      ( vx vy cmnd wcel csubmnd cfv wss cv wral w3a wa df-3an cplusg co eqid wb
      issubm issubmnd bicomd 3expb pm5.32da 3bitr4g bitrd ) DKLZBDMNLBAOZEBLZIP
      JPDUANZUBBLJBQIBQZRZUMUNCKLZRZIJAUOBDEFGUOUCZUEULUMUNSZUPSVAURSUQUSULVAUP
      URULUMUNUPURUDULUMUNRURUPIJAUOBDCEFUTGHUFUGUHUIUMUNUPTUMUNURTUJUK $.
  $}

  ${
    submss.b $e |- B = ( Base ` M ) $.
    $( Submonoids are subsets of the base set.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    submss $p |- ( S e. ( SubMnd ` M ) -> S C_ B ) $=
      ( csubmnd cfv wcel wss c0g cress co cmnd w3a submrcl eqid issubm2 syl ibi
      wb simp1d ) BCEFGZBAHZCIFZBGZCBJKZLGZUAUBUDUFMZUACLGUAUGSBCNABUECUCDUCOUE
      OPQRT $.

    $( Every monoid is trivially a submonoid of itself.  (Contributed by Stefan
       O'Rear, 15-Aug-2015.) $)
    submid $p |- ( M e. Mnd -> B e. ( SubMnd ` M ) ) $=
      ( cmnd wcel csubmnd cfv wss c0g cress co ssid eqid mndidcl ressid eqeltrd
      a1i id issubm2 mpbir3and ) BDEZABFGEAAHZBIGZAEBAJKZDEUBUAALQABUCCUCMZNUAU
      DBDABDCOUARPAAUDBUCCUEUDMST $.
  $}

  ${
    subm0cl.z $e |- .0. = ( 0g ` M ) $.
    $( Submonoids contain zero.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    subm0cl $p |- ( S e. ( SubMnd ` M ) -> .0. e. S ) $=
      ( csubmnd cfv wcel cbs wss cress co cmnd w3a submrcl eqid issubm2 syl ibi
      wb simp2d ) ABEFGZABHFZIZCAGZBAJKZLGZUAUCUDUFMZUABLGUAUGSABNUBAUEBCUBODUE
      OPQRT $.
  $}

  ${
    $d M x y $.  $d .+ x y $.  $d S x y $.  $d X x y $.  $d Y y $.
    submcl.p $e |- .+ = ( +g ` M ) $.
    $( Submonoids are closed under the monoid operation.  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    submcl $p |- ( ( S e. ( SubMnd ` M ) /\ X e. S /\ Y e. S ) ->
        ( X .+ Y ) e. S ) $=
      ( vx vy csubmnd cfv wcel co wa cv wral cbs wss c0g w3a eqid wb issubm syl
      cmnd submrcl ibi simp3d proplem2 sylan2 ancoms 3impb ) BCIJKZDBKZEBKZDEAL
      BKZUMUNMZULUOULUPGNHNALBKHBOGBOZUOULBCPJZQZCRJZBKZUQULUSVAUQSZULCUDKULVBU
      ABCUEGHURABCUTURTUTTFUBUCUFUGGHBBBADEUHUIUJUK $.
  $}

  ${
    submmnd.h $e |- H = ( M |`s S ) $.
    $( Submonoids are themselves monoids under the given operation.
       (Contributed by Mario Carneiro, 7-Mar-2015.) $)
    submmnd $p |- ( S e. ( SubMnd ` M ) -> H e. Mnd ) $=
      ( csubmnd cfv wcel cbs wss c0g cmnd w3a wb submrcl issubm2 syl ibi simp3d
      eqid ) ACEFGZACHFZIZCJFZAGZBKGZTUBUDUELZTCKGTUFMACNUAABCUCUASUCSDOPQR $.

    $( The base set of a submonoid.  (Contributed by Stefan O'Rear,
       15-Jun-2015.) $)
    submbas $p |- ( S e. ( SubMnd ` M ) -> S = ( Base ` H ) ) $=
      ( csubmnd cfv wcel cbs wss wceq eqid submss ressbas2 syl ) ACEFGACHFZIABH
      FJOACOKZLAOBCDPMN $.

    subm0.z $e |- .0. = ( 0g ` M ) $.
    $( Submonoids have the same identity.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    subm0 $p |- ( S e. ( SubMnd ` M ) -> .0. = ( 0g ` H ) ) $=
      ( csubmnd cfv wcel cmnd cbs wss wceq submrcl submmnd eqid subm0cl submnd0
      c0g submss syl22anc ) ACGHICJIBJIACKHZLDAIDBSHMACNABCEOUBACUBPZTACDFQUBAC
      BDUCFERUA $.
  $}

  ${
    subsubm.h $e |- H = ( G |`s S ) $.
    $( A submonoid of a submonoid is a submonoid.  (Contributed by Mario
       Carneiro, 21-Jun-2015.) $)
    subsubm $p |- ( S e. ( SubMnd ` G ) -> ( A e. ( SubMnd ` H ) <->
      ( A e. ( SubMnd ` G ) /\ A C_ S ) ) ) $=
      ( csubmnd cfv wcel wss cbs c0g cress cmnd eqid adantl wceq adantr submmnd
      wa co submss submbas sseqtr4d sstrd subm0cl eqeltrd oveq1i ressabs syl5eq
      subm0 syldan eqeltrrd w3a wb submrcl issubm2 syl mpbir3and simprr sseqtrd
      jca ad2antrl adantrl impbida ) BCFGZHZADFGHZAVEHZABIZSZVFVGSZVHVIVKVHACJG
      ZIZCKGZAHZCALTZMHZVKABVLVKADJGZBVGAVRIZVFVRADVRNZUAOVFBVRPZVGBDCEUBZQUCZV
      FBVLIVGVLBCVLNZUAQUDVKVNDKGZAVFVNWEPZVGBDCVNEVNNZUJZQVGWEAHZVFADWEWENZUEO
      UFVKDALTZVPMVFVGVIWKVPPZWCVFVISWKCBLTZALTVPDWMALEUGBACVEUHUIZUKVGWKMHZVFA
      WKDWKNZROULVKCMHZVHVMVOVQUMUNVFWQVGBCUOQVLAVPCVNWDWGVPNZUPUQURWCVAVFVJSZV
      GVSWIWOWSABVRVFVHVIUSVFWAVJWBQUTWSVNWEAVFWFVJWHQVHVOVFVIACVNWGUEVBULWSWKV
      PMVFVIWLVHWNVCVHVQVFVIAVPCWRRVBUFWSDMHZVGVSWIWOUMUNVFWTVJBDCERQVRAWKDWEVT
      WJWPUPUQURVD $.
  $}

  ${
    $d x y B $.  $d x y M $.  $d x y N $.  $d x y .0. $.
    0mhm.z $e |- .0. = ( 0g ` N ) $.
    0mhm.b $e |- B = ( Base ` M ) $.
    $( The constant zero linear function between two monoids.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    0mhm $p |- ( ( M e. Mnd /\ N e. Mnd ) ->
        ( B X. { .0. } ) e. ( M MndHom N ) ) $=
      ( vx vy cmnd wcel wa cfv cv cplusg co wceq c0g eqid syl fvconst2 cbs wral
      csn cxp wf w3a cmhm id mndidcl adantl fconst6g simpr mndlid eqcomd adantr
      syl2anc mndcl 3expb adantlr cvv fvex eqeltri oveqan12d 3eqtr4d ralrimivva
      3jca ismhm sylanbrc ) BIJZCIJZKZVKACUALZADUCUDZUEZGMZHMZBNLZOZVMLZVOVMLZV
      PVMLZCNLZOZPZHAUBGAUBZBQLZVMLDPZUFVMBCUGOJVKUHVKVNWEWGVKDVLJZVNVJWHVIVLCD
      VLRZEUIUJZADVLUKSVKWDGHAAVKVOAJZVPAJZKZKZDDDWBOZVSWCVKDWOPZWMVKVJWHWPVIVJ
      ULWJVJWHKWODVLWBCDDWIWBRZEUMUNUPUOWNVRAJZVSDPVIWMWRVJVIWKWLWRAVQBVOVPFVQR
      ZUQURUSADVRDCQLUTECQVAVBZTSWMWCWOPVKWKWLVTDWADWBADVOWTTADVPWTTVCUJVDVEVKW
      FAJZWGVIXAVJABWFFWFRZUIUOADWFWTTSVFGHAVLVQWBBCVMDWFFWIWSWQXBEVGVH $.
  $}

  ${
    $d F x y $.  $d S x y $.  $d T x y $.  $d U x y $.  $d V x y $.
    $d X x y $.
    resmhm.u $e |- U = ( S |`s X ) $.
    $( Restriction of a monoid homomorphism to a submonoid is a homomorphism.
       (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    resmhm $p |- ( ( F e. ( S MndHom T ) /\ X e. ( SubMnd ` S ) ) ->
        ( F |` X ) e. ( U MndHom T ) ) $=
      ( vx vy co wcel cfv wa cbs wf cplusg wceq wral eqid adantl fvres cmhm c0g
      csubmnd cmnd cres w3a mhmrcl2 submmnd anim12ci wss submss fssres ressbas2
      cv mhmf syl2an syl feq2d mpbid simpll simprl sseldd simprr mhmlin syl3anc
      ad2antlr submcl 3expb adantll oveqan12d ralrimivva ressplusg oveqd fveq2d
      3eqtr4d eqeq1d raleqbidv subm0cl subm0 mhm0 adantr 3eqtr3d ismhm sylanbrc
      3jca ) DABUAIJZEAUCKZJZLZCUDJZBUDJZLCMKZBMKZDEUEZNZGUNZHUNZCOKZIZWNKZWPWN
      KZWQWNKZBOKZIZPZHWLQZGWLQZCUBKZWNKZBUBKZPZUFWNCBUAIJWFWKWHWJABDUGECAFUHUI
      WIWOXGXKWIEWMWNNZWOWFAMKZWMDNEXMUJZXLWHXMWMABDXMRZWMRZUOXMEAXOUKZXMWMEDUL
      UPWIEWLWMWNWIXNEWLPWHXNWFXQSEXMCAFXOUMUQZURUSWIWPWQAOKZIZWNKZXDPZHEQZGEQX
      GWIYBGHEEWIWPEJZWQEJZLZLZXTDKZWPDKZWQDKZXCIZYAXDYGWFWPXMJWQXMJYHYKPWFWHYF
      UTYGEXMWPWHXNWFYFXQVFZWIYDYEVAVBYGEXMWQYLWIYDYEVCVBXMXSXCABDWPWQXOXSRZXCR
      ZVDVEYGXTEJZYAYHPWHYFYOWFWHYDYEYOXSEAWPWQYMVGVHVIXTEDTUQYFXDYKPWIYDYEXAYI
      XBYJXCWPEDTWQEDTVJSVOVKWIYCXFGEWLXRWIYBXEHEWLXRWIYAWTXDWIXTWSWNWIXSWRWPWQ
      WHXSWRPWFEXSACWGFYMVLSVMVNVPVQVQUSWIAUBKZWNKZYPDKZXIXJWIYPEJZYQYRPWHYSWFE
      AYPYPRZVRSYPEDTUQWIYPXHWNWHYPXHPWFECAYPFYTVSSVNWFYRXJPWHABDXJYPYTXJRZVTWA
      WBWEGHWLWMWRXCCBWNXJXHWLRXPWRRYNXHRUUAWCWD $.
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y T $.  $d x y U $.  $d x y X $.
    resmhm2.u $e |- U = ( T |`s X ) $.
    $( One direction of ~ resmhm2b .  (Contributed by Mario Carneiro,
       18-Jun-2015.) $)
    resmhm2 $p |- ( ( F e. ( S MndHom U ) /\ X e. ( SubMnd ` T ) ) ->
      F e. ( S MndHom T ) ) $=
      ( vx vy cmhm co wcel cfv wa cmnd cbs wf cplusg wceq c0g eqid csubmnd wral
      cv w3a mhmrcl1 submrcl anim12i mhmf submbas submss eqsstr3d syl2an mhmlin
      wss 3expb adantlr ressplusg ad2antlr oveqd eqtr4d ralrimivva adantr subm0
      fss mhm0 adantl 3jca ismhm sylanbrc ) DACIJKZEBUALZKZMZANKZBNKZMAOLZBOLZD
      PZGUCZHUCZAQLZJDLZVSDLZVTDLZBQLZJZRZHVPUBGVPUBZASLZDLZBSLZRZUDDABIJKVJVNV
      LVOACDUEEBUFUGVMVRWHWLVJVPCOLZDPWMVQUNVRVLVPWMACDVPTZWMTUHVLWMEVQECBFUIVQ
      EBVQTZUJUKVPWMVQDVDULVMWGGHVPVPVMVSVPKZVTVPKZMZMZWBWCWDCQLZJZWFVJWRWBXARZ
      VLVJWPWQXBVPWAWTACDVSVTWNWATZWTTUMUOUPWSWEWTWCWDVLWEWTRVJWREWEBCVKFWETZUQ
      URUSUTVAVMWJCSLZWKVJWJXERVLACDXEWIWITZXETVEVBVLWKXERVJECBWKFWKTZVCVFUTVGG
      HVPVQWAWEABDWKWIWNWOXCXDXFXGVHVI $.

    $( Restriction of the codomain of a homomorphism.  (Contributed by Mario
       Carneiro, 18-Jun-2015.) $)
    resmhm2b $p |- ( ( X e. ( SubMnd ` T ) /\ ran F C_ X ) ->
      ( F e. ( S MndHom T ) <-> F e. ( S MndHom U ) ) ) $=
      ( vx vy cfv wcel wa co cbs wf cplusg wceq c0g adantl ad2antrr eqid crn cv
      csubmnd wss cmhm cmnd w3a mhmrcl1 submmnd jca wfn ffn syl simplr sylanbrc
      wral mhmf df-f wb submbas feq3 mpbid mhmlin 3expb adantll ressplusg oveqd
      ad3antrrr eqtrd ralrimivva mhm0 subm0 3jca resmhm2 ancoms adantlr impbida
      ismhm ) EBUCIZJZDUAEUDZKZDABUELJZDACUELJZWBWCKZAUFJZCUFJZKAMIZCMIZDNZGUBZ
      HUBZAOIZLDIZWKDIZWLDIZCOIZLZPZHWHUPGWHUPZAQIZDIZCQIZPZUGWDWEWFWGWCWFWBABD
      UHRVTWGWAWCECBFUISUJWEWJWTXDWEWHEDNZWJWEDWHUKZWAXEWEWHBMIZDNZXFWCXHWBWHXG
      ABDWHTZXGTUQRWHXGDULUMVTWAWCUNWHEDURUOWEEWIPZXEWJUSVTXJWAWCECBFUTSEWIWHDV
      AUMVBWEWSGHWHWHWEWKWHJZWLWHJZKZKZWNWOWPBOIZLZWRWCXMWNXPPZWBWCXKXLXQWHWMXO
      ABDWKWLXIWMTZXOTZVCVDVEXNXOWQWOWPVTXOWQPWAWCXMEXOBCVSFXSVFVHVGVIVJWEXBBQI
      ZXCWCXBXTPWBABDXTXAXATZXTTZVKRVTXTXCPWAWCECBXTFYBVLSVIVMGHWHWIWMWQACDXCXA
      XIWITXRWQTYAXCTVRUOVTWDWCWAWDVTWCABCDEFVNVOVPVQ $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y S $.  $d x y T $.  $d x y U $.
    $( The composition of monoid homomorphisms is a homomorphism.  (Contributed
       by Mario Carneiro, 12-Jun-2015.) $)
    mhmco $p |- ( ( F e. ( T MndHom U ) /\ G e. ( S MndHom T ) ) ->
        ( F o. G ) e. ( S MndHom U ) ) $=
      ( vx vy cmhm co wcel wa cbs cfv wf cplusg wceq c0g eqid fvco3 syl2anc w3a
      cmnd ccom cv wral mhmrcl2 mhmrcl1 anim12ci mhmf fco syl2an mhmlin adantll
      3expb fveq2d simpll ad2antlr simprl ffvelrnd simprr syl3anc eqtrd oveq12d
      adantl mndcl sylan 3eqtr4d ralrimivva mndidcl syl mhm0 adantr 3eqtrd 3jca
      ismhm sylanbrc ) DBCHIJZEABHIJZKZAUBJZCUBJZKALMZCLMZDEUCZNZFUDZGUDZAOMZIZ
      WDMZWFWDMZWGWDMZCOMZIZPZGWBUEFWBUEZAQMZWDMZCQMZPZUAWDACHIJVQWAVRVTBCDUFAB
      EUGZUHVSWEWPWTVQBLMZWCDNWBXBENZWEVRXBWCBCDXBRZWCRZUIWBXBABEWBRZXDUIZWBXBW
      CDEUJUKVSWOFGWBWBVSWFWBJZWGWBJZKZKZWIEMZDMZWFEMZDMZWGEMZDMZWMIZWJWNXKXMXN
      XPBOMZIZDMZXRXKXLXTDVRXJXLXTPZVQVRXHXIYBWBWHXSABEWFWGXFWHRZXSRZULUNUMUOXK
      VQXNXBJXPXBJYAXRPVQVRXJUPXKWBXBWFEVRXCVQXJXGUQZVSXHXIURZUSXKWBXBWGEYEVSXH
      XIUTZUSXBXSWMBCDXNXPXDYDWMRZULVAVBXKXCWIWBJZWJXMPYEVSVTXJYIVRVTVQXAVDZVTX
      HXIYIWBWHAWFWGXFYCVEUNVFWBXBWIDESTXKWKXOWLXQWMXKXCXHWKXOPYEYFWBXBWFDESTXK
      XCXIWLXQPYEYGWBXBWGDESTVCVGVHVSWRWQEMZDMZBQMZDMZWSVSXCWQWBJZWRYLPVRXCVQXG
      VDVSVTYOYJWBAWQXFWQRZVIVJWBXBWQDESTVSYKYMDVRYKYMPVQABEYMWQYPYMRZVKVDUOVQY
      NWSPVRBCDWSYMYQWSRZVKVLVMVNFGWBWCWHWMACWDWSWQXFXEYCYHYPYRVOVP $.
  $}

  ${
    $d F x y z $.  $d M x y z $.  $d N x y z $.  $d V x z $.  $d X x y z $.
    $( The homomorphic image of a submonoid is a submonoid.  (Contributed by
       Mario Carneiro, 10-Mar-2015.) $)
    mhmima $p |- ( ( F e. ( M MndHom N ) /\ X e. ( SubMnd ` M ) ) ->
      ( F " X ) e. ( SubMnd ` N ) ) $=
      ( vx vy vz co wcel cfv wa wss cv wral eqid adantr syl wceq syl3anc wb cbs
      cmhm csubmnd cima c0g cplusg crn imassrn wf mhmf frn syl5ss submss adantl
      wfn ffn subm0cl fnfvima eqeltrrd simpll simprl sseldd simprr mhmlin 3expb
      submcl adantll anassrs ralrimiva oveq2 eleq1d ralima syl2anc mpbird oveq1
      mhm0 ralbidv cmnd w3a mhmrcl2 issubm mpbir3and ) ABCUBHIZDBUCJIZKZADUDZCU
      CJIZWFCUAJZLZCUEJZWFIZEMZFMZCUFJZHZWFIZFWFNZEWFNZWEWFAUGZWHADUHWEBUAJZWHA
      UIZWSWHLWCXAWDWTWHBCAWTOZWHOZUJPZWTWHAUKQULWEBUEJZAJZWJWFWCXFWJRWDBCAWJXE
      XEOZWJOZVPPWEAWTUOZDWTLZXEDIZXFWFIWEXAXIXDWTWHAUPQZWDXJWCWTDBXBUMUNZWDXKW
      CDBXEXGUQUNWTDAXEURSUSWEWRGMZAJZWMWNHZWFIZFWFNZGDNZWEXRGDWEXNDIZKZXRXOWLA
      JZWNHZWFIZEDNZYAYDEDWEXTWLDIZYDWEXTYFKZKZXNWLBUFJZHZAJZYCWFYHWCXNWTIWLWTI
      YKYCRWCWDYGUTYHDWTXNWEXJYGXMPZWEXTYFVAVBYHDWTWLYLWEXTYFVCVBWTYIWNBCAXNWLX
      BYIOZWNOZVDSYHXIXJYJDIZYKWFIWEXIYGXLPYLWDYGYOWCWDXTYFYOYIDBXNWLYMVFVEVGWT
      DAYJURSUSVHVIWEXRYETZXTWEXIXJYPXLXMXQYDFEWTDAWMYBRXPYCWFWMYBXOWNVJVKVLVMP
      VNVIWEXIXJWRXSTXLXMWQXREGWTDAWLXORZWPXQFWFYQWOXPWFWLXOWMWNVOVKVQVLVMVNWEC
      VRIZWGWIWKWRVSTWCYRWDBCAVTPEFWHWNWFCWJXCXHYNWAQWB $.
  $}

  ${
    $d F x y z $.  $d G x y z $.  $d S x y z $.  $d T x y $.  $d V x y $.
    $( The equalizer of two monoid homomorphisms is a submonoid.  (Contributed
       by Stefan O'Rear, 7-Mar-2015.)  (Revised by Mario Carneiro,
       6-May-2015.) $)
    mhmeql $p |- ( ( F e. ( S MndHom T ) /\ G e. ( S MndHom T ) ) ->
        dom ( F i^i G ) e. ( SubMnd ` S ) ) $=
      ( vz vx vy co wcel wa cfv wceq eqid adantr syl wral eqtr4d fveq2 eqeq12d
      cv cmhm cin cdm cbs crab csubmnd wfn wf ffn adantl fndmin syl2anc wss c0g
      mhmf cplusg a1i cmnd mhmrcl1 mndidcl mhm0 elrab sylanbrc ad2antrr simplrl
      ssrab2 simprl mndcl syl3anc simplll mhmlin simpllr simplrr simprr oveq12d
      wi expr ralrimiva ralrab sylibr w3a wb issubm mpbir3and eqeltrd ) CABUAHZ
      IZDWFIZJZCDUBUCZETZCKZWKDKZLZEAUDKZUEZAUFKZWICWOUGZDWOUGZWJWPLWIWOBUDKZCU
      HZWRWGXAWHWOWTABCWOMZWTMZUONWOWTCUIOWIWOWTDUHZWSWHXDWGWOWTABDXBXCUOUJWOWT
      DUIOEWOCDUKULWIWPWQIZWPWOUMZAUNKZWPIZFTZGTZAUPKZHZWPIZGWPPZFWPPZXFWIWNEWO
      VFUQWIXGWOIZXGCKZXGDKZLZXHWIAURIZXPWGXTWHABCUSNZWOAXGXBXGMZUTOWIXQBUNKZXR
      WGXQYCLWHABCYCXGYBYCMZVANWHXRYCLWGABDYCXGYBYDVAUJQWNXSEXGWOWKXGLWLXQWMXRW
      KXGCRWKXGDRSVBVCWIXICKZXIDKZLZXNVPZFWOPXOWIYHFWOWIXIWOIZYGXNWIYIYGJZJZXJC
      KZXJDKZLZXMVPZGWOPXNYKYOGWOYKXJWOIZYNXMYKYPYNJZJZXLWOIZXLCKZXLDKZLZXMYRXT
      YIYPYSWIXTYJYQYAVDWIYIYGYQVEZYKYPYNVGZWOXKAXIXJXBXKMZVHVIYRYTYEYLBUPKZHZU
      UAYRWGYIYPYTUUGLWGWHYJYQVJUUCUUDWOXKUUFABCXIXJXBUUEUUFMZVKVIYRUUAYFYMUUFH
      ZUUGYRWHYIYPUUAUUILWGWHYJYQVLUUCUUDWOXKUUFABDXIXJXBUUEUUHVKVIYRYEYFYLYMUU
      FWIYIYGYQVMYKYPYNVNVOQQWNUUBEXLWOWKXLLWLYTWMUUAWKXLCRWKXLDRSVBVCVQVRWNYNX
      MGEWOWKXJLWLYLWMYMWKXJCRWKXJDRSVSVTVQVRWNYGXNFEWOWKXILWLYEWMYFWKXICRWKXID
      RSVSVTWIXTXEXFXHXOWAWBYAFGWOXKWPAXGXBYBUUEWCOWDWE $.
  $}

  ${
    $d B s x y z $.  $d G s x y z $.
    submacs.b $e |- B = ( Base ` G ) $.
    $( Submonoids are an algebraic closure system.  (Contributed by Stefan
       O'Rear, 22-Aug-2015.) $)
    submacs $p |- ( G e. Mnd -> ( SubMnd ` G ) e. ( ACS ` B ) ) $=
      ( vs vx vy cmnd wcel csubmnd cfv c0g cv cplusg wral crab eqid cvv sylancr
      wa cbs cpw cacs cab wss w3a issubm vex elpw anbi1i 3anass syl6bbr abbi2dv
      co bitr4i df-rab syl6eqr cin cmre fvex eqeltri mreacs mp1i mndidcl acsfn0
      inrab mndcl 3expb ralrimivva acsfn2 mreincl syl3anc syl5eqelr eqeltrd ) B
      GHZBIJZBKJZDLZHZELZFLZBMJZUMZVQHFVQNEVQNZSZDAUAZOZAUBJZVNVOVQWEHZWDSZDUCW
      FVNWIDVOVNVQVOHVQAUDZVRWCUEZWIEFAWAVQBVPCVPPZWAPZUFWIWJWDSWKWHWJWDVQADUGU
      HUIWJVRWCUJUNUKULWDDWEUOUPVNWFVRDWEOZWCDWEOZUQZWGVRWCDWEVEVNWGWEURJHZWNWG
      HZWOWGHZWPWGHAQHZWQVNABTJQCBTUSUTZQAVAVBVNWTVPAHWRXAABVPCWLVCVPQADVDRVNWT
      WBAHZFANEANWSXAVNXBEFAAVNVSAHVTAHXBAWABVSVTCWMVFVGVHWBQADEFVIRWNWOWGWEVJV
      KVLVM $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z ph $.  $d x y z R $.  $d x y z Y $.
    prdspjmhm.y $e |- Y = ( S Xs_ R ) $.
    prdspjmhm.b $e |- B = ( Base ` Y ) $.
    prdspjmhm.i $e |- ( ph -> I e. V ) $.
    prdspjmhm.s $e |- ( ph -> S e. X ) $.
    prdspjmhm.r $e |- ( ph -> R : I --> Mnd ) $.
    prdspjmhm.a $e |- ( ph -> A e. I ) $.
    $( A projection from a product of monoids to one of the factors is a monoid
       homomorphism.  (Contributed by Mario Carneiro, 6-May-2015.) $)
    prdspjmhm $p |- ( ph ->
      ( x e. B |-> ( x ` A ) ) e. ( Y MndHom ( R ` A ) ) ) $=
      ( cmnd wcel cfv adantr vy vz wa cbs cv cmpt cplusg wceq wral c0g w3a cmhm
      wf prdsmndd ffvelrnd jca wfn ffn syl simpr prdsbasprj fmptd simprl simprr
      co eqid prdsplusgfval mndcl 3expb sylan fveq1 fvex fvmpt oveqan12d adantl
      3eqtr4d ralrimivva ccom mndidcl prds0g fveq1d fvco3 syl2anc 3eqtr2d ismhm
      3syl 3jca sylanbrc ) AJQRZCESZQRZUCDWJUDSZBDCBUEZSZUFZUMZUAUEZUBUEZJUGSZV
      EZWOSZWQWOSZWRWOSZWJUGSZVEZUHZUBDUIUADUIZJUJSZWOSZWJUJSZUHZUKWOJWJULVERAW
      IWKAEFGIHJKMNOUNZAGQCEOPUOUPAWPXGXKABDWNWLWOAWMDRZUCDEFWMGCIHJKLAFIRZXMNT
      AGHRZXMMTAEGUQZXMAGQEUMZXPOGQEURUSZTAXMUTACGRZXMPTVAWOVFZVBAXFUAUBDDAWQDR
      ZWRDRZUCZUCZCWTSZCWQSZCWRSZXDVEZXAXEYDDWSEFWQWRGCIHJKLAXNYCNTAXOYCMTAXPYC
      XRTAYAYBVCAYAYBVDWSVFZAXSYCPTVGYDWTDRZXAYEUHAWIYCYJXLWIYAYBYJDWSJWQWRLYIV
      HVIVJBWTWNYEDWOCWMWTVKXTCWTVLVMUSYCXEYHUHAYAYBXBYFXCYGXDBWQWNYFDWOCWMWQVK
      XTCWQVLVMBWRWNYGDWOCWMWRVKXTCWRVLVMVNVOVPVQAXICXHSZCUJEVRZSZXJAWIXHDRXIYK
      UHXLDJXHLXHVFZVSBXHWNYKDWOCWMXHVKXTCXHVLVMWFACYLXHAEFGIHJKMNOVTWAAXQXSYMX
      JUHOPGQCUJEWBWCWDWGUAUBDWLWSXDJWJWOXJXHLWLVFYIXDVFYNXJVFWEWH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x I $.  $d x R $.  $d x V $.
    pwspjmhm.y $e |- Y = ( R ^s I ) $.
    pwspjmhm.b $e |- B = ( Base ` Y ) $.
    $( A projection from a product of monoids to one of the factors is a monoid
       homomorphism.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    pwspjmhm $p |- ( ( R e. Mnd /\ I e. V /\ A e. I ) ->
        ( x e. B |-> ( x ` A ) ) e. ( Y MndHom R ) ) $=
      ( cmnd wcel csca cfv co cbs cmpt cmhm cvv eqid wceq w3a csn cprds cv fvex
      cxp simp2 a1i wf fconst6g 3ad2ant1 prdspjmhm pwsval 3adant3 fveq2d syl5eq
      simp3 mpteq1d fvconst2g 3adant2 eqcomd oveq12d 3eltr4d ) DJKZEFKZBEKZUAZA
      DLMZEDUBUFZUCNZOMZBAUDMZPVJBVIMZQNACVLPGDQNVGABVKVIVHEFRVJVJSVKSVDVEVFUGV
      HRKVGDLUEUHVDVEEJVIUIVFEDJUJUKVDVEVFUQULVGACVKVLVGCGOMVKIVGGVJOVDVEGVJTVF
      DVHEJFGHVHSUMUNZUOUPURVGGVJDVMQVNVGVMDVDVFVMDTVEEDBJUSUTVAVBVC $.
  $}

  ${
    $d Y x a b $.  $d R x a b $.  $d I x a b $.  $d B x a b $.  $d F a b $.
    $d W x a b $.
    pwsdiagmhm.y $e |- Y = ( R ^s I ) $.
    pwsdiagmhm.b $e |- B = ( Base ` R ) $.
    pwsdiagmhm.f $e |- F = ( x e. B |-> ( I X. { x } ) ) $.
    $( Diagonal monoid homomorphism into a structure power.  (Contributed by
       Stefan O'Rear, 12-Mar-2015.) $)
    pwsdiagmhm $p |- ( ( R e. Mnd /\ I e. W ) -> F e. ( R MndHom Y ) ) $=
      ( va vb cmnd wcel wa cfv co wceq cvv eqid cbs wf cplusg wral c0g w3a cmhm
      cv simpl pwsmnd jca cmap fvex eqeltri fdiagfn mpan adantl pwsbas feq3 syl
      wb mpbid csn cxp simplr mndcl 3expb adantlr syl2anc cof oveqan12d anandis
      fvdiagfn adantll simpll pwsdiagel adantrr adantrl pwsplusgval id ad2antlr
      vex ofc12 3eqtrd eqtr4d ralrimivva simpr mndidcl adantr pws0g eqtrd ismhm
      a1i 3jca sylanbrc ) CMNZEFNZOZWPGMNZOBGUAPZDUBZKUHZLUHZCUCPZQZDPZXBDPZXCD
      PZGUCPZQZRZLBUDKBUDZCUEPZDPZGUEPZRZUFDCGUGQNWRWPWSWPWQUICEFGHUJUKWRXAXLXP
      WRBBEULQZDUBZXAWQXRWPBSNWQXRBCUAPSICUAUMUNABDESFJUOUPUQWRXQWTRXRXAVABCEMF
      GHIURXQWTBDUSUTVBWRXKKLBBWRXBBNZXCBNZOZOZXFEXEVCVDZXJYBWQXEBNZXFYCRWPWQYA
      VEZWPYAYDWQWPXSXTYDBXDCXBXCIXDTZVFVGVHABDEFXEJVMVIYBXJEXBVCVDZEXCVCVDZXIQ
      ZYGYHXDVJQZYCWQYAXJYIRZWPWQXSXTYKWQXSOWQXTOXGYGXHYHXIABDEFXBJVMABDEFXCJVM
      VKVLVNYBWTXDXICYGYHEMFGHWTTZWPWQYAVOYEWRXSYGWTNXTXBBWTCEMFGHIYLVPVQWRXTYH
      WTNXSXCBWTCEMFGHIYLVPVRYFXITZVSWQYJYCRWPYAWQEXBXCXDFSSWQVTXBSNWQKWBWMXCSN
      WQLWBWMWCWAWDWEWFWRXNEXMVCVDZXOWRWQXMBNZXNYNRWPWQWGWPYOWQBCXMIXMTZWHWIABD
      EFXMJVMVICEFGXMHYPWJWKWNKLBWTXDXICGDXOXMIYLYFYMYPXOTWLWO $.
  $}

  ${
    $d x z A $.  $d g w x y z C $.  $d w x z R $.  $d g x y Y $.  $d g x y Z $.
    $d w z B $.  $d g w x y z F $.  $d g w x y z ph $.
    pwsco1mhm.y $e |- Y = ( R ^s A ) $.
    pwsco1mhm.z $e |- Z = ( R ^s B ) $.
    pwsco1mhm.c $e |- C = ( Base ` Z ) $.
    pwsco1mhm.r $e |- ( ph -> R e. Mnd ) $.
    pwsco1mhm.a $e |- ( ph -> A e. V ) $.
    pwsco1mhm.b $e |- ( ph -> B e. W ) $.
    pwsco1mhm.f $e |- ( ph -> F : A --> B ) $.
    $( Right composition with a function on the index sets yields a monoid
       homomorphism of structure powers.  (Contributed by Mario Carneiro,
       12-Jun-2015.) $)
    pwsco1mhm $p |- ( ph -> ( g e. C |-> ( g o. F ) ) e. ( Z MndHom Y ) ) $=
      ( wcel cvv vx vy vz vw cmnd wa cbs cfv cv ccom cmpt wf cplusg co wceq c0g
      wral w3a cmhm pwsmnd syl2anc wb eqid pwselbasb biimpa adantr mpbird fmptd
      jca fco cof fvex a1i ffvelrnda feqmptd simprl fveq2 fmptco simprr offval2
      pwselbas pwsplusgval eqtrd oveq12d 3eqtr4rd mndcl 3expb sylan fex sylancr
      ovex coexg fvmptg 3eqtr4d ralrimivva csn cxp mndidcl syl wfn ffn fnconstg
      coeq1 pws0g fveq1d fvconst2g eqtr3d fvco3 eqfnfvd 3eqtrd ismhm sylanbrc
      3jca ) AKUESZJUESZUFDJUGUHZFDFUIZGUJZUKZULZUAUIZUBUIZKUMUHZUNZXSUHZYAXSUH
      ZYBXSUHZJUMUHZUNZUOZUBDUQUADUQZKUPUHZXSUHZJUPUHZUOZURXSKJUSUNSAXNXOAEUESZ
      CISZXNOQECIKMUTVAZAYPBHSZXOOPEBHJLUTVAVIAXTYKYOAFDXRXPXSAXQDSZUFZXRXPSZBE
      UGUHZXRULZUUACUUCXQULZBCGULZUUDAYTUUEAYPYQYTUUEVBOQUUCECDUEXQKIMUUCVCZNVD
      VAVEAUUFYTRVFBCUUCXQGVJVAAUUBUUDVBZYTAYPYSUUHOPUUCEBXPUEXRJHLUUGXPVCZVDVA
      VFVGXSVCZVHAYJUAUBDDAYADSZYBDSZUFZUFZYDGUJZYAGUJZYBGUJZYHUNZYEYIUUNUUPUUQ
      EUMUHZVKZUNUCBUCUIZGUHZYAUHZUVBYBUHZUUSUNZUKUURUUOUUNUCBUVCUVDUUSUUPUUQHT
      TAYSUUMPVFZUVCTSUUNUVABSUFZUVBYAVLVMUVDTSUVGUVBYBVLVMUUNUCUDBCUVBUDUIZYAU
      HZUVCGYAUUNBCUVAGAUUFUUMRVFZVNZUUNUCBCGUVJVOZUUNUDCUUCYAUUNUUCECDUEYAKIMU
      UGNAYPUUMOVFZAYQUUMQVFZAUUKUULVPZWAZVOZUVHUVBYAVQZVRUUNUCUDBCUVBUVHYBUHZU
      VDGYBUVKUVLUUNUDCUUCYBUUNUUCECDUEYBKIMUUGNUVMUVNAUUKUULVSZWAZVOZUVHUVBYBV
      QZVRVTUUNXPUUSYHEUUPUUQBUEHJLUUIUVMUVFUUNUUPXPSZBUUCUUPULZUUNCUUCYAULUUFU
      WEUVPUVJBCUUCYAGVJVAUUNYPYSUWDUWEVBUVMUVFUUCEBXPUEUUPJHLUUGUUIVDVAVGUUNUU
      QXPSZBUUCUUQULZUUNCUUCYBULUUFUWGUWAUVJBCUUCYBGVJVAUUNYPYSUWFUWGVBUVMUVFUU
      CEBXPUEUUQJHLUUGUUIVDVAVGUUSVCZYHVCZWBUUNUCUDBCUVBUVIUVSUUSUNZUVEGYDUVKUV
      LUUNYDYAYBUUTUNUDCUWJUKUUNDUUSYCEYAYBCUEIKMNUVMUVNUVOUVTUWHYCVCZWBUUNUDCU
      VIUVSUUSYAYBITTUVNUVITSUUNUVHCSUFZUVHYAVLVMUVSTSUWLUVHYBVLVMUVQUWBVTWCUVH
      UVBUOUVIUVCUVSUVDUUSUVRUWCWDVRWEUUNYDDSZUUOTSZYEUUOUOAXNUUMUWMYRXNUUKUULU
      WMDYCKYAYBNUWKWFWGWHUUNYDTSGTSZUWNYAYBYCWKAUWOUUMAUUFYSUWORPBCHGWIVAZVFZY
      DGTTWLWJFYDXRUUODTXSXQYDGXCUUJWMVAUUNYFUUPYGUUQYHUUNUUKUUPTSZYFUUPUOUVOUU
      NUUKUWOUWRUVOUWQYAGDTWLVAFYAXRUUPDTXSXQYAGXCUUJWMVAUUNUULUUQTSZYGUUQUOUVT
      UUNUULUWOUWSUVTUWQYBGDTWLVAFYBXRUUQDTXSXQYBGXCUUJWMVAWDWNWOAYMYLGUJZBEUPU
      HZWPZWQZYNAYLDSZUWTTSZYMUWTUOAXNUXDYRDKYLNYLVCZWRWSZAUXDUWOUXEUXGUWPYLGDT
      WLVAFYLXRUWTDTXSXQYLGXCUUJWMVAAUABUWTUXCABUUCUWTULZUWTBWTACUUCYLULUUFUXHA
      UUCECDUEYLKIMUUGNOQUXGWARBCUUCYLGVJVABUUCUWTXAWSAUXATSZUXCBWTUXIAEUPVLZVM
      ZBUXATXBWSAYABSZUFZYAGUHZYLUHZUXAYAUWTUHZYAUXCUHZUXMUXNCUXBWQZUHZUXOUXAAU
      XSUXOUOUXLAUXNUXRYLAYPYQUXRYLUOOQECIKUXAMUXAVCZXDVAXEVFUXMUXIUXNCSUXSUXAU
      OUXJABCYAGRVNCUXAUXNTXFWJXGAUUFUXLUXPUXOUORBCYAYLGXHWHAUXIUXLUXQUXAUOUXKB
      UXAYATXFWHWNXIAYPYSUXCYNUOOPEBHJUXALUXTXDVAXJXMUAUBDXPYCYHKJXSYNYLNUUIUWK
      UWIUXFYNVCXKXL $.
  $}

  ${
    $d w A $.  $d g w x y B $.  $d g w x y z F $.  $d g x y Y $.  $d g x y Z $.
    $d g w x y ph $.  $d w z R $.  $d w S $.
    pwsco2mhm.y $e |- Y = ( R ^s A ) $.
    pwsco2mhm.z $e |- Z = ( S ^s A ) $.
    pwsco2mhm.b $e |- B = ( Base ` Y ) $.
    pwsco2mhm.a $e |- ( ph -> A e. V ) $.
    pwsco2mhm.f $e |- ( ph -> F e. ( R MndHom S ) ) $.
    $( Left composition with a monoid homomorphism yields a monoid homomorphism
       of structure powers.  (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    pwsco2mhm $p |- ( ph -> ( g e. B |-> ( F o. g ) ) e. ( Y MndHom Z ) ) $=
      ( vw cmnd wcel cfv syl2anc vx vy vz wa cbs cv ccom cmpt wf cplusg co wceq
      wral c0g w3a cmhm mhmrcl1 syl pwsmnd mhmrcl2 jca eqid mhmf simpr pwselbas
      adantr fco wb pwselbasb mpbird cof simprl ffvelrnda simprr mhmlin syl3anc
      fmptd mpteq2dva cvv feqmptd fveq2 fmptco offval2 eqtr4d mndcl pwsplusgval
      fvex a1i eqtrd 3eqtr4d 3expb sylan coexg coeq2 oveq12d ralrimivva csn cxp
      fvmptg mndidcl wfn fcoconst pws0g coeq2d mhm0 sneqd xpeq2d 3eqtr3d 3eqtrd
      ffn 3jca ismhm sylanbrc ) AIQRZJQRZUDCJUESZFCGFUFZUGZUHZUIZUAUFZUBUFZIUJS
      ZUKZXSSZYAXSSZYBXSSZJUJSZUKZULZUBCUMUACUMZIUNSZXSSZJUNSZULZUOXSIJUPUKRAXN
      XOADQRZBHRZXNAGDEUPUKZRZYPODEGUQZURZNDBHIKUSTZAEQRZYQXOAYSUUCODEGUTZURZNE
      BHJLUSTVAAXTYKYOAFCXRXPXSAXQCRZUDZXRXPRZBEUESZXRUIZUUGDUESZUUIGUIZBUUKXQU
      IUUJAUULUUFAYSUULOUUKUUIDEGUUKVBZUUIVBZVCZURZVFUUGUUKDBCQXQIHKUUMMAYPUUFU
      UAVFAYQUUFNVFZAUUFVDVEBUUKUUIGXQVGTUUGUUCYQUUHUUJVHAUUCUUFUUEVFUUQUUIEBXP
      QXRJHLUUNXPVBZVITVJXSVBZVQAYJUAUBCCAYACRZYBCRZUDZUDZGYDUGZGYAUGZGYBUGZYHU
      KZYEYIUVCPBPUFZYASZUVHYBSZDUJSZUKZGSZUHZUVEUVFEUJSZVKUKZUVDUVGUVCUVNPBUVI
      GSZUVJGSZUVOUKZUHUVPUVCPBUVMUVSUVCUVHBRZUDZYSUVIUUKRZUVJUUKRZUVMUVSULUVCY
      SUVTAYSUVBOVFZVFUVCBUUKUVHYAUVCUUKDBCQYAIHKUUMMUVCYSYPUWDYTURZAYQUVBNVFZA
      UUTUVAVLZVEZVMZUVCBUUKUVHYBUVCUUKDBCQYBIHKUUMMUWEUWFAUUTUVAVNZVEZVMZUUKUV
      KUVODEGUVIUVJUUMUVKVBZUVOVBZVOVPVRUVCPBUVQUVRUVOUVEUVFHVSVSUWFUVQVSRUWAUV
      IGWGWHUVRVSRUWAUVJGWGWHUVCPUCBUUKUVIUCUFZGSZUVQYAGUWIUVCPBUUKYAUWHVTZUVCU
      CUUKUUIGUVCYSUULUWDUUOURZVTZUWOUVIGWAWBUVCPUCBUUKUVJUWPUVRYBGUWLUVCPBUUKY
      BUWKVTZUWSUWOUVJGWAWBWCWDUVCPUCBUUKUVLUWPUVMYDGUWAYPUWBUWCUVLUUKRUVCYPUVT
      UWEVFUWIUWLUUKUVKDUVIUVJUUMUWMWEVPUVCYDYAYBUVKVKUKPBUVLUHUVCCUVKYCDYAYBBQ
      HIKMUWEUWFUWGUWJUWMYCVBZWFUVCPBUVIUVJUVKYAYBHVSVSUWFUVIVSRUWAUVHYAWGWHUVJ
      VSRUWAUVHYBWGWHUWQUWTWCWIUWSUWOUVLGWAWBUVCXPUVOYHEUVEUVFBQHJLUURUVCYSUUCU
      WDUUDURZUWFUVCUVEXPRZBUUIUVEUIZUVCUULBUUKYAUIUXDUWRUWHBUUKUUIGYAVGTUVCUUC
      YQUXCUXDVHUXBUWFUUIEBXPQUVEJHLUUNUURVITVJZUVCUVFXPRZBUUIUVFUIZUVCUULBUUKY
      BUIUXGUWRUWKBUUKUUIGYBVGTUVCUUCYQUXFUXGVHUXBUWFUUIEBXPQUVFJHLUUNUURVITVJZ
      UWNYHVBZWFWJUVCYDCRZUVDVSRZYEUVDULAXNUVBUXJUUBXNUUTUVAUXJCYCIYAYBMUXAWEWK
      WLZUVCYSUXJUXKUWDUXLGYDYRCWMTFYDXRUVDCVSXSXQYDGWNUUSWSTUVCYFUVEYGUVFYHUVC
      UUTUXCYFUVEULUWGUXEFYAXRUVECXPXSXQYAGWNUUSWSTUVCUVAUXFYGUVFULUWJUXHFYBXRU
      VFCXPXSXQYBGWNUUSWSTWOWJWPAYMGYLUGZBEUNSZWQZWRZYNAYLCRZUXMVSRZYMUXMULAXNU
      XQUUBCIYLMYLVBZWTURZAYSUXQUXROUXTGYLYRCWMTFYLXRUXMCVSXSXQYLGWNUUSWSTAGBDU
      NSZWQWRZUGZBUYAGSZWQZWRZUXMUXPAGUUKXAZUYAUUKRZUYCUYFULAUULUYGUUPUUKUUIGXJ
      URAYPUYHUUAUUKDUYAUUMUYAVBZWTURGBUUKUYAXBTAUYBYLGAYPYQUYBYLULUUANDBHIUYAK
      UYIXCTXDAUYEUXOBAUYDUXNAYSUYDUXNULODEGUXNUYAUYIUXNVBZXEURXFXGXHAUUCYQUXPY
      NULUUENEBHJUXNLUYJXCTXIXKUAUBCXPYCYHIJXSYNYLMUURUXAUXIUXSYNVBXLXM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Ordered group sum operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  One important use of words is as formal composites in cases where order is
  significant, using the general sum operator ~ df-gsum .  If order is not
  significant, it is simpler to use families instead.

$)

  ${
    $d x y z B $.  $d x y z G $.  $d x y z .+ $.  $d x V $.  $d x y z .0. $.
    gsumvallem1.b $e |- B = ( Base ` G ) $.
    gsumvallem1.z $e |- .0. = ( 0g ` G ) $.
    gsumvallem1.p $e |- .+ = ( +g ` G ) $.
    gsumvallem1.o $e |- O = { x e. B |
      A. y e. B ( ( x .+ y ) = y /\ ( y .+ x ) = y ) } $.
    $( Lemma for properties of the set of identities of ` G ` .  Either ` G `
       has no identities, and ` O = (/) ` , or it has one and this identity is
       unique and identified by the ` 0g ` function.  (Contributed by Mario
       Carneiro, 7-Dec-2014.) $)
    gsumvallem1 $p |- ( G e. V -> O C_ { .0. } ) $=
      ( vz wcel cv co wceq wa wral eqeq1d crab csn wss simpr wrex oveq1 anbi12d
      wi oveq2 ralbidv rspcev adantl ismgmid mpbid eqcomd elsn sylibr ralrimiva
      expr rabss syl5eqss ) EGNZFAOZBOZDPZVDQZVDVCDPZVDQZRZBCSZACUAZHUBZLVBVJVC
      VLNZUHZACSVKVLUCVBVNACVBVCCNZVJVMVBVOVJRZRZVCHQVMVQHVCVQVPHVCQVBVPUDVQBCD
      VCMEHIJKVPMOZVDDPZVDQZVDVRDPZVDQZRZBCSZMCUEVBWDVJMVCCVRVCQZWCVIBCWEVTVFWB
      VHWEVSVEVDVRVCVDDUFTWEWAVGVDVRVCVDDUITUGUJUKULUMUNUOAHUPUQUSURVJACVLUTUQV
      A $.

    $( Lemma for properties of the set of identities of ` G ` .  The set of
       identities of a monoid is exactly the unique identity element.
       (Contributed by Mario Carneiro, 7-Dec-2014.) $)
    gsumvallem2 $p |- ( G e. Mnd -> O = { .0. } ) $=
      ( cmnd wcel csn cv co wceq wa wral eqeq1d mndidcl mndlrid ralrimiva oveq1
      gsumvallem1 oveq2 anbi12d ralbidv elrab2 sylanbrc snssd eqssd ) ELMZFGNAB
      CDEFLGHIJKUEUMGFUMGCMGBOZDPZUNQZUNGDPZUNQZRZBCSZGFMCEGHIUAUMUSBCCDEUNGHJI
      UBUCAOZUNDPZUNQZUNVADPZUNQZRZBCSUTAGCFVAGQZVFUSBCVGVCUPVEURVGVBUOUNVAGUND
      UDTVGVDUQUNVAGUNDUFTUGUHKUIUJUKUL $.
  $}

  ${
    fisuppfi.1 $e |- ( ph -> A e. Fin ) $.
    fisuppfi.2 $e |- ( ph -> F : A --> B ) $.
    $( A function on a finite set is finitely supported.  (Contributed by Mario
       Carneiro, 20-Jun-2015.) $)
    fisuppfi $p |- ( ph -> ( `' F " C ) e. Fin ) $=
      ( cfn wcel ccnv cima wss cdm cnvimass wf wceq fdm syl syl5sseq ssfi
      syl2anc ) ABHIEJDKZBLUBHIFAEMZUBBEDNABCEOUCBPGBCEQRSBUBTUA $.
  $}

  ${
    $d g o w .0. $.  $d s t x y B $.  $d j z J $.  $d f g j m n o w x y z ph $.
    $d f g j m n o w x y z F $.  $d f g j m n o w x y z G $.  $d g j o w y W $.
    $d g j o s t w x y .+ $.  $d g o w A $.  $d f g j m n o w x y z O $.
    $d y S $.
    gsumval.b $e |- B = ( Base ` G ) $.
    gsumval.z $e |- .0. = ( 0g ` G ) $.
    gsumval.p $e |- .+ = ( +g ` G ) $.
    gsumval.o $e |- O = { s e. B |
      A. t e. B ( ( s .+ t ) = t /\ ( t .+ s ) = t ) } $.
    gsumval.w $e |- ( ph -> W = ( `' F " ( _V \ O ) ) ) $.
    gsumval.g $e |- ( ph -> G e. V ) $.
    ${
      gsumvalx.f $e |- ( ph -> F e. X ) $.
      gsumvalx.a $e |- ( ph -> dom F = A ) $.
      $( Expand out the substitutions in ~ df-gsum .  (Contributed by Mario
         Carneiro, 18-Sep-2015.) $)
      gsumvalx $p |- ( ph -> ( G gsum F ) = if ( ran F C_ O , .0. ,
        if ( A e. ran ... , ( iota x E. m E. n e. ( ZZ>= ` m )
          ( A = ( m ... n ) /\ x = ( seq m ( .+ , F ) ` n ) ) ) ,
        ( iota x E. f ( f : ( 1 ... ( # ` W ) ) -1-1-onto-> W /\
            x = ( seq 1 ( .+ , ( F o. f ) ) ` ( # ` W ) ) ) ) ) ) ) $=
        ( vw vg vo vy cvv cv cplusg cfv co wceq wa cbs wral crn wss c0g cdm cfz
        crab wcel cseq cuz wrex wex cio chash wf1o ccom ccnv cdif cima wsbc cif
        csb cgsu cmpt2 df-gsum a1i simprl fveq2d syl6eqr oveqd eqeq1d raleqbidv
        c1 anbi12d rabeqbidv weq oveq2 id eqeq12d oveq1 cbvralv ralbidv cbvrabv
        syl5bb eqtri csbeq1d eqeltri rabex simplrr rneqd simpr sseq12d ad2antrr
        fvex adantr dmeqd eleq1d seqeq2d seqeq3d fveq1d eqeq2d rexbidv iotabidv
        eqtrd exbidv wb difeq2d imaeq2d cnveqd imaeq1d dfsbcq syl cnvexg imaexg
        3eqtr4d 3syl eqeltrd adantl bitrd ifbieq12d elex iotaex ifex fveq12d
        fveq2 oveq2d f1oeq2 f1oeq3 coeq1d sbcied csbied ovmpt2d ) AUFUGKJUJUJUH
        BUKZUIUKZUFUKZULUMZUNZUUKUOZUUKUUJUUMUNZUUKUOZUPZUIUULUQUMZURZBUUSVDZUG
        UKZUSZUHUKZUTZUULVAUMZUVBVBZVCUSZVEZUVGHUKZIUKZVCUNZUOZUUJUVKUUMUVBUVJV
        FZUMZUOZUPZIUVJVGUMZVHZHVIZBVJZWJUUKVKUMZVCUNZUUKGUKZVLZUUJUWBUUMUVBUWD
        VMZWJVFZUMZUOZUPZUIUVBVNZUJUVDVOZVPZVQZGVIZBVJZVRZVRZVSZJUSZLUTZPDUVHVE
        ZDUVLUOZUUJUVKFJUVJVFZUMZUOZUPZIUVRVHZHVIZBVJZWJNVKUMZVCUNZNUWDVLZUUJUX
        KFJUWDVMZWJVFZUMZUOZUPZGVIZBVJZVRZVRZVTUJVTUFUGUJUJUWSWAUOABUIUFUGGHIUH
        WBWCAUULKUOZUVBJUOZUPZUPZUWSUHLUWRVSUYBUYFUHUVALUWRUYFUVAUUJUUKFUNZUUKU
        OZUUKUUJFUNZUUKUOZUPZUIEURZBEVDZLUYFUUTUYLBUUSEUYFUUSKUQUMZEUYFUULKUQAU
        YCUYDWDZWERWFZUYFUURUYKUIUUSEUYPUYFUUOUYHUUQUYJUYFUUNUYGUUKUYFUUMFUUJUU
        KUYFUUMKULUMFUYFUULKULUYOWETWFZWGWHUYFUUPUYIUUKUYFUUMFUUKUUJUYQWGWHWKWI
        WLLQUKZCUKZFUNZUYSUOZUYSUYRFUNZUYSUOZUPZCEURZQEVDUYMUAVUEUYLQBEVUEUYRUU
        KFUNZUUKUOZUUKUYRFUNZUUKUOZUPZUIEURQBWMZUYLVUDVUJCUIECUIWMZVUAVUGVUCVUI
        VULUYTVUFUYSUUKUYSUUKUYRFWNVULWOZWPVULVUBVUHUYSUUKUYSUUKUYRFWQVUMWPWKWR
        VUKVUJUYKUIEVUKVUGUYHVUIUYJVUKVUFUYGUUKUYRUUJUUKFWQWHVUKVUHUYIUUKUYRUUJ
        UUKFWNWHWKWSXAWTXBZWFXCUYFUHLUWRUYBUJLUJVEUYFLUYMUJVUNUYLBEEUYNUJRKUQXK
        XDXEXDWCUYFUVDLUOZUPZUVEUXAUVFUWQPUYAVUPUVCUWTUVDLVUPUVBJAUYCUYDVUOXFZX
        GUYFVUOXHZXIVUPUVFKVAUMZPVUPUULKVAUYFUYCVUOUYOXLWESWFVUPUVIUXBUWAUWPUXJ
        UXTVUPUVGDUVHVUPUVGJVBZDVUPUVBJVUQXMAVUTDUOUYEVUOUEXJYAZXNVUPUVTUXIBVUP
        UVSUXHHVUPUVQUXGIUVRVUPUVMUXCUVPUXFVUPUVGDUVLVVAWHVUPUVOUXEUUJVUPUVKUVN
        UXDVUPUVNFUVBUVJVFUXDVUPUUMFUVBUVJUYFUUMFUOVUOUYQXLZXOVUPUVBJFUVJVUQXPY
        AXQXRWKXSYBXTVUPUWOUXSBVUPUWNUXRGVUPUWNUWJUINVQZUXRVUPUWMNUOUWNVVCYCVUP
        JVNZUWLVPVVDUJLVOZVPZUWMNVUPUWLVVEVVDVUPUVDLUJVURYDYEVUPUWKVVDUWLVUPUVB
        JVUQYFYGANVVFUOUYEVUOUBXJYLUWJUIUWMNYHYIVUPUWJUXRUINUJANUJVEUYEVUOANVVF
        UJUBAJOVEZVVDUJVEVVFUJVEUDJOYJVVDVVEUJYKYMYNXJVUPUUKNUOZUPZUWEUXMUWIUXQ
        VVIUWEUXLUUKUWDVLZUXMVVIUWCUXLUOUWEVVJYCVVIUWBUXKWJVCVVHUWBUXKUOVUPUUKN
        VKUUBYOZUUCUWCUXLUUKUWDUUDYIVVHVVJUXMYCVUPUUKNUXLUWDUUEYOYPVVIUWHUXPUUJ
        VVIUWBUXKUWGUXOVUPUWGUXOUOVVHVUPUWGFUWFWJVFUXOVUPUUMFUWFWJVVBXOVUPUWFUX
        NFWJVUPUVBJUWDVUQUUFXPYAXLVVKUUAXRWKUUGYPYBXTYQYQUUHYAAKMVEKUJVEUCKMYRY
        IAVVGJUJVEUDJOYRYIUYBUJVEAUXAPUYAPVUSUJSKVAXKXDUXBUXJUXTUXIBYSUXSBYSYTY
        TWCUUI $.
    $}

    gsumval.a $e |- ( ph -> A e. X ) $.
    gsumval.f $e |- ( ph -> F : A --> B ) $.
    $( Expand out the substitutions in ~ df-gsum .  (Contributed by Mario
       Carneiro, 7-Dec-2014.) $)
    gsumval $p |- ( ph -> ( G gsum F ) = if ( ran F C_ O , .0. ,
      if ( A e. ran ... , ( iota x E. m E. n e. ( ZZ>= ` m )
        ( A = ( m ... n ) /\ x = ( seq m ( .+ , F ) ` n ) ) ) ,
      ( iota x E. f ( f : ( 1 ... ( # ` W ) ) -1-1-onto-> W /\
          x = ( seq 1 ( .+ , ( F o. f ) ) ` ( # ` W ) ) ) ) ) ) ) $=
      ( cvv wf wcel cbs cfv fvex eqeltri a1i fex2 syl3anc cdm wceq fdm gsumvalx
      syl ) ABCDEFGHIJKLMNUFPQRSTUAUBUCADEJUGZDOUHEUFUHZJUFUHUEUDVBAEKUIUJUFRKU
      IUKULUMDEJOUFUNUOAVAJUPDUQUEDEJURUTUS $.
  $}

  ${
    $d a b f m n s t x G $.  $d a b f m n s t x H $.  $d a b f m n s t x ph $.
    $d f m n x F $.
    gsumpropd.f $e |- ( ph -> F e. V ) $.
    gsumpropd.g $e |- ( ph -> G e. W ) $.
    gsumpropd.h $e |- ( ph -> H e. X ) $.
    gsumpropd.b $e |- ( ph -> ( Base ` G ) = ( Base ` H ) ) $.
    gsumpropd.p $e |- ( ph -> ( +g ` G ) = ( +g ` H ) ) $.
    $( The group sum depends only on the base set and additive operation.  Note
       that for entirely unrestricted functions, there can be dependency on
       out-of-domain values of the operation, so this is somewhat weaker than
       ~ mndpropd etc.  (Contributed by Stefan O'Rear, 1-Feb-2015.)  (Proof
       shortened by Mario Carneiro, 18-Sep-2015.) $)
    gsumpropd $p |- ( ph -> ( G gsum F ) = ( H gsum F ) ) $=
      ( vs vx cv cfv co wceq wa eqid vt vm vn vf va vb crn cplusg cbs wral crab
      wss c0g cdm cfz wcel cseq cuz wrex wex cio ccnv cdif cima chash wf1o ccom
      c1 cvv cif oveqd eqeq1d anbi12d raleqbidv rabeqbidv sseq2d eqidd proplem3
      cgsu seqeq2d fveq1d eqeq2d anbi2d rexbidv exbidv iotabidv difeq2d imaeq2d
      grpidpropd wb fveq2d oveq2d f1oeq2 f1oeq3 bitrd fveq12d ifeq12d ifbieq12d
      syl gsumvalx 3eqtr4d ) ABUGZMOZUAOZCUHPZQZXDRZXDXCXEQZXDRZSZUACUIPZUJZMXK
      UKZULZCUMPZBUNZUOUGUPZXPUBOZUCOZUOQRZNOZXSXEBXRUQZPZRZSZUCXRURPZUSZUBUTZN
      VAZVHBVBZVIXMVCZVDZVEPZUOQZYLUDOZVFZYAYMXEBYOVGZVHUQZPZRZSZUDUTZNVAZVJZVJ
      XBXCXDDUHPZQZXDRZXDXCUUEQZXDRZSZUADUIPZUJZMUUKUKZULZDUMPZXQXTYAXSUUEBXRUQ
      ZPZRZSZUCYFUSZUBUTZNVAZVHYJVIUUMVCZVDZVEPZUOQZUVDYOVFZYAUVEUUEYQVHUQZPZRZ
      SZUDUTZNVAZVJZVJCBVSQDBVSQAXNUUNXOUUDUUOUVNAXMUUMXBAXLUULMXKUUKKAXJUUJUAX
      KUUKKAXGUUGXIUUIAXFUUFXDAXEUUEXCXDLVKVLAXHUUHXDAXEUUEXDXCLVKVLVMVNVOZVPAU
      EUFXKCDAXKVQKAUEOXKUPUFOXKUPSUEUFXEUUELVRWIAXQYIUVBUUCUVMAYHUVANAYGUUTUBA
      YEUUSUCYFAYDUURXTAYCUUQYAAXSYBUUPAXEUUEBXRLVTWAWBWCWDWEWFAUUBUVLNAUUAUVKU
      DAYPUVGYTUVJAYPUVFYLYOVFZUVGAYNUVFRYPUVPWJAYMUVEVHUOAYLUVDVEAYKUVCYJAXMUU
      MVIUVOWGWHZWKZWLYNUVFYLYOWMWSAYLUVDRUVPUVGWJUVQYLUVDUVFYOWNWSWOAYSUVIYAAY
      MUVEYRUVHAXEUUEYQVHLVTUVRWPWBVMWEWFWQWRANUAXPXKXEUDUBUCBCXMFYLEXOMXKTXOTX
      ETXMTAYLVQIHAXPVQZWTANUAXPUUKUUEUDUBUCBDUUMGUVDEUUOMUUKTUUOTUUETUUMTAUVDV
      QJHUVSWTXA $.
  $}

  ${
    $d f m n x y z B $.  $d f m n x y z G $.  $d f m n x y z ph $.  $d x y S $.
    $d f m n z F $.  $d f m n x y z H $.  $d f m n x y z .+ $.  $d x y .0. $.
    $d y V $.
    gsumress.b $e |- B = ( Base ` G ) $.
    gsumress.o $e |- .+ = ( +g ` G ) $.
    gsumress.h $e |- H = ( G |`s S ) $.
    gsumress.g $e |- ( ph -> G e. V ) $.
    gsumress.a $e |- ( ph -> A e. X ) $.
    gsumress.s $e |- ( ph -> S C_ B ) $.
    gsumress.f $e |- ( ph -> F : A --> S ) $.
    gsumress.z $e |- ( ph -> .0. e. S ) $.
    gsumress.c $e |- ( ( ph /\ x e. B ) ->
      ( ( .0. .+ x ) = x /\ ( x .+ .0. ) = x ) ) $.
    $( The group sum in a substructure is the same as the group sum in the
       original structure.  The only requirement on the substructure is that it
       contain the identity element; neither ` G ` nor ` H ` need be groups.
       (Contributed by Mario Carneiro, 19-Dec-2014.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    gsumress $p |- ( ph -> ( G gsum F ) = ( H gsum F ) ) $=
      ( vy vm vn vz vf crn cv wceq wral crab wss c0g cfv cfz wcel cseq cuz wrex
      co wa wex cio c1 ccnv cvv csn cdif cima chash wf1o ccom cif cplusg sseldd
      cbs cgsu ralrimiva oveq1 eqeq1d oveq2 anbi12d ralbidv elrab sylanbrc eqid
      snssd gsumvallem1 syl elsni sneqd sseqtr4d eqssd sselda ressbas2 syl6eqel
      syldan fvex ressplusg oveqd raleqbidv rabeqbidv eleqtrd cress eqeltri a1i
      ovex eqtr3d sseq2d seqeq2d fveq1d eqeq2d anbi2d exbidv iotabidv ifbieq12d
      rexbidv ifeq12d difeq2d imaeq2d wf fss syl2anc gsumval feq3 mpbid 3eqtr4d
      wb ) AGUGZUBUHZBUHZEUTZYKUIZYKYJEUTZYKUIZVAZBDUJZUBDUKZULZHUMUNZCUOUGUPZC
      UCUHZUDUHZUOUTUIZUEUHZUUCEGUUBUQZUNZUIZVAZUDUUBURUNZUSZUCVBZUEVCZVDGVEZVF
      LVGZVHZVIZVJUNZUOUTUUQUFUHZVKZUUEUUREGUUSVLZVDUQZUNZUIZVAZUFVBZUEVCZVMZVM
      YIYJYKIVNUNZUTZYKUIZYKYJUVIUTZYKUIZVAZBIVPUNZUJZUBUVOUKZULZIUMUNZUUAUUDUU
      EUUCUVIGUUBUQZUNZUIZVAZUDUUJUSZUCVBZUEVCZUUTUUEUURUVIUVAVDUQZUNZUIZVAZUFV
      BZUEVCZVMZVMHGVQUTIGVQUTAYSUVRYTUVHUVSUWMAYRUVQYIAUUOYRUVQAUUOYRALYRALDUP
      LYKEUTZYKUIZYKLEUTZYKUIZVAZBDUJZLYRUPAFDLRTVOAUWRBDUAVRYQUWSUBLDYJLUIZYPU
      WRBDUWTYMUWOYOUWQUWTYLUWNYKYJLYKEVSVTUWTYNUWPYKYJLYKEWAVTWBZWCWDWEZWGAYRY
      TVGZUUOAHJUPYRUXCULPUBBDEHYRJYTMYTWFZNYRWFZWHWIZALYTALUXCUPLYTUIAYRUXCLUX
      FUXBVOLYTWJWIZWKWLWMZAUUOUVQALUVQALYPBFUJZUBFUKZUVQALFUPUWRBFUJZLUXJUPTAU
      WRBFAYKFUPYKDUPUWRAFDYKRWNUAWQVRUXIUXKUBLFUWTYPUWRBFUXAWCWDWEAUXIUVPUBFUV
      OAFDULZFUVOUIZRFDIHOMWOWIZAYPUVNBFUVOUXNAYMUVKYOUVMAYLUVJYKAEUVIYJYKAFVFU
      PEUVIUIAFUVOVFUXNIVPWRWPFEHIVFONWSWIZWTVTAYNUVLYKAEUVIYKYJUXOWTVTWBXAXBXC
      ZWGAUVQUVSVGZUUOAIVFUPZUVQUXQULUXRAIHFXDUTVFOHFXDXGXEXFZUBBUVOUVIIUVQVFUV
      SUVOWFZUVSWFZUVIWFZUVQWFZWHWIZALUVSALUXQUPLUVSUIAUVQUXQLUYDUXPVOLUVSWJWIZ
      WKWLWMZXHXIALYTUVSUXGUYEXHAUUAUUMUWFUVGUWLAUULUWEUEAUUKUWDUCAUUIUWCUDUUJA
      UUHUWBUUDAUUGUWAUUEAUUCUUFUVTAEUVIGUUBUXOXJXKXLXMXQXNXOAUVFUWKUEAUVEUWJUF
      AUVDUWIUUTAUVCUWHUUEAUURUVBUWGAEUVIUVAVDUXOXJXKXLXMXNXOXRXPAUEBCDEUFUCUDG
      HYRJUUQKYTUBMUXDNUXEAUUPVFYRVHUUNAUUOYRVFUXHXSXTPQACFGYAZUXLCDGYASRCFDGYB
      YCYDAUEBCUVOUVIUFUCUDGIUVQVFUUQKUVSUBUXTUYAUYBUYCAUUPVFUVQVHUUNAUUOUVQVFU
      YFXSXTUXSQAUYGCUVOGYAZSAUXMUYGUYHYHUXNFUVOCGYEWIYFYDYG $.
  $}

  ${
    $d x G $.  $d x H $.  $d x ph $.  $d x S $.
    gsumsubm.a $e |- ( ph -> A e. V ) $.
    gsumsubm.s $e |- ( ph -> S e. ( SubMnd ` G ) ) $.
    gsumsubm.f $e |- ( ph -> F : A --> S ) $.
    gsumsubm.h $e |- H = ( G |`s S ) $.
    $( Evaluate a group sum in a submonoid.  (Contributed by Mario Carneiro,
       19-Dec-2014.) $)
    gsumsubm $p |- ( ph -> ( G gsum F ) = ( H gsum F ) ) $=
      ( vx cbs cfv cmnd eqid wcel syl co wceq cplusg c0g csubmnd submrcl submss
      wss subm0cl cv wa mndlrid sylan gsumress ) ALBEMNZEUANZCDEFOGEUBNZUMPZUNP
      ZKACEUCNQZEOQZICEUDRZHAURCUMUFIUMCEUPUERJAURUOCQICEUOUOPZUGRAUSLUHZUMQUOV
      BUNSVBTVBUOUNSVBTUIUTUMUNEVBUOUPUQVAUJUKUL $.
  $}

  ${
    $d f m n z F $.  $d f m n z G $.  $d f m n z O $.  $d f m n z ph $.
    $d x y z B $.  $d x y z .+ $.
    gsumval1.b $e |- B = ( Base ` G ) $.
    gsumval1.z $e |- .0. = ( 0g ` G ) $.
    gsumval1.p $e |- .+ = ( +g ` G ) $.
    gsumval1.o $e |- O = { x e. B |
      A. y e. B ( ( x .+ y ) = y /\ ( y .+ x ) = y ) } $.
    gsumval1.g $e |- ( ph -> G e. V ) $.
    gsumval1.a $e |- ( ph -> A e. W ) $.
    gsumval1.f $e |- ( ph -> F : A --> O ) $.
    $( Value of the group sum operation when every element being summed is an
       identity of ` G ` .  (Contributed by Mario Carneiro, 7-Dec-2014.) $)
    gsumval1 $p |- ( ph -> ( G gsum F ) = .0. ) $=
      ( cv vm vn vz vf cgsu co crn wss cfz wcel wceq cseq cfv wa cuz wex cio c1
      wrex ccnv cvv cdif cima chash wf1o ccom eqidd wf wral crab ssrab2 eqsstri
      cif fss sylancl gsumval frn iftrue 3syl eqtrd ) AHGUEUFGUGIUHZLDUIUGUJDUA
      TZUBTZUIUFUKUCTZWCFGWBULUMUKUNUBWBUOUMUSUAUPUCUQURGUTVAIVBVCZVDUMZUIUFWEU
      DTZVEWDWFFGWGVFURULUMUKUNUDUPUCUQVMZVMZLAUCCDEFUDUAUBGHIJWEKLBMNOPAWEVGQR
      ADIGVHZIEUHDEGVHSIBTZCTZFUFWLUKWLWKFUFWLUKUNCEVIZBEVJEPWMBEVKVLDIEGVNVOVP
      AWJWAWILUKSDIGVQWALWHVRVSVT $.
  $}

  ${
    $d f g m n o w x y $.  $d k A $.  $d k x y G $.  $d k V $.  $d x y .0. $.
    gsum0.z $e |- .0. = ( 0g ` G ) $.
    $( Value of the empty group sum.  (Contributed by Mario Carneiro,
       7-Dec-2014.) $)
    gsum0 $p |- ( G gsum (/) ) = .0. $=
      ( vx vy vw vf vo vm vn vg cvv wcel c0 cgsu co wceq cfv cv wa wral crab id
      cbs cplusg eqid 0ex a1i wf gsumval1 crn wss c0g cdm cfz cseq cuz wrex wex
      f0 wn cio c1 chash wf1o ccom ccnv cdif cima wsbc cif csb reldmmpt2 ovprc1
      df-gsum fvprc syl5eq eqtr4d pm2.61i ) ALMZANOPZBQVTDENAUDRZAUERZNADSZESZW
      CPWEQWEWDWCPWEQTEWBUADWBUBZLLBWBUFCWCUFWFUFVTUCNLMVTUGUHNWFNUIVTWFUTUHUJV
      TVAZWANBANOFGLLHWDWEFSZUERZPWEQWEWDWIPWEQTEWHUDRZUADWJUBGSZUKHSZULWHUMRWK
      UNZUOUKMWMISZJSZUOPQWDWOWIWKWNUPRQTJWNUQRURIUSDVBVCWEVDRZUOPWEKSZVEWDWPWI
      WKWQVFVCUPRQTEWKVGLWLVHVIVJKUSDVBVKVKVLODEFGKIJHVOVMVNWGBAUMRNCAUMVPVQVRV
      S $.

    $( Value of a group sum over the zero element.  (Contributed by Mario
       Carneiro, 7-Dec-2014.) $)
    gsumz $p |- ( ( G e. Mnd /\ A e. V ) ->
      ( G gsum ( k e. A |-> .0. ) ) = .0. ) $=
      ( vx vy cmnd wcel wa cbs cfv cplusg cmpt cv co wceq eqid c0g wral csn cvv
      crab simpl simpr fvex snid gsumvallem2 syl5eleqr ad2antrr fmptd gsumval1
      eqeltri ) CIJZADJZKZGHACLMZCNMZBAEOZCGPZHPZUSQVBRVBVAUSQVBRKHURUAGURUDZID
      EURSZFUSSZVCSZUOUPUEUOUPUFUQBAEVCUTUOEVCJUPBPAJUOEEUBVCEECTMUCFCTUGUNUHGH
      URUSCVCEVDFVEVFUIUJUKUTSULUM $.
  $}

  ${
    $d x y z B $.  $d f m n x y z G $.  $d m n z M $.  $d m n z N $.  $d x V $.
    $d f m n z F $.  $d f m n z O $.  $d m n x y z .+ $.  $d f m n z ph $.
    gsumval2.b $e |- B = ( Base ` G ) $.
    gsumval2.p $e |- .+ = ( +g ` G ) $.
    gsumval2.g $e |- ( ph -> G e. V ) $.
    gsumval2.n $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    gsumval2.f $e |- ( ph -> F : ( M ... N ) --> B ) $.
    ${
      gsumval2a.o $e |- O = { x e. B |
        A. y e. B ( ( x .+ y ) = y /\ ( y .+ x ) = y ) } $.
      gsumval2a.f $e |- ( ph -> -. ran F C_ O ) $.
      $( Value of the group sum operation over a finite set of sequential
         integers.  (Contributed by Mario Carneiro, 7-Dec-2014.) $)
      gsumval2a $p |- ( ph -> ( G gsum F ) = ( seq M ( .+ , F ) ` N ) ) $=
        ( cfz wceq vm vn vz vf cgsu co cv cseq cfv cuz wrex wex cio crn wss c0g
        wa wcel c1 ccnv cvv cdif cima chash wf1o ccom cif eqid ovex a1i gsumval
        eqidd wn iffalse syl cz eluzel2 eluzelz cxp wfn cpw wf fzf ax-mp fnovrn
        ffn mp3an1 syl2anc iftrue eqtrd fvex wb wi fzopth simpl seqeq1d fveq12d
        simpr eqcomd eqeq1 syl5ibrcom syl6bi rexlimdvw exlimdv adantr biantrurd
        imp3a oveq2 fveq2 eqeq2d bitr3d rspcev sylan oveq1 seqeq1 fveq1d spcegv
        anbi12d rexeqbidv sylc ex impbid iota5 mpan2 ) AGFUEUFZHISUFZUAUGZUBUGZ
        SUFZTZUCUGZYHEFYGUHZUIZTZUQZUBYGUJUIZUKZUAULZUCUMZIEFHUHZUIZAYEFUNJUOZG
        UPUIZYFSUNURZYSUSFUTVAJVBVCZVDUIZSUFUUEUDUGZVEYKUUFEFUUGVFUSUHUITUQUDUL
        UCUMZVGZVGZYSAUCCYFDEUDUAUBFGJKUUEVAUUCBLUUCVHMQAUUEVLNYFVAURAHISVIVJPV
        KAUUJUUIYSAUUBVMUUJUUITRUUBUUCUUIVNVOAUUDUUIYSTAHVPURZIVPURZUUDAIHUJUIZ
        URZUUKOHIVQVOZAUUNUULOHIVRVOSVPVPVSZVTZUUKUULUUDUUPVPWAZSWBUUQWCUUPUURS
        WFWDVPVPHISWEWGWHUUDYSUUHWIVOWJWJAUUAVAURZYSUUATIYTWKAYRUCUUAVAAYRYKUUA
        TZWLUUSAYRUUTAYQUUTUAAYOUUTUBYPAYJYNUUTAYJHYGTZIYHTZUQZYNUUTWMAUUNYJUVC
        WLOYGYHHIWNVOUVCUUTYNYMUUATUVCUUAYMUVCIYHYTYLUVCHYGEFUVAUVBWOWPUVAUVBWR
        WQWSYKYMUUAWTXAXBXGXCXDAUUTYRAUUTUQUUKYFHYHSUFZTZYKYHYTUIZTZUQZUBUUMUKZ
        YRAUUKUUTUUOXEAUUNUUTUVIOUVHUUTUBIUUMYHITZUVGUVHUUTUVJUVEUVGUVJUVDYFYHI
        HSXHWSXFUVJUVFUUAYKYHIYTXIXJXKXLXMYQUVIUAHVPYGHTZYOUVHUBYPUUMYGHUJXIUVK
        YJUVEYNUVGUVKYIUVDYFYGHYHSXNXJUVKYMUVFYKUVKYHYLYTEFYGHXOXPXJXRXSXQXTYAY
        BXEYCYDWJ $.
    $}

    $( Value of the group sum operation over a finite set of sequential
       integers.  (Contributed by Mario Carneiro, 7-Dec-2014.) $)
    gsumval2 $p |- ( ph -> ( G gsum F ) = ( seq M ( .+ , F ) ` N ) ) $=
      ( vx vy co wceq wcel adantr c0 vz crn wral crab wss cgsu cseq cfv c0g cfz
      cv wa cvv eqid ovex a1i wfn wf ffn syl simpr df-f sylanbrc gsumval1 simpl
      wi ralimi ss2rabi csn fvex snid wne cdm fdm cuz eluzfz1 ne0i 3syl eqnetrd
      wn dm0rn0 necon3bii sylib ssn0 syl2anc neneqd wo gsumvallem1 sssn orcanai
      syldan syl5eleqr sseldi oveq1 eqeq1d ralbidv elrab oveq2 id eqeq12d sylbi
      rspcva ad2antrr ffvelrnda sseldd elsni seqid3 eqtr4d gsumval2a pm2.61dan
      ) ADUBZNUKZOUKZCPZXMQZXMXLCPXMQZULZOBUCZNBUDZUEZEDUFPZGCDFUGUHZQAXTULZYAE
      UIUHZYBYCNOFGUJPZBCDEXSHUMYDIYDUNZJXSUNZAEHRZXTKSYEUMRYCFGUJUOUPYCDYEUQZX
      TYEXSDURAYIXTAYEBDURZYIMYEBDUSUTSAXTVAZYEXSDVBVCZVDYCUACDFGYDYCYDXOOBUCZN
      BUDZRZYDYDCPZYDQZYCXSYNYDXRYMNBXRYMVFXLBRXQXOOBXOXPVEVGUPVHYCYDYDVIZXSYDE
      UIVJVKAXTXSTQZVTXSYRQZYCXSTYCXTXKTVLZXSTVLYKAUUAXTADVMZTVLUUAAUUBYETAYJUU
      BYEQMYEBDVNUTAGFVOUHRZFYERYETVLLFGVPYEFVQVRVSUUBTXKTDWAWBWCSXKXSWDWEWFAYS
      YTAXSYRUEZYSYTWGAYHUUDKNOBCEXSHYDIYFJYGWHUTZXSYDWIWCWJWKWLWMYOYDBRYDXMCPZ
      XMQZOBUCZULYQYMUUHNYDBXLYDQZXOUUGOBUUIXNUUFXMXLYDXMCWNWOWPWQUUGYQOYDBXMYD
      QZUUFYPXMYDXMYDYDCWRUUJWSWTXBXAUTAUUCXTLSYCUAUKZYERZULZUUKDUHZYRRUUNYDQUU
      MXSYRUUNAUUDXTUULUUEXCYCYEXSUUKDYLXDXEUUNYDXFUTXGXHAXTVTZULNOBCDEFGXSHIJA
      YHUUOKSAUUCUUOLSAYJUUOMSYGAUUOVAXIXJ $.
  $}

  ${
    $d x y S $.  $d x y G $.  $d x y W $.
    $( Closure of the composite in any submonoid.  (Contributed by Stefan
       O'Rear, 15-Aug-2015.)  (Revised by Mario Carneiro, 1-Oct-2015.) $)
    gsumwsubmcl $p |- ( ( S e. ( SubMnd ` G ) /\ W e. Word S ) ->
        ( G gsum W ) e. S ) $=
      ( vx vy cfv wcel wa cgsu co c0 wceq eqid cc0 cmnd ad2antrr cn0 syl wf cv
      csubmnd cword c0g oveq2 gsum0 syl6eq eleq1d wne chash c1 cmin cplusg cseq
      cbs submrcl cuz cn lennncl adantll nnm1nn0 syl6eleq cfz wss cfzo ad2antlr
      nn0uz wrdf cz nnzd fzoval feq2d mpbid submss fss syl2anc ffvelrnda simpll
      gsumval2 submcl 3expb sylan seqcl eqeltrd subm0cl adantr pm2.61ne ) ABUAF
      GZCAUBGZHZBCIJZAGBUCFZAGZCKCKLZWJWKAWMWJBKIJWKCKBIUDBWKWKMZUEUFUGWICKUHZH
      ZWJCUIFZUJUKJZBULFZCNUMFAWPBUNFZWSCBNWROWTMZWSMZWGBOGWHWOABUOPWPWRQNUPFWP
      WQUQGZWRQGWHWOXCWGACURUSZWQUTRVFVAZWPNWRVBJZACSZAWTVCZXFWTCSWPNWQVDJZACSZ
      XGWHXJWGWOACVGVEWPXIXFACWPWQVHGXIXFLWPWQXDVINWQVJRVKVLZWGXHWHWOWTABXAVMPX
      FAWTCVNVOVRWPDEWSACNWRXEWPXFADTZCXKVPWPWGXLAGZETZAGZHXLXNWSJAGZWGWHWOVQWG
      XMXOXPWSABXLXNXBVSVTWAWBWCWGWLWHABWKWNWDWEWF $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z .+ $.  $d x y z W $.  $d x y z X $.
    gsumwcl.b $e |- B = ( Base ` G ) $.
    $( A singleton composite recovers the initial symbol.  (Contributed by
       Stefan O'Rear, 16-Aug-2015.) $)
    gsumws1 $p |- ( S e. B -> ( G gsum <" S "> ) = S ) $=
      ( wcel cs1 cgsu co cc0 cop csn cplusg cfv cseq cbs wf cz 0z mpan wceq cdm
      s1val oveq2d eqid elfvdm eleq2s cuz cn0 0nn0 nn0uz eleqtri a1i cfz f1osng
      wss wf1o f1of syl snssi fss syl2anc fzsn ax-mp feq2i gsumval2 fvsng seq1i
      sylibr 3eqtrd ) BAEZCBFZGHCIBJKZGHICLMZVLINMBVJVKVLCGBAUBUCVJAVMVLCIIOUAZ
      DVMUDCVNEBCOMABCOUEDUFIIUGMZEVJIUHVOUIUJUKULVJIKZAVLPZIIUMHZAVLPVJVPBKZVL
      PZVSAUOVQVJVPVSVLUPZVTIQEZVJWARIBQAUNSVPVSVLUQURBAUSVPVSAVLUTVAVRVPAVLWBV
      RVPTRIVBVCVDVHVEVJBVMVLIRWBVJIVLMBTRIBQAVFSVGVI $.

    $( Closure of the composite of a word in a structure ` G ` .  (Contributed
       by Stefan O'Rear, 15-Aug-2015.) $)
    gsumwcl $p |- ( ( G e. Mnd /\ W e. Word B ) -> ( G gsum W ) e. B ) $=
      ( cmnd wcel csubmnd cfv cword cgsu co submid gsumwsubmcl sylan ) BEFABGHF
      CAIFBCJKAFABDLABCMN $.

    gsumccat.p $e |- .+ = ( +g ` G ) $.
    $( Homomorphic property of composites.  (Contributed by Stefan O'Rear,
       16-Aug-2015.)  (Revised by Mario Carneiro, 1-Oct-2015.) $)
    gsumccat $p |- ( ( G e. Mnd /\ W e. Word B /\ X e. Word B ) ->
        ( G gsum ( W concat X ) ) = ( ( G gsum W ) .+ ( G gsum X ) ) ) $=
      ( wcel co cgsu wceq c0 cfv oveq2d wa caddc c1 cc0 cn0 syl vx vy cword w3a
      vz cmnd cconcat c0g oveq1 oveq2 eqid gsum0 syl6eq oveq1d eqeq12d wne cmin
      chash cseq simpl1 cn lennncl 3ad2antl2 adantrr 3ad2antl3 adantrl nnaddcld
      cuz nnm1nn0 nn0uz syl6eleq cfzo wf cfz simpl2 simpl3 syl2anc wrdf ccatlen
      ccatcl cz nnzd zaddcld fzoval eqtrd feq2d mpbid gsumval2 oveq12d cv mndcl
      3expb sylan mndass uzid uzaddcl nncnd ax-1cn a1i addsubassd npcan sylancl
      fveq2d 3eltr4d ffvelrnda seqsplit simpll2 simpll3 eleq2d biimpar ccatval1
      cc syl3anc seqfveq addid2d eqtr4d seqeq1d addcomd addsubd ccatval3 eqcomd
      fveq12d seqshft2 anassrs ccatrid gsumwcl 3adant3 adantr pm2.61ne 3ad2ant3
      mndrid ccatlid simp1 3adant2 mndlid ) CUFHZDAUCZHZEYQHZUDZCDEUGIZJIZCDJIZ
      CEJIZBIZKZCLEUGIZJIZCUHMZUUDBIZKDLDLKZUUBUUHUUEUUJUUKUUAUUGCJDLEUGUINUUKU
      UCUUIUUDBUUKUUCCLJIZUUIDLCJUJCUUIUUIUKZULZUMUNUOYTDLUPZOZUUFCDLUGIZJIZUUC
      UUIBIZKELELKZUUBUURUUEUUSUUTUUAUUQCJELDUGUJNUUTUUDUUIUUCBUUTUUDUULUUIELCJ
      UJUUNUMNUOYTUUOELUPZUUFYTUUOUVAOZOZUUBDURMZEURMZPIZQUQIZBUUARUSZMZUUEUVCA
      BUUACRUVGUFFGYPYRYSUVBUTZUVCUVGSRVHMZUVCUVFVAHUVGSHUVCUVDUVEYTUUOUVDVAHZU
      VAYRYPUUOUVLYSADVBVCVDZYTUVAUVEVAHZUUOYSYPUVAUVNYRAEVBVEVFZVGUVFVITVJVKUV
      CRUUAURMZVLIZAUUAVMZRUVGVNIZAUUAVMUVCUUAYQHZUVRUVCYRYSUVTYPYRYSUVBVOZYPYR
      YSUVBVPZADEVTVQAUUAVRTUVCUVQUVSAUUAUVCUVQRUVFVLIZUVSUVCUVPUVFRVLUVCYRYSUV
      PUVFKUWAUWBADEVSVQNUVCUVFWAHUWCUVSKUVCUVDUVEUVCUVDUVMWBZUVCUVEUVOWBZWCRUV
      FWDTWEWFWGZWHUVCUUEUVDQUQIZBDRUSMZUVEQUQIZBERUSMZBIZUVIUVCUUCUWHUUDUWJBUV
      CABDCRUWGUFFGUVJUVCUWGSUVKUVCUVLUWGSHUVMUVDVITVJVKZUVCRUVDVLIZADVMZRUWGVN
      IZADVMUVCYRUWNUWAADVRTUVCUWMUWOADUVCUVDWAHZUWMUWOKUWDRUVDWDTZWFWGWHUVCABE
      CRUWIUFFGUVJUVCUWISUVKUVCUVNUWISHZUVOUVEVITZVJVKZUVCRUVEVLIZAEVMZRUWIVNIZ
      AEVMUVCYSUXBUWBAEVRTUVCUXAUXCAEUVCUVEWAHUXAUXCKUWERUVEWDTZWFWGWHWIUVCUVIU
      WGUVHMZUVGBUUAUWGQPIZUSZMZBIUWKUVCUAUBUEBAUUARUWGUVGUVCYPUAWJZAHZUBWJZAHZ
      OUXIUXKBIZAHZUVJYPUXJUXLUXNABCUXIUXKFGWKWLWMUVCYPUXJUXLUEWJZAHUDUXMUXOBIU
      XIUXKUXOBIBIKUVJABCUXIUXKUXOFGWNWMUVCUVDUWIPIZUVDVHMZUVGUXFVHMUVCUVDUXQHZ
      UWRUXPUXQHUVCUWPUXRUWDUVDWOTUWSUWIUVDUVDWPVQUVCUVDUVEQUVCUVDUVMWQZUVCUVEU
      VOWQZQXLHZUVCWRWSZWTUVCUXFUVDVHUVCUVDXLHUYAUXFUVDKUXSWRUVDQXAXBZXCXDUWLUV
      CUVSAUXIUUAUWFXEXFUVCUXEUWHUXHUWJBUVCBUAUUADRUWGUWLUVCUXIUWOHZOYRYSUXIUWM
      HZUXIUUAMUXIDMKYPYRYSUVBUYDXGYPYRYSUVBUYDXHUVCUYEUYDUVCUWMUWOUXIUWQXIXJAD
      EUXIXKXMXNUVCUXHUWIUVDPIZBUUARUVDPIZUSZMUWJUVCUVGUYFUXGUYHUVCUXFUYGBUUAUV
      CUXFUVDUYGUYCUVCUVDUXSXOXPXQUVCUVGUVEUVDPIZQUQIUYFUVCUVFUYIQUQUVCUVDUVEUX
      SUXTXRUNUVCUVEUVDQUXTUXSUYBXSWEYBUVCBUAEUUAUVDRUWIUWTUWDUVCUXIUXCHZOZUXIU
      VDPIUUAMZUXIEMZUYKYRYSUXIUXAHZUYLUYMKYPYRYSUVBUYJXGYPYRYSUVBUYJXHUVCUYNUY
      JUVCUXAUXCUXIUXDXIXJADEUXIXTXMYAYCXPWIWEXPXPYDUUPUURUUCUUSUUPUUQDCJUUPYRU
      UQDKYPYRYSUUOVOADYETNUUPYPUUCAHZUUSUUCKYPYRYSUUOUTYTUYOUUOYPYRUYOYSACDFYF
      YGYHABCUUCUUIFGUUMYKVQXPYIYTUUHUUDUUJYTUUGECJYSYPUUGEKYRAEYLYJNYTYPUUDAHZ
      UUJUUDKYPYRYSYMYPYSUYPYRACEFYFYNABCUUDUUIFGUUMYOVQXPYI $.

    $( Valuation of a pair in a monoid.  (Contributed by Stefan O'Rear,
       23-Aug-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    gsumws2 $p |- ( ( G e. Mnd /\ S e. B /\ T e. B ) ->
        ( G gsum <" S T "> ) = ( S .+ T ) ) $=
      ( cmnd wcel w3a cs2 cgsu co cs1 cconcat wceq df-s2 a1i s1cl gsumws1 cword
      oveq2d id gsumccat syl3an oveqan12d 3adant1 3eqtrd ) EHIZCAIZDAIZJZECDKZL
      MECNZDNZOMZLMZEUNLMZEUOLMZBMZCDBMZULUMUPELUMUPPULCDQRUBUIUIUJUNAUAZIUKUOV
      BIUQUTPUIUCCASDASABEUNUOFGUDUEUJUKUTVAPUIUJUKURCUSDBACEFTADEFTUFUGUH $.
  $}

  ${
    gsumspl.b $e |- B = ( Base ` M ) $.
    gsumspl.m $e |- ( ph -> M e. Mnd ) $.
    gsumspl.s $e |- ( ph -> S e. Word B ) $.
    gsumspl.f $e |- ( ph -> F e. ( 0 ... T ) ) $.
    gsumspl.t $e |- ( ph -> T e. ( 0 ... ( # ` S ) ) ) $.
    gsumspl.x $e |- ( ph -> X e. Word B ) $.
    gsumspl.y $e |- ( ph -> Y e. Word B ) $.
    gsumspl.eq $e |- ( ph -> ( M gsum X ) = ( M gsum Y ) ) $.
    $( The primary purpose of the splice construction is to enable local
       rewrites.  Thus, in any monoidal valuation, if a splice does not cause a
       local change it does not cause a global change.  (Contributed by Stefan
       O'Rear, 23-Aug-2015.) $)
    gsumspl $p |- ( ph -> ( M gsum ( S splice <. F , T , X >. ) ) =
          ( M gsum ( S splice <. F , T , Y >. ) ) ) $=
      ( co cgsu wcel wceq cc0 cop csubstr cplusg cfv cotp csplice oveq2d oveq1d
      chash cconcat cfz splval syl13anc cmnd swrdcl syl ccatcl syl2anc gsumccat
      cword eqid syl3anc 3eqtrd 3eqtr4d ) AFCUAEUBUCQZRQZFGRQZFUDUEZQZFCDCUJUEZ
      UBUCQZRQZVIQZVGFHRQZVIQZVMVIQZFCEDGUFUGQZRQZFCEDHUFUGQZRQZAVJVPVMVIAVHVOV
      GVIPUHUIAVSFVFGUKQZVLUKQZRQZFWBRQZVMVIQZVNAVRWCFRACBVAZSZEUADULQZSZDUAVKU
      LQZSZGWGSZVRWCTKLMNGCDEWGWIWKWGUMUNUHAFUOSZWBWGSZVLWGSZWDWFTJAVFWGSZWMWOA
      WHWQKBCUAEUPUQZNBVFGURUSAWHWPKBCDVKUPUQZBVIFWBVLIVIVBZUTVCAWEVJVMVIAWNWQW
      MWEVJTJWRNBVIFVFGIWTUTVCUIVDAWAFVFHUKQZVLUKQZRQZFXARQZVMVIQZVQAVTXBFRAWHW
      JWLHWGSZVTXBTKLMOHCDEWGWIWKWGUMUNUHAWNXAWGSZWPXCXETJAWQXFXGWROBVFHURUSWSB
      VIFXAVLIWTUTVCAXDVPVMVIAWNWQXFXDVPTJWROBVIFVFHIWTUTVCUIVDVE $.
  $}

  ${
    $d x y B $.  $d x y H $.  $d x y M $.  $d x y N $.  $d x y O $.
    $d x y W $.
    gsumwmhm.b $e |- B = ( Base ` M ) $.
    $( Behavior of homomorphisms on finite monoidal sums.  (Contributed by
       Stefan O'Rear, 27-Aug-2015.) $)
    gsumwmhm $p |- ( ( H e. ( M MndHom N ) /\ W e. Word B ) ->
        ( H ` ( M gsum W ) ) = ( N gsum ( H o. W ) ) ) $=
      ( co wcel wa cgsu cfv wceq c0 eqid syl6eq cc0 cmnd ad2antrr wf syl vx c0g
      vy cmhm cword ccom oveq2 gsum0 fveq2d coeq2 co02 oveq2d eqeq12d wne chash
      c1 cmin cplusg cseq cv mhmrcl1 mndcl 3expb sylan cfzo wrdf ad2antlr cz cn
      cfz cfn wb wrdfin adantl hashnncl biimpar nnzd fzoval feq2d ffvelrnda cn0
      mpbid cuz nnm1nn0 nn0uz syl6eleq simpll mhmlin wfn fvco2 seqhomo gsumval2
      ffn eqcomd cbs mhmrcl2 mhmf fco syl2anc 3eqtr4d mhm0 adantr pm2.61ne ) BC
      DUDGHZEAUEHZIZCEJGZBKZDBEUFZJGZLCUBKZBKZDUBKZLZEMEMLZXHXLXJXMXOXGXKBXOXGC
      MJGXKEMCJUGCXKXKNZUHOUIXOXJDMJGXMXOXIMDJXOXIBMUFMEMBUJBUKOULDXMXMNZUHOUMX
      FEMUNZIZEUOKZUPUQGZCURKZEPUSKZBKYADURKZXIPUSKXHXJXSUAUCYBYDAEXIBPYAXSCQHZ
      UAUTZAHZUCUTZAHZIZYFYHYBGZAHZXDYEXEXRCDBVARZYEYGYIYLAYBCYFYHFYBNZVBVCVDXS
      PYAVJGZAYFEXSPXTVEGZAESZYOAESZXEYQXDXRAEVFVGXSYPYOAEXSXTVHHYPYOLXSXTXFXTV
      IHZXRXFEVKHZYSXRVLXEYTXDAEVMVNEVOTVPZVQPXTVRTVSWBZVTXSYAWAPWCKXSYSYAWAHUU
      AXTWDTWEWFZXSXDYJYKBKYFBKYHBKYDGLZXDXEXRWGXDYGYIUUDAYBYDCDBYFYHFYNYDNZWHV
      CVDXSYFYOHZIYFXIKZYFEKBKZXSEYOWIZUUFUUGUUHLXSYRUUIUUBYOAEWMTYOBEYFWJVDWNW
      KXSXGYCBXSAYBECPYAQFYNYMUUCUUBWLUIXSDWOKZYDXIDPYAQUUJNZUUEXDDQHXEXRCDBWPR
      UUCXSAUUJBSZYRYOUUJXISXDUULXEXRAUUJCDBFUUKWQRUUBYOAUUJBEWRWSWLWTXDXNXECDB
      XMXKXPXQXAXBXC $.
  $}

  ${
    $d v w x y G $.  $d v w x z B $.  $d v w x y M $.  $d w K $.  $d z G $.
    $d z M $.
    gsumwspan.b $e |- B = ( Base ` M ) $.
    gsumwspan.k $e |- K = ( mrCls ` ( SubMnd ` M ) ) $.
    $( The submonoid generated by a set of elements is precisely the set of
       elements which can be expressed as finite products of the generator.
       (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
    gsumwspan $p |- ( ( M e. Mnd /\ G C_ B ) -> ( K ` G ) =
          ran ( w e. Word G |-> ( M gsum w ) ) ) $=
      ( vx vy vz vv wcel wss cgsu co wceq oveq2 cvv wb wral cmnd cfv cword cmpt
      wa crn csubmnd cmre submacs acsmred adantr wrex simpr s1cld ssel2 adantll
      cv cs1 gsumws1 syl eqcomd eqeq2d rspcev syl2anc eqid elrnmpt ax-mp sylibr
      vex ex ssrdv cplusg wf mrccl sylan mrcssid sswrd sselda gsumwsubmcl fmptd
      c0g frn mrcssvd sstrd c0 wrd0 gsum0 eqcomi a1i sylancr fvex ccatcl adantl
      cconcat simpll ad2antlr simprl sseldd gsumccat syl3anc ralrimivva cbvmptv
      simprr ovex rneqi raleqi eleq1d ralrnmpt mprg bitri ralbii ralbidv 3bitri
      oveq1 w3a issubm mpbir3and mrcsscl eqssd ) EUALZCBMZUEZCDUBZACUCZEAUQZNOZ
      UDZUFZYBEUGUBZBUHUBLZCYHMYHYILZYCYHMXTYJYAXTYIBBEFUIUJZUKYBHCYHYBHUQZCLZY
      MYHLZYBYNUEZYMYFPZAYDULZYOYPYMURZYDLYMEYSNOZPZYRYPYMCYBYNUMUNYPYTYMYPYMBL
      ZYTYMPYAYNUUBXTCBYMUOUPBYMEFUSUTVAYQUUAAYSYDYEYSPYFYTYMYEYSENQVBVCVDYMRLY
      OYRSHVIAYDYFYMYGRYGVEZVFVGVHVJVKYBYKYHBMZEWAUBZYHLZYMIUQZEVLUBZOZYHLZIYHT
      ZHYHTZYBYHYCBYBYDYCYGVMYHYCMYBAYDYFYCYGYBYEYDLZUEYCYILZYEYCUCZLYFYCLYBUUN
      UUMXTYJYAUUNYLYICDBGVNVOUKYBYDUUOYEYBCYCMZYDUUOMXTYJYAUUPYLYICDBGVPVOCYCV
      QUTVRYCEYEVSVDUUCVTYDYCYGWBUTZXTYCBMYAXTYICDBYLGWCUKWDYBUUEYFPZAYDULZUUFY
      BWEYDLUUEEWENOZPZUUSCWFUVAYBUUTUUEEUUEUUEVEZWGWHWIUURUVAAWEYDYEWEPYFUUTUU
      EYEWEENQVBVCWJUUERLUUFUUSSEWAWKAYDYFUUEYGRUUCVFVGVHYBEJUQZNOZEKUQZNOZUUHO
      ZYHLZKYDTZJYDTZUULYBUVHJKYDYDYBUVCYDLZUVEYDLZUEZUEZUVGYFPZAYDULZUVHUVNUVC
      UVEWNOZYDLZUVGEUVQNOZPZUVPUVMUVRYBCUVCUVEWLWMUVNUVSUVGUVNXTUVCBUCZLUVEUWA
      LUVSUVGPXTYAUVMWOUVNYDUWAUVCYAYDUWAMXTUVMCBVQWPZYBUVKUVLWQWRUVNYDUWAUVEUW
      BYBUVKUVLXCWRBUUHEUVCUVEFUUHVEZWSWTVAUVOUVTAUVQYDYEUVQPYFUVSUVGYEUVQENQVB
      VCVDUVGRLUVHUVPSUVDUVFUUHXDAYDYFUVGYGRUUCVFVGVHXAUULUUKHJYDUVDUDZUFZTYMUV
      FUUHOZYHLZKYDTZHUWETZUVJUUKHYHUWEYGUWDAJYDYFUVDYEUVCENQXBXEXFUUKUWHHUWEUU
      KUUJIKYDUVFUDZUFZTZUWHUUJIYHUWKYGUWJAKYDYFUVFYEUVEENQXBXEXFUVFRLZUWLUWHSK
      YDUUJUWGKIYDUVFUWJRUWJVEUUGUVFPUUIUWFYHUUGUVFYMUUHQXGXHUWMUVLEUVENXDWIXIX
      JXKUVDRLZUWIUVJSJYDUWHUVIJHYDUVDUWDRUWDVEYMUVDPZUWGUVHKYDUWOUWFUVGYHYMUVD
      UVFUUHXNXGXLXHUWNUVKEUVCNXDWIXIXMVHXTYKUUDUUFUULXOSYAHIBUUHYHEUUEFUVBUWCX
      PUKXQYICDYHBGXRWTUUQXS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Free monoids
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c freeMnd $.
  $c varFMnd $.

  $( Extend class definition with the free monoid construction. $)
  cfrmd $a class freeMnd $.

  $( Extend class notation with free monoid injection. $)
  cvrmd $a class varFMnd $.

  $( Define a free monoid over a set ` i ` of generators, defined as the set of
     finite strings on ` I ` with the operation of concatenation.  (Contributed
     by Mario Carneiro, 27-Sep-2015.) $)
  df-frmd $a |- freeMnd = ( i e. _V |->
   { <. ( Base ` ndx ) , Word i >. ,
     <. ( +g ` ndx ) , ( concat |` ( Word i X. Word i ) ) >. } ) $.
  ${
    $d i j $.
    $( Define a free monoid over a set ` i ` of generators, defined as the set
       of finite strings on ` I ` with the operation of concatenation.
       (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    df-vrmd $a |- varFMnd = ( i e. _V |-> ( j e. i |-> <" j "> ) ) $.
  $}

  ${
    $d i B $.  $d i I $.  $d i .+ $.  $d i V $.
    frmdval.m $e |- M = ( freeMnd ` I ) $.
    frmdval.b $e |- ( I e. V -> B = Word I ) $.
    frmdval.p $e |- .+ = ( concat |` ( B X. B ) ) $.
    $( Value of the free monoid construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.) $)
    frmdval $p |- ( I e. V ->
      M = { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. } ) $=
      ( vi wcel cfrmd cfv cnx cop cpr cword cconcat cxp cres cvv cplusg cv cmpt
      cbs wceq df-frmd wa wrdeq eqcomd sylan9eqr opeq2d xpeq12d reseq2d syl6eqr
      a1i preq12d elex prex fvmptd syl5eq ) CEJZDCKLMUDLZANZMUALZBNZOZFVAICVBIU
      BZPZNZVDQVHVHRZSZNZOZVFTKTKITVMUCUEVAIUFUOVAVGCUEZUGZVIVCVLVEVOVHAVBVNVAV
      HCPZAVGCUHVAAVPGUIUJZUKVOVKBVDVOVKQAARZSBVOVJVRQVOVHAVHAVQVQULUMHUNUKUPCE
      UQVFTJVAVCVEURUOUSUT $.
  $}

  ${
    $d x y B $.  $d x y I $.
    frmdbas.m $e |- M = ( freeMnd ` I ) $.
    frmdbas.b $e |- B = ( Base ` M ) $.
    $( The base set of a free monoid.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    frmdbas $p |- ( I e. V -> B = Word I ) $=
      ( wcel cbs cfv cword cnx cop cplusg cconcat cxp cres cpr eqidd eqid cvv
      frmdval fveq2d wceq wrdexg grpbase syl eqtr4d syl5eq ) BDGZACHIZBJZFUIUJK
      HIUKLKMINUKUKOPZLQZHIZUKUICUMHUKULBCDEUIUKRULSUAUBUIUKTGUKUNUCBDUDUKULUMT
      UMSUEUFUGUH $.

    $( An element of the base set of a free monoid is a string on the
       generators.  (Contributed by Mario Carneiro, 27-Feb-2016.) $)
    frmdelbas $p |- ( X e. B -> X e. Word I ) $=
      ( wcel cword id cvv wceq cfrmd elbasfv frmdbas syl eleqtrd ) DAGZDABHZQIQ
      BJGARKACLDBEFMABCJEFNOP $.

    frmdplusg.p $e |- .+ = ( +g ` M ) $.
    $( The monoid operation of a free monoid.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    frmdplusg $p |- .+ = ( concat |` ( B X. B ) ) $=
      ( vx vy cvv wcel cconcat cxp cres cbs cfv cplusg fveq2d syl5eq c0 cnx cop
      wceq cpr frmdbas eqid frmdval cword wrdexg wf wfn cv wral wss ccatfn xpss
      co fnssres mp2an wa ovres frmdelbas ccatcl syl2an eqeltrd rgen2a mpbir2an
      ffnov fvex eqeltri xpex fex2 mp3an12 grpplusg 3syl wn cfrmd fvprc res0 c2
      eqtr4d df-plusg str0 eqtr2i syl6eq base0 3eqtr4g xpeq2d reseq2d pm2.61i
      xp0 ) CJKZBLAAMZNZUCWLBUAOPAUBUAQPWNUBUDZQPZWNWLBDQPZWPGWLDWOQAWNCDJEACDJ
      EFUEWNUFUGRSWLCUHZJKZWNJKZWNWPUCCJUIWMWRWNUJZWMJKWSWTXAWNWMUKZHULZIULZWNU
      QZWRKZIAUMHAUMLJJMZUKWMXGUNXBUOAAUPXGWMLURUSXFHIAXCAKZXDAKZUTXEXCXDLUQZWR
      XCXDAALVAXHXCWRKXDWRKXJWRKXIACDXCEFVBACDXDEFVBCXCXDVCVDVEVFHIAAWRWNVHVGAA
      ADOPZJFDOVIVJZXLVKWMWRWNJJVLVMAWNWOJWOUFVNVOWAWLVPZBLTNZWNXMBTQPZXNXMBWQX
      OGXMDTQXMDCVQPTECVQVRSZRSXNTXOLVSQVTWBWCWDWEXMWMTLXMWMATMTXMATAXMXKTOPATX
      MDTOXPRFWFWGWHAWKWEWIWAWJ $.

    $( Value of the monoid operation of the free monoid construction.
       (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    frmdadd $p |- ( ( X e. B /\ Y e. B ) -> ( X .+ Y ) = ( X concat Y ) ) $=
      ( wcel wa co cconcat cxp cres frmdplusg oveqi ovres syl5eq ) EAJFAJKEFBLE
      FMAANOZLEFMLBTEFABCDGHIPQEFAAMRS $.
  $}

  ${
    $d j A $.  $d i j x y I $.  $d i j x y R $.  $d j V $.  $d j X $.
    vrmdfval.u $e |- U = ( varFMnd ` I ) $.
    $( The canonical injection from the generating set ` I ` to the base set of
       the free monoid.  (Contributed by Mario Carneiro, 27-Feb-2016.) $)
    vrmdfval $p |- ( I e. V -> U = ( j e. I |-> <" j "> ) ) $=
      ( vi wcel cvrmd cfv cv cs1 cmpt cvv wceq elex cword wf s1cl adantl eqid
      fmptd wrdexg fex2 syl3anc mpteq1 df-vrmd fvmptg syl2anc syl5eq ) CDGZACHI
      ZBCBJZKZLZEUJCMGZUNMGZUKUNNCDOZUJCCPZUNQUOURMGUPUJBCUMURUNULCGUMURGUJULCR
      SUNTUAUQCDUBCURUNMMUCUDFCBFJZUMLUNMMHBUSCUMUEFBUFUGUHUI $.

    $( The value of the generating elements of a free monoid.  (Contributed by
       Mario Carneiro, 27-Feb-2016.) $)
    vrmdval $p |- ( ( I e. V /\ A e. I ) -> ( U ` A ) = <" A "> ) $=
      ( vj wcel wa cs1 cword cmpt wceq vrmdfval adantr s1eq adantl simpr fvmptd
      cv s1cl ) CDGZACGZHZFAFSZIZAIZCBCJZUABFCUEKLUBBFCDEMNUDALUEUFLUCUDAOPUAUB
      QUBUFUGGUAACTPR $.

    $( The mapping from the index set to the generators is a function into the
       free monoid.  (Contributed by Mario Carneiro, 27-Feb-2016.) $)
    vrmdf $p |- ( I e. V -> U : I --> Word I ) $=
      ( vj wcel cword wf cs1 cmpt s1cl adantl eqid fmptd vrmdfval feq1d mpbird
      cv ) BCFZBBGZAHBTEBERZIZJZHSEBUBTUCUABFUBTFSUABKLUCMNSBTAUCAEBCDOPQ $.
  $}

  ${
    $d x A $.  $d x y z I $.  $d x y J $.  $d x y z M $.  $d x y z U $.
    $d x y z V $.  $d x W $.
    frmdmnd.m $e |- M = ( freeMnd ` I ) $.
    $( A free monoid is a monoid.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    frmdmnd $p |- ( I e. V -> M e. Mnd ) $=
      ( vx vy vz wcel cfv c0 cv cconcat frmdadd frmdelbas wceq eleqtrrd syl2anc
      co wa syl cbs cplusg eqidd w3a eqid ccatcl syl2an eqeltrd 3adant1 frmdbas
      cword 3ad2ant1 simpr1 simpr2 simpr3 ccatass syl3anc adantr 3eqtr4d oveq1d
      oveq2d wrd0 syl5eleqr sylan adantl ccatlid eqtrd ancoms ccatrid ismndd )
      ACHZEFGBUAIZBUBIZBJVKVLUCVKVMUCVKEKZVLHZFKZVLHZUDVNVPVMRZAUKZVLVOVQVRVSHV
      KVOVQSVRVNVPLRZVSVLVMABVNVPDVLUEZVMUEZMZVOVNVSHZVPVSHZVTVSHZVQVLABVNDWANZ
      VLABVPDWANZAVNVPUFUGZUHUIVKVOVLVSOZVQVLABCDWAUJZULPVKVOVQGKZVLHZUDZSZVTWL
      VMRZVNVPWLLRZVMRZVRWLVMRVNVPWLVMRZVMRWOVTWLLRZVNWQLRZWPWRWOWDWEWLVSHZWTXA
      OWOVOWDVKVOVQWMUMZWGTWOVQWEVKVOVQWMUNZWHTZWOWMXBVKVOVQWMUOZVLABWLDWANTZAV
      NVPWLUPUQWOVTVLHWMWPWTOWOVTVSVLWOVOVQWFXCXDWIQVKWJWNWKURZPXFVLVMABVTWLDWA
      WBMQWOVOWQVLHWRXAOXCWOWQVSVLWOWEXBWQVSHXEXGAVPWLUFQXHPVLVMABVNWQDWAWBMQUS
      WOVRVTWLVMWOVOVQVRVTOXCXDWCQUTWOWSWQVNVMWOVQWMWSWQOXDXFVLVMABVPWLDWAWBMQV
      AUSVKJVSVLAVBWKVCZVKVOSZJVNVMRZJVNLRZVNVKJVLHZVOXKXLOXIVLVMABJVNDWAWBMVDX
      JWDXLVNOVOWDVKWGVEZAVNVFTVGXJVNJVMRZVNJLRZVNVKXMVOXOXPOZXIVOXMXQVLVMABVNJ
      DWAWBMVHVDXJWDXPVNOXNAVNVITVGVJ $.

    $( The identity of the free monoid is the empty word.  (Contributed by
       Mario Carneiro, 27-Sep-2015.) $)
    frmd0 $p |- (/) = ( 0g ` M ) $=
      ( vx cvv wcel c0 c0g cfv wceq cbs cplusg eqid cconcat frmdadd sylan eqtrd
      co syl cfrmd cword wrd0 frmdbas syl5eleqr frmdelbas adantl ccatlid ancoms
      cv wa ccatrid ismgmid2 wn fvprc syl5eq fveq2d 0g0 syl6reqr pm2.61i ) AEFZ
      GBHIZJUTDBKIZBLIZGBVAVBMZVAMVCMZUTGAUAZVBAUBVBABECVDUCUDZUTDUIZVBFZUJZGVH
      VCRZGVHNRZVHUTGVBFZVIVKVLJVGVBVCABGVHCVDVEOPVJVHVFFZVLVHJVIVNUTVBABVHCVDU
      EUFZAVHUGSQVJVHGVCRZVHGNRZVHUTVMVIVPVQJZVGVIVMVRVBVCABVHGCVDVEOUHPVJVNVQV
      HJVOAVHUKSQULUTUMZVAGHIGVSBGHVSBATIGCATUNUOUPUQURUS $.

    $( The set of words taking values in a subset is a (free) submonoid of the
       free monoid.  (Contributed by Mario Carneiro, 27-Sep-2015.)  (Revised by
       Mario Carneiro, 27-Feb-2016.) $)
    frmdsssubm $p |- ( ( I e. V /\ J C_ I ) ->
        Word J e. ( SubMnd ` M ) ) $=
      ( vx vy wcel wss wa cword cfv c0 cv co wral adantl wceq eqid adantr sswrd
      csubmnd cbs cplusg frmdbas sseqtr4d wrd0 cconcat sselda anim12dan frmdadd
      a1i syl ccatcl eqeltrd ralrimivva cmnd w3a frmdmnd frmd0 issubm mpbir3and
      wb ) ADHZBAIZJZBKZCUBLHZVGCUCLZIZMVGHZFNZGNZCUDLZOZVGHZGVGPFVGPZVFVGAKZVI
      VEVGVRIVDBAUAQVDVIVRRVEVIACDEVISZUETUFZVKVFBUGULVFVPFGVGVGVFVLVGHZVMVGHZJ
      ZJZVOVLVMUHOZVGWDVLVIHZVMVIHZJVOWERVFWAWFWBWGVFVGVIVLVTUIVFVGVIVMVTUIUJVI
      VNACVLVMEVSVNSZUKUMWCWEVGHVFBVLVMUNQUOUPVFCUQHZVHVJVKVQURVCVDWIVEACDEUSTF
      GVIVNVGCMVSACEUTWHVAUMVB $.

    frmdgsum.u $e |- U = ( varFMnd ` I ) $.
    $( Any word in a free monoid can be expressed as the sum of the singletons
       composing it.  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    frmdgsum $p |- ( ( I e. V /\ W e. Word I ) ->
      ( M gsum ( U o. W ) ) = W ) $=
      ( wcel ccom cgsu co wceq wi c0 cconcat coeq2 oveq2d id eqeq12d eqtrd co02
      vx vy vz cword cv cs1 syl6eq imbi2d frmd0 gsum0 wa oveq1 wf simprl simprr
      a1i s1cld vrmdf adantr ccatco syl3anc s1co syl2anc vrmdval adantrl cplusg
      cfv s1eqd cmnd cbs frmdmnd wrdco eqid frmdbas wrdeq syl eleqtrrd gsumccat
      gsumws1 gsumwcl frmdadd eqeq1d syl5ibr expcom a2d wrdind impcom ) EBUEZHB
      DHZCAEIZJKZELZWJCAUBUFZIZJKZWNLZMWJCNJKZNLZMWJCAUCUFZIZJKZWTLZMWJCAWTUDUF
      ZUGZOKZIZJKZXFLZMWJWMMUBUCUDEBWNNLZWQWSWJXJWPWRWNNXJWONCJXJWOANINWNNAPAUA
      UHQXJRSUIWNWTLZWQXCWJXKWPXBWNWTXKWOXACJWNWTAPQXKRSUIWNXFLZWQXIWJXLWPXHWNX
      FXLWOXGCJWNXFAPQXLRSUIWNELZWQWMWJXMWPWLWNEXMWOWKCJWNEAPQXMRSUIWSWJCNBCFUJ
      UKUQWTWIHZXDBHZULZWJXCXIWJXPXCXIMXCXIWJXPULZXBXEOKZXFLXBWTXEOUMXQXHXRXFXQ
      XHCXAXEUGZOKZJKZXRXQXGXTCJXQXGXAAXEIZOKZXTXQXNXEWIHBWIAUNZXGYCLWJXNXOUOZX
      QXDBWJXNXOUPZURZWJYDXPABDGUSUTZBWIWTXEAVAVBXQYBXSXAOXQYBXDAVHZUGZXSXQXOYD
      YBYJLYFYHBWIXDAVCVDXQYIXEWJXOYIXELXNXDABDGVEVFVITQTQXQYAXBCXSJKZCVGVHZKZX
      RXQCVJHZXACVKVHZUEZHZXSYPHYAYMLWJYNXPBCDFVLUTZXQXAWIUEZYPXQXNYDXAYSHYEYHB
      WIAWTVMVDXQYOWILZYPYSLWJYTXPYOBCDFYOVNZVOUTZYOWIVPVQVRZXQXEYOXQXEWIYOYGUU
      BVRZURYOYLCXAXSUUAYLVNZVSVBXQYMXBXEYLKZXRXQYKXEXBYLXQXEYOHZYKXELUUDYOXECU
      UAVTVQQXQXBYOHZUUGUUFXRLXQYNYQUUHYRUUCYOCXAUUAWAVDUUDYOYLBCXBXEFUUAUUEWBV
      DTTTWCWDWEWFWGWH $.

    $( A subset of generators is contained in a submonoid iff the set of words
       on the generators is in the submonoid.  This can be viewed as an
       elementary way of saying "the monoidal closure of ` J ` is
       ` Word J ` ".  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    frmdss2 $p |- ( ( I e. V /\ J C_ I /\ A e. ( SubMnd ` M ) ) ->
      ( ( U " J ) C_ A <-> Word J C_ A ) ) $=
      ( vx wcel wss cfv cword wa ccom co wceq syl syl2anc wf csubmnd w3a simpl1
      cima cv cgsu simpl2 sswrd simprr sseldd frmdgsum simpl3 cres crn cc0 cfzo
      chash wrdf ad2antll frn cores wfn vrmdf 3ad2ant1 ffn adantr df-ima simprl
      fnssres syl5eqssr df-f sylanbrc wrdco eqeltrrd gsumwsubmcl expr ssrdv cs1
      ex wi wral simp2 sselda vrmdval simpr s1cld eqeltrd ralrimiva wfun cdm wb
      fnfun fndm sseqtr4d funimass4 mpbird sstr2 impbid ) CFJZDCKZAEUALJZUBZBDU
      DZAKZDMZAKZXBXDXFXBXDNIXEAXBXDIUEZXEJZXGAJXBXDXHNZNZEBXGOZUFPZXGAXJWSXGCM
      ZJXLXGQWSWTXAXIUCXJXEXMXGXJWTXEXMKWSWTXAXIUGZDCUHRXBXDXHUIZUJBCEFXGGHUKSX
      JXAXKAMZJXLAJWSWTXAXIULXJBDUMZXGOZXKXPXJXGUNDKZXRXKQXJUOXGUQLUPPZDXGTZXSX
      HYAXBXDDXGURUSXTDXGUTRBXGDVARXJXHDAXQTZXRXPJXOXJXQDVBZXQUNZAKYBXJBCVBZWTY
      CXBYEXIXBCXMBTZYEWSWTYFXABCFHVCVDCXMBVERZVFXNCDBVISXJYDXCABDVGXBXDXHVHVJD
      AXQVKVLDAXQXGVMSVNAEXKVOSVNVPVQVSXBXCXEKZXFXDVTXBYHXGBLZXEJZIDWAZXBYJIDXB
      XGDJZNZYIXGVRZXEYMWSXGCJYIYNQWSWTXAYLUCXBDCXGWSWTXAWBZWCXGBCFHWDSYMXGDXBY
      LWEWFWGWHXBBWIZDBWJZKYHYKWKXBYEYPYGCBWLRXBDCYQYOXBYEYQCQYGCBWMRWNIDXEBWOS
      WPXCXEAWQRWR $.
  $}

  ${
    $d x A $.  $d x B $.  $d y z E $.  $d x y z G $.  $d x y z ph $.  $d x Y $.
    $d x y z I $.  $d y z M $.
    frmdup.m $e |- M = ( freeMnd ` I ) $.
    frmdup.b $e |- B = ( Base ` G ) $.
    frmdup.e $e |- E = ( x e. Word I |-> ( G gsum ( A o. x ) ) ) $.
    frmdup.g $e |- ( ph -> G e. Mnd ) $.
    frmdup.i $e |- ( ph -> I e. X ) $.
    frmdup.a $e |- ( ph -> A : I --> B ) $.
    $( Any assignment of the generators to target elements can be extended
       (uniquely) to a homomorphism from a free monoid to an arbitrary other
       monoid.  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    frmdup1 $p |- ( ph -> E e. ( M MndHom G ) ) $=
      ( wcel co wceq c0 cgsu vy vz cmnd wa cbs cfv wf cv cplusg c0g w3a frmdmnd
      wral cmhm syl cword ccom adantr simpr wrdco syl2anc gsumwcl fmptd frmdbas
      jca eqid mpbird cconcat frmdelbas ad2antrl ad2antll ccatco syl3anc oveq2d
      feq2d gsumccat eqtrd frmdadd adantl fveq2d ccatcl coeq2 fvmpt3i oveqan12d
      ovex 3eqtr4d ralrimivva wrd0 co02 syl6eq gsum0 mp1i frmd0 ismhm sylanbrc
      3jca ) AHUCPZFUCPZUDHUEUFZDEUGZUAUHZUBUHZHUIUFZQZEUFZXAEUFZXBEUFZFUIUFZQZ
      RZUBWSUMUAWSUMZSEUFFUJUFZRZUKEHFUNQPAWQWRAGIPZWQNGHIJULUOMVEAWTXKXMAWTGUP
      ZDEUGABXOFCBUHZUQZTQZDEAXPXOPZUDZWRXQDUPZPZXRDPAWRXSMURXTXSGDCUGZYBAXSUSA
      YCXSOURGDCXPUTVADFXQKVBVALVCAWSXODEAXNWSXORNWSGHIJWSVFZVDUOVOVGAXJUAUBWSW
      SAXAWSPZXBWSPZUDZUDZFCXAXBVHQZUQZTQZFCXAUQZTQZFCXBUQZTQZXHQZXEXIYHYKFYLYN
      VHQZTQZYPYHYJYQFTYHXAXOPZXBXOPZYCYJYQRYEYSAYFWSGHXAJYDVIVJZYFYTAYEWSGHXBJ
      YDVIVKZAYCYGOURZGDXAXBCVLVMVNYHWRYLYAPZYNYAPZYRYPRAWRYGMURYHYSYCUUDUUAUUC
      GDCXAUTVAYHYTYCUUEUUBUUCGDCXBUTVADXHFYLYNKXHVFZVPVMVQYHXEYIEUFZYKYHXDYIEY
      GXDYIRAWSXCGHXAXBJYDXCVFZVRVSVTYHYIXOPZUUGYKRYHYSYTUUIUUAUUBGXAXBWAVABYIX
      RYKXOEXPYIRXQYJFTXPYICWBVNLFXQTWEZWCUOVQYHYSYTXIYPRUUAUUBYSYTXFYMXGYOXHBX
      AXRYMXOEXPXARXQYLFTXPXACWBVNLUUJWCBXBXRYOXOEXPXBRXQYNFTXPXBCWBVNLUUJWCWDV
      AWFWGSXOPXMAGWHBSXRXLXOEXPSRZXRFSTQXLUUKXQSFTUUKXQCSUQSXPSCWBCWIWJVNFXLXL
      VFZWKWJLUUJWCWLWPUAUBWSDXCXHHFEXLSYDKUUHUUFGHJWMUULWNWO $.

    frmdup2.u $e |- U = ( varFMnd ` I ) $.
    frmdup2.y $e |- ( ph -> Y e. I ) $.
    $( The evaluation map has the intended behavior on the generators.
       (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    frmdup2 $p |- ( ph -> ( E ` ( U ` Y ) ) = ( A ` Y ) ) $=
      ( cgsu cfv cs1 wcel wceq vrmdval syl2anc fveq2d ccom co cword s1cld coeq2
      cv oveq2d ovex fvmpt3i syl wf s1co ffvelrnd gsumws1 3eqtrd eqtrd ) AKEUAZ
      FUAKUBZFUAZKCUAZAVDVEFAHJUCKHUCZVDVEUDPSKEHJRUEUFUGAVFGCVEUHZTUIZGVGUBZTU
      IZVGAVEHUJZUCVFVJUDAKHSUKBVEGCBUMZUHZTUIVJVMFVNVEUDVOVIGTVNVECULUNNGVOTUO
      UPUQAVIVKGTAVHHDCURVIVKUDSQHDKCUSUFUNAVGDUCVLVGUDAHDKCQSUTDVGGMVAUQVBVC
      $.
  $}

  ${
    $d m x y A $.  $d m x y B $.  $d m x y G $.  $d m x y I $.  $d m x y U $.
    $d m x y M $.  $d m x y V $.
    frmdup3.m $e |- M = ( freeMnd ` I ) $.
    frmdup3.b $e |- B = ( Base ` G ) $.
    frmdup3.u $e |- U = ( varFMnd ` I ) $.
    $( Universal property of the free monoid by existential uniqueness.
       (Contributed by Mario Carneiro, 2-Oct-2015.)  (Revised by Mario
       Carneiro, 27-Feb-2016.) $)
    frmdup3 $p |- ( ( G e. Mnd /\ I e. V /\ A : I --> B ) ->
      E! m e. ( M MndHom G ) ( m o. U ) = A ) $=
      ( vx vy wcel wf ccom cgsu co wceq cfv cmnd w3a cword cv cmpt cmhm wi wral
      wreu eqid simp1 simp2 simp3 frmdup1 wa adantr simpr frmdup2 mpteq2dva cbs
      mhmf vrmdf 3ad2ant2 wb frmdbas feq3 mpbird fcompt syl2anc feqmptd 3eqtr4d
      syl ad2antrl feq2d mpbid simplrl ad2antrr wrdco gsumwmhm frmdgsum simplrr
      fveq2d coass coeq1d syl5eqr oveq2d 3eqtr3d eqtrd ralrimiva eqeq1d syl3anc
      expr coeq1 eqreu ) EUANZFHNZFBAOZUBZLFUCZEALUDZPZQRZUEZGEUFRZNZXCCPZASZDU
      DZCPZASZXHXCSZUGZDXDUHXJDXDUIWRLABXCEFGHIJXCUJZWOWPWQUKZWOWPWQULZWOWPWQUM
      ZUNZWRMFMUDZCTXCTZUEZMFXRATZUEXFAWRMFXSYAWRXRFNZUOLABCXCEFGHXRIJXMWRWOYBX
      NUPWRWPYBXOUPWRWQYBXPUPKWRYBUQURUSWRGUTTZBXCOZFYCCOZXFXTSWRXEYDXQYCBGEXCY
      CUJZJVAVLWRYEFWSCOZWPWOYGWQCFHKVBVCWRYCWSSZYEYGVDWPWOYHWQYCFGHIYFVEVCZYCW
      SFCVFVLVGZMXCCFYCBVHVIWRMFBAXPVJVKWRXLDXDWRXHXDNZXJXKWRYKXJUOZUOZXHLWSWTX
      HTZUEXCYMLWSBXHYMYCBXHOZWSBXHOYKYOWRXJYCBGEXHYFJVAVMYMYCWSBXHWRYHYLYIUPVN
      VOVJYMLWSYNXBYMWTWSNZUOZGCWTPZQRZXHTZEXHYRPZQRZYNXBYQYKYRYCUCNZYTUUBSWRYK
      XJYPVPYQYPYEUUCYMYPUQZWRYEYLYPYJVQFYCCWTVRVIYCXHGEYRYFVSVIYQYSWTXHYQWPYPY
      SWTSWRWPYLYPXOVQUUDCFGHWTIKVTVIWBYQUUAXAEQYQUUAXIWTPXAXHCWTWCYQXIAWTWRYKX
      JYPWAWDWEWFWGUSWHWLWIXJXGDXDXCXKXIXFAXHXCCWMWJWNWK $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Groups
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a g m n s w x y $.
    $( Define class of all groups.  A group is a monoid ( ~ df-mnd ) whose
       internal operation is such that every element admits a left inverse
       (which can be proven to be a two-sided inverse).  Thus, a group ` G ` is
       an algebraic structure formed from a base set of elements (notated
       ` ( Base `` G ) ` per ~ df-base ) and an internal group operation
       (notated ` ( +g `` G ) ` per ~ df-plusg ).  The operation combines any
       two elements of the group base set and must satisfy the 4 group axioms:
       closure (the result of the group operation must always be a member of
       the base set, see ~ grpcl ), associativity (so
       ` ( ( a +g b ) +g c ) = ( a +g ( b +g c ) ) ` for any a, b, c, see
       ~ grpass ), identity (there must be an element ` e = ( 0g `` G ) ` such
       that ` e +g a = e +g a = a ` for any a), and inverse (for each element a
       in the base set, there must be an element ` b = invg a ` in the base set
       such that ` a +g b = b +g a = e ` ).  It can be proven that the identity
       element is unique ( ~ grpideu ).  Groups need not be commutative; a
       commutative group is an Abelian group (see ~ df-abl ).  Subgroups can
       often be formed from groups, see ~ df-subg .  An example of an (Abelian)
       group is the set of complex numbers ` CC ` over the group operation
       ` + ` (addition), as proven in ~ cnaddablx ; an Abelian group is a group
       as proven in ~ ablgrp .  Other structures include groups, including
       unital rings ( ~ df-rng ) and fields ( ~ df-field ).  (Contributed by
       NM, 17-Oct-2012.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    df-grp $a |- Grp = { g e. Mnd | A. a e. ( Base ` g ) E. m e. ( Base ` g )
      ( m ( +g ` g ) a ) = ( 0g ` g ) } $.

    $( Define inverse of group element.  (Contributed by NM, 24-Aug-2011.) $)
    df-minusg $a |- invg = ( g e. _V |-> ( x e. ( Base ` g )
  |-> ( iota_ w e. ( Base ` g ) ( w ( +g ` g ) x ) = ( 0g ` g ) ) ) ) $.

    $( Define group subtraction (also called division for multiplicative
       groups).  (Contributed by NM, 31-Mar-2014.) $)
    df-sbg $a |- -g = ( g e. _V |-> ( x e. ( Base ` g ) , y e. ( Base ` g )
  |-> ( x ( +g ` g ) ( ( invg ` g ) ` y ) ) ) ) $.

    $( Define the group multiple function, also known as group exponentiation
       when viewed multiplicatively.  (Contributed by Mario Carneiro,
       11-Dec-2014.) $)
    df-mulg $a |- .g = ( g e. _V |-> ( n e. ZZ , x e. ( Base ` g ) |->
    if ( n = 0 , ( 0g ` g ) , [_ seq 1 ( ( +g ` g ) , ( NN X. { x } ) ) / s ]_
      if ( 0 < n , ( s ` n ) , ( ( invg ` g ) ` ( s ` -u n ) ) ) ) ) ) $.
  $}

  ${
    $d a g m B $.  $d a g m G $.  $d g .+ $.  $d g .0. $.
    isgrp.b $e |- B = ( Base ` G ) $.
    isgrp.p $e |- .+ = ( +g ` G ) $.
    isgrp.z $e |- .0. = ( 0g ` G ) $.
    $( The predicate "is a group."  (This theorem demonstrates the use of
       symbols as variable names, first proposed by FL in 2010.)  (Contributed
       by NM, 17-Oct-2012.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    isgrp $p |- ( G e. Grp <->
      ( G e. Mnd /\ A. a e. B E. m e. B ( m .+ a ) = .0. ) ) $=
      ( vg cv cplusg cfv co c0g wceq cbs wrex fveq2 syl6eqr wral cmnd rexeqbidv
      cgrp oveqd eqeq12d raleqbidv df-grp elrab2 ) CKZFKZJKZLMZNZULOMZPZCULQMZR
      ZFUQUAUJUKBNZEPZCARZFAUAJDUBUDULDPZURVAFUQAVBUQDQMAULDQSGTZVBUPUTCUQAVCVB
      UNUSUOEVBUMBUJUKVBUMDLMBULDLSHTUEVBUODOMEULDOSITUFUCUGJCFUHUI $.
  $}

  ${
    $d u x y B $.  $d a m u x y G $.  $d u x .+ $.  $d x y X $.  $d x .0. $.
    $( A group is a monoid.  (Contributed by Mario Carneiro, 6-Jan-2015.) $)
    grpmnd $p |- ( G e. Grp -> G e. Mnd ) $=
      ( vm va cgrp wcel cmnd cv cplusg cfv co c0g wceq cbs wrex wral eqid isgrp
      simplbi ) ADEAFEBGCGAHIZJAKIZLBAMIZNCUAOUASBATCUAPSPTPQR $.

    grpcl.b $e |- B = ( Base ` G ) $.
    grpcl.p $e |- .+ = ( +g ` G ) $.
    $( Closure of the operation of a group.  (Contributed by NM,
       14-Aug-2011.) $)
    grpcl $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) -> ( X .+ Y ) e. B ) $=
      ( cgrp wcel cmnd co grpmnd mndcl syl3an1 ) CHICJIDAIEAIDEBKAICLABCDEFGMN
      $.

    $( A group operation is associative.  (Contributed by NM, 14-Aug-2011.) $)
    grpass $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
              ( ( X .+ Y ) .+ Z ) = ( X .+ ( Y .+ Z ) ) ) $=
      ( cgrp wcel cmnd w3a co wceq grpmnd mndass sylan ) CIJCKJDAJEAJFAJLDEBMFB
      MDEFBMBMNCOABCDEFGHPQ $.

    grpinvex.p $e |- .0. = ( 0g ` G ) $.
    $( Every member of a group has a left inverse.  (Contributed by NM,
       16-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    grpinvex $p |- ( ( G e. Grp /\ X e. B ) -> E. y e. B ( y .+ X ) = .0. ) $=
      ( vx cgrp wcel cv co wceq wrex wral cmnd isgrp simprbi oveq2 eqeq1d sylan
      rexbidv rspccva ) DKLZAMZJMZCNZFOZABPZJBQZEBLUGECNZFOZABPZUFDRLULBCADFJGH
      ISTUKUOJEBUHEOZUJUNABUPUIUMFUHEUGCUAUBUDUEUC $.

    $( The two-sided identity element of a group is unique.  Lemma 2.2.1(a) of
       [Herstein] p. 55.  (Contributed by NM, 16-Aug-2011.)  (Revised by Mario
       Carneiro, 8-Dec-2014.) $)
    grpideu $p |- ( G e. Grp ->
      E! u e. B A. x e. B ( ( u .+ x ) = x /\ ( x .+ u ) = x ) ) $=
      ( cgrp wcel cmnd cv co wceq wa wral wreu grpmnd mndideu syl ) EJKELKBMZAM
      ZDNUCOUCUBDNUCOPACQBCRESABCDEGHTUA $.
  $}


  ${
    grpplusf.1 $e |- B = ( Base ` G ) $.
    grpplusf.2 $e |- F = ( +f ` G ) $.
    $( The group addition operation is a function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    grpplusf $p |- ( G e. Grp -> F : ( B X. B ) --> B ) $=
      ( cgrp wcel cmnd cxp wf grpmnd mndplusf syl ) CFGCHGAAIABJCKABCDELM $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y L $.  $d x y ph $.
    grppropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    grppropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    grppropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    $( If two structures have the same group components (properties), one is a
       group iff the other one is.  (Contributed by Stefan O'Rear,
       27-Nov-2014.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    grppropd $p |- ( ph -> ( K e. Grp <-> L e. Grp ) ) $=
      ( cmnd wcel cv cplusg cfv co wceq wrex wral wa eqid c0g cbs cgrp mndpropd
      wb grpidpropd adantr eqeq12d anass1rs rexbidva ralbidva rexeqdv raleqbidv
      3bitr3d anbi12d isgrp 3bitr4g ) AEJKZBLZCLZEMNZOZEUANZPZBEUBNZQZCVERZSFJK
      ZUSUTFMNZOZFUANZPZBFUBNZQZCVMRZSEUCKFUCKAURVHVGVOABCDEFGHIUDAVDBDQZCDRVLB
      DQZCDRVGVOAVPVQCDAUTDKZSVDVLBDAUSDKZVRVDVLUEAVSVRSZSVBVJVCVKIAVCVKPVTABCD
      EFGHIUFUGUHUIUJUKAVPVFCDVEGAVDBDVEGULUMAVQVNCDVMHAVLBDVMHULUMUNUOVEVABEVC
      CVETVATVCTUPVMVIBFVKCVMTVITVKTUPUQ $.
  $}

  ${
    $d x y K $.  $d x y L $.
    grpprop.b $e |- ( Base ` K ) = ( Base ` L ) $.
    grpprop.p $e |- ( +g ` K ) = ( +g ` L ) $.
    $( If two structures have the same group components (properties), one is a
       group iff the other one is.  (Contributed by NM, 11-Oct-2013.) $)
    grpprop $p |- ( K e. Grp <-> L e. Grp ) $=
      ( vx vy cgrp wcel wb wtru cbs cfv eqidd wceq a1i cv cplusg co wa oveqi
      grppropd trud ) AGHBGHIJEFAKLZABJUCMUCBKLNJCOEPZFPZAQLZRUDUEBQLZRNJUDUCHU
      EUCHSSUFUGUDUEDTOUAUB $.
  $}

  ${
    grppropstr.b $e |- ( Base ` K ) = B $.
    grppropstr.p $e |- ( +g ` K ) = .+ $.
    grppropstr.l $e |- L
          = { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. } $.
    $( Generalize a specific 2-element group ` L ` to show that any set ` K `
       with the same (relevant) properties is also a group.  (Contributed by
       NM, 28-Oct-2012.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    grppropstr $p |- ( K e. Grp <-> L e. Grp ) $=
      ( cbs cfv cvv wcel wceq fvex eqeltrri grpbase ax-mp eqtri cplusg grpplusg
      grpprop ) CDCHIZADHIZEAJKAUBLUAAJECHMNABDJGOPQCRIZBDRIZFBJKBUDLUCBJFCRMNA
      BDJGSPQT $.
  $}

  ${
    grpss.g $e |- G = { <. ( Base ` ndx ) , B >. , <. ( +g ` ndx ) , .+ >. } $.
    grpss.r $e |- R e. _V $.
    grpss.s $e |- G C_ R $.
    grpss.f $e |- Fun R $.
    $( Show that a structure extending a constructed group (e.g. a ring) is
       also a group.  This allows us to prove that a constructed potential ring
       ` R ` is a group before we know that it is also a ring.  (Theorem
       ~ rnggrp , on the other hand, requires that we know in advance that
       ` R ` is a ring.)  (Contributed by NM, 11-Oct-2013.) $)
    grpss $p |- ( G e. Grp <-> R e. Grp ) $=
      ( cgrp wcel cbs baseid cnx cfv cop cplusg cpr opex eleqtrri strss plusgid
      prid1 prid2 grpprop bicomi ) CIJDIJCDADCKFHGLMKNZAOZUGMPNZBOZQZDUGUIUFARU
      BESTBDCPFHGUAUIUJDUGUIUHBRUCESTUDUE $.
  $}

  ${
    $d x y .+ $.  $d y .0. $.  $d x y B $.  $d x y G $.  $d x y ph $.
    $d y N $.
    isgrpd2.b $e |- ( ph -> B = ( Base ` G ) ) $.
    isgrpd2.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    isgrpd2.z $e |- ( ph -> .0. = ( 0g ` G ) ) $.
    isgrpd2.g $e |- ( ph -> G e. Mnd ) $.
    ${
      isgrpd2e.n $e |- ( ( ph /\ x e. B ) -> E. y e. B ( y .+ x ) = .0. ) $.
      $( Deduce a group from its properties.  In this version of ~ isgrpd2 , we
         don't assume there is an expression for the inverse of ` x ` .
         (Contributed by NM, 10-Aug-2013.) $)
      isgrpd2e $p |- ( ph -> G e. Grp ) $=
        ( wcel cv cfv co wceq wrex wral eqid cmnd cplusg c0g cbs cgrp ralrimiva
        oveqd eqeq12d rexeqbidv raleqbidv mpbid isgrp sylanbrc ) AFUAMCNZBNZFUB
        OZPZFUCOZQZCFUDOZRZBUTSZFUEMKAUNUOEPZGQZCDRZBDSVBAVEBDLUFAVEVABDUTHAVDU
        SCDUTHAVCUQGURAEUPUNUOIUGJUHUIUJUKUTUPCFURBUTTUPTURTULUM $.
    $}

    isgrpd2.n $e |- ( ( ph /\ x e. B ) -> N e. B ) $.
    isgrpd2.j $e |- ( ( ph /\ x e. B ) -> ( N .+ x ) = .0. ) $.
    $( Deduce a group from its properties. ` N ` (negative) is normally
       dependent on ` x ` i.e. read it as ` N ( x ) ` .  Note: normally we
       don't use a ` ph ` antecedent on hypotheses that name structure
       components, since they can be eliminated with ~ eqid , but we make an
       exception for theorems such as ~ isgrpd2 , ~ ismndd , and ~ islmodd
       since theorems using them often rewrite the structure components.
       (Contributed by NM, 10-Aug-2013.) $)
    isgrpd2 $p |- ( ph -> G e. Grp ) $=
      ( vy cv wcel wa co wceq wrex oveq1 eqeq1d rspcev syl2anc isgrpd2e ) ABNCD
      EGHIJKABOZCPQFCPFUFDRZGSZNOZUFDRZGSZNCTLMUKUHNFCUIFSUJUGGUIFUFDUAUBUCUDUE
      $.
  $}

  ${
    $d x y z .+ $.  $d x y z .0. $.  $d x y z B $.  $d y N $.  $d x y z ph $.
    $d x y z G $.
    isgrpd.b $e |- ( ph -> B = ( Base ` G ) ) $.
    isgrpd.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    isgrpd.c $e |- ( ( ph /\ x e. B /\ y e. B ) -> ( x .+ y ) e. B ) $.
    isgrpd.a $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) ) ->
                   ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    isgrpd.z $e |- ( ph -> .0. e. B ) $.
    isgrpd.i $e |- ( ( ph /\ x e. B ) -> ( .0. .+ x ) = x ) $.
    ${
      isgrpde.n $e |- ( ( ph /\ x e. B ) -> E. y e. B ( y .+ x ) = .0. ) $.
      $( Deduce a group from its properties.  In this version of ~ isgrpd , we
         don't assume there is an expression for the inverse of ` x ` .
         (Contributed by NM, 6-Jan-2015.) $)
      isgrpde $p |- ( ph -> G e. Grp ) $=
        ( grpridd grpidd ismndd isgrpd2e ) ABCEFGHIJABEFGHIJMNABCDEFHKMNLOPZQAB
        CDEFGHIJKLMNTROS $.
    $}

    isgrpd.n $e |- ( ( ph /\ x e. B ) -> N e. B ) $.
    isgrpd.j $e |- ( ( ph /\ x e. B ) -> ( N .+ x ) = .0. ) $.
    $( Deduce a group from its properties.  Unlike ~ isgrpd2 , this one goes
       straight from the base properties rather than going through ` Mnd ` .
       ` N ` (negative) is normally dependent on ` x ` i.e. read it as
       ` N ( x ) ` .  (Contributed by NM, 6-Jun-2013.)  (Revised by Mario
       Carneiro, 6-Jan-2015.) $)
    isgrpd $p |- ( ph -> G e. Grp ) $=
      ( cv wcel wceq wa co wrex oveq1 eqeq1d rspcev syl2anc isgrpde ) ABCDEFGIJ
      KLMNOABRZESUAHESHUIFUBZITZCRZUIFUBZITZCEUCPQUNUKCHEULHTUMUJIULHUIFUDUEUFU
      GUH $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d y N $.  $d x y z .+ $.  $d x y z .0. $.
    isgrpi.b $e |- B = ( Base ` G ) $.
    isgrpi.p $e |- .+ = ( +g ` G ) $.
    isgrpi.c $e |- ( ( x e. B /\ y e. B ) -> ( x .+ y ) e. B ) $.
    isgrpi.a $e |- ( ( x e. B /\ y e. B /\ z e. B ) ->
                   ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    isgrpi.z $e |- .0. e. B $.
    isgrpi.i $e |- ( x e. B -> ( .0. .+ x ) = x ) $.
    isgrpi.n $e |- ( x e. B -> N e. B ) $.
    isgrpi.j $e |- ( x e. B -> ( N .+ x ) = .0. ) $.
    $( Properties that determine a group. ` N ` (negative) is normally
       dependent on ` x ` i.e. read it as ` N ( x ) ` .  (Contributed by NM,
       3-Sep-2011.) $)
    isgrpi $p |- G e. Grp $=
      ( wcel wtru wceq co cgrp cbs cfv a1i cplusg cv 3adant1 adantl isgrpd trud
      w3a ) FUAQRABCDEFGHDFUBUCSRIUDEFUEUCSRJUDAUFZDQZBUFZDQZULUNETZDQRKUGUMUOC
      UFZDQUKUPUQETULUNUQETETSRLUHHDQRMUDUMHULETULSRNUHUMGDQROUHUMGULETHSRPUHUI
      UJ $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d y N $.  $d x y z .+ $.  $d x y z .0. $.
    isgrpix.a $e |- B e. _V $.
    isgrpix.b $e |- .+ e. _V $.
    isgrpix.g $e |- G = { <. 1 , B >. , <. 2 , .+ >. } $.
    isgrpix.2 $e |- ( ( x e. B /\ y e. B ) -> ( x .+ y ) e. B ) $.
    isgrpix.3 $e |- ( ( x e. B /\ y e. B /\ z e. B ) ->
                   ( ( x .+ y ) .+ z ) = ( x .+ ( y .+ z ) ) ) $.
    isgrpix.z $e |- .0. e. B $.
    isgrpix.5 $e |- ( x e. B -> ( .0. .+ x ) = x ) $.
    isgrpix.6 $e |- ( x e. B -> N e. B ) $.
    isgrpix.7 $e |- ( x e. B -> ( N .+ x ) = .0. ) $.
    $( Properties that determine a group.  Read ` N ` as ` N ( x ) ` .  Note:
       This theorem has hard-coded structure indices for demonstration
       purposes.  It is not intended for general use.
       (New usage is discouraged.)  (Contributed by NM, 4-Sep-2011.) $)
    isgrpix $p |- G e. Grp $=
      ( grpbasex grpplusgx isgrpi ) ABCDEFGHDEFIJKRDEFIJKSLMNOPQT $.
  $}

  ${
    grpidcl.b $e |- B = ( Base ` G ) $.
    grpidcl.o $e |- .0. = ( 0g ` G ) $.
    $( The identity element of a group belongs to the group.  (Contributed by
       NM, 27-Aug-2011.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
    grpidcl $p |- ( G e. Grp -> .0. e. B ) $=
      ( cgrp wcel cmnd grpmnd mndidcl syl ) BFGBHGCAGBIABCDEJK $.
  $}

  ${
    grpbn0.b $e |- B = ( Base ` G ) $.
    $( The base set of a group is not empty.  (Contributed by Szymon
       Jaroszewicz, 3-Apr-2007.) $)
    grpbn0 $p |- ( G e. Grp -> B =/= (/) ) $=
      ( cgrp wcel c0g cfv c0 wne eqid grpidcl ne0i syl ) BDEBFGZAEAHIABNCNJKANL
      M $.

    grplid.p $e |- .+ = ( +g ` G ) $.
    grplid.o $e |- .0. = ( 0g ` G ) $.
    $( The identity element of a group is a left identity.  (Contributed by NM,
       18-Aug-2011.) $)
    grplid $p |- ( ( G e. Grp /\ X e. B ) -> ( .0. .+ X ) = X ) $=
      ( cgrp wcel cmnd co wceq grpmnd mndlid sylan ) CIJCKJDAJEDBLDMCNABCDEFGHO
      P $.

    $( The identity element of a group is a right identity.  (Contributed by
       NM, 18-Aug-2011.) $)
    grprid $p |- ( ( G e. Grp /\ X e. B ) -> ( X .+ .0. ) = X ) $=
      ( cgrp wcel cmnd co wceq grpmnd mndrid sylan ) CIJCKJDAJDEBLDMCNABCDEFGHO
      P $.
  $}

  $( A group is not empty.  (Contributed by Szymon Jaroszewicz, 3-Apr-2007.)
     (Revised by Mario Carneiro, 2-Dec-2014.) $)
  grpn0 $p |- ( G e. Grp -> G =/= (/) ) $=
    ( cgrp wcel cbs cfv c0 wne eqid grpbn0 wceq fveq2 base0 syl6eqr necon3i syl
    ) ABCADEZFGAFGPAPHIAFPFAFJPFDEFAFDKLMNO $.

  ${
    $d u v w y B $.  $d u v w y G $.  $d u v w y .+ $.  $d u v w y X $.
    $d u v w y Y $.  $d u v w y Z $.
    grprcan.b $e |- B = ( Base ` G ) $.
    grprcan.p $e |- .+ = ( +g ` G ) $.
    $( Right cancellation law for groups.  (Contributed by NM, 24-Aug-2011.)
       (Proof shortened by Mario Carneiro, 6-Jan-2015.) $)
    grprcan $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                  ( ( X .+ Z ) = ( Y .+ Z ) <-> X = Y ) ) $=
      ( vy vu vv vw wcel w3a wa co wceq cv sylan 3eqtr3d cgrp c0g cfv wrex eqid
      wi grpinvex 3ad2antr3 simprr oveq1d simpll grpass simplr1 simplr3 simprll
      caovassd simplr2 grpcl syl3an1 grpidcl syl grplid adantr simprlr grprinvd
      simpr mpdan oveq2d grprid syl2anc expr rexlimddv oveq1 impbid1 ) CUAMZDAM
      ZEAMZFAMZNZOZDFBPZEFBPZQZDEQZVTIRZFBPCUBUCZQZWCWDUFIAVOVPVRWGIAUDVQIABCFW
      FGHWFUEZUGUHVTWEAMZWGOZWCWDVTWJWCOZOZDWFBPZEWFBPZDEWLDFWEBPZBPZEWOBPZWMWN
      WLWAWEBPWBWEBPWPWQWLWAWBWEBVTWJWCUIUJWLJKLDFWEABWLVOJRZAMZKRZAMZLRZAMNWRW
      TBPZXBBPWRWTXBBPBPQVOVSWKUKZABCWRWTXBGHULSZVPVQVRVOWKUMZVPVQVRVOWKUNZVTWI
      WGWCUOZUPWLJKLEFWEABXEVPVQVRVOWKUQZXGXHUPTWLWOWFDBWLVRWOWFQXGWLVRJKLABWEW
      FFWLVOWSXAXCAMXDABCWRWTGHURUSWLVOWFAMXDACWFGWHUTVAWLVOWSWFWRBPWRQXDABCWRW
      FGHWHVBSXEWLVOWSWTWRBPWFQKAUDXDKABCWRWFGHWHUGSWLVRVFWLWIVRXHVCWLWGVRVTWIW
      GWCVDVCVEVGZVHWLWOWFEBXJVHTWLVOVPWMDQXDXFABCDWFGHWHVIVJWLVOVQWNEQXDXIABCE
      WFGHWHVIVJTVKVLDEFBVMVN $.
  $}

  ${
    $d y z B $.  $d y z G $.  $d y z .+ $.  $d y z .0. $.  $d y z X $.
    grpinveu.b $e |- B = ( Base ` G ) $.
    grpinveu.p $e |- .+ = ( +g ` G ) $.
    grpinveu.o $e |- .0. = ( 0g ` G ) $.
    $( The left inverse element of a group is unique.  Lemma 2.2.1(b) of
       [Herstein] p. 55.  (Contributed by NM, 24-Aug-2011.) $)
    grpinveu $p |- ( ( G e. Grp /\ X e. B )
           -> E! y e. B ( y .+ X ) = .0. ) $=
      ( vz cgrp wcel wa cv co wceq wi wral wrex wreu grpinvex w3a eqtr3 grprcan
      syl5ib 3exp2 com24 imp41 an32s exp3a ralrimdva ancld reximdva eqeq1d reu8
      mpd oveq1 sylibr ) DKLZEBLZMZANZECOZFPZJNZECOZFPZVBVEPZQZJBRZMZABSZVDABTV
      AVDABSVLABCDEFGHIUAVAVDVKABVAVBBLZMZVDVJVNVDVIJBVNVEBLZMVDVGVHVAVOVMVDVGM
      ZVHQZUSUTVOVMVQUSVMVOUTVQUSVMVOUTVQVPVCVFPUSVMVOUTUBMVHVCVFFUCBCDVBVEEGHU
      DUEUFUGUHUIUJUKULUMUPVDVGAJBVHVCVFFVBVEECUQUNUOUR $.

    $( Two ways of saying that an element of a group is the identity element.
       Provides a convenient way to compute the value of the identity element.
       (Contributed by NM, 24-Aug-2011.) $)
    grpid $p |- ( ( G e. Grp /\ X e. B ) ->
                  ( ( X .+ X ) = X <-> .0. = X ) ) $=
      ( wceq cgrp wcel wa co eqcom wb wi grpidcl grprcan 3exp2 mpid pm2.43d imp
      grplid eqeq2d bitr3d syl5rbb ) EDIDEIZCJKZDAKZLZDDBMZDIZEDNUJUKEDBMZIZUGU
      LUHUIUNUGOZUHUIUOUHUIEAKZUIUOPACEFHQUHUIUPUIUOABCDEDFGRSTUAUBUJUMDUKABCDE
      FGHUCUDUEUF $.

    $( Properties showing that an element ` Z ` is the identity element of a
       group.  (Contributed by NM, 7-Aug-2013.) $)
    isgrpid2 $p |- ( G e. Grp
  -> ( ( Z e. B /\ ( Z .+ Z ) = Z ) <-> .0. = Z ) ) $=
      ( cgrp wcel co wceq wa grpid biimpd expimpd grpidcl grplid mpdan jca id
      eleq1 oveq12d eqeq12d anbi12d syl5ibcom impbid ) CIJZEAJZEEBKZELZMZDELZUH
      UIUKUMUHUIMUKUMABCEDFGHNOPUHDAJZDDBKZDLZMUMULUHUNUPACDFHQZUHUNUPUQABCDDFG
      HRSTUMUNUIUPUKDEAUBUMUOUJDEUMDEDEBUMUAZURUCURUDUEUFUG $.
  $}

  ${
    $d x B $.  $d x .+ $.  $d x ph $.  $d x .0. $.
    grpidd2.b $e |- ( ph -> B = ( Base ` G ) ) $.
    grpidd2.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    grpidd2.z $e |- ( ph -> .0. e. B ) $.
    grpidd2.i $e |- ( ( ph /\ x e. B ) -> ( .0. .+ x ) = x ) $.
    grpidd2.j $e |- ( ph -> G e. Grp ) $.
    $( Deduce the identity element of a group from its properties.  Useful in
       conjunction with ~ isgrpd .  (Contributed by Mario Carneiro,
       14-Jun-2015.) $)
    grpidd2 $p |- ( ph -> .0. = ( 0g ` G ) ) $=
      ( c0g cfv cplusg co wceq oveqd wcel cv eqid wral ralrimiva oveq2 id rspcv
      eqeq12d sylc eqtr3d cgrp cbs wb eleqtrd grpid syl2anc mpbid eqcomd ) AELM
      ZFAFFENMZOZFPZUQFPZAFFDOZUSFADURFFHQAFCRFBSZDOZVCPZBCUAVBFPZIAVEBCJUBVEVF
      BFCVCFPZVDVBVCFVCFFDUCVGUDUFUEUGUHAEUIRFEUJMZRUTVAUKKAFCVHIGULVHUREFUQVHT
      URTUQTUMUNUOUP $.
  $}

  ${
    $d g x y B $.  $d g x y G $.  $d g x .0. $.  $d g x .+ $.  $d x y X $.
    grpinvval.b $e |- B = ( Base ` G ) $.
    grpinvval.p $e |- .+ = ( +g ` G ) $.
    grpinvval.o $e |- .0. = ( 0g ` G ) $.
    grpinvval.n $e |- N = ( invg ` G ) $.
    $( The inverse function of a group.  (Contributed by NM, 24-Aug-2011.)
       (Revised by Mario Carneiro, 7-Aug-2013.) $)
    grpinvfval $p |- N = ( x e. B |-> ( iota_ y e. B ( y .+ x ) = .0. ) ) $=
      ( vg cminusg cfv cv wceq cmpt cbs syl6eqr c0 co crio cvv cplusg c0g fveq2
      wcel oveqd eqeq12d riotaeqbidv mpteq12dv df-minusg eqeltri mptex fvmpt wn
      fvex fvprc mpt0 syl5eq mpteq1d eqtr4d pm2.61i eqtri ) FEMNZACBOZAOZDUAZGP
      ZBCUBZQZKEUCUGZVEVKPLEALOZRNZVFVGVMUDNZUAZVMUENZPZBVNUBZQVKUCMVMEPZAVNVSC
      VJVTVNERNZCVMERUFHSZVTVRVIBVNCWBVTVPVHVQGVTVODVFVGVTVOEUDNDVMEUDUFISUHVTV
      QEUENGVMEUEUFJSUIUJUKABLULACVJCWAUCHERUQUMUNUOVLUPZVEATVJQZVKWCVETWDEMURA
      VJUSSWCACTVJWCCWATHERURUTVAVBVCVD $.

    $( The inverse of a group element.  (Contributed by NM, 24-Aug-2011.)
       (Revised by Mario Carneiro, 7-Aug-2013.) $)
    grpinvval $p |- ( X e. B ->
                    ( N ` X ) = ( iota_ y e. B ( y .+ X ) = .0. ) ) $=
      ( vx cv co wceq crio oveq2 eqeq1d riotabidv grpinvfval riotaex fvmpt ) LF
      AMZLMZCNZGOZABPUCFCNZGOZABPBEUDFOZUFUHABUIUEUGGUDFUCCQRSLABCDEGHIJKTUHABU
      AUB $.
  $}

  ${
    $d B x y $.  $d G x y $.
    grpinvfn.b $e |- B = ( Base ` G ) $.
    grpinvfn.n $e |- N = ( invg ` G ) $.
    $( Functionality of the group inverse function.  (Contributed by Stefan
       O'Rear, 21-Mar-2015.) $)
    grpinvfn $p |- N Fn B $=
      ( vx vy cv cplusg cfv co c0g wceq crio riotaex eqid grpinvfval fnmpti ) F
      AGHFHBIJZKBLJZMZGANCUAGAOFGASBCTDSPTPEQR $.
  $}

  ${
    grpinvfvi.t $e |- N = ( invg ` G ) $.
    $( The group inverse function is compatible with identity-function
       protection.  (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
    grpinvfvi $p |- N = ( invg ` ( _I ` G ) ) $=
      ( cminusg cfv cid cvv wcel wceq fvi fveq2d wn wfn base0 eqid grpinvfn fn0
      c0 mpbi fvprc 3eqtr4a pm2.61i eqtr4i ) BADEZAFEZDEZCAGHZUFUDIUGUEADAGJKUG
      LZRDEZRUFUDUIRMUIRIRRUINUIOPUIQSUHUERDAFTKADTUAUBUC $.
  $}

  ${
    $d g x y B $.  $d g x y G $.  $d g x y I $.  $d g x y .+ $.  $d x y X $.
    $d x y Y $.
    grpsubval.b $e |- B = ( Base ` G ) $.
    grpsubval.p $e |- .+ = ( +g ` G ) $.
    grpsubval.i $e |- I = ( invg ` G ) $.
    grpsubval.m $e |- .- = ( -g ` G ) $.
    $( Group subtraction (division) operation.  (Contributed by NM,
       31-Mar-2014.)  (Revised by Stefan O'Rear, 27-Mar-2015.) $)
    grpsubfval $p |- .- = ( x e. B , y e. B |-> ( x .+ ( I ` y ) ) ) $=
      ( vg cvv cv cfv cmpt2 wceq csg cbs c0 wcel co cminusg fveq2 syl6eqr eqidd
      cplusg fveq1d oveq123d mpt2eq123dv df-sbg fvex eqeltri mpt2ex fvmpt fvprc
      syl5eq wn mpt2eq12 syl2anc mpt20 syl6eq eqtr4d pm2.61i ) EMUAZGABCCANZBNZ
      FOZDUBZPZQVEGEROZVJKLEABLNZSOZVMVFVGVLUCOZOZVLUGOZUBZPVJMRVLEQZABVMVMVQCC
      VIVRVMESOZCVLESUDHUEZVTVRVFVFVOVHVPDVRVPEUGODVLEUGUDIUEVRVFUFVRVGVNFVRVNE
      UCOFVLEUCUDJUEUHUIUJABLUKABCCVICVSMHESULUMZWAUNUOUQVEURZGTVJWBGVKTKERUPUQ
      WBVJABTTVIPZTWBCTQZWDVJWCQWBCVSTHESUPUQZWEABCCTTVIUSUTABTVIVAVBVCVD $.

    $( Group subtraction (division) operation.  (Contributed by NM,
       31-Mar-2014.)  (Revised by Mario Carneiro, 13-Dec-2014.) $)
    grpsubval $p |- ( ( X e. B /\ Y e. B ) ->
                    ( X .- Y ) = ( X .+ ( I ` Y ) ) ) $=
      ( vx vy cv cfv co oveq1 wceq fveq2 oveq2d grpsubfval ovex ovmpt2 ) LMFGAA
      LNZMNZDOZBPFGDOZBPEFUFBPUDFUFBQUEGRUFUGFBUEGDSTLMABCDEHIJKUAFUGBUBUC $.
  $}

  ${
    $d x y B $.  $d x y G $.
    grpinvcl.b $e |- B = ( Base ` G ) $.
    grpinvcl.n $e |- N = ( invg ` G ) $.
    $( The group inversion operation is a function on the base set.
       (Contributed by Mario Carneiro, 4-May-2015.) $)
    grpinvf $p |- ( G e. Grp -> N : B --> B ) $=
      ( vx vy cgrp wcel cv cplusg cfv co c0g wceq crio wa wreu eqid grpinveu
      riotacl syl grpinvfval fmptd ) BHIZFAGJFJZBKLZMBNLZOZGAPZACUEUFAIQUIGARUJ
      AIGAUGBUFUHDUGSZUHSZTUIGAUAUBFGAUGBCUHDUKULEUCUD $.

    $( A group element's inverse is a group element.  (Contributed by NM,
       24-Aug-2011.)  (Revised by Mario Carneiro, 4-May-2015.) $)
    grpinvcl $p |- ( ( G e. Grp /\ X e. B ) -> ( N ` X ) e. B ) $=
      ( cgrp wcel grpinvf ffvelrnda ) BGHAADCABCEFIJ $.
  $}

  ${
    $d e w x y z B $.  $d e x y z G $.  $d e w x y z .0. $.  $d e w x y z .+ $.
    $d e w x M $.  $d x y z N $.  $d y z X $.
    grpinv.b $e |- B = ( Base ` G ) $.
    grpinv.p $e |- .+ = ( +g ` G ) $.
    grpinv.u $e |- .0. = ( 0g ` G ) $.
    grpinv.n $e |- N = ( invg ` G ) $.
    $( The left inverse of a group element.  (Contributed by NM, 24-Aug-2011.)
       (Revised by Mario Carneiro, 6-Jan-2015.) $)
    grplinv $p |- ( ( G e. Grp /\ X e. B ) -> ( ( N ` X ) .+ X ) = .0. ) $=
      ( vy cgrp wcel wa cfv cv co wceq crab syl crio grpinvval grpinveu eqeltrd
      adantl wreu riotacl2 oveq1 eqeq1d elrab simprbi ) CLMZEAMZNZEDOZKPZEBQZFR
      ZKASZMZUOEBQZFRZUNUOURKAUAZUSUMUOVCRULKABCDEFGHIJUBUEUNURKAUFVCUSMKABCEFG
      HIUCURKAUGTUDUTUOAMVBURVBKUOAUPUORUQVAFUPUOEBUHUIUJUKT $.

    $( The right inverse of a group element.  (Contributed by NM,
       24-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    grprinv $p |- ( ( G e. Grp /\ X e. B ) -> ( X .+ ( N ` X ) ) = .0. ) $=
      ( vx vy vz cgrp wcel cfv cv grpcl grpidcl grplid grpass grpinvex grpinvcl
      simpr grplinv grprinvd ) CNOZEAOZKLMABEDPFEABCKQZLQZGHRACFGISABCUIFGHITAB
      CUIUJMQGHUALABCUIFGHIUBUGUHUDACDEGJUCABCDEFGHIJUEUF $.

    $( The inverse of a group element expressed in terms of the identity
       element.  (Contributed by NM, 24-Aug-2011.) $)
    grpinvid1 $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) ->
                    ( ( N ` X ) = Y <-> ( X .+ Y ) = .0. ) ) $=
      ( wcel w3a wceq co wa oveq2 3adant3 adantr eqtr3d cgrp cfv adantl grprinv
      grplinv oveq1d grpinvcl adantrr simprl simprr grpass syldan 3impb 3adant2
      3jca grplid grprid 3eqtr3rd impbida ) CUALZEALZFALZMZEDUBZFNZEFBOZGNZVCVE
      PEVDBOZVFGVEVHVFNVCVDFEBQUCVCVHGNZVEUTVAVIVBABCDEGHIJKUDRSTVCVGPVDVFBOZVD
      GBOZFVDVGVJVKNVCVFGVDBQUCVCVJFNVGVCGFBOZVJFVCVDEBOZFBOZVLVJUTVAVNVLNVBUTV
      APVMGFBABCDEGHIJKUEUFRUTVAVBVNVJNZUTVAVBPZVDALZVAVBMVOUTVPPVQVAVBUTVAVQVB
      ACDEHKUGZUHUTVAVBUIUTVAVBUJUOABCVDEFHIUKULUMTUTVBVLFNVAABCFGHIJUPUNTSVCVK
      VDNZVGUTVAVSVBUTVAVQVSVRABCVDGHIJUQULRSURUS $.

    $( The inverse of a group element expressed in terms of the identity
       element.  (Contributed by NM, 24-Aug-2011.) $)
    grpinvid2 $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) ->
                    ( ( N ` X ) = Y <-> ( Y .+ X ) = .0. ) ) $=
      ( wcel w3a wceq co wa oveq1 adantl 3adant3 adantr cgrp cfv grplinv eqtr3d
      grpinvcl grplid syldan eqcomd simprr simprl adantrr grpass grprinv oveq2d
      3jca 3impb grprid 3adant2 3eqtrd 3eqtr2d impbida ) CUALZEALZFALZMZEDUBZFN
      ZFEBOZGNZVEVGPVFEBOZVHGVGVJVHNVEVFFEBQRVEVJGNZVGVBVCVKVDABCDEGHIJKUCSTUDV
      EVIPVFGVFBOZVHVFBOZFVEVFVLNVIVEVLVFVBVCVLVFNZVDVBVCVFALZVNACDEHKUEZABCVFG
      HIJUFUGSUHTVIVMVLNVEVHGVFBQRVEVMFNVIVEVMFEVFBOZBOZFGBOZFVBVCVDVMVRNZVBVCV
      DPZVDVCVOMVTVBWAPVDVCVOVBVCVDUIVBVCVDUJVBVCVOVDVPUKUOABCFEVFHIULUGUPVBVCV
      RVSNVDVBVCPVQGFBABCDEGHIJKUMUNSVBVDVSFNVCABCFGHIJUQURUSTUTVA $.

    $( Properties showing that a function ` M ` is the inverse function of a
       group.  (Contributed by NM, 7-Aug-2013.)  (Revised by Mario Carneiro,
       2-Oct-2015.) $)
    isgrpinv $p |- ( G e. Grp
  -> ( ( M : B --> B /\ A. x e. B ( ( M ` x ) .+ x ) = .0. ) <-> N = M ) ) $=
      ( ve wcel wf cv cfv co wceq wral wa cgrp crio grpinvval ad2antlr simpr wb
      wreu simpllr simplr ffvelrnd simplll grpinveu syl2anc oveq1 eqeq1d riota2
      mpbid eqtrd ralimdva impr wfn grpinvfn ffn ad2antrl eqfnfv sylancr mpbird
      grpinvf grplinv ralrimiva jca feq1 fveq1 oveq1d ralbidv anbi12d syl5ibcom
      ex impbid ) DUAMZBBENZAOZEPZWBCQZGRZABSZTZFERZVTWGWHVTWGTZWHWBFPZWCRZABSZ
      VTWAWFWLVTWATZWEWKABWMWBBMZTZWEWKWOWETZWJLOZWBCQZGRZLBUBZWCWNWJWTRWMWELBC
      DFWBGHIJKUCUDWPWEWTWCRZWOWEUEWPWCBMWSLBUGZWEXAUFWPBBWBEVTWAWNWEUHWMWNWEUI
      ZUJWPVTWNXBVTWAWNWEUKXCLBCDWBGHIJULUMWSWELBWCWQWCRWRWDGWQWCWBCUNUOUPUMUQU
      RVRUSUTWIFBVAEBVAZWHWLUFBDFHKVBWAXDVTWFBBEVCVDABFEVEVFVGVRVTBBFNZWJWBCQZG
      RZABSZTWHWGVTXEXHBDFHKVHVTXGABBCDFWBGHIJKVIVJVKWHXEWAXHWFBBFEVLWHXGWEABWH
      XFWDGWHWJWCWBCWBFEVMVNUOVOVPVQVS $.
  $}

  ${
    grpinvid.u $e |- .0. = ( 0g ` G ) $.
    grpinvid.n $e |- N = ( invg ` G ) $.
    $( The inverse of the identity element of a group.  (Contributed by NM,
       24-Aug-2011.) $)
    grpinvid $p |- ( G e. Grp -> ( N ` .0. ) = .0. ) $=
      ( cgrp wcel cfv wceq cplusg co cbs eqid grpidcl grplid mpdan wb grpinvid1
      mpd3an23 mpbird ) AFGZCBHCIZCCAJHZKCIZUACALHZGZUDUEACUEMZDNZUEUCACCUGUCMZ
      DOPUAUFUFUBUDQUHUHUEUCABCCCUGUIDERST $.
  $}

  ${
    grplcan.b $e |- B = ( Base ` G ) $.
    grplcan.p $e |- .+ = ( +g ` G ) $.
    $( Left cancellation law for groups.  (Contributed by NM, 25-Aug-2011.) $)
    grplcan $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                  ( ( Z .+ X ) = ( Z .+ Y ) <-> X = Y ) ) $=
      ( wcel w3a wa co wceq cfv oveq2 eqid adantlr adantrl adantr 3eqtr3d exp53
      cgrp cminusg adantl c0g grplinv oveq1d grpinvcl simprr simprl 3jca grpass
      wi syldan anassrs grplid adantrr 3imp2 impbid1 ) CUBIZDAIZEAIZFAIZJKFDBLZ
      FEBLZMZDEMZUTVAVBVCVFVGUMUTVAVBVCVFVGUTVAKZVBVCKZKZVFKFCUCNZNZVDBLZVLVEBL
      ZDEVFVMVNMVJVDVEVLBOUDVJVMDMZVFVHVCVOVBVHVCKZVLFBLZDBLZCUENZDBLZVMDVPVQVS
      DBUTVCVQVSMZVAABCVKFVSGHVSPZVKPZUFZQUGUTVAVCVRVMMZUTVAVCKZVLAIZVCVAJWEUTW
      FKWGVCVAUTVCWGVAACVKFGWCUHZRUTVAVCUIUTVAVCUJUKABCVLFDGHULUNUOVHVTDMVCABCD
      VSGHWBUPSTRSVJVNEMZVFUTVIWIVAUTVIKZVQEBLZVSEBLZVNEWJVQVSEBUTVCWAVBWDRUGUT
      VIWGVCVBJWKVNMWJWGVCVBUTVCWGVBWHRUTVBVCUIUTVBVCUJUKABCVLFEGHULUNUTVBWLEMV
      CABCEVSGHWBUPUQTQSTUAURDEFBOUS $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y N $.
    grpinvinv.b $e |- B = ( Base ` G ) $.
    grpinvinv.n $e |- N = ( invg ` G ) $.
    $( Double inverse law for groups.  Lemma 2.2.1(c) of [Herstein] p. 55.
       (Contributed by NM, 31-Mar-2014.) $)
    grpinvinv $p |- ( ( G e. Grp /\ X e. B ) -> ( N ` ( N ` X ) ) = X ) $=
      ( cgrp wcel wa cfv cplusg co wceq c0g grpinvcl eqid grprinv syldan eqtr4d
      grplinv wb simpl simpr grplcan syl13anc mpbid ) BGHZDAHZIZDCJZUJCJZBKJZLZ
      UJDULLZMZUKDMZUIUMBNJZUNUGUHUJAHZUMUQMABCDEFOZAULBCUJUQEULPZUQPZFQRAULBCD
      UQEUTVAFTSUIUGUKAHZUHURUOUPUAUGUHUBUGUHURVBUSABCUJEFORUGUHUCUSAULBUKDUJEU
      TUDUEUF $.

    $( The group inverse is its own inverse function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    grpinvcnv $p |- ( G e. Grp -> `' N = N ) $=
      ( vx vy cgrp wcel cv cfv cmpt ccnv wceq eqid grpinvcl wa wb eqcom feqmptd
      wf1o w3a cplusg co c0g grpinvid1 3com23 grpinvid2 bitr4d 3bitr4g f1ocnv2d
      3expb simprd grpinvf cnveqd 3eqtr4d ) BHIZFAFJZCKZLZMZGAGJZCKZLZCMCUQAAUT
      UAVAVDNUQFGAAUSVCUTUTOABCURDEPABCVBDEPUQURAIZVBAIZQQVCURNZUSVBNZURVCNVBUS
      NUQVEVFVGVHRUQVEVFUBVGVBURBUCKZUDBUEKZNZVHUQVFVEVGVKRAVIBCVBURVJDVIOZVJOZ
      EUFUGAVIBCURVBVJDVLVMEUHUIULURVCSVBUSSUJUKUMUQCUTUQFAACABCDEUNZTUOUQGAACV
      NTUP $.

    grpinv11.g $e |- ( ph -> G e. Grp ) $.
    ${
      grpinv11.x $e |- ( ph -> X e. B ) $.
      grpinv11.y $e |- ( ph -> Y e. B ) $.
      $( The group inverse is one-to-one.  (Contributed by NM, 22-Mar-2015.) $)
      grpinv11 $p |- ( ph -> ( ( N ` X ) = ( N ` Y ) <-> X = Y ) ) $=
        ( cfv wceq wa fveq2 adantl wcel grpinvinv syl2anc adantr cgrp 3eqtr3d
        ex impbid1 ) AEDLZFDLZMZEFMZAUGUHAUGNUEDLZUFDLZEFUGUIUJMAUEUFDOPAUIEMZU
        GACUAQZEBQUKIJBCDEGHRSTAUJFMZUGAULFBQUMIKBCDFGHRSTUBUCEFDOUD $.
    $}

    $( The group inverse is a one-to-one onto function.  (Contributed by NM,
       22-Oct-2014.)  (Proof shortened by Mario Carneiro, 14-Aug-2015.) $)
    grpinvf1o $p |- ( ph -> N : B -1-1-onto-> B ) $=
      ( wfn ccnv wf1o wf cgrp wcel grpinvf syl ffn wceq grpinvcnv fneq1d mpbird
      dff1o4 sylanbrc ) ADBHZDIZBHZBBDJABBDKZUCACLMZUFGBCDEFNOBBDPOZAUEUCUHABUD
      DAUGUDDQGBCDEFROSTBBDUAUB $.
  $}

  ${
    grpinvnzcl.b $e |- B = ( Base ` G ) $.
    grpinvnzcl.z $e |- .0. = ( 0g ` G ) $.
    grpinvnzcl.n $e |- N = ( invg ` G ) $.
    $( The inverse of a nonzero group element is not zero.  (Contributed by
       Stefan O'Rear, 27-Feb-2015.) $)
    grpinvnz $p |- ( ( G e. Grp /\ X e. B /\ X =/= .0. ) ->
        ( N ` X ) =/= .0. ) $=
      ( cgrp wcel wne cfv wceq fveq2 adantl grpinvinv adantr grpinvid ad2antrr
      wa 3eqtr3d ex necon3d 3impia ) BIJZDAJZDEKDCLZEKUEUFTZUGEDEUHUGEMZDEMUHUI
      TUGCLZECLZDEUIUJUKMUHUGECNOUHUJDMUIABCDFHPQUEUKEMUFUIBCEGHRSUAUBUCUD $.

    $( The inverse of a nonzero group element is a nonzero group element.
       (Contributed by Stefan O'Rear, 27-Feb-2015.) $)
    grpinvnzcl $p |- ( ( G e. Grp /\ X e. ( B \ { .0. } ) ) ->
        ( N ` X ) e. ( B \ { .0. } ) ) $=
      ( cgrp wcel csn cdif wa cfv wne eldifi grpinvcl sylan2 eldifsn grpinvnz
      3expb sylan2b sylanbrc ) BIJZDAEKZLZJZMDCNZAJZUHEOZUHUFJUGUDDAJZUIDAUEPAB
      CDFHQRUGUDUKDEOZMUJDAESUDUKULUJABCDEFGHTUAUBUHAESUC $.
  $}

  ${
    grpsubinv.b $e |- B = ( Base ` G ) $.
    grpsubinv.p $e |- .+ = ( +g ` G ) $.
    grpsubinv.m $e |- .- = ( -g ` G ) $.
    grpsubinv.n $e |- N = ( invg ` G ) $.
    grpsubinv.g $e |- ( ph -> G e. Grp ) $.
    grpsubinv.x $e |- ( ph -> X e. B ) $.
    grpsubinv.y $e |- ( ph -> Y e. B ) $.
    $( Subtraction of an inverse.  (Contributed by NM, 7-Apr-2015.) $)
    grpsubinv $p |- ( ph -> ( X .- ( N ` Y ) ) = ( X .+ Y ) ) $=
      ( cfv co wcel wceq syl2anc cgrp grpinvcl grpsubval grpinvinv oveq2d eqtrd
      ) AGHFPZEQZGUGFPZCQZGHCQAGBRUGBRZUHUJSNADUARZHBRZUKMOBDFHILUBTBCDFEGUGIJL
      KUCTAUIHGCAULUMUIHSMOBDFHILUDTUEUF $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y .+ $.  $d x y X $.
    grplmulf1o.b $e |- B = ( Base ` G ) $.
    grplmulf1o.p $e |- .+ = ( +g ` G ) $.
    grplmulf1o.n $e |- F = ( x e. B |-> ( X .+ x ) ) $.
    $( Left multiplication by a group element is a bijection on any group.
       (Contributed by Mario Carneiro, 17-Jan-2015.) $)
    grplmulf1o $p |- ( ( G e. Grp /\ X e. B ) -> F : B -1-1-onto-> B ) $=
      ( vy wcel wa cv co cfv grpcl 3expa eqid wceq adantr cgrp cminusg grpinvcl
      simpl jca sylan eqcom wb adantrl simprl simplr grplcan c0g grprinv oveq1d
      syl13anc simprr grpass grplid ad2ant2rl 3eqtr3d eqeq1d bitr3d syl5bb
      f1o2d ) EUAKZFBKZLZAJBBFAMZCNZFEUBOZOZJMZCNZDIVFVGVIBKZVJBKBCEFVIGHPQVHVF
      VLBKZLVMBKZVNBKZVHVFVPVFVGUDZBEVKFGVKRZUCZUEVFVPVQVRBCEVLVMGHPQUFZVIVNSVN
      VISZVHVOVQLZLZVMVJSZVIVNUGWEFVNCNZVJSZWCWFWEVFVRVOVGWHWCUHVHVFWDVSTZVHVQV
      RVOWBUIVHVOVQUJVFVGWDUKZBCEVNVIFGHULUPWEWGVMVJWEFVLCNZVMCNZEUMOZVMCNZWGVM
      WEWKWMVMCVHWKWMSWDBCEVKFWMGHWMRZVTUNTUOWEVFVGVPVQWLWGSWIWJVHVPWDWATVHVOVQ
      UQBCEFVLVMGHURUPVFVQWNVMSVGVOBCEVMWMGHWOUSUTVAVBVCVDVE $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y L $.  $d x y ph $.
    grpinvpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    grpinvpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    grpinvpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    $( If two structures have the same group components (properties), they have
       the same group inversion function.  (Contributed by Mario Carneiro,
       27-Nov-2014.)  (Revised by Stefan O'Rear, 21-Mar-2015.) $)
    grpinvpropd $p |- ( ph -> ( invg ` K ) = ( invg ` L ) ) $=
      ( cbs cfv cv cplusg co c0g wceq crio cmpt wa eqid cminusg wcel grpidpropd
      adantr eqeq12d anass1rs riotabidva mpteq2dva riotaeqdv 3eqtr3d grpinvfval
      wb mpteq12dv 3eqtr4g ) ACEJKZBLZCLZEMKZNZEOKZPZBUOQZRZCFJKZUPUQFMKZNZFOKZ
      PZBVDQZRZEUAKZFUAKZACDVABDQZRCDVHBDQZRVCVJACDVMVNAUQDUBZSVAVHBDAUPDUBZVOV
      AVHULAVPVOSZSUSVFUTVGIAUTVGPVQABCDEFGHIUCUDUEUFUGUHACDVMUOVBGAVABDUOGUIUM
      ACDVNVDVIHAVHBDVDHUIUMUJCBUOUREVKUTUOTURTUTTVKTUKCBVDVEFVLVGVDTVETVGTVLTU
      KUN $.
  $}

  ${
    grpinvadd.b $e |- B = ( Base ` G ) $.
    grpinvadd.p $e |- .+ = ( +g ` G ) $.
    grpinvadd.n $e |- N = ( invg ` G ) $.
    $( The inverse of the group operation reverses the arguments.  Lemma
       2.2.1(d) of [Herstein] p. 55.  (Contributed by NM, 27-Oct-2006.) $)
    grpinvadd $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) ->
                   ( N ` ( X .+ Y ) ) = ( ( N ` Y ) .+ ( N ` X ) ) ) $=
      ( wcel co cfv wceq grpinvcl 3adant2 3adant3 grpcl syl3anc grpass syl13anc
      cgrp w3a c0g simp1 simp2 simp3 eqid grprinv oveq1d grplid syl2anc 3eqtr3d
      oveq2d 3eqtrd wb grpinvid1 mpbird ) CUAJZEAJZFAJZUBZEFBKZDLFDLZEDLZBKZMZV
      BVEBKZCUCLZMZVAVGEFVEBKZBKZEVDBKZVHVAURUSUTVEAJZVGVKMURUSUTUDZURUSUTUEURU
      SUTUFZVAURVCAJZVDAJZVMVNURUTVPUSACDFGINOZURUSVQUTACDEGINPZABCVCVDGHQRZABC
      EFVEGHSTVAVJVDEBVAFVCBKZVDBKZVHVDBKZVJVDVAWAVHVDBURUTWAVHMUSABCDFVHGHVHUG
      ZIUHOUIVAURUTVPVQWBVJMVNVOVRVSABCFVCVDGHSTVAURVQWCVDMVNVSABCVDVHGHWDUJUKU
      LUMURUSVLVHMUTABCDEVHGHWDIUHPUNVAURVBAJVMVFVIUOVNABCEFGHQVTABCDVBVEVHGHWD
      IUPRUQ $.
  $}

  ${
    $d x y B $.  $d x y G $.
    grpsubcl.b $e |- B = ( Base ` G ) $.
    grpsubcl.m $e |- .- = ( -g ` G ) $.
    $( Functionality of group subtraction.  (Contributed by Mario Carneiro,
       9-Sep-2014.) $)
    grpsubf $p |- ( G e. Grp -> .- : ( B X. B ) --> B ) $=
      ( vx vy cgrp wcel cv cminusg cfv cplusg co wral cxp eqid grpinvcl 3adant2
      wf grpcl syld3an3 3expb ralrimivva grpsubfval fmpt2 sylib ) BHIZFJZGJZBKL
      ZLZBMLZNZAIZGAOFAOAAPACTUHUOFGAAUHUIAIZUJAIZUOUHUPUQULAIZUOUHUQURUPABUKUJ
      DUKQZRSAUMBUIULDUMQZUAUBUCUDFGAAUNACFGAUMBUKCDUTUSEUEUFUG $.

    $( Closure of group subtraction.  (Contributed by NM, 31-Mar-2014.) $)
    grpsubcl $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) -> ( X .- Y ) e. B ) $=
      ( cgrp wcel cxp wf co grpsubf fovrn syl3an1 ) BHIAAJACKDAIEAIDECLAIABCFGM
      DEAAACNO $.

    $( Right cancellation law for group subtraction.  (Contributed by NM,
       31-Mar-2014.) $)
    grpsubrcan $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                  ( ( X .- Z ) = ( Y .- Z ) <-> X = Y ) ) $=
      ( cgrp wcel w3a wa co wceq cminusg cfv cplusg wb eqid grpsubval 3ad2antr3
      3adant2 3adant1 eqeq12d adantl simpl simpr1 simpr2 grpinvcl grprcan bitrd
      syl13anc ) BIJZDAJZEAJZFAJZKZLZDFCMZEFCMZNZDFBOPZPZBQPZMZEVCVDMZNZDENZUQV
      AVGRUMUQUSVEUTVFUNUPUSVENUOAVDBVBCDFGVDSZVBSZHTUBUOUPUTVFNUNAVDBVBCEFGVIV
      JHTUCUDUEURUMUNUOVCAJZVGVHRUMUQUFUMUNUOUPUGUMUNUOUPUHUMUNUPVKUOABVBFGVJUI
      UAAVDBDEVCGVIUJULUK $.

    grpinvsub.n $e |- N = ( invg ` G ) $.
    $( Inverse of a group subtraction.  (Contributed by NM, 9-Sep-2014.) $)
    grpinvsub $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) ->
                      ( N ` ( X .- Y ) ) = ( Y .- X ) ) $=
      ( cgrp wcel w3a cfv cplusg co wceq grpinvcl 3adant2 grpsubval 3adant1
      eqid grpinvadd syld3an3 grpinvinv oveq1d eqtrd fveq2d ancoms 3eqtr4d ) BJ
      KZEAKZFAKZLZEFDMZBNMZOZDMZFEDMZUOOZEFCOZDMFECOZUMUQUNDMZURUOOZUSUJUKULUNA
      KZUQVCPUJULVDUKABDFGIQRAUOBDEUNGUOUAZIUBUCUMVBFURUOUJULVBFPUKABDFGIUDRUEU
      FUMUTUPDUKULUTUPPUJAUOBDCEFGVEIHSTUGUKULVAUSPZUJULUKVFAUOBDCFEGVEIHSUHTUI
      $.

    grpinvval2.z $e |- .0. = ( 0g ` G ) $.
    $( A ~ df-neg -like equation for inverse in terms of group subtraction.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    grpinvval2 $p |- ( ( G e. Grp /\ X e. B ) ->
                      ( N ` X ) = ( .0. .- X ) ) $=
      ( cgrp wcel wa co cfv cplusg wceq grpidcl eqid grpsubval grpinvcl grplid
      sylan syldan eqtr2d ) BKLZEALZMFECNZFEDOZBPOZNZUIUFFALUGUHUKQABFGJRAUJBDC
      FEGUJSZIHTUCUFUGUIALUKUIQABDEGIUAAUJBUIFGULJUBUDUE $.
  $}

  ${
    grpsubid.b $e |- B = ( Base ` G ) $.
    grpsubid.o $e |- .0. = ( 0g ` G ) $.
    grpsubid.m $e |- .- = ( -g ` G ) $.
    $( Subtraction of a group element from itself.  (Contributed by NM,
       31-Mar-2014.) $)
    grpsubid $p |- ( ( G e. Grp /\ X e. B ) -> ( X .- X ) = .0. ) $=
      ( cgrp wcel wa co cminusg cfv cplusg wceq eqid grpsubval anidms adantl
      grprinv eqtrd ) BIJZDAJZKDDCLZDDBMNZNBONZLZEUDUEUHPZUCUDUIAUGBUFCDDFUGQZU
      FQZHRSTAUGBUFDEFUJGUKUAUB $.

    $( Subtraction of the identity from a group element.  (Contributed by Mario
       Carneiro, 14-Jan-2015.) $)
    grpsubid1 $p |- ( ( G e. Grp /\ X e. B ) -> ( X .- .0. ) = X ) $=
      ( cgrp wcel wa co cminusg cfv cplusg wceq id grpidcl eqid grpsubval
      syl2anr grpinvid adantr oveq2d grprid 3eqtrd ) BIJZDAJZKZDECLZDEBMNZNZBON
      ZLZDEUMLDUHUHEAJUJUNPUGUHQABEFGRAUMBUKCDEFUMSZUKSZHTUAUIULEDUMUGULEPUHBUK
      EGUPUBUCUDAUMBDEFUOGUEUF $.

    $( If the difference between two group elements is zero, they are equal.
       ( ~ subeq0 analog.)  (Contributed by NM, 31-Mar-2014.) $)
    grpsubeq0 $p |- ( ( G e. Grp /\ X e. B /\ Y e. B )
                  -> ( ( X .- Y ) = .0. <-> X = Y ) ) $=
      ( cgrp wcel w3a co wceq cminusg cfv cplusg eqid eqeq1d 3adant2 3adant1 wb
      grpsubval simp1 grpinvcl simp2 grpinvid2 syl3anc grpinvinv syl6bb 3bitr2d
      eqcom ) BJKZDAKZEAKZLZDECMZFNDEBOPZPZBQPZMZFNZUSURPZDNZDENZUPUQVAFUNUOUQV
      ANUMAUTBURCDEGUTRZURRZIUCUASUPUMUSAKZUNVDVBUBUMUNUOUDUMUOVHUNABUREGVGUETU
      MUNUOUFAUTBURUSDFGVFHVGUGUHUPVDEDNVEUPVCEDUMUOVCENUNABUREGVGUITSEDULUJUK
      $.
  $}

  ${
    grpsubadd.b $e |- B = ( Base ` G ) $.
    grpsubadd.p $e |- .+ = ( +g ` G ) $.
    grpsubadd.m $e |- .- = ( -g ` G ) $.
    $( Relationship between group subtraction and addition.  (Contributed by
       NM, 31-Mar-2014.) $)
    grpsubadd $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) )
          -> ( ( X .- Y ) = Z <-> ( Z .+ Y ) = X ) ) $=
      ( cgrp wcel w3a co wceq cfv eqid eqeq1d 3ad2antr2 syl13anc cminusg adantl
      wa grpsubval 3adant3 wb simpl simpr1 grpinvcl grpcl syl3anc simpr3 simpr2
      grprcan c0g grpass grplinv oveq2d grprid 3ad2antr1 3eqtrd 3bitr2d syl6bb
      eqcom ) CKLZEALZFALZGALZMZUCZEFDNZGOZEGFBNZOZVMEOVJVLEFCUAPZPZBNZGOZVQFBN
      ZVMOZVNVJVKVQGVIVKVQOZVEVFVGWAVHABCVODEFHIVOQZJUDUEUBRVJVEVQALZVHVGVTVRUF
      VEVIUGZVJVEVFVPALZWCWDVEVFVGVHUHZVEVFVGWEVHACVOFHWBUISZABCEVPHIUJUKVEVFVG
      VHULVEVFVGVHUMZABCVQGFHIUNTVJVSEVMVJVSEVPFBNZBNZECUOPZBNZEVJVEVFWEVGVSWJO
      WDWFWGWHABCEVPFHIUPTVJWIWKEBVEVFVGWIWKOVHABCVOFWKHIWKQZWBUQSURVEVGVFWLEOV
      HABCEWKHIWMUSUTVARVBEVMVDVC $.

    $( Double group subtraction.  (Contributed by NM, 24-Feb-2008.)  (Revised
       by Mario Carneiro, 2-Dec-2014.) $)
    grpsubsub $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( X .- ( Y .- Z ) ) = ( X .+ ( Z .- Y ) ) ) $=
      ( cgrp wcel w3a wa co cminusg cfv wceq simpr1 3adant3r1 grpsubval syl2anc
      grpsubcl eqid grpinvsub oveq2d eqtrd ) CKLZEALZFALZGALZMNZEFGDOZDOZEUMCPQ
      ZQZBOZEGFDOZBOULUIUMALZUNUQRUHUIUJUKSUHUJUKUSUIACDFGHJUCTABCUODEUMHIUOUDZ
      JUAUBULUPUREBUHUJUKUPURRUIACDUOFGHJUTUETUFUG $.

    $( Associative-type law for group subtraction and addition.  (Contributed
       by NM, 16-Apr-2014.) $)
    grpaddsubass $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( ( X .+ Y ) .- Z ) = ( X .+ ( Y .- Z ) ) ) $=
      ( cgrp wcel w3a wa co cminusg cfv wceq grpsubval syl2anc simpr1 3ad2antr3
      simpl simpr2 eqid grpinvcl grpass syl13anc grpcl 3adant3r3 simpr3 3eqtr4d
      oveq2d ) CKLZEALZFALZGALZMZNZEFBOZGCPQZQZBOZEFVBBOZBOZUTGDOZEFGDOZBOUSUNU
      OUPVBALZVCVERUNURUCUNUOUPUQUAUNUOUPUQUDZUNUOUQVHUPACVAGHVAUEZUFUBABCEFVBH
      IUGUHUSUTALZUQVFVCRUNUOUPVKUQABCEFHIUIUJUNUOUPUQUKZABCVADUTGHIVJJSTUSVGVD
      EBUSUPUQVGVDRVIVLABCVADFGHIVJJSTUMUL $.

    $( Cancellation law for subtraction ( ~ pncan analog).  (Contributed by NM,
       16-Apr-2014.) $)
    grppncan $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) ->
        ( ( X .+ Y ) .- Y ) = X ) $=
      ( cgrp wcel w3a co c0g cfv wceq simp1 simp2 simp3 grpaddsubass wa 3adant2
      syl13anc eqid grpsubid oveq2d grprid 3adant3 3eqtrd ) CJKZEAKZFAKZLZEFBMF
      DMZEFFDMZBMZECNOZBMZEUMUJUKULULUNUPPUJUKULQUJUKULRUJUKULSZUSABCDEFFGHITUC
      UJULUPURPUKUJULUAUOUQEBACDFUQGUQUDZIUEUFUBUJUKUREPULABCEUQGHUTUGUHUI $.

    $( Cancellation law for subtraction ( ~ npcan analog). .  (Contributed by
       NM, 19-Apr-2014.) $)
    grpnpcan $p |- ( ( G e. Grp /\ X e. B /\ Y e. B ) ->
        ( ( X .- Y ) .+ Y ) = X ) $=
      ( cgrp wcel w3a cminusg cfv co wceq eqid 3adant2 syld3an3 grpsubval grpcl
      grpinvcl syl2anc grppncan 3adant1 eqcomd grpinvinv oveq12d 3eqtr3rd ) CJK
      ZEAKZFAKZLZEFCMNZNZBOZUODOZUPUOUNNZBOZEEFDOZFBOUMUPAKZUOAKZUQUSPUJUKULVBV
      AUJULVBUKACUNFGUNQZUBRZABCEUOGHUASVDABCUNDUPUOGHVCITUCUJUKULVBUQEPVDABCDE
      UOGHIUDSUMUPUTURFBUMUTUPUKULUTUPPUJABCUNDEFGHVCITUEUFUJULURFPUKACUNFGVCUG
      RUHUI $.

    $( Double group subtraction ( ~ subsub4 analog).  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    grpsubsub4 $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( ( X .- Y ) .- Z ) = ( X .- ( Z .+ Y ) ) ) $=
      ( cgrp wcel w3a co wceq grpsubcl 3adant3r3 grpnpcan syl3anc syl13anc wa
      simpl simpr3 oveq1d simpr2 grpass wb simpr1 grpcl grpsubadd mpbird eqcomd
      3eqtr3d ) CKLZEALZFALZGALZMZUAZEGFBNZDNZEFDNZGDNZUSVAVCOZVCUTBNZEOZUSVCGB
      NZFBNZVBFBNZVEEUSVGVBFBUSUNVBALZUQVGVBOUNURUBZUNUOUPVJUQACDEFHJPQZUNUOUPU
      QUCZABCDVBGHIJRSUDUSUNVCALZUQUPVHVEOVKUSUNVJUQVNVKVLVMACDVBGHJPSZVMUNUOUP
      UQUEZABCVCGFHIUFTUNUOUPVIEOUQABCDEFHIJRQUMUSUNUOUTALZVNVDVFUGVKUNUOUPUQUH
      USUNUQUPVQVKVMVPABCGFHIUISVOABCDEUTVCHIJUJTUKUL $.

    $( Cancellation law for mixed addition and subtraction.  ( ~ pnpcan2
       analog.)  (Contributed by NM, 15-Feb-2008.)  (Revised by Mario Carneiro,
       2-Dec-2014.) $)
    grppnpcan2 $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( ( X .+ Z ) .- ( Y .+ Z ) ) = ( X .- Y ) ) $=
      ( cgrp wcel w3a wa co wceq simpl grpcl 3adant3r2 simpr3 simpr2 grpsubsub4
      syl13anc grppncan oveq1d eqtr3d ) CKLZEALZFALZGALZMZNZEGBOZGDOZFDOZUMFGBO
      DOZEFDOULUGUMALZUJUIUOUPPUGUKQUGUHUJUQUIABCEGHIRSUGUHUIUJTUGUHUIUJUAABCDU
      MGFHIJUBUCULUNEFDUGUHUJUNEPUIABCDEGHIJUDSUEUF $.

    $( Cancellation law for group subtraction.  ( ~ npncan analog.)
       (Contributed by NM, 15-Feb-2008.)  (Revised by Mario Carneiro,
       2-Dec-2014.) $)
    grpnpncan $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( ( X .- Y ) .+ ( Y .- Z ) ) = ( X .- Z ) ) $=
      ( cgrp wcel w3a wa co wceq simpl grpsubcl 3adant3r3 simpr2 simpr3 oveq1d
      grpaddsubass syl13anc grpnpcan eqtr3d ) CKLZEALZFALZGALZMZNZEFDOZFBOZGDOZ
      UMFGDOBOZEGDOULUGUMALZUIUJUOUPPUGUKQUGUHUIUQUJACDEFHJRSUGUHUIUJTUGUHUIUJU
      AABCDUMFGHIJUCUDULUNEGDUGUHUIUNEPUJABCDEFHIJUESUBUF $.
  $}

  ${
    grpnnncan2.b $e |- B = ( Base ` G ) $.
    grpnnncan2.m $e |- .- = ( -g ` G ) $.
    $( Cancellation law for group subtraction.  ( ~ nnncan2 analog.)
       (Contributed by NM, 15-Feb-2008.)  (Revised by Mario Carneiro,
       2-Dec-2014.) $)
    grpnnncan2 $p |- ( ( G e. Grp /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( ( X .- Z ) .- ( Y .- Z ) ) = ( X .- Y ) ) $=
      ( cgrp wcel w3a wa co cplusg cfv wceq simpl simpr1 simpr3 3adant3r1 eqtrd
      grpsubcl eqid grpsubsub4 syl13anc grpnpcan oveq2d ) BIJZDAJZEAJZFAJZKZLZD
      FCMEFCMZCMZDUNFBNOZMZCMZDECMUMUHUIUKUNAJZUOURPUHULQUHUIUJUKRUHUIUJUKSUHUJ
      UKUSUIABCEFGHUBTAUPBCDFUNGUPUCZHUDUEUMUQEDCUHUJUKUQEPUIAUPBCEFGUTHUFTUGUA
      $.
  $}

  ${
    $d a b g A $.  $d a b g G $.  $d a b g I $.  $d a b g .+ $.  $d a b g X $.
    $d a B $.
    grplact.1 $e |- F = ( g e. X |-> ( a e. X |-> ( g .+ a ) ) ) $.
    grplact.2 $e |- X = ( Base ` G ) $.
    $( The left group action of element ` A ` of group ` G ` .  (Contributed by
       Paul Chapman, 18-Mar-2008.) $)
    grplactfval $p |- ( A e. X ->
                ( F ` A ) = ( a e. X |-> ( A .+ a ) ) ) $=
      ( cv co cmpt wceq oveq1 mpteq2dv cbs cfv cvv fvex eqeltri mptex fvmpt ) C
      AGFCJZGJZBKZLGFAUDBKZLFDUCAMGFUEUFUCAUDBNOHGFUFFEPQRIEPSTUAUB $.

    $( The value of the left group action of element ` A ` of group ` G ` at
       ` B ` .  (Contributed by Paul Chapman, 18-Mar-2008.) $)
    grplactval $p |- ( ( A e. X /\ B e. X ) ->
                       ( ( F ` A ) ` B ) = ( A .+ B ) ) $=
      ( wcel cfv cv co cmpt grplactfval fveq1d oveq2 eqid ovex fvmpt sylan9eq )
      AGKZBGKBAELZLBHGAHMZCNZOZLABCNZUCBUDUGACDEFGHIJPQHBUFUHGUGUEBACRUGSABCTUA
      UB $.

    grplact.3 $e |- .+ = ( +g ` G ) $.
    ${
      grplactcnv.4 $e |- I = ( invg ` G ) $.
      $( The left group action of element ` A ` of group ` G ` maps the
         underlying set ` X ` of ` G ` one-to-one onto itself.  (Contributed by
         Paul Chapman, 18-Mar-2008.)  (Proof shortened by Mario Carneiro,
         14-Aug-2015.) $)
      grplactcnv $p |- ( ( G e. Grp /\ A e. X ) ->
       ( ( F ` A ) : X -1-1-onto-> X /\ `' ( F ` A ) = ( F ` ( I ` A ) ) ) ) $=
        ( vb wcel wa cfv wf1o wceq co cmpt cgrp ccnv grpcl 3expa simpl grpinvcl
        cv eqid jca sylan c0g grplinv adantr oveq1d simpll simplr simprl grpass
        eqcom syl13anc grplid ad2ant2r 3eqtr3rd eqeq2d syl5bb wb simprr adantrr
        grplcan bitrd grplactfval adantl f1oeq1 syl cnveqd oveq2 cbvmptv syl6eq
        f1ocnv2d eqeq12d anbi12d mpbird ) EUANZAGNZOZGGADPZQZWFUBZAFPZDPZRZOGGH
        GAHUGZBSZTZQZWNUBZMGWIMUGZBSZTZRZOWEHMGGWMWRWNWNUHWCWDWLGNZWMGNZGBEAWLJ
        KUCUDZWEWCWIGNZOWQGNZWRGNZWEWCXDWCWDUEGEFAJLUFZUIWCXDXEXFGBEWIWQJKUCUDU
        JWEXAXEOZOZWLWRRZWRWIWMBSZRZWQWMRZXJWRWLRXIXLWLWRUSXIWLXKWRXIWIABSZWLBS
        ZEUKPZWLBSZXKWLXIXNXPWLBWEXNXPRXHGBEFAXPJKXPUHZLULUMUNXIWCXDWDXAXOXKRWC
        WDXHUOZWEXDXHXGUMZWCWDXHUPWEXAXEUQGBEWIAWLJKURUTWCXAXQWLRWDXEGBEWLXPJKX
        RVAVBVCVDVEXIWCXEXBXDXLXMVFXSWEXAXEVGWEXAXBXEXCVHXTGBEWQWMWIJKVIUTVJVSW
        EWGWOWKWTWEWFWNRZWGWOVFWDYAWCABCDEGHIJVKVLZGGWFWNVMVNWEWHWPWJWSWEWFWNYB
        VOWEXDWJWSRXGXDWJHGWIWLBSZTWSWIBCDEGHIJVKHMGYCWRWLWQWIBVPVQVRVNVTWAWB
        $.
    $}

    $( The left group action of element ` A ` of group ` G ` maps the
       underlying set ` X ` of ` G ` one-to-one onto itself.  (Contributed by
       Paul Chapman, 18-Mar-2008.)  (Proof shortened by Mario Carneiro,
       14-Aug-2015.) $)
    grplactf1o $p |- ( ( G e. Grp /\ A e. X ) ->
                       ( F ` A ) : X -1-1-onto-> X ) $=
      ( cgrp wcel wa cfv wf1o ccnv cminusg wceq eqid grplactcnv simpld ) EKLAFL
      MFFADNZOUBPAEQNZNDNRABCDEUCFGHIJUCSTUA $.
  $}

  ${
    $d ph a b $.  $d ph x y $.  $d G a b $.  $d G x y $.  $d H a b $.
    $d H x y $.
    grpsubpropd.b $e |- ( ph -> ( Base ` G ) = ( Base ` H ) ) $.
    grpsubpropd.p $e |- ( ph -> ( +g ` G ) = ( +g ` H ) ) $.
    $( Weak property deduction for the group subtraction operation.
       (Contributed by Mario Carneiro, 27-Mar-2015.) $)
    grpsubpropd $p |- ( ph -> ( -g ` G ) = ( -g ` H ) ) $=
      ( va vb vx vy cbs cfv cv cminusg cplusg co cmpt2 csg eqidd wcel eqid wa
      proplem3 grpinvpropd fveq1d oveq123d mpt2eq123dv grpsubfval 3eqtr4g ) AFG
      BJKZUIFLZGLZBMKZKZBNKZOZPFGCJKZUPUJUKCMKZKZCNKZOZPBQKZCQKZAFGUIUIUOUPUPUT
      DDAUJUJUMURUNUSEAUJRAUKULUQAHIUIBCAUIRDAHLUISILUISUAHIUNUSEUBUCUDUEUFFGUI
      UNBULVAUITUNTULTVATUGFGUPUSCUQVBUPTUSTUQTVBTUGUH $.
  $}

  ${
    $d x y B $.  $d a b x y G $.  $d a b x y H $.  $d a b x y ph $.
    grpsubpropd2.1 $e |- ( ph -> B = ( Base ` G ) ) $.
    grpsubpropd2.2 $e |- ( ph -> B = ( Base ` H ) ) $.
    grpsubpropd2.3 $e |- ( ph -> G e. Grp ) $.
    grpsubpropd2.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` G ) y ) = ( x ( +g ` H ) y ) ) $.
    $( Strong property deduction for the group subtraction operation.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    grpsubpropd2 $p |- ( ph -> ( -g ` G ) = ( -g ` H ) ) $=
      ( va vb cbs cfv co cmpt2 wcel wceq 3ad2ant1 eqid cminusg cplusg csg simp1
      cv w3a simp2 eleqtrrd simp3 grpinvcl syl2anc proplem syl12anc grpinvpropd
      cgrp fveq1d oveq2d eqtrd mpt2eq3dva eqtr3d mpt2eq12 grpsubfval 3eqtr4g )
      AKLEMNZVDKUEZLUEZEUANZNZEUBNZOZPZKLFMNZVLVEVFFUANZNZFUBNZOZPZEUCNZFUCNZAV
      KKLVDVDVPPZVQAKLVDVDVJVPAVEVDQZVFVDQZUFZVJVEVHVOOZVPWCAVEDQVHDQVJWDRAWAWB
      UDWCVEVDDAWAWBUGAWADVDRWBGSZUHWCVHVDDWCEUOQZWBVHVDQAWAWFWBISAWAWBUIVDEVGV
      FVDTZVGTZUJUKWEUHABCDDVIVOVEVHJULUMAWAWDVPRWBAVHVNVEVOAVFVGVMABCDEFGHJUNU
      PUQSURUSAVDVLRZWIVTVQRADVDVLGHUTZWJKLVDVDVLVLVPVAUKURKLVDVIEVGVRWGVITWHVR
      TVBKLVLVOFVMVSVLTVOTVMTVSTVBVC $.
  $}

  ${
    $d n w x .0. $.  $d n s w x G $.  $d n s w x I $.  $d n x N $.  $d n x S $.
    $d s w .+ $.  $d n w x B $.  $d n x X $.
    mulgval.b $e |- B = ( Base ` G ) $.
    mulgval.p $e |- .+ = ( +g ` G ) $.
    mulgval.o $e |- .0. = ( 0g ` G ) $.
    mulgval.i $e |- I = ( invg ` G ) $.
    mulgval.t $e |- .x. = ( .g ` G ) $.
    $( Group multiple (exponentiation) operation.  (Contributed by Mario
       Carneiro, 11-Dec-2014.) $)
    mulgfval $p |- .x. = ( n e. ZZ , x e. B |->
      if ( n = 0 , .0. , if ( 0 < n ,
        ( seq 1 ( .+ , ( NN X. { x } ) ) ` n ) ,
        ( I ` ( seq 1 ( .+ , ( NN X. { x } ) ) ` -u n ) ) ) ) ) $=
      ( vs cfv cz wceq cvv cbs c0 vw cmg cv cc0 clt wbr cn csn cxp c1 cseq cneg
      cif cmpt2 wcel c0g cplusg cminusg csb eqidd fveq2 syl6eqr seqex a1i wa id
      seqeq2d sylan9eqr fveq1d simpl fveq2d fveq12d ifeq12d mpt2eq123dv df-mulg
      csbied zex fvex eqeltri mpt2ex fvmpt wn fvprc wfn eqid ifex syl5eq xpeq2d
      fnmpt2i xp0 syl6eq fneq2d mpbii fn0 sylib eqtr4d pm2.61i eqtri ) DFUBOZEA
      PBEUCZUDQZHUDWTUEUFZWTCUGAUCUHUIZUJUKZOZWTULZXDOZGOZUMZUMZUNZMFRUOZWSXKQU
      AFEAPUAUCZSOZXAXMUPOZNXMUQOZXCUJUKZXBWTNUCZOZXFXROZXMUROZOZUMZUSZUMZUNXKR
      UBXMFQZEAPXNYEPBXJYFPUTYFXNFSOZBXMFSVAIVBYFXAXOHYDXIYFXOFUPOZHXMFUPVAKVBY
      FNXQYCXIRXQRUOYFXPXCUJVCVDYFXRXQQZVEZXBXSXEYBXHYJWTXRXDYIYFXRXQXDYIVFYFXP
      CXCUJYFXPFUQOCXMFUQVAJVBVGVHZVIYJXTXGYAGYJYAFUROGYJXMFURYFYIVJVKLVBYJXFXR
      XDYKVIVLVMVPVMVNAUAENVOEAPBXJVQBYGRIFSVRVSVTWAXLWBZWSTXKFUBWCYLXKTWDZXKTQ
      YLXKPBUIZWDYMEAPBXJXKXKWEXAHXIHYHRKFUPVRVSXBXEXHWTXDVRXGGVRWFWFWIYLYNTXKY
      LYNPTUITYLBTPYLBYGTIFSWCWGWHPWJWKWLWMXKWNWOWPWQWR $.

    mulgval.s $e |- S = seq 1 ( .+ , ( NN X. { X } ) ) $.
    $( Group multiple (exponentiation) operation.  (Contributed by Mario
       Carneiro, 11-Dec-2014.) $)
    mulgval $p |- ( ( N e. ZZ /\ X e. B ) -> ( N .x. X ) =
      if ( N = 0 , .0. , if ( 0 < N , ( S ` N ) , ( I ` ( S ` -u N ) ) ) ) ) $=
      ( vn cc0 wceq cfv cif vx cz cv clt wbr cn csn cxp c1 cseq wa simpl eqeq1d
      breq2d simpr sneqd xpeq2d seqeq3d syl6eqr fveq12d negeqd fveq2d ifbieq12d
      cneg ifbieq2d mulgfval c0g cvv fvex eqeltri ifex ovmpt2a ) PUAGHUBAPUCZQR
      ZIQVMUDUEZVMBUFUAUCZUGZUHZUIUJZSZVMVDZVSSZFSZTZTGQRZIQGUDUEZGCSZGVDZCSZFS
      ZTZTDVMGRZVPHRZUKZVNWEWDWKIWNVMGQWLWMULZUMWNVOWFVTWCWGWJWNVMGQUDWOUNWNVMG
      VSCWNVSBUFHUGZUHZUIUJCWNVRWQBUIWNVQWPUFWNVPHWLWMUOUPUQUROUSZWOUTWNWBWIFWN
      WAWHVSCWRWNVMGWOVAUTVBVCVEUAABDPEFIJKLMNVFWEIWKIEVGSVHLEVGVIVJWFWGWJGCVIW
      IFVIVKVKVL $.
  $}

  ${
    $d B n x $.  $d G n x $.
    mulgfn.b $e |- B = ( Base ` G ) $.
    mulgfn.t $e |- .x. = ( .g ` G ) $.
    $( Functionality of the group multiple function.  (Contributed by Mario
       Carneiro, 21-Mar-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    mulgfn $p |- .x. Fn ( ZZ X. B ) $=
      ( vn vx cz cv cc0 wceq c0g cfv clt wbr cplusg cif eqid fvex ifex csn cseq
      cn cxp c1 cneg cminusg mulgfval fnmpt2i ) FGHAFIZJKZCLMZJUJNOZUJCPMZUCGIU
      AUDUEUBZMZUJUFUOMZCUGMZMZQZQBGAUNBFCURULDUNRULRURREUHUKULUTCLSUMUPUSUJUOS
      UQURSTTUI $.
  $}

  ${
    mulgfvi.t $e |- .x. = ( .g ` G ) $.
    $( The group multiple function is compatible with identity-function
       protection.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    mulgfvi $p |- .x. = ( .g ` ( _I ` G ) ) $=
      ( cmg cfv cid cvv wcel wceq fvi eqcomd fveq2d wn c0 fvprc wfn cz cxp mpbi
      base0 eqid mulgfn xp0 fneq2i fn0 syl6eq eqtr4d pm2.61i eqtri ) ABDEZBFEZD
      EZCBGHZUJULIUMBUKDUMUKBBGJKLUMMZUJNULBDOUNULNDEZNUNUKNDBFOLUONPZUONIUOQNR
      ZPUPNUONTUOUAUBUQNUOQUCUDSUOUESUFUGUHUI $.
  $}

  ${
    mulg0.b $e |- B = ( Base ` G ) $.
    mulg0.o $e |- .0. = ( 0g ` G ) $.
    mulg0.t $e |- .x. = ( .g ` G ) $.
    $( Group multiple (exponentiation) operation at zero.  (Contributed by
       Mario Carneiro, 11-Dec-2014.) $)
    mulg0 $p |- ( X e. B -> ( 0 .x. X ) = .0. ) $=
      ( cc0 cz wcel co wceq 0z wa clt wbr cfv cif eqid cplusg csn cxp cseq cneg
      cn c1 cminusg mulgval iftrue ax-mp syl6eq mpan ) IJKZDAKZIDBLZEMNUNUOOUPI
      IMZEIIPQICUARZUFDUBUCUGUDZRIUEUSRCUHRZRSZSZEAURUSBCUTIDEFURTGUTTHUSTUIUQV
      BEMITUQEVAUJUKULUM $.
  $}

  ${
    mulgnn.b $e |- B = ( Base ` G ) $.
    mulgnn.p $e |- .+ = ( +g ` G ) $.
    mulgnn.t $e |- .x. = ( .g ` G ) $.
    mulgnn.s $e |- S = seq 1 ( .+ , ( NN X. { X } ) ) $.
    $( Group multiple (exponentiation) operation at a positive integer.
       (Contributed by Mario Carneiro, 11-Dec-2014.) $)
    mulgnn $p |- ( ( N e. NN /\ X e. B ) -> ( N .x. X ) = ( S ` N ) ) $=
      ( cn wcel cc0 wceq cfv cif eqid syl eqtrd wa c0g clt wbr cneg cminusg nnz
      co cz mulgval sylan wn nnne0 neneqd iffalse nngt0 iftrue adantr ) FLMZGAM
      ZUAFGDUHZFNOZEUBPZNFUCUDZFCPZFUECPEUFPZPZQZQZVEUSFUIMUTVAVIOFUGABCDEVFFGV
      CHIVCRVFRJKUJUKUSVIVEOUTUSVIVHVEUSVBULVIVHOUSFNFUMUNVBVCVHUOSUSVDVHVEOFUP
      VDVEVGUQSTURT $.
  $}

  ${
    mulg1.b $e |- B = ( Base ` G ) $.
    mulg1.m $e |- .x. = ( .g ` G ) $.
    $( Group multiple (exponentiation) operation at one.  (Contributed by Mario
       Carneiro, 11-Dec-2014.) $)
    mulg1 $p |- ( X e. B -> ( 1 .x. X ) = X ) $=
      ( wcel c1 co cplusg cfv cn csn cxp cseq wceq 1nn eqid mulgnn mpan mpan2
      1z fvconst2g seq1i eqtrd ) DAGZHDBIZHCJKZLDMNZHOZKZDHLGZUFUGUKPQAUHUJBCHD
      EUHRFUJRSTUFDUHUIHUBUFULHUIKDPQLDHAUCUAUDUE $.

    ${
      mulgnnp1.p $e |- .+ = ( +g ` G ) $.
      $( Group multiple (exponentiation) operation at a successor.
         (Contributed by Mario Carneiro, 11-Dec-2014.) $)
      mulgnnp1 $p |- ( ( N e. NN /\ X e. B ) ->
        ( ( N + 1 ) .x. X ) = ( ( N .x. X ) .+ X ) ) $=
        ( cn wcel wa c1 caddc co csn cxp cfv wceq mulgnn cseq cuz nnuz syl6eleq
        simpl seqp1 syl id peano2nn fvconst2g syl2anr oveq2d eqtrd sylan oveq1d
        eqid 3eqtr4d ) EJKZFAKZLZEMNOZBJFPQZMUAZRZEVCRZFBOZVAFCOZEFCOZFBOUTVDVE
        VAVBRZBOZVFUTEMUBRZKVDVJSUTEJVKURUSUEUCUDBVBMEUFUGUTVIFVEBUSUSVAJKZVIFS
        URUSUHEUIZJFVAAUJUKULUMURVLUSVGVDSVMABVCCDVAFGIHVCUPZTUNUTVHVEFBABVCCDE
        FGIHVNTUOUQ $.

      $( Group multiple (exponentiation) operation at two.  (Contributed by
         Mario Carneiro, 15-Oct-2015.) $)
      mulg2 $p |- ( X e. B -> ( 2 .x. X ) = ( X .+ X ) ) $=
        ( wcel c2 co c1 caddc df-2 oveq1i cn wceq 1nn mulgnnp1 mpan mulg1 eqtrd
        syl5eq oveq1d ) EAIZJECKZLECKZEBKZEEBKUEUFLLMKZECKZUHJUIECNOLPIUEUJUHQR
        ABCDLEFGHSTUCUEUGEEBACDEFGUAUDUB $.
    $}

    mulgnegnn.i $e |- I = ( invg ` G ) $.
    $( Group multiple (exponentiation) operation at a negative integer.
       (Contributed by Mario Carneiro, 11-Dec-2014.) $)
    mulgnegnn $p |- ( ( N e. NN /\ X e. B ) ->
      ( -u N .x. X ) = ( I ` ( N .x. X ) ) ) $=
      ( cn wcel cneg cfv wceq fveq2d cc0 clt wbr eqid syl wa cplusg csn c1 cseq
      cxp co nncn negnegd adantr c0g cif cz nnnegz mulgval sylan wn nnne0 cc wb
      negeq0 necon3abid mpbid iffalse cr nnre renegcld nngt0 lt0neg2d wi ltnsym
      wne 0re mpan2 sylc eqtrd mulgnn 3eqtr4d ) EJKZFAKZUAZELZLZCUBMZJFUCUFUDUE
      ZMZDMZEWEMZDMWBFBUGZEFBUGZDMWAWFWHDWAWCEWEVSWCENVTVSEEUHZUIUJOOWAWIWBPNZC
      UKMZPWBQRZWBWEMZWGULZULZWGVSWBUMKVTWIWQNEUNAWDWEBCDWBFWMGWDSZWMSIHWESZUOU
      PVSWQWGNVTVSWQWPWGVSWLUQZWQWPNVSEPVLZWTEURVSEUSKZXAWTUTWKXBWLEPEVAVBTVCWL
      WMWPVDTVSWNUQZWPWGNVSWBVEKZWBPQRZXCVSEEVFZVGVSPEQRXEEVHVSEXFVIVCXDPVEKXEX
      CVJVMWBPVKVNVOWNWOWGVDTVPUJVPWAWJWHDAWDWEBCEFGWRHWSVQOVR $.
  $}

  ${
    mulgnn0p1.b $e |- B = ( Base ` G ) $.
    mulgnn0p1.t $e |- .x. = ( .g ` G ) $.
    mulgnn0p1.p $e |- .+ = ( +g ` G ) $.
    $( Group multiple (exponentiation) operation at a successor, extended to
       ` NN0 ` .  (Contributed by Mario Carneiro, 11-Dec-2014.) $)
    mulgnn0p1 $p |- ( ( G e. Mnd /\ N e. NN0 /\ X e. B ) ->
      ( ( N + 1 ) .x. X ) = ( ( N .x. X ) .+ X ) ) $=
      ( cmnd wcel c1 caddc co wceq cc0 wa adantl oveq1d oveq1 cn0 w3a cn simpl3
      simpr mulgnnp1 syl2anc c0g eqid mndlid mulg0 mulg1 3eqtr4rd 3adant2 1e0p1
      cfv syl6eqr eqeq12d syl5ibrcom imp wo simp2 elnn0 sylib mpjaodan ) DJKZEU
      AKZFAKZUBZEUCKZELMNZFCNZEFCNZFBNZOZEPOZVIVJQVJVHVOVIVJUEVFVGVHVJUDABCDEFG
      HIUFUGVIVPVOVIVOVPLFCNZPFCNZFBNZOZVFVHVTVGVFVHQZDUHUPZFBNFVSVQABDFWBGIWBU
      IZUJWAVRWBFBVHVRWBOVFACDFWBGWCHUKRSVHVQFOVFACDFGHULRUMUNVPVLVQVNVSVPVKLFC
      VPVKPLMNLEPLMTUOUQSVPVMVRFBEPFCTSURUSUTVIVGVJVPVAVFVGVHVBEVCVDVE $.
  $}

  ${
    $d x y .+ $.  $d x y B $.  $d x y G $.  $d x I $.  $d x y N $.  $d x y S $.
    $d x y ph $.  $d x .x. $.  $d x y X $.
    mulgnnsubcl.b $e |- B = ( Base ` G ) $.
    mulgnnsubcl.t $e |- .x. = ( .g ` G ) $.
    mulgnnsubcl.p $e |- .+ = ( +g ` G ) $.
    mulgnnsubcl.g $e |- ( ph -> G e. V ) $.
    mulgnnsubcl.s $e |- ( ph -> S C_ B ) $.
    mulgnnsubcl.c $e |- ( ( ph /\ x e. S /\ y e. S ) -> ( x .+ y ) e. S ) $.
    $( Closure of the group multiple (exponentiation) operation in a
       subsemigroup.  (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    mulgnnsubcl $p |- ( ( ph /\ N e. NN /\ X e. S ) -> ( N .x. X ) e. S ) $=
      ( cn wcel c1 w3a co csn cxp cseq cfv wceq simp2 wss 3ad2ant1 simp3 sseldd
      eqid mulgnn syl2anc cuz syl6eleq cv cfz wa elfznn fvconst2g syl2an simpl3
      nnuz eqeltrd 3expb 3ad2antl1 seqcl ) AIRSZKFSZUAZIKGUBZIERKUCUDZTUEZUFZFV
      LVJKDSVMVPUGAVJVKUHZVLFDKAVJFDUIVKPUJAVJVKUKZULDEVOGHIKLNMVOUMUNUOVLBCEFV
      NTIVLIRTUPUFVQVEUQVLBURZTIUSUBSZUTVSVNUFZKFVLVKVSRSWAKUGVTVRVSIVARKVSFVBV
      CAVJVKVTVDVFAVJVSFSZCURZFSZUTVSWCEUBFSZVKAWBWDWEQVGVHVIVF $.

    mulgnn0subcl.z $e |- .0. = ( 0g ` G ) $.
    mulgnn0subcl.c $e |- ( ph -> .0. e. S ) $.
    $( Closure of the group multiple (exponentiation) operation in a
       submonoid.  (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    mulgnn0subcl $p |- ( ( ph /\ N e. NN0 /\ X e. S ) -> ( N .x. X ) e. S ) $=
      ( cn0 wcel w3a cn co wceq mulgnnsubcl 3expa an32s 3adantl2 oveq1 3ad2ant1
      cc0 wa wss simp3 sseldd mulg0 syl sylan9eqr adantr eqeltrd wo simp2 elnn0
      sylib mpjaodan ) AIUAUBZKFUBZUCZIUDUBZIKGUEZFUBZIUMUFZAVIVKVMVHAVKVIVMAVK
      VIVMABCDEFGHIJKMNOPQRUGUHUIUJVJVNUNVLLFVNVJVLUMKGUEZLIUMKGUKVJKDUBVOLUFVJ
      FDKAVHFDUOVIQULAVHVIUPUQDGHKLMSNURUSUTVJLFUBZVNAVHVPVITULVAVBVJVHVKVNVCAV
      HVIVDIVEVFVG $.

    mulgsubcl.i $e |- I = ( invg ` G ) $.
    mulgsubcl.c $e |- ( ( ph /\ x e. S ) -> ( I ` x ) e. S ) $.
    $( Closure of the group multiple (exponentiation) operation in a subgroup.
       (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    mulgsubcl $p |- ( ( ph /\ N e. ZZ /\ X e. S ) -> ( N .x. X ) e. S ) $=
      ( cz wcel w3a cn0 co cr cn wa mulgnn0subcl 3expa an32s 3adantl2 cfv simp2
      cneg adantr zcnd negnegd oveq1d wceq id wss 3ad2ant1 simp3 sseldd syl2anr
      mulgnegnn eqtr3d cv wral mulgnnsubcl ralrimiva fveq2 eleq1d rspcv eqeltrd
      sylc adantrl wo elznn0nn sylib mpjaodan ) AJUDUEZLFUEZUFZJUGUEZJLGUHZFUEZ
      JUIUEZJURZUJUEZUKZAWGWIWKWFAWIWGWKAWIWGWKABCDEFGHJKLMNOPQRSTUAULUMUNUOWHW
      NWKWLWHWNUKZWJWMLGUHZIUPZFWPWMURZLGUHZWJWRWPWSJLGWPJWPJWHWFWNAWFWGUQZUSUT
      VAVBWNWNLDUEWTWRVCWHWNVDWHFDLAWFFDVEWGRVFAWFWGVGVHDGHIWMLNOUBVJVIVKWPWQFU
      EZBVLZIUPZFUEZBFVMZWRFUEZAWGWNXBWFAWNWGXBAWNWGXBABCDEFGHWMKLNOPQRSVNUMUNU
      OWHXFWNAWFXFWGAXEBFUCVOVFUSXEXGBWQFXCWQVCXDWRFXCWQIVPVQVRVTVSWAWHWFWIWOWB
      XAJWCWDWE $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y N $.  $d x .x. $.  $d x y X $.
    mulgnncl.b $e |- B = ( Base ` G ) $.
    mulgnncl.t $e |- .x. = ( .g ` G ) $.
    $( Closure of the group multiple (exponentiation) operation.  TODO:  This
       can be generalized to a magma if/when we introduce them.  (Contributed
       by Mario Carneiro, 11-Dec-2014.) $)
    mulgnncl $p |- ( ( G e. Mnd /\ N e. NN /\ X e. B ) -> ( N .x. X ) e. B ) $=
      ( vx vy cmnd wcel cplusg cfv eqid id wss ssid a1i cv mndcl mulgnnsubcl )
      CJKZHIACLMZABCDJEFGUCNZUBOAAPUBAQRAUCCHSISFUDTUA $.

    $( Closure of the group multiple (exponentiation) operation.  (Contributed
       by Mario Carneiro, 11-Dec-2014.) $)
    mulgnn0cl $p |- ( ( G e. Mnd /\ N e. NN0 /\ X e. B ) ->
      ( N .x. X ) e. B ) $=
      ( vx vy cmnd wcel cplusg cfv c0g eqid id wss ssid a1i cv mndcl mndidcl
      mulgnn0subcl ) CJKZHIACLMZABCDJECNMZFGUEOZUDPAAQUDARSAUECHTITFUGUAUFOZACU
      FFUHUBUC $.

    $( Closure of the group multiple (exponentiation) operation.  (Contributed
       by Mario Carneiro, 11-Dec-2014.) $)
    mulgcl $p |- ( ( G e. Grp /\ N e. ZZ /\ X e. B ) -> ( N .x. X ) e. B ) $=
      ( vx vy cgrp wcel cplusg cfv cminusg c0g eqid id wss ssid cv a1i grpinvcl
      grpcl grpidcl mulgsubcl ) CJKZHIACLMZABCCNMZDJECOMZFGUGPZUFQAARUFASUAAUGC
      HTZITFUJUCUIPZACUIFULUDUHPZACUHUKFUMUBUE $.

    mulgneg.i $e |- I = ( invg ` G ) $.
    $( Group multiple (exponentiation) operation at a negative integer.
       (Contributed by Mario Carneiro, 11-Dec-2014.) $)
    mulgneg $p |- ( ( G e. Grp /\ N e. ZZ /\ X e. B ) ->
      ( -u N .x. X ) = ( I ` ( N .x. X ) ) ) $=
      ( wcel cz cneg co cfv wceq wa cc0 simpl3 syl2anc oveq1d cgrp w3a cr cn wo
      cn0 elnn0 simpr mulgnegnn c0g simpl1 eqid grpinvid syl mulg0 eqtrd fveq2d
      negeqd neg0 syl6eq 3eqtr4rd jaodan sylan2b simprr mulgcl grpinvinv simprl
      nnzd syl3anc recnd negnegd eqtr3d simp2 elznn0nn sylib mpjaodan ) CUAJZEK
      JZFAJZUBZEUFJZELZFBMZEFBMZDNZOZEUCJZWBUDJZPZWAVTEUDJZEQOZUEWFEUGVTWJWFWKV
      TWJPWJVSWFVTWJUHVQVRVSWJRABCDEFGHIUISVTWKPZCUJNZDNZWMWEWCWLVQWNWMOVQVRVSW
      KUKCDWMWMULZIUMUNWLWDWMDWLWDQFBMZWMWLEQFBVTWKUHZTWLVSWPWMOVQVRVSWKRABCFWM
      GWOHUOUNZUPUQWLWCWPWMWLWBQFBWLWBQLQWLEQWQURUSUTTWRUPVAVBVCVTWIPZWCDNZDNZW
      CWEWSVQWCAJZXAWCOVQVRVSWIUKZWSVQWBKJVSXBXCWSWBVTWGWHVDZVHVQVRVSWIRZABCWBF
      GHVEVIACDWCGIVFSWSWTWDDWSWBLZFBMZWTWDWSWHVSXGWTOXDXEABCDWBFGHIUISWSXFEFBW
      SEWSEVTWGWHVGVJVKTVLUQVLVTVRWAWIUEVQVRVSVMEVNVOVP $.

    $( Group multiple (exponentiation) operation at negative one.  (Contributed
       by Mario Carneiro, 20-Dec-2014.) $)
    mulgm1 $p |- ( ( G e. Grp /\ X e. B ) -> ( -u 1 .x. X ) = ( I ` X ) ) $=
      ( cgrp wcel wa c1 cneg co cfv cz wceq 1z mulgneg mp3an2 adantl fveq2d
      mulg1 eqtrd ) CIJZEAJZKZLMEBNZLEBNZDOZEDOUELPJUFUHUJQRABCDLEFGHSTUGUIEDUF
      UIEQUEABCEFGUCUAUBUD $.
  $}

  ${
    $d x G $.  $d x N $.  $d x .0. $.
    mulgnn0z.b $e |- B = ( Base ` G ) $.
    mulgnn0z.t $e |- .x. = ( .g ` G ) $.
    mulgnn0z.o $e |- .0. = ( 0g ` G ) $.
    $( A group multiple of the identity, for nonnegative multiple.
       (Contributed by Mario Carneiro, 13-Dec-2014.) $)
    mulgnn0z $p |- ( ( G e. Mnd /\ N e. NN0 ) -> ( N .x. .0. ) = .0. ) $=
      ( vx cn0 wcel cmnd cn cc0 wceq co cfv c1 eqid adantr elnn0 cplusg csn cxp
      wo wa cseq id mndidcl mulgnn syl2anr mndlid mpdan cuz simpr nnuz syl6eleq
      cfz elfznn fvconst2g syl2an seqid3 eqtrd oveq1 mulg0 syl sylan9eqr jaodan
      cv sylan2b ) DJKCLKZDMKZDNOZUEDEBPZEOZDUAVKVLVOVMVKVLUFZVNDCUBQZMEUCUDZRU
      GZQZEVLVLEAKZVNVTOVKVLUHACEFHUIZAVQVSBCDEFVQSZGVSSUJUKVPIVQVRRDEVKEEVQPEO
      ZVLVKWAWDWBAVQCEEFWCHULUMTVPDMRUNQVKVLUOUPUQVPWAIVIZMKWEVRQEOWERDURPKVKWA
      VLWBTWEDUSMEWEAUTVAVBVCVMVKVNNEBPZEDNEBVDVKWAWFEOWBABCEEFHGVEVFVGVHVJ $.

    $( A group multiple of the identity, for integer multiple.  (Contributed by
       Mario Carneiro, 13-Dec-2014.) $)
    mulgz $p |- ( ( G e. Grp /\ N e. ZZ ) -> ( N .x. .0. ) = .0. ) $=
      ( wcel cz wa cn0 co wceq cneg mulgnn0z sylan cfv adantl ad2antrr cgrp zcn
      cmnd grpmnd adantr cminusg simpll nn0z grpidcl mulgneg syl3anc cc negnegd
      eqid ad2antlr oveq1d fveq2d grpinvid eqtrd 3eqtr3d wo cr simprbi mpjaodan
      elznn0 ) CUAIZDJIZKZDLIZDEBMZENZDOZLIZVHCUCIZVIVKVFVNVGCUDUEZABCDEFGHPQVH
      VMKZVLOZEBMZVLEBMZCUFRZRZVJEVPVFVLJIZEAIZVRWANVFVGVMUGVMWBVHVLUHSVFWCVGVM
      ACEFHUITABCVTVLEFGVTUNZUJUKVPVQDEBVPDVGDULIVFVMDUBUOUMUPVPWAEVTRZEVPVSEVT
      VHVNVMVSENVOABCVLEFGHPQUQVFWEENVGVMCVTEHWDURTUSUTVGVIVMVAZVFVGDVBIWFDVEVC
      SVD $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z M $.  $d x y z N $.  $d x y z .+ $.
    $d x y z X $.
    mulgnndir.b $e |- B = ( Base ` G ) $.
    mulgnndir.t $e |- .x. = ( .g ` G ) $.
    mulgnndir.p $e |- .+ = ( +g ` G ) $.
    $( Sum of group multiples, for positive multiples.  TODO:  This can be
       generalized to a semigroup if/when we introduce them.  (Contributed by
       Mario Carneiro, 11-Dec-2014.) $)
    mulgnndir $p |- ( ( G e. Mnd /\ ( M e. NN /\ N e. NN /\ X e. B ) ) ->
      ( ( M + N ) .x. X ) = ( ( M .x. X ) .+ ( N .x. X ) ) ) $=
      ( wcel cn wa caddc co c1 cfv wceq cuz syl2anc vx vy cmnd w3a csn cxp cseq
      vz cv mndcl 3expb adantlr mndass simpr2 nnuz syl6eleq simpr1 nnzd eluzadd
      cz nncnd addcomd cc ax-1cn addcom sylancl fveq2d 3eltr4d simpr3 fvconst2g
      cfz elfznn syl2an adantr eqeltrd seqsplit nnaddcl mulgnn syl2anr seqshft2
      eqid eqtr4d seqeq1d fveq12d 3eqtr4d oveq12d ) DUCKZELKZFLKZGAKZUDZMZEFNOZ
      BLGUEUFZPUGZQZEWOQZWMBWNEPNOZUGZQZBOWMGCOZEGCOZFGCOZBOWLUAUBUHBAWNPEWMWGU
      AUIZAKZUBUIZAKZMXDXFBOZAKZWKWGXEXGXIABDXDXFHJUJUKULWGXEXGUHUIZAKUDXHXJBOX
      DXFXJBOBORWKABDXDXFXJHJUMULWLFENOZPENOZSQZWMWRSQWLFPSQZKEUTKXKXMKWLFLXNWG
      WHWIWJUNZUOUPZWLEWGWHWIWJUQZURZEPFUSTWLEFWLEXQVAZWLFXOVAVBZWLWRXLSWLEVCKP
      VCKWRXLRXSVDEPVEVFZVGVHWLELXNXQUOUPWLXDPWMVKOKZMXDWNQZGAWLWJXDLKZYCGRZYBW
      GWHWIWJVIZXDWMVLLGXDAVJZVMWLWJYBYFVNVOVPWLWMLKZWJXAWPRWLWHWIYHXQXOEFVQTYF
      ABWOCDWMGHJIWOWAZVRTWLXBWQXCWTBWLWHWJXBWQRXQYFABWOCDEGHJIYIVRTWLFWOQZXKBW
      NXLUGZQXCWTWLBUAWNWNEPFXPXRWLXDPFVKOKZMZYCGXDENOZWNQZWLWJYDYEYLYFXDFVLZYG
      VMYMWJYNLKZYOGRWLWJYLYFVNYLYDWHYQWLYPXQXDEVQVSLGYNAVJTWBVTWLWIWJXCYJRXOYF
      ABWOCDFGHJIYIVRTWLWMXKWSYKWLWRXLBWNYAWCXTWDWEWFWE $.

    $( Sum of group multiples, generalized to ` NN0 ` .  (Contributed by Mario
       Carneiro, 11-Dec-2014.) $)
    mulgnn0dir $p |- ( ( G e. Mnd /\ ( M e. NN0 /\ N e. NN0 /\ X e. B ) ) ->
      ( ( M + N ) .x. X ) = ( ( M .x. X ) .+ ( N .x. X ) ) ) $=
      ( wcel cn0 wa caddc co wceq cc0 simpr oveq1d eqtrd cmnd cn simplll simplr
      w3a simpr3 ad2antrr mulgnndir syl13anc c0g simpll simpr1 adantr mulgnn0cl
      cfv simplr3 syl3anc eqid mndrid syl2anc mulg0 syl oveq2d addid1d 3eqtr4rd
      nn0cnd adantlr wo simpr2 elnn0 sylib mpjaodan simplr2 mndlid addid2d ) DU
      AKZELKZFLKZGAKZUEZMZEUBKZEFNOZGCOZEGCOZFGCOZBOZPZEQPZWAWBMZFUBKZWHFQPZWJW
      KMVPWBWKVSWHVPVTWBWKUCWAWBWKUDWJWKRWAVSWBWKVPVQVRVSUFUGABCDEFGHIJUHUIWAWL
      WHWBWAWLMZWEDUJUOZBOZWEWGWDWMVPWEAKZWOWEPVPVTWLUKZWMVPVQVSWPWQWAVQWLVPVQV
      RVSULZUMZVQVRVSVPWLUPZACDEGHIUNUQABDWEWNHJWNURZUSUTWMWFWNWEBWMWFQGCOZWNWM
      FQGCWAWLRZSWMVSXBWNPZWTACDGWNHXAIVAZVBTVCWMWCEGCWMWCEQNOEWMFQENXCVCWMEWME
      WSVFVDTSVEVGWAWKWLVHZWBWAVRXFVPVQVRVSVIFVJVKUMVLWAWIMZWNWFBOZWFWGWDXGVPWF
      AKZXHWFPVPVTWIUKZXGVPVRVSXIXJVQVRVSVPWIVMZVQVRVSVPWIUPZACDFGHIUNUQABDWFWN
      HJXAVNUTXGWEWNWFBXGWEXBWNXGEQGCWAWIRZSXGVSXDXLXEVBTSXGWCFGCXGWCQFNOFXGEQF
      NXMSXGFXGFXKVFVOTSVEWAVQWBWIVHWREVJVKVL $.

    $( Lemma for ~ mulgdir .  (Contributed by Mario Carneiro, 13-Dec-2014.) $)
    mulgdirlem $p |- ( ( G e. Grp /\
        ( M e. ZZ /\ N e. ZZ /\ X e. B ) /\ ( M + N ) e. NN0 ) ->
      ( ( M + N ) .x. X ) = ( ( M .x. X ) .+ ( N .x. X ) ) ) $=
      ( wcel cz co cn0 wceq wa syl syl13anc adantr syl3anc cgrp caddc cneg cmnd
      w3a simpl1 grpmnd simprl simprr simpl23 mulgnn0dir anassrs c0g cfv simp22
      cminusg eqid mulgneg oveq1d mulgcl grplinv syl2anc oveq2d simpl3 ad2antll
      eqtrd nn0z grprid grpass cmin cc simp21 zcnd addcld negsubd pncand eqtr3d
      wo elznn0 simprbi mpjaodan znegcld 3ad2ant3 grprinv grplid negcld addcomd
      cr simpr pncan2d 3eqtrd 3eqtr3d ) DUAKZELKZFLKZGAKZUEZEFUBMZNKZUEZENKZWRG
      CMZEGCMZFGCMZBMZOZEUCZNKZWTXAPFNKZXFFUCZNKZWTXAXIXFWTXAXIPZPZDUDKZXAXIWPX
      FXMWMXNWMWQWSXLUFDUGZQWTXAXIUHWTXAXIUIWNWOWPWMWSXLUJABCDEFGHIJUKRULWTXAXK
      XFWTXAXKPZPZXBXJGCMZXDBMZBMZXBXEXQXTXBDUMUNZBMZXBXQXSYAXBBXQXSXDDUPUNZUNZ
      XDBMZYAXQXRYDXDBXQWMWOWPXRYDOWMWQWSXPUFZWTWOXPWMWNWOWPWSUOZSZWNWOWPWMWSXP
      UJZACDYCFGHIYCUQZURTUSXQWMXDAKZYEYAOYFXQWMWOWPYKYFYHYIACDFGHIUTTZABDYCXDY
      AHJYAUQZYJVAVBVFVCXQWMXBAKZYBXBOYFXQWMWRLKZWPYNYFXQWSYOWMWQWSXPVDZWRVGZQY
      IACDWRGHIUTZTZABDXBYAHJYMVHVBVFXQXBXRBMZXDBMZXTXEXQWMYNXRAKZYKUUAXTOYFYSX
      QWMXJLKZWPUUBYFXKUUCWTXAXJVGVEYIACDXJGHIUTTYLABDXBXRXDHJVIRXQYTXCXDBXQWRX
      JUBMZGCMZYTXCXQXNWSXKWPUUEYTOXQWMXNYFXOQYPWTXAXKUIYIABCDWRXJGHIJUKRXQUUDE
      GCXQUUDWRFVJMEXQWRFWTWRVKKZXPWTEFWTEWMWNWOWPWSVLZVMZWTFYGVMZVNZSWTFVKKZXP
      UUISZVOXQEFWTEVKKZXPUUHSUULVPVFUSVQUSVQVQULWTXIXKVRZXAWTWOUUNYGWOFWHKUUNF
      VSVTQSWAWTXHPZXCXGGCMZBMZXBBMZXCUUPXBBMZBMZXBXEUUOWMXCAKZUUPAKZYNUURUUTOW
      MWQWSXHUFZUUOWMWNWPUVAUVCWTWNXHUUGSZWNWOWPWMWSXHUJZACDEGHIUTTZUUOWMXGLKWP
      UVBUVCUUOEUVDWBUVEACDXGGHIUTTUUOWMYOWPYNUVCWTYOXHWSWMYOWQYQWCSUVEYRTZABDX
      CUUPXBHJVIRUUOUURYAXBBMZXBUUOUUQYAXBBUUOUUQXCXCYCUNZBMZYAUUOUUPUVIXCBUUOW
      MWNWPUUPUVIOUVCUVDUVEACDYCEGHIYJURTVCUUOWMUVAUVJYAOUVCUVFABDYCXCYAHJYMYJW
      DVBVFUSUUOWMYNUVHXBOUVCUVGABDXBYAHJYMWEVBVFUUOUUSXDXCBUUOXGWRUBMZGCMZUUSX
      DUUOXNXHWSWPUVLUUSOUUOWMXNUVCXOQWTXHWIWMWQWSXHVDUVEABCDXGWRGHIJUKRUUOUVKF
      GCUUOUVKWRXGUBMWREVJMFUUOXGWRUUOEWTUUMXHUUHSZWFWTUUFXHUUJSZWGUUOWREUVNUVM
      VOUUOEFUVMWTUUKXHUUISWJWKUSVQVCWLWTWNXAXHVRZUUGWNEWHKUVOEVSVTQWA $.

    $( Sum of group multiples, generalized to ` ZZ ` .  (Contributed by Mario
       Carneiro, 13-Dec-2014.) $)
    mulgdir $p |- ( ( G e. Grp /\ ( M e. ZZ /\ N e. ZZ /\ X e. B ) ) ->
      ( ( M + N ) .x. X ) = ( ( M .x. X ) .+ ( N .x. X ) ) ) $=
      ( wcel cz caddc co cn0 wceq cneg cfv adantr syl3anc cgrp mulgdirlem 3expa
      w3a wa cminusg simpll simpr2 znegcld simpr1 simplr3 negdid negcld addcomd
      zcnd eqtrd simpr eqeltrrd syl131anc oveq1d zaddcld mulgneg eqtr3d oveq12d
      eqid mulgcl grpinvadd eqtr4d 3eqtr3d fveq2d grpinvinv syl2anc grpcl wo cr
      elznn0 simprbi syl mpjaodan ) DUAKZELKZFLKZGAKZUDZUEZEFMNZOKZWFGCNZEGCNZF
      GCNZBNZPZWFQZOKZVTWDWGWLABCDEFGHIJUBUCWEWNUEZWHDUFRZRZWPRZWKWPRZWPRZWHWKW
      OWQWSWPWOFQZEQZMNZGCNZXAGCNZXBGCNZBNZWQWSWOVTXALKXBLKWCXCOKXDXGPVTWDWNUGZ
      WOFWEWBWNVTWAWBWCUHZSZUIWOEWEWAWNVTWAWBWCUJZSZUIWAWBWCVTWNUKZWOWMXCOWOWMX
      BXAMNXCWOEFWOEXLUOZWOFXJUOZULWOXBXAWOEXNUMWOFXOUMUNUPZWEWNUQURABCDXAXBGHI
      JUBUSWOWMGCNZXDWQWOWMXCGCXPUTWOVTWFLKZWCXQWQPXHWEXRWNWEEFXKXIVAZSZXMACDWP
      WFGHIWPVEZVBTVCWOXGWJWPRZWIWPRZBNZWSWOXEYBXFYCBWOVTWBWCXEYBPXHXJXMACDWPFG
      HIYAVBTWOVTWAWCXFYCPXHXLXMACDWPEGHIYAVBTVDWOVTWIAKZWJAKZWSYDPXHWOVTWAWCYE
      XHXLXMACDEGHIVFTZWOVTWBWCYFXHXJXMACDFGHIVFTZABDWPWIWJHJYAVGTVHVIVJWOVTWHA
      KZWRWHPXHWOVTXRWCYIXHXTXMACDWFGHIVFTADWPWHHYAVKVLWOVTWKAKZWTWKPXHWOVTYEYF
      YJXHYGYHABDWIWJHJVMTADWPWKHYAVKVLVIWEXRWGWNVNZXSXRWFVOKYKWFVPVQVRVS $.

    $( Group multiple (exponentiation) operation at a successor, extended to
       ` ZZ ` .  (Contributed by Mario Carneiro, 11-Dec-2014.) $)
    mulgp1 $p |- ( ( G e. Grp /\ N e. ZZ /\ X e. B ) ->
      ( ( N + 1 ) .x. X ) = ( ( N .x. X ) .+ X ) ) $=
      ( cgrp wcel cz w3a c1 caddc co wceq 1z mulgdir mp3anr2 3impb mulg1 oveq2d
      3ad2ant3 eqtrd ) DJKZELKZFAKZMZENOPFCPZEFCPZNFCPZBPZUKFBPUFUGUHUJUMQZUFUG
      NLKUHUNRABCDENFGHISTUAUIULFUKBUHUFULFQUGACDFGHUBUDUCUE $.
  $}

  ${
    $d n x B $.  $d n x G $.  $d n x I $.  $d n x .x. $.  $d n x X $.
    $d x N $.
    mulgneg2.b $e |- B = ( Base ` G ) $.
    mulgneg2.m $e |- .x. = ( .g ` G ) $.
    mulgneg2.i $e |- I = ( invg ` G ) $.
    $( Group multiple (exponentiation) operation at a negative integer.
       (Contributed by Mario Carneiro, 13-Dec-2014.) $)
    mulgneg2 $p |- ( ( G e. Grp /\ N e. ZZ /\ X e. B ) ->
      ( -u N .x. X ) = ( N .x. ( I ` X ) ) ) $=
      ( wcel cneg co cfv wceq cc0 c1 negeq oveq1d oveq1 eqeq12d vx vn cgrp neg0
      cz cv caddc wa syl6eq c0g eqid mulg0 adantl grpinvcl syl eqtr4d wi cplusg
      cn0 cc nn0cn ax-1cn negdi sylancl simpll nn0negz 1z znegcl simplr mulgdir
      mp1i syl13anc mulgm1 adantr oveq2d 3eqtrd grpmnd ad2antrr simpr mulgnn0p1
      cmnd syl3anc syl5ibr ex cn fveq2 nnnegz mulgneg id mulgnegnn zindd 3impia
      syl2anr 3com23 ) CUCJZFAJZEUEJZEKZFBLZEFDMZBLZNZWOWPWQXBUAUFZKZFBLZXCWTBL
      ZNOFBLZOWTBLZNUBUFZKZFBLZXIWTBLZNZXJKZFBLZXJWTBLZNZXIPUGLZKZFBLZXRWTBLZNZ
      XBWOWPUHZUAUBEXCONZXEXGXFXHYDXDOFBYDXDOKOXCOQUDUIRXCOWTBSTXCXINZXEXKXFXLY
      EXDXJFBXCXIQRXCXIWTBSTXCXRNZXEXTXFYAYFXDXSFBXCXRQRXCXRWTBSTXCXJNZXEXOXFXP
      YGXDXNFBXCXJQRXCXJWTBSTXCENZXEWSXFXAYHXDWRFBXCEQRXCEWTBSTYCXGCUJMZXHWPXGY
      INWOABCFYIGYIUKZHULUMYCWTAJZXHYINACDFGIUNZABCWTYIGYJHULUOUPYCXIUSJZXMYBUQ
      XMYBYCYMUHZXKWTCURMZLZXLWTYOLZNXKXLWTYOSYNXTYPYAYQYNXTXJPKZUGLZFBLZXKYRFB
      LZYOLZYPYNXSYSFBYNXIUTJZPUTJXSYSNYMUUCYCXIVAUMVBXIPVCVDRYNWOXJUEJZYRUEJZW
      PYTUUBNWOWPYMVEYMUUDYCXIVFUMPUEJUUEYNVGPVHVKWOWPYMVIAYOBCXJYRFGHYOUKZVJVL
      YNUUAWTXKYOYCUUAWTNYMABCDFGHIVMVNVOVPYNCWAJZYMYKYAYQNWOUUGWPYMCVQVRYCYMVS
      YCYKYMYLVNAYOBCXIWTGHUUFVTWBTWCWDYCXIWEJZXMXQUQXMXQYCUUHUHZXKDMZXLDMZNXKX
      LDWFUUIXOUUJXPUUKUUIWOUUDWPXOUUJNWOWPUUHVEUUHUUDYCXIWGUMWOWPUUHVIABCDXJFG
      HIWHWBUUHUUHYKXPUUKNYCUUHWIYLABCDXIWTGHIWJWMTWCWDWKWLWN $.
  $}

  ${
    $d m n B $.  $d m n G $.  $d m n N $.  $d m n .x. $.  $d m n X $.
    $d n M $.
    mulgass.b $e |- B = ( Base ` G ) $.
    mulgass.t $e |- .x. = ( .g ` G ) $.
    $( Product of group multiples, for positive multiples.  TODO:  This can be
       generalized to a semigroup if/when we introduce them.  (Contributed by
       Mario Carneiro, 13-Dec-2014.) $)
    mulgnnass $p |- ( ( G e. Mnd /\ ( M e. NN /\ N e. NN /\ X e. B ) ) ->
      ( ( M x. N ) .x. X ) = ( M .x. ( N .x. X ) ) ) $=
      ( wcel cn cmul co wceq wi c1 caddc oveq1 oveq1d eqeq12d imbi2d vn vm cmnd
      w3a cv nncn mulid2d 3ad2ant1 mulgnncl 3coml mulg1 syl eqtr4d wa cplusg cc
      cfv adantr ax-1cn simpr1 nncnd adddird adantl oveq2d eqtrd simpr3 nnmulcl
      3ad2antr1 simpr2 eqid mulgnndir syl13anc mulgnnp1 sylan2 syl5ibr ex nnind
      a1i a2d 3expd com4r 3imp2 ) CUCIZDJIZEJIZFAIZDEKLZFBLZDEFBLZBLZMZWDWEWFWC
      WKWDWEWFWCWKWEWFWCUDZUAUEZEKLZFBLZWMWIBLZMZNWLOEKLZFBLZOWIBLZMZNWLUBUEZEK
      LZFBLZXBWIBLZMZNWLXBOPLZEKLZFBLZXGWIBLZMZNWLWKNUAUBDWMOMZWQXAWLXLWOWSWPWT
      XLWNWRFBWMOEKQRWMOWIBQSTWMXBMZWQXFWLXMWOXDWPXEXMWNXCFBWMXBEKQRWMXBWIBQSTW
      MXGMZWQXKWLXNWOXIWPXJXNWNXHFBWMXGEKQRWMXGWIBQSTWMDMZWQWKWLXOWOWHWPWJXOWNW
      GFBWMDEKQRWMDWIBQSTWLWSWIWTWLWREFBWEWFWREMZWCWEEEUFUGUHZRWLWIAIZWTWIMWCWE
      WFXRABCEFGHUIUJZABCWIGHUKULUMXBJIZWLXFXKXTWLXFXKNXFXKXTWLUNZXDWICUOUQZLZX
      EWIYBLZMXDXEWIYBQYAXIYCXJYDYAXIXCEPLZFBLZYCYAXHYEFBYAXHXCWRPLYEYAXBOEXTXB
      UPIWLXBUFUROUPIYAUSVRYAEXTWEWFWCUTZVAVBYAWREXCPWLXPXTXQVCVDVERYAWCXCJIZWE
      WFYFYCMXTWEWFWCVFXTWFWEYHWCXBEVGVHYGXTWEWFWCVIAYBBCXCEFGHYBVJZVKVLVEWLXTX
      RXJYDMXSAYBBCXBWIGHYIVMVNSVOVPVSVQVTWAWB $.

    $( Product of group multiples, generalized to ` NN0 ` .  (Contributed by
       Mario Carneiro, 13-Dec-2014.) $)
    mulgnn0ass $p |- ( ( G e. Mnd /\ ( M e. NN0 /\ N e. NN0 /\ X e. B ) ) ->
      ( ( M x. N ) .x. X ) = ( M .x. ( N .x. X ) ) ) $=
      ( wcel cn0 wa cn cmul co wceq cc0 adantr mulg0 oveq1d oveq1 simpll simprl
      cmnd w3a simprr simpr3 mulgnnass syl13anc expr c0g cfv eqid simpr1 nn0cnd
      syl mul01d oveq2d 3ad2antr1 eqtrd 3eqtr4d oveq2 eqeq12d syl5ibrcom simpr2
      mulgnn0z wo elnn0 sylib mpjaod ex mul02d mulgnn0cl 3adant3r1 ) CUCIZDJIZE
      JIZFAIZUDZKZDLIZDEMNZFBNZDEFBNZBNZOZDPOZVSVTWEVSVTKZELIZWEEPOZVSVTWHWEVSV
      TWHKZKVNVTWHVQWEVNVRWJUAVSVTWHUBVSVTWHUEVSVQWJVNVOVPVQUFZQABCDEFGHUGUHUIW
      GWEWIDPMNZFBNZDPFBNZBNZOZVSWPVTVSWNCUJUKZWMWOVSVQWNWQOWKABCFWQGWQULZHRUOZ
      VSWLPFBVSDVSDVNVOVPVQUMZUNUPSVSWODWQBNZWQVSWNWQDBWSUQVNVPVOXAWQOVQABCDWQG
      HWRVEURUSUTQWIWBWMWDWOWIWAWLFBEPDMVASWIWCWNDBEPFBTUQVBVCVSWHWIVFZVTVSVPXB
      VNVOVPVQVDZEVGVHQVIVJVSWEWFPEMNZFBNZPWCBNZOVSWNWQXEXFWSVSXDPFBVSEVSEXCUNV
      KSVSWCAIZXFWQOVNVPVQXGVOABCEFGHVLVMABCWCWQGWRHRUOUTWFWBXEWDXFWFWAXDFBDPEM
      TSDPWCBTVBVCVSVOVTWFVFWTDVGVHVI $.

    $( Product of group multiples, generalized to ` ZZ ` .  (Contributed by
       Mario Carneiro, 13-Dec-2014.) $)
    mulgass $p |- ( ( G e. Grp /\ ( M e. ZZ /\ N e. ZZ /\ X e. B ) ) ->
      ( ( M x. N ) .x. X ) = ( M .x. ( N .x. X ) ) ) $=
      ( wcel cz wa cn0 cneg cmul co wceq ad2antrr adantr cfv syl3anc w3a simpr1
      cgrp wo cr elznn0 simprbi syl simpr2 cmnd grpmnd simprl simprr mulgnn0ass
      simplr3 syl13anc zcnd mulneg1d oveq1d simpr3 eqtr3d cminusg fveq2 zmulcld
      ex simpl eqid mulgneg fveq2d mulgcl grpinvinv syldan eqtrd eqeq12d syl5ib
      imp mulneg2d oveq2d mulgneg2 eqtr4d 3eqtr3d mul2negd nn0z ad2antll ccased
      negnegd mp2and ) CUCIZDJIZEJIZFAIZUAZKZDLIZDMZLIZUDZELIZEMZLIZUDZDENOZFBO
      ZDEFBOZBOZPZWMWIWQWHWIWJWKUBZWIDUEIWQDUFUGUHWMWJXAWHWIWJWKUIZWJEUEIXAEUFU
      GUHWMWNWRWPWTXFWMWNWRKZXFWMXIKCUJIZWNWRWKXFWHXJWLXICUKZQWMWNWRULWMWNWRUMW
      IWJWKWHXIUOABCDEFGHUNUPVEWMWPWRKZXFWMXLXBMZFBOZWOXDBOZPZXFWMXLKZWOENOZFBO
      ZXNXOXQXRXMFBWMXRXMPXLWMDEWMDXGUQZWMEXHUQZURRUSXQXJWPWRWKXSXOPWHXJWLXLXKQ
      WMWPWRULWMWPWRUMWMWKXLWHWIWJWKUTZRABCWOEFGHUNUPVAWMXPXFXPXNCVBSZSZXOYCSZP
      WMXFXNXOYCVCWMYDXCYEXEWMYDXCYCSZYCSZXCWMXNYFYCWMWHXBJIZWKXNYFPWHWLVFZWMDE
      XGXHVDZYBABCYCXBFGHYCVGZVHTVIWHWLXCAIZYGXCPWMWHYHWKYLYIYJYBABCXBFGHVJTACY
      CXCGYKVKVLVMWMYEXEYCSZYCSZXEWMXOYMYCWMWHWIXDAIZXOYMPYIXGWMWHWJWKYOYIXHYBA
      BCEFGHVJTZABCYCDXDGHYKVHTVIWHWLXEAIZYNXEPWMWHWIYOYQYIXGYPABCDXDGHVJTACYCX
      EGYKVKVLVMVNVOVPZVLVEWMWNWTKZXFWMYSXPXFWMYSKZDWSNOZFBOZDWSFBOZBOZXNXOYTXJ
      WNWTWKUUBUUDPWHXJWLYSXKQWMWNWTULWMWNWTUMWMWKYSYBRABCDWSFGHUNUPYTUUAXMFBWM
      UUAXMPYSWMDEXTYAVQRUSWMUUDXOPYSWMUUDDXDYCSZBOZXOWMUUCUUEDBWMWHWJWKUUCUUEP
      YIXHYBABCYCEFGHYKVHTVRWMWHWIYOXOUUFPYIXGYPABCYCDXDGHYKVSTVTRWAYRVLVEWMWPW
      TKZXFWMUUGKZWOWSNOZFBOZWOUUCBOZXCXEUUHXJWPWTWKUUJUUKPWHXJWLUUGXKQWMWPWTUL
      WMWPWTUMWMWKUUGYBRZABCWOWSFGHUNUPWMUUJXCPUUGWMUUIXBFBWMDEXTYAWBUSRUUHUUKD
      UUCYCSZBOZXEUUHWHWIUUCAIZUUKUUNPWMWHUUGYIRZWMWIUUGXGRUUHWHWSJIZWKUUOUUPWT
      UUQWMWPWSWCWDZUULABCWSFGHVJTABCYCDUUCGHYKVSTUUHUUMXDDBUUHWSMZFBOZUUMXDUUH
      WHUUQWKUUTUUMPUUPUURUULABCYCWSFGHYKVHTUUHUUSEFBWMUUSEPUUGWMEYAWFRUSVAVRVM
      WAVEWEWG $.
  $}

  ${
    mulgsubdir.b $e |- B = ( Base ` G ) $.
    mulgsubdir.t $e |- .x. = ( .g ` G ) $.
    mulgsubdir.d $e |- .- = ( -g ` G ) $.
    $( Subtraction of a group element from itself.  (Contributed by Mario
       Carneiro, 13-Dec-2014.) $)
    mulgsubdir $p |- ( ( G e. Grp /\ ( M e. ZZ /\ N e. ZZ /\ X e. B ) ) ->
      ( ( M - N ) .x. X ) = ( ( M .x. X ) .- ( N .x. X ) ) ) $=
      ( cgrp wcel cz co cfv wceq eqid zcnd 3adant3r1 mulgcl w3a wa caddc cplusg
      cneg znegcl mulgdir syl3anr2 simpr1 simpr2 negsubd oveq1d cminusg mulgneg
      cmin oveq2d 3adant3r2 grpsubval syl2anc eqtr4d 3eqtr3d ) CKLZDMLZFMLZGALZ
      UAUBZDFUEZUCNZGBNZDGBNZVGGBNZCUDOZNZDFUONZGBNVJFGBNZENZVDVCVBVGMLVEVIVMPF
      UFAVLBCDVGGHIVLQZUGUHVFVHVNGBVFDFVFDVBVCVDVEUIRVFFVBVCVDVEUJRUKULVFVMVJVO
      CUMOZOZVLNZVPVFVKVSVJVLVBVDVEVKVSPVCABCVRFGHIVRQZUNSUPVFVJALZVOALZVPVTPVB
      VCVEWBVDABCDGHITUQVBVDVEWCVCABCFGHITSAVLCVREVJVOHVQWAJURUSUTVA $.
  $}

  ${
    $d m n B $.  $d m n F $.  $d m n G $.  $d m n H $.  $d n N $.  $d m n X $.
    $d m n .x. $.  $d m n .X. $.
    mhmmulg.b $e |- B = ( Base ` G ) $.
    mhmmulg.s $e |- .x. = ( .g ` G ) $.
    mhmmulg.t $e |- .X. = ( .g ` H ) $.
    $( A homomorphism of monoids preserves group multiples.  (Contributed by
       Mario Carneiro, 14-Jun-2015.) $)
    mhmmulg $p |- ( ( F e. ( G MndHom H ) /\ N e. NN0 /\ X e. B ) ->
        ( F ` ( N .x. X ) ) = ( N .X. ( F ` X ) ) ) $=
      ( wcel co cfv wceq wi cc0 oveq1 fveq2d eqeq12d vn vm cn0 cmhm wa cv caddc
      c1 imbi2d c0g eqid mhm0 adantr mulg0 adantl cbs mhmf ffvelrnda syl cplusg
      3eqtr4d cmnd mhmrcl1 ad2antrr simpr simplr mulgnn0p1 syl3anc simpll an32s
      mulgnn0cl mhmlin eqtrd mhmrcl2 syl5ibr expcom a2d nn0ind 3impib 3com12 )
      GUCLZDEFUDMLZHALZGHBMZDNZGHDNZCMZOZWAWBWCWHWBWCUEZUAUFZHBMZDNZWJWFCMZOZPW
      IQHBMZDNZQWFCMZOZPWIUBUFZHBMZDNZWSWFCMZOZPWIWSUHUGMZHBMZDNZXDWFCMZOZPWIWH
      PUAUBGWJQOZWNWRWIXIWLWPWMWQXIWKWODWJQHBRSWJQWFCRTUIWJWSOZWNXCWIXJWLXAWMXB
      XJWKWTDWJWSHBRSWJWSWFCRTUIWJXDOZWNXHWIXKWLXFWMXGXKWKXEDWJXDHBRSWJXDWFCRTU
      IWJGOZWNWHWIXLWLWEWMWGXLWKWDDWJGHBRSWJGWFCRTUIWIEUJNZDNZFUJNZWPWQWBXNXOOW
      CEFDXOXMXMUKZXOUKZULUMWIWOXMDWCWOXMOWBABEHXMIXPJUNUOSWIWFFUPNZLZWQXOOWBAX
      RHDAXREFDIXRUKZUQURZXRCFWFXOXTXQKUNUSVAWSUCLZWIXCXHWIYBXCXHPXCXHWIYBUEZXA
      WFFUTNZMZXBWFYDMZOXAXBWFYDRYCXFYEXGYFYCXFWTHEUTNZMZDNZYEYCXEYHDYCEVBLZYBW
      CXEYHOWBYJWCYBEFDVCZVDWIYBVEZWBWCYBVFZAYGBEWSHIJYGUKZVGVHSYCWBWTALZWCYIYE
      OWBWCYBVIWBYBWCYOWBYBUEZWCUEYJYBWCYOWBYJYBWCYKVDWBYBWCVFYPWCVEABEWSHIJVKV
      HVJYMAYGYDEFDWTHIYNYDUKZVLVHVMYCFVBLZYBXSXGYFOWBYRWCYBEFDVNVDYLWIXSYBYAUM
      XRYDCFWSWFXTKYQVGVHTVOVPVQVRVSVT $.
  $}

  ${
    $d ph a b x y $.  $d B x y $.  $d G a b x y $.  $d H a b x y $.
    $d K x y $.
    mulgpropd.m $e |- .x. = ( .g ` G ) $.
    mulgpropd.n $e |- .X. = ( .g ` H ) $.
    mulgpropd.b1 $e |- ( ph -> B = ( Base ` G ) ) $.
    mulgpropd.b2 $e |- ( ph -> B = ( Base ` H ) ) $.
    mulgpropd.i $e |- ( ph -> B C_ K ) $.
    mulgpropd.k $e |- ( ( ph /\ ( x e. K /\ y e. K ) ) ->
        ( x ( +g ` G ) y ) e. K ) $.
    mulgpropd.e $e |- ( ( ph /\ ( x e. K /\ y e. K ) ) ->
        ( x ( +g ` G ) y ) = ( x ( +g ` H ) y ) ) $.
    $( Two structures with the same group-nature have the same group multiple
       function. ` K ` is expected to either be ` _V ` (when strong equality is
       available) or ` B ` (when closure is available).  (Contributed by Stefan
       O'Rear, 21-Mar-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    mulgpropd $p |- ( ph -> .x. = .X. ) $=
      ( va vb cz cfv cbs cv cc0 wceq c0g clt wbr cplusg cn csn cxp c1 cseq cneg
      cminusg cif cmpt2 wcel w3a wa co wss wi anim12d syl imp syldan grpidpropd
      ssel 3ad2ant1 a1i cuz vex fvconst2 nnuz eqcomi eleq2s adantl simp3 sseldd
      1z adantr eqeltrd 3ad2antl1 seqfeq3 fveq1d grpinvpropd fveq12d mpt2eq3dva
      ifeq12d eqidd mpt2eq123dv 3eqtr3d eqid mulgfval 3eqtr4g ) AQRSGUATZQUBZUC
      UDZGUETZUCWRUFUGZWRGUHTZUIRUBZUJUKZULUMZTZWRUNZXETZGUOTZTZUPZUPZUQZQRSHUA
      TZWSHUETZXAWRHUHTZXDULUMZTZXGXQTZHUOTZTZUPZUPZUQZEFAQRSDXLUQQRSDYCUQXMYDA
      QRSDXLYCAWRSURZXCDURZUSZWSWTXOXKYBAYEWTXOUDYFABCDGHLMABUBZDURZCUBZDURZUTZ
      YHIURZYJIURZUTZYHYJXBVAZYHYJXPVAUDZAYLYOADIVBZYLYOVCNYRYIYMYKYNDIYHVIDIYJ
      VIVDVEVFPVGZVHVJYGXAXFXRXJYAYGWRXEXQYGBCXBXPIXDULULSURYGWAVKYGYHULVLTZURZ
      UTYHXDTZXCIUUAUUBXCUDZYGUUCYHUIYTUIXCYHRVMVNUIYTVOVPVQVRYGXCIURUUAYGDIXCA
      YEYRYFNVJAYEYFVSVTWBWCAYEYOYPIURYFOWDAYEYOYQYFPWDWEZWFYGXHXSXIXTAYEXIXTUD
      YFABCDGHLMYSWGVJYGXGXEXQUUDWFWHWJWJWIAQRSDXLSWQXLASWKZLAXLWKWLAQRSDYCSXNY
      CUUEMAYCWKWLWMRWQXBEQGXIWTWQWNXBWNWTWNXIWNJWORXNXPFQHXTXOXNWNXPWNXOWNXTWN
      KWOWP $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y S $.  $d x .xb $.  $d x y X $.
    submmulgcl.t $e |- .xb = ( .g ` G ) $.
    $( Closure of the group multiple (exponentiation) operation in a
       submonoid.  (Contributed by Mario Carneiro, 13-Jan-2015.) $)
    submmulgcl $p |- ( ( S e. ( SubMnd ` G ) /\ N e. NN0 /\ X e. S ) ->
      ( N .xb X ) e. S ) $=
      ( vx vy csubmnd cfv wcel cbs cplusg cmnd c0g eqid submrcl submss submcl
      cv subm0cl mulgnn0subcl ) ACIJKGHCLJZCMJZABCDNECOJZUCPZFUDPZACQUCACUFRUDA
      CGTHTUGSUEPZACUEUHUAUB $.

    submmulg.h $e |- H = ( G |`s S ) $.
    submmulg.t $e |- .x. = ( .g ` H ) $.
    $( A group multiple is the same if evaluated in a submonoid.  (Contributed
       by Mario Carneiro, 15-Jun-2015.) $)
    submmulg $p |- ( ( S e. ( SubMnd ` G ) /\ N e. NN0 /\ X e. S ) ->
      ( N .xb X ) = ( N .x. X ) ) $=
      ( cfv wcel co wceq cc0 c1 eqid syl adantr 3eqtr4d csubmnd cn0 w3a csn cxp
      cn wa cplusg cseq simpl1 ressplusg seqeq2d fveq1d cbs wss submss 3ad2ant1
      simpr simp3 sseldd mulgnn syl2anc submbas c0g subm0 mulg0 oveq1d wo simp2
      eleqtrd elnn0 sylib mpjaodan ) ADUAKZLZFUBLZGALZUCZFUFLZFGBMZFGCMZNFONZVR
      VSUGZFDUHKZUFGUDUEZPUIZKZFEUHKZWEPUIZKZVTWAWCFWFWIWCWDWHWEPWCVOWDWHNVOVPV
      QVSUJAWDDEVNIWDQZUKRULUMWCVSGDUNKZLZVTWGNVRVSURZVRWMVSVRAWLGVOVPAWLUOVQWL
      ADWLQZUPUQVOVPVQUSZUTZSWLWDWFBDFGWOWKHWFQVAVBWCVSGEUNKZLZWAWJNWNVRWSVSVRG
      AWRWPVOVPAWRNVQAEDIVCUQVJZSWRWHWICEFGWRQZWHQJWIQVAVBTVRWBUGZOGBMZOGCMZVTW
      AXBDVDKZEVDKZXCXDXBVOXEXFNVOVPVQWBUJAEDXEIXEQZVERXBWMXCXENVRWMWBWQSWLBDGX
      EWOXGHVFRXBWSXDXFNVRWSWBWTSWRCEGXFXAXFQJVFRTXBFOGBVRWBURZVGXBFOGCXHVGTVRV
      PVSWBVHVOVPVQVIFVKVLVM $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y I $.  $d x N $.  $d x y ph $.  $d x y R $.
    $d x .+ $.  $d x y S $.  $d x y V $.  $d x y W $.  $d x y Y $.  $d x .0. $.
    prdsinvlem.y $e |- Y = ( S Xs_ R ) $.
    prdsinvlem.b $e |- B = ( Base ` Y ) $.
    prdsinvlem.p $e |- .+ = ( +g ` Y ) $.
    prdsinvlem.s $e |- ( ph -> S e. V ) $.
    prdsinvlem.i $e |- ( ph -> I e. W ) $.
    prdsinvlem.r $e |- ( ph -> R : I --> Grp ) $.
    prdsinvlem.f $e |- ( ph -> F e. B ) $.
    prdsinvlem.z $e |- .0. = ( 0g o. R ) $.
    prdsinvlem.n $e |- N = ( y e. I |->
        ( ( invg ` ( R ` y ) ) ` ( F ` y ) ) ) $.
    $( Characterization of inverses in a structure product.  (Contributed by
       Mario Carneiro, 10-Jan-2015.) $)
    prdsinvlem $p |- ( ph -> ( N e. B /\ ( N .+ F ) = .0. ) ) $=
      ( vx wcel co wceq cv cfv cminusg cmpt cbs wral wa ffvelrnda adantr wfn wf
      cgrp ffn syl prdsbasprj eqid grpinvcl syl2anc ralrimiva prdsbasmpt mpbird
      simpr syl5eqel cplusg c0g grplinv fveq2 fveq2d fveq12d fvex adantl oveq1d
      weq fvmpt ccom fveq1i fvco2 syl5eq 3eqtr4d mpteq2dva prdsplusgval cvv crn
      sylan wss fn0g a1i ssv fnco syl3anc fneq1i sylibr dffn5 sylib jca ) AICUD
      IGDUEZMUFAIBHBUGZGUHZXCEUHZUIUHZUHZUJZCUBAXHCUDXGXEUKUHZUDZBHULAXJBHAXCHU
      DZUMZXEURUDXDXIUDXJAHURXCESUNXLCEFGHXCJKLNOAFJUDZXKQUOAHKUDZXKRUOAEHUPZXK
      AHUREUQXOSHUREUSUTZUOAGCUDZXKTUOAXKVHVAXIXEXFXDXIVBXFVBVCVDVEABCEFXGHJKLN
      OQRXPVFVGVIZAUCHUCUGZIUHZXSGUHZXSEUHZVJUHZUEZUJUCHXSMUHZUJZXBMAUCHYDYEAXS
      HUDZUMZYAYBUIUHZUHZYAYCUEZYBVKUHZYDYEYHYBURUDYAYBUKUHZUDYKYLUFAHURXSESUNY
      HCEFGHXSJKLNOAXMYGQUOAXNYGRUOAXOYGXPUOAXQYGTUOAYGVHVAYMYCYBYIYAYLYMVBYCVB
      YLVBYIVBVLVDYHXTYJYAYCYGXTYJUFABXSXGYJHIBUCVSZXDYAXFYIYNXEYBUIXCXSEVMVNXC
      XSGVMVOUBYAYIVPVTVQVRYHYEXSVKEWAZUHZYLXSMYOUAWBAXOYGYPYLUFXPHVKEXSWCWJWDW
      EWFAUCCDEFIGHJKLNOQRXPXRTPWGAMHUPZMYFUFAYOHUPZYQAVKWHUPZXOEWIZWHWKZYRYSAW
      LWMXPUUAAYTWNWMWHHVKEWOWPHMYOUAWQWRUCHMWSWTWEXA $.
  $}

  ${
    $d x B $.  $d b x I $.  $d a b x ph $.  $d b x R $.  $d b x S $.  $d x X $.
    $d a b x Y $.
    prdsgrpd.y $e |- Y = ( S Xs_ R ) $.
    prdsgrpd.i $e |- ( ph -> I e. W ) $.
    prdsgrpd.s $e |- ( ph -> S e. V ) $.
    prdsgrpd.r $e |- ( ph -> R : I --> Grp ) $.
    $( The product of a family of groups is a group.  (Contributed by Stefan
       O'Rear, 10-Jan-2015.) $)
    prdsgrpd $p |- ( ph -> Y e. Grp ) $=
      ( va vb cfv cgrp cmnd wcel cvv eqid adantr cbs cplusg cv cminusg cmpt c0g
      ccom eqidd wf wss grpmnd ssriv fss sylancl prds0g prdsmndd wa co wceq syl
      elex simpr prdsinvlem simpld simprd isgrpd2 ) ALGUANZGUBNZGMDMUCZLUCZNVIB
      NUDNNUEZUFBUGZAVGUHAVHUHABCDEFGHIJADOBUIZOPUJDPBUIKLOPVJUKULDOPBUMUNZUOAB
      CDEFGHIJVNUPAVJVGQZUQZVKVGQZVKVJVHURVLUSZVPMVGVHBCVJDVKRRGVLHVGSVHSACRQZV
      OACEQVSJCEVAUTTADRQZVOADFQVTIDFVAUTTAVMVOKTAVOVBVLSVKSVCZVDVPVQVRWAVEVF
      $.

    prdsinvgd.b $e |- B = ( Base ` Y ) $.
    prdsinvgd.n $e |- N = ( invg ` Y ) $.
    prdsinvgd.x $e |- ( ph -> X e. B ) $.
    $( Negation in a product of groups.  (Contributed by Stefan O'Rear,
       10-Jan-2015.) $)
    prdsinvgd $p |- ( ph -> ( N ` X ) = ( x e. I |->
        ( ( invg ` ( R ` x ) ) ` ( X ` x ) ) ) ) $=
      ( cfv wcel va cv cminusg cmpt wceq cplusg co c0g ccom cvv eqid prdsinvlem
      elex syl simprd cgrp wf cmnd wss grpmnd ssriv fss sylancl prds0g eqtrd wb
      prdsgrpd simpld grpinvid2 syl3anc mpbird ) AJGSBFBUBZJSVLDSUCSSUDZUEZVMJK
      UFSZUGZKUHSZUEZAVPUHDUIZVQAVMCTZVPVSUEZABCVODEJFVMUJUJKVSLPVOUKZAEHTEUJTN
      EHUMUNAFITFUJTMFIUMUNORVSUKVMUKULZUOADEFHIKLMNAFUPDUQUPURUSFURDUQOUAUPURU
      AUBUTVAFUPURDVBVCVDVEAKUPTJCTVTVNVRVFADEFHIKLMNOVGRAVTWAWCVHCVOKGJVMVQPWB
      VQUKQVIVJVK $.
  $}

  ${
    $d x A $.  $d x y G $.  $d x y M $.  $d x y R $.  $d x y X $.  $d x .xb $.
    $d x B $.  $d x F $.  $d x I $.  $d x N $.  $d x V $.
    pwsgrp.y $e |- Y = ( R ^s I ) $.
    $( The product of a family of groups is a group.  (Contributed by Mario
       Carneiro, 11-Jan-2015.) $)
    pwsgrp $p |- ( ( R e. Grp /\ I e. V ) -> Y e. Grp ) $=
      ( cgrp wcel wa csca cfv csn cxp cprds co eqid pwsval cvv simpr fvex a1i
      wf fconst6g adantr prdsgrpd eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUIO
      PUHUJUIBQCUKUKOUFUGRUIQGUHAISTUFBFUJUAUGBAFUBUCUDUE $.

    pwsinvg.b $e |- B = ( Base ` Y ) $.
    ${
      pwsinvg.m $e |- M = ( invg ` R ) $.
      pwsinvg.n $e |- N = ( invg ` Y ) $.
      $( Negation in a group power.  (Contributed by Mario Carneiro,
         11-Jan-2015.) $)
      pwsinvg $p |- ( ( R e. Grp /\ I e. V /\ X e. B ) ->
        ( N ` X ) = ( M o. X ) ) $=
        ( vx vy cgrp wcel cfv cminusg cbs eqid w3a csca csn cxp cprds cmpt ccom
        co cv cvv simp2 fvex a1i wf simp1 fconst6g syl simp3 wceq pwsval fveq2d
        3adant3 syl5eq eleqtrd prdsinvgd fvconst2g sylan fveq1d mpteq2dva eqtrd
        wa syl6eqr pwselbas ffvelrnda feqmptd grpinvf fveq2 fmptco 3eqtr4d ) BO
        PZCFPZGAPZUAZGBUBQZCBUCUDZUEUHZRQZQZMCMUIZGQZDQZUFZGEQDGUGWCWHMCWJWIWEQ
        ZRQZQZUFWLWCMWFSQZWEWDCWGUJFGWFWFTVTWAWBUKZWDUJPWCBUBULUMWCVTCOWEUNVTWA
        WBUOZCBOUPUQWPTWGTWCGAWPVTWAWBURZWCAHSQWPJWCHWFSVTWAHWFUSWBBWDCOFHIWDTU
        TVBZVAVCVDVEWCMCWOWKWCWICPZVKZWJWNDXBWNBRQDXBWMBRWCVTXAWMBUSWRCBWIOVFVG
        VAKVLVHVIVJWCGEWGWCEHRQWGLWCHWFRWTVAVCVHWCMNCBSQZWJNUIZDQWKGDWCCXCWIGWC
        XCBCAOGHFIXCTZJWRWQWSVMZVNWCMCXCGXFVOWCNXCXCDWCVTXCXCDUNWRXCBDXEKVPUQVO
        XDWJDVQVRVS $.
    $}

    ${
      pwssub.m $e |- M = ( -g ` R ) $.
      pwssub.n $e |- .- = ( -g ` Y ) $.
      $( Subtraction in a group power.  (Contributed by Mario Carneiro,
         12-Jan-2015.) $)
      pwssub $p |- ( ( ( R e. Grp /\ I e. V ) /\ ( F e. B /\ G e. B ) ) ->
        ( F .- G ) = ( F oF M G ) ) $=
        ( vx cgrp wcel wa cfv co eqid vy cminusg cplusg cmpt cof cbs cvv simplr
        simpll simprl pwselbas ffvelrnda fvex feqmptd ccom wceq pwsinvg syl3anc
        cv a1i simprr grpinvf ad2antrr fveq2 fmptco eqtrd offval2 pwsgrp adantr
        wf grpinvcl syl2anc pwsplusgval grpsubval mpteq2dva 3eqtr4d adantl ) BO
        PZEHPZQZCAPZDAPZQZQZCDIUBRZRZIUCRZSZNENUSZCRZWIDRZFSZUDZCDGSZCDFUESWDCW
        FBUCRZUESNEWJWKBUBRZRZWOSZUDWHWMWDNEWJWQWOCWFHBUFRZUGVRVSWCUHZWDEWSWICW
        DWSBEAOCIHJWSTZKVRVSWCUIZWTVTWAWBUJZUKZULZWQUGPWDWIEPQZWKWPUMUTWDNEWSCX
        DUNZWDWFWPDUOZNEWQUDWDVRVSWBWFXHUPXBWTVTWAWBVAZABEWPWEHDIJKWPTZWETZUQUR
        WDNUAEWSWKUAUSZWPRWQDWPWDEWSWIDWDWSBEAODIHJXAKXBWTXIUKZULZWDNEWSDXMUNZW
        DUAWSWSWPVRWSWSWPVJVSWCWSBWPXAXJVBVCUNXLWKWPVDVEVFVGWDAWOWGBCWFEOHIJKXB
        WTXCWDIOPZWBWFAPVTXPWCBEHIJVHVIXIAIWEDKXKVKVLWOTZWGTZVMWDNEWLWRXFWJWSPW
        KWSPWLWRUPXEXNWSWOBWPFWJWKXAXQXJLVNVLVOVPWCWNWHUPVTAWGIWEGCDKXRXKMVNVQW
        DNEWJWKFCDHWSWSWTXEXNXGXOVGVP $.
    $}

    pwsmulg.s $e |- .xb = ( .g ` Y ) $.
    pwsmulg.t $e |- .x. = ( .g ` R ) $.
    $( Value of a group multiple in a structure power.  (Contributed by Mario
       Carneiro, 15-Jun-2015.) $)
    pwsmulg $p |- ( ( ( R e. Mnd /\ I e. V ) /\
      ( N e. NN0 /\ X e. B /\ A e. I ) ) ->
        ( ( N .xb X ) ` A ) = ( N .x. ( X ` A ) ) ) $=
      ( vx wcel co cfv wceq syl3anc cmnd cn0 w3a cmpt cmhm simpll simplr simpr3
      wa pwspjmhm simpr1 simpr2 mhmmulg pwsmnd adantr mulgnn0cl fveq1 eqid fvex
      cv fvmpt syl oveq2d 3eqtr3d ) CUAPZFHPZUIZGUBPZIBPZAFPZUCZUIZGIDQZOBAOUTZ
      RZUDZRZGIVPRZEQZAVMRZGAIRZEQVLVPJCUEQPZVHVIVQVSSVLVEVFVJWBVEVFVKUFVEVFVKU
      GVGVHVIVJUHOABCFHJKLUJTVGVHVIVJUKZVGVHVIVJULZBDEVPJCGILMNUMTVLVMBPZVQVTSV
      LJUAPZVHVIWEVGWFVKCFHJKUNUOWCWDBDJGILMUPTOVMVOVTBVPAVNVMUQVPURZAVMUSVAVBV
      LVRWAGEVLVIVRWASWDOIVOWABVPAVNIUQWGAIUSVAVBVCVD $.
  $}

  ${
    $d p q u v w x B $.  $d p v N $.  $d a b p q u v w x y z ph $.  $d p q R $.
    $d a b p q u v w x y z F $.  $d p q x y .+ $.  $d a b p q u v w x y z U $.
    $d a b p q x y z V $.  $d p q u v w x .0. $.
    imasgrp.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasgrp.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasgrp.p $e |- ( ph -> .+ = ( +g ` R ) ) $.
    imasgrp.f $e |- ( ph -> F : V -onto-> B ) $.
    imasgrp.e $e |- ( ( ph /\ ( a e. V /\ b e. V ) /\ ( p e. V /\ q e. V ) )
      -> ( ( ( F ` a ) = ( F ` p ) /\ ( F ` b ) = ( F ` q ) )
        -> ( F ` ( a .+ b ) ) = ( F ` ( p .+ q ) ) ) ) $.
    ${
      imasgrp2.r $e |- ( ph -> R e. W ) $.
      imasgrp2.1 $e |- ( ( ph /\ x e. V /\ y e. V ) -> ( x .+ y ) e. V ) $.
      imasgrp2.2 $e |- ( ( ph /\ ( x e. V /\ y e. V /\ z e. V ) ) ->
        ( F ` ( ( x .+ y ) .+ z ) ) = ( F ` ( x .+ ( y .+ z ) ) ) ) $.
      imasgrp2.3 $e |- ( ph -> .0. e. V ) $.
      imasgrp2.4 $e |- ( ( ph /\ x e. V ) ->
        ( F ` ( .0. .+ x ) ) = ( F ` x ) ) $.
      imasgrp2.5 $e |- ( ( ph /\ x e. V ) -> N e. V ) $.
      imasgrp2.6 $e |- ( ( ph /\ x e. V ) ->
        ( F ` ( N .+ x ) ) = ( F ` .0. ) ) $.
      $( The image structure of a group is a group.  (Contributed by Mario
         Carneiro, 24-Feb-2015.)  (Revised by Mario Carneiro, 5-Sep-2015.) $)
      imasgrp2 $p |- ( ph -> ( U e. Grp /\ ( F ` .0. ) = ( 0g ` U ) ) ) $=
        ( vu vv vw cgrp wcel cfv c0g wceq cplusg imasbas eqidd cxp wf cv co w3a
        wa wb oveqd fveq2d eqeq12d 3ad2ant1 sylibd eqid adantr caovclg eqeltrrd
        3expb imasaddf fovrn syl3an1 wrex crn wfo forn syl eleq2d 3anbi123d wfn
        fofn fvelrnb bitr3d 3reeanv syl6bbr 3eqtr3d 3adant3r3 simpr3 imasaddval
        wi simpl syl3anc simpr1 3adantr1 3eqtr4d eqtr4d oveq1d 3adant3r1 oveq2d
        simp1 simp2 oveq12d simp3 syl5ibcom 3exp2 imp32 rexlimdv rexlimdvva imp
        sylbid fof ffvelrnd simpr 3eqtr2d oveq2 rexlimdva eqeq1d rspcev syl2anc
        id oveq1 rexbidv isgrpde grpidd2 jca ) AHUMUNMIUOZHUPUOUQAUJUKULEHURUOZ
        HYNAEGHIKLRSUAUCUSZAYOUTZAEEVAEYOVBUJVCZEUNZUKVCZEUNZYRYTYOVDZEUNAEGYOG
        URUOZHIKLNOPQUAAPVCZKUNQVCZKUNVFZOVCZKUNNVCZKUNVFZVEUUDIUOUUGIUOUQUUEIU
        OUUHIUOUQVFUUDUUEFVDZIUOZUUGUUHFVDZIUOZUQZUUDUUEUUCVDZIUOZUUGUUHUUCVDZI
        UOZUQZUBAUUFUUNUUSVGUUIAUUKUUPUUMUURAUUJUUOIAFUUCUUDUUETVHVIAUULUUQIAFU
        UCUUGUUHTVHZVIVJVKVLZRSUCUUCVMZYOVMZAUUIVFUULUUQKAUULUUQUQUUIUUTVNABCUU
        GUUHKKKFABVCZKUNZCVCZKUNZUVDUVFFVDZKUNZUDVQVOZVPVRYRYTEEEYOVSVTAYSUUAUL
        VCZEUNZVEZUUBUVKYOVDZYRYTUVKYOVDZYOVDZUQZAUVMUVDIUOZYRUQZUVFIUOZYTUQZDV
        CZIUOZUVKUQZVEZDKWAZCKWABKWAZUVQAUVMUVSBKWAZUWACKWAZUWDDKWAZVEZUWGAYRIW
        BZUNZYTUWLUNZUVKUWLUNZVEZUVMUWKAUWMYSUWNUUAUWOUVLAUWLEYRAKEIWCZUWLEUQUA
        KEIWDWEZWFZAUWLEYTUWRWFAUWLEUVKUWRWFWGAIKWHZUWPUWKVGAUWQUWTUAKEIWIWEZUW
        TUWMUWHUWNUWIUWOUWJBKYRIWJZCKYTIWJDKUVKIWJWGWEWKUVSUWAUWDBCDKKKWLWMAUWF
        UVQBCKKAUVEUVGVFVFUWEUVQDKAUVEUVGUWBKUNZUWEUVQWRZWRAUVEUVGUXCUXDAUVEUVG
        UXCVEZVFZUVRUVTYOVDZUWCYOVDZUVRUVTUWCYOVDZYOVDZUQUWEUVQUXFUVHIUOZUWCYOV
        DZUVRUVFUWBFVDZIUOZYOVDZUXHUXJUXFUVHUWBUUCVDZIUOZUVDUXMUUCVDZIUOZUXLUXO
        UXFUVHUWBFVDZIUOUVDUXMFVDZIUOUXQUXSUEUXFUXTUXPIUXFFUUCUVHUWBAFUUCUQZUXE
        TVNZVHVIUXFUYAUXRIUXFFUUCUVDUXMUYCVHVIWNUXFAUVIUXCUXLUXQUQAUXEWSZAUVEUV
        GUVIUXCUDWOAUVEUVGUXCWPAEGYOUUCHIKUVHUWBLNOPQUAUVARSUCUVBUVCWQWTUXFAUVE
        UXMKUNZUXOUXSUQUYDAUVEUVGUXCXAAUVGUXCUYEUVEAONUVFUWBKKKFUVJVOXBAEGYOUUC
        HIKUVDUXMLNOPQUAUVARSUCUVBUVCWQWTXCUXFUXGUXKUWCYOUXFUXGUVDUVFUUCVDZIUOZ
        UXKAUVEUVGUXGUYGUQUXCAEGYOUUCHIKUVDUVFLNOPQUAUVARSUCUVBUVCWQWOUXFUVHUYF
        IUXFFUUCUVDUVFUYCVHVIXDXEUXFUXIUXNUVRYOUXFUXIUVFUWBUUCVDZIUOZUXNAUVGUXC
        UXIUYIUQUVEAEGYOUUCHIKUVFUWBLNOPQUAUVARSUCUVBUVCWQXFUXFUXMUYHIUXFFUUCUV
        FUWBUYCVHVIXDXGXCUWEUXHUVNUXJUVPUWEUXGUUBUWCUVKYOUWEUVRYRUVTYTYOUVSUWAU
        WDXHZUVSUWAUWDXIZXJUVSUWAUWDXKZXJUWEUVRYRUXIUVOYOUYJUWEUVTYTUWCUVKYOUYK
        UYLXJXJVJXLXMXNXOXPXRXQAKEMIAUWQKEIVBZUAKEIXSWEZUFXTZAYSYNYRYOVDZYRUQZA
        YSUWHUYQAUWMYSUWHUWSAUWTUWMUWHVGUXAUXBWEWKZAUVSUYQBKAUVEVFZYNUVRYOVDZUV
        RUQUVSUYQUYSUYTMUVDUUCVDZIUOZMUVDFVDZIUOUVRUYSAMKUNZUVEUYTVUBUQAUVEWSZA
        VUDUVEUFVNAUVEYAZAEGYOUUCHIKMUVDLNOPQUAUVARSUCUVBUVCWQWTUYSVUCVUAIUYSFU
        UCMUVDAUYBUVETVNZVHVIUGYBUVSUYTUYPUVRYRUVRYRYNYOYCUVSYHVJXLYDXRXQZAYSYT
        YRYOVDZYNUQZUKEWAZAYSUWHVUKUYRAUVSVUKBKUYSYTUVRYOVDZYNUQZUKEWAZUVSVUKUY
        SJIUOZEUNVUOUVRYOVDZYNUQZVUNUYSKEJIAUYMUVEUYNVNUHXTUYSVUPJUVDUUCVDZIUOZ
        JUVDFVDZIUOYNUYSAJKUNUVEVUPVUSUQVUEUHVUFAEGYOUUCHIKJUVDLNOPQUAUVARSUCUV
        BUVCWQWTUYSVUTVURIUYSFUUCJUVDVUGVHVIUIYBVUMVUQUKVUOEYTVUOUQVULVUPYNYTVU
        OUVRYOYIYEYFYGUVSVUMVUJUKEUVSVULVUIYNUVRYRYTYOYCYEYJXLYDXRXQYKZAUJEYOHY
        NYPYQUYOVUHVVAYLYM $.
    $}

    ${
      imasgrp.r $e |- ( ph -> R e. Grp ) $.
      imasgrp.z $e |- .0. = ( 0g ` R ) $.
      $( The image structure of a group is a group.  (Contributed by Mario
         Carneiro, 24-Feb-2015.)  (Revised by Mario Carneiro, 5-Sep-2015.) $)
      imasgrp $p |- ( ph -> ( U e. Grp /\ ( F ` .0. ) = ( 0g ` U ) ) ) $=
        ( co vx vy vz cv cminusg cfv cgrp w3a cplusg cbs 3ad2ant1 simp2 eleqtrd
        wcel wceq simp3 eqid grpcl syl3anc oveqd adantr 3adant3r3 simpr3 grpass
        3eltr4d wa syl13anc oveq123d 3eqtr4d fveq2d grpidcl syl eleqtrrd eleq2d
        eqidd biimpa grplid syl2anc eqtrd grpinvcl grplinv imasgrp2 ) AUAUBUCBC
        DEFUAUDZDUEUFZUFZGUGHIJKLMNOPQRAWCGUNZUBUDZGUNZUHZWCWGDUIUFZTZDUJUFZWCW
        GCTZGWIDUGUNZWCWLUNZWGWLUNZWKWLUNAWFWNWHRUKWIWCGWLAWFWHULAWFGWLUOZWHNUK
        ZUMZWIWGGWLAWFWHUPWRUMZWLWJDWCWGWLUQZWJUQZURUSWICWJWCWGAWFCWJUOZWHOUKUT
        ZWRVEAWFWHUCUDZGUNZUHZVFZWMXECTZWCWGXECTZCTZFXHWKXEWJTZWCWGXEWJTZWJTZXI
        XKXHWNWOWPXEWLUNXLXNUOAWNXGRVAAWFWHWOXFWSVBAWFWHWPXFWTVBXHXEGWLAWFWHXFV
        CAWQXGNVAUMWLWJDWCWGXEXAXBVDVGXHWMWKXEXECWJAXCXGOVAZAWFWHWMWKUOXFXDVBXH
        XEVOVHXHWCWCXJXMCWJXOXHWCVOXHCWJWGXEXOUTVHVIVJAHWLGAWNHWLUNRWLDHXASVKVL
        NVMAWFVFZHWCCTZWCFXPXQHWCWJTZWCXPCWJHWCAXCWFOVAZUTXPWNWOXRWCUOAWNWFRVAZ
        AWFWOAGWLWCNVNVPZWLWJDWCHXAXBSVQVRVSVJXPWEWLGXPWNWOWEWLUNXTYAWLDWDWCXAW
        DUQZVTVRAWQWFNVAVMXPWEWCCTZHFXPYCWEWCWJTZHXPCWJWEWCXSUTXPWNWOYDHUOXTYAW
        LWJDWDWCHXAXBSYBWAVRVSVJWB $.
    $}
  $}

  ${
    $d a b p q B $.  $d a b p q F $.  $d a b p q R $.  $d a b p q U $.
    $d a b p q V $.
    imasgrpf1.u $e |- U = ( F "s R ) $.
    imasgrpf1.v $e |- V = ( Base ` R ) $.
    $( The image of a group under an injection is a group.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    imasgrpf1 $p |- ( ( F : V -1-1-> B /\ R e. Grp ) -> U e. Grp ) $=
      ( vq vp va vb wf1 cgrp wcel wa c0g cfv wceq a1i cv crn cplusg cimas eqidd
      cbs wf1o wfo f1f1orn adantr f1ofo syl f1ocpbl simpr eqid imasgrp simpld
      co ) EADLZBMNZOZCMNBPQZDQCPQRUTDUAZBUBQZBCDEVAHIJKCDBUCUQRUTFSEBUEQRUTGSU
      TVCUDUTEVBDUFZEVBDUGURVDUSEADUHUIZEVBDUJUKUTJTKTITHTVCDEVBVEULURUSUMVAUNU
      OUP $.
  $}

  ${
    $d a b p q u x y z .~ $.  $d a b p q u x .0. $.  $d p u N $.  $d p q u R $.
    $d a b p q u x y .+ $.  $d a b p q u x y z ph $.  $d a b p q u x y z V $.
    $d a b p q x y z U $.
    divsgrp2.u $e |- ( ph -> U = ( R /s .~ ) ) $.
    divsgrp2.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divsgrp2.p $e |- ( ph -> .+ = ( +g ` R ) ) $.
    divsgrp2.r $e |- ( ph -> .~ Er V ) $.
    divsgrp2.x $e |- ( ph -> R e. X ) $.
    divsgrp2.e $e |- ( ph ->
      ( ( a .~ p /\ b .~ q ) -> ( a .+ b ) .~ ( p .+ q ) ) ) $.
    divsgrp2.1 $e |- ( ( ph /\ x e. V /\ y e. V ) -> ( x .+ y ) e. V ) $.
    divsgrp2.2 $e |- ( ( ph /\ ( x e. V /\ y e. V /\ z e. V ) ) ->
      ( ( x .+ y ) .+ z ) .~ ( x .+ ( y .+ z ) ) ) $.
    divsgrp2.3 $e |- ( ph -> .0. e. V ) $.
    divsgrp2.4 $e |- ( ( ph /\ x e. V ) -> ( .0. .+ x ) .~ x ) $.
    divsgrp2.5 $e |- ( ( ph /\ x e. V ) -> N e. V ) $.
    divsgrp2.6 $e |- ( ( ph /\ x e. V ) -> ( N .+ x ) .~ .0. ) $.
    $( Prove that a quotient structure is a group.  (Contributed by Mario
       Carneiro, 14-Jun-2015.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    divsgrp2 $p |- ( ph -> ( U e. Grp /\ [ .0. ] .~ = ( 0g ` U ) ) ) $=
      ( vu cgrp wcel cec c0g cfv wceq wa cv cmpt cqs cvv eqid wer fvex syl6eqel
      cbs erex sylc divsval divslem co 3expb ercpbl w3a adantr divsfval 3eqtr4d
      erthi ersym 3eqtr4rd imasgrp2 eqcomd eqeq1d anbi2d mpbird ) AHUJUKZLFULZH
      UMUNZUOZUPWELUIJUIUQFULURZUNZWGUOZUPABCDJFUSEGHWIIJKLMNOPAUIFGHWIJUTKQRWI
      VAZAJFVBZJUTUKZFUTUKTAJGVEUNUTRGVEVCVDZJFUTVFVGZUAVHRSAUIFGHWIJUTKQRWLWPU
      AVIAUIOUQPUQNUQMUQEFWIJBCTWOWLABUQZJUKZCUQZJUKZWQWSEVJZJUKUCVKUBVLUAUCAWR
      WTDUQZJUKVMZUPZXAXBEVJZFULWQWSXBEVJEVJZFULXEWIUNXFWIUNXDXEXFFJAWMXCTVNZUD
      VQXDUIXEFWIJXGAWNXCWOVNZWLVOXDUIXFFWIJXGXHWLVOVPUEAWRUPZLWQEVJZFULWQFULXJ
      WIUNWQWIUNXIXJWQFJAWMWRTVNZUFVQXIUIXJFWIJXKAWNWRWOVNZWLVOXIUIWQFWIJXKXLWL
      VOVPUGXIWFIWQEVJZFULWJXMWIUNXILXMFJXKXIXMLFJXKUHVRVQXIUILFWIJXKXLWLVOXIUI
      XMFWIJXKXLWLVOVSVTAWHWKWEAWFWJWGAWJWFAUILFWIJTWOWLVOWAWBWCWD $.
  $}

  ${
    $d x y R $.  $d x y S $.
    xpsgrp.t $e |- T = ( R Xs. S ) $.
    $( The binary product of groups is a group.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xpsgrp $p |- ( ( R e. Grp /\ S e. Grp ) -> T e. Grp ) $=
      ( vx vy cgrp wcel cbs cfv cv csn ccda co ccnv csca eqid wf1o c2o cvv wceq
      wa cmpt2 cprds cimas simpl simpr xpsval cxp wf1 xpsff1o2 wb xpslem f1oeq3
      crn syl mpbii f1ocnv f1of1 3syl con0 2on a1i fvex xpscf biimpri imasgrpf1
      wf prdsgrpd syl2anc eqeltrd ) AGHZBGHZUBZCEFAIJZBIJZEKLFKLMNOUCZOZAPJZALB
      LMNOZUDNZUENZGVNEFABCWAVQVSGGVOVPDVOQZVPQZVLVMUFZVLVMUGZVQQZVSQZWAQZUHVNW
      AIJZVOVPUIZVRUJZWAGHWBGHVNWKWJVQRZWJWKVRRWLVNWKVQUOZVQRZWMEFVOVPVQWGUKVNW
      NWJUAWOWMULVNEFABCWAVQVSGGVOVPDWCWDWEWFWGWHWIUMWNWJWKVQUNUPUQWKWJVQURWJWK
      VRUSUTVNVTVSSTVAWAWISVAHVNVBVCVSTHVNAPVDVCSGVTVHVNGABVEVFVIWKWAWBVRWJWBQW
      JQVGVJVK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Subgroups and Quotient groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~QG $.
  $c SubGrp $.
  $c NrmSGrp $.

  $( Extend class notation with all subgroups of a group. $)
  csubg $a class SubGrp $.

  $( Extend class notation with all normal subgroups of a group. $)
  cnsg $a class NrmSGrp $.

  $( Quotient group equivalence class. $)
  cqg $a class ~QG $.

  ${
    $d b i p r s w x y $.
    $( Define a subgroup of a group as a set of elements that is a group in its
       own right.  Equivalently ( ~ issubg2 ), a subgroup is a subset of the
       group that is closed for the group internal operation (see ~ subgcl ),
       contains the neutral element of the group (see ~ subg0 ) and contains
       the inverses for all of its elements (see ~ subginvcl ).  (Contributed
       by Mario Carneiro, 2-Dec-2014.) $)
    df-subg $a |- SubGrp = ( w e. Grp |->
        { s e. ~P ( Base ` w ) | ( w |`s s ) e. Grp } ) $.

    $( Define the equivalence relation in a quotient ring or quotient group
       (where ` i ` is a two-sided ideal or a normal subgroup).  For non-normal
       subgroups this generates the left cosets.  (Contributed by Mario
       Carneiro, 15-Jun-2015.) $)
    df-nsg $a |- NrmSGrp = ( w e. Grp |-> { s e. ( SubGrp ` w ) |
       [. ( Base ` w ) / b ]. [. ( +g ` w ) / p ]. A. x e. b A. y e. b
        ( ( x p y ) e. s <-> ( y p x ) e. s ) } ) $.

    $( Define the equivalence relation in a quotient ring or quotient group
       (where ` i ` is a two-sided ideal or a normal subgroup).  For non-normal
       subgroups this generates the left cosets.  (Contributed by Mario
       Carneiro, 15-Jun-2015.) $)
    df-eqg $a |- ~QG = ( r e. _V , i e. _V |-> { <. x , y >. |
      ( { x , y } C_ ( Base ` r ) /\
        ( ( ( invg ` r ) ` x ) ( +g ` r ) y ) e. i ) } ) $.
  $}

  ${
    $d s w B $.  $d s w G $.  $d s S $.
    issubg.b $e |- B = ( Base ` G ) $.
    $( The subgroup predicate.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    issubg $p |- ( S e. ( SubGrp ` G ) <->
      ( G e. Grp /\ S C_ B /\ ( G |`s S ) e. Grp ) ) $=
      ( vw vs csubg cfv wcel cgrp wss cress co cv cbs cpw crab wa wceq eleq1d
      w3a cdm df-subg dmmptss elfvdm sseldi simp1 fveq2 syl6eqr pweqd rabeqbidv
      oveq1 fvex eqeltri pwex rabex fvmpt eleq2d oveq2 elrab elpw2 anbi1i bitri
      cvv syl6bb ibar bitrd 3anass syl6bbr pm5.21nii ) BCGHZIZCJIZVMBAKZCBLMZJI
      ZUAZVLGUBJCEJENZFNZLMZJIZFVROHZPZQZGEFUCZUDBCGUEUFVMVNVPUGVMVLVMVNVPRZRZV
      QVMVLWFWGVMVLBCVSLMZJIZFAPZQZIZWFVMVKWKBECWDWKJGVRCSZWAWIFWCWJWMWBAWMWBCO
      HZAVRCOUHDUIUJWMVTWHJVRCVSLULTUKWEWIFWJAAWNVDDCOUMUNZUOUPUQURWLBWJIZVPRWF
      WIVPFBWJVSBSWHVOJVSBCLUSTUTWPVNVPBAWOVAVBVCVEVMWFVFVGVMVNVPVHVIVJ $.

    $( A subgroup is a subset.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    subgss $p |- ( S e. ( SubGrp ` G ) -> S C_ B ) $=
      ( csubg cfv wcel cgrp wss cress co issubg simp2bi ) BCEFGCHGBAICBJKHGABCD
      LM $.

    $( A group is a subgroup of itself.  (Contributed by Mario Carneiro,
       7-Dec-2014.) $)
    subgid $p |- ( G e. Grp -> B e. ( SubGrp ` G ) ) $=
      ( cgrp wcel wss cress co csubg cfv id a1i ressid eqeltrd issubg syl3anbrc
      ssid ) BDEZRAAFZBAGHZDEABIJERKZSRAQLRTBDABDCMUANAABCOP $.
  $}

  ${
    subggrp.h $e |- H = ( G |`s S ) $.
    $( A subgroup is a group.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    subggrp $p |- ( S e. ( SubGrp ` G ) -> H e. Grp ) $=
      ( csubg cfv wcel cress co cgrp cbs wss eqid issubg simp3bi syl5eqel ) ABE
      FGZCBAHIZJDQBJGABKFZLRJGSABSMNOP $.

    $( The base of the restricted group in a subgroup.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    subgbas $p |- ( S e. ( SubGrp ` G ) -> S = ( Base ` H ) ) $=
      ( csubg cfv wcel cbs wss wceq eqid subgss ressbas2 syl ) ABEFGABHFZIACHFJ
      OABOKZLAOCBDPMN $.
  $}

  $( Reverse closure for the subgroup predicate.  (Contributed by Mario
     Carneiro, 2-Dec-2014.) $)
  subgrcl $p |- ( S e. ( SubGrp ` G ) -> G e. Grp ) $=
    ( csubg cfv wcel cgrp cbs wss cress co eqid issubg simp1bi ) ABCDEBFEABGDZH
    BAIJFENABNKLM $.

  ${
    $d R x $.  $d S x $.  $d A x $.
    subg0.h $e |- H = ( G |`s S ) $.
    ${
      subg0.i $e |- .0. = ( 0g ` G ) $.
      $( A subgroup of a group must have the same identity as the group.
         (Contributed by Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario
         Carneiro, 30-Apr-2015.) $)
      subg0 $p |- ( S e. ( SubGrp ` G ) -> .0. = ( 0g ` H ) ) $=
        ( csubg cfv wcel c0g cplusg co wceq eqid ressplusg cgrp subggrp syl2anc
        oveqd cbs grpidcl grplid eqtrd wb subgrcl subgss subgbas eleqtrrd grpid
        syl sseldd mpbid ) ABGHZIZCJHZUOBKHZLZUOMZDUOMZUNUQUOUOCKHZLZUOUNUPUTUO
        UOAUPBCUMEUPNZOSUNCPIZUOCTHZIZVAUOMABCEQZUNVCVEVFVDCUOVDNZUONZUAUJZVDUT
        CUOUOVGUTNVHUBRUCUNBPIUOBTHZIURUSUDABUEUNAVJUOVJABVJNZUFUNUOVDAVIABCEUG
        UHUKVJUPBUODVKVBFUIRUL $.
    $}

    subginv.i $e |- I = ( invg ` G ) $.
    subginv.j $e |- J = ( invg ` H ) $.
    $( The inverse of an element in a subgroup is the same as the inverse in
       the larger group.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    subginv $p |- ( ( S e. ( SubGrp ` G ) /\ X e. S ) ->
      ( I ` X ) = ( J ` X ) ) $=
      ( cfv wcel wceq cplusg co c0g cgrp cbs adantr eleq2d eqid subggrp subgbas
      csubg biimpa grprinv syl2anc ressplusg oveqd subg0 3eqtr4d subgrcl subgss
      wa wb sselda wi grpinvcl syl 3imtr4d imp syldan grpinvid1 syl3anc mpbird
      ex ) ABUCJZKZFAKZUMZFDJFEJZLZFVJBMJZNZBOJZLZVIFVJCMJZNZCOJZVMVNVICPKZFCQJ
      ZKZVQVRLVGVSVHABCGUAZRVGVHWAVGAVTFABCGUBZSZUDVTVPCEFVRVTTZVPTVRTIUEUFVIVL
      VPFVJVGVLVPLVHAVLBCVFGVLTZUGRUHVGVNVRLVHABCVNGVNTZUIRUJVIBPKZFBQJZKVJWIKZ
      VKVOUNVGWHVHABUKRVGAWIFWIABWITZULZUOVGVHVJAKZWJVGVHWMVGWAVJVTKZVHWMVGVSWA
      WNUPWBVSWAWNVTCEFWEIUQVEURWDVGAVTVJWCSUSUTVGAWIVJWLUOVAWIVLBDFVJVNWKWFWGH
      VBVCVD $.
  $}

  ${
    subg0cl.i $e |- .0. = ( 0g ` G ) $.
    $( The group identity is an element of any subgroup.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    subg0cl $p |- ( S e. ( SubGrp ` G ) -> .0. e. S ) $=
      ( csubg cfv wcel cress co c0g cbs cgrp eqid subggrp grpidcl subg0 subgbas
      syl 3eltr4d ) ABEFGZBAHIZJFZUAKFZCATUALGUBUCGABUAUAMZNUCUAUBUCMUBMORABUAC
      UDDPABUAUDQS $.
  $}

  ${
    subginvcl.i $e |- I = ( invg ` G ) $.
    $( The inverse of an element is closed in a subgroup.  (Contributed by
       Mario Carneiro, 2-Dec-2014.) $)
    subginvcl $p |- ( ( S e. ( SubGrp ` G ) /\ X e. S ) -> ( I ` X ) e. S ) $=
      ( csubg cfv wcel wa cress cminusg cbs cgrp eqid subggrp adantr simpr wceq
      co subgbas eleqtrd grpinvcl syl2anc subginv 3eltr4d ) ABFGHZDAHZIZDBAJSZK
      GZGZUILGZDCGAUHUIMHZDULHUKULHUFUMUGABUIUINZOPUHDAULUFUGQUFAULRUGABUIUNTPZ
      UAULUIUJDULNUJNZUBUCABUICUJDUNEUPUDUOUE $.
  $}

  ${
    subgcl.p $e |- .+ = ( +g ` G ) $.
    $( A subgroup is closed under group operation.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    subgcl $p |- ( ( S e. ( SubGrp ` G ) /\ X e. S /\ Y e. S ) ->
      ( X .+ Y ) e. S ) $=
      ( csubg cfv wcel w3a cress cplusg cgrp eqid subggrp 3ad2ant1 wceq eleqtrd
      co cbs simp2 subgbas simp3 grpcl syl3anc ressplusg oveqd 3eltr4d ) BCGHZI
      ZDBIZEBIZJZDECBKSZLHZSZUNTHZDEASBUMUNMIZDUQIEUQIUPUQIUJUKURULBCUNUNNZOPUM
      DBUQUJUKULUAUJUKBUQQULBCUNUSUBPZRUMEBUQUJUKULUCUTRUQUOUNDEUQNUONUDUEUMAUO
      DEUJUKAUOQULBACUNUIUSFUFPUGUTUH $.
  $}

  ${
    subgsubcl.p $e |- .- = ( -g ` G ) $.
    $( A subgroup is closed under group subtraction.  (Contributed by Mario
       Carneiro, 18-Jan-2015.) $)
    subgsubcl $p |- ( ( S e. ( SubGrp ` G ) /\ X e. S /\ Y e. S ) ->
      ( X .- Y ) e. S ) $=
      ( cfv wcel w3a co cminusg cplusg cbs wceq wss eqid subgss 3ad2ant1 sseldd
      csubg simp2 grpsubval syl2anc subginvcl 3adant2 subgcl syld3an3 eqeltrd
      simp3 ) ABTGHZDAHZEAHZIZDECJZDEBKGZGZBLGZJZAUMDBMGZHEUSHUNURNUMAUSDUJUKAU
      SOULUSABUSPZQRZUJUKULUASUMAUSEVAUJUKULUISUSUQBUOCDEUTUQPZUOPZFUBUCUJUKULU
      PAHZURAHUJULVDUKABUOEVCUDUEUQABDUPVBUFUGUH $.

    subgsub.h $e |- H = ( G |`s S ) $.
    subgsub.n $e |- N = ( -g ` H ) $.
    $( The subtraction of elements in a subgroup is the same as subtraction in
       the group.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    subgsub $p |- ( ( S e. ( SubGrp ` G ) /\ X e. S /\ Y e. S ) ->
      ( X .- Y ) = ( X N Y ) ) $=
      ( cfv wcel cminusg cplusg co wceq eqid 3ad2ant1 cbs sseldd csubg oveq123d
      w3a ressplusg eqidd subginv 3adant2 simp2 simp3 grpsubval syl2anc subgbas
      wss subgss eleqtrd 3eqtr4d ) ABUAKZLZFALZGALZUCZFGBMKZKZBNKZOZFGCMKZKZCNK
      ZOZFGDOZFGEOZVAFFVCVGVDVHURUSVDVHPUTAVDBCUQIVDQZUDRVAFUEURUTVCVGPUSABCVBV
      FGIVBQZVFQZUFUGUBVAFBSKZLGVOLVJVEPVAAVOFURUSAVOUMUTVOABVOQZUNRZURUSUTUHZT
      VAAVOGVQURUSUTUIZTVOVDBVBDFGVPVLVMHUJUKVAFCSKZLGVTLVKVIPVAFAVTVRURUSAVTPU
      TABCIULRZUOVAGAVTVSWAUOVTVHCVFEFGVTQVHQVNJUJUKUP $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y S $.  $d x .x. $.  $d x y X $.
    subgmulgcl.t $e |- .x. = ( .g ` G ) $.
    $( Closure of the group multiple (exponentiation) operation in a subgroup.
       (Contributed by Mario Carneiro, 13-Jan-2015.) $)
    subgmulgcl $p |- ( ( S e. ( SubGrp ` G ) /\ N e. ZZ /\ X e. S ) ->
      ( N .x. X ) e. S ) $=
      ( vx vy csubg cfv wcel cbs cplusg cminusg cgrp c0g eqid subgrcl subgss cv
      subgcl subg0cl subginvcl mulgsubcl ) ACIJKGHCLJZCMJZABCCNJZDOECPJZUEQZFUF
      QZACRUEACUISUFACGTZHTUJUAUHQZACUHULUBUGQZACUGUKUMUCUD $.

    subgmulg.h $e |- H = ( G |`s S ) $.
    subgmulg.t $e |- .xb = ( .g ` H ) $.
    $( A group multiple is the same if evaluated in a subgroup.  (Contributed
       by Mario Carneiro, 15-Jan-2015.) $)
    subgmulg $p |- ( ( S e. ( SubGrp ` G ) /\ N e. ZZ /\ X e. S ) ->
      ( N .x. X ) = ( N .xb X ) ) $=
      ( cfv wcel cc0 wceq cif eqid 3ad2ant1 wa adantr syl2anc csubg w3a c0g clt
      cz wbr cplusg cn csn cxp c1 cseq cneg cminusg co ifeq1d ressplusg seqeq2d
      subg0 wn fveq1d wo cr simp2 zred 0re axlttri sylancl ioran syl6bb biimpar
      simpl1 cbs znegcld lt0neg1d biimpa elnnz sylanbrc wss subgss simp3 sseldd
      wb mulgnn subgmulgcl syl3anc eqeltrrd subginv syldan fveq2d eqtrd anassrs
      ifeq2da mulgval subgbas eleqtrd 3eqtr4d ) ADUAKZLZFUELZGALZUBZFMNZDUCKZMF
      UDUFZFDUGKZUHGUIUJZUKULZKZFUMZXHKZDUNKZKZOZOZXCEUCKZXEFEUGKZXGUKULZKZXJXR
      KZEUNKZKZOZOZFGCUOZFGBUOZXBXOXCXPXNOYDXBXCXDXPXNWSWTXDXPNXAADEXDIXDPZUSQU
      PXBXCXNYCXPXBXCUTZRZXNXEXSXMOYCYIXEXIXSXMYIFXHXRXBXHXRNZYHXBXFXQXGUKWSWTX
      FXQNXAAXFDEWRIXFPZUQQURZSVAUPYIXEXMYBXSXBYHXEUTZXMYBNXBYHYMRZRZXMXKYAKZYB
      XBYNFMUDUFZXMYPNZXBYQYNXBYQXCXEVBUTZYNXBFVCLMVCLYQYSWCXBFWSWTXAVDZVEZVFFM
      VGVHXCXEVIVJVKXBYQRZWSXKALYRWSWTXAYQVLZUUBXJGCUOZXKAUUBXJUHLZGDVMKZLZUUDX
      KNUUBXJUELZMXJUDUFZUUEUUBFXBWTYQYTSVNZXBYQUUIXBFUUAVOVPXJVQVRXBUUGYQXBAUU
      FGWSWTAUUFVSXAUUFADUUFPZVTQWSWTXAWAZWBZSUUFXFXHCDXJGUUKYKHXHPZWDTUUBWSUUH
      XAUUDALUUCUUJXBXAYQUULSACDXJGHWEWFWGADEXLYAXKIXLPZYAPZWHTWIYOXKXTYAYOXJXH
      XRXBYJYNYLSVAWJWKWLWMWKWMWKXBWTUUGYEXONYTUUMUUFXFXHCDXLFGXDUUKYKYGUUOHUUN
      WNTXBWTGEVMKZLYFYDNYTXBGAUUQUULWSWTAUUQNXAADEIWOQWPUUQXQXRBEYAFGXPUUQPXQP
      XPPUUPJXRPWNTWQ $.
  $}

  ${
    $d u v w x y G $.  $d u v w x y I $.  $d u v w x y .+ $.  $d u v w x y S $.
    $d u v w B $.  $d u v w O $.
    issubg2.b $e |- B = ( Base ` G ) $.
    issubg2.p $e |- .+ = ( +g ` G ) $.
    issubg2.i $e |- I = ( invg ` G ) $.
    $( Characterize the subgroups of a group by closure properties.
       (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    issubg2 $p |- ( G e. Grp -> ( S e. ( SubGrp ` G ) <-> ( S C_ B /\ S =/= (/)
      /\ A. x e. S ( A. y e. S ( x .+ y ) e. S /\ ( I ` x ) e. S ) ) ) ) $=
      ( vu wcel cfv c0 cv co wral wa syl wceq vv vw cgrp csubg wss subgss cress
      wne w3a cbs eqid subgbas subggrp grpbn0 eqnetrd 3expa ralrimiva subginvcl
      subgcl jca 3jca simpl simpr1 c0g ressbas2 cvv cplusg fvex syl6eqel simpr3
      ressplusg ralimi oveq1 eleq1d oveq2 rspc2v syl5com 3impib sseld 3anim123d
      imp grpass adantlr syldan wex simpr2 n0 sylib grplinv simpr fveq2 rspccva
      sselda adantr proplem2 syl21anc eqeltrrd exlimddv grplid isgrpd syl3anbrc
      sylan issubg ex impbid2 ) FUCLZEFUDMLZECUEZENUHZAOZBOZDPZELZBEQZXJGMZELZR
      ZAEQZUIZXGXHXIXRCEFHUFXGEFEUGPZUJMZNEFXTXTUKZULXGXTUCLZYANUHEFXTYBUMYAXTY
      AUKUNSUOXGXQAEXGXJELZRZXNXPYEXMBEXGYDXKELXMDEFXJXKIUSUPUQEFGXJJURUTUQVAXF
      XSXGXFXSRZXFXHYCXGXFXSVBXFXHXIXRVCZYFKUAUBEDXTKOZGMZFVDMZYFXHEYATYGECXTFY
      BHVESZYFEVFLDXTVGMTYFEYAVFYKXTUJVHVIEDFXTVFYBIVKSYFYHELZUAOZELZYHYMDPZELZ
      YFXNAEQZYLYNRYPYFXRYQXFXHXIXRVJZXQXNAEXNXPVBVLSZXMYPYHXKDPZELABYHYMEEXJYH
      TZXLYTEXJYHXKDVMVNXKYMTYTYOEXKYMYHDVOVNVPVQVRYFYLYNUBOZELZUIZYHCLZYMCLZUU
      BCLZUIZYOUUBDPYHYMUUBDPDPTZYFUUDUUHYFYLUUEYNUUFUUCUUGYFECYHYGVSYFECYMYGVS
      YFECUUBYGVSVTWAXFUUHUUIXSCDFYHYMUUBHIWBWCWDYFYLYJELKYFXIYLKWEXFXHXIXRWFKE
      WGWHYFYLRZYIYHDPZYJEYFYLUUEUUKYJTZYFECYHYGWMZXFUUEUULXSCDFGYHYJHIYJUKZJWI
      WCWDZUUJYIELZYLYQUUKELYFXPAEQZYLUUPYFXRUUQYRXQXPAEXNXPWJVLSXPUUPAYHEUUAXO
      YIEXJYHGWKVNWLXBZYFYLWJYFYQYLYSWNABEEEDYIYHWOWPWQWRYFYLUUEYJYHDPYHTZUUMXF
      UUEUUSXSCDFYHYJHIUUNWSWCWDUURUUOWTCEFHXCXAXDXE $.
  $}

  ${
    $d G x y $.  $d I x y $.  $d S x y $.
    issubg3.i $e |- I = ( invg ` G ) $.
    $( A subgroup is a symmetric submonoid.  (Contributed by Mario Carneiro,
       7-Mar-2015.) $)
    issubg3 $p |- ( G e. Grp -> ( S e. ( SubGrp ` G ) <->
        ( S e. ( SubMnd ` G ) /\ A. x e. S ( I ` x ) e. S ) ) ) $=
      ( vy cgrp wcel c0g cfv cv wral wa wi eqid a1i adantr wb w3a df-3an cbs c0
      csubg csubmnd subg0cl subm0cl wss wne cplusg co ne0i 2thd adantl 3anbi23d
      r19.26 anass anbi1i 3bitr4ri syl6bb issubg2 cmnd grpmnd issubm syl anbi1d
      id 3bitr4d ex pm5.21ndd ) CGHZCIJZBHZBCUCJHZBCUDJHZAKZDJBHZABLZMZVMVLNVJB
      CVKVKOZUEPVRVLNVJVNVLVQBCVKVSUFQPVJVLVMVRRVJVLMZBCUAJZUGZBUBUHZVOFKCUIJZU
      JBHFBLZVPMABLZSZWBVLWEABLZSZVQMZVMVRVTWGWBVLWHVQMZSZWJVTWCVLWFWKWBVLWCVLR
      VJVLWCVLBVKUKVLVFULUMWFWKRVTWEVPABUOPUNWBVLMZWHMZVQMWMWKMWJWLWMWHVQUPWIWN
      VQWBVLWHTUQWBVLWKTURUSVJVMWGRVLAFWAWDBCDWAOZWDOZEUTQVJVRWJRVLVJVNWIVQVJCV
      AHVNWIRCVBAFWAWDBCVKWOVSWPVCVDVEQVGVHVI $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z .- $.  $d x y z S $.
    issubg4.b $e |- B = ( Base ` G ) $.
    issubg4.p $e |- .- = ( -g ` G ) $.
    $( A subgroup is a nonempty subset of the group closed under subtraction.
       (Contributed by Mario Carneiro, 17-Sep-2015.) $)
    issubg4 $p |- ( G e. Grp -> ( S e. ( SubGrp ` G ) <-> ( S C_ B /\ S =/= (/)
      /\ A. x e. S A. y e. S ( x .- y ) e. S ) ) ) $=
      ( vz wcel cfv cv co wral eqid wa wi wceq eleq1d rspcv cgrp wss c0 wne w3a
      csubg subgss c0g subg0cl ne0i syl subgsubcl 3expb ralrimivva 3jca cminusg
      cplusg simplrl simplrr simprr r19.2z sylan adantl simprl grpsubid adantlr
      wrex oveq2 sselda syldan sylibd rexlimdva imp simpr oveq1 ralbidv sylc wb
      grpidcl ad2antrr grpsubval syl2anc simpll grpinvcl grplid ralbidva adantr
      eqtrd mpbid rspccva ad2ant2l simplll grpsubinv anassrs ralrimdva ralimdva
      fveq2 sseldd impancom cbvralv sylib r19.26 sylanbrc exp42 issubg2 sylibrd
      mpd 3impd impbid2 ) EUAJZDEUFKJZDCUBZDUCUDZALZBLZFMZDJZBDNZADNZUEZXKXLXMX
      SCDEGUGXKEUHKZDJZXMDEYAYAOZUIDYAUJUKXKXQABDDXKXNDJZXODJZXQDEFXNXOHULUMUNU
      OXJXTXLXMXOILZEUQKZMZDJZIDNZXOEUPKZKZDJZPBDNZUEZXKXJXLXMXSYOXJXLXMXSYOXJX
      LXMPZPZXSPZXLXMYNXJXLXMXSURXJXLXMXSUSYRYJBDNZYMBDNZYNYRXNYFYGMZDJZIDNZADN
      ZYSYRYTUUDYRYAXOFMZDJZBDNZYTYRYBXSUUGYQXSXRADVGZYBYQXMXSUUHXJXLXMUTXRADVA
      VBYQUUHYBYQXRYBADYQYDPZXRXNXNFMZDJZYBYDXRUUKQYQXQUUKBXNDXOXNRXPUUJDXOXNXN
      FVHSTVCUUIUUJYADYQYDXNCJZUUJYARZYQDCXNXJXLXMVDZVIXJUULUUMYPCEFXNYAGYCHVEV
      FVJSVKVLVMVJYQXSVNXRUUGAYADXNYARZXQUUFBDUUOXPUUEDXNYAXOFVOSVPTVQYQUUGYTVR
      XSYQUUFYMBDYQYEPZUUEYLDUUPUUEYAYLYGMZYLUUPYACJZXOCJZUUEUUQRXJUURYPYECEYAG
      YCVSVTYQDCXOUUNVIZCYGEYKFYAXOGYGOZYKOZHWAWBUUPXJYLCJZUUQYLRXJYPYEWCZUUPXJ
      UUSUVCUVDUUTCEYKXOGUVBWDWBCYGEYLYAGUVAYCWEWBWHSWFWGWIZYQYTXSUUDYQYTPZXRUU
      CADUVFYDPXRUUBIDUVFYDYFDJZXRUUBQUVFYDUVGPZPZXRXNYFYKKZFMZDJZUUBUVIUVJDJZX
      RUVLQYTUVGUVMYQYDYMUVMBYFDXOYFRYLUVJDXOYFYKWQSWJWKXQUVLBUVJDXOUVJRXPUVKDX
      OUVJXNFVHSTUKUVIUVKUUADUVICYGEFYKXNYFGUVAHUVBXJYPYTUVHWLUVIDCXNUVFXLUVHXJ
      XLXMYTURWGZUVFYDUVGVDWRUVIDCYFUVNUVFYDUVGUTWRWMSVKWNWOWPWSXGUUCYJABDXNXOR
      ZUUBYIIDUVOUUAYHDXNXOYFYGVOSVPWTXAUVEYJYMBDXBXCUOXDXHBICYGDEYKGUVAUVBXEXF
      XI $.
  $}

  ${
    $d x G $.  $d x S $.
    $( A subgroup is a submonoid.  (Contributed by Mario Carneiro,
       18-Jun-2015.) $)
    subgsubm $p |- ( S e. ( SubGrp ` G ) -> S e. ( SubMnd ` G ) ) $=
      ( vx csubg cfv wcel csubmnd cv cminusg wral cgrp subgrcl eqid issubg3 syl
      wa wb ibi simpld ) ABDEFZABGEFZCHBIEZEAFCAJZTUAUCPZTBKFTUDQABLCABUBUBMNOR
      S $.
  $}

  ${
    subsubg.h $e |- H = ( G |`s S ) $.
    $( A subgroup of a subgroup is a subgroup.  (Contributed by Mario Carneiro,
       19-Jan-2015.) $)
    subsubg $p |- ( S e. ( SubGrp ` G ) -> ( A e. ( SubGrp ` H ) <->
      ( A e. ( SubGrp ` G ) /\ A C_ S ) ) ) $=
      ( csubg cfv wcel wss wa cgrp cbs cress co adantr eqid subgss wceq subggrp
      adantl subgrcl subgbas sseqtr4d sstrd oveq1i ressabs syl5eq syldan issubg
      eqeltrrd syl3anbrc jca simprr sseqtrd adantrl ad2antrl eqeltrd impbida )
      BCFGZHZADFGHZAUSHZABIZJZUTVAJZVBVCVECKHZACLGZICAMNZKHZVBUTVFVABCUAOVEABVG
      VEADLGZBVAAVJIZUTVJADVJPZQTUTBVJRZVABCDEUBZOUCZUTBVGIVAVGBCVGPZQOUDVEDAMN
      ZVHKUTVAVCVQVHRZVOUTVCJVQCBMNZAMNVHDVSAMEUEBACUSUFUGZUHVAVQKHZUTADVQVQPST
      UJVGACVPUIUKVOULUTVDJZDKHZVKWAVAUTWCVDBCDESOWBABVJUTVBVCUMUTVMVDVNOUNWBVQ
      VHKUTVCVRVBVTUOVBVIUTVCACVHVHPSUPUQVJADVLUIUKUR $.
  $}

  ${
    $d g x y G $.  $d g x y S $.
    $( The intersection of a nonempty collection of subgroups is a subgroup.
       (Contributed by Mario Carneiro, 7-Dec-2014.) $)
    subgint $p |- ( ( S C_ ( SubGrp ` G ) /\ S =/= (/) ) ->
      |^| S e. ( SubGrp ` G ) ) $=
      ( vx vy vg cfv wss c0 wne wcel wral adantlr eqid syl ralrimiva sylibr c0g
      wa cv elint2 csubg cint cbs cplusg co cminusg cuni intssuni adantl subgss
      ssel2 unissb sstrd subg0cl fvex simprl elinti sylan simprr subgcl syl3anc
      ne0i imp ovex anassrs adantll subginvcl syl2anc jca cgrp w3a ssn0 subgrcl
      wb wex n0 exlimiv sylbi issubg2 3syl mpbir3and ) ABUAFZGZAHIZRZAUBZWBJZWF
      BUCFZGZWFHIZCSZDSZBUDFZUEZWFJZDWFKZWKBUFFZFZWFJZRZCWFKZWEWFAUGZWHWDWFXBGW
      CAUHUIWEESZWHGZEAKXBWHGWEXDEAWEXCAJZRZXCWBJZXDWCXEXGWDAWBXCUKLZWHXCBWHMZU
      JNOEAWHULPUMWEBQFZWFJZWJWEXJXCJZEAKXKWEXLEAXFXGXLXHXCBXJXJMUNNOEXJABQUOTP
      WFXJVBNWEWTCWFWEWKWFJZRZWPWSXNWODWFWEXMWLWFJZWOWEXMXORZRZWNXCJZEAKWOXQXRE
      AXQXERXGWKXCJZWLXCJZXRWEXEXGXPXHLXQXMXEXSWEXMXOUPXMXEXSWKAXCUQVCZURXQXOXE
      XTWEXMXOUSXOXEXTWLAXCUQVCURWMXCBWKWLWMMZUTVAOEWNAWKWLWMVDTPVEOXNWRXCJZEAK
      WSXNYCEAXNXERXGXSYCWEXEXGXMXHLXMXEXSWEYAVFXCBWQWKWQMZVGVHOEWRAWKWQUOTPVIO
      WEWBHIZBVJJZWGWIWJXAVKVNAWBVLYEXGEVOYFEWBVPXGYFEXCBVMVQVRCDWHWMWFBWQXIYBY
      DVSVTWA $.
  $}

  ${
    $d G a b $.  $d .0. a b $.
    0subg.z $e |- .0. = ( 0g ` G ) $.
    $( The zero subgroup of an arbitrary group.  (Contributed by Stefan O'Rear,
       10-Dec-2014.) $)
    0subg $p |- ( G e. Grp -> { .0. } e. ( SubGrp ` G ) ) $=
      ( va vb cgrp wcel cfv cv co wral wa eqid c0g fvex wceq elsnc sylibr ralsn
      eleq1d csn csubg cbs wss c0 wne cplusg cminusg grpidcl snssd eqeltri snnz
      cvv a1i grplid mpdan grpinvid oveq1 ralbidv oveq2 syl6bb anbi12d sylanbrc
      ovex fveq2 issubg2 mpbir3and ) AFGZBUAZAUBHGVIAUCHZUDVIUEUFZDIZEIZAUGHZJZ
      VIGZEVIKZVLAUHHZHZVIGZLZDVIKZVHBVJVJABVJMZCUIZUJVKVHBBANHUMCANOUKZULUNVHB
      BVNJZVIGZBVRHZVIGZWBVHWFBPZWGVHBVJGWJWDVJVNABBWCVNMZCUOUPWFBBBVNVDQRVHWHB
      PWIAVRBCVRMZUQWHBBVROQRWAWGWILDBWEVLBPZVQWGVTWIWMVQBVMVNJZVIGZEVIKWGWMVPW
      OEVIWMVOWNVIVLBVMVNURTUSWOWGEBWEVMBPWNWFVIVMBBVNUTTSVAWMVSWHVIVLBVRVETVBS
      VCDEVJVNVIAVRWCWKWLVFVG $.
  $}

  ${
    $d m n s x A $.  $d m n s u v x G $.  $d x S $.  $d x .x. $.  $d m n x X $.
    $d m n s u v F $.
    cycsubg.x $e |- X = ( Base ` G ) $.
    cycsubg.t $e |- .x. = ( .g ` G ) $.
    cycsubg.f $e |- F = ( x e. ZZ |-> ( x .x. A ) ) $.
    $( The set of integer powers of an element ` A ` of a group forms a
       subgroup containing ` A ` , called the cyclic group generated by the
       element ` A ` .  (Contributed by Mario Carneiro, 13-Jan-2015.) $)
    cycsubgcl $p |- ( ( G e. Grp /\ A e. X ) ->
      ( ran F e. ( SubGrp ` G ) /\ A e. ran F ) ) $=
      ( vv wcel wa cfv cv co cz syl c1 wceq oveq1 vu vm vn crn csubg wss c0 wne
      cgrp cplusg wral cminusg wf mulgcl 3expa an32s fmptd frn ovex fvmpt ax-mp
      1z mulg1 adantl syl5eq wfn ffn fnfvelrn sylancl eqeltrrd caddc w3a df-3an
      mulgdir sylan2br anass1rs zaddcl ad2antrl ad2antll oveq12d 3eqtr4d syl2an
      ne0i eqid anassrs ralrimiva oveq2 eleq1d ralrn adantr mpbird cneg mulgneg
      wb znegcl fveq2d jca ralbidv fveq2 anbi12d issubg2 mpbir3and ) EUIKZBFKZL
      ZDUDZEUEMKZBXFKZXEXGXFFUFZXFUGUHZUANZJNZEUJMZOZXFKZJXFUKZXKEULMZMZXFKZLZU
      AXFUKZXEPFDUMZXIXEAPANZBCOZFDXCYCPKZXDYDFKZXCYEXDYFFCEYCBGHUNUOUPIUQZPFDU
      RQXEXHXJXERDMZBXFXEYHRBCOZBRPKZYHYISVBARYDYIPDYCRBCTIRBCUSUTVAXDYIBSXCFCE
      BGHVCVDVEXEDPVFZYJYHXFKXEYBYKYGPFDVGQZVBPRDVHVIVJZXFBWCQXEYAUBNZDMZXLXMOZ
      XFKZJXFUKZYOXQMZXFKZLZUBPUKZXEUUAUBPXEYNPKZLZYRYTUUDYRYOUCNZDMZXMOZXFKZUC
      PUKZUUDUUHUCPXEUUCUUEPKZUUHXEUUCUUJLZLZYNUUEVKOZDMZUUGXFUULUUMBCOZYNBCOZU
      UEBCOZXMOZUUNUUGXCUUKXDUUOUURSZUUKXDLXCUUCUUJXDVLUUSUUCUUJXDVMFXMCEYNUUEB
      GHXMWDZVNVOVPUULUUMPKZUUNUUOSUUKUVAXEYNUUEVQZVDAUUMYDUUOPDYCUUMBCTIUUMBCU
      SUTQUULYOUUPUUFUUQXMUUCYOUUPSZXEUUJAYNYDUUPPDYCYNBCTIYNBCUSUTZVRUUJUUFUUQ
      SXEUUCAUUEYDUUQPDYCUUEBCTIUUEBCUSUTVSVTWAXEYKUVAUUNXFKUUKYLUVBPUUMDVHWBVJ
      WEWFXEYRUUIWNZUUCXEYKUVEYLYQUUHJUCPDXLUUFSYPUUGXFXLUUFYOXMWGWHWIQWJWKUUDY
      NWLZDMZYSXFUUDUVFBCOZUUPXQMZUVGYSXCUUCXDUVHUVISZXCUUCXDUVJFCEXQYNBGHXQWDZ
      WMUOUPUUDUVFPKZUVGUVHSUUCUVLXEYNWOZVDAUVFYDUVHPDYCUVFBCTIUVFBCUSUTQUUDYOU
      UPXQUUCUVCXEUVDVDWPWAXEYKUVLUVGXFKUUCYLUVMPUVFDVHWBVJWQWFXEYKYAUUBWNYLXTU
      UAUAUBPDXKYOSZXPYRXSYTUVNXOYQJXFUVNXNYPXFXKYOXLXMTWHWRUVNXRYSXFXKYOXQWSWH
      WTWIQWKXCXGXIXJYAVLWNXDUAJFXMXFEXQGUUTUVKXAWJXBYMWQ $.

    $( The cyclic subgroup generated by an element ` A ` is a subset of any
       subgroup containing ` A ` .  (Contributed by Mario Carneiro,
       13-Jan-2015.) $)
    cycsubgss $p |- ( ( S e. ( SubGrp ` G ) /\ A e. S ) -> ran F C_ S ) $=
      ( csubg cfv wcel wa cz wf crn wss cv co subgmulgcl 3expa an32s fmptd frn
      syl ) CFKLMZBCMZNZOCEPEQCRUIAOASZBDTZCEUGUJOMZUHUKCMZUGULUHUMCDFUJBIUAUBU
      CJUDOCEUEUF $.

    $( The cyclic group generated by ` A ` is the smallest subgroup containing
       ` A ` .  (Contributed by Mario Carneiro, 13-Jan-2015.) $)
    cycsubg $p |- ( ( G e. Grp /\ A e. X ) ->
      ran F = |^| { s e. ( SubGrp ` G ) | A e. s } ) $=
      ( cgrp wcel wa crn cv csubg cfv crab cint wss wi ssintab cycsubgss mpgbir
      cab df-rab inteqi sseqtr4i a1i cycsubgcl eleq2 elrab sylibr intss1 eqssd
      syl ) EKLBFLMZDNZBGOZLZGEPQZRZSZURVCTUQURUSVALUTMZGUEZSZVCURVFTVDURUSTUAG
      VDGURUBABUSCDEFHIJUCUDVBVEUTGVAUFUGUHUIUQURVBLZVCURTUQURVALBURLZMVGABCDEF
      HIJUJUTVHGURVAUSURBUKULUMURVBUNUPUO $.
  $}

  ${
    $d x y A $.  $d b g p s x y z G $.  $d b g p s x y z .+ $.  $d s x y z S $.
    $d y B $.  $d b g p s x y z X $.
    isnsg.1 $e |- X = ( Base ` G ) $.
    isnsg.2 $e |- .+ = ( +g ` G ) $.
    $( Property of being a normal subgroup.  (Contributed by Mario Carneiro,
       18-Jan-2015.) $)
    isnsg $p |- ( S e. ( NrmSGrp ` G ) <-> ( S e. ( SubGrp ` G ) /\
      A. x e. X A. y e. X ( ( x .+ y ) e. S <-> ( y .+ x ) e. S ) ) ) $=
      ( vg vp vs vb cnsg cfv wcel cgrp csubg cv co wral wb cdm cplusg wsbc crab
      wa cbs df-nsg dmmptss elfvdm sseldi subgrcl adantr wceq fveq2 cvv syl6eqr
      fvex a1i simpl fveq2d simplr simpr oveqd eleq1d bibi12d raleqbidv sbcied2
      rabeqbidv rabex fvmpt eleq2d eleq2 2ralbidv elrab syl6bb pm5.21nii ) DEMN
      ZOZEPOZDEQNZOZARZBRZCSZDOZWDWCCSZDOZUAZBFTAFTZUFZVSMUBPEIPWCWDJRZSZKRZOZW
      DWCWLSZWNOZUAZBLRZTZAWSTZJIRZUCNZUDZLXBUGNZUDZKXBQNZUEZMABIKJLUHZUIDEMUJU
      KWBVTWJDEULUMVTVSDWEWNOZWGWNOZUAZBFTZAFTZKWAUEZOWKVTVRXODIEXHXOPMXBEUNZXF
      XNKXGWAXBEQUOXPXDXNLXEFUPXEUPOXPXBUGURUSXPXEEUGNFXBEUGUOGUQXPWSFUNZUFZXAX
      NJXCCUPXCUPOXRXBUCURUSXRXCEUCNCXRXBEUCXPXQUTVAHUQXRWLCUNZUFZWTXMAWSFXPXQX
      SVBZXTWRXLBWSFYAXTWOXJWQXKXTWMWEWNXTWLCWCWDXRXSVCZVDVEXTWPWGWNXTWLCWDWCYB
      VDVEVFVGVGVHVHVIXIXNKWAEQURVJVKVLXNWJKDWAWNDUNZXLWIABFFYCXJWFXKWHWNDWEVMW
      NDWGVMVFVNVOVPVQ $.

    $( Weaken the condition of ~ isnsg to only one side of the implication.
       (Contributed by Mario Carneiro, 18-Jan-2015.) $)
    isnsg2 $p |- ( S e. ( NrmSGrp ` G ) <-> ( S e. ( SubGrp ` G ) /\
      A. x e. X A. y e. X ( ( x .+ y ) e. S -> ( y .+ x ) e. S ) ) ) $=
      ( vz wcel cv co wral wa wi ralbii weq oveq2 eleq1d oveq1 cnsg csubg isnsg
      cfv wb dfbi2 r19.26-2 bitri imbi12d cbvralv ralcom ralbidv 3bitri anbi12i
      anidm anbi2i ) DEUAUDJDEUBUDJZAKZIKZCLZDJZUSURCLZDJZUEZIFMZAFMZNUQURBKZCL
      ZDJZVGURCLZDJZOZBFMZAFMZNAICDEFGHUCVFVNUQVFVAVCOZIFMZAFMZVCVAOZIFMAFMZNZV
      NVNNVNVFVOVRNZIFMZAFMVTVEWBAFVDWAIFVAVCUFPPVOVRAIFFUGUHVQVNVSVNVPVMAFVOVL
      IBFIBQZVAVIVCVKWCUTVHDUSVGURCRSWCVBVJDUSVGURCTSUIUJPVSVRAFMZIFMUSVGCLZDJZ
      VGUSCLZDJZOZBFMZIFMVNVRAIFFUKWDWJIFVRWIABFABQZVCWFVAWHWKVBWEDURVGUSCRSWKU
      TWGDURVGUSCTSUIUJPWJVMIAFIAQZWIVLBFWLWFVIWHVKWLWEVHDUSURVGCTSWLWGVJDUSURV
      GCRSUIULUJUMUNVNUOUMUPUH $.

    $( Defining property of a normal subgroup.  (Contributed by Mario Carneiro,
       18-Jan-2015.) $)
    nsgbi $p |- ( ( S e. ( NrmSGrp ` G ) /\ A e. X /\ B e. X ) ->
                  ( ( A .+ B ) e. S <-> ( B .+ A ) e. S ) ) $=
      ( vx vy cfv wcel co wb cv wral wceq oveq1 eleq1d oveq2 cnsg csubg simprbi
      wa isnsg bibi12d rspc2v syl5com 3impib ) DEUAKLZAFLZBFLZABCMZDLZBACMZDLZN
      ZUJIOZJOZCMZDLZUSURCMZDLZNZJFPIFPZUKULUDUQUJDEUBKLVEIJCDEFGHUEUCVDUQAUSCM
      ZDLZUSACMZDLZNIJABFFURAQZVAVGVCVIVJUTVFDURAUSCRSVJVBVHDURAUSCTSUFUSBQZVGU
      NVIUPVKVFUMDUSBACTSVKVHUODUSBACRSUFUGUHUI $.
  $}

  ${
    $d w x y z .- $.  $d w x y z G $.  $d w x y z .+ $.  $d w x y z S $.
    $d w x y z X $.
    $( A normal subgroup is a subgroup.  (Contributed by Mario Carneiro,
       18-Jan-2015.) $)
    nsgsubg $p |- ( S e. ( NrmSGrp ` G ) -> S e. ( SubGrp ` G ) ) $=
      ( vx vy cnsg cfv wcel csubg cv cplusg co wb cbs wral eqid isnsg simplbi )
      ABEFGABHFGCIZDIZBJFZKAGSRTKAGLDBMFZNCUANCDTABUAUAOTOPQ $.

    isnsg3.1 $e |- X = ( Base ` G ) $.
    isnsg3.2 $e |- .+ = ( +g ` G ) $.
    isnsg3.3 $e |- .- = ( -g ` G ) $.
    $( The conjugation of an element of a normal subgroup is in the subgroup.
       (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    nsgconj $p |- ( ( S e. ( NrmSGrp ` G ) /\ A e. X /\ B e. S ) ->
      ( ( A .+ B ) .- A ) e. S ) $=
      ( cnsg cfv wcel w3a co cgrp wceq syl syl3anc eqeltrd csubg 3ad2ant1 simp2
      nsgsubg subgrcl wss subgss simp3 sseldd grpaddsubass syl13anc grpnpcan wb
      simp1 grpsubcl nsgbi mpbid ) DEKLMZAGMZBDMZNZABCOAFOZABAFOZCOZDVAEPMZUSBG
      MZUSVBVDQVADEUALMZVEURUSVGUTDEUDUBZDEUERZURUSUTUCZVADGBVAVGDGUFVHGDEHUGRU
      RUSUTUHZUIZVJGCEFABAHIJUJUKVAVCACOZDMZVDDMZVAVMBDVAVEVFUSVMBQVIVLVJGCEFBA
      HIJULSVKTVAURVCGMZUSVNVOUMURUSUTUNVAVEVFUSVPVIVLVJGEFBAHJUOSVJVCACDEGHIUP
      SUQT $.

    $( A subgroup is normal iff the conjugation of all the elements of the
       subgroup is in the subgroup.  (Contributed by Mario Carneiro,
       18-Jan-2015.) $)
    isnsg3 $p |- ( S e. ( NrmSGrp ` G ) <-> ( S e. ( SubGrp ` G ) /\
      A. x e. X A. y e. S ( ( x .+ y ) .- x ) e. S ) ) $=
      ( vz vw cfv wcel cv co wral wa wceq syl2anc cnsg csubg nsgsubg ralrimivva
      nsgconj 3expb jca wi simpl cminusg c0g cgrp subgrcl ad2antrr simprll eqid
      grplinv oveq1d grpinvcl simprlr grpass grplid 3eqtr3d eqtrd simprr simplr
      syl13anc grpsubinv oveq1 id oveq12d eleq1d rspc2va syl21anc eqeltrrd expr
      oveq2 isnsg2 sylanbrc impbii ) DEUAMNZDEUBMNZAOZBOZCPZWCFPZDNZBDQAGQZRZWA
      WBWHDEUCWAWGABGDWAWCGNWDDNWGWCWDCDEFGHIJUEUFUDUGWIWBKOZLOZCPZDNZWKWJCPZDN
      ZUHZLGQKGQWAWBWHUIWIWPKLGGWIWJGNZWKGNZRZWMWOWIWSWMRZRZWJEUJMZMZWLCPZXCFPZ
      WNDXAXEWKXCFPWNXAXDWKXCFXAXCWJCPZWKCPZEUKMZWKCPZXDWKXAXFXHWKCXAEULNZWQXFX
      HSWBXJWHWTDEUMUNZWIWQWRWMUOZGCEXBWJXHHIXHUPZXBUPZUQTURXAXJXCGNZWQWRXGXDSX
      KXAXJWQXOXKXLGEXBWJHXNUSTZXLWIWQWRWMUTZGCEXCWJWKHIVAVGXAXJWRXIWKSXKXQGCEW
      KXHHIXMVBTVCURXAGCEFXBWKWJHIJXNXKXQXLVHVDXAXOWMWHXEDNZXPWIWSWMVEWBWHWTVFW
      GXRXCWDCPZXCFPZDNABXCWLGDWCXCSZWFXTDYAWEXSWCXCFWCXCWDCVIYAVJVKVLWDWLSZXTX
      EDYBXSXDXCFWDWLXCCVQURVLVMVNVOVPUDKLCDEGHIVRVSVT $.
  $}

  ${
    $d B s x y z $.  $d G s x y z $.
    subgacs.b $e |- B = ( Base ` G ) $.
    $( Subgroups are an algebraic closure system.  (Contributed by Stefan
       O'Rear, 4-Apr-2015.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    subgacs $p |- ( G e. Grp -> ( SubGrp ` G ) e. ( ACS ` B ) ) $=
      ( vx vy vs cgrp wcel csubg cfv csubmnd cv cminusg wral cpw wa syl cvv cbs
      crab cin cacs eqid issubg3 wb wss submss adantl vex elpw eleq2 raleqbi1dv
      sylibr elrab3 pm5.32da bitr4d elin syl6bbr eqrdv cmre fvex eqeltri mreacs
      mp1i cmnd grpmnd submacs ralrimiva acsfn1 sylancr mreincl syl3anc eqeltrd
      grpinvcl ) BGHZBIJZBKJZDLZBMJZJZELZHZDWANZEAOZTZUAZAUBJZVOFVPWFVOFLZVPHZW
      HVQHZWHWEHZPZWHWFHVOWIWJVTWHHZDWHNZPWLDWHBVSVSUCZUDVOWJWKWNVOWJPZWHWDHZWK
      WNUEWPWHAUFZWQWJWRVOAWHBCUGUHWHAFUIUJUMWCWNEWHWDWBWMDWAWHWAWHVTUKULUNQUOU
      PWHVQWEUQURUSVOWGWDUTJHZVQWGHZWEWGHZWFWGHARHZWSVOABSJRCBSVAVBZRAVCVDVOBVE
      HWTBVFABCVGQVOXBVTAHZDANXAXCVOXDDAABVSVRCWOVNVHVTRAEDVIVJVQWEWGWDVKVLVM
      $.

    $( Normal subgroups form an algebraic closure system.  (Contributed by
       Stefan O'Rear, 4-Sep-2015.) $)
    nsgacs $p |- ( G e. Grp -> ( NrmSGrp ` G ) e. ( ACS ` B ) ) $=
      ( vx vy vz vs cgrp wcel cnsg cfv csubg cv co wral wa eqid cvv cbs syl3anc
      cplusg csg cpw crab cin cacs wb wss subgss vex elpw sylibr weq raleqbi1dv
      eleq2 ralbidv elrab3 syl bicomd pm5.32i isnsg3 elin 3bitr4i eqriv eqeltri
      cmre fvex mreacs mp1i subgacs simpl grpcl 3expb simprl ralrimivva acsfn1c
      grpsubcl sylancr mreincl syl5eqel ) BHIZBJKZBLKZDMZEMZBUAKZNZWDBUBKZNZFMZ
      IZEWJOZDAOZFAUCZUDZUEZAUFKZGWBWPGMZWCIZWIWRIZEWROZDAOZPWSWRWOIZPWRWBIWRWP
      IWSXBXCWSXCXBWSWRWNIZXCXBUGWSWRAUHXDAWRBCUIWRAGUJUKULWMXBFWRWNFGUMWLXADAW
      KWTEWJWRWJWRWIUOUNUPUQURUSUTDEWFWRBWHACWFQZWHQZVAWRWCWOVBVCVDWAWQWNVFKIZW
      CWQIWOWQIZWPWQIARIZXGWAABSKRCBSVGVEZRAVHVIABCVJWAXIWIAIZEAODAOXHXJWAXKDEA
      AWAWDAIZWEAIZPZPWAWGAIZXLXKWAXNVKWAXLXMXOAWFBWDWECXEVLVMWAXLXMVNABWHWGWDC
      XFVQTVOWIARAFDEVPVRWCWOWQWNVSTVT $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x .x. $.  $d x y X $.  $d y F $.  $d y K $.
    cycsubg2.x $e |- X = ( Base ` G ) $.
    cycsubg2.t $e |- .x. = ( .g ` G ) $.
    cycsubg2.f $e |- F = ( x e. ZZ |-> ( x .x. A ) ) $.
    cycsubg2.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( The subgroup generated by an element is exhausted by its multiples.
       (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
    cycsubg2 $p |- ( ( G e. Grp /\ A e. X ) -> ( K ` { A } ) = ran F ) $=
      ( vy cgrp wcel wa csn wss cfv crab cint cv csubg crn snssg bicomd rabbidv
      wb adantl inteqd cmre subgacs acsmred snssi mrcval syl2an cycsubg 3eqtr4d
      wceq ) EMNZBGNZOZBPZLUAZQZLEUBRZSZTZBVCNZLVESZTVBFRZDUCVAVFVIVAVDVHLVEUTV
      DVHUGUSUTVHVDBVCGUDUEUHUFUIUSVEGUJRNVBGQVJVGURUTUSVEGGEHUKULBGUMVEVBFGLKU
      NUOABCDEGLHIJUPUQ $.
  $}

  ${
    cycsubg2cl.x $e |- X = ( Base ` G ) $.
    cycsubg2cl.t $e |- .x. = ( .g ` G ) $.
    cycsubg2cl.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( Any multiple of an element is contained in the generated cyclic
       subgroup.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    cycsubg2cl $p |- ( ( G e. Grp /\ A e. X /\ N e. ZZ ) ->
        ( N .x. A ) e. ( K ` { A } ) ) $=
      ( cgrp wcel cz w3a csn cfv csubg co cmre wss subgacs 3ad2ant1 simp2 snssd
      acsmred mrccl syl2anc simp3 mrcssidd wb snssg 3ad2ant2 subgmulgcl syl3anc
      mpbird ) CJKZAFKZELKZMZANZDOZCPOZKZUQAUTKZEABQUTKURVAFROKZUSFSVBUOUPVDUQU
      OVAFFCGTUDUAZURAFUOUPUQUBUCZVAUSDFIUEUFUOUPUQUGURVCUSUTSZURVAUSDFVEIVFUHU
      PUOVCVGUIUQAUTFUJUKUNUTBCEAHULUM $.
  $}

  ${
    $d x z A $.  $d z B $.  $d u w x y z G $.  $d u w z N $.  $d u w x y z S $.
    $d u w x y z .+ $.  $d w z H $.  $d u w x y z X $.
    elnmz.1 $e |- N = { x e. X |
      A. y e. X ( ( x .+ y ) e. S <-> ( y .+ x ) e. S ) } $.
    $( Elementhood in the normalizer.  (Contributed by Mario Carneiro,
       18-Jan-2015.) $)
    elnmz $p |- ( A e. N <-> ( A e. X /\
      A. z e. X ( ( A .+ z ) e. S <-> ( z .+ A ) e. S ) ) ) $=
      ( cv co wcel wb wral wceq oveq2 eleq1d oveq1 bibi12d cbvralv ralbidv
      syl5bb elrab2 ) AJZBJZEKZFLZUEUDEKZFLZMZBHNZDCJZEKZFLZULDEKZFLZMZCHNZADHG
      UKUDULEKZFLZULUDEKZFLZMZCHNUDDOZURUJVCBCHUEULOZUGUTUIVBVEUFUSFUEULUDEPQVE
      UHVAFUEULUDERQSTVDVCUQCHVDUTUNVBUPVDUSUMFUDDULERQVDVAUOFUDDULEPQSUAUBIUC
      $.

    $( Defining property of the normalizer.  (Contributed by Mario Carneiro,
       18-Jan-2015.) $)
    nmzbi $p |- ( ( A e. N /\ B e. X ) ->
      ( ( A .+ B ) e. S <-> ( B .+ A ) e. S ) ) $=
      ( vz wcel cv co wb wral elnmz simprbi wceq oveq2 eleq1d bibi12d rspccva
      oveq1 sylan ) CGKZCJLZEMZFKZUFCEMZFKZNZJHOZDHKCDEMZFKZDCEMZFKZNZUECHKULAB
      JCEFGHIPQUKUQJDHUFDRZUHUNUJUPURUGUMFUFDCESTURUIUOFUFDCEUCTUAUBUD $.

    nmzsubg.2 $e |- X = ( Base ` G ) $.
    nmzsubg.3 $e |- .+ = ( +g ` G ) $.
    $( The normalizer N_G(S) of a subset ` S ` of the group is a subgroup.
       (Contributed by Mario Carneiro, 18-Jan-2015.) $)
    nmzsubg $p |- ( G e. Grp -> N e. ( SubGrp ` G ) ) $=
      ( vz vu wcel co wral wb eleq1d wceq grpass syl2anc cgrp csubg cfv wss wne
      vw c0 cv cminusg wa crab ssrab2 eqsstri a1i c0g eqid grplid grprid eqtr4d
      grpidcl ralrimiva elnmz sylanbrc syl w3a sseli grpcl syl3an simpl1 simpl2
      ne0i id sseldi simpl3 simpr syl13anc syl3anc nmzbi 3bitrd grpinvcl sylan2
      3expa simplr simpll adantr grprinv oveq1d 3eqtr3d grplinv oveq2d 3bitr3rd
      3eqtrd eqtrd jca issubg2 mpbir3and ) EUAMZFEUBUCMFGUDZFUGUEZKUHZUFUHZCNZF
      MZUFFOZWTEUIUCZUCZFMZUJZKFOWRWQFAUHZBUHZCNDMXJXICNDMPBGOZAGUKGHXKAGULUMZU
      NWQEUOUCZFMZWSWQXMGMXMWTCNZDMWTXMCNZDMPZKGOXNGEXMIXMUPZUTWQXQKGWQWTGMZUJZ
      XOXPDXTXOWTXPGCEWTXMIJXRUQGCEWTXMIJXRURUSQVAABKXMCDFGHVBVCFXMVKVDWQXHKFWQ
      WTFMZUJZXDXGYBXCUFFWQYAXAFMZXCWQYAYCVEZXBGMZXBLUHZCNZDMZYFXBCNZDMZPZLGOXC
      WQWQYAXSYCXAGMZYEWQVLFGWTXLVFZFGXAXLVFGCEWTXAIJVGVHYDYKLGYDYFGMZUJZYHWTXA
      YFCNZCNZDMZYFWTCNZXACNZDMZYJYOYGYQDYOWQXSYLYNYGYQRWQYAYCYNVIZYOFGWTXLWQYA
      YCYNVJZVMZYOFGXAXLWQYAYCYNVNZVMZYDYNVOZGCEWTXAYFIJSVPQYOYRYPWTCNZDMZXAYSC
      NZDMZUUAYOYAYPGMZYRUUIPUUCYOWQYLYNUULUUBUUFUUGGCEXAYFIJVGVQABWTYPCDFGHVRT
      YOUUHUUJDYOWQYLYNXSUUHUUJRUUBUUFUUGUUDGCEXAYFWTIJSVPQYOYCYSGMZUUKUUAPUUEY
      OWQYNXSUUMUUBUUGUUDGCEYFWTIJVGVQABXAYSCDFGHVRTVSYOYTYIDYOWQYNXSYLYTYIRUUB
      UUGUUDUUFGCEYFWTXAIJSVPQVSVAABLXBCDFGHVBVCWBVAYBXFGMZXFYFCNZDMZYFXFCNZDMZ
      PZLGOXGYAWQXSUUNYMGEXEWTIXEUPZVTWAZYBUUSLGYBYNUJZWTXFUUQCNZCNZDMZUVCWTCNZ
      DMZUURUUPUVBYAUVCGMZUVEUVGPWQYAYNWCZUVBWQUUNUUQGMZUVHWQYAYNWDZYBUUNYNUVAW
      EZUVBWQYNUUNUVJUVKYBYNVOZUVLGCEYFXFIJVGVQZGCEXFUUQIJVGVQABWTUVCCDFGHVRTUV
      BUVDUUQDUVBWTXFCNZUUQCNZXMUUQCNZUVDUUQUVBUVOXMUUQCUVBWQXSUVOXMRUVKUVBFGWT
      XLUVIVMZGCEXEWTXMIJXRUUTWFTWGUVBWQXSUUNUVJUVPUVDRUVKUVRUVLUVNGCEWTXFUUQIJ
      SVPUVBWQUVJUVQUUQRUVKUVNGCEUUQXMIJXRUQTWHQUVBUVFUUODUVBUVFXFUUQWTCNZCNZUU
      OUVBWQUUNUVJXSUVFUVTRUVKUVLUVNUVRGCEXFUUQWTIJSVPUVBUVSYFXFCUVBUVSYFXFWTCN
      ZCNZYFXMCNZYFUVBWQYNUUNXSUVSUWBRUVKUVMUVLUVRGCEYFXFWTIJSVPUVBUWAXMYFCUVBW
      QXSUWAXMRUVKUVRGCEXEWTXMIJXRUUTWITWJUVBWQYNUWCYFRUVKUVMGCEYFXMIJXRURTWLWJ
      WMQWKVAABLXFCDFGHVBVCWNVAKUFGCFEXEIJUUTWOWP $.

    $( A subgroup is a subset of its normalizer.  (Contributed by Mario
       Carneiro, 18-Jan-2015.) $)
    ssnmz $p |- ( S e. ( SubGrp ` G ) -> S C_ N ) $=
      ( vw cfv wcel wa co wceq syl eqid syl2anc syl3anc vz csubg cv wral subgss
      wb sselda simpll cminusg c0g subgrcl wss simplrl sseldd grplinv subginvcl
      cgrp oveq1d simplrr grpass syl13anc grplid simpr subgcl eqeltrrd grppncan
      3eqtr3d csg subgsubcl impbida anassrs ralrimiva elnmz sylanbrc ex ssrdv )
      DEUBLMZUADFVQUAUCZDMZVRFMZVQVSNZVRGMZVRKUCZCOZDMZWCVRCOZDMZUFZKGUDVTVQDGV
      RGDEIUEZUGZWAWHKGVQVSWCGMZWHVQVSWKNZNZWEWGWMWENZVQWCDMZVSWGVQWLWEUHZWNVRE
      UILZLZWDCOZWCDWNWRVRCOZWCCOZEUJLZWCCOZWSWCWNWTXBWCCWNEUQMZWBWTXBPWNVQXDWP
      DEUKZQZWNDGVRWNVQDGULWPWIQZVQVSWKWEUMZUNZGCEWQVRXBIJXBRZWQRZUOSURWNXDWRGM
      WBWKXAWSPXFWNDGWRXGWNVQVSWRDMZWPXHDEWQVRXKUPSZUNXIVQVSWKWEUSZGCEWRVRWCIJU
      TVAWNXDWKXCWCPXFXNGCEWCXBIJXJVBSVGWNVQXLWEWSDMWPXMWMWEVCCDEWRWDJVDTVEXHCD
      EWCVRJVDTWMWGNZVQVSWOWEVQWLWGUHZVQVSWKWGUMZXOWFVREVHLZOZWCDXOXDWKWBXSWCPX
      OVQXDXPXEQVQVSWKWGUSXOVQVSWBXPXQWJSGCEXRWCVRIJXRRZVFTXOVQWGVSXSDMXPWMWGVC
      XQDEXRWFVRXTVITVECDEVRWCJVDTVJVKVLABKVRCDFGHVMVNVOVP $.

    $( A subgroup is normal iff its normalizer is the entire group.
       (Contributed by Mario Carneiro, 18-Jan-2015.) $)
    isnsg4 $p |- ( S e. ( NrmSGrp ` G ) <->
                   ( S e. ( SubGrp ` G ) /\ N = X ) ) $=
      ( cnsg cfv wcel csubg cv co wb wral wa wceq eqeq2i rabid2 3bitri anbi2i
      isnsg crab eqcom bitr4i ) DEKLMDENLMZAOZBOZCPDMUKUJCPDMQBGRZAGRZSUIFGTZSA
      BCDEGIJUEUNUMUIUNGFTGULAGUFZTUMFGUGFUOGHUAULAGUBUCUDUH $.

    nmznsg.4 $e |- H = ( G |`s N ) $.
    $( Any subgroup is a normal subgroup of its normalizer.  (Contributed by
       Mario Carneiro, 19-Jan-2015.) $)
    nmznsg $p |- ( S e. ( SubGrp ` G ) -> S e. ( NrmSGrp ` H ) ) $=
      ( vz vw cfv wcel cv co wb wral csubg cbs cnsg id ssnmz wa subgrcl nmzsubg
      wss cgrp syl subsubg mpbir2and crab ssrab2 sseli nmzbi sylan2 rgen2a wceq
      eqsstri subgbas raleqdv raleqbidv mpbii eqid cvv cplusg eqeltri ressplusg
      fvex ssexi ax-mp isnsg sylanbrc ) DEUAOZPZDFUAOPZMQZNQZCRDPVTVSCRDPSZNFUB
      OZTZMWBTZDFUCOPVQVRVQDGUIZVQUDABCDEGHIJKUEVQGVPPZVRVQWEUFSVQEUJPWFDEUGABC
      DEGHIJKUHUKZDGEFLULUKUMVQWANGTZMGTWDWAMNGVTGPVSGPVTHPWAGHVTGAQZBQZCRDPWJW
      ICRDPSBHTZAHUNHIWKAHUOVAZUPABVSVTCDGHIUQURUSVQWHWCMGWBVQWFGWBUTWGGEFLVBUK
      ZVQWANGWBWMVCVDVEMNCDFWBWBVFGVGPCFVHOUTGHHEUBOVGJEUBVKVIWLVLGCEFVGLKVJVMV
      NVO $.
  $}

  ${
    $d G x y $.  $d .0. x y $.
    0nsg.z $e |- .0. = ( 0g ` G ) $.
    $( The zero subgroup is normal.  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    0nsg $p |- ( G e. Grp -> { .0. } e. ( NrmSGrp ` G ) ) $=
      ( vx vy cgrp wcel csn csubg cfv cv cplusg co wral wceq eqid adantrr eqtrd
      csg wa cnsg 0subg elsni ad2antll oveq2d grprid oveq1d grpsubid ovex elsnc
      cbs sylibr ralrimivva isnsg3 sylanbrc ) AFGZBHZAIJGDKZEKZALJZMZURASJZMZUQ
      GZEUQNDAUKJZNUQAUAJGABCUBUPVDDEVEUQUPURVEGZUSUQGZTTZVCBOVDVHVCURURVBMZBVH
      VAURURVBVHVAURBUTMZURVHUSBURUTVGUSBOUPVFUSBUCUDUEUPVFVJUROVGVEUTAURBVEPZU
      TPZCUFQRUGUPVFVIBOVGVEAVBURBVKCVBPZUHQRVCBVAURVBUIUJULUMDEUTUQAVBVEVKVLVM
      UNUO $.
  $}

  ${
    $d G x y $.  $d B x y $.
    nsgid.z $e |- B = ( Base ` G ) $.
    $( The whole group is a normal subgroup of itself.  (Contributed by Mario
       Carneiro, 4-Feb-2015.) $)
    nsgid $p |- ( G e. Grp -> B e. ( NrmSGrp ` G ) ) $=
      ( vx vy cgrp wcel csubg cfv cv cplusg csg wral cnsg subgid w3a simp1 eqid
      co grpcl simp2 grpsubcl syl3anc 3expb ralrimivva isnsg3 sylanbrc ) BFGZAB
      HIGDJZEJZBKIZSZUIBLIZSAGZEAMDAMABNIGABCOUHUNDEAAUHUIAGZUJAGZUNUHUOUPPUHUL
      AGUOUNUHUOUPQAUKBUIUJCUKRZTUHUOUPUAABUMULUICUMRZUBUCUDUEDEUKABUMACUQURUFU
      G $.
  $}

  ${
    $d g s x y $.
    releqg.r $e |- R = ( G ~QG S ) $.
    $( The left coset equivalence relation is a relation.  (Contributed by
       Mario Carneiro, 14-Jun-2015.) $)
    releqg $p |- Rel R $=
      ( vx vy vg vs wrel cqg co cv cpr cbs cfv wss cminusg cplusg wcel cvv wa
      df-eqg relmpt2opab releqi mpbir ) AICBJKZIELZFLZMGLZNOPUGUIQOOUHUIROKHLSU
      AGHEFTTCBJEFHGUBUCAUFDUDUE $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d g s x y G $.  $d g s x y N $.  $d g s x y S $.
    $d g s x y .+ $.  $d g s x y X $.
    eqgval.x $e |- X = ( Base ` G ) $.
    eqgval.n $e |- N = ( invg ` G ) $.
    eqgval.p $e |- .+ = ( +g ` G ) $.
    eqgval.r $e |- R = ( G ~QG S ) $.
    $( Value of the subgroup left coset equivalence relation.  (Contributed by
       Mario Carneiro, 15-Jan-2015.) $)
    eqgfval $p |- ( ( G e. V /\ S C_ X ) -> R = { <. x , y >. |
      ( { x , y } C_ X /\ ( ( N ` x ) .+ y ) e. S ) } ) $=
      ( vg wcel cvv cv cfv wa cbs vs cpr wss co wceq elex fvex eqeltri ssex cqg
      copab cminusg cplusg simpl fveq2d syl6eqr sseq2d oveq123d eleq12d anbi12d
      fveq1d eqidd simpr opabbidv df-eqg cxp xpex prss sylibr ssopab2i sseqtr4i
      vex df-xp ssexi ovmpt2a syl5eq syl2an ) FHOFPOZEPOZDAQZBQZUBZIUCZVTGRZWAC
      UDZEOZSZABUKZUEEIUCFHUFEIIFTRZPJFTUGUHZUIVRVSSDFEUJUDWHMNUAFEPPWBNQZTRZUC
      ZVTWKULRZRZWAWKUMRZUDZUAQZOZSZABUKWHUJWKFUEZWREUEZSZWTWGABXCWMWCWSWFXCWLI
      WBXCWLWIIXCWKFTXAXBUNZUOJUPUQXCWQWEWREXCWOWDWAWAWPCXCWPFUMRCXCWKFUMXDUOLU
      PXCVTWNGXCWNFULRGXCWKFULXDUOKUPVAXCWAVBURXAXBVCUSUTVDABUANVEWHIIVFZIIWJWJ
      VGWHVTIOWAIOSZABUKXEWGXFABWGWCXFWCWFUNVTWAIAVLBVLVHVIVJABIIVMVKVNVOVPVQ
      $.

    $( Value of the subgroup left coset equivalence relation.  (Contributed by
       Mario Carneiro, 15-Jan-2015.)  (Revised by Mario Carneiro,
       14-Jun-2015.) $)
    eqgval $p |- ( ( G e. V /\ S C_ X ) -> ( A R B <->
      ( A e. X /\ B e. X /\ ( ( N ` A ) .+ B ) e. S ) ) ) $=
      ( vx vy wcel wss wa wbr cvv cv cpr cfv co copab w3a eqgfval adantl simpr1
      breqd brabv elex syl simpr2 jca wceq prss eleq1 bi2anan9 syl5bbr fveq2 id
      vex oveqan12d eleq1d anbi12d df-3an syl6bbr eqid brabga pm5.21nd bitrd )
      FHPEIQRZABDSABNUAZOUAZUBIQZVNGUCZVOCUDZEPZRZNOUEZSZAIPZBIPZAGUCZBCUDZEPZU
      FZVMDWAABNOCDEFGHIJKLMUGUJVMWBWHATPZBTPZRZWBWKVMVTNOABUKUHVMWHRZWIWJWLWCW
      IVMWCWDWGUIAIULUMWLWDWJVMWCWDWGUNBIULUMUOVTWHNOABWATTVNAUPZVOBUPZRZVTWCWD
      RZWGRWHWOVPWPVSWGVPVNIPZVOIPZRWOWPVNVOINVCOVCUQWMWQWCWNWRWDVNAIURVOBIURUS
      UTWOVRWFEWMWNVQWEVOBCVNAGVAWNVBVDVEVFWCWDWGVGVHWAVIVJVKVL $.
  $}

  ${
    $d g x .+ $.  $d x y z .~ $.  $d x .0. $.  $d g x y z G $.  $d g x y z X $.
    $d g x A $.  $d x y z Y $.
    eqger.x $e |- X = ( Base ` G ) $.
    eqger.r $e |- .~ = ( G ~QG Y ) $.
    $( The subgroup coset equivalence relation is an equivalence relation.
       (Contributed by Mario Carneiro, 13-Jan-2015.) $)
    eqger $p |- ( Y e. ( SubGrp ` G ) -> .~ Er X ) $=
      ( cfv wcel cv wbr wa co w3a cgrp wb eqid eqgval syl2anc wceq adantr vx vy
      vz wrel releqg a1i cminusg cplusg wss subgrcl subgss biimpa simp2d simp1d
      csubg grpinvcl grpinvadd syl3anc grpinvinv oveq2d simp3d subginvcl syldan
      eqtrd eqeltrrd mpbir3and adantrr adantrl grpcl grpass syl13anc c0g oveq1d
      grprinv grplid 3eqtr3d simpl subgcl grplinv sylan subg0cl pm4.71rd df-3an
      eqeltrd ex anidm anbi2ci bitri syl6bb bitr4d iserd ) DBUOGHZUAUBUCCAAUDWL
      ADBFUEUFWLUAIZUBIZAJZKZWNWMAJZWNCHZWMCHZWNBUGGZGZWMBUHGZLZDHZWPWSWRWMWTGZ
      WNXBLZDHZWLWOWSWRXGMZWLBNHZDCUIZWOXHODBUJZCDBEUKZWMWNXBADBWTNCEWTPZXBPZFQ
      RULZUMZWPWSWRXGXOUNZWPXFWTGZXCDWPXRXAXEWTGZXBLZXCWPXIXECHZWRXRXTSWLXIWOXK
      TZWPXIWSYAYBXQCBWTWMEXMUPZRXPCXBBWTXEWNEXNXMUQURWPXSWMXAXBWPXIWSXSWMSYBXQ
      CBWTWMEXMUSRUTVDWLWOXGXRDHWPWSWRXGXOVAZDBWTXFXMVBVCVEWPXIXJWQWRWSXDMOYBWL
      XJWOXLTWNWMXBADBWTNCEXMXNFQRVFWLWOWNUCIZAJZKZKZWMYEAJZWSYECHZXEYEXBLZDHZW
      LWOWSYFXQVGZYHWRYJXAYEXBLZDHZWLYFWRYJYOMZWOWLYFYPWLXIXJYFYPOXKXLWNYEXBADB
      WTNCEXMXNFQRULVHZUMZYHXFYNXBLZYKDYHYSXEWNYNXBLZXBLZYKYHXIYAWRYNCHZYSUUASW
      LXIYGXKTZYHXIWSYAUUCYMYCRWLWOWRYFXPVGZYHXIXACHZYJUUBUUCYHXIWRUUEUUCUUDCBW
      TWNEXMUPRZYRCXBBXAYEEXNVIURCXBBXEWNYNEXNVJVKYHYTYEXEXBYHWNXAXBLZYEXBLZBVL
      GZYEXBLZYTYEYHUUGUUIYEXBYHXIWRUUGUUISUUCUUDCXBBWTWNUUIEXNUUIPZXMVNRVMYHXI
      WRUUEYJUUHYTSUUCUUDUUFYRCXBBWNXAYEEXNVJVKYHXIYJUUJYESUUCYRCXBBYEUUIEXNUUK
      VORVPUTVDYHWLXGYOYSDHWLYGVQWLWOXGYFYDVGYHWRYJYOYQVAXBDBXFYNXNVRURVEYHXIXJ
      YIWSYJYLMOUUCWLXJYGXLTWMYEXBADBWTNCEXMXNFQRVFWLWSXEWMXBLZDHZWSKZWMWMAJZWL
      WSUUMWLWSUUMWLWSKUULUUIDWLXIWSUULUUISXKCXBBWTWMUUIEXNUUKXMVSVTWLUUIDHWSDB
      UUIUUKWATWDWEWBWLUUOWSWSUUMMZUUNWLXIXJUUOUUPOXKXLWMWMXBADBWTNCEXMXNFQRUUP
      WSWSKZUUMKUUNWSWSUUMWCUUQWSUUMWSWFWGWHWIWJWK $.

    ${
      eqglact.3 $e |- .+ = ( +g ` G ) $.
      $( A left coset can be expressed as the image of a left action.
         (Contributed by Mario Carneiro, 20-Sep-2015.) $)
      eqglact $p |- ( ( G e. Grp /\ Y C_ X /\ A e. X ) ->
        [ A ] .~ = ( ( x e. X |-> ( A .+ x ) ) " Y ) ) $=
        ( vg wcel cfv co wa cmpt cima eqid wceq ccnv wss w3a cv wbr cab cminusg
        cgrp cec wb eqgval 3anass syl6bb baibd 3impa abbidv dfec2 3ad2ant3 wf1o
        grplactcnv simprd grplactfval adantl cnveqd syl 3eqtr3d 3adant2 imaeq1d
        grpinvcl imacnvcnv crab mptpreima df-rab eqtri 3eqtr3g 3eqtr4d ) EUGLZG
        FUAZBFLZUBZBAUCZDUDZAUEZVTFLZBEUFMZMZVTCNZGLZOZAUEZBDUHZAFBVTCNPZGQZVSW
        AWHAVPVQVRWAWHUIVPVQOZWAVRWHWMWAVRWCWGUBVRWHOBVTCDGEWDUGFHWDRZJIUJVRWCW
        GUKULUMUNUOVRVPWJWBSVQABDFUPUQVSWKTZTZGQAFWFPZTZGQZWLWIVSWPWRGVPVRWPWRS
        VQVPVROZWOWQWTBKFAFKUCVTCNPPZMZTZWEXAMZWOWQWTFFXBURXCXDSBCKXAEWDFAXARZH
        JWNUSUTWTXBWKVRXBWKSVPBCKXAEFAXEHVAVBVCWTWEFLXDWQSFEWDBHWNVHWECKXAEFAXE
        HVAVDVEVCVFVGWKGVIWSWGAFVJWIAFWFGWQWQRVKWGAFVLVMVNVO $.
    $}

    ${
      eqgid.3 $e |- .0. = ( 0g ` G ) $.
      $( The left coset containing the identity is the original subgroup.
         (Contributed by Mario Carneiro, 20-Sep-2015.) $)
      eqgid $p |- ( Y e. ( SubGrp ` G ) -> [ .0. ] .~ = Y ) $=
        ( vx csubg cfv wcel cec wb co wa cgrp wceq eqid syl cv wbr wrel relelec
        releqg ax-mp cminusg cplusg subgrcl adantr grpinvid oveq1d grplid sylan
        eqtrd eleq1d pm5.32da wss subgss grpidcl w3a eqgval 3anass syl6bb baibd
        syl21anc sseld pm4.71rd 3bitr4d syl5bb eqrdv ) DBJKLZIEAMZDIUAZVMLZEVNA
        UBZVLVNDLZAUCVOVPNADBGUEVNEAUDUFVLVNCLZEBUGKZKZVNBUHKZOZDLZPZVRVQPVPVQV
        LVRWCVQVLVRPZWBVNDWEWBEVNWAOZVNWEVTEVNWAWEBQLZVTERVLWGVRDBUIZUJBVSEHVSS
        ZUKTULVLWGVRWFVNRWHCWABVNEFWASZHUMUNUOUPUQVLWGDCURZECLZVPWDNWHCDBFUSZVL
        WGWLWHCBEFHUTTWGWKPZVPWLWDWNVPWLVRWCVAWLWDPEVNWAADBVSQCFWIWJGVBWLVRWCVC
        VDVEVFVLVQVRVLDCVNWMVGVHVIVJVK $.
    $}

    $( Each coset is equipotent to the subgroup itself (which is also the coset
       containing the identity).  (Contributed by Mario Carneiro,
       20-Sep-2015.) $)
    eqgen $p |- ( ( Y e. ( SubGrp ` G ) /\ A e. ( X /. .~ ) ) -> Y ~~ A ) $=
      ( vz vy cv cen wbr cfv wcel eqid wa co cmpt cvv wf1o cec csubg cqs cplusg
      vx breq2 cima cres simpl cgrp wss wceq subgrcl subgss eqglact 3expa sylan
      jca cqg ovex eqeltri ecexg syl6eqelr wf1 grplactf1o wb grplactfval adantl
      ax-mp f1oeq1 mpbid adantr f1ores syl2anc f1oen2g syl3anc breqtrrd ectocld
      syl f1of1 ) EUEJZBUAZKLEAKLECUBMZNZUEADBDBUCZWEOWBAEKUFWDWADNZPZEHDWAHJZC
      UDMZQRZEUGZWBKWGWDWKSNEWKWJEUHZTZEWKKLWDWFUIWGWKWBSWDCUJNZEDUKZPWFWBWKULZ
      WDWNWOECUMZDECFUNZURWNWOWFWPHWAWIBCDEFGWIOZUOUPUQZBSNWBSNBCEUSQSGCEUSUTVA
      WASBVBVIVCWGDDWJVDZWOWMWGDDWJTZXAWDWNWFXBWQWNWFPZDDWAIDHDIJWHWIQRRZMZTZXB
      WAWIIXDCDHXDOZFWSVEXCXEWJULZXFXBVFWFXHWNWAWIIXDCDHXGFVGVHDDXEWJVJVSVKUQDD
      WJVTVSWDWOWFWRVLDDEWJVMVNEWKWLWCSVOVPWTVQVR $.

    eqgcpbl.p $e |- .+ = ( +g ` G ) $.
    $( The subgroup coset equivalence relation is compatible with addition when
       the subgroup is normal.  (Contributed by Mario Carneiro,
       14-Jun-2015.) $)
    eqgcpbl $p |- ( Y e. ( NrmSGrp ` G ) ->
        ( ( A .~ C /\ B .~ D ) -> ( A .+ B ) .~ ( C .+ D ) ) ) $=
      ( cfv wcel co cgrp wb syl2anc mpbid syl3anc cnsg wa cminusg csubg nsgsubg
      wbr adantr subgrcl syl w3a simprl subgss eqid eqgval simp1d simprr simp2d
      wss grpcl wceq grpinvadd oveq1d grpinvcl grpass eqtrd eqtr3d simp3d simpl
      syl13anc nsgbi subgcl eqeltrd mpbir3and ex ) IGUAMNZACFUFZBDFUFZUBZABEOZC
      DEOZFUFZVOVRUBZWAVSHNZVTHNZVSGUCMZMZVTEOZINZWBGPNZAHNZBHNZWCWBIGUDMNZWIVO
      WLVRIGUEUGZIGUHUIZWBWJCHNZAWEMZCEOZINZWBVPWJWOWRUJZVOVPVQUKWBWIIHURZVPWSQ
      WNWBWLWTWMHIGJULUIZACEFIGWEPHJWEUMZLKUNRSZUOZWBWKDHNZBWEMZDEOINZWBVQWKXEX
      GUJZVOVPVQUPWBWIWTVQXHQWNXABDEFIGWEPHJXBLKUNRSZUOZHEGABJLUSTWBWIWOXEWDWNW
      BWJWOWRXCUQZWBWKXEXGXIUQZHEGCDJLUSTZWBWGXFWPVTEOZEOZIWBWGXFWPEOZVTEOZXOWB
      WFXPVTEWBWIWJWKWFXPUTWNXDXJHEGWEABJLXBVATVBWBWIXFHNZWPHNZWDXQXOUTWNWBWIWK
      XRWNXJHGWEBJXBVCRZWBWIWJXSWNXDHGWEAJXBVCRZXMHEGXFWPVTJLVDVIVEWBXNXFEOZINZ
      XOINZWBYBWQDXFEOZEOZIWBWQDEOZXFEOZYBYFWBYGXNXFEWBWIXSWOXEYGXNUTWNYAXKXLHE
      GWPCDJLVDVIVBWBWIWQHNZXEXRYHYFUTWNWBWIXSWOYIWNYAXKHEGWPCJLUSTXLXTHEGWQDXF
      JLVDVIVFWBWLWRYEINZYFINWMWBWJWOWRXCVGWBXGYJWBWKXEXGXIVGWBVOXRXEXGYJQVOVRV
      HZXTXLXFDEIGHJLVJTSEIGWQYELVKTVLWBVOXNHNZXRYCYDQYKWBWIXSWDYLWNYAXMHEGWPVT
      JLUSTXTXNXFEIGHJLVJTSVLWBWIWTWAWCWDWHUJQWNXAVSVTEFIGWEPHJXBLKUNRVMVN $.
  $}

  ${
    $d a b c d p q u v w G $.  $d a b c d u v w H $.  $d a b c d p q u v w S $.
    $d a b p q .+b $.  $d p q .+ $.  $d a b p q V $.  $d p q X $.  $d p q Y $.
    divsgrp.h $e |- H = ( G /s ( G ~QG S ) ) $.
    $( If ` Y ` is a normal subgroup of ` G ` , then ` H = G / Y ` is a group,
       called the quotient of ` G ` by ` Y ` .  (Contributed by Mario Carneiro,
       14-Jun-2015.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    divsgrp $p |- ( S e. ( NrmSGrp ` G ) -> H e. Grp ) $=
      ( vu vv vw vd vc cfv wcel cgrp co wceq cv eqid syl adantr erref sylan c0g
      va cnsg cqg cec cplusg cminusg cbs cqus a1i eqidd csubg wer nsgsubg eqger
      vb subgrcl eqgcpbl grpcl syl3an1 w3a simpr1 simpr2 syl3anc simpr3 breqtrd
      wa grpass grpidcl grplid simpr eqbrtrd grpinvcl grplinv divsgrp2 simpld )
      ABUCJKZCLKBUAJZBAUDMZUECUAJNVQEFGBUFJZVSBCEOZBUGJZJZBUHJZLVRHIUBUPCBVSUIM
      NVQDUJVQWDUKVQVTUKVQABULJKZWDVSUMZABUNZVSBWDAWDPZVSPZUOQZVQWEBLKZWGABUQQZ
      UBOUPOIOHOVTVSBWDAWHWIVTPZURVQWKWAWDKZFOZWDKZWAWOVTMZWDKZWLWDVTBWAWOWHWMU
      SZUTVQWNWPGOZWDKZVAZVGZWQWTVTMZXDWAWOWTVTMVTMZVSXCXDVSWDVQWFXBWJRXCWKWRXA
      XDWDKVQWKXBWLRZXCWKWNWPWRXFVQWNWPXAVBVQWNWPXAVCWSVDVQWNWPXAVEWDVTBWQWTWHW
      MUSVDSVQWKXBXDXENWLWDVTBWAWOWTWHWMVHTVFVQWKVRWDKZWLWDBVRWHVRPZVIQZVQWNVGZ
      VRWAVTMZWAWAVSVQWKWNXKWANWLWDVTBWAVRWHWMXHVJTXJWAVSWDVQWFWNWJRZVQWNVKSVLV
      QWKWNWCWDKWLWDBWBWAWHWBPZVMTXJWCWAVTMZVRVRVSVQWKWNXNVRNWLWDVTBWBWAVRWHWMX
      HXMVNTXJVRVSWDXLVQXGWNXIRSVLVOVP $.

    ${
      divsadd.v $e |- V = ( Base ` G ) $.
      ${
        divseccl.b $e |- B = ( Base ` H ) $.
        $( Closure of the quotient map for a quotient group.  (Contributed by
           Mario Carneiro, 18-Sep-2015.) $)
        divseccl $p |- ( ( S e. ( NrmSGrp ` G ) /\ X e. V ) ->
          [ X ] ( G ~QG S ) e. B ) $=
          ( cnsg cfv wcel wa cqg co cbs cvv cgrp wceq a1i cec ovex ecelqsi cqus
          cqs adantl csubg nsgsubg subgrcl syl adantr divsbas syl6eqr eleqtrd )
          BCJKLZFELZMZFCBNOZUAZEURUEZAUPUSUTLUOEFURCBNUBZUCUFUQUTDPKAUQURCDEQRD
          CURUDOSUQGTECPKSUQHTURQLUQVATUOCRLZUPUOBCUGKLVBBCUHBCUIUJUKULIUMUN $.
      $}

      divsadd.p $e |- .+ = ( +g ` G ) $.
      divsadd.a $e |- .+b = ( +g ` H ) $.
      $( Value of the group operation in a quotient group.  (Contributed by
         Mario Carneiro, 18-Sep-2015.) $)
      divsadd $p |- ( ( S e. ( NrmSGrp ` G ) /\ X e. V /\ Y e. V ) ->
  ( [ X ] ( G ~QG S ) .+b [ Y ] ( G ~QG S ) ) = [ ( X .+ Y ) ] ( G ~QG S ) ) $=
        ( vq vp va vb cfv wcel co cv cnsg cqg cgrp cqus wceq a1i cbs csubg eqid
        wer nsgsubg eqger syl subgrcl eqgcpbl wa grpcl 3expb sylan divsaddval )
        CDUAQRZDCUBSZDBAEFGHUCMNOPEDVBUDSUEVAIUFFDUGQUEVAJUFVACDUHQRZFVBUJCDUKZ
        VBDFCJVBUIZULUMVAVCDUCRZVDCDUNUMZOTPTNTZMTZAVBDFCJVEKUOVAVFVHFRZVIFRZUP
        VHVIASFRZVGVFVJVKVLFADVHVIJKUQURUSKLUT $.
    $}

    ${
      divs0.p $e |- .0. = ( 0g ` G ) $.
      $( Value of the group identity operation in a quotient group.
         (Contributed by Mario Carneiro, 18-Sep-2015.) $)
      divs0 $p |- ( S e. ( NrmSGrp ` G ) ->
        [ .0. ] ( G ~QG S ) = ( 0g ` H ) ) $=
        ( cnsg cfv wcel c0g cqg co cec cplusg wceq cbs cgrp syl eqid syl2anc wb
        csubg nsgsubg subgrcl grpidcl divsadd mpd3an23 grplid eceq1 eqtrd mpdan
        divsgrp divseccl grpid mpbid eqcomd ) ABGHIZCJHZDBAKLZMZUQUTUTCNHZLZUTO
        ZURUTOZUQVBDDBNHZLZUSMZUTUQDBPHZIZVIVBVGOUQBQIZVIUQABUBHIVJABUCABUDRZVH
        BDVHSZFUERZVMVEVAABCVHDDEVLVESZVASZUFUGUQVFDOZVGUTOUQVJVIVPVKVMVHVEBDDV
        LVNFUHTVFDUSUIRUJUQCQIUTCPHZIZVCVDUAABCEULUQVIVRVMVQABCVHDEVLVQSZUMUKVQ
        VACUTURVSVOURSUNTUOUP $.
    $}

    divsinv.v $e |- V = ( Base ` G ) $.
    ${
      divsinv.i $e |- I = ( invg ` G ) $.
      divsinv.n $e |- N = ( invg ` H ) $.
      $( Value of the group inverse operation in a quotient group.
         (Contributed by Mario Carneiro, 18-Sep-2015.) $)
      divsinv $p |- ( ( S e. ( NrmSGrp ` G ) /\ X e. V ) ->
        ( N ` [ X ] ( G ~QG S ) ) = [ ( I ` X ) ] ( G ~QG S ) ) $=
        ( cfv wcel co cec wceq cplusg c0g cgrp eqid cnsg wa cqg nsgsubg subgrcl
        csubg syl grpinvcl sylan divsadd mpd3an3 grprinv eceq1 divs0 adantr cbs
        3eqtrd wb divsgrp divseccl syldan grpinvid1 syl3anc mpbird ) ABUALMZGFM
        ZUBZGBAUCNZOZELGDLZVHOZPZVIVKCQLZNZCRLZPZVGVNGVJBQLZNZVHOZBRLZVHOZVOVEV
        FVJFMZVNVSPVEBSMZVFWBVEABUFLMWCABUDABUEUGZFBDGIJUHUIZVQVMABCFGVJHIVQTZV
        MTZUJUKVGVRVTPZVSWAPVEWCVFWHWDFVQBDGVTIWFVTTZJULUIVRVTVHUMUGVEWAVOPVFAB
        CVTHWIUNUOUQVGCSMZVICUPLZMVKWKMZVLVPURVEWJVFABCHUSUOWKABCFGHIWKTZUTVEVF
        WBWLWEWKABCFVJHIWMUTVAWKVMCEVIVKVOWMWGVOTKVBVCVD $.
    $}

    ${
      divssub.p $e |- .- = ( -g ` G ) $.
      divssub.a $e |- N = ( -g ` H ) $.
      $( Value of the group subtraction operation in a quotient group.
         (Contributed by Mario Carneiro, 18-Sep-2015.) $)
      divssub $p |- ( ( S e. ( NrmSGrp ` G ) /\ X e. V /\ Y e. V ) ->
    ( [ X ] ( G ~QG S ) N [ Y ] ( G ~QG S ) ) = [ ( X .- Y ) ] ( G ~QG S ) ) $=
        ( cfv wcel co cec cminusg wceq eqid 3adant2 w3a cqg cplusg cbs divseccl
        cnsg 3adant3 grpsubval syl2anc divsinv oveq2d csubg nsgsubg subgrcl syl
        cgrp grpinvcl sylan divsadd syld3an3 3adant1 eceq1 eqtr4d 3eqtrd ) ABUF
        MNZGFNZHFNZUAZGBAUBOZPZHVIPZEOZVJVKCQMZMZCUCMZOZVJHBQMZMZVIPZVOOZGHDOZV
        IPZVHVJCUDMZNZVKWCNZVLVPRVEVFWDVGWCABCFGIJWCSZUEUGVEVGWEVFWCABCFHIJWFUE
        TWCVOCVMEVJVKWFVOSZVMSZLUHUIVHVNVSVJVOVEVGVNVSRVFABCVQVMFHIJVQSZWHUJTUK
        VHVTGVRBUCMZOZVIPZWBVEVFVGVRFNZVTWLRVEVGWMVFVEBUPNZVGWMVEABULMNWNABUMAB
        UNUOFBVQHJWIUQURTWJVOABCFGVRIJWJSZWGUSUTVHWAWKRZWBWLRVFVGWPVEFWJBVQDGHJ
        WOWIKUHVAWAWKVIVBUOVCVD $.
    $}
  $}

  ${
    $d x ph $.  $d x .~ $.  $d x X $.  $d x Y $.
    lagsubg.1 $e |- X = ( Base ` G ) $.
    ${
      lagsubg.2 $e |- .~ = ( G ~QG Y ) $.
      lagsubg.3 $e |- ( ph -> Y e. ( SubGrp ` G ) ) $.
      lagsubg.4 $e |- ( ph -> X e. Fin ) $.
      $( Lagrange's theorem for finite groups.  Call the "order" of a group the
         cardinal number of the basic set of the group, and "index of a
         subgroup" the cardinal number of the set of left (or right, this is
         the same) cosets of this subgroup.  Then the order of the group is the
         (cardinal) product of the order of any of its subgroups by the index
         of this subgroup.  (Contributed by Mario Carneiro, 11-Jul-2014.)
         (Revised by Mario Carneiro, 12-Aug-2015.) $)
      lagsubg2 $p |- ( ph -> ( # ` X ) =
        ( ( # ` ( X /. .~ ) ) x. ( # ` Y ) ) ) $=
        ( vx chash cfv csu wcel syl wceq cfn wss ssfi syl2anc cqs cv cmul csubg
        co wer eqger qshash wa cen wbr eqgen sylan wb subgss adantr qsss sselda
        cpw elpwid hashen mpbird sumeq2dv cc pwfi sylib hashcl nn0cnd fsumconst
        cn0 3eqtr2d ) ADKLDBUAZJUBZKLZJMVLEKLZJMZVLKLVOUCUEZAJDBAECUDLNZDBUFHBC
        DEFGUGOZIUHAVLVOVNJAVMVLNZUIZVOVNPZEVMUJUKZAVRVTWCHVMBCDEFGULUMWAEQNZVM
        QNZWBWCUNAWDVTADQNZEDRZWDIAVRWGHDECFUOODESTZUPWAWFVMDRWEAWFVTIUPWAVMDAV
        LDUSZVMADBVSUQZURUTDVMSTEVMVATVBVCAVLQNZVOVDNVPVQPAWIQNZVLWIRWKAWFWLIDV
        EVFWJWIVLSTAVOAWDVOVJNWHEVGOVHVLVOJVITVK $.
    $}

    $( Lagrange theorem for Groups: the order of any subgroup of a finite group
       is a divisor of the order of the group.  (Contributed by Mario Carneiro,
       11-Jul-2014.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    lagsubg $p |- ( ( Y e. ( SubGrp ` G ) /\ X e. Fin ) ->
                    ( # ` Y ) || ( # ` X ) ) $=
      ( csubg cfv wcel cfn wa chash co cdivides cn0 wss ssfi syl2anc hashcl syl
      cz nn0zd cqg cqs cmul wbr cpw simpr pwfi sylib wer eqid eqger adantr qsss
      id subgss syl2anr dvdsmul2 simpl lagsubg2 breqtrrd ) CAEFGZBHGZIZCJFZBACU
      AKZUBZJFZVDUCKZBJFLVCVGSGVDSGVDVHLUDVCVGVCVFHGZVGMGVCBUEZHGZVFVJNVIVCVBVK
      VAVBUFZBUGUHVCBVEVABVEUIVBVEABCDVEUJZUKULUMVJVFOPVFQRTVCVDVCCHGZVDMGVBVBC
      BNVNVAVBUNBCADUOBCOUPCQRTVGVDUQPVCVEABCDVMVAVBURVLUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Elementary theory of group homomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpHom $.

  $( Extend class notation with the generator of group hom-sets. $)
  cghm $a class GrpHom $.

  ${
    $d g s t w x y $.
    $( A homomorphism of groups is a map between two structures which preserves
       the group operation.  Requiring both sides to be groups simplifies most
       theorems at the cost of complicating the theorem which pushes forward a
       group structure.  (Contributed by Stefan O'Rear, 31-Dec-2014.) $)
    df-ghm $a |- GrpHom = ( s e. Grp , t e. Grp |-> { g |
        [. ( Base ` s ) / w ]. ( g : w --> ( Base ` t ) /\
            A. x e. w A. y e. w ( g ` ( x ( +g ` s ) y ) ) =
                ( ( g ` x ) ( +g ` t ) ( g ` y ) ) ) } ) $.

    $( Lemma for group homomorphisms.  (Contributed by Stefan O'Rear,
       31-Dec-2014.) $)
    reldmghm $p |- Rel dom GrpHom $=
      ( vs vt vw vg vx vy cgrp cv cbs cfv wf cplusg co wceq wral wa wsbc df-ghm
      cab cghm reldmmpt2 ) ABGGCHZBHZIJDHZKEHZFHZAHZLJMUDJUEUDJUFUDJUCLJMNFUBOE
      UBOPCUGIJQDSTEFCBDARUA $.
  $}

  ${
    $d s t w u v f S $.  $d s t w u v f T $.  $d u v f t s X $.
    $d u v f s t .+ $.  $d u v f s t Y $.  $d u v f s t .+^ $.  $d F f u v $.
    isghm.w $e |- X = ( Base ` S ) $.
    isghm.x $e |- Y = ( Base ` T ) $.
    isghm.a $e |- .+ = ( +g ` S ) $.
    isghm.b $e |- .+^ = ( +g ` T ) $.
    $( Property of being a homomorphism of groups.  (Contributed by Stefan
       O'Rear, 31-Dec-2014.) $)
    isghm $p |- ( F e. ( S GrpHom T ) <->
        ( ( S e. Grp /\ T e. Grp ) /\ ( F : X --> Y /\ A. u e. X A. v e. X
              ( F ` ( u .+ v ) ) = ( ( F ` u ) .+^ ( F ` v ) ) ) ) ) $=
      ( vf wcel cfv wceq wral cbs cvv vs vt vw cghm co cgrp wa wf cv cplusg cab
      wsbc df-ghm elmpt2cl fvex feq2 raleq raleqbi1dv anbi12d sbcie fveq2 feq2d
      syl6eqr fveq2d eqeq1d raleqbidv syl5bb abbidv wb feq3 syl eqeq2d 2ralbidv
      oveqd eqeltri mapex mp2an simpl ss2abi ssexi ovmpt2 eleq2d fex mpan2 feq1
      adantr fveq1 oveq12d eqeq12d elab3 syl6bb biadan2 ) GEFUDUEZOZEUFOFUFOUGZ
      HIGUHZBUIZAUIZCUEZGPZWQGPZWRGPZDUEZQZAHRBHRZUGZUAUBUFUFUCUIZUBUIZSPZNUIZU
      HZWQWRUAUIZUJPZUEZXJPZWQXJPZWRXJPZXHUJPZUEZQZAXGRZBXGRZUGZUCXLSPZULZNUKZE
      FUDGBAUCUBNUAUMZUNWOWNGHIXJUHZWSXJPZXPXQDUEZQZAHRBHRZUGZNUKZOXFWOWMYNGUAU
      BEFUFUFYFYNUDHXIXJUHZYIXSQZAHRZBHRZUGZNUKXLEQZYEYSNYEYDXIXJUHZXTAYDRZBYDR
      ZUGZYTYSYCUUDUCYDXLSUOXGYDQXKUUAYBUUCXGYDXIXJUPYAUUBBXGYDXTAXGYDUQURUSUTY
      TUUAYOUUCYRYTYDHXIXJYTYDESPZHXLESVAJVCZVBYTUUBYQBYDHUUFYTXTYPAYDHUUFYTXOY
      IXSYTXNWSXJYTXMCWQWRYTXMEUJPCXLEUJVALVCVNVDVEVFVFUSVGVHXHFQZYSYMNUUGYOYHY
      RYLUUGXIIQYOYHVIUUGXIFSPZIXHFSVAKVCXIIHXJVJVKUUGYPYKBAHHUUGXSYJYIUUGXRDXP
      XQUUGXRFUJPDXHFUJVAMVCVNVLVMUSVHYGYNYHNUKZHTOZITOUUITOHUUETJESUOVOZIUUHTK
      FSUOVOHITTNVPVQYMYHNYHYLVRVSVTWAWBYMXFNGWPGTOZXEWPUUJUULUUKHITGWCWDWFXJGQ
      ZYHWPYLXEHIXJGWEUUMYKXDBAHHUUMYIWTYJXCWSXJGWGUUMXPXAXQXBDWQXJGWGWRXJGWGWH
      WIVMUSWJWKWL $.

    $( Property of a group homomorphism, similar to ~ ismhm .  (Contributed by
       Mario Carneiro, 7-Mar-2015.) $)
    isghm3 $p |- ( ( S e. Grp /\ T e. Grp ) -> ( F e. ( S GrpHom T ) <->
          ( F : X --> Y /\ A. u e. X A. v e. X
              ( F ` ( u .+ v ) ) = ( ( F ` u ) .+^ ( F ` v ) ) ) ) ) $=
      ( co wcel cgrp wa cv cfv wral cghm wf wceq isghm baib ) GEFUANOEPOFPOQHIG
      UBBRZARZCNGSUFGSUGGSDNUCAHTBHTQABCDEFGHIJKLMUDUE $.
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y T $.  $d x y X $.  $d x y Y $.
    $( A group homomorphism is only defined when the domain is a group.
       (Contributed by Stefan O'Rear, 31-Dec-2014.) $)
    ghmgrp1 $p |- ( F e. ( S GrpHom T ) -> S e. Grp ) $=
      ( vy vx cghm co wcel cgrp wa cbs cfv wf cv cplusg wceq wral isghm simplbi
      eqid simpld ) CABFGHZAIHZBIHZUBUCUDJAKLZBKLZCMDNZENZAOLZGCLUGCLUHCLBOLZGP
      EUEQDUEQJEDUIUJABCUEUFUETUFTUITUJTRSUA $.

    $( A group homomorphism is only defined when the codomain is a group.
       (Contributed by Stefan O'Rear, 31-Dec-2014.) $)
    ghmgrp2 $p |- ( F e. ( S GrpHom T ) -> T e. Grp ) $=
      ( vy vx cghm co wcel cgrp wa cbs cfv wf cv cplusg wceq wral isghm simplbi
      eqid simprd ) CABFGHZAIHZBIHZUBUCUDJAKLZBKLZCMDNZENZAOLZGCLUGCLUHCLBOLZGP
      EUEQDUEQJEDUIUJABCUEUFUETUFTUITUJTRSUA $.

    ghmf.x $e |- X = ( Base ` S ) $.
    ghmf.y $e |- Y = ( Base ` T ) $.
    $( A group homomorphism is a function.  (Contributed by Stefan O'Rear,
       31-Dec-2014.) $)
    ghmf $p |- ( F e. ( S GrpHom T ) -> F : X --> Y ) $=
      ( vy vx cghm co wcel wf cv cplusg cfv wral cgrp wa eqid wceq isghm simpld
      simprbi ) CABJKLZDECMZHNZINZAOPZKCPUGCPUHCPBOPZKUAIDQHDQZUEARLBRLSUFUKSIH
      UIUJABCDEFGUITUJTUBUDUC $.
  $}

  ${
    $d ph a b $.  $d U a b $.  $d V a b $.  $d F a b $.  $d S a b $.
    $d T a b $.  $d .+ a b $.  $d .+^ a b $.  $d X a b $.
    ghmlin.x $e |- X = ( Base ` S ) $.
    ghmlin.a $e |- .+ = ( +g ` S ) $.
    ghmlin.b $e |- .+^ = ( +g ` T ) $.
    $( A homomorphism of groups is linear.  (Contributed by Stefan O'Rear,
       31-Dec-2014.) $)
    ghmlin $p |- ( ( F e. ( S GrpHom T ) /\ U e. X /\ V e. X ) ->
      ( F ` ( U .+ V ) ) = ( ( F ` U ) .+^ ( F ` V ) ) ) $=
      ( va vb co wcel cfv wceq cv wral wa cghm cbs wf cgrp isghm simprbi simprd
      eqid oveq1 fveq2d fveq2 oveq1d eqeq12d oveq2 oveq2d rspc2v mpan9 3impb )
      FCDUANOZEHOZGHOZEGANZFPZEFPZGFPZBNZQZUSLRZMRZANZFPZVHFPZVIFPZBNZQZMHSLHSZ
      UTVATVGUSHDUBPZFUCZVPUSCUDODUDOTVRVPTMLABCDFHVQIVQUHJKUEUFUGVOVGEVIANZFPZ
      VDVMBNZQLMEGHHVHEQZVKVTVNWAWBVJVSFVHEVIAUIUJWBVLVDVMBVHEFUKULUMVIGQZVTVCW
      AVFWCVSVBFVIGEAUNUJWCVMVEVDBVIGFUKUOUMUPUQUR $.
  $}

  ${
    ghmid.y $e |- Y = ( 0g ` S ) $.
    ghmid.z $e |- .0. = ( 0g ` T ) $.
    $( A homomorphism of groups preserves the identity.  (Contributed by Stefan
       O'Rear, 31-Dec-2014.) $)
    ghmid $p |- ( F e. ( S GrpHom T ) -> ( F ` Y ) = .0. ) $=
      ( cghm co wcel cfv cplusg wceq cbs cgrp ghmgrp1 eqid grpidcl syl syl2anc
      ghmlin mpd3an23 grplid fveq2d eqtr3d wb ghmgrp2 ghmf ffvelrnd grpid mpbid
      eqcomd ) CABHIJZEDCKZUMUNUNBLKZIZUNMZEUNMZUMDDALKZIZCKZUPUNUMDANKZJZVCVAU
      PMUMAOJZVCABCPZVBADVBQZFRSZVGUSUOABDCDVBVFUSQZUOQZUAUBUMUTDCUMVDVCUTDMVEV
      GVBUSADDVFVHFUCTUDUEUMBOJUNBNKZJUQURUFABCUGUMVBVJDCABCVBVJVFVJQZUHVGUIVJU
      OBUNEVKVIGUJTUKUL $.
  $}

  ${
    ghminv.b $e |- B = ( Base ` S ) $.
    ghminv.y $e |- M = ( invg ` S ) $.
    ghminv.z $e |- N = ( invg ` T ) $.
    $( A homomorphism of groups preserves inverses.  (Contributed by Stefan
       O'Rear, 31-Dec-2014.) $)
    ghminv $p |- ( ( F e. ( S GrpHom T ) /\ X e. B ) ->
        ( F ` ( M ` X ) ) = ( N ` ( F ` X ) ) ) $=
      ( co wcel cfv wceq cplusg c0g cgrp eqid sylan adantr cghm ghmgrp1 grprinv
      wa fveq2d grpinvcl ghmlin mpd3an3 ghmid 3eqtr3d wb ghmgrp2 ghmf ffvelrnda
      cbs wf ffvelrnd grpinvid1 syl3anc mpbird eqcomd ) DBCUAKLZGALZUDZGDMZFMZG
      EMZDMZVDVFVHNZVEVHCOMZKZCPMZNZVDGVGBOMZKZDMZBPMZDMZVKVLVDVOVQDVBBQLZVCVOV
      QNBCDUBZAVNBEGVQHVNRZVQRZIUCSUEVBVCVGALZVPVKNVBVSVCWCVTABEGHIUFSZVNVJBCGD
      VGAHWAVJRZUGUHVBVRVLNVCBCDVQVLWBVLRZUITUJVDCQLZVECUOMZLVHWHLVIVMUKVBWGVCB
      CDULTVBAWHGDBCDAWHHWHRZUMZUNVDAWHVGDVBAWHDUPVCWJTWDUQWHVJCFVEVHVLWIWEWFJU
      RUSUTVA $.
  $}

  ${
    ghmsub.b $e |- B = ( Base ` S ) $.
    ghmsub.m $e |- .- = ( -g ` S ) $.
    ghmsub.n $e |- N = ( -g ` T ) $.
    $( Linearity of subtraction through a group homomorphism.  (Contributed by
       Stefan O'Rear, 31-Dec-2014.) $)
    ghmsub $p |- ( ( F e. ( S GrpHom T ) /\ U e. B /\ V e. B ) ->
      ( F ` ( U .- V ) ) = ( ( F ` U ) N ( F ` V ) ) ) $=
      ( co wcel cminusg cfv cplusg wceq eqid wa grpsubval cghm w3a cgrp ghmgrp1
      3ad2ant1 simp3 grpinvcl syl2anc ghmlin ghminv 3adant2 oveq2d eqtrd fveq2d
      syld3an3 3adant1 cbs wf ghmf ffvelrn anim12dan sylan 3impb syl 3eqtr4d )
      EBCUALMZDAMZHAMZUBZDHBNOZOZBPOZLZEOZDEOZHEOZCNOZOZCPOZLZDHFLZEOZVOVPGLZVI
      VNVOVKEOZVSLZVTVFVGVHVKAMZVNWEQVIBUCMZVHWFVFVGWGVHBCEUDUEVFVGVHUFABVJHIVJ
      RZUGUHVLVSBCDEVKAIVLRZVSRZUIUOVIWDVRVOVSVFVHWDVRQVGABCEVJVQHIWHVQRZUJUKUL
      UMVGVHWBVNQVFVGVHSZWAVMEAVLBVJFDHIWIWHJTUNUPVIVOCUQOZMZVPWMMZSZWCVTQVFVGV
      HWPVFAWMEURZWLWPBCEAWMIWMRZUSWQVGWNVHWOAWMDEUTAWMHEUTVAVBVCWMVSCVQGVOVPWR
      WJWKKTVDVE $.
  $}

  ${
    $d ph x y $.  $d F x y $.  $d S x y $.  $d T x y $.  $d .+ x y $.
    $d .+^ x y $.  $d X x y $.  $d Y x y $.
    isghmd.x $e |- X = ( Base ` S ) $.
    isghmd.y $e |- Y = ( Base ` T ) $.
    isghmd.a $e |- .+ = ( +g ` S ) $.
    isghmd.b $e |- .+^ = ( +g ` T ) $.
    isghmd.s $e |- ( ph -> S e. Grp ) $.
    isghmd.t $e |- ( ph -> T e. Grp ) $.
    isghmd.f $e |- ( ph -> F : X --> Y ) $.
    isghmd.l $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) -> ( F ` ( x .+ y ) ) =
          ( ( F ` x ) .+^ ( F ` y ) ) ) $.
    $( Deduction for a group homomorphism.  (Contributed by Stefan O'Rear,
       4-Feb-2015.) $)
    isghmd $p |- ( ph -> F e. ( S GrpHom T ) ) $=
      ( wcel co cgrp wa wf cv cfv wceq wral cghm jca ralrimivva isghm sylanbrc
      ) AFUASZGUASZUBIJHUCZBUDZCUDZDTHUEUPHUEUQHUEETUFZCIUGBIUGZUBHFGUHTSAUMUNO
      PUIAUOUSQAURBCIIRUJUICBDEFGHIJKLMNUKUL $.
  $}

  ${
    $d F s t x y $.  $d S f x y s t $.  $d T f x y s t $.
    $( A group homorphism is a monoid homorphism.  (Contributed by Stefan
       O'Rear, 7-Mar-2015.) $)
    ghmmhm $p |- ( F e. ( S GrpHom T ) -> F e. ( S MndHom T ) ) $=
      ( vx vy cghm co wcel cmnd cbs cfv cv cplusg wceq wral c0g cgrp grpmnd syl
      eqid wa wf w3a cmhm ghmgrp1 ghmgrp2 jca ghmf ghmlin 3expb ralrimivva 3jca
      ghmid ismhm sylanbrc ) CABFGHZAIHZBIHZUAAJKZBJKZCUBZDLZELZAMKZGCKVBCKVCCK
      BMKZGNZEUSODUSOZAPKZCKBPKZNZUCCABUDGHUPUQURUPAQHUQABCUEARSUPBQHURABCUFBRS
      UGUPVAVGVJABCUSUTUSTZUTTZUHUPVFDEUSUSUPVBUSHVCUSHVFVDVEABVBCVCUSVKVDTZVET
      ZUIUJUKABCVHVIVHTZVITZUMULDEUSUTVDVEABCVIVHVKVLVMVNVOVPUNUO $.

    $( Group homorphisms and monoid homomorphisms coincide.  (Thus, ` GrpHom `
       is somewhat redundant, although its stronger reverse closure properties
       are sometimes useful.)  (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    ghmmhmb $p |- ( ( S e. Grp /\ T e. Grp ) ->
        ( S GrpHom T ) = ( S MndHom T ) ) $=
      ( vf vx vy cgrp wcel wa cghm co cmhm cv ghmmhm cplusg cfv cbs eqid simpll
      simplr wf mhmf adantl wceq mhmlin 3expb adantll isghmd ex impbid2 eqrdv )
      AFGZBFGZHZCABIJZABKJZUMCLZUNGZUPUOGZABUPMUMURUQUMURHDEANOZBNOZABUPAPOZBPO
      ZVAQZVBQZUSQZUTQZUKULURRUKULURSURVAVBUPTUMVAVBABUPVCVDUAUBURDLZVAGZELZVAG
      ZHVGVIUSJUPOVGUPOVIUPOUTJUCZUMURVHVJVKVAUSUTABUPVGVIVCVEVFUDUEUFUGUHUIUJ
      $.
  $}

  ${
    ghmmulg.b $e |- B = ( Base ` G ) $.
    ghmmulg.s $e |- .x. = ( .g ` G ) $.
    ghmmulg.t $e |- .X. = ( .g ` H ) $.
    $( A homomorphism of monoids preserves group multiples.  (Contributed by
       Mario Carneiro, 14-Jun-2015.) $)
    ghmmulg $p |- ( ( F e. ( G GrpHom H ) /\ N e. ZZ /\ X e. B ) ->
        ( F ` ( N .x. X ) ) = ( N .X. ( F ` X ) ) ) $=
      ( co wcel cz cfv wceq syl syl3anc eqid eqtr3d cghm w3a cr cneg cn wa cmhm
      ghmmhm mhmmulg syl3an1 3expa an32s 3adantl2 cminusg simpl1 nnnn0 ad2antll
      cn0 simpl3 fveq2d cgrp ghmgrp1 nnz mulgcl ghminv syl2anc cbs ghmgrp2 ghmf
      wf ffvelrnd mulgneg 3eqtr4d simprl recnd negnegd oveq1d wo simp2 elznn0nn
      sylib mpjaodan ) DEFUALMZGNMZHAMZUBZGURMZGHBLZDOZGHDOZCLZPZGUCMZGUDZUEMZU
      FZWCWEWGWLWDWCWGWEWLWCWGWEWLWCDEFUGLMZWGWEWLEFDUHZABCDEFGHIJKUIUJUKULUMWF
      WPUFZWNUDZWJCLZWIWKWSWNHBLZEUNOZOZDOZXAWIWSXBDOZFUNOZOZWNWJCLZXGOZXEXAWSX
      FXIXGWSWQWNURMZWEXFXIPWSWCWQWCWDWEWPUOZWRQWOXKWFWMWNUPUQWCWDWEWPUSZABCDEF
      WNHIJKUIRUTWSWCXBAMZXEXHPXLWSEVAMZWNNMZWEXNWSWCXOXLEFDVBQZWOXPWFWMWNVCUQZ
      XMABEWNHIJVDRAEFDXCXGXBIXCSZXGSZVEVFWSFVAMZXPWJFVGOZMXAXJPWSWCYAXLEFDVHQX
      RWSAYBHDWSWCAYBDVJXLEFDAYBIYBSZVIQXMVKYBCFXGWNWJYCKXTVLRVMWSXDWHDWSWTHBLZ
      XDWHWSXOXPWEYDXDPXQXRXMABEXCWNHIJXSVLRWSWTGHBWSGWSGWFWMWOVNVOVPZVQTUTTWSW
      TGWJCYEVQTWFWDWGWPVRWCWDWEVSGVTWAWB $.
  $}

  ${
    $d F a b c $.  $d S a b c $.  $d T a b c $.  $d V a b c $.
    $( The range of a homomorphism is a subgroup.  (Contributed by Stefan
       O'Rear, 31-Dec-2014.) $)
    ghmrn $p |- ( F e. ( S GrpHom T ) -> ran F e. ( SubGrp ` T ) ) $=
      ( va vb vc co wcel cfv cbs c0 wne cv wral wa eqid syl wceq wb eleq1d cghm
      crn csubg wss cplusg cminusg ghmf frn cdm fdm cgrp ghmgrp1 grpbn0 eqnetrd
      dm0rn0 necon3bii sylib w3a ghmlin wfn ffn 3ad2ant1 grpcl syl3an1 fnfvelrn
      syl2anc eqeltrrd 3expia ralrimiv oveq2 ralrn adantr mpbird grpinvcl sylan
      wf ghminv ralrimiva oveq1 ralbidv fveq2 anbi12d ghmgrp2 issubg2 mpbir3and
      jca ) CABUAGHZCUBZBUCIHZWHBJIZUDZWHKLZDMZEMZBUEIZGZWHHZEWHNZWMBUFIZIZWHHZ
      OZDWHNZWGAJIZWJCVPZWKABCXDWJXDPZWJPZUGZXDWJCUHQWGCUIZKLWLWGXIXDKWGXEXIXDR
      XHXDWJCUJQWGAUKHZXDKLABCULZXDAXFUMQUNXIKWHKCUOUPUQWGXCFMZCIZWNWOGZWHHZEWH
      NZXMWSIZWHHZOZFXDNZWGXSFXDWGXLXDHZOZXPXRYBXPXMWMCIZWOGZWHHZDXDNZYBYEDXDWG
      YAWMXDHZYEWGYAYGURZXLWMAUEIZGZCIZYDWHYIWOABXLCWMXDXFYIPZWOPZUSYHCXDUTZYJX
      DHZYKWHHWGYAYNYGWGXEYNXHXDWJCVAQZVBWGXJYAYGYOXKXDYIAXLWMXFYLVCVDXDYJCVEVF
      VGVHVIWGXPYFSZYAWGYNYQYPXOYEEDXDCWNYCRXNYDWHWNYCXMWOVJTVKQVLVMYBXLAUFIZIZ
      CIZXQWHXDABCYRWSXLXFYRPZWSPZVQYBYNYSXDHZYTWHHWGYNYAYPVLWGXJYAUUCXKXDAYRXL
      XFUUAVNVOXDYSCVEVFVGWFVRWGYNXCXTSYPXBXSDFXDCWMXMRZWRXPXAXRUUDWQXOEWHUUDWP
      XNWHWMXMWNWOVSTVTUUDWTXQWHWMXMWSWATWBVKQVMWGBUKHWIWKWLXCURSABCWCDEWJWOWHB
      WSXGYMUUBWDQWE $.
  $}

  ${
    0ghm.z $e |- .0. = ( 0g ` N ) $.
    0ghm.b $e |- B = ( Base ` M ) $.
    $( The constant zero linear function between two groups.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    0ghm $p |- ( ( M e. Grp /\ N e. Grp ) ->
        ( B X. { .0. } ) e. ( M GrpHom N ) ) $=
      ( cgrp wcel wa csn cxp cmhm cghm cmnd grpmnd 0mhm syl2an ghmmhmb eleqtrrd
      co ) BGHZCGHZIADJKZBCLTZBCMTUABNHCNHUCUDHUBBOCOABCDEFPQBCRS $.
  $}

  ${
    $d B a b $.  $d G a b $.
    idghm.b $e |- B = ( Base ` G ) $.
    $( The identity homomorphism on a group.  (Contributed by Stefan O'Rear,
       31-Dec-2014.) $)
    idghm $p |- ( G e. Grp -> ( _I |` B ) e. ( G GrpHom G ) ) $=
      ( va vb cgrp wcel wa cid cres wf cv cplusg cfv co wceq wral cghm fvresi
      id ancli eqid grpcl syl oveqan12d adantl eqtr4d ralrimivva wf1o f1oi f1of
      3expb ax-mp jctil isghm sylanbrc ) BFGZUQUQHAAIAJZKZDLZELZBMNZOZURNZUTURN
      ZVAURNZVBOZPZEAQDAQZHURBBROGUQUQUQTUAUQVIUSUQVHDEAAUQUTAGZVAAGZHZHZVDVCVG
      VMVCAGZVDVCPUQVJVKVNAVBBUTVACVBUBZUCULAVCSUDVLVGVCPUQVJVKVEUTVFVAVBAUTSAV
      ASUEUFUGUHAAURUIUSAUJAAURUKUMUNEDVBVBBBURAACCVOVOUOUP $.
  $}

  ${
    $d S a b $.  $d X a b $.  $d F a b $.  $d T a b $.  $d V a b $.
    $d U a b $.
    resghm.u $e |- U = ( S |`s X ) $.
    $( Restriction of a homomorphism to a subgroup.  (Contributed by Stefan
       O'Rear, 31-Dec-2014.) $)
    resghm $p |- ( ( F e. ( S GrpHom T ) /\ X e. ( SubGrp ` S ) ) ->
        ( F |` X ) e. ( U GrpHom T ) ) $=
      ( va vb co wcel cfv wa cplusg cbs eqid adantl wf wceq syl fvres cghm cres
      csubg cgrp subggrp ghmgrp2 adantr wss subgss fssres syl2an ressbas2 feq2d
      ghmf mpbid cv eleq2 anbi12d biimpar simpll sselda adantrr adantrl syl3anc
      wb ghmlin ressplusg ad2antlr oveqd fveq2d subgcl adantll eqtr3d oveqan12d
      3expb 3eqtr4d syldan isghmd ) DABUAIJZEAUCKZJZLZGHCMKZBMKZCBDEUBZCNKZBNKZ
      WFOWGOZWCOWDOZWACUDJVSEACFUEPVSBUDJWAABDUFUGWBEWGWEQZWFWGWEQVSANKZWGDQEWK
      UHZWJWAABDWKWGWKOZWHUNWKEAWMUIZWKWGEDUJUKWBEWFWGWEWBWLEWFRZWAWLVSWNPZEWKC
      AFWMULSZUMUOWBGUPZWFJZHUPZWFJZLZWREJZWTEJZLZWRWTWCIZWEKZWRWEKZWTWEKZWDIZR
      WBXEXBWBWOXEXBVEWQWOXCWSXDXAEWFWRUQEWFWTUQURSUSWBXELZWRWTAMKZIZDKZWRDKZWT
      DKZWDIZXGXJXKVSWRWKJZWTWKJZXNXQRVSWAXEUTWBXCXRXDWBEWKWRWPVAVBWBXDXSXCWBEW
      KWTWPVAVCXLWDABWRDWTWKWMXLOZWIVFVDXKXMWEKZXGXNXKXMXFWEXKXLWCWRWTWAXLWCRVS
      XEEXLACVTFXTVGVHVIVJXKXMEJZYAXNRWAXEYBVSWAXCXDYBXLEAWRWTXTVKVOVLXMEDTSVMX
      EXJXQRWBXCXDXHXOXIXPWDWREDTWTEDTVNPVPVQVR $.
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y T $.  $d x y U $.  $d x y X $.
    resghm2.u $e |- U = ( T |`s X ) $.
    $( One direction of ~ resghm2b .  (Contributed by Mario Carneiro,
       13-Jan-2015.)  (Revised by Mario Carneiro, 18-Jun-2015.) $)
    resghm2 $p |- ( ( F e. ( S GrpHom U ) /\ X e. ( SubGrp ` T ) ) ->
      F e. ( S GrpHom T ) ) $=
      ( cghm co wcel csubg cfv cmhm csubmnd ghmmhm subgsubm resmhm2 syl2an cgrp
      wa wceq ghmgrp1 subgrcl ghmmhmb eleqtrrd ) DACGHIZEBJKIZSDABLHZABGHZUEDAC
      LHIEBMKIDUGIUFACDNEBOABCDEFPQUEARIBRIUHUGTUFACDUAEBUBABUCQUD $.

    $( Restriction of the codomain of a homomorphism.  (Contributed by Mario
       Carneiro, 13-Jan-2015.)  (Revised by Mario Carneiro, 18-Jun-2015.) $)
    resghm2b $p |- ( ( X e. ( SubGrp ` T ) /\ ran F C_ X ) ->
      ( F e. ( S GrpHom T ) <-> F e. ( S GrpHom U ) ) ) $=
      ( cfv wcel wa cgrp cghm co wi ghmgrp1 a1i wb cmhm wceq adantr ghmmhmb crn
      csubg wss csubmnd subgsubm resmhm2b adantl subgrcl sylan2 subggrp 3bitr4d
      sylan eleq2d expcom pm5.21ndd ) EBUBGHZDUAEUCZIZAJHZDABKLZHZDACKLZHZVAUSM
      URABDNOVCUSMURACDNOUSURVAVCPUSURIZDABQLZHZDACQLZHZVAVCURVFVHPZUSUPEBUDGHU
      QVIEBUEABCDEFUFULUGVDUTVEDURUSBJHZUTVERUPVJUQEBUHSABTUIUMVDVBVGDURUSCJHZV
      BVGRUPVKUQEBCFUJSACTUIUMUKUNUO $.
  $}

  $( The composition of group homomorphisms is a homomorphism.  (Contributed by
     Mario Carneiro, 12-Jun-2015.) $)
  ghmco $p |- ( ( F e. ( T GrpHom U ) /\ G e. ( S GrpHom T ) ) ->
      ( F o. G ) e. ( S GrpHom U ) ) $=
    ( cghm co wcel wa ccom cmhm ghmmhm syl2an cgrp wceq ghmgrp1 ghmgrp2 ghmmhmb
    mhmco syl2anr eleqtrrd ) DBCFGHZEABFGHZIDEJZACKGZACFGZUBDBCKGHEABKGHUDUEHUC
    BCDLABELABCDESMUCANHCNHUFUEOUBABEPBCDQACRTUA $.

  $( The image of a subgroup under a homomorphism.  (Contributed by Stefan
     O'Rear, 31-Dec-2014.) $)
  ghmima $p |- ( ( F e. ( S GrpHom T ) /\ U e. ( SubGrp ` S ) ) ->
      ( F " U ) e. ( SubGrp ` T ) ) $=
    ( cghm co wcel csubg cfv wa cima cres crn df-ima cress eqid resghm syl5eqel
    ghmrn syl ) DABEFGCAHIGJZDCKDCLZMZBHIZDCNUAUBACOFZBEFGUCUDGABUEDCUEPQUEBUBS
    TR $.

  ${
    $d F a b $.  $d V a b $.  $d T a b $.  $d S a b $.
    $( The inverse image of a subgroup under a homomorphism.  (Contributed by
       Stefan O'Rear, 31-Dec-2014.) $)
    ghmpreima $p |- ( ( F e. ( S GrpHom T ) /\ V e. ( SubGrp ` T ) ) ->
        ( `' F " V ) e. ( SubGrp ` S ) ) $=
      ( va vb co wcel csubg cfv wceq eqid adantr syl eqeltrd elpreima mpbir2and
      wa wb syl3anc cghm ccnv cima cbs wss wne cplusg wral cminusg cdm cnvimass
      c0 cv ghmf fdm syl5sseq c0g cgrp ghmgrp1 grpidcl ghmid subg0cl adantl wfn
      wf ffn ne0i ad2antrr simprll simprrl simpll ghmlin simplr simprlr simprrr
      grpcl subgcl expr sylbid ralrimiv simprl grpinvcl syl2anc ghminv ad2ant2r
      subginvcl ad2ant2l jca ex w3a issubg2 mpbir3and ) CABUAGHZDBIJHZRZCUBDUCZ
      AIJHZWPAUDJZUEZWPULUFZEUMZFUMZAUGJZGZWPHZFWPUHZXAAUIJZJZWPHZRZEWPUHZWOCUJ
      ZWPWRCDUKWOWRBUDJZCVEZXLWRKWMXNWNABCWRXMWRLZXMLUNMZWRXMCUONUPWOAUQJZWPHZW
      TWOXRXQWRHZXQCJZDHZWOAURHZXSWMYBWNABCUSZMZWRAXQXOXQLZUTNWOXTBUQJZDWMXTYFK
      WNABCXQYFYEYFLZVAMWNYFDHWMDBYFYGVBVCOWOCWRVDZXRXSYARSWOXNYHXPWRXMCVFNZWRX
      QDCPNQWPXQVGNWOXJEWPWOXAWPHZXAWRHZXACJZDHZRZXJWOYHYJYNSYIWRXADCPNWOYNXJWO
      YNRZXFXIYOXEFWPYOXBWPHZXBWRHZXBCJZDHZRZXEWOYPYTSZYNWOYHUUAYIWRXBDCPNMWOYN
      YTXEWOYNYTRZRZXEXDWRHZXDCJZDHZUUCYBYKYQUUDWMYBWNUUBYCVHWOYKYMYTVIZWOYNYQY
      SVJZWRXCAXAXBXOXCLZVPTUUCUUEYLYRBUGJZGZDUUCWMYKYQUUEUUKKWMWNUUBVKUUGUUHXC
      UUJABXACXBWRXOUUIUUJLZVLTUUCWNYMYSUUKDHWMWNUUBVMWOYKYMYTVNWOYNYQYSVOUUJDB
      YLYRUULVQTOWOXEUUDUUFRSZUUBWOYHUUMYIWRXDDCPNMQVRVSVTYOXIXHWRHZXHCJZDHZYOY
      BYKUUNWOYBYNYDMWOYKYMWAWRAXGXAXOXGLZWBWCYOUUOYLBUIJZJZDWMYKUUOUUSKWNYMWRA
      BCXGUURXAXOUUQUURLZWDWEWNYMUUSDHWMYKDBUURYLUUTWFWGOWOXIUUNUUPRSZYNWOYHUVA
      YIWRXHDCPNMQWHWIVSVTWOYBWQWSWTXKWJSYDEFWRXCWPAXGXOUUIUUQWKNWL $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d S x y $.  $d T x $.  $d V x $.
    $( The equalizer of two group homomorphisms is a subgroup.  (Contributed by
       Stefan O'Rear, 7-Mar-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    ghmeql $p |- ( ( F e. ( S GrpHom T ) /\ G e. ( S GrpHom T ) ) ->
        dom ( F i^i G ) e. ( SubGrp ` S ) ) $=
      ( vx vy co wcel wa cfv cminusg wral ghmmhm wceq cbs adantr eqid fveq2 syl
      cv cghm cin cdm csubg csubmnd cmhm mhmeql syl2an crab cgrp ghmgrp1 simprl
      wi grpinvcl syl2anc simprr fveq2d ghminv ad2ant2r ad2ant2lr 3eqtr4d elrab
      eqeq12d sylanbrc expr ralrimiva ralrab sylibr wb wfn wf ffn adantl fndmin
      ghmf eleq2 raleqbi1dv mpbird issubg3 mpbir2and ) CABUAGZHZDWAHZIZCDUBUCZA
      UDJHZWEAUEJHZETZAKJZJZWEHZEWELZWBCABUFGZHDWMHWGWCABCMABDMABCDUGUHWDWLWJFT
      ZCJZWNDJZNZFAOJZUIZHZEWSLZWDWHCJZWHDJZNZWTUMZEWRLXAWDXEEWRWDWHWRHZXDWTWDX
      FXDIZIZWJWRHZWJCJZWJDJZNZWTXHAUJHZXFXIWDXMXGWBXMWCABCUKPZPWDXFXDULWRAWIWH
      WRQZWIQZUNUOXHXBBKJZJZXCXQJZXJXKXHXBXCXQWDXFXDUPUQWBXFXJXRNWCXDWRABCWIXQW
      HXOXPXQQZURUSWCXFXKXSNWBXDWRABDWIXQWHXOXPXTURUTVAWQXLFWJWRWNWJNWOXJWPXKWN
      WJCRWNWJDRVCVBVDVEVFWQXDWTEFWRWNWHNWOXBWPXCWNWHCRWNWHDRVCVGVHWDWEWSNZWLXA
      VIWDCWRVJZDWRVJZYAWDWRBOJZCVKZYBWBYEWCABCWRYDXOYDQZVOPWRYDCVLSWDWRYDDVKZY
      CWCYGWBABDWRYDXOYFVOVMWRYDDVLSFWRCDVNUOWKWTEWEWSWEWSWJVPVQSVRWDXMWFWGWLIV
      IXNEWEAWIXPVSSVT $.
  $}

  ${
    $d x y z F $.  $d x y z S $.  $d x y z T $.  $d x y z U $.  $d x y z Y $.
    ghmnsgima.1 $e |- Y = ( Base ` T ) $.
    $( The image of a normal subgroup under a surjective homomorphism is
       normal.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    ghmnsgima $p |- ( ( F e. ( S GrpHom T ) /\ U e. ( NrmSGrp ` S ) /\
      ran F = Y ) -> ( F " U ) e. ( NrmSGrp ` T ) ) $=
      ( vx vy vz co wcel cnsg cfv wceq cv wral adantr syl eqid syl3anc cghm crn
      w3a csubg cplusg csg simp1 nsgsubg 3ad2ant2 ghmima syl2anc cbs wa ghmgrp1
      cima simprl wss subgss simprr sseldd grpcl ghmsub ghmlin oveq1d eqtrd wfn
      cgrp wf ghmf ffn simpl2 nsgconj fnfvima eqeltrrd ralrimivva oveq1 oveq12d
      wb eleq1d ralbidv ralrn simp3 raleqdv oveq2 ralima mpbird isnsg3 sylanbrc
      id 3bitr3d ) DABUAJKZCALMKZDUBZENZUCZDCUOZBUDMKZGOZHOZBUEMZJZWRBUFMZJZWPK
      ZHWPPZGEPZWPBLMKWOWKCAUDMKZWQWKWLWNUGZWLWKXGWNCAUHUIZABCDUJUKWOXFIOZDMZWR
      DMZWTJZXKXBJZWPKZGCPZIAULMZPZWOXOIGXQCWOXJXQKZWRCKZUMZUMZXJWRAUEMZJZXJAUF
      MZJZDMZXNWPYBYGYDDMZXKXBJZXNYBWKYDXQKZXSYGYINWOWKYAXHQZYBAVGKZXSWRXQKZYJY
      BWKYLYKABDUNRWOXSXTUPZYBCXQWRWOCXQUQZYAWOXGYOXIXQCAXQSZURRZQZWOXSXTUSZUTZ
      XQYCAXJWRYPYCSZVATYNXQABYDDYEXBXJYPYESZXBSZVBTYBYHXMXKXBYBWKXSYMYHXMNYKYN
      YTYCWTABXJDWRXQYPUUAWTSZVCTVDVEYBDXQVFZYOYFCKZYGWPKYBXQEDVHZUUEWOUUGYAWOW
      KUUGXHABDXQEYPFVIRZQXQEDVJZRYRYBWLXSXTUUFWKWLWNYAVKYNYSXJWRYCCAYEXQYPUUAU
      UBVLTXQCDYFVMTVNVOWOXEGWMPZXKWSWTJZXKXBJZWPKZHWPPZIXQPZXFXRWOUUEUUJUUOVRW
      OUUGUUEUUHUUIRZXEUUNGIXQDWRXKNZXDUUMHWPUUQXCUULWPUUQXAUUKWRXKXBWRXKWSWTVP
      UUQWIVQVSVTWARWOXEGWMEWKWLWNWBWCWOUUNXPIXQWOUUEYOUUNXPVRUUPYQUUMXOHGXQCDW
      SXLNZUULXNWPUURUUKXMXKXBWSXLXKWTWDVDVSWEUKVTWJWFGHWTWPBXBEFUUDUUCWGWH $.
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y T $.  $d x y V $.
    $( The inverse image of a normal subgroup under a homomorphism is normal.
       (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    ghmnsgpreima $p |- ( ( F e. ( S GrpHom T ) /\ V e. ( NrmSGrp ` T ) ) ->
        ( `' F " V ) e. ( NrmSGrp ` S ) ) $=
      ( vx vy co wcel cnsg cfv wa csubg cv cplusg csg wral cbs eqid syl syl3anc
      cghm ccnv cima nsgsubg ghmpreima sylan2 ghmgrp1 ad2antrr simprl simprr wb
      cgrp wfn simpll ghmf ffn elpreima mpbid simpld grpcl grpsubcl wceq ghmsub
      wf ghmlin oveq1d eqtrd simplr simprd nsgconj eqeltrd mpbir2and ralrimivva
      ffvelrnd isnsg3 sylanbrc ) CABUAGHZDBIJHZKZCUBDUCZALJHZEMZFMZANJZGZWBAOJZ
      GZVTHZFVTPEAQJZPVTAIJHVRVQDBLJHWADBUDABCDUEUFVSWHEFWIVTVSWBWIHZWCVTHZKZKZ
      WHWGWIHZWGCJZDHZWMAULHZWEWIHZWJWNVQWQVRWLABCUGUHZWMWQWJWCWIHZWRWSVSWJWKUI
      ZWMWTWCCJZDHZWMWKWTXCKZVSWJWKUJWMCWIUMZWKXDUKWMWIBQJZCVDZXEWMVQXGVQVRWLUN
      ZABCWIXFWIRZXFRZUOSZWIXFCUPSZWIWCDCUQSURZUSZWIWDAWBWCXIWDRZUTTZXAWIAWFWEW
      BXIWFRZVATWMWOWBCJZXBBNJZGZXRBOJZGZDWMWOWECJZXRYAGZYBWMVQWRWJWOYDVBXHXPXA
      WIABWECWFYAWBXIXQYARZVCTWMYCXTXRYAWMVQWJWTYCXTVBXHXAXNWDXSABWBCWCWIXIXOXS
      RZVETVFVGWMVRXRXFHXCYBDHVQVRWLVHWMWIXFWBCXKXAVNWMWTXCXMVIXRXBXSDBYAXFXJYF
      YEVJTVKWMXEWHWNWPKUKXLWIWGDCUQSVLVMEFWDVTAWFWIXIXOXQVOVP $.
  $}

  ${
    ghmker.1 $e |- .0. = ( 0g ` T ) $.
    $( The kernel of a homomorphism is a normal subgroup.  (Contributed by
       Mario Carneiro, 4-Feb-2015.) $)
    ghmker $p |- ( F e. ( S GrpHom T ) ->
        ( `' F " { .0. } ) e. ( NrmSGrp ` S ) ) $=
      ( cghm co wcel csn cnsg cfv ccnv cima cgrp ghmgrp2 syl ghmnsgpreima mpdan
      0nsg ) CABFGHZDIZBJKHZCLUAMAJKHTBNHUBABCOBDESPABCUAQR $.
  $}

  ${
    ghmeqker.b $e |- B = ( Base ` S ) $.
    ghmeqker.z $e |- .0. = ( 0g ` T ) $.
    ghmeqker.k $e |- K = ( `' F " { .0. } ) $.
    ghmeqker.m $e |- .- = ( -g ` S ) $.
    $( Two source points map to the same destination point under a group
       homomorphism iff their difference belongs to the kernel.  (Contributed
       by Stefan O'Rear, 31-Dec-2014.) $)
    ghmeqker $p |- ( ( F e. ( S GrpHom T ) /\ U e. B /\ V e. B ) ->
      ( ( F ` U ) = ( F ` V ) <-> ( U .- V ) e. K ) ) $=
      ( co wcel cfv wceq csn eqid 3ad2ant1 cghm w3a c0g ccnv cima sneqi imaeq2i
      wa csg eqtri eleq2i wfn wb cbs ghmf ffn syl fniniseg syl5bb cgrp grpsubcl
      wf ghmgrp1 syl3an1 biantrurd ghmsub eqeq1d bitr3d ghmgrp2 simp2 grpsubeq0
      ffvelrnd simp3 syl3anc 3bitrrd ) EBCUANOZDAOZHAOZUBZDHGNZFOZVTAOZVTEPZCUC
      PZQZUHZDEPZHEPZCUIPZNZWDQZWGWHQZWAVTEUDZWDRZUEZOZVSWFFWOVTFWMIRZUEWOLWQWN
      WMIWDKUFUGUJUKVSEAULZWPWFUMVPVQWRVRVPACUNPZEVBZWRBCEAWSJWSSZUOZAWSEUPUQTA
      WDVTEURUQUSVSWEWFWKVSWBWEVPBUTOVQVRWBBCEVCABGDHJMVAVDVEVSWCWJWDABCDEGWIHJ
      MWISZVFVGVHVSCUTOZWGWSOWHWSOWKWLUMVPVQXDVRBCEVITVSAWSDEVPVQWTVRXBTZVPVQVR
      VJVLVSAWSHEXEVPVQVRVMVLWSCWIWGWHWDXAWDSXCVKVNVO $.
  $}

  ${
    $d Y x a b $.  $d R x a b $.  $d I x a b $.  $d B x a b $.  $d F a b $.
    $d W x a b $.
    pwsdiagghm.y $e |- Y = ( R ^s I ) $.
    pwsdiagghm.b $e |- B = ( Base ` R ) $.
    pwsdiagghm.f $e |- F = ( x e. B |-> ( I X. { x } ) ) $.
    $( Diagonal homomorphism into a structure power.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    pwsdiagghm $p |- ( ( R e. Grp /\ I e. W ) -> F e. ( R GrpHom Y ) ) $=
      ( cgrp wcel wa cmhm co cghm cmnd grpmnd pwsdiagmhm sylan ghmmhmb eleqtrrd
      wceq pwsgrp syldan ) CKLZEFLZMDCGNOZCGPOZUFCQLUGDUHLCRABCDEFGHIJSTUFUGGKL
      UIUHUCCEFGHUDCGUAUEUB $.
  $}

  ${
    $d x y z F $.  $d x y z S $.  $d x y z T $.  $d x y z U $.  $d x y z W $.
    $d x y z X $.  $d x Y $.  $d x y z .0. $.
    ghmf1.x $e |- X = ( Base ` S ) $.
    ghmf1.y $e |- Y = ( Base ` T ) $.
    ghmf1.z $e |- .0. = ( 0g ` S ) $.
    ghmf1.u $e |- U = ( 0g ` T ) $.
    $( Two ways of saying a group homomorphism is 1-1 into its codomain.
       (Contributed by Paul Chapman, 3-Mar-2008.)  (Revised by Mario Carneiro,
       13-Jan-2015.) $)
    ghmf1 $p |- ( F e. ( S GrpHom T ) -> ( F : X -1-1-> Y <->
          A. x e. X ( ( F ` x ) = U -> x = .0. ) ) ) $=
      ( vy vz co wcel cfv wceq wa ad2antrr cghm wf1 cv wral ghmid eqeq2d simplr
      wi simpr cgrp ghmgrp1 grpidcl syl f1fveq syl12anc bitr3d biimpd ralrimiva
      wb wf ghmf adantr csg eqid ghmsub 3expb eqeq1d grpsubcl sylan fveq2 eqeq1
      adantlr imbi12d rspcv sylc sylbird ghmgrp2 simprl ffvelrnd simprr syl3anc
      grpsubeq0 3imtr3d ralrimivva dff13 sylanbrc impbida ) EBCUAOPZFGEUBZAUCZE
      QZDRZWJHRZUHZAFUDZWHWISZWNAFWPWJFPZSZWLWMWRWKHEQZRZWLWMWRWSDWKWHWSDRWIWQB
      CEHDKLUETUFWRWIWQHFPZWTWMUSWHWIWQUGWPWQUIWRBUJPZXAWHXBWIWQBCEUKZTFBHIKULU
      MFGWJHEUNUOUPUQURWHWOSZFGEUTZMUCZEQZNUCZEQZRZXFXHRZUHZNFUDMFUDWIWHXEWOBCE
      FGIJVAZVBXDXLMNFFXDXFFPZXHFPZSZSZXGXICVCQZOZDRZXFXHBVCQZOZHRZXJXKXQXTYBEQ
      ZDRZYCXQYDXSDWHXPYDXSRZWOWHXNXOYFFBCXFEYAXRXHIYAVDZXRVDZVEVFVLVGXQYBFPZWO
      YEYCUHZXDXBXPYIWHXBWOXCVBXBXNXOYIFBYAXFXHIYGVHVFVIWHWOXPUGWNYJAYBFWJYBRZW
      LYEWMYCYKWKYDDWJYBEVJVGWJYBHVKVMVNVOVPXQCUJPZXGGPXIGPXTXJUSWHYLWOXPBCEVQT
      XQFGXFEWHXEWOXPXMTZXDXNXOVRZVSXQFGXHEYMXDXNXOVTZVSGCXRXGXIDJLYHWBWAXQXBXN
      XOYCXKUSWHXBWOXPXCTYNYOFBYAXFXHHIKYGWBWAWCWDMNFGEWEWFWG $.
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y T $.  $d x y W $.  $d x y X $.
    $d x y Y $.
    ghmf1o.x $e |- X = ( Base ` S ) $.
    ghmf1o.y $e |- Y = ( Base ` T ) $.
    $( A bijective group homomorphism is an isomorphism.  (Contributed by Mario
       Carneiro, 13-Jan-2015.) $)
    ghmf1o $p |- ( F e. ( S GrpHom T ) ->
      ( F : X -1-1-onto-> Y <-> `' F e. ( T GrpHom S ) ) ) $=
      ( vx vy cghm co wcel wf1o wa cgrp cfv wceq adantr syl syl2anc ccnv cplusg
      wral ghmgrp2 ghmgrp1 jca f1ocnv adantl f1of simpll simprl ffvelrnd simprr
      wf cv ghmlin syl3anc simplr f1ocnvfv2 oveq12d eqtrd wi grpcl f1ocnvfv mpd
      eqid ralrimivva isghm sylanbrc wfn ghmf ffn dff1o4 impbida ) CABJKLZDECMZ
      CUAZBAJKLZVOVPNZBOLZAOLZNZEDVQUNZHUOZIUOZBUBPZKZVQPWDVQPZWEVQPZAUBPZKZQZI
      EUCHEUCZNVRVOWBVPVOVTWAABCUDABCUEZUFRVSWCWMVSEDVQMZWCVPWOVODECUGUHEDVQUIS
      ZVSWLHIEEVSWDELZWEELZNZNZWKCPZWGQZWLWTXAWHCPZWICPZWFKZWGWTVOWHDLZWIDLZXAX
      EQVOVPWSUJZWTEDWDVQVSWCWSWPRZVSWQWRUKZULZWTEDWEVQXIVSWQWRUMZULZWJWFABWHCW
      IDFWJVFZWFVFZUPUQWTXCWDXDWEWFWTVPWQXCWDQVOVPWSURZXJDEWDCUSTWTVPWRXDWEQXPX
      LDEWECUSTUTVAWTVPWKDLZXBWLVBXPWTWAXFXGXQWTVOWAXHWNSXKXMDWJAWHWIFXNVCUQDEW
      KWGCVDTVEVGUFIHWFWJBAVQEDGFXOXNVHVIVOVRNZCDVJZVQEVJZVPXRDECUNZXSVOYAVRABC
      DEFGVKRDECVLSXRWCXTVRWCVOBAVQEDGFVKUHEDVQVLSDECVMVIVN $.
  $}

  ${
    $d x y .- $.  $d w x y z .+ $.  $d w x y z A $.  $d w y z F $.  $d w x N $.
    $d w x y z G $.  $d w x y z S $.  $d w x y z X $.
    conjghm.x $e |- X = ( Base ` G ) $.
    conjghm.p $e |- .+ = ( +g ` G ) $.
    conjghm.m $e |- .- = ( -g ` G ) $.
    ${
      conjghm.f $e |- F = ( x e. X |-> ( ( A .+ x ) .- A ) ) $.
      $( Conjugation is an automorphism of the group.  (Contributed by Mario
         Carneiro, 13-Jan-2015.) $)
      conjghm $p |- ( ( G e. Grp /\ A e. X ) ->
        ( F e. ( G GrpHom G ) /\ F : X -1-1-onto-> X ) ) $=
        ( wcel wa co adantr syl3anc cfv wceq syl13anc oveq1d vy cgrp cghm simpl
        vz wf1o grpcl 3expa simplr grpsubcl fmptd simprl simprr grpass grpnpcan
        grpaddsubass 3eqtr2rd oveq2d 3eqtr4d oveq2 ovex fvmpt ad2antrl ad2antll
        cv syl oveq12d isghmd cminusg grpinvcl simpr wb adantrl adantrr grplcan
        eqid c0g grplinv grplid ad2ant2r eqeq2d grpsubadd 3bitr4d eqcom 3bitr4g
        3eqtr3rd f1o2d jca ) EUBLZBGLZMZDEEUCNLGGDUFWKUAUECCEEDGGHHIIWIWJUDZWLW
        KAGBAVEZCNZBFNZGDWKWMGLZMWIWNGLZWJWOGLWKWIWPWLOWIWJWPWQGCEBWMHIUGUHZWIW
        JWPUIGEFWNBHJUJPZKUKWKUAVEZGLZUEVEZGLZMZMZBWTXBCNZCNZBFNZBWTCNZBFNZBXBC
        NZBFNZCNZXFDQZWTDQZXBDQZCNXEXJBCNZXBBFNZCNZXJBXRCNZCNZXHXMXEWIXJGLZWJXR
        GLZXSYARWKWIXDWLOZXEWIXIGLZWJYBYDXEWIWJXAYEYDWIWJXDUIZWKXAXCULZGCEBWTHI
        UGPZYFGEFXIBHJUJPYFXEWIXCWJYCYDWKXAXCUMZYFGEFXBBHJUJPGCEXJBXRHIUNSXEXSX
        IXRCNZXIXBCNZBFNZXHXEXQXIXRCXEWIYEWJXQXIRYDYHYFGCEFXIBHIJUOPTXEWIYEXCWJ
        YLYJRYDYHYIYFGCEFXIXBBHIJUPSXEYKXGBFXEWIWJXAXCYKXGRYDYFYGYIGCEBWTXBHIUN
        STUQXEXLXTXJCXEWIWJXCWJXLXTRYDYFYIYFGCEFBXBBHIJUPSURUSXEXFGLZXNXHRXEWIX
        AXCYMYDYGYIGCEWTXBHIUGPAXFWOXHGDWMXFRWNXGBFWMXFBCUTTKXGBFVAVBVFXEXOXJXP
        XLCXAXOXJRWKXCAWTWOXJGDWMWTRWNXIBFWMWTBCUTTKXIBFVAVBVCXCXPXLRWKXAAXBWOX
        LGDWMXBRWNXKBFWMXBBCUTTKXKBFVAVBVDVGUSVHWKAUAGGWOBEVIQZQZWTBCNZCNZDKWSW
        KXAMZWIYOGLZYPGLZYQGLWKWIXAWLOZWKYSXAGEYNBHYNVPZVJZOYRWIXAWJYTUUAWKXAVK
        WIWJXAUIGCEWTBHIUGPZGCEYOYPHIUGPWKWPXAMZMZYQWMRZWOWTRZWMYQRWTWORUUFYQYO
        WNCNZRZYPWNRZUUGUUHUUFWIYTWQYSUUJUUKVLWKWIUUEWLOZWKXAYTWPUUDVMWKWPWQXAW
        RVNZWKYSUUEUUCOZGCEYPWNYOHIVOSUUFWMUUIYQUUFYOBCNZWMCNZEVQQZWMCNZUUIWMUU
        FUUOUUQWMCWKUUOUUQRUUEGCEYNBUUQHIUUQVPZUUBVROTUUFWIYSWJWPUUPUUIRUULUUNW
        IWJUUEUIZWKWPXAULGCEYOBWMHIUNSWIWPUURWMRWJXAGCEWMUUQHIUUSVSVTWFWAUUFWIW
        QWJXAUUHUUKVLUULUUMUUTWKWPXAUMGCEFWNBWTHIJWBSWCWMYQWDWTWOWDWEWGWH $.
    $}

    conjsubg.f $e |- F = ( x e. S |-> ( ( A .+ x ) .- A ) ) $.
    $( A conjugated subgroup is also a subgroup.  (Contributed by Mario
       Carneiro, 13-Jan-2015.) $)
    conjsubg $p |- ( ( S e. ( SubGrp ` G ) /\ A e. X ) ->
      ran F e. ( SubGrp ` G ) ) $=
      ( csubg cfv wcel wa cv co cmpt crn cima wceq subgss adantr df-ima syl6eqr
      wss cres resmpt rneqd syl5eq syl cghm wf1o cgrp subgrcl eqid sylan simpld
      conjghm simpl ghmima syl2anc eqeltrrd ) DFMNZOZBHOZPZAHBAQCRBGRZSZDUAZETZ
      VEVHDHUGZVKVLUBVFVMVGHDFIUCUDVMVKVJDUHZTVLVJDUEVMVNEVMVNADVISEAHDVIUILUFU
      JUKULVHVJFFUMROZVFVKVEOVHVOHHVJUNZVFFUOOVGVOVPPDFUPABCVJFGHIJKVJUQUTURUSV
      FVGVAFFDVJVBVCVD $.

    $( A conjugated subgroup is equinumerous to the original subgroup.
       (Contributed by Mario Carneiro, 18-Jan-2015.) $)
    conjsubgen $p |- ( ( S e. ( SubGrp ` G ) /\ A e. X ) ->
      S ~~ ran F ) $=
      ( wcel wf1o wa wf1 co cmpt syl wceq cfv crn cen wbr cv cres wss cghm cgrp
      csubg subgrcl conjghm sylan simprd f1of1 subgss adantr f1ssres syl2anc wb
      eqid resmpt syl6eqr f1eq1 mpbid f1f1orn f1oeng syldan ) DFUJUAZMZBHMZDEUB
      ZENZDVLUCUDVJVKOZDHEPZVMVNDHAHBAUECQBGQZRZDUFZPZVOVNHHVQPZDHUGZVSVNHHVQNZ
      VTVNVQFFUHQMZWBVJFUIMVKWCWBODFUKABCVQFGHIJKVQVAULUMUNHHVQUOSVJWAVKHDFIUPU
      QZHHDVQURUSVNVRETVSVOUTVNVRADVPRZEVNWAVRWETWDAHDVPVBSLVCDHVREVDSVEDHEVFSD
      VLVIEVGVH $.

    ${
      conjnmz.1 $e |- N = { y e. X |
        A. z e. X ( ( y .+ z ) e. S <-> ( z .+ y ) e. S ) } $.
      $( A subgroup is unchanged under conjugation by an element of its
         normalizer.  (Contributed by Mario Carneiro, 18-Jan-2015.) $)
      conjnmz $p |- ( ( S e. ( SubGrp ` G ) /\ A e. N ) -> S = ran F ) $=
        ( wcel co wceq syl2anc vw csubg cfv wa cv cminusg cgrp subgrcl ad2antrr
        crn wb wral crab ssrab2 eqsstri simplr sseldi eqid subgss adantr sselda
        grpinvcl wss grpass syl13anc grprinv oveq1d 3eqtr3d simpr eqeltrd grpcl
        c0g grplid syl3anc nmzbi mpbid eqeltrrd oveq2 fvmpt syl grppncan 3eqtrd
        ovex fnmpti fnfvelrn sylancr ex ssrdv wf grpaddsubass grpnpcan grpsubcl
        wfn mpbird fmptd frn eqssd ) FHUBUCQZDJQZUDZFGUJZWTUAFXAWTUAUEZFQZXBXAQ
        WTXCUDZDHUFUCZUCZXBDERZERZGUCZXBXAXDXIDXHERZDIRZXGDIRZXBXDXHFQZXIXKSXDX
        FXBERZDERZXHFXDHUGQZXFKQZXBKQZDKQZXOXHSWRXPWSXCFHUHZUIZXDXPXSXQYAXDJKDJ
        BUEZCUEZERFQYCYBERFQUKCKULZBKUMKPYDBKUNUOZWRWSXCUPZUQZKHXEDLXEURZVBTZWT
        FKXBWRFKVCWSKFHLUSUTZVAZYGKEHXFXBDLMVDVEXDDXNERZFQZXOFQZXDYLXBFXDDXFERZ
        XBERZHVLUCZXBERZYLXBXDYOYQXBEXDXPXSYOYQSYAYGKEHXEDYQLMYQURZYHVFTZVGXDXP
        XSXQXRYPYLSYAYGYIYKKEHDXFXBLMVDVEXDXPXRYRXBSYAYKKEHXBYQLMYSVMTVHWTXCVIV
        JXDWSXNKQZYMYNUKYFXDXPXQXRUUAYAYIYKKEHXFXBLMVKVNBCDXNEFJKPVOTVPVQZAXHDA
        UEZERZDIRZXKFGUUCXHSUUDXJDIUUCXHDEVRVGOXJDIWCVSVTXDXJXGDIXDYOXGERZYQXGE
        RZXJXGXDYOYQXGEYTVGXDXPXSXQXGKQZUUFXJSYAYGYIXDXPXRXSUUHYAYKYGKEHXBDLMVK
        VNZKEHDXFXGLMVDVEXDXPUUHUUGXGSYAUUIKEHXGYQLMYSVMTVHVGXDXPXRXSXLXBSYAYKY
        GKEHIXBDLMNWAVNWBXDGFWMXMXIXAQAFUUEGUUDDIWCOWDUUBFXHGWEWFVQWGWHWTFFGWIX
        AFVCWTAFUUEFGWTUUCFQZUDZUUEDUUCDIRZERZFUUKXPXSUUCKQZXSUUEUUMSWRXPWSUUJX
        TUIZUUKJKDYEWRWSUUJUPZUQZWTFKUUCYJVAZUUQKEHIDUUCDLMNWJVEUUKUUMFQZUULDER
        ZFQZUUKUUTUUCFUUKXPUUNXSUUTUUCSUUOUURUUQKEHIUUCDLMNWKVNWTUUJVIVJUUKWSUU
        LKQZUUSUVAUKUUPUUKXPUUNXSUVBUUOUURUUQKHIUUCDLNWLVNBCDUULEFJKPVOTWNVJOWO
        FFGWPVTWQ $.

      $( Alternative condition for elementhood in the normalizer.  (Contributed
         by Mario Carneiro, 18-Jan-2015.) $)
      conjnmzb $p |- ( S e. ( SubGrp ` G ) ->
        ( A e. N <-> ( A e. X /\ S = ran F ) ) ) $=
        ( wcel wceq wa co vw csubg cfv crn cv wb wral crab ssrab2 eqsstri simpr
        sseldi conjnmz jca simprl simplrr eleq2d wrex subgrcl ad3antrrr simpllr
        wss subgss ad2antrr sselda grpaddsubass syl13anc eqeq1d grpsubcl simplr
        cgrp syl3anc grplcan grpsubadd 3bitrd eqcom 3bitr4g rexbidva ovex eqeq1
        adantlrr rexbidv rnmpt elab2 risset bitrd ralrimiva sylanbrc impbida
        elnmz ) FHUBUCQZDJQZDKQZFGUDZRZSZWKWLSZWMWOWQJKDJBUEZCUEZETFQWSWRETFQUF
        CKUGZBKUHKPWTBKUIUJWKWLUKULABCDEFGHIJKLMNOPUMUNWKWPSZWMDUAUEZETZFQZXBDE
        TZFQZUFZUAKUGWLWKWMWOUOXAXGUAKXAXBKQZSZXDXCWNQZXFXIFWNXCWKWMWOXHUPUQXIX
        CDAUEZETDITZRZAFURZXKXERZAFURZXJXFWKWMXHXNXPUFWOWKWMSZXHSZXMXOAFXRXKFQZ
        SZXLXCRZXEXKRZXMXOXTYADXKDITZETZXCRZYCXBRZYBXTXLYDXCXTHVKQZWMXKKQZWMXLY
        DRWKYGWMXHXSFHUSUTZWKWMXHXSVAZXRFKXKWKFKVBWMXHKFHLVCVDVEZYJKEHIDXKDLMNV
        FVGVHXTYGYCKQZXHWMYEYFUFYIXTYGYHWMYLYIYKYJKHIXKDLNVIVLXQXHXSVJZYJKEHYCX
        BDLMVMVGXTYGYHWMXHYFYBUFYIYKYJYMKEHIXKDXBLMNVNVGVOXCXLVPXKXEVPVQVRWAWRX
        LRZAFURXNBXCWNDXBEVSWRXCRYNXMAFWRXCXLVTWBABFXLGOWCWDAXEFWEVQWFWGBCUADEF
        JKPWJWHWI $.
    $}

    $( A normal subgroup is unchanged under conjugation.  (Contributed by Mario
       Carneiro, 18-Jan-2015.) $)
    conjnsg $p |- ( ( S e. ( NrmSGrp ` G ) /\ A e. X ) -> S = ran F ) $=
      ( vy vz cnsg cfv wcel cv co wceq wb wral crab csubg isnsg4 simprbi eleq2d
      crn eqid biimpar nsgsubg conjnmz sylan syldan ) DFOPQZBHQZBMRZNRZCSDQURUQ
      CSDQUANHUBMHUCZQZDEUHTZUOUTUPUOUSHBUODFUDPQZUSHTMNCDFUSHUSUIZIJUEUFUGUJUO
      VBUTVADFUKAMNBCDEFGUSHIJKLVCULUMUN $.
  $}

  ${
    $d y z F $.  $d x y z G $.  $d x y z H $.  $d x y z X $.  $d x y z Y $.
    divsghm.x $e |- X = ( Base ` G ) $.
    divsghm.h $e |- H = ( G /s ( G ~QG Y ) ) $.
    divsghm.f $e |- F = ( x e. X |-> [ x ] ( G ~QG Y ) ) $.
    $( If ` Y ` is a normal subgroup of ` G ` , then the "natural map" from
       elements to their cosets is a group homomorphism from ` G ` to
       ` G / Y ` .  (Contributed by Mario Carneiro, 14-Jun-2015.)  (Revised by
       Mario Carneiro, 18-Sep-2015.) $)
    divsghm $p |- ( Y e. ( NrmSGrp ` G ) -> F e. ( G GrpHom H ) ) $=
      ( vy cfv wcel eqid cv co cec wceq eceq1 cvv fvmpt3i cnsg cplusg cbs csubg
      vz cgrp nsgsubg subgrcl syl divsgrp cqg divseccl fmptd divsadd 3expb ovex
      wa ecexg ax-mp ad2antrl ad2antll oveq12d grpcl sylan 3eqtr4rd isghmd ) FC
      UAKLZJUECUBKZDUBKZCDBEDUCKZGVJMZVHMZVIMZVGFCUDKLCUFLZFCUGFCUHUIZFCDHUJVGA
      EANZCFUKOZPZVJBVJFCDEVPHGVKULIUMVGJNZELZUENZELZUQZUQZVSVQPZWAVQPZVIOZVSWA
      VHOZVQPZVSBKZWABKZVIOWHBKZVGVTWBWGWIQVHVIFCDEVSWAHGVLVMUNUOWDWJWEWKWFVIVT
      WJWEQVGWBAVSVRWEEBVPVSVQRIVQSLVRSLCFUKUPVPSVQURUSZTUTWBWKWFQVGVTAWAVRWFEB
      VPWAVQRIWMTVAVBWDWHELZWLWIQVGVNWCWNVOVNVTWBWNEVHCVSWAGVLVCUOVDAWHVRWIEBVP
      WHVQRIWMTUIVEVF $.
  $}

  ${
    $d f x y J $.  $d f x y K $.  $d f x y L $.  $d f x y M $.  $d f x y ph $.
    $d x y B $.  $d x y C $.
    ghmpropd.a $e |- ( ph -> B = ( Base ` J ) ) $.
    ghmpropd.b $e |- ( ph -> C = ( Base ` K ) ) $.
    ghmpropd.c $e |- ( ph -> B = ( Base ` L ) ) $.
    ghmpropd.d $e |- ( ph -> C = ( Base ` M ) ) $.
    ghmpropd.e $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` J ) y ) = ( x ( +g ` L ) y ) ) $.
    ghmpropd.f $e |- ( ( ph /\ ( x e. C /\ y e. C ) ) ->
        ( x ( +g ` K ) y ) = ( x ( +g ` M ) y ) ) $.
    $( Group homomorphism depends only on the group attributes of structures.
       (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    ghmpropd $p |- ( ph -> ( J GrpHom K ) = ( L GrpHom M ) ) $=
      ( co cgrp wcel wa eleq2d vf cghm cv cmhm grppropd anbi12d ghmgrp1 ghmgrp2
      mhmpropd jca ghmmhmb biadan2 3bitr4g eqrdv ) AUAFGUBPZHIUBPZAFQRZGQRZSZUA
      UCZFGUDPZRZSHQRZIQRZSZUTHIUDPZRZSUTUORZUTUPRZAUSVEVBVGAUQVCURVDABCDFHJLNU
      EABCEGIKMOUEUFAVAVFUTABCDEFGHIJKLMNOUITUFVHUSVBVHUQURFGUTUGFGUTUHUJUSUOVA
      UTFGUKTULVIVEVGVIVCVDHIUTUGHIUTUHUJVEUPVFUTHIUKTULUMUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Isomorphisms of groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpIso $.
  $c ~=g $.

  $( The class of group isomorphism sets. $)
  cgim $a class GrpIso $.

  $( The class of the group isomorphism relation. $)
  cgic $a class ~=g $.

  ${
    $d g s t w x y $.

    $( An isomorphism of groups is a homomorphism which is also a bijection,
       i.e. it preserves equality as well as the group operation.  (Contributed
       by Stefan O'Rear, 21-Jan-2015.) $)
    df-gim $a |- GrpIso = ( s e. Grp , t e. Grp |-> { g e. ( s GrpHom t ) |
        g : ( Base ` s ) -1-1-onto-> ( Base ` t ) } ) $.

    $( Two groups are said to be isomorphic iff they are connected by at least
       one isomorphism.  Isomophic groups share all global group properties,
       but to relate local properties requires knowledge of a specific
       isomorphism.  (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    df-gic $a |- ~=g = ( `' GrpIso " ( _V \ 1o ) ) $.

    $( The group isomorphism function is a well-defined function.  (Contributed
       by Mario Carneiro, 23-Aug-2015.) $)
    gimfn $p |- GrpIso Fn ( Grp X. Grp ) $=
      ( vs vt vg cgrp cv cbs cfv wf1o cghm crab cgim df-gim ovex rabex fnmpt2i
      co ) ABDDAEZFGBEZFGCEHZCQRIPZJKBCALSCTQRIMNO $.
  $}

  ${
    $d F a b c $.  $d R a b c $.  $d S a b c $.  $d B a b c $.  $d C a b c $.
    $d V a b c $.
    isgim.b $e |- B = ( Base ` R ) $.
    isgim.c $e |- C = ( Base ` S ) $.
    $( An isomorphism of groups is a bijective homomorphism.  (Contributed by
       Stefan O'Rear, 21-Jan-2015.) $)
    isgim $p |- ( F e. ( R GrpIso S ) <-> ( F e. ( R GrpHom S ) /\
          F : B -1-1-onto-> C ) ) $=
      ( vc va vb cgrp wcel cv wf1o cghm co wa cbs cfv wceq crab w3a cgim df-3an
      df-gim ovex rabex oveq12 wb fveq2 syl6eqr f1oeq23 syl2an elovmpt2 ghmgrp1
      rabeqbidv ghmgrp2 jca adantr pm4.71ri f1oeq1 elrab anbi2i bitr4i 3bitr4i
      ) CKLZDKLZEABHMZNZHCDOPZUAZLZUBVFVGQZVLQZECDUCPLEVJLZABENZQZVFVGVLUDKKIMZ
      RSZJMZRSZVHNZHVRVTOPZUAUCVKECDIJJHIUEWBHWCVRVTOUFUGVRCTZVTDTZQWBVIHWCVJVR
      CVTDOUHWDVSATWABTWBVIUIWEWDVSCRSAVRCRUJFUKWEWADRSBVTDRUJGUKVSAWABVHULUMUP
      UNVQVMVQQVNVQVMVOVMVPVOVFVGCDEUOCDEUQURUSUTVLVQVMVIVPHEVJABVHEVAVBVCVDVE
      $.

    $( An isomorphism of groups is a bijection.  (Contributed by Stefan O'Rear,
       21-Jan-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    gimf1o $p |- ( F e. ( R GrpIso S ) -> F : B -1-1-onto-> C ) $=
      ( cgim co wcel cghm wf1o isgim simprbi ) ECDHIJECDKIJABELABCDEFGMN $.
  $}

  $( An isomorphism of groups is a homomorphism.  (Contributed by Stefan
     O'Rear, 21-Jan-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
  gimghm $p |- ( F e. ( R GrpIso S ) -> F e. ( R GrpHom S ) ) $=
    ( cgim co wcel cghm cbs cfv wf1o eqid isgim simplbi ) CABDEFCABGEFAHIZBHIZC
    JNOABCNKOKLM $.

  $( A group isomorphism is a homomorphism whose converse is also a
     homomorphism.  Characterization of isomorphisms similar to ~ ishmeo .
     (Contributed by Mario Carneiro, 6-May-2015.) $)
  isgim2 $p |- ( F e. ( R GrpIso S ) <-> ( F e. ( R GrpHom S ) /\
          `' F e. ( S GrpHom R ) ) ) $=
    ( cgim co wcel cghm cbs cfv wf1o wa ccnv eqid isgim ghmf1o pm5.32i bitri )
    CABDEFCABGEFZAHIZBHIZCJZKRCLBAGEFZKSTABCSMZTMZNRUAUBABCSTUCUDOPQ $.

  ${
    $d F a b c d $.  $d A a b c d $.  $d R a b c d $.  $d S a b c d $.
    $d B a b c d $.  $d V a b c d $.
    subgim.b $e |- B = ( Base ` R ) $.
    $( Behavior of subgroups under isomorphism.  (Contributed by Stefan O'Rear,
       21-Jan-2015.) $)
    subggim $p |- ( ( F e. ( R GrpIso S ) /\ A C_ B ) ->
        ( A e. ( SubGrp ` R ) <-> ( F " A ) e. ( SubGrp ` S ) ) ) $=
      ( cgim co wcel wss wa csubg cfv cima cghm gimghm adantr ghmima sylan ccnv
      wceq cbs wf1 wf1o eqid gimf1o f1of1 f1imacnv ghmpreima eqeltrrd impbida
      syl ) ECDGHIZABJZKZACLMZIZEANZDLMIZUOECDOHIZUQUSUMUTUNCDEPQZCDAERSUOUSKET
      URNZAUPUOVBAUAZUSUMBDUBMZEUCZUNVCUMBVDEUDVEBVDCDEFVDUEUFBVDEUGULBVDAEUHSQ
      UOUTUSVBUPIVACDEURUISUJUK $.
  $}

  $( The converse of a bijective group homomorphism is a bijective group
     homomorphism.  (Contributed by Stefan O'Rear, 25-Jan-2015.)  (Revised by
     Mario Carneiro, 6-May-2015.) $)
  gimcnv $p |- ( F e. ( S GrpIso T ) -> `' F e. ( T GrpIso S ) ) $=
    ( cghm co wcel ccnv wa cgim cbs cfv wceq eqid ghmf wrel dfrel2 sylib isgim2
    wf frel syl id eqeltrd anim2i ancoms 3imtr4i ) CABDEZFZCGZBADEFZHUJUIGZUGFZ
    HZCABIEFUIBAIEFUJUHUMUHULUJUHUKCUGUHAJKZBJKZCSZUKCLZABCUNUOUNMUOMNUPCOUQUNU
    OCTCPQUAUHUBUCUDUEABCRBAUIRUF $.

  $( The composition of group isomorphisms is a group isomorphism.
     (Contributed by Mario Carneiro, 21-Apr-2016.) $)
  gimco $p |- ( ( F e. ( T GrpIso U ) /\ G e. ( S GrpIso T ) ) ->
      ( F o. G ) e. ( S GrpIso U ) ) $=
    ( cgim co wcel wa ccom cghm ccnv isgim2 ghmco cnvco ancoms syl5eqel anim12i
    an4s syl2anb sylibr ) DBCFGHZEABFGHZIDEJZACKGHZUDLZCAKGZHZIZUDACFGHUBDBCKGH
    ZDLZCBKGHZIEABKGHZELZBAKGHZIUIUCBCDMABEMUJUMULUOUIUJUMIUEULUOIZUHABCDENUPUF
    UNUKJZUGDEOUOULUQUGHCBAUNUKNPQRSTACUDMUA $.

  $( The relation "is isomorphic to" for groups.  (Contributed by Stefan
     O'Rear, 25-Jan-2015.) $)
  brgic $p |- ( R ~=g S <-> ( R GrpIso S ) =/= (/) ) $=
    ( cgic cgim cgrp cxp df-gic gimfn brwitnlem ) ABCDEEFGHI $.

  $( Prove isomorphic by an explicit isomorphism.  (Contributed by Stefan
     O'Rear, 25-Jan-2015.) $)
  brgici $p |- ( F e. ( R GrpIso S ) -> R ~=g S ) $=
    ( cgim co wcel c0 wne cgic wbr ne0i brgic sylibr ) CABDEZFNGHABIJNCKABLM $.

  $( Isomorphism is reflexive.  (Contributed by Mario Carneiro,
     21-Apr-2016.) $)
  gicref $p |- ( R e. Grp -> R ~=g R ) $=
    ( cgrp wcel cid cbs cfv cres cgim co cgic wbr cghm ccnv eqid idghm cnvresid
    syl5eqel isgim2 sylanbrc brgici syl ) ABCZDAEFZGZAAHICZAAJKUBUDAALIZCUDMZUF
    CUEUCAUCNOZUBUGUDUFUCPUHQAAUDRSAAUDTUA $.

  ${
    $d x y z $.  $d f B $.  $d f C $.  $d f g R $.  $d f g S $.  $d f g T $.
    $( Isomorphism implies the left side is a group.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    giclcl $p |- ( R ~=g S -> R e. Grp ) $=
      ( vf cgic wbr cv cgim co wcel wex cgrp c0 wne brgic n0 bitri cghm ghmgrp1
      gimghm syl exlimiv sylbi ) ABDEZCFZABGHZIZCJZAKIZUCUELMUGABNCUEOPUFUHCUFU
      DABQHIUHABUDSABUDRTUAUB $.

    $( Isomorphism implies the right side is a group.  (Contributed by Mario
       Carneiro, 6-May-2015.) $)
    gicrcl $p |- ( R ~=g S -> S e. Grp ) $=
      ( vf cgic wbr cv cgim co wcel wex cgrp c0 wne brgic n0 bitri cghm ghmgrp2
      gimghm syl exlimiv sylbi ) ABDEZCFZABGHZIZCJZBKIZUCUELMUGABNCUEOPUFUHCUFU
      DABQHIUHABUDSABUDRTUAUB $.

    $( Isomorphism is symmetric.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    gicsym $p |- ( R ~=g S -> S ~=g R ) $=
      ( vf cgic wbr cgim co c0 wne brgic cv wcel wex ccnv gimcnv brgici exlimiv
      n0 syl sylbi ) ABDEABFGZHIZBADEZABJUBCKZUALZCMUCCUARUEUCCUEUDNZBAFGLUCABU
      DOBAUFPSQTT $.

    $( Isomorphism is transitive.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    gictr $p |- ( ( R ~=g S /\ S ~=g T ) -> R ~=g T ) $=
      ( vf vg cgic wbr cgim co c0 wne brgic cv wcel wex n0 eeanv ccom syl2anb
      wa gimco brgici syl ancoms exlimivv sylbir ) ABFGABHIZJKZBCHIZJKZACFGZBCF
      GABLBCLUHDMZUGNZDOZEMZUINZEOZUKUJDUGPEUIPUNUQTUMUPTZEODOUKUMUPDEQURUKDEUP
      UMUKUPUMTUOULRZACHINUKABCUOULUAACUSUBUCUDUEUFSS $.

    $( Isomorphism is an equivalence relation on groups.  (Contributed by Mario
       Carneiro, 21-Apr-2016.) $)
    gicer $p |- ~=g Er Grp $=
      ( vx vy vz cgrp cgic wer wtru wrel cxp wss cgim ccnv cvv c1o cdif cima cv
      a1i wbr adantl df-gic cdm cnvimass wceq gimfn ax-mp sseqtri eqsstri relxp
      wfn fndm relss mp2 gicsym wa gictr wcel gicref giclcl impbii iserd trud
      wb ) DEFGABCDEEHZGEDDIZJVEHVDEKLMNOZPZVEUAVGKUBZVEKVFUCKVEUJVHVEUDUEVEKUK
      UFUGUHDDUIEVEULUMRAQZBQZESZVJVIESGVIVJUNTVKVJCQZESUOVIVLESGVIVJVLUPTVIDUQ
      ZVIVIESZVCGVMVNVIURVIVIUSUTRVAVB $.

    gicen.b $e |- B = ( Base ` R ) $.
    gicen.c $e |- C = ( Base ` S ) $.
    $( Isomorphic groups have equinumerous base sets.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    gicen $p |- ( R ~=g S -> B ~~ C ) $=
      ( vf cgic wbr cgim co c0 wne cen brgic cv wcel wex cbs sylbi wf1o cfv cvv
      n0 gimf1o fvex eqeltri f1oen syl exlimiv ) CDHICDJKZLMZABNIZCDOULGPZUKQZG
      RUMGUKUDUOUMGUOABUNUAUMABCDUNEFUEABUNACSUBUCECSUFUGUHUIUJTT $.
  $}

  ${
    $d R a b c $.  $d S a b c $.  $d V a b c $.
    $( A less trivial example of a group invariant: cardinality of the subgroup
       lattice.  (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    gicsubgen $p |- ( R ~=g S -> ( SubGrp ` R ) ~~ ( SubGrp ` S ) ) $=
      ( va vb vc wbr cv wcel csubg cfv cima cvv fvex a1i imaexg ax-mp a1ii wceq
      co wa cgic cgim wex cen c0 wne brgic n0 bitri ccnv vex cghm gimghm ghmima
      cnvex sylan cbs wf1 wss wf1o eqid gimf1o f1of1 syl subgss f1imacnv syl2an
      eqcomd jca eleq1 imaeq2 eqeq2d anbi12d syl5ibrcom impr ghmpreima foimacnv
      wfo f1ofo impbida en2d exlimiv sylbi ) ABUAFZCGZABUBSZHZCUCZAIJZBIJZUDFZW
      DWFUEUFWHABUGCWFUHUIWGWKCWGDEWIWJWEDGZKZWEUJZEGZKZWILHWGAIMNWJLHWGBIMNWGW
      LWIHZWMLHZWELHWRCUKZWEWLLOPQWGWOWJHZWPLHZWNLHXAWEWSUOWNWOLOPQWGWQWOWMRZTZ
      WTWLWPRZTZWGWQXBXEWGWQTZXEXBWMWJHZWLWNWMKZRZTXFXGXIWGWEABULSHZWQXGABWEUMZ
      ABWLWEUNUPXFXHWLWGAUQJZBUQJZWEURZWLXLUSXHWLRWQWGXLXMWEUTZXNXLXMABWEXLVAZX
      MVAZVBZXLXMWEVCVDXLWLAXPVEXLXMWLWEVFVGVHVIXBWTXGXDXIWOWMWJVJXBWPXHWLWOWMW
      NVKVLVMVNVOWGWTXDXCWGWTTZXCXDWPWIHZWOWEWPKZRZTXSXTYBWGXJWTXTXKABWEWOVPUPX
      SYAWOWGXLXMWEVRZWOXMUSYAWORWTWGXOYCXRXLXMWEVSVDXMWOBXQVEXLXMWOWEVQVGVHVIX
      DWQXTXBYBWLWPWIVJXDWMYAWOWLWPWEVKVLVMVNVOVTWAWBWC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Group actions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpAct $.
  $( Extend class definition to include the class of group actions. $)
  cga $a class GrpAct $.

  ${
    $d b g m s x y z G $.  $d b g m s y z X $.  $d b g m s x y z Y $.
    $d b g m s .+ $.  $d m x y z .(+) $.  $d b g m s .0. $.
    $( Define the class of all group actions.  A group ` G ` acts on a set
       ` S ` if a permutation on ` S ` is associated with every element of
       ` G ` in such a way that the identity permutation on ` S ` is associated
       with the neutral element of ` G ` , and the composition of the
       permutations associated with two elements of ` G ` is identical with the
       permutation associated to the composition of these two elements (in the
       same order) in the group ` G ` .  (Contributed by Jeff Hankins,
       10-Aug-2009.) $)
    df-ga $a |- GrpAct = ( g e. Grp , s e. _V |-> [_ ( Base ` g ) / b ]_
      { m e. ( s ^m ( b X. s ) ) | A. x e. s ( ( ( 0g ` g ) m x ) = x /\
    A. y e. b A. z e. b ( ( y ( +g ` g ) z ) m x ) = ( y m ( z m x ) ) ) } ) $.

    isga.1 $e |- X = ( Base ` G ) $.
    isga.2 $e |- .+ = ( +g ` G ) $.
    isga.3 $e |- .0. = ( 0g ` G ) $.
    $( The predicate "is a (left) group action."  The group ` G ` is said to
       act on the base set ` Y ` of the action, which is not assumed to have
       any special properties.  There is a related notion of right group
       action, but as the Wikipedia article explains, it is not mathematically
       interesting.  The way actions are usually thought of is that each
       element ` g ` of ` G ` is a permutation of the elements of ` Y ` (see
       ~ gapm ).  Since group theory was classically about symmetry groups, it
       is therefore likely that the notion of group action was useful even in
       early group theory.  (Contributed by Jeff Hankins, 10-Aug-2009.)
       (Revised by Mario Carneiro, 13-Jan-2015.) $)
    isga $p |- ( .(+) e. ( G GrpAct Y ) <-> ( ( G e. Grp /\ Y e. _V ) /\
                 ( .(+) : ( X X. Y ) --> Y /\ A. x e. Y ( ( .0. .(+) x ) = x /\
 A. y e. X A. z e. X ( ( y .+ z ) .(+) x ) = ( y .(+) ( z .(+) x ) ) ) ) ) ) $=
      ( vm co wcel cvv wa cv wceq wral vg vs vb cga cgrp cxp cbs cfv c0g cplusg
      wf cmap crab csb df-ga elmpt2cl fvex a1i simplr id simpl fveq2d sylan9eqr
      syl6eqr xpeq12d oveq12d simpll oveq1d eqeq1d oveqd raleqbidv anbi12d ovex
      rabeqbidv csbied rabex ovmpt2a eleq2d oveq eqtrd eqeq12d 2ralbidv ralbidv
      oveq2d elrab syl6bb wb simpr eqeltri xpexg sylancr elmapg syl2anc biadan2
      anbi1d bitrd ) EFHUDNZOZFUEOZHPOZQZGHUFZHEUKZIARZENZXDSZBRZCRZDNZXDENZXGX
      HXDENZENZSZCGTBGTZQZAHTZQZUAUBUEPUCUARZUGUHZXRUIUHZXDMRZNZXDSZXGXHXRUJUHZ
      NZXDYANZXGXHXDYANZYANZSZCUCRZTZBYJTZQZAUBRZTZMYNYJYNUFZULNZUMZUNZFHUDEABC
      UAMUBUCUOZUPXAWREHXBULNZOZXPQZXQXAWREIXDYANZXDSZXIXDYANZYHSZCGTZBGTZQZAHT
      ZMUUAUMZOUUCXAWQUULEUAUBFHUEPYSUULUDXRFSZYNHSZQZUCXSYRUULPXSPOUUOXRUGUQUR
      UUOYJXSSZQZYOUUKMYQUUAUUQYNHYPXBULUUMUUNUUPUSZUUQYJGYNHUUPUUOYJXSGUUPUTUU
      OXSFUGUHZGUUOXRFUGUUMUUNVAVBJVDVCZUURVEVFUUQYMUUJAYNHUURUUQYCUUEYLUUIUUQY
      BUUDXDUUQXTIXDYAUUQXTFUIUHIUUQXRFUIUUMUUNUUPVGZVBLVDVHVIUUQYKUUHBYJGUUTUU
      QYIUUGCYJGUUTUUQYFUUFYHUUQYEXIXDYAUUQYDDXGXHUUQYDFUJUHDUUQXRFUJUVAVBKVDVJ
      VHVIVKVKVLVKVNVOYTUUKMUUAHXBULVMVPVQVRUUKXPMEUUAYAESZUUJXOAHUVBUUEXFUUIXN
      UVBUUDXEXDIXDYAEVSVIUVBUUGXMBCGGUVBUUFXJYHXLXIXDYAEVSUVBYHXGYGENXLXGYGYAE
      VSUVBYGXKXGEXHXDYAEVSWDVTWAWBVLWCWEWFXAUUBXCXPXAWTXBPOZUUBXCWGWSWTWHZXAGP
      OWTUVCGUUSPJFUGUQWIUVDGHPPWJWKHXBEPPWLWMWOWPWN $.
  $}

  ${
    $d x y z G $.  $d x y z .(+) $.  $d x y z Y $.
    $( The left argument of a group action is a group.  (Contributed by Jeff
       Hankins, 11-Aug-2009.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    gagrp $p |- ( .(+) e. ( G GrpAct Y ) -> G e. Grp ) $=
      ( vx vy vz cga co wcel cgrp cvv wa cbs cfv cxp wf cv wceq wral eqid isga
      c0g cplusg simplbi simpld ) ABCGHIZBJIZCKIZUFUGUHLBMNZCOCAPBUBNZDQZAHUKRE
      QZFQZBUCNZHUKAHULUMUKAHAHRFUISEUISLDCSLDEFUNABUICUJUITUNTUJTUAUDUE $.

    $( The right argument of a group action is a set.  (Contributed by Mario
       Carneiro, 30-Apr-2015.) $)
    gaset $p |- ( .(+) e. ( G GrpAct Y ) -> Y e. _V ) $=
      ( vx vy vz cga co wcel cgrp cvv wa cbs cfv cxp wf cv wceq wral eqid isga
      c0g cplusg simplbi simprd ) ABCGHIZBJIZCKIZUFUGUHLBMNZCOCAPBUBNZDQZAHUKRE
      QZFQZBUCNZHUKAHULUMUKAHAHRFUISEUISLDCSLDEFUNABUICUJUITUNTUJTUAUDUE $.
  $}

  ${
    $d x A $.  $d x y z G $.  $d x y z .(+) $.  $d x .0. $.  $d x y z Y $.
    gagrpid.1 $e |- .0. = ( 0g ` G ) $.
    $( The identity of the group does not alter the base set.  (Contributed by
       Jeff Hankins, 11-Aug-2009.)  (Revised by Mario Carneiro,
       13-Jan-2015.) $)
    gagrpid $p |- ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) ->
      ( .0. .(+) A ) = A ) $=
      ( vx vy vz cga co wcel cv wceq wral cplusg cfv cbs wa eqid cxp wf simprbi
      cgrp cvv isga simprd simpl ralimi syl oveq2 id eqeq12d rspccva sylan ) BC
      DJKLZEGMZBKZUQNZGDOZADLEABKZANZUPUSHMZIMZCPQZKUQBKVCVDUQBKBKNICRQZOHVFOZS
      ZGDOZUTUPVFDUADBUBZVIUPCUDLDUELSVJVISGHIVEBCVFDEVFTVETFUFUCUGVHUSGDUSVGUH
      UIUJUSVBGADUQANZURVAUQAUQAEBUKVKULUMUNUO $.
  $}

  ${
    $d x y z G $.  $d x y z .(+) $.  $d x V $.  $d x y z X $.  $d x y z Y $.
    gaf.1 $e |- X = ( Base ` G ) $.
    $( The mapping of the group action operation.  (Contributed by Jeff
       Hankins, 11-Aug-2009.)  (Revised by Mario Carneiro, 13-Jan-2015.) $)
    gaf $p |- ( .(+) e. ( G GrpAct Y ) -> .(+) : ( X X. Y ) --> Y ) $=
      ( vx vy vz cga co wcel cxp wf c0g cfv cv wceq wral wa eqid cplusg simprbi
      cgrp cvv isga simpld ) ABDIJKZCDLDAMZBNOZFPZAJUJQGPZHPZBUAOZJUJAJUKULUJAJ
      AJQHCRGCRSFDRZUGBUCKDUDKSUHUNSFGHUMABCDUIEUMTUITUEUBUF $.

    $( A group action is onto its base set.  (Contributed by Jeff Hankins,
       10-Aug-2009.)  (Revised by Mario Carneiro, 13-Jan-2015.) $)
    gafo $p |- ( .(+) e. ( G GrpAct Y ) -> .(+) : ( X X. Y ) -onto-> Y ) $=
      ( vx vy vz cga co wcel cxp wf cv wceq wrex wral wfo gaf wa c0g cgrp gagrp
      cfv adantr eqid grpidcl syl gagrpid eqcomd rspceov syl3anc ralrimiva foov
      simpr sylanbrc ) ABDIJKZCDLZDAMFNZGNHNAJOHDPGCPZFDQURDARABCDESUQUTFDUQUSD
      KZTZBUAUDZCKZVAUSVCUSAJZOUTVBBUBKZVDUQVFVAABDUCUECBVCEVCUFZUGUHUQVAUOVBVE
      USUSABDVCVGUIUJGHCDVCUSUSAUKULUMGHFCDDAUNUP $.
  $}

  ${
    $d x y z .+ $.  $d x y z .(+) $.  $d y z A $.  $d x y z C $.  $d x y z G $.
    $d z B $.  $d x y z X $.  $d x y z Y $.
    gaass.1 $e |- X = ( Base ` G ) $.
    gaass.2 $e |- .+ = ( +g ` G ) $.
    $( An "associative" property for group actions.  (Contributed by Jeff
       Hankins, 11-Aug-2009.)  (Revised by Mario Carneiro, 13-Jan-2015.) $)
    gaass $p |- ( ( .(+) e. ( G GrpAct Y ) /\ ( A e. X /\ B e. X /\ C e. Y ) )
      -> ( ( A .+ B ) .(+) C ) = ( A .(+) ( B .(+) C ) ) ) $=
      ( vy vz vx wcel co wceq cv wral wa oveq2 w3a cga wi c0g cfv cxp cgrp eqid
      wf cvv simprbi simprd simpr ralimi syl oveq2d eqeq12d oveq1 oveq1d rspc3v
      isga syl5 3coml impcom ) AGNZBGNZCHNZUAEFHUBONZABDOZCEOZABCEOZEOZPZVGVEVF
      VHVMUCVHKQZLQZDOZMQZEOZVNVOVQEOZEOZPZLGRKGRZMHRZVGVEVFUAVMVHFUDUEZVQEOVQP
      ZWBSZMHRZWCVHGHUFHEUIZWGVHFUGNHUJNSWHWGSMKLDEFGHWDIJWDUHVAUKULWFWBMHWEWBU
      MUNUOWAVMVPCEOZVNVOCEOZEOZPAVODOZCEOZAWJEOZPMKLCABHGGVQCPZVRWIVTWKVQCVPET
      WOVSWJVNEVQCVOETUPUQVNAPZWIWMWKWNWPVPWLCEVNAVODURUSVNAWJEURUQVOBPZWMVJWNV
      LWQWLVICEVOBADTUSWQWJVKAEVOBCEURUPUQUTVBVCVD $.
  $}

  ${
    $d x y z G $.
    $( The action of a group on the empty set.  (Contributed by Jeff Hankins,
       11-Aug-2009.)  (Revised by Mario Carneiro, 13-Jan-2015.) $)
    ga0 $p |- ( G e. Grp -> (/) e. ( G GrpAct (/) ) ) $=
      ( vx vy vz cgrp wcel c0 cvv wa cbs cfv cxp wf cv co wceq cplusg wral eqid
      c0g cga 0ex jctr f0 xp0 feq2i mpbir ral0 pm3.2i a1i isga sylanbrc ) AEFZU
      MGHFZIAJKZGLZGGMZATKZBNZGOUSPCNZDNZAQKZOUSGOUTVAUSGOGOPDUORCUORIZBGRZIZGA
      GUAOFUMUNUBUCVEUMUQVDUQGGGMGUDUPGGGUOUEUFUGVCBUHUIUJBCDVBGAUOGURUOSVBSURS
      UKUL $.
  $}

  ${
    $d x y z G $.  $d x y z S $.  $d x y z V $.  $d x y z X $.
    gaid.1 $e |- X = ( Base ` G ) $.
    $( The trivial action of a group on any set.  Each group element
       corresponds to the identity permutation.  (Contributed by Jeff Hankins,
       11-Aug-2009.)  (Proof shortened by Mario Carneiro, 13-Jan-2015.) $)
    gaid $p |- ( ( G e. Grp /\ S e. V ) ->
      ( 2nd |` ( X X. S ) ) e. ( G GrpAct S ) ) $=
      ( vx vy vz wcel wa c2nd cfv co wceq ovres cop df-ov op2nd eqtri syl6eq wf
      cgrp cvv cxp cres c0g cv cplusg wral elex anim2i eqid grpidcl adantr fvex
      cga vex sylan simprl simplr syl2anc simprr oveq2d simpll grpcl 3expb ovex
      3eqtr4rd ralrimivva jca ralrimiva f2ndres jctil isga sylanbrc ) BUBIZACIZ
      JZVPAUCIZJDAUDZAKVTUEZUAZBUFLZFUGZWAMZWDNZGUGZHUGZBUHLZMZWDWAMZWGWHWDWAMZ
      WAMZNZHDUIGDUIZJZFAUIZJWABAUPMIVQVSVPACUJUKVRWQWBVRWPFAVRWDAIZJZWFWOVRWCD
      IZWRWFVPWTVQDBWCEWCULZUMUNWTWRJWEWCWDKMZWDWCWDDAKOXBWCWDPKLWDWCWDKQWCWDBU
      FUOFUQZRSTURWSWNGHDDWSWGDIZWHDIZJZJZWGWDWAMZWDWMWKXGXDWRXHWDNWSXDXEUSVRWR
      XFUTZXDWRJXHWGWDKMZWDWGWDDAKOXJWGWDPKLWDWGWDKQWGWDGUQXCRSTVAXGWLWDWGWAXGX
      EWRWLWDNWSXDXEVBXIXEWRJWLWHWDKMZWDWHWDDAKOXKWHWDPKLWDWHWDKQWHWDHUQXCRSTVA
      VCXGWJDIZWRWKWDNWSVPXFXLVPVQWRVDVPXDXEXLDWIBWGWHEWIULZVEVFURXIXLWRJWKWJWD
      KMZWDWJWDDAKOXNWJWDPKLWDWJWDKQWJWDWGWHWIVGXCRSTVAVHVIVJVKDAVLVMFGHWIWABDA
      WCEXMXAVNVO $.
  $}

  ${
    $d u v w F $.  $d u v w x y G $.  $d u v w x y X $.  $d u v w x y Y $.
    $d u v w H $.  $d x y .+ $.
    subgga.1 $e |- X = ( Base ` G ) $.
    subgga.2 $e |- .+ = ( +g ` G ) $.
    subgga.3 $e |- H = ( G |`s Y ) $.
    subgga.4 $e |- F = ( x e. Y , y e. X |-> ( x .+ y ) ) $.
    $( A subgroup acts on its parent group.  (Contributed by Jeff Hankins,
       13-Aug-2009.)  (Proof shortened by Mario Carneiro, 13-Jan-2015.) $)
    subgga $p |- ( Y e. ( SubGrp ` G ) -> F e. ( H GrpAct X ) ) $=
      ( vv vw cfv wcel wa co wceq wral vu csubg cgrp cvv cbs cxp c0g cplusg cga
      wf subggrp fvex eqeltri jctir subgrcl adantr subgss sselda adantrr simprr
      cv grpcl syl3anc ralrimivva fmpt2 sylib subgbas xpeq1d feq2d eqid subg0cl
      mpbid oveq12 ovex ovmpt2a sylan oveq1d grplid 3eqtr3d ad2antrr wss simprl
      subg0 sseldd simplr grpass syl13anc syl2anc eqtr4d subgcl adantlr 3eqtr4d
      3expb oveq2d ressplusg oveqd eqeq1d raleqbidv biimpa syldan jca ralrimiva
      isga sylanbrc ) HEUBOZPZFUCPZGUDPZQFUEOZGUFZGDUJZFUGOZUAVAZDRZXMSZMVAZNVA
      ZFUHOZRZXMDRZXPXQXMDRZDRZSZNXITZMXITZQZUAGTZQDFGUIRPXFXGXHHEFKUKGEUEOUDIE
      UEULUMUNXFXKYGXFHGUFZGDUJZXKXFAVAZBVAZCRZGPZBGTAHTYIXFYMABHGXFYJHPZYKGPZQ
      ZQEUCPZYJGPZYOYMXFYQYPHEUOZUPXFYNYRYOXFHGYJGHEIUQZURUSXFYNYOUTGCEYJYKIJVB
      VCVDABHGYLGDLVEVFXFYHXJGDXFHXIGHEFKVGZVHVIVLXFYFUAGXFXMGPZQZXOYEUUCEUGOZX
      MDRZUUDXMCRZXNXMXFUUDHPUUBUUEUUFSHEUUDUUDVJZVKABUUDXMHGYLUUFDYJUUDYKXMCVM
      LUUDXMCVNVOVPXFUUEXNSUUBXFUUDXLXMDHEFUUDKUUGWCVQUPXFYQUUBUUFXMSYSGCEXMUUD
      IJUUGVRVPVSXFUUBXPXQCRZXMDRZYBSZNHTZMHTZYEUUCUUJMNHHUUCXPHPZXQHPZQZQZUUHX
      MCRZXPXQXMCRZDRZUUIYBUUPUUQXPUURCRZUUSUUPYQXPGPXQGPZUUBUUQUUTSXFYQUUBUUOY
      SVTZUUPHGXPXFHGWAUUBUUOYTVTZUUCUUMUUNWBZWDUUPHGXQUVCUUCUUMUUNUTZWDZXFUUBU
      UOWEZGCEXPXQXMIJWFWGUUPUUMUURGPZUUSUUTSUVDUUPYQUVAUUBUVHUVBUVFUVGGCEXQXMI
      JVBVCABXPUURHGYLUUTDYJXPYKUURCVMLXPUURCVNVOWHWIUUPUUHHPZUUBUUIUUQSXFUUOUV
      IUUBXFUUMUUNUVICHEXPXQJWJWMWKUVGABUUHXMHGYLUUQDYJUUHYKXMCVMLUUHXMCVNVOWHU
      UPYAUURXPDUUPUUNUUBYAUURSUVEUVGABXQXMHGYLUURDYJXQYKXMCVMLXQXMCVNVOWHWNWLV
      DXFUULYEXFUUKYDMHXIUUAXFUUJYCNHXIUUAXFUUIXTYBXFUUHXSXMDXFCXRXPXQHCEFXEKJW
      OWPVQWQWRWRWSWTXAXBXAUAMNXRDFXIGXLXIVJXRVJXLVJXCXD $.
  $}

  ${
    $d u v x y z G $.  $d u v x y z V $.  $d u v x y z X $.  $d u v x y z Y $.
    $d u v x y z .(+) $.  $d u v x y z Z $.
    gass.1 $e |- X = ( Base ` G ) $.
    $( A subset of a group action is a group action iff it is closed under the
       group action operation.  (Contributed by Mario Carneiro,
       17-Jan-2015.) $)
    gass $p |- ( ( .(+) e. ( G GrpAct Y ) /\ Z C_ Y ) ->
      ( ( .(+) |` ( X X. Z ) ) e. ( G GrpAct Z ) <->
        A. x e. X A. y e. Z ( x .(+) y ) e. Z ) ) $=
      ( vz vu vv co wcel wa cv wral wceq ovres ad2antrr syl2anc cga cres adantl
      wss cxp wf gaf fovrnda eqeltrrd ralrimivva cvv c0g cfv cplusg gagrp gaset
      cgrp adantr simpr ssexd jca wfn ffn simplr xpss2 fnssres ralbidva ralbiia
      syl eleq1d sylibr ffnov sylanbrc eqid grpidcl sylan sselda simpll gagrpid
      syldan eqtrd simprl simprr gaass syl13anc simpllr proplem2 syl21anc grpcl
      eqtr4d syl3anc oveq2d 3eqtr4d ralrimiva isga impbida ) CDFUALMZGFUDZNZCEG
      UEZUBZDGUALMZAOZBOZCLZGMZBGPZAEPZWSXBNZXFABEGXIXCEMZXDGMNZNXCXDXALZXEGXKX
      LXEQXIXCXDEGCRZUCXIXCXDGEGXAXBWTGXAUFZWSXADEGHUGUCUHUIUJWSXHNZDUQMZGUKMZN
      XNDULUMZIOZXALZXSQZJOZKOZDUNUMZLZXSXALZYBYCXSXALZXALZQZKEPJEPZNZIGPZNXBXO
      XPXQWQXPWRXHCDFUOSZWSXQXHWSGFUKWQFUKMWRCDFUPURWQWRUSUTURVAXOXNYLXOXAWTVBZ
      XLGMZBGPZAEPZXNXOCEFUEZVBZWTYRUDZYNXOYRFCUFZYSWQUUAWRXHCDEFHUGSYRFCVCVIXO
      WRYTWQWRXHVDZGFEVEVIYRWTCVFTXOXHYQWSXHUSYPXGAEXJYOXFBGXKXLXEGXMVJVGVHVKAB
      EGGXAVLVMXOYKIGXOXSGMZNZYAYJUUDXTXRXSCLZXSXOXREMZUUCXTUUEQXOXPUUFYMEDXRHX
      RVNZVOVIXRXSEGCRVPXOUUCXSFMZUUEXSQZXOGFXSUUBVQZXOWQUUHUUIWQWRXHVRZXSCDFXR
      UUGVSVPVTWAUUDYIJKEEUUDYBEMZYCEMZNZNZYEXSCLZYBYCXSCLZXALZYFYHUUOUUPYBUUQC
      LZUURUUOWQUULUUMUUHUUPUUSQXOWQUUCUUNUUKSUUDUULUUMWBZUUDUULUUMWCZUUDUUHUUN
      UUJURYBYCXSYDCDEFHYDVNZWDWEUUOUULUUQGMZUURUUSQUUTUUOUUMUUCXHUVCUVAXOUUCUU
      NVDZWSXHUUCUUNWFABEGGCYCXSWGWHYBUUQEGCRTWJUUOYEEMZUUCYFUUPQUUOXPUULUUMUVE
      XOXPUUCUUNYMSUUTUVAEYDDYBYCHUVBWIWKUVDYEXSEGCRTUUOYGUUQYBXAUUOUUMUUCYGUUQ
      QUVAUVDYCXSEGCRTWLWMUJVAWNVAIJKYDXADEGXRHUVBUUGWOVMWP $.
  $}

  ${
    $d x y z G $.  $d x y z H $.  $d x y z S $.  $d x y z V $.  $d x y z Y $.
    $d x y z .(+) $.
    gasubg.1 $e |- H = ( G |`s S ) $.
    $( The restriction of a group action to a subgroup is a group action.
       (Contributed by Mario Carneiro, 17-Jan-2015.) $)
    gasubg $p |- ( ( .(+) e. ( G GrpAct Y ) /\ S e. ( SubGrp ` G ) ) ->
      ( .(+) |` ( S X. Y ) ) e. ( H GrpAct Y ) ) $=
      ( vx vy vz co wcel cfv wa cxp wceq eqid adantr syl syl2anc ovres cga cgrp
      csubg cvv cbs cres wf c0g cv cplusg wral gaset subggrp anim12ci wss simpr
      gaf subgss xpss1 fssres subgbas xpeq1d feq2d mpbid subg0cl oveq1d gagrpid
      subg0 adantlr 3eqtr3d eqimss2 sselda simprl ad2antrr simprr sseldd fovrnd
      anim12dan ad3antlr oveq2d simplll gaass syl13anc 3eqtr4d subgcl ressplusg
      3expb sylan oveqd 3eqtr2rd syldan ralrimivva jca ralrimiva isga sylanbrc
      ) ACEUAJKZBCUCLZKZMZDUBKZEUDKZMDUELZENZEABENZUFZUGZDUHLZGUIZXFJZXIOZHUIZI
      UIZDUJLZJZXIXFJZXLXMXIXFJZXFJZOZIXCUKHXCUKZMZGEUKZMXFDEUAJKWQXBWSXAACEULB
      CDFUMUNWTXGYBWTXEEXFUGZXGWTCUELZENZEAUGZXEYEUOZYCWQYFWSACYDEYDPZUQQZWTBYD
      UOZYGWTWSYJWQWSUPZYDBCYHURZRBYDEUSRYEEXEAUTSWTXEXDEXFWTBXCEWTWSBXCOZYKBCD
      FVARZVBVCVDWTYAGEWTXIEKZMZXKXTYPCUHLZXIXFJZYQXIAJZXJXIYPYQBKZYOYRYSOYPWSY
      TWTWSYOYKQZBCYQYQPZVERWTYOUPZYQXIBEATSYPYQXHXIXFYPWSYQXHOUUABCDYQFUUBVHRV
      FWQYOYSXIOWSXIACEYQUUBVGVIVJYPXSHIXCXCYPXLXCKZXMXCKZMXLBKZXMBKZMZXSYPUUDU
      UFUUEUUGYPXCBXLWTXCBUOZYOWTYMUUIYNXCBVKRQZVLYPXCBXMUUJVLVRYPUUHMZXRXLXMCU
      JLZJZXIAJZUUMXIXFJZXPUUKXLXMXIAJZXFJZXLUUPAJZXRUUNUUKUUFUUPEKUUQUUROYPUUF
      UUGVMZUUKXMXIEYDEAWTYFYOUUHYIVNUUKBYDXMWSYJWQYOUUHYLVSZYPUUFUUGVOZVPZYPYO
      UUHUUCQZVQXLUUPBEATSUUKXQUUPXLXFUUKUUGYOXQUUPOUVAUVCXMXIBEATSVTUUKWQXLYDK
      XMYDKYOUUNUUROWQWSYOUUHWAUUKBYDXLUUTUUSVPUVBUVCXLXMXIUULACYDEYHUULPZWBWCW
      DUUKUUMBKZYOUUOUUNOYPWSUUHUVEUUAWSUUFUUGUVEUULBCXLXMUVDWEWGWHUVCUUMXIBEAT
      SUUKUUMXOXIXFUUKUULXNXLXMWSUULXNOWQYOUUHBUULCDWRFUVDWFVSWIVFWJWKWLWMWNWMG
      HIXNXFDXCEXHXCPXNPXHPWOWP $.
  $}

  ${
    $d x y G $.  $d x y .+ $.  $d x y X $.
    gaid2.1 $e |- X = ( Base ` G ) $.
    gaid2.2 $e |- .+ = ( +g ` G ) $.
    gaid2.3 $e |- F = ( x e. X , y e. X |-> ( x .+ y ) ) $.
    $( A group operation is a left group action of the group on itself.
       (Contributed by FL, 17-May-2010.)  (Revised by Mario Carneiro,
       13-Jan-2015.) $)
    gaid2 $p |- ( G e. Grp -> F e. ( G GrpAct X ) ) $=
      ( cgrp wcel cress co cga csubg cfv subgid eqid subgga syl ressid eleqtrd
      oveq1d ) EJKZDEFLMZFNMZEFNMUDFEOPKDUFKFEGQABCDEUEFFGHUERISTUDUEEFNFEJGUAU
      CUB $.
  $}

  ${
    galcan.1 $e |- X = ( Base ` G ) $.
    $( The action of a particular group element is left-cancelable.
       (Contributed by FL, 17-May-2010.)  (Revised by Mario Carneiro,
       13-Jan-2015.) $)
    galcan $p |- ( ( .(+) e. ( G GrpAct Y ) /\
        ( A e. X /\ B e. Y /\ C e. Y ) ) ->
      ( ( A .(+) B ) = ( A .(+) C ) <-> B = C ) ) $=
      ( wcel wceq cfv oveq2 eqid syl2anc oveq1d gaass syl13anc gagrpid 3eqtr3d
      co cga w3a wa cminusg cplusg c0g cgrp simpl gagrp simpr1 grplinv grpinvcl
      syl simpr2 simpr3 eqeq12d syl5ib impbid1 ) DEGUATIZAFIZBGIZCGIZUBZUCZABDT
      ZACDTZJZBCJZVGAEUDKZKZVEDTZVJVFDTZJVDVHVEVFVJDLVDVKBVLCVDVJAEUEKZTZBDTZEU
      FKZBDTZVKBVDVNVPBDVDEUGIZUTVNVPJVDUSVRUSVCUHZDEGUIUMZUSUTVAVBUJZFVMEVIAVP
      HVMMZVPMZVIMZUKNZOVDUSVJFIZUTVAVOVKJVSVDVRUTWFVTWAFEVIAHWDULNZWAUSUTVAVBU
      NZVJABVMDEFGHWBPQVDUSVAVQBJVSWHBDEGVPWCRNSVDVNCDTZVPCDTZVLCVDVNVPCDWEOVDU
      SWFUTVBWIVLJVSWGWAUSUTVAVBUOZVJACVMDEFGHWBPQVDUSVBWJCJVSWKCDEGVPWCRNSUPUQ
      BCADLUR $.

    gacan.2 $e |- N = ( invg ` G ) $.
    $( Group inverses cancel in a group action.  (Contributed by Jeff Hankins,
       11-Aug-2009.)  (Revised by Mario Carneiro, 13-Jan-2015.) $)
    gacan $p |- ( ( .(+) e. ( G GrpAct Y ) /\ ( A e. X /\ B e. Y /\ C e. Y ) )
      -> ( ( A .(+) B ) = C <-> ( ( N ` A ) .(+) C ) = B ) ) $=
      ( cga co wcel w3a wceq cfv adantr eqid syl2anc syl13anc cplusg cgrp gagrp
      wa c0g simpr1 grprinv oveq1d simpl grpinvcl simpr3 gagrpid 3eqtr3d eqeq2d
      gaass wb simpr2 cxp wf gaf fovrnd galcan bitr3d eqcom syl6bb ) DEHKLMZAGM
      ZBHMZCHMZNZUDZABDLZCOZBAFPZCDLZOZVOBOVKVLAVODLZOZVMVPVKVQCVLVKAVNEUAPZLZC
      DLZEUEPZCDLZVQCVKVTWBCDVKEUBMZVGVTWBOVFWDVJDEHUCQZVFVGVHVIUFZGVSEFAWBIVSR
      ZWBRZJUGSUHVKVFVGVNGMZVIWAVQOVFVJUIZWFVKWDVGWIWEWFGEFAIJUJSZVFVGVHVIUKZAV
      NCVSDEGHIWGUOTVKVFVIWCCOWJWLCDEHWBWHULSUMUNVKVFVGVHVOHMVRVPUPWJWFVFVGVHVI
      UQVKVNCHGHDVFGHURHDUSVJDEGHIUTQWKWLVAABVODEGHIVBTVCBVOVDVE $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y .(+) $.  $d x y V $.  $d x y X $.
    $d x y Y $.
    gapm.1 $e |- X = ( Base ` G ) $.
    gapm.2 $e |- F = ( x e. Y |-> ( A .(+) x ) ) $.
    $( The action of a particular group element is a permutation of the base
       set.  (Contributed by Jeff Hankins, 11-Aug-2009.)  (Proof shortened by
       Mario Carneiro, 13-Jan-2015.) $)
    gapm $p |- ( ( .(+) e. ( G GrpAct Y ) /\ A e. X ) ->
      F : Y -1-1-onto-> Y ) $=
      ( vy co wcel wa cv cfv ad2antrr simplr simpr fovrnd wceq cga cminusg cgrp
      cxp wf gagrp eqid grpinvcl syl2anc wb simpll simprl simprr gacan syl13anc
      gaf bicomd eqcom 3bitr4g f1o2d ) CEGUAKLZBFLZMZAJGGBANZCKZBEUBOZOZJNZCKZD
      IVCVDGLZMBVDGFGCVAFGUDGCUEZVBVJCEFGHUPZPVAVBVJQVCVJRSVCVHGLZMZVGVHGFGCVAV
      KVBVMVLPVNEUCLZVBVGFLVAVOVBVMCEGUFPVAVBVMQFEVFBHVFUGZUHUIVCVMRSVCVJVMMZMZ
      VIVDTZVEVHTZVDVITVHVETVRVTVSVRVAVBVJVMVTVSUJVAVBVQUKVAVBVQQVCVJVMULVCVJVM
      UMBVDVHCEVFFGHVPUNUOUQVDVIURVHVEURUSUT $.
  $}

  ${
    $d g h x y A $.  $d g h x y B $.  $d f h k u v w G $.  $d f h k u v w .~ $.
    $d f g h k u v w x y .(+) $.  $d f g h k x y X $.  $d f h k u v w x y Y $.
    $d h k u v w V $.
    gaorb.1 $e |- .~ = { <. x , y >. |
      ( { x , y } C_ Y /\ E. g e. X ( g .(+) x ) = y ) } $.
    $( The orbit equivalence relation puts two points in the group action in
       the same equivalence class iff there is a group element that takes one
       element to the other.  (Contributed by Mario Carneiro, 14-Jan-2015.) $)
    gaorb $p |- ( A .~ B <->
      ( A e. Y /\ B e. Y /\ E. h e. X ( h .(+) A ) = B ) ) $=
      ( wbr wcel wa cv co wceq wrex copab vex w3a wb oveq2 eqeq12 sylan rexbidv
      oveq1 eqeq1d cbvrexv syl6bb cpr prss anbi1i opabbii eqtr4i brab2ga df-3an
      wss bitr4i ) CDFLCJMZDJMZNHOZCEPZDQZHIRZNUTVAVEUAGOZAOZEPZBOZQZGIRZVEABCD
      JJFVGCQZVIDQZNZVKVFCEPZDQZGIRVEVNVJVPGIVLVHVOQVMVJVPUBVGCVFEUCVHVOVIDUDUE
      UFVPVDGHIVFVBQVOVCDVFVBCEUGUHUIUJFVGVIUKJURZVKNZABSVGJMVIJMNZVKNZABSKVTVR
      ABVSVQVKVGVIJATBTULUMUNUOUPUTVAVEUQUS $.

    gaorber.2 $e |- X = ( Base ` G ) $.
    $( The orbit equivalence relation is an equivalence relation on the target
       set of the group action.  (Contributed by NM, 11-Aug-2009.)  (Revised by
       Mario Carneiro, 13-Jan-2015.) $)
    gaorber $p |- ( .(+) e. ( G GrpAct Y ) -> .~ Er Y ) $=
      ( vk vh co wcel cv wceq wrex wa wbr gaorb vu vv cga wrel cpr wss relopabi
      vw vf a1i w3a simpr sylib simp2d simp1d simp3d cminusg cfv wb simpll eqid
      adantr gacan syl13anc wi cgrp gagrp grpinvcl sylan oveq1 eqeq1d rspcev ex
      syl sylbid rexlimdva mpd syl3anbrc adantrr simprr reeanv ad2antrr simprlr
      cplusg simprll grpcl syl3anc gaass simprrl oveq2d simprrr expr rexlimdvva
      3eqtrd syl2anc syl5bir mp2and c0g grpidcl gagrpid pm4.71rd df-3an anbi2ci
      anidm bitri syl6bbr iserd ) CFHUCMNZUAUBUHHDDUDXHAOZBOZUEHUFEOXICMXJPEGQR
      ABDIUGUJXHUAOZUBOZDSZRZXLHNZXKHNZKOZXLCMZXKPZKGQZXLXKDSXNXPXOLOZXKCMZXLPZ
      LGQZXNXMXPXOYDUKXHXMULABXKXLCDELGHITUMZUNZXNXPXOYDYEUOZXNYDXTXNXPXOYDYEUP
      ZXNYCXTLGXNYAGNZRZYCYAFUQURZURZXLCMZXKPZXTYJXHYIXPXOYCYNUSXHXMYIUTXNYIULX
      NXPYIYGVBXNXOYIYFVBYAXKXLCFYKGHJYKVAZVCVDYJYLGNZYNXTVEXNFVFNZYIYPXHYQXMCF
      HVGZVBGFYKYAJYOVHVIYPYNXTXSYNKYLGXQYLPXRYMXKXQYLXLCVJVKVLVMVNVOVPVQABXLXK
      CDEKGHITVRXHXMXLUHOZDSZRZRZXPYSHNZUIOZXKCMZYSPZUIGQZXKYSDSXHXMXPYTYGVSZUU
      BXOUUCXRYSPZKGQZUUBYTXOUUCUUJUKXHXMYTVTABXLYSCDEKGHITUMZUNUUBYDUUJUUGXHXM
      YDYTYHVSUUBXOUUCUUJUUKUPYDUUJRYCUUIRZKGQLGQUUBUUGYCUUILKGGWAUUBUULUUGLKGG
      UUBYIXQGNZRZUULUUGUUBUUNUULRZRZXQYAFWDURZMZGNZUURXKCMZYSPZUUGUUPYQUUMYIUU
      SXHYQUUAUUOYRWBUUBYIUUMUULWCZUUBYIUUMUULWEZGUUQFXQYAJUUQVAZWFWGUUPUUTXQYB
      CMZXRYSUUPXHUUMYIXPUUTUVEPXHUUAUUOUTUVBUVCUUBXPUUOUUHVBXQYAXKUUQCFGHJUVDW
      HVDUUPYBXLXQCUUBUUNYCUUIWIWJUUBUUNYCUUIWKWNUUFUVAUIUURGUUDUURPUUEUUTYSUUD
      UURXKCVJVKVLWOWLWMWPWQABXKYSCDEUIGHITVRXHXPXPXPYBXKPZLGQZUKZXKXKDSXHXPUVG
      XPRZUVHXHXPUVGXHXPUVGXHXPRZFWRURZGNZUVKXKCMZXKPZUVGUVJYQUVLXHYQXPYRVBGFUV
      KJUVKVAZWSVNXKCFHUVKUVOWTUVFUVNLUVKGYAUVKPYBUVMXKYAUVKXKCVJVKVLWOVMXAUVHX
      PXPRZUVGRUVIXPXPUVGXBUVPXPUVGXPXDXCXEXFABXKXKCDELGHITXFXG $.
  $}

  ${
    $d a b g h k s w x y z .~ $.  $d a b g h k s u w x y z .(+) $.  $d x y H $.
    $d a b g h k s u w x y z A $.  $d a b g h k s u w x y z G $.  $d g s x S $.
    $d g k s u x B $.  $d a b g h s w x y z V $.  $d a b g h k s u w x y z X $.
    $d a b h w z F $.  $d a h k w z O $.  $d a b g h k s w x y z Y $.
    $d u C $.
    gasta.1 $e |- X = ( Base ` G ) $.
    gasta.2 $e |- H = { u e. X | ( u .(+) A ) = A } $.
    $( The stabilizer subgroup in a group action.  (Contributed by Mario
       Carneiro, 15-Jan-2015.) $)
    gastacl $p |- ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) ->
      H e. ( SubGrp ` G ) ) $=
      ( vx vy co wcel wa cfv wceq syl oveq1 eqeq1d elrab2 cga wss c0 wne cplusg
      csubg cv wral cminusg crab ssrab2 eqsstri a1i c0g cgrp gagrp eqid grpidcl
      adantr gagrpid ne0i simpll simpr sylib simpld adantrr simprr grpcl simplr
      sylanbrc syl3anc syl13anc simprd oveq2d 3eqtrd anassrs ralrimiva grpinvcl
      gaass syl2anc wb gacan mpbid jca w3a issubg2 mpbir3and ) CDGUALMZBGMZNZED
      UFOMZEFUBZEUCUDZJUGZKUGZDUEOZLZEMZKEUHZWNDUIOZOZEMZNZJEUHZWLWJEAUGZBCLZBP
      ZAFUJFIXGAFUKULUMWJDUNOZEMZWMWJXHFMZXHBCLZBPZXIWJDUOMZXJWHXMWICDGUPZUSZFD
      XHHXHUQZURQBCDGXHXPUTXGXLAXHFEXEXHPXFXKBXEXHBCRSITVJEXHVAQWJXCJEWJWNEMZNZ
      WSXBXRWRKEWJXQWOEMZWRWJXQXSNZNZWQFMZWQBCLZBPZWRYAXMWNFMZWOFMZYBYAWHXMWHWI
      XTVBZXNQWJXQYEXSXRYEWNBCLZBPZXRXQYEYINWJXQVCXGYIAWNFEXEWNPXFYHBXEWNBCRSIT
      VDZVEZVFZYAYFWOBCLZBPZYAXSYFYNNWJXQXSVGXGYNAWOFEXEWOPXFYMBXEWOBCRSITVDZVE
      ZFWPDWNWOHWPUQZVHVKYAYCWNYMCLZYHBYAWHYEYFWIYCYRPYGYLYPWHWIXTVIWNWOBWPCDFG
      HYQVSVLYAYMBWNCYAYFYNYOVMVNWJXQYIXSXRYEYIYJVMZVFVOXGYDAWQFEXEWQPXFYCBXEWQ
      BCRSITVJVPVQXRXAFMZXABCLZBPZXBXRXMYEYTXRWHXMWHWIXQVBZXNQYKFDWTWNHWTUQZVRV
      TXRYIUUBYSXRWHYEWIWIYIUUBWAUUCYKWHWIXQVIZUUEWNBBCDWTFGHUUDWBVLWCXGUUBAXAF
      EXEXAPXFUUABXEXABCRSITVJWDVQWJXMWKWLWMXDWEWAXOJKFWPEDWTHYQUUDWFQWG $.

    orbsta.r $e |- .~ = ( G ~QG H ) $.
    $( Write the coset relation for the stabilizer subgroup.  (Contributed by
       Mario Carneiro, 15-Jan-2015.) $)
    gastacos $p |- ( ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) /\
      ( B e. X /\ C e. X ) ) -> ( B .~ C <-> ( B .(+) A ) = ( C .(+) A ) ) ) $=
      ( co wcel wa cfv wceq wb syl cga wbr cminusg cplusg w3a wss csubg gastacl
      cgrp adantr subgrcl subgss eqid eqgval syl2anc df-3an syl6bb simpr simpll
      biantrurd simprl grpinvcl simprr simplr gaass syl13anc eqeq1d grpcl oveq1
      syl3anc cv elrab2 baib cxp wf gaf fovrnd gacan 3bitr4d 3bitr2d ) EGJUANOZ
      BJOZPZCIOZDIOZPZPZCDFUBZWFCGUCQZQZDGUDQZNZHOZPZWMCBENDBENZRZWGWHWDWEWMUEZ
      WNWGGUIOZHIUFZWHWQSWGHGUGQOZWRWCWTWFABEGHIJKLUHUJZHGUKTZWGWTWSXAIHGKULTCD
      WKFHGWIUIIKWIUMZWKUMZMUNUOWDWEWMUPUQWGWFWMWCWFURUTWGWLBENZBRZWJWOENZBRZWM
      WPWGXEXGBWGWAWJIOZWEWBXEXGRWAWBWFUSZWGWRWDXIXBWCWDWEVAZIGWICKXCVBUOZWCWDW
      EVCZWAWBWFVDZWJDBWKEGIJKXDVEVFVGWGWLIOZWMXFSWGWRXIWEXOXBXLXMIWKGWJDKXDVHV
      JWMXOXFAVKZBENZBRXFAWLIHXPWLRXQXEBXPWLBEVIVGLVLVMTWGWAWDWBWOJOWPXHSXJXKXN
      WGDBJIJEWGWAIJVNJEVOXJEGIJKVPTXMXNVQCBWOEGWIIJKXCVRVFVSVT $.

    orbsta.f $e |- F = ran ( k e. X |-> <. [ k ] .~ , ( k .(+) A ) >. ) $.
    $( Existence and uniqueness for the function of ~ orbsta .  (Contributed by
       Mario Carneiro, 15-Jan-2015.)  (Proof shortened by Mario Carneiro,
       23-Dec-2016.) $)
    orbstafun $p |- ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) -> Fun F ) $=
      ( vh co wcel wa cvv cfv cga ovex a1i csubg wer gastacl eqger syl cbs fvex
      cv eqeltri oveq1 wbr wceq simpr wb cminusg cplusg w3a cgrp subgrcl subgss
      wss eqid eqgval syl2anc biimpa simp1d simp2d jca gastacos mpbid qliftfund
      syldan ) CGJUAPQBJQRZEOEUKZBCPZOUKZBCPZDFISNVRSQVPVQIQZRVQBCUBUCVPHGUDTQZ
      IDUEABCGHIJKLUFZDGIHKMUGUHISQVPIGUITSKGUIUJULUCVQVSBCUMVPVQVSDUNZRZWDVRVT
      UOZVPWDUPVPWDWAVSIQZRWDWFUQWEWAWGWEWAWGVQGURTZTVSGUSTZPHQZVPWDWAWGWJUTZVP
      WBWDWKUQZWCWBGVAQHIVDWLHGVBIHGKVCVQVSWIDHGWHVAIKWHVEWIVEMVFVGUHVHZVIWEWAW
      GWJWMVJVKABVQVSCDGHIJKLMVLVOVMVN $.

    $( Value of the function at a given equivalence class element.
       (Contributed by Mario Carneiro, 15-Jan-2015.)  (Proof shortened by Mario
       Carneiro, 23-Dec-2016.) $)
    orbstaval $p |- ( ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) /\
      B e. X ) -> ( F ` [ B ] .~ ) = ( B .(+) A ) ) $=
      ( co wcel wa cvv a1i cga cv ovex csubg cfv wer gastacl eqger syl cbs fvex
      eqeltri oveq1 orbstafun qliftval ) DHKUAPQBKQRZFFUBZBDPZCBDPCEGJSOURSQUPU
      QJQRUQBDUCTUPIHUDUEQJEUFABDHIJKLMUGEHJILNUHUIJSQUPJHUJUESLHUJUKULTUQCBDUM
      ABDEFGHIJKLMNOUNUO $.

    orbsta.o $e |- O = { <. x , y >. |
      ( { x , y } C_ Y /\ E. g e. X ( g .(+) x ) = y ) } $.
    $( The Orbit-Stabilizer theorem.  The mapping ` F ` is a bijection from the
       cosets of the stabilizer subgroup of ` A ` to the orbit of ` A ` .
       (Contributed by Mario Carneiro, 15-Jan-2015.) $)
    orbsta $p |- ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) ->
      F : ( X /. .~ ) -1-1-onto-> [ A ] O ) $=
      ( wceq va vb vh vz vw cga co wcel wa cqs cec wf1 wfo wf1o wf cv wral wfun
      cfv wi orbstafun wbr wrex simpr adantr cxp gaf fovrnd oveq1 eqeq1d rspcev
      eqid sylancl gaorb syl3anbrc cvv wb ovex elecg sylancr mpbird wer gastacl
      csubg eqger syl cbs fvex eqeltri qliftf mpbid fveq2 eqeq1 imbi12d ralbidv
      a1i eqeq2d orbstaval adantrr adantrl eqeq12d gastacos simprl erth 3bitr2d
      eqeq2 biimpd anassrs ectocld ralrimiva dff13 w3a vex syl6bb biimpa simp3d
      sylanbrc ecelqsi adantl eqcomd syl2anc rexbidv syl5ibcom rexlimdva syldan
      cqg imp dffo3 df-f1o ) EJNUFUGUHZDNUHZUIZMFUJZDLUKZIULZYMYNIUMZYMYNIUNYLY
      MYNIUOZUAUPZIUSZUBUPZIUSZTZYRYTTZUTZUBYMUQZUAYMUQYOYLIURYQCDEFHIJKMNOPQRV
      AYLHHUPZDEUGZFIMYNRYLUUFMUHZUIZUUGYNUHZDUUGLVBZUUIYKUUGNUHUCUPZDEUGZUUGTZ
      UCMVCZUUKYLYKUUHYJYKVDZVEZUUIUUFDNMNEYLMNVFNEUOZUUHYJUURYKEJMNOVGVEVEYLUU
      HVDZUUQVHUUIUUHUUGUUGTZUUOUUSUUGVLUUNUUTUCUUFMUULUUFTUUMUUGUUGUULUUFDEVIV
      JVKVMABDUUGELGUCMNSVNVOUUIUUGVPUHYKUUJUUKVQUUFDEVRUUQUUGDLVPNVSVTWAYLKJWD
      USUHMFWBZCDEJKMNOPWCFJMKOQWEWFZMVPUHYLMJWGUSVPOJWGWHWIWPWJWKZYLUUEUAYMUDU
      PZFUKZIUSZUUATZUVEYTTZUTZUBYMUQUUEYLUDYRMFYMYMVLZUVEYRTZUVIUUDUBYMUVKUVGU
      UBUVHUUCUVKUVFYSUUAUVEYRIWLVJUVEYRYTWMWNWOYLUVDMUHZUIZUVIUBYMUVFUEUPZFUKZ
      IUSZTZUVEUVOTZUTZUVIUVMUEYTMFYMUVJUVOYTTZUVQUVGUVRUVHUVTUVPUUAUVFUVOYTIWL
      WQUVOYTUVEXFWNYLUVLUVNMUHZUVSYLUVLUWAUIZUIZUVQUVRUWCUVQUVDDEUGZUVNDEUGZTU
      VDUVNFVBUVRUWCUVFUWDUVPUWEYLUVLUVFUWDTUWACDUVDEFHIJKMNOPQRWRWSYLUWAUVPUWE
      TUVLCDUVNEFHIJKMNOPQRWRZWTXACDUVDUVNEFJKMNOPQXBUWCUVDUVNFMYLUVAUWBUVBVEYL
      UVLUWAXCXDXEXGXHXIXJXIXJUAUBYMYNIXKXQYLYQUULUVDIUSZTZUDYMVCZUCYNUQYPUVCYL
      UWIUCYNYLUULYNUHZUWEUULTZUEMVCZUWIYLUWJUIYKUULNUHZUWLYLUWJYKUWMUWLXLZYLUW
      JDUULLVBZUWNYLUULVPUHYKUWJUWOVQUCXMUUPUULDLVPNVSVTABDUULELGUEMNSVNXNXOXPY
      LUWLUWIYLUWKUWIUEMYLUWAUIZUWEUWGTZUDYMVCZUWKUWIUWPUVOYMUHZUWEUVPTZUWRUWAU
      WSYLMUVNFFJKYFUGVPQJKYFVRWIXRXSUWPUVPUWEUWFXTUWQUWTUDUVOYMUVDUVOTUWGUVPUW
      EUVDUVOIWLWQVKYAUWKUWQUWHUDYMUWEUULUWGWMYBYCYDYGYEXJUDUCYMYNIYHXQYMYNIYIX
      Q $.
  $}

  ${
    $d g k u x y .(+) $.  $d g k u x y A $.  $d g k u x y G $.  $d g k x y Y $.
    $d g k x y .~ $.  $d x y H $.  $d k O $.  $d g k u x y X $.
    orbsta2.x $e |- X = ( Base ` G ) $.
    orbsta2.h $e |- H = { u e. X | ( u .(+) A ) = A } $.
    orbsta2.r $e |- .~ = ( G ~QG H ) $.
    orbsta2.o $e |- O = { <. x , y >. |
      ( { x , y } C_ Y /\ E. g e. X ( g .(+) x ) = y ) } $.
    $( Relation between the size of the orbit and the size of the stabilizer of
       a point in a finite group action.  (Contributed by Mario Carneiro,
       16-Jan-2015.) $)
    orbsta2 $p |- ( ( ( .(+) e. ( G GrpAct Y ) /\ A e. Y ) /\
      X e. Fin ) -> ( # ` X ) = ( ( # ` [ A ] O ) x. ( # ` H ) ) ) $=
      ( co wcel cfn cfv vk cga wa chash cqs cmul cec csubg gastacl adantr simpr
      lagsubg2 wceq cen wbr cop cmpt crn wf1o eqid orbsta cbs fvex eqeltri qsex
      cv cvv f1oen syl wb cpw wss pwfi sylib wer eqger qsss ssfi syl2anc ensymd
      enfii hashen mpbird oveq1d eqtrd ) EHLUBQRDLRUCZKSRZUCZKUDTKFUEZUDTZIUDTZ
      UFQDJUGZUDTZWKUFQWHFHKIMOWFIHUHTRZWGCDEHIKLMNUIUJZWFWGUKZULWHWJWMWKUFWHWJ
      WMUMZWIWLUNUOZWHWIWLUAKUAVFZFUGWSDEQUPUQURZUSZWRWFXAWGABCDEFGUAWTHIJKLMNO
      WTUTPVAUJWIWLWTKFKHVBTVGMHVBVCVDVEVHVIZWHWISRZWLSRZWQWRVJWHKVKZSRZWIXEVLX
      CWHWGXFWPKVMVNWHKFWHWNKFVOWOFHKIMOVPVIVQXEWIVRVSZWHXCWLWIUNUOXDXGWHWIWLXB
      VTWLWIWAVSWIWLWBVSWCWDWE $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Symmetry groups and Cayley's Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SymGrp $.

  $( Extend class notation to include the class of symmetry groups. $)
  csymg $a class SymGrp $.

  ${
    $d b f g h x $.
    $( Define the symmetry group on set ` x ` .  We represent the group as the
       set of 1-1-onto functions from ` x ` to itself under function
       composition, and topologize it as a function space assuming the set is
       discrete.  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    df-symg $a |- SymGrp = ( x e. _V |-> [_ { h | h : x -1-1-onto-> x } / b ]_
      { <. ( Base ` ndx ) , b >. ,
        <. ( +g ` ndx ) , ( f e. b , g e. b |-> ( f o. g ) ) >. ,
        <. ( TopSet ` ndx ) , ( Xt_ ` ( x X. { ~P x } ) ) >. } ) $.
  $}

  ${
    $d a b f g x A $.  $d a b B $.  $d a b J $.  $d a b .+ $.
    symgval.1 $e |- G = ( SymGrp ` A ) $.
    symgval.2 $e |- B = { x | x : A -1-1-onto-> A } $.
    symgval.3 $e |- .+ = ( f e. B , g e. B |-> ( f o. g ) ) $.
    symgval.4 $e |- J = ( Xt_ ` ( A X. { ~P A } ) ) $.
    $( The value of the symmetry group function at ` A ` .  (Contributed by
       Paul Chapman, 25-Feb-2008.)  (Revised by Mario Carneiro,
       12-Jan-2015.) $)
    symgval $p |- ( A e. V -> G = { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( TopSet ` ndx ) , J >. } ) $=
      ( va vb wcel cfv cop cvv cv csymg cnx cbs cts ctp wceq elex wf1o cab ccom
      cplusg cmpt2 cpw csn cxp cpt csb cmap co ovex f1of vex elmap sylibr abssi
      wf ssexi a1i wa id wb f1oeq23 anidms abbidv syl6eqr sylan9eqr mpt2eq123dv
      opeq2d eqidd simpl pweqd sneqd xpeq12d fveq2d tpeq123d df-symg tpex fvmpt
      csbied syl syl5eq ) BIPZGBUAQZUBUCQZCRZUBUKQZDRZUBUDQZHRZUEZJWLBSPWMWTUFB
      IUGNBONTZXAATZUHZAUIZWNOTZRZWPEFXEXEETFTUJZULZRZWRXAXAUMZUNZUOZUPQZRZUEZU
      QWTSUAXABUFZOXDXOWTSXDSPXPXDXAXAURUSZXAXAURUTXCAXQXCXAXAXBVFXBXQPXAXAXBVA
      XAXAXBNVBZXRVCVDVEVGVHXPXEXDUFZVIZXFWOXIWQXNWSXTXECWNXSXPXEXDCXSVJXPXDBBX
      BUHZAUICXPXCYAAXPXCYAVKXABXABXBVLVMVNKVOVPZVRXTXHDWPXTXHEFCCXGULDXTEFXEXE
      XGCCXGYBYBXTXGVSVQLVOVRXTXMHWRXTXMBBUMZUNZUOZUPQHXTXLYEUPXTXABXKYDXPXSVTZ
      XTXJYCXTXABYFWAWBWCWDMVOVRWEWINEFAOWFWOWQWSWGWHWJWK $.
  $}

  ${
    $d f g x A $.  $d x F $.  $d x V $.
    symgbas.1 $e |- G = ( SymGrp ` A ) $.
    symgbas.2 $e |- B = ( Base ` G ) $.
    $( The base set of the symmetric group.  (Contributed by Mario Carneiro,
       12-Jan-2015.) $)
    symgbas $p |- B = { x | x : A -1-1-onto-> A } $=
      ( vf vg cbs cfv cv cvv wcel wceq cnx cop cmap wss eqid c0 wf1o cab cplusg
      ccom cmpt2 cts cpw csn cxp cpt co wf f1of wb elmapg anidms syl5ibr abssdv
      ctp ovex ssexg sylancl topgrpbas syl symgval fveq2d eqtr4d wn base0 f1odm
      cdm vex syl6eqelr con3i pm2.21d csymg fvprc syl5eq 3eqtr4a pm2.61i eqtr4i
      dmex ss0 ) CDIJZBBAKZUAZAUBZFBLMZWGWDNWHWGOIJWGPOUCJGHWGWGGKHKUDUEZPOUFJB
      BUGUHUIUJJZPUSZIJZWDWHWGLMZWGWLNWHWGBBQUKZRWNLMWMWHWFAWNWFWEWNMZWHBBWEULZ
      BBWEUMWHWOWPUNBBWELLUOUPUQURBBQUTWGWNLVAVBWGWIWJWKLWKSVCVDWHDWKIABWGWIGHD
      WJLEWGSWISWJSVEVFVGWHVHZTTIJWGWDVIWQWGTRWGTNWQWFATWQWFWETMWFWHWFBWEVKLBBW
      EVJWEAVLWBVMVNVOURWGWCVDWQDTIWQDBVPJTEBVPVQVRVFVSVTWA $.

    $( Two ways of saying a function is a 1-1-onto mapping of A to itself.
       (Contributed by Mario Carneiro, 28-Jan-2015.) $)
    elsymgbas2 $p |- ( F e. V -> ( F e. B <-> F : A -1-1-onto-> A ) ) $=
      ( vx cv wf1o f1oeq1 symgbas elab2g ) AAHIZJAACJHCBEAANCKHABDFGLM $.

    $( Two ways of saying a function is a 1-1-onto mapping of A to itself.
       (Contributed by Paul Chapman, 25-Feb-2008.)  (Revised by Mario Carneiro,
       28-Jan-2015.) $)
    elsymgbas $p |- ( A e. V -> ( F e. B <-> F : A -1-1-onto-> A ) ) $=
      ( wcel cvv wf1o wi elex a1i wf f1of fex expcom syl5 wb elsymgbas2
      pm5.21ndd ) AEHZCIHZCBHZAACJZUDUCKUBCBLMUEAACNZUBUCAACOUFUBUCAAECPQRUCUDU
      ESKUBABCDIFGTMUA $.

    $( The symmetric group on ` n ` objects has cardinality ` n ! ` .
       (Contributed by Mario Carneiro, 22-Jan-2015.) $)
    symghash $p |- ( A e. Fin -> ( # ` B ) = ( ! ` ( # ` A ) ) ) $=
      ( vf cfn wcel chash cfv cv wf1o cab cfa symgbas fveq2i hashfac syl5eq ) A
      GHBIJAAFKLFMZIJAIJNJBSIFABCDEOPAFQR $.
  $}

  ${
    $d f g x A $.  $d f g B $.  $d f g X $.  $d f g Y $.
    symgplusg.1 $e |- G = ( SymGrp ` A ) $.
    symgplusg.2 $e |- B = ( Base ` G ) $.
    symgplusg.3 $e |- .+ = ( +g ` G ) $.
    $( The value of the symmetry group function at ` A ` .  (Contributed by
       Paul Chapman, 25-Feb-2008.)  (Revised by Mario Carneiro,
       28-Jan-2015.) $)
    symgplusg $p |- .+ = ( f e. B , g e. B |-> ( f o. g ) ) $=
      ( cvv wceq cplusg cfv cnx cbs cop cxp eqid fveq2d c0 vx wcel cv cmpt2 cts
      ccom cpw csn cpt symgbas symgval eqeltri mpt2ex topgrpplusg ax-mp 3eqtr4g
      ctp fvex wn csymg fvprc syl5eq plusgid str0 wfn coex fnmpt2i base0 xpeq2d
      vex xp0 syl6eq fneq2d mpbii fn0 sylib eqtr4d pm2.61i ) AJUBZCDEBBDUCZEUCZ
      UFZUDZKVSFLMZNOMBPNLMZWCPNUEMAAUGUHQUIMZPUQZLMZCWCVSFWGLUAABWCDEFWFJGUAAB
      FGHUJWCRZWFRUKSIWCJUBWCWHKDEBBWBBFOMZJHFOURULZWKUMBWCWFWGJWGRUNUOUPVSUSZC
      TWCWLWDTLMCTWLFTLWLFAUTMTGAUTVAVBZSILWEVCVDUPWLWCTVEZWCTKWLWCBBQZVEWNDEBB
      WBWCWIVTWADVJEVJVFVGWLWOTWCWLWOBTQTWLBTBWLWJTOMBTWLFTOWMSHVHUPVIBVKVLVMVN
      WCVOVPVQVR $.

    $( The value of the group operation of the symmetry group on ` A ` .
       (Contributed by Paul Chapman, 25-Feb-2008.)  (Revised by Mario Carneiro,
       28-Jan-2015.) $)
    symgov $p |- ( ( X e. B /\ Y e. B ) ->
      ( X .+ Y ) = ( X o. Y ) ) $=
      ( vf vg wcel ccom cvv co wceq coexg cv coeq1 coeq2 symgplusg ovmpt2g
      mpd3an3 ) EBLFBLEFMZNLEFCOUDPEFBBQJKEFBBJRZKRZMUDCEUFMNUEEUFSUFFETABCJKDG
      HIUAUBUC $.

    $( The group operation of the symmetry group on ` A ` is closed, i.e. a
       magma.  (Contributed by Mario Carneiro, 12-Jan-2015.)  (Revised by Mario
       Carneiro, 28-Jan-2015.) $)
    symgcl $p |- ( ( X e. B /\ Y e. B ) -> ( X .+ Y ) e. B ) $=
      ( wcel wa co ccom symgov wf1o elsymgbas2 ibi f1oco syl2an cvv syl eqeltrd
      wb coexg mpbird ) EBJZFBJZKZEFCLEFMZBABCDEFGHINUHUIBJZAAUIOZUFAAEOZAAFOZU
      KUGUFULABEDBGHPQUGUMABFDBGHPQAAAEFRSUHUITJUJUKUCEFBBUDABUIDTGHPUAUEUB $.
  $}

  ${
    $d f g x y z A $.  $d f g x y z G $.  $d x y z V $.
    symggrp.1 $e |- G = ( SymGrp ` A ) $.
    $( The topology of the symmetry group on ` A ` .  This component is defined
       on a larger set than the true base - the product topology is defined on
       the set of all functions, not just bijections - but the definition of
       ` TopOpen ` ensures that it is trimmed down before it gets use.
       (Contributed by Mario Carneiro, 29-Aug-2015.) $)
    symgtset $p |- ( A e. V ->
      ( Xt_ ` ( A X. { ~P A } ) ) = ( TopSet ` G ) ) $=
      ( vx vf vg wcel cts cfv cnx cbs cop cplusg cpw csn cxp cpt eqid cvv ax-mp
      ctp symgbas symgplusg symgval fveq2d wceq fvex topgrptset syl6reqr ) ACHZ
      BIJKLJBLJZMKNJBNJZMKIJAAOPQZRJZMUBZIJZUOUKBUPIEAULUMFGBUOCDEAULBDULSZUCAU
      LUMFGBDURUMSUDUOSUEUFUOTHUOUQUGUNRUHULUMUOUPTUPSUIUAUJ $.

    $( The symmetry group on ` A ` is a group.  (Contributed by Paul Chapman,
       25-Feb-2008.)  (Revised by Mario Carneiro, 13-Jan-2015.) $)
    symggrp $p |- ( A e. V -> G e. Grp ) $=
      ( vx vy vz wcel cfv cv eqidd co eqid symgcl ccom wceq symgov syl2anc wf1o
      elsymgbas cbs cplusg ccnv cid cres 3adant1 w3a coass simpr1 simpr2 coeq1d
      wa simpr3 coeq2d 3eqtr4a 3eqtr4d f1oi mpbiri sylan biimpa f1of fcoi2 3syl
      wf eqtrd wi f1ocnv a1i 3imtr4d imp sylancom f1ococnv1 syl isgrpd ) ACHZEF
      GBUAIZBUBIZBEJZUCZUDAUEZVOVPKVOVQKVRVPHZFJZVPHZVRWBVQLZVPHZVOAVPVQBVRWBDV
      PMZVQMZNZUFVOWAWCGJZVPHZUGULZWDWIOZVRWBWIVQLZOZWDWIVQLZVRWMVQLZWKVRWBOZWI
      OVRWBWIOZOWLWNVRWBWIUHWKWDWQWIWKWAWCWDWQPVOWAWCWJUIZVOWAWCWJUJZAVPVQBVRWB
      DWFWGQRUKWKWMWRVRWKWCWJWMWRPWTVOWAWCWJUMZAVPVQBWBWIDWFWGQRUNUOWKWEWJWOWLP
      WKWAWCWEWSWTWHRXAAVPVQBWDWIDWFWGQRWKWAWMVPHZWPWNPWSWKWCWJXBWTXAAVPVQBWBWI
      DWFWGNRAVPVQBVRWMDWFWGQRUPVOVTVPHZAAVTSAUQAVPVTBCDWFTURZVOWAULZVTVRVQLZVT
      VROZVRVOXCWAXFXGPXDAVPVQBVTVRDWFWGQUSXEAAVRSZAAVRVDXGVRPVOWAXHAVPVRBCDWFT
      ZUTZAAVRVAAAVRVBVCVEVOWAVSVPHZVOXHAAVSSZWAXKXHXLVFVOAAVRVGVHXIAVPVSBCDWFT
      VIVJZXEVSVRVQLZVSVROZVTVOWAXKXNXOPXMAVPVQBVSVRDWFWGQVKXEXHXOVTPXJAAVRVLVM
      VEVN $.

    $( The value of the identity element of the symmetry group on ` A `
       (Contributed by Paul Chapman, 25-Jul-2008.)  (Revised by Mario Carneiro,
       13-Jan-2015.) $)
    symgid $p |- ( A e. V -> ( _I |` A ) = ( 0g ` G ) ) $=
      ( wcel c0g cfv cid cres cplusg wceq ccom wf1o f1oi eqid elsymgbas syl2anc
      co cbs mpbiri symgov wf f1of fcoi1 mp2b syl6eq cgrp wb grpid mpbid eqcomd
      symggrp ) ACEZBFGZHAIZUMUOUOBJGZRZUOKZUNUOKZUMUQUOUOLZUOUMUOBSGZEZVBUQUTK
      UMVBAAUOMZANZAVAUOBCDVAOZPTZVFAVAUPBUOUODVEUPOZUAQVCAAUOUBUTUOKVDAAUOUCAA
      UOUDUEUFUMBUGEVBURUSUHABCDULVFVAUPBUOUNVEVGUNOUIQUJUK $.

    symginv.2 $e |- B = ( Base ` G ) $.
    symginv.3 $e |- N = ( invg ` G ) $.
    $( The group inverse in the symmetric group corresponds to the functional
       inverse.  (Contributed by Stefan O'Rear, 24-Aug-2015.)  (Revised by
       Mario Carneiro, 2-Sep-2015.) $)
    symginv $p |- ( F e. B -> ( N ` F ) = `' F ) $=
      ( wcel cfv ccnv wceq cplusg wf1o elsymgbas2 syl cvv wb mpbird eqid co c0g
      ccom cid f1ocnv cnvexg symgov mpdan f1ococnv2 csymg elbasfv symgid 3eqtrd
      cres ibi cgrp symggrp id grpinvid1 syl3anc ) CBIZCEJCKZLZCVBDMJZUAZDUBJZL
      ZVAVECVBUCZUDAUNZVFVAVBBIZVEVHLVAVJAAVBNZVAAACNZVKVAVLABCDBFGOUOZAACUEPVA
      VBQIVJVKRCBUFABVBDQFGOPSZABVDDCVBFGVDTZUGUHVAVLVHVILVMAACUIPVAAQIZVIVFLBD
      UJCAFGUKZADQFULPUMVADUPIZVAVJVCVGRVAVPVRVQADQFUQPVAURVNBVDDECVBVFGVOVFTHU
      SUTS $.
  $}

  ${
    $d w x y z G $.  $d w x y z .(+) $.  $d w x y z V $.  $d w x y z X $.
    $d w z F $.  $d w x z H $.  $d w x y z Y $.
    galactghm.x $e |- X = ( Base ` G ) $.
    galactghm.h $e |- H = ( SymGrp ` Y ) $.
    galactghm.f $e |- F = ( x e. X |-> ( y e. Y |-> ( x .(+) y ) ) ) $.
    $( The currying of a group action is a group homomorphism between the group
       ` G ` and the symetry group ` ( SymGrp `` Y ) ` .  (Contributed by FL,
       17-May-2010.)  (Proof shortened by Mario Carneiro, 13-Jan-2015.) $)
    galactghm $p |- ( .(+) e. ( G GrpAct Y ) -> F e. ( G GrpHom H ) ) $=
      ( co wcel cfv cvv syl cmpt wa adantr wceq vz vw cga cplusg cbs eqid gagrp
      cgrp gaset symggrp cv wf1o gapm wb elsymgbas mpbird fmptd df-3an sylan2br
      gaass anassrs mpteq2dva simprl simprr grpcl syl3anc mptexg oveq1 mpteq2dv
      w3a fvmptg syl2anc wf ffvelrnd symgov cxp gaf ad2antrr simpr fovrnd oveq2
      ccom cbvmptv syl6eq fmptco eqtrd 3eqtr4d isghmd ) CEHUCLMZUAUBEUDNZFUDNZE
      FDGFUENZIWLUFZWJUFZWKUFZCEHUGZWIHOMZFUHMCEHUIZHFOJUJPWIAGBHAUKZBUKZCLZQZW
      LDWIWSGMZRZXBWLMZHHXBULZBWSCXBEGHIXBUFUMXDWQXEXFUNWIWQXCWRSHWLXBFOJWMUOPU
      PKUQZWIUAUKZGMZUBUKZGMZRZRZBHXHXJWJLZWTCLZQZBHXHXJWTCLZCLZQZXNDNZXHDNZXJD
      NZWKLZXMBHXOXRWIXLWTHMZXOXRTZXLYDRWIXIXKYDVJYEXIXKYDURXHXJWTWJCEGHIWNUTUS
      VAVBXMXNGMZXPOMZXTXPTXMEUHMZXIXKYFWIYHXLWPSWIXIXKVCZWIXIXKVDZGWJEXHXJIWNV
      EVFXMWQYGWIWQXLWRSZBHXOOVGPAXNXBXPGODWSXNTBHXAXOWSXNWTCVHVIKVKVLXMYCYAYBW
      BZXSXMYAWLMYBWLMYCYLTXMGWLXHDWIGWLDVMXLXGSZYIVNXMGWLXJDYMYJVNHWLWKFYAYBJW
      MWOVOVLXMBAHHXQXHWSCLZXRYBYAXMYDRXJWTHGHCWIGHVPHCVMXLYDCEGHIVQVRXMXKYDYJS
      XMYDVSVTXMXKBHXQQZOMZYBYOTYJXMWQYPYKBHXQOVGPAXJXBYOGODWSXJTBHXAXQWSXJWTCV
      HVIKVKVLXMYABHXHWTCLZQZAHYNQXMXIYROMZYAYRTYIXMWQYSYKBHYQOVGPAXHXBYRGODWSX
      HTBHXAYQWSXHWTCVHVIKVKVLBAHYQYNWTWSXHCWAWCWDWSXQXHCWAWEWFWGWH $.
  $}

  ${
    $d u v x y z F $.  $d u v x y z G $.  $d u v x y z H $.  $d u v x y z V $.
    $d u v z .(+) $.  $d u v x y X $.  $d u v x y z Y $.
    lactghmga.x $e |- X = ( Base ` G ) $.
    lactghmga.h $e |- H = ( SymGrp ` Y ) $.
    lactghmga.f $e |- .(+) = ( x e. X , y e. Y |-> ( ( F ` x ) ` y ) ) $.
    $( The converse of ~ galactghm .  The uncurrying of a homomorphism into
       ` ( SymGrp `` Y ) ` is a group action.  Thus, group actions and group
       homomorphisms into a symmetric group are essentially equivalent
       notions.  (Contributed by Mario Carneiro, 15-Jan-2015.) $)
    lactghmga $p |- ( F e. ( G GrpHom H ) -> .(+) e. ( G GrpAct Y ) ) $=
      ( co wcel wa cfv cv wceq syl fveq2 fveq1d vz vu vv cghm cvv cxp wf cplusg
      cgrp c0g wral cga ghmgrp1 c0 ghmgrp2 grpn0 wn csymg fvprc syl5eq necon1ai
      wne 3syl jca wf1o eqid ghmf ffvelrnda wb adantr elsymgbas mpbid ralrimiva
      cbs f1of fmpt2 sylib cres grpidcl ovmpt2 sylan ghmid symgid eqtr4d fvresi
      cid fvex adantl 3eqtrd ccom ad2antrr simprr ffvelrnd simplr fvco3 syl2anc
      simpll simprl ghmlin syl3anc symgov eqtrd 3eqtr4d grpcl oveq2d ralrimivva
      isga sylanbrc ) DEFUDLMZEUIMZHUEMZNGHUFHCUGZEUJOZUAPZCLZXNQZUBPZUCPZEUHOZ
      LZXNCLZXQXRXNCLZCLZQZUCGUKUBGUKZNZUAHUKZNCEHULLMXIXJXKEFDUMZXIFUIMFUNVBXK
      EFDUOFUPXKFUNXKUQFHUROUNJHURUSUTVAVCZVDXIXLYGXIBPZAPZDOZOZHMZBHUKZAGUKXLX
      IYOAGXIYKGMZNZYNBHYQHHYJYLYQHHYLVEZHHYLUGYQYLFVNOZMZYRXIGYSYKDEFDGYSIYSVF
      ZVGZVHYQXKYTYRVIXIXKYPYIVJHYSYLFUEJUUAVKRVLHHYLVORVHVMVMABGHYMHCKVPVQXIYF
      UAHXIXNHMZNZXPYEUUDXOXNXMDOZOZXNWFHVRZOZXNXIXMGMZUUCXOUUFQXIXJUUIYHGEXMIX
      MVFZVSRABXMXNGHYMUUFCYJUUEOYKXMQYJYLUUEYKXMDSTYJXNUUESKXNUUEWGVTWAUUDXNUU
      EUUGUUDUUEFUJOZUUGXIUUEUUKQUUCEFDXMUUKUUJUUKVFWBVJUUDXKUUGUUKQXIXKUUCYIVJ
      HFUEJWCRWDTUUCUUHXNQXIHXNWEWHWIUUDYDUBUCGGUUDXQGMZXRGMZNZNZXNXTDOZOZXQXNX
      RDOZOZCLZYAYCUUOXNXQDOZUURWJZOZUUSUVAOZUUQUUTUUOHHUURUGZUUCUVCUVDQUUOHHUU
      RVEZUVEUUOUURYSMZUVFUUOGYSXRDXIGYSDUGUUCUUNUUBWKZUUDUULUUMWLZWMZUUOXKUVGU
      VFVIXIXKUUCUUNYIWKHYSUURFUEJUUAVKRVLHHUURVORZXIUUCUUNWNZHHXNUVAUURWOWPUUO
      XNUUPUVBUUOUUPUVAUURFUHOZLZUVBUUOXIUULUUMUUPUVNQXIUUCUUNWQUUDUULUUMWRZUVI
      XSUVMEFXQDXRGIXSVFZUVMVFZWSWTUUOUVAYSMUVGUVNUVBQUUOGYSXQDUVHUVOWMUVJHYSUV
      MFUVAUURJUUAUVQXAWPXBTUUOUULUUSHMUUTUVDQUVOUUOHHXNUURUVKUVLWMABXQUUSGHYMU
      VDCYJUVAOYKXQQYJYLUVAYKXQDSTYJUUSUVASKUUSUVAWGVTWPXCUUOXTGMZUUCYAUUQQUUOX
      JUULUUMUVRXIXJUUCUUNYHWKUVOUVIGXSEXQXRIUVPXDWTUVLABXTXNGHYMUUQCYJUUPOYKXT
      QYJYLUUPYKXTDSTYJXNUUPSKXNUUPWGVTWPUUOYBUUSXQCUUOUUMUUCYBUUSQUVIUVLABXRXN
      GHYMUUSCYJUUROYKXRQYJYLUURYKXRDSTYJXNUURSKXNUURWGVTWPXEXCXFVDVMVDUAUBUCXS
      CEGHXMIUVPUUJXGXH $.
  $}

  ${
    $d f x B $.  $d f x G $.  $d f x V $.  $d f x X $.
    symgga.g $e |- G = ( SymGrp ` X ) $.
    symgga.b $e |- B = ( Base ` G ) $.
    $( The topology of the symmetry group on ` A ` .  (Contributed by Mario
       Carneiro, 29-Aug-2015.) $)
    symgtopn $p |- ( X e. V ->
      ( ( Xt_ ` ( X X. { ~P X } ) ) |`t B ) = ( TopOpen ` G ) ) $=
      ( wcel cpw csn cxp cpt cfv crest cts ctopn symgtset oveq1d eqid topnval
      co syl6eq ) DCGZDDHIJKLZAMTBNLZAMTBOLUBUCUDAMDBCEPQAUDBFUDRSUA $.

    symgga.f $e |- F = ( f e. B , x e. X |-> ( f ` x ) ) $.
    $( The symmetric group induces a group action on its base set.
       (Contributed by Mario Carneiro, 24-Jan-2015.) $)
    symgga $p |- ( X e. V -> F e. ( G GrpAct X ) ) $=
      ( wcel cgrp cid cres cghm co cga cv cfv cmpt2 symggrp idghm fvresi adantr
      wa wceq fveq1d mpt2eq3ia eqtr4i lactghmga 3syl ) GFKELKMBNZEEOPKDEGQPKGEF
      HUABEIUBCADULEEBGIHDCABGARZCRZSZTCABGUMUNULSZSZTJCABGUQUOUNBKZUMGKZUEUMUP
      UNURUPUNUFUSBUNUCUDUGUHUIUJUK $.
  $}

  ${
    $d a g x y .+ $.  $d x F $.  $d a g x y G $.  $d g x H $.  $d a g x y X $.
    $d a x .0. $.  $d x S $.
    cayleylem1.x $e |- X = ( Base ` G ) $.
    cayleylem1.p $e |- .+ = ( +g ` G ) $.
    cayleylem1.u $e |- .0. = ( 0g ` G ) $.
    cayleylem1.h $e |- H = ( SymGrp ` X ) $.
    cayleylem1.s $e |- S = ( Base ` H ) $.
    cayleylem1.f $e |- F = ( g e. X |-> ( a e. X |-> ( g .+ a ) ) ) $.
    $( Lemma for ~ cayley .  (Contributed by Paul Chapman, 3-Mar-2008.)
       (Revised by Mario Carneiro, 13-Jan-2015.) $)
    cayleylem1 $p |- ( G e. Grp -> F e. ( G GrpHom H ) ) $=
      ( vx vy wcel cv co cgrp cmpt2 cga cghm eqid cmpt oveq12 ovmpt2a mpteq2dva
      gaid2 ovex mpteq2ia eqtr4i galactghm syl ) EUARPQGGPSZQSZATZUBZEGUCTRDEFU
      DTRPQAUSEGJKUSUEZUJCIUSDEFGGJMDCGIGCSZISZATZUFZUFCGIGVAVBUSTZUFZUFOCGVFVD
      VAGRIGVEVCPQVAVBGGURVCUSUPVAUQVBAUGUTVAVBAUKUHUIULUMUNUO $.

    $( Lemma for ~ cayley .  (Contributed by Paul Chapman, 3-Mar-2008.)
       (Revised by Mario Carneiro, 13-Jan-2015.) $)
    cayleylem2 $p |- ( G e. Grp -> F : X -1-1-> S ) $=
      ( vx wcel cfv wceq cvv cgrp wf1 cv c0g wi wral wa fveq1 co grpidcl adantr
      simpr grplactval syl2anc grprid eqtrd cid cres fvex eqeltri symgid fveq1i
      cbs ax-mp fvresi syl5eqr eqeq12d syl5ib ralrimiva cghm wb cayleylem1 eqid
      syl ghmf1 mpbird ) EUAQZGBDUBZPUCZDRZFUDRZSZVSHSZUEZPGUFZVQWDPGWBHVTRZHWA
      RZSVQVSGQZUGZWCHVTWAUHWIWFVSWGHWIWFVSHAUIZVSWIWHHGQZWFWJSVQWHULVQWKWHGEHJ
      LUJUKZVSHACDEGIOJUMUNGAEVSHJKLUOUPWIWGHUQGURZRZHHWMWAGTQWMWASGEVCRTJEVCUS
      UTGFTMVAVDVBWIWKWNHSWLGHVEVNVFVGVHVIVQDEFVJUIQVRWEVKABCDEFGHIJKLMNOVLPEFW
      ADGBHJNLWAVMVOVNVP $.
  $}

  ${
    $d a f g s G $.  $d f g s H $.  $d a g .+ $.  $d a f g s X $.
    cayley.x $e |- X = ( Base ` G ) $.
    cayley.h $e |- H = ( SymGrp ` X ) $.
    ${
      cayley.p $e |- .+ = ( +g ` G ) $.
      cayley.f $e |- F = ( g e. X |-> ( a e. X |-> ( g .+ a ) ) ) $.
      cayley.s $e |- S = ran F $.
      $( Cayley's Theorem (constructive version): given group ` G ` , ` F ` is
         an isomorphism between ` G ` and the subgroup ` S ` of the symmetry
         group ` H ` on the underlying set ` X ` of ` G ` .  (Contributed by
         Paul Chapman, 3-Mar-2008.)  (Proof shortened by Mario Carneiro,
         13-Jan-2015.) $)
      cayley $p |- ( G e. Grp -> ( S e. ( SubGrp ` H ) /\
        F e. ( G GrpHom ( H |`s S ) ) /\ F : X -1-1-onto-> S ) ) $=
        ( wcel cfv co cghm wf1o eqid syl cgrp csubg crn cbs cayleylem1 syl5eqel
        cress c0g ghmrn wss wb eqimss2i resghm2b sylancl wf1 cayleylem2 f1f1orn
        mpbid wceq f1oeq3 ax-mp sylibr 3jca ) EUANZBFUBOZNZDEFBUGPZQPNZGBDRZVDB
        DUCZVEMVDDEFQPNZVJVENAFUDOZCDEFGEUHOZHIKVMSZJVLSZLUEZEFDUITUFZVDVKVHVPV
        DVFVJBUJVKVHUKVQBVJMULEFVGDBVGSUMUNURVDGVJDRZVIVDGVLDUOVRAVLCDEFGVMHIKV
        NJVOLUPGVLDUQTBVJUSVIVRUKMBVJGDUTVAVBVC $.
    $}

    $( Cayley's Theorem (existence version): every group ` G ` is isomorphic to
       a subgroup of the symmetry group on the underlying set of ` G ` .  (For
       any group ` G ` there exists an isomorphism ` f ` between ` G ` and a
       subgroup ` h ` of the symmetry group on the underlying set of ` G ` .)
       (Contributed by Paul Chapman, 3-Mar-2008.)  (Revised by Mario Carneiro,
       13-Jan-2015.) $)
    cayleyth $p |- ( G e. Grp -> E. s e. ( SubGrp ` H )
      E. f e. ( G GrpHom ( H |`s s ) ) f : X -1-1-onto-> s ) $=
      ( vg va wcel cv cfv co cmpt wf1o cress cghm wrex eqid rspcev cplusg csubg
      cgrp crn cayley simp1d simp2d simp3d f1oeq1 syl2anc wceq oveq2d rexeqbidv
      oveq2 f1oeq3 ) BUCJZHDIDHKIKBUALZMNNZUDZCUBLZJZDUSAKZOZABCUSPMZQMZRZDEKZV
      BOZABCVGPMZQMZRZEUTRUPVAURVEJZDUSUROZUQUSHURBCDIFGUQSURSUSSUEZUFUPVLVMVFU
      PVAVLVMVNUGUPVAVLVMVNUHVCVMAURVEDUSVBURUITUJVKVFEUSUTVGUSUKZVHVCAVJVEVOVI
      VDBQVGUSCPUNULVGUSDVBUOUMTUJ $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Centralizers and centers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Cntr $.
  $c Cntz $.

  $( Syntax for the centralizer of a set in a monoid. $)
  ccntz $a class Cntz $.

  $( Syntax for the centralizer of a monoid. $)
  ccntr $a class Cntr $.

  ${
    $d m s x y $.
    $( Define the _centralizer_ of a subset of a magma, which is the set of
       elements each of which commutes with each element of the given subset.
       (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
    df-cntz $a |- Cntz = ( m e. _V |-> ( s e. ~P ( Base ` m ) |-> { x e.
      ( Base ` m ) | A. y e. s ( x ( +g ` m ) y ) = ( y ( +g ` m ) x ) } ) ) $.

    $( Define the _center_ of a magma, which is the elements that commute with
       all others.  (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
    df-cntr $a |- Cntr = ( m e. _V |-> ( ( Cntz ` m ) ` ( Base ` m ) ) ) $.
  $}

  ${
    $d m B $.  $d m M $.  $d m Z $.
    cntrval.b $e |- B = ( Base ` M ) $.
    cntrval.z $e |- Z = ( Cntz ` M ) $.
    $( Substitute definition of the center.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    cntrval $p |- ( Z ` B ) = ( Cntr ` M ) $=
      ( vm cvv wcel cfv ccntr wceq cv ccntz fveq2 syl6eqr fveq12d df-cntr fvprc
      cbs c0 fvex fvmpt eqcomd wn 0fv syl5eq fveq1d 3eqtr4a pm2.61i ) BGHZACIZB
      JIZKUJULUKFBFLZSIZUMMIZIUKGJUMBKZUNAUOCUPUOBMIZCUMBMNEOUPUNBSIAUMBSNDOPFQ
      ACUAUBUCUJUDZATITUKULAUEURACTURCUQTEBMRUFUGBJRUHUI $.
  $}

  ${
    $d m s x y .+ $.  $d x y A $.  $d m s x B $.  $d m s x y M $.  $d x y T $.
    $d s x y S $.  $d x y X $.  $d x y Y $.
    cntzfval.b $e |- B = ( Base ` M ) $.
    cntzfval.p $e |- .+ = ( +g ` M ) $.
    cntzfval.z $e |- Z = ( Cntz ` M ) $.
    $( First level substitution for a centralizer.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    cntzfval $p |- ( M e. V -> Z = ( s e. ~P B |->
            { x e. B | A. y e. s ( x .+ y ) = ( y .+ x ) } ) ) $=
      ( vm wcel cfv cv co wceq cvv cbs cplusg ccntz wral crab cmpt elex syl6eqr
      cpw fveq2 pweqd oveqd eqeq12d ralbidv rabeqbidv mpteq12dv df-cntz eqeltri
      fvex pwex mptex fvmpt syl syl5eq ) EFMZGEUANZHCUGZAOZBOZDPZVGVFDPZQZBHOZU
      BZACUCZUDZKVCERMVDVNQEFUELEHLOZSNZUGZVFVGVOTNZPZVGVFVRPZQZBVKUBZAVPUCZUDV
      NRUAVOEQZHVQWCVEVMWDVPCWDVPESNZCVOESUHIUFZUIWDWBVLAVPCWFWDWAVJBVKWDVSVHVT
      VIWDVRDVFVGWDVRETNDVOETUHJUFZUJWDVRDVGVFWGUJUKULUMUNABLHUOHVEVMCCWERIESUQ
      UPURUSUTVAVB $.

    $( Definition substitution for a centralizer.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    cntzval $p |- ( S C_ B -> ( Z ` S ) = { x e. B |
            A. y e. S ( x .+ y ) = ( y .+ x ) } ) $=
      ( vs cvv wcel wss cfv cv co wceq cbs c0 wral crab cpw cmpt fveq1d eqeltri
      cntzfval fvex elpw2 raleq rabbidv eqid rabex fvmpt sylbir sylan9eq wn 0fv
      ccntz fvprc syl5eq ssrab2 syl5sseq ss0 syl 3eqtr4a adantr pm2.61ian ) FLM
      ZECNZEGOZAPZBPZDQVMVLDQRZBEUAZACUBZRZVIVJVKEKCUCZVNBKPZUAZACUBZUDZOZVPVIE
      GWBABCDFLGKHIJUGUEVJEVRMWCVPRECCFSOZLHFSUHUFZUIKEWAVPVRWBVSERVTVOACVNBVSE
      UJUKWBULVOACWEUMUNUOUPVIUQZVQVJWFETOTVKVPEURWFEGTWFGFUSOTJFUSUTVAUEWFVPTN
      VPTRWFCVPTVOACVBWFCWDTHFSUTVAVCVPVDVEVFVGVH $.

    $( Elementhood in the centralizer.  (Contributed by Mario Carneiro,
       22-Sep-2015.) $)
    elcntz $p |- ( S C_ B -> ( A e. ( Z ` S ) <-> ( A e. B /\
            A. y e. S ( A .+ y ) = ( y .+ A ) ) ) ) $=
      ( vx wss cfv wcel cv co wceq wral crab wa eleq2d oveq1 oveq2 elrab syl6bb
      cntzval eqeq12d ralbidv ) ECLZBEGMZNBKOZAOZDPZULUKDPZQZAERZKCSZNBCNBULDPZ
      ULBDPZQZAERZTUIUJUQBKACDEFGHIJUFUAUPVAKBCUKBQZUOUTAEVBUMURUNUSUKBULDUBUKB
      ULDUCUGUHUDUE $.

    $( Membership in a centralizer.  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    cntzel $p |- ( ( S C_ B /\ X e. B ) -> ( X e. ( Z ` S ) <->
          A. y e. S ( X .+ y ) = ( y .+ X ) ) ) $=
      ( wss cfv wcel cv co wceq wral elcntz baibd ) DBKFDGLMFBMFANZCOTFCOPADQAF
      BCDEGHIJRS $.

    $( Special substitution for the centralizer of a singleton.  (Contributed
       by Stefan O'Rear, 5-Sep-2015.) $)
    cntzsnval $p |- ( Y e. B -> ( Z ` { Y } ) =
          { x e. B | ( x .+ Y ) = ( Y .+ x ) } ) $=
      ( vy wcel csn cfv cv co wceq wral crab wss snssi cntzval syl oveq2 ralsng
      oveq1 eqeq12d rabbidv eqtrd ) EBKZELZFMZANZJNZCOZUMULCOZPZJUJQZABRZULECOZ
      EULCOZPZABRUIUJBSUKURPEBTAJBCUJDFGHIUAUBUIUQVAABUPVAJEBUMEPUNUSUOUTUMEULC
      UCUMEULCUEUFUDUGUH $.

    $( Value of the centralizer of a singleton.  (Contributed by Mario
       Carneiro, 25-Apr-2016.) $)
    elcntzsn $p |- ( Y e. B -> ( X e. ( Z ` { Y } ) <->
      ( X e. B /\ ( X .+ Y ) = ( Y .+ X ) ) ) ) $=
      ( vx wcel csn cfv cv co wceq crab wa cntzsnval eleq2d oveq1 oveq2 eqeq12d
      elrab syl6bb ) EAKZDELFMZKDJNZEBOZEUHBOZPZJAQZKDAKDEBOZEDBOZPZRUFUGULDJAB
      CEFGHISTUKUOJDAUHDPUIUMUJUNUHDEBUAUHDEBUBUCUDUE $.

    $( A centralizer expression for two sets elementwise commuting.
       (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
    sscntz $p |- ( ( S C_ B /\ T C_ B ) -> ( S C_ ( Z ` T ) <->
          A. x e. S A. y e. T ( x .+ y ) = ( y .+ x ) ) ) $=
      ( wss cfv cv co wceq wral wa crab cntzval sseq2d ssrab syl6bb ibar bicomd
      sylan9bbr ) FCLZEFHMZLZECLZANZBNZDOULUKDOPBFQZAEQZRZUJUNUGUIEUMACSZLUOUGU
      HUPEABCDFGHIJKTUAUMACEUBUCUJUNUOUJUNUDUEUF $.
  $}

  ${
    $d x y z M $.  $d x y B $.  $d x y S $.  $d x Z $.  $d y P $.  $d y X $.
    $d y Y $.
    cntzrcl.b $e |- B = ( Base ` M ) $.
    cntzrcl.z $e |- Z = ( Cntz ` M ) $.
    $( Reverse closure for elements of the centralizer.  (Contributed by Stefan
       O'Rear, 6-Sep-2015.) $)
    cntzrcl $p |- ( X e. ( Z ` S ) -> ( M e. _V /\ S C_ B ) ) $=
      ( vx vy vz cfv wcel cvv c0 ccntz cdm cv co wceq eqid wn noel fvprc syl5eq
      wss fveq1d 0fv syl6eq eleq2d mtbiri con4i cpw wral crab cmpt cntzfval syl
      cplusg dmeqd dmmptss syl6eqss elfvdm sseldd elpwid jca ) DBEKZLZCMLZBAUEV
      HVGVHUAZVGDNLDUBVIVFNDVIVFBNKNVIBENVIECOKNGCOUCUDUFBUGUHUIUJUKZVGBAVGEPZA
      ULZBVGVKHVLIQZJQZCURKZRVNVMVORSJHQUMIAUNZUOZPVLVGEVQVGVHEVQSVJIJAVOCMEHFV
      OTGUPUQUSHVLVPVQVQTUTVADBEVBVCVDVE $.

    $( The centralizer is unconditionally a subset.  (Contributed by Stefan
       O'Rear, 6-Sep-2015.) $)
    cntzssv $p |- ( Z ` S ) C_ B $=
      ( vx vy cfv wss c0 wceq 0ss sseq1 mpbiri wne cv wcel wex co n0 cplusg cvv
      wral crab cntzrcl simprd eqid cntzval syl ssrab2 syl6eqss sylbi pm2.61ine
      exlimiv ) BDIZAJZUPKUPKLUQKAJAMUPKANOUPKPGQZUPRZGSUQGUPUAUSUQGUSUPURHQZCU
      BIZTUTURVATLHBUDZGAUEZAUSBAJZUPVCLUSCUCRVDABCURDEFUFUGGHAVABCDEVAUHFUIUJV
      BGAUKULUOUMUN $.
  $}

  ${
    $d s x y M $.  $d s x y .+ $.  $d y S $.  $d y X $.  $d y Y $.
    cntzi.p $e |- .+ = ( +g ` M ) $.
    cntzi.z $e |- Z = ( Cntz ` M ) $.
    $( Membership in a centralizer (inference).  (Contributed by Stefan O'Rear,
       6-Sep-2015.)  (Revised by Mario Carneiro, 22-Sep-2015.) $)
    cntzi $p |- ( ( X e. ( Z ` S ) /\ Y e. S ) -> ( X .+ Y ) = ( Y .+ X ) ) $=
      ( vy cfv wcel cv co wceq wral cbs wss wa wb cvv cntzrcl simprd elcntz syl
      eqid simplbda anidms oveq2 oveq1 eqeq12d rspccva sylan ) DBFJKZDILZAMZUND
      AMZNZIBOZEBKDEAMZEDAMZNZUMURUMUMDCPJZKZURUMBVBQZUMVCURRSUMCTKVDVBBCDFVBUE
      ZHUAUBIDVBABCFVEGHUCUDUFUGUQVAIEBUNENUOUSUPUTUNEDAUHUNEDAUIUJUKUL $.
  $}

  ${
    cntri.b $e |- B = ( Base ` M ) $.
    cntri.p $e |- .+ = ( +g ` M ) $.
    cntri.z $e |- Z = ( Cntr ` M ) $.
    $( Defining property of the center of a group.  (Contributed by Mario
       Carneiro, 22-Sep-2015.) $)
    cntri $p |- ( ( X e. Z /\ Y e. B ) -> ( X .+ Y ) = ( Y .+ X ) ) $=
      ( wcel ccntz cfv co wceq ccntr eqid cntrval eqtr4i eleq2i cntzi sylanb )
      DFJDACKLZLZJEAJDEBMEDBMNFUCDFCOLUCIACUBGUBPZQRSBACDEUBHUDTUA $.
  $}

  ${
    $d x y A $.  $d y G $.  $d y H $.  $d x y S $.  $d x y V $.  $d x Y $.
    $d x Z $.
    resscntz.p $e |- H = ( G |`s A ) $.
    resscntz.z $e |- Z = ( Cntz ` G ) $.
    resscntz.y $e |- Y = ( Cntz ` H ) $.
    $( Centralizer in a substructure.  (Contributed by Mario Carneiro,
       3-Oct-2015.) $)
    resscntz $p |- ( ( A e. V /\ S C_ A ) ->
      ( Y ` S ) = ( ( Z ` S ) i^i A ) ) $=
      ( vx vy wcel wss wa cfv cin eqid wb co cbs cv wi cntzrcl simprd ressbasss
      cvv syl6ss a1i inss1 sseli syl cplusg wceq wral anass elin ressbas eleq2d
      syl5bbr ressplusg eqeq12d ralbidv anbi12d ad2antrr syl5rbbr sseq2d syl5bb
      oveqd ssin biimpd impl elcntz ancom bitri adantl anbi2d 3bitr4d pm5.21ndd
      ex eqrdv ) AEMZBANZOZKBFPZBGPZAQZWDBCUAPZNZKUBZWEMZWJWGMZWKWIUCWDWKBDUAPZ
      WHWKDUGMBWMNZWMBDWJFWMRZJUDUEAWHDCHWHRZUFUHUIWLWIUCWDWLWJWFMZWIWGWFWJWFAU
      JUKWQCUGMWIWHBCWJGWPIUDUEULUIWDWIWKWLSWDWIOZWJWMMZWJLUBZDUMPZTZWTWJXATZUN
      ZLBUOZOZWJAMZWJWHMZWJWTCUMPZTZWTWJXITZUNZLBUOZOZOZWKWLXOXGXHOZXMOZWRXFXGX
      HXMUPWBXQXFSWCWIWBXPWSXMXEXPWJAWHQZMWBWSWJAWHUQWBXRWMWJAWHDECHWPURZUSUTWB
      XLXDLBWBXJXBXKXCWBXIXAWJWTAXICDEHXIRZVAZVIWBXIXAWTWJYAVIVBVCVDVEVFWRWNWKX
      FSWBWCWIWNWBWCWIOZWNYBBXRNWBWNBAWHVJWBXRWMBXSVGVHVKVLLWJWMXABDFWOXARJVMUL
      WLXGWQOZWRXOWLWQXGOYCWJWFAUQWQXGVNVOWRWQXNXGWIWQXNSWDLWJWHXIBCGWPXTIVMVPV
      QVHVRVTVSWA $.
  $}

  ${
    $d x y z B $.  $d x y z M $.  $d x y z S $.  $d x y T $.  $d x y z Z $.
    cntzrec.b $e |- B = ( Base ` M ) $.
    cntzrec.z $e |- Z = ( Cntz ` M ) $.
    $( Centralizers reverse the subset relation.  (Contributed by Mario
       Carneiro, 3-Oct-2015.) $)
    cntz2ss $p |- ( ( S C_ B /\ T C_ S ) -> ( Z ` S ) C_ ( Z ` T ) ) $=
      ( vx vy wss wa cfv cv cplusg co wceq wral wcel eqid cntzi ssralv ralrimiv
      ralrimiva wi adantl syl5 wb cntzssv sstr ancoms sscntz sylancr mpbird ) B
      AJZCBJZKZBELZCELJZHMZIMZDNLZOUTUSVAOPZICQZHUQQZUPVCHUQUSUQRZVBIBQZUPVCVEV
      BIBVABDUSUTEVASZGTUCUOVFVCUDUNVBICBUAUEUFUBUPUQAJCAJZURVDUGABDEFGUHUOUNVH
      CBAUIUJHIAVAUQCDEFVGGUKULUM $.

    $( Reciprocity relationship for centralizers.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    cntzrec $p |- ( ( S C_ B /\ T C_ B ) ->
        ( S C_ ( Z ` T ) <-> T C_ ( Z ` S ) ) ) $=
      ( vx vy wss wa cv cplusg cfv co wceq wral wb ralcom sscntz eqcom a1i eqid
      2ralbii bitri ancoms 3bitr4d ) BAJZCAJZKZHLZILZDMNZOZULUKUMOZPZICQHBQZUOU
      NPZHBQICQZBCENJCBENJZUQUSRUJUQUPHBQICQUSUPHIBCSUPURIHCBUNUOUAUDUEUBHIAUMB
      CDEFUMUCZGTUIUHUTUSRIHAUMCBDEFVAGTUFUG $.

    $( Express any centralizer as an intersection of singleton centralizers.
       (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
    cntziinsn $p |- ( S C_ B -> ( Z ` S ) =
          ( B i^i |^|_ x e. S ( Z ` { x } ) ) ) $=
      ( vy wss cfv cv cplusg co wceq wral crab csn ciin cin wcel eqid cntzsnval
      cntzval wa ssel2 syl iineq2dv ineq2d riinrab syl6eq eqtr4d ) CBIZCEJHKZAK
      ZDLJZMUNUMUOMNZACOHBPZBACUNQEJZRZSZHABUOCDEFUOUAZGUCULUTBACUPHBPZRZSUQULU
      SVCBULACURVBULUNCTUDUNBTURVBNCBUNUEHBUODUNEFVAGUBUFUGUHUPAHBCUIUJUK $.

    $d w x y z B $.  $d w x y z M $.  $d x y S $.  $d x y T $.  $d x y Z $.
    $( Centralizers in a monoid are submonoids.  (Contributed by Stefan O'Rear,
       6-Sep-2015.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    cntzsubm $p |- ( ( M e. Mnd /\ S C_ B ) -> ( Z ` S ) e. ( SubMnd ` M ) ) $=
      ( vy vz vx wcel wa cfv cv co wral wceq adantr wb mndass syl13anc cmnd wss
      csubmnd c0g cplusg cntzssv a1i mndidcl simpll simpr sselda mndlid syl2anc
      eqid mndrid eqtr4d ralrimiva elcntz adantl mpbir2and simprl sseldi simprr
      mndcl syl3anc adantlr cntzi sylan oveq2d oveq1d 3eqtr2d 3eqtrd ralrimivva
      ad2antlr w3a issubm mpbir3and ) CUAJZBAUBZKZBDLZCUCLJZWAAUBZCUDLZWAJZGMZH
      MZCUELZNZWAJZHWAOGWAOZWCVTABCDEFUFZUGVTWEWDAJZWDIMZWHNZWNWDWHNZPZIBOZVRWM
      VSACWDEWDUNZUHQVTWQIBVTWNBJZKZWOWNWPXAVRWNAJZWOWNPVRVSWTUIZVTBAWNVRVSUJUK
      ZAWHCWNWDEWHUNZWSULUMXAVRXBWPWNPXCXDAWHCWNWDEXEWSUOUMUPUQVSWEWMWRKRVRIWDA
      WHBCDEXEFURUSUTVTWJGHWAWAVTWFWAJZWGWAJZKZKZWJWIAJZWIWNWHNZWNWIWHNZPZIBOZX
      IVRWFAJZWGAJZXJVRVSXHUIZXIWAAWFWLVTXFXGVAZVBZXIWAAWGWLVTXFXGVCZVBZAWHCWFW
      GEXEVDVEXIXMIBXIWTKZXKWFWGWNWHNZWHNZWNWFWHNZWGWHNZXLYBVRXOXPXBXKYDPXIVRWT
      XQQZXIXOWTXSQZXIXPWTYAQZVTWTXBXHXDVFZAWHCWFWGWNEXESTYBYDWFWNWGWHNZWHNZWFW
      NWHNZWGWHNZYFYBYCYKWFWHXIXGWTYCYKPXTWHBCWGWNDXEFVGVHVIYBVRXOXBXPYNYLPYGYH
      YJYIAWHCWFWNWGEXESTYBYMYEWGWHXIXFWTYMYEPXRWHBCWFWNDXEFVGVHVJVKYBVRXBXOXPY
      FXLPYGYJYHYIAWHCWNWFWGEXESTVLUQVSWJXJXNKRVRXHIWIAWHBCDEXEFURVNUTVMVRWBWCW
      EWKVORVSGHAWHWACWDEWSXEVPQVQ $.

    $( Centralizers in a group are subgroups.  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    cntzsubg $p |- ( ( M e. Grp /\ S C_ B ) -> ( Z ` S ) e. ( SubGrp ` M ) ) $=
      ( vx vy wcel wa cfv wceq eqid syl2anc grpcl grpass syl13anc oveq2d eqtr4d
      co cgrp wss csubg csubmnd cminusg wral cmnd grpmnd cntzsubm cplusg simpll
      sylan cntzssv simprl sseldi grpinvcl ssel2 ad2ant2l syl3anc adantl oveq1d
      cv cntzi grprinv grprid eqtrd grplinv grplid 3eqtr3d anassrs ralrimiva wb
      c0g simplr simpr cntzel mpbird issubg3 adantr mpbir2and ) CUAIZBAUBZJZBDK
      ZCUCKIZWDCUDKIZGVBZCUEKZKZWDIZGWDUFZWACUGIWBWFCUHABCDEFUIULWCWJGWDWCWGWDI
      ZJZWJWIHVBZCUJKZTZWNWIWOTZLZHBUFZWMWRHBWCWLWNBIZWRWCWLWTJZJZWPWGWIWOTZWOT
      ZWIWGWOTZWQWOTZWPWQXBXDWIWGWNWOTZWIWOTZWOTZXFXBXDWIWNWGWOTZWIWOTZWOTZXIXB
      XDWIWNXCWOTZWOTZXLXBWAWIAIZWNAIZXCAIZXDXNLWAWBXAUKZXBWAWGAIZXOXRXBWDAWGAB
      CDEFUMZWCWLWTUNUOZACWHWGEWHMZUPZNZWBWTXPWAWLBAWNUQURZXBWAXSXOXQXRYAYDAWOC
      WGWIEWOMZOUSAWOCWIWNXCEYFPQXBXKXMWIWOXBWAXPXSXOXKXMLXRYEYAYDAWOCWNWGWIEYF
      PQRSXBXHXKWIWOXBXGXJWIWOXAXGXJLWCWOBCWGWNDYFFVCUTVARSXBXFWIWGWQWOTZWOTZXI
      XBWAXOXSWQAIZXFYHLXRYDYAXBWAXPXOYIXRYEYDAWOCWNWIEYFOUSZAWOCWIWGWQEYFPQXBX
      HYGWIWOXBWAXSXPXOXHYGLXRYAYEYDAWOCWGWNWIEYFPQRSSXBXDWPCVMKZWOTZWPXBXCYKWP
      WOXBWAXSXCYKLXRYAAWOCWHWGYKEYFYKMZYBVDNRXBWAWPAIZYLWPLXRXBWAXOXPYNXRYDYEA
      WOCWIWNEYFOUSAWOCWPYKEYFYMVENVFXBXFYKWQWOTZWQXBXEYKWQWOXBWAXSXEYKLXRYAAWO
      CWHWGYKEYFYMYBVGNVAXBWAYIYOWQLXRYJAWOCWQYKEYFYMVHNVFVIVJVKWMWBXOWJWSVLWAW
      BWLVNWMWAXSXOWAWBWLUKWMWDAWGXTWCWLVOUOYCNHAWOBCWIDEYFFVPNVQVKWAWEWFWKJVLW
      BGWDCWHYBVRVSVT $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y G $.  $d x y H $.  $d x y S $.  $d x T $.
    $d x Y $.  $d x Z $.
    cntzmhm.z $e |- Z = ( Cntz ` G ) $.
    $( If the elements of ` S ` commute, the elements of a subset ` T ` also
       commute.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    cntzidss $p |- ( ( S C_ ( Z ` S ) /\ T C_ S ) -> T C_ ( Z ` T ) ) $=
      ( cfv wss wa simpr simpl cbs eqid cntzssv syl6ss cntz2ss sylancom sstrd )
      AADFZGZBAGZHZBABDFZSTIUAARUBSTJZSTACKFZGRUBGUAARUDUCUDACDUDLZEMNUDABCDUEE
      OPQQ $.

    cntzmhm.y $e |- Y = ( Cntz ` H ) $.
    $( Centralizers in a monoid are preserved by monoid homomorphisms.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    cntzmhm $p |- ( ( F e. ( G MndHom H ) /\ A e. ( Z ` S ) ) ->
      ( F ` A ) e. ( Y ` ( F " S ) ) ) $=
      ( vy vx co wcel cfv wa cbs wceq eqid wss syl cmhm cima cv wral wf cntzssv
      cplusg mhmf sseli ffvelrn syl2an cntzi adantll fveq2d simpll ad2antlr cvv
      cntzrcl adantl simprd sselda mhmlin syl3anc ralrimiva wfn wb adantr oveq2
      3eqtr3d ffn oveq1 eqeq12d ralima syl2anc mpbird crn imassrn syl5ss elcntz
      frn mpbir2and ) CDEUALMZABGNZMZOZACNZCBUBZFNMZWFEPNZMZWFJUCZEUGNZLZWKWFWL
      LZQZJWGUDZWBDPNZWICUEZAWQMZWJWDWQWIDECWQRZWIRZUHZWCWQAWQBDGWTHUFUIZWQWIAC
      UJUKWEWPWFKUCZCNZWLLZXEWFWLLZQZKBUDZWEXHKBWEXDBMZOZAXDDUGNZLZCNZXDAXLLZCN
      ZXFXGXKXMXOCWDXJXMXOQWBXLBDAXDGXLRZHULUMUNXKWBWSXDWQMZXNXFQWBWDXJUOZWDWSW
      BXJXCUPZWEBWQXDWEDUQMZBWQSZWDYAYBOWBWQBDAGWTHURUSUTZVAZWQXLWLDECAXDWTXQWL
      RZVBVCXKWBXRWSXPXGQXSYDXTWQXLWLDECXDAWTXQYEVBVCVIVDWECWQVEZYBWPXIVFWEWRYF
      WBWRWDXBVGZWQWICVJTYCWOXHJKWQBCWKXEQWMXFWNXGWKXEWFWLVHWKXEWFWLVKVLVMVNVOW
      EWGWISWHWJWPOVFWEWGCVPZWICBVQWEWRYHWISYGWQWICVTTVRJWFWIWLWGEFXAYEIVSTWA
      $.

    $( Centralizers in a monoid are preserved by monoid homomorphisms.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    cntzmhm2 $p |- ( ( F e. ( G MndHom H ) /\ S C_ ( Z ` T ) ) ->
      ( F " S ) C_ ( Y ` ( F " T ) ) ) $=
      ( vx cmhm co wcel cfv wss cima wral cbs eqid syl cntzmhm ralrimiva ssralv
      wa cv mpan9 wfun cdm wb wf mhmf adantr ffun simpr cntzssv syl6ss wceq fdm
      sseqtr4d funimass4 syl2anc mpbird ) CDEKLMZABGNZOZUDZCAPCBPFNZOZJUEZCNVGM
      ZJAQZVCVJJVDQVEVKVCVJJVDVIBCDEFGHIUAUBVJJAVDUCUFVFCUGZACUHZOVHVKUIVFDRNZE
      RNZCUJZVLVCVPVEVNVODECVNSZVOSUKULZVNVOCUMTVFAVNVMVFAVDVNVCVEUNVNBDGVQHUOU
      PVFVPVMVNUQVRVNVOCURTUSJAVGCUTVAVB $.
  $}

  ${
    $d x y M $.  $d x y X $.  $d x y Z $.
    cntrnsg.z $e |- Z = ( Cntr ` M ) $.
    $( A central subgroup is normal.  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    cntrsubgnsg $p |- ( ( X e. ( SubGrp ` M ) /\ X C_ Z ) ->
        X e. ( NrmSGrp ` M ) ) $=
      ( vx vy csubg cfv wcel wss wa cv cplusg co wral wceq sseldd eqid ad2antrr
      csg simpl ccntz simplr simprr ccntr cntrval eqtr4i syl6eleqr simprl cntzi
      cbs cnsg syl2anc oveq1d subgrcl subgss grppncan syl3anc eqtr3d ralrimivva
      cgrp eqeltrd isnsg3 sylanbrc ) BAGHIZBCJZKZVEELZFLZAMHZNZVHATHZNZBIZFBOEA
      UKHZOBAULHIVEVFUAVGVNEFVOBVGVHVOIZVIBIZKZKZVMVIBVSVIVHVJNZVHVLNZVMVIVSVTV
      KVHVLVSVIVOAUBHZHZIVPVTVKPVSVICWCVSBCVIVEVFVRUCVGVPVQUDZQWCAUEHCVOAWBVORZ
      WBRZUFDUGUHVGVPVQUIZVJVOAVIVHWBVJRZWFUJUMUNVSAVAIZVIVOIVPWAVIPVEWIVFVRBAU
      OSVSBVOVIVEBVOJVFVRVOBAWEUPSWDQWGVOVJAVLVIVHWEWHVLRZUQURUSWDVBUTEFVJBAVLV
      OWEWHWJVCVD $.

    $( The center of a group is a normal subgroup.  (Contributed by Stefan
       O'Rear, 6-Sep-2015.) $)
    cntrnsg $p |- ( M e. Grp -> Z e. ( NrmSGrp ` M ) ) $=
      ( cgrp wcel csubg cfv wss cnsg cbs ccntz ccntr eqid cntrval ssid cntzsubg
      eqtr4i mpan2 syl5eqel cntrsubgnsg sylancl ) ADEZBAFGZEBBHBAIGEUBBAJGZAKGZ
      GZUCBALGUFCUDAUEUDMZUEMZNQUBUDUDHUFUCEUDOUDUDAUEUGUHPRSBOABBCTUA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The opposite group
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c oppG $. $( Opposite group $)

  $( The opposite group operation. $)
  coppg $a class oppG $.

  ${
    $d v w x y z $.
    $( Define an opposite group, which is the same as the original group but
       with addition written the other way around. ~ df-oppr does the same
       thing for multiplication.  (Contributed by Stefan O'Rear,
       25-Aug-2015.) $)
    df-oppg $a |- oppG = ( w e. _V |-> ( w sSet
      <. ( +g ` ndx ) , tpos ( +g ` w ) >. ) ) $.
  $}

  ${
    $d w x y R $.  $d w x y B $.  $d w x y .+ $.  $d x y X $.  $d x y Y $.
    oppgval.2 $e |- .+ = ( +g ` R ) $.
    oppgval.3 $e |- O = ( oppG ` R ) $.
    $( Value of the opposite group.  (Contributed by Stefan O'Rear,
       25-Aug-2015.)  (Revised by Mario Carneiro, 16-Sep-2015.)  (Revised by
       Fan Zheng, 26-Jun-2016.) $)
    oppgval $p |- O = ( R sSet <. ( +g ` ndx ) , tpos .+ >. ) $=
      ( vx coppg cfv cnx cplusg ctpos cop csts co cvv wcel wceq cv id fveq2 wn
      syl6eqr tposeqd opeq2d oveq12d df-oppg ovex fvmpt reldmsets ovprc1 eqtr4d
      c0 fvprc pm2.61i eqtri ) CBGHZBIJHZAKZLZMNZEBOPZUPUTQFBFRZUQVBJHZKZLZMNUT
      OGVBBQZVBBVEUSMVFSVFVDURUQVFVCAVFVCBJHAVBBJTDUBUCUDUEFUFBUSMUGUHVAUAUPULU
      TBGUMBUSMUIUJUKUNUO $.

    oppgplusfval.4 $e |- .+b = ( +g ` O ) $.
    $( Value of the addition operation of an opposite group.  (Contributed by
       Stefan O'Rear, 26-Aug-2015.)  (Revised by Fan Zheng, 26-Jun-2016.) $)
    oppgplusfval $p |- .+b = tpos .+ $=
      ( cplusg cfv ctpos cvv wcel wceq cnx cop csts co plusgid c0 syl5eq tposex
      fvex eqeltri setsid mpan2 oppgval fveq2i syl6reqr wn tpos0 str0 reldmsets
      eqtr2i ovprc1 fveq2d fvprc tposeqd 3eqtr4a pm2.61i eqtri ) BDHIZAJZGCKLZV
      AVBMVCVBCNHIZVBOZPQZHIZVAVCVBKLVBVGMAACHIZKECHUBUCUAKVBHKCRUDUEDVFHACDEFU
      FZUGUHVCUIZSHIZSJZVAVBVLSVKUJHVDRUKUMVJDSHVJDVFSVICVEPULUNTUOVJASVJAVHSEC
      HUPTUQURUSUT $.

    $( Value of the addition operation of an opposite ring.  (Contributed by
       Stefan O'Rear, 26-Aug-2015.)  (Revised by Fan Zheng, 26-Jun-2016.) $)
    oppgplus $p |- ( X .+b Y ) = ( Y .+ X ) $=
      ( co ctpos oppgplusfval oveqi ovtpos eqtri ) EFBJEFAKZJFEAJBPEFABCDGHILME
      FANO $.
  $}

  ${
    $d s x y z R $.  $d s E $.  $d x y z O $.  $d x y V $.
    oppgbas.1 $e |- O = ( oppG ` R ) $.
    ${
      oppglem.2 $e |- E = Slot N $.
      oppglem.3 $e |- N e. NN $.
      oppglem.4 $e |- N =/= 2 $.
      $( Lemma for ~ oppgbas .  (Contributed by Stefan O'Rear, 26-Aug-2015.) $)
      oppglem $p |- ( E ` R ) = ( E ` O ) $=
        ( cfv cnx cplusg ctpos cop csts co ndxid wne c2 ndxarg plusgndx neeq12i
        mpbir setsnid eqid oppgval fveq2i eqtr4i ) ABIAJKIZAKIZLZMNOZBIDBIUJUHB
        ABCFGPJBIZUHQCRQHULCUHRBCFGSTUAUBUCDUKBUIADUIUDEUEUFUG $.
    $}

    ${
      oppgbas.2 $e |- B = ( Base ` R ) $.
      $( Base set of an opposite group.  (Contributed by Stefan O'Rear,
         26-Aug-2015.) $)
      oppgbas $p |- B = ( Base ` O ) $=
        ( cbs cfv c1 df-base 1nn 1ne2 oppglem eqtri ) ABFGCFGEBFHCDIJKLM $.
    $}

    ${
      oppgtset.2 $e |- J = ( TopSet ` R ) $.
      $( Topology of an opposite group.  (Contributed by Mario Carneiro,
         17-Sep-2015.) $)
      oppgtset $p |- J = ( TopSet ` O ) $=
        ( cts cfv c9 df-tset 9nn c2 2re 2lt9 gtneii oppglem eqtri ) BAFGCFGEAFH
        CDIJKHLMNOP $.
    $}

    ${
      oppgtopn.2 $e |- J = ( TopOpen ` R ) $.
      $( Topology of an opposite group.  (Contributed by Mario Carneiro,
         17-Sep-2015.) $)
      oppgtopn $p |- J = ( TopOpen ` O ) $=
        ( ctopn cfv cts cbs crest co eqid topnval oppgbas oppgtset 3eqtr2i ) BA
        FGAHGZAIGZJKCFGERQARLZQLZMRQCRACDSNAQCDTOMP $.
    $}

    $( The opposite of a monoid is a monoid.  (Contributed by Stefan O'Rear,
       26-Aug-2015.)  (Revised by Mario Carneiro, 16-Sep-2015.) $)
    oppgmnd $p |- ( R e. Mnd -> O e. Mnd ) $=
      ( vx vy vz cmnd wcel cbs cfv cplusg wceq eqid cv w3a co oppgplus wa eqtri
      syl5eq c0g oppgbas eqidd mndcl 3com23 syl5eqel simpl simpr3 simpr2 simpr1
      mndass syl13anc eqcomd oveq1i oveq2i 3eqtr4g mndidcl mndrid mndlid ismndd
      a1i ) AGHZDEFAIJZBKJZBAUAJZVCBIJLVBVCABCVCMZUBVAVBVDUCVBDNZVCHZENZVCHZOVG
      VIVDPZVIVGAKJZPZVCVLVDABVGVIVLMZCVDMZQZVBVJVHVMVCHVCVLAVIVGVFVNUDUEUFVBVH
      VJFNZVCHZOZRZVQVMVLPZVQVIVLPZVGVLPZVKVQVDPZVGVIVQVDPZVDPZVTWCWAVTVBVRVJVH
      WCWALVBVSUGVBVHVJVRUHVBVHVJVRUIVBVHVJVRUJVCVLAVQVIVGVFVNUKULUMWDVMVQVDPWA
      VKVMVQVDVPUNVLVDABVMVQVNCVOQSWFVGWBVDPWCWEWBVGVDVLVDABVIVQVNCVOQUOVLVDABV
      GWBVNCVOQSUPVCAVEVFVEMZUQVBVHRZVEVGVDPVGVEVLPVGVLVDABVEVGVNCVOQVCVLAVGVEV
      FVNWGURTWHVGVEVDPVEVGVLPVGVLVDABVGVEVNCVOQVCVLAVGVEVFVNWGUSTUT $.

    $( Bidirectional form of ~ oppgmnd .  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    oppgmndb $p |- ( R e. Mnd <-> O e. Mnd ) $=
      ( vx vy cmnd wcel oppgmnd cfv eqid wtru cbs wceq oppgbas a1i cv cplusg co
      wa oppgplus coppg wb eqidd eqtri mndpropd trud sylib impbii ) AFGZBFGZABC
      HUJBUAIZFGZUIBUKUKJZHULUIUBKDEALIZUKAUNUKLIMKUNBUKUMUNABCUNJNNOKUNUCDPZEP
      ZUKQIZRZUOUPAQIZRZMKUOUNGUPUNGSSURUPUOBQIZRUTVAUQBUKUOUPVAJZUMUQJTUSVAABU
      PUOUSJCVBTUDOUEUFUGUH $.

    $d x O $.  $d x R $.  $d x .0. $.  $d x I $.
    ${
      oppgid.2 $e |- .0. = ( 0g ` R ) $.
      $( Zero in a monoid is a symmetric notion.  (Contributed by Stefan
         O'Rear, 26-Aug-2015.)  (Revised by Mario Carneiro, 16-Sep-2015.) $)
      oppgid $p |- .0. = ( 0g ` O ) $=
        ( vx vy cv cbs cfv cplusg co wceq wa wral eqid oppgplus eqeq1i grpidval
        cio wcel c0g ancom anbi12i bitr4i ralbii anbi2i iotabii oppgbas 3eqtr4i
        ) FHZAIJZUAZUKGHZAKJZLZUNMZUNUKUOLZUNMZNZGULOZNZFTUMUKUNBKJZLZUNMZUNUKV
        CLZUNMZNZGULOZNZFTCBUBJZVBVJFVAVIUMUTVHGULUTUSUQNVHUQUSUCVEUSVGUQVDURUN
        UOVCABUKUNUOPZDVCPZQRVFUPUNUOVCABUNUKVLDVMQRUDUEUFUGUHGULUOFACULPZVLESG
        ULVCFBVKULABDVNUIVMVKPSUJ $.
    $}

    $( The opposite of a group is a group.  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    oppggrp $p |- ( R e. Grp -> O e. Grp ) $=
      ( vx cgrp wcel cbs cfv cplusg cv cminusg c0g wceq eqid oppgbas a1i oppgid
      eqidd cmnd co grpmnd oppgmnd syl grpinvcl oppgplus grprinv syl5eq isgrpd2
      wa ) AEFZDAGHZBIHZBDJZAKHZHZALHZUKBGHMUJUKABCUKNZOPUJULRUPBLHMUJABUPCUPNZ
      QPUJASFBSFAUAABCUBUCUKAUNUMUQUNNZUDUJUMUKFUIUOUMULTUMUOAIHZTUPUTULABUOUMU
      TNZCULNUEUKUTAUNUMUPUQVAURUSUFUGUH $.

    $( Bidirectional form of ~ oppggrp .  (Contributed by Stefan O'Rear,
       26-Aug-2015.) $)
    oppggrpb $p |- ( R e. Grp <-> O e. Grp ) $=
      ( vx vy cgrp wcel oppggrp cfv eqid wtru cbs wceq oppgbas a1i cv cplusg co
      wa oppgplus coppg wb eqidd eqtri grppropd trud sylib impbii ) AFGZBFGZABC
      HUJBUAIZFGZUIBUKUKJZHULUIUBKDEALIZUKAUNUKLIMKUNBUKUMUNABCUNJNNOKUNUCDPZEP
      ZUKQIZRZUOUPAQIZRZMKUOUNGUPUNGSSURUPUOBQIZRUTVAUQBUKUOUPVAJZUMUQJTUSVAABU
      PUOUSJCVBTUDOUEUFUGUH $.

    ${
      oppginv.2 $e |- I = ( invg ` R ) $.
      $( Inverses in a group are a symmetric notion.  (Contributed by Stefan
         O'Rear, 26-Aug-2015.) $)
      oppginv $p |- ( R e. Grp -> I = ( invg ` O ) ) $=
        ( vx cgrp wcel cminusg cfv cbs wf cv cplusg co c0g wceq wral eqid wa wb
        grpinvf oppgplus grprinv syl5eq ralrimiva oppggrp isgrpinv syl mpbi2and
        oppgbas oppgid eqcomd ) AGHZCIJZBUNAKJZUPBLZFMZBJZURCNJZOZAPJZQZFUPRZUO
        BQZUPABUPSZEUBUNVCFUPUNURUPHTVAURUSANJZOVBVGUTACUSURVGSZDUTSZUCUPVGABUR
        VBVFVHVBSZEUDUEUFUNCGHUQVDTVEUAACDUGFUPUTCBUOVBUPACDVFUKVIACVBDVJULUOSU
        HUIUJUM $.
    $}
  $}

  ${
    $d x y G $.  $d x y I $.  $d x y O $.
    invoppggim.o $e |- O = ( oppG ` G ) $.
    invoppggim.i $e |- I = ( invg ` G ) $.
    $( The inverse is an antiautomorphism on any group.  (Contributed by Stefan
       O'Rear, 26-Aug-2015.) $)
    invoppggim $p |- ( G e. Grp -> I e. ( G GrpIso O ) ) $=
      ( vx vy cgrp wcel cghm co cbs cfv wf1o cgim cplusg eqid oppgbas cv wa id
      oppggrp grpinvf wceq grpinvadd oppgplus syl6eqr isghmd grpinvf1o sylanbrc
      3expb isgim ) AHIZBACJKIALMZUNBNBACOKIUMFGAPMZCPMZACBUNUNUNQZUNACDUQRZUOQ
      ZUPQZUMUAZACDUBUNABUQEUCUMFSZUNIZGSZUNIZTTVBVDUOKBMZVDBMZVBBMZUOKZVHVGUPK
      UMVCVEVFVIUDUNUOABVBVDUQUSEUEUKUOUPACVHVGUSDUTUFUGUHUMUNABUQEVAUIUNUNACBU
      QURULUJ $.
  $}

  ${
    $d x y A $.  $d x y z G $.  $d x y z O $.  $d x Z $.
    oppggic.o $e |- O = ( oppG ` G ) $.
    $( Every group is (naturally) isomorphic to its opposite.  (Contributed by
       Stefan O'Rear, 26-Aug-2015.) $)
    oppggic $p |- ( G e. Grp -> G ~=g O ) $=
      ( cgrp wcel cminusg cfv cgim co cgic wbr eqid invoppggim brgici syl ) ADE
      AFGZABHIEABJKAPBCPLMABPNO $.

    $( Being a submonoid is a symmetric property.  (Contributed by Mario
       Carneiro, 17-Sep-2015.) $)
    oppgsubm $p |- ( SubMnd ` G ) = ( SubMnd ` O ) $=
      ( vx vy vz csubmnd cfv cv wcel cmnd submrcl oppgmndb cplusg wral w3a eqid
      co wb issubm sylibr cbs wss ralcom oppgplus eleq1i 2ralbii bitr4i 3anbi3i
      c0g a1i oppgbas oppgid sylbi 3bitr4d pm5.21nii eqriv ) DAGHZBGHZDIZURJZAK
      JZUTUSJZUTALVCBKJZVBUTBLABCMZUAVBUTAUBHZUCZAUJHZUTJZEIZFIZANHZRZUTJZFUTOE
      UTOZPZVGVIVKVJBNHZRZUTJZEUTOFUTOZPZVAVCVPWASVBVOVTVGVIVOVNEUTOFUTOVTVNEFU
      TUTUDVSVNFEUTUTVRVMUTVLVQABVKVJVLQZCVQQZUEUFUGUHUIUKEFVFVLUTAVHVFQZVHQZWB
      TVBVDVCWASVEFEVFVQUTBVHVFABCWDULABVHCWEUMWCTUNUOUPUQ $.

    $( Being a subgroup is a symmetric property.  (Contributed by Mario
       Carneiro, 17-Sep-2015.) $)
    oppgsubg $p |- ( SubGrp ` G ) = ( SubGrp ` O ) $=
      ( vx vy csubg cfv cv wcel cgrp subgrcl oppggrpb sylibr csubmnd cminusg wa
      wral wb eqid issubg3 oppgsubm eleq2i oppginv fveq1d ralbidv anbi12d sylbi
      a1i eleq1d 3bitr4d pm5.21nii eqriv ) DAFGZBFGZDHZUMIZAJIZUOUNIZUOAKURBJIZ
      UQUOBKABCLZMUQUOANGZIZEHZAOGZGZUOIZEUOQZPUOBNGZIZVCBOGZGZUOIZEUOQZPZUPURU
      QVBVIVGVMVBVIRUQVAVHUOABCUAUBUHUQVFVLEUOUQVEVKUOUQVCVDVJAVDBCVDSZUCUDUIUE
      UFEUOAVDVOTUQUSURVNRUTEUOBVJVJSTUGUJUKUL $.

    ${
      oppgcntz.z $e |- Z = ( Cntz ` G ) $.
      $( A centralizer in a group is the same as the centralizer in the
         opposite group.  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      oppgcntz $p |- ( Z ` A ) = ( ( Cntz ` O ) ` A ) $=
        ( vx vy cfv cv wcel cplusg co wceq wral wa eqid oppgplus anbi2i cvv cbs
        ccntz eqcom eqeq12i bitr4i ralbii cntzrcl simprd elcntz biadan2 oppgbas
        wss 3bitr4i eqriv ) GADIZACUBIZIZABUAIZULZGJZURKZUTHJZBLIZMZVBUTVCMZNZH
        AOZPZPUSVAUTVBCLIZMZVBUTVIMZNZHAOZPZPUTUOKZUTUQKZVHVNUSVGVMVAVFVLHAVFVE
        VDNVLVDVEUCVJVEVKVDVCVIBCUTVBVCQZEVIQZRVCVIBCVBUTVQEVRRUDUEUFSSVOUSVHVO
        BTKUSURABUTDURQZFUGUHHUTURVCABDVSVQFUIUJVPUSVNVPCTKUSURACUTUPURBCEVSUKZ
        UPQZUGUHHUTURVIACUPVTVRWAUIUJUMUN $.
    $}

    ${
      oppgcntr.z $e |- Z = ( Cntr ` G ) $.
      $( The center of a group is the same as the center of the opposite
         group.  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      oppgcntr $p |- Z = ( Cntr ` O ) $=
        ( cbs cfv ccntz ccntr eqid oppgcntz cntrval eqtr4i oppgbas 3eqtr3i ) AF
        GZAHGZGZPBHGZGCBIGPABQDQJZKRAIGCPAQPJZTLEMPBSPABDUANSJLO $.
    $}
  $}

  ${
    $d x y z B $.  $d x y z M $.  $d x y z O $.  $d x W $.
    gsumwrev.b $e |- B = ( Base ` M ) $.
    gsumwrev.o $e |- O = ( oppG ` M ) $.
    $( A sum in an opposite monoid is the regular sum of a reversed word.
       (Contributed by Stefan O'Rear, 27-Aug-2015.)  (Proof shortened by Mario
       Carneiro, 28-Feb-2016.) $)
    gsumwrev $p |- ( ( M e. Mnd /\ W e. Word B ) ->
        ( O gsum W ) = ( M gsum ( reverse ` W ) ) ) $=
      ( wcel cgsu co creverse cfv wceq wi c0 cconcat oveq2 fveq2 oveq2d eqeq12d
      imbi2d vx vy vz cword cmnd cv cs1 rev0 syl6eq c0g oppgid gsum0 eqtr4i a1i
      eqid wa cplusg oppgmnd adantr simprl simprr s1cld oppgbas syl3anc gsumws1
      gsumccat ad2antll oppgplus eqtrd revccat syl2anc revs1 oveq1i simpl revcl
      ad2antrl oveq1d 3eqtrd syl5ibr expcom a2d wrdind impcom ) DAUDZGBUEGZCDHI
      ZBDJKZHIZLZWECUAUFZHIZBWJJKZHIZLZMWECNHIZBNHIZLZMWECUBUFZHIZBWRJKZHIZLZMW
      ECWRUCUFZUGZOIZHIZBXEJKZHIZLZMWEWIMUAUBUCDAWJNLZWNWQWEXJWKWOWMWPWJNCHPXJW
      LNBHXJWLNJKNWJNJQUHUIRSTWJWRLZWNXBWEXKWKWSWMXAWJWRCHPXKWLWTBHWJWRJQRSTWJX
      ELZWNXIWEXLWKXFWMXHWJXECHPXLWLXGBHWJXEJQRSTWJDLZWNWIWEXMWKWFWMWHWJDCHPXMW
      LWGBHWJDJQRSTWQWEWOBUJKZWPCXNBCXNFXNUOZUKULBXNXOULUMUNWRWDGZXCAGZUPZWEXBX
      IWEXRXBXIMXBXIWEXRUPZXCWSBUQKZIZXCXAXTIZLWSXAXCXTPXSXFYAXHYBXSXFWSCXDHIZC
      UQKZIZYAXSCUEGZXPXDWDGZXFYELWEYFXRBCFURUSWEXPXQUTZXSXCAWEXPXQVAVBZAYDCWRX
      DABCFEVCZYDUOZVFVDXSYEWSXCYDIYAXSYCXCWSYDXQYCXCLWEXPAXCCYJVEVGRXTYDBCWSXC
      XTUOZFYKVHUIVIXSXHBXDWTOIZHIZBXDHIZXAXTIZYBXSXGYMBHXSXGXDJKZWTOIZYMXSXPYG
      XGYRLYHYIAWRXDVJVKYQXDWTOXCVLVMUIRXSWEYGWTWDGZYNYPLWEXRVNYIXPYSWEXQAWRVOV
      PAXTBXDWTEYLVFVDXSYOXCXAXTXQYOXCLWEXPAXCBEVEVGVQVRSVSVTWAWBWC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              p-Groups and Sylow groups; Sylow's theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c od $.
  $c gEx $.
  $c pGrp $.
  $c pSyl $.

  $( Extend class notation to include the order function on the elements of a
     group. $)
  cod $a class od $.

  $( Extend class notation to include the order function on the elements of a
     group. $)
  cgex $a class gEx $.

  $( Extend class notation to include the class of all p-groups. $)
  cpgp $a class pGrp $.

  $( Extend class notation to include the class of all Sylow p-subgroups of a
     group. $)
  cslw $a class pSyl $.

  ${
    $d g h i k n p x $.
    $( Define the order of an element in a group.  (Contributed by Mario
       Carneiro, 13-Jul-2014.)  (Revised by Stefan O'Rear, 4-Sep-2015.) $)
    df-od $a |- od = ( g e. _V |-> ( x e. ( Base ` g ) |->
            [_ { n e. NN | ( n ( .g ` g ) x ) = ( 0g ` g ) } / i ]_
              if ( i = (/) , 0 , sup ( i , RR , `' < ) ) ) ) $.

    $( Define the exponent of a group.  (Contributed by Mario Carneiro,
       13-Jul-2014.)  (Revised by Stefan O'Rear, 4-Sep-2015.) $)
    df-gex $a |- gEx = ( g e. _V |-> [_ { n e. NN |
            A. x e. ( Base ` g ) ( n ( .g ` g ) x ) = ( 0g ` g ) } / i ]_
              if ( i = (/) , 0 , sup ( i , RR , `' < ) ) ) $.

    $( Define the set of p-groups, which are groups such that every element has
       a power of ` p ` as its order.  (Contributed by Mario Carneiro,
       15-Jan-2015.) $)
    df-pgp $a |- pGrp = { <. p , g >. | ( ( p e. Prime /\ g e. Grp ) /\
      A. x e. ( Base ` g ) E. n e. NN0 ( ( od ` g ) ` x ) = ( p ^ n ) ) } $.

    $( Define the set of Sylow p-subgroups of a group ` g ` .  A Sylow
       p-subgroup is a p-group that is not a subgroup of any other p-groups in
       ` g ` .  (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    df-slw $a |- pSyl = ( p e. Prime , g e. Grp |-> { h e. ( SubGrp ` g ) |
   A. k e. ( SubGrp ` g ) ( ( h C_ k /\ p pGrp ( g |`s k ) ) <-> h = k ) } ) $.
  $}

  ${
    $d g i y $.  $d x y A $.  $d g x y G $.  $d g x y .x. $.  $d g x y .0. $.
    $d i x I $.  $d g x X $.
    odval.1 $e |- X = ( Base ` G ) $.
    odval.2 $e |- .x. = ( .g ` G ) $.
    odval.3 $e |- .0. = ( 0g ` G ) $.
    odval.4 $e |- O = ( od ` G ) $.
    $( Value of the order function.  (Contributed by Mario Carneiro,
       13-Jul-2014.) $)
    odfval $p |- O = ( x e. X |-> [_ { y e. NN | ( y .x. x ) = .0. } / i ]_
            if ( i = (/) , 0 , sup ( i , RR , `' < ) ) ) $=
      ( vg cod cfv cv wceq cn c0 cbs co crab cc0 clt ccnv csup cif csb cmpt cvv
      wcel cmg fveq2 syl6eqr oveqd eqeq12d rabbidv csbeq1d mpteq12dv df-od fvex
      cr eqeltri mptex fvmpt wn fvprc syl5eq mpteq1d mpt0 syl6eq eqtr4d pm2.61i
      c0g eqtri ) FENOZAGDBPZAPZCUAZHQZBRUBZDPZSQUCWBVBUDUEUFUGZUHZUIZLEUJUKZVP
      WEQMEAMPZTOZDVQVRWGULOZUAZWGVNOZQZBRUBZWCUHZUIWEUJNWGEQZAWHWNGWDWOWHETOZG
      WGETUMIUNWODWMWAWCWOWLVTBRWOWJVSWKHWOWICVQVRWOWIEULOCWGEULUMJUNUOWOWKEVNO
      HWGEVNUMKUNUPUQURUSAMDBUTAGWDGWPUJIETVAVCVDVEWFVFZVPSWEENVGWQWEASWDUISWQA
      GSWDWQGWPSIETVGVHVIAWDVJVKVLVMVO $.

    odval.i $e |- I = { y e. NN | ( y .x. A ) = .0. } $.
    $( Second substitution for the group order definition.  (Contributed by
       Mario Carneiro, 13-Jul-2014.)  (Revised by Stefan O'Rear,
       5-Sep-2015.) $)
    odval $p |- ( A e. X -> ( O ` A ) =
          if ( I = (/) , 0 , sup ( I , RR , `' < ) ) ) $=
      ( vx vi cv wceq cn cc0 cr co crab c0 clt ccnv csup cif csb eqeq1d rabbidv
      oveq2 syl6eqr csbeq1d cvv nnex rabex eqeltri eqeq1 supeq1 ifbieq2d csbief
      nfcv syl6eq odfval c0ex wor ltso cnvso mpbi supex ifex fvmpt ) NBOAPZNPZC
      UAZHQZARUBZOPZUCQZSVRTUDUEZUFZUGZUHZEUCQZSETVTUFZUGZGFVNBQZWCOEWBUHWFWGOV
      QEWBWGVQVMBCUAZHQZARUBZEWGVPWIARWGVOWHHVNBVMCUKUIUJMULUMOEWBWFEWJUNMWIARU
      OUPUQOWFVBVREQVSWDWAWESVREUCURTVREVTUSUTVAVCNACODFGHIJKLVDWDSWEVETEVTTUDV
      FTVTVFVGTUDVHVIVJVKVL $.

    $( The group element order is either zero or a nonzero multiplier that
       annihilates the element.  (Contributed by Mario Carneiro, 14-Jan-2015.)
       (Revised by Stefan O'Rear, 5-Sep-2015.) $)
    odlem1 $p |- ( A e. X -> ( ( ( O ` A ) = 0 /\ I = (/) ) \/
            ( O ` A ) e. I ) ) $=
      ( wcel cfv c0 wceq cc0 wi cn cr clt ccnv cif wa wo odval eqeq2 imbi1d orc
      csup expcom adantl wn c1 cuz wss wne cv co crab ssrab2 nnuz 3sstr4i df-ne
      eqcomi biimpri infmssuzcl sylancr eleq1a syl olc syl6 ifbothda mpd ) BGNZ
      BFOZEPQZREUAUBUCUKZUDZQZVQRQZVRUEZVQENZUFZABCDEFGHIJKLMUGVRWBWESZVQVSQZWE
      SWAWESVPRVSRVTQWBWAWERVTVQUHUIVSVTQWGWAWEVSVTVQUHUIVRWFVPWBVRWEWCWDUJULUM
      VPVRUNZUEZWGWDWEWIVSENZWGWDSWIEUOUPOZUQEPURZWJAUSBCUTHQZATVATEWKWMATVBMTW
      KVCVFVDWHWLVPWLWHEPVEVGUMEUOVHVIVSEVQVJVKWDWCVLVMVNVO $.
  $}

  ${
    $d w y z $.  $d y .0. $.  $d x y A $.  $d y N $.  $d x y O $.  $d y .x. $.
    $d x y z G $.  $d x y X $.
    odcl.1 $e |- X = ( Base ` G ) $.
    odcl.2 $e |- O = ( od ` G ) $.
    $( The order of a group element is always a nonnegative integer.
       (Contributed by Mario Carneiro, 14-Jan-2015.)  (Revised by Stefan
       O'Rear, 5-Sep-2015.) $)
    odcl $p |- ( A e. X -> ( O ` A ) e. NN0 ) $=
      ( vy wcel cfv cn cc0 wceq wo cn0 cv cmg co c0g crab eqid c0 odlem1 elrabi
      wa simpl orim12i syl orcomd elnn0 sylibr ) ADHZACIZJHZULKLZMULNHUKUNUMUKU
      NGOABPIZQBRIZLZGJSZUALZUDZULURHZMUNUMMGAUOBURCDUPEUOTUPTFURTUBUTUNVAUMUNU
      SUEUQGULJUCUFUGUHULUIUJ $.

    $( Functionality of the group element order.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    odf $p |- O : X --> NN0 $=
      ( vx vy vw vz cn0 wf wfn cv cfv wceq cc0 cr clt wor eqid wcel wral cmg co
      c0g cn crab c0 ccnv csup cif c0ex ltso cnvso mpbi supex ifex csbex odfval
      csb fnmpti odcl rgen ffnfv mpbir2an ) CJBKBCLFMZBNJUAZFCUBGCHIMGMAUCNZUDA
      UENZOIUFUGZHMZUHOZPVKQRUIZUJZUKZUTBHVJVOVLPVNULQVKVMQRSQVMSUMQRUNUOUPUQUR
      GIVHHABCVIDVHTVITEUSVAVGFCVFABCDEVBVCFCJBVDVE $.

    odid.3 $e |- .x. = ( .g ` G ) $.
    odid.4 $e |- .0. = ( 0g ` G ) $.
    $( Any element to the power of its order is the identity.  (Contributed by
       Mario Carneiro, 14-Jan-2015.)  (Revised by Stefan O'Rear,
       5-Sep-2015.) $)
    odid $p |- ( A e. X -> ( ( O ` A ) .x. A ) = .0. ) $=
      ( vy wcel cfv cc0 wceq cv co cn crab oveq1 c0 wa sylan9eqr adantrr eqeq1d
      mulg0 elrab simprbi adantl eqid odlem1 mpjaodan ) AELZADMZNOZKPZABQZFOZKR
      SZUAOZUBUNABQZFOZUNUSLZUMUOVBUTUOUMVANABQFUNNABTEBCAFGJIUFUCUDVCVBUMVCUNR
      LVBURVBKUNRUPUNOUQVAFUPUNABTUEUGUHUIKABCUSDEFGIJHUSUJUKUL $.

    $( Any positive annihilator of a group element is an upper bound on the
       (positive) order of the element.  (Contributed by Mario Carneiro,
       14-Jan-2015.)  (Revised by Stefan O'Rear, 5-Sep-2015.) $)
    odlem2 $p |- ( ( A e. X /\ N e. NN /\ ( N .x. A ) = .0. ) ->
        ( O ` A ) e. ( 1 ... N ) ) $=
      ( vy wcel cn co wceq cfv c1 wa adantl cfz cv crab oveq1 eqeq1d elrab ccnv
      cr clt csup c0 cc0 cif eqid odval n0i iffalse syl sylan9eq cle wbr ssrab2
      wn cuz wss nnuz sseqtri ne0i infmssuzcl sylancr sseldi infmssuzle mpan wb
      wne cz elrabi nnzd fznn mpbir2and eqeltrd sylan2br 3impb ) AFMZDNMZDABOZG
      PZAEQZRDUAOZMZWEWGSWDDLUBZABOZGPZLNUCZMZWJWMWGLDNWKDPWLWFGWKDABUDUEUFWDWO
      SZWHWNUHUIUGUJZWIWDWOWHWNUKPZULWQUMZWQLABCWNEFGHJKIWNUNUOWOWRVCWSWQPWNDUP
      WRULWQUQURUSWPWQWIMZWQNMZWQDUTVAZWPWNNWQWMLNVBZWPWNRVDQZVEZWNUKVOZWQWNMWN
      NXDXCVFVGZWOXFWDWNDVHTWNRVIVJVKWOXBWDXEWOXBXGDWNRVLVMTWOWTXAXBSVNZWDWODVP
      MXHWODWMLDNVQVRWQDVSURTVTWAWBWC $.

    $( Reduce the argument of a group multiple by modding out the order of the
       element.  (Contributed by Mario Carneiro, 23-Sep-2015.) $)
    odmodnn0 $p |- ( ( ( G e. Mnd /\ A e. X /\ N e. NN0 ) /\
      ( O ` A ) e. NN ) -> ( ( N mod ( O ` A ) ) .x. A ) = ( N .x. A ) ) $=
      ( wcel cn0 cfv co caddc wceq adantl syl2anc eqtrd cmnd w3a cn wa cdiv cfl
      cmul cmo cplusg simpl1 nnnn0 cr cc0 cle wbr simpl3 nn0red nnrp rerpdivcld
      crp nn0ge0d nnre nngt0 divge0 syl22anc flge0nn0 nn0mulcld cz nn0zd zmodcl
      sylancom simpl2 eqid mulgnn0dir syl13anc nn0cnd mulcomd oveq1d mulgnn0ass
      clt odid syl oveq2d mulgnn0z cmin modval pncan3d mulgnn0cl syl3anc mndlid
      recnd 3eqtr3rd ) CUALZAFLZDMLZUBZAENZUCLZUDZWQDWQUEOZUFNZUGOZDWQUHOZPOZAB
      OZGXCABOZCUINZOZDABOXFWSXEXBABOZXFXGOZXHWSWMXBMLXCMLZWNXEXJQWMWNWOWRUJZWS
      WQXAWRWQMLZWPWQUKRZWSWTULLUMWTUNUOZXAMLZWSDWQWSDWMWNWOWRUPZUQZWRWQUTLZWPW
      QURRZUSWSDULLZUMDUNUOWQULLZUMWQVTUOZXOXRWSDXQVAWRYBWPWQVBRZWRYCWPWQVCRDWQ
      VDVEWTVFSZVGZWPWRDVHLXKWSDXQVIDWQVJVKZWMWNWOWRVLZFXGBCXBXCAHJXGVMZVNVOWSX
      IGXFXGWSXIXAWQUGOZABOZGWSXBYJABWSWQXAWSWQYDWKWSXAYEVPVQVRWSYKXAWQABOZBOZG
      WSWMXPXMWNYKYMQXLYEXNYHFBCXAWQAHJVSVOWSYMXAGBOZGWSYLGXABWSWNYLGQYHABCEFGH
      IJKWAWBWCWSWMXPYNGQXLYEFBCXAGHJKWDSTTTVRTWSXDDABWSXDXBDXBWEOZPODWSXCYOXBP
      WSYAXSXCYOQXRXTDWQWFSWCWSXBDWSXBYFVPWSDXQVPWGTVRWSWMXFFLZXHXFQXLWSWMXKWNY
      PXLYGYHFBCXCAHJWHWIFXGCXFGHYIKWJSWL $.

    ${
      mndodconglem.1 $e |- ( ph -> G e. Mnd ) $.
      mndodconglem.2 $e |- ( ph -> A e. X ) $.
      mndodconglem.3 $e |- ( ph -> ( O ` A ) e. NN ) $.
      mndodconglem.4 $e |- ( ph -> M e. NN0 ) $.
      mndodconglem.5 $e |- ( ph -> N e. NN0 ) $.
      mndodconglem.6 $e |- ( ph -> M < ( O ` A ) ) $.
      mndodconglem.7 $e |- ( ph -> N < ( O ` A ) ) $.
      mndodconglem.8 $e |- ( ph -> ( M .x. A ) = ( N .x. A ) ) $.
      $( Lemma for ~ mndodcong .  (Contributed by Mario Carneiro,
         23-Sep-2015.) $)
      mndodconglem $p |- ( ( ph /\ M <_ N ) -> M = N ) $=
        ( cle wbr wceq cc0 cmin co cfv caddc c1 cfz wcel nnred recnd addsubassd
        cn nn0red clt nnzd nn0zd zaddcld cr cn0 nn0addge1 syl2anc ltletrd cz wb
        zred znnsub mpbid eqeltrrd addsub12d oveq1d cplusg cmnd eqid mulgnn0dir
        nnnn0d syl13anc 3eqtr4d pncan3d odid syl odlem2 syl3anc elfzle2 zsubcld
        eqtrd addge01d mpbird subge0d wa letri3d biimprd mpan2d imp ) AEFUBUCZE
        FUDZAWRFEUBUCZWSAUEEFUFUGZUBUCZWTAXBBGUHZXCXAUIUGZUBUCZAXCUJXDUKUGULZXE
        ABHULZXDUPULXDBCUGZIUDXFOAXCEUIUGZFUFUGZXDUPAXCEFAXCAXCPUMZUNZAEAEQUQZU
        NZAFAFRUQZUNZUOAFXIURUCZXJUPULZAFXCXIXOXKAXIAXCEAXCPUSZAEQUTZVAZVITAXCV
        BULEVCULZXCXIUBUCXKQXCEVDVEVFAFVGULZXIVGULXQXRVHAFRUTZYAFXIVJVEVKVLAXHE
        XCFUFUGZUIUGZBCUGZIAXDYFBCAXCEFXLXNXPVMVNAYGFYEUIUGZBCUGZIAEBCUGZYEBCUG
        ZDVOUHZUGZFBCUGZYKYLUGZYGYIAYJYNYKYLUAVNADVPULZYBYEVCULZXGYGYMUDNQAYEAF
        XCURUCZYEUPULZTAYCXCVGULYRYSVHYDXSFXCVJVEVKVSZOHYLCDEYEBJLYLVQZVRVTAYPF
        VCULYQXGYIYOUDNRYTOHYLCDFYEBJLUUAVRVTWAAYIXCBCUGZIAYHXCBCAFXCXPXLWBVNAX
        GUUBIUDOBCDGHIJKLMWCWDWIWIWIBCDXDGHIJKLMWEWFXCUJXDWGWDAXCXAXKAXAAEFXTYD
        WHVIWJWKAEFXMXOWLVKAWSWRWTWMAEFXMXOWNWOWPWQ $.
    $}

    $( If two multipliers are congruent relative to the base point's order, the
       corresponding multiples are the same.  (Contributed by Mario Carneiro,
       23-Sep-2015.) $)
    mndodcong $p |- ( ( ( G e. Mnd /\ A e. X ) /\
      ( M e. NN0 /\ N e. NN0 ) /\ ( O ` A ) e. NN ) ->
        ( ( O ` A ) || ( M - N ) <-> ( M .x. A ) = ( N .x. A ) ) ) $=
      ( wcel wa cn0 co wceq wbr adantr nn0red cmnd cfv cn w3a cmo cmin cdivides
      oveq1 simp2l nn0zd simp3 zmodcld simp2r simp1l simp1r clt crp nnrpd modlt
      cr syl2anc simpr mndodconglem cle eqcomd lecasei ex impbid2 cz wb moddvds
      syl3anc odmodnn0 syl31anc eqeq12d 3bitr3d ) CUAMZAGMZNZDOMZEOMZNZAFUBZUCM
      ZUDZDWCUEPZEWCUEPZQZWFABPZWGABPZQZWCDEUFPUGRZDABPZEABPZQWEWHWKWFWGABUHWEW
      KWHWEWKNZWHWFWGWOWFWEWFOMWKWEDWCWEDVSVTWAWDUIZUJZVSWBWDUKZULSZTWOWGWEWGOM
      WKWEEWCWEEVSVTWAWDUMZUJZWRULSZTWOABCWFWGFGHIJKLWEVQWKVQVRWBWDUNZSZWEVRWKV
      QVRWBWDUOZSZWEWDWKWRSZWSXBWEWFWCUPRZWKWEDUTMWCUQMZXHWEDWPTWEWCWRURZDWCUSV
      ASZWEWGWCUPRZWKWEEUTMXIXLWEEWTTXJEWCUSVASZWEWKVBZVCWOWGWFVDRNWGWFWOABCWGW
      FFGHIJKLXDXFXGXBWSXMXKWOWIWJXNVEVCVEVFVGVHWEWDDVIMEVIMWHWLVJWRWQXADEWCVKV
      LWEWIWMWJWNWEVQVRVTWDWIWMQXCXEWPWRABCDFGHIJKLVMVNWEVQVRWAWDWJWNQXCXEWTWRA
      BCEFGHIJKLVMVNVOVP $.

    $( If two multipliers are congruent relative to the base point's order, the
       corresponding multiples are the same.  For monoids, the reverse
       implication is false for elements with infinite order.  For example, the
       powers of ` 2 ` mod ` 10 ` are 1,2,4,8,6,2,4,8,6,... so that the
       identity 1 never repeats, which is infinite order by our definition, yet
       other numbers like 6 appear many times in the sequence.  (Contributed by
       Mario Carneiro, 23-Sep-2015.) $)
    mndodcongi $p |- ( ( G e. Mnd /\ A e. X /\ ( M e. NN0 /\ N e. NN0 ) ) ->
        ( ( O ` A ) || ( M - N ) -> ( M .x. A ) = ( N .x. A ) ) ) $=
      ( wcel cn0 co cdivides wceq wi cc0 cz cmnd wa w3a cfv cn mndodcong biimpd
      cmin wbr 3expia 3impa wb zsubcl syl2an 3ad2ant3 0dvds syl cc nn0cn subeq0
      nn0z oveq1 syl6bi sylbid breq1 imbi1d syl5ibrcom wo 3ad2ant2 elnn0 mpjaod
      odcl sylib ) CUAMZAGMZDNMZENMZUBZUCZAFUDZUEMZVTDEUHOZPUIZDABOEABOQZRZVTSQ
      ZVNVOVRWAWERVNVOUBZVRWAWEWGVRWAUCWCWDABCDEFGHIJKLUFUGUJUKVSWEWFSWBPUIZWDR
      VSWHWBSQZWDVSWBTMZWHWIULVRVNWJVOVPDTMETMWJVQDVAEVADEUMUNUOWBUPUQVSWIDEQZW
      DVRVNWIWKULZVOVPDURMEURMWLVQDUSEUSDEUTUNUODEABVBVCVDWFWCWHWDVTSWBPVEVFVGV
      SVTNMZWAWFVHVOVNWMVRACFGIJVLVIVTVJVMVK $.

    $( The only multiples of ` A ` that are equal to the identity are the
       multiples of the order of ` A ` .  (Contributed by Mario Carneiro,
       23-Sep-2015.) $)
    oddvdsnn0 $p |- ( ( G e. Mnd /\ A e. X /\ N e. NN0 ) ->
      ( ( O ` A ) || N <-> ( N .x. A ) = .0. ) ) $=
      ( wcel cn0 cdivides wbr co wceq wb cc0 wa cmnd w3a cn cmin 0nn0 mndodcong
      cfv wi 3expia mpanr2 3impa cc nn0cn 3ad2ant3 breq2d mulg0 3ad2ant2 eqeq2d
      subid1d bibi12d sylibd simpr breq1d simpl3 nn0z 0dvds adantr oveq1 eqeq1d
      cz syl5ibrcom wn wne c1 cfz odlem2 3com23 elfznn nnne0 3ad2antl2 necon2bd
      3syl wo elnn0 sylib ord syld impancom impbid 3bitrd ex odcl mpjaod ) CUAL
      ZAFLZDMLZUBZAEUGZUCLZWRDNOZDABPZGQZRZWRSQZWQWSWRDSUDPZNOZXASABPZQZRZXCWNW
      OWPWSXIUHZWNWOTZWPSMLZXJUEXKWPXLTWSXIABCDSEFGHIJKUFUIUJUKWQXFWTXHXBWQXEDW
      RNWQDWPWNDULLWODUMUNUSUOWQXGGXAWOWNXGGQZWPFBCAGHKJUPUQZURUTVAWQXDXCWQXDTZ
      WTSDNOZDSQZXBXOWRSDNWQXDVBVCXOWPDVJLXPXQRWNWOWPXDVDDVEDVFWBXOXQXBXOXBXQXM
      WQXMXDXNVGXQXAXGGDSABVHVIVKWQXBXDXQWQXBTZXDDUCLZVLXQXRXSWRSWOWNXBXSWRSVMZ
      UHWPWOXBXSXTWOXBXSUBWRVNDVOPLZWSXTWOXSXBYAABCDEFGHIJKVPVQWRDVRWRVSWBUIVTW
      AXRXSXQXRWPXSXQWCWNWOWPXBVDDWDWEWFWGWHWIWJWKWQWRMLZWSXDWCWOWNYBWPACEFHIWL
      UQWRWDWEWM $.

    $( If a nonzero multiple of an element is zero, the element has positive
       order.  (Contributed by Stefan O'Rear, 5-Sep-2015.)  (Revised by Mario
       Carneiro, 22-Sep-2015.) $)
    odnncl $p |- ( ( ( G e. Grp /\ A e. X /\ N e. ZZ ) /\
      ( N =/= 0 /\ ( N .x. A ) = .0. ) ) -> ( O ` A ) e. NN ) $=
      ( wcel cc0 co wceq wa cfv cn syl oveq1 cgrp cz w3a wne c1 cabs cfz simpl2
      wn simprl cc wb simpl3 zcnd abs00 necon3bbid mpbird cn0 wo nn0abscl elnn0
      sylib ord mt3d cneg simprr eqeq1d syl5ibrcom cminusg eqid mulgneg syl3anc
      simpl1 fveq2d grpinvid 3eqtrd zred absord mpjaod odlem2 elfznn ) CUALZAFL
      ZDUBLZUCZDMUDZDABNZGOZPZPZAEQZUEDUFQZUGNLZWKRLWJWCWLRLZWLABNZGOZWMWBWCWDW
      IUHZWJWNWLMOZWJWRUIZWFWEWFWHUJWJDUKLZWSWFULWJDWBWCWDWIUMZUNWTWRDMDUOUPSUQ
      WJWNWRWJWLURLZWNWRUSWJWDXBXADUTSWLVAVBVCVDWJWLDOZWPWLDVEZOZWJWPXCWHWEWFWH
      VFZXCWOWGGWLDABTVGVHWJWPXEXDABNZGOWJXGWGCVIQZQZGXHQZGWJWBWDWCXGXIOWBWCWDW
      IVMZXAWQFBCXHDAHJXHVJZVKVLWJWGGXHXFVNWJWBXJGOXKCXHGKXLVOSVPXEWOXGGWLXDABT
      VGVHWJDWJDXAVQVRVSABCWLEFGHIJKVTVLWKWLWAS $.

    $( Reduce the argument of a group multiple by modding out the order of the
       element.  (Contributed by Mario Carneiro, 14-Jan-2015.)  (Revised by
       Mario Carneiro, 6-Sep-2015.) $)
    odmod $p |- ( ( ( G e. Grp /\ A e. X /\ N e. ZZ ) /\ ( O ` A ) e. NN ) ->
      ( ( N mod ( O ` A ) ) .x. A ) = ( N .x. A ) ) $=
      ( wcel cz cfv co cmul wceq syl2anc oveq1d syl13anc cgrp w3a cn wa cmo cfl
      cdiv cmin csg cr crp simpl3 zred simpr nnrpd modval simpl1 nndivred flcld
      nnzd zmulcld simpl2 eqid mulgsubdir cc nncn zcn mulcom syl2an mulgass syl
      odid oveq2d mulgz eqtrd 3eqtrd mulgcl syl3anc grpsubid1 ) CUALZAFLZDMLZUB
      ZAENZUCLZUDZDWDUEOZABODWDDWDUGOZUFNZPOZUHOZABOZDABOZWJABOZCUINZOZWMWFWGWK
      ABWFDUJLWDUKLWGWKQWFDVTWAWBWEULZUMZWFWDWCWEUNZUODWDUPRSWFVTWBWJMLWAWLWPQV
      TWAWBWEUQZWQWFWDWIWFWDWSUTZWFWHWFDWDWRWSURUSZVAVTWAWBWEVBZFBCDWOWJAHJWOVC
      ZVDTWFWPWMGWOOZWMWFWNGWMWOWFWNWIWDPOZABOZWIWDABOZBOZGWFWJXFABWFWEWIMLZWJX
      FQZWSXBWEWDVELWIVELXKXJWDVFWIVGWDWIVHVIRSWFVTXJWDMLWAXGXIQWTXBXAXCFBCWIWD
      AHJVJTWFXIWIGBOZGWFXHGWIBWFWAXHGQXCABCEFGHIJKVLVKVMWFVTXJXLGQWTXBFBCWIGHJ
      KVNRVOVPVMWFVTWMFLZXEWMQWTWFVTWBWAXMWTWQXCFBCDAHJVQVRFCWOWMGHKXDVSRVOVP
      $.

    $( The only multiples of ` A ` that are equal to the identity are the
       multiples of the order of ` A ` .  (Contributed by Mario Carneiro,
       14-Jan-2015.)  (Revised by Mario Carneiro, 23-Sep-2015.) $)
    oddvds $p |- ( ( G e. Grp /\ A e. X /\ N e. ZZ ) ->
      ( ( O ` A ) || N <-> ( N .x. A ) = .0. ) ) $=
      ( wcel cdivides wbr co wceq wb cc0 wa syl cgrp cz w3a cfv cn simpr simpl3
      cmo dvdsval3 syl2anc simpl2 mulg0 oveq1 eqeq1d syl5ibrcom wn cle clt zred
      wi cr crp nnrpd modlt zmodcld nn0red nnred ltnled mpbid c1 odlem2 elfzle2
      cfz 3com23 3expia con3d impancom cn0 wo elnn0 sylib ord syld impbid odmod
      3bitrd breq1d 0dvds wne odnncl nnne0d expr necon4d odcl 3ad2ant2 mpjaodan
      ) CUALZAFLZDUBLZUCZAEUDZUELZXADMNZDABOZGPZQXARPZWTXBSZXCDXAUHOZRPZXHABOZG
      PZXEXGXBWSXCXIQWTXBUFZWQWRWSXBUGZXADUIUJXGXIXKXGXKXIRABOZGPZXGWRXOWQWRWSX
      BUKZFBCAGHKJULZTXIXJXNGXHRABUMUNUOXGXKXHUELZUPZXIXGWRXAXHUQNZUPZXKXSUTXPX
      GXHXAURNZYAXGDVALXAVBLYBXGDXMUSXGXAXLVCDXAVDUJXGXHXAXGXHXGDXAXMXLVEZVFXGX
      AXLVGVHVIWRXKYAXSWRXKSXRXTWRXKXRXTWRXRXKXTWRXRXKUCXAVJXHVMOLXTABCXHEFGHIJ
      KVKXAVJXHVLTVNVOVPVQUJXGXRXIXGXHVRLXRXIVSYCXHVTWAWBWCWDXGXJXDGABCDEFGHIJK
      WEUNWFWTXFSZXCRDMNZDRPZXEYDXARDMWTXFUFWGYDWSYEYFQWQWRWSXFUGDWHTYDYFXEYDXE
      YFXOYDWRXOWQWRWSXFUKXQTYFXDXNGDRABUMUNUOWTXEXFYFWTXESDRXARWTDRWIZXEXARWIZ
      WTYGXEYHWTYGXESSXAABCDEFGHIJKWJWKWLVQWMVQWDWFWTXAVRLZXBXFVSWRWQYIWSACEFHI
      WNWOXAVTWAWP $.

    $( Any group element is annihilated by any multiple of its order.
       (Contributed by Stefan O'Rear, 5-Sep-2015.)  (Revised by Mario Carneiro,
       23-Sep-2015.) $)
    oddvdsi $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) || N ) ->
      ( N .x. A ) = .0. ) $=
      ( cgrp wcel cfv cdivides wbr w3a co wceq cz simp3 dvdszrcl simprd syl3an3
      wb oddvds mpbid ) CLMZAFMZAENZDOPZQUKDABRGSZUHUIUKUAUKUHUIDTMZUKULUEUKUJT
      MUMUJDUBUCABCDEFGHIJKUFUDUG $.

    $( If two multipliers are congruent relative to the base point's order, the
       corresponding multiples are the same.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    odcong $p |- ( ( G e. Grp /\ A e. X /\ ( M e. ZZ /\ N e. ZZ ) ) ->
        ( ( O ` A ) || ( M - N ) <-> ( M .x. A ) = ( N .x. A ) ) ) $=
      ( wcel cz cfv co wceq wb mulgcl syl3anc cgrp wa w3a cmin cdivides wbr csg
      zsubcl oddvds syl3an3 simp1 simp3l simp3r eqid mulgsubdir syl13anc eqeq1d
      simp2 grpsubeq0 3bitrd ) CUAMZAGMZDNMZENMZUBZUCZAFODEUDPZUEUFZVGABPZHQZDA
      BPZEABPZCUGOZPZHQZVKVLQZVEVAVBVGNMVHVJRDEUHABCVGFGHIJKLUIUJVFVIVNHVFVAVCV
      DVBVIVNQVAVBVEUKZVAVBVCVDULZVAVBVCVDUMZVAVBVEURZGBCDVMEAIKVMUNZUOUPUQVFVA
      VKGMZVLGMZVOVPRVQVFVAVCVBWBVQVRVTGBCDAIKSTVFVAVDVBWCVQVSVTGBCEAIKSTGCVMVK
      VLHILWAUSTUT $.

    $( The ~ oddvds property uniquely defines the group order.  (Contributed by
       Stefan O'Rear, 6-Sep-2015.) $)
    odeq $p |- ( ( G e. Grp /\ A e. X /\ N e. NN0 ) -> ( N = ( O ` A ) <->
          A. y e. NN0 ( N || y <-> ( y .x. A ) = .0. ) ) ) $=
      ( wcel cn0 wceq cdivides wbr co wb wral cgrp w3a cfv cv wi wa nn0z oddvds
      cz syl3an3 3expa ralrimiva breq1 bibi1d ralbidv syl5ibrcom 3adant3 simpl3
      simpl2 odcl odid 3ad2ant2 breq2 oveq1 eqeq1d bibi12d rspcva mpbird iddvds
      syl sylan 3syl 3ad2antl3 mpbid adantr dvdseq syl22anc ex impbid ) DUAMZBG
      MZENMZUBZEBFUCZOZEAUDZPQZWFBCRZHOZSZANTZVTWAWEWKUEWBVTWAUFZWKWEWDWFPQZWIS
      ZANTWLWNANVTWAWFNMZWNWOVTWAWFUIMWNWFUGBCDWFFGHIJKLUHUJUKULWEWJWNANWEWGWMW
      IEWDWFPUMUNUOUPUQWCWKWEWCWKUFZWBWDNMZEWDPQZWDEPQZWEVTWAWBWKURZWPWAWQVTWAW
      BWKUSZBDFGIJUTZVJWPWRWDBCRZHOZWPWAXDXABCDFGHIJKLVAVJWCWQWKWRXDSZWAVTWQWBX
      BVBWJXEAWDNWFWDOZWGWRWIXDWFWDEPVCXFWHXCHWFWDBCVDVEVFVGVKVHWPWSEBCRZHOZWPE
      EPQZXHWPWBEUIMZXIWTEUGZEVIVLWBVTWKXIXHSZWAWJXLAENWFEOZWGXIWIXHWFEEPVCXMWH
      XGHWFEBCVDVEVFVGVMVNWCWSXHSZWKWBVTWAXJXNXKBCDEFGHIJKLUHUJVOVHEWDVPVQVRVS
      $.

    $( A non-conditional definition of the group order.  (Contributed by Stefan
       O'Rear, 6-Sep-2015.) $)
    odval2 $p |- ( ( G e. Grp /\ A e. X ) -> ( O ` A ) = ( iota_ x e. NN0
            A. y e. NN0 ( x || y <-> ( y .x. A ) = .0. ) ) ) $=
      ( cgrp wcel wa cv cdivides wceq wb cn0 wbr wral crio cfv odcl adantl odeq
      co 3expa bicomd riota5 eqcomd ) EMNZCGNZOZAPZBPZQUAUQCDUHHRSBTUBZATUCCFUD
      ZUOURATUSUNUSTNUMCEFGIJUEUFUOUPTNZOUPUSRZURUMUNUTVAURSBCDEUPFGHIJKLUGUIUJ
      UKUL $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y N $.  $d x y O $.  $d x y .x. $.
    $d x y X $.
    odmulgid.1 $e |- X = ( Base ` G ) $.
    odmulgid.2 $e |- O = ( od ` G ) $.
    odmulgid.3 $e |- .x. = ( .g ` G ) $.
    $( A relationship between the order of a multiple and the order of the
       basepoint.  (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
    odmulgid $p |- ( ( ( G e. Grp /\ A e. X /\ N e. ZZ ) /\ K e. ZZ ) ->
          ( ( O ` ( N .x. A ) ) || K <-> ( O ` A ) || ( K x. N ) ) ) $=
      ( wcel cz co cfv wceq cdivides wbr wb oddvds syl3anc cgrp w3a wa cmul c0g
      simpl1 simpl3 simpl2 mulgass syl13anc eqeq1d zmulcld eqid mulgcl 3bitr4rd
      simpr ) CUAKZAGKZELKZUBZDLKZUCZDEUDMZABMZCUENZOZDEABMZBMZVEOZAFNVCPQZVGFN
      DPQZVBVDVHVEVBUQVAUSURVDVHOUQURUSVAUFZUTVAUPZUQURUSVAUGZUQURUSVAUHZGBCDEA
      HJUIUJUKVBUQURVCLKVJVFRVLVOVBDEVMVNULABCVCFGVEHIJVEUMZSTVBUQVGGKZVAVKVIRV
      LVBUQUSURVQVLVNVOGBCEAHJUNTVMVGBCDFGVEHIJVPSTUO $.

    $( The order of a multiple divides the order of the base point.
       (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
    odmulg2 $p |- ( ( G e. Grp /\ A e. X /\ N e. ZZ ) ->
        ( O ` ( N .x. A ) ) || ( O ` A ) ) $=
      ( cgrp wcel cz w3a co cfv cdivides wbr cmul odcl nn0zd 3ad2ant2 wb mpbird
      simp3 dvdsmul1 syl2anc odmulgid mpdan ) CJKZAFKZDLKZMZDABNEOAEOZPQZUMUMDR
      NPQZULUMLKZUKUOUJUIUPUKUJUMACEFGHSTUAZUIUJUKUDUMDUEUFULUPUNUOUBUQABCUMDEF
      GHIUGUHUC $.

    $( Relationship between the order of an element and that of a multiple.
       (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
    odmulg $p |- ( ( G e. Grp /\ A e. X /\ N e. ZZ ) ->
        ( O ` A ) = ( ( N gcd ( O ` A ) ) x. ( O ` ( N .x. A ) ) ) ) $=
      ( wcel cz co cmul cc0 wa cn0 adantr wb cdivides wbr vx cgrp w3a cgcd wceq
      vy cfv cc mulgcl 3com23 odcl syl nn0cnd mul02d simpr simp3 3ad2ant2 nn0zd
      oveq1d gcdeq0 syl2anc simplbda 3eqtr4rd wne wral simpll3 ad2antrr gcddvds
      cv simprd wi gcdcld adantl dvdstr syl3anc mpand muldvds1 dvdszrcl divides
      nn0z wrex ibi simprr adantrr simprl dvdscmulr odmulgid adantrl dvdsmulgcd
      syl112anc simpl3 3bitrrd mulcomd breq2d bitrd anassrs syl5ibcom rexlimdva
      zcnd bibi12d syl5 pm5.21ndd ralrimiva nn0mulcld dvdsext mpbird pm2.61dane
      breq2 ) CUBJZAFJZDKJZUCZAEUGZDXMUDLZDABLZEUGZMLZUEZXNNXLXNNUEZOZNXPMLNXQX
      MXTXPXLXPUHJXSXLXPXLXOFJZXPPJZXIXKXJYAFBCDAGIUIUJXOCEFGHUKULZUMQUNXTXNNXP
      MXLXSUOUSXLXSDNUEZXMNUEZXLXKXMKJZXSYDYEORXIXJXKUPZXLXMXJXIXMPJZXKACEFGHUK
      UQZURZDXMUTVAVBVCXLXNNVDZOZXRXMUAVIZSTZXQYMSTZRZUAPVEZYLYPUAPYLYMPJZOZXNY
      MSTZYNYOYSXNXMSTZYNYTYSXNDSTZUUAYSXKYFUUBUUAOXIXJXKYKYRVFXLYFYKYRYJVGZDXM
      VHVAVJYSXNKJZYFYMKJZUUAYNOYTVKYLUUDYRYLXNXLXNPJYKXLDXMYGYJVLQZURZQZUUCYRU
      UEYLYMVTVMZXNXMYMVNVOVPYSUUDXPKJZUUEYOYTVKUUHXLUUJYKYRXLXPYCURZVGUUIXNXPY
      MVQVOYLYTYPVKYRYTUFVIZXNMLZYMUEZUFKWAZYLYPYTUUOYTUUDUUEOYTUUORXNYMVRUFXNY
      MVSULWBYLUUNYPUFKYLUULKJZOXMUUMSTZXQUUMSTZRZUUNYPXLYKUUPUUSXLYKUUPOZOZUUQ
      XQXNUULMLZSTZUURUVAUVCXPUULSTZXMUULDMLSTZUUQUVAUUJUUPUUDYKUVCUVDRXLUUJUUT
      UUKQXLYKUUPWCZXLYKUUDUUPUUGWDZXLYKUUPWEXNXPUULWFWJXLUUPUVDUVERYKABCUULDEF
      GHIWGWHUVAUUPXKUVEUUQRUVFXIXJXKUUTWKXMUULDWIVAWLUVAUVBUUMXQSUVAXNUULUVAXN
      UVGWSUVAUULUVFWSWMWNWOWPUUNUUQYNUURYOUUMYMXMSXHUUMYMXQSXHWTWQWRXAQXBXCYLY
      HXQPJXRYQRXLYHYKYIQYLXNXPUUFXLYBYKYCQXDUAXMXQXEVAXFXG $.

    $( A multiple of a point of finite order only has the same order if the
       multiplier is relatively prime.  (Contributed by Stefan O'Rear,
       12-Sep-2015.) $)
    odmulgeq $p |- ( ( ( G e. Grp /\ A e. X /\ N e. ZZ ) /\ ( O ` A ) e. NN )
      -> ( ( O ` ( N .x. A ) ) = ( O ` A ) <-> ( N gcd ( O ` A ) ) = 1 ) ) $=
      ( co cfv wceq wcel cz c1 cn0 syl nn0cnd cc0 cdivides cgrp w3a cn wa eqcom
      cgcd cdiv simpl2 odcl simpl1 simpl3 mulgcl syl3anc wne adantl wbr odmulg2
      nnne0 adantr breq1 syl5ibcom nn0zd 0dvds sylibd necon3d mpd diveq1ad cmul
      wb gcdcld mulcomd odmulg eqtr4d divmuld mpbird eqeq1d bitr3d syl5bb ) DAB
      JZEKZAEKZLWAVTLZCUAMZAFMZDNMZUBZWAUCMZUDZDWAUFJZOLZVTWAUEWHWAVTUGJZOLWBWJ
      WHWAVTWHWAWHWDWAPMWCWDWEWGUHZACEFGHUIQZRZWHVTWHVSFMZVTPMWHWCWEWDWOWCWDWEW
      GUJWCWDWEWGUKZWLFBCDAGIULUMVSCEFGHUIQRZWHWASUNZVTSUNWGWRWFWAURUOWHVTSWASW
      HVTSLZSWATUPZWASLZWHVTWATUPZWSWTWFXBWGABCDEFGHIUQUSVTSWATUTVAWHWANMWTXAVI
      WHWAWMVBZWAVCQVDVEVFZVGWHWKWIOWHWKWILVTWIVHJZWALWHXEWIVTVHJZWAWHVTWIWQWHW
      IWHDWAWPXCVJRZVKWFWAXFLWGABCDEFGHIVLUSVMWHWAVTWIWNWQXGXDVNVOVPVQVR $.

    $( If ` N ` is coprime to the order of ` A ` , there is a modular inverse
       ` x ` to cancel multiplication by ` N ` .  (Contributed by Mario
       Carneiro, 27-Apr-2016.) $)
    odbezout $p |- ( ( ( G e. Grp /\ A e. X /\ N e. ZZ ) /\
      ( N gcd ( O ` A ) ) = 1 ) -> E. x e. ZZ ( x .x. ( N .x. A ) ) = A ) $=
      ( vy wcel cz cfv co c1 wceq wa cmul eqtrd cgrp w3a cgcd caddc wrex simpl3
      cv cn0 simpl2 odcl syl nn0zd bezout syl2anc wi oveq1 eqcoms cplusg adantr
      simpll1 simprl zmulcld simprr mulgdir syl13anc c0g mulcomd oveq1d mulgass
      eqid zcnd cdivides dvdsmul1 wb oddvds syl3anc mpbid oveq12d mulgcl grprid
      wbr simplr mulg1 eqeq12d syl5ib anassrs rexlimdva reximdva mpd ) DUALZBGL
      ZEMLZUBZEBFNZUCOZPQZRZWOEAUGZSOZWNKUGZSOZUDOZQZKMUEZAMUEZWREBCOZCOZBQZAMU
      EWQWLWNMLZXEWJWKWLWPUFZWQWNWQWKWNUHLZWJWKWLWPUIZBDFGHIUJZUKULAKEWNUMUNWQX
      DXHAMWQWRMLZRXCXHKMWQXNWTMLZXCXHUOXCXBBCOZWOBCOZQZWQXNXORZRZXHXRXBWOXBWOB
      CUPUQXTXPXGXQBXTXPWSBCOZXABCOZDURNZOZXGXTWJWSMLXAMLZWKXPYDQWJWKWLWPXSUTZX
      TEWRWQWLXSXJUSZWQXNXOVAZVBXTWNWTXTWNXTWKXKWQWKXSXLUSZXMUKULZWQXNXOVCZVBZY
      IGYCCDWSXABHJYCVJZVDVEXTYDXGDVFNZYCOZXGXTYAXGYBYNYCXTYAWRESOZBCOZXGXTWSYP
      BCXTEWRXTEYGVKXTWRYHVKVGVHXTWJXNWLWKYQXGQYFYHYGYIGCDWREBHJVIVETXTWNXAVLWA
      ZYBYNQZXTXIXOYRYJYKWNWTVMUNXTWJWKYEYRYSVNYFYIYLBCDXAFGYNHIJYNVJZVOVPVQVRX
      TWJXGGLZYOXGQYFXTWJXNXFGLZUUAYFYHXTWJWLWKUUBYFYGYIGCDEBHJVSVPGCDWRXFHJVSV
      PGYCDXGYNHYMYTVTUNTTXTXQPBCOZBXTWOPBCWMWPXSWBVHXTWKUUCBQYIGCDBHJWCUKTWDWE
      WFWGWHWI $.
  $}

  ${
    od1.1 $e |- O = ( od ` G ) $.
    od1.2 $e |- .0. = ( 0g ` G ) $.
    $( The order of the group identity is one.  (Contributed by Mario Carneiro,
       14-Jan-2015.)  (Revised by Mario Carneiro, 23-Sep-2015.) $)
    od1 $p |- ( G e. Grp -> ( O ` .0. ) = 1 ) $=
      ( cgrp wcel cfv c1 cfz co wceq cbs cn cmg eqid grpidcl 1nn a1i syl odlem2
      mulg1 syl3anc elfz1eq ) AFGZCBHZIIJKGZUFILUECAMHZGZINGZICAOHZKCLZUGUHACUH
      PZEQZUJUERSUEUIULUNUHUKACUMUKPZUBTCUKAIBUHCUMDUOEUAUCUFIUDT $.

    odeq1.3 $e |- X = ( Base ` G ) $.
    $( The group identity is the unique element of a group with order one.
       (Contributed by Mario Carneiro, 14-Jan-2015.)  (Revised by Mario
       Carneiro, 23-Sep-2015.) $)
    odeq1 $p |- ( ( G e. Grp /\ A e. X ) -> ( ( O ` A ) = 1 <-> A = .0. ) ) $=
      ( cgrp wcel wa cfv c1 wceq cmg co oveq1 eqcomd wb eqid mulg1 odid eqeq12d
      adantl syl5ib od1 adantr fveq2 eqeq1d syl5ibrcom impbid ) BIJZADJZKZACLZM
      NZAENZUPMABOLZPZUOAURPZNZUNUQUPUTUSUOMAURQRUMVAUQSULUMUSAUTEDURBAHURTZUAA
      URBCDEHFVBGUBUCUDUEUNUPUQECLZMNZULVDUMBCEFGUFUGUQUOVCMAECUHUIUJUK $.
  $}

  ${
    odinv.1 $e |- O = ( od ` G ) $.
    odinv.2 $e |- I = ( invg ` G ) $.
    odinv.3 $e |- X = ( Base ` G ) $.
    $( The order of the inverse of a group element.  (Contributed by Mario
       Carneiro, 20-Oct-2015.) $)
    odinv $p |- ( ( G e. Grp /\ A e. X ) -> ( O ` ( I ` A ) ) = ( O ` A ) ) $=
      ( wcel cfv c1 cgcd co cmul cz wceq 1z cn0 odcl syl cgrp wa cneg cmg ax-mp
      znegcl eqid odmulg mp3an3 adantl nn0zd gcdcom sylancr gcdneg sylancl gcd1
      3eqtrd mulgm1 fveq2d oveq12d grpinvcl nn0cnd mulid2d 3eqtrrd ) BUAIZAEIZU
      BZADJZKUCZVHLMZVIABUDJZMZDJZNMZKACJZDJZNMVPVEVFVIOIZVHVNPKOIZVQQKUFUEZAVK
      BVIDEHFVKUGZUHUIVGVJKVMVPNVGVJVHVILMZVHKLMZKVGVQVHOIZVJWAPVSVGVHVFVHRIVEA
      BDEHFSUJUKZVIVHULUMVGWCVRWAWBPWDQVHKUNUOVGWCWBKPWDVHUPTUQVGVLVODEVKBCAHVT
      GURUSUTVGVPVGVPVGVOEIVPRIEBCAHGVAVOBDEHFSTVBVCVD $.
  $}

  ${
    $d x y z A $.  $d x y z G $.  $d x y z O $.  $d x y z .x. $.  $d x y z X $.
    $d y z F $.
    odf1.1 $e |- X = ( Base ` G ) $.
    odf1.2 $e |- O = ( od ` G ) $.
    odf1.3 $e |- .x. = ( .g ` G ) $.
    odf1.4 $e |- F = ( x e. ZZ |-> ( x .x. A ) ) $.
    $( The multiples of an element with infinite order form an infinite cyclic
       subgroup of ` G ` .  (Contributed by Mario Carneiro, 14-Jan-2015.)
       (Revised by Mario Carneiro, 23-Sep-2015.) $)
    odf1 $p |- ( ( G e. Grp /\ A e. X ) ->
      ( ( O ` A ) = 0 <-> F : ZZ -1-1-> X ) ) $=
      ( vy wcel wa cfv cc0 wceq cz co wb vz cgrp wf1 wf cv wi wral mulgcl 3expa
      an32s fmptd adantr cmin ovex fvmpt3i eqeqan12d adantl cdivides wbr simplr
      oveq1 breq1d c0g odcong adantlr zsubcl 0dvds syl 3bitr3d cc subeq0 syl2an
      eqid zcn 3bitrd biimpd ralrimivva dff13 sylanbrc odid eqtr4d ad2antlr cn0
      mulg0 odcl nn0zd 0z a1i 3eqtr4d simpr f1fveq syl12anc mpbid impbida ) EUB
      MZBGMZNZBFOZPQZRGDUCZWQWSNZRGDUDZLUEZDOZUAUEZDOZQZXCXEQZUFZUARUGLRUGWTWQX
      BWSWQARAUEZBCSZGDWOXJRMZWPXKGMZWOXLWPXMGCEXJBHJUHUIUJKUKULXAXILUARRXAXCRM
      ZXERMZNZNZXGXHXQXGXCBCSZXEBCSZQZXCXEUMSZPQZXHXPXGXTTXAXNXOXDXRXFXSAXCXKXR
      RDXJXCBCVAKXJBCUNZUOAXEXKXSRDXJXEBCVAKYCUOUPUQXQWRYAURUSZPYAURUSZXTYBXQWR
      PYAURWQWSXPUTVBWQXPYDXTTZWSWOWPXPYFBCEXCXEFGEVCOZHIJYGVMZVDUIVEXQYARMZYEY
      BTXPYIXAXCXEVFUQYAVGVHVIXPYBXHTZXAXNXCVJMXEVJMYJXOXCVNXEVNXCXEVKVLUQVOVPV
      QLUARGDVRVSWQWTNZWRDOZPDOZQZWSYKWRBCSZPBCSZYLYMWPYOYPQWOWTWPYOYGYPBCEFGYG
      HIJYHVTGCEBYGHYHJWDWAWBYKWRRMZYLYOQYKWRWPWRWCMWOWTBEFGHIWEWBWFZAWRXKYORDX
      JWRBCVAKYCUOVHYKPRMZYMYPQYSYKWGWHZAPXKYPRDXJPBCVAKYCUOVHWIYKWTYQYSYNWSTWQ
      WTWJYRYTRGWRPDWKWLWMWN $.

    $( The multiples of an element with infinite order form an infinite cyclic
       subgroup of ` G ` .  (Contributed by Mario Carneiro, 14-Jan-2015.) $)
    odinf $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) = 0 ) ->
      -. ran F e. Fin ) $=
      ( wcel cfv com wbr cen cz cvv cbs 3syl cgrp cc0 wceq w3a crn csdm cdom wn
      cfn cn znnen nnenom entr2i wf1o wf1 wf odf1 biimp3a f1f fvex eqeltri fex2
      zex mp3an23 f1f1orn f1oen3g syl2anc entr sylancr domnsym isfinite sylnibr
      syl endom ) EUALZBGLZBFMUBUCZUDZDUEZNUFOZVSUILVRNVSPOZNVSUGOVTUHVRNQPOQVS
      POZWAQUJNUKULUMVRDRLZQVSDUNZWBVRQGDUOZQGDUPZWCVOVPVQWEABCDEFGHIJKUQURZQGD
      USWFQRLGRLWCVCGESMRHESUTVAQGDRRVBVDTVRWEWDWGQGDVEVMQVSDRVFVGNQVSVHVINVSVN
      NVSVJTVSVKVL $.

    $( An alternative definition of the order of a group element is as the
       cardinality of the cyclic subgroup generated by the element.
       (Contributed by Mario Carneiro, 14-Jan-2015.)  (Revised by Mario
       Carneiro, 2-Oct-2015.) $)
    dfod2 $p |- ( ( G e. Grp /\ A e. X ) ->
      ( O ` A ) = if ( ran F e. Fin , ( # ` ran F ) , 0 ) ) $=
      ( vy wcel cc0 wceq co wbr wb cvv cz vz wa cfv cn crn cfn chash cif c1 cfz
      cgrp cmin fzfid cen cv cmpt wf1o wss mulgcl 3expa an32s adantlr fmptd frn
      wf cbs fvex eqeltri ssex 3syl wral wreu elfzelz adantl ovex oveq1 sylancl
      elrnmpt1s ralrimiva zmodfz ancoms adantll cdivides simpllr simplr moddvds
      cmo syl3anc cr crp cle clt nnrpd w3a 0z nnz adantr elfzm11 sylancr biimpa
      zred simp2d simp3d modid syl22anc eqeq2d eqcom syl6bb simp-4l simp-4r c0g
      eqid odcong syl112anc 3bitr3rd reu6i syl2anc rgenw eqeq1 reubidv ralrnmpt
      ax-mp sylibr f1ompt sylanbrc f1oen2g syl mpbid iftrue fz01en ensym hashen
      enfi entr mpbird cn0 nnnn0 hashfz1 3eqtr2rd simp3 wn odinf iffalse eqtr4d
      wo odcl elnn0 sylib mpjaodan ) EUKMZBGMZUBZBFUCZUDMZUUMDUEZUFMZUUOUGUCZNU
      HZOZUUMNOZUULUUNUBZUURUUQUIUUMUJPZUGUCZUUMUVAUUPUURUUQOUVANUUMUIULPZUJPZU
      FMZUUPUVANUVDUMZUVAUVEUUOUNQZUVFUUPRUVAUVFUUOSMZUVEUUOLUVELUOZBCPZUPZUQZU
      VHUVGUVATGDVEUUOGURUVIUVAATAUOZBCPZGDUULUVNTMZUVOGMZUUNUUJUVPUUKUVQUUJUVP
      UUKUVQGCEUVNBHJUSUTVAVBKVCTGDVDUUOGGEVFUCSHEVFVGVHVIVJUVAUVKUUOMZLUVEVKUA
      UOZUVKOZLUVEVLZUAUUOVKZUVMUVAUVRLUVEUVAUVJUVEMZUBUVJTMZUVKSMUVRUWCUWDUVAU
      VJNUVDVMZVNUVJBCVOATUVOUVKUVJDSKUVNUVJBCVPVRVQVSUVAUVOUVKOZLUVEVLZATVKZUW
      BUVAUWGATUVAUVPUBZUVNUUMWGPZUVEMZUWFUVJUWJOZRZLUVEVKUWGUUNUVPUWKUULUVPUUN
      UWKUVNUUMVTWAWBUWIUWMLUVEUWIUWCUBZUWJUVJUUMWGPZOZUUMUVNUVJULPWCQZUWLUWFUW
      NUUNUVPUWDUWPUWQRUULUUNUVPUWCWDZUVAUVPUWCWEZUWCUWDUWIUWEVNZUVNUVJUUMWFWHU
      WNUWPUWJUVJOUWLUWNUWOUVJUWJUWNUVJWIMUUMWJMNUVJWKQZUVJUUMWLQZUWOUVJOUWNUVJ
      UWTXAUWNUUMUWRWMUWNUWDUXAUXBUWIUWCUWDUXAUXBWNZUWINTMUUMTMZUWCUXCRWOUVAUXD
      UVPUUNUXDUULUUMWPVNZWQUVJNUUMWRWSWTZXBUWNUWDUXAUXBUXFXCUVJUUMXDXEXFUWJUVJ
      XGXHUWNUUJUUKUVPUWDUWQUWFRUUJUUKUUNUVPUWCXIUUJUUKUUNUVPUWCXJUWSUWTBCEUVNU
      VJFGEXKUCZHIJUXGXLXMXNXOVSUWFLUVEUWJXPXQVSUVOSMZATVKUWBUWHRUXHATUVNBCVOXR
      UWAUWGAUATUVODSKUVSUVOOUVTUWFLUVEUVSUVOUVKXSXTYAYBYCLUAUVEUUOUVKUVLUVLXLY
      DYEUVEUUOUVLUFSYFWHZUVEUUOYMYGYHZUUPUUQNYIYGUVAUVCUUQOZUVBUUOUNQZUVAUVBUV
      EUNQZUVHUXLUVAUXDUVEUVBUNQUXMUXEUUMYJUVEUVBYKVJUXIUVBUVEUUOYNXQUVAUVBUFMU
      UPUXKUXLRUVAUIUUMUMUXJUVBUUOYLXQYOUVAUUMYPMZUVCUUMOUUNUXNUULUUMYQVNUUMYRY
      GYSUUJUUKUUTUUSUUJUUKUUTWNZUUMNUURUUJUUKUUTYTUXOUUPUUAUURNOABCDEFGHIJKUUB
      UUPUUQNUUCYGUUDUTUULUXNUUNUUTUUEUUKUXNUUJBEFGHIUUFVNUUMUUGUUHUUI $.
  $}

  ${
    $d x A $.  $d x G $.  $d x O $.  $d x X $.
    odcl2.1 $e |- X = ( Base ` G ) $.
    odcl2.2 $e |- O = ( od ` G ) $.
    $( The order of an element of a finite group is finite.  (Contributed by
       Mario Carneiro, 14-Jan-2015.) $)
    odcl2 $p |- ( ( G e. Grp /\ X e. Fin /\ A e. X ) -> ( O ` A ) e. NN ) $=
      ( vx cgrp wcel cfn cfv cn wa wn cc0 wceq cn0 wo cz eqid odcl adantl elnn0
      sylib ord w3a cv cmg co cmpt crn odinf wf1 wf wss wi odf1 biimp3a f1f frn
      ssfi expcom 4syl mtod 3expia syld con4d 3impia 3com23 ) BHIZADIZDJIZACKZL
      IZVJVKVLVNVJVKMZVNVLVOVNNVMOPZVLNZVOVNVPVOVMQIZVNVPRVKVRVJABCDEFUAUBVMUCU
      DUEVJVKVPVQVJVKVPUFZVLGSGUGABUHKZUIUJZUKZJIZGAVTWABCDEFVTTZWATZULVSSDWAUM
      ZSDWAUNWBDUOZVLWCUPVJVKVPWFGAVTWABCDEFWDWEUQURSDWAUSSDWAUTVLWGWCDWBVAVBVC
      VDVEVFVGVHVI $.

    $( The order of an element of a finite group divides the order
       (cardinality) of the group.  Corollary of Lagrange's theorem for the
       order of a subgroup.  (Contributed by Mario Carneiro, 14-Jan-2015.) $)
    oddvds2 $p |- ( ( G e. Grp /\ X e. Fin /\ A e. X ) ->
      ( O ` A ) || ( # ` X ) ) $=
      ( cgrp wcel cfn w3a cfv chash cdivides cc0 wceq eqid 3adant2 syl syl2anc
      vx cz cv cmg co cmpt crn cif dfod2 simp2 csubg wa cycsubgcl simpld subgss
      wss ssfi iftrue eqtrd wbr lagsubg eqbrtrd ) BGHZDIHZADHZJZACKZTUATUBABUCK
      ZUDUEZUFZLKZDLKZMVEVFVIIHZVJNUGZVJVBVDVFVMOVCTAVGVHBCDEFVGPZVHPZUHQVEVLVM
      VJOVEVCVIDUOZVLVBVCVDUIZVEVIBUJKHZVPVEVRAVIHZVBVDVRVSUKVCTAVGVHBDEVNVOULQ
      UMZDVIBEUNRDVIUPSVLVJNUQRURVEVRVCVJVKMUSVTVQBDVIEUTSVA $.
  $}

  ${
    $d x A $.  $d x G $.  $d x H $.  $d x Y $.
    submod.h $e |- H = ( G |`s Y ) $.
    submod.o $e |- O = ( od ` G ) $.
    submod.p $e |- P = ( od ` H ) $.
    $( The order of an element is the same in a subgroup.  (Contributed by
       Stefan O'Rear, 12-Sep-2015.) $)
    submod $p |- ( ( Y e. ( SubMnd ` G ) /\ A e. Y ) ->
        ( O ` A ) = ( P ` A ) ) $=
      ( vx cfv wcel wa wceq cn c0 cc0 cr eqid syl csubmnd cmg c0g crab clt ccnv
      cv co csup cif simpll nnnn0 adantl simplr submmulg syl3anc subm0 ad2antrr
      cn0 eqeq12d rabbidva eqeq1 supeq1 ifbieq2d cbs submss sselda odval adantr
      simpr wss ressbas2 eleqtrd 3eqtr4d ) FCUAKLZAFLZMZJUGZACUBKZUHZCUCKZNZJOU
      DZPNZQWCRUEUFZUIZUJZVRADUBKZUHZDUCKZNZJOUDZPNZQWLRWEUIZUJZAEKZABKZVQWCWLN
      ZWGWONVQWBWKJOVQVROLZMZVTWIWAWJWTVOVRUSLZVPVTWINVOVPWSUKWSXAVQVRULUMVOVPW
      SUNFVSWHCDVRAVSSZGWHSZUOUPVOWAWJNVPWSFDCWAGWASZUQURUTVAWRWDWMWFWNQWCWLPVB
      RWCWLWEVCVDTVQACVEKZLWPWGNVOFXEAXEFCXESZVFZVGJAVSCWCEXEWAXFXBXDHWCSVHTVQA
      DVEKZLWQWONVQAFXHVOVPVJVQFXEVKZFXHNVOXIVPXGVIFXEDCGXFVLTVMJAWHDWLBXHWJXHS
      XCWJSIWLSVHTVN $.

    $( The order of an element is the same in a subgroup.  (Contributed by
       Mario Carneiro, 14-Jan-2015.)  (Proof shortened by Stefan O'Rear,
       12-Sep-2015.) $)
    subgod $p |- ( ( Y e. ( SubGrp ` G ) /\ A e. Y ) ->
      ( O ` A ) = ( P ` A ) ) $=
      ( csubg cfv wcel csubmnd wceq subgsubm submod sylan ) FCJKLFCMKLAFLAEKABK
      NFCOABCDEFGHIPQ $.
  $}

  ${
    odsubdvds.1 $e |- O = ( od ` G ) $.
    $( The order of an element of a subgroup divides the order of the
       subgroup.  (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    odsubdvds $p |- ( ( S e. ( SubGrp ` G ) /\ S e. Fin /\ A e. S ) ->
      ( O ` A ) || ( # ` S ) ) $=
      ( csubg cfv wcel cfn w3a cress cod chash cdivides cgrp eqid 3ad2ant1 wceq
      co cbs wbr subggrp subgbas simp2 eqeltrrd eleqtrd oddvds2 syl3anc 3adant2
      simp3 subgod fveq2d 3brtr4d ) BCFGHZBIHZABHZJZACBKSZLGZGZURTGZMGZADGZBMGN
      UQUROHZVAIHAVAHUTVBNUAUNUOVDUPBCURURPZUBQUQBVAIUNUOBVARUPBCURVEUCQZUNUOUP
      UDUEUQABVAUNUOUPUJVFUFAURUSVAVAPUSPZUGUHUNUPVCUTRUOAUSCURDBVEEVGUKUIUQBVA
      MVFULUM $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y K $.  $d x y O $.  $d x y .x. $.
    $d x y X $.
    odf1o1.x $e |- X = ( Base ` G ) $.
    odf1o1.t $e |- .x. = ( .g ` G ) $.
    odf1o1.o $e |- O = ( od ` G ) $.
    odf1o1.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( An element with zero order has infinitely many multiples.  (Contributed
       by Stefan O'Rear, 6-Sep-2015.) $)
    odf1o1 $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) = 0 ) ->
        ( x e. ZZ |-> ( x .x. A ) ) : ZZ -1-1-onto-> ( K ` { A } ) ) $=
      ( wcel cfv cc0 wceq cz co wa syl wb vy cgrp w3a csn cv cmpt wf1 wfo csubg
      wf1o cmre wss cacs simpl1 subgacs acsmre simpl2 snssd mrccl syl2anc simpr
      3syl mrcssidd snidg sseldd subgmulgcl syl3anc ex cmin cdivides wbr simpl3
      breq1d zsubcl adantl 0dvds simprl simprr c0g eqid odcong syl112anc cc zcn
      bitrd subeq0 syl2an 3bitr3d dom2lem crn f1f cycsubg2 3adant3 eqcomd dffo2
      wf sylanbrc df-f1o ) DUBLZBGLZBFMZNOZUCZPBUDZEMZAPAUEZBCQZUFZUGZPXEXHUHZP
      XEXHUJXCAUAPXEXGUAUEZBCQZXCXFPLZXGXELZXCXMRZXEDUIMZLZXMBXELXNXOXPGUKMLZXD
      GULXQXOWSXPGUMMLXRWSWTXBXMUNGDHUOXPGUPVBZXOBGWSWTXBXMUQZURZXPXDEGKUSUTXCX
      MVAXOXDXEBXOXPXDEGXSKYAVCXOWTBXDLXTBGVDSVEXECDXFBIVFVGVHXCXMXKPLZRZXGXLOZ
      XFXKOZTXCYCRZXAXFXKVIQZVJVKZYGNOZYDYEYFYHNYGVJVKZYIYFXANYGVJWSWTXBYCVLVMY
      FYGPLZYJYITYCYKXCXFXKVNVOYGVPSWEYFWSWTXMYBYHYDTWSWTXBYCUNWSWTXBYCUQXCXMYB
      VQXCXMYBVRBCDXFXKFGDVSMZHJIYLVTWAWBYCYIYETZXCXMXFWCLXKWCLYMYBXFWDXKWDXFXK
      WFWGVOWHVHWIZXCPXEXHWPZXHWJZXEOXJXCXIYOYNPXEXHWKSXCXEYPWSWTXEYPOXBABCXHDE
      GHIXHVTKWLWMWNPXEXHWOWQPXEXHWRWQ $.

    $( An element with nonzero order has as many multiples as its order.
       (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
    odf1o2 $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) e. NN ) ->
        ( x e. ( 0 ..^ ( O ` A ) ) |-> ( x .x. A ) ) :
          ( 0 ..^ ( O ` A ) ) -1-1-onto-> ( K ` { A } ) ) $=
      ( vy wcel cc0 co wceq wa cz wb wss cgrp cfv cn w3a cfzo csn cmpt wfo ccnv
      cv wfun wf1o wfn crn simpl1 elfzoelz adantl simpl2 mulgcl syl3anc ex cmin
      wf1 cdivides simpl3 nncnd subid1d breq1d fzocongeq ad2antrl ad2antll eqid
      wbr c0g odcong syl112anc 3bitr3rd dom2lem f1fn syl cres resss ssriv ax-mp
      resmpt oveq1 cbvmptv 3sstr3i rnss mp1i wf cmo simpr zmodfzo syl2anc odmod
      wrex 3an1rs eqcomd eqeq2d rspcev ovex elrnmpt sylibr fmptd eqssd cycsubg2
      cvv frn 3adant3 eqtr4d df-fo sylanbrc df-f1 simprbi dff1o3 ) DUAMZBGMZBFU
      BZUCMZUDZNXSUEOZBUFEUBZAYBAUJZBCOZUGZUHZYFUIUKZYBYCYFULYAYFYBUMZYFUNZYCPY
      GYAYBGYFVCZYIYAALYBGYELUJZBCOZYAYDYBMZYEGMZYAYNQXQYDRMZXRYOXQXRXTYNUOYNYP
      YAYDNXSUPZUQXQXRXTYNURGCDYDBHIUSUTVAYAYNYLYBMZQZYEYMPZYDYLPZSYAYSQZXSNVBO
      ZYDYLVBOZVDVMZXSUUDVDVMZUUAYTUUBUUCXSUUDVDUUBXSUUBXSXQXRXTYSVEVFVGVHYSUUE
      UUASYAYDYLNXSVIUQUUBXQXRYPYLRMZUUFYTSXQXRXTYSUOXQXRXTYSURYNYPYAYRYQVJYRUU
      GYAYNYLNXSUPVKBCDYDYLFGDVNUBZHJIUUHVLZVOVPVQVAVRZYBGYFVSVTYAYJLRYMUGZUNZY
      CYAYJUULYFUUKTYJUULTYAARYEUGZYBWAZUUMYFUUKUUMYBWBYBRTUUNYFPAYBRYQWCARYBYE
      WEWDALRYEYMYDYLBCWFWGWHYFUUKWIWJYARYJUUKWKUULYJTYALRYMYJUUKYAUUGQZYMYEPZA
      YBWQZYMYJMZUUOYLXSWLOZYBMZYMUUSBCOZPZUUQUUOUUGXTUUTYAUUGWMXQXRXTUUGVEYLXS
      WNWOUUOUVAYMXQXRUUGXTUVAYMPBCDYLFGUUHHJIUUIWPWRWSUUPUVBAUUSYBYDUUSPYEUVAY
      MYDUUSBCWFWTXAWOYMXHMUURUUQSYLBCXBAYBYEYMYFXHYFVLXCWDXDUUKVLZXERYJUUKXIVT
      XFXQXRYCUULPXTLBCUUKDEGHIUVCKXGXJXKYBYCYFXLXMYAYKYHUUJYKYBGYFWKYHYBGYFXNX
      OVTYBYCYFXPXM $.
  $}

  ${
    $d x A $.  $d x G $.  $d x K $.  $d x O $.  $d x X $.
    odhash.x $e |- X = ( Base ` G ) $.
    odhash.o $e |- O = ( od ` G ) $.
    odhash.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( An element of zero order generates an infinite subgroup.  (Contributed
       by Stefan O'Rear, 12-Sep-2015.) $)
    odhash $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) = 0 ) ->
        ( # ` ( K ` { A } ) ) = +oo ) $=
      ( vx wcel cfv wceq cpnf cz chash cvv cfn zex com cen cc0 w3a csn wn ominf
      cgrp wbr wb cn znnen nnenom entri enfi ax-mp mtbir hashinf mp2an cmg cmpt
      cv co wf1o eqid odf1o1 f1oen hasheni 3syl syl5reqr ) BUFJAEJADKUALUBZMNOK
      ZAUCCKZOKZNPJNQJZUDVJMLRVMSQJZUENSTUGVMVNUHNUISUJUKULNSUMUNUONPUPUQVINVKI
      NIUTABURKZVAUSZVBNVKTUGVJVLLIAVOBCDEFVOVCGHVDNVKVPRVENVKVFVGVH $.

    $( If an element has nonzero order, it generates a subgroup with size equal
       to the order.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    odhash2 $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) e. NN ) ->
        ( # ` ( K ` { A } ) ) = ( O ` A ) ) $=
      ( vx cgrp wcel cfv cn w3a cc0 cfzo co chash csn wceq cv cmg cmpt wf1o cen
      wbr eqid odf1o2 ovex f1oen hasheni 3syl cn0 odcl 3ad2ant2 hashfzo0 eqtr3d
      syl ) BJKZAEKZADLZMKZNZOVAPQZRLZASCLZRLZVAVCVDVFIVDIUAABUBLZQUCZUDVDVFUEU
      FVEVGTIAVHBCDEFVHUGGHUHVDVFVIOVAPUIUJVDVFUKULVCVAUMKZVEVATUTUSVJVBABDEFGU
      NUOVAUPURUQ $.

    $( An element which generates a finite subgroup has order the size of that
       subgroup.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    odhash3 $p |- ( ( G e. Grp /\ A e. X /\ ( K ` { A } ) e. Fin ) ->
        ( O ` A ) = ( # ` ( K ` { A } ) ) ) $=
      ( cgrp wcel csn cfv cfn w3a chash cn wceq cc0 cr cpnf cn0 wne 3ad2ant2 wa
      odcl hashcl nn0red wn pnfnre neli odhash eleq1d mtbiri 3expia syl5 3impia
      necon2ad elnnne0 sylanbrc odhash2 syld3an3 eqcomd ) BIJZAEJZAKCLZMJZNZVEO
      LZADLZVCVDVFVIPJZVHVIQVGVIUAJZVIRUBZVJVDVCVKVFABDEFGUEUCVCVDVFVLVFVHSJZVC
      VDUDZVLVFVHVEUFUGVNVMVIRVCVDVIRQZVMUHVCVDVONZVMTSJTSUIUJVPVHTSABCDEFGHUKU
      LUMUNUQUOUPVIURUSABCDEFGHUTVAVB $.

    $d x y A $.  $d x y G $.  $d x y K $.  $d x y O $.  $d x y X $.
    $( A cyclic subgroup of size ` ( O `` A ) ` has ` ( phi `` ( O `` A ) ) `
       generators.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    odngen $p |- ( ( G e. Grp /\ A e. X /\ ( O ` A ) e. NN ) ->
        ( # ` { x e. ( K ` { A } ) | ( O ` x ) = ( O ` A ) } ) =
          ( phi ` ( O ` A ) ) ) $=
      ( vy wcel cfv cc0 co cv wceq crab chash eqid wf1o cgrp w3a cfzo cmpt ccnv
      cn cmg csn cima cphi mptpreima fveq2i wf1 odf1o2 f1ocnv f1of1 3syl ssrab2
      wss wa cen wbr fvex rabex f1imaen hasheni syl sylancl c1 wb simpl1 simpl2
      cz elfzoelz adantl cycsubg2cl syl3anc fveq2 eqeq1d elrab3 simpl3 odmulgeq
      cgcd syl31anc bitrd rabbidva fveq2d dfphi2 3ad2ant3 eqtr4d 3eqtr3a ) CUAK
      ZBFKZBELZUFKZUBZJMWNUCNZJOZBCUGLZNZUDZUEZAOZELZWNPZABUHZDLZQZUIZRLZWTXHKZ
      JWQQZRLZXHRLZWNUJLZXIXLRJWQWTXHXAXASUKULWPXGWQXBUMZXHXGUSZXJXNPZWPWQXGXAT
      XGWQXBTXPJBWSCDEFGWSSZHIUNWQXGXAUOXGWQXBUPUQXEAXGURXPXQUTXIXHVAVBXRXGWQXH
      XBXEAXGXFDVCVDVEXIXHVFVGVHWPXMWRWNWCNVIPZJWQQZRLZXOWPXLYARWPXKXTJWQWPWRWQ
      KZUTZXKWTELZWNPZXTYDWTXGKZXKYFVJYDWLWMWRVMKZYGWLWMWOYCVKZWLWMWOYCVLZYCYHW
      PWRMWNVNVOZBWSCDWRFGXSIVPVQXEYFAWTXGXCWTPXDYEWNXCWTEVRVSVTVGYDWLWMYHWOYFX
      TVJYIYJYKWLWMWOYCWABWSCWREFGHXSWBWDWEWFWGWOWLXOYBPWMJWNWHWIWJWK $.
  $}

  ${
    $d x y .0. $.  $d g i x y G $.  $d g i I $.  $d g i x y V $.  $d x y .x. $.
    $d x X $.
    gexval.1 $e |- X = ( Base ` G ) $.
    gexval.2 $e |- .x. = ( .g ` G ) $.
    gexval.3 $e |- .0. = ( 0g ` G ) $.
    gexval.4 $e |- E = ( gEx ` G ) $.
    gexval.i $e |- I = { y e. NN | A. x e. X ( y .x. x ) = .0. } $.
    $( Value of the exponent of a group.  (Contributed by Mario Carneiro,
       23-Apr-2016.) $)
    gexval $p |- ( G e. V ->
      E = if ( I = (/) , 0 , sup ( I , RR , `' < ) ) ) $=
      ( vg vi cfv wceq cr cvv wcel cgex c0 cc0 clt ccnv csup cif cv cmg c0g cbs
      co wral cn crab csb cmpt df-gex a1i nnex rabex simpr fveq2d syl6eqr oveqd
      wa eqeq12d raleqbidv rabbidv eqeq2d biimpa eqeq1d supeq1d ifbieq2d csbied
      elex c0ex wor ltso cnvso mpbi supex ifex fvmptd syl5eq ) EGUAZDEUBQFUCRZU
      DFSUEUFZUGZUHZMWGOEPBUIZAUIZOUIZUJQZUMZWNUKQZRZAWNULQZUNZBUOUPZPUIZUCRZUD
      XBSWIUGZUHZUQZWKTUBTUBOTXFURRWGAOPBUSUTWGWNERZVGZPXAXEWKTXATUAXHWTBUOVAVB
      UTXHXBXARZVGZXCWHXDWJUDXJXBFUCXHXIXBFRXHXAFXBXHXAWLWMCUMZIRZAHUNZBUOUPFXH
      WTXMBUOXHWRXLAWSHXHWSEULQHXHWNEULWGXGVCZVDJVEXHWPXKWQIXHWOCWLWMXHWOEUJQCX
      HWNEUJXNVDKVEVFXHWQEUKQIXHWNEUKXNVDLVEVHVIVJNVEVKVLZVMXJSXBFWIXOVNVOVPEGV
      QWKTUAWGWHUDWJVRSFWISUEVSSWIVSVTSUEWAWBWCWDUTWEWF $.

    $( The group element order is either zero or a nonzero multiplier that
       annihilates the element.  (Contributed by Mario Carneiro,
       23-Apr-2016.) $)
    gexlem1 $p |- ( G e. V -> ( ( E = 0 /\ I = (/) ) \/ E e. I ) ) $=
      ( wcel c0 wceq cc0 wi cn cr clt ccnv cif wa wo gexval eqeq2 imbi1d expcom
      csup orc adantl wn c1 cuz cfv wss wne cv co wral crab ssrab2 nnuz 3sstr4i
      eqcomi df-ne biimpri infmssuzcl sylancr eleq1a syl olc syl6 ifbothda mpd
      ) EGOZDFPQZRFUAUBUCUKZUDZQZDRQZVSUEZDFOZUFZABCDEFGHIJKLMNUGVSWCWFSZDVTQZW
      FSWBWFSVRRVTRWAQWCWBWFRWADUHUIVTWAQWHWBWFVTWADUHUIVSWGVRWCVSWFWDWEULUJUMV
      RVSUNZUEZWHWEWFWJVTFOZWHWESWJFUOUPUQZURFPUSZWKBUTAUTCVAIQAHVBZBTVCTFWLWNB
      TVDNTWLVEVGVFWIWMVRWMWIFPVHVIUMFUOVJVKVTFDVLVMWEWDVNVOVPVQ $.
  $}

  ${
    $d x A $.  $d x y E $.  $d x y G $.  $d x y N $.  $d x y V $.  $d x y X $.
    $d x y .0. $.  $d x y .x. $.
    gexcl.1 $e |- X = ( Base ` G ) $.
    gexcl.2 $e |- E = ( gEx ` G ) $.
    $( The exponent of a group is a nonnegative integer.  (Contributed by Mario
       Carneiro, 23-Apr-2016.) $)
    gexcl $p |- ( G e. V -> E e. NN0 ) $=
      ( vy vx wcel cn cc0 wceq wo cn0 cv cmg cfv co c0g eqid wral c0 wa gexlem1
      crab simpl elrabi orim12i syl orcomd elnn0 sylibr ) BCIZAJIZAKLZMANIUMUOU
      NUMUOGOHOBPQZRBSQZLHDUAZGJUEZUBLZUCZAUSIZMUOUNMHGUPABUSCDUQEUPTUQTFUSTUDV
      AUOVBUNUOUTUFURGAJUGUHUIUJAUKUL $.

    gexid.3 $e |- .x. = ( .g ` G ) $.
    gexid.4 $e |- .0. = ( 0g ` G ) $.
    $( Any element to the power of the group exponent.  (Contributed by Mario
       Carneiro, 24-Apr-2016.) $)
    gexid $p |- ( A e. X -> ( E .x. A ) = .0. ) $=
      ( vy vx wcel cc0 wceq cv co wral cn oveq1 crab c0 mulg0 sylan9eqr adantrr
      wa eqeq1d ralbidv elrab simprbi oveq2 rspcva sylan2 cvv wo cbs cfv elfvex
      eleq2s eqid gexlem1 syl mpjaodan ) AEMZCNOZKPZLPZBQZFOZLERZKSUAZUBOZUFZCA
      BQZFOZCVKMZVDVEVOVLVEVDVNNABQFCNABTEBDAFGJIUCUDUEVPVDCVGBQZFOZLERZVOVPCSM
      VSVJVSKCSVFCOZVIVRLEVTVHVQFVFCVGBTUGUHUIUJVRVOLAEVGAOVQVNFVGACBUKUGULUMVD
      DUNMZVMVPUOWAADUPUQEADUPURGUSLKBCDVKUNEFGIJHVKUTVAVBVC $.

    $( Any positive annihilator of all the group elements is an upper bound on
       the group exponent.  (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexlem2 $p |- ( ( G e. V /\ N e. NN /\ A. x e. X ( N .x. x ) = .0. ) ->
        E e. ( 1 ... N ) ) $=
      ( vy wcel cn co wceq c1 wa c0 cv wral cfz crab oveq1 eqeq1d ralbidv elrab
      clt ccnv csup cc0 cif eqid gexval wne ne0i ifnefalse syl sylan9eq cle wbr
      cr ssrab2 cuz cfv wss sseqtri adantl infmssuzcl sylancr sseldi infmssuzle
      nnuz mpan wb cz elrabi nnzd fznn mpbir2and eqeltrd sylan2br 3impb ) DFNZE
      ONZEAUAZBPZHQZAGUBZCREUCPZNZWFWJSWEEMUAZWGBPZHQZAGUBZMOUDZNZWLWPWJMEOWMEQ
      ZWOWIAGWSWNWHHWMEWGBUEUFUGUHWEWRSZCWQVCUIUJUKZWKWEWRCWQTQULXAUMZXAAMBCDWQ
      FGHIKLJWQUNUOWRWQTUPZXBXAQWQEUQZWQTULXAURUSUTWTXAWKNZXAONZXAEVAVBZWTWQOXA
      WPMOVDZWTWQRVEVFZVGZXCXAWQNWQOXIXHVNVHZWRXCWEXDVIWQRVJVKVLWRXGWEXJWRXGXKE
      WQRVMVOVIWRXEXFXGSVPZWEWREVQNXLWREWPMEOVRVSXAEVTUSVIWAWBWCWD $.

    $( Any group element is annihilated by any multiple of the group exponent.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexdvdsi $p |- ( ( G e. Grp /\ A e. X /\ E || N ) ->
      ( N .x. A ) = .0. ) $=
      ( vx cgrp wcel cdivides co wceq cz wa simpld wbr cmul wrex simp3 dvdszrcl
      w3a cv divides biadan2 sylib simprd simpl1 adantr simpl2 mulgass syl13anc
      simpr gexid syl oveq2d mulgz 3ad2antl1 3eqtrd eqeq1d syl5ibcom rexlimdva
      oveq1 mpd ) DMNZAFNZCEOUAZUFZLUGZCUBPZEQZLRUCZEABPZGQZVLCRNZERNZSZVPVLVKW
      AVPSVIVJVKUDVKWAVPCEUELCEUHUIUJZUKVLVOVRLRVLVMRNZSZVNABPZGQVOVRWDWEVMCABP
      ZBPZVMGBPZGWDVIWCVSVJWEWGQVIVJVKWCULVLWCUQVLVSWCVLVSVTVLWAVPWBTTUMVIVJVKW
      CUNZFBDVMCAHJUOUPWDWFGVMBWDVJWFGQWIABCDFGHIJKURUSUTVIVJWCWHGQVKFBDVMGHJKV
      AVBVCVOWEVQGVNEABVGVDVEVFVH $.

    $( The only ` N ` that annihilate all the elements of the group are the
       multiples of the group exponent.  (Contributed by Mario Carneiro,
       24-Apr-2016.) $)
    gexdvds $p |- ( ( G e. Grp /\ N e. ZZ ) ->
      ( E || N <-> A. x e. X ( N .x. x ) = .0. ) ) $=
      ( vy wcel wa co wceq adantr cc0 cn cfv cgrp cz cdivides wbr wral gexdvdsi
      cv wi 3expia ralrimdva crab c0 cabs wn oveq1 eqeq1d ralbidv simprr eleq2d
      noel elrab syl5rbbr rbaibd mtbii ex cn0 nn0abscl ad2antlr elnn0 sylib ord
      wo syld wb cneg simpr oveq1d cminusg eqid mulgneg 3expa grpinvid ad2antrr
      eqcomd eqeq12d simpll mulgcl grpidcl grpinv11 bitrd sylan9bbr cr mpjaodan
      zre absord ralbidva 0dvds simprl breq1d cc zcn abs00ad 3imtr3d elrabi cmo
      3bitr4rd cdiv cfl cmul cmin csg adantl nnrp modval syl2an simplll simpllr
      crp nnz rerpdivcl flcld zmulcld syl13anc dvdsmul1 syl2anc syl3anc oveq12d
      mulgsubdir grpsubid eqtrd 3eqtrd ralimdva cle modlt zmodcl adantll nn0red
      expr clt c1 nnre ltnled mpbid w3a cfz gexlem2 elfzle2 impancom con3d mpid
      syl 3syld simplr dvdsval3 sylibrd sylan2 gexlem1 impbid ) DUAMZEUBMZNZCEU
      CUDZEAUGZBOZGPZAFUEZUUSUVBUVFUHUUTUUSUVBUVEAFUUSUVCFMZUVBUVEUVCBCDEFGHIJK
      UFUIUJQUVACRPZLUGZUVCBOZGPZAFUEZLSUKZULPZNZUVFUVBUHZCUVMMZUVAUVONZEUMTZUV
      CBOZGPZAFUEZUVSRPZUVFUVBUVRUWBUVSSMZUNZUWCUVRUWBUWEUVRUWBNUVSULMZUWDUVSUT
      UVRUWFUWDUWBUWDUWBNUVSUVMMUVRUWFUVLUWBLUVSSUVIUVSPZUVKUWAAFUWGUVJUVTGUVIU
      VSUVCBUOUPUQVAUVRUVMULUVSUVAUVHUVNURUSVBVCVDVEUVRUWDUWCUVRUVSVFMZUWDUWCVL
      UUTUWHUUSUVOEVGVHUVSVIVJVKVMUVAUWBUVFVNUVOUVAUWAUVEAFUVAUVGNZUVSEPZUWAUVE
      VNUVSEVOZPZUWIUWJNZUVTUVDGUWMUVSEUVCBUWIUWJVPVQUPUWLUWAUWKUVCBOZGPZUWIUVE
      UWLUVTUWNGUVSUWKUVCBUOUPUWIUWOUVDDVRTZTZGUWPTZPUVEUWIUWNUWQGUWRUUSUUTUVGU
      WNUWQPFBDUWPEUVCHJUWPVSZVTWAUWIUWRGUUSUWRGPUUTUVGDUWPGKUWSWBWCWDWEUWIFDUW
      PUVDGHUWSUUSUUTUVGWFUUSUUTUVGUVDFMFBDEUVCHJWGWAUUSGFMZUUTUVGFDGHKWHZWCWIW
      JWKUWIEUUTEWLMZUUSUVGEWNZVHWOWMWPQUVRREUCUDZERPZUVBUWCUUTUXDUXEVNUUSUVOEW
      QVHUVRCREUCUVAUVHUVNWRWSUVREUUTEWTMUUSUVOEXAVHXBXFXCUVQUVACSMZUVPUVLLCSXD
      UVAUXFNZUVFECXEOZRPZUVBUXGUVFUXHUVCBOZGPZAFUEZUXHSMZUNZUXIUXGUVEUXKAFUXGU
      VGUVEUXKUXGUVGUVENZNZUXJECECXGOZXHTZXIOZXJOZUVCBOZUVDUXSUVCBOZDXKTZOZGUXP
      UXHUXTUVCBUXGUXHUXTPZUXOUVAUXBCXRMZUYEUXFUUTUXBUUSUXCXLZCXMZECXNXOQVQUXPU
      USUUTUXSUBMUVGUYAUYDPUUSUUTUXFUXOXPZUUSUUTUXFUXOXQUXPCUXRUXFCUBMZUVAUXOCX
      SVHZUXGUXRUBMZUXOUXGUXQUVAUXBUYFUXQWLMUXFUYGUYHECXTXOYAQZYBUXGUVGUVEWRZFB
      DEUYCUXSUVCHJUYCVSZYHYCUXPUYDGGUYCOZGUXPUVDGUYBGUYCUXGUVGUVEURUXPUUSUVGCU
      XSUCUDZUYBGPUYIUYNUXPUYJUYLUYQUYKUYMCUXRYDYEUVCBCDUXSFGHIJKUFYFYGUXGUYPGP
      ZUXOUXGUUSUWTUYRUUSUUTUXFWFUUSUWTUUTUXFUXAWCFDUYCGGHKUYOYIYEQYJYKYRYLUXGU
      XLCUXHYMUDZUNZUXNUXGUXHCYSUDZUYTUVAUXBUYFVUAUXFUYGUYHECYNXOUXGUXHCUXGUXHU
      UTUXFUXHVFMZUUSECYOYPZYQUXFCWLMUVACUUAXLUUBUUCUUSUXLUYTUXNUHZUHUUTUXFUUSU
      XLVUDUUSUXLNUXMUYSUUSUXMUXLUYSUUSUXMUXLUYSUUSUXMUXLUUDCYTUXHUUEOMUYSABCDU
      XHUAFGHIJKUUFCYTUXHUUGUUKUIUUHUUIVEWCUUJUXGUXMUXIUXGVUBUXMUXIVLVUCUXHVIVJ
      VKUULUXGUXFUUTUVBUXIVNUVAUXFVPUUSUUTUXFUUMCEUUNYEUUOUUPUUSUVOUVQVLUUTALBC
      DUVMUAFGHJKIUVMVSUUQQWMUUR $.
  $}

  ${
    $d x E $.  $d x G $.  $d x N $.  $d x X $.
    gexod.1 $e |- X = ( Base ` G ) $.
    gexod.2 $e |- E = ( gEx ` G ) $.
    gexod.3 $e |- O = ( od ` G ) $.
    $( An integer divides the group exponent iff it divides all the group
       orders.  In other words, the group exponent is the LCM of the orders of
       all the elements.  (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexdvds2 $p |- ( ( G e. Grp /\ N e. ZZ ) ->
      ( E || N <-> A. x e. X ( O ` x ) || N ) ) $=
      ( cgrp wcel cz wa cdivides wbr cv cmg cfv wral eqid co c0g gexdvds oddvds
      wceq wb 3expa an32s ralbidva bitr4d ) CJKZDLKZMZBDNODAPZCQRZUACUBRZUEZAFS
      UNERDNOZAFSAUOBCDFUPGHUOTZUPTZUCUMURUQAFUKUNFKZULURUQUFZUKVAULVBUNUOCDEFU
      PGIUSUTUDUGUHUIUJ $.

    $( Any group element is annihilated by any multiple of the group exponent.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexod $p |- ( ( G e. Grp /\ A e. X ) -> ( O ` A ) || E ) $=
      ( cgrp wcel wa cfv cdivides wbr cmg co c0g wceq eqid gexid cz gexcl nn0zd
      adantl wb cn0 adantr oddvds mpd3an3 mpbird ) CIJZAEJZKZADLBMNZBACOLZPCQLZ
      RZULUQUKAUOBCEUPFGUOSZUPSZTUDUKULBUAJUNUQUEUMBUKBUFJULBCIEFGUBUGUCAUOCBDE
      UPFHURUSUHUIUJ $.

    $( If the order of every group element is bounded by ` N ` , the group has
       finite exponent.  (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexcl3 $p |- ( ( G e. Grp /\
      A. x e. X ( O ` x ) e. ( 1 ... N ) ) -> E e. NN ) $=
      ( cgrp wcel cfv c1 cfz co wral wa cn cuz syl cv cfa cmg c0g wceq cn0 wrex
      simpl c0 wne grpbn0 r19.2z sylan elfzuz2 syl6eleqr rexlimivw nnnn0d faccl
      cdivides wbr elfzuzb elnnuz dvdsfac sylanbr sylbi adantl cz simpll simplr
      nnuz wb nnzd eqid oddvds syl3anc mpbid ex ralimdva imp gexlem2 elfznn ) C
      JKZAUAZELZMDNOKZAFPZQZBMDUBLZNOKZBRKWGWBWHRKZWHWCCUCLZOCUDLZUEZAFPZWIWBWF
      UHWGDUFKZWJWGDWGWEAFUGZDRKZWBFUIUJWFWPFCGUKWEAFULUMWEWQAFWEDMSLZRWDMDUNVJ
      UOZUPTUQDURZTWBWFWNWBWEWMAFWBWCFKZQZWEWMXBWEQZWDWHUSUTZWMWEXDXBWEWDWRKZDW
      DSLKZQXDWDMDVAXEWDRKXFXDWDVBWDDVCVDVEVFXCWBXAWHVGKXDWMVKWBXAWEVHWBXAWEVIX
      CWHXCWOWJXCDWEWQXBWSVFUQWTTVLWCWKCWHEFWLGIWKVMZWLVMZVNVOVPVQVRVSAWKBCWHJF
      WLGHXGXHVTVOBWHWAT $.

    $( Every group element has finite order if the exponent is finite.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexnnod $p |- ( ( G e. Grp /\ E e. NN /\ A e. X ) -> ( O ` A ) e. NN ) $=
      ( cgrp wcel cn w3a cfv cc0 wceq cdivides wbr wn wne 3ad2ant2 nnne0 cz nnz
      wb 0dvds syl necon3bbid mpbird gexod 3adant2 breq1 syl5ibcom mtod wo odcl
      cn0 3ad2ant3 elnn0 sylib ord mt3d ) CIJZBKJZAEJZLZADMZKJZVFNOZVEVHNBPQZVE
      VIRBNSZVCVBVJVDBUATVEVIBNVEBUBJZVIBNOUDVCVBVKVDBUCTBUEUFUGUHVEVFBPQZVHVIV
      BVDVLVCABCDEFGHUIUJVFNBPUKULUMVEVGVHVEVFUPJZVGVHUNVDVBVMVCACDEFHUOUQVFURU
      SUTVA $.
  $}

  ${
    $d x E $.  $d x G $.  $d x X $.
    gexcl2.1 $e |- X = ( Base ` G ) $.
    gexcl2.2 $e |- E = ( gEx ` G ) $.
    $( The exponent of a finite group is finite.  (Contributed by Mario
       Carneiro, 24-Apr-2016.) $)
    gexcl2 $p |- ( ( G e. Grp /\ X e. Fin ) -> E e. NN ) $=
      ( vx cgrp wcel cfn cv cod cfv c1 chash cn wa wbr cz nnzd wb cfz wral eqid
      co w3a cle odcl2 cdivides oddvds2 wi c0 grpbn0 3ad2ant1 hashnncl 3ad2ant2
      wne mpbird dvdsle syl2anc mpd syl mpbir2and 3expa ralrimiva gexcl3 syldan
      fznn ) BGHZCIHZFJZBKLZLZMCNLZUAUDHZFCUBAOHVHVIPVNFCVHVIVJCHZVNVHVIVOUEZVN
      VLOHZVLVMUFQZVJBVKCDVKUCZUGZVPVLVMUHQZVRVJBVKCDVSUIVPVLRHVMOHZWAVRUJVPVLV
      TSVPWBCUKUPZVHVIWCVOCBDULUMVIVHWBWCTVOCUNUOUQZVLVMURUSUTVPVMRHVNVQVRPTVPV
      MWDSVLVMVGVAVBVCVDFABVMVKCDEVSVEVF $.

    $( The exponent of a finite group divides the order (cardinality) of the
       group.  Corollary of Lagrange's theorem for the order of a subgroup.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexdvds3 $p |- ( ( G e. Grp /\ X e. Fin ) -> E || ( # ` X ) ) $=
      ( vx cgrp wcel cfn wa chash cfv cdivides wbr cod wral eqid oddvds2 3expa
      cv ralrimiva cz wb cn0 hashcl adantl nn0zd gexdvds2 syldan mpbird ) BGHZC
      IHZJZACKLZMNZFTZBOLZLUNMNZFCPZUMURFCUKULUPCHURUPBUQCDUQQZRSUAUKULUNUBHUOU
      SUCUMUNULUNUDHUKCUEUFUGFABUNUQCDEUTUHUIUJ $.

    $( A group or monoid has exponent 1 iff it is trivial.  (Contributed by
       Mario Carneiro, 24-Apr-2016.) $)
    gex1 $p |- ( G e. Mnd -> ( E = 1 <-> X ~~ 1o ) ) $=
      ( vx cmnd wcel c1 wceq c1o cen wbr wa c0g cfv csn co eqid adantl cv gexid
      cmg simplr oveq1d mulg1 3eqtr3rd elsn sylibr ex ssrdv mndidcl snssd eqssd
      adantr fvex ensn1 syl6eqbr cfz cn wral simpl 1nn a1i en1eqsn sylan eleq2d
      biimpa sylib eqtrd ralrimiva gexlem2 syl3anc elfz1eq syl impbida ) BGHZAI
      JZCKLMZVQVRNZCBOPZQZKLVTCWBVTFCWBVTFUAZCHZWCWBHZVTWDNZWCWAJZWEWFAWCBUCPZR
      ZIWCWHRZWAWCWFAIWCWHVQVRWDUDUEWDWIWAJVTWCWHABCWADEWHSZWASZUBTWDWJWCJZVTCW
      HBWCDWKUFZTUGFWAUHZUIUJUKVTWACVQWACHZVRCBWADWLULZUOUMUNWABOUPUQURVQVSNZAI
      IUSRHZVRWRVQIUTHZWJWAJZFCVAWSVQVSVBWTWRVCVDWRXAFCWRWDNZWJWCWAWDWMWRWNTXBW
      EWGWRWDWEWRCWBWCVQWPVSCWBJWQWACVEVFVGVHWOVIVJVKFWHABIGCWADEWKWLVLVMAIVNVO
      VP $.
  $}

  ${
    $d g n p x G $.  $d g p O $.  $d g n p x P $.  $d g p x X $.
    ispgp.1 $e |- X = ( Base ` G ) $.
    ispgp.2 $e |- O = ( od ` G ) $.
    $( A group is a ` P ` -group if every element has some power of ` P ` as
       its order.  (Contributed by Mario Carneiro, 15-Jan-2015.) $)
    ispgp $p |- ( P pGrp G <-> ( P e. Prime /\ G e. Grp /\
      A. x e. X E. n e. NN0 ( O ` x ) = ( P ^ n ) ) ) $=
      ( vg vp cpgp cprime wa cv cfv cexp wceq cn0 cod cbs wbr wcel cgrp co wrex
      simpr fveq2d syl6eqr fveq1d simpl oveq1d eqeq12d rexbidv raleqbidv df-pgp
      wral w3a brab2ga df-3an bitr4i ) BDKUABLUBZDUCUBZMANZEOZBCNZPUDZQZCRUEZAF
      UPZMVAVBVIUQVCINZSOZOZJNZVEPUDZQZCRUEZAVJTOZUPVIJIBDLUCKVMBQZVJDQZMZVPVHA
      VQFVTVQDTOFVTVJDTVRVSUFZUGGUHVTVOVGCRVTVLVDVNVFVTVCVKEVTVKDSOEVTVJDSWAUGH
      UHUIVTVMBVEPVRVSUJUKULUMUNAICJUOURVAVBVIUSUT $.
  $}

  ${
    $d g n p x G $.  $d n x N $.  $d n x P $.  $d x X $.
    $( Reverse closure for the first argument of ` pGrp ` .  (Contributed by
       Mario Carneiro, 15-Jan-2015.) $)
    pgpprm $p |- ( P pGrp G -> P e. Prime ) $=
      ( vx vn cpgp wbr cprime wcel cgrp cv cod cfv cexp wceq cn0 wrex wral eqid
      co cbs ispgp simp1bi ) ABEFAGHBIHCJBKLZLADJMSNDOPCBTLZQCADBUCUDUDRUCRUAUB
      $.

    $( Reverse closure for the second argument of ` pGrp ` .  (Contributed by
       Mario Carneiro, 15-Jan-2015.) $)
    pgpgrp $p |- ( P pGrp G -> G e. Grp ) $=
      ( vx vn cpgp wbr cprime wcel cgrp cv cod cfv cexp wceq cn0 wrex wral eqid
      co cbs ispgp simp2bi ) ABEFAGHBIHCJBKLZLADJMSNDOPCBTLZQCADBUCUDUDRUCRUAUB
      $.

    pgpfi1.1 $e |- X = ( Base ` G ) $.
    $( A finite group with order a power of a prime ` P ` is a ` P ` -group.
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    pgpfi1 $p |- ( ( G e. Grp /\ P e. Prime /\ N e. NN0 ) ->
      ( ( # ` X ) = ( P ^ N ) -> P pGrp G ) ) $=
      ( vx vn wcel cn0 cfv cexp co wceq wbr wa cv wrex cdivides adantr cvv cgrp
      cprime w3a chash cpgp cod wral simpl2 simpl1 simpll3 cfn simplr prmnn syl
      cn nnexpcld nnnn0d eqeltrd wb cbs fvex eqeltri hashclb ax-mp sylibr simpr
      eqid oddvds2 syl3anc breqtrd oveq2 breq2d rspcev syl2anc pcprmpw2 pcprmpw
      odcl2 cpc bitr4d mpbid ralrimiva ispgp syl3anbrc ex ) BUAHZAUBHZCIHZUCZDU
      DJZACKLZMZABUENZWHWKOZWFWEFPZBUFJZJZAGPZKLZMGIQZFDUGWLWEWFWGWKUHZWEWFWGWK
      UIZWMWSFDWMWNDHZOZWPWRRNZGIQZWSXCWGWPWJRNZXEWEWFWGWKXBUJZXCWPWIWJRXCWEDUK
      HZXBWPWIRNWMWEXBXASZXCWIIHZXHXCWIWJIWHWKXBULZXCWJXCACXCWFAUOHWMWFXBWTSZAU
      MUNXGUPUQURDTHXHXJUSDBUTJTEBUTVAVBDTVCVDVEZWMXBVFZWNBWODEWOVGZVHVIXKVJXDX
      FGCIWQCMWRWJWPRWQCAKVKVLVMVNXCWFWPUOHZXEWSUSXLXCWEXHXBXPXIXMXNWNBWODEXOVQ
      VIWFXPOXEWPAAWPVRLKLMWSWPAGVOWPAGVPVSVNVTWAFAGBWODEXOWBWCWD $.
  $}

  ${
    pgp0.1 $e |- .0. = ( 0g ` G ) $.
    $( The identity subgroup is a ` P ` -group for every prime ` P ` .
       (Contributed by Mario Carneiro, 19-Jan-2015.) $)
    pgp0 $p |- ( ( G e. Grp /\ P e. Prime ) -> P pGrp ( G |`s { .0. } ) ) $=
      ( cgrp wcel cprime wa csn cress co cfv chash cc0 wceq c1 cvv c0g eqid syl
      cbs cexp cpgp wbr cn prmnn adantl nncnd exp0d eqeltri hashsng ax-mp csubg
      fvex 0subg adantr subgbas fveq2d syl5eqr eqtr2d cn0 wi subggrp simpr 0nn0
      a1i pgpfi1 syl3anc mpd ) BEFZAGFZHZBCIZJKZUALZMLZANUBKZOZAVNUCUDZVLVQPVPV
      LAVLAVKAUEFVJAUFUGUHUIVLPVMMLZVPCQFVTPOCBRLQDBRUNUJCQUKULVLVMVOMVLVMBUMLF
      ZVMVOOVJWAVKBCDUOUPZVMBVNVNSZUQTURUSUTVLVNEFZVKNVAFZVRVSVBVLWAWDWBVMBVNWC
      VCTVJVKVDWEVLVEVFAVNNVOVOSVGVHVI $.
  $}

  ${
    $d n x G $.  $d n x P $.  $d n x S $.
    $( A subgroup of a p-group is a p-group.  (Contributed by Mario Carneiro,
       27-Apr-2016.) $)
    subgpgp $p |- ( ( P pGrp G /\ S e. ( SubGrp ` G ) ) ->
      P pGrp ( G |`s S ) ) $=
      ( vx vn cpgp wbr cfv wcel wa co cgrp cod wceq cn0 wrex wral eqid adantl
      cv csubg cprime cress cexp cbs pgpprm adantr subggrp ispgp simp3bi wss wi
      subgss ssralv syl subgod adantll eqeq1d rexbidv ralbidva sylibd mpd mpbid
      subgbas raleqdv syl3anbrc ) ACFGZBCUAHIZJZAUBIZCBUCKZLIZDTZVKMHZHZAETUDKZ
      NZEOPZDVKUEHZQZAVKFGVGVJVHACUFUGVHVLVGBCVKVKRZUHSVIVRDBQZVTVIVMCMHZHZVPNZ
      EOPZDCUEHZQZWBVGWHVHVGVJCLIWHDAECWCWGWGRZWCRZUIUJUGVIWHWFDBQZWBVIBWGUKZWH
      WKULVHWLVGWGBCWIUMSWFDBWGUNUOVIWFVRDBVIVMBIZJZWEVQEOWNWDVOVPVHWMWDVONVGVM
      VNCVKWCBWAWJVNRZUPUQURUSUTVAVBVIVRDBVSVHBVSNVGBCVKWAVDSVEVCDAEVKVNVSVSRWO
      UIVF $.
  $}

  ${
    $d a b c g s u x y z B $.  $d a b c g h x y H $.  $d a b c g u w x y z S $.
    $d a b g h k n s t u v w x y z N $.  $d a b c g h k n s t u v w x y z X $.
    $d b c s u v w x y z .+ $.  $d a w z .~ $.  $d a b c g u w x y z .(+) $.
    $d a b c g h k s t u v x y z G $.  $d a b g h k n s t u v w x y z P $.
    $d a b c n t u x y z ph $.
    sylow1.x $e |- X = ( Base ` G ) $.
    sylow1.g $e |- ( ph -> G e. Grp ) $.
    sylow1.f $e |- ( ph -> X e. Fin ) $.
    sylow1.p $e |- ( ph -> P e. Prime ) $.
    sylow1.n $e |- ( ph -> N e. NN0 ) $.
    sylow1.d $e |- ( ph -> ( P ^ N ) || ( # ` X ) ) $.
    ${
      sylow1lem.a $e |- .+ = ( +g ` G ) $.
      sylow1lem.s $e |- S = { s e. ~P X | ( # ` s ) = ( P ^ N ) } $.
      $( Lemma for ~ sylow1 .  The p-adic valuation of the size of ` S ` is
         equal to the number of excess powers of ` P ` in
         ` ( # `` X ) / ( P ^ N ) ` .  (Contributed by Mario Carneiro,
         15-Jan-2015.) $)
      sylow1lem1 $p |- ( ph -> ( ( # ` S ) e. NN /\
        ( P pCnt ( # ` S ) ) = ( ( P pCnt ( # ` X ) ) - N ) ) ) $=
        ( wcel cpc co cc0 vx vn chash cfv cn cmin wceq cexp cbc cv cpw crab cfn
        cz cprime prmnn syl nnexpcld nnzd hashbc syl2anc fveq2i syl6eqr cfz cle
        wbr cdivides wi wn wne cgrp grpbn0 hasheq0 necon3bbid mpbird cn0 hashcl
        c0 wb wo elnn0 sylib ord mt3d dvdsle mpd cuz nn0uz syl6eleq nn0zd elfz5
        bccl2 c1 cdiv cmul caddc a1i mpbid bcp1nk cc nn0cnd npcan sylancl nncnd
        ax-1cn oveq12d oveq2d 3eqtr3d nnne0d syl3anc syl122anc oveq1d clt nnred
        breq1 bcxmaslem1 eqeq1d imbi12d imbi2d eqtrd wa ad2antrl nn0p1nn adantr
        cr expr eqtr3d nnq crp nnrp pcdiv syl121anc simpr ad2antrr pccld nn0red
        cq pcdvdsb lenltd a2d nnnn0d eqeltrrd nnuz 1z fzsubel syl22anc dvdsval2
        1m1e0 oveq1i divne0d pcmul npncand ltm1d nnm1nn0 0nn0 nn0addcl bcn0 pc1
        znn0sub nn0re ltp1d simprr lttrd imim1d oveq1 nn0cn nn0addge2 nn0addcld
        a1d addassd simprl peano2zd rpdivcl syl2an rpne0d pcqmul addcomd eqtr2d
        znq addid1d zq neneqd sylbid 3imtr3d dvdssubr ltletrd pcadd2 pm2.61dane
        mt4d eqtr4d eqeltrd subeq0bd 00id syl6req eqeq12d syl5ibr expcom nn0ind
        syld mpcom pcid zsubcld zcnd addid2d 3eqtrd jca ) ADUCUDZUEQBUXGRSZBGUC
        UDZRSZFUFSZUGAUXIBFUHSZUISZUXGUEAUXMHUJUCUDUXLUGHGUKULZUCUDZUXGAGUMQZUX
        LUNQZUXMUXOUGKAUXLABFABUOQZBUEQLBUPUQMURZUSZHGUXLUTVADUXNUCPVBVCZAUXLTU
        XIVDSQZUXMUEQAUYBUXLUXIVEVFZAUXLUXIVGVFZUYCNAUXQUXIUEQZUYDUYCVHUXTAUYEU
        XITUGZAUYFVIGVRVJZAEVKQUYGJGEIVLUQAUYFGVRAUXPUYFGVRUGVSKGUMVMUQVNVOAUYE
        UYFAUXIVPQZUYEUYFVTAUXPUYHKGVQUQZUXIWAWBWCWDZUXLUXIWEVAWFZAUXLTWGUDZQUX
        IUNQZUYBUYCVSAUXLVPUYLAUXLUXSUUAWHWIAUXIUYIWJZUXLTUXIWKVAVOUXLUXIWLUQUU
        BABUXMRSBUXIWMUFSZUXLWMUFSZUISZUXIUXLWNSZWOSZRSZUXHUXKAUXMUYSBRAUYOWMWP
        SZUYPWMWPSZUISZUYQVUAVUBWNSZWOSZUXMUYSAUYPTUYOVDSZQZVUCVUEUGAUYPWMWMUFS
        ZUYOVDSZVUFAUXLWMUXIVDSQZUYPVUIQZAVUJUYCUYKAUXLWMWGUDZQUYMVUJUYCVSAUXLU
        EVULUXSUUCWIUYNUXLWMUXIWKVAVOAWMUNQZUYMUXQVUMVUJVUKVSVUMAUUDWQZUYNUXTVU
        NUXLWMWMUXIUUEUUFWRVUHTUYOVDUUHUUIWIZUYPUYOWSUQAVUAUXIVUBUXLUIAUXIWTQWM
        WTQZVUAUXIUGAUXIUYIXAZXEUXIWMXBXCZAUXLWTQVUPVUBUXLUGAUXLUXSXDZXEUXLWMXB
        XCZXFAVUDUYRUYQWOAVUAUXIVUBUXLWNVURVUTXFXGXHXGAUXMUXGBRUYAXGAUYTBUYQRSZ
        BUYRRSZWPSZTUXKWPSUXKAUXRUYQUNQUYQTVJUYRUNQZUYRTVJUYTVVCUGLAUYQAVUGUYQU
        EQVUOUYPUYOWLUQZUSAUYQVVEXIAUYDVVDNAUXQUXLTVJUYMUYDVVDVSUXTAUXLUXSXIZUY
        NUXLUXIUUGXJWRAUXIUXLVUQVUSAUXIUYJXIZVVFUUJUYQUYRBUUKXKAVVATVVBUXKWPABU
        XIUXLUFSZUYPWPSZUYPUISZRSZVVATAVVJUYQBRAVVIUYOUYPUIAUXIUXLWMVUQVUSVUPAX
        EWQUULXLXGAUYPUXLXMVFZVVKTUGZAUXLAUXLUXSXNUUMUYPVPQZAVVLVVMVHZAUXLUEQZV
        VNUXSUXLUUNUQAUAUJZUXLXMVFZBVVHVVQWPSVVQUISZRSZTUGZVHZVHATUXLXMVFZBVVHT
        WPSZTUISZRSZTUGZVHZVHAUBUJZUXLXMVFZBVVHVWIWPSZVWIUISZRSZTUGZVHZVHAVWIWM
        WPSZUXLXMVFZBVVHVWPWPSZVWPUISZRSZTUGZVHZVHAVVOVHUAUBUYPVVQTUGZVWBVWHAVX
        CVVRVWCVWAVWGVVQTUXLXMXOVXCVVTVWFTVXCVVSVWEBRVVQTVVHXPXGXQXRXSVVQVWIUGZ
        VWBVWOAVXDVVRVWJVWAVWNVVQVWIUXLXMXOVXDVVTVWMTVXDVVSVWLBRVVQVWIVVHXPXGXQ
        XRXSVVQVWPUGZVWBVXBAVXEVVRVWQVWAVXAVVQVWPUXLXMXOVXEVVTVWTTVXEVVSVWSBRVV
        QVWPVVHXPXGXQXRXSVVQUYPUGZVWBVVOAVXFVVRVVLVWAVVMVVQUYPUXLXMXOVXFVVTVVKT
        VXFVVSVVJBRVVQUYPVVHXPXGXQXRXSAVWGVWCAVWFBWMRSZTAVWEWMBRAVWDVPQZVWEWMUG
        AVVHVPQZTVPQVXHAUYCVXIUYKAUXQUYMUYCVXIVSUXTUYNUXLUXIUUSVAWRZUUOVVHTUUPX
        CVWDUUQUQXGAUXRVXGTUGLBUURUQXTUVIVWIVPQZAVWOVXBAVXKVWOVXBVHAVXKYAZVWOVW
        QVWNVHVXBVXLVWQVWJVWNAVXKVWQVWJAVXKVWQYAZYAZVWIVWPUXLVXKVWIYEQZAVWQVWIU
        UTYBZVXNVWPVXKVWPUEQZAVWQVWIYCYBZXNZVXNUXLAVVPVXMUXSYDXNZVXNVWIVXPUVAAV
        XKVWQUVBZUVCYFUVDVXLVWQVWNVXAAVXKVWQVWNVXAVHVWNVXAVXNVWMBVWKWMWPSZVWPWN
        SZRSZWPSZTVYDWPSZUGVWMTVYDWPUVEVXNVWTVYETVYFVXNVWTBVWLVYCWOSZRSZVYEVXNV
        WSVYGBRVXNVYBVWPUISZVWSVYGVXNVYBVWRVWPUIVXNVVHVWIWMVXNVVHAVXIVXMVXJYDZX
        AZVXKVWIWTQAVWQVWIUVFYBVUPVXNXEWQUVJZXLVXNVWITVWKVDSQZVYIVYGUGVXNVYMVWI
        VWKVEVFZVXNVXOVXIVYNVXPVYJVWIVVHUVGVAVXNVWIUYLQVWKUNQVYMVYNVSVXNVWIVPUY
        LAVXKVWQUVKZWHWIVXNVWKVXNVVHVWIVYJVYOUVHZWJZVWITVWKWKVAVOZVWIVWKWSUQYGX
        GVXNUXRVWLYQQZVWLTVJVYCYQQZVYCTVJVYHVYEUGAUXRVXMLYDZVXNVWLUEQZVYSVXNVYM
        WUBVYRVWIVWKWLUQZVWLYHUQVXNVWLWUCXIVXNVYBUNQZVXQVYTVXNVWKVYQUVLZVXRVYBV
        WPUVSVAVXNVYCVXNVYBUEQZVXQVYCYIQZVXNVWKVPQWUFVYPVWKYCUQZVXRWUFVYBYIQVWP
        YIQWUGVXQVYBYJVWPYJVYBVWPUVMUVNVAUVOVWLVYCBUVPXKXTVXNVYFTTWPSTVXNVYDTTW
        PVXNVYDBVYBRSZBVWPRSZUFSZTVXNUXRWUDVYBTVJVXQVYDWUKUGWUAWUEVXNVYBWUHXIVX
        RVYBVWPBYKYLVXNWUIWUJVXNWUIWUJWTVXNWUIBVWPVVHWPSZRSZWUJVXNVYBWULBRVXNVY
        BVWRWULVYLVXNVVHVWPVYKVXNVWPVXRXDZUVQXTXGVXNWUJWUMUGVVHTVXNVVHTUGZYAZVW
        PWULBRWUPWULVWPTWPSZVWPWUPVVHTVWPWPVXNWUOYMXGVXNWUQVWPUGWUOVXNVWPWUNUVT
        YDUVRXGVXNVVHTVJZYAZVWPVVHBAUXRVXMWURLYNZVXNVWPYQQZWURVXNVXQWVAVXRVWPYH
        UQYDVXNVVHYQQZWURVXNVVHUNQZWVBVXNVVHVYJWJVVHUWAUQYDWUSWUJFBVVHRSZVXNWUJ
        YEQWURVXNWUJVXNBVWPWUAVXRYOZYPZYDVXNFYEQWURVXNFAFVPQZVXMMYDZYPZYDWUSWVD
        WUSBVVHWUTWUSVVHUEQZWUOWUSVVHTVXNWURYMUWBWUSWVJWUOWUSVXIWVJWUOVTAVXIVXM
        WURVXJYNZVVHWAWBWCWDYOYPVXNWUJFXMVFZWURVXNVWQWVLVYAVXNFWUJVEVFZUXLVWPVE
        VFZWVLVIVWQVIVXNWVMUXLVWPVGVFZWVNVXNUXRVWPUNQWVGWVMWVOVSWUAVXNVWPVXRUSW
        VHFBVWPYRXJVXNUXQVXQWVOWVNVHAUXQVXMUXTYDVXRUXLVWPWEVAUWCVXNFWUJWVIWVFYS
        VXNUXLVWPVXTVXSYSUWDUWIYDWUSFWVDVEVFZUXLVVHVGVFZAWVQVXMWURAUYDWVQNAUXQU
        YMUYDWVQVSUXTUYNUXLUXIUWEVAWRYNWUSUXRWVCWVGWVPWVQVSWUTWUSVVHWVKWJAWVGVX
        MWURMYNFBVVHYRXJVOUWFUWGUWHUWJZVXNWUJWVEXAUWKWVRUWLXTXGUWMUWNUWOUWPYFYT
        UWSUWQYTUWRUWTWFYGAVVBUXJBUXLRSZUFSZUXKAUXRUYMUXITVJVVPVVBWVTUGLUYNVVGU
        XSUXIUXLBYKYLAWVSFUXJUFAUXRFUNQWVSFUGLAFMWJZFBUXAVAXGXTXFAUXKAUXKAUXJFA
        UXJABUXILUYJYOWJWWAUXBUXCUXDUXEXHUXF $.

      sylow1lem.m $e |- .(+) = ( x e. X , y e. S |->
        ran ( z e. y |-> ( x .+ z ) ) ) $.
      $( Lemma for ~ sylow1 .  The function ` .(+) ` is a group action on
         ` S ` .  (Contributed by Mario Carneiro, 15-Jan-2015.) $)
      sylow1lem2 $p |- ( ph -> .(+) e. ( G GrpAct S ) ) $=
        ( va vb vc vw vu vv cgrp wcel cvv wa cxp wf c0g cfv cv co wceq wral cga
        chash cexp cpw crab cbs fvex eqeltri pwex rabex jctir cmpt crn wss cres
        wf1 wf1o adantr simprl grplmulf1o syl2anc f1of1 syl simprr fveq2 eqeq1d
        eqid weq elrab2 sylib simpld elpwid f1ssres resmpt f1eq1 3syl mpbid f1f
        wb frn elpw2 sylibr cen wbr f1f1orn vex f1oen ssfi hashen mpbird simprd
        cfn eqtr3d sylanbrc ralrimivva fmpt2 simpr simpl oveq1d mpteq12dv rneqd
        grpidcl mptex rnex ovmpt2a cid ssrab2 sseldi sselda grplid sylan syl6eq
        eqsstri wrex cab ovex oveq2 rnmpt abbidv ad2antrr jca mpteq2dva abrexco
        syldan mptresid rnresi rexeqdv adantlr grpass syl13anc rexbidva 3eqtr4a
        eqtrd eqeq2d 3eqtr4g fovrnd cbvmptv grpcl syl3anc 3eqtr4rd ralrimiva
        isga ) AIUHUIZHUJUIZUKKHULHGUMZIUNUOZUBUPZGUQZUVFURZUCUPZUDUPZFUQZUVFGU
        QZUVIUVJUVFGUQZGUQZURZUDKUSUCKUSZUKZUBHUSZUKGIHUTUQUIAUVBUVCNHLUPZVAUOZ
        EJVBUQZURZLKVCZVDZUJTUWBLUWCKKIVEUOUJMIVEVFVGZVHVIVGVJAUVDUVRADCUPZBUPZ
        DUPZFUQZVKZVLZHUIZCHUSBKUSUVDAUWLBCKHAUWGKUIZUWFHUIZUKZUKZUWKUWCUIZUWKV
        AUOZUWAURZUWLUWPUWKKVMZUWQUWPUWFKUWJVOZUWFKUWJUMUWTUWPUWFKDKUWIVKZUWFVN
        ZVOZUXAUWPKKUXBVOZUWFKVMZUXDUWPKKUXBVPZUXEUWPUVBUWMUXGAUVBUWONVQAUWMUWN
        VRDKFUXBIUWGMSUXBWFVSVTKKUXBWAWBUWPUWFKUWPUWFUWCUIZUWFVAUOZUWAURZUWPUWN
        UXHUXJUKAUWMUWNWCUWBUXJLUWFUWCHLCWGUVTUXIUWAUVSUWFVAWDWETWHWIZWJWKZKKUW
        FUXBWLVTUWPUXFUXCUWJURUXDUXAWRUXLDKUWFUWIWMUWFKUXCUWJWNWOWPZUWFKUWJWQUW
        FKUWJWSWOZUWKKUWEWTXAUWPUXIUWRUWAUWPUXIUWRURZUWFUWKXBXCZUWPUXAUWFUWKUWJ
        VPUXPUXMUWFKUWJXDUWFUWKUWJCXEXFWOUWPUWFXKUIZUWKXKUIZUXOUXPWRUWPKXKUIZUX
        FUXQAUXSUWOOVQZUXLKUWFXGVTUWPUXSUWTUXRUXTUXNKUWKXGVTUWFUWKXHVTXIUWPUXHU
        XJUXKXJXLUWBUWSLUWKUWCHUVSUWKURUVTUWRUWAUVSUWKVAWDWETWHXMXNBCKHUWKHGUAX
        OWIZAUVQUBHAUVFHUIZUKZUVHUVPUYCUVGDUVFUVEUWHFUQZVKZVLZUVFUYCUVEKUIZUYBU
        VGUYFURUYCUVBUYGAUVBUYBNVQZKIUVEMUVEWFZYAWBAUYBXPZBCUVEUVFKHUWKUYFGUWGU
        VEURZCUBWGZUKZUWJUYEUYMDUWFUWIUVFUYDUYKUYLXPUYMUWGUVEUWHFUYKUYLXQXRXSXT
        UAUYEDUVFUYDUBXEZYBYCYDVTUYCUYFYEUVFVNZVLUVFUYCUYEUYOUYCUYEDUVFUWHVKUYO
        UYCDUVFUYDUWHUYCUWHUVFUIZUWHKUIZUYDUWHURZUYCUVFKUWHUYCUVFKUYCHUWCUVFHUW
        DUWCTUWBLUWCYFYLUYJYGWKYHZUYCUVBUYQUYRUYHKFIUWHUVEMSUYIYIYJUUCUUADUVFUU
        DYKXTUVFUUEYKUULUYCUVOUCUDKKUYCUVIKUIZUVJKUIZUKZUKZUEUVMUVIUEUPZFUQZVKZ
        VLZDUVFUVKUWHFUQZVKZVLZUVNUVLVUCUFUPZVUEURZUEUVMYMZUFYNZVUKVUHURZDUVFYM
        ZUFYNZVUGVUJVUCVULUEUGUPUVJUWHFUQZURDUVFYMUGYNZYMZUFYNVUKUVIVURFUQZURZD
        UVFYMZUFYNVUNVUQUFUEUGDUVFVURVUEVVAUVJUWHFYOVUDVURUVIFYPUUBVUCVUMVUTUFV
        UCVULUEUVMVUSVUCUVMDUVFVURVKZVLZVUSVUCVUAUYBUVMVVEURUYCUYTVUAWCZUYCUYBV
        UBUYJVQZBCUVJUVFKHUWKVVEGBUDWGZUYLUKZUWJVVDVVIDUWFUWIUVFVURVVHUYLXPVVIU
        WGUVJUWHFVVHUYLXQXRXSXTUAVVDDUVFVURUYNYBYCYDVTDUGUVFVURVVDVVDWFYQYKUUFY
        RVUCVUPVVCUFVUCVUOVVBDUVFVUCUYPUKZVUHVVAVUKVVJUVBUYTVUAUYQVUHVVAURUYCUV
        BVUBUYPUYHYSVUCUYTUYPUYCUYTVUAVRZVQVUCVUAUYPVVFVQUYCUYPUYQVUBUYSUUGKFIU
        VIUVJUWHMSUUHUUIUUMUUJYRUUKUEUFUVMVUEVUFVUFWFYQDUFUVFVUHVUIVUIWFYQUUNVU
        CUYTUVMHUIUVNVUGURVVKVUCUVJUVFHKHGAUVDUYBVUBUYAYSVVFVVGUUOBCUVIUVMKHUWK
        VUGGBUCWGZUWFUVMURZUKZUWJVUFVVNUWJDUVMUVIUWHFUQZVKVUFVVNDUWFUWIUVMVVOVV
        LVVMXPVVNUWGUVIUWHFVVLVVMXQXRXSDUEUVMVVOVUEUWHVUDUVIFYPUUPYKXTUAVUFUEUV
        MVUEUVJUVFGYOYBYCYDVTVUCUVKKUIZUYBUVLVUJURVUCUVBUYTVUAVVPAUVBUYBVUBNYSV
        VKVVFKFIUVIUVJMSUUQUURVVGBCUVKUVFKHUWKVUJGUWGUVKURZUYLUKZUWJVUIVVRDUWFU
        WIUVFVUHVVQUYLXPVVRUWGUVKUWHFVVQUYLXQXRXSXTUAVUIDUVFVUHUYNYBYCYDVTUUSXN
        YTUUTYTUBUCUDFGIKHUVEMSUYIUVAXM $.

      sylow1lem3.1 $e |- .~ = { <. x , y >. |
        ( { x , y } C_ S /\ E. g e. X ( g .(+) x ) = y ) } $.
      $( Lemma for ~ sylow1 .  One of the orbits of the group action has p-adic
         valuation less than the prime count of the set ` S ` .  (Contributed
         by Mario Carneiro, 15-Jan-2015.) $)
      sylow1lem3 $p |- ( ph -> E. w e. S
        ( P pCnt ( # ` [ w ] .~ ) ) <_ ( ( P pCnt ( # ` X ) ) - N ) ) $=
        ( va cv chash cfv cpc co cmin cle wbr cqs wrex cec wn wral c1 caddc csu
        cexp cdivides cprime wcel wceq sylow1lem1 simpld pcndvds syl2anc simprd
        cn oveq1d oveq2d cga wer sylow1lem2 gaorber syl cpw cfn pwfi sylib crab
        wss ssrab2 eqsstri ssfi sylancl qshash breq12d mtbid wa adantr cz prmnn
        qsss cn0 pccld eqeltrrd peano2nn0 nnexpcld nnzd c0 wne cdm elqsn0 sylan
        erdm sselda elpwid hashnncl mpbird adantlr clt weq fveq2 breq1d rspccva
        wb notbid adantll cgrp grpbn0 nn0zd zsubcld ad2antrr zred zltp1le mpbid
        ltnled pcdvdsb syl3anc fsumdvds mtand dfrex2 sylibr wi eqid ectocld mpd
        imbi1d eceq1 fveq2d rspcev ex adantl rexlimdva ) AFUFUGZUHUIZUJUKZFNUHU
        IZUJUKZMULUKZUMUNZUFJIUOZUPZFEUGZIUQZUHUIZUJUKZUUOUMUNZEJUPZAUUPURZUFUU
        QUSZURUURAUVFFUUOUTVAUKZVCUKZUUQDUGZUHUIZDVBZVDUNZAFFJUHUIZUJUKZUTVAUKZ
        VCUKZUVMVDUNZUVLAFVEVFZUVMVMVFZUVQURSAUVSUVNUUOVGZAFGJLMNOPQRSTUAUBUCVH
        ZVIZFUVMVJVKAUVPUVHUVMUVKVDAUVOUVGFVCAUVNUUOUTVAAUVSUVTUWAVLZVNVOADJIAH
        LJVPUKVFJIVQZABCDFGHJLMNOPQRSTUAUBUCUDVRBCHIKLNJUEPVSVTZANWAZWBVFZJUWFW
        FJWBVFZANWBVFZUWGRNWCWDJOUGUHUIFMVCUKVGZOUWFWEUWFUCUWJOUWFWGWHUWFJWIWJZ
        WKWLWMAUVFWNZUUQUVJDUVHAUUQWBVFZUVFAJWAZWBVFZUUQUWNWFUWMAUWHUWOUWKJWCWD
        AJIUWEWRZUWNUUQWIVKWOAUVHWPVFUVFAUVHAFUVGAUVRFVMVFSFWQVTAUUOWSVFUVGWSVF
        ZAUVNUUOWSUWCAFUVMSUWBWTXAUUOXBVTZXCXDWOUWLUVIUUQVFZWNZUVJAUWSUVJVMVFZU
        VFAUWSWNZUXAUVIXEXFZAIXGJVGZUWSUXCAUWDUXDUWEJIXJVTJUVIIXHXIUXBUVIWBVFZU
        XAUXCYAUXBUWHUVIJWFUXEAUWHUWSUWKWOUXBUVIJAUUQUWNUVIUWPXKXLJUVIWIVKUVIXM
        VTXNXOZXDZUWTUVGFUVJUJUKZUMUNZUVHUVJVDUNZUWTUUOUXHXPUNZUXIUWTUXKUXHUUOU
        MUNZURZUVFUWSUXMAUVEUXMUFUVIUUQUFDXQZUUPUXLUXNUULUXHUUOUMUXNUUKUVJFUJUU
        JUVIUHXRVOXSYBXTYCUWTUUOUXHUWTUUOAUUOWPVFZUVFUWSAUUNMAUUNAFUUMSAUUMVMVF
        ZNXEXFZALYDVFUXQQNLPYEVTAUWIUXPUXQYARNXMVTXNWTYFAMTYFYGYHZYIUWTUXHUWTUX
        HUWTFUVJAUVRUVFUWSSYHZUXFWTYFZYIYLXNUWTUXOUXHWPVFUXKUXIYAUXRUXTUUOUXHYJ
        VKYKUWTUVRUVJWPVFUWQUXIUXJYAUXSUXGAUWQUVFUWSUWRYHUVGFUVJYMYNYKYOYPUUPUF
        UUQYQYRAUUPUVDUFUUQFUVIIUQZUHUIZUJUKZUUOUMUNZUVDYSZUUPUVDYSADUUJJIUUQUU
        QYTUYAUUJVGZUYDUUPUVDUYFUYCUULUUOUMUYFUYBUUKFUJUYAUUJUHXRVOXSUUCUVIJVFZ
        UYEAUYGUYDUVDUVCUYDEUVIJEDXQZUVBUYCUUOUMUYHUVAUYBFUJUYHUUTUYAUHUUSUVIIU
        UDUUEVOXSUUFUUGUUHUUAUUIUUB $.

      sylow1lem4.b $e |- ( ph -> B e. S ) $.
      sylow1lem4.h $e |- H = { u e. X | ( u .(+) B ) = B } $.
      $( Lemma for ~ sylow1 .  The stabilizer subgroup of any element of ` S `
         is at most ` P ^ N ` in size.  (Contributed by Mario Carneiro,
         15-Jan-2015.) $)
      sylow1lem4 $p |- ( ph -> ( # ` H ) <_ ( P ^ N ) ) $=
        ( va vb vc chash cfv cexp co cle wbr cdom cv wcel c0 wne wex cc0 cn cpw
        wceq fveq2 eqeq1d elrab2 sylib simprd cprime prmnn syl nnexpcld eqeltrd
        wa nnne0d wb hasheq0 necon3bid mpbid n0 adantr cmpt crn oveq2 eqid ovex
        simplr fvmpt wfn fnmpti fnfvelrn sylancr eqeltrrd cvv crab ssrab2 simpr
        eqsstri sseldi ad2antrr mptexg rnexg 3syl weq oveq1d mpteq12dv ovmpt2ga
        simpl rneqd syl3anc eleqtrrd oveq1 simprbi adantl eleqtrd simprl simprr
        ex cgrp simpld elpwid sselda grprcan syl13anc mpd exlimddv cfn wss ssfi
        dom2d sylancl syl2anc hashdom mpbird breqtrd ) ANUMUNZFUMUNZGOUOUPZUQAU
        UAUUBUQURZNFUSURZAUJUTZFVAZUUEUJAFVBVCZUUGUJVDAUUBVEVCZUUHAUUBAUUBUUCVF
        AFPVGZVAZUUBUUCVHZAFKVAZUUKUULVSUHQUTZUMUNZUUCVHUULQFUUJKUUNFVHUUOUUBUU
        CUUNFUMVIVJUEVKVLZVMZAGOAGVNVAGVFVAUAGVOVPUBVQVRVTAUUMUUIUUHWAUHUUMUUBV
        EFVBFKWBWCVPWDUJFWEVLAUUGVSZUUMUUEAUUMUUGUHWFUURUKULNFUKUTZUUFHUPZULUTZ
        UUFHUPZKUURUUSNVAZUUTFVAUURUVCVSZUUTUUSFIUPZFUVDUUTDFUUSDUTZHUPZWGZWHZU
        VEUVDUUFUVHUNZUUTUVIUVDUUGUVJUUTVHAUUGUVCWLZDUUFUVGUUTFUVHUVFUUFUUSHWIU
        VHWJZUUSUUFHWKWMVPUVDUVHFWNUUGUVJUVIVADFUVGUVHUUSUVFHWKUVLWOUVKFUUFUVHW
        PWQWRUVDUUSPVAZUUMUVIWSVAZUVEUVIVHUVDNPUUSNEUTZFIUPZFVHZEPWTPUIUVQEPXAX
        CZUURUVCXBXDAUUMUUGUVCUHXEZUVDUUMUVHWSVAUVNUVSDFUVGKXFUVHWSXGXHBCUUSFPK
        DCUTZBUTZUVFHUPZWGZWHUVIIWSBUKXIZUVTFVHZVSZUWCUVHUWFDUVTUWBFUVGUWDUWEXB
        UWFUWAUUSUVFHUWDUWEXMXJXKXNUFXLXOXPUVCUVEFVHZUURUVCUVMUWGUVQUWGEUUSPNEU
        KXIUVPUVEFUVOUUSFIXQVJUIVKXRXSXTYCUURUVCUVANVAZVSZUUTUVBVHUKULXIWAZUURU
        WIVSZMYDVAZUVMUVAPVAUUFPVAZUWJAUWLUUGUWISXEUWKNPUUSUVRUURUVCUWHYAXDUWKN
        PUVAUVRUURUVCUWHYBXDUURUWMUWIAFPUUFAFPAUUKUULUUPYEYFZYGWFPHMUUSUVAUUFRU
        DYHYIYCYOYJYKANYLVAZFYLVAZUUDUUEWAAPYLVAZNPYMUWOTUVRPNYNYPAUWQFPYMUWPTU
        WNPFYNYQNFYLYRYQYSUUQYT $.

      sylow1lem5.l $e |- ( ph ->
        ( P pCnt ( # ` [ B ] .~ ) ) <_ ( ( P pCnt ( # ` X ) ) - N ) ) $.
      $( Lemma for ~ sylow1 .  Using Lagrange's theorem and the
         orbit-stabilizer theorem, show that there is a subgroup with size
         exactly ` P ^ N ` .  (Contributed by Mario Carneiro, 16-Jan-2015.) $)
      sylow1lem5 $p |- ( ph ->
        E. h e. ( SubGrp ` G ) ( # ` h ) = ( P ^ N ) ) $=
        ( csubg cfv wcel chash cexp co wceq wrex cga sylow1lem2 gastacl syl2anc
        cv cle wbr sylow1lem4 cdivides cpc cec caddc cmin cr wb wne cdm gaorber
        cn c0 wer syl erdm eleqtrrd ecdmn0 cfn wss cpw pwfi crab ssrab2 eqsstri
        sylib ssfi sylancl hashnncl mpbird pccld nn0red grpbn0 leaddsub syl3anc
        ecss cgrp cmul cqg eqid orbsta2 syl21anc oveq2d cprime cc0 nnzd subg0cl
        nnne0d c0g ne0i pcmul syl122anc eqtrd breqtrd leadd2d cn0 pcdvdsb mpbid
        cz wi prmnn nnexpcld dvdsle hashcl nnred letri3d mpbir2and fveq2 eqeq1d
        mpd rspcev ) AONULUMZUNZOUOUMZGPUPUQZURZMVDZUOUMZUUAURZMYRUSAINKUTUQUNZ
        FKUNZYSABCDGHIKNPQRSTUAUBUCUDUEUFUGVAZUIEFINOQKSUJVBVCZAUUBYTUUAVEVFUUA
        YTVEVFZABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJVGAUUAYTVHVFZUUJAPGYTVIUQ
        ZVEVFZUUKAUUMGFJVJZUOUMZVIUQZPVKUQZUUPUULVKUQZVEVFAUUQGQUOUMZVIUQZUURVE
        AUUQUUTVEVFZUUPUUTPVLUQVEVFZUKAUUPVMUNPVMUNUUTVMUNUVAUVBVNAUUPAGUUOUBAU
        UOVRUNZUUNVSVOZAFJVPZUNUVDAFKUVEUIAKJVTZUVEKURAUUFUVFUUHBCIJLNQKUHSVQWA
        ZKJWBWAWCFJWDWLAUUNWEUNZUVCUVDVNAKWEUNZUUNKWFUVHAQWGZWEUNZKUVJWFUVIAQWE
        UNZUVKUAQWHWLKRVDUOUMUUAURZRUVJWIUVJUFUVMRUVJWJWKUVJKWMWNAFJKUVGXBKUUNW
        MVCUUNWOWAWPZWQWRZAPUCWRZAUUTAGUUSUBAUUSVRUNZQVSVOZANXCUNUVRTQNSWSWAAUV
        LUVQUVRVNUAQWOWAWPWQWRUUPPUUTWTXAWPAUUTGUUOYTXDUQZVIUQZUURAUUSUVSGVIAUU
        FUUGUVLUUSUVSURUUHUIUABCEFINOXEUQZLNOJQKSUJUWAXFUHXGXHXIAGXJUNZUUOYEUNU
        UOXKVOYTYEUNZYTXKVOUVTUURURUBAUUOUVNXLAUUOUVNXNAYTAYTVRUNZOVSVOZANXOUMZ
        OUNZUWEAYSUWGUUIONUWFUWFXFXMWAOUWFXPWAAOWEUNZUWDUWEVNAUVLOQWFUWHUAOEVDF
        IUQFURZEQWIQUJUWIEQWJWKQOWMWNZOWOWAWPZXLZAYTUWKXNUUOYTGXQXRXSXTAPUULUUP
        UVPAUULAGYTUBUWKWQWRUVOYAWPAUWBUWCPYBUNUUMUUKVNUBUWLUCPGYTYCXAYDAUUAYEU
        NUWDUUKUUJYFAUUAAGPAUWBGVRUNUBGYGWAUCYHZXLUWKUUAYTYIVCYPAYTUUAAYTAUWHYT
        YBUNUWJOYJWAWRAUUAUWMYKYLYMUUEUUBMOYRUUCOURUUDYTUUAUUCOUOYNYOYQVC $.
    $}

    $d g h ph $.
    $( Sylow's first theorem.  If ` P ^ N ` is a prime power that divides the
       cardinality of ` G ` , then ` G ` has a supgroup with size ` P ^ N ` .
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    sylow1 $p |- ( ph -> E. g e. ( SubGrp ` G ) ( # ` g ) = ( P ^ N ) ) $=
      ( vs vk vx vz cv cfv co wceq vh va vb vu vv vy vt cpr chash cexp cpw crab
      wss cplusg cmpt crn cmpt2 wrex wa copab cec cpc cmin cle csubg eqid oveq2
      wbr cbvmptv oveq1 mpteq2dv syl5eq mpteq1 cbvmpt2v preq12 sseq1d eqeqan12d
      rneqd rexbidv anbi12d cbvopabv sylow1lem3 wcel cgrp adantr cfn cprime cn0
      id cdivides simprl simprr sylow1lem5 rexlimddv ) ABUAQZUBQZUCQZUHZMQZUIRB
      EUJSZTMFUKULZUMZNQZWPUDUEFXAMUEQZUDQZWSDUNRZSZUOZUPZUQZSZWQTZNFURZUSZUBUC
      UTZVAUIRVBSBFUIRZVBSEVCSVDVHZCQUIRWTTCDVERURUAXAAOUFPUABXFXJXOXANDEFMGHIJ
      KLXFVFZXAVFZUDUEOUFFXAXIPUFQZOQZPQZXFSZUOZUPPXDYCUOZUPXEYATZXHYEYFXHPXDXE
      YBXFSZUOYEMPXDXGYGWSYBXEXFVGVIYFPXDYGYCXEYAYBXFVJVKVLVRXDXTTYEYDPXDXTYCVM
      VRVNZXNYAXTUHZXAUMZXCYAXJSZXTTZNFURZUSUBUCOUFWPYATZWQXTTZUSZXBYJXMYMYPWRY
      IXAWPWQYAXTVOVPYPXLYLNFYNYOXKYKWQXTWPYAXCXJVGYOWIVQVSVTWAZWBAWOXAWCZXQUSZ
      USOUFPUGWOBXFXJXOXANCDUGQWOXJSWOTUGFULZEFMGADWDWCYSHWEAFWFWCYSIWEABWGWCYS
      JWEAEWHWCYSKWEAWTXPWJVHYSLWEXRXSYHYQAYRXQWKYTVFAYRXQWLWMWN $.
  $}

  ${
    $d g s G $.  $d s O $.  $d g s P $.  $d g s X $.
    odcau.x $e |- X = ( Base ` G ) $.
    odcau.o $e |- O = ( od ` G ) $.
    $( Cauchy's theorem for the order of an element in a group.  A finite group
       whose order divides a prime ` P ` contains an element of order ` P ` .
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    odcau $p |- ( ( ( G e. Grp /\ X e. Fin /\ P e. Prime ) /\ P || ( # ` X ) )
      -> E. g e. X ( O ` g ) = P ) $=
      ( vs wcel cfn chash cfv cdivides wbr wa c1 wceq syl wb adantr cgrp cprime
      w3a cv cexp co csubg wrex simpl1 simpl2 simpl3 cn0 1nn0 prmnn nncnd exp1d
      a1i cn simpr eqbrtrd sylow1 eqeq2d wex c0g csn cdif wne csdm clt cvv fvex
      hashsng ax-mp cuz simprr prmuz2 eqeltrd eluz2b2 simprbi syl5eqbr snfi wss
      c0 c2 subgss ad2antrl ssfi syl2anc hashsdom sylancr mpbid sdomdif eldifsn
      n0 sylib adantrr simprrl sseldd simprrr simprll odsubdvds syl3anc simprlr
      wn wo breqtrd odcl2 dvdsprime ord eqid odeq1 sylibd necon1ad mpd jca expr
      syl5bi eximdv df-rex sylibr sylbid rexlimdva ) CUAIZEJIZAUBIZUCZAEKLZMNZO
      ZHUDZKLZAPUEUFZQZHCUGLZUHBUDZDLZAQZBEUHZYIAHCPEFYCYDYEYHUIZYCYDYEYHUJZYCY
      DYEYHUKZPULIYIUMUQYIYLAYGMYIAYIAYIYEAURIUUAAUNRUOUPZYFYHUSUTVAYIYMYRHYNYI
      YJYNIZOYMYKAQZYRYIYMUUDSUUCYIYLAYKUUBVBTYIUUCUUDYRYIUUCUUDOZOZYOEIZYQOZBV
      CZYRUUFYOYJCVDLZVEZVFZIZBVCZUUIUUFUULWCVGZUUNUUFUUKYJVHNZUUOUUFUUKKLZYKVI
      NZUUPUUFUUQPYKVIUUJVJIUUQPQCVDVKUUJVJVLVMUUFYKWDVNLZIZPYKVINZUUFYKAUUSYIU
      UCUUDVOUUFYEAUUSIYIYEUUEUUATAVPRVQUUTYKURIUVAYKVRVSRVTUUFUUKJIYJJIZUURUUP
      SUUJWAUUFYDYJEWBZUVBYIYDUUEYTTUUCUVCYIUUDEYJCFWEWFZEYJWGWHZUUKYJWIWJWKUUK
      YJWLRBUULWNWOUUFUUMUUHBUUMYOYJIZYOUUJVGZOZUUFUUHYOYJUUJWMYIUUEUVHUUHYIUUE
      UVHOZOZUUGYQUVJYJEYOYIUUEUVCUVHUVDWPYIUUEUVFUVGWQZWRZUVJUVGYQYIUUEUVFUVGW
      SUVJYQYOUUJUVJYQXDYPPQZYOUUJQZUVJYQUVMUVJYPAMNZYQUVMXEZUVJYPYKAMUVJUUCUVB
      UVFYPYKMNYIUUCUUDUVHWTYIUUEUVBUVHUVEWPUVKYOYJCDGXAXBYIUUCUUDUVHXCXFUVJYEY
      PURIZUVOUVPSYIYEUVIUUATUVJYCYDUUGUVQYIYCUVIYSTZYIYDUVIYTTUVLYOCDEFGXGXBAY
      PXHWHWKXIUVJYCUUGUVMUVNSUVRUVLYOCDEUUJGUUJXJFXKWHXLXMXNXOXPXQXRXNYQBEXSXT
      XPYAYBXN $.
  $}

  ${
    $d g m n p x G $.  $d g m n p x P $.  $d g n p x X $.
    pgpfi.1 $e |- X = ( Base ` G ) $.
    $( The converse to ~ pgpfi1 .  A finite group is a ` P ` -group iff it has
       size some power of ` P ` .  (Contributed by Mario Carneiro,
       16-Jan-2015.) $)
    pgpfi $p |- ( ( G e. Grp /\ X e. Fin ) ->
      ( P pGrp G <-> ( P e. Prime /\ E. n e. NN0 ( # ` X ) = ( P ^ n ) ) ) ) $=
      ( vm wcel wa wbr cv cexp co wceq cn0 wrex cdivides cpc ad2antrr syl2anc
      cn vx vp vg cgrp cfn cpgp cprime chash cfv cod wral w3a eqid ispgp simprl
      c0 wne grpbn0 wb hashnncl ad2antlr mpbird pccld cle nn0red leidd cz nn0zd
      breqtrrd simpr oveq1d 3brtr4d cc0 wn simp-4l simplr odcau syl31anc adantr
      pcid prmz iddvds 3syl simprr simplrr fveq2 rexbidv rspccva sylan ad2ant2r
      eqeq1d ad3antrrr prmnn syl eqeltrd pcprmpw breqtrd wi prmdvdsexpr syl3anc
      mpbid mpd rexlimddv ex necon3ad pceq0 ad2antrl nn0ge0d eqbrtrd pm2.61dane
      imp nnexpcld ralrimiva hashcl pc2dvds oveq2 breq2d rspcev pcprmpw2 bitr4d
      nnzd jca 3adantr2 syl5bi pgpfi1 3expia rexlimdv expimpd impbid ) CUDGZDUE
      GZHZACUFIZAUGGZDUHUIZABJZKLZMZBNOZHZYMYNYJUAJZCUJUIZUIZAFJKLZMZFNOZUADUKZ
      ULZYLYTUAAFCUUBDEUUBUMZUNYLUUHYTYLYNUUGYTYJYLYNUUGHZHZYNYSYLYNUUGUOZUUKYO
      YQPIZBNOZYSUUKAYOQLZNGYOAUUOKLZPIZUUNUUKAYOUULUUKYOTGZDUPUQZYJUUSYKUUJDCE
      URRYKUURUUSUSYJUUJDUTVAVBZVCZUUKUUQUBJZYOQLZUVBUUPQLZVDIZUBUGUKZUUKUVEUBU
      GUUKUVBUGGZHZUVEUVBAUVHUVBAMZHZUUOAUUPQLZUVCUVDVDUUKUUOUVKVDIUVGUVIUUKUUO
      UUOUVKVDUUKUUOUUKUUOUVAVEVFUUKYNUUOVGGUVKUUOMUULUUKUUOUVAVHUUOAVTSVIRUVJU
      VBAYOQUVHUVIVJZVKUVJUVBAUUPQUVLVKVLUVHUVBAUQZHZUVCVMUVDVDUVNUVCVMMZUVBYOP
      IZVNZUVHUVMUVQUVHUVPUVBAUVHUVPUVIUVHUVPHZUCJZUUBUIZUVBMZUVIUCDUVRYJYKUVGU
      VPUWAUCDOYJYKUUJUVGUVPVOUUKYKUVGUVPYJYKUUJVPRUUKUVGUVPVPZUVHUVPVJUVBUCCUU
      BDEUUIVQVRUVRUVSDGZUWAHZHZUVBAAUVTQLZKLZPIZUVIUWEUVBUVTUWGPUWEUVBUVBUVTPU
      WEUVGUVBVGGUVBUVBPIUVRUVGUWDUWBVSZUVBWAUVBWBWCUVRUWCUWAWDZVIUWEUVTUUDMZFN
      OZUVTUWGMZUVHUWCUWLUVPUWAUVHUUGUWCUWLYLYNUUGUVGWEUUFUWLUAUVSDUUAUVSMZUUEU
      WKFNUWNUUCUVTUUDUUAUVSUUBWFWKWGWHWIWJUWEYNUVTTGUWLUWMUSUUKYNUVGUVPUWDUULW
      LZUWEUVTUVBTUWJUWEUVGUVBTGUWIUVBWMWNWOZUVTAFWPSXAWQUWEUVGYNUWFNGUWHUVIWRU
      WIUWOUWEAUVTUWOUWPVCUVBAUWFWSWTXBXCXDXEXKUVNUVGUURUVOUVQUSUUKUVGUVMVPZUUK
      UURUVGUVMUUTRUVBYOXFSVBUVNUVDUVNUVBUUPUWQUUKUUPTGUVGUVMUUKAUUOYNATGYLUUGA
      WMXGUVAXLZRVCXHXIXJXMUUKYOVGGUUPVGGUUQUVFUSUUKYOYKYONGYJUUJDXNVAVHUUKUUPU
      WRYAYOUUPUBXOSVBUUMUUQBUUONYPUUOMYQUUPYOPYPUUOAKXPXQXRSUUKYNUURUUNYSUSUUL
      UUTYNUURHUUNYOUUPMYSYOABXSYOABWPXTSXAYBYCXDYDYJYTYMWRYKYJYNYSYMYJYNHYRYMB
      NYJYNYPNGYRYMWRACYPDEYEYFYGYHVSYI $.

    $( Alternate version of ~ pgpfi .  (Contributed by Mario Carneiro,
       27-Apr-2016.) $)
    pgpfi2 $p |- ( ( G e. Grp /\ X e. Fin ) -> ( P pGrp G <->
      ( P e. Prime /\ ( # ` X ) = ( P ^ ( P pCnt ( # ` X ) ) ) ) ) ) $=
      ( vn cgrp wcel cfn wa cpgp wbr cprime chash cfv cv cexp co wceq cn0 wrex
      cpc pgpfi cn wb id c0 wne grpbn0 hashnncl syl5ibrcom imp pcprmpw pm5.32da
      syl2anr bitrd ) BFGZCHGZIZABJKALGZCMNZAEOPQRESTZIUSUTAAUTUAQPQRZIAEBCDUBU
      RUSVAVBUSUSUTUCGZVAVBUDURUSUEUPUQVCUPVCUQCUFUGCBDUHCUIUJUKUTAEULUNUMUO $.

    $( The order of a p-group.  (Contributed by Mario Carneiro,
       27-Apr-2016.) $)
    pgphash $p |- ( ( P pGrp G /\ X e. Fin ) ->
      ( # ` X ) = ( P ^ ( P pCnt ( # ` X ) ) ) ) $=
      ( cpgp wbr cfn wcel wa cprime chash cfv co cexp wceq simpl cgrp wb pgpgrp
      cpc pgpfi2 sylan mpbid simprd ) ABEFZCGHZIZAJHZCKLZAAUITMNMOZUGUEUHUJIZUE
      UFPUEBQHUFUEUKRABSABCDUAUBUCUD $.
  $}

  ${
    $d g h k p G $.  $d h k H $.  $d k K $.  $d g h k p P $.  $d k S $.
    $( The property of being a Sylow subgroup.  A Sylow ` P ` -subgroup is a
       ` P ` -group which has no proper supersets that are also ` P ` -groups.
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    isslw $p |- ( H e. ( P pSyl G ) <->
      ( P e. Prime /\ H e. ( SubGrp ` G ) /\ A. k e. ( SubGrp ` G )
        ( ( H C_ k /\ P pGrp ( G |`s k ) ) <-> H = k ) ) ) $=
      ( vp vg vh cslw co wcel cprime cgrp wa csubg cv cress cpgp wceq wb wral
      cfv wss wbr w3a df-slw elmpt2cl simp1 subgrcl 3ad2ant2 simpr fveq2d simpl
      crab oveq1d breq12d anbi2d bibi1d raleqbidv rabeqbidv fvex ovmpt2a eleq2d
      jca rabex sseq1 anbi1d eqeq1 bibi12d ralbidv elrab syl6bb biantrurd bitrd
      3anass syl6bbr pm5.21nii ) DACHIZJZAKJZCLJZMZVSDCNUAZJZDBOZUBZACWDPIZQUCZ
      MZDWDRZSZBWBTZUDZEFKLGOZWDUBZEOZFOZWDPIZQUCZMZWMWDRZSZBWPNUAZTZGXBUMZACHD
      FGBEUEZUFWLVSVTVSWCWKUGWCVSVTWKDCUHUIVCWAVRVSWCWKMZMZWLWAVRXFXGWAVRDWNWGM
      ZWTSZBWBTZGWBUMZJXFWAVQXKDEFACKLXDXKHWOARZWPCRZMZXCXJGXBWBXNWPCNXLXMUJZUK
      ZXNXAXIBXBWBXPXNWSXHWTXNWRWGWNXNWOAWQWFQXLXMULXNWPCWDPXOUNUOUPUQURUSXEXJG
      WBCNUTVDVAVBXJWKGDWBWMDRZXIWJBWBXQXHWHWTWIXQWNWEWGWMDWDVEVFWMDWDVGVHVIVJV
      KWAVSXFVSVTULVLVMVSWCWKVNVOVP $.

    $( Reverse closure for the first argument of a Sylow ` P ` -subgroup.
       (Contributed by Mario Carneiro, 16-Jan-2015.)  (Revised by Mario
       Carneiro, 2-May-2015.) $)
    slwprm $p |- ( H e. ( P pSyl G ) -> P e. Prime ) $=
      ( vk cslw co wcel cprime csubg cfv cv wss cress cpgp wbr wa wceq wb isslw
      wral simp1bi ) CABEFGAHGCBIJZGCDKZLABUCMFNOPCUCQRDUBTADBCSUA $.

    $( A Sylow ` P ` -subgroup is a subgroup.  (Contributed by Mario Carneiro,
       16-Jan-2015.) $)
    slwsubg $p |- ( H e. ( P pSyl G ) -> H e. ( SubGrp ` G ) ) $=
      ( vk cslw co wcel cprime csubg cfv cv wss cress cpgp wbr wa wceq wb isslw
      wral simp2bi ) CABEFGAHGCBIJZGCDKZLABUCMFNOPCUCQRDUBTADBCSUA $.

    slwispgp.1 $e |- S = ( G |`s K ) $.
    $( Defining property of a Sylow ` P ` -subgroup.  (Contributed by Mario
       Carneiro, 16-Jan-2015.) $)
    slwispgp $p |- ( ( H e. ( P pSyl G ) /\ K e. ( SubGrp ` G ) ) ->
      ( ( H C_ K /\ P pGrp S ) <-> H = K ) ) $=
      ( vk cslw co wcel cv wss cress cpgp wbr wa wceq wb csubg cfv cprime isslw
      simp3bi sseq2 oveq2 syl6eqr breq2d anbi12d eqeq2 bibi12d rspccva sylan
      wral ) DACHIJZDGKZLZACUOMIZNOZPZDUOQZRZGCSTZUMZEVBJDELZABNOZPZDEQZRZUNAUA
      JDVBJVCAGCDUBUCVAVHGEVBUOEQZUSVFUTVGVIUPVDURVEUOEDUDVIUQBANVIUQCEMIBUOECM
      UEFUFUGUHUOEDUIUJUKUL $.

    $( A proper superset of a Sylow subgroup is not a ` P ` -group.
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    slwpss $p |- ( ( H e. ( P pSyl G ) /\ K e. ( SubGrp ` G ) /\
      H C. K ) -> -. P pGrp S ) $=
      ( cslw co wcel csubg cfv wpss w3a cpgp wbr wn wne simp3 pssned wss pssssd
      wa wceq biantrurd wb slwispgp 3adant3 bitrd necon3bbid mpbird ) DACGHIZEC
      JKIZDELZMZABNOZPDEQUNDEUKULUMRZSUNUODEUNUODETZUOUBZDEUCZUNUQUOUNDEUPUAUDU
      KULURUSUEUMABCDEFUFUGUHUIUJ $.
  $}

  ${
    slwpgp.1 $e |- S = ( G |`s H ) $.
    $( A Sylow ` P ` -subgroup is a ` P ` -group.  (Contributed by Mario
       Carneiro, 16-Jan-2015.) $)
    slwpgp $p |- ( H e. ( P pSyl G ) -> P pGrp S ) $=
      ( cslw co wcel wss cpgp wbr wa wceq eqid csubg cfv slwsubg slwispgp mpdan
      wb mpbiri simprd ) DACFGHZDDIZABJKZUCUDUELZDDMZDNUCDCOPHUFUGTACDQABCDDERS
      UAUB $.
  $}

  ${
    $d k m w x y G $.  $d k m w x y H $.  $d k m w x y P $.  $d k m w x z X $.
    $d k m w z F $.  $d k m x y S $.
    pgpssslw.1 $e |- X = ( Base ` G ) $.
    pgpssslw.2 $e |- S = ( G |`s H ) $.
    pgpssslw.3 $e |- F = ( x e. { y e. ( SubGrp ` G ) |
      ( P pGrp ( G |`s y ) /\ H C_ y ) } |-> ( # ` x ) ) $.
    $( Every ` P ` -subgroup is contained in a Sylow ` P ` -subgroup.
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    pgpssslw $p |- ( ( H e. ( SubGrp ` G ) /\ X e. Fin /\ P pGrp S ) ->
      E. k e. ( P pSyl G ) H C_ k ) $=
      ( vm cfv wcel wbr wa cle chash syl vw vz csubg cfn cpgp w3a cress wss crn
      cv co cr clt csup wceq wrex cslw crab cz c0 wne wral wf cn0 elrabi subgss
      simp2 ssfi syl2an hashcl nn0zd fmptd frn fvex fnmpti simp1 simp3 biantrud
      eqimss2 oveq2 syl6eqr breq2d bitr3d sylanbrc fnfvelrn sylancr ne0i nn0red
      wfn elrab fveq2 fvmpt adantl weq anbi12d cdom adantr ad2antrl ssdomg sylc
      sseq2 syl2anc hashdom mpbird sylan2b eqbrtrd ralrimiva breq1 ralrn sylibr
      wb ax-mp breq2 ralbidv rspcev suprzcl syl3anc fvelrnb sylib rexrab cprime
      simpl3 pgpprm simprl wpss wn zssre syl6ss ad2antrr simprrr simprrl simprd
      sstrd jca eqeltrrd suprub syl31anc nn0re ex mpd eqtr3d breqtrd lenlt csdm
      simpll2 mpbid wi php3 hashsdom sylibrd mtod wo sspss ord simpld biantrurd
      expr eqimss bitrd syl5ibcom impbid isslw syl3anbrc reximdv2 ) HGUCNZOZIUD
      OZCDUEPZUFZCGEUJZUGUKZUEPZHUVJUHZQZUVJFNZFUIZULUMUNZUOZQZEUVEUPZUVMECGUQU
      KZUPUVIUVRECGBUJZUGUKZUEPZHUWBUHZQZBUVEURZUPZUVTUVIUVQUVPOZUWHUVIUVPUSUHZ
      UVPUTVAZUAUJZUBUJZRPZUAUVPVBZUBULUPZUWIUVIUWGUSFVCUWJUVIAUWGAUJZSNZUSFUVI
      UWQUWGOZQZUWRUWTUWQUDOZUWRVDOUVIUVGUWQIUHZUXAUWSUVFUVGUVHVGZUWSUWQUVEOUXB
      UWFBUWQUVEVEIUWQGJVFTIUWQVHVIUWQVJTVKLVLUWGUSFVMTZUVIHFNZUVPOZUWKUVIFUWGW
      IZHUWGOZUXFAUWGUWRFUWQSVNLVOZUVIUVFUVHUXHUVFUVGUVHVPUVFUVGUVHVQUWFUVHBHUV
      EUWBHUOZUWDUWFUVHUXJUWEUWDHUWBVSVRUXJUWCDCUEUXJUWCGHUGUKDUWBHGUGVTKWAWBWC
      WJWDUWGHFWEWFUVPUXEWGTZUVIISNZULOUWLUXLRPZUAUVPVBZUWPUVIUXLUVIUVGUXLVDOUX
      CIVJTWHUVIMUJZFNZUXLRPZMUWGVBZUXNUVIUXQMUWGUVIUXOUWGOZQUXPUXOSNZUXLRUXSUX
      PUXTUOZUVIAUXOUWRUXTUWGFUWQUXOSWKLUXOSVNWLZWMUXSUVIUXOUVEOZCGUXOUGUKZUEPZ
      HUXOUHZQZQZUXTUXLRPZUWFUYGBUXOUVEBMWNZUWDUYEUWEUYFUYJUWCUYDCUEUWBUXOGUGVT
      WBUWBUXOHXAWOWJZUVIUYHQZUYIUXOIWPPZUYLUVGUXOIUHZUYMUVIUVGUYHUXCWQZUYCUYNU
      VIUYGIUXOGJVFZWRZUXOIUDWSWTUYLUXOUDOZUVGUYIUYMXKUYLUVGUYNUYRUYOUYQIUXOVHZ
      XBUYOUXOIUDXCXBXDXEXFXGUXGUXNUXRXKUXIUXMUXQUAMUWGFUWLUXPUXLRXHXIXLXJUWOUX
      NUBUXLULUWMUXLUOUWNUXMUAUVPUWMUXLUWLRXMXNXOXBZUBUAUVPXPXQUXGUWIUWHXKUXIEU
      WGUVQFXRXLXSUWFUVNUVREBUVEBEWNZUWDUVLUWEUVMVUAUWCUVKCUEUWBUVJGUGVTWBUWBUV
      JHXAWOZXTXSUVIUVSUVMEUVEUWAUVIUVJUVEOZUVSQZUVJUWAOZUVMQUVIVUDQZVUEUVMVUFC
      YAOZVUCUVJUXOUHZUYEQZEMWNZXKZMUVEVBVUEVUFUVHVUGUVFUVGUVHVUDYBCDYCTUVIVUCU
      VSYDZVUFVUKMUVEVUFUYCQZVUIVUJVUFUYCVUIVUJVUFUYCVUIQZQZUVJUXOYEZYFVUJVUOVU
      PUVJSNZUXTUMPZVUOUXTVUQRPZVURYFZVUOUXTUVQVUQRVUOUVPULUHZUWKUWPUXTUVPOUXTU
      VQRPUVIVVAVUDVUNUVIUVPUSULUXDYGYHYIUVIUWKVUDVUNUXKYIUVIUWPVUDVUNUYTYIVUOU
      XPUXTUVPVUOUXSUYAVUOUYCUYGUXSVUFUYCVUIYDVUOUYEUYFVUFUYCVUHUYEYJVUOHUVJUXO
      VUOUVLUVMVUFUVNVUNUVIVUCUVNUVRYKZWQZYLVUFUYCVUHUYEYKZYMYNUYKWDZUYBTVUOUXG
      UXSUXPUVPOUXIVVEUWGUXOFWEWFYOUBUAUVPUXTYPYQVUOUVOUVQVUQVUFUVRVUNUVIVUCUVN
      UVRYJWQVUOUVJUWGOZUVOVUQUOVUOVUCUVNVVFVUFVUCVUNVULWQVVCUWFUVNBUVJUVEVUBWJ
      WDAUVJUWRVUQUWGFUWQUVJSWKLUVJSVNWLTUUAUUBVUOUYRUVJUDOZVUSVUTXKZVUOUVGUYNU
      YRUVFUVGUVHVUDVUNUUEUYCUYNVUFVUIUYPWRUYSXBZVUOUYRVUHVVGVVIVVDUXOUVJVHXBZU
      YRUXTVDOZVUQVDOZVVHVVGUXOVJUVJVJVVKUXTULOVUQULOVVHVVLUXTYRVUQYRUXTVUQUUCV
      IVIXBUUFVUOVUPUVJUXOUUDPZVURVUOUYRVUPVVMUUGVVIUYRVUPVVMUXOUVJUUHYSTVUOVVG
      UYRVURVVMXKVVJVVIUVJUXOUUIXBUUJUUKVUOVUPVUJVUOVUHVUPVUJUULVVDUVJUXOUUMXSU
      UNYTUUQVUMUVLVUJVUIVUFUVLUYCVUFUVLUVMVVBUUOWQVUJUVLUYEVUIVUJUVKUYDCUEUVJU
      XOGUGVTWBVUJVUHUYEUVJUXOUURUUPUUSUUTUVAXGCMGUVJUVBUVCVUFUVLUVMVVBYLYNYSUV
      DYT $.
  $}

  ${
    $d x y z G $.  $d x y z P $.  $d x z X $.
    slwn0.1 $e |- X = ( Base ` G ) $.
    $( Every finite group contains a Sylow ` P ` -subgroup.  (Contributed by
       Mario Carneiro, 16-Jan-2015.) $)
    slwn0 $p |- ( ( G e. Grp /\ X e. Fin /\ P e. Prime ) ->
      ( P pSyl G ) =/= (/) ) $=
      ( vz vx vy cgrp wcel cfn cprime w3a cfv cv wss co cress cpgp wbr eqid c0g
      csn cslw wrex c0 wne csubg 0subg 3ad2ant1 simp2 pgp0 3adant2 wa crab cmpt
      chash pgpssslw syl3anc rexn0 syl ) BHIZCJIZAKIZLZBUAMZUBZENOZEABUCPZUDZVH
      UEUFVDVFBUGMZIZVBABVFQPZRSZVIVAVBVKVCBVEVETZUHUIVAVBVCUJVAVCVMVBABVEVNUKU
      LFGAVLEFABGNZQPRSVFVOOUMGVJUNFNUPMUOZBVFCDVLTVPTUQURVGEVHUSUT $.
  $}

  ${
    $d x G $.  $d x H $.  $d x K $.  $d x P $.  $d x S $.
    subgslw.1 $e |- H = ( G |`s S ) $.
    $( A Sylow subgroup that is contained in a larger subgroup is also Sylow
       with respect to the subgroup.  (The converse may not be true, though.)
       (Contributed by Mario Carneiro, 19-Jan-2015.) $)
    subgslw $p |- ( ( S e. ( SubGrp ` G ) /\ K e. ( P pSyl G ) /\ K C_ S ) ->
      K e. ( P pSyl H ) ) $=
      ( vx csubg cfv wcel cslw co wss cress cpgp wbr wa wceq wb 3ad2ant2 cprime
      w3a cv wral slwprm slwsubg simp3 subsubg 3ad2ant1 mpbir2and oveq1i simpl1
      simplbda ressabs syl5eq breq2d anbi2d simpl2 simprbda eqid slwispgp bitrd
      syl2anc ralrimiva isslw syl3anbrc ) BCHIZJZEACKLJZEBMZUBZAUAJZEDHIZJZEGUC
      ZMZADVONLZOPZQZEVORZSZGVMUDEADKLJVIVHVLVJACEUETVKVNEVGJZVJVIVHWBVJACEUFTV
      HVIVJUGVHVIVNWBVJQSVJEBCDFUHUIUJVKWAGVMVKVOVMJZQZVSVPACVONLZOPZQZVTWDVRWF
      VPWDVQWEAOWDVQCBNLZVONLZWEDWHVONFUKWDVHVOBMZWIWERVHVIVJWCULVKWCVOVGJZWJVH
      VIWCWKWJQSVJVOBCDFUHUIZUMBVOCVGUNVCUOUPUQWDVIWKWGVTSVHVIVJWCURVKWCWKWJWLU
      SAWECEVOWEUTVAVCVBVDAGDEVEVF $.
  $}

  ${
    $d h k n w z .~ $.  $d g h k u w x y A $.  $d g n v x y G $.  $d n w z P $.
    $d v w $.  $d g h k u v x y .(+) $.  $d g h k n u v x y X $.  $d k w z Z $.
    $d h k w z ph $.  $d g h k u w x y z Y $.
    sylow2a.x $e |- X = ( Base ` G ) $.
    sylow2a.m $e |- ( ph -> .(+) e. ( G GrpAct Y ) ) $.
    sylow2a.p $e |- ( ph -> P pGrp G ) $.
    sylow2a.f $e |- ( ph -> X e. Fin ) $.
    sylow2a.y $e |- ( ph -> Y e. Fin ) $.
    sylow2a.z $e |- Z = { u e. Y | A. h e. X ( h .(+) u ) = u } $.
    sylow2a.r $e |- .~ =
      { <. x , y >. | ( { x , y } C_ Y /\ E. g e. X ( g .(+) x ) = y ) } $.
    $( Lemma for ~ sylow2a .  An equivalence class of fixed points is a
       singleton.  (Contributed by Mario Carneiro, 17-Jan-2015.) $)
    sylow2alem1 $p |- ( ( ph /\ A e. Z ) -> [ A ] .~ = { A } ) $=
      ( vw vk wcel wa cec csn cv wceq wbr cvv wb simpr elecg sylancr wrex gaorb
      co simp3bi wral oveq2 id eqeq12d ralbidv elrab2 sylib simprd oveq1 eqeq1d
      vex rspccva sylan eqeq1 syl5ibcom rexlimdva syl5 sylbid syl6ibr ssrdv wer
      elsn cga gaorber syl adantr simpld erref sylancom mpbird snssd eqssd ) AE
      NUDZUEZEHUFZEUGZWMUBWNWOWMUBUHZWNUDZWPEUIZWPWOUDWMWQEWPHUJZWRWMWPUKUDWLWQ
      WSULUBVJAWLUMZWPEHUKNUNUOWSUCUHZEGURZWPUIZUCLUPZWMWRWSEMUDZWPMUDXDBCEWPGH
      IUCLMUAUQUSWMXCWRUCLWMXALUDZUEXBEUIZXCWRWMJUHZEGURZEUIZJLUTZXFXGWMXEXKWMW
      LXEXKUEWTXHDUHZGURZXLUIZJLUTXKDEMNXLEUIZXNXJJLXOXMXIXLEXLEXHGVAXOVBVCVDTV
      EVFZVGXJXGJXALXHXAUIXIXBEXHXAEGVHVIVKVLXBWPEVMVNVOVPVQUBEWAVRVSWMEWNWMEWN
      UDZEEHUJZWMEHMAMHVTZWLAGKMWBURUDXSPBCGHIKLMUAOWCWDWEWMXEXKXPWFWGAWLWLXQXR
      ULWTEEHNNUNWHWIWJWK $.

    $( Lemma for ~ sylow2a .  All the orbits which are not for fixed points
       have size ` | G | / | G x | ` (where ` G x ` is the stabilizer subgroup)
       and thus are powers of ` P ` .  And since they are all nontrivial
       (because any orbit which is a singleton is a fixed point), they all
       divide ` P ` , and so does the sum of all of them.  (Contributed by
       Mario Carneiro, 17-Jan-2015.) $)
    sylow2alem2 $p |- ( ph ->
      P || sum_ z e. ( ( Y /. .~ ) \ ~P Z ) ( # ` z ) ) $=
      ( vn vw vv vk cqs cpw cdif cv chash cfv cfn wcel wss sylib cga co gaorber
      pwfi wer syl qsss ssfi syl2anc diffi cprime cz cexp wceq cn0 wrex cpgp wa
      wbr cgrp gagrp pgpfi mpbid simpld prmz eldifi adantr sselda elpwid sylan2
      wb hashcl nn0zd wn cdivides eldif cec wi eqid sseq1 vex elpw notbid fveq2
      syl6bbr breq2d imbi12d wral cpc cc0 cn c0 wne simpr elec sylibr ne0i ecss
      erref hashnncl mpbird pceq0 oveq2 cuni csn c1o crab cmul sylancl dvdsmul1
      cen ssrab2 orbsta2 syl21anc breqtrrd simprd breq2 biimpcd reximdv eqeq12d
      cqg sylc weq eleqtrd elsnc pcprmpw2 eqcomd zcnd exp0d hash1 syl6eqr df1o2
      c1 snfi eqeltri hashen bitrd en1b syl6bb cxp wf ad2antrr gaf simprl oveq1
      fovrnd eqeq1d rspcev gaorb syl3anbrc ovex simprr eqtr4d ralrimdva sylbird
      expr sylbid syl5 id ralbidv elrab2 baib sylibrd sylow2alem1 snssd eqsstrd
      adantl ex syld con1d ectocld impr sylan2b fsumdvds ) AMHUFZNUGZUHZDUIZUJU
      KZDFAUWJULUMZUWLULUMAMUGZULUMZUWJUWPUNUWOAMULUMZUWQSMUSUOAMHAGKMUPUQUMZMH
      UTZPBCGHIKLMUAOURVAZVBZUWPUWJVCVDUWJUWKVEVAAFVFUMZFVGUMZAUXCLUJUKZFUBUIVH
      UQZVIZUBVJVKZAFKVLVNZUXCUXHVMZQAKVOUMZLULUMZUXIUXJWFAUWSUXKPGKMVPVARFUBKL
      OVQVDVRZVSZFVTVAZAUWMUWLUMZVMZUWNUXQUWMULUMZUWNVJUMUXPAUWMUWJUMZUXRUWMUWJ
      UWKWAAUXSVMZUWRUWMMUNUXRAUWRUXSSWBUXTUWMMAUWJUWPUWMUXBWCWDMUWMVCVDWEUWMWG
      VAWHUXPAUXSUWMUWKUMZWIZVMFUWNWJVNZUWMUWJUWKWKAUXSUYBUYCUCUIZHWLZNUNZWIZFU
      YEUJUKZWJVNZWMUYBUYCWMAUCUWMMHUWJUWJWNUYEUWMVIZUYGUYBUYIUYCUYJUYFUYAUYJUY
      FUWMNUNUYAUYEUWMNWOUWMNDWPWQWTWRUYJUYHUWNFWJUYEUWMUJWSXAXBAUYDMUMZVMZUYIU
      YFUYLUYIWIZUYDNUMZUYFUYLUYMJUIZUYDGUQZUYDVIZJLXCZUYNUYLUYMFUYHXDUQZXEVIZU
      YRUYLUXCUYHXFUMZUYTUYMWFAUXCUYKUXNWBZUYLVUAUYEXGXHZUYLUYDUYEUMZVUCUYLUYDU
      YDHVNVUDUYLUYDHMAUWTUYKUXAWBAUYKXIZXNUYDUYDHUCWPZVUFXJXKZUYEUYDXLVAUYLUYE
      ULUMZVUAVUCWFAVUHUYKAUWRUYEMUNVUHSAUYDHMUXAXMMUYEVCVDZWBZUYEXOVAXPZFUYHXQ
      VDUYTFUYSVHUQZFXEVHUQZVIZUYLUYRUYSXEFVHXRUYLVUNUYEUYEXSZXTZVIZUYRUYLVUNUY
      EYAYFVNZVUQUYLVUNUYHYAUJUKZVIZVURUYLVULUYHVUMVUSUYLUYHVULUYLUYHUXFWJVNZUB
      VJVKZUYHVULVIZUYLUYHUXEWJVNZUXHVVBUYLUYHUYHUDUIUYDGUQUYDVIZUDLYBZUJUKZYCU
      QZUXEWJAUYHVVHWJVNZUYKAUYHVGUMVVGVGUMVVIAUYHAVUHUYHVJUMVUIUYEWGVAWHAVVGAV
      VFULUMZVVGVJUMAUXLVVFLUNVVJRVVEUDLYGLVVFVCYDVVFWGVAWHUYHVVGYEVDWBUYLUWSUY
      KUXLUXEVVHVIAUWSUYKPWBVUEAUXLUYKRWBBCUDUYDGKVVFYPUQZIKVVFHLMOVVFWNVVKWNUA
      YHYIYJAUXHUYKAUXCUXHUXMYKWBVVDUXGVVAUBVJUXGVVDVVAUXEUXFUYHWJYLYMYNYQUYLUX
      CVUAVVBVVCWFVUBVUKUYHFUBUUAVDVRUUBUYLVUMUUHVUSUYLFUYLFAUXDUYKUXOWBUUCUUDU
      UEUUFYOUYLVUHYAULUMVUTVURWFVUJYAXGXTULUUGXGUUIUUJUYEYAUUKYDUULUYEUUMUUNUY
      LVUQUYQJLUYLUYOLUMZVUQUYQUYLVVLVUQVMZVMZUYPVUOUYDVVNUYPVUPUMUYPVUOVIVVNUY
      PUYEVUPVVNUYDUYPHVNZUYPUYEUMVVNUYKUYPMUMUEUIZUYDGUQZUYPVIZUELVKZVVOUYLUYK
      VVMVUEWBZVVNUYOUYDMLMGVVNUWSLMUUOMGUUPAUWSUYKVVMPUUQGKLMOUURVAUYLVVLVUQUU
      SZVVTUVAVVNVVLUYPUYPVIZVVSVWAUYPWNVVRVWBUEUYOLUEJYRVVQUYPUYPVVPUYOUYDGUUT
      UVBUVCYDBCUYDUYPGHIUELMUAUVDUVEUYPUYDHUYOUYDGUVFZVUFXJXKUYLVVLVUQUVGZYSUY
      PVUOVWCYTUOVVNUYDVUPUMUYDVUOVIVVNUYDUYEVUPUYLVUDVVMVUGWBVWDYSUYDVUOVUFYTU
      OUVHUVKUVIUVLUVMUVJUYKUYNUYRWFAUYNUYKUYRUYOEUIZGUQZVWEVIZJLXCUYREUYDMNEUC
      YRZVWGUYQJLVWHVWFUYPVWEUYDVWEUYDUYOGXRVWHUVNYOUVOTUVPUVQUWBUVRAUYNUYFWMUY
      KAUYNUYFAUYNVMZUYEUYDXTNABCEUYDFGHIJKLMNOPQRSTUAUVSVWIUYDNAUYNXIUVTUWAUWC
      WBUWDUWEUWFUWGUWHUWI $.

    $( A named lemma of Sylow's second and third theorems.  If ` G ` is a
       finite ` P ` -group that acts on the finite set ` Y ` , then the set
       ` Z ` of all points of ` Y ` fixed by every element of ` G ` has
       cardinality equivalent to the cardinality of ` Y ` , ` mod P ` .
       (Contributed by Mario Carneiro, 17-Jan-2015.) $)
    sylow2a $p |- ( ph -> P || ( ( # ` Y ) - ( # ` Z ) ) ) $=
      ( vz vw cqs cpw cdif cv chash cfv cmin co cdivides sylow2alem2 wceq caddc
      csu cin c0 inass disjdif ineq2i in0 3eqtri a1i cun inundif eqcomi cfn wss
      wcel pwfi sylib cga wer gaorber qsss ssfi syl2anc wa adantr sselda elpwid
      syl cn0 hashcl nn0cnd fsumsplit qshash c1 cmul cc inss1 sylancl fsumconst
      ax-1cn cuni csn c1o cen wbr elin cec wi eqid sseq1 vex elpw syl6bbr breq1
      imbi12d simpr erref elec sylibr ssel syl5com sylow2alem1 syl6eqbr ex syld
      ensn1 ectocld impr sylan2b fveq2d cvv uniex hashsng ax-mp syl6eq sumeq2dv
      en1b wral ssexg sylancr eqeltrd sseldi wb mpbird oveq1d 3eqtr4rd crab cdm
      eqsstri mulid1d elex inss2 pwexg crn cxp wrel cpr wrex relopabi relssdmrn
      ssrab2 erdm errn xpexg ecelqsg eqeltrrd snelpwi adantl sylanbrc snss sneq
      eqsstr3d eqeq2d syl5ibrcom adantrl unieq unisn syl6req en3d hashen eqtr3d
      impbid1 diffi eldifi sylan2 fsumcl subaddd breqtrrd ) AELGUCZMUDZUEZUAUFZ
      UGUHZUAUOZLUGUHZMUGUHZUIUJZUKABCUADEFGHIJKLMNOPQRSTULAUWKUWHUMUWJUWHUNUJZ
      UWIUMAUWCUWGUAUOUWCUWDUPZUWGUAUOZUWHUNUJUWIUWLAUWMUWEUWGUWCUAUWMUWEUPZUQU
      MAUWOUWCUWDUWEUPZUPUWCUQUPUQUWCUWDUWEURUWPUQUWCUWDUWCUSUTUWCVAVBVCUWCUWMU
      WEVDZUMAUWQUWCUWCUWDVEVFVCALUDZVGVIZUWCUWRVHUWCVGVIZALVGVIZUWSRLVJVKALGAF
      JLVLUJVILGVMZOBCFGHJKLTNVNWBZVOZUWRUWCVPVQZAUWFUWCVIZVRZUWGUXGUWFVGVIZUWG
      WCVIUXGUXAUWFLVHUXHAUXAUXFRVSUXGUWFLAUWCUWRUWFUXDVTWALUWFVPVQUWFWDWBWEZWF
      AUALGUXCRWGAUWJUWNUWHUNAUWMWHUAUOZUWMUGUHZWHWIUJZUWNUWJAUWMVGVIZWHWJVIUXJ
      UXLUMAUWTUWMUWCVHUXMUXEUWCUWDWKUWCUWMVPWLZWNUWMWHUAWMWLAUWMUWGWHUAAUWFUWM
      VIZVRZUWGUWFWOZWPZUGUHZWHUXPUWFUXRUGUXPUWFWQWRWSZUWFUXRUMZUXOAUXFUWFUWDVI
      ZVRUXTUWFUWCUWDWTAUXFUYBUXTUBUFZGXAZMVHZUYDWQWRWSZXBUYBUXTXBAUBUWFLGUWCUW
      CXCUYDUWFUMZUYEUYBUYFUXTUYGUYEUWFMVHUYBUYDUWFMXDUWFMUAXEZXFXGUYDUWFWQWRXH
      XIAUYCLVIZVRZUYEUYCMVIZUYFUYJUYCUYDVIZUYEUYKUYJUYCUYCGWSUYLUYJUYCGLAUXBUY
      IUXCVSAUYIXJXKUYCUYCGUBXEZUYMXLXMUYDMUYCXNXOAUYKUYFXBUYIAUYKUYFAUYKVRZUYD
      UYCWPZWQWRABCDUYCEFGHIJKLMNOPQRSTXPZUYCUYMXTXQXRVSXSYAYBYCUWFYKVKZYDUXQYE
      VIUXSWHUMUWFUYHYFZUXQYEYGYHYIYJAUWJWHWIUJUWJUXLAUWJAUWJAMVGVIZUWJWCVIAUXA
      MLVHUYSRMIUFDUFZFUJUYTUMIKYLZDLUUALSVUADLUUOUUCZLMVPWLZMWDWBWEZUUDAUWJUXK
      WHWIAUWJUXKUMZMUWMWRWSZAUBUAMUWMUYOUXQAUYSMYEVIVUCMVGUUEWBAUWMUWDVHUWDYEV
      IZUWMYEVIUWCUWDUUFZAUYSVUGVUCMVGUUGWBUWMUWDYEYMYNAUYKUYOUWMVIZUYNUYOUWCVI
      UYOUWDVIZVUIUYNUYDUYOUWCUYPUYNGYEVIZUYIUYDUWCVIAVUKUYKAGGUUBZGUUHZUUIZVHZ
      VUNYEVIZVUKGUUJVUOBUFZCUFZUUKLVHHUFVUQFUJVURUMHKUULVRBCGTUUMGUUNYHAVULVGV
      IVUMVGVIVUPAVULLVGAUXBVULLUMUXCLGUUPWBRYOAVUMLVGAUXBVUMLUMUXCLGUUQWBRYOVU
      LVUMVGVGUURVQGVUNYEYMYNVSUYNMLUYCVUBAUYKXJYPLUYCGYEUUSVQUUTUYKVUJAUYCMUVA
      UVBUYOUWCUWDWTUVCXRAUXOUXQMVIZUXPUXRMVHVUSUXPUXRUWFMUYQUXPUWFMUXPUWMUWDUW
      FVUHAUXOXJYPWAUVFUXQMUYRUVDXMXRAUYKUXOVRZUYCUXQUMZUWFUYOUMZYQAVUTVRVVAVVB
      AUXOVVAVVBXBUYKUXPVVBVVAUYAUYQVVAUYOUXRUWFUYCUXQUVEUVGUVHUVIVVBUXQUYOWOUY
      CUWFUYOUVJUYCUYMUVKUVLUVPXRUVMAUYSUXMVUEVUFYQVUCUXNMUWMUVNVQYRYSUVOYTYSYT
      AUWIUWJUWHAUWIAUXAUWIWCVIRLWDWBWEVUDAUWEUWGUAAUWTUWEVGVIUXEUWCUWDUVQWBUWF
      UWEVIAUXFUWGWJVIUWFUWCUWDUVRUXIUVSUVTUWAYRUWB $.
  $}

  ${
    $d a b g s u v x y z G $.  $d g u v x y z K $.  $d a b g s u v x y z .x. $.
    $d g s u v x y z .+ $.  $d a b g s u v x y z .~ $.  $d a b g s u v z ph $.
    $d u x z .- $.  $d x y z B $.  $d x y z C $.  $d a b g s u v x y z H $.
    $d a b g s u v x y z X $.
    sylow2b.x $e |- X = ( Base ` G ) $.
    sylow2b.xf $e |- ( ph -> X e. Fin ) $.
    sylow2b.h $e |- ( ph -> H e. ( SubGrp ` G ) ) $.
    sylow2b.k $e |- ( ph -> K e. ( SubGrp ` G ) ) $.
    sylow2b.a $e |- .+ = ( +g ` G ) $.
    ${
      sylow2b.r $e |- .~ = ( G ~QG K ) $.
      sylow2b.m $e |- .x. = ( x e. H , y e. ( X /. .~ ) |->
        ran ( z e. y |-> ( x .+ z ) ) ) $.
      $( Lemma for ~ sylow2b .  Evaluate the group action on a left coset.
         (Contributed by Mario Carneiro, 17-Jan-2015.) $)
      sylow2blem1 $p |- ( ( ph /\ B e. H /\ C e. X ) ->
        ( B .x. [ C ] .~ ) = [ ( B .+ C ) ] .~ ) $=
        ( wcel w3a cec co cv cmpt crn cqs wceq simp2 cvv cqg ovex eqeltri simp3
        ecelqsg sylancr wa simpr simpl oveq1d mpteq12dv rneqd ecexg ax-mp mptex
        rnex ovmpt2a syl2anc cfn wss cen wbr csubg cfv eqger ecss ssfi 3ad2ant1
        wer syl wf wb vex elecg biimpa cminusg cgrp subgrcl subgss sseldd grpcl
        syl3anc adantr eqid eqgval simp2d grpinvcl syl13anc grpinvadd grpsubval
        grpass csg eqtr4d grpnpcan eqtrd eqtr3d simp3d eqeltrd mpbir3and sylibr
        elec syldan fmptd frn wf1o wf1 cres grplmulf1o f1of1 f1ssres f1eq1 3syl
        resmpt mpbid f1f1orn f1oen ensym eqgen entr fisseneq ) AEKUAZFMUAZUBZEF
        HUCZIUDZDYOEDUEZGUDZUFZUGZEFGUDZHUCZYNYLYOMHUHZUAZYPYTUIAYLYMUJZYNHUKUA
        ZYMUUDHJLULUDUKSJLULUMUNZAYLYMUOZMFHUKUPUQZBCEYOKUUCDCUEZBUEZYQGUDZUFZU
        GYTIUUKEUIZUUJYOUIZURZUUMYSUUPDUUJUULYOYRUUNUUOUSUUPUUKEYQGUUNUUOUTVAVB
        VCTYSDYOYRUUFYOUKUAUUGFUKHVDVEZVFVGVHVIYNUUBVJUAZYTUUBVKZYTUUBVLVMZYTUU
        BUIAYLUURYMAMVJUAUUBMVKUUROAUUAHMALJVNVOZUAZMHVTQHJMLNSVPWAZVQMUUBVRVIV
        SYNYOUUBYSWBUUSYNDYOYRUUBYSYNYQYOUAZFYQHVMZYRUUBUAZYNUVDUVEYNYQUKUAYMUV
        DUVEWCDWDUUHYQFHUKMWEUQWFYNUVEURZUUAYRHVMZUVFUVGUVHUUAMUAZYRMUAZUUAJWGV
        OZVOZYRGUDZLUAZYNUVIUVEYNJWHUAZEMUAZYMUVIAYLUVOYMAKUVAUAZUVOPKJWIWAZVSZ
        YNKMEAYLKMVKZYMAUVQUVTPMKJNWJWAVSUUEWKZUUHMGJEFNRWLWMZWNUVGUVOUVPYQMUAZ
        UVJYNUVOUVEUVSWNZYNUVPUVEUWAWNZUVGYMUWCFUVKVOZYQGUDZLUAZYNUVEYMUWCUWHUB
        ZAYLUVEUWIWCZYMAUVOLMVKZUWJUVRAUVBUWKQMLJNWJWAZFYQGHLJUVKWHMNUVKWOZRSWP
        VIVSWFZWQZMGJEYQNRWLWMUVGUVMUWGLUVGUVLEGUDZYQGUDZUVMUWGUVGUVOUVLMUAZUVP
        UWCUWQUVMUIUWDYNUWRUVEYNUVOUVIUWRUVSUWBMJUVKUUANUWMWRVIWNUWEUWOMGJUVLEY
        QNRXBWSYNUWQUWGUIUVEYNUWPUWFYQGYNUWPUWFEJXCVOZUDZEGUDZUWFYNUVLUWTEGYNUV
        LUWFEUVKVOGUDZUWTYNUVOUVPYMUVLUXBUIUVSUWAUUHMGJUVKEFNRUWMWTWMYNUWFMUAZU
        VPUWTUXBUIYNUVOYMUXCUVSUUHMJUVKFNUWMWRVIZUWAMGJUVKUWSUWFENRUWMUWSWOZXAV
        IXDVAYNUVOUXCUVPUXAUWFUIUVSUXDUWAMGJUWSUWFENRUXEXEWMXFVAWNXGUVGYMUWCUWH
        UWNXHXIYNUVHUVIUVJUVNUBWCZUVEAYLUXFYMAUVOUWKUXFUVRUWLUUAYRGHLJUVKWHMNUW
        MRSWPVIVSWNXJYRUUAHEYQGUMEFGUMXLXKXMYSWOXNYOUUBYSXOWAYNYTYOVLVMZYOUUBVL
        VMZUUTYNYOYTYSXPZYOYTVLVMUXGYNYOMYSXQZUXIYNYOMDMYRUFZYOXRZXQZUXJYNMMUXK
        XQZYOMVKZUXMYNMMUXKXPZUXNYNUVOUVPUXPUVSUWADMGUXKJENRUXKWOXSVIMMUXKXTWAA
        YLUXOYMAFHMUVCVQVSZMMYOUXKYAVIYNUXOUXLYSUIUXMUXJWCUXQDMYOYRYDYOMUXLYSYB
        YCYEYOMYSYFWAYOYTYSUUQYGYOYTYHYCYNYOLVLVMZLUUBVLVMZUXHYNLYOVLVMZUXRYNUV
        BUUDUXTAYLUVBYMQVSZUUIYOHJMLNSYIVILYOYHWAYNUVBUUBUUCUAZUXSUYAYNUUFUVIUY
        BUUGUWBMUUAHUKUPUQUUBHJMLNSYIVIYOLUUBYJVIYTYOUUBYJVIYTUUBYKWMXF $.

      $( Lemma for ~ sylow2b .  Left multiplication in a subgroup ` H ` is a
         group action on the set of all left cosets of ` K ` .  (Contributed by
         Mario Carneiro, 17-Jan-2015.) $)
      sylow2blem2 $p |- ( ph -> .x. e. ( ( G |`s H ) GrpAct ( X /. .~ ) ) ) $=
        ( co wcel vu va vb vv vs cress cgrp cqs cvv wa cbs cfv cxp wf cv cplusg
        c0g wceq wral cga csubg eqid subggrp syl cpw cfn pwfi sylib eqger ssexd
        wer qsss jca wfn cmpt crn vex mptex rnex fnmpt2i a1i eleq1d sylow2blem1
        cec oveq2 w3a cqg ovex eqeltri subgrcl 3ad2ant1 wss subgss sselda simp3
        3adant3 grpcl syl3anc ecelqsg sylancr eqeltrd ectocld ralrimiva subgbas
        3expa ffnov sylanbrc xpeq1d feq2d mpbid eqeq12d oveq2d 2ralbidv anbi12d
        id simpl adantr subg0cl simpr subg0 oveq1d grplid 3eqtr3d simprl sseldd
        sylan simprr grpass syl13anc eqtr4d subgcl 3eqtr4d ralrimivva ressplusg
        eceq1 proplem3 eqeq1d raleqbidv isga ) AHIUFSZUGTZKFUHZUITZUJYTUKULZUUB
        UMZUUBGUNZYTUQULZUAUOZGSZUUHURZUBUOZUCUOZYTUPULZSZUUHGSZUUKUULUUHGSZGSZ
        URZUCUUDUSUBUUDUSZUJZUAUUBUSZUJGYTUUBUTSTAUUAUUCAIHVAULZTZUUANIHYTYTVBZ
        VCVDAUUBKVEZVFAKVFTUVEVFTMKVGVHAKFAJUVBTKFVKOFHKJLQVIVDVLVJVMAUUFUVAAIU
        UBUMZUUBGUNZUUFAGUVFVNZUUHUDUOZGSZUUBTZUDUUBUSZUAIUSUVGUVHABCIUUBDCUOZB
        UODUOESZVOZVPGRUVODUVMUVNCVQVRVSVTWAAUVLUAIAUUHITZUJZUVKUDUUBUUHUEUOZFW
        DZGSZUUBTZUVKUVQUEUVIKFUUBUUBVBZUVSUVIURUVTUVJUUBUVSUVIUUHGWEWBAUVPUVRK
        TZUWAAUVPUWCWFZUVTUUHUVRESZFWDZUUBABCDUUHUVREFGHIJKLMNOPQRWCUWDFUITUWEK
        TZUWFUUBTFHJWGSUIQHJWGWHWIUWDHUGTZUUHKTZUWCUWGAUVPUWHUWCAUVCUWHNIHWJZVD
        ZWKAUVPUWIUWCAIKUUHAUVCIKWLZNKIHLWMZVDWNWPAUVPUWCWOKEHUUHUVRLPWQWRKUWEF
        UIWSWTXAXEXBXCXCUAUDIUUBUUBGXFXGAUVFUUEUUBGAIUUDUUBAUVCIUUDURZNIHYTUVDX
        DZVDXHXIXJAUUTUAUUBUUGUVSGSZUVSURZUUNUVSGSZUUKUULUVSGSZGSZURZUCUUDUSZUB
        UUDUSZUJUUTAUEUUHKFUUBUWBUVSUUHURZUWQUUJUXCUUSUXDUWPUUIUVSUUHUVSUUHUUGG
        WEUXDXOXKUXDUXAUURUBUCUUDUUDUXDUWRUUOUWTUUQUVSUUHUUNGWEUXDUWSUUPUUKGUVS
        UUHUULGWEXLXKXMXNAUWCUJZUWQUXCUXEHUQULZUVSGSZUXFUVRESZFWDZUWPUVSUXEAUXF
        ITZUWCUXGUXIURAUWCXPZUXEUVCUXJAUVCUWCNXQZIHUXFUXFVBZXRVDAUWCXSZABCDUXFU
        VREFGHIJKLMNOPQRWCWRUXEUXFUUGUVSGUXEUVCUXFUUGURUXLIHYTUXFUVDUXMXTVDYAUX
        EUXHUVRURZUXIUVSURAUWHUWCUXOUWKKEHUVRUXFLPUXMYBYFUXHUVRFYOVDYCUXEUUKUUL
        ESZUVSGSZUWTURZUCIUSZUBIUSUXCUXEUXRUBUCIIUXEUUKITZUULITZUJZUJZUXPUVRESZ
        FWDZUUKUULUVRESZFWDZGSZUXQUWTUYCUYEUUKUYFESZFWDZUYHUYCUYDUYIURZUYEUYJUR
        UYCUWHUUKKTUULKTZUWCUYKUYCUVCUWHUXEUVCUYBUXLXQZUWJVDZUYCIKUUKUYCUVCUWLU
        YMUWMVDZUXEUXTUYAYDZYEUYCIKUULUYOUXEUXTUYAYGZYEZUXEUWCUYBUXNXQZKEHUUKUU
        LUVRLPYHYIUYDUYIFYOVDUYCAUXTUYFKTZUYHUYJURUXEAUYBUXKXQZUYPUYCUWHUYLUWCU
        YTUYNUYRUYSKEHUULUVRLPWQWRABCDUUKUYFEFGHIJKLMNOPQRWCWRYJUYCAUXPITZUWCUX
        QUYEURVUAUYCUVCUXTUYAVUBUYMUYPUYQEIHUUKUULPYKWRUYSABCDUXPUVREFGHIJKLMNO
        PQRWCWRUYCUWSUYGUUKGUYCAUYAUWCUWSUYGURVUAUYQUYSABCDUULUVREFGHIJKLMNOPQR
        WCWRXLYLYMUXEUXSUXBUBIUUDUXEUVCUWNUXLUWOVDZUXEUXRUXAUCIUUDVUCUXEUXQUWRU
        WTUXEUXPUUNUVSGAUWCUBUCEUUMAUVCEUUMURNIEHYTUVBUVDPYNVDYPYAYQYRYRXJVMXBX
        CVMUAUBUCUUMGYTUUDUUBUUGUUDVBUUMVBUUGVBYSXG $.

      sylow2blem3.hp $e |- ( ph -> P pGrp ( G |`s H ) ) $.
      sylow2blem3.kn $e |- ( ph -> ( # ` K ) = ( P ^ ( P pCnt ( # ` X ) ) ) )
          $.
      sylow2blem3.d $e |- .- = ( -g ` G ) $.
      $( Sylow's second theorem.  Putting together the results of ~ sylow2a and
         the orbit-stabilizer theorem to show that ` P ` does not divide the
         set of all fixed points under the group action, we get that there is a
         fixed point of the group action, so that there is some ` g e. X ` with
         ` h g K = g K ` for all ` h e. H ` .  This implies that
         ` invg ( g ) h g e. K ` , so ` h ` is in the conjugated subgroup
         ` g K invg ( g ) ` .  (Contributed by Mario Carneiro, 18-Jan-2015.) $)
      sylow2blem3 $p |- ( ph ->
        E. g e. X H C_ ran ( x e. K |-> ( ( g .+ x ) .- g ) ) ) $=
        ( vu cv co wceq wral cqs wrex cmpt crn wss cress cbs cfv crab wne chash
        c0 cdivides wbr wn cpc cexp cdiv cprime wcel cpgp pgpprm syl cgrp csubg
        cn subgrcl grpbn0 cfn wb hashnncl mpbird pcndvds2 syl2anc cmul lagsubg2
        oveq1d oveq2d cn0 cpw pwfi sylib wer eqger qsss ssfi hashcl nn0cnd eqid
        c0g subg0cl ne0i subgss nncnd nnne0d divcan4d 3eqtr3d breq2d mtbid cmin
        cz prmz nn0zd ssrab2 sylancl copab sylow2blem2 subgbas eqeltrrd sylow2a
        cpr wa dvdssub2 syl31anc cc0 hasheq0 dvds0 breq2 syl5ibrcom sylbird mpd
        necon3bd rabn0 raleqdv rexbidv cec wi syl3anc ad2antrr ovex expr simprr
        vex cminusg w3a simplrr simpll simprl simplrl sylow2blem1 eqtr3d eqgval
        elqs erth mpbid simp3d oveq2 fvmpt grprinv grpinvcl sseldd grpcl grpass
        syl13anc grplid grppncan 3eqtrd wfn fnfvelrn sylancr ralimdva imp an32s
        fnmpti dfss3 sylibr reximdva ex com23 syl5bi rexlimdv ) AUEUFZDUFZHUGZU
        WBUHZUEKUIZDNGUJZUKZKBLIUFZBUFZFUGZUWHMUGZULZUMZUNZINUKZAUWGUWDUEJKUOUG
        ZUPUQZUIZDUWFUKZAUWRDUWFURZVAUSZUWSAEUWTUTUQZVBVCZVDUXAAEUWFUTUQZVBVCZU
        XCAENUTUQZEEUXFVEUGVFUGZVGUGZVBVCZUXEAEVHVIZUXFVOVIZUXIVDAEUWPVJVCUXJUB
        EUWPVKVLZAUXKNVAUSZAJVMVIZUXMAKJVNUQZVIZUXNQKJVPVLZNJOVQVLANVRVIZUXKUXM
        VSPNVTVLWAEUXFWBWCAUXHUXDEVBAUXFLUTUQZVGUGUXDUXSWDUGZUXSVGUGUXHUXDAUXFU
        XTUXSVGAGJNLOTRPWEWFAUXSUXGUXFVGUCWGAUXDUXSAUXDAUWFVRVIZUXDWHVIANWIZVRV
        IZUWFUYBUNUYAAUXRUYCPNWJWKANGALUXOVIZNGWLZRGJNLOTWMVLZWNUYBUWFWOWCZUWFW
        PVLZWQAUXSAUXSVOVIZLVAUSZAJWSUQZLVIZUYJAUYDUYLRLJUYKUYKWRZWTVLLUYKXAVLA
        LVRVIZUYIUYJVSAUXRLNUNZUYNPAUYDUYORNLJOXBVLZNLWOWCLVTVLWAZXCAUXSUYQXDXE
        XFXGXHAEXJVIZUXDXJVIUXBXJVIEUXDUXBXIUGVBVCUXEUXCVSAUXJUYRUXLEXKVLZAUXDU
        YHXLAUXBAUWTVRVIZUXBWHVIAUYAUWTUWFUNUYTUYGUWRDUWFXMUWFUWTWOXNZUWTWPVLXL
        ABCDEHUWICUFZXTUWFUNUWHUWIHUGVUBUHIUWQUKYABCXOZIUEUWPUWQUWFUWTUWQWRABCD
        FGHJKLNOPQRSTUAXPUBAKUWQVRAUXPKUWQUHQKJUWPUWPWRXQVLZAUXRKNUNZKVRVIPAUXP
        VUEQNKJOXBVLZNKWOWCXRUYGUWTWRVUCWRXSEUXDUXBYBYCXHAUXCUWTVAAUWTVAUHZUXBY
        DUHZUXCAUYTVUHVUGVSVUAUWTVRYEVLAUXCVUHEYDVBVCZAUYRVUIUYSEYFVLUXBYDEVBYG
        YHYIYKYJUWRDUWFYLWKAUWEUWRDUWFAUWDUEKUWQVUDYMYNWAAUWEUWODUWFUWBUWFVIUWB
        UWHGYOZUHZINUKZAUWEUWOYPINUWBGDUUBUULAUWEVULUWOAUWEVULUWOYPAUWEYAZVUKUW
        NINVUMUWHNVIZVUKUWNVUMVUNVUKYAZYAUWAUWMVIZUEKUIZUWNAVUOUWEVUQAVUOYAZUWE
        VUQVURUWDVUPUEKVURUWAKVIZUWDVUPVURVUSUWDYAZYAZUWHJUUCUQZUQZUWAUWHFUGZFU
        GZUWLUQZUWAUWMVVAVVFUWHVVEFUGZUWHMUGZVVDUWHMUGZUWAVVAVVELVIZVVFVVHUHVVA
        VUNVVDNVIZVVJVVAUWHVVDGVCZVUNVVKVVJUUDZVVAVVLVUJVVDGYOZUHVVAUWBVUJVVNAV
        UNVUKVUTUUEZVVAUWCUWAVUJHUGZUWBVVNVVAUWBVUJUWAHVVOWGVURVUSUWDUUAVVAAVUS
        VUNVVPVVNUHAVUOVUTUUFVURVUSUWDUUGZAVUNVUKVUTUUHZABCDUWAUWHFGHJKLNOPQRST
        UAUUIYQXFUUJVVAUWHVVDGNAUYEVUOVUTUYFYRVVRUUMWAVVAUXNUYOVVLVVMVSAUXNVUOV
        UTUXQYRZAUYOVUOVUTUYPYRUWHVVDFGLJVVBVMNOVVBWRZSTUUKWCUUNUUOZBVVEUWKVVHL
        UWLUWIVVEUHUWJVVGUWHMUWIVVEUWHFUUPWFUWLWRZVVGUWHMYSUUQVLVVAVVGVVDUWHMVV
        AUWHVVCFUGZVVDFUGZUYKVVDFUGZVVGVVDVVAVWCUYKVVDFVVAUXNVUNVWCUYKUHVVSVVRN
        FJVVBUWHUYKOSUYMVVTUURWCWFVVAUXNVUNVVCNVIZVVKVWDVVGUHVVSVVRVVAUXNVUNVWF
        VVSVVRNJVVBUWHOVVTUUSWCVVAUXNUWANVIZVUNVVKVVSVVAKNUWAAVUEVUOVUTVUFYRVVQ
        UUTZVVRNFJUWAUWHOSUVAYQZNFJUWHVVCVVDOSUVBUVCVVAUXNVVKVWEVVDUHVVSVWINFJV
        VDUYKOSUYMUVDWCXFWFVVAUXNVWGVUNVVIUWAUHVVSVWHVVRNFJMUWAUWHOSUDUVEYQUVFV
        VAUWLLUVGVVJVVFUWMVIBLUWKUWLUWJUWHMYSVWBUVMVWALVVEUWLUVHUVIXRYTUVJUVKUV
        LUEKUWMUVNUVOYTUVPUVQUVRUVSUVTYJ $.
    $}

    sylow2b.hp $e |- ( ph -> P pGrp ( G |`s H ) ) $.
    sylow2b.kn $e |- ( ph -> ( # ` K ) = ( P ^ ( P pCnt ( # ` X ) ) ) ) $.
    sylow2b.d $e |- .- = ( -g ` G ) $.
    $( Sylow's second theorem.  Any ` P ` -group ` H ` is a subgroup of a
       conjugated ` P ` -group ` K ` of order ` P ^ n || ( # `` X ) ` with
       ` n ` maximal.  This is usually stated under the assumption that ` K `
       is a Sylow subgroup, but we use a slightly different definition, whose
       equivalence to this one requires this theorem.  (Contributed by Mario
       Carneiro, 18-Jan-2015.) $)
    sylow2b $p |- ( ph ->
      E. g e. X H C_ ran ( x e. K |-> ( ( g .+ x ) .- g ) ) ) $=
      ( vz cv vy vu vv vs cqg co cqs cmpt crn cmpt2 eqid oveq2 cbvmptv mpteq2dv
      weq oveq1 syl5eq rneqd mpteq1 cbvmpt2v sylow2blem3 ) ABUASCDFHUEUFZUBUCGJ
      VBUGZUDUCTZUBTZUDTZDUFZUHZUIZUJEFGHIJKLMNOVBUKUBUCBUAGVCVISUATZBTZSTZDUFZ
      UHZUISVDVMUHZUIUBBUOZVHVOVPVHSVDVEVLDUFZUHVOUDSVDVGVQVFVLVEDULUMVPSVDVQVM
      VEVKVLDUPUNUQURUCUAUOVOVNSVDVJVMUSURUTPQRVA $.
  $}

  ${
    $d g k n x G $.  $d g k n x H $.  $d g k n p P $.  $d g k n p x X $.
    $d g k ph $.
    fislw.1 $e |- X = ( Base ` G ) $.
    ${
      slwhash.3 $e |- ( ph -> X e. Fin ) $.
      slwhash.4 $e |- ( ph -> H e. ( P pSyl G ) ) $.
      $( A sylow subgroup has cardinality equal to the maximum power of ` P `
         dividing the group.  (Contributed by Mario Carneiro, 18-Jan-2015.) $)
      slwhash $p |- ( ph -> ( # ` H ) = ( P ^ ( P pCnt ( # ` X ) ) ) ) $=
        ( vx vn chash cfv co wceq wcel syl cfn syl2anc wa eqid vk vg cexp csubg
        cv cpc cgrp cslw slwsubg subgrcl cprime slwprm cn c0 grpbn0 wb hashnncl
        wne mpbird cdivides wbr pcdvds sylow1 cplusg csg cmpt crn adantr simprl
        pccld wss cress slwpgp simprr sylow2b cbs cn0 ad2antrr conjsubg subgbas
        cpgp wrex fveq2d cen conjsubgen subgss ssfi hashen simplrr eqtr3d oveq2
        eqeq2d rspcev subggrp eqeltrrd pgpfi mpbir2and slwispgp eqtrd rexlimddv
        mpbi2and ) AUAUEZKLZBBEKLZUFMZUCMZNZDKLZXFNZUACUDLZABUACXEEFADXJOZCUGOZ
        ADBCUHMOZXKHBCDUIPZDCUJPZGAXMBUKOZHBCDULZPZABXDXRAXDUMOZEUNURZAXLXTXOEC
        FUOPAEQOZXSXTUPGEUQPUSZVJZAXPXSXFXDUTVAXRYBBXDVBRVCAXBXJOZXGSZSZDIXBUBU
        EZIUECVDLZMYGCVELZMVFZVGZVKZXIUBEYFIBYHUBCDXBYIEFAYAYEGVHAXKYEXNVHAYDXG
        VIZYHTZABCDVLMZWAVAZYEAXMYPHBYOCDYOTVMPVHAYDXGVNYITZVOYFYGEOZYLSZSZXHYK
        KLZXFYTDYKKYTYLBCYKVLMZWAVAZDYKNZYFYRYLVNYTUUCXPUUBVPLZKLZBJUEZUCMZNZJV
        QWBZYTXMXPAXMYEYSHVRZXQPYTXEVQOZUUFXFNZUUJAUULYEYSYCVRYTUUAUUFXFYTYKUUE
        KYTYKXJOZYKUUENYTYDYRUUNYFYDYSYMVHZYFYRYLVIZIYGYHXBYJCYIEFYNYQYJTZVSRZY
        KCUUBUUBTZVTPZWCYTXCUUAXFYTXCUUANZXBYKWDVAZYTYDYRUVBUUOUUPIYGYHXBYJCYIE
        FYNYQUUQWERYTXBQOZYKQOZUVAUVBUPYTYAXBEVKZUVCAYAYEYSGVRZYTYDUVEUUOEXBCFW
        FPEXBWGRYTYAYKEVKZUVDUVFYTUUNUVGUUREYKCFWFPEYKWGRZXBYKWHRUSAYDXGYSWIWJZ
        WJUUIUUMJXEVQUUGXENUUHXFUUFUUGXEBUCWKWLWMRYTUUBUGOZUUEQOUUCXPUUJSUPYTUU
        NUVJUURYKCUUBUUSWNPYTYKUUEQUUTUVHWOBJUUBUUEUUETWPRWQYTXMUUNYLUUCSUUDUPU
        UKUURBUUBCDYKUUSWRRXAWCUVIWSWTWT $.
    $}

    $( The sylow subgroups of a finite group are exactly the groups which have
       cardinality equal to the maximum power of ` P ` dividing the group.
       (Contributed by Mario Carneiro, 16-Jan-2015.) $)
    fislw $p |- ( ( G e. Grp /\ X e. Fin /\ P e. Prime ) ->
      ( H e. ( P pSyl G ) <-> ( H e. ( SubGrp ` G ) /\
        ( # ` H ) = ( P ^ ( P pCnt ( # ` X ) ) ) ) ) ) $=
      ( vn wcel cfn co cfv chash cpc wceq wa syl wbr wb adantr syl2anc cn0 cgrp
      vk vp cprime w3a cslw csubg simpr slwsubg simpl2 slwhash jca cv wss cress
      cexp cpgp wral simpl3 simprl cen subgss ssfi simprrl cdom ssdomg sylc cle
      cn cbs wrex simprrr eqid subggrp subgbas eqeltrrd pgpfi mpbid prmnn nnred
      simpld nnge1d cz cuz c0 wne c0g subg0cl ne0i hashnncl mpbird pccld simpl1
      nn0zd grpbn0 cdivides lagsubg pc2dvds oveq1 breq12d rspcv eluz2 syl3anbrc
      nnzd leexp2ad simprd fveq2d rexbidv pcprmpw simplrr 3brtr4d ad2antrl sbth
      eqeq1d hashdom fisseneq syl3anc expr simprr eqtr3d oveq2 eqeq2d mpbir2and
      rspcev breq2d eqimss biantrurd bitrd syl5ibcom impbid ralrimiva impbida
      isslw ) BUAGZDHGZAUDGZUEZCABUFIGZCBUGJZGZCKJZAADKJZLIZUPIZMZNZYQYRNZYTUUE
      UUGYRYTYQYRUHZABCUIOUUGABCDEYNYOYPYRUJUUHUKULYQUUFNZYPYTCUBUMZUNZABUUJUOI
      ZUQPZNZCUUJMZQZUBYSURYRYNYOYPUUFUSZYQYTUUEUTUUIUUPUBYSUUIUUJYSGZNZUUNUUOU
      UIUURUUNUUOUUIUURUUNNZNZUUJHGZUUKCUUJVAPZUUOUVAYOUUJDUNZUVBUUIYOUUTYNYOYP
      UUFUJZRZUVAUURUVDUUIUURUUNUTZDUUJBEVBODUUJVCSZUUIUURUUKUUMVDZUVACUUJVEPZU
      UJCVEPZUVCUVAUVBUUKUVJUVHUVICUUJHVFVGUVAUUJKJZUUAVHPZUVKUVAAAUVLLIZUPIZUU
      DUVLUUAVHUVAAUVNUUCUVAAUVAYPAVIGUVAYPUULVJJZKJZAFUMZUPIZMZFTVKZUVAUUMYPUW
      ANZUUIUURUUKUUMVLUVAUULUAGZUVPHGUUMUWBQUVAUURUWCUVGUUJBUULUULVMZVNOUVAUUJ
      UVPHUVAUURUUJUVPMUVGUUJBUULUWDVOOZUVHVPAFUULUVPUVPVMVQSVRZWAZAVSOZVTUVAAU
      WHWBUVAUVNWCGUUCWCGUVNUUCVHPZUUCUVNWDJGUVAUVNUVAAUVLUWGUVAUVLVIGZUUJWEWFZ
      UVABWGJZUUJGZUWKUVAUURUWMUVGUUJBUWLUWLVMWHOUUJUWLWIOUVAUVBUWJUWKQUVHUUJWJ
      OWKZWLWNUVAUUCUUIUUCTGZUUTUUIAUUBUUQUUIUUBVIGZDWEWFZUUIYNUWQYNYOYPUUFWMDB
      EWOOUUIYOUWPUWQQUVEDWJOWKZWLZRWNUVAYPUCUMZUVLLIZUWTUUBLIZVHPZUCUDURZUWIUW
      GUVAUVLUUBWPPZUXDUVAUURYOUXEUVGUVFBDUUJEWQSUVAUVLWCGUUBWCGUXEUXDQUVAUVLUW
      NXDUVAUUBUUIUWPUUTUWRRXDUVLUUBUCWRSVRUXCUWIUCAUDUWTAMUXAUVNUXBUUCVHUWTAUV
      LLWSUWTAUUBLWSWTXAVGUVNUUCXBXCXEUVAUVLUVSMZFTVKZUVLUVOMZUVAUXGUWAUVAYPUWA
      UWFXFUVAUXFUVTFTUVAUVLUVQUVSUVAUUJUVPKUWEXGXNXHWKUVAYPUWJUXGUXHQUWGUWNUVL
      AFXISVRYQYTUUEUUTXJXKUVAUVBCHGZUVMUVKQUVHUUIUXIUUTUUIYOCDUNZUXIUVEYTUXJYQ
      UUEDCBEVBXLDCVCSZRUUJCHXOSVRCUUJXMSCUUJXPXQXRUUSABCUOIZUQPZUUOUUNUUIUXMUU
      RUUIUXMYPUXLVJJZKJZUVSMZFTVKZUUQUUIUWOUXOUUDMZUXQUWSUUIUUAUXOUUDUUICUXNKY
      TCUXNMYQUUECBUXLUXLVMZVOXLZXGYQYTUUEXSXTUXPUXRFUUCTUVRUUCMUVSUUDUXOUVRUUC
      AUPYAYBYDSUUIUXLUAGZUXNHGUXMYPUXQNQYTUYAYQUUECBUXLUXSVNXLUUICUXNHUXTUXKVP
      AFUXLUXNUXNVMVQSYCRUUOUXMUUMUUNUUOUXLUULAUQCUUJBUOYAYEUUOUUKUUMCUUJYFYGYH
      YIYJYKAUBBCYMXCYL $.
  $}

  ${
    $d x .- $.  $d g x .+ $.  $d g x G $.  $d g x H $.  $d g x K $.  $d g ph $.
    $d g x X $.
    sylow2.x $e |- X = ( Base ` G ) $.
    sylow2.f $e |- ( ph -> X e. Fin ) $.
    sylow2.h $e |- ( ph -> H e. ( P pSyl G ) ) $.
    sylow2.k $e |- ( ph -> K e. ( P pSyl G ) ) $.
    sylow2.a $e |- .+ = ( +g ` G ) $.
    sylow2.d $e |- .- = ( -g ` G ) $.
    $( Sylow's second theorem.  See also ~ sylow2b for the "hard" part of the
       proof.  Any two Sylow ` P ` -subgroups are conjugate to one another, and
       hence the same size, namely ` P ^ ( P pCnt | X | ) ` (see ~ fislw ).
       (Contributed by Mario Carneiro, 18-Jan-2015.) $)
    sylow2 $p |- ( ph ->
      E. g e. X H = ran ( x e. K |-> ( ( g .+ x ) .- g ) ) ) $=
      ( co wcel syl syl2anc cmpt crn wss wrex wceq cslw csubg cfv slwsubg cress
      cv cpgp wbr eqid slwpgp slwhash sylow2b wa cfn cen adantr simprl conjsubg
      subgss ssfi simprr chash cpc cexp eqtr4d hashen mpbid conjsubgen fisseneq
      wb entr syl3anc expr reximdva mpd ) AGBHEUKZBUKDQWAIQUAZUBZUCZEJUDGWCUEZE
      JUDABCDEFGHIJKLAGCFUFQZRZGFUGUHZRZMCFGUISZAHWFRHWHRZNCFHUISZOAWGCFGUJQZUL
      UMMCWMFGWMUNUOSACFHJKLNUPZPUQAWDWEEJAWAJRZWDWEAWOWDURZURZWCUSRZWDGWCUTUMZ
      WEWQJUSRZWCJUCZWRAWTWPLVAWQWCWHRZXAWQWKWOXBAWKWPWLVAZAWOWDVBZBWADHWBFIJKO
      PWBUNZVCTJWCFKVDSJWCVETAWOWDVFWQGHUTUMZHWCUTUMZWSAXFWPAGVGUHZHVGUHZUEZXFA
      XHCCJVGUHVHQVIQXIACFGJKLMUPWNVJAGUSRZHUSRZXJXFVOAWTGJUCZXKLAWIXMWJJGFKVDS
      JGVETAWTHJUCZXLLAWKXNWLJHFKVDSJHVETGHVKTVLVAWQWKWOXGXCXDBWADHWBFIJKOPXEVM
      TGHWCVPTGWCVNVQVRVSVT $.
  $}

  ${
    $d a b c u v w x y z .- $.  $d a b c g h s u w x y z .(+) $.  $d g x y H $.
    $d g h s u v w x y z K $.  $d g k u w z N $.  $d a b c g h k u w x y z X $.
    $d a b c g h k s u w x y z G $.  $d a b c g h k s u w x y z ph $.
    $d a b c g u v w x y z .+ $.  $d a b c g h k s u w x y z P $.
    sylow3.x $e |- X = ( Base ` G ) $.
    sylow3.g $e |- ( ph -> G e. Grp ) $.
    sylow3.xf $e |- ( ph -> X e. Fin ) $.
    sylow3.p $e |- ( ph -> P e. Prime ) $.
    ${
      sylow3lem1.a $e |- .+ = ( +g ` G ) $.
      sylow3lem1.d $e |- .- = ( -g ` G ) $.
      sylow3lem1.m $e |- .(+) = ( x e. X , y e. ( P pSyl G ) |->
        ran ( z e. y |-> ( ( x .+ z ) .- x ) ) ) $.
      $( Lemma for ~ sylow3 , first part.  (Contributed by Mario Carneiro,
         19-Jan-2015.) $)
      sylow3lem1 $p |- ( ph -> .(+) e. ( G GrpAct ( P pSyl G ) ) ) $=
        ( wcel co wceq va vb vc vw vu vv cgrp cslw cvv wa cxp wf c0g cfv cv cga
        wral ovex jctir cmpt crn csubg chash cpc cexp cfn cprime syl3anc biimpa
        wb fislw adantrl simpld simprl eqid conjsubg syl2anc cen wbr conjsubgen
        wss adantr subgss ssfi hashen mpbird simprd eqtr3d mpbir2and ralrimivva
        syl fmpt2 sylib grpidcl simpr simpl oveq1d oveq12d mpteq12dv rneqd rnex
        weq vex mptex ovmpt2a cid cres ad2antrr slwsubg adantl sselda grpsubid1
        grplid eqtrd mpteq2dva mptresid syl6eq rnresi wrex oveq2 abrexco simprr
        cab simplr rnmpt rexeqdv grpcl adantlr grpsubsub4 syl13anc grpaddsubass
        abbidv grpass eqeq2d rexbidva 3eqtr4a 3eqtr4g fovrnd cbvmptv jca isga
        3eqtr4rd ralrimiva sylanbrc ) AHUGRZEHUHSZUIRZUJJUUFUKUUFGULZHUMUNZUAUO
        ZGSZUUJTZUBUOZUCUOZFSZUUJGSZUUMUUNUUJGSZGSZTZUCJUQUBJUQZUJZUAUUFUQZUJGH
        UUFUPSRAUUEUUGLEHUHURUSAUUHUVBADCUOZBUOZDUOZFSZUVDISZUTZVAZUUFRZCUUFUQB
        JUQUUHAUVJBCJUUFAUVDJRZUVCUUFRZUJZUJZUVJUVIHVBUNZRZUVIVCUNZEEJVCUNVDSVE
        SZTZUVNUVCUVORZUVKUVPUVNUVTUVCVCUNZUVRTZAUVLUVTUWBUJZUVKAUVLUWCAUUEJVFR
        ZEVGRZUVLUWCVJLMNEHUVCJKVKVHVIVLZVMZAUVKUVLVNZDUVDFUVCUVHHIJKOPUVHVOZVP
        VQZUVNUWAUVQUVRUVNUWAUVQTZUVCUVIVRVSZUVNUVTUVKUWLUWGUWHDUVDFUVCUVHHIJKO
        PUWIVTVQUVNUVCVFRZUVIVFRZUWKUWLVJUVNUWDUVCJWAZUWMAUWDUVMMWBZUVNUVTUWOUW
        GJUVCHKWCWKJUVCWDVQUVNUWDUVIJWAZUWNUWPUVNUVPUWQUWJJUVIHKWCWKJUVIWDVQUVC
        UVIWEVQWFUVNUVTUWBUWFWGWHAUVJUVPUVSUJVJZUVMAUUEUWDUWEUWRLMNEHUVIJKVKVHW
        BWIWJBCJUUFUVIUUFGQWLWMZAUVAUAUUFAUUJUUFRZUJZUULUUTUXAUUKDUUJUUIUVEFSZU
        UIISZUTZVAZUUJUXAUUIJRZUWTUUKUXETUXAUUEUXFAUUEUWTLWBZJHUUIKUUIVOZWNWKAU
        WTWOBCUUIUUJJUUFUVIUXEGUVDUUITZCUAXBZUJZUVHUXDUXKDUVCUVGUUJUXCUXIUXJWOU
        XKUVFUXBUVDUUIIUXKUVDUUIUVEFUXIUXJWPZWQUXLWRWSWTQUXDDUUJUXCUAXCZXDXAXEV
        QUXAUXEXFUUJXGZVAUUJUXAUXDUXNUXAUXDDUUJUVEUTUXNUXADUUJUXCUVEUXAUVEUUJRZ
        UJZUXCUVEUUIISZUVEUXPUXBUVEUUIIUXPUUEUVEJRZUXBUVETAUUEUWTUXOLXHZUXAUUJJ
        UVEUXAUUJUVORZUUJJWAUWTUXTAEHUUJXIXJJUUJHKWCWKXKZJFHUVEUUIKOUXHXMVQWQUX
        PUUEUXRUXQUVETUXSUYAJHIUVEUUIKUXHPXLVQXNXODUUJXPXQWTUUJXRXQXNUXAUUSUBUC
        JJUXAUUMJRZUUNJRZUJZUJZUDUUQUUMUDUOZFSZUUMISZUTZVAZDUUJUUOUVEFSZUUOISZU
        TZVAZUURUUPUYEUEUOZUYHTZUDUUQXSZUEYCZUYOUYLTZDUUJXSZUEYCZUYJUYNUYEUYPUD
        UFUOUUNUVEFSZUUNISZTDUUJXSUFYCZXSZUEYCUYOUUMVUCFSZUUMISZTZDUUJXSZUEYCUY
        RVUAUEUDUFDUUJVUCUYHVUGVUBUUNIURUYFVUCTUYGVUFUUMIUYFVUCUUMFXTWQYAUYEUYQ
        VUEUEUYEUYPUDUUQVUDUYEUUQDUUJVUCUTZVAZVUDUYEUYCUWTUUQVUKTUXAUYBUYCYBZAU
        WTUYDYDZBCUUNUUJJUUFUVIVUKGBUCXBZUXJUJZUVHVUJVUODUVCUVGUUJVUCVUNUXJWOVU
        OUVFVUBUVDUUNIVUOUVDUUNUVEFVUNUXJWPZWQVUPWRWSWTQVUJDUUJVUCUXMXDXAXEVQDU
        FUUJVUCVUJVUJVOYEXQYFYLUYEUYTVUIUEUYEUYSVUHDUUJUYEUXOUJZUYLVUGUYOVUQUYK
        UUNISZUUMISZUYLVUGVUQUUEUYKJRZUYCUYBVUSUYLTUYEUUEUXOUXAUUEUYDUXGWBZWBZV
        UQUUEUUOJRZUXRVUTVVBUYEVVCUXOUYEUUEUYBUYCVVCVVAUXAUYBUYCVNZVULJFHUUMUUN
        KOYGVHZWBUXAUXOUXRUYDUYAYHZJFHUUOUVEKOYGVHUYEUYCUXOVULWBZUYEUYBUXOVVDWB
        ZJFHIUYKUUNUUMKOPYIYJVUQVURVUFUUMIVUQVURUUMVUBFSZUUNISZVUFVUQUYKVVIUUNI
        VUQUUEUYBUYCUXRUYKVVITVVBVVHVVGVVFJFHUUMUUNUVEKOYMYJWQVUQUUEUYBVUBJRZUY
        CVVJVUFTVVBVVHVUQUUEUYCUXRVVKVVBVVGVVFJFHUUNUVEKOYGVHVVGJFHIUUMVUBUUNKO
        PYKYJXNWQWHYNYOYLYPUDUEUUQUYHUYIUYIVOYEDUEUUJUYLUYMUYMVOYEYQUYEUYBUUQUU
        FRUURUYJTVVDUYEUUNUUJUUFJUUFGAUUHUWTUYDUWSXHVULVUMYRBCUUMUUQJUUFUVIUYJG
        BUBXBZUVCUUQTZUJZUVHUYIVVNUVHDUUQUUMUVEFSZUUMISZUTUYIVVNDUVCUVGUUQVVPVV
        LVVMWOVVNUVFVVOUVDUUMIVVNUVDUUMUVEFVVLVVMWPZWQVVQWRWSDUDUUQVVPUYHDUDXBV
        VOUYGUUMIUVEUYFUUMFXTWQYSXQWTQUYIUDUUQUYHUUNUUJGURXDXAXEVQUYEVVCUWTUUPU
        YNTVVEVUMBCUUOUUJJUUFUVIUYNGUVDUUOTZUXJUJZUVHUYMVVSDUVCUVGUUJUYLVVRUXJW
        OVVSUVFUYKUVDUUOIVVSUVDUUOUVEFVVRUXJWPZWQVVTWRWSWTQUYMDUUJUYLUXMXDXAXEV
        QUUBWJYTUUCYTUAUBUCFGHJUUFUUIKOUXHUUAUUD $.

      sylow3lem2.k $e |- ( ph -> K e. ( P pSyl G ) ) $.
      sylow3lem2.h $e |- H = { u e. X | ( u .(+) K ) = K } $.
      sylow3lem2.n $e |- N = { x e. X |
        A. y e. X ( ( x .+ y ) e. K <-> ( y .+ x ) e. K ) } $.
      $( Lemma for ~ sylow3 , first part.  The stabilizer of a given Sylow
         subgroup ` K ` in the group action ` .(+) ` acting on all of ` G ` is
         the normalizer N_G(K).  (Contributed by Mario Carneiro,
         19-Jan-2015.) $)
      sylow3lem2 $p |- ( ph -> H = N ) $=
        ( vw vv cv co wceq crab cin wcel wb wral ssrab2 eqsstri sseqin2 mpbi wa
        wss cmpt crn cslw simpr adantr mptexg rnexg 3syl simpl oveq1d mpteq12dv
        cvv oveq12d rneqd ovmpt2ga syl3anc csubg cfv slwsubg eqid conjnmz sylan
        eqtr4d simplr simprl eqtr3d eleq2d wrex ovex eqeq1 rexbidv rnmpt simprr
        elab2 cgrp ad3antrrr simpllr subgss sseldd grpaddsubass syl13anc eqtr2d
        grpsubcl simplrr grplcan mpbid grpsubadd eqeltrd rexlimdvaa oveq2 fvmpt
        syl syl5bi grpass grppncan 3eqtr2d wfn fnmpti fnfvelrn sylancr eqeltrrd
        grpcl ex impbid bitrd anassrs ralrimiva elnmz impbida rabbi2dva syl5eqr
        sylanbrc syl6reqr ) AMEUGZKHUHZKUIZENUJZJAMNMUKZYQMNUTYRMUIMBUGZCUGZGUH
        KULYTYSGUHKULUMCNUNZBNUJNUDUUABNUOUPMNUQURAYPENMAYNNULZUSZYNMULZYPUUCUU
        DUSYODKYNDUGZGUHZYNLUHZVAZVBZKUUCYOUUIUIZUUDUUCUUBKFIVCUHZULZUUIVLULZUU
        JAUUBVDAUULUUBUBVEZUUCUULUUHVLULUUMUUNDKUUGUUKVFUUHVLVGVHBCYNKNUUKDYTYS
        UUEGUHZYSLUHZVAZVBUUIHVLYSYNUIZYTKUIZUSZUUQUUHUUTDYTUUPKUUGUURUUSVDUUTU
        UOUUFYSYNLUUTYSYNUUEGUURUUSVIZVJUVAVMVKVNUAVOVPZVEUUCKIVQVRULZUUDKUUIUI
        AUVCUUBAUULUVCUBFIKVSXLZVEDBCYNGKUUHILMNOSTUUHVTZUDWAWBWCUUCYPUSZUUBYNU
        EUGZGUHZKULZUVGYNGUHZKULZUMZUENUNUUDAUUBYPWDUVFUVLUENUUCYPUVGNULZUVLUUC
        YPUVMUSZUSZUVIUVHUUIULZUVKUVOKUUIUVHUVOYOKUUIUUCYPUVMWEUUCUUJUVNUVBVEWF
        WGUVOUVPUVKUVPUVHUUGUIZDKWHZUVOUVKUFUGZUUGUIZDKWHUVRUFUVHUUIYNUVGGWIUVS
        UVHUIUVTUVQDKUVSUVHUUGWJWKDUFKUUGUUHUVEWLWNUVOUVQUVKDKUVOUUEKULZUVQUSZU
        SZUVJUUEKUWCUUEYNLUHZUVGUIZUVJUUEUIZUWCYNUWDGUHZUVHUIZUWEUWCUVHUUGUWGUV
        OUWAUVQWMUWCIWOULZUUBUUENULZUUBUUGUWGUIAUWIUUBUVNUWBPWPZAUUBUVNUWBWQZUW
        CKNUUEAKNUTZUUBUVNUWBAUVCUWMUVDNKIOWRXLWPUVOUWAUVQWEZWSZUWLNGILYNUUEYNO
        STWTXAXBUWCUWIUWDNULZUVMUUBUWHUWEUMUWKUWCUWIUWJUUBUWPUWKUWOUWLNILUUEYNO
        TXCVPUUCYPUVMUWBXDZUWLNGIUWDUVGYNOSXEXAXFUWCUWIUWJUUBUVMUWEUWFUMUWKUWOU
        WLUWQNGILUUEYNUVGOSTXGXAXFUWNXHXIXMUVOUVKUVPUVOUVKUSZUVJUUHVRZUVHUUIUWR
        UWSYNUVJGUHZYNLUHZUVHYNGUHZYNLUHZUVHUWRUVKUWSUXAUIUVOUVKVDZDUVJUUGUXAKU
        UHUUEUVJUIUUFUWTYNLUUEUVJYNGXJVJUVEUWTYNLWIXKXLUWRUXBUWTYNLUWRUWIUUBUVM
        UUBUXBUWTUIAUWIUUBUVNUVKPWPZAUUBUVNUVKWQZUUCYPUVMUVKXDZUXFNGIYNUVGYNOSX
        NXAVJUWRUWIUVHNULZUUBUXCUVHUIUXEUWRUWIUUBUVMUXHUXEUXFUXGNGIYNUVGOSYBVPU
        XFNGILUVHYNOSTXOVPXPUWRUUHKXQUVKUWSUUIULDKUUGUUHUUFYNLWIUVEXRUXDKUVJUUH
        XSXTYAYCYDYEYFYGBCUEYNGKMNUDYHYLYIYJYKUCYM $.

      $( Lemma for ~ sylow3 , first part.  The number of Sylow subgroups is the
         same as the index (number of cosets) of the normalizer of the Sylow
         subgroup ` K ` .  (Contributed by Mario Carneiro, 19-Jan-2015.) $)
      sylow3lem3 $p |- ( ph ->
        ( # ` ( P pSyl G ) ) = ( # ` ( X /. ( G ~QG N ) ) ) ) $=
        ( vg vh cslw co chash cfv cqg cqs cfn wcel cn0 cpw wss pwfi sylib csubg
        slwsubg subgss syl vex elpw sylibr ssriv ssfi sylancl hashcl nn0cnd wer
        cv cgrp nmzsubg eqid eqger qsss syl2anc cn c0 wne subg0cl ne0i hashnncl
        c0g wb mpbird nncnd nnne0d cpr wceq wrex wa cec cmul sylow3lem1 orbsta2
        copab cga syl21anc lagsubg2 gaorber ecss adantr simpr cmpt sylow2 eqcom
        wbr crn cvv mptexg rnexg simpl oveq12d mpteq12dv rneqd ovmpt2ga syl3anc
        oveq1d eqeq2d syl5bb rexbidva gaorb syl3anbrc elecg ex ssrdv sylow3lem2
        eqssd fveq2d 3eqtr3rd mulcan2ad ) AFIUGUHZUIUJZNIMUKUHZULZUIUJZMUIUJZAY
        PAYOUMUNZYPUOUNANUPZUMUNZYOUUBUQUUAANUMUNZUUCQNURUSZBYOUUBBVMZYOUNZUUFN
        UQZUUFUUBUNUUGUUFIUTUJZUNUUHFIUUFVANUUFIOVBVCUUFNBVDVEVFVGUUBYOVHVIYOVJ
        VCVKAYSAYRUMUNZYSUOUNAUUCYRUUBUQUUJUUEANYQAMUUIUNZNYQVLAIVNUNUUKPBCGKIM
        NUDOSVOVCZYQINMOYQVPZVQVCVRUUBYRVHVSYRVJVCVKAYTAYTVTUNZMWAWBZAIWFUJZMUN
        ZUUOAUUKUUQUULMIUUPUUPVPWCVCMUUPWDVCAMUMUNZUUNUUOWGAUUDMNUQZUURQAUUKUUS
        UULNMIOVBVCNMVHVSMWEVCWHZWIAYTUUTWJANUIUJZKUUFCVMZWKYOUQUEVMUUFHUHUVBWL
        UENWMWNBCWSZWOZUIUJZJUIUJZWPUHZYSYTWPUHYPYTWPUHAHIYOWTUHUNZKYOUNZUUDUVA
        UVGWLABCDFGHILNOPQRSTUAWQZUBQBCEKHIJUKUHZUEIJUVCNYOOUCUVKVPUVCVPZWRXAAY
        QINMOUUMUULQXBAUVEYPUVFYTWPAUVDYOUIAUVDYOAKUVCYOAUVHYOUVCVLUVJBCHUVCUEI
        NYOUVLOXCVCXDAUFYOUVDAUFVMZYOUNZUVMUVDUNZAUVNWNZUVOKUVMUVCXJZUVPUVIUVNE
        VMZKHUHZUVMWLZENWMZUVQAUVIUVNUBXEZAUVNXFZUVPUWAUVMDKUVRDVMZGUHZUVRLUHZX
        GZXKZWLZENWMUVPDFGEIUVMKLNOAUUDUVNQXEUWCUWBSTXHUVPUVTUWIENUVTUVMUVSWLUV
        PUVRNUNZWNZUWIUVSUVMXIUWKUVSUWHUVMUWKUWJUVIUWHXLUNZUVSUWHWLUVPUWJXFUVPU
        VIUWJUWBXEZUWKUWGXLUNZUWLUWKUVIUWNUWMDKUWFYOXMVCUWGXLXNVCBCUVRKNYODUVBU
        UFUWDGUHZUUFLUHZXGZXKUWHHXLUUFUVRWLZUVBKWLZWNZUWQUWGUWTDUVBUWPKUWFUWRUW
        SXFUWTUWOUWEUUFUVRLUWTUUFUVRUWDGUWRUWSXOZYAUXAXPXQXRUAXSXTYBYCYDWHBCKUV
        MHUVCUEENYOUVLYEYFUVPUVNUVIUVOUVQWGUWCUWBUVMKUVCYOYOYGVSWHYHYIYKYLAJMUI
        ABCDEFGHIJKLMNOPQRSTUAUBUCUDYJYLXPYMYN $.

      $( Lemma for ~ sylow3 , first part.  The number of Sylow subgroups is a
         divisor of the size of ` G ` reduced by the size of a Sylow subgroup
         of ` G ` .  (Contributed by Mario Carneiro, 19-Jan-2015.) $)
      sylow3lem4 $p |- ( ph -> ( # ` ( P pSyl G ) ) ||
        ( ( # ` X ) / ( P ^ ( P pCnt ( # ` X ) ) ) ) ) $=
        ( cslw co chash cfv cqg cqs cpc cexp cdiv cdivides sylow3lem3 wbr cress
        cmul cbs csubg wcel cfn slwsubg syl cnsg eqid nsgsubg wceq cgrp nmzsubg
        nmznsg subgbas wss subgss ssfi syl2anc eqeltrrd lagsubg fveq2d breqtrrd
        cz wi cn c0 wne c0g subg0cl ne0i wb hashnncl mpbird nnzd cn0 hashcl cpw
        nn0zd pwfi sylib wer eqger qsss dvdscmul syl3anc nn0cnd nnne0d divcan1d
        mpd nncnd lagsubg2 eqtrd cc0 dvdsval2 mpbid dvdsmulcr syl112anc slwhash
        oveq2d breqtrd eqbrtrd ) AFIUEUFZUGUHNIMUIUFZUJZUGUHZNUGUHZFFYDUKUFULUF
        ZUMUFZUNABCDEFGHIJKLMNOPQRSTUAUBUCUDUOAYCYDKUGUHZUMUFZYFUNAYCYGURUFZYHY
        GURUFZUNUPZYCYHUNUPZAYIYCMUGUHZURUFZYJUNAYGYMUNUPZYIYNUNUPZAYGIMUQUFZUS
        UHZUGUHZYMUNAKYQUTUHVAZYRVBVAYGYSUNUPAKIUTUHZVAZYTAKXTVAUUBUBFIKVCVDZUU
        BKYQVEUHVAYTBCGKIYQMNUDOSYQVFZVKKYQVGVDVDAMYRVBAMUUAVAZMYRVHAIVIVAUUEPB
        CGKIMNUDOSVJVDZMIYQUUDVLVDZANVBVAZMNVMZMVBVAZQAUUEUUIUUFNMIOVNVDNMVOVPZ
        VQYQYRKYRVFVRVPAMYRUGUUGVSVTAYGWAVAZYMWAVAYCWAVAZYOYPWBAYGAYGWCVAZKWDWE
        ZAIWFUHZKVAZUUOAUUBUUQUUCKIUUPUUPVFWGVDKUUPWHVDAKVBVAZUUNUUOWIAUUHKNVMZ
        UURQAUUBUUSUUCNKIOVNVDNKVOVPKWJVDWKZWLZAYMAUUJYMWMVAUUKMWNVDWPAYCAYBVBV
        AZYCWMVAANWOZVBVAZYBUVCVMUVBAUUHUVDQNWQWRANYAAUUENYAWSUUFYAINMOYAVFZWTV
        DXAUVCYBVOVPYBWNVDWPZYCYGYMXBXCXGAYJYDYNAYDYGAYDAUUHYDWMVAQNWNVDZXDAYGU
        UTXHAYGUUTXEZXFAYAINMOUVEUUFQXIXJVTAUUMYHWAVAZUULYGXKWEZYKYLWIUVFAYGYDU
        NUPZUVIAUUBUUHUVKUUCQINKOVRVPAUULUVJYDWAVAUVKUVIWIUVAUVHAYDUVGWPYGYDXLX
        CXMUVAUVHYGYCYHXNXOXMAYGYEYDUMAFIKNOQUBXPXQXRXS $.
    $}

    ${
      sylow3lem5.a $e |- .+ = ( +g ` G ) $.
      sylow3lem5.d $e |- .- = ( -g ` G ) $.
      sylow3lem5.k $e |- ( ph -> K e. ( P pSyl G ) ) $.
      sylow3lem5.m $e |- .(+) = ( x e. K , y e. ( P pSyl G ) |->
        ran ( z e. y |-> ( ( x .+ z ) .- x ) ) ) $.
      $( Lemma for ~ sylow3 , second part.  Reduce the group action of
         ~ sylow3lem1 to a given Sylow subgroup.  (Contributed by Mario
         Carneiro, 19-Jan-2015.) $)
      sylow3lem5 $p |- ( ph -> .(+) e. ( ( G |`s K ) GrpAct ( P pSyl G ) ) ) $=
        ( co va vb vc cslw cmpt crn cmpt2 cxp cres cress cga wss wceq csubg cfv
        cv wcel slwsubg syl subgss resmpt2 sylancl syl6eqr oveq2 oveq1d cbvmptv
        ssid oveq1 id oveq12d mpteq2dv syl5eq mpteq1 cbvmpt2v sylow3lem1 gasubg
        rneqd eqid syl2anc eqeltrrd ) ABCKEHUDTZDCUPZBUPZDUPZFTZWCJTZUEZUFZUGZI
        WAUHUIZGHIUJTZWAUKTZAWJBCIWAWHUGZGAIKULZWAWAULWJWMUMAIHUNUOUQZWNAIWAUQW
        OREHIURUSZKIHLUTUSWAVGBCKWAIWAWHVAVBSVCAWIHWAUKTUQWOWJWLUQAUAUBUCEFWIHJ
        KLMNOPQBCUAUBKWAWHUCUBUPZUAUPZUCUPZFTZWRJTZUEZUFUCWBXAUEZUFWCWRUMZWGXCX
        DWGUCWBWCWSFTZWCJTZUEXCDUCWBWFXFWDWSUMWEXEWCJWDWSWCFVDVEVFXDUCWBXFXAXDX
        EWTWCWRJWCWRWSFVHXDVIVJVKVLVQWBWQUMXCXBUCWBWQXAVMVQVNVOWPWIIHWKWAWKVRVP
        VSVT $.

      sylow3lem6.n $e |- N = { x e. X |
        A. y e. X ( ( x .+ y ) e. s <-> ( y .+ x ) e. s ) } $.
      $( Lemma for ~ sylow3 , second part.  Using the lemma ~ sylow2a , show
         that the number of sylow subgroups is equivalent ` mod P ` to the
         number of fixed points under the group action.  But ` K ` is the
         unique element of the set of Sylow subgroups that is fixed under the
         group action, so there is exactly one fixed point and so
         ` ( ( # `` ( P pSyl G ) ) mod P ) = 1 ` .  (Contributed by Mario
         Carneiro, 19-Jan-2015.) $)
      sylow3lem6 $p |- ( ph -> ( ( # ` ( P pSyl G ) ) mod P ) = 1 ) $=
        ( vg vw vh cslw co chash cfv cmo c1 wceq cmin cdivides wbr cv cress cbs
        wral crab cpr wss wrex copab eqid sylow3lem5 wcel cpgp slwpgp syl csubg
        wa cfn slwsubg subgbas subgss ssfi syl2anc eqeltrrd cpw pwfi sylib elpw
        vex sylibr ssriv sylancl sylow2a csn cmpt eqcom adantr sselda biantrurd
        crn syl5bb simpr simplr simpl oveq1d oveq12d mpteq12dv rneqd mptex rnex
        ovmpt2a eqeq1d ad2antlr conjnmzb 3bitr4d ralbidva dfss3 syl6bbr raleqdv
        weq wb csg cgrp ad2antrr nmzsubg subgslw syl3anc ssnmz cvv fvex eqeltri
        cplusg rabex ressplusg ax-mp sylow2 cnsg conjnsg sylan eqeq2 syl5ibrcom
        nmznsg rexlimdva eqtrd cz mpd eqeltrd eqsstr3d impbida 3bitr3d rabbidva
        rabsn fveq2d hashsng oveq2d breqtrd cn cprime prmnn cn0 hashcl nn0zd 1z
        a1i moddvds mpbird c2 cuz prmuz2 clt eluz2b2 cr nnre 1mod sylbi 3syl )
        AEHUFUGZUHUIZEUJUGZUKEUJUGZUKAUVNUVOULZEUVMUKUMUGZUNUOZAEUVMUCUPZMUPZGU
        GZUVTULZUCHIUQUGZURUIZUSZMUVLUTZUHUIZUMUGUVQUNADUDMEGDUPZUDUPZVAUVLVBUE
        UPUWHGUGUWIULUEUWDVCVLDUDVDZUEUCUWCUWDUVLUWFUWDVEABCDEFGHIJLNOPQRSTUAVF
        AIUVLVGZEUWCVHUOTEUWCHIUWCVEZVIVJAIUWDVMAIHVKUIZVGZIUWDULZAUWKUWNTEHIVN
        VJZIHUWCUWLVOVJZALVMVGZILVBZIVMVGPAUWNUWSUWPLIHNVPVJZLIVQVRVSALVTZVMVGZ
        UVLUXAVBUVLVMVGZAUWRUXBPLWAWBBUVLUXABUPZUVLVGZUXDLVBZUXDUXAVGUXEUXDUWMV
        GUXFEHUXDVNLUXDHNVPVJUXDLBWDWCWEWFUXAUVLVQWGZUWFVEUWJVEWHAUWGUKUVMUMAUW
        GIWIZUHUIZUKAUWFUXHUHAUWFUVTIULZMUVLUTZUXHAUWEUXJMUVLAUVTUVLVGZVLZUWBUC
        IUSZIKVBZUWEUXJUXMUXNUVSKVGZUCIUSUXOUXMUWBUXPUCIUXMUVSIVGZVLZDUVTUVSUWH
        FUGZUVSJUGZWJZWOZUVTULZUVSLVGZUVTUYBULZVLZUWBUXPUYCUYEUXRUYFUYBUVTWKUXR
        UYDUYEUXMILUVSAUWSUXLUWTWLWMWNWPUXRUWAUYBUVTUXRUXQUXLUWAUYBULUXMUXQWQAU
        XLUXQWRBCUVSUVTIUVLDCUPZUXDUWHFUGZUXDJUGZWJZWOUYBGBUCXOZCMXOZVLZUYJUYAU
        YMDUYGUYIUVTUXTUYKUYLWQUYMUYHUXSUXDUVSJUYMUXDUVSUWHFUYKUYLWSZWTUYNXAXBX
        CUAUYADUVTUXTMWDXDXEXFVRXGUXRUVTUWMVGZUXPUYFXPUXLUYOAUXQEHUVTVNZXHDBCUV
        SFUVTUYAHJKLNRSUYAVEUBXIVJXJXKUCIKXLXMUXMUWBUCIUWDAUWOUXLUWQWLXNUXMUXOU
        XJUXMUXOVLZIDUVTUXSUVSHKUQUGZXQUIZUGWJZWOZULZUCUYRURUIZVCUXJUYQDEFUCUYR
        IUVTUYSVUCVUCVEZUYQKVUCVMUYQKUWMVGZKVUCULUYQHXRVGZVUEAVUFUXLUXOOXSBCFUV
        THKLUBNRXTVJZKHUYRUYRVEZVOVJUYQUWRKLVBZKVMVGAUWRUXLUXOPXSUYQVUEVUIVUGLK
        HNVPVJLKVQVRVSUYQVUEUWKUXOIEUYRUFUGZVGVUGAUWKUXLUXOTXSUXMUXOWQEKHUYRIVU
        HYAYBUYQVUEUXLUVTKVBZUVTVUJVGVUGAUXLUXOWRUYQUYOVUKUXLUYOAUXOUYPXHZBCFUV
        THKLUBNRYCZVJEKHUYRUVTVUHYAYBKYDVGFUYRYGUIULKUXDUYGFUGUVTVGUYGUXDFUGUVT
        VGXPCLUSZBLUTYDUBVUNBLLHURUIYDNHURYEYFYHYFKFHUYRYDVUHRYIYJZUYSVEZYKUYQV
        UBUXJUCVUCUYQUVSVUCVGZVLUXJVUBUVTVUAULZUYQUVTUYRYLUIVGZVUQVURUYQUYOVUSV
        ULBCFUVTHUYRKLUBNRVUHYQVJDUVSFUVTUYTUYRUYSVUCVUDVUOVUPUYTVEYMYNIVUAUVTY
        OYPYRUUAUXMUXJVLZIUVTKUXMUXJWQZVUTUYOVUKVUTUVTIUWMVVAAUWNUXLUXJUWPXSUUB
        VUMVJUUCUUDUUEUUFAUWKUXKUXHULTMUVLIUUGVJYSUUHAUWKUXIUKULTIUVLUUIVJYSUUJ
        UUKAEUULVGZUVMYTVGUKYTVGZUVPUVRXPAEUUMVGZVVBQEUUNVJAUVMAUXCUVMUUOVGUXGU
        VLUUPVJUUQVVCAUURUUSUVMUKEUUTYBUVAAVVDEUVBUVCUIVGZUVOUKULZQEUVDVVEVVBUK
        EUVEUOZVLVVFEUVFVVBEUVGVGVVGVVFEUVHEUVIYNUVJUVKYS $.
    $}

    sylow3.n $e |- N = ( # ` ( P pSyl G ) ) $.
    $( Sylow's third theorem.  The number of Sylow subgroups is a divisor of
       ` | G | / d ` , where ` d ` is the common order of a Sylow subgroup, and
       is equivalent to ` 1 mod P ` .  (Contributed by Mario Carneiro,
       19-Jan-2015.) $)
    sylow3 $p |- ( ph -> ( N || ( ( # ` X ) / ( P ^ ( P pCnt ( # ` X ) ) ) ) /\
                   ( N mod P ) = 1 ) ) $=
      ( vx vy vz va vb cv co wcel wceq eqid vk vu vc vs cslw chash cfv cpc cexp
      cdiv cdivides wbr cmo c1 wa c0 wne wex cgrp cprime slwn0 syl3anc n0 sylib
      cfn cplusg csg cmpt crn cmpt2 crab wral adantr oveq2 oveq1d cbvmptv oveq1
      wb id oveq12d mpteq2dv syl5eq rneqd mpteq1 cbvmpt2v simpr syl5eqbr oveq1i
      sylow3lem4 sylow3lem6 jca exlimddv ) AUAPZBCUEQZRZDEUFUGZBBWPUHQUIQUJQZUK
      ULZDBUMQZUNSZUOUAAWNUPUQZWOUAURACUSRZEVERZBUTRZXAGHIBCEFVAVBUAWNVCVDAWOUO
      ZWRWTXEDWNUFUGZWQUKJXEKLMUBBCVFUGZNOEWNUCOPZNPZUCPZXGQZXICVGUGZQZVHZVIZVJ
      ZCUBPWMXPQWMSUBEVKZWMXLKPZLPZXGQZWMRXSXRXGQZWMRVRLEVLKEVKZEFAXBWOGVMZAXCW
      OHVMZAXDWOIVMZXGTZXLTZNOKLEWNXOMXSXRMPZXGQZXRXLQZVHZVIZMXHYJVHZVIZXIXRSZX
      NYMYOXNMXHXIYHXGQZXIXLQZVHYMUCMXHXMYQXJYHSXKYPXIXLXJYHXIXGVNVOVPYOMXHYQYJ
      YOYPYIXIXRXLXIXRYHXGVQYOVSVTWAWBWCZXHXSSYMYKMXHXSYJWDWCZWEAWOWFZXQTYBTWIW
      GXEWSXFBUMQUNDXFBUMJWHXEKLMBXGNOWMWNXOVJCWMXLXTUDPZRYAUUARVRLEVLKEVKZEUDF
      YCYDYEYFYGYTNOKLWMWNXOYLYNYRYSWEUUBTWJWBWKWL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Direct products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LSSum $.
  $c proj1 $.

  $( Extend class notation with subgroup sum. $)
  clsm $a class LSSum $.

  $( Extend class notation with left projection. $)
  cpj1 $a class proj1 $.

  ${
    $d w t u x y z $.
    $( Define subgroup sum (inner direct product of subgroups).  (Contributed
       by NM, 28-Jan-2014.) $)
    df-lsm $a |- LSSum = ( w e. _V |->
       ( t e. ~P ( Base ` w ) , u e. ~P ( Base ` w ) |->
           ran ( x e. t , y e. u |-> ( x ( +g ` w ) y ) ) ) ) $.

    $( Define the left projection function, which takes two subgroups ` t , u `
       with trivial intersection and returns a function mapping the elements of
       the subgroup sum ` t + u ` to their projections onto ` t ` .  (The other
       projection function can be obtained by swapping the roles of ` t ` and
       ` u ` .)  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    df-pj1 $a |- proj1 = ( w e. _V |->
       ( t e. ~P ( Base ` w ) , u e. ~P ( Base ` w ) |->
         ( z e. ( t ( LSSum ` w ) u ) |->
           ( iota_ x e. t E. y e. u z = ( x ( +g ` w ) y ) ) ) ) ) $.
  $}

  ${
    $d t u w x y z .+ $.  $d t u w x y z B $.  $d t u x y z T $.  $d x y z X $.
    $d t u w x y z G $.  $d t u x y z U $.  $d x y Y $.
    lsmfval.v $e |- B = ( Base ` G ) $.
    lsmfval.a $e |- .+ = ( +g ` G ) $.
    lsmfval.s $e |- .(+) = ( LSSum ` G ) $.
    $( The subgroup sum function (for a group or vector space).  (Contributed
       by NM, 28-Jan-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmfval $p |- ( G e. V -> .(+) = ( t e. ~P B , u e. ~P B |->
                    ran ( x e. t , y e. u |-> ( x .+ y ) ) ) ) $=
      ( vw wcel cfv cv cmpt2 cvv wceq cbs clsm cpw co elex cplusg fveq2 syl6eqr
      crn pweqd oveqd 3ad2ant1 mpt2eq3dva rneqd mpt2eq123dv df-lsm fvex eqeltri
      pwex mpt2ex fvmpt syl syl5eq ) HINZGHUAOZDCEUBZVEABDPZCPZAPZBPZFUCZQZUHZQ
      ZLVCHRNVDVMSHIUDMHDCMPZTOZUBZVPABVFVGVHVIVNUEOZUCZQZUHZQVMRUAVNHSZDCVPVPV
      TVEVEVLWAVOEWAVOHTOZEVNHTUFJUGUIZWCWAVSVKWAABVFVGVRVJWAVHVFNVRVJSVIVGNWAV
      QFVHVIWAVQHUEOFVNHUEUFKUGUJUKULUMUNABMCDUODCVEVEVLEEWBRJHTUPUQURZWDUSUTVA
      VB $.

    $( Subspace sum value (for a group or vector space).  Extended domain
       version of ~ lsmval .  (Contributed by NM, 28-Jan-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2016.) $)
    lsmvalx $p |- ( ( G e. V /\ T C_ B /\ U C_ B )
       -> ( T .(+) U ) = ran ( x e. T , y e. U |-> ( x .+ y ) ) ) $=
      ( vt vu wcel co cv cmpt2 wceq cvv wss crn wa cpw lsmfval cbs fvex eqeltri
      oveqd elpw2 mpt2exga rnexg mpt2eq12 rneqd eqid ovmpt2ga syl2anbr sylan9eq
      cfv syl mpd3an3 3impb ) HIOZFCUAZGCUAZFGEPZABFGAQBQDPZRZUBZSVCVDVEUCVFFGM
      NCUDZVJABMQZNQZVGRZUBZRZPZVIVCEVOFGABNMCDEHIJKLUEUIVDFVJOZGVJOZVPVISZVEFC
      CHUFUSTJHUFUGUHZUJGCVTUJVQVRVITOZVSVQVRUCVHTOWAABFGVGVJVJUKVHTULUTMNFGVJV
      JVNVIVOTVKFSVLGSUCVMVHABVKVLFGVGUMUNVOUOUPVAUQURVB $.

    $( Subspace sum membership (for a group or vector space).  Extended domain
       version of ~ lsmelval .  (Contributed by NM, 28-Jan-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2016.) $)
    lsmelvalx $p |- ( ( G e. V /\ T C_ B /\ U C_ B )
       -> ( X e. ( T .(+) U ) <-> E. y e. T E. z e. U X = ( y .+ z ) ) ) $=
      ( wcel wss w3a co cv cmpt2 wrex crn wceq eleq2d eqid ovex elrnmpt2 syl6bb
      lsmvalx ) HINFCOGCOPZJFGEQZNJABFGARZBRZDQZSZUAZNJUMUBBGTAFTUIUJUOJABCDEFG
      HIKLMUHUCABFGUMJUNUNUDUKULDUEUFUG $.

    $( Subspace sum membership (for a group or vector space).  (Contributed by
       NM, 4-Feb-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmelvalix $p |- ( ( ( G e. V /\ T C_ B /\ U C_ B ) /\
               ( X e. T /\ Y e. U ) ) -> ( X .+ Y ) e. ( T .(+) U ) ) $=
      ( vx vy wcel wss co cv wceq wrex wa eqid rspceov mp3an3 lsmelvalx biimpar
      w3a sylan2 ) HDOZIEOZUAFGODAPEAPUGZHIBQZMRNRBQSNETMDTZULDECQOZUIUJULULSUM
      ULUBMNDEHIULBUCUDUKUNUMMNABCDEFGULJKLUEUFUH $.
  $}

  ${
    $d t u x y G $.  $d t u x y O $.  $d t u x T $.  $d t u x U $.
    oppglsm.o $e |- O = ( oppG ` G ) $.
    oppglsm.p $e |- .(+) = ( LSSum ` G ) $.
    $( The subspace sum operation in the opposite group.  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    oppglsm $p |- ( T ( LSSum ` O ) U ) = ( U .(+) T ) $=
      ( vt vu vx vy cvv wcel cfv co wceq cmpt2 eqid syl6eq c0 clsm ctpos cbs cv
      cpw cplusg crn lsmfval tposeqd wa cdm ccnv wrel reldmmpt2 mpt2fun funforn
      wfo wfun mpbi tposfo2 forn ax-mp oppgplus eqcomi mpt2eq3ia tposmpt2 rneqi
      mp2 a1i eqtr3i coppg fvex eqeltri oppgbas syl6reqr oveqd ovtpos wss eqidd
      wn 0ex elovmpt2 simp3bi ssriv ss0 w3a elpwi 3ad2ant2 3ad2ant1 sseqtrd syl
      fvprc mpt2eq12 sylancl mpt20 rneqd rn0 mpt2eq3dva cop df-ov eqtri 3eqtr4a
      syl5eq 0fv pm2.61i ) DLMZBCEUANZOZCBAOZPXFXHBCAUBZOXIXFXGXJBCXFXJHIDUCNZU
      EZXLJKHUDZIUDZJUDZKUDZEUFNZOZQZUGZQZXGXFXJIHXLXLKJXNXMXPXODUFNZOZQZUGZQZU
      BYAXFAYFKJHIXKYBADLXKRZYBRZGUHUIIHXLXLXTYFIHXLXLYEXTYEXTPXNXLMZXMXLMZUJYD
      UBZUGZYEXTYDUKZULZYEYKUQZYLYEPYMUMYMYEYDUQZYOKJXNXMYCYDYDRZUNYDURYPKJXNXM
      YCYDYQUOYDUPUSYMYEYDUTVHYNYEYKVAVBYKXSKJXNXMXRYDKJXNXMYCXRYCXRPXPXNMXOXMM
      UJXRYCYBXQDEXOXPYHFXQRZVCVDVIVEVFVGVJVIVEVFSELMXGYAPEDVKNLFDVKVLVMJKIHXKX
      QXGELXKDEFYGVNYRXGRUHVBZVOVPBCAVQSXFVTZBCHIXLXLTQZOZTXHXIUUBTVRUUBTPJUUBT
      XOUUBMBXLMCXLMXOTMXLXLTUUATXOBCHIUUARWAXMBPXNCPUJTVSWBWCWDUUBWEVBYTXGUUAB
      CYTXGYAUUAYSYTHIXLXLXTTYTYJYIWFZXTTUGTUUCXSTUUCXSJKTXNXRQZTUUCXMTPZXNXNPX
      SUUDPUUCXMTVRUUEUUCXMXKTYJYTXMXKVRYIXMXKWGWHYTYJXKTPYIDUCWLWIWJXMWEWKXNRJ
      KXMXNTXNXRWMWNJKXNXRWOSWPWQSWRXCVPYTXICBTOZTYTATCBYTADUANTGDUAWLXCVPUUFCB
      WSZTNTCBTWTUUGXDXASXBXE $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z R $.  $d x y z T $.  $d x y z U $.
    $d x .(+) $.  $d x V $.
    lsmless2.v $e |- B = ( Base ` G ) $.
    lsmless2.s $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum is a subset of the base.  (Contributed by Mario Carneiro,
       19-Apr-2016.) $)
    lsmssv $p |- ( ( G e. Mnd /\ T C_ B /\ U C_ B ) -> ( T .(+) U ) C_ B ) $=
      ( vx vy cmnd wcel wss w3a co cv cplusg eqid wral wa sselda cfv lsmvalx wf
      cmpt2 crn cxp simpl1 simp2 adantrr simp3 adantrl mndcl syl3anc ralrimivva
      fmpt2 sylib frn syl eqsstrd ) EJKZCALZDALZMZCDBNHICDHOZIOZEPUAZNZUDZUEZAH
      IAVFBCDEJFVFQZGUBVCCDUFZAVHUCZVIALVCVGAKZIDRHCRVLVCVMHICDVCVDCKZVEDKZSZSU
      TVDAKZVEAKZVMUTVAVBVPUGVCVNVQVOVCCAVDUTVAVBUHTUIVCVOVRVNVCDAVEUTVAVBUJTUK
      AVFEVDVEFVJULUMUNHICDVGAVHVHQUOUPVKAVHUQURUS $.

    $( Subset implies subgroup sum subset (extended domain version).
       (Contributed by NM, 22-Feb-2014.)  (Revised by Mario Carneiro,
       19-Apr-2016.) $)
    lsmless1x $p |- ( ( ( G e. V /\ T C_ B /\ U C_ B ) /\ R C_ T )
       -> ( R .(+) U ) C_ ( T .(+) U ) ) $=
      ( vx vy vz wcel wss w3a co cv wrex wb lsmelvalx wa cplusg cfv wceq ssrexv
      adantl simpl1 simpr simpl2 sstrd simpl3 eqid syl3anc adantr 3imtr4d ssrdv
      wi ) FGMZDANZEANZOZCDNZUAZJCEBPZDEBPZVCJQZKQLQFUBUCZPUDLERZKCRZVHKDRZVFVD
      MZVFVEMZVBVIVJUQVAVHKCDUEUFVCURCANUTVKVISURUSUTVBUGVCCDAVAVBUHURUSUTVBUIU
      JURUSUTVBUKKLAVGBCEFGVFHVGULZITUMVAVLVJSVBKLAVGBDEFGVFHVMITUNUOUP $.

    $( Subset implies subgroup sum subset (extended domain version).
       (Contributed by NM, 25-Feb-2014.)  (Revised by Mario Carneiro,
       19-Apr-2016.) $)
    lsmless2x $p |- ( ( ( G e. V /\ R C_ B /\ U C_ B ) /\ T C_ U )
       -> ( R .(+) T ) C_ ( R .(+) U ) ) $=
      ( vx vy vz wcel wss w3a co cv wrex wb lsmelvalx wa cplusg cfv wceq ssrexv
      wi reximdv adantl simpl1 simpl2 simpr simpl3 sstrd syl3anc adantr 3imtr4d
      eqid ssrdv ) FGMZCANZEANZOZDENZUAZJCDBPZCEBPZVDJQZKQLQFUBUCZPUDZLDRZKCRZV
      ILERZKCRZVGVEMZVGVFMZVCVKVMUFVBVCVJVLKCVILDEUEUGUHVDUSUTDANVNVKSUSUTVAVCU
      IUSUTVAVCUJVDDEAVBVCUKUSUTVAVCULUMKLAVHBCDFGVGHVHUQZITUNVBVOVMSVCKLAVHBCE
      FGVGHVPITUOUPUR $.

    $( Subgroup sum is an upper bound of its arguments.  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    lsmub1x $p |- ( ( T C_ B /\ U e. ( SubMnd ` G ) ) -> T C_ ( T .(+) U ) ) $=
      ( vx wss csubmnd cfv wcel wa co cv c0g cplusg cmnd ad2antlr eqid syl32anc
      wceq submrcl simpll simpr sseldd mndrid syl2anc submss subm0cl lsmelvalix
      eqeltrrd ex ssrdv ) CAIZDEJKLZMZHCCDBNZUQHOZCLZUSURLUQUTMZUSEPKZEQKZNZUSU
      RVAERLZUSALVDUSUBUPVEUOUTDEUCSZVACAUSUOUPUTUDZUQUTUEZUFAVCEUSVBFVCTZVBTZU
      GUHVAVEUODAIZUTVBDLZVDURLVFVGUPVKUOUTADEFUISVHUPVLUOUTDEVBVJUJSAVCBCDERUS
      VBFVIGUKUAULUMUN $.

    $( Subgroup sum is an upper bound of its arguments.  (Contributed by NM,
       6-Feb-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmub2x $p |- ( ( T e. ( SubMnd ` G ) /\ U C_ B ) -> U C_ ( T .(+) U ) ) $=
      ( vx csubmnd cfv wcel wss wa co cv c0g cmnd ad2antrr simpr eqid cplusg ex
      submrcl sselda mndlid syl2anc submss subm0cl lsmelvalix syl32anc eqeltrrd
      wceq simplr ssrdv ) CEIJKZDALZMZHDCDBNZUQHOZDKZUSURKUQUTMZEPJZUSEUAJZNZUS
      URVAEQKZUSAKVDUSULUOVEUPUTCEUCRZUQDAUSUOUPSUDAVCEUSVBFVCTZVBTZUEUFVAVECAL
      ZUPVBCKZUTVDURKVFUOVIUPUTACEFUGRUOUPUTUMUOVJUPUTCEVBVHUHRUQUTSAVCBCDEQVBU
      SFVGGUIUJUKUBUN $.
  $}

  ${
    $d x y z .+ $.  $d x y z T $.  $d x y z U $.  $d x y z B $.  $d x y z G $.
    $d x y z X $.
    lsmval.v $e |- B = ( Base ` G ) $.
    lsmval.a $e |- .+ = ( +g ` G ) $.
    lsmval.p $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum value (for a left module or left vector space).
       (Contributed by NM, 4-Feb-2014.)  (Revised by Mario Carneiro,
       19-Apr-2016.) $)
    lsmval $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
       -> ( T .(+) U ) = ran ( x e. T , y e. U |-> ( x .+ y ) ) ) $=
      ( csubg cfv wcel cgrp wss co cv adantr subgss wa cmpt2 crn subgrcl adantl
      wceq lsmvalx syl3anc ) FHLMZNZGUINZUAHONZFCPZGCPZFGEQABFGARBRDQUBUCUFUJUL
      UKFHUDSUJUMUKCFHITSUKUNUJCGHITUEABCDEFGHOIJKUGUH $.
  $}

  ${
    $d y z .+ $.  $d y z T $.  $d y z U $.  $d y z G $.  $d y z X $.
    lsmelval.a $e |- .+ = ( +g ` G ) $.
    lsmelval.p $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum membership (for a left module or left vector space).
       (Contributed by NM, 4-Feb-2014.)  (Revised by Mario Carneiro,
       19-Apr-2016.) $)
    lsmelval $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
       -> ( X e. ( T .(+) U ) <-> E. y e. T E. z e. U X = ( y .+ z ) ) ) $=
      ( csubg cfv wcel cgrp wss co cv wrex adantr subgss wa cbs wceq wb subgrcl
      eqid adantl lsmelvalx syl3anc ) EGKLZMZFUJMZUAGNMZEGUBLZOZFUNOZHEFDPMHAQB
      QCPUCBFRAERUDUKUMULEGUESUKUOULUNEGUNUFZTSULUPUKUNFGUQTUGABUNCDEFGNHUQIJUH
      UI $.

    $( Subgroup sum membership (for a left module or left vector space).
       (Contributed by NM, 4-Feb-2014.)  (Revised by Mario Carneiro,
       19-Apr-2016.) $)
    lsmelvali $p |- ( ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) ) /\
               ( X e. T /\ Y e. U ) ) -> ( X .+ Y ) e. ( T .(+) U ) ) $=
      ( csubg cfv wcel wa cgrp cbs wss w3a co adantr subgss subgrcl eqid adantl
      3jca lsmelvalix sylan ) CEJKZLZDUGLZMZENLZCEOKZPZDULPZQFCLGDLMFGARCDBRLUJ
      UKUMUNUHUKUICEUASUHUMUIULCEULUBZTSUIUNUHULDEUOTUCUDULABCDENFGUOHIUEUF $.
  $}

  ${
    $d x y z .- $.  $d x y z G $.  $d x y z ph $.  $d x y z T $.  $d x y z U $.
    $d x y z X $.  $d x y Y $.
    lsmelvalm.m $e |- .- = ( -g ` G ) $.
    lsmelvalm.p $e |- .(+) = ( LSSum ` G ) $.
    lsmelvalm.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    lsmelvalm.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    $( Subgroup sum membership analog of ~ lsmelval using vector subtraction.
       TODO: any way to shorten proof?  (Contributed by NM, 16-Mar-2015.)
       (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmelvalm $p |- ( ph
       -> ( X e. ( T .(+) U ) <-> E. y e. T E. z e. U X = ( y .- z ) ) ) $=
      ( vx co wcel cfv wceq wrex syl2anc cv cplusg csubg wb lsmelval wa cminusg
      eqid adantr subginvcl sylan cbs subgrcl syl ad2antrr wss subgss grpsubinv
      cgrp sselda eqcomd oveq2 eqeq2d rspcev eqeq1 rexbidv syl5ibrcom rexlimdva
      grpsubval impbid rexbidva bitrd ) AIEFDOPZIBUAZNUAZGUBQZOZRZNFSZBESZIVNCU
      AZHOZRZCFSZBESAEGUCQZPZFWEPZVMVTUDLMBNVPDEFGIVPUHZKUETAVSWDBEAVNEPZUFZVSW
      DWJVRWDNFWJVOFPZUFZWDVRVQWBRZCFSZWLVOGUGQZQZFPZVQVNWPHOZRZWNWJWGWKWQAWGWI
      MUIZFGWOVOWOUHZUJUKWLWRVQWLGULQZVPGHWOVNVOXBUHZWHJXAAGUSPZWIWKAWFXDLEGUMU
      NUOWJVNXBPZWKAEXBVNAWFEXBUPLXBEGXCUQUNUTZUIWJFXBVOWJWGFXBUPWTXBFGXCUQUNZU
      TURVAWMWSCWPFWAWPRWBWRVQWAWPVNHVBVCVDTVRWCWMCFIVQWBVEVFVGVHWJWCVSCFWJWAFP
      ZUFZVSWCWBVQRZNFSZXIWAWOQZFPZWBVNXLVPOZRZXKWJWGXHXMWTFGWOWAXAUJUKXIXEWAXB
      PXOWJXEXHXFUIWJFXBWAXGUTXBVPGWOHVNWAXCWHXAJVITXJXONXLFVOXLRVQXNWBVOXLVNVP
      VBVCVDTWCVRXJNFIWBVQVEVFVGVHVJVKVL $.

    lsmelvalmi.x $e |- ( ph -> X e. T ) $.
    lsmelvalmi.y $e |- ( ph -> Y e. U ) $.
    $( Membership of vector subtraction in subgroup sum.  (Contributed by NM,
       27-Apr-2015.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmelvalmi $p |- ( ph -> ( X .- Y ) e. ( T .(+) U ) ) $=
      ( vx vy co wcel cv wceq wrex eqidd rspceov syl3anc lsmelvalm mpbird ) AGH
      FQZCDBQRUGOSPSFQTPDUAOCUAZAGCRHDRUGUGTUHMNAUGUBOPCDGHUGFUCUDAOPBCDEFUGIJK
      LUEUF $.
  $}

  ${
    $d a b c d x y .(+) $.  $d a b c d x y G $.  $d a b c d x y T $.
    $d a b c d x y U $.  $d a b c d x y Z $.
    lsmsubg.p $e |- .(+) = ( LSSum ` G ) $.
    lsmsubg.z $e |- Z = ( Cntz ` G ) $.
    $( The sum of two commuting submonoids is a submonoid.  (Contributed by
       Mario Carneiro, 19-Apr-2016.) $)
    lsmsubm $p |- ( ( T e. ( SubMnd ` G ) /\ U e. ( SubMnd ` G ) /\
        T C_ ( Z ` U ) ) -> ( T .(+) U ) e. ( SubMnd ` G ) ) $=
      ( va vc vb vd cfv wcel wss co cv syl3anc sseldd wa wrex vx vy csubmnd w3a
      cbs cplusg wral cmnd submrcl 3ad2ant1 eqid submss 3ad2ant2 lsmssv lsmub1x
      c0g simp2 syl2anc subm0cl wceq wb lsmelvalx anbi12d reeanv adantr simprll
      wi simprlr simprrl simprrr simpl3 cntzi simpl1 submcl lsmelvalix syl32anc
      mnd4g simpl2 eqeltrrd oveq12 eleq1d syl5ibrcom anassrs rexlimdvva syl5bir
      sylbid ralrimivv issubm syl mpbir3and ) BDUCLZMZCWKMZBCELZNZUDZBCAOZWKMZW
      QDUELZNZDUPLZWQMZUAPZUBPZDUFLZOZWQMZUBWQUGUAWQUGZWPDUHMZBWSNZCWSNZWTWLWMX
      IWOBDUIUJZWLWMXJWOWSBDWSUKZULUJZWMWLXKWOWSCDXMULUMZWSABCDXMFUNQWPBWQXAWPX
      JWMBWQNXNWLWMWOUQWSABCDXMFUOURWLWMXABMWOBDXAXAUKZUSUJRWPXGUAUBWQWQWPXCWQM
      ZXDWQMZSXCHPZIPZXEOZUTZICTZHBTZXDJPZKPZXEOZUTZKCTZJBTZSZXGWPXQYDXRYJWPXIX
      JXKXQYDVAXLXNXOHIWSXEABCDUHXCXMXEUKZFVBQWPXIXJXKXRYJVAXLXNXOJKWSXEABCDUHX
      DXMYLFVBQVCYKYCYISZJBTHBTWPXGYCYIHJBBVDWPYMXGHJBBYMYBYHSZKCTICTWPXSBMZYEB
      MZSZSZXGYBYHIKCCVDYRYNXGIKCCWPYQXTCMZYFCMZSZYNXGVGWPYQUUASZSZXGYNYAYGXEOZ
      WQMUUCXSYEXEOZXTYFXEOZXEOZUUDWQUUCWSXEDYFXSYEXTXMYLWPXIUUBXLVEZUUCBWSXSWP
      XJUUBXNVEZWPYOYPUUAVFZRUUCBWSYEUUIWPYOYPUUAVHZRUUCCWSXTWPXKUUBXOVEZWPYQYS
      YTVIZRUUCCWSYFUULWPYQYSYTVJZRUUCYEWNMYSYEXTXEOXTYEXEOUTUUCBWNYEWLWMWOUUBV
      KUUKRUUMXECDYEXTEYLGVLURVQUUCXIXJXKUUEBMZUUFCMZUUGWQMUUHUUIUULUUCWLYOYPUU
      OWLWMWOUUBVMUUJUUKXEBDXSYEYLVNQUUCWMYSYTUUPWLWMWOUUBVRUUMUUNXECDXTYFYLVNQ
      WSXEABCDUHUUEUUFXMYLFVOVPVSYNXFUUDWQXCYAXDYGXEVTWAWBWCWDWEWDWEWFWGWPXIWRW
      TXBXHUDVAXLUAUBWSXEWQDXAXMXPYLWHWIWJ $.

    $( The sum of two commuting subgroups is a subgroup.  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    lsmsubg $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) /\
        T C_ ( Z ` U ) ) -> ( T .(+) U ) e. ( SubGrp ` G ) ) $=
      ( vx va vb cfv wcel wss co cv syl wceq eqid wa adantr w3a csubmnd cminusg
      csubg wral simp1 subgsubm simp2 simp3 lsmsubm syl3anc cplusg wrex 3adant3
      lsmelval cgrp cbs subgrcl subgss simprl sseldd simprr grpinvadd subginvcl
      wb syl2anc eqtr4d lsmelvali syl22anc eqeltrd eleq1d syl5ibrcom rexlimdvva
      cntzi fveq2 sylbid ralrimiv issubg3 mpbir2and ) BDUDKZLZCVTLZBCEKZMZUAZBC
      ANZVTLZWFDUBKZLZHOZDUCKZKZWFLZHWFUEZWEBWHLZCWHLZWDWIWEWAWOWAWBWDUFZBDUGPW
      EWBWPWAWBWDUHZCDUGPWAWBWDUIZABCDEFGUJUKWEWMHWFWEWJWFLZWJIOZJOZDULKZNZQZJC
      UMIBUMZWMWAWBWTXFVEWDIJXCABCDWJXCRZFUOUNWEXEWMIJBCWEXABLZXBCLZSZSZWMXEXDW
      KKZWFLXKXLXAWKKZXBWKKZXCNZWFXKXLXNXMXCNZXOXKDUPLZXADUQKZLXBXRLXLXPQXKWAXQ
      WEWAXJWQTZBDURZPXKBXRXAXKWABXRMXSXRBDXRRZUSPWEXHXIUTZVAXKCXRXBXKWBCXRMWEW
      BXJWRTZXRCDYAUSPWEXHXIVBZVAXRXCDWKXAXBYAXGWKRZVCUKXKXMWCLXNCLZXOXPQXKBWCX
      MWEWDXJWSTXKWAXHXMBLZXSYBBDWKXAYEVDVFZVAXKWBXIYFYCYDCDWKXBYEVDVFZXCCDXMXN
      EXGGVNVFVGXKWAWBYGYFXOWFLXSYCYHYIXCABCDXMXNXGFVHVIVJXEWLXLWFWJXDWKVOVKVLV
      MVPVQWEXQWGWIWNSVEWEWAXQWQXTPHWFDWKYEVRPVS $.

    $( Subgroup sum commutes.  (Contributed by Mario Carneiro, 22-Apr-2016.) $)
    lsmcom2 $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) /\
        T C_ ( Z ` U ) ) -> ( T .(+) U ) = ( U .(+) T ) ) $=
      ( vx va vb cfv wcel co cv wceq wrex wa wb lsmelval 3adant3 wss w3a cplusg
      csubg simp3 sselda adantrr simprr eqid cntzi syl2anc eqeq2d rexcom syl6bb
      2rexbidva ancoms 3bitr4d eqrdv ) BDUDKZLZCUSLZBCEKZUAZUBZHBCAMZCBAMZVDHNZ
      INZJNZDUCKZMZOZJCPIBPZVGVIVHVJMZOZIBPJCPZVGVELZVGVFLZVDVMVOJCPIBPVPVDVLVO
      IJBCVDVHBLZVICLZQQZVKVNVGWAVHVBLZVTVKVNOVDVSWBVTVDBVBVHUTVAVCUEUFUGVDVSVT
      UHVJCDVHVIEVJUIZGUJUKULUOVOIJBCUMUNUTVAVQVMRVCIJVJABCDVGWCFSTUTVAVRVPRZVC
      VAUTWDJIVJACBDVGWCFSUPTUQUR $.
  $}

  ${
    $d a c x y z .(+) $.  $d a b c x y z G $.  $d a b c x y z R $.
    $d a b c x y z T $.  $d a b c x y z U $.
    lsmub1.p $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum is an upper bound of its arguments.  (Contributed by NM,
       6-Feb-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmub1 $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) ) ->
        T C_ ( T .(+) U ) ) $=
      ( csubg cfv wcel cbs wss csubmnd co eqid subgss subgsubm lsmub1x syl2an )
      BDFGZHBDIGZJCDKGHBBCALJCRHSBDSMZNCDOSABCDTEPQ $.

    $( Subgroup sum is an upper bound of its arguments.  (Contributed by NM,
       6-Feb-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmub2 $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) ) ->
        U C_ ( T .(+) U ) ) $=
      ( csubg cfv wcel csubmnd cbs wss co subgsubm eqid subgss lsmub2x syl2an )
      BDFGZHBDIGHCDJGZKCBCALKCRHBDMSCDSNZOSABCDTEPQ $.

    $( Union of subgroups is a subset of subgroup sum.  (Contributed by NM,
       6-Feb-2014.)  (Proof shortened by Mario Carneiro, 21-Jun-2014.) $)
    lsmunss $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
       -> ( T u. U ) C_ ( T .(+) U ) ) $=
      ( csubg cfv wcel wa co lsmub1 lsmub2 unssd ) BDFGZHCNHIBCBCAJABCDEKABCDEL
      M $.

    $( Subset implies subgroup sum subset.  (Contributed by NM, 6-Feb-2014.)
       (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmless1 $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) /\ S C_ T )
        -> ( S .(+) U ) C_ ( T .(+) U ) ) $=
      ( csubg cfv wcel wss w3a cgrp cbs co subgrcl 3ad2ant1 eqid 3ad2ant2 simp3
      subgss lsmless1x syl31anc ) CEGHZIZDUCIZBCJZKELIZCEMHZJZDUHJZUFBDANCDANJU
      DUEUGUFCEOPUDUEUIUFUHCEUHQZTPUEUDUJUFUHDEUKTRUDUEUFSUHABCDELUKFUAUB $.

    $( Subset implies subgroup sum subset.  (Contributed by NM, 25-Feb-2014.)
       (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmless2 $p |- ( ( S e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) /\ T C_ U )
        -> ( S .(+) T ) C_ ( S .(+) U ) ) $=
      ( csubg cfv wcel wss w3a cgrp cbs co subgrcl 3ad2ant1 eqid 3ad2ant2 simp3
      subgss lsmless2x syl31anc ) BEGHZIZDUCIZCDJZKELIZBEMHZJZDUHJZUFBCANBDANJU
      DUEUGUFBEOPUDUEUIUFUHBEUHQZTPUEUDUJUFUHDEUKTRUDUEUFSUHABCDELUKFUAUB $.

    $( Subset implies subgroup sum subset.  (Contributed by NM, 14-Jan-2015.)
       (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmless12 $p |- ( ( ( S e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
             /\ ( R C_ S /\ T C_ U ) ) -> ( R .(+) T ) C_ ( S .(+) U ) ) $=
      ( csubg cfv wcel wa wss co cgrp cbs subgrcl ad2antrr eqid subgss sstrd
      simprr ad2antlr simprl lsmless1x syl31anc simpll simplr lsmless2 syl3anc
      ) CFHIZJZEUJJZKZBCLZDELZKZKZBDAMZCDAMZCEAMZUQFNJZCFOIZLZDVBLUNURUSLUKVAUL
      UPCFPQUKVCULUPVBCFVBRZSQUQDEVBUMUNUOUAZULEVBLUKUPVBEFVDSUBTUMUNUOUCVBABCD
      FNVDGUDUEUQUKULUOUSUTLUKULUPUFUKULUPUGVEACDEFGUHUIT $.

    $( Subgroup sum is idempotent.  (Contributed by NM, 6-Feb-2014.)  (Revised
       by Mario Carneiro, 21-Jun-2014.) $)
    lsmidm $p |- ( U e. ( SubGrp ` G ) -> ( U .(+) U ) = U ) $=
      ( vx vy csubg cfv wcel co cplusg cmpt2 crn wceq cbs eqid anidms wss wral
      cv lsmval cxp wf subgcl 3expb ralrimivva fmpt2 sylib frn syl lsmub1 eqssd
      eqsstrd ) BCGHIZBBAJZBUNUOEFBBETZFTZCKHZJZLZMZBUNUOVANEFCOHZURABBCVBPURPZ
      DUAQUNBBUBZBUTUCZVABRUNUSBIZFBSEBSVEUNVFEFBBUNUPBIUQBIVFURBCUPUQVCUDUEUFE
      FBBUSBUTUTPUGUHVDBUTUIUJUMUNBUORABBCDUKQUL $.

    $( The least upper bound property of subgroup sum.  (Contributed by NM,
       6-Feb-2014.)  (Revised by Mario Carneiro, 21-Jun-2014.) $)
    lsmlub $p |- ( ( S e. ( SubGrp ` G ) /\ T e. ( SubGrp ` G ) /\
                     U e. ( SubGrp ` G ) ) ->
      ( ( S C_ U /\ T C_ U ) <-> ( S .(+) T ) C_ U ) ) $=
      ( csubg cfv wcel w3a wss wa co wi simp3 lsmless12 ex 3adant3 sstr2 syl
      syl2anc wceq lsmidm 3ad2ant3 sseq2d sylibd lsmub1 lsmub2 jcad impbid ) BE
      GHZIZCUKIZDUKIZJZBDKZCDKZLZBCAMZDKZUOURUSDDAMZKZUTUOUNUNURVBNULUMUNOZVCUN
      UNLURVBABDCDEFPQUAUOVADUSUNULVADUBUMADEFUCUDUEUFUOUTUPUQUOBUSKZUTUPNULUMV
      DUNABCEFUGRBUSDSTUOCUSKZUTUQNULUMVEUNABCEFUHRCUSDSTUIUJ $.

    $( Subgroup sum with a subset.  (Contributed by NM, 27-Mar-2014.)  (Revised
       by Mario Carneiro, 19-Apr-2016.) $)
    lsmss1 $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) /\ T C_ U )
            -> ( T .(+) U ) = U ) $=
      ( csubg cfv wcel wss w3a co wa ssid wb lsmlub biimpd mpan2i 3impia lsmub2
      3anidm23 3adant3 eqssd ) BDFGZHZCUCHZBCIZJBCAKZCUDUEUFUGCIZUDUELZUFCCIZUH
      CMUIUFUJLZUHUDUEUKUHNABCCDEOTPQRUDUECUGIUFABCDESUAUB $.

    $( Subgroup sum with a subset.  (Contributed by NM, 10-Jan-2015.)  (Revised
       by Mario Carneiro, 19-Apr-2016.) $)
    lsmss1b $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
         -> ( T C_ U <-> ( T .(+) U ) = U ) ) $=
      ( csubg cfv wcel wa wss wceq lsmss1 3expia lsmub1 sseq2 syl5ibcom impbid
      co ) BDFGZHZCSHZIZBCJZBCARZCKZTUAUCUEABCDELMUBBUDJUEUCABCDENUDCBOPQ $.

    $( Subgroup sum with a subset.  (Contributed by NM, 27-Mar-2014.)  (Revised
       by Mario Carneiro, 19-Apr-2016.) $)
    lsmss2 $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) /\ U C_ T )
          -> ( T .(+) U ) = T ) $=
      ( csubg cfv wcel wss w3a co wa lsmlub 3anidm13 biimpd mpani 3impia lsmub1
      ssid wb 3adant3 eqssd ) BDFGZHZCUCHZCBIZJBCAKZBUDUEUFUGBIZUDUELZBBIZUFUHB
      SUIUJUFLZUHUDUEUKUHTABCBDEMNOPQUDUEBUGIUFABCDERUAUB $.

    $( Subgroup sum with a subset.  (Contributed by NM, 10-Jan-2015.)  (Revised
       by Mario Carneiro, 19-Apr-2016.) $)
    lsmss2b $p |- ( ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
         -> ( U C_ T <-> ( T .(+) U ) = T ) ) $=
      ( csubg cfv wcel wa wss wceq lsmss2 3expia lsmub2 sseq2 syl5ibcom impbid
      co ) BDFGZHZCSHZIZCBJZBCARZBKZTUAUCUEABCDELMUBCUDJUEUCABCDENUDBCOPQ $.

    $( Subgroup sum is associative.  (Contributed by NM, 2-Mar-2014.)  (Revised
       by Mario Carneiro, 19-Apr-2016.) $)
    lsmass $p |- ( ( R e. ( SubGrp ` G ) /\ T e. ( SubGrp ` G ) /\
                     U e. ( SubGrp ` G ) ) ->
                   ( ( R .(+) T ) .(+) U ) = ( R .(+) ( T .(+) U ) ) ) $=
      ( vy vc va vz vb wcel co cv wceq wrex eqid cvv wb wss vx csubg cfv cplusg
      w3a cmpt2 crn cbs lsmval 3adant3 rexeqdv wral rgen2w oveq1 eqeq2d rexbidv
      ovex rexrnmpt2 ax-mp syl6bb wa 3adant1 oveq2 adantr cgrp subgrcl 3ad2ant1
      ad2antrr subgss simplr sseldd 3ad2ant2 simprl 3ad2ant3 syl13anc 2rexbidva
      simprr grpass bitr4d rexbidva grpmnd syl lsmssv syl3anc lsmelvalx 3bitr4d
      cmnd eqrdv ) BEUBUCZLZCWILZDWILZUEZUABCAMZDAMZBCDAMZAMZWMUANZGNZHNZEUDUCZ
      MZOZHDPZGWNPZWRINZJNZXAMZOZJWPPZIBPZWRWOLZWRWQLZWMXEWRXFKNZXAMZWTXAMZOZHD
      PZKCPZIBPZXKWMXEXDGIKBCXOUFZUGZPZXTWMXDGWNYBWJWKWNYBOWLIKEUHUCZXAABCEYDQZ
      XAQZFUIUJUKXORLZKCULIBULYCXTSYGIKBCXFXNXAUQUMXDXRIKGBCXOYARYAQWSXOOZXCXQH
      DYHXBXPWRWSXOWTXAUNUOUPURUSUTWMXJXSIBWMXFBLZVAZXJWRXFXNWTXAMZXAMZOZHDPKCP
      ZXSWMXJYNSYIWMXJXIJKHCDYKUFZUGZPZYNWMXIJWPYPWKWLWPYPOWJKHYDXAACDEYEYFFUIV
      BUKYKRLZHDULKCULYQYNSYRKHCDXNWTXAUQUMXIYMKHJCDYKYORYOQXGYKOXHYLWRXGYKXFXA
      VCUOURUSUTVDYJXQYMKHCDYJXNCLZWTDLZVAZVAZXPYLWRUUBEVELZXFYDLXNYDLWTYDLXPYL
      OWMUUCYIUUAWJWKUUCWLBEVFVGZVHUUBBYDXFWMBYDTZYIUUAWJWKUUEWLYDBEYEVIVGZVHWM
      YIUUAVJVKUUBCYDXNWMCYDTZYIUUAWKWJUUGWLYDCEYEVIVLZVHYJYSYTVMVKUUBDYDWTWMDY
      DTZYIUUAWLWJUUIWKYDDEYEVIVNZVHYJYSYTVQVKYDXAEXFXNWTYEYFVRVOUOVPVSVTVSWMUU
      CWNYDTZUUIXLXESUUDWMEWGLZUUEUUGUUKWMUUCUULUUDEWAWBZUUFUUHYDABCEYEFWCWDUUJ
      GHYDXAAWNDEVEWRYEYFFWEWDWMUUCUUEWPYDTZXMXKSUUDUUFWMUULUUGUUIUUNUUMUUHUUJY
      DACDEYEFWCWDIJYDXAABWPEVEWRYEYFFWEWDWFWH $.
  $}

  ${
    lsm01.z $e |- .0. = ( 0g ` G ) $.
    lsm01.p $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum with the zero subgroup.  (Contributed by NM, 27-Mar-2014.)
       (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsm01 $p |- ( X e. ( SubGrp ` G ) -> ( X .(+) { .0. } ) = X ) $=
      ( csubg cfv wcel csn wss wceq cgrp subgrcl 0subg syl subg0cl snssd lsmss2
      co mpd3an23 ) CBGHZIZDJZUBIZUDCKCUDATCLUCBMIUECBNBDEOPUCDCCBDEQRACUDBFSUA
      $.

    $( Subgroup sum with the zero subgroup.  (Contributed by NM, 27-Mar-2014.)
       (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsm02 $p |- ( X e. ( SubGrp ` G ) -> ( { .0. } .(+) X ) = X ) $=
      ( csubg cfv wcel csn wss co wceq cgrp subgrcl 0subg syl id subg0cl snssd
      lsmss1 syl3anc ) CBGHZIZDJZUCIZUDUECKUECALCMUDBNIUFCBOBDEPQUDRUDDCCBDESTA
      UECBFUAUB $.
  $}

  ${
    $d x y G $.  $d x y H $.  $d x y S $.  $d x y T $.  $d x y U $.
    subglsm.h $e |- H = ( G |`s S ) $.
    subglsm.s $e |- .(+) = ( LSSum ` G ) $.
    subglsm.a $e |- A = ( LSSum ` H ) $.
    $( The subgroup sum evaluated within a subgroup.  (Contributed by Mario
       Carneiro, 27-Apr-2016.) $)
    subglsm $p |- ( ( S e. ( SubGrp ` G ) /\ T C_ S /\ U C_ S ) ->
        ( T .(+) U ) = ( T A U ) ) $=
      ( vx vy cfv wcel wss co wceq eqid cgrp 3ad2ant1 csubg w3a cv cplusg cmpt2
      crn simp11 ressplusg syl oveqd mpt2eq3dva rneqd subgrcl simp2 sstrd simp3
      cbs subgss lsmvalx syl3anc subggrp subgbas sseqtrd 3eqtr4d ) CFUAMZNZDCOZ
      ECOZUBZKLDEKUCZLUCZFUDMZPZUEZUFZKLDEVJVKGUDMZPZUEZUFZDEBPZDEAPZVIVNVRVIKL
      DEVMVQVIVJDNZVKENZUBZVLVPVJVKWDVFVLVPQVFVGVHWBWCUGCVLFGVEHVLRZUHUIUJUKULV
      IFSNZDFUQMZOEWGOVTVOQVFVGWFVHCFUMTVIDCWGVFVGVHUNZVFVGCWGOVHWGCFWGRZURTZUO
      VIECWGVFVGVHUPZWJUOKLWGVLBDEFSWIWEIUSUTVIGSNZDGUQMZOEWMOWAVSQVFVGWLVHCFGH
      VATVIDCWMWHVFVGCWMQVHCFGHVBTZVCVIECWMWKWNVCKLWMVPADEGSWMRVPRJUSUTVD $.
  $}

  ${
    lssnle.p $e |- .(+) = ( LSSum ` G ) $.
    lssnle.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    lssnle.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    $( Equivalent expressions for "not less than".  ( ~ chnlei analog.)
       (Contributed by NM, 10-Jan-2015.)  (Revised by Mario Carneiro,
       19-Apr-2016.) $)
    lssnle $p |- ( ph -> ( -. U C_ T <-> T C. ( T .(+) U ) ) ) $=
      ( wss wn co wne wpss wceq csubg cfv wcel wb lsmss2b syl2anc syl6bb lsmub1
      eqcom necon3bbid df-pss baib syl bitr4d ) ADCIZJCCDBKZLZCUJMZAUICUJAUIUJC
      NZCUJNACEOPZQZDUNQZUIUMRGHBCDEFSTUJCUCUAUDACUJIZULUKRAUOUPUQGHBCDEFUBTULU
      QUKCUJUEUFUGUH $.
  $}

  ${
    $d x y z .(+) $.  $d x y z G $.  $d x y z S $.  $d x y z T $.
    $d x y z U $.
    lsmmod.p $e |- .(+) = ( LSSum ` G ) $.
    $( The modular law holds for subgroup sum.  Similar to part of Theorem 16.9
       of [MaedaMaeda] p. 70.  (Contributed by NM, 2-Apr-2014.)  (Revised by
       Mario Carneiro, 19-Apr-2016.) $)
    lsmmod $p |- ( ( ( S e. ( SubGrp ` G ) /\ T e. ( SubGrp ` G ) /\
                       U e. ( SubGrp ` G ) ) /\ S C_ U ) ->
      ( S .(+) ( T i^i U ) ) = ( ( S .(+) T ) i^i U ) ) $=
      ( vy vz cfv wcel wss wa co syl3anc eqid cv wceq syl2anc adantr sseldd w3a
      csubg cin simpl1 simpl2 inss1 a1i lsmless2 simpr inss2 cbs cmre cgrp cacs
      vx subgrcl subgacs acsmre 4syl simpl3 mreincl lsmlub mpbi2and elin cplusg
      ssind wrex lsmelval simprll simprlr cminusg c0g syl subgss grplinv oveq1d
      subginvcl simpll2 grpass syl13anc grplid 3eqtr3d simprr eqeltrrd sylanbrc
      wb wi subgcl lsmelvali syl22anc expr imbi12d syl5ibrcom rexlimdvva sylbid
      eleq1 imp3a syl5bi ssrdv eqssd ) BEUBIZJZCXAJZDXAJZUAZBDKZLZBCDUCZAMZBCAM
      ZDUCZXGXIXJDXGXBXCXHCKZXIXJKXBXCXDXFUDZXBXCXDXFUEZXLXGCDUFUGABXHCEFUHNXGX
      FXHDKZXIDKZXEXFUIZXOXGCDUJUGXGXBXHXAJZXDXFXOLXPWFXMXGXAEUKIZULIJZXCXDXRXG
      XBEUMJZXAXSUNIJXTXMBEUPZXSEXSOZUQXAXSURUSXNXBXCXDXFUTZCDXAXSVANZYDABXHDEF
      VBNVCVFXGUOXKXIUOPZXKJYFXJJZYFDJZLXGYFXIJZYFXJDVDXGYGYHYIXGYGYFGPZHPZEVEI
      ZMZQZHCVGGBVGZYHYIWGZXGXBXCYGYOWFXMXNGHYLABCEYFYLOZFVHRXGYNYPGHBCXGYJBJZY
      KCJZLZLYPYNYMDJZYMXIJZWGXGYTUUAUUBXGYTUUALZLZXBXRYRYKXHJZUUBXGXBUUCXMSZXG
      XRUUCYESXGYRYSUUAVIZUUDYSYKDJUUEXGYRYSUUAVJZUUDYJEVKIZIZYMYLMZYKDUUDUUJYJ
      YLMZYKYLMZEVLIZYKYLMZUUKYKUUDUULUUNYKYLUUDYAYJXSJZUULUUNQUUDXBYAUUFYBVMZU
      UDDXSYJUUDXDDXSKXGXDUUCYDSZXSDEYCVNVMZUUDBDYJXGXFUUCXQSUUGTZTZXSYLEUUIYJU
      UNYCYQUUNOZUUIOZVORVPUUDYAUUJXSJUUPYKXSJZUUMUUKQUUQUUDDXSUUJUUSUUDXDYJDJU
      UJDJZUURUUTDEUUIYJUVCVQRZTUVAUUDCXSYKUUDXCCXSKXBXCXDXFUUCVRXSCEYCVNVMUUHT
      ZXSYLEUUJYJYKYCYQVSVTUUDYAUVDUUOYKQUUQUVGXSYLEYKUUNYCYQUVBWARWBUUDXDUVEUU
      AUUKDJUURUVFXGYTUUAWCYLDEUUJYMYQWHNWDYKCDVDWEYLABXHEYJYKYQFWIWJWKYNYHUUAY
      IUUBYFYMDWPYFYMXIWPWLWMWNWOWQWRWSWT $.

    $( Modular law dual for subgroup sum.  Similar to part of Theorem 16.9 of
       [MaedaMaeda] p. 70.  (Contributed by NM, 8-Jan-2015.)  (Revised by Mario
       Carneiro, 21-Apr-2016.) $)
    lsmmod2 $p |- ( ( ( S e. ( SubGrp ` G ) /\ T e. ( SubGrp ` G ) /\
                        U e. ( SubGrp ` G ) ) /\ U C_ S ) ->
                    ( S i^i ( T .(+) U ) ) = ( ( S i^i T ) .(+) U ) ) $=
      ( csubg cfv wcel w3a wss wa coppg cin eqid syl6eleq incom 3eqtr3g oppglsm
      co clsm simpl3 oppgsubg simpl2 simpl1 simpr lsmmod syl31anc eqcomd oveq2i
      wceq ineq2i ) BEGHZIZCUMIZDUMIZJZDBKZLZBDCEMHZUAHZTZNZDBCNZVATZBCDATZNVDD
      ATUSVBBNZDCBNZVATZVCVEUSVIVGUSDUTGHZICVJIBVJIURVIVGUKUSDUMVJUNUOUPURUBEUT
      UTOZUCZPUSCUMVJUNUOUPURUDVLPUSBUMVJUNUOUPURUEVLPUQURUFVADCBUTVAOUGUHUIVBB
      QVHVDDVACBQUJRVBVFBADCEUTVKFSULADVDEUTVKFSR $.
  $}

  ${
    $d t u x y z B $.  $d t u x y z K $.  $d t u x y z L $.  $d t u x y z ph $.
    lsmpropd.b1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lsmpropd.b2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lsmpropd.p $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lsmpropd.v1 $e |- ( ph -> K e. _V ) $.
    lsmpropd.v2 $e |- ( ph -> L e. _V ) $.
    $( If two structures have the same components (properties), they have the
       same subspace structure.  (Contributed by Mario Carneiro,
       29-Jun-2015.) $)
    lsmpropd $p |- ( ph -> ( LSSum ` K ) = ( LSSum ` L ) ) $=
      ( vt vu cfv cv cmpt2 wcel wceq cvv eqid cbs cpw cplusg co crn clsm simp11
      w3a simp12 elpwid simp2 sseldd simp13 simp3 syl12anc rneqd pweqd mpt2eq12
      mpt2eq3dva syl2anc 3eqtr3d lsmfval syl 3eqtr4d ) ALMEUANZUBZVFBCLOZMOZBOZ
      COZEUCNZUDZPZUEZPZLMFUANZUBZVQBCVGVHVIVJFUCNZUDZPZUEZPZEUFNZFUFNZALMDUBZW
      EVNPZLMWEWEWAPZVOWBALMWEWEVNWAAVGWEQZVHWEQZUHZVMVTWJBCVGVHVLVSWJVIVGQZVJV
      HQZUHZAVIDQVJDQVLVSRAWHWIWKWLUGWMVGDVIWMVGDAWHWIWKWLUIUJWJWKWLUKULWMVHDVJ
      WMVHDAWHWIWKWLUMUJWJWKWLUNULIUOUSUPUSAWEVFRZWNWFVORADVEGUQZWOLMWEWEVFVFVN
      URUTAWEVQRZWPWGWBRADVPHUQZWQLMWEWEVQVQWAURUTVAAESQWCVORJBCMLVEVKWCESVETVK
      TWCTVBVCAFSQWDWBRKBCMLVPVRWDFSVPTVRTWDTVBVCVD $.
  $}

  ${
    cntzrecd.z $e |- Z = ( Cntz ` G ) $.
    cntzrecd.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    cntzrecd.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    cntzrecd.s $e |- ( ph -> T C_ ( Z ` U ) ) $.
    $( Commute the "subgroups commute" predicate.  (Contributed by Mario
       Carneiro, 21-Apr-2016.) $)
    cntzrecd $p |- ( ph -> U C_ ( Z ` T ) ) $=
      ( cfv wss csubg wcel wb cbs eqid subgss cntzrec syl2an syl2anc mpbid ) AB
      CEJKZCBEJKZIABDLJZMZCUDMZUBUCNZGHUEBDOJZKCUHKUGUFUHBDUHPZQUHCDUIQUHBCDEUI
      FRSTUA $.
  $}

  ${
    $d x .(+) $.  $d s u x .0. $.  $d s u x ph $.  $d s u x S $.  $d s u x T $.
    $d s u G $.  $d s u x U $.
    lsmcntz.p $e |- .(+) = ( LSSum ` G ) $.
    lsmcntz.s $e |- ( ph -> S e. ( SubGrp ` G ) ) $.
    lsmcntz.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    lsmcntz.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    ${
      lsmcntz.z $e |- Z = ( Cntz ` G ) $.
      $( The "subgroups commute" predicate applied to a subgroup sum.
         (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      lsmcntz $p |- ( ph -> ( ( S .(+) T ) C_ ( Z ` U ) <->
        ( S C_ ( Z ` U ) /\ T C_ ( Z ` U ) ) ) ) $=
        ( cfv wss wa co csubg wcel wb cgrp subgrcl eqid subgss cntzsubg syl2anc
        cbs syl lsmlub syl3anc bicomd ) ACEGMZNDUKNOZCDBPUKNZACFQMZRDUNRUKUNRZU
        LUMSIJAEUNRZUOKUPFTREFUFMZNUOEFUAUQEFUQUBZUCUQEFGURLUDUEUGBCDUKFHUHUIUJ
        $.

      $( The "subgroups commute" predicate applied to a subgroup sum.
         (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      lsmcntzr $p |- ( ph -> ( S C_ ( Z ` ( T .(+) U ) ) <->
        ( S C_ ( Z ` T ) /\ S C_ ( Z ` U ) ) ) ) $=
        ( cfv wss wb wcel subgss syl cntzrec syl2anc co lsmcntz cmnd csubg cgrp
        wa cbs subgrcl grpmnd 3syl eqid lsmssv syl3anc anbi12d 3bitr3d ) ADEBUA
        ZCGMZNZDUQNZEUQNZUFCUPGMNZCDGMNZCEGMNZUFABDECFGHJKILUBAUPFUGMZNZCVDNZUR
        VAOAFUCPZDVDNZEVDNZVEACFUDMZPZFUEPVGICFUHFUIUJADVJPVHJVDDFVDUKZQRZAEVJP
        VIKVDEFVLQRZVDBDEFVLHULUMAVKVFIVDCFVLQRZVDUPCFGVLLSTAUSVBUTVCAVHVFUSVBO
        VMVOVDDCFGVLLSTAVIVFUTVCOVNVOVDECFGVLLSTUNUO $.
    $}

    lsmdisj.o $e |- .0. = ( 0g ` G ) $.
    ${
      lsmdisj.i $e |- ( ph -> ( ( S .(+) T ) i^i U ) = { .0. } ) $.
      $( Disjointness from a subgroup sum.  (Contributed by Mario Carneiro,
         21-Apr-2016.) $)
      lsmdisj $p |- ( ph ->
        ( ( S i^i U ) = { .0. } /\ ( T i^i U ) = { .0. } ) ) $=
        ( cin wceq wss wcel syl2anc syl subg0cl csn co csubg cfv lsmub1 sseqtrd
        ssrin elin sylanbrc snssd eqssd lsmub2 jca ) ACENZGUAZODENZUOOAUNUOAUNC
        DBUBZENZUOACUQPZUNURPACFUCUDZQZDUTQZUSIJBCDFHUERCUQEUGSMUFAGUNAGCQZGEQZ
        GUNQAVAVCICFGLTSAEUTQVDKEFGLTSZGCEUHUIUJUKAUPUOAUPURUOADUQPZUPURPAVAVBV
        FIJBCDFHULRDUQEUGSMUFAGUPAGDQZVDGUPQAVBVGJDFGLTSVEGDEUHUIUJUKUM $.

      lsmdisj2.i $e |- ( ph -> ( S i^i T ) = { .0. } ) $.
      $( Association of the disjointness constraint in a subgroup sum.
         (Contributed by Mario Carneiro, 22-Apr-2016.) $)
      lsmdisj2 $p |- ( ph -> ( T i^i ( S .(+) U ) ) = { .0. } ) $=
        ( co wcel wceq syl2anc syl ad2antrr vx vs vu cin csn cv cplusg cfv wrex
        wa wi csubg wb eqid lsmelval simplrl cminusg cgrp subgrcl subgss sseldd
        cbs wss grplinv oveq1d subginvcl simplrr grpass syl13anc grplid 3eqtr3d
        simpr syl22anc eqeltrrd elin sylanbrc eleqtrd elsni oveq2d grprid eqtrd
        lsmelvali oveq12d grpidcl ex eleq1 imbi12d syl5ibrcom rexlimdvva sylbid
        eqeq1 com23 imp3a elsn 3imtr4g ssrdv subg0cl lsmub1 snssd eqssd ) ADCEB
        OZUDZGUEZAUAXBXCAUAUFZDPZXDXAPZUJXDGQZXDXBPXDXCPAXEXFXGAXFXEXGAXFXDUBUF
        ZUCUFZFUGUHZOZQZUCEUIUBCUIZXEXGUKZACFULUHZPZEXOPZXFXMUMIKUBUCXJBCEFXDXJ
        UNZHUORAXLXNUBUCCEAXHCPZXIEPZUJZUJZXNXLXKDPZXKGQZUKYBYCYDYBYCUJZXKGGXJO
        ZGYEXHGXIGXJYEXHXCPXHGQYEXHCDUDZXCYEXSXHDPXHYGPAXSXTYCUPZYEXKXHDYEXKXHG
        XJOZXHYEXIGXHXJYEXIXCPXIGQYEXICDBOZEUDZXCYEXIYJPXTXIYKPYEXHFUQUHZUHZXKX
        JOZXIYJYEYMXHXJOZXIXJOZGXIXJOZYNXIYEYOGXIXJYEFURPZXHFVBUHZPZYOGQAYRYAYC
        AXPYRICFUSSZTZYECYSXHYEXPCYSVCAXPYAYCITZYSCFYSUNZUTSZYHVAZYSXJFYLXHGUUD
        XRLYLUNZVDRVEYEYRYMYSPYTXIYSPZYPYNQUUBYECYSYMUUEYEXPXSYMCPZUUCYHCFYLXHU
        UGVFRZVAUUFYEEYSXIYEXQEYSVCAXQYAYCKTYSEFUUDUTSAXSXTYCVGZVAZYSXJFYMXHXIU
        UDXRVHVIYEYRUUHYQXIQUUBUULYSXJFXIGUUDXRLVJRVKYEXPDXOPZUUIYCYNYJPUUCAUUM
        YAYCJTUUJYBYCVLZXJBCDFYMXKXRHWBVMVNUUKXIYJEVOVPAYKXCQYAYCMTVQXIGVRSZVSY
        EYRYTYIXHQUUBUUFYSXJFXHGUUDXRLVTRWAUUNVNXHCDVOVPAYGXCQYAYCNTVQXHGVRSUUO
        WCAYFGQZYAYCAYRGYSPZUUPUUAAYRUUQUUAYSFGUUDLWDSYSXJFGGUUDXRLVJRTWAWEXLXE
        YCXGYDXDXKDWFXDXKGWKWGWHWIWJWLWMXDDXAVOUAGWNWOWPAGXBAGDPZGXAPGXBPAUUMUU
        RJDFGLWQSACXAGAXPXQCXAVCIKBCEFHWRRAXPGCPICFGLWQSVAGDXAVOVPWSWT $.

      lsmdisj3.z $e |- Z = ( Cntz ` G ) $.
      lsmdisj3.s $e |- ( ph -> S C_ ( Z ` T ) ) $.
      $( Association of the disjointness constraint in a subgroup sum.
         (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      lsmdisj3 $p |- ( ph -> ( S i^i ( T .(+) U ) ) = { .0. } ) $=
        ( co cin cfv csn csubg wcel wss wceq lsmcom2 ineq1d eqtr3d incom syl5eq
        syl3anc lsmdisj2 ) ABDCEFGIKJLMACDBRZESDCBRZESGUAZAUMUNEACFUBTZUCDUPUCC
        DHTUDUMUNUEJKQBCDFHIPUFUKUGNUHADCSCDSUODCUIOUJUL $.
    $}

    ${
      lsmdisjr.i $e |- ( ph -> ( S i^i ( T .(+) U ) ) = { .0. } ) $.
      $( Disjointness from a subgroup sum.  (Contributed by Mario Carneiro,
         21-Apr-2016.) $)
      lsmdisjr $p |- ( ph ->
        ( ( S i^i T ) = { .0. } /\ ( S i^i U ) = { .0. } ) ) $=
        ( cin csn wceq wa co incom eqeq1i syl5eqr lsmdisj anbi12i sylib ) ADCNZ
        GOZPZECNZUFPZQCDNZUFPZCENZUFPZQABDECFGHJKILADEBRZCNCUNNUFCUNSMUAUBUGUKU
        IUMUEUJUFDCSTUHULUFECSTUCUD $.

      lsmdisj2r.i $e |- ( ph -> ( T i^i U ) = { .0. } ) $.
      $( Association of the disjointness constraint in a subgroup sum.
         (Contributed by Mario Carneiro, 22-Apr-2016.) $)
      lsmdisj2r $p |- ( ph -> ( ( S .(+) U ) i^i T ) = { .0. } ) $=
        ( co cin cfv eqid incom syl6eleq coppg clsm csn oppglsm ineq2i oppgsubg
        eqtri csubg oppgid ineq1i syl5eq syl5eqr lsmdisj2 ) ACEBOZDPZDECFUAQZUB
        QZOZPZGUCZUSDUNPUOURUNDBECFUPUPRZHUDUEDUNSUGAUQEDCUPGUQRAEFUHQZUPUHQZKF
        UPVAUFZTADVBVCJVDTACVBVCIVDTFUPGVALUIAEDUQOZCPZCDEBOZPZUTVFVGCPVHVEVGCB
        EDFUPVAHUDUJVGCSUGMUKAEDPDEPUTDESNULUMUL $.

      lsmdisj3r.z $e |- Z = ( Cntz ` G ) $.
      lsmdisj3r.s $e |- ( ph -> T C_ ( Z ` U ) ) $.
      $( Association of the disjointness constraint in a subgroup sum.
         (Contributed by Mario Carneiro, 22-Apr-2016.) $)
      lsmdisj3r $p |- ( ph -> ( ( S .(+) T ) i^i U ) = { .0. } ) $=
        ( co cin cfv csn csubg wcel wss wceq lsmcom2 ineq2d eqtr3d incom syl5eq
        syl3anc lsmdisj2r ) ABCEDFGIJLKMACDEBRZSCEDBRZSGUAZAUMUNCADFUBTZUCEUPUC
        DEHTUDUMUNUEKLQBDEFHIPUFUKUGNUHAEDSDESUOEDUIOUJUL $.
    $}

    $( Association of the disjointness constraint in a subgroup sum.
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    lsmdisj2a $p |- ( ph ->
      ( ( ( ( S .(+) T ) i^i U ) = { .0. } /\ ( S i^i T ) = { .0. } ) <->
        ( ( T i^i ( S .(+) U ) ) = { .0. } /\ ( S i^i U ) = { .0. } ) ) ) $=
      ( co cin wceq wa wcel adantr incom syl5eq csn csubg simprl simprr lsmdisj
      cfv lsmdisj2 simpld jca lsmdisjr impbida ) ACDBMZENZGUAZOZCDNZUNOZPZDCEBM
      ZNZUNOZCENUNOZPZAURPZVAVBVDBCDEFGHACFUBUFZQZURIRZADVEQZURJRZAEVEQZURKRZLA
      UOUQUCZAUOUQUDUGVDVBDENUNOZVDBCDEFGHVGVIVKLVLUEUHUIAVCPZUOUQVNUMEULNUNULE
      SVNBCEDFGHAVFVCIRZAVJVCKRZAVHVCJRZLVNUSDNUTUNUSDSAVAVBUCZTAVAVBUDUGTVNUPD
      CNZUNCDSVNVSUNOVMVNBDCEFGHVQVOVPLVRUJUHTUIUK $.

    $( Association of the disjointness constraint in a subgroup sum.
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    lsmdisj2b $p |- ( ph ->
      ( ( ( ( S .(+) U ) i^i T ) = { .0. } /\ ( S i^i U ) = { .0. } ) <->
        ( ( S i^i ( T .(+) U ) ) = { .0. } /\ ( T i^i U ) = { .0. } ) ) ) $=
      ( co cin wceq wa incom wcel adantr syl5eq csn cfv simprl simprr lsmdisj2r
      csubg lsmdisj simprd jca lsmdisjr impbida ) ACEBMZDNZGUAZOZCENUNOZPZCDEBM
      ZNZUNOZDENZUNOZPZAUQPZUTVBVDUSURCNUNCURQVDBDCEFGHADFUFUBZRZUQJSZACVERZUQI
      SZAEVERZUQKSZLVDDULNUMUNDULQAUOUPUCZTAUOUPUDUETVDVAEDNZUNDEQVDCDNUNOZVMUN
      OVDBCEDFGHVIVKVGLVLUGUHTUIAVCPZUOUPVOBCDEFGHAVHVCISZAVFVCJSZAVJVCKSZLAUTV
      BUCZAUTVBUDUEVOVNUPVOBCDEFGHVPVQVRLVSUJUHUIUK $.

    lsmdisj3b.z $e |- Z = ( Cntz ` G ) $.
    ${
      lsmdisj3a.2 $e |- ( ph -> S C_ ( Z ` T ) ) $.
      $( Association of the disjointness constraint in a subgroup sum.
         (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      lsmdisj3a $p |- ( ph ->
        ( ( ( ( S .(+) T ) i^i U ) = { .0. } /\ ( S i^i T ) = { .0. } ) <->
          ( ( S i^i ( T .(+) U ) ) = { .0. } /\ ( T i^i U ) = { .0. } ) ) ) $=
        ( co cin wceq wa cfv csn csubg wcel lsmcom2 syl3anc ineq1d eqeq1d incom
        wss a1i anbi12d lsmdisj2a bitrd ) ACDBPZEQZGUAZRZCDQZUPRZSDCBPZEQZUPRZD
        CQZUPRZSCDEBPQUPRDEQUPRSAUQVBUSVDAUOVAUPAUNUTEACFUBTZUCDVEUCCDHTUIUNUTR
        JKOBCDFHINUDUEUFUGAURVCUPURVCRACDUHUJUGUKABDCEFGIKJLMULUM $.
    $}

    ${
      lsmdisj3b.2 $e |- ( ph -> T C_ ( Z ` U ) ) $.
      $( Association of the disjointness constraint in a subgroup sum.
         (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      lsmdisj3b $p |- ( ph ->
        ( ( ( ( S .(+) T ) i^i U ) = { .0. } /\ ( S i^i T ) = { .0. } ) <->
          ( ( S i^i ( T .(+) U ) ) = { .0. } /\ ( T i^i U ) = { .0. } ) ) ) $=
        ( co cin wceq wa cfv csn lsmdisj2b csubg wcel wss lsmcom2 ineq2d eqeq1d
        syl3anc incom a1i anbi12d bitr4d ) ACDBPEQGUAZRCDQUNRSCEDBPZQZUNRZEDQZU
        NRZSCDEBPZQZUNRZDEQZUNRZSABCEDFGIJLKMUBAVBUQVDUSAVAUPUNAUTUOCADFUCTZUDE
        VEUDDEHTUEUTUORKLOBDEFHINUFUIUGUHAVCURUNVCURRADEUJUKUHULUM $.
    $}
  $}

  ${
    subgdisj.p $e |- .+ = ( +g ` G ) $.
    subgdisj.o $e |- .0. = ( 0g ` G ) $.
    subgdisj.z $e |- Z = ( Cntz ` G ) $.
    subgdisj.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    subgdisj.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    subgdisj.i $e |- ( ph -> ( T i^i U ) = { .0. } ) $.
    subgdisj.s $e |- ( ph -> T C_ ( Z ` U ) ) $.
    subgdisj.a $e |- ( ph -> A e. T ) $.
    subgdisj.c $e |- ( ph -> C e. T ) $.
    subgdisj.b $e |- ( ph -> B e. U ) $.
    subgdisj.d $e |- ( ph -> D e. U ) $.
    ${
      subgdisj.j $e |- ( ph -> ( A .+ B ) = ( C .+ D ) ) $.
      $( Vectors belonging to disjoint commuting subgroups are uniquely
         determined by their sum.  (Contributed by NM, 2-Apr-2014.)  (Revised
         by Mario Carneiro, 19-Apr-2016.) $)
      subgdisj1 $p |- ( ph -> A = C ) $=
        ( csg cfv wceq csn wcel cin csubg eqid subgsubcl syl3anc sseldd syl2anc
        cntzi oveq12d cgrp cbs subgrcl syl wss subgss grpcl grpsubsub4 syl13anc
        co eqeltrrd 3eqtr4d grppncan oveq1d eqtrd 3eqtr3d eqeltrd elin sylanbrc
        eleqtrd elsni wb grpsubeq0 mpbid ) ABDIUDUEZVGZJUFZBDUFZAWCJUGZUHWDAWCG
        HUIZWFAWCGUHZWCHUHWCWGUHAGIUJUEZUHZBGUHDGUHWHOSTGIWBBDWBUKZULUMAWCECWBV
        GZHABCFVGZCWBVGZDWBVGZDEFVGZDWBVGZCWBVGZWCWLAWMDCFVGZWBVGZWPCDFVGZWBVGZ
        WOWRAWMWPWSXAWBUCADHKUEZUHZCHUHZWSXAUFAGXCDRTUNZUAFHIDCKLNUPUOUQAIURUHZ
        WMIUSUEZUHZCXHUHZDXHUHZWOWTUFAWJXGOGIUTVAZAXGBXHUHZXJXIXLAGXHBAWJGXHVBO
        XHGIXHUKZVCVAZSUNZAHXHCAHWIUHZHXHVBPXHHIXNVCVAZUAUNZXHFIBCXNLVDUMZXSAGX
        HDXOTUNZXHFIWBWMCDXNLWKVEVFAXGWPXHUHXKXJWRXBUFXLAWMWPXHUCXTVHYAXSXHFIWB
        WPDCXNLWKVEVFVIAWNBDWBAXGXMXJWNBUFXLXPXSXHFIWBBCXNLWKVJUMVKAWQECWBAWQED
        FVGZDWBVGZEAWPYBDWBAXDEHUHZWPYBUFXFUBFHIDEKLNUPUOVKAXGEXHUHXKYCEUFXLAHX
        HEXRUBUNYAXHFIWBEDXNLWKVJUMVLVKVMAXQYDXEWLHUHPUBUAHIWBECWKULUMVNWCGHVOV
        PQVQWCJVRVAAXGXMXKWDWEVSXLXPYAXHIWBBDJXNMWKVTUMWA $.

      $( Vectors belonging to disjoint subgroups are uniquely determined by
         their sum.  (Contributed by NM, 12-Jul-2014.)  (Revised by Mario
         Carneiro, 19-Apr-2016.) $)
      subgdisj2 $p |- ( ph -> B = D ) $=
        ( cin csn incom syl5eqr cntzrecd co cfv wcel wceq cntzi syl2anc 3eqtr3d
        sseldd subgdisj1 ) ACBEDFHGIJKLMNPOAHGUDGHUDJUEGHUFQUGAGHIKNOPRUHUAUBST
        ABCFUIZDEFUIZCBFUIZEDFUIZUCABHKUJZUKCHUKURUTULAGVBBRSUPUAFHIBCKLNUMUNAD
        VBUKEHUKUSVAULAGVBDRTUPUBFHIDEKLNUMUNUOUQ $.
    $}

    $( Vectors belonging to disjoint subgroups are uniquely determined by their
       sum.  Analogous to ~ opth , this theorem shows a way of representing a
       pair of vectors.  (Contributed by NM, 5-Jul-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2016.) $)
    subgdisjb $p |- ( ph ->
        ( ( A .+ B ) = ( C .+ D ) <-> ( A = C /\ B = D ) ) ) $=
      ( co wceq csubg cfv wcel adantr cin csn wss simpr subgdisj1 subgdisj2 jca
      wa ex oveq12 impbid1 ) ABCFUCDEFUCUDZBDUDZCEUDZUPZAUTVCAUTUPZVAVBVDBCDEFG
      HIJKLMNAGIUEUFZUGUTOUHZAHVEUGUTPUHZAGHUIJUJUDUTQUHZAGHKUFUKUTRUHZABGUGUTS
      UHZADGUGUTTUHZACHUGUTUAUHZAEHUGUTUBUHZAUTULZUMVDBCDEFGHIJKLMNVFVGVHVIVJVK
      VLVMVNUNUOUQBDCEFURUS $.
  $}

  ${
    $d g t u z .+ $.  $d g t u x y z B $.  $d t u x y z T $.  $d t u x y z U $.
    $d g t u x y z .(+) $.  $d g t u x y z G $.  $d t u x y z V $.
    $d x y z X $.
    pj1fval.v $e |- B = ( Base ` G ) $.
    pj1fval.a $e |- .+ = ( +g ` G ) $.
    pj1fval.s $e |- .(+) = ( LSSum ` G ) $.
    pj1fval.p $e |- P = ( proj1 ` G ) $.
    $( The left projection function (for a direct product of group subspaces).
       (Contributed by Mario Carneiro, 15-Oct-2015.)  (Revised by Mario
       Carneiro, 21-Apr-2016.) $)
    pj1fval $p |- ( ( G e. V /\ T C_ B /\ U C_ B ) -> ( T P U ) =
      ( z e. ( T .(+) U ) |-> ( iota_ x e. T E. y e. U z = ( x .+ y ) ) ) ) $=
      ( vt vu cv wceq cfv vg wcel wss w3a cpw co wrex crio cmpt cpj1 cmpt2 elex
      cvv 3ad2ant1 cbs clsm cplusg fveq2 syl6eqr pweqd eqeq2d rexbidv riotabidv
      oveqd mpteq12dv mpt2eq123dv df-pj1 fvex eqeltri pwex mpt2ex syl syl5eq wa
      fvmpt oveq12 adantl simprl simprr riotaeqbidv simp2 elpw2 sylibr ovex a1i
      rexeqdv simp3 mptex ovmpt2d ) JKUBZHDUCZIDUCZUDZPQHIDUEZWNCPRZQRZGUFZCRZA
      RZBRZFUFZSZBWPUGZAWOUHZUIZCHIGUFZXBBIUGZAHUHZUIZEUMWMEJUJTZPQWNWNXEUKZOWM
      JUMUBZXJXKSWJWKXLWLJKULUNUAJPQUARZUOTZUEZXOCWOWPXMUPTZUFZWRWSWTXMUQTZUFZS
      ZBWPUGZAWOUHZUIZUKXKUMUJXMJSZPQXOXOYCWNWNXEYDXNDYDXNJUOTZDXMJUOURLUSUTZYF
      YDCXQYBWQXDYDXPGWOWPYDXPJUPTGXMJUPURNUSVDYDYAXCAWOYDXTXBBWPYDXSXAWRYDXRFW
      SWTYDXRJUQTFXMJUQURMUSVDVAVBVCVEVFABCUAQPVGPQWNWNXEDDYEUMLJUOVHVIZVJZYHVK
      VOVLVMWMWOHSZWPISZVNZVNZCWQXDXFXHYKWQXFSWMWOHWPIGVPVQYLXCXGAWOHWMYIYJVRYL
      XBBWPIWMYIYJVSWFVTVEWMWKHWNUBWJWKWLWAHDYGWBWCWMWLIWNUBWJWKWLWGIDYGWBWCXIU
      MUBWMCXFXHHIGWDWHWEWI $.

    $( The left projection function (for a direct product of group subspaces).
       (Contributed by Mario Carneiro, 15-Oct-2015.)  (Revised by Mario
       Carneiro, 21-Apr-2016.) $)
    pj1val $p |- ( ( ( G e. V /\ T C_ B /\ U C_ B ) /\ X e. ( T .(+) U ) ) ->
      ( ( T P U ) ` X ) = ( iota_ x e. T E. y e. U X = ( x .+ y ) ) ) $=
      ( vz wcel co cv wceq wss w3a wa wrex crio cvv pj1fval adantr simpr eqeq1d
      cmpt rexbidv riotabidv riotaex a1i fvmptd ) IJQGCUAHCUAUBZKGHFRZQZUCZPKPS
      ZASBSERZTZBHUDZAGUEZKVBTZBHUDZAGUEZURGHDRZUFUQVIPURVEUKTUSABPCDEFGHIJLMNO
      UGUHUTVAKTZUCZVDVGAGVKVCVFBHVKVAKVBUTVJUIUJULUMUQUSUIVHUFQUTVGAGUNUOUP $.
  $}

  ${
    $d u v x y z .+ $.  $d u v x y z .(+) $.  $d v x y P $.  $d u v x y z ph $.
    $d u v x y z G $.  $d u v x y z T $.  $d u v x y z U $.  $d u v x y X $.
    $d y Q $.
    pj1eu.a $e |- .+ = ( +g ` G ) $.
    pj1eu.s $e |- .(+) = ( LSSum ` G ) $.
    pj1eu.o $e |- .0. = ( 0g ` G ) $.
    pj1eu.z $e |- Z = ( Cntz ` G ) $.
    pj1eu.2 $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    pj1eu.3 $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    pj1eu.4 $e |- ( ph -> ( T i^i U ) = { .0. } ) $.
    pj1eu.5 $e |- ( ph -> T C_ ( Z ` U ) ) $.
    $( Uniqueness of a left projection.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    pj1eu $p |- ( ( ph /\ X e. ( T .(+) U ) ) ->
      E! x e. T E. y e. U X = ( x .+ y ) ) $=
      ( wa vu vv co wcel cv wceq wrex wi wral wreu csubg cfv wb lsmelval biimpa
      syl2anc reeanv eqtr2 ad2antrr cin csn wss simplrl simprl simprr subgdisjb
      simplrr simpl syl6bi syl5 rexlimdvva ralrimivva adantr oveq1 eqeq2d oveq2
      syl5bir rexbidv cbvrexv syl6bb reu4 sylanbrc ) AIFGEUCUDZTIBUEZCUEZDUCZUF
      ZCGUGZBFUGZWHIUAUEZUBUEZDUCZUFZUBGUGZTZWDWJUFZUHZUAFUIBFUIZWHBFUJAWCWIAFH
      UKULZUDZGWSUDZWCWIUMPQBCDEFGHILMUNUPUOAWRWCAWQBUAFFWOWGWMTZUBGUGCGUGAWDFU
      DZWJFUDZTZTZWPWGWMCUBGGUQXFXBWPCUBGGXBWFWLUFZXFWEGUDZWKGUDZTZTZWPIWFWLURX
      KXGWPWEWKUFZTWPXKWDWEWJWKDFGHJKLNOAWTXEXJPUSAXAXEXJQUSAFGUTJVAUFXEXJRUSAF
      GKULVBXEXJSUSAXCXDXJVCAXCXDXJVGXFXHXIVDXFXHXIVEVFWPXLVHVIVJVKVQVLVMWHWNBU
      AFWPWHIWJWEDUCZUFZCGUGWNWPWGXNCGWPWFXMIWDWJWEDVNVOVRXNWMCUBGXLXMWLIWEWKWJ
      DVPVOVSVTWAWB $.

    pj1f.p $e |- P = ( proj1 ` G ) $.
    $( The left projection function maps a direct subspace sum onto the left
       factor.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    pj1f $p |- ( ph -> ( T P U ) : ( T .(+) U ) --> T ) $=
      ( vx wcel vz vy co wf cv wceq wrex crio cmpt wreu pj1eu riotacl syl fmptd
      eqid cgrp cbs cfv wss csubg subgrcl subgss pj1fval syl3anc feq1d mpbird
      wa ) AEFDUCZEEFBUCZUDVHEUAVHUAUEZSUEUBUECUCUFUBFUGZSEUHZUIZUDAUAVHVLEVMAV
      JVHTVGVKSEUJVLETASUBCDEFGVJHIJKLMNOPQUKVKSEULUMVMUOUNAVHEVIVMAGUPTZEGUQUR
      ZUSZFVOUSZVIVMUFAEGUTURZTZVNNEGVAUMAVSVPNVOEGVOUOZVBUMAFVRTVQOVOFGVTVBUMS
      UBUAVOBCDEFGUPVTJKRVCVDVEVF $.

    $( The right projection function maps a direct subspace sum onto the right
       factor.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    pj2f $p |- ( ph -> ( U P T ) : ( T .(+) U ) --> U ) $=
      ( co wf cin csn incom syl5eq cntzrecd pj1f csubg cfv wcel lsmcom2 syl3anc
      wss wceq feq2d mpbird ) AEFDSZFFEBSZTFEDSZFUQTABCDFEGHIJKLMONAFEUAEFUAHUB
      FEUCPUDAEFGIMNOQUERUFAUPURFUQAEGUGUHZUIFUSUIEFIUHULUPURUMNOQDEFGIKMUJUKUN
      UO $.

    $( Any element of a direct subspace sum can be decomposed into projections
       onto the left and right factors.  (Contributed by Mario Carneiro,
       15-Oct-2015.)  (Revised by Mario Carneiro, 21-Apr-2016.) $)
    pj1id $p |- ( ( ph /\ X e. ( T .(+) U ) ) ->
      X = ( ( ( T P U ) ` X ) .+ ( ( U P T ) ` X ) ) ) $=
      ( wceq vy vx vu vv co wcel wa cfv wrex crab crio cgrp cbs wss w3a subgrcl
      csubg syl eqid subgss 3jca pj1val sylan wreu pj1eu riotacl2 eqeltrd oveq1
      cv eqeq2d rexbidv simprbi simprr ad2antrr simplr lsmcom2 syl3anc syl31anc
      elrab eleqtrd wf pj1f ffvelrnd sseldd simprl cntzi syl2anc eqtrd oveq2 wb
      rspcev simpll cin csn incom syl5eq cntzrecd riota2 mpbid oveq2d rexlimddv
      eqtr4d ) AHEFDUEZUFZUGZHHEFBUEZUHZUAVIZCUEZTZHXGHFEBUEUHZCUEZTUAFXEXGHUBV
      IZXHCUEZTZUAFUIZUBEUJZUFZXJUAFUIZXEXGXPUBEUKZXQAGULUFZEGUMUHZUNZFYBUNZUOX
      DXGXTTAYAYCYDAEGUQUHZUFZYAOEGUPURZAYFYCOYBEGYBUSZUTURZAFYEUFZYDPYBFGYHUTU
      RZVAUBUAYBBCDEFGULHYHKLSVBVCXEXPUBEVDXTXQUFAUBUACDEFGHIJKLMNOPQRVEXPUBEVF
      URVGXRXGEUFZXSXPXSUBXGEXMXGTZXOXJUAFYMXNXIHXMXGXHCVHVJVKVSVLURXEXHFUFZXJU
      GZUGZHXIXLXEYNXJVMZYPXKXHXGCYPXKHUCVIZUDVIZCUEZTZUDEUIZUCFUKZXHYPYAYDYCHF
      EDUEZUFZXKUUCTAYAXDYOYGVNAYDXDYOYKVNAYCXDYOYIVNYPHXCUUDAXDYOVOZAXCUUDTZXD
      YOAYFYJEFJUHZUNZUUGOPRDEFGJLNVPVQVNVTZUCUDYBBCDFEGULHYHKLSVBVRYPHXHYSCUEZ
      TZUDEUIZUUCXHTZYPYLHXHXGCUEZTZUUMYPXCEHXFAXCEXFWAXDYOABCDEFGIJKLMNOPQRSWB
      VNUUFWCZYPHXIUUOYQYPXGUUHUFYNXIUUOTYPEUUHXGAUUIXDYORVNUUQWDXEYNXJWEZCFGXG
      XHJKNWFWGWHUULUUPUDXGEYSXGTUUKUUOHYSXGXHCWIVJWKWGYPYNUUBUCFVDZUUMUUNWJUUR
      YPAUUEUUSAXDYOWLUUJAUCUDCDFEGHIJKLMNPOAFEWMEFWMIWNFEWOQWPAEFGJNOPRWQVEWGU
      UBUUMUCFXHYRXHTZUUAUULUDEUUTYTUUKHYRXHYSCVHVJVKWRWGWSWHWTXBXA $.

    ${
      pj1eq.5 $e |- ( ph -> X e. ( T .(+) U ) ) $.
      pj1eq.6 $e |- ( ph -> B e. T ) $.
      pj1eq.7 $e |- ( ph -> C e. U ) $.
      $( Any element of a direct subspace sum can be decomposed uniquely into
         projections onto the left and right factors.  (Contributed by Mario
         Carneiro, 16-Oct-2015.) $)
      pj1eq $p |- ( ph -> ( X = ( B .+ C ) <->
        ( ( ( T P U ) ` X ) = B /\ ( ( U P T ) ` X ) = C ) ) ) $=
        ( co wceq wa wcel pj1id mpdan eqeq1d pj1f ffvelrnd pj2f subgdisjb bitrd
        cfv ) AJBCEUEZUFJGHDUEZUQZJHGDUEZUQZEUEZURUFUTBUFVBCUFUGAJVCURAJGHFUEZU
        HJVCUFUBADEFGHIJKLMNOPQRSTUAUIUJUKAUTVBBCEGHIKLMOPQRSTAVDGJUSADEFGHIKLM
        NOPQRSTUAULUBUMUCAVDHJVAADEFGHIKLMNOPQRSTUAUNUBUMUDUOUP $.
    $}

    $( The left projection function is the identity on the left subspace.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    pj1lid $p |- ( ( ph /\ X e. T ) -> ( ( T P U ) ` X ) = X ) $=
      ( wcel wa co cfv wceq cgrp cbs csubg adantr subgrcl syl wss subgss sselda
      eqid grprid syl2anc eqcomd cin lsmub1 simpr subg0cl pj1eq mpbid simpld
      csn ) AHETZUAZHEFBUBUCHUDZHFEBUBUCIUDZVGHHICUBZUDVHVIUAVGVJHVGGUETZHGUFUC
      ZTVJHUDVGEGUGUCZTZVKAVNVFOUHZEGUIUJAEVLHAVNEVLUKOVLEGVLUNZULUJUMVLCGHIVPK
      MUOUPUQVGHIBCDEFGHIJKLMNVOAFVMTZVFPUHZAEFURIVEUDVFQUHAEFJUCUKVFRUHSAEEFDU
      BZHAVNVQEVSUKOPDEFGLUSUPUMAVFUTVGVQIFTVRFGIMVAUJVBVCVD $.

    $( The left projection function is the zero operator on the right
       subspace.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    pj1rid $p |- ( ( ph /\ X e. U ) -> ( ( T P U ) ` X ) = .0. ) $=
      ( wcel wa co cfv wceq cgrp cbs csubg adantr subgrcl syl wss subgss sselda
      eqid grplid syl2anc eqcomd cin lsmub2 subg0cl simpr pj1eq mpbid simpld
      csn ) AHFTZUAZHEFBUBUCIUDZHFEBUBUCHUDZVGHIHCUBZUDVHVIUAVGVJHVGGUETZHGUFUC
      ZTVJHUDVGEGUGUCZTZVKAVNVFOUHZEGUIUJAFVLHAFVMTZFVLUKPVLFGVLUNZULUJUMVLCGHI
      VQKMUOUPUQVGIHBCDEFGHIJKLMNVOAVPVFPUHAEFURIVEUDVFQUHAEFJUCUKVFRUHSAFEFDUB
      ZHAVNVPFVRUKOPDEFGLUSUPUMVGVNIETVOEGIMUTUJAVFVAVBVCVD $.

    $( The left projection function is a group homomorphism.  (Contributed by
       Mario Carneiro, 21-Apr-2016.) $)
    pj1ghm $p |- ( ph -> ( T P U ) e. ( ( G |`s ( T .(+) U ) ) GrpHom G ) ) $=
      ( co wcel vx vy cress cbs cfv eqid cplusg wceq ovex ressplusg ax-mp csubg
      cvv cgrp wss lsmsubg syl3anc subggrp syl subgrcl pj1f fss syl2anc subgbas
      wf subgss feq2d mpbid cv wa anbi12d biimpar pj1id adantrr adantrl oveq12d
      eleq2d cmnd adantr grpmnd 3syl simpl syl2an sseldd simpr pj2f cntzi mnd4g
      ffvelrn eqtr4d cin csn subgcl 3expb sylan pj1eq simpld syldan isghmd ) AU
      AUBCCGEFDSZUCSZGEFBSZXAUDUEZGUDUEZXCUFXDUFZWTUMTCXAUGUEUHEFDUIWTCGXAUMXAU
      FZJUJUKJAWTGULUEZTZXAUNTAEXGTZFXGTZEFIUEZUOZXHNOQDEFGIKMUPUQZWTGXAXFURUSA
      XIGUNTZNEGUTZUSAWTXDXBVEZXCXDXBVEAWTEXBVEZEXDUOZXPABCDEFGHIJKLMNOPQRVAZAX
      IXRNXDEGXEVFZUSWTEXDXBVBVCAWTXCXDXBAXHWTXCUHXMWTGXAXFVDUSZVGVHAUAVIZXCTZU
      BVIZXCTZVJZYBWTTZYDWTTZVJZYBYDCSZXBUEYBXBUEZYDXBUEZCSZUHZAYIYFAYGYCYHYEAW
      TXCYBYAVQAWTXCYDYAVQVKVLAYIVJZYNYJFEBSZUEYBYPUEZYDYPUEZCSZUHZYOYJYMYSCSZU
      HYNYTVJYOYJYKYQCSZYLYRCSZCSUUAYOYBUUBYDUUCCAYGYBUUBUHYHABCDEFGYBHIJKLMNOP
      QRVMVNAYHYDUUCUHYGABCDEFGYDHIJKLMNOPQRVMVOVPYOXDCGYRYKYLYQXEJYOXIXNGVRTAX
      IYINVSZXOGVTWAYOEXDYKYOXIXRUUDXTUSZAXQYGYKETZYIXSYGYHWBZWTEYBXBWIWCZWDYOE
      XDYLUUEAXQYHYLETZYIXSYGYHWEZWTEYDXBWIWCZWDYOFXDYQYOXJFXDUOAXJYIOVSZXDFGXE
      VFUSZAWTFYPVEZYGYQFTZYIABCDEFGHIJKLMNOPQRWFZUUGWTFYBYPWIWCZWDYOFXDYRUUMAU
      UNYHYRFTZYIUUPUUJWTFYDYPWIWCZWDYOYLXKTUUOYLYQCSYQYLCSUHYOEXKYLAXLYIQVSZUU
      KWDUUQCFGYLYQIJMWGVCWHWJYOYMYSBCDEFGYJHIJKLMUUDUULAEFWKHWLUHYIPVSUUTRAXHY
      IYJWTTZXMXHYGYHUVACWTGYBYDJWMWNWOYOXIUUFUUIYMETUUDUUHUUKCEGYKYLJWMUQYOXJU
      UOUURYSFTUULUUQUUSCFGYQYRJWMUQWPVHWQWRWS $.

    $( The left projection function is a group homomorphism.  (Contributed by
       Mario Carneiro, 21-Apr-2016.) $)
    pj1ghm2 $p |- ( ph ->
      ( T P U ) e. ( ( G |`s ( T .(+) U ) ) GrpHom ( G |`s T ) ) ) $=
      ( co wcel cress cghm pj1ghm csubg cfv crn wss wb wf pj1f frn syl resghm2b
      eqid syl2anc mpbid ) AEFBSZGEFDSZUASZGUBSTZUQUSGEUASZUBSTZABCDEFGHIJKLMNO
      PQRUCAEGUDUETUQUFEUGZUTVBUHNAUREUQUIVCABCDEFGHIJKLMNOPQRUJUREUQUKULUSGVAU
      QEVAUNUMUOUP $.
  $}

  ${
    $d x y .(+) $.  $d x y G $.  $d x y ph $.  $d x y T $.  $d x y U $.
    lsmhash.p $e |- .(+) = ( LSSum ` G ) $.
    lsmhash.o $e |- .0. = ( 0g ` G ) $.
    lsmhash.z $e |- Z = ( Cntz ` G ) $.
    lsmhash.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    lsmhash.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    lsmhash.i $e |- ( ph -> ( T i^i U ) = { .0. } ) $.
    lsmhash.s $e |- ( ph -> T C_ ( Z ` U ) ) $.
    lsmhash.1 $e |- ( ph -> T e. Fin ) $.
    lsmhash.2 $e |- ( ph -> U e. Fin ) $.
    $( The order of the direct product of groups.  (Contributed by Mario
       Carneiro, 21-Apr-2016.) $)
    lsmhash $p |- ( ph ->
      ( # ` ( T .(+) U ) ) = ( ( # ` T ) x. ( # ` U ) ) ) $=
      ( cfv wceq wcel wa vx vy chash cxp cmul cen wbr cpj1 cop c1st c2nd cplusg
      co cv cvv ovex a1i csubg xpexg syl2anc eqid pj1f ffvelrnda opelxpi ex jca
      pj2f xp1st xp2nd lsmelvali syl2an wb adantr cin csn simprl ad2antll pj1eq
      wss eqcom anbi12i syl6bb eqop bitr4d en3d hasheni syl cfn hashxp eqtrd )
      ACDBUMZUCQZCDUDZUCQZCUCQDUCQUEUMZAWKWMUFUGWLWNRAUAUBWKWMUAUNZCDEUHQZUMZQZ
      WPDCWQUMZQZUIZUBUNZUJQZXCUKQZEULQZUMZWKUOSACDBUPUQACEURQZSZDXHSZWMUOSKLCD
      XHXHUSUTAWPWKSZXBWMSZAXKTWSCSXADSXLAWKCWPWRAWQXFBCDEFGXFVAZHIJKLMNWQVAZVB
      VCAWKDWPWTAWQXFBCDEFGXMHIJKLMNXNVGVCWSXACDVDUTVEAXCWMSZXGWKSZAXIXJTXDCSZX
      EDSZTXPXOAXIXJKLVFXOXQXRXCCDVHZXCCDVIZVFXFBCDEXDXEXMHVJVKVEAXKXOTZWPXGRZX
      CXBRZVLAYATZYBXDWSRZXEXARZTZYCYDYBWSXDRZXAXERZTYGYDXDXEWQXFBCDEWPFGXMHIJA
      XIYAKVMAXJYALVMACDVNFVORYAMVMACDGQVSYANVMXNAXKXOVPXOXQAXKXSVQXOXRAXKXTVQV
      RYHYEYIYFWSXDVTXAXEVTWAWBXOYCYGVLAXKXCWSXACDWCVQWDVEWEWKWMWFWGACWHSDWHSWN
      WOROPCDWIUTWJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Free groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~FG $.
  $c freeGrp $.
  $c varFGrp $.

  $( Extend class notation with the free group equivalence relation. $)
  cefg $a class ~FG $.

  $( Extend class notation with the free group construction. $)
  cfrgp $a class freeGrp $.

  $( Extend class notation with free group injection. $)
  cvrgp $a class varFGrp $.

  ${
    $d i j n r x y z $.
    $( Define the free group equivalence relation, which is the smallest
       equivalence relation ` ~~ ` such that for any words ` A , B ` and formal
       symbol ` x ` with inverse ` invg x ` , ` A B ~~ A x ( invg x ) B ` .
       (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    df-efg $a |- ~FG = ( i e. _V |-> |^| { r | ( r Er Word ( i X. 2o ) /\
      A. x e. Word ( i X. 2o ) A. n e. ( 0 ... ( # ` x ) )
        A. y e. i A. z e. 2o x r ( x splice <. n , n ,
          <" <. y , z >. <. y , ( 1o \ z ) >. "> >. ) ) } ) $.

    $( Define the free group on a set ` I ` of generators, defined as the
       quotient of the free monoid on ` I X. 2o ` (representing the generator
       elements and their formal inverses) by the free group equivalence
       relation ~ df-efg .  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    df-frgp $a |- freeGrp = ( i e. _V |->
      ( ( freeMnd ` ( i X. 2o ) ) /s ( ~FG ` i ) ) ) $.

    $( Define the canonical injection from the generating set ` I ` into the
       base set of the free group.  (Contributed by Mario Carneiro,
       2-Oct-2015.) $)
    df-vrgp $a |- varFGrp = ( i e. _V |-> ( j e. i |->
      [ <" <. j , (/) >. "> ] ( ~FG ` i ) ) ) $.
  $}

  ${
    $d a b A $.  $d a b B $.  $d a b y z I $.  $d a b M $.
    efgmval.m $e |- M = ( y e. I , z e. 2o |-> <. y , ( 1o \ z ) >. ) $.
    $( Value of the formal inverse operation for the generating set of a free
       group.  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    efgmval $p |- ( ( A e. I /\ B e. 2o )
        -> ( A M B ) = <. A , ( 1o \ B ) >. ) $=
      ( va vb c2o cv c1o cdif cop opeq1 wceq difeq2 opeq2d cmpt2 cbvmpt2v eqtri
      opex ovmpt2 ) HICDEJHKZLIKZMZNZCLDMZNFCUFNUDCUFOUEDPUFUHCUEDLQRFABEJAKZLB
      KZMZNZSHIEJUGSGABHIEJULUGUDUKNUIUDUKOUJUEPUKUFUDUJUELQRTUACUHUBUC $.

    $( The formal inverse operation is an endofunction on the generating set.
       (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    efgmf $p |- M : ( I X. 2o ) --> ( I X. 2o ) $=
      ( cv c1o cdif cop c2o cxp wcel wral wf 2oconcl opelxpi sylan2 rgen2 fmpt2
      mpbi ) AFZGBFZHZIZCJKZLZBJMACMUEUEDNUFABCJUBJLUACLUCJLUFUBOUAUCCJPQRABCJU
      DUEDEST $.

    $( The inversion function on the generators is an involution.  (Contributed
       by Mario Carneiro, 1-Oct-2015.) $)
    efgmnvl $p |- ( A e. ( I X. 2o ) -> ( M ` ( M ` A ) ) = A ) $=
      ( va vb c2o wcel cv cop wceq wrex cfv co c1o cdif efgmval fveq2d elxp2 wa
      cxp df-ov syl6eqr 2oconcl sylan2 wss csuc wtr wi 1on onordi ordtr trsucss
      word mp2b df-2o eleq2s adantl dfss4 sylib opeq2d fveq2 eqeq12d syl5ibrcom
      3eqtrd id rexlimivv sylbi ) CDIUCJCGKZHKZLZMZHINGDNCEOZEOZCMZGHCDIUAVNVQG
      HDIVKDJZVLIJZUBZVQVNVKVLEPZEOZVMMVTWBVKQVLRZEPZVKQWCRZLZVMVTWBVKWCLZEOWDV
      TWAWGEABVKVLDEFSTVKWCEUDUEVSVRWCIJWDWFMVLUFABVKWCDEFSUGVTWEVLVKVTVLQUHZWE
      VLMVSWHVRWHVLQUIZIQUPQUJVLWIJWHUKQULUMQUNQVLUOUQURUSUTVLQVAVBVCVGVNVPWBCV
      MVNVOWAEVNVOVMEOWACVMEVDVKVLEUDUETVNVHVEVFVIVJ $.
  $}

  ${
    $d a b c d f g h i j r s u A $.  $d a b r y z J $.  $d a b f g h r s u L $.
    $d a b f i F $.  $d a b c r K $.  $d c n t v w y z P $.  $d c i j r s ph $.
    $d a b c f g i j m n r s t u v w x M $.  $d a b i r N $.  $d n v w y z U $.
    $d a b c f g i j k m o r s t u x T $.  $d n v w y z V $.  $d a b i j u X $.
    $d c n t v w y z Q $.  $d a b c d f g h i j k m n o r s t u v w x y z W $.
    $d a b c d f g i j m r s t u x y z .~ $.  $d a b c d f g h i j r s u B $.
    $d a b i k m n t v w x y z C $.  $d a b c d i j o r s u S $.  $d i j Y $.
    $d a b c f g i j m n r s t u v w x y z I $.
    $d a b c d f i j m r s t u D $.
    efgval.w $e |- W = ( _I ` Word ( I X. 2o ) ) $.
    $( Lemma for ~ efgval .  (Contributed by Mario Carneiro, 1-Oct-2015.)
       (Revised by Mario Carneiro, 27-Feb-2016.) $)
    efgrcl $p |- ( A e. W -> ( I e. _V /\ W = Word ( I X. 2o ) ) ) $=
      ( wcel cvv c2o cxp cword wceq cdm wne 2on0 dmxp ax-mp cid cfv elfvex syl
      c0 eleq2s wrdexb sylibr dmexg syl5eqelr fvi syl5eq jca ) ACEZBFECBGHZIZJU
      IBUJKZFGTLULBJMBGNOUIUJFEZULFEUIUKFEZUMUNAUKPQZCAUKPRDUAZUJUBUCUJFUDSUEUI
      CUOUKDUIUNUOUKJUPUKFUFSUGUH $.

    $( Lemma for ~ efgval .  (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    efglem $p |- E. r ( r Er W /\ A. x e. W
    A. n e. ( 0 ... ( # ` x ) ) A. y e. I A. z e. 2o x r ( x splice <. n , n ,
        <" <. y , z >. <. y , ( 1o \ z ) >. "> >. ) ) $=
      ( cxp wer cv cop co wbr c2o wral cfv wa wcel cid c1o cdif cs2 csplice cc0
      chash cfz xpider simpll cword fviss eqsstri sseldi opelxpi adantl 2oconcl
      cotp sylan2 s2cld splcl syl2anc wceq efgrcl simprd ad2antrr eleqtrrd brxp
      wex cvv sylanbrc ralrimivva rgen2 fvex eqeltri xpex breq 2ralbidv anbi12d
      ereq1 spcev mp2an ) FFFIZJZAKZWDDKZWEBKZCKZLZWFUAWGUBZLZUCZUQUDMZWBNZCOPB
      EPZDUEWDUFQUGMZPAFPZFGKZJZWDWLWQNZCOPBEPZDWOPAFPZRZGVHFUHWNADFWOWDFSZWEWO
      SZRZWMBCEOXEWFESZWGOSZRZRZXCWLFSWMXCXDXHUIZXIWLEOIZUJZFXIWDXLSWKXLSWLXLSX
      IFXLWDFXLTQZXLHXLUKULXJUMXIWHWJXKXHWHXKSXEWFWGEOUNUOXHWJXKSZXEXGXFWIOSXNW
      GUPWFWIEOUNURUOUSXKWKWDWEWEUTVAXCFXLVBZXDXHXCEVISXOWDEFHVCVDVEVFWDWLFFVGV
      JVKVLXBWCWPRGWBFFFXMVIHXLTVMVNZXPVOWQWBVBZWRWCXAWPFWQWBVSXQWTWNADFWOXQWSW
      MBCEOWDWLWQWBVPVQVQVRVTWA $.

    efgval.r $e |- .~ = ( ~FG ` I ) $.
    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    efgval $p |- .~ = |^| { r | ( r Er W /\ A. x e. W
     A. n e. ( 0 ... ( # ` x ) ) A. y e. I A. z e. 2o x r ( x splice <. n , n ,
       <" <. y , z >. <. y , ( 1o \ z ) >. "> >. ) ) } $=
      ( vi vw cv c2o wral cvv wcel wceq c0 wss cefg cfv wer cop c1o cs2 csplice
      cdif cotp co wbr cc0 chash cfz wa cab cint cxp cword wb cid vex 2on elexi
      con0 xpex wrdexg fvi xpeq1 wrdeq syl fveq2d syl5eqr syl6eqr ereq2 ralbidv
      mp2b raleq raleqbidv anbi12d abbidv inteqd df-efg wex efglem intexab mpbi
      fvmpt wn fvprc cuni wne abn0 mpbir intssuni ax-mp wi erssxp efgrcl simpld
      wal con3i eq0rdv xpeq2d xp0 syl6eq ss0b sylibr sylan9ssr ex adantrd sseq1
      alrimiv ralab2 unissb syl5ss ss0 eqtr4d pm2.61i eqtri ) DFUAUBZGHMZUCZAMZ
      YDEMZYEBMZCMZUDYFUEYGUHUDUFUIUGUJYBUKCNOZBFOZEULYDUMUBUNUJZOZAGOZUOZHUPZU
      QZJFPQZYAYORKFKMZNURZUSZYBUCZYHBYQOZEYJOZAYSOZUOZHUPZUQYOPUAYQFRZUUEYNUUF
      UUDYMHUUFYTYCUUCYLUUFYSGRYTYCUTUUFYSFNURZUSZVAUBZGUUFYSYSVAUBZUUIYRPQYSPQ
      UUJYSRYQNKVBNVEVCVDVFYRPVGYSPVHVQUUFYSUUHVAUUFYRUUGRYSUUHRYQFNVIYRUUGVJVK
      VLVMIVNZYSGYBVOVKUUFUUBYKAYSGUUKUUFUUAYIEYJYHBYQFVRVPVSVTWAWBABCKEHWCYMHW
      DZYOPQABCEFGHIWEZYMHWFWGWHYPWIZYASYOFUAWJUUNYOSTYOSRUUNYOYNWKZSYNSWLZYOUU
      OTUUPUULUUMYMHWMWNYNWOWPUUNLMZSTZLYNOZUUOSTUUNYMYBSTZWQZHXAUUSUUNUVAHUUNY
      CUUTYLUUNYCUUTYCUUNYBGGURZSGYBWRUUNUVBSRUVBSTUUNUVBGSURSUUNGSGUUNAGYDGQZY
      PUVCYPGUUHRYDFGIWSWTXBXCXDGXEXFUVBXGXHXIXJXKXMYMUURUUTLHUUQYBSXLXNXHLYNSX
      OXHXPYOXQVKXRXSXT $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    efger $p |- .~ Er W $=
      ( vw vr vx vn vy vz wer cv cop c1o cdif co wral mpbir ereq1 csplice chash
      cs2 cotp wbr c2o cc0 cfv cfz wa cab ciin c0 wne wex efglem abn0 wi ralab2
      simpl mpgbir iiner mp2an wceq wb cint efgval intiin eqtri ax-mp ) CALZCFC
      GMZLZHMZVNIMZVOJMZKMZNVPOVQPNUCUDUAQVLUEKUFRJBRIUGVNUBUHUIQRHCRZUJZGUKZFM
      ZULZLZVTUMUNZCWALZFVTRZWCWDVSGUOHJKIBCGDUPVSGUQSWFVSVMURGVSWEVMFGCWAVLTUS
      VMVRUTVAFVTCWAVBVCAWBVDVKWCVEAVTVFWBHJKAIBCGDEVGFVTVHVICAWBTVJS $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    efgi $p |- ( ( ( A e. W /\ N e. ( 0 ... ( # ` A ) ) ) /\
        ( J e. I /\ K e. 2o ) ) -> A .~ ( A splice
         <. N , N , <" <. J , K >. <. J , ( 1o \ K ) >. "> >. ) ) $=
      ( vr vi va vb wcel co c2o cop csplice wbr wral cc0 chash cfv cfz c1o cdif
      vu wa cs2 cotp cv wer cab cint wi wal wceq fveq2 oveq2d id oveq1 2ralbidv
      breq12d raleqbidv rspcv oteq1 oteq2 eqtrd breq2d sylan9 opeq1 s2eqd opeq2
      oteq3d difeq2 opeq2d syl6bb rspc2v adantld alrimiv opex elintab syl6eleqr
      df-br sylibr efgval ) AGNZFUAAUBUCZUDOZNZUHZDCNEPNUHZUHZAAFFDEQZDUEEUFZQZ
      UIZUJZROZQZBNAWSBSWMWTGJUKZULZUGUKZXCKUKZXDLUKZMUKZQZXEUEXFUFZQZUIZUJZROZ
      XASZMPTLCTZKUAXCUBUCZUDOZTZUGGTZUHZJUMUNZBWMXSWTXANZUOZJUPWTXTNWMYBJWMXRY
      AXBWKXRAAFFXJUJZROZXASZMPTLCTZWLYAWGXRAAXKROZXASZMPTLCTZKWITZWJYFXQYJUGAG
      XCAUQZXNYIKXPWIYKXOWHUAUDXCAUBURUSYKXMYHLMCPYKXCAXLYGXAYKUTXCAXKRVAVCVBVD
      VEYIYFKFWIXDFUQZYHYELMCPYLYGYDAXAYLXKYCARYLXKFXDXJUJYCXDFXDXJVFXDFFXJVGVH
      USVIVBVEVJYEYAAAFFDXFQZDXHQZUIZUJZROZXASZLMDECPXEDUQZYDYQAXAYSYCYPARYSXJY
      OFFYSXGXIYMYNXEDXFVKXEDXHVKVLVNUSVIXFEUQZYRAWSXASYAYTYQWSAXAYTYPWRARYTYOW
      QFFYTYMYNWNWPXFEDVMYTXHWODXFEUEVOVPVLVNUSVIAWSXAWDVQVRVJVSVTXSJWTAWSWAWBW
      EUGLMBKCGJHIWFWCAWSBWDWE $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    efgi0 $p |- ( ( A e. W /\ N e. ( 0 ... ( # ` A ) ) /\ J e. I ) -> A .~
    ( A splice <. N , N , <" <. J , (/) >. <. J , 1o >. "> >. ) ) $=
      ( wcel cc0 co c0 cop c1o cs2 cotp csplice c2o wtru wceq chash cfv cfz w3a
      cdif wbr wa cpr 0ex prid1 df2o3 eleqtrri efgi mpanr2 3impa tru eqidd dif0
      opeq2i a1i s2eqd oteq3 mp2b oveq2i syl6breq ) AFIZEJAUAUBUCKIZDCIZUDAAEED
      LMZDNLUEZMZOZPZQKZAEEVIDNMZOZPZQKBVFVGVHAVNBUFZVFVGUGVHLRIVRLLNUHRLNUIUJU
      KULABCDLEFGHUMUNUOVMVQAQSVLVPTVMVQTUPSVIVKVIVOSVIUQVKVOTSVJNDNURUSUTVAVLV
      PEEVBVCVDVE $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    efgi1 $p |- ( ( A e. W /\ N e. ( 0 ... ( # ` A ) ) /\ J e. I ) -> A .~
    ( A splice <. N , N , <" <. J , 1o >. <. J , (/) >. "> >. ) ) $=
      ( wcel cc0 co c1o cop cs2 cotp csplice c0 c2o wtru wceq chash cfv cfz w3a
      cdif wbr wa cpr con0 1on elexi prid2 df2o3 eleqtrri efgi mpanr2 3impa tru
      eqidd difid opeq2i a1i s2eqd oteq3 mp2b oveq2i syl6breq ) AFIZEJAUAUBUCKI
      ZDCIZUDAAEEDLMZDLLUEZMZNZOZPKZAEEVKDQMZNZOZPKBVHVIVJAVPBUFZVHVIUGVJLRIVTL
      QLUHRQLLUIUJUKULUMUNABCDLEFGHUOUPUQVOVSAPSVNVRTVOVSTURSVKVMVKVQSVKUSVMVQT
      SVLQDLUTVAVBVCVNVREEVDVEVFVG $.

    efgval2.m $e |- M = ( y e. I , z e. 2o |-> <. y , ( 1o \ z ) >. ) $.
    efgval2.t $e |- T = ( v e. W |->
        ( n e. ( 0 ... ( # ` v ) ) , w e. ( I X. 2o ) |-> ( v splice
      <. n , n , <" w ( M ` w ) "> >. ) ) ) $.
    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.) $)
    efgtf $p |- ( X e. W -> ( ( T ` X ) = ( a e. ( 0 ... ( # ` X ) ) ,
        b e. ( I X. 2o ) |-> ( X splice <. a , a , <" b ( M ` b ) "> >. ) ) /\
      ( T ` X ) : ( ( 0 ... ( # ` X ) ) X. ( I X. 2o ) ) --> W ) ) $=
      ( wcel csplice cvv vu cfv cc0 chash cfz co c2o cxp cv cs2 cotp cmpt2 wceq
      wf wa cword cid fviss eqsstri simpl sseldi simprr efgmf ffvelrni ad2antll
      wral s2cld splcl syl2anc efgrcl simprd adantr ralrimivva eqid fmpt2 sylib
      eleqtrrd ovex con0 simpld 2on xpexg sylancl sylancr fvex eqeltri a1i fex2
      syl3anc fveq2 oveq2d eqidd oveq1 mpt2eq123dv cmpt oteq1 oteq2 eqtrd s2eqd
      weq id oteq3d cbvmpt2v syl5eq cbvmptv eqtri fvmptg mpdan feq1d mpbird jca
      ) KJRZKFUBZLMUCKUDUBZUEUFZHUGUHZKLUIZXQMUIZXRIUBZUJZUKZSUFZULZUMZXOXPUHZJ
      XMUNZXLYCTRZYDXLYEJYCUNZYETRZJTRZYGXLYBJRZMXPVFLXOVFYHXLYKLMXOXPXLXQXORZX
      RXPRZUOZUOZYBXPUPZJYOKYPRXTYPRYBYPRYOJYPKJYPUQUBZYPNYPURUSXLYNUTVAYOXRXSX
      PXLYLYMVBYMXSXPRXLYLXPXPXRIABHIPVCVDVEVGXPXTKXQXQVHVIXLJYPUMZYNXLHTRZYRKH
      JNVJZVKVLVQVMLMXOXPYBJYCYCVNVOVPZXLXOTRXPTRZYIUCXNUEVRXLYSUGVSRUUBXLYSYRY
      TVTWAHUGTVSWBWCXOXPTTWBWDYJXLJYQTNYPUQWEWFWGYEJYCTTWHWIUAKLMUCUAUIZUDUBZU
      EUFZXPUUCYASUFZULZYCJTFUUCKUMZLMUUEXPUUFXOXPYBUUHUUDXNUCUEUUCKUDWJWKUUHXP
      WLUUCKYASWMWNFDJGCUCDUIZUDUBZUEUFZXPUUIGUIZUULCUIZUUMIUBZUJZUKZSUFZULZWOU
      AJUUGWOQDUAJUURUUGDUAWTZUURLMUUKXPUUIYASUFZULUUGGCLMUUKXPUUQUUTUUIXQXQUUO
      UKZSUFGLWTZUUPUVAUUISUVBUUPXQUULUUOUKUVAUULXQUULUUOWPUULXQXQUUOWQWRWKCMWT
      ZUVAYAUUISUVCUUOXTXQXQUVCUUMUUNXRXSUVCXAUUMXRIWJWSXBWKXCUUSLMUUKXPUUTUUEX
      PUUFUUSUUJUUDUCUEUUIUUCUDWJWKUUSXPWLUUIUUCYASWMWNXDXEXFXGXHZXLYFYHUUAXLYE
      JXMYCUVDXIXJXK $.

    $( Value of the extension function, which maps a word (a representation of
       the group element as a sequence of elements and their inverses) to its
       direct extensions, defined as the original representation with an
       element and its inverse inserted somewhere in the string.  (Contributed
       by Mario Carneiro, 29-Sep-2015.) $)
    efgtval $p |- ( ( X e. W /\ N e. ( 0 ... ( # ` X ) ) /\ A e. ( I X. 2o ) )
       -> ( N ( T ` X ) A ) = ( X splice <. N , N , <" A ( M ` A ) "> >. ) ) $=
      ( va co csplice vb wcel cc0 chash cfv cfz c2o cxp cs2 cotp wa cv cmpt2 wf
      wceq efgtf simpld oveqd oteq1 oteq2 eqtrd oveq2d id fveq2 s2eqd eqid ovex
      oteq3d ovmpt2 sylan9eq 3impb ) MLUBZKUCMUDUEUFSZUBZEIUGUHZUBZKEMGUEZSZMKK
      EEJUEZUIZUJZTSZUOVLVNVPUKVRKERUAVMVOMRULZWCUAULZWDJUEZUIZUJZTSZUMZSWBVLVQ
      WIKEVLVQWIUOVMVOUHLVQUNABCDFGHIJLMRUANOPQUPUQURRUAKEVMVOWHWBWIMKKWFUJZTSW
      CKUOZWGWJMTWKWGKWCWFUJWJWCKWCWFUSWCKKWFUTVAVBWDEUOZWJWAMTWLWFVTKKWLWDWEEV
      SWLVCWDEJVDVEVHVBWIVFMWATVGVIVJVK $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.) $)
    efgval2 $p |- .~ =
      |^| { r | ( r Er W /\ A. x e. W ran ( T ` x ) C_ [ x ] r ) } $=
      ( vm va vu wral vb cv wer cop c1o cdif cs2 cotp csplice wbr c2o cc0 chash
      co cfv cfz wa cab cint crn cec wss efgval wcel cmpt2 wceq wf efgtf simpld
      cxp rneqd sseq1d dfss3 cvv wb ovex rgen2w eqid vex breq2 syl5bb ralrnmpt2
      elec ax-mp id fveq2 df-ov syl6eqr s2eqd oteq3d oveq2d ralxp eqidd efgmval
      breq2d ralbidva ralbiia bitri ralbii syl6bb anbi2i abbii inteqi eqtr4i )
      FKLUBZUCZAUBZXGQUBZXHRUBZUAUBZUDZXIUEXJUFUDZUGZUHZUIUNZXEUJZUAUKTZRITZQUL
      XGUMUOUPUNZTZAKTZUQZLURZUSXFXGGUOZUTZXGXEVAZVBZAKTZUQZLURZUSARUAFQIKLMNVC
      YJYCYIYBLYHYAXFYGXTAKXGKVDZYGQSXSIUKVJZXGXHXHSUBZYMJUOZUGZUHZUIUNZVEZUTZY
      FVBZXTYKYEYSYFYKYDYRYKYDYRVFXSYLVJKYDVGBCDEFGHIJKXGQSMNOPVHVIVKVLYTXIYFVD
      ZRYSTZXTRYSYFVMUUBXGYQXEUJZSYLTZQXSTZXTYQVNVDZSYLTQXSTUUBUUEVOUUFQSXSYLXG
      YPUIVPVQUUAUUCQSRXSYLYQYRVNYRVRUUAXGXIXEUJXIYQVFUUCXIXGXERVSAVSWCXIYQXGXE
      VTWAWBWDUUDXRQXSUUDXGXGXHXHXKXIXJJUNZUGZUHZUIUNZXEUJZUAUKTZRITXRUUCUUKSRU
      AIUKYMXKVFZYQUUJXGXEUUMYPUUIXGUIUUMYOUUHXHXHUUMYMYNXKUUGUUMWEUUMYNXKJUOUU
      GYMXKJWFXIXJJWGWHWIWJWKWOWLUULXQRIXIIVDZUUKXPUAUKUUNXJUKVDUQZUUJXOXGXEUUO
      UUIXNXGUIUUOUUHXMXHXHUUOXKUUGXKXLUUOXKWMBCXIXJIJOWNWIWJWKWOWPWQWRWSWRWRWT
      WQXAXBXCXD $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    efgi2 $p |- ( ( A e. W /\ B e. ran ( T ` A ) ) -> A .~ B ) $=
      ( vr va wcel wa cfv crn cop wbr cv wer cec wss wral cab cint wi wal fveq2
      wceq rneqd eceq1 sseq12d rspcv adantr com12 simpl elecg mpbid df-br sylib
      ssel expcom sylan9r syld adantld alrimiv elintab sylibr efgval2 syl6eleqr
      opex ) ELSZFEHUAZUBZSZTZEFUCZGSEFGUDWBWCLQUEZUFZRUEZHUAZUBZWFWDUGZUHZRLUI
      ZTZQUJUKZGWBWLWCWDSZULZQUMWCWMSWBWOQWBWKWNWEWBWKVTEWDUGZUHZWNVRWKWQULWAWJ
      WQRELWFEUOZWHVTWIWPWRWGVSWFEHUNUPWFEWDUQURUSUTWAWQFWPSZVRWNWQWAWSVTWPFVGV
      AWSVRWNWSVRTZEFWDUDZWNWTWSXAWSVRVBFEWDWPLVCVDEFWDVEVFVHVIVJVKVLWLQWCEFVQV
      MVNRABCDGHIJKLQMNOPVOVPEFGVEVN $.

    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       27-Sep-2015.) $)
    efgtlen $p |- ( ( X e. W /\ A e. ran ( T ` X ) ) ->
      ( # ` A ) = ( ( # ` X ) + 2 ) ) $=
      ( wcel cfv co cc0 va vb crn chash c2 caddc wceq cs2 cotp csplice c2o wrex
      cv cxp cfz cmpt2 efgtf simpld rneqd eleq2d eqid ovex elrnmpt2 syl6bb cmin
      wf wa cword cid fviss eqsstri simpl sseldi elfzuz ad2antrl eluzfz2b sylib
      cuz simprl simprr efgmf ffvelrni syl s2cld spllen s2len cc eluzelz subidd
      a1i zcnd oveq12d subid1i syl6eq oveq2d eqtrd eqeq1d syl5ibrcom rexlimdvva
      2cn fveq2 sylbid imp ) LKQZELGRZUCZQZEUDRZLUDRZUEUFSZUGZXDXGELUAUMZXLUBUM
      ZXMJRZUHZUIZUJSZUGZUBIUKUNZULUATXIUOSZULZXKXDXGEUAUBXTXSXQUPZUCZQYAXDXFYC
      EXDXEYBXDXEYBUGXTXSUNKXEVFABCDFGHIJKLUAUBMNOPUQURUSUTUAUBXTXSXQEYBYBVALXP
      UJVBVCVDXDXRXKUAUBXTXSXDXLXTQZXMXSQZVGZVGZXKXRXQUDRZXJUGYGYHXIXOUDRZXLXLV
      ESZVESZUFSXJYGXSXOLXLXLYGKXSVHZLKYLVIRYLMYLVJVKXDYFVLVMYGXLTVRRQZXLTXLUOS
      QYDYMXDYEXLTXIVNVOZTXLVPVQXDYDYEVSYGXMXNXSXDYDYEVTZYGYEXNXSQYOXSXSXMJABIJ
      OWAWBWCWDWEYGYKUEXIUFYGYKUETVESUEYGYIUEYJTVEYIUEUGYGXMXNWFWJYGXLYGYMXLWGQ
      YNYMXLTXLWHWKWCWIWLUEWTWMWNWOWPXRXHYHXJEXQUDXAWQWRWSXBXC $.

    $( The inverse of the reverse of a word composed with the word relates to
       the identity.  (This provides an explicit expression for the
       representation of the group inverse, given a representative of the free
       group equivalence class.)  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    efginvrel2 $p |- ( A e. W ->
      ( A concat ( M o. ( reverse ` A ) ) ) .~ (/) ) $=
      ( wcel cfv cconcat co c0 vc va vb vm vu c2o cxp cword creverse ccom fviss
      wbr cid eqsstri sseli cv wi wceq id fveq2 rev0 syl6eq coeq2d co02 oveq12d
      cs1 breq1d imbi2d ccatlid ax-mp wer efger a1i cvv efgrcl simprd syl5eleqr
      erref syl5eqbr wa crn simprl wf revcl ad2antrl efgmf wrdco sylancl ccatcl
      wrd0 syl2anc adantr eleqtrrd chash cs2 cotp csplice cc0 cfz cuz cn0 lencl
      nn0uz syl6eleq caddc ccatlen cz uzid syl uzaddcl eqeltrd elfzuzb sylanbrc
      nn0zd simprr efgtval syl3anc ffvelrni ccatrid eqcomd oveq1d oveq2i nn0cnd
      s2cld eqidd hash0 addid1d syl5req splval2 s1cld revccat revs1 oveq1i s1co
      ccatco 3eqtrd oveq2d ccatass df-s2 syl6eqr 3eqtr2rd wfn cmpt2 3syl fnovrn
      efgtf ffn eqeltrrd efgi2 ersym ertr mpand expcom a2d wrdind mpcom ) EIUFU
      GZUHZPEKPZEJEUIQZUJZRSZTFULZKUUREKUURUMQUURLUURUKUNUOUUSUAUPZJUVDUIQZUJZR
      SZTFULZUQUUSTTRSZTFULZUQUUSUBUPZJUVKUIQZUJZRSZTFULZUQUUSUVKUCUPZVFZRSZJUV
      RUIQZUJZRSZTFULZUQUUSUVCUQUAUBUCEUUQUVDTURZUVHUVJUUSUWCUVGUVITFUWCUVDTUVF
      TRUWCUSUWCUVFJTUJTUWCUVETJUWCUVETUIQTUVDTUIUTVAVBVCJVDVBVEVGVHUVDUVKURZUV
      HUVOUUSUWDUVGUVNTFUWDUVDUVKUVFUVMRUWDUSUWDUVEUVLJUVDUVKUIUTVCVEVGVHUVDUVR
      URZUVHUWBUUSUWEUVGUWATFUWEUVDUVRUVFUVTRUWEUSUWEUVEUVSJUVDUVRUIUTVCVEVGVHU
      VDEURZUVHUVCUUSUWFUVGUVBTFUWFUVDEUVFUVARUWFUSUWFUVEUUTJUVDEUIUTVCVEVGVHUU
      SUVITTFTUURPZUVITURUUQWJZUUQTVIVJUUSTFKKFVKZUUSFIKLMVLZVMUUSTUURKUWHUUSIV
      NPKUURURZEIKLVOVPZVQVRVSUVKUURPZUVPUUQPZVTZUUSUVOUWBUUSUWOUVOUWBUQUUSUWOV
      TZUWAUVNFULUVOUWBUWPUVNUWAFKUWIUWPUWJVMZUWPUVNKPZUWAUVNGQZWAZPUVNUWAFULUW
      PUVNUURKUWPUWMUVMUURPZUVNUURPUUSUWMUWNWBZUWPUVLUURPZUUQUUQJWCZUXAUWMUXCUU
      SUWNUUQUVKWDWEZABIJNWFZUUQUUQJUVLWGWHZUUQUVKUVMWIWKUUSUWKUWOUWLWLWMZUWPUV
      KWNQZUVPUWSSZUWAUWTUWPUXJUVNUXIUXIUVPUVPJQZWOZWPWQSZUVKUXLRSZUVMRSZUWAUWP
      UWRUXIWRUVNWNQZWSSZPZUWNUXJUXMURUXHUWPUXIWRWTQZPUXPUXIWTQZPUXRUWPUXIXAUXS
      UWMUXIXAPUUSUWNUUQUVKXBWEZXCXDUWPUXPUXIUVMWNQZXESZUXTUWPUWMUXAUXPUYCURUXB
      UXGUUQUVKUVMXFWKUWPUXIUXTPZUYBXAPZUYCUXTPUWPUXIXGPUYDUWPUXIUYAXNUXIXHXIUW
      PUXAUYEUXGUUQUVMXBXIUYBUXIUXIXJWKXKUXIWRUXPXLXMZUUSUWMUWNXOZABCDUVPFGHIJU
      XIKUVNLMNOXPXQUWPUVKTUVMUXLUVNUXIUXIUUQUXBUWGUWPUWHVMUXGUWPUVPUXKUUQUYGUW
      PUWNUXKUUQPUYGUUQUUQUVPJUXFXRXIZYDUWPUVKUVKTRSZUVMRUWPUYIUVKUWMUYIUVKURUU
      SUWNUUQUVKXSWEXTYAUWPUXIYEUWPUXITWNQZXESUXIWRXESUXIUYJWRUXIXEYFYBUWPUXIUW
      PUXIUYAYCYGYHYIUWPUWAUVRUXKVFZUVMRSZRSZUVRUYKRSZUVMRSZUXOUWPUVTUYLUVRRUWP
      UVTJUVQUVLRSZUJZJUVQUJZUVMRSZUYLUWPUVSUYPJUWPUVSUVQUIQZUVLRSZUYPUWPUWMUVQ
      UURPZUVSVUAURUXBUWPUVPUUQUYGYJZUUQUVKUVQYKWKUYTUVQUVLRUVPYLYMVBVCUWPVUBUX
      CUXDUYQUYSURVUCUXEUXDUWPUXFVMUUQUUQUVQUVLJYOXQUWPUYRUYKUVMRUWPUWNUXDUYRUY
      KURUYGUXFUUQUUQUVPJYNWHYAYPYQUWPUVRUURPZUYKUURPZUXAUYOUYMURUWPUWMVUBVUDUX
      BVUCUUQUVKUVQWIWKUWPUXKUUQUYHYJZUXGUUQUVRUYKUVMYRXQUWPUYNUXNUVMRUWPUYNUVK
      UVQUYKRSZRSZUXNUWPUWMVUBVUEUYNVUHURUXBVUCVUFUUQUVKUVQUYKYRXQUXLVUGUVKRUVP
      UXKYSYBYTYAUUAYPUWPUWSUXQUUQUGZUUBZUXRUWNUXJUWTPUWPUWRVUIKUWSWCZVUJUXHUWR
      UWSUDUEUXQUUQUVNUDUPZVULUEUPZVUMJQWOWPWQSUUCURVUKABCDFGHIJKUVNUDUELMNOUUF
      VPVUIKUWSUUGUUDUYFUYGUXQUUQUXIUVPUWSUUEXQUUHABCDUVNUWAFGHIJKLMNOUUIWKUUJU
      WPUWAUVNTFKUWQUUKUULUUMUUNUUOUUP $.

    $( The inverse of the reverse of a word composed with the word relates to
       the identity.  (This provides an explicit expression for the
       representation of the group inverse, given a representative of the free
       group equivalence class.)  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    efginvrel1 $p |- ( A e. W ->
      ( ( M o. ( reverse ` A ) ) concat A ) .~ (/) ) $=
      ( vc wcel cfv ccom syl va creverse cconcat co c0 c2o cxp cword wceq fviss
      wf cid eqsstri sseli revcl efgmf revco sylancl revrev coeq2d eqtr3d chash
      cc0 cfzo cv cmpt wrdf ffvelrnda efgmnvl mpteq2dva ffvelrni fcompt sylancr
      a1i feqmptd fveq2 fmptco 3eqtr4d eqtrd oveq2d wbr wrdco cvv efgrcl simprd
      wa eleqtrrd efginvrel2 eqbrtrrd ) EKQZJEUBRZSZJWLUBRZSZUCUDZWLEUCUDUEFWJW
      NEWLUCWJWNJJESZSZEWJWMWPJWJJWKUBRZSZWMWPWJWKIUFUGZUHZQZWTWTJUKZWSWMUIWJEX
      AQZXBKXAEKXAULRXALXAUJUMUNZWTEUOTZABIJNUPZWTWTJWKUQURWJWREJWJXDWREUIXEWTE
      USTUTVAUTWJPVCEVBRVDUDZPVEZERZJRZJRZVFPXHXJVFWQEWJPXHXLXJWJXIXHQWFZXJWTQZ
      XLXJUIWJXHWTXIEWJXDXHWTEUKZXEWTEVGTZVHZABXJIJNVITVJWJPUAXHWTXKUAVEZJRXLWP
      JXMXNXKWTQXQWTWTXJJXGVKTWJXCXOWPPXHXKVFUIXGXPPJEXHWTWTVLVMWJUAWTWTJXCWJXG
      VNVOXRXKJVPVQWJPXHWTEXPVOVRVSVTWJWLKQWOUEFWAWJWLXAKWJXBXCWLXAQXFXGWTWTJWK
      WBURWJIWCQKXAUIEIKLWDWEWGABCDWLFGHIJKLMNOWHTWI $.

    efgred.d $e |- D = ( W \ U_ x e. W ran ( T ` x ) ) $.
    efgred.s $e |- S = ( m e. { t e. ( Word W \ { (/) } ) |
      ( ( t ` 0 ) e. D /\ A. k e. ( 1 ..^ ( # ` t ) ) ( t ` k ) e.
        ran ( T ` ( t ` ( k - 1 ) ) ) ) } |-> ( m ` ( ( # ` m ) - 1 ) ) ) $.
    $( Value of the auxiliary function ` S ` defining a sequence of extensions
       starting at some irreducible word.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    efgsf $p |- S : { t e. ( Word W \ { (/) } ) |
      ( ( t ` 0 ) e. D /\ A. k e. ( 1 ..^ ( # ` t ) )
        ( t ` k ) e. ran ( T ` ( t ` ( k - 1 ) ) ) ) } --> W $=
      ( cv chash cfv c1 cmin co wcel cc0 crn cfzo wral wa cword c0 cdif crab wf
      csn wi weq id fveq2 oveq1d fveq12d eleq1d ralrab2 eldifi wrdf syl eldifsn
      cn wne lennncl sylbi fzo0end ffvelrnd a1d mprgbir fmpt mpbi ) LUCZUDUEZUF
      UGUHZWCUEZPUIZLUJFUCZUEGUIKUCZWHUEWIUFUGUHWHUEJUEUKUIKUFWHUDUEZULUHUMUNZF
      PUOZUPUTZUQZURZUMZWOPIUSWPWKWJUFUGUHZWHUEZPUIZVAFWNWKWGWSLFWNLFVBZWFWRPWT
      WEWQWCWHWTVCWTWDWJUFUGWCWHUDVDVEVFVGVHWHWNUIZWSWKXAUJWJULUHZPWQWHXAWHWLUI
      ZXBPWHUSWHWLWMVIPWHVJVKXAWJVMUIZWQXBUIXAXCWHUPVNUNXDWHWLUPVLPWHVOVPWJVQVK
      VRVSVTLWOPWFIUBWAWB $.

    $( Elementhood in the domain of ` S ` , the set of sequences of extensions
       starting at an irreducible word.  (Contributed by Mario Carneiro,
       27-Sep-2015.) $)
    efgsdm $p |- ( F e. dom S <-> ( F e. ( Word W \ { (/) } ) /\
          ( F ` 0 ) e. D /\ A. i e. ( 1 ..^ ( # ` F ) )
        ( F ` i ) e. ran ( T ` ( F ` ( i - 1 ) ) ) ) ) $=
      ( vf cdm wcel cword c0 csn cdif cc0 cfv cv c1 cmin co crn chash cfzo wral
      w3a wceq fveq1 eleq1d fveq2 oveq2d fveq2d rneqd eleq12d raleqbidv anbi12d
      crab efgsf fdmi oveq1 cbvralv syl5bb cbvrabv eqtri elrab2 3anass bitr4i
      wa ) OIUFZUGORUHUIUJUKZUGZULOUMZGUGZKUNZOUMZWJUOUPUQZOUMZJUMZURZUGZKUOOUS
      UMZUTUQZVAZWDZWDWGWIWSVBULUEUNZUMZGUGZWJXAUMZWLXAUMZJUMZURZUGZKUOXAUSUMZU
      TUQZVAZWDZWTUEOWFWEXAOVCZXCWIXKWSXMXBWHGULXAOVDVEXMXHWPKXJWRXMXIWQUOUTXAO
      USVFVGXMXDWKXGWOWJXAOVDXMXFWNXMXEWMJWLXAOVDVHVIVJVKVLWEULFUNZUMZGUGZLUNZX
      NUMZXQUOUPUQZXNUMZJUMZURZUGZLUOXNUSUMZUTUQZVAZWDZFWFVMZXLUEWFVMYHRIABCDEF
      GHIJLMNPQRSTUAUBUCUDVNVOYGXLFUEWFXNXAVCZXPXCYFXKYIXOXBGULXNXAVDVEYFWJXNUM
      ZWLXNUMZJUMZURZUGZKYEVAYIXKYCYNLKYEXQWJVCZXRYJYBYMXQWJXNVFYOYAYLYOXTYKJYO
      XSWLXNXQWJUOUPVPVHVHVIVJVQYIYNXHKYEXJYIYDXIUOUTXNXAUSVFVGYIYJXDYMXGWJXNXA
      VDYIYLXFYIYKXEJWLXNXAVDVHVIVJVKVRVLVSVTWAWGWIWSWBWC $.

    $( Value of the auxiliary function ` S ` defining a sequence of extensions
       (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    efgsval $p |- ( F e. dom S -> ( S ` F ) = ( F ` ( ( # ` F ) - 1 ) ) ) $=
      ( vf cfv chash c1 cmin co wceq cc0 cv wcel crn cfzo wral wa cword c0 cdif
      csn crab id fveq2 oveq1d fveq12d cmpt cbvmptv eqtri fvex fvmpt efgsf fdmi
      cdm eleq2s ) NIUENUFUEZUGUHUIZNUEZUJNUKFULZUEGUMKULZVSUEVTUGUHUIVSUEJUEUN
      UMKUGVSUFUEUOUIUPUQFQURUSVAUTVBZIVNUDNUDULZUFUEZUGUHUIZWBUEZVRWAIWBNUJZWD
      VQWBNWFVCWFWCVPUGUHWBNUFVDVEVFILWALULZUFUEZUGUHUIZWGUEZVGUDWAWEVGUCLUDWAW
      JWEWGWBUJZWIWDWGWBWKVCWKWHWCUGUHWGWBUFVDVEVFVHVIVQNVJVKWAQIABCDEFGHIJKLMO
      PQRSTUAUBUCVLVMVO $.

    $( Property of the last link in the chain of extensions.  (Contributed by
       Mario Carneiro, 29-Sep-2015.) $)
    efgsdmi $p |- ( ( F e. dom S /\ ( ( # ` F ) - 1 ) e. NN ) ->
      ( S ` F ) e. ran ( T ` ( F ` ( ( ( # ` F ) - 1 ) - 1 ) ) ) ) $=
      ( vi cdm wcel chash cfv c1 cmin co cn wa wceq efgsval adantr cfzo cv wral
      crn cfz cuz simpr nnuz syl6eleq eluzfz1 syl cword cn0 csn cdif cc0 efgsdm
      cz c0 simp1bi eldifad lencl nn0z fzoval 4syl eleqtrrd simp3bi fveq2 oveq1
      fzoend fveq2d rneqd eleq12d rspcv sylc eqeltrd ) NIUEUFZNUGUHZUIUJUKZULUF
      ZUMZNIUHZWONUHZWOUIUJUKZNUHZJUHZUTZWMWRWSUNWPABCDEFGHIJKLMNOPQRSTUAUBUCUO
      UPWQWOUIWNUQUKZUFZUDURZNUHZXFUIUJUKZNUHZJUHZUTZUFZUDXDUSZWSXCUFZWQUIXDUFX
      EWQUIUIWOVAUKZXDWQWOUIVBUHZUFUIXOUFWQWOULXPWMWPVCVDVEUIWOVFVGWQNQVHZUFWNV
      IUFWNVNUFXDXOUNWQNXQVOVJZWMNXQXRVKUFZWPWMXSVLNUHGUFZXMABCDEFGHIJUDKLMNOPQ
      RSTUAUBUCVMZVPUPVQQNVRWNVSUIWNVTWAWBUIWNWFVGWMXMWPWMXSXTXMYAWCUPXLXNUDWOX
      DXFWOUNZXGWSXKXCXFWONWDYBXJXBYBXIXAJYBXHWTNXFWOUIUJWEWGWGWHWIWJWKWL $.

    $( Value of the auxiliary function ` S ` defining a sequence of extensions
       (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgsval2 $p |- ( ( A e. Word W /\ B e. W /\ ( A concat <" B "> ) e. dom S )
                   -> ( S ` ( A concat <" B "> ) ) = B ) $=
      ( cword wcel cs1 cconcat co cdm w3a cfv chash cmin cc0 caddc wceq efgsval
      c1 3ad2ant3 cc cn0 lencl 3ad2ant1 nn0cnd ax-1cn pncan sylancl simp1 simp2
      s1cld ccatlen syl2anc oveq2i syl6eq oveq1d addid2d 3eqtr4d fveq2d cfzo cn
      s1len 1nn eqeltri a1i lbfzo0 sylibr ccatval3 syl3anc s1fv 3ad2ant2 3eqtrd
      eqtrd ) GRUEZUFZHRUFZGHUGZUHUIZKUJUFZUKZWRKULZWRUMULZUSUNUIZWRULZUOGUMULZ
      UPUIZWRULZHWSWOXAXDUQWPABCDEFIJKLMNOWRPQRSTUAUBUCUDURUTWTXCXFWRWTXEUSUPUI
      ZUSUNUIZXEXCXFWTXEVAUFUSVAUFXIXEUQWTXEWOWPXEVBUFWSRGVCVDVEZVFXEUSVGVHWTXB
      XHUSUNWTXBXEWQUMULZUPUIZXHWTWOWQWNUFZXBXLUQWOWPWSVIZWTHRWOWPWSVJVKZRGWQVL
      VMXKUSXEUPHWBZVNVOVPWTXEXJVQVRVSWTXGUOWQULZHWTWOXMUOUOXKVTUIUFZXGXQUQXNXO
      WTXKWAUFZXRXSWTXKUSWAXPWCWDWEXKWFWGRGWQUOWHWIWPWOXQHUQWSHRWJWKWMWL $.

    $( The start and end of any extension sequence are related (i.e. evaluate
       to the same element of the quotient group to be created).  (Contributed
       by Mario Carneiro, 1-Oct-2015.) $)
    efgsrel $p |- ( F e. dom S -> ( F ` 0 ) .~ ( S ` F ) ) $=
      ( va vi cdm wcel cc0 cfv chash c1 cmin co cfzo wbr cword c0 csn cn cv crn
      cdif wral efgsdm simp1bi wne wa eldifsn lennncl sylbi fzo0end 3syl cn0 wi
      nnm1nn0 caddc wceq eleq1 fveq2 breq2d imbi12d imbi2d wer efger a1i eldifi
      wf ffvelrnda erref ex cuz elnn0uz peano2fzor sylanb 3adant1 3expia imim1d
      wrdf w3a 3ad2ant1 ffvelrnd nn0p1nn 3ad2ant2 nnuz syl6eleq 3ad2ant3 elfzo3
      elfzolt2b sylanbrc simp3bi oveq1 fveq2d rneqd eleq12d rspcv sylc cc nn0cn
      ax-1cn pncan sylancl eleqtrd efgi2 syl2anc ertr mpan2d syld expcom nn0ind
      a2d mpcom mpd efgsval breqtrrd ) NIUFUGZUHNUIZNUJUIZUKULUMZNUIZNIUIHYOYRU
      HYQUNUMZUGZYPYSHUOZYONQUPZUQURZVBUGZYQUSUGZUUAYOUUEYPGUGZUDUTZNUIZUUHUKUL
      UMZNUIZJUIZVAZUGZUDUKYQUNUMZVCZABCDEFGHIJUDKLMNOPQRSTUAUBUCVDZVEZUUENUUCU
      GZNUQVFVGUUFNUUCUQVHQNVIVJZYQVKVLYRVMUGZYOUUAUUBVNZYOUUEUUFUVAUURUUTYQVOV
      LYOUUHYTUGZYPUUIHUOZVNZVNYOUHYTUGZYPYPHUOZVNZVNYOUEUTZYTUGZYPUVINUIZHUOZV
      NZVNYOUVIUKVPUMZYTUGZYPUVNNUIZHUOZVNZVNYOUVBVNUDUEYRUUHUHVQZUVEUVHYOUVSUV
      CUVFUVDUVGUUHUHYTVRUVSUUIYPYPHUUHUHNVSVTWAWBUUHUVIVQZUVEUVMYOUVTUVCUVJUVD
      UVLUUHUVIYTVRUVTUUIUVKYPHUUHUVINVSVTWAWBUUHUVNVQZUVEUVRYOUWAUVCUVOUVDUVQU
      UHUVNYTVRUWAUUIUVPYPHUUHUVNNVSZVTWAWBUUHYRVQZUVEUVBYOUWCUVCUUAUVDUUBUUHYR
      YTVRUWCUUIYSYPHUUHYRNVSVTWAWBYOUVFUVGYOUVFVGZYPHQQHWCZUWDHOQRSWDZWEYOYTQU
      HNYOUUEUUSYTQNWGZUURNUUCUUDWFQNWRVLZWHWIWJUVIVMUGZYOUVMUVRYOUWIUVMUVRVNYO
      UWIVGZUVMUVOUVLVNUVRUWJUVOUVJUVLYOUWIUVOUVJUWIUVOUVJYOUWIUVIUHWKUIUGUVOUV
      JUVIWLUVIUHYQWMWNWOZWPWQUWJUVOUVLUVQYOUWIUVOUVLUVQVNYOUWIUVOWSZUVLUVKUVPH
      UOZUVQUWLUVKQUGUVPUVKJUIZVAZUGUWMUWLYTQUVINYOUWIUWGUVOUWHWTUWKXAUWLUVPUVN
      UKULUMZNUIZJUIZVAZUWOUWLUVNUUOUGZUUPUVPUWSUGZUWLUVNUKWKUIZUGUVNUVNYQUNUMU
      GZUWTUWLUVNUSUXBUWIYOUVNUSUGUVOUVIXBXCXDXEUVOYOUXCUWIUVNUHYQXHXFUVNUKYQXG
      XIYOUWIUUPUVOYOUUEUUGUUPUUQXJWTUUNUXAUDUVNUUOUWAUUIUVPUUMUWSUWBUWAUULUWRU
      WAUUKUWQJUWAUUJUWPNUUHUVNUKULXKXLXLXMXNXOXPUWLUWRUWNUWLUWQUVKJUWLUWPUVINU
      WLUVIXQUGZUKXQUGUWPUVIVQUWIYOUXDUVOUVIXRXCXSUVIUKXTYAXLXLXMYBBCDEUVKUVPHJ
      MOPQRSTUAYCYDUWLYPUVKUVPHQUWEUWLUWFWEYEYFWPYJYGYHYJYIYKYLABCDEFGHIJKLMNOP
      QRSTUAUBUCYMYN $.

    $( A singleton of an irreducible word is an extension sequence.
       (Contributed by Mario Carneiro, 27-Sep-2015.) $)
    efgs1 $p |- ( A e. D -> <" A "> e. dom S ) $=
      ( vi wcel cs1 cword c0 csn cdif cc0 cfv cv c1 cmin co crn chash cfzo wral
      cdm ciun eldifi eleq2s s1cld s1nz eldifsn mpbiran2 sylibr s1fv id eqeltrd
      wne wceq s1len a1i oveq2d fzo0 syl6eq rzal syl efgsdm syl3anbrc ) GHUEZGU
      FZQUGZUHUIUJUEZUKWEULZHUEUDUMZWEULWIUNUOUPWEULKULUQUEZUDUNWEURULZUSUPZUTZ
      WEJVAUEWDWEWFUEZWGWDGQGQUEGQAQAUMKULUQVBZUJHGQWOVCUBVDVEWGWNWEUHVMGVFWEWF
      UHVGVHVIWDWHGHGHVJWDVKVLWDWLUHVNWMWDWLUNUNUSUPUHWDWKUNUNUSWKUNVNWDGVOVPVQ
      UNVRVSWJUDWLVTWAABCDEFHIJKUDLMNWEOPQRSTUAUBUCWBWC $.

    $( Every extension sequence ending in an irreducible word is trivial.
       (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgs1b $p |- ( A e. dom S -> ( ( S ` A ) e. D <-> ( # ` A ) = 1 ) ) $=
      ( va cdm wcel cfv chash c1 wceq cv crn ciun wn eldifn eleq2s c2 cuz cn wo
      cdif cword c0 csn cc0 cmin co cfzo wral efgsdm simp1bi wa eldifsn lennncl
      wne sylbi syl elnn1uz2 sylib ord wrex wf eldifad adantr wrdf cfz cz caddc
      1z simpr df-2 fveq2i syl6eleq sylancr nnuz syl6eleqr lbfzo0 sylibr fzoend
      eluzp1m1 elfzofz 3syl eluzelz adantl fzoval eleqtrrd uz2m1nn sylan2 fveq2
      ffvelrnd efgsdmi rneqd eleq2d syl2anc eliun cbviunv ex syld con1d simp2bi
      rspcev oveq1 1m1e0 syl6eq fveq2d eleq1d syl5ibrcom efgsval sylibrd impbid
      syl5 ) GJUEUFZGJUGZHUFZGUHUGZUIUJZYNYMAQAUKZKUGZULZUMZUFZUNZYLYPUUBYMQYTV
      AHYMQYTUOUBUPYLYPUUAYLYPUNYOUQURUGZUFZUUAYLYPUUDYLYOUSUFZYPUUDUTYLGQVBZVC
      VDZVAUFZUUEYLUUHVEGUGZHUFZUDUKZGUGUUKUIVFVGGUGKUGULUFUDUIYOVHVGVIZABCDEFH
      IJKUDLMNGOPQRSTUAUBUCVJZVKZUUHGUUFUFZGVCVOVLUUEGUUFVCVMQGVNVPVQYOVRVSVTYL
      UUDUUAYLUUDVLZYMUDQUUKKUGZULZUMZYTUUPYMUURUFZUDQWAZYMUUSUFUUPYOUIVFVGZUIV
      FVGZGUGZQUFYMUVDKUGZULZUFZUVAUUPVEYOVHVGZQUVCGUUPUUOUVHQGWBYLUUOUUDYLGUUF
      UUGUUNWCWDQGWEVQUUPUVCVEUVBWFVGZUVHUUPVEVEUVBVHVGZUFZUVCUVJUFUVCUVIUFUUPU
      VBUSUFZUVKUUPUVBUIURUGZUSUUPUIWGUFYOUIUIWHVGZURUGZUFUVBUVMUFWIUUPYOUUCUVO
      YLUUDWJUQUVNURWKWLWMUIYOWTWNWOWPUVBWQWRVEUVBWSUVCVEUVBXAXBUUPYOWGUFZUVHUV
      IUJUUDUVPYLUQYOXCXDVEYOXEVQXFXJUUDYLUVLUVGYOXGABCDEFHIJKLMNGOPQRSTUAUBUCX
      KXHUUTUVGUDUVDQUUKUVDUJZUURUVFYMUVQUUQUVEUUKUVDKXIXLXMYAXNUDYMQUURXOWRUDA
      QUURYSUUKYQUJUUQYRUUKYQKXIXLXPWMXQXRXSYKYLYPUVBGUGZHUFZYNYLUVSYPUUJYLUUHU
      UJUULUUMXTYPUVRUUIHYPUVBVEGYPUVBUIUIVFVGVEYOUIUIVFYBYCYDYEYFYGYLYMUVRHABC
      DEFHIJKLMNGOPQRSTUAUBUCYHYFYIYJ $.

    $( If ` F ` is an extension sequence and ` A ` is an extension of the last
       element of ` F ` , then ` F + <" A "> ` is an extension sequence.
       (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgsp1 $p |- ( ( F e. dom S /\ A e. ran ( T ` ( S ` F ) ) ) ->
      ( F concat <" A "> ) e. dom S ) $=
      ( vi va cdm wcel cfv crn wa cs1 cconcat co cword c0 csn cdif cc0 cv chash
      cmin cfzo wral wne efgsdm simp1bi adantr eldifad cfz c2o cxp wss cs2 cotp
      c1 wf csplice cmpt2 wceq crab efgsf feq2i mpbir ffvelrni efgtf syl simprd
      fdmi frn simpr sseldd s1cld ccatcl syl2anc cn caddc ccatlen oveq2i syl6eq
      s1len cn0 lencl nn0p1nn 3syl eqeltrd cfn wb wrdfin hashnncl mpbid eldifsn
      sylanbrc eldifsni mpbird lbfzo0 ccatval1 syl3anc simp2bi cun simp3bi 1nn0
      sylibr w3a cuz nn0uz eleqtri fzoss1 ax-mp sseli syl3an3 elfzoel2 peano2zm
      cz cle wbr syl3anbrc fveq2d rneqd eleq12d lem1d eluz2 fzoss2 elfzoelz ibi
      zred elfzom1b 3expa ralbidva nn0cnd addid2d 1nn eqeltri a1i ccatval3 s1fv
      eqtr3d adantl fzo0end efgsval eqtr4d fvex fveq2 oveq1 ralsn ralunb oveq2d
      3eltr4d nnuz syl6eleq fzosplitsn eqtrd raleqdv ) OJUGZUHZGOJUIZKUIZUJZUHZ
      UKZOGULZUMUNZRUOZUPUQZURZUHZUSUWBUIZHUHUEUTZUWBUIZUWHVPVBUNZUWBUIZKUIZUJZ
      UHZUEVPUWBVAUIZVCUNZVDZUWBUVNUHUVTUWBUWCUHZUWBUPVEZUWFUVTOUWCUHZUWAUWCUHZ
      UWRUVTOUWCUWDUVOOUWEUHZUVSUVOUXBUSOUIZHUHZUWHOUIZUWJOUIZKUIZUJZUHZUEVPOVA
      UIZVCUNZVDZABCDEFHIJKUELMNOPQRSTUAUBUCUDVFZVGVHZVIZUVTGRUVTUVRRGUVTUSUVPV
      AUIVJUNZPVKVLZVLZRUVQVQZUVRRVMUVTUVQUFUEUXPUXQUVPUFUTZUXTUWHUWHQUIVNVOVRU
      NVSVTZUXSUVTUVPRUHZUYAUXSUKUVOUYBUVSUVNROJUVNRJVQUSFUTZUIHUHLUTZUYCUIUYDV
      PVBUNUYCUIKUIUJUHLVPUYCVAUIVCUNVDUKFUWEWAZRJVQABCDEFHIJKLMNPQRSTUAUBUCUDW
      BZUVNUYERJUYERJUYFWIWCWDWEVHBCDEIKNPQRUVPUFUESTUAUBWFWGWHUXRRUVQWJWGUVOUV
      SWKZWLWMZROUWAWNWOZUVTUWOWPUHZUWSUVTUWOUXJVPWQUNZWPUVTUWOUXJUWAVAUIZWQUNZ
      UYKUVTUWTUXAUWOUYMVTUXOUYHROUWAWRWOUYLVPUXJWQGXAZWSWTZUVTUWTUXJXBUHZUYKWP
      UHUXOROXCZUXJXDXEXFUVTUWRUWBXGUHUYJUWSXHUYIRUWBXIUWBXJXEXKUWBUWCUPXLXMUVT
      UWGUXCHUVTUWTUXAUSUSUXJVCUNZUHZUWGUXCVTUXOUYHUVTUXJWPUHZUYSUVTUYTOUPVEZUV
      TUXBVUAUXNOUWCUPXNWGUVTUWTOXGUHUYTVUAXHUXOROXIOXJXEXOZUXJXPYCROUWAUSXQXRU
      VOUXDUVSUVOUXBUXDUXLUXMXSVHXFUVTUWQUWNUEUXKUXJUQZXTZVDZUVTUWNUEUXKVDZUWNU
      EVUCVDZVUEUVTVUFUXLUVOUXLUVSUVOUXBUXDUXLUXMYAVHUVTUWTUXAVUFUXLXHUXOUYHUWT
      UXAUKUWNUXIUEUXKUWTUXAUWHUXKUHZUWNUXIXHUWTUXAVUHYDZUWIUXEUWMUXHVUHUWTUXAU
      WHUYRUHUWIUXEVTUXKUYRUWHVPUSYEUIZUHUXKUYRVMVPXBVUJYBYFYGVPUSUXJYHYIYJROUW
      AUWHXQYKVUIUWLUXGVUIUWKUXFKVUHUWTUXAUWJUYRUHUWKUXFVTVUHUSUXJVPVBUNZVCUNZU
      YRUWJVUHUXJVUKYEUIUHZVULUYRVMVUHVUKYNUHZUXJYNUHZVUKUXJYOYPVUMVUHVUOVUNUWH
      VPUXJYLZUXJYMWGVUPVUHUXJVUHUXJVUPUUFUUAVUKUXJUUBYQVUKUSUXJUUCWGVUHUWJVULU
      HZVUHUWHYNUHVUOVUHVUQXHUWHVPUXJUUDVUPUWHUXJUUGWOUUEWLROUWAUWJXQYKYRYSYTUU
      HUUIWOXOUVTUXJUWBUIZVUKUWBUIZKUIZUJZUHZVUGUVTVURUSUWAUIZVVAUVTUSUXJWQUNZU
      WBUIZVURVVCUVTVVDUXJUWBUVTUXJUVTUXJUVTUWTUYPUXOUYQWGUUJUUKYRUVTUWTUXAUSUS
      UYLVCUNUHZVVEVVCVTUXOUYHUVTUYLWPUHZVVFVVGUVTUYLVPWPUYNUULUUMUUNUYLXPYCROU
      WAUSUUOXRUUQUVTGUVRVVCVVAUYGUVSVVCGVTUVOGUVRUUPUURUVTVUTUVQUVTVUSUVPKUVTV
      USVUKOUIZUVPUVTUWTUXAVUKUYRUHZVUSVVHVTUXOUYHUVTUYTVVIVUBUXJUUSWGROUWAVUKX
      QXRUVOUVPVVHVTUVSABCDEFHIJKLMNOPQRSTUAUBUCUDUUTVHUVAYRYSUVHXFUWNVVBUEUXJO
      VAUVBUWHUXJVTZUWIVURUWMVVAUWHUXJUWBUVCVVJUWLVUTVVJUWKVUSKVVJUWJVUKUWBUWHU
      XJVPVBUVDYRYRYSYTUVEYCUWNUEUXKVUCUVFXMUVTUWNUEUWPVUDUVTUWPVPUYKVCUNZVUDUV
      TUWOUYKVPVCUYOUVGUVTUXJVPYEUIZUHVVKVUDVTUVTUXJWPVVLVUBUVIUVJVPUXJUVKWGUVL
      UVMXOABCDEFHIJKUELMNUWBPQRSTUAUBUCUDVFYQ $.

    $( An initial segment of an extension sequence is an extension sequence.
       (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgsres $p |- ( ( F e. dom S /\ N e. ( 1 ... ( # ` F ) ) ) ->
      ( F |` ( 0 ..^ N ) ) e. dom S ) $=
      ( vi cdm wcel c1 chash cfv cfz co wa cc0 cfzo cres cword c0 csn cdif cmin
      crn wral wne cop csubstr wceq efgsdm simp1bi adantr eldifad cuz wss nn0uz
      cv 1nn0 eleqtri fzss1 ax-mp simpr sseldi swrd0val syl2anc swrdcl eqeltrrd
      cn0 syl cn swrd0len elfznn adantl eqeltrd cfn wb wrdfin hashnncl eqnetrrd
      mpbid eldifsn sylanbrc lbfzo0 sylibr fvres simp2bi elfzuz3 fzoss2 simp3bi
      3syl ssralv sylc fzoss1 sseli cz caddc elfzoel2 peano2zm uzid zcnd ax-1cn
      cc npcan sylancl fveq2d eleqtrrd peano2uzr elfzoelz elfzom1b sseldd rneqd
      ibi eleq12d ralbiia eqtr3d oveq2d raleqdv mpbird syl3anbrc ) NIUFZUGZQUHN
      UIUJZUKULZUGZUMZNUNQUOULZUPZRUQZURUSZUTZUGZUNUUEUJZGUGUEVOZUUEUJZUUKUHVAU
      LZUUEUJZJUJZVBZUGZUEUHUUEUIUJZUOULZVCZUUEYRUGUUCUUEUUFUGUUEURVDUUIUUCNUNQ
      VEVFULZUUEUUFUUCNUUFUGZQUNYTUKULZUGZUVAUUEVGUUCNUUFUUGYSNUUHUGZUUBYSUVEUN
      NUJZGUGZUUKNUJZUUMNUJZJUJZVBZUGZUEUHYTUOULZVCZABCDEFGHIJUEKLMNOPRSTUAUBUC
      UDVHZVIVJVKZUUCUUAUVCQUHUNVLUJZUGZUUAUVCVMUHWFUVQVPVNVQZUHUNYTVRVSYSUUBVT
      WAZRNQWBWCZUUCUVBUVAUUFUGZUVPRNUNQWDWGZWEUUCUVAUUEURUWAUUCUVAUIUJZWHUGZUV
      AURVDZUUCUWDQWHUUCUVBUVDUWDQVGUVPUVTRNQWIWCZUUBQWHUGZYSQYTWJWKZWLUUCUWBUV
      AWMUGUWEUWFWNUWCRUVAWOUVAWPXHWRWQUUEUUFURWSWTUUCUUJUVFGUUCUNUUDUGZUUJUVFV
      GUUCUWHUWJUWIQXAXBUNUUDNXCWGYSUVGUUBYSUVEUVGUVNUVOXDVJWLUUCUUTUUQUEUHQUOU
      LZVCZUUCUVLUEUWKVCZUWLUUCUWKUVMVMZUVNUWMUUCYTQVLUJZUGZUWNUUBUWPYSQUHYTXEW
      KQUHYTXFWGYSUVNUUBYSUVEUVGUVNUVOXGVJUVLUEUWKUVMXIXJUUQUVLUEUWKUUKUWKUGZUU
      LUVHUUPUVKUWQUUKUUDUGUULUVHVGUWKUUDUUKUVRUWKUUDVMUVSUHUNQXKVSXLUUKUUDNXCW
      GUWQUUOUVJUWQUUNUVIJUWQUUMUUDUGUUNUVIVGUWQUNQUHVAULZUOULZUUDUUMUWQQUWRVLU
      JUGZUWSUUDVMUWQUWRXMUGZQUWRUHXNULZVLUJZUGUWTUWQQXMUGZUXAUUKUHQXOZQXPWGUWQ
      QUWOUXCUWQUXDQUWOUGUXEQXQWGUWQUXBQVLUWQQXTUGUHXTUGUXBQVGUWQQUXEXRXSQUHYAY
      BYCYDUWRQYEWCUWRUNQXFWGUWQUUMUWSUGZUWQUUKXMUGUXDUWQUXFWNUUKUHQYFUXEUUKQYG
      WCYJYHUUMUUDNXCWGYCYIYKYLXBUUCUUQUEUUSUWKUUCUURQUHUOUUCUWDUURQUUCUVAUUEUI
      UWAYCUWGYMYNYOYPABCDEFGHIJUEKLMUUEOPRSTUAUBUCUDVHYQ $.

    $( For any word, there is a sequence of extensions starting at a reduced
       word and ending at the target word, such that each word in the chain is
       an extension of the previous (inserting an element and its inverse at
       adjacent indexes somewhere in the sequence).  (Contributed by Mario
       Carneiro, 27-Sep-2015.) $)
    efgsfo $p |- S : dom S -onto-> W $=
      ( vc va vb vd vo vi cdm wfo wf crn wceq cc0 cv wcel c1 cmin co chash cfzo
      cfv wral wa cword c0 csn cdif crab efgsf fdmi feq2i mpbir wss ax-mp caddc
      frn clt wbr cn0 c2o cxp cid fviss eqsstri sseli lencl syl peano2nn0 breq2
      nn0nlt0 notbid syl5ibr syl5 ralrimiv rabeq0 sylibr sseq1d weq rabbidv 0ss
      wn cun simpr fveq2 eqeq1d cbvrabv w3a ciun wrex eliun rneqd cbvrexv bitri
      eleq2d simpl1r simprl c2 cr crp sseldi nn0red 2rp ltaddrp sylancl efgtlen
      adantl breq1d elrab sylanbrc sseldd 3syl fnfvelrn sylancr eqeltrrd sylbir
      wb ex id syl2anr simpl3 breqtrd wfn ffn fvelrnb sylib cs1 cconcat simprrl
      eqtr3d efgsdm simp1bi eldifi simpl2 simprlr simprrr fveq2d efgsp1 syl2anc
      eleqtrrd efgsval2 syl3anc anassrs rexlimddv rexlimdvaa syl5bi eldif efgs1
      eleq2i efgsval s1len oveq1i 1m1e0 eqtri fveq2i a1i adantr 3eqtrd 3ad2ant2
      wi s1fv pm2.61d rabssdv syl5eqss unssd cle nn0leltp1 nn0re leloe rabbidva
      wo bitr3d unrab syl6eqr sylibrd nn0ind ltp1d ssriv eqssi dffo2 mpbir2an )
      IUIZPIUJUXBPIUKZIULZPUMUXCUNFUOZVBGUPKUOZUXEVBUXFUQURUSUXEVBJVBULUPKUQUXE
      UTVBVAUSVCVDFPVEZVFVGZVHZVIZPIUKABCDEFGHIJKLMNOPQRSTUAUBVJZUXBUXJPIUXJPIU
      XKVKVLVMZUXDPUXCUXDPVNUXLUXBPIVQVOUCPUXDUCUOZPUPZUDUOZUTVBZUXMUTVBZUQVPUS
      ZVRVSZUDPVIZUXDUXMUXNUXQVTUPZUXRVTUPUXTUXDVNZUXNUXMNWAWBZVEZUPUYAPUYDUXMP
      UYDWCVBUYDQUYDWDWEZWFUYCUXMWGWHZUXQWIUXPUEUOZVRVSZUDPVIZUXDVNVFUXDVNUXPUF
      UOZVRVSZUDPVIZUXDVNZUXPUYJUQVPUSZVRVSZUDPVIZUXDVNZUYBUEUFUXRUYGUNUMZUYIVF
      UXDUYRUYHXBZUDPVCUYIVFUMUYRUYSUDPUXOPUPZUXPVTUPZUYRUYSUYTUXOUYDUPVUAPUYDU
      XOUYEWFUYCUXOWGWHZVUAUYSUYRUXPUNVRVSZXBUXPWKUYRUYHVUCUYGUNUXPVRWJWLWMWNWO
      UYHUDPWPWQWRUEUFWSZUYIUYLUXDVUDUYHUYKUDPUYGUYJUXPVRWJWTWRUYGUYNUMZUYIUYPU
      XDVUEUYHUYOUDPUYGUYNUXPVRWJWTWRUYGUXRUMZUYIUXTUXDVUFUYHUXSUDPUYGUXRUXPVRW
      JWTWRUXDXAUYJVTUPZUYMUYLUXPUYJUMZUDPVIZXCZUXDVNZUYQVUGUYMVUKVUGUYMVDZUYLV
      UIUXDVUGUYMXDVULVUIUXQUYJUMZUCPVIUXDVUHVUMUDUCPUDUCWSZUXPUXQUYJUXOUXMUTXE
      ZXFXGVULVUMUCPUXDVULUXNVUMXHZUXMAPAUOZJVBZULZXIZUPZUXMUXDUPZVVAUXMUYGJVBZ
      ULZUPZUEPXJZVUPVVBVVAUXMVUSUPZAPXJVVFAUXMPVUSXKVVGVVEAUEPAUEWSZVUSVVDUXMV
      VHVURVVCVUQUYGJXEXLXOXMXNVUPVVEVVBUEPVUPUYGPUPZVVEVDZVDZUGUOZIVBZUYGUMZVV
      BUGUXBVVKUYGUXDUPZVVNUGUXBXJZVVKUYLUXDUYGVUGUYMUXNVUMVVJXPVVKVVIUYGUTVBZU
      YJVRVSZUYGUYLUPVUPVVIVVEXQZVVKVVQVVQXRVPUSZUYJVRVVKVVQXSUPXRXTUPVVQVVTVRV
      SVVKVVQVVKUYGUYDUPVVQVTUPVVKPUYDUYGUYEVVSYAUYCUYGWGWHYBYCVVQXRYDYEVVKUXQV
      VTUYJVVJUXQVVTUMVUPBCDEUXMHJMNOPUYGQRSTYFYGVULUXNVUMVVJUUAUUJUUBUYKVVRUDU
      YGPUDUEWSUXPVVQUYJVRUXOUYGUTXEYHYIYJYKIUXBUUCZVVOVVPYQUXCVWAUXLUXBPIUUDVO
      ZUGUXBUYGIUUEVOUUFVUPVVJVVLUXBUPZVVNVDZVVBVUPVVJVWDVDZVDZVVLUXMUUGZUUHUSZ
      IVBZUXMUXDVWFVVLUXGUPZUXNVWHUXBUPZVWIUXMUMVWFVWCVVLUXIUPZVWJVUPVVJVWCVVNU
      UIZVWCVWLUNVVLVBGUPUHUOZVVLVBVWNUQURUSVVLVBJVBULUPUHUQVVLUTVBVAUSVCABCDEF
      GHIJUHKLMVVLNOPQRSTUAUBUUKUULVVLUXGUXHUUMYLVULUXNVUMVWEUUNVWFVWCUXMVVMJVB
      ZULZUPVWKVWMVWFUXMVVDVWPVUPVVIVVEVWDUUOVWFVWOVVCVWFVVMUYGJVUPVVJVWCVVNUUP
      UUQXLUUTABCDEFUXMGHIJKLMVVLNOPQRSTUAUBUURUUSZABCDEFVVLUXMGHIJKLMNOPQRSTUA
      UBUVAUVBVWFVWAVWKVWIUXDUPVWBVWQUXBVWHIYMYNYOUVCUVDUVEUVFUXNVULVVAXBZVVBUV
      TVUMUXNVWRVVBUXNVWRVDZVWGIVBZUXMUXDVWSVWTVWGUTVBZUQURUSZVWGVBZUNVWGVBZUXM
      VWSVWGUXBUPZVWTVXCUMVWSUXMPVUTVHZUPZVXEUXMPVUTUVGVXGUXMGUPVXEGVXFUXMUAUVI
      ABCDEFUXMGHIJKLMNOPQRSTUAUBUVHYPYPZABCDEFGHIJKLMVWGNOPQRSTUAUBUVJWHVXCVXD
      UMVWSVXBUNVWGVXBUQUQURUSUNVXAUQUQURUXMUVKUVLUVMUVNUVOUVPUXNVXDUXMUMVWRUXM
      PUWAUVQUVRVWSVWAVXEVWTUXDUPVWBVXHUXBVWGIYMYNYOYRUVSUWBUWCUWDUWEYRVUGUYPVU
      JUXDVUGUYPUYKVUHUWKZUDPVIVUJVUGUYOVXIUDPVUGUYTVDUXPUYJUWFVSZUYOVXIUYTVUAV
      UGVXJUYOYQVUGVUBVUGYSUXPUYJUWGYTUYTUXPXSUPUYJXSUPVXJVXIYQVUGUYTUXPVUBYBUY
      JUWHUXPUYJUWIYTUWLUWJUYKVUHUDPUWMUWNWRUWOUWPYLUXNUXNUXQUXRVRVSZUXMUXTUPUX
      NYSUXNUXQUXNUXQUYFYBUWQUXSVXKUDUXMPVUNUXPUXQUXRVRVUOYHYIYJYKUWRUWSUXBPIUW
      TUXA $.

    ${
      efgredlem.1 $e |- ( ph -> A. a e. dom S A. b e. dom S
        ( ( # ` ( S ` a ) ) < ( # ` ( S ` A ) ) ->
          ( ( S ` a ) = ( S ` b ) -> ( a ` 0 ) = ( b ` 0 ) ) ) ) $.
      efgredlem.2 $e |- ( ph -> A e. dom S ) $.
      efgredlem.3 $e |- ( ph -> B e. dom S ) $.
      efgredlem.4 $e |- ( ph -> ( S ` A ) = ( S ` B ) ) $.
      efgredlem.5 $e |- ( ph -> -. ( A ` 0 ) = ( B ` 0 ) ) $.
      $( The reduced word that forms the base of the sequence in ~ efgsval is
         uniquely determined, given the ending representation.  (Contributed by
         Mario Carneiro, 1-Oct-2015.) $)
      efgredlema $p |- ( ph ->
        ( ( ( # ` A ) - 1 ) e. NN /\ ( ( # ` B ) - 1 ) e. NN ) ) $=
        ( vu chash cfv c1 cmin co cn wcel c2 cuz wceq wn cc0 wa cdm efgsval syl
        eqtr3d oveq1 1m1e0 syl6eq fveq2d sylan9eq eleq1d wb efgs1b biimpa mtand
        3bitr3d wo cword c0 csn cdif cv crn cfzo efgsdm simp1bi eldifsn lennncl
        wral wne sylbi 3syl elnn1uz2 sylib ord mpd uz2m1nn mtbid jca ) AHUNUOZU
        PUQURZUSUTZIUNUOZUPUQURZUSUTZAXEVAVBUOZUTZXGAXEUPVCZVDXLAXMVEHUOZVEIUOZ
        VCULAXMVFZXIIUOZXNXOAXMXQXFHUOZXNAILUOZXQXRAILVGZUTZXSXQVCUJBCDEFGJKLMN
        OPIQRSUBUCUDUEUFUGVHVIAHLUOZXSXRUKAHXTUTZYBXRVCUIBCDEFGJKLMNOPHQRSUBUCU
        DUEUFUGVHVIVJVJXMXFVEHXMXFUPUPUQURZVEXEUPUPUQVKVLVMVNVOXPXHUPVCZXQXOVCA
        XMYEAYBJUTZXSJUTZXMYEAYBXSJUKVPAYCYFXMVQUIBCDEFGHJKLMNOPQRSUBUCUDUEUFUG
        VRVIAYAYGYEVQUJBCDEFGIJKLMNOPQRSUBUCUDUEUFUGVRVIWAZVSYEXIVEIYEXIYDVEXHU
        PUPUQVKVLVMVNVIVJVTZAXMXLAXEUSUTZXMXLWBAYCHSWCZWDWEWFZUTZYJUIYCYMXNJUTU
        MWGZHUOYNUPUQURZHUOMUOWHUTUMUPXEWIURWNBCDEFGJKLMUMNOPHQRSUBUCUDUEUFUGWJ
        WKYMHYKUTHWDWOVFYJHYKWDWLSHWMWPWQXEWRWSWTXAXEXBVIAXHXKUTZXJAYEVDYPAXMYE
        YIYHXCAYEYPAXHUSUTZYEYPWBAYAIYLUTZYQUJYAYRXOJUTYNIUOYOIUOMUOWHUTUMUPXHW
        IURWNBCDEFGJKLMUMNOPIQRSUBUCUDUEUFUGWJWKYRIYKUTIWDWOVFYQIYKWDWLSIWMWPWQ
        XHWRWSWTXAXHXBVIXD $.

      ${
        efgredlemb.k $e |- K = ( ( ( # ` A ) - 1 ) - 1 ) $.
        efgredlemb.l $e |- L = ( ( ( # ` B ) - 1 ) - 1 ) $.
        $( Lemma for ~ efgredleme .  (Contributed by Mario Carneiro,
           4-Jun-2016.) $)
        efgredlemf $p |- ( ph -> ( ( A ` K ) e. W /\ ( B ` L ) e. W ) ) $=
          ( vi cfv wcel cc0 chash cfzo co cword wf c0 csn cdm cdif cv cmin wral
          c1 crn efgsdm simp1bi syl eldifad wrdf cfz fzossfz cz cn0 lencl nn0zd
          fzoval syl5sseqr cn efgredlema simpld syl5eqel sseldd ffvelrnd simprd
          wceq fzo0end jca ) ARHURUAUSSIURUAUSAUTHVAURZVBVCZUARHAHUAVDZUSZWSUAH
          VEAHWTVFVGZAHLVHZUSZHWTXBVIZUSZUKXDXFUTHURJUSUQVJZHURXGVMVKVCZHURMURV
          NUSUQVMWRVBVCVLBCDEFGJKLMUQNOPHQTUAUDUEUFUGUHUIVOVPVQVRZUAHVSVQAUTWRV
          MVKVCZVBVCZWSRAUTXJVTVCZXKWSUTXJWAAWRWBUSWSXLWOAWRAXAWRWCUSXIUAHWDVQW
          EUTWRWFVQWGARXJVMVKVCZXKUOAXJWHUSZXMXKUSAXNIVAURZVMVKVCZWHUSZABCDEFGH
          IJKLMNOPQTUAUBUCUDUEUFUGUHUIUJUKULUMUNWIZWJXJWPVQWKWLWMAUTXOVBVCZUASI
          AIWTUSZXSUAIVEAIWTXBAIXCUSZIXEUSZULYAYBUTIURJUSXGIURXHIURMURVNUSUQVMX
          OVBVCVLBCDEFGJKLMUQNOPIQTUAUDUEUFUGUHUIVOVPVQVRZUAIVSVQAUTXPVBVCZXSSA
          UTXPVTVCZYDXSUTXPWAAXOWBUSXSYEWOAXOAXTXOWCUSYCUAIWDVQWEUTXOWFVQWGASXP
          VMVKVCZYDUPAXQYFYDUSAXNXQXRWNXPWPVQWKWLWMWQ $.

        efgredlemb.p $e |- ( ph -> P e. ( 0 ... ( # ` ( A ` K ) ) ) ) $.
        efgredlemb.q $e |- ( ph -> Q e. ( 0 ... ( # ` ( B ` L ) ) ) ) $.
        efgredlemb.u $e |- ( ph -> U e. ( I X. 2o ) ) $.
        efgredlemb.v $e |- ( ph -> V e. ( I X. 2o ) ) $.
        efgredlemb.6 $e |- ( ph -> ( S ` A ) = ( P ( T ` ( A ` K ) ) U ) ) $.
        efgredlemb.7 $e |- ( ph -> ( S ` B ) = ( Q ( T ` ( B ` L ) ) V ) ) $.
        $( Lemma for ~ efgred .  (Contributed by Mario Carneiro,
           4-Jun-2016.) $)
        efgredlemg $p |- ( ph -> ( # ` ( A ` K ) ) = ( # ` ( B ` L ) ) ) $=
          ( cfv chash c2 c2o cxp cword wcel cn0 fviss eqsstri efgredlemf simpld
          cid sseldi lencl syl nn0cnd simprd cc 2cn a1i caddc crn wceq cmin cdm
          co efgredlema efgsdmi syl2anc fveq2i syl6eleqr efgtlen eqeltrd eqtr3d
          c1 cn rneqi addcan2ad ) AUAHVGZVHVGZUBIVGZVHVGZVIAXGAXFTVJVKZVLZVMXGV
          NVMAUEXKXFUEXKVSVGXKUHXKVOVPZAXFUEVMZXHUEVMZABCDEFGHIJMNOQRSTUAUBUCUE
          UFUGUHUIUJUKULUMUNUOUPUQURUSUTVQZVRZVTXJXFWAWBWCAXIAXHXKVMXIVNVMAUEXK
          XHXLAXMXNXOWDZVTXJXHWAWBWCVIWEVMAWFWGAHNVGZVHVGZXGVIWHWMZXIVIWHWMZAXM
          XRXFOVGZWIZVMXSXTWJXPAXRHVHVGXBWKWMZXBWKWMZHVGZOVGZWIZYCAHNWLZVMYDXCV
          MZXRYHVMUOAYJIVHVGXBWKWMZXCVMZABCDEFGHIJMNOQRSTUCUEUFUGUHUIUJUKULUMUN
          UOUPUQURWNZVRBCDEFGJMNOQRSHTUCUEUHUIUJUKULUMWOWPYBYGXFYFOUAYEHUSWQWQX
          DWRCDEFXRMOSTUCUEXFUHUIUJUKWSWPAXNXRXHOVGZWIZVMXSYAWJXQAXRYKXBWKWMZIV
          GZOVGZWIZYOAXRINVGZYSUQAIYIVMYLYTYSVMUPAYJYLYMWDBCDEFGJMNOQRSITUCUEUH
          UIUJUKULUMWOWPWTYNYRXHYQOUBYPIUTWQWQXDWRCDEFXRMOSTUCUEXHUHUIUJUKWSWPX
          AXE $.

        efgredlemb.8 $e |- ( ph -> -. ( A ` K ) = ( B ` L ) ) $.
        ${
          efgredlemd.9 $e |- ( ph -> P e. ( ZZ>= ` ( Q + 2 ) ) ) $.
          efgredlemd.c $e |- ( ph -> C e. dom S ) $.
          efgredlemd.sc $e |- ( ph -> ( S ` C ) =
            ( ( ( B ` L ) substr <. 0 , Q >. ) concat
              ( ( A ` K ) substr <. ( Q + 2 ) , ( # ` ( A ` K ) ) >. ) ) ) $.
          $( Lemma for ~ efgred .  (Contributed by Mario Carneiro,
             1-Oct-2015.) $)
          efgredleme $p |- ( ph -> ( ( A ` K ) e. ran ( T ` ( S ` C ) ) /\
                                     ( B ` L ) e. ran ( T ` ( S ` C ) ) ) ) $=
            ( vi cfv crn wcel co cs2 cotp csplice cc0 cop csubstr cconcat caddc
            c2 chash cfz cxp wceq wf cv c1 cmin wa cword c0 ffvelrni syl elfzuz
            cuz fveq2d simprd swrdcl simpld syl2anc swrd0len 2nn0 sylancl uztrn
            cn0 elfzuzb sylanbrc swrdlen syl3anc cz zcnd 2cn a1i 3eqtr2d 3eqtrd
            2z efgtval eluzfz1 cle wbr ccatswrd syl13anc oveq1d ccatass 3eqtr3d
            cc cr ccatcl wb eqtr4d ccatopth syl221anc mpbid oveq2d eqeltrrd c2o
            cdm cfzo wral csn cdif crab efgsf fdmi feq2i mpbir fviss efgredlemf
            eqsstri sseldi ccatlen uzaddcl elfzuz3 lencl nn0uz syl6eleq eluzfz2
            cid oveq12d elfzelz nn0cnd zaddcl addsubassd pnpcand npcan eleqtrrd
            zsubcl eluzsub eqeltrd wrd0 efgmf s2cld zred nn0addge1 eluz2 splval
            ccatrid 3eqtr4rd eqcomd hash0 oveq2i addid1d syl5req splval2 pncan2
            syl3anbrc eqtrd s2len syl6eqr eqtr3d wfn cmpt2 efgtf ffn efgredlemg
            swrdid fnovrn nn0ge0i 2re subge02 sub32d subsub4d eqtr2d syl5eq jca
            nncan ) AUBHVMZJOVMZPVMZVNZVOUCIVMZUXOVOAMUEUXNVPZUXLUXOAUXQUXMMMUE
            UEUDVMZVQZVRZVSVPZUXLVTMWAZWBVPZUXSWCVPZUXLMWEWDVPZUXLWFVMZWAWBVPZW
            CVPZUXLAUXMUFVOZMVTUXMWFVMZWGVPZVOZUEUAUUAWHZVOZUXQUYAWIAJOUUBZVOUY
            IVJUYOUFJOUYOUFOWJVTGWKZVMKVORWKZUYPVMUYQWLWMVPUYPVMPVMVNVORWLUYPWF
            VMUUCVPUUDWNGUFWOWPUUEUUFUUGZUFOWJBCDEFGKNOPRSTUAUDUFUIUJUKULUMUNUU
            HZUYOUYRUFOUYRUFOUYSUUIUUJUUKWQWRZAMVTWTVMZVOZUYJMWTVMZVOZUYLAMVTUX
            PWFVMZWGVPZVOZVUBVCMVTVUEWSWRZAUYJLWEWMVPZWTVMZVOZVUIVUCVOZVUDAUYJU
            YFWEWMVPZVUJAUYJUXPUYBWBVPZUYGWCVPZWFVMZVUNWFVMZUYGWFVMZWDVPZVUMAUX
            MVUOWFVKXAAVUNUYMWOZVOZUYGVUTVOZVUPVUSWIAUXPVUTVOZVVAAUFVUTUXPUFVUT
            UVCVMVUTUIVUTUULUUNZAUXLUFVOZUXPUFVOZABCDEFGHIKNOPRSTUAUBUCUDUFUGUH
            UIUJUKULUMUNUOUPUQURUSUTVAUUMZXBZUUOZUYMUXPVTMXCWRZAUXLVUTVOZVVBAUF
            VUTUXLVVDAVVEVVFVVGXDZUUOZUYMUXLUYEUYFXCWRZUYMVUNUYGUUPXEAVUSMUYFUY
            EWMVPZWDVPMUYFWDVPUYEWMVPVUMAVUQMVURVVOWDAVVCVUGVUQMWIVVIVCUYMUXPMX
            FXEZAVVKUYEVTUYFWGVPZVOZUYFVVQVOZVURVVOWIVVMAUYEVUAVOZUYFUYEWTVMZVO
            ZVVRAVUBWEXJVOZVVTVUHXGWEVTMUUQXHZAUYFLWTVMZVOZLVWAVOZVWBALVVQVOZVW
            FVBLVTUYFUURWRZVILUYFUYEXIXEUYEVTUYFXKXLZAUYFVUAVOVVSAUYFXJVUAAVVKU
            YFXJVOVVMUYMUXLUUSWRZUUTUVAVTUYFUVBWRZUYMUXLUYEUYFXMXNUVDAMUYFUYEAM
            AVUGMXOVOZVCMVTVUEUVEWRZXPZAUYFVWKUVFZAUYEAVWMWEXOVOZUYEXOVOZVWNYAM
            WEUVGXHZXPUVHAMUYFWEVWOVWPWEYKVOZAXQXRZUVIXSXTAVUIXOVOZVWQUYFVUIWEW
            DVPZWTVMZVOVUMVUJVOALXOVOZVWQVXBAVWHVXEVBLVTUYFUVEWRZYALWEUVLXHZVWQ
            AYAXRZAUYFVWEVXDVWIAVXCLWTALYKVOZVWTVXCLWIALVXFXPZXQLWEUVJXHXAUVKWE
            VUIUYFUVMXNUVNZAVWMVWQVWGVULVWNVXHVIWEMLUVMXNZVUIUYJMXIXEMVTUYJXKXL
            ZVECDEFUENPTUAUDMUFUXMUIUJUKULYBXNAUYCWPUYGUXSUXMMMUYMAVVKUYCVUTVOZ
            VVMUYMUXLVTMXCWRZWPVUTVOAUYMUVOXRZVVNAUEUXRUYMVEAUYNUXRUYMVOVEUYMUY
            MUEUDCDUAUDUKUVPZWQWRUVQZAUYCUYGWCVPVUOUYCWPWCVPZUYGWCVPUXMAUYCVUNU
            YGWCAUYCVUNWIZUXLMLWAWBVPZQQUDVMZVQZUXLLUYFWAWBVPZWCVPZWCVPZUXSUXPM
            VUEWAWBVPZWCVPZWIZAUYCVYFWCVPZVUNVYHWCVPZWIZVXTVYIWNZAUYCVYAWCVPZVY
            EWCVPZVUNUXSWCVPVYGWCVPZVYJVYKAVYOUXLVTLWAZWBVPZVYEWCVPZVYRVYCWCVPV
            YDWCVPZVYPAVYNVYRVYEWCAVVKVTVTMWGVPVOZMVTLWGVPZVOZVWHVYNVYRWIVVMAVU
            BWUAVUHVTMYCWRZAVUBLVUCVOZWUCVUHAVWGUYEVUCVOZWUEVIAVWMVWRMUYEYDYEZW
            UFVWNVWSAMYLVOVWCWUGAMVWNUVRXGMWEUVSXHMUYEUVTUWKZUYELMXIXEZMVTLXKXL
            VBUYMUXLVTMLYFYGYHAVYRVUTVOZVYCVUTVOZVYDVUTVOZVYTVYSWIAVVKWUJVVMUYM
            UXLVTLXCWRAQVYBUYMVDAQUYMVOZVYBUYMVOVDUYMUYMQUDVXQWQWRUVQZAVVKWULVV
            MUYMUXLLUYFXCWRZUYMVYRVYCVYDYIXNAHOVMZIOVMZVYTVYPURAWUPLQUXLPVMVPZU
            XLLLVYCVRVSVPZVYTVFAVVEVWHWUMWURWUSWIVVLVBVDCDEFQNPTUAUDLUFUXLUIUJU
            KULYBXNAVVEVWHVWHWUKWUSVYTWIVVLVBVBWUNVYCUXLLLUFVVQVVQVUTUWAYGXTAWU
            QMUEUXPPVMVPZUXPUXTVSVPZVYPVGAVVFVUGUYNWUTWVAWIVVHVCVECDEFUENPTUAUD
            MUFUXPUIUJUKULYBXNAVVFVUGVUGUXSVUTVOZWVAVYPWIVVHVCVCVXRUXSUXPMMUFVU
            FVUFVUTUWAYGXTYJXSAVXNVYAVUTVOZVYEVUTVOZVYOVYJWIVXOAVVKWVCVVMUYMUXL
            MLXCWRZAWUKWULWVDWUNWUOUYMVYCVYDYMXEZUYMUYCVYAVYEYIXNAVVAWVBVYGVUTV
            OZVYPVYKWIVVJVXRAVVCWVGVVIUYMUXPMVUEXCWRZUYMVUNUXSVYGYIXNYJAVXNVYFV
            UTVOZVVAVYHVUTVOZUYCWFVMZVUQWIVYLVYMYNVXOAWVCWVDWVIWVEWVFUYMVYAVYEY
            MXEVVJAWVBWVGWVJVXRWVHUYMUXSVYGYMXEAWVKMVUQAVVKMVVQVOZWVKMWIVVMAVUB
            UYFVUCVOZWVLVUHAVWFWUEWVMVWIWUILUYFMXIXEMVTUYFXKXLUYMUXLMXFXEZVVPYO
            UYCVYFVUNVYHUYMYPYQYRZXDYHAVXSUYCUYGWCAVXNVXSUYCWIVXOUYMUYCUWBWRYHV
            KUWCAWVKMWVNUWDAMWPWFVMZWDVPMVTWDVPMWVPVTMWDUWEUWFAMVWOUWGUWHUWIAUY
            HUXLVTUYEWAWBVPZUYGWCVPZUXLVTUYFWAWBVPZUXLAUYDWVQUYGWCAUYCUXLMUYEWA
            WBVPZWCVPZUYDWVQAWVTUXSUYCWCAWVTUXSWIZUXLUYELWAWBVPZVYEWCVPZVYGWIZA
            WVTWWDWCVPZVYHWIZWWBWWEWNZAWVTWWCWCVPZVYEWCVPZVYFWWFVYHAWWIVYAVYEWC
            AVVKMVTUYEWGVPZVOZUYEWUBVOZVWHWWIVYAWIVVMAVUBWUFWWLVUHWUHMVTUYEXKXL
            ZAVVTVWGWWMVWDVIUYEVTLXKXLZVBUYMUXLMUYELYFYGYHAWVTVUTVOZWWCVUTVOZWV
            DWWJWWFWIAVVKWWPVVMUYMUXLMUYEXCWRZAVVKWWQVVMUYMUXLUYELXCWRZWVFUYMWV
            TWWCVYEYIXNAVXTVYIWVOXBYJAWWPWWDVUTVOZWVBWVGWVTWFVMZUXSWFVMZWIWWGWW
            HYNWWRAWWQWVDWWTWWSWVFUYMWWCVYEYMXEVXRWVHAWXAWEWXBAWXAUYEMWMVPZWEAV
            VKWWLVVRWXAWXCWIVVMWWNVWJUYMUXLMUYEXMXNAMYKVOVWTWXCWEWIVWOXQMWEUWJX
            HUWLUEUXRUWMUWNWVTWWDUXSVYGUYMYPYQYRZXDYSAVVKWUAWWLVVRWWAWVQWIVVMWU
            DWWNVWJUYMUXLVTMUYEYFYGUWOYHAVVKVTWWKVOZVVRVVSWVRWVSWIVVMAVVTWXEVWD
            VTUYEYCWRVWJVWLUYMUXLVTUYEUYFYFYGAVVKWVSUXLWIVVMUYMUXLUXAWRXTXTAUXN
            UYKUYMWHZUWPZUYLUYNUXQUXOVOAWXFUFUXNWJZWXGAUXNUGVLUYKUYMUXMUGWKZWXI
            VLWKZWXJUDVMVQVRVSVPUWQWIZWXHAUYIWXKWXHWNUYTCDEFNPTUAUDUFUXMUGVLUIU
            JUKULUWRWRXBWXFUFUXNUWSWRZVXMVEUYKUYMMUEUXNUXBXNYTAVUIQUXNVPZUXPUXO
            AWXMUXMVUIVUIVYCVRVSVPZUXPVTVUIWAWBVPZVYCWCVPZUXPLVUEWAWBVPZWCVPZUX
            PAUYIVUIUYKVOZWUMWXMWXNWIUYTAVUIVUAVOZVUKWXSAVULVUBWXTVXLVUHMVUIVTX
            IXEZVXKVUIVTUYJXKXLZVDCDEFQNPTUAUDVUIUFUXMUIUJUKULYBXNAWXOWPWXQVYCU
            XMVUIVUIUYMAVVCWXOVUTVOZVVIUYMUXPVTVUIXCWRZVXPAVVCWXQVUTVOZVVIUYMUX
            PLVUEXCWRZWUNAUXMWXOWXQWCVPZWXOWPWCVPZWXQWCVPAUXMVUOVUNUXPMVUIWAWBV
            PZWCVPZWXQWCVPZWYGVKAVUOVUNWYIWXQWCVPZWCVPZWYKAUYGWYLVUNWCAWWCVYDWC
            VPZUYGWYLAVVKWWMVWHVVSWYNUYGWIVVMWWOVBVWLUYMUXLUYELUYFYFYGAWWCWYIVY
            DWXQWCAWWCWYIWIZVYEUXPVUIVUEWAWBVPZWIZAWWDWYIWYPWCVPZWIZWYOWYQWNZAW
            WDVYGWYRAWWBWWEWXDXBAVVCMVTVUIWGVPZVOZVUIVUFVOZVUEVUFVOZWYRVYGWIVVI
            AVUBVULXUBVUHVXLMVTVUIXKXLZAWXTVUEVUJVOZXUCWYAAVUEVWEVOZLVUJVOZXUFA
            UYFVUEVWEABCDEFGHIKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSU
            TVAVBVCVDVEVFVGUWTVWIYTZAVXBVXEVUILYDYEZXUHVXGVXFAVTWEYDYEZXUJXUKAW
            EXGUXCXRALYLVOWEYLVOXUKXUJYNALVXFUVRUXDLWEUXEXHYRVUILUVTUWKZLVUEVUI
            XIXEVUIVTVUEXKXLZAVUEVUAVOXUDAVUEXJVUAAVVCVUEXJVOVVIUYMUXPUUSWRUUTU
            VAVTVUEUVBWRZUYMUXPMVUIVUEYFYGYOAWWQWVDWYIVUTVOZWYPVUTVOZWWCWFVMZWY
            IWFVMZWIWYSWYTYNWWSWVFAVVCXUOVVIUYMUXPMVUIXCWRZAVVCXUPVVIUYMUXPVUIV
            UEXCWRAXUQLUYEWMVPZXURAVVKWWMVWHXUQXUTWIVVMWWOVBUYMUXLUYELXMXNAXURV
            UIMWMVPZLMWMVPWEWMVPXUTAVVCXUBXUCXURXVAWIVVIXUEXUMUYMUXPMVUIXMXNALM
            WEVXJVWOVXAUXFALMWEVXJVWOVXAUXGXSYOWWCVYEWYIWYPUYMYPYQYRZXDAVYCUXPV
            UILWAWBVPZWIZVYDWXQWIZAVYEXVCWXQWCVPZWIZXVDXVEWNZAVYEWYPXVFAWYOWYQX
            VBXBAVVCVUIWUBVOZLVUFVOZXUDXVFWYPWIVVIAWXTXUHXVIWYAXULVUIVTLXKXLZAL
            VUAVOZXUGXVJAVWHXVLVBLVTUYFWSWRZXUILVTVUEXKXLZXUNUYMUXPVUILVUEYFYGY
            OAWUKWULXVCVUTVOZWYEVYCWFVMZXVCWFVMZWIXVGXVHYNWUNWUOAVVCXVOVVIUYMUX
            PVUILXCWRWYFAXVPWEXVQQVYBUWMAXVQLVUIWMVPZWEAVVCXVIXVJXVQXVRWIVVIXVK
            XVNUYMUXPVUILXMXNAVXIVWTXVRWEWIVXJXQLWEUXKXHUXHUXIVYCVYDXVCWXQUYMYP
            YQYRZXBUVDUWOYSAVVAXUOWYEWYKWYMWIVVJXUSWYFUYMVUNWYIWXQYIXNYOAWYJWXO
            WXQWCAVVCWUAXUBXUCWYJWXOWIVVIWUDXUEXUMUYMUXPVTMVUIYFYGYHXTAWYHWXOWX
            QWCAWYCWYHWXOWIWYDUYMWXOUWBWRYHYOAWXOWFVMZVUIAVVCXUCXVTVUIWIVVIXUMU
            YMUXPVUIXFXEUWDAVUIWVPWDVPVUIVTWDVPVUIWVPVTVUIWDUWEUWFAVUIAVUIVXGXP
            UWGUWHUWIAWXRUXPVYQWBVPZWXQWCVPZUXPVTVUEWAWBVPZUXPAWXPXWAWXQWCAWXPW
            XOXVCWCVPZXWAAVYCXVCWXOWCAXVDXVEXVSXDYSAVVCVTXUAVOZXVIXVJXWDXWAWIVV
            IAWXTXWEWYAVTVUIYCWRXVKXVNUYMUXPVTVUILYFYGUWLYHAVVCVTWUBVOZXVJXUDXW
            BXWCWIVVIAXVLXWFXVMVTLYCWRXVNXUNUYMUXPVTLVUEYFYGAVVCXWCUXPWIVVIUYMU
            XPUXAWRXTXTAWXGWXSWUMWXMUXOVOWXLWYBVDUYKUYMVUIQUXNUXBXNYTUXJ $.

          $( The reduced word that forms the base of the sequence in ~ efgsval
             is uniquely determined, given the ending representation.
             (Contributed by Mario Carneiro, 1-Oct-2015.) $)
          efgredlemd $p |- ( ph -> ( A ` 0 ) = ( B ` 0 ) ) $=
            ( vi cc0 chash cfv c1 cmin co cfzo cres cs1 cconcat cword wcel wceq
            c0 cv crn wral efgsdm simp1bi syl eldifad wf wrdf cfz fzossfz lencl
            cz nn0zd fzoval syl5sseqr cn simpld fzo0end syl5eqel ffvelrnd s1cld
            cn0 sseldd wa lbfzo0 sylibr ccatval1 syl3anc simprd eqtr4d c2 caddc
            clt wbr cr sseldi nn0red 2rp ltaddrp sylancl lem1d wb syl2anc fvres
            cle fveq2d fveq2i wi fveq2 eqeq1d fveq1 imbi12d eqeq2d csn cdm cdif
            efgredlema wne eldifsn lennncl sylbi crp c2o cxp fviss eqsstri fznn
            cid mpbir2and efgsres efgsval cop csubstr cuz wss nn0uz fzss1 ax-mp
            1nn0 eleqtri swrd0val swrd0len eqtr3d oveq1d syl6eqr 3eqtrd efgsdmi
            syl6eleqr efgtlen 3brtr4d efgredleme efgsp1 efgsval2 breq1d rspc2va
            rneqi imbi2d syl21anc mp2d eqeltrd 3eqtr4d 3eqtr3d ) AVMHVMHVNVOZVP
            VQVRZVSVRZVTZVOZVMIVMIVNVOZVPVQVRZVSVRZVTZVOZVMHVOZVMIVOZAVMJUBHVOZ
            WAZWBVRZVOZVMJUCIVOZWAZWBVRZVOZUWNUWSAUXEVMJVOZUXIAJUFWCZWDZUXCUXKW
            DVMVMJVNVOZVSVRWDZUXEUXJWEAJUXKWFUUAZAJOUUBZWDZJUXKUXOUUCZWDZVJUXQU
            XSUXJKWDVLWGZJVOUXTVPVQVRZJVOPVOWHWDVLVPUXMVSVRWIBCDEFGKNOPVLRSTJUA
            UDUFUIUJUKULUMUNWJWKWLZWMZAUXBUFAVMUWJVSVRZUFUBHAHUXKWDZUYDUFHWNAHU
            XKUXOAHUXPWDZHUXRWDZUPUYFUYGUWTKWDUXTHVOUYAHVOPVOWHWDVLVPUWJVSVRWIB
            CDEFGKNOPVLRSTHUAUDUFUIUJUKULUMUNWJWKWLWMZUFHWOWLAUWLUYDUBAVMUWKWPV
            RZUWLUYDVMUWKWQAUWJWSWDZUYDUYIWEAUWJAUYEUWJXIWDUYHUFHWRWLZWTZVMUWJX
            AWLXBAUBUWKVPVQVRZUWLUTAUWKXCWDZUYMUWLWDAUYNUWPXCWDZABCDEFGHIKNOPRS
            TUAUDUFUGUHUIUJUKULUMUNUOUPUQURUSUUDZXDZUWKXEWLXFZXJXGZXHAUXMXCWDZU
            XNAUXSUYTUYBUXSUXLJWFUUEXKUYTJUXKWFUUFUFJUUGUUHWLUXMXLXMZUFJUXCVMXN
            XOAUXLUXGUXKWDUXNUXIUXJWEUYCAUXFUFAVMUWOVSVRZUFUCIAIUXKWDZVUBUFIWNA
            IUXKUXOAIUXPWDZIUXRWDZUQVUDVUEUXAKWDUXTIVOUYAIVOPVOWHWDVLVPUWOVSVRW
            IBCDEFGKNOPVLRSTIUAUDUFUIUJUKULUMUNWJWKWLWMZUFIWOWLAUWQVUBUCAVMUWPW
            PVRZUWQVUBVMUWPWQAUWOWSWDZVUBVUGWEAUWOAVUCUWOXIWDVUFUFIWRWLZWTZVMUW
            OXAWLXBAUCUWPVPVQVRZUWQVAAUYOVUKUWQWDAUYNUYOUYPXPZUWPXEWLXFZXJXGZXH
            VUAUFJUXGVMXNXOXQAUWMOVOZVNVOZHOVOZVNVOZXTYAZVUOUXDOVOZWEZUWNUXEWEZ
            AUXBVNVOZVVCXRXSVRZVUPVURXTAVVCYBWDXRUUIWDZVVCVVDXTYAAVVCAUXBUAUUJU
            UKZWCZWDVVCXIWDAUFVVGUXBUFVVGUUOVOVVGUIVVGUULUUMZUYSYCVVFUXBWRWLYDY
            EVVCXRYFYGAVUOUXBVNAVUOUWMVNVOZVPVQVRZUWMVOZUBUWMVOZUXBAUWMUXPWDZVU
            OVVKWEAUYFUWKVPUWJWPVRZWDZVVMUPAVVOUYNUWKUWJYLYAZUYQAUWJAUWJUYKYDYH
            AUYJVVOUYNVVPXKYIUYLUWKUWJUUNWLUUPZBCDEFGKNOPRSTHUAUDUWKUFUIUJUKULU
            MUNUUQYJZBCDEFGKNOPRSTUWMUAUDUFUIUJUKULUMUNUURWLAVVJUBUWMAVVJUYMUBA
            VVIUWKVPVQAHVMUWKUUSUUTVRZVNVOZVVIUWKAVVSUWMVNAUYEUWKVMUWJWPVRZWDZV
            VSUWMWEUYHAVVNVWAUWKVPVMUVAVOZWDZVVNVWAUVBVPXIVWCUVFUVCUVGZVPVMUWJU
            VDUVEVVQYCZUFHUWKUVHYJYMAUYEVWBVVTUWKWEUYHVWFUFHUWKUVIYJUVJUVKUTUVL
            YMAUBUWLWDVVLUXBWEUYRUBUWLHYKWLUVMZYMAUXBUFWDZVUQUXBPVOZWHZWDVURVVD
            WEUYSAVUQUYMHVOZPVOZWHZVWJAUYFUYNVUQVWMWDUPUYQBCDEFGKNOPRSTHUAUDUFU
            IUJUKULUMUNUVNYJVWIVWLUXBVWKPUBUYMHUTYNYNUWCUVOCDEFVUQNPTUAUDUFUXBU
            IUJUKULUVPYJUVQAVUOUXBVUTVWGAUXLVWHUXDUXPWDZVUTUXBWEUYCUYSAUXQUXBJO
            VOPVOWHZWDZVWNVJAVWPUXFVWOWDZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
            UJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKUVRZXDBCDEFGUXBKNOPRSTJ
            UAUDUFUIUJUKULUMUNUVSYJZBCDEFGJUXBKNOPRSTUAUDUFUIUJUKULUMUNUVTXOXQA
            VVMVWNUGWGZOVOZVNVOZVURXTYAZVXAUHWGZOVOZWEZVMVWTVOZVMVXDVOZWEZYOZYO
            ZUHUXPWIUGUXPWIZVUSVVAVVBYOZYOZVVRVWSUOVXKVXNVUSVUOVXEWEZUWNVXHWEZY
            OZYOUGUHUWMUXDUXPUXPVWTUWMWEZVXCVUSVXJVXQVXRVXBVUPVURXTVXRVXAVUOVNV
            WTUWMOYPZYMUWAVXRVXFVXOVXIVXPVXRVXAVUOVXEVXSYQVXRVXGUWNVXHVMVWTUWMY
            RYQYSYSVXDUXDWEZVXQVXMVUSVXTVXOVVAVXPVVBVXTVXEVUTVUOVXDUXDOYPYTVXTV
            XHUXEUWNVMVXDUXDYRYTYSUWDUWBUWEUWFAUWROVOZVNVOZVURXTYAZVYAUXHOVOZWE
            ZUWSUXIWEZAUXFVNVOZVYGXRXSVRZVYBVURXTAVYGYBWDVVEVYGVYHXTYAAVYGAUXFV
            VGWDVYGXIWDAUFVVGUXFVVHVUNYCVVFUXFWRWLYDYEVYGXRYFYGAVYAUXFVNAVYAUWR
            VNVOZVPVQVRZUWRVOZUCUWRVOZUXFAUWRUXPWDZVYAVYKWEAVUDUWPVPUWOWPVRZWDZ
            VYMUQAVYOUYOUWPUWOYLYAZVULAUWOAUWOVUIYDYHAVUHVYOUYOVYPXKYIVUJUWPUWO
            UUNWLUUPZBCDEFGKNOPRSTIUAUDUWPUFUIUJUKULUMUNUUQYJZBCDEFGKNOPRSTUWRU
            AUDUFUIUJUKULUMUNUURWLAVYJUCUWRAVYJVUKUCAVYIUWPVPVQAIVMUWPUUSUUTVRZ
            VNVOZVYIUWPAVYSUWRVNAVUCUWPVMUWOWPVRZWDZVYSUWRWEVUFAVYNWUAUWPVWDVYN
            WUAUVBVWEVPVMUWOUVDUVEVYQYCZUFIUWPUVHYJYMAVUCWUBVYTUWPWEVUFWUCUFIUW
            PUVIYJUVJUVKVAUVLYMAUCUWQWDVYLUXFWEVUMUCUWQIYKWLUVMZYMAUXFUFWDZVUQU
            XFPVOZWHZWDVURVYHWEVUNAVUQVUKIVOZPVOZWHZWUGAVUQIOVOZWUJURAVUDUYOWUK
            WUJWDUQVULBCDEFGKNOPRSTIUAUDUFUIUJUKULUMUNUVNYJUWGWUFWUIUXFWUHPUCVU
            KIVAYNYNUWCUVOCDEFVUQNPTUAUDUFUXFUIUJUKULUVPYJUVQAVYAUXFVYDWUDAUXLW
            UEUXHUXPWDZVYDUXFWEUYCVUNAUXQVWQWULVJAVWPVWQVWRXPBCDEFGUXFKNOPRSTJU
            AUDUFUIUJUKULUMUNUVSYJZBCDEFGJUXFKNOPRSTUAUDUFUIUJUKULUMUNUVTXOXQAV
            YMWULVXLVYCVYEVYFYOZYOZVYRWUMUOVXKWUOVYCVYAVXEWEZUWSVXHWEZYOZYOUGUH
            UWRUXHUXPUXPVWTUWRWEZVXCVYCVXJWURWUSVXBVYBVURXTWUSVXAVYAVNVWTUWROYP
            ZYMUWAWUSVXFWUPVXIWUQWUSVXAVYAVXEWUTYQWUSVXGUWSVXHVMVWTUWRYRYQYSYSV
            XDUXHWEZWURWUNVYCWVAWUPVYEWUQVYFWVAVXEVYDVYAVXDUXHOYPYTWVAVXHUXIUWS
            VMVXDUXHYRYTYSUWDUWBUWEUWFUWHAVMUWLWDZUWNUWTWEAUYNWVBUYQUWKXLXMVMUW
            LHYKWLAVMUWQWDZUWSUXAWEAUYOWVCVULUWPXLXMVMUWQIYKWLUWI $.
        $}

        $d c L $.
        $( The reduced word that forms the base of the sequence in ~ efgsval is
           uniquely determined, given the ending representation.  (Contributed
           by Mario Carneiro, 1-Oct-2015.) $)
        efgredlemc $p |- ( ph ->
          ( P e. ( ZZ>= ` Q ) -> ( A ` 0 ) = ( B ` 0 ) ) ) $=
          ( vi vc cuz cfv wcel wceq c1 caddc co wo cc0 uzp1 cop csubstr cconcat
          chash cword cfz cfzo wf cv cmin crn wral efgsdm simp1bi syl wrdf 3syl
          eldifi fzossfz cn simpld fzo0end syl5eqel sseldi lencl nn0zd eleqtrrd
          cz cn0 fzoval ffvelrnd elfzuz eluzfz1 syl13anc simprd eqeq12d syl3anc
          eqtrd 3eqtrd adantr swrdcl ccatcl syl2anc a1i oveq12d ccatlen 3eqtr4d
          wa wb c2 ccatopth syl221anc mpbid s1cld ccatass oveq2i syl6eqr oveq1d
          cs1 s1len ad2antrr c2o cxp cid fviss eqsstri c0 cdif efgredlema nn0uz
          csn cdm syl6eleq eluzfz2 ccatswrd swrdid mtbird csplice efgtval efgmf
          cs2 ffvelrni s2cld splval 3eqtr3d swrd0len biimpar s2len eqtr4i mtand
          cotp pm2.21d df-s2 eqtr3d s111 fveq2d efgmnvl s1eqd oveq2d elfzelz cc
          zcnd ax-1cn addassd df-2 eleq2d wrex wfo efgsfo efgrcl foelrn sylancr
          cvv clt wbr wi wn simplr simprl simprr eqcomd efgredlemd rexlimddv ex
          sylbid jaod syl5 ) KLVJVKVLKLVMZKLVNVOVPZVJVKVLZVQAVRHVKZVRIVKZVMZLKV
          SAUXGUXLUXIAUXGUXLAUXGUAHVKZVRKVTWAVPZUXMKUXMWCVKZVTWAVPZWBVPZUBIVKZV
          RLVTWAVPZUXRLUXRWCVKZVTWAVPZWBVPZVMZAUYCUXMUXRVMZVGAUXQUXMUYBUXRAUXQU
          XMVRUXOVTWAVPZUXMAUXMTUUAUUBZWDZVLZVRVRKWEVPVLZKVRUXOWEVPZVLZUXOUYJVL
          ZUXQUYEVMAUEUYGUXMUEUYGUUCVKUYGUHUYGUUDUUEZAVRHWCVKZWFVPZUEUAHAHUEWDZ
          UUFUUJZUUGZVLZHUYPVLZUYOUEHWGAHNUUKZVLZUYSUOVUBUYSUXJJVLVHWHZHVKVUCVN
          WIVPZHVKOVKWJVLVHVNUYNWFVPWKBCDEFGJMNOVHQRSHTUCUEUHUIUJUKULUMWLWMWNZH
          UYPUYQWQZUEHWOWPAUAVRUYNVNWIVPZWEVPZUYOAVRVUGWFVPZVUHUAVRVUGWRAUAVUGV
          NWIVPZVUIUSAVUGWSVLZVUJVUIVLAVUKIWCVKZVNWIVPZWSVLZABCDEFGHIJMNOQRSTUC
          UEUFUGUHUIUJUKULUMUNUOUPUQURUUHZWTVUGXAWNXBXCAUYNXGVLUYOVUHVMAUYNAUYS
          UYTUYNXHVLVUEVUFUEHXDWPXEVRUYNXIWNXFXJZXCZAUYKKVRVJVKZVLUYIVAKVRUXOXK
          VRKXLWPVAAUXOVURVLUYLAUXOXHVURAUYHUXOXHVLVUQUYFUXMXDWNUUIUULVRUXOUUMW
          NUYFUXMVRKUXOUUNXMAUYHUYEUXMVMVUQUYFUXMUUOWNXQAUYBUXRVRUXTVTWAVPZUXRA
          UXRUYGVLZVRVRLWEVPVLZLVRUXTWEVPZVLZUXTVVBVLZUYBVUSVMAUEUYGUXRUYMAVRVU
          LWFVPZUEUBIAIUYRVLZIUYPVLZVVEUEIWGAIVUAVLZVVFUPVVHVVFUXKJVLVUCIVKVUDI
          VKOVKWJVLVHVNVULWFVPWKBCDEFGJMNOVHQRSITUCUEUHUIUJUKULUMWLWMWNZIUYPUYQ
          WQZUEIWOWPAUBVRVUMWEVPZVVEAVRVUMWFVPZVVKUBVRVUMWRAUBVUMVNWIVPZVVLUTAV
          UNVVMVVLVLAVUKVUNVUOXNVUMXAWNXBXCAVULXGVLVVEVVKVMAVULAVVFVVGVULXHVLVV
          IVVJUEIXDWPXEVRVULXIWNXFXJZXCZAVVCLVURVLVVAVBLVRUXTXKVRLXLWPVBAUXTVUR
          VLVVDAUXTXHVURAVUTUXTXHVLVVOUYFUXRXDWNUUIUULVRUXTUUMWNUYFUXRVRLUXTUUN
          XMAVUTVUSUXRVMVVOUYFUXRUUOWNXQXOUUPZAUXGYGZUXNUXSUXPUYAWBVVQUXNUXSVMZ
          PPUCVKZUUTZUDUDUCVKZUUTZVMZVVQUXNVVTWBVPZUXSVWBWBVPZVMZVVRVWCYGZVVQVW
          FUXPUYAVMZVVQVWDUXPWBVPZVWEUYAWBVPZVMZVWFVWHYGZAVWKUXGAHNVKZINVKZVWIV
          WJUQAVWMKPUXMOVKVPZUXMKKVVTUVJUUQVPZVWIVEAUXMUEVLZUYKPUYFVLZVWOVWPVMV
          UPVAVCCDEFPMOSTUCKUEUXMUHUIUJUKUURXPAVWQUYKUYKVVTUYGVLZVWPVWIVMVUPVAV
          AAPVVSUYFVCAVWRVVSUYFVLVCUYFUYFPUCCDTUCUJUUSZUVAWNZUVBZVVTUXMKKUEUYJU
          YJUYGUVCXMXRAVWNLUDUXROVKVPZUXRLLVWBUVJUUQVPZVWJVFAUXRUEVLZVVCUDUYFVL
          ZVXCVXDVMVVNVBVDCDEFUDMOSTUCLUEUXRUHUIUJUKUURXPAVXEVVCVVCVWBUYGVLZVXD
          VWJVMVVNVBVBAUDVWAUYFVDAVXFVWAUYFVLZVDUYFUYFUDUCVWTUVAWNZUVBZVWBUXRLL
          UEVVBVVBUYGUVCXMXRUVDZXSVVQVWDUYGVLZUXPUYGVLZVWEUYGVLZUYAUYGVLZVWDWCV
          KZVWEWCVKZVMVWKVWLYHVVQUXNUYGVLZVWSVXLAVXRUXGAUYHVXRVUQUYFUXMVRKXTWNZ
          XSZAVWSUXGVXBXSZUYFUXNVVTYAYBAVXMUXGAUYHVXMVUQUYFUXMKUXOXTWNZXSVVQUXS
          UYGVLZVXGVXNAVYCUXGAVUTVYCVVOUYFUXRVRLXTWNZXSZAVXGUXGVXJXSZUYFUXSVWBY
          AYBAVXOUXGAVUTVXOVVOUYFUXRLUXTXTWNZXSVVQUXNWCVKZVVTWCVKZVOVPZUXSWCVKZ
          VWBWCVKZVOVPZVXPVXQVVQVYHVYKVYIVYLVOAVYHVYKVMZUXGAVYHKVYKLAUYHUYKVYHK
          VMVUQVAUYFUXMKUVEYBZAVUTVVCVYKLVMVVOVBUYFUXRLUVEYBZXOUVFZVYIVYLVMVVQV
          YIYIVYLPVVSUVGUDVWAUVGUVHYCYDVVQVXRVWSVXPVYJVMVXTVYAUYFUXNVVTYEYBVVQV
          YCVXGVXQVYMVMVYEVYFUYFUXSVWBYEYBYFVWDUXPVWEUYAUYFYJYKYLZWTVVQVXRVWSVY
          CVXGVYNVWFVWGYHVXTVYAVYEVYFVYQUXNVVTUXSVWBUYFYJYKYLWTVVQVWFVWHVYRXNYD
          UVIUVKUXIKUXHVMZKUXHVNVOVPZVJVKZVLZVQAUXLUXHKVSAVYSUXLWUBAVYSUXLAVYSU
          YCVVPAVYSYGZUXQUXSUDYRZWBVPZUXPWBVPZUXSWUDUXPWBVPZWBVPZUYBWUCUXNWUEUX
          PWBWUCUXNWUEVMZPYRZVWAYRZVMZWUCUXNWUJWBVPZWUEWUKWBVPZVMZWUIWULYGZWUCW
          UOVVSYRZUXPWBVPZUYAVMZWUCWUMWURWBVPZWUNUYAWBVPZVMZWUOWUSYGZAWVBVYSAWU
          MWUQWBVPZUXPWBVPZWUTWVAAWUMUYGVLZWUQUYGVLZVXMWVEWUTVMAVXRWUJUYGVLZWVF
          VXSAPUYFVCYMZUYFUXNWUJYAYBZAVVSUYFVXAYMZVYBUYFWUMWUQUXPYNXPAVWIVWJWVE
          WVAVXKAWVDVWDUXPWBAWVDUXNWUJWUQWBVPZWBVPZVWDAVXRWVHWVGWVDWVMVMVXSWVIW
          VKUYFUXNWUJWUQYNXPVVTWVLUXNWBPVVSUVLYOYPYQAWUNVWEUYAWBAWUNUXSWUDWUKWB
          VPZWBVPZVWEAVYCWUDUYGVLZWUKUYGVLZWUNWVOVMVYDAUDUYFVDYMZAVWAUYFVXIYMZU
          YFUXSWUDWUKYNXPVWBWVNUXSWBUDVWAUVLYOYPYQYFUVMXSWUCWVFWURUYGVLZWUNUYGV
          LZVXOWUMWCVKZWUNWCVKZVMWVBWVCYHAWVFVYSWVJXSWUCWVGVXMWVTAWVGVYSWVKXSAV
          XMVYSVYBXSZUYFWUQUXPYAYBWUCWUEUYGVLZWVQWWAAWWEVYSAVYCWVPWWEVYDWVRUYFU
          XSWUDYAYBXSZAWVQVYSWVSXSZUYFWUEWUKYAYBAVXOVYSVYGXSWUCVYHWUJWCVKZVOVPZ
          WUEWCVKZWUKWCVKZVOVPZWWBWWCWUCVYHWWJWWHWWKVOAVYHWWJVMZVYSAVYHKWWJUXHV
          YOAWWJVYKWUDWCVKZVOVPZUXHAVYCWVPWWJWWOVMVYDWVRUYFUXSWUDYEYBAVYKLWWNVN
          VOVYPWWNVNVMAUDYSYCYDXQXOUVFZWWHWWKVMWUCWWHVNWWKPYSVWAYSUVHYCYDWUCVXR
          WVHWWBWWIVMAVXRVYSVXSXSZAWVHVYSWVIXSZUYFUXNWUJYEYBWUCWWEWVQWWCWWLVMWW
          FWWGUYFWUEWUKYEYBYFWUMWURWUNUYAUYFYJYKYLZWTWUCVXRWVHWWEWVQWWMWUOWUPYH
          WWQWWRWWFWWGWWPUXNWUJWUEWUKUYFYJYKYLZWTYQWUCVYCWVPVXMWUFWUHVMAVYCVYSV
          YDXSAWVPVYSWVRXSWWDUYFUXSWUDUXPYNXPWUCWUGUYAUXSWBWUCWURWUGUYAWUCWUQWU
          DUXPWBWUCVVSUDWUCVVSVWAUCVKZUDWUCPVWAUCWUCWULPVWAVMZWUCWUIWULWWTXNAWU
          LWXBYHZVYSAVWRVXHWXCVCVXIUYFPVWAUVNYBXSYLUVOAWXAUDVMZVYSAVXFWXDVDCDUD
          TUCUJUVPWNXSXQUVQYQWUCWUOWUSWWSXNUVMUVRXRUVIUVKAWUBKLYIVOVPZVJVKZVLZU
          XLAWUAWXFKAVYTWXEVJAVYTLVNVNVOVPZVOVPWXEALVNVNALAVVCLXGVLVBLVRUXTUVSW
          NUWAVNUVTVLAUWBYCZWXIUWCYIWXHLVOUWDYOYPUVOUWEAWXGUXLAWXGYGZUXSUXMWXEU
          XOVTWAVPZWBVPZVIWHZNVKZVMZUXLVIVUAAWXOVIVUAUWFZWXGAVUAUENUWGWXLUEVLWX
          PBCDEFGJMNOQRSTUCUEUHUIUJUKULUMUWHAWXLUYGUEAVYCWXKUYGVLZWXLUYGVLVYDAU
          YHWXQVUQUYFUXMWXEUXOXTWNUYFUXSWXKYAYBATUWLVLZUEUYGVMZAVWQWXRWXSYGVUPU
          XMTUEUHUWIWNXNXFVIVUAUEWXLNUWJUWKXSWXJWXMVUAVLZWXOYGZYGZBCDEFGHIWXMJK
          LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMAUFWHZNVKZWCVKVWMWCVKUWMUWNWYDUGWH
          ZNVKVMVRWYCVKVRWYEVKVMUWOUWOUGVUAWKUFVUAWKWXGWYAUNYTAVUBWXGWYAUOYTAVV
          HWXGWYAUPYTAVWMVWNVMWXGWYAUQYTAUXLUWPWXGWYAURYTUSUTAUYKWXGWYAVAYTAVVC
          WXGWYAVBYTAVWRWXGWYAVCYTAVXFWXGWYAVDYTAVWMVWOVMWXGWYAVEYTAVWNVXCVMWXG
          WYAVFYTAUYDUWPWXGWYAVGYTAWXGWYAUWQWXJWXTWXOUWRWYBWXLWXNWXJWXTWXOUWSUW
          TUXAUXBUXCUXDUXEUXFUXEUXF $.

        $( The reduced word that forms the base of the sequence in ~ efgsval is
           uniquely determined, given the ending representation.  (Contributed
           by Mario Carneiro, 30-Sep-2015.) $)
        efgredlemb $p |- -. ph $=
          ( cc0 cfv wceq cuz wcel cv chash clt wbr wi cdm wral wb breq2d imbi1d
          fveq2 2ralbidv syl mpbid eqcomd eqcom sylnib efgredlemc syl6ibr cz wo
          cfz co elfzelz uztric syl2anc mpjaod pm2.65i ) AVHHVIZVHIVIZVJZALKVKV
          IVLZXCKLVKVIVLZAXDXBXAVJZXCABCDEFGIHJLKMNOUDQRSTUBUAUCPUEUFUGUHUIUJUK
          ULUMAUFVMZNVIZVNVIZHNVIZVNVIZVOVPZXHUGVMZNVIVJVHXGVIVHXMVIVJVQZVQZUGN
          VRZVSUFXPVSZXIINVIZVNVIZVOVPZXNVQZUGXPVSUFXPVSZUNAXJXRVJZXQYBVTUQYCXO
          YAUFUGXPXPYCXLXTXNYCXKXSXIVOXJXRVNWCWAWBWDWEWFUPUOAXJXRUQWGAXCXFURXAX
          BWHZWIUTUSVBVAVDVCVFVEAUAHVIZUBIVIZVJYFYEVJVGYEYFWHWIWJYDWKABCDEFGHIJ
          KLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGWJAKW
          LVLZLWLVLZXDXEWMAKVHYEVNVIZWNWOVLYGVAKVHYIWPWEALVHYFVNVIZWNWOVLYHVBLV
          HYJWPWEKLWQWRWSURWT $.
      $}

      $( The reduced word that forms the base of the sequence in ~ efgsval is
         uniquely determined, given the ending representation.  (Contributed by
         Mario Carneiro, 30-Sep-2015.) $)
      efgredlem $p |- -. ph $=
        ( vi vr vj vs cc0 cfv wceq chash c1 cmin co cfzo cres clt c2 wcel cword
        wbr cxp cn0 wf c0 cv crn wral efgsdm simp1bi syl eldifad cfz cle simpld
        wrdf cn nnm1nn0 lem1d wa wb mpbir2and cz lencl fzoval eleqtrrd ffvelrnd
        3syl nn0zd sseldi nn0red fznn efgsres syl2anc efgsval cop csubstr fzss1
        ax-mp swrd0val fveq2d swrd0len eqtr3d oveq1d fzo0end fvres efgsdmi wrex
        wss wfn csplice cmpt2 efgtf simprd ffn ovelrn mpbid reeanv wi ad3antrrr
        wn rexlimdvva syl5bir 3eqtr4d fveq2 eqeq1d fveq1 imbi12d eqeq2d lbfzo0
        eqid caddc crp c2o cid fviss eqsstri csn cdif efgredlema nnred eldifsni
        cdm wne cfn wrdfin hashnncl mpbird fznn0 2rp ltaddrp sylancl 1nn0 nn0uz
        cuz eleqtri 3eqtrd efgtlen 3brtr4d cotp elfzofz simpllr simplrl simplrr
        cr cs2 simpr efgredlemb iman expr mp2and breq1d imbi2d rspc2va syl21anc
        mpbir mp2d sylibr 3eqtr3d pm2.65i ) AUQHURZUQIURZUSZAUQHUQHUTURZVAVBVCZ
        VDVCZVEZURZUQIUQIUTURZVAVBVCZVDVCZVEZURZUWJUWKAUWPLURZUTURZHLURZUTURZVF
        VJZUXCUXALURZUSZUWQUXBUSZAUWNVAVBVCZHURZUTURZUXMVGUUAVCZUXDUXFVFAUXMUVN
        VHVGUUBVHUXMUXNVFVJAUXMAUXLQUUCVKZVIZVHUXMVLVHASUXPUXLSUXPUUDURUXPUBUXP
        UUEUUFAUQUWMVDVCZSUXKHAHSVIZVHZUXQSHVMAHUXRVNUUGZAHLUULZVHZHUXRUXTUUHZV
        HZUIUYBUYDUWJJVHUMVOZHURUYEVAVBVCZHURMURVPVHUMVAUWMVDVCVQBCDEFGJKLMUMNO
        PHQRSUBUCUDUEUFUGVRVSZVTWAZSHWEVTAUXKUQUWNWBVCZUXQAUXKUYIVHZUXKVLVHZUXK
        UWNWCVJZAUWNWFVHZUYKAUYMUWSWFVHZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
        JUKULUUIZWDZUWNWGVTAUWNAUWNUYPUUJWHAUWMWFVHZUWNVLVHUYJUYKUYLWIWJAUYQHVN
        UUMZAUYBUYDUYRUIUYGHUXRVNUUKWQAUXSHUUNVHUYQUYRWJUYHSHUUOHUUPWQUUQUWMWGU
        XKUWNUURWQWKAUWMWLVHZUXQUYIUSAUWMAUXSUWMVLVHUYHSHWMVTZWRZUQUWMWNVTWOWPZ
        WSUXOUXLWMVTWTUUSUXMVGUUTUVAAUXCUXLUTAUXCUWPUTURZVAVBVCZUWPURZUXKUWPURZ
        UXLAUWPUYAVHZUXCVUEUSAUYBUWNVAUWMWBVCZVHZVUGUIAVUIUYMUWNUWMWCVJZUYPAUWM
        AUWMUYTWTWHAUYSVUIUYMVUJWIWJVUAUWNUWMXAVTWKZBCDEFGJKLMNOPHQRUWNSUBUCUDU
        EUFUGXBXCZBCDEFGJKLMNOPUWPQRSUBUCUDUEUFUGXDVTZAVUDUXKUWPAVUCUWNVAVBAHUQ
        UWNXEXFVCZUTURZVUCUWNAVUNUWPUTAUXSUWNUQUWMWBVCZVHZVUNUWPUSUYHAVUHVUPUWN
        VAUQUVDURZVHZVUHVUPXRVAVLVURUVBUVCUVEZVAUQUWMXGXHVUKWSZSHUWNXIXCXJAUXSV
        UQVUOUWNUSUYHVVASHUWNXKXCXLXMXJZAUYMUXKUWOVHVUFUXLUSUYPUWNXNUXKUWOHXOWQ
        ZUVFXJAUXLSVHZUXEUXLMURZVPVHZUXFUXNUSVUBAUYBUYMVVFUIUYPBCDEFGJKLMNOPHQR
        SUBUCUDUEUFUGXPXCZCDEFUXEKMPQRSUXLUBUCUDUEUVGXCUVHAVUEUXAUTURZVAVBVCZUX
        AURZUXCUXHAVUFUWSVAVBVCZUXAURZVUEVVJAUXLVVKIURZVUFVVLAUXEUYEUNVOZVVEVCU
        SZUNUXOXQZUMUQUXMWBVCZXQZILURZUOVOZUPVOZVVMMURZVCUSZUPUXOXQZUOUQVVMUTUR
        WBVCZXQZUXLVVMUSZAVVFVVRVVGAVVQUXOVKZSVVEVMZVVEVWHXSVVFVVRWJAVVETUAVVQU
        XOUXLTVOZVWJUAVOZVWKRURUVOUVIZXTVCYAUSZVWIAVVDVWMVWIWIVUBCDEFKMPQRSUXLT
        UAUBUCUDUEYBVTYCVWHSVVEYDUMUNVVQUXOUXEVVEYEWQYFAVVSVWBVPVHZVWFAIUYAVHZU
        YNVWNUJAUYMUYNUYOYCZBCDEFGJKLMNOPIQRSUBUCUDUEUFUGXPXCAVWEUXOVKZSVWBVMZV
        WBVWQXSVWNVWFWJAVWBTUAVWEUXOVVMVWLXTVCYAUSZVWRAVVMSVHVWSVWRWIAUQUWRVDVC
        ZSVVKIAIUXRVHZVWTSIVMAIUXRUXTAVWOIUYCVHZUJVWOVXBUWKJVHUYEIURUYFIURMURVP
        VHUMVAUWRVDVCVQBCDEFGJKLMUMNOPIQRSUBUCUDUEUFUGVRVSVTWAZSIWEVTAVVKUQUWSW
        BVCZVWTAUYNVVKUWTVHZVVKVXDVHVWPUWSXNZVVKUQUWSUVJWQAUWRWLVHZVWTVXDUSAUWR
        AVXAUWRVLVHVXCSIWMVTZWRZUQUWRWNVTWOWPCDEFKMPQRSVVMTUAUBUCUDUEYBVTYCVWQS
        VWBYDUOUPVWEUXOVVSVWBYEWQYFVVRVWFWIVVPVWDWIZUOVWEXQUMVVQXQAVWGVVPVWDUMU
        OVVQVWEYGAVXJVWGUMUOVVQVWEVXJVVOVWCWIZUPUXOXQUNUXOXQAUYEVVQVHZVVTVWEVHZ
        WIZWIZVWGVVOVWCUNUPUXOUXOYGVXOVXKVWGUNUPUXOUXOVXOVVNUXOVHZVWAUXOVHZWIZV
        XKVWGVXOVXRVXKWIZWIZVWGYHVXTVWGYJZWIZYJVYBBCDEFGHIJUYEVVTKLMVVNNOPQUXKV
        VKRVWASTUAUBUCUDUEUFUGAVWJLURZUTURZUXFVFVJZVYCVWKLURZUSZUQVWJURZUQVWKUR
        ZUSZYHZYHZUAUYAVQTUYAVQZVXNVXSVYAUHYIAUYBVXNVXSVYAUIYIAVWOVXNVXSVYAUJYI
        AUXEVVSUSVXNVXSVYAUKYIAUWLYJVXNVXSVYAULYIUXKYTVVKYTVYBVXLVXMAVXNVXSVYAU
        VKZWDVYBVXLVXMVYNYCVYBVXPVXQVXOVXRVXKVYAUVLZWDVYBVXPVXQVYOYCVYBVVOVWCVX
        OVXRVXKVYAUVMZWDVYBVVOVWCVYPYCVXTVYAUVPUVQVXTVWGUVRUWEUVSYKYLYKYLUVTVVC
        AUYNVXEVVLVVMUSVWPVXFVVKUWTIXOWQYMVVBAVVIVVKUXAAVVHUWSVAVBAIUQUWSXEXFVC
        ZUTURZVVHUWSAVYQUXAUTAVXAUWSUQUWRWBVCZVHZVYQUXAUSVXCAVAUWRWBVCZVYSUWSVU
        SWUAVYSXRVUTVAUQUWRXGXHAUWSWUAVHZUYNUWSUWRWCVJZVWPAUWRAUWRVXHWTWHAVXGWU
        BUYNWUCWIWJVXIUWSUWRXAVTWKZWSZSIUWSXIXCXJAVXAVYTVYRUWSUSVXCWUESIUWSXKXC
        XLXMXJYMVUMAUXAUYAVHZUXHVVJUSAVWOWUBWUFUJWUDBCDEFGJKLMNOPIQRUWSSUBUCUDU
        EUFUGXBXCZBCDEFGJKLMNOPUXAQRSUBUCUDUEUFUGXDVTYMAVUGWUFVYMUXGUXIUXJYHZYH
        ZVULWUGUHVYLWUIUXGUXCVYFUSZUWQVYIUSZYHZYHTUAUWPUXAUYAUYAVWJUWPUSZVYEUXG
        VYKWULWUMVYDUXDUXFVFWUMVYCUXCUTVWJUWPLYNZXJUWAWUMVYGWUJVYJWUKWUMVYCUXCV
        YFWUNYOWUMVYHUWQVYIUQVWJUWPYPYOYQYQVWKUXAUSZWULWUHUXGWUOWUJUXIWUKUXJWUO
        VYFUXHUXCVWKUXALYNYRWUOVYIUXBUWQUQVWKUXAYPYRYQUWBUWCUWDUWFAUQUWOVHZUWQU
        WJUSAUYMWUPUYPUWNYSUWGUQUWOHXOVTAUQUWTVHZUXBUWKUSAUYNWUQVWPUWSYSUWGUQUW
        TIXOVTUWHULUWI $.
    $}

    $( The reduced word that forms the base of the sequence in ~ efgsval is
       uniquely determined, given the terminal point.  (Contributed by Mario
       Carneiro, 28-Sep-2015.) $)
    efgred $p |- ( ( A e. dom S /\ B e. dom S /\ ( S ` A ) = ( S ` B ) ) ->
        ( A ` 0 ) = ( B ` 0 ) ) $=
      ( va vb vc vi vd cdm wcel cfv wceq cc0 wa cv chash c1 caddc co clt wbr wi
      wral cn0 c2o cxp cword cid fviss eqsstri wf cmin crn cfzo cdif crab efgsf
      c0 csn fdmi feq2i mpbir ffvelrni adantr sseldi lencl syl peano2nn0 imbi1d
      breq2 2ralbidv weq wn nn0nlt0 pm2.21d rgen2a w3a simpl1 wb simpl3l mpbird
      simpl2l simpl2r simpr efgredlem iman 3expia exp3a ralrimivva fveq2 fveq2d
      simpl3r eqeq1d fveq1 imbi12d eqeq2d imbi2d cbvral2v sylib ancli nn0leltp1
      wo cle cr nn0re leloe syl2an bitr3d ancoms sylan2 jaob 2ralbidva r19.26-2
      syl6bb syl5ibr nn0ind nn0red ltp1d breq1d rspc2v mp2d 3impia ) GKUJZUKZHU
      UDUKZGKULZHKULZUMZUNGULZUNHULZUMZUUEUUFUOZUEUPZKULZUQULZUUGUQULZURUSUTZVA
      VBZUUOUFUPZKULZUMZUNUUNULZUNUUTULZUMZVCZVCZUFUUDVDUEUUDVDZUUQUURVAVBZUUIU
      ULVCZUUMUURVEUKZUVHUUMUUQVEUKZUVKUUMUUGPVFVGZVHZUKUVLUUMRUVNUUGRUVNVIULUV
      NSUVNVJVKZUUEUUGRUKUUFUUDRGKUUDRKVLUNFUPZULIUKMUPZUVPULUVQURVMUTUVPULLULV
      NUKMURUVPUQULVOUTVDUOFRVHVSVTVPVQZRKVLABCDEFIJKLMNOPQRSTUAUBUCUDVRZUUDUVR
      RKUVRRKUVSWAWBWCZWDWEWFUVMUUGWGWHZUUQWIWHUUPUGUPZVAVBZUVFVCZUFUUDVDUEUUDV
      DUUPUNVAVBZUVFVCZUFUUDVDUEUUDVDUUPUHUPZVAVBZUVFVCZUFUUDVDUEUUDVDZUUPUWGUR
      USUTZVAVBZUVFVCZUFUUDVDUEUUDVDZUVHUGUHUURUWBUNUMZUWDUWFUEUFUUDUUDUWOUWCUW
      EUVFUWBUNUUPVAWKWJWLUGUHWMZUWDUWIUEUFUUDUUDUWPUWCUWHUVFUWBUWGUUPVAWKWJWLU
      WBUWKUMZUWDUWMUEUFUUDUUDUWQUWCUWLUVFUWBUWKUUPVAWKWJWLUWBUURUMZUWDUVGUEUFU
      UDUUDUWRUWCUUSUVFUWBUURUUPVAWKWJWLUWFUEUFUUDUUNUUDUKZUWFUUTUUDUKZUWSUWEUV
      FUWSUUPVEUKZUWEWNUWSUUOUVNUKUXAUWSRUVNUUOUVOUUDRUUNKUVTWDWFUVMUUOWGWHZUUP
      WOWHWPWEWQUWJUWNUWGVEUKZUWJUUPUWGUMZUVFVCZUFUUDVDUEUUDVDZUOZUWJUXFUWJUWBK
      ULZUQULZUWGUMZUXHUIUPZKULZUMZUNUWBULZUNUXKULZUMZVCZVCZUIUUDVDUGUUDVDUXFUW
      JUXRUGUIUUDUUDUWJUWBUUDUKZUXKUUDUKZUOZUOUXJUXMUXPUWJUYAUXJUXMUOZUXPUWJUYA
      UYBWRZUXPVCUYCUXPWNZUOZWNUYEABCDEFUWBUXKIJKLMNOPQRUEUFSTUAUBUCUDUYEUUPUXI
      VAVBZUVFVCZUFUUDVDUEUUDVDZUWJUWJUYAUYBUYDWSUYEUXJUYHUWJWTUXJUXMUWJUYAUYDX
      AUXJUYGUWIUEUFUUDUUDUXJUYFUWHUVFUXIUWGUUPVAWKWJWLWHXBUXSUXTUWJUYBUYDXCUXS
      UXTUWJUYBUYDXDUXJUXMUWJUYAUYDXMUYCUYDXEXFUYCUXPXGWCXHXIXJUXRUXEUXDUUOUXLU
      MZUVCUXOUMZVCZVCUGUIUEUFUUDUUDUGUEWMZUXJUXDUXQUYKUYLUXIUUPUWGUYLUXHUUOUQU
      WBUUNKXKZXLXNUYLUXMUYIUXPUYJUYLUXHUUOUXLUYMXNUYLUXNUVCUXOUNUWBUUNXOXNXPXP
      UIUFWMZUYKUVFUXDUYNUYIUVBUYJUVEUYNUXLUVAUUOUXKUUTKXKXQUYNUXOUVDUVCUNUXKUU
      TXOXQXPXRXSXTYAUXCUWNUWIUXEUOZUFUUDVDUEUUDVDUXGUXCUWMUYOUEUFUUDUUDUXCUWSU
      WTUOZUOZUWMUWHUXDYCZUVFVCUYOUYQUWLUYRUVFUYPUXCUXAUWLUYRWTZUWSUXAUWTUXBWEU
      XAUXCUYSUXAUXCUOUUPUWGYDVBZUWLUYRUUPUWGYBUXAUUPYEUKUWGYEUKUYTUYRWTUXCUUPY
      FUWGYFUUPUWGYGYHYIYJYKWJUWHUVFUXDYLYOYMUWIUXEUEUFUUDUUDYNYOYPYQWHUUMUUQUU
      MUUQUWAYRYSUVGUVIUVJVCUVIUUGUVAUMZUUJUVDUMZVCZVCUEUFGHUUDUUDUUNGUMZUUSUVI
      UVFVUCVUDUUPUUQUURVAVUDUUOUUGUQUUNGKXKZXLYTVUDUVBVUAUVEVUBVUDUUOUUGUVAVUE
      XNVUDUVCUUJUVDUNUUNGXOXNXPXPUUTHUMZVUCUVJUVIVUFVUAUUIVUBUULVUFUVAUUHUUGUU
      THKXKXQVUFUVDUUKUUJUNUUTHXOXQXPXRUUAUUBUUC $.

    ${
      efgrelexlem.1 $e |- L = { <. i , j >. | E. c e. ( `' S " { i } )
        E. d e. ( `' S " { j } ) ( c ` 0 ) = ( d ` 0 ) } $.
      $( If two words ` A , B ` are related under the free group equivalence,
         then there exist two extension sequences ` a , b ` such that ` a `
         ends at ` A ` , ` b ` ends at ` B ` , and ` a ` and ` B ` have the
         same starting point.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
      efgrelexlema $p |- ( A L B <-> E. a e. ( `' S " { A } )
        E. b e. ( `' S " { B } ) ( a ` 0 ) = ( b ` 0 ) ) $=
        ( wbr cvv wcel wa cc0 cv cfv wceq ccnv csn cima wrex relopabi brrelex12
        wrel mpan c0 n0i snprc imaeq2 sylbi ima0 syl6eq nsyl2 anim12i rexlimivv
        wn a1d fveq1 eqeq1d eqeq2d cbvrex2v sneq imaeq2d rexeqdv syl5bb rexbidv
        brabg pm5.21nii ) GHSUMZGUNUOZHUNUOZUPZUQUBURZUSZUQUCURZUSZUTZUCKVAZHVB
        ZVCZVDZUBXAGVBZVCZVDZSVGWLWOUQUDURZUSZUQUEURZUSZUTZUEXANURZVBZVCZVDUDXA
        MURZVBZVCZVDZMNSULVEGHSVFVHWTWOUBUCXFXCWPXFUOZWRXCUOZUPWOWTXTWMYAWNXTXF
        VIUTWMXFWPVJWMVSZXFXAVIVCZVIYBXEVIUTXFYCUTGVKXEVIXAVLVMXAVNZVOVPYAXCVIU
        TWNXCWRVJWNVSZXCYCVIYEXBVIUTXCYCUTHVKXBVIXAVLVMYDVOVPVQVTVRXSWTUCXOVDZU
        BXFVDZXGMNGHUNUNSXSYFUBXRVDXPGUTZYGXLWTWQXKUTUDUEUBUCXRXOXHWPUTXIWQXKUQ
        XHWPWAWBXJWRUTXKWSWQUQXJWRWAWCWDYHYFUBXRXFYHXQXEXAXPGWEWFWGWHXMHUTZYFXD
        UBXFYIWTUCXOXCYIXNXBXAXMHWEWFWGWIULWJWK $.

      $( If two words ` A , B ` are related under the free group equivalence,
         then there exist two extension sequences ` a , b ` such that ` a `
         ends at ` A ` , ` b ` ends at ` B ` , and ` a ` and ` B ` have the
         same starting point.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
      efgrelexlemb $p |- .~ C_ L $=
        ( vr va vf vg vh vb vs cv wer cfv crn cec wss wral wa cint efgval2 wcel
        cab wtru wrel cc0 wceq ccnv csn cima wrex relopabi a1i wbr simpr rexcom
        eqcom 2rexbii bitri efgrelexlema 3bitr4i sylib reeanv wi cdm wfn wb wfo
        efgsfo fofn ax-mp fniniseg eqtr3 w3a efgred eqcomd 3expa sylan2 syl2anb
        eqeq2 syl5ibcom reximdv eqeq1 rexbidv imbi2d syl5ibrcom rexlimdva imp3a
        an4s reximi sylbir sylibr adantl eqid fveq1 eqeq2d rspcev mpan2 pm4.71i
        rexlimiv bitr3i sylanbrc co syl2anc cword c0 chash cfzo cxp syl syl3anc
        c1 ex vex cvv cid rexbii2 forn eleq2i fvelrnb 3bitr4ri iserd trud simpl
        foelrn sylancr simprl simprr cconcat simplr fveq2d rneqd eleqtrd efgsp1
        cs1 cdif cmin efgsdm simp1bi ad2antrl eldifad cfz c2o wf cs2 cotp cmpt2
        csplice efgtf simprd frn sselda adantr efgsval2 s1cld wne eldifsn sylbi
        cn lennncl lbfzo0 ccatval1 jca reximdv2 mpd elec rgen fvex eqeltri erex
        ssrdv ereq1 eceq2 sseq2d ralbidv anbi12d elab mpbir2an intss1 eqsstri
        mp2 ) HSUIUPZUQZUJUPZJURZUSZUXHUXFUTZVAZUJSVBZVCZUIVGZVDZQUJBCDEHJOPRSU
        IUBUCUDUEVEQUXOVFZUXPQVAUXQSQUQZUXJUXHQUTZVAZUJSVBZUXRVHUKULUMSQQVIVHVJ
        TUPURVJUAUPURVKUAIVLZLUPVMVNVOTUYBKUPZVMVNVOKLQUHVPVQVHUKUPZULUPZQVRZVC
        UYFUYEUYDQVRZVHUYFVSVJUXHURZVJUNUPZURZVKZUNUYBUYEVMVNZVOZUJUYBUYDVMVNZV
        OZUYJUYHVKZUJUYNVOUNUYLVOZUYFUYGUYOUYPUNUYLVOUJUYNVOUYQUYKUYPUJUNUYNUYL
        UYHUYJWAWBUYPUJUNUYNUYLVTWCABCDEFUYDUYEGHIJKLMNOPQRSUJUNTUAUBUCUDUEUFUG
        UHWDZABCDEFUYEUYDGHIJKLMNOPQRSUNUJTUAUBUCUDUEUFUGUHWDWEWFUYFUYEUMUPZQVR
        ZVCZUYDUYSQVRZVHVUAUYHVJUOUPZURZVKZUOUYBUYSVMVNZVOZUJUYNVOZVUBUYFUYOVJU
        XFURZVUDVKZUOVUFVOZUIUYLVOZVUHUYTUYRABCDEFUYEUYSGHIJKLMNOPQRSUIUOTUAUBU
        CUDUEUFUGUHWDUYOVULVCUYMVUKVCZUIUYLVOZUJUYNVOVUHUYMVUKUJUIUYNUYLWGVUNVU
        GUJUYNVUMVUGUIUYLUXFUYLVFZUYMVUKVUGVUOUYKVUKVUGWHZUNUYLVUOUYIUYLVFZVCZV
        UPUYKVUKUYJVUDVKZUOVUFVOZWHVURVUJVUSUOVUFVURUYJVUIVKZVUJVUSVUOUXFIWIZVF
        ZUXFIURZUYEVKZVCZUYIVVBVFZUYIIURZUYEVKZVCZVVAVUQIVVBWJZVUOVVFWKVVBSIWLZ
        VVKABCDEFGHIJMNOPRSUBUCUDUEUFUGWMZVVBSIWNWOZVVBUYEUXFIWPWOVVKVUQVVJWKVV
        NVVBUYEUYIIWPWOVVCVVGVVEVVIVVAVVEVVIVCVVCVVGVCVVDVVHVKZVVAVVDVVHUYEWQVV
        CVVGVVOVVAVVCVVGVVOWRVUIUYJABCDEFUXFUYIGHIJMNOPRSUBUCUDUEUFUGWSWTXAXBXM
        XCVUIVUDUYJXDXEXFUYKVUGVUTVUKUYKVUEVUSUOVUFUYHUYJVUDXGXHXIXJXKXLYDXNXOX
        CABCDEFUYDUYSGHIJKLMNOPQRSUJUOTUAUBUCUDUEUFUGUHWDXPXQUYDSVFZUYDUYDQVRZW
        KVHUYKUNUYNVOZUJUYNVOUXHIURUYDVKZUJVVBVOZVVQVVPVVRVVSUJUYNVVBUXHUYNVFZV
        VRVCVWAUXHVVBVFVVSVCZVWAVVRVWAUYHUYHVKZVVRUYHXRUYKVWCUNUXHUYNUYIUXHVKUY
        JUYHUYHVJUYIUXHXSXTYAYBYCVVKVWAVWBWKVVNVVBUYDUXHIWPWOYEUUAABCDEFUYDUYDG
        HIJKLMNOPQRSUJUNTUAUBUCUDUEUFUGUHWDVVPUYDIUSZVFZVVTVWDSUYDVVLVWDSVKVVMV
        VBSIUUBWOUUCVVKVWEVVTWKVVNUJVVBUYDIUUDWOYEUUEVQUUFUUGZUXTUJSUXHSVFZUNUX
        JUXSVWGUYIUXJVFZUYIUXSVFZVWGVWHVCZUXHUYIQVRZVWIVWJVUJUOUYBUYIVMVNZVOZUI
        UYBUXHVMVNZVOZVWKVWJUXHVVDVKZUIVVBVOZVWOVWJVVLVWGVWQVVMVWGVWHUUHUIVVBSU
        XHIUUIUUJVWJVWPVWMUIVVBVWNVWJVVCVWPVCZUXFVWNVFZVWMVCVWJVWRVCZVWSVWMVWTV
        VCVVDUXHVKZVWSVWJVVCVWPUUKZVWTUXHVVDVWJVVCVWPUULZWTVVKVWSVVCVXAVCWKVVNV
        VBUXHUXFIWPWOYFVWTUXFUYIUUSZUUMYGZVWLVFZVUIVJVXEURZVKZVWMVWTVXEVVBVFZVX
        EIURUYIVKZVXFVWTVVCUYIVVDJURZUSZVFVXIVXBVWTUYIUXJVXLVWGVWHVWRUUNVWTUXIV
        XKVWTUXHVVDJVXCUUOUUPUUQABCDEFUYIGHIJMNOUXFPRSUBUCUDUEUFUGUURYHZVWTUXFS
        YIZVFZUYISVFZVXIVXJVWTUXFVXNYJVMZVVCUXFVXNVXQUUTVFZVWJVWPVVCVXRVUIGVFUY
        CUXFURUYCYPUVAYGUXFURJURUSVFKYPUXFYKURZYLYGVBABCDEFGHIJKMNOUXFPRSUBUCUD
        UEUFUGUVBUVCUVDZUVEZVWJVXPVWRVWGUXJSUYIVWGVJUXHYKURUVFYGZPUVGYMZYMZSUXI
        UVHZUXJSVAVWGUXIUKULVYBVYCUXHUYDUYDUYEUYERURUVIUVJUVLYGUVKVKVYEBCDEHJOP
        RSUXHUKULUBUCUDUEUVMUVNVYDSUXIUVOYNUVPUVQZVXMABCDEFUXFUYIGHIJMNOPRSUBUC
        UDUEUFUGUVRYOVVKVXFVXIVXJVCWKVVNVVBUYIVXEIWPWOYFVWTVXGVUIVWTVXOVXDVXNVF
        VJVJVXSYLYGVFZVXGVUIVKVYAVWTUYISVYFUVSVWTVXSUWCVFZVYGVWTVXRVYHVXTVXRVXO
        UXFYJUVTVCVYHUXFVXNYJUWASUXFUWDUWBYNVXSUWEXPSUXFVXDVJUWFYOWTVUJVXHUOVXE
        VWLVUCVXEVKVUDVXGVUIVJVUCVXEXSXTYAYHUWGYQUWHUWIABCDEFUXHUYIGHIJKLMNOPQR
        SUIUOTUAUBUCUDUEUFUGUHWDXPUYIUXHQUNYRUJYRUWJXPYQUWOUWKUXNUXRUYAVCUIQUXR
        SYSVFQYSVFVWFSVYCYIZYTURYSUBVYIYTUWLUWMSQYSUWNUXEUXFQVKZUXGUXRUXMUYASUX
        FQUWPVYJUXLUXTUJSVYJUXKUXSUXJUXFQUXHUWQUWRUWSUWTUXAUXBQUXOUXCWOUXD $.
    $}

    $( If two words ` A , B ` are related under the free group equivalence,
       then there exist two extension sequences ` a , b ` such that ` a ` ends
       at ` A ` , ` b ` ends at ` B ` , and ` a ` and ` B ` have the same
       starting point.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgrelex $p |- ( A .~ B -> E. a e. ( `' S " { A } )
        E. b e. ( `' S " { B } ) ( a ` 0 ) = ( b ` 0 ) ) $=
      ( vc vd vj vi wbr cc0 cfv wceq ccnv csn cima wrex copab eqid efgrelexlemb
      cv ssbri efgrelexlema sylib ) GHJUKGHULUGVBUMULUHVBUMUNUHKUOZUIVBUPUQURUG
      VFUJVBUPUQURUJUIUSZUKULSVBUMULTVBUMUNTVFHUPUQURSVFGUPUQURJVGGHABCDEFIJKLU
      JUIMNOPVGQRUGUHUAUBUCUDUEUFVGUTZVAVCABCDEFGHIJKLUJUIMNOPVGQRSTUGUHUAUBUCU
      DUEUFVHVDVE $.

    $( There is a unique reduced word equivalent to a given word.  (Contributed
       by Mario Carneiro, 1-Oct-2015.) $)
    efgredeu $p |- ( A e. W -> E! d e. D d .~ A ) $=
      ( vc va vi vb wcel cv wbr wrex wa wceq wi wral wreu cfv cdm efgsfo foelrn
      wfo mpan cc0 cword c0 csn cdif c1 cmin co crn chash efgsdm simp2bi adantl
      efgsrel breq1 rspcev syl2anc breq2 rexbidv syl5ibrcom rexlimdva mpd efger
      cfzo wer a1i simprl simprr ertr4d ccnv cima efgrelex wfn wb fofn fniniseg
      mp2b simplbi ad2antrl efgsval simprbi simpllr simpld eqeltrd efgs1b mpbid
      syl oveq1d 1m1e0 syl6eq fveq2d 3eqtr3rd ad2antll simprd biimpd rexlimdvva
      eqeq12d syl5 ex ralrimivva reu4 sylanbrc ) GQUIZRUJZGIUKZRHULZYHUEUJZGIUK
      ZUMZYGYJUNZUOZUEHUPRHUPYHRHUQYFGUFUJZJURZUNZUFJUSZULZYIYRQJVBZYFYSABCDEFH
      IJKLMNOPQSTUAUBUCUDUTZUFYRQGJVAVCYFYQYIUFYRYFYOYRUIZUMZYIYQYGYPIUKZRHULZU
      UCVDYOURZHUIZUUFYPIUKZUUEUUBUUGYFUUBYOQVEVFVGVHUIUUGUGUJZYOURUUIVIVJVKYOU
      RKURVLUIUGVIYOVMURZWGVKUPABCDEFHIJKUGLMNYOOPQSTUAUBUCUDVNVOVPUUBUUHYFABCD
      EFHIJKLMNYOOPQSTUAUBUCUDVQVPUUDUUHRUUFHYGUUFYPIVRVSVTYQYHUUDRHGYPYGIWAWBW
      CWDWEYFYNRUEHHYFYGHUIZYJHUIZUMZUMZYLYMUUNYLUMZYGYJIUKZYMUUOYGGYJIQQIWHUUO
      IOQSTWFWIUUNYHYKWJUUNYHYKWKWLUUPUUFVDUHUJZURZUNZUHJWMZYJVGWNZULUFUUTYGVGW
      NZULUUOYMABCDEFYGYJHIJKLMNOPQUFUHSTUAUBUCUDWOUUOUUSYMUFUHUVBUVAUUOYOUVBUI
      ZUUQUVAUIZUMZUMZUUSYMUVFUUFYGUURYJUVFYPUUJVIVJVKZYOURZYGUUFUVFUUBYPUVHUNU
      VCUUBUUOUVDUVCUUBYPYGUNZYTJYRWPZUVCUUBUVIUMWQUUAYRQJWRZYRYGYOJWSWTZXAXBZA
      BCDEFHIJKLMNYOOPQSTUAUBUCUDXCXJUVCUVIUUOUVDUVCUUBUVIUVLXDXBZUVFUVGVDYOUVF
      UVGVIVIVJVKZVDUVFUUJVIVIVJUVFYPHUIZUUJVIUNZUVFYPYGHUVNUVFUUKUULYFUUMYLUVE
      XEZXFXGUVFUUBUVPUVQWQUVMABCDEFYOHIJKLMNOPQSTUAUBUCUDXHXJXIXKXLXMXNXOUVFUU
      QJURZUUQVMURZVIVJVKZUUQURZYJUURUVFUUQYRUIZUVSUWBUNUVDUWCUUOUVCUVDUWCUVSYJ
      UNZYTUVJUVDUWCUWDUMWQUUAUVKYRYJUUQJWSWTZXAXPZABCDEFHIJKLMNUUQOPQSTUAUBUCU
      DXCXJUVDUWDUUOUVCUVDUWCUWDUWEXDXPZUVFUWAVDUUQUVFUWAUVOVDUVFUVTVIVIVJUVFUV
      SHUIZUVTVIUNZUVFUVSYJHUWGUVFUUKUULUVRXQXGUVFUWCUWHUWIWQUWFABCDEFUUQHIJKLM
      NOPQSTUAUBUCUDXHXJXIXKXLXMXNXOXTXRXSYAWEYBYCYHYKRUEHYGYJGIVRYDYE $.

    $( Two extension sequences have related endpoints iff they have the same
       base.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgred2 $p |- ( ( A e. dom S /\ B e. dom S ) ->
      ( ( S ` A ) .~ ( S ` B ) <-> ( A ` 0 ) = ( B ` 0 ) ) ) $=
      ( vd vi cdm wcel wa cfv wbr cc0 wceq cv wrmo wreu wfo wf efgsfo fof ax-mp
      ffvelrni ad2antlr efgredeu reurmo 3syl cword c0 csn cdif c1 cmin co chash
      crn cfzo wral efgsdm simp2bi ad2antrr wer efger efgsrel simpr ertrd breq1
      a1i rmoi syl122anc eqbrtrd ertr3d impbida ) GKUGZUHZHWMUHZUIZGKUJZHKUJZJU
      KZULGUJZULHUJZUMZWPWSUIZUEUNZWRJUKZUEIUOZWTIUHZWTWRJUKZXAIUHZXAWRJUKZXBXC
      WRRUHZXEUEIUPXFWOXKWNWSWMRHKWMRKUQWMRKURABCDEFIJKLMNOPQRSTUAUBUCUDUSWMRKU
      TVAVBVCABCDEFWRIJKLMNOPQRUESTUAUBUCUDVDXEUEIVEVFWNXGWOWSWNGRVGVHVIVJZUHXG
      UFUNZGUJXMVKVLVMZGUJLUJVOUHUFVKGVNUJVPVMVQABCDEFIJKLUFMNOGPQRSTUAUBUCUDVR
      VSVTXCWTWQWRJRRJWAZXCJPRSTWBZWGWNWTWQJUKZWOWSABCDEFIJKLMNOGPQRSTUAUBUCUDW
      CZVTWPWSWDWEWOXIWNWSWOHXLUHXIXMHUJXNHUJLUJVOUHUFVKHVNUJVPVMVQABCDEFIJKLUF
      MNOHPQRSTUAUBUCUDVRVSVCWOXJWNWSABCDEFIJKLMNOHPQRSTUAUBUCUDWCZVCXEXHXJUEIW
      TXAXDWTWRJWFXDXAWRJWFWHWIWPXBUIZWQWTWRJRXOXTXPWGWNXQWOXBXRVTXTWTXAWRJWPXB
      WDWOXJWNXBXSVCWJWKWL $.

    ${
      $d c L $.
      efgcpbllem.1 $e |- L = { <. i , j >. | ( { i , j } C_ W /\
        ( ( A concat i ) concat B ) .~ ( ( A concat j ) concat B ) ) } $.
      $( Lemma for ~ efgrelex .  Define an auxiliary equivalence relation ` L `
         such that ` A L B ` if there are sequences from ` A ` to ` B ` passing
         through the same reduced word.  (Contributed by Mario Carneiro,
         1-Oct-2015.) $)
      efgcpbllema $p |- ( X L Y <-> ( X e. W /\ Y e. W /\
        ( ( A concat X ) concat B ) .~ ( ( A concat Y ) concat B ) ) ) $=
        ( wbr wcel wa cconcat co w3a cv wceq oveq2 oveq1d breqan12d cpr wss vex
        copab prss anbi1i opabbii eqtr4i brab2ga df-3an bitr4i ) UBUCSUKUBUAULZ
        UCUAULZUMGUBUNUOZHUNUOZGUCUNUOZHUNUOZJUKZUMVMVNVSUPGMUQZUNUOZHUNUOZGNUQ
        ZUNUOZHUNUOZJUKZVSMNUBUCUAUASVTUBURZWCUCURZWBVPWEVRJWGWAVOHUNVTUBGUNUSU
        TWHWDVQHUNWCUCGUNUSUTVASVTWCVBUAVCZWFUMZMNVEVTUAULWCUAULUMZWFUMZMNVEUJW
        LWJMNWKWIWFVTWCUAMVDNVDVFVGVHVIVJVMVNVSVKVL $.

      $( Lemma for ~ efgrelex .  Show that ` L ` is an equivalence relation
         containing all direct extensions of a word, so is closed under
         ` .~ ` .  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
      efgcpbllemb $p |- ( ( A e. W /\ B e. W ) -> .~ C_ L ) $=
        ( vr vf vg vh va vc vu vb wcel wa wer cfv crn cec wss wral cint efgval2
        cv cab wrel cpr cconcat co wbr relopabi a1i efgcpbllema simp2bi simp1bi
        efger simp3bi ersym syl3anbrc ad2antrl ad2antll ertrd c2o cxp cword cid
        adantl fviss eqsstri simpll sseldi simpr ccatcl syl2anc simplr wceq cvv
        simprd wrex cc0 chash cfz wf wfn wb cs2 cotp csplice cmpt2 efgtf adantr
        ffn 3syl cop csubstr swrdcl syl ccatass syl3anc oveq1d efgtval syl13anc
        caddc eqtrd oveq2d cuz cn0 lencl nn0uz syl6eleq uzaddcl ccatlen addcomd
        nn0cnd eqeltrd c0 vex efgrcl ad2antrr eleqtrrd erref pm4.71d w3a df-3an
        ex anidm anbi1i 3bitri iserd ovelrn ad2antlr simprl simprr fovrnd efgmf
        syl6bbr ffvelrni s2cld splval 3eqtr4rd elfznn0 cz elfzuz3 nn0zd eluzadd
        fveq2d 3eltr3d elfzuzb sylanbrc ccatrid eluzfz1 eluzfz2 ccatswrd swrdid
        3eqtr2rd swrd0len eqtr2d hash0 oveq2i nn0addcld addid1d syl5req splval2
        wrd0 3eqtr4d fnovrn efgi2 elec breq2 syl5bb syl5ibrcom rexlimdvva ssrdv
        sylbid ralrimiva fvex eqeltri erex ereq1 eceq2 sseq2d ralbidv mpbir2and
        ee10 anbi12d elabg intss1 syl5eqss ) GUAUQZHUAUQZURZJUAUIVGZUSZUJVGZLUT
        ZVAZUXQUXOVBZVCZUJUAVDZURZUIVHZVEZSUJBCDEJLQRTUAUIUBUCUDUEVFUXNSUYDUQZU
        YESVCUXNUYFUASUSZUXSUXQSVBZVCZUJUAVDZUXNUJUKULUASSVIUXNMVGZNVGZVJUAVCGU
        YKVKVLHVKVLGUYLVKVLHVKVLJVMURMNSUHVNVOUXNUXQUKVGZSVMZURZUYMUAUQZUXQUAUQ
        ZGUYMVKVLHVKVLZGUXQVKVLZHVKVLZJVMUYMUXQSVMUYNUYPUXNUYNUYQUYPUYTUYRJVMZA
        BCDEFGHIJKLMNOPQRSTUAUXQUYMUBUCUDUEUFUGUHVPZVQWJUYNUYQUXNUYNUYQUYPVUAVU
        BVRZWJUYOUYTUYRJUAUAJUSZUYOJRUAUBUCVSZVOUYNVUAUXNUYNUYQUYPVUAVUBVTZWJWA
        ABCDEFGHIJKLMNOPQRSTUAUYMUXQUBUCUDUEUFUGUHVPWBUXNUYNUYMULVGZSVMZURURZUY
        QVUGUAUQZUYTGVUGVKVLHVKVLZJVMUXQVUGSVMUYNUYQUXNVUHVUCWCVUHVUJUXNUYNVUHU
        YPVUJUYRVUKJVMZABCDEFGHIJKLMNOPQRSTUAUYMVUGUBUCUDUEUFUGUHVPZVQWDVUIUYTU
        YRVUKJUAVUDVUIVUEVOUYNVUAUXNVUHVUFWCVUHVULUXNUYNVUHUYPVUJVULVUMVTWDWEAB
        CDEFGHIJKLMNOPQRSTUAUXQVUGUBUCUDUEUFUGUHVPWBUXNUYQUYQUYTUYTJVMZURZUXQUX
        QSVMZUXNUYQVUNUXNUYQVUNUXNUYQURZUYTJUAVUDVUQVUEVOVUQUYTRWFWGZWHZUAVUQUY
        SVUSUQZHVUSUQZUYTVUSUQVUQGVUSUQZUXQVUSUQZVUTVUQUAVUSGUAVUSWIUTZVUSUBVUS
        WKWLZUXLUXMUYQWMZWNVUQUAVUSUXQVVEUXNUYQWOWNZVURGUXQWPWQZVUQUAVUSHVVEUXL
        UXMUYQWRWNZVURUYSHWPWQUXLUAVUSWSZUXMUYQUXLRWTUQVVJGRUAUBUUAXAUUBUUCZUUD
        UUHUUEVUPUYQUYQVUNUUFUYQUYQURZVUNURVUOABCDEFGHIJKLMNOPQRSTUAUXQUXQUBUCU
        DUEUFUGUHVPUYQUYQVUNUUGVVLUYQVUNUYQUUIUUJUUKUUSUULZUXNUYIUJUAVUQUMUXSUY
        HVUQUMVGZUXSUQZVVNUNVGZUOVGZUXRVLZWSZUOVURXBUNXCUXQXDUTZXEVLZXBZVVNUYHU
        QZVUQVWAVURWGZUAUXRXFZUXRVWDXGVVOVWBXHUYQVWEUXNUYQUXRUMUPVWAVURUXQVVNVV
        NUPVGZVWFTUTXIXJZXKVLXLWSVWEBCDEJLQRTUAUXQUMUPUBUCUDUEXMXAZWJVWDUAUXRXO
        UNUOVWAVURVVNUXRUUMXPVUQVVSVWCUNUOVWAVURVUQVVPVWAUQZVVQVURUQZURZURZVWCV
        VSUXQVVRSVMZVWLUYQVVRUAUQUYTGVVRVKVLZHVKVLZJVMZVWMUXNUYQVWKWRZVWLVVPVVQ
        UAVWAVURUXRUYQVWEUXNVWKVWHUUNVUQVWIVWJUUOZVUQVWIVWJUUPZUUQVWLUYTUAUQZVW
        OUYTLUTZVAZUQVWPVUQVWTVWKVVKXNZVWLVWOGXDUTZVVPYFVLZVVQVXAVLZVXBVWLGUXQX
        CVVPXQXRVLZVKVLZVVQVVQTUTZXIZVKVLZUXQVVPVVTXQXRVLZVKVLZHVKVLZVXKVXLHVKV
        LZVKVLZVWOVXFVWLVXKVUSUQZVXLVUSUQZVVAVXNVXPWSVWLVXHVUSUQZVXJVUSUQZVXQVW
        LVVBVXGVUSUQZVXSVWLUAVUSGVVEVUQUXLVWKVVFXNWNZVWLVVCVYAVUQVVCVWKVVGXNZVU
        RUXQXCVVPXSXTZVURGVXGWPWQZVWLVVQVXIVURVWSVWJVXIVURUQVUQVWIVURVURVVQTBCR
        TUDUURUUTWDUVAZVURVXHVXJWPWQVWLVVCVXRVYCVURUXQVVPVVTXSXTZVUQVVAVWKVVIXN
        ZVURVXKVXLHYAYBVWLVWNVXMHVKVWLGVXGVXJVKVLZVKVLZVXLVKVLZGVYIVXLVKVLZVKVL
        ZVXMVWNVWLVVBVYIVUSUQZVXRVYKVYMWSVYBVWLVYAVXTVYNVYDVYFVURVXGVXJWPWQVYGV
        URGVYIVXLYAYBVWLVXKVYJVXLVKVWLVVBVYAVXTVXKVYJWSVYBVYDVYFVURGVXGVXJYAYBY
        CVWLVVRVYLGVKVWLVVRUXQVVPVVPVXJXJXKVLZVYLVWLUYQVWIVWJVVRVYOWSVWQVWRVWSB
        CDEVVQJLQRTVVPUAUXQUBUCUDUEYDYBVWLUYQVWIVWIVXTVYOVYLWSVWQVWRVWRVYFVXJUX
        QVVPVVPUAVWAVWAVUSUVBYEYGYHUVCYCVWLVXFUYTVXEVXEVXJXJXKVLZVXPVWLVWTVXEXC
        UYTXDUTZXEVLZUQZVWJVXFVYPWSVXCVWLVXEXCYIUTZUQZVYQVXEYIUTZUQVYSVWLVXDVYT
        UQVVPYJUQZWUAVWLVXDYJVYTVWLVVBVXDYJUQVYBVURGYKXTZYLYMVWIWUCVUQVWJVVPVVT
        UVDWCZVVPXCVXDYNWQVWLVYQUYSXDUTZHXDUTZYFVLZWUBVWLVUTVVAVYQWUHWSVUQVUTVW
        KVVHXNVYHVURUYSHYOWQVWLWUFWUBUQWUGYJUQZWUHWUBUQVWLWUFVXDVVTYFVLZWUBVWLV
        VBVVCWUFWUJWSVYBVYCVURGUXQYOWQVWLVVTVXDYFVLZVVPVXDYFVLZYIUTZWUJWUBVWLVV
        TVVPYIUTUQZVXDUVEUQWUKWUMUQVWIWUNVUQVWJVVPXCVVTUVFWCVWLVXDWUDUVGVXDVVPV
        VTUVHWQVWLVVTVXDVWLVVTVWLVVCVVTYJUQVYCVURUXQYKXTZYQVWLVXDWUDYQZYPVWLWUL
        VXEYIVWLVVPVXDVWLVVPWUEYQWUPYPUVIUVJYRVWLVVAWUIVYHVURHYKXTWUGVXEWUFYNWQ
        YRVXEXCVYQUVKUVLZVWSBCDEVVQJLQRTVXEUAUYTUBUCUDUEYDYBVWLVXHYSVXOVXJUYTVX
        EVXEVURVYEYSVUSUQVWLVURUWGVOVWLVXRVVAVXOVUSUQVYGVYHVURVXLHWPWQVYFVWLVXH
        YSVKVLZVXOVKVLVXHVXOVKVLZVXHVXLVKVLZHVKVLZUYTVWLWURVXHVXOVKVWLVXSWURVXH
        WSVYEVURVXHUVMXTYCVWLVXSVXRVVAWVAWUSWSVYEVYGVYHVURVXHVXLHYAYBVWLWUTUYSH
        VKVWLWUTGVXGVXLVKVLZVKVLZUYSVWLVVBVYAVXRWUTWVCWSVYBVYDVYGVURGVXGVXLYAYB
        VWLWVBUXQGVKVWLWVBUXQXCVVTXQXRVLZUXQVWLVVCXCXCVVPXEVLUQZVWIVVTVWAUQZWVB
        WVDWSVYCVWLVVPVYTUQWVEVWLVVPYJVYTWUEYLYMXCVVPUVNXTVWRVWLVVTVYTUQWVFVWLV
        VTYJVYTWUOYLYMXCVVTUVOXTVURUXQXCVVPVVTUVPYEVWLVVCWVDUXQWSVYCVURUXQUVQXT
        YGYHYGYCUVRVWLVXHXDUTZVXDVXGXDUTZYFVLZVXEVWLVVBVYAWVGWVIWSVYBVYDVURGVXG
        YOWQVWLWVHVVPVXDYFVWLVVCVWIWVHVVPWSVYCVWRVURUXQVVPUVSWQYHUVTVWLVXEYSXDU
        TZYFVLVXEXCYFVLVXEWVJXCVXEYFUWAUWBVWLVXEVWLVXEVWLVXDVVPWUDWUEUWCYQUWDUW
        EUWFYGUWHVWLVXAVYRVURWGZXGZVYSVWJVXFVXBUQVWLVWTWVKUAVXAXFZWVLVXCVWTVXAU
        MUPVYRVURUYTVWGXKVLXLWSWVMBCDEJLQRTUAUYTUMUPUBUCUDUEXMXAWVKUAVXAXOXPWUQ
        VWSVYRVURVXEVVQVXAUWIYBYRBCDEUYTVWOJLQRTUAUBUCUDUEUWJWQABCDEFGHIJKLMNOP
        QRSTUAUXQVVRUBUCUDUEUFUGUHVPWBVWCUXQVVNSVMVVSVWMVVNUXQSUMYTUJYTUWKVVNVV
        RUXQSUWLUWMUWNUWOUWQUWPUWRUXNSWTUQZUYFUYGUYJURZXHUXNUYGUAWTUQWVNVVMUAVV
        DWTUBVUSWIUWSUWTUASWTUXAUXGUYCWVOUISWTUXOSWSZUXPUYGUYBUYJUAUXOSUXBWVPUY
        AUYIUJUAWVPUXTUYHUXSUXOSUXQUXCUXDUXEUXHUXIXTUXFSUYDUXJXTUXK $.
    $}

    $( Two extension sequences have related endpoints iff they have the same
       base.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgcpbl $p |- ( ( A e. W /\ B e. W /\ X .~ Y ) ->
      ( ( A concat X ) concat B ) .~ ( ( A concat Y ) concat B ) ) $=
      ( vi vj wcel wbr w3a cv cpr wss cconcat co copab efgcpbllemb ssbrd 3impia
      wa eqid efgcpbllema simp3bi syl ) GRUIZHRUIZSTJUJZUKSTUGULZUHULZUMRUNGVIU
      OUPHUOUPGVJUOUPHUOUPJUJVAUGUHUQZUJZGSUOUPHUOUPGTUOUPHUOUPJUJZVFVGVHVLVFVG
      VAJVKSTABCDEFGHIJKLUGUHMNOPVKQRUAUBUCUDUEUFVKVBZURUSUTVLSRUITRUIVMABCDEFG
      HIJKLUGUHMNOPVKQRSTUAUBUCUDUEUFVNVCVDVE $.

    $( Two extension sequences have related endpoints iff they have the same
       base.  (Contributed by Mario Carneiro, 1-Oct-2015.) $)
    efgcpbl2 $p |- ( ( A .~ X /\ B .~ Y ) ->
                     ( A concat B ) .~ ( X concat Y ) ) $=
      ( wbr wa cconcat co wer efger a1i wcel simpl ercl c2o cxp cword wrd0 wceq
      c0 cvv efgrcl syl simprd syl5eleqr efgcpbl syl3anc eleqtrd ccatcl syl2anc
      simpr ccatrid ercl2 3brtr3d ccatlid oveq1d ertrd ) GSJUGZHTJUGZUHZGHUIUJZ
      GTUIUJZSTUIUJZJRRJUKWBJPRUAUBULUMZWBWCVBUIUJZWDVBUIUJZWCWDJWBGRUNZVBRUNZW
      AWGWHJUGWBGSJRWFVTWAUOZUPZWBVBPUQURZUSZRWMUTWBPVCUNZRWNVAZWBWIWOWPUHWLGPR
      UAVDVEVFZVGZVTWAVMZABCDEFGVBIJKLMNOPQRHTUAUBUCUDUEUFVHVIWBWCWNUNZWGWCVAWB
      GWNUNZHWNUNWTWBGRWNWLWQVJZWBHRWNWBHTJRWFWSUPWQVJWMGHVKVLWMWCVNVEWBWDWNUNZ
      WHWDVAWBXATWNUNXCXBWBTRWNWBHTJRWFWSVOZWQVJWMGTVKVLWMWDVNVEVPWBVBGUIUJZTUI
      UJZVBSUIUJZTUIUJZWDWEJWBWJTRUNVTXFXHJUGWRXDWKABCDEFVBTIJKLMNOPQRGSUAUBUCU
      DUEUFVHVIWBXEGTUIWBXAXEGVAXBWMGVQVEVRWBXGSTUIWBSWNUNXGSVAWBSRWNWBGSJRWFWK
      VOWQVJWMSVQVEVRVPVS $.
  $}

  ${
    $d i k m n t v w x y z I $.  $d i M $.  $d i m t x y z .~ $.
    frgpval.m $e |- G = ( freeGrp ` I ) $.
    frgpval.b $e |- M = ( freeMnd ` ( I X. 2o ) ) $.
    frgpval.r $e |- .~ = ( ~FG ` I ) $.
    $( Value of the free group construction.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    frgpval $p |- ( I e. V -> G = ( M /s .~ ) ) $=
      ( vi wcel cfrgp cfv cqus co cvv wceq c2o cxp cfrmd cefg elex xpeq1 fveq2d
      cv syl6eqr fveq2 oveq12d df-frgp ovex fvmpt syl syl5eq ) CEJZBCKLZDAMNZFU
      MCOJUNUOPCEUAICIUDZQRZSLZUPTLZMNUOOKUPCPZURDUSAMUTURCQRZSLDUTUQVASUPCQUBU
      CGUEUTUSCTLAUPCTUFHUEUGIUHDAMUIUJUKUL $.

    frgpcpbl.p $e |- .+ = ( +g ` M ) $.
    $( Compatibility of the group operation with the free group equivalence
       relation.  (Contributed by Mario Carneiro, 1-Oct-2015.)  (Revised by
       Mario Carneiro, 27-Feb-2016.) $)
    frgpcpbl $p |- ( ( A .~ C /\ B .~ D ) -> ( A .+ B ) .~ ( C .+ D ) ) $=
      ( co c2o cfv cv wcel eqid wceq vx vy vz vw vv vt vn vm vk wbr cconcat cxp
      cword cid cc0 chash cfz c1o cdif cop cmpt2 cs2 cotp csplice cmpt crn ciun
      wa c1 cmin cfzo wral c0 csn crab efgcpbl2 cbs wer efger simpl ercl efgrcl
      a1i cvv syl simprd con0 simpld xpexg sylancl frmdbas eqtr4d eleqtrd simpr
      2on frmdadd syl2anc ercl2 3brtr4d ) ACFUJZBDFUJZVHZABUKNZCDUKNZABENZCDENZ
      FUAUBUCUDUEUFABHOULZUMZUNPZUAXIUAQUEXIUGUDUOUEQZUPPUQNXGXJUGQZXKUDQZXLUBU
      CHOUBQURUCQUSUTVAZPVBVCVDNVAVEZPVFVGUSZFUHUOUFQZPXORUIQZXPPXQVIVJNXPPXNPV
      FRUIVIXPUPPVKNVLVHUFXIUMVMVNUSVOUHQZUPPVIVJNXRPVEZXNUIUHUGHXMXICDXISZLXMS
      XNSXOSXSSVPXBAIVQPZRBYARXEXCTXBAXIYAXBACFXIXIFVRXBFHXIXTLVSWCZWTXAVTZWAZX
      BXIXHYAXBHWDRZXIXHTZXBAXIRYEYFVHYDAHXIXTWBWEZWFXBXGWDRZYAXHTXBYEOWGRYHXBY
      EYFYGWHWOHOWDWGWIWJYAXGIWDKYASZWKWEWLZWMXBBXIYAXBBDFXIYBWTXAWNZWAYJWMYAEX
      GIABKYIMWPWQXBCYARDYARXFXDTXBCXIYAXBACFXIYBYCWRYJWMXBDXIYAXBBDFXIYBYKWRYJ
      WMYAEXGICDKYIMWPWQWS $.
  $}

  ${
    $d a b c d x y z G $.  $d a b c d n v w x y z I $.  $d a b c d x y z .~ $.
    $d a b c d x y z V $.
    frgp0.m $e |- G = ( freeGrp ` I ) $.
    frgp0.r $e |- .~ = ( ~FG ` I ) $.
    $( The free group is a group.  (Contributed by Mario Carneiro,
       1-Oct-2015.)  (Revised by Mario Carneiro, 27-Feb-2016.) $)
    frgp0 $p |- ( I e. V -> ( G e. Grp /\ [ (/) ] .~ = ( 0g ` G ) ) ) $=
      ( vy vz wcel c2o cfv cv cvv c0 eqid wceq syl a1i co adantr vx vd vb va vc
      vw vv cxp cfrmd cplusg c1o cdif cop cmpt2 creverse ccom cword frgpval cbs
      vn con0 2on xpexg mpan2 frmdbas eqcomd eqidd cid wer efger wb wrdexg 3syl
      fvi ereq2 mpbii fvex wbr wa wi frgpcpbl w3a cmnd frmdmnd 3ad2ant1 eleqtrd
      simp2 simp3 mndcl syl3anc eleqtrrd 3adant3r3 simpr3 erref mndass syl13anc
      breqtrd wrd0 cconcat syl5eleq eleq2d biimpa frmdadd syl2anc ccatlid eqtrd
      adantl simpr eqbrtrd revcl efgmf wrdco biimpar cc0 chash cfz cotp csplice
      wf cs2 cmpt efginvrel1 divsgrp2 ) CDIZUAGHCJUHZUIKZUJKZAYFBGHCJGLZUKHLZUL
      UMUNZUALZUOKZUPZYEUQZMNUBUCUDUEABCYFDEYFOZFURYDYFUSKZYNYDYEMIZYPYNPYDJVAI
      YQVBCJDVAVCVDZYPYEYFMYOYPOZVEQVFZYDYGVGYDYNVHKZAVIZYNAVIZACUUAUUAOZFVJYDU
      UAYNPZUUBUUCVKYDYQYNMIUUEYRYEMVLYNMVNVMZUUAYNAVOQVPZYFMIYDYEUIVQRUDLZUCLZ
      AVRUELZUBLZAVRVSUUHUUJYGSUUIUUKYGSAVRVTYDUUHUUJUUIUUKYGABCYFEYOFYGOZWARYD
      YKYNIZYHYNIZWBZYKYHYGSZYPYNUUOYFWCIZYKYPIZYHYPIZUUPYPIZYDUUMUUQUUNYDYQUUQ
      YRYEYFMYOWDQZWEUUOYKYNYPYDUUMUUNWGYDUUMYNYPPZUUNYTWEZWFZUUOYHYNYPYDUUMUUN
      WHUVCWFZYPYGYFYKYHYSUULWIWJZUVCWKYDUUMUUNYIYNIZWBZVSZUUPYIYGSZUVJYKYHYIYG
      SYGSZAUVIUVJAYNYDUUCUVHUUGTUVIUVJYPYNUVIUUQUUTYIYPIZUVJYPIYDUUQUVHUVATZYD
      UUMUUNUUTUVGUVFWLUVIYIYNYPYDUUMUUNUVGWMYDUVBUVHYTTZWFZYPYGYFUUPYIYSUULWIW
      JUVNWKWNUVIUUQUURUUSUVLUVJUVKPUVMYDUUMUUNUURUVGUVDWLYDUUMUUNUUSUVGUVEWLUV
      OYPYGYFYKYHYIYSUULWOWPWQNYNIYDYEWRZRYDUUMVSZNYKYGSZYKYKAUVQUVRNYKWSSZYKUV
      QNYPIZUURUVRUVSPYDUVTUUMYDNYNYPUVPYTWTTYDUUMUURYDYNYPYKYTXAXBZYPYGYEYFNYK
      YOYSUULXCXDUUMUVSYKPYDYEYKXEXGXFUVQYKAYNYDUUCUUMUUGTYDUUMXHWNXIUVQYLYNIZY
      EYEYJXSZYMYNIUUMUWBYDYEYKXJXGUWCUVQGHCYJYJOZXKRYEYEYJYLXLXDZUVQYMYKYGSZYM
      YKWSSZNAUVQYMYPIUURUWFUWGPUVQYMYNYPUWEYDUVBUUMYTTWFUWAYPYGYEYFYMYKYOYSUUL
      XCXDUVQYKUUAIZUWGNAVRYDUWHUUMYDUUAYNYKUUFXAXMGHUFUGYKAUGUUAUTUFXNUGLZXOKX
      PSYEUWIUTLZUWJUFLZUWKYJKXTXQXRSUNYAZUTCYJUUAUUDFUWDUWLOYBQXIYC $.

    frgpeccl.w $e |- W = ( _I ` Word ( I X. 2o ) ) $.
    frgpeccl.b $e |- B = ( Base ` G ) $.
    $( Closure of the quotient map in a free group.  (Contributed by Mario
       Carneiro, 1-Oct-2015.) $)
    frgpeccl $p |- ( X e. W -> [ X ] .~ e. B ) $=
      ( wcel cefg cfv cvv fvex cbs c2o cfrmd wceq eqid cec eqeltri ecelqsi cqus
      cqs cxp cword efgrcl simpld frgpval syl simprd con0 xpexg sylancl frmdbas
      co 2on eqtr4d a1i divsbas syl6eqr eleqtrd ) FEKZFBUAEBUEZAEFBBDLMNHDLOUBZ
      UCVDVECPMAVDBDQUFZRMZCENNVDDNKZCVHBUDUQSVDVIEVGUGZSZFDEIUHZUIZBCDVHNGVHTZ
      HUJUKVDEVJVHPMZVDVIVKVLULVDVGNKZVOVJSVDVIQUMKVPVMURDQNUMUNUOVOVGVHNVNVOTU
      PUKUSBNKVDVFUTVHNKVDVGROUTVAJVBVC $.
  $}

  ${
    frgpgrp.g $e |- G = ( freeGrp ` I ) $.
    $( The free group is a group.  (Contributed by Mario Carneiro,
       1-Oct-2015.) $)
    frgpgrp $p |- ( I e. V -> G e. Grp ) $=
      ( wcel cgrp c0 cefg cfv cec c0g wceq eqid frgp0 simpld ) BCEAFEGBHIZJAKIL
      PABCDPMNO $.
  $}

  ${
    $d a b c d A $.  $d b d n v w y z I $.  $d n v w M $.  $d a b c d y z .~ $.
    $d a b c d B $.  $d a b c d .+ $.  $d a b c d n v w y z W $.
    frgpadd.w $e |- W = ( _I ` Word ( I X. 2o ) ) $.
    frgpadd.g $e |- G = ( freeGrp ` I ) $.
    frgpadd.r $e |- .~ = ( ~FG ` I ) $.
    ${
      frgpadd.n $e |- .+ = ( +g ` G ) $.
      $( Addition in the free group is given by concatenation.  (Contributed by
         Mario Carneiro, 1-Oct-2015.) $)
      frgpadd $p |- ( ( A e. W /\ B e. W ) ->
        ( [ A ] .~ .+ [ B ] .~ ) = [ ( A concat B ) ] .~ ) $=
        ( wcel wa cec co wceq cvv syl cv eleqtrd vd vb va vc c2o cxp cfv cplusg
        cfrmd cconcat simpl simpr cmnd cqus cword efgrcl adantr simpld eqid cbs
        frgpval simprd con0 2on xpexg sylancl frmdbas wer efger a1i frmdmnd wbr
        eqtr4d frgpcpbl simprl simprr mndcl syl3anc eleqtrrd divsaddval frmdadd
        wi mpd3an23 syl2anc eceq1 eqtrd ) AGLZBGLZMZADNBDNCOZABFUEUFZUIUGZUHUGZ
        OZDNZABUJOZDNZWIWGWHWJWOPWGWHUKZWGWHULZWIDWLCWMEGABUMUAUBUCUDWIFQLZEWLD
        UNOPWIWTGWKUOZPZWGWTXBMWHAFGHUPUQZURZDEFWLQIWLUSZJVARWIGXAWLUTUGZWIWTXB
        XCVBWIWKQLZXFXAPWIWTUEVCLXGXDVDFUEQVCVEVFZXFWKWLQXEXFUSZVGRVMZGDVHWIDFG
        HJVIVJWIXGWLUMLZXHWKWLQXEVKRZUCSZUBSZDVLUDSZUASZDVLMXMXOWMOXNXPWMOZDVLW
        BWIXMXOXNXPWMDEFWLIXEJWMUSZVNVJWIXNGLZXPGLZMZMZXQXFGYBXKXNXFLXPXFLXQXFL
        WIXKYAXLUQYBXNGXFWIXSXTVOWIGXFPYAXJUQZTYBXPGXFWIXSXTVPYCTXFWMWLXNXPXIXR
        VQVRYCVSXRKVTWCWIWNWPPZWOWQPWIAXFLBXFLYDWIAGXFWRXJTWIBGXFWSXJTXFWMWKWLA
        BXEXIXRWAWDWNWPDWERWF $.
    $}

    frgpinv.n $e |- N = ( invg ` G ) $.
    frgpinv.m $e |- M = ( y e. I , z e. 2o |-> <. y , ( 1o \ z ) >. ) $.
    $( The inverse of an element of the free group.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    frgpinv $p |- ( A e. W ->
      ( N ` [ A ] .~ ) = [ ( M o. ( reverse ` A ) ) ] .~ ) $=
      ( wcel cec cfv wceq co eqid vw vv vn creverse ccom cplusg c0g cconcat c2o
      c0 cxp cword wf cid fviss eqsstri sseli revcl syl efgmf wrdco sylancl cvv
      efgrcl simprd eleqtrrd frgpadd mpdan wer efger a1i cc0 chash cfz cs2 cotp
      cv csplice cmpt2 cmpt efginvrel2 erthi cgrp wa frgp0 adantr 3eqtrd cbs wb
      simpld frgpeccl grpinvid1 syl3anc mpbird ) CIOZCDPZHQGCUDQZUEZDPZRZWPWSEU
      FQZSZEUGQZRZWOXBCWRUHSZDPZUJDPZXCWOWRIOZXBXFRWOWRFUIUKZULZIWOWQXJOZXIXIGU
      MWRXJOWOCXJOXKIXJCIXJUNQXJJXJUOUPUQXICURUSABFGNUTXIXIGWQVAVBWOFVCOZIXJRZC
      FIJVDZVEVFZCWRXADEFIJKLXATZVGVHWOXEUJDIIDVIWODFIJLVJVKABUAUBCDUBIUCUAVLUB
      VQZVMQVNSXIXQUCVQZXRUAVQZXSGQVOVPVRSVSVTZUCFGIJLNXTTWAWBWOEWCOZXGXCRZWOXL
      XMWDYAYBWDZXNXLYCXMDEFVCKLWEWFUSZVEWGWOYAWPEWHQZOWSYEOZWTXDWIWOYAYBYDWJYE
      DEFICKLJYETZWKWOXHYFXOYEDEFIWRKLJYGWKUSYEXAEHWPWSXCYGXPXCTMWLWMWN $.
  $}

  ${
    $d a b F $.  $d a b x G $.  $d a b x I $.  $d a b x V $.  $d a b x W $.
    $d a b M $.  $d x .~ $.
    frgpmhm.m $e |- M = ( freeMnd ` ( I X. 2o ) ) $.
    frgpmhm.w $e |- W = ( Base ` M ) $.
    frgpmhm.g $e |- G = ( freeGrp ` I ) $.
    frgpmhm.r $e |- .~ = ( ~FG ` I ) $.
    frgpmhm.f $e |- F = ( x e. W |-> [ x ] .~ ) $.
    $( The "natural map" from words of the free monoid to their cosets in the
       free group is a surjective monoid homomorphism.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    frgpmhm $p |- ( I e. V -> F e. ( M MndHom G ) ) $=
      ( wcel wa cfv co wceq cvv syl va vb cmnd cbs wf cv cplusg wral c0 c0g w3a
      cmhm c2o cxp con0 2on xpexg mpan2 frmdmnd cgrp frgpgrp grpmnd jca cec cid
      cword frmdbas wrdexg fvi eqtr4d eleq2d biimpa eqid frgpeccl fmptd cconcat
      wer efger wb ereq2 mpbiri adantr fvex eqeltri a1i divsfval frmdadd adantl
      fveq2d oveq12d anbi12d frgpadd eqtrd 3eqtr4d ralrimivva frgp0 simprd 3jca
      frmd0 ismhm sylanbrc ) EGNZFUCNZDUCNZOHDUDPZCUEZUAUFZUBUFZFUGPZQZCPZXGCPZ
      XHCPZDUGPZQZRZUBHUHUAHUHZUICPZDUJPZRZUKCFDULQNXBXCXDXBEUMUNZSNZXCXBUMUONY
      BUPEUMGUOUQURZYAFSIUSTXBDUTNZXDDEGKVADVBTVCXBXFXQXTXBAHAUFZBVDZXECXBYEHNZ
      OYEYAVFZVEPZNZYFXENXBYGYJXBHYIYEXBYBHYIRZYCYBHYHYIHYAFSIJVGYBYHSNYIYHRYAS
      VHYHSVITVJTZVKVLXEBDEYIYEKLYIVMZXEVMZVNTMVOXBXPUAUBHHXBXGHNZXHHNZOZOZXGXH
      VPQZCPYSBVDZXKXOYRAYSBCHXBHBVQZYQXBUUAYIBVQZBEYIYMLVRXBYKUUAUUBVSYLHYIBVT
      TWAZWBZHSNZYRHFUDPSJFUDWCWDZWEZMWFYRXJYSCYQXJYSRXBHXIYAFXGXHIJXIVMZWGWHWI
      YRXOXGBVDZXHBVDZXNQZYTYRXLUUIXMUUJXNYRAXGBCHUUDUUGMWFYRAXHBCHUUDUUGMWFWJY
      RXGYINZXHYINZOZUUKYTRXBYQUUNXBYOUULYPUUMXBHYIXGYLVKXBHYIXHYLVKWKVLXGXHXNB
      DEYIYMKLXNVMZWLTWMWNWOXBXRUIBVDZXSXBAUIBCHUUCUUEXBUUFWEMWFXBYDUUPXSRBDEGK
      LWPWQWMWRUAUBHXEXIXNFDCXSUIJYNUUHUUOYAFIWSXSVMWTXA $.
  $}

  ${
    $d j A $.  $d i j x y I $.  $d i j x y .~ $.  $d j V $.  $d j X $.
    vrgpfval.r $e |- .~ = ( ~FG ` I ) $.
    vrgpfval.u $e |- U = ( varFGrp ` I ) $.
    $( The canonical injection from the generating set ` I ` to the base set of
       the free group.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    vrgpfval $p |- ( I e. V ->
      U = ( j e. I |-> [ <" <. j , (/) >. "> ] .~ ) ) $=
      ( vi wcel cvrgp cfv cv c0 cop cec cmpt cvv wceq cefg syl cs1 elex syl6eqr
      id fveq2 eceq2 mpteq12dv df-vrgp vex mptex fvmpt3i syl5eq ) DEIZBDJKZCDCL
      MNUAZAOZPZGUMDQIUNUQRDEUBHDCHLZUOURSKZOZPUQQJURDRZCURUTDUPVAUDVAUSARUTUPR
      VAUSDSKAURDSUEFUCUSAUOUFTUGHCUHCURUTHUIUJUKTUL $.

    $( The value of the generating elements of a free group.  (Contributed by
       Mario Carneiro, 2-Oct-2015.) $)
    vrgpval $p |- ( ( I e. V /\ A e. I ) ->
      ( U ` A ) = [ <" <. A , (/) >. "> ] .~ ) $=
      ( vj wcel cfv cv c0 cop cs1 cec cmpt vrgpfval wceq cvv cefg syl eqid fvex
      fveq1d opeq1 s1eqd eceq1 eqeltri ecexg ax-mp fvmpt sylan9eq ) DEIZADIACJA
      HDHKZLMZNZBOZPZJALMZNZBOZUMACURBCHDEFGQUDHAUQVADURUNARZUPUTRUQVARVBUOUSUN
      ALUEUFUPUTBUGUAURUBBSIVASIBDTJSFDTUCUHUTSBUIUJUKUL $.

    vrgpf.m $e |- G = ( freeGrp ` I ) $.
    ${
      vrgpf.x $e |- X = ( Base ` G ) $.
      $( The mapping from the index set to the generators is a function into
         the free group.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
      vrgpf $p |- ( I e. V -> U : I --> X ) $=
        ( vj wcel wf c0 c2o c1o mpan2 cvv con0 eqid cv cop cs1 cec wa cxp cword
        cmpt cid cfv cpr 0ex prid1 df2o3 eleqtrri opelxpi adantl s1cld wceq 2on
        xpexg adantr wrdexg fvi 3syl eleqtrrd frgpeccl syl fmptd vrgpfval feq1d
        mpbird ) DELZDFBMDFKDKUAZNUBZUCZAUDZUHZMVMKDVQFVRVMVNDLZUEZVPDOUFZUGZUI
        UJZLVQFLVTVPWBWCVTVOWAVSVOWALZVMVSNOLWDNNPUKONPULUMUNUOVNNDOUPQUQURVTWA
        RLZWBRLWCWBUSVMWEVSVMOSLWEUTDOESVAQVBWARVCWBRVDVEVFFACDWCVPIGWCTJVGVHVR
        TVIVMDFBVRABKDEGHVJVKVL $.
    $}

    vrgpinv.n $e |- N = ( invg ` G ) $.
    $( The inverse of a generating element is represented by ` <. A , 1 >. `
       instead of ` <. A , 0 >. ` .  (Contributed by Mario Carneiro,
       2-Oct-2015.) $)
    vrgpinv $p |- ( ( I e. V /\ A e. I ) ->
      ( N ` ( U ` A ) ) = [ <" <. A , 1o >. "> ] .~ ) $=
      ( vx vy wcel cfv c0 cop c2o c1o wceq wa cs1 cec cv cmpt2 creverse vrgpval
      cdif ccom fveq2d cxp cword cid simpr cpr 0ex prid1 df2o3 eleqtrri opelxpi
      sylancl s1cld cvv con0 simpl 2on xpexg fvi 3syl eleqtrrd eqid frgpinv syl
      wrdexg revs1 a1i coeq2d wf efgmf s1co co efgmval df-ov dif0 3eqtr3g s1eqd
      opeq2i 3eqtrd eceq1 ) EGNZAENZUAZACOZFOAPQZUBZBUCZFOZLMERLUDSMUDUHQUEZWOU
      FOZUIZBUCZASQZUBZBUCZWLWMWPFABCEGHIUGUJWLWOERUKZULZUMOZNWQXATWLWOXFXGWLWN
      XEWLWKPRNZWNXENZWJWKUNZPPSUORPSUPUQURUSZAPERUTVAZVBWLXEVCNZXFVCNXGXFTWLWJ
      RVDNXMWJWKVEVFERGVDVGVAXEVCVNXFVCVHVIVJLMWOBDEWRFXGXGVKJHKWRVKZVLVMWLWTXC
      TXAXDTWLWTWRWOUIZWNWROZUBZXCWLWSWOWRWSWOTWLWNVOVPVQWLXIXEXEWRVRXOXQTXLLME
      WRXNVSXEXEWNWRVTVAWLXPXBWLAPWRWAZASPUHZQZXPXBWLWKXHXRXTTXJXKLMAPEWRXNWBVA
      APWRWCXSSASWDWGWEWFWHWTXCBWIVMWH $.
  $}

  ${
    $d a b g s u v y z A $.  $d a c h t u E $.  $d a b c g h n r s t u v x H $.
    $d u v C $.  $d y z F $.  $d a i j n t w K $.  $d a b M $.  $d a b y z N $.
    $d a c g h n t y z B $.  $d a c t u w G $.  $d a b g h i j n r s u v x T $.
    $d a b g h i j n r s t u w x .~ $.  $d a b c g h i j n s t u w x y z ph $.
    $d a b i j n r w x y z I $.  $d w V $.  $d a b g h n r s t u v w x W $.
    $d a b c n u w X $.
    frgpup.b $e |- B = ( Base ` H ) $.
    frgpup.n $e |- N = ( invg ` H ) $.
    frgpup.t $e |- T = ( y e. I , z e. 2o |->
      if ( z = (/) , ( F ` y ) , ( N ` ( F ` y ) ) ) ) $.
    frgpup.h $e |- ( ph -> H e. Grp ) $.
    frgpup.i $e |- ( ph -> I e. V ) $.
    frgpup.a $e |- ( ph -> F : I --> B ) $.
    $( Any assignment of the generators to target elements can be extended
       (uniquely) to a homomorphism from a free monoid to an arbitrary other
       monoid.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    frgpuptf $p |- ( ph -> T : ( I X. 2o ) --> B ) $=
      ( cv cfv wcel c2o c0 wceq cif wral cxp wf ffvelrnda adantrr cgrp grpinvcl
      wa adantr syl2anc ifcl ralrimivva fmpt2 sylib ) ACQZUAUBZBQZFRZVAIRZUCZDS
      ZCTUDBHUDHTUEDEUFAVDBCHTAUTHSZURTSZUKZUKZVADSZVBDSZVDAVEVIVFAHDUTFPUGUHZV
      HGUISZVIVJAVLVGNULVKDGIVAKLUJUMUSVAVBDUNUMUOBCHTVCDEMUPUQ $.

    ${
      frgpuptinv.m $e |- M = ( y e. I , z e. 2o |-> <. y , ( 1o \ z ) >. ) $.
      $( Any assignment of the generators to target elements can be extended
         (uniquely) to a homomorphism from a free monoid to an arbitrary other
         monoid.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
      frgpuptinv $p |- ( ( ph /\ A e. ( I X. 2o ) ) ->
        ( T ` ( M ` A ) ) = ( N ` ( T ` A ) ) ) $=
        ( c1o va vb c2o cxp wcel cfv wceq cv cop wrex elxp2 cdif efgmval adantl
        wa co fveq2d df-ov syl6eqr c0 wo cpr elpri df2o3 eleq2s simpr 1on elexi
        con0 prid2 eleqtrri cif wne neeq1 mpbiri ifnefalse fveq2 sylan9eqr fvex
        1n0 ovmpt2a sylancl prid1 iftrue eqtr4d difeq2 dif0 syl6eq oveq2d oveq2
        syl 0ex eqeq12d syl5ibrcom cgrp adantr ffvelrnda eqeltrd syl2anc eqtr2d
        grpinvinv difid jaod syl5 impr eqtrd rexlimdvva syl5bi imp ) ADIUCUDUEZ
        DJUFZFUFZDFUFZKUFZUGZXJDUAUHZUBUHZUIZUGZUBUCUJUAIUJAXOUAUBDIUCUKAXSXOUA
        UBIUCAXPIUEZXQUCUEZUOZUOZXOXSXPXQJUPZFUFZXPXQFUPZKUFZUGYCYEXPTXQULZFUPZ
        YGYCYEXPYHUIZFUFYIYCYDYJFYBYDYJUGABCXPXQIJSUMUNUQXPYHFURUSAXTYAYIYGUGZY
        AXQUTUGZXQTUGZVAZAXTUOZYKYNXQUTTVBZUCXQUTTVCVDVEYOYLYKYMYOYKYLXPTFUPZXP
        UTFUPZKUFZUGYOYQXPGUFZKUFZYSYOXTTUCUEYQUUAUGAXTVFZTYPUCUTTTVIVGVHVJVDVK
        BCXPTIUCCUHZUTUGZBUHZGUFZUUFKUFZVLZUUAFUUCTUGZUUEXPUGZUUHUUGUUAUUIUUCUT
        VMZUUHUUGUGUUIUUKTUTVMVTUUCTUTVNVOUUCUTUUFUUGVPWKUUJUUFYTKUUEXPGVQZUQVR
        OYTKVSWAWBYOYRYTKYOXTUTUCUEYRYTUGUUBUTYPUCUTTWLWCVDVKBCXPUTIUCUUHYTFUUD
        UUJUUHUUFYTUUDUUFUUGWDUULVROXPGVSWAWBZUQWEZYLYIYQYGYSYLYHTXPFYLYHTUTULT
        XQUTTWFTWGWHWIYLYFYRKXQUTXPFWJUQWMWNYOYKYMYRYQKUFZUGYOUUOYSKUFZYRYOYQYS
        KUUNUQYOHWOUEZYREUEUUPYRUGAUUQXTPWPYOYRYTEUUMAIEXPGRWQWREHKYRMNXAWSWTYM
        YIYRYGUUOYMYHUTXPFYMYHTTULUTXQTTWFTXBWHWIYMYFYQKXQTXPFWJUQWMWNXCXDXEXFX
        SXLYEXNYGXSXKYDFXSXKXRJUFYDDXRJVQXPXQJURUSUQXSXMYFKXSXMXRFUFYFDXRFVQXPX
        QFURUSUQWMWNXGXHXI $.
    $}

    frgpup.w $e |- W = ( _I ` Word ( I X. 2o ) ) $.
    frgpup.r $e |- .~ = ( ~FG ` I ) $.
    $( Any assignment of the generators to target elements can be extended
       (uniquely) to a homomorphism from a free monoid to an arbitrary other
       monoid.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    frgpuplem $p |- ( ( ph /\ A .~ C ) ->
      ( H gsum ( T o. A ) ) = ( H gsum ( T o. C ) ) ) $=
      ( vu vv vr vx vn va vb wbr wa cpr wss ccom cgsu co wceq copab wer cop c1o
      cdif cs2 cotp csplice c2o wral cc0 chash cfv cfz cab cint efgval wcel cxp
      cv cin cvv coeq2 oveq2d eqid eqer a1i erinxp wb df-xp ineq1i incom inopab
      ssv 3eqtr3i vex prss anbi1i opabbii eqtri ereq1 ax-mp sylib simplrl cword
      fviss eqsstri sseldi opelxpi adantl simprl 2oconcl ad2antll syl2anc s2cld
      cid efgrcl syl simprd eleqtrrd jca csubstr cconcat cplusg swrdcl ad2antrr
      splcl ccatco syl3anc wrdco gsumccat df-ov eqtr3d eqtrd 3eqtr4d cn0 coeq2d
      syl13anc eleq1 eqeqan12d anbi12d ralrimivva 2ralbidv frgpuptf cmnd grpmnd
      wf cgrp c0g cmpt2 efgmval syl5eqr fveq2d frgpuptinv sylan2 adantlr fveq2i
      s2co syl6reqr s2eqd eqtr4d simprr fovrnd grpinvcl gsumws2 grprinv gsumwcl
      3eqtrd grprid 3eqtrrd oveq1d ccatcl cuz simplrr elfzuz eluzfz1 3syl lencl
      nn0uz syl6eleq eluzfz2 ccatswrd swrdid splval ovex bi2anan9 syl5bbr braba
      sylanbrc fvex eqeltri erex ee10 elabg mpbir2and intss1 syl5eqss ssbrd imp
      breq wrel efger errel mp1i brrelex12 sylan preq12 sseq1d brabga mpbid ) A
      DFGUJZUKZDFULZNUMZJHDUNZUOUPZJHFUNZUOUPZUQZUXIDFUCVQZUDVQZULZNUMZJHUXQUNZ
      UOUPZJHUXRUNZUOUPZUQZUKZUCUDURZUJZUXKUXPUKZAUXHUYHAGUYGDFAGNUEVQZUSZUFVQZ
      UYLUGVQZUYMUHVQZUIVQZUTZUYNVAUYOVBZUTZVCZVDZVEUPZUYJUJZUIVFVGUHKVGZUGVHUY
      LVIVJZVKUPZVGUFNVGZUKZUEVLZVMZUYGUFUHUIGUGKNUEUAUBVNAUYGVUHVOZVUIUYGUMAVU
      JNUYGUSZUYLVUAUYGUJZUIVFVGUHKVGZUGVUEVGUFNVGZANUYEUCUDURZNNVPZVRZUSZVUKAV
      SNVUOVSVUOUSAUCUDUYBUYDVUOUXQUXRUQUYAUYCJUOUXQUXRHVTWAVUOWBWCWDNVSUMANWKW
      DWEVUQUYGUQVURVUKWFVUQUXQNVOZUXRNVOZUKZUYEUKZUCUDURZUYGVUPVUOVRVVAUCUDURZ
      VUOVRVUQVVCVUPVVDVUOUCUDNNWGWHVUPVUOWIVVAUYEUCUDWJWLVVBUYFUCUDVVAUXTUYEUX
      QUXRNUCWMUDWMWNZWOWPWQNVUQUYGWRWSWTZAVUMUFUGNVUEAUYLNVOZUYMVUEVOZUKZUKZVU
      LUHUIKVFVVJUYNKVOZUYOVFVOZUKZUKZVVGVUANVOZUKZJHUYLUNZUOUPZJHVUAUNZUOUPZUQ
      ZVULVVNVVGVVOAVVGVVHVVMXAZVVNVUAKVFVPZXBZNVVNUYLVWDVOZUYSVWDVOZVUAVWDVOVV
      NNVWDUYLNVWDXMVJZVWDUAVWDXCXDVWBXEZVVNUYPUYRVWCVVMUYPVWCVOZVVJUYNUYOKVFXF
      ZXGZVVNVVKUYQVFVOZUYRVWCVOVVJVVKVVLXHZVVLVWLVVJVVKUYOXIXJUYNUYQKVFXFXKZXL
      ZVWCUYSUYLUYMUYMYDXKVVNKVSVOZNVWDUQZVVNVVGVWPVWQUKVWBUYLKNUAXNXOXPXQXRVVN
      JHUYLVHUYMUTXSUPZUNZHUYLUYMVUDUTXSUPZUNZXTUPZUOUPZJHVWRUYSXTUPZUNZVXAXTUP
      ZUOUPZVVRVVTVVNJVWSUOUPZJVXAUOUPZJYAVJZUPZJVXEUOUPZVXIVXJUPZVXCVXGVVNVXHV
      XLVXIVXJVVNVXLJVWSHUYSUNZXTUPZUOUPZVXHJVXNUOUPZVXJUPZVXHVVNVXEVXOJUOVVNVW
      RVWDVOZVWFVWCEHUUDZVXEVXOUQVVNVWEVXSVWHVWCUYLVHUYMYBXOZVWOAVXTVVIVVMABCEH
      IJKLMOPQRSTUUAYCZVWCEVWRUYSHYEYFWAVVNJUUBVOZVWSEXBZVOZVXNVYDVOZVXPVXRUQVV
      NJUUEVOZVYCAVYGVVIVVMRYCZJUUCXOZVVNVXSVXTVYEVYAVYBVWCEHVWRYGXKZVVNVWFVXTV
      YFVWOVYBVWCEHUYSYGXKEVXJJVWSVXNOVXJWBZYHYFVVNVXRVXHJUUFVJZVXJUPZVXHVVNVXQ
      VYLVXHVXJVVNVXQJUYNUYOHUPZVYNLVJZVCZUOUPZVYNVYOVXJUPZVYLVVNVXNVYPJUOVVNVX
      NUYPHVJZUYRHVJZVCVYPVVNUYPUYRHVWCEVYBVWKVWNUUOVVNVYNVYOVYSVYTVYNVYSUQVVNU
      YNUYOHYIZWDVVNVYTVYSLVJZVYOVVNUYPBCKVFBVQVACVQVBUTUUGZVJZHVJZVYTWUBVVNWUD
      UYRHVVMWUDUYRUQVVJVVMWUDUYNUYOWUCUPUYRUYNUYOWUCYIBCUYNUYOKWUCWUCWBZUUHUUI
      XGUUJAVVMWUEWUBUQZVVIVVMAVWIWUGVWJABCUYPEHIJKWUCLMOPQRSTWUFUUKUULUUMYJVYN
      VYSLWUAUUNUUPUUQUURWAVVNVYCVYNEVOZVYOEVOZVYQVYRUQVYIVVNUYNUYOEKVFHVYBVWMV
      VJVVKVVLUUSUUTZVVNVYGWUHWUIVYHWUJEJLVYNOPUVAXKEVXJVYNVYOJOVYKUVBYFVVNVYGW
      UHVYRVYLUQVYHWUJEVXJJLVYNVYLOVYKVYLWBZPUVCXKUVEWAVVNVYGVXHEVOZVYMVXHUQVYH
      VVNVYCVYEWULVYIVYJEJVWSOUVDXKEVXJJVXHVYLOVYKWUKUVFXKYKUVGUVHVVNVYCVYEVXAV
      YDVOZVXCVXKUQVYIVYJVVNVWTVWDVOZVXTWUMVVNVWEWUNVWHVWCUYLUYMVUDYBXOZVYBVWCE
      HVWTYGXKZEVXJJVWSVXAOVYKYHYFVVNVYCVXEVYDVOZWUMVXGVXMUQVYIVVNVXDVWDVOZVXTW
      UQVVNVXSVWFWURVYAVWOVWCVWRUYSUVIXKZVYBVWCEHVXDYGXKWUPEVXJJVXEVXAOVYKYHYFY
      LVVNVVQVXBJUOVVNHVWRVWTXTUPZUNZVVQVXBVVNWUTUYLHVVNWUTUYLVHVUDUTXSUPZUYLVV
      NVWEVHVHUYMVKUPVOZVVHVUDVUEVOZWUTWVBUQVWHVVNVVHUYMVHUVJVJZVOWVCAVVGVVHVVM
      UVKZUYMVHVUDUVLVHUYMUVMUVNWVFVVNVUDWVEVOWVDVVNVUDYMWVEVVNVWEVUDYMVOVWHVWC
      UYLUVOXOUVPUVQVHVUDUVRXOVWCUYLVHUYMVUDUVSYOVVNVWEWVBUYLUQVWHVWCUYLUVTXOYK
      YNVVNVXSWUNVXTWVAVXBUQVYAWUOVYBVWCEVWRVWTHYEYFYJWAVVNVVSVXFJUOVVNVVSHVXDV
      WTXTUPZUNZVXFVVNVUAWVGHVVNVVGVVHVVHVWFVUAWVGUQVWBWVFWVFVWOUYSUYLUYMUYMNVU
      EVUEVWDUWAYOYNVVNWURWUNVXTWVHVXFUQWUSWUOVYBVWCEVXDVWTHYEYFYKWAYLUYFVVPVWA
      UKUCUDUYLVUAUYGUFWMUYLUYTVEUWBUXQUYLUQZUXRVUAUQZUKZUXTVVPUYEVWAUXTVVAWVKV
      VPVVEWVIVUSVVGWVJVUTVVOUXQUYLNYPUXRVUANYPUWCUWDWVIWVJUYBVVRUYDVVTWVIUYAVV
      QJUOUXQUYLHVTWAWVJUYCVVSJUOUXRVUAHVTWAYQYRUYGWBZUWEUWFYSYSAUYGVSVOZVUJVUK
      VUNUKZWFAVUKNVSVOWVMVVFNVWGVSUAVWDXMUWGUWHNUYGVSUWIUWJVUGWVNUEUYGVSUYJUYG
      UQZUYKVUKVUFVUNNUYJUYGWRWVOVUCVUMUFUGNVUEWVOVUBVULUHUIKVFUYLVUAUYJUYGUWQY
      TYTYRUWKXOUWLUYGVUHUWMXOUWNUWOUWPUXIDVSVOFVSVOUKZUYHUYIWFAGUWRZUXHWVPNGUS
      WVQAGKNUAUBUWSNGUWTUXADFGUXBUXCUYFUYIUCUDDFUYGVSVSUXQDUQZUXRFUQZUKZUXTUXK
      UYEUXPWVTUXSUXJNUXQUXRDFUXDUXEWVRWVSUYBUXMUYDUXOWVRUYAUXLJUOUXQDHVTWAWVSU
      YCUXNJUOUXRFHVTWAYQYRWVLUXFXOUXGXP $.

    frgpup.g $e |- G = ( freeGrp ` I ) $.
    frgpup.x $e |- X = ( Base ` G ) $.
    frgpup.e $e |- E = ran ( g e. W |->
      <. [ g ] .~ , ( H gsum ( T o. g ) ) >. ) $.
    $( Any assignment of the generators to target elements can be extended
       (uniquely) to a homomorphism from a free monoid to an arbitrary other
       monoid.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    frgpupf $p |- ( ph -> E : X --> B ) $=
      ( vh wf cqs wfun cv ccom cgsu co wcel wa cmnd cword grpmnd syl adantr c2o
      cgrp cxp cid cfv fviss eqsstri sseli frgpuptf syl2anr gsumwcl syl2anc wer
      wrdco efger a1i fvex eqeltri wceq coeq2 oveq2d frgpuplem qliftfund qliftf
      cvv mpbid cbs cfrmd cqus eqid frgpval 2on xpexg sylancl wrdexg fvi syl5eq
      con0 3syl frmdbas eqtr4d cefg divsbas syl6reqr feq2d mpbird ) APDHUIOEUJZ
      DHUIZAHUKXJAGUHKFGULZUMZUNUOZKFUHULZUMZUNUOEHODUGAXKOUPZUQKURUPZXLDUSUPZX
      MDUPAXQXPAKVDUPXQTKUTVAVBXPXKLVCVEZUSZUPXSDFUIXRAOXTXKOXTVFVGZXTUCXTVHVIV
      JABCDFIKLMNQRSTUAUBVKXSDFXKVPVLDKXLQVMVNZOEVOAELOUCUDVQVRZOWGUPAOYAWGUCXT
      VFVSVTVRZXKXNWAXLXOKUNXKXNFWBWCABCXKDXNEFIKLMNOQRSTUAUBUCUDWDWEAGXMEHODUG
      YBYCYDWFWHAPXIDHAXIJWIVGPAEXSWJVGZJOWGWGALNUPZJYEEWKUOWAUAEJLYENUEYEWLZUD
      WMVAAOXTYEWIVGZAOYAXTUCAXSWGUPZXTWGUPYAXTWAAYFVCWTUPYIUAWNLVCNWTWOWPZXSWG
      WQXTWGWRXAWSAYIYHXTWAYJYHXSYEWGYGYHWLXBVAXCEWGUPAELXDVGWGUDLXDVSVTVRYEWGU
      PAXSWJVSVRXEUFXFXGXH $.

    $( Any assignment of the generators to target elements can be extended
       (uniquely) to a homomorphism from a free monoid to an arbitrary other
       monoid.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    frgpupval $p |- ( ( ph /\ A e. W ) ->
      ( E ` [ A ] .~ ) = ( H gsum ( T o. A ) ) ) $=
      ( cv ccom cgsu co cvv wcel wa a1i wer efger c2o cxp cword cid cfv eqeltri
      ovex fvex wceq coeq2 oveq2d wf wfun frgpupf ffun syl qliftval ) AHLGHUIZU
      JZUKULZLGDUJZUKULDFIPUMUHVRUMUNAVPPUNUOLVQUKVEUPPFUQAFMPUDUEURUPPUMUNAPMU
      SUTVAZVBVCUMUDVTVBVFVDUPVPDVGVQVSLUKVPDGVHVIAQEIVJIVKABCEFGHIJKLMNOPQRSTU
      AUBUCUDUEUFUGUHVLQEIVMVNVO $.

    $( Any assignment of the generators to target elements can be extended
       (uniquely) to a homomorphism from a free monoid to an arbitrary other
       monoid.  (Contributed by Mario Carneiro, 2-Oct-2015.)  (Revised by Mario
       Carneiro, 28-Feb-2016.) $)
    frgpup1 $p |- ( ph -> E e. ( G GrpHom H ) ) $=
      ( va vc vu vt cplusg cfv eqid wcel cgrp frgpgrp syl frgpupf cv co wceq wa
      cqs wss cbs c2o cxp cfrmd cvv cqus frgpval cword cid xpexg sylancl wrdexg
      con0 2on fvi 3syl syl5eq frmdbas eqtr4d cefg eqeltri a1i divsbas syl6reqr
      fvex eqimss adantr sselda oveq2 fveq2d fveq2 oveq2d eqeq12d adantlr oveq1
      cec oveq1d cconcat ccom fviss eqsstri sseli ccatcl syl2an efgrcl eleqtrrd
      cgsu simprd frgpupval sylan2 wf ad2antrl ad2antll frgpuptf ccatco syl3anc
      cmnd grpmnd wrdco syl2anr adantrr syl2anc gsumccat 3eqtrd frgpadd adantrl
      adantl oveq12d 3eqtr4d anass1rs ectocld syldan an32s anasss isghmd ) AUHU
      IJULUMZKULUMZJKHPDUFQUUAUNZUUBUNZALNUOZJUPUOUAJLNUEUQURTABCDEFGHIJKLMNOPQ
      RSTUAUBUCUDUEUFUGUSAUHUTZPUOZUIUTZPUOZUUFUUHUUAVAZHUMZUUFHUMZUUHHUMZUUBVA
      ZVBZAUUGVCZUUIUUHOEVDZUOUUOUUPPUUQUUHAPUUQVEZUUGAPUUQVBUURAUUQJVFUMPAELVG
      VHZVIUMZJOVJVJAUUEJUUTEVKVAVBUAEJLUUTNUEUUTUNZUDVLURAOUUSVMZUUTVFUMZAOUVB
      VNUMZUVBUCAUUSVJUOZUVBVJUOUVDUVBVBAUUEVGVRUOUVEUAVSLVGNVRVOVPZUUSVJVQUVBV
      JVTWAWBAUVEUVCUVBVBUVFUVCUUSUUTVJUVAUVCUNWCURWDEVJUOAELWEUMVJUDLWEWJWFWGU
      UTVJUOAUUSVIWJWGWHUFWIPUUQWKURZWLWMUUFUJUTZEXAZUUAVAZHUMZUULUVIHUMZUUBVAZ
      VBZUUOUUPUJUUHOEUUQUUQUNZUVIUUHVBZUVKUUKUVMUUNUVPUVJUUJHUVIUUHUUFUUAWNWOU
      VPUVLUUMUULUUBUVIUUHHWPWQWRAUVHOUOZUUGUVNAUVQVCZUUGUUFUUQUOZUVNAUUGUVSUVQ
      APUUQUUFUVGWMWSUKUTZEXAZUVIUUAVAZHUMZUWAHUMZUVLUUBVAZVBZUVNUVRUKUUFOEUUQU
      VOUWAUUFVBZUWCUVKUWEUVMUWGUWBUVJHUWAUUFUVIUUAWTWOUWGUWDUULUVLUUBUWAUUFHWP
      XBWRAUVTOUOZUVQUWFAUWHUVQVCZVCZUVTUVHXCVAZEXAZHUMZKFUVTXDZXLVAZKFUVHXDZXL
      VAZUUBVAZUWCUWEUWJUWMKFUWKXDZXLVAZKUWNUWPXCVAZXLVAZUWRUWIAUWKOUOUWMUWTVBU
      WIUWKUVBOUWHUVTUVBUOZUVHUVBUOZUWKUVBUOUVQOUVBUVTOUVDUVBUCUVBXEXFZXGZOUVBU
      VHUXEXGZUUSUVTUVHXHXIUWILVJUOZOUVBVBZUWHUXHUXIVCUVQUVTLOUCXJWLXMXKABCUWKD
      EFGHIJKLMNOPQRSTUAUBUCUDUEUFUGXNXOUWJUWSUXAKXLUWJUXCUXDUUSDFXPZUWSUXAVBUW
      HUXCAUVQUXFXQUVQUXDAUWHUXGXRZAUXJUWIABCDFIKLMNQRSTUAUBXSZWLZUUSDUVTUVHFXT
      YAWQUWJKYBUOZUWNDVMZUOZUWPUXOUOZUXBUWRVBAUXNUWIAKUPUOUXNTKYCURWLAUWHUXPUV
      QUWHUXCUXJUXPAUXFUXLUUSDFUVTYDYEYFUWJUXDUXJUXQUXKUXMUUSDFUVHYDYGDUUBKUWNU
      WPQUUDYHYAYIUWJUWBUWLHUWIUWBUWLVBAUVTUVHUUAEJLOUCUEUDUUCYJYLWOUWJUWDUWOUV
      LUWQUUBAUWHUWDUWOVBUVQABCUVTDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGXNYFAUVQUVLUWQ
      VBUWHABCUVHDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGXNYKYMYNYOYPYQYRYPYQYSYT $.

    frgpup.u $e |- U = ( varFGrp ` I ) $.
    ${
      frgpup.y $e |- ( ph -> A e. I ) $.
      $( The evaluation map has the intended behavior on the generators.
         (Contributed by Mario Carneiro, 2-Oct-2015.)  (Revised by Mario
         Carneiro, 28-Feb-2016.) $)
      frgpup2 $p |- ( ph -> ( E ` ( U ` A ) ) = ( F ` A ) ) $=
        ( cfv c0 cop cs1 cec ccom cgsu wcel wceq vrgpval syl2anc fveq2d c2o cxp
        co cword c1o cpr 0ex prid1 df2o3 eleqtrri opelxpi sylancl s1cld cid cvv
        con0 2on xpexg wrdexg fvi 3syl syl5eq eleqtrrd frgpupval mpdan frgpuptf
        wf s1co df-ov cv cif iftrue fveq2 sylan9eqr ovmpt2a syl5eqr s1eqd eqtrd
        fvex oveq2d ffvelrnd gsumws1 syl 3eqtrd ) ADHULZJULDUMUNZUOZFUPZJULZMGX
        JUQZURVFZDKULZAXHXKJANPUSZDNUSZXHXKUTUCUKDFHNPUFUJVAVBVCAXJQUSXLXNUTAXJ
        NVDVEZVGZQAXIXRAXQUMVDUSZXIXRUSZUKUMUMVHVIVDUMVHVJVKVLVMZDUMNVDVNVOZVPA
        QXSVQULZXSUEAXRVRUSZXSVRUSYDXSUTAXPVDVSUSYEUCVTNVDPVSWAVOXRVRWBXSVRWCWD
        WEWFABCXJEFGIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIWGWHAXNMXOUOZURVFZXOAXMYFMURA
        XMXIGULZUOZYFAYAXREGWJXMYIUTYCABCEGKMNOPSTUAUBUCUDWIXREXIGWKVBAYHXOAYHD
        UMGVFZXODUMGWLAXQXTYJXOUTUKYBBCDUMNVDCWMUMUTZBWMZKULZYMOULZWNZXOGYKYLDU
        TYOYMXOYKYMYNWOYLDKWPWQUADKXBWRVOWSWTXAXCAXOEUSYGXOUTANEDKUDUKXDEXOMSXE
        XFXAXG $.
    $}

    frgpup3.k $e |- ( ph -> K e. ( G GrpHom H ) ) $.
    frgpup3.e $e |- ( ph -> ( K o. U ) = F ) $.
    $( The evaluation map has the intended behavior on the generators.
       (Contributed by Mario Carneiro, 2-Oct-2015.)  (Revised by Mario
       Carneiro, 28-Feb-2016.) $)
    frgpup3lem $p |- ( ph -> K = E ) $=
      ( va vt vw vn vi vj cghm co wcel wf wfn ghmf ffn 3syl frgpup1 cv cqs wceq
      cfv wss cbs c2o cxp cfrmd cvv cqus eqid frgpval syl cword cid 2on sylancl
      con0 xpexg wrdexg fvi syl5eq frmdbas eqtr4d cefg fvex eqeltri a1i divsbas
      syl6reqr eqimss sselda cec fveq2 eqeq12d wa cmpt cvrmd ccom cgsu cc0 cfzo
      chash cs1 cop simpr adantr eleqtrd ffvelrnda c0 cif weq fveq2d adantl c1o
      wrex sylan s1eqd eceq1 3eqtr4d syl2anc wne s1eq ad2antrr eleqtrrd feqmptd
      opeq2d fmptco cmhm mpbird wrdco gsumwmhm wrdf elxp2 sylib wi ifeq12d ifex
      eqeq1 ifbid ovmpt2 wo elpri df2o3 eleq2s fveq1d vrgpf fvco3 eqtr3d iftrue
      cpr vrgpval cminusg ghminv 1n0 neeq1d mpbiri vrgpinv jaodan sylan2 anasss
      ifnefalse eqtrd df-ov syl5ibrcom rexlimdvva mpd mpteq2dva frgpuptf fcompt
      syl6eqr s1cld frgpeccl vrmdfval eqidd oveq2d frgpupval vrmdf feq3 mpteq1d
      ghmmhm wb frgpmhm eqeltrd feq2d frmdgsum wrdeq wer efger divsfval 3eqtr3d
      mhmf eqtr2d ectocld syldan eqfnfvd ) AUMRNIANKLUSUTZVAZRDNVBZNRVCUKKLNRDU
      HSVDZRDNVEVFAIUXEVARDIVBIRVCABCDEFHIJKLMOPQRSTUAUBUCUDUEUFUGUHUIVGKLIRDUH
      SVDRDIVEVFAUMVHZRVAUXIQEVIZVAUXINVKZUXIIVKZVJZARUXJUXIARUXJVJRUXJVLAUXJKV
      MVKRAEMVNVOZVPVKZKQVQVQAMPVAZKUXOEVRUTVJUCEKMUXOPUGUXOVSZUFVTWAAQUXNWBZUX
      OVMVKZAQUXRWCVKZUXRUEAUXNVQVAZUXRVQVAUXTUXRVJAUXPVNWFVAZUYAUCWDMVNPWFWGZW
      EZUXNVQWHUXRVQWIVFWJZAUYAUXSUXRVJZUYDUXSUXNUXOVQUXQUXSVSZWKWAZWLZEVQVAAEM
      WMVKVQUFMWMWNWOWPUXOVQVAAUXNVPWNWPWQUHWRRUXJWSWAWTUNVHZEXAZNVKZUYKIVKZVJU
      XMAUNUXIQEUXJUXJVSUYKUXIVJUYLUXKUYMUXLUYKUXINXBUYKUXIIXBXCAUYJQVAZXDZUYMK
      UOQUOVHZEXAZXEZUXNXFVKZUYJXGZXGZXHUTZNVKZUYLUYOLFUYJXGZXHUTLNVUAXGZXHUTZU
      YMVUCUYOVUDVUELXHUYOUPXIUYJXKVKXJUTZUPVHZUYJVKZFVKZXEZUPVUGVUIXLZEXAZNVKZ
      XEVUDVUEUYOUPVUGVUJVUNUYOVUHVUGVAZXDZVUIUQVHZURVHZXMZVJZURVNYDUQMYDZVUJVU
      NVJZVUPVUIUXNVAVVAUYOVUGUXNVUHUYJUYOUYJUXRVAZVUGUXNUYJVBZUYOUYJQUXRAUYNXN
      AQUXRVJZUYNUYEXOZXPZUXNUYJUUAWAZXQZUQURVUIMVNUUBUUCAVVAVVBUUDUYNVUOAVUTVV
      BUQURMVNAVUQMVAZVURVNVAZXDZXDZVVBVUTVUQVURFUTZVUSXLZEXAZNVKZVJVVMVVNVURXR
      VJZVUQJVKZVVSOVKZXSZVVQVVLVVNVWAVJABCVUQVURMVNCVHZXRVJZBVHZJVKZVWEOVKZXSV
      WAFVWCVVSVVTXSBUQXTZVWCVWEVVSVWFVVTVWDVUQJXBZVWGVWEVVSOVWHYAUUECURXTVWCVV
      RVVSVVTVWBVURXRUUGUUHUAVVRVVSVVTVUQJWNVVSOWNUUFUUIYBAVVJVVKVWAVVQVJZVVKAV
      VJXDZVVRVURYCVJZUUJZVWIVWLVURXRYCUUSVNVURXRYCUUKUULUUMVWJVVRVWIVWKVWJVVRX
      DZVVSVUQGVKZNVKZVWAVVQVWJVVSVWOVJVVRVWJVUQNGXGZVKZVVSVWOVWJVUQVWPJAVWPJVJ
      VVJULXOUUNAMRGVBZVVJVWQVWOVJAUXPVWRUCEGKMPRUFUJUGUHUUOWAZMRVUQNGUUPYEUUQZ
      XOVVRVWAVVSVJVWJVVRVVSVVTUURYBVWMVVPVWNNVWMVVPVUQXRXMZXLZEXAZVWNVWMVVOVXB
      VJVVPVXCVJVWMVUSVXAVWMVURXRVUQVWJVVRXNYOYFVVOVXBEYGWAVWJVWNVXCVJZVVRAUXPV
      VJVXDUCVUQEGMPUFUJUUTYEXOWLYAYHVWJVWKXDZVVTVWNKUVAVKZVKZNVKZVWAVVQVWJVVTV
      XHVJVWKVWJVVTVWOOVKZVXHVWJVVSVWOOVWTYAVWJUXFVWNRVAVXHVXIVJAUXFVVJUKXOAMRV
      UQGVWSXQRKLNVXFOVWNUHVXFVSZTUVBYIWLXOVXEVURXRYJZVWAVVTVJVXEVXKYCXRYJUVCVX
      EVURYCXRVWJVWKXNZUVDUVEVURXRVVSVVTUVJWAVXEVVPVXGNVXEVVPVUQYCXMZXLZEXAZVXG
      VXEVVOVXNVJVVPVXOVJVXEVUSVXMVXEVURYCVUQVXLYOYFVVOVXNEYGWAVWJVXGVXOVJZVWKA
      UXPVVJVXPUCVUQEGKMVXFPUFUJUGVXJUVFYEXOWLYAYHUVGUVHUVIUVKVUTVUJVVNVUNVVQVU
      TVUJVUSFVKVVNVUIVUSFXBVUQVURFUVLUVSVUTVUMVVPNVUTVULVVOVJVUMVVPVJVUIVUSYKV
      ULVVOEYGWAYAXCUVMUVNYLUVOUVPUYOUXNDFVBZVVDVUDVUKVJAVXQUYNABCDFJLMOPSTUAUB
      UCUDUVQXOVVHUPFUYJVUGUXNDUVRYIUYOUPUOVUGRVUMUYPNVKVUNVUANVUPVULQVAVUMRVAV
      UPVULUXRQVUPVUIUXNVVIUVTAVVEUYNVUOUYEYLYMZREKMQVULUGUFUEUHUWAWAUYOUPUOVUG
      QVULUYQVUMUYTUYRVXRUYOUPUOVUGUXNVUIUYPXLZVULUYJUYSVVIUYOUPVUGUXNUYJVVHYNU
      YOUYAUYSUOUXNVXSXEVJUYOUXPUYBUYAAUXPUYNUCXOZWDUYCWEZUYSUOUXNVQUYSVSZUWBWA
      UYPVUIYKYPUYOUYRUWCUYPVULEYGYPUYOUORDNUYOUXFUXGAUXFUYNUKXOZUXHWAYNUYPVUMN
      XBYPYHUWDABCUYJDEFHIJKLMOPQRSTUAUBUCUDUEUFUGUHUIUWEUYONKLYQUTVAZVUARWBVAZ
      VUCVUFVJUYOUXFVYDVYCKLNUWIWAUYOUYTQWBVAZQRUYRVBZVYEUYOVVCUXNQUYSVBZVYFVVG
      UYOVYHUXNUXRUYSVBZUYOUYAVYIVYAUYSUXNVQVYBUWFWAZUYOVVEVYHVYIUWJVVFQUXRUXNU
      YSUWGWAYRUXNQUYSUYJYSYIUYOVYGUXSRUYRVBZUYOUYRUXOKYQUTZVAZVYKUYOUYRUOUXSUY
      QXEZVYLUYOUOQUXSUYQAQUXSVJUYNUYIXOZUWHUYOUXPVYNVYLVAVXTUOEVYNKMUXOPUXSUXQ
      UYGUGUFVYNVSUWKWAUWLZUXSRUXOKUYRUYGUHUWTWAUYOQUXSRUYRVYOUWMYRQRUYRUYTYSYI
      RNKLVUAUHYTYIYHUYOVUBUYKNUYOUXOUYTXHUTZUYRVKZUYJUYRVKVUBUYKUYOVYQUYJUYRUY
      OUYAVVCVYQUYJVJVYAVVGUYSUXNUXOVQUYJUXQVYBUWNYIYAUYOVYMUYTUXSWBZVAVYRVUBVJ
      VYPUYOUYTUXRWBZVYSUYOVVCVYIUYTVYTVAVVGVYJUXNUXRUYSUYJYSYIUYOUYFVYSVYTVJAU
      YFUYNUYHXOUXSUXRUWOWAYMUXSUYRUXOKUYTUYGYTYIUYOUOUYJEUYRQQEUWPUYOEMQUEUFUW
      QWPQVQVAUYOQUXTVQUEUXRWCWNWOWPUYRVSUWRUWSYAUXAUXBUXCUXD $.
  $}

  ${
    $d b g k m s y z B $.  $d b g k m s y z F $.  $d b g k m s y z G $.
    $d b g k m s y z H $.  $d b g k m s y z I $.  $d b g k m s y z U $.
    $d b g k m s y z V $.
    frgpup3.g $e |- G = ( freeGrp ` I ) $.
    frgpup3.b $e |- B = ( Base ` H ) $.
    frgpup3.u $e |- U = ( varFGrp ` I ) $.
    $( Universal property of the free monoid by existential uniqueness.
       (Contributed by Mario Carneiro, 2-Oct-2015.)  (Revised by Mario
       Carneiro, 28-Feb-2016.) $)
    frgpup3 $p |- ( ( H e. Grp /\ I e. V /\ F : I --> B ) ->
      E! m e. ( G GrpHom H ) ( m o. U ) = F ) $=
      ( vg vy vz vk wcel cfv cv eqid adantr cgrp w3a c2o cxp cword cid cefg cec
      wf c0 wceq cminusg cif cmpt2 ccom cgsu co cop cmpt crn cghm wral wreu cbs
      wi simp1 simp2 simp3 frgpup1 wa simpr frgpup2 mpteq2dva ghmf vrgpf fcompt
      syl syl2anc feqmptd 3eqtr4d simprl simprr frgpup3lem expr ralrimiva coeq1
      eqeq1d eqreu syl3anc ) FUAPZGHPZGADUIZUBZLGUCUDUEUFQZLRZGUGQZUHFMNGUCNRUJ
      UKMRDQZWQFULQZQUMUNZWOUOUPUQURUSUTZEFVAUQZPZWTBUOZDUKZCRZBUOZDUKZXEWTUKZV
      EZCXAVBXGCXAVCWMMNAWPWSLWTDEFGWRHWNEVDQZJWRSZWSSZWJWKWLVFZWJWKWLVGZWJWKWL
      VHZWNSZWPSZIXJSZWTSZVIZWMOGORZBQWTQZUSZOGYADQZUSXCDWMOGYBYDWMYAGPZVJMNYAA
      WPWSBLWTDEFGWRHWNXJJXKXLWMWJYEXMTWMWKYEXNTWMWLYEXOTXPXQIXRXSKWMYEVKVLVMWM
      XJAWTUIZGXJBUIZXCYCUKWMXBYFXTEFWTXJAXRJVNVQWMWKYGXNWPBEGHXJXQKIXRVOVQOWTB
      GXJAVPVRWMOGADXOVSVTWMXICXAWMXEXAPZXGXHWMYHXGVJZVJMNAWPWSBLWTDEFGXEWRHWNX
      JJXKXLWMWJYIXMTWMWKYIXNTWMWLYIXOTXPXQIXRXSKWMYHXGWAWMYHXGWBWCWDWEXGXDCXAW
      TXHXFXCDXEWTBWFWGWHWI $.
  $}

  ${
    $d f x B $.  $d f x G $.
    0frgp.g $e |- G = ( freeGrp ` (/) ) $.
    0frgp.b $e |- B = ( Base ` G ) $.
    $( The free group on zero generators is trivial.  (Contributed by Mario
       Carneiro, 21-Apr-2016.) $)
    0frgp $p |- B ~~ 1o $=
      ( vx vf c0g cfv cv wcel wceq cmpt c0 wtru wa cvv wf 0ex ax-mp eqid csn co
      c1o cen wral cid cres cxp mptresid ccom cghm wrmo wreu cgrp frgpgrp cvrgp
      f0 wfn cefg vrgpf ffn mp2b fn0 mpbi eqcomi frgpup3 mp3an reurmo idghm tru
      pm3.2i 0ghm mp2an wb co02 bitru a1i rmoi fconstmpt 3eqtri mpteqb id rspec
      mprg elsn sylibr ssriv wss grpidcl snssi eqssi fvex ensn1 eqbrtri ) ABGHZ
      UAZUCUDAWPEAWPEIZAJZWQWOKZWQWPJWSEAEAWQLZEAWOLZKZWSEAUEZWTUFAUGZAWPUHZXAE
      AUIFIZMUJMKZFBBUKUBZULZXDXHJZNOXEXHJZNOXDXEKXGFXHUMZXIBUNJZMPJZMAMQXLXNXM
      RBMPCUOSZRAUQAMFMBBMPCDMUPHZMXPMURZXPMKXNMAXPQXQRMUSHZXPBMPAXRTXPTCDUTMAX
      PVAVBXPVCVDVEVFVGXGFXHVHSXJNXMXJXOABDVISVJVKXKNXMXMXKXOXOABBWOWOTZDVLVMVJ
      VKXGNNFXHXDXEXGNVNZXFXDKXGXFVOVPZVQXTXFXEKYAVQVRVGEAWOVSVTWRXBXCVNEAEAWQW
      OAWAWRWBWDVDWCEWOWEWFWGWOAJZWPAWHXMYBXOABWODXSWISWOAWJSWKWOBGWLWMWN $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Abelian groups
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CMnd $.
  $c Abel $.

  $( Extend class notation with class of all commutative monoids. $)
  ccmn $a class CMnd $.

  $( Extend class notation with class of all Abelian groups. $)
  cabel $a class Abel $.

  ${
    $d a b g $.
    $( Define class of all commutative monoids.  (Contributed by Mario
       Carneiro, 6-Jan-2015.) $)
    df-cmn $a |- CMnd = { g e. Mnd | A. a e. ( Base ` g )
      A. b e. ( Base ` g ) ( a ( +g ` g ) b ) = ( b ( +g ` g ) a ) } $.
  $}

  $( Define class of all Abelian groups.  (Contributed by NM, 17-Oct-2011.)
     (Revised by Mario Carneiro, 6-Jan-2015.) $)
  df-abl $a |- Abel = ( Grp i^i CMnd ) $.

  $( The predicate "is an Abelian (commutative) group."  (Contributed by NM,
     17-Oct-2011.) $)
  isabl $p |- ( G e. Abel <-> ( G e. Grp /\ G e. CMnd ) ) $=
    ( cgrp ccmn cabel df-abl elin2 ) ABCDEF $.

  $( An Abelian group is a group.  (Contributed by NM, 26-Aug-2011.) $)
  ablgrp $p |- ( G e. Abel -> G e. Grp ) $=
    ( cabel wcel cgrp ccmn isabl simplbi ) ABCADCAECAFG $.

  $( An Abelian group is a commutative monoid.  (Contributed by Mario Carneiro,
     6-Jan-2015.) $)
  ablcmn $p |- ( G e. Abel -> G e. CMnd ) $=
    ( cabel wcel cgrp ccmn isabl simprbi ) ABCADCAECAFG $.

  ${
    $d g x y B $.  $d g x y G $.  $d g .+ $.
    iscmn.b $e |- B = ( Base ` G ) $.
    iscmn.p $e |- .+ = ( +g ` G ) $.
    $( The predicate "is a commutative monoid."  (Contributed by Mario
       Carneiro, 6-Jan-2015.) $)
    iscmn $p |- ( G e. CMnd <-> ( G e. Mnd /\
             A. x e. B A. y e. B ( x .+ y ) = ( y .+ x ) ) ) $=
      ( vg cv cplusg cfv co wceq cbs wral cmnd ccmn fveq2 syl6eqr oveqd eqeq12d
      wb raleq raleqbi1dv syl 2ralbidv bitrd df-cmn elrab2 ) AIZBIZHIZJKZLZUKUJ
      UMLZMZBULNKZOZAUQOZUJUKDLZUKUJDLZMZBCOACOZHEPQULEMZUSUPBCOZACOZVCVDUQCMUS
      VFUBVDUQENKCULENRFSURVEAUQCUPBUQCUCUDUEVDUPVBABCCVDUNUTUOVAVDUMDUJUKVDUME
      JKDULEJRGSZTVDUMDUKUJVGTUAUFUGHABUHUI $.

    $( The predicate "is an Abelian (commutative) group."  (Contributed by NM,
       17-Oct-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    isabl2 $p |- ( G e. Abel <-> ( G e. Grp /\
             A. x e. B A. y e. B ( x .+ y ) = ( y .+ x ) ) ) $=
      ( cabel wcel cgrp ccmn wa cv co wceq wral isabl cmnd wb grpmnd iscmn baib
      syl pm5.32i bitri ) EHIEJIZEKIZLUFAMZBMZDNUIUHDNOBCPACPZLEQUFUGUJUFERIZUG
      UJSETUGUKUJABCDEFGUAUBUCUDUE $.
  $}

  ${
    $d u v x y B $.  $d u v x y K $.  $d u v x y L $.  $d u v x y ph $.
    ablpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    ablpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    ablpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    $( If two structures have the same group components (properties), one is a
       commutative monoid iff the other one is.  (Contributed by Mario
       Carneiro, 6-Jan-2015.) $)
    cmnpropd $p |- ( ph -> ( K e. CMnd <-> L e. CMnd ) ) $=
      ( vu vv cmnd wcel cv cfv co wceq wral wa eqid cplusg cbs mndpropd proplem
      ancom2s eqeq12d 2ralbidva raleqdv raleqbidv 3bitr3d anbi12d iscmn 3bitr4g
      ccmn ) AELMZJNZKNZEUAOZPZUQUPURPZQZKEUBOZRZJVBRZSFLMZUPUQFUAOZPZUQUPVFPZQ
      ZKFUBOZRZJVJRZSEUNMFUNMAUOVEVDVLABCDEFGHIUCAVAKDRZJDRVIKDRZJDRVDVLAVAVIJK
      DDAUPDMZUQDMZSSUSVGUTVHABCDDURVFUPUQIUDAVPVOUTVHQABCDDURVFUQUPIUDUEUFUGAV
      MVCJDVBGAVAKDVBGUHUIAVNVKJDVJHAVIKDVJHUHUIUJUKJKVBUREVBTURTULJKVJVFFVJTVF
      TULUM $.

    $( If two structures have the same group components (properties), one is an
       Abelian group iff the other one is.  (Contributed by NM, 6-Dec-2014.) $)
    ablpropd $p |- ( ph -> ( K e. Abel <-> L e. Abel ) ) $=
      ( cgrp wcel ccmn wa cabel grppropd cmnpropd anbi12d isabl 3bitr4g ) AEJKZ
      ELKZMFJKZFLKZMENKFNKATUBUAUCABCDEFGHIOABCDEFGHIPQERFRS $.
  $}

  ${
    $d x y K $.  $d x y L $.
    ablprop.b $e |- ( Base ` K ) = ( Base ` L ) $.
    ablprop.p $e |- ( +g ` K ) = ( +g ` L ) $.
    $( If two structures have the same group components (properties), one is an
       Abelian group iff the other one is.  (Contributed by NM,
       11-Oct-2013.) $)
    ablprop $p |- ( K e. Abel <-> L e. Abel ) $=
      ( vx vy cabel wcel wb wtru cbs cfv eqidd wceq a1i cv cplusg co wa oveqi
      ablpropd trud ) AGHBGHIJEFAKLZABJUCMUCBKLNJCOEPZFPZAQLZRUDUEBQLZRNJUDUCHU
      EUCHSSUFUGUDUEDTOUAUB $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y ph $.
    iscmnd.b $e |- ( ph -> B = ( Base ` G ) ) $.
    iscmnd.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    iscmnd.g $e |- ( ph -> G e. Mnd ) $.
    iscmnd.c $e |- ( ( ph /\ x e. B /\ y e. B ) -> ( x .+ y ) = ( y .+ x ) ) $.
    $( Properties that determine a commutative monoid.  (Contributed by Mario
       Carneiro, 7-Jan-2015.) $)
    iscmnd $p |- ( ph -> G e. CMnd ) $=
      ( cmnd wcel cv cfv co wceq wral oveqd raleqbidv eqid cplusg cbs wa 3expib
      ccmn ralrimivv eqeq12d anbi2d mpbi2and iscmn sylibr ) AFKLZBMZCMZFUANZOZU
      NUMUOOZPZCFUBNZQZBUSQZUCZFUELAULUMUNEOZUNUMEOZPZCDQZBDQZVBIAVEBCDDAUMDLUN
      DLVEJUDUFAVGVAULAVFUTBDUSGAVEURCDUSGAVCUPVDUQAEUOUMUNHRAEUOUNUMHRUGSSUHUI
      BCUSUOFUSTUOTUJUK $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y ph $.
    isabld.b $e |- ( ph -> B = ( Base ` G ) ) $.
    isabld.p $e |- ( ph -> .+ = ( +g ` G ) ) $.
    isabld.g $e |- ( ph -> G e. Grp ) $.
    isabld.c $e |- ( ( ph /\ x e. B /\ y e. B ) -> ( x .+ y ) = ( y .+ x ) ) $.
    $( Properties that determine an Abelian group.  (Contributed by NM,
       6-Aug-2013.) $)
    isabld $p |- ( ph -> G e. Abel ) $=
      ( cgrp wcel ccmn cabel cmnd grpmnd syl iscmnd isabl sylanbrc ) AFKLZFMLFN
      LIABCDEFGHAUAFOLIFPQJRFST $.
  $}

  ${
    $d x y B $.  $d x y G $.
    isabli.g $e |- G e. Grp $.
    isabli.b $e |- B = ( Base ` G ) $.
    isabli.p $e |- .+ = ( +g ` G ) $.
    isabli.c $e |- ( ( x e. B /\ y e. B ) -> ( x .+ y ) = ( y .+ x ) ) $.
    $( Properties that determine an Abelian group.  (Contributed by NM,
       4-Sep-2011.) $)
    isabli $p |- G e. Abel $=
      ( cabel wcel cgrp cv co wceq wral rgen2a isabl2 mpbir2an ) EJKELKAMZBMZDN
      UATDNOZBCPACPFUBABCIQABCDEGHRS $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z .+ $.  $d x y z W $.  $d x y z X $.
    $d x y z Y $.  $d x y z Z $.
    $( A commutative monoid is a monoid.  (Contributed by Mario Carneiro,
       6-Jan-2015.) $)
    cmnmnd $p |- ( G e. CMnd -> G e. Mnd ) $=
      ( vx vy ccmn wcel cmnd cv cplusg cfv co wceq cbs wral eqid iscmn simplbi
      ) ADEAFEBGZCGZAHIZJRQSJKCALIZMBTMBCTSATNSNOP $.

    ablcom.b $e |- B = ( Base ` G ) $.
    ablcom.p $e |- .+ = ( +g ` G ) $.
    $( A commutative monoid is commutative.  (Contributed by Mario Carneiro,
       6-Jan-2015.) $)
    cmncom $p |- ( ( G e. CMnd /\ X e. B /\ Y e. B ) ->
                 ( X .+ Y ) = ( Y .+ X ) ) $=
      ( vx vy ccmn wcel co wceq cv wral wa cmnd iscmn simprbi rsp2 imp caovcomg
      sylan 3impb ) CJKZDAKEAKDEBLEDBLMUEHIDEABUEHNZINZBLUGUFBLMZIAOHAOZUFAKUGA
      KPZUHUECQKUIHIABCFGRSUIUJUHUHHIAATUAUCUBUD $.

    $( An Abelian group operation is commutative.  (Contributed by NM,
       26-Aug-2011.) $)
    ablcom $p |- ( ( G e. Abel /\ X e. B /\ Y e. B ) ->
                 ( X .+ Y ) = ( Y .+ X ) ) $=
      ( cabel wcel ccmn co wceq ablcmn cmncom syl3an1 ) CHICJIDAIEAIDEBKEDBKLCM
      ABCDEFGNO $.

    $( Commutative/associative law for Abelian groups.  (Contributed by NM,
       4-Feb-2014.)  (Revised by Mario Carneiro, 21-Apr-2016.) $)
    cmn32 $p |- ( ( G e. CMnd /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                 ( ( X .+ Y ) .+ Z ) = ( ( X .+ Z ) .+ Y ) ) $=
      ( ccmn wcel w3a wa cmnd cmnmnd adantr simpr1 simpr2 simpr3 co wceq cmncom
      3adant3r1 mnd32g ) CIJZDAJZEAJZFAJZKZLABCDEFGHUDCMJUHCNOUDUEUFUGPUDUEUFUG
      QUDUEUFUGRUDUFUGEFBSFEBSTUEABCEFGHUAUBUC $.

    $( Commutative/associative law for Abelian groups.  (Contributed by NM,
       4-Feb-2014.)  (Revised by Mario Carneiro, 21-Apr-2016.) $)
    cmn4 $p |- ( ( G e. CMnd /\ ( X e. B /\ Y e. B ) /\ ( Z e. B /\ W e. B ) )
       -> ( ( X .+ Y ) .+ ( Z .+ W ) ) = ( ( X .+ Z ) .+ ( Y .+ W ) ) ) $=
      ( ccmn wcel wa w3a cmnd simp1 cmnmnd syl simp2l simp2r co simp3l syl3anc
      simp3r wceq cmncom mnd4g ) CJKZEAKZFAKZLZGAKZDAKZLZMZABCDEFGHIUNUGCNKUGUJ
      UMOZCPQUGUHUIUMRUGUHUIUMSZUGUJUKULUAZUGUJUKULUCUNUGUIUKFGBTGFBTUDUOUPUQAB
      CFGHIUEUBUF $.

    $( Commutative/associative law for Abelian monoids.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.)  (Revised by Mario Carneiro, 21-Apr-2016.) $)
    cmn12 $p |- ( ( G e. CMnd /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
        ( X .+ ( Y .+ Z ) ) = ( Y .+ ( X .+ Z ) ) ) $=
      ( ccmn wcel w3a wa cmnd cmnmnd adantr simpr1 simpr2 simpr3 co wceq cmncom
      3adant3r3 mnd12g ) CIJZDAJZEAJZFAJZKZLABCDEFGHUDCMJUHCNOUDUEUFUGPUDUEUFUG
      QUDUEUFUGRUDUEUFDEBSEDBSTUGABCDEGHUAUBUC $.

    abl32.g $e |- ( ph -> G e. Abel ) $.
    abl32.x $e |- ( ph -> X e. B ) $.
    abl32.y $e |- ( ph -> Y e. B ) $.
    abl32.z $e |- ( ph -> Z e. B ) $.
    $( Commutative/associative law for Abelian groups.  (Contributed by Stefan
       O'Rear, 10-Apr-2015.)  (Revised by Mario Carneiro, 21-Apr-2016.) $)
    abl32 $p |- ( ph -> ( ( X .+ Y ) .+ Z ) = ( ( X .+ Z ) .+ Y ) ) $=
      ( ccmn wcel co wceq cabel ablcmn syl cmn32 syl13anc ) ADNOZEBOFBOGBOEFCPG
      CPEGCPFCPQADROUCJDSTKLMBCDEFGHIUAUB $.
  $}

  ${
    ablinvadd.b $e |- B = ( Base ` G ) $.
    ablinvadd.p $e |- .+ = ( +g ` G ) $.
    ablinvadd.n $e |- N = ( invg ` G ) $.
    $( The inverse of an Abelian group operation.  (Contributed by NM,
       31-Mar-2014.) $)
    ablinvadd $p |- ( ( G e. Abel /\ X e. B /\ Y e. B ) ->
                   ( N ` ( X .+ Y ) ) = ( ( N ` X ) .+ ( N ` Y ) ) ) $=
      ( cabel wcel w3a co cfv cgrp wceq ablgrp grpinvadd grpinvcl syl2anc simp1
      syl3an1 3ad2ant1 simp2 simp3 ablcom syl3anc eqtr4d ) CJKZEAKZFAKZLZEFBMDN
      ZFDNZEDNZBMZUOUNBMZUICOKZUJUKUMUPPCQZABCDEFGHIRUBULUIUOAKZUNAKZUQUPPUIUJU
      KUAULURUJUTUIUJURUKUSUCZUIUJUKUDACDEGISTULURUKVAVBUIUJUKUEACDFGISTABCUOUN
      GHUFUGUH $.
  $}

  ${
    ablsub2inv.b $e |- B = ( Base ` G ) $.
    ablsub2inv.m $e |- .- = ( -g ` G ) $.
    ablsub2inv.n $e |- N = ( invg ` G ) $.
    ablsub2inv.g $e |- ( ph -> G e. Abel ) $.
    ablsub2inv.x $e |- ( ph -> X e. B ) $.
    ablsub2inv.y $e |- ( ph -> Y e. B ) $.
    $( Abelian group subtraction of two inverses.  (Contributed by Stefan
       O'Rear, 24-May-2015.) $)
    ablsub2inv $p |- ( ph -> ( ( N ` X ) .- ( N ` Y ) ) = ( Y .- X ) ) $=
      ( cfv co wcel syl2anc wceq syl3anc eqtr4d cplusg eqid cabel cgrp grpinvcl
      ablgrp syl grpsubinv ablcom grpinvinv oveq1d grpinvadd grpsubval fveq2d
      grpinvsub 3eqtrd ) AFENZGENZDOUQGCUANZOZFGDOZENZGFDOZABUSCDEUQGHUSUBZIJAC
      UCPZCUDPZKCUFUGZAVFFBPZUQBPZVGLBCEFHJUEQZMUHAUTFURUSOZENZVBAUTURENZUQUSOZ
      VLAUTGUQUSOZVNAVEVIGBPZUTVORKVJMBUSCUQGHVDUISAVMGUQUSAVFVPVMGRVGMBCEGHJUJ
      QUKTAVFVHURBPZVLVNRVGLAVFVPVQVGMBCEGHJUEQBUSCEFURHVDJULSTAVAVKEAVHVPVAVKR
      LMBUSCEDFGHVDJIUMQUNTAVFVHVPVBVCRVGLMBCDEFGHIJUOSUP $.
  $}

  ${
    ablsubadd.b $e |- B = ( Base ` G ) $.
    ablsubadd.p $e |- .+ = ( +g ` G ) $.
    ablsubadd.m $e |- .- = ( -g ` G ) $.
    $( Relationship between Abelian group subtraction and addition.
       (Contributed by NM, 31-Mar-2014.) $)
    ablsubadd $p |- ( ( G e. Abel /\ ( X e. B /\ Y e. B /\ Z e. B ) )
          -> ( ( X .- Y ) = Z <-> ( Y .+ Z ) = X ) ) $=
      ( cabel wcel w3a wa co wceq cgrp wb ablgrp grpsubadd ablcom eqeq1d bitr4d
      sylan 3adant3r1 ) CKLZEALZFALZGALZMZNZEFDOGPZGFBOZEPZFGBOZEPUFCQLUJULUNRC
      SABCDEFGHIJTUDUKUOUMEUFUHUIUOUMPUGABCFGHIUAUEUBUC $.

    $( Commutative/associative subtraction law for Abelian groups.
       (Contributed by NM, 31-Mar-2014.) $)
    ablsub4 $p |- ( ( G e. Abel /\ ( X e. B /\ Y e. B ) /\ ( Z e. B /\ W e. B )
        ) -> ( ( X .+ Y ) .- ( Z .+ W ) ) = ( ( X .- Z ) .+ ( Y .- W ) ) ) $=
      ( wcel wa co cfv wceq 3ad2ant1 syl3anc grpsubval syl2anc w3a cminusg cgrp
      cabel ablgrp simp2l simp2r grpcl simp3l simp3r eqid ablcmn simp2 grpinvcl
      ccmn cmn4 syl112anc simp1 ablinvadd oveq2d oveq12d 3eqtr4d eqtrd ) CUDLZF
      ALZGALZMZHALZEALZMZUAZFGBNZHEBNZDNZVLVMCUBOZOZBNZFHDNZGEDNZBNZVKVLALZVMAL
      ZVNVQPVKCUCLZVEVFWAVDVGWCVJCUEQZVDVEVFVJUFZVDVEVFVJUGZABCFGIJUHRVKWCVHVIW
      BWDVDVGVHVIUIZVDVGVHVIUJZABCHEIJUHRABCVODVLVMIJVOUKZKSTVKVLHVOOZEVOOZBNZB
      NZFWJBNZGWKBNZBNZVQVTVKCUOLZVGWJALZWKALZWMWPPVDVGWQVJCULQVDVGVJUMVKWCVHWR
      WDWGACVOHIWIUNTVKWCVIWSWDWHACVOEIWIUNTABCWKFGWJIJUPUQVKVPWLVLBVKVDVHVIVPW
      LPVDVGVJURWGWHABCVOHEIJWIUSRUTVKVRWNVSWOBVKVEVHVRWNPWEWGABCVODFHIJWIKSTVK
      VFVIVSWOPWFWHABCVODGEIJWIKSTVAVBVC $.

    $( Abelian group addition/subtraction law.  (Contributed by NM,
       31-Mar-2014.) $)
    abladdsub4 $p |- ( ( G e. Abel
       /\ ( X e. B /\ Y e. B ) /\ ( Z e. B /\ W e. B ) )
   -> ( ( X .+ Y ) = ( Z .+ W ) <-> ( X .- Z ) = ( W .- Y ) ) ) $=
      ( wcel wa co wceq grpcl syl3anc ablsub4 syl122anc syl2anc w3a cgrp ablgrp
      cabel wb 3ad2ant1 simp2l simp2r simp3l simp3r grpsubrcan syl13anc c0g cfv
      simp1 grpsubid oveq2d grpsubcl grprid 3eqtrd oveq1d grplid eqeq12d bitr3d
      eqid ) CUDLZFALZGALZMZHALZEALZMZUAZFGBNZHGBNZDNZHEBNZVODNZOZVNVQOZFHDNZEG
      DNZOVMCUBLZVNALZVQALZVOALZVSVTUEVFVIWCVLCUCUFZVMWCVGVHWDWGVFVGVHVLUGZVFVG
      VHVLUHZABCFGIJPQVMWCVJVKWEWGVFVIVJVKUIZVFVIVJVKUJZABCHEIJPQVMWCVJVHWFWGWJ
      WIABCHGIJPQACDVNVQVOIKUKULVMVPWAVRWBVMVPWAGGDNZBNZWACUMUNZBNZWAVMVFVGVHVJ
      VHVPWMOVFVIVLUOZWHWIWJWIABCDGFGHIJKRSVMWLWNWABVMWCVHWLWNOWGWIACDGWNIWNVEZ
      KUPTUQVMWCWAALZWOWAOWGVMWCVGVJWRWGWHWJACDFHIKURQABCWAWNIJWQUSTUTVMVRHHDNZ
      WBBNZWNWBBNZWBVMVFVJVKVJVHVRWTOWPWJWKWJWIABCDGHEHIJKRSVMWSWNWBBVMWCVJWSWN
      OWGWJACDHWNIWQKUPTVAVMWCWBALZXAWBOWGVMWCVKVHXBWGWKWIACDEGIKURQABCWBWNIJWQ
      VBTUTVCVD $.

    $( Associative-type law for group subtraction and addition.  (Contributed
       by NM, 19-Apr-2014.) $)
    abladdsub $p |- ( ( G e. Abel /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
         ( ( X .+ Y ) .- Z ) = ( ( X .- Z ) .+ Y ) ) $=
      ( cabel wcel w3a wa co wceq ablcom 3adant3r3 oveq1d syl3anc ablgrp adantr
      cgrp simpr2 simpr1 simpr3 grpaddsubass syl13anc simpl grpsubcl 3eqtrd ) C
      KLZEALZFALZGALZMZNZEFBOZGDOFEBOZGDOZFEGDOZBOZVAFBOZUQURUSGDULUMUNURUSPUOA
      BCEFHIQRSUQCUCLZUNUMUOUTVBPULVDUPCUAUBZULUMUNUOUDZULUMUNUOUEZULUMUNUOUFZA
      BCDFEGHIJUGUHUQULUNVAALZVBVCPULUPUIVFUQVDUMUOVIVEVGVHACDEGHJUJTABCFVAHIQT
      UK $.

    $( Cancellation law for subtraction.  (Contributed by NM, 2-Oct-2014.) $)
    ablpncan2 $p |- ( ( G e. Abel /\ X e. B /\ Y e. B )
       -> ( ( X .+ Y ) .- X ) = Y ) $=
      ( cabel wcel w3a co c0g cfv wceq simp1 simp2 simp3 syl2anc abladdsub cgrp
      syl13anc ablgrp syl eqid grpsubid oveq1d grplid 3eqtrd ) CJKZEAKZFAKZLZEF
      BMEDMZEEDMZFBMZCNOZFBMZFUNUKULUMULUOUQPUKULUMQZUKULUMRZUKULUMSZVAABCDEFEG
      HIUAUCUNUPURFBUNCUBKZULUPURPUNUKVCUTCUDUEZVAACDEURGURUFZIUGTUHUNVCUMUSFPV
      DVBABCFURGHVEUITUJ $.

    $( A cancellation law for commutative groups.  (Contributed by NM,
       23-Mar-2015.) $)
    ablpncan3 $p |- ( ( G e. Abel /\ ( X e. B /\ Y e. B ) ) ->
        ( X .+ ( Y .- X ) ) = Y ) $=
      ( cabel wcel wa co wceq simpl simprl cgrp ablgrp adantr syl3anc grpsubcl
      simprr ablcom grpnpcan eqtrd ) CJKZEAKZFAKZLZLZEFEDMZBMZUKEBMZFUJUFUGUKAK
      ZULUMNUFUIOUFUGUHPZUJCQKZUHUGUNUFUPUICRSZUFUGUHUBZUOACDFEGIUATABCEUKGHUCT
      UJUPUHUGUMFNUQURUOABCDFEGHIUDTUE $.

    ablsubsub.g $e |- ( ph -> G e. Abel ) $.
    ablsubsub.x $e |- ( ph -> X e. B ) $.
    ablsubsub.y $e |- ( ph -> Y e. B ) $.
    ablsubsub.z $e |- ( ph -> Z e. B ) $.
    $( Law for double subtraction.  (Contributed by NM, 7-Apr-2015.) $)
    ablsubsub $p |- ( ph -> ( X .- ( Y .- Z ) ) = ( ( X .- Y ) .+ Z ) ) $=
      ( co cgrp wcel wceq syl13anc cabel ablgrp syl grpsubsub abladdsub 3eqtr2d
      grpaddsubass ) AFGHEPEPZFHGEPCPZFHCPGEPZFGEPHCPZADQRZFBRZGBRZHBRZUHUISADU
      ARZULLDUBUCZMNOBCDEFGHIJKUDTAULUMUOUNUJUISUQMONBCDEFHGIJKUGTAUPUMUOUNUJUK
      SLMONBCDEFHGIJKUETUF $.

    $( Law for double subtraction.  (Contributed by NM, 7-Apr-2015.) $)
    ablsubsub4 $p |- ( ph -> ( ( X .- Y ) .- Z ) = ( X .- ( Y .+ Z ) ) ) $=
      ( co cminusg cfv wcel syl2anc wceq cgrp cabel ablgrp syl grpsubcl syl3anc
      eqid grpsubval grpinvcl ablsubsub grpsubinv oveq2d 3eqtr2d ) AFGEPZHEPZUO
      HDQRZRZCPZFGUREPZEPFGHCPZEPAUOBSZHBSZUPUSUAADUBSZFBSGBSVBADUCSVDLDUDUEZMN
      BDEFGIKUFUGOBCDUQEUOHIJUQUHZKUITABCDEFGURIJKLMNAVDVCURBSVEOBDUQHIVFUJTUKA
      UTVAFEABCDEUQGHIJKVFVENOULUMUN $.

    ablpnpcan.g $e |- ( ph -> G e. Abel ) $.
    ablpnpcan.x $e |- ( ph -> X e. B ) $.
    ablpnpcan.y $e |- ( ph -> Y e. B ) $.
    ablpnpcan.z $e |- ( ph -> Z e. B ) $.
    $( Cancellation law for mixed addition and subtraction.  ( ~ pnpcan
       analog.)  (Contributed by NM, 29-May-2015.) $)
    ablpnpcan $p |- ( ph -> ( ( X .+ Y ) .- ( X .+ Z ) ) = ( Y .- Z ) ) $=
      ( co c0g cfv wcel wceq ablsub4 syl122anc cgrp ablgrp syl grpsubid syl2anc
      cabel eqid oveq1d grpsubcl syl3anc grplid 3eqtrd ) AFGCTFHCTETZFFETZGHETZ
      CTZDUAUBZVACTZVAADULUCZFBUCZGBUCZVFHBUCZUSVBUDLMNMOBCDEHFGFIJKUEUFAUTVCVA
      CADUGUCZVFUTVCUDAVEVILDUHUIZMBDEFVCIVCUMZKUJUKUNAVIVABUCZVDVAUDVJAVIVGVHV
      LVJNOBDEGHIKUOUPBCDVAVCIJVKUQUKUR $.
  $}

  ${
    ablnncan.b $e |- B = ( Base ` G ) $.
    ablnncan.m $e |- .- = ( -g ` G ) $.
    ablnncan.g $e |- ( ph -> G e. Abel ) $.
    ablnncan.x $e |- ( ph -> X e. B ) $.
    ablnncan.y $e |- ( ph -> Y e. B ) $.
    $( Cancellation law for group division.  ( ~ nncan analog.)  (Contributed
       by NM, 7-Apr-2015.) $)
    ablnncan $p |- ( ph ->
             ( X .- ( X .- Y ) ) = Y ) $=
      ( co cplusg cfv c0g eqid ablsubsub wcel wceq syl2anc cgrp ablgrp grpsubid
      cabel syl oveq1d grplid 3eqtrd ) AEEFDLDLEEDLZFCMNZLCONZFUJLZFABUJCDEEFGU
      JPZHIJJKQAUIUKFUJACUARZEBRUIUKSACUDRUNICUBUEZJBCDEUKGUKPZHUCTUFAUNFBRULFS
      UOKBUJCFUKGUMUPUGTUH $.

    ablsub32.z $e |- ( ph -> Z e. B ) $.
    $( Swap the second and third terms in a double subtraction.  (Contributed
       by NM, 7-Apr-2015.) $)
    ablsub32 $p |- ( ph -> ( ( X .- Y ) .- Z ) = ( ( X .- Z ) .- Y ) ) $=
      ( cplusg cfv co cabel wcel wceq ablsubsub4 ablcom syl3anc oveq2d 3eqtr4d
      eqid ) AEFGCNOZPZDPEGFUFPZDPEFDPGDPEGDPFDPAUGUHEDACQRFBRGBRUGUHSJLMBUFCFG
      HUFUEZUAUBUCABUFCDEFGHUIIJKLMTABUFCDEGFHUIIJKMLTUD $.

    $( Cancellation law for subtraction.  ( ~ nnncan1 analog.)  (Contributed by
       NM, 7-Apr-2015.) $)
    ablnnncan1 $p |- ( ph -> ( ( X .- Y ) .- ( X .- Z ) ) = ( Z .- Y ) ) $=
      ( co cgrp wcel cabel ablgrp syl grpsubcl syl3anc ablsub32 ablnncan oveq1d
      eqtrd ) AEFDNEGDNZDNEUFDNZFDNGFDNABCDEFUFHIJKLACOPZEBPGBPUFBPACQPUHJCRSKM
      BCDEGHITUAUBAUGGFDABCDEGHIJKMUCUDUE $.
  $}

  ${
    $d k x y z B $.  $d k x y z G $.  $d k x y z M $.  $d k x y z .+ $.
    $d k x y z X $.  $d k x y z Y $.
    mulgdi.b $e |- B = ( Base ` G ) $.
    mulgdi.m $e |- .x. = ( .g ` G ) $.
    mulgdi.p $e |- .+ = ( +g ` G ) $.
    $( Group multiple of a sum, for nonnegative multiples.  (Contributed by
       Mario Carneiro, 13-Dec-2014.) $)
    mulgnn0di $p |- ( ( G e. CMnd /\ ( M e. NN0 /\ X e. B /\ Y e. B ) ) ->
      ( M .x. ( X .+ Y ) ) = ( ( M .x. X ) .+ ( M .x. Y ) ) ) $=
      ( wcel wa cn co wceq cc0 c1 cfv cv eqid vx vy vz vk ccmn cn0 w3a csn cseq
      cxp cmnd cmnmnd ad2antrr mndcl 3expb sylan simpll cmncom mndass cuz simpr
      nnuz syl6eleq cfz simplr2 elfznn fvconst2g syl2an eqeltrd simplr3 syl3anc
      adantr oveq12d eqtr4d seqcaopr mulgnn syl2anc 3eqtr4d c0g syl cbs mndidcl
      mulg0 mndlid mpdan oveq1d eqtrd wo simpr1 elnn0 sylib mpjaodan ) DUEKZEUF
      KZFAKZGAKZUGZLZEMKZEFGBNZCNZEFCNZEGCNZBNZOEPOZWRWSLZEBMWTUHUJZQUIZRZEBMFU
      HUJZQUIZRZEBMGUHUJZQUIZRZBNXAXDXFUAUBUCBAUDXJXMXGQEXFDUKKZUASZAKZUBSZAKZL
      ZXQXSBNZAKZWMXPWQWSDULZUMZXPXRXTYCABDXQXSHJUNUOUPXFWMYAYBXSXQBNOZWMWQWSUQ
      WMXRXTYFABDXQXSHJURUOUPXFXPXRXTUCSZAKUGYBYGBNXQXSYGBNBNOYEABDXQXSYGHJUSUP
      XFEMQUTRWRWSVAZVBVCXFUDSZQEVDNKZLZYIXJRZFAXFWOYIMKZYLFOYJWNWOWPWMWSVEZYIE
      VFZMFYIAVGVHZXFWOYJYNVLVIYKYIXMRZGAXFWPYMYQGOYJWNWOWPWMWSVJZYOMGYIAVGVHZX
      FWPYJYRVLVIYKYIXGRZWTYLYQBNXFWTAKZYMYTWTOYJXFXPWOWPUUAYEYNYRABDFGHJUNZVKZ
      YOMWTYIAVGVHYKYLFYQGBYPYSVMVNVOXFWSUUAXAXIOYHUUCABXHCDEWTHJIXHTVPVQXFXBXL
      XCXOBXFWSWOXBXLOYHYNABXKCDEFHJIXKTVPVQXFWSWPXCXOOYHYRABXNCDEGHJIXNTVPVQVM
      VRWRXELZPWTCNZDVSRZUUFBNZXAXDUUDUUEUUFUUGUUDUUAUUEUUFOUUDXPWOWPUUAWMXPWQX
      EYDUMWNWOWPWMXEVEZWNWOWPWMXEVJZUUBVKACDWTUUFHUUFTZIWCVTWMUUGUUFOZWQXEWMXP
      UUKYDXPUUFDWARZKUUKUULDUUFUULTZUUJWBUULBDUUFUUFUUMJUUJWDWEVTUMVNUUDEPWTCW
      RXEVAZWFUUDXBUUFXCUUFBUUDXBPFCNZUUFUUDEPFCUUNWFUUDWOUUOUUFOUUHACDFUUFHUUJ
      IWCVTWGUUDXCPGCNZUUFUUDEPGCUUNWFUUDWPUUPUUFOUUIACDGUUFHUUJIWCVTWGVMVRWRWN
      WSXEWHWMWNWOWPWIEWJWKWL $.

    $( Group multiple of a sum.  (Contributed by Mario Carneiro,
       13-Dec-2014.) $)
    mulgdi $p |- ( ( G e. Abel /\ ( M e. ZZ /\ X e. B /\ Y e. B ) ) ->
      ( M .x. ( X .+ Y ) ) = ( ( M .x. X ) .+ ( M .x. Y ) ) ) $=
      ( wcel wa co wceq ad2antrr cfv adantr syl3anc mulgneg mulgcl cabel cz w3a
      cn0 cneg ccmn ablcmn simpr simplr2 simplr3 syl13anc cminusg simpr2 simpr3
      mulgnn0di cgrp ablgrp simpr1 grpcl oveq12d 3eqtr3d simpl ablinvadd eqtr4d
      eqid fveq2d grpinvinv syl2anc wo cr elznn0 simprbi syl mpjaodan ) DUAKZEU
      BKZFAKZGAKZUCZLZEUDKZEFGBMZCMZEFCMZEGCMZBMZNZEUEZUDKZVTWALDUFKZWAVQVRWGVO
      WJVSWADUGZOVTWAUHVPVQVRVOWAUIVPVQVRVOWAUJABCDEFGHIJUOUKVTWILZWCDULPZPZWMP
      ZWFWMPZWMPZWCWFWLWNWPWMWLWNWDWMPZWEWMPZBMZWPWLWHWBCMZWHFCMZWHGCMZBMZWNWTW
      LWJWIVQVRXAXDNVOWJVSWIWKOVTWIUHVTVQWIVOVPVQVRUMZQVTVRWIVOVPVQVRUNZQABCDWH
      FGHIJUOUKVTXAWNNZWIVTDUPKZVPWBAKZXGVOXHVSDUQZQZVOVPVQVRURZVTXHVQVRXIXKXEX
      FABDFGHJUSRZACDWMEWBHIWMVEZSRQVTXDWTNWIVTXBWRXCWSBVTXHVPVQXBWRNXKXLXEACDW
      MEFHIXNSRVTXHVPVRXCWSNXKXLXFACDWMEGHIXNSRUTQVAVTWPWTNZWIVTVOWDAKZWEAKZXOV
      OVSVBVTXHVPVQXPXKXLXEACDEFHITRZVTXHVPVRXQXKXLXFACDEGHITRZABDWMWDWEHJXNVCR
      QVDVFWLXHWCAKZWOWCNVOXHVSWIXJOZVTXTWIVTXHVPXIXTXKXLXMACDEWBHITRQADWMWCHXN
      VGVHWLXHWFAKZWQWFNYAVTYBWIVTXHXPXQYBXKXRXSABDWDWEHJUSRQADWMWFHXNVGVHVAVTV
      PWAWIVIZXLVPEVJKYCEVKVLVMVN $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z M $.  $d x y z .x. $.
    mulgmhm.b $e |- B = ( Base ` G ) $.
    mulgmhm.m $e |- .x. = ( .g ` G ) $.
    $( The map from ` x ` to ` n x ` for a fixed positive integer ` n ` is a
       monoid homomorphism if the monoid is commutative.  (Contributed by Mario
       Carneiro, 4-May-2015.) $)
    mulgmhm $p |- ( ( G e. CMnd /\ M e. NN0 ) ->
      ( x e. B |-> ( M .x. x ) ) e. ( G MndHom G ) ) $=
      ( vy vz wcel wa cv co cfv wceq wral eqid oveq2 ovex fvmpt ccmn cn0 cplusg
      cmnd cmpt wf c0g w3a cmhm cmnmnd adantr jca mulgnn0cl syl3an1 3expa fmptd
      3anass mulgnn0di sylan2br anassrs mndcl 3expb sylan syl oveqan12d 3eqtr4d
      adantl ralrimivva mndidcl 3syl mulgnn0z eqtrd 3jca ismhm sylanbrc ) DUAJZ
      EUBJZKZDUDJZVSKBBABEALZCMZUEZUFZHLZILZDUCNZMZWBNZWDWBNZWEWBNZWFMZOZIBPHBP
      ZDUGNZWBNZWNOZUHWBDDUIMJVRVSVSVPVSVQDUJZUKZWRULVRWCWMWPVRABWABWBVPVQVTBJZ
      WABJZVPVSVQWSWTWQBCDEVTFGUMUNUOWBQZUPVRWLHIBBVRWDBJZWEBJZKZKZEWGCMZEWDCMZ
      EWECMZWFMZWHWKVPVQXDXFXIOZVQXDKVPVQXBXCUHXJVQXBXCUQBWFCDEWDWEFGWFQZURUSUT
      XEWGBJZWHXFOVRVSXDXLWRVSXBXCXLBWFDWDWEFXKVAVBVCAWGWAXFBWBVTWGECRXAEWGCSTV
      DXDWKXIOVRXBXCWIXGWJXHWFAWDWAXGBWBVTWDECRXAEWDCSTAWEWAXHBWBVTWEECRXAEWECS
      TVEVGVFVHVRWOEWNCMZWNVRVSWNBJWOXMOWRBDWNFWNQZVIAWNWAXMBWBVTWNECRXAEWNCSTV
      JVPVSVQXMWNOWQBCDEWNFGXNVKVCVLVMHIBBWFWFDDWBWNWNFFXKXKXNXNVNVO $.

    $( The map from ` x ` to ` n x ` for a fixed integer ` n ` is a group
       homomorphism if the group is commutative.  (Contributed by Mario
       Carneiro, 4-May-2015.) $)
    mulgghm $p |- ( ( G e. Abel /\ M e. ZZ ) ->
      ( x e. B |-> ( M .x. x ) ) e. ( G GrpHom G ) ) $=
      ( vy vz cabel wcel wa cfv cv co eqid wceq oveq2 ovex fvmpt cz cplusg cmpt
      cgrp ablgrp adantr mulgcl syl3an1 3expa fmptd w3a 3anass sylan2br anassrs
      mulgdi grpcl 3expb sylan syl oveqan12d adantl 3eqtr4d isghmd ) DJKZEUAKZL
      ZHIDUBMZVGDDABEANZCOZUCZBBFFVGPZVKVDDUDKZVEDUEZUFZVNVFABVIBVJVDVEVHBKZVIB
      KZVDVLVEVOVPVMBCDEVHFGUGUHUIVJPZUJVFHNZBKZINZBKZLZLZEVRVTVGOZCOZEVRCOZEVT
      COZVGOZWDVJMZVRVJMZVTVJMZVGOZVDVEWBWEWHQZVEWBLVDVEVSWAUKWMVEVSWAULBVGCDEV
      RVTFGVKUOUMUNWCWDBKZWIWEQVFVLWBWNVNVLVSWAWNBVGDVRVTFVKUPUQURAWDVIWEBVJVHW
      DECRVQEWDCSTUSWBWLWHQVFVSWAWJWFWKWGVGAVRVIWFBVJVHVRECRVQEVRCSTAVTVIWGBVJV
      HVTECRVQEVTCSTUTVAVBVC $.
  $}

  ${
    mulgsubdi.b $e |- B = ( Base ` G ) $.
    mulgsubdi.t $e |- .x. = ( .g ` G ) $.
    mulgsubdi.d $e |- .- = ( -g ` G ) $.
    $( Group multiple of a difference.  (Contributed by Mario Carneiro,
       13-Dec-2014.) $)
    mulgsubdi $p |- ( ( G e. Abel /\ ( M e. ZZ /\ X e. B /\ Y e. B ) ) ->
      ( M .x. ( X .- Y ) ) = ( ( M .x. X ) .- ( M .x. Y ) ) ) $=
      ( wcel w3a cfv co wceq eqid syl2anc syl3anc oveq2d grpsubval cabel cplusg
      cz wa cminusg simpr1 simpr2 ablgrp adantr simpr3 grpinvcl mulgdi syl13anc
      simpl cgrp cneg mulgneg2 mulgneg eqtr3d eqtrd mulgcl 3eqtr4d ) CUAKZDUCKZ
      FAKZGAKZLZUDZDFGCUEMZMZCUBMZNZBNZDFBNZDGBNZVIMZVKNZDFGENZBNVNVOENZVHVMVND
      VJBNZVKNZVQVHVCVDVEVJAKZVMWAOVCVGUNVCVDVEVFUFZVCVDVEVFUGZVHCUOKZVFWBVCWEV
      GCUHUIZVCVDVEVFUJZACVIGHVIPZUKQAVKBCDFVJHIVKPZULUMVHVTVPVNVKVHWEVDVFVTVPO
      WFWCWGWEVDVFLDUPGBNVTVPABCVIDGHIWHUQABCVIDGHIWHURUSRSUTVHVRVLDBVHVEVFVRVL
      OWDWGAVKCVIEFGHWIWHJTQSVHVNAKZVOAKZVSVQOVHWEVDVEWJWFWCWDABCDFHIVARVHWEVDV
      FWKWFWCWGABCDGHIVARAVKCVIEVNVOHWIWHJTQVB $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y I $.
    invghm.b $e |- B = ( Base ` G ) $.
    invghm.m $e |- I = ( invg ` G ) $.
    $( The inversion map is a group automorphism if and only if the group is
       abelian.  (In general it is only a group homomorphism into the opposite
       group, but in an abelian group the opposite group coincides with the
       group itself.)  (Contributed by Mario Carneiro, 4-May-2015.) $)
    invghm $p |- ( G e. Abel <-> I e. ( G GrpHom G ) ) $=
      ( vx vy cabel wcel cghm co cfv cv wceq wral wa syl3anc grpinvcl grpinvinv
      syl2anc cplusg eqid ablgrp cgrp wf grpinvf ablinvadd 3expb isghmd ghmgrp1
      syl adantr simprr simprl grpinvadd fveq2d simpl ghmlin oveq12d ralrimivva
      3eqtrd grpcl eqtr3d isabl2 sylanbrc impbii ) BHIZCBBJKIZVGFGBUALZVIBBCAAD
      DVIUBZVJBUCZVKVGBUDIZAACUEVKABCDEUFUKVGFMZAIZGMZAIZVMVOVIKZCLVMCLZVOCLZVI
      KZNAVIBCVMVODVJEUGUHUIVHVLVQVOVMVIKZNZGAOFAOVGBBCUJZVHWBFGAAVHVNVPPZPZWAC
      LZCLZVQWAWEWGVTCLZVRCLZVSCLZVIKZVQWEWFVTCWEVLVPVNWFVTNVHVLWDWCULZVHVNVPUM
      ZVHVNVPUNZAVIBCVOVMDVJEUOQUPWEVHVRAIZVSAIZWHWKNVHWDUQWEVLVNWOWLWNABCVMDER
      TWEVLVPWPWLWMABCVODERTVIVIBBVRCVSADVJVJURQWEWIVMWJVOVIWEVLVNWIVMNWLWNABCV
      MDESTWEVLVPWJVONWLWMABCVODESTUSVAWEVLWAAIZWGWANWLWEVLVPVNWQWLWMWNAVIBVOVM
      DVJVBQABCWADESTVCUTFGAVIBDVJVDVEVF $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d g s x y G $.  $d g s x y N $.  $d g s x y S $.
    $d g s x y .+ $.  $d g s x y X $.
    eqgabl.x $e |- X = ( Base ` G ) $.
    eqgabl.n $e |- .- = ( -g ` G ) $.
    eqgabl.r $e |- .~ = ( G ~QG S ) $.
    $( Value of the subgroup coset equivalence relation on an abelian group.
       (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    eqgabl $p |- ( ( G e. Abel /\ S C_ X ) -> ( A .~ B <->
      ( A e. X /\ B e. X /\ ( B .- A ) e. S ) ) ) $=
      ( cabel wcel wa cfv co w3a eqid wceq syl2anc df-3an wss wbr cplusg eqgval
      cminusg simpll cgrp ablgrp ad2antrr simprl grpinvcl simprr ablcom syl3anc
      grpsubval eqtr4d eleq1d pm5.32da 3bitr4g bitrd ) EKLZDGUAZMZABCUBAGLZBGLZ
      AEUENZNZBEUCNZOZDLZPZVDVEBAFOZDLZPZABVHCDEVFKGHVFQZVHQZJUDVCVDVEMZVJMVQVM
      MVKVNVCVQVJVMVCVQMZVIVLDVRVIBVGVHOZVLVRVAVGGLZVEVIVSRVAVBVQUFVREUGLZVDVTV
      AWAVBVQEUHUIVCVDVEUJZGEVFAHVOUKSVCVDVEULZGVHEVGBHVPUMUNVRVEVDVLVSRWCWBGVH
      EVFFBAHVPVOIUOSUPUQURVDVEVJTVDVEVMTUSUT $.
  $}

  ${
    $d x y G $.  $d x y H $.  $d x y S $.
    subgabl.h $e |- H = ( G |`s S ) $.
    $( A subgroup of an abelian group is also abelian.  (Contributed by Mario
       Carneiro, 3-Dec-2014.) $)
    subgabl $p |- ( ( G e. Abel /\ S e. ( SubGrp ` G ) ) -> H e. Abel ) $=
      ( vx vy cabel wcel csubg cfv wa cplusg cbs wceq subgbas adantl eqid cv co
      sseldd ressplusg cgrp subggrp w3a simp1l simp1r subgss simp2 simp3 ablcom
      wss syl syl3anc isabld ) BGHZABIJZHZKZEFABLJZCUQACMJNUOABCDOPUQUSCLJNUOAU
      SBCUPDUSQZUAPUQCUBHUOABCDUCPURERZAHZFRZAHZUDZUOVABMJZHVCVFHVAVCUSSVCVAUSS
      NUOUQVBVDUEVEAVFVAVEUQAVFUKUOUQVBVDUFVFABVFQZUGULZURVBVDUHTVEAVFVCVHURVBV
      DUITVFUSBVAVCVGUTUJUMUN $.

    $( A submonoid of a commutative monoid is also commutative.  (Contributed
       by Mario Carneiro, 10-Jan-2015.) $)
    subcmn $p |- ( ( G e. CMnd /\ H e. Mnd ) -> H e. CMnd ) $=
      ( vx vy wcel cbs cfv cplusg cvv wceq c0 wn eqid syl cress co cv sseli c0g
      ccmn cmnd wa eqidd mndidcl n0i reldmress ovprc2 syl5eq fveq2d base0 nsyl2
      syl6eqr adantl ressplusg simpr simpl ressbasss cmncom syl3an iscmnd ) BUB
      GZCUCGZUDZEFCHIZBJIZCVEVFUEVEAKGZVGCJILVDVHVCVDVFMLZVHVDCUAIZVFGVINVFCVJV
      FOVJOUFVFVJUGPVHNZVFMHIMVKCMHVKCBAQRMDBAQUHUIUJUKULUNUMUOAVGBCKDVGOZUPPVC
      VDUQVEVCESZVFGVMBHIZGFSZVFGVOVNGVMVOVGRVOVMVGRLVCVDURVFVNVMAVNCBDVNOZUSZT
      VFVNVOVQTVNVGBVMVOVPVLUTVAVB $.

    $( A submonoid of a commutative monoid is also commutative.  (Contributed
       by Mario Carneiro, 24-Apr-2016.) $)
    submcmn $p |- ( ( G e. CMnd /\ S e. ( SubMnd ` G ) ) -> H e. CMnd ) $=
      ( csubmnd cfv wcel ccmn cmnd submmnd subcmn sylan2 ) ABEFGBHGCIGCHGACBDJA
      BCDKL $.

    submcmn2.z $e |- Z = ( Cntz ` G ) $.
    $( A submonoid is commutative iff it is a subset of its own centralizer.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    submcmn2 $p |- ( S e. ( SubMnd ` G ) ->
      ( H e. CMnd <-> S C_ ( Z ` S ) ) ) $=
      ( vx vy cfv wcel cv cplusg co wceq wral cbs wss eqid oveqd raleqbidv ccmn
      csubmnd submbas ressplusg eqeq12d submss sscntz syl2anc cmnd submmnd baib
      wb iscmn syl 3bitr4rd ) ABUBIZJZGKZHKZBLIZMZUSURUTMZNZHAOZGAOZURUSCLIZMZU
      SURVFMZNZHCPIZOZGVJOZAADIQZCUAJZUQVDVKGAVJACBEUCZUQVCVIHAVJVOUQVAVGVBVHUQ
      UTVFURUSAUTBCUPEUTRZUDZSUQUTVFUSURVQSUETTUQABPIZQZVSVMVEULVRABVRRZUFZWAGH
      VRUTAABDVTVPFUGUHUQCUIJZVNVLULACBEUJVNWBVLGHVJVFCVJRVFRUMUKUNUO $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y S $.  $d x Z $.
    cntzcmn.b $e |- B = ( Base ` G ) $.
    cntzcmn.z $e |- Z = ( Cntz ` G ) $.
    $( The centralizer of any subset in a commutative monoid is the whole
       monoid.  (Contributed by Mario Carneiro, 3-Oct-2015.) $)
    cntzcmn $p |- ( ( G e. CMnd /\ S C_ B ) -> ( Z ` S ) = B ) $=
      ( vx vy ccmn wcel wss wa cfv cntzssv a1i cv w3a cplusg co wceq wral simp2
      simpl1 simpl3 sselda eqid cmncom syl3anc ralrimiva wb cntzel mpbird ssrdv
      3adant1 3expia eqssd ) CIJZBAKZLZBDMZAUTAKUSABCDEFNOUSGAUTUQURGPZAJZVAUTJ
      ZUQURVBQZVCVAHPZCRMZSVEVAVFSTZHBUAZVDVGHBVDVEBJZLUQVBVEAJVGUQURVBVIUCUQUR
      VBVIUDVDBAVEUQURVBUBUEAVFCVAVEEVFUFZUGUHUIURVBVCVHUJUQHAVFBCVADEVJFUKUNUL
      UOUMUP $.
  $}

  ${
    $d x y z M $.  $d x y B $.  $d x y S $.  $d x Z $.  $d y P $.  $d y X $.
    $d y Y $.
    cntzspan.z $e |- Z = ( Cntz ` G ) $.
    cntzspan.k $e |- K = ( mrCls ` ( SubMnd ` G ) ) $.
    cntzspan.h $e |- H = ( G |`s ( K ` S ) ) $.
    $( If the generators commute, the generated monoid is commutative.
       (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    cntzspan $p |- ( ( G e. Mnd /\ S C_ ( Z ` S ) ) -> H e. CMnd ) $=
      ( cmnd wcel cfv wss wa ccmn cntzsubm syldan mrcsscl syl3anc wb syl2anc
      csubmnd cbs cmre cacs submacs adantr acsmred simpr cntzssv syl6ss mrcssvd
      eqid cntzrec mpbid mrccl submcmn2 syl mpbird ) BIJZAAEKZLZMZCNJZADKZVDEKZ
      LZVBBUAKZBUBKZUCKJZAVELZVEVGJZVFVBVGVHUSVGVHUDKJVAVHBVHULZUEUFUGZVBVDUTLZ
      VJVBVIVAUTVGJZVNVMUSVAUHZUSVAAVHLZVOVBAUTVHVPVHABEVLFUIUJZVHABEVLFOPVGADU
      TVHGQRVBVDVHLZVQVNVJSVBVGADVHVMGUKZVRVHVDABEVLFUMTUNUSVAVSVKVTVHVDBEVLFOP
      VGADVEVHGQRVBVDVGJZVCVFSVBVIVQWAVMVRVGADVHGUOTVDBCEHFUPUQUR $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y M $.  $d x y N $.  $d x y .+ $.
    ghmplusg.p $e |- .+ = ( +g ` N ) $.
    $( The pointwise sum of two linear functions is linear.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    ghmplusg $p |- ( ( N e. Abel /\ F e. ( M GrpHom N ) /\
          G e. ( M GrpHom N ) ) -> ( F oF .+ G ) e. ( M GrpHom N ) ) $=
      ( vx vy wcel co cfv cbs eqid 3ad2ant3 cvv wa 3expb wceq syl ffvelrnda w3a
      cabel cghm cplusg cof cgrp ghmgrp1 ghmgrp2 grpcl sylan ghmf 3ad2ant2 fvex
      cv wf a1i inidm off ghmlin 3ad2antl2 3ad2antl3 oveq12d ccmn simpl1 ablcmn
      adantrr adantrl cmn4 syl122anc eqtrd adantr fnfvof syl22anc simprl simprr
      wfn ffn 3eqtr4d isghmd ) EUBIZBDEUCJZIZCWAIZUAZGHDUDKZADEBCAUEJZDLKZELKZW
      GMZWHMZWEMZFWCVTDUFIZWBDECUGNZWCVTEUFIZWBDECUHNZWDGHWGWGWGAWHWHWHBCOOWDWN
      GUNZWHIZHUNZWHIZPWPWRAJWHIZWOWNWQWSWTWHAEWPWRWJFUIQUJWBVTWGWHBUOZWCDEBWGW
      HWIWJUKULZWCVTWGWHCUOZWBDECWGWHWIWJUKNZWGOIZWDDLUMZUPZXGWGUQURWDWPWGIZWRW
      GIZPZPZWPWRWEJZBKZXLCKZAJZWPBKZWPCKZAJZWRBKZWRCKZAJZAJZXLWFKZWPWFKZWRWFKZ
      AJXKXOXPXSAJZXQXTAJZAJZYBXKXMYFXNYGAWBVTXJXMYFRZWCWBXHXIYIWEADEWPBWRWGWIW
      KFUSQUTWCVTXJXNYGRZWBWCXHXIYJWEADEWPCWRWGWIWKFUSQVAVBXKEVCIZXPWHIZXSWHIZX
      QWHIZXTWHIZYHYBRXKVTYKVTWBWCXJVDEVESWDXHYLXIWDWGWHWPBXBTVFWDXIYMXHWDWGWHW
      RBXBTVGWDXHYNXIWDWGWHWPCXDTVFWDXIYOXHWDWGWHWRCXDTVGWHAEXTXPXSXQWJFVHVIVJX
      KBWGVPZCWGVPZXEXLWGIZYCXORWDYPXJWDXAYPXBWGWHBVQSVKZWDYQXJWDXCYQXDWGWHCVQS
      VKZXEXKXFUPZWDWLXJYRWMWLXHXIYRWGWEDWPWRWIWKUIQUJWGABCOXLVLVMXKYDXRYEYAAXK
      YPYQXEXHYDXRRYSYTUUAWDXHXIVNWGABCOWPVLVMXKYPYQXEXIYEYARYSYTUUAWDXHXIVOWGA
      BCOWRVLVMVBVRVS $.
  $}

  ${
    $d x y z G $.
    $( Every subgroup of an abelian group is normal.  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    ablnsg $p |- ( G e. Abel -> ( NrmSGrp ` G ) = ( SubGrp ` G ) ) $=
      ( vx vy vz cabel wcel cnsg cfv csubg cv cplusg co wb cbs wral wceq ablcom
      wa eqid 3expb eleq1d ralrimivva isnsg rbaib syl eqrdv ) AEFZBAGHZAIHZUGCJ
      ZDJZAKHZLZBJZFUKUJULLZUNFMZDANHZOCUQOZUNUHFZUNUIFZMUGUPCDUQUQUGUJUQFZUKUQ
      FZRRUMUOUNUGVAVBUMUOPUQULAUJUKUQSZULSZQTUAUBUSUTURCDULUNAUQVCVDUCUDUEUF
      $.
  $}

  ${
    odadd1.1 $e |- O = ( od ` G ) $.
    odadd1.2 $e |- X = ( Base ` G ) $.
    odadd1.3 $e |- .+ = ( +g ` G ) $.
    $( The order of a product in an abelian group divides the LCM of the orders
       of the factors.  (Contributed by Mario Carneiro, 20-Oct-2015.) $)
    odadd1 $p |- ( ( G e. Abel /\ A e. X /\ B e. X ) ->
      ( ( O ` ( A .+ B ) ) x. ( ( O ` A ) gcd ( O ` B ) ) ) ||
        ( ( O ` A ) x. ( O ` B ) ) ) $=
      ( wcel co cmul cdivides wbr cc0 wceq cz adantr wb syl3anc w3a cfv cgcd wa
      cabel cn0 cgrp ablgrp grpcl syl3an1 odcl 3ad2ant2 3ad2ant3 gcdcld zmulcld
      syl nn0zd dvds0 gcdeq0 syl2anc biimpa oveq12 0cn mul01i breqtrrd wne cdiv
      syl6eq cmg c0g simpl1 gcddvds simpld dvdsmultr1 mpd simpr dvdsval2 simpl2
      wi mpbid simpl3 eqid mulgdi syl13anc simprd dvdsmul1 zcnd divassd mulcomd
      oddvds oveq1d oveq12d grpidcl grplid dvdsmulcr syl112anc divcan1d breqtrd
      eqtrd mpbird pm2.61dane ) DUEJZAFJZBFJZUAZABCKZEUBZAEUBZBEUBZUCKZLKZXHXIL
      KZMNXJOXEXJOPZUDZXKOXLMXNXKQJZXKOMNXEXOXMXEXGXJXEXGXEXFFJZXGUFJXBDUGJZXCX
      DXPDUHZFCDABHIUIUJZXFDEFHGUKUPUQZXEXJXEXHXIXEXHXCXBXHUFJXDADEFHGUKULUQZXE
      XIXDXBXIUFJXCBDEFHGUKUMUQZUNUQZUORXKURUPXNXHOPXIOPUDZXLOPXEXMYDXEXHQJZXIQ
      JZXMYDSYAYBXHXIUSUTVAYDXLOOLKOXHOXIOLVBOVCVDVHUPVEXEXJOVFZUDZXKXLXJVGKZXJ
      LKZXLMYHXKYJMNZXGYIMNZYHYLYIXFDVIUBZKZDVJUBZPZYHYNYIAYMKZYIBYMKZCKZYOYHXB
      YIQJZXCXDYNYSPXBXCXDYGVKZYHXJXLMNZYTYHXJXHMNZUUBYHUUCXJXIMNZYHYEYFUUCUUDU
      DXEYEYGYARZXEYFYGYBRZXHXIVLUTZVMZYHXJQJZYEYFUUCUUBVSXEUUIYGYCRZUUEUUFXJXH
      XIVNTVOYHUUIYGXLQJUUBYTSUUJXEYGVPZYHXHXIUUEUUFUOZXJXLVQTVTZXBXCXDYGVRZXBX
      CXDYGWAZFCYMDYIABHYMWBZIWCWDYHYSYOYOCKZYOYHYQYOYRYOCYHXHYIMNZYQYOPZYHXHXH
      XIXJVGKZLKZYIMYHYEUUTQJZXHUVAMNUUEYHUUDUVBYHUUCUUDUUGWEYHUUIYGYFUUDUVBSUU
      JUUKUUFXJXIVQTVTXHUUTWFUTYHXHXIXJYHXHUUEWGZYHXIUUFWGZYHXJUUJWGZUUKWHVEYHX
      QXCYTUURUUSSYHXBXQUUAXRUPZUUNUUMAYMDYIEFYOHGUUPYOWBZWJTVTYHXIYIMNZYRYOPZY
      HXIXIXHXJVGKZLKZYIMYHYFUVJQJZXIUVKMNUUFYHUUCUVLUUHYHUUIYGYEUUCUVLSUUJUUKU
      UEXJXHVQTVTXIUVJWFUTYHYIXIXHLKZXJVGKUVKYHXLUVMXJVGYHXHXIUVCUVDWIWKYHXIXHX
      JUVDUVCUVEUUKWHWSVEYHXQXDYTUVHUVISUVFUUOUUMBYMDYIEFYOHGUUPUVGWJTVTWLYHXQY
      OFJZUUQYOPUVFYHXQUVNUVFFDYOHUVGWMUPFCDYOYOHIUVGWNUTWSWSYHXQXPYTYLYPSUVFXE
      XPYGXSRUUMXFYMDYIEFYOHGUUPUVGWJTWTYHXGQJZYTUUIYGYKYLSXEUVOYGXTRUUMUUJUUKX
      JXGYIWOWPWTYHXLXJYHXLUULWGUVEUUKWQWRXA $.

    $( The order of a product in an abelian group is divisible by the LCM of
       the orders of the factors divided by the GCD. (Contributed by Mario
       Carneiro, 20-Oct-2015.) $)
    odadd2 $p |- ( ( G e. Abel /\ A e. X /\ B e. X ) ->
      ( ( O ` A ) x. ( O ` B ) ) ||
        ( ( O ` ( A .+ B ) ) x. ( ( ( O ` A ) gcd ( O ` B ) ) ^ 2 ) ) ) $=
      ( wcel cmul co cdivides wbr cc0 wceq cz wb syl3anc mpbid cabel w3a cfv c2
      cgcd cexp cn0 odcl 3ad2ant2 nn0zd 3ad2ant3 zmulcld adantr dvds0 syl simpr
      wa sq0id oveq2d cgrp ablgrp grpcl syl3an1 zcnd mul01d eqtrd breqtrrd cdiv
      gcdcld nn0cnd sqvald gcddvds syl2anc simpld dvdsval2 simprd mul4d oveq12d
      wne divcan1d 3eqtr2d dvdsmul2 cmg simpl1 simpl2 simpl3 eqid mulgdi oddvds
      c0g syl13anc dvdsmul1 mulgcl grprid 3eqtr3rd mpbird dvdsgcd mp2and mulgcd
      wi breqtrd eqbrtrd dvdsmulcr syl112anc oveq1d grplid c1 cc ax-1cn mulid2d
      3eqtr2rd mulcan2ad coprmdvds2 syl31anc zsqcl dvdsmulc eqbrtrrd pm2.61dane
      a1i mulgcdr mpd ) DUAJZAFJZBFJZUBZAEUCZBEUCZKLZABCLZEUCZYFYGUELZUDUFLZKLZ
      MNYKOYEYKOPZUQZYHOYMMYOYHQJZYHOMNYEYPYNYEYFYGYEYFYCYBYFUGJYDADEFHGUHUIUJZ
      YEYGYDYBYGUGJYCBDEFHGUHUKUJZULUMYHUNUOYOYMYJOKLOYOYLOYJKYOYKYEYNUPURUSYOY
      JYOYJYEYJQJZYNYEYJYEYIFJZYJUGJZYBDUTJZYCYDYTDVAZFCDABHIVBVCZYIDEFHGUHUOZU
      JZUMVDVEVFVGYEYKOVSZUQZYFYKVHLZYGYKVHLZKLZYLKLZYHYMMUUHUULUUKYKYKKLZKLUUI
      YKKLZUUJYKKLZKLYHUUHYLUUMUUKKUUHYKUUHYKUUHYFYGYEYFQJZUUGYQUMZYEYGQJZUUGYR
      UMZVIZVJZVKUSUUHUUIYKUUJYKUUHUUIUUHYKYFMNZUUIQJZUUHUVBYKYGMNZUUHUUPUURUVB
      UVDUQUUQUUSYFYGVLVMZVNUUHYKQJZUUGUUPUVBUVCRUUHYKUUTUJZYEUUGUPZUUQYKYFVOST
      ZVDUVAUUHUUJUUHUVDUUJQJZUUHUVBUVDUVEVPUUHUVFUUGUURUVDUVJRUVGUVHUUSYKYGVOS
      TZVDUVAVQUUHUUNYFUUOYGKUUHYFYKUUHYFUUQVDUVAUVHVTZUUHYGYKUUHYGUUSVDUVAUVHV
      TZVRWAUUHUUKYJMNZUULYMMNZUUHUUIYJMNZUUJYJMNZUVNUUHUUNYJYKKLZMNZUVPUUHUUNY
      FUVRMUVLUUHYFYJYFKLZYJYGKLZUELZUVRMUUHYFUVTMNZYFUWAMNZYFUWBMNZUUHYSUUPUWC
      YEYSUUGUUFUMZUUQYJYFWBVMZUUHUWDUWAADWCUCZLZDWJUCZPZUUHUWAYIUWHLZUWIUWJCLZ
      UWJUWIUUHUWLUWIUWABUWHLZCLZUWMUUHYBUWAQJZYCYDUWLUWOPYBYCYDUUGWDZUUHYJYGUW
      FUUSULZYBYCYDUUGWEZYBYCYDUUGWFZFCUWHDUWAABHUWHWGZIWHWKUUHUWNUWJUWICUUHYGU
      WAMNZUWNUWJPZUUHYSUURUXBUWFUUSYJYGWBVMZUUHUUBYDUWPUXBUXCRUUHYBUUBUWQUUCUO
      ZUWTUWRBUWHDUWAEFUWJHGUXAUWJWGZWISTUSVFUUHYJUWAMNZUWLUWJPZUUHYSUURUXGUWFU
      USYJYGWLVMUUHUUBYTUWPUXGUXHRUXEYEYTUUGUUDUMZUWRYIUWHDUWAEFUWJHGUXAUXFWIST
      UUHUUBUWIFJZUWMUWIPUXEUUHUUBUWPYCUXJUXEUWRUWSFUWHDUWAAHUXAWMSFCDUWIUWJHIU
      XFWNVMWOUUHUUBYCUWPUWDUWKRUXEUWSUWRAUWHDUWAEFUWJHGUXAUXFWISWPUUHUUPUVTQJZ
      UWPUWCUWDUQUWEWTUUQUUHYJYFUWFUUQULZUWRYFUVTUWAWQSWRUUHUUAUUPUURUWBUVRPYEU
      UAUUGUUEUMUUQUUSYJYFYGWSSZXAXBUUHUVCYSUVFUUGUVSUVPRUVIUWFUVGUVHYKUUIYJXCX
      DTUUHUUOUVRMNZUVQUUHUUOYGUVRMUVMUUHYGUWBUVRMUUHYGUVTMNZUXBYGUWBMNZUUHUXOU
      VTBUWHLZUWJPZUUHUVTYIUWHLZUWJUXQCLZUWJUXQUUHUXSUVTAUWHLZUXQCLZUXTUUHYBUXK
      YCYDUXSUYBPUWQUXLUWSUWTFCUWHDUVTABHUXAIWHWKUUHUYAUWJUXQCUUHUWCUYAUWJPZUWG
      UUHUUBYCUXKUWCUYCRUXEUWSUXLAUWHDUVTEFUWJHGUXAUXFWISTXEVFUUHYJUVTMNZUXSUWJ
      PZUUHYSUUPUYDUWFUUQYJYFWLVMUUHUUBYTUXKUYDUYERUXEUXIUXLYIUWHDUVTEFUWJHGUXA
      UXFWISTUUHUUBUXQFJZUXTUXQPUXEUUHUUBUXKYDUYFUXEUXLUWTFUWHDUVTBHUXAWMSFCDUX
      QUWJHIUXFXFVMWOUUHUUBYDUXKUXOUXRRUXEUWTUXLBUWHDUVTEFUWJHGUXAUXFWISWPUXDUU
      HUURUXKUWPUXOUXBUQUXPWTUUSUXLUWRYGUVTUWAWQSWRUXMXAXBUUHUVJYSUVFUUGUXNUVQR
      UVKUWFUVGUVHYKUUJYJXCXDTUUHUVCUVJYSUUIUUJUELZXGPUVPUVQUQUVNWTUVIUVKUWFUUH
      UYGXGYKUUHUYGUUHUUIUUJUVIUVKVIVJXGXHJUUHXIXSUVAUVHUUHXGYKKLYKUUNUUOUELZUY
      GYKKLZUUHYKUVAXJUUHUUNYFUUOYGUEUVLUVMVRUUHUVCUVJYKUGJUYHUYIPUVIUVKUUTUUIU
      UJYKXTSXKXLYJUUIUUJXMXNWRUUHUUKQJYSYLQJZUVNUVOWTUUHUUIUUJUVIUVKULUWFUUHUV
      FUYJUVGYKXOUOYLUUKYJXPSYAXQXR $.

    $( The order of a product is the product of the orders, if the factors have
       coprime order.  (Contributed by Mario Carneiro, 20-Oct-2015.) $)
    odadd $p |- ( ( ( G e. Abel /\ A e. X /\ B e. X ) /\
      ( ( O ` A ) gcd ( O ` B ) ) = 1 ) ->
        ( O ` ( A .+ B ) ) = ( ( O ` A ) x. ( O ` B ) ) ) $=
      ( wcel cfv co c1 cn0 cmul cdivides wbr syl odcl c2 cabel w3a cgcd wceq wa
      simpl1 ablgrp simpl2 simpl3 grpcl syl3anc nn0mulcld oveq2d nn0cnd mulid1d
      cgrp simpr eqtrd odadd1 adantr eqbrtrrd cexp odadd2 oveq1d syl6eq breqtrd
      sq1 dvdseq syl22anc ) DUAJZAFJZBFJZUBZAEKZBEKZUCLZMUDZUEZABCLZEKZNJZVNVOO
      LZNJVTWBPQWBVTPQVTWBUDVRVSFJZWAVRDUPJZVKVLWCVRVJWDVJVKVLVQUFDUGRVJVKVLVQU
      HZVJVKVLVQUIZFCDABHIUJUKVSDEFHGSRZVRVNVOVRVKVNNJWEADEFHGSRVRVLVONJWFBDEFH
      GSRULVRVTVPOLZVTWBPVRWHVTMOLZVTVRVPMVTOVMVQUQZUMVRVTVRVTWGUNUOZURVMWHWBPQ
      VQABCDEFGHIUSUTVAVRWBVTVPTVBLZOLZVTPVMWBWMPQVQABCDEFGHIVCUTVRWMWIVTVRWLMV
      TOVRWLMTVBLMVRVPMTVBWJVDVGVEUMWKURVFVTWBVHVI $.
  $}

  ${
    $d p x y A $.  $d n x y E $.  $d x y G $.  $d n p x y O $.  $d p x y ph $.
    $d p x y X $.
    gexex.1 $e |- X = ( Base ` G ) $.
    gexex.2 $e |- E = ( gEx ` G ) $.
    $( A group with exponent 2 (or 1) is abelian.  (Contributed by Mario
       Carneiro, 24-Apr-2016.) $)
    gex2abl $p |- ( ( G e. Grp /\ E || 2 ) -> G e. Abel ) $=
      ( vx vy wcel c2 cfv wceq cv co grpass syl13anc mulg2 syl gexdvdsi syl3anc
      eqid cgrp cdivides wbr wa cplusg cbs a1i eqidd simpl w3a c0g simp1l simp2
      cmg simp3 simp1r eqtr3d oveq2d grprid syl2anc 3eqtrd oveq1d 3eqtr2d grpcl
      wb grplcan mpbid isabld ) BUAHZAIUBUCZUDZFGCBUEJZBCBUFJKVKDUGVKVLUHVIVJUI
      VKFLZCHZGLZCHZUJZVMVOVLMZVRVLMZVRVOVMVLMZVLMZKZVRVTKZVQVRVOVLMZVMVLMZVSWA
      VQWEBUKJZIVRBUNJZMZVSVQWEVMVMVLMZIVMWGMZWFVQWDVMVMVLVQWDVMVOVOVLMZVLMZVMW
      FVLMZVMVQVIVNVPVPWDWLKVIVJVNVPULZVKVNVPUMZVKVNVPUOZWPCVLBVMVOVODVLTZNOVQW
      KWFVMVLVQIVOWGMZWKWFVQVPWRWKKWPCVLWGBVODWGTZWQPQVQVIVPVJWRWFKWNWPVIVJVNVP
      UPZVOWGABICWFDEWSWFTZRSUQURVQVIVNWMVMKWNWOCVLBVMWFDWQXAUSUTVAVBVQVNWJWIKW
      OCVLWGBVMDWSWQPQVQVIVNVJWJWFKWNWOWTVMWGABICWFDEWSXARSVCVQVIVRCHZVJWHWFKWN
      VQVIVNVPXBWNWOWPCVLBVMVODWQVDSZWTVRWGABICWFDEWSXARSVQXBWHVSKXCCVLWGBVRDWS
      WQPQVCVQVIXBVPVNWEWAKWNXCWPWOCVLBVRVOVMDWQNOUQVQVIXBVTCHZXBWBWCVEWNXCVQVI
      VPVNXDWNWPWOCVLBVOVMDWQVDSXCCVLBVRVTVRDWQVFOVGVH $.

    gexex.3 $e |- O = ( od ` G ) $.
    ${
      gexexlem.1 $e |- ( ph -> G e. Abel ) $.
      gexexlem.2 $e |- ( ph -> E e. NN ) $.
      gexexlem.3 $e |- ( ph -> A e. X ) $.
      gexexlem.4 $e |- ( ( ph /\ y e. X ) -> ( O ` y ) <_ ( O ` A ) ) $.
      $( Lemma for ~ gexex .  (Contributed by Mario Carneiro, 24-Apr-2016.) $)
      gexexlem $p |- ( ph -> ( O ` A ) = E ) $=
        ( wcel wbr wceq syl2anc co syl3anc vx vp cfv cn0 cdivides odcl syl cgrp
        nnnn0d cabel ablgrp gexod wral cpc cle cprime cexp cdiv cmul cmg cplusg
        cv wa cgcd c1 ad2antrr cz cn prmnn adantl simpr gexnnod pccld nnzd eqid
        nnexpcld mulgcl simplr pcdvds nndivdvds mpbid odmulg gcdeq mpbird eqtrd
        oveq1d nncnd nnne0d divcan3d divcan1d dvdsmul1 breqtrd 3eqtrrd mulcanad
        wb eqtr2d oveq12d gcdcom wn pcndvds2 coprm wi prmz rpexp1i 3eqtrd odadd
        mpd syl31anc grpcl ralrimiva fveq2 breq1d rspcv sylc eqbrtrrd lemuldivd
        nnred nnrpd crp nnrp cr cc0 clt rpregt0 lediv2 syl3an nn0zd cuz eluz2b2
        c2 prmuz2 simprbi leexp2d adantr pc2dvds gexdvds2 dvdseq syl22anc ) ACF
        UCZUDOZDUDOYSDUEPZDYSUEPZYSDQACGOZYTMCEFGHJUFUGZADLUIAEUHOZUUCUUAAEUJOZ
        UUEKEUKUGZMCDEFGHIJULRAUUBUAVBZFUCZYSUEPZUAGUMZAUUJUAGAUUHGOZVCZUUJUBVB
        ZUUIUNSZUUNYSUNSZUOPZUBUPUMZUUMUUQUBUPUUMUUNUPOZVCZUUQUUNUUOUQSZUUNUUPU
        QSZUOPZUUTUVCYSUVBURSZYSUVAURSUOPZUUTUVDUVAUSSZYSUOPUVEUUTUVBCEUTUCZSZU
        UIUVAURSZUUHUVGSZEVAUCZSZFUCZUVFYSUOUUTUVMUVHFUCZUVJFUCZUSSZUVFUUTUUFUV
        HGOZUVJGOZUVNUVOVDSZVEQUVMUVPQAUUFUULUUSKVFUUTUUEUVBVGOZUUCUVQAUUEUULUU
        SUUGVFZUUTUVBUUTUUNUUPUUSUUNVHOZUUMUUNVIVJZUUTUUNYSUUMUUSVKZUUTUUEDVHOZ
        UUCYSVHOZUWAAUWEUULUUSLVFZAUUCUULUUSMVFZCDEFGHIJVLTZVMZVPZVNZUWHGUVGEUV
        BCHUVGVOZVQTZUUTUUEUVIVGOZUULUVRUWAUUTUVIUUTUVAUUIUEPZUVIVHOZUUTUUSUUIV
        HOZUWPUWDUUTUUEUWEUULUWRUWAUWGAUULUUSVRZUUHDEFGHIJVLTZUUNUUIVSRUUTUWRUV
        AVHOZUWPUWQWOUWTUUTUUNUUOUWCUUTUUNUUIUWDUWTVMZVPZUUIUVAVTRWAZVNZUWSGUVG
        EUVIUUHHUWMVQTZUUTUVSUVDUVAVDSZUVAUVDVDSZVEUUTUVNUVDUVOUVAVDUUTUVDUVBUV
        NUSSZUVBURSUVNUUTYSUXIUVBURUUTYSUVBYSVDSZUVNUSSZUXIUUTUUEUUCUVTYSUXKQUW
        AUWHUWLCUVGEUVBFGHJUWMWBTUUTUXJUVBUVNUSUUTUXJUVBQZUVBYSUEPZUUTUUSUWFUXM
        UWDUWIUUNYSVSRZUUTUVBVHOZUWFUXLUXMWOUWKUWIUVBYSWCRWDWFWEWFUUTUVNUVBUUTU
        VNUUTUUEUWEUVQUVNVHOUWAUWGUWNUVHDEFGHIJVLTWGUUTUVBUWKWGUUTUVBUWKWHWIWPZ
        UUTUVOUVAUVIUUTUVOUUTUUEUWEUVRUVOVHOUWAUWGUXFUVJDEFGHIJVLTWGUUTUVAUXCWG
        ZUUTUVIUXDWGUUTUVIUXDWHUUTUVIUVAUSSZUUIUVIUUIVDSZUVOUSSZUVIUVOUSSUUTUUI
        UVAUUTUUIUWTWGUXQUUTUVAUXCWHWJZUUTUUEUULUWOUUIUXTQUWAUWSUXEUUHUVGEUVIFG
        HJUWMWBTUUTUXSUVIUVOUSUUTUXSUVIQZUVIUUIUEPZUUTUVIUXRUUIUEUUTUWOUVAVGOZU
        VIUXRUEPUXEUUTUVAUXCVNZUVIUVAWKRUYAWLUUTUWQUWRUYBUYCWOUXDUWTUVIUUIWCRWD
        WFWMWNZWQUUTUVDVGOZUYDUXGUXHQUUTUVDUUTUXMUVDVHOZUXNUUTUWFUXOUXMUYHWOUWI
        UWKYSUVBVTRWAZVNZUYEUVDUVAWRRUUTUUNUVDVDSVEQZUXHVEQZUUTUUNUVDUEPWSZUYKU
        UTUUSUWFUYMUWDUWIUUNYSWTRUUTUUSUYGUYMUYKWOUWDUYJUUNUVDXARWAUUTUUNVGOZUY
        GUUOUDOUYKUYLXBUUSUYNUUMUUNXCVJUYJUXBUUNUVDUUOXDTXGXEUVHUVJUVKEFGJHUVKV
        OZXFXHUUTUVNUVDUVOUVAUSUXPUYFWQWEUUTUVLGOZBVBZFUCZYSUOPZBGUMZUVMYSUOPZU
        UTUUEUVQUVRUYPUWAUWNUXFGUVKEUVHUVJHUYOXITAUYTUULUUSAUYSBGNXJVFUYSVUABUV
        LGUYQUVLQUYRUVMYSUOUYQUVLFXKXLXMXNXOUUTUVDYSUVAUUTUVDUYIXQUUTYSUWIXQUUT
        UVAUXCXRXPWAUUTUXAUXOUWFUVCUVEWOZUXCUWKUWIUXAUVAXSOZUXOUVBXSOZUWFYSXSOZ
        VUBUVAXTUVBXTYSXTVUCUVAYAOYBUVAYCPVCVUDUVBYAOYBUVBYCPVCVUEYSYAOYBYSYCPV
        CVUBUVAYDUVBYDYSYDUVAUVBYSYEYFYFTWDUUTUUNUUOUUPUUTUUNUWCXQUUTUUOUXBYGUU
        TUUPUWJYGUUTUUNYJYHUCOZVEUUNYCPZUUSVUFUUMUUNYKVJVUFUWBVUGUUNYIYLUGYMWDX
        JUUMUUIVGOYSVGOZUUJUURWOUUMUUIUULUUIUDOAUUHEFGHJUFVJYGAVUHUULAYSUUDYGZY
        NUUIYSUBYORWDXJAUUEVUHUUBUUKWOUUGVUIUADEYSFGHIJYPRWDYSDYQYR $.
    $}

    $( In an abelian group with finite exponent, there is an element in the
       group with order equal to the exponent.  In other words, all orders of
       elements divide the largest order of an element of the group.  This
       fails if ` E = 0 ` , for example in an infinite p-group, where there are
       elements of arbitrarily large orders (so ` E ` is zero) but no elements
       of infinite order.  (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    gexex $p |- ( ( G e. Abel /\ E e. NN ) -> E. x e. X ( O ` x ) = E ) $=
      ( vy vn wcel wa cv wceq cz c0 cle wbr cn0 ax-mp cabel cn cfv crn clt csup
      cr wrex wss wne wral wf odf frn nn0ssz sstri a1i ablgrp adantr grpbn0 syl
      cgrp cdm fdmi eqeq1i dm0rn0 bitr3i necon3bii sylib nnz adantl gexod sylan
      cdivides wi odcl nn0zd simplr dvdsle syl2anc mpd ralrimiva wb breq1 ralrn
      wfn sylibr ralbidv rspcev suprzcl2 syl3anc fvelrnb simpll simprl ad2antrr
      ffn breq2 fnfvelrn suprzub simplrr breqtrrd gexexlem expr reximdva ) CUAK
      ZBUBKZLZAMZDUCZDUDZUGUEUFZNZAEUHZXIBNZAEUHXGXKXJKZXMXGXJOUIZXJPUJZIMZJMZQ
      RZIXJUKZJOUHZXOXPXGXJSOESDULZXJSUICDEFHUMZESDUNTUOUPZUQXGEPUJZXQXGCVBKZYF
      XEYGXFCURUSZECFUTVAEPXJPEPNDVCZPNXJPNYIEPESDYDVDVEDVFVGVHVIXGBOKZXRBQRZIX
      JUKZYBXFYJXEBVJVKXGXIBQRZAEUKZYLXGYMAEXGXHEKZLZXIBVNRZYMXGYGYOYQYHXHBCDEF
      GHVLVMYPXIOKXFYQYMVOYPXIYOXISKXGXHCDEFHVPVKVQXEXFYOVRXIBVSVTWAWBDEWFZYLYN
      WCYCYRYDESDWPTZYKYMIAEDXRXIBQWDWETWGYAYLJBOXSBNXTYKIXJXSBXRQWQWHWIVTZJIXJ
      WJWKYRXOXMWCYSAEXKDWLTVIXGXLXNAEXGYOXLXNXGYOXLLZLZIXHBCDEFGHXEXFUUAWMXEXF
      UUAVRXGYOXLWNUUBXREKZLZXRDUCZXKXIQUUDXPYBUUEXJKZUUEXKQRXPUUDYEUQXGYBUUAUU
      CYTWOUUBYRUUCUUFYRUUBYSUQEXRDWRVMJIXJUUEWSWKXGYOXLUUCWTXAXBXCXDWA $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z N $.  $d x y z O $.
    torsubg.1 $e |- O = ( od ` G ) $.
    $( The set of all elements of finite order forms a subgroup of any abelian
       group, called the torsion subgroup.  (Contributed by Mario Carneiro,
       20-Oct-2015.) $)
    torsubg $p |- ( G e. Abel -> ( `' O " NN ) e. ( SubGrp ` G ) ) $=
      ( vx vy wcel cn cfv co wa cn0 eqid syl wceq wb elpreima cc0 cmul cdivides
      ax-mp cabel ccnv cima csubg cbs wss c0 wne cv cplusg cminusg cdm cnvimass
      wral odf fdmi sseqtri a1i c0g cgrp ablgrp grpidcl c1 od1 1nn syl6eqel wfn
      wf ffn sylanbrc ne0i ad2antrr sseli ad2antlr adantl syl3anc cgcd wbr 0nnn
      grpcl odcl nn0zd gcdcld nn0cnd mul02d breq1d zmulcld 0dvds bitrd nnmulcld
      cz simprbi eleq1 syl5ibcom sylbid mtoi simpll odadd1 oveq1 wo elnn0 sylib
      mtod ord mt3d ralrimiva grpinvcl syl2an eqeltrd jca w3a issubg2 mpbir3and
      odinv ) AUAFZBUBGUCZAUDHFZXPAUEHZUFZXPUGUHZDUIZEUIZAUJHZIZXPFZEXPUNZYAAUK
      HZHZXPFZJZDXPUNZXSXOXPBULXRBGUMXRKBABXRXRLZCUOZUPUQZURXOAUSHZXPFZXTXOYOXR
      FZYOBHZGFZYPXOAUTFZYQAVAZXRAYOYLYOLZVBMXOYRVCGXOYTYRVCNUUAABYOCUUBVDMVEVF
      BXRVGZYPYQYSJOXRKBVHUUCYMXRKBVITZXRYOGBPTVJXPYOVKMXOYJDXPXOYAXPFZJZYFYIUU
      FYEEXPUUFYBXPFZJZYDXRFZYDBHZGFZYEUUHYTYAXRFZYBXRFZUUIXOYTUUEUUGUUAVLUUEUU
      LXOUUGXPXRYAYNVMZVNZUUGUUMUUFXPXRYBYNVMVOZXRYCAYAYBYLYCLZVTVPZUUHUUKUUJQN
      ZUUHUUSQYABHZYBBHZVQIZRIZUUTUVARIZSVRZUUHUVEQGFZVSUUHUVEUVDQNZUVFUUHUVEQU
      VDSVRZUVGUUHUVCQUVDSUUHUVBUUHUVBUUHUUTUVAUUHUUTUUHUULUUTKFUUOYAABXRYLCWAM
      WBZUUHUVAUUHUUMUVAKFUUPYBABXRYLCWAMWBZWCWDWEWFUUHUVDWKFUVHUVGOUUHUUTUVAUV
      IUVJWGUVDWHMWIUUHUVDGFUVGUVFUUHUUTUVAUUEUUTGFZXOUUGUUEUULUVKUUCUUEUULUVKJ
      OUUDXRYAGBPTWLZVNUUGUVAGFZUUFUUGUUMUVMUUCUUGUUMUVMJOUUDXRYBGBPTWLVOWJUVDQ
      GWMWNWOWPUUHUUJUVBRIZUVDSVRZUUSUVEUUHXOUULUUMUVOXOUUEUUGWQUUOUUPYAYBYCABX
      RCYLUUQWRVPUUSUVNUVCUVDSUUJQUVBRWSWFWNXCUUHUUKUUSUUHUUJKFZUUKUUSWTUUHUUIU
      VPUURYDABXRYLCWAMUUJXAXBXDXEUUCYEUUIUUKJOUUDXRYDGBPTVJXFUUFYHXRFZYHBHZGFZ
      YIXOYTUULUVQUUEUUAUUNXRAYGYAYLYGLZXGXHUUFUVRUUTGXOYTUULUVRUUTNUUEUUAUUNYA
      AYGBXRCUVTYLXNXHUUEUVKXOUVLVOXIUUCYIUVQUVSJOUUDXRYHGBPTVJXJXFXOYTXQXSXTYK
      XKOUUADEXRYCXPAYGYLUUQUVTXLMXM $.

    oddvdssubg.1 $e |- B = ( Base ` G ) $.
    $( The set of all elements whose order divides a fixed integer is a
       subgroup of any abelian group.  (Contributed by Mario Carneiro,
       19-Apr-2016.) $)
    oddvdssubg $p |- ( ( G e. Abel /\ N e. ZZ ) ->
      { x e. B | ( O ` x ) || N } e. ( SubGrp ` G ) ) $=
      ( vy wcel wa cfv cdivides wbr co adantr syl wceq fveq2 breq1d elrab cabel
      vz cz cv crab csubg wss c0 wne cplusg wral cminusg ssrab2 a1i cgrp ablgrp
      c0g eqid grpidcl c1 od1 1dvds adantl eqbrtrd sylanbrc ne0i simprl syl3anc
      grpcl cmg simplll simpllr mulgdi syl13anc simprr wb oddvds oveq12d grplid
      mpbid syl2anc 3eqtrd mpbird sylan2b ralrimiva odinv jca issubg2 mpbir3and
      grpinvcl w3a ) CUAIZDUCIZJZAUDZEKZDLMZABUEZCUFKIZWRBUGZWRUHUIZHUDZUBUDZCU
      JKZNZWRIZUBWRUKZXBCULKZKZWRIZJZHWRUKZWTWNWQABUMUNWNCUQKZWRIZXAWNXMBIZXMEK
      ZDLMZXNWNCUOIZXOWLXRWMCUPOZBCXMGXMURZUSZPWNXPUTDLWNXRXPUTQXSCEXMFXTVAPWMU
      TDLMWLDVBVCVDWQXQAXMBWOXMQWPXPDLWOXMERSTVEWRXMVFPWNXKHWRXBWRIWNXBBIZXBEKZ
      DLMZJZXKWQYDAXBBWOXBQWPYCDLWOXBERSTWNYEJZXGXJYFXFUBWRXCWRIYFXCBIZXCEKZDLM
      ZJZXFWQYIAXCBWOXCQWPYHDLWOXCERSTYFYJJZXEBIZXEEKZDLMZXFYKXRYBYGYLYFXRYJWNX
      RYEXSOZOZYFYBYJWNYBYDVGZOZYFYGYIVGZBXDCXBXCGXDURZVIVHZYKYNDXECVJKZNZXMQZY
      KUUCDXBUUBNZDXCUUBNZXDNZXMXMXDNZXMYKWLWMYBYGUUCUUGQWLWMYEYJVKWLWMYEYJVLZY
      RYSBXDUUBCDXBXCGUUBURZYTVMVNYKUUEXMUUFXMXDYKYDUUEXMQZYFYDYJWNYBYDVOZOYKXR
      YBWMYDUUKVPYPYRUUIXBUUBCDEBXMGFUUJXTVQVHVTYKYIUUFXMQZYFYGYIVOYKXRYGWMYIUU
      MVPYPYSUUIXCUUBCDEBXMGFUUJXTVQVHVTVRYKXRXOUUHXMQYPYKXRXOYPYAPBXDCXMXMGYTX
      TVSWAWBYKXRYLWMYNUUDVPYPUUAUUIXEUUBCDEBXMGFUUJXTVQVHWCWQYNAXEBWOXEQWPYMDL
      WOXEERSTVEWDWEYFXIBIZXIEKZDLMZXJYFXRYBUUNYOYQBCXHXBGXHURZWJWAYFUUOYCDLYFX
      RYBUUOYCQYOYQXBCXHEBFUUQGWFWAUULVDWQUUPAXIBWOXIQWPUUODLWOXIERSTVEWGWDWEWN
      XRWSWTXAXLWKVPXSHUBBXDWRCXHGYTUUQWHPWI $.
  $}

  ${
    $d x y z R $.  $d x y z T $.  $d x y z U $.  $d x y z B $.  $d x y z G $.
    $d x .(+) $.
    lsmcomx.v $e |- B = ( Base ` G ) $.
    lsmcomx.s $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum commutes (extended domain version).  (Contributed by NM,
       25-Feb-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmcomx $p |- ( ( G e. Abel /\ T C_ B /\ U C_ B )
       -> ( T .(+) U ) = ( U .(+) T ) ) $=
      ( vx vy vz cabel wcel wss co cv wceq wrex wa sseldd lsmelvalx cplusg eqid
      w3a cfv simpl1 simpl2 simprl simpl3 simprr ablcom eqeq2d 2rexbidva rexcom
      syl3anc syl6bb wb 3com23 3bitr4d eqrdv ) EKLZCAMZDAMZUCZHCDBNZDCBNZVCHOZI
      OZJOZEUAUDZNZPZJDQICQZVFVHVGVINZPZICQJDQZVFVDLVFVELZVCVLVNJDQICQVOVCVKVNI
      JCDVCVGCLZVHDLZRZRZVJVMVFVTUTVGALVHALVJVMPUTVAVBVSUEVTCAVGUTVAVBVSUFVCVQV
      RUGSVTDAVHUTVAVBVSUHVCVQVRUISAVIEVGVHFVIUBZUJUNUKULVNIJCDUMUOIJAVIBCDEKVF
      FWAGTUTVBVAVPVOUPJIAVIBDCEKVFFWAGTUQURUS $.
  $}

  ${
    ablcntzd.z $e |- Z = ( Cntz ` G ) $.
    ablcntzd.a $e |- ( ph -> G e. Abel ) $.
    ablcntzd.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    ablcntzd.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
    $( All subgroups in an abelian group commute.  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    ablcntzd $p |- ( ph -> T C_ ( Z ` U ) ) $=
      ( cbs cfv csubg wcel wss eqid subgss syl ccmn wceq cabel cntzcmn sseqtr4d
      ablcmn syl2anc ) ABDJKZCEKZABDLKZMBUENHUEBDUEOZPQADRMZCUENZUFUESADTMUIGDU
      CQACUGMUJIUECDUHPQUECDEUHFUAUDUB $.
  $}

  ${
    lsmcom.s $e |- .(+) = ( LSSum ` G ) $.
    $( Subgroup sum commutes.  (Contributed by NM, 6-Feb-2014.)  (Revised by
       Mario Carneiro, 21-Jun-2014.) $)
    lsmcom $p |- ( ( G e. Abel /\ T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) )
       -> ( T .(+) U ) = ( U .(+) T ) ) $=
      ( cabel wcel csubg cfv cbs wss co wceq id eqid subgss lsmcomx syl3an ) DF
      GZSBDHIZGBDJIZKCTGCUAKBCALCBALMSNUABDUAOZPUACDUBPUAABCDUBEQR $.

    $( The sum of two subgroups is a subgroup.  (Contributed by NM,
       4-Feb-2014.)  (Proof shortened by Mario Carneiro, 19-Apr-2016.) $)
    lsmsubg2 $p |- ( ( G e. Abel /\ T e. ( SubGrp ` G ) /\
      U e. ( SubGrp ` G ) ) -> ( T .(+) U ) e. ( SubGrp ` G ) ) $=
      ( cabel wcel csubg cfv w3a ccntz wss co simp2 simp3 eqid ablcntzd lsmsubg
      simp1 syl3anc ) DFGZBDHIZGZCUBGZJZUCUDBCDKIZILBCAMUBGUAUCUDNZUAUCUDOZUEBC
      DUFUFPZUAUCUDSUGUHQABCDUFEUIRT $.

    $( Commutative/associative law for subgroup sum.  (Contributed by NM,
       26-Sep-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsm4 $p |- ( ( G e. Abel /\ ( Q e. ( SubGrp ` G ) /\ R e. ( SubGrp ` G ) )
                /\ ( T e. ( SubGrp ` G ) /\ U e. ( SubGrp ` G ) ) ) ->
   ( ( Q .(+) R ) .(+) ( T .(+) U ) ) = ( ( Q .(+) T ) .(+) ( R .(+) U ) ) ) $=
      ( cabel wcel csubg cfv wa w3a wceq simp1 simp2r syl3anc lsmass lsmsubg2
      co simp3l lsmcom oveq2d simp2l 3eqtr4d oveq1d simp3r 3eqtr3d ) FHIZBFJKZI
      ZCUJIZLZDUJIZEUJIZLZMZBCATZDATZEATZBDATZCATZEATZURDEATATZVACEATATZUQUSVBE
      AUQBCDATZATZBDCATZATZUSVBUQVFVHBAUQUIULUNVFVHNUIUMUPOZUIUKULUPPZUIUMUNUOU
      AZACDFGUBQUCUQUKULUNUSVGNUIUKULUPUDZVKVLABCDFGRQUQUKUNULVBVINVMVLVKABDCFG
      RQUEUFUQURUJIZUNUOUTVDNUQUIUKULVNVJVMVKABCFGSQVLUIUMUNUOUGZAURDEFGRQUQVAU
      JIZULUOVCVENUQUIUKUNVPVJVMVLABDFGSQVKVOAVACEFGRQUH $.
  $}

  ${
    $d c I $.  $d a b c ph $.  $d c R $.  $d c S $.  $d a b c Y $.
    prdscmnd.y $e |- Y = ( S Xs_ R ) $.
    prdscmnd.i $e |- ( ph -> I e. W ) $.
    prdscmnd.s $e |- ( ph -> S e. V ) $.
    ${
      prdscmnd.r $e |- ( ph -> R : I --> CMnd ) $.
      $( The product of a family of commutative monoids is commutative.
         (Contributed by Stefan O'Rear, 10-Jan-2015.) $)
      prdscmnd $p |- ( ph -> Y e. CMnd ) $=
        ( vc cfv ccmn cmnd wcel co 3ad2ant1 cvv eqid va vb cbs cplusg eqidd wss
        wf cv cmnmnd ssriv fss sylancl prdsmndd w3a cmpt wa wceq ffvelrnda elex
        syl adantr wfn ffn simpl2 simpr prdsbasprj simpl3 mpteq2dva simp2 simp3
        cmncom syl3anc prdsplusgval 3eqtr4d iscmnd ) AUAUBGUCMZGUDMZGAVPUEAVQUE
        ABCDEFGHIJADNBUGZNOUFDOBUGKUANOUAUHZUIUJDNOBUKULUMAVSVPPZUBUHZVPPZUNZLD
        LUHZVSMZWDWAMZWDBMZUDMZQZUOLDWFWEWHQZUOVSWAVQQWAVSVQQWCLDWIWJWCWDDPZUPZ
        WGNPWEWGUCMZPWFWMPWIWJUQWCDNWDBAVTVRWBKRURWLVPBCVSDWDSSGHVPTZWCCSPZWKAV
        TWOWBACEPWOJCEUSUTRZVAZWCDSPZWKAVTWRWBADFPWRIDFUSUTRZVAZWCBDVBZWKAVTXAW
        BAVRXAKDNBVCUTRZVAZAVTWBWKVDWCWKVEZVFWLVPBCWADWDSSGHWNWQWTXCAVTWBWKVGXD
        VFWMWHWGWEWFWMTWHTVKVLVHWCLVPVQBCVSWADSSGHWNWPWSXBAVTWBVIZAVTWBVJZVQTZV
        MWCLVPVQBCWAVSDSSGHWNWPWSXBXFXEXGVMVNVO $.
    $}

    prdsgabld.r $e |- ( ph -> R : I --> Abel ) $.
    $( The product of a family of Abelian groups is an Abelian group.
       (Contributed by Stefan O'Rear, 10-Jan-2015.) $)
    prdsabld $p |- ( ph -> Y e. Abel ) $=
      ( va cgrp wcel ccmn cabel wf wss ssriv fss ablgrp sylancl prdsgrpd ablcmn
      cv prdscmnd isabl sylanbrc ) AGMNGONGPNABCDEFGHIJADPBQZPMRDMBQKLPMLUEZUAS
      DPMBTUBUCABCDEFGHIJAUIPORDOBQKLPOUJUDSDPOBTUBUFGUGUH $.
  $}

  ${
    pwscmn.y $e |- Y = ( R ^s I ) $.
    $( The structure power on a commutative monoid is commutative.
       (Contributed by Mario Carneiro, 11-Jan-2015.) $)
    pwscmn $p |- ( ( R e. CMnd /\ I e. V ) -> Y e. CMnd ) $=
      ( ccmn wcel wa csca cfv csn cxp cprds co eqid pwsval cvv simpr fvex a1i
      wf fconst6g adantr prdscmnd eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUIO
      PUHUJUIBQCUKUKOUFUGRUIQGUHAISTUFBFUJUAUGBAFUBUCUDUE $.

    $( The structure power on an Abelian group is Abelian.  (Contributed by
       Mario Carneiro, 21-Jan-2015.) $)
    pwsabl $p |- ( ( R e. Abel /\ I e. V ) -> Y e. Abel ) $=
      ( cabel wcel wa csca cfv csn cxp cprds co eqid pwsval cvv simpr fvex a1i
      wf fconst6g adantr prdsabld eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUIO
      PUHUJUIBQCUKUKOUFUGRUIQGUHAISTUFBFUJUAUGBAFUBUCUDUE $.
  $}

  ${
    $d a b x y G $.  $d a b x y H $.  $d a b x y S $.
    divsabl.h $e |- H = ( G /s ( G ~QG S ) ) $.
    $( If ` Y ` is a subgroup of the abelian group ` G ` , then ` H = G / Y `
       is an abelian group.  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
    divsabl $p |- ( ( G e. Abel /\ S e. ( SubGrp ` G ) ) -> H e. Abel ) $=
      ( vx vy va vb cabel wcel cfv wa cv cplusg co wceq eleq2d cec wrex eqid
      csubg cgrp cbs wral cnsg ablnsg biimpar divsgrp syl cqg cqs vex elqs cqus
      cvv eqidd simpl divsbas syl5bbr anbi12d reeanv ablcom 3expb adantlr eceq1
      a1i adantr simprl simprr divsadd syl3anc 3eqtr4d oveq12 ancoms syl5ibrcom
      ovex eqeq12d rexlimdvva syl5bir sylbird ralrimivv isabl2 sylanbrc ) BIJZA
      BUAKZJZLZCUBJZEMZFMZCNKZOZWJWIWKOZPZFCUCKZUDEWOUDCIJWGABUEKZJZWHWDWQWFWDW
      PWEABUFQUGZABCDUHUIWGWNEFWOWOWGWIWOJZWJWOJZLWIGMZBAUJOZRZPZGBUCKZSZWJHMZX
      BRZPZHXESZLZWNWGXFWSXJWTXFWIXEXBUKZJWGWSGXEWIXBEULUMWGXLWOWIWGXBBCXEUOICB
      XBUNOPWGDVFWGXEUPXBUOJWGBAUJVPVFWDWFUQURZQUSXJWJXLJWGWTHXEWJXBFULUMWGXLWO
      WJXMQUSUTXKXDXILZHXESGXESWGWNXDXIGHXEXEVAWGXNWNGHXEXEWGXAXEJZXGXEJZLZLZWN
      XNXCXHWKOZXHXCWKOZPXRXAXGBNKZOZXBRZXGXAYAOZXBRZXSXTXRYBYDPZYCYEPWDXQYFWFW
      DXOXPYFXEYABXAXGXETZYATZVBVCVDYBYDXBVEUIXRWQXOXPXSYCPWGWQXQWRVGZWGXOXPVHZ
      WGXOXPVIZYAWKABCXEXAXGDYGYHWKTZVJVKXRWQXPXOXTYEPYIYKYJYAWKABCXEXGXADYGYHY
      LVJVKVLXNWLXSWMXTWIXCWJXHWKVMXIXDWMXTPWJXHWIXCWKVMVNVQVOVRVSVTWAEFWOWKCWO
      TYLWBWC $.
  $}

  ${
    $d x y z G $.
    cnaddablx.g $e |- G = { <. 1 , CC >. , <. 2 , + >. } $.
    $( The complex numbers are an Abelian group under addition.  This version
       of ~ cnaddabl shows the explicit structure "scaffold" we chose for the
       definition for Abelian groups.  Note:  This theorem has hard-coded
       structure indices for demonstration purposes.  It is not intended for
       general use; use ~ cnaddabl instead.  (New usage is discouraged.)
       (Contributed by NM, 18-Oct-2012.) $)
    cnaddablx $p |- G e. Abel $=
      ( vx vy vz cc caddc cv cneg cc0 cnex addex addcl addass addid2 negcl wcel
      0cn co addcom wceq mpdan negid eqtr3d isgrpix grpbasex grpplusgx isabli )
      CDFGACDEFGACHZIZJKLBUIDHZMUIUKEHNRUIOUIPZUIFQZUIUJGSZUJUIGSZJUMUJFQUNUOUA
      ULUIUJTUBUIUCUDUEFGAKLBUFFGAKLBUGUIUKTUH $.
  $}

  ${
    $d x y z G $.
    cnaddabl.g $e |- G
               = { <. ( Base ` ndx ) , CC >. , <. ( +g ` ndx ) , + >. } $.
    $( The complex numbers are an Abelian group under addition.  This version
       of ~ cnaddablx hides the explicit structure indices i.e. is
       "scaffold-independent".  Note that the proof also does not reference
       explicit structure indices.  The actual structure is dependent on how
       ` Base ` and ` +g ` is defined.  This theorem should not be referenced
       in any proof.  For the group/ring properties of the complex numbers, see
       ~ cnrng .  (Contributed by NM, 20-Oct-2012.)
       (New usage is discouraged.) $)
    cnaddabl $p |- G e. Abel $=
      ( vx vy vz cc caddc cv cneg cc0 cvv wcel cbs cfv wceq cnex grpbase addcom
      ax-mp co cplusg addex grpplusg addcl addass 0cn addid2 negcl mpdan eqtr3d
      negid isgrpi isabli ) CDFGACDEFGACHZIZJFKLFAMNOPFGAKBQSZGKLGAUANOUBFGAKBU
      CSZUNDHZUDUNUREHUEUFUNUGUNUHZUNFLZUNUOGTZUOUNGTZJUTUOFLVAVBOUSUNUORUIUNUK
      UJULUPUQUNURRUM $.
  $}

  ${
    $d x y z G $.
    zaddablx.g $e |- G = { <. 1 , ZZ >. , <. 2 , + >. } $.
    $( The integers are an Abelian group under addition.  Note:  This theorem
       has hard-coded structure indices for demonstration purposes.  It is not
       intended for general use.  Use ~ zsubrg instead.
       (New usage is discouraged.)  (Contributed by NM, 4-Sep-2011.) $)
    zaddablx $p |- G e. Abel $=
      ( vx vy vz cz caddc cv cneg cc0 zex addex zaddcl wcel cc co addcom syl2an
      wceq zcn addass syl3an 0z addid2d znegcl negidd eqtr3d grpbasex grpplusgx
      mpdan isgrpix isabli ) CDFGACDEFGACHZIZJKLBUMDHZMUMFNZUMONZUOFNZUOONZEHZF
      NUTONUMUOGPZUTGPUMUOUTGPGPSUMTZUOTZUTTUMUOUTUAUBUCUPUMVBUDUMUEZUPUMUNGPZU
      NUMGPZJUPUNFNZVEVFSZVDUPUQUNONVHVGVBUNTUMUNQRUJUPUMVBUFUGUKFGAKLBUHFGAKLB
      UIUPUQUSVAUOUMGPSURVBVCUMUOQRUL $.
  $}

  ${
    $d a b d x A $.  $d d m t D $.  $d a b m n t v w x y z I $.  $d a b x ph $.
    $d a b d m t x y z .~ $.  $d a b d x B $.  $d a b d k m n t v w x y z W $.
    $d a b x G $.  $d a b m n t v w x M $.  $d a b d k m t x T $.
    frgpnabl.g $e |- G = ( freeGrp ` I ) $.
    ${
      frgpnabl.w $e |- W = ( _I ` Word ( I X. 2o ) ) $.
      frgpnabl.r $e |- .~ = ( ~FG ` I ) $.
      frgpnabl.p $e |- .+ = ( +g ` G ) $.
      frgpnabl.m $e |- M = ( y e. I , z e. 2o |-> <. y , ( 1o \ z ) >. ) $.
      frgpnabl.t $e |- T = ( v e. W |->
        ( n e. ( 0 ... ( # ` v ) ) , w e. ( I X. 2o ) |->
          ( v splice <. n , n , <" w ( M ` w ) "> >. ) ) ) $.
      frgpnabl.d $e |- D = ( W \ U_ x e. W ran ( T ` x ) ) $.
      frgpnabl.u $e |- U = ( varFGrp ` I ) $.
      frgpnabl.i $e |- ( ph -> I e. _V ) $.
      frgpnabl.a $e |- ( ph -> A e. I ) $.
      frgpnabl.b $e |- ( ph -> B e. I ) $.
      $( Lemma for ~ frgpnabl .  (Contributed by Mario Carneiro,
         21-Apr-2016.) $)
      frgpnabllem1 $p |- ( ph -> <" <. A , (/) >. <. B , (/) >. "> e.
        ( D i^i ( ( U ` A ) .+ ( U ` B ) ) ) ) $=
        ( va vb c0 cop cs2 wcel cfv co cin cv crn ciun cdif c2o cxp c1o cpr 0ex
        cword prid1 df2o3 eleqtrri opelxpi sylancl s2cld cid cvv wceq 2on xpexg
        con0 wrdexg fvi 3syl syl5eq eleqtrrd wrex wa wne wn 1n0 cc0 chash caddc
        c2 2cn addid2i s2len eqtr4i efgtlen adantll ex 0cn a1i cn0 simpr efgrcl
        cc simprd adantl eleqtrd lencl syl nn0cnd addcan2d wi cfz csplice rneqd
        eleq2d cconcat ccatlid ax-mp hash0 oveq2i eqtrd c1 fveq1d s2fv1 3eqtr3g
        ovex opex s2fv0 vex sylbid wb cs1 cec vrgpval syl2anc s1cld sylibd cotp
        cmpt2 wf efgtf simpld eqid elrnmpt2 simprr efgmf ffvelrni oveq1i eqtr2i
        simprl syl6eleq elfz1eq syl6eqr syl6eqel addid1d syl5req splval2 oveq1d
        wrd0 ccatrid eqeq2d ad3antrrr 1on fvex fveq2d efgmval df-ov dif0 opeq2i
        3eqtr2rd opthg simplbda syl21anc rexlimdvva expimpd hasheq0 eleq1 fveq2
        syl5bi anbi12d sylbi eqcoms imbi1d syl5ibrcom expdimp mpdd necon3ad mpi
        com23 nrexdv eliun sylnibr eldifd syl6eleqr df-s2 efger erref syl5eqbrr
        wbr wer eqeltri elec sylibr oveq12d frgpadd elin sylanbrc ) AGULUMZHULU
        MZUNZIUOUXNGMUPZHMUPZJUQZUOUXNIUXQURUOAUXNRBRBUSZLUPZUTZVAZVBIAUXNRUYAA
        UXNPVCVDZVHZRAUXLUXMUYBAGPUOZULVCUOZUXLUYBUOUHULULVEVFVCULVEVGVIVJVKZGU
        LPVCVLVMZAHPUOZUYEUXMUYBUOUIUYFHULPVCVLVMZVNARUYCVOUPZUYCTAUYBVPUOZUYCV
        PUOUYJUYCVQAPVPUOZVCVTUOUYKUGVRPVCVPVTVSVMUYBVPWAUYCVPWBWCWDZWEZAUXNUXT
        UOZBRWFUXNUYAUOAUYOBRAUXRRUOZWGZVEULWHUYOWIWJUYQUYOVEULUYQUYOWKUXRWLUPZ
        VQZVEULVQZUYQUYOWKWNWMUQZUYRWNWMUQZVQZUYSUYQUYOVUCUYQUYOWGVUAUXNWLUPZVU
        BVUAWNVUDWNWOWPUXLUXMWQWRUYPUYOVUDVUBVQACDEFUXNKLNPQRUXRTUAUCUDWSWTWDXA
        UYQWKUYRWNWKXGUOUYQXBXCUYQUYRUYQUXRUYCUOUYRXDUOUYQUXRRUYCAUYPXEUYPRUYCV
        QZAUYPUYLVUEUXRPRTXFXHXIXJUYBUXRXKXLXMWNXGUOUYQWOXCXNUUAAUYPUYOUYSUYTXO
        AUYSUYPUYOWGZUYTAVUFUYTXOUYSULRUOZUXNULLUPZUTZUOZWGZUYTXOAVUGVUJUYTAVUG
        WGZVUJUXNUJUKWKULWLUPZXPUQZUYBULUJUSZVUOUKUSZVUPQUPZUNZUUBZXQUQZUUCZUTZ
        UOZUYTVULVUIVVBUXNVULVUHVVAVULVUHVVAVQZVUNUYBVDRVUHUUDZVUGVVDVVEWGACDEF
        KLNPQRULUJUKTUAUCUDUUEXIUUFXRXSVVCUXNVUTVQZUKUYBWFUJVUNWFVULUYTUJUKVUNU
        YBVUTUXNVVAVVAUUGULVUSXQYJUUHVULVVFUYTUJUKVUNUYBVULVUOVUNUOZVUPUYBUOZWG
        ZWGZVVFUXNVURVQZUYTVVJVUTVURUXNVVJVUTULVURXTUQZULXTUQZVURVVJULULULVURUL
        VUOVUOUYBULUYCUOZVVJUYBUVCZXCZVVPVVPVVJVUPVUQUYBVULVVGVVHUUIZVVJVVHVUQU
        YBUOVVQUYBUYBVUPQCDPQUCUUJUUKXLVNZULULULXTUQZULXTUQZVQVVJVVTVVSULVVSULU
        LXTVVNVVSULVQVVOUYBULYAYBZUULVWAUUMXCVVJVUOWKVUMVVJVUOWKWKXPUQZUOVUOWKV
        QVVJVUOVUNVWBVULVVGVVHUUNVUMWKWKXPYCYDUUOVUOWKUUPXLZYCUUQVVJVUOVUMWMUQV
        UOWKWMUQVUOVUMWKVUOWMYCYDVVJVUOVVJVUOWKXGVWCXBUURUUSUUTUVAVVJVURUYCUOZV
        VMVURVQVVRVWDVVMVURULXTUQVURVWDVVLVURULXTUYBVURYAUVBUYBVURUVDYEXLYEUVEV
        VJVVKUYTVVJVVKWGZUYDVEVTUOZGVEUMZUXMVQZUYTAUYDVUGVVIVVKUHUVFZVWFVWEUVGX
        CVWEUXMVUQUXLQUPZVWGVWEYFUXNUPZYFVURUPZUXMVUQVWEYFUXNVURVVJVVKXEZYGUXMV
        PUOVWKUXMVQHULYKUXLUXMVPYHYBVUQVPUOVWLVUQVQVUPQUVHVUPVUQVPYHYBYIVWEUXLV
        UPQVWEWKUXNUPZWKVURUPZUXLVUPVWEWKUXNVURVWMYGUXLVPUOVWNUXLVQGULYKUXLUXMV
        PYLYBVUPVPUOVWOVUPVQUKYMVUPVUQVPYLYBYIUVIVWEGULQUQZGVEULVBZUMZVWJVWGVWE
        UYDUYEVWPVWRVQVWIUYFCDGULPQUCUVJVMGULQUVKVWQVEGVEUVLUVMYIUVNUYDVWFWGVWH
        GHVQUYTGVEHULPVTUVOUVPUVQXAYNUVRUWCYNUVSUYSVUFVUKUYTVUFVUKYOZUYRWKUYRWK
        VQZUXRULVQZVWSUXRVPUOVWTVXAYOBYMUXRVPUVTYBVXAUYPVUGUYOVUJUXRULRUWAVXAUX
        TVUIUXNVXAUXSVUHUXRULLUWBXRXSUWDUWEUWFUWGUWHUWMUWIUWJUWKUWLUWNBUXNRUXTU
        WOUWPUWQUEUWRAUXNUXLYPZUXMYPZXTUQZKYQZUXQAVXDUXNKUXCUXNVXEUOAVXDUXNUXNK
        UXLUXMUWSZAUXNKRRKUXDAKPRTUAUWTXCUYNUXAUXBUXNVXDKUXNVXDVPVXFVXBVXCXTYJZ
        UXEVXGUXFUXGAUXQVXBKYQZVXCKYQZJUQZVXEAUXOVXHUXPVXIJAUYLUYDUXOVXHVQUGUHG
        KMPVPUAUFYRYSAUYLUYHUXPVXIVQUGUIHKMPVPUAUFYRYSUXHAVXBRUOVXCRUOVXJVXEVQA
        VXBUYCRAUXLUYBUYGYTUYMWEAVXCUYCRAUXMUYBUYIYTUYMWEVXBVXCJKOPRTSUAUBUXIYS
        YEWEUXNIUXQUXJUXK $.

      frgpnabl.n $e |- ( ph ->
        ( ( U ` A ) .+ ( U ` B ) ) = ( ( U ` B ) .+ ( U ` A ) ) ) $.
      $( Lemma for ~ frgpnabl .  (Contributed by Mario Carneiro,
         21-Apr-2016.) $)
      frgpnabllem2 $p |- ( ph -> A = B ) $=
        ( vd vt vm vk wcel c0 cvv cop wceq 0ex a1i cc0 cs2 cfv cv wbr wrmo wreu
        crn ciun cdif difss eqsstri co cin inss1 frgpnabllem1 sseldi cmin chash
        c1 cfzo wral wa cword csn crab cmpt eqid efgredeu reurmo 3syl cec efger
        wer cqs cbs cgrp frgpgrp syl vrgpf ffvelrnd grpcl syl3anc c2o cxp cfrmd
        wf cqus frgpval cid con0 2on xpexg sylancl wrdexg syl5eq frmdbas eqtr4d
        cefg fvex eqeltri divsbas eleqtrrd inss2 qsel eqtr3d mpbird erref breq1
        fvi erth rmoi syl122anc fveq1d opex s2fv0 ax-mp 3eqtr3g opthg simprbda
        syl21anc ) AGPUOZUPUQUOZGUPURZHUPURZUSZGHUSZUHUUDAUTVAAVBUUEUUFVCZVDZVB
        UUFUUEVCZVDZUUEUUFAVBUUIUUKAUKVEZUUKKVFZUKIVGZUUIIUOUUIUUKKVFZUUKIUOUUK
        UUKKVFZUUIUUKUSAUUKRUOUUNUKIVHUUOAIRUUKIRBRBVELVDVIVJZVKRUERUURVLVMZAIH
        MVDZGMVDZJVNZVOZIUUKIUVBVPABCDEFHGIJKLMNOPQRSTUAUBUCUDUEUFUGUIUHVQZVRZV
        RZBCDEFULUUKIKUMVBULVEZVDIUOUNVEZUVGVDUVHWAVSVNUVGVDLVDVIUOUNWAUVGVTVDW
        BVNWCWDULRWEUPWFVKWGUMVEZVTVDWAVSVNUVIVDWHZLUNUMNPQRUKTUAUCUDUEUVJWIWJU
        UNUKIWKWLAIUVAUUTJVNZVOZIUUIIUVKVPABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
        IVQZVRZAUUPUUIKWMZUUKKWMZUSAUVKUVOUVPARKWOZUVKRKWPZUOZUUIUVKUOUVKUVOUSU
        VQAKPRTUAWNVAZAUVKOWQVDZUVRAOWRUOZUVAUWAUOUUTUWAUOUVKUWAUOAPUQUOZUWBUGO
        PUQSWSWTAPUWAGMAUWCPUWAMXHUGKMOPUQUWAUAUFSUWAWIZXAWTZUHXBAPUWAHMUWEUIXB
        UWAJOUVAUUTUWDUBXCXDAKPXEXFZXGVDZORUQUQAUWCOUWGKXIVNUSUGKOPUWGUQSUWGWIZ
        UAXJWTARUWFWEZUWGWQVDZARUWIXKVDZUWITAUWFUQUOZUWIUQUOUWKUWIUSAUWCXEXLUOU
        WLUGXMPXEUQXLXNXOZUWFUQXPUWIUQYKWLXQAUWLUWJUWIUSUWMUWJUWFUWGUQUWHUWJWIX
        RWTXSKUQUOAKPXTVDUQUAPXTYAYBVAUWGUQUOAUWFXGYAVAYCYDZAUVLUVKUUIIUVKYEUVM
        VRRUVKUUIKRYFXDAUVQUVSUUKUVKUOUVKUVPUSUVTUWNAUUKUVBUVKAUVCUVBUUKIUVBYEU
        VDVRUJYDRUVKUUKKRYFXDYGAUUIUUKKRUVTAIRUUIUUSUVNVRYLYHUVEAUUKKRUVTUVFYIU
        UNUUPUUQUKIUUIUUKUUMUUIUUKKYJUUMUUKUUKKYJYMYNYOUUEUQUOUUJUUEUSGUPYPUUEU
        UFUQYQYRUUFUQUOUULUUFUSHUPYPUUFUUEUQYQYRYSUUCUUDWDUUGUUHUPUPUSGUPHUPPUQ
        YTUUAUUB $.
    $}

    $( The free group on two or more generators is not abelian.  (Contributed
       by Mario Carneiro, 21-Apr-2016.) $)
    frgpnabl $p |- ( 1o ~< I -> -. G e. Abel ) $=
      ( va vb vx vy vz vw vv vn c1o csdm cv wcel cvv wa cfv co eqid wbr wceq wn
      wrex cabel wb relsdom brrelex2i 1sdom syl ibi c2o cxp cword cid cc0 chash
      cfz cdif cop cmpt2 cs2 cotp csplice cmpt crn ciun cplusg ad2antrr simplrl
      cefg cvrgp simplrr simpr wf vrgpf ffvelrnd ablcom syl3anc frgpnabllem2 ex
      cbs con3d rexlimdvva mpd ) LBMUAZDNZENZUBZUCZEBUDDBUDZAUEOZUCZWFWKWFBPOZW
      FWKUFLBMUGUHZDEBPUIUJUKWFWJWMDEBBWFWGBOZWHBOZQZQZWLWIWSWLWIWSWLQZFGHIJWGW
      HBULUMZUNUORZFXBFNJXBKIUPJNZUQRURSXAXCKNZXDINZXEGHBULGNLHNUSUTVAZRVBVCVDS
      VAVEZRVFVGUSZAVHRZBVKRZXGBVLRZKABXFXBCXBTXJTZXITZXFTXGTXHTXKTZWFWNWRWLWOV
      IZWFWPWQWLVJZWFWPWQWLVMZWTWLWGXKRZAWBRZOWHXKRZXSOXRXTXISXTXRXISUBWSWLVNWT
      BXSWGXKWTWNBXSXKVOXOXJXKABPXSXLXNCXSTZVPUJZXPVQWTBXSWHXKYBXQVQXSXIAXRXTYA
      XMVRVSVTWAWCWDWE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Cyclic groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CycGrp $. $( Cyclic group $)

  $( Cyclic group. $)
  ccyg $a class CycGrp $.

  ${
    $d g m n x y B $.  $d m y E $.  $d m n x y N $.  $d n O $.  $d m n x y X $.
    $d g m n x y G $.  $d y ph $.  $d g m n x y .x. $.
    $( Define a cyclic group, which is a group with an element ` x ` , called
       the generator of the group, such that all elements in the group are
       multiples of ` x ` .  A generator is usually not unique.  (Contributed
       by Mario Carneiro, 21-Apr-2016.) $)
    df-cyg $a |- CycGrp = { g e. Grp | E. x e. ( Base ` g )
      ran ( n e. ZZ |-> ( n ( .g ` g ) x ) ) = ( Base ` g ) } $.

    iscyg.1 $e |- B = ( Base ` G ) $.
    iscyg.2 $e |- .x. = ( .g ` G ) $.
    $( Definition of a cyclic group.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    iscyg $p |- ( G e. CycGrp <-> ( G e. Grp /\
      E. x e. B ran ( n e. ZZ |-> ( n .x. x ) ) = B ) ) $=
      ( vg cz cv cmg cfv co cmpt crn cbs wceq wrex fveq2 syl6eqr oveqd mpteq2dv
      cgrp ccyg rneqd eqeq12d rexeqbidv df-cyg elrab2 ) DIDJZAJZHJZKLZMZNZOZULP
      LZQZAUQRDIUJUKCMZNZOZBQZABRHEUCUDULEQZURVBAUQBVCUQEPLBULEPSFTZVCUPVAUQBVC
      UOUTVCDIUNUSVCUMCUJUKVCUMEKLCULEKSGTUAUBUEVDUFUGAHDUHUI $.

    ${
      iscyg3.e $e |- E = { x e. B | ran ( n e. ZZ |-> ( n .x. x ) ) = B } $.
      $( The property of being a cyclic generator for a group.  (Contributed by
         Mario Carneiro, 21-Apr-2016.) $)
      iscyggen $p |- ( X e. E <-> ( X e. B /\
        ran ( n e. ZZ |-> ( n .x. X ) ) = B ) ) $=
        ( cz cv co cmpt crn wceq wcel wa simpl oveq2d mpteq2dva eqeq1d elrab2
        rneqd ) DKDLZALZCMZNZOZBPDKUEGCMZNZOZBPAGBEUFGPZUIULBUMUHUKUMDKUGUJUMUE
        KQZRUFGUECUMUNSTUAUDUBJUC $.

      $( The property of being a cyclic generator for a group.  (Contributed by
         Mario Carneiro, 21-Apr-2016.) $)
      iscyggen2 $p |- ( G e. Grp -> ( X e. E <-> ( X e. B /\
        A. y e. B E. n e. ZZ y = ( n .x. X ) ) ) ) $=
        ( wcel cz cv co cmpt wceq wa wral wss crn cgrp iscyggen wf mulgcl 3expa
        wrex wb an32s eqid fmptd frn eqss baib 3syl dfss3 elrnmpti ralbii bitri
        ovex syl6bb pm5.32da syl5bb ) HFLHCLZEMENZHDOZPZUAZCQZRGUBLZVDBNZVFQEMU
        GZBCSZRACDEFGHIJKUCVJVDVIVMVJVDRZVICVHTZVMVNMCVGUDVHCTZVIVOUHVNEMVFCVGV
        JVEMLZVDVFCLZVJVQVDVRCDGVEHIJUEUFUIVGUJZUKMCVGULVIVPVOVHCUMUNUOVOVKVHLZ
        BCSVMBCVHUPVTVLBCEMVFVKVGVSVEHDUTUQURUSVAVBVC $.

      $( A cyclic group is a group which contains a generator.  (Contributed by
         Mario Carneiro, 21-Apr-2016.) $)
      iscyg2 $p |- ( G e. CycGrp <-> ( G e. Grp /\ E =/= (/) ) ) $=
        ( ccyg wcel cgrp cz cv co cmpt crn wa c0 wne wceq wrex iscyg crab rabn0
        neeq1i bitri anbi2i bitr4i ) FJKFLKZDMDNANCOPQBUAZABUBZRUJESTZRABCDFGHU
        CUMULUJUMUKABUDZSTULEUNSIUFUKABUEUGUHUI $.

      ${
        cyggeninv.n $e |- N = ( invg ` G ) $.
        $( The inverse of a cyclic generator is a generator.  (Contributed by
           Mario Carneiro, 21-Apr-2016.) $)
        cyggeninv $p |- ( ( G e. Grp /\ X e. E ) -> ( N ` X ) e. E ) $=
          ( vy vm wcel wa co wceq cz wrex cgrp wral iscyggen2 simprbda grpinvcl
          cv syldan simplbda oveq1 eqeq2d cbvrexv cneg znegcl adantl simpr zcnd
          negnegd oveq1d simplll ad2antrr mulgneg2 syl3anc eqtr3d syl2anc eqeq1
          cfv rspcev rexbidv syl5ibrcom rexlimdva syl5bi ralimdva mpd wb adantr
          mpbir2and ) FUAOZHEOZPZHGVFZEOZVTBOZMUFZDUFZVTCQZRZDSTZMBUBZVQVRHBOZW
          BVQVRWIWCWDHCQZRZDSTZMBUBZAMBCDEFHIJKUCZUDZBFGHILUEUGVSWMWHVQVRWIWMWN
          UHVSWLWGMBWLWCNUFZHCQZRZNSTVSWCBOZPZWGWKWRDNSWDWPRWJWQWCWDWPHCUIUJUKW
          TWRWGNSWTWPSOZPZWGWRWQWERZDSTZXBWPULZSOZWQXEVTCQZRZXDXAXFWTWPUMUNZXBX
          EULZHCQZWQXGXBXJWPHCXBWPXBWPWTXAUOUPUQURXBVQXFWIXKXGRVQVRWSXAUSXIVSWI
          WSXAWOUTBCFGXEHIJLVAVBVCXCXHDXESWDXERWEXGWQWDXEVTCUIUJVGVDWRWFXCDSWCW
          QWEVEVHVIVJVKVLVMVQWAWBWHPVNVRAMBCDEFVTIJKUCVOVP $.
      $}

      ${
        cyggenod.o $e |- O = ( od ` G ) $.
        $( An element is the generator of a finite group iff the order of the
           generator equals the order of the group.  (Contributed by Mario
           Carneiro, 21-Apr-2016.) $)
        cyggenod $p |- ( ( G e. Grp /\ B e. Fin ) ->
          ( X e. E <-> ( X e. B /\ ( O ` X ) = ( # ` B ) ) ) ) $=
          ( wcel cz wceq wa cfn cfv cen syl2anc cv cmpt crn cgrp chash iscyggen
          co wbr wb wss simplr simplll simpr mulgcl syl3anc eqid fmptd frn ssfi
          syl hashen cc0 cif dfod2 adantlr iftrue eqtr2d eqeq1d fisseneq 3expia
          wf enrefg adantr breq1 syl5ibrcom impbid 3bitr3rd pm5.32da syl5bb ) H
          EMHBMZDNDUAZHCUGZUBZUCZBOZPFUDMZBQMZPZVTHGRZBUERZOZPABCDEFHIJKUFWHVTW
          EWKWHVTPZWDUERZWJOZWDBSUHZWKWEWLWDQMZWGWNWOUIWLWGWDBUJZWPWFWGVTUKZWLN
          BWCVKWQWLDNWBBWCWLWANMZPWFWSVTWBBMWFWGVTWSULWLWSUMWHVTWSUKBCFWAHIJUNU
          OWCUPZUQNBWCURUTZBWDUSTZWRWDBVATWLWMWIWJWLWIWPWMVBVCZWMWFVTWIXCOWGDHC
          WCFGBILJWTVDVEWLWPXCWMOXBWPWMVBVFUTVGVHWLWGWQWOWEUIWRXAWGWQPZWOWEWGWQ
          WOWEWDBVIVJXDWOWEBBSUHZWGXEWQBQVLVMWDBBSVNVOVPTVQVRVS $.

        $( In an infinite cyclic group, the generator must have infinite order,
           but this property no longer characterizes the generators.
           (Contributed by Mario Carneiro, 21-Apr-2016.) $)
        cyggenod2 $p |- ( ( G e. Grp /\ X e. E ) ->
          ( O ` X ) = if ( B e. Fin , ( # ` B ) , 0 ) ) $=
          ( cgrp wcel cfv cfn chash cc0 cif wceq wa cz cv cmpt iscyggen simplbi
          co crn eqid dfod2 sylan2 simprbi adantl eleq1d fveq2d eqidd ifbieq12d
          eqtrd ) FMNZHENZUAZHGOZDUBDUCHCUGUDZUHZPNZVDQOZRSZBPNZBQOZRSUTUSHBNZV
          BVGTUTVJVDBTZABCDEFHIJKUEZUFDHCVCFGBILJVCUIUJUKVAVEVHVFRVIRVAVDBPUTVK
          USUTVJVKVLULUMZUNVAVDBQVMUOVARUPUQUR $.
      $}
    $}

    $( Definition of a cyclic group.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    iscyg3 $p |- ( G e. CycGrp <-> ( G e. Grp /\
      E. x e. B A. y e. B E. n e. ZZ y = ( n .x. x ) ) ) $=
      ( ccyg wcel cgrp cz cv co wceq wrex wa wral wss bitri crn iscyg wf mulgcl
      cmpt 3expa an32s eqid fmptd frn eqss baib 3syl dfss3 ovex elrnmpti ralbii
      wb syl6bb rexbidva pm5.32i ) FIJFKJZELEMZAMZDNZUEZUAZCOZACPZQVBBMZVEOELPZ
      BCRZACPZQACDEFGHUBVBVIVMVBVHVLACVBVDCJZQZVHCVGSZVLVOLCVFUCVGCSZVHVPURVOEL
      VECVFVBVCLJZVNVECJZVBVRVNVSCDFVCVDGHUDUFUGVFUHZUILCVFUJVHVQVPVGCUKULUMVPV
      JVGJZBCRVLBCVGUNWAVKBCELVEVJVFVTVCVDDUOUPUQTUSUTVAT $.

    iscygd.3 $e |- ( ph -> G e. Grp ) $.
    iscygd.4 $e |- ( ph -> X e. B ) $.
    iscygd.5 $e |- ( ( ph /\ y e. B ) -> E. n e. ZZ y = ( n .x. X ) ) $.
    $( Definition of a cyclic group.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    iscygd $p |- ( ph -> G e. CycGrp ) $=
      ( vx cgrp wcel cz cv co wceq syl cmpt crn crab c0 wne ccyg wrex ralrimiva
      wral wa wb eqid iscyggen2 mpbir2and ne0i iscyg2 sylanbrc ) AFNOZEPEQZMQDR
      UAUBCSMCUCZUDUEZFUFOJAGUTOZVAAVBGCOZBQUSGDRSEPUGZBCUIZKAVDBCLUHAURVBVCVEU
      JUKJMBCDEUTFGHIUTULZUMTUNUTGUOTMCDEUTFHIVFUPUQ $.
  $}

  ${
    $d n x B $.  $d n x G $.  $d n O $.  $d n x X $.
    iscygodd.1 $e |- B = ( Base ` G ) $.
    iscygodd.o $e |- O = ( od ` G ) $.
    iscygodd.3 $e |- ( ph -> G e. Grp ) $.
    iscygodd.4 $e |- ( ph -> X e. B ) $.
    iscygodd.5 $e |- ( ph -> ( O ` X ) = ( # ` B ) ) $.
    $( Show that a group with an element the same order as the group is
       cyclic.  (Contributed by Mario Carneiro, 27-Apr-2016.) $)
    iscygodd $p |- ( ph -> G e. CycGrp ) $=
      ( vn vx wcel cv cfv wceq wb cn0 syl cvv cgrp cz cmg co cmpt crn crab ccyg
      c0 wne chash cfn odcl eqeltrrd cbs fvex eqeltri hashclb ax-mp sylibr eqid
      wa cyggenod syl2anc mpbir2and ne0i iscyg2 sylanbrc ) ACUAMZKUBKNLNCUCOZUD
      UEUFBPLBUGZUIUJZCUHMHAEVKMZVLAVMEBMZEDOZBUKOZPZIJAVIBULMZVMVNVQVBQHAVPRMZ
      VRAVOVPRJAVNVORMIECDBFGUMSUNBTMVRVSQBCUOOTFCUOUPUQBTURUSUTLBVJKVKCDEFVJVA
      ZVKVAZGVCVDVEVKEVFSLBVJKVKCFVTWAVGVH $.
  $}

  ${
    $d m n x y B $.  $d m x y z C $.  $d m x y z F $.  $d a b m n x y z G $.
    $d x y E $.  $d m x y H $.
    $( A cyclic group is a group.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    cyggrp $p |- ( G e. CycGrp -> G e. Grp ) $=
      ( vn vx ccyg wcel cgrp cz cv cmg cfv co cmpt crn cbs wceq wrex eqid iscyg
      simplbi ) ADEAFEBGBHCHAIJZKLMANJZOCUAPCUATBAUAQTQRS $.

    $( A cyclic group is abelian.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    cygabl $p |- ( G e. CycGrp -> G e. Abel ) $=
      ( vy vn vx va vb vm wcel cv cfv co wceq cz wrex wa eqid eqidd simpll weq
      wi ccyg cgrp cmg cbs wral cabel iscyg3 cplusg eqeq1 rexbidv oveq1 cbvrexv
      eqeq2d syl6bb rspccv adantl reeanv caddc cc zcn ad2antrl ad2antll addcomd
      oveq1d simprl simprr simplr mulgdir syl13anc oveq12 syl5ibrcom rexlimdvva
      3eqtr3d ancoms eqeq12d syl5bir adantr syl2and 3impib isabld rexlimdva imp
      ex sylbi ) AUAHAUBHZBIZCIZDIZAUCJZKZLZCMNZBAUDJZUEZDWMNZOAUFHZDBWMWICAWMP
      ZWIPZUGWEWOWPWEWNWPDWMWEWHWMHZOZWNWPWTWNOZEFWMAUHJZAXAWMQXAXBQWEWSWNRXAEI
      ZWMHZFIZWMHZXCXEXBKZXEXCXBKZLZXAXDXCGIZWHWIKZLZGMNZXFXEWJLZCMNZXIWNXDXMTW
      TWLXMBXCWMBESZWLXCWJLZCMNXMXPWKXQCMWFXCWJUIUJXQXLCGMCGSWJXKXCWGXJWHWIUKUM
      ULUNUOUPWNXFXOTWTWLXOBXEWMBFSWKXNCMWFXEWJUIUJUOUPWTXMXOOZXITWNXRXLXNOZCMN
      GMNWTXIXLXNGCMMUQWTXSXIGCMMWTXJMHZWGMHZOZOZXIXSXKWJXBKZWJXKXBKZLYCXJWGURK
      ZWHWIKZWGXJURKZWHWIKZYDYEYCYFYHWHWIYCXJWGXTXJUSHWTYAXJUTVAYAWGUSHWTXTWGUT
      VBVCVDYCWEXTYAWSYGYDLWEWSYBRZWTXTYAVEZWTXTYAVFZWEWSYBVGZWMXBWIAXJWGWHWQWR
      XBPZVHVIYCWEYAXTWSYIYELYJYLYKYMWMXBWIAWGXJWHWQWRYNVHVIVMXSXGYDXHYEXCXKXEW
      JXBVJXNXLXHYELXEWJXCXKXBVJVNVOVKVLVPVQVRVSVTWCWAWBWD $.

    cygctb.1 $e |- B = ( Base ` G ) $.
    $( A cyclic group is countable.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    cygctb $p |- ( G e. CycGrp -> B ~<_ om ) $=
      ( vn vx ccyg wcel cz cv cmg cfv co cmpt crn wceq com cdom wbr eqid ax-mp
      wrex cgrp iscyg simprbi wfo wa wfn ovex fnmpti df-fo mpbiran ccrd wi con0
      cdm omelon onenon cen wb cn znnen entri ennum mpbir fodomnum mp1i domentr
      nnenom mpan2 syl6 syl5bir rexlimdva mpd ) BFGZDHDIZEIZBJKZLZMZNAOZEAUAZAP
      QRZVNBUBGWAEAVQDBCVQSUCUDVNVTWBEAVTHAVSUEZVNVPAGUFZWBWCVSHUGVTDHVRVSVOVPV
      QUHVSSUIHAVSUJUKWDWCAHQRZWBHULUOZGZWCWEUMWDWGPWFGZPUNGWHUPPUQTHPURRZWGWHU
      SHUTPVAVHVBZHPVCTVDHAVSVEVFWEWIWBWJAHPVGVIVJVKVLVM $.

    $( The trivial group is cyclic.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    0cyg $p |- ( ( G e. Grp /\ B ~~ 1o ) -> G e. CycGrp ) $=
      ( vx vn cgrp wcel c1o cen wbr wa cmg cfv eqid adantr cv cc0 cz co wceq 0z
      c0g simpl grpidcl wrex csn en1eqsn sylan eleq2d biimpa sylib mulg0 eqtr4d
      elsn syl oveq1 eqeq2d rspcev sylancr iscygd ) BFGZAHIJZKZDABLMZEBBUBMZCVD
      NZVAVBUCVAVEAGZVBABVECVENZUDZOZVCDPZAGZKZQRGVKQVEVDSZTZVKEPZVEVDSZTZERUEU
      AVMVKVEVNVMVKVEUFZGZVKVETVCVLVTVCAVSVKVAVGVBAVSTVIVEAUGUHUIUJDVEUNUKVCVNV
      ETZVLVCVGWAVJAVDBVEVECVHVFULUOOUMVRVOEQRVPQTVQVNVKVPQVEVDUPUQURUSUT $.

    $( A group with prime order is cyclic.  (Contributed by Mario Carneiro,
       27-Apr-2016.) $)
    prmcyg $p |- ( ( G e. Grp /\ ( # ` B ) e. Prime ) -> G e. CycGrp ) $=
      ( vx wcel chash cfv cprime wa c0g wn wss c1 eqid cvv wceq ax-mp simplr wb
      fvex cgrp cv csn ccyg wex 1nprm simpr grpidcl snssd ad2antrr eqssd fveq2d
      hashsng syl6eq eqeltrrd ex mtoi nss sylib cod simpll simprl odeq1 syl2anc
      simprr elsn syl6bbr mtbird cdivides wbr wo cfn cn0 cn ad2antlr nnnn0d cbs
      prmnn eqeltri hashclb sylibr oddvds2 syl3anc odcl2 dvdsprime ord iscygodd
      mpbid mt3d exlimddv ) BUAEZAFGZHEZIZDUBZAEZWOBJGZUCZEZKZIZBUDEDWNAWRLZKXA
      DUEWNXBMHEZUFWNXBXCWNXBIZWLMHXDWLWRFGZMXDAWRFXDAWRWNXBUGWKWRALWMXBWKWQAAB
      WQCWQNZUHUIUJUKULWQOEXEMPBJTWQOUMQUNWKWMXBRUOUPUQDAWRURUSWNXAIZABBUTGZWOC
      XHNZWKWMXAVAZWNWPWTVBZXGWOXHGZWLPZXLMPZXGXNWSWNWPWTVEXGXNWOWQPZWSXGWKWPXN
      XOSXJXKWOBXHAWQXIXFCVCVDDWQVFVGVHXGXMXNXGXLWLVIVJZXMXNVKZXGWKAVLEZWPXPXJX
      GWLVMEZXRXGWLWMWLVNEWKXAWLVRVOVPAOEXRXSSABVQGOCBVQTVSAOVTQWAZXKWOBXHACXIW
      BWCXGWMXLVNEZXPXQSWKWMXARXGWKXRWPYAXJXTXKWOBXHACXIWDWCWLXLWEVDWHWFWIWGWJ
      $.

    $( A group with fewer than ` 6 ` elements is abelian.  (Contributed by
       Mario Carneiro, 27-Apr-2016.) $)
    lt6abl $p |- ( ( G e. Grp /\ ( # ` B ) < 6 ) -> G e. Abel ) $=
      ( wcel cfv c6 wbr c1 cfzo co wa wb wceq c5 ax-mp c4 c3 c2 cn0 cdivides vx
      vn cgrp chash clt cabel cuz cz cn c0 wne grpbn0 adantr cfn cpnf cr cxr wn
      6re rexr pnfnlt mp2b cvv cbs fvex eqeltri a1i hashinf sylan breq1d biimpd
      impancom mt3i hashnncl syl mpbird nnuz syl6eleq 6nn nnzi elfzo2 syl3anbrc
      simpr wo caddc df-6 oveq2i eleq2i 5nn eleqtri fzosplitsni bitri df-5 df-4
      4nn 3nn df-3 2nn c1o cen csn elsni df-2 fzosn eqtri eleq2s adantl syl6eqr
      1z hash1 1nn0 syl6eqel hashclb sylibr com 1onn nnfi sylancl syldan cprime
      mpbid ex id 2prm syl5 jaod syl5bi cv eqid wrex 4nn0 syl3anc cexp sq2 2nn0
      2z wi cle sylancr dvdsexp hashen ccyg 0cyg cygabl 3prm wral cgex gexdvds2
      prmcyg cod simpl gex2abl sylbird rexnal odcl ad2antrl oddvds2 breqtrd cpc
      simprl odcl2 pccl nn0zd simprr 3expia oveq2 syl6eq breq2d rspcev pcprmpw2
      eluz eqcomd cc 2cn exp1 breq12d 3imtr3d mtod 1re ltnle nn0ltp1le syl5eqbr
      nn0red eluz2 syl5eqbrr breqtrrd dvdseq syl22anc eqtr4d rexlimdvaa syl5bir
      iscygodd pm2.61d 5prm imp ) BUCDZAUDEZFUEGZUWQHFIJZDZBUFDZUWPUWRKZUWQHUGE
      ZDFUHDZUWRUWTUXBUWQUIUXCUXBUWQUIDZAUJUKZUWPUXFUWRABCULUMUXBAUNDZUXEUXFLUX
      BUXGUOFUEGZFUPDFUQDUXHURUSFUTFVAVBUWPUXGURZUWRUXHUWPUXIKZUWRUXHUXJUWQUOFU
      EUWPAVCDZUXIUWQUOMUXKUWPABVDEVCCBVDVEVFZVGAVCVHVIVJVKVLVMAVNVOVPVQVRUXDUX
      BFVSVTVGUWPUWRWCUWQHFWAWBUWPUWTUXAUWTUWQHNIJZDZUWQNMZWDZUWPUXAUWTUWQHNHWE
      JZIJZDZUXPUWSUXRUWQFUXQHIWFWGWHNUXCDUXSUXPLNUIUXCWIVQWJHNUWQWKOWLUWPUXNUX
      AUXOUXNUWQHPIJZDZUWQPMZWDZUWPUXAUXNUWQHPHWEJZIJZDZUYCUXMUYEUWQNUYDHIWMWGW
      HPUXCDUYFUYCLPUIUXCWOVQWJHPUWQWKOWLUWPUYAUXAUYBUYAUWQHQIJZDZUWQQMZWDZUWPU
      XAUYAUWQHQHWEJZIJZDZUYJUXTUYLUWQPUYKHIWNWGWHQUXCDUYMUYJLQUIUXCWPVQWJHQUWQ
      WKOWLUWPUYHUXAUYIUYHUWQHRIJZDZUWQRMZWDZUWPUXAUYHUWQHRHWEJZIJZDZUYQUYGUYSU
      WQQUYRHIWQWGWHRUXCDUYTUYQLRUIUXCWRVQWJHRUWQWKOWLUWPUYOUXAUYPUWPUYOUXAUWPU
      YOAWSWTGZUXAUWPUYOKZUWQWSUDEZMZVUAVUBUWQHVUCUYOUWQHMZUWPVUEUWQHXAZUYNUWQH
      XBUYNHHHWEJZIJZVUFRVUGHIXCWGHUHDZVUHVUFMXIHXDOXEXFXGZXJXHVUBUXGWSUNDZVUDV
      UALVUBUWQSDZUXGVUBUWQHSVUJXKXLUXKUXGVULLUXLAVCXMOZXNWSXODVUKXPWSXQOAWSUUA
      XRYAUWPVUAKBUUBDZUXAABCUUCBUUDZVOXSYBUYPUWQXTDZUWPUXAUYPUWQRXTUYPYCYDXLUW
      PVUPUXAUWPVUPKVUNUXAABCUUIVUOVOYBZYEYFYGUYIVUPUWPUXAUYIUWQQXTUYIYCUUEXLVU
      QYEYFYGUWPUYBUXAUWPUYBKZUAYHZBUUJEZEZRTGZUAAUUFZUXAVURVVCBUUGEZRTGZUXAVUR
      UWPRUHDZVVEVVCLUWPUYBUUKZYPUAVVDBRVUTACVVDYIZVUTYIZUUHXRUWPVVEUXAYQUYBUWP
      VVEUXAVVDBACVVHUULYBUMUUMVVCURVVBURZUAAYJVURUXAVVBUAAUUNVURVVJUXAUAAVURVU
      SADZVVJKZKZVUNUXAVVMABVUTVUSCVVIVURUWPVVLVVGUMZVURVVKVVJUUTZVVMVVAPUWQVVM
      VVASDZPSDZVVAPTGZPVVATGVVAPMVVKVVPVURVVJVUSBVUTACVVIUUOUUPVVQVVMYKVGVVMVV
      AUWQPTVVMUWPUXGVVKVVAUWQTGVVNVURUXGVVLVURVULUXGVURUWQPSUWPUYBWCZYKXLVUMXN
      UMZVVOVUSBVUTACVVIUUQYLVURUYBVVLVVSUMZUURZVVMPRRVVAUUSJZYMJZVVATVVMPRRYMJ
      ZVWDTYNVVMVVFRSDZVWCRUGEDZVWEVWDTGVVFVVMYPVGZVWFVVMYOVGVVMVVFVWCUHDZRVWCY
      RGVWGVWHVVMVWCVVMRXTDZVVAUIDZVWCSDZYDVVMUWPUXGVVKVWKVVNVVTVVOVUSBVUTACVVI
      UVAYLZRVVAUVBYSZUVCZVVMRVUGVWCYRXCVVMHVWCUEGZVUGVWCYRGZVVMVWPVWCHYRGZURZV
      VMVWRVVBVURVVKVVJUVDVVMHVWCUGEDZVWDRHYMJZTGZVWRVVBVVMVVFVWLVWTVXBYQYPVWNV
      VFVWLVWTVXBRVWCHYTUVEYSVVMVWIVUIVWTVWRLVWOXIVWCHUVKXRVVMVWDVVAVXARTVVMVVA
      VWDVVMVVARUBYHZYMJZTGZUBSYJZVVAVWDMZVVMVWFVVRVXFYOVWBVXEVVRUBRSVXCRMZVXDP
      VVATVXHVXDVWEPVXCRRYMUVFYNUVGUVHUVIYSVVMVWJVWKVXFVXGLYDVWMVVARUBUVJYSYAZU
      VLVXARMZVVMRUVMDVXJUVNRUVOOVGUVPUVQUVRVVMHUPDVWCUPDVWPVWSLUVSVVMVWCVWNUWC
      HVWCUVTYSVPVVMHSDVWLVWPVWQLXKVWNHVWCUWAYSYAUWBRVWCUWDWBRRVWCYTYLUWEVXIUWF
      VVAPUWGUWHVWAUWIUWLVUOVOUWJUWKUWMYBYFYGUXOVUPUWPUXAUXOUWQNXTUXOYCUWNXLVUQ
      YEYFYGUWOXS $.

    ${
      ghmcyg.1 $e |- C = ( Base ` H ) $.
      $( The image of a cyclic group under a surjective group homomorphism is
         cyclic.  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      ghmcyg $p |- ( ( F e. ( G GrpHom H ) /\ F : B -onto-> C ) ->
        ( G e. CycGrp -> H e. CycGrp ) ) $=
        ( vn vx vy vm vz wcel cz cv cfv co wceq wrex wa ccyg cmg cmpt cghm cgrp
        crn wfo eqid iscyg simprbi ghmgrp2 ad2antrr wf ad2antlr simprl ffvelrnd
        fof simplr foeq2 ad2antll mpbird foelrn sylan cvv wral ovex rgenw oveq1
        cbvmptv fveq2 eqeq2d rexrnmpt ax-mp sylib simp-4l simpr ghmmulg syl3anc
        wb rexbidva mpbid iscygd rexlimdvaa syl5 ) DUAMZHNHOZIOZDUBPZQZUCZUFZAR
        ZIASZCDEUDQMZABCUGZTZEUAMZWEDUEMWMIAWHHDFWHUHZUIUJWPWLWQIAWPWGAMZWLTZTZ
        JBEUBPZKEWGCPZGXBUHZWNEUEMWOWTDECUKULXAABWGCWOABCUMWNWTABCUQUNWPWSWLUOZ
        UPXAJOZBMZTZXFKOZWGWHQZCPZRZKNSZXFXIXCXBQZRZKNSXHXFLOZCPZRZLWKSZXMXAWKB
        CUGZXGXSXAXTWOWNWOWTURWLXTWOVSWPWSWKABCUSUTVALWKBXFCVBVCXJVDMZKNVEXSXMV
        SYAKNXIWGWHVFVGXRXLKLNXJWJVDHKNWIXJWFXIWGWHVHVIXPXJRXQXKXFXPXJCVJVKVLVM
        VNXHXLXOKNXHXINMZTZXKXNXFYCWNYBWSXKXNRWNWOWTXGYBVOXHYBVPXAWSXGYBXEULAWH
        XBCDEXIWGFWRXDVQVRVKVTWAWBWCWD $.
    $}

    cyggex.o $e |- E = ( gEx ` G ) $.
    $( The exponent of a cyclic group is ` 0 ` if the group is infinite,
       otherwise it equals the order of the group.  (Contributed by Mario
       Carneiro, 24-Apr-2016.) $)
    cyggex2 $p |- ( G e. CycGrp ->
      E = if ( B e. Fin , ( # ` B ) , 0 ) ) $=
      ( vn vx vy wcel cgrp cz cv cfv wceq wa cc0 eqid cn0 cdivides wbr ccyg cmg
      co cmpt crn c0 wne cfn chash cif iscyg2 wex n0 cod ssrab2 simpr cyggenod2
      crab sseldi jca ex gexcl adantr hashcl adantl wn 0nn0 a1i ifclda gexdvds3
      breq2 adantlr nn0z dvds0 ifbothda simprr adantrr eqbrtrrd dvdseq syl22anc
      3syl gexod syld exlimdv syl5bi imp sylbi ) CUAICJIZFKFLGLCUBMZUCUDUEANZGA
      URZUFUGZOBAUHIZAUIMZPUJZNZGAWIFWKCDWIQZWKQZUKWHWLWPWLHLZWKIZHULWHWPHWKUMW
      HWTWPHWHWTWSAIZWSCUNMZMZWONZOZWPWHWTXEWHWTOZXAXDXFWKAWSWJGAUOWHWTUPUSGAWI
      FWKCXBWSDWQWRXBQZUQUTVAWHXEWPWHXEOZBRIZWORIBWOSTZWOBSTWPWHXIXEBCJADEVBVCZ
      XHWMWNPRWMWNRIXHAVDVEPRIXHWMVFZOZVGVHVIWMBWNSTZBPSTZXJXHWNPWNWOBSVKPWOBSV
      KWHWMXNXEBCADEVJVLXMXIBKIXOXHXIXLXKVCBVMBVNWAVOXHXCWOBSWHXAXDVPWHXAXCBSTX
      DWSBCXBADEXGWBVQVRBWOVSVTVAWCWDWEWFWG $.

    $( The exponent of a finite cyclic group is the order of the group.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    cyggex $p |- ( ( G e. CycGrp /\ B e. Fin ) -> E = ( # ` B ) ) $=
      ( ccyg wcel cfn chash cfv cc0 cif cyggex2 iftrue sylan9eq ) CFGAHGZBPAIJZ
      KLQABCDEMPQKNO $.

    $( A finite abelian group is cyclic iff the exponent equals the order of
       the group.  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    cyggexb $p |- ( ( G e. Abel /\ B e. Fin ) ->
      ( G e. CycGrp <-> E = ( # ` B ) ) ) $=
      ( vx vn vy cabel wcel cfn wa ccyg cfv wceq cv simplr syl2anc eqid wb wrex
      chash wi cyggex expcom adantl cn simpll cgrp ablgrp ad2antrr gexcl2 gexex
      cod eqeq2d cz cmg cmpt crn crab cyggenod wne ne0i iscyg2 baib syl syl5ibr
      co c0 sylbird expdimp sylbid rexlimdva mpd ex impbid ) CIJZAKJZLZCMJZBAUB
      NZOZVRVTWBUCVQVTVRWBABCDEUDUEUFVSWBVTVSWBLZFPZCUNNZNZBOZFAUAZVTWCVQBUGJZW
      HVQVRWBUHWCCUIJZVRWIVQWJVRWBCUJUKZVQVRWBQZBCADEULRFBCWEADEWESZUMRWCWGVTFA
      WCWDAJZLZWGWFWAOZVTWOBWAWFVSWBWNQUOWCWNWPVTWCWNWPLZWDGUPGPHPCUQNZVHURUSAO
      HAUTZJZVTWCWJVRWTWQTWKWLHAWRGWSCWEWDDWRSZWSSZWMVARWTVTWCWSVIVBZWSWDVCWCWJ
      VTXCTWKVTWJXCHAWRGWSCDXAXBVDVEVFVGVJVKVLVMVNVOVP $.
  $}

  ${
    $d n x y A $.  $d f n x y G $.  $d n y S $.  $d n x .x. $.  $d n x y X $.
    $d f H $.
    $( Cyclicity is a group property, i.e. it is preserved under isomorphism.
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    giccyg $p |- ( G ~=g H -> ( G e. CycGrp -> H e. CycGrp ) ) $=
      ( vf cgic wbr cgim co c0 wne ccyg wcel wi brgic cv wex cbs cfv eqid sylbi
      n0 cghm wfo gimghm wf1o gimf1o f1ofo syl ghmcyg syl2anc exlimiv ) ABDEABF
      GZHIZAJKBJKLZABMULCNZUKKZCOUMCUKTUOUMCUOUNABUAGKAPQZBPQZUNUBZUMABUNUCUOUP
      UQUNUDURUPUQABUNUPRZUQRZUEUPUQUNUFUGUPUQUNABUSUTUHUIUJSS $.

    cycsubgcyg.x $e |- X = ( Base ` G ) $.
    cycsubgcyg.t $e |- .x. = ( .g ` G ) $.
    cycsubgcyg.s $e |- S = ran ( x e. ZZ |-> ( x .x. A ) ) $.
    $( The cyclic subgroup generated by ` A ` is a cyclic group.  (Contributed
       by Mario Carneiro, 24-Apr-2016.) $)
    cycsubgcyg $p |- ( ( G e. Grp /\ A e. X ) ->
      ( G |`s S ) e. CycGrp ) $=
      ( vy vn cgrp wcel wa co cfv eqid cz cv wceq cress cbs cmg csubg cycsubgcl
      cmpt crn simpld syl5eqel subggrp syl simprd syl6eleqr subgbas wrex eleq2d
      eleqtrd biimpar simpr syl6eleq oveq1 cbvmptv ovex elrnmpti sylib ad2antrr
      subgmulg syl3anc eqeq2d rexbidva mpbid syldan iscygd ) ELMBFMNZJECUAOZUBP
      ZVOUCPZKVOBVPQVQQZVNCEUDPZMZVOLMVNCARASZBDOZUFZUGZVSIVNWDVSMZBWDMZABDWCEF
      GHWCQUEZUHUIZCEVOVOQZUJUKVNBCVPVNBWDCVNWEWFWGULIUMZVNVTCVPTWHCEVOWIUNUKZU
      QVNJSZVPMZWLCMZWLKSZBVQOZTZKRUOZVNWNWMVNCVPWLWKUPURVNWNNZWLWOBDOZTZKRUOZW
      RWSWLWDMXBWSWLCWDVNWNUSIUTKRWTWLWCAKRWBWTWAWOBDVAVBWOBDVCVDVEWSXAWQKRWSWO
      RMZNZWTWPWLXDVTXCBCMZWTWPTVNVTWNXCWHVFWSXCUSVNXEWNXCWJVFCVQDEVOWOBHWIVRVG
      VHVIVJVKVLVM $.
  $}

  ${
    $d n A $.  $d n B $.  $d n G $.
    cycsubgcyg2.b $e |- B = ( Base ` G ) $.
    cycsubgcyg2.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( The cyclic subgroup generated by ` A ` is a cyclic group.  (Contributed
       by Mario Carneiro, 27-Apr-2016.) $)
    cycsubgcyg2 $p |- ( ( G e. Grp /\ A e. B ) ->
      ( G |`s ( K ` { A } ) ) e. CycGrp ) $=
      ( vn cgrp wcel wa csn cfv cress co cz cv cmg cmpt crn eqid oveq2d eqeltrd
      ccyg cycsubg2 cycsubgcyg ) CHIABIJZCAKDLZMNCGOGPACQLZNRZSZMNUCUFUGUJCMGAU
      HUICDBEUHTZUITFUDUAGAUJUHCBEUKUJTUEUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Group sum operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g k m n x y z .+ $.  $d f g k m n x y z A $.  $d f g k m n x y z ph $.
    $d g x y z .0. $.  $d f g m n x y z G $.  $d f k m n x y z M $.  $d x V $.
    $d f g k m n x y z B $.  $d f g k m n x y z F $.  $d f g k m n x y z H $.
    $d f g k m n x y z W $.
    gsumval3.b $e |- B = ( Base ` G ) $.
    gsumval3.0 $e |- .0. = ( 0g ` G ) $.
    gsumval3.p $e |- .+ = ( +g ` G ) $.
    gsumval3.z $e |- Z = ( Cntz ` G ) $.
    gsumval3.g $e |- ( ph -> G e. Mnd ) $.
    gsumval3.a $e |- ( ph -> A e. V ) $.
    gsumval3.f $e |- ( ph -> F : A --> B ) $.
    gsumval3.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    ${
      gsumval3a.t $e |- ( ph -> W e. Fin ) $.
      gsumval3a.n $e |- ( ph -> W =/= (/) ) $.
      ${
        gsumval3a.w $e |- W = ( `' F " ( _V \ { .0. } ) ) $.
        gsumval3a.i $e |- ( ph -> -. A e. ran ... ) $.
        $( Value of the group sum operation over an index set with finite
           support.  (Contributed by Mario Carneiro, 7-Dec-2014.) $)
        gsumval3a $p |- ( ph -> ( G gsum F ) = ( iota x E. f
          ( f : ( 1 ... ( # ` W ) ) -1-1-onto-> W /\
            x = ( seq 1 ( .+ , ( F o. f ) ) ` ( # ` W ) ) ) ) ) $=
          ( vz vy vm vn cgsu co crn cv wceq wral crab wss cfz wcel cseq cfv cuz
          wa wrex wex cio c1 chash wf1o ccom cif cmnd eqid ccnv cvv gsumvallem2
          cdif csn syl difeq2d imaeq2d syl6reqr gsumval wn c0 wne sseq2d wf cin
          cima wfn ffn adantr simpr sylanbrc disjdif fimacnvdisj sylancl syl5eq
          df-f ex sylbid necon3ad mpd iffalse 3eqtrd ) AHGUIUJGUKZUEULZUFULZEUJ
          XHUMXHXGEUJXHUMVBUFDUNUEDUOZUPZKCUQUKURZCUGULZUHULZUQUJUMBULZXMEGXLUS
          UTUMVBUHXLVAUTVCUGVDBVEZVFJVGUTZUQUJJFULZVHXNXPEGXQVIVFUSUTUMVBFVDBVE
          ZVJZVJZXSXRABUFCDEFUGUHGHXIVKJIKUEMNOXIVLZAGVMZVNXIVPZWIYBVNKVQZVPZWI
          ZJAYCYEYBAXIYDVNAHVKURXIYDUMQUEUFDEHXIKMNOYAVOVRZVSVTUCWAQRSWBAXJWCZX
          TXSUMAJWDWEYHUBAXJJWDAXJXFYDUPZJWDUMZAXIYDXFYGWFAYIYJAYIVBZJYFWDUCYKC
          YDGWGZYDYEWHWDUMYFWDUMYKGCWJZYIYLAYMYIACDGWGYMSCDGWKVRWLAYIWMCYDGWSWN
          YDVNWOCYDYEGWPWQWRWTXAXBXCXJKXSXDVRAXKWCXSXRUMUDXKXOXRXDVRXE $.
      $}

      gsumval3a.s $e |- ( ph -> W C_ A ) $.
      $( The group sum as defined in ~ gsumval3a is uniquely defined.
         (Contributed by Mario Carneiro, 8-Dec-2014.) $)
      gsumval3eu $p |- ( ph -> E! x E. f
        ( f : ( 1 ... ( # ` W ) ) -1-1-onto-> W /\
          x = ( seq 1 ( .+ , ( F o. f ) ) ` ( # ` W ) ) ) ) $=
        ( vg vy vz vk c1 chash cfv cfz co cv wf1o ccom cseq wceq wa wex weq wal
        wi weu cn wcel c0 wn neneqd cfn fz1f1o syl ord mpd simprd excom exancom
        wo fvex biidd ceqsexv bitri exbii sylibr eeanv an4 crn ccnv cmnd adantr
        mndcl 3expb sylan wss sselda adantrr simprr cntzi syl2anc mndass simpld
        w3a cuz nnuz syl6eleq wf frn f1ocnv simprl f1oco f1of fvco3 wfn ffn fss
        ffvelrnda fnfvelrn eqeltrd fveq2d f1ocnvfv2 eqtr2d syldan seqf1o eqeq12
        3eqtr4d syl5ibrcom expimpd exlimdvv alrimivv eqeq1 anbi2d exbidv f1oeq1
        syl5bir coeq2 seqeq3d fveq1d eqeq2d anbi12d cbvexv syl6bb eu4 sylanbrc
        ) AUHJUIUJZUKULZJFUMZUNZBUMZUUCEGUUEUOZUHUPZUJZUQZURZFUSZBUSZUUMUUDJUDU
        MZUNZUEUMZUUCEGUUOUOZUHUPZUJZUQZURZUDUSZURZBUEUTZVBZUEVABVAUUMBVCAUUFFU
        SZUUNAUUCVDVEZUVGAJVFUQZVGUVHUVGURZAJVFUBVHAUVIUVJAJVIVEUVIUVJVQUAJFVJV
        KVLVMZVNUUNUULBUSZFUSUVGUULBFVOUVLUUFFUVLUUKUUFURBUSUUFUUFUUKBVPUUFUUFB
        UUJUUCUUIVRUUKUUFVSVTWAWBWAWCAUVFBUEUVDUULUVBURZUDUSFUSAUVEUULUVBFUDWDA
        UVMUVEFUDUVMUUFUUPURZUUKUVAURZURAUVEUUFUUPUUKUVAWEAUVNUVOUVEAUVNURZUVEU
        VOUUJUUTUQUVPBUEUFGWFZEDUGUUOWGZUUEUOZUURUUHUHUUCUVPHWHVEZUUGDVEZUUQDVE
        ZURUUGUUQEULZDVEZAUVTUVNQWIZUVTUWAUWBUWDDEHUUGUUQMOWJWKWLUVPUUGUVQVEZUU
        QUVQVEZURURUUGUVQLUJZVEZUWGUWCUUQUUGEULUQUVPUWFUWIUWGUVPUVQUWHUUGAUVQUW
        HWMUVNTWIWNWOUVPUWFUWGWPEUVQHUUGUUQLOPWQWRUVPUVTUWAUWBUFUMZDVEXAUWCUWJE
        ULUUGUUQUWJEULEULUQUWEDEHUUGUUQUWJMOWSWLUVPUUCVDUHXBUJAUVHUVNAUVHUVGUVK
        WTWIXCXDUVPCDGXEZUVQDWMAUWKUVNSWIZCDGXFVKUVPJUUDUVRUNZUUFUUDUUDUVSUNZUV
        PUUPUWMAUUFUUPWPZUUDJUUOXGVKAUUFUUPXHZUUDJUUDUVRUUEXIWRZUVPUUGUUDVEZURZ
        UUGUURUJZUUGUUOUJZGUJZUVQUVPUUDJUUOXEZUWRUWTUXBUQUVPUUPUXCUWOUUDJUUOXJV
        KZUUDJUUGGUUOXKWLUWSGCXLZUXACVEUXBUVQVEUVPUXEUWRUVPUWKUXEUWLCDGXMVKWIUV
        PUUDCUUGUUOUVPUXCJCWMZUUDCUUOXEZUXDAUXFUVNUCWIUUDJCUUOXNWRZXOCUXAGXPWRX
        QUVPUGUMZUUDVEZURZUXIUUEUJZGUJZUXIUVSUJZUUOUJZGUJZUXIUUHUJZUXNUURUJZUXK
        UXLUXOGUXKUXOUXLUVRUJZUUOUJZUXLUXKUXNUXSUUOUVPUUDJUUEXEZUXJUXNUXSUQUVPU
        UFUYAUWPUUDJUUEXJVKZUUDJUXIUVRUUEXKWLXRUXKUUPUXLJVEUXTUXLUQUVPUUPUXJUWO
        WIUVPUUDJUXIUUEUYBXOUUDJUXLUUOXSWRXTXRUVPUYAUXJUXQUXMUQUYBUUDJUXIGUUEXK
        WLUVPUXJUXNUUDVEZUXRUXPUQZUVPUUDUUDUXIUVSUVPUWNUUDUUDUVSXEUWQUUDUUDUVSX
        JVKXOUVPUXGUYCUYDUXHUUDCUXNGUUOXKWLYAYDYBUUGUUJUUQUUTYCYEYFYMYGYMYHUUMU
        VCBUEUVEUUMUUFUUQUUJUQZURZFUSUVCUVEUULUYFFUVEUUKUYEUUFUUGUUQUUJYIYJYKUY
        FUVBFUDFUDUTZUUFUUPUYEUVAUUDJUUEUUOYLUYGUUJUUTUUQUYGUUCUUIUUSUYGUUHUURE
        UHUUEUUOGYNYOYPYQYRYSYTUUAUUB $.
    $}

    gsumval3.m $e |- ( ph -> M e. NN ) $.
    gsumval3.h $e |- ( ph -> H : ( 1 ... M ) -1-1-> A ) $.
    gsumval3.n $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) C_ ran H ) $.
    gsumval3.w $e |- W = ( `' ( F o. H ) " ( _V \ { .0. } ) ) $.
    $( Value of the group sum operation over an arbitrary finite set.
       (Contributed by Mario Carneiro, 15-Dec-2014.) $)
    gsumval3 $p |- ( ph ->
      ( G gsum F ) = ( seq 1 ( .+ , ( F o. H ) ) ` M ) ) $=
      ( vx vm vn vf vy vz vk vg cgsu co ccom c1 cseq cfv wceq c0 cmpt cmnd wcel
      wa syl2anc adantr cv crn ccnv cfz syl ad2antrr wf1o f1ocnv f1of ffvelrnda
      wf fvco3 cdif simpr syl6eq fco cvv cima wss a1i suppssr syldan sylan fvex
      fveq2d sylibr adantlr wn sylib eqtrd oveq2d mndlid cn nnuz eleq2d biimpar
      cuz 3eqtr4d wne cz wrex wfn wb ffn cdm fdm eqeq1d syl5eq mpbid chash wiso
      clt wex wor cfn cr frn fzssuz sstri syl6ss ltso soss ee10 cen wbr f1oen3g
      fz1iso hashen sylancr mpbird simprr isof1o f1oeq2 coass gsumz feqmptd csn
      wf1 f1f1orn difeq2d dif0 eleqtrrd eqimss2i f1ocnvfv2 3eqtr3rd elsnc eldif
      f1f sylan2br anassrs pm2.61dan mndidcl syl6eleq seqid3 cxp cpw fzf ovelrn
      mpteq2dva mp2b wrel frel reldm0 bitrd coeq1 co01 cnveqd cnv0 imaeq1d 0ima
      syl6bir necon3d imp eqnetrrd fzn0 feq2d gsumval2 sseqtrd uzssz zssre fzfi
      fex2 syl3anc enfi mpbii cn0 nnnn0d eqtr3d mndcl 3expb sselda cntzi anasss
      hashfz1 w3a mndass f1oco wfo dffn4 fof cres f1ococnv2 coeq1d fcoi2 eqtr2d
      fss cid coeq2d syl6eqr fveq1d seqf1o mndrid eluzfz1 ne0i dm0rn0 necon3bii
      eqnetrd adantrr simprl difeq1d simpll seqcoll2 expr exlimdv mpd eqtr4d ex
      rexlimdvw syl5bi cnvimass eqsstri syl5sseq sseqtr4i nnssre ssfi vex coexg
      sylancl f1ores cnvco imaeq1i imaco 3eqtri imaeq2i f1ofo f1oeq3 cores 4syl
      foimacnv f1oeq1 resexg jca seqeq3d eqeq2d anbi12d spcegv sylc wal cio weu
      coeq2 imaeq2 ima0 necon3i ad2antlr sstrd gsumval3eu eqid gsumval3a bitr4d
      iota1 alrimiv eqeq1 anbi2d exbidv eqeq2 bibi12d simplr syl5eqr pm2.61dane
      spcv fveq1i pm2.61d ) AFEUMUNZHDEGUOZUPUQURZUSZJUTAJUTUSZVDZFUEBKVAZUMUNZ
      KVWJVWLAVWQKUSZVWNAFVBVCZBIVCZVWRQRBUEFIKNUUAVEVFVWOEVWPFUMVWOEUEBUEVGZEU
      RZVAZVWPAEVXCUSVWNAUEBCESUUBVFVWOUEBVXBKVWOVXABVCZVDZVXBKUUCZVCZVXBKUSZVX
      EVXAGVHZVCZVXGVWOVXJVXGVXDVWOVXJVDZVXHVXGVXKVXAGVIZURZVWKURZVXMGURZEURZKV
      XBVXKUPHVJUNZBGVQZVXMVXQVCVXNVXPUSAVXRVWNVXJAVXQBGUUDZVXRUBVXQBGUUNVKZVLV
      WOVXIVXQVXAVXLVWOVXIVXQVXLVMZVXIVXQVXLVQVWOVXQVXIGVMZVYAAVYBVWNAVXSVYBUBV
      XQBGUUEZVKZVFZVXQVXIGVNVKVXIVXQVXLVOVKVPZVXQBVXMEGVRVEVWOVXJVXMVXQJVSZVCV
      XNKUSVXKVXMVXQVYGVYFVWOVYGVXQUSVXJVWOVYGVXQUTVSVXQVWOJUTVXQAVWNVTUUFVXQUU
      GWAZVFUUHVWOVXQCVWKJVXMKAVXQCVWKVQZVWNABCEVQZVXRVYISVXTVXQBCEGWBVEZVFZVWK
      VIZWCVXFVSZWDZJWEZVWOJVYOUDUUIZWFZWGWHVXKVXOVXAEVWOVYBVXJVXOVXAUSVYEVXQVX
      IVXAGUUJWIWKUUKVXBKVXAEWJUULZWLWMVWOVXDVXJWNZVXGAVXDVYTVDZVXGVWNWUAAVXABV
      XIVSZVCZVXGVXABVXIUUMAWUCVDVXHVXGABCEVXIVXAKSUCWGZVYSWLUUOWMUUPUUQVYSWOUV
      EWPWQVWOUEDVWKUPHKAKKDUNKUSZVWNAVWSKCVCZWUEQAVWSWUFQCFKMNUURZVKCDFKKMONWR
      VEVFAHUPXCURZVCZVWNAHWSWUHUAWTUUSZVFVWOVXAVXQVCZVXAVYGVCZVXAVWKURKUSVWOWU
      LWUKVWOVYGVXQVXAVYHXAXBVWOVXQCVWKJVXAKVYLVYRWGWHUUTXDAJUTXEZVDZBVJVHVCZVW
      MWUOBUFVGZUGVGZVJUNZUSZUGXFXGZUFXFXGZWUNVWMXFXFUVAZXFUVBZVJVQVJWVBXHWUOWV
      AXIUVCWVBWVCVJXJUFUGXFXFBVJUVDUVFWUNWUTVWMUFXFWUNWUSVWMUGXFWUNWUSVWMWUNWU
      SVDZVWJWUQDEWUPUQURZVWLWVDCDEFWUPWUQVBMOAVWSWUMWUSQVLWVDWURUTXEWUQWUPXCUR
      ZVCWVDBWURUTWUNWUSVTZWUNBUTXEZWUSAWUMWVHABUTJUTABUTUSZEUTUSZVWNAWVJEXKZUT
      USZWVIAEUVGZWVJWVLXIAVYJWVMSBCEUVHVKEUVIVKAWVKBUTAVYJWVKBUSSBCEXLVKXMUVJW
      VJJVYOUTUDWVJVYOUTVYNWDUTWVJVYMUTVYNWVJVYMUTVIUTWVJVWKUTWVJVWKUTGUOUTEUTG
      UVKGUVLWAUVMUVNWAUVOVYNUVPWAXNUVQUVRUVSVFUVTWUPWUQUWAWOWVDVYJWURCEVQAVYJW
      UMWUSSVLWVDBWURCEWVGUWBXOUWCWVDUPVXIXPURZVJUNZVXIXRXRUHVGZXQZUHXSZVWLWVEU
      SZWVDVXIXRXTZVXIYAVCZWVRWVDVXIYBWEYBXRXTZWVTWVDVXIWURYBWVDVXIBWURAVXIBWEZ
      WUMWUSAVXRWWCVXTVXQBGYCVKZVLWVGUWDZWURWVFYBWUPWUQYDWVFXFYBWUPUWEUWFYEYEYF
      YGVXIYBXRYHYIAWWAWUMWUSAVXQYAVCZWWAUPHUWGZAVXQVXIYJYKZWWFWWAXIAGWCVCZVYBW
      WHAVXRWWFVWTWWIVXTWWFAWWGWFRVXQBGYAIUWHUWIZVYDVXQVXIGWCYLVEZVXQVXIUWJVKUW
      KZVLVXIXRUHYMVEWVDWVQWVSUHWUNWUSWVQWVSWUNWUSWVQVDZVDZHDEWVPUOZUPUQZURWVNW
      WPURVWLWVEWWNHWVNWWPAHWVNUSWUMWWMAVXQXPURZHWVNAHUWLVCWWQHUSAHUAUWMHUWTVKA
      WWQWVNUSZWWHWWKAWWFWWAWWRWWHXIWWGWWLVXQVXIYNYOYPUWNVLZWKWWNUEUIUJEVHZDCUK
      WVPVIZGUOZWWOVWKUPHWWNVWSVXACVCZUIVGZCVCZVDZVXAWXDDUNZCVCZAVWSWUMWWMQVLZV
      WSWXCWXEWXHCDFVXAWXDMOUWOUWPZWIZWWNVXAWWTVCZWXDWWTVCZWXGWXDVXADUNUSZWWNWX
      LVDVXAWWTLURZVCWXMWXNWWNWWTWXOVXAAWWTWXOWEZWUMWWMTVLUWQDWWTFVXAWXDLOPUWRW
      IUWSWWNVWSWXCWXEUJVGZCVCUXAWXGWXQDUNVXAWXDWXQDUNDUNUSWXICDFVXAWXDWXQMOUXB
      WIAWUIWUMWWMWUJVLWWNVYJWWTCWEAVYJWUMWWMSVLZBCEYCVKWWNVXIVXQWXAVMZVYBVXQVX
      QWXBVMWWNVXQVXIWVPVMZWXSWWNWXTWVOVXIWVPVMZWWNWVQWYAWUNWUSWVQYQZWVOVXIXRXR
      WVPYRVKZWWNVXQWVOUSWXTWYAXIWWNHWVNUPVJWWSWQVXQWVOVXIWVPYSVKYPZVXQVXIWVPVN
      VKZAVYBWUMWWMVYDVLZVXQVXIVXQWXAGUXCVEWWNVXQWWTVXAWWOWWNBWWTEVQZVXQBWVPVQZ
      VXQWWTWWOVQWWNBWWTEUXDZWYGWWNVYJWYIWXRVYJEBXHWYIBCEXJBEUXEWOVKBWWTEUXFVKW
      WNVXQVXIWVPVQZWWCWYHWWNWXTWYJWYDVXQVXIWVPVOVKAWWCWUMWWMWWDVLVXQVXIBWVPUXL
      VEVXQBWWTEWVPWBVEVPWWNUKVGZVXQVCZVDWYKVWKURZWYKWWOWXBUOZURZWYKWXBURWWOURZ
      WWNWYMWYOUSWYLWWNWYKVWKWYNWWNVWKEWVPWXBUOZUOWYNWWNGWYQEWWNGWVPWXAUOZGUOZW
      YQWWNWYSUXMVXIUXGZGUOZGWWNWYRWYTGWWNWXTWYRWYTUSWYDVXQVXIWVPUXHVKUXIWWNVXQ
      VXIGVQZXUAGUSWWNVYBXUBWYFVXQVXIGVOVKZVXQVXIGUXJVKUXKWVPWXAGYTWAUXNEWVPWXB
      YTUXOUXPVFWWNVXQVXQWXBVQZWYLWYOWYPUSWWNVXIVXQWXAVQZXUBXUDWWNWXSXUEWYEVXIV
      XQWXAVOVKXUCVXQVXIVXQWXAGWBVEVXQVXQWYKWWOWXBVRWIWPUXQWWNVXIDCUEUIEWVPWWOW
      UPWUQKWWNVWSWXCKVXADUNVXAUSZWXICDFVXAKMONWRZWIWWNVWSWXCVXAKDUNVXAUSZWXICD
      FVXAKMONUXRZWIWXKWWNVWSWUFWXIWUGVKWYBAVXIUTXEZWUMWWMAGXKZUTXEXUJAXUKVXQUT
      AVXRXUKVXQUSVXTVXQBGXLVKAUPVXQVCZVXQUTXEAWUIXULWUJUPHUXSVKVXQUPUXTVKUYCXU
      KUTVXIUTGUYAUYBWOVLWUNWUSVXIWURWEWVQWWEUYDWWNVXAWURVCZVXDVXBCVCWWNVXDXUMW
      WNBWURVXAWUNWUSWVQUYEZXAXBWWNBCVXAEWXRVPWHWWNVXAWURVXIVSZVCZWUCVXHWWNWUCX
      UPWWNWUBXUOVXAWWNBWURVXIXUNUYFXAXBWWNAWUCVXHAWUMWWMUYGWUDWIWHWWNWVOVXIWVP
      VQZWXDWVOVCWXDWWOURWXDWVPURZEURUSWWNWYAXUQWYCWVOVXIWVPVOVKWVOVXIWXDEWVPVR
      WIUYHXDUYIUYJUYKUYLUYMUYNUYNUYOWUNWUOWNZVWMWUNXUSVDZUPJXPURZVJUNZJXRXRWVP
      XQZUHXSZVWMAXVDWUMXUSAJXRXTZJYAVCZXVDAJYBWEWWBXVEAJVXQYBAVWKXKZJVXQJVYOXV
      GUDVWKVYNUYPUYQAVYIXVGVXQUSVYKVXQCVWKXLVKUYRZVXQWSYBVXQWUHWSUPHYDWTUYSUYT
      YEYFYGJYBXRYHYIAWWFJVXQWEZXVFWWGXVHVXQJVUAYOZJXRUHYMVEVLXUTXVCVWMUHWUNXUS
      XVCVWMWUNXUSXVCVDZVDZVWJXVADEGWVPUOZUOZUPUQZURZVWLXVLUPEVIZVYNWDZXPURZVJU
      NZXVRULVGZVMZXVPXVSDEXWAUOZUPUQZURZUSZVDZULXSZVWJXVPUSZXVLXVMWCVCZXVTXVRX
      VMVMZXVPXVSXVOURZUSZVDZXWHAXWJWUMXVKAWWIWVPWCVCXWJWWJUHVUBGWVPWCWCVUCVUDV
      LXVLXWKXWMXVLXVBXVRXVMVMZXWKXVLXVBXVRGJUXGZWVPUOZVMZXWOXVLJXVRXWPVMZXVBJW
      VPVMZXWRXVLJGJWDZXWPVMZXWSXVLVXSXVIXXBAVXSWUMXVKUBVLZAXVIWUMXVKXVHVLZVXQB
      JGVUEVEXVLXXAXVRUSXXBXWSXIXVLXXAGVXLXVRWDZWDZXVRJXXEGJVYOVXLXVQUOZVYNWDXX
      EUDVYMXXGVYNEGVUFVUGVXLXVQVYNVUHVUIZVUJXVLVXQVXIGUXDZXVRVXIWEZXXFXVRUSXVL
      VYBXXIXVLVXSVYBXXCVYCVKVXQVXIGVUKVKAXXJWUMXVKUCVLZVXQVXIXVRGVUOVEXNXXAXVR
      JXWPVULVKXOZXVLXVCXWTWUNXUSXVCYQZXVBJXRXRWVPYRVKZXVBJXVRXWPWVPUXCVEXVLXVB
      JWVPVQZWVPVHJWEXWQXVMUSXWRXWOXIXVLXWTXXOXXNXVBJWVPVOVKZXVBJWVPYCGWVPJVUMX
      VBXVRXWQXVMVUPVUNXOXVLXVBXVTUSXWOXWKXIXVLXVAXVSUPVJXVLXVAXVSUSZJXVRYJYKZX
      VLXWPWCVCZXWSXXRAXXSWUMXVKAWWIXXSWWJGJWCVUQVKVLXXLJXVRXWPWCYLVEXVLXVFXVRY
      AVCZXXQXXRXIAXVFWUMXVKXVJVLAXXTWUMXVKAWWAXXJXXTWWLUCVXIXVRVUAVEVLZJXVRYNV
      EYPZWQXVBXVTXVRXVMYSVKXOXVLXVAXVSXVOXYBWKVURXWGXWNULXVMWCXWAXVMUSZXWBXWKX
      WFXWMXVTXVRXWAXVMVUPXYCXWEXWLXVPXYCXVSXWDXVOXYCXWCXVNDUPXWAXVMEVVGVUSUXPV
      UTVVAVVBVVCXVLXWBVXAXWEUSZVDZULXSZVWJVXAUSZXIZUEVVDXWHXWIXIZXVLXYHUEXVLXY
      FXYFUEVVEZVXAUSZXYGXVLXYFUEVVFXYFXYKXIXVLUEBCDULEFIXVRKLMNOPAVWSWUMXVKQVL
      ZAVWTWUMXVKRVLZAVYJWUMXVKSVLZAWXPWUMXVKTVLZXYAWUMXVRUTXEAXVKXVRUTJUTXVRUT
      USZJXXEUTXXHXYPXXEVXLUTWDUTXVRUTVXLVVHVXLVVIWAXNVVJVVKZXVLXVRVXIBXXKAWWCW
      UMXVKWWDVLVVLVVMXYFUEVVQVKXVLVWJXYJVXAXVLUEBCDULEFIXVRKLMNOPXYLXYMXYNXYOX
      YAXYQXVRVVNWUNXUSXVCUYEVVOXMVVPVVRXYHXYIUEXVPXVAXVOWJVXAXVPUSZXYFXWHXYGXW
      IXYRXYEXWGULXYRXYDXWFXWBVXAXVPXWEVVSVVTVWAVXAXVPVWJVWBVWCVWGVKXOXVLJDCUEU
      IVWKWVPXVNUPHKXVLVWSWXCXUFXYLXUGWIXVLVWSWXCXUHXYLXUIWIXVLVWSWXFWXHXYLWXJW
      IXVLVWSWUFXYLWUGVKXXMAWUMXVKVWDXXDXVLVXQCVXAVWKAVYIWUMXVKVYKVLZVPXVLVXQCV
      WKJVXAKXYSVYPXVLVYQWFWGXVLWXDXVBVCZVDWXDXVNURWXDVWKWVPUOZURZXURVWKURZWXDY
      UAXVNEGWVPYTVWHXVLXXOXYTYUBYUCUSXXPXVBJWXDVWKWVPVRWIVWEUYHUYLUYIUYJUYKUYM
      VWIVWF $.
  $}

  ${
    cntzcmnf.b $e |- B = ( Base ` G ) $.
    cntzcmnf.z $e |- Z = ( Cntz ` G ) $.
    cntzcmnf.g $e |- ( ph -> G e. CMnd ) $.
    cntzcmnf.f $e |- ( ph -> F : A --> B ) $.
    $( Discharge the centralizer assumption in a commutative monoid.
       (Contributed by Mario Carneiro, 24-Apr-2016.) $)
    cntzcmnf $p |- ( ph -> ran F C_ ( Z ` ran F ) ) $=
      ( crn cfv wf wss frn syl ccmn wcel wceq cntzcmn syl2anc sseqtr4d ) ADKZCU
      CFLZABCDMUCCNZJBCDOPZAEQRUEUDCSIUFCUCEFGHTUAUB $.
  $}

  ${
    $d k A $.  $d k F $.  $d k ph $.  $d k W $.
    gsumcllem.f $e |- ( ph -> F : A --> B ) $.
    gsumcllem.s $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) C_ W ) $.
    $( Lemma for ~ gsumcl and related theorems.  (Contributed by Mario
       Carneiro, 15-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumcllem $p |- ( ( ph /\ W = (/) ) -> F = ( k e. A |-> .0. ) ) $=
      ( c0 wceq wa cv cfv cmpt feqmptd adantr wcel cdif difeq2 syl6eq mpteq2dva
      dif0 eleq2d biimpar suppssr sylan2 anassrs eqtrd ) AFJKZLZEDBDMZENZOZDBGO
      AEUNKUJADBCEHPQUKDBUMGAUJULBRZUMGKZUJUOLAULBFSZRZUPUJURUOUJUQBULUJUQBJSBF
      JBTBUCUAUDUEABCEFULGHIUFUGUHUBUI $.
  $}

  ${
    $d f k x .0. $.  $d f k x B $.  $d f k x F $.  $d f k x G $.  $d f k x H $.
    $d k x A $.  $d x C $.  $d f k x ph $.  $d k V $.  $d f k W $.
    gsumzcl.b $e |- B = ( Base ` G ) $.
    gsumzcl.0 $e |- .0. = ( 0g ` G ) $.
    gsumzcl.z $e |- Z = ( Cntz ` G ) $.
    gsumzcl.g $e |- ( ph -> G e. Mnd ) $.
    gsumzcl.a $e |- ( ph -> A e. V ) $.
    gsumzcl.f $e |- ( ph -> F : A --> B ) $.
    gsumzcl.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    ${
      gsumzres.s $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) C_ W ) $.
      gsumzres.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
      $( Extend a finite group sum by padding outside with zeroes.
         (Contributed by Mario Carneiro, 24-Apr-2016.) $)
      gsumzres $p |- ( ph -> ( G gsum ( F |` W ) ) = ( G gsum F ) ) $=
        ( wceq wss vf vk ccnv cvv csn cdif cima c0 cres cgsu co chash cfv cn c1
        wcel cfz cv wf1o wex wa cin cmpt inex1g syl gsumz syl2anc eqtr4d adantr
        cmnd resres wf wfn ffn fnresdm 3syl reseq1d syl5eqr a1i gsumcllem inss1
        ssid resmpt ax-mp syl6eq eqtr3d oveq2d 3eqtr4d cplusg ccom cseq crn wfo
        ex f1ofo forn ad2antll eqsstrd cores seqeq3d fveq1d eqid fssres sylancl
        feq1d biimpa syldan resss rnss cntzidss wf1 f1of1 cdm cnvimass syl5sseq
        simprl fdm ssind f1ss cnvss imass1 mp2b syl5sseqr gsumval3 expr exlimdv
        expimpd cfn wo fz1f1o mpjaod ) ADUCZUDHUEUFZUGZUHSZEDGUIZUJUKZEDUJUKZSZ
        YNULUMZUNUPZUOYTUQUKZYNUAURZUSZUAUTZVAZAYOYSAYOVAZEUBBGVBZHVCZUJUKZEUBB
        HVCZUJUKZYQYRAUUJUULSYOAUUJHUULAEVJUPZUUHUDUPZUUJHSMABFUPZUUNNBGFVDVEZU
        UHUBEUDHKVFVGAUUMUUOUULHSMNBUBEFHKVFVGVHVIUUGYPUUIEUJUUGDUUHUIZYPUUIAUU
        QYPSYOAUUQDBUIZGUIYPDBGVKAUURDGABCDVLZDBVMUURDSOBCDVNBDVOVPVQVRZVIUUGUU
        QUUKUUHUIZUUIUUGDUUKUUHABCUBDYNHOYNYNTAYNWBZVSVTZVQUUHBTZUVAUUISBGWAZUB
        BUUHHWCWDWEWFWGUUGDUUKEUJUVCWGWHWNAUUAUUEYSAUUAVAUUDYSUAAUUAUUDYSAUUAUU
        DVAZVAZYTEWIUMZYPUUCWJZUOWKZUMYTUVHDUUCWJZUOWKZUMYQYRUVGYTUVJUVLUVGUVIU
        VKUVHUOUVGUUCWLZGTUVIUVKSUVGUVMYNGUUDUVMYNSZAUUAUUDUUBYNUUCWMUVNUUBYNUU
        CWOUUBYNUUCWPVEWQZAYNGTUVFQVIWRDUUCGWSVEWTXAUVGUUHCUVHYPEUUCYTUDUVIUCYM
        UGZHIJKUVHXBZLAUUMUVFMVIZAUUNUVFUUPVIAUVFUUHCUUQVLZUUHCYPVLZUVGUUSUVDUV
        SAUUSUVFOVIZUVEBCUUHDXCXDAUVSUVTAUUHCUUQYPUUTXEXFXGAYPWLZUWBIUMTZUVFADW
        LZUWDIUMTZUWBUWDTZUWCPYPDTZUWFDGXHZYPDXIWDUWDUWBEILXJXDVIAUUAUUDXPZUVGU
        UBYNUUCXKZYNUUHTZUUBUUHUUCXKUUDUWJAUUAUUBYNUUCXLWQZAUWKUVFAYNBGADXMZYNB
        DYMXNAUUSUWMBSOBCDXQVEXOZQXRVIUUBYNUUHUUCXSVGUVGYNYPUCZYMUGZUVMUWGUWOYL
        TUWPYNTUWHYPDXTUWOYLYMYAYBUVOYCUVPXBYDUVGBCUVHDEUUCYTFUVKUCYMUGZHIJKUVQ
        LUVRAUUOUVFNVIUWAAUWEUVFPVIUWIUVGUWJYNBTZUUBBUUCXKUWLAUWRUVFUWNVIUUBYNB
        UUCXSVGUVGYNYNUVMUVBUVOYCUWQXBYDWHYEYFYGAYNYHUPYOUUFYIRYNUAYJVEYK $.
    $}

    gsumzcl.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Closure of a finite group sum.  (Contributed by Mario Carneiro,
       24-Apr-2016.) $)
    gsumzcl $p |- ( ph -> ( G gsum F ) e. B ) $=
      ( vk wcel wa adantr vf vx ccnv cvv csn cdif cima c0 wceq cgsu co chash cn
      cfv c1 cfz wf1o wex cmpt wss ssid a1i gsumcllem oveq2d cmnd gsumz syl2anc
      cv eqtrd mndidcl syl eqeltrd ex cplusg ccom cseq eqid wf crn simprl f1of1
      wf1 ad2antll cdm cnvimass fdm syl5sseq f1ss f1ofo forn syl5sseqr gsumval3
      wfo cuz nnuz syl6eleq f1f fco ffvelrnda mndcl 3expb sylan exlimdv expimpd
      seqcl expr cfn wo fz1f1o mpjaod ) ADUCUDGUEUFZUGZUHUIZEDUJUKZCRZXLULUNZUM
      RZUOXPUPUKZXLUAVHZUQZUAURZSZAXMXOAXMSZXNGCYCXNEQBGUSZUJUKZGYCDYDEUJABCQDX
      LGNXLXLUTAXLVAZVBVCVDAYEGUIZXMAEVERZBFRZYGLMBQEFGJVFVGTVIAGCRZXMAYHYJLCEG
      IJVJVKTVLVMAXQYAXOAXQSXTXOUAAXQXTXOAXQXTSZSZXNXPEVNUNZDXSVOZUOVPUNCYLBCYM
      DEXSXPFYNUCXKUGZGHIJYMVQZKAYHYKLTZAYIYKMTABCDVRZYKNTZADVSZYTHUNUTYKOTAXQX
      TVTZYLXRXLXSWBZXLBUTZXRBXSWBZXTUUBAXQXRXLXSWAWCAUUCYKADWDZXLBDXKWEAYRUUEB
      UINBCDWFVKWGTXRXLBXSWHVGZYLXLXLXSVSZYFXTUUGXLUIZAXQXTXRXLXSWMUUHXRXLXSWIX
      RXLXSWJVKWCWKYOVQWLYLQUBYMCYNUOXPYLXPUMUOWNUNUUAWOWPYLXRCQVHZYNYLYRXRBXSV
      RZXRCYNVRYSYLUUDUUJUUFXRBXSWQVKXRBCDXSWRVGWSYLYHUUICRZUBVHZCRZSUUIUULYMUK
      CRZYQYHUUKUUMUUNCYMEUUIUULIYPWTXAXBXEVLXFXCXDAXLXGRXMYBXHPXLUAXIVKXJ $.

    gsumzf1o.h $e |- ( ph -> H : C -1-1-onto-> A ) $.
    $( Re-index a finite group sum using a bijection.  (Contributed by Mario
       Carneiro, 24-Apr-2016.) $)
    gsumzf1o $p |- ( ph -> ( G gsum F ) = ( G gsum ( F o. H ) ) ) $=
      ( adantr vf vk vx ccnv cvv csn cdif cima c0 wceq cgsu ccom chash cfv wcel
      co cn c1 cfz cv wf1o wex wa cmpt cmnd gsumz syl2anc wf1 syl f1dmex eqtr4d
      f1of1 wss ssid a1i gsumcllem oveq2d f1of ffvelrnda feqmptd fmptco 3eqtr4d
      wf eqidd ex cplusg cseq coass cid cres f1ococnv2 coeq1d ad2antll cnvimass
      cdm fdm syl5sseq f1ss f1f fcoi2 3syl eqtrd syl5reqr coeq2d syl6eqr fveq1d
      seqeq3d eqid crn simprl wfo f1ofo forn syl5sseqr gsumval3 rncoss cntzidss
      fco sylancl f1ocnv imass2 cnvco imaeq1i imaco eqtri rnco2 3sstr4g exlimdv
      f1co expr expimpd cfn wo fz1f1o mpjaod ) AEUDZUEIUFUGZUHZUIUJZFEUKUPZFEGU
      LZUKUPZUJZYRUMUNZUQUOZURUUDUSUPZYRUAUTZVAZUAVBZVCZAYSUUCAYSVCZFUBBIVDZUKU
      PZFUCDIVDZUKUPZYTUUBAUUMUUOUJYSAUUMIUUOAFVEUOZBHUOZUUMIUJNOBUBFHILVFVGAUU
      PDUEUOZUUOIUJNADBGVHZUUQUURADBGVAZUUSSDBGVLVIODBHGVJVGZDUCFUEILVFVGVKTUUK
      EUULFUKABCUBEYRIPYRYRVMAYRVNZVOVPZVQUUKUUAUUNFUKUUKUCUBDBUCUTZGUNZIIGEUUK
      DBUVDGADBGWCZYSAUUTUVFSDBGVRVIZTZVSUUKUCDBGUVHVTUVCUBUTUVEUJIWDWAVQWBWEAU
      UEUUIUUCAUUEVCUUHUUCUAAUUEUUHUUCAUUEUUHVCZVCZUUDFWFUNZEUUGULZURWGZUNUUDUV
      KUUAGUDZUUGULZULZURWGZUNYTUUBUVJUUDUVMUVQUVJUVLUVPUVKURUVJUVLEGUVOULZULUV
      PUVJUUGUVREUVJUVRGUVNULZUUGULZUUGGUVNUUGWHUVJUVTWIBWJZUUGULZUUGUVJUVSUWAU
      UGUVJUUTUVSUWAUJAUUTUVISTDBGWKVIWLUVJUUFBUUGVHZUUFBUUGWCUWBUUGUJUVJUUFYRU
      UGVHZYRBVMZUWCUUHUWDAUUEUUFYRUUGVLWMAUWEUVIAEWOZYRBEYQWNABCEWCZUWFBUJPBCE
      WPVIWQTUUFYRBUUGWRVGZUUFBUUGWSUUFBUUGWTXAXBXCXDEGUVOWHXEXGXFUVJBCUVKEFUUG
      UUDHUVLUDYQUHZIJKLUVKXHZMAUUPUVINTZAUUQUVIOTAUWGUVIPTAEXIZUWLJUNVMZUVIQTA
      UUEUUHXJZUWHUVJYRYRUUGXIZUVBUUHUWOYRUJZAUUEUUHUUFYRUUGXKUWPUUFYRUUGXLUUFY
      RUUGXMVIWMXNZUWIXHXOUVJDCUVKUUAFUVOUUDUEUVPUDYQUHZIJKLUWJMUWKAUURUVIUVATA
      DCUUAWCZUVIAUWGUVFUWSPUVGDBCEGXRVGTAUUAXIZUWTJUNVMZUVIAUWMUWTUWLVMUXAQEGX
      PUWLUWTFJMXQXSTUWNUVJBDUVNVHZUWCUUFDUVOVHAUXBUVIAUUTBDUVNVAUXBSDBGXTBDUVN
      VLXATUWHUUFBDUVNUUGYIVGUVJUVNYRUHZUVNUWOUHZUUAUDZYQUHZUVOXIUVJYRUWOVMUXCU
      XDVMUWQYRUWOUVNYAVIUXFUVNYPULZYQUHUXCUXEUXGYQEGYBYCUVNYPYQYDYEUVNUUGYFYGU
      WRXHXOWBYJYHYKAYRYLUOYSUUJYMRYRUAYNVIYO $.
  $}

  ${
    gsumcl.b $e |- B = ( Base ` G ) $.
    gsumcl.z $e |- .0. = ( 0g ` G ) $.
    gsumcl.g $e |- ( ph -> G e. CMnd ) $.
    gsumcl.a $e |- ( ph -> A e. V ) $.
    gsumcl.f $e |- ( ph -> F : A --> B ) $.
    ${
      gsumres.s $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) C_ W ) $.
      gsumres.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
      $( Extend a finite group sum by padding outside with zeroes.
         (Contributed by Mario Carneiro, 15-Dec-2014.)  (Revised by Mario
         Carneiro, 24-Apr-2016.) $)
      gsumres $p |- ( ph -> ( G gsum ( F |` W ) ) = ( G gsum F ) ) $=
        ( ccntz cfv eqid ccmn wcel cmnd cmnmnd syl cntzcmnf gsumzres ) ABCDEFGH
        EPQZIJUFRZAESTEUATKEUBUCLMABCDEUFIUGKMUDNOUE $.
    $}

    gsumcl.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Closure of a finite group sum.  (Contributed by Mario Carneiro,
       15-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumcl $p |- ( ph -> ( G gsum F ) e. B ) $=
      ( ccntz cfv eqid ccmn wcel cmnd cmnmnd syl cntzcmnf gsumzcl ) ABCDEFGENOZ
      HIUDPZAEQRESRJETUAKLABCDEUDHUEJLUBMUC $.

    gsumf1o.h $e |- ( ph -> H : C -1-1-onto-> A ) $.
    $( Re-index a finite group sum using a bijection.  (Contributed by Mario
       Carneiro, 15-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumf1o $p |- ( ph -> ( G gsum F ) = ( G gsum ( F o. H ) ) ) $=
      ( ccntz cfv eqid wcel ccmn cmnd cmnmnd syl cntzcmnf gsumzf1o ) ABCDEFGHIF
      QRZJKUGSZAFUATFUBTLFUCUDMNABCEFUGJUHLNUEOPUF $.
  $}

  ${
    gsumzsubmcl.0 $e |- .0. = ( 0g ` G ) $.
    gsumzsubmcl.z $e |- Z = ( Cntz ` G ) $.
    gsumzsubmcl.g $e |- ( ph -> G e. Mnd ) $.
    gsumzsubmcl.a $e |- ( ph -> A e. V ) $.
    gsumzsubmcl.s $e |- ( ph -> S e. ( SubMnd ` G ) ) $.
    gsumzsubmcl.f $e |- ( ph -> F : A --> S ) $.
    gsumzsubmcl.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    gsumzsubmcl.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Closure of a group sum in a submonoid.  (Contributed by Mario Carneiro,
       24-Apr-2016.) $)
    gsumzsubmcl $p |- ( ph -> ( G gsum F ) e. S ) $=
      ( co cfv eqid syl cress cgsu cbs c0g ccntz csubmnd wcel cmnd submmnd wceq
      wf wb submbas feq3 mpbid crn cin wss ssind resscntz syl2anc sseqtr4d ccnv
      frn cvv csn cdif cima cfn subm0 difeq2d imaeq2d eqeltrrd gsumzcl gsumsubm
      sneqd 3eltr4d ) AECUAQZDUBQVRUCRZEDUBQCABVSDVRFVRUDRZVRUERZVSSVTSWASZACEU
      FRZUGZVRUHUGMCVREVRSZUITLABCDUKZBVSDUKZNACVSUJZWFWGULAWDWHMCVREWEUMTZCVSB
      DUNTUOADUPZWJHRZCUQZWJWARZAWJWKCOAWFWJCURZNBCDVDTZUSAWDWNWMWLUJMWOCWJEVRW
      CWAHWEJWBUTVAVBADVCZVEGVFZVGZVHWPVEVTVFZVGZVHVIAWRWTWPAWQWSVEAGVTAWDGVTUJ
      MCVREGWEIVJTVPVKVLPVMVNABCDEVRFLMNWEVOWIVQ $.
  $}

  ${
    gsumsubmcl.z $e |- .0. = ( 0g ` G ) $.
    gsumsubmcl.g $e |- ( ph -> G e. CMnd ) $.
    gsumsubmcl.a $e |- ( ph -> A e. V ) $.
    gsumsubmcl.s $e |- ( ph -> S e. ( SubMnd ` G ) ) $.
    gsumsubmcl.f $e |- ( ph -> F : A --> S ) $.
    gsumsubmcl.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Closure of a group sum in a submonoid.  (Contributed by Mario Carneiro,
       10-Jan-2015.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumsubmcl $p |- ( ph -> ( G gsum F ) e. S ) $=
      ( ccntz cfv eqid ccmn wcel syl wf cmnd cmnmnd cbs wss csubmnd fss syl2anc
      submss cntzcmnf gsumzsubmcl ) ABCDEFGENOZHUKPZAEQREUARIEUBSJKLABEUCOZDEUK
      UMPZULIABCDTCUMUDZBUMDTLACEUEORUOKUMCEUNUHSBCUMDUFUGUIMUJ $.
  $}

  ${
    gsumsubgcl.z $e |- .0. = ( 0g ` G ) $.
    gsumsubgcl.g $e |- ( ph -> G e. Abel ) $.
    gsumsubgcl.a $e |- ( ph -> A e. V ) $.
    gsumsubgcl.s $e |- ( ph -> S e. ( SubGrp ` G ) ) $.
    gsumsubgcl.f $e |- ( ph -> F : A --> S ) $.
    gsumsubgcl.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Closure of a group sum in a subgroup.  (Contributed by Mario Carneiro,
       15-Dec-2014.) $)
    gsumsubgcl $p |- ( ph -> ( G gsum F ) e. S ) $=
      ( cabel wcel ccmn ablcmn syl csubg cfv csubmnd subgsubm gsumsubmcl ) ABCD
      EFGHAENOEPOIEQRJACESTOCEUATOKCEUBRLMUC $.
  $}

  ${
    $d f k n w x y z .+ $.  $d k x .0. $.  $d f k n w x y z F $.  $d f k x G $.
    $d k x A $.  $d k w x y z B $.  $d f k n w x y H $.  $d f k n w x y z ph $.
    $d x y S $.  $d x V $.  $d f k n w x y z W $.  $d k x Z $.
    gsumzadd.b $e |- B = ( Base ` G ) $.
    gsumzadd.0 $e |- .0. = ( 0g ` G ) $.
    gsumzadd.p $e |- .+ = ( +g ` G ) $.
    gsumzadd.z $e |- Z = ( Cntz ` G ) $.
    gsumzadd.g $e |- ( ph -> G e. Mnd ) $.
    gsumzadd.a $e |- ( ph -> A e. V ) $.
    gsumzadd.fn $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumzadd.hn $e |- ( ph -> ( `' H " ( _V \ { .0. } ) ) e. Fin ) $.
    ${
      gsumzaddlem.w $e |- W = ( `' ( F u. H ) " ( _V \ { .0. } ) ) $.
      gsumzaddlem.f $e |- ( ph -> F : A --> B ) $.
      gsumzaddlem.h $e |- ( ph -> H : A --> B ) $.
      gsumzaddlem.1 $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
      gsumzaddlem.2 $e |- ( ph -> ran H C_ ( Z ` ran H ) ) $.
      gsumzaddlem.3 $e |- ( ph ->
        ran ( F oF .+ H ) C_ ( Z ` ran ( F oF .+ H ) ) ) $.
      gsumzaddlem.4 $e |- ( ( ph /\ ( x C_ A /\ k e. ( A \ x ) ) ) ->
        ( F ` k ) e. ( Z ` { ( G gsum ( H |` x ) ) } ) ) $.
      $( The sum of two group sums.  (Contributed by Mario Carneiro,
         25-Apr-2016.) $)
      gsumzaddlem $p |- ( ph ->
        ( G gsum ( F oF .+ H ) ) = ( ( G gsum F ) .+ ( G gsum H ) ) ) $=
        ( vf vy vn vz vw c0 wceq cof co cgsu chash cfv cn wcel c1 cfz cv wex wa
        wf1o cmnd mndidcl syl mndlid syl2anc adantr cmpt ccnv cvv csn cdif cima
        wss ssun1 cnvun imaeq1i imaundir 3eqtri sseqtr4i gsumcllem oveq2d gsumz
        cun a1i eqtrd ssun2 oveq12d ad2antrr ex ccom cseq mndcl 3expb sylan cuz
        nnuz wf1 f1of1 ad2antll cdm cnvimass fdm syl5sseq fco ffvelrnda wfn ffn
        inidm fnfco eqidd ofval adantl adantlr syldan seqcl ffvelrn syl2an cres
        wf wral cin expr crn ax-mp sylc sseqtri eqid gsumval3 syl5sseqr suppssr
        wi cfn offval2 mpteq2dv 3eqtr4rd caovclg simprl syl6eleq unssd syl5eqss
        f1ss f1f ovex ofco fveq1d cfzo caddc elfzouz fzss2 sselda fzofzp1 fvco3
        elfzouz2 wn fzp1disj disjsn mpbi f1elima syl3anc mtbiri eldifd ralrimiv
        wb wal alrimiv imassrn frn syl5ss vex imaexg sseq1 difeq2 reseq2 fveq2d
        sneqd eleq2d raleqbidv imbi12d spcv fveq2 eleq1d rspcv eqeltrd cntzidss
        fssres resss sylancl syl6eleqr f1ores dmres inss1 df-ima sstri eqimss2i
        rnss cores resco eqtr4i fveq1i fvres syl5eq seqfveq eqtr2d elsnc sylibr
        fvex cntzi eqcomd mnd4g seqcaopr3 off eldifi sylan2 f1ofo 3eqtrd suppss
        wfo forn 3eqtr4d exlimdv expimpd wo unfi syl5eqel fz1f1o mpjaod ) AKUNU
        OZHGIEUPZUQZURUQZHGURUQZHIURUQZEUQZUOZKUSUTZVAVBZVCVUCVDUQZKUIVEZVHZUIV
        FZVGZAUYOVUBAUYOVGZLLEUQZLVUAUYRAVUKLUOZUYOAHVIVBZLDVBZVULRAVUMVUNRDHLN
        OVJVKZDEHLLNPOVLVMZVNZVUJUYSLUYTLEVUJUYSHBCLVOZURUQZLVUJGVURHURACDBGKLU
        CGVPZVQLVRVSZVTZKWAAVVBVVBIVPZVVAVTZWKZKVVBVVDWBKGIWKVPZVVAVTVUTVVCWKZV
        VAVTVVEUBVVFVVGVVAGIWCWDVUTVVCVVAWEWFZWGZWLWHZWIAVUSLUOZUYOAVUMCJVBZVVK
        RSCBHJLOWJVMVNZWMVUJUYTVUSLVUJIVURHURACDBIKLUDVVDKWAAVVDVVEKVVDVVBWNVVH
        WGZWLWHZWIVVMWMWOVUJUYRVUSLVUJUYQVURHURVUJUYQBCVUKVOVURVUJBCLLEGIJDDAVV
        LUYOSVNAVUNUYOBVEZCVBZVUOWPZVVRVVJVVOUUAVUJBCVUKLVUQUUBWMWIVVMWMUUCWQAV
        UDVUHVUBAVUDVGVUGVUBUIAVUDVUGVUBAVUDVUGVGZVGZVUCEUYQVUFWRZVCWSUTVUCEGVU
        FWRZVCWSZUTZVUCEIVUFWRZVCWSZUTZEUQUYRVUAVVTBUJEEDFUKVWBVWEVWAVCVUCVVTUL
        UMVVPUJVEDDDEVVTVUMULVEZDVBZUMVEZDVBZVGVWHVWJEUQDVBZAVUMVVSRVNZVUMVWIVW
        KVWLDEHVWHVWJNPWTXAXBZUUDZVWOVVTVUCVAVCXCUTZAVUDVUGUUEZXDUUFVVTVUEDFVEZ
        VWBVVTCDGYGZVUECVUFYGZVUEDVWBYGZAVWSVVSUCVNZVVTVUECVUFXEZVWTVVTVUEKVUFX
        EZKCWAZVXCVUGVXDAVUDVUEKVUFXFXGAVXEVVSAKVVECVVHAVVBVVDCAGXHZVVBCGVVAXIA
        VWSVXFCUOUCCDGXJVKXKAIXHZVVDCIVVAXIACDIYGZVXGCUOUDCDIXJVKXKUUGUUHVNVUEK
        CVUFUUIVMZVUECVUFUUJVKZVUECDGVUFXLVMZXMZVVTVUEDVWRVWEVVTVXHVWTVUEDVWEYG
        ZAVXHVVSUDVNZVXJVUECDIVUFXLVMZXMZVVTVWRVUEVBZVGZVWRVWAUTZVWRVWBVWEUYPUQ
        ZUTZVWRVWBUTZVWRVWEUTZEUQVVTVXSVYAUOVXQVVTVWRVWAVXTVVTCCCVUEEGIVUFJJVQV
        VTVWSGCXNZVXBCDGXOVKZVVTVXHICXNZVXNCDIXOVKZVXJAVVLVVSSVNZVYHVUEVQVBVVTV
        CVUCVDUUKWLZCXPZUULUUMVNVVTVUEVUEVYBVYCEVUEVWBVWEVQVQVWRVVTVYDVWTVWBVUE
        XNVYEVXJCVUEGVUFXQVMVVTVYFVWTVWEVUEXNVYGVXJCVUEIVUFXQVMVYIVYIVUEXPVXRVY
        BXRVXRVYCXRXSWMVVTUKVEZVCVUCUUNUQVBZVGZDEHVYKVCUUOUQZVWEUTZVYKVWCUTVYKV
        WFUTZVYNVWBUTZNPAVUMVVSVYLRWPZVYMFBEDVWBVCVYKVYLVYKVWPVBVVTVYKVCVUCUUPX
        TZVYMVWRVCVYKVDUQZVBZVXQVYBDVBZVYMVYTVUEVWRVYMVUCVYKXCUTVBZVYTVUEWAZVYL
        WUCVVTVYKVCVUCUVAXTVYKVCVUCUUQVKZUURZVVTVXQWUBVYLVXLYAYBVYMVUMVWRDVBZVV
        PDVBZVGVWRVVPEUQDVBZVYRVUMWUGWUHWUIDEHVWRVVPNPWTXAXBZYCVYMFBEDVWEVCVYKV
        YSVYMWUAVXQVYCDVBZWUFVVTVXQWUKVYLVXPYAYBWUJYCVVTVXAVYNVUEVBZVYQDVBVYLVX
        KVCVUCVYKUUSZVUEDVYNVWBYDYEVVTVXMWULVYODVBVYLVXOWUMVUEDVYNVWEYDYEVYMVYQ
        VYPEUQZVYPVYQEUQZVYMVYQHIVUFVYTVTZYFZURUQZVRZMUTZVBVYPWUSVBZWUNWUOUOVYM
        VYQVYNVUFUTZGUTZWUTVVTVWTWULVYQWVCUOVYLVXJWUMVUECVYNGVUFUUTYEVYMWVBCWUP
        VSZVBVWRGUTZWUTVBZFWVDYHZWVCWUTVBZVYMWVBCWUPVVTVWTWULWVBCVBVYLVXJWUMVUE
        CVYNVUFYDYEVYMWVBWUPVBZVYNVYTVBZVYTVYNVRYIUNUOWVJUVBVCVYKUVCVYTVYNUVDUV
        EVYMVXCWULWUDWVIWVJUVKVVTVXCVYLVXIVNZVYLWULVVTWUMXTWUEVUECVUFVYNVYTUVFU
        VGUVHUVIVYMVVPCWAZWVEHIVVPYFZURUQZVRZMUTZVBZFCVVPVSZYHZYSZBUVLZWUPCWAZW
        VGAWWAVVSVYLAWVTBAWVLWVSAWVLVGWVQFWVRAWVLVWRWVRVBWVQUHYJUVJWQUVMWPVYMWU
        PVUFYKZCVUFVYTUVNVYMVWTWWCCWAVVTVWTVYLVXJVNVUECVUFUVOVKUVPZWVTWWBWVGYSB
        WUPVUFVQVBWUPVQVBZUIUVQVUFVYTVQUVRYLZVVPWUPUOZWVLWWBWVSWVGVVPWUPCUVSWWG
        WVQWVFFWVRWVDVVPWUPCUVTWWGWVPWUTWVEWWGWVOWUSMWWGWVNWURWWGWVMWUQHURVVPWU
        PIUWAWIUWCUWBUWDUWEUWFUWGYMWVFWVHFWVBWVDVWRWVBUOWVEWVCWUTVWRWVBGUWHUWIU
        WJYMUWKVYMVYPWURUOWVAVYMWURVYKEWUQVUFVYTYFZWRZVCWSUTVYPVYMWUPDEWUQHWWHV
        YKVQWWIVPVVAVTZLMNOPQVYRWWEVYMWWFWLVYMVXHWWBWUPDWUQYGAVXHVVSVYLUDWPWWDC
        DWUPIUWMVMVYMIYKZWWKMUTWAZWUQYKZWWKWAZWWMWWMMUTWAAWWLVVSVYLUFWPWUQIWAWW
        NIWUPUWNWUQIUXCYLWWKWWMHMQUWLUWOVYMVYKVWPVAVYSXDUWPVYMVYTWUPWWHVHZVYTWU
        PWWHXEVYMVXCWUDWWOWVKWUEVUECVYTVUFUWQVMVYTWUPWWHXFVKWUQVPVVAVTZWWHYKZWA
        VYMWWPWUPVXGYIZWWQWWPWUQXHWWRWUQVVAXIIWUPUWRYNWWRWUPWWQWUPVXGUWSVUFVYTU
        WTZYNUXAWLWWJYOYPVYMEFWWIVWEVCVYKVYSWUAVWRWWIUTZVYCUOVYMWUAWWTVWRVWEVYT
        YFZUTVYCVWRWWIWXAWWIIWWHWRZWXAWWQWUPWAWWIWXBUOWUPWWQWWSUXBIWWHWUPUXDYLI
        VUFVYTUXEUXFUXGVWRVYTVWEUXHUXIXTUXJUXKVYPWURVYKVWFUXNUXLUXMEWUSHVYQVYPM
        PQUXOVMUXPUXQUXRVVTCDEUYQHVUFVUCJVWAVPVVAVTZLMNOPQVWMVYHVVTULUMCCCEDDDG
        IJJVWNVXBVXNVYHVYHVYJUXSZAUYQYKZWXEMUTWAVVSUGVNVWQVXIVVTCDBUYQWWCLWXDVV
        TVVPCWWCVSVBZVGZVVPUYQUTZVVPGUTZVVPIUTZEUQZVUKLWXFVVTVVQWXHWXKUOVVPCWWC
        UXTVVTCCWXIWXJECGIJJVVPVYEVYGVYHVYHVYJVVTVVQVGZWXIXRWXLWXJXRXSUYAWXGWXI
        LWXJLEVVTCDGWWCVVPLVXBVVTKVVBWWCVVIVUGWWCKUOZAVUDVUGVUEKVUFUYEWXMVUEKVU
        FUYBVUEKVUFUYFVKXGZYQZYRVVTCDIWWCVVPLVXNVVTKVVDWWCVVNWXNYQZYRWOAVULVVSW
        XFVUPWPUYCUYDWXCYOYPVVTUYSVWDUYTVWGEVVTCDEGHVUFVUCJVWBVPVVAVTZLMNOPQVWM
        VYHVXBAGYKZWXRMUTWAVVSUEVNVWQVXIWXOWXQYOYPVVTCDEIHVUFVUCJVWEVPVVAVTZLMN
        OPQVWMVYHVXNAWWLVVSUFVNVWQVXIWXPWXSYOYPWOUYGYJUYHUYIAKYTVBUYOVUIUYJAKVV
        EYTVVHAVVBYTVBVVDYTVBVVEYTVBTUAVVBVVDUYKVMUYLKUIUYMVKUYN $.
    $}

    gsumzadd.s $e |- ( ph -> S e. ( SubMnd ` G ) ) $.
    gsumzadd.c $e |- ( ph -> S C_ ( Z ` S ) ) $.
    gsumzadd.f $e |- ( ph -> F : A --> S ) $.
    gsumzadd.h $e |- ( ph -> H : A --> S ) $.
    $( The sum of two group sums.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    gsumzadd $p |- ( ph ->
      ( G gsum ( F oF .+ H ) ) = ( ( G gsum F ) .+ ( G gsum H ) ) ) $=
      ( vx vk vy cun ccnv cvv csn cdif cima eqid wf wss csubmnd cfv wcel submss
      syl fss syl2anc crn frn cntzidss cof co cv wa submcl 3expb sylan off cres
      inidm cgsu adantr cmnd vex a1i simpl fssres syl2an resss rnss sylancl cfn
      ax-mp cnvss imass1 mp2b ssfi gsumzsubmcl snssd sstrd eldifi adantl sseldd
      cntz2ss ffvelrn gsumzaddlem ) AUDBCDUEFGHIFHUGUHUIJUJUKZULZJKLMNOPQRSXCUM
      ABEFUNZECUOZBCFUNUBAEGUPUQURZXETCEGLUSUTZBECFVAVBABEHUNZXEBCHUNUCXGBECHVA
      VBAEEKUQZUOZFVCZEUOZXKXKKUQUOUAAXDXLUBBEFVDUTEXKGKOVEVBAXJHVCZEUOZXMXMKUQ
      UOZUAAXHXNUCBEHVDUTEXMGKOVEVBZAXJFHDVFVGZVCZEUOZXRXRKUQUOUAABEXQUNXSAUDUF
      BBBDEEEFHIIAXFUDVHZEURZUFVHZEURZVIXTYBDVGEURZTXFYAYCYDDEGXTYBNVJVKVLUBUCQ
      QBVOVMBEXQVDUTEXRGKOVEVBAXTBUOZUEVHZBXTUKURZVIZVIZEGHXTVNZVPVGZUJZKUQZYFF
      UQZYIEXIYMAXJYHUAVQYIXEYLEUOXIYMUOAXEYHXGVQYIYKEYIXTEYJGUIJKMOAGVRURYHPVQ
      XTUIURYIUDVSVTAXFYHTVQAXHYEXTEYJUNYHUCYEYGWABEXTHWBWCYIXOYJVCZXMUOZYOYOKU
      QUOAXOYHXPVQYJHUOZYPHXTWDZYJHWEWHXMYOGKOVEWFYIHUHZXBULZWGURZYJUHZXBULZYTU
      OZUUCWGURAUUAYHSVQYQUUBYSUOUUDYRYJHWIUUBYSXBWJWKYTUUCWLWFWMWNCEYLGKLOWSVB
      WOAXDYFBURZYNEURYHUBYGUUEYEYFBXTWPWQBEYFFWTWCWRXA $.
  $}

  ${
    gsumadd.b $e |- B = ( Base ` G ) $.
    gsumadd.z $e |- .0. = ( 0g ` G ) $.
    gsumadd.p $e |- .+ = ( +g ` G ) $.
    gsumadd.g $e |- ( ph -> G e. CMnd ) $.
    gsumadd.a $e |- ( ph -> A e. V ) $.
    gsumadd.f $e |- ( ph -> F : A --> B ) $.
    gsumadd.h $e |- ( ph -> H : A --> B ) $.
    gsumadd.fn $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumadd.hn $e |- ( ph -> ( `' H " ( _V \ { .0. } ) ) e. Fin ) $.
    $( The sum of two group sums.  (Contributed by Mario Carneiro,
       19-Dec-2014.)  (Revised by Mario Carneiro, 25-Apr-2016.) $)
    gsumadd $p |- ( ph ->
      ( G gsum ( F oF .+ H ) ) = ( ( G gsum F ) .+ ( G gsum H ) ) ) $=
      ( cfv wcel eqid ccmn cmnd cmnmnd syl csubmnd submid ssid wss wceq cntzcmn
      ccntz sylancl syl5sseqr gsumzadd ) ABCDCEFGHIFULSZJKLUPUAZAFUBTZFUCTZMFUD
      UEZNQRAUSCFUFSTUTCFJUGUEACCCUPSZCUHZAURCCUIVACUJMVBCCFUPJUQUKUMUNOPUO $.
  $}

  ${
    $d k .+ $.  $d k .0. $.  $d k A $.  $d k B $.  $d k C $.  $d k ph $.
    $d k D $.  $d k F $.  $d k G $.
    gsumzsplit.b $e |- B = ( Base ` G ) $.
    gsumzsplit.0 $e |- .0. = ( 0g ` G ) $.
    gsumzsplit.p $e |- .+ = ( +g ` G ) $.
    gsumzsplit.z $e |- Z = ( Cntz ` G ) $.
    gsumzsplit.g $e |- ( ph -> G e. Mnd ) $.
    gsumzsplit.a $e |- ( ph -> A e. V ) $.
    gsumzsplit.f $e |- ( ph -> F : A --> B ) $.
    gsumzsplit.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    gsumzsplit.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumzsplit.i $e |- ( ph -> ( C i^i D ) = (/) ) $.
    gsumzsplit.u $e |- ( ph -> A = ( C u. D ) ) $.
    $( Split a group sum into two parts.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    gsumzsplit $p |- ( ph -> ( G gsum F ) =
      ( ( G gsum ( F |` C ) ) .+ ( G gsum ( F |` D ) ) ) ) $=
      ( vk cv wcel cfv cif cmpt cof co cgsu cres crn csubmnd cmrc ccnv cvv cdif
      csn cima cfn wss ssid a1i suppssr ifeq1d ifid syl6eq suppss2 ssfi syl2anc
      wa cmre cmnd cacs submacs acsmre 3syl wf frn syl eqid mrccl ccmn cntzspan
      cress wb submcmn2 mpbid mrcssidd adantr wfn fnfvelrn sylan sseldd subm0cl
      ffn ifcl fmptd gsumzadd feqmptd wceq iftrue adantl wn wi cin eleq2 mtbiri
      noel elin sylnib imnan sylibr imp iffalse oveq12d ffvelrnda mndrid syldan
      c0 eqtrd con2d mndlid wo eleq2d elun syl6bb eqtr4d eqidd oveq2d syl5sseqr
      cun reseq1d mpteq2ia resmpt 3eqtr4a cntzidss eldifn gsumzres biimpa ssun1
      mpjaodan mpteq2dva mndidcl offval2 ssun2 3eqtr4d ) AHUCBUCUDZDUEZUUIGUFZJ
      UGZUHZUCBUUIEUEZUUKJUGZUHZFUIUJZUKUJHUUMUKUJZHUUPUKUJZFUJHGUKUJHGDULZUKUJ
      ZHGEULZUKUJZFUJABCFGUMZHUNUFZUOUFZUFZUUMHUUPIJKLMNOPQAGUPUQJUSURZUTZVAUEZ
      UUMUPUVHUTZUVIVBUVKVAUETABUULUCUVIJAUUIBUVIURUEVLZUULUUJJJUGJUVLUUJUUKJJA
      BCGUVIUUIJRUVIUVIVBAUVIVCVDVEZVFUUJJVGVHVIUVIUVKVJVKZAUVJUUPUPUVHUTZUVIVB
      UVOVAUETABUUOUCUVIJUVLUUOUUNJJUGJUVLUUNUUKJJUVMVFUUNJVGVHVIUVIUVOVJVKZAUV
      ECVMUFUEZUVDCVBZUVGUVEUEZAHVNUEZUVECVOUFUEUVQPCHLVPUVECVQVRZABCGVSZUVRRBC
      GVTWAZUVEUVDUVFCUVFWBZWCVKZAHUVGWFUJZWDUEZUVGUVGKUFVBZAUVTUVDUVDKUFVBUWGP
      SUVDHUWFUVFKOUWDUWFWBZWEVKAUVSUWGUWHWGUWEUVGHUWFKUWIOWHWAWIZAUCBUULUVGUUM
      AUUIBUEZVLZUUKUVGUEZJUVGUEZUULUVGUEUWLUVDUVGUUKAUVDUVGVBUWKAUVEUVDUVFCUWA
      UWDUWCWJWKAGBWLZUWKUUKUVDUEAUWBUWORBCGWQWABUUIGWMWNWOZAUWNUWKAUVSUWNUWEUV
      GHJMWPWAWKZUUJUUKJUVGWRVKUUMWBZWSZAUCBUUOUVGUUPUWLUWMUWNUUOUVGUEUWPUWQUUN
      UUKJUVGWRVKUUPWBZWSZWTAGUUQHUKAGUCBUULUUOFUJZUHZUUQAGUCBUUKUHZUXCAUCBCGRX
      AZAUCBUXBUUKUWLUUJUXBUUKXBUUNUWLUUJVLZUXBUUKJFUJZUUKUXFUULUUKUUOJFUUJUULU
      UKXBUWLUUJUUKJXCZXDUXFUUNXEZUUOJXBZUWLUUJUXIUWLUUJUUNVLZXEUUJUXIXFUWLUUID
      EXGZUEZUXKAUXMXEZUWKAUXLYAXBZUXNUAUXOUXMUUIYAUEUUIXJUXLYAUUIXHXIWAWKUUIDE
      XKXLUUJUUNXMXNZXOUUNUUKJXPZWAXQUWLUXGUUKXBZUUJAUWKUUKCUEZUXRABCUUIGRXRZAU
      VTUXSUXRPCFHUUKJLNMXSWNXTWKYBUWLUUNVLZUXBJUUKFUJZUUKUYAUULJUUOUUKFUYAUUJX
      EZUULJXBZUWLUUNUYCUWLUUJUUNUXPYCXOUUJUUKJXPZWAUUNUUOUUKXBUWLUUNUUKJXCZXDX
      QUWLUYBUUKXBZUUNAUWKUXSUYGUXTAUVTUXSUYGPCFHUUKJLNMYDWNXTWKYBAUWKUUJUUNYEZ
      AUWKUUIDEYMZUEUYHABUYIUUIUBYFUUIDEYGYHUUAUUCUUDYIAUCBUULUUOFUUMUUPICCQUWL
      UXSJCUEZUULCUEUXTAUYJUWKAUVTUYJPCHJLMUUEWAWKZUUJUUKJCWRVKZUWLUXSUYJUUOCUE
      UXTUYKUUNUUKJCWRVKZAUUMYJAUUPYJUUFYIYKAUVAUURUVCUUSFAUVAHUUMDULZUKUJUURAU
      UTUYNHUKAUUTUXDDULZUYNAGUXDDUXEYNADBVBZUYNUYOXBAUYIDBDEUUBUBYLUYPUCDUULUH
      UCDUUKUHUYNUYOUCDUULUUKUXHYOUCBDUULYPUCBDUUKYPYQWAYIYKABCUUMHIDJKLMOPQAUC
      BUULCUUMUYLUWRWSAUWHUUMUMZUVGVBZUYQUYQKUFVBUWJABUVGUUMVSUYRUWSBUVGUUMVTWA
      UVGUYQHKOYRVKABUULUCDJAUUIBDURUEZVLUYCUYDUYSUYCAUUIBDYSXDUYEWAVIUVNYTYBAU
      VCHUUPEULZUKUJUUSAUVBUYTHUKAUVBUXDEULZUYTAGUXDEUXEYNAEBVBZUYTVUAXBAUYIEBE
      DUUGUBYLVUBUCEUUOUHUCEUUKUHUYTVUAUCEUUOUUKUYFYOUCBEUUOYPUCBEUUKYPYQWAYIYK
      ABCUUPHIEJKLMOPQAUCBUUOCUUPUYMUWTWSAUWHUUPUMZUVGVBZVUCVUCKUFVBUWJABUVGUUP
      VSVUDUXABUVGUUPVTWAUVGVUCHKOYRVKABUUOUCEJAUUIBEURUEZVLUXIUXJVUEUXIAUUIBEY
      SXDUXQWAVIUVPYTYBXQUUH $.
  $}

  ${
    gsumsplit.b $e |- B = ( Base ` G ) $.
    gsumsplit.z $e |- .0. = ( 0g ` G ) $.
    gsumsplit.p $e |- .+ = ( +g ` G ) $.
    gsumsplit.g $e |- ( ph -> G e. CMnd ) $.
    gsumsplit.a $e |- ( ph -> A e. V ) $.
    gsumsplit.f $e |- ( ph -> F : A --> B ) $.
    gsumsplit.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumsplit.i $e |- ( ph -> ( C i^i D ) = (/) ) $.
    gsumsplit.u $e |- ( ph -> A = ( C u. D ) ) $.
    $( Split a group sum into two parts.  (Contributed by Mario Carneiro,
       19-Dec-2014.) $)
    gsumsplit $p |- ( ph -> ( G gsum F ) =
      ( ( G gsum ( F |` C ) ) .+ ( G gsum ( F |` D ) ) ) ) $=
      ( wcel ccntz cfv eqid ccmn cmnd cmnmnd syl cntzcmnf gsumzsplit ) ABCDEFGH
      IJHUAUBZKLMUJUCZAHUDTHUETNHUFUGOPABCGHUJKUKNPUHQRSUI $.
  $}

  ${
    $d k A $.  $d k B $.  $d k C $.  $d k D $.  $d k ph $.
    gsumsplit2.b $e |- B = ( Base ` G ) $.
    gsumsplit2.z $e |- .0. = ( 0g ` G ) $.
    gsumsplit2.p $e |- .+ = ( +g ` G ) $.
    gsumsplit2.g $e |- ( ph -> G e. CMnd ) $.
    gsumsplit2.a $e |- ( ph -> A e. V ) $.
    gsumsplit2.f $e |- ( ( ph /\ k e. A ) -> X e. B ) $.
    gsumsplit2.w $e |- ( ph ->
      ( `' ( k e. A |-> X ) " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumsplit2.i $e |- ( ph -> ( C i^i D ) = (/) ) $.
    gsumsplit2.u $e |- ( ph -> A = ( C u. D ) ) $.
    $( Split a group sum into two parts.  (Contributed by Mario Carneiro,
       19-Dec-2014.) $)
    gsumsplit2 $p |- ( ph -> ( G gsum ( k e. A |-> X ) ) =
      ( ( G gsum ( k e. C |-> X ) ) .+ ( G gsum ( k e. D |-> X ) ) ) ) $=
      ( cmpt cgsu cres eqid fmptd gsumsplit wss wceq cun ssun1 syl5sseqr resmpt
      co syl oveq2d ssun2 oveq12d eqtrd ) AHGBJUAZUBUMHUSDUCZUBUMZHUSEUCZUBUMZF
      UMHGDJUAZUBUMZHGEJUAZUBUMZFUMABCDEFUSHIKLMNOPAGBJCUSQUSUDUERSTUFAVAVEVCVG
      FAUTVDHUBADBUGUTVDUHADEUIZDBDEUJTUKGBDJULUNUOAVBVFHUBAEBUGVBVFUHAVHEBEDUP
      TUKGBEJULUNUOUQUR $.
  $}

  ${
    $d f k x A $.  $d f k x B $.  $d f k x G $.  $d f .x. $.  $d f k x X $.
    gsumconst.b $e |- B = ( Base ` G ) $.
    gsumconst.m $e |- .x. = ( .g ` G ) $.
    $( Sum of a constant series.  (Contributed by Mario Carneiro,
       19-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumconst $p |- ( ( G e. Mnd /\ A e. Fin /\ X e. B ) ->
      ( G gsum ( k e. A |-> X ) ) = ( ( # ` A ) .x. X ) ) $=
      ( vf vx wcel c0 wceq co cfv cn c1 wa eqid syl cmnd cfn w3a cmpt chash cfz
      cgsu cv wf1o wex cc0 simpl3 mulg0 fveq2 adantl hash0 syl6eq oveq1d mpteq1
      c0g mpt0 oveq2d gsum0 3eqtr4rd ex cplusg ccom csn cxp cuz simprl syl6eleq
      cseq nnuz simpr adantr fvmpt2 syl2anc wf ad2antll ffvelrnda feqmptd eqidd
      f1of fmptco fveq1d elfznn fvconst2g syl2an 3eqtr4d seqfveq ccnv cdif cima
      cvv ccntz simpl1 simpl2 fmptd wss elcntzsn mpbir2and snssd snidg cntzidss
      crn frn wf1 f1of1 cdm cnvimass dmmptss sstri wfo f1ofo syl5sseqr gsumval3
      wb forn mulgnn expr exlimdv expimpd wo fz1f1o 3ad2ant2 mpjaod ) EUAKZAUBK
      ZFBKZUCZALMZEDAFUDZUGNZAUEOZFCNZMZYOPKZQYOUFNZAIUHZUIZIUJZRZYKYLYQYKYLRZU
      KFCNZEUTOZYPYNUUDYJUUEUUFMYHYIYJYLULBCEFUUFGUUFSZHUMTUUDYOUKFCUUDYOLUEOZU
      KYLYOUUHMYKALUEUNUOUPUQURUUDYNELUGNUUFUUDYMLEUGUUDYMDLFUDZLYLYMUUIMYKDALF
      USUODFVAUQVBEUUFUUGVCUQVDVEYKYRUUBYQYKYRRUUAYQIYKYRUUAYQYKYRUUARZRZYOEVFO
      ZYMYTVGZQVMOYOUULPFVHZVIZQVMZOZYNYPUUKUULJUUMUUOQYOUUKYOPQVJOYKYRUUAVKZVN
      VLUUKJUHZYSKZRZUUSJYSFUDZOZFUUSUUMOZUUSUUOOZUVAUUTYJUVCFMUUKUUTVOUUKYJUUT
      YHYIYJUUJULZVPJYSFBUVBUVBSVQVRUUKUVDUVCMUUTUUKUUSUUMUVBUUKJDYSAUUSYTOZFFY
      TYMUUKYSAUUSYTUUAYSAYTVSYKYRYSAYTWDVTZWAUUKJYSAYTUVHWBUUKYMWCDUHZUVGMFWCW
      EWFVPUUKYJUUSPKUVEFMUUTUVFUUSYOWGPFUUSBWHWIWJWKUUKABUULYMEYTYOUBUUMWLWOUU
      FVHWMZWNZUUFEWPOZGUUGUULSZUVLSZYHYIYJUUJWQYHYIYJUUJWRUUKDAFBYMUUKYJUVIAKZ
      UVFVPYMSZWSUUKUUNUUNUVLOZWTYMXFZUUNWTZUVRUVRUVLOWTUUKFUVQUUKFUVQKZYJFFUUL
      NZUWAMZUVFUUKUWAWCUUKYJUVTYJUWBRXRUVFBUULEFFUVLGUVMUVNXATXBXCUUKAUUNYMVSU
      VSUUKDAFUUNYMUUKFUUNKZUVOUUKYJUWCUVFFBXDTVPUVPWSAUUNYMXGTUUNUVREUVLUVNXEV
      RUURUUAYSAYTXHYKYRYSAYTXIVTUUKAYMWLUVJWNZYTXFZUWDYMXJAYMUVJXKDAFYMUVPXLXM
      UUAUWEAMZYKYRUUAYSAYTXNUWFYSAYTXOYSAYTXSTVTXPUVKSXQUUKYRYJYPUUQMUURUVFBUU
      LUUPCEYOFGUVMHUUPSXTVRWJYAYBYCYIYHYLUUCYDYJAIYEYFYG $.
  $}

  ${
    $d k A $.  $d k x y B $.  $d f k x y F $.  $d f k x y G $.  $d f k x y H $.
    $d f k x y .0. $.  $d f k x y K $.  $d f k x y ph $.  $d k V $.
    gsumzmhm.b $e |- B = ( Base ` G ) $.
    gsumzmhm.z $e |- Z = ( Cntz ` G ) $.
    gsumzmhm.g $e |- ( ph -> G e. Mnd ) $.
    gsumzmhm.h $e |- ( ph -> H e. Mnd ) $.
    gsumzmhm.a $e |- ( ph -> A e. V ) $.
    gsumzmhm.k $e |- ( ph -> K e. ( G MndHom H ) ) $.
    gsumzmhm.f $e |- ( ph -> F : A --> B ) $.
    gsumzmhm.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    gsumzmhm.0 $e |- .0. = ( 0g ` G ) $.
    gsumzmhm.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Apply a group homomorphism to a group sum.  (Contributed by Mario
       Carneiro, 24-Apr-2016.) $)
    gsumzmhm $p |- ( ph -> ( H gsum ( K o. F ) ) = ( K ` ( G gsum F ) ) ) $=
      ( vf vk vx vy ccnv cvv csn cdif cima c0 wceq ccom cgsu co cfv chash cn c1
      wcel cfz cv wf1o wex wa c0g cmpt cmnd eqid gsumz syl2anc adantr cmhm mhm0
      syl eqtr4d mndidcl ad2antrr wss ssid a1i gsumcllem cbs mhmf feqmptd fveq2
      wf fmptco mpteq2dv eqtrd oveq2d fveq2d 3eqtr4d ex cplusg cseq mndcl 3expb
      sylan wf1 f1of1 ad2antll cdm cnvimass fdm syl5sseq f1ss f1f fco ffvelrnda
      cuz simprl nnuz syl6eleq mhmlin coass fvco3 syl5req seqhomo crn wfo f1ofo
      fveq1i forn sseqtr4d gsumval3 ccntz cntzmhm2 fveq2i 3sstr4g eldifi syl2an
      rnco2 suppssr 3eqtrd suppss 3eqtr4rd expr exlimdv expimpd cfn wo fz1f1o
      mpjaod ) ADUEUFIUGUHZUIZUJUKZFGDULZUMUNZEDUMUNZGUOZUKZUUEUPUOZUQUSZURUULU
      TUNZUUEUAVAZVBZUAVCZVDZAUUFUUKAUUFVDZFUBBFVEUOZVFZUMUNZIGUOZUUHUUJUUSUVBU
      UTUVCAUVBUUTUKZUUFAFVGUSZBHUSZUVDNOBUBFHUUTUUTVHZVIVJVKAUVCUUTUKZUUFAGEFV
      LUNUSZUVHPEFGUUTISUVGVMVNZVKVOUUSUUGUVAFUMUUSUUGUBBUVCVFZUVAUUSUBUCBCIUCV
      AZGUOZUVCDGAICUSZUUFUBVABUSAEVGUSZUVNMCEIKSVPVNVQABCUBDUUEIQUUEUUEVRZAUUE
      VSZVTWAZAGUCCUVMVFUKUUFAUCCFWBUOZGAUVICUVSGWFZPCUVSEFGKUVSVHZWCVNZWDVKUVL
      IGWEWGAUVKUVAUKUUFAUBBUVCUUTUVJWHVKWIWJUUSUUIIGUUSUUIEUBBIVFZUMUNZIUUSDUW
      CEUMUVRWJAUWDIUKZUUFAUVOUVFUWEMOBUBEHISVIVJVKWIWKWLWMAUUMUUQUUKAUUMVDUUPU
      UKUAAUUMUUPUUKAUUMUUPVDZVDZUULEWNUOZDUUOULZURWOUOZGUOUULFWNUOZUUGUUOULZUR
      WOUOUUJUUHUWGUCUDUWHUWKCUWIUWLGURUULUWGUVOUVLCUSZUDVAZCUSZVDZUVLUWNUWHUNZ
      CUSZAUVOUWFMVKZUVOUWMUWOUWRCUWHEUVLUWNKUWHVHZWPWQWRUWGUUNCUVLUWIUWGBCDWFZ
      UUNBUUOWFZUUNCUWIWFZAUXAUWFQVKZUWGUUNBUUOWSZUXBUWGUUNUUEUUOWSZUUEBVRUXEUU
      PUXFAUUMUUNUUEUUOWTXAUWGDXBZUUEBDUUDXCUWGUXAUXGBUKUXDBCDXDVNXEUUNUUEBUUOX
      FVJZUUNBUUOXGVNUUNBCDUUOXHVJZXIUWGUULUQURXJUOAUUMUUPXKZXLXMUWGUVIUWPUWQGU
      OUVMUWNGUOUWKUNUKZAUVIUWFPVKZUVIUWMUWOUXKCUWHUWKEFGUVLUWNKUWTUWKVHZXNWQWR
      UWGUVLUUNUSZVDUVLUWLUOUVLGUWIULZUOZUVLUWIUOGUOZUVLUWLUXOGDUUOXOYBUWGUXCUX
      NUXPUXQUKUXIUUNCUVLGUWIXPWRXQXRUWGUUIUWJGUWGBCUWHDEUUOUULHUWIUEUUDUIZIJKS
      UWTLUWSAUVFUWFOVKZUXDADXSZUXTJUOVRZUWFRVKZUXJUXHUWGUUEUUEUUOXSZUVPUWGUVQV
      TZUUPUYCUUEUKZAUUMUUPUUNUUEUUOXTUYEUUNUUEUUOYAUUNUUEUUOYCVNXAZYDUXRVHYEWK
      UWGBUVSUWKUUGFUUOUULHUWLUEUFUUTUGUHZUIZUUTFYFUOZUWAUVGUXMUYIVHZAUVEUWFNVK
      UXSUWGUVTUXABUVSUUGWFAUVTUWFUWBVKUXDBCUVSGDXHVJZUWGGUXTUIZUYLUYIUOZUUGXSZ
      UYNUYIUOUWGUVIUYAUYLUYMVRUXLUYBUXTUXTGEFUYIJLUYJYGVJGDYLZUYNUYLUYIUYOYHYI
      UXJUXHUWGUUGUEUYGUIUUEUYCUWGBUVSUCUUGUUEUUTUYKUWGUVLBUUEUHUSZVDZUVLUUGUOZ
      UVLDUOZGUOZUVCUUTUWGUXAUVLBUSUYRUYTUKUYPUXDUVLBUUEYJBCUVLGDXPYKUYQUYSIGUW
      GBCDUUEUVLIUXDUYDYMWKAUVHUWFUYPUVJVQYNYOUYFYDUYHVHYEYPYQYRYSAUUEYTUSUUFUU
      RUUATUUEUAUUBVNUUC $.
  $}

  ${
    gsummhm.b $e |- B = ( Base ` G ) $.
    gsummhm.z $e |- .0. = ( 0g ` G ) $.
    gsummhm.g $e |- ( ph -> G e. CMnd ) $.
    gsummhm.h $e |- ( ph -> H e. Mnd ) $.
    gsummhm.a $e |- ( ph -> A e. V ) $.
    gsummhm.k $e |- ( ph -> K e. ( G MndHom H ) ) $.
    gsummhm.f $e |- ( ph -> F : A --> B ) $.
    gsummhm.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Apply a group homomorphism to a group sum.  (Contributed by Mario
       Carneiro, 15-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsummhm $p |- ( ph -> ( H gsum ( K o. F ) ) = ( K ` ( G gsum F ) ) ) $=
      ( ccntz cfv wcel eqid ccmn cmnd cmnmnd syl cntzcmnf gsumzmhm ) ABCDEFGHIE
      RSZJUHUAZAEUBTEUCTLEUDUEMNOPABCDEUHJUILPUFKQUG $.
  $}

  ${
    $d k x A $.  $d k x B $.  $d k C $.  $d x D $.  $d x E $.  $d k ph $.
    $d x G $.  $d x H $.  $d x X $.
    gsummhm2.b $e |- B = ( Base ` G ) $.
    gsummhm2.z $e |- .0. = ( 0g ` G ) $.
    gsummhm2.g $e |- ( ph -> G e. CMnd ) $.
    gsummhm2.h $e |- ( ph -> H e. Mnd ) $.
    gsummhm2.a $e |- ( ph -> A e. V ) $.
    gsummhm2.k $e |- ( ph -> ( x e. B |-> C ) e. ( G MndHom H ) ) $.
    gsummhm2.f $e |- ( ( ph /\ k e. A ) -> X e. B ) $.
    gsummhm2.w $e |- ( ph ->
      ( `' ( k e. A |-> X ) " ( _V \ { .0. } ) ) e. Fin ) $.
    gsummhm2.1 $e |- ( x = X -> C = D ) $.
    gsummhm2.2 $e |- ( x = ( G gsum ( k e. A |-> X ) ) -> C = E ) $.
    $( Apply a group homomorphism to a group sum, mapping version with implicit
       substitution.  (Contributed by Mario Carneiro, 5-May-2015.) $)
    gsummhm2 $p |- ( ph -> ( H gsum ( k e. A |-> D ) ) = E ) $=
      ( cmpt ccom cgsu cfv eqid fmptd gsummhm eqidd fmptco oveq2d wcel cbs wceq
      co gsumcl wral wf cmhm mhmf syl fmpt sylibr cv eleq1d sylc fvmptg syl2anc
      rspcv 3eqtr3d ) AJBDEUDZGCLUDZUEZUFUQIVNUFUQZVMUGZJGCFUDZUFUQHACDVNIJVMKM
      NOPQRSAGCLDVNTVNUHUIZUAUJAVOVRJUFAGBCDLEFVNVMTAVNUKAVMUKUBULUMAVPDUNZHJUO
      UGZUNZVQHUPACDVNIKMNOPRVSUAURZAVTEWAUNZBDUSZWBWCADWAVMUTZWEAVMIJVAUQUNWFS
      DWAIJVMNWAUHVBVCBDWAEVMVMUHZVDVEWDWBBVPDBVFVPUPEHWAUCVGVKVHBVPEHDWAVMUCWG
      VIVJVL $.
  $}

  ${
    $d k x A $.  $d k x B $.  $d x G $.  $d k x N $.  $d k ph $.  $d k x .x. $.
    $d x X $.
    gsummulg.b $e |- B = ( Base ` G ) $.
    gsummulg.z $e |- .0. = ( 0g ` G ) $.
    gsummulg.t $e |- .x. = ( .g ` G ) $.
    gsummulg.a $e |- ( ph -> A e. V ) $.
    gsummulg.f $e |- ( ( ph /\ k e. A ) -> X e. B ) $.
    gsummulg.w $e |- ( ph ->
      ( `' ( k e. A |-> X ) " ( _V \ { .0. } ) ) e. Fin ) $.
    ${
      gsummulglem.g $e |- ( ph -> G e. CMnd ) $.
      gsummulglem.n $e |- ( ph -> N e. ZZ ) $.
      gsummulglem.o $e |- ( ph -> ( G e. Abel \/ N e. NN0 ) ) $.
      $( Lemma for ~ gsummulg and ~ gsummulgz .  (Contributed by Mario
         Carneiro, 7-Jan-2015.) $)
      gsummulglem $p |- ( ph -> ( G gsum ( k e. A |-> ( N .x. X ) ) ) =
                             ( N .x. ( G gsum ( k e. A |-> X ) ) ) ) $=
        ( wcel vx cv co cmpt cgsu ccmn cmnd cmnmnd syl cabel cmhm cz wi wa cghm
        cn0 mulgghm ghmmhm expcom mulgmhm ex mpjaod oveq2 gsummhm2 ) AUABCGUAUB
        ZDUCZGIDUCEGFEBIUDUEUCZDUCFFHIJKLQAFUFTZFUGTQFUHUINAFUJTZUACVFUDZFFUKUC
        TZGUPTZAGULTZVIVKUMRVIVMVKVIVMUNVJFFUOUCTVKUACDFGKMUQFFVJURUIUSUIAVHVLV
        KUMQVHVLVKUACDFGKMUTVAUISVBOPVEIGDVCVEVGGDVCVD $.
    $}

    ${
      gsummulg.g $e |- ( ph -> G e. CMnd ) $.
      gsummulg.n $e |- ( ph -> N e. NN0 ) $.
      $( Nonnegative multiple of a group sum.  (Contributed by Mario Carneiro,
         15-Dec-2014.)  (Revised by Mario Carneiro, 7-Jan-2015.) $)
      gsummulg $p |- ( ph -> ( G gsum ( k e. A |-> ( N .x. X ) ) ) =
                             ( N .x. ( G gsum ( k e. A |-> X ) ) ) ) $=
        ( nn0zd wcel cn0 cabel olcd gsummulglem ) ABCDEFGHIJKLMNOPQAGRSAGUATFUB
        TRUCUD $.
    $}

    ${
      gsummulgz.g $e |- ( ph -> G e. Abel ) $.
      gsummulgz.n $e |- ( ph -> N e. ZZ ) $.
      $( Integer multiple of a group sum.  (Contributed by Mario Carneiro,
         7-Jan-2015.) $)
      gsummulgz $p |- ( ph -> ( G gsum ( k e. A |-> ( N .x. X ) ) ) =
                             ( N .x. ( G gsum ( k e. A |-> X ) ) ) ) $=
        ( cabel wcel ccmn ablcmn syl cn0 orcd gsummulglem ) ABCDEFGHIJKLMNOPAFS
        TZFUATQFUBUCRAUGGUDTQUEUF $.
    $}
  $}

  ${
    $d f k x y .0. $.  $d k A $.  $d f k x y F $.  $d f k x y ph $.  $d k V $.
    $d f k x y G $.  $d f k x y O $.
    gsumzoppg.b $e |- B = ( Base ` G ) $.
    gsumzoppg.0 $e |- .0. = ( 0g ` G ) $.
    gsumzoppg.z $e |- Z = ( Cntz ` G ) $.
    gsumzoppg.o $e |- O = ( oppG ` G ) $.
    gsumzoppg.g $e |- ( ph -> G e. Mnd ) $.
    gsumzoppg.a $e |- ( ph -> A e. V ) $.
    gsumzoppg.f $e |- ( ph -> F : A --> B ) $.
    gsumzoppg.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    gsumzoppg.n $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( The opposite of a group sum is the same as the original.  (Contributed
       by Mario Carneiro, 25-Apr-2016.) $)
    gsumzoppg $p |- ( ph -> ( O gsum F ) = ( G gsum F ) ) $=
      ( cfv wcel vf vk vx vy ccnv cvv csn cdif cima c0 wceq cgsu co chash cn c1
      cfz cv wf1o wex wa cmpt cmnd oppgmnd syl oppgid syl2anc eqtr4d adantr wss
      gsumz ssid a1i gsumcllem oveq2d 3eqtr4d cplusg ccom cseq crn csubmnd cmrc
      ex cuz simprl nnuz syl6eleq wf wfo wfn ffn dffn4 sylib fof 3syl cacs cmre
      submacs acsmre eqid frn mrcssidd fss wf1 f1of1 ad2antll cnvimass syl5sseq
      cdm fdm f1ss f1f fco ffvelrnda mrccl oppgsubm submcl 3expb sylan cntzspan
      cress ccmn wb submcmn2 mpbid sselda cntzi oppgplus syl6reqr seqfeq4 ccntz
      anasss oppgbas oppgcntz syl6sseq f1ofo forn syl5sseqr gsumval3 expr cfn
      exlimdv expimpd wo fz1f1o mpjaod ) ADUEUFHUGUHZUIZUJUKZFDULUMZEDULUMZUKZU
      UHUNSZUOTZUPUUMUQUMZUUHUAURZUSZUAUTZVAZAUUIUULAUUIVAZFUBBHVBZULUMZEUVAULU
      MZUUJUUKAUVBUVCUKUUIAUVBHUVCAFVCTZBGTZUVBHUKAEVCTZUVDNEFMVDVEZOBUBFGHEFHM
      KVFZVKVGAUVFUVEUVCHUKNOBUBEGHKVKVGVHVIUUTDUVAFULABCUBDUUHHPUUHUUHVJAUUHVL
      ZVMVNZVOUUTDUVAEULUVJVOVPWCAUUNUURUULAUUNVAUUQUULUAAUUNUUQUULAUUNUUQVAZVA
      ZUUMFVQSZDUUPVRZUPVSSUUMEVQSZUVNUPVSSUUJUUKUVLUCUDUVMUVODVTZEWASZWBSZSZUV
      NUPUUMUVLUUMUOUPWDSAUUNUUQWEZWFWGUVLUUOUVSUCURZUVNUVLBUVSDWHZUUOBUUPWHZUU
      OUVSUVNWHUVLBUVPDWHZUVPUVSVJUWBUVLBCDWHZBUVPDWIZUWDAUWEUVKPVIZUWEDBWJUWFB
      CDWKBDWLWMBUVPDWNWOUVLUVQUVPUVRCUVLUVFUVQCWPSTUVQCWQSTZAUVFUVKNVIZCEJWRUV
      QCWSWOZUVRWTZUVLUWEUVPCVJZUWGBCDXAVEZXBBUVPUVSDXCVGUVLUUOBUUPXDZUWCUVLUUO
      UUHUUPXDZUUHBVJUWNUUQUWOAUUNUUOUUHUUPXEXFUVLDXIZUUHBDUUGXGUVLUWEUWPBUKUWG
      BCDXJVEXHUUOUUHBUUPXKVGZUUOBUUPXLVEUUOBUVSDUUPXMVGXNUVLUVSFWASZTZUWAUVSTZ
      UDURZUVSTZVAUWAUXAUVMUMZUVSTZUVLUVSUVQUWRUVLUWHUWLUVSUVQTZUWJUWMUVQUVPUVR
      CUWKXOVGZEFMXPWGUWSUWTUXBUXDUVMUVSFUWAUXAUVMWTZXQXRXSUVLUWTUXBUXCUWAUXAUV
      OUMZUKUVLUWTVAZUXBVAUXHUXAUWAUVOUMZUXCUXIUWAUVSISZTUXBUXHUXJUKUVLUVSUXKUW
      AUVLEUVSYAUMZYBTZUVSUXKVJZUVLUVFUVPUVPISZVJZUXMUWIAUXPUVKQVIZUVPEUXLUVRIL
      UWKUXLWTZXTVGUVLUXEUXMUXNYCUXFUVSEUXLIUXRLYDVEYEYFUVOUVSEUWAUXAIUVOWTZLYG
      XSUVOUVMEFUWAUXAUXSMUXGYHYIYLYJUVLBCUVMDFUUPUUMGUVNUEUUGUIZHFYKSZCEFMJYMU
      VHUXGUYAWTAUVDUVKUVGVIAUVEUVKOVIZUWGUVLUVPUXOUVPUYASUXQUVPEFIMLYNYOUVTUWQ
      UVLUUHUUHUUPVTZUVIUUQUYCUUHUKZAUUNUUQUUOUUHUUPWIUYDUUOUUHUUPYPUUOUUHUUPYQ
      VEXFYRZUXTWTZYSUVLBCUVODEUUPUUMGUXTHIJKUXSLUWIUYBUWGUXQUVTUWQUYEUYFYSVPYT
      UUBUUCAUUHUUATUUIUUSUUDRUUHUAUUEVEUUF $.
  $}

  ${
    $d x .0. $.  $d x F $.  $d x I $.  $d x ph $.
    gsumzinv.b $e |- B = ( Base ` G ) $.
    gsumzinv.0 $e |- .0. = ( 0g ` G ) $.
    gsumzinv.z $e |- Z = ( Cntz ` G ) $.
    gsumzinv.p $e |- I = ( invg ` G ) $.
    gsumzinv.g $e |- ( ph -> G e. Grp ) $.
    gsumzinv.a $e |- ( ph -> A e. V ) $.
    gsumzinv.f $e |- ( ph -> F : A --> B ) $.
    gsumzinv.c $e |- ( ph -> ran F C_ ( Z ` ran F ) ) $.
    gsumzinv.n $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Inverse of a group sum.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    gsumzinv $p |- ( ph -> ( G gsum ( I o. F ) ) = ( I ` ( G gsum F ) ) ) $=
      ( cfv wcel vx coppg ccom cgsu co eqid cgrp cmnd grpmnd syl wf grpinvf fco
      syl2anc crn cima ccntz cmhm wss cgim cghm invoppggim gimghm 4syl cntzmhm2
      ghmmhm rnco2 fveq2i oppgcntz eqtri 3sstr4g ccnv cvv csn cdif cv wa eldifi
      cfn wceq fvco3 syl2an ssid a1i suppssr fveq2d grpinvid adantr 3eqtrd ssfi
      suppss gsumzoppg oppgmnd gsumzmhm eqtr3d ) AEUBSZFDUCZUDUEEWQUDUEEDUDUEFS
      ABCWQEWPGHIJKLWPUFZAEUGTZEUHTZNEUIUJZOACCFUKZBCDUKZBCWQUKAWSXBNCEFJMULUJP
      BCCFDUMUNZAFDUOZUPZXFWPUQSZSZWQUOZXIISZAFEWPURUETZXEXEISUSXFXHUSAWSFEWPUT
      UETFEWPVAUETXKNEFWPWRMVBEWPFVCEWPFVFVDZQXEXEFEWPXGILXGUFVEUNFDVGZXJXFISXH
      XIXFIXMVHXFEWPIWRLVIVJVKADVLVMHVNVOZUPZVSTWQVLXNUPZXOUSXPVSTRABCUAWQXOHXD
      AUAVPZBXOVOTZVQZXQWQSZXQDSZFSZHFSZHAXCXQBTXTYBVTXRPXQBXOVRBCXQFDWAWBXSYAH
      FABCDXOXQHPXOXOUSAXOWCWDWEWFAYCHVTZXRAWSYDNEFHKMWGUJWHWIWKXOXPWJUNWLABCDE
      WPFGHIJLXAAWTWPUHTXAEWPWRWMUJOXLPQKRWNWO $.
  $}

  ${
    gsuminv.b $e |- B = ( Base ` G ) $.
    gsuminv.z $e |- .0. = ( 0g ` G ) $.
    gsuminv.p $e |- I = ( invg ` G ) $.
    gsuminv.g $e |- ( ph -> G e. Abel ) $.
    gsuminv.a $e |- ( ph -> A e. V ) $.
    gsuminv.f $e |- ( ph -> F : A --> B ) $.
    gsuminv.n $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Inverse of a group sum.  (Contributed by Mario Carneiro, 15-Dec-2014.)
       (Revised by Mario Carneiro, 4-May-2015.) $)
    gsuminv $p |- ( ph -> ( G gsum ( I o. F ) ) = ( I ` ( G gsum F ) ) ) $=
      ( cabel wcel ccmn syl co ablcmn cmnd cmnmnd cghm cmhm invghm sylib ghmmhm
      gsummhm ) ABCDEEFGHIJAEPQZERQZLEUASZAUKEUBQULEUCSMAFEEUDTQZFEEUETQAUJUMLC
      EFIKUFUGEEFUHSNOUI $.
  $}

  ${
    $d k .- $.  $d k .0. $.  $d k x B $.  $d k x G $.  $d k x H $.  $d k ph $.
    $d k A $.  $d k F $.
    gsumsub.b $e |- B = ( Base ` G ) $.
    gsumsub.z $e |- .0. = ( 0g ` G ) $.
    gsumsub.m $e |- .- = ( -g ` G ) $.
    gsumsub.g $e |- ( ph -> G e. Abel ) $.
    gsumsub.a $e |- ( ph -> A e. V ) $.
    gsumsub.f $e |- ( ph -> F : A --> B ) $.
    gsumsub.h $e |- ( ph -> H : A --> B ) $.
    gsumsub.fn $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumsub.hn $e |- ( ph -> ( `' H " ( _V \ { .0. } ) ) e. Fin ) $.
    $( The difference of two group sums.  (Contributed by Mario Carneiro,
       28-Dec-2014.) $)
    gsumsub $p |- ( ph ->
      ( G gsum ( F oF .- H ) ) = ( ( G gsum F ) .- ( G gsum H ) ) ) $=
      ( co wcel vk vx cminusg cfv ccom cplusg cof cgsu eqid cabel ablcmn syl wf
      ccmn wf1o cgrp ablgrp grpinvf1o f1of fco syl2anc ccnv cvv csn cdif cfn cv
      cima wss wceq eldifi fvco3 syl2an ssid a1i suppssr fveq2d grpinvid adantr
      wa eqtrd suppss ssfi gsumadd gsuminv oveq2d ffvelrnda grpsubval mpteq2dva
      cmpt feqmptd offval2 fvex fveq2 fmptco 3eqtr4d gsumcl ) AEDEUCUDZFUEZEUFU
      DZUGSZUHSZEDUHSZEFUHSZWRUDZWTSZEDFGUGSZUHSXCXDGSZAXBXCEWSUHSZWTSXFABCWTDE
      WSHIJKWTUIZAEUJTZEUNTMEUKULZNOACCWRUMZBCFUMZBCWSUMACCWRUOXMACEWRJWRUIZAXK
      EUPTZMEUQULZURCCWRUSULZPBCCWRFUTVAZQAFVBVCIVDVEZVHZVFTWSVBXTVHZYAVIYBVFTR
      ABCUAWSYAIXSAUAVGZBYAVETZVTZYCWSUDZYCFUDZWRUDZIAXNYCBTZYFYHVJYDPYCBYAVKBC
      YCWRFVLVMYEYHIWRUDZIYEYGIWRABCFYAYCIPYAYAVIAYAVNVOVPVQAYJIVJZYDAXPYKXQEWR
      IKXOVRULVSWAWAWBYAYBWCVAWDAXIXEXCWTABCFEWRHIJKXOMNPRWEWFWAAXGXAEUHAUABYCD
      UDZYGGSZWJUABYLYHWTSZWJXGXAAUABYMYNAYIVTZYLCTYGCTYMYNVJABCYCDOWGZABCYCFPW
      GZCWTEWRGYLYGJXJXOLWHVAWIAUABYLYGGDFHCCNYPYQAUABCDOWKZAUABCFPWKZWLAUABYLY
      HWTDWSHCVCNYPYHVCTYOYGWRWMVOYRAUAUBBCYGUBVGZWRUDYHFWRYQYSAUBCCWRXRWKYTYGW
      RWNWOWLWPWFAXCCTXDCTXHXFVJABCDEHIJKXLNOQWQABCFEHIJKXLNPRWQCWTEWRGXCXDJXJX
      OLWHVAWP $.
  $}

  ${
    $d k B $.  $d k C $.  $d k G $.  $d k M $.
    gsumsn.b $e |- B = ( Base ` G ) $.
    gsumsn.s $e |- ( k = M -> A = C ) $.
    $( Group sum of a singleton.  (Contributed by Mario Carneiro,
       19-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumsn $p |- ( ( G e. Mnd /\ M e. V /\ C e. B ) ->
      ( G gsum ( k e. { M } |-> A ) ) = C ) $=
      ( cmnd wcel w3a csn cmpt cgsu co chash cfv c1 wceq cmg elsni syl mpteq2ia
      cv oveq2i cfn snfi gsumconst mp3an2 3adant2 syl5eq hashsng 3ad2ant2 mulg1
      eqid oveq1d 3ad2ant3 3eqtrd ) EJKZFGKZCBKZLZEDFMZANZOPZVDQRZCEUARZPZSCVHP
      ZCVCVFEDVDCNZOPZVIVEVKEODVDACDUEZVDKVMFTACTVMFUBIUCUDUFUTVBVLVITZVAUTVDUG
      KVBVNFUHVDBVHDECHVHUPZUIUJUKULVCVGSCVHVAUTVGSTVBFGUMUNUQVBUTVJCTVABVHECHV
      OUOURUS $.
  $}

  ${
    $d k A $.  $d k B $.  $d k G $.  $d k M $.  $d k ph $.  $d k Y $.
    gsumunsn.b $e |- B = ( Base ` G ) $.
    gsumunsn.p $e |- .+ = ( +g ` G ) $.
    gsumunsn.g $e |- ( ph -> G e. CMnd ) $.
    gsumunsn.a $e |- ( ph -> A e. Fin ) $.
    gsumunsn.f $e |- ( ( ph /\ k e. A ) -> X e. B ) $.
    gsumunsn.m $e |- ( ph -> M e. V ) $.
    gsumunsn.d $e |- ( ph -> -. M e. A ) $.
    gsumunsn.y $e |- ( ph -> Y e. B ) $.
    gsumunsn.s $e |- ( k = M -> X = Y ) $.
    $( Append an element to a finite group sum.  (Contributed by Mario
       Carneiro, 19-Dec-2014.) $)
    gsumunsn $p |- ( ph -> ( G gsum ( k e. ( A u. { M } ) |-> X ) ) =
      ( ( G gsum ( k e. A |-> X ) ) .+ Y ) ) $=
      ( wcel csn cun cmpt cgsu co cfn c0g cfv eqid snfi unfi sylancl cv wo elun
      wa wceq elsni syl adantl adantr eqeltrd jaodan sylan2b ccnv cvv cdif cima
      wss cdm cnvimass dmmptss sstri ssfi wn cin disjsn sylibr eqidd gsumsplit2
      c0 cmnd ccmn cmnmnd gsumsn syl3anc oveq2d eqtrd ) AFEBGUAZUBZIUCZUDUEFEBI
      UCUDUEZFEWIIUCUDUEZDUEWLJDUEAWJCBWIDEFUFIFUGUHZKWNUILMABUFTWIUFTWJUFTZNGU
      JBWIUKULZEUMZWJTAWQBTZWQWITZUNICTZWQBWIUOAWRWTWSOAWSUPIJCWSIJUQZAWSWQGUQX
      AWQGURSUSUTAJCTZWSRVAVBVCVDAWOWKVEVFWNUAVGZVHZWJVIXDUFTWPXDWKVJWJWKXCVKEW
      JIWKWKUIVLVMWJXDVNULAGBTVOBWIVPWAUQQBGVQVRAWJVSVTAWMJWLDAFWBTZGHTXBWMJUQA
      FWCTXEMFWDUSPRICJEFGHKSWEWFWGWH $.
  $}

  ${
    $d a A $.  $d a B $.  $d a F $.  $d a G $.  $d a ph $.  $d a X $.
    gsumpt.b $e |- B = ( Base ` G ) $.
    gsumpt.z $e |- .0. = ( 0g ` G ) $.
    gsumpt.g $e |- ( ph -> G e. Mnd ) $.
    gsumpt.a $e |- ( ph -> A e. V ) $.
    gsumpt.x $e |- ( ph -> X e. A ) $.
    gsumpt.f $e |- ( ph -> F : A --> B ) $.
    gsumpt.s $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) C_ { X } ) $.
    $( Sum of a family that is nonzero at at most one point.  (Contributed by
       Stefan O'Rear, 7-Feb-2015.)  (Revised by Mario Carneiro,
       25-Apr-2016.) $)
    gsumpt $p |- ( ph -> ( G gsum F ) = ( F ` X ) ) $=
      ( va co cfv wss wcel csn cres cgsu cmpt snssd feqresmpt oveq2d ccntz eqid
      cv csubmnd cmrc cress ccmn cmnd cplusg wceq ffvelrnd eqidd wa wb elcntzsn
      crn syl mpbir2and cntzspan syl2anc cmre cacs submacs acsmre 3syl submcmn2
      mrccl mpbid wfn wral ffn simpr fveq2d mrcssidd fvex snss ad2antrr eqeltrd
      wf sylibr cdif eldifsn suppssr sylan2br subm0cl adantr anassrs pm2.61dane
      wne ralrimiva ffnfv sylanbrc frn cntzidss cfn ccnv cima snfi ssfi sylancr
      cvv gsumzres fveq2 gsumsn syl3anc 3eqtr3d ) AEDGUAZUBZUCQEPXNPUJZDRZUDZUC
      QZEDUCQGDRZAXOXREUCAPBCXNDNAGBMUEUFUGABCDEFXNHEUHRZIJYAUIZKLNAXTUAZEUKRZU
      LRZRZYFYARSZDVCZYFSZYHYHYARSAEYFUMQZUNTZYGAEUOTZYCYCYARZSYKKAXTYMAXTYMTZX
      TCTZXTXTEUPRZQZYQUQZABCGDNMURZAYQUSAYOYNYOYRUTVAYSCYPEXTXTYAIYPUIYBVBVDVE
      UEYCEYJYEYAYBYEUIZYJUIZVFVGAYFYDTZYKYGVAAYDCVHRTZYCCSUUBAYLYDCVIRTUUCKCEI
      VJYDCVKVLZAXTCYSUEZYDYCYECYTVNVGZYFEYJYAUUAYBVMVDVOABYFDWFZYIADBVPZXQYFTZ
      PBVQUUGABCDWFUUHNBCDVRVDAUUIPBAXPBTZUTZUUIXPGUUKXPGUQZUTZXQXTYFUUMXPGDUUK
      UULVSVTAXTYFTZUUJUULAYCYFSUUNAYDYCYECUUDYTUUEWAXTYFGDWBWCWGWDWEAUUJXPGWPZ
      UUIAUUJUUOUTZUTXQHYFUUPAXPBXNWHTXQHUQXPBGWIABCDXNXPHNOWJWKAHYFTZUUPAUUBUU
      QUUFYFEHJWLVDWMWEWNWOWQPBYFDWRWSBYFDWTVDYFYHEYAYBXAVGOAXNXBTDXCXHHUAWHXDZ
      XNSUURXBTGXEOXNUURXFXGXIAYLGBTYOXSXTUQKMYSXQCXTPEGBIXPGDXJXKXLXM $.
  $}

  ${
    $d j k x y z A $.  $d j k x y z F $.  $d j k x y z G $.  $d j k x y z ph $.
    $d j k B $.  $d j k D $.  $d j k x y z .0. $.
    gsum2d.b $e |- B = ( Base ` G ) $.
    gsum2d.z $e |- .0. = ( 0g ` G ) $.
    gsum2d.g $e |- ( ph -> G e. CMnd ) $.
    gsum2d.a $e |- ( ph -> A e. V ) $.
    gsum2d.r $e |- ( ph -> Rel A ) $.
    gsum2d.d $e |- ( ph -> D e. W ) $.
    gsum2d.s $e |- ( ph -> dom A C_ D ) $.
    gsum2d.f $e |- ( ph -> F : A --> B ) $.
    gsum2d.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Write a sum over a two-dimensional region as a double sum.  (Contributed
       by Mario Carneiro, 28-Dec-2014.) $)
    gsum2d $p |- ( ph -> ( G gsum F ) = ( G gsum
      ( j e. D |-> ( G gsum ( k e. ( A " { j } ) |-> ( j F k ) ) ) ) ) ) $=
      ( vx vy vz ccnv cvv csn cdif cima cdm cres cgsu co cv cmpt wcel wceq dmfi
      cfn syl wi c0 cun reseq2 res0 syl6eq reseq2d oveq2d mpteq1 eqeq12d imbi2d
      mpt0 weq eqidd wel wn wa cplusg cfv oveq1 eqid adantr resexg wf wss resss
      ccmn fssres sylancl imass1 mp2b ssfi simprr disjsn sylibr resindi 3eqtr3g
      cnvss cin resundi a1i gsumsplit ssun1 ssres2 resabs1 oveq2i ssun2 oveq12i
      simprl imaexg cop vex elimasn df-ov ffvelrnda syl5eqel sylan2b fmptd rnfi
      crn biimpi opelrn con3i anim12i eldif 3imtr4i ssid suppss2 syl2anc chvarv
      c2nd cxp mp1i eqtrd feqmptd reseq1d resmpt ax-mp ssv wrel gsumres suppssr
      syl5eq sylan2 gsumcl ad2antrr sneq imaeq2d mpteq12dv eleq1d gsumunsn ccom
      2ndconst gsumf1o 1st2nd2 xp1st elsni opeq1d fveq2d syl6eqr mpteq2ia ressn
      wf1o eqtri xp2nd adantl wfo fo2nd fof oveq2 fmptco 3eqtr4a eqtr4d syl5ibr
      c1st expcom findcard2s mpcom cnvimass syl5sseq relss sylc relssdmrn xpss2
      a2d fdm syl6ss ssind df-res syl6sseqr dmss sstrd ad2antll eldifn ad2antrl
      opeldm nsyl eldifd syldan anassrs mpteq2dva cmnmnd gsumz eqtr3d 3eqtr3d
      cmnd ) AHGBGUDZUEKUFUGZUHZUIZUJZUJZUKULZHEUXIHFBEUMZUFZUHZUXMFUMZGULZUNZU
      KULZUNZUKULZHGUKULHEDUXSUNZUKULZUXIURUOZAUXLUYAUPZAUXHURUOZUYDTUXHUQUSZAH
      GBUAUMZUJZUJZUKULZHEUYHUXSUNZUKULZUPZUTAHVAUKULZUYOUPZUTAHGBUBUMZUJZUJZUK
      ULZHEUYQUXSUNZUKULZUPZUTAHGBUYQUCUMZUFZVBZUJZUJZUKULZHEVUFUXSUNZUKULZUPZU
      TAUYEUTUAUBUCUXIUYHVAUPZUYNUYPAVUMUYKUYOUYMUYOVUMUYJVAHUKVUMUYJGVAUJVAVUM
      UYIVAGVUMUYIBVAUJZVAUYHVABVCBVDZVEVFGVDVEVGVUMUYLVAHUKVUMUYLEVAUXSUNVAEUY
      HVAUXSVHEUXSVKVEVGVIVJUAUBVLZUYNVUCAVUPUYKUYTUYMVUBVUPUYJUYSHUKVUPUYIUYRG
      UYHUYQBVCVFVGVUPUYLVUAHUKEUYHUYQUXSVHVGVIVJUYHVUFUPZUYNVULAVUQUYKVUIUYMVU
      KVUQUYJVUHHUKVUQUYIVUGGUYHVUFBVCVFVGVUQUYLVUJHUKEUYHVUFUXSVHVGVIVJUYHUXIU
      PZUYNUYEAVURUYKUXLUYMUYAVURUYJUXKHUKVURUYIUXJGUYHUXIBVCVFVGVURUYLUXTHUKEU
      YHUXIUXSVHVGVIVJAUYOVMUYQURUOZUCUBVNVOZVPZAVUCVULAVVAVUCVULUTVUCVULAVVAVP
      ZUYTHGBVUEUJZUJZUKULZHVQVRZULZVUBVVEVVFULZUPUYTVUBVVEVVFVSVVBVUIVVGVUKVVH
      VVBVUIHVUHUYRUJZUKULZHVUHVVCUJZUKULZVVFULVVGVVBVUGCUYRVVCVVFVUHHUEKLMVVFV
      TZAHWFUOZVVANWAZAVUGUEUOZVVAABIUOZVVPOBVUFIWBUSWAAVUGCVUHWCZVVAABCGWCZVUG
      BWDVVRSBVUFWEBCVUGGWGWHWAAVUHUDZUXGUHZURUOZVVAAUYFVWAUXHWDZVWBTVUHGWDVVTU
      XFWDVWCGVUGWEVUHGWQVVTUXFUXGWIWJUXHVWAWKWHWAVVBBUYQVUEWRZUJVUNUYRVVCWRVAV
      VBVWDVABVVBVUTVWDVAUPAVUSVUTWLZUYQVUDWMWNVFBUYQVUEWOVUOWPVUGUYRVVCVBUPVVB
      BUYQVUEWSWTXAVVJUYTVVLVVEVVFVVIUYSHUKUYQVUFWDUYRVUGWDVVIUYSUPUYQVUEXBUYQV
      UFBXCGUYRVUGXDWJXEVVKVVDHUKVUEVUFWDVVCVUGWDVVKVVDUPVUEUYQXFVUEVUFBXCGVVCV
      UGXDWJXEXGVEVVBVUKVUBHFBVUEUHZVUDUXPGULZUNZUKULZVVFULVVHVVBUYQCVVFEHVUDUE
      UXSVWILVVMVVOAVUSVUTXHAUXSCUOZVVAEUBVNAUXOCUXRHUEKLMNAVVQUXOUEUOZOBUXNIXI
      USZAFUXOUXQCUXRUXPUXOUOZAUXMUXPXJZBUOZUXQCUOBUXMUXPEXKZFXKZXLZAVWOVPUXQVW
      NGVRZCUXMUXPGXMZABCVWNGSXNXOXPUXRVTXQZAUXHXSZURUOZUXRUDUXGUHZVXBWDVXDURUO
      AUYFVXCTUXHXRUSAUXOUXQFVXBKUXPUXOVXBUGUOZAVWNBUXHUGUOZUXQKUPZVWMUXPVXBUOZ
      VOZVPVWOVWNUXHUOZVOZVPVXEVXFVWMVWOVXIVXKVWMVWOVWRXTZVXJVXHUXMUXPUXHVWPVWQ
      YAYBYCUXPUXOVXBYDVWNBUXHYDYEAVXFVPUXQVWSKVWTABCGUXHVWNKSUXHUXHWDAUXHYFWTU
      UAUUBZUUCYGVXBVXDWKYHZUUDZUUEVUDUEUOVVBUCXKWTVWEAVWICUOZVVAAVWJUTAVXPUTEU
      CEUCVLZVWJVXPAVXQUXSVWICVXQUXRVWHHUKVXQFUXOUXQVWFVWGVXQUXNVUEBUXMVUDUUFZU
      UGUXMVUDUXPGVSUUHVGZUUIVJVXOYIWAVXSUUJVVBVWIVVEVUBVVFAVWIVVEUPZVVAAUXSHGB
      UXNUJZUJZUKULZUPZUTAVXTUTEUCVXQVYDVXTAVXQUXSVWIVYCVVEVXSVXQVYBVVDHUKVXQVY
      AVVCGVXQUXNVUEBVXRVFVFVGVIVJAUXSHUXRYJUXNUXOYKZUJZUUKZUKULVYCAUXOCVYEUXRH
      VYFUEKLMNVWLVXAVXNUXMUEUOVYEUXOVYFUVBAVWPUXMUXOUEUULYLUUMAVYBVYGHUKAUAVYE
      UYHGVRZUNZUAVYEUXMUYHYJVRZGULZUNVYBVYGUAVYEVYHVYKUYHVYEUOZVYHUXMVYJXJZGVR
      VYKVYLUYHVYMGVYLUYHUYHUVNVRZVYJXJVYMUYHUXNUXOUUNVYLVYNUXMVYJVYLVYNUXNUOVY
      NUXMUPUYHUXNUXOUUOVYNUXMUUPUSUUQYMUURUXMVYJGXMUUSUUTAVYBUABVYHUNZVYAUJZVY
      IAGVYOVYAAUABCGSYNYOVYPUAVYAVYHUNZVYIVYABWDVYPVYQUPBUXNWEUABVYAVYHYPYQVYA
      VYEUPVYQVYIUPBUXMUVAUAVYAVYEVYHVHYQUVCVEAUAFVYEUXOVYJUXQVYKVYFUXRVYLVYJUX
      OUOAUYHUXNUXOUVDUVEAVYFUAUEVYJUNZVYEUJZUAVYEVYJUNZAYJVYRVYEAUAUEUEYJUEUEY
      JUVFUEUEYJWCAUVGUEUEYJUVHYLYNYOVYEUEWDVYSVYTUPVYEYRUAUEVYEVYJYPYQVEAUXRVM
      UXPVYJUXMGUVIUVJUVKVGUVLYIWAVGYMVIUVMUVOUWDUVPUVQABCGHIUXJKLMNOSAUXHBUXIU
      EYKZWRUXJAUXHBWUAAGUIZUXHBGUXGUVRAVVSWUBBUPSBCGUWEUSUVSZAUXHYSZUXHWUAWDAU
      XHBWDZBYSWUDWUCPUXHBUVTUWAWUDUXHUXIVXBYKZWUAUXHUWBVXBUEWDWUFWUAWDVXBYRVXB
      UEUXIUWCYQUWFUSUWGBUXIUWHUWITYTAHUYBUXIUJZUKULUYAUYCAWUGUXTHUKAUXIDWDWUGU
      XTUPAUXIBUIZDAWUEUXIWUHWDWUCUXHBUWJUSRUWKEDUXIUXSYPUSVGADCUYBHJUXIKLMNQAE
      DUXSCUYBAVWJUXMDUOVXOWAUYBVTXQADUXSEUXIKAUXMDUXIUGUOZVPZUXSHFUXOKUNZUKULZ
      KWUJUXRWUKHUKWUJFUXOUXQKAWUIVWMVXGAWUIVWMVPZVXFVXGAWUMVPZVWNBUXHVWMVWOAWU
      IVXLUWLWUNUXMUXIUOZVXJWUIWUOVOAVWMUXMDUXIUWMUWNUXMUXPUXHVWPVWQUWOUWPUWQVX
      MUWRUWSUWTVGAWULKUPZWUIAHUXEUOZVWKWUPAVVNWUQNHUXAUSVWLUXOFHUEKMUXBYHWAYMY
      GZAUYDUYBUDUXGUHZUXIWDWUSURUOUYGWURUXIWUSWKYHYTUXCUXD $.
  $}

  ${
    $d j k m n B $.  $d j k x y z D $.  $d j x y z E $.  $d j k m n x y z ph $.
    $d j k m n x y z A $.  $d j k m n x G $.  $d j k z U $.  $d m n x y z X $.
    $d k m n x y z C $.  $d j V $.  $d j k m n x z .0. $.
    gsum2d2.b $e |- B = ( Base ` G ) $.
    gsum2d2.z $e |- .0. = ( 0g ` G ) $.
    gsum2d2.g $e |- ( ph -> G e. CMnd ) $.
    gsum2d2.a $e |- ( ph -> A e. V ) $.
    gsum2d2.r $e |- ( ( ph /\ j e. A ) -> C e. W ) $.
    gsum2d2.f $e |- ( ( ph /\ ( j e. A /\ k e. C ) ) -> X e. B ) $.
    gsum2d2.u $e |- ( ph -> U e. Fin ) $.
    gsum2d2.n $e |- ( ( ph /\ ( ( j e. A /\ k e. C ) /\ -. j U k ) )
                      -> X = .0. ) $.
    $( Lemma for ~ gsum2d2 : show the function is finitely supported.
       (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    gsum2d2lem $p |- ( ph ->
      ( `' ( j e. A , k e. C |-> X ) " ( _V \ { .0. } ) ) e. Fin ) $=
      ( vz cfn wcel cmpt2 ccnv cvv csn cdif cima wss cv ciun wral wf ralrimivva
      cxp eqid fmpt2x sylib wa cop wceq wex cfv relxp rgenw reliun mpbir eldifi
      wrel adantl elrel sylancr nfv nfiu1 nfcv nfdif nfcri nfan nfmpt21 nfmpt22
      nffv nfeq1 simprr fveq2d co df-ov simprl eqeltrrd opeliunxp simpld simprd
      eldifad syldan ovmpt4g syl3anc syl5eqr wbr eldifn ad2antrl eleq1d syl6bbr
      wn df-br mtbid jca 3eqtrd expr exlimd mpd suppss ssfi syl2anc ) AEUBUCFGB
      DKUDZUEUFLUGUHUIZEUJXOUBUCSAFBFUKZUGZDUPZULZCUAXNELAKCUCZGDUMFBUMXSCXNUNA
      XTFGBDRUOFGBDKCXNXNUQZURUSAUAUKZXSEUHZUCZUTZYBXPGUKZVAZVBZGVCZFVCZYBXNVDZ
      LVBZYEXSVJZYBXSUCZYJYMXRVJZFBUMYOFBXQDVEVFFBXRVGVHYDYNAYBXSEVIVKFGYBXSVLV
      MYEYIYLFAYDFAFVNFUAYCFXSEFBXRVOFEVPVQVRVSFYKLFYBXNFGBDKVTFYBVPWBWCYEYHYLG
      YEGVNGYKLGYBXNFGBDKWAGYBVPWBWCAYDYHYLAYDYHUTZUTZYKYGXNVDZKLYQYBYGXNAYDYHW
      DZWEYQYRXPYFXNWFZKXPYFXNWGYQXPBUCZYFDUCZXTYTKVBYQUUAUUBYQYGXSUCUUAUUBUTZY
      QYGXSEYQYBYGYCYSAYDYHWHWIWMFBDYFWJUSZWKYQUUAUUBUUDWLAYPUUCXTUUDRWNFGBDKXN
      CYAWOWPWQAYPUUCXPYFEWRZXCZUTKLVBYQUUCUUFUUDYQYBEUCZUUEYDUUGXCAYHYBXSEWSWT
      YQUUGYGEUCUUEYQYBYGEYSXAXPYFEXDXBXEXFTWNXGXHXIXIXJXKEXOXLXM $.

    $( Write a group sum over a two-dimensional region as a double sum.  (Note
       that ` C ( j ) ` is a function of ` j ` .)  (Contributed by Mario
       Carneiro, 28-Dec-2014.) $)
    gsum2d2 $p |- ( ph -> ( G gsum ( j e. A , k e. C |-> X ) ) =
      ( G gsum ( j e. A |-> ( G gsum ( k e. C |-> X ) ) ) ) ) $=
      ( vm vn vx vy cmpt2 cgsu co cv csn cxp ciun cima cmpt cvv wcel wral xpexg
      wa snex sylancr ralrimiva iunexg syl2anc relxp rgenw reliun mpbir a1i cdm
      wrel cop wex vex eldm2 eliunxp opth1 ad2antrl simprrl eqeltrd ex exlimdvv
      wceq syl5bi exlimdv ssrdv wf ralrimivva eqid fmpt2x sylib gsum2d2lem nfcv
      gsum2d nfiu1 nfima nfmpt21 nfov nfmpt sneq imaeq2d oveq1 mpteq12dv oveq2d
      cbvmpt elimasn opeliunxp bitri eqrdv mpteq1d nfmpt22 syl6eq adantl simprl
      baib oveq2 simprr ovmpt4g syl3anc anassrs mpteq2dva eqtrd syl5eq ) AHFGBD
      KUEZUFUGHUABHUBFBFUHZUIZDUJZUKZUAUHZUIZULZYHUBUHZYCUGZUMZUFUGZUMZUFUGHFBH
      GDKUMZUFUGZUMZUFUGAYGCBUAUBYCHUNILMNOABIUOYFUNUOZFBUPYGUNUOPAYSFBAYDBUOZU
      RZYEUNUODJUOYSYDUSQYEDUNJUQUTVAFBYFIUNVBVCYGVJZAUUBYFVJZFBUPUUCFBYEDVDVEF
      BYFVFVGVHPAUCYGVIZBUCUHZUUDUOUUEUDUHZVKZYGUOZUDVLAUUEBUOZUDUUEYGUCVMZVNAU
      UHUUIUDUUHUUGYDGUHZVKZWBZYTUUKDUOZURZURZGVLFVLAUUIFGBDUUGVOAUUPUUIFGAUUPU
      UIAUUPURUUEYDBUUMUUEYDWBAUUOUUEUUFYDUUKUUJUDVMVPVQAUUMYTUUNVRVSVTWAWCWDWC
      WEAKCUOZGDUPFBUPYGCYCWFAUUQFGBDRWGFGBDKCYCYCWHZWIWJABCDEFGHIJKLMNOPQRSTWK
      WMAYOYRHUFAYOFBHUBYGYEULZYDYKYCUGZUMZUFUGZUMYRUAFBYNUVBFHYMUFFHWLFUFWLFUB
      YJYLFYGYIFBYFWNFYIWLWOFYHYKYCFYHWLFGBDKWPFYKWLWQWRWQUAUVBWLYHYDWBZYMUVAHU
      FUVCUBYJYLUUSUUTUVCYIYEYGYHYDWSWTYHYDYKYCXAXBXCXDAFBUVBYQUUAUVAYPHUFUUAUV
      AGDYDUUKYCUGZUMZYPYTUVAUVEWBAYTUVAUBDUUTUMUVEYTUBUUSDUUTYTGUUSDUUKUUSUOZY
      TUUNUVFUULYGUOUUOYGYDUUKFVMGVMXEFBDUUKXFXGXNXHXIUBGDUUTUVDGYDYKYCGYDWLFGB
      DKXJGYKWLWQUBUVDWLYKUUKYDYCXOXDXKXLUUAGDUVDKAYTUUNUVDKWBZAUUOURYTUUNUUQUV
      GAYTUUNXMAYTUUNXPRFGBDKYCCUURXQXRXSXTYAXCXTYBXCYA $.

    gsumcom2.d $e |- ( ph -> D e. Y ) $.
    gsumcom2.c $e |- ( ph ->
      ( ( j e. A /\ k e. C ) <-> ( k e. D /\ j e. E ) ) ) $.
    $( Two-dimensional commutation of a group sum.  Note that while ` A ` and
       ` D ` are constants w.r.t. ` j , k ` , ` C ( j ) ` and ` E ( k ) ` are
       not.  (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    gsumcom2 $p |- ( ph -> ( G gsum ( j e. A , k e. C |-> X ) ) =
      ( G gsum ( k e. D , j e. E |-> X ) ) ) $=
      ( vz vx vy cmpt2 cgsu co cv csn cxp ciun ccnv cuni cmpt ccom wcel wral wa
      cvv snex xpexg sylancr ralrimiva iunexg syl2anc wf ralrimivva eqid fmpt2x
      sylib gsum2d2lem wf1o wrel relxp rgenw reliun mpbir cnvf1o wceq wb relcnv
      ax-mp cop nfv nfiu1 nfcnv nfel2 nfbi nfim weq opeq2 eleq1d bibi12d imbi2d
      wi opeq1 opeliunxp 3bitr4g vex opelcnv syl6bbr eqrelrdv f1oeq3 syl mpbiri
      chvar gsumf1o cfv csb cnveqd unieqd opswap syl6eq fveq2d syl6eqr mpt2mptx
      sneq nfcv nfcsb1v nfxp csbeq1a xpeq12d cbviun mpteq1 nfmpt22 nfov nfmpt21
      df-ov oveq2 oveq1 sylan9eq cbvmpt2x 3eqtr4i f1of fmpt sylibr eqidd w3a ex
      feqmptd fveq2 fmptcof ovmpt4g 3expia sylcom sylbird 3impib eqcomd 3eqtr4a
      mpt2eq3dva oveq2d eqtrd ) AJGHBDMUIZUJUKJUUQUFHEHULZUMZIUNZUOZUFULZUMZUPZ
      UQZURZUSZUJUKJHGEIMUIZUJUKAGBGULZUMZDUNZUOZCUVAUUQJUVFVCOPQRABKUTUVKVCUTZ
      GBVAUVLVCUTSAUVMGBAUVIBUTZVBUVJVCUTDLUTUVMUVIVDTUVJDVCLVEVFVGGBUVKKVCVHVI
      AMCUTZHDVAGBVAUVLCUUQVJAUVOGHBDUAVKGHBDMCUUQUUQVLZVMVNZABCDFGHJKLMOPQRSTU
      AUBUCVOAUVAUVLUVFVPZUVAUVAUPZUVFVPZUVAVQZUVTUWAUUTVQZHEVAUWBHEUUSIVRVSHEU
      UTVTWAUFUVAWBWFAUVLUVSWCUVRUVTWDAUGUHUVLUVSUVLVQUVKVQZGBVAUWCGBUVJDVRVSGB
      UVKVTWAUVAWEAUGULZUURWGZUVLUTZUWEUVSUTZWDZWSZAUWDUHULZWGZUVLUTZUWKUVSUTZW
      DZWSHUHAUWNHAHWHUWLUWMHUWLHWHHUWKUVSHUVAHEUUTWIWJWKWLWMHUHWNZUWHUWNAUWOUW
      FUWLUWGUWMUWOUWEUWKUVLUURUWJUWDWOZWPUWOUWEUWKUVSUWPWPWQWRAUVIUURWGZUVLUTZ
      UWQUVSUTZWDZWSUWIGUGAUWHGAGWHUWFUWGGGUWEUVLGBUVKWIWKUWGGWHWLWMGUGWNZUWTUW
      HAUXAUWRUWFUWSUWGUXAUWQUWEUVLUVIUWDUURWTZWPUXAUWQUWEUVSUXBWPWQWRAUWRUURUV
      IWGUVAUTZUWSAUVNUURDUTZVBZUUREUTZUVIIUTZVBZUWRUXCUEGBDUURXAHEIUVIXAXBUVIU
      URUVAGXCHXCXDXEXJXJXFUVLUVSUVAUVFXGXHXIZXKAUVGUVHJUJAUFUVAUVEUUQXLZURZHGE
      IUVIUURUUQUKZUIZUVGUVHUFUGEUWDUMZHUWDIXMZUNZUOZUXJURZUGUHEUXOUWJUWDUUQUKZ
      UIUXKUXMUGUHUFEUXOUXJUXSUVBUWKWCZUXJUWJUWDWGZUUQXLUXSUXTUVEUYAUUQUXTUVEUW
      KUMZUPZUQUYAUXTUVDUYCUXTUVCUYBUVBUWKYAXNXOUWDUWJXPXQXRUWJUWDUUQYLXSXTUVAU
      XQWCUXKUXRWCHUGEUUTUXPUGUUTYBHUXNUXOHUXNYBHUWDIYCZYDHUGWNZUUSUXNIUXOUURUW
      DYAHUWDIYEZYFYGUFUVAUXQUXJYHWFHGUGUHEIUXLUXOUXSUGIYBUYDUGUXLYBUHUXLYBHUWJ
      UWDUUQHUWJYBGHBDMYIHUWDYBYJGUWJUWDUUQGUWJYBGHBDMYKGUWDYBYJUYFUYEGUHWNUXLU
      VIUWDUUQUKUXSUURUWDUVIUUQYMUVIUWJUWDUUQYNYOYPYQAUFUGUVAUVLUVEUWDUUQXLUXJU
      VFUUQAUVAUVLUVFVJZUVEUVLUTUFUVAVAAUVRUYGUXIUVAUVLUVFYRXHUFUVAUVLUVEUVFUVF
      VLYSYTAUVFUUAAUGUVLCUUQUVQUUDUWDUVEUUQUUEUUFAHGEIMUXLAUXFUXGUUBUXLMAUXFUX
      GUXLMWCZAUXHUXEUYHUEAUXEUVOUYHAUXEUVOUAUUCUVNUXDUVOUYHGHBDMUUQCUVPUUGUUHU
      UIUUJUUKUULUUNUUMUUOUUP $.
  $}

  ${
    $d j k m n x z .0. $.  $d j k m n x G $.  $d j k m n z ph $.  $d j k z U $.
    $d j k m n x y z A $.  $d j k m n B $.  $d j k m n x y z C $.  $d j k F $.
    $d j m V $.  $d m n x y z X $.
    gsumxp.b $e |- B = ( Base ` G ) $.
    gsumxp.z $e |- .0. = ( 0g ` G ) $.
    gsumxp.g $e |- ( ph -> G e. CMnd ) $.
    gsumxp.a $e |- ( ph -> A e. V ) $.
    gsumxp.r $e |- ( ph -> C e. W ) $.
    ${
      gsumxp.f $e |- ( ph -> F : ( A X. C ) --> B ) $.
      gsumxp.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
      $( Write a group sum over a cartesian product as a double sum.
         (Contributed by Mario Carneiro, 28-Dec-2014.) $)
      gsumxp $p |- ( ph -> ( G gsum F ) = ( G gsum
        ( j e. A |-> ( G gsum ( k e. C |-> ( j F k ) ) ) ) ) ) $=
        ( cgsu co cxp cv csn cima cmpt cvv wcel xpexg syl2anc relxp a1i cdm wss
        wrel dmxpss gsum2d wa cres crn df-ima cin df-res inxp eqtri simpr snssd
        wceq sseqin2 sylib inv1 xpeq12d syl5eq rneqd c0 wne vex snnz rnxp ax-mp
        syl6eq mpteq1d oveq2d mpteq2dva eqtrd ) AHGSTHEBHFBDUAZEUBZUCZUDZWFFUBG
        TZUEZSTZUEZSTHEBHFDWIUEZSTZUEZSTAWECBEFGHUFIKLMNABIUGDJUGWEUFUGOPBDIJUH
        UIWEUNABDUJUKOWEULBUMABDUOUKQRUPAWLWOHSAEBWKWNAWFBUGZUQZWJWMHSWQFWHDWIW
        QWHWEWGURZUSZDWEWGUTWQWSWGDUAZUSZDWQWRWTWQWRBWGVAZDUFVAZUAZWTWRWEWGUFUA
        VAXDWEWGVBBDWGUFVCVDWQXBWGXCDWQWGBUMXBWGVGWQWFBAWPVEVFWGBVHVIXCDVGWQDVJ
        UKVKVLVMWGVNVOXADVGWFEVPVQWGDVRVSVTVLWAWBWCWBWD $.
    $}

    gsumcom.f $e |- ( ( ph /\ ( j e. A /\ k e. C ) ) -> X e. B ) $.
    gsumcom.u $e |- ( ph -> U e. Fin ) $.
    gsumcom.n $e |- ( ( ph /\ ( ( j e. A /\ k e. C ) /\ -. j U k ) )
                      -> X = .0. ) $.
    $( Commute the arguments of a double sum.  (Contributed by Mario Carneiro,
       28-Dec-2014.) $)
    gsumcom $p |- ( ph -> ( G gsum ( j e. A , k e. C |-> X ) ) =
      ( G gsum ( k e. C , j e. A |-> X ) ) ) $=
      ( wcel cv adantr wa wb ancom a1i gsumcom2 ) ABCDDEFGBHIJKJLMNOPADJUAFUBBU
      AZQUCRSTQUIGUBDUAZUDUJUIUDUEAUIUJUFUGUH $.
  $}

  ${
    $d a x y z I $.  $d a x y z J $.  $d a R $.  $d a z U $.  $d a x y z Y $.
    $d a x y ph $.
    prdsgsum.y $e |- Y = ( S Xs_ ( x e. I |-> R ) ) $.
    prdsgsum.b $e |- B = ( Base ` R ) $.
    prdsgsum.z $e |- .0. = ( 0g ` Y ) $.
    prdsgsum.i $e |- ( ph -> I e. V ) $.
    prdsgsum.j $e |- ( ph -> J e. W ) $.
    prdsgsum.s $e |- ( ph -> S e. X ) $.
    prdsgsum.r $e |- ( ( ph /\ x e. I ) -> R e. CMnd ) $.
    prdsgsum.f $e |- ( ( ph /\ ( x e. I /\ y e. J ) ) -> U e. B ) $.
    prdsgsum.w $e |- ( ph ->
      ( `' ( y e. J |-> ( x e. I |-> U ) ) " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Finite commutative sums in a product structure are taken componentwise.
       (Contributed by Stefan O'Rear, 1-Feb-2015.)  (Revised by Mario Carneiro,
       3-Jul-2015.) $)
    prdsgsum $p |- ( ph -> ( Y gsum ( y e. J |-> ( x e. I |-> U ) ) ) =
        ( x e. I |-> ( R gsum ( y e. J |-> U ) ) ) ) $=
      ( va cmpt cgsu co cv cfv wfn wceq cbs eqid ccmn wf fmptd ffn syl prdscmnd
      wcel wa wral anassrs ralrimiva prdsbasmpt2 adantr mpbird gsumcl prdsbasfn
      an32s nfcv nfmpt1 nfmpt nfov dffn5f sylib fvmpt2 syl2anc mpteq2dva oveq2d
      wb simpr cmnd cmnmnd cmhm prdspjmhm eleqtrd adantlr ccnv cvv csn cdif cfn
      cima fveq1 gsummhm2 eqtr3d eqtr4d ) AMCIBHGUEZUEZUFUGZBHBUHZXAUIZUEZBHECI
      GUEZUFUGZUEAXAHUJXAXDUKAMULUIZBHEUEZFXAHLJMOXGUMZTRAHUNXHUOXHHUJABHEUNXHU
      AXHUMZUPZHUNXHUQURAIXGWTMKNXIQAXHFHLJMORTXKUSZSACIWSXGWTACUHIUTZVAZWSXGUT
      ZGDUTZBHVBZXNXPBHAXBHUTZXMXPAXRXMXPUBVCZVJVDAXOXQWAXMABXGEFGHDLJUNMOXITRA
      EUNUTZBHUAVDPVEVFVGZWTUMUPUCVHVIBHXABMWTUFBMVKBUFVKBCIWSBIVKBHGVLVMVNVOVP
      ABHXFXCAXRVAZECIXBWSUIZUEZUFUGXFXCYBYDXEEUFYBCIYCGYBXMVAXRXPYCGUKYBXRXMAX
      RWBZVFXSBHGDWSWSUMVQVRVSVTYBUDIXGXBUDUHZUIZYCCXCMEKWSNXIQAMUNUTXRXLVFYBXT
      EWCUTUAEWDURZAIKUTXRSVFYBUDXGYGUEMXBXHUIZWEUGMEWEUGYBUDXBXGXHFHJLMOXIAHJU
      TXRRVFAFLUTXRTVFAHWCXHUOXRABHEWCXHYHXJUPVFYEWFYBYIEMWEYBXRXTYIEUKYEUABHEU
      NXHXJVQVRVTWGAXMXOXRYAWHAWTWIWJNWKWLWNWMUTXRUCVFXBYFWSWOXBYFXAWOWPWQVSWR
      $.
  $}

  ${
    $d a b c x y B $.  $d a b c x y F $.  $d a b c x y I $.  $d a b c x y ph $.
    $d a b c x y .0. $.  $d a b c x y J $.  $d a b c x y R $.
    $d a b c x y Y $.
    pwsgsum.y $e |- Y = ( R ^s I ) $.
    pwsgsum.b $e |- B = ( Base ` R ) $.
    pwsgsum.z $e |- .0. = ( 0g ` Y ) $.
    pwsgsum.i $e |- ( ph -> I e. V ) $.
    pwsgsum.j $e |- ( ph -> J e. W ) $.
    pwsgsum.r $e |- ( ph -> R e. CMnd ) $.
    pwsgsum.f $e |- ( ( ph /\ ( x e. I /\ y e. J ) ) -> U e. B ) $.
    pwsgsum.w $e |- ( ph ->
      ( `' ( y e. J |-> ( x e. I |-> U ) ) " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Finite commutative sums in a power structure are taken componentwise.
       (Contributed by Stefan O'Rear, 1-Feb-2015.)  (Revised by Mario Carneiro,
       3-Jul-2015.) $)
    pwsgsum $p |- ( ph -> ( Y gsum ( y e. J |-> ( x e. I |-> U ) ) ) =
       ( x e. I |-> ( R gsum ( y e. J |-> U ) ) ) ) $=
      ( cmpt cgsu co csca cfv csn cxp ccmn wcel wceq eqid pwsval syl2anc oveq1d
      cprds cvv c0g fconstmpt oveq2i fvex a1i cv adantr ccnv cdif fveq2d syl5eq
      cima cfn sneqd difeq2d imaeq2d eqeltrrd prdsgsum eqtrd ) AKCHBGFUAUAZUBUC
      EUDUEZGEUFUGZUOUCZVPUBUCBGECHFUAUBUCUAAKVSVPUBAEUHUIZGIUIKVSUJRPEVQGUHIKM
      VQUKULUMZUNABCDEVQFGHIJUPVSVSUQUEZVRBGEUAVQUOBGEURUSNWBUKPQVQUPUIAEUDUTVA
      AVTBVBGUIRVCSAVPVDZUPLUFZVEZVHWCUPWBUFZVEZVHVIAWEWGWCAWDWFUPALWBALKUQUEWB
      OAKVSUQWAVFVGVJVKVLTVMVNVO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Internal direct products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c DProd $. $( Direct product $)
  $c dProj $. $( Direct product projection $)

  $( Internal direct product of a family of subgroups. $)
  cdprd $a class DProd $.

  $( Internal direct product of a family of subgroups. $)
  cdpj $a class dProj $.

  ${
    $d g h .0. $.  $d f g h i s x y G $.  $d h x y I $.  $d g h K $.
    $d g h Z $.  $d x y ph $.  $d g h x y S $.  $d h x y V $.
    $( Define the internal direct product of a family of subgroups.
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    df-dprd $a |- DProd = ( g e. Grp , s e. { h |
      ( h : dom h --> ( SubGrp ` g ) /\ A. x e. dom h
       ( A. y e. ( dom h \ { x } ) ( h ` x ) C_ ( ( Cntz ` g ) ` ( h ` y ) ) /\
         ( ( h ` x ) i^i ( ( mrCls ` ( SubGrp ` g ) ) `
           U. ( h " ( dom h \ { x } ) ) ) ) = { ( 0g ` g ) } ) ) } |->
        ran ( f e. { h e. X_ x e. dom s ( s ` x ) |
          ( `' h " ( _V \ { ( 0g ` g ) } ) ) e. Fin } |-> ( g gsum f ) ) ) $.

    $( Define the projection operator for a direct product.  (Contributed by
       Mario Carneiro, 21-Apr-2016.) $)
    df-dpj $a |- dProj = ( g e. Grp , s e. ( dom DProd " { g } ) |->
        ( i e. dom s |->
      ( ( s ` i ) ( proj1 ` g ) ( g DProd ( s |` ( dom s \ { i } ) ) ) ) ) ) $.

    $( The domain of definition of the internal direct product, which states
       that ` S ` is a family of subgroups that mutually commute and have
       trivial intersections.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    reldmdprd $p |- Rel dom DProd $=
      ( vg vs vh vx vy vf cgrp cv cdm csubg cfv wf ccntz wss csn cdif wral cima
      cuni wa cmrc cin c0g wceq cab ccnv cvv cfn wcel cixp crab cgsu cmpt cdprd
      co crn df-dprd reldmmpt2 ) ABGCHZIZAHZJKZUSLDHZUSKZEHUSKVAMKKNEUTVCOPZQVD
      USVERSVBUAKKUBVAUCKOZUDTDUTQTCUEFUSUFUGVFPRUHUICDBHZIVCVGKUJUKVAFHULUOUMU
      PUNDEFACBUQUR $.

    dmdprd.z $e |- Z = ( Cntz ` G ) $.
    dmdprd.0 $e |- .0. = ( 0g ` G ) $.
    dmdprd.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( The domain of definition of the internal direct product, which states
       that ` S ` is a family of subgroups that mutually commute and have
       trivial intersections.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dmdprd $p |- ( ( I e. V /\ dom S = I ) ->
      ( G dom DProd S <-> ( G e. Grp /\
        S : I --> ( SubGrp ` G ) /\ A. x e. I
        ( A. y e. ( I \ { x } ) ( S ` x ) C_ ( Z ` ( S ` y ) ) /\
        ( ( S ` x ) i^i ( K ` U. ( S " ( I \ { x } ) ) ) ) = { .0. } ) ) ) ) $=
      ( vh vg wcel wceq wa cfv wral cvv vf vs cdm cgrp cv csubg wf wss csn cdif
      cima cuni cin cab cdprd wbr w3a wi elex a1i expcom adantr adantrd wb wsbc
      fex df-sbc simpr dmeqd simplr eqtrd feq12d difeq1d fveq1d fveq2d imaeq12d
      sseq12d raleqbidv unieqd ineq12d eqeq1d anbi12d adantlr sbcied syl5bbr ex
      pm5.21ndd anbi2d cop ccntz cmrc c0g cxp ciun df-br ccnv cixp crab cgsu co
      cfn cmpt crn fvex rgenw ixpexg ax-mp rabex mptex rnex rgen2w df-dprd mpbi
      fmpt2x fdmi eleq2i fveq2 feq3 syl6eqr sseq2d ralbidv ineq2d sneqd eqeq12d
      syl abbidv opeliunxp2 3bitri 3anass 3bitr4g ) EGOZCUCZEPZQZDUDOZCMUEZUCZD
      UFRZYPUGZAUEZYPRZBUEZYPRZIRZUHZBYQYTUIZUJZSZUUAYPUUGUKZULZFRZUMZHUIZPZQZA
      YQSZQZMUNZOZQZYOEYRCUGZYTCRZUUBCRZIRZUHZBEUUFUJZSZUVBCUVFUKZULZFRZUMZUUMP
      ZQZAESZQZQDCUOUCZUPZYOUVAUVNUQYNUUSUVOYOYNCTOZUUSUVOUUSUVRURYNCUURUSUTYNU
      VAUVRUVNYKUVAUVRURYMUVAYKUVREYRGCVFVAVBVCYNUVRUUSUVOVDUUSUUQMCVEYNUVRQZUV
      OUUQMCVGUVSUUQUVOMCTYNUVRVHYNYPCPZUUQUVOVDUVRYNUVTQZYSUVAUUPUVNUWAYQEYRYP
      CYNUVTVHZUWAYQYLEUWAYPCUWBVIYKYMUVTVJVKZVLUWAUUOUVMAYQEUWCUWAUUHUVGUUNUVL
      UWAUUEUVEBUUGUVFUWAYQEUUFUWCVMZUWAUUAUVBUUDUVDUWAYTYPCUWBVNZUWAUUCUVCIUWA
      UUBYPCUWBVNVOVQVRUWAUULUVKUUMUWAUUAUVBUUKUVJUWEUWAUUJUVIFUWAUUIUVHUWAYPCU
      UGUVFUWBUWDVPVSVOVTWAWBVRWBWCWDWEWFWGWHUVQDCWIZUVPOUWFNUDNUEZUIYQUWGUFRZY
      PUGZUUAUUCUWGWJRZRZUHZBUUGSZUUAUUJUWHWKRZRZUMZUWGWLRZUIZPZQZAYQSZQZMUNZWM
      WNZOUUTDCUVPWOUVPUXDUWFUXDTUOUAYPWPTUWRUJUKXAOZMAUBUEZUCZYTUXFRZWQZWRZUWG
      UAUEWSWTZXBZXCZTOZUBUXCSNUDSUXDTUOUGUXNNUBUDUXCUXLUAUXJUXKUXEMUXIUXHTOZAU
      XGSUXITOUXOAUXGYTUXFXDXEAUXGUXHTXFXGXHXIXJXKNUBUDUXCUXMTUOABUANMUBXLXNXMX
      OXPNUDUXCDCUURUWGDPZUXBUUQMUXPUWIYSUXAUUPUXPUWHYRPUWIYSVDUWGDUFXQZUWHYRYQ
      YPXRYEUXPUWTUUOAYQUXPUWMUUHUWSUUNUXPUWLUUEBUUGUXPUWKUUDUUAUXPUUCUWJIUXPUW
      JDWJRIUWGDWJXQJXSVNXTYAUXPUWPUULUWRUUMUXPUWOUUKUUAUXPUUJUWNFUXPUWNYRWKRFU
      XPUWHYRWKUXQVOLXSVNYBUXPUWQHUXPUWQDWLRHUWGDWLXQKXSYCYDWBYAWBYFYGYHYOUVAUV
      NYIYJ $.

    dmdprdd.1 $e |- ( ph -> G e. Grp ) $.
    dmdprdd.2 $e |- ( ph -> I e. V ) $.
    dmdprdd.3 $e |- ( ph -> S : I --> ( SubGrp ` G ) ) $.
    dmdprdd.4 $e |- ( ( ph /\ ( x e. I /\ y e. I /\ x =/= y ) ) ->
      ( S ` x ) C_ ( Z ` ( S ` y ) ) ) $.
    dmdprdd.5 $e |- ( ( ph /\ x e. I ) ->
      ( ( S ` x ) i^i ( K ` U. ( S " ( I \ { x } ) ) ) ) C_ { .0. } ) $.
    $( Show that a given family is a direct product decomposition.
       (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dmdprdd $p |- ( ph -> G dom DProd S ) $=
      ( wcel cfv cdprd cdm wbr cgrp csubg wf cv wss csn cdif wral cima cuni cin
      wceq wne eldifsn necom anbi2i bitri 3exp2 imp4b syl5bi ralrimiv ffvelrnda
      subg0cl syl cbs cmre cacs adantr eqid subgacs acsmre 3syl cpw crn imassrn
      frn syl5ss mresspw sstrd sspwuni sylib mrccl syl2anc sylanbrc snssd eqssd
      wa elin jca ralrimiva w3a wb fdm dmdprd mpbir3and ) AEDUAUBUCZEUDSZFEUETZ
      DUFZBUGZDTZCUGZDTJTUHZCFXCUIUJZUKZXDDXGULZUMZGTZUNZIUIZUOZWJZBFUKZNPAXOBF
      AXCFSZWJZXHXNXRXFCXGXEXGSZXEFSZXCXEUPZWJZXRXFXSXTXEXCUPZWJYBXEFXCUQYCYAXT
      XEXCURUSUTAXQXTYAXFAXQXTYAXFQVAVBVCVDXRXLXMRXRIXLXRIXDSZIXKSZIXLSXRXDXASY
      DAFXAXCDPVEXDEILVFVGXRXKXASZYEXRXAEVHTZVITSZXJYGUHZYFXRWTXAYGVJTSYHAWTXQN
      VKYGEYGVLVMXAYGVNVOZXRXIYGVPZUHYIXRXIXAYKXRXIDVQZXADXGVRAYLXAUHZXQAXBYMPF
      XADVSVGVKVTXRYHXAYKUHYJXAYGWAVGWBXIYGWCWDXAXJGYGMWEWFXKEILVFVGIXDXKWKWGWH
      WIWLWMAFHSDUBFUOZWSWTXBXPWNWOOAXBYNPFXADWPVGBCDEFGHIJKLMWQWFWR $.
  $}

  ${
    $d f g h i s y $.  $d g .0. $.  $d f A $.  $d f h i s I $.  $d f h i s S $.
    $d f g h i s G $.  $d s W $.
    dprdval.0 $e |- .0. = ( 0g ` G ) $.
    dprdval.w $e |- W = { h e. X_ i e. I ( S ` i ) |
        ( `' h " ( _V \ { .0. } ) ) e. Fin } $.
    $( The domain of definition of the internal direct product, which states
       that ` S ` is a family of subgroups that mutually commute and have
       trivial intersections.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdval $p |- ( ( G dom DProd S /\ dom S = I ) ->
      ( G DProd S ) = ran ( f e. W |-> ( G gsum f ) ) ) $=
      ( vs vg cdprd wceq wa cv cvv wcel cfv cgrp vy cdm wbr cgsu cmpt crn simpl
      ccnv csn cdif cima cfn cixp crab wsbc reldmdprd brrelex2i adantr brrelexi
      co c0g breq1 oveq1 fveq2 syl6eqr difeq2d imaeq2d eleq1d rabbidv mpteq12dv
      wi sneqd rneqd eqeq12d imbi12d csubg ccntz wss wral cuni cmrc cin cab cop
      wf cxp ciun df-br fvex rgenw ixpexg ax-mp rabex mptex rnex rgen2w df-dprd
      fmpt2x mpbi fdmi eleq2i opeliunxp 3bitri ovmpt4g mp3an3 sylbi mpcom sbcth
      vtoclg syl simpr breq2d oveq2d dmeqd simplr eqtrd ixpeq1d fveq1d ixpeq2dv
      biidd rabeqbidv eqidd sbcied mpbid mpd ) EAMUBZUCZAUBZFNZOZYGEAMUTZBGEBPZ
      UDUTZUEZUFZNZYGYIUGYJEKPZYFUCZEYQMUTZBCPZUHZQHUIZUJZUKZULRZCDYQUBZDPZYQSZ
      UMZUNZYMUEZUFZNZVKZKAUOZYGYPVKZYJAQRZUUOYGUUQYIEAYFUPUQURZUUNKAQEQRYRUUME
      YQYFUPUSLPZYQYFUCZUUSYQMUTZBUUAQUUSVASZUIZUJZUKZULRZCUUIUNZUUSYLUDUTZUEZU
      FZNZVKUUNLEQUUSENZUUTYRUVKUUMUUSEYQYFVBUVLUVAYSUVJUULUUSEYQMVCUVLUVIUUKUV
      LBUVGUVHUUJYMUVLUVFUUECUUIUVLUVEUUDULUVLUVDUUCUUAUVLUVCUUBQUVLUVBHUVLUVBE
      VASHUUSEVAVDIVEVLVFVGVHVIUUSEYLUDVCVJVMVNVOUUTUUSTRZYQYTUBZUUSVPSZYTWEUUG
      YTSZUAPYTSUUSVQSSVRUAUVNUUGUIUJZVSUVPYTUVQUKVTUVOWASSWBUVCNODUVNVSOCWCZRZ
      OZUVKUUTUUSYQWDZYFRUWALTUUSUIUVRWFWGZRUVTUUSYQYFWHYFUWBUWAUWBQMUVJQRZKUVR
      VSLTVSUWBQMWEUWCLKTUVRUVIBUVGUVHUVFCUUIUUHQRZDUUFVSUUIQRUWDDUUFUUGYQWIWJD
      UUFUUHQWKWLWMWNWOZWPLKTUVRUVJQMDUABLCKWQZWRWSWTXALTUVRYQXBXCUVMUVSUWCUVKU
      WELKTUVRUVJMQUWFXDXEXFXIXGXHXJYJUUNUUPKAQUURYJYQANZOZYRYGUUMYPUWHYQAEYFYJ
      UWGXKZXLUWHYSYKUULYOUWHYQAEMUWIXMUWHUUKYNUWHBUUJYMGYMUWHUUJUUECDFUUGASZUM
      ZUNGUWHUUEUUECUUIUWKUWHUUIDFUUHUMUWKUWHDUUFFUUHUWHUUFYHFUWHYQAUWIXNYGYIUW
      GXOXPXQUWHDFUUHUWJUWHUUGYQAUWIXRXSXPUWHUUEXTYAJVEUWHYMYBVJVMVNVOYCYDYE $.

    $( The domain of definition of the internal direct product, which states
       that ` S ` is a family of subgroups that mutually commute and have
       trivial intersections.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    eldprd $p |- ( dom S = I -> ( A e. ( G DProd S ) <-> ( G dom DProd S /\
      E. f e. W A = ( G gsum f ) ) ) ) $=
      ( cdprd co wcel cdm wbr wa wceq cv cgsu cop cfv elfvdm df-ov eleq2s df-br
      wrex sylibr pm4.71ri wb cmpt crn dprdval eleq2d eqid ovex elrnmpti syl6bb
      ancoms pm5.32da syl5bb ) AFBLMZNZFBLOZPZVCQBOGRZVEAFCSZTMZRCHUGZQVCVEVCFB
      UAZVDNZVEVKAVJLUBVBAVJLUCFBLUDUEFBVDUFUHUIVFVEVCVIVEVFVCVIUJVEVFQZVCACHVH
      UKZULZNVIVLVBVNABCDEFGHIJKUMUNCHVHAVMVMUOFVGTUPUQURUSUTVA $.
  $}

  ${
    $d x .0. $.  $d x y G $.  $d x y I $.  $d x K $.  $d x y S $.  $d x y X $.
    $d y Y $.  $d x y Z $.
    $( Reverse closure for the internal direct product.  (Contributed by Mario
       Carneiro, 25-Apr-2016.) $)
    dprdgrp $p |- ( G dom DProd S -> G e. Grp ) $=
      ( vx vy cdprd cdm wbr cgrp wcel csubg cfv wf ccntz wss csn wral wceq eqid
      cv cvv cdif cima cuni cmrc cin c0g wa wb reldmdprd brrelex2i dmexg dmdprd
      w3a syl sylancl ibi simp1d ) BAEFZGZBHIZAFZBJKZALZCSZAKZDSAKBMKZKNDVAVDOU
      AZPVEAVGUBUCVBUDKZKUEBUFKZOQUGCVAPZUSUTVCVJUMZUSVATIZVAVAQUSVKUHUSATIVLBA
      URUIUJATUKUNVARCDABVAVHTVIVFVFRVIRVHRULUOUPUQ $.

    $( The function ` S ` is a family of subgroups.  (Contributed by Mario
       Carneiro, 25-Apr-2016.) $)
    dprdf $p |- ( G dom DProd S -> S : dom S --> ( SubGrp ` G ) ) $=
      ( vx vy cdprd cdm wbr cgrp wcel csubg cfv wf ccntz wss csn wral wceq eqid
      cv cvv cdif cima cuni cmrc cin c0g wa wb reldmdprd brrelex2i dmexg dmdprd
      w3a syl sylancl ibi simp2d ) BAEFZGZBHIZAFZBJKZALZCSZAKZDSAKBMKZKNDVAVDOU
      AZPVEAVGUBUCVBUDKZKUEBUFKZOQUGCVAPZUSUTVCVJUMZUSVATIZVAVAQUSVKUHUSATIVLBA
      URUIUJATUKUNVARCDABVAVHTVIVFVFRVIRVHRULUOUPUQ $.

    dprdcntz.1 $e |- ( ph -> G dom DProd S ) $.
    dprdcntz.2 $e |- ( ph -> dom S = I ) $.
    $( The function ` S ` is a family of subgroups.  (Contributed by Mario
       Carneiro, 25-Apr-2016.) $)
    dprdf2 $p |- ( ph -> S : I --> ( SubGrp ` G ) ) $=
      ( cdm csubg cfv wf cdprd wbr dprdf syl feq2d mpbid ) ABGZCHIZBJZDRBJACBKG
      LSEBCMNAQDRBFOP $.

    dprdcntz.3 $e |- ( ph -> X e. I ) $.
    ${
      dprdcntz.4 $e |- ( ph -> Y e. I ) $.
      dprdcntz.5 $e |- ( ph -> X =/= Y ) $.
      dprdcntz.z $e |- Z = ( Cntz ` G ) $.
      $( The function ` S ` is a family of subgroups.  (Contributed by Mario
         Carneiro, 25-Apr-2016.) $)
      dprdcntz $p |- ( ph -> ( S ` X ) C_ ( Z ` ( S ` Y ) ) ) $=
        ( vy vx wcel cfv wral wceq cvv csn cdif wss wne necomd eldifsn sylanbrc
        cv cima cuni csubg cmrc cin c0g wa wf cdprd cdm wbr reldmdprd brrelex2i
        cgrp w3a wb dmexg 3syl eqeltrrd eqid dmdprd syl2anc mpbid simp3d ralimi
        simpl syl sneq difeq2d fveq2 sseq1d raleqbidv rspcv sylc fveq2d sseq2d
        ) AFDEUAZUBZPZEBQZNUHZBQZGQZUCZNWFRZWHFBQZGQZUCZAFDPFEUDWGKAEFLUEFDEUFU
        GAEDPOUHZBQZWKUCZNDWQUAZUBZRZODRZWMJAXBWRBXAUIUJCUKQZULQZQUMCUNQZUASZUO
        ZODRZXCACVBPZDXDBUPZXIACBUQURZUSZXJXKXIVCZHADTPBURZDSXMXNVDAXODTIAXMBTP
        XOTPHCBXLUTVABTVEVFVGIONBCDXETXFGMXFVHXEVHVIVJVKVLXHXBODXBXGVNVMVOXBWMO
        EDWQESZWSWLNXAWFXPWTWEDWQEVPVQXPWRWHWKWQEBVRVSVTWAWBWLWPNFWFWIFSZWKWOWH
        XQWJWNGWIFBVRWCWDWAWB $.
    $}

    ${
      dprddisj.0 $e |- .0. = ( 0g ` G ) $.
      dprddisj.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
      $( The function ` S ` is a family of subgroups.  (Contributed by Mario
         Carneiro, 25-Apr-2016.) $)
      dprddisj $p |- ( ph ->
        ( ( S ` X ) i^i ( K ` U. ( S " ( I \ { X } ) ) ) ) = { .0. } ) $=
        ( vx vy wcel cfv csn wceq wral cvv cv cdif cima cuni cin ccntz wss cgrp
        wa csubg wf cdprd cdm wbr w3a wb reldmdprd brrelex2i 3syl eqeltrrd eqid
        dmexg dmdprd syl2anc mpbid simp3d simpr ralimi syl sneq difeq2d imaeq2d
        fveq2 unieqd fveq2d ineq12d eqeq1d rspcv sylc ) AFDOMUAZBPZBDVTQZUBZUCZ
        UDZEPZUEZGQZRZMDSZFBPZBDFQZUBZUCZUDZEPZUEZWHRZJAWANUABPCUFPZPUGNWCSZWIU
        IZMDSZWJACUHOZDCUJPBUKZXBACBULUMZUNZXCXDXBUOZHADTOBUMZDRXFXGUPAXHDTIAXF
        BTOXHTOHCBXEUQURBTVBUSUTIMNBCDETGWSWSVAKLVCVDVEVFXAWIMDWTWIVGVHVIWIWRMF
        DVTFRZWGWQWHXIWAWKWFWPVTFBVMXIWEWOEXIWDWNXIWCWMBXIWBWLDVTFVJVKVLVNVOVPV
        QVRVS $.
    $}
  $}

  ${
    $d h y z A $.  $d x B $.  $d h x y z F $.  $d x y z G $.  $d h i x y z I $.
    $d h .0. $.  $d x y z ph $.  $d h i x y z S $.  $d x X $.  $d y Z $.
    dprdff.w $e |- W = { h e. X_ i e. I ( S ` i ) |
        ( `' h " ( _V \ { .0. } ) ) e. Fin } $.
    dprdff.1 $e |- ( ph -> G dom DProd S ) $.
    dprdff.2 $e |- ( ph -> dom S = I ) $.
    $( The property of being a finitely supported function in the family
       ` S ` .  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdw $p |- ( ph -> ( F e. W <-> ( F Fn I /\
        A. x e. I ( F ` x ) e. ( S ` x ) /\
        ( `' F " ( _V \ { .0. } ) ) e. Fin ) ) ) $=
      ( cv cfv wcel cvv cfn wa wi cixp ccnv csn cdif cima wfn wral w3a elex a1i
      cdm cdprd wbr reldmdprd brrelex2i dmexg 3syl eqeltrrd fnex expcom adantrd
      syl fveq2 cbvixpv eleq2i elixp2 3anass 3bitri baib pm5.21ndd anbi1d cnveq
      wb wceq imaeq1d eleq1d elrab2 df-3an 3bitr4g ) AFEHENZCOZUAZPZFUBZQJUCUDZ
      UEZRPZSFHUFZBNZFOWICOZPBHUGZSZWGSFIPWHWKWGUHAWCWLWGAFQPZWCWLWCWMTAFWBUIUJ
      AWHWMWKAHQPZWHWMTACUKZHQMAGCULUKZUMCQPWOQPLGCWPUNUOCQUPUQURWHWNWMHQFUSUTV
      BVAWMWCWLVMTAWCWMWLWCFBHWJUAZPWMWHWKUHWMWLSWBWQFEBHWAWJVTWICVCVDVEBHWJFVF
      WMWHWKVGVHVIUJVJVKDNZUBZWEUEZRPWGDFWBIWRFVNZWTWFRXAWSWDWEWRFVLVOVPKVQWHWK
      WGVRVS $.

    ${
      dprdwd.3 $e |- ( ( ph /\ x e. I ) -> A e. ( S ` x ) ) $.
      dprdwd.4 $e |- ( ph ->
        ( `' ( x e. I |-> A ) " ( _V \ { .0. } ) ) e. Fin ) $.
      $( The property of being a finitely supported function in the family
         ` S ` .  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
      dprdwd $p |- ( ph -> ( x e. I |-> A ) e. W ) $=
        ( vy wcel cv cfv wral cmpt wfn ccnv cvv csn cdif cima cfn ralrimiva syl
        eqid fnmpt wceq simpr fvmpt2 syl2anc eqeltrd nfv nffvmpt1 nfel1 eleq12d
        wa fveq2 cbvral sylib dprdw mpbir3and ) ABHCUAZIQVHHUBZPRZVHSZVJDSZQZPH
        TZVHUCUDJUEUFUGUHQACBRZDSZQZBHTVIAVQBHNUIBHCVHVPVHUKZULUJAVOVHSZVPQZBHT
        VNAVTBHAVOHQZVBZVSCVPWBWAVQVSCUMAWAUNNBHCVPVHVRUOUPNUQUIVTVMBPHVTPURBVK
        VLBHCVJUSUTVOVJUMVSVKVPVLVOVJVHVCVOVJDVCVAVDVEOAPDEFVHGHIJKLMVFVG $.
    $}

    dprdff.3 $e |- ( ph -> F e. W ) $.
    ${
      dprdff.b $e |- B = ( Base ` G ) $.
      $( A finitely supported function in ` S ` is a function into the base.
         (Contributed by Mario Carneiro, 25-Apr-2016.) $)
      dprdff $p |- ( ph -> F : I --> B ) $=
        ( vx wfn cfv wcel wral cv wf ccnv cvv csn cdif cima cfn w3a dprdw mpbid
        simp1d simp2d wa csubg wss dprdf2 ffvelrnda subgss sseld ralimdva ffnfv
        syl mpd sylanbrc ) AFHQZPUAZFRZBSZPHTZHBFUBAVFVHVGCRZSZPHTZFUCUDJUEUFUG
        UHSZAFISVFVMVNUINAPCDEFGHIJKLMUJUKZULAVMVJAVFVMVNVOUMAVLVIPHAVGHSUNZVKB
        VHVPVKGUORZSVKBUPAHVQVGCACGHLMUQURBVKGOUSVCUTVAVDPHBFVBVE $.
    $}

    $( A finitely supported function in ` S ` has its ` X ` -th element in
       ` S ( X ) ` .  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdfcl $p |- ( ( ph /\ X e. I ) -> ( F ` X ) e. ( S ` X ) ) $=
      ( vx cv cfv wcel wral fveq2 wfn ccnv cvv csn cdif cima dprdw mpbid simp2d
      cfn w3a wceq eleq12d rspccva sylan ) AOPZEQZUPBQZRZOGSZIGRIEQZIBQZRZAEGUA
      ZUTEUBUCJUDUEUFUJRZAEHRVDUTVEUKNAOBCDEFGHJKLMUGUHUIUSVCOIGUPIULUQVAURVBUP
      IETUPIBTUMUNUO $.

    $( The function ` S ` is a family of subgroups.  (Contributed by Mario
       Carneiro, 25-Apr-2016.) $)
    dprdffi $p |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $=
      ( vx wfn cv cfv wcel wral ccnv cvv csn cdif cima cfn dprdw mpbid simp3d
      w3a ) AEGOZNPZEQUKBQRNGSZETUAIUBUCUDUERZAEHRUJULUMUIMANBCDEFGHIJKLUFUGUH
      $.

    dprdfcntz.z $e |- Z = ( Cntz ` G ) $.
    $( A function on the elements of an internal direct product has
       pairwise-commuting values.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    dprdfcntz $p |- ( ph -> ran F C_ ( Z ` ran F ) ) $=
      ( cfv wcel syl wa wceq vy vx vz crn wf wss wfn cv wral eqid dprdff cplusg
      cbs ffn ffvelrnda simpr fveq2d eqcomd oveq12d wne cdprd cdm wbr ad3antrrr
      co simpllr simplr dprdcntz dprdfcl ad2antrr sseldd adantlr adantr syl2anc
      cntzi pm2.61dane ralrimiva wb oveq2 oveq1 eqeq12d ralrn mpbird frn elcntz
      mpbir2and ffnfv sylanbrc ) AGEUDZJPZEUEZWIWJUFAEGUGZUAUHZEPZWJQZUAGUIWKAG
      FUMPZEUEZWLAWPBCDEFGHIKLMNWPUJZUKZGWPEUNRZAWOUAGAWMGQZSZWOWNWPQZWNUBUHZFU
      LPZVEZXDWNXEVEZTZUBWIUIZAGWPWMEWSUOXBXIWNUCUHZEPZXEVEZXKWNXEVEZTZUCGUIZXB
      XNUCGXBXJGQZSZXNWMXJXQWMXJTZSZWNXKXKWNXEXSWMXJEXQXRUPZUQXSXJWMEXSWMXJXTUR
      UQUSXQWMXJUTZSZWNXJBPZJPZQXKYCQZXNYBWMBPZYDWNYBBFGWMXJJAFBVAVBVCXAXPYALVD
      ABVBGTXAXPYAMVDAXAXPYAVFXBXPYAVGXQYAUPOVHXBWNYFQXPYAABCDEFGHWMIKLMNVIVJVK
      XQYEYAAXPYEXAABCDEFGHXJIKLMNVIVLVMXEYCFWNXKJXEUJZOVOVNVPVQXBWLXIXOVRAWLXA
      WTVMXHXNUBUCGEXDXKTXFXLXGXMXDXKWNXEVSXDXKWNXEVTWAWBRWCXBWIWPUFZWOXCXISVRA
      YHXAAWQYHWSGWPEWDRVMUBWNWPXEWIFJWRYGOWERWFVQUAGWJEWGWHGWJEWDR $.
  $}

  ${
    $d f x B $.  $d f h i x G $.  $d f h i x S $.
    dprdssv.b $e |- B = ( Base ` G ) $.
    $( The internal direct product of a family of subgroups is a subset of the
       base.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdssv $p |- ( G DProd S ) C_ B $=
      ( vx vf vh vi cdprd co cv wcel cdm wceq cvv cfv wa eqid syl adantr wbr wb
      cgsu ccnv c0g csn cdif cima cfn cixp crab wrex eldprd ax-mp ccntz dprdgrp
      cmnd grpmnd reldmdprd brrelex2i dmexg simpl eqidd simpr dprdfcntz dprdffi
      cgrp dprdff gsumzcl eleq1 syl5ibrcom rexlimdva imp sylbi ssriv ) ECBIJZAE
      KZVPLZCBIMZUAZVQCFKZUCJZNZFGKUDOCUEPZUFUGUHUILGHBMZHKBPUJUKZULZQZVQALZWEW
      ENVRWHUBWERVQBFGHCWEWFWDWDRZWFRZUMUNVTWGWIVTWCWIFWFVTWAWFLZQZWIWCWBALWMWE
      AWACOWDCUOPZDWJWNRZVTCUQLZWLVTCVGLWPBCUPCURSTVTWEOLZWLVTBOLWQCBVSUSUTBOVA
      STWMABGHWACWEWFWDWKVTWLVBZWMWEVCZVTWLVDZDVHWMBGHWACWEWFWDWNWKWRWSWTWOVEWM
      BGHWACWEWFWDWKWRWSWTVFVIVQWBAVJVKVLVMVNVO $.
  $}

  ${
    $d k .- $.  $d h k x .+ $.  $d h n A $.  $d f h k x y F $.  $d h k x y H $.
    $d f h i k n x y G $.  $d f h i k n x y I $.  $d h x N $.  $d k n x y ph $.
    $d h k n x y .0. $.  $d f h i n x y S $.  $d f W $.  $d h n X $.
    eldprdi.0 $e |- .0. = ( 0g ` G ) $.
    eldprdi.w $e |- W = { h e. X_ i e. I ( S ` i ) |
        ( `' h " ( _V \ { .0. } ) ) e. Fin } $.
    eldprdi.1 $e |- ( ph -> G dom DProd S ) $.
    eldprdi.2 $e |- ( ph -> dom S = I ) $.
    ${
      dprdfid.3 $e |- ( ph -> X e. I ) $.
      dprdfid.4 $e |- ( ph -> A e. ( S ` X ) ) $.
      dprdfid.f $e |- F = ( n e. I |-> if ( n = X , A , .0. ) ) $.
      $( The zero function is the only function that sums two zero in a direct
         product.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
      dprdfid $p |- ( ph -> ( F e. W /\ ( G gsum F ) = A ) ) $=
        ( wcel cgsu co wceq cv cif cmpt wa ad2antrr simpr fveq2d eleqtrrd csubg
        cfv wn dprdf2 ffvelrnda subg0cl syl adantr ifclda csn cfn ccnv cvv cdif
        cima wss snfi wne eldifsni adantl ifnefalse suppss2 ssfi sylancr dprdwd
        syl5eqel cbs eqid cdprd cdm wbr cgrp cmnd dprdgrp grpmnd 3syl reldmdprd
        brrelex2i eqeltrrd dprdff cnveqi imaeq1i syl5eqss gsumpt iftrue syl2anc
        dmexg fvmptg eqtrd jca ) AGJTHGUAUBZBUCAGFIFUDZKUCZBLUEZUFZJSAFXECDEHIJ
        LNOPAXCITZUGZXDBLXCCUMZXHXDUGZBKCUMZXIABXKTZXGXDRUHXJXCKCXHXDUIUJUKXHLX
        ITZXDUNXHXIHULUMZTXMAIXNXCCACHIOPUOUPXIHLMUQURUSUTAKVAZVBTXFVCZVDLVAVEZ
        VFZXOVGXRVBTKVHAIXEFXOLAXCIXOVETZUGXCKVIZXELUCXSXTAXCIKVJVKXCKBLVLURVMZ
        XOXRVNVOVPVQZAXBKGUMZBAIHVRUMZGHVDKLYDVSZMAHCVTWAZWBZHWCTHWDTOCHWEHWFWG
        ACWAZIVDPAYGCVDTYHVDTOHCYFWHWICVDWRWGWJQAYDCDEGHIJLNOPYBYEWKAGVCZXQVFXR
        XOYIXPXQGXFSWLWMYAWNWOAKITXLYCBUCQRFKXEBIXKGXDBLWPSWSWQWTXA $.

    $}

    eldprdi.3 $e |- ( ph -> F e. W ) $.
    $( The domain of definition of the internal direct product, which states
       that ` S ` is a family of subgroups that mutually commute and have
       trivial intersections.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    eldprdi $p |- ( ph -> ( G gsum F ) e. ( G DProd S ) ) $=
      ( vf cgsu co cdprd wcel wceq cdm cv wrex eqid oveq2 eqeq2d rspcev sylancl
      wbr wa wb eldprd syl mpbir2and ) AFEPQZFBRQSZFBRUAUIZUOFOUBZPQZTZOHUCZLAE
      HSUOUOTZVANUOUDUTVBOEHURETUSUOUOUREFPUEUFUGUHABUAGTUPUQVAUJUKMUOBOCDFGHIJ
      KULUMUN $.

    ${
      dprdfinv.b $e |- N = ( invg ` G ) $.
      $( Take the inverse of a group sum over a family of elements of disjoint
         subgroups.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
      dprdfinv $p |- ( ph -> ( ( N o. F ) e. W /\
        ( G gsum ( N o. F ) ) = ( N ` ( G gsum F ) ) ) ) $=
        ( vx wcel cfv cvv ccom cgsu co wceq cv cmpt cbs wf cgrp cdm wbr dprdgrp
        cdprd syl eqid grpinvf dprdff fcompt syl2anc wa csubg ffvelrnda dprdfcl
        dprdf2 subginvcl ccnv csn cdif cima cfn wss dprdffi ssid suppssr fveq2d
        a1i grpinvid adantr eqtrd suppss2 ssfi dprdwd ccntz reldmdprd brrelex2i
        eqeltrd dmexg 3syl eqeltrrd dprdfcntz gsumzinv jca ) AHEUAZIRFWMUBUCFEU
        BUCHSUDAWMQGQUEZESZHSZUFZIAFUGSZWRHUHZGWREUHWMWQUDAFUIRZWSAFBUMUJZUKZWT
        MBFULUNZWRFHWRUOZPUPUNAWRBCDEFGIJLMNOXDUQZQHEGWRWRURUSAQWPBCDFGIJLMNAWN
        GRUTWNBSZFVASZRWOXFRWPXFRAGXGWNBABFGMNVDVBABCDEFGIWNJLMNOVCXFFHWOPVEUSA
        EVFTJVGVHZVIZVJRWQVFXHVIZXIVKXJVJRABCDEFGIJLMNOVLZAGWPQXIJAWNGXIVHRZUTZ
        WPJHSZJXMWOJHAGWREXIWNJXEXIXIVKAXIVMVPVNVOAXNJUDZXLAWTXOXCFHJKPVQUNVRVS
        VTXIXJWAUSWBWFAGWREFHTJFWCSZXDKXPUOZPXCABUJZGTNAXBBTRXRTRMFBXAWDWEBTWGW
        HWIXEABCDEFGIJXPLMNOXQWJXKWKWL $.
    $}

    ${
      dprdfadd.4 $e |- ( ph -> H e. W ) $.
      ${
        dprdfadd.b $e |- .+ = ( +g ` G ) $.
        $( Take the sum of group sums over two families of elements of disjoint
           subgroups.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
        dprdfadd $p |- ( ph -> ( ( F oF .+ H ) e. W /\
          ( G gsum ( F oF .+ H ) ) = ( ( G gsum F ) .+ ( G gsum H ) ) ) ) $=
          ( wcel cfv vx vk vy cof co cgsu wceq cmpt cvv cdm cdprd wbr reldmdprd
          brrelex2i dmexg 3syl eqeltrrd dprdfcl cbs eqid dprdff feqmptd offval2
          cv wa csubg dprdf2 ffvelrnda subgcl syl3anc ccnv csn cdif cun cfn wss
          cima dprdffi unfi syl2anc ssun1 a1i suppssr ssun2 oveq12d dprdgrp syl
          cgrp grpidcl grplid adantr eqtrd suppss2 ssfi eqeltrd ccntz dprdfcntz
          dprdwd cmnd grpmnd cres csubmnd wf eldifi adantl ffvelrn syl2an snssd
          vex cntzsubm wfn wral simprl fnssres fvres ad2antrr ad2antlr ffvelrnd
          ffn subgss mpdan cntz2ss sselda wn wne simpr simplrr eldifbd dprdcntz
          nelne2 ralrimiva ffnfv sylanbrc crn resss rnss ax-mp cntzidss sylancl
          sseldd cnvss imass1 mp2b gsumzsubmcl fssres gsumzcl cntzrec fvex snss
          wb mpbid sylibr gsumzaddlem jca ) AFHBUDUEZJSGUUOUFUEGFUFUEGHUFUEBUEU
          GAUUOUAIUAVDZFTZUUPHTZBUEZUHZJAUAIUUQUURBFHUIUUPCTZUVAACUJZIUIOAGCUKU
          JZULZCUISUVBUISNGCUVCUMUNCUIUOUPUQZACDEFGIJUUPKMNOPURZACDEHGIJUUPKMNO
          QURZAUAIGUSTZFAUVHCDEFGIJKMNOPUVHUTZVAZVBAUAIUVHHAUVHCDEHGIJKMNOQUVIV
          AZVBVCAUAUUSCDEGIJKMNOAUUPISVEUVAGVFTZSUUQUVASUURUVASUUSUVASAIUVLUUPC
          ACGINOVGVHUVFUVGBUVAGUUQUURRVIVJAFVKUIKVLVMZVQZHVKZUVMVQZVNZVOSZUUTVK
          UVMVQZUVQVPUVSVOSAUVNVOSUVPVOSZUVRACDEFGIJKMNOPVRZACDEHGIJKMNOQVRZUVN
          UVPVSVTAIUUSUAUVQKAUUPIUVQVMSZVEZUUSKKBUEZKUWDUUQKUURKBAIUVHFUVQUUPKU
          VJUVNUVQVPAUVNUVPWAWBWCAIUVHHUVQUUPKUVKUVPUVQVPAUVPUVNWDWBWCWEAUWEKUG
          ZUWCAGWHSZKUVHSZUWFAUVDUWGNCGWFWGZAUWGUWHUWIUVHGKUVILWIWGUVHBGKKUVIRL
          WJVTWKWLWMUVQUVSWNVTWRWOZAUAIUVHBUBFGHUIFHVNVKUVMVQZKGWPTZUVILRUWLUTZ
          AUWGGWSSZUWIGWTWGZUVEUWAUWBUWKUTUVJUVKACDEFGIJKUWLMNOPUWMWQACDEHGIJKU
          WLMNOQUWMWQZACDEUUOGIJKUWLMNOUWJUWMWQAUUPIVPZUBVDZIUUPVMSZVEZVEZUWRFT
          ZVLZGHUUPXAZUFUEZVLZUWLTZVPZUXBUXGSUXAUXFUXCUWLTZVPZUXHUXAUXEUXIUXAUU
          PUXIUXDGUIKUWLLUWMAUWNUWTUWOWKZUUPUISUXAUAXIWBZUXAUWNUXCUVHVPZUXIGXBT
          SUXKUXAUXBUVHAIUVHFXCUWRISZUXBUVHSUWTUVJUWSUXNUWQUWRIUUPXDXEZIUVHUWRF
          XFXGXHZUVHUXCGUWLUVIUWMXJVTUXAUXDUUPXKZUCVDZUXDTZUXISZUCUUPXLUUPUXIUX
          DXCUXAHIXKZUWQUXQUXAIUVHHXCZUYAAUYBUWTUVKWKZIUVHHXSWGAUWQUWSXMZIUUPHX
          NVTUXAUXTUCUUPUXAUXRUUPSZVEZUXSUXRHTZUXIUYEUXSUYGUGUXAUXRUUPHXOXEUYFU
          WRCTZUWLTZUXIUYGUYFUYHUVHVPZUXCUYHVPUYIUXIVPUYFUYHUVLSUYJUYFIUVLUWRCU
          YFCGIAUVDUWTUYENXPZAUVBIUGUWTUYEOXPZVGUWTUXNAUYEUXOXQZXRUVHUYHGUVIXTW
          GUYFUXBUYHUYFUXNUXBUYHSUYMUYFCDEFGIJUWRKMUYKUYLAFJSUWTUYEPXPURYAXHUVH
          UYHUXCGUWLUVIUWMYBVTUYFUXRCTZUYIUYGUYFCGIUXRUWRUWLUYKUYLUXAUUPIUXRUYD
          YCZUYMUYFUYEUWRUUPSYDUXRUWRYEUXAUYEYFUYFUWRIUUPAUWQUWSUYEYGYHUXRUWRUU
          PYJVTUWMYIUYFUXRISUYGUYNSUYOUYFCDEHGIJUXRKMUYKUYLAHJSUWTUYEQXPURYAYTY
          TWOYKUCUUPUXIUXDYLYMAUXDYNZUYPUWLTVPZUWTAHYNZUYRUWLTVPUYPUYRVPZUYQUWP
          UXDHVPZUYSHUUPYOZUXDHYPYQUYRUYPGUWLUWMYRYSWKZAUXDVKZUVMVQZVOSZUWTAUVT
          VUDUVPVPZVUEUWBUYTVUCUVOVPVUFVUAUXDHUUAVUCUVOUVMUUBUUCUVPVUDWNYSWKZUU
          DXHUXAUXFUVHVPUXMUXJUXHUUJUXAUXEUVHUXAUUPUVHUXDGUIKUWLUVILUWMUXKUXLUX
          AUYBUWQUUPUVHUXDXCUYCUYDIUVHUUPHUUEVTVUBVUGUUFXHUXPUVHUXFUXCGUWLUVIUW
          MUUGVTUUKUXBUXGUWRFUUHUUIUULUUMUUN $.
      $}

      dprdfsub.b $e |- .- = ( -g ` G ) $.
      $( Take the difference of group sums over two families of elements of
         disjoint subgroups.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
      dprdfsub $p |- ( ph -> ( ( F oF .- H ) e. W /\
        ( G gsum ( F oF .- H ) ) = ( ( G gsum F ) .- ( G gsum H ) ) ) ) $=
        ( co wcel vk vx cof cgsu wceq cminusg cfv ccom cplusg cv cmpt wa dprdff
        cbs ffvelrnda grpsubval syl2anc mpteq2dva cvv cdprd reldmdprd brrelex2i
        eqid cdm wbr dmexg 3syl eqeltrrd feqmptd offval2 fvex wf1o cgrp dprdgrp
        a1i wf syl grpinvf1o f1of fveq2 fmptco 3eqtr4d dprdfinv simpld dprdfadd
        eqeltrd oveq2d simprd dprdssv eldprdi sseldi eqtrd jca ) AEGIUCSZJTFWNU
        DSZFEUDSZFGUDSZISZUEAWNEFUFUGZGUHZFUIUGZUCSZJAUAHUAUJZEUGZXCGUGZISZUKUA
        HXDXEWSUGZXASZUKWNXBAUAHXFXHAXCHTULZXDFUNUGZTXEXJTXFXHUEAHXJXCEAXJBCDEF
        HJKMNOPXJVCZUMZUOZAHXJXCGAXJBCDGFHJKMNOQXKUMZUOZXJXAFWSIXDXEXKXAVCZWSVC
        ZRUPUQURAUAHXDXEIEGUSXJXJABVDZHUSOAFBUTVDZVEZBUSTXRUSTNFBXSVAVBBUSVFVGV
        HZXMXOAUAHXJEXLVIZAUAHXJGXNVIZVJAUAHXDXGXAEWTUSXJUSYAXMXGUSTXIXEWSVKVOY
        BAUAUBHXJXEUBUJZWSUGXGGWSXOYCAUBXJXJWSAXJXJWSVLXJXJWSVPAXJFWSXKXQAXTFVM
        TNBFVNVQVRXJXJWSVSVQVIYDXEWSVTWAVJWBZAXBJTZFXBUDSZWPFWTUDSZXASZUEZAXABC
        DEFWTHJKLMNOPAWTJTZYHWQWSUGZUEZABCDGFHWSJKLMNOQXQWCZWDXPWEZWDWFAWOYGWRA
        WNXBFUDYEWGAYIWPYLXASZYGWRAYHYLWPXAAYKYMYNWHWGAYFYJYOWHAWPXJTWQXJTWRYPU
        EAFBUTSZXJWPXJBFXKWIZABCDEFHJKLMNOPWJWKAYQXJWQYRABCDGFHJKLMNOQWJWKXJXAF
        WSIWPWQXKXPXQRUPUQWBWLWM $.
    $}

    $( The zero function is the only function that sums two zero in a direct
       product.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdfeq0 $p |- ( ph ->
      ( ( G gsum F ) = .0. <-> F = ( x e. I |-> .0. ) ) ) $=
      ( co wceq cfv wcel cvv vy cgsu cmpt wa cbs eqid dprdff feqmptd adantr csn
      cv cdif cima cuni csubg cmrc cin dprdfcl adantlr cif csg cof cdm ad2antrr
      cdprd simpr dprdfid simpld dprdfsub simprd reldmdprd brrelex2i dmexg 3syl
      wbr eqeltrrd fvex c0g eqeltri ifex eqidd wf offval2 oveq2d simplr oveq12d
      a1i cgrp dprdgrp syl ffvelrnd grpsubid1 syl2anc eqtrd 3eqtr3d cmnd grpmnd
      ccntz csubmnd cmre wss cacs subgacs acsmre cpw crn imassrn dprdf2 mresspw
      frn sstrd syl5ss sspwuni sylib mrccl subgsubm oveq1 eleq1d fveq2d subg0cl
      grpsubid eqeltrd wn mrcssidd wfn ffn difssd df-ne eldifsn biimpri adantll
      wne sylan2br fnfvima syl3anc elunii sseldd subgsubcl ifbothda fmptd elsni
      dprdfcntz dprdffi gsumzsubmcl elin sylanbrc dprddisj eleqtrd mpteq2dva ex
      gsumz oveq2 eqeq1d syl5ibrcom impbid ) AGFUBPZJQZFBHJUCZQZAUUQUUSAUUQUDZF
      BHBUKZFRZUCZUURAFUVCQUUQABHGUERZFAUVDCDEFGHIJLMNOUVDUFZUGZUHUIUUTBHUVBJUU
      TUVAHSZUDZUVBJUJZSUVBJQUVHUVBUVACRZCHUVAUJZULZUMZUNZGUORZUPRZRZUQZUVIUVHU
      VBUVJSZUVBUVQSUVBUVRSAUVGUVSUUQACDEFGHIUVAJLMNOURUSZUVHGUAHUAUKZUVAQZUVBJ
      UTZUWAFRZGVARZPZUCZUBPZUVBUVQUVHGUAHUWCUCZFUWEVBPZUBPZGUWIUBPZUUPUWEPZUWH
      UVBUVHUWJISZUWKUWMQZUVHCDEUWIGFHUWEIJKLAGCVEVCZVOZUUQUVGMVDZACVCZHQUUQUVG
      NVDZUVHUWIISZUWLUVBQZUVHUVBCDEUAUWIGHIUVAJKLUWRUWTUUTUVGVFZUVTUWIUFVGZVHA
      FISUUQUVGOVDZUWEUFZVIZVJUVHUWJUWGGUBUVHUAHUWCUWDUWEUWIFTTTAHTSZUUQUVGAUWS
      HTNAUWQCTSUWSTSMGCUWPVKVLCTVMVNVPZVDZUWCTSUVHUWAHSZUDZUWBUVBJUVAFVQJGVRRT
      KGVRVQVSVTWGUWDTSUXLUWAFVQWGUVHUWIWAUVHUAHUVDFAHUVDFWBUUQUVGUVFVDZUHWCZWD
      UVHUWMUVBJUWEPZUVBUVHUWLUVBUUPJUWEUVHUXAUXBUXDVJAUUQUVGWEWFUVHGWHSZUVBUVD
      SZUXOUVBQUVHUWQUXPUWRCGWIZWJZUVHHUVDUVAFUXMUXCWKZUVDGUWEUVBJUVEKUXFWLWMWN
      WOUVHHUVQUWGGTJGWRRZKUYAUFZAGWPSZUUQUVGAUWQUXPUYCMUXRGWQVNZVDUXJUVHUVQUVO
      SZUVQGWSRSUVHUVOUVDWTRSZUVNUVDXAZUYEUVHUXPUVOUVDXBRSUYFUXSUVDGUVEXCUVOUVD
      XDVNZUVHUVMUVDXEZXAUYGUVHUVMCXFZUYICUVLXGUVHUYJUVOUYIUVHHUVOCWBZUYJUVOXAA
      UYKUUQUVGACGHMNXHVDZHUVOCXJWJUVHUYFUVOUYIXAUYHUVOUVDXIWJXKXLUVMUVDXMXNZUV
      OUVNUVPUVDUVPUFZXOWMZUVQGXPWJUVHUAHUWFUVQUWGUWBUVBUWDUWEPZUVQSJUWDUWEPZUV
      QSZUWFUVQSUXLUVBJUVBUWCQUYPUWFUVQUVBUWCUWDUWEXQXRJUWCQUYQUWFUVQJUWCUWDUWE
      XQXRUXLUWBUDZUYPUVBUVBUWEPZUVQUYSUWDUVBUVBUWEUYSUWAUVAFUXLUWBVFXSWDUVHUYT
      UVQSUXKUWBUVHUYTJUVQUVHUXPUXQUYTJQUXSUXTUVDGUWEUVBJUVEKUXFYAWMUVHUYEJUVQS
      ZUYOUVQGJKXTZWJYBVDYBUXLUWBYCZUDZUYEVUAUWDUVQSUYRUVHUYEUXKVUCUYOVDZVUDUYE
      VUAVUEVUBWJVUDUVNUVQUWDUVHUVNUVQXAUXKVUCUVHUVOUVNUVPUVDUYHUYNUYMYDVDVUDUW
      DUWACRZSZVUFUVMSZUWDUVNSUXLVUGVUCUVHCDEFGHIUWAJLUWRUWTUXEURUIVUDCHYEZUVLH
      XAUWAUVLSZVUHUVHVUIUXKVUCUVHUYKVUIUYLHUVOCYFWJVDVUDHUVKYGUXKVUCVUJUVHVUCU
      XKUWAUVAYLZVUJUWAUVAYHVUJUXKVUKUDUWAHUVAYIYJYMYKHUVLCUWAYNYOUWDVUFUVMYPWM
      YQUVQGUWEJUWDUXFYRYOYSUWGUFYTUVHCDEUWGGHIJUYALUWRUWTUVHUWJUWGIUXNUVHUWNUW
      OUXGVHVPZUYBUUBUVHCDEUWGGHIJLUWRUWTVULUUCUUDVPUVBUVJUVQUUEUUFUVHCGHUVPUVA
      JUWRUWTUXCKUYNUUGUUHUVBJUUAWJUUIWNUUJAUUQUUSGUURUBPZJQZAUYCUXHVUNUYDUXIHB
      GTJKUUKWMUUSUUPVUMJFUURGUBUULUUMUUNUUO $.

    dprdf11.4 $e |- ( ph -> H e. W ) $.
    $( Two group sums over a direct product that give the same value are equal
       as functions.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdf11 $p |- ( ph -> ( ( G gsum F ) = ( G gsum H ) <-> F = H ) ) $=
      ( vx wceq wcel cvv cv cfv wral cgsu co csg wfn wb cbs eqid dprdff ffn syl
      wf eqfnfv syl2anc cof cmpt dprdfsub simpld dprdfeq0 simprd eqeq1d cdm wbr
      cdprd reldmdprd brrelex2i dmexg 3syl eqeltrrd wa fvex a1i feqmptd offval2
      ovex rgenw mpteqb ax-mp cgrp dprdgrp ffvelrnda grpsubeq0 syl3anc ralbidva
      adantr syl5bb bitrd 3bitr3d dprdssv eldprdi sseldi 3bitr2rd ) AEGRZQUAZEU
      BZWPGUBZRZQHUCZFEUDUEZFGUDUEZFUFUBZUEZJRZXAXBRZAEHUGZGHUGZWOWTUHAHFUIUBZE
      UNXGAXIBCDEFHIJLMNOXIUJZUKZHXIEULUMAHXIGUNXHAXIBCDGFHIJLMNPXJUKZHXIGULUMQ
      HEGUOUPAFEGXCUQUEZUDUEZJRXMQHJURZRZXEWTAQBCDXMFHIJKLMNAXMISZXNXDRZABCDEFG
      HXCIJKLMNOPXCUJZUSZUTVAAXNXDJAXQXRXTVBVCAXPQHWQWRXCUEZURZXORZWTAXMYBXOAQH
      WQWRXCEGTTTABVDZHTNAFBVFVDZVEZBTSYDTSMFBYEVGVHBTVIVJVKWQTSAWPHSZVLZWPEVMV
      NWRTSYHWPGVMVNAQHXIEXKVOAQHXIGXLVOVPVCYCYAJRZQHUCZAWTYATSZQHUCYCYJUHYKQHW
      QWRXCVQVRQHYAJTVSVTAYIWSQHYHFWASZWQXISWRXISYIWSUHAYLYGAYFYLMBFWBUMZWGAHXI
      WPEXKWCAHXIWPGXLWCXIFXCWQWRJXJKXSWDWEWFWHWIWJAYLXAXISXBXISXEXFUHYMAFBVFUE
      ZXIXAXIBFXJWKZABCDEFHIJKLMNOWLWMAYNXIXBYOABCDGFHIJKLMNPWLWMXIFXCXAXBJXJKX
      SWDWEWN $.
  $}

  ${
    $d f g h i k x y G $.  $d f g h i k x y S $.
    $( The internal direct product of a family of subgroups is a subgroup.
       (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdsubg $p |- ( G dom DProd S -> ( G DProd S ) e. ( SubGrp ` G ) ) $=
      ( vx vy vh vi vk vf vg co cfv wcel c0 cv eqid cgsu wa wceq syl wrex cdprd
      cdm wbr csubg cbs wss wne csg wral dprdssv a1i c0g csn cxp ccnv cdif cima
      cvv cfn cixp crab eqidd wfn fvex fnconstg fvconst2 adantl dprdf ffvelrnda
      id mp1i subg0cl eqeltrd ralrimiva 0fin wf dprdgrp grpidcl fconst6g eldifi
      cgrp suppss ssfi sylancr dprdw mpbir3and eldprdi ne0i eldprd anbi12d mpan
      baibd reeanv cof simpl simprl simprr dprdfsub simprd simpld oveq12 eleq1d
      wb eqeltrrd syl5ibrcom rexlimdvva syl5bir sylbid ralrimivv w3a issubg4 )
      BAUAUBUCZBAUAJZBUDKZLZXMBUEKZUFZXMMUGZCNZDNZBUHKZJZXMLZDXMUICXMUIZXQXLXPA
      BXPOZUJUKXLBAUBZBULKZUMZUNZPJZXMLXRXLAEFYIBYFENUOURYHUPZUQUSLEFYFFNAKUTVA
      ZYGYGOZYLOZXLVJZXLYFVBZXLYIYLLYIYFVCZGNZYIKZYRAKZLZGYFUIYIUOYKUQZUSLZYGUR
      LYQXLBULVDZYFYGURVEVKXLUUAGYFXLYRYFLZQZYSYGYTUUEYSYGRZXLYFYGYRUUDVFZVGUUF
      YTXNLYGYTLXLYFXNYRAABVHVIYTBYGYMVLSVMVNXLMUSLUUBMUFUUCVOXLYFXPGYIMYGXLYGX
      PLZYFXPYIVPXLBWALZUUIABVQZXPBYGYEYMVRSYFYGXPVSSXLYRYFMUPLZQUUEUUGUULUUEXL
      YRYFMVTVGUUHSWBMUUBWCWDXLGAEFYIBYFYLYGYNYOYPWEWFWGXMYJWHSXLYCCDXMXMXLXSXM
      LZXTXMLZQZXSBHNZPJZRZHYLTZXTBINZPJZRZIYLTZQZYCYFYFRZXLUUOUVDXCYFOUVEXLQUU
      MUUSUUNUVCUVEUUMXLUUSXSAHEFBYFYLYGYMYNWIWLUVEUUNXLUVCXTAIEFBYFYLYGYMYNWIW
      LWJWKUVDUURUVBQZIYLTHYLTXLYCUURUVBHIYLYLWMXLUVFYCHIYLYLXLUUPYLLZUUTYLLZQZ
      QZYCUVFUUQUVAYAJZXMLUVJBUUPUUTYAWNJZPJZUVKXMUVJUVLYLLZUVMUVKRZUVJAEFUUPBU
      UTYFYAYLYGYMYNXLUVIWOZUVJYFVBZXLUVGUVHWPXLUVGUVHWQYAOZWRZWSUVJAEFUVLBYFYL
      YGYMYNUVPUVQUVJUVNUVOUVSWTWGXDUVFYBUVKXMXSUUQXTUVAYAXAXBXEXFXGXHXIXLUUJXO
      XQXRYDXJXCUUKCDXPXMBYAYEUVRXKSWF $.
  $}

  ${
    $d h i n x G $.  $d h i n I $.  $d h i n x S $.  $d h n x X $.
    $d n x ph $.
    dprdub.1 $e |- ( ph -> G dom DProd S ) $.
    dprdub.2 $e |- ( ph -> dom S = I ) $.
    dprdub.3 $e |- ( ph -> X e. I ) $.
    $( Each factor is a subset of the internal direct product.  (Contributed by
       Mario Carneiro, 25-Apr-2016.) $)
    dprdub $p |- ( ph -> ( S ` X ) C_ ( G DProd S ) ) $=
      ( vx vn vh vi cfv cdprd co cv wcel wceq eqid adantr wa c0g cmpt cgsu ccnv
      cif cvv csn cdif cima cfn cixp crab cdm wbr dprdfid simprd simpld eldprdi
      simpr eqeltrrd ex ssrdv ) AIEBMZCBNOZAIPZVDQZVFVEQAVGUAZCJDJPERVFCUBMZUFU
      CZUDOZVFVEVHVJKPUEUGVIUHUIUJUKQKLDLPBMULUMZQZVKVFRZVHVFBKLJVJCDVLEVIVISZV
      LSZACBNUNUOVGFTZABUNDRVGGTZAEDQVGHTAVGUTVJSUPZUQVHBKLVJCDVLVIVOVPVQVRVHVM
      VNVSURUSVAVBVC $.
  $}

  ${
    $d f h i k G $.  $d f h i k I $.  $d f k ph $.  $d f h i k S $.
    $d f k T $.
    dprdlub.1 $e |- ( ph -> G dom DProd S ) $.
    dprdlub.2 $e |- ( ph -> dom S = I ) $.
    dprdlub.3 $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    dprdlub.4 $e |- ( ( ph /\ k e. I ) -> ( S ` k ) C_ T ) $.
    $( The direct product is smaller than any subgroup which contains the
       factors.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdlub $p |- ( ph -> ( G DProd S ) C_ T ) $=
      ( vf vh vi cv cvv cfv wcel eqid wf adantr cdprd co ccnv c0g csn cdif cima
      cfn cixp crab cgsu cmpt crn cdm wbr wceq dprdval syl2anc wss wa cgrp cmnd
      ccntz dprdgrp grpmnd 3syl reldmdprd dmexg eqeltrrd csubg csubmnd subgsubm
      brrelex2i syl wfn cbs simpr dprdff adantlr dprdfcl sseldd ralrimiva ffnfv
      wral ffn sylanbrc dprdfcntz dprdffi gsumzsubmcl fmptd frn eqsstrd ) AEBUA
      UBZKLNUCOEUDPZUEUFUGUHQLMFMNBPUIUJZEKNZUKUBZULZUMZCAEBUAUNZUOZBUNZFUPZWMW
      SUPGHBKLMEFWOWNWNRZWORZUQURAWOCWRSWSCUSAKWOWQCWRAWPWOQZUTZFCWPEOWNEVCPZXD
      XHRZXGXAEVAQEVBQAXAXFGTZBEVDEVEVFXGXBFOAXCXFHTZXGXABOQXBOQXJEBWTVGVMBOVHV
      FVIXGCEVJPQZCEVKPQAXLXFITCEVLVNXGWPFVOZDNZWPPZCQZDFWDFCWPSXGFEVPPZWPSXMXG
      XQBLMWPEFWOWNXEXJXKAXFVQZXQRVRFXQWPWEVNXGXPDFXGXNFQZUTXNBPZCXOAXSXTCUSXFJ
      VSXGBLMWPEFWOXNWNXEXJXKXRVTWAWBDFCWPWCWFXGBLMWPEFWOWNXHXEXJXKXRXIWGXGBLMW
      PEFWOWNXEXJXKXRWHWIWRRWJWOCWRWKVNWL $.
  $}

  ${
    $d k G $.  $d k K $.  $d k S $.
    dprdspan.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( The direct product is the span of the union of the factors.
       (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdspan $p |- ( G dom DProd S -> ( G DProd S ) = ( K ` U. ran S ) ) $=
      ( vk cdprd cdm wbr co crn cuni cfv id eqidd csubg wcel wss syl wral iunss
      cbs cmre cgrp cacs dprdgrp eqid subgacs acsmre 3syl cv ciun wceq wf dprdf
      wfn fniunfv wa simpl simpr dprdub ralrimiva sylibr eqsstr3d dprdssv mrccl
      ffn syl6ss syl2anc eqimss sylib r19.21bi mrcssidd adantr dprdlub dprdsubg
      sstrd mrcsscl syl3anc eqssd ) BAFGHZBAFIZAJKZCLZVTAWCEBAGZVTMVTWDNVTBOLZB
      UALZUBLPZWBWFQWCWEPVTBUCPWEWFUDLPWGABUEWFBWFUFZUGWEWFUHUIZVTWBWAWFVTWBEWD
      EUJZALZUKZWAVTAWDUOZWLWBULZVTWDWEAUMWMABUNWDWEAVFREWDAUPRZVTWKWAQZEWDSWLW
      AQVTWPEWDVTWJWDPZUQZABWDWJVTWQURWRWDNVTWQUSUTVAEWDWKWATVBVCZWFABWHVDVGZWE
      WBCWFDVEVHWRWKWBWCVTWKWBQZEWDVTWLWBQZXAEWDSVTWNXBWOWLWBVIREWDWKWBTVJVKVTW
      BWCQWQVTWEWBCWFWIDWTVLVMVPVNVTWGWBWAQWAWEPWCWAQWIWSABVOWEWBCWAWFDVQVRVS
      $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y ph $.  $d x y S $.
    dprdres.1 $e |- ( ph -> G dom DProd S ) $.
    dprdres.2 $e |- ( ph -> dom S = I ) $.
    dprdres.3 $e |- ( ph -> A C_ I ) $.
    $( Restriction of a direct product (dropping factors).  (Contributed by
       Mario Carneiro, 25-Apr-2016.) $)
    dprdres $p |- ( ph -> ( G dom DProd ( S |` A ) /\
      ( G DProd ( S |` A ) ) C_ ( G DProd S ) ) ) $=
      ( vx vy cdprd wss wcel cfv cuni wceq syl eqid adantr cvv cres cdm co cgrp
      wbr csubg wf cv ccntz csn cdif wral cima cin c0g wa dprdgrp dprdf2 fssres
      syl2anc ad2antrr simplr sseldd eldifi adantl wne eldifsni necomd dprdcntz
      cmrc fvres fveq2d 3sstr4d ralrimiva ineq1d cmre cacs subgacs acsmre resss
      cbs imass1 ax-mp ssdif imass2 syl5ss uniss cpw crn imassrn frn subgss vex
      3syl elpw sylibr ssriv sstrd sspwuni sylib mrcssd sselda dprddisj sseqtrd
      a1i sslin ffvelrnda subg0cl mrccl elin sylanbrc snssd eqssd eqtrd jca w3a
      syldan reldmdprd brrelex2i dmexg eqeltrrd ssexd fdm dmdprd mpbir3and rnss
      wb mp2b dprdspan ) ADCBUAZKUBZUEZDYJKUCZDCKUCZLAYLDUDMZBDUFNZYJUGZIUHZYJN
      ZJUHZYJNZDUINZNZLZJBYRUJZUKZULZYSYJUUFUMZOZYPVJNZNZUNZDUONZUJZPZUPZIBULZA
      DCYKUEZYOFCDUQQZAEYPCUGZBELZYQACDEFGURZHEYPBCUSUTZAUUPIBAYRBMZUPZUUGUUOUV
      EUUDJUUFUVEYTUUFMZUPZYRCNZYTCNZUUBNYSUUCUVGCDEYRYTUUBAUURUVDUVFFVAACUBZEP
      ZUVDUVFGVAUVGBEYRAUVAUVDUVFHVAZAUVDUVFVBZVCUVGBEYTUVLUVFYTBMZUVEYTBUUEVDV
      EZVCUVGYTYRUVFYTYRVFUVEYTBYRVGVEVHUUBRZVIUVGUVDYSUVHPZUVMYRBCVKZQUVGUUAUV
      IUUBUVGUVNUUAUVIPUVOYTBCVKQVLVMVNUVEUULUVHUUKUNZUUNUVEYSUVHUUKUVDUVQAUVRV
      EVOUVEUVSUUNUVEUVSUVHCEUUEUKZUMZOZUUJNZUNZUUNUVEUUKUWCLUVSUWDLUVEYPUUIUUJ
      UWBDWANZAYPUWEVPNMZUVDAYOYPUWEVQNMUWFUUSUWEDUWERZVRYPUWEVSWNZSZUUJRZUVEUU
      HUWALUUIUWBLUVEUUHCUUFUMZUWAYJCLZUUHUWKLCBVTZYJCUUFWBWCUVEUVAUUFUVTLUWKUW
      ALAUVAUVDHSBEUUEWDUUFUVTCWEWNWFUUHUWAWGQZUVEUWAUWEWHZLUWBUWELUVEUWACWIZUW
      OCUVTWJAUWPUWOLZUVDAUWPYPUWOAUUTUWPYPLUVBEYPCWKQYPUWOLAIYPUWOYRYPMYRUWELY
      RUWOMUWEYRDUWGWLYRUWEIWMWOWPWQXEWRZSWFUWAUWEWSWTZXAUUKUWCUVHXFQUVECDEUUJY
      RUUMAUURUVDFSAUVKUVDGSABEYRHXBZUUMRZUWJXCXDUVEUUMUVSUVEUUMUVHMZUUMUUKMZUU
      MUVSMUVEUVHYPMZUXBAUVDYREMUXDUWTAEYPYRCUVBXGXQUVHDUUMUXAXHQUVEUUKYPMZUXCU
      VEUWFUUIUWELUXEUWIUVEUUIUWBUWEUWNUWSWRYPUUIUUJUWEUWJXIUTUUKDUUMUXAXHQUUMU
      VHUUKXJXKXLXMXNXOVNABTMYJUBBPZYLYOYQUUQXPYGABETAUVJETGAUURCTMUVJTMFDCYKXR
      XSCTXTWNYAHYBAYQUXFUVCBYPYJYCQIJYJDBUUJTUUMUUBUVPUXAUWJYDUTYEZAYJWIZOZUUJ
      NZUWPOZUUJNZYMYNAYPUXIUUJUXKUWEUWHUWJUXIUXKLZAUWLUXHUWPLUXMUWMYJCYFUXHUWP
      WGYHXEAUWQUXKUWELUWRUWPUWEWSWTXAAYLYMUXJPUXGYJDUUJUWJYIQAUURYNUXLPFCDUUJU
      WJYIQVMXO $.
  $}

  ${
    $d a f h k x y G $.  $d a k x y ph $.  $d a f h k x y S $.  $d a f h k T $.
    $d f h k x y I $.
    dprdss.1 $e |- ( ph -> G dom DProd T ) $.
    dprdss.2 $e |- ( ph -> dom T = I ) $.
    dprdss.3 $e |- ( ph -> S : I --> ( SubGrp ` G ) ) $.
    dprdss.4 $e |- ( ( ph /\ k e. I ) -> ( S ` k ) C_ ( T ` k ) ) $.
    $( Create a direct product by finding subgroups inside each factor of
       another direct product.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    dprdss $p |- ( ph ->
      ( G dom DProd S /\ ( G DProd S ) C_ ( G DProd T ) ) ) $=
      ( vf vh wss cfv cvv eqid wcel syl wceq adantr vx vy va cdprd cdm co csubg
      wbr cmrc c0g ccntz cgrp dprdgrp reldmdprd brrelex2i dmexg eqeltrrd cv wne
      3syl w3a wral ralrimiva fveq2 sseq12d rspcv mpan9 3ad2antr1 simpr1 simpr2
      wa simpr3 dprdcntz cbs wf dprdf2 ffvelrnd subgss sylc cntz2ss syl2anc csn
      sstrd cdif cima cuni cin cacs cmre subgacs acsmre ciun difss ssralv mpsyl
      ss2iun wfun funiunfv 3sstr3d cpw crn imassrn mresspw syl5ss sspwuni sylib
      ffun mrcssd ss2in simpr dprddisj sseqtrd dmdprdd cgsu ccnv cixp crab wrex
      frn cfn a1d wi ss2ixp rabss2 ssrexv anim12d fdm eldprd 3imtr4d ssrdv jca
      wb ) AEBUDUEZUHZEBUDUFZECUDUFZMAUAUBBEFEUGNZUINZOEUJNZEUKNZYTPZYSPZYRPZAE
      CYMUHZEULQZGCEUMRZACUEZFOHAUUDCOQUUGOQGECYMUNUOCOUPUTUQIAUAURZFQZUBURZFQZ
      UUHUUJUSZVAZVKZUUHBNZUUHCNZUUJBNZYTNZAUUKUUIUUOUUPMZUULADURZBNZUUTCNZMZDF
      VBZUUIUUSAUVCDFJVCZUVCUUSDUUHFUUTUUHSUVAUUOUVBUUPUUTUUHBVDUUTUUHCVDVEVFVG
      ZVHUUNUUPUUJCNZYTNZUURUUNCEFUUHUUJYTAUUDUUMGTAUUGFSZUUMHTAUUIUUKUULVIAUUI
      UUKUULVJZAUUIUUKUULVLUUAVMUUNUVGEVNNZMZUUQUVGMZUVHUURMUUNUVGYQQUVLUUNFYQU
      UJCAFYQCVOZUUMACEFGHVPZTUVJVQUVKUVGEUVKPZVRRUUNUUKUVDUVMUVJAUVDUUMUVETUVC
      UVMDUUJFUUTUUJSUVAUUQUVBUVGUUTUUJBVDUUTUUJCVDVEVFVSUVKUVGUUQEYTUVPUUAVTWA
      WCWCAUUIVKZUUOBFUUHWBZWDZWEWFZYRNZWGZUUPCUVSWEZWFZYRNZWGZYSWBZUVQUUSUWAUW
      EMUWBUWFMUVFUVQYQUVTYRUWDUVKUVQUUEYQUVKWHNQYQUVKWINQZAUUEUUIUUFTUVKEUVPWJ
      YQUVKWKUTZUUCUVQDUVSUVAWLZDUVSUVBWLZUVTUWDUVQUVCDUVSVBZUWJUWKMUVSFMUVQUVD
      UWLFUVRWMAUVDUUIUVETUVCDUVSFWNWODUVSUVAUVBWPRUVQFYQBVOZBWQUWJUVTSAUWMUUII
      TFYQBXGDUVSBWRUTUVQUVNCWQUWKUWDSAUVNUUIUVOTZFYQCXGDUVSCWRUTWSUVQUWCUVKWTZ
      MUWDUVKMUVQUWCCXAZUWOCUVSXBUVQUWPYQUWOUVQUVNUWPYQMUWNFYQCXSRUVQUWHYQUWOMU
      WIYQUVKXCRWCXDUWCUVKXEXFXHUUOUUPUWAUWEXIWAUVQCEFYRUUHYSAUUDUUIGTAUVIUUIHT
      AUUIXJUUBUUCXKXLXMAUCYOYPAYNUCURZEKURXNUFSZKLURXOOUWGWDWEXTQZLDFUVAXPZXQZ
      XRZVKZUUDUWRKUWSLDFUVBXPZXQZXRZVKZUWQYOQZUWQYPQZAYNUUDUXBUXFAUUDYNGYAAUWT
      UXDMZUXAUXEMUXBUXFYBAUVDUXJUVEDFUVAUVBYCRUWSLUWTUXDYDUWRKUXAUXEYEUTYFAUWM
      BUEFSUXHUXCYLIFYQBYGUWQBKLDEFUXAYSUUBUXAPYHUTAUVIUXIUXGYLHUWQCKLDEFUXEYSU
      UBUXEPYHRYIYJYK $.
  $}

  ${
    $d x y z .0. $.  $d x y z G $.  $d x y z I $.  $d x y z V $.
    dprd0.0 $e |- .0. = ( 0g ` G ) $.
    $( A family consisting entirely of trivial groups is an internal direct
       product, the product of which is the trivial subgroup.  (Contributed by
       Mario Carneiro, 25-Apr-2016.) $)
    dprdz $p |- ( ( G e. Grp /\ I e. V ) ->
      ( G dom DProd ( x e. I |-> { .0. } ) /\
        ( G DProd ( x e. I |-> { .0. } ) ) = { .0. } ) ) $=
      ( vy vz wcel wa csn wceq cfv eqid cv wss adantr snssd subg0cl syl cdm wbr
      cgrp cmpt cdprd csubg cmrc ccntz simpl simpr 0subg ad2antrr fmptd wne w3a
      co cbs grpidcl cntzsubg syldan simpr1 eqidd fvmpt3i simpr2 fveq2d 3sstr4d
      snex cdif cima cuni cin adantl ineq1d cmre subgacs acsmred cpw imassrn wf
      cacs crn frn mresspw sstrd syl5ss sspwuni sylib mrccl syl2anc df-ss eqtrd
      eqimss dmdprdd fdm dprdlub dprdsubg 3syl eqssd jca ) BUCIZCDIZJZBACEKZUDZ
      UEUAUBZBXDUEUPZXCLXBGHXDBCBUFMZUGMZDEBUHMZXINZFXHNZWTXAUIWTXAUJXBACXCXGXD
      WTXCXGIZXAAOZCIBEFUKZULXDNZUMZXBGOZCIZHOZCIZXQXSUNZUOZJZXCXCXIMZXQXDMZXSX
      DMZXIMXBXCYDPYBXBEYDXBYDXGIZEYDIWTXAXCBUQMZPYGXBEYHWTEYHIXAYHBEYHNZFURQRY
      HXCBXIYIXJUSUTYDBEFSTRQYCXRYEXCLZXBXRXTYAVAAXQXCXCCXDXMXQLXCVBXOEVGZVCZTY
      CYFXCXIYCXTYFXCLXBXRXTYAVDAXSXCXCCXDXMXSLXCVBXOYKVCTVEVFXBXRJZYEXDCXQKVHZ
      VIZVJZXHMZVKZXCLYRXCPYMYRXCYQVKZXCYMYEXCYQXRYJXBYLVLZVMYMXCYQPYSXCLYMEYQY
      MYQXGIZEYQIYMXGYHVNMIZYPYHPZUUAYMXGYHWTXGYHVTMIXAXRYHBYIVOULVPZYMYOYHVQZP
      UUCYMYOXDWAZUUEXDYNVRYMUUFXGUUEYMCXGXDVSZUUFXGPXBUUGXRXPQCXGXDWBTYMUUBXGU
      UEPUUDXGYHWCTWDWEYOYHWFWGXGYPXHYHXKWHWIYQBEFSTRXCYQWJWGWKYRXCWLTWMZXBXFXC
      XBXDXCGBCUUHXBUUGXDUACLXPCXGXDWNTWTXLXAXNQYMYJYEXCPYTYEXCWLTWOXBEXFXBXEXF
      XGIEXFIUUHXDBWPXFBEFSWQRWRWS $.

    $( The empty family is an internal direct product, the product of which is
       the trivial subgroup.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprd0 $p |- ( G e. Grp ->
      ( G dom DProd (/) /\ ( G DProd (/) ) = { .0. } ) ) $=
      ( vx cgrp wcel c0 csn cmpt cdprd cdm wbr co wceq cvv 0ex dprdz mpan2 mpt0
      wa breq2i oveq2i eqeq1i anbi12i sylib ) AEFZADGBHZIZJKZLZAUHJMZUGNZTZAGUI
      LZAGJMZUGNZTUFGOFUMPDAGOBCQRUJUNULUPUHGAUIDUGSZUAUKUOUGUHGAJUQUBUCUDUE $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y J $.  $d x y ph $.  $d x y S $.
    dprdf1o.1 $e |- ( ph -> G dom DProd S ) $.
    dprdf1o.2 $e |- ( ph -> dom S = I ) $.
    dprdf1o.3 $e |- ( ph -> F : J -1-1-onto-> I ) $.
    $( Rearrange the index set of a direct product family.  (Contributed by
       Mario Carneiro, 25-Apr-2016.) $)
    dprdf1o $p |- ( ph ->
      ( G dom DProd ( S o. F ) /\ ( G DProd ( S o. F ) ) = ( G DProd S ) ) ) $=
      ( cdprd wceq cfv cvv wcel syl 3syl syl2anc adantr cima cuni vx vy cdm wbr
      ccom csubg cmrc c0g ccntz eqid cgrp dprdgrp wf1 f1of1 reldmdprd brrelex2i
      co wf1o dmexg eqeltrrd f1dmex wf dprdf2 f1of fco cv wne wa simpr1 ffvelrn
      w3a simpr2 simpr3 f1fveq syl12anc necon3bid mpbird dprdcntz fvco3 3sstr4d
      wb fveq2d csn cdif cin wss sylan imaco ccnv wfun wfo dff1o3 simprbi f1ofo
      imadif foima wfn f1ofn fnsnfv eqcomd difeq12d eqtrd imaeq2d syl5eq unieqd
      ineq12d dprddisj eqimss dmdprdd crn rnco2 forn ffn fnima dprdspan 3eqtr4d
      jca ) ADBCUEZJUCZUDZDXRJUQZDBJUQZKAUAUBXRDFDUFLZUGLZMDUHLZDUILZYFUJZYEUJZ
      YDUJZADBXSUDZDUKNGBDULOAFECUMZEMNFMNAFECURZYKIFECUNOZABUCZEMHAYJBMNYNMNGD
      BXSUOUPBMUSPUTFEMCVAQAEYCBVBZFECVBZFYCXRVBABDEGHVCZAYLYPIFECVDOZFEYCBCVEQ
      AUAVFZFNZUBVFZFNZYSUUAVGZVKZVHZYSCLZBLZUUACLZBLZYFLYSXRLZUUAXRLZYFLUUEBDE
      UUFUUHYFAYJUUDGRAYNEKZUUDHRUUEYPYTUUFENZAYPUUDYRRZAYTUUBUUCVIZFEYSCVJZQUU
      EYPUUBUUHENUUNAYTUUBUUCVLZFEUUACVJQUUEUUFUUHVGUUCAYTUUBUUCVMUUEUUFUUHYSUU
      AUUEYKYTUUBUUFUUHKYSUUAKWAAYKUUDYMRUUOUUQFEYSUUACVNVOVPVQYGVRUUEYPYTUUJUU
      GKZUUNUUOFEYSBCVSZQUUEUUKUUIYFUUEYPUUBUUKUUIKUUNUUQFEUUABCVSQWBVTAYTVHZUU
      JXRFYSWCZWDZSZTZYDLZWEZYEWCZKUVFUVGWFUUTUVFUUGBEUUFWCZWDZSZTZYDLZWEUVGUUT
      UUJUUGUVEUVLAYPYTUURYRUUSWGUUTUVDUVKYDUUTUVCUVJUUTUVCBCUVBSZSUVJBCUVBWHUU
      TUVMUVIBUUTUVMCFSZCUVASZWDZUVIUUTYLCWIWJZUVMUVPKAYLYTIRZYLFECWKZUVQFECWLW
      MFUVACWOPUUTUVNEUVOUVHUUTYLUVSUVNEKUVRFECWNZFECWPPUUTUVHUVOACFWQZYTUVHUVO
      KAYLUWAIFECWROFYSCWSWGWTXAXBXCXDXEWBXFUUTBDEYDUUFYEAYJYTGRAUULYTHRAYPYTUU
      MYRUUPWGYHYIXGXBUVFUVGXHOXIZAXRXJZTZYDLZBXJZTZYDLZYAYBAUWDUWGYDAUWCUWFAUW
      CBCXJZSZUWFBCXKAUWJBESZUWFAUWIEBAYLUVSUWIEKIUVTFECXLPXCAYOBEWQUWKUWFKYQEY
      CBXMEBXNPXBXDXEWBAXTYAUWEKUWBXRDYDYIXOOAYJYBUWHKGBDYDYIXOOXPXQ $.
  $}

  ${
    dprdf1.1 $e |- ( ph -> G dom DProd S ) $.
    dprdf1.2 $e |- ( ph -> dom S = I ) $.
    dprdf1.3 $e |- ( ph -> F : J -1-1-> I ) $.
    $( Rearrange the index set of a direct product family.  (Contributed by
       Mario Carneiro, 25-Apr-2016.) $)
    dprdf1 $p |- ( ph ->
     ( G dom DProd ( S o. F ) /\ ( G DProd ( S o. F ) ) C_ ( G DProd S ) ) ) $=
      ( ccom cdprd cdm wbr co wss wceq wf simpld syl simprd crn wf1 f1f dprdres
      cres frn 3syl csubg cfv dprdf2 fssres syl2anc fdm wf1o f1f1orn ssid cores
      dprdf1o ax-mp syl6breq oveq2i syl5eqr eqsstrd jca ) ADBCJZKLZMDVEKNZDBKNZ
      OADBCUAZUEZCJZVEVFADVKVFMZDVKKNZDVJKNZPZAVJCDVIFADVJVFMZVNVHOZAVIBDEGHAFE
      CUBZFECQVIEOZIFECUCFECUFUGZUDZRAVIDUHUIZVJQZVJLVIPAEWBBQVSWCABDEGHUJVTEWB
      VIBUKULVIWBVJUMSAVRFVICUNIFECUOSURZRVIVIOVKVEPVIUPBCVIUQUSZUTAVGVNVHAVGVM
      VNVKVEDKWEVAAVLVOWDTVBAVPVQWATVCVD $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y H $.  $d x y S $.
    subgdprd.1 $e |- H = ( G |`s A ) $.
    $( A direct product in a subgroup.  (Contributed by Mario Carneiro,
       27-Apr-2016.) $)
    subgdmdprd $p |- ( A e. ( SubGrp ` G ) ->
      ( H dom DProd S <-> ( G dom DProd S /\ ran S C_ ~P A ) ) ) $=
      ( vx vy cfv wcel cvv wss wa adantr wb csn wral cin wceq eqid ad2antrr cdm
      csubg cdprd wbr crn cpw wi reldmdprd brrelex2i wf cv ccntz cdif cima cuni
      a1i c0g cbs ffvelrn ad2ant2lr subgss syl subgbas sseqtr4d biantrud simpll
      cmrc simplr eldifi ad2antll ffvelrnd resscntz syl2anc sseq2d ssin syl6bbr
      bitr4d anassrs cmre cgrp cacs subgrcl subgacs acsmre 3syl subggrp imassrn
      ralbidva frn ad2antlr syl5ss mresspw sstrd sspwuni sylib mrcssidd subsubg
      mrccl mpbid simpld mrcsscl syl3anc mpbir2and eqssd ineq2d eqeq12d anbi12d
      subg0 sneqd pm5.32da wfn elin elpw anbi2i bitri eqrdv anbi2d anbi1i anass
      vex df-f 3bitr4g anbi1d bitr3d dmexg adantl eqidd w3a dmdprd 3anass baibd
      syl6bb syl21anc an32 3bitr4d ex pm5.21ndd ) ACUBHZIZBJIZDBUCUAZUDZCBUUAUD
      ZBUEZAUFZKZLZUUBYTUGYSDBUUAUHUIUPUUGYTUGYSUUCYTUUFCBUUAUHUIMUPYSYTUUBUUGN
      YSYTLZBUAZDUBHZBUJZFUKZBHZGUKZBHZDULHZHZKZGUUIUULOZUMZPZUUMBUUTUNZUOZUUJV
      GHZHZQZDUQHZOZRZLZFUUIPZLZUUIYRBUJZUUFLZUUMUUOCULHZHZKZGUUTPZUUMUVCYRVGHZ
      HZQZCUQHZOZRZLZFUUIPZLZUUBUUGYSUVLUWGNYTYSUUKUWFLUVLUWGYSUUKUWFUVKYSUUKLZ
      UWEUVJFUUIUWHUULUUIIZLZUVRUVAUWDUVIUWJUVQUURGUUTUWHUWIUUNUUTIZUVQUURNUWHU
      WIUWKLZLZUVQUVQUUMAKZLZUURUWMUWNUVQUWMUUMDURHZAUWMUUMUUJIZUUMUWPKUUKUWIUW
      QYSUWKUUIUUJUULBUSUTUWPUUMDUWPSZVAVBYSAUWPRZUUKUWLACDEVCZTZVDVEUWMUURUUMU
      VPAQZKUWOUWMUUQUXBUUMUWMYSUUOAKUUQUXBRYSUUKUWLVFUWMUUOUWPAUWMUUOUUJIUUOUW
      PKUWMUUIUUJUUNBYSUUKUWLVHUWKUUNUUIIUWHUWIUUNUUIUUSVIVJVKUWPUUODUWRVAVBUXA
      VDAUUOCDYRUUPUVOEUVOSZUUPSZVLVMVNUUMUVPAVOVPVQVRWHUWJUWAUVFUWCUVHUWJUVTUV
      EUUMUWJUVTUVEUWJYRCURHZVSHIZUVCUVEKUVEYRIZUVTUVEKUWJCVTIZYRUXEWAHIUXFYSUX
      HUUKUWIACWBZTUXECUXESZWCYRUXEWDWEZUWJUUJUVCUVDUWPUWJDVTIZUUJUWPWAHIUUJUWP
      VSHIZYSUXLUUKUWIACDEWFZTUWPDUWRWCUUJUWPWDWEZUVDSZUWJUVBUWPUFZKUVCUWPKZUWJ
      UVBUUJUXQUWJUVBUUDUUJBUUTWGUUKUUDUUJKZYSUWIUUIUUJBWIWJWKUWJUXMUUJUXQKUXOU
      UJUWPWLVBWMUVBUWPWNWOZWPUWJUXGUVEAKZUWJUVEUUJIZUXGUYALZUWJUXMUXRUYBUXOUXT
      UUJUVCUVDUWPUXPWRVMYSUYBUYCNUUKUWIUVEACDEWQTWSWTYRUVCUVSUVEUXEUVSSZXAXBUW
      JUXMUVCUVTKUVTUUJIZUVEUVTKUXOUWJYRUVCUVSUXEUXKUYDUWJUVCAUXEUWJUVCUWPAUXTY
      SUWSUUKUWIUWTTVDZYSAUXEKUUKUWIUXEACUXJVATWMZWPUWJUYEUVTYRIZUVTAKZUWJUXFUV
      CUXEKUYHUXKUYGYRUVCUVSUXEUYDWRVMUWJUXFUVCAKYSUYIUXKUYFYSUUKUWIVFYRUVCUVSA
      UXEUYDXAXBYSUYEUYHUYILNUUKUWIUVTACDEWQTXCUUJUVCUVDUVTUWPUXPXAXBXDXEUWJUWB
      UVGYSUWBUVGRUUKUWIACDUWBEUWBSZXHTXIXFXGWHXJYSUUKUVNUWFYSBUUIXKZUXSLUYKUUD
      YRKZUUFLZLZUUKUVNYSUXSUYMUYKYSUXSUUDYRUUEQZKUYMYSUUJUYOUUDYSFUUJUYOYSUULU
      UJIUULYRIZUULAKZLZUULUYOIZUULACDEWQUYSUYPUULUUEIZLUYRUULYRUUEXLUYTUYQUYPU
      ULAFXTXMXNXOVPXPVNUUDYRUUEVOVPXQUUIUUJBYAUVNUYKUYLLZUUFLUYNUVMVUAUUFUUIYR
      BYAXRUYKUYLUUFXSXOYBYCYDMUUHUUIJIZUUIUUIRZUXLUUBUVLNYTVUBYSBJYEYFZUUHUUIY
      GZYSUXLYTUXNMVUBVUCLZUUBUXLUVLVUFUUBUXLUUKUVKYHUXLUVLLFGBDUUIUVDJUVGUUPUX
      DUVGSUXPYIUXLUUKUVKYJYLYKYMUUHUUGUVMUWFLZUUFLUWGUUHUUCVUGUUFUUHVUBVUCUXHU
      UCVUGNVUDVUEYSUXHYTUXIMVUFUUCUXHVUGVUFUUCUXHUVMUWFYHUXHVUGLFGBCUUIUVSJUWB
      UVOUXCUYJUYDYIUXHUVMUWFYJYLYKYMYCUVMUWFUUFYNYLYOYPYQ $.

    subgdprd.2 $e |- ( ph -> A e. ( SubGrp ` G ) ) $.
    subgdprd.3 $e |- ( ph -> G dom DProd S ) $.
    subgdprd.4 $e |- ( ph -> ran S C_ ~P A ) $.
    $( A direct product in a subgroup.  (Contributed by Mario Carneiro,
       27-Apr-2016.) $)
    subgdprd $p |- ( ph -> ( H DProd S ) = ( G DProd S ) ) $=
      ( cfv cdprd wcel wss syl eqid 3syl cpw sspwuni sylib mrcsscl crn csubg co
      cuni cmrc cbs cmre cgrp cacs subggrp subgacs acsmre subgrcl cdm wbr dprdf
      wf frn mresspw sstrd mrcssidd mrccl syl2anc syl3anc wa subsubg subgdmdprd
      wb mpbir2and eqidd dprdf2 mpbid simpld eqssd wceq dprdspan 3eqtr4d ) ACUA
      ZUDZEUBJZUEJZJZVSDUBJZUEJZJZECKUCZDCKUCZAWBWEAVTEUFJZUGJLZVSWEMWEVTLZWBWE
      MAEUHLZVTWHUIJLWIABWCLZWKGBDEFUJNWHEWHOUKVTWHULPZAWCVSWDDUFJZADUHLZWCWNUI
      JLWCWNUGJLZAWLWOGBDUMNWNDWNOUKWCWNULPZWDOZAVRWNQZMVSWNMZAVRWCWSADCKUNZUOZ
      CUNZWCCUQVRWCMHCDUPXCWCCURPAWPWCWSMWQWCWNUSNUTVRWNRSZVAAWJWEWCLZWEBMZAWPW
      TXEWQXDWCVSWDWNWRVBVCAWPVSBMZWLXFWQAVRBQMZXGIVRBRSGWCVSWDBWNWRTVDAWLWJXEX
      FVEVHGWEBDEFVFNVIVTVSWAWEWHWAOZTVDAWPVSWBMWBWCLZWEWBMWQAVTVSWAWHWMXIAVRWH
      QZMVSWHMZAVRVTXKAXCVTCUQVRVTMACEXCAECXAUOZXBXHHIAWLXMXBXHVEVHGBCDEFVGNVIZ
      AXCVJVKXCVTCURNAWIVTXKMWMVTWHUSNUTVRWHRSZVAAXJWBBMZAWBVTLZXJXPVEZAWIXLXQW
      MXOVTVSWAWHXIVBVCAWLXQXRVHGWBBDEFVFNVLVMWCVSWDWBWNWRTVDVNAXMWFWBVOXNCEWAX
      IVPNAXBWGWEVOHCDWDWRVPNVQ $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y S $.  $d x y V $.
    $( A singleton family is an internal direct product, the product of which
       is the given subgroup.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dprdsn $p |- ( ( A e. V /\ S e. ( SubGrp ` G ) ) ->
      ( G dom DProd { <. A , S >. } /\
        ( G DProd { <. A , S >. } ) = S ) ) $=
      ( vx vy wcel cfv wa csn cdprd wceq eqid adantl wss syl cuni syl6eq eqtrd
      c0 csubg cop cdm wbr cmrc cvv c0g ccntz cgrp subgrcl snex a1i wf1o f1osng
      co wf f1of simpr snssd fss syl2anc cv wne w3a simpr1 simpr2 eqtr4d simpr3
      elsni pm2.21ddne cdif cima cin cmre cacs adantr subgacs acsmre 3syl sneqd
      cbs difeq2d difid imaeq2d ima0 unieqd 0ss eqsstrd mrcsscl syl3anc subg0cl
      uni0 0subg ad2antlr fveq2d fvsng sylan9eqr eleqtrrd sstrd dfss1 sylib crn
      dmdprdd dprdspan rnsnopg unisng mrcid jca ) ADGZBCUAHZGZIZCABUBJZKUCUDZCX
      MKUOZBLXLEFXMCAJZXJUEHZUFCUGHZCUHHZXSMXRMZXQMZXKCUIGZXIBCUJNZXPUFGXLAUKUL
      XLXPBJZXMUPZYDXJOXPXJXMUPXLXPYDXMUMYEABDXJUNXPYDXMUQPXLBXJXIXKURZUSXPYDXJ
      XMUTVAXLEVBZXPGZFVBZXPGZYGYIVCZVDIZYGXMHZYIXMHXSHOYGYIYLYGAYIYLYHYGALZXLY
      HYJYKVEYGAVIZPYLYJYIALXLYHYJYKVFYIAVIPVGXLYHYJYKVHVJXLYHIZYMXMXPYGJZVKZVL
      ZQZXQHZVMZUUAXRJZYPUUAYMOUUBUUALYPUUAUUCYMYPXJCWAHZVNHGZYTUUCOUUCXJGZUUAU
      UCOYPYBXJUUDVOHGZUUEXLYBYHYCVPZUUDCUUDMVQZXJUUDVRZVSYPYTTUUCYPYTTQTYPYSTY
      PYSXMTVLTYPYRTXMYPYRXPXPVKTYPYQXPXPYPYGAYHYNXLYONVTWBXPWCRWDXMWERWFWLRTUU
      COYPUUCWGULWHYPYBUUFUUHCXRXTWMPXJYTXQUUCUUDYAWIWJZYPXRYMYPXRBYMXKXRBGXIYH
      BCXRXTWKWNYHXLYMAXMHBYHYGAXMYOWOABDXJWPWQWRUSWSUUAYMWTXAUUKWHXCZXLXOXMXBZ
      QZXQHZBXLXNXOUUOLUULXMCXQYAXDPXLUUOBXQHZBXLUUNBXQXLUUNYDQZBXLUUMYDXIUUMYD
      LXKABDXEVPWFXKUUQBLXIBXJXFNSWOXLUUEXKUUPBLXLYBUUGUUEYCUUIUUJVSYFXJBXQUUDY
      AXGVASSXH $.
  $}

  ${
    $d f h k n .0. $.  $d f h i k n A $.  $d f h i k n G $.  $d f h i k n I $.
    $d f h k n F $.  $d f k n ph $.  $d f h i k n S $.  $d f k n X $.
    dmdprdsplitlem.0 $e |- .0. = ( 0g ` G ) $.
    dmdprdsplitlem.w $e |- W = { h e. X_ i e. I ( S ` i ) |
        ( `' h " ( _V \ { .0. } ) ) e. Fin } $.
    dmdprdsplitlem.1 $e |- ( ph -> G dom DProd S ) $.
    dmdprdsplitlem.2 $e |- ( ph -> dom S = I ) $.
    dmdprdsplitlem.3 $e |- ( ph -> A C_ I ) $.
    dmdprdsplitlem.4 $e |- ( ph -> F e. W ) $.
    dmdprdsplitlem.5 $e |- ( ph -> ( G gsum F ) e. ( G DProd ( S |` A ) ) ) $.
    $( Lemma for ~ dmdprdsplit .  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    dmdprdsplitlem $p |- ( ( ph /\ X e. ( I \ A ) ) -> ( F ` X ) = .0. ) $=
      ( wcel wceq vf vn cdif wa cgsu co cv cfv ccnv cvv csn cima cres cixp crab
      cfn wrex cdprd cdm wbr csubg wf wss dprdf2 fssres syl2anc fdm eqid eldprd
      wb 3syl mpbid simprd adantr cif cmpt simprr simpld ad2antrr simprl dprdff
      cbs syl feqmptd resmpt iftrue mpteq2ia syl6eq eqtr4d oveq2d ccntz dprdgrp
      cgrp cmnd grpmnd reldmdprd brrelex2i dmexg eqeltrrd simplrl dprdfcl fvres
      adantl eleqtrd wn ffvelrnda subg0cl ifclda dprdffi eldifn ad2antlr eldifd
      simpr ssid a1i suppssr adantlr syldan ifeq1da ifid suppss2 ssfi dprdfcntz
      dprdwd iffalse gsumzres 3eqtrd dprdf11 fveq1d eleq1 fveq2 eqidd ifbieq12d
      eldifi fvex c0g eqeltri ifex fvmpt3i rexlimddv ) AJHBUCZSZUDZGFUEUFZGUAUG
      ZUEUFZTZJFUHZKTUADUGUIUJKUKUCZULUPSDEBEUGCBUMZUHUNUOZAUUGUAUUKUQZUUBAGUUJ
      URUSZUTZUULAUUDGUUJURUFSZUUNUULUDZRABGVAUHZUUJVBZUUJUSBTZUUOUUPVJAHUUQCVB
      ZBHVCZUURACGHNOVDZPHUUQBCVEVFZBUUQUUJVGZUUDUUJUADEGBUUKKLUUKVHZVIVKVLZVMV
      NUUCUUEUUKSZUUGUDZUDZUUHJUBHUBUGZBSZUVJUUEUHZKVOZVPZUHZJBSZJUUEUHZKVOZKUV
      IJFUVNUVIUUDGUVNUEUFZTFUVNTUVIUUDUUFGUVNBUMZUEUFUVSUUCUVGUUGVQUVIUUEUVTGU
      EUVIUUEUBBUVLVPZUVTUVIUBBGWBUHZUUEUVIUWBUUJDEUUEGBUUKKUVEAUUNUUBUVHAUUNUU
      LUVFVRVSZAUUSUUBUVHAUURUUSUVCUVDWCVSZUUCUVGUUGVTZUWBVHZWAZWDUVIUVTUBBUVMV
      PZUWAUVIUVAUVTUWHTAUVAUUBUVHPVSUBHBUVMWEWCUBBUVMUVLUVKUVLKWFWGWHWIWJUVIHU
      WBUVNGUJBKGWKUHZUWFLUWIVHZUVIGCUUMUTZGWMSGWNSAUWKUUBUVHNVSZCGWLGWOVKAHUJS
      UUBUVHACUSZHUJOAUWKCUJSUWMUJSNGCUUMWPWQCUJWRVKWSVSUVIUWBCDEUVNGHIKMUWLAUW
      MHTUUBUVHOVSZUVIUBUVMCDEGHIKMUWLUWNUVIUVJHSZUDZUVKUVLKUVJCUHZUWPUVKUDUVLU
      VJUUJUHZUWQUWPUUJDEUUEGBUUKUVJKUVEUVIUUNUWOUWCVNUVIUUSUWOUWDVNUUCUVGUUGUW
      OWTXAUVKUWRUWQTUWPUVJBCXBXCXDUWPKUWQSZUVKXEZUWPUWQUUQSUWSUVIHUUQUVJCAUUTU
      UBUVHUVBVSXFUWQGKLXGWCVNXHUVIUUEUIUUIULZUPSUVNUIUUIULZUXAVCUXBUPSUVIUUJDE
      UUEGBUUKKUVEUWCUWDUWEXIUVIHUVMUBUXAKUVIUVJHUXAUCSZUDZUVMUVKKKVOKUXDUVKUVL
      KKUXDUVKUVJBUXAUCSZUVLKTZUXDUVKUDUVJBUXAUXDUVKXMUXCUVJUXASXEUVIUVKUVJHUXA
      XJXKXLUVIUXEUXFUXCUVIBUWBUUEUXAUVJKUWGUXAUXAVCUVIUXAXNXOXPXQXRXSUVKKXTWHY
      AUXAUXBYBVFZYDZUWFWAUVICDEUVNGHIKUWIMUWLUWNUXHUWJYCUVIHUVMUBBKUVIUVJUUASZ
      UDUWTUVMKTUXIUWTUVIUVJHBXJXCUVKUVLKYEWCYAUXGYFYGUVICDEFGUVNHIKLMUWLUWNAFI
      SUUBUVHQVSUXHYHVLYIUVIJHSZUVOUVRTUUBUXJAUVHJHBYNXKUBJUVMUVRHUVNUVJJTZUVKU
      VPUVLKUVQKUVJJBYJUVJJUUEYKUXKKYLYMUVNVHUVKUVLKUVJUUEYOKGYPUHUJLGYPYOYQYRY
      SWCUVIUVPXEZUVRKTUUBUXLAUVHJHBXJXKUVPUVQKYEWCYGYT $.
  $}

  ${
    $d f h i x y C $.  $d f h i x y D $.  $d f h i x y G $.  $d f h i x y S $.
    $d f h x .0. $.  $d f h i x I $.  $d f x y ph $.  $d x y Z $.
    dprdcntz2.1 $e |- ( ph -> G dom DProd S ) $.
    dprdcntz2.2 $e |- ( ph -> dom S = I ) $.
    dprdcntz2.c $e |- ( ph -> C C_ I ) $.
    dprdcntz2.d $e |- ( ph -> D C_ I ) $.
    dprdcntz2.i $e |- ( ph -> ( C i^i D ) = (/) ) $.
    ${
      dprdcntz2.z $e |- Z = ( Cntz ` G ) $.
      $( The function ` S ` is a family of subgroups.  (Contributed by Mario
         Carneiro, 26-Apr-2016.) $)
      dprdcntz2 $p |- ( ph ->
        ( G DProd ( S |` C ) ) C_ ( Z ` ( G DProd ( S |` D ) ) ) ) $=
        ( cdprd cfv cdm wss wceq wcel adantr vx vy cres co dprdres simpld dmres
        wbr cin sseqtr4d df-ss sylib syl5eq cgrp cbs csubg dprdgrp eqid dprdssv
        syl cntzsubg cv wa fvres adantl dprdsubg sselda dprdf2 ffvelrnda syldan
        sylancl subgss syl2anc ad2antrr wn simpr wi c0 noel elin eleq2d syl5bbr
        wne mtbiri imnan sylibr imp nelne2 dprdcntz eqsstrd dprdlub cntzrecd )
        ADBUCZEDCUCZNUDZGOZUAEBAEWMNPZUHEWMNUDEDNUDZQABDEFHIJUEUFAWMPBDPZUIZBDB
        UGABWSQWTBRABFWSJIUJBWSUKULUMAEUNSZWOEUOOZQWPEUPOZSAEDWQUHZXAHDEUQUTZXB
        WNEXBURZUSXBWOEGXFMVAVKAUAVBZBSZVCZXGWMOZXGDOZWPXHXJXKRAXGBDVDVEXIWOXKE
        GMXIEWNWQUHZWOXCSAXLXHAXLWOWRQACDEFHIKUEUFTZWNEVFUTAXHXGFSZXKXCSZABFXGJ
        VGZAFXCXGDADEFHIVHVIVJZXIWNXKGOZUBECXMAWNPZCRXHAXSCWSUIZCDCUGACWSQXTCRA
        CFWSKIUJCWSUKULUMTXIXAXKXBQZXRXCSAXAXHXETXIXOYAXQXBXKEXFVLUTXBXKEGXFMVA
        VMXIUBVBZCSZVCZYBWNOZYBDOZXRYCYEYFRXIYBCDVDVEYDDEFYBXGGAXDXHYCHVNAWSFRX
        HYCIVNXICFYBACFQXHKTVGXIXNYCXPTYDYCXGCSZVOZYBXGWCXIYCVPXIYHYCAXHYHAXHYG
        VCZVOXHYHVQAYIXGVRSZXGVSYIXGBCUIZSAYJXGBCVTAYKVRXGLWAWBWDXHYGWEWFWGTYBX
        GCWHVMMWIWJWKWLWJWK $.
    $}

    ${
      dprddisj2.0 $e |- .0. = ( 0g ` G ) $.
      $( The function ` S ` is a family of subgroups.  (Contributed by Mario
         Carneiro, 26-Apr-2016.) $)
      dprddisj2 $p |- ( ph ->
        ( ( G DProd ( S |` C ) ) i^i ( G DProd ( S |` D ) ) ) = { .0. } ) $=
        ( vx vh vi wcel wceq cvv ad2antrr vf cres cdprd co cin csn cv inss1 cdm
        wbr wss dprdres simprd sseld cgsu ccnv cdif cima cfn cfv cixp crab wrex
        syl5ss wa wi eqid eldprd syl cmpt cbs simplr dprdff feqmptd cun difeq2d
        wb wo c0 difindi dif0 3eqtr3g eqimss2 sselda elun simprl dmdprdsplitlem
        sylib simprr jaodan syldan mpteq2dva eqtrd oveq2d cmnd cgrp grpmnd 3syl
        dprdgrp reldmdprd brrelex2i dmexg eqeltrrd gsumz syl2anc ex elin syl6bb
        eleq1 elsn eqeq1 syl5bb imbi12d syl5ibrcom rexlimdva adantld com23 mpdd
        sylbid ssrdv csubg simpld dprdsubg subg0cl sylanbrc snssd eqssd ) AEDBU
        BZUCUDZEDCUBZUCUDZUEZGUFZANYLYMANUGZYLQZYNEDUCUDZQZYNYMQZAYLYPYNAYLYIYP
        YIYKUHAEYHUCUIZUJZYIYPUKZABDEFHIJULZUMVDUNAYQYOYRAYQEDYSUJZYNEUAUGZUOUD
        ZRZUAOUGUPSYMUQURUSQOPFPUGDUTVAVBZVCZVEZYOYRVFZADUIZFRZYQUUIVQIYNDUAOPE
        FUUGGMUUGVGZVHVIAUUHUUJUUCAUUFUUJUAUUGAUUDUUGQZVEZUUJUUFUUEYIQZUUEYKQZV
        EZUUEGRZVFUUOUURUUSUUOUURVEZUUEENFGVJZUOUDZGUUTUUDUVAEUOUUTUUDNFYNUUDUT
        ZVJUVAUUTNFEVKUTZUUDUUTUVDDOPUUDEFUUGGUUMAUUCUUNUURHTZAUULUUNUURITZAUUN
        UURVLZUVDVGVMVNUUTNFUVCGUUTYNFQZYNFBUQZQZYNFCUQZQZVRZUVCGRZUUTUVHVEYNUV
        IUVKVOZQUVMUUTFUVOYNAFUVOUKZUUNUURAUVOFRUVPAFBCUEZUQFVSUQUVOFAUVQVSFLVP
        FBCVTFWAWBFUVOWCVITWDYNUVIUVKWEWHUUTUVJUVNUVLUUTBDOPUUDEFUUGYNGMUUMUVEU
        VFABFUKUUNUURJTUVGUUOUUPUUQWFWGUUTCDOPUUDEFUUGYNGMUUMUVEUVFACFUKUUNUURK
        TUVGUUOUUPUUQWIWGWJWKWLWMWNAUVBGRZUUNUURAEWOQZFSQUVRAUUCEWPQUVSHDEWSEWQ
        WRAUUKFSIAUUCDSQUUKSQHEDYSWTXADSXBWRXCFNESGMXDXETWMXFUUFYOUURYRUUSUUFYO
        UUEYLQUURYNUUEYLXIUUEYIYKXGXHYRYNGRUUFUUSNGXJYNUUEGXKXLXMXNXOXPXSXQXRXT
        AGYLAGYIQZGYKQZGYLQAYTYIEYAUTZQUVTAYTUUAUUBYBYHEYCYIEGMYDWRAEYJYSUJZYKU
        WBQUWAAUWCYKYPUKACDEFHIKULYBYJEYCYKEGMYDWRGYIYKXGYEYFYG $.
    $}
  $}

  ${
    $d i j k x y A $.  $d i k x C $.  $d i j k x y G $.  $d i I $.  $d i k K $.
    $d i j k x y ph $.  $d i j k x y S $.  $d i j X $.
    dprd2d.1 $e |- ( ph -> Rel A ) $.
    dprd2d.2 $e |- ( ph -> S : A --> ( SubGrp ` G ) ) $.
    dprd2d.3 $e |- ( ph -> dom A C_ I ) $.
    dprd2d.4 $e |- ( ( ph /\ i e. I ) ->
      G dom DProd ( j e. ( A " { i } ) |-> ( i S j ) ) ) $.
    dprd2d.5 $e |- ( ph -> G dom DProd
      ( i e. I |-> ( G DProd ( j e. ( A " { i } ) |-> ( i S j ) ) ) ) ) $.
    dprd2d.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( The direct product of a collection of direct products.  (Contributed by
       Mario Carneiro, 26-Apr-2016.) $)
    dprd2dlem2 $p |- ( ( ph /\ X e. A ) -> ( S ` X ) C_
      ( G DProd ( j e. ( A " { ( 1st ` X ) } ) |-> ( ( 1st ` X ) S j ) ) ) ) $=
      ( wcel cfv co wceq wbr wa c2nd c1st csn cima cv cmpt cdprd cop df-ov wrel
      1st2nd sylan simpr eqeltrrd df-br sylibr wb adantr elrelimasn mpbird eqid
      syl oveq2 ovex fvmpt3i fveq2d 3eqtr4a cdm wral wss 1stdm sseldd ralrimiva
      sneq imaeq2d oveq1 mpteq12dv breq2d rspcv sylc dmmpti a1i dprdub eqsstr3d
      ) AIBPZUAZICQZIUBQZEBIUCQZUDZUEZWJEUFZCRZUGZQZFWOUHRWGWJWICRZWJWIUIZCQWPW
      HWJWICUJWGWIWLPZWPWQSWGWSWJWIBTZWGWRBPWTWGIWRBABUKZWFIWRSJIBULUMZAWFUNUOW
      JWIBUPUQWGXAWSWTURAXAWFJUSWJWIBUTVCVAZEWIWNWQWLWOWMWIWJCVDWOVBZWJWMCVEZVF
      VCWGIWRCXBVGVHWGWOFWLWIWGWJGPFEBDUFZUDZUEZXFWMCRZUGZUHVIZTZDGVJZFWOXKTZWG
      BVIZGWJAXOGVKWFLUSAXAWFWJXOPJIBVLUMVMAXMWFAXLDGMVNUSXLXNDWJGXFWJSZXJWOFXK
      XPEXHXIWLWNXPXGWKBXFWJVOVPXFWJWMCVQVRVSVTWAWOVIWLSWGEWLWNWOXEXDWBWCXCWDWE
      $.

    ${
      dprd2d.6 $e |- ( ph -> C C_ I ) $.
      $( The direct product of a collection of direct products.  (Contributed
         by Mario Carneiro, 26-Apr-2016.) $)
      dprd2dlem1 $p |- ( ph -> ( K ` U. ( S " ( A |` C ) ) ) = ( G DProd
        ( i e. C |-> ( G DProd ( j e. ( A " { i } ) |-> ( i S j ) ) ) ) ) ) $=
        ( cfv wcel syl wss vx vk cres cima cuni cv csn cmpt cdprd crn csubg cbs
        co cgrp cacs cmre cdm wbr dprdgrp eqid subgacs acsmre 3syl ciun wf wfun
        wceq ffun funiunfv wral c1st resss sseli dprd2dlem2 sylan2 cvv c2nd cop
        wa wrel 1st2nd syl2an simpr eqeltrrd fvex opelres simprbi imaeq2d oveq1
        ovex sneq mpteq12dv oveq2d elrnmpt1s sylancl elssuni sstrd iunss sylibr
        ralrimiva eqsstr3d cpw sselda syldan dmmpti a1i imassrn mresspw sspwuni
        frn syl5ss sylib mrccl syl2anc adantr oveq2 fvmpt3i adantl wfn ad2antrr
        df-ov ffn wb elrelimasn biimpa simplr sylanbrc fnfvima syl3anc syl5eqel
        df-br vex mrcssidd eqsstrd dprdlub elpw fmptd mrcssvd mrcssd mrcsscl
        eqssd dprdres simpld resmpt breqtrd dprdspan eqtr4d ) ADBCUCZUDZUEZIQZE
        CGFBEUFZUGZUDZUULFUFZDUMZUHZUIUMZUHZUJZUEZIQZGUUSUIUMZAUUKUVBAGUKQZUUJI
        UVAGULQZAGUNRZUVDUVEUOQRUVDUVEUPQRZAGEHUURUHZUIUQZURUVFNUVHGUSSUVEGUVEU
        TVAUVDUVEVBVCZOAUUJUAUUHUAUFZDQZVDZUVAABUVDDVEZDVFUVMUUJVGKBUVDDVHUAUUH
        DVIVCAUVLUVATZUAUUHVJUVMUVATAUVOUAUUHAUVKUUHRZVSZUVLGFBUVKVKQZUGZUDZUVR
        UUODUMZUHZUIUMZUVAUVPAUVKBRZUVLUWCTUUHBUVKBCVLZVMZABDEFGHIUVKJKLMNOVNVO
        UVQUWCUUTRZUWCUVATUVQUVRCRZUWCVPRUWGUVQUVRUVKVQQZVRZUUHRZUWHUVQUVKUWJUU
        HABVTZUWDUVKUWJVGUVPJUWFUVKBWAWBAUVPWCWDUWKUWJBRUWHUVRUWIBCUVKVQWEWFWGS
        GUWBUIWJECUURUWCUVRUUSVPUUSUTZUULUVRVGZUUQUWBGUIUWNFUUNUUPUVTUWAUWNUUMU
        VSBUULUVRWKWHUULUVRUUODWIWLWMWNWOUWCUUTWPSWQWTUAUUHUVLUVAWRWSXAAUVAUUKU
        VEAUUTUUKXBZTZUVAUUKTZACUWOUUSVEUWPAECUURUWOUUSAUULCRZVSZUURUUKTUURUWOR
        UWSUUQUUKUBGUUNAUWRUULHRGUUQUVIURACHUULPXCMXDUUQUQUUNVGUWSFUUNUUPUUQUUL
        UUODWJZUUQUTZXEXFAUUKUVDRZUWRAUVGUUJUVETZUXBUVJAUUIUVEXBZTUXCAUUIDUJZUX
        DDUUHXGAUXEUVDUXDAUVNUXEUVDTKBUVDDXJSAUVGUVDUXDTUVJUVDUVEXHSWQXKUUIUVEX
        IXLZUVDUUJIUVEOXMXNZXOUWSUBUFZUUNRZVSZUXHUUQQZUULUXHDUMZUUKUXIUXKUXLVGU
        WSFUXHUUPUXLUUNUUQUUOUXHUULDXPUXAUWTXQXRUXJUXLUUJUUKUXJUXLUUIRUXLUUJTUX
        JUXLUULUXHVRZDQZUUIUULUXHDYAUXJDBXSZUUHBTZUXMUUHRZUXNUUIRAUXOUWRUXIAUVN
        UXOKBUVDDYBSXTUXPUXJUWEXFUXJUXMBRZUWRUXQUXJUULUXHBURZUXRUWSUXIUXSAUXIUX
        SYCZUWRAUWLUXTJUULUXHBYDSXOYEUULUXHBYKXLAUWRUXIYFUULUXHBCUBYLWFYGBUUHDU
        XMYHYIYJUXLUUIWPSAUUJUUKTUWRUXIAUVDUUJIUVEUVJOUXFYMXTWQYNYOUURUUKGUUQUI
        WJZYPWSUWMYQCUWOUUSXJSUUTUUKXIXLZAUVDUUJIUVEUVJOYRWQYSAUVGUWQUXBUVBUUKT
        UVJUYBUXGUVDUVAIUUKUVEOYTYIUUAAGUUSUVIURUVCUVBVGAGUVHCUCZUUSUVIAGUYCUVI
        URGUYCUIUMGUVHUIUMTACUVHGHNUVHUQHVGAEHUURUVHUYAUVHUTXEXFPUUBUUCACHTUYCU
        USVGPEHCUURUUDSUUEUUSGIOUUFSUUG $.
    $}

    $( The direct product of a collection of direct products.  (Contributed by
       Mario Carneiro, 26-Apr-2016.) $)
    dprd2da $p |- ( ph -> G dom DProd S ) $=
      ( cvv cfv wcel syl wss wceq vx vy eqid cv csn cima co cmpt cdprd cdm cres
      wbr ciun syl5eq wral ovex dmmpti reldmdprd brrelex2i dmexg 3syl syl5eqelr
      syl2anc wa cxp ressn sylancr syl5eqel ralrimiva eqeltrrd c1st c2nd adantr
      wne 1stdm sylan sseldd sneq imaeq2d oveq1 mpteq12dv breq2d sylc 3ad2antr1
      rspcv a1i cop 1st2nd simpr df-br sylibr wb elrelimasn mpbird eqeq12d fvex
      sneqd opth mpbid dprdcntz df-ov oveq2 fvmpt3i fveq2d 3eqtr4a oveq1d eqtrd
      necon3bid oveq2d sseqtr4d ad2antrr eqsstr3d eqsstrd sstrd cdif cuni snssd
      cin cun sylib syl6eq c0 eleq1d simprbi crn imassrn wf frn syl5ss mrcssidd
      sspwuni mrccl difss elrnmpt1s syl6eqr syl3anc sseqtrd subg0cl sylanbrc
      ax-mp ccntz cgrp dprdgrp resiun2 iunid reseq2i eqtr3i wrel relssres xpexg
      c0g iunexg w3a simpr2 eleqtrrd simplr3 simpr1 syl6bb baibd fveq1d 3sstr3d
      snex dprd2dlem2 dprdssv dprdub cntz2ss pm2.61dane clsm csubg cmre subgacs
      cbs acsmre undif2 ssequn1 syl5req reseq2d eqtr3d resundi difeq1d difundir
      cacs neirr brres eldifsni sylbir syl6bi mtoi disjsn eqcomd uneq2d imaundi
      wn disj3 unieqd uniun mresspw unss12 lsmunss sseqtri imass2 mpan2 ralbidv
      cpw rgen ralsn wfun resss eqsstr3i fdm syl5sseqr funimassov unissd biimpa
      ffun ffvelrnd fmptd mrcssd dprdspan fnmpti fnressn opeq2d dprdsubg dprdsn
      simprd disjdif dprdcntz2 adantlr dprd2dlem1 resmpt oveq2i lsmsubg mrcsscl
      sslin ffvelrnda lsmlub mpbi2and dprdres simpld df-ima unieqi fveq2i ss2in
      wfn eqimss dprddisj lsmub2 elin eqssd incom eqimss2 eldifsn simprl sseldi
      opelres elsni syl6eleq xp2nd simprr baib sylancl eqeltrd syl6eleqr syl5bi
      bitrd ex ralrimiv funimass4 lsmdisj2 dmdprdd ) AUAUBCFBHOFUUKPZFUUAPZVVLU
      CZVVKUCZNAFDGFEBDUDZUEZUFZVVOEUDZCUGZUHZUIUGZUHZUIUJZULZFUUBQZMVWBFUUCRZA
      DGBVVPUKZUMZBOAVWHBGUKZBBDGVVPUMZUKVWHVWIDGVVPBUUDVWJGBDGUUEUUFUUGABUUHZB
      UJZGSZVWIBTZIKBGUUIVCZUNAGOQVWGOQZDGUOVWHOQAGVWBUJZODGVWAVWBFVVTUIUPZVWBU
      CZUQZAVWDVWBOQVWQOQMFVWBVWCURUSVWBOUTVAVBAVWPDGAVVOGQZVDZVWGVVPVVQVEZOBVV
      OVFVXBVVPOQVVQOQVXCOQVVOUVBVXBVVQVVTUJZOEVVQVVSVVTVVOVVRCUPVVTUCUQVXBFVVT
      VWCULZVVTOQVXDOQLFVVTVWCURUSVVTOUTVAVBVVPVVQOOUUJVGVHVIDGVWGOOUULVCVJJAUA
      UDZBQZUBUDZBQZVXFVXHVNZUUMZVDZVXFCPZVXHCPZVVLPZSVXFVKPZVXHVKPZVXLVXPVXQTZ
      VDZVXFVLPZEBVXPUEZUFZVXPVVRCUGZUHZPZVXHVLPZVYDPZVVLPVXMVXOVXSVYDFVYBVXTVY
      FVVLVXLFVYDVWCULZVXRAVXIVXGVYHVXJAVXGVDZVXPGQZVXEDGUOZVYHVYIVWLGVXPAVWMVX
      GKVMZAVWKVXGVXPVWLQIVXFBVOVPVQZAVYKVXGAVXEDGLVIZVMVXEVYHDVXPGVVOVXPTZVVTV
      YDFVWCVYOEVVQVVSVYBVYCVYOVVPVYABVVOVXPVRVSVVOVXPVVRCVTWAZWBWEWCZWDVMVYDUJ
      VYBTZVXSEVYBVYCVYDVXPVVRCUPZVYDUCZUQZWFVXLVXTVYBQZVXRAVXIVXGWUBVXJVYIWUBV
      XPVXTBULZVYIVXPVXTWGZBQWUCVYIVXFWUDBAVWKVXGVXFWUDTZIVXFBWHZVPZAVXGWIVJVXP
      VXTBWJWKVYIVWKWUBWUCWLAVWKVXGIVMZVXPVXTBWMRWNZWDZVMVXSVYFBVXQUEZUFZVYBVXL
      VYFWULQZVXRVXLWUMVXQVYFBULZVXLVXQVYFWGZBQZWUNVXLVXHWUOBVXLVWKVXIVXHWUOTZA
      VWKVXKIVMZAVXGVXIVXJUUNZVXHBWHZVCZWUSVJVXQVYFBWJWKVXLVWKWUMWUNWLWURVXQVYF
      BWMRWNZVMVXSVYAWUKBVXSVXPVXQVXLVXRWIZWQVSZUUOVXSVXJVXTVYFVNVXGVXIVXJAVXRU
      UPVXSVXFVXHVXTVYFVXLVXFVXHTZVXRVXTVYFTZVXLWVEWUDWUOTVXRWVFVDVXLVXFWUDVXHW
      UOVXLVWKVXGWUEWURAVXGVXIVXJUUQWUFVCZWVAWOVXPVXTVXQVYFVXFVKWPZVXFVLWPZWRUU
      RUUSXHWSVVMWTVXLVYEVXMTZVXRVXLVXPVXTCUGZWUDCPZVYEVXMVXPVXTCXAZVXLWUBVYEWV
      KTZWUJEVXTVYCWVKVYBVYDVVRVXTVXPCXBVYTVYSXCZRVXLVXFWUDCWVGXDXEVMVXSVYGVXNV
      VLVXSVYGVYFEWULVXQVVRCUGZUHZPZVXNVXSVYFVYDWVQVXSEVYBVYCWULWVPWVDVXSVXPVXQ
      VVRCWVCXFWAUUTVXLWVRVXNTVXRVXLVXQVYFCUGZWUOCPZWVRVXNVXQVYFCXAZVXLWUMWVRWV
      STWVBEVYFWVPWVSWULWVQVVRVYFVXQCXBWVQUCZVXQVVRCUPZXCRVXLVXHWUOCWVAXDXEZVMX
      GXDUVAVXLVXPVXQVNZVDZVXMVXPVWBPZVXOVXLVXMWWGSZWWEAVXIVXGWWHVXJVYIVXMFVYDU
      IUGZWWGABCDEFGHVXFIJKLMNUVCZVYIVYJWWGWWITVYMDVXPVWAWWIGVWBVYOVVTVYDFUIVYP
      XIVWSVWRXCRZXJWDVMWWFWWGVXQVWBPZVVLPZVXOWWFVWBFGVXPVXQVVLAVWDVXKWWEMXKVWQ
      GTZWWFVWTWFVXLVYJWWEAVXIVXGVYJVXJVYMWDVMVXLVXQGQZWWEVXLVWLGVXQAVWMVXKKVMV
      XLVWKVXIVXQVWLQWURWUSVXHBVOVCVQZVMVXLWWEWIVVMWTVXLWWMVXOSWWEVXLWWMFWVQUIU
      GZVVLPZVXOVXLWWLWWQVVLVXLWWOWWLWWQTWWPDVXQVWAWWQGVWBVVOVXQTZVVTWVQFUIWWSE
      VVQVVSWULWVPWWSVVPWUKBVVOVXQVRVSVVOVXQVVRCVTWAZXIVWSVWRXCRXDVXLWWQFUVLPZS
      VXNWWQSWWRVXOSWXAWVQFWXAUCZUVDVXLVXNWVRWWQWWDVXLWVQFWULVYFVXLWWOVYKFWVQVW
      CULZWWPAVYKVXKVYNVMVXEWXCDVXQGWWSVVTWVQFVWCWWTWBWEWCWVQUJWULTVXLEWULWVPWV
      QWWCWWBUQWFWVBUVEXLWXAWWQVXNFVVLWXBVVMUVFVGXMVMXNXNUVGVYIVXMCBVXFUEZXOZUF
      ZXPZHPZXRZVXMCBVYAUKZWXDXOZUFZXPZHPZCBGVYAXOZUKZUFZXPZHPZFUVHPZUGZXRZVVKU
      EZVYIWXHWYASZWXIWYBSVYIFUVIPZWXAUVJPQZWXGWYASWYAWYEQZWYDVYIVWEWYEWXAUWBPQ
      WYFAVWEVXGVWFVMWXAFWXBUVKWYEWXAUVMVAZVYIWXGWXNWXSXSZWYAVYIWXGWXMWXRXSZWYI
      VYIWXGWXLWXQXSZXPWYJVYIWXFWYKVYIWXFCWXKWXPXSZUFWYKVYIWXEWYLCVYIWXEWXKWXPW
      XDXOZXSZWYLVYIWXEWXJWXPXSZWXDXOWYNVYIBWYOWXDVYIBBVYAWXOXSZUKZWYOVYIVWIBWY
      QAVWNVXGVWOVMVYIGWYPBVYIWYPVYAGXSZGVYAGUVNVYIVYAGSWYRGTVYIVXPGVYMXQZVYAGU
      VOXTUVPUVQUVRBVYAWXOUVSYAUVTWXJWXPWXDUWAYAVYIWYMWXPWXKVYIWXPWYMVYIWXPWXDX
      RYBTZWXPWYMTVYIVXFWXPQZUWMWYTVYIXUAVXPVXPVNZVXPUWCVYIXUAWUDWXPQZXUBVYIVXF
      WUDWXPWUGYCXUCVXPVXTWXPULZXUBVXPVXTWXPWJXUDVXPWXOQZXUBXUDWUCXUEVXPVXTBWXO
      WVIUWDYDVXPGVXPUWERUWFUWGUWHWXPVXFUWIWKWXPWXDUWNXTUWJUWKXGVSCWXKWXPUWLYAU
      WOWXLWXQUWPYAVYIWXMWXNSWXRWXSSWYJWYISVYIWYEWXMHWXAWYHNVYIWXLWXAUXDZSWXMWX
      ASZVYIWXLCYEZXUFCWXKYFVYIXUHWYEXUFAXUHWYESZVXGABWYECYGZXUIJBWYECYHRVMVYIW
      YFWYEXUFSWYHWYEWXAUWQRZXNZYIWXLWXAYKXTZYJVYIWYEWXRHWXAWYHNVYIWXQXUFSWXRWX
      ASZVYIWXQXUHXUFCWXPYFXULYIWXQWXAYKXTZYJWXMWXNWXRWXSUWRVCXMVYIWXNWYEQZWXSW
      YEQZWYIWYASVYIWYFXUGXUPWYHXUMWYEWXMHWXANYLVCZVYIWYFXUNXUQWYHXUOWYEWXRHWXA
      NYLVCZWXTWXNWXSFWXTUCZUWSVCXNVYIXUPXUQWXNWXSVVLPZSWYGXURXUSVYIWXNWWIXVAVY
      IWXNVYDYEZXPZHPZWWIVYIWYEWXMHXVCWXAWYHNVYIWXLXVBVYIWXLCVYAVYBVEZUFZXVBWXK
      XVESWXLXVFSWXKWXJXVEWXJWXDYMBVXPVFZUWTZWXKXVECUXAYTVYIXVFXVBSZVXHVVOCUGZX
      VBQZDVYBUOZUBVYAUOZVYIVXPVVOCUGZXVBQZDVYBUOZXVMXVPVYIXVODVYBVVOVYBQXVNOQX
      VOVXPVVOCUPEVYBVYCXVNVVOVYDOVYTVVRVVOVXPCXBYNUXBUXEWFXVLXVPUBVXPWVHVXHVXP
      TZXVKXVODVYBXVQXVJXVNXVBVXHVXPVVOCVTYCUXCUXFWKVYICUXGZXVECUJZSXVIXVMWLVYI
      XUJXVRAXUJVXGJVMZBWYECUXORZVYIBXVEXVSXVEWXJBXVGBVYAUXHZUXIVYIXUJXVSBTXVTB
      WYECUXJRUXKZUBDVYAVYBXVBCUXLVCWNYIUXMVYIXVBXUFSXVCWXASVYIXVBWYEXUFVYIVYBW
      YEVYDYGXVBWYESVYIEVYBVYCWYEVYDVYIVVRVYBQZVDZVYCVXPVVRWGZCPWYEVXPVVRCXAXWE
      BWYEXWFCAXUJVXGXWDJXKXWEVXPVVRBULZXWFBQVYIXWDXWGVYIVWKXWDXWGWLWUHVXPVVRBW
      MRUXNVXPVVRBWJXTUXPVHVYTUXQVYBWYEVYDYHRXUKXNZXVBWXAYKXTUXRVYIVYHWWIXVDTVY
      QVYDFHNUXSRXJZVYIWWIFVWBWXOUKZUIUGZVVLPZXVAVYIWWIFVWBVYAUKZUIUGZXWLVYIXWN
      FVXPWWIWGZUEZUIUGZWWIVYIXWMXWPFUIVYIXWMVXPWWGWGZUEZXWPVYIVWBGVUDVYJXWMXWS
      TDGVWAVWBVWRVWSUXTVYMGVXPVWBUYAVGVYIXWRXWOVYIWWGWWIVXPWWKUYBWQXGXIVYIFXWP
      VWCULZXWQWWITZVYIVYJWWIWYEQZXWTXXAVDVYMVYIVYHXXBVYQVYDFUYCRZVXPWWIFGUYDVC
      UYEXGVYIVYAWXOVWBFGVVLAVWDVXGMVMZWWNVYIVWTWFZWYSWXOGSZVYIGVYAYMZWFZVYAWXO
      XRYBTVYIVYAGUYFWFVVMUYGXLVYIWXSXWKVVLVYIWXSFDWXOVWAUHZUIUGXWKVYIBWXOCDEFG
      HWUHXVTVYLAVXAVXEVXGLUYHXXDNXXHUYIXWJXXIFUIXXFXWJXXITXXGDGWXOVWAUYJYTUYKY
      OZXDXJXNWXTWXNWXSFVVLXUTVVMUYLYPWYEWXGHWYAWXANUYMYPWXHWYAVXMUYNRVYIWXTWXN
      VXMWXSFVVKXUTXURABWYEVXFCJUYOZXUSVVNVYIWXNVXMWXTUGZWXSXRZWYCVYIXXMWWGVWBW
      XOUFZXPZHPZXRZWYCVYIXXLWWGSWXSXXPSZXXMXXQSVYIXXLWWIWWGVYIWXNWWISZVXMWWISZ
      XXLWWISZXWIWWJVYIXUPVXMWYEQZXXBXXSXXTVDXYAWLXURXXKXXCWXTWXNVXMWWIFXUTUYPY
      PUYQWWKXJVYIWXSXXPTXXRVYIWXSXWKXXPXXJVYIXWKXWJYEZXPZHPZXXPVYIFXWJVWCULZXW
      KXYETVYIXYFXWKFVWBUIUGSVYIWXOVWBFGXXDXXEXXHUYRUYSXWJFHNUXSRXXOXYDHXXNXYCV
      WBWXOUYTVUAVUBYOXGWXSXXPVUERXXLWWGWXSXXPVUCVCVYIVWBFGHVXPVVKXXDXXEVYMVVNN
      VUFYQVYIVVKXXMVYIVVKXXLQVVKWXSQZVVKXXMQVYIVXMXXLVVKVYIXUPXYBVXMXXLSXURXXK
      WXTWXNVXMFXUTVUGVCVYIXYBVVKVXMQZXXKVXMFVVKVVNYRRZVQVYIXUQXYGXUSWXSFVVKVVN
      YRRVVKXXLWXSVUHYSXQVUIVYIWXNVXMXRVXMWXNXRZWYCWXNVXMVUJVYIXYJWYCVYIXYJVYEV
      YDVYBVXTUEZXOZUFZXPZHPZXRZWYCVYIVXMVYESZWXNXYOSXYJXYPSVYIWVJXYQVYIWVKWVLV
      YEVXMWVMVYIWUBWVNWUIWVORVYIVXFWUDCWUGXDXEVXMVYEVUKRVYIWYEWXMHXYNWXAWYHNVY
      IWXLXYMVYIWXLXYMSZVXNXYMQZUBWXKUOZVYIXYSUBWXKVXHWXKQVXHWXJQZVXHVXFVNZVDZV
      YIXYSVXHWXJVXFVULVYIYUCXYSVYIYUCVDZVXNVYDXYLUKZYEZXYMYUDVXNVXPVYFCUGZYUFY
      UDVXNWVSYUGYUDVXNWVTWVSYUDVXHWUOCYUDVWKVXIWUQAVWKVXGYUCIXKYUDWXJBVXHXWBVY
      IYUAYUBVUMZVUNWUTVCZXDWWAYOYUDVXQVXPVYFCYUDVXQVYAQZVXQVXPTZYUDWUOWXJQZYUJ
      YUDVXHWUOWXJYUIYUHVJYULWUPYUJVXQVYFBVYAVXHVLWPZVUOYDRVXQVXPVUPRZXFXGYUDVY
      FXYLQZYUGOQYUGYUFQYUDVYFVYBQZVYFVXTVNZYUOYUDVXHXVEQYUPYUDVXHWXJXVEYUHXVGV
      UQVXHVYAVYBVURRYUDYUBYUQVYIYUAYUBVUSYUDVXHVXFVYFVXTYUDVXHVXFTWUOWUDTZVYFV
      XTTZYUDVXHWUOVXFWUDYUIVYIWUEYUCWUGVMWOYUDYUKYURYUSWLYUNYURYUKYUSVXQVYFVXP
      VXTVXHVKWPYUMWRVUTRVVEXHWSVYFVYBVXTVULYSVXPVYFCUPEXYLVYCYUGVYFYUEOXYLVYBS
      YUEEXYLVYCUHTVYBXYKYMEVYBXYLVYCUYJYTVVRVYFVXPCXBYNVVAVVBVYDXYLUYTVVCVVFVV
      DVVGVYIXVRWXKXVSSXYRXYTWLXWAVYIWXKXVEXVSXVHXWCYIUBWXKXYMCVVHVCWNUXMVYIXYM
      XUFSXYNWXASVYIXYMXVBXUFVYDXYLYFXWHYIXYMWXAYKXTUXRVXMVYEWXNXYOVUCVCVYIVYDF
      VYBHVXTVVKVYQVYRVYIWUAWFWUIVVNNVUFYQVYIVVKXYJVYIXYHVVKWXNQZVVKXYJQXYIVYIX
      UPYUTXURWXNFVVKVVNYRRVVKVXMWXNVUHYSXQVUIUNVVIYQVVJ $.

    $( The direct product of a collection of direct products.  (Contributed by
       Mario Carneiro, 25-Apr-2016.) $)
    dprd2db $p |- ( ph -> ( G DProd S ) = ( G DProd
      ( i e. I |-> ( G DProd ( j e. ( A " { i } ) |-> ( i S j ) ) ) ) ) ) $=
      ( cdprd co cuni cfv cima wceq crn cres csn cmpt cdm dprd2da dprdspan wrel
      cv wbr syl wss relssres syl2anc imaeq2d csubg wfn ffn fnima eqtr2d unieqd
      wf 3syl fveq2d ssid a1i dprd2dlem1 3eqtrd ) AFCOPZCUAZQZHRZCBGUBZSZQZHRFD
      GFEBDUIZUCSVPEUICPUDOPUDOPAFCOUEUJVIVLTABCDEFGHIJKLMNUFCFHNUGUKAVKVOHAVJV
      NAVNCBSZVJAVMBCABUHBUEGULVMBTIKBGUMUNUOABFUPRZCVBCBUQVQVJTJBVRCURBCUSVCUT
      VAVDABGCDEFGHIJKLMNGGULAGVEVFVGVH $.
  $}

  ${
    $d i j x y z G $.  $d i j x y z I $.  $d j x y z J $.  $d i j x y z ph $.
    $d x y z S $.
    dprd2d2.1 $e |- ( ( ph /\ ( i e. I /\ j e. J ) ) -> S e. ( SubGrp ` G ) )
        $.
    dprd2d2.2 $e |- ( ( ph /\ i e. I ) -> G dom DProd ( j e. J |-> S ) ) $.
    dprd2d2.3 $e |- ( ph -> G dom DProd
      ( i e. I |-> ( G DProd ( j e. J |-> S ) ) ) ) $.
    $( The direct product of a collection of direct products.  (Contributed by
       Mario Carneiro, 26-Apr-2016.) $)
    dprd2d2 $p |- ( ph -> ( G dom DProd ( i e. I , j e. J |-> S ) /\
      ( G DProd ( i e. I , j e. J |-> S ) ) = ( G DProd
      ( i e. I |-> ( G DProd ( j e. J |-> S ) ) ) ) ) ) $=
      ( vx vy cdprd co cmpt cv wcel wa nfcv wex cmpt2 cdm wbr wceq csn cxp ciun
      vz csubg cfv cmrc wrel wral relxp rgenw reliun mpbir wf ralrimivva fmpt2x
      a1i eqid sylib dmiun wss dmxpss simpr snssd syl5ss ralrimiva iunss sylibr
      syl5eqss csb cima simprl simprr ovmpt4g syl3anc anassrs mpteq2dva nfcsb1v
      breqtrrd nfmpt21 nfov nfmpt nfbr weq csbeq1a oveq1 mpteq12dv breq2d mpan9
      rspc nfmpt22 oveq2 cbvmpt cop nfv nfcri nfan eleq2d anbi2d equsex eqeltrd
      simplr biantrurd pm5.32da anass opth bitr2i anbi1i 3bitr3g exbidv syl5bbr
      eqcom vex eleq1 ceqsexv excom elrelimasn ax-mp df-br eliunxp 3bitri eqrdv
      wb syl6bbr mpteq1d syl5eq breqtrd oveq2d dprd2da dprd2db eqtr3d eqtrd jca
      ) AECDFGBUAZMUBZUCEYRMNZECFEDGBOZMNZOZMNZUDACFCPZUEZGUFZUGZYRKLEFEUIUJZUK
      UJZUUHULZAUUKUUGULZCFUMUULCFUUFGUNUOCFUUGUPUQZVAZABUUIQZDGUMCFUMUUHUUIYRU
      RAUUOCDFGHUSCDFGBUUIYRYRVBZUTVCZAUUHUBCFUUGUBZUGZFCFUUGVDAUURFVEZCFUMUUSF
      VEAUUTCFAUUEFQZRZUURUUFFUUFGVFUVBUUEFAUVAVGVHVIVJCFUURFVKVLVMZAKPZFQZRZED
      CUVDGVNZUVDDPZYRNZOZLUUHUVDUEVOZUVDLPZYRNZOZYSAEDGUUEUVHYRNZOZYSUCZCFUMUV
      EEUVJYSUCZAUVQCFUVBEUUAUVPYSIUVBDGUVOBAUVAUVHGQZUVOBUDZAUVAUVSRZRUVAUVSUU
      OUVTAUVAUVSVPAUVAUVSVQHCDFGBYRUUIUUPVRVSVTWAZWCVJUVQUVRCUVDFCEUVJYSCESZCY
      SSCDUVGUVICUVDGWBZCUVDUVHYRCUVDSCDFGBWDCUVHSWEWFZWGCKWHZUVPUVJEYSUWFDGUVO
      UVGUVICUVDGWIZUUEUVDUVHYRWJWKZWLWNWMUVFUVJLUVGUVMOUVNDLUVGUVIUVMLUVISDUVD
      UVLYRDUVDSCDFGBWODUVLSWEUVHUVLUVDYRWPWQUVFLUVGUVKUVMUVFUHUVGUVKUVFUHPZUVG
      QZUVDUWIWRZUUEUVHWRZUDZUWARZDTCTZUWIUVKQZUVFDUHWHZUVHUVGQZRZDTUWNCTZDTUWJ
      UWOUVFUWSUWTDUWSUWFUWQUVSRZRZCTUVFUWTUXAUWSCKUWQUWRCUWQCWSCDUVGUWDWTXAUWF
      UVSUWRUWQUWFGUVGUVHUWGXBXCXDUVFUXBUWNCUVFUWFUWQRZUVSRUXCUWARUXBUWNUVFUXCU
      VSUWAUVFUXCRZUVAUVSUXDUUEUVDFUVFUWFUWQVPAUVEUXCXFXEXGXHUWFUWQUVSXIUXCUWMU
      WAUWMUWLUWKUDUXCUWKUWLXPUUEUVHUVDUWICXQDXQXJXKXLXMXNXOXNUWRUWJDUWIUHXQUVH
      UWIUVGXRXSUWNDCXTXMUWPUVDUWIUUHUCZUWKUUHQUWOUUKUWPUXEYGUUMUVDUWIUUHYAYBUV
      DUWIUUHYCCDFGUWKYDYEYHYFYIYJZYKZAECFEUVPMNZOZKFEUVNMNZOZYSAEUUCUXIYSJACFU
      XHUUBUVBUVPUUAEMUWBYLWAZWCAUXIKFEUVJMNZOUXKCKFUXHUXMKUXHSCEUVJMUWCCMSUWEW
      EUWFUVPUVJEMUWHYLWQAKFUXMUXJUVFUVJUVNEMUXFYLWAYJZYKZUUJVBZYMAYTEUXKMNUUDA
      UUHYRKLEFUUJUUNUUQUVCUXGUXOUXPYNAUXKUUCEMAUXIUXKUUCUXNUXLYOYLYPYQ $.
  $}

  ${
    $d x .(+) $.  $d x y C $.  $d x D $.  $d x y G $.  $d x y I $.  $d x y S $.
    $d x y ph $.  $d y X $.  $d y Z $.
    dprdsplit.2 $e |- ( ph -> S : I --> ( SubGrp ` G ) ) $.
    dprdsplit.i $e |- ( ph -> ( C i^i D ) = (/) ) $.
    dprdsplit.u $e |- ( ph -> I = ( C u. D ) ) $.
    ${
      dmdprdsplit.z $e |- Z = ( Cntz ` G ) $.
      dmdprdsplit.0 $e |- .0. = ( 0g ` G ) $.
      ${
        dmdprdsplit2.1 $e |- ( ph -> G dom DProd ( S |` C ) ) $.
        dmdprdsplit2.2 $e |- ( ph -> G dom DProd ( S |` D ) ) $.
        dmdprdsplit2.3 $e |- ( ph ->
          ( G DProd ( S |` C ) ) C_ ( Z ` ( G DProd ( S |` D ) ) ) ) $.
        dmdprdsplit2.4 $e |- ( ph ->
          ( ( G DProd ( S |` C ) ) i^i ( G DProd ( S |` D ) ) ) = { .0. } ) $.
        ${
          dmdprdsplit2lem.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
          $( Lemma for ~ dmdprdsplit .  (Contributed by Mario Carneiro,
             26-Apr-2016.) $)
          dmdprdsplit2lem $p |- ( ( ph /\ X e. C ) ->
            ( ( Y e. I -> ( X =/= Y -> ( S ` X ) C_ ( Z ` ( S ` Y ) ) ) ) /\
           ( ( S ` X ) i^i ( K ` U. ( S " ( I \ { X } ) ) ) ) C_ { .0. } ) ) $=
            ( vy wcel wa wne cfv wss wi csn cdif cima cuni cin wo adantr eleq2d
            cun wceq elun syl6bb cres cdprd cdm wbr ad2antrr csubg wf syl5sseqr
            ssun1 fssres syl2anc fdm syl simplr simprl simprr dprdcntz ad2antlr
            fvres ad2antrl fveq2d 3sstr3d exp32 co dprdub eqsstr3d eqid dprdssv
            ssun2 cntz2ss sylancr sstrd jaod sylbid clsm cmre cgrp cacs dprdgrp
            cbs subgacs acsmre 3syl difundir difeq1d c0 simpr snssd sslin incom
            syl5eqr sseq0 disj3 sylib uneq2d 3eqtr4a imaeq2d syl6eq uniun difss
            imaundi unieqd imass2 imassrn syl5ss sspwuni mrcssidd df-ima unieqi
            crn dprdspan fveq2i syl6eqr sseqtr4d syl3anc mrcsscl adantl sseqtrd
            dprdsubg subg0cl uniss cpw frn mresspw unss12 mrccl lsmunss eqsstrd
            a1i mrcssd lsmsubg sselda ffvelrnda syldan wb lsmlub mpbi2and ssrin
            mp2b lsmub1 sseldd elin sylanbrc eqssd resima2 mp1i dprddisj eqtr3d
            ineq12d cv ciun wfun ffun funiunfv eldifi eldifsni ralrimiva sylibr
            wral iunss subgss cntzsubg cntzrecd lsmdisj3 jca ) AHBUCZUDZIFUCZHI
            UEZHDUFZIDUFZKUFZUGZUHZUHUWJDFHUIZUJZUKZULZGUFZUMZJUIZUGUWGUWHIBUCZ
            ICUCZUNZUWNUWGUWHIBCUQZUCUXDUWGFUXEIAFUXEURUWFNUOZUPIBCUSUTUWGUXBUW
            NUXCUWGUXBUWIUWMUWGUXBUWIUDZUDZHDBVAZUFZIUXIUFZKUFUWJUWLUXHUXIEBHIK
            AEUXIVBVCZVDZUWFUXGQVEAUXIVCBURZUWFUXGABEVFUFZUXIVGZUXNAFUXODVGZBFU
            GUXPLAUXEBFBCVINVHZFUXOBDVJVKBUXOUXIVLVMZVEAUWFUXGVNUWGUXBUWIVOUWGU
            XBUWIVPOVQUWFUXJUWJURZAUXGHBDVSZVRUXHUXKUWKKUXBUXKUWKURUWGUWIIBDVSV
            TWAWBWCUWGUXCUWIUWMUWGUXCUWIUDZUDZUWJEUXIVBWDZUWLUYCUWJUXJUYDUWFUXT
            AUYBUYAVRUYCUXIEBHAUXMUWFUYBQVEAUXNUWFUYBUXSVEAUWFUYBVNWEWFUYCUYDED
            CVAZVBWDZKUFZUWLAUYDUYGUGZUWFUYBSVEUYCUYFEWTUFZUGUWKUYFUGUYGUWLUGUY
            IUYEEUYIWGZWHUYCUWKIUYEUFZUYFUXCUYKUWKURUWGUWIICDVSVTUYCUYEECIAEUYE
            UXLVDZUWFUYBRVEAUYEVCCURZUWFUYBACUXOUYEVGZUYMAUXQCFUGUYNLAUXECFCBWI
            NVHFUXOCDVJVKCUXOUYEVLVMVEUWGUXCUWIVOWEWFUYIUYFUWKEKUYJOWJWKWLWLWCW
            MWNUWGUWTUWJDBUWOUJZUKZULZGUFZUYFEWOUFZWDZUMZUXAUWGUWSUYTUGZUWTVUAU
            GUWGUXOUYIWPUFUCZUWRUYTUGUYTUXOUCZVUBUWGEWQUCZUXOUYIWRUFUCVUCAVUEUW
            FAUXMVUEQUXIEWSVMUOZUYIEUYJXAUXOUYIXBXCZUWGUWRUYQDCUKZULZUQZUYTUWGU
            WRUYPVUHUQZULVUJUWGUWQVUKUWGUWQDUYOCUQZUKVUKUWGUWPVULDUWGUXEUWOUJUY
            OCUWOUJZUQUWPVULBCUWOXDUWGFUXEUWOUXFXEUWGCVUMUYOUWGCUWOUMZXFURZCVUM
            URUWGVUNCBUMZUGZVUPXFURVUOUWGUWOBUGVUQUWGHBAUWFXGZXHUWOBCXIVMUWGVUP
            BCUMZXFBCXJAVUSXFURUWFMUOXKVUNVUPXLVKCUWOXMXNXOXPXQDUYOCYAXRYBUYPVU
            HXSXRUWGVUJUYRUYFUQZUYTUWGUYQUYRUGVUIUYFUGVUJVUTUGUWGUXOUYQGUYIVUGU
            AUWGUYQDBUKZULZUYIUYOBUGZUYPVVAUGUYQVVBUGZBUWOXTZUYOBDYCUYPVVAUUAUU
            SZUWGVVAUYIUUBZUGVVBUYIUGUWGVVADYJZVVGDBYDUWGVVHUXOVVGAVVHUXOUGZUWF
            AUXQVVILFUXODUUCVMUOUWGVUCUXOVVGUGVUGUXOUYIUUDVMWLZYEVVAUYIYFXNZYEZ
            YGUWGVUIVUIGUFZUYFUWGUXOVUIGUYIVUGUAUWGVUHVVGUGVUIUYIUGUWGVUHVVHVVG
            DCYDVVJYEVUHUYIYFXNYGAUYFVVMURUWFAUYFUYEYJZULZGUFZVVMAUYLUYFVVPURRU
            YEEGUAYKVMVUIVVOGVUHVVNDCYHYIYLYMUOYNUYQUYRVUIUYFUUEVKUWGUYRUXOUCZU
            YFUXOUCZVUTUYTUGUWGVUCUYQUYIUGVVQVUGVVLUXOUYQGUYIUAUUFVKZAVVRUWFAUY
            LVVRRUYEEYSVMUOZUYSUYRUYFEUYSWGZUUGVKWLUUHUWGVVQVVRUYRUYGUGVUDVVSVV
            TUWGUYRUYDUYGUWGUYRVVBGUFZUYDUWGUXOUYQGVVBUYIVUGUAVVDUWGVVFUUIVVKUU
            JAUYDVWBURUWFAUYDUXIYJZULZGUFZVWBAUXMUYDVWEURQUXIEGUAYKVMVVBVWDGVVA
            VWCDBYHYIYLYMUOYNZAUYHUWFSUOWLUYSUYRUYFEKVWAOUUKYOUXOUWRGUYTUYIUAYP
            YOUWSUYTUWJXIVMUWGUYSUWJUYRUYFEJKVWAAUWFHFUCUWJUXOUCZABFHUXRUULAFUX
            OHDLUUMUUNZVVSVVTPUWGUWJUYRUYSWDZUYFUMZUXAUWGVWJUYDUYFUMZUXAUWGVWIU
            YDUGZVWJVWKUGUWGUWJUYDUGZUYRUYDUGZVWLUWGUWJUXJUYDUWFUXTAUYAYQZUWGUX
            IEBHAUXMUWFQUOZAUXNUWFUXSUOZVURWEWFVWFUWGVWGVVQUYDUXOUCZVWMVWNUDVWL
            UUOVWHVVSAVWRUWFAUXMVWRQUXIEYSVMUOUYSUWJUYRUYDEVWAUUPYOUUQVWIUYDUYF
            UURVMAVWKUXAURUWFTUOYRUWGJVWJUWGJVWIUCJUYFUCZJVWJUCUWGUWJVWIJUWGVWG
            VVQUWJVWIUGVWHVVSUYSUWJUYREVWAUUTVKUWGVWGJUWJUCVWHUWJEJPYTVMUVAUWGV
            VRVWSVVTUYFEJPYTVMJVWIUYFUVBUVCXHUVDUWGUXJUXIUYOUKZULZGUFZUMUWJUYRU
            MUXAUWGUXJUWJVXBUYRVWOUWGVXAUYQGUWGVWTUYPVVCVWTUYPURUWGVVEDUYOBUVEU
            VFYBWAUVIUWGUXIEBGHJVWPVWQVURPUAUVGUVHOUWGUYRUWJEKOVVSVWHUWGVUCUYQU
            WJKUFZUGVXCUXOUCZUYRVXCUGVUGUWGUYQUBUYOUBUVJZDUFZUVKZVXCUWGUXQDUVLV
            XGUYQURAUXQUWFLUOFUXODUVMUBUYODUVNXCUWGVXFVXCUGZUBUYOUVSVXGVXCUGUWG
            VXHUBUYOUWGVXEUYOUCZUDZVXEUXIUFZUXJKUFVXFVXCVXJUXIEBVXEHKAUXMUWFVXI
            QVEAUXNUWFVXIUXSVEVXIVXEBUCZUWGVXEBUWOUVOYQZAUWFVXIVNVXIVXEHUEUWGVX
            EBHUVPYQOVQVXJVXLVXKVXFURVXMVXEBDVSVMVXJUXJUWJKUWFUXTAVXIUYAVRWAWBU
            VQUBUYOVXFVXCUVTUVRWFUWGVUEUWJUYIUGZVXDVUFUWGVWGVXNVWHUYIUWJEUYJUWA
            VMUYIUWJEKUYJOUWBVKUXOUYQGVXCUYIUAYPYOUWCUWDYRUWE $.
        $}

        $( The direct product splits into the direct product of any partition
           of the index set.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
        dmdprdsplit2 $p |- ( ph -> G dom DProd S ) $=
          ( cfv cvv wcel vx csubg cmrc eqid cres cdprd cdm wbr cgrp dprdgrp syl
          vy cun wf wceq wss ssun1 syl5sseqr fssres syl2anc reldmdprd brrelex2i
          fdm dmexg 3syl eqeltrrd ssun2 unexg eqeltrd cv wne eleq2d elun syl6bb
          wo wi wa csn cdif cima cuni cin dmdprdsplit2lem c0 incom uncom syl6eq
          syl5eqr co dprdsubg cntzrecd jaodan simpld sylbid 3imp2 biimpa simprd
          ex syldan dmdprdd ) AUAULDEFEUBRZUCRZSGHLMXBUDZAEDBUEZUFUGZUHZEUITNXD
          EUJUKAFBCUMZSKABSTCSTXGSTAXDUGZBSABXAXDUNZXHBUOAFXADUNZBFUPXIIAXGBFBC
          UQKURFXABDUSUTBXAXDVCUKAXFXDSTXHSTNEXDXEVAVBXDSVDVEVFADCUEZUGZCSACXAX
          KUNZXLCUOAXJCFUPXMIAXGCFCBVGKURFXACDUSUTCXAXKVCUKAEXKXEUHZXKSTXLSTOEX
          KXEVAVBXKSVDVEVFBCSSVHUTVIIAUAVJZFTZULVJZFTZXOXQVKZXODRZXQDRHRUPZAXPX
          OBTZXOCTZVOZXRXSYAVPVPZAXPXOXGTYDAFXGXOKVLXOBCVMVNZAYDYEAYDVQYEXTDFXO
          VRVSVTWAXBRWBGVRZUPZAYBYEYHVQYCABCDEFXBXOXQGHIJKLMNOPQXCWCZACBDEFXBXO
          XQGHIACBWBBCWBWDBCWEJWHAFXGCBUMKBCWFWGLMONAEXDUFWIZEXKUFWIZEHLAXFYJXA
          TNXDEWJUKAXNYKXATOXKEWJUKPWKAYKYJWBYJYKWBYGYJYKWEQWHXCWCZWLWMWRWNWOAX
          PYDYHAXPYDYFWPAYBYHYCAYBVQYEYHYIWQAYCVQYEYHYLWQWLWSWT $.
      $}

      $( The direct product splits into the direct product of any partition of
         the index set.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
      dmdprdsplit $p |- ( ph -> ( G dom DProd S <->
     ( ( G dom DProd ( S |` C ) /\ G dom DProd ( S |` D ) ) /\
       ( G DProd ( S |` C ) ) C_ ( Z ` ( G DProd ( S |` D ) ) ) /\
       ( ( G DProd ( S |` C ) ) i^i ( G DProd ( S |` D ) ) ) = { .0. } ) ) ) $=
        ( cdprd wbr wa co wss wceq adantr cdm cres cfv cin csn w3a simpr wf fdm
        csubg syl cun ssun1 syl5sseqr dprdres simpld jca c0 dprdcntz2 dprddisj2
        ssun2 3jca simpr1l simpr1r simpr2 simpr3 dmdprdsplit2 impbida ) AEDNUAZ
        OZEDBUBZVIOZEDCUBZVIOZPZEVKNQZEVMNQZHUCRZVPVQUDGUESZUFZAVJPZVOVRVSWAVLV
        NWAVLVPEDNQZRWABDEFAVJUGZADUAFSZVJAFEUJUCZDUHZWDIFWEDUIUKTZWABCULZBFBCU
        MAFWHSZVJKTZUNZUOUPWAVNVQWBRWACDEFWCWGWAWHCFCBVAWJUNZUOUPUQWABCDEFHWCWG
        WKWLABCUDURSZVJJTZLUSWABCDEFGWCWGWKWLWNMUTVBAVTPBCDEFGHAWFVTITAWMVTJTAW
        IVTKTLMVLVNVRVSAVCVLVNVRVSAVDAVOVRVSVEAVOVRVSVFVGVH $.
    $}

    dprdsplit.s $e |- .(+) = ( LSSum ` G ) $.
    dprdsplit.1 $e |- ( ph -> G dom DProd S ) $.
    $( The direct product is the binary subgroup product ("sum") of the direct
       products of the partition.  (Contributed by Mario Carneiro,
       25-Apr-2016.) $)
    dprdsplit $p |- ( ph -> ( G DProd S ) =
      ( ( G DProd ( S |` C ) ) .(+) ( G DProd ( S |` D ) ) ) ) $=
      ( cdprd co cfv wceq syl wcel wss adantr vx csubg wf cdm fdm ccntz wbr cun
      cres ssun1 syl5sseqr dprdres simpld dprdsubg ssun2 wa cin c0g dmdprdsplit
      csn w3a eqid mpbid simp2d lsmsubg syl3anc cv wo eleq2d elun syl6bb biimpa
      adantl fssres syl2anc dprdub eqsstr3d lsmub1 lsmub2 jaodan syldan dprdlub
      fvres simpr sstrd simprd wb lsmlub mpbi2and eqssd ) AFEMNZFEBUIZMNZFECUIZ
      MNZDNZAEWPUAFGLAGFUBOZEUCZEUDGPHGWQEUEQZAWMWQRZWOWQRZWMWOFUFOZOSZWPWQRAFW
      LMUDZUGZWTAXEWMWKSZABEFGLWSABCUHZBGBCUJJUKZULZUMZWLFUNQZAFWNXDUGZXAAXLWOW
      KSZACEFGLWSAXGCGCBUOJUKZULZUMZWNFUNQZAXEXLUPZXCWMWOUQFUROZUTPZAFEXDUGZXRX
      CXTVALABCEFGXSXBHIJXBVBZXSVBUSVCVDDWMWOFXBKYBVEVFAUAVGZGRZYCBRZYCCRZVHZYC
      EOZWPSZAYDYGAYDYCXGRYGAGXGYCJVIYCBCVJVKVLAYEYIYFAYEUPZYHWMWPYJYHYCWLOZWMY
      EYKYHPAYCBEWCVMYJWLFBYCAXEYEXJTAWLUDBPZYEABWQWLUCZYLAWRBGSYMHXHGWQBEVNVOB
      WQWLUEQTAYEWDVPVQAWMWPSZYEAWTXAYNXKXQDWMWOFKVRVOTWEAYFUPZYHWOWPYOYHYCWNOZ
      WOYFYPYHPAYCCEWCVMYOWNFCYCAXLYFXPTAWNUDCPZYFACWQWNUCZYQAWRCGSYRHXNGWQCEVN
      VOCWQWNUEQTAYFWDVPVQAWOWPSZYFAWTXAYSXKXQDWMWOFKVSVOTWEVTWAWBAXFXMWPWKSZAX
      EXFXIWFAXLXMXOWFAWTXAWKWQRZXFXMUPYTWGXKXQAYAUUALEFUNQDWMWOWKFKWHVFWIWJ $.
  $}

  ${
    dmdprdpr.z $e |- Z = ( Cntz ` G ) $.
    dmdprdpr.0 $e |- .0. = ( 0g ` G ) $.
    dmdprdpr.s $e |- ( ph -> S e. ( SubGrp ` G ) ) $.
    dmdprdpr.t $e |- ( ph -> T e. ( SubGrp ` G ) ) $.
    $( A singleton family is an internal direct product, the product of which
       is the given subgroup.  (Contributed by Mario Carneiro, 25-Apr-2016.) $)
    dmdprdpr $p |- ( ph -> ( G dom DProd `' ( { S } +c { T } ) <->
        ( S C_ ( Z ` T ) /\ ( S i^i T ) = { .0. } ) ) ) $=
      ( csn co cdprd wbr c0 c1o wceq wa wcel c2o ccda ccnv cdm cres cfv wss cin
      wb cop cvv csubg 0ex dprdsn sylancr simpld wfn xpscf sylanbrc ffn syl cpr
      wf prid1 df2o3 eleqtrri fnressn sylancl xpsc0 opeq2d sneqd eqtrd breqtrrd
      con0 1on elexi prid2 xpsc1 w3a wne 1n0 necomi disjsn2 cun df-pr eqtri a1i
      mp1i dmdprdsplit 3anass syl6bb baibd mp2and oveq2d simprd sseq12d ineq12d
      ex fveq2d eqeq1d anbi12d bitrd ) ADBKCKUALUBZMUCZNZDXBOKZUDZMLZDXBPKZUDZM
      LZFUEZUFZXGXJUGZEKZQZRZBCFUEZUFZBCUGZXNQZRADXFXCNZDXIXCNZXDXPUHZADOBUIZKZ
      XFXCADYEXCNZDYEMLZBQZAOUJSBDUKUEZSZYFYHRULIOBDUJUMUNZUOAXFOOXBUEZUIZKZYEA
      XBTUPZOTSXFYNQATYIXBVBZYOAYJCYISZYPIJYIBCUQURZTYIXBUSUTZOOPVAZTOPULVCVDVE
      TOXBVFVGAYMYDAYLBOAYJYLBQIBCYIVHUTVIVJVKZVLADPCUIZKZXIXCADUUCXCNZDUUCMLZC
      QZAPVMSYQUUDUUFRVNJPCDVMUMUNZUOAXIPPXBUEZUIZKZUUCAYOPTSXIUUJQYSPYTTOPPVMV
      NVOVPVDVETPXBVFVGAUUIUUBAUUHCPAYQUUHCQJBCYIVQUTVIVJVKZVLAYAYBRZYCAXDUULXP
      AXDUULXLXOVRUULXPRAXEXHXBDTEFYROPVSXEXHUGOQAPOVTWAOPWBWGTXEXHWCZQATYTUUMV
      DOPWDWEWFGHWHUULXLXOWIWJWKWQWLAXLXRXOXTAXGBXKXQAXGYGBAXFYEDMUUAWMAYFYHYKW
      NVKZAXJCFAXJUUECAXIUUCDMUUKWMAUUDUUFUUGWNVKZWRWOAXMXSXNAXGBXJCUUNUUOWPWSW
      TXA $.

    dprdpr.s $e |- .(+) = ( LSSum ` G ) $.
    dprdpr.1 $e |- ( ph -> S C_ ( Z ` T ) ) $.
    dprdpr.2 $e |- ( ph -> ( S i^i T ) = { .0. } ) $.
    $( A singleton family is an internal direct product, the product of which
       is the given subgroup.  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
    dprdpr $p |- ( ph -> ( G DProd `' ( { S } +c { T } ) ) = ( S .(+) T ) ) $=
      ( csn co c0 c1o c2o wceq ccda ccnv cdprd cres csubg cfv wf xpscf sylanbrc
      wcel wne cin 1n0 necomi disjsn2 cun cpr df2o3 df-pr eqtri a1i cdm wbr wss
      dmdprdpr mpbir2and dprdsplit cop wfn ffn syl 0ex eleqtrri fnressn sylancl
      mp1i prid1 xpsc0 opeq2d sneqd eqtrd oveq2d cvv dprdsn sylancr simprd con0
      wa 1on elexi prid2 xpsc1 oveq12d ) AECODOUAPUBZUCPEWNQOZUDZUCPZEWNROZUDZU
      CPZBPCDBPAWOWRBWNESACEUEUFZUJZDXAUJZSXAWNUGZJKXACDUHUIZQRUKWOWRULQTARQUMU
      NQRUOVPSWOWRUPZTASQRUQZXFURQRUSUTVALAEWNUCVBZVCCDGUFVDCDULFOTMNACDEFGHIJK
      VEVFVGAWQCWTDBAWQEQCVHZOZUCPZCAWPXJEUCAWPQQWNUFZVHZOZXJAWNSVIZQSUJWPXNTAX
      DXOXESXAWNVJVKZQXGSQRVLVQURVMSQWNVNVOAXMXIAXLCQAXBXLCTJCDXAVRVKVSVTWAWBAE
      XJXHVCZXKCTZAQWCUJXBXQXRWHVLJQCEWCWDWEWFWAAWTERDVHZOZUCPZDAWSXTEUCAWSRRWN
      UFZVHZOZXTAXORSUJWSYDTXPRXGSQRRWGWIWJWKURVMSRWNVNVOAYCXSAYBDRAXCYBDTKCDXA
      WLVKVSVTWAWBAEXTXHVCZYADTZARWGUJXCYEYFWHWIKRDEWGWDWEWFWAWMWA $.
  $}

  ${
    $d h k x .0. $.  $d f g h i k s x G $.  $d f h x P $.  $d f g i k s x ph $.
    $d h C $.  $d f g h i k s x I $.  $d g s x Q $.  $d f k x W $.  $d h x X $.
    $d f h k x A $.  $d f g h i k s x S $.  $d x Y $.
    dpjfval.1 $e |- ( ph -> G dom DProd S ) $.
    dpjfval.2 $e |- ( ph -> dom S = I ) $.
    ${
      dpjlem.3 $e |- ( ph -> X e. I ) $.
      $( Lemma for theorems about direct product projection.  (Contributed by
         Mario Carneiro, 26-Apr-2016.) $)
      dpjlem $p |- ( ph -> ( G DProd ( S |` { X } ) ) = ( S ` X ) ) $=
        ( csn cres cdprd co cfv cop wfn wcel wceq csubg wf syl2anc ffn ffvelrnd
        dprdf2 syl fnressn oveq2d cdm wbr wa dprdsn simprd eqtrd ) ACBEIJZKLCEE
        BMZNIZKLZUNAUMUOCKABDOZEDPZUMUOQADCRMZBSUQABCDFGUCZDUSBUAUDHDEBUETUFACU
        OKUGUHZUPUNQZAURUNUSPVAVBUIHADUSEBUTHUBEUNCDUJTUKUL $.

      ${
        dpjcntz.z $e |- Z = ( Cntz ` G ) $.
        $( The two subgroups that appear in ~ dpjval commute.  (Contributed by
           Mario Carneiro, 26-Apr-2016.) $)
        dpjcntz $p |- ( ph ->
          ( S ` X ) C_ ( Z ` ( G DProd ( S |` ( I \ { X } ) ) ) ) ) $=
          ( cfv csn cres cdprd co wbr wss cin wceq cun dpjlem cdm wa c0g dprdf2
          cdif w3a c0 disjdif a1i undif2 snssd ssequn1 syl5req eqid dmdprdsplit
          sylib mpbid simp2d eqsstr3d ) AEBKCBELZMZNOZCBDVAUFZMZNOZFKZABCDEGHIU
          AACVBNUBZPCVEVHPUCZVCVGQZVCVFRCUDKZLSZACBVHPVIVJVLUGGAVAVDBCDVKFABCDG
          HUEVAVDRUHSAVADUIUJAVAVDTVADTZDVADUKAVADQVMDSAEDIULVADUMUQUNJVKUOUPUR
          USUT $.
      $}

      ${
        dpjdisj.0 $e |- .0. = ( 0g ` G ) $.
        $( The two subgroups that appear in ~ dpjval are disjoint.
           (Contributed by Mario Carneiro, 26-Apr-2016.) $)
        dpjdisj $p |- ( ph ->
          ( ( S ` X ) i^i ( G DProd ( S |` ( I \ { X } ) ) ) ) = { .0. } ) $=
          ( csn cres cdprd co cin cfv wbr wss wceq cun cdif dpjlem ineq1d ccntz
          cdm wa w3a dprdf2 disjdif a1i undif2 snssd ssequn1 sylib syl5req eqid
          c0 dmdprdsplit mpbid simp3d eqtr3d ) ACBEKZLZMNZCBDVBUAZLZMNZOZEBPZVG
          OFKZAVDVIVGABCDEGHIUBUCACVCMUEZQCVFVKQUFZVDVGCUDPZPRZVHVJSZACBVKQVLVN
          VOUGGAVBVEBCDFVMABCDGHUHVBVEOUQSAVBDUIUJAVBVETVBDTZDVBDUKAVBDRVPDSAED
          IULVBDUMUNUOVMUPJURUSUTVA $.
      $}

      dpjlsm.s $e |- .(+) = ( LSSum ` G ) $.
      $( The two subgroups that appear in ~ dpjval add to the full direct
         product.  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjlsm $p |- ( ph -> ( G DProd S ) =
        ( ( S ` X ) .(+) ( G DProd ( S |` ( I \ { X } ) ) ) ) ) $=
        ( cdprd co csn cres cdif cfv dprdf2 cin wceq cun disjdif a1i undif2 wss
        c0 snssd ssequn1 sylib syl5req dprdsplit dpjlem oveq1d eqtrd ) ADCKLDCF
        MZNKLZDCEUNOZNKLZBLFCPZUQBLAUNUPBCDEACDEGHQUNUPRUESAUNEUAUBAUNUPTUNETZE
        UNEUCAUNEUDUSESAFEIUFUNEUGUHUIJGUJAUOURUQBACDEFGHIUKULUM $.
    $}

    dpjfval.p $e |- P = ( G dProj S ) $.
    ${
      dpjfval.q $e |- Q = ( proj1 ` G ) $.
      $( Value of the direct product projection (defined in terms of binary
         projection).  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjfval $p |- ( ph -> P = ( i e. I |->
        ( ( S ` i ) Q ( G DProd ( S |` ( I \ { i } ) ) ) ) ) ) $=
        ( vg vs cdpj co cfv cdprd cvv wceq wcel cv csn cdif cres cmpt cgrp cima
        cdm cmpt2 df-dpj a1i wa simprr dmeqd adantr eqtrd simprl fveq2d syl6eqr
        cpj1 fveq1d difeq1d reseq12d oveq12d oveq123d mpteq12dv simpr sneqd wbr
        imaeq2d dprdgrp syl wrel wb reldmdprd elrelimasn ax-mp sylibr brrelex2i
        dmexg 3syl eqeltrrd mptexg ovmpt2dx syl5eq ) ABFDNOEGEUAZDPZFDGWFUBZUCZ
        UDZQOZCOZUEZJALMFDUFQUHZLUAZUBZUGZEMUAZUHZWFWRPZWOWRWSWHUCZUDZQOZWOUTPZ
        OZUEZWMNWNFUBZUGZRNLMUFWQXFUISALEMUJUKAWOFSZWRDSZULZULZEWSXEGWLXLWSDUHZ
        GXLWRDAXIXJUMZUNAXMGSXKIUOUPZXLWTWGXCWKXDCXLXDFUTPCXLWOFUTAXIXJUQZURKUS
        XLWFWRDXNVAXLWOFXBWJQXPXLWRDXAWIXNXLWSGWHXOVBVCVDVEVFAXIULZWPXGWNXQWOFA
        XIVGVHVJAFDWNVIZFUFTHDFVKVLAXRDXHTZHWNVMXSXRVNVOFDWNVPVQVRAGRTWMRTAXMGR
        IAXRDRTXMRTHFDWNVOVSDRVTWAWBEGWLRWCVLWDWE $.

      dpjval.3 $e |- ( ph -> X e. I ) $.
      $( Value of the direct product projection (defined in terms of binary
         projection).  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjval $p |- ( ph -> ( P ` X ) =
        ( ( S ` X ) Q ( G DProd ( S |` ( I \ { X } ) ) ) ) ) $=
        ( vx cfv csn cdif cres cdprd co cvv cv dpjfval wceq simpr sneqd difeq2d
        wa fveq2d reseq2d oveq2d oveq12d wcel ovex a1i fvmptd ) AMGMUAZDNZEDFUP
        OZPZQZRSZCSGDNZEDFGOZPZQZRSZCSZFBTABCDMEFHIJKUBAUPGUCZUGZUQVBVAVFCVIUPG
        DAVHUDZUHVIUTVEERVIUSVDDVIURVCFVIUPGVJUEUFUIUJUKLVGTULAVBVFCUMUNUO $.
    $}

    ${
      dpjf.3 $e |- ( ph -> X e. I ) $.
      $( The ` X ` -th index projection is a function from the direct product
         to the ` X ` -th factor.  (Contributed by Mario Carneiro,
         26-Apr-2016.) $)
      dpjf $p |- ( ph -> ( P ` X ) : ( G DProd S ) --> ( S ` X ) ) $=
        ( cdprd co cfv wf csn cdif cres clsm cpj1 eqid c0g ccntz csubg ffvelrnd
        cplusg dprdf2 cdm wbr wcel wss difssd dprdres dprdsubg syl dpjdisj pj1f
        simpld dpjcntz dpjval dpjlsm feq12d mpbird ) ADCKLZFCMZFBMZNVDDCEFOZPZQ
        ZKLZDRMZLZVDVDVIDSMZLZNAVLDUEMZVJVDVIDDUAMZDUBMZVNTVJTZVOTZVPTZAEDUCMZF
        CACDEGHUFJUDADVHKUGUHZVIVTUIAWAVIVCUJAVGCDEGHAEVFUKULUQVHDUMUNACDEFVOGH
        JVRUOACDEFVPGHJVSURVLTZUPAVCVKVDVEVMABVLCDEFGHIWBJUSAVJCDEFGHJVQUTVAVB
        $.
    $}

    ${
      dpjidcl.3 $e |- ( ph -> A e. ( G DProd S ) ) $.
      dpjidcl.0 $e |- .0. = ( 0g ` G ) $.
      dpjidcl.w $e |- W = { h e. X_ i e. I ( S ` i ) |
          ( `' h " ( _V \ { .0. } ) ) e. Fin } $.
      $( The key property of projections: the sum of all the projections of
         ` A ` is ` A ` .  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjidcl $p |- ( ph -> ( ( x e. I |-> ( ( P ` x ) ` A ) ) e. W /\
        A = ( G gsum ( x e. I |-> ( ( P ` x ) ` A ) ) ) ) ) $=
        ( wceq cfv wcel vf vk cv cgsu co cmpt wa cdprd cdm wrex wb eldprd mpbid
        wbr syl simprd adantr ad2antrr dpjf ffvelrnd ccnv cvv csn cdif cima cfn
        simpr simprl dprdffi cres cpj1 eldifi eqid dpjval fveq1d sylan2 simplrr
        wss cbs ccntz cmnd cgrp dprdgrp 3syl reldmdprd brrelex2i dmexg eqeltrrd
        grpmnd wf dprdff crn dprdfcntz snssi adantl difss2d cnvimass fdm ssconb
        syl5sseq syl2anc gsumzres eqtr4d cixp difss dprdres simpld csubg dprdf2
        a1i fssres sylancl feqmptd reseq1d resmpt ax-mp syl6eq dprdfcl eleqtrrd
        crab fvres ssdif sseli ssid suppssr suppss2 ssfi dprdwd eqeltrd eldprdi
        cplusg clsm dprdsubg dpjdisj dpjcntz pj1rid sylanl2 eqtrd cun oveq2d c0
        mpdan simprr disjdif undif2 snssd ssequn1 sylib syl5req feqresmpt fveq2
        cin gsumzsplit gsumsn syl3anc oveq1d 3eqtrd eleqtrd pj1eq mpteq2dva jca
        dpjlsm rexlimddv ) ACHUAUCZUDUEZRZBICBUCZDSZSZUFZJTZCHUVJUDUEZRZUGUAJAH
        EUHUIZUNZUVFUAJUJZACHEUHUEZTZUVOUVPUGZOAEUIZIRZUVRUVSUKMCEUAFGHIJKPQULU
        OUMUPAUVDJTZUVFUGZUGZUVKUVMUWDBUVIEFGHIJKQAUVOUWCLUQZAUWAUWCMUQZUWDUVGI
        TZUGZUVQUVGESZCUVHUWHDEHIUVGAUVOUWCUWGLURZAUWAUWCUWGMURZNUWDUWGVGZUSAUV
        RUWCUWGOURZUTUWDUVDVAVBKVCVDZVEZVFTZUVJVAUWNVEZUWOVRUWQVFTUWDEFGUVDHIJK
        QUWEUWFAUWBUVFVHZVIZUWDIUVIBUWOKUWDUVGIUWOVDZTZUGZUVICUWIHEIUVGVCZVDZVJ
        ZUHUEZHVKSZUEZSZKUXAUWDUWGUVIUXIRUVGIUWOVLZUWHCUVHUXHUWHDUXGEHIUVGUWJUW
        KNUXGVMZUWLVNVOZVPUXBCUXFTZUXIKRZUXBCHUVDUXDVJZUDUEZUXFUXBCUVEUXPAUWBUV
        FUXAVQUXBIHVSSZUVDHVBUXDKHVTSZUXQVMZPUXRVMZUWDHWATZUXAUWDUVOHWBTZUYAUWE
        EHWCZHWIZWDUQUWDIVBTUXAUWDUVTIVBUWFUWDUVOEVBTZUVTVBTZUWEHEUVNWEWFZEVBWG
        ZWDWHUQUWDIUXQUVDWJZUXAUWDUXQEFGUVDHIJKQUWEUWFUWRUXSWKZUQUXAUWDUWGUVDWL
        ZUYKUXRSVRUXJUWHEFGUVDHIJKUXRQUWJUWKUWDUWBUWGUWRUQZUXTWMZVPUXBUXCUWTVRZ
        UWOUXDVRZUXAUYNUWDUVGUWTWNWOZUXBUXCIVRZUWOIVRZUYNUYOUKUXBUXCIUWOUYPWPUW
        DUYRUXAUWDUVDUIZUWOIUVDUWNWQUWDUYIUYSIRUYJIUXQUVDWRUOWTUQUXCUWOIWSXAUMU
        WDUWPUXAUWSUQXBXCUXAUWDUWGUXPUXFTUXJUWHUXEFGUXOHUXDFUCVAUWNVEVFTFGUXDGU
        CUXESXDXTZKPUYTVMZUWHHUXEUVNUNZUXFUVQVRUWHUXDEHIUWJUWKUXDIVRZUWHIUXCXEZ
        XJXFXGZUWHUXDHXHSZUXEWJZUXEUIUXDRUWHIVUFEWJVUCVUGUWHEHIUWJUWKXIZVUDIVUF
        UXDEXKXLUXDVUFUXEWRUOZUWHUXOUBUXDUBUCZUVDSZUFZUYTUWHUXOUBIVUKUFZUXDVJZV
        ULUWHUVDVUMUXDUWHUBIUXQUVDUWDUYIUWGUYJUQZXMXNVUCVUNVULRVUDUBIUXDVUKXOXP
        XQUWHUBVUKUXEFGHUXDUYTKVUAVUEVUIUWHVUJUXDTZUGVUKVUJESZVUJUXESZVUPUWHVUJ
        ITVUKVUQTVUJIUXCVLUWHEFGUVDHIJVUJKQUWJUWKUYLXRVPVUPVURVUQRUWHVUJUXDEYAW
        OXSUWHUWPVULVAUWNVEZUWOVRVUSVFTUWDUWPUWGUWSUQUWHUXDVUKUBUWOKVUJUXDUWOVD
        ZTUWHVUJUWTTVUKKRVUTUWTVUJVUCVUTUWTVRVUDUXDIUWOYBXPYCUWHIUXQUVDUWOVUJKV
        UOUWOUWOVRUWHUWOYDXJYEVPYFUWOVUSYGXAYHYIYJZVPYIUXAUWDUWGUXMUXNUXJUWHUXG
        HYKSZHYLSZUWIUXFHCKUXRVVBVMZVVCVMZPUXTUWHIVUFUVGEVUHUWLUTZUWHVUBUXFVUFT
        VUEUXEHYMUOZUWHEHIUVGKUWJUWKUWLPYNZUWHEHIUVGUXRUWJUWKUWLUXTYOZUXKYPYQUU
        BYRYFUWOUWQYGXAYHUWDCUVEUVLAUWBUVFUUCUWDUVDUVJHUDUWDUVDBIUVGUVDSZUFUVJU
        WDBIUXQUVDUYJXMUWDBIUVIVVJUWHUVIUXIVVJUXLUWHUXIVVJRZCUXFUWIUXGUESUXPRZU
        WHCVVJUXPVVBUEZRVVKVVLUGUWHCUVEHUVDUXCVJZUDUEZUXPVVBUEVVMAUWBUVFUWGVQUW
        HIUXQUXCUXDVVBUVDHVBKUXRUXSPVVDUXTUWHUVOUYBUYAUWJUYCUYDWDZUWHUVTIVBUWKU
        WHUVOUYEUYFUWJUYGUYHWDWHVUOUYMUWHEFGUVDHIJKQUWJUWKUYLVIUXCUXDUULUUARUWH
        UXCIUUDXJUWHUXCUXDYSUXCIYSZIUXCIUUEUWHUYQVVQIRUWHUVGIUWLUUFZUXCIUUGUUHU
        UIUUMUWHVVOVVJUXPVVBUWHVVOHUBUXCVUKUFZUDUEZVVJUWHVVNVVSHUDUWHUBIUXQUXCU
        VDVUOVVRUUJYTUWHUYAUWGVVJUXQTVVTVVJRVVPUWLUWHIUXQUVGUVDVUOUWLUTVUKUXQVV
        JUBHUVGIUXSVUJUVGUVDUUKUUNUUOYRUUPUUQUWHVVJUXPUXGVVBVVCUWIUXFHCKUXRVVDV
        VEPUXTVVFVVGVVHVVIUXKUWHCUVQUWIUXFVVCUEUWMUWHVVCEHIUVGUWJUWKUWLVVEUVBUU
        RUWDEFGUVDHIJUVGKQUWEUWFUWRXRVVAUUSUMXGYRUUTXCYTYRUVAUVC $.

      dpjeq.c $e |- ( ph -> ( x e. I |-> C ) e. W ) $.
      $( Decompose a group sum into projections.  (Contributed by Mario
         Carneiro, 26-Apr-2016.) $)
      dpjeq $p |- ( ph -> ( A = ( G gsum ( x e. I |-> C ) ) <->
        A. x e. I ( ( P ` x ) ` A ) = C ) ) $=
        ( wceq cmpt cgsu cfv wral wcel dpjidcl simprd eqeq1d simpld dprdf11 cvv
        co cv wb fvex rgenw mpteqb mp1i 3bitrd ) ACIBJDUAZUBULZTIBJCBUMEUCZUCZU
        AZUBULZVATVDUTTZVCDTBJUDZACVEVAAVDKUEZCVETZABCEFGHIJKLMNOPQRUFZUGUHAFGH
        VDIUTJKLQRMNAVHVIVJUISUJVCUKUEZBJUDVFVGUNAVKBJCVBUOUPBJVCDUKUQURUS $.
    $}

    ${
      dpjid.3 $e |- ( ph -> A e. ( G DProd S ) ) $.
      $( The key property of projections: the sum of all the projections of
         ` A ` is ` A ` .  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjid $p |- ( ph -> A = ( G gsum ( x e. I |-> ( ( P ` x ) ` A ) ) ) ) $=
        ( vh vi cv cfv cmpt ccnv cvv wcel eqid c0g csn cdif cima cixp crab cgsu
        cfn co wceq dpjidcl simprd ) ABGCBNDOOPZLNQRFUAOZUBUCUDUHSLMGMNEOUEUFZS
        CFUMUGUIUJABCDELMFGUOUNHIJKUNTUOTUKUL $.
    $}

    dpjlid.3 $e |- ( ph -> X e. I ) $.
    ${
      dpjlid.4 $e |- ( ph -> A e. ( S ` X ) ) $.
      $( The ` X ` -th index projection acts as the identity on elements of the
         ` X ` -th factor.  (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjlid $p |- ( ph -> ( ( P ` X ) ` A ) = A ) $=
        ( cfv csn cdif cres cdprd co eqid wcel cpj1 dpjval fveq1d wceq clsm c0g
        cplusg ccntz dprdf2 ffvelrnd cdm wbr wss difssd dprdres simpld dprdsubg
        csubg syl dpjdisj dpjcntz pj1lid mpdan eqtrd ) ABGCMZMBGDMZEDFGNZOZPZQR
        ZEUAMZRZMZBABVEVLACVKDEFGHIJVKSZKUBUCABVFTVMBUDLAVKEUGMZEUEMZVFVJEBEUFM
        ZEUHMZVOSVPSVQSZVRSZAFEURMZGDADEFHIUIKUJAEVIQUKULZVJWATAWBVJEDQRUMAVHDE
        FHIAFVGUNUOUPVIEUQUSADEFGVQHIKVSUTADEFGVRHIKVTVAVNVBVCVD $.

      dpjrid.0 $e |- .0. = ( 0g ` G ) $.
      dpjrid.5 $e |- ( ph -> Y e. I ) $.
      dpjrid.6 $e |- ( ph -> Y =/= X ) $.
      $( The ` Y ` -th index projection annihilates elements of other factors.
         (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      dpjrid $p |- ( ph -> ( ( P ` Y ) ` A ) = .0. ) $=
        ( vx cfv wceq vh vi cif wcel cv wral cmpt cgsu co ccnv cvv csn cdif cfn
        cima cixp crab eqid simprd eqcomd cdprd dprdub sseldd dpjeq mpbid fveq2
        dprdfid simpld fveq1d eqeq1 ifbid eqeq12d rspcv wne ifnefalse syl eqtrd
        sylc ) ABHCSZSZHGTZBIUCZIAHFUDBRUEZCSZSZWCGTZBIUCZTZRFUFZVTWBTZPABERFWG
        UGZUHUIZTWIAWLBAWKUAUEUJUKIULUMUOUNUDUAUBFUBUEDSUPUQZUDZWLBTZABDUAUBRWK
        EFWMGIOWMURZJKMNWKURVGZUSUTARBWGCDUAUBEFWMIJKLAGDSEDVAUIBADEFGJKMVBNVCO
        WPAWNWOWQVHVDVEWHWJRHFWCHTZWEVTWGWBWRBWDVSWCHCVFVIWRWFWABIWCHGVJVKVLVMV
        RAHGVNWBITQHGBIVOVPVQ $.
    $}

    $( The direct product is the binary subgroup product ("sum") of the direct
       products of the partition.  (Contributed by Mario Carneiro,
       26-Apr-2016.) $)
    dpjghm $p |- ( ph ->
      ( P ` X ) e. ( ( G |`s ( G DProd S ) ) GrpHom G ) ) $=
      ( cfv csn cdif cres cdprd co cpj1 cress cghm eqid clsm cplusg ccntz csubg
      c0g dprdf2 ffvelrnd cdm wbr wss difssd dprdres simpld syl dpjdisj dpjcntz
      wcel dprdsubg pj1ghm dpjval dpjlsm oveq2d oveq1d 3eltr4d ) AFCKZDCEFLZMZN
      ZOPZDQKZPDVEVIDUAKZPZRPZDSPFBKDDCOPZRPZDSPAVJDUBKZVKVEVIDDUEKZDUCKZVPTVKT
      ZVQTZVRTZAEDUDKZFCACDEGHUFJUGADVHOUHUIZVIWBUQAWCVIVNUJAVGCDEGHAEVFUKULUMV
      HDURUNACDEFVQGHJVTUOACDEFVRGHJWAUPVJTZUSABVJCDEFGHIWDJUTAVOVMDSAVNVLDRAVK
      CDEFGHJVSVAVBVCVD $.

    $( The direct product is the binary subgroup product ("sum") of the direct
       products of the partition.  (Contributed by Mario Carneiro,
       26-Apr-2016.) $)
    dpjghm2 $p |- ( ph ->
      ( P ` X ) e. ( ( G |`s ( G DProd S ) ) GrpHom ( G |`s ( S ` X ) ) ) ) $=
      ( cfv cdprd co cress cghm wcel dpjghm csubg crn wss wb dprdf2 ffvelrnd wf
      dpjf frn syl eqid resghm2b syl2anc mpbid ) AFBKZDDCLMZNMZDOMPZULUNDFCKZNM
      ZOMPZABCDEFGHIJQAUPDRKZPULSUPTZUOURUAAEUSFCACDEGHUBJUCAUMUPULUDUTABCDEFGH
      IJUEUMUPULUFUGUNDUQULUPUQUHUIUJUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The Fundamental Theorem of Abelian Groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b g x B $.  $d a b g x G $.  $d a b g p K $.  $d a b g L $.  $d x O $.
    $d a b g .(+) $.  $d a b g x M $.  $d a b p x N $.  $d a b g p x ph $.
    $d x .0. $.
    ablfacrp.b $e |- B = ( Base ` G ) $.
    ablfacrp.o $e |- O = ( od ` G ) $.
    ablfacrp.k $e |- K = { x e. B | ( O ` x ) || M } $.
    ablfacrp.l $e |- L = { x e. B | ( O ` x ) || N } $.
    ablfacrp.g $e |- ( ph -> G e. Abel ) $.
    ablfacrp.m $e |- ( ph -> M e. NN ) $.
    ablfacrp.n $e |- ( ph -> N e. NN ) $.
    ablfacrp.1 $e |- ( ph -> ( M gcd N ) = 1 ) $.
    ablfacrp.2 $e |- ( ph -> ( # ` B ) = ( M x. N ) ) $.
    $( Lemma for ~ ablfacrp2 .  (Contributed by Mario Carneiro,
       19-Apr-2016.) $)
    ablfacrplem $p |- ( ph -> ( ( # ` K ) gcd N ) = 1 ) $=
      ( wcel cdivides vp vg chash cfv cgcd co c1 wceq c2 cuz cv wbr cprime wrex
      wa wn nprmdvds1 adantl adantr breq2d mtbird cress cod cbs cgrp csubg crab
      cfn cz nnzd oddvdssubg syl2anc syl5eqel ad2antrr eqid subggrp syl subgbas
      cabel wss cn0 cmul nnnn0d nn0mulcld eqeltrd wb fvex eqeltri hashclb ax-mp
      cvv sylibr ssrab2 eqsstri ssfi sylancl eqeltrrd simplr simpr fveq2d odcau
      breqtrd syl31anc rexeqdv mpbird subgod sylan fveq2 breq1d elrab2 eqbrtrrd
      simprbi breq1 syl5ibcom rexlimdva mpd ex anim1d prmz hashcl nn0zd syl3anc
      dvdsgcdb 3imtr3d mtod nrexdv exprmfct nsyl cn wo cc0 wne necon3ai gcdn0cl
      nnne0d syl21anc elnn1uz2 sylib ord mt3d ) AEUCUDZHUEUFZUGUHZUUBUIUJUDSZAU
      AUKZUUBTULZUAUMUNUUDAUUFUAUMAUUEUMSZUOZUUFUUEGHUEUFZTULZUUHUUJUUEUGTULZUU
      GUUKUPAUUEUQURUUHUUIUGUUETAUUIUGUHUUGQUSUTVAUUHUUEUUATULZUUEHTULZUOZUUEGT
      ULZUUMUOZUUFUUJUUHUULUUOUUMUUHUULUUOUUHUULUOZUBUKZDEVBUFZVCUDZUDZUUEUHZUB
      EUNZUUOUUQUVCUVBUBUUSVDUDZUNZUUQUUSVESZUVDVHSUUGUUEUVDUCUDZTULUVEUUQEDVFU
      DZSZUVFAUVIUUGUULAEBUKZIUDZGTULZBCVGZUVHLADVSSGVISZUVMUVHSNAGOVJZBCDGIKJV
      KVLVMVNZEDUUSUUSVOZVPVQUUQEUVDVHUUQUVIEUVDUHUVPEDUUSUVQVRVQZAEVHSZUUGUULA
      CVHSZECVTUVSACUCUDZWASZUVTAUWAGHWBUFWARAGHAGOWCAHPWCWDWECWKSUVTUWBWFCDVDU
      DWKJDVDWGWHCWKWIWJWLEUVMCLUVLBCWMWNCEWOWPZVNWQAUUGUULWRUUQUUEUUAUVGTUUHUU
      LWSUUQEUVDUCUVRWTXBUUEUBUUSUUTUVDUVDVOUUTVOZXAXCUUQUVBUBEUVDUVRXDXEUUQUVB
      UUOUBEUUQUURESZUOZUVAGTULUVBUUOUWFUURIUDZUVAGTUUQUVIUWEUWGUVAUHUVPUURUUTD
      UUSIEUVQKUWDXFXGUWEUWGGTULZUUQUWEUURCSUWHUVLUWHBUURCEUVJUURUHUVKUWGGTUVJU
      URIXHXILXJXLURXKUVAUUEGTXMXNXOXPXQXRUUHUUEVISZUUAVISZHVISZUUNUUFWFUUGUWIA
      UUEXSURZAUWJUUGAUUAAUVSUUAWASUWCEXTVQYAZUSAUWKUUGAHPVJZUSZUUEUUAHYCYBUUHU
      WIUVNUWKUUPUUJWFUWLAUVNUUGUVOUSUWOUUEGHYCYBYDYEYFUUBUAYGYHAUUCUUDAUUBYISZ
      UUCUUDYJAUWJUWKUUAYKUHZHYKUHZUOZUPZUWPUWMUWNAHYKYLUWTAHPYOUWSHYKUWQUWRWSY
      MVQUUAHYNYPUUBYQYRYSYT $.

    ${
      ablfacrp.z $e |- .0. = ( 0g ` G ) $.
      ablfacrp.s $e |- .(+) = ( LSSum ` G ) $.
      $( A finite abelian group whose order factors into relatively prime
         integers, itself "factors" into two subgroups ` K , L ` that have
         trivial intersection and whose product is the whole group.  Lemma
         6.1C.2 of [Shapiro], p. 199.  (Contributed by Mario Carneiro,
         19-Apr-2016.) $)
      ablfacrp $p |- ( ph -> ( ( K i^i L ) = { .0. } /\ ( K .(+) L ) = B ) ) $=
        ( vg va vb cin csn wceq co cv cfv cdivides wbr crab ineq12i inrab eqtri
        wa wcel w3a c1 cgcd cz wi odcl adantl nn0zd nnzd adantr dvdsgcd syl3anc
        cn0 3impia 3ad2ant1 breqtrd wb simp2 dvds1 3syl mpbid cgrp cabel ablgrp
        syl odeq1 syl2anc elsn sylibr rabssdv syl5eqss csubg oddvdssubg subg0cl
        syl5eqel elin sylanbrc snssd eqssd wss lsmsubg2 subgss eqid mulg1 caddc
        cmg cmul wrex bezout ad2antrr eqeq1d cplusg simprl zmulcld zcnd addcomd
        simprr oveq1d simplr mulgdir syl13anc eqtrd mulgcl cfn nnmulcld eqeltrd
        chash nnnn0d cvv fvex eqeltri dvdsmultr1 odmulgid syl31anc mpbird fveq2
        cbs mpd breq1d elrab2 cc hashclb ax-mp oddvds2 ad2antlr ad2antrl mulass
        mulassd zcn mul12 lsmelvali syl22anc oveq1 eleq1d syl5ibrcom rexlimdvva
        sylbid eqeltrrd ex ssrdv jca ) AFGUFZKUGZUHFGDUIZCUHAUVAUVBAUVABUJZJUKZ
        HULUMZUVEIULUMZURZBCUNZUVBUVAUVFBCUNZUVGBCUNZUFUVIFUVJGUVKNOUOUVFUVGBCU
        PUQAUVHBCUVBAUVDCUSZUVHUTZUVDKUHZUVDUVBUSUVMUVEVAUHZUVNUVMUVEVAULUMZUVO
        UVMUVEHIVBUIZVAULAUVLUVHUVEUVQULUMZAUVLURZUVEVCUSHVCUSZIVCUSZUVHUVRVDUV
        SUVEUVLUVEVLUSZAUVDEJCLMVEZVFVGAUVTUVLAHQVHZVIAUWAUVLAIRVHZVIUVEHIVJVKV
        MAUVLUVQVAUHZUVHSVNVOUVMUVLUWBUVPUVOVPAUVLUVHVQZUWCUVEVRVSVTUVMEWAUSZUV
        LUVOUVNVPAUVLUWHUVHAEWBUSZUWHPEWCWDZVNUWGUVDEJCKMUALWEWFVTBKWGWHWIWJAKU
        VAAKFUSZKGUSZKUVAUSAFEWKUKZUSZUWKAFUVJUWMNAUWIUVTUVJUWMUSPUWDBCEHJMLWLW
        FWNZFEKUAWMWDAGUWMUSZUWLAGUVKUWMOAUWIUWAUVKUWMUSPUWEBCEIJMLWLWFWNZGEKUA
        WMWDKFGWOWPWQWRAUVCCAUVCUWMUSZUVCCWSAUWIUWNUWPUWRPUWOUWQDFGEUBWTVKCUVCE
        LXAWDAUCCUVCAUCUJZCUSZUWSUVCUSAUWTURZVAUWSEXEUKZUIZUWSUVCUWTUXCUWSUHACU
        XBEUWSLUXBXBZXCVFUXAUVQHUDUJZXFUIZIUEUJZXFUIZXDUIZUHZUEVCXGUDVCXGZUXCUV
        CUSZAUXKUWTAUVTUWAUXKUWDUWEUDUEHIXHWFVIUXAUXJUXLUDUEVCVCUXAUXEVCUSZUXGV
        CUSZURZURZUXJVAUXIUHZUXLUXPUVQVAUXIAUWFUWTUXOSXIXJUXPUXLUXQUXIUWSUXBUIZ
        UVCUSUXPUXRUXHUWSUXBUIZUXFUWSUXBUIZEXKUKZUIZUVCUXPUXRUXHUXFXDUIZUWSUXBU
        IZUYBUXPUXIUYCUWSUXBUXPUXFUXHUXPUXFUXPHUXEAUVTUWTUXOUWDXIZUXAUXMUXNXLZX
        MZXNUXPUXHUXPIUXGAUWAUWTUXOUWEXIZUXAUXMUXNXPZXMZXNXOXQUXPUWHUXHVCUSZUXF
        VCUSZUWTUYDUYBUHAUWHUWTUXOUWJXIZUYJUYGAUWTUXOXRZCUYAUXBEUXHUXFUWSLUXDUY
        AXBZXSXTYAUXPUWNUWPUXSFUSZUXTGUSZUYBUVCUSAUWNUWTUXOUWOXIAUWPUWTUXOUWQXI
        UXPUXSCUSZUXSJUKZHULUMZUYPUXPUWHUYKUWTUYRUYMUYJUYNCUXBEUXHUWSLUXDYBVKUX
        PUYTUWSJUKZHUXHXFUIZULUMZUXPVUAHIXFUIZUXGXFUIZVUBULUXPVUAVUDULUMZVUAVUE
        ULUMZUXPVUACYFUKZVUDULUXPUWHCYCUSZUWTVUAVUHULUMUYMAVUIUWTUXOAVUHVLUSZVU
        IAVUHVUDVLTAVUDAHIQRYDYGYECYHUSVUIVUJVPCEYPUKYHLEYPYIYJCYHUUAUUBWHXIUYN
        UWSEJCLMUUCVKAVUHVUDUHUWTUXOTXIVOZUXPVUAVCUSZVUDVCUSZUXNVUFVUGVDUXPVUAU
        WTVUAVLUSAUXOUWSEJCLMVEUUDVGZUXPHIUYEUYHXMZUYIVUAVUDUXGYKVKYQUXPHIUXGUX
        PHUYEXNZUXPIUYHXNZUXPUXGUYIXNUUGVOUXPUWHUWTUYKUVTUYTVUCVPUYMUYNUYJUYEUW
        SUXBEHUXHJCLMUXDYLYMYNUVFUYTBUXSCFUVDUXSUHUVEUYSHULUVDUXSJYOYRNYSWPUXPU
        XTCUSZUXTJUKZIULUMZUYQUXPUWHUYLUWTVURUYMUYGUYNCUXBEUXFUWSLUXDYBVKUXPVUT
        VUAIUXFXFUIZULUMZUXPVUAVUDUXEXFUIZVVAULUXPVUFVUAVVCULUMZVUKUXPVULVUMUXM
        VUFVVDVDVUNVUOUYFVUAVUDUXEYKVKYQUXPHYTUSZIYTUSZUXEYTUSZVVCVVAUHVUPVUQUX
        MVVGUXAUXNUXEUUHUUEVVEVVFVVGUTVVCHIUXEXFUIXFUIVVAHIUXEUUFHIUXEUUIYAVKVO
        UXPUWHUWTUYLUWAVUTVVBVPUYMUYNUYGUYHUWSUXBEIUXFJCLMUXDYLYMYNUVGVUTBUXTCG
        UVDUXTUHUVEVUSIULUVDUXTJYOYROYSWPUYADFGEUXSUXTUYOUBUUJUUKYEUXQUXCUXRUVC
        VAUXIUWSUXBUULUUMUUNUUPUUOYQUUQUURUUSWRUUT $.
    $}

    $( The factors ` K , L ` of ~ ablfacrp have the expected orders (which
       allows for repeated application to decompose ` G ` into subgroups of
       prime-power order).  Lemma 6.1C.2 of [Shapiro], p. 199.  (Contributed by
       Mario Carneiro, 21-Apr-2016.) $)
    ablfacrp2 $p |- ( ph -> ( ( # ` K ) = M /\ ( # ` L ) = N ) ) $=
      ( wcel cdivides cfv wceq cn0 wbr cfn wss cmul co nnnn0d nn0mulcld eqeltrd
      chash cvv wb cbs fvex eqeltri hashclb ax-mp sylibr cv crab ssrab2 eqsstri
      ssfi sylancl hashcl syl cgcd csubg cabel nnzd oddvdssubg syl2anc syl5eqel
      c1 cz lagsubg nncnd mulcomd eqtrd breqtrd ablfacrplem wa wi nn0zd syl3anc
      coprmdvds mp2and gcdcom eqtr3d dvdscmul mpd clsm cin eqid ablfacrp simprd
      c0g csn fveq2d ccntz simpld ablcntzd lsmhash breqtrrd cc0 cn subg0cl ne0i
      wne 3syl hashnncl mpbird nnne0d dvdsmulcr syl112anc mpbid dvdseq syl22anc
      c0 dvdsmulc dvdscmulr jca ) AEULUAZGUBZFULUAZHUBZAYEUCSZGUCSYEGTUDZGYETUD
      ZYFAEUESZYIACUESZECUFYLACULUAZUCSZYMAYNGHUGUHZUCRAGHAGOUIZAHPUIZUJUKCUMSY
      MYOUNCDUOUAUMJDUOUPUQCUMURUSUTZEBVAIUAZGTUDZBCVBZCLUUABCVCVDCEVEVFZEVGVHZ
      YQAYEHGUGUHZTUDZYEHVIUHVPUBZYJAYEYNUUETAEDVJUAZSYMYEYNTUDAEUUBUUHLADVKSZG
      VQSZUUBUUHSNAGOVLZBCDGIKJVMVNVOZYSDCEJVRVNAYNYPUUERAGHAGOVSAHPVSVTWAZWBAB
      CDEFGHIJKLMNOPQRWCAYEVQSZHVQSZUUJUUFUUGWDYJWEAYEUUDWFZAHPVLZUUKYEHGWHWGWI
      ZAGYGUGUHZYEYGUGUHZTUDZYKAUUSYPUUTTAYGHTUDZUUSYPTUDZAYGYPTUDZYGGVIUHVPUBZ
      UVBAYGYNYPTAFUUHSZYMYGYNTUDAFYTHTUDZBCVBZUUHMAUUIUUOUVHUUHSNUUQBCDHIKJVMV
      NVOZYSDCFJVRVNRWBABCDFEHGIJKMLNPOAGHVIUHZHGVIUHZVPAUUJUUOUVJUVKUBUUKUUQGH
      WJVNQWKUUMWCAYGVQSZUUJUUOUVDUVEWDUVBWEAYGAFUESZYGUCSZAYMFCUFUVMYSFUVHCMUV
      GBCVCVDCFVEVFZFVGVHZWFZUUKUUQYGGHWHWGWIZAUVLUUOUUJUVBUVCWEUVQUUQUUKGYGHWL
      WGWMAYNUUTYPAEFDWNUAZUHZULUAYNUUTAUVTCULAEFWODWSUAZWTUBZUVTCUBZABCUVSDEFG
      HIUWAJKLMNOPQRUWAWPZUVSWPZWQZWRXAAUVSEFDUWADXBUAZUWEUWDUWGWPZUULUVIAUWBUW
      CUWFXCAEFDUWGUWHNUULUVIXDUUCUVOXEWKRWKZXFAUUJUUNUVLYGXGXKUVAYKUNUUKUUPUVQ
      AYGAYGXHSZFYAXKZAUVFUWAFSUWKUVIFDUWAUWDXIFUWAXJXLAUVMUWJUWKUNUVOFXMVHXNXO
      YGGYEXPXQXRYEGXSXTZAUVNHUCSUVBHYGTUDZYHUVPYRUVRAYEHUGUHZUUTTUDZUWMAUWNYPU
      UTTAYJUWNYPTUDZUURAUUNUUJUUOYJUWPWEUUPUUKUUQHYEGYBWGWMUWIXFAUUOUVLUUNYEXG
      XKUWOUWMUNUUQUVQUUPAYEAYEGXHUWLOUKXOYEHYGYCXQXRYGHXSXTYD $.
  $}

  ${
    $d p q w x y B $.  $d p q x y D $.  $d a b p q w x y z ph $.  $d a b q S $.
    $d a b p q x y z A $.  $d p q x y O $.  $d p q x y z P $.  $d q x y z T $.
    $d a b p q x y z G $.
    ablfac1.b $e |- B = ( Base ` G ) $.
    ablfac1.o $e |- O = ( od ` G ) $.
    ablfac1.s $e |- S = ( p e. A |-> { x e. B |
      ( O ` x ) || ( p ^ ( p pCnt ( # ` B ) ) ) } ) $.
    ablfac1.g $e |- ( ph -> G e. Abel ) $.
    ablfac1.f $e |- ( ph -> B e. Fin ) $.
    ablfac1.1 $e |- ( ph -> A C_ Prime ) $.
    ${
      ablfac1.m $e |- M = ( P ^ ( P pCnt ( # ` B ) ) ) $.
      ablfac1.n $e |- N = ( ( # ` B ) / M ) $.
      $( Lemma for ~ ablfac1b .  Satisfy the assumptions of ablfacrp.
         (Contributed by Mario Carneiro, 26-Apr-2016.) $)
      ablfac1lem $p |- ( ( ph /\ P e. A ) -> ( ( M e. NN /\ N e. NN ) /\
        ( M gcd N ) = 1 /\ ( # ` B ) = ( M x. N ) ) ) $=
        ( wcel wa cn cgcd co c1 wceq chash cfv cmul cpc cprime sselda prmnn syl
        cexp c0 wne cabel cgrp ablgrp grpbn0 3syl cfn wb hashnncl mpbird adantr
        pccld nnexpcld syl5eqel cdiv cdivides pcdvds syl2anc syl5eqbr nndivdvds
        wbr mpbid jca oveq1i wn pcndvds2 oveq2i eqtri breq2i sylnibr nnzd coprm
        cz cn0 wi prmz rpexp1i syl3anc mpd syl5eq nncnd nnne0d divcan2d syl5req
        3jca ) AECTZUAZHUBTZIUBTZUAHIUCUDZUEUFDUGUHZHIUIUDZUFXCXDXEXCHEEXGUJUDZ
        UOUDZUBRXCEXIXCEUKTZEUBTACUKEQULZEUMUNXCEXGXLAXGUBTZXBAXMDUPUQZAGURTGUS
        TXNOGUTDGLVAVBADVCTXMXNVDPDVEUNVFVGZVHZVIVJZXCIXGHVKUDZUBSXCHXGVLVQZXRU
        BTZXCHXJXGVLRXCXKXMXJXGVLVQXLXOEXGVMVNVOXCXMXDXSXTVDXOXQXGHVPVNVRVJZVSX
        CXFXJIUCUDZUEHXJIUCRVTXCEIUCUDUEUFZYBUEUFZXCEIVLVQZWAZYCXCEXGXJVKUDZVLV
        QZYEXCXKXMYHWAXLXOEXGWBVNIYGEVLIXRYGSHXJXGVKRWCWDWEWFXCXKIWITZYFYCVDXLX
        CIYAWGZEIWHVNVRXCEWITZYIXIWJTYCYDWKXCXKYKXLEWLUNYJXPEIXIWMWNWOWPXCXHHXR
        UIUDXGIXRHUISWCXCXGHXCXGXOWQXCHXQWQXCHXQWRWSWTXA $.
    $}

    $( The factors of ~ ablfac1b are of prime power order.  (Contributed by
       Mario Carneiro, 26-Apr-2016.) $)
    ablfac1a $p |- ( ( ph /\ P e. A ) ->
      ( # ` ( S ` P ) ) = ( P ^ ( P pCnt ( # ` B ) ) ) ) $=
      ( wcel cfv chash co wceq wa cv cpc cexp cdivides wbr crab id oveq1 breq2d
      oveq12d rabbidv cbs cvv fvex eqeltri rabex fvmpt3i adantl cdiv eqid cabel
      fveq2d adantr cn cgcd c1 ablfac1lem simp1d simpld simprd simp2d ablfacrp2
      cmul simp3d eqtrd ) AECPZUAZEFQZRQBUBHQZEEDRQZUCSZUDSZUEUFZBDUGZRQZWCVRVS
      WERVQVSWETAIEVTIUBZWGWAUCSZUDSZUEUFZBDUGWECFWGETZWJWDBDWKWIWCVTUEWKWGEWHW
      BUDWKUHWGEWAUCUIUKUJULLWJBDDGUMQUNJGUMUOUPUQURUSVCVRWFWCTVTWAWCUTSZUEUFBD
      UGZRQWLTVRBDGWEWMWCWLHJKWEVAWMVAAGVBPVQMVDVRWCVEPZWLVEPZVRWNWOUAZWCWLVFSV
      GTZWAWCWLVNSTZABCDEFGWCWLHIJKLMNOWCVAWLVAVHZVIZVJVRWNWOWTVKVRWPWQWRWSVLVR
      WPWQWRWSVOVMVJVP $.

    $( Any abelian group is the direct product of factors of prime power order
       (with the exact order further matching the prime factorization of the
       group order).  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    ablfac1b $p |- ( ph -> G dom DProd S ) $=
      ( cfv eqid wcel syl co cdivides va vb csubg cmrc cvv c0g ccntz cabel cgrp
      ablgrp cprime wss cn nnex cv prmnn ssriv ssexi ssex chash cpc cexp wbr wa
      crab cz adantr sselda c0 wne grpbn0 cfn wb hashnncl mpbird pccld nnexpcld
      nnzd oddvdssubg syl2anc fmptd w3a wf simpr1 ffvelrnd simpr2 ablcntzd cdif
      csn cima cuni cin cdiv wceq oveq1 oveq12d breq2d rabbidv cbs fvex eqeltri
      id rabex fvmpt3i adantl eqimss cmre cacs subgacs acsmre 4syl cpw cres crn
      df-ima cmul ad2antrr ad3antrrr pcdvds eldifi sseldd cgcd c1 wi ablfac1lem
      ad2antlr simp1d simpld eldifsni necomd prmrp cn0 prmz rpexp12i coprmdvds2
      syl112anc mpd syl31anc syl3anc cmpt mp2and simp3d simprd nnne0d dvdscmulr
      breqtrd mpbid odcl nn0zd dvdstr mpan2d ss2rabdv elpw sylibr reseq1i difss
      cc0 resmpt ax-mp eqtri syl5eqss sspwuni sylib mrcsscl ss2in clsm ablfacrp
      frn simp2d sseqtrd dmdprdd ) AUAUBEFCFUCOZUDOZUEFUFOZFUGOZUVOPZUVNPZUVMPZ
      AFUHQZFUIQZLFUJZRZACUKULZCUEQNCUKUKUMUNHUKUMHUOZUPZUQURUSRAHCBUOZGOZUWDUW
      DDUTOZVASZVBSZTVCZBDVEZUVLEAUWDCQZVDZUVSUWJVFQZUWLUVLQAUVSUWMLVGUWNUWJUWN
      UWDUWIUWNUWDUKQZUWDUMQZACUKUWDNVHZUWERUWNUWDUWHUWRAUWHUMQZUWMAUWSDVIVJZAU
      VTUWTUWBDFIVKRADVLQUWSUWTVMMDVNRVOZVGVPVQVRBDFUWJGJIVSVTKWAZAUAUOZCQZUBUO
      ZCQZUXCUXEVJZWBZVDZUXCEOZUXEEOFUVOUVPAUVSUXHLVGUXICUVLUXCEACUVLEWCUXHUXBV
      GZAUXDUXFUXGWDWEUXICUVLUXEEUXKAUXDUXFUXGWFWEWGAUXDVDZUXJECUXCWIZWHZWJZWKZ
      UVMOZWLZUWGUXCUXCUWHVASZVBSZTVCZBDVEZUWGUWHUXTWMSZTVCZBDVEZWLZUVNWIZUXLUX
      JUYBULZUXQUYEULZUXRUYFULUXLUXJUYBWNZUYHUXDUYJAHUXCUWLUYBCEUWDUXCWNZUWKUYA
      BDUYKUWJUXTUWGTUYKUWDUXCUWIUXSVBUYKXBUWDUXCUWHVAWOWPWQWRKUWKBDDFWSOZUEIFW
      SWTXAXCZXDXEUXJUYBXFRUXLUVLUYLXGOQZUXPUYEULZUYEUVLQZUYIUXLUVSUVTUVLUYLXHO
      QUYNAUVSUXDLVGZUWAUYLFUYLPXIUVLUYLXJXKUXLUXOUYEXLZULUYOUXLUXOEUXNXMZXNZUY
      REUXNXOUXLUXNUYRUYSWCUYTUYRULUXLHUXNUWLUYRUYSUXLUWDUXNQZVDZUWLUYEULUWLUYR
      QVUBUWKUYDBDVUBUWFDQZVDZUWKUWJUYCTVCZUYDVUDUXTUWJXPSZUXTUYCXPSZTVCZVUEVUD
      VUFUWHVUGTVUDUXTUWHTVCZUWJUWHTVCZVUFUWHTVCZVUDUXCUKQZUWSVUIUXLVULVUAVUCAC
      UKUXCNVHXQZAUWSUXDVUAVUCUXAXRZUXCUWHXSVTVUDUWPUWSVUJVUDCUKUWDAUWCUXDVUAVU
      CNXRVUAUWMUXLVUCUWDCUXMXTYFYAZVUNUWDUWHXSVTVUDUXTVFQZUWOUWHVFQUXTUWJYBSYC
      WNZVUIVUJVDVUKYDVUDUXTUXLUXTUMQZVUAVUCUXLVURUYCUMQZUXLVURVUSVDZUXTUYCYBSY
      CWNZUWHVUGWNZABCDUXCEFUXTUYCGHIJKLMNUXTPUYCPYEZYGZYHZXQZVRZVUDUWJVUDUWDUW
      IVUDUWPUWQVUOUWERVUDUWDUWHVUOVUNVPZVQVRZVUDUWHVUNVRVUDUXCUWDYBSYCWNZVUQVU
      DVVJUXCUWDVJZVUDUWDUXCVUAUWDUXCVJUXLVUCUWDCUXCYIYFYJVUDVULUWPVVJVVKVMVUMV
      UOUXCUWDYKVTVOVUDUXCVFQZUWDVFQZUXSYLQUWIYLQVVJVUQYDVUDVULVVLVUMUXCYMRVUDU
      WPVVMVUOUWDYMRVUDUXCUWHVUMVUNVPVVHUXCUWDUXSUWIYNYPYQUWHUXTUWJYOYRUUAUXLVV
      BVUAVUCUXLVUTVVAVVBVVCUUBZXQUUFVUDUWOUYCVFQZVUPUXTUUQVJVUHVUEVMVVIVUDUYCU
      XLVUSVUAVUCUXLVURVUSVVDUUCZXQVRZVVGVUDUXTVVFUUDUXTUWJUYCUUEYPUUGVUDUWGVFQ
      UWOVVOUWKVUEVDUYDYDVUDUWGVUCUWGYLQVUBUWFFGDIJUUHXEUUIVVIVVQUWGUWJUYCUUJYS
      UUKUULUWLUYEUYMUUMUUNUYSHCUWLYTZUXNXMZHUXNUWLYTZEVVRUXNKUUOUXNCULVVSVVTWN
      CUXMUUPHCUXNUWLUURUUSUUTWAUXNUYRUYSUVHRUVAUXOUYEUVBUVCUXLUVSVVOUYPUYQUXLU
      YCVVPVRBDFUYCGJIVSVTUVLUXPUVMUYEUYLUVRUVDYSUXJUYBUXQUYEUVEVTUXLUYFUYGWNUY
      BUYEFUVFOZSDWNUXLBDVWAFUYBUYEUXTUYCGUVNIJUYBPUYEPUYQVVEVVPUXLVUTVVAVVBVVC
      UVIVVNUVQVWAPUVGYHUVJUVK $.

    ablfac1c.d $e |- D = { w e. Prime | w || ( # ` B ) } $.
    ablfac1.2 $e |- ( ph -> D C_ A ) $.
    $( The factors of ~ ablfac1b cover the entire group.  (Contributed by Mario
       Carneiro, 21-Apr-2016.) $)
    ablfac1c $p |- ( ph -> ( G DProd S ) = B ) $=
      ( wcel wbr vq cfn cdprd co wss cen wceq dprdssv a1i cfv cn0 cdivides ssfi
      chash sylancl hashcl syl cdm ablfac1b dprdsubg lagsubg syl2anc cv cpc cle
      csubg cprime wral breq1 elrab2 sseld syl5bir impl cexp ablfac1a cress cbs
      wa crab fvex eqeltri rabex dmmpti dprdf2 ffvelrnda adantr simpr dprdub wb
      cvv subsubg mpbir2and subgbas eqeltrrd fveq2d breqtrrd eqbrtrrd cz sselda
      eqid nn0zd cn c0 wne cabel cgrp ablgrp grpbn0 3syl hashnncl mpbird syldan
      pccld pcdvdsb syl3anc adantlr wn cc0 biimpar subg0cl ne0i nn0ge0d eqbrtrd
      pceq0 pm2.61dan ralrimiva pc2dvds dvdseq syl22anc hashen mpbid fisseneq
      c0g ) AEUBSZHGUCUDZEUEZYOEUFTZYOEUGOYPAEGHKUHZUIAYOUNUJZEUNUJZUGZYQAYSUKS
      ZYTUKSZYSYTULTZYTYSULTZUUAAYOUBSZUUBAYNYPUUFOYREYOUMUOZYOUPUQZAYNUUCOEUPU
      QZAYOHVFUJZSZYNUUDAHGUCURTZUUKABDEGHIJKLMNOPUSZGHUTUQZOHEYOKVAVBAUUEUAVCZ
      YTVDUDZUUOYSVDUDZVETZUAVGVHZAUURUAVGAUUOVGSZVRZUUOYTULTZUURUVAUVBUUODSZUU
      RAUUTUVBUVCUUTUVBVRUUOFSAUVCCVCZYTULTUVBCUUOVGFUVDUUOYTULVIQVJAFDUUORVKVL
      VMAUVCUURUUTAUVCVRZUURUUOUUPVNUDZYSULTZUVEUUOGUJZUNUJZUVFYSULABDEUUOGHIJK
      LMNOPVOUVEUVIHYOVPUDZVQUJZUNUJZYSULUVEUVHUVJVFUJSZUVKUBSUVIUVLULTUVEUVMUV
      HUUJSZUVHYOUEZADUUJUUOGAGHDUUMGURDUGZAJDBVCIUJJVCZUVQYTVDUDVNUDULTZBEVSGU
      VRBEEHVQUJWJKHVQVTWAWBMWCZUIWDWEUVEGHDUUOAUULUVCUUMWFUVPUVEUVSUIAUVCWGWHU
      VEUUKUVMUVNUVOVRWIAUUKUVCUUNWFZUVHYOHUVJUVJWTZWKUQWLUVEYOUVKUBUVEUUKYOUVK
      UGUVTYOHUVJUWAWMUQZAUUFUVCUUGWFWNUVJUVKUVHUVKWTVAVBUVEYOUVKUNUWBWOWPWQUVE
      UUTYSWRSZUUPUKSZUURUVGWIADVGUUOPWSZAUWCUVCAYSUUHXAZWFAUVCUUTUWDUWEUVAUUOY
      TAUUTWGZAYTXBSZUUTAUWHEXCXDZAHXESHXFSUWINHXGEHKXHXIAYNUWHUWIWIOEXJUQXKWFZ
      XMXLUUPUUOYSXNXOXKXPXLUVAUVBXQZVRUUPXRUUQVEUVAUUPXRUGZUWKUVAUUTUWHUWLUWKW
      IUWGUWJUUOYTYDVBXSUVAXRUUQVETUWKUVAUUQUVAUUOYSUWGAYSXBSZUUTAUWMYOXCXDZAUU
      KHYMUJZYOSUWNUUNYOHUWOUWOWTXTYOUWOYAXIAUUFUWMUWNWIUUGYOXJUQXKWFXMYBWFYCYE
      YFAYTWRSUWCUUEUUSWIAYTUUIXAUWFYTYSUAYGVBXKYSYTYHYIAUUFYNUUAYQWIUUGOYOEYJV
      BYKYOEYLXO $.

    ablfac1eu.1 $e |- ( ph -> ( G dom DProd T /\ ( G DProd T ) = B ) ) $.
    ablfac1eu.2 $e |- ( ph -> dom T = A ) $.
    ablfac1eu.3 $e |- ( ( ph /\ q e. A ) -> C e. NN0 ) $.
    ablfac1eu.4 $e |- ( ( ph /\ q e. A ) -> ( # ` ( T ` q ) ) = ( q ^ C ) ) $.
    ${
      ablfac1eulem.1 $e |- ( ph -> P e. Prime ) $.
      ablfac1eulem.2 $e |- ( ph -> A e. Fin ) $.
      $( Lemma for ~ ablfac1eu .  (Contributed by Mario Carneiro,
         27-Apr-2016.) $)
      ablfac1eulem $p |- ( ph ->
        -. P || ( # ` ( G DProd ( T |` ( A \ { P } ) ) ) ) ) $=
        ( vy vz wss csn cdif cres cdprd co chash cfv cdivides wbr ssid cfn wcel
        wn wi cv cun wceq sseq1 difeq1 0dif syl6eq reseq2d oveq2d fveq2d breq2d
        c0 res0 notbid imbi12d imbi2d c1 cprime nprmdvds1 syl c0g cabel cgrp wa
        cdm ablgrp eqid dprd0 3syl simprd cvv fvex hashsng ax-mp a1d ssun1 sstr
        mtbird mpan imim1i cmul clsm csubg simpld dprdf2 adantr simprr ssdifssd
        wo wf fssres syl2anc simprl disjsn sylibr difeq1d dprdres mp1i dprdsubg
        cin ssdif dprdssv ssfi sylancl resabs1 cz hashcl nn0zd syl3anc ad2antrr
        cn0 eqtrd syldan adantl a2d difindir 3eqtr3g difundir a1i dprdsplit fdm
        ccntz ssun2 dprddisj2 dprdcntz2 lsmhash oveq12d wb euclemma bitrd simpr
        3eqtrd sneqd difid wne cexp unssbd snss sseldd prmdvdsexpr eqcom syl6ib
        vex imp disjsn2 disj3 sylib dpjlem eqtr3d pm2.61dane orel2 sylbid con3d
        necon3ad expr syl5 expcom findcard2s mpcom mpi ) ADDUKZHKJDHULZUMZUNZUO
        UPZUQURZUSUTZVDZDVADVBVCAUWFUWMVEZUHAUIVFZDUKZHKJUWOUWGUMZUNZUOUPZUQURZ
        USUTZVDZVEZVEAVQDUKZHKVQUOUPZUQURZUSUTZVDZVEZVEAUJVFZDUKZHKJUXJUWGUMZUN
        ZUOUPZUQURZUSUTZVDZVEZVEAUXJMVFZULZVGZDUKZHKJUYAUWGUMZUNZUOUPZUQURZUSUT
        ZVDZVEZVEAUWNVEUIUJMDUWOVQVHZUXCUXIAUYJUWPUXDUXBUXHUWOVQDVIUYJUXAUXGUYJ
        UWTUXFHUSUYJUWSUXEUQUYJUWRVQKUOUYJUWRJVQUNZVQUYJUWQVQJUYJUWQVQUWGUMZVQU
        WOVQUWGVJUWGVKZVLVMJVRZVLVNVOVPVSVTWAUWOUXJVHZUXCUXRAUYOUWPUXKUXBUXQUWO
        UXJDVIUYOUXAUXPUYOUWTUXOHUSUYOUWSUXNUQUYOUWRUXMKUOUYOUWQUXLJUWOUXJUWGVJ
        VMVNVOVPVSVTWAUWOUYAVHZUXCUYIAUYPUWPUYBUXBUYHUWOUYADVIUYPUXAUYGUYPUWTUY
        FHUSUYPUWSUYEUQUYPUWRUYDKUOUYPUWQUYCJUWOUYAUWGVJVMVNVOVPVSVTWAUWODVHZUX
        CUWNAUYQUWPUWFUXBUWMUWODDVIUYQUXAUWLUYQUWTUWKHUSUYQUWSUWJUQUYQUWRUWIKUO
        UYQUWQUWHJUWODUWGVJVMVNVOVPVSVTWAAUXHUXDAUXGHWBUSUTZAHWCVCZUYRVDZUGHWDW
        EZAUXFWBHUSAUXFKWFURZULZUQURZWBAUXEVUCUQAKVQUOWJZUTZUXEVUCVHZAKWGVCKWHV
        CVUFVUGWIRKWKKVUBVUBWLZWMWNWOZVOVUBWPVCVUDWBVHKWFWQVUBWPWRWSZVLVPXCWTUX
        JVBVCZUXSUXJVCVDZWIAUXRUYIVULAUXRUYIVEZVEVUKAVULVUMUXRUYBUXQVEAVULWIZUY
        IUYBUXKUXQUXJUYAUKZUYBUXKUXJUXTXAZUXJUYADXBXDXEVUNUYBUXQUYHAVULUYBUXQUY
        HVEAVULUYBWIZWIZUYGUXPVURUYGUXPHKJUXTUWGUMZUNZUOUPZUQURZUSUTZXNZUXPVURU
        YGHUXOVVBXFUPZUSUTZVVDVURUYFVVEHUSVURUYFKUYDUXLUNZUOUPZKUYDVUSUNZUOUPZK
        XGURZUPZUQURVVHUQURZVVJUQURZXFUPVVEVURUYEVVLUQVURUXLVUSVVKUYDKUYCVURDKX
        HURZJXOZUYCDUKUYCVVOUYDXOZAVVPVUQAJKDAKJVUEUTZKJUOUPZEVHUCXIZUDXJXKVURU
        YADUWGAVULUYBXLZXMZDVVOUYCJXPXQZVURUXJUXTYEZUWGUMUYLUXLVUSYEVQVURVWDVQU
        WGVURVULVWDVQVHAVULUYBXRUXJUXSXSXTYAUXJUXTUWGUUAUYMUUBZUYCUXLVUSVGVHVUR
        UXJUXTUWGUUCUUDVVKWLZVURKUYDVUEUTUYEVVSUKVURUYCJKDAVVRVUQVVTXKAJWJDVHZV
        UQUDXKVWBYBXIZUUEVOVURVVKVVHVVJKVUBKUUGURZVWFVUHVWIWLZVURKVVGVUEUTZVVHV
        VOVCVURVWKVVHUYEUKVURUXLUYDKUYCVWHVURVVQUYDWJUYCVHVWCUYCVVOUYDUUFWEZVUO
        UXLUYCUKZVURVUPUXJUYAUWGYFYCZYBXIVVGKYDWEVURKVVIVUEUTZVVJVVOVCVURVWOVVJ
        UYEUKVURVUSUYDKUYCVWHVWLUXTUYAUKVUSUYCUKZVURUXTUXJUUHUXTUYAUWGYFYCZYBXI
        VVIKYDWEVURUXLVUSUYDKUYCVUBVWHVWLVWNVWQVWEVUHUUIVURUXLVUSUYDKUYCVWIVWHV
        WLVWNVWQVWEVWJUUJVUREVBVCZVVHEUKVVHVBVCAVWRVUQSXKZEVVGKOYGEVVHYHYIVURVW
        RVVJEUKVVJVBVCVWSEVVIKOYGEVVJYHYIUUKVURVVMUXOVVNVVBXFVURVVHUXNUQVURVVGU
        XMKUOVURVWMVVGUXMVHVWNJUXLUYCYJWEVNVOVURVVJVVAUQVURVVIVUTKUOVURVWPVVIVU
        TVHVWQJVUSUYCYJWEVNVOUULUUQVPVURUYSUXOYKVCVVBYKVCVVFVVDUUMAUYSVUQUGXKZV
        URUXOVURUXNVBVCZUXOYPVCVURVWRUXNEUKVXAVWSEUXMKOYGEUXNYHYIUXNYLWEYMVURVV
        BVURVVAVBVCZVVBYPVCVURVWRVVAEUKVXBVWSEVUTKOYGEVVAYHYIVVAYLWEYMHUXOVVBUU
        NYNUUOVURVVCVDZVVDUXPVEVURVXCUXSHVURUXSHVHZWIZVVCUYRAUYTVUQVXDVUAYOVXEV
        VBWBHUSVXEVVBVUDWBVXEVVAVUCUQVXEVVAUXEVUCVXEVUTVQKUOVXEVUTUYKVQVXEVUSVQ
        JVXEVUSUWGUWGUMVQVXEUXTUWGUWGVXEUXSHVURVXDUUPUURYAUWGUUSVLVMUYNVLVNAVUG
        VUQVXDVUIYOYQVOVUJVLVPXCVURUXSHUUTZWIZVVCHUXSFUVAUPZUSUTZVURVXFVXIVDVUR
        VXIUXSHVURVXIHUXSVHZVXDVURUYSUXSWCVCFYPVCZVXIVXJVEVWTVURDWCUXSADWCUKVUQ
        TXKVURUXTDUKUXSDVCZVURUXJUXTDVWAUVBUXSDMUVHUVCXTZUVDAVUQVXLVXKVXMUEYRHU
        XSFUVEYNHUXSUVFUVGUVSUVIVXGVVBVXHHUSVXGVVBUXSJURZUQURZVXHVXGVVAVXNUQVXG
        KJUXTUNZUOUPVVAVXNVXGVXPVUTKUOVXGUXTVUSJVXGUXTUWGYEVQVHZUXTVUSVHVXFVXQV
        URUXSHUVJYSUXTUWGUVKUVLVMVNVXGJKDUXSAVVRVUQVXFVVTYOAVWGVUQVXFUDYOVURVXL
        VXFVXMXKUVMUVNVOVURVXOVXHVHZVXFAVUQVXLVXRVXMUFYRXKYQVPXCUVOVVCUXPUVPWEU
        VQUVRUVTYTUWAUWBYSYTUWCUWDUWE $.
    $}

    $( The factorization of ~ ablfac1b is unique, in that any other
       factorization into prime power factors (even if the exponents are
       different) must be equal to ` S ` .  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    ablfac1eu $p |- ( ph -> T = S ) $=
      ( vy cfv wf wfn cdprd cdm wbr co wceq simpld dprdf2 ffn syl cv chash cexp
      cpc cdivides crab cbs cvv fvex a1i wa cfn wss cen adantr ffvelrnda subgss
      wcel ssfi syl2anc simpr syl3anc cz cn0 cprime sselda prmz cle nn0zd cn c0
      wne wb hashnncl mpbird lagsubg nnzd wi prmnn dvdstr mp2and id adantl cres
      weq csn cdif cmul dprdres fssres fdm difssd dprdsubg cgcd c1 eqid subg0cl
      c0g dprdssv sylancl wn fvres adantrr snssd cc0 sylib oveq2d 3eqtrd hashen
      mpd mpbid fisseneq cin disjdif cun dprdsplit simprd eqtr3d syldan adantlr
      fveq2d reseq2d csubg ablfac1b eqeltri rabex dmmpti odsubdvds cabel ablgrp
      cgrp grpbn0 pccld eqbrtrrd pcdvdsb eluz2 syl3anbrc dvdsexp eqbrtrd hashcl
      cuz nnexpcld ssrabdv oveq1 oveq12d breq2d rabbidv fvmpt3i sseqtr4d nnnn0d
      odcl pcdvds ne0i wral cmpt ssrab2 eqsstri ssid clsm difss eldif iddvdsexp
      sylan eqeltrrd breq1 elrab2 sylanbrc ex con3d impr wo elnn0 nncnd hashsng
      exp0d ax-mp syl6reqr snfi sylancr eqsstr3d sylan2b eqsstrd dprdlub lsmss2
      ord undif2 ssequn1 syl5req jca eqtrd cfz fzfid w3a 3ad2ant2 dvdsle 3impia
      syl2anr 3ad2ant1 mpbir2and rabssdv ablfac1eulem ralrimiva difeq2d breq12d
      fznn syl5eqss sneq notbid rspcv sylc coprm rpexp1i coprmdvds2 ccntz inss1
      syl31anc inass ineq2i in0 3eqtri dprddisj2 dprdcntz2 lsmhash eqcomi snssi
      inundif dfss1 ad2antrr dpjlem simprr disjsn sylibr syl6eq dprd0 pm2.61dan
      anassrs oveq1d 3eqtr3d breqtrd nnne0d dvdsmulcr syl112anc dvdseq syl22anc
      res0 ablfac1a eqtr4d eqfnfvd ) ALDIHADJUUAUGZIUHZIDUIAIJDAJIUJUKZULZJIUJU
      MZEUNZUBUOZUCUPZDVVGIUQURADVVGHUHHDUIAHJDABDEHJKMNOPQRSUUBHUKDUNAMDBUSZKU
      GZMUSZVVQEUTUGZVBUMZVAUMZVCULZBEVDZHVWABEEJVEUGVFNJVEVGUUCUUDZPUUEVHUPZDV
      VGHUQURALUSZDVPZVIZVWEHUGZVJVPZVWEIUGZVWHVKVWJVWHVLULZVWJVWHUNVWGEVJVPZVW
      HEVKZVWIAVWLVWFRVMZVWGVWHVVGVPVWMADVVGVWEHVWDVNEVWHJNVOUREVWHVQVRZVWGVWJV
      VPVWEVWEVVRVBUMZVAUMZVCULZBEVDZVWHVWGVWRBEVWJVWGVWJVVGVPZVWJEVKZADVVGVWEI
      VVNVNZEVWJJNVOURZVWGVVOVWJVPZVIZVVPVWJUTUGZVCULZVXFVWQVCULZVWRVXEVWTVWJVJ
      VPZVXDVXGVWGVWTVXDVXBVMVWGVXIVXDVWGVWLVXAVXIVWNVXCEVWJVQVRZVMVWGVXDVSVVOV
      WJJKOUUFVTVWGVXHVXDVWGVXFVWEFVAUMZVWQVCUEVWGVWEWAVPZFWBVPZVWPFUUSUGVPZVXK
      VWQVCULVWGVWEWCVPZVXLADWCVWESWDZVWEWEURZUDVWGFWAVPVWPWAVPFVWPWFULZVXNVWGF
      UDWGVWGVWPVWGVWEVVRVXPAVVRWHVPZVWFAVXSEWIWJZAJUUIVPZVXTAJUUGVPZVYAQJUUHUR
      ZEJNUUJURAVWLVXSVXTWKREWLURWMZVMZUUKZWGVWGVXRVXKVVRVCULZVWGVXFVXKVVRVCUEV
      WGVWTVWLVXFVVRVCULVXBVWNJEVWJNWNVRUULZVWGVXOVVRWAVPZVXMVXRVYGWKVXPVWGVVRV
      YEWOZUDFVWEVVRUUMVTWMFVWPUUNUUOVWEFVWPUUPVTUUQZVMVXEVVPWAVPVXFWAVPZVWQWAV
      PZVXGVXHVIVWRWPVXEVVPVXEVVOEVPVVPWBVPVWGVWJEVVOVXCWDVVOJKENOUVIURWGVWGVYL
      VXDVWGVXFVWGVXIVXFWBVPZVXJVWJUURURZWGZVMVWGVYMVXDVWGVWQVWGVWEVWPVWGVXOVWE
      WHVPZVXPVWEWQURZVYFUUTZWOZVMVVPVXFVWQWRVTWSUVAVWFVWHVWSUNAMVWEVWBVWSDHMLX
      CZVWAVWRBEWUAVVTVWQVVPVCWUAVVQVWEVVSVWPVAWUAWTVVQVWEVVRVBUVBUVCUVDUVEPVWC
      UVFXAUVGVWGVXFVWHUTUGZUNZVWKVWGVXFVWQWUBVWGVYNVWQWBVPVXHVWQVXFVCULZVXFVWQ
      UNVYOVWGVWQVYSUVHVYKVWGVWQJIGXBZGVWEXDZXEZXBZUJUMZUTUGZXFUMZVXFWUJXFUMZVC
      ULZWUDVWGWUKVVRWULVCVWGVWQVVRVCULZWUJVVRVCULZWUKVVRVCULZVWGVXOVXSWUNVXPVY
      EVWEVVRUVJVRVWGWUIVVGVPZVWLWUOVWGJWUHVVIULZWUQVWGWURWUIJWUEUJUMZVKVWGWUGW
      UEJGVWGJWUEVVIULZWUSVVKVKZVWGGIJDAVVJVWFVVMVMAIUKDUNVWFUCVMAGDVKZVWFUAVMZ
      XGUOZVWGGVVGWUEUHZWUEUKGUNZVWGVVHWVBWVEAVVHVWFVVNVMWVCDVVGGIXHZVRZGVVGWUE
      XIZURZVWGGWUFXJZXGUOWUHJXKURZVWNJEWUINWNVRVWGVYMWUJWAVPZVYIVWQWUJXLUMXMUN
      ZWUNWUOVIWUPWPVYTVWGWUJVWGWUJWHVPZWUIWIWJZVWGJXPUGZWUIVPZWVPVWGWUQWVRWVLW
      UIJWVQWVQXNZXOURWUIWVQUVKURVWGWUIVJVPZWVOWVPWKVWGVWLWUIEVKWVTVWNEWUHJNXQE
      WUIVQXRZWUIWLURWMZWOZVYJVWGVWEWUJXLUMXMUNZWVNVWGVWEWUJVCULZXSZWWDVWGVXOVV
      OJWUEGVVOXDZXEZXBZUJUMZUTUGZVCULZXSZBWCUVLZWWFVXPAWWNVWFAWWMBWCAVVOWCVPZV
      IZUFCGEFGVVOMGUFUSKUGVVTVCULUFEVDUVMZWUEJKLMNOWWQXNAVYBWWOQVMAVWLWWORVMGW
      CVKWWPGCUSZVVRVCULZCWCVDZWCTWWSCWCUVNUVOVHTGGVKWWPGUVPVHAWUTWUSEUNZVIWWOA
      WUTWXAAWUTWVAAGIJDVVMUCUAXGUOZAWUSJIDGXEZXBZUJUMZJUVQUGZUMZWUSEAWUSVVGVPZ
      WXEVVGVPZWXEWUSVKWXGWUSUNAWUTWXHWXBWUEJXKURZAJWXDVVIULZWXIAWXKWXEVVKVKAWX
      CIJDVVMUCADGXJXGUOZWXDJXKURAWXDWUSLJWXCWXLAWXCVVGWXDUHZWXDUKWXCUNAVVHWXCD
      VKWXMVVNDGUVRDVVGWXCIXHXRWXCVVGWXDXIURWXJAVWEWXCVPZVIVWEWXDUGZVWJWUSWXNWX
      OVWJUNAVWEWXCIXTXAWXNAVWFVWEGVPZXSZVIZVWJWUSVKVWEDGUVSAWXRVIZVWJWVQXDZWUS
      WXSVXIWXTVWJVKZWXTVWJVLULZWXTVWJUNAVWFVXIWXQVXJYAZAVWFWYAWXQVWGWVQVWJVWGV
      WTWVQVWJVPVXBVWJJWVQWVSXOURYBYAWXSWXTUTUGZVXFUNZWYBWXSVXFXMWYDWXSVXFVXKVW
      EYCVAUMXMAVWFVXFVXKUNZWXQUEYAWXSFYCVWEVAWXSFWHVPZXSZFYCUNZAVWFWXQWYHVWGWY
      GWXPVWGWYGWXPVWGWYGVIZVXOVWEVVRVCULZWXPVWGVXOWYGVXPVMWYJVWEVXKVCULZVYGWYK
      VWGVXLWYGWYLVXQVWEFUVTUWAVWGVYGWYGVYHVMVWGWYLVYGVIWYKWPZWYGVWGVXLVXKWAVPV
      YIWYMVXQVWGVXFVXKWAUEVYPUWBVYJVWEVXKVVRWRVTVMWSWWSWYKCVWEWCGWWRVWEVVRVCUW
      CTUWDUWEUWFUWGUWHWXSWYGWYIWXSVXMWYGWYIUWIAVWFVXMWXQUDYAFUWJYDUXCYHYEWXSVW
      EWXSVWEAVWFVYQWXQVYRYAUWKUWMYFWVQVFVPWYDXMUNJXPVGWVQVFUWLUWNUWOWXSWXTVJVP
      VXIWYEWYBWKWVQUWPWYCWXTVWJYGUWQYIWXTVWJYJVTZWXSWVQWUSAWVQWUSVPZWXRAWXHWYO
      WXJWUSJWVQWVSXOURVMYBUWRUWSUWTUXAWXFWUSWXEJWXFXNZUXBVTAVVKWXGEAGWXCWXFIJD
      VVNGWXCYKWIUNAGDYLVHAGWXCYMGDYMZDGDUXDAWVBWYQDUNUAGDUXEYDUXFWYPVVMYNAVVJV
      VLUBYOYPYPZUXGVMAWVFWWOAWVEWVFAVVHWVBWVEVVNUAWVGVRWVIURZVMAWXPVXMWWOAWXPV
      WFVXMAGDVWEUAWDZUDYQYRAWXPVWEWUEUGZUTUGZVXKUNWWOAWXPVIZXUBVXFVXKXUCXUAVWJ
      UTWXPXUAVWJUNZAVWEGIXTZXAYSAWXPVWFWYFWYTUEYQUXHYRAWWOVSAGVJVPZWWOAXMVVRUX
      IUMZVJVPGXUGVKXUFAXMVVRUXJAGWWTXUGTAWWSCWCXUGAWWRWCVPZWWSUXKZWWRXUGVPZWWR
      WHVPZWWRVVRWFULZXUHAXUKWWSWWRWQUXLAXUHWWSXULXUHWWRWAVPVXSWWSXULWPAWWRWEVY
      DWWRVVRUXMUXOUXNXUIVYIXUJXUKXULVIWKAXUHVYIWWSAVVRVYDWOUXPWWRVVRUYCURUXQUX
      RUYDXUGGVQVRVMUXSUXTVMWWMWWFBVWEWCBLXCZWWLWWEXUMVVOVWEWWKWUJVCXUMWTXUMWWJ
      WUIUTXUMWWIWUHJUJXUMWWHWUGWUEXUMWWGWUFGVVOVWEUYEUYAYTYEYSUYBUYFUYGUYHVWGV
      XOWVMWWFWWDWKVXPWWCVWEWUJUYIVRYIVWGVXLWVMVWPWBVPWWDWVNWPVXQWWCVYFVWEWUJVW
      PUYJVTYHVVRVWQWUJUYKUYNWSVWGJWUEGWUFYKZXBZUJUMZWUIWXFUMZUTUGXUPUTUGZWUJXF
      UMVVRWULVWGWXFXUPWUIJWVQJUYLUGZWYPWVSXUSXNZVWGJXUOVVIULZXUPVVGVPVWGXVAXUP
      WUSVKVWGXUNWUEJGWVDWVJXUNGVKVWGGWUFUYMVHZXGUOXUOJXKURWVLVWGXUNWUGWUEJGWVQ
      WVDWVJXVBWVKXUNWUGYKZWIUNVWGXVCGWUFWUGYKZYKGWIYKWIGWUFWUGUYOXVDWIGWUFGYLU
      YPGUYQUYRVHZWVSUYSVWGXUNWUGWUEJGXUSWVDWVJXVBWVKXVEXUTUYTVWGVWLXUPEVKXUPVJ
      VPVWNEXUOJNXQEXUPVQXRWWAVUAVWGXUQEUTVWGWUSXUQEVWGXUNWUGWXFWUEJGWVHXVEGXUN
      WUGYMZUNVWGXVFGGWUFVUDVUBVHWYPWVDYNAWXAVWFWYRVMYPYSVWGXURVXFWUJXFVWGXUPVW
      JUTVWGWXPXUPVWJUNZVWGWXPVIZXUPJWUEWUFXBZUJUMXUAVWJXVHXUOXVIJUJXVHXUNWUFWU
      EXVHWUFGVKZXUNWUFUNWXPXVJVWGVWEGVUCXAWUFGVUEYDYTYEXVHWUEJGVWEVWGWUTWXPWVD
      VMAWVFVWFWXPWYSVUFVWGWXPVSVUGWXPXUDVWGXUEXAYFAVWFWXQXVGWXSXUPJWIUJUMZWXTV
      WJWXSXUOWIJUJWXSXUOWUEWIXBWIWXSXUNWIWUEWXSWXQXUNWIUNAVWFWXQVUHGVWEVUIVUJY
      TWUEVVCVUKYEAXVKWXTUNZWXRAJWIVVIULZXVLAVYAXVMXVLVIVYCJWVQWVSVULURYOVMWYNY
      FVUNVUMYSVUOVUPVUQVWGVYMVYLWVMWUJYCWJWUMWUDWKVYTVYPWWCVWGWUJWWBVURWUJVWQV
      XFVUSVUTYIVXFVWQVVAVVBABDEVWEHJKMNOPQRSVVDVVEVWGVXIVWIWUCVWKWKVXJVWOVWJVW
      HYGVRYIVWJVWHYJVTVVF $.
  $}

  ${
    $d b k s t u v x y .0. $.  $d b k s t u v w x y A $.  $d a b n t w x y D $.
    $d a b k s t u v w x y .(+) $.  $d k E $.  $d a O $.  $d a b k s t w y P $.
    $d a k n s t v B $.  $d a b k n s t u v w x y G $.  $d b k s t u v w y U $.
    $d a k s t w C $.  $d a b k n s t u v w x y S $.  $d a b k n s t w x y W $.
    $d a b k n s t u v w x y ph $.  $d a b k n s t w y .x. $.
    $d s t w x y K $.
    pgpfac1.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    pgpfac1.s $e |- S = ( K ` { A } ) $.
    pgpfac1.b $e |- B = ( Base ` G ) $.
    pgpfac1.o $e |- O = ( od ` G ) $.
    pgpfac1.e $e |- E = ( gEx ` G ) $.
    pgpfac1.z $e |- .0. = ( 0g ` G ) $.
    pgpfac1.l $e |- .(+) = ( LSSum ` G ) $.
    pgpfac1.p $e |- ( ph -> P pGrp G ) $.
    pgpfac1.g $e |- ( ph -> G e. Abel ) $.
    pgpfac1.n $e |- ( ph -> B e. Fin ) $.
    pgpfac1.oe $e |- ( ph -> ( O ` A ) = E ) $.
    ${
      pgpfac1.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
      pgpfac1.au $e |- ( ph -> A e. U ) $.
      ${
        pgpfac1.w $e |- ( ph -> W e. ( SubGrp ` G ) ) $.
        pgpfac1.i $e |- ( ph -> ( S i^i W ) = { .0. } ) $.
        pgpfac1.ss $e |- ( ph -> ( S .(+) W ) C_ U ) $.
        pgpfac1.2 $e |- ( ph -> A. w e. ( SubGrp ` G )
          ( ( w C. U /\ A e. w ) -> -. ( S .(+) W ) C. w ) ) $.
        $( Lemma for ~ pgpfac1 .  (Contributed by Mario Carneiro,
           27-Apr-2016.) $)
        pgpfac1lem1 $p |- ( ( ph /\ C e. ( U \ ( S .(+) W ) ) ) ->
          ( ( S .(+) W ) .(+) ( K ` { C } ) ) = U ) $=
          ( co cdif wcel wa csn cfv wss wceq adantr csubg cmre cgrp cacs ablgrp
          cabel subgacs acsmre 4syl eldifi adantl mrcsscl syl3anc wb subgss syl
          snssd sseldd mrcsncl syl2anc syl5eqel lsmsubg2 sselda sylan2 mpbi2and
          lsmlub wn wi lsmub1 lsmub2 mrcssidd mpbird eldifn ssnelpssd syl6sseqr
          wpss snssg wral psseq1 eleq2 anbi12d psseq2 notbid imbi12d rspcv sylc
          cv mpan2d mt2d npss sylib mpd ) AEIHNGUMZUNUOZUPZXNEUQZLURZGUMZIUSZXS
          IUTZXPXNIUSZXRIUSZXTAYBXOUKVAXPKVBURZDVCURUOZXQIUSIYDUOZYCAYEXOAKVGUO
          ZKVDUOYDDVEURUOYEUDKVFDKRVHYDDVIVJZVAZXPEIXOEIUOZAEIXNVKZVLVRAYFXOUGV
          AZYDXQLIDPVMVNXPXNYDUOZXRYDUOZYFYBYCUPXTVOAYMXOAYGHYDUOZNYDUOZYMUDAHC
          UQZLURZYDQAYECDUOYRYDUOYHAIDCAYFIDUSUGDIKRVPVQZUHVSZYDCLDPVTWAWBZUIGH
          NKUBWCVNVAZXPYEEDUOZYNYIXOAYJUUCYKAIDEYSWDWEZYDELDPVTWAZYLGXNXRIKUBWG
          VNWFXPXSIWQZWHXTYAWIXPUUFXNXSWQZXPXNXSEXPYMYNXNXSUSUUBUUEGXNXRKUBWJWA
          ZXPXRXSEXPYMYNXRXSUSUUBUUEGXNXRKUBWKWAXPEXRUOZXQXRUSZXPYDXQLDYIPXPEDU
          UDVRWLXPUUCUUIUUJVOUUDEXRDWRVQWMVSXOEXNUOWHAEIXNWNVLWOXPUUFCXSUOZUUGW
          HZXPXNXSCUUHACXNUOXOAHXNCAYOYPHXNUSUUAUIGHNKUBWJWAACHUOZYQHUSZAYQYRHA
          YDYQLDYHPACDYTVRWLQWPACIUOUUMUUNVOUHCHIWRVQWMVSVAVSXPXSYDUOZBXHZIWQZC
          UUPUOZUPZXNUUPWQZWHZWIZBYDWSZUUFUUKUPZUULWIZXPYGYMYNUUOAYGXOUDVAUUBUU
          EGXNXRKUBWCVNAUVCXOULVAUVBUVEBXSYDUUPXSUTZUUSUVDUVAUULUVFUUQUUFUURUUK
          UUPXSIWTUUPXSCXAXBUVFUUTUUGUUPXSXNXCXDXEXFXGXIXJXSIXKXLXM $.

        pgpfac1.c $e |- ( ph -> C e. ( U \ ( S .(+) W ) ) ) $.
        pgpfac1.mg $e |- .x. = ( .g ` G ) $.
        $( Lemma for ~ pgpfac1 .  (Contributed by Mario Carneiro,
           27-Apr-2016.) $)
        pgpfac1lem2 $p |- ( ph -> ( P .x. C ) e. ( S .(+) W ) ) $=
          ( vk vs vt va co wcel eldifbd wn c1 cv cmul caddc cz wrex csn eldifad
          cfv adantr cdif wceq csubg cprime cpgp wbr pgpprm syl prmz subgmulgcl
          wa syl3anc simpr eldifd pgpfac1lem1 syldan eleqtrrd ex csg eqid cabel
          cmre cgrp cacs ablgrp subgacs acsmred subgss mrcsncl syl2anc syl5eqel
          wss sseldd lsmsubg2 lsmelvalm cmpt crn cycsubg2 rexeqdv cvv wral ovex
          rgenw oveq2 eqeq2d rexrnmpt mp1i bitrd rexbidv rexcom cplusg ad2antrr
          wb sstrd sselda simplr syl13anc 1z a1i eqcom rexbidva wi cgcd cn0 mpd
          nn0zd rexlimdva grpsubadd zmulcld mulgdir mulg1 mulgass oveq12d eqtrd
          mulgcl eqeq1d bitr4d 3bitr4g risset syl6bbr syl5bb id syl2anr sylancr
          3bitrd sylibd zmulcl zaddcl chash cdivides odcl cfn hashcl cpc gcdcom
          cexp pgphash oveq1d gcdaddm gcd1 eqtr3d cn wne grpbn0 hashnncl mpbird
          pccld rpexp1i 3eqtrd oddvds2 rpdvds syl32anc odbezout syl31anc 3expia
          c0 eleq1 imbi2d syl5ibcom syld mt3d ) AFEIUTZHOGUTZVAZEUWPVAZAEJUWPUN
          VBAUWQVCZVDUPVEZFVFUTZVGUTZEIUTZUWPVAZUPVHVIZUWRAUWSEUWPUWOVJMVLZGUTZ
          VAZUXEAUWSUXHAUWSWDZEJUXGAEJVAZUWSAEJUWPUNVKZVMAUWSUWOJUWPVNVAUXGJVOU
          XIUWOJUWPAUWOJVAZUWSAJLVPVLZVAZFVHVAZUXJUXLUHAFVQVAZUXOAFLVRVSZUXPUDF
          LVTWAZFWBWAZUXKJILFEUOWCWEZVMAUWSWFWGABCDUWOFGHJKLMNOPQRSTUAUBUCUDUEU
          FUGUHUIUJUKULUMWHWIWJWKAUXHEUQVEZURVEZLWLVLZUTZVOZURUXFVIZUQUWPVIEUYA
          UWTUWOIUTZUYCUTZVOZUPVHVIZUQUWPVIZUXEAUQURGUWPUXFLUYCEUYCWMZUCALWNVAZ
          HUXMVAOUXMVAUWPUXMVAZUEAHCVJMVLZUXMRAUXMDWOVLVAZCDVAUYOUXMVAAUXMDALWP
          VAZUXMDWQVLVAAUYMUYQUELWRWAZDLSWSWAWTZAJDCAUXNJDXEUHDJLSXAWAZUIXFUXMC
          MDQXBXCXDUJGHOLUCXGWEZAUYPUWODVAZUXFUXMVAUYSAJDUWOUYTUXTXFZUXMUWOMDQX
          BXCXHAUYFUYJUQUWPAUYFUYEURUPVHUYGXIZXJZVIZUYJAUYEURUXFVUEAUYQVUBUXFVU
          EVOUYRVUCUPUWOIVUDLMDSUOVUDWMZQXKXCXLUYGXMVAZUPVHXNVUFUYJYFAVUHUPVHUW
          TUWOIXOXPUYEUYIUPURVHUYGVUDXMVUGUYBUYGVOUYDUYHEUYBUYGUYAUYCXQXRXSXTYA
          YBUYKUYIUQUWPVIZUPVHVIAUXEUYIUQUPUWPVHYCAVUIUXDUPVHAUWTVHVAZWDZVUIUYA
          UXCVOZUQUWPVIUXDVUKUYIVULUQUWPVUKUYAUWPVAZWDZUYHEVOZUXCUYAVOZUYIVULVU
          NVUOEUYGLYDVLZUTZUYAVOZVUPVUNUYQUYADVAUYGDVAZEDVAZVUOVUSYFAUYQVUJVUMU
          YRYEZVUKUWPDUYAAUWPDXEVUJAUWPJDULUYTYGVMYHVUNUYQVUJVUBVUTVVBAVUJVUMYI
          ZAVUBVUJVUMVUCYEDILUWTUWOSUOUUHWEAVVAVUJVUMAJDEUYTUXKXFZYEZDVUQLUYCUY
          AUYGESVUQWMZUYLUUAYJVUNUXCVURUYAVUNUXCVDEIUTZUXAEIUTZVUQUTZVURVUNUYQV
          DVHVAZUXAVHVAZVVAUXCVVIVOVVBVVJVUNYKYLVUNUWTFVVCAUXOVUJVUMUXSYEZUUBVV
          EDVUQILVDUXAESUOVVFUUCYJVUNVVGEVVHUYGVUQVUNVVAVVGEVOVVEDILESUOUUDWAVU
          NUYQVUJUXOVVAVVHUYGVOVVBVVCVVLVVEDILUWTFESUOUUEYJUUFUUGUUIUUJEUYHYMUY
          AUXCYMUUKYNUQUXCUWPUULUUMYNUUNUURUUSAUXDUWRUPVHVUKUSVEZUXCIUTZEVOZUSV
          HVIZUXDUWRYOZVUKUYQVVAUXBVHVAZUXBENVLZYPUTVDVOZVVPAUYQVUJUYRVMAVVAVUJ
          VVDVMZVUKVVJVVKVVRYKVUJVUJUXOVVKAVUJUUOUXSUWTFUUTUUPVDUXAUVAUUQZVUKVV
          RVVSVHVADUVBVLZVHVAZUXBVWCYPUTZVDVOVVSVWCUVCVSZVVTVWBVUKVVSVUKVVAVVSY
          QVAVWAELNDSTUVDWAYSAVWDVUJAVWCADUVEVAZVWCYQVAUFDUVFWAYSVMZVUKVWEVWCUX
          BYPUTZFFVWCUVGUTZUVIUTZUXBYPUTZVDVUKVVRVWDVWEVWIVOVWBVWHUXBVWCUVHXCVU
          KVWCVWKUXBYPAVWCVWKVOZVUJAUXQVWGVWMUDUFFLDSUVJXCVMUVKVUKFUXBYPUTZVDVO
          ZVWLVDVOZVUKFVDYPUTZVWNVDVUKVUJUXOVVJVWQVWNVOAVUJWFAUXOVUJUXSVMZVVJVU
          KYKYLUWTFVDUVLWEVUKUXOVWQVDVOVWRFUVMWAUVNVUKUXOVVRVWJYQVAZVWOVWPYOVWR
          VWBAVWSVUJAFVWCUXRAVWCUVOVAZDUWIUVPZAUYQVXAUYRDLSUVQWAAVWGVWTVXAYFUFD
          UVRWAUVSUVTVMFUXBVWJUWAWEYRUWBAVWFVUJAUYQVWGVVAVWFUYRUFVVDELNDSTUWCWE
          VMUXBVVSVWCUWDUWEUSEILUXBNDSTUOUWFUWGVUKVVOVVQUSVHVUKVVMVHVAZWDZUXDVV
          NUWPVAZYOZVVOVVQVXCUYNVXBVXEAUYNVUJVXBVUAYEVUKVXBWFUYNVXBUXDVXDUWPILV
          VMUXCUOWCUWHXCVVOVXDUWRUXDVVNEUWPUWJUWKUWLYTYRYTUWMUWN $.

        ${
          pgpfac1.m $e |- ( ph -> M e. ZZ ) $.
          pgpfac1.mw $e |- ( ph ->
            ( ( P .x. C ) ( +g ` G ) ( M .x. A ) ) e. W ) $.
          $( Lemma for ~ pgpfac1 .  (Contributed by Mario Carneiro,
             4-Jun-2016.) $)
          pgpfac1lem3a $p |- ( ph -> ( P || E /\ P || M ) ) $=
            ( vk cdivides wbr co wcel eldifbd wn c1o cen cpc cexp cc0 cprime cn
            wceq wb cpgp pgpprm syl cfn cabel ablgrp gexcl2 syl2anc pceq0 oveq2
            cgrp syl6bir c1 cv cn0 wrex chash cfv c0 wne grpbn0 hashnncl mpbird
            pccld gexdvds3 pgphash breq2d rspcev mpbid eqcomd prmnn nncnd exp0d
            breqtrd pcprmpw2 eqeq12d cmnd grpmnd gex1 bitrd sylibd wa csn csubg
            wss subgacs acsmred subgss sseldd mrcsncl syl5eqel lsmsubg2 syl3anc
            cmre cacs subg0cl adantr eleqtrd cmul nnne0d cz subgmulgcl syl13anc
            snssd mulgcl mulgass eldifad grpidcl en1eqsn sylan ex syld divcan1d
            mt3d cdiv eqtr4d cin nndivdvds nnzd mrcssidd syl6sseqr snssg cplusg
            zmulcld prmz mulgdi oveq1d 3eqtr3rd oveq12d grplid 3eqtr2d eqeltrrd
            eqid gexid elin sylanbrc elsni oddvds eqbrtrrd dvdscmulr syl112anc
            jca ) AFKUTVAZFNUTVAZAUVQEHPGVBZVCZAEJUVSUOVDAUVQVEZDVFVGVAZUVTAUWA
            FFKVHVBZVIVBZFVJVIVBZVMZUWBAUWAUWCVJVMZUWFAFVKVCZKVLVCZUWGUWAVNAFLV
            OVAZUWHUEFLVPVQZALWEVCZDVRVCZUWIALVSVCZUWLUFLVTVQZUGKLDTUBWAWBZFKWC
            WBUWCVJFVIWDWFAUWFKWGVMZUWBAUWDKUWEWGAKUWDAKFUSWHZVIVBZUTVAZUSWIWJZ
            KUWDVMZAFDWKWLZVHVBZWIVCKFUXDVIVBZUTVAZUXAAFUXCUWKAUXCVLVCZDWMWNZAU
            WLUXHUWODLTWOVQAUWMUXGUXHVNUGDWPVQWQWRAKUXCUXEUTAUWLUWMKUXCUTVAUWOU
            GKLDTUBWSWBAUWJUWMUXCUXEVMUEUGFLDTWTWBXHUWTUXFUSUXDWIUWRUXDVMUWSUXE
            KUTUWRUXDFVIWDXAXBWBAUWHUWIUXAUXBVNUWKUWPKFUSXIWBXCXDAFAFAUWHFVLVCZ
            UWKFXEVQZXFZXGXJALXKVCZUWQUWBVNAUWLUXLUWOLXLVQKLDTUBXMVQXNXOAUWBUVT
            AUWBXPZQXQZUVSEAUXNUVSXSUWBAQUVSAUVSLXRWLZVCZQUVSVCAUWNHUXOVCZPUXOV
            CZUXPUFAHCXQZMWLZUXOSAUXODYHWLVCCDVCZUXTUXOVCAUXODAUWLUXODYIWLVCUWO
            DLTXTVQYAZAJDCAJUXOVCJDXSUIDJLTYBVQZUJYCZUXOCMDRYDWBYEZUKGHPLUDYFYG
            UVSLQUCYJVQYRYKUXMEDUXNAEDVCZUWBAJDEUYCAEJUVSUOUUAYCZYKAQDVCZUWBDUX
            NVMAUWLUYHUWODLQTUCUUBVQQDUUCUUDYLYCUUEUUFUUHZAKFUUIVBZFYMVBZUYJNYM
            VBZUTVAZUVRACOWLZUYKUYLUTAUYNKUYKUHAKFAKUWPXFUXKAFUXJYNUUGZUUJAUYNU
            YLUTVAZUYLCIVBZQVMZAUYQUXNVCUYRAUYQHPUUKZUXNAUYQHVCZUYQPVCUYQUYSVCA
            UXQUYLYOVCZCHVCZUYTUYEAUYJNAUYJAUVQUYJVLVCZUYIAUWIUXIUVQVUCVNUWPUXJ
            KFUULWBXCZUUMZUQUURZAVUBUXSHXSZAUXSUXTHAUXOUXSMDUYBRACDUYDYRUUNSUUO
            ACJVCVUBVUGVNUJCHJUUPVQWQHILUYLCUPYPYGZAUYJFEIVBZNCIVBZLUUQWLZVBZIV
            BZUYQPAVUMUYJVUIIVBZUYJVUJIVBZVUKVBZQUYQVUKVBZUYQAUWNUYJYOVCZVUIDVC
            ZVUJDVCZVUMVUPVMUFVUEAUWLFYOVCZUYFVUSUWOAUWHVVAUWKFUUSVQZUYGDILFETU
            PYSYGAUWLNYOVCZUYAVUTUWOUQUYDDILNCTUPYSYGDVUKILUYJVUIVUJTUPVUKUVGZU
            UTYQAQVUNUYQVUOVUKAUYKEIVBZKEIVBZVUNQAUYKKEIUYOUVAAUWLVURVVAUYFVVEV
            UNVMUWOVUEVVBUYGDILUYJFETUPYTYQAUYFVVFQVMUYGEIKLDQTUBUPUCUVHVQUVBAU
            WLVURVVCUYAUYQVUOVMUWOVUEUQUYDDILUYJNCTUPYTYQUVCAUWLUYQDVCVUQUYQVMU
            WOAHDUYQAUXQHDXSUYEDHLTYBVQVUHYCDVUKLUYQQTVVDUCUVDWBUVEAUXRVURVULPV
            CVUMPVCUKVUEURPILUYJVULUPYPYGUVFUYQHPUVIUVJULYLUYQQUVKVQAUWLUYAVUAU
            YPUYRVNUWOUYDVUFCILUYLODQTUAUPUCUVLYGWQUVMAVVAVVCVURUYJVJWNUYMUVRVN
            VVBUQVUEAUYJVUDYNUYJFNUVNUVOXCUVP $.

          pgpfac1.d $e |- D = ( C ( +g ` G ) ( ( M / P ) .x. A ) ) $.
          $( Lemma for ~ pgpfac1 .  (Contributed by Mario Carneiro,
             27-Apr-2016.) $)
          pgpfac1lem3 $p |- ( ph -> E. t e. ( SubGrp ` G )
            ( ( S i^i t ) = { .0. } /\ ( S .(+) t ) = U ) ) $=
            ( vx vn vy va vb csn cfv co csubg wcel wceq cv wrex cabel cmre cgrp
            cin wa cacs ablgrp syl subgacs acsmre 3syl wss subgss cplusg sseldd
            eldifad mrcsncl syl2anc syl5eqel lsmub1 sstrd cdivides pgpfac1lem3a
            cdiv cz wbr simprd cc0 dvdsval2 syl3anc mpbid snssd subgmulgcl eqid
            wne wb subgcl lsmsubg2 cvv oveq2 adantr ad3antrrr cmul cc oveq1d wn
            zcnd subgsubcl syl5eq eleq1d sylibd c1 zmulcld syl13anc zcn mulcomd
            mulgass eqtr3d oveq2d eqeltrd rexlimdvva sylbid elin subg0cl eqeq1d
            eqtrd cprime cpgp pgpprm prmz prmnn nnne0d mrcssidd syl6sseqr snssg
            cn mpbird csg lsmelvalm cmpt crn cycsubg2 rexeqdv wral rgenw eqeq2d
            ovex ax-mp syl6bb rexbidv bitrd simpr simplrl simplrr nncnd eldifbd
            rexrnmpt divcan1d wi 3expia impancom grppncan mtod cgcd coprm caddc
            oveq1i bezout eqeq1 2rexbidv syl5ibcom simprl simprr mulgdir lsmub2
            ad2antrl oveq2i mulgdi divcan2d ad2antll ablnncan ad2antrr eqeltrrd
            mulgcl oveq1 syl5ibrcom syld mulg1 mt3d ex imdistanda 3imtr4g ssrdv
            sselda sseqtrd sylanbrc eqssd lsmass eldifd pgpfac1lem1 mpdan ineq2
            cdif anbi12d rspcev syl12anc ) ARGVGOVHZIVIZNVJVHZVKZJUYBVRZSVGZVLZ
            JUYBIVIZLVLZJCVMZVRZUYFVLZJUYJIVIZLVLZVSZCUYCVNANVOVKZRUYCVKZUYAUYC
            VKZUYDUHUMAUYCEVPVHVKZGEVKZUYRANVQVKZUYCEVTVHVKUYSAUYPVUAUHNWAWBZEN
            UBWCUYCEWDWEZALEGALUYCVKZLEWFUKELNUBWGWBZAGFPHWRVIZDKVIZNWHVHZVIZLV
            AAVUDFLVKVUGLVKVUILVKUKAFLJRIVIZUQWJZAJLVUGAJVUJLAJUYCVKZUYQJVUJWFA
            JDVGZOVHZUYCUAAUYSDEVKZVUNUYCVKVUCALEDVUEULWIZUYCDOETWKWLWMZUMIJRNU
            FWNWLZUOWOAVULVUFWSVKZDJVKZVUGJVKVUQAHPWPWTZVUSAHMWPWTVVAABDEFHIJKL
            MNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTWQXAAHWSVKZHXBXIZPW
            SVKVVAVUSXJAHUUAVKZVVBAHNUUBWTVVDUGHNUUCWBZHUUDWBZAHAVVDHUUJVKVVEHU
            UEWBZUUFZUSHPXCXDXEZAVUTVUMJWFZAVUMVUNJAUYCVUMOEVUCTADEVUPXFUUGUAUU
            HADLVKVUTVVJXJULDJLUUIWBUUKJKNVUFDURXGXDZWIVUHLNFVUGVUHXHZXKXDWMZWI
            ZUYCGOETWKWLZIRUYANUFXLXDZAUYEUYFAUYEJRVRZUYFAVBUYEVVQAVBVMZJVKZVVR
            UYBVKZVSVVSVVRRVKZVSVVRUYEVKVVRVVQVKAVVSVVTVWAAVVSVSZVVTVVRBVMZVCVM
            ZGKVIZNUULVHZVIZVLZVCWSVNZBRVNZVWAAVVTVWJXJVVSAVVTVVRVWCVDVMZVWFVIZ
            VLZVDUYAVNZBRVNVWJABVDIRUYANVWFVVRVWFXHZUFUMVVOUUMAVWNVWIBRAVWNVWMV
            DVCWSVWEUUNZUUOZVNZVWIAVWMVDUYAVWQAVUAUYTUYAVWQVLVUBVVNVCGKVWPNOEUB
            URVWPXHZTUUPWLUUQVWEXMVKZVCWSUURVWRVWIXJVWTVCWSVWDGKUVAUUSVWMVWHVCV
            DWSVWEVWPXMVWSVWKVWEVLVWLVWGVVRVWKVWEVWCVWFXNUUTUVKUVBUVCUVDUVEXOVW
            BVWHVWABVCRWSVWBVWCRVKZVWDWSVKZVSZVSZVWHVWAVXDVWHVSZVVRVWGRVXDVWHUV
            FZVXEUYQVXAVWERVKVWGRVKAUYQVVSVXCVWHUMXPZVWBVXAVXBVWHUVGZVXEVWEVWDH
            WRVIZHGKVIZKVIZRVXEVXIHXQVIZGKVIZVWEVXKVXEVXLVWDGKVXEVWDHVXEVWDVWBV
            XAVXBVWHUVHZYAZAHXRVKZVVSVXCVWHAHVVGUVIZXPZAVVCVVSVXCVWHVVHXPZUVLXS
            VXEVUAVXIWSVKZVVBUYTVXMVXKVLAVUAVVSVXCVWHVUBXPZVXEHVWDWPWTZVXTVXEVY
            BGVUJVKZAVYCXTVVSVXCVWHAVYCFVUJVKZAFLVUJUQUVJAVYCGVUGVWFVIZVUJVKZVY
            DAVUJUYCVKZVUGVUJVKZVYCVYFUVMAUYPVULUYQVYGUHVUQUMIJRNUFXLXDZAJVUJVU
            GVURVVKWIVYGVYCVYHVYFVYGVYCVYHVYFVUJNVWFGVUGVWOYBUVNUVOWLAVYEFVUJAV
            YEVUIVUGVWFVIZFGVUIVUGVWFVAUWAAVUAFEVKZVUGEVKZVYJFVLVUBALEFVUEVUKWI
            ZAJEVUGAVULJEWFVUQEJNUBWGWBVVKWIZEVUHNVWFFVUGUBVVLVWOUVPXDYCYDYEUVQ
            ZXPVXEVYBXTZHVWDUVRVIZYFVLZVYCVXEVVDVXBVYPVYRXJAVVDVVSVXCVWHVVEXPVX
            NHVWDUVSWLVXEVYRYFGKVIZVUJVKZVYCVXEVYRYFHVEVMZXQVIZVWDVFVMZXQVIZUVT
            VIZVLZVFWSVNVEWSVNZVYTVXEVYQWUEVLZVFWSVNVEWSVNZVYRWUGVXEVVBVXBWUIAV
            VBVVSVXCVWHVVFXPZVXNVEVFHVWDUWBWLVYRWUHWUFVEVFWSWSVYQYFWUEUWCUWDUWE
            VXEWUFVYTVEVFWSWSVXEWUAWSVKZWUCWSVKZVSZVSZVYTWUFWUEGKVIZVUJVKWUNWUO
            WUBGKVIZWUDGKVIZVUHVIZVUJWUNVUAWUBWSVKWUDWSVKUYTWUOWURVLVXEVUAWUMVY
            AXOZWUNHWUAVXEVVBWUMWUJXOZVXEWUKWULUWFZYGWUNVWDWUCVXEVXBWUMVXNXOZVX
            EWUKWULUWGZYGVXEUYTWUMAUYTVVSVXCVWHVVNXPZXOZEVUHKNWUBWUDGUBURVVLUWH
            YHWUNVYGWUPVUJVKWUQVUJVKWURVUJVKVXEVYGWUMAVYGVVSVXCVWHVYIXPZXOZWUNW
            UPWUAVXJKVIZVUJWUNWUPWUAHXQVIZGKVIZWVHWUNWUBWVIGKWUNHWUAVXEVXPWUMVX
            RXOWUKWUAXRVKVXEWULWUAYIUWJYJXSWUNVUAWUKVVBUYTWVJWVHVLWUSWVAWUTWVEE
            KNWUAHGUBURYKYHYTWUNVYGWUKVXJVUJVKZWVHVUJVKWVGWVAVXEWVKWUMAWVKVVSVX
            CVWHARVUJVXJAVULUYQRVUJWFZVUQUMIJRNUFUWIWLZAVXJHFKVIZPDKVIZVUHVIZRA
            VXJWVNHVUGKVIZVUHVIZWVPAVXJHVUIKVIZWVRGVUIHKVAUWKAUYPVVBVYKVYLWVSWV
            RVLUHVVFVYMVYNEVUHKNHFVUGUBURVVLUWLYHYCAWVQWVOWVNVUHAHVUFXQVIZDKVIZ
            WVQWVOAVUAVVBVUSVUOWWAWVQVLVUBVVFVVIVUPEKNHVUFDUBURYKYHAWVTPDKAPHAP
            USYAVXQVVHUWMXSYLYMYTUTYNZWIXPXOVUJKNWUAVXJURXGXDYNWUNWUQWUCVWEKVIZ
            VUJWUNWUQWUCVWDXQVIZGKVIZWWCWUNWUDWWDGKWUNVWDWUCVXEVWDXRVKWUMVXOXOW
            ULWUCXRVKVXEWUKWUCYIUWNYJXSWUNVUAWULVXBUYTWWEWWCVLWUSWVCWVBWVEEKNWU
            CVWDGUBURYKYHYTWUNVYGWULVWEVUJVKZWWCVUJVKWVGWVCVXEWWFWUMVXEVWCVVRVW
            FVIZVWEVUJVXEWWGVWCVWGVWFVIVWEVXEVVRVWGVWCVWFVXFYMVXEENVWFVWCVWEUBV
            WOAUYPVVSVXCVWHUHXPVXEREVWCVXEUYQREWFVXGERNUBWGWBVXHWIVXEVUAVXBUYTV
            WEEVKVYAVXNWVDEKNVWDGUBURUWRXDUWOYTVXEVYGVWCVUJVKVVRVUJVKZWWGVUJVKW
            VFVXERVUJVWCAWVLVVSVXCVWHWVMXPVXHWIVWBWWHVXCVWHAJVUJVVRVURUXHUWPVUJ
            NVWFVWCVVRVWOYBXDUWQXOVUJKNWUCVWEURXGXDYNVUHVUJNWUPWUQVVLXKXDYNWUFV
            YSWUOVUJYFWUEGKUWSYDUWTYOUXAVXEVYSGVUJVXEUYTVYSGVLWVDEKNGUBURUXBWBY
            DYEYPUXCVXEVVBVVCVXBVYBVXTXJWUJVXSVXNHVWDXCXDXEZWUJWVDEKNVXIHGUBURY
            KYHYLVXEUYQVXTVXJRVKZVXKRVKVXGWWIAWWJVVSVXCVWHWWBXPRKNVXIVXJURXGXDY
            NRNVWFVWCVWEVWOYBXDYNUXDYOYPUXEVVRJUYBYQVVRJRYQUXFUXGUNUXIASUYEASJV
            KZSUYBVKZSUYEVKAVULWWKVUQJNSUEYRWBAUYDWWLVVPUYBNSUEYRWBSJUYBYQUXJXF
            UXKAVUJUYAIVIZUYHLAVULUYQUYRWWMUYHVLVUQUMVVOIJRUYANUFUXLXDAGLVUJUXQ
            VKWWMLVLAGLVUJVVMVYOUXMABDEGHIJLMNOQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
            UOUPUXNUXOYLUYOUYGUYIVSCUYBUYCUYJUYBVLZUYLUYGUYNUYIWWNUYKUYEUYFUYJU
            YBJUXPYSWWNUYMUYHLUYJUYBJIXNYSUXRUXSUXT $.
        $}

        $( Lemma for ~ pgpfac1 .  (Contributed by Mario Carneiro,
           27-Apr-2016.) $)
        pgpfac1lem4 $p |- ( ph -> E. t e. ( SubGrp ` G )
          ( ( S i^i t ) = { .0. } /\ ( S .(+) t ) = U ) ) $=
          ( vk vs co cv cplusg cfv wcel cin csn wceq csubg wrex csg pgpfac1lem2
          wa cz cmre cgrp cacs ablgrp syl subgacs acsmre 3syl wss subgss sseldd
          cabel mrcsncl syl2anc syl5eqel lsmcom syl3anc eleqtrd lsmelvalm mpbid
          eqid cmpt crn cycsubg2 syl5eq rexeqdv wral wb ovex rgenw oveq2 eqeq2d
          cvv rexrnmpt ax-mp syl6bb rexbidv rexcom sylib ad2antrr adantr sselda
          simplr mulgcl cpgp wbr cprime pgpprm eldifad grpsubadd syl13anc eqcom
          prmz 3bitr4g rexbidva risset syl6bbr cdiv cfn wpss cdif simprl simprr
          wn wi pgpfac1lem3 rexlimddv ) AGFJUSZUQUTZDJUSZMVAVBZUSZPVCZICUTZVDQV
          EZVFIUUFHUSKVFVKCMVGVBZVHUQVLAYTBUTZUUBMVIVBZUSZVFZBPVHZUQVLVHZUUEUQV
          LVHAUULUQVLVHZBPVHZUUNAYTUUIURUTZUUJUSZVFZURIVHZBPVHZUUPAYTPIHUSZVCUV
          AAYTIPHUSZUVBABDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVJAMW
          DVCZIUUHVCPUUHVCZUVCUVBVFUFAIDVENVBZUUHSAUUHEVMVBVCZDEVCZUVFUUHVCAMVN
          VCZUUHEVOVBVCUVGAUVDUVIUFMVPVQZEMTVRUUHEVSVTAKEDAKUUHVCZKEWAUIEKMTWBV
          QZUJWCZUUHDNERWEWFWGZUKHIPMUDWHWIWJABURHPIMUUJYTUUJWMZUDUKUVNWKWLAUUT
          UUOBPAUUTUUSURUQVLUUBWNZWOZVHZUUOAUUSURIUVQAIUVFUVQSAUVIUVHUVFUVQVFUV
          JUVMUQDJUVPMNETUPUVPWMZRWPWFWQWRUUBXEVCZUQVLWSUVRUUOWTUVTUQVLUUADJXAX
          BUUSUULUQURVLUUBUVPXEUVSUUQUUBVFUURUUKYTUUQUUBUUIUUJXCXDXFXGXHXIWLUUL
          BUQPVLXJXKAUUMUUEUQVLAUUAVLVCZVKZUUMUUIUUDVFZBPVHUUEUWBUULUWCBPUWBUUI
          PVCZVKZUUKYTVFZUUDUUIVFZUULUWCUWEUVIUUIEVCUUBEVCZYTEVCZUWFUWGWTAUVIUW
          AUWDUVJXLZUWBPEUUIAPEWAZUWAAUVEUWKUKEPMTWBVQXMXNUWEUVIUWAUVHUWHUWJAUW
          AUWDXOAUVHUWAUWDUVMXLEJMUUADTUPXPWIAUWIUWAUWDAUVIGVLVCZFEVCUWIUVJAGMX
          QXRZGXSVCUWLUEGMXTGYEVTAKEFUVLAFKUVCUOYAWCEJMGFTUPXPWIXLEUUCMUUJUUIUU
          BYTTUUCWMUVOYBYCYTUUKYDUUIUUDYDYFYGBUUDPYHYIYGWLAUWAUUEVKZVKBCDEFFUUA
          GYJUSDJUSUUCUSZGHIJKLMNUUAOPQRSTUAUBUCUDAUWMUWNUEXMAUVDUWNUFXMAEYKVCU
          WNUGXMADOVBLVFUWNUHXMAUVKUWNUIXMADKVCUWNUJXMAUVEUWNUKXMAIPVDUUGVFUWNU
          LXMAUVCKWAUWNUMXMAUUIKYLDUUIVCVKUVCUUIYLYPYQBUUHWSUWNUNXMAFKUVCYMVCUW
          NUOXMUPAUWAUUEYNAUWAUUEYOUWOWMYRYS $.
      $}

      pgpfac1.3 $e |- ( ph -> A. s e. ( SubGrp ` G )
        ( ( s C. U /\ A e. s ) -> E. t e. ( SubGrp ` G )
          ( ( S i^i t ) = { .0. } /\ ( S .(+) t ) = s ) ) ) $.
      $( Lemma for ~ pgpfac1 (Contributed by Mario Carneiro, 27-Apr-2016.) $)
      pgpfac1lem5 $p |- ( ph -> E. t e. ( SubGrp ` G )
        ( ( S i^i t ) = { .0. } /\ ( S .(+) t ) = U ) ) $=
        ( vw vv vu vb vy wpss cv cin csn wceq co wa csubg cfv wrex wcel wn wral
        wi crab ccrd cdm c0 wne wss crpss wor w3a cuni wal cfn cpw sylib adantr
        pwfi subgss 3ad2ant2 vex elpw sylibr rabssdv ssfi syl2anc syl cmre cgrp
        finnum cacs cabel ablgrp subgacs acsmre 3syl sseldd mrcsncl simpr snssd
        syl5eqel sstrd mrcssidd syl6sseqr wb snssg mpbird psseq1 anbi12d rspcev
        eleq2 syl12anc simpr1 simpr2 simpr3 fin1a2lem10 syl3anc alrimiv zornn0g
        rabn0 weq ralrab rexbii r19.29 elrab ineq2 eqeq1d oveq2 cbvrexv adantrr
        ex ad3antrrr notbid imp3a rexlimdva wex simprrl ad2antrr psseq1d pssdif
        cdif n0 cmg simplr simprl1 pssssd simprl3 imbi2d ralbidv psseq2 imbi12d
        cpgp wbr cbvralv syl6bb simprr eqid pgpfac1lem4 expr exlimdv mpd syl5bi
        3exp2 sylan2b syl5 mpand syld subg0cl sseqin2 lsmss2 biimpar wo mrcsscl
        0subg syl5eqss sspss mpjaod ) AGHUNZGBUOZUPZMUQZURZGUWDFUSZHURZUTZBJVAV
        BZVCZGHURZAUWCUIUOZHUNZCUWNVDZUTZNUOZUWNUNZVEZVGZUIUWKVFZNUJUOZHUNZCUXC
        VDZUTZUJUWKVHZVCZUWLAUWCUXHAUWCUTZUWTUIUXGVFZNUXGVCZUXHUXIUXGVIVJVDZUXG
        VKVLZUKUOZUXGVMZUXNVKVLZUXNVNVOZVPZUXNVQZUXGVDZVGZUKVRUXKUXIUXGVSVDZUXL
        UXIDVTZVSVDZUXGUYCVMUYBAUYDUWCADVSVDZUYDUDDWCWAWBUXIUXFUJUWKUYCUXIUXCUW
        KVDZUXFVPUXCDVMZUXCUYCVDUYFUXIUYGUXFDUXCJQWDWEUXCDUJWFWGWHWIUYCUXGWJWKZ
        UXGWOWLUXIUXFUJUWKVCZUXMUXIGUWKVDZUWCCGVDZUYIAUYJUWCAGCUQZKVBZUWKPAUWKD
        WMVBVDZCDVDZUYMUWKVDAJWNVDZUWKDWPVBVDUYNAJWQVDZUYPUCJWRWLZDJQWSUWKDWTXA
        ZAHDCAHUWKVDZHDVMUFDHJQWDWLZUGXBZUWKCKDOXCWKXFZWBAUWCXDAUYKUWCAUYKUYLGV
        MZAUYLUYMGAUWKUYLKDUYSOAUYLHDACHUGXEZVUAXGXHPXIAUYOUYKVUDXJVUBCGDXKWLXL
        WBUXFUWCUYKUTUJGUWKUXCGURUXDUWCUXEUYKUXCGHXMUXCGCXPXNXOXQUXFUJUWKYEWHUX
        IUYAUKUXIUXRUXTUXIUXRUTZUXNUXGUXSUXIUXOUXPUXQXRZVUFUXPUXNVSVDZUXQUXSUXN
        VDUXIUXOUXPUXQXSVUFUYBUXOVUHUXIUYBUXRUYHWBVUGUXGUXNWJWKUXIUXOUXPUXQXTUX
        NYAYBXBYPYCNUIUKUXGYDYBUXJUXBNUXGUXFUWQUWTUIUJUWKUJUIYFUXDUWOUXEUWPUXCU
        WNHXMUXCUWNCXPXNYGYHWAYPAUWGUWHUWRURZUTZBUWKVCZNUXGVFZUXHUWLAUWRHUNZCUW
        RVDZUTZVUKVGNUWKVFVULUHUXFVUOVUKNUJUWKUJNYFUXDVUMUXEVUNUXCUWRHXMUXCUWRC
        XPXNZYGWHVULUXHUTVUKUXBUTZNUXGVCAUWLVUKUXBNUXGYIAVUQUWLNUXGUWRUXGVDAUWR
        UWKVDZVUOUTZVUQUWLVGUXFVUOUJUWRUWKVUPYJAVUSUTZVUKUXBUWLVUKGUXCUPZUWFURZ
        GUXCFUSZUWRURZUTZUJUWKVCVUTUXBUWLVGZVUJVVEBUJUWKBUJYFZUWGVVBVUIVVDVVGUW
        EVVAUWFUWDUXCGYKYLVVGUWHVVCUWRUWDUXCGFYMYLXNYNVUTVVEVVFUJUWKVUTUYFUTZVV
        BVVDVVFVVHVVBVVDUXBUWLVVHVVBVVDUXBVPZUTZULUOZHVVCUUFZVDZULUUAZUWLVVJVVC
        HUNZVVNVVJVVOVUMVUTVUMUYFVVIAVURVUMVUNUUBUUCVVJVVCUWRHVVHVVBVVDUXBXSZUU
        DXLZVVOVVLVKVLVVNVVCHUUEULVVLUUGWAWLVVJVVMUWLULVVHVVIVVMUWLVVHVVIVVMUTZ
        UTZUMBCDVVKEFGJUUHVBZHIJKLUXCMOPQRSTUAAEJUUQUURVUSUYFVVRUBYQAUYQVUSUYFV
        VRUCYQAUYEVUSUYFVVRUDYQACLVBIURVUSUYFVVRUEYQAUYTVUSUYFVVRUFYQACHVDVUSUY
        FVVRUGYQVUTUYFVVRUUIVVBVVDUXBVVMVVHUUJVVSVVCHVVHVVIVVOVVMVVQYOUUKVVSUMU
        OZHUNZCVWAVDZUTZVVCVWAUNZVEZVGZUMUWKVFZUXBVVBVVDUXBVVMVVHUULVVSVVDVWHUX
        BXJVVHVVIVVDVVMVVPYOVVDVWHVWDUWRVWAUNZVEZVGZUMUWKVFUXBVVDVWGVWKUMUWKVVD
        VWFVWJVWDVVDVWEVWIVVCUWRVWAXMYRUUMUUNVWKUXAUMUIUWKUMUIYFZVWDUWQVWJUWTVW
        LVWBUWOVWCUWPVWAUWNHXMVWAUWNCXPXNVWLVWIUWSVWAUWNUWRUUOYRUUPUUSUUTWLXLVV
        HVVIVVMUVAVVTUVBUVCUVDUVEUVFUVHYSYTUVGYSUVIYTUVJUVKUVLAUWMUWLAUWMUTZUWF
        UWKVDZGUWFUPZUWFURZGUWFFUSZHURZUWLAVWNUWMAUYPVWNUYRJMTUVSWLZWBVWMUWFGVM
        ZVWPAVWTUWMAMGAUYJMGVDVUCGJMTUVMWLXEZWBUWFGUVNWAAVWRUWMAVWQGHAUYJVWNVWT
        VWQGURVUCVWSVXAFGUWFJUAUVOYBYLUVPUWJVWPVWRUTBUWFUWKUWDUWFURZUWGVWPUWIVW
        RVXBUWEVWOUWFUWDUWFGYKYLVXBUWHVWQHUWDUWFGFYMYLXNXOXQYPAGHVMUWCUWMUVQAGU
        YMHPAUYNUYLHVMUYTUYMHVMUYSVUEUFUWKUYLKHDOUVRYBUVTGHUWAWAUWB $.
    $}

    pgpfac1.ab $e |- ( ph -> A e. B ) $.
    $( Factorization of a finite abelian p-group.  There is a direct product
       decomposition of any abelian group of prime-power order where one of the
       factors is cyclic and generated by an element of maximal order.
       (Contributed by Mario Carneiro, 27-Apr-2016.) $)
    pgpfac1 $p |- ( ph -> E. t e. ( SubGrp ` G )
      ( ( S i^i t ) = { .0. } /\ ( S .(+) t ) = B ) ) $=
      ( vs vu vx vy csubg cfv wcel cv cin csn wceq co wa wrex cabel cgrp ablgrp
      subgid 3syl cfn wi eleq1 eleq2 anbi12d anbi2d rexbidv imbi12d imbi2d wpss
      eqeq2 wal wral bi2.04 impexp imbi2i 3bitr4i df-ral r19.21v 3bitr2i psseq1
      albii ineq2 eqeq1d cbvrexv syl5bb cbvralv cpgp wbr adantr simprrl simprrr
      oveq2 simprl sylib pgpfac1lem5 exp32 syl5bir sylbi findcard3 mpcom mp2and
      a2i a1i ) ADIUIUJZUKZCDUKZGBULZUMZLUNZUOZGXKFUPZDUOZUQZBXHURZAIUSUKZIUTUK
      XIUAIVADIOVBVCUDDVDUKZAXIXJUQZXRVEZUBAUEULZXHUKZCYCUKZUQZXNXOYCUOZUQZBXHU
      RZVEZVEZAUFULZXHUKZCYLUKZUQZXNXOYLUOZUQZBXHURZVEZVEZAYBVEUEUFDYCYLUOZYJYS
      AUUAYFYOYIYRUUAYDYMYEYNYCYLXHVFYCYLCVGVHUUAYHYQBXHUUAYGYPXNYCYLXOVNVIVJVK
      VLYCDUOZYJYBAUUBYFYAYIXRUUBYDXIYEXJYCDXHVFYCDCVGVHUUBYHXQBXHUUBYGXPXNYCDX
      OVNVIVJVKVLYCYLVMZYKVEZUEVOZYTVEYLVDUKUUEAUUCYEUQZYIVEZUEXHVPZVEZYTUUEYDA
      UUGVEZVEZUEVOUUJUEXHVPUUIUUDUUKUEAUUCYJVEZVEAYDUUGVEZVEUUDUUKUULUUMAUUCYD
      YEYIVEZVEZVEYDUUCUUNVEZVEUULUUMUUCYDUUNVQYJUUOUUCYDYEYIVRVSUUGUUPYDUUCYEY
      IVRVSVTVSUUCAYJVQYDAUUGVQVTWEUUJUEXHWAAUUGUEXHWBWCAUUHYSUUHUGULZYLVMZCUUQ
      UKZUQZGUHULZUMZXMUOZGUVAFUPZUUQUOZUQZUHXHURZVEZUGXHVPZAYSUVHUUGUGUEXHUUQY
      CUOZUUTUUFUVGYIUVJUURUUCUUSYEUUQYCYLWDUUQYCCVGVHUVGXNXOUUQUOZUQZBXHURUVJY
      IUVFUVLUHBXHUVAXKUOZUVCXNUVEUVKUVMUVBXLXMUVAXKGWFWGUVMUVDXOUUQUVAXKGFWPWG
      VHWHUVJUVLYHBXHUVJUVKYGXNUUQYCXOVNVIVJWIVKWJZAUVIYOYRAUVIYOUQZUQZBCDEFGYL
      HIJKLUEMNOPQRSAEIWKWLUVOTWMAXSUVOUAWMAXTUVOUBWMACKUJHUOUVOUCWMAUVIYMYNWNA
      UVIYMYNWOUVPUVIUUHAUVIYOWQUVNWRWSWTXAXFXBXGXCXDXE $.
  $}

  ${
    $d a s t u w x C $.  $d a r s t u w x G $.  $d r s K $.  $d a t u w x ph $.
    $d s t x B $.  $d w P $.  $d a r s t w x U $.  $d a s t W $.  $d r s X $.
    $d s T $.
    pgpfac.b $e |- B = ( Base ` G ) $.
    pgpfac.c $e |- C = { r e. ( SubGrp ` G ) |
      ( G |`s r ) e. ( CycGrp i^i ran pGrp ) } $.
    pgpfac.g $e |- ( ph -> G e. Abel ) $.
    pgpfac.p $e |- ( ph -> P pGrp G ) $.
    pgpfac.f $e |- ( ph -> B e. Fin ) $.
    ${
      pgpfac.u $e |- ( ph -> U e. ( SubGrp ` G ) ) $.
      pgpfac.a $e |- ( ph -> A. t e. ( SubGrp ` G ) ( t C. U ->
        E. s e. Word C ( G dom DProd s /\ ( G DProd s ) = t ) ) ) $.
      ${
        pgpfac.h $e |- H = ( G |`s U ) $.
        pgpfac.k $e |- K = ( mrCls ` ( SubGrp ` H ) ) $.
        pgpfac.o $e |- O = ( od ` H ) $.
        pgpfac.e $e |- E = ( gEx ` H ) $.
        pgpfac.0 $e |- .0. = ( 0g ` H ) $.
        pgpfac.l $e |- .(+) = ( LSSum ` H ) $.
        pgpfac.1 $e |- ( ph -> E =/= 1 ) $.
        pgpfac.x $e |- ( ph -> X e. U ) $.
        pgpfac.oe $e |- ( ph -> ( O ` X ) = E ) $.
        pgpfac.w $e |- ( ph -> W e. ( SubGrp ` H ) ) $.
        pgpfac.i $e |- ( ph -> ( ( K ` { X } ) i^i W ) = { .0. } ) $.
        pgpfac.s $e |- ( ph -> ( ( K ` { X } ) .(+) W ) = U ) $.
        ${
          pgpfac.2 $e |- ( ph -> S e. Word C ) $.
          pgpfac.4 $e |- ( ph -> G dom DProd S ) $.
          pgpfac.5 $e |- ( ph -> ( G DProd S ) = W ) $.
          pgpfac.t $e |- T = ( S concat <" ( K ` { X } ) "> ) $.
          $( Lemma for ~ pgpfac .  (Contributed by Mario Carneiro,
             27-Apr-2016.)  (Revised by Mario Carneiro, 3-May-2016.) $)
          pgpfaclem1 $p |- ( ph -> E. s e. Word C
            ( G dom DProd s /\ ( G DProd s ) = U ) ) $=
            ( cword wcel cdprd cdm wbr co wceq cv wrex csn cfv csubg cress ccyg
            cpgp crn cin wss cbs cmre cgrp cacs subggrp syl eqid subgacs acsmre
            wa 3syl subgbas eleqtrd mrcsncl syl2anc subsubg mpbid simpld oveq1i
            wb simprd ressabs syl5eq cycsubgcyg2 eqeltrrd cprime pgpprm subgpgp
            brelrng syl3anc elin sylanbrc oveq2 eleq1d elrab2 cc0 chash cfzo wf
            c0g wrdf sylancl caddc cn0 cun syl6eq oveq2d eqtrd cres cop wfn ffn
            c1 breqtrrd cvv fvex cn 3eqtrd sneqd dprdsubg cats1cld ccntz ssrab2
            eqsstri fss c0 fzodisj cz lencl nn0zd fzosn ineq2d syl5reqr cconcat
            cs1 fveq2i s1cld ccatlen s1len oveq2i cuz nn0uz syl6eleq fzosplitsn
            crab cats1un reseq1d fzonel fsnunres dprdsn sylancr ssun2 syl5eleqr
            snss mpbir fnressn fveq1i nn0cnd addid2d eqcomd fveq2d 1nn syl5eqel
            wn a1i lbfzo0 sylibr ccatval3 s1fv mp1i opeq2d ablcntzd incom subg0
            ineq12d syl6eqr 3eqtr4d dmdprdsplit2 dprdsplit oveq12d cabel lsmcom
            clsm subgss sseqtr4d subglsm breq2 eqeq1d anbi12d rspcev syl12anc )
            AHDVCZVDZKHVEVFZVGZKHVEVHZIVIZKRVJZUXNVGZKUXRVEVHZIVIZWJZRUXLVKADGH
            PVLZMVMZVBUSAUYDKVNVMZVDZKUYDVOVHZVPVQVRZVSZVDZUYDDVDZAUYFUYDIVTZAU
            YDLVNVMZVDZUYFUYLWJZAUYMLWAVMZWBVMVDZPUYPVDZUYNALWCVDZUYMUYPWDVMVDU
            YQAIUYEVDZUYSUEIKLUGWEWFZUYPLUYPWGZWHUYMUYPWIWKAPIUYPUNAUYTIUYPVIUE
            IKLUGWLWFZWMZUYMPMUYPUHWNWOAUYTUYNUYOWTUEUYDIKLUGWPWFWQZWRZAUYGVPVD
            ZUYGUYHVDZUYJALUYDVOVHZUYGVPAVUIKIVOVHZUYDVOVHZUYGLVUJUYDVOUGWSAUYT
            UYLVUKUYGVIUEAUYFUYLVUEXAZIUYDKUYEXBWOXCAUYSUYRVUIVPVDVUAVUDPUYPLMV
            UBUHXDWOXEZAEXFVDZVUGEUYGVQVGZVUHAEKVQVGZVUNUCEKXGWFVUMAVUPUYFVUOUC
            VUFEUYDKXHWOEUYGVQXFVPXIXJUYGVPUYHXKXLKSVJZVOVHZUYIVDZUYJSUYDUYEDVU
            QUYDVIVURUYGUYIVUQUYDKVOXMXNUAXOXLZUUAZAXPGXQVMZXRVHZVVBVLZHKXPHXQV
            MZXRVHZKXTVMZKUUBVMZAVVFDHXSZDUYEVTVVFUYEHXSAUXMVVIVVADHYAZWFDVUSSU
            YEUVEUYEUAVUSSUYEUUCUUDVVFDUYEHUUEYBZAUUFVVCVVBVVBYMYCVHZXRVHZVSVVC
            VVDVSXPVVBVVLUUGAVVMVVDVVCAVVBUUHVDVVMVVDVIAVVBAGUXLVDZVVBYDVDUSDGU
            UIWFZUUJVVBUUKWFUULUUMZAVVFXPVVLXRVHZVVCVVDYEZAVVEVVLXPXRAVVEVVBUYD
            UUOZXQVMZYCVHZVVLAVVEGVVSUUNVHZXQVMZVWAHVWBXQVBUUPAVVNVVSUXLVDZVWCV
            WAVIUSAUYDDVUTUUQZDGVVSUURWOXCVVTYMVVBYCUYDUUSZUUTYFYGAVVBXPUVAVMZV
            DVVQVVRVIAVVBYDVWGVVOUVBUVCXPVVBUVDWFYHZVVHWGZVVGWGZAKGHVVCYIZUXNUT
            AVWKGVVBUYDYJZVLZYEZVVCYIZGAHVWNVVCAHVWBVWNVBAVVNUYKVWBVWNVIUSVUTGU
            YDDUVFWOXCUVGAGVVCYKZVVBVVCVDUWDVWOGVIAVVNVVCDGXSVWPUSDGYAVVCDGYLWK
            XPVVBUVHVVCGVVBUYDUVIYBYHZYNZAKVWMHVVDYIZUXNAKVWMUXNVGZKVWMVEVHZUYD
            VIZAVVBYOVDUYFVWTVXBWJGXQYPZVUFVVBUYDKYOUVJUVKZWRAVWSVVBVVBHVMZYJZV
            LZVWMAHVVFYKZVVBVVFVDVWSVXGVIAUXMVVIVXHVVAVVJVVFDHYLWKAVVBVVRVVFVVB
            VVRVDVVDVVRVTVVDVVCUVLVVBVVRVXCUVNUVOVWHUVMVVFVVBHUVPWOAVXFVWLAVXEU
            YDVVBAVXEXPVVBYCVHZVWBVMZXPVVSVMZUYDAVXEVVBVWBVMVXJVVBHVWBVBUVQAVVB
            VXIVWBAVXIVVBAVVBAVVBVVOUVRUVSUVTUWAXCAVVNVWDXPXPVVTXRVHVDZVXJVXKVI
            USVWEAVVTYQVDVXLAVVTYMYQVWFYMYQVDAUWBUWEUWCVVTUWFUWGDGVVSXPUWHXJUYD
            YOVDVXKUYDVIAUYCMYPUYDYOUWIUWJYRUWKYSYHZYNZAKVWKVEVHZKVWSVEVHZKVVHV
            WIUBAKVWKUXNVGVXOUYEVDVWRVWKKYTWFZAKVWSUXNVGVXPUYEVDVXNVWSKYTWFUWLA
            UYDOVSZQVLVXOVXPVSZVVGVLUQAVXSOUYDVSVXRAVXOOVXPUYDAVXOKGVEVHOAVWKGK
            VEVWQYGVAYHZAVXPVXAUYDAVWSVWMKVEVXMYGAVWTVXBVXDXAYHZUWOOUYDUWMYFAVV
            GQAVVGLXTVMZQAUYTVVGVYBVIUEIKLVVGUGVWJUWNWFUKUWPYSUWQUWRZAUXPUYDOKU
            XCVMZVHZUYDOFVHZIAUXPVXOVXPVYDVHOUYDVYDVHZVYEAVVCVVDVYDHKVVFVVKVVPV
            WHVYDWGZVYCUWSAVXOOVXPUYDVYDVXTVYAUWTAKUXAVDOUYEVDUYFVYGVYEVIUBAVXO
            OUYEVXTVXQXEVUFVYDOUYDKVYHUXBXJYRAUYTUYLOIVTVYEVYFVIUEVULAOUYPIAOUY
            MVDOUYPVTUPUYPOLVUBUXDWFVUCUXEFVYDIUYDOKLUGVYHULUXFXJURYRUYBUXOUXQW
            JRHUXLUXRHVIZUXSUXOUYAUXQUXRHKUXNUXGVYIUXTUXPIUXRHKVEXMUXHUXIUXJUXK
            $.
        $}

        $( Lemma for ~ pgpfac .  (Contributed by Mario Carneiro, 27-Apr-2016.)
           (Revised by Mario Carneiro, 3-May-2016.) $)
        pgpfaclem2 $p |- ( ph -> E. s e. Word C
          ( G dom DProd s /\ ( G DProd s ) = U ) ) $=
          ( va cv cdprd cdm wbr co wceq cword wrex csubg cfv wcel wpss wral wss
          wa wi wb subsubg syl mpbid simpld wne simprd chash cfn subgss syl2anc
          cn0 ssfi hashcl nn0red c1 cmul csn clt cvv fvex eqeltri hashsng ax-mp
          c0g csdm cbs cgrp cacs cmre subgrcl eqid subgacs 4syl mrcssvd subgbas
          acsmre sseqtr4d eleqtrd mrcsncl subg0cl snssd mrcssidd mpbird eqnetrd
          snssg od1 3syl elsni fveq2d eqeq1d syl5ibrcom necon3ad ssnelpssd php3
          wn mpd snfi hashsdom sylancr syl5eqbrr cr cc0 1re a1i cabel adantr cn
          c0 ne0i hashnncl nngt0d ltmul1 syl112anc recnd mulid2d ccntz ablcntzd
          subgabl lsmhash eqtr3d 3brtr3d ltned fveq2 df-pss psseq1 eqeq2 anbi2d
          necon3i rexbidv imbi12d rspcv syl3c breq2 oveq2 anbi12d cbvrexv sylib
          sylanbrc cs1 cconcat cpgp simprl simprrl simprrr pgpfaclem1 rexlimddv
          cin ) AIUQURZUSUTZVAZIUWBUSVBZMVCZVLZIPURZUWCVAZIUWHUSVBZGVCVLPDVDZVE
          UQUWKAUWIUWJMVCZVLZPUWKVEZUWGUQUWKVEAMIVFVGZVHZBURZGVIZUWIUWJUWQVCZVL
          ZPUWKVEZVMZBUWOVJZMGVIZUWNAUWPMGVKZAMJVFVGZVHZUWPUXEVLZUNAGUWOVHZUXGU
          XHVNUCMGIJUEVOVPVQZVRUDAUXEMGVSZUXDAUWPUXEUXJVTZAMWAVGZGWAVGZVSUXKAUX
          MUXNAUXMAMWBVHZUXMWEVHAGWBVHZUXEUXOACWBVHZGCVKZUXPUBAUXIUXRUCCGIRWCVP
          CGWFWDZUXLGMWFWDZMWGVPWHZAWIUXMWJVBZNWKZKVGZWAVGZUXMWJVBZUXMUXNWLAWIU
          YEWLVAZUYBUYFWLVAZAWIOWKZWAVGZUYEWLOWMVHUYJWIVCOJWRVGWMUIJWRWNWOOWMWP
          WQAUYJUYEWLVAZUYIUYDWSVAZAUYDWBVHZUYIUYDVIUYLAUXPUYDGVKUYMUXSAUYDJWTV
          GZGAUXFUYCKUYNAUXGJXAVHZUXFUYNXBVGVHUXFUYNXCVGVHZUNMJXDZUYNJUYNXEXFUX
          FUYNXJXGZUFXHAUXIGUYNVCUCGIJUEXIVPZXKGUYDWFWDZAUYIUYDNAOUYDAUYDUXFVHZ
          OUYDVHAUYPNUYNVHVUAUYRANGUYNULUYSXLZUXFNKUYNUFXMWDZUYDJOUIXNVPXOANUYD
          VHZUYCUYDVKZAUXFUYCKUYNUYRUFANUYNVUBXOXPANGVHZVUDVUEVNULNUYDGXSVPXQAN
          LVGZWIVSNUYIVHZYIAVUGHWIUMUKXRAVUHVUGWIAVUGWIVCVUHOLVGZWIVCZAUXGUYOVU
          JUNUYQJLOUGUIXTYAVUHVUGVUIWIVUHNOLNOYBYCYDYEYFYJYGUYDUYIYHWDAUYIWBVHU
          YMUYKUYLVNOYKUYTUYIUYDYLYMXQYNAWIYOVHZUYEYOVHUXMYOVHYPUXMWLVAUYGUYHVN
          VUKAYQYRAUYEAUYMUYEWEVHUYTUYDWGVPWHUYAAUXMAUXMUUAVHZMUUBVSZAUXGOMVHVU
          MUNMJOUIXNMOUUCYAAUXOVULVUMVNUXTMUUDVPXQUUEWIUYEUXMUUFUUGVQAUXMAUXMUY
          AUUHUUIAUYDMFVBZWAVGUYFUXNAFUYDMJOJUUJVGZUJUIVUOXEZVUCUNUOAUYDMJVUOVU
          PAIYSVHZUXIJYSVHTUCGIJUEUULWDVUCUNUUKUYTUXTUUMAVUNGWAUPYCUUNUUOUUPMGU
          XMUXNMGWAUUQUVBVPMGUURUVLUXBUXDUWNVMBMUWOUWQMVCZUWRUXDUXAUWNUWQMGUUSV
          URUWTUWMPUWKVURUWSUWLUWIUWQMUWJUUTUVAUVCUVDUVEUVFUWMUWGPUQUWKUWHUWBVC
          ZUWIUWDUWLUWFUWHUWBIUWCUVGVUSUWJUWEMUWHUWBIUSUVHYDUVIUVJUVKAUWBUWKVHZ
          UWGVLZVLBCDEFUWBUWBUYDUVMUVNVBZGHIJKLMNOPQRSAVUQVVATYTAEIUVOVAVVAUAYT
          AUXQVVAUBYTAUXIVVAUCYTAUXCVVAUDYTUEUFUGUHUIUJAHWIVSVVAUKYTAVUFVVAULYT
          AVUGHVCVVAUMYTAUXGVVAUNYTAUYDMUWAUYIVCVVAUOYTAVUNGVCVVAUPYTAVUTUWGUVP
          AVUTUWDUWFUVQAVUTUWDUWFUVRVVBXEUVSUVT $.
      $}

      $( Lemma for ~ pgpfac .  (Contributed by Mario Carneiro, 27-Apr-2016.)
         (Revised by Mario Carneiro, 3-May-2016.) $)
      pgpfaclem3 $p |- ( ph -> E. s e. Word C
        ( G dom DProd s /\ ( G DProd s ) = U ) ) $=
        ( wceq wa cfv wcel vx vw cv cdprd cdm wbr co cword wrex cress cgex wrd0
        c1 c0 c0g csn cabel cgrp ablgrp eqid dprd0 adantr c1o cen csubg subg0cl
        3syl syl cbs subgbas cmnd wb subggrp grpmnd gex1 biimpa eqbrtrd en1eqsn
        syl2anc eqeq2d anbi2d mpbird breq2 oveq2 eqeq1d anbi12d sylancr wne cod
        rspcev subgabl cfn wss subgss ssfi eqeltrrd gexcl2 gexex cmrc clsm cpgp
        cn cin subgpgp ad2antrr simprr simprl pgpfac1 ad3antrrr wpss wi simpllr
        simplrl eleqtrrd simplrr simprrl eqtr4d pgpfaclem2 rexlimddv pm2.61dane
        wral simprrr ) AGHUCZUDUEZUFZGYCUDUGZFQZRZHDUHZUIZGFUJUGZUKSZUMAYLUMQZR
        ZUNYITGUNYDUFZGUNUDUGZFQZRZYJDULYNYRYOYPGUOSZUPZQZRZAUUBYMAGUQTZGURTUUB
        LGUSGYSYSUTZVAVGVBYNYQUUAYOYNFYTYPYNYSFTZFVCVDUFFYTQAUUEYMAFGVESZTZUUEO
        FGYSUUDVFVHVBYNFYKVISZVCVDAFUUHQZYMAUUGUUIOFGYKYKUTZVJZVHZVBAYMUUHVCVDU
        FZAYKURTZYKVKTYMUUMVLAUUGUUNOFGYKUUJVMVHZYKVNYLYKUUHUUHUTZYLUTZVOVGVPVQ
        YSFVRVSVTWAWBYHYRHUNYIYCUNQZYEYOYGYQYCUNGYDWCUURYFYPFYCUNGUDWDWEWFWJWGA
        YLUMWHZRZUAUCZYKWISZSYLQZYJUAUUHAUVCUAUUHUIZUUSAYKUQTZYLXBTZUVDAUUCUUGU
        VELOFGYKUUJWKVSZAUUNUUHWLTZUVFUUOAFUUHWLUULACWLTZFCWMZFWLTNAUUGUVJOCFGJ
        WNVHCFWOVSWPZYLYKUUHUUPUUQWQVSUAYLYKUVBUUHUUPUUQUVBUTZWRVSVBUUTUVAUUHTZ
        UVCRZRZUVAUPYKVESZWSSZSZUBUCZXCYKUOSZUPQZUVRUVSYKWTSZUGZUUHQZRZYJUBUVPU
        VOUBUVAUUHEUWBUVRYLYKUVQUVBUVTUVQUTZUVRUTUUPUVLUUQUVTUTZUWBUTZAEYKXAUFZ
        UUSUVNAEGXAUFZUUGUWIMOEFGXDVSXEAUVEUUSUVNUVGXEAUVHUUSUVNUVKXEUUTUVMUVCX
        FUUTUVMUVCXGXHUVOUVSUVPTZUWERZRZBCDEUWBFYLGYKUVQUVBUVSUVAUVTHIJKAUUCUUS
        UVNUWLLXIAUWJUUSUVNUWLMXIAUVIUUSUVNUWLNXIAUUGUUSUVNUWLOXIZABUCZFXJYEYFU
        WOQRHYIUIXKBUUFYAUUSUVNUWLPXIUUJUWFUVLUUQUWGUWHAUUSUVNUWLXLUWMUVAUUHFUU
        TUVMUVCUWLXMUWMUUGUUIUWNUUKVHZXNUUTUVMUVCUWLXOUVOUWKUWEXGUVOUWKUWAUWDXP
        UWMUWCUUHFUVOUWKUWAUWDYBUWPXQXRXSXSXT $.
    $}

    $( Full factorization of a finite abelian p-group, by iterating
       ~ pgpfac1 .  There is a direct product decomposition of any abelian
       group of prime-power order into cyclic subgroups.  (Contributed by Mario
       Carneiro, 27-Apr-2016.)  (Revised by Mario Carneiro, 3-May-2016.) $)
    pgpfac $p |- ( ph -> E. s e. Word C
      ( G dom DProd s /\ ( G DProd s ) = B ) ) $=
      ( vt vx wcel cv wceq wa wrex wi vu csubg cfv cdprd cdm wbr co cword cabel
      cgrp ablgrp subgid 3syl cfn eleq1 eqeq2 anbi2d rexbidv imbi12d imbi2d wal
      wpss wral bi2.04 imbi2i 3bitr4i df-ral r19.21v 3bitr2i adantr cpgp simprr
      albii simprl psseq1 cbvralv sylib pgpfaclem3 exp32 syl5bi findcard3 mpcom
      a1i a2d mpd ) ABEUBUCZOZEFPZUDUEUFZEWHUDUGZBQZRZFCUHZSZAEUIOZEUJOWGJEUKBE
      HULUMBUNOZAWGWNTZLAMPZWFOZWIWJWRQZRZFWMSZTZTZAUAPZWFOZWIWJXEQZRZFWMSZTZTZ
      AWQTMUABWRXEQZXCXJAXLWSXFXBXIWRXEWFUOXLXAXHFWMXLWTXGWIWRXEWJUPUQURUSUTWRB
      QZXCWQAXMWSWGXBWNWRBWFUOXMXAWLFWMXMWTWKWIWRBWJUPUQURUSUTWRXEVBZXDTZMVAZAX
      NXBTZMWFVCZTZXEUNOZXKXPWSAXQTZTZMVAYAMWFVCXSXOYBMAXNXCTZTAWSXQTZTXOYBYCYD
      AXNWSXBVDVEXNAXCVDWSAXQVDVFVMYAMWFVGAXQMWFVHVIXTAXRXJAXRXJTTXTAXRXFXIAXRX
      FRZRZNBCDXEEFGHIAWOYEJVJADEVKUFYEKVJAWPYELVJAXRXFVLYFXRNPZXEVBZWIWJYGQZRZ
      FWMSZTZNWFVCAXRXFVNXQYLMNWFWRYGQZXNYHXBYKWRYGXEVOYMXAYJFWMYMWTYIWIWRYGWJU
      PUQURUSVPVQVRVSWCWDVTWAWBWE $.
  $}

  ${
    $d a b c f h p q s t x y z A $.  $d s z F $.  $d a b c f g h q r s t y S $.
    $d a b c f g h j k n p r s t w x B $.  $d b c p x O $.  $d j k w x .x. $.
    $d a b c f g h j k n p q s t w x y z C $.  $d a b c f h p q t w x y W $.
    $d s H $.  $d a b c f h j k n p q s t w x y z ph $.  $d g s U $.
    $d a b c g j k n p r s t w x y z G $.
    ablfac.b $e |- B = ( Base ` G ) $.
    ablfac.c $e |- C = { r e. ( SubGrp ` G ) |
      ( G |`s r ) e. ( CycGrp i^i ran pGrp ) } $.
    ablfac.1 $e |- ( ph -> G e. Abel ) $.
    ablfac.2 $e |- ( ph -> B e. Fin ) $.
    ${
      ablfac.o $e |- O = ( od ` G ) $.
      ablfac.a $e |- A = { w e. Prime | w || ( # ` B ) } $.
      ablfac.s $e |- S = ( p e. A |-> { x e. B |
        ( O ` x ) || ( p ^ ( p pCnt ( # ` B ) ) ) } ) $.
      ablfac.w $e |- W = ( g e. ( SubGrp ` G ) |->
        { s e. Word C | ( G dom DProd s /\ ( G DProd s ) = g ) } ) $.
      $( Lemma for ~ ablfac .  (Contributed by Mario Carneiro, 27-Apr-2016.)
         (Revised by Mario Carneiro, 3-May-2016.) $)
      ablfaclem1 $p |- ( U e. ( SubGrp ` G ) -> ( W ` U ) =
        { s e. Word C | ( G dom DProd s /\ ( G DProd s ) = U ) } ) $=
        ( cv cdprd cdm wbr co wceq wa cword crab csubg cfv eqeq2 anbi2d rabbidv
        cvv wcel cress ccyg cpgp crn cin fvex rabex eqeltri wrdexg ax-mp fvmpt
        ) IHJMUDZUEUFUGZJVKUEUHZIUDZUIZUJZMFUKZULVLVMHUIZUJZMVQULJUMUNZLVNHUIZV
        PVSMVQWAVOVRVLVNHVMUOUPUQUCVSMVQFURUSVQURUSFJNUDUTUHVAVBVCVDUSZNVTULURQ
        WBNVTJUMVEVFVGFURVHVIVFVJ $.

      ${
        ablfaclem2.f $e |- ( ph -> F : A --> Word C ) $.
        ablfaclem2.q $e |- ( ph ->
          A. y e. A ( F ` y ) e. ( W ` ( S ` y ) ) ) $.
        ablfaclem2.l $e |- L = U_ y e. A ( { y } X. dom ( F ` y ) ) $.
        ablfaclem2.g $e |- ( ph -> H : ( 0 ..^ ( # ` L ) ) -1-1-onto-> L ) $.
        $( Lemma for ~ ablfac .  (Contributed by Mario Carneiro, 27-Apr-2016.)
           (Proof shortened by Mario Carneiro, 3-May-2016.) $)
        ablfaclem2 $p |- ( ph -> ( W ` B ) =/= (/) ) $=
          ( vz cfv cv cdprd cdm wbr co wceq wa cword crab cabel wcel cgrp csubg
          c0 ablgrp subgid ablfaclem1 4syl wrex wne cmpt2 ccom cc0 chash wf csn
          cfzo cxp ciun wral ffvelrnda wrdf feq2d mpbird anasss ralrimivva eqid
          syl fdm fmpt2x sylib feq2i sylibr wf1o f1of fco syl2anc cmpt r19.21bi
          iswrdi cprime wss cdivides eqsstri a1i ablfac1b cpc cexp cbs cvv fvex
          ssrab2 eqeltri rabex dmmpti dprdf2 eleqtrd breq2 oveq2 eqeq1d anbi12d
          simprbi simpld feqmptd breqtrd oveq2d simprd eqtr3d mpteq2dva dprd2d2
          elrab dprdf eqtr4d dprdf1o ssid ablfac1c 3eqtrd rspcev syl12anc rabn0
          eqnetrd ) AFOULZKPUMZUNUOZUPZKUUEUNUQZFURZUSZPGUTZVAZVFAKVBVCKVDVCFKV
          EULZVCUUDUULURUAKVGFKSVHABDEFGHFIKNOPQRSTUAUBUCUDUEUFVIVJAUUJPUUKVKZU
          ULVFVLACUKECUMZJULZUOZUKUMZUUPULZVMZLVNZUUKVCZKUVAUUFUPZKUVAUNUQZFURZ
          UUNAVOMVPULZVSUQZGUVAVQZUVBAMGUUTVQZUVGMLVQZUVHACEUUOVRUUQVTWAZGUUTVQ
          ZUVIAUUSGVCZUKUUQWBCEWBUVLAUVMCUKEUUQAUUOEVCZUURUUQVCZUVMAUVNUSZUUQGU
          URUUPUVPUUQGUUPVQVOUUPVPULVSUQZGUUPVQZUVPUUPUUKVCZUVRAEUUKUUOJUGWCGUU
          PWDWJZUVPUUQUVQGUUPUVPUVRUUQUVQURUVTUVQGUUPWKWJWEWFWCWGWHCUKEUUQUUSGU
          UTUUTWIWLWMMUVKGUUTUIWNWOZAUVGMLWPUVJUJUVGMLWQWJUVGMGUUTLWRWSGUVFUVAX
          BWJAUVCUVDKUUTUNUQZURZAUUTLKMUVGAKUUTUUFUPZUWBKCEKUKUUQUUSWTZUNUQZWTZ
          UNUQZURZAUUSCUKKEUUQAUVNUVOUUSUUMVCUVPUUQUUMUURUUPUVPKUUPUUFUPZUUQUUM
          UUPVQUVPUWJKUUPUNUQZUUOHULZURZUVPUUPUUGUUHUWLURZUSZPUUKVAZVCZUWJUWMUS
          ZUVPUUPUWLOULZUWPAUUPUWSVCCEUHXAUVPUWLUUMVCUWSUWPURAEUUMUUOHAHKEABEFH
          KNRSUCUEUAUBEXCXDAEDUMFVPULZXEUPZDXCVAXCUDUXADXCXNXFXGZXHZHUOEURAREBU
          MNULRUMZUXDUWTXIUQXJUQXEUPZBFVAHUXEBFFKXKULXLSKXKXMXOXPUEXQXGXRZWCABD
          EFGHUWLIKNOPQRSTUAUBUCUDUEUFVIWJXSUWQUVSUWRUWOUWRPUUPUUKUUEUUPURZUUGU
          WJUWNUWMUUEUUPKUUFXTUXGUUHUWKUWLUUEUUPKUNYAYBYCYMYDWJZYEZUUPKYNWJZWCW
          GUVPKUUPUWEUUFUXIUVPUKUUQUUMUUPUXJYFZYGAKHUWGUUFUXCAHCEUWLWTUWGACEUUM
          HUXFYFACEUWFUWLUVPUWKUWFUWLUVPUUPUWEKUNUXKYHUVPUWJUWMUXHYIYJYKYOZYGYL
          ZYEAUVIUUTUOMURUWAMGUUTWKWJUJYPZYEAUVDUWBUWHFAUVCUWCUXNYIAUWDUWIUXMYI
          AKHUNUQUWHFAHUWGKUNUXLYHABDEFEHKNRSUCUEUAUBUXBUDEEXDAEYQXGYRYJYSUUJUV
          CUVEUSPUVAUUKUUEUVAURZUUGUVCUUIUVEUUEUVAKUUFXTUXOUUHUVDFUUEUVAKUNYAYB
          YCYTUUAUUJPUUKUUBWOUUC $.
      $}

      $( Lemma for ~ ablfac .  (Contributed by Mario Carneiro, 27-Apr-2016.)
         (Revised by Mario Carneiro, 3-May-2016.) $)
      ablfaclem3 $p |- ( ph -> ( W ` B ) =/= (/) ) $=
        ( vf vq vy vh vc va vt vb cword cv wf cfv wcel wral wa wne cfn wrex wex
        c0 c1 chash cfz co wss fzfid cdivides wbr cprime crab cn prmnn 3ad2ant2
        w3a cle cz wi prmz cabel cgrp ablgrp grpbn0 3syl wb hashnncl syl mpbird
        3ad2ant1 mpbir2and rabssdv syl5eqss ssfi syl2anc cdprd cdm csubg ssrab2
        wceq cin a1i cpc cexp cbs ffvelrnda sylib eqtrd cress crn adantr sselda
        cpgp eqid fveq2d oveq2d eqeltrrd sswrd simprbda simplbda jctild expimpd
        weq oveq2 eleq1d cbvrabv 3adant3 mpd rabn0 ralrimiva cc0 csn ciun fveq2
        cxp cfzo fzofi sylancr eqtri cmpt dvdsle syl2anr 3impia nnzd fznn dfin5
        eqsstri ablfac1b cvv fvex rabex dmmpti dprdf2 ablfaclem1 syl6eqss dfss1
        eqeltri syl5eqr ccyg subgabl subgbas ablfac1a eqtr3d pccld nn0zd eqtr4d
        pcid subggrp subgss pgpfi2 ax-mp sseli cpw subgdmdprd subgdprd ad2antrr
        pgpfac eqcomd eqeq12d biimpd sylan2 subsubg ressabs simp3 elrab2 sylibr
        sylanbrc reximdv2 eqnetrd eleq1 wf1o cen cn0 sneq dmeqd xpeq12d cbviunv
        ac6sfi snfi simprl wrdf fdm syl6eqel xpfi iunfi syl5eqel hashfzo0 mpbid
        hashcl hashen bren breq1 breq1d id oveq1 oveq12d breq2d rabbidv cbvmptv
        syl5eq breq2 anbi12d mpteq2i simprll simprlr eleq12d cbvralv ablfaclem2
        eqeq1d simprr expr exlimdv exlimddv ) ADFUKZUCULZUMZUDULZUYOUNZUYQGUNZK
        UNZUOZUDDUPZUQZEKUNVBURZUCADUSUOZUEULZUYTUOZUEUYNUTZUDDUPVUCUCVAAVCEVDU
        NZVEVFZUSUODVUJVGVUEAVCVUIVHADCULZVUIVIVJZCVKVLZVUJTAVULCVKVUJAVUKVKUOZ
        VULVPZVUKVUJUOZVUKVMUOZVUKVUIVQVJZVUNAVUQVULVUKVNVOAVUNVULVURVUNVUKVRUO
        VUIVMUOZVULVURVSAVUKVTAVUSEVBURZAIWAUOZIWBUOVUTQIWCEIOWDWEAEUSUOZVUSVUT
        WFREWGWHWIZVUKVUIUUAUUBUUCVUOVUIVRUOZVUPVUQVURUQWFAVUNVVDVULAVUIVVCUUDW
        JVUKVUIUUEWHWKWLWMVUJDWNWOZAVUHUDDAUYQDUOZUQZVUGUEUYNVLZVBURVUHVVGVVHIL
        ULZWPWQZVJZIVVIWPVFZUYSWTZUQZLUYNVLZVBVVGVVHUYTVVOVVGVVHUYNUYTXAZUYTUEU
        YNUYTUUFVVGUYTUYNVGVVPUYTWTVVGUYTVVOUYNVVGUYSIWRUNZUOZUYTVVOWTADVVQUYQG
        AGIDABDEGIJNOSUAQRDVKVGADVUMVKTVULCVKWSUUGXBZUUHGWQDWTANDBULZJUNZNULZVW
        BVUIXCVFZXDVFZVIVJZBEVLZGVWEBEEIXEUNUUIOIXEUUJUUQUUKUAUULXBUUMXFZABCDEF
        GUYSHIJKLMNOPQRSTUAUBUUNWHZVVNLUYNWSUUOUYTUYNUUPXGUURVWHXHVVGVVNLUYNUTZ
        VVOVBURVVGIUYSXIVFZVVIVVJVJZVWJVVIWPVFZVWJXEUNZWTZUQZLVWJMULZXIVFZUUSXM
        XJXAZUOZMVWJWRUNZVLZUKZUTVWIVVGVWMVXAUYQVWJLMVWMXNZVXAXNVVGVVAVVRVWJWAU
        OAVVAVVFQXKVWGUYSIVWJVWJXNZUUTWOVVGUYQVWJXMVJZUYQVKUOZVWMVDUNZUYQUYQVXG
        XCVFZXDVFZWTZADVKUYQVVSXLZVVGVXGUYQUYQVUIXCVFZXDVFZVXIVVGUYSVDUNVXGVXMV
        VGUYSVWMVDVVGVVRUYSVWMWTZVWGUYSIVWJVXDUVAWHZXOABDEUYQGIJNOSUAQRVVSUVBUV
        CZVVGVXHVXLUYQXDVVGVXHUYQVXMXCVFZVXLVVGVXGVXMUYQXCVXPXPVVGVXFVXLVRUOVXQ
        VXLWTVXKVVGVXLVVGUYQVUIVXKAVUSVVFVVCXKUVDUVEVXLUYQUVGWOXHXPUVFVVGVWJWBU
        OZVWMUSUOVXEVXFVXJUQWFVVGVVRVXRVWGUYSIVWJVXDUVHWHVVGUYSVWMUSVXOVVGVVBUY
        SEVGZUYSUSUOAVVBVVFRXKVVGVVRVXSVWGEUYSIOUVIWHEUYSWNWOXQZUYQVWJVWMVXCUVJ
        WOWKVXTUVQVVGVWOVVNLVXBUYNVVGVVIVXBUOZVWOVVIUYNUOZVVNUQVVGVYAUQVWOVVNVY
        BVYAVVGVVIVWTUKZUOZVWOVVNVSVXBVYCVVIVXAVWTVGVXBVYCVGVWSMVWTWSVXAVWTXRUV
        KUVLVVGVYDUQZVWKVWNVVNVYEVWKUQZVWNVVMVVKVYFVWNVVMVYFVWLVVLVWMUYSVYFUYSV
        VIIVWJVXDVYEVVRVWKVVGVVRVYDVWGXKZXKVYEVWKVVKVVIXJUYSUVMVGZVYEVVRVWKVVKV
        YHUQWFVYGUYSVVIIVWJVXDUVNWHZXSZVYEVWKVVKVYHVYIXTUVOVYFUYSVWMVVGVXNVYDVW
        KVXOUVPUVRUVSUVTVYJYAYBUWAVVGVXBUYNVVIVVGVXAFVGVXBUYNVGVVGVXAVWJVUFXIVF
        ZVWRUOZUEVWTVLFVWSVYLMUEVWTMUEYCZVWQVYKVWRVWPVUFVWJXIYDYEYFVVGVYLUEVWTF
        VVGVUFVWTUOZVYLVPZVUFVVQUOZIVUFXIVFZVWRUOZVUFFUOVVGVYNVYPVYLVVGVYNVYPVU
        FUYSVGZVVGVVRVYNVYPVYSUQWFVWGVUFUYSIVWJVXDUWBWHZXSYGVYOVYKVYQVWRVYOVVRV
        YSVYKVYQWTVVGVYNVVRVYLVWGWJVVGVYNVYSVYLVVGVYNVYPVYSVYTXTYGUYSVUFIVVQUWC
        WOVVGVYNVYLUWDXQIVWPXIVFZVWRUOVYRMVUFVVQFVYMWUAVYQVWRVWPVUFIXIYDYEPUWEU
        WGWLWMVXAFXRWHXLYAYBUWHYHVVNLUYNYIUWFUWIVUGUEUYNYIXGYJVUGVUAUDUEDUYNUCV
        UFUYRUYTUWJUWRWOAVUCUQZYKUDDUYQYLZUYRWQZYOZYMZVDUNZYPVFZWUFUFULZUWKZUFV
        AZVUDWUBWUHWUFUWLVJZWUKWUBWUHVDUNWUGWTZWULWUBWUFUSUOZWUGUWMUOWUMWUBWUFU
        EDVUFYLZVUFUYOUNZWQZYOZYMZUSUDUEDWUEWURUDUEYCZWUCWUOWUDWUQUYQVUFUWNWUTU
        YRWUPUYQVUFUYOYNZUWOUWPUWQZWUBVUEWURUSUOZUEDUPWUSUSUOAVUEVUCVVEXKWUBWVC
        UEDWUBVUFDUOUQZWUOUSUOWUQUSUOWVCVUFUWSWVDWUQYKWUPVDUNZYPVFZUSWVDWUPUYNU
        OWVFFWUPUMWUQWVFWTWUBDUYNVUFUYOAUYPVUBUWTXFFWUPUXAWVFFWUPUXBWEYKWVEYQUX
        CWUOWUQUXDYRYJUEDWURUXEWOUXFZWUFUXIWUGUXGWEWUBWUHUSUOWUNWUMWULWFYKWUGYQ
        WVGWUHWUFUXJYRUXHWUHWUFUFUXKXGWUBWUJVUDUFAVUCWUJVUDAVUCWUJUQZUQZUGUEUHD
        EFGHUYOIWUIWUFJKUIMUJOPAVVAWVHQXKAVVBWVHRXKSDVUMUHULZVUIVIVJZUHVKVLTVUL
        WVKCUHVKVUKWVJVUIVIUXLYFYSGNDVWFYTUJDUGULZJUNZUJULZWVNVUIXCVFZXDVFZVIVJ
        ZUGEVLZYTUANUJDVWFWVRNUJYCZVWFWVMVWDVIVJZUGEVLWVRVWEWVTBUGEBUGYCVWAWVMV
        WDVIVVTWVLJYNUXMYFWVSWVTWVQUGEWVSVWDWVPWVMVIWVSVWBWVNVWCWVOXDWVSUXNVWBW
        VNVUIXCUXOUXPUXQUXRUXTUXSYSKHVVQVVKVVLHULZWTZUQZLUYNVLZYTHVVQIUIULZVVJV
        JZIWWEWPVFZWWAWTZUQZUIUYNVLZYTUBHVVQWWDWWJWWCWWILUIUYNLUIYCZVVKWWFWWBWW
        HVVIWWEIVVJUYAWWKVVLWWGWWAVVIWWEIWPYDUYIUYBYFUYCYSAUYPVUBWUJUYDWVIVUBWU
        PVUFGUNZKUNZUOZUEDUPAUYPVUBWUJUYEVUAWWNUDUEDWUTUYRWUPUYTWWMWVAWUTUYSWWL
        KUYQVUFGYNXOUYFUYGXGWVBAVUCWUJUYJUYHUYKUYLYHUYM $.
    $}

    $( The Fundamental Theorem of (finite) Abelian Groups.  Any finite abelian
       group is a direct product of cyclic p-groups.  (Contributed by Mario
       Carneiro, 27-Apr-2016.)  (Revised by Mario Carneiro, 3-May-2016.) $)
    ablfac $p |- ( ph -> E. s e. Word C
      ( G dom DProd s /\ ( G DProd s ) = B ) ) $=
      ( vg vx vw vp cv wbr co crab cfv eqid cdprd cdm wceq wa cword c0 wne wrex
      csubg cmpt cabel wcel cgrp ablgrp subgid chash cdivides cprime ablfaclem1
      cod cpc cexp 4syl ablfaclem3 eqnetrrd rabn0 sylib ) ADEOZUAUBPZDVHUAQZBUC
      UDZECUEZRZUFUGVKEVLUHABKDUISZVIVJKOUCUDEVLRUJZSZVMUFADUKULDUMULBVNULVPVMU
      CIDUNBDGUOALMMOBUPSZUQPMURRZBCNVRLODUTSZSNOZVTVQVAQVBQUQPLBRUJZBKDVSVOEFN
      GHIJVSTZVRTZWATZVOTZUSVCALMVRBCWAKDVSVOEFNGHIJWBWCWDWEVDVEVKEVLVFVG $.

    ablfac2.m $e |- .x. = ( .g ` G ) $.
    ablfac2.s $e |- S = ( k e. dom w |->
      ran ( n e. ZZ |-> ( n .x. ( w ` k ) ) ) ) $.
    $( Choose generators for each cyclic group in ~ ablfac .  (Contributed by
       Mario Carneiro, 28-Apr-2016.) $)
    ablfac2 $p |- ( ph -> E. w e. Word B
      ( S : dom w --> C /\ G dom DProd S /\ ( G DProd S ) = B ) ) $=
      ( vx wceq wa wcel vs vj cv cdprd cdm wbr co cword wrex w3a ablfac wex cfv
      wf cz cmpt crn wral cfn cc0 chash cfzo wrdf ad2antlr fdm syl syl6eqel wss
      fzofi csubg feq2d mpbird ffvelrnda cress ccyg oveq2 eleq1d elrab2 simplbi
      cpgp cin subgss cmg inss1 simprbi sseldi cgrp eqid iscyg subgbas ad2antrr
      cbs rexeqdv simpr simplr subgmulg syl3anc mpteq2dva rneqd adantr rexbidva
      eqeq12d ssrexv sylc ralrimiva mpteq2dv eqeq1d ac6sfi syl2anc simprl mpbid
      iswrdi eqtr4d eleq2d biimpa simprr simpl fveq2d oveq2d fveq2 sylan syldan
      rspccva eqeltrd cbvmptv eqtri fmptd raleqdv mpteq12 syl5eq dprdf breqtrrd
      feqmptd simplrr eqtrd 3jca jca ex eximdv mpd df-rex sylibr rexlimdva ) AI
      UAUCZUDUEZUFZIUUDUDUGZCRZSZUADUHZUIBUCZUEZDEUNZIEUUEUFZIEUDUGZCRZUJZBCUHZ
      UIZACDIUAJKLMNUKAUUIUUSUAUUJAUUDUUJTZSZUUIUUSUVAUUISZUUKUURTZUUQSZBULZUUS
      UVBUUDUEZCUUKUNZHUOHUCZGUCZUUKUMZFUGZUPZUQZUVIUUDUMZRZGUVFURZSZBULZUVEUVB
      UVFUSTHUOUVHQUCZFUGZUPZUQZUVNRZQCUIZGUVFURUVRUVBUVFUTUUDVAUMZVBUGZUSUVBUW
      FDUUDUNZUVFUWFRZUUTUWGAUUIDUUDVCVDZUWFDUUDVEVFZUTUWEVIVGUVBUWDGUVFUVBUVIU
      VFTSZUVNCVHZUWCQUVNUIZUWDUWKUVNIVJUMZTZUWLUWKUVNDTZUWOUVBUVFDUVIUUDUVBUVF
      DUUDUNZUWGUWIUVBUVFUWFDUUDUWJVKVLZVMZUWPUWOIUVNVNUGZVOVTUQZWAZTZIJUCZVNUG
      ZUXBTUXCJUVNUWNDUXDUVNRUXEUWTUXBUXDUVNIVNVPVQLVRZVSVFZCUVNIKWBVFUWKUWMHUO
      UVHUVSUWTWCUMZUGZUPZUQZUWTWLUMZRZQUVNUIZUWKUXNUXMQUXLUIZUWKUWTVOTZUXOUWKU
      XBVOUWTVOUXAWDUWKUWPUXCUWSUWPUWOUXCUXFWEVFWFUXPUWTWGTUXOQUXLUXHHUWTUXLWHU
      XHWHZWIWEVFUWKUXMQUVNUXLUWKUWOUVNUXLRZUXGUVNIUWTUWTWHZWJVFZWMVLUWKUWCUXMQ
      UVNUWKUVSUVNTZSZUWBUXKUVNUXLUYBUWAUXJUYBHUOUVTUXIUYBUVHUOTZSUWOUYCUYAUVTU
      XIRUWKUWOUYAUYCUXGWKUYBUYCWNUWKUYAUYCWOUVNUXHFIUWTUVHUVSOUXSUXQWPWQWRWSUW
      KUXRUYAUXTWTXBXAVLUWCQUVNCXCXDXEUWCUVOGQUVFCBUVSUVJRZUWBUVMUVNUYDUWAUVLUY
      DHUOUVTUVKUVSUVJUVHFVPXFWSXGXHXIUVBUVQUVDBUVBUVQUVDUVBUVQSZUVCUUQUYEUWFCU
      UKUNZUVCUYEUVGUYFUVBUVGUVPXJUYEUVFUWFCUUKUVBUWHUVQUWJWTZVKXKZCUWEUUKXLVFU
      YEUUMUUNUUPUYEUBUULHUOUVHUBUCZUUKUMZFUGZUPZUQZDEUYEUYIUULTZUYIUVFTZUYMDTU
      YEUYNUYOUYEUULUVFUYIUYEUULUWFUVFUYEUYFUULUWFRUYHUWFCUUKVEVFUYGXMZXNXOUYEU
      YOSUYMUYIUUDUMZDUYEUVPUYOUYMUYQRZUVBUVGUVPXPZUVOUYRGUYIUVFUVIUYIRZUVMUYMU
      VNUYQUYTUVLUYLUYTHUOUVKUYKUYTUYCSZUVJUYJUVHFVUAUVIUYIUUKUYTUYCXQXRXSWRWSU
      VIUYIUUDXTXBYCYAUYEUVFDUYIUUDUVBUWQUVQUWRWTVMYDYBEGUULUVMUPZUBUULUYMUPPGU
      BUULUVMUYMUYTUVLUYLUYTHUOUVKUYKUYTUVJUYJUVHFUVIUYIUUKXTXSXFWSYEYFYGUYEIUU
      DEUUEUVBUUFUVQUVAUUFUUHXJWTZUYEEGUVFUVNUPZUUDUYEEVUBVUDPUYEUULUVFRUVOGUUL
      URZVUBVUDRUYPUYEVUEUVPUYSUYEUVOGUULUVFUYPYHVLGUULUVMUVFUVNYIXIYJUYEGUVFUW
      NUUDUYEUUFUVFUWNUUDUNVUCUUDIYKVFYMXMZYLUYEUUOUUGCUYEEUUDIUDVUFXSUVAUUFUUH
      UVQYNYOYPYQYRYSYTUUQBUURUUAUUBYRUUCYT $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Rings
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Multiplicative Group
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c mulGrp $. $( Multiplicative group $)

  $( Multiplicative group. $)
  cmgp $a class mulGrp $.

  $( Define a structure that puts the multiplication operation of a ring in the
     addition slot.  Note that this will not actually be a group for the
     average ring, or even for a field, but it will be a monoid, and ~ unitgrp
     shows that we get a group if we restrict to the elements that have
     inverses.  This allows us to formalize such notions as "the multiplication
     operation of a ring is a monoid" ( ~ rngmgp ) or "the multiplicative
     identity" in terms of the identity of a monoid ( ~ df-1r ).  (Contributed
     by Mario Carneiro, 21-Dec-2014.) $)
  df-mgp $a |- mulGrp = ( w e. _V |->
    ( w sSet <. ( +g ` ndx ) , ( .r ` w ) >. ) ) $.

  $( The multiplicative group operator is a function.  (Contributed by Mario
     Carneiro, 11-Mar-2015.) $)
  fnmgp $p |- mulGrp Fn _V $=
    ( vx cvv cv cnx cplusg cfv cmulr cop csts co cmgp ovex df-mgp fnmpti ) ABAC
    ZDEFOGFHZIJKOPILAMN $.

  ${
    $d r x R $.  $d r x .x. $.
    mgpval.1 $e |- M = ( mulGrp ` R ) $.
    mgpval.2 $e |- .x. = ( .r ` R ) $.
    $( Value of the multiplication group operation.  (Contributed by Mario
       Carneiro, 21-Dec-2014.) $)
    mgpval $p |- M = ( R sSet <. ( +g ` ndx ) , .x. >. ) $=
      ( vr cmgp cfv cnx cplusg cop csts co cvv wcel wceq cv cmulr id fveq2 ovex
      syl6eqr opeq2d oveq12d df-mgp fvmpt wn c0 reldmsets ovprc1 eqtr4d pm2.61i
      fvprc eqtri ) CAGHZAIJHZBKZLMZDANOZUOURPFAFQZUPUTRHZKZLMURNGUTAPZUTAVBUQL
      VCSVCVABUPVCVAARHBUTARTEUBUCUDFUEAUQLUAUFUSUGUOUHURAGUMAUQLUIUJUKULUN $.

    $( Value of the group operation of the multiplication group.  (Contributed
       by Mario Carneiro, 21-Dec-2014.) $)
    mgpplusg $p |- .x. = ( +g ` M ) $=
      ( cvv wcel cplusg cfv wceq cnx csts co cmulr plusgid c0 fvprc syl5eq cmgp
      cop fvex eqeltri setsid mgpval fveq2i syl6eqr str0 fveq2d 3eqtr4a pm2.61i
      mpan2 wn ) AFGZBCHIZJUMBAKHIZBTLMZHIZUNUMBFGBUQJBANIZFEANUAUBFBHFAOUCUKCU
      PHABCDEUDUEUFUMULZPPHIBUNHUOOUGUSBURPEANQRUSCPHUSCASIPDASQRUHUIUJ $.
  $}

  ${
    $d x R $.
    mgpbas.1 $e |- M = ( mulGrp ` R ) $.
    ${
      mgplem.2 $e |- E = Slot N $.
      mgplem.3 $e |- N e. NN $.
      mgplem.4 $e |- N =/= 2 $.
      $( Lemma for ~ mgpbas .  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
      mgplem $p |- ( E ` R ) = ( E ` M ) $=
        ( cfv cnx cplusg cmulr cop csts co ndxid wne c2 ndxarg plusgndx neeq12i
        mpbir setsnid eqid mgpval fveq2i eqtr4i ) ABIAJKIZALIZMNOZBICBIUIUHBABD
        FGPJBIZUHQDRQHUKDUHRBDFGSTUAUBUCCUJBAUICEUIUDUEUFUG $.
    $}

    ${
      mgpbas.2 $e |- B = ( Base ` R ) $.
      $( Base set of the multiplication group.  (Contributed by Mario Carneiro,
         21-Dec-2014.)  (Revised by Mario Carneiro, 5-Oct-2015.) $)
      mgpbas $p |- B = ( Base ` M ) $=
        ( cbs cfv c1 df-base 1nn 1ne2 mgplem eqtri ) ABFGCFGEBFCHDIJKLM $.
    $}

    ${
      mgpsca.s $e |- S = ( Scalar ` R ) $.
      $( The multiplication monoid has the same (if any) scalars as the
         original ring.  Mostly to simplify ~ pwsmgp .  (Contributed by Mario
         Carneiro, 12-Mar-2015.)  (Revised by Mario Carneiro, 5-May-2015.) $)
      mgpsca $p |- S = ( Scalar ` M ) $=
        ( csca cfv c5 df-sca 5nn c2 2re 2lt5 gtneii mgplem eqtri ) BAFGCFGEAFCH
        DIJKHLMNOP $.
    $}

    $( Topology component of the multiplication group.  (Contributed by Mario
       Carneiro, 5-Oct-2015.) $)
    mgptset $p |- ( TopSet ` R ) = ( TopSet ` M ) $=
      ( cts c9 df-tset 9nn c2 2re 2lt9 gtneii mgplem ) ADBECFGHEIJKL $.

    ${
      mgptopn.2 $e |- J = ( TopOpen ` R ) $.
      $( Topology of the multiplication group.  (Contributed by Mario Carneiro,
         5-Oct-2015.) $)
      mgptopn $p |- J = ( TopOpen ` M ) $=
        ( ctopn cfv cts cbs crest co eqid topnval mgpbas mgptset 3eqtr2i ) BAFG
        AHGZAIGZJKCFGERQARLZQLMRQCRACDSNACDOMP $.
    $}

    ${
      mgpds.2 $e |- B = ( dist ` R ) $.
      $( Distance function of the multiplication group.  (Contributed by Mario
         Carneiro, 5-Oct-2015.) $)
      mgpds $p |- B = ( dist ` M ) $=
        ( cds cfv c1 c2 cdc df-ds 1nn0 2nn decnncl 2re 2nn0 2lt10 declti gtneii
        1nn mgplem eqtri ) ABFGCFGEBFCHIJZDKHILMNIUCOHIITPPQRSUAUB $.
    $}
  $}

  ${
    mgpress.1 $e |- S = ( R |`s A ) $.
    mgpress.2 $e |- M = ( mulGrp ` R ) $.
    $( Subgroup commutes with the multiplication group operator.  (Contributed
       by Mario Carneiro, 10-Jan-2015.) $)
    mgpress $p |- ( ( R e. V /\ A e. W ) -> ( M |`s A ) = ( mulGrp ` S ) ) $=
      ( wcel wa cbs cfv co cmgp wceq cvv fvex eqid syl3anc csts wss cress simpr
      eqeltri a1i simplr mgpbas ressid2 simpll fveq2d 3eqtr4a wn cnx cin cplusg
      cop mgpval oveq1i ressval2 ressmulr eqcomd ad2antlr opeq2d oveq12d syl5eq
      cmulr wne c2 c1 1ne2 plusgndx basendx neeq12i mpbir inex2 setscom mpanr12
      necomi sylancl eqtr4d pm2.61dan ) BEIZAFIZJZBKLZAUAZDAUBMZCNLZOWDWFJZDBNL
      ZWGWHHWIWFDPIZWCWGDOWDWFUCZWKWIDWJPHBNQUDZUEWBWCWFUFZAWEWGDPFWGRZWEBDHWER
      ZUGZUHSWICBNWIWFWBWCCBOWLWBWCWFUIWNAWECBEFGWPUHSUJUKWDWFULZJZDUMKLZAWEUNZ
      UPZTMZBUMUOLZBVFLZUPZTMZXBTMZWGWHDXGXBTBXEDHXERZUQURWSWRWKWCWGXCOWDWRUCZW
      KWSWMUEWBWCWRUFZAWEWGDPFWOWQUSSWSWHBXBTMZXFTMZXHWSWHCXDCVFLZUPZTMXMCXNWHW
      HRXNRUQWSCXLXOXFTWSWRWBWCCXLOXJWBWCWRUIZXKAWECBEFGWPUSSWSXNXEXDWCXNXEOWBW
      RWCXEXNABCXEFGXIUTVAVBVCVDVEWSWBXDWTVGZXHXMOZXPXQVHVIVGVIVHVJVRXDVHWTVIVK
      VLVMVNWBXQJXEPIXAPIXRBVFQWEABKQVOXDWTXEXABEPPUMUOQUMKQVPVQVSVTUKWA $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ring $.
  $c CRing $.
  $c 1r $.

  $( Extend class notation with class of all (unital) rings. $)
  crg $a class Ring $.

  $( Extend class notation with class of all (unital) commutative rings. $)
  ccrg $a class CRing $.

  $( Extend class notation with ring unit. $)
  cur $a class 1r $.

  ${
    $d f p r t x y z $.
    $( Define class of all (unital) rings.  A unital ring is a set equipped
       with two everywhere-defined internal operations, whose first one is an
       additive group structure and the second one is a multiplicative monoid
       structure, and where the addition is left- and right-distributive for
       the multiplication.  So that the additive structure must be abelian (see
       ~ rngcom ), care must be taken that in the case of a non-unital ring,
       the commutativity of addition must be postulated and cannot be proved
       from the other conditions.  (Contributed by NM, 18-Oct-2012.)  (Revised
       by Mario Carneiro, 27-Dec-2014.) $)
    df-rng $a |- Ring = { f e. Grp | ( ( mulGrp ` f ) e. Mnd /\
        [. ( Base ` f ) / r ]. [. ( +g ` f ) / p ]. [. ( .r ` f ) / t ].
        A. x e. r A. y e. r A. z e. r
           ( ( x t ( y p z ) ) = ( ( x t y ) p ( x t z ) )
            /\ ( ( x p y ) t z ) = ( ( x t z ) p ( y t z ) ) ) ) } $.

    $( Define class of all commutative rings.  (Contributed by Mario Carneiro,
       7-Jan-2015.) $)
    df-cring $a |- CRing = { f e. Ring | ( mulGrp ` f ) e. CMnd } $.

    $( Define the multiplicative neutral element of a ring.  This definition
       works by extracting the ` 0g ` element, i.e. the neutral element in a
       group or monoid, and transfering it to the multiplicative monoid via the
       ` mulGrp ` function ( ~ df-mgp ).  See also ~ dfur2 , which derives the
       "traditional" definition as the unique element of a ring which is left-
       and right-neutral under multiplication.  (Contributed by NM,
       27-Aug-2011.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
    df-ur $a |- 1r = ( 0g o. mulGrp ) $.
  $}

  ${
    rngidval.g $e |- G = ( mulGrp ` R ) $.
    rngidval.u $e |- .1. = ( 1r ` R ) $.
    $( The value of the unity element of a ring.  (Contributed by NM,
       27-Aug-2011.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
    rngidval $p |- .1. = ( 0g ` G ) $=
      ( cur cfv cmgp c0g cvv wcel wceq ccom df-ur fveq1i wfn fnmgp fvco2 fvprc
      c0 mpan syl5eq wn 0g0 fveq2d 3eqtr4a pm2.61i fveq2i 3eqtr4i ) AFGZAHGZIGZ
      BCIGAJKZUJULLUMUJAIHMZGZULAFUNNOHJPUMUOULLQJIHARUAUBUMUCZTTIGUJULUDAFSUPU
      KTIAHSUEUFUGECUKIDUHUI $.
  $}

  ${
    $d e x B $.  $d e x R $.
    dfur2.b $e |- B = ( Base ` R ) $.
    dfur2.t $e |- .x. = ( .r ` R ) $.
    dfur2.u $e |- .1. = ( 1r ` R ) $.
    $( The multiplicative identity is the unique element of the ring that is
       left- and right-neutral on all elements under multiplication.
       (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    dfur2 $p |- .1. = ( iota e ( e e. B /\
      A. x e. B ( ( e .x. x ) = x /\ ( x .x. e ) = x ) ) ) $=
      ( cmgp cfv eqid mgpbas mgpplusg rngidval grpidval ) ABDFCJKZEBCQQLZGMCDQR
      HNCEQRIOP $.
  $}

  ${
    $d b p r t x y z B $.  $d b p r t x y z .+ $.  $d b p r t x y z R $.
    $d r G $.  $d b p r t x y z .x. $.
    isrng.b $e |- B = ( Base ` R ) $.
    isrng.g $e |- G = ( mulGrp ` R ) $.
    isrng.p $e |- .+ = ( +g ` R ) $.
    isrng.t $e |- .x. = ( .r ` R ) $.
    $( The predicate "is a (unital) ring."  Definition of ring with unit in
       [Schechter] p. 187.  (Contributed by NM, 18-Oct-2012.)  (Revised by
       Mario Carneiro, 6-Jan-2015.) $)
    isrng $p |- ( R e. Ring <-> ( R e. Grp /\ G e. Mnd
      /\ A. x e. B A. y e. B A. z e. B
       ( ( x .x. ( y .+ z ) ) = ( ( x .x. y ) .+ ( x .x. z ) )
      /\ ( ( x .+ y ) .x. z ) = ( ( x .x. z ) .+ ( y .x. z ) ) ) ) ) $=
      ( wcel cv co wceq wa wral cfv cvv vr vp vt vb crg cgrp cmnd w3a cmgp wsbc
      cmulr cplusg cbs fveq2 syl6eqr eleq1d fvex a1i simpl fveq2d simpllr simpr
      simpll eqidd simplr oveqd eqeq12d anbi12d raleqbidv sbcied2 df-rng elrab2
      oveq123d 3anass bitr4i ) FUEMFUFMZHUGMZANZBNZCNZEOZGOZVRVSGOZVRVTGOZEOZPZ
      VRVSEOZVTGOZWDVSVTGOZEOZPZQZCDRZBDRZADRZQZQVPVQWOUHUANZUISZUGMZVRVSVTUBNZ
      OZUCNZOZVRVSXBOZVRVTXBOZWTOZPZVRVSWTOZVTXBOZXEVSVTXBOZWTOZPZQZCUDNZRZBXNR
      ZAXNRZUCWQUKSZUJZUBWQULSZUJZUDWQUMSZUJZQWPUAFUFUEWQFPZWSVQYCWOYDWRHUGYDWR
      FUISHWQFUIUNJUOUPYDYAWOUDYBDTYBTMYDWQUMUQURYDYBFUMSDWQFUMUNIUOYDXNDPZQZXS
      WOUBXTETXTTMYFWQULUQURYFXTFULSEYFWQFULYDYEUSUTKUOYFWTEPZQZXQWOUCXRGTXRTMY
      HWQUKUQURYHXRFUKSGYHWQFUKYDYEYGVCUTLUOYHXBGPZQZXPWNAXNDYDYEYGYIVAZYJXOWMB
      XNDYKYJXMWLCXNDYKYJXGWFXLWKYJXCWBXFWEYJVRVRXAWAXBGYHYIVBZYJVRVDYJWTEVSVTY
      FYGYIVEZVFVMYJXDWCXEWDWTEYMYJXBGVRVSYLVFYJXBGVRVTYLVFZVMVGYJXIWHXKWJYJXHW
      GVTVTXBGYLYJWTEVRVSYMVFYJVTVDVMYJXEWDXJWIWTEYMYNYJXBGVSVTYLVFVMVGVHVIVIVI
      VJVJVJVHABCUCUAUDUBVKVLVPVQWOVNVO $.
  $}

  ${
    $d r G $.  $d r x y z R $.
    $( A ring is a group.  (Contributed by NM, 15-Sep-2011.) $)
    rnggrp $p |- ( R e. Ring -> R e. Grp ) $=
      ( vx vy vz crg wcel cgrp cmgp cfv cmnd cv cplusg cmulr wceq cbs wral eqid
      co wa isrng simp1bi ) AEFAGFAHIZJFBKZCKZDKZALIZRAMIZRUCUDUGRUCUEUGRZUFRNU
      CUDUFRUEUGRUHUDUEUGRUFRNSDAOIZPCUIPBUIPBCDUIUFAUGUBUIQUBQUFQUGQTUA $.

    rngmgp.g $e |- G = ( mulGrp ` R ) $.
    $( A ring is a monoid under multiplication.  (Contributed by Mario
       Carneiro, 6-Jan-2015.) $)
    rngmgp $p |- ( R e. Ring -> G e. Mnd ) $=
      ( vx vy vz crg wcel cgrp cmnd cv cplusg cfv co cmulr wceq cbs wral eqid
      wa isrng simp2bi ) AGHAIHBJHDKZEKZFKZALMZNAOMZNUCUDUGNUCUEUGNZUFNPUCUDUFN
      UEUGNUHUDUEUGNUFNPTFAQMZREUIRDUIRDEFUIUFAUGBUISCUFSUGSUAUB $.

    $( A commutative ring is a ring whose multiplication is a commutative
       monoid.  (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    iscrng $p |- ( R e. CRing <-> ( R e. Ring /\ G e. CMnd ) ) $=
      ( vr cv cmgp cfv ccmn wcel ccrg wceq fveq2 syl6eqr eleq1d df-cring elrab2
      crg ) DEZFGZHIBHIDAQJRAKZSBHTSAFGBRAFLCMNDOP $.

    $( A commutative ring's multiplication operation is commutative.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    crngmgp $p |- ( R e. CRing -> G e. CMnd ) $=
      ( ccrg wcel crg ccmn iscrng simprbi ) ADEAFEBGEABCHI $.
  $}

  $( A ring is a monoid under addition.  (Contributed by Mario Carneiro,
     7-Jan-2015.) $)
  rngmnd $p |- ( R e. Ring -> R e. Mnd ) $=
    ( crg wcel cgrp cmnd rnggrp grpmnd syl ) ABCADCAECAFAGH $.

  $( A commutative ring is a ring.  (Contributed by Mario Carneiro,
     7-Jan-2015.) $)
  crngrng $p |- ( R e. CRing -> R e. Ring ) $=
    ( ccrg wcel crg cmgp cfv ccmn eqid iscrng simplbi ) ABCADCAEFZGCAKKHIJ $.

  $( Restricted functionality of the multiplicative group on rings.
     (Contributed by Mario Carneiro, 11-Mar-2015.) $)
  mgpf $p |- ( mulGrp |` Ring ) : Ring --> Mnd $=
    ( va crg cmnd cmgp cres wf wfn cv cfv wcel wral cvv wss fnmgp fnssres mp2an
    ssv fvres eqid rngmgp eqeltrd rgen ffnfv mpbir2an ) BCDBEZFUEBGZAHZUEIZCJZA
    BKDLGBLMUFNBQLBDOPUIABUGBJUHUGDIZCUGBDRUGUJUJSTUAUBABCUEUCUD $.

  ${
    $d x y z B $.  $d x y z R $.  $d x y z .x. $.  $d x y z X $.  $d x y z Y $.
    $d x y z .+ $.  $d x y z Z $.
    rngi.b $e |- B = ( Base ` R ) $.
    rngi.p $e |- .+ = ( +g ` R ) $.
    rngi.t $e |- .x. = ( .r ` R ) $.
    $( Properties of a unital ring.  (Contributed by NM, 26-Aug-2011.)
       (Revised by Mario Carneiro, 6-Jan-2015.) $)
    rngi $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. B /\ Z e. B ) )
           -> ( ( X .x. ( Y .+ Z ) ) = ( ( X .x. Y ) .+ ( X .x. Z ) )
                /\ ( ( X .+ Y ) .x. Z ) = ( ( X .x. Z ) .+ ( Y .x. Z ) ) ) ) $=
      ( vx vy vz wcel wa co wceq cv wral rsp crg w3a cgrp cmgp cfv cmnd simp3bi
      eqid isrng adantr simpr1 simpr2 simpr3 simpld caovdig simprd caovdirg jca
      sylc ) CUANZEANFANGANUBOEFGBPDPEFDPEGDPZBPQEFBPGDPVAFGDPBPQUTKLMEFGABDBAU
      TKRZANZLRZANZMRZANZUBZOZVBVDVFBPDPVBVDDPVBVFDPZBPQZVBVDBPVFDPVJVDVFDPBPQZ
      VIVKVLOZMASZVGVMVIVNLASZVEVNVIVOKASZVCVOUTVPVHUTCUCNCUDUEZUFNVPKLMABCDVQH
      VQUHIJUIUGUJUTVCVEVGUKVOKATUSUTVCVEVGULVNLATUSUTVCVEVGUMVMMATUSZUNUOUTKLM
      EFGABDBAVIVKVLVRUPUQUR $.
  $}

  ${
    rngcl.b $e |- B = ( Base ` R ) $.
    rngcl.t $e |- .x. = ( .r ` R ) $.
    $( Closure of the multiplication operation of a ring.  (Contributed by NM,
       26-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    rngcl $p |- ( ( R e. Ring /\ X e. B /\ Y e. B ) -> ( X .x. Y ) e. B ) $=
      ( crg wcel cmgp cfv cmnd co eqid rngmgp mgpbas mgpplusg mndcl syl3an1 ) B
      HIBJKZLIDAIEAIDECMAIBTTNZOACTDEABTUAFPBCTUAGQRS $.

    $( A commutative ring's multiplication operation is commutative.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    crngcom $p |- ( ( R e. CRing /\ X e. B /\ Y e. B ) ->
      ( X .x. Y ) = ( Y .x. X ) ) $=
      ( ccrg wcel cmgp ccmn co wceq eqid crngmgp mgpbas mgpplusg cmncom syl3an1
      cfv ) BHIBJTZKIDAIEAIDECLEDCLMBUAUANZOACUADEABUAUBFPBCUAUBGQRS $.

    $d x y B $.  $d x y R $.
    $( A commutative ring is a ring whose multiplication is a commutative
       monoid.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    iscrng2 $p |- ( R e. CRing <-> ( R e. Ring /\
        A. x e. B A. y e. B ( x .x. y ) = ( y .x. x ) ) ) $=
      ( ccrg wcel crg cmgp cfv ccmn wa cv co wceq wral eqid iscrng rngmgp iscmn
      cmnd wb mgpbas mgpplusg baib syl pm5.32i bitri ) DHIDJIZDKLZMIZNUKAOZBOZE
      PUOUNEPQBCRACRZNDULULSZTUKUMUPUKULUCIZUMUPUDDULUQUAUMURUPABCEULCDULUQFUED
      EULUQGUFUBUGUHUIUJ $.

    $( Associative law for the multiplication operation of a ring.
       (Contributed by NM, 27-Aug-2011.)  (Revised by Mario Carneiro,
       6-Jan-2015.) $)
    rngass $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                      ( ( X .x. Y ) .x. Z ) = ( X .x. ( Y .x. Z ) ) ) $=
      ( crg wcel cmgp cfv cmnd w3a co wceq eqid rngmgp mgpbas mgpplusg mndass
      sylan ) BIJBKLZMJDAJEAJFAJNDECOFCODEFCOCOPBUCUCQZRACUCDEFABUCUDGSBCUCUDHT
      UAUB $.

    $d u x B $.  $d u x R $.  $d u x .x. $.
    $( The unit element of a ring is unique.  (Contributed by NM,
       27-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    rngideu $p |- ( R e. Ring ->
                E! u e. B A. x e. B ( ( u .x. x ) = x /\ ( x .x. u ) = x ) ) $=
      ( crg wcel cmgp cfv cmnd cv co wceq wa wral wreu eqid rngmgp mgpplusg syl
      mgpbas mndideu ) DHIDJKZLIBMZAMZENUGOUGUFENUGOPACQBCRDUEUESZTABCEUECDUEUH
      FUCDEUEUHGUAUDUB $.
  $}

  ${
    rngdi.b $e |- B = ( Base ` R ) $.
    rngdi.p $e |- .+ = ( +g ` R ) $.
    rngdi.t $e |- .x. = ( .r ` R ) $.
    $( Distributive law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    rngdi $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                     ( X .x. ( Y .+ Z ) ) = ( ( X .x. Y ) .+ ( X .x. Z ) ) ) $=
      ( crg wcel w3a wa co wceq rngi simpld ) CKLEALFALGALMNEFGBODOEFDOEGDOZBOP
      EFBOGDOSFGDOBOPABCDEFGHIJQR $.

    $( Distributive law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.) $)
    rngdir $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                     ( ( X .+ Y ) .x. Z ) = ( ( X .x. Z ) .+ ( Y .x. Z ) ) ) $=
      ( crg wcel w3a wa co wceq rngi simprd ) CKLEALFALGALMNEFGBODOEFDOEGDOZBOP
      EFBOGDOSFGDOBOPABCDEFGHIJQR $.
  $}

  ${
    rngidcl.b $e |- B = ( Base ` R ) $.
    rngidcl.u $e |- .1. = ( 1r ` R ) $.
    $( The unit element of a ring belongs to the base set of the ring.
       (Contributed by NM, 27-Aug-2011.)  (Revised by Mario Carneiro,
       27-Dec-2014.) $)
    rngidcl $p |- ( R e. Ring -> .1. e. B ) $=
      ( crg wcel cmgp cfv cmnd eqid rngmgp mgpbas rngidval mndidcl syl ) BFGBHI
      ZJGCAGBQQKZLAQCABQRDMBCQRENOP $.
  $}

  ${
    rng0cl.b $e |- B = ( Base ` R ) $.
    rng0cl.z $e |- .0. = ( 0g ` R ) $.
    $( The zero element of a ring belongs to its base set.  (Contributed by
       Mario Carneiro, 12-Jan-2014.) $)
    rng0cl $p |- ( R e. Ring -> .0. e. B ) $=
      ( crg wcel cgrp rnggrp grpidcl syl ) BFGBHGCAGBIABCDEJK $.
  $}

  ${
    $d x y B $.  $d x y I $.  $d x y R $.  $d x y .x. $.  $d x y .1. $.
    rngidm.b $e |- B = ( Base ` R ) $.
    rngidm.t $e |- .x. = ( .r ` R ) $.
    rngidm.u $e |- .1. = ( 1r ` R ) $.
    $( Lemma for ~ rnglidm and ~ rngridm .  (Contributed by NM, 15-Sep-2011.)
       (Revised by Mario Carneiro, 27-Dec-2014.) $)
    rngidmlem $p |- ( ( R e. Ring /\ X e. B )
           -> ( ( .1. .x. X ) = X /\ ( X .x. .1. ) = X ) ) $=
      ( crg wcel cmgp cfv cmnd co wceq wa eqid rngmgp mgpbas mgpplusg rngidval
      mndlrid sylan ) BIJBKLZMJEAJDECNEOEDCNEOPBUDUDQZRACUDEDABUDUEFSBCUDUEGTBD
      UDUEHUAUBUC $.

    $( The unit element of a ring is a left multiplicative identity.
       (Contributed by NM, 15-Sep-2011.) $)
    rnglidm $p |- ( ( R e. Ring /\ X e. B ) -> ( .1. .x. X ) = X ) $=
      ( crg wcel wa co wceq rngidmlem simpld ) BIJEAJKDECLEMEDCLEMABCDEFGHNO $.

    $( The unit element of a ring is a right multiplicative identity.
       (Contributed by NM, 15-Sep-2011.) $)
    rngridm $p |- ( ( R e. Ring /\ X e. B ) -> ( X .x. .1. ) = X ) $=
      ( crg wcel wa co wceq rngidmlem simprd ) BIJEAJKDECLEMEDCLEMABCDEFGHNO $.

    $( Properties showing that an element ` I ` is the unity element of a
       ring.  (Contributed by NM, 7-Aug-2013.) $)
    isrngid $p |- ( R e. Ring
      -> ( ( I e. B /\ A. x e. B ( ( I .x. x ) = x /\ ( x .x. I ) = x ) )
        <-> .1. = I ) ) $=
      ( vy crg wcel cmgp cfv eqid mgpbas rngidval cv co wceq mgpplusg wral wreu
      wa wrex rngideu reurex syl ismgmid ) CKLZABDFJCMNZEBCUKUKOZGPCEUKULIQCDUK
      ULHUAUJJRZARZDSUNTUNUMDSUNTUDABUBZJBUCUOJBUEAJBCDGHUFUOJBUGUHUI $.
  $}

  ${
    $d y A $.  $d y B $.  $d y M $.  $d y .1. $.  $d y R $.
    rngidss.g $e |- M = ( ( mulGrp ` R ) |`s A ) $.
    rngidss.b $e |- B = ( Base ` R ) $.
    rngidss.u $e |- .1. = ( 1r ` R ) $.
    $( A subset of the multiplicative group has the multiplicative identity as
       its identity if the identity is in the subset.  (Contributed by Mario
       Carneiro, 27-Dec-2014.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    rngidss $p |- ( ( R e. Ring /\ A C_ B /\ .1. e. A ) ->
      .1. = ( 0g ` M ) ) $=
      ( vy wcel cbs cfv eqid wceq co cvv oveqd 3ad2antl1 eqtr3d syldan crg cmgp
      wss w3a cplusg c0g simp3 mgpbas ressbas2 3ad2ant2 eleqtrd cv simp2 sselda
      eqsstr3d wa cmulr fvex syl6eqel mgpplusg ressplusg adantr rnglidm rngridm
      syl ismgmid2 ) CUAJZABUCZDAJZUDZIEKLZEUELZDEEUFLZVKMVMMVLMVJDAVKVGVHVIUGV
      HVGAVKNVIABECUBLZFBCVNVNMZGUHUIUJZUKVJIULZVKJZVQBJZDVQVLOZVQNVJVKBVQVJVKA
      BVPVGVHVIUMUOUNZVJVSUPZDVQCUQLZOZVTVQWBWCVLDVQVJWCVLNZVSVJAPJWEVJAVKPVPEK
      URUSAWCVNEPFCWCVNVOWCMZUTVAVEVBZQVGVHVSWDVQNVIBCWCDVQGWFHVCRSTVJVRVSVQDVL
      OZVQNWAWBVQDWCOZWHVQWBWCVLVQDWGQVGVHVSWIVQNVIBCWCDVQGWFHVDRSTVF $.
  $}

  ${
    rngacl.b $e |- B = ( Base ` R ) $.
    rngacl.p $e |- .+ = ( +g ` R ) $.
    $( Closure of the addition operation of a ring.  (Contributed by Mario
       Carneiro, 14-Jan-2014.) $)
    rngacl $p |- ( ( R e. Ring /\ X e. B /\ Y e. B ) -> ( X .+ Y ) e. B ) $=
      ( crg wcel cgrp co rnggrp grpcl syl3an1 ) CHICJIDAIEAIDEBKAICLABCDEFGMN
      $.

    $( Commutativity of the additive group of a ring.  (See also ~ lmodcom .)
       (Contributed by G&eacute;rard Lang, 4-Dec-2014.) $)
    rngcom $p |- ( ( R e. Ring /\ X e. B /\ Y e. B ) ->
      ( X .+ Y ) = ( Y .+ X ) ) $=
      ( wcel co wceq cfv rngacl syl3anc syl13anc rngdir rnglidm syl2anc oveq12d
      eqid grpass crg w3a cur cmulr simp1 rngidcl syl simp2 simp3 rngdi 3eqtr3d
      eqtr3d eqtrd cgrp rnggrp 3eqtr4d wb grprcan mpbid 3com23 grplcan ) CUAHZD
      AHZEAHZUBZDDEBIZBIZDEDBIZBIZJZVFVHJZVEDDBIZEBIZVFDBIZVGVIVEVMEBIZVNEBIZJZ
      VMVNJZVEVLEEBIZBIZVFVFBIZVOVPVECUCKZWBBIZDCUDKZIZWCEWDIZBIZWBVFWDIZWHBIZV
      TWAVEWCVFWDIZWGWIVEVBWCAHZVCVDWJWGJVBVCVDUEZVEVBWBAHZWMWKWLVEVBWMWLACWBFW
      BSZUFUGZWOABCWBWBFGLMVBVCVDUHZVBVCVDUIZABCWDWCDEFGWDSZUJNVEVBWMWMVFAHZWJW
      IJWLWOWOABCDEFGLZABCWDWBWBVFFGWRONULVEWEVLWFVSBVEWEWBDWDIZXABIZVLVEVBWMWM
      VCWEXBJWLWOWOWPABCWDWBWBDFGWRONVEXADXADBVEVBVCXADJWLWPACWDWBDFWRWNPQZXCRU
      MVEWFWBEWDIZXDBIZVSVEVBWMWMVDWFXEJWLWOWOWQABCWDWBWBEFGWRONVEXDEXDEBVEVBVD
      XDEJWLWQACWDWBEFWRWNPQZXFRUMRVEWHVFWHVFBVEVBWSWHVFJWLWTACWDWBVFFWRWNPQZXG
      RUKVECUNHZVLAHZVDVDVOVTJVEVBXHWLCUOUGZVEVBVCVCXIWLWPWPABCDDFGLMZWQWQABCVL
      EEFGTNVEXHWSVCVDVPWAJXJWTWPWQABCVFDEFGTNUPVEXHVMAHZVNAHZVDVQVRUQXJVEVBXIV
      DXLWLXKWQABCVLEFGLMVEVBWSVCXMWLWTWPABCVFDFGLMWQABCVMVNEFGURNUSVEXHVCVCVDV
      MVGJXJWPWPWQABCDDEFGTNVEXHVCVDVCVNVIJXJWPWQWPABCDEDFGTNUKVEXHWSVHAHZVCVJV
      KUQXJWTVBVDVCXNABCEDFGLUTWPABCVFVHDFGVANUS $.
  $}

  ${
    $d x y R $.
    $( A ring is an Abelian group.  (Contributed by NM, 26-Aug-2011.) $)
    rngabl $p |- ( R e. Ring -> R e. Abel ) $=
      ( vx vy crg wcel cbs cfv cplusg eqidd rnggrp cv eqid rngcom isabld ) ADEZ
      BCAFGZAHGZAOPIOQIAJPQABKCKPLQLMN $.
  $}

  $( A ring is a commutative monoid.  (Contributed by Mario Carneiro,
     7-Jan-2015.) $)
  rngcmn $p |- ( R e. Ring -> R e. CMnd ) $=
    ( crg wcel cabel ccmn rngabl ablcmn syl ) ABCADCAECAFAGH $.

  ${
    $d s u v w x y B $.  $d s u v w x y K $.  $d s u v w x y ph $.
    $d s u v w x y L $.
    rngpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    rngpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    rngpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    rngpropd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( If two structures have the same group components (properties), one is a
       ring iff the other one is.  (Contributed by Mario Carneiro,
       6-Dec-2014.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
    rngpropd $p |- ( ph -> ( K e. Ring <-> L e. Ring ) ) $=
      ( vu vv vw wcel cfv co wceq wa wral proplem cgrp cmgp cv cplusg cmulr cbs
      cmnd w3a crg simpll simprll simplrl simprlr ad2antrr eleqtrd simprr grpcl
      eqid syl3anc eleqtrrd syl12anc oveq2d eqtrd simplrr mgpbas mgpplusg mndcl
      oveq12d eqeq12d oveq1d anbi12d anassrs 2ralbidva adantr raleqdv raleqbidv
      wb ralbidva 3bitr3d pm5.32da df-3an 3bitr4g grppropd syl6eq oveqi 3eqtr3g
      mndpropd 3anbi12d bitrd isrng ) AEUANZEUBOZUGNZKUCZLUCZMUCZEUDOZPZEUEOZPZ
      WNWOWSPZWNWPWSPZWQPZQZWNWOWQPZWPWSPZXBWOWPWSPZWQPZQZRZMEUFOZSZLXKSZKXKSZU
      HZFUANZFUBOZUGNZWNWOWPFUDOZPZFUEOZPZWNWOYAPZWNWPYAPZXSPZQZWNWOXSPZWPYAPZY
      DWOWPYAPZXSPZQZRZMFUFOZSZLYMSZKYMSZUHZEUINFUINAXOWKWMYPUHZYQAWKWMRZXNRYSY
      PRXOYRAYSXNYPAYSRZXJMDSZLDSZKDSYLMDSZLDSZKDSXNYPYTUUAUUCKLDDYTWNDNZWODNZR
      ZRXJYLMDYTUUGWPDNZXJYLVQYTUUGUUHRZRZXDYFXIYKUUJWTYBXCYEUUJWTWNWRYAPZYBUUJ
      AUUEWRDNWTUUKQAYSUUIUJZYTUUEUUFUUHUKZUUJWRXKDUUJWKWOXKNZWPXKNZWRXKNAWKWMU
      UIULZUUJWODXKYTUUEUUFUUHUMZADXKQZYSUUIGUNZUOZUUJWPDXKYTUUGUUHUPZUUSUOZXKW
      QEWOWPXKURZWQURZUQUSUUSUTABCDDWSYAWNWRJTVAUUJWRXTWNYAUUJAUUFUUHWRXTQUULUU
      QUVAABCDDWQXSWOWPITVAVBVCUUJXCXAXBXSPZYEUUJAXADNXBDNZXCUVEQUULUUJXAXKDUUJ
      WMWNXKNZUUNXAXKNAWKWMUUIVDZUUJWNDXKUUMUUSUOZUUTXKWSWLWNWOXKEWLWLURZUVCVEZ
      EWSWLUVJWSURZVFZVGUSUUSUTUUJXBXKDUUJWMUVGUUOXBXKNUVHUVIUVBXKWSWLWNWPUVKUV
      MVGUSUUSUTZABCDDWQXSXAXBITVAUUJXAYCXBYDXSUUJAUUEUUFXAYCQUULUUMUUQABCDDWSY
      AWNWOJTVAUUJAUUEUUHXBYDQUULUUMUVAABCDDWSYAWNWPJTVAZVHVCVIUUJXFYHXHYJUUJXF
      XEWPYAPZYHUUJAXEDNUUHXFUVPQUULUUJXEXKDUUJWKUVGUUNXEXKNUUPUVIUUTXKWQEWNWOU
      VCUVDUQUSUUSUTUVAABCDDWSYAXEWPJTVAUUJXEYGWPYAUUJAUUEUUFXEYGQUULUUMUUQABCD
      DWQXSWNWOITVAVJVCUUJXHXBXGXSPZYJUUJAUVFXGDNXHUVQQUULUVNUUJXGXKDUUJWMUUNUU
      OXGXKNUVHUUTUVBXKWSWLWOWPUVKUVMVGUSUUSUTABCDDWQXSXBXGITVAUUJXBYDXGYIXSUVO
      UUJAUUFUUHXGYIQUULUUQUVAABCDDWSYAWOWPJTVAVHVCVIVKVLVRVMYTUUBXMKDXKAUURYSG
      VNZYTUUAXLLDXKUVRYTXJMDXKUVRVOVPVPYTUUDYOKDYMADYMQYSHVNZYTUUCYNLDYMUVSYTY
      LMDYMUVSVOVPVPVSVTWKWMXNWAWKWMYPWAWBAWKXPWMXRYPABCDEFGHIWCABCDWLXQADXKWLU
      FOGUVKWDADYMXQUFOHYMFXQXQURZYMURZVEWDABUCZDNCUCZDNRRUWBUWCWSPUWBUWCYAPUWB
      UWCWLUDOZPUWBUWCXQUDOZPJWSUWDUWBUWCUVMWEYAUWEUWBUWCFYAXQUVTYAURZVFWEWFWGW
      HWIKLMXKWQEWSWLUVCUVJUVDUVLWJKLMYMXSFYAXQUWAUVTXSURUWFWJWB $.

    $( If two structures have the same group components (properties), one is a
       commutative ring iff the other one is.  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    crngpropd $p |- ( ph -> ( K e. CRing <-> L e. CRing ) ) $=
      ( crg wcel cmgp cfv ccmn wa ccrg cbs eqid co rngpropd mgpbas syl6eq cmulr
      cv cplusg mgpplusg oveqi 3eqtr3g cmnpropd anbi12d iscrng 3bitr4g ) AEKLZE
      MNZOLZPFKLZFMNZOLZPEQLFQLAUNUQUPUSABCDEFGHIJUAABCDUOURADERNZUORNGUTEUOUOS
      ZUTSUBUCADFRNZURRNHVBFURURSZVBSUBUCABUEZDLCUEZDLPPVDVEEUDNZTVDVEFUDNZTVDV
      EUOUFNZTVDVEURUFNZTJVFVHVDVEEVFUOVAVFSUGUHVGVIVDVEFVGURVCVGSUGUHUIUJUKEUO
      VAULFURVCULUM $.
  $}

  ${
    $d x y K $.  $d x y L $.
    rngprop.b $e |- ( Base ` K ) = ( Base ` L ) $.
    rngprop.p $e |- ( +g ` K ) = ( +g ` L ) $.
    rngprop.m $e |- ( .r ` K ) = ( .r ` L ) $.
    $( If two structures have the same ring components (properties), one is a
       ring iff the other one is.  (Contributed by Mario Carneiro,
       11-Oct-2013.) $)
    rngprop $p |- ( K e. Ring <-> L e. Ring ) $=
      ( vx vy crg wcel wtru cbs cfv wceq a1i cv cplusg co wa oveqi cmulr eqidd
      wb rngpropd trud ) AHIBHIUBJFGAKLZABJUEUAUEBKLMJCNFOZGOZAPLZQUFUGBPLZQMJU
      FUEIUGUEIRRZUHUIUFUGDSNUFUGATLZQUFUGBTLZQMUJUKULUFUGESNUCUD $.
  $}

  ${
    $d u x .1. $.  $d u x y z B $.  $d u x y z ph $.  $d u x y z R $.
    $d u .x. $.
    isrngd.b $e |- ( ph -> B = ( Base ` R ) ) $.
    isrngd.p $e |- ( ph -> .+ = ( +g ` R ) ) $.
    isrngd.t $e |- ( ph -> .x. = ( .r ` R ) ) $.
    isrngd.g $e |- ( ph -> R e. Grp ) $.
    isrngd.c $e |- ( ( ph /\ x e. B /\ y e. B ) -> ( x .x. y ) e. B ) $.
    isrngd.a $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) ) ->
                  ( ( x .x. y ) .x. z ) = ( x .x. ( y .x. z ) ) ) $.
    isrngd.d $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) ) ->
                  ( x .x. ( y .+ z ) ) = ( ( x .x. y ) .+ ( x .x. z ) ) ) $.
    isrngd.e $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. B ) ) ->
                  ( ( x .+ y ) .x. z ) = ( ( x .x. z ) .+ ( y .x. z ) ) ) $.
    isrngd.u $e |- ( ph -> .1. e. B ) $.
    isrngd.i $e |- ( ( ph /\ x e. B ) -> ( .1. .x. x ) = x ) $.
    isrngd.h $e |- ( ( ph /\ x e. B ) -> ( x .x. .1. ) = x ) $.
    $( Properties that determine a ring.  (Contributed by NM, 2-Aug-2013.) $)
    isrngd $p |- ( ph -> R e. Ring ) $=
      ( cgrp wcel cmgp cfv cmnd cv cplusg co cmulr wceq wa cbs wral eqid mgpbas
      crg syl6eq mgpplusg ismndd eleq2d 3anbi123d biimpar adantr eqidd proplem3
      w3a oveq123d 3eqtr3d jca syldan ralrimivvva isrng syl3anbrc ) AGUAUBGUCUD
      ZUEUBBUFZCUFZDUFZGUGUDZUHZGUIUDZUHZVOVPVTUHZVOVQVTUHZVRUHZUJZVOVPVRUHZVQV
      TUHZWCVPVQVTUHZVRUHZUJZUKZDGULUDZUMCWLUMBWLUMGUPUBMABCDEHVNIAEWLVNULUDJWL
      GVNVNUNZWLUNZUOUQAHVTVNUGUDLGVTVNWMVTUNZURUQNORSTUSAWKBCDWLWLWLAVOWLUBZVP
      WLUBZVQWLUBZVFZVOEUBZVPEUBZVQEUBZVFZWKAXCWSAWTWPXAWQXBWRAEWLVOJUTAEWLVPJU
      TAEWLVQJUTVAVBAXCUKZWEWJXDVOVPVQFUHZHUHVOVPHUHZVOVQHUHZFUHWAWDPXDVOVOXEVS
      HVTAHVTUJXCLVCZXDVOVDAXCCDFVRKVEVGXDXFWBXGWCFVRAFVRUJXCKVCZAXCBCHVTLVEAXC
      BDHVTLVEZVGVHXDVOVPFUHZVQHUHXGVPVQHUHZFUHWGWIQXDXKWFVQVQHVTXHAXCBCFVRKVEX
      DVQVDVGXDXGWCXLWHFVRXIXJAXCCDHVTLVEVGVHVIVJVKBCDWLVRGVTVNWNWMVRUNWOVLVM
      $.

    iscrngd.c $e |- ( ( ph /\ x e. B /\ y e. B ) ->
      ( x .x. y ) = ( y .x. x ) ) $.
    $( Properties that determine a commutative ring.  (Contributed by Mario
       Carneiro, 7-Jan-2015.) $)
    iscrngd $p |- ( ph -> R e. CRing ) $=
      ( crg wcel cmgp ccmn ccrg isrngd eqid mgpbas syl6eq cmulr cplusg mgpplusg
      cfv cbs ismndd iscmnd iscrng sylanbrc ) AGUBUCGUDUNZUEUCGUFUCABCDEFGHIJKL
      MNOPQRSTUGABCEHUTAEGUOUNZUTUOUNJVAGUTUTUHZVAUHUIUJZAHGUKUNZUTULUNLGVDUTVB
      VDUHUMUJZABCDEHUTIVCVENORSTUPUAUQGUTVBURUS $.
  $}

  ${
    rngz.b $e |- B = ( Base ` R ) $.
    rngz.t $e |- .x. = ( .r ` R ) $.
    rngz.z $e |- .0. = ( 0g ` R ) $.
    $( The zero of a unital ring is a left absorbing element.  (Contributed by
       FL, 31-Aug-2009.) $)
    rnglz $p |- ( ( R e. Ring /\ X e. B ) -> ( .0. .x. X ) = .0. ) $=
      ( crg wcel wa co cplusg cfv wceq cgrp rnggrp grpidcl syl adantr mpdan w3a
      eqid grplid oveq1d simpr rngdir syldan simpl rngcl syl3anc grprid syl2anc
      3jca eqcomd 3eqtr3d wb grplcan syl13anc mpbid ) BIJZDAJZKZEDCLZVDBMNZLZVD
      EVELZOZVDEOZVCEEVELZDCLZVDVFVGVCVJEDCVAVJEOZVBVABPJZVLBQZVMEAJZVLABEFHRZA
      VEBEEFVEUCZHUDUASTUEVAVBVOVOVBUBVKVFOVCVOVOVBVAVOVBVAVMVOVNVPSTZVRVAVBUFZ
      UNAVEBCEEDFVQGUGUHVCVMVDAJZVDVGOVAVMVBVNTZVCVAVOVBVTVAVBUIVRVSABCEDFGUJUK
      ZVMVTKVGVDAVEBVDEFVQHULUOUMUPVCVMVTVOVTVHVIUQWAWBVRWBAVEBVDEVDFVQURUSUT
      $.

    $( The zero of a unital ring is a right absorbing element.  (Contributed by
       FL, 31-Aug-2009.) $)
    rngrz $p |- ( ( R e. Ring /\ X e. B ) -> ( X .x. .0. ) = .0. ) $=
      ( crg wcel wa co cplusg cfv wceq cgrp rnggrp grplid syl adantr eqid mpdan
      grpidcl oveq2d w3a simpr 3jca rngdi syldan mpd3an3 eqcomd syl2anc 3eqtr3d
      rngcl wb grprcan syl13anc mpbid ) BIJZDAJZKZDECLZVBBMNZLZEVBVCLZOZVBEOZVA
      DEEVCLZCLZVBVDVEVAVHEDCUSVHEOZUTUSBPJZVJBQZVKEAJZVJABEFHUCZAVCBEEFVCUAZHR
      UBSTUDUSUTUTVMVMUEVIVDOVAUTVMVMUSUTUFUSVMUTUSVKVMVLVNSTZVPUGAVCBCDEEFVOGU
      HUIVAVKVBAJZVBVEOUSVKUTVLTZUSUTVMVQVPABCDEFGUNUJZVKVQKVEVBAVCBVBEFVOHRUKU
      LUMVAVKVQVMVQVFVGUOVRVSVPVSAVCBVBEVBFVOUPUQUR $.
  $}

  ${
    rng1eq0.b $e |- B = ( Base ` R ) $.
    rng1eq0.u $e |- .1. = ( 1r ` R ) $.
    rng1eq0.z $e |- .0. = ( 0g ` R ) $.
    $( If one and zero are equal, then any two elements of a ring are equal.
       Alternatively, every ring has one distinct from zero except the zero
       ring containing the single element ` { 0 } ` .  (Contributed by Mario
       Carneiro, 10-Sep-2014.) $)
    rng1eq0 $p |- ( ( R e. Ring /\ X e. B /\ Y e. B ) ->
      ( .1. = .0. -> X = Y ) ) $=
      ( crg wcel w3a wceq wa co oveq1d rnglz syl2anc eqtr4d rnglidm cmulr simpr
      cfv simpl1 simpl2 eqid simpl3 3eqtr3d ex ) BJKZDAKZEAKZLZCFMZDEMUMUNNZCDB
      UAUCZOZCEUPOZDEUOUQFDUPOZURUOCFDUPUMUNUBZPUOURFEUPOZUSUOCFEUPUTPUOUSFVAUO
      UJUKUSFMUJUKULUNUDZUJUKULUNUEZABUPDFGUPUFZIQRUOUJULVAFMVBUJUKULUNUGZABUPE
      FGVDIQRSSSUOUJUKUQDMVBVCABUPCDGVDHTRUOUJULUREMVBVEABUPCEGVDHTRUHUI $.
  $}

  ${
    rngnegl.b $e |- B = ( Base ` R ) $.
    rngnegl.t $e |- .x. = ( .r ` R ) $.
    rngnegl.u $e |- .1. = ( 1r ` R ) $.
    rngnegl.n $e |- N = ( invg ` R ) $.
    rngnegl.r $e |- ( ph -> R e. Ring ) $.
    rngnegl.x $e |- ( ph -> X e. B ) $.
    $( Negation in a ring is the same as left multiplication by -1.
       ( ~ rngonegmn1l analog.)  (Contributed by Jeff Madsen, 19-Jun-2010.)
       (Revised by Mario Carneiro, 2-Jul-2014.) $)
    rngnegl $p |- ( ph -> ( ( N ` .1. ) .x. X ) = ( N ` X ) ) $=
      ( cfv co wceq wcel syl syl2anc eqid cplusg c0g rngidcl cgrp rnggrp rngdir
      crg grpinvcl syl13anc grprinv oveq1d rnglz eqtrd rnglidm 3eqtr3rd syl3anc
      wb rngcl grpinvid1 mpbird eqcomd ) AGFNZEFNZGDOZAVBVDPZGVDCUANZOZCUBNZPZA
      EVCVFOZGDOZEGDOZVDVFOZVHVGACUGQZEBQZVCBQZGBQZVKVMPLAVNVOLBCEHJUCRZACUDQZV
      OVPAVNVSLCUERZVRBCFEHKUHSZMBVFCDEVCGHVFTZIUFUIAVKVHGDOZVHAVJVHGDAVSVOVJVH
      PVTVRBVFCFEVHHWBVHTZKUJSUKAVNVQWCVHPLMBCDGVHHIWDULSUMAVLGVDVFAVNVQVLGPLMB
      CDEGHIJUNSUKUOAVSVQVDBQZVEVIUQVTMAVNVPVQWELWAMBCDVCGHIURUPBVFCFGVDVHHWBWD
      KUSUPUTVA $.

    $( Negation in a ring is the same as right multiplication by -1.
       ( ~ rngonegmn1r analog.)  (Contributed by Jeff Madsen, 19-Jun-2010.)
       (Revised by Mario Carneiro, 2-Jul-2014.) $)
    rngnegr $p |- ( ph -> ( X .x. ( N ` .1. ) ) = ( N ` X ) ) $=
      ( cfv co wceq wcel syl syl2anc eqid cplusg c0g cgrp rnggrp grpinvcl rngdi
      crg rngidcl syl13anc grplinv oveq2d rngrz eqtrd rngridm 3eqtr3rd wb rngcl
      syl3anc grpinvid2 mpbird eqcomd ) AGFNZGEFNZDOZAVBVDPZVDGCUANZOZCUBNZPZAG
      VCEVFOZDOZVDGEDOZVFOZVHVGACUGQZGBQZVCBQZEBQZVKVMPLMACUCQZVQVPAVNVRLCUDRZA
      VNVQLBCEHJUHRZBCFEHKUESZVTBVFCDGVCEHVFTZIUFUIAVKGVHDOZVHAVJVHGDAVRVQVJVHP
      VSVTBVFCFEVHHWBVHTZKUJSUKAVNVOWCVHPLMBCDGVHHIWDULSUMAVLGVDVFAVNVOVLGPLMBC
      DEGHIJUNSUKUOAVRVOVDBQZVEVIUPVSMAVNVOVPWELMWABCDGVCHIUQURBVFCFGVDVHHWBWDK
      USURUTVA $.
  $}

  ${
    rngneglmul.b $e |- B = ( Base ` R ) $.
    rngneglmul.t $e |- .x. = ( .r ` R ) $.
    rngneglmul.n $e |- N = ( invg ` R ) $.
    rngneglmul.r $e |- ( ph -> R e. Ring ) $.
    rngneglmul.x $e |- ( ph -> X e. B ) $.
    rngneglmul.y $e |- ( ph -> Y e. B ) $.
    $( Negation of a product in a ring.  ( ~ mulneg1 analog.)  (Contributed by
       Jeff Madsen, 19-Jun-2010.)  (Revised by Mario Carneiro, 2-Jul-2014.) $)
    rngmneg1 $p |- ( ph -> ( ( N ` X ) .x. Y ) = ( N ` ( X .x. Y ) ) ) $=
      ( cur cfv co crg wcel syl rngnegl wceq cgrp eqid rngidcl grpinvcl syl2anc
      rnggrp rngass syl13anc oveq1d rngcl syl3anc 3eqtr3d ) ACNOZEOZFDPZGDPZUOF
      GDPZDPZFEOZGDPUREOACQRZUOBRZFBRZGBRZUQUSUAKACUBRZUNBRZVBAVAVEKCUGSAVAVFKB
      CUNHUNUCZUDSBCEUNHJUEUFLMBCDUOFGHIUHUIAUPUTGDABCDUNEFHIVGJKLTUJABCDUNEURH
      IVGJKAVAVCVDURBRKLMBCDFGHIUKULTUM $.

    $( Negation of a product in a ring.  ( ~ mulneg2 analog.)  (Contributed by
       Jeff Madsen, 19-Jun-2010.)  (Revised by Mario Carneiro, 2-Jul-2014.) $)
    rngmneg2 $p |- ( ph -> ( X .x. ( N ` Y ) ) = ( N ` ( X .x. Y ) ) ) $=
      ( co cur cfv crg wcel syl rngnegr wceq cgrp eqid rngidcl grpinvcl syl2anc
      rnggrp rngass syl13anc rngcl syl3anc oveq2d 3eqtr3rd ) AFGDNZCOPZEPZDNZFG
      UPDNZDNZUNEPFGEPZDNACQRZFBRZGBRZUPBRZUQUSUAKLMACUBRZUOBRZVDAVAVEKCUGSAVAV
      FKBCUOHUOUCZUDSBCEUOHJUEUFBCDFGUPHIUHUIABCDUOEUNHIVGJKAVAVBVCUNBRKLMBCDFG
      HIUJUKTAURUTFDABCDUOEGHIVGJKMTULUM $.

    $( Double negation of a product in a ring.  ( ~ mul2neg analog.)
       (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    rngm2neg $p |- ( ph -> ( ( N ` X ) .x. ( N ` Y ) ) = ( X .x. Y ) ) $=
      ( cfv co cgrp wcel crg rnggrp syl2anc syl grpinvcl rngmneg1 rngmneg2 wceq
      fveq2d rngcl syl3anc grpinvinv 3eqtrd ) AFENGENZDOFUKDOZENFGDOZENZENZUMAB
      CDEFUKHIJKLACPQZGBQZUKBQACRQZUPKCSUAZMBCEGHJUBTUCAULUNEABCDEFGHIJKLMUDUFA
      UPUMBQZUOUMUEUSAURFBQUQUTKLMBCDFGHIUGUHBCEUMHJUITUJ $.
  $}

  ${
    rngsubdi.b $e |- B = ( Base ` R ) $.
    rngsubdi.t $e |- .x. = ( .r ` R ) $.
    rngsubdi.m $e |- .- = ( -g ` R ) $.
    rngsubdi.r $e |- ( ph -> R e. Ring ) $.
    rngsubdi.x $e |- ( ph -> X e. B ) $.
    rngsubdi.y $e |- ( ph -> Y e. B ) $.
    rngsubdi.z $e |- ( ph -> Z e. B ) $.
    $( Ring multiplication distributes over subtraction.  ( ~ subdi analog.)
       (Contributed by Jeff Madsen, 19-Jun-2010.)  (Revised by Mario Carneiro,
       2-Jul-2014.) $)
    rngsubdi $p |- ( ph ->
      ( X .x. ( Y .- Z ) ) = ( ( X .x. Y ) .- ( X .x. Z ) ) ) $=
      ( cfv co wcel wceq syl2anc cminusg cplusg cgrp rnggrp eqid grpinvcl rngdi
      crg syl syl13anc rngmneg2 oveq2d eqtrd grpsubval rngcl syl3anc 3eqtr4d )
      AFGHCUAPZPZCUBPZQZDQZFGDQZFHDQZURPZUTQZFGHEQZDQVCVDEQZAVBVCFUSDQZUTQZVFAC
      UHRZFBRZGBRZUSBRZVBVJSLMNACUCRZHBRZVNAVKVOLCUDUIOBCURHIURUEZUFTBUTCDFGUSI
      UTUEZJUGUJAVIVEVCUTABCDURFHIJVQLMOUKULUMAVGVAFDAVMVPVGVASNOBUTCUREGHIVRVQ
      KUNTULAVCBRZVDBRZVHVFSAVKVLVMVSLMNBCDFGIJUOUPAVKVLVPVTLMOBCDFHIJUOUPBUTCU
      REVCVDIVRVQKUNTUQ $.

    $( Ring multiplication distributes over subtraction.  ( ~ subdir analog.)
       (Contributed by Jeff Madsen, 19-Jun-2010.)  (Revised by Mario Carneiro,
       2-Jul-2014.) $)
    rngsubdir $p |- ( ph ->
      ( ( X .- Y ) .x. Z ) = ( ( X .x. Z ) .- ( Y .x. Z ) ) ) $=
      ( cfv co wcel wceq syl2anc cminusg cplusg crg cgrp rnggrp syl eqid rngdir
      grpinvcl syl13anc rngmneg1 oveq2d eqtrd grpsubval oveq1d syl3anc 3eqtr4d
      rngcl ) AFGCUAPZPZCUBPZQZHDQZFHDQZGHDQZUSPZVAQZFGEQZHDQVDVEEQZAVCVDUTHDQZ
      VAQZVGACUCRZFBRZUTBRZHBRZVCVKSLMACUDRZGBRZVNAVLVPLCUEUFNBCUSGIUSUGZUITOBV
      ACDFUTHIVAUGZJUHUJAVJVFVDVAABCDUSGHIJVRLNOUKULUMAVHVBHDAVMVQVHVBSMNBVACUS
      EFGIVSVRKUNTUOAVDBRZVEBRZVIVGSAVLVMVOVTLMOBCDFHIJURUPAVLVQVOWALNOBCDGHIJU
      RUPBVACUSEVDVEIVSVRKUNTUQ $.
  $}

  ${
    $d x y B $.  $d x y R $.  $d x y .x. $.  $d x y .X. $.  $d x y X $.
    $d x N $.  $d x y Y $.
    mulgass2.b $e |- B = ( Base ` R ) $.
    mulgass2.m $e |- .x. = ( .g ` R ) $.
    mulgass2.t $e |- .X. = ( .r ` R ) $.
    $( An associative property between group multiple and ring multiplication.
       (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    mulgass2 $p |- ( ( R e. Ring /\ ( N e. ZZ /\ X e. B /\ Y e. B ) ) ->
      ( ( N .x. X ) .X. Y ) = ( N .x. ( X .X. Y ) ) ) $=
      ( wcel co wceq cc0 oveq1 oveq1d eqeq12d cfv adantr syl3anc vx vy cz wi cv
      crg cneg c1 caddc w3a c0g eqid rnglz 3adant3 simp3 mulg0 syl rngcl 3com23
      3eqtr4d cn0 wa cplusg cgrp simpl1 rnggrp nn0z adantl mulgp1 mulgcl simpl2
      3ad2ant1 rngdir syl13anc eqtrd syl5ibr ex cn cminusg nnz mulgneg rngmneg1
      fveq2 zindd 3exp com24 3imp2 ) BUFKZEUCKZFAKZGAKZEFCLZGDLZEFGDLZCLZMZWHWK
      WJWIWPWHWKWJWIWPUDUAUEZFCLZGDLZWQWNCLZMNFCLZGDLZNWNCLZMUBUEZFCLZGDLZXDWNC
      LZMZXDUGZFCLZGDLZXIWNCLZMZXDUHUILZFCLZGDLZXNWNCLZMZWPWHWKWJUJZUAUBEWQNMZW
      SXBWTXCXTWRXAGDWQNFCOPWQNWNCOQWQXDMZWSXFWTXGYAWRXEGDWQXDFCOPWQXDWNCOQWQXN
      MZWSXPWTXQYBWRXOGDWQXNFCOPWQXNWNCOQWQXIMZWSXKWTXLYCWRXJGDWQXIFCOPWQXIWNCO
      QWQEMZWSWMWTWOYDWRWLGDWQEFCOPWQEWNCOQXSBUKRZGDLZYEXBXCWHWKYFYEMWJABDGYEHJ
      YEULZUMUNXSXAYEGDXSWJXAYEMWHWKWJUOZACBFYEHYGIUPUQPXSWNAKZXCYEMWHWJWKYIABD
      FGHJURUSZACBWNYEHYGIUPUQUTXSXDVAKZXHXRUDXHXRXSYKVBZXFWNBVCRZLZXGWNYMLZMXF
      XGWNYMOYLXPYNXQYOYLXPXEFYMLZGDLZYNYLXOYPGDYLBVDKZXDUCKZWJXOYPMYLWHYRWHWKW
      JYKVEZBVFZUQZYKYSXSXDVGVHZXSWJYKYHSZAYMCBXDFHIYMULZVITPYLWHXEAKZWJWKYQYNM
      YTYLYRYSWJUUFXSYRYKWHWKYRWJUUAVLZSUUCUUDACBXDFHIVJZTUUDWHWKWJYKVKAYMBDXEF
      GHUUEJVMVNVOYLYRYSYIXQYOMUUBUUCXSYIYKYJSAYMCBXDWNHIUUEVITQVPVQXSXDVRKZXHX
      MUDXHXMXSUUIVBZXFBVSRZRZXGUUKRZMXFXGUUKWCUUJXKUULXLUUMUUJXKXEUUKRZGDLUULU
      UJXJUUNGDUUJYRYSWJXJUUNMXSYRUUIUUGSZUUIYSXSXDVTVHZXSWJUUIYHSZACBUUKXDFHIU
      UKULZWATPUUJABDUUKXEGHJUURWHWKWJUUIVEUUJYRYSWJUUFUUOUUPUUQUUHTWHWKWJUUIVK
      WBVOUUJYRYSYIXLUUMMUUOUUPXSYIUUIYJSACBUUKXDWNHIUURWATQVPVQWDWEWFWG $.
  $}

  ${
    $d x y z B $.  $d x y z R $.  $d x y z .x. $.  $d x y z X $.
    rnglghm.b $e |- B = ( Base ` R ) $.
    rnglghm.t $e |- .x. = ( .r ` R ) $.
    $( Left-multiplication in a ring by a fixed element of the ring is a group
       homomorphism.  (It is not usually a ring homomorphism.)  (Contributed by
       Mario Carneiro, 4-May-2015.) $)
    rnglghm $p |- ( ( R e. Ring /\ X e. B ) ->
      ( x e. B |-> ( X .x. x ) ) e. ( R GrpHom R ) ) $=
      ( vy vz crg wcel wa cfv cv co eqid wceq oveq2 ovex fvmpt cplusg cmpt cgrp
      rnggrp adantr rngcl 3expa fmptd w3a 3anass rngdi sylan2br anassrs adantlr
      rngacl 3expb syl oveqan12d adantl 3eqtr4d isghmd ) CJKZEBKZLZHICUAMZVECCA
      BEANZDOZUBZBBFFVEPZVIVBCUCKVCCUDUEZVJVDABVGBVHVBVCVFBKVGBKBCDEVFFGUFUGVHP
      ZUHVDHNZBKZINZBKZLZLZEVLVNVEOZDOZEVLDOZEVNDOZVEOZVRVHMZVLVHMZVNVHMZVEOZVB
      VCVPVSWBQZVCVPLVBVCVMVOUIWGVCVMVOUJBVECDEVLVNFVIGUKULUMVQVRBKZWCVSQVBVPWH
      VCVBVMVOWHBVECVLVNFVIUOUPUNAVRVGVSBVHVFVREDRVKEVRDSTUQVPWFWBQVDVMVOWDVTWE
      WAVEAVLVGVTBVHVFVLEDRVKEVLDSTAVNVGWABVHVFVNEDRVKEVNDSTURUSUTVA $.

    $( Right-multiplication in a ring by a fixed element of the ring is a group
       homomorphism.  (It is not usually a ring homomorphism.)  (Contributed by
       Mario Carneiro, 4-May-2015.) $)
    rngrghm $p |- ( ( R e. Ring /\ X e. B ) ->
      ( x e. B |-> ( x .x. X ) ) e. ( R GrpHom R ) ) $=
      ( vy vz crg wcel wa cfv cv co eqid wceq oveq1 ovex fvmpt cplusg cmpt cgrp
      rnggrp adantr rngcl 3expa an32s fmptd w3a df-3an rngdir sylan2br anass1rs
      rngacl 3expb adantlr syl oveqan12d adantl 3eqtr4d isghmd ) CJKZEBKZLZHICU
      AMZVFCCABANZEDOZUBZBBFFVFPZVJVCCUCKVDCUDUEZVKVEABVHBVIVCVGBKZVDVHBKZVCVLV
      DVMBCDVGEFGUFUGUHVIPZUIVEHNZBKZINZBKZLZLZVOVQVFOZEDOZVOEDOZVQEDOZVFOZWAVI
      MZVOVIMZVQVIMZVFOZVCVSVDWBWEQZVSVDLVCVPVRVDUJWJVPVRVDUKBVFCDVOVQEFVJGULUM
      UNVTWABKZWFWBQVCVSWKVDVCVPVRWKBVFCVOVQFVJUOUPUQAWAVHWBBVIVGWAEDRVNWAEDSTU
      RVSWIWEQVEVPVRWGWCWHWDVFAVOVHWCBVIVGVOEDRVNVOEDSTAVQVHWDBVIVGVQEDRVNVQEDS
      TUSUTVAVB $.
  $}

  ${
    $d k x y z A $.  $d k x y z B $.  $d k x y z ph $.  $d k x y z .x. $.
    $d x y z R $.  $d x y z X $.  $d k x y z Y $.  $d x y z .0. $.
    gsummulc1.b $e |- B = ( Base ` R ) $.
    gsummulc1.z $e |- .0. = ( 0g ` R ) $.
    gsummulc1.p $e |- .+ = ( +g ` R ) $.
    gsummulc1.t $e |- .x. = ( .r ` R ) $.
    gsummulc1.r $e |- ( ph -> R e. Ring ) $.
    gsummulc1.a $e |- ( ph -> A e. V ) $.
    gsummulc1.y $e |- ( ph -> Y e. B ) $.
    gsummulc1.x $e |- ( ( ph /\ k e. A ) -> X e. B ) $.
    gsummulc1.n $e |- ( ph ->
      ( `' ( k e. A |-> X ) " ( _V \ { .0. } ) ) e. Fin ) $.
    $( A finite ring sum multiplied by a constant.  (Contributed by Mario
       Carneiro, 19-Dec-2014.) $)
    gsummulc1 $p |- ( ph -> ( R gsum ( k e. A |-> ( X .x. Y ) ) ) =
      ( ( R gsum ( k e. A |-> X ) ) .x. Y ) ) $=
      ( vx cv co cmpt cgsu crg wcel ccmn rngcmn syl cmnd rngmnd rngrghm syl2anc
      cghm cmhm ghmmhm oveq1 gsummhm2 ) AUABCUAUBZJFUCZIJFUCGEGBIUDUEUCZJFUCEEH
      IKLMAEUFUGZEUHUGPEUIUJAVCEUKUGPEULUJQAUACVAUDZEEUOUCUGZVDEEUPUCUGAVCJCUGV
      EPRUACEFJLOUMUNEEVDUQUJSTUTIJFURUTVBJFURUS $.

    $( A finite ring sum multiplied by a constant.  (Contributed by Mario
       Carneiro, 19-Dec-2014.) $)
    gsummulc2 $p |- ( ph -> ( R gsum ( k e. A |-> ( Y .x. X ) ) ) =
      ( Y .x. ( R gsum ( k e. A |-> X ) ) ) ) $=
      ( vx cv co cmpt cgsu crg wcel ccmn rngcmn syl cmnd rngmnd rnglghm syl2anc
      cghm cmhm ghmmhm oveq2 gsummhm2 ) AUABCJUAUBZFUCZJIFUCGJEGBIUDUEUCZFUCEEH
      IKLMAEUFUGZEUHUGPEUIUJAVCEUKUGPEULUJQAUACVAUDZEEUOUCUGZVDEEUPUCUGAVCJCUGV
      EPRUACEFJLOUMUNEEVDUQUJSTUTIJFURUTVBJFURUS $.
  $}

  ${
    $d ph i j x y $.  $d B i j x y $.  $d I i j k x y $.  $d J i j k x y $.
    $d R i j k x $.  $d .x. i j k x y $.  $d V i $.  $d X i j k y $.
    $d Y i j k x $.  $d .0. i j $.
    gsumdixp.b $e |- B = ( Base ` R ) $.
    gsumdixp.t $e |- .x. = ( .r ` R ) $.
    gsumdixp.z $e |- .0. = ( 0g ` R ) $.
    gsumdixp.i $e |- ( ph -> I e. V ) $.
    gsumdixp.j $e |- ( ph -> J e. W ) $.
    gsumdixp.r $e |- ( ph -> R e. Ring ) $.
    gsumdixp.x $e |- ( ( ph /\ x e. I ) -> X e. B ) $.
    gsumdixp.y $e |- ( ( ph /\ y e. J ) -> Y e. B ) $.
    gsumdixp.xf $e |- ( ph ->
        ( `' ( x e. I |-> X ) " ( _V \ { .0. } ) ) e. Fin ) $.
    gsumdixp.yf $e |- ( ph ->
        ( `' ( y e. J |-> Y ) " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Distribute a binary product of sums to a sum of binary products in a
       ring.  (Contributed by Mario Carneiro, 8-Mar-2015.) $)
    gsumdixp $p |- ( ph ->
        ( ( R gsum ( x e. I |-> X ) ) .x. ( R gsum ( y e. J |-> Y ) ) ) =
          ( R gsum ( x e. I , y e. J |-> ( X .x. Y ) ) ) ) $=
      ( vi vj co cmpt2 cgsu cmpt cfv ccnv cvv csn cdif cima cxp crg wcel rngcmn
      cv ccmn syl adantr wa eqid fmptd simpl ffvelrn syl2an simpr rngcl syl3anc
      wf cfn xpfi syl2anc wbr wn wceq wo ianor brxp xchnxbir simprl eldif sylan
      biimpri wss ssid a1i syldan oveq1d rnglz eqtrd simprr oveq2d rngrz jaodan
      suppssr sylan2b anasss gsum2d2 nffvmpt1 nfcv nfov fveq2 oveqan12d cbvmpt2
      weq simp2 3adant3 fvmpt2 simp3 3adant2 oveq12d mpt2eq3dva syl5eq mpteq2dv
      w3a nfmpt cbvmpt syl6eq mpteq2dva 3eqtr3d cplusg adantlr gsummulc2 gsumcl
      3expa gsummulc1 3eqtrrd ) AEBCGHKLFUFZUGZUHUFZEBGECHYLUIZUHUFZUIZUHUFZEBG
      KECHLUIZUHUFZFUFZUIZUHUFEBGKUIZUHUFYTFUFAEUDUEGHUDUTZUUCUJZUEUTZYSUJZFUFZ
      UGZUHUFEUDGEUEHUUHUIZUHUFZUIZUHUFYNYRAGDHUUCUKULMUMUNZUOZYSUKUUMUOZUPZUDU
      EEIJUUHMNPAEUQURZEVAURSEUSVBZQAHJURZUUDGURZRVCAUUTUUFHURZVDZVDZUUQUUEDURZ
      UUGDURZUUHDURAUUQUVBSVCZAGDUUCVMZUUTUVDUVBABGKDUUCTUUCVEZVFZUUTUVAVGGDUUD
      UUCVHVIZAHDYSVMZUVAUVEUVBACHLDYSUAYSVEZVFZUUTUVAVJHDUUFYSVHVIZDEFUUEUUGNO
      VKVLAUUNVNURUUOVNURZUUPVNURUBUCUUNUUOVOVPAUVBUUDUUFUUPVQZVRZUUHMVSZUVQUVC
      UUDUUNURZVRZUUFUUOURZVRZVTZUVRUVSUWAVDUWCUVPUVSUWAWAUUDUUFUUNUUOWBWCUVCUV
      TUVRUWBUVCUVTVDZUUHMUUGFUFZMUWDUUEMUUGFUVCUVTUUDGUUNUNURZUUEMVSUVCUUTUVTU
      WFAUUTUVAWDUWFUUTUVTVDUUDGUUNWEWGWFUVCGDUUCUUNUUDMAUVGUVBUVIVCUUNUUNWHUVC
      UUNWIWJWSWKWLUVCUWEMVSZUVTUVCUUQUVEUWGUVFUVNDEFUUGMNOPWMVPVCWNUVCUWBVDZUU
      HUUEMFUFZMUWHUUGMUUEFUVCUWBUUFHUUOUNURZUUGMVSUVCUVAUWBUWJAUUTUVAWOUWJUVAU
      WBVDUUFHUUOWEWGWFUVCHDYSUUOUUFMAUVKUVBUVMVCUUOUUOWHUVCUUOWIWJWSWKWPUVCUWI
      MVSZUWBUVCUUQUVDUWKUVFUVJDEFUUEMNOPWQVPVCWNWRWTXAXBAUUIYMEUHAUUIBCGHBUTZU
      UCUJZCUTZYSUJZFUFZUGYMUDUEBCGHUUHUWPBUUEUUGFBGKUUDXCBFXDBUUGXDXEZCUUEUUGF
      CUUEXDCFXDZCHLUUFXCZXEUDUWPXDUEUWPXDZUDBXIZUECXIZUUEUWMUUGUWOFUUDUWLUUCXF
      ZUUFUWNYSXFZXGXHABCGHUWPYLAUWLGURZUWNHURZXSZUWMKUWOLFUXGUXEKDURZUWMKVSAUX
      EUXFXJAUXEUXHUXFTXKBGKDUUCUVHXLVPUXGUXFLDURZUWOLVSAUXEUXFXMAUXFUXIUXEUAXN
      CHLDYSUVLXLVPXOZXPXQWPAUULYQEUHAUULBGECHUWPUIZUHUFZUIYQUDBGUUKUXLBEUUJUHB
      EXDBUHXDBUEHUUHBHXDUWQXTXEUDUXLXDUXAUUJUXKEUHUXAUUJUEHUWMUUGFUFZUIUXKUXAU
      EHUUHUXMUXAUUEUWMUUGFUXCWLXRUECHUXMUWPCUWMUUGFCUWMXDUWRUWSXEUWTUXBUUGUWOU
      WMFUXDWPYAYBWPYAABGUXLYPAUXEVDZUXKYOEUHUXNCHUWPYLAUXEUXFUWPYLVSUXJYIYCWPY
      CXQWPYDAYQUUBEUHABGYPUUAUXNHDEYEUJZEFCJLKMNPUXOVEZOAUUQUXESVCAUUSUXERVCTA
      UXFUXIUXEUAYFAUVOUXEUCVCYGYCWPAGDUXOEFBIKYTMNPUXPOSQAHDYSEJMNPUURRUVMUCYH
      TUBYJYK $.
  $}

  ${
    $d x y z I $.  $d x y z M $.  $d x y z ph $.  $d x y z R $.  $d x y z S $.
    $d x V $.  $d x W $.  $d x y z Y $.  $d x y z Z $.
    prdsmgp.y $e |- Y = ( S Xs_ R ) $.
    prdsmgp.m $e |- M = ( mulGrp ` Y ) $.
    prdsmgp.z $e |- Z = ( S Xs_ ( mulGrp o. R ) ) $.
    prdsmgp.i $e |- ( ph -> I e. V ) $.
    prdsmgp.s $e |- ( ph -> S e. W ) $.
    prdsmgp.r $e |- ( ph -> R Fn I ) $.
    $( The multiplicative monoid of a product is the product of the
       multiplicative monoids of the factors.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    prdsmgp $p |- ( ph ->
      ( ( Base ` M ) = ( Base ` Z ) /\ ( +g ` M ) = ( +g ` Z ) ) ) $=
      ( vx cbs cfv cmgp eqid vy vz wceq cplusg cv cixp ccom wa mgpbas wfn fvco2
      wcel sylan eqcomd fveq2d syl5eq ixpeq2dva eqcomi prdsbas2 cvv crn wss a1i
      fnmgp fnco syl3anc 3eqtr4d cmulr mgpplusg co cmpt cmpt2 oveqd mpt2eq123dv
      ssv mpteq2dva fnex syl2anc cdm fndm syl prdsmulr prdsplusg syl5eqr jca )
      AEQRZIQRZUCEUDRZIUDRZUCAPDPUEZBRZQRZUFPDWJSBUGZRZQRZUFWFWGAPDWLWOAWJDULZU
      HZWLWKSRZQRWOWLWKWRWRTWLTUIWQWRWNQWQWNWRABDUJZWPWNWRUCODSBWJUKUMUNUOUPUQA
      PWFBCDGFHJHQRZWFWTHEKWTTUIURZNMOUSAPWGWMCDGFILWGTZNMASUTUJZWSBVAZUTVBZWMD
      UJZXCAVDVCOXEAXDVOVCUTDSBVEVFZUSVGZAWHHVHRZWIHXIEKXITZVIAPUAWFWFUBDUBUEZW
      JRZXKUAUERZXKBRZVHRZVJZVKZVLPUAWGWGUBDXLXMXKWMRZUDRZVJZVKZVLXIWIAPUAWFWFX
      QWGWGYAXHXHAUBDXPXTAXKDULZUHZXOXSXLXMYCXOXNSRZUDRXSXNXOYDYDTXOTVIYCYDXRUD
      YCXRYDAWSYBXRYDUCODSBXKUKUMUNUOUPVMVPVNAUBWFHBCXIPUADGUTJNAWSDFULZBUTULOM
      DFBVQVRXAAWSBVSDUCODBVTWAXJWBAUBWGIWIWMCPUADGUTLNAXFYEWMUTULXGMDFWMVQVRXB
      AXFWMVSDUCXGDWMVTWAWITWCVGWDWE $.
  $}

  ${
    $d x B $.  $d x F $.  $d x G $.  $d x I $.  $d x R $.  $d x S $.  $d x V $.
    $d x ph $.  $d x W $.  $d x .x. $.  $d x Y $.
    prdsmulrcl.y $e |- Y = ( S Xs_ R ) $.
    prdsmulrcl.b $e |- B = ( Base ` Y ) $.
    prdsmulrcl.t $e |- .x. = ( .r ` Y ) $.
    prdsmulrcl.s $e |- ( ph -> S e. V ) $.
    prdsmulrcl.i $e |- ( ph -> I e. W ) $.
    prdsmulrcl.r $e |- ( ph -> R : I --> Ring ) $.
    prdsmulrcl.f $e |- ( ph -> F e. B ) $.
    prdsmulrcl.g $e |- ( ph -> G e. B ) $.
    $( A structure product of rings has closed binary operation.  (Contributed
       by Mario Carneiro, 11-Mar-2015.) $)
    prdsmulrcl $p |- ( ph -> ( F .x. G ) e. B ) $=
      ( wcel vx co cv cfv cmulr cmpt crg wf wfn ffn syl prdsmulrval cbs wral wa
      ffvelrnda adantr simpr prdsbasprj eqid rngcl syl3anc ralrimiva prdsbasmpt
      mpbird eqeltrd ) AFGEUBUAHUAUCZFUDZVGGUDZVGCUDZUEUDZUBZUFZBAUABCDEFGHIJKL
      MOPAHUGCUHCHUIZQHUGCUJUKZRSNULAVMBTVLVJUMUDZTZUAHUNAVQUAHAVGHTZUOZVJUGTVH
      VPTVIVPTVQAHUGVGCQUPVSBCDFHVGIJKLMADITVROUQZAHJTVRPUQZAVNVRVOUQZAFBTVRRUQ
      AVRURZUSVSBCDGHVGIJKLMVTWAWBAGBTVRSUQWCUSVPVJVKVHVIVPUTVKUTVAVBVCAUABCDVL
      HIJKLMOPVOVDVEVF $.
  $}

  ${
    $d w I $.  $d w x y z ph $.  $d w x y R $.  $d w x y S $.  $d w x y z Y $.
    $d w V $.  $d w W $.
    prdsrngd.y $e |- Y = ( S Xs_ R ) $.
    prdsrngd.i $e |- ( ph -> I e. W ) $.
    prdsrngd.s $e |- ( ph -> S e. V ) $.
    prdsrngd.r $e |- ( ph -> R : I --> Ring ) $.
    $( A product of rings is a ring.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    prdsrngd $p |- ( ph -> Y e. Ring ) $=
      ( vx vw wcel cfv cmnd co crg eqid adantr vy vz cgrp cmgp cv cmulr wceq wa
      cplusg cbs wral wf wss rnggrp ssriv sylancl prdsgrpd ccom cprds cres mgpf
      fss fco2 sylancr prdsmndd wfn ffn prdsmgp simpld simprd proplem3 mndpropd
      eqidd syl mpbird w3a cmpt ffvelrnda simplr1 simpr prdsbasprj simpr2 rngdi
      simpr3 prdsplusgfval oveq2d prdsmulrfval oveq12d 3eqtr4d mpteq2dva simpr1
      rngmnd prdsplusgcl prdsmulrval prdsmulrcl prdsplusgval rngdir ralrimivvva
      syl13anc oveq1d jca isrng syl3anbrc ) AGUCNGUDOZPNZLUEZUAUEZUBUEZGUIOZQZG
      UFOZQZXFXGXKQZXFXHXKQZXIQZUGZXFXGXIQZXHXKQZXNXGXHXKQZXIQZUGZUHZUBGUJOZUKU
      AYCUKLYCUKGRNABCDEFGHIJADRBULZRUCUMDUCBULKLRUCXFUNUODRUCBVBUPUQAXECUDBURZ
      USQZPNAYECDEFYFYFSZIJARPUDRUTULYDDPYEULVAKDRPUDBVCVDVEALUAXDUJOZXDYFAYHVM
      AYHYFUJOUGZXDUIOZYFUIOZUGZABCDXDFEGYFHXDSZYGIJAYDBDVFZKDRBVGVNZVHZVIAXFYH
      NXGYHNUHLUAYJYKAYIYLYPVJVKVLVOAYBLUAUBYCYCYCAXFYCNZXGYCNZXHYCNZVPZUHZXPYA
      UUAMDMUEZXFOZUUBXJOZUUBBOZUFOZQZVQMDUUBXMOZUUBXNOZUUEUIOZQZVQXLXOUUAMDUUG
      UUKUUAUUBDNZUHZUUCUUBXGOZUUBXHOZUUJQZUUFQZUUCUUNUUFQZUUCUUOUUFQZUUJQZUUGU
      UKUUMUUERNZUUCUUEUJOZNZUUNUVBNZUUOUVBNZUUQUUTUGUUADRUUBBAYDYTKTZVRZUUMYCB
      CXFDUUBEFGHYCSZUUACENZUULAUVIYTJTZTZUUADFNZUULAUVLYTITZTZUUAYNUULAYNYTYOT
      ZTZYQYRYSAUULVSZUUAUULVTZWAZUUMYCBCXGDUUBEFGHUVHUVKUVNUVPUUAYRUULAYQYRYSW
      BZTZUVRWAZUUMYCBCXHDUUBEFGHUVHUVKUVNUVPUUAYSUULAYQYRYSWDZTZUVRWAZUVBUUJUU
      EUUFUUCUUNUUOUVBSZUUJSZUUFSZWCWSUUMUUDUUPUUCUUFUUMYCXIBCXGXHDUUBEFGHUVHUV
      KUVNUVPUWAUWDXISZUVRWEWFUUMUUHUURUUIUUSUUJUUMYCBCXKXFXGDUUBEFGHUVHUVKUVNU
      VPUVQUWAXKSZUVRWGUUMYCBCXKXFXHDUUBEFGHUVHUVKUVNUVPUVQUWDUWJUVRWGZWHWIWJUU
      AMYCBCXKXFXJDEFGHUVHUVJUVMUVOAYQYRYSWKZUUAYCXIBCXGXHDEFGHUVHUWIUVJUVMADPB
      ULZYTAYDRPUMUWMKLRPXFWLUODRPBVBUPTZUVTUWCWMUWJWNUUAMYCXIBCXMXNDEFGHUVHUVJ
      UVMUVOUUAYCBCXKXFXGDEFGHUVHUWJUVJUVMUVFUWLUVTWOUUAYCBCXKXFXHDEFGHUVHUWJUV
      JUVMUVFUWLUWCWOZUWIWPWIUUAMDUUBXQOZUUOUUFQZVQMDUUIUUBXSOZUUJQZVQXRXTUUAMD
      UWQUWSUUMUUCUUNUUJQZUUOUUFQZUUSUUNUUOUUFQZUUJQZUWQUWSUUMUVAUVCUVDUVEUXAUX
      CUGUVGUVSUWBUWEUVBUUJUUEUUFUUCUUNUUOUWFUWGUWHWQWSUUMUWPUWTUUOUUFUUMYCXIBC
      XFXGDUUBEFGHUVHUVKUVNUVPUVQUWAUWIUVRWEWTUUMUUIUUSUWRUXBUUJUWKUUMYCBCXKXGX
      HDUUBEFGHUVHUVKUVNUVPUWAUWDUWJUVRWGWHWIWJUUAMYCBCXKXQXHDEFGHUVHUVJUVMUVOU
      UAYCXIBCXFXGDEFGHUVHUWIUVJUVMUWNUWLUVTWMUWCUWJWNUUAMYCXIBCXNXSDEFGHUVHUVJ
      UVMUVOUWOUUAYCBCXKXGXHDEFGHUVHUWJUVJUVMUVFUVTUWCWOUWIWPWIXAWRLUAUBYCXIGXK
      XDUVHYMUWIUWJXBXC $.
  $}

  ${
    $d ph x y $.  $d R x y $.  $d S x y $.  $d Y x y $.
    prdscrngd.y $e |- Y = ( S Xs_ R ) $.
    prdscrngd.i $e |- ( ph -> I e. W ) $.
    prdscrngd.s $e |- ( ph -> S e. V ) $.
    prdscrngd.r $e |- ( ph -> R : I --> CRing ) $.
    $( A product of commutative rings is a commutative ring.  Since the
       resulting ring will have zero divisors in all nontrivial cases, this
       cannot be strengthened much further.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    prdscrngd $p |- ( ph -> Y e. CRing ) $=
      ( vx vy crg wcel cmgp cfv ccmn ccrg wf wss crngrng ssriv sylancl prdsrngd
      cv fss ccom cprds co eqid cres wfn wral cvv fnmgp ssv fnssres mp2an fvres
      crngmgp eqeltrd rgen ffnfv mpbir2an fco2 sylancr prdscmnd cbs wceq cplusg
      ffn syl prdsmgp simpld wa simprd proplem3 cmnpropd mpbird iscrng sylanbrc
      eqidd ) AGNOGPQZROZGSOABCDEFGHIJADSBTZSNUADNBTKLSNLUFZUBUCDSNBUGUDUEAWECP
      BUHZUIUJZROAWHCDEFWIWIUKZIJASRPSULZTZWFDRWHTWLWKSUMZWGWKQZROZLSUNPUOUMSUO
      UAWMUPSUQUOSPURUSWOLSWGSOWNWGPQZRWGSPUTWGWPWPUKVAVBVCLSRWKVDVEKDSRPBVFVGV
      HALMWDVIQZWDWIAWQWCAWQWIVIQVJZWDVKQZWIVKQZVJZABCDWDFEGWIHWDUKZWJIJAWFBDUM
      KDSBVLVMVNZVOAWGWQOMUFWQOVPLMWSWTAWRXAXCVQVRVSVTGWDXBWAWB $.
  $}

  ${
    $d ph x y $.  $d R x y $.  $d S x y $.  $d Y x y $.
    prds1.y $e |- Y = ( S Xs_ R ) $.
    prds1.i $e |- ( ph -> I e. W ) $.
    prds1.s $e |- ( ph -> S e. V ) $.
    prds1.r $e |- ( ph -> R : I --> Ring ) $.
    $( Value of the ring unit in a structure family product.  (Contributed by
       Mario Carneiro, 11-Mar-2015.) $)
    prds1 $p |- ( ph -> ( 1r o. R ) = ( 1r ` Y ) ) $=
      ( vx vy c0g cmgp ccom cfv cur eqid crg cprds co cmnd cres wf mgpf sylancr
      fco2 prds0g cbs eqidd wceq cplusg wfn ffn syl prdsmgp simpld cv wa simprd
      wcel proplem3 grpidpropd eqtr4d df-ur coeq1i coass eqtri rngidval 3eqtr4g
      ) ANOBPZPZGOQZNQZRBPZGRQZAVMCVLUAUBZNQVOAVLCDEFVRVRSZIJATUCOTUDUEDTBUEZDU
      CVLUEUFKDTUCOBUHUGUIALMVNUJQZVNVRAWAUKAWAVRUJQULZVNUMQZVRUMQZULZABCDVNFEG
      VRHVNSZVSIJAVTBDUNKDTBUOUPUQZURALUSWAVBMUSWAVBUTLMWCWDAWBWEWGVAVCVDVEVPNO
      PZBPVMRWHBVFVGNOBVHVIGVQVNWFVQSVJVK $.
  $}

  ${
    pwsrng.y $e |- Y = ( R ^s I ) $.
    $( A structure power of a ring is a ring.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    pwsrng $p |- ( ( R e. Ring /\ I e. V ) -> Y e. Ring ) $=
      ( crg wcel wa csca cfv csn cxp cprds co eqid pwsval cvv simpr fvex a1i wf
      fconst6g adantr prdsrngd eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUIOPUH
      UJUIBQCUKUKOUFUGRUIQGUHAISTUFBFUJUAUGBAFUBUCUDUE $.
  $}

  ${
    pws1.y $e |- Y = ( R ^s I ) $.
    pws1.o $e |- .1. = ( 1r ` R ) $.
    $( Value of the ring unit in a structure power.  (Contributed by Mario
       Carneiro, 11-Mar-2015.) $)
    pws1 $p |- ( ( R e. Ring /\ I e. V ) -> ( I X. { .1. } ) = ( 1r ` Y ) ) $=
      ( crg wcel cur cfv csca csn cxp ccom cvv a1i wfn c0g cmgp wa cprds pwsval
      co eqid fveq2d simpr fvex wf fconst6g adantr prds1 wceq crn wss fnmgp ssv
      fn0g fnco syl3anc df-ur fneq1i sylibr elex fcoconst syl2anc sneqi syl6eqr
      xpeq2i 3eqtr2rd ) AHIZCDIZUAZEJKALKZCAMNZUBUDZJKJVOOZCBMZNZVMEVPJAVNCHDEF
      VNUEUCUFVMVOVNCPDVPVPUEVKVLUGVNPIVMALUHQVKCHVOUIVLCAHUJUKULVMVQCAJKZMZNZV
      SVMJPRZAPIZVQWBUMVMSTOZPRZWCVMSPRZTPRZTUNZPUOZWFWGVMURQWHVMUPQWJVMWIUQQPP
      STUSUTPJWEVAVBVCVKWDVLAHVDUKJCPAVEVFVRWACBVTGVGVIVHVJ $.
  $}

  ${
    pwscrng.y $e |- Y = ( R ^s I ) $.
    $( A structure power of a commutative ring is a commutative ring.
       (Contributed by Mario Carneiro, 11-Mar-2015.) $)
    pwscrng $p |- ( ( R e. CRing /\ I e. V ) -> Y e. CRing ) $=
      ( ccrg wcel wa csca cfv csn cxp cprds co eqid pwsval cvv simpr fvex a1i
      wf fconst6g adantr prdscrngd eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUI
      OPUHUJUIBQCUKUKOUFUGRUIQGUHAISTUFBFUJUAUGBAFUBUCUDUE $.
  $}

  ${
    pwsmgp.y $e |- Y = ( R ^s I ) $.
    pwsmgp.m $e |- M = ( mulGrp ` R ) $.
    pwsmgp.z $e |- Z = ( M ^s I ) $.
    pwsmgp.n $e |- N = ( mulGrp ` Y ) $.
    pwsmgp.b $e |- B = ( Base ` N ) $.
    pwsmgp.c $e |- C = ( Base ` Z ) $.
    pwsmgp.p $e |- .+ = ( +g ` N ) $.
    pwsmgp.q $e |- .+b = ( +g ` Z ) $.
    $( The multiplicative group of the power structure resembles the power of
       the multiplicative group.  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    pwsmgp $p |- ( ( R e. V /\ I e. W ) -> ( B = C /\ .+ = .+b ) ) $=
      ( wcel wa wceq cbs cfv csca csn cxp cprds cmgp ccom cplusg cvv eqid simpr
      co fvex a1i wfn fnconstg adantr prdsmgp simpld pwsval fveq2d cpws eqeltri
      syl5eq sylancr mgpsca eqcomi fnmgp fcoconst sneqi xpeq2i syl6reqr oveq12d
      elex eqtrd 3eqtr4d 3eqtr4g simprd jca ) EIUAZFJUAZUBZABUCCDUCWFHUDUEZLUDU
      EZABWFEUFUEZFEUGUHZUIUPZUJUEZUDUEZWIUJWJUKZUIUPZUDUEZWGWHWFWMWPUCZWLULUEZ
      WOULUEZUCZWFWJWIFWLJUMWKWOWKUNWLUNWOUNWDWEUOZWIUMUAWFEUFUQURWDWJFUSWEFEIU
      TVAVBZVCWFHWLUDWFHKUJUEWLPWFKWKUJEWIFIJKMWIUNZVDVEVHZVEWFLWOUDWFLGFVFUPZW
      OOWFXEGUFUEZFGUGZUHZUIUPZWOWFGUMUAWEXEXIUCGEUJUEZUMNEUJUQVGXAGXFFUMJXEXEU
      NXFUNVDVIWFXFWIXHWNUIXFWIUCWFWIXFEWIGNXCVJVKURWFWNFXJUGZUHZXHWFUJUMUSEUMU
      AZWNXLUCVLWDXMWEEIVRVAUJFUMEVMVIXGXKFGXJNVNVOVPVQVSVHZVEVTQRWAWFHULUEZLUL
      UEZCDWFWRWSXOXPWFWQWTXBWBWFHWLULXDVEWFLWOULXNVEVTSTWAWC $.
  $}

  ${
    $d p q u v .+ $.  $d a b p q u v w x y z ph $.  $d a b p q u v w x y z U $.
    $d p q u x .1. $.  $d p q u v w B $.  $d a b p q u x y z F $.  $d p q R $.
    $d a b p q u v x y z V $.  $d p q u v .x. $.
    imasrng.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasrng.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasrng.p $e |- .+ = ( +g ` R ) $.
    imasrng.t $e |- .x. = ( .r ` R ) $.
    imasrng.o $e |- .1. = ( 1r ` R ) $.
    imasrng.f $e |- ( ph -> F : V -onto-> B ) $.
    imasrng.e1 $e |- ( ( ph /\ ( a e. V /\ b e. V ) /\ ( p e. V /\ q e. V ) )
      -> ( ( ( F ` a ) = ( F ` p ) /\ ( F ` b ) = ( F ` q ) )
        -> ( F ` ( a .+ b ) ) = ( F ` ( p .+ q ) ) ) ) $.
    imasrng.e2 $e |- ( ( ph /\ ( a e. V /\ b e. V ) /\ ( p e. V /\ q e. V ) )
      -> ( ( ( F ` a ) = ( F ` p ) /\ ( F ` b ) = ( F ` q ) )
        -> ( F ` ( a .x. b ) ) = ( F ` ( p .x. q ) ) ) ) $.
    imasrng.r $e |- ( ph -> R e. Ring ) $.
    $( The image structure of a ring is a ring.  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    imasrng $p |- ( ph -> ( U e. Ring /\ ( F ` .1. ) = ( 1r ` U ) ) ) $=
      ( vu vv vw vx vy vz crg wcel cfv cur wceq cplusg cmulr imasbas eqidd cgrp
      c0g a1i rnggrp syl eqid imasgrp simpld cxp wf cv co wa cbs adantr eleqtrd
      simprl rngcl syl3anc eleqtrrd caovclg imasmulf fovrn syl3an1 w3a wrex crn
      simprr wfo forn eleq2d 3anbi123d wfn wb fvelrnb bitr3d 3reeanv syl6bbr wi
      fofn simp2 3ad2ant1 3adant3r3 simp3 simpr3 rngass syl13anc simpl 3adantr3
      fveq2d imasmulval simpr1 3adantr1 3eqtr4d oveq1d 3adant3r1 oveq2d oveq12d
      simp1 eqeq12d syl5ibcom 3exp2 imp32 rexlimdv rexlimdvva sylbid imp rngacl
      rngdi 3adantr2 imasaddval 3adant3r2 rngdir rngidcl ffvelrnd simpr rnglidm
      fof biimpa syl2anc eqtrd oveq2 rexlimdva mpd3an3 rngridm isrngd wral jcad
      id oveq1 sylbird ralrimiv isrngid mpbi2and eqcomd jca ) AFUIUJZGHUKZFULUK
      ZUMAUCUDUEBFUNUKZFFUOUKZUUOABDFHIUINOSUBUPZAUUQUQAUURUQAFURUJDUSUKZHUKFUS
      UKUMABCDFHIUUTJKLMNOCDUNUKUMAPUTSTADUIUJZDURUJUBDVAVBUUTVCVDVEABBVFBUURVG
      UCVHZBUJZUDVHZBUJZUVBUVDUURVIZBUJABDUUREFHIUIJKLMSUANOUBQUURVCZAUCUDKVHJV
      HIIIEAUVBIUJZUVDIUJZVJZVJZUVBUVDEVIZDVKUKZIUVKUVAUVBUVMUJZUVDUVMUJZUVLUVM
      UJAUVAUVJUBVLZUVKUVBIUVMAUVHUVIVNAIUVMUMZUVJOVLZVMZUVKUVDIUVMAUVHUVIWEUVR
      VMZUVMDEUVBUVDUVMVCZQVOVPUVRVQZVRVSUVBUVDBBBUURVTWAAUVCUVEUEVHZBUJZWBZUVF
      UWCUURVIZUVBUVDUWCUURVIZUURVIZUMZAUWEUFVHZHUKZUVBUMZUGVHZHUKZUVDUMZUHVHZH
      UKZUWCUMZWBZUHIWCZUGIWCUFIWCZUWIAUWEUWLUFIWCZUWOUGIWCZUWRUHIWCZWBZUXAAUVB
      HWDZUJZUVDUXFUJZUWCUXFUJZWBZUWEUXEAUXGUVCUXHUVEUXIUWDAUXFBUVBAIBHWFZUXFBU
      MSIBHWGVBZWHZAUXFBUVDUXLWHAUXFBUWCUXLWHWIAHIWJZUXJUXEWKAUXKUXNSIBHWQVBZUX
      NUXGUXBUXHUXCUXIUXDUFIUVBHWLZUGIUVDHWLUHIUWCHWLWIVBWMUWLUWOUWRUFUGUHIIIWN
      WOZAUWTUWIUFUGIIAUWJIUJZUWMIUJZVJVJZUWSUWIUHIAUXRUXSUWPIUJZUWSUWIWPZWPAUX
      RUXSUYAUYBAUXRUXSUYAWBZVJZUWKUWNUURVIZUWQUURVIZUWKUWNUWQUURVIZUURVIZUMUWS
      UWIUYDUWJUWMEVIZHUKZUWQUURVIZUWKUWMUWPEVIZHUKZUURVIZUYFUYHUYDUYIUWPEVIZHU
      KZUWJUYLEVIZHUKZUYKUYNUYDUYOUYQHUYDUVAUWJUVMUJZUWMUVMUJZUWPUVMUJZUYOUYQUM
      AUVAUYCUBVLZAUXRUXSUYSUYAAUXRUXSWBZUWJIUVMAUXRUXSWRAUXRUVQUXSOWSZVMWTZAUX
      RUXSUYTUYAVUCUWMIUVMAUXRUXSXAVUDVMWTZUYDUWPIUVMAUXRUXSUYAXBZAUVQUYCOVLVMZ
      UVMDEUWJUWMUWPUWAQXCXDXGUYDAUYIIUJZUYAUYKUYPUMAUYCXEZAUXRUXSVUIUYAAUCUDUW
      JUWMIIIEUWBVRXFZVUGABDUUREFHIUYIUWPUIJKLMSUANOUBQUVGXHVPUYDAUXRUYLIUJZUYN
      UYRUMVUJAUXRUXSUYAXIZAUXSUYAVULUXRAUCUDUWMUWPIIIEUWBVRXJZABDUUREFHIUWJUYL
      UIJKLMSUANOUBQUVGXHVPXKUYDUYEUYJUWQUURAUXRUXSUYEUYJUMUYAABDUUREFHIUWJUWMU
      IJKLMSUANOUBQUVGXHWTZXLUYDUYGUYMUWKUURAUXSUYAUYGUYMUMUXRABDUUREFHIUWMUWPU
      IJKLMSUANOUBQUVGXHXMZXNXKUWSUYFUWFUYHUWHUWSUYEUVFUWQUWCUURUWSUWKUVBUWNUVD
      UURUWLUWOUWRXPZUWLUWOUWRWRZXOZUWLUWOUWRXAZXOUWSUWKUVBUYGUWGUURVUQUWSUWNUV
      DUWQUWCUURVURVUTXOZXOXQXRXSXTYAYBYCYDAUWEUVBUVDUWCUUQVIZUURVIZUVFUVBUWCUU
      RVIZUUQVIZUMZAUWEUXAVVFUXQAUWTVVFUFUGIIUXTUWSVVFUHIAUXRUXSUYAUWSVVFWPZWPA
      UXRUXSUYAVVGUYDUWKUWNUWQUUQVIZUURVIZUYEUWKUWQUURVIZUUQVIZUMUWSVVFUYDUWKUW
      MUWPCVIZHUKZUURVIZUYJUWJUWPEVIZHUKZUUQVIZVVIVVKUYDUWJVVLEVIZHUKZUYIVVOCVI
      ZHUKZVVNVVQUYDVVRVVTHUYDUVAUYSUYTVUAVVRVVTUMVUBVUEVUFVUHUVMCDEUWJUWMUWPUW
      APQYFXDXGUYDAUXRVVLIUJZVVNVVSUMVUJVUMAUXSUYAVWBUXRAUCUDUWMUWPIIICUVKUVBUV
      DCVIZUVMIUVKUVAUVNUVOVWCUVMUJUVPUVSUVTUVMCDUVBUVDUWAPYEVPUVRVQZVRXJABDUUR
      EFHIUWJVVLUIJKLMSUANOUBQUVGXHVPUYDAVUIVVOIUJZVVQVWAUMVUJVUKAUXRUYAVWEUXSA
      UCUDUWJUWPIIIEUWBVRYGZABDUUQCFHIUYIVVOUIJKLMSTNOUBPUUQVCZYHVPXKUYDVVHVVMU
      WKUURAUXSUYAVVHVVMUMUXRABDUUQCFHIUWMUWPUIJKLMSTNOUBPVWGYHXMXNUYDUYEUYJVVJ
      VVPUUQVUOAUXRUYAVVJVVPUMUXSABDUUREFHIUWJUWPUIJKLMSUANOUBQUVGXHYIZXOXKUWSV
      VIVVCVVKVVEUWSUWKUVBVVHVVBUURVUQUWSUWNUVDUWQUWCUUQVURVUTXOXOUWSUYEUVFVVJV
      VDUUQVUSUWSUWKUVBUWQUWCUURVUQVUTXOZXOXQXRXSXTYAYBYCYDAUWEUVBUVDUUQVIZUWCU
      URVIZVVDUWGUUQVIZUMZAUWEUXAVWMUXQAUWTVWMUFUGIIUXTUWSVWMUHIAUXRUXSUYAUWSVW
      MWPZWPAUXRUXSUYAVWNUYDUWKUWNUUQVIZUWQUURVIZVVJUYGUUQVIZUMUWSVWMUYDUWJUWMC
      VIZHUKZUWQUURVIZVVPUYMUUQVIZVWPVWQUYDVWRUWPEVIZHUKZVVOUYLCVIZHUKZVWTVXAUY
      DVXBVXDHUYDUVAUYSUYTVUAVXBVXDUMVUBVUEVUFVUHUVMCDEUWJUWMUWPUWAPQYJXDXGUYDA
      VWRIUJZUYAVWTVXCUMVUJAUXRUXSVXFUYAAUCUDUWJUWMIIICVWDVRXFVUGABDUUREFHIVWRU
      WPUIJKLMSUANOUBQUVGXHVPUYDAVWEVULVXAVXEUMVUJVWFVUNABDUUQCFHIVVOUYLUIJKLMS
      TNOUBPVWGYHVPXKUYDVWOVWSUWQUURAUXRUXSVWOVWSUMUYAABDUUQCFHIUWJUWMUIJKLMSTN
      OUBPVWGYHWTXLUYDVVJVVPUYGUYMUUQVWHVUPXOXKUWSVWPVWKVWQVWLUWSVWOVWJUWQUWCUU
      RUWSUWKUVBUWNUVDUUQVUQVURXOVUTXOUWSVVJVVDUYGUWGUUQVWIVVAXOXQXRXSXTYAYBYCY
      DAIBGHAUXKIBHVGSIBHYOVBAGUVMIAUVAGUVMUJUBUVMDGUWARYKVBOVQZYLZAUVCUUOUVBUU
      RVIZUVBUMZAUVCUXBVXJAUXGUVCUXBUXMAUXNUXGUXBWKUXOUXPVBWMZAUWLVXJUFIAUXRVJZ
      UUOUWKUURVIZUWKUMUWLVXJVXLVXMGUWJEVIZHUKZUWKVXLAGIUJZUXRVXMVXOUMAUXRXEAVX
      PUXRVXGVLZAUXRYMABDUUREFHIGUWJUIJKLMSUANOUBQUVGXHVPVXLVXNUWJHVXLUVAUYSVXN
      UWJUMAUVAUXRUBVLZAUXRUYSAIUVMUWJOWHYPZUVMDEGUWJUWAQRYNYQXGYRUWLVXMVXIUWKU
      VBUWKUVBUUOUURYSUWLUUFZXQXRYTYCZYDAUVCUVBUUOUURVIZUVBUMZAUVCUXBVYCVXKAUWL
      VYCUFIVXLUWKUUOUURVIZUWKUMUWLVYCVXLVYDUWJGEVIZHUKZUWKAUXRVXPVYDVYFUMVXQAB
      DUUREFHIUWJGUIJKLMSUANOUBQUVGXHUUAVXLVYEUWJHVXLUVAUYSVYEUWJUMVXRVXSUVMDEG
      UWJUWAQRUUBYQXGYRUWLVYDVYBUWKUVBUWKUVBUUOUURUUGVXTXQXRYTYCZYDUUCZAUUPUUOA
      UUOFVKUKZUJZVXJVYCVJZUCVYIUUDZUUPUUOUMZAUUOBVYIVXHUUSVMAVYKUCVYIAUVBVYIUJ
      UVCVYKABVYIUVBUUSWHAUVCVXJVYCVYAVYGUUEUUHUUIAUUNVYJVYLVJVYMWKVYHUCVYIFUUR
      UUPUUOVYIVCUVGUUPVCUUJVBUUKUULUUM $.
  $}

  ${
    $d p q u x y .+ $.  $d p q u .1. $.  $d a b p q U $.  $d a b p q u x y V $.
    $d a b p q u .~ $.  $d a b p q u x y ph $.  $d p q u x y .x. $.
    $d p q u R $.
    divsrng2.u $e |- ( ph -> U = ( R /s .~ ) ) $.
    divsrng2.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divsrng2.p $e |- .+ = ( +g ` R ) $.
    divsrng2.t $e |- .x. = ( .r ` R ) $.
    divsrng2.o $e |- .1. = ( 1r ` R ) $.
    divsrng2.r $e |- ( ph -> .~ Er V ) $.
    divsrng2.e1 $e |- ( ph ->
      ( ( a .~ p /\ b .~ q ) -> ( a .+ b ) .~ ( p .+ q ) ) ) $.
    divsrng2.e2 $e |- ( ph ->
      ( ( a .~ p /\ b .~ q ) -> ( a .x. b ) .~ ( p .x. q ) ) ) $.
    divsrng2.x $e |- ( ph -> R e. Ring ) $.
    $( The quotient structure of a ring is a ring.  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    divsrng2 $p |- ( ph -> ( U e. Ring /\ [ .1. ] .~ = ( 1r ` U ) ) ) $=
      ( vu vx vy crg wcel cec cur cfv wceq wa cv cmpt cqs cvv eqid wer cbs fvex
      syl6eqel erex sylc divsval divslem co adantr simprl eleqtrd simprr rngacl
      syl3anc eleqtrrd ercpbl imasrng divsfval eqcomd eqeq1d anbi2d mpbird
      rngcl ) AFUEUFZGCUGZFUHUIZUJZUKWAGUBHUBULCUGUMZUIZWCUJZUKAHCUNBDEFGWEHIJK
      LAUBCDFWEHUOUEMNWEUPZAHCUQHUOUFCUOUFRAHDURUIZUONDURUSUTZHCUOVAVBZUAVCNOPQ
      AUBCDFWEHUOUEMNWHWKUAVDAUBKULZLULZJULZIULZBCWEHUCUDRWJWHAUCULZHUFZUDULZHU
      FZUKZUKZWPWRBVEZWIHXADUEUFZWPWIUFZWRWIUFZXBWIUFAXCWTUAVFZXAWPHWIAWQWSVGAH
      WIUJWTNVFZVHZXAWRHWIAWQWSVIXGVHZWIBDWPWRWIUPZOVJVKXGVLSVMAUBWLWMWNWOECWEH
      UCUDRWJWHXAWPWREVEZWIHXAXCXDXEXKWIUFXFXHXIWIDEWPWRXJPVTVKXGVLTVMUAVNAWDWG
      WAAWBWFWCAWFWBAUBGCWEHRWJWHVOVPVQVRVS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Opposite ring
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c oppR $. $( Opposite ring $)

  $( The opposite ring operation. $)
  coppr $a class oppR $.

  $( Define an opposite ring, which is the same as the original ring but with
     multiplication written the other way around.  (Contributed by Mario
     Carneiro, 1-Dec-2014.) $)
  df-oppr $a |- oppR = ( f e. _V |-> ( f sSet
    <. ( .r ` ndx ) , tpos ( .r ` f ) >. ) ) $.

  ${
    $d w x y R $.  $d w x y B $.  $d w x y .x. $.  $d x y X $.  $d x y Y $.
    opprval.1 $e |- B = ( Base ` R ) $.
    opprval.2 $e |- .x. = ( .r ` R ) $.
    opprval.3 $e |- O = ( oppR ` R ) $.
    $( Value of the opposite ring.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    opprval $p |- O = ( R sSet <. ( .r ` ndx ) , tpos .x. >. ) $=
      ( vx coppr cfv cnx cmulr ctpos cop csts co cvv wcel wceq cv fveq2 syl6eqr
      id tposeqd opeq2d oveq12d df-oppr ovex fvmpt wn c0 fvprc reldmsets ovprc1
      eqtr4d pm2.61i eqtri ) DBIJZBKLJZCMZNZOPZGBQRZURVBSHBHTZUSVDLJZMZNZOPVBQI
      VDBSZVDBVGVAOVHUCVHVFUTUSVHVECVHVEBLJCVDBLUAFUBUDUEUFHUGBVAOUHUIVCUJURUKV
      BBIULBVAOUMUNUOUPUQ $.

    opprmulfval.4 $e |- .xb = ( .r ` O ) $.
    $( Value of the multiplication operation of an opposite ring.  (Contributed
       by Mario Carneiro, 1-Dec-2014.) $)
    opprmulfval $p |- .xb = tpos .x. $=
      ( cmulr cfv ctpos cvv wcel wceq mulrid c0 coppr fvprc syl5eq cnx cop csts
      co fvex eqeltri tposex setsid mpan2 opprval fveq2i syl6reqr wn tpos0 str0
      eqtr2i fveq2d tposeqd 3eqtr4a pm2.61i eqtri ) CEJKZDLZIBMNZVBVCOVDVCBUAJK
      ZVCUBUCUDZJKZVBVDVCMNVCVGODDBJKZMGBJUEUFUGMVCJMBPUHUIEVFJABDEFGHUJUKULVDU
      MZQJKZQLZVBVCVKQVJUNJVEPUOUPVIEQJVIEBRKQHBRSTUQVIDQVIDVHQGBJSTURUSUTVA $.

    $( Value of the multiplication operation of an opposite ring.  Hypotheses
       eliminated by a suggestion of Stefan O'Rear, 30-Aug-2015.  (Contributed
       by Mario Carneiro, 1-Dec-2014.)  (Revised by Mario Carneiro,
       30-Aug-2015.) $)
    opprmul $p |- ( X .xb Y ) = ( Y .x. X ) $=
      ( co ctpos opprmulfval oveqi ovtpos eqtri ) FGCLFGDMZLGFDLCRFGABCDEHIJKNO
      FGDPQ $.

    $( In a commutative ring, the opposite ring is equivalent to the original
       ring (for theorems like ~ unitpropd ).  (Contributed by Mario Carneiro,
       14-Jun-2015.) $)
    crngoppr $p |- ( ( R e. CRing /\ X e. B /\ Y e. B ) ->
        ( X .x. Y ) = ( X .xb Y ) ) $=
      ( ccrg wcel w3a co crngcom opprmul syl6eqr ) BLMFAMGAMNFGDOGFDOFGCOABDFGH
      IPABCDEFGHIJKQR $.
  $}

  ${
    $d s x y z R $.  $d s E $.  $d x y z O $.  $d x y V $.
    opprbas.1 $e |- O = ( oppR ` R ) $.
    ${
      opprlem.2 $e |- E = Slot N $.
      opprlem.3 $e |- N e. NN $.
      opprlem.4 $e |- N < 3 $.
      $( Lemma for ~ opprbas and ~ oppradd .  (Contributed by Mario Carneiro,
         1-Dec-2014.) $)
      opprlem $p |- ( E ` R ) = ( E ` O ) $=
        ( cfv cnx cmulr ctpos cop csts co ndxid wne c3 nnrei eqid ltneii ndxarg
        mulrndx neeq12i mpbir setsnid cbs opprval fveq2i eqtr4i ) ABIAJKIZAKIZL
        ZMNOZBIDBIUMUKBABCFGPJBIZUKQCRQCRCGSHUAUOCUKRBCFGUBUCUDUEUFDUNBAUGIZAUL
        DUPTULTEUHUIUJ $.
    $}

    ${
      opprbas.2 $e |- B = ( Base ` R ) $.
      $( Base set of an opposite ring.  (Contributed by Mario Carneiro,
         1-Dec-2014.) $)
      opprbas $p |- B = ( Base ` O ) $=
        ( cbs cfv c1 df-base 1nn 1lt3 opprlem eqtri ) ABFGCFGEBFHCDIJKLM $.
    $}

    ${
      oppradd.2 $e |- .+ = ( +g ` R ) $.
      $( Addition operation of an opposite ring.  (Contributed by Mario
         Carneiro, 1-Dec-2014.) $)
      oppradd $p |- .+ = ( +g ` O ) $=
        ( cplusg cfv c2 df-plusg 2nn 2lt3 opprlem eqtri ) ABFGCFGEBFHCDIJKLM $.
    $}

    $( An opposite ring is a ring.  (Contributed by Mario Carneiro,
       1-Dec-2014.)  (Revised by Mario Carneiro, 30-Aug-2015.) $)
    opprrng $p |- ( R e. Ring -> O e. Ring ) $=
      ( vx vy vz wcel cbs cfv cplusg cmulr wceq eqid a1i cv co opprmul syl13anc
      cgrp 3eqtr4g crg cur opprbas oppradd eqidd rnggrp grpprop sylib w3a rngcl
      3com23 syl5eqel wa simpl simpr3 simpr2 simpr1 rngass eqcomd oveq1i oveq2i
      eqtri rngdir oveq12i rngdi rngidcl rngridm syl5eq rnglidm isrngd ) AUAGZD
      EFAHIZAJIZBBKIZAUBIZVLBHILVKVLABCVLMZUCZNVMBJILVKVMABCVMMZUDZNVKVNUEVKASG
      BSGAUFABVQVSUGUHVKDOZVLGZEOZVLGZUIVTWBVNPZWBVTAKIZPZVLVLAVNWEBVTWBVPWEMZC
      VNMZQZVKWCWAWFVLGVLAWEWBVTVPWGUJUKULVKWAWCFOZVLGZUIZUMZWJWFWEPZWJWBWEPZVT
      WEPZWDWJVNPZVTWBWJVNPZVNPZWMWPWNWMVKWKWCWAWPWNLVKWLUNZVKWAWCWKUOZVKWAWCWK
      UPZVKWAWCWKUQZVLAWEWJWBVTVPWGURRUSWQWFWJVNPWNWDWFWJVNWIUTVLAVNWEBWFWJVPWG
      CWHQVBWSVTWOVNPWPWRWOVTVNVLAVNWEBWBWJVPWGCWHQZVAVLAVNWEBVTWOVPWGCWHQVBTWM
      WBWJVMPZVTWEPZWFWJVTWEPZVMPZVTXEVNPWDVTWJVNPZVMPWMVKWCWKWAXFXHLWTXBXAXCVL
      VMAWEWBWJVTVPVRWGVCRVLAVNWEBVTXEVPWGCWHQWDWFXIXGVMWIVLAVNWEBVTWJVPWGCWHQZ
      VDTWMWJVTWBVMPZWEPZXGWOVMPZXKWJVNPXIWRVMPWMVKWKWAWCXLXMLWTXAXCXBVLVMAWEWJ
      VTWBVPVRWGVERVLAVNWEBXKWJVPWGCWHQXIXGWRWOVMXJXDVDTVLAVOVPVOMZVFVKWAUMZVOV
      TVNPVTVOWEPVTVLAVNWEBVOVTVPWGCWHQVLAWEVOVTVPWGXNVGVHXOVTVOVNPVOVTWEPVTVLA
      VNWEBVTVOVPWGCWHQVLAWEVOVTVPWGXNVIVHVJ $.

    $( Bidirectional form of ~ opprrng .  (Contributed by Mario Carneiro,
       6-Dec-2014.) $)
    opprrngb $p |- ( R e. Ring <-> O e. Ring ) $=
      ( vx vy crg wcel opprrng cfv eqid wtru cbs opprbas a1i cv cplusg co cmulr
      wceq wa coppr wb eqidd oppradd opprmul eqtr2i rngpropd trud sylibr impbii
      oveqi ) AFGZBFGZABCHUMBUAIZFGZULBUNUNJZHULUOUBKDEALIZAUNKUQUCUQUNLISKUQBU
      NUPUQABCUQJZMZMNDOZEOZAPIZQUTVAUNPIZQSKUTUQGVAUQGTTZVBVCUTVAVBBUNUPVBABCV
      BJUDUDUKNUTVAARIZQZUTVAUNRIZQZSVDVHVAUTBRIZQVFUQBVGVIUNUTVAUSVIJZUPVGJUEU
      QAVIVEBVAUTURVEJCVJUEUFNUGUHUIUJ $.

    ${
      oppr0.2 $e |- .0. = ( 0g ` R ) $.
      $( Additive identity of an opposite ring.  (Contributed by Mario
         Carneiro, 1-Dec-2014.) $)
      oppr0 $p |- .0. = ( 0g ` O ) $=
        ( vy vx cv cbs cfv wcel cplusg co wceq wa wral cio c0g eqid grpidval
        opprbas oppradd eqtr4i ) CFHZAIJZKUDGHZALJZMUFNUFUDUGMUFNOGUEPOFQBRJZGU
        EUGFACUESZUGSZETGUEUGFBUHUEABDUIUAUGABDUJUBUHSTUC $.
    $}

    ${
      oppr1.2 $e |- .1. = ( 1r ` R ) $.
      $( Multiplicative identity of an opposite ring.  (Contributed by Mario
         Carneiro, 1-Dec-2014.) $)
      oppr1 $p |- .1. = ( 1r ` O ) $=
        ( vx vy cmgp cfv c0g cv cmulr co wceq wa wral cio eqid opprmul eqeq1i
        cur cbs anbi12ci ralbii anbi2i iotabii opprbas mgpbas mgpplusg grpidval
        wcel 3eqtr4i rngidval 3eqtr4ri ) CHIZJIZAHIZJIZCUAIZBFKZAUBIZUKZUTGKZCL
        IZMZVCNZVCUTVDMZVCNZOZGVAPZOZFQVBUTVCALIZMZVCNZVCUTVLMZVCNZOZGVAPZOZFQU
        PURVKVSFVJVRVBVIVQGVAVFVPVHVNVEVOVCVAAVDVLCUTVCVARZVLRZDVDRZSTVGVMVCVAA
        VDVLCVCUTVTWADWBSTUCUDUEUFGVAVDFUOUPVACUOUORZVAACDVTUGUHCVDUOWCWBUIUPRU
        JGVAVLFUQURVAAUQUQRZVTUHAVLUQWDWAUIURRUJULCUSUOWCUSRUMABUQWDEUMUN $.
    $}

    ${
      opprneg.2 $e |- N = ( invg ` R ) $.
      $( The negative function in an opposite ring.  (Contributed by Mario
         Carneiro, 5-Dec-2014.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
      opprneg $p |- N = ( invg ` O ) $=
        ( vx vy cbs cfv cv cplusg co c0g wceq crio cmpt cminusg eqid grpinvfval
        opprbas oppradd oppr0 eqtr4i ) BFAHIZGJFJAKIZLAMIZNGUDOPCQIZFGUDUEABUFU
        DRZUERZUFRZESFGUDUECUGUFUDACDUHTUEACDUIUAACUFDUJUBUGRSUC $.
    $}

    $( Being a subgroup is a symmetric property.  (Contributed by Mario
       Carneiro, 6-Dec-2014.) $)
    opprsubg $p |- ( SubGrp ` R ) = ( SubGrp ` O ) $=
      ( vx csubg cfv cgrp wcel cbs cress co w3a eqid cplusg grpprop cvv ressbas
      wceq ax-mp ressplusg cv wss opprbas oppradd biid cin vex eqtr3i 3anbi123i
      eqtr3d issubg 3bitr4i eqriv ) DAEFZBEFZAGHZDUAZAIFZUBZAUQJKZGHZLBGHZUSBUQ
      JKZGHZLUQUNHUQUOHUPVBUSUSVAVDABURABCURMZUCZANFZABCVGMZUDZOUSUEUTVCUQURUFZ
      UTIFZVCIFZUQPHZVJVKRDUGZUQURUTPAUTMZVEQSVMVJVLRVNUQURVCPBVCMZVFQSUHVMUTNF
      ZVCNFZRVNVMVGVQVRUQVGAUTPVOVHTUQVGBVCPVPVITUJSOUIURUQAVEUKURUQBVFUKULUM
      $.
  $}

  ${
    $d x y B $.  $d x y N $.  $d x y R $.  $d x y X $.  $d x y Y $.
    mulgass3.b $e |- B = ( Base ` R ) $.
    mulgass3.m $e |- .x. = ( .g ` R ) $.
    mulgass3.t $e |- .X. = ( .r ` R ) $.
    $( An associative property between group multiple and ring multiplication.
       (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    mulgass3 $p |- ( ( R e. Ring /\ ( N e. ZZ /\ X e. B /\ Y e. B ) ) ->
        ( X .X. ( N .x. Y ) ) = ( N .x. ( X .X. Y ) ) ) $=
      ( vx vy wcel wa cfv co wceq eqid cvv a1i crg w3a coppr cmg opprrng adantr
      cz cmulr simpr1 simpr3 simpr2 opprbas mulgass2 opprmul oveq2i 3eqtr3g cbs
      syl13anc wss ssv cplusg ovex oppradd oveqi mulgpropd oveqd oveq2d 3eqtr4d
      cv ) BUAMZEUGMZFAMZGAMZUBZNZFEGBUCOZUDOZPZDPZEFGDPZVQPZFEGCPZDPEVTCPVOVRF
      VPUHOZPZEGFWCPZVQPZVSWAVOVPUAMZVKVMVLWDWFQVJWGVNBVPVPRZUEUFVJVKVLVMUIVJVK
      VLVMUJVJVKVLVMUKAVPVQWCEGFABVPWHHULZVQRZWCRZUMURABWCDVPVRFHJWHWKUNWEVTEVQ
      ABWCDVPGFHJWHWKUNUOUPVOWBVRFDVOCVQEGVOKLACVQBVPSIWJABUQOQVOHTAVPUQOQVOWIT
      ASUSVOAUTTKVIZLVIZBVAOZPZSMVOWLSMWMSMNNZWLWMWNVBTWOWLWMVPVAOZPQWPWNWQWLWM
      WNBVPWHWNRVCVDTVEZVFVGVOCVQEVTWRVFVH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Divisibility
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c ||r $. $( Ring divides relation $)
  $c Unit $. $( Ring unit $)
  $c Irred $. $( Ring irreducible $)

  $( Ring divides relation. $)
  cdsr $a class ||r $.

  $( Ring unit. $)
  cui $a class Unit $.

  $( Ring irreducibles. $)
  cir $a class Irred $.

  ${
    $d b v w x y z $.
    $( Define the (right) divisibility relation in a ring.  Access to the left
       divisibility relation is available through
       ` ( ||r `` ( oppR `` R ) ) ` .  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    df-dvdsr $a |- ||r = ( w e. _V |-> { <. x , y >. | ( x e. ( Base ` w ) /\
      E. z e. ( Base ` w ) ( z ( .r ` w ) x ) = y ) } ) $.

    $( Define the set of units in a ring.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    df-unit $a |- Unit = ( w e. _V |->
      ( `' ( ( ||r ` w ) i^i ( ||r ` ( oppR ` w ) ) ) " { ( 1r ` w ) } ) ) $.

    $( Define the set of irreducible elements in a ring.  (Contributed by Mario
       Carneiro, 4-Dec-2014.) $)
    df-irred $a |- Irred = ( w e. _V |->
      [_ ( ( Base ` w ) \ ( Unit ` w ) ) / b ]_
        { z e. b | A. x e. b A. y e. b ( x ( .r ` w ) y ) =/= z } ) $.
  $}

  ${
    $d w x y z R $.
    reldvdsr.1 $e |- .|| = ( ||r ` R ) $.
    $( The divides relation is a relation.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    reldvdsr $p |- Rel .|| $=
      ( vx vw vz vy wrel cdsr cfv cv cbs wcel cmulr co wceq wrex cvv df-dvdsr
      wa relmptopab releqi mpbir ) AHBIJZHDKZEKZLJZMFKUEUFNJOGKPFUGQTEDGRBIDGFE
      SUAAUDCUBUC $.
  $}

  ${
    $d x y .|| $.  $d b r x y z B $.  $d x y z X $.  $d x y z Y $.  $d x y Z $.
    $d x y ph $.  $d r x y z R $.  $d r x y z .x. $.
    dvdsr.1 $e |- B = ( Base ` R ) $.
    dvdsr.2 $e |- .|| = ( ||r ` R ) $.
    ${
      dvdsr.3 $e |- .x. = ( .r ` R ) $.
      $( Value of the divides relation.  (Contributed by Mario Carneiro,
         1-Dec-2014.)  (Revised by Mario Carneiro, 6-Jan-2015.) $)
      dvdsrval $p |- .|| = { <. x , y >. |
        ( x e. B /\ E. z e. B ( z .x. x ) = y ) } $=
        ( vr cvv wcel cv wceq wrex wa cfv cbs c0 copab cdsr cmulr fveq2 syl6eqr
        co eleq2d rexeqdv anbi12d oveqd eqeq1d rexbidv anbi2d opabbidv df-dvdsr
        bitrd fvex eqeltri cab eqcom rexbii abbii abrexex a1i opabex3 syl5eq wn
        fvmpt fvprc wne wex opabn0 nsyl2 adantr exlimivv sylbi necon1bi pm2.61i
        n0i eqtr4d ) FLMZEANZDMZCNZWBGUFZBNZOZCDPZQZABUAZOWAEFUBRZWJIKFWBKNZSRZ
        MZWDWBWLUCRZUFZWFOZCWMPZQZABUAWJLUBWLFOZWSWIABWTWSWCWQCDPZQWIWTWNWCWRXA
        WTWMDWBWTWMFSRZDWLFSUDHUEZUGWTWQCWMDXCUHUIWTXAWHWCWTWQWGCDWTWPWEWFWTWOG
        WDWBWTWOFUCRGWLFUCUDJUEUJUKULUMUPUNABCKUOWHABDDXBLHFSUQURZWHBUSZLMWCXEW
        FWEOZCDPZBUSLWHXGBWGXFCDWEWFUTVAVBCBDWEXDVCURVDVEVHVFWAVGZETWJXHEWKTIFU
        BVIVFWAWJTWJTVJWIBVKAVKWAWIABVLWIWAABWCWAWHWCDTOWADWBVSXHDXBTHFSVIVFVMV
        NVOVPVQVTVR $.

      $( Value of the divides relation.  (Contributed by Mario Carneiro,
         1-Dec-2014.) $)
      dvdsr $p |- ( X .|| Y <-> ( X e. B /\ E. z e. B ( z .x. X ) = Y ) ) $=
        ( vx vy wbr cvv wcel wa cv co wceq wrex wrel reldvdsr brrelex12 mpan id
        elex ovex syl6eqelr rexlimivw anim12i simpl eleq1d oveq2d simpr eqeq12d
        rexbidv anbi12d dvdsrval brabga pm5.21nii ) FGCMZFNOZGNOZPZFBOZAQZFERZG
        SZABTZPZCUAVAVDCDIUBFGCUCUDVEVBVIVCFBUFVHVCABVHGVGNVHUEVFFEUGUHUIUJKQZB
        OZVFVKERZLQZSZABTZPVJKLFGCNNVKFSZVNGSZPZVLVEVPVIVSVKFBVQVRUKZULVSVOVHAB
        VSVMVGVNGVSVKFVFEVTUMVQVRUNUOUPUQKLABCDEHIJURUSUT $.

      $( Value of the divides relation.  (Contributed by Mario Carneiro,
         1-Dec-2014.) $)
      dvdsr2 $p |- ( X e. B -> ( X .|| Y <-> E. z e. B ( z .x. X ) = Y ) ) $=
        ( wbr wcel cv co wceq wrex dvdsr baib ) FGCKFBLAMFENGOABPABCDEFGHIJQR
        $.

      $( A left-multiple of ` X ` is divisible by ` X ` .  (Contributed by
         Mario Carneiro, 1-Dec-2014.) $)
      dvdsrmul $p |- ( ( X e. B /\ Y e. B ) -> X .|| ( Y .x. X ) ) $=
        ( vz wcel wa cv co wceq wrex wbr simpl simpr eqid eqeq1d rspcev sylancl
        oveq1 dvdsr sylanbrc ) EAKZFAKZLZUGJMZEDNZFEDNZOZJAPZEULBQUGUHRUIUHULUL
        OZUNUGUHSULTUMUOJFAUJFOUKULULUJFEDUDUAUBUCJABCDEULGHIUEUF $.
    $}

    $( Closure of a dividing element.  (Contributed by Mario Carneiro,
       5-Dec-2014.) $)
    dvdsrcl $p |- ( X .|| Y -> X e. B ) $=
      ( vx wbr wcel cv cmulr cfv co wceq wrex eqid dvdsr simplbi ) DEBIDAJHKDCL
      MZNEOHAPHABCTDEFGTQRS $.

    $( Closure of a dividing element.  (Contributed by Mario Carneiro,
       5-Dec-2014.) $)
    dvdsrcl2 $p |- ( ( R e. Ring /\ X .|| Y ) -> Y e. B ) $=
      ( vx wbr crg wcel cv cmulr cfv co wceq wrex wa eqid dvdsr rngcl syl5ibcom
      3expa an32s eleq1 rexlimdva impr sylan2b ) DEBICJKZDAKZHLZDCMNZOZEPZHAQZR
      EAKZHABCULDEFGULSZTUIUJUOUPUIUJRZUNUPHAURUKAKZRUMAKZUNUPUIUSUJUTUIUSUJUTA
      CULUKDFUQUAUCUDUMEAUEUBUFUGUH $.

    $( An element in a (unital) ring divides itself.  (Contributed by Mario
       Carneiro, 1-Dec-2014.)  (Revised by Mario Carneiro, 30-Apr-2015.) $)
    dvdsrid $p |- ( ( R e. Ring /\ X e. B ) -> X .|| X ) $=
      ( crg wcel wa cur cfv cmulr co wbr eqid rngidcl dvdsrmul syl2anr rnglidm
      id breqtrd ) CGHZDAHZIDCJKZDCLKZMZDBUCUCUDAHDUFBNUBUCTACUDEUDOZPABCUEDUDE
      FUEOZQRACUEUDDEUHUGSUA $.

    $( Divisibility is transitive.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    dvdsrtr $p |- ( ( R e. Ring /\ Y .|| Z /\ Z .|| X ) -> Y .|| X ) $=
      ( vy vx crg wcel wbr wa cv cmulr co wceq wrex dvdsr cfv anbi12i an4 bitri
      reeanv simplrl simpll simprr simprl rngcl syl3anc dvdsrmul syl2anc rngass
      eqid syl13anc breqtrd oveq2 id sylan9eq breq2d rexlimdvva syl5bir expimpd
      syl5ibcom syl5bi 3impib ) CKLZEFBMZFDBMZEDBMZVIVJNZEALZFALZNZIOZECPUAZQZF
      RZIASZJOZFVQQZDRZJASZNZNZVHVKVLVMVTNZVNWDNZNWFVIWGVJWHIABCVQEFGHVQUOZTJAB
      CVQFDGHWITUBVMVTVNWDUCUDVHVOWEVKWEVSWCNZJASIASVHVONZVKVSWCIJAAUEWKWJVKIJA
      AWKVPALZWAALZNZNZEWAVRVQQZBMWJVKWOEWAVPVQQZEVQQZWPBWOVMWQALZEWRBMVHVMVNWN
      UFZWOVHWMWLWSVHVOWNUGZWKWLWMUHZWKWLWMUIZACVQWAVPGWIUJUKABCVQEWQGHWIULUMWO
      VHWMWLVMWRWPRXAXBXCWTACVQWAVPEGWIUNUPUQWJWPDEBVSWCWPWBDVRFWAVQURWCUSUTVAV
      EVBVCVDVFVG $.

    ${
      dvdsrmul1.3 $e |- .x. = ( .r ` R ) $.
      $( The divisibility relation is preserved under right-multiplication.
         (Contributed by Mario Carneiro, 1-Dec-2014.) $)
      dvdsrmul1 $p |- ( ( R e. Ring /\ Z e. B /\ X .|| Y ) ->
        ( X .x. Z ) .|| ( Y .x. Z ) ) $=
        ( vx crg wcel wbr co cv wceq wrex wa dvdsr simplll simplr simpllr rngcl
        dvdsrmul sylancom simpr rngass syl13anc breqtrrd oveq1 breq2d syl5ibcom
        syl3anc rexlimdva expimpd syl5bi 3impia ) CLMZGAMZEFBNZEGDOZFGDOZBNZVAE
        AMZKPZEDOZFQZKARZSUSUTSZVDKABCDEFHIJTVJVEVIVDVJVESZVHVDKAVKVFAMZSZVBVGG
        DOZBNVHVDVMVBVFVBDOZVNBVKVLVBAMZVBVOBNVMUSVEUTVPUSUTVEVLUAZVJVEVLUBZUSU
        TVEVLUCZACDEGHJUDUNABCDVBVFHIJUEUFVMUSVLVEUTVNVOQVQVKVLUGVRVSACDVFEGHJU
        HUIUJVHVNVCVBBVGFGDUKULUMUOUPUQUR $.
    $}

    dvdsrneg.5 $e |- N = ( invg ` R ) $.
    $( An element divides its negative.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    dvdsrneg $p |- ( ( R e. Ring /\ X e. B ) -> X .|| ( N ` X ) ) $=
      ( crg wcel wa cur cfv cmulr co wbr id cgrp rnggrp eqid grpinvcl dvdsrmul
      rngidcl syl2anc syl2anr simpl simpr rngnegl breqtrd ) CIJZEAJZKZECLMZDMZE
      CNMZOZEDMBUKUKUNAJZEUPBPUJUKQUJCRJUMAJUQCSACUMFUMTZUCACDUMFHUAUDABCUOEUNF
      GUOTZUBUEULACUOUMDEFUSURHUJUKUFUJUKUGUHUI $.

  $}

  ${
    $d B x $.  $d R x $.  $d X x $.  $d .0. x $.
    dvdsr0.b $e |- B = ( Base ` R ) $.
    dvdsr0.d $e |- .|| = ( ||r ` R ) $.
    dvdsr0.z $e |- .0. = ( 0g ` R ) $.
    $( In a ring, zero is divisible by all elements.  ("Zero divisor" as a term
       has a somewhat different meaning, see ~ df-rlreg .)  (Contributed by
       Stefan O'Rear, 29-Mar-2015.) $)
    dvdsr01 $p |- ( ( R e. Ring /\ X e. B ) -> X .|| .0. ) $=
      ( vx crg wcel wa wbr cv cmulr cfv co wceq wrex rng0cl adantr rnglz eqeq1d
      eqid oveq1 rspcev syl2anc wb dvdsr2 adantl mpbird ) CJKZDAKZLZDEBMZINZDCO
      PZQZERZIASZUNEAKZEDUQQZERZUTULVAUMACEFHTUAACUQDEFUQUDZHUBUSVCIEAUPERURVBE
      UPEDUQUEUCUFUGUMUOUTUHULIABCUQDEFGVDUIUJUK $.

    $( Only zero is divisible by zero.  (Contributed by Stefan O'Rear,
       29-Mar-2015.) $)
    dvdsr02 $p |- ( ( R e. Ring /\ X e. B ) -> ( .0. .|| X <-> X = .0. ) ) $=
      ( vx crg wcel wa wbr cv cmulr cfv wceq wrex wb adantr rng0cl dvdsr2 rngrz
      co eqid syl eqeq1d eqcom syl6bb rexbidva cgrp c0 wne rnggrp r19.9rzv 3syl
      grpbn0 bitr4d bitrd ) CJKZDAKZLZEDBMZINZECOPZUDZDQZIARZDEQZVBEAKZVCVHSUTV
      JVAACEFHUATIABCVEEDFGVEUEZUBUFUTVHVISVAUTVHVIIARZVIUTVGVIIAUTVDAKLZVGEDQV
      IVMVFEDACVEVDEFVKHUCUGEDUHUIUJUTCUKKAULUMVIVLSCUNACFUQVIIAUOUPURTUS $.
  $}

  ${
    $d r .|| $.  $d r E $.  $d r .1. $.  $d r R $.
    unit.1 $e |- U = ( Unit ` R ) $.
    unit.2 $e |- .1. = ( 1r ` R ) $.
    ${
      unit.3 $e |- .|| = ( ||r ` R ) $.
      unit.4 $e |- S = ( oppR ` R ) $.
      unit.5 $e |- E = ( ||r ` S ) $.
      $( Property of being a unit of a ring.  A unit is an element that left-
         and right-divides one.  (Contributed by Mario Carneiro, 1-Dec-2014.)
         (Revised by Mario Carneiro, 8-Dec-2015.) $)
      isunit $p |- ( X e. U <-> ( X .|| .1. /\ X E .1. ) ) $=
        ( vr wcel cvv wbr cui cfv cdsr syl6eqr cdm elfvdm eleq2s elex syl df-br
        wa cop sylbi adantr cin ccnv csn cima cv coppr cur fveq2 fveq2d ineq12d
        wceq cnveqd sneqd imaeq12d df-unit fvex eqeltri inex1 cnvex ax-mp fvmpt
        imaexg syl5eq eleq2d wrel wss inss1 reldvdsr relss eliniseg2 brin bitri
        wb mp2 syl6bb pm5.21nii ) GDNZBONZGEAPZGEFPZUGZWGBQUAZNZWHWMGBQRZDGBQUB
        HUCBWLUDUEWIWHWJWIGEUHZANZWHGEAUFWPBSUAZNZWHWRWOBSRZAWOBSUBJUCBWQUDUEUI
        UJWHWGGAFUKZULZEUMZUNZNZWKWHDXCGWHDWNXCHMBMUOZSRZXEUPRZSRZUKZULZXEUQRZU
        MZUNXCOQXEBVAZXJXAXLXBXMXIWTXMXFAXHFXMXFWSAXEBSURJTXMXHCSRFXMXGCSXMXGBU
        PRCXEBUPURKTUSLTUTVBXMXKEXMXKBUQREXEBUQURITVCVDMVEXAONXCONWTAFAWSOJBSVF
        VGVHVIXAXBOVLVJVKVMVNXDGEWTPZWKWTVOZXDXNWCWTAVPAVOXOAFVQABJVRWTAVSWDWTE
        GVTVJGEAFWAWBWEWF $.
    $}

    $( The multiplicative identity is a unit.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    1unit $p |- ( R e. Ring -> .1. e. U ) $=
      ( crg wcel cdsr cfv wbr coppr cbs rngidcl dvdsrid opprrng opprbas syl2anc
      eqid mpdan isunit sylanbrc ) AFGZCCAHIZJZCCAKIZHIZJZCBGUBCALIZGZUDUHACUHR
      ZEMZUHUCACUJUCRZNSUBUEFGUIUGAUEUERZOUKUHUFUECUHAUEUMUJPUFRZNQUCAUEBCUFCDE
      ULUMUNTUA $.
  $}

  ${
    $d x B $.  $d x R $.  $d x U $.  $d x X $.
    unitcl.1 $e |- B = ( Base ` R ) $.
    unitcl.2 $e |- U = ( Unit ` R ) $.
    $( A unit is an element of the base set.  (Contributed by Mario Carneiro,
       1-Dec-2014.) $)
    unitcl $p |- ( X e. U -> X e. B ) $=
      ( wcel cur cfv cdsr wbr coppr eqid isunit simplbi dvdsrcl syl ) DCGZDBHIZ
      BJIZKZDAGRUADSBLIZJIZKTBUBCSUCDFSMTMZUBMUCMNOATBDSEUDPQ $.

    $( The set of units is contained in the base set.  (Contributed by Mario
       Carneiro, 5-Oct-2015.) $)
    unitss $p |- U C_ B $=
      ( vx cv unitcl ssriv ) FCAABCFGDEHI $.
  $}

  ${
    $d y R $.  $d x y S $.  $d x U $.
    opprunit.1 $e |- U = ( Unit ` R ) $.
    opprunit.2 $e |- S = ( oppR ` R ) $.
    $( Being a unit is a symmetric property, so it transfers to the opposite
       ring.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    opprunit $p |- U = ( Unit ` S ) $=
      ( vx vy cfv cv cdsr wbr wa wcel cmulr co wceq wrex eqid opprbas opprmul
      cui cur coppr cbs eqtr2i eqeq1i rexbii anbi2i dvdsr 3bitr4i anbi2ci oppr1
      isunit eqriv ) FCBUAHZFIZAUBHZAJHZKZUPUQBJHZKZLVAUPUQBUCHZJHZKZLUPCMUPUOM
      USVDVAUPAUDHZMZGIZUPANHZOZUQPZGVEQZLVFVGUPVBNHZOZUQPZGVEQZLUSVDVKVOVFVJVN
      GVEVIVMUQVMUPVGBNHZOVIVEBVLVPVBVGUPVEABEVERZSZVPRZVBRZVLRZTVEAVPVHBUPVGVQ
      VHRZEVSTUEUFUGUHGVEURAVHUPUQVQURRZWBUIGVEVCVBVLUPUQVEBVBVTVRSVCRZWAUIUJUK
      URABCUQUTUPDUQRZWCEUTRZUMUTBVBUOUQVCUPUORAUQBEWEULWFVTWDUMUJUN $.
  $}

  ${
    $d y .1. $.  $d y R $.  $d y X $.
    crngunit.1 $e |- U = ( Unit ` R ) $.
    crngunit.2 $e |- .1. = ( 1r ` R ) $.
    crngunit.3 $e |- .|| = ( ||r ` R ) $.
    $( Property of being a unit in a commutative ring.  (Contributed by Mario
       Carneiro, 18-Apr-2016.) $)
    crngunit $p |- ( R e. CRing -> ( X e. U <-> X .|| .1. ) ) $=
      ( vy wcel wbr cfv wa cmulr co wceq wrex eqid dvdsr 3bitr4g ccrg coppr cbs
      cdsr cv crngoppr 3expa eqcomd an32s eqeq1d rexbidva opprbas anbi2d isunit
      pm5.32da pm4.24 ) BUAJZEDAKZEDBUBLZUDLZKZMURURMECJURUQVAURURUQEBUCLZJZIUE
      ZEUSNLZOZDPZIVBQZMVCVDEBNLZOZDPZIVBQZMVAURUQVCVHVLUQVCMZVGVKIVBVMVDVBJZMV
      FVJDUQVNVCVFVJPUQVNMVCMVJVFUQVNVCVJVFPVBBVEVIUSVDEVBRZVIRZUSRZVERZUFUGUHU
      IUJUKUOIVBUTUSVEEDVBBUSVQVOULUTRZVRSIVBABVIEDVOHVPSTUMABUSCDUTEFGHVQVSUNU
      RUPT $.
  $}

  ${
    $d r .|| $.  $d r E $.  $d r .1. $.  $d r R $.
    dvdsunit.1 $e |- U = ( Unit ` R ) $.
    dvdsunit.3 $e |- .|| = ( ||r ` R ) $.
    $( A divisor of a unit is a unit.  (Contributed by Mario Carneiro,
       18-Apr-2016.) $)
    dvdsunit $p |- ( ( R e. CRing /\ Y .|| X /\ X e. U ) -> Y e. U ) $=
      ( ccrg wcel wbr wa cur cfv crg wi crngrng eqid wb crngunit adantr dvdsrtr
      cbs 3expia sylan 3imtr4d 3impia ) BHIZEDAJZDCIZECIZUGUHKDBLMZAJZEUKAJZUIU
      JUGBNIZUHULUMOBPUNUHULUMBUBMZABUKEDUOQGUAUCUDUGUIULRUHABCUKDFUKQZGSTUGUJU
      MRUHABCUKEFUPGSTUEUF $.
  $}

  ${
    unitmulcl.1 $e |- U = ( Unit ` R ) $.
    ${
      unitmulcl.2 $e |- .x. = ( .r ` R ) $.
      $( The product of units is a unit.  (Contributed by Mario Carneiro,
         2-Dec-2014.) $)
      unitmulcl $p |- ( ( R e. Ring /\ X e. U /\ Y e. U ) ->
        ( X .x. Y ) e. U ) $=
        ( crg wcel co cfv cdsr wbr eqid unitcl syl wa isunit sylib syl3anc wceq
        w3a cur coppr simp1 cbs simp3 dvdsrmul1 rnglidm syl2anc breqtrd dvdsrtr
        simpld opprrng opprmul simprd opprbas rngridm syl5eq syl5eqbrr sylanbrc
        simp2 cmulr ) AHIZDCIZECIZUBZDEBJZAUCKZALKZMZVHVIAUDKZLKZMZVHCIVGVDVHEV
        JMEVIVJMZVKVDVEVFUEZVGVHVIEBJZEVJVGVDEAUFKZIZDVIVJMZVHVQVJMVPVGVFVSVDVE
        VFUGZVRACEVRNZFOPZVGVTDVIVMMZVGVEVTWDQVDVEVFVBZVJAVLCVIVMDFVINZVJNZVLNZ
        VMNZRSZUMVRVJABDVIEWBWGGUHTVGVDVSVQEUAVPWCVRABVIEWBGWFUIUJUKVGVOEVIVMMZ
        VGVFVOWKQWAVJAVLCVIVMEFWFWGWHWIRSZUMVRVJAVIVHEWBWGULTVGVLHIZVHDVMMWDVNV
        GVDWMVPAVLWHUNPZVGVHEDVLVCKZJZDVMVRAWOBVLEDWBGWHWONZUOVGWPVIDWOJZDVMVGW
        MDVRIZWKWPWRVMMWNVGVEWSWEVRACDWBFOPZVGVOWKWLUPVRVMVLWOEVIDVRAVLWHWBUQZW
        IWQUHTVGWRDVIBJZDVRAWOBVLVIDWBGWHWQUOVGVDWSXBDUAVPWTVRABVIDWBGWFURUJUSU
        KUTVGVTWDWJUPVRVMVLVIVHDXAWIULTVJAVLCVIVMVHFWFWGWHWIRVA $.

      unitmulclb.1 $e |- B = ( Base ` R ) $.
      $( Reversal of ~ unitmulcl in a commutative ring.  (Contributed by Mario
         Carneiro, 18-Apr-2016.) $)
      unitmulclb $p |- ( ( R e. CRing /\ X e. B /\ Y e. B ) ->
        ( ( X .x. Y ) e. U <-> ( X e. U /\ Y e. U ) ) ) $=
        ( ccrg wcel w3a co wa wbr wi dvdsrmul syl2anc dvdsunit 3expia cfv simp1
        cdsr simp2 simp3 eqid crngcom breqtrrd jcad crg crngrng 3ad2ant1 3expib
        unitmulcl syl impbid ) BJKZEAKZFAKZLZEFCMZDKZEDKZFDKZNZUTVBVCVDUTUQEVAB
        UCUAZOZVBVCPUQURUSUBZUTEFECMZVAVFUTURUSEVIVFOUQURUSUDZUQURUSUEZAVFBCEFI
        VFUFZHQRABCEFIHUGUHUQVGVBVCVFBDVAEGVLSTRUTUQFVAVFOZVBVDPVHUTUSURVMVKVJA
        VFBCFEIVLHQRUQVMVBVDVFBDVAFGVLSTRUIUTBUJKZVEVBPUQURVNUSBUKULVNVCVDVBBCD
        EFGHUNUMUOUP $.
    $}

    $d x y z G $.  $d m x y z R $.  $d m x y z U $.
    unitgrp.2 $e |- G = ( ( mulGrp ` R ) |`s U ) $.
    $( The base set of the group of units.  (Contributed by Mario Carneiro,
       25-Dec-2014.) $)
    unitgrpbas $p |- U = ( Base ` G ) $=
      ( cbs cfv wss wceq eqid unitss cmgp mgpbas ressbas2 ax-mp ) BAFGZHBCFGIPA
      BPJZDKBPCALGZEPARRJQMNO $.

    $( The group of units is a group under multiplication.  (Contributed by
       Mario Carneiro, 2-Dec-2014.) $)
    unitgrp $p |- ( R e. Ring -> G e. Grp ) $=
      ( vy vm wcel cfv cbs wceq cvv eqid cv co unitcl wa wbr wrex syl2anc vx vz
      crg cmulr cur unitgrpbas cplusg fvex eqeltri cmgp mgpplusg ressplusg mp1i
      a1i unitmulcl w3a 3anim123i rngass sylan2 1unit rnglidm cdsr coppr isunit
      simpr sylib wb adantl dvdsr2 syl opprbas anbi12d reeanv ad2antrr dvdsrmul
      simplll syl13anc simprrl opprmul simprrr syl5eqr 3eqtr3d rngridm sylanbrc
      simprl simplr oveq1d oveq2d 3brtr3d syl5eq breqtrd jca rexlimdvaa expimpd
      reximdv2 syl5bir sylbid mpd isgrpde ) AUCHZUAFUBBAUDIZCAUEIZBCJIZKWTABCDE
      UFZUNBLHXACUGIKWTBXCLXDCJUHUIBXAAUJIZCLEAXAXEXEMXAMZUKULUMAXABUANZFNZDXFU
      OXGBHZXHBHZUBNZBHZUPWTXGAJIZHZXHXMHZXKXMHZUPXGXHXAOXKXAOXGXHXKXAOXAOKXIXN
      XJXOXLXPXMABXGXMMZDPZXMABXHXQDPXMABXKXQDPUQXMAXAXGXHXKXQXFURUSABXBDXBMZUT
      XIWTXNXBXGXAOXGKXRXMAXAXBXGXQXFXSVAUSWTXIQZXGXBAVBIZRZXGXBAVCIZVBIZRZQZXH
      XGXAOZXBKZFBSZXTXIYFWTXIVEYAAYCBXBYDXGDXSYAMZYCMZYDMZVDVFXTYFYHFXMSZGNZXG
      YCUDIZOZXBKZGXMSZQZYIXTYBYMYEYRXTXNYBYMVGXIXNWTXRVHZFXMYAAXAXGXBXQYJXFVIV
      JXTXNYEYRVGYTGXMYDYCYOXGXBXMAYCYKXQVKZYLYOMZVIVJVLYSYHYQQZGXMSZFXMSXTYIYH
      YQFGXMXMVMXTUUDYHFXMBXTXOUUDXJYHQZXTXOQZUUCUUEGXMUUFYNXMHZUUCQZQZXJYHUUIX
      HXBYARXHXBYDRXJUUIYNXGYNXAOZXHXBYAUUIUUGXNYNUUJYARUUFUUGUUCWEZXTXNXOUUHYT
      VNZXMYAAXAYNXGXQYJXFVOTUUIXBYNXAOZXHXBXAOZYNXHUUIYGYNXAOZXHUUJXAOZUUMUUNU
      UIWTXOXNUUGUUOUUPKWTXIXOUUHVPZXTXOUUHWFZUULUUKXMAXAXHXGYNXQXFURVQUUIYGXBY
      NXAUUFUUGYHYQVRZWGUUIUUJXBXHXAUUIUUJYPXBXMAYOXAYCYNXGXQXFYKUUBVSUUFUUGYHY
      QVTWAZWHWBUUIWTUUGUUMYNKUUQUUKXMAXAXBYNXQXFXSVATUUIWTXOUUNXHKUUQUURXMAXAX
      BXHXQXFXSWCTWBUUTWIUUIXHXGXHYOOZXBYDUUIXOXNXHUVAYDRUURUULXMYDYCYOXHXGUUAY
      LUUBVOTUUIUVAYGXBXMAYOXAYCXGXHXQXFYKUUBVSUUSWJWKYAAYCBXBYDXHDXSYJYKYLVDWD
      UUSWLWMWNWOWPWQWRWS $.

    $( The group of units of a commutative ring is abelian.  (Contributed by
       Mario Carneiro, 19-Apr-2016.) $)
    unitabl $p |- ( R e. CRing -> G e. Abel ) $=
      ( ccrg wcel cgrp ccmn cabel crg crngrng unitgrp syl cmgp cfv cmnd crngmgp
      eqid grpmnd subcmn syl2anc isabl sylanbrc ) AFGZCHGZCIGZCJGUEAKGUFALABCDE
      MNZUEAOPZIGCQGZUGAUIUISRUEUFUJUHCTNBUICEUAUBCUCUD $.

    unitgrp.3 $e |- .1. = ( 1r ` R ) $.
    $( The identity of the multiplicative group is ` 1r ` .  (Contributed by
       Mario Carneiro, 2-Dec-2014.) $)
    unitgrpid $p |- ( R e. Ring -> .1. = ( 0g ` G ) ) $=
      ( crg wcel c0g cfv wceq 1unit cbs wss eqid unitss rngidss mp3an2 mpdan )
      AHIZCBIZCDJKLZABCEGMUABANKZOUBUCUDABUDPZEQBUDACDFUEGRST $.
  $}

  ${
    $d x R $.  $d x U $.
    unitsubm.1 $e |- U = ( Unit ` R ) $.
    unitsubm.2 $e |- M = ( mulGrp ` R ) $.
    $( The group of units is a submonoid of the multiplicative monoid of the
       ring.  (Contributed by Mario Carneiro, 18-Jun-2015.) $)
    unitsubm $p |- ( R e. Ring -> U e. ( SubMnd ` M ) ) $=
      ( crg wcel csubmnd cfv cbs wss cur cress cmnd eqid unitss a1i 1unit syl
      co cgrp cmgp oveq1i unitgrp grpmnd w3a wb rngmgp mgpbas issubm2 mpbir3and
      rngidval ) AFGZBCHIGZBAJIZKZALIZBGZCBMTZNGZUPUMUOABUOOZDPQABUQDUQOZRUMUSU
      AGUTABUSDCAUBIBMEUCUDUSUESUMCNGUNUPURUTUFUGACEUHUOBUSCUQUOACEVAUIAUQCEVBU
      LUSOUJSUK $.
  $}

  $c invr $.

  $( Extend class notation with multiplicative inverse. $)
  cinvr $a class invr $.

  $( Define multiplicative inverse.  (Contributed by NM, 21-Sep-2011.) $)
  df-invr $a |- invr = ( r e. _V |-> ( invg `
    ( ( mulGrp ` r ) |`s ( Unit ` r ) ) ) ) $.

  ${
    $d r G $.  $d r R $.
    invrfval.u $e |- U = ( Unit ` R ) $.
    invrfval.g $e |- G = ( ( mulGrp ` R ) |`s U ) $.
    invrfval.i $e |- I = ( invr ` R ) $.
    $( Multiplicative inverse function for a division ring.  (Contributed by
       NM, 21-Sep-2011.)  (Revised by Mario Carneiro, 25-Dec-2014.) $)
    invrfval $p |- I = ( invg ` G ) $=
      ( vr cinvr cfv cminusg cvv wceq cmgp cui cress co fveq2 syl6eqr c0 fveq2d
      wcel cv oveq12d df-invr fvex fvmpt fvprc wfn base0 eqid grpinvfn fn0 mpbi
      wn oveq1d syl5eq ress0 syl6eq eqtr4d pm2.61i eqtri ) DAIJZCKJZGALUBZVCVDM
      HAHUCZNJZVFOJZPQZKJVDLIVFAMZVICKVJVIANJZBPQZCVJVGVKVHBPVFANRVJVHAOJBVFAOR
      ESUDFSUAHUECKUFUGVEUOZVCTKJZVDVMVCTVNAIUHVNTUIVNTMTTVNUJVNUKULVNUMUNSVMCT
      KVMCTBPQZTVMCVLVOFVMVKTBPANUHUPUQBURUSUAUTVAVB $.
  $}

  ${
    unitinvcl.1 $e |- U = ( Unit ` R ) $.
    unitinvcl.2 $e |- I = ( invr ` R ) $.
    $( The inverse of a unit exists and is a unit.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    unitinvcl $p |- ( ( R e. Ring /\ X e. U ) -> ( I ` X ) e. U ) $=
      ( crg wcel cmgp cfv cress co cgrp eqid unitgrpbas invrfval grpinvcl sylan
      unitgrp ) AGHAIJBKLZMHDBHDCJBHABTETNZSBTCDABTEUAOABTCEUAFPQR $.

    $( The inverse of the inverse of a unit is the same element.  (Contributed
       by Mario Carneiro, 4-Dec-2014.) $)
    unitinvinv $p |- ( ( R e. Ring /\ X e. U ) -> ( I ` ( I ` X ) ) = X ) $=
      ( crg wcel cmgp cfv cress co cgrp wceq eqid unitgrpbas invrfval grpinvinv
      unitgrp sylan ) AGHAIJBKLZMHDBHDCJCJDNABUAEUAOZSBUACDABUAEUBPABUACEUBFQRT
      $.

    ${
      rnginvcl.3 $e |- B = ( Base ` R ) $.
      $( The inverse of a unit is an element of the ring.  (Contributed by
         Mario Carneiro, 2-Dec-2014.) $)
      rnginvcl $p |- ( ( R e. Ring /\ X e. U ) -> ( I ` X ) e. B ) $=
        ( crg wcel wa cfv unitinvcl unitcl syl ) BIJECJKEDLZCJPAJBCDEFGMABCPHFN
        O $.
    $}

    unitinvcl.3 $e |- .x. = ( .r ` R ) $.
    unitinvcl.4 $e |- .1. = ( 1r ` R ) $.
    $( A unit times its inverse is the identity.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    unitlinv $p |- ( ( R e. Ring /\ X e. U ) -> ( ( I ` X ) .x. X ) = .1. ) $=
      ( crg wcel wa cfv co cmgp wceq eqid cvv cui cress cgrp unitgrp unitgrpbas
      c0g cplusg fvex eqeltri mgpplusg ressplusg ax-mp invrfval sylan unitgrpid
      grplinv adantr eqtr4d ) AKLZFCLZMFENFBOZAPNZCUAOZUENZDURVBUBLUSUTVCQACVBG
      VBRZUCCBVBEFVCACVBGVDUDCSLBVBUFNQCATNSGATUGUHCBVAVBSVDABVAVARIUIUJUKVCRAC
      VBEGVDHULUOUMURDVCQUSACDVBGVDJUNUPUQ $.

    $( A unit times its inverse is the identity.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    unitrinv $p |- ( ( R e. Ring /\ X e. U ) -> ( X .x. ( I ` X ) ) = .1. ) $=
      ( crg wcel wa cfv co cmgp wceq eqid cvv cui cress cgrp unitgrp unitgrpbas
      c0g cplusg fvex eqeltri mgpplusg ressplusg ax-mp invrfval sylan unitgrpid
      grprinv adantr eqtr4d ) AKLZFCLZMFFENBOZAPNZCUAOZUENZDURVBUBLUSUTVCQACVBG
      VBRZUCCBVBEFVCACVBGVDUDCSLBVBUFNQCATNSGATUGUHCBVAVBSVDABVAVARIUIUJUKVCRAC
      VBEGVDHULUOUMURDVCQUSACDVBGVDJUNUPUQ $.
  $}

  ${
    1rinv.1 $e |- I = ( invr ` R ) $.
    1rinv.2 $e |- .1. = ( 1r ` R ) $.
    $( The inverse of the identity is the identity.  (Contributed by Mario
       Carneiro, 18-Jun-2015.) $)
    1rinv $p |- ( R e. Ring -> ( I ` .1. ) = .1. ) $=
      ( crg wcel cfv cmulr co cbs wceq cui eqid 1unit rnginvcl rnglidm unitrinv
      mpdan eqtr3d ) AFGZBBCHZAIHZJZUBBUAUBAKHZGZUDUBLUABAMHZGZUFAUGBUGNZEOZUEA
      UGCBUIDUENZPSUEAUCBUBUKUCNZEQSUAUHUDBLUJAUCUGBCBUIDULERST $.
  $}

  ${
    0unit.1 $e |- U = ( Unit ` R ) $.
    0unit.2 $e |- .0. = ( 0g ` R ) $.
    0unit.3 $e |- .1. = ( 1r ` R ) $.
    $( The additive identity is a unit if and only if ` 1 = 0 ` , i.e. we are
       in the zero ring.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    0unit $p |- ( R e. Ring -> ( .0. e. U <-> .1. = .0. ) ) $=
      ( crg wcel wceq wa cinvr cfv cmulr co eqid unitrinv cbs rnginvcl rnglz
      syldan eqtr3d simpr 1unit adantr eqeltrrd impbida ) AHIZDBIZCDJZUHUIKDDAL
      MZMZANMZOZCDAUMBCUKDEUKPZUMPZGQUHUIULARMZIUNDJUQABUKDEUOUQPZSUQAUMULDURUP
      FTUAUBUHUJKCDBUHUJUCUHCBIUJABCEGUDUEUFUG $.
  $}

  ${
    $d x N $.  $d x R $.  $d x X $.
    unitnegcl.1 $e |- U = ( Unit ` R ) $.
    unitnegcl.2 $e |- N = ( invg ` R ) $.
    $( The negative of a unit is a unit.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    unitnegcl $p |- ( ( R e. Ring /\ X e. U ) -> ( N ` X ) e. U ) $=
      ( crg wcel wa cfv cur cdsr wbr eqid syl2an breqtrd isunit dvdsrtr syl3anc
      dvdsrneg coppr simpl cbs cgrp rnggrp unitcl grpinvcl wceq grpinvinv simpr
      syldan simpld opprrng adantr opprbas opprneg syl2anc simprd sylanbrc
      sylib ) AGHZDBHZIZDCJZAKJZALJZMZVDVEAUAJZLJZMZVDBHVCVAVDDVFMDVEVFMZVGVAVB
      UBVCVDVDCJZDVFVAVBVDAUCJZHZVDVLVFMVAAUDHZDVMHZVNVBAUEZVMABDVMNZEUFZVMACDV
      RFUGOZVMVFACVDVRVFNZFTUKVAVOVPVLDUHVBVQVSVMACDVRFUIOZPVCVKDVEVIMZVCVBVKWC
      IVAVBUJVFAVHBVEVIDEVENZWAVHNZVINZQUTZULVMVFAVEVDDVRWARSVCVHGHZVDDVIMWCVJV
      AWHVBAVHWEUMUNZVCVDVLDVIVCWHVNVDVLVIMWIVTVMVIVHCVDVMAVHWEVRUOZWFACVHWEFUP
      TUQWBPVCVKWCWGURVMVIVHVEVDDWJWFRSVFAVHBVEVIVDEWDWAWEWFQUS $.
  $}

  $c /r $.

  $( Extend class notation with ring division. $)
  cdvr $a class /r $.

  ${
    $d r x y $.
    $( Define ring division.  (Contributed by Mario Carneiro, 2-Jul-2014.) $)
    df-dvr $a |- /r = ( r e. _V
     |-> ( x e. ( Base ` r ) , y e. ( Unit ` r )
         |-> ( x ( .r ` r ) ( ( invr ` r ) ` y ) ) ) ) $.
  $}

  ${
    $d r x y B $.  $d r x y I $.  $d r x y R $.  $d r x y .x. $.  $d r x y U $.
    $d x y X $.  $d x y Y $.
    dvrval.b $e |- B = ( Base ` R ) $.
    dvrval.t $e |- .x. = ( .r ` R ) $.
    dvrval.u $e |- U = ( Unit ` R ) $.
    dvrval.i $e |- I = ( invr ` R ) $.
    dvrval.d $e |- ./ = ( /r ` R ) $.
    $( Division operation in a ring.  (Contributed by Mario Carneiro,
       2-Jul-2014.)  (Revised by Mario Carneiro, 2-Dec-2014.) $)
    dvrfval $p |- ./ = ( x e. B , y e. U |-> ( x .x. ( I ` y ) ) ) $=
      ( cfv cvv wceq cbs cui fveq2 c0 vr cdvr cv cmpt2 wcel cinvr cmulr syl6eqr
      co eqidd fveq1d oveq123d mpt2eq123dv df-dvr eqeltri mpt2ex fvmpt wn fvprc
      fvex syl5eq eqid mpt2eq12 sylancl mpt20 syl6eq eqtr4d pm2.61i eqtri ) DEU
      BNZABCGAUCZBUCZHNZFUIZUDZMEOUEZVJVOPUAEABUAUCZQNZVQRNZVKVLVQUFNZNZVQUGNZU
      IZUDVOOUBVQEPZABVRVSWCCGVNWDVREQNZCVQEQSIUHWDVSERNZGVQERSKUHWDVKVKWAVMWBF
      WDWBEUGNFVQEUGSJUHWDVKUJWDVLVTHWDVTEUFNHVQEUFSLUHUKULUMABUAUNABCGVNCWEOIE
      QUTUOGWFOKERUTUOUPUQVPURZVJTVOEUBUSWGVOABTGVNUDZTWGCTPGGPVOWHPWGCWETIEQUS
      VAGVBABCGTGVNVCVDABGVNVEVFVGVHVI $.

    $( Division operation in a ring.  (Contributed by Mario Carneiro,
       2-Jul-2014.)  (Revised by Mario Carneiro, 2-Dec-2014.) $)
    dvrval $p |- ( ( X e. B /\ Y e. U ) ->
      ( X ./ Y ) = ( X .x. ( I ` Y ) ) ) $=
      ( vx vy cv cfv co oveq1 wceq fveq2 oveq2d dvrfval ovex ovmpt2 ) NOGHAENPZ
      OPZFQZDRGHFQZDRBGUHDRUFGUHDSUGHTUHUIGDUGHFUAUBNOABCDEFIJKLMUCGUIDUDUE $.
  $}

  ${
    dvrcl.b $e |- B = ( Base ` R ) $.
    dvrcl.o $e |- U = ( Unit ` R ) $.
    dvrcl.d $e |- ./ = ( /r ` R ) $.
    $( Closure of division operation.  (Contributed by Mario Carneiro,
       2-Jul-2014.) $)
    dvrcl $p |- ( ( R e. Ring /\ X e. B /\ Y e. U ) -> ( X ./ Y ) e. B ) $=
      ( crg wcel w3a co cinvr cfv cmulr wceq eqid dvrval 3adant1 rnginvcl rngcl
      3adant2 syld3an3 eqeltrd ) CJKZEAKZFDKZLEFBMZEFCNOZOZCPOZMZAUGUHUIUMQUFAB
      CULDUJEFGULRZHUJRZISTUFUGUHUKAKZUMAKUFUHUPUGACDUJFHUOGUAUCACULEUKGUNUBUDU
      E $.
  $}

  ${
    unitdvcl.o $e |- U = ( Unit ` R ) $.
    unitdvcl.d $e |- ./ = ( /r ` R ) $.
    $( The units are closed under division.  (Contributed by Mario Carneiro,
       2-Jul-2014.) $)
    unitdvcl $p |- ( ( R e. Ring /\ X e. U /\ Y e. U ) -> ( X ./ Y ) e. U ) $=
      ( crg wcel w3a co cinvr cfv cmulr wceq cbs eqid unitcl dvrval sylan
      3adant1 unitinvcl 3adant2 unitmulcl syld3an3 eqeltrd ) BHIZDCIZECIZJDEAKZ
      DEBLMZMZBNMZKZCUHUIUJUNOZUGUHDBPMZIUIUOUPBCDUPQZFRUPABUMCUKDEUQUMQZFUKQZG
      STUAUGUHUIULCIZUNCIUGUIUTUHBCUKEFUSUBUCBUMCDULFURUDUEUF $.

    dvrid.o $e |- .1. = ( 1r ` R ) $.
    $( A cancellation law for division.  ( ~ divid analog.)  (Contributed by
       Mario Carneiro, 18-Jun-2015.) $)
    dvrid $p |- ( ( R e. Ring /\ X e. U ) -> ( X ./ X ) = .1. ) $=
      ( crg wcel wa co cinvr cfv cmulr cbs wceq eqid unitcl adantl dvrval eqtrd
      sylancom unitrinv ) BIJZECJZKEEALZEEBMNZNBONZLZDUEUFEBPNZJZUGUJQUFULUEUKB
      CEUKRZFSTUKABUICUHEEUMUIRZFUHRZGUAUCBUICDUHEFUOUNHUDUB $.
  $}

  ${
    dvr1.b $e |- B = ( Base ` R ) $.
    dvr1.d $e |- ./ = ( /r ` R ) $.
    dvr1.o $e |- .1. = ( 1r ` R ) $.
    $( A cancellation law for division.  ( ~ div1 analog.)  (Contributed by
       Mario Carneiro, 18-Jun-2015.) $)
    dvr1 $p |- ( ( R e. Ring /\ X e. B ) -> ( X ./ .1. ) = X ) $=
      ( crg wcel wa co cinvr cfv cmulr cui wceq id eqid 1unit syl2anr rngridm
      dvrval 1rinv adantr oveq2d 3eqtrd ) CIJZEAJZKZEDBLZEDCMNZNZCONZLZEDUNLEUI
      UIDCPNZJUKUOQUHUIRCUPDUPSZHTABCUNUPULEDFUNSZUQULSZGUCUAUJUMDEUNUHUMDQUICD
      ULUSHUDUEUFACUNDEFURHUBUG $.
  $}

  ${
    dvrass.b $e |- B = ( Base ` R ) $.
    dvrass.o $e |- U = ( Unit ` R ) $.
    dvrass.d $e |- ./ = ( /r ` R ) $.
    dvrass.t $e |- .x. = ( .r ` R ) $.
    $( An associative law for division.  ( ~ divass analog.)  (Contributed by
       Mario Carneiro, 4-Dec-2014.) $)
    dvrass $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. B /\ Z e. U ) ) ->
      ( ( X .x. Y ) ./ Z ) = ( X .x. ( Y ./ Z ) ) ) $=
      ( crg wcel w3a co cfv wceq syl2anc dvrval cinvr simpr1 simpr2 simpr3 eqid
      wa simpl rnginvcl rngass syl13anc rngcl 3adant3r3 oveq2d 3eqtr4d ) CMNZFA
      NZGANZHENZOZUFZFGDPZHCUAQZQZDPZFGVCDPZDPZVAHBPZFGHBPZDPUTUOUPUQVCANZVDVFR
      UOUSUGZUOUPUQURUBUOUPUQURUCZUTUOURVIVJUOUPUQURUDZACEVBHJVBUEZIUHSACDFGVCI
      LUIUJUTVAANZURVGVDRUOUPUQVNURACDFGILUKULVLABCDEVBVAHILJVMKTSUTVHVEFDUTUQU
      RVHVERVKVLABCDEVBGHILJVMKTSUMUN $.

    $( A cancellation law for division.  ( ~ divcan1 analog.)  (Contributed by
       Mario Carneiro, 2-Jul-2014.)  (Revised by Mario Carneiro,
       2-Dec-2014.) $)
    dvrcan1 $p |- ( ( R e. Ring /\ X e. B /\ Y e. U ) ->
      ( ( X ./ Y ) .x. Y ) = X ) $=
      ( crg wcel w3a co cfv wceq eqid 3adant2 eqtrd cinvr dvrval 3adant1 oveq1d
      simp1 simp2 rnginvcl unitcl 3ad2ant3 rngass syl13anc cur unitlinv rngridm
      oveq2d 3adant3 ) CLMZFAMZGEMZNZFGBOZGDOFGCUAPZPZDOZGDOZFUTVAVDGDURUSVAVDQ
      UQABCDEVBFGHKIVBRZJUBUCUDUTVEFVCGDOZDOZFUTUQURVCAMZGAMZVEVHQUQURUSUEUQURU
      SUFUQUSVIURACEVBGIVFHUGSUSUQVJURACEGHIUHUIACDFVCGHKUJUKUTVHFCULPZDOZFUTVG
      VKFDUQUSVGVKQURCDEVKVBGIVFKVKRZUMSUOUQURVLFQUSACDVKFHKVMUNUPTTT $.

    $( A cancellation law for division.  ( ~ divcan3 analog.)  (Contributed by
       Mario Carneiro, 2-Jul-2014.)  (Revised by Mario Carneiro,
       18-Jun-2015.) $)
    dvrcan3 $p |- ( ( R e. Ring /\ X e. B /\ Y e. U ) ->
      ( ( X .x. Y ) ./ Y ) = X ) $=
      ( crg wcel w3a co cur cfv wceq simp1 simp2 unitcl 3ad2ant3 simp3 syl13anc
      dvrass eqid dvrid 3adant2 oveq2d rngridm 3adant3 3eqtrd ) CLMZFAMZGEMZNZF
      GDOGBOZFGGBOZDOZFCPQZDOZFUPUMUNGAMZUOUQUSRUMUNUOSUMUNUOTUOUMVBUNACEGHIUAU
      BUMUNUOUCABCDEFGGHIJKUEUDUPURUTFDUMUOURUTRUNBCEUTGIJUTUFZUGUHUIUMUNVAFRUO
      ACDUTFHKVCUJUKUL $.
  $}

  ${
    dvreq1.b $e |- B = ( Base ` R ) $.
    dvreq1.o $e |- U = ( Unit ` R ) $.
    dvreq1.d $e |- ./ = ( /r ` R ) $.
    dvreq1.t $e |- .1. = ( 1r ` R ) $.
    $( A cancellation law for division.  ( ~ diveq1 analog.)  (Contributed by
       Mario Carneiro, 28-Apr-2016.) $)
    dvreq1 $p |- ( ( R e. Ring /\ X e. B /\ Y e. U ) ->
                   ( ( X ./ Y ) = .1. <-> X = Y ) ) $=
      ( crg wcel w3a co wceq cmulr cfv oveq1 3adant2 eqid dvrcan1 unitcl sylan2
      rnglidm eqeq12d syl5ib dvrid eqeq1d syl5ibrcom impbid ) CLMZFAMZGDMZNZFGB
      OZEPZFGPZUQUPGCQRZOZEGUSOZPUOURUPEGUSSUOUTFVAGABCUSDFGHIJUSUAZUBULUNVAGPZ
      UMUNULGAMVCACDGHIUCACUSEGHVBKUEUDTUFUGUOUQURGGBOZEPZULUNVEUMBCDEGIJKUHTUR
      UPVDEFGGBSUIUJUK $.
  $}

  ${
    rnginvdv.b $e |- B = ( Base ` R ) $.
    rnginvdv.u $e |- U = ( Unit ` R ) $.
    rnginvdv.d $e |- ./ = ( /r ` R ) $.
    rnginvdv.o $e |- .1. = ( 1r ` R ) $.
    rnginvdv.i $e |- I = ( invr ` R ) $.
    $( Write the inverse function in terms of division.  (Contributed by Mario
       Carneiro, 2-Jul-2014.) $)
    rnginvdv $p |- ( ( R e. Ring /\ X e. U ) -> ( I ` X ) = ( .1. ./ X ) ) $=
      ( crg wcel wa co cfv cmulr wceq rngidcl eqid dvrval sylan rnginvcl syldan
      rnglidm eqtr2d ) CMNZGDNZOEGBPZEGFQZCRQZPZUKUHEANUIUJUMSACEHKTABCULDFEGHU
      LUAZILJUBUCUHUIUKANUMUKSACDFGILHUDACULEUKHUNKUFUEUG $.
  $}

  ${
    $d x y B $.  $d x y z K $.  $d x y z L $.  $d x y z ph $.
    rngidpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    rngidpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    rngidpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( The ring identity depends only on the ring's base set and multiplication
       operation.  (Contributed by Mario Carneiro, 26-Dec-2014.) $)
    rngidpropd $p |- ( ph -> ( 1r ` K ) = ( 1r ` L ) ) $=
      ( cmgp cfv c0g cur cbs eqid mgpbas syl6eq cv wcel co cmulr mgpplusg oveqi
      wa cplusg 3eqtr3g grpidpropd rngidval 3eqtr4g ) AEJKZLKFJKZLKEMKZFMKZABCD
      UJUKADENKZUJNKGUNEUJUJOZUNOPQADFNKZUKNKHUPFUKUKOZUPOPQABRZDSCRZDSUDUDURUS
      EUAKZTURUSFUAKZTURUSUJUEKZTURUSUKUEKZTIUTVBURUSEUTUJUOUTOUBUCVAVCURUSFVAU
      KUQVAOUBUCUFUGEULUJUOULOUHFUMUKUQUMOUHUI $.

    $( The divisibility relation depends only on the ring's base set and
       multiplication operation.  (Contributed by Mario Carneiro,
       26-Dec-2014.) $)
    dvdsrpropd $p |- ( ph -> ( ||r ` K ) = ( ||r ` L ) ) $=
      ( vz cv cbs cfv wcel cmulr co wceq wrex wa eqid copab cdsr anassrs eqeq1d
      an32s rexbidva pm5.32da rexeqdv anbi12d 3bitr3d opabbidv dvdsrval 3eqtr4g
      wb eleq2d ) ACKZELMZNZBKZUPEOMZPZJKZQZBUQRZSZCJUAUPFLMZNZUSUPFOMZPZVBQZBV
      FRZSZCJUAEUBMZFUBMZAVEVLCJAUPDNZVCBDRZSVOVJBDRZSVEVLAVOVPVQAVOSVCVJBDAUSD
      NZVOVCVJUNAVRSVOSVAVIVBAVRVOVAVIQIUCUDUEUFUGAVOURVPVDADUQUPGUOAVCBDUQGUHU
      IAVOVGVQVKADVFUPHUOAVJBDVFHUHUIUJUKCJBUQVMEUTUQTVMTUTTULCJBVFVNFVHVFTVNTV
      HTULUM $.

    $( The set of units depends only on the ring's base set and multiplication
       operation.  (Contributed by Mario Carneiro, 26-Dec-2014.) $)
    unitpropd $p |- ( ph -> ( Unit ` K ) = ( Unit ` L ) ) $=
      ( vz cfv cv cdsr wbr wa wcel cbs eqid cmulr co cui cur rngidpropd anbi12d
      coppr breq2d dvdsrpropd breqd opprbas syl6eq wceq ancom2s opprmul 3eqtr4g
      bitrd isunit 3bitr4g eqrdv ) AJEUAKZFUAKZAJLZEUBKZEMKZNZVAVBEUEKZMKZNZOZV
      AFUBKZFMKZNZVAVIFUEKZMKZNZOZVAUSPVAUTPAVHVAVIVCNZVAVIVFNZOVOAVDVPVGVQAVBV
      IVAVCABCDEFGHIUCZUFAVBVIVAVFVRUFUDAVPVKVQVNAVCVJVAVIABCDEFGHIUGUHAVFVMVAV
      IACBDVEVLADEQKZVEQKGVSEVEVERZVSRZUIUJADFQKZVLQKHWBFVLVLRZWBRZUIUJACLZDPZB
      LZDPZOOWGWEESKZTZWGWEFSKZTZWEWGVESKZTWEWGVLSKZTAWHWFWJWLUKIULVSEWMWIVEWEW
      GWAWIRVTWMRUMWBFWNWKVLWEWGWDWKRWCWNRUMUNUGUHUDUOVCEVEUSVBVFVAUSRVBRVCRVTV
      FRUPVJFVLUTVIVMVAUTRVIRVJRWCVMRUPUQUR $.

    $( The ring inverse function depends only on the ring's base set and
       multiplication operation.  (Contributed by Mario Carneiro,
       26-Dec-2014.)  (Revised by Mario Carneiro, 5-Oct-2015.) $)
    invrpropd $p |- ( ph -> ( invr ` K ) = ( invr ` L ) ) $=
      ( cmgp cfv cui cress co cbs wceq eqid wcel wa cvv cminusg cinvr unitpropd
      unitgrpbas a1i syl6eq cmulr cplusg unitss syl5sseqr sselda anim12dan fvex
      cv syldan mgpplusg ressplusg ax-mp 3eqtr3g grpinvpropd invrfval 3eqtr4g
      oveqi ) AEJKZELKZMNZUAKFJKZFLKZMNZUAKEUBKZFUBKZABCVEVFVIVEVFOKPAEVEVFVEQZ
      VFQZUDUEAVEVHVIOKABCDEFGHIUCFVHVIVHQZVIQZUDUFABUNZVERZCUNZVERZSZSVPVREUGK
      ZNZVPVRFUGKZNZVPVRVFUHKZNVPVRVIUHKZNAVTVPDRZVRDRZSWBWDPAVQWGVSWHAVEDVPAEO
      KZVEDWIEVEWIQVLUIGUJZUKAVEDVRWJUKULIUOWAWEVPVRVETRWAWEPELUMVEWAVDVFTVMEWA
      VDVDQWAQUPUQURVCWCWFVPVRVHTRWCWFPFLUMVHWCVGVITVOFWCVGVGQWCQUPUQURVCUSUTEV
      EVFVJVLVMVJQVAFVHVIVKVNVOVKQVAVB $.
  $}

  ${
    $d b r x y z N $.  $d b r x y z R $.  $d b r z .x. $.  $d x y z X $.
    irred.1 $e |- B = ( Base ` R ) $.
    irred.2 $e |- U = ( Unit ` R ) $.
    irred.3 $e |- I = ( Irred ` R ) $.
    irred.4 $e |- N = ( B \ U ) $.
    irred.5 $e |- .x. = ( .r ` R ) $.
    $( An irreducible element of a ring is a non-unit that is not the product
       of two non-units.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    isirred $p |- ( X e. I <-> ( X e. N /\
      A. x e. N A. y e. N ( x .x. y ) =/= X ) ) $=
      ( vz wcel cvv wral cfv cbs vr vb cv co wne cir cdm elfvdm eleq2s elex syl
      wa cdif eldifi syl6eleq elfvexd adantr crab cui csb wceq fvex difexg mp1i
      cmulr simpr simpl fveq2d syl6eqr difeq12d eqtrd oveqd raleqbidv rabeqbidv
      neeq1d csbied df-irred ax-mp rabex fvmpt syl5eq eleq2d neeq2 elrab syl6bb
      eqeltri 2ralbidv pm5.21nii ) IGPZDQPZIHPZAUCZBUCZEUDZIUEZBHRAHRZULZWIDUFU
      GZPZWJWSIDUFSZGIDUFUHLUIDWRUJUKWKWJWPWKITDWKICDTSZICPICFUMZHICFUNMUIJUOUP
      UQWJWIIWNOUCZUEZBHRZAHRZOHURZPWQWJGXGIWJGWTXGLUADUBUAUCZTSZXHUSSZUMZWLWMX
      HVESZUDZXCUEZBUBUCZRZAXORZOXOURZUTXGQUFXHDVAZUBXKXRXGQXIQPXKQPXSXHTVBXIXJ
      QVCVDXSXOXKVAZULZXQXFOXOHYAXOXKHXSXTVFYAXKXBHYAXICXJFYAXIXACYAXHDTXSXTVGZ
      VHJVIYAXJDUSSFYAXHDUSYBVHKVIVJMVIVKZYAXPXEAXOHYCYAXNXDBXOHYCYAXMWNXCYAXLE
      WLWMYAXLDVESEYAXHDVEYBVHNVIVLVOVMVMVNVPABOUAUBVQXFOHHXBQMCQPXBQPCXAQJDTVB
      WFCFQVCVRWFVSVTWAWBXFWPOIHXCIVAXDWOABHHXCIWNWCWGWDWEWH $.

    $( The property of being a non-irreducible (reducible) element in a ring.
       (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    isnirred $p |- ( X e. B -> ( -. X e. I <-> ( X e. U \/
      E. x e. N E. y e. N ( x .x. y ) = X ) ) ) $=
      ( wcel cv wrex wn wa wral co wceq wo wne cdif eleq2i eldif bitri baibr wb
      df-ne ralbii ralnex bitr2i a1i anbi12d ioran isirred 3bitr4g con1bid ) IC
      OZIFOZAPBPEUAZIUBZBHQZAHQZUCZIGOZVAVBRZVFRZSIHOZVCIUDZBHTZAHTZSVGRVHVAVIV
      KVJVNVKVAVIVKICFUEZOVAVISHVOIMUFICFUGUHUIVJVNUJVAVNVERZAHTVJVMVPAHVMVDRZB
      HTVPVLVQBHVCIUKULVDBHUMUHULVEAHUMUNUOUPVBVFUQABCDEFGHIJKLMNURUSUT $.
  $}

  ${
    $d x y B $.  $d x y R $.  $d x y U $.  $d x y X $.
    isirred2.1 $e |- B = ( Base ` R ) $.
    isirred2.2 $e |- U = ( Unit ` R ) $.
    isirred2.3 $e |- I = ( Irred ` R ) $.
    isirred2.4 $e |- .x. = ( .r ` R ) $.
    $( Expand out the set differences from ~ isirred .  (Contributed by Mario
       Carneiro, 4-Dec-2014.) $)
    isirred2 $p |- ( X e. I <-> ( X e. B /\ -. X e. U /\
      A. x e. B A. y e. B ( ( x .x. y ) = X -> ( x e. U \/ y e. U ) ) ) ) $=
      ( wcel wral wa wn wi eldif wal bitri cdif cv co wne wo w3a anbi12i imbi1i
      wceq impexp pm4.56 df-ne imbi12i con34b bitr4i imbi2i 2albii r2al 3bitr4i
      an4 eqid isirred df-3an ) HCFUAZMZAUBZBUBZEUCZHUDZBVDNAVDNZOHCMZHFMPZOZVH
      HUIZVFFMZVGFMZUEZQZBCNACNZOHGMVKVLVSUFVEVMVJVSHCFRVFVDMZVGVDMZOZVIQZBSASV
      FCMZVGCMZOZVRQZBSASVJVSWCWGABWCWFVOPZVPPZOZOZVIQZWGWBWKVIWBWDWHOZWEWIOZOW
      KVTWMWAWNVFCFRVGCFRUGWDWHWEWIUTTUHWLWFWJVIQZQWGWFWJVIUJWOVRWFWOVQPZVNPZQV
      RWJWPVIWQVOVPUKVHHULUMVNVQUNUOUPTTUQVIABVDVDURVRABCCURUSUGABCDEFGVDHIJKVD
      VALVBVKVLVSVCUS $.
  $}

  ${
    $d x I $.  $d y z R $.  $d x y z S $.
    opprirred.1 $e |- S = ( oppR ` R ) $.
    opprirred.2 $e |- I = ( Irred ` R ) $.
    $( Irreducibility is symmetric, so the irreducible elements of the opposite
       ring are the same as the original ring.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    opprirred $p |- I = ( Irred ` S ) $=
      ( vx vz vy cir cfv cv cbs wcel cmulr co wne wral wa eqid isirred cui cdif
      ralcom opprmul neeq1i 2ralbii bitr4i anbi2i opprbas opprunit 3bitr4i
      eqriv ) FCBIJZFKZALJZAUAJZUBZMZGKZHKZANJZOZUNPZHUQQGUQQZRURUTUSBNJZOZUNPZ
      GUQQHUQQZRUNCMUNUMMVDVHURVDVCGUQQHUQQVHVCGHUQUQUCVGVCHGUQUQVFVBUNUOAVEVAB
      UTUSUOSZVASZDVESZUDUEUFUGUHGHUOAVAUPCUQUNVIUPSZEUQSZVJTHGUOBVEUPUMUQUNUOA
      BDVIUIABUPVLDUJUMSVMVKTUKUL $.
  $}

  ${
    $d x y z R $.  $d x y z .x. $.  $d x y z U $.  $d x y z X $.  $d x y z Y $.
    $d x y B $.  $d x y I $.  $d x y .0. $.
    irredn0.i $e |- I = ( Irred ` R ) $.
    ${
      irredn0.z $e |- .0. = ( 0g ` R ) $.
      $( The additive identity is not irreducible.  (Contributed by Mario
         Carneiro, 4-Dec-2014.) $)
      irredn0 $p |- ( ( R e. Ring /\ X e. I ) -> X =/= .0. ) $=
        ( vx vy crg wcel wa wn cfv cv co wceq wrex eqid adantr eqeq1d wne cmulr
        cui cbs cdif rng0cl anim1i eldif sylibr rnglz mpdan oveq1 oveq2 rspc2ev
        wo syl3anc ex wb isnirred syl mpbird simpr eleq1 syl5ibcom necon3bd mpd
        orrd ) AIJZCBJZKZDBJZLZCDUAVHVLVIVHVLDAUCMZJZGNZHNZAUBMZOZDPZHAUDMZVMUE
        ZQGWAQZUOZVHVNWBVHVNLZWBVHWDKZDWAJZWFDDVQOZDPZWBWEDVTJZWDKWFVHWIWDVTADV
        TRZFUFZUGDVTVMUHUIZWLVHWHWDVHWIWHWKVTAVQDDWJVQRZFUJUKSVSWHDVPVQOZDPGHDD
        WAWAVODPVRWNDVODVPVQULTVPDPWNWGDVPDDVQUMTUNUPUQVGVHWIVLWCURWKGHVTAVQVMB
        WADWJVMREWARWMUSUTVASVJVKCDVJVICDPVKVHVIVBCDBVCVDVEVF $.
    $}

    ${
      irredcl.b $e |- B = ( Base ` R ) $.
      $( An irreducible element is in the ring.  (Contributed by Mario
         Carneiro, 4-Dec-2014.) $)
      irredcl $p |- ( X e. I -> X e. B ) $=
        ( vx vy wcel cui cfv wn cv cmulr co wceq wo wi wral eqid isirred2
        simp1bi ) DCIDAIDBJKZILGMZHMZBNKZODPUDUCIUEUCIQRHASGASGHABUFUCCDFUCTEUF
        TUAUB $.
    $}

    ${
      irrednu.u $e |- U = ( Unit ` R ) $.
      $( An irreducible element is not a unit.  (Contributed by Mario Carneiro,
         4-Dec-2014.) $)
      irrednu $p |- ( X e. I -> -. X e. U ) $=
        ( vx vy wcel cbs cfv wn cv cmulr co wceq wo wi wral eqid isirred2
        simp2bi ) DCIDAJKZIDBILGMZHMZANKZODPUDBIUEBIQRHUCSGUCSGHUCAUFBCDUCTFEUF
        TUAUB $.
    $}

    ${
      irredn1.o $e |- .1. = ( 1r ` R ) $.
      $( The multiplicative identity is not irreducible.  (Contributed by Mario
         Carneiro, 4-Dec-2014.) $)
      irredn1 $p |- ( ( R e. Ring /\ X e. I ) -> X =/= .1. ) $=
        ( crg wcel wne cui wn eqid irrednu wceq 1unit eleq1 syl5ibrcom necon3bd
        cfv syl5 imp ) AGHZDCHZDBIZUCDAJSZHZKUBUDAUECDEUELZMUBUFDBUBUFDBNBUEHAU
        EBUGFODBUEPQRTUA $.
    $}

    ${
      irredrmul.u $e |- U = ( Unit ` R ) $.
      irredrmul.t $e |- .x. = ( .r ` R ) $.
      $( The product of an irreducible element and a unit is irreducible.
         (Contributed by Mario Carneiro, 4-Dec-2014.) $)
      irredrmul $p |- ( ( R e. Ring /\ X e. I /\ Y e. U ) ->
        ( X .x. Y ) e. I ) $=
        ( vx vy vz wcel co cv wceq wrex wn eqid syl3anc crg w3a cbs cfv cdif wo
        simp2 cdvr simp1 simp3 unitdvcl 3com23 syl2anc irredcl 3ad2ant2 dvrcan3
        wi 3expia eleq1d sylibd ad2antrr eldifi ad2antrl dvrcl eldifn unitmulcl
        wa dvrcan1 eldifd simprr oveq1d ad2antlr dvrass syl13anc 3eqtr3d eqeq1d
        oveq2 rspcev rexlimdvaa reximdva orim12d unitcl 3ad2ant3 rngcl isnirred
        mtod wb syl 3imtr4d mt4d ) AUAMZEDMZFCMZUBZWLEFBNZDMZWKWLWMUGWNWOCMZJOZ
        KOZBNZWOPZKAUCUDZCUEZQZJXCQZUFZECMZWRLOZBNZEPZLXCQZJXCQZUFZWPRZWLRZWNWQ
        XGXEXLWNWQWOFAUHUDZNZCMZXGWNWKWMWQXRUQWKWLWMUIZWKWLWMUJZWKWMWQXRWKWQWMX
        RXPACWOFHXPSZUKULURUMWNXQECWNWKEXBMZWMXQEPZXSWLWKYBWMXBADEGXBSZUNUOZXTX
        BXPABCEFYDHYAIUPTZUSUTWNXDXKJXCWNWRXCMZVGZXAXKKXCYHWSXCMZXAVGZVGZWSFXPN
        ZXCMWRYLBNZEPZXKYKYLXBCYKWKWSXBMZWMYLXBMWNWKYGYJXSVAZYIYOYHXAWSXBCVBVCZ
        WNWMYGYJXTVAZXBXPACWSFYDHYAVDTYKYLCMZWSCMZYIYTRYHXAWSXBCVEVCYKYSYLFBNZC
        MZYTYKWKWMYSUUBUQYPYRWKWMYSUUBWKYSWMUUBABCYLFHIVFULURUMYKUUAWSCYKWKYOWM
        UUAWSPYPYQYRXBXPABCWSFYDHYAIVHTUSUTWFVIYKWTFXPNZXQYMEYKWTWOFXPYHYIXAVJV
        KYKWKWRXBMZYOWMUUCYMPYPYGUUDWNYJWRXBCVBVLYQYRXBXPABCWRWSFYDHYAIVMVNWNYC
        YGYJYFVAVOXJYNLYLXCXHYLPXIYMEXHYLWRBVQVPVRUMVSVTWAWNWOXBMZXNXFWGWNWKYBF
        XBMZUUEXSYEWMWKUUFWLXBACFYDHWBWCXBABEFYDIWDTJKXBABCDXCWOYDHGXCSZIWEWHWN
        YBXOXMWGYEJLXBABCDXCEYDHGUUGIWEWHWIWJ $.

      $( The product of a unit and an irreducible element is irreducible.
         (Contributed by Mario Carneiro, 4-Dec-2014.) $)
      irredlmul $p |- ( ( R e. Ring /\ X e. U /\ Y e. I ) ->
        ( X .x. Y ) e. I ) $=
        ( crg wcel w3a co coppr cfv cmulr cbs eqid opprmul opprrng opprirred
        opprunit irredrmul syl3an1 3com23 syl5eqelr ) AJKZECKZFDKZLEFBMFEANOZPO
        ZMZDAQOZAUKBUJFEUMRIUJRZUKRZSUGUIUHULDKZUGUJJKUIUHUPAUJUNTUJUKCDFEAUJDU
        NGUAAUJCHUNUBUOUCUDUEUF $.
    $}

    ${
      irredmul.b $e |- B = ( Base ` R ) $.
      irredmul.u $e |- U = ( Unit ` R ) $.
      irredmul.t $e |- .x. = ( .r ` R ) $.
      $( If product of two elements is irreducible, then one of the elements
         must be a unit.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
      irredmul $p |- ( ( X e. B /\ Y e. B /\ ( X .x. Y ) e. I ) ->
        ( X e. U \/ Y e. U ) ) $=
        ( vx vy wcel co wo cv wceq wi wral wa isirred2 simp3bi eqid oveq1 eleq1
        wn eqeq1d orbi1d imbi12d oveq2 orbi2d rspc2v mpii syl5 3impia ) FANZGAN
        ZFGCOZENZFDNZGDNZPZUTLQZMQZCOZUSRZVDDNZVEDNZPZSZMATLATZUQURUAZVCUTUSANU
        SDNUGVLLMABCDEUSIJHKUBUCVMVLUSUSRZVCUSUDVKVNVCSFVECOZUSRZVAVIPZSLMFGAAV
        DFRZVGVPVJVQVRVFVOUSVDFVECUEUHVRVHVAVIVDFDUFUIUJVEGRZVPVNVQVCVSVOUSUSVE
        GFCUKUHVSVIVBVAVEGDUFULUJUMUNUOUP $.
    $}

    ${
      irredneg.n $e |- N = ( invg ` R ) $.
      $( The negative of an irreducible element is irreducible.  (Contributed
         by Mario Carneiro, 4-Dec-2014.) $)
      irredneg $p |- ( ( R e. Ring /\ X e. I ) -> ( N ` X ) e. I ) $=
        ( crg wcel wa cur cfv cmulr cbs eqid simpl irredcl adantl rngnegr cui
        co 1unit unitnegcl mpdan adantr irredrmul mpd3an3 eqeltrrd ) AGHZDBHZIZ
        DAJKZCKZALKZTZDCKBUJAMKZAUMUKCDUONZUMNZUKNZFUHUIOUIDUOHUHUOABDEUPPQRUHU
        IULASKZHZUNBHUHUTUIUHUKUSHUTAUSUKUSNZURUAAUSCUKVAFUBUCUDAUMUSBDULEVAUQU
        EUFUG $.

      irrednegb.b $e |- B = ( Base ` R ) $.
      $( An element is irreducible iff its negative is.  (Contributed by Mario
         Carneiro, 4-Dec-2014.) $)
      irrednegb $p |- ( ( R e. Ring /\ X e. B ) ->
        ( X e. I <-> ( N ` X ) e. I ) ) $=
        ( crg wcel cfv irredneg adantlr wceq cgrp rnggrp grpinvinv sylan adantr
        wa eqeltrrd impbida ) BIJZEAJZTZECJZEDKZCJZUCUFUHUDBCDEFGLMUEUHTUGDKZEC
        UEUIENZUHUCBOJUDUJBPABDEHGQRSUCUHUICJUDBCDUGFGLMUAUB $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Ring homomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RingHom $. $( Ring homomorphism $)
  $c RingIso $. $( Ring isomorphism $)

  $( Ring homomorphisms. $)
  crh $a class RingHom $.

  $( Ring isomorphisms. $)
  crs $a class RingIso $.

  ${
    $d r s v w f x y m n $.
    $( Define the set of ring homomorphisms from ` r ` to ` s ` .  (Contributed
       by Stefan O'Rear, 7-Mar-2015.) $)
    df-rnghom $a |- RingHom = ( r e. Ring , s e. Ring |->
      [_ ( Base ` r ) / v ]_ [_ ( Base ` s ) / w ]_
   { f e. ( w ^m v ) | ( ( f ` ( 1r ` r ) ) = ( 1r ` s ) /\ A. x e. v A. y e. v
   ( ( f ` ( x ( +g ` r ) y ) ) = ( ( f ` x ) ( +g ` s ) ( f ` y ) ) /\
     ( f ` ( x ( .r ` r ) y ) ) = ( ( f ` x ) ( .r ` s ) ( f ` y ) ) ) ) } ) $.

    $( Define the set of ring isomorphisms from ` r ` to ` s ` .  (Contributed
       by Stefan O'Rear, 7-Mar-2015.) $)
    df-rngiso $a |- RingIso = ( r e. _V , s e. _V |->
      { f e. ( r RingHom s ) | `' f e. ( s RingHom r ) } ) $.

    $( The property of a ring homomorphism can be decomposed into separate
       homomorphic conditions for addition and multiplication.  (Contributed by
       Stefan O'Rear, 7-Mar-2015.) $)
    dfrhm2 $p |- RingHom = ( r e. Ring , s e. Ring |->
          ( ( r GrpHom s ) i^i ( ( mulGrp ` r ) MndHom ( mulGrp ` s ) ) ) ) $=
      ( vv vw vf vx vy crg cv cbs cfv wceq co wa wral crab wcel cab wb eqid crh
      cur cplusg cmulr cmap csb cmpt2 cghm cmgp cmhm df-rnghom wf rnggrp isghm3
      cin cgrp syl2an abbi2dv df-rab fvex elmap anbi1i abbii eqtri syl6eqr cmnd
      rngmgp mgpbas mgpplusg rngidval ismhm baib 3anass bitr4i ineq12d r19.26-2
      w3a ancom anass 3bitri a1i rabbiia oveq12 ancoms raleqbi1dv adantr anbi2d
      raleq rabeqbidv csbie2 inrab 3eqtr4i syl6reqr mpt2eq3ia ) UABAHHCBIZJKZDA
      IZJKZWOUBKZEIZKWQUBKZLZFIZGIZWOUCKZMWTKXCWTKZXDWTKZWQUCKZMLZXCXDWOUDKZMWT
      KXFXGWQUDKZMLZNZGCIZOZFXNOZNZEDIZXNUEMZPZUFUFZUGBAHHWOWQUHMZWOUIKZWQUIKZU
      JMZUOZUGFGDCEABUKBAHHYAYFWOHQZWQHQZNZYFXIGWPOFWPOZEWRWPUEMZPZXLGWPOFWPOZX
      BNZEYKPZUOZYAYIYBYLYEYOYIYBWPWRWTULZYJNZERZYLYIYREYBYGWOUPQWQUPQWTYBQYRSY
      HWOUMWQUMGFXEXHWOWQWTWPWRWPTZWRTZXETXHTUNUQURYLWTYKQZYJNZERYSYJEYKUSUUCYR
      EUUBYQYJWRWPWTWQJUTZWOJUTZVAZVBVCVDVEYIYEYQYMXBVQZERZYOYIUUGEYEYGYCVFQZYD
      VFQZWTYEQZUUGSYHWOYCYCTZVGWQYDYDTZVGUUKUUIUUJNUUGFGWPWRXJXKYCYDWTXAWSWPWO
      YCUULYTVHWRWQYDUUMUUAVHWOXJYCUULXJTVIWQXKYDUUMXKTVIWOWSYCUULWSTVJWQXAYDUU
      MXATVJVKVLUQURYOUUBYNNZERUUHYNEYKUSUUNUUGEUUNYQYNNUUGUUBYQYNUUFVBYQYMXBVM
      VNVCVDVEVOXBXMGWPOZFWPOZNZEYKPZYJYNNZEYKPYAYPUUQUUSEYKUUQUUSSUUBUUQUUPXBN
      YJYMNZXBNUUSXBUUPVRUUPUUTXBXIXLFGWPWPVPVBYJYMXBVSVTWAWBCDWPWRXTUURUUEUUDX
      NWPLZXRWRLZNZXQUUQEXSYKUVBUVAXSYKLXRWRXNWPUEWCWDUVCXPUUPXBUVAXPUUPSUVBXOU
      UOFXNWPXMGXNWPWHWEWFWGWIWJYJYNEYKWKWLWMWNVD $.
  $}

  ${
    $d r s $.
    $( Reverse closure of a ring homomorphism.  (Contributed by Stefan O'Rear,
       7-Mar-2015.) $)
    rhmrcl1 $p |- ( F e. ( R RingHom S ) -> R e. Ring ) $=
      ( vr vs crg cv cghm co cmgp cfv cmhm cin crh dfrhm2 elmpt2cl1 ) DEFFDGZEG
      ZHIQJKRJKLIMABNCEDOP $.

    $( Reverse closure of a ring homomorphism.  (Contributed by Stefan O'Rear,
       7-Mar-2015.) $)
    rhmrcl2 $p |- ( F e. ( R RingHom S ) -> S e. Ring ) $=
      ( vr vs crg cv cghm co cmgp cfv cmhm cin crh dfrhm2 elmpt2cl2 ) DEFFDGZEG
      ZHIQJKRJKLIMABNCEDOP $.
  $}

  ${
    $d R r s $.  $d S r s $.
    isrhm.m $e |- M = ( mulGrp ` R ) $.
    isrhm.n $e |- N = ( mulGrp ` S ) $.
    $( A function is a ring homomorphism iff it preserves both addition and
       multiplication.  (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    isrhm $p |- ( F e. ( R RingHom S ) <-> ( ( R e. Ring /\ S e. Ring ) /\
          ( F e. ( R GrpHom S ) /\ F e. ( M MndHom N ) ) ) ) $=
      ( vr vs crh co wcel crg wa cghm cmhm cv cmgp cfv cin dfrhm2 elmpt2cl wceq
      oveq12 fveq2 oveqan12d ineq12d inex1 ovmpt2a eleq2d oveq12i eqcomi eleq2i
      ovex elin anbi2i bitri syl6bb biadan2 ) CABJKZLZAMLBMLNZCABOKZLZCDEPKZLZN
      ZHIMMHQZIQZOKZVHRSZVIRSZPKZTZABJCIHUAZUBVBVACVCARSZBRSZPKZTZLZVGVBUTVSCHI
      ABMMVNVSJVHAUCZVIBUCZNVJVCVMVRVHAVIBOUDWAWBVKVPVLVQPVHARUEVIBRUEUFUGVOVCV
      RABOUNUHUIUJVTVDCVRLZNVGCVCVRUOWCVFVDVRVECVEVRDVPEVQPFGUKULUMUPUQURUS $.

    $( A ring homomorphism is a homomorphism of multiplicative monoids.
       (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    rhmmhm $p |- ( F e. ( R RingHom S ) -> F e. ( M MndHom N ) ) $=
      ( crh co wcel cghm cmhm crg wa isrhm simprbi simprd ) CABHIJZCABKIJZCDELI
      JZRAMJBMJNSTNABCDEFGOPQ $.
  $}

  $( A ring homomorphism is an additive group homomorphism.  (Contributed by
     Stefan O'Rear, 7-Mar-2015.) $)
  rhmghm $p |- ( F e. ( R RingHom S ) -> F e. ( R GrpHom S ) ) $=
    ( crh co wcel cghm cmgp cfv cmhm crg wa eqid isrhm simprbi simpld ) CABDEFZ
    CABGEFZCAHIZBHIZJEFZQAKFBKFLRUALABCSTSMTMNOP $.

  ${
    rhmf.b $e |- B = ( Base ` R ) $.
    rhmf.c $e |- C = ( Base ` S ) $.
    $( A ring homomorphism is a function.  (Contributed by Stefan O'Rear,
       8-Mar-2015.) $)
    rhmf $p |- ( F e. ( R RingHom S ) -> F : B --> C ) $=
      ( crh co wcel cghm wf rhmghm ghmf syl ) ECDHIJECDKIJABELCDEMCDEABFGNO $.
  $}

  ${
    rhmmul.x $e |- X = ( Base ` R ) $.
    rhmmul.m $e |- .x. = ( .r ` R ) $.
    rhmmul.n $e |- .X. = ( .r ` S ) $.
    $( A homomorphism of rings preserves multiplication.  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    rhmmul $p |- ( ( F e. ( R RingHom S ) /\ A e. X /\ B e. X ) ->
      ( F ` ( A .x. B ) ) = ( ( F ` A ) .X. ( F ` B ) ) ) $=
      ( crh co wcel cmgp cfv cmhm wceq eqid mgpplusg rhmmhm mgpbas syl3an1
      mhmlin ) GCDLMNGCOPZDOPZQMNAHNBHNABEMGPAGPBGPFMRCDGUEUFUESZUFSZUAHEFUEUFG
      ABHCUEUGIUBCEUEUGJTDFUFUHKTUDUC $.
  $}

  ${
    $d ph x y $.  $d B x y $.  $d C x y $.  $d F x y $.  $d .+ x y $.
    $d .+^ x y $.  $d R x y $.  $d S x y $.
    isrhmd.b $e |- B = ( Base ` R ) $.
    isrhmd.o $e |- .1. = ( 1r ` R ) $.
    isrhmd.n $e |- N = ( 1r ` S ) $.
    isrhmd.t $e |- .x. = ( .r ` R ) $.
    isrhmd.u $e |- .X. = ( .r ` S ) $.
    isrhmd.r $e |- ( ph -> R e. Ring ) $.
    isrhmd.s $e |- ( ph -> S e. Ring ) $.
    isrhmd.ho $e |- ( ph -> ( F ` .1. ) = N ) $.
    isrhmd.ht $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( F ` ( x .x. y ) ) = ( ( F ` x ) .X. ( F ` y ) ) ) $.
    ${
      isrhm2d.f $e |- ( ph -> F e. ( R GrpHom S ) ) $.
      $( Demonstration of ring homomorphism.  (Contributed by Mario Carneiro,
         13-Jun-2015.) $)
      isrhm2d $p |- ( ph -> F e. ( R RingHom S ) ) $=
        ( crg wcel wa cghm co cmgp cfv cmhm crh jca cmnd cbs wf cv wceq c0g w3a
        wral eqid rngmgp syl ralrimivva rngidval fveq2i 3eqtr3g mgpbas mgpplusg
        ghmf 3jca ismhm sylanbrc isrhm ) AEUBUCZFUBUCZUDJEFUEUFUCZJEUGUHZFUGUHZ
        UIUFUCZUDJEFUJUFUCAVNVOQRUKAVPVSUAAVQULUCZVRULUCZUDDFUMUHZJUNZBUOZCUOZG
        UFJUHWDJUHWEJUHHUFUPZCDUSBDUSZVQUQUHZJUHZVRUQUHZUPZURVSAVTWAAVNVTQEVQVQ
        UTZVAVBAVOWARFVRVRUTZVAVBUKAWCWGWKAVPWCUAEFJDWBLWBUTZVIVBAWFBCDDTVCAIJU
        HKWIWJSIWHJEIVQWLMVDVEFKVRWMNVDVFVJBCDWBGHVQVRJWJWHDEVQWLLVGWBFVRWMWNVG
        EGVQWLOVHFHVRWMPVHWHUTWJUTVKVLUKEFJVQVRWLWMVMVL $.
    $}

    isrhmd.c $e |- C = ( Base ` S ) $.
    isrhmd.p $e |- .+ = ( +g ` R ) $.
    isrhmd.q $e |- .+^ = ( +g ` S ) $.
    isrhmd.f $e |- ( ph -> F : B --> C ) $.
    isrhmd.hp $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( F ` ( x .+ y ) ) = ( ( F ` x ) .+^ ( F ` y ) ) ) $.
    $( Demonstration of ring homomorphism.  (Contributed by Stefan O'Rear,
       8-Mar-2015.) $)
    isrhmd $p |- ( ph -> F e. ( R RingHom S ) ) $=
      ( crg wcel cgrp rnggrp syl isghmd isrhm2d ) ABCDHIJKLMNOPQRSTUAUBUCABCFGH
      IMDEOUDUEUFAHUIUJHUKUJTHULUMAIUIUJIUKUJUAIULUMUGUHUNUO $.
  $}

  ${
    rhm1.o $e |- .1. = ( 1r ` R ) $.
    rhm1.n $e |- N = ( 1r ` S ) $.
    $( Ring homomorphisms are required to fix 1.  (Contributed by Stefan
       O'Rear, 8-Mar-2015.) $)
    rhm1 $p |- ( F e. ( R RingHom S ) -> ( F ` .1. ) = N ) $=
      ( crh co wcel cmgp cfv c0g cmhm wceq eqid rhmmhm mhm0 syl rngidval fveq2i
      3eqtr4g ) DABHIJZAKLZMLZDLZBKLZMLZCDLEUCDUDUGNIJUFUHOABDUDUGUDPZUGPZQUDUG
      DUHUEUEPUHPRSCUEDACUDUIFTUABEUGUJGTUB $.
  $}

  $( The composition of ring homomorphisms is a homomorphism.  (Contributed by
     Mario Carneiro, 12-Jun-2015.) $)
  rhmco $p |- ( ( F e. ( T RingHom U ) /\ G e. ( S RingHom T ) ) ->
      ( F o. G ) e. ( S RingHom U ) ) $=
    ( crh co wcel crg ccom cghm cmgp cfv cmhm rhmrcl2 rhmghm syl2an eqid rhmmhm
    wa rhmrcl1 anim12ci ghmco mhmco jca isrhm sylanbrc ) DBCFGHZEABFGHZTZAIHZCI
    HZTDEJZACKGHZUMALMZCLMZNGHZTUMACFGHUHULUIUKBCDOABEUAUBUJUNUQUHDBCKGHEABKGHU
    NUIBCDPABEPABCDEUCQUHDBLMZUPNGHEUOURNGHUQUIBCDURUPURRZUPRZSABEUOURUORZUSSUO
    URUPDEUDQUEACUMUOUPVAUTUFUG $.

  ${
    $d g x y A $.  $d g x y B $.  $d g x y ph $.  $d g x y R $.  $d g x y Y $.
    $d g C $.  $d g F $.  $d g x y Z $.
    pwsco1rhm.y $e |- Y = ( R ^s A ) $.
    pwsco1rhm.z $e |- Z = ( R ^s B ) $.
    pwsco1rhm.c $e |- C = ( Base ` Z ) $.
    pwsco1rhm.r $e |- ( ph -> R e. Ring ) $.
    pwsco1rhm.a $e |- ( ph -> A e. V ) $.
    pwsco1rhm.b $e |- ( ph -> B e. W ) $.
    pwsco1rhm.f $e |- ( ph -> F : A --> B ) $.
    $( Right composition with a function on the index sets yields a ring
       homomorphism of structure powers.  (Contributed by Mario Carneiro,
       12-Jun-2015.) $)
    pwsco1rhm $p |- ( ph -> ( g e. C |-> ( g o. F ) ) e. ( Z RingHom Y ) ) $=
      ( wcel eqid vx vy crg wa cv ccom cmpt cghm co cmgp cfv crh pwsrng syl2anc
      cmhm jca cmnd rngmnd syl pwsco1mhm cgrp wceq rnggrp ghmmhmb eleqtrrd cpws
      cbs rngmgp cmap pwsbas syl6eqr mgpbas eqtr3d mpteq1d cplusg pwsmgp simpld
      eqidd simprd proplem3 mhmpropd 3eltr4d isrhm sylanbrc ) AKUCSZJUCSZUDFDFU
      EGUFZUGZKJUHUIZSZWHKUJUKZJUJUKZUOUIZSZUDWHKJULUISAWEWFAEUCSZCISZWEOQECIKM
      UMUNZAWOBHSZWFOPEBHJLUMUNZUPAWJWNAWHKJUOUIZWIABCDEFGHIJKLMNAWOEUQSZOEURUS
      ZPQRUTAKVASZJVASZWIWTVBAWEXCWQKVCUSAWFXDWSJVCUSKJVDUNVEAFEUJUKZCVFUIZVGUK
      ZWGUGXFXEBVFUIZUOUIWHWMABCXGXEFGHIXHXFXHTZXFTZXGTZAWOXEUQSZOEXEXETZVHUSZP
      QRUTAFDXGWGAEVGUKZCVIUIZDXGAXPKVGUKZDAXAWPXPXQVBXBQXOECUQIKMXOTZVJUNNVKAX
      LWPXPXGVBXNQXOXECUQIXFXJXOEXEXMXRVLVJUNVMVNAUAUBWKVGUKZWLVGUKZWKWLXFXHAXS
      VRAXTVRAXSXGVBZWKVOUKZXFVOUKZVBZAWOWPYAYDUDOQXSXGYBYCECXEWKUCIKXFMXMXJWKT
      ZXSTXKYBTYCTVPUNZVQAXTXHVGUKZVBZWLVOUKZXHVOUKZVBZAWOWRYHYKUDOPXTYGYIYJEBX
      EWLUCHJXHLXMXIWLTZXTTYGTYITYJTVPUNZVQAUAUEZXSSUBUEZXSSUDUAUBYBYCAYAYDYFVS
      VTAYNXTSYOXTSUDUAUBYIYJAYHYKYMVSVTWAWBUPKJWHWKWLYEYLWCWD $.
  $}

  ${
    $d g x y A $.  $d g x y ph $.  $d g x y R $.  $d g x y S $.  $d g x y Y $.
    $d g B $.  $d g F $.  $d g x y Z $.
    pwsco2rhm.y $e |- Y = ( R ^s A ) $.
    pwsco2rhm.z $e |- Z = ( S ^s A ) $.
    pwsco2rhm.b $e |- B = ( Base ` Y ) $.
    pwsco2rhm.a $e |- ( ph -> A e. V ) $.
    pwsco2rhm.f $e |- ( ph -> F e. ( R RingHom S ) ) $.
    $( Left composition with a ring homomorphism yields a ring homomorphism of
       structure powers.  (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    pwsco2rhm $p |- ( ph -> ( g e. B |-> ( F o. g ) ) e. ( Y RingHom Z ) ) $=
      ( wcel co cfv syl eqid vx vy crg wa cv ccom cmpt cghm cmgp rhmrcl1 pwsrng
      cmhm crh syl2anc rhmrcl2 rhmghm ghmmhm pwsco2mhm cgrp wceq rnggrp ghmmhmb
      jca eleqtrrd cpws rhmmhm cmap pwsbas syl6eqr rngmgp mgpbas eqtr3d mpteq1d
      cmnd eqidd cplusg pwsmgp simpld simprd proplem3 mhmpropd 3eltr4d sylanbrc
      cbs isrhm ) AIUCPZJUCPZUDFCGFUEUFZUGZIJUHQZPZWIIUIRZJUIRZULQZPZUDWIIJUMQP
      AWFWGADUCPZBHPZWFAGDEUMQPZWPODEGUJSZNDBHIKUKUNZAEUCPZWQWGAWRXAODEGUOSZNEB
      HJLUKUNZVCAWKWOAWIIJULQZWJABCDEFGHIJKLMNAGDEUHQPZGDEULQPAWRXEODEGUPSDEGUQ
      SURAIUSPZJUSPZWJXDUTAWFXFWTIVASAWGXGXCJVASIJVBUNVDAFDUIRZBVEQZWDRZWHUGXIE
      UIRZBVEQZULQWIWNABXJXHXKFGHXIXLXITZXLTZXJTZNAWRGXHXKULQPODEGXHXKXHTZXKTZV
      FSURAFCXJWHADWDRZBVGQZCXJAXSIWDRZCAWPWQXSXTUTWSNXRDBUCHIKXRTZVHUNMVIAXHVN
      PZWQXSXJUTAWPYBWSDXHXPVJSNXRXHBVNHXIXMXRDXHXPYAVKVHUNVLVMAUAUBWLWDRZWMWDR
      ZWLWMXIXLAYCVOAYDVOAYCXJUTZWLVPRZXIVPRZUTZAWPWQYEYHUDWSNYCXJYFYGDBXHWLUCH
      IXIKXPXMWLTZYCTXOYFTYGTVQUNZVRAYDXLWDRZUTZWMVPRZXLVPRZUTZAXAWQYLYOUDXBNYD
      YKYMYNEBXKWMUCHJXLLXQXNWMTZYDTYKTYMTYNTVQUNZVRAUAUEZYCPUBUEZYCPUDUAUBYFYG
      AYEYHYJVSVTAYRYDPYSYDPUDUAUBYMYNAYLYOYQVSVTWAWBVCIJWIWLWMYIYPWEWC $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Division rings and fields
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c DivRing $.
  $c Field $.

  $( Extend class notation with class of all division rings. $)
  cdr $a class DivRing $.

  $( Class of fields. $)
  cfield $a class Field $.

  $( Define class of all division rings.  A division ring is a ring in which
     the set of units is exactly the nonzero elements of the ring.
     (Contributed by NM, 18-Oct-2012.) $)
  df-drng $a |- DivRing = { r e. Ring |
    ( Unit ` r ) = ( ( Base ` r ) \ { ( 0g ` r ) } ) } $.

  $( A _field_ is a commutative division ring.  (Contributed by Mario Carneiro,
     17-Jun-2015.) $)
  df-field $a |- Field = ( DivRing i^i CRing ) $.

  ${
    $d r B $.  $d r R $.  $d r U $.  $d r .0. $.
    isdrng.b $e |- B = ( Base ` R ) $.
    isdrng.u $e |- U = ( Unit ` R ) $.
    isdrng.z $e |- .0. = ( 0g ` R ) $.
    $( The predicate "is a division ring".  (Contributed by NM, 18-Oct-2012.)
       (Revised by Mario Carneiro, 2-Dec-2014.) $)
    isdrng $p |- ( R e. DivRing <-> ( R e. Ring /\ U = ( B \ { .0. } ) ) ) $=
      ( vr cv cui cfv cbs c0g csn cdif wceq crg cdr fveq2 syl6eqr sneqd eqeq12d
      difeq12d df-drng elrab2 ) HIZJKZUFLKZUFMKZNZOZPCADNZOZPHBQRUFBPZUGCUKUMUN
      UGBJKCUFBJSFTUNUHAUJULUNUHBLKAUFBLSETUNUIDUNUIBMKDUFBMSGTUAUCUBHUDUE $.

    $( Elementhood in the set of units when ` R ` is a division ring.
       (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    drngunit $p |- ( R e. DivRing ->
      ( X e. U <-> ( X e. B /\ X =/= .0. ) ) ) $=
      ( cdr wcel csn cdif wne wa crg wceq isdrng simprbi eleq2d eldifsn syl6bb
      ) BIJZDCJDAEKLZJDAJDEMNUBCUCDUBBOJCUCPABCEFGHQRSDAETUA $.
  $}

  ${
    $d r B $.  $d r R $.  $d r U $.  $d r .0. $.
    drngui.b $e |- B = ( Base ` R ) $.
    drngui.z $e |- .0. = ( 0g ` R ) $.
    drngui.r $e |- R e. DivRing $.
    $( The set of units of a division ring.  (Contributed by Mario Carneiro,
       2-Dec-2014.) $)
    drngui $p |- ( B \ { .0. } ) = ( Unit ` R ) $=
      ( cui cfv csn cdif crg wcel wceq cdr wa eqid isdrng mpbi simpri eqcomi )
      BGHZACIJZBKLZUAUBMZBNLUCUDOFABUACDUAPEQRST $.
  $}

  $( A division ring is a ring.  (Contributed by NM, 8-Sep-2011.) $)
  drngrng $p |- ( R e. DivRing -> R e. Ring ) $=
    ( cdr wcel crg cui cfv cbs c0g csn cdif wceq eqid isdrng simplbi ) ABCADCAE
    FZAGFZAHFZIJKPAOQPLOLQLMN $.

  $( A division ring is a group.  (Contributed by NM, 8-Sep-2011.) $)
  drnggrp $p |- ( R e. DivRing -> R e. Grp ) $=
    ( cdr wcel crg cgrp drngrng rnggrp syl ) ABCADCAECAFAGH $.

  $( A field is a commutative division ring.  (Contributed by Mario Carneiro,
     17-Jun-2015.) $)
  isfld $p |- ( R e. Field <-> ( R e. DivRing /\ R e. CRing ) ) $=
    ( cdr ccrg cfield df-field elin2 ) ABCDEF $.

  ${
    $d x y B $.  $d x y G $.  $d x y R $.  $d y T $.  $d x .0. $.
    isdrng2.b $e |- B = ( Base ` R ) $.
    isdrng2.z $e |- .0. = ( 0g ` R ) $.
    isdrng2.g $e |- G = ( ( mulGrp ` R ) |`s ( B \ { .0. } ) ) $.
    $( A division ring can equivalently be defined as a ring such that the
       nonzero elements form a group under multiplication (from which it
       follows that this is the same group as the group of units).
       (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    isdrng2 $p |- ( R e. DivRing <-> ( R e. Ring /\ G e. Grp ) ) $=
      ( vx wcel cfv wceq wa cgrp eqid cress co adantr syl2anc wbr cvv cdif cmgp
      cdr crg cui csn isdrng adantl syl6eqr unitgrp eqeltrrd cv wne unitcl cdvr
      oveq2 c0g cmulr wss cbs difss mgpbas ressbas2 ax-mp grpidcl eldifsn sylib
      ad2antlr simprd eldifad simpr dvrcan1 syl3anc dvrcl rngrz 3netr4d necon3i
      simpll syl sylanbrc ssrdv cur cdsr coppr cminusg eldifi grpinvcl dvdsrmul
      ex adantll cplusg fvex eqeltri mgpplusg ressplusg grplinv rngidcl rnglidm
      difexg mp2b mpdan 1unit grpid mpbid eqtrd breqtrd opprbas opprmul grprinv
      wb sseldd syl5eq isunit eqssd impbida pm5.32i bitri ) BUCIBUDIZBUEJZADUFZ
      UAZKZLZXRCMIZLZABXSDEXSNZFUGXRYBYDXRYBYDYCBUBJZXSOPZCMYCYHYGYAOPZCYBYHYIK
      XRXSYAYGOUPUHGUIXRYHMIYBBXSYHYFYHNUJQUKYEXSYAYEHXSYAYEHULZXSIZYJYAIZYEYKL
      ZYJAIZYJDUMZYLYKYNYEABXSYJEYFUNUHYMCUQJZYJBUOJZPZYJBURJZPZYRDYSPZUMYOYMYP
      DYTUUAYMYPAIZYPDUMZYMYPYAIZUUBUUCLYDUUDXRYKYACYPYAAUSYACUTJKAXTVAYAACYGGA
      BYGYGNZEVBVCVDZYPNZVEVHZYPADVFVGVIYMXRUUBYKYTYPKXRYDYKVRZYMYPAXTUUHVJZYEY
      KVKZAYQBYSXSYPYJEYFYQNZYSNZVLVMYMXRYRAIZUUADKUUIYMXRUUBYKUUNUUIUUJUUKAYQB
      XSYPYJEYFUULVNVMABYSYRDEUUMFVORVPYJDYTUUAYJDYRYSUPVQVSYJADVFVTWIWAZYEHYAX
      SYEYLYKYEYLLZYJBWBJZBWCJZSYJUUQBWDJZWCJZSYKUUPYJYJCWEJZJZYJYSPZUUQUURUUPY
      NUVBAIZYJUVCUURSYLYNYEYJAXTWFUHZUUPUVBAXTYDYLUVBYAIXRYACUVAYJUUFUVANZWGWJ
      VJZAUURBYSYJUVBEUURNZUUMWHRUUPUVCYPUUQYDYLUVCYPKXRYAYSCUVAYJYPUUFATIYATIY
      SCWKJKABUTJTEBUTWLWMAXTTWSYAYSYGCTGBYSYGUUEUUMWNWOWTZUUGUVFWPWJYEYPUUQKZY
      LYEUUQUUQYSPUUQKZUVJXRUVKYDXRUUQAIUVKABUUQEUUQNZWQABYSUUQUUQEUUMUVLWRXAQY
      EYDUUQYAIUVKUVJXJXRYDVKYEXSYAUUQUUOXRUUQXSIYDBXSUUQYFUVLXBQXKYAYSCUUQYPUU
      FUVIUUGXCRXDQZXEXFUUPYJUVBYJUUSURJZPZUUQUUTUUPYNUVDYJUVOUUTSUVEUVGAUUTUUS
      UVNYJUVBABUUSUUSNZEXGUUTNZUVNNZWHRUUPUVOYJUVBYSPZUUQABUVNYSUUSUVBYJEUUMUV
      PUVRXHUUPUVSYPUUQYDYLUVSYPKXRYAYSCUVAYJYPUUFUVIUUGUVFXIWJUVMXEXLXFUURBUUS
      XSUUQUUTYJYFUVLUVHUVPUVQXMVTWIWAXNXOXPXQ $.
  $}

  ${
    $d x y K $.  $d x y L $.
    drngprop.b $e |- ( Base ` K ) = ( Base ` L ) $.
    drngprop.p $e |- ( +g ` K ) = ( +g ` L ) $.
    drngprop.m $e |- ( .r ` K ) = ( .r ` L ) $.
    $( If two structures have the same ring components (properties), one is a
       division ring iff the other one is.  (Contributed by Mario Carneiro,
       11-Oct-2013.)  (Revised by Mario Carneiro, 28-Dec-2014.) $)
    drngprop $p |- ( K e. DivRing <-> L e. DivRing ) $=
      ( vx vy crg wcel cui cfv cbs c0g csn cdif wceq wa a1i co eqid eqidd cmulr
      cv oveqi unitpropd cplusg grpidpropd sneqd difeq2d eqeq12d pm5.32i anbi1i
      cdr rngprop bitri isdrng 3bitr4i ) AHIZAJKZALKZAMKZNZOZPZQZBHIZBJKZUTBMKZ
      NZOZPZQZAUMIBUMIVEURVKQVLURVDVKURUSVGVCVJURFGUTABURUTUAZUTBLKPURCRZFUCZGU
      CZAUBKZSVOVPBUBKZSPURVOUTIVPUTIQQZVQVRVOVPEUDRUEURVBVIUTURVAVHURFGUTABVMV
      NVOVPAUFKZSVOVPBUFKZSPVSVTWAVOVPDUDRUGUHUIUJUKURVFVKABCDEUNULUOUTAUSVAUTT
      USTVATUPUTBVGVHCVGTVHTUPUQ $.
  $}

  ${
    drngmgp.b $e |- B = ( Base ` R ) $.
    drngmgp.z $e |- .0. = ( 0g ` R ) $.
    drngmgp.g $e |- G = ( ( mulGrp ` R ) |`s ( B \ { .0. } ) ) $.
    $( A division ring contains a multiplicative group.  (Contributed by NM,
       8-Sep-2011.) $)
    drngmgp $p |- ( R e. DivRing -> G e. Grp ) $=
      ( cdr wcel crg cgrp isdrng2 simprbi ) BHIBJICKIABCDEFGLM $.
  $}

  ${
    drngmcl.b $e |- B = ( Base ` R ) $.
    drngmcl.t $e |- .x. = ( .r ` R ) $.
    drngmcl.z $e |- .0. = ( 0g ` R ) $.
    $( The product of two nonzero elements of a division ring is nonzero.
       (Contributed by NM, 7-Sep-2011.) $)
    drngmcl $p |- ( ( R e. DivRing /\ X e. ( B \ { .0. } )
               /\ Y e. ( B \ { .0. } ) ) -> ( X .x. Y ) e. ( B \ { .0. } ) ) $=
      ( cdr wcel cmgp cfv csn cdif co eqid cbs wceq cvv cress drngmgp wss difss
      cgrp mgpbas ressbas2 ax-mp cplusg eqeltri difexg mgpplusg ressplusg grpcl
      fvex mp2b syl3an1 ) BJKBLMZAFNZOZUAPZUEKDUTKEUTKDECPUTKABVAFGIVAQZUBUTCVA
      DEUTAUCUTVARMSAUSUDUTAVAURVBABURURQZGUFUGUHATKUTTKCVAUIMSABRMTGBRUOUJAUST
      UKUTCURVATVBBCURVCHULUMUPUNUQ $.
  $}

  ${
    drngid.b $e |- B = ( Base ` R ) $.
    drngid.z $e |- .0. = ( 0g ` R ) $.
    drngid.u $e |- .1. = ( 1r ` R ) $.
    drngid.g $e |- G = ( ( mulGrp ` R ) |`s ( B \ { .0. } ) ) $.
    $( A division ring's unit is the identity element of its multiplicative
       group.  (Contributed by NM, 7-Sep-2011.) $)
    drngid $p |- ( R e. DivRing -> .1. = ( 0g ` G ) ) $=
      ( cdr wcel cmgp cfv cui cress co c0g crg wceq eqid drngrng unitgrpid cdif
      syl csn isdrng simprbi oveq2d syl6eqr fveq2d eqtrd ) BJKZCBLMZBNMZOPZQMZD
      QMULBRKZCUPSBUABUNCUOUNTZUOTHUBUDULUODQULUOUMAEUEUCZOPDULUNUSUMOULUQUNUSS
      ABUNEFURGUFUGUHIUIUJUK $.
  $}

  ${
    drngunz.z $e |- .0. = ( 0g ` R ) $.
    drngunz.u $e |- .1. = ( 1r ` R ) $.
    $( A division ring's unit is different from its zero.  (Contributed by NM,
       8-Sep-2011.) $)
    drngunz $p |- ( R e. DivRing -> .1. =/= .0. ) $=
      ( cdr wcel cbs cfv wne cui wa crg drngrng 1unit syl drngunit mpbid simprd
      eqid ) AFGZBAHIZGZBCJZUABAKIZGZUCUDLUAAMGUFANAUEBUETZEOPUBAUEBCUBTUGDQRS
      $.
  $}

  ${
    drngid2.b $e |- B = ( Base ` R ) $.
    drngid2.t $e |- .x. = ( .r ` R ) $.
    drngid2.o $e |- .0. = ( 0g ` R ) $.
    drngid2.u $e |- .1. = ( 1r ` R ) $.
    $( Properties showing that an element ` I ` is the identity element of a
       division ring.  (Contributed by Mario Carneiro, 11-Oct-2013.) $)
    drngid2 $p |- ( R e. DivRing
        -> ( ( I e. B /\ I =/= .0. /\ ( I .x. I ) = I ) <-> .1. = I ) ) $=
      ( cdr wcel wne co wceq cfv wa eqid cbs cvv w3a cmgp csn cdif cress df-3an
      c0g eldifsn anbi1i bitr4i cgrp wb drngmgp wss difss mgpbas ressbas2 ax-mp
      cplusg fvex eqeltri difexg mgpplusg ressplusg mp2b isgrpid2 syl5bb drngid
      syl eqeq1d bitr4d ) BKLZEALZEFMZEECNEOZUAZBUBPZAFUCZUDZUENZUGPZEOZDEOVPEV
      SLZVOQZVLWBVPVMVNQZVOQWDVMVNVOUFWCWEVOEAFUHUIUJVLVTUKLWDWBULABVTFGIVTRZUM
      VSCVTWAEVSAUNVSVTSPOAVRUOVSAVTVQWFABVQVQRZGUPUQURATLVSTLCVTUSPOABSPTGBSUT
      VAAVRTVBVSCVQVTTWFBCVQWGHVCVDVEWARVFVIVGVLDWAEABDVTFGIJWFVHVJVK $.
  $}

  ${
    invrcl.b $e |- B = ( Base ` R ) $.
    invrcl.z $e |- .0. = ( 0g ` R ) $.
    invrcl.i $e |- I = ( invr ` R ) $.
    $( Closure of the multiplicative inverse in a division ring.  ( ~ reccl
       analog.)  (Contributed by NM, 19-Apr-2014.) $)
    drnginvrcl $p |- ( ( R e. DivRing /\ X e. B /\ X =/= .0. )
             -> ( I ` X ) e. B ) $=
      ( cdr wcel wne cfv wa cui eqid drngunit crg wi drngrng rnginvcl ex 3impib
      syl sylbird ) BIJZDAJZDEKZDCLAJZUEUFUGMDBNLZJZUHABUIDEFUIOZGPUEBQJZUJUHRB
      SULUJUHABUICDUKHFTUAUCUDUB $.

    $( The multiplicative inverse in a division ring is nonzero.  ( ~ recne0
       analog.)  (Contributed by NM, 19-Apr-2014.) $)
    drnginvrn0 $p |- ( ( R e. DivRing /\ X e. B /\ X =/= .0. )
             -> ( I ` X ) =/= .0. ) $=
      ( cdr wcel wne w3a cfv wa cui crg wi drngrng eqid drngunit ex syl 3imtr3d
      unitinvcl 3impib simprd ) BIJZDAJZDEKZLDCMZAJZUJEKZUGUHUIUKULNZUGDBOMZJZU
      JUNJZUHUINUMUGBPJZUOUPQBRUQUOUPBUNCDUNSZHUDUAUBABUNDEFURGTABUNUJEFURGTUCU
      EUF $.
  $}

  ${
    drnginvrl.b $e |- B = ( Base ` R ) $.
    drnginvrl.z $e |- .0. = ( 0g ` R ) $.
    drnginvrl.t $e |- .x. = ( .r ` R ) $.
    drnginvrl.u $e |- .1. = ( 1r ` R ) $.
    drnginvrl.i $e |- I = ( invr ` R ) $.
    $( Property of the multiplicative inverse in a division ring.  ( ~ recid2
       analog.)  (Contributed by NM, 19-Apr-2014.) $)
    drnginvrl $p |- ( ( R e. DivRing /\ X e. B /\ X =/= .0. )
             -> ( ( I ` X ) .x. X ) = .1. ) $=
      ( cdr wcel wne cfv co wceq wa cui drngunit crg wi drngrng unitlinv ex syl
      eqid sylbird 3impib ) BMNZFANZFGOZFEPFCQDRZUKULUMSFBTPZNZUNABUOFGHUOUHZIU
      AUKBUBNZUPUNUCBUDURUPUNBCUODEFUQLJKUEUFUGUIUJ $.

    $( Property of the multiplicative inverse in a division ring.  ( ~ recid
       analog.)  (Contributed by NM, 19-Apr-2014.) $)
    drnginvrr $p |- ( ( R e. DivRing /\ X e. B /\ X =/= .0. )
             -> ( X .x. ( I ` X ) ) = .1. ) $=
      ( cdr wcel wne cfv co wceq wa cui drngunit crg wi drngrng unitrinv ex syl
      eqid sylbird 3impib ) BMNZFANZFGOZFFEPCQDRZUKULUMSFBTPZNZUNABUOFGHUOUHZIU
      AUKBUBNZUPUNUCBUDURUPUNBCUODEFUQLJKUEUFUGUIUJ $.
  $}

  ${
    drngmuleq0.b $e |- B = ( Base ` R ) $.
    drngmuleq0.o $e |- .0. = ( 0g ` R ) $.
    drngmuleq0.t $e |- .x. = ( .r ` R ) $.
    drngmuleq0.r $e |- ( ph -> R e. DivRing ) $.
    drngmuleq0.x $e |- ( ph -> X e. B ) $.
    drngmuleq0.y $e |- ( ph -> Y e. B ) $.
    $( A product is zero iff one of its factors is zero.  (Contributed by NM,
       8-Oct-2014.) $)
    drngmul0or $p |- ( ph ->
      ( ( X .x. Y ) = .0. <-> ( X = .0. \/ Y = .0. ) ) ) $=
      ( co wceq wa cfv wcel adantr syl2anc wo wn wne df-ne cinvr oveq2 ad2antlr
      cur cdr simpr eqid drnginvrl syl3anc oveq1d crg drngrng drnginvrcl rngass
      syl13anc rnglidm 3eqtr3d adantlr rngrz ex syl5bir orrd rnglz oveq1 eqeq1d
      syl syl5ibrcom jaod impbid ) AEFDNZGOZEGOZFGOZUAZAVOVRAVOPZVPVQVPUBEGUCZV
      SVQEGUDVSVTVQVSVTPZECUEQZQZVNDNZWCGDNZFGVOWDWEOAVTVNGWCDUFUGAVTWDFOVOAVTP
      ZWCEDNZFDNZCUHQZFDNZWDFWFWGWIFDWFCUIRZEBRZVTWGWIOAWKVTKSZAWLVTLSZAVTUJZBC
      DWIWBEGHIJWIUKZWBUKZULUMUNWFCUORZWCBRZWLFBRZWHWDOAWRVTAWKWRKCUPVJZSWFWKWL
      VTWSWMWNWOBCWBEGHIWQUQUMZWNAWTVTMSBCDWCEFHJURUSAWJFOZVTAWRWTXCXAMBCDWIFHJ
      WPUTTSVAVBWAWRWSWEGOVSWRVTAWRVOXASSAVTWSVOXBVBBCDWCGHJIVCTVAVDVEVFVDAVPVO
      VQAVOVPGFDNZGOZAWRWTXEXAMBCDFGHJIVGTVPVNXDGEGFDVHVIVKAVOVQEGDNZGOZAWRWLXG
      XALBCDEGHJIVCTVQVNXFGFGEDUFVIVKVLVM $.

    $( A product is nonzero iff both its factors are nonzero.  (Contributed by
       NM, 18-Oct-2014.) $)
    drngmulne0 $p |- ( ph
     -> ( ( X .x. Y ) =/= .0. <-> ( X =/= .0. /\ Y =/= .0. ) ) ) $=
      ( co wne wceq wo wn wa drngmul0or necon3abid neanior syl6bbr ) AEFDNZGOEG
      PFGPQZREGOFGOSAUEUDGABCDEFGHIJKLMTUAEGFGUBUC $.

    drngmuleq0.e $e |- ( ph -> Y =/= .0. ) $.
    $( An element is zero iff its product with a nonzero element is zero.
       (Contributed by NM, 8-Oct-2014.) $)
    drngmuleq0 $p |- ( ph -> ( ( X .x. Y ) = .0. <-> X = .0. ) ) $=
      ( co wceq wo drngmul0or wne wb wn df-ne orel2 orc impbid1 sylbi syl bitrd
      ) AEFDOGPEGPZFGPZQZUIABCDEFGHIJKLMRAFGSZUKUITZNULUJUAZUMFGUBUNUKUIUJUIUCU
      IUJUDUEUFUGUH $.
  $}

  ${
    $d s x y z R $.  $d s E $.  $d x y z O $.  $d x y V $.
    opprdrng.1 $e |- O = ( oppR ` R ) $.
    $( The opposite of a division ring is also a division ring.  (Contributed
       by NM, 18-Oct-2014.) $)
    opprdrng $p |- ( R e. DivRing <-> O e. DivRing ) $=
      ( crg wcel cui cfv cbs c0g csn cdif wceq cdr opprrngb anbi1i eqid opprbas
      wa isdrng opprunit oppr0 3bitr4i ) ADEZAFGZAHGZAIGZJKLZRBDEZUGRAMEBMEUCUH
      UGABCNOUEAUDUFUEPZUDPZUFPZSUEBUDUFUEABCUIQABUDUJCTABUFCUKUASUB $.
  $}

  ${
    $d x y z .0. $.  $d x y z .1. $.  $d x y z B $.  $d y z I $.  $d x y z R $.
    $d x y z ph $.  $d x y z .x. $.
    isdrngd.b $e |- ( ph -> B = ( Base ` R ) ) $.
    isdrngd.t $e |- ( ph -> .x. = ( .r ` R ) ) $.
    isdrngd.z $e |- ( ph -> .0. = ( 0g ` R ) ) $.
    isdrngd.u $e |- ( ph -> .1. = ( 1r ` R ) ) $.
    isdrngd.r $e |- ( ph -> R e. Ring ) $.
    isdrngd.n $e |- ( ( ph /\ ( x e. B /\ x =/= .0. )
            /\ ( y e. B /\ y =/= .0. ) ) -> ( x .x. y ) =/= .0. ) $.
    isdrngd.o $e |- ( ph -> .1. =/= .0. ) $.
    isdrngd.i $e |- ( ( ph /\ ( x e. B /\ x =/= .0. ) ) -> I e. B ) $.
    isdrngd.j $e |- ( ( ph /\ ( x e. B /\ x =/= .0. ) ) -> I =/= .0. ) $.
    ${
      isdrngd.k $e |- ( ( ph /\ ( x e. B /\ x =/= .0. ) ) ->
        ( I .x. x ) = .1. ) $.
      $( Properties that determine a division ring. ` I ` (reciprocal) is
         normally dependent on ` x ` i.e. read it as ` I ( x ) ` ."
         (Contributed by NM, 2-Aug-2013.) $)
      isdrngd $p |- ( ph -> R e. DivRing ) $=
        ( wcel vz crg cmgp cfv cbs c0g csn cdif cress co cgrp wa cdr wceq difss
        wss syl5sseq eqid mgpbas ressbas2 syl cmulr cplusg fvex syl6eqel difexg
        cvv mgpplusg ressplusg 3syl eqtrd wne eldifsn w3a syl3an1 3expib eleq2d
        rngcl anbi12d oveqd eleq12d 3imtr4d 3adant2r 3adant3r sylanbrc syl3an3b
        cv 3impib syl3an2b eldifi 3anim123i wi rngass ex eqidd oveq123d eqeq12d
        3anbi123d imp sylan2 cur rngidcl 3eltr4d rnglidm eqeq1d adantrr sylan2b
        isgrpd sneqd difeq12d oveq2d eleq1d anbi2d mpbi2and isdrng2 sylibr ) AE
        UBTZEUCUDZEUEUDZEUFUDZUGZUHZUIUJZUKTZULZEUMTAXQXRDIUGZUHZUIUJZUKTZYENAB
        CUAYGFYHHGAYGXSUPYGYHUEUDUNADYGXSDYFUOJUQYGXSYHXRYHURZXSEXRXRURZXSURZUS
        UTVAAFEVBUDZYHVCUDZKADVGTYGVGTYMYNUNADXSVGJEUEVDVEDYFVGVFYGYMXRYHVGYJEY
        MXRYKYMURZVHVIVJVKBWGZYGTZAYPDTZYPIVLZULZCWGZYGTZYPUUAFUJZYGTZYPDIVMZUU
        BAYTUUADTZUUAIVLZULZUUDUUADIVMAYTUUHVNUUCDTZUUCIVLUUDAYTUUFUUIUUGAYRUUF
        UUIYSAYRUUFUUIAYPXSTZUUAXSTZULYPUUAYMUJZXSTZYRUUFULUUIAUUJUUKUUMAXQUUJU
        UKUUMNXSEYMYPUUAYLYOVRVOVPAYRUUJUUFUUKADXSYPJVQZADXSUUAJVQZVSAUUCUULDXS
        AFYMYPUUAKVTZJWAWBWHWCWDOUUCDIVMWEWFWIYQUUBUAWGZYGTZVNAYRUUFUUQDTZVNZUU
        CUUQFUJZYPUUAUUQFUJZFUJZUNZYQYRUUBUUFUURUUSYPDYFWJUUADYFWJUUQDYFWJWKAUU
        TUVDAUUJUUKUUQXSTZVNZUULUUQYMUJZYPUUAUUQYMUJZYMUJZUNZUUTUVDAXQUVFUVJWLN
        XQUVFUVJXSEYMYPUUAUUQYLYOWMWNVAAYRUUJUUFUUKUUSUVEUUNUUOADXSUUQJVQWRAUVA
        UVGUVCUVIAUUCUULUUQUUQFYMKUUPAUUQWOWPAYPYPUVBUVHFYMKAYPWOZAFYMUUAUUQKVT
        WPWQWBWSWTAGDTGIVLGYGTAEXAUDZXSGDAXQUVLXSTNXSEUVLYLUVLURZXBVAMJXCPGDIVM
        WEYQAYTGYPFUJZYPUNZUUEAYRUVOYSAYRUVOAUUJUVLYPYMUJZYPUNZYRUVOAXQUUJUVQWL
        NXQUUJUVQXSEYMUVLYPYLYOUVMXDWNVAUUNAUVNUVPYPAGUVLYPYPFYMKMUVKWPXEWBWSXF
        XGYQAYTHYGTZUUEAYTULHDTHIVLUVRQRHDIVMWEXGYQAYTHYPFUJGUNUUESXGXHAYIYDXQA
        YHYCUKAYGYBXRUIADXSYFYAJAIXTLXIXJXKXLXMXNXSEYCXTYLXTURYCURXOXP $.
    $}

    ${
      isdrngrd.k $e |- ( ( ph /\ ( x e. B /\ x =/= .0. ) ) ->
        ( x .x. I ) = .1. ) $.
      $( Properties that determine a division ring. ` I ` (reciprocal) is
         normally dependent on ` x ` i.e. read it as ` I ( x ) ` ."  This
         version of ~ isdrngd requires a right reciprocal instead of left.
         (Contributed by NM, 10-Aug-2013.) $)
      isdrngrd $p |- ( ph -> R e. DivRing ) $=
        ( cfv vz coppr cdr wcel cmulr cbs eqid opprbas syl6eq eqidd oppr0 oppr1
        c0g cur crg opprrng syl cv wne wa w3a co wi eleq1 neeq1 anbi12d 3anbi2d
        wceq oveq1 neeq1d imbi12d 3anbi3d oveq2 3ad2ant1 oveqd opprmul eqnetrrd
        syl6eqr 3com23 chvarv adantr eqtr3d syl5eq isdrngd opprdrng sylibr ) AE
        UBTZUCUDEUCUDABUADWGWGUETZGHIADEUFTZWGUFTJWIEWGWGUGZWIUGZUHUIAWHUJAIEUM
        TZWGUMTLEWGWLWJWLUGUKUIAGEUNTZWGUNTMEWMWGWJWMUGULUIAEUOUDWGUOUDNEWGWJUP
        UQACURZDUDZWNIUSZUTZUAURZDUDZWRIUSZUTZVAZWNWRWHVBZIUSZVCZABURZDUDZXFIUS
        ZUTZXAVAZXFWRWHVBZIUSZVCCBWNXFVHZXBXJXDXLXMWQXIAXAXMWOXGWPXHWNXFDVDWNXF
        IVEVFVGXMXCXKIWNXFWRWHVIVJVKAWQXIVAZWNXFWHVBZIUSZVCXEBUAXFWRVHZXNXBXPXD
        XQXIXAAWQXQXGWSXHWTXFWRDVDXFWRIVEVFVLXQXOXCIXFWRWNWHVMVJVKAXIWQXPAXIWQV
        AZXFWNFVBZXOIXRXSXFWNEUETZVBXOXRFXTXFWNAXIFXTVHZWQKVNVOWIEWHXTWGWNXFWKX
        TUGZWJWHUGZVPVROVQVSVTVTPQRAXIUTZHXFWHVBXFHXTVBZGWIEWHXTWGHXFWKYBWJYCVP
        YDXFHFVBYEGYDFXTXFHAYAXIKWAVOSWBWCWDEWGWJWEWF $.
    $}
  $}

  ${
    $d s u v w x y B $.  $d s u v w x y K $.  $d s u v w x y ph $.
    $d s u v w x y L $.
    drngpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    drngpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    drngpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    drngpropd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( If two structures have the same group components (properties), one is a
       division ring iff the other one is.  (Contributed by Mario Carneiro,
       27-Jun-2015.) $)
    drngpropd $p |- ( ph -> ( K e. DivRing <-> L e. DivRing ) ) $=
      ( crg wcel cui cfv cbs c0g wceq wa adantr eqid csn cdif cdr eqtr3d cplusg
      unitpropd cv co adantlr grpidpropd sneqd difeq12d eqeq12d pm5.32da anbi1d
      rngpropd bitrd isdrng 3bitr4g ) AEKLZEMNZEONZEPNZUAZUBZQZRZFKLZFMNZFONZFP
      NZUAZUBZQZRZEUCLFUCLAVGUTVNRVOAUTVFVNAUTRZVAVIVEVMAVAVIQUTABCDEFGHJUFSVPV
      BVJVDVLAVBVJQUTADVBVJGHUDSVPVCVKVPBCDEFADVBQUTGSADVJQUTHSABUGZDLCUGZDLRVQ
      VREUENUHVQVRFUENUHQUTIUIUJUKULUMUNAUTVHVNABCDEFGHIJUPUOUQVBEVAVCVBTVATVCT
      URVJFVIVKVJTVITVKTURUS $.

    $( If two structures have the same group components (properties), one is a
       field iff the other one is.  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    fldpropd $p |- ( ph -> ( K e. Field <-> L e. Field ) ) $=
      ( cdr wcel ccrg wa cfield drngpropd crngpropd anbi12d isfld 3bitr4g ) AEK
      LZEMLZNFKLZFMLZNEOLFOLAUAUCUBUDABCDEFGHIJPABCDEFGHIJQRESFST $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Subrings of a ring
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c SubRing $.
  $c RingSpan $.

  $( Extend class notation with all subrings of a ring. $)
  csubrg $a class SubRing $.

  $( Extend class notation with span of a set of elements over a ring. $)
  crgspn $a class RingSpan $.

  ${
    $d w s t $.
    $( Define a subring of a ring as a set of elements that is a ring in its
       own right and contains the multiplicative identity.

       The additional constraint is necessary because the multiplicative
       identity of a ring, unlike the additive identity of a ring/group or the
       multiplicative identity of a field, cannot be identified by a local
       property.  Thus, it is possible for a subset of a ring to be a ring
       while not containing the true identity if it contains a false identity.
       For instance, the subset ` ( ZZ X. { 0 } ) ` of ` ( ZZ X. ZZ ) ` (where
       multiplication is component-wise) contains the false identity
       ` <. 1 , 0 >. ` which preserves every element of the subset and thus
       appears to be the identity of the subset, but is not the identity of the
       larger ring.  (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    df-subrg $a |- SubRing = ( w e. Ring |-> { s e. ~P ( Base ` w ) |
        ( ( w |`s s ) e. Ring /\ ( 1r ` w ) e. s ) } ) $.

    $( The ring-span of a set of elements in a ring is the smallest subring
       which contains all of them.  (Contributed by Stefan O'Rear,
       7-Dec-2014.) $)
    df-rgspn $a |- RingSpan = ( w e. _V |-> ( s e. ~P ( Base ` w ) |->
        |^| { t e. ( SubRing ` w ) | s C_ t } ) ) $.
  $}

  ${
    $d s A $.  $d r s B $.  $d r s .1. $.  $d r s R $.
    issubrg.b $e |- B = ( Base ` R ) $.
    issubrg.i $e |- .1. = ( 1r ` R ) $.
    $( The subring predicate.  (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    issubrg $p |- ( A e. ( SubRing ` R ) <->
      ( ( R e. Ring /\ ( R |`s A ) e. Ring ) /\ ( A C_ B /\ .1. e. A ) ) ) $=
      ( vr vs csubrg cfv wcel crg cress co wa cv cur cbs cpw eleq1d wss dmmptss
      crab df-subrg elfvdm sseldi simpll wceq fveq2 syl6eqr pweqd oveq1 anbi12d
      cdm rabeqbidv cvv fvex eqeltri rabex fvmpt eleq2d oveq2 eleq2 elrab elpw2
      pwex anbi1i an12 3bitri ibar anbi1d syl5bb bitrd pm5.21nii ) ACIJZKZCLKZV
      QCAMNZLKZOZABUAZDAKZOZOZVPIUNLCGLGPZHPZMNZLKZWEQJZWFKZOZHWERJZSZUCZIGHUDZ
      UBACIUEUFVQVSWCUGVQVPACWFMNZLKZDWFKZOZHBSZUCZKZWDVQVOXAAGCWNXALIWECUHZWKW
      SHWMWTXCWLBXCWLCRJZBWECRUIEUJUKXCWHWQWJWRXCWGWPLWECWFMULTXCWIDWFXCWICQJDW
      ECQUIFUJTUMUOWOWSHWTBBXDUPECRUQURZVFUSUTVAXBVSWCOZVQWDXBAWTKZVSWBOZOWAXHO
      XFWSXHHAWTWFAUHZWQVSWRWBXIWPVRLWFACMVBTWFADVCUMVDXGWAXHABXEVEVGWAVSWBVHVI
      VQVSVTWCVQVSVJVKVLVMVN $.
  $}

  ${
    subrgss.1 $e |- B = ( Base ` R ) $.
    $( A subring is a subset.  (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    subrgss $p |- ( A e. ( SubRing ` R ) -> A C_ B ) $=
      ( csubrg cfv wcel wss cur crg cress co wa eqid issubrg simprbi simpld ) A
      CEFGZABHZCIFZAGZRCJGCAKLJGMSUAMABCTDTNOPQ $.

    $( Every ring is a subring of itself.  (Contributed by Stefan O'Rear,
       30-Nov-2014.) $)
    subrgid $p |- ( R e. Ring -> B e. ( SubRing ` R ) ) $=
      ( crg wcel cress co wa wss cur cfv csubrg ressid id eqeltrd ancli rngidcl
      eqid ssid jctil issubrg sylanbrc ) BDEZUCBAFGZDEZHAAIZBJKZAEZHABLKEUCUEUC
      UDBDABDCMUCNOPUCUHUFABUGCUGRZQASTAABUGCUIUAUB $.
  $}

  ${
    subrgrng.1 $e |- S = ( R |`s A ) $.
    $( A subring is a ring.  (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    subrgrng $p |- ( A e. ( SubRing ` R ) -> S e. Ring ) $=
      ( csubrg cfv wcel cress co crg wa cbs wss cur eqid issubrg simplbi simprd
      syl5eqel ) ABEFGZCBAHIZJDTBJGZUAJGZTUBUCKABLFZMBNFZAGKAUDBUEUDOUEOPQRS $.

    $( A subring of a commutative ring is a commutative ring.  (Contributed by
       Mario Carneiro, 10-Jan-2015.) $)
    subrgcrng $p |- ( ( R e. CRing /\ A e. ( SubRing ` R ) ) -> S e. CRing ) $=
      ( ccrg wcel csubrg cfv wa cmgp ccmn subrgrng adantl cress co eqid mgpress
      crg cmnd crngmgp adantr rngmgp syl eqeltrd subcmn syl2anc eqeltrrd iscrng
      sylanbrc ) BEFZABGHZFZIZCRFZCJHZKFCEFULUNUJABCDLMZUMBJHZANOZUOKABCUQEUKDU
      QPZQZUMUQKFZURSFURKFUJVAULBUQUSTUAUMURUOSUTUMUNUOSFUPCUOUOPZUBUCUDAUQURUR
      PUEUFUGCUOVBUHUI $.
  $}

  $( Reverse closure for a subring predicate.  (Contributed by Mario Carneiro,
     3-Dec-2014.) $)
  subrgrcl $p |- ( A e. ( SubRing ` R ) -> R e. Ring ) $=
    ( csubrg cfv wcel crg cress co wa cbs wss cur eqid issubrg simplbi simpld )
    ABCDEZBFEZBAGHFEZQRSIABJDZKBLDZAEIATBUATMUAMNOP $.

  $( A subring is a subgroup.  (Contributed by Mario Carneiro, 3-Dec-2014.) $)
  subrgsubg $p |- ( A e. ( SubRing ` R ) -> A e. ( SubGrp ` R ) ) $=
    ( csubrg cfv wcel cgrp cbs wss cress csubg crg subrgrcl rnggrp eqid subrgss
    co syl subrgrng issubg syl3anbrc ) ABCDEZBFEZABGDZHBAIPZFEZABJDEUABKEUBABLB
    MQAUCBUCNZOUAUDKEUEABUDUDNRUDMQUCABUFST $.

  ${
    subrg0.1 $e |- S = ( R |`s A ) $.
    subrg0.2 $e |- .0. = ( 0g ` R ) $.
    $( A subring always has the same additive identity.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.) $)
    subrg0 $p |- ( A e. ( SubRing ` R ) -> .0. = ( 0g ` S ) ) $=
      ( csubrg cfv wcel csubg c0g wceq subrgsubg subg0 syl ) ABGHIABJHIDCKHLABM
      ABCDEFNO $.
  $}

  ${
    subrg1cl.a $e |- .1. = ( 1r ` R ) $.
    $( A subring contains the multiplicative identity.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.) $)
    subrg1cl $p |- ( A e. ( SubRing ` R ) -> .1. e. A ) $=
      ( csubrg cfv wcel cbs wss crg cress co wa eqid issubrg simprbi simprd ) A
      BEFGZABHFZIZCAGZRBJGBAKLJGMTUAMASBCSNDOPQ $.
  $}

  ${
    subrgbas.b $e |- S = ( R |`s A ) $.
    $( Base set of a subring structure.  (Contributed by Stefan O'Rear,
       27-Nov-2014.) $)
    subrgbas $p |- ( A e. ( SubRing ` R ) -> A = ( Base ` S ) ) $=
      ( csubrg cfv wcel csubg cbs wceq subrgsubg subgbas syl ) ABEFGABHFGACIFJA
      BKABCDLM $.
  $}

  ${
    $d S x $.  $d R x $.  $d A x $.  $d ph x $.
    subrg1.1 $e |- S = ( R |`s A ) $.
    subrg1.2 $e |- .1. = ( 1r ` R ) $.
    $( A subring always has the same multiplicative identity.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.) $)
    subrg1 $p |- ( A e. ( SubRing ` R ) -> .1. = ( 1r ` S ) ) $=
      ( vx cfv wcel cur cbs cmulr co wceq wa eqid crg oveqd eqeq1d syldan sylan
      csubrg cv wral subrg1cl subrgbas eleqtrd subrgss eqsstr3d sselda subrgrcl
      rngidmlem ressmulr anbi12d biimpa ralrimiva subrgrng isrngid syl mpbi2and
      wb syl6reqr ) ABUBHZIZCJHZBJHZDVDVFCKHZIZVFGUCZCLHZMZVINZVIVFVJMZVINZOZGV
      GUDZVEVFNZVDVFAVGABVFVFPZUEABCEUFZUGVDVOGVGVDVIVGIVIBKHZIZVOVDVGVTVIVDVGA
      VTVSAVTBVTPZUHUIUJVDWAVFVIBLHZMZVINZVIVFWCMZVINZOZVOVDBQIWAWHABUKVTBWCVFV
      IWBWCPZVRULUAVDWHVOVDWEVLWGVNVDWDVKVIVDWCVJVFVIABCWCVCEWIUMZRSVDWFVMVIVDW
      CVJVIVFWJRSUNUOTTUPVDCQIVHVPOVQVAABCEUQGVGCVJVEVFVGPVJPVEPURUSUTFVB $.
  $}

  ${
    subrgacl.p $e |- .+ = ( +g ` R ) $.
    $( A subring is closed under addition.  (Contributed by Mario Carneiro,
       2-Dec-2014.) $)
    subrgacl $p |- ( ( A e. ( SubRing ` R ) /\ X e. A /\ Y e. A ) ->
      ( X .+ Y ) e. A ) $=
      ( csubrg cfv wcel csubg co subrgsubg subgcl syl3an1 ) ACGHIACJHIDAIEAIDEB
      KAIACLBACDEFMN $.
  $}

  ${
    subrgmcl.p $e |- .x. = ( .r ` R ) $.
    $( A subgroup is closed under multiplication.  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    subrgmcl $p |- ( ( A e. ( SubRing ` R ) /\ X e. A /\ Y e. A ) ->
      ( X .x. Y ) e. A ) $=
      ( csubrg cfv wcel w3a cress cmulr cbs eqid subrgrng 3ad2ant1 wceq eleqtrd
      co crg simp2 subrgbas simp3 rngcl syl3anc ressmulr oveqd 3eltr4d ) ABGHZI
      ZDAIZEAIZJZDEBAKSZLHZSZUNMHZDECSAUMUNTIZDUQIEUQIUPUQIUJUKURULABUNUNNZOPUM
      DAUQUJUKULUAUJUKAUQQULABUNUSUBPZRUMEAUQUJUKULUCUTRUQUNUODEUQNUONUDUEUMCUO
      DEUJUKCUOQULABUNCUIUSFUFPUGUTUH $.
  $}

  ${
    subrgsubm.1 $e |- M = ( mulGrp ` R ) $.
    $( A subring is a submonoid of the multiplicative monoid.  (Contributed by
       Mario Carneiro, 15-Jun-2015.) $)
    subrgsubm $p |- ( A e. ( SubRing ` R ) -> A e. ( SubMnd ` M ) ) $=
      ( csubrg cfv wcel csubmnd cbs wss cur cress co cmnd eqid subrgss subrg1cl
      cmgp crg rngmgp wceq subrgrcl mgpress mpancom subrgrng syl eqeltrd w3a wb
      mgpbas rngidval issubm2 3syl mpbir3and ) ABEFZGZACHFGZABIFZJZBKFZAGZCALMZ
      NGZAURBUROZPABUTUTOZQUPVBBALMZRFZNBSGZUPVBVGUAABUBZABVFCSUOVFOZDUCUDUPVFS
      GVGNGABVFVJUEVFVGVGOTUFUGUPVHCNGUQUSVAVCUHUIVIBCDTURAVBCUTURBCDVDUJBUTCDV
      EUKVBOULUMUN $.
  $}

  ${
    $d x y z A $.  $d x y z .|| $.  $d x y E $.  $d x y z R $.  $d z S $.
    subrgdvds.1 $e |- S = ( R |`s A ) $.
    subrgdvds.2 $e |- .|| = ( ||r ` R ) $.
    subrgdvds.3 $e |- E = ( ||r ` S ) $.
    $( If an element divides another in a subring, then it also divides the
       other in the parent ring.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    subrgdvds $p |- ( A e. ( SubRing ` R ) -> E C_ .|| ) $=
      ( vx vy vz cfv wcel cv wbr cbs cmulr co wrex eqid csubrg reldvdsr a1i cop
      wrel wa subrgbas subrgss eqsstr3d sseld ressmulr oveqd eqeq1d rexbidv wss
      wceq wi ssrexv syl sylbird anim12d dvdsr 3imtr4g df-br 3imtr3g relssdv )
      ACUALZMZIJEBEUEVHEDHUBUCVHINZJNZEOZVIVJBOZVIVJUDZEMVMBMVHVIDPLZMZKNZVIDQL
      ZRZVJUPZKVNSZUFVICPLZMZVPVICQLZRZVJUPZKWASZUFVKVLVHVOWBVTWFVHVNWAVIVHVNAW
      AACDFUGAWACWATZUHUIZUJVHVTWEKVNSZWFVHWEVSKVNVHWDVRVJVHWCVQVPVIACDWCVGFWCT
      ZUKULUMUNVHVNWAUOWIWFUQWHWEKVNWAURUSUTVAKVNEDVQVIVJVNTHVQTVBKWABCWCVIVJWG
      GWJVBVCVIVJEVDVIVJBVDVEVF $.
  $}

  ${
    $d x A $.  $d x y R $.  $d y S $.  $d x U $.  $d x V $.
    subrguss.1 $e |- S = ( R |`s A ) $.
    subrguss.2 $e |- U = ( Unit ` R ) $.
    subrguss.3 $e |- V = ( Unit ` S ) $.
    $( A unit of a subring is a unit of the parent ring.  (Contributed by Mario
       Carneiro, 4-Dec-2014.) $)
    subrguss $p |- ( A e. ( SubRing ` R ) -> V C_ U ) $=
      ( vx cfv wcel wa cur cdsr wbr eqid wceq adantr cmulr co coppr simpr sylib
      csubrg cv isunit simpld subrg1 breqtrrd wss subrgdvds ssbrd mpd cinvr cbs
      subrgbas subrgss eqsstr3d unitcl adantl sseldd crg subrgrng sylan opprbas
      rnginvcl dvdsrmul syl2anc opprmul unitrinv ressmulr oveqd 3eqtr4d breqtrd
      syl5eq sylanbrc ex ssrdv ) ABUDJZKZIEDVTIUEZEKZWADKZVTWBLZWABMJZBNJZOZWAW
      EBUAJZNJZOWCWDWAWECNJZOWGWDWACMJZWEWJWDWAWKWJOZWAWKCUAJZNJZOZWDWBWLWOLVTW
      BUBWJCWMEWKWNWAHWKPZWJPZWMPWNPUFUCUGVTWEWKQWBABCWEFWEPZUHRZUIWDWJWFWAWEVT
      WJWFUJWBAWFBCWJFWFPZWQUKRULUMWDWAWACUNJZJZWAWHSJZTZWEWIWDWABUOJZKXBXEKWAX
      DWIOWDCUOJZXEWAWDXFAXEVTAXFQWBABCFUPRVTAXEUJWBAXEBXEPZUQRURZWBWAXFKVTXFCE
      WAXFPZHUSUTVAWDXFXEXBXHVTCVBKZWBXBXFKABCFVCZXFCEXAWAHXAPZXIVFVDVAXEWIWHXC
      WAXBXEBWHWHPZXGVEWIPZXCPZVGVHWDXDWAXBBSJZTZWEXEBXCXPWHXBWAXGXPPZXMXOVIWDW
      AXBCSJZTZWKXQWEVTXJWBXTWKQXKCXSEWKXAWAHXLXSPWPVJVDWDXPXSWAXBVTXPXSQWBABCX
      PVSFXRVKRVLWSVMVOVNWFBWHDWEWIWAGWRWTXMXNUFVPVQVR $.
  $}

  ${
    subrginv.1 $e |- S = ( R |`s A ) $.
    subrginv.2 $e |- I = ( invr ` R ) $.
    subrginv.3 $e |- U = ( Unit ` S ) $.
    subrginv.4 $e |- J = ( invr ` S ) $.
    $( A subring always has the same inversion function, for elements that are
       invertible.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    subrginv $p |- ( ( A e. ( SubRing ` R ) /\ X e. U ) ->
      ( I ` X ) = ( J ` X ) ) $=
      ( cfv wcel cur cmulr co wceq adantr eqid sylan csubrg wa crg cbs subrgrcl
      subrgbas subrgss eqsstr3d subrgrng rnginvcl sseldd unitcl adantl subrguss
      wss sselda syldan rngass syl13anc unitlinv ressmulr subrg1 3eqtr4d oveq1d
      cui oveqd unitrinv oveq2d 3eqtr3d rnglidm syl2anc rngridm ) ABUALZMZGDMZU
      BZBNLZGELZBOLZPZGFLZVQVSPZVRWAVPWAGVSPZVRVSPZWAGVRVSPZVSPZVTWBVPBUCMZWABU
      DLZMZGWHMVRWHMZWDWFQVNWGVOABUEZRZVPCUDLZWHWAVNWMWHUOVOVNWMAWHABCHUFAWHBWH
      SZUGUHRZVNCUCMZVOWAWMMABCHUIZWMCDFGJKWMSZUJTUKZVPWMWHGWOVOGWMMVNWMCDGWRJU
      LUMUKVNVOGBVELZMZWJVNDWTGABCWTDHWTSZJUNUPZVNWGXAWJWKWHBWTEGXBIWNUJTUQZWHB
      VSWAGVRWNVSSZURUSVPWCVQVRVSVPWAGCOLZPZCNLZWCVQVNWPVOXGXHQWQCXFDXHFGJKXFSX
      HSUTTVPVSXFWAGVNVSXFQVOABCVSVMHXEVARVFVNVQXHQVOABCVQHVQSZVBRVCVDVPWEVQWAV
      SVNVOXAWEVQQZXCVNWGXAXJWKBVSWTVQEGXBIXEXIVGTUQVHVIVPWGWJVTVRQWLXDWHBVSVQV
      RWNXEXIVJVKVPWGWIWBWAQWLWSWHBVSVQWAWNXEXIVLVKVI $.
  $}

  ${
    subrgdv.1 $e |- S = ( R |`s A ) $.
    subrgdv.2 $e |- ./ = ( /r ` R ) $.
    subrgdv.3 $e |- U = ( Unit ` S ) $.
    subrgdv.4 $e |- E = ( /r ` S ) $.
    $( A subring always has the same division function, for elements that are
       invertible.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    subrgdv $p |- ( ( A e. ( SubRing ` R ) /\ X e. A /\ Y e. U ) ->
      ( X ./ Y ) = ( X E Y ) ) $=
      ( cfv wcel cinvr cmulr co wceq eqid 3ad2ant1 csubrg w3a subrginv ressmulr
      3adant2 oveq2d oveqd eqtrd cbs cui wss simp2 sseldd subrguss simp3 dvrval
      subrgss syl2anc subrgbas eleqtrd 3eqtr4d ) ACUAMZNZGANZHENZUBZGHCOMZMZCPM
      ZQZGHDOMZMZDPMZQZGHBQZGHFQZVFVJGVLVIQVNVFVHVLGVIVCVEVHVLRVDACDEVGVKHIVGSZ
      KVKSZUCUEUFVFVIVMGVLVCVDVIVMRVEACDVIVBIVISZUDTUGUHVFGCUIMZNHCUJMZNVOVJRVF
      AVTGVCVDAVTUKVEAVTCVTSZUQTVCVDVEULZUMVFEWAHVCVDEWAUKVEACDWAEIWASZKUNTVCVD
      VEUOZUMVTBCVIWAVGGHWBVSWDVQJUPURVFGDUIMZNVEVPVNRVFGAWFWCVCVDAWFRVEACDIUST
      UTWEWFFDVMEVKGHWFSVMSKVRLUPURVA $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x I $.  $d x y R $.  $d x y T $.  $d x y V $.
    $d x S $.  $d x X $.
    subrgugrp.1 $e |- S = ( R |`s A ) $.
    subrgugrp.2 $e |- U = ( Unit ` R ) $.
    subrgugrp.3 $e |- V = ( Unit ` S ) $.
    ${
      subrgunit.4 $e |- I = ( invr ` R ) $.
      $( An element of a ring is a unit of a subring iff it is a unit of the
         parent ring and both it and its inverse are in the subring.
         (Contributed by Mario Carneiro, 4-Dec-2014.) $)
      subrgunit $p |- ( A e. ( SubRing ` R ) ->
        ( X e. V <-> ( X e. U /\ X e. A /\ ( I ` X ) e. A ) ) ) $=
        ( cfv wcel eqid wceq adantr wbr cmulr co syl2anc csubrg w3a wa subrguss
        sselda unitcl adantl subrgbas eleqtrrd cinvr subrgrng rnginvcl subrginv
        cbs crg sylan 3eltr4d 3jca cdsr simpr2 eleqtrd simpr3 dvdsrmul subrgrcl
        cur coppr simpr1 unitlinv ressmulr oveqd subrg1 3eqtr3d breqtrd opprbas
        opprmul unitrinv syl5eq isunit sylanbrc impbida ) ABUALZMZGFMZGDMZGAMZG
        ELZAMZUBZWBWCUCZWDWEWGWBFDGABCDFHIJUDUEWIGCUNLZAWCGWJMZWBWJCFGWJNZJUFUG
        WBAWJOZWCABCHUHZPZUIWIGCUJLZLZWJWFAWBCUOMWCWQWJMABCHUKWJCFWPGJWPNZWLULU
        PABCFEWPGHKJWRUMWOUQURWBWHUCZGCVELZCUSLZQGWTCVFLZUSLZQWCWSGWFGCRLZSZWTX
        AWSWKWFWJMZGXEXAQWSGAWJWBWDWEWGUTWBWMWHWNPZVAZWSWFAWJWBWDWEWGVBXGVAZWJX
        ACXDGWFWLXANZXDNZVCTWSWFGBRLZSZBVELZXEWTWSBUOMZWDXMXNOWBXOWHABVDPZWBWDW
        EWGVGZBXLDXNEGIKXLNZXNNZVHTWSXLXDWFGWBXLXDOWHABCXLWAHXRVIPZVJWBXNWTOWHA
        BCXNHXSVKPZVLVMWSGWFGXBRLZSZWTXCWSWKXFGYCXCQXHXIWJXCXBYBGWFWJCXBXBNZWLV
        NXCNZYBNZVCTWSYCGWFXDSZWTWJCYBXDXBWFGWLXKYDYFVOWSGWFXLSZXNYGWTWSXOWDYHX
        NOXPXQBXLDXNEGIKXRXSVPTWSXLXDGWFXTVJYAVLVQVMXACXBFWTXCGJWTNXJYDYEVRVSVT
        $.
    $}

    subrgugrp.4 $e |- G = ( ( mulGrp ` R ) |`s U ) $.
    $( The units of a subring form a subgroup of the unit group of the original
       ring.  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    subrgugrp $p |- ( A e. ( SubRing ` R ) -> V e. ( SubGrp ` G ) ) $=
      ( vx vy cfv wcel cv cmulr co wral eqid cvv csubrg csubg c0 cinvr subrguss
      wss wne crg cur subrgrng 1unit ne0i 3syl w3a wceq ressmulr 3ad2ant1 oveqd
      wa unitmulcl syl3an1 eqeltrd 3expa ralrimiva subrginv unitinvcl sylan jca
      cgrp wb subrgrcl unitgrp unitgrpbas cplusg cui fvex eqeltri cmgp mgpplusg
      ressplusg ax-mp invrfval issubg2 mpbir3and ) ABUAMZNZFEUBMNZFDUFZFUCUGZKO
      ZLOZBPMZQZFNZLFRZWJBUDMZMZFNZUSZKFRZABCDFGHIUEWFCUHNZCUIMZFNWIABCGUJZCFXB
      IXBSUKFXBULUMWFWSKFWFWJFNZUSZWOWRXEWNLFWFXDWKFNZWNWFXDXFUNZWMWJWKCPMZQZFX
      GWLXHWJWKWFXDWLXHUOXFABCWLWEGWLSZUPUQURWFXAXDXFXIFNXCCXHFWJWKIXHSUTVAVBVC
      VDXEWQWJCUDMZMZFABCFWPXKWJGWPSZIXKSZVEWFXAXDXLFNXCCFXKWJIXNVFVGVBVHVDWFBU
      HNEVINWGWHWIWTUNVJABVKBDEHJVLKLDWLFEWPBDEHJVMDTNWLEVNMUODBVOMTHBVOVPVQDWL
      BVRMZETJBWLXOXOSXJVSVTWABDEWPHJXMWBWCUMWD $.
  $}

  ${
    $d u v w x y A $.  $d u v w .1. $.  $d u v w x y R $.  $d u v w x y .x. $.
    issubrg2.b $e |- B = ( Base ` R ) $.
    issubrg2.o $e |- .1. = ( 1r ` R ) $.
    issubrg2.t $e |- .x. = ( .r ` R ) $.
    $( Characterize the subrings of a ring by closure properties.  (Contributed
       by Mario Carneiro, 3-Dec-2014.) $)
    issubrg2 $p |- ( R e. Ring -> ( A e. ( SubRing ` R ) <->
                     ( A e. ( SubGrp ` R ) /\ .1. e. A /\
                       A. x e. A A. y e. A ( x .x. y ) e. A ) ) ) $=
      ( wcel cfv cv co w3a wa wceq syl adantlr syldan vu vv vw crg csubrg csubg
      wral subrgsubg subrg1cl subrgmcl 3expb ralrimivva 3jca cress simpl cplusg
      wss cbs simpr1 eqid subgbas ressplusg cmulr ressmulr subggrp simpr3 oveq1
      cgrp eleq1d oveq2 rspc2v syl5com 3impib subgss sseld 3anim123d imp rngass
      rngdi rngdir simpr2 rnglidm rngridm isrngd jca issubrg sylanbrc impbid2
      ex ) EUDKZCEUELKZCEUFLZKZGCKZAMZBMZFNZCKZBCUGACUGZOZWKWMWNWSCEUHCEGIUIWKW
      RABCCWKWOCKWPCKWRCEFWOWPJUJUKULUMWJWTWKWJWTPZWJECUNNZUDKZPCDUQZWNPWKXAWJX
      CWJWTUOXAUAUBUCCEUPLZXBFGXAWMCXBURLQWJWMWNWSUSZCEXBXBUTZVARXAWMXEXBUPLQXF
      CXEEXBWLXGXEUTZVBRXAWMFXBVCLQXFCEXBFWLXGJVDRXAWMXBVHKXFCEXBXGVERXAUAMZCKZ
      UBMZCKZXIXKFNZCKZXAWSXJXLPXNWJWMWNWSVFWRXNXIWPFNZCKABXIXKCCWOXIQWQXOCWOXI
      WPFVGVIWPXKQXOXMCWPXKXIFVJVIVKVLVMXAXJXLUCMZCKZOZXIDKZXKDKZXPDKZOZXMXPFNX
      IXKXPFNZFNQZXAXRYBXAXJXSXLXTXQYAXACDXIXAWMXDXFDCEHVNRZVOZXACDXKYEVOXACDXP
      YEVOVPVQZWJYBYDWTDEFXIXKXPHJVRSTXAXRYBXIXKXPXENFNXMXIXPFNZXENQZYGWJYBYIWT
      DXEEFXIXKXPHXHJVSSTXAXRYBXIXKXENXPFNYHYCXENQZYGWJYBYJWTDXEEFXIXKXPHXHJVTS
      TWJWMWNWSWAZXAXJXSGXIFNXIQZXAXJXSYFVQZWJXSYLWTDEFGXIHJIWBSTXAXJXSXIGFNXIQ
      ZYMWJXSYNWTDEFGXIHJIWCSTWDWEXAXDWNYEYKWECDEGHIWFWGWIWH $.
  $}

  ${
    $d x y z O $.  $d x y z R $.
    opprsubrg.o $e |- O = ( oppR ` R ) $.
    $( Being a subring is a symmetric property.  (Contributed by Mario
       Carneiro, 6-Dec-2014.) $)
    opprsubrg $p |- ( SubRing ` R ) = ( SubRing ` O ) $=
      ( vx vy vz csubrg cfv cv wcel crg subrgrcl csubg cmulr co wral w3a a1i wb
      eqid opprrngb sylibr cur opprsubg eleq2d ralcom cbs opprmul eleq1i bitr4i
      2ralbii 3anbi13d issubrg2 opprbas oppr1 sylbi 3bitr4d pm5.21nii eqriv
      wceq ) DAGHZBGHZDIZVAJZAKJZVCVBJZVCALVFBKJZVEVCBLABCUAZUBVEVCAMHZJZAUCHZV
      CJZEIZFIZANHZOZVCJZFVCPEVCPZQVCBMHZJZVLVNVMBNHZOZVCJZEVCPFVCPZQZVDVFVEVJV
      TVRWDVLVEVIVSVCVIVSUTVEABCUDRUEVRWDSVEVRVQEVCPFVCPWDVQEFVCVCUFWCVQFEVCVCW
      BVPVCAUGHZAWAVOBVNVMWFTZVOTZCWATZUHUIUKUJRULEFVCWFAVOVKWGVKTZWHUMVEVGVFWE
      SVHFEVCWFBWAVKWFABCWGUNAVKBCWJUOWIUMUPUQURUS $.
  $}

  ${
    $d r x y R $.  $d r x y S $.
    $( The intersection of a nonempty collection of subrings is a subring.
       (Contributed by Stefan O'Rear, 30-Nov-2014.)  (Revised by Mario
       Carneiro, 7-Dec-2014.) $)
    subrgint $p |- ( ( S C_ ( SubRing ` R ) /\ S =/= (/) ) ->
      |^| S e. ( SubRing ` R ) ) $=
      ( vx vy vr cfv wss c0 wne wa wcel cur wral sylan adantlr ralrimiva elint2
      cv eqid sylibr csubrg cint csubg cmulr subrgsubg ssriv sstr mpan2 subgint
      co ssel2 subrg1cl syl fvex simprl elinti imp simprr subrgmcl syl3anc ovex
      ralrimivva crg w3a wb ssn0 wex n0 subrgrcl exlimiv cbs issubrg2 mpbir3and
      sylbi 3syl ) BAUAFZGZBHIZJZBUBZVPKZVTAUCFZKZALFZVTKZCRZDRZAUDFZUJZVTKZDVT
      MCVTMZVQBWBGZVRWCVQVPWBGWLEVPWBERZAUEUFBVPWBUGUHBAUINVSWDWMKZEBMWEVSWNEBV
      SWMBKZJWMVPKZWNVQWOWPVRBVPWMUKOZWMAWDWDSZULUMPEWDBALUNQTVSWJCDVTVTVSWFVTK
      ZWGVTKZJZJZWIWMKZEBMWJXBXCEBXBWOJWPWFWMKZWGWMKZXCVSWOWPXAWQOXBWSWOXDVSWSW
      TUOWSWOXDWFBWMUPUQNXBWTWOXEVSWSWTURWTWOXEWGBWMUPUQNWMAWHWFWGWHSZUSUTPEWIB
      WFWGWHVAQTVBVSVPHIZAVCKZWAWCWEWKVDVEBVPVFXGWPEVGXHEVPVHWPXHEWMAVIVJVNCDVT
      AVKFZAWHWDXISWRXFVLVOVM $.
  $}

  ${
    $( The intersection of two subrings is a subring.  (Contributed by Stefan
       O'Rear, 30-Nov-2014.)  (Revised by Mario Carneiro, 7-Dec-2014.) $)
    subrgin $p |- ( ( A e. ( SubRing ` R ) /\ B e. ( SubRing ` R ) ) ->
      ( A i^i B ) e. ( SubRing ` R ) ) $=
      ( csubrg cfv wcel wa cpr cint cin intprg wss c0 wne prssi adantr subrgint
      prnzg syl2anc eqeltrrd ) ACDEZFZBUAFZGZABHZIZABJUAABUAUAKUDUEUALUEMNZUFUA
      FABUAOUBUGUCABUARPCUEQST $.
  $}

  ${
    $d B a $.  $d R a $.
    subrgmre.b $e |- B = ( Base ` R ) $.
    $( The subrings of a ring are a Moore system.  (Contributed by Stefan
       O'Rear, 9-Mar-2015.) $)
    subrgmre $p |- ( R e. Ring -> ( SubRing ` R ) e. ( Moore ` B ) ) $=
      ( va crg wcel csubrg cfv cpw cv wss subrgss vex elpw sylibr ssrdv subrgid
      wi a1i c0 wne cint subrgint 3adant1 ismred ) BEFZBGHZADUFDUGAIZDJZUGFZUIU
      HFZRUFUJUIAKUKUIABCLUIADMNOSPABCQUIUGKUITUAUIUBUGFUFBUIUCUDUE $.
  $}

  ${
    $d x A $.  $d x R $.  $d x S $.  $d x .0. $.
    issubdrg.s $e |- S = ( R |`s A ) $.
    issubdrg.z $e |- .0. = ( 0g ` R ) $.
    issubdrg.i $e |- I = ( invr ` R ) $.
    $( Characterize the subfields of a division ring.  (Contributed by Mario
       Carneiro, 3-Dec-2014.) $)
    issubdrg $p |- ( ( R e. DivRing /\ A e. ( SubRing ` R ) ) ->
      ( S e. DivRing <-> A. x e. ( A \ { .0. } ) ( I ` x ) e. A ) ) $=
      ( cdr wcel cfv wa cdif syl wceq wb eqid ad2antlr wss csubrg cv wral cinvr
      csn cbs crg cui simpllr subrgrng c0g simpr eldifsn sylib subrgbas eleqtrd
      simpld simprd subrg0 neeqtrd drngunit mpbir2and rnginvcl syl2anc subrginv
      wne 3eltr4d ralrimiva cin subrguss isdrng simprbi ad2antrr sseqtrd unitss
      syl5sseqr ssind subrgss difin2 sseqtr4d simprl sseldd subrgunit mpbir3and
      simprr w3a expr ralimdva dfss3 sylibr eqssd sneqd difeq12d eqtrd sylanbrc
      imp impbida ) CJKZBCUALKZMZDJKZAUBZELZBKZABFUEZNZUCZWTXAMZXDAXFXHXBXFKZMZ
      XBDUDLZLZDUFLZXCBXJDUGKZXBDUHLZKZXLXMKXJWSXNWRWSXAXIUIZBCDGUJZOXJXPXBXMKZ
      XBDUKLZVFZXJXBBXMXJXBBKZXBFVFZXJXIYBYCMZXHXIULXBBFUMZUNZUQXJWSBXMPZXQBCDG
      UOZOZUPXJXBFXTXJYBYCYFURXJWSFXTPZXQBCDFGHUSZOUTXAXPXSYAMQWTXIXMDXOXBXTXMR
      ZXORZXTRZVASVBZXMDXOXKXBYMXKRZYLVCVDXJWSXPXCXLPXQYOBCDXOEXKXBGIYMYPVEVDYI
      VGVHWTXGMZXNXOXMXTUEZNZPXAWSXNWRXGXRSYQXOXFYSYQXOXFYQXOCUFLZXENZBVIZXFYQX
      OUUABYQXOCUHLZUUAWSXOUUCTWRXGBCDUUCXOGUUCRZYMVJSWRUUCUUAPZWSXGWRCUGKUUEYT
      CUUCFYTRZUUDHVKVLVMVNYQXMXOBXMDXOYLYMVOWSYGWRXGYHSZVPVQYQBYTTZXFUUBPWSUUH
      WRXGBYTCUUFVRZSBXEYTVSOVTYQXPAXFUCZXFXOTWTXGUUJWTXDXPAXFWTXIXDXPWTXIXDMZM
      ZXPXBUUCKZYBXDUULUUMXBYTKZYCUULBYTXBWSUUHWRUUKUUISUULYBYCUULXIYDWTXIXDWAY
      EUNZUQZWBUULYBYCUUOURWRUUMUUNYCMQWSUUKYTCUUCXBFUUFUUDHVAVMVBUUPWTXIXDWEWS
      XPUUMYBXDWFQWRUUKBCDUUCEXOXBGUUDYMIWCSWDWGWHWPAXFXOWIWJWKYQBXMXEYRUUGYQFX
      TWSYJWRXGYKSWLWMWNXMDXOXTYLYMYNVKWOWQ $.
  $}

  ${
    $d A a $.  $d R a $.  $d S a $.
    subsubrg.s $e |- S = ( R |`s A ) $.
    $( A subring of a subring is a subring.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    subsubrg $p |- ( A e. ( SubRing ` R ) -> ( B e. ( SubRing ` S ) <->
      ( B e. ( SubRing ` R ) /\ B C_ A ) ) ) $=
      ( csubrg cfv wcel wss wa crg cress co cbs adantr wceq adantl subrgrng jca
      eqid cur subrgrcl subrgss subrgbas sseqtr4d oveq1i syl5eq syldan eqeltrrd
      ressabs subrg1 subrg1cl eqeltrd issubrg sylanbrc adantrl ad2antrl sseqtrd
      sstrd simprr impbida ) ACFGZHZBDFGHZBVBHZBAIZJZVCVDJZVEVFVHCKHZCBLMZKHZJB
      CNGZIZCUAGZBHZJVEVHVIVKVCVIVDACUBOVHDBLMZVJKVCVDVFVPVJPZVHBDNGZAVDBVRIZVC
      BVRDVRTZUCQVCAVRPZVDACDEUDZOUEZVCVFJVPCALMZBLMVJDWDBLEUFABCVBUJUGZUHVDVPK
      HZVCBDVPVPTRQUISVHVMVOVHBAVLWCVCAVLIVDAVLCVLTZUCOUSVHVNDUAGZBVCVNWHPZVDAC
      DVNEVNTZUKZOVDWHBHZVCBDWHWHTZULQUMSBVLCVNWGWJUNUOWCSVCVGJZDKHZWFJVSWLJVDW
      NWOWFVCWOVGACDEROWNVPVJKVCVFVQVEWEUPVEVKVCVFBCVJVJTRUQUMSWNVSWLWNBAVRVCVE
      VFUTVCWAVGWBOURWNVNWHBVCWIVGWKOVEVOVCVFBCVNWJULUQUISBVRDWHVTWMUNUOVA $.

    $( The set of subrings of a subring are the smaller subrings.  (Contributed
       by Stefan O'Rear, 9-Mar-2015.) $)
    subsubrg2 $p |- ( A e. ( SubRing ` R ) ->
        ( SubRing ` S ) = ( ( SubRing ` R ) i^i ~P A ) ) $=
      ( va csubrg cfv wcel cpw cin cv wss wa subsubrg elin anbi2i bitr2i syl6bb
      vex elpw eqrdv ) ABFGZHZECFGZUBAIZJZUCEKZUDHUGUBHZUGALZMZUGUFHZAUGBCDNUKU
      HUGUEHZMUJUGUBUEOULUIUHUGAESTPQRUA $.
  $}

  ${
    $d M x y $.  $d R x y $.  $d S x y $.
    issubrg3.m $e |- M = ( mulGrp ` R ) $.
    $( A subring is an additive subgroup which is also a multiplicative
       submonoid.  (Contributed by Mario Carneiro, 7-Mar-2015.) $)
    issubrg3 $p |- ( R e. Ring -> ( S e. ( SubRing ` R ) <->
        ( S e. ( SubGrp ` R ) /\ S e. ( SubMnd ` M ) ) ) ) $=
      ( vx vy crg wcel csubrg cfv csubg cur cv cmulr wral wa eqid 3anass syl6bb
      w3a co csubmnd cbs issubrg2 wss wb rngmgp subgss mgpbas rngidval mgpplusg
      cmnd issubm baibd syl2an pm5.32da bitr4d ) AGHZBAIJHZBAKJHZALJZBHZEMFMANJ
      ZUABHFBOEBOZPZPZUTBCUBJHZPURUSUTVBVDTVFEFBAUCJZAVCVAVHQZVAQZVCQZUDUTVBVDR
      SURUTVGVEURCULHZBVHUEZVGVEUFUTACDUGVHBAVIUHVLVGVMVEVLVGVMVBVDTVMVEPEFVHVC
      BCVAVHACDVIUIAVACDVJUJAVCCDVKUKUMVMVBVDRSUNUOUPUQ $.
  $}

  ${
    resrhm.u $e |- U = ( S |`s X ) $.
    $( Restriction of a ring homomorphism to a subring is a homomorphism.
       (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    resrhm $p |- ( ( F e. ( S RingHom T ) /\ X e. ( SubRing ` S ) ) ->
        ( F |` X ) e. ( U RingHom T ) ) $=
      ( crh co wcel csubrg cfv wa crg cres cghm cmgp cmhm rhmrcl2 syl2an eqid
      subrgrng anim12ci rhmghm subrgsubg resghm csubmnd rhmmhm subrgsubm resmhm
      csubg cress wceq rhmrcl1 mgpress sylan oveq1d eleqtrd jca isrhm sylanbrc
      ) DABGHIZEAJKZIZLZCMIZBMIZLDENZCBOHIZVGCPKZBPKZQHZIZLVGCBGHIVAVFVCVEABDRE
      ACFUAUBVDVHVLVADABOHIEAUJKIVHVCABDUCEAUDABCDEFUESVDVGAPKZEUKHZVJQHZVKVADV
      MVJQHIEVMUFKIVGVOIVCABDVMVJVMTZVJTZUGEAVMVPUHVMVJVNDEVNTUISVDVNVIVJQVAAMI
      VCVNVIULABDUMEACVMMVBFVPUNUOUPUQURCBVGVIVJVITVQUSUT $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d S x y $.
    $( The equalizer of two ring homomorphisms is a subring.  (Contributed by
       Stefan O'Rear, 7-Mar-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    rhmeql $p |- ( ( F e. ( S RingHom T ) /\ G e. ( S RingHom T ) ) ->
      dom ( F i^i G ) e. ( SubRing ` S ) ) $=
      ( crh co wcel wa cin cdm csubrg cfv csubg cmgp csubmnd cghm rhmghm syl2an
      eqid rhmmhm ghmeql cmhm mhmeql crg rhmrcl1 adantr issubrg3 syl mpbir2and
      wb ) CABEFZGZDUKGZHZCDIJZAKLGZUOAMLGZUOANLZOLGZULCABPFZGDUTGUQUMABCQABDQA
      BCDUARULCURBNLZUBFZGDVBGUSUMABCURVAURSZVASZTABDURVAVCVDTURVACDUCRUNAUDGZU
      PUQUSHUJULVEUMABCUEUFAUOURVCUGUHUI $.
  $}

  $( The homomorphic image of a subring is a subring.  (Contributed by Stefan
     O'Rear, 10-Mar-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
  rhmima $p |- ( ( F e. ( M RingHom N ) /\ X e. ( SubRing ` M ) ) ->
      ( F " X ) e. ( SubRing ` N ) ) $=
    ( crh co wcel csubrg cfv wa cima csubg cmgp csubmnd rhmghm subrgsubg ghmima
    cghm syl2an eqid rhmmhm subrgsubm mhmima crg wb rhmrcl2 adantr issubrg3 syl
    cmhm mpbir2and ) ABCEFGZDBHIGZJZADKZCHIGZUOCLIGZUOCMIZNIGZULABCRFGDBLIGUQUM
    BCAODBPBCDAQSULABMIZURUJFGDUTNIGUSUMBCAUTURUTTZURTZUADBUTVAUBAUTURDUCSUNCUD
    GZUPUQUSJUEULVCUMBCAUFUGCUOURVBUHUIUK $.

  ${
    $d x y z B $.  $d y z M $.  $d x y z R $.  $d x y z S $.  $d x y z Z $.
    cntzsubr.b $e |- B = ( Base ` R ) $.
    cntzsubr.m $e |- M = ( mulGrp ` R ) $.
    cntzsubr.z $e |- Z = ( Cntz ` M ) $.
    $( Centralizers in a ring are subrings.  (Contributed by Stefan O'Rear,
       6-Sep-2015.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    cntzsubr $p |- ( ( R e. Ring /\ S C_ B ) ->
        ( Z ` S ) e. ( SubRing ` R ) ) $=
      ( vx vz wcel wa cfv co wral wceq syl2anc ralrimiva wb sseldi vy crg csubg
      wss csubrg csubmnd c0 wne cv cplusg cminusg mgpbas cntzssv a1i c0g simpll
      cmulr ssel2 adantll eqid rnglz rngrz eqtr4d rng0cl adantr mgpplusg cntzel
      simpr mpbird syl simpl2 cntzi simpl3 oveq12d simpl1l simp1r sselda rngdir
      w3a syl13anc rngdi 3eqtr4d simp1l simp2 simp3 rngacl syl3anc 3expa fveq2d
      ne0i simplr rngmneg1 rngmneg2 cgrp rnggrp ad2antrr grpinvcl jca mpbir3and
      simplll issubg2 cmnd rngmgp cntzsubm sylan issubrg3 mpbir2and ) BUBKZCAUD
      ZLZCEMZBUEMKZXKBUCMKZXKDUFMKZXJXMXKAUDZXKUGUHZIUIZUAUIZBUJMZNZXKKZUAXKOZX
      QBUKMZMZXKKZLZIXKOZXOXJACDEABDGFULZHUMZUNXJBUOMZXKKZXPXJYKYJJUIZBUQMZNZYL
      YJYMNZPZJCOZXJYPJCXJYLCKZLZYNYJYOYSXHYLAKZYNYJPXHXIYRUPZXIYRYTXHCAYLURUSZ
      ABYMYLYJFYMUTZYJUTZVAQYSXHYTYOYJPUUAUUBABYMYLYJFUUCUUDVBQVCRXJXIYJAKZYKYQ
      SXHXIVHXHUUEXIABYJFUUDVDVEJAYMCDYJEYHBYMDGUUCVFZHVGQVIXKYJWJVJXJYFIXKXJXQ
      XKKZLZYBYEUUHYAUAXKXJUUGXRXKKZYAXJUUGUUIVSZYAXTYLYMNZYLXTYMNZPZJCOZUUJUUM
      JCUUJYRLZXQYLYMNZXRYLYMNZXSNZYLXQYMNZYLXRYMNZXSNZUUKUULUUOUUPUUSUUQUUTXSU
      UOUUGYRUUPUUSPZXJUUGUUIYRVKZUUJYRVHZYMCDXQYLEUUFHVLZQUUOUUIYRUUQUUTPXJUUG
      UUIYRVMZUVDYMCDXRYLEUUFHVLQVNUUOXHXQAKZXRAKZYTUUKUURPXHXIUUGUUIYRVOZUUOXK
      AXQYIUVCTZUUOXKAXRYIUVFTZUUJCAYLXHXIUUGUUIVPZVQZAXSBYMXQXRYLFXSUTZUUCVRVT
      UUOXHYTUVGUVHUULUVAPUVIUVMUVJUVKAXSBYMYLXQXRFUVNUUCWAVTWBRUUJXIXTAKZYAUUN
      SUVLUUJXHUVGUVHUVOXHXIUUGUUIWCUUJXKAXQYIXJUUGUUIWDTUUJXKAXRYIXJUUGUUIWETA
      XSBXQXRFUVNWFWGJAYMCDXTEYHUUFHVGQVIWHRUUHYEYDYLYMNZYLYDYMNZPZJCOZUUHUVRJC
      UUHYRLZUUPYCMUUSYCMUVPUVQUVTUUPUUSYCUUGYRUVBXJUVEUSWIUVTABYMYCXQYLFUUCYCU
      TZXHXIUUGYRWTZUVTXKAXQYIXJUUGYRWKTZUUHCAYLXHXIUUGWKZVQZWLUVTABYMYCYLXQFUU
      CUWAUWBUWEUWCWMWBRUUHXIYDAKZYEUVSSUWDUUHBWNKZUVGUWFXHUWGXIUUGBWOZWPUUHXKA
      XQYIXJUUGVHTABYCXQFUWAWQQJAYMCDYDEYHUUFHVGQVIWRRXJUWGXMXOXPYGVSSXHUWGXIUW
      HVEIUAAXSXKBYCFUVNUWAXAVJWSXHDXBKXIXNBDGXCACDEYHHXDXEXHXLXMXNLSXIBXKDGXFV
      EXG $.
  $}

  ${
    $d B x $.  $d F y z $.  $d I x $.  $d I y z $.  $d R x $.  $d R y z $.
    $d W x $.  $d W y z $.  $d Y x $.  $d Y y z $.
    pwsdiagrhm.y $e |- Y = ( R ^s I ) $.
    pwsdiagrhm.b $e |- B = ( Base ` R ) $.
    pwsdiagrhm.f $e |- F = ( x e. B |-> ( I X. { x } ) ) $.
    $( Diagonal homomorphism into a structure power (Rings).  (Contributed by
       Mario Carneiro, 12-Mar-2015.)  (Revised by Mario Carneiro,
       6-May-2015.) $)
    pwsdiagrhm $p |- ( ( R e. Ring /\ I e. W ) -> F e. ( R RingHom Y ) ) $=
      ( vy vz crg wcel wa co cfv eqid cbs eqidd cghm cmgp cmhm crh simpl pwsrng
      jca cgrp rnggrp pwsdiagghm cpws cmnd rngmgp mgpbas pwsdiagmhm wceq cplusg
      sylan pwsmgp simpld cv simprd proplem3 mhmpropd eleqtrrd isrhm sylanbrc )
      CMNZEFNZOZVHGMNZODCGUAPNZDCUBQZGUBQZUCPZNZODCGUDPNVJVHVKVHVIUECEFGHUFUGVJ
      VLVPVHCUHNVIVLCUIABCDEFGHIJUJURVJDVMVMEUKPZUCPZVOVHVMULNVIDVRNCVMVMRZUMAB
      VMDEFVQVQRZBCVMVSIUNJUOURVJKLVMSQZVNSQZVMVNVMVQVJWATZVJWBTWCVJWBVQSQZUPZV
      NUQQZVQUQQZUPZWBWDWFWGCEVMVNMFGVQHVSVTVNRZWBRWDRWFRWGRUSZUTVJKVAZWANLVAZW
      ANOOWKWLVMUQQPTVJWKWBNWLWBNOKLWFWGVJWEWHWJVBVCVDVEUGCGDVMVNVSWIVFVG $.
  $}

  ${
    $d s u v w x y B $.  $d s u v w x y K $.  $d s u v w x y ph $.
    $d s u v w x y L $.
    subrgpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    subrgpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    subrgpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    subrgpropd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( If two structures have the same group components (properties), they have
       the same set of subrings.  (Contributed by Mario Carneiro,
       9-Feb-2015.) $)
    subrgpropd $p |- ( ph -> ( SubRing ` K ) = ( SubRing ` L ) ) $=
      ( cfv crg wcel co wa cbs cvv wceq eqid ax-mp vs csubrg cress wss rngpropd
      cv cur cin ineq2d vex ressbas syl6eq cplusg inss2 sseli anim12i ressplusg
      oveqi 3eqtr3g sylan2 cmulr ressmulr anbi12d eqtr3d sseq2d issubrg 3bitr4g
      rngidpropd eleq1d eqrdv ) AUAEUBKZFUBKZAELMZEUAUFZUCNZLMZOZVNEPKZUDZEUGKZ
      VNMZOZOFLMZFVNUCNZLMZOZVNFPKZUDZFUGKZVNMZOZOVNVKMVNVLMAVQWFWBWKAVMWCVPWEA
      BCDEFGHIJUEABCVNDUHZVOWDAWLVNVRUHZVOPKZADVRVNGUIVNQMZWMWNRUAUJZVNVRVOQEVO
      SZVRSZUKTULAWLVNWGUHZWDPKZADWGVNHUIWOWSWTRWPVNWGWDQFWDSZWGSZUKTULBUFZWLMZ
      CUFZWLMZOZAXCDMZXEDMZOZXCXEVOUMKZNZXCXEWDUMKZNZRXDXHXFXIWLDXCVNDUNZUOWLDX
      EXOUOUPZAXJOZXCXEEUMKZNXCXEFUMKZNXLXNIXRXKXCXEWOXRXKRWPVNXREVOQWQXRSUQTUR
      XSXMXCXEWOXSXMRWPVNXSFWDQXAXSSUQTURUSUTXGAXJXCXEVOVAKZNZXCXEWDVAKZNZRXPXQ
      XCXEEVAKZNXCXEFVAKZNYAYCJYDXTXCXEWOYDXTRWPVNEVOYDQWQYDSVBTURYEYBXCXEWOYEY
      BRWPVNFWDYEQXAYESVBTURUSUTUEVCAVSWHWAWJAVRWGVNADVRWGGHVDVEAVTWIVNABCDEFGH
      JVHVIVCVCVNVREVTWRVTSVFVNWGFWIXBWISVFVGVJ $.
  $}

  ${
    $d f x y J $.  $d f x y K $.  $d f x y L $.  $d f x y M $.  $d f x y ph $.
    $d x y B $.  $d x y C $.
    rhmpropd.a $e |- ( ph -> B = ( Base ` J ) ) $.
    rhmpropd.b $e |- ( ph -> C = ( Base ` K ) ) $.
    rhmpropd.c $e |- ( ph -> B = ( Base ` L ) ) $.
    rhmpropd.d $e |- ( ph -> C = ( Base ` M ) ) $.
    rhmpropd.e $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` J ) y ) = ( x ( +g ` L ) y ) ) $.
    rhmpropd.f $e |- ( ( ph /\ ( x e. C /\ y e. C ) ) ->
        ( x ( +g ` K ) y ) = ( x ( +g ` M ) y ) ) $.
    rhmpropd.g $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( .r ` J ) y ) = ( x ( .r ` L ) y ) ) $.
    rhmpropd.h $e |- ( ( ph /\ ( x e. C /\ y e. C ) ) ->
        ( x ( .r ` K ) y ) = ( x ( .r ` M ) y ) ) $.
    $( Ring homomorphism depends only on the ring attributes of structures.
       (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    rhmpropd $p |- ( ph -> ( J RingHom K ) = ( L RingHom M ) ) $=
      ( co wcel cfv vf crh crg wa cv cghm cmgp rngpropd anbi12d ghmpropd eleq2d
      cmhm cbs mgpbas syl6eq cmulr cplusg mgpplusg oveqi 3eqtr3g mhmpropd isrhm
      eqid 3bitr4g eqrdv ) AUAFGUBRZHIUBRZAFUCSZGUCSZUDZUAUEZFGUFRZSZVKFUGTZGUG
      TZULRZSZUDZUDHUCSZIUCSZUDZVKHIUFRZSZVKHUGTZIUGTZULRZSZUDZUDVKVFSVKVGSAVJW
      AVRWHAVHVSVIVTABCDFHJLNPUHABCEGIKMOQUHUIAVMWCVQWGAVLWBVKABCDEFGHIJKLMNOUJ
      UKAVPWFVKABCDEVNVOWDWEADFUMTZVNUMTJWIFVNVNVCZWIVCUNUOAEGUMTZVOUMTKWKGVOVO
      VCZWKVCUNUOADHUMTZWDUMTLWMHWDWDVCZWMVCUNUOAEIUMTZWEUMTMWOIWEWEVCZWOVCUNUO
      ABUEZDSCUEZDSUDUDWQWRFUPTZRWQWRHUPTZRWQWRVNUQTZRWQWRWDUQTZRPWSXAWQWRFWSVN
      WJWSVCURUSWTXBWQWRHWTWDWNWTVCURUSUTAWQESWRESUDUDWQWRGUPTZRWQWRIUPTZRWQWRV
      OUQTZRWQWRWEUQTZRQXCXEWQWRGXCVOWLXCVCURUSXDXFWQWRIXDWEWPXDVCURUSUTVAUKUIU
      IFGVKVNVOWJWLVBHIVKWDWEWNWPVBVDVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Absolute value (abstract algebra)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c AbsVal $. $( Absolute value function $)

  $( The set of absolute values on a ring. $)
  cabv $a class AbsVal $.

  ${
    $d f r x y $.
    $( Define the set of absolute values on a ring.  An absolute value is a
       generalization of the usual absolute value function ~ df-abs to
       arbitrary rings.  (Contributed by Mario Carneiro, 8-Sep-2014.) $)
    df-abv $a |- AbsVal = ( r e. Ring |->
                            { f e. ( ( 0 [,) +oo ) ^m ( Base ` r ) ) |
      A. x e. ( Base ` r ) ( ( ( f ` x ) = 0 <-> x = ( 0g ` r ) ) /\
      A. y e. ( Base ` r )
        ( ( f ` ( x ( .r ` r ) y ) ) = ( ( f ` x ) x. ( f ` y ) ) /\
          ( f ` ( x ( +g ` r ) y ) ) <_ ( ( f ` x ) + ( f ` y ) ) ) ) } ) $.
  $}

  ${
    $d f r x y B $.  $d f x y F $.  $d f r .+ $.  $d x y ph $.  $d f r x y R $.
    $d f r .x. $.  $d f r .0. $.
    abvfval.a $e |- A = ( AbsVal ` R ) $.
    abvfval.b $e |- B = ( Base ` R ) $.
    abvfval.p $e |- .+ = ( +g ` R ) $.
    abvfval.t $e |- .x. = ( .r ` R ) $.
    abvfval.z $e |- .0. = ( 0g ` R ) $.
    $( Value of the set of absolute values.  (Contributed by Mario Carneiro,
       8-Sep-2014.) $)
    abvfval $p |- ( R e. Ring -> A = { f e. ( ( 0 [,) +oo ) ^m B ) |
    A. x e. B ( ( ( f ` x ) = 0 <-> x = .0. ) /\ A. y e. B
      ( ( f ` ( x .x. y ) ) = ( ( f ` x ) x. ( f ` y ) ) /\
        ( f ` ( x .+ y ) ) <_ ( ( f ` x ) + ( f ` y ) ) ) ) } ) $=
      ( cfv cv wceq co wa wral vr crg wcel cabv cc0 wb cmul caddc cle cpnf cico
      wbr cmap c0g cmulr cplusg fveq2 syl6eqr oveq2d eqeq2d bibi2d oveqd fveq2d
      crab cbs eqeq1d breq1d raleqbidv rabeqbidv df-abv ovex rabex fvmpt syl5eq
      anbi12d ) FUBUCCFUDOAPZHPZOZUEQZVPIQZUFZVPBPZGRZVQOZVRWBVQOZUGRZQZVPWBERZ
      VQOZVRWEUHRZUIULZSZBDTZSZADTZHUEUJUKRZDUMRZVDZJUAFVSVPUAPZUNOZQZUFZVPWBWS
      UOOZRZVQOZWFQZVPWBWSUPOZRZVQOZWJUIULZSZBWSVEOZTZSZAXLTZHWPXLUMRZVDWRUBUDW
      SFQZXOWOHXPWQXQXLDWPUMXQXLFVEODWSFVEUQKURZUSXQXNWNAXLDXRXQXBWAXMWMXQXAVTV
      SXQWTIVPXQWTFUNOIWSFUNUQNURUTVAXQXKWLBXLDXRXQXFWGXJWKXQXEWDWFXQXDWCVQXQXC
      GVPWBXQXCFUOOGWSFUOUQMURVBVCVFXQXIWIWJUIXQXHWHVQXQXGEVPWBXQXGFUPOEWSFUPUQ
      LURVBVCVGVOVHVOVHVIABHUAVJWOHWQWPDUMVKVLVMVN $.

    $( Elementhood in the set of absolute values.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    isabv $p |- ( R e. Ring -> ( F e. A <-> ( F : B --> ( 0 [,) +oo ) /\
    A. x e. B ( ( ( F ` x ) = 0 <-> x = .0. ) /\ A. y e. B
      ( ( F ` ( x .x. y ) ) = ( ( F ` x ) x. ( F ` y ) ) /\
        ( F ` ( x .+ y ) ) <_ ( ( F ` x ) + ( F ` y ) ) ) ) ) ) ) $=
      ( vf cfv cc0 wceq co wa crg wcel cv wb cmul caddc cle wral cpnf cico cmap
      wbr wf abvfval eleq2d fveq1 eqeq1d bibi1d oveq12d eqeq12d breq12d anbi12d
      crab ralbidv elrab ovex cbs cvv fvex eqeltri elmap anbi1i bitri syl6bb )
      FUAUBZHCUBHAUCZOUCZPZQRZVPIRZUDZVPBUCZGSZVQPZVRWBVQPZUESZRZVPWBESZVQPZVRW
      EUFSZUGULZTZBDUHZTZADUHZOQUIUJSZDUKSZVCZUBZDWPHUMZVPHPZQRZVTUDZWCHPZXAWBH
      PZUESZRZWHHPZXAXEUFSZUGULZTZBDUHZTZADUHZTZVOCWRHABCDEFGOIJKLMNUNUOWSHWQUB
      ZXNTXOWOXNOHWQVQHRZWNXMADXQWAXCWMXLXQVSXBVTXQVRXAQVPVQHUPZUQURXQWLXKBDXQW
      GXGWKXJXQWDXDWFXFWCVQHUPXQVRXAWEXEUEXRWBVQHUPZUSUTXQWIXHWJXIUGWHVQHUPXQVR
      XAWEXEUFXRXSUSVAVBVDVBVDVEXPWTXNWPDHQUIUJVFDFVGPVHKFVGVIVJVKVLVMVN $.
  $}

  ${
    $d x y F $.  $d x y ph $.  $d x y R $.
    isabvd.a $e |- ( ph -> A = ( AbsVal ` R ) ) $.
    isabvd.b $e |- ( ph -> B = ( Base ` R ) ) $.
    isabvd.p $e |- ( ph -> .+ = ( +g ` R ) ) $.
    isabvd.t $e |- ( ph -> .x. = ( .r ` R ) ) $.
    isabvd.z $e |- ( ph -> .0. = ( 0g ` R ) ) $.
    isabvd.1 $e |- ( ph -> R e. Ring ) $.
    isabvd.2 $e |- ( ph -> F : B --> RR ) $.
    isabvd.3 $e |- ( ph -> ( F ` .0. ) = 0 ) $.
    isabvd.4 $e |- ( ( ph /\ x e. B /\ x =/= .0. ) -> 0 < ( F ` x ) ) $.
    isabvd.5 $e |- ( ( ph /\
      ( x e. B /\ x =/= .0. ) /\ ( y e. B /\ y =/= .0. ) ) ->
      ( F ` ( x .x. y ) ) = ( ( F ` x ) x. ( F ` y ) ) ) $.
    isabvd.6 $e |- ( ( ph /\
      ( x e. B /\ x =/= .0. ) /\ ( y e. B /\ y =/= .0. ) ) ->
      ( F ` ( x .+ y ) ) <_ ( ( F ` x ) + ( F ` y ) ) ) $.
    $( Properties that determine an absolute value.  (Contributed by Mario
       Carneiro, 8-Sep-2014.)  (Revised by Mario Carneiro, 4-Dec-2014.) $)
    isabvd $p |- ( ph -> F e. A ) $=
      ( cabv cfv wcel cbs cc0 cpnf cico co wf cv wceq c0g wb cmulr cplusg caddc
      cmul cle wbr wa wral wfn feq2d mpbid ffn syl ffvelrnda 0le0 fveq2d eqtr3d
      syl5breqr adantr fveq2 breq2d syl5ibrcom wne w3a clt simp1 simp2 3ad2ant1
      cr eleqtrrd simp3 neeqtrrd syl3anc wi 0re 3adant3 ltle sylancr mpd 3expia
      pm2.61dne elrege0 ralrimiva ffnfv gt0ne0d necon4d eqeq1d impbid oveq1 crg
      sylanbrc eqid rnglz syl2anc sylan9eqr oveq1d ffvelrnd recnd eqtrd 3eqtr4d
      mul02d oveq2 rngrz oveq2d mul01d simpl1 oveqd simpl2 simprl simpl3 simprr
      syl122anc pm2.61da2ne cgrp rnggrp grplid addge02d eqbrtrd grprid addge01d
      cc eqbrtrrd jca ralrimiv isabv mpbir2and ) AIGUBUCZDAIUUAUDZGUEUCZUFUGUHU
      IZIUJZBUKZIUCZUFULZUUFGUMUCZULZUNZUUFCUKZGUOUCZUIZIUCZUUGUULIUCZURUIZULZU
      UFUULGUPUCZUIZIUCZUUGUUPUQUIZUSUTZVAZCUUCVBZVAZBUUCVBZAIUUCVCZUUGUUDUDZBU
      UCVBUUEAUUCWCIUJZUVHAEWCIUJUVJQAEUUCWCILVDVEZUUCWCIVFVGAUVIBUUCAUUFUUCUDZ
      VAZUUGWCUDZUFUUGUSUTZUVIAUUCWCUUFIUVKVHZUVMUVOUUFUUIUVMUVOUUJUFUUIIUCZUSU
      TZAUVRUVLAUFUFUVQUSVIAJIUCUVQUFAJUUIIOVJRVKZVLVMUUJUUGUVQUFUSUUFUUIIVNZVO
      VPAUVLUUFUUIVQZUVOAUVLUWAVRZUFUUGVSUTZUVOUWBAUUFEUDZUUFJVQZUWCAUVLUWAVTUW
      BUUFUUCEAUVLUWAWAAUVLEUUCULZUWALWBWDUWBUUFUUIJAUVLUWAWEAUVLJUUIULZUWAOWBW
      FSWGZUWBUFWCUDUVNUWCUVOWHWIAUVLUVNUWAUVPWJUFUUGWKWLWMWNWOUUGWPXEWQBUUCUUD
      IWRXEAUVFBUUCUVMUUKUVEUVMUUHUUJUVMUUFUUIUUGUFAUVLUWAUUGUFVQUWBUUGUWHWSWNW
      TUVMUUHUUJUVQUFULZAUWIUVLUVSVMUUJUUGUVQUFUVTXAVPXBUVMUVDCUUCAUVLUULUUCUDZ
      UVDAUVLUWJVRZUURUVCUWKUURUUFUUIUULUUIUWKUUJVAZUVQUFUUOUUQUWKUWIUUJAUVLUWI
      UWJUVSWBZVMUWLUUNUUIIUUJUWKUUNUUIUULUUMUIZUUIUUFUUIUULUUMXCUWKGXDUDZUWJUW
      NUUIULAUVLUWOUWJPWBZAUVLUWJWEZUUCGUUMUULUUIUUCXFZUUMXFZUUIXFZXGXHXIVJUWLU
      UQUFUUPURUIUFUWLUUGUFUUPURUUJUWKUUGUVQUFUVTUWMXIZXJUWLUUPUWKUUPYOUDUUJUWK
      UUPUWKUUCWCUULIAUVLUVJUWJUVKWBZUWQXKZXLVMXOXMXNUWKUULUUIULZVAZUVQUFUUOUUQ
      UWKUWIUXDUWMVMUXEUUNUUIIUXDUWKUUNUUFUUIUUMUIZUUIUULUUIUUFUUMXPUWKUWOUVLUX
      FUUIULUWPAUVLUWJWAZUUCGUUMUUFUUIUWRUWSUWTXQXHXIVJUXEUUQUUGUFURUIUFUXEUUPU
      FUUGURUXDUWKUUPUVQUFUULUUIIVNUWMXIZXRUXEUUGUWKUUGYOUDUXDUWKUUGUWKUUCWCUUF
      IUXBUXGXKZXLVMXSXMXNUWKUWAUULUUIVQZVAZVAZUUFUULHUIZIUCZUUOUUQUXLUXMUUNIUX
      LHUUMUUFUULUXLAHUUMULAUVLUWJUXKXTZNVGYAVJUXLAUWDUWEUULEUDZUULJVQZUXNUUQUL
      UXOUXLUUFUUCEAUVLUWJUXKYBUXLAUWFUXOLVGZWDZUXLUUFUUIJUWKUWAUXJYCUXLAUWGUXO
      OVGZWFZUXLUULUUCEAUVLUWJUXKYDUXRWDZUXLUULUUIJUWKUWAUXJYEUXTWFZTYFVKYGUWKU
      VCUUFUUIUULUUIUWLUVAUUPUVBUSUWLUUTUULIUUJUWKUUTUUIUULUUSUIZUULUUFUUIUULUU
      SXCUWKGYHUDZUWJUYDUULULUWKUWOUYEUWPGYIVGZUWQUUCUUSGUULUUIUWRUUSXFZUWTYJXH
      XIVJUWLUVOUUPUVBUSUTZUWLUFUFUUGUSVIUXAVLUWKUVOUYHUNUUJUWKUUPUUGUXCUXIYKVM
      VEYLUXEUVAUUGUVBUSUXEUUTUUFIUXDUWKUUTUUFUUIUUSUIZUUFUULUUIUUFUUSXPUWKUYEU
      VLUYIUUFULUYFUXGUUCUUSGUUFUUIUWRUYGUWTYMXHXIVJUXEUFUUPUSUTZUUGUVBUSUTZUXE
      UFUFUUPUSVIUXHVLUWKUYJUYKUNUXDUWKUUGUUPUXIUXCYNVMVEYLUXLUUFUULFUIZIUCZUVA
      UVBUSUXLUYLUUTIUXLFUUSUUFUULUXLAFUUSULUXOMVGYAVJUXLAUWDUWEUXPUXQUYMUVBUSU
      TUXOUXSUYAUYBUYCUAYFYPYGYQWNYRYQWQAUWOUUBUUEUVGVAUNPBCUUAUUCUUSGUUMIUUIUU
      AXFUWRUYGUWSUWTYSVGYTKWD $.
  $}

  ${
    $d x y .+ $.  $d x .0. $.  $d x y B $.  $d x y F $.  $d x y R $.  $d y Y $.
    $d f r x y $.  $d x y .x. $.  $d x y X $.
    abvf.a $e |- A = ( AbsVal ` R ) $.
    $( Reverse closure for the absolute value set.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    abvrcl $p |- ( F e. A -> R e. Ring ) $=
      ( vr vx vf vy crg wcel cabv cfv cdm cv cc0 wceq c0g co wa wral cmulr cmul
      cplusg caddc cle wbr cbs cpnf cico cmap crab df-abv dmmptss elfvdm sseldi
      wb eleq2s ) BIJCBKLZACURJKMIBEIFNZGNZLZOPUSENZQLPUPUSHNZVBUALRUTLVAVCUTLZ
      UBRPUSVCVBUCLRUTLVAVDUDRUEUFSHVBUGLZTSFVETGOUHUIRVEUJRUKKFHGEULUMCBKUNUOD
      UQ $.

    abvf.b $e |- B = ( Base ` R ) $.
    $( An absolute value is a function from the ring to the nonnegative real
       numbers.  (Contributed by Mario Carneiro, 8-Sep-2014.) $)
    abvfge0 $p |- ( F e. A -> F : B --> ( 0 [,) +oo ) ) $=
      ( vx vy wcel cc0 cpnf cico co cv cfv wceq wb wa wral eqid wf cmulr cplusg
      c0g cmul caddc cle wbr crg abvrcl isabv syl ibi simpld ) DAIZBJKLMDUAZGNZ
      DOZJPUQCUDOZPQUQHNZCUBOZMDOURUTDOZUEMPUQUTCUCOZMDOURVBUFMUGUHRHBSRGBSZUOU
      PVDRZUOCUIIUOVEQACDEUJGHABVCCVADUSEFVCTVATUSTUKULUMUN $.

    $( An absolute value is a function from the ring to the real numbers.
       (Contributed by Mario Carneiro, 8-Sep-2014.) $)
    abvf $p |- ( F e. A -> F : B --> RR ) $=
      ( wcel cc0 cpnf cico co wf cr wss abvfge0 cxr 0re pnfxr icossre mp2an fss
      sylancl ) DAGBHIJKZDLUCMNZBMDLABCDEFOHMGIPGUDQRHISTBUCMDUAUB $.

    $( An absolute value is a function from the ring to the real numbers.
       (Contributed by Mario Carneiro, 8-Sep-2014.) $)
    abvcl $p |- ( ( F e. A /\ X e. B ) -> ( F ` X ) e. RR ) $=
      ( wcel cr abvf ffvelrnda ) DAHBIEDABCDFGJK $.

    $( The absolute value of a number is greater or equal to zero.
       (Contributed by Mario Carneiro, 8-Sep-2014.) $)
    abvge0 $p |- ( ( F e. A /\ X e. B ) -> 0 <_ ( F ` X ) ) $=
      ( wcel wa cfv cc0 cpnf cico co cle wbr abvfge0 ffvelrnda cr elrege0 syl
      simprbi ) DAHZEBHIEDJZKLMNZHZKUDOPZUCBUEEDABCDFGQRUFUDSHUGUDTUBUA $.

    ${
      abveq0.z $e |- .0. = ( 0g ` R ) $.
      $( The value of an absolute value is zero iff the argument is zero.
         (Contributed by Mario Carneiro, 8-Sep-2014.) $)
      abveq0 $p |- ( ( F e. A /\ X e. B ) -> ( ( F ` X ) = 0 <-> X = .0. ) ) $=
        ( vx vy wcel cv cfv cc0 wceq wb wral co wa cmulr cmul cplusg caddc cpnf
        cle wbr cico wf crg abvrcl eqid isabv syl ibi simprd simpl ralimi fveq2
        eqeq1d eqeq1 bibi12d rspccva sylan ) DALZJMZDNZOPZVFFPZQZJBRZEBLEDNZOPZ
        EFPZQZVEVJVFKMZCUANZSDNVGVPDNZUBSPVFVPCUCNZSDNVGVRUDSUFUGTKBRZTZJBRZVKV
        EBOUEUHSDUIZWBVEWCWBTZVECUJLVEWDQACDGUKJKABVSCVQDFGHVSULVQULIUMUNUOUPWA
        VJJBVJVTUQURUNVJVOJEBVFEPZVHVMVIVNWEVGVLOVFEDUSUTVFEFVAVBVCVD $.

      $( The absolute value of a nonzero number is nonzero.  (Contributed by
         Mario Carneiro, 8-Sep-2014.) $)
      abvne0 $p |- ( ( F e. A /\ X e. B /\ X =/= .0. ) -> ( F ` X ) =/= 0 ) $=
        ( wcel cfv cc0 wne wa abveq0 necon3bid biimp3ar ) DAJZEBJZEDKZLMEFMRSNT
        LEFABCDEFGHIOPQ $.

      $( The absolute value of a nonzero number is strictly positive.
         (Contributed by Mario Carneiro, 8-Sep-2014.) $)
      abvgt0 $p |- ( ( F e. A /\ X e. B /\ X =/= .0. ) -> 0 < ( F ` X ) ) $=
        ( wcel wne w3a cfv cr abvcl 3adant3 cc0 cle wbr abvge0 abvne0 ne0gt0d )
        DAJZEBJZEFKZLEDMZUCUDUFNJUEABCDEGHOPUCUDQUFRSUEABCDEGHTPABCDEFGHIUAUB
        $.
    $}

    ${
      abvmul.t $e |- .x. = ( .r ` R ) $.
      $( An absolute value distributes under multiplication.  (Contributed by
         Mario Carneiro, 8-Sep-2014.) $)
      abvmul $p |- ( ( F e. A /\ X e. B /\ Y e. B ) ->
        ( F ` ( X .x. Y ) ) = ( ( F ` X ) x. ( F ` Y ) ) ) $=
        ( vx vy wcel co cfv cmul wceq cv wral wa cc0 c0g wb cplusg cle wbr cpnf
        caddc cico wf crg abvrcl isabv syl ibi simprd simpl ralimi adantl oveq1
        eqid fveq2d fveq2 oveq1d eqeq12d oveq2 oveq2d rspc2v syl5com 3impib ) E
        AMZFBMZGBMZFGDNZEOZFEOZGEOZPNZQZVKKRZLRZDNZEOZVTEOZWAEOZPNZQZLBSZKBSZVL
        VMTVSVKWDUAQVTCUBOZQUCZWGVTWACUDOZNEOWDWEUHNUEUFZTZLBSZTZKBSZWIVKBUAUGU
        INEUJZWQVKWRWQTZVKCUKMVKWSUCACEHULKLABWLCDEWJHIWLVAJWJVAUMUNUOUPWPWHKBW
        OWHWKWNWGLBWGWMUQURUSURUNWGVSFWADNZEOZVPWEPNZQKLFGBBVTFQZWCXAWFXBXCWBWT
        EVTFWADUTVBXCWDVPWEPVTFEVCVDVEWAGQZXAVOXBVRXDWTVNEWAGFDVFVBXDWEVQVPPWAG
        EVCVGVEVHVIVJ $.
    $}

    abvtri.p $e |- .+ = ( +g ` R ) $.
    $( An absolute value satisfies the triangle inequality.  (Contributed by
       Mario Carneiro, 8-Sep-2014.) $)
    abvtri $p |- ( ( F e. A /\ X e. B /\ Y e. B ) ->
      ( F ` ( X .+ Y ) ) <_ ( ( F ` X ) + ( F ` Y ) ) ) $=
      ( vx vy wcel co cfv caddc cle wral wa wceq wbr cv cc0 c0g cmulr cmul cpnf
      wb cico wf crg abvrcl eqid isabv syl ibi simprd simpr ralimi adantl oveq1
      fveq2d fveq2 oveq1d breq12d oveq2 oveq2d rspc2v syl5com 3impib ) EAMZFBMZ
      GBMZFGCNZEOZFEOZGEOZPNZQUAZVKKUBZLUBZCNZEOZVTEOZWAEOZPNZQUAZLBRZKBRZVLVMS
      VSVKWDUCTVTDUDOZTUHZVTWADUEOZNEOWDWEUFNTZWGSZLBRZSZKBRZWIVKBUCUGUINEUJZWQ
      VKWRWQSZVKDUKMVKWSUHADEHULKLABCDWLEWJHIJWLUMWJUMUNUOUPUQWPWHKBWOWHWKWNWGL
      BWMWGURUSUTUSUOWGVSFWACNZEOZVPWEPNZQUAKLFGBBVTFTZWCXAWFXBQXCWBWTEVTFWACVA
      VBXCWDVPWEPVTFEVCVDVEWAGTZXAVOXBVRQXDWTVNEWAGFCVFVBXDWEVQVPPWAGEVCVGVEVHV
      IVJ $.
  $}

  ${
    abv0.a $e |- A = ( AbsVal ` R ) $.
    ${
      abv0.z $e |- .0. = ( 0g ` R ) $.
      $( The absolute value of zero is zero.  (Contributed by Mario Carneiro,
         8-Sep-2014.) $)
      abv0 $p |- ( F e. A -> ( F ` .0. ) = 0 ) $=
        ( wcel cbs cfv cc0 wceq crg abvrcl eqid rng0cl syl abveq0 mpbiri mpdan
        wa ) CAGZDBHIZGZDCIJKZUABLGUCABCEMUBBDUBNZFOPUAUCTUDDDKDNAUBBCDDEUEFQRS
        $.
    $}

    ${
      abv1.p $e |- .1. = ( 1r ` R ) $.
      ${
        abv1z.z $e |- .0. = ( 0g ` R ) $.
        $( The absolute value of one is one in a non-trivial ring.
           (Contributed by Mario Carneiro, 8-Sep-2014.) $)
        abv1z $p |- ( ( F e. A /\ .1. =/= .0. ) -> ( F ` .1. ) = 1 ) $=
          ( wcel wne wa cfv co cdiv c1 eqid adantr syl3anc wceq eqtr3d cmul cbs
          cr crg abvrcl rngidcl syl abvcl mpdan recnd cc0 simpl abvne0 divcan3d
          simpr cmulr rnglidm syl2anc fveq2d abvmul oveq1d dividd ) DAIZCEJZKZC
          DLZVFUAMZVFNMZVFOVEVFVFVEVFVCVFUCIZVDVCCBUBLZIZVIVCBUDIZVKABDFUEZVJBC
          VJPZGUFUGZAVJBDCFVNUHUIQUJZVPVEVCVKVDVFUKJVCVDULZVCVKVDVOQZVCVDUOAVJB
          DCEFVNHUMRZUNVEVFVFNMVHOVEVFVGVFNVECCBUPLZMZDLZVFVGVEWACDVEVLVKWACSVC
          VLVDVMQVRVJBVTCCVNVTPZGUQURUSVEVCVKVKWBVGSVQVRVRAVJBVTDCCFVNWCUTRTVAV
          EVFVPVSVBTT $.
      $}

      $( The absolute value of one is one in a division ring.  (Contributed by
         Mario Carneiro, 8-Sep-2014.) $)
      abv1 $p |- ( ( R e. DivRing /\ F e. A ) -> ( F ` .1. ) = 1 ) $=
        ( wcel c0g cfv wne c1 wceq cdr id eqid drngunz abv1z syl2anr ) DAGZSCBH
        IZJCDIKLBMGSNBCTTOZFPABCDTEFUAQR $.
    $}

    abvneg.b $e |- B = ( Base ` R ) $.
    ${
      abvneg.p $e |- N = ( invg ` R ) $.
      $( The absolute value of a negative is the same as that of the positive.
         (Contributed by Mario Carneiro, 8-Sep-2014.) $)
      abvneg $p |- ( ( F e. A /\ X e. B ) ->
        ( F ` ( N ` X ) ) = ( F ` X ) ) $=
        ( wcel wa cfv wceq adantr eqid fveq2d c1 cmul co syl2anc cur c0g crg wi
        abvrcl cgrp rnggrp syl grpinvcl sylan simpr rng1eq0 syl3anc imp c2 cexp
        wne cmulr cr rngidcl abvcl mpdan recnd sqvald mpd3an23 rngmneg2 rngnegl
        abvmul grpinvinv 3eqtrd 3eqtr2d abv1z sq1 syl6eqr cc0 cle wbr wb abvge0
        eqtrd 1re 0le1 sq11 mpanr12 biimpa syldan adantlr oveq1d eqtr3d mulid2d
        simpl pm2.61dane ) DAJZFBJZKZFELZDLZFDLZMCUALZCUBLZWOWSWTMZKWPFDWOXAWPF
        MZWOCUCJZWPBJZWNXAXBUDWMXCWNACDGUEZNZWMCUFJZWNXDWMXCXGXECUGUHZBCEFHIUIU
        JWMWNUKZBCWSWPFWTHWSOZWTOZULUMUNPWOWSWTUQZKZQWRRSZWQWRXMWSELZDLZWRRSZXN
        WQXMXPQWRRWMXLXPQMZWNWMXLXPUOUPSZQUOUPSZMZXRWMXLKZXSQXTYBXSWSDLZQWMXSYC
        MXLWMXSXPXPRSZXOXOCURLZSZDLZYCWMXPWMXPWMXOBJZXPUSJZWMXGWSBJZYHXHWMXCYJX
        EBCWSHXJUTUHZBCEWSHIUITZABCDXOGHVAVBZVCVDWMYHYHYGYDMYLYLABCYEDXOXOGHYEO
        ZVHVEWMYFWSDWMYFXOWSYESZELXOELZWSWMBCYEEXOWSHYNIXEYLYKVFWMYOXOEWMBCYEWS
        EWSHYNXJIXEYKVGPWMXGYJYPWSMXHYKBCEWSHIVITVJPVKNACWSDWTGXJXKVLVTVMVNWMYA
        XRWMYIVOXPVPVQZYAXRVRZYMWMYHYQYLABCDXOGHVSVBYIYQKQUSJVOQVPVQYRWAWBXPQWC
        WDTWEWFWGWHWOXQWQMXLWOXOFYESZDLZXQWQWOWMYHWNYTXQMWMWNWKWMYHWNYLNXIABCYE
        DXOFGHYNVHUMWOYSWPDWOBCYEWSEFHYNXJIXFXIVGPWINWIWOXNWRMXLWOWRWOWRABCDFGH
        VAVCWJNWIWL $.
    $}

    ${
      abvsubtri.p $e |- .- = ( -g ` R ) $.
      $( An absolute value satisfies the triangle inequality.  (Contributed by
         Mario Carneiro, 4-Oct-2015.) $)
      abvsubtri $p |- ( ( F e. A /\ X e. B /\ Y e. B ) ->
        ( F ` ( X .- Y ) ) <_ ( ( F ` X ) + ( F ` Y ) ) ) $=
        ( wcel w3a co cfv cminusg cplusg caddc cle wceq eqid 3adant1 fveq2d wbr
        grpsubval cgrp crg abvrcl 3ad2ant1 rnggrp simp3 grpinvcl syl2anc abvtri
        syl syld3an3 abvneg 3adant2 oveq2d breqtrd eqbrtrd ) DAKZFBKZGBKZLZFGEM
        ZDNFGCONZNZCPNZMZDNZFDNZGDNZQMZRVDVEVIDVBVCVEVISVABVHCVFEFGIVHTZVFTZJUD
        UAUBVDVJVKVGDNZQMZVMRVAVBVCVGBKZVJVQRUCVDCUEKZVCVRVDCUFKZVSVAVBVTVCACDH
        UGUHCUIUNVAVBVCUJBCVFGIVOUKULABVHCDFVGHIVNUMUOVDVPVLVKQVAVCVPVLSVBABCDV
        FGHIVOUPUQURUSUT $.
    $}

    abvrec.z $e |- .0. = ( 0g ` R ) $.
    ${
      abvrec.p $e |- I = ( invr ` R ) $.
      $( The absolute value distributes under reciprocal.  (Contributed by
         Mario Carneiro, 10-Sep-2014.) $)
      abvrec $p |- ( ( ( R e. DivRing /\ F e. A ) /\ ( X e. B /\ X =/= .0. ) )
        -> ( F ` ( I ` X ) ) = ( 1 / ( F ` X ) ) ) $=
        ( wcel wa cfv co cdiv c1 syl3anc wceq eqtr3d cdr wne cmul simplr simpll
        cr simprl simprr drnginvrcl abvcl syl2anc recnd cc0 abvne0 divcan3d cur
        cmulr eqid drnginvrr fveq2d abvmul abv1 adantr oveq1d ) CUALZDALZMZFBLZ
        FGUBZMZMZFDNZFENZDNZUCOZVLPOVNQVLPOVKVNVLVKVNVKVFVMBLZVNUFLVEVFVJUDZVKV
        EVHVIVPVEVFVJUEZVGVHVIUGZVGVHVIUHZBCEFGIJKUIRZABCDVMHIUJUKULVKVLVKVFVHV
        LUFLVQVSABCDFHIUJUKULVKVFVHVIVLUMUBVQVSVTABCDFGHIJUNRUOVKVOQVLPVKCUPNZD
        NZVOQVKFVMCUQNZOZDNZWCVOVKWEWBDVKVEVHVIWEWBSVRVSVTBCWDWBEFGIJWDURZWBURZ
        KUSRUTVKVFVHVPWFVOSVQVSWAABCWDDFVMHIWGVARTVGWCQSVJACWBDHWHVBVCTVDT $.
    $}

    ${
      abvdiv.p $e |- ./ = ( /r ` R ) $.
      $( The absolute value distributes under division.  (Contributed by Mario
         Carneiro, 10-Sep-2014.) $)
      abvdiv $p |- ( ( ( R e. DivRing /\ F e. A ) /\
                       ( X e. B /\ Y e. B /\ Y =/= .0. ) ) ->
                     ( F ` ( X ./ Y ) ) = ( ( F ` X ) / ( F ` Y ) ) ) $=
        ( wcel wa cfv co cmul wceq eqid syl3anc cdr wne w3a cinvr cmulr c1 cdiv
        simplr simpr1 simpll simpr2 simpr3 drnginvrcl abvmul 3adantr1 eqtrd cui
        abvrec oveq2d wb drngunit syl mpbir2and dvrval syl2anc fveq2d abvcl cc0
        cr recnd abvne0 divrecd 3eqtr4d ) DUAMZEAMZNZFBMZGBMZGHUBZUCZNZFGDUDOZO
        ZDUEOZPZEOZFEOZUFGEOZUGPZQPZFGCPZEOWGWHUGPWAWFWGWCEOZQPZWJWAVOVQWCBMZWF
        WMRVNVOVTUHZVPVQVRVSUIZWAVNVRVSWNVNVOVTUJZVPVQVRVSUKZVPVQVRVSULZBDWBGHJ
        KWBSZUMTABDWDEFWCIJWDSZUNTWAWLWIWGQVPVRVSWLWIRVQABDEWBGHIJKWTURUOUSUPWA
        WKWEEWAVQGDUQOZMZWKWERWPWAXCVRVSWRWSWAVNXCVRVSNUTWQBDXBGHJXBSZKVAVBVCBC
        DWDXBWBFGJXAXDWTLVDVEVFWAWGWHWAWGWAVOVQWGVIMWOWPABDEFIJVGVEVJWAWHWAVOVR
        WHVIMWOWRABDEGIJVGVEVJWAVOVRVSWHVHUBWOWRWSABDEGHIJKVKTVLVM $.
    $}

    ${
      abvdom.t $e |- .x. = ( .r ` R ) $.
      $( Any ring with an absolute value is a domain, which is to say that it
         contains no zero divisors.  (Contributed by Mario Carneiro,
         10-Sep-2014.) $)
      abvdom $p |- ( ( F e. A /\ ( X e. B /\ X =/= .0. ) /\
        ( Y e. B /\ Y =/= .0. ) ) -> ( X .x. Y ) =/= .0. ) $=
        ( wcel wne wa co cfv cc0 wceq syl3anc w3a simp1 simp2l simp3l abvmul cr
        cmul abvcl syl2anc recnd simp2r abvne0 simp3r mulne0d eqnetrd syl fveq2
        abv0 eqeq1d syl5ibrcom necon3d mpd ) EAMZFBMZFHNZOZGBMZGHNZOZUAZFGDPZEQ
        ZRNVKHNVJVLFEQZGEQZUGPZRVJVCVDVGVLVOSVCVFVIUBZVCVDVEVIUCZVCVFVGVHUDZABC
        DEFGIJLUETVJVMVNVJVMVJVCVDVMUFMVPVQABCEFIJUHUIUJVJVNVJVCVGVNUFMVPVRABCE
        GIJUHUIUJVJVCVDVEVMRNVPVQVCVDVEVIUKABCEFHIJKULTVJVCVGVHVNRNVPVRVCVFVGVH
        UMABCEGHIJKULTUNUOVJVKHVLRVJVLRSVKHSZHEQZRSZVJVCWAVPACEHIKURUPVSVLVTRVK
        HEUQUSUTVAVB $.
    $}
  $}

  ${
    $d x y A $.  $d x y C $.  $d x y F $.  $d x y R $.  $d x y S $.
    abvres.a $e |- A = ( AbsVal ` R ) $.
    abvres.s $e |- S = ( R |`s C ) $.
    abvres.b $e |- B = ( AbsVal ` S ) $.
    $( The restriction of an absolute value to a subring is an absolute value.
       (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    abvres $p |- ( ( F e. A /\ C e. ( SubRing ` R ) ) -> ( F |` C ) e. B ) $=
      ( wcel cfv wa wceq adantl eqid syl cc0 fvres syl3anc co vx vy csubrg cres
      cplusg cmulr c0g cabv a1i cbs subrgbas ressplusg ressmulr csubg subrgsubg
      subg0 crg subrgrng cr wf wss abvf subrgss fssres syl2an subg0cl 3syl abv0
      adantr eqtrd cv wne w3a clt simp1l sselda 3adant3 simp3 3ad2ant2 breqtrrd
      wbr abvgt0 cmul simp1r simp2l sseldd simp3l abvmul subrgmcl oveq12d caddc
      3eqtr4d cle abvtri subrgacl 3brtr4d isabvd ) FAJZCDUCKZJZLZUAUBBCDUEKZEDU
      FKZFCUDZDUGKZBEUHKMXAIUIWTCEUJKMWRCDEHUKNWTXBEUEKMWRCXBDEWSHXBOZULNWTXCEU
      FKMWRCDEXCWSHXCOZUMNXACDUNKJZXEEUGKMWTXHWRCDUONZCDEXEHXEOZUPPWTEUQJWRCDEH
      URNWRDUJKZUSFUTCXKVAZCUSXDUTWTAXKDFGXKOZVBCXKDXMVCZXKUSCFVDVEXAXEXDKZXEFK
      ZQXAXHXECJXOXPMXICDXEXJVFXECFRVGWRXPQMWTADFXEGXJVHVIVJXAUAVKZCJZXQXEVLZVM
      ZQXQFKZXQXDKZVNXTWRXQXKJZXSQYAVNWAWRWTXRXSVOXAXRYCXSXACXKXQWTXLWRXNNVPVQX
      AXRXSVRAXKDFXQXEGXMXJWBSXRXAYBYAMZXSXQCFRZVSVTXAXRXSLZUBVKZCJZYGXEVLZLZVM
      ZXQYGXCTZFKZYAYGFKZWCTZYLXDKZYBYGXDKZWCTYKWRYCYGXKJZYMYOMWRWTYFYJVOZYKCXK
      XQYKWTXLWRWTYFYJWDZXNPZXAXRXSYJWEZWFZYKCXKYGUUAXAYFYHYIWGZWFZAXKDXCFXQYGG
      XMXGWHSYKYLCJZYPYMMYKWTXRYHUUFYTUUBUUDCDXCXQYGXGWISYLCFRPYKYBYAYQYNWCYKXR
      YDUUBYEPZYKYHYQYNMUUDYGCFRPZWJWLYKXQYGXBTZFKZYAYNWKTZUUIXDKZYBYQWKTWMYKWR
      YCYRUUJUUKWMWAYSUUCUUEAXKXBDFXQYGGXMXFWNSYKUUICJZUULUUJMYKWTXRYHUUMYTUUBU
      UDCXBDXQYGXFWOSUUICFRPYKYBYAYQYNWKUUGUUHWJWPWQ $.
  $}

  ${
    $d x .0. $.  $d y z F $.  $d x y z ph $.  $d x y z R $.  $d x .x. $.
    $d x B $.
    abvtriv.a $e |- A = ( AbsVal ` R ) $.
    abvtriv.b $e |- B = ( Base ` R ) $.
    abvtriv.z $e |- .0. = ( 0g ` R ) $.
    abvtriv.f $e |- F = ( x e. B |-> if ( x = .0. , 0 , 1 ) ) $.
    ${
      abvtrivd.1 $e |- .x. = ( .r ` R ) $.
      abvtrivd.2 $e |- ( ph -> R e. Ring ) $.
      abvtrivd.3 $e |- ( ( ph /\ ( y e. B /\ y =/= .0. ) /\
        ( z e. B /\ z =/= .0. ) ) -> ( y .x. z ) =/= .0. ) $.
      $( The trivial absolute value.  (Contributed by Mario Carneiro,
         6-May-2015.) $)
      abvtrivd $p |- ( ph -> F e. A ) $=
        ( wceq cc0 c1 cplusg cfv cabv a1i cbs eqidd cmulr c0g cv cif cr wcel wa
        0re 1re keepel fmptd crg rng0cl iftrue c0ex fvmpt 3syl wne w3a clt 0lt1
        eqeq1 ifbid 1ex ifex ifnefalse sylan9eq 3adant1 syl5breqr cmul co 1t1e1
        eqcomi 3ad2ant1 simp2l simp3l rngcl syl3anc syl wn neneqd iffalse eqtrd
        simp2r simp3r oveq12d 3eqtr4a caddc cle wbr c2 breq1 2re ltleii keephyp
        2pos 1lt2 df-2 breqtri cgrp rnggrp eqid grpcl 3brtr4d isabvd ) ACDEFGUA
        UBZGHIJEGUCUBRAKUDFGUEUBRALUDAXLUFHGUGUBRAOUDJGUHUBRAMUDPABFBUIZJRZSTUJ
        ZUKIXOUKULAXMFULUMXNSTUKUNUOUPUDNUQAGURULZJFULJIUBSRPFGJLMUSBJXOSFIXNST
        UTNVAVBVCACUIZFULZXQJVDZVESTXQIUBZVFVGXRXSXTTRAXRXSXTXQJRZSTUJZTBXQXOYB
        FIXMXQRXNYASTXMXQJVHVINYASTVAVJVKVBZXQJSTVLVMVNVOAXRXSUMZDUIZFULZYEJVDZ
        UMZVEZTTTVPVQZXQYEHVQZIUBZXTYEIUBZVPVQYJTVRVSYIYLYKJRZSTUJZTYIYKFULZYLY
        ORYIXPXRYFYPAYDXPYHPVTAXRXSYHWAZAYDYFYGWBZFGHXQYELOWCWDBYKXOYOFIXMYKRXN
        YNSTXMYKJVHVINYNSTVAVJVKVBWEYIYNWFYOTRYIYKJQWGYNSTWHWEWIYIXTTYMTVPYIXTY
        BTYIXRXTYBRYQYCWEYIYAWFYBTRYIXQJAXRXSYHWJWGYASTWHWEWIZYIYMYEJRZSTUJZTYI
        YFYMUUARYRBYEXOUUAFIXMYERXNYTSTXMYEJVHVINYTSTVAVJVKVBWEYIYTWFUUATRYIYEJ
        AYDYFYGWKWGYTSTWHWEWIZWLWMYIXQYEXLVQZJRZSTUJZTTWNVQZUUCIUBZXTYMWNVQWOUU
        EUUFWOWPYIUUEWQUUFWOUUDSWQWOWPTWQWOWPUUEWQWOWPSTSUUEWQWOWRTUUEWQWOWRSWQ
        UNWSXBWTTWQUOWSXCWTXAXDXEUDYIUUCFULZUUGUUERYIGXFULZXRYFUUHAYDUUIYHAXPUU
        IPGXGWEVTYQYRFXLGXQYELXLXHXIWDBUUCXOUUEFIXMUUCRXNUUDSTXMUUCJVHVINUUDSTV
        AVJVKVBWEYIXTTYMTWNYSUUBWLXJXK $.
    $}

    $( The trivial absolute value.  (This theorem is true as long as ` R ` is a
       domain, but it is not true for rings with zero divisors, which violate
       the multiplication axiom; ~ abvdom is the converse of this remark.)
       (Contributed by Mario Carneiro, 8-Sep-2014.)  (Revised by Mario
       Carneiro, 6-May-2015.) $)
    abvtriv $p |- ( R e. DivRing -> F e. A ) $=
      ( vy vz cdr wcel cmulr cfv cv wne wa eldifsn eqid drngrng w3a co csn cdif
      biid drngmcl syl3anbr sylib simprd abvtrivd ) DMNZAKLBCDDOPZEFGHIJUNUAZDU
      BUMKQZCNUPFRSZLQZCNURFRSZUCZUPURUNUDZCNZVAFRZUTVACFUEUFZNZVBVCSUMUMUQUPVD
      NUSURVDNVEUMUGUPCFTURCFTCDUNUPURFHUOIUHUIVACFTUJUKUL $.
  $}

  ${
    $d x y B $.  $d f x y K $.  $d f x y L $.  $d f x y ph $.
    abvpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    abvpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    abvpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    abvpropd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( If two structures have the same ring components, they have the same
       collection of absolute values.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    abvpropd $p |- ( ph -> ( AbsVal ` K ) = ( AbsVal ` L ) ) $=
      ( cfv wcel co cv wceq wb wa wral anbi12d eqid vf cabv crg cbs cc0 cpnf wf
      cico c0g cmulr cmul cplusg caddc cle wbr rngpropd eqtr3d feq2d grpidpropd
      adantr eqeq2d bibi2d fveq2d eqeq1d breq1d anassrs ralbidva raleqdv anbi2d
      raleqbidv 3bitr3d abvrcl isabv biadan2 3bitr4g eqrdv ) AUAEUBKZFUBKZAEUCL
      ZEUDKZUEUFUHMZUANZUGZBNZWBKZUEOZWDEUIKZOZPZWDCNZEUJKZMZWBKZWEWJWBKZUKMZOZ
      WDWJEULKZMZWBKZWEWNUMMZUNUOZQZCVTRZQZBVTRZQZQFUCLZFUDKZWAWBUGZWFWDFUIKZOZ
      PZWDWJFUJKZMZWBKZWOOZWDWJFULKZMZWBKZWTUNUOZQZCXHRZQZBXHRZQZQWBVQLZWBVRLZA
      VSXGXFYEABCDEFGHIJUPAWCXIXEYDAVTXHWAWBADVTXHGHUQURAWIXBCDRZQZBDRXLYACDRZQ
      ZBDRXEYDAYIYKBDAWDDLZQZWIXLYHYJYMWHXKWFYMWGXJWDAWGXJOYLABCDEFGHIUSUTVAVBY
      MXBYACDAYLWJDLZXBYAPAYLYNQQZWPXPXAXTYOWMXOWOYOWLXNWBJVCVDYOWSXSWTUNYOWRXR
      WBIVCVESVFVGSVGAYIXDBDVTGAYHXCWIAXBCDVTGVHVIVJAYKYCBDXHHAYJYBXLAYACDXHHVH
      VIVJVKSSYFVSXFVQEWBVQTZVLBCVQVTWQEWKWBWGYPVTTWQTWKTWGTVMVNYGXGYEVRFWBVRTZ
      VLBCVRXHXQFXMWBXJYQXHTXQTXMTXJTVMVNVOVP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Star rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c *Ring $.
  $c *rf $.

  $( Extend class notation with the functionalization of the *-ring
     involution. $)
  cstf $a class *rf $.

  $( Extend class notation with class of all *-rings. $)
  csr $a class *Ring $.

  ${
    $d f i x $.
    $( Define the functionalization of the involution in a star ring.  This is
       not strictly necessary but by having ` *r ` as an actual function we can
       state the principal properties of an involution much more cleanly.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    df-staf $a |- *rf = ( f e. _V |->
      ( x e. ( Base ` f ) |-> ( ( *r ` f ) ` x ) ) ) $.

    $( Define class of all star rings.  A star ring is a ring with an
       involution (conjugation) function.  Involution (unlike say the ring
       zero) is not unique and therefore must be added as a new component to
       the ring.  For example, two possible involutions for complex numbers are
       the identity function and complex conjugation.  Definition of involution
       in [Holland95] p. 204.  (Contributed by NM, 22-Sep-2011.)  (Revised by
       Mario Carneiro, 6-Oct-2015.) $)
    df-srng $a |- *Ring = { f | [. ( *rf ` f ) / i ].
      ( i e. ( f RingHom ( oppR ` f ) ) /\ i = `' i ) } $.
  $}

  ${
    $d x A $.  $d f x B $.  $d f x .* $.  $d f x R $.
    staffval.b $e |- B = ( Base ` R ) $.
    staffval.i $e |- .* = ( *r ` R ) $.
    staffval.f $e |- .xb = ( *rf ` R ) $.
    $( The functionalization of the involution component of a structure.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    staffval $p |- .xb = ( x e. B |-> ( .* ` x ) ) $=
      ( vf cstf cfv cv cmpt cvv wcel wceq cbs cstv syl6eqr c0 mpteq12dv df-staf
      fveq2 fveq1d crn csn cun eqid fvrn0 a1i fmpti fvex eqeltri rnex p0ex unex
      wf fex2 mp3an fvmpt wn fvprc mpt0 syl5eq mpteq1d eqtr4d pm2.61i eqtri ) D
      CJKZABALZEKZMZHCNOZVIVLPICAILZQKZVJVNRKZKZMVLNJVNCPZAVOVQBVKVRVOCQKZBVNCQ
      UCFSVRVJVPEVRVPCRKZEVNCRUCGSUDUAAIUBBEUEZTUFZUGZVLUQBNOWCNOVLNOABWCVKVLVL
      UHVKWCOVJBOEVJUIUJUKBVSNFCQULUMWAWBEEVTNGCRULUMUNUOUPBWCVLNNURUSUTVMVAZVI
      ATVKMZVLWDVITWECJVBAVKVCSWDABTVKWDBVSTFCQVBVDVEVFVGVH $.

    $( The functionalization of the involution component of a structure.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    stafval $p |- ( A e. B -> ( .xb ` A ) = ( .* ` A ) ) $=
      ( vx cv cfv fveq2 staffval fvex fvmpt ) IAIJZEKAEKBDPAELIBCDEFGHMAENO $.

    $( The functionalization is equal to the original function, if it is a
       function on the right base set.  (Contributed by Mario Carneiro,
       6-Oct-2015.) $)
    staffn $p |- ( .* Fn B -> .xb = .* ) $=
      ( vx wfn cv cfv cmpt wceq dffn5 biimpi staffval syl6reqr ) DAIZDHAHJDKLZC
      RDSMHADNOHABCDEFGPQ $.
  $}

  ${
    $d i r .* $.  $d i r O $.  $d i r R $.
    issrng.o $e |- O = ( oppR ` R ) $.
    issrng.i $e |- .* = ( *rf ` R ) $.
    $( The predicate "is a star ring."  (Contributed by NM, 22-Sep-2011.)
       (Revised by Mario Carneiro, 6-Oct-2015.) $)
    issrng $p |- ( R e. *Ring <-> ( .* e. ( R RingHom O ) /\ .* = `' .* ) ) $=
      ( vi vr csr wcel cv coppr cfv crh co ccnv wceq wa cstf cvv crg cab eleq2i
      wsbc df-srng rhmrcl1 elex syl adantr a1i id fveq2 syl6eqr sylan9eqr simpl
      fvex fveq2d oveq12d eleq12d cnveqd eqeq12d anbi12d sbcied elab3 bitri ) A
      HIAFJZGJZVFKLZMNZIZVEVEOZPZQZFVFRLZUCZGUAZIBACMNZIZBBOZPZQZHVOAGFUDUBVNVT
      GAVQASIZVSVQATIWAACBUEATUFUGUHVFAPZVLVTFVMSVMSIWBVFRUOUIWBVEVMPZQZVIVQVKV
      SWDVEBVHVPWCWBVEVMBWCUJWBVMARLBVFARUKEULUMZWDVFAVGCMWBWCUNZWDVGAKLCWDVFAK
      WFUPDULUQURWDVEBVJVRWEWDVEBWEUSUTVAVBVCVD $.

    $( The involution function in a star ring is an antiautomorphism.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    srngrhm $p |- ( R e. *Ring -> .* e. ( R RingHom O ) ) $=
      ( csr wcel crh co ccnv wceq issrng simplbi ) AFGBACHIGBBJKABCDELM $.
  $}

  $( A star ring is a ring.  (Contributed by Mario Carneiro, 6-Oct-2015.) $)
  srngrng $p |- ( R e. *Ring -> R e. Ring ) $=
    ( csr wcel cstf cfv coppr crh co crg eqid srngrhm rhmrcl1 syl ) ABCADEZAAFE
    ZGHCAICANOOJNJKAONLM $.

  ${
    srngcnv.i $e |- .* = ( *rf ` R ) $.
    $( The involution function in a star ring is its own inverse function.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    srngcnv $p |- ( R e. *Ring -> .* = `' .* ) $=
      ( csr wcel coppr cfv crh co ccnv wceq eqid issrng simprbi ) ADEBAAFGZHIEB
      BJKABOOLCMN $.

    srngf1o.b $e |- B = ( Base ` R ) $.
    $( The involution function in a star ring is a bijection.  (Contributed by
       Mario Carneiro, 6-Oct-2015.) $)
    srngf1o $p |- ( R e. *Ring -> .* : B -1-1-onto-> B ) $=
      ( csr wcel wfn ccnv wf1o coppr cfv crh co cbs wf eqid srngrhm rhmf ffn
      3syl srngcnv fneq1d mpbid dff1o4 sylanbrc ) BFGZCAHZCIZAHZAACJUGCBBKLZMNG
      AUKOLZCPUHBCUKUKQDRAULBUKCEULQSAULCTUAZUGUHUJUMUGACUIBCDUBUCUDAACUEUF $.
  $}

  ${
    srngcl.i $e |- .* = ( *r ` R ) $.
    srngcl.b $e |- B = ( Base ` R ) $.
    $( The involution function in a star ring is closed in the ring.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    srngcl $p |- ( ( R e. *Ring /\ X e. B ) -> ( .* ` X ) e. B ) $=
      ( csr wcel wa cstf cfv wceq eqid stafval adantl wf1o wf srngf1o f1of syl
      ffvelrnda eqeltrrd ) BGHZDAHZIDBJKZKZDCKZAUDUFUGLUCDABUECFEUEMZNOUCAADUEU
      CAAUEPAAUEQABUEUHFRAAUESTUAUB $.

    $( The involution function in a star ring is an involution.  (Contributed
       by Mario Carneiro, 6-Oct-2015.) $)
    srngnvl $p |- ( ( R e. *Ring /\ X e. B ) -> ( .* ` ( .* ` X ) ) = X ) $=
      ( csr wcel wa cfv cstf wceq srngcl eqid stafval syl srngcnv adantr fveq1d
      ccnv adantl fveq2d wf1o srngf1o f1ocnvfv1 sylan 3eqtr3d eqtr3d ) BGHZDAHZ
      IZDCJZBKJZJZULCJZDUKULAHUNUOLABCDEFMULABUMCFEUMNZOPUKDUMJZUMJUQUMTZJZUNDU
      KUQUMURUIUMURLUJBUMUPQRSUKUQULUMUJUQULLUIDABUMCFEUPOUAUBUIAAUMUCUJUSDLABU
      MUPFUDAADUMUEUFUGUH $.

    ${
      srngadd.p $e |- .+ = ( +g ` R ) $.
      $( The involution function in a star ring distributes over addition.
         (Contributed by Mario Carneiro, 6-Oct-2015.) $)
      srngadd $p |- ( ( R e. *Ring /\ X e. B /\ Y e. B ) ->
        ( .* ` ( X .+ Y ) ) = ( ( .* ` X ) .+ ( .* ` Y ) ) ) $=
        ( csr wcel w3a co cstf cfv wceq eqid syl syl3an1 stafval coppr cghm crh
        srngrhm rhmghm oppradd ghmlin srngrng 3ad2ant2 3ad2ant3 oveq12d 3eqtr3d
        crg rngacl ) CJKZEAKZFAKZLZEFBMZCNOZOZEUTOZFUTOZBMZUSDOZEDOZFDOZBMUOUTC
        CUAOZUBMKZUPUQVAVDPUOUTCVHUCMKVICUTVHVHQZUTQZUDCVHUTUERBBCVHEUTFAHIBCVH
        VJIUFUGSURUSAKZVAVEPUOCUMKUPUQVLCUHABCEFHIUNSUSACUTDHGVKTRURVBVFVCVGBUP
        UOVBVFPUQEACUTDHGVKTUIUQUOVCVGPUPFACUTDHGVKTUJUKUL $.
    $}

    srngmul.t $e |- .x. = ( .r ` R ) $.
    $( The involution function in a star ring distributes over multiplication,
       with a change in the order of the factors.  (Contributed by Mario
       Carneiro, 6-Oct-2015.) $)
    srngmul $p |- ( ( R e. *Ring /\ X e. B /\ Y e. B ) ->
      ( .* ` ( X .x. Y ) ) = ( ( .* ` Y ) .x. ( .* ` X ) ) ) $=
      ( csr wcel w3a co cstf cfv coppr wceq eqid syl3an1 stafval srngrhm rhmmul
      cmulr crh opprmul crg srngrng rngcl syl 3ad2ant3 3ad2ant2 oveq12d 3eqtr3d
      syl6eq ) BJKZEAKZFAKZLZEFCMZBNOZOZFUTOZEUTOZCMZUSDOZFDOZEDOZCMURVAVCVBBPO
      ZUCOZMZVDUOUTBVHUDMKUPUQVAVJQBUTVHVHRZUTRZUAEFBVHCVIUTAHIVIRZUBSABVICVHVC
      VBHIVKVMUEUNURUSAKZVAVEQUOBUFKUPUQVNBUGABCEFHIUHSUSABUTDHGVLTUIURVBVFVCVG
      CUQUOVBVFQUPFABUTDHGVLTUJUPUOVCVGQUQEABUTDHGVLTUKULUM $.
  $}

  ${
    srng1.i $e |- .* = ( *r ` R ) $.
    srng1.t $e |- .1. = ( 1r ` R ) $.
    $( The conjugate of the ring identity is the identity.  (This is sometimes
       taken as an axiom, and indeed the proof here follows because we defined
       ` *r ` to be a ring homomorphism, which preserves 1; nevertheless, it is
       redundant, as can be seen from the proof of ~ issrngd .)  (Contributed
       by Mario Carneiro, 6-Oct-2015.) $)
    srng1 $p |- ( R e. *Ring -> ( .* ` .1. ) = .1. ) $=
      ( csr wcel cstf cfv crg cbs wceq srngrng eqid rngidcl stafval 3syl crh co
      coppr srngrhm oppr1 rhm1 syl eqtr3d ) AFGZBAHIZIZBCIZBUFAJGBAKIZGUHUILAMU
      JABUJNZEOBUJAUGCUKDUGNZPQUFUGAATIZRSGUHBLAUGUMUMNZULUAAUMBUGBEABUMUNEUBUC
      UDUE $.
  $}

  ${
    srng0.i $e |- .* = ( *r ` R ) $.
    srng0.z $e |- .0. = ( 0g ` R ) $.
    $( The conjugate of the ring zero is zero.  (Contributed by Mario Carneiro,
       7-Oct-2015.) $)
    srng0 $p |- ( R e. *Ring -> ( .* ` .0. ) = .0. ) $=
      ( csr wcel cstf cfv crg cgrp cbs wceq srngrng rnggrp eqid grpidcl stafval
      4syl co coppr crh cghm srngrhm rhmghm oppr0 ghmid 3syl eqtr3d ) AFGZCAHIZ
      IZCBIZCUJAJGAKGCALIZGULUMMANAOUNACUNPZEQCUNAUKBUODUKPZRSUJUKAAUAIZUBTGUKA
      UQUCTGULCMAUKUQUQPZUPUDAUQUKUEAUQUKCCEAUQCUREUFUGUHUI $.
  $}

  ${
    $d x y K $.  $d x y R $.  $d x y ph $.
    $( Ring base $)
    issrngd.k $e |- ( ph -> K = ( Base ` R ) ) $.
    $( Ring plus $)
    issrngd.p $e |- ( ph -> .+ = ( +g ` R ) ) $.
    $( Ring times $)
    issrngd.t $e |- ( ph -> .x. = ( .r ` R ) ) $.
    $( Involution (e.g. complex conjugate) $)
    issrngd.c $e |- ( ph -> .* = ( *r ` R ) ) $.
    issrngd.r $e |- ( ph -> R e. Ring ) $.
    $( Closure $)
    issrngd.cl $e |- ( ( ph /\ x e. K ) -> ( .* ` x ) e. K ) $.
    $( Distributive law over addition $)
    issrngd.dp $e |- ( ( ph /\ x e. K /\ y e. K )
           -> ( .* ` ( x .+ y ) ) = ( ( .* ` x ) .+ ( .* ` y ) ) ) $.
    $( Distributive law over multiplication $)
    issrngd.dt $e |- ( ( ph /\ x e. K /\ y e. K )
           -> ( .* ` ( x .x. y ) ) = ( ( .* ` y ) .x. ( .* ` x ) ) ) $.
    $( Idempotency $)
    issrngd.id $e |- ( ( ph /\ x e. K ) -> ( .* ` ( .* ` x ) ) = x ) $.
    $( Properties that determine a star ring.  (Contributed by Mario Carneiro,
       18-Nov-2013.)  (Revised by Mario Carneiro, 6-Oct-2015.) $)
    issrngd $p |- ( ph -> R e. *Ring ) $=
      ( cfv co wceq cstf coppr crh wcel ccnv csr cbs cplusg cmulr cur oppr1 crg
      eqid opprrng syl cstv cv wral rngidcl wa ex eleq2d fveq1d fveq12d 3imtr3d
      eqeq1d eqcomd ralrimiva id fveq2 fveq2d eqeq12d rspcv sylc oveq1d eleq12d
      imp ralrimiv eleq1d 3expib anbi12d oveqd oveq123d ralrimivv oveq1 rspc2va
      oveq2d oveq2 eqtr4d rnglidm syl2anc 3eqtr3d stafval 3eqtr4d opprmul rngcl
      syl21anc syl6eqr 3expb sylan adantl opprbas oppradd staffval fmptd rngacl
      oveqan12d isrhmd cmpt wf1o wf fmpt sylibr r19.21bi rspccva adantrl eqeq2d
      syl5ibrcom adantrr impbid f1ocnv2d simprd syl6reqr issrng sylanbrc ) AEUA
      RZEEUBRZUCSUDYFYFUEZTEUFUDABCEUGRZYIEUHRZYJEYGEUIRZYGUIRZEUJRZYFYMYIUMZYM
      UMZEYMYGYGUMZYOUKYKUMZYLUMZMAEULUDZYGULUDMEYGYPUNUOAYMEUPRZRZUUAYTRZYMYFR
      ZYMAYMUUAYKSZUUDYTRZUUAUUBAUUDUUBUUAYKSZUUEAYMUUBUUAYKAYMYIUDZBUQZUUHYTRZ
      YTRZTZBYIURZYMUUBTZAYSUUGMYIEYMYNYOUSUOZAUUKBYIAUUHYIUDZUTUUJUUHAUUOUUJUU
      HTZAUUHHUDZUUHGRZGRZUUHTZUUOUUPAUUQUUTQVAAHYIUUHIVBZAUUSUUJUUHAUURUUIGYTL
      AUUHGYTLVCZVDVFVEVQVGZVHZUUKUUMBYMYIUUHYMTZUUHYMUUJUUBUVEVIUVEUUIUUAYTUUH
      YMYTVJZVKVLVMVNZVOAUUGUUAYIUDZUUHCUQZYKSZYTRZUVIYTRZUUIYKSZTZCYIURBYIURUU
      EUUFTZUUNAUUGUUIYIUDZBYIURUVHUUNAUVPBYIAUUQUURHUDZUUOUVPAUUQUVQNVAUVAAUUR
      UUIHYIUVBIVPVEZVRUVPUVHBYMYIUVEUUIUUAYIUVFVSVMVNZAUVNBCYIYIAUUQUVIHUDZUTZ
      UUHUVIFSZGRZUVIGRZUURFSZTZUUOUVIYIUDZUTZUVNAUUQUVTUWFPVTAUUQUUOUVTUWGUVAA
      HYIUVIIVBWAZAUWCUVKUWEUVMAUWBUVJGYTLAFYKUUHUVIKWBVDAUWDUVLUURUUIFYKKAUVIG
      YTLVCZUVBWCVLVEZWDUVNUVOYMUVIYKSZYTRZUVLUUAYKSZTBCYMUUAYIYIUVEUVKUWMUVMUW
      NUVEUVJUWLYTUUHYMUVIYKWEVKUVEUUIUUAUVLYKUVFWGVLUVIUUATZUWMUUEUWNUUFUWOUWL
      UUDYTUVIUUAYMYKWHVKUWOUVLUUBUUAYKUVIUUAYTVJVOVLWFWQWIAYSUVHUUDUUATMUVSYIE
      YKYMUUAYNYQYOWJWKZAUUDUUAYTUWPVKWLAUUGUUCUUATUUNYMYIEYFYTYNYTUMZYFUMZWMUO
      UVGWNAUWHUTZUVKUUIUVLYLSZUVJYFRZUUHYFRZUVIYFRZYLSZUWSUVKUVMUWTAUWHUVNUWKV
      QYIEYLYKYGUUIUVLYNYQYPYRWOWRUWSUVJYIUDZUXAUVKTAYSUWHUXEMYSUUOUWGUXEYIEYKU
      UHUVIYNYQWPWSWTUVJYIEYFYTYNUWQUWRWMUOUWHUXDUWTTAUUOUWGUXBUUIUXCUVLYLUUHYI
      EYFYTYNUWQUWRWMZUVIYIEYFYTYNUWQUWRWMZXGXAWNYIEYGYPYNXBYJUMZYJEYGYPUXHXCAB
      YIUUIYIYFAUUOUVPUVRVQZBYIEYFYTYNUWQUWRXDZXEZUWSUUHUVIYJSZYTRZUUIUVLYJSZUX
      LYFRZUXBUXCYJSZAUWHUXMUXNTZAUWAUUHUVIDSZGRZUURUWDDSZTZUWHUXQAUUQUVTUYAOVT
      UWIAUXSUXMUXTUXNAUXRUXLGYTLADYJUUHUVIJWBVDAUURUUIUWDUVLDYJJUVBUWJWCVLVEVQ
      UWSUXLYIUDZUXOUXMTAYSUWHUYBMYSUUOUWGUYBYIYJEUUHUVIYNUXHXFWSWTUXLYIEYFYTYN
      UWQUWRWMUOUWHUXPUXNTAUUOUWGUXBUUIUXCUVLYJUXFUXGXGXAWNXHAYHCYIUVLXIZYFAYIY
      IYFXJYHUYCTABCYIYIUUIUVLYFUXJUXIAUVLYIUDZCYIAYIYIYFXKUYDCYIURUXKCYIYIUVLY
      FCYIEYFYTYNUWQUWRXDZXLXMXNUWSUUHUVLTZUVIUUITZUWSUYGUYFUVIUVLYTRZTZAUWGUYI
      UUOAUULUWGUYIUVDUUKUYIBUVIYIUUHUVITZUUHUVIUUJUYHUYJVIUYJUUIUVLYTUUHUVIYTV
      JVKVLXOWTXPUYFUUIUYHUVIUUHUVLYTVJXQXRUWSUYFUYGUUKAUUOUUKUWGUVCXSUYGUVLUUJ
      UUHUVIUUIYTVJXQXRXTYAYBUYEYCEYFYGYPUWRYDYE $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Left modules
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LMod $.
  $c .sf $.

  $( Extend class notation with class of all left modules. $)
  clmod $a class LMod $.

  $( The functionalization of the scalar multiplication operation. $)
  cscaf $a class .sf $.

  ${
    $d a f g k p q r s t v w x y $.
    $( Define the class of all left modules, which are generalizations of left
       vector spaces.  A left module over a ring is an (Abelian) group
       (vectors) together with a ring (scalars) and a left scalar product
       connecting them.  (Contributed by NM, 4-Nov-2013.) $)
    df-lmod $a |- LMod = { g e. Grp | [. ( Base ` g ) / v ].
      [. ( +g ` g ) / a ]. [. ( Scalar ` g ) / f ]. [. ( .s ` g ) / s ].
      [. ( Base ` f ) / k ]. [. ( +g ` f ) / p ]. [. ( .r ` f ) / t ].
      ( f e. Ring /\ A. q e. k A. r e. k A. x e. v A. w e. v
                ( ( ( r s w ) e. v
                 /\ ( r s ( w a x ) ) = ( ( r s w ) a ( r s x ) )
                 /\ ( ( q p r ) s w ) = ( ( q s w ) a ( r s w ) )
               ) /\ ( ( ( q t r ) s w ) = ( q s ( r s w ) )
                 /\ ( ( 1r ` f ) s w ) = w ) ) ) } $.

    $( Define the functionalization of the ` .s ` operator.  This restricts the
       value of ` .s ` to the stated domain, which is necessary when working
       with restricted structures, whose operations may be defined on a larger
       set than the true base.  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    df-scaf $a |- .sf = ( g e. _V |-> ( x e. ( Base ` ( Scalar ` g ) ) ,
      y e. ( Base ` g ) |-> ( x ( .s ` g ) y ) ) ) $.
  $}

  ${
    $d a f g k p q r s v w x F $.  $d a f g k p q r s v w x K $.  $d r w x R $.
    $d a f g k p q r s v w x .+^ $.  $d a f g k p q r s v w x V $.  $d w x X $.
    $d a f g k p q r s v w x .+ $.  $d q r w x Q $.  $d a f g v W $.  $d w Y $.
    $d a f g k p q r s v w x .1. $.  $d a f g k p q r s t v w x .X. $.
    $d a f g k p q r s v w x .x. $.
    islmod.v $e |- V = ( Base ` W ) $.
    islmod.a $e |- .+ = ( +g ` W ) $.
    islmod.s $e |- .x. = ( .s ` W ) $.
    islmod.f $e |- F = ( Scalar ` W ) $.
    islmod.k $e |- K = ( Base ` F ) $.
    islmod.p $e |- .+^ = ( +g ` F ) $.
    islmod.t $e |- .X. = ( .r ` F ) $.
    islmod.u $e |- .1. = ( 1r ` F ) $.
    $( The predicate "is a left module".  (Contributed by NM, 4-Nov-2013.)
       (Revised by Mario Carneiro, 19-Jun-2014.) $)
    islmod $p |- ( W e. LMod <->
      ( W e. Grp /\ F e. Ring /\ A. q e. K A. r e. K A. x e. V A. w e. V
                ( ( ( r .x. w ) e. V
                 /\ ( r .x. ( w .+ x ) ) = ( ( r .x. w ) .+ ( r .x. x ) )
                 /\ ( ( q .+^ r ) .x. w ) = ( ( q .x. w ) .+ ( r .x. w ) )
               ) /\ ( ( ( q .X. r ) .x. w ) = ( q .x. ( r .x. w ) )
                 /\ ( .1. .x. w ) = w ) ) ) ) $=
      ( vf vs vv va vp vt vk vg clmod wcel cgrp crg cv co wceq w3a wral cur cfv
      wa cmulr wsbc cplusg cbs cvsca csca wb fveq2 syl6eqr dfsbcq sbcbidv bitrd
      syl cvv fvex simp3 fveq2d oveq oveq1d eqeq1d anbi1d anbi2d 2ralbidv sbcie
      eqeltri eleq1d simp1 eleq2d simp2 oveq2d eqeq12d eqeq2d 3anbi123d anbi12d
      oveqd raleqbidv syl5bb sbc3ie oveq12d syl6bb df-lmod elrab2 3anass bitr4i
      eqtrd bitri ) KUJUKKULUKZHUMUKZLUNZBUNZEUOZJUKZXJXKAUNZCUOZEUOZXLXJXNEUOZ
      CUOZUPZMUNZXJDUOZXKEUOZXTXKEUOZXLCUOZUPZUQZXTXJFUOZXKEUOZXTXLEUOZUPZGXKEU
      OZXKUPZVAZVAZBJURAJURZLIURZMIURZVAZVAXHXIYQUQUBUNZUMUKZXJXKUCUNZUOZUDUNZU
      KZXJXKXNUEUNZUOZUUAUOZUUBXJXNUUAUOZUUEUOZUPZXTXJUFUNZUOZXKUUAUOZXTXKUUAUO
      ZUUBUUEUOZUPZUQZXTXJUGUNZUOZXKUUAUOZXTUUBUUAUOZUPZYSUSUTZXKUUAUOZXKUPZVAZ
      VAZBUUCURAUUCURZLUHUNZURMUVIURZVAZUGYSVBUTZVCZUFYSVDUTZVCZUHYSVEUTZVCZUCU
      IUNZVFUTZVCZUBUVRVGUTZVCZUEUVRVDUTZVCZUDUVRVEUTZVCZYRUIKULUJUVRKUPZUWFUVQ
      UCEVCZUBHVCZUECVCZUDJVCZYRUWGUWFUWDUDJVCZUWKUWGUWEJUPUWFUWLVHUWGUWEKVEUTZ
      JUVRKVEVINVJUWDUDUWEJVKVNUWGUWDUWJUDJUWGUWDUWBUECVCZUWJUWGUWCCUPUWDUWNVHU
      WGUWCKVDUTZCUVRKVDVIOVJUWBUEUWCCVKVNUWGUWBUWIUECUWGUWBUVTUBHVCZUWIUWGUWAH
      UPUWBUWPVHUWGUWAKVGUTZHUVRKVGVIQVJUVTUBUWAHVKVNUWGUVTUWHUBHUWGUVSEUPUVTUW
      HVHUWGUVSKVFUTZEUVRKVFVIPVJUVQUCUVSEVKVNVLVMVLVMVLVMUWKXIUUBJUKZXJXOUUAUO
      ZUUBUUHCUOZUPZUUMUUNUUBCUOZUPZUQZYGXKUUAUOZUVAUPZGXKUUAUOZXKUPZVAZVAZBJUR
      ZAJURZLUVIURZMUVIURZVAZUFDVCZUHIVCZUCEVCZYRUWHUXSUDUEUBJCHJUWMVONKVEVPWFC
      UWOVOOKVDVPWFHUWQVOQKVGVPWFUUCJUPZUUECUPZYSHUPZUQZUVQUXRUCEUYCUVQUVOUHIVC
      ZUXRUYCUVPIUPUVQUYDVHUYCUVPHVEUTZIUYCYSHVEUXTUYAUYBVQZVRRVJUVOUHUVPIVKVNU
      YCUVOUXQUHIUYCUVOUVMUFDVCZUXQUYCUVNDUPUVOUYGVHUYCUVNHVDUTZDUYCYSHVDUYFVRS
      VJUVMUFUVNDVKVNUYCUVMUXPUFDUYCUVMUVKUGFVCZUXPUYCUVLFUPUVMUYIVHUYCUVLHVBUT
      ZFUYCYSHVBUYFVRTVJUVKUGUVLFVKVNUYIYTUUQUXGUVEVAZVAZBUUCURZAUUCURZLUVIURMU
      VIURZVAZUYCUXPUVKUYPUGFFUYJVOTHVBVPWFUURFUPZUVJUYOYTUYQUVHUYNMLUVIUVIUYQU
      VGUYLABUUCUUCUYQUVFUYKUUQUYQUVBUXGUVEUYQUUTUXFUVAUYQUUSYGXKUUAXTXJUURFVSV
      TWAWBWCWDWDWCWEUYCYTXIUYOUXOUYCYSHUMUYFWGUYCUYNUXMMLUVIUVIUYCUYMUXLAUUCJU
      XTUYAUYBWHZUYCUYLUXKBUUCJUYRUYCUUQUXEUYKUXJUYCUUDUWSUUJUXBUUPUXDUYCUUCJUU
      BUYRWIUYCUUGUWTUUIUXAUYCUUFXOXJUUAUYCUUECXKXNUXTUYAUYBWJZWPWKUYCUUECUUBUU
      HUYSWPWLUYCUUOUXCUUMUYCUUECUUNUUBUYSWPWMWNUYCUVEUXIUXGUYCUVDUXHXKUYCUVCGX
      KUUAUYCUVCHUSUTGUYCYSHUSUYFVRUAVJVTWAWCWOWQWQWDWOWRVMVLVMVLVMVLWSUXPYRUCU
      HUFEIDEUWRVOPKVFVPWFIUYEVORHVEVPWFDUYHVOSHVDVPWFUUAEUPZUVIIUPZUUKDUPZUQZU
      XOYQXIVUCUXNYPMUVIIUYTVUAVUBWJZVUCUXMYOLUVIIVUDVUCUXKYNABJJVUCUXEYFUXJYMV
      UCUWSXMUXBXSUXDYEVUCUUBXLJVUCUUAEXJXKUYTVUAVUBWHZWPZWGVUCUWTXPUXAXRVUCUUA
      EXJXOVUEWPVUCUUBXLUUHXQCVUFVUCUUAEXJXNVUEWPWTWLVUCUUMYBUXCYDVUCUUMYAXKUUA
      UOYBVUCUULYAXKUUAVUCUUKDXTXJUYTVUAVUBVQWPVTVUCUUAEYAXKVUEWPXFVUCUUNYCUUBX
      LCVUCUUAEXTXKVUEWPVUFWTWLWNVUCUXGYJUXIYLVUCUXFYHUVAYIVUCUUAEYGXKVUEWPVUCU
      VAXTXLUUAUOYIVUCUUBXLXTUUAVUFWKVUCUUAEXTXLVUEWPXFWLVUCUXHYKXKVUCUUAEGXKVU
      EWPWAWOWOWDWQWQWCWSXGXAABUDUGUBUIUHUCLMUFUEXBXCXHXIYQXDXE $.

    $( Lemma for properties of a left module.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodlema $p |- ( ( W e. LMod /\ ( Q e. K /\ R e. K )
          /\ ( X e. V /\ Y e. V ) ) ->
                ( ( ( R .x. Y ) e. V
                 /\ ( R .x. ( Y .+ X ) ) = ( ( R .x. Y ) .+ ( R .x. X ) )
                 /\ ( ( Q .+^ R ) .x. Y ) = ( ( Q .x. Y ) .+ ( R .x. Y ) )
               ) /\ ( ( ( Q .X. R ) .x. Y ) = ( Q .x. ( R .x. Y ) )
                 /\ ( .1. .x. Y ) = Y ) ) ) $=
      ( vw vx vr vq clmod wcel wa co wceq w3a cv wral cgrp islmod simp3bi oveq1
      crg oveq1d eqeq12d 3anbi3d anbi1d anbi12d 2ralbidv eleq1d oveq2 3anbi123d
      oveq12d oveq2d rspc2v mpan9 3anbi2d id syl5com 3impia ) KUFUGZCIUGDIUGUHZ
      LJUGMJUGUHZDMEUIZJUGZDMLAUIZEUIZVSDLEUIZAUIZUJZCDBUIZMEUIZCMEUIZVSAUIZUJZ
      UKZCDFUIZMEUIZCVSEUIZUJZGMEUIZMUJZUHZUHZVPVQUHDUBULZEUIZJUGZDWTUCULZAUIZE
      UIZXADXCEUIZAUIZUJZWFWTEUIZCWTEUIZXAAUIZUJZUKZWLWTEUIZCXAEUIZUJZGWTEUIZWT
      UJZUHZUHZUBJUMUCJUMZVRWSVPUDULZWTEUIZJUGZYBXDEUIZYCYBXCEUIZAUIZUJZUEULZYB
      BUIZWTEUIZYIWTEUIZYCAUIZUJZUKZYIYBFUIZWTEUIZYIYCEUIZUJZXRUHZUHZUBJUMUCJUM
      ZUDIUMUEIUMZVQYAVPKUNUGHURUGUUCUCUBABEFGHIJKUDUENOPQRSTUAUOUPUUBYAYDYHCYB
      BUIZWTEUIZXJYCAUIZUJZUKZCYBFUIZWTEUIZCYCEUIZUJZXRUHZUHZUBJUMUCJUMUEUDCDII
      YICUJZUUAUUNUCUBJJUUOYOUUHYTUUMUUOYNUUGYDYHUUOYKUUEYMUUFUUOYJUUDWTEYICYBB
      UQUSUUOYLXJYCAYICWTEUQUSUTVAUUOYSUULXRUUOYQUUJYRUUKUUOYPUUIWTEYICYBFUQUSY
      ICYCEUQUTVBVCVDYBDUJZUUNXTUCUBJJUUPUUHXMUUMXSUUPYDXBYHXHUUGXLUUPYCXAJYBDW
      TEUQZVEUUPYEXEYGXGYBDXDEUQUUPYCXAYFXFAUUQYBDXCEUQVHUTUUPUUEXIUUFXKUUPUUDW
      FWTEYBDCBVFUSUUPYCXAXJAUUQVIUTVGUUPUULXPXRUUPUUJXNUUKXOUUPUUIWLWTEYBDCFVF
      USUUPYCXACEUUQVIUTVBVCVDVJVKXTWSXBDWTLAUIZEUIZXAWCAUIZUJZXLUKZXSUHUCUBLMJ
      JXCLUJZXMUVBXSUVCXHUVAXBXLUVCXEUUSXGUUTUVCXDUURDEXCLWTAVFVIUVCXFWCXAAXCLD
      EVFVIUTVLVBWTMUJZUVBWKXSWRUVDXBVTUVAWEXLWJUVDXAVSJWTMDEVFZVEUVDUUSWBUUTWD
      UVDUURWADEWTMLAUQVIUVDXAVSWCAUVEUSUTUVDXIWGXKWIWTMWFEVFUVDXJWHXAVSAWTMCEV
      FUVEVHUTVGUVDXPWOXRWQUVDXNWMXOWNWTMWLEVFUVDXAVSCEUVEVIUTUVDXQWPWTMWTMGEVF
      UVDVMUTVCVCVJVNVO $.
  $}

  ${
    $d y z .+^ $.  $d r u w x y z B $.  $d r u w x y z ph $.  $d u w x y z V $.
    $d x y z .+ $.  $d r u w x W $.  $d x y z .x. $.  $d y z .X. $.
    $d x .1. $.
    islmodd.v $e |- ( ph -> V = ( Base ` W ) ) $.
    islmodd.a $e |- ( ph -> .+ = ( +g ` W ) ) $.
    islmodd.f $e |- ( ph -> F = ( Scalar ` W ) ) $.
    islmodd.s $e |- ( ph -> .x. = ( .s ` W ) ) $.
    islmodd.b $e |- ( ph -> B = ( Base ` F ) ) $.
    islmodd.p $e |- ( ph -> .+^ = ( +g ` F ) ) $.
    islmodd.t $e |- ( ph -> .X. = ( .r ` F ) ) $.
    islmodd.u $e |- ( ph -> .1. = ( 1r ` F ) ) $.
    islmodd.r $e |- ( ph -> F e. Ring ) $.
    $( Group operations $)
    islmodd.l $e |- ( ph -> W e. Grp ) $.
    $( Scalar product operation $)
    islmodd.w $e |- ( ( ph /\ x e. B /\ y e. V ) -> ( x .x. y ) e. V ) $.
    islmodd.c $e |- ( ( ph /\ ( x e. B /\ y e. V /\ z e. V ) )
        -> ( x .x. ( y .+ z ) ) = ( ( x .x. y ) .+ ( x .x. z ) ) ) $.
    islmodd.d $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. V ) )
        -> ( ( x .+^ y ) .x. z ) = ( ( x .x. z ) .+ ( y .x. z ) ) ) $.
    islmodd.e $e |- ( ( ph /\ ( x e. B /\ y e. B /\ z e. V ) )
        -> ( ( x .X. y ) .x. z ) = ( x .x. ( y .x. z ) ) ) $.
    islmodd.g $e |- ( ( ph /\ x e. V ) -> ( .1. .x. x ) = x ) $.
    $( Properties that determine a left module.  See note in ~ isgrpd2
       regarding the ` ph ` on hypotheses that name structure components.
       (Contributed by Mario Carneiro, 22-Jun-2014.) $)
    islmodd $p |- ( ph -> W e. LMod ) $=
      ( vr vw vu cgrp wcel csca cfv crg cv cvsca co cbs cplusg w3a cmulr cur wa
      wceq wral clmod eqeltrrd 3expb ralrimivva weq oveq1 eleq1d oveq2 ad2ant2l
      wi rspc2v ralrimivvva oveq12d eqeq12d oveq2d oveq1d rspc3v 3com23 adantll
      mpan9 simpll 3exp2 imp43 sylan2 simprlr simprrr syl2anc 3jca ralrimiva id
      rspcv ad2antll jca32 anassrs eqtrd oveqd eleq12d eqidd oveq123d 3anbi123d
      mpd fveq2d eqeq1d anbi12d raleqbidv mpbid eqid islmod syl3anbrc ) AMULUMM
      UNUOZUPUMUIUQZUJUQZMURUOZUSZMUTUOZUMZXRXSUKUQZMVAUOZUSZXTUSZYAXRYDXTUSZYE
      USZVFZBUQZXRXQVAUOZUSZXSXTUSZYKXSXTUSZYAYEUSZVFZVBZYKXRXQVCUOZUSZXSXTUSZY
      KYAXTUSZVFZXQVDUOZXSXTUSZXSVFZVEZVEZUJYBVGZUKYBVGZUIXQUTUOZVGZBUUKVGZMVHU
      MUCAKXQUPPUBVIAXRXSHUSZLUMZXRXSYDFUSZHUSZUUNXRYDHUSZFUSZVFZYKXRGUSZXSHUSZ
      YKXSHUSZUUNFUSZVFZVBZYKXRIUSZXSHUSZYKUUNHUSZVFZJXSHUSZXSVFZVEZVEZUJLVGZUK
      LVGZUIEVGZBEVGUUMAUVPBUIEEAYKEUMZXREUMZVEZVEUVNUKUJLLAUVTYDLUMZXSLUMZVEZU
      VNAUVTUWCVEZVEZUVFUVJUVLUWEUUOUUTUVEAYKCUQZHUSZLUMZCLVGBEVGZUWDUUOAUWHBCE
      LAUVRUWFLUMUWHUDVJVKUVSUWBUWIUUOVQUVRUWAUWHUUOXRUWFHUSZLUMBCXRXSELBUIVLZU
      WGUWJLYKXRUWFHVMZVNCUJVLZUWJUUNLUWFXSXRHVOZVNVRVPWGAYKUWFDUQZFUSZHUSZUWGY
      KUWOHUSZFUSZVFZDLVGCLVGBEVGZUWDUUTAUWTBCDELLUEVSUVSUWCUXAUUTVQZUVRUVSUWAU
      WBUXBUVSUWBUWAUXBUWTUUTXRUWPHUSZUWJXRUWOHUSZFUSZVFXRXSUWOFUSZHUSZUUNUXDFU
      SZVFBCDXRXSYDELLUWKUWQUXCUWSUXEYKXRUWPHVMUWKUWGUWJUWRUXDFUWLYKXRUWOHVMVTW
      AUWMUXCUXGUXEUXHUWMUWPUXFXRHUWFXSUWOFVMWBUWMUWJUUNUXDFUWNWCWADUKVLZUXGUUQ
      UXHUUSUXIUXFUUPXRHUWOYDXSFVOWBUXIUXDUURUUNFUWOYDXRHVOWBWAWDWEVJWFWGUWEYKU
      WFGUSZUWOHUSZUWRUWFUWOHUSZFUSZVFZDLVGCEVGZUVEUWDAUVRUXOUVRUVSUWCWHZAUVRVE
      ZUXNCDELAUVRUWFEUMZUWOLUMZUXNAUVRUXRUXSUXNUFWIWJVKWKUWEUVSUWBUXOUVEVQAUVR
      UVSUWCWLZAUVTUWAUWBWMZUXNUVEUVAUWOHUSZUWRUXDFUSZVFCDXRXSELCUIVLZUXKUYBUXM
      UYCUYDUXJUVAUWOHUWFXRYKGVOWCUYDUXLUXDUWRFUWFXRUWOHVMZWBWADUJVLZUYBUVBUYCU
      VDUWOXSUVAHVOUYFUWRUVCUXDUUNFUWOXSYKHVOUWOXSXRHVOZVTWAVRWNXHWOUWEYKUWFIUS
      ZUWOHUSZYKUXLHUSZVFZDLVGCEVGZUVJUWDAUVRUYLUXPUXQUYKCDELAUVRUXRUXSUYKAUVRU
      XRUXSUYKUGWIWJVKWKUWEUVSUWBUYLUVJVQUXTUYAUYKUVJUVGUWOHUSZYKUXDHUSZVFCDXRX
      SELUYDUYIUYMUYJUYNUYDUYHUVGUWOHUWFXRYKIVOWCUYDUXLUXDYKHUYEWBWAUYFUYMUVHUY
      NUVIUWOXSUVGHVOUYFUXDUUNYKHUYGWBWAVRWNXHAJYKHUSZYKVFZBLVGZUWDUVLAUYPBLUHW
      PUWBUYQUVLVQUVTUWAUYPUVLBXSLBUJVLZUYOUVKYKXSYKXSJHVOUYRWQWAWRWSWGWTXAVKVK
      AUVQUULBEUUKAEKUTUOUUKRAKXQUTPXIXBZAUVPUUJUIEUUKUYSAUVOUUIUKLYBNAUVNUUHUJ
      LYBNAUVFYRUVMUUGAUUOYCUUTYJUVEYQAUUNYALYBAHXTXRXSQXCZNXDAUUQYGUUSYIAXRXRU
      UPYFHXTQAXRXEAFYEXSYDOXCXFAUUNYAUURYHFYEOUYTAHXTXRYDQXCXFWAAUVBYNUVDYPAUV
      AYMXSXSHXTQAGYLYKXRAGKVAUOYLSAKXQVAPXIXBXCAXSXEZXFAUVCYOUUNYAFYEOAHXTYKXS
      QXCUYTXFWAXGAUVJUUCUVLUUFAUVHUUAUVIUUBAUVGYTXSXSHXTQAIYSYKXRAIKVCUOYSTAKX
      QVCPXIXBXCVUAXFAYKYKUUNYAHXTQAYKXEUYTXFWAAUVKUUEXSAJUUDXSXSHXTQAJKVDUOUUD
      UAAKXQVDPXIXBVUAXFXJXKXKXLXLXLXLXMUKUJYEYLXTYSUUDXQUUKYBMUIBYBXNYEXNXTXNX
      QXNUUKXNYLXNYSXNUUDXNXOXP $.
  $}

  ${
    $d q r w x F $.  $d q r w x W $.
    $( A left module is a group.  (Contributed by NM, 8-Dec-2013.)  (Revised by
       Mario Carneiro, 25-Jun-2014.) $)
    lmodgrp $p |- ( W e. LMod -> W e. Grp ) $=
      ( vr vw vx vq clmod wcel cgrp csca cfv crg cv cvsca co cbs cplusg wceq wa
      wral eqid w3a cmulr cur islmod simp1bi ) AFGAHGAIJZKGBLZCLZAMJZNZAOJZGUGU
      HDLZAPJZNUINUJUGULUINUMNQELZUGUFPJZNUHUINUNUHUINUJUMNQUAUNUGUFUBJZNUHUINU
      NUJUINQUFUCJZUHUINUHQRRCUKSDUKSBUFOJZSEURSDCUMUOUIUPUQUFURUKABEUKTUMTUITU
      FTURTUOTUPTUQTUDUE $.

    lmodrng.1 $e |- F = ( Scalar ` W ) $.
    $( The scalar component of a left module is a ring.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodrng $p |- ( W e. LMod -> F e. Ring ) $=
      ( vr vw vx vq clmod wcel cgrp crg cv cfv co cbs cplusg wceq wa wral eqid
      cvsca w3a cmulr cur islmod simp2bi ) BHIBJIAKIDLZELZBUAMZNZBOMZIUGUHFLZBP
      MZNUINUJUGULUINUMNQGLZUGAPMZNUHUINUNUHUINUJUMNQUBUNUGAUCMZNUHUINUNUJUINQA
      UDMZUHUINUHQRREUKSFUKSDAOMZSGURSFEUMUOUIUPUQAURUKBDGUKTUMTUITCURTUOTUPTUQ
      TUEUF $.

    $( The scalar component of a left module is an additive group.
       (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmodfgrp $p |- ( W e. LMod -> F e. Grp ) $=
      ( clmod wcel crg cgrp lmodrng rnggrp syl ) BDEAFEAGEABCHAIJ $.
  $}

  ${
    lmodbn0.b $e |- B = ( Base ` W ) $.
    $( The base set of a left module is nonempty.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodbn0 $p |- ( W e. LMod -> B =/= (/) ) $=
      ( clmod wcel cgrp c0 wne lmodgrp grpbn0 syl ) BDEBFEAGHBIABCJK $.
  $}

  ${
    lmodacl.f $e |- F = ( Scalar ` W ) $.
    lmodacl.k $e |- K = ( Base ` F ) $.
    lmodacl.p $e |- .+ = ( +g ` F ) $.
    $( Closure of ring addition for a left module.  (Contributed by NM,
       14-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodacl $p |- ( ( W e. LMod /\ X e. K /\ Y e. K ) -> ( X .+ Y ) e. K ) $=
      ( clmod wcel cgrp co lmodfgrp grpcl syl3an1 ) DJKBLKECKFCKEFAMCKBDGNCABEF
      HIOP $.
  $}

  ${
    lmodmcl.f $e |- F = ( Scalar ` W ) $.
    lmodmcl.k $e |- K = ( Base ` F ) $.
    lmodmcl.t $e |- .x. = ( .r ` F ) $.
    $( Closure of ring multiplication for a left module.  (Contributed by NM,
       14-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodmcl $p |- ( ( W e. LMod /\ X e. K /\ Y e. K ) -> ( X .x. Y ) e. K ) $=
      ( clmod wcel crg co lmodrng rngcl syl3an1 ) DJKBLKECKFCKEFAMCKBDGNCBAEFHI
      OP $.
  $}

  ${
    lmodsn0.f $e |- F = ( Scalar ` W ) $.
    lmodsn0.b $e |- B = ( Base ` F ) $.
    $( The set of scalars in a left module is nonempty.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodsn0 $p |- ( W e. LMod -> B =/= (/) ) $=
      ( clmod wcel cgrp c0 wne lmodfgrp grpbn0 syl ) CFGBHGAIJBCDKABELM $.
  $}

  ${
    lmodvacl.v $e |- V = ( Base ` W ) $.
    lmodvacl.a $e |- .+ = ( +g ` W ) $.
    $( Closure of vector addition for a left module.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvacl $p |- ( ( W e. LMod /\ X e. V /\ Y e. V ) -> ( X .+ Y ) e. V ) $=
      ( clmod wcel cgrp co lmodgrp grpcl syl3an1 ) CHICJIDBIEBIDEAKBICLBACDEFGM
      N $.

    $( Left module vector sum is associative.  (Contributed by NM,
       10-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodass $p |- ( ( W e. LMod /\ ( X e. V /\ Y e. V /\ Z e. V ) ) ->
                    ( ( X .+ Y ) .+ Z ) = ( X .+ ( Y .+ Z ) ) ) $=
      ( clmod wcel cgrp w3a co wceq lmodgrp grpass sylan ) CIJCKJDBJEBJFBJLDEAM
      FAMDEFAMAMNCOBACDEFGHPQ $.

    $( Left cancellation law for vector sum.  (Contributed by NM,
       12-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodlcan $p |- ( ( W e. LMod /\ ( X e. V /\ Y e. V /\ Z e. V ) ) ->
                     ( ( Z .+ X ) = ( Z .+ Y ) <-> X = Y ) ) $=
      ( clmod wcel cgrp w3a co wceq wb lmodgrp grplcan sylan ) CIJCKJDBJEBJFBJL
      FDAMFEAMNDENOCPBACDEFGHQR $.
  $}

  ${
    lmodvscl.v $e |- V = ( Base ` W ) $.
    lmodvscl.f $e |- F = ( Scalar ` W ) $.
    lmodvscl.s $e |- .x. = ( .s ` W ) $.
    lmodvscl.k $e |- K = ( Base ` F ) $.
    $( Closure of scalar product for a left module.  ( ~ hvmulcl analog.)
       (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmodvscl $p |- ( ( W e. LMod /\ R e. K /\ X e. V ) -> ( R .x. X ) e. V ) $=
      ( wcel wa co pm4.24 w3a cplusg cfv wceq eqid clmod biid cur simpld simp1d
      cmulr lmodlema syl3anb ) FUALZUIADLZUJUJMZGELZULULMZAGBNZELZUIUBUJOULOUIU
      KUMPZUOAGGFQRZNBNUNUNUQNZSZAACQRZNGBNURSZUPUOUSVAPAACUFRZNGBNAUNBNSCUCRZG
      BNGSMUQUTAABVBVCCDEFGGHUQTJIKUTTVBTVCTUGUDUEUH $.
  $}

  ${
    $d w x y B $.  $d w x y K $.  $d w x y .x. $.  $d w x y W $.  $d x y X $.
    $d x y Y $.
    scaffval.b $e |- B = ( Base ` W ) $.
    scaffval.f $e |- F = ( Scalar ` W ) $.
    scaffval.k $e |- K = ( Base ` F ) $.
    scaffval.a $e |- .xb = ( .sf ` W ) $.
    ${
      scaffval.s $e |- .x. = ( .s ` W ) $.
      $( The scalar multiplication operation as a function.  (Contributed by
         Mario Carneiro, 5-Oct-2015.) $)
      scaffval $p |- .xb = ( x e. K , y e. B |-> ( x .x. y ) ) $=
        ( cfv cvv wcel wceq cbs syl6eqr c0 vw cscaf cv cmpt2 cvsca fveq2 fveq2d
        co csca oveqd mpt2eq123dv df-scaf cxp crn csn cun wf wral df-ov eqeltri
        cop fvrn0 rgen2w eqid fmpt2 mpbi fvex xpex rnex p0ex unex fex2 mp3an wn
        fvmpt fvprc mpt20 syl5eq base0 mpt2eq12 sylancl eqtr4d pm2.61i eqtri )
        DHUBNZABGCAUCZBUCZEUHZUDZLHOPZWEWIQUAHABUAUCZUINZRNZWKRNZWFWGWKUENZUHZU
        DWIOUBWKHQZABWMWNWPGCWHWQWMFRNZGWQWLFRWQWLHUINZFWKHUIUFJSUGKSWQWNHRNZCW
        KHRUFISWQWOEWFWGWQWOHUENZEWKHUEUFMSUJUKABUAULGCUMZEUNZTUOZUPZWIUQZXBOPX
        EOPWIOPWHXEPZBCURAGURXFXGABGCWHWFWGVAZENXEWFWGEUSEXHVBUTVCABGCWHXEWIWIV
        DVEVFGCGWROKFRVGUTCWTOIHRVGUTVHXCXDEEXAOMHUEVGUTVIVJVKXBXEWIOOVLVMVOWJV
        NZWEABTCWHUDZWIXIWETXJHUBVPABCWHVQSXIGTQCCQWIXJQXIGTRNZTXIGWRXKKXIFTRXI
        FWSTJHUIVPVRUGVRVSSCVDABGCTCWHVTWAWBWCWD $.

      $( The scalar multiplication operation as a function.  (Contributed by
         Mario Carneiro, 5-Oct-2015.) $)
      scafval $p |- ( ( X e. K /\ Y e. B ) -> ( X .xb Y ) = ( X .x. Y ) ) $=
        ( vx vy cv co oveq12 scaffval ovex ovmpt2a ) NOGHEANPZOPZCQGHCQBUBGUCHC
        RNOABCDEFIJKLMSGHCTUA $.

      $( If the scalar multiplication operation is already a function, the
         functionalization of it is equal to the original operation.
         (Contributed by Mario Carneiro, 5-Oct-2015.) $)
      scafeq $p |- ( .x. Fn ( K X. B ) -> .xb = .x. ) $=
        ( vx vy cxp wfn cv co cmpt2 wceq fnov biimpi scaffval syl6reqr ) CEANOZ
        CLMEALPMPCQRZBUDCUESLMEACTUALMABCDEFGHIJKUBUC $.
    $}

    $( The scalar multiplication operation is a function.  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    scaffn $p |- .xb Fn ( K X. B ) $=
      ( vx vy cv cvsca cfv co eqid scaffval ovex fnmpt2i ) JKDAJLZKLZEMNZOBJKAB
      UBCDEFGHIUBPQTUAUBRS $.

    $( The scalar multiplication operation is a function.  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    lmodscaf $p |- ( W e. LMod -> .xb : ( K X. B ) --> B ) $=
      ( vx vy clmod wcel cv cvsca cfv co wral cxp wf lmodvscl 3expb fmpt2 sylib
      eqid ralrimivva scaffval ) ELMZJNZKNZEOPZQZAMZKARJDRDASABTUHUMJKDAUHUIDMU
      JAMUMUIUKCDAEUJFGUKUEZHUAUBUFJKDAULABJKABUKCDEFGHIUNUGUCUD $.
  $}

  ${
    lmodvsdi.v $e |- V = ( Base ` W ) $.
    lmodvsdi.a $e |- .+ = ( +g ` W ) $.
    lmodvsdi.f $e |- F = ( Scalar ` W ) $.
    lmodvsdi.s $e |- .x. = ( .s ` W ) $.
    lmodvsdi.k $e |- K = ( Base ` F ) $.
    $( Distributive law for scalar product.  ( ~ ax-hvdistr1 analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.) $)
    lmodvsdi $p |- ( ( W e. LMod /\ ( R e. K /\ X e. V /\ Y e. V ) ) ->
                     ( R .x. ( X .+ Y ) ) = ( ( R .x. X ) .+ ( R .x. Y ) ) ) $=
      ( wcel co wceq wa cfv eqid clmod wi w3a cplusg cur lmodlema simpld simp2d
      cmulr 3expia anabsan2 exp4b com34 3imp2 ) GUAOZBEOZHFOZIFOZBHIAPCPBHCPZBI
      CPAPQZUOUPURUQUTUOUPURUQUTUOUPURUQRZUTUBUOUPUPRZVAUTUOVBVAUCZUSFOZUTBBDUD
      SZPHCPUSUSAPQZVCVDUTVFUCBBDUISZPHCPBUSCPQDUESZHCPHQRAVEBBCVGVHDEFGIHJKMLN
      VETVGTVHTUFUGUHUJUKULUMUN $.
  $}

  ${
    lmodvsdir.v $e |- V = ( Base ` W ) $.
    lmodvsdir.a $e |- .+ = ( +g ` W ) $.
    lmodvsdir.f $e |- F = ( Scalar ` W ) $.
    lmodvsdir.s $e |- .x. = ( .s ` W ) $.
    lmodvsdir.k $e |- K = ( Base ` F ) $.
    lmodvsdir.p $e |- .+^ = ( +g ` F ) $.
    $( Distributive law for scalar product.  ( ~ ax-hvdistr1 analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.) $)
    lmodvsdir $p |- ( ( W e. LMod /\ ( Q e. K /\ R e. K /\ X e. V ) ) ->
                    ( ( Q .+^ R ) .x. X ) = ( ( Q .x. X ) .+ ( R .x. X ) ) ) $=
      ( wcel co wceq wa clmod w3a cmulr cfv cur lmodlema simpld simp3d anabsan2
      eqid 3expa exp42 3imp2 ) IUAQZCGQZDGQZJHQZCDBRJERCJERDJERZARSZUNUOUPUQUSU
      NUOUPTZTUQUSUNUTUQUQTZUSUNUTVAUBZURHQZDJJARERURURARSZUSVBVCVDUSUBCDFUCUDZ
      RJERCURERSFUEUDZJERJSTABCDEVEVFFGHIJJKLNMOPVEUJVFUJUFUGUHUKUIULUM $.
  $}

  ${
    lmodvsass.v $e |- V = ( Base ` W ) $.
    lmodvsass.f $e |- F = ( Scalar ` W ) $.
    lmodvsass.s $e |- .x. = ( .s ` W ) $.
    lmodvsass.k $e |- K = ( Base ` F ) $.
    lmodvsass.t $e |- .X. = ( .r ` F ) $.
    $( Associative law for scalar product.  ( ~ ax-hvmulass analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.) $)
    lmodvsass $p |- ( ( W e. LMod /\ ( Q e. K /\ R e. K /\ X e. V ) ) ->
                      ( ( Q .X. R ) .x. X ) = ( Q .x. ( R .x. X ) ) ) $=
      ( wcel co wceq wa cfv eqid w3a cur cplusg lmodlema simprd simpld anabsan2
      clmod 3expa exp42 3imp2 ) HUHOZAFOZBFOZIGOZABDPICPABICPZCPQZULUMUNUOUQULU
      MUNRZRUOUQULURUOUORZUQULURUSUAZUQEUBSZICPIQZUTUPGOBIIHUCSZPCPUPUPVCPQABEU
      CSZPICPAICPUPVCPQUAUQVBRVCVDABCDVAEFGHIIJVCTLKMVDTNVATUDUEUFUIUGUJUK $.
  $}

  ${
    lmod0cl.f $e |- F = ( Scalar ` W ) $.
    lmod0cl.k $e |- K = ( Base ` F ) $.
    lmod0cl.z $e |- .0. = ( 0g ` F ) $.
    $( The ring zero in a left module belongs to the ring base set.
       (Contributed by NM, 11-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmod0cl $p |- ( W e. LMod -> .0. e. K ) $=
      ( clmod wcel crg lmodrng rng0cl syl ) CHIAJIDBIACEKBADFGLM $.
  $}

  ${
    lmod1cl.f $e |- F = ( Scalar ` W ) $.
    lmod1cl.k $e |- K = ( Base ` F ) $.
    lmod1cl.u $e |- .1. = ( 1r ` F ) $.
    $( The ring unit in a left module belongs to the ring base set.
       (Contributed by NM, 11-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmod1cl $p |- ( W e. LMod -> .1. e. K ) $=
      ( clmod wcel crg lmodrng rngidcl syl ) DHIBJIACIBDEKCBAFGLM $.
  $}

  ${
    lmodvs1.v $e |- V = ( Base ` W ) $.
    lmodvs1.f $e |- F = ( Scalar ` W ) $.
    lmodvs1.s $e |- .x. = ( .s ` W ) $.
    lmodvs1.u $e |- .1. = ( 1r ` F ) $.
    $( Scalar product with ring unit.  ( ~ ax-hvmulid analog.)  (Contributed by
       NM, 10-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvs1 $p |- ( ( W e. LMod /\ X e. V ) -> ( .1. .x. X ) = X ) $=
      ( clmod wcel wa cfv co wceq eqid w3a cplusg simprd cbs simpl adantr simpr
      lmod1cl cmulr lmodlema syl122anc ) EKLZFDLZMUIBCUANZLZULUJUJBFAOZFPZUIUJU
      BUIULUJBCUKEHUKQZJUEUCZUPUIUJUDZUQUIULULMUJUJMRZBBCUFNZOFAOBUMAOPZUNURUMD
      LBFFESNZOAOUMUMVAOZPBBCSNZOFAOVBPRUTUNMVAVCBBAUSBCUKDEFFGVAQIHUOVCQUSQJUG
      TTUH $.
  $}

  ${
    0vcl.v $e |- V = ( Base ` W ) $.
    0vcl.z $e |- .0. = ( 0g ` W ) $.
    $( The zero vector is a vector.  ( ~ ax-hv0cl analog.)  (Contributed by NM,
       10-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmod0vcl $p |- ( W e. LMod -> .0. e. V ) $=
      ( clmod wcel cgrp lmodgrp grpidcl syl ) BFGBHGCAGBIABCDEJK $.
  $}

  ${
    0vlid.v $e |- V = ( Base ` W ) $.
    0vlid.a $e |- .+ = ( +g ` W ) $.
    0vlid.z $e |- .0. = ( 0g ` W ) $.
    $( Left identity law for the zero vector.  ( ~ hvaddid2 analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmod0vlid $p |- ( ( W e. LMod /\ X e. V ) -> ( .0. .+ X ) = X ) $=
      ( clmod wcel cgrp co wceq lmodgrp grplid sylan ) CIJCKJDBJEDALDMCNBACDEFG
      HOP $.

    $( Right identity law for the zero vector.  ( ~ ax-hvaddid analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmod0vrid $p |- ( ( W e. LMod /\ X e. V ) -> ( X .+ .0. ) = X ) $=
      ( clmod wcel cgrp co wceq lmodgrp grprid sylan ) CIJCKJDBJDEALDMCNBACDEFG
      HOP $.

    $( Identity equivalent to the value of the zero vector.  Provides a
       convenient way to compute the value.  (Contributed by NM, 9-Mar-2014.)
       (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmod0vid $p |- ( ( W e. LMod /\ X e. V )
        -> ( ( X .+ X ) = X <-> .0. = X ) ) $=
      ( clmod wcel cgrp co wceq wb lmodgrp grpid sylan ) CIJCKJDBJDDALDMEDMNCOB
      ACDEFGHPQ $.
  $}

  ${
    lmod0vs.v $e |- V = ( Base ` W ) $.
    lmod0vs.f $e |- F = ( Scalar ` W ) $.
    lmod0vs.s $e |- .x. = ( .s ` W ) $.
    lmod0vs.o $e |- O = ( 0g ` F ) $.
    lmod0vs.z $e |- .0. = ( 0g ` W ) $.
    $( Zero times a vector is the zero vector.  Equation 1a of [Kreyszig]
       p. 51.  ( ~ ax-hvmul0 analog.)  (Contributed by NM, 12-Jan-2014.)
       (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmod0vs $p |- ( ( W e. LMod /\ X e. V ) -> ( O .x. X ) = .0. ) $=
      ( clmod wcel co cplusg cfv wceq eqid syl wa cbs crg lmodrng adantr rng0cl
      simpl simpr lmodvsdir syl13anc cgrp rnggrp grplid syl2anc oveq1d lmodvscl
      eqtr3d wb syl3anc lmod0vid syldan mpbid eqcomd ) EMNZFDNZUAZGCFAOZVFVGVGE
      PQZOZVGRZGVGRZVFCCBPQZOZFAOZVIVGVFVDCBUBQZNZVPVEVNVIRVDVEUGZVFBUCNZVPVDVR
      VEBEIUDUEZVOBCVOSZKUFTZWAVDVEUHZVHVLCCABVODEFHVHSZIJVTVLSZUIUJVFVMCFAVFBU
      KNZVPVMCRVFVRWEVSBULTWAVOVLBCCVTWDKUMUNUOUQVDVEVGDNZVJVKURVFVDVPVEWFVQWAW
      BCABVODEFHIJVTUPUSVHDEVGGHWCLUTVAVBVC $.
  $}

  ${
    lmodvs0.f $e |- F = ( Scalar ` W ) $.
    lmodvs0.s $e |- .x. = ( .s ` W ) $.
    lmodvs0.k $e |- K = ( Base ` F ) $.
    lmodvs0.z $e |- .0. = ( 0g ` W ) $.
    $( Anything times the zero vector is the zero vector.  Equation 1b of
       [Kreyszig] p. 51.  ( ~ hvmul0 analog.)  (Contributed by NM,
       12-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvs0 $p |- ( ( W e. LMod /\ X e. K ) -> ( X .x. .0. ) = .0. ) $=
      ( clmod wcel wa c0g cfv cmulr co wceq eqid adantr crg lmodrng rngrz sylan
      oveq1d cbs simpl simpr rng0cl syl lmod0vcl syl13anc lmod0vs syldan oveq2d
      lmodvsass eqtrd 3eqtr3d ) DKLZECLZMZEBNOZBPOZQZFAQZVBFAQZEFAQZFVAVDVBFAUS
      BUALZUTVDVBRBDGUBZCBVCEVBIVCSZVBSZUCUDUEVAVEEVFAQZVGVAUSUTVBCLZFDUFOZLZVE
      VLRUSUTUGUSUTUHVAVHVMUSVHUTVITCBVBIVKUIUJUSVOUTVNDFVNSZJUKTZEVBAVCBCVNDFV
      PGHIVJUPULVAVFFEAUSUTVOVFFRVQABVBVNDFFVPGHVKJUMUNZUOUQVRUR $.
  $}

  ${
    lmodvnegcl.v $e |- V = ( Base ` W ) $.
    lmodvnegcl.n $e |- N = ( invg ` W ) $.
    $( Closure of vector negative.  (Contributed by NM, 18-Apr-2014.)  (Revised
       by Mario Carneiro, 19-Jun-2014.) $)
    lmodvnegcl $p |- ( ( W e. LMod /\ X e. V ) -> ( N ` X ) e. V ) $=
      ( clmod wcel cgrp cfv lmodgrp grpinvcl sylan ) CGHCIHDBHDAJBHCKBCADEFLM
      $.
  $}

  ${
    lmodvnegid.v $e |- V = ( Base ` W ) $.
    lmodvnegid.p $e |- .+ = ( +g ` W ) $.
    lmodvnegid.z $e |- .0. = ( 0g ` W ) $.
    lmodvnegid.n $e |- N = ( invg ` W ) $.
    $( Addition of a vector with its negative.  (Contributed by NM,
       18-Apr-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvnegid $p |- ( ( W e. LMod /\ X e. V ) -> ( X .+ ( N ` X ) ) = .0. ) $=
      ( clmod wcel cgrp cfv co wceq lmodgrp grprinv sylan ) DKLDMLECLEEBNAOFPDQ
      CADBEFGHIJRS $.
  $}

  ${
    lmodvneg1.v $e |- V = ( Base ` W ) $.
    lmodvneg1.n $e |- N = ( invg ` W ) $.
    lmodvneg1.f $e |- F = ( Scalar ` W ) $.
    lmodvneg1.s $e |- .x. = ( .s ` W ) $.
    lmodvneg1.u $e |- .1. = ( 1r ` F ) $.
    lmodvneg1.m $e |- M = ( invg ` F ) $.
    $( Minus 1 times a vector is the negative of the vector.  Equation 2 of
       [Kreyszig] p. 51.  (Contributed by NM, 18-Apr-2014.)  (Revised by Mario
       Carneiro, 19-Jun-2014.) $)
    lmodvneg1 $p |- ( ( W e. LMod /\ X e. V ) ->
                      ( ( M ` .1. ) .x. X ) = ( N ` X ) ) $=
      ( wcel cfv co wceq eqid eqtr3d clmod c0g cplusg cbs simpl lmodfgrp adantr
      cgrp lmod1cl grpinvcl syl2anc simpr lmodvscl syl3anc lmod0vrid lmodvnegcl
      wa syldan lmodass lmodvs1 oveq2d grplinv oveq1d lmodvsdir lmod0vs 3eqtr3d
      syl13anc lmodvnegid lmod0vlid ) GUAOZHFOZUQZBDPZHAQZGUBPZGUCPZQZVNHEPZVJV
      KVNFOZVQVNRVLVJVMCUDPZOZVKVSVJVKUEZVLCUHOZBVTOZWAVJWCVKCGKUFUGZVJWDVKBCVT
      GKVTSZMUIUGZVTCDBWFNUJUKZVJVKULZVMACVTFGHIKLWFUMUNZVPFGVNVOIVPSZVOSZUOURV
      LVNHVRVPQZVPQZVOVRVPQZVQVRVLVNHVPQZVRVPQZWNWOVLVJVSVKVRFOZWQWNRWBWJWIEFGH
      IJUPZVPFGVNHVRIWKUSVGVLWPVOVRVPVLVNBHAQZVPQZWPVOVLWTHVNVPABCFGHIKLMUTVAVL
      VMBCUCPZQZHAQZCUBPZHAQXAVOVLXCXEHAVLWCWDXCXERWEWGVTXBCDBXEWFXBSZXESZNVBUK
      VCVLVJWAWDVKXDXARWBWHWGWIVPXBVMBACVTFGHIWKKLWFXFVDVGACXEFGHVOIKLXGWLVEVFT
      VCTVLWMVOVNVPVPEFGHVOIWKWLJVHVAVJVKWRWOVRRWSVPFGVRVOIWKWLVIURVFT $.
  $}

  ${
    lmodvsneg.b $e |- B = ( Base ` W ) $.
    lmodvsneg.f $e |- F = ( Scalar ` W ) $.
    lmodvsneg.s $e |- .x. = ( .s ` W ) $.
    lmodvsneg.n $e |- N = ( invg ` W ) $.
    lmodvsneg.k $e |- K = ( Base ` F ) $.
    lmodvsneg.m $e |- M = ( invg ` F ) $.
    lmodvsneg.w $e |- ( ph -> W e. LMod ) $.
    lmodvsneg.x $e |- ( ph -> X e. B ) $.
    lmodvsneg.r $e |- ( ph -> R e. K ) $.
    $( Multiplication of a vector by a negated scalar.  (Contributed by Stefan
       O'Rear, 28-Feb-2015.) $)
    lmodvsneg $p |- ( ph -> ( N ` ( R .x. X ) ) = ( ( M ` R ) .x. X ) ) $=
      ( wcel cur cfv cmulr clmod wceq cgrp crg lmodrng syl rnggrp eqid grpinvcl
      co rngidcl syl2anc lmodvsass syl13anc rngnegl lmodvscl lmodvneg1 3eqtr3rd
      oveq1d syl3anc ) AEUAUBZGUBZCEUCUBZUMZJDUMZVECJDUMZDUMZCGUBZJDUMVIHUBZAIU
      DTZVEFTZCFTZJBTZVHVJUEQAEUFTZVDFTZVNAEUGTZVQAVMVSQEILUHUIZEUJUIAVSVRVTFEV
      DOVDUKZUNUIFEGVDOPULUOSRVECDVFEFBIJKLMOVFUKZUPUQAVGVKJDAFEVFVDGCOWBWAPVTS
      URVBAVMVIBTZVJVLUEQAVMVOVPWCQSRCDEFBIJKLMOUSVCDVDEGHBIVIKNLMWAPUTUOVA $.
  $}

  ${
    lmodvsubcl.v $e |- V = ( Base ` W ) $.
    lmodvsubcl.m $e |- .- = ( -g ` W ) $.
    $( Closure of vector subtraction.  ( ~ hvsubcl analog.)  (Contributed by
       NM, 31-Mar-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvsubcl $p |- ( ( W e. LMod /\ X e. V /\ Y e. V ) ->
      ( X .- Y ) e. V ) $=
      ( clmod wcel cgrp co lmodgrp grpsubcl syl3an1 ) CHICJIDBIEBIDEAKBICLBCADE
      FGMN $.
  $}

  ${
    lmodcom.v $e |- V = ( Base ` W ) $.
    lmodcom.a $e |- .+ = ( +g ` W ) $.
    $( Left module vector sum is commutative.  (Contributed by G&eacute;rard
       Lang, 25-Jun-2014.) $)
    lmodcom $p |- ( ( W e. LMod /\ X e. V /\ Y e. V ) ->
                    ( X .+ Y ) = ( Y .+ X ) ) $=
      ( wcel co wceq cfv eqid syl3anc syl13anc lmodvacl lmodvs1 syl2anc oveq12d
      lmodvsdir lmodass clmod w3a csca cur cplusg cvsca cbs lmod1cl syl lmodacl
      simp1 simp2 simp3 lmodvsdi eqtr3d 3eqtr3d 3eqtr4d cgrp wb lmodgrp grprcan
      eqtrd mpbid 3com23 lmodlcan ) CUAHZDBHZEBHZUBZDDEAIZAIZDEDAIZAIZJZVJVLJZV
      IDDAIZEAIZVJDAIZVKVMVIVQEAIZVREAIZJZVQVRJZVIVPEEAIZAIZVJVJAIZVSVTVICUCKZU
      DKZWGWFUEKZIZDCUFKZIZWIEWJIZAIZWGVJWJIZWNAIZWDWEVIWIVJWJIZWMWOVIVFWIWFUGK
      ZHZVGVHWPWMJVFVGVHUKZVIVFWGWQHZWTWRWSVIVFWTWSWGWFWQCWFLZWQLZWGLZUHUIZXDWH
      WFWQCWGWGXAXBWHLZUJMVFVGVHULZVFVGVHUMZAWIWJWFWQBCDEFGXAWJLZXBUNNVIVFWTWTV
      JBHZWPWOJWSXDXDABCDEFGOZAWHWGWGWJWFWQBCVJFGXAXHXBXESNUOVIWKVPWLWCAVIWKWGD
      WJIZXKAIZVPVIVFWTWTVGWKXLJWSXDXDXFAWHWGWGWJWFWQBCDFGXAXHXBXESNVIXKDXKDAVI
      VFVGXKDJWSXFWJWGWFBCDFXAXHXCPQZXMRVBVIWLWGEWJIZXNAIZWCVIVFWTWTVHWLXOJWSXD
      XDXGAWHWGWGWJWFWQBCEFGXAXHXBXESNVIXNEXNEAVIVFVHXNEJWSXGWJWGWFBCEFXAXHXCPQ
      ZXPRVBRVIWNVJWNVJAVIVFXIWNVJJWSXJWJWGWFBCVJFXAXHXCPQZXQRUPVIVFVPBHZVHVHVS
      WDJWSVIVFVGVGXRWSXFXFABCDDFGOMZXGXGABCVPEEFGTNVIVFXIVGVHVTWEJWSXJXFXGABCV
      JDEFGTNUQVICURHZVQBHZVRBHZVHWAWBUSVIVFXTWSCUTUIVIVFXRVHYAWSXSXGABCVPEFGOM
      VIVFXIVGYBWSXJXFABCVJDFGOMXGBACVQVREFGVANVCVIVFVGVGVHVQVKJWSXFXFXGABCDDEF
      GTNVIVFVGVHVGVRVMJWSXFXGXFABCDEDFGTNUPVIVFXIVLBHZVGVNVOUSWSXJVFVHVGYCABCE
      DFGOVDXFABCVJVLDFGVENVC $.
  $}

  ${
    $d x y W $.
    $( A left module is an abelian group (of vectors, under addition).
       (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       25-Jun-2014.) $)
    lmodabl $p |- ( W e. LMod -> W e. Abel ) $=
      ( vx vy clmod wcel cbs cfv cplusg eqidd lmodgrp cv eqid lmodcom isabld )
      ADEZBCAFGZAHGZAOPIOQIAJQPABKCKPLQLMN $.

    $( A left module is a commutative monoid under addition.  (Contributed by
       NM, 7-Jan-2015.) $)
    lmodcmn $p |- ( W e. LMod -> W e. CMnd ) $=
      ( clmod wcel cabel ccmn lmodabl ablcmn syl ) ABCADCAECAFAGH $.
  $}

  ${
    lmodnegadd.v $e |- V = ( Base ` W ) $.
    lmodnegadd.p $e |- .+ = ( +g ` W ) $.
    lmodnegadd.t $e |- .x. = ( .s ` W ) $.
    lmodnegadd.n $e |- N = ( invg ` W ) $.
    lmodnegadd.r $e |- R = ( Scalar ` W ) $.
    lmodnegadd.k $e |- K = ( Base ` R ) $.
    lmodnegadd.i $e |- I = ( invg ` R ) $.
    lmodnegadd.w $e |- ( ph -> W e. LMod ) $.
    lmodnegadd.a $e |- ( ph -> A e. K ) $.
    lmodnegadd.b $e |- ( ph -> B e. K ) $.
    lmodnegadd.x $e |- ( ph -> X e. V ) $.
    lmodnegadd.y $e |- ( ph -> Y e. V ) $.
    $( Distribute negation through addition of scalar products.  (Contributed
       by NM, 9-Apr-2015.) $)
    lmodnegadd $p |- ( ph -> ( N ` ( ( A .x. X ) .+ ( B .x. Y ) ) )
           = ( ( ( I ` A ) .x. X ) .+ ( ( I ` B ) .x. Y ) ) ) $=
      ( co cfv cabel wcel wceq lmodabl syl lmodvscl syl3anc ablinvadd lmodvsneg
      clmod oveq12d eqtrd ) ABLFUFZCMFUFZDUFIUGZUTIUGZVAIUGZDUFZBGUGLFUFZCGUGMF
      UFZDUFAKUHUIZUTJUIZVAJUIZVBVEUJAKUQUIZVHUAKUKULAVKBHUILJUIVIUAUBUDBFEHJKL
      NRPSUMUNAVKCHUIMJUIVJUAUCUECFEHJKMNRPSUMUNJDKIUTVANOQUOUNAVCVFVDVGDAJBFEH
      GIKLNRPQSTUAUDUBUPAJCFEHGIKMNRPQSTUAUEUCUPURUS $.
  $}

  ${
    lmod4.v $e |- V = ( Base ` W ) $.
    lmod4.p $e |- .+ = ( +g ` W ) $.
    $( Commutative/associative law for left module vector sum.  (Contributed by
       NM, 4-Feb-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmod4 $p |- ( ( W e. LMod /\ ( X e. V /\ Y e. V ) /\ ( Z e. V /\ U e. V ) )
        -> ( ( X .+ Y ) .+ ( Z .+ U ) ) = ( ( X .+ Z ) .+ ( Y .+ U ) ) ) $=
      ( clmod wcel ccmn wa co wceq lmodcmn cmn4 syl3an1 ) DJKDLKECKFCKMGCKBCKME
      FANGBANANEGANFBANANODPCADBEFGHIQR $.

    lmodvaddsub4.m $e |- .- = ( -g ` W ) $.
    $( Relationship between vector subtraction and addition.  ( ~ hvsubadd
       analog.)  (Contributed by NM, 31-Mar-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmodvsubadd $p |- ( ( W e. LMod /\ ( A e. V /\ B e. V /\ C e. V ) )
          -> ( ( A .- B ) = C <-> ( B .+ C ) = A ) ) $=
      ( clmod wcel cabel w3a co wceq wb lmodabl ablsubadd sylan ) GKLGMLAFLBFLC
      FLNABEOCPBCDOAPQGRFDGEABCHIJST $.

    $( Vector addition/subtraction law.  (Contributed by NM, 31-Mar-2014.)
       (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvaddsub4 $p |- ( ( W e. LMod /\ ( A e. V /\ B e. V ) /\
                           ( C e. V /\ D e. V ) ) ->
      ( ( A .+ B ) = ( C .+ D ) <-> ( A .- C ) = ( D .- B ) ) ) $=
      ( clmod wcel cabel wa co wceq wb lmodabl abladdsub4 syl3an1 ) HLMHNMAGMBG
      MOCGMDGMOABEPCDEPQACFPDBFPQRHSGEHFDABCIJKTUA $.

    $( Addition/subtraction cancellation law for vectors.  ( ~ hvpncan
       analog.)  (Contributed by NM, 16-Apr-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lmodvpncan $p |- ( ( W e. LMod /\ A e. V /\ B e. V ) ->
                       ( ( A .+ B ) .- B ) = A ) $=
      ( clmod wcel cgrp co wceq lmodgrp grppncan syl3an1 ) FJKFLKAEKBEKABCMBDMA
      NFOECFDABGHIPQ $.

    $( Cancellation law for vector subtraction ( ~ npcan analog).  (Contributed
       by NM, 19-Apr-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodvnpcan $p |- ( ( W e. LMod /\ A e. V /\ B e. V ) ->
                       ( ( A .- B ) .+ B ) = A ) $=
      ( clmod wcel cgrp co wceq lmodgrp grpnpcan syl3an1 ) FJKFLKAEKBEKABDMBCMA
      NFOECFDABGHIPQ $.
  $}

  ${
    lmodvsubval2.v $e |- V = ( Base ` W ) $.
    lmodvsubval2.p $e |- .+ = ( +g ` W ) $.
    lmodvsubval2.m $e |- .- = ( -g ` W ) $.
    lmodvsubval2.f $e |- F = ( Scalar ` W ) $.
    lmodvsubval2.s $e |- .x. = ( .s ` W ) $.
    lmodvsubval2.n $e |- N = ( invg ` F ) $.
    lmodvsubval2.u $e |- .1. = ( 1r ` F ) $.
    $( Value of vector subtraction in terms of addition.  ( ~ hvsubval
       analog.)  (Contributed by NM, 31-Mar-2014.)  (Proof shortened by Mario
       Carneiro, 19-Jun-2014.) $)
    lmodvsubval2 $p |- ( ( W e. LMod /\ A e. V /\ B e. V )
          -> ( A .- B ) = ( A .+ ( ( N ` .1. ) .x. B ) ) ) $=
      ( wcel co cfv clmod cminusg wceq eqid grpsubval 3adant1 lmodvneg1 3adant2
      w3a oveq2d eqtr4d ) JUARZAIRZBIRZUIZABGSZABJUBTZTZCSZAEHTBDSZCSUMUNUPUSUC
      ULICJUQGABKLUQUDZMUEUFUOUTURACULUNUTURUCUMDEFHUQIJBKVANOQPUGUHUJUK $.
  $}

  ${
    lmodsubvs.v $e |- V = ( Base ` W ) $.
    lmodsubvs.p $e |- .+ = ( +g ` W ) $.
    lmodsubvs.m $e |- .- = ( -g ` W ) $.
    lmodsubvs.t $e |- .x. = ( .s ` W ) $.
    lmodsubvs.f $e |- F = ( Scalar ` W ) $.
    lmodsubvs.k $e |- K = ( Base ` F ) $.
    lmodsubvs.n $e |- N = ( invg ` F ) $.
    lmodsubvs.w $e |- ( ph -> W e. LMod ) $.
    lmodsubvs.a $e |- ( ph -> A e. K ) $.
    lmodsubvs.x $e |- ( ph -> X e. V ) $.
    lmodsubvs.y $e |- ( ph -> Y e. V ) $.
    $( Subtraction of a scalar product in terms of addition.  (Contributed by
       NM, 9-Apr-2015.) $)
    lmodsubvs $p |- ( ph
          -> ( X .- ( A .x. Y ) ) = ( X .+ ( ( N ` A ) .x. Y ) ) ) $=
      ( co cur cfv clmod wcel wceq lmodvscl syl3anc eqid lmodvsubval2 cmulr crg
      cgrp lmodrng syl rnggrp rngidcl grpinvcl syl2anc lmodvsass rngnegl oveq1d
      syl13anc eqtr3d oveq2d eqtrd ) AKBLDUDZGUDZKEUEUFZHUFZVJDUDZCUDZKBHUFZLDU
      DZCUDAJUGUHZKIUHVJIUHZVKVOUITUBAVRBFUHZLIUHZVSTUAUCBDEFIJLMQPRUJUKKVJCDVL
      EGHIJMNOQPSVLULZUMUKAVNVQKCAVMBEUNUFZUDZLDUDZVNVQAVRVMFUHZVTWAWEVNUITAEUP
      UHZVLFUHZWFAEUOUHZWGAVRWITEJQUQURZEUSURAWIWHWJFEVLRWBUTURFEHVLRSVAVBUAUCV
      MBDWCEFIJLMQPRWCULZVCVFAWDVPLDAFEWCVLHBRWKWBSWJUAVDVEVGVHVI $.
  $}

  ${
    lmodsubdi.v $e |- V = ( Base ` W ) $.
    lmodsubdi.t $e |- .x. = ( .s ` W ) $.
    lmodsubdi.f $e |- F = ( Scalar ` W ) $.
    lmodsubdi.k $e |- K = ( Base ` F ) $.
    lmodsubdi.m $e |- .- = ( -g ` W ) $.
    lmodsubdi.w $e |- ( ph -> W e. LMod ) $.
    lmodsubdi.a $e |- ( ph -> A e. K ) $.
    lmodsubdi.x $e |- ( ph -> X e. V ) $.
    lmodsubdi.y $e |- ( ph -> Y e. V ) $.
    $( Scalar multiplication distributive law for subtraction.  ( ~ hvsubdistr1
       analog, with longer proof since our scalar multiplication is not
       commutative.)  (Contributed by NM, 2-Jul-2014.) $)
    lmodsubdi $p |- ( ph
       -> ( A .x. ( X .- Y ) ) = ( ( A .x. X ) .- ( A .x. Y ) ) ) $=
      ( co cur cminusg cplusg clmod wcel wceq lmodvsubval2 syl3anc oveq2d cmulr
      cfv crg lmodrng syl rngnegr rngnegl eqtr4d oveq1d rnggrp rngidcl grpinvcl
      eqid cgrp syl2anc lmodvsass syl13anc 3eqtr3d lmodvscl lmodvsdi 3eqtr4rd )
      ABIJFTZCTBIDUAUKZDUBUKZUKZJCTZHUCUKZTZCTZBICTZBJCTZFTZAVKVQBCAHUDUEZIGUEZ
      JGUEZVKVQUFPRSIJVPCVLDFVMGHKVPVBZOMLVMVBZVLVBZUGUHUIAVSBVOCTZVPTZVSVNVTCT
      ZVPTZVRWAAWHWJVSVPABVNDUJUKZTZJCTZVNBWLTZJCTZWHWJAWMWOJCAWMBVMUKWOAEDWLVL
      VMBNWLVBZWGWFAWBDULUEZPDHMUMUNZQUOAEDWLVLVMBNWQWGWFWSQUPUQURAWBBEUEZVNEUE
      ZWDWNWHUFPQADVCUEZVLEUEZXAAWRXBWSDUSUNAWRXCWSEDVLNWGUTUNEDVMVLNWFVAVDZSBV
      NCWLDEGHJKMLNWQVEVFAWBXAWTWDWPWJUFPXDQSVNBCWLDEGHJKMLNWQVEVFVGUIAWBWTWCVO
      GUEZVRWIUFPQRAWBXAWDXEPXDSVNCDEGHJKMLNVHUHVPBCDEGHIVOKWEMLNVIVFAWBVSGUEZV
      TGUEZWAWKUFPAWBWTWCXFPQRBCDEGHIKMLNVHUHAWBWTWDXGPQSBCDEGHJKMLNVHUHVSVTVPC
      VLDFVMGHKWEOMLWFWGUGUHVJUQ $.
  $}

  ${
    lmodsubdir.v $e |- V = ( Base ` W ) $.
    lmodsubdir.t $e |- .x. = ( .s ` W ) $.
    lmodsubdir.f $e |- F = ( Scalar ` W ) $.
    lmodsubdir.k $e |- K = ( Base ` F ) $.
    lmodsubdir.m $e |- .- = ( -g ` W ) $.
    lmodsubdir.s $e |- S = ( -g ` F ) $.
    lmodsubdir.w $e |- ( ph -> W e. LMod ) $.
    lmodsubdir.a $e |- ( ph -> A e. K ) $.
    lmodsubdir.b $e |- ( ph -> B e. K ) $.
    lmodsubdir.x $e |- ( ph -> X e. V ) $.
    $( Scalar multiplication distributive law for subtraction.  ( ~ hvsubdistr2
       analog.)  (Contributed by NM, 2-Jul-2014.) $)
    lmodsubdir $p |- ( ph
       -> ( ( A S B ) .x. X ) = ( ( A .x. X ) .- ( B .x. X ) ) ) $=
      ( cminusg cfv cplusg cur clmod wcel wceq cgrp crg lmodrng syl rnggrp eqid
      grpinvcl syl2anc lmodvsdir syl13anc cmulr rngnegl oveq1d lmodvsass eqtr3d
      co rngidcl oveq2d eqtrd grpsubval lmodvscl syl3anc lmodvsubval2 3eqtr4d )
      ABCFUBUCZUCZFUDUCZVDZKEVDZBKEVDZFUEUCZVMUCZCKEVDZEVDZJUDUCZVDZBCDVDZKEVDV
      RWAHVDZAVQVRVNKEVDZWCVDZWDAJUFUGZBGUGZVNGUGZKIUGZVQWHUHRSAFUIUGZCGUGZWKAF
      UJUGZWMAWIWORFJNUKULZFUMULZTGFVMCOVMUNZUOUPUAWCVOBVNEFGIJKLWCUNZNMOVOUNZU
      QURAWGWBVRWCAVTCFUSUCZVDZKEVDZWGWBAXBVNKEAGFXAVSVMCOXAUNZVSUNZWRWPTUTVAAW
      IVTGUGZWNWLXCWBUHRAWMVSGUGZXFWQAWOXGWPGFVSOXEVEULGFVMVSOWRUOUPTUAVTCEXAFG
      IJKLNMOXDVBURVCVFVGAWEVPKEAWJWNWEVPUHSTGVOFVMDBCOWTWRQVHUPVAAWIVRIUGZWAIU
      GZWFWDUHRAWIWJWLXHRSUABEFGIJKLNMOVIVJAWIWNWLXIRTUACEFGIJKLNMOVIVJVRWAWCEV
      SFHVMIJLWSPNMWRXEVKVJVL $.
  $}

  ${
    lmodsubeq0.v $e |- V = ( Base ` W ) $.
    lmodsubeq0.o $e |- .0. = ( 0g ` W ) $.
    lmodsubeq0.m $e |- .- = ( -g ` W ) $.
    $( If the difference between two vectors is zero, they are equal.
       ( ~ hvsubeq0 analog.)  (Contributed by NM, 31-Mar-2014.)  (Revised by
       Mario Carneiro, 19-Jun-2014.) $)
    lmodsubeq0 $p |- ( ( W e. LMod /\ A e. V /\ B e. V )
                  -> ( ( A .- B ) = .0. <-> A = B ) ) $=
      ( clmod wcel cgrp co wceq wb lmodgrp grpsubeq0 syl3an1 ) EJKELKADKBDKABCM
      FNABNOEPDECABFGHIQR $.

    $( Subtraction of a vector from itself.  ( ~ hvsubid analog.)  (Contributed
       by NM, 16-Apr-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lmodsubid $p |- ( ( W e. LMod /\ A e. V ) -> ( A .- A ) = .0. ) $=
      ( clmod wcel cgrp co wceq lmodgrp grpsubid sylan ) DIJDKJACJAABLEMDNCDBAE
      FGHOP $.
  $}

  ${
    $d x y z K $.  $d x y z R $.  $d x y z .x. $.  $d x y z V $.  $d x y z W $.
    lmodvsghm.v $e |- V = ( Base ` W ) $.
    lmodvsghm.f $e |- F = ( Scalar ` W ) $.
    lmodvsghm.s $e |- .x. = ( .s ` W ) $.
    lmodvsghm.k $e |- K = ( Base ` F ) $.
    $( Scalar multiplication of the vector space by a fixed scalar is an
       automorphism of the addiive group of vectors.  (Contributed by Mario
       Carneiro, 5-May-2015.) $)
    lmodvsghm $p |- ( ( W e. LMod /\ R e. K ) ->
                      ( x e. V |-> ( R .x. x ) ) e. ( W GrpHom W ) ) $=
      ( wcel wa cfv cv co wceq oveq2 ovex fvmpt vy vz clmod cplusg cmpt lmodgrp
      eqid cgrp adantr lmodvscl 3expa fmptd lmodvsdi 3exp2 imp43 lmodvacl 3expb
      adantlr syl oveqan12d adantl 3eqtr4d isghmd ) GUCLZBELZMZUAUBGUDNZVGGGAFB
      AOZCPZUEZFFHHVGUGZVKVDGUHLVEGUFUIZVLVFAFVIFVJVDVEVHFLVIFLBCDEFGVHHIJKUJUK
      VJUGZULVFUAOZFLZUBOZFLZMZMZBVNVPVGPZCPZBVNCPZBVPCPZVGPZVTVJNZVNVJNZVPVJNZ
      VGPZVDVEVOVQWAWDQZVDVEVOVQWIVGBCDEFGVNVPHVKIJKUMUNUOVSVTFLZWEWAQVDVRWJVEV
      DVOVQWJVGFGVNVPHVKUPUQURAVTVIWAFVJVHVTBCRVMBVTCSTUSVRWHWDQVFVOVQWFWBWGWCV
      GAVNVIWBFVJVHVNBCRVMBVNCSTAVPVIWCFVJVHVPBCRVMBVPCSTUTVAVBVC $.
  $}

  ${
    $d q r w x y z B $.  $d q r w x y z F $.  $d q r w x y z ph $.
    $d q r w x y z G $.  $d q r w x y z K $.  $d q r w x y z L $.
    $d q r w x y z P $.
    lmodprop2d.b1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lmodprop2d.b2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lmodprop2d.f $e |- F = ( Scalar ` K ) $.
    lmodprop2d.g $e |- G = ( Scalar ` L ) $.
    lmodprop2d.p1 $e |- ( ph -> P = ( Base ` F ) ) $.
    lmodprop2d.p2 $e |- ( ph -> P = ( Base ` G ) ) $.
    lmodprop2d.1 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lmodprop2d.2 $e |- ( ( ph /\ ( x e. P /\ y e. P ) ) ->
      ( x ( +g ` F ) y ) = ( x ( +g ` G ) y ) ) $.
    lmodprop2d.3 $e |- ( ( ph /\ ( x e. P /\ y e. P ) ) ->
      ( x ( .r ` F ) y ) = ( x ( .r ` G ) y ) ) $.
    lmodprop2d.4 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    $( If two structures have the same components (properties), one is a left
       module iff the other one is.  This version of ~ lmodpropd also breaks up
       the components of the scalar ring.  (Contributed by Mario Carneiro,
       27-Jun-2015.) $)
    lmodprop2d $p |- ( ph -> ( K e. LMod <-> L e. LMod ) ) $=
      ( wcel vr vw vz vq cgrp crg cv cvsca cfv co wral w3a clmod wi lmodgrp a1i
      cbs cplusg wceq cur wa eqid islmod simp2bi simplr simprl ad2antrr eleqtrd
      cmulr simprr lmodvscl syl3anc eleqtrrd ralrimivva 3jcad grppropd rngpropd
      ex syl5ibr adantlr 3eltr4d adantr simpll simprlr simprrr proplem syl12anc
      wb eleq1d simplr1 simprrl grpcl simplr3 proplem2 syl21anc oveq12d eqeq12d
      oveq2d eqtrd simplr2 simprll rngacl ad2ant2r oveq1d 3anbi123d rngidcl syl
      rngcl rngidpropd eqeq1d anbi12d anassrs 2ralbidva eleq2d anbi1d raleqbidv
      3anbi1d 3bitr3d 3bitr4g pm5.21ndd ) AHUETZFUFTZBUGZCUGZHUHUIZUJZDTZCDUKBE
      UKZULZHUMTZIUMTZAYJYAYBYHYJYAUNAHUOUPYJYBUNAYJYAYBUAUGZUBUGZYEUJZHUQUIZTZ
      YLYMUCUGZHURUIZUJZYEUJZYNYLYQYEUJZYRUJZUSZUDUGZYLFURUIZUJZYMYEUJZUUDYMYEU
      JZYNYRUJZUSZULZUUDYLFVIUIZUJZYMYEUJZUUDYNYEUJZUSZFUTUIZYMYEUJZYMUSZVAZVAZ
      UBYOUKZUCYOUKZUAFUQUIZUKZUDUVDUKZUCUBYRUUEYEUULUUQFUVDYOHUAUDYOVBZYRVBZYE
      VBZLUVDVBZUUEVBZUULVBZUUQVBZVCZVDUPAYJYHAYJVAZYGBCEDUVOYCETZYDDTZVAZVAZYF
      YODUVSYJYCUVDTYDYOTYFYOTAYJUVRVEUVSYCEUVDUVOUVPUVQVFAEUVDUSZYJUVRNVGVHUVS
      YDDYOUVOUVPUVQVJADYOUSZYJUVRJVGZVHYCYEFUVDYOHYDUVGLUVIUVJVKVLUWBVMVNVRVOA
      YKYAYBYHYKYAAIUETZIUOABCDHIJKPVPZVSYKYBAGUFTZYKUWCUWEYLYMIUHUIZUJZIUQUIZT
      ZYLYMYQIURUIZUJZUWFUJZUWGYLYQUWFUJZUWJUJZUSZUUDYLGURUIZUJZYMUWFUJZUUDYMUW
      FUJZUWGUWJUJZUSZULZUUDYLGVIUIZUJZYMUWFUJZUUDUWGUWFUJZUSZGUTUIZYMUWFUJZYMU
      SZVAZVAZUBUWHUKZUCUWHUKZUAGUQUIZUKZUDUXOUKZUCUBUWJUWPUWFUXCUXHGUXOUWHIUAU
      DUWHVBZUWJVBUWFVBZMUXOVBZUWPVBUXCVBUXHVBVCZVDABCEFGNOQRVQZVSAYKYHAYKVAZYG
      BCEDUYCUVRVAZYCYDUWFUJZUWHYFDUYDYKYCUXOTYDUWHTUYEUWHTAYKUVRVEUYDYCEUXOUYC
      UVPUVQVFAEUXOUSZYKUVROVGVHUYDYDDUWHUYCUVPUVQVJADUWHUSZYKUVRKVGZVHYCUWFGUX
      OUWHIYDUXRMUXSUXTVKVLAUVRYFUYEUSYKSVTUYHWAVNVRVOAYIYJYKWHAYIVAZYAYBUVFULU
      WCUWEUXQULYJYKUYIYAUWCYBUWEUVFUXQAYAUWCWHYIUWDWBAYBUWEWHYIUYBWBUYIYNDTZUU
      CUUJULZUUTVAZUBDUKZUCDUKZUAEUKZUDEUKUWGDTZUWOUXAULZUXKVAZUBDUKZUCDUKZUAEU
      KZUDEUKUVFUXQUYIUYNUYTUDUAEEUYIUUDETZYLETZVAZVAUYLUYRUCUBDDUYIVUDYQDTZYMD
      TZVAZUYLUYRWHUYIVUDVUGVAZVAZUYKUYQUUTUXKVUIUYJUYPUUCUWOUUJUXAVUIYNUWGDVUI
      AVUCVUFYNUWGUSAYIVUHWCZUYIVUBVUCVUGWDZUYIVUDVUEVUFWEZABCEDYEUWFYLYMSWFWGZ
      WIVUIYTUWLUUBUWNVUIYTYLYSUWFUJZUWLVUIAVUCYSDTYTVUNUSVUJVUKVUIYSYODVUIYAYM
      YOTYQYOTYSYOTYAYBYHAVUHWJVUIYMDYOVULAUWAYIVUHJVGZVHVUIYQDYOUYIVUDVUEVUFWK
      ZVUOVHYOYRHYMYQUVGUVHWLVLVUOVMABCEDYEUWFYLYSSWFWGVUIYSUWKYLUWFVUIAVUFVUEY
      SUWKUSVUJVULVUPABCDDYRUWJYMYQPWFWGWRWSVUIUUBYNUUAUWJUJZUWNVUIAUYJUUADTZUU
      BVUQUSVUJVUIVUCVUFYHUYJVUKVULYAYBYHAVUHWMZBCEDDYEYLYMWNWOZVUIVUCVUEYHVURV
      UKVUPVUSBCEDDYEYLYQWNWOABCDDYRUWJYNUUAPWFWGVUIYNUWGUUAUWMUWJVUMVUIAVUCVUE
      UUAUWMUSVUJVUKVUPABCEDYEUWFYLYQSWFWGWPWSWQVUIUUGUWRUUIUWTVUIUUGUUFYMUWFUJ
      ZUWRVUIAUUFETVUFUUGVVAUSVUJVUIUUFUVDEVUIYBUUDUVDTZYLUVDTZUUFUVDTYAYBYHAVU
      HWTZVUIUUDEUVDUYIVUBVUCVUGXAZAUVTYIVUHNVGZVHZVUIYLEUVDVUKVVFVHZUVDUUEFUUD
      YLUVJUVKXBVLVVFVMVULABCEDYEUWFUUFYMSWFWGVUIUUFUWQYMUWFAVUDUUFUWQUSYIVUGAB
      CEEUUEUWPUUDYLQWFXCXDWSVUIUUIUUHYNUWJUJZUWTVUIAUUHDTZUYJUUIVVIUSVUJVUIVUB
      VUFYHVVJVVEVULVUSBCEDDYEUUDYMWNWOVUTABCDDYRUWJUUHYNPWFWGVUIUUHUWSYNUWGUWJ
      VUIAVUBVUFUUHUWSUSVUJVVEVULABCEDYEUWFUUDYMSWFWGVUMWPWSWQXEVUIUUPUXGUUSUXJ
      VUIUUNUXEUUOUXFVUIUUNUUMYMUWFUJZUXEVUIAUUMETVUFUUNVVKUSVUJVUIUUMUVDEVUIYB
      VVBVVCUUMUVDTVVDVVGVVHUVDFUULUUDYLUVJUVLXHVLVVFVMVULABCEDYEUWFUUMYMSWFWGV
      UIUUMUXDYMUWFAVUDUUMUXDUSYIVUGABCEEUULUXCUUDYLRWFXCXDWSVUIUUOUUDYNUWFUJZU
      XFVUIAVUBUYJUUOVVLUSVUJVVEVUTABCEDYEUWFUUDYNSWFWGVUIYNUWGUUDUWFVUMWRWSWQV
      UIUURUXIYMVUIUURUUQYMUWFUJZUXIVUIAUUQETVUFUURVVMUSVUJVUIUUQUVDEVUIYBUUQUV
      DTVVDUVDFUUQUVJUVMXFXGVVFVMVULABCEDYEUWFUUQYMSWFWGVUIUUQUXHYMUWFAUUQUXHUS
      YIVUHABCEFGNORXIVGXDWSXJXKXKXLXMXMUYIUYOUVEUDEUVDAUVTYINWBZUYIUYNUVCUAEUV
      DVVNUYIUYMUVBUCDYOAUWAYIJWBZUYIUYLUVAUBDYOVVOUYIUYKUUKUUTUYIUYJYPUUCUUJUY
      IDYOYNVVOXNXQXOXPXPXPXPUYIVUAUXPUDEUXOAUYFYIOWBZUYIUYTUXNUAEUXOVVPUYIUYSU
      XMUCDUWHAUYGYIKWBZUYIUYRUXLUBDUWHVVQUYIUYQUXBUXKUYIUYPUWIUWOUXAUYIDUWHUWG
      VVQXNXQXOXPXPXPXPXRXEUVNUYAXSVRXT $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y L $.  $d x y P $.  $d x y ph $.
    lmodpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lmodpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lmodpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lmodpropd.4 $e |- ( ph -> F = ( Scalar ` K ) ) $.
    lmodpropd.5 $e |- ( ph -> F = ( Scalar ` L ) ) $.
    lmodpropd.6 $e |- P = ( Base ` F ) $.
    lmodpropd.7 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    $( If two structures have the same components (properties), one is a left
       module iff the other one is.  (Contributed by Mario Carneiro,
       8-Feb-2015.)  (Revised by Mario Carneiro, 27-Jun-2015.) $)
    lmodpropd $p |- ( ph -> ( K e. LMod <-> L e. LMod ) ) $=
      ( cfv cbs fveq2d cplusg cmulr csca eqid syl5eq cv wcel wceq eqtr3d adantr
      wa oveqd lmodprop2d ) ABCDEGUAPZHUAPZGHIJULUBUMUBAEFQPZULQPNAFULQLRUCAEUN
      UMQPNAFUMQMRUCKABUDZEUECUDZEUEUIZUIZULSPUMSPUOUPURULUMSAULUMUFUQAFULUMLMU
      GUHZRUJURULTPUMTPUOUPURULUMTUSRUJOUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Subspaces and spans in a left module
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LSubSp $.

  $( Extend class notation with linear subspaces of a left module or left
     vector space. $)
  clss $a class LSubSp $.

  ${
    $d a b s x w $.
    $( Define the set of linear subspaces of a left module or left vector
       space.  (Contributed by NM, 8-Dec-2013.) $)
    df-lss $a |- LSubSp = ( w e. _V |->
     { s e. ( ~P ( Base ` w ) \ { (/) } ) |
        A. x e. ( Base ` ( Scalar ` w ) ) A. a e. s A. b e. s
          ( ( x ( .s ` w ) a ) ( +g ` w ) b ) e. s } ) $.
  $}

  ${
    $d s w .+ $.  $d s w x B $.  $d s w V $.  $d a b s w x W $.  $d s w .x. $.
    $d a b s x U $.
    lssset.f $e |- F = ( Scalar ` W ) $.
    lssset.b $e |- B = ( Base ` F ) $.
    lssset.v $e |- V = ( Base ` W ) $.
    lssset.p $e |- .+ = ( +g ` W ) $.
    lssset.t $e |- .x. = ( .s ` W ) $.
    lssset.s $e |- S = ( LSubSp ` W ) $.
    $( The set of all (not necessarily closed) linear subspaces of a left
       module or left vector space.  (Contributed by NM, 8-Dec-2013.)  (Revised
       by Mario Carneiro, 15-Jul-2014.) $)
    lssset $p |- ( W e. X -> S = { s e. ( ~P V \ { (/) } ) |
         A. x e. B A. a e. s A. b e. s ( ( x .x. a ) .+ b ) e. s } ) $=
      ( cfv cbs vw wcel clss cv co wral cpw csn cdif crab cvv wceq cvsca cplusg
      c0 elex csca fveq2 syl6eqr pweqd difeq1d fveq2d oveqd oveq1d eqtrd eleq1d
      2ralbidv raleqbidv rabeqbidv df-lss fvex eqeltri difexg ax-mp rabex fvmpt
      pwex syl syl5eq ) HIUBZDHUCSZAUDZKUDZEUEZLUDZCUEZJUDZUBZLWGUFKWGUFZABUFZJ
      GUGZUOUHZUIZUJZRVTHUKUBWAWNULHIUPUAHWBWCUAUDZUMSZUEZWEWOUNSZUEZWGUBZLWGUF
      KWGUFZAWOUQSZTSZUFZJWOTSZUGZWLUIZUJWNUKUCWOHULZXDWJJXGWMXHXFWKWLXHXEGXHXE
      HTSZGWOHTUROUSUTVAXHXAWIAXCBXHXCFTSBXHXBFTXHXBHUQSFWOHUQURMUSVBNUSXHWTWHK
      LWGWGXHWSWFWGXHWSWDWEWRUEWFXHWQWDWEWRXHWPEWBWCXHWPHUMSEWOHUMURQUSVCVDXHWR
      CWDWEXHWRHUNSCWOHUNURPUSVCVEVFVGVHVIAUAJKLVJWJJWMWKUKUBWMUKUBGGXIUKOHTVKV
      LVQWKWLUKVMVNVOVPVRVS $.

    $( The predicate "is a subspace" (of a left module or left vector space).
       (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       8-Jan-2015.) $)
    islss $p |- ( U e. S <-> ( U C_ V /\ U =/= (/)
          /\ A. x e. B A. a e. U A. b e. U ( ( x .x. a ) .+ b ) e. U ) ) $=
      ( wcel c0 wral vs cvv wss wne cv co w3a clss cfv elfvex eleq2s wceq fvprc
      cbs syl5eq sseq2d biimpcd ss0 syl6 necon1ad imp 3adant3 cpw csn cdif crab
      wn lssset eleq2d eldifsn fvex eqeltri elpw2 anbi1i bitri eleq2 raleqbi1dv
      wa ralbidv elrab df-3an 3bitr4i syl6bb pm5.21nii ) FDRZIUBRZFHUCZFSUDZAUE
      JUEEUFKUECUFZFRZKFTZJFTZABTZUGZWFFIUHUIDFIUHUJQUKWGWHWFWMWGWHWFWGWFFSWGWF
      VGZFSUCZFSULWOWGWPWOHSFWOHIUNUIZSNIUNUMUOUPUQFURUSUTVAVBWFWEFWIUAUEZRZKWR
      TZJWRTZABTZUAHVCZSVDVEZVFZRZWNWFDXEFABCDEGHIUBUAJKLMNOPQVHVIFXDRZWMVRWGWH
      VRZWMVRXFWNXGXHWMXGFXCRZWHVRXHFXCSVJXIWGWHFHHWQUBNIUNVKVLVMVNVOVNXBWMUAFX
      DWRFULXAWLABWTWKJWRFWSWJKWRFWRFWIVPVQVQVSVTWGWHWMWAWBWCWD $.
  $}

  ${
    $d a b x ph $.  $d a b x U $.  $d a b x W $.  $d a b B $.
    islssd.f $e |- ( ph -> F = ( Scalar ` W ) ) $.
    islssd.b $e |- ( ph -> B = ( Base ` F ) ) $.
    islssd.v $e |- ( ph -> V = ( Base ` W ) ) $.
    islssd.p $e |- ( ph -> .+ = ( +g ` W ) ) $.
    islssd.t $e |- ( ph -> .x. = ( .s ` W ) ) $.
    islssd.s $e |- ( ph -> S = ( LSubSp ` W ) ) $.
    islssd.u $e |- ( ph -> U C_ V ) $.
    islssd.z $e |- ( ph -> U =/= (/) ) $.
    islssd.c $e |- ( ( ph /\ ( x e. B /\ a e. U /\ b e. U ) ) ->
            ( ( x .x. a ) .+ b ) e. U ) $.
    $( Properties that determine a subspace of a left module or left vector
       space.  (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       8-Jan-2015.) $)
    islssd $p |- ( ph -> U e. S ) $=
      ( clss cfv cbs wss c0 wne cv cvsca co cplusg wcel wral csca sseqtrd 3exp2
      wa imp43 ralrimivva ex fveq2d eqtrd eleq2d oveq1d eleq1d 2ralbidv 3imtr3d
      oveqd ralrimiv eqid islss syl3anbrc eleqtrrd ) AGJUBUCZEAGJUDUCZUEGUFUGBU
      HZKUHZJUIUCZUJZLUHZJUKUCZUJZGULZLGUMKGUMZBJUNUCZUDUCZUMGVNULAGIVOSOUOTAWD
      BWFAVPCULZVPVQFUJZVTDUJZGULZLGUMKGUMZVPWFULWDAWGWKAWGUQWJKLGGAWGVQGULZVTG
      ULZWJAWGWLWMWJUAUPURUSUTACWFVPACHUDUCWFNAHWEUDMVAVBVCAWJWCKLGGAWIWBGAWIWH
      VTWAUJWBADWAWHVTPVHAWHVSVTWAAFVRVPVQQVHVDVBVEVFVGVIBWFWAVNVRGWEVOJKLWEVJW
      FVJVOVJWAVJVRVJVNVJVKVLRVM $.
  $}

  ${
    $d a b x U $.  $d a b x V $.  $d a b x W $.
    lssss.v $e |- V = ( Base ` W ) $.
    lssss.s $e |- S = ( LSubSp ` W ) $.
    $( A subspace is a set of vectors.  (Contributed by NM, 8-Dec-2013.)
       (Revised by Mario Carneiro, 8-Jan-2015.) $)
    lssss $p |- ( U e. S -> U C_ V ) $=
      ( vx va vb wcel wss c0 wne cv cvsca cfv co cplusg wral eqid islss simp1bi
      csca cbs ) BAJBCKBLMGNHNDOPZQINDRPZQBJIBSHBSGDUCPZUDPZSGUHUFAUEBUGCDHIUGT
      UHTEUFTUETFUAUB $.

    $( A subspace member is a vector.  (Contributed by NM, 11-Jan-2014.)
       (Revised by Mario Carneiro, 8-Jan-2015.) $)
    lssel $p |- ( ( U e. S /\ X e. U ) -> X e. V ) $=
      ( wcel lssss sselda ) BAHBCEABCDFGIJ $.

    $( The set of vectors in a left module is a subspace.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lss1 $p |- ( W e. LMod -> V e. S ) $=
      ( vx va vb clmod wcel csca cfv cbs cplusg eqidd wceq a1i cv co eqid cvsca
      clss wss ssid lmodbn0 wa simpl lmodvscl 3adant3r3 simpr3 lmodvacl syl3anc
      w3a islssd ) CIJZFCKLZMLZCNLZACUALZBUPBCGHUOUPOUOUQOBCMLPUODQUOUROUOUSOAC
      UBLPUOEQBBUCUOBUDQBCDUEUOFRZUQJZGRZBJZHRZBJZUMZUFUOUTVBUSSZBJZVEVGVDURSBJ
      UOVFUGUOVAVCVHVEUTUSUPUQBCVBDUPTUSTUQTUHUIUOVAVCVEUJURBCVGVDDURTUKULUN $.

    $d x S $.
    lssuni.w $e |- ( ph -> W e. LMod ) $.
    $( The union of all subspaces is the vector space.  (Contributed by NM,
       13-Mar-2015.) $)
    lssuni $p |- ( ph -> U. S = V ) $=
      ( vx cuni cv wss crab wceq rabid2 lssss mprgbir unieqi clmod wcel lss1
      unimax 3syl syl5eq ) ABIHJZCKZHBLZIZCBUFBUFMUEHBUEHBNBUDCDEFOPQADRSCBSUGC
      MGBCDEFTHCBUAUBUC $.
  $}

  ${
    $d a b x U $.  $d a b x W $.
    lssn0.s $e |- S = ( LSubSp ` W ) $.
    $( A subspace is not empty.  (Contributed by NM, 12-Jan-2014.)  (Revised by
       Mario Carneiro, 8-Jan-2015.) $)
    lssn0 $p |- ( U e. S -> U =/= (/) ) $=
      ( vx va vb wcel cbs cfv wss c0 wne cv cvsca co cplusg wral csca eqid
      islss simp2bi ) BAHBCIJZKBLMENFNCOJZPGNCQJZPBHGBRFBRECSJZIJZREUGUEAUDBUFU
      CCFGUFTUGTUCTUETUDTDUAUB $.
  $}

  $( The empty structure has no subspaces (for use with ~ fvco4i ).
     (Contributed by Stefan O'Rear, 31-Mar-2015.) $)
  00lss $p |- (/) = ( LSubSp ` (/) ) $=
    ( va c0 clss cfv wcel noel wceq wss base0 eqid lssss ss0 syl neneqd pm2.65i
    cv lssn0 2false eqriv ) ABBCDZAPZBEUATEZUAFUBUABGZUBUABHUCTUABBITJZKUALMUBU
    ABTUABUDQNORS $.

  ${
    $d x B $.  $d a b x .+ $.  $d a b x .x. $.  $d a b x U $.  $d a b x W $.
    $d a b X $.  $d b Y $.  $d a b x Z $.
    lsscl.f $e |- F = ( Scalar ` W ) $.
    lsscl.b $e |- B = ( Base ` F ) $.
    lsscl.p $e |- .+ = ( +g ` W ) $.
    lsscl.t $e |- .x. = ( .s ` W ) $.
    lsscl.s $e |- S = ( LSubSp ` W ) $.
    $( Closure property of a subspace.  (Contributed by NM, 8-Dec-2013.)
       (Revised by Mario Carneiro, 8-Jan-2015.) $)
    lsscl $p |- ( ( U e. S /\ ( Z e. B /\ X e. U /\ Y e. U ) ) ->
      ( ( Z .x. X ) .+ Y ) e. U ) $=
      ( vx va vb wcel co cv wral w3a cbs cfv wss c0 wne eqid islss simp3bi wceq
      oveq1 oveq1d eleq1d oveq2 rspc3v mpan9 ) ECSZPUAZQUAZDTZRUAZBTZESZREUBQEU
      BPAUBZJASHESIESUCJHDTZIBTZESZUSEGUDUEZUFEUGUHVFPABCDEFVJGQRKLVJUIMNOUJUKV
      EVIJVADTZVCBTZESVGVCBTZESPQRJHIAEEUTJULZVDVLEVNVBVKVCBUTJVADUMUNUOVAHULZV
      LVMEVOVKVGVCBVAHJDUPUNUOVCIULVMVHEVCIVGBUPUOUQUR $.
  $}

  ${
    lssvsubcl.m $e |- .- = ( -g ` W ) $.
    lssvsubcl.s $e |- S = ( LSubSp ` W ) $.
    $( Closure of vector subtraction in a subspace.  (Contributed by NM,
       31-Mar-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lssvsubcl $p |- ( ( ( W e. LMod /\ U e. S )
          /\ ( X e. U /\ Y e. U ) ) -> ( X .- Y ) e. U ) $=
      ( clmod wcel wa co cfv cbs wceq eqid lssel syl3anc syl eqeltrd csca cvsca
      cur cminusg cplusg ad2ant2lr ad2ant2l lmodvsubval2 cgrp lmodfgrp grpinvcl
      simpll lmod1cl syl2anc lmodvscl lmodcom simplr simprr simprl syl13anc
      lsscl ) DIJZBAJZKZEBJZFBJZKZKZEFCLZEDUAMZUCMZVJUDMZMZFDUBMZLZDUEMZLZBVHVB
      EDNMZJZFVRJZVIVQOVBVCVGULZVCVEVSVBVFABVRDEVRPZHQUFZVCVFVTVBVEABVRDFWBHQUG
      ZEFVPVNVKVJCVLVRDWBVPPZGVJPZVNPZVLPZVKPZUHRVHVQVOEVPLZBVHVBVSVOVRJZVQWJOW
      AWCVHVBVMVJNMZJZVTWKWAVHVJUIJZVKWLJZWMVHVBWNWAVJDWFUJSVHVBWOWAVKVJWLDWFWL
      PZWIUMSWLVJVLVKWPWHUKUNZWDVMVNVJWLVRDFWBWFWGWPUORVPVRDEVOWBWEUPRVHVCWMVFV
      EWJBJVBVCVGUQWQVDVEVFURVDVEVFUSWLVPAVNBVJDFEVMWFWPWEWGHVAUTTT $.
  $}

  ${
    lssvancl.v $e |- V = ( Base ` W ) $.
    lssvancl.p $e |- .+ = ( +g ` W ) $.
    lssvancl.s $e |- S = ( LSubSp ` W ) $.
    lssvancl.w $e |- ( ph -> W e. LMod ) $.
    lssvancl.u $e |- ( ph -> U e. S ) $.
    lssvancl.x $e |- ( ph -> X e. U ) $.
    lssvancl.y $e |- ( ph -> Y e. V ) $.
    lssvancl.n $e |- ( ph -> -. Y e. U ) $.
    $( Non-closure: if one vector belongs to a subspace but another does not,
       their sum does not belong.  Useful for obtaining a new vector not in a
       subspace.  TODO: notice similarity to ~ lspindp3 .  Can it be used along
       with ~ lspsnne1 , ~ lspsnne2 to shorten this proof?  (Contributed by NM,
       14-May-2015.) $)
    lssvancl1 $p |- ( ph -> -. ( X .+ Y ) e. U ) $=
      ( co wcel wa adantr csg cfv wceq cabel clmod lmodabl lssel eqid ablpncan2
      syl syl2anc syl3anc simpr lssvsubcl syl22anc eqeltrrd mtand ) AGHBQZDRZHD
      RPAUSSZURGFUAUBZQZHDAVBHUCZUSAFUDRZGERZHERVCAFUERZVDLFUFUJADCRZGDRZVEMNCD
      EFGIKUGUKOEBFVAGHIJVAUHZUIULTUTVFVGUSVHVBDRAVFUSLTAVGUSMTAUSUMAVHUSNTCDVA
      FURGVIKUNUOUPUQ $.

    $( Non-closure: if one vector belongs to a subspace but another does not,
       their sum does not belong.  Useful for obtaining a new vector not in a
       subspace.  (Contributed by NM, 20-May-2015.) $)
    lssvancl2 $p |- ( ph -> -. ( Y .+ X ) e. U ) $=
      ( co clmod wcel wceq lssel syl2anc lmodcom syl3anc lssvancl1 eqneltrrd )
      AGHBQZHGBQZDAFRSGESZHESUGUHTLADCSGDSUIMNCDEFGIKUAUBOBEFGHIJUCUDABCDEFGHIJ
      KLMNOPUEUF $.
  $}

  ${
    $d x S $.  $d x U $.  $d a b x W $.  $d y X $.  $d a b x y .0. $.
    lss0cl.z $e |- .0. = ( 0g ` W ) $.
    lss0cl.s $e |- S = ( LSubSp ` W ) $.
    $( The zero vector belongs to every subspace.  (Contributed by NM,
       12-Jan-2014.)  (Proof shortened by Mario Carneiro, 19-Jun-2014.) $)
    lss0cl $p |- ( ( W e. LMod /\ U e. S ) -> .0. e. U ) $=
      ( vx clmod wcel wa cv wex c0 wne lssn0 n0 sylib adantl cfv eqid w3a simp1
      csg co cbs wceq lssel 3adant1 lmodsubid lssvsubcl anabsan2 3impa eqeltrrd
      syl2anc 3expia exlimdv mpd ) CHIZBAIZJZGKZBIZGLZDBIZUSVCURUSBMNVCABCFOGBP
      QRUTVBVDGURUSVBVDURUSVBUAZVAVACUCSZUDZDBVEURVACUESZIZVGDUFURUSVBUBUSVBVIU
      RABVHCVAVHTZFUGUHVAVFVHCDVJEVFTZUIUNURUSVBVGBIZUTVBVLABVFCVAVAVKFUJUKULUM
      UOUPUQ $.

    $( The singleton of the zero vector is a subspace.  (Contributed by NM,
       13-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lsssn0 $p |- ( W e. LMod -> { .0. } e. S ) $=
      ( vx va vb wcel cfv cbs eqidd wceq a1i eqid c0g cv co elsni syl clmod csn
      csca cplusg cvsca clss lmod0vcl snssd c0 wne cvv fvex eqeltri snnz w3a wa
      simpr2 oveq2d lmodvs0 3ad2antr1 eqtrd simpr3 oveq12d lmod0vlid mpdan ovex
      adantr elsnc sylibr islssd ) BUAIZFBUCJZKJZBUDJZABUEJZCUBZVLBKJZBGHVKVLLV
      KVMLVKVQLVKVNLVKVOLABUFJMVKENVKCVQVQBCVQOZDUGZUHVPUIUJVKCCBPJUKDBPULUMUNN
      VKFQZVMIZGQZVPIZHQZVPIZUOZUPZVTWBVORZWDVNRZCMWIVPIWGWICCVNRZCWGWHCWDCVNWG
      WHVTCVORZCWGWBCVTVOWGWCWBCMVKWAWCWEUQWBCSTURVKWCWAWKCMWEVOVLVMBVTCVLOVOOV
      MODUSUTVAWGWEWDCMVKWAWCWEVBWDCSTVCVKWJCMZWFVKCVQIWLVSVNVQBCCVRVNODVDVEVGV
      AWICWHWDVNVFVHVIVJ $.

    $( The zero subspace is included in every subspace.  ( ~ sh0le analog.)
       (Contributed by NM, 27-Mar-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lss0ss $p |- ( ( W e. LMod /\ X e. S ) -> { .0. } C_ X ) $=
      ( clmod wcel wa lss0cl snssd ) BGHCAHIDCACBDEFJK $.

    $( No subspace is smaller than the zero subspace.  ( ~ shle0 analog.)
       (Contributed by NM, 20-Apr-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lssle0 $p |- ( ( W e. LMod /\ X e. S )
         -> ( X C_ { .0. } <-> X = { .0. } ) ) $=
      ( clmod wcel wa csn wss wceq lss0ss biantrud eqss syl6bbr ) BGHCAHIZCDJZK
      ZSRCKZICRLQTSABCDEFMNCROP $.

    $( A nonzero subspace has a nonzero vector.  ( ~ shne0i analog.)
       (Contributed by NM, 20-Apr-2014.)  (Proof shortened by Mario Carneiro,
       8-Jan-2015.) $)
    lssne0 $p |- ( X e. S -> ( X =/= { .0. } <-> E. y e. X y =/= .0. ) ) $=
      ( wcel cv wne wrex csn wceq wral wn c0 wb lssn0 eqsn syl ralbii syl6rbb
      nne ralnex bitr3i necon1abid ) DBHZAIZEJZADKZDELZUGDUKMZUHEMZADNZUJOZUGDP
      JULUNQBDCGRADESTUNUIOZADNUOUPUMADUHEUCUAUIADUDUEUBUF $.
  $}

  ${
    lssneln0.v $e |- V = ( Base ` W ) $.
    lssneln0.o $e |- .0. = ( 0g ` W ) $.
    lssneln0.s $e |- S = ( LSubSp ` W ) $.
    lssneln0.w $e |- ( ph -> W e. LMod ) $.
    lssneln0.u $e |- ( ph -> U e. S ) $.
    lssneln0.x $e |- ( ph -> X e. V ) $.
    lssneln0.n $e |- ( ph -> -. X e. U ) $.
    $( A vector which doesn't belong to a subspace is nonzero.  (Contributed by
       NM, 14-May-2015.) $)
    lssneln0 $p |- ( ph -> X e. ( V \ { .0. } ) ) $=
      ( wcel wne csn cdif wn wceq wi lss0cl syl2anc eleq1a syl necon3bd eldifsn
      clmod mpd sylanbrc ) AFDOFGPZFDGQROMAFCOZSUKNAULFGAGCOZFGTULUAAEUHOCBOUMK
      LBCEGIJUBUCGCFUDUEUFUIFDGUGUJ $.
  $}

  ${
    $d x T $.  $d x U $.  $d x ph $.
    lssssr.v $e |- V = ( Base ` W ) $.
    lssssr.o $e |- .0. = ( 0g ` W ) $.
    lssssr.s $e |- S = ( LSubSp ` W ) $.
    lssssr.w $e |- ( ph -> W e. LMod ) $.
    lssssr.t $e |- ( ph -> T C_ V ) $.
    lssssr.u $e |- ( ph -> U e. S ) $.
    lssssr.1 $e |- ( ( ph /\ x e. ( V \ { .0. } ) ) ->
      ( x e. T -> x e. U ) ) $.
    $( Conclude subspace ordering from nonzero vector membership.  ( ~ ssrdv
       analog.)  (Contributed by NM, 17-Aug-2014.) $)
    lssssr $p |- ( ph -> T C_ U ) $=
      ( cv wcel wi wa adantr simpr clmod lss0cl syl2anc eqeltrd a1d sseld ancrd
      wceq wne cdif eldifsn sylan2br exp32 com23 imp4b syld pm2.61dane ssrdv
      csn ) ABDEABPZDQZVAEQZRZVAHAVAHUIZSZVCVBVFVAHEAVEUAAHEQZVEAGUBQECQVGLNCEG
      HJKUCUDTUEUFAVAHUJZSVBVAFQZVBSZVCAVBVJRVHAVBVIADFVAMUGUHTAVHVIVBVCAVIVHVD
      AVIVHVDVIVHSAVAFHUTUKQVDVAFHULOUMUNUOUPUQURUS $.
  $}

  ${
    lssvacl.p $e |- .+ = ( +g ` W ) $.
    lssvacl.s $e |- S = ( LSubSp ` W ) $.
    $( Closure of vector addition in a subspace.  (Contributed by NM,
       11-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lssvacl $p |- ( ( ( W e. LMod /\ U e. S ) /\ ( X e. U /\ Y e. U ) )
       -> ( X .+ Y ) e. U ) $=
      ( clmod wcel wa csca cfv cur cvsca co cbs wceq simpll eqid lmodvs1 oveq1d
      ad2ant2lr syl2anc simplr lmod1cl ad2antrr simprl simprr syl13anc eqeltrrd
      lssel lsscl ) DIJZCBJZKZECJZFCJZKZKZDLMZNMZEDOMZPZFAPZEFAPCUTVDEFAUTUNEDQ
      MZJZVDERUNUOUSSUOUQVGUNURBCVFDEVFTZHULUCVCVBVAVFDEVHVATZVCTZVBTZUAUDUBUTU
      OVBVAQMZJZUQURVECJUNUOUSUEUNVMUOUSVBVAVLDVIVLTZVKUFUGUPUQURUHUPUQURUIVLAB
      VCCVADEFVBVIVNGVJHUMUJUK $.
  $}

  ${
    lssvscl.f $e |- F = ( Scalar ` W ) $.
    lssvscl.t $e |- .x. = ( .s ` W ) $.
    lssvscl.b $e |- B = ( Base ` F ) $.
    lssvscl.s $e |- S = ( LSubSp ` W ) $.
    $( Closure of scalar product in a subspace.  (Contributed by NM,
       11-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lssvscl $p |- ( ( ( W e. LMod /\ U e. S ) /\ ( X e. B /\ Y e. U ) )
       -> ( X .x. Y ) e. U ) $=
      ( clmod wcel wa co c0g cfv cplusg eqid cbs simpll lssel ad2ant2l lmodvscl
      wceq simprl syl3anc lmod0vrid syl2anc simplr simprr lss0cl lsscl syl13anc
      adantr eqeltrrd ) FMNZDBNZOZGANZHDNZOZOZGHCPZFQRZFSRZPZVEDVDURVEFUARZNZVH
      VEUFURUSVCUBZVDURVAHVINZVJVKUTVAVBUGZUSVBVLURVABDVIFHVITZLUCUDGCEAVIFHVNI
      JKUEUHVGVIFVEVFVNVGTZVFTZUIUJVDUSVAVBVFDNZVHDNURUSVCUKVMUTVAVBULUTVQVCBDF
      VFVPLUMUPAVGBCDEFHVFGIKVOJLUNUOUQ $.
  $}

  ${
    lssvnegcl.s $e |- S = ( LSubSp ` W ) $.
    lssvnegcl.n $e |- N = ( invg ` W ) $.
    $( Closure of negative vectors in a subspace.  (Contributed by Stefan
       O'Rear, 11-Dec-2014.) $)
    lssvnegcl $p |- ( ( W e. LMod /\ U e. S /\ X e. U ) -> ( N ` X ) e. U ) $=
      ( clmod wcel w3a csca cfv cur cminusg cvsca co wceq cbs eqid syl wa lssel
      lmodvneg1 sylan2 3impb simp1 simp2 cgrp lmodrng 3ad2ant1 rngidcl grpinvcl
      crg rnggrp syl2anc simp3 lssvscl syl22anc eqeltrrd ) DHIZBAIZEBIZJZDKLZML
      ZVDNLZLZEDOLZPZECLZBUTVAVBVIVJQZVAVBUAUTEDRLZIVKABVLDEVLSZFUBVHVEVDVFCVLD
      EVMGVDSZVHSZVESZVFSZUCUDUEVCUTVAVGVDRLZIZVBVIBIUTVAVBUFUTVAVBUGVCVDUHIZVE
      VRIZVSVCVDUMIZVTUTVAWBVBVDDVNUIUJZVDUNTVCWBWAWCVRVDVEVRSZVPUKTVRVDVFVEWDV
      QULUOUTVAVBUPVRAVHBVDDVGEVNVOWDFUQURUS $.
  $}

  ${
    $d x y S $.  $d x y U $.  $d x y W $.
    lsssubg.s $e |- S = ( LSubSp ` W ) $.
    $( All subspaces are subgroups.  (Contributed by Stefan O'Rear,
       11-Dec-2014.) $)
    lsssubg $p |- ( ( W e. LMod /\ U e. S ) -> U e. ( SubGrp ` W ) ) $=
      ( vx vy clmod wcel wa csubg cfv cbs wss c0 wne wral eqid adantl ralrimiva
      cv cplusg co cminusg lssss lssn0 lssvacl anassrs lssvnegcl 3expa jca cgrp
      w3a wb lmodgrp adantr issubg2 syl mpbir3and ) CGHZBAHZIZBCJKHZBCLKZMZBNOZ
      ETZFTZCUAKZUBBHZFBPZVFCUCKZKBHZIZEBPZUTVDUSABVCCVCQZDUDRUTVEUSABCDUERVAVM
      EBVAVFBHZIZVJVLVQVIFBVAVPVGBHVIVHABCVFVGVHQZDUFUGSUSUTVPVLABVKCVFDVKQZUHU
      IUJSVACUKHZVBVDVEVNULUMUSVTUTCUNUOEFVCVHBCVKVOVRVSUPUQUR $.

    $( All subspaces are subgroups.  (Contributed by Mario Carneiro,
       19-Apr-2016.) $)
    lsssssubg $p |- ( W e. LMod -> S C_ ( SubGrp ` W ) ) $=
      ( vx clmod wcel csubg cfv cv lsssubg ex ssrdv ) BEFZDABGHZMDIZAFONFAOBCJK
      L $.
  $}

  ${
    $d a b x S $.  $d a b x U $.  $d a b x V $.  $d a b x W $.  $d a b x X $.
    islss3.x $e |- X = ( W |`s U ) $.
    islss3.v $e |- V = ( Base ` W ) $.
    islss3.s $e |- S = ( LSubSp ` W ) $.
    $( A linear subspace of a module is a subset which is a module in its own
       right.  (Contributed by Stefan O'Rear, 6-Dec-2014.)  (Revised by Mario
       Carneiro, 30-Apr-2015.) $)
    islss3 $p |- ( W e. LMod -> ( U e. S <-> ( U C_ V /\ X e. LMod ) ) ) $=
      ( vx wcel wa adantl cfv cbs wceq eqid eqidd syl co cvv va clmod wss lssss
      vb csca cplusg cvsca cmulr cur ressbas2 sylan2 ressplusg resssca ressvsca
      crg lmodrng adantr csubg cgrp lsssubg subggrp cv lssvscl 3impb w3a simpll
      simpr1 ad2antlr simpr2 sseldd simpr3 lmodvsdi lmodvsdir lmodvsass lmodvs1
      syl13anc sselda adantlr syldan islmodd simprl fvex syl6eqel clss eqsstr3d
      jca eqcomd a1i c0 lmodgrp ad2antll grpbn0 lss1 lsscl sylan islssd eqeltrd
      wne impbida ) DUBJZBAJZBCUCZEUBJZKZXAXBKZXCXDXBXCXAABCDGHUDZLZXFIUAUEDUFM
      ZNMZDUGMZXIUGMZDUHMZXIUIMZXIUJMZXIBEXBXAXCBENMZOZXGXCXQXABCEDFGUKZLULXBXK
      EUGMZOZXABXKDEAFXKPZUMLXBXIEUFMZOZXABXIDEAFXIPZUNLXBXMEUHMZOZXABXMDEAFXMP
      ZUOLXFXJQXFXLQXFXNQXFXOQXAXIUPJXBXIDYDUQURXFBDUSMJEUTJZABDHVABDEFVBRXFIVC
      ZXJJZUAVCZBJZYIYKXMSZBJXJAXMBXIDYIYKYDYGXJPZHVDVEXFYJYLUEVCZBJZVFZKZXAYJY
      KCJYOCJZYIYKYOXKSXMSYMYIYOXMSZXKSOXAXBYQVGXFYJYLYPVHYRBCYKXBXCXAYQXGVIZXF
      YJYLYPVJVKYRBCYOUUAXFYJYLYPVLVKXKYIXMXIXJCDYKYOGYAYDYGYNVMVQXFYJYKXJJZYPV
      FZKZXAYJUUBYSYIYKXLSYOXMSYTYKYOXMSZXKSOXAXBUUCVGZXFYJUUBYPVHZXFYJUUBYPVJZ
      UUDBCYOXBXCXAUUCXGVIXFYJUUBYPVLVKZXKXLYIYKXMXIXJCDYOGYAYDYGYNXLPVNVQUUDXA
      YJUUBYSYIYKXNSYOXMSYIUUEXMSOUUFUUGUUHUUIYIYKXMXNXIXJCDYOGYDYGYNXNPVOVQXFY
      IBJYICJZXOYIXMSYIOZXFBCYIXHVRXAUUJUUKXBXMXOXICDYIGYDYGXOPVPVSVTWAWGXAXEKZ
      BXPAUULXCXQXAXCXDWBZXRRZUULIYBNMZXSAYEXPYBCDUAUEUULXIYBUULBTJZYCUULBXPTUU
      NENWCWDZBXIDETFYDUNRWHUULUUOQCDNMOUULGWIUULXKXSUULUUPXTUUQBXKDETFYAUMRWHU
      ULXMYEUULUUPYFUUQBXMDETFYGUORWHADWEMOUULHWIUULXPBCUUNUUMWFUULYHXPWJWSXDYH
      XAXCEWKWLXPEXPPZWMRUULXPEWEMZJZYIUUOJYKXPJYOXPJVFYIYKYESYOXSSXPJXDUUTXAXC
      UUSXPEUURUUSPZWNWLUUOXSUUSYEXPYBEYKYOYIYBPUUOPXSPYEPUVAWOWPWQWRWT $.
  $}

  ${
    lsslss.x $e |- X = ( W |`s U ) $.
    lsslss.s $e |- S = ( LSubSp ` W ) $.
    $( A submodule is a module.  (Contributed by Stefan O'Rear,
       12-Dec-2014.) $)
    lsslmod $p |- ( ( W e. LMod /\ U e. S ) -> X e. LMod ) $=
      ( clmod wcel cbs cfv wss eqid islss3 simplbda ) CGHBAHBCIJZKDGHABOCDEOLFM
      N $.

    lsslss.t $e |- T = ( LSubSp ` X ) $.
    $( The subspaces of a subspace are the smaller subspaces.  (Contributed by
       Stefan O'Rear, 12-Dec-2014.) $)
    lsslss $p |- ( ( W e. LMod /\ U e. S ) ->
      ( V e. T <-> ( V e. S /\ V C_ U ) ) ) $=
      ( clmod wcel wa cbs cfv wss cress co wb eqid islss3 syl wceq lssss adantl
      lsslmod sseq2d anbi1d sstr2 mpan9 biantrurd oveq1i ressabs adantll syl5eq
      ressbas2 eleq1d ad2antrr 3bitr4d pm5.32da ancom syl6bb 3bitr2d ) EJKZCAKZ
      LZDBKZDFMNZOZFDPQZJKZLZDCOZVJLZDAKZVLLZVEFJKVFVKRACEFGHUEBDVGFVIVISVGSITU
      AVEVLVHVJVECVGDVECEMNZOZCVGUBVDVQVCACVPEVPSZHUCUDZCVPFEGVRUOUAUFUGVEVMVLV
      NLVOVEVLVJVNVEVLLZEDPQZJKZDVPOZWBLZVJVNVTWCWBVEVQVLWCVSDCVPUHUIUJVTVIWAJV
      TVIECPQZDPQZWAFWEDPGUKVDVLWFWAUBVCCDEAULUMUNUPVCVNWDRVDVLADVPEWAWASVRHTUQ
      URUSVLVNUTVAVB $.
  $}

  ${
    $d F a b c $.  $d W a b c $.  $d B a b c $.  $d V a b c $.  $d .x. a b c $.
    $d S a b c $.  $d G a b c $.  $d U a b c $.
    islss4.f $e |- F = ( Scalar ` W ) $.
    islss4.b $e |- B = ( Base ` F ) $.
    islss4.v $e |- V = ( Base ` W ) $.
    islss4.t $e |- .x. = ( .s ` W ) $.
    islss4.s $e |- S = ( LSubSp ` W ) $.
    $( A linear subspace is a subgroup which respects scalar multiplication.
       (Contributed by Stefan O'Rear, 11-Dec-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2016.) $)
    islss4 $p |- ( W e. LMod -> ( U e. S <-> ( U e. ( SubGrp ` W ) /\
          A. a e. B A. b e. U ( a .x. b ) e. U ) ) ) $=
      ( vc wcel cfv cv wral wa clmod csubg co lsssubg lssvscl ralrimivva jca c0
      wss wne cplusg subgss ad2antrl c0g eqid subg0cl ne0i syl wi subgcl adantl
      3exp ralrimdv ralimdv impr islss syl3anbrc impbida ) GUAPZDBPZDGUBQPZHRZI
      RZCUCZDPZIDSZHASZTZVIVJTZVKVQBDGNUDVSVOHIADABCDEGVLVMJMKNUEUFUGVIVRTDFUIZ
      DUHUJZVNORZGUKQZUCDPZODSZIDSZHASZVJVKVTVIVQFDGLULUMVKWAVIVQVKGUNQZDPWADGW
      HWHUOUPDWHUQURUMVIVKVQWGVIVKTZVPWFHAWIVOWEIDWIVOWDODVKVOWBDPZWDUSUSVIVKVO
      WJWDWCDGVNWBWCUOZUTVBVAVCVDVDVEHAWCBCDEFGIOJKLWKMNVFVGVH $.
  $}

  ${
    $d a b k v x y z K $.  $d a b k v x y z .x. $.  $d a b k v x y z V $.
    $d k x F $.  $d a b k v x y z W $.  $d a b k v x y z X $.
    lss1d.v $e |- V = ( Base ` W ) $.
    lss1d.f $e |- F = ( Scalar ` W ) $.
    lss1d.t $e |- .x. = ( .s ` W ) $.
    lss1d.k $e |- K = ( Base ` F ) $.
    lss1d.s $e |- S = ( LSubSp ` W ) $.
    $( One-dimensional subspace (or zero-dimensional if ` X ` is the zero
       vector).  (Contributed by NM, 14-Jan-2014.)  (Proof shortened by Mario
       Carneiro, 19-Jun-2014.) $)
    lss1d $p |- ( ( W e. LMod /\ X e. V )
        -> { v | E. k e. K v = ( k .x. X ) } e. S ) $=
      ( wcel wa cfv co wceq wrex vx va vb vy vz clmod cplusg cab csca a1i eqidd
      cv cbs cvsca clss wi lmodvscl 3expa an32s eleq1a syl rexlimdva abssdv c0g
      c0 wne eqid lmod0cl nfcv nfre1 nfab nfne biidd ovex elabrex ne0i vtoclgaf
      adantr w3a eqeq1 rexbidv oveq1 eqeq2d cbvrexv bitri anbi12i reeanv bitr4i
      vex cmulr simpll simprr simprll lmodmcl syl3anc simprlr lmodacl lmodvsdir
      simplr syl13anc lmodvsass oveq1d eqtr2d rspcev syl2anc oveq2 oveq12 sylan
      eqeq1d syl5ibrcom com23 rexlimdvva syl5bi exp3acom23 com24 sylibr islssd
      elab expr 3imp2 ) HUFOZIGOZPZUAFHUGQZBCAULZDULZICRZSZDFTZAUHZEGHUBUCEHUIQ
      SYCKUJFEUMQSYCMUJGHUMQSYCJUJYCYDUKCHUNQSYCLUJBHUOQSYCNUJYCYIAGYCYHYEGOZDF
      YCYFFOZPYGGOZYHYKUPYAYLYBYMYAYLYBYMYFCEFGHIJKLMUQURUSYGGYEUTVAVBVCYCEVDQZ
      FOZYJVEVFZYAYOYBEFHYNKMYNVGVHVRYPYPDYNFDYNVIDYJVEYIDAYHDFVJVKDVEVIVLYFYNS
      YPVMYLYGYJOYPDAFYGYFICVNVOYJYGVPVAVQVAYCUAULZFOZUBULZYJOZUCULZYJOZVSPYQYS
      CRZUUAYDRZYGSZDFTZUUDYJOYCYRYTUUBUUFYCUUBYTYRUUFYCYTUUBYRUUFUPZYTUUBPZYSU
      DULZICRZSZUUAUEULZICRZSZPZUEFTUDFTZYCUUGUUHUUKUDFTZUUNUEFTZPUUPYTUUQUUBUU
      RYTYSYGSZDFTZUUQYIUUTAYSUBWIYEYSSYHUUSDFYEYSYGVTWAXRUUSUUKDUDFYFUUISYGUUJ
      YSYFUUIICWBWCWDWEUUBUUAYGSZDFTZUURYIUVBAUUAUCWIYEUUASYHUVADFYEUUAYGVTWAXR
      UVAUUNDUEFYFUULSYGUUMUUAYFUULICWBWCWDWEWFUUKUUNUDUEFFWGWHYCUUOUUGUDUEFFYC
      UUIFOZUULFOZPZPYRUUOUUFYCUVEYRUUOUUFUPYCUVEYRPZPZUUFUUOYQUUJCRZUUMYDRZYGS
      ZDFTZUVGYQUUIEWJQZRZUULEUGQZRZFOZUVIUVOICRZSZUVKUVGYAUVMFOZUVDUVPYAYBUVFW
      KZUVGYAYRUVCUVSUVTYCUVEYRWLZYCUVCUVDYRWMZUVLEFHYQUUIKMUVLVGZWNWOZYCUVCUVD
      YRWPZUVNEFHUVMUULKMUVNVGZWQWOUVGUVQUVMICRZUUMYDRZUVIUVGYAUVSUVDYBUVQUWHSU
      VTUWDUWEYAYBUVFWSZYDUVNUVMUULCEFGHIJYDVGKLMUWFWRWTUVGUWGUVHUUMYDUVGYAYRUV
      CYBUWGUVHSUVTUWAUWBUWIYQUUICUVLEFGHIJKLMUWCXAWTXBXCUVJUVRDUVOFYFUVOSYGUVQ
      UVIYFUVOICWBWCXDXEUUOUUEUVJDFUUOUUDUVIYGUUKUUCUVHSUUNUUDUVISYSUUJYQCXFUUC
      UVHUUAUUMYDXGXHXIWAXJXSXKXLXMXNXOXTYIUUFAUUDUUCUUAYDVNYEUUDSYHUUEDFYEUUDY
      GVTWAXRXPXQ $.
  $}

  ${
    $d a b x y A $.  $d a b x y S $.  $d a b x y W $.
    lssintcl.s $e |- S = ( LSubSp ` W ) $.
    $( The intersection of a nonempty set of subspaces is a subspace.
       (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lssintcl $p |- ( ( W e. LMod /\ A C_ S /\ A =/= (/) )
          -> |^| A e. S ) $=
      ( vx va vb vy wcel wss c0 wne w3a cfv cbs eqidd cv eqid sylibr wa 3adant1
      clmod csca cplusg cvsca cint clss wceq a1i cuni intssuni2 cpw lssss ssriv
      vex elpw sspwuni mpbi syl6ss simpl1 simp2 sselda lss0cl syl2anc ralrimiva
      c0g wral fvex elint2 ne0i co adantlr simplr1 simplr2 simpr elinti simplr3
      syl sylc lsscl syl13anc ovex islssd ) CUBIZABJZAKLZMZECUCNZONZCUDNZBCUENZ
      AUFZWHCONZCFGWGWHPWGWIPWGWMPWGWJPWGWKPBCUGNUHWGDUIWGWLBUJZWMWEWFWLWNJWDAB
      UKUABWMULZJWNWMJHBWOHQZBIZWPWMJWPWOIBWPWMCWMRDUMWPWMHUOUPSUNBWMUQURUSWGCV
      FNZWLIZWLKLWGWRWPIZHAVGWSWGWTHAWGWPAIZTWDWQWTWDWEWFXAUTWGABWPWDWEWFVAVBZB
      WPCWRWRRDVCVDVEHWRACVFVHVISWLWRVJVRWGEQZWIIZFQZWLIZGQZWLIZMZTZXCXEWKVKZXG
      WJVKZWPIZHAVGXLWLIXJXMHAXJXATZWQXDXEWPIZXGWPIZXMWGXAWQXIXBVLXDXFXHWGXAVMX
      NXFXAXOXDXFXHWGXAVNXJXAVOZXEAWPVPVSXNXHXAXPXDXFXHWGXAVQXQXGAWPVPVSWIWJBWK
      WPWHCXEXGXCWHRWIRWJRWKRDVTWAVEHXLAXKXGWJWBVISWC $.

    $( The intersection of two subspaces is a subspace.  (Contributed by NM,
       7-Mar-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lssincl $p |- ( ( W e. LMod /\ T e. S /\ U e. S )
         -> ( T i^i U ) e. S ) $=
      ( clmod wcel w3a cpr cint cin intprg 3adant1 wss c0 wne simp1 prssi prnzg
      wceq 3ad2ant2 lssintcl syl3anc eqeltrrd ) DFGZBAGZCAGZHZBCIZJZBCKZAUFUGUJ
      UKTUEBCAALMUHUEUIANZUIOPZUJAGUEUFUGQUFUGULUEBCARMUFUEUMUGBCASUAUIADEUBUCU
      D $.
  $}

  ${
    $d B a b x y $.  $d S a x y $.  $d W a b x y $.
    lssacs.b $e |- B = ( Base ` W ) $.
    lssacs.s $e |- S = ( LSubSp ` W ) $.
    $( The subspaces of a module comprise a Moore system on the vectors of the
       module.  (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    lssmre $p |- ( W e. LMod -> S e. ( Moore ` B ) ) $=
      ( va clmod wcel cpw cv wss lssss vex elpw sylibr a1i ssrdv lss1 lssintcl
      wi ismred ) CGHZBAFUBFBAIZFJZBHZUDUCHZTUBUEUDAKUFBUDACDELUDAFMNOPQBACDERU
      DBCESUA $.

    $( Submodules are an algebraic closure system.  (Contributed by Stefan
       O'Rear, 4-Apr-2015.) $)
    lssacs $p |- ( W e. LMod -> S e. ( ACS ` B ) ) $=
      ( vx vy vb va wcel cfv cv wral cbs wi a1i wb wa eqid cvv clmod csubg csca
      cvsca cpw crab cin cacs wss lssss inss2 ssrab2 sstri elpwid islss4 adantr
      co sseli vex elpw weq eleq2 raleqbi1dv elrab3 sylbir adantl anbi2d bitr4d
      ralbidv elin syl6bbr pm5.21ndd cmre fvex eqeltri mreacs mp1i cgrp lmodgrp
      eqrdv subgacs lmodvscl ralrimivva acsfn1c sylancr mreincl syl3anc eqeltrd
      ex syl 3expb ) CUAJZBCUBKZFLZGLZCUDKZUQZHLZJZGWRMZFCUCKZNKZMZHAUEZUFZUGZA
      UHKZWLIBXFWLILZAUIZXHBJZXHXFJZXJXIOWLBXHACDEUJPXKXIOWLXKXHAXFXDXHXFXEXDWM
      XEUKXCHXDULUMURUNPWLXIXJXKQWLXIRZXJXHWMJZXHXEJZRZXKXLXJXMWQXHJZGXHMZFXBMZ
      RZXOWLXJXSQXIXBBWPXHXAACFGXASZXBSZDWPSZEUOUPXLXNXRXMXIXNXRQZWLXIXHXDJYCXH
      AIUSUTXCXRHXHXDHIVAWTXQFXBWSXPGWRXHWRXHWQVBVCVIVDVEVFVGVHXHWMXEVJVKWIVLVT
      WLXGXDVMKJZWMXGJZXEXGJZXFXGJATJZYDWLACNKTDCNVNVOZTAVPVQWLCVRJYECVSACDWAWJ
      WLYGWQAJZGAMFXBMYFYHWLYIFGXBAWLWNXBJWOAJYIWNWPXAXBACWODXTYBYAWBWKWCWQXBTA
      HFGWDWEWMXEXGXDWFWGWH $.
  $}

  ${
    $d x B $.  $d x F $.  $d x G $.  $d x I $.  $d x K $.  $d x R $.  $d x S $.
    $d x ph $.  $d x T $.  $d x W $.  $d x Y $.
    prdsvscacl.y $e |- Y = ( S Xs_ R ) $.
    prdsvscacl.b $e |- B = ( Base ` Y ) $.
    prdsvscacl.t $e |- .x. = ( .s ` Y ) $.
    prdsvscacl.k $e |- K = ( Base ` S ) $.
    prdsvscacl.s $e |- ( ph -> S e. Ring ) $.
    prdsvscacl.i $e |- ( ph -> I e. W ) $.
    prdsvscacl.r $e |- ( ph -> R : I --> LMod ) $.
    prdsvscacl.f $e |- ( ph -> F e. K ) $.
    prdsvscacl.g $e |- ( ph -> G e. B ) $.
    prdsvscacl.sr $e |- ( ( ph /\ x e. I ) -> ( Scalar ` ( R ` x ) ) = S ) $.
    $( Pointwise scalar multiplication is closed in products of modules.
       (Contributed by Stefan O'Rear, 10-Jan-2015.) $)
    prdsvscacl $p |- ( ph -> ( F .x. G ) e. B ) $=
      ( co cv cfv cvsca cmpt crg clmod wf wfn ffn syl prdsvscaval wcel cbs wral
      wa csca ffvelrnda adantr fveq2d syl6eqr eleqtrrd prdsbasprj eqid lmodvscl
      simpr syl3anc ralrimiva prdsbasmpt mpbird eqeltrd ) AGHFUCBIGBUDZHUEZVNDU
      EZUFUEZUCZUGZCABCDEFGHIJUHKLMNOPQRAIUIDUJDIUKZSIUIDULUMZTUAUNAVSCUOVRVPUP
      UEZUOZBIUQAWCBIAVNIUOZURZVPUIUOGVPUSUEZUPUEZUOVOWBUOWCAIUIVNDSUTWEGJWGAGJ
      UOWDTVAWEWGEUPUEJWEWFEUPUBVBPVCVDWECDEHIVNUHKLMNAEUHUOWDQVAAIKUOWDRVAAVTW
      DWAVAAHCUOWDUAVAAWDVHVEGVQWFWGWBVPVOWBVFWFVFVQVFWGVFVGVIVJABCDEVRIUHKLMNQ
      RWAVKVLVM $.
  $}

  ${
    $d y I $.  $d a b c y ph $.  $d y R $.  $d a b c y S $.  $d a b c y Y $.
    prdslmodd.y $e |- Y = ( S Xs_ R ) $.
    prdslmodd.s $e |- ( ph -> S e. Ring ) $.
    prdslmodd.i $e |- ( ph -> I e. V ) $.
    prdslmodd.rm $e |- ( ph -> R : I --> LMod ) $.
    prdslmodd.rs $e |- ( ( ph /\ y e. I ) -> ( Scalar ` ( R ` y ) ) = S ) $.
    $( The product of a family of left modules is a left module.  (Contributed
       by Stefan O'Rear, 10-Jan-2015.) $)
    prdslmodd $p |- ( ph -> Y e. LMod ) $=
      ( cfv crg cvv wcel co wa eqid adantr va vb vc cbs cvsca cmulr eqidd clmod
      cplusg cur wf fex syl2anc prdssca cgrp wss lmodgrp ssriv sylancl prdsgrpd
      cv fss elex syl simprl simprr csca wceq adantlr prdsvscacl 3impb w3a cmpt
      ffvelrnda simplr1 fveq2d eleqtrrd ad2antrr wfn simplr2 prdsbasprj simplr3
      simpr lmodvsdi syl13anc prdsplusgfval oveq2d prdsvscafval oveq12d 3eqtr4d
      ffn mpteq2dva simpr1 simpr2 simpr3 grpcl syl3anc prdsvscaval prdsplusgval
      3adantr3 3adantr2 lmodvsdir oveqd oveq1d 3eqtr2rd rngacl lmodvsass simplr
      rngcl lmodvs1 eqtr3d rngidcl prdsbasfn dffn5 sylib islmodd ) AUAUBUCDUDMZ
      GUIMZDUIMZGUEMZDUFMZDUJMZDGUDMZGAYCUGAXRUGAGCDNOHIAEUHCUKZEFPZCOPKJEUHFCU
      LUMUNAXTUGAXQUGAXSUGAYAUGAYBUGIACDENFGHJIAYDUHUOUPEUOCUKKUAUHUOUAVAZUQURE
      UHUOCVBUSUTZAYFXQPZUBVAZYCPZYFYIXTQZYCPZAYHYJRZRBYCCDXTYFYIEXQOGHYCSZXTSZ
      XQSZADNPZYMITAEOPZYMAYEYRJEFVCVDZTAYDYMKTAYHYJVEAYHYJVFABVAZEPZYTCMZVGMZD
      VHZYMLVIVJZVKAYHYJUCVAZYCPZVLZRZBEYFYTYIUUFXRQZMZUUBUEMZQZVMBEYTYKMZYTYFU
      UFXTQZMZUUBUIMZQZVMYFUUJXTQYKUUOXRQUUIBEUUMUURUUIUUARZYFYTYIMZYTUUFMZUUQQ
      ZUULQZYFUUTUULQZYFUVAUULQZUUQQZUUMUURUUSUUBUHPZYFUUCUDMZPZUUTUUBUDMZPUVAU
      VJPZUVCUVFVHAUUAUVGUUHAEUHYTCKVNZVIUUSYFXQUVHYHYJUUGAUUAVOZAUUAUVHXQVHZUU
      HAUUARZUUCDUDLVPZVIVQUUSYCCDYIEYTNOGHYNAYQUUHUUAIVRZAYRUUHUUAYSVRZACEVSZU
      UHUUAAYDUVSKEUHCWKVDZVRZYHYJUUGAUUAVTZUUIUUAWCZWAUUSYCCDUUFEYTNOGHYNUVQUV
      RUWAYHYJUUGAUUAWBZUWCWAUUQYFUULUUCUVHUVJUUBUUTUVAUVJSZUUQSZUUCSZUULSZUVHS
      ZWDWEUUSUUKUVBYFUULUUSYCXRCDYIUUFEYTNOGHYNUVQUVRUWAUWBUWDXRSZUWCWFWGUUSUU
      NUVDUUPUVEUUQUUSYCCDXTYFYIEYTXQNOGHYNYOYPUVQUVRUWAUVMUWBUWCWHUUSYCCDXTYFU
      UFEYTXQNOGHYNYOYPUVQUVRUWAUVMUWDUWCWHWIWJWLUUIBYCCDXTYFUUJEXQNOGHYNYOYPAY
      QUUHITZAYRUUHYSTZAUVSUUHUVTTZAYHYJUUGWMUUIGUOPZYJUUGUUJYCPAUWNUUHYGTAYHYJ
      UUGWNAYHYJUUGWOYCXRGYIUUFYNUWJWPWQWRUUIBYCXRCDYKUUOENOGHYNUWKUWLUWMAYHYJY
      LUUGUUEWTAYHUUGUUOYCPZYJAYHUUGRZRBYCCDXTYFUUFEXQOGHYNYOYPAYQUWPITAYRUWPYS
      TAYDUWPKTAYHUUGVEAYHUUGVFAUUAUUDUWPLVIVJZXAUWJWSWJAYHYIXQPZUUGVLZRZBEYFYI
      XSQZUVAUULQZVMBEUUPYTYIUUFXTQZMZUUQQZVMUXAUUFXTQUUOUXCXRQUWTBEUXBUXEUWTUU
      ARZUXEUVEYIUVAUULQZUUQQZYFYIUUCUIMZQZUVAUULQZUXBUXFUUPUVEUXDUXGUUQUXFYCCD
      XTYFUUFEYTXQNOGHYNYOYPAYQUWSUUAIVRZAYRUWSUUAYSVRZAUVSUWSUUAUVTVRZYHUWRUUG
      AUUAVOZYHUWRUUGAUUAWBZUWTUUAWCZWHUXFYCCDXTYIUUFEYTXQNOGHYNYOYPUXLUXMUXNYH
      UWRUUGAUUAVTZUXPUXQWHZWIUXFUVGUVIYIUVHPZUVKUXKUXHVHAUUAUVGUWSUVLVIZUXFYFX
      QUVHUXOAUUAUVNUWSUVPVIZVQZUXFYIXQUVHUXRUYBVQZUXFYCCDUUFEYTNOGHYNUXLUXMUXN
      UXPUXQWAZUUQUXIYFYIUULUUCUVHUVJUUBUVAUWEUWFUWGUWHUWIUXISXBWEUXFUXJUXAUVAU
      ULUXFUXIXSYFYIUXFUUCDUIAUUAUUDUWSLVIZVPXCXDXEWLUWTBYCCDXTUXAUUFEXQNOGHYNY
      OYPAYQUWSITZAYRUWSYSTZAUVSUWSUVTTZUWTYQYHUWRUXAXQPUYGAYHUWRUUGWMZAYHUWRUU
      GWNZXQXSDYFYIYPXSSXFWQAYHUWRUUGWOZWRUWTBYCXRCDUUOUXCENOGHYNUYGUYHUYIAYHUU
      GUWOUWRUWQXAUWTBYCCDXTYIUUFEXQOGHYNYOYPUYGUYHAYDUWSKTUYKUYLUYFVJZUWJWSWJU
      WTBEYFYIYAQZUVAUULQZVMBEYFUXDUULQZVMUYNUUFXTQYFUXCXTQUWTBEUYOUYPUXFUYPYFU
      XGUULQZYFYIUUCUFMZQZUVAUULQZUYOUXFUXDUXGYFUULUXSWGUXFUVGUVIUXTUVKUYTUYQVH
      UYAUYCUYDUYEYFYIUULUYRUUCUVHUVJUUBUVAUWEUWGUWHUWIUYRSXGWEUXFUYSUYNUVAUULU
      XFUYRYAYFYIUXFUUCDUFUYFVPXCXDXEWLUWTBYCCDXTUYNUUFEXQNOGHYNYOYPUYGUYHUYIUW
      TYQYHUWRUYNXQPUYGUYJUYKXQDYAYFYIYPYASXIWQUYLWRUWTBYCCDXTYFUXCEXQNOGHYNYOY
      PUYGUYHUYIUYJUYMWRWJAYFYCPZRZBEYBYTYFMZUULQZVMBEVUCVMZYBYFXTQYFVUBBEVUDVU
      CVUBUUARZUUCUJMZVUCUULQZVUDVUCVUFVUGYBVUCUULAUUAVUGYBVHVUAUVOUUCDUJLVPVIX
      DVUFUVGVUCUVJPVUHVUCVHAUUAUVGVUAUVLVIVUFYCCDYFEYTNOGHYNAYQVUAUUAIVRAYRVUA
      UUAYSVRAUVSVUAUUAUVTVRAVUAUUAXHVUBUUAWCWAUULVUGUUCUVJUUBVUCUWEUWGUWHVUGSX
      JUMXKWLVUBBYCCDXTYBYFEXQNOGHYNYOYPAYQVUAITZAYRVUAYSTZAUVSVUAUVTTZAYBXQPZV
      UAAYQVULIXQDYBYPYBSXLVDTAVUAWCZWRVUBYFEVSYFVUEVHVUBYCCDYFENOGHYNVUIVUJVUK
      VUMXMBEYFXNXOWJXP $.
  $}

  ${
    $d x I $.  $d x R $.  $d x V $.
    pwslmod.y $e |- Y = ( R ^s I ) $.
    $( The product of a family of left modules is a left module.  (Contributed
       by Mario Carneiro, 11-Jan-2015.) $)
    pwslmod $p |- ( ( R e. LMod /\ I e. V ) -> Y e. LMod ) $=
      ( vx clmod wcel wa csca cfv csn cxp cprds eqid pwsval crg lmodrng adantr
      co simpr wf fconst6g cv wceq fvconst2g adantlr fveq2d prdslmodd eqeltrd )
      AGHZBCHZIZDAJKZBALMZNTZGAUNBGCDEUNOZPUMFUOUNBCUPUPOUKUNQHULUNAUQRSUKULUAU
      KBGUOUBULBAGUCSUMFUDZBHZIURUOKZAJUKUSUTAUEULBAURGUFUGUHUIUJ $.
  $}

  $c LSpan $.

  $( Extend class notation with span of a set of vectors. $)
  clspn $a class LSpan $.

  ${
    $d w s t $.
    $( Define span of a set of vectors of a left module or left vector space.
       (Contributed by NM, 8-Dec-2013.) $)
    df-lsp $a |- LSpan = ( w e. _V |-> ( s e. ~P ( Base ` w ) |->
         |^| { t e. ( LSubSp ` w ) | s C_ t } ) ) $.
  $}

  ${
    $d p s t w S $.  $d s t U $.  $d p s t w V $.  $d s w W $.
    lspval.v $e |- V = ( Base ` W ) $.
    lspval.s $e |- S = ( LSubSp ` W ) $.
    lspval.n $e |- N = ( LSpan ` W ) $.
    $( The span function for a left vector space (or a left module).
       ( ~ df-span analog.)  (Contributed by NM, 8-Dec-2013.)  (Revised by
       Mario Carneiro, 19-Jun-2014.) $)
    lspfval $p |- ( W e. X
      -> N = ( s e. ~P V |-> |^| { t e. S | s C_ t } ) ) $=
      ( vw wcel clspn cfv cpw cv cvv wceq cbs clss crab cint cmpt fveq2 syl6eqr
      wss elex pweqd rabeq syl inteqd mpteq12dv df-lsp fvex eqeltri mptex fvmpt
      pwex syl5eq ) EFLZCEMNZGDOZGPAPUFZABUAZUBZUCZJUTEQLVAVFREFUGKEGKPZSNZOZVC
      AVGTNZUAZUBZUCVFQMVGERZGVIVLVBVEVMVHDVMVHESNZDVGESUDHUEUHVMVKVDVMVJBRVKVD
      RVMVJETNBVGETUDIUEVCAVJBUIUJUKULKAGUMGVBVEDDVNQHESUNUOURUPUQUJUS $.

    $( The span operator on a left module maps subsets to subsets.
       (Contributed by Stefan O'Rear, 12-Dec-2014.) $)
    lspf $p |- ( W e. LMod -> N : ~P V --> S ) $=
      ( vs vp clmod wcel cpw wf cv wss crab cint cmpt wa c0 wne ssrab2 a1i wrex
      simpl lss1 elpwi sseq2 rspcev syl2an sylibr lssintcl syl3anc eqid lspfval
      rabn0 fmptd feq1d mpbird ) DJKZCLZABMVAAHVAHNZINZOZIAPZQZRZMUTHVAVFAVGUTV
      BVAKZSZUTVEAOZVETUAZVFAKUTVHUEVJVIVDIAUBUCVIVDIAUDZVKUTCAKVBCOZVLVHACDEFU
      FVBCUGVDVMICAVCCVBUHUIUJVDIAUPUKVEADFULUMVGUNUQUTVAABVGIABCDJHEFGUOURUS
      $.

    $( The span of a set of vectors (in a left module).  ( ~ spanval analog.)
       (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lspval $p |- ( ( W e. LMod /\ U C_ V )
       -> ( N ` U ) = |^| { t e. S | U C_ t } ) $=
      ( vs clmod wcel wss cfv cv crab cint wceq cvv cbs cpw cmpt lspfval fveq1d
      wa adantr simpr fvex eqeltri elpw2 sylibr wrex lss1 sseq2 rspcev intexrab
      sylan sylib sseq1 rabbidv inteqd eqid fvmptg syl2anc eqtrd ) FKLZCEMZUEZC
      DNZCJEUAZJOZAOZMZABPZQZUBZNZCVLMZABPZQZVFVIVQRVGVFCDVPABDEFKJGHIUCUDUFVHC
      VJLZVTSLZVQVTRVHVGWAVFVGUGCEEFTNSGFTUHUIUJUKVHVRABULZWBVFEBLVGWCBEFGHUMVR
      VGAEBVLECUNUOUQVRABUPURJCVOVTVJSVPVKCRZVNVSWDVMVRABVKCVLUSUTVAVPVBVCVDVE
      $.

    $( The span of a set of vectors is a subspace.  ( ~ spancl analog.)
       (Contributed by NM, 9-Dec-2013.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lspcl $p |- ( ( W e. LMod /\ U C_ V ) -> ( N ` U ) e. S ) $=
      ( clmod wcel cpw wf cfv wss lspf cbs cvv fvex eqeltri elpw2 biimpri
      ffvelrn syl2an ) EIJDKZACLBUDJZBCMAJBDNZACDEFGHOUEUFBDDEPMQFEPRSTUAUDABCU
      BUC $.

    $( The span of a singleton is a subspace (frequently used special case of
       ~ lspcl ).  (Contributed by NM, 17-Jul-2014.) $)
    lspsncl $p |- ( ( W e. LMod /\ X e. V ) -> ( N ` { X } ) e. S ) $=
      ( wcel clmod csn wss cfv snssi lspcl sylan2 ) ECIDJIEKZCLQBMAIECNAQBCDFGH
      OP $.

    lspprcl.w $e |- ( ph -> W e. LMod ) $.
    lspprcl.x $e |- ( ph -> X e. V ) $.
    lspprcl.y $e |- ( ph -> Y e. V ) $.
    $( The span of a pair is a subspace (frequently used special case of
       ~ lspcl ).  (Contributed by NM, 11-Apr-2015.) $)
    lspprcl $p |- ( ph -> ( N ` { X , Y } ) e. S ) $=
      ( clmod wcel cpr wss cfv prssi syl2anc lspcl ) AENOFGPZDQZUBCRBOKAFDOGDOU
      CLMFGDSTBUBCDEHIJUAT $.

    lsptpcl.z $e |- ( ph -> Z e. V ) $.
    $( The span of an unordered triple is a subspace (frequently used special
       case of ~ lspcl ).  (Contributed by NM, 22-May-2015.) $)
    lsptpcl $p |- ( ph -> ( N ` { X , Y , Z } ) e. S ) $=
      ( clmod wcel ctp wss syl2anc cfv cpr csn df-tp prssi snssd unssd syl5eqss
      cun lspcl ) AEPQFGHRZDSUKCUABQLAUKFGUBZHUCZUIDFGHUDAULUMDAFDQGDQULDSMNFGD
      UETAHDOUFUGUHBUKCDEIJKUJT $.
  $}

  ${
    lspsnsubg.v $e |- V = ( Base ` W ) $.
    lspsnsubg.n $e |- N = ( LSpan ` W ) $.
    $( The span of a singleton is an additive subgroup (frequently used special
       case of ~ lspcl ).  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    lspsnsubg $p |- ( ( W e. LMod /\ X e. V ) ->
        ( N ` { X } ) e. ( SubGrp ` W ) ) $=
      ( clmod wcel csn cfv clss csubg eqid lspsncl lsssubg syldan ) CGHDBHDIAJZ
      CKJZHQCLJHRABCDERMZFNRQCSOP $.
  $}

  ${
    $d a b $.
    $( ~ fvco4i lemma for linear spans.  (Contributed by Stefan O'Rear,
       4-Apr-2015.) $)
    00lsp $p |- (/) = ( LSpan ` (/) ) $=
      ( va vb c0 clspn cfv cpw wss crab cint cmpt cvv wcel wceq 0ex base0 ax-mp
      cv eqid eqtri mpbir 00lss lspfval cdm dmmpt wn wral vprc rab0 inteqi int0
      eleq1i mtbir rgenw rabeq0 wrel wb wfun funmpt funrel reldm0 eqtr2i ) CDEZ
      ACFZAQBQGZBCHZIZJZCCKLVBVGMNBCVBCCKAOUAVBRUBPVGCMZVGUCZCMZVIVFKLZAVCHZCAV
      CVFVGVGRUDVLCMVKUEZAVCUFVMAVCVKKKLUGVFKKVFCIKVECVDBUHUIUJSUKULUMVKAVCUNTS
      VGUOZVHVJUPVGUQVNAVCVFURVGUSPVGUTPTVA $.
  $}

  ${
    $d t S $.  $d t U $.  $d t W $.
    lspid.s $e |- S = ( LSubSp ` W ) $.
    lspid.n $e |- N = ( LSpan ` W ) $.
    $( The span of a subspace is itself.  ( ~ spanid analog.)  (Contributed by
       NM, 15-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lspid $p |- ( ( W e. LMod /\ U e. S ) -> ( N ` U ) = U ) $=
      ( vt clmod wcel wa cfv cv wss crab cint cbs wceq eqid lssss lspval sylan2
      intmin adantl eqtrd ) DHIZBAIZJBCKZBGLMGANOZBUFUEBDPKZMUGUHQABUIDUIRZESGA
      BCUIDUJEFTUAUFUHBQUEGBAUBUCUD $.
  $}

  ${
    $d t T $.  $d t U $.  $d t V $.  $d t W $.
    lspss.v $e |- V = ( Base ` W ) $.
    lspss.n $e |- N = ( LSpan ` W ) $.
    $( A span is a set of vectors.  (Contributed by NM, 22-Feb-2014.)  (Revised
       by Mario Carneiro, 19-Jun-2014.) $)
    lspssv $p |- ( ( W e. LMod /\ U C_ V ) -> ( N ` U ) C_ V ) $=
      ( clmod wcel wss wa cfv clss eqid lspcl lssss syl ) DGHACIJABKZDLKZHQCIRA
      BCDERMZFNRQCDESOP $.

    $( Span preserves subset ordering.  ( ~ spanss analog.)  (Contributed by
       NM, 11-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lspss $p |- ( ( W e. LMod /\ U C_ V /\ T C_ U )
          -> ( N ` T ) C_ ( N ` U ) ) $=
      ( vt clmod wcel wss w3a cv clss cfv crab cint syl wceq lspval wa wi sstr2
      simpl3 ss2rabdv intss simp1 simp3 simp2 sstrd syl2anc 3adant3 3sstr4d
      eqid ) EIJZBDKZABKZLZAHMZKZHENOZPZQZBUSKZHVAPZQZACOZBCOZURVEVBKVCVFKURVDU
      THVAURUSVAJZUAUQVDUTUBUOUPUQVIUDABUSUCRUEVEVBUFRURUOADKVGVCSUOUPUQUGURABD
      UOUPUQUHUOUPUQUIUJHVAACDEFVAUNZGTUKUOUPVHVFSUQHVABCDEFVJGTULUM $.

    $( A set of vectors is a subset of its span.  ( ~ spanss2 analog.)
       (Contributed by NM, 6-Feb-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lspssid $p |- ( ( W e. LMod /\ U C_ V ) -> U C_ ( N ` U ) ) $=
      ( vt clmod wcel wss wa clss cfv crab cint ssintub eqid lspval syl5sseqr
      cv ) DHIACJKAGTJGDLMZNOAABMGAUAPGUAABCDEUAQFRS $.

    $( The span of a set of vectors is idempotent.  (Contributed by NM,
       22-Feb-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lspidm $p |- ( ( W e. LMod /\ U C_ V )
                  -> ( N ` ( N ` U ) ) = ( N ` U ) ) $=
      ( clmod wcel wss cfv clss wceq eqid lspcl lspid syldan ) DGHACIABJZDKJZHQ
      BJQLRABCDERMZFNRQBDSFOP $.

    $( The span of union is the span of the union of spans.  (Contributed by
       NM, 22-Feb-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.) $)
    lspun $p |- ( ( W e. LMod /\ T C_ V /\ U C_ V )
       -> ( N ` ( T u. U ) ) = ( N ` ( ( N ` T ) u. ( N ` U ) ) ) ) $=
      ( clmod wcel wss w3a cun cfv simp1 unssd lspss syl3anc syl2anc lspssid
      a1i simp2 simp3 ssun1 ssun2 lspssv sstrd unss12 wceq lspidm sseqtrd eqssd
      ) EHIZADJZBDJZKZABLZCMZACMZBCMZLZCMZUOULUTDJUPUTJZUQVAJULUMUNNZUOUTUQDUOU
      RUSUQUOULUPDJZAUPJZURUQJVCUOABDULUMUNUAZULUMUNUBZOZVEUOABUCTAUPCDEFGPQUOU
      LVDBUPJZUSUQJVCVHVIUOBAUDTBUPCDEFGPQOZUOULVDUQDJZVCVHUPCDEFGUERZUFUOAURJZ
      BUSJZVBUOULUMVMVCVFACDEFGSRUOULUNVNVCVGBCDEFGSRAURBUSUGRUPUTCDEFGPQUOVAUQ
      CMZUQUOULVKUTUQJVAVOJVCVLVJUTUQCDEFGPQUOULVDVOUQUHVCVHUPCDEFGUIRUJUK $.
  $}

  ${
    $d t S $.  $d t U $.  $d t W $.
    lspssp.s $e |- S = ( LSubSp ` W ) $.
    lspssp.n $e |- N = ( LSpan ` W ) $.
    $( If a set of vectors is a subset of a subspace, then the span of those
       vectors is also contained in the subspace.  (Contributed by Mario
       Carneiro, 4-Sep-2014.) $)
    lspssp $p |- ( ( W e. LMod /\ U e. S /\ T C_ U ) -> ( N ` T ) C_ U ) $=
      ( clmod wcel wss w3a cfv cbs eqid lssss lspss syl3an2 wceq lspid 3adant3
      sseqtrd ) EHIZCAIZBCJZKBDLZCDLZCUCUBCEMLZJUDUEUFJACUGEUGNZFOBCDUGEUHGPQUB
      UCUFCRUDACDEFGSTUA $.
  $}

  ${
    $d W a b c $.  $d U a b c $.  $d K a b c $.  $d F a b c $.
    mrclsp.u $e |- U = ( LSubSp ` W ) $.
    mrclsp.k $e |- K = ( LSpan ` W ) $.
    mrclsp.f $e |- F = ( mrCls ` U ) $.
    $( Moore closure generalizes module span.  (Contributed by Stefan O'Rear,
       31-Jan-2015.) $)
    mrclsp $p |- ( W e. LMod -> K = F ) $=
      ( va vb clmod wcel cbs cfv cpw cv wss crab cint cmpt eqid lspfval mrcfval
      cmre wceq lssmre syl eqtr4d ) DJKZCHDLMZNHOIOPIAQRSZBIACUIDJHUITZEFUAUHAU
      IUCMKBUJUDUIADUKEUEHABUIIGUBUFUG $.
  $}

  ${
    lspsnss.s $e |- S = ( LSubSp ` W ) $.
    lspsnss.n $e |- N = ( LSpan ` W ) $.
    $( The span of the singleton of a subspace member is included in the
       subspace.  ( ~ spansnss analog.)  (Contributed by NM, 9-Apr-2014.)
       (Revised by Mario Carneiro, 4-Sep-2014.) $)
    lspsnss $p |- ( ( W e. LMod /\ U e. S /\ X e. U )
            -> ( N ` { X } ) C_ U ) $=
      ( wcel clmod csn wss cfv snssi lspssp syl3an3 ) EBHDIHBAHEJZBKPCLBKEBMAPB
      CDFGNO $.

    lspsnel3.w $e |- ( ph -> W e. LMod ) $.
    lspsnel3.u $e |- ( ph -> U e. S ) $.
    lspsnel3.x $e |- ( ph -> X e. U ) $.
    lspsnel3.y $e |- ( ph -> Y e. ( N ` { X } ) ) $.
    $( A member of the span of the singleton of a vector is a member of a
       subspace containing the vector.  ( ~ elspansn3 analog.)  (Contributed by
       NM, 4-Jul-2014.) $)
    lspsnel3 $p |- ( ph -> Y e. U ) $=
      ( csn cfv clmod wcel wss lspsnss syl3anc sseldd ) AFNDOZCGAEPQCBQFCQUBCRJ
      KLBCDEFHISTMUA $.
  $}

  ${
    lspprss.s $e |- S = ( LSubSp ` W ) $.
    lspprss.n $e |- N = ( LSpan ` W ) $.
    lspprss.w $e |- ( ph -> W e. LMod ) $.
    lspprss.u $e |- ( ph -> U e. S ) $.
    lspprss.x $e |- ( ph -> X e. U ) $.
    lspprss.y $e |- ( ph -> Y e. U ) $.
    $( The span of a pair of vectors in a subspace belongs to the subspace.
       (Contributed by NM, 12-Jan-2015.) $)
    lspprss $p |- ( ph -> ( N ` { X , Y } ) C_ U ) $=
      ( clmod wcel cpr wss cfv wa jca wb prssg syl mpbid lspssp syl3anc ) AENOC
      BOFGPZCQZUGDRCQJKAFCOZGCOZSZUHAUIUJLMTZAUKUKUHUAULFGCCCUBUCUDBUGCDEHIUEUF
      $.
  $}

  ${
    lspsnid.v $e |- V = ( Base ` W ) $.
    lspsnid.n $e |- N = ( LSpan ` W ) $.
    $( A vector belongs to the span of its singleton.  ( ~ spansnid analog.)
       (Contributed by NM, 9-Apr-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lspsnid $p |- ( ( W e. LMod /\ X e. V ) -> X e. ( N ` { X } ) ) $=
      ( clmod wcel wa csn cfv wss snssi lspssid sylan2 wb snssg adantl mpbird )
      CGHZDBHZIDDJZAKZHZUBUCLZUATUBBLUEDBMUBABCEFNOUAUDUEPTDUCBQRS $.
  $}

  ${
    lspsnel5.v $e |- V = ( Base ` W ) $.
    lspsnel5.s $e |- S = ( LSubSp ` W ) $.
    lspsnel5.n $e |- N = ( LSpan ` W ) $.
    lspsnel5.w $e |- ( ph -> W e. LMod ) $.
    lspsnel5.a $e |- ( ph -> U e. S ) $.
    $( Relationship between a vector and the 1-dim (or 0-dim) subspace it
       generates.  (Contributed by NM, 8-Aug-2014.)  (Revised by Mario
       Carneiro, 8-Jan-2015.) $)
    lspsnel6 $p |- ( ph -> ( X e. U <-> ( X e. V /\ ( N ` { X } ) C_ U ) ) ) $=
      ( wcel csn cfv wss wa lssel sylan adantr clmod simpr lspsnss syl3anc ssel
      jca lspsnid syl5com impr impbida ) AGCMZGEMZGNDOZCPZQAUKQZULUNACBMZUKULLB
      CEFGHIRSUOFUAMZUPUKUNAUQUKKTAUPUKLTAUKUBBCDFGIJUCUDUFAULUNUKAULQGUMMZUNUK
      AUQULURKDEFGHJUGSUMCGUEUHUIUJ $.

    lspsnel5.x $e |- ( ph -> X e. V ) $.
    $( Relationship between a vector and the 1-dim (or 0-dim) subspace it
       generates.  (Contributed by NM, 8-Aug-2014.) $)
    lspsnel5 $p |- ( ph -> ( X e. U <-> ( N ` { X } ) C_ U ) ) $=
      ( wcel csn cfv wss wa lspsnel6 biantrurd bitr4d ) AGCNGENZGODPCQZRUCABCDE
      FGHIJKLSAUBUCMTUA $.
  $}

  ${
    lspsnel5a.s $e |- S = ( LSubSp ` W ) $.
    lspsnel5a.n $e |- N = ( LSpan ` W ) $.
    lspsnel5a.w $e |- ( ph -> W e. LMod ) $.
    lspsnel5a.a $e |- ( ph -> U e. S ) $.
    lspsnel5a.x $e |- ( ph -> X e. U ) $.
    $( Relationship between a vector and the 1-dim (or 0-dim) subspace it
       generates.  (Contributed by NM, 20-Feb-2015.) $)
    lspsnel5a $p |- ( ph -> ( N ` { X } ) C_ U ) $=
      ( wcel csn cfv wss cbs eqid lssel syl2anc lspsnel5 mpbid ) AFCLZFMDNCOKAB
      CDEPNZEFUCQZGHIJACBLUBFUCLJKBCUCEFUDGRSTUA $.
  $}

  ${
    lspprid.v $e |- V = ( Base ` W ) $.
    lspprid.n $e |- N = ( LSpan ` W ) $.
    lspprid.w $e |- ( ph -> W e. LMod ) $.
    lspprid.x $e |- ( ph -> X e. V ) $.
    lspprid.y $e |- ( ph -> Y e. V ) $.
    $( A member of a pair of vectors belongs to their span.  (Contributed by
       NM, 14-May-2015.) $)
    lspprid1 $p |- ( ph -> X e. ( N ` { X , Y } ) ) $=
      ( cpr cfv wcel csn wss clmod prssi syl2anc snsspr1 a1i lspss syl3anc clss
      eqid lspprcl lspsnel5 mpbird ) AEEFLZBMZNEOZBMUJPZADQNUICPZUKUIPZULIAECNF
      CNUMJKEFCRSUNAEFTUAUKUIBCDGHUBUCADUDMZUJBCDEGUOUEZHIAUOBCDEFGUPHIJKUFJUGU
      H $.

    $( A member of a pair of vectors belongs to their span.  (Contributed by
       NM, 14-May-2015.) $)
    lspprid2 $p |- ( ph -> Y e. ( N ` { X , Y } ) ) $=
      ( cpr cfv lspprid1 prcom fveq2i syl6eleq ) AFFELZBMEFLZBMABCDFEGHIKJNRSBF
      EOPQ $.
  $}

  ${
    lspprvacl.v $e |- V = ( Base ` W ) $.
    lspprvacl.p $e |- .+ = ( +g ` W ) $.
    lspprvacl.n $e |- N = ( LSpan ` W ) $.
    lspprvacl.w $e |- ( ph -> W e. LMod ) $.
    lspprvacl.x $e |- ( ph -> X e. V ) $.
    lspprvacl.y $e |- ( ph -> Y e. V ) $.
    $( The sum of two vectors belongs to their span.  (Contributed by NM,
       20-May-2015.) $)
    lspprvacl $p |- ( ph -> ( X .+ Y ) e. ( N ` { X , Y } ) ) $=
      ( clmod wcel cpr cfv clss co eqid lspprcl lspprid1 lspprid2 syl22anc
      lssvacl ) AENOFGPCQZERQZOFUFOGUFOFGBSUFOKAUGCDEFGHUGTZJKLMUAACDEFGHJKLMUB
      ACDEFGHJKLMUCBUGUFEFGIUHUEUD $.
  $}

  ${
    $d x y N $.  $d x y U $.  $d x y ph $.
    lssats2.s $e |- S = ( LSubSp ` W ) $.
    lssats2.n $e |- N = ( LSpan ` W ) $.
    lssats2.w $e |- ( ph -> W e. LMod ) $.
    lssats2.u $e |- ( ph -> U e. S ) $.
    $( A way to express atomisticity (a subspace is the union of its atoms).
       (Contributed by NM, 3-Feb-2015.) $)
    lssats2 $p |- ( ph -> U = U_ x e. U ( N ` { x } ) ) $=
      ( vy cv csn cfv ciun wcel wa simpr adantr syl2anc wrex clmod eqid lspsnid
      cbs lssel sylan weq fveq2d eleq2d rspcev lspsnel5a sseld rexlimdva impbid
      sneq ex eliun syl6bbr eqrdv ) AKDBDBLZMZENZOZAKLZDPZVEVCPZBDUAZVEVDPAVFVH
      AVFVHAVFQZVFVEVEMZENZPZVHAVFRVIFUBPZVEFUENZPZVLAVMVFISADCPZVFVOJCDVNFVEVN
      UCZGUFUGEVNFVEVQHUDTVGVLBVEDBKUHZVCVKVEVRVBVJEVAVEUPUIUJUKTUQAVGVFBDAVADP
      ZQZVCDVEVTCDEFVAGHAVMVSISAVPVSJSAVSRULUMUNUOBVEDVCURUSUT $.
  $}

  ${
    lspsnvsel.v $e |- V = ( Base ` W ) $.
    lspsnvsel.t $e |- .x. = ( .s ` W ) $.
    lspsnvsel.f $e |- F = ( Scalar ` W ) $.
    lspsnvsel.k $e |- K = ( Base ` F ) $.
    lspsnvsel.n $e |- N = ( LSpan ` W ) $.
    lspsnvsel.w $e |- ( ph -> W e. LMod ) $.
    lspsnvsel.a $e |- ( ph -> A e. K ) $.
    lspsnvsel.x $e |- ( ph -> X e. V ) $.
    $( A scalar product with a vector belongs to the span of its singleton.
       ( ~ spansnmul analog.)  (Contributed by NM, 2-Jul-2014.) $)
    lspsneli $p |- ( ph -> ( A .x. X ) e. ( N ` { X } ) ) $=
      ( wcel cfv syl2anc clmod csn clss eqid lspsncl lspsnid lssvscl syl22anc
      co ) AHUARZIUBFSZHUCSZRZBERIUKRZBICUIUKROAUJIGRZUMOQULFGHIJULUDZNUETPAUJU
      OUNOQFGHIJNUFTEULCUKDHBILKMUPUGUH $.
  $}

  ${
    $d k F $.  $d k v K $.  $d k v N $.  $d k v U $.  $d k v V $.  $d k v W $.
    $d k R $.  $d k v .x. $.  $d k v X $.
    lspsn.f $e |- F = ( Scalar ` W ) $.
    lspsn.k $e |- K = ( Base ` F ) $.
    lspsn.v $e |- V = ( Base ` W ) $.
    lspsn.t $e |- .x. = ( .s ` W ) $.
    lspsn.n $e |- N = ( LSpan ` W ) $.
    $( Span of the singleton of a vector.  (Contributed by NM, 14-Jan-2014.)
       (Proof shortened by Mario Carneiro, 19-Jun-2014.) $)
    lspsn $p |- ( ( W e. LMod /\ X e. V )
        -> ( N ` { X } ) = { v | E. k e. K v = ( k .x. X ) } ) $=
      ( wcel wa cfv cv wceq adantr clmod csn wrex cab clss eqid simpl lss1d cur
      co lmod1cl lmodvs1 eqcomd oveq1 eqeq2d rspcev syl2anc eqeq1 rexbidv elabg
      wb adantl mpbird lspsnel5a wi lspsncl lspsnid lssvscl syl22anc eleq1a syl
      simpr rexlimdva abssdv eqssd ) HUAOZIGOZPZIUBFQZARZCRZIBUJZSZCEUCZAUDZVRH
      UEQZWEFHIWFUFZNVPVQUGZAWFBCDEGHILJMKWGUHVRIWEOZIWBSZCEUCZVRDUIQZEOZIWLIBU
      JZSZWKVPWMVQWLDEHJKWLUFZUKTVRWNIBWLDGHILJMWPULUMWJWOCWLEWAWLSWBWNIWAWLIBU
      NUOUPUQVQWIWKVAVPWDWKAIGVTISWCWJCEVTIWBURUSUTVBVCVDVRWDAVSVRWCVTVSOZCEVRW
      AEOZPZWBVSOZWCWQVEWSVPVSWFOZWRIVSOZWTVRVPWRWHTVRXAWRWFFGHILWGNVFTVRWRVLVR
      XBWRFGHILNVGTEWFBVSDHWAIJMKWGVHVIWBVSVTVJVKVMVNVO $.

    $( Member of span of the singleton of a vector.  ( ~ elspansn analog.)
       (Contributed by NM, 22-Feb-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lspsnel $p |- ( ( W e. LMod /\ X e. V )
       -> ( U e. ( N ` { X } ) <-> E. k e. K U = ( k .x. X ) ) ) $=
      ( vv wcel cv wceq wrex cvv clmod wa csn cfv co lspsn eleq2d ovex syl6eqel
      cab id rexlimivw eqeq1 rexbidv elab3 syl6bb ) HUAPIGPUBZBIUCFUDZPBOQZCQZI
      AUEZRZCESZOUJZPBVARZCESZUQURVDBOACDEFGHIJKLMNUFUGVCVFOBVEBTPCEVEBVATVEUKU
      TIAUHUIULUSBRVBVECEUSBVAUMUNUOUP $.

    $( Span of a scalar product of a singleton.  (Contributed by NM,
       23-Apr-2014.)  (Proof shortened by Mario Carneiro, 4-Sep-2014.) $)
    lspsnvsi $p |- ( ( W e. LMod /\ R e. K /\ X e. V )
        -> ( N ` { ( R .x. X ) } ) C_ ( N ` { X } ) ) $=
      ( clmod wcel w3a clss cfv csn co eqid simp1 wss simp3 snssd lspcl syl2anc
      simp2 lspsneli lspsnel5a ) GNOZADOZHFOZPZGQRZHSZERZEGAHBTUOUAZMUKULUMUBZU
      NUKUPFUCUQUOOUSUNHFUKULUMUDZUEUOUPEFGKURMUFUGUNABCDEFGHKLIJMUSUKULUMUHUTU
      IUJ $.
  $}

  ${
    $d k K $.  $d k N $.  $d k S $.  $d k V $.  $d k W $.  $d k X $.  $d k Y $.
    $d k .x. $.
    lspsnss2.v $e |- V = ( Base ` W ) $.
    lspsnss2.s $e |- S = ( Scalar ` W ) $.
    lspsnss2.k $e |- K = ( Base ` S ) $.
    lspsnss2.t $e |- .x. = ( .s ` W ) $.
    lspsnss2.n $e |- N = ( LSpan ` W ) $.
    lspsnss2.w $e |- ( ph -> W e. LMod ) $.
    lspsnss2.x $e |- ( ph -> X e. V ) $.
    lspsnss2.y $e |- ( ph -> Y e. V ) $.
    $( Comparable spans of singletons must have proportional vectors.  See
       ~ lspsneq for equal span version.  (Contributed by NM, 7-Jun-2015.) $)
    lspsnss2 $p |- ( ph ->
 ( ( N ` { X } ) C_ ( N ` { Y } ) <-> E. k e. K X = ( k .x. Y ) ) ) $=
      ( cfv wcel csn wss cv co wceq wrex clss clmod lspsncl syl2anc lspsnel5 wb
      eqid lspsnel bitr3d ) AIJUAFSZTZIUAFSUPUBIDUCJCUDUEDEUFZAHUGSZUPFGHIKUSUM
      ZOPAHUHTZJGTZUPUSTPRUSFGHJKUTOUIUJQUKAVAVBUQURULPRCIDBEFGHJLMKNOUNUJUO $.
  $}

  ${
    lspsnneg.v $e |- V = ( Base ` W ) $.
    lspsnneg.m $e |- M = ( invg ` W ) $.
    lspsnneg.n $e |- N = ( LSpan ` W ) $.
    $( Negation does not change the span of a singleton.  (Contributed by NM,
       24-Apr-2014.)  (Proof shortened by Mario Carneiro, 19-Jun-2014.) $)
    lspsnneg $p |- ( ( W e. LMod /\ X e. V )
        -> ( N ` { ( M ` X ) } ) = ( N ` { X } ) ) $=
      ( wcel cfv csn co eqid lmodvneg1 sneqd fveq2d wss cgrp lspsnvsi syl3anc
      clmod wa csca cur cminusg cvsca cbs simpl lmodfgrp lmod1cl syl2anc adantr
      grpinvcl simpr wceq lmodvnegcl syldan lmodgrp grpinvinv sylan eqtrd eqssd
      eqsstr3d ) DUAIZECIZUBZEAJZKZBJZEKZBJZVFVIDUCJZUDJZVLUEJZJZEDUFJZLZKZBJZV
      KVFVRVHBVFVQVGVPVMVLVNACDEFGVLMZVPMZVMMZVNMZNOPVFVDVOVLUGJZIZVEVSVKQVDVEU
      HZVDWEVEVDVLRIVMWDIWEVLDVTUIVMVLWDDVTWDMZWBUJWDVLVNVMWGWCUMUKULZVDVEUNVOV
      PVLWDBCDEVTWGFWAHSTVCVFVKVOVGVPLZKZBJZVIVFWJVJBVFWIEVFWIVGAJZEVDVEVGCIZWI
      WLUOACDEFGUPZVPVMVLVNACDVGFGVTWAWBWCNUQVDDRIVEWLEUODURCDAEFGUSUTVAOPVFVDW
      EWMWKVIQWFWHWNVOVPVLWDBCDVGVTWGFWAHSTVCVB $.
  $}

  ${
    lspsnsub.v $e |- V = ( Base ` W ) $.
    lspsnsub.s $e |- .- = ( -g ` W ) $.
    lspsnsub.n $e |- N = ( LSpan ` W ) $.
    lspsnsub.w $e |- ( ph -> W e. LMod ) $.
    lspsnsub.x $e |- ( ph -> X e. V ) $.
    lspsnsub.y $e |- ( ph -> Y e. V ) $.
    $( Swapping subtraction order does not change the span of a singleton.
       (Contributed by NM, 4-Apr-2015.) $)
    lspsnsub $p |- ( ph -> ( N ` { ( X .- Y ) } ) = ( N ` { ( Y .- X ) } ) ) $=
      ( co cminusg cfv csn wcel wceq syl3anc clmod lmodvsubcl eqid syl2anc cgrp
      lspsnneg lmodgrp syl grpinvsub sneqd fveq2d eqtr3d ) AFGBNZEOPZPZQZCPZUMQ
      CPZGFBNZQZCPAEUARZUMDRZUQURSKAVAFDRZGDRZVBKLMBDEFGHIUBTUNCDEUMHUNUCZJUFUD
      AUPUTCAUOUSAEUERZVCVDUOUSSAVAVFKEUGUHLMDEBUNFGHIVEUITUJUKUL $.
  $}

  ${
    lspsn0.z $e |- .0. = ( 0g ` W ) $.
    lspsn0.n $e |- N = ( LSpan ` W ) $.
    $( Span of the singleton of the zero vector.  ( ~ spansn0 analog.)
       (Contributed by NM, 15-Jan-2014.)  (Proof shortened by Mario Carneiro,
       19-Jun-2014.) $)
    lspsn0 $p |- ( W e. LMod -> ( N ` { .0. } ) = { .0. } ) $=
      ( clmod wcel csn clss cfv wceq eqid lsssn0 lspid mpdan ) BFGCHZBIJZGPAJPK
      QBCDQLZMQPABRENO $.

    $( Span of the empty set.  (Contributed by Mario Carneiro, 5-Sep-2014.) $)
    lsp0 $p |- ( W e. LMod -> ( N ` (/) ) = { .0. } ) $=
      ( clmod wcel c0 cfv csn clss wss lsssn0 0ss lspssp mp3an3 mpdan cbs lspcl
      eqid mpan2 lss0ss eqssd ) BFGZHAIZCJZUDUFBKIZGZUEUFLZUGBCDUGTZMUDUHHUFLUI
      UFNUGHUFABUJEOPQUDUEUGGZUFUELUDHBRIZLUKULNUGHAULBULTUJESUAUGBUECDUJUBQUC
      $.

    $( Union of the span of the empty set.  (Contributed by NM,
       14-Mar-2015.) $)
    lspuni0 $p |- ( W e. LMod -> U. ( N ` (/) ) = .0. ) $=
      ( clmod wcel cfv cuni csn lsp0 unieqd c0g cvv fvex eqeltri unisn syl6eq
      c0 ) BFGZSAHZICJZICTUAUBABCDEKLCCBMHNDBMOPQR $.
  $}

  ${
    lspun0.v $e |- V = ( Base ` W ) $.
    lspun0.o $e |- .0. = ( 0g ` W ) $.
    lspun0.n $e |- N = ( LSpan ` W ) $.
    lspun0.w $e |- ( ph -> W e. LMod ) $.
    lspun0.x $e |- ( ph -> X C_ V ) $.
    $( The span of a union with the zero subspace.  (Contributed by NM,
       22-May-2015.) $)
    lspun0 $p |- ( ph -> ( N ` ( X u. { .0. } ) ) = ( N ` X ) ) $=
      ( csn cun cfv wcel wss wceq syl syl2anc eqtrd clmod lmod0vcl snssd lspsn0
      lspun syl3anc uneq2d clss eqid lspcl lss0ss ssequn2 sylib fveq2d lspidm )
      AEFLZMBNZEBNZUPBNZMZBNZURADUAOZECPZUPCPUQVAQJKAFCAVBFCOJCDFGHUBRUCEUPBCDG
      IUEUFAVAURBNZURAUTURBAUTURUPMZURAUSUPURAVBUSUPQJBDFHIUDRUGAUPURPZVEURQAVB
      URDUHNZOZVFJAVBVCVHJKVGEBCDGVGUIZIUJSVGDURFHVIUKSUPURULUMTUNAVBVCVDURQJKE
      BCDGIUOSTT $.
  $}

  ${
    lspsneq0.v $e |- V = ( Base ` W ) $.
    lspsneq0.z $e |- .0. = ( 0g ` W ) $.
    lspsneq0.n $e |- N = ( LSpan ` W ) $.
    $( Span of the singleton is the zero subspace iff the vector is zero.
       (Contributed by NM, 27-Apr-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.) $)
    lspsneq0 $p |- ( ( W e. LMod /\ X e. V )
         -> ( ( N ` { X } ) = { .0. } <-> X = .0. ) ) $=
      ( clmod wcel wa csn cfv wceq lspsnid eleq2 syl5ibcom elsni syl6 lspsn0
      adantr sneq fveq2d eqeq1d syl5ibrcom impbid ) CIJZDBJZKZDLZAMZELZNZDENZUI
      UMDULJZUNUIDUKJUMUOABCDFHOUKULDPQDERSUIUMUNULAMZULNZUGUQUHACEGHTUAUNUKUPU
      LUNUJULADEUBUCUDUEUF $.
  $}

  ${
    lspsneq0b.v $e |- V = ( Base ` W ) $.
    lspsneq0b.o $e |- .0. = ( 0g ` W ) $.
    lspsneq0b.n $e |- N = ( LSpan ` W ) $.
    lspsneq0b.w $e |- ( ph -> W e. LMod ) $.
    lspsneq0b.x $e |- ( ph -> X e. V ) $.
    lspsneq0b.y $e |- ( ph -> Y e. V ) $.
    lspsneq0b.e $e |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $.
    $( Equal singleton spans imply both arguments are zero or both are
       nonzero.  (Contributed by NM, 21-Mar-2015.) $)
    lspsneq0b $p |- ( ph -> ( X = .0. <-> Y = .0. ) ) $=
      ( wceq wa csn cfv adantr wcel clmod lspsneq0 syl2anc biimpar eqtr3d mpbid
      wb eqtrd impbida ) AEGOZFGOZAUJPZFQBRZGQZOZUKULEQBRZUMUNAUPUMOZUJNSAUPUNO
      ZUJADUATZECTURUJUGZKLBCDEGHIJUBUCZUDUEAUOUKUGZUJAUSFCTVBKMBCDFGHIJUBUCZSU
      FAUKPZURUJVDUPUMUNAUQUKNSAUOUKVCUDUHAUTUKVASUFUI $.
  $}

  ${
    lmodindp1.v $e |- V = ( Base ` W ) $.
    lmodindp1.p $e |- .+ = ( +g ` W ) $.
    lmodindp1.o $e |- .0. = ( 0g ` W ) $.
    lmodindp1.n $e |- N = ( LSpan ` W ) $.
    lmodindp1.w $e |- ( ph -> W e. LMod ) $.
    lmodindp1.x $e |- ( ph -> X e. V ) $.
    lmodindp1.y $e |- ( ph -> Y e. V ) $.
    lmodindp1.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    $( Two independent (non-colinear) vectors have nonzero sum.  (Contributed
       by NM, 22-Apr-2015.) $)
    lmodindp1 $p |- ( ph -> ( X .+ Y ) =/= .0. ) $=
      ( csn cfv wceq wcel wne co wa cminusg eqid lspsnneg syl2anc eqcomd adantr
      clmod cgrp wb lmodgrp syl grpinvid1 syl3anc biimpar sneqd fveq2d eqtrd ex
      necon3d mpd ) AFQCRZGQZCRZUAFGBUBZHUAPAVGHVDVFAVGHSZVDVFSAVHUCZVDFEUDRZRZ
      QZCRZVFAVDVMSVHAVMVDAEUJTZFDTZVMVDSMNVJCDEFIVJUEZLUFUGUHUIVIVLVECVIVKGAVK
      GSZVHAEUKTZVOGDTVQVHULAVNVRMEUMUNNODBEVJFGHIJKVPUOUPUQURUSUTVAVBVC $.
  $}

  ${
    lsslsp.x $e |- X = ( W |`s U ) $.
    lsslsp.m $e |- M = ( LSpan ` W ) $.
    lsslsp.n $e |- N = ( LSpan ` X ) $.
    lsslsp.l $e |- L = ( LSubSp ` W ) $.
    $( Spans in submodules correspond to spans in the containing module.
       (Contributed by Stefan O'Rear, 12-Dec-2014.)  TODO:  Shouldn't we swap
       ` M `` G ` and ` N `` G ` since we are computing a property of
       ` N `` G ` ?  (Like we say sin 0 = 0 and not 0 = sin 0.) - NM
       15-Mar-2015. $)
    lsslsp $p |- ( ( W e. LMod /\ U e. L /\ G C_ U ) ->
      ( M ` G ) = ( N ` G ) ) $=
      ( clmod wcel wss cfv wa 3adant3 eqid syl2anc lspssp w3a simp1 cbs lsslmod
      clss simp3 wceq lssss 3ad2ant2 ressbas2 syl sseqtrd lspcl wb lsslss mpbid
      simpld lspssid syl3anc sstrd mpbir2and eqssd ) FLMZACMZBANZUAZBDOZBEOZVFV
      CVHCMZBVHNZVGVHNVCVDVEUBZVFVIVHANZVFVHGUEOZMZVIVLPZVFGLMZBGUCOZNZVNVCVDVP
      VECAFGHKUDQZVFBAVQVCVDVEUFZVFAFUCOZNZAVQUGVDVCWBVECAWAFWARZKUHUIZAWAGFHWC
      UJUKULZVMBEVQGVQRZVMRZJUMSVCVDVNVOUNVECVMAVHFGHKWGUOQUPUQVFVPVRVJVSWEBEVQ
      GWFJURSCBVHDFKITUSVFVPVGVMMZBVGNZVHVGNVSVFWHVGCMZVGANZVFVCBWANZWJVKVFBAWA
      VTWDUTZCBDWAFWCKIUMSCBADFKITVCVDWHWJWKPUNVECVMAVGFGHKWGUOQVAVFVCWLWIVKWMB
      DWAFWCIURSVMBVGEGWGJTUSVB $.
  $}

  ${
    lss0v.x $e |- X = ( W |`s U ) $.
    lss0v.o $e |- .0. = ( 0g ` W ) $.
    lss0v.z $e |- Z = ( 0g ` X ) $.
    lss0v.l $e |- L = ( LSubSp ` W ) $.
    $( The zero vector in a submodule equals the zero vector in the including
       module.  (Contributed by NM, 15-Mar-2015.) $)
    lss0v $p |- ( ( W e. LMod /\ U e. L ) -> Z = .0. ) $=
      ( clmod wcel csn cuni c0 clspn cfv wceq eqid c0g wa wss 0ss lsslsp mp3an3
      lsp0 adantr lsslmod syl 3eqtr3rd unieqd cvv fvex eqeltri unisn 3eqtr3g )
      CKLZABLZUAZFMZNEMZNFEUSUTVAUSOCPQZQZODPQZQZVAUTUQUROAUBVCVERAUCAOBVBVDCDG
      VBSZVDSZJUDUEUQVCVARURVBCEHVFUFUGUSDKLVEUTRBACDGJUHVDDFIVGUFUIUJUKFFDTQUL
      IDTUMUNUOEECTQULHCTUMUNUOUP $.
  $}

  ${
    $d a b x y z B $.  $d a b s t x y z K $.  $d a b s x y z ph $.  $d x y W $.
    $d a b s t x y z L $.  $d a b x y z P $.
    lsspropd.b1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lsspropd.b2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lsspropd.w $e |- ( ph -> B C_ W ) $.
    lsspropd.p $e |- ( ( ph /\ ( x e. W /\ y e. W ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lsspropd.s1 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) e. W ) $.
    lsspropd.s2 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    lsspropd.p1 $e |- ( ph -> P = ( Base ` ( Scalar ` K ) ) ) $.
    lsspropd.p2 $e |- ( ph -> P = ( Base ` ( Scalar ` L ) ) ) $.
    $( If two structures have the same components (properties), they have the
       same subspace structure.  (Contributed by Mario Carneiro, 9-Feb-2015.)
       (Revised by Mario Carneiro, 14-Jun-2015.) $)
    lsspropd $p |- ( ph -> ( LSubSp ` K ) = ( LSubSp ` L ) ) $=
      ( vz cfv wcel eqid vs va vb clss cv cbs wss c0 wne cvsca cplusg wral csca
      co w3a wa wb wceq simpll simprl simplr simprrl sseldd ralrimivva ad2antrr
      proplem2 syl21anc simprrr proplem syl12anc oveq1d eqtrd anassrs 2ralbidva
      eleq1d ralbidva anbi2d pm5.32da 3anass 3bitr4g sseq2d raleqdv islss eqrdv
      3anbi13d 3bitr3d ) AUAFUDRZGUDRZAUAUEZFUFRZUGZWIUHUIZQUEZUBUEZFUJRZUNZUCU
      EZFUKRZUNZWISZUCWIULUBWIULZQFUMRZUFRZULZUOZWIGUFRZUGZWLWMWNGUJRZUNZWQGUKR
      ZUNZWISZUCWIULUBWIULZQGUMRZUFRZULZUOZWIWGSWIWHSAWIDUGZWLXAQEULZUOZXRWLXMQ
      EULZUOZXEXQAXRWLXSUPZUPXRWLYAUPZUPXTYBAXRYCYDAXRUPZXSYAWLYEXAXMQEYEWMESZU
      PWTXLUBUCWIWIYEYFWNWISZWQWISZUPZWTXLUQYEYFYIUPZUPZWSXKWIYKWSWPWQXJUNZXKYK
      AWPHSZWQHSWSYLURAXRYJUSZYKYFWNDSZBUECUEWOUNHSZCDULBEULZYMYEYFYIUTZYKWIDWN
      AXRYJVAZYEYFYGYHVBVCZAYQXRYJAYPBCEDMVDVEBCEDHWOWMWNVFVGYKDHWQADHUGXRYJKVE
      YKWIDWQYSYEYFYGYHVHVCVCABCHHWRXJWPWQLVIVJYKWPXIWQXJYKAYFYOWPXIURYNYRYTABC
      EDWOXHWMWNNVIVJVKVLVOVMVNVPVQVRXRWLXSVSXRWLYAVSVTAXRWKXSXDWLADWJWIIWAAXAQ
      EXCOWBWEAXRXGYAXPWLADXFWIJWAAXMQEXOPWBWEWFQXCWRWGWOWIXBWJFUBUCXBTXCTWJTWR
      TWOTWGTWCQXOXJWHXHWIXNXFGUBUCXNTXOTXFTXJTXHTWHTWCVTWD $.

    lsspropd.v1 $e |- ( ph -> K e. _V ) $.
    lsspropd.v2 $e |- ( ph -> L e. _V ) $.
    $( If two structures have the same components (properties), they have the
       same span function.  (Contributed by Mario Carneiro, 9-Feb-2015.)
       (Revised by Mario Carneiro, 14-Jun-2015.) $)
    lsppropd $p |- ( ph -> ( LSpan ` K ) = ( LSpan ` L ) ) $=
      ( vs vt cbs cfv cpw cv wss clss crab cint cmpt clspn eqtr3d wceq lsspropd
      pweqd rabeq syl inteqd mpteq12dv cvv wcel eqid lspfval 3eqtr4d ) ASFUAUBZ
      UCZSUDTUDUEZTFUFUBZUGZUHZUIZSGUAUBZUCZVFTGUFUBZUGZUHZUIZFUJUBZGUJUBZASVEV
      IVLVOAVDVKADVDVKIJUKUNAVHVNAVGVMULVHVNULABCDEFGHIJKLMNOPUMVFTVGVMUOUPUQUR
      AFUSUTVQVJULQTVGVQVDFUSSVDVAVGVAVQVAVBUPAGUSUTVRVPULRTVMVRVKGUSSVKVAVMVAV
      RVAVBUPVC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Homomorphisms and isomorphisms of left modules
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LMHom $.
  $c LMIso $.
  $c ~=m $.

  $( Extend class notation with the generator of left module hom-sets. $)
  clmhm $a class LMHom $.

  $( The class of left module isomorphism sets. $)
  clmim $a class LMIso $.

  $( The class of the left module isomorphism relation. $)
  clmic $a class ~=m $.

  ${
    $d f s t w x B $.  $d f s t w y E $.  $d f s t w K $.  $d f s t w x y S $.
    $d f x y F $.  $d f g s t w x y T $.  $d f s t w .x. $.  $d f s t w .X. $.
    $d f s t w L $.
    $( A homomorphism of left modules is a group homomorphism which
       additionally preserves the scalar product.  This requires both
       structures to be left modules over the same ring.  (Contributed by
       Stefan O'Rear, 31-Dec-2014.) $)
    df-lmhm $a |- LMHom = ( s e. LMod , t e. LMod
     |-> { f e. ( s GrpHom t ) |
        [. ( Scalar ` s ) / w ]. ( ( Scalar ` t ) = w /\
          A. x e. ( Base ` w ) A. y e. ( Base ` s )
          ( f ` ( x ( .s ` s ) y ) ) = ( x ( .s ` t ) ( f ` y ) ) ) } ) $.

    $( An isomorphism of modules is a homomorphism which is also a bijection,
       i.e. it preserves equality as well as the group and scalar operations.
       (Contributed by Stefan O'Rear, 21-Jan-2015.) $)
    df-lmim $a |- LMIso = ( s e. LMod , t e. LMod |-> { g e. ( s LMHom t ) |
        g : ( Base ` s ) -1-1-onto-> ( Base ` t ) } ) $.

    $( Two modules are said to be isomorphic iff they are connected by at least
       one isomorphism.  (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    df-lmic $a |- ~=m = ( `' LMIso " ( _V \ 1o ) ) $.

    $( Lemma for module homomorphisms.  (Contributed by Stefan O'Rear,
       31-Dec-2014.) $)
    reldmlmhm $p |- Rel dom LMHom $=
      ( vs vt vw vx vy vf clmod cv csca cfv wceq cvsca co cbs wral wa wsbc cghm
      crab clmhm df-lmhm reldmmpt2 ) ABGGBHZIJCHZKDHZEHZAHZLJMFHZJUEUFUHJUCLJMK
      EUGNJODUDNJOPCUGIJQFUGUCRMSTDECBFAUAUB $.

    $( Lemma for module isomorphisms.  (Contributed by Stefan O'Rear,
       23-Aug-2015.) $)
    lmimfn $p |- LMIso Fn ( LMod X. LMod ) $=
      ( vs vt vg clmod cv cbs cfv wf1o clmhm co crab clmim df-lmim ovex fnmpt2i
      rabex ) ABDDAEZFGBEZFGCEHZCQRIJZKLBCAMSCTQRINPO $.

    islmhm.k $e |- K = ( Scalar ` S ) $.
    islmhm.l $e |- L = ( Scalar ` T ) $.
    islmhm.b $e |- B = ( Base ` K ) $.
    islmhm.e $e |- E = ( Base ` S ) $.
    islmhm.m $e |- .x. = ( .s ` S ) $.
    islmhm.n $e |- .X. = ( .s ` T ) $.
    $( Property of being a homomorphism of left modules.  (Contributed by
       Stefan O'Rear, 1-Jan-2015.)  (Proof shortened by Mario Carneiro,
       30-Apr-2015.) $)
    islmhm $p |- ( F e. ( S LMHom T ) <->
       ( ( S e. LMod /\ T e. LMod ) /\ ( F e. ( S GrpHom T ) /\ L = K /\
         A. x e. B A. y e. E ( F ` ( x .x. y ) ) = ( x .X. ( F ` y ) ) ) ) ) $=
      ( co wceq cfv vs vt vw vf clmhm wcel clmod wa cghm cv wral w3a csca cvsca
      cbs wsbc crab df-lmhm elmpt2cl oveq12 cvv a1i simplr fveq2d syl6eqr simpr
      fvex simpll eqtrd eqeq12d raleqbidv anbi12d sbcied rabeqbidv ovex ovmpt2a
      oveqd rabex eleq2d fveq1 oveq2d anbi2d elrab 3anass bitr4i syl6bb biadan2
      2ralbidv ) IDEUERZUFZDUGUFEUGUFUHZIDEUIRZUFZKJSZAUJZBUJZFRZITZWOWPITZGRZS
      ZBHUKACUKZULZUAUBUGUGUBUJZUMTZUCUJZSZWOWPUAUJZUNTZRZUDUJZTZWOWPXKTZXDUNTZ
      RZSZBXHUOTZUKZAXFUOTZUKZUHZUCXHUMTZUPZUDXHXDUIRZUQZDEUEIABUCUBUDUAURZUSWK
      WJIWNWQXKTZWOXMGRZSZBHUKZACUKZUHZUDWLUQZUFZXCWKWIYMIUAUBDEUGUGYEYMUEXHDSZ
      XDESZUHZYCYLUDYDWLXHDXDEUIUTYQYAYLUCYBVAYBVAUFYQXHUMVGVBYQXFYBSZUHZXGWNXT
      YKYSXEKXFJYSXEEUMTKYSXDEUMYOYPYRVCZVDMVEYSXFDUMTZJYSXFYBUUAYQYRVFYSXHDUMY
      OYPYRVHZVDVILVEZVJYSXRYJAXSCYSXSJUOTCYSXFJUOUUCVDNVEYSXPYIBXQHYSXQDUOTHYS
      XHDUOUUBVDOVEYSXLYGXOYHYSXJWQXKYSXIFWOWPYSXIDUNTFYSXHDUNUUBVDPVEVQVDYSXNG
      WOXMYSXNEUNTGYSXDEUNYTVDQVEVQVJVKVKVLVMVNYFYLUDWLDEUIVOVRVPVSYNWMWNXBUHZU
      HXCYLUUDUDIWLXKISZYKXBWNUUEYIXAABCHUUEYGWRYHWTWQXKIVTUUEXMWSWOGWPXKIVTWAV
      JWHWBWCWMWNXBWDWEWFWG $.

    $( Property of a module homomorphism, similar to ~ ismhm .  (Contributed by
       Stefan O'Rear, 7-Mar-2015.) $)
    islmhm3 $p |- ( ( S e. LMod /\ T e. LMod ) -> ( F e. ( S LMHom T ) <->
       ( F e. ( S GrpHom T ) /\ L = K /\
         A. x e. B A. y e. E ( F ` ( x .x. y ) ) = ( x .X. ( F ` y ) ) ) ) ) $=
      ( co wcel clmod clmhm wa cghm wceq cv cfv wral w3a islmhm baib ) IDEUARSD
      TSETSUBIDEUCRSKJUDAUEZBUEZFRIUFUKULIUFGRUDBHUGACUGUHABCDEFGHIJKLMNOPQUIUJ
      $.
  $}

  ${
    $d F a b $.  $d S a b $.  $d T a b $.  $d V a b $.  $d L a b $.
    $d K a b $.
    lmhmlem.k $e |- K = ( Scalar ` S ) $.
    lmhmlem.l $e |- L = ( Scalar ` T ) $.
    $( Non-quantified consequences of a left module homomorphism.  (Contributed
       by Stefan O'Rear, 1-Jan-2015.) $)
    lmhmlem $p |- ( F e. ( S LMHom T ) ->
        ( ( S e. LMod /\ T e. LMod ) /\ ( F e. ( S GrpHom T ) /\ L = K ) ) ) $=
      ( va vb co wcel clmod wa wceq cv cvsca cfv cbs wral eqid clmhm w3a islmhm
      cghm 3simpa anim2i sylbi ) CABUAJKALKBLKMZCABUDJKZEDNZHOZIOZAPQZJCQUKULCQ
      BPQZJNIARQZSHDRQZSZUBZMUHUIUJMZMHIUPABUMUNUOCDEFGUPTUOTUMTUNTUCURUSUHUIUJ
      UQUEUFUG $.

    $( A homomorphism of left modules constrains both modules to the same ring
       of scalars.  (Contributed by Stefan O'Rear, 1-Jan-2015.) $)
    lmhmsca $p |- ( F e. ( S LMHom T ) -> L = K ) $=
      ( clmhm co wcel clmod wa cghm wceq lmhmlem simprr syl ) CABHIJAKJBKJLZCAB
      MIJZEDNZLLTABCDEFGORSTPQ $.
  $}

  ${
    $( A homomorphism of left modules is a homomorphism of groups.
       (Contributed by Stefan O'Rear, 1-Jan-2015.) $)
    lmghm $p |- ( F e. ( S LMHom T ) -> F e. ( S GrpHom T ) ) $=
      ( clmhm co wcel clmod wa cghm csca cfv wceq eqid lmhmlem simprl syl ) CAB
      DEFAGFBGFHZCABIEFZBJKZAJKZLZHHRABCTSTMSMNQRUAOP $.

    $( A homomorphism of left modules has a left module as codomain.
       (Contributed by Stefan O'Rear, 1-Jan-2015.) $)
    lmhmlmod2 $p |- ( F e. ( S LMHom T ) -> T e. LMod ) $=
      ( clmhm co wcel clmod wa cghm csca cfv wceq eqid lmhmlem simplr syl ) CAB
      DEFAGFZBGFZHCABIEFBJKZAJKZLHZHRABCTSTMSMNQRUAOP $.

    $( A homomorphism of left modules has a left module as domain.
       (Contributed by Stefan O'Rear, 1-Jan-2015.) $)
    lmhmlmod1 $p |- ( F e. ( S LMHom T ) -> S e. LMod ) $=
      ( clmhm co wcel clmod wa cghm csca cfv wceq eqid lmhmlem simpld ) CABDEFZ
      AGFZBGFZPQRHCABIEFBJKZAJKZLHABCTSTMSMNOO $.
  $}

  ${
    lmhmf.b $e |- B = ( Base ` S ) $.
    lmhmf.c $e |- C = ( Base ` T ) $.
    $( A homomorphism of left modules is a function.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    lmhmf $p |- ( F e. ( S LMHom T ) -> F : B --> C ) $=
      ( clmhm co wcel cghm wf lmghm ghmf syl ) ECDHIJECDKIJABELCDEMCDEABFGNO $.
  $}

  ${
    $d K a b $.  $d S a b $.  $d T a b $.  $d E a b $.  $d .x. a b $.
    $d .X. a b $.  $d B a b $.  $d X a b $.  $d Y a b $.  $d V a b $.
    $d F a b $.
    lmhmlin.k $e |- K = ( Scalar ` S ) $.
    lmhmlin.b $e |- B = ( Base ` K ) $.
    lmhmlin.e $e |- E = ( Base ` S ) $.
    lmhmlin.m $e |- .x. = ( .s ` S ) $.
    lmhmlin.n $e |- .X. = ( .s ` T ) $.
    $( A homomorphism of left modules is ` K ` -linear.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    lmhmlin $p |- ( ( F e. ( S LMHom T ) /\ X e. B /\ Y e. E ) ->
      ( F ` ( X .x. Y ) ) = ( X .X. ( F ` Y ) ) ) $=
      ( va co wcel cfv wceq vb clmhm cv wral wa cghm csca clmod w3a eqid islmhm
      simprbi simp3d oveq1 fveq2d eqeq12d oveq2 oveq2d rspc2v syl5com 3impib
      fveq2 ) GBCUBQRZIARZJFRZIJDQZGSZIJGSZEQZTZVCPUCZUAUCZDQZGSZVKVLGSZEQZTZUA
      FUDPAUDZVDVEUEVJVCGBCUFQRZCUGSZHTZVRVCBUHRCUHRUEVSWAVRUIPUAABCDEFGHVTKVTU
      JLMNOUKULUMVQVJIVLDQZGSZIVOEQZTPUAIJAFVKITZVNWCVPWDWEVMWBGVKIVLDUNUOVKIVO
      EUNUPVLJTZWCVGWDVIWFWBVFGVLJIDUQUOWFVOVHIEVLJGVBURUPUSUTVA $.
  $}

  ${
    lmodvsinv.b $e |- B = ( Base ` W ) $.
    lmodvsinv.f $e |- F = ( Scalar ` W ) $.
    lmodvsinv.s $e |- .x. = ( .s ` W ) $.
    lmodvsinv.n $e |- N = ( invg ` W ) $.
    lmodvsinv.m $e |- M = ( invg ` F ) $.
    lmodvsinv.k $e |- K = ( Base ` F ) $.
    $( Multiplication of a vector by a negated scalar.  (Contributed by Stefan
       O'Rear, 28-Feb-2015.) $)
    lmodvsinv $p |- ( ( W e. LMod /\ R e. K /\ X e. B ) ->
        ( ( M ` R ) .x. X ) = ( N ` ( R .x. X ) ) ) $=
      ( wcel cfv co wceq syl clmod w3a cur cmulr simp1 cgrp crg 3ad2ant1 rnggrp
      lmodrng eqid rngidcl grpinvcl syl2anc simp2 simp3 syl13anc rngnegl oveq1d
      lmodvsass lmodvscl lmodvneg1 3eqtr3d ) HUAPZBEPZIAPZUBZDUCQZFQZBDUDQZRZIC
      RZVIBICRZCRZBFQZICRVMGQZVGVDVIEPZVEVFVLVNSVDVEVFUEZVGDUFPZVHEPZVQVGDUGPZV
      SVDVEWAVFDHKUJUHZDUITVGWAVTWBEDVHOVHUKZULTEDFVHONUMUNVDVEVFUOZVDVEVFUPVIB
      CVJDEAHIJKLOVJUKZUTUQVGVKVOICVGEDVJVHFBOWEWCNWBWDURUSVGVDVMAPVNVPSVRBCDEA
      HIJKLOVACVHDFGAHVMJMKLWCNVBUNVC $.
  $}

  ${
    lmodvsinv2.b $e |- B = ( Base ` W ) $.
    lmodvsinv2.f $e |- F = ( Scalar ` W ) $.
    lmodvsinv2.s $e |- .x. = ( .s ` W ) $.
    lmodvsinv2.n $e |- N = ( invg ` W ) $.
    lmodvsinv2.k $e |- K = ( Base ` F ) $.
    $( Multiplying a negated vector by a scalar.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    lmodvsinv2 $p |- ( ( W e. LMod /\ R e. K /\ X e. B ) ->
        ( R .x. ( N ` X ) ) = ( N ` ( R .x. X ) ) ) $=
      ( wcel co cfv wceq eqid syl2anc lmodvscl clmod w3a c0g cgrp simp1 lmodgrp
      cplusg syl simp3 grprinv simp2 grpinvcl lmodvsdi syl13anc lmodvs0 3eqtr3d
      oveq2d wb syl3anc grpinvid1 mpbird eqcomd ) GUANZBENZHANZUBZBHCOZFPZBHFPZ
      COZVFVHVJQZVGVJGUGPZOZGUCPZQZVFBHVIVLOZCOZBVNCOZVMVNVFVPVNBCVFGUDNZVEVPVN
      QVFVCVSVCVDVEUEZGUFUHZVCVDVEUIZAVLGFHVNIVLRZVNRZLUJSUQVFVCVDVEVIANZVQVMQV
      TVCVDVEUKZWBVFVSVEWEWAWBAGFHILULSZVLBCDEAGHVIIWCJKMUMUNVFVCVDVRVNQVTWFCDE
      GBVNJKMWDUOSUPVFVSVGANVJANZVKVOURWABCDEAGHIJKMTVFVCVDWEWHVTWFWGBCDEAGVIIJ
      KMTUSAVLGFVGVJVNIWCWDLUTUSVAVB $.
  $}

  ${
    $d x y z .+^ $.  $d x y z B $.  $d x y z C $.  $d x y z E $.  $d x y z F $.
    $d x y z .+ $.  $d x y z K $.  $d x y z L $.  $d x y z S $.  $d x y z T $.
    $d x z .x. $.  $d x z .X. $.
    islmhm2.b $e |- B = ( Base ` S ) $.
    islmhm2.c $e |- C = ( Base ` T ) $.
    islmhm2.k $e |- K = ( Scalar ` S ) $.
    islmhm2.l $e |- L = ( Scalar ` T ) $.
    islmhm2.e $e |- E = ( Base ` K ) $.
    islmhm2.p $e |- .+ = ( +g ` S ) $.
    islmhm2.q $e |- .+^ = ( +g ` T ) $.
    islmhm2.m $e |- .x. = ( .s ` S ) $.
    islmhm2.n $e |- .X. = ( .s ` T ) $.
    $( A one-equation proof of linearity of a left module homomorphism, similar
       to ~ df-lss .  (Contributed by Mario Carneiro, 7-Oct-2015.) $)
    islmhm2 $p |- ( ( S e. LMod /\ T e. LMod ) -> ( F e. ( S LMHom T ) <->
          ( F : B --> C /\ L = K /\ A. x e. E A. y e. B A. z e. B
  ( F ` ( ( x .x. y ) .+ z ) ) = ( ( x .X. ( F ` y ) ) .+^ ( F ` z ) ) ) ) ) $=
      ( clmod wcel wa clmhm co wf wceq cv cfv wral w3a lmhmf lmhmsca cghm lmghm
      adantr lmhmlmod1 simpr1 simpr2 syl3anc simpr3 ghmlin lmhmlin oveq1d eqtrd
      lmodvscl 3adant3r3 ralrimivvva 3jca adantl lmodgrp anim12i wi cur lmodrng
      cgrp crg ad2antrr eqid rngidcl oveq1 fveq2d eqeq12d 2ralbidv 3syl simplll
      rspcv simprl lmodvs1 syl2anc simplrr simpllr ffvelrnd eqtr3d sylibd exp32
      simplrl 2ralbidva 3imp2 jca isghm c0g ghmid ad3antrrr grpidcl oveq2 fveq2
      sylanbrc syl oveq2d simprr grprid simplr3 simplr2 syl6eqr simplr1 anassrs
      cbs eleqtrrd ralimdva 3exp2 com45 mpd wb islmhm3 mpbir3and impbida ) HUEU
      FZIUEUFZUGZMHIUHUIUFZDEMUJZONUKZAULZBULZJUIZCULZFUIZMUMZYRYSMUMZKUIZUUAMU
      MZGUIZUKZCDUNZBDUNZALUNZUOZYOUULYNYOYPYQUUKDEHIMPQUPHIMNORSUQYOUUHABCLDDY
      OYRLUFZYSDUFZUUADUFZUOZUGZUUCYTMUMZUUFGUIZUUGUUQMHIURUIUFZYTDUFZUUOUUCUUS
      UKYOUUTUUPHIMUSUTUUQYLUUMUUNUVAYOYLUUPHIMVAUTYOUUMUUNUUOVBYOUUMUUNUUOVCYR
      JNLDHYSPRUCTVJZVDYOUUMUUNUUOVEFGHIYTMUUADPUAUBVFVDUUQUURUUEUUFGYOUUMUUNUU
      RUUEUKZUUOLHIJKDMNYRYSRTPUCUDVGVKVHVIVLVMVNYNUULUGZYOUUTYQUVCBDUNZALUNZUV
      DHVTUFZIVTUFZUGZYPYSUUAFUIZMUMZUUDUUFGUIZUKZCDUNBDUNZUGUUTYNUVIUULYLUVGYM
      UVHHVOZIVOZVPUTUVDYPUVNYNYPYQUUKVBYNYPYQUUKUVNYNYPYQUUKUVNVQYNYPYQUGZUGZU
      UKNVRUMZYSJUIZUUAFUIZMUMZUVSUUDKUIZUUFGUIZUKZCDUNBDUNZUVNUVRNWAUFZUVSLUFU
      UKUWFVQYLUWGYMUVQNHRVSWBLNUVSTUVSWCZWDUUJUWFAUVSLYRUVSUKZUUHUWEBCDDUWIUUC
      UWBUUGUWDUWIUUBUWAMUWIYTUVTUUAFYRUVSYSJWEVHWFUWIUUEUWCUUFGYRUVSUUDKWEVHWG
      WHWKWIUVRUWEUVMBCDDUVRUUNUUOUGZUGZUWBUVKUWDUVLUWKUWAUVJMUWKUVTYSUUAFUWKYL
      UUNUVTYSUKYLYMUVQUWJWJUVRUUNUUOWLZJUVSNDHYSPRUCUWHWMWNVHWFUWKUWCUUDUUFGUW
      KOVRUMZUUDKUIZUWCUUDUWKUWMUVSUUDKUWKONVRYNYPYQUWJWOWFVHUWKYMUUDEUFZUWNUUD
      UKYLYMUVQUWJWPUWKDEYSMYNYPYQUWJXAUWLWQKUWMOEIUUDQSUDUWMWCWMWNWRVHWGXBWSWT
      XCXDCBFGHIMDEPQUAUBXEXLZYNYPYQUUKVCUVDHXFUMZMUMZIXFUMZUKZUVFUVDUUTUWTUWPH
      IMUWQUWSUWQWCZUWSWCZXGXMYNYPYQUUKUWTUVFVQYNYPYQUWTUUKUVFYNYPYQUWTUUKUVFVQ
      YNYPYQUWTUOZUGZUUJUVEALUXDUUMUGUUIUVCBDUXDUUMUUNUUIUVCVQUXDUUMUUNUGZUGZUU
      IYTUWQFUIZMUMZUUEUWRGUIZUKZUVCUXFUVGUWQDUFUUIUXJVQYLUVGYMUXCUXEUVOXHZDHUW
      QPUXAXIUUHUXJCUWQDUUAUWQUKZUUCUXHUUGUXIUXLUUBUXGMUUAUWQYTFXJWFUXLUUFUWRUU
      EGUUAUWQMXKXNWGWKWIUXFUXHUURUXIUUEUXFUXGYTMUXFUVGUVAUXGYTUKUXKUXFYLUUMUUN
      UVAYLYMUXCUXEWJUXDUUMUUNWLZUXDUUMUUNXOZUVBVDDFHYTUWQPUAUXAXPWNWFUXFUXIUUE
      UWSGUIZUUEUXFUWRUWSUUEGYPYQUWTYNUXEXQXNUXFUVHUUEEUFZUXOUUEUKUXFYMUVHYLYMU
      XCUXEWPZUVPXMUXFYMYROYBUMZUFUWOUXPUXQUXFYRLUXRUXMUXFUXRNYBUMLUXFONYBYPYQU
      WTYNUXEXRWFTXSYCUXFDEYSMYPYQUWTYNUXEXTUXNWQYRKOUXREIUUDQSUDUXRWCVJVDEGIUU
      EUWSQUBUXBXPWNVIWGWSYAYDYDYEYFXCYGYNYOUUTYQUVFUOYHUULABLHIJKDMNORSTPUCUDY
      IUTYJYK $.
  $}

  ${
    $d ph x y $.  $d F x y $.  $d S x y $.  $d T x y $.  $d A x y $.
    $d B x y $.  $d X x y $.  $d J x y $.  $d N x y $.  $d K x y $.
    islmhmd.x $e |- X = ( Base ` S ) $.
    islmhmd.a $e |- .x. = ( .s ` S ) $.
    islmhmd.b $e |- .X. = ( .s ` T ) $.
    islmhmd.k $e |- K = ( Scalar ` S ) $.
    islmhmd.j $e |- J = ( Scalar ` T ) $.
    islmhmd.n $e |- N = ( Base ` K ) $.
    islmhmd.s $e |- ( ph -> S e. LMod ) $.
    islmhmd.t $e |- ( ph -> T e. LMod ) $.
    islmhmd.c $e |- ( ph -> J = K ) $.
    islmhmd.f $e |- ( ph -> F e. ( S GrpHom T ) ) $.
    islmhmd.l $e |- ( ( ph /\ ( x e. N /\ y e. X ) ) -> ( F ` ( x .x. y ) ) =
          ( x .X. ( F ` y ) ) ) $.
    $( Deduction for a module homomorphism.  (Contributed by Stefan O'Rear,
       4-Feb-2015.) $)
    islmhmd $p |- ( ph -> F e. ( S LMHom T ) ) $=
      ( clmod wcel wa cghm co wceq cv cfv wral w3a clmhm ralrimivva 3jca islmhm
      jca sylanbrc ) ADUDUEZEUDUEZUFHDEUGUHUEZIJUIZBUJZCUJZFUHHUKVDVEHUKGUHUIZC
      LULBKULZUMHDEUNUHUEAUTVASTURAVBVCVGUBUAAVFBCKLUCUOUPBCKDEFGLHJIPQRMNOUQUS
      $.
  $}

  ${
    $d x y B $.  $d x y M $.  $d x y N $.  $d x y S $.  $d x y T $.
    $d x y .0. $.
    0lmhm.z $e |- .0. = ( 0g ` N ) $.
    0lmhm.b $e |- B = ( Base ` M ) $.
    0lmhm.s $e |- S = ( Scalar ` M ) $.
    0lmhm.t $e |- T = ( Scalar ` N ) $.
    $( The constant zero linear function between two modules.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    0lmhm $p |- ( ( M e. LMod /\ N e. LMod /\ S = T ) ->
        ( B X. { .0. } ) e. ( M LMHom N ) ) $=
      ( vx vy clmod wcel wceq cvsca cfv cbs eqid co w3a simp1 simp2 eqcomd cghm
      csn cxp simp3 cgrp lmodgrp 0ghm syl2an 3adant3 cv wa simpl2 simprl simpl3
      fveq2d eleqtrd lmodvs0 syl2anc c0g cvv fvex fvconst2 oveq2d simpl1 simprr
      eqeltri ad2antll lmodvscl syl3anc syl 3eqtr4rd islmhmd ) DMNZEMNZBCOZUAZK
      LDEDPQZEPQZAFUFUGZCBBRQZAHWASZWBSZIJWDSZVQVRVSUBVQVRVSUCVTBCVQVRVSUHUDVQV
      RWCDEUETNZVSVQDUINEUINWHVRDUJEUJADEFGHUKULUMVTKUNZWDNZLUNZANZUOZUOZWIFWBT
      ZFWIWKWCQZWBTZWIWKWATZWCQZWNVRWICRQZNWOFOVQVRVSWMUPWNWIWDWTVTWJWLUQZWNBCR
      VQVRVSWMURUSUTWBCWTEWIFJWFWTSGVAVBWLWQWOOVTWJWLWPFWIWBAFWKFEVCQVDGEVCVEVJ
      ZVFVGVKWNWRANZWSFOWNVQWJWLXCVQVRVSWMVHXAVTWJWLVIWIWABWDADWKHIWEWGVLVMAFWR
      XBVFVNVOVP $.
  $}

  ${
    $d x y B $.  $d x y M $.
    idlmhm.b $e |- B = ( Base ` M ) $.
    $( The identity function on a module is linear.  (Contributed by Stefan
       O'Rear, 4-Sep-2015.) $)
    idlmhm $p |- ( M e. LMod -> ( _I |` B ) e. ( M LMHom M ) ) $=
      ( vx vy clmod wcel cvsca cfv cid cres csca cbs eqid co syl cv wceq fvresi
      wa id eqidd cgrp cghm lmodgrp idghm lmodvscl 3expb ad2antll oveq2d eqtr4d
      islmhmd ) BFGZDEBBBHIZUNJAKZBLIZUPUPMIZACUNNZURUPNZUSUQNZUMUAZVAUMUPUBUMB
      UCGUOBBUDOGBUEABCUFPUMDQZUQGZEQZAGZTTZVBVDUNOZUOIZVGVBVDUOIZUNOVFVGAGZVHV
      GRUMVCVEVJVBUNUPUQABVDCUSURUTUGUHAVGSPVFVIVDVBUNVEVIVDRUMVCAVDSUIUJUKUL
      $.
  $}

  ${
    $d x y I $.  $d x y M $.
    invlmhm.b $e |- I = ( invg ` M ) $.
    $( The negative function on a module is linear.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    invlmhm $p |- ( M e. LMod -> I e. ( M LMHom M ) ) $=
      ( vx vy clmod wcel cvsca cfv csca cbs eqid id eqidd cabel cghm co lmodabl
      invghm cv sylib wceq w3a lmodvsinv2 eqcomd 3expb islmhmd ) BFGZDEBBBHIZUI
      ABJIZUJUJKIZBKIZULLZUILZUNUJLZUOUKLZUHMZUQUHUJNUHBOGABBPQGBRULBAUMCSUAUHD
      TZUKGZETZULGZURUTUIQAIZURUTAIUIQZUBUHUSVAUCVCVBULURUIUJUKABUTUMUOUNCUPUDU
      EUFUG $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y M $.  $d x y N $.  $d x y O $.
    $( The composition of two module-linear functions is module-linear.
       (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    lmhmco $p |- ( ( F e. ( N LMHom O ) /\ G e. ( M LMHom N ) ) ->
        ( F o. G ) e. ( M LMHom O ) ) $=
      ( vx vy clmhm co wcel wa cvsca cfv csca cbs eqid clmod cghm wceq syl3anc
      ccom lmhmlmod1 adantl lmhmlmod2 adantr sylan9eq lmghm ghmco syl2an simplr
      lmhmsca cv simprl simprr lmhmlin fveq2d simpll ad2antlr eleqtrrd wf lmhmf
      ffvelrnda adantrl eqtrd wfn ffn syl lmodvscl fvco2 syl2anc oveq2d 3eqtr4d
      islmhmd ) ADEHIJZBCDHIJZKZFGCECLMZELMZABUAZENMZCNMZWAOMZCOMZWCPZVQPZVRPZW
      APZVTPZWBPZVOCQJZVNCDBUBZUCVNEQJVODEAUDUEVNVOVTDNMZWADEAWLVTWLPZWHUKCDBWA
      WLWGWMUKZUFVNADERIJBCDRIJVSCERIJVODEAUGCDBUGCDEABUHUIVPFULZWBJZGULZWCJZKZ
      KZWOWQVQIZBMZAMZWOWQBMZAMZVRIZXAVSMZWOWQVSMZVRIWTXCWOXDDLMZIZAMZXFWTXBXJA
      WTVOWPWRXBXJSVNVOWSUJVPWPWRUMZVPWPWRUNZWBCDVQXIWCBWAWOWQWGWIWDWEXIPZUOTUP
      WTVNWOWLOMZJXDDOMZJZXKXFSVNVOWSUQWTWOWBXOXLVOXOWBSVNWSVOWLWAOWNUPURUSVPWR
      XQWPVPWCXPWQBVOWCXPBUTZVNWCXPCDBWDXPPZVAUCZVBVCXODEXIVRXPAWLWOXDWMXOPXSXN
      WFUOTVDWTBWCVEZXAWCJZXGXCSVPYAWSVPXRYAXTWCXPBVFVGUEZWTWJWPWRYBVOWJVNWSWKU
      RXLXMWOVQWAWBWCCWQWDWGWEWIVHTWCABXAVIVJWTXHXEWOVRWTYAWRXHXESYCXMWCABWQVIV
      JVKVLVM $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y M $.  $d x y N $.  $d x y .+ $.
    lmhmplusg.p $e |- .+ = ( +g ` N ) $.
    $( The pointwise sum of two linear functions is linear.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    lmhmplusg $p |- ( ( F e. ( M LMHom N ) /\ G e. ( M LMHom N ) ) ->
        ( F oF .+ G ) e. ( M LMHom N ) ) $=
      ( vx vy co wcel wa cfv cbs eqid adantr wceq syl syl3anc ad2antrr cvv csca
      clmhm cvsca cof clmod lmhmlmod1 lmhmlmod2 lmhmsca cabel cghm lmghm adantl
      lmodabl ghmplusg cv simpll simprl simprr lmhmlin simplr oveq12d fveq2d wf
      eleqtrrd ffvelrnd ad2antlr lmodvsdi syl13anc eqtr4d wfn ffn fvex lmodvscl
      lmhmf a1i fnfvof syl22anc oveq2d 3eqtr4d islmhmd ) BDEUBIZJZCWAJZKZGHDEDU
      CLZEUCLZBCAUDIZEUALZDUALZWIMLZDMLZWKNZWENZWFNZWINZWHNZWJNZWBDUEJZWCDEBUFZ
      OWBEUEJZWCDEBUGZOZWBWHWIPWCDEBWIWHWOWPUHZOWDEUIJZBDEUJIZJZCXEJZWGXEJWDWTX
      DXBEUMQWBXFWCDEBUKOWCXGWBDECUKULABCDEFUNRWDGUOZWJJZHUOZWKJZKZKZXHXJWEIZBL
      ZXNCLZAIZXHXJBLZXJCLZAIZWFIZXNWGLZXHXJWGLZWFIXMXQXHXRWFIZXHXSWFIZAIZYAXMX
      OYDXPYEAXMWBXIXKXOYDPWBWCXLUPWDXIXKUQZWDXIXKURZWJDEWEWFWKBWIXHXJWOWQWLWMW
      NUSRXMWCXIXKXPYEPWBWCXLUTYGYHWJDEWEWFWKCWIXHXJWOWQWLWMWNUSRVAXMWTXHWHMLZJ
      XREMLZJXSYJJYAYFPWBWTWCXLXASXMXHWJYIYGWBYIWJPWCXLWBWHWIMXCVBSVDXMWKYJXJBW
      BWKYJBVCZWCXLWKYJDEBWLYJNZVNSZYHVEXMWKYJXJCWCWKYJCVCZWBXLWKYJDECWLYLVNVFZ
      YHVEAXHWFWHYIYJEXRXSYLFWPWNYINVGVHVIXMBWKVJZCWKVJZWKTJZXNWKJZYBXQPXMYKYPY
      MWKYJBVKQZXMYNYQYOWKYJCVKQZYRXMDMVLVOZXMWRXIXKYSWBWRWCXLWSSYGYHXHWEWIWJWK
      DXJWLWOWMWQVMRWKABCTXNVPVQXMYCXTXHWFXMYPYQYRXKYCXTPYTUUAUUBYHWKABCTXJVPVQ
      VRVSVT $.
  $}

  ${
    $d u v x y A $.  $d u v x y F $.  $d u v x y K $.  $d u v x y N $.
    $d v x y J $.  $d v x y M $.  $d u v x y .x. $.  $d v x y V $.
    lmhmvsca.v $e |- V = ( Base ` M ) $.
    lmhmvsca.s $e |- .x. = ( .s ` N ) $.
    lmhmvsca.j $e |- J = ( Scalar ` N ) $.
    lmhmvsca.k $e |- K = ( Base ` J ) $.
    $( The pointwise scalar product of a linear function and a constant is
       linear, over a commutative ring.  (Contributed by Mario Carneiro,
       22-Sep-2015.) $)
    lmhmvsca $p |- ( ( J e. CRing /\ A e. K /\ F e. ( M LMHom N ) ) ->
        ( ( V X. { A } ) oF .x. F ) e. ( M LMHom N ) ) $=
      ( vv wcel co cfv cbs eqid 3ad2ant3 wceq vx vy vu ccrg clmhm w3a cvsca csn
      cxp cof csca clmod lmhmlmod1 lmhmlmod2 lmhmsca cv cmpt ccom cghm cvv fvex
      eqeltri a1i simpl2 lmhmf ffvelrnda fconstmpt feqmptd offval2 eqidd fmptco
      wf oveq2 eqtr4d simp2 lmodvsghm syl2anc lmghm ghmco eqeltrd simpl1 simprl
      wa cmulr fveq2d syl5eq adantr eleqtrrd crngcom syl3anc ffvelrnd lmodvsass
      oveq1d simprr syl13anc 3eqtr3d lmodvscl 3expb sylan wfn ffn syl 3ad2antl3
      lmhmlin ofc1 mpdan oveq2d 3eqtr4d islmhmd ) DUDNZAENZCFGUEONZUFZUAUBFGFUG
      PZBHAUHUIZCBUJOZDFUKPZXQQPZHIXNRZJXQRZKXRRZXLXJFULNZXKFGCUMSZXLXJGULNZXKF
      GCUNSZXLXJDXQTXKFGCXQDXTKUOSZXMXPUCGQPZAUCUPZBOZUQZCURZFGUSOZXMXPMHAMUPZC
      PZBOZUQYKXMMHAYNBXOCUTEYGHUTNZXMHFQPUTIFQVAVBZVCXJXKXLYMHNVDXMHYGYMCXLXJH
      YGCVLZXKHYGFGCIYGRZVESZVFZXOMHAUQTXMMHAVGVCXMMHYGCYTVHZVIXMMUCHYGYNYIYOCY
      JUUAUUBXMYJVJYHYNABVMVKVNXMYJGGUSONZCYLNZYKYLNXMYDXKUUCYEXJXKXLVOUCABDEYG
      GYSKJLVPVQXLXJUUDXKFGCVRSFGGYJCVSVQVTXMUAUPZXRNZUBUPZHNZWCZWCZAUUEUUGCPZB
      OZBOZUUEAUUKBOZBOZUUEUUGXNOZXPPZUUEUUGXPPZBOUUJAUUEDWDPZOZUUKBOZUUEAUUSOZ
      UUKBOZUUMUUOUUJUUTUVBUUKBUUJXJXKUUEENZUUTUVBTXJXKXLUUIWAXJXKXLUUIVDZUUJUU
      EXREXMUUFUUHWBXMEXRTUUIXMEDQPXRLXMDXQQYFWEWFWGWHZEDUUSAUUELUUSRZWIWJWMUUJ
      YDXKUVDUUKYGNZUVAUUMTXMYDUUIYEWGZUVEUVFUUJHYGUUGCXMYRUUIYTWGXMUUFUUHWNZWK
      ZAUUEBUUSDEYGGUUKYSKJLUVGWLWOUUJYDUVDXKUVHUVCUUOTUVIUVFUVEUVKUUEABUUSDEYG
      GUUKYSKJLUVGWLWOWPUUJUUPHNZUUQUUMTXMYBUUIUVLYCYBUUFUUHUVLUUEXNXQXRHFUUGIX
      TXSYAWQWRWSUUJHAUULBCUTEUUPYPUUJYQVCZUVEXMCHWTZUUIXMYRUVNYTHYGCXAXBWGZUUJ
      UUPCPUULTZUVLXLXJUUIUVPXKXLUUFUUHUVPXRFGXNBHCXQUUEUUGXTYAIXSJXDWRXCWGXEXF
      UUJUURUUNUUEBUUJUUHUURUUNTUVJUUJHAUUKBCUTEUUGUVMUVEUVOUUJUUHWCUUKVJXEXFXG
      XHXI $.
  $}

  ${
    $d F a b $.  $d S a b $.  $d T a b $.  $d W a b $.  $d X a b $.
    $d Y a b $.
    lmhmf1o.x $e |- X = ( Base ` S ) $.
    lmhmf1o.y $e |- Y = ( Base ` T ) $.
    $( A bijective module homomorphism is also converse homomorphic.
       (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    lmhmf1o $p |- ( F e. ( S LMHom T ) ->
        ( F : X -1-1-onto-> Y <-> `' F e. ( T LMHom S ) ) ) $=
      ( va vb clmhm co wcel wf1o wa cfv cbs eqid adantr wceq syl ccnv lmhmlmod2
      cvsca csca clmod lmhmlmod1 lmhmsca eqcomd cghm lmghm ghmf1o biimpa simpll
      wb cv fveq2d eleq2d biimpar adantrr wf f1ocnv f1of adantl adantrl lmhmlin
      ffvelrnda syl3anc f1ocnvfv2 ad2ant2l oveq2d eqtrd simplr lmodvscl syl2anc
      wi f1ocnvfv mpd islmhmd wfn lmhmf ffn dff1o4 sylanbrc impbida ) CABJKLZDE
      CMZCUAZBAJKLZWEWFNZHIBABUCOZAUCOZWGAUDOZBUDOZWMPOZEGWJQZWKQZWMQZWLQZWNQWE
      BUELWFABCUBRWEAUELZWFABCUFRZWEWLWMSWFWEWMWLABCWLWMWRWQUGUHRZWEWFWGBAUIKLZ
      WECABUIKLWFXBUNABCUJABCDEFGUKTULWIHUOZWNLZIUOZELZNZNZXCXEWGOZWKKZCOZXCXEW
      JKZSZXLWGOXJSZXHXKXCXICOZWJKZXLXHWEXCWLPOZLZXIDLZXKXPSWEWFXGUMWIXDXRXFWIX
      RXDWIXQWNXCWIWLWMPXAUPUQURUSZWIXFXSXDWIEDXEWGWFEDWGUTZWEWFEDWGMYADECVAEDW
      GVBTVCVFVDZXQABWKWJDCWLXCXIWRXQQZFWPWOVEVGXHXOXEXCWJWFXFXOXESWEXDDEXECVHV
      IVJVKXHWFXJDLZXMXNVOWEWFXGVLXHWSXRXSYDWIWSXGWTRXTYBXCWKWLXQDAXIFWRWPYCVMV
      GDEXJXLCVPVNVQVRWEWHNZCDVSZWGEVSZWFWEYFWHWEDECUTYFDEABCFGVTDECWATRYEYAYGW
      HYAWEEDBAWGGFVTVCEDWGWATDECWBWCWD $.
  $}

  ${
    $d F a b c $.  $d S a b c $.  $d T a b c $.  $d U a b c $.  $d X a b c $.
    $d Y a b c $.  $d V a b c $.
    lmhmima.x $e |- X = ( LSubSp ` S ) $.
    lmhmima.y $e |- Y = ( LSubSp ` T ) $.
    $( The image of a subspace under a homomorphism.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    lmhmima $p |- ( ( F e. ( S LMHom T ) /\ U e. X ) ->
        ( F " U ) e. Y ) $=
      ( va vb vc co wcel wa cfv cv cbs adantr eqid syl cima wral csca lmhmlmod1
      clmhm csubg cvsca cghm lmghm clmod simpr lsssubg syl2anc ghmima wceq wrex
      wb wfn wss wf lmhmf ffn lssss simpll lmhmsca fveq2d eleq2d biimpa adantrr
      fvelimab sselda adantrl lmhmlin syl3anc lssvscl syl22anc fnfvima eqeltrrd
      3syl simplr simprr oveq2 eleq1d syl5ibcom rexlimdva sylbid impr lmhmlmod2
      anassrs ralrimivva islss4 mpbir2and ) DABUELMZCEMZNZDCUAZFMZWPBUFOMZIPZJP
      ZBUGOZLZWPMZJWPUBIBUCOZQOZUBZWODABUHLMZCAUFOMZWRWMXGWNABDUIRWOAUJMZWNXHWM
      XIWNABDUDRZWMWNUKZECAGULUMABCDUNUMWOXCIJXEWPWOWSXEMZWTWPMZXCWOXLNZXMKPZDO
      ZWTUOZKCUPZXCWOXMXRUQZXLWODAQOZURZCXTUSZXSWOXTBQOZDUTZYAWMYDWNXTYCABDXTSZ
      YCSZVAZRXTYCDVBZTWOWNYBXKECXTAYEGVCZTZKXTCWTDVJUMRXNXQXCKCXNXOCMZNWSXPXAL
      ZWPMZXQXCWOXLYKYMWOXLYKNZNZWSXOAUGOZLZDOZYLWPYOWMWSAUCOZQOZMZXOXTMZYRYLUO
      WMWNYNVDZWOXLUUAYKWOXLUUAWOXEYTWSWOXDYSQWMXDYSUOWNABDYSXDYSSZXDSZVERVFVGV
      HVIZWOYKUUBXLWOCXTXOYJVKVLYTABYPXAXTDYSWSXOUUDYTSZYEYPSZXASZVMVNYOYAYBYQC
      MZYRWPMYOWMYDYAUUCYGYHVSYOWNYBWMWNYNVTZYITYOXIWNUUAYKUUJWOXIYNXJRUUKUUFWO
      XLYKWAYTEYPCYSAWSXOUUDUUHUUGGVOVPXTCDYQVQVNVRWIXQYLXBWPXPWTWSXAWBWCWDWEWF
      WGWJWOBUJMZWQWRXFNUQWMUULWNABDWHRXEFXAWPXDYCBIJUUEXESYFUUIHWKTWL $.

    $( The inverse image of a subspace under a homomorphism.  (Contributed by
       Stefan O'Rear, 1-Jan-2015.) $)
    lmhmpreima $p |- ( ( F e. ( S LMHom T ) /\ U e. Y ) ->
        ( `' F " U ) e. X ) $=
      ( va vb co wcel wa csubg cfv cbs adantr wceq eqid syl clmhm ccnv cv cvsca
      cima wral csca cghm lmghm clmod lmhmlmod2 lsssubg sylan ghmpreima syl2anc
      lmhmlmod1 ad2antrr simprl cdm cnvimass lmhmf fdm syl5sseq sselda lmodvscl
      adantrl syl3anc simpll lmhmlin simplr lmhmsca fveq2d biimpar adantrr wfun
      wf eleq2d ffun simprr fvimacnvi lssvscl syl22anc eqeltrd wfn ffn elpreima
      wb 3syl mpbir2and ralrimivva islss4 ) DABUAKLZCFLZMZDUBCUEZELZWOANOLZIUCZ
      JUCZAUDOZKZWOLZJWOUFIAUGOZPOZUFZWNDABUHKLZCBNOLZWQWLXFWMABDUIQWLBUJLZWMXG
      ABDUKZFCBHULUMABDCUNUOWNXBIJXDWOWNWRXDLZWSWOLZMZMZXBXAAPOZLZXADOZCLZXMAUJ
      LZXJWSXNLZXOWLXRWMXLABDUPZUQWNXJXKURZWNXKXSXJWNWOXNWSWNDUSZWOXNDCUTWNXNBP
      OZDVPZYBXNRWLYDWMXNYCABDXNSZYCSVAQZXNYCDVBTVCVDVFZWRWTXCXDXNAWSYEXCSZWTSZ
      XDSZVEVGXMXPWRWSDOZBUDOZKZCXMWLXJXSXPYMRWLWMXLVHYAYGXDABWTYLXNDXCWRWSYHYJ
      YEYIYLSZVIVGXMXHWMWRBUGOZPOZLZYKCLZYMCLWLXHWMXLXIUQWLWMXLVJWNXJYQXKWNYQXJ
      WNYPXDWRWNYOXCPWLYOXCRWMABDXCYOYHYOSZVKQVLVQVMVNXMDVOZXKYRWNYTXLWNYDYTYFX
      NYCDVRTQWNXJXKVSWSCDVTUOYPFYLCYOBWRYKYSYNYPSHWAWBWCWNXBXOXQMWGZXLWNYDDXNW
      DUUAYFXNYCDWEXNXACDWFWHQWIWJWNXRWPWQXEMWGWLXRWMXTQXDEWTWOXCXNAIJYHYJYEYIG
      WKTWI $.
  $}

  ${
    lmhmlsp.v $e |- V = ( Base ` S ) $.
    lmhmlsp.k $e |- K = ( LSpan ` S ) $.
    lmhmlsp.l $e |- L = ( LSpan ` T ) $.
    $( Homomorphisms preserve spans. $)

    $( Homomorphisms preserve spans.  (Contributed by Stefan O'Rear,
       1-Jan-2015.) $)
    lmhmlsp $p |- ( ( F e. ( S LMHom T ) /\ U C_ V ) ->
        ( F " ( K ` U ) ) = ( L ` ( F " U ) ) ) $=
      ( wcel wss cfv cima eqid adantr syl clmod clss syl2anc clmhm co wfun ccnv
      wa cbs wf lmhmf ffun lmhmlmod1 lmhmlmod2 crn imassrn frn lspcl lmhmpreima
      syl5ss syldan cdm cin incom simpr fdm sseqtr4d df-ss sylib syl5req dminss
      wceq syl6eqss lspssid imass2 sstrd lspssp syl3anc funimass2 lmhmima eqssd
      ) DABUAUBKZCGLZUEZDCEMZNZDCNZFMZWADUCZWBDUDZWENZLZWCWELWAGBUFMZDUGZWFVSWK
      VTGWJABDHWJOZUHPZGWJDUIQWAARKZWHASMZKZCWHLWIVSWNVTABDUJPZVSVTWEBSMZKZWPWA
      BRKZWDWJLZWSVSWTVTABDUKPZWAWDDULZWJDCUMWAWKXCWJLWMGWJDUNQUQZWRWDFWJBWLWRO
      ZJUOTABWEDWOWRWOOZXEUPURWACWGWDNZWHWACDUSZCUTZXGWAXICXHUTZCXHCVAWACXHLXJC
      VIWACGXHVSVTVBZWAWKXHGVIWMGWJDVCQVDCXHVEVFVGCDVHVJWAWDWELZXGWHLWAWTXAXLXB
      XDWDFWJBWLJVKTWDWEWGVLQVMWOCWHEAXFIVNVOWBWEDVPTWAWTWCWRKZWDWCLZWEWCLXBVSV
      TWBWOKZXMWAWNVTXOWQXKWOCEGAHXFIUOTABWBDWOWRXFXEVQURWACWBLZXNWAWNVTXPWQXKC
      EGAHIVKTCWBDVLQWRWDWCFBXEJVNVOVR $.
  $}

  ${
    $( The range of a homomorphism is a submodule.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    lmhmrnlss $p |- ( F e. ( S LMHom T ) -> ran F e. ( LSubSp ` T ) ) $=
      ( clmhm co wcel cbs cfv cima crn clss wfn wceq eqid lmhmf ffn fnima clmod
      wf 3syl lmhmlmod1 lss1 syl lmhmima mpdan eqeltrrd ) CABDEFZCAGHZIZCJZBKHZ
      UGUHBGHZCSCUHLUIUJMUHULABCUHNZULNOUHULCPUHCQTUGUHAKHZFZUIUKFUGARFUOABCUAU
      NUHAUMUNNZUBUCABUHCUNUKUPUKNUDUEUF $.

    lmhmkerlss.k $e |- K = ( `' F " { .0. } ) $.
    lmhmkerlss.z $e |- .0. = ( 0g ` T ) $.
    lmhmkerlss.u $e |- U = ( LSubSp ` S ) $.
    $( The kernel of a homomorphism is a submodule.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    lmhmkerlss $p |- ( F e. ( S LMHom T ) -> K e. U ) $=
      ( clmhm co wcel ccnv csn cima clss cfv clmod lmhmlmod2 eqid lsssn0 mpdan
      syl lmhmpreima syl5eqel ) DABJKLZEDMFNZOZCGUFUGBPQZLZUHCLUFBRLUJABDSUIBFH
      UITZUAUCABUGDCUIIUKUDUBUE $.
  $}

  ${
    $d S a b $.  $d X a b $.  $d F a b $.  $d T a b $.  $d V a b $.
    $d R a b $.  $d U a b $.
    reslmhm.u $e |- U = ( LSubSp ` S ) $.
    reslmhm.r $e |- R = ( S |`s X ) $.
    $( Restriction of a homomorphism to a subspace.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    reslmhm $p |- ( ( F e. ( S LMHom T ) /\ X e. U ) ->
        ( F |` X ) e. ( R LMHom T ) ) $=
      ( va vb co wcel wa clmod cfv wceq cbs wral adantr eqid clmhm cres cghm cv
      csca cvsca w3a lmhmlmod1 lsslmod sylan lmhmlmod2 jca csubg lsssubg resghm
      lmghm syl2anc lmhmsca resssca sylan9eq simpll simprl wss lssss adantl syl
      eleq2d biimpar adantrl sseldd lmhmlin syl3anc simplr lssvscl fvres oveq2d
      ressbas2 syl22anc 3eqtr4d ralrimivva fveq2d ressvsca oveqd eqeq1d ralbidv
      raleqbidv mpbid 3jca islmhm sylanbrc ) EBCUAKLZFDLZMZANLZCNLZMEFUBZACUCKL
      ZCUEOZAUEOZPZIUDZJUDZAUFOZKZWPOZXAXBWPOZCUFOZKZPZJAQOZRZIWSQOZRZUGWPACUAK
      LWMWNWOWKBNLZWLWNBCEUHZDFBAHGUIUJWKWOWLBCEUKSULWMWQWTXMWMEBCUCKLZFBUMOLZW
      QWKXPWLBCEUPSWKXNWLXQXODFBGUNUJBCAEFHUOUQWKWLWRBUEOZWSBCEXRWRXRTZWRTZURFX
      RBADHXSUSZUTWMXAXBBUFOZKZWPOZXHPZJXJRZIXRQOZRXMWMYEIJYGXJWMXAYGLZXBXJLZMZ
      MZYCEOZXAXBEOZXGKZYDXHYKWKYHXBBQOZLYLYNPWKWLYJVAWMYHYIVBZYKFYOXBWMFYOVCZY
      JWLYQWKDFYOBYOTZGVDVEZSWMYIXBFLZYHWMYTYIWMFXJXBWMYQFXJPYSFYOABHYRVQVFVGVH
      VIZVJYGBCYBXGYOEXRXAXBXSYGTZYRYBTZXGTZVKVLYKYCFLZYDYLPYKXNWLYHYTUUEWMXNYJ
      WKXNWLXOSSWKWLYJVMYPUUAYGDYBFXRBXAXBXSUUCUUBGVNVRYCFEVOVFYKYTXHYNPUUAYTXF
      YMXAXGXBFEVOVPVFVSVTWMYFXKIYGXLWMXRWSQWLXRWSPWKYAVEWAWMYEXIJXJWMYDXEXHWMY
      CXDWPWMYBXCXAXBWLYBXCPWKFYBBADHUUCWBVEWCWAWDWEWFWGWHIJXLACXCXGXJWPWSWRWST
      XTXLTXJTXCTUUDWIWJ $.
  $}

  ${
    $d U x y $.  $d T x y $.  $d S x y $.  $d X x y $.  $d F x y $.
    $d L x y $.
    reslmhm2.u $e |- U = ( T |`s X ) $.
    reslmhm2.l $e |- L = ( LSubSp ` T ) $.
    $( Expansion of the codomain of a homomorphism.  (Contributed by Stefan
       O'Rear, 3-Feb-2015.)  (Revised by Mario Carneiro, 5-May-2015.) $)
    reslmhm2 $p |- ( ( F e. ( S LMHom U ) /\ T e. LMod /\ X e. L ) ->
        F e. ( S LMHom T ) ) $=
      ( vx vy co wcel clmod cvsca cfv csca cbs eqid 3ad2ant1 wceq w3a lmhmlmod1
      clmhm simp2 resssca 3ad2ant3 lmhmsca cghm lsssubg 3adant1 resghm2 syl2anc
      eqtrd csubg lmghm cv wa lmhmlin 3expb 3ad2antl1 simpl3 ressvsca oveqd syl
      eqtr4d islmhmd ) DACUCKLZBMLZFELZUAZIJABANOZBNOZDBPOZAPOZVNQOZAQOZVPRZVKR
      ZVLRZVNRZVMRZVORZVGVHAMLVIACDUBSVGVHVIUDVJVMCPOZVNVIVGVMWCTVHFVMBCEGWAUEU
      FVGVHWCVNTVIACDVNWCVTWCRUGSUMVJDACUHKLZFBUNOLZDABUHKLVGVHWDVIACDUOSVHVIWE
      VGEFBHUIUJABCDFGUKULVJIUPZVOLZJUPZVPLZUQZUQZWFWHVKKDOZWFWHDOZCNOZKZWFWMVL
      KZVGVHWJWLWOTZVIVGWGWIWQVOACVKWNVPDVNWFWHVTWBVQVRWNRURUSUTWKVIWPWOTVGVHVI
      WJVAVIVLWNWFWMFVLBCEGVSVBVCVDVEVF $.

    $( Expansion of the codomain of a homomorphism.  (Contributed by Stefan
       O'Rear, 3-Feb-2015.)  (Revised by Mario Carneiro, 5-May-2015.) $)
    reslmhm2b $p |- ( ( T e. LMod /\ X e. L /\ ran F C_ X ) ->
        ( F e. ( S LMHom T ) <-> F e. ( S LMHom U ) ) ) $=
      ( vx vy clmod wcel clmhm co wa cvsca cfv csca eqid wceq crn wss lmhmlmod1
      w3a adantl simpl1 lsslmod syl2anc resssca 3ad2ant2 lmhmsca sylan9req cghm
      cbs simpl2 lmghm csubg wb lsssubg 3adant3 simp3 resghm2b biimpa sylan2 cv
      lmhmlin 3expb adantll simpll2 ressvsca oveqd eqtrd islmhmd simpr reslmhm2
      syl syl3anc impbida ) BKLZFELZDUAFUBZUDZDABMNLZDACMNLZWBWCOZIJACAPQZCPQZD
      CRQZARQZWIUNQZAUNQZWKSZWFSZWGSWISZWHSWJSZWCAKLWBABDUCUEWEVSVTCKLVSVTWAWCU
      FVSVTWAWCUOEFBCGHUGUHWBWCWHBRQZWIVTVSWPWHTWAFWPBCEGWPSZUIUJABDWIWPWNWQUKU
      LWCWBDABUMNLZDACUMNLZABDUPWBWRWSWBFBUQQLZWAWRWSURVSVTWTWAEFBHUSUTVSVTWAVA
      ABCDFGVBUHVCVDWEIVEZWJLZJVEZWKLZOZOZXAXCWFNDQZXAXCDQZBPQZNZXAXHWGNZWCXEXG
      XJTZWBWCXBXDXLWJABWFXIWKDWIXAXCWNWOWLWMXISZVFVGVHXFVTXJXKTVSVTWAWCXEVIVTX
      IWGXAXHFXIBCEGXMVJVKVPVLVMWBWDOWDVSVTWCWBWDVNVSVTWAWDUFVSVTWAWDUOABCDEFGH
      VOVQVR $.
  $}

  ${
    $d F x y z $.  $d G x y z $.  $d S x y z $.  $d T x y $.  $d U x y $.
    $d V x y $.
    lmhmeql.u $e |- U = ( LSubSp ` S ) $.
    $( The equalizer of two module homomorphisms is a subspace.  (Contributed
       by Stefan O'Rear, 7-Mar-2015.) $)
    lmhmeql $p |- ( ( F e. ( S LMHom T ) /\ G e. ( S LMHom T ) ) ->
        dom ( F i^i G ) e. U ) $=
      ( vx vy vz co wcel wa cfv cv wral cbs wceq eqid fveq2 syl clmhm cin csubg
      cdm cvsca csca cghm lmghm ghmeql syl2an crab wi lmhmlmod1 adantr ad2antrr
      clmod simplr simprl syl3anc oveq2 simplll lmhmlin simpllr 3eqtr4d eqeq12d
      lmodvscl ad2antll elrab sylanbrc expr ralrimiva wb wfn wf lmhmf ffn eleq2
      fndmin raleqbi1dv ralrab syl6bb mpbird islss4 mpbir2and ) DABUAJZKZEWEKZL
      ZDEUBUDZCKZWIAUCMKZGNZHNZAUEMZJZWIKZHWIOZGAUFMZPMZOZWFDABUGJZKEXAKWKWGABD
      UHABEUHABDEUIUJWHWQGWSWHWLWSKZLZWQWMDMZWMEMZQZWOINZDMZXGEMZQZIAPMZUKZKZUL
      ZHXKOZXCXNHXKXCWMXKKZXFXMXCXPXFLZLZWOXKKZWODMZWOEMZQZXMXRAUPKZXBXPXSWHYCX
      BXQWFYCWGABDUMUNZUOWHXBXQUQZXCXPXFURZWLWNWRWSXKAWMXKRZWRRZWNRZWSRZVFUSXRW
      LXDBUEMZJZWLXEYKJZXTYAXFYLYMQXCXPXDXEWLYKUTVGXRWFXBXPXTYLQWFWGXBXQVAYEYFW
      SABWNYKXKDWRWLWMYHYJYGYIYKRZVBUSXRWGXBXPYAYMQWFWGXBXQVCYEYFWSABWNYKXKEWRW
      LWMYHYJYGYIYNVBUSVDXJYBIWOXKXGWOQXHXTXIYAXGWODSXGWOESVEVHVIVJVKXCWIXLQZWQ
      XOVLWHYOXBWFDXKVMZEXKVMZYOWGWFXKBPMZDVNYPXKYRABDYGYRRZVOXKYRDVPTWGXKYREVN
      YQXKYRABEYGYSVOXKYREVPTIXKDEVRUJUNYOWQXMHXLOXOWPXMHWIXLWIXLWOVQVSXJXFXMHI
      XKXGWMQXHXDXIXEXGWMDSXGWMESVEVTWATWBVKWHYCWJWKWTLVLYDWSCWNWIWRXKAGHYHYJYG
      YIFWCTWD $.
  $}

  ${
    $d B g h $.  $d F g h $.  $d K g h $.  $d S g h $.  $d T g h $.
    $d V g h $.  $d X g h $.
    lspextmo.b $e |- B = ( Base ` S ) $.
    lspextmo.k $e |- K = ( LSpan ` S ) $.
    $( A linear function is completely determined (or overdetermined) by its
       values on a spanning subset.  (Contributed by Stefan O'Rear,
       7-Mar-2015.)  (Revised by NM, 17-Jun-2017.) $)
    lspextmo $p |- ( ( X C_ B /\ ( K ` X ) = B ) ->
        E* g e. ( S LMHom T ) ( g |` X ) = F ) $=
      ( vh wss cfv wceq wa cv cres wral wcel cdm ad2antrl weq wi clmhm co eqtr3
      wrmo cin inss1 dmss ax-mp wfn cbs wf eqid lmhmf ffn adantrr fndm syl5sseq
      simplr clmod clss lmhmlmod1 adantr lmhmeql simprr lspssp syl3anc eqsstr3d
      syl eqssd expr wb 3syl simpll fnreseql fneqeql syl2anc 3imtr4d ralrimivva
      syl5 reseq1 eqeq1d rmo4 sylibr ) GAKZGFLZAMZNZDOZGPZEMZJOZGPZEMZNZDJUAZUB
      ZJBCUCUDZQDWSQWLDWSUFWIWRDJWSWSWPWKWNMZWIWJWSRZWMWSRZNZNZWQWKWNEUEXDGWJWM
      UGZSZKZXFAMZWTWQWIXCXGXHWIXCXGNZNZXFAXJWJSZXFAXEWJKXFXKKWJWMUHXEWJUIUJXJW
      JAUKZXKAMWIXCXLXGXDACULLZWJUMZXLXAXNWIXBAXMBCWJHXMUNZUOTAXMWJUPVJZUQAWJUR
      VJUSXJAWGXFWFWHXIUTXJBVARZXFBVBLZRZXGWGXFKXCXQWIXGXAXQXBBCWJVCVDTXCXSWIXG
      BCXRWJWMXRUNZVETWIXCXGVFXRGXFFBXTIVGVHVIVKVLXDXLWMAUKZWFWTXGVMXPXDXBAXMWM
      UMYAWIXAXBVFAXMBCWMHXOUOAXMWMUPVNZWFWHXCVOAWJWMGVPVHXDXLYAWQXHVMXPYBAWJWM
      VQVRVSWAVTWLWODJWSWQWKWNEWJWMGWBWCWDWE $.
  $}

  ${
    $d Y x a b $.  $d R x a b $.  $d I x a b $.  $d B x a b $.  $d F a b $.
    $d W x a b $.
    pwsdiaglmhm.y $e |- Y = ( R ^s I ) $.
    pwsdiaglmhm.b $e |- B = ( Base ` R ) $.
    pwsdiaglmhm.f $e |- F = ( x e. B |-> ( I X. { x } ) ) $.
    $( Diagonal homomorphism into a structure power.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    pwsdiaglmhm $p |- ( ( R e. LMod /\ I e. W ) -> F e. ( R LMHom Y ) ) $=
      ( va vb clmod wcel wa cfv eqid co csn cvv cvsca csca simpl pwslmod pwssca
      cbs eqcomd cgrp cghm lmodgrp pwsdiagghm sylan cv cxp wceq simplr lmodvscl
      3expb adantlr fvdiagfn syl2anc cof oveq2d simpll simprl pwsdiagel adantrl
      ad2ant2l pwsvscafval id vex a1i ofc12 ad2antlr 3eqtrd eqtr4d islmhmd ) CM
      NZEFNZOZKLCGCUAPZGUAPZDGUBPZCUBPZWDUFPZBIWAQZWBQZWDQZWCQWEQZVRVSUCCEFGHUD
      VTWDWCCWDEMFGHWHUEUGVRCUHNVSDCGUIRNCUJABCDEFGHIJUKULVTKUMZWENZLUMZBNZOZOZ
      WJWLWARZDPZEWPSUNZWJWLDPZWBRZWOVSWPBNZWQWRUOVRVSWNUPZVRWNXAVSVRWKWMXAWJWA
      WDWEBCWLIWHWFWIUQURUSABDEFWPJUTVAWOWTWJEWLSUNZWBREWJSUNXCWAVBRZWRWOWSXCWJ
      WBVSWMWSXCUOVRWKABDEFWLJUTVHVCWOWJGUFPZCWBWAWDEWEMFXCGHXEQZWFWGWHWIVRVSWN
      VDXBVTWKWMVEVTWMXCXENWKWLBXECEMFGHIXFVFVGVIVSXDWRUOVRWNVSEWJWLWAFTTVSVJWJ
      TNVSKVKVLWLTNVSLVKVLVMVNVOVPVQ $.
  $}

  ${
    $d F a b c $.  $d R a b c $.  $d S a b c $.  $d B a b c $.  $d C a b c $.
    $d V a b c $.
    islmim.b $e |- B = ( Base ` R ) $.
    islmim.c $e |- C = ( Base ` S ) $.
    $( An isomorphism of left modules is a bijective homomorphism.
       (Contributed by Stefan O'Rear, 21-Jan-2015.) $)
    islmim $p |- ( F e. ( R LMIso S ) <-> ( F e. ( R LMHom S ) /\
          F : B -1-1-onto-> C ) ) $=
      ( vc va vb co wcel clmod cv wf1o clmhm wa cbs cfv wceq clmim crab df-lmim
      w3a ovex rabex oveq12 wb syl6eqr f1oeq23 syl2an rabeqbidv elovmpt2 df-3an
      fveq2 f1oeq1 anbi2i lmhmlmod1 lmhmlmod2 jca adantr pm4.71ri bitr4i 3bitri
      elrab ) ECDUAKLCMLZDMLZEABHNZOZHCDPKZUBZLZUDVFVGQZVLQZEVJLZABEOZQZMMINZRS
      ZJNZRSZVHOZHVRVTPKZUBUAVKECDIJJHIUCWBHWCVRVTPUEUFVRCTZVTDTZQWBVIHWCVJVRCV
      TDPUGWDVSATWABTWBVIUHWEWDVSCRSAVRCRUOFUIWEWADRSBVTDRUOGUIVSAWABVHUJUKULUM
      VFVGVLUNVNVMVQQVQVLVQVMVIVPHEVJABVHEUPVEUQVQVMVOVMVPVOVFVGCDEURCDEUSUTVAV
      BVCVD $.

    $( An isomorphism of left modules is a bijection.  (Contributed by Stefan
       O'Rear, 21-Jan-2015.) $)
    lmimf1o $p |- ( F e. ( R LMIso S ) -> F : B -1-1-onto-> C ) $=
      ( clmim co wcel clmhm wf1o islmim simprbi ) ECDHIJECDKIJABELABCDEFGMN $.
  $}

  ${
    $d F a b $.  $d R a b $.  $d S a b $.  $d a b c $.
    $( An isomorphism of modules is a homomorphism.  (Contributed by Stefan
       O'Rear, 21-Jan-2015.) $)
    lmimlmhm $p |- ( F e. ( R LMIso S ) -> F e. ( R LMHom S ) ) $=
      ( clmim co wcel clmhm cbs cfv wf1o eqid islmim simplbi ) CABDEFCABGEFAHIZ
      BHIZCJNOABCNKOKLM $.

    $( An isomorphism of modules is an isomorphism of groups.  (Contributed by
       Stefan O'Rear, 21-Jan-2015.)  (Revised by Mario Carneiro,
       6-May-2015.) $)
    lmimgim $p |- ( F e. ( R LMIso S ) -> F e. ( R GrpIso S ) ) $=
      ( clmim wcel cghm cbs cfv wf1o cgim clmhm lmimlmhm lmghm syl eqid lmimf1o
      co isgim sylanbrc ) CABDQEZCABFQEZAGHZBGHZCICABJQETCABKQEUAABCLABCMNUBUCA
      BCUBOZUCOZPUBUCABCUDUERS $.

    $( An isomorphism of left modules is a homomorphism whose converse is a
       homomorphism.  (Contributed by Mario Carneiro, 6-May-2015.) $)
    islmim2 $p |- ( F e. ( R LMIso S ) <-> ( F e. ( R LMHom S ) /\
          `' F e. ( S LMHom R ) ) ) $=
      ( clmim co wcel clmhm cbs cfv wf1o ccnv eqid islmim lmhmf1o pm5.32i bitri
      wa ) CABDEFCABGEFZAHIZBHIZCJZQRCKBAGEFZQSTABCSLZTLZMRUAUBABCSTUCUDNOP $.
  $}

  $( The converse of a bijective module homomorphism is a bijective module
     homomorphism.  (Contributed by Stefan O'Rear, 25-Jan-2015.)  (Revised by
     Mario Carneiro, 6-May-2015.) $)
  lmimcnv $p |- ( F e. ( S LMIso T ) -> `' F e. ( T LMIso S ) ) $=
    ( clmhm co wcel ccnv wa clmim wrel wceq cbs cfv eqid lmhmf frel syl islmim2
    wf dfrel2 sylib id eqeltrd anim2i ancoms 3imtr4i ) CABDEZFZCGZBADEFZHUJUIGZ
    UGFZHZCABIEFUIBAIEFUJUHUMUHULUJUHUKCUGUHCJZUKCKUHALMZBLMZCSUNUOUPABCUONUPNO
    UOUPCPQCTUAUHUBUCUDUEABCRBAUIRUF $.

  ${
    $d R f r s $.  $d S f r s $.  $d F f r s $.
    $( The relation "is isomorphic to" for modules.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    brlmic $p |- ( R ~=m S <-> ( R LMIso S ) =/= (/) ) $=
      ( clmic clmim clmod cxp df-lmic lmimfn brwitnlem ) ABCDEEFGHI $.

    $( Prove isomorphic by an explicit isomorphism.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    brlmici $p |- ( F e. ( R LMIso S ) -> R ~=m S ) $=
      ( clmim co wcel c0 wne clmic wbr ne0i brlmic sylibr ) CABDEZFNGHABIJNCKAB
      LM $.

    $( Isomorphism implies the left side is a module.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    lmiclcl $p |- ( R ~=m S -> R e. LMod ) $=
      ( vf clmic wbr cv clmim co wcel wex clmod c0 wne brlmic n0 bitri lmimlmhm
      clmhm lmhmlmod1 syl exlimiv sylbi ) ABDEZCFZABGHZIZCJZAKIZUCUELMUGABNCUEO
      PUFUHCUFUDABRHIUHABUDQABUDSTUAUB $.

    $( Isomorphism implies the right side is a module.  (Contributed by Mario
       Carneiro, 6-May-2015.) $)
    lmicrcl $p |- ( R ~=m S -> S e. LMod ) $=
      ( vf clmic wbr cv clmim co wcel wex clmod c0 wne brlmic n0 bitri lmimlmhm
      clmhm lmhmlmod2 syl exlimiv sylbi ) ABDEZCFZABGHZIZCJZBKIZUCUELMUGABNCUEO
      PUFUHCUFUDABRHIUHABUDQABUDSTUAUB $.

    $( Module isomorphism is symmetric.  (Contributed by Stefan O'Rear,
       26-Feb-2015.) $)
    lmicsym $p |- ( R ~=m S -> S ~=m R ) $=
      ( vf clmic wbr clmim co c0 wne brlmic cv wcel wex n0 ccnv lmimcnv brlmici
      syl exlimiv sylbi ) ABDEABFGZHIZBADEZABJUBCKZUALZCMUCCUANUEUCCUEUDOZBAFGL
      UCABUDPBAUFQRSTT $.
  $}

  ${
    $d x y C $.  $d w z F $.  $d w z G $.  $d f w x y z J $.  $d f w x y z K $.
    $d f w x y z L $.  $d f w x y z M $.  $d w x y z P $.  $d f w x y z ph $.
    $d w x y B $.  $d x y Q $.
    lmhmpropd.a $e |- ( ph -> B = ( Base ` J ) ) $.
    lmhmpropd.b $e |- ( ph -> C = ( Base ` K ) ) $.
    lmhmpropd.c $e |- ( ph -> B = ( Base ` L ) ) $.
    lmhmpropd.d $e |- ( ph -> C = ( Base ` M ) ) $.
    lmhmpropd.1 $e |- ( ph -> F = ( Scalar ` J ) ) $.
    lmhmpropd.2 $e |- ( ph -> G = ( Scalar ` K ) ) $.
    lmhmpropd.3 $e |- ( ph -> F = ( Scalar ` L ) ) $.
    lmhmpropd.4 $e |- ( ph -> G = ( Scalar ` M ) ) $.
    lmhmpropd.p $e |- P = ( Base ` F ) $.
    lmhmpropd.q $e |- Q = ( Base ` G ) $.
    lmhmpropd.e $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` J ) y ) = ( x ( +g ` L ) y ) ) $.
    lmhmpropd.f $e |- ( ( ph /\ ( x e. C /\ y e. C ) ) ->
        ( x ( +g ` K ) y ) = ( x ( +g ` M ) y ) ) $.
    lmhmpropd.g $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
        ( x ( .s ` J ) y ) = ( x ( .s ` L ) y ) ) $.
    lmhmpropd.h $e |- ( ( ph /\ ( x e. Q /\ y e. C ) ) ->
        ( x ( .s ` K ) y ) = ( x ( .s ` M ) y ) ) $.
    $( Module homomorphism depends only on the module attributes of
       structures.  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    lmhmpropd $p |- ( ph -> ( J LMHom K ) = ( L LMHom M ) ) $=
      ( vf vz vw clmhm co clmod wcel wa cghm csca cfv wceq cvsca wral lmodpropd
      cv cbs w3a anbi12d proplem adantlr fveq2d simpll simplrr 3eqtr4g eleqtrrd
      simprl wf simplrl eqid ghmf syl simprr eleqtrd ffvelrnd eqeq12d 2ralbidva
      syl12anc pm5.32da df-3an 3bitr4g syl5eq raleqdv raleqbidv 3anbi23d eleq2d
      ghmpropd 3anbi123d 3bitr3d islmhm eqrdv ) AUHJKUKULZLMUKULZAJUMUNZKUMUNZU
      OZUHVCZJKUPULZUNZKUQURZJUQURZUSZUIVCZUJVCZJUTURZULZXDURZXJXKXDURZKUTURZUL
      ZUSZUJJVDURZVAZUIXHVDURZVAZVEZUOLUMUNZMUMUNZUOZXDLMUPULZUNZMUQURZLUQURZUS
      ZXJXKLUTURZULZXDURZXJXOMUTURZULZUSZUJLVDURZVAZUIYJVDURZVAZVEZUOXDWSUNXDWT
      UNAXCYFYCUUBAXAYDXBYEABCDFHJLNPUDRTUBUFVBABCEGIKMOQUESUAUCUGVBVFAXFIHUSZX
      RUJDVAZUIFVAZVEZXFUUCYQUJDVAZUIFVAZVEZYCUUBAXFUUCUOZUUEUOUUJUUHUOUUFUUIAU
      UJUUEUUHAUUJUOZXRYQUIUJFDUUKXJFUNZXKDUNZUOZUOZXNYNXQYPUUOXMYMXDAUUNXMYMUS
      UUJABCFDXLYLXJXKUFVGVHVIUUOAXJGUNXOEUNXQYPUSAUUJUUNVJZUUOXJFGUUKUULUUMVNU
      UOIVDURHVDURZGFUUOIHVDAXFUUCUUNVKVIUCUBVLVMUUOXOKVDURZEUUOXSUURXKXDUUOXFX
      SUURXDVOAXFUUCUUNVPJKXDXSUURXSVQZUURVQVRVSUUOXKDXSUUKUULUUMVTUUOADXSUSUUP
      NVSWAWBUUOAEUURUSUUPOVSVMABCGEXPYOXJXOUGVGWEWCWDWFXFUUCUUEWGXFUUCUUHWGWHA
      UUCXIUUEYBXFAIXGHXHSRWCAUUDXTUIFYAAFUUQYAUBAHXHVDRVIWIAXRUJDXSNWJWKWLAXFY
      HUUCYKUUHUUAAXEYGXDABCDEJKLMNOPQUDUEWNWMAIYIHYJUATWCAUUGYSUIFYTAFUUQYTUBA
      HYJVDTVIWIAYQUJDYRPWJWKWOWPVFUIUJYAJKXLXPXSXDXHXGXHVQXGVQYAVQUUSXLVQXPVQW
      QUIUJYTLMYLYOYRXDYJYIYJVQYIVQYTVQYRVQYLVQYOVQWQWHWR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Subspace sum; bases for a left module
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LBasis $.

  $( Extend class notation with the set of bases for a vector space. $)
  clbs $a class LBasis $.

  ${
    $d b n s w x y $.
    $( Define the set of bases to a left module or left vector space.
       (Contributed by Mario Carneiro, 24-Jun-2014.) $)
    df-lbs $a |- LBasis = ( w e. _V |-> { b e. ~P ( Base ` w ) |
 [. ( LSpan ` w ) / n ]. [. ( Scalar ` w ) / s ]. ( ( n ` b ) = ( Base ` w ) /\
       A. x e. b A. y e. ( ( Base ` s ) \ { ( 0g ` s ) } )
       -. ( y ( .s ` w ) x ) e. ( n ` ( b \ { x } ) ) ) } ) $.

    $(
    df-lbs @a |- LBasis = ( w e. _V |-> { b e. ~P ( Base ` w ) |
      ( ( ( LSpan ` w ) ` b ) = ( Base ` w ) /\ A. x e. ( ~P b i^i Fin )
       A. f e. ( ( Base ` ( Scalar ` w ) ) ^m x )
       ( ( w gsum ( f oF ( .s ` w ) ( _I |` x ) ) ) = ( 0g ` w ) ->
         f = ( x X. { ( 0g ` w ) } ) ) } ) @.

    df-lbs @a |- LBasis = ( w e. _V |-> { b e. ~P ( Base ` w ) |
      [. ( Base ` ( ( Scalar ` w ) freeLMod b ) ) / k ]. ( f e. k |->
        ( w gsum ( f oF ( .s ` w ) ( _I |` b ) ) ) ) :
           k -1-1-onto-> ( Base ` w ) } ) @.
    $)
  $}

  ${
    $d b x y B $.  $d b f n w y K $.  $d b f n w x y N $.  $d b f n w x y W $.
    $d x y F $.  $d b f n w .x. $.  $d b f n w V $.  $d b f n w y .0. $.
    islbs.v $e |- V = ( Base ` W ) $.
    islbs.f $e |- F = ( Scalar ` W ) $.
    islbs.s $e |- .x. = ( .s ` W ) $.
    islbs.k $e |- K = ( Base ` F ) $.
    islbs.j $e |- J = ( LBasis ` W ) $.
    islbs.n $e |- N = ( LSpan ` W ) $.
    islbs.z $e |- .0. = ( 0g ` F ) $.
    $( The predicate " ` B ` is a basis for the left module or vector space
       ` W ` ".  A subset of the base set is a basis if zero is not in the set,
       it spans the set, and no nonzero multiple of an element of the basis is
       in the span of the rest of the family.  (Contributed by Mario Carneiro,
       24-Jun-2014.)  (Revised by Mario Carneiro, 14-Jan-2015.) $)
    islbs $p |- ( W e. X -> ( B e. J <-> ( B C_ V /\ ( N ` B ) = V /\ A. x e. B
      A. y e. ( K \ { .0. } ) -. ( y .x. x ) e. ( N ` ( B \ { x } ) ) ) ) ) $=
      ( cfv vb vw vn vf wcel cv wceq co csn cdif wral cpw crab wss w3a cvv elex
      wn clbs cbs cvsca c0g csca wsbc clspn fveq2 syl6eqr pweqd fvex a1i adantr
      simplr fveq1d ad2antrr eqeq12d simpr fveq2d sneqd difeq12d eleq12d notbid
      wa oveqd raleqbidv ralbidv anbi12d sbcied2 rabeqbidv df-lbs eqeltri rabex
      pwex fvmpt syl5eq syl eleq2d elpw2 anbi1i eqeq1d difeq1 raleqbi1dv 3anass
      elrab 3bitr4i syl6bb ) JKUEZCFUECUAUFZHTZIUGZBUFZAUFZDUHZXGXKUIZUJZHTZUEZ
      URZBGLUIZUJZUKZAXGUKZWBZUAIULZUMZUEZCIUNZCHTZIUGZXLCXMUJZHTZUEZURZBXSUKZA
      CUKZUOZXFFYDCXFJUPUEZFYDUGJKUQYPFJUSTYDQUBJXGUCUFZTZUBUFZUTTZUGZXJXKYSVAT
      ZUHZXNYQTZUEZURZBUDUFZUTTZUUGVBTZUIZUJZUKZAXGUKZWBZUDYSVCTZVDZUCYSVETZVDZ
      UAYTULZUMYDUPUSYSJUGZUURYBUAUUSYCUUTYTIUUTYTJUTTZIYSJUTVFMVGZVHUUTUUPYBUC
      UUQHUPUUQUPUEUUTYSVEVIVJUUTUUQJVETHYSJVEVFRVGUUTYQHUGZWBZUUNYBUDUUOEUPUUO
      UPUEUVDYSVCVIVJUVDUUOJVCTZEUUTUUOUVEUGUVCYSJVCVFVKNVGUVDUUGEUGZWBZUUAXIUU
      MYAUVGYRXHYTIUVGXGYQHUUTUVCUVFVLZVMUUTYTIUGUVCUVFUVBVNVOUVGUULXTAXGUVGUUF
      XQBUUKXSUVGUUHGUUJXRUVGUUHEUTTGUVGUUGEUTUVDUVFVPZVQPVGUVGUUILUVGUUIEVBTLU
      VGUUGEVBUVIVQSVGVRVSUVGUUEXPUVGUUCXLUUDXOUVGUUBDXJXKUUTUUBDUGUVCUVFUUTUUB
      JVATDYSJVAVFOVGVNWCUVGXNYQHUVHVMVTWAWDWEWFWGWGWHABUBUCUDUAWIYBUAYCIIUVAUP
      MJUTVIWJZWLWKWMWNWOWPCYCUEZYHYNWBZWBYFUVLWBYEYOUVKYFUVLCIUVJWQWRYBUVLUACY
      CXGCUGZXIYHYAYNUVMXHYGIXGCHVFWSXTYMAXGCUVMXQYLBXSUVMXPYKUVMXOYJXLUVMXNYIH
      XGCXMWTVQWPWAWEXAWFXCYFYHYNXBXDXE $.
  $}

  ${
    $d y A $.  $d x y B $.  $d x y E $.  $d x y F $.  $d x y K $.  $d x y N $.
    $d x y .x. $.  $d x y W $.  $d x y .0. $.
    lbsss.v $e |- V = ( Base ` W ) $.
    lbsss.j $e |- J = ( LBasis ` W ) $.
    $( A basis is a set of vectors.  (Contributed by Mario Carneiro,
       24-Jun-2014.) $)
    lbsss $p |- ( B e. J -> B C_ V ) $=
      ( vy vx wcel wss clspn cfv wceq cv cvsca csn cdif wral clbs eqid csca cbs
      co wn c0g w3a cdm wb elfvdm eleq2s islbs syl ibi simp1d ) ABIZACJZADKLZLC
      MZGNHNZDOLZUCAUSPQUQLIUDGDUALZUBLZVAUELZPQRHARZUOUPURVDUFZUODSUGZIZUOVEUH
      VGADSLBADSUIFUJHGAUTVABVBUQCDVFVCEVATUTTVBTFUQTVCTUKULUMUN $.

    $( An element of a basis is a vector.  (Contributed by Mario Carneiro,
       24-Jun-2014.) $)
    lbsel $p |- ( ( B e. J /\ E e. B ) -> E e. V ) $=
      ( wcel lbsss sselda ) ACHADBACDEFGIJ $.

    lbssp.n $e |- N = ( LSpan ` W ) $.
    $( The span of a basis is the whole space.  (Contributed by Mario Carneiro,
       24-Jun-2014.) $)
    lbssp $p |- ( B e. J -> ( N ` B ) = V ) $=
      ( vy vx wcel wss cfv wceq cv csn cdif wral clbs eqid cvsca co wn csca cbs
      c0g w3a cdm wb elfvdm eleq2s islbs syl ibi simp2d ) ABKZADLZACMDNZIOJOZEU
      AMZUBAUSPQCMKUCIEUDMZUEMZVAUFMZPQRJARZUPUQURVDUGZUPESUHZKZUPVEUIVGAESMBAE
      SUJGUKJIAUTVABVBCDEVFVCFVATUTTVBTGHVCTULUMUNUO $.

    lbsind.f $e |- F = ( Scalar ` W ) $.
    lbsind.s $e |- .x. = ( .s ` W ) $.
    lbsind.k $e |- K = ( Base ` F ) $.
    lbsind.z $e |- .0. = ( 0g ` F ) $.
    $( A basis is linearly independent; that is, every element has a span which
       trivially intersects the span of the remainder of the basis.
       (Contributed by Mario Carneiro, 12-Jan-2015.) $)
    lbsind $p |- ( ( ( B e. J /\ E e. B ) /\ ( A e. K /\ A =/= .0. ) ) ->
        -. ( A .x. E ) e. ( N ` ( B \ { E } ) ) ) $=
      ( vy wcel vx wne wa csn cdif co cfv wn eldifsn wral wss wceq w3a clbs cdm
      cv wb elfvdm eleq2s islbs syl ibi simp3d oveq2 sneq difeq2d fveq2d notbid
      eleq12d oveq1 eleq1d rspc2v syl5com impl sylan2br ) AGTAKUBUCBFTZDBTZUCAG
      KUDUEZTZADCUFZBDUDZUEZHUGZTZUHZAGKUIVPVQVSWEVPSUPZUAUPZCUFZBWGUDZUEZHUGZT
      ZUHZSVRUJUABUJZVQVSUCWEVPBIUKZBHUGIULZWNVPWOWPWNUMZVPJUNUOZTZVPWQUQWSBJUN
      UGFBJUNURMUSUASBCEFGHIJWRKLOPQMNRUTVAVBVCWMWEWFDCUFZWCTZUHUASDABVRWGDULZW
      LXAXBWHWTWKWCWGDWFCVDXBWJWBHXBWIWABWGDVEVFVGVIVHWFAULZXAWDXCWTVTWCWFADCVJ
      VKVHVLVMVNVO $.
  $}

  ${
    lbsind2.j $e |- J = ( LBasis ` W ) $.
    lbsind2.n $e |- N = ( LSpan ` W ) $.
    lbsind2.f $e |- F = ( Scalar ` W ) $.
    lbsind2.o $e |- .1. = ( 1r ` F ) $.
    lbsind2.z $e |- .0. = ( 0g ` F ) $.
    $( A basis is linearly independent; that is, every element is not in the
       span of the remainder of the basis.  (Contributed by Mario Carneiro,
       25-Jun-2014.)  (Revised by Mario Carneiro, 12-Jan-2015.) $)
    lbsind2 $p |- ( ( ( W e. LMod /\ .1. =/= .0. ) /\ B e. J /\ E e. B ) ->
                   -. E e. ( N ` ( B \ { E } ) ) ) $=
      ( clmod wcel wne cfv cbs eqid syl2anc wa w3a cvsca co csn cdif wceq simp2
      simp1l simp3 lbsel lmodvs1 wn lmodrng rngidcl 3syl simp1r lbsind syl22anc
      crg eqneltrrd ) GNOZBHPZUAZAEOZCAOZUBZBCGUCQZUDZCACUEUFFQZVGVBCGRQZOZVICU
      GVBVCVEVFUIZVGVEVFVLVDVEVFUHZVDVEVFUJZACEVKGVKSZIUKTVHBDVKGCVPKVHSZLULTVG
      VEVFBDRQZOZVCVIVJOUMVNVOVGVBDUTOVSVMDGKUNVRDBVRSZLUOUPVBVCVEVFUQBAVHCDEVR
      FVKGHVPIJKVQVTMURUSVA $.

    $d x y .0. $.  $d x y B $.  $d x y C $.  $d x y J $.  $d x N $.  $d x V $.
    $d x y .1. $.  $d x y W $.
    lbspss.v $e |- V = ( Base ` W ) $.
    $( No proper subset of a basis spans the space.  (Contributed by Mario
       Carneiro, 25-Jun-2014.) $)
    lbspss $p |- ( ( ( W e. LMod /\ .1. =/= .0. ) /\ B e. J /\ C C. B ) ->
      ( N ` C ) =/= V ) $=
      ( vx wcel wne wa wn vy clmod wpss w3a cv cfv pssnel 3ad2ant3 simpl2 lbsss
      wex wss syl simprl sseldd csn simpl1l ssdifssd simpl3 pssssd sseld simprr
      cdif eleq1 notbid syl5ibrcom necon2ad eldifsn syl6ibr ssrdv lspss syl3anc
      weq jcad simpl1r lbsind2 syl211anc ssneldd nelne1 syl2anc necomd exlimddv
      ) HUBQZCIRZSZAEQZBAUCZUDZPUEZAQZWIBQZTZSZBFUFZGRPWGWEWMPUKWFPBAUGUHWHWMSZ
      GWNWOWIGQWIWNQTGWNRWOAGWIWOWFAGULWEWFWGWMUIZAEGHOJUJUMZWHWJWLUNZUOWOWNAWI
      UPZVCZFUFZWIWOWCWTGULBWTULWNXAULWCWDWFWGWMUQZWOAGWSWQURWOUABWTWOUAUEZBQZX
      CAQZXCWIRZSXCWTQWOXDXEXFWOBAXCWOBAWEWFWGWMUSUTVAWOXDXCWIWOXDTUAPVMZWLWHWJ
      WLVBXGXDWKXCWIBVDVEVFVGVNXCAWIVHVIVJBWTFGHOKVKVLWOWCWDWFWJWIXAQTXBWCWDWFW
      GWMVOWPWRACWIDEFHIJKLMNVPVQVRWIGWNVSVTWAWB $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d a d e f g u v x y z .(+) $.
    $d a d e f g u v x y z S $.  $d a d e f g u v x y z T $.
    $d a d e f g u v x y z U $.  $d a d e f g u v x y z W $.
    lsmcl.s $e |- S = ( LSubSp ` W ) $.
    lsmcl.p $e |- .(+) = ( LSSum ` W ) $.
    $( The sum of two subspaces is a subspace.  (Contributed by NM,
       4-Feb-2014.)  (Revised by Mario Carneiro, 19-Apr-2016.) $)
    lsmcl $p |- ( ( W e. LMod /\ T e. S /\ U e. S ) -> ( T .(+) U ) e. S ) $=
      ( va vu vd ve wcel co cfv cv wral wa eqid syl2anc syl22anc clmod w3a csca
      csubg cvsca cbs lmodabl 3ad2ant1 lsssubg 3adant3 3adant2 lsmsubg2 syl3anc
      cplusg wceq wrex wb lsmelval adantr simpll1 simplr simpll2 simprl simpll3
      cabel lssel simprr lmodvsdi syl13anc lssvscl lsmelvali eqeltrd syl5ibrcom
      oveq2 eleq1d rexlimdvva sylbid impr ralrimivva islss4 mpbir2and ) EUALZCB
      LZDBLZUBZCDAMZBLZWFEUDNZLZHOZIOZEUENZMZWFLZIWFPHEUCNZUFNZPZWEEVELZCWHLZDW
      HLZWIWBWCWRWDEUGUHWBWCWSWDBCEFUIZUJZWBWDWTWCBDEFUIZUKZACDEGULUMWEWNHIWPWF
      WEWJWPLZWKWFLZWNWEXEQZXFWKJOZKOZEUNNZMZUOZKDUPJCUPZWNWEXFXMUQZXEWEWSWTXNX
      BXDJKXJACDEWKXJRZGURSUSXGXLWNJKCDXGXHCLZXIDLZQZQZWNXLWJXKWLMZWFLXSXTWJXHW
      LMZWJXIWLMZXJMZWFXSWBXEXHEUFNZLZXIYDLZXTYCUOWBWCWDXEXRUTZWEXEXRVAZXSWCXPY
      EWBWCWDXEXRVBZXGXPXQVCZBCYDEXHYDRZFVFSXSWDXQYFWBWCWDXEXRVDZXGXPXQVGZBDYDE
      XIYKFVFSXJWJWLWOWPYDEXHXIYKXOWORZWLRZWPRZVHVIXSWSWTYACLZYBDLZYCWFLXSWBWCW
      SYGYIXASXSWBWDWTYGYLXCSXSWBWCXEXPYQYGYIYHYJWPBWLCWOEWJXHYNYOYPFVJTXSWBWDX
      EXQYRYGYLYHYMWPBWLDWOEWJXIYNYOYPFVJTXJACDEYAYBXOGVKTVLXLWMXTWFWKXKWJWLVNV
      OVMVPVQVRVSWBWCWGWIWQQUQWDWPBWLWFWOYDEHIYNYPYKYOFVTUHWA $.
  $}

  ${
    $d j k v w .+ $.  $d j k F $.  $d j k v w K $.  $d j k v w N $.
    $d j k v w .x. $.  $d j k v w U $.  $d j k V $.  $d j k v w W $.
    $d j k v w X $.  $d j k v w Y $.  $d j k v w ph $.
    lsmspsn.v $e |- V = ( Base ` W ) $.
    lsmspsn.a $e |- .+ = ( +g ` W ) $.
    lsmspsn.f $e |- F = ( Scalar ` W ) $.
    lsmspsn.k $e |- K = ( Base ` F ) $.
    lsmspsn.t $e |- .x. = ( .s ` W ) $.
    lsmspsn.p $e |- .(+) = ( LSSum ` W ) $.
    lsmspsn.n $e |- N = ( LSpan ` W ) $.
    lsmspsn.w $e |- ( ph -> W e. LMod ) $.
    lsmspsn.x $e |- ( ph -> X e. V ) $.
    lsmspsn.y $e |- ( ph -> Y e. V ) $.
    $( Member of subspace sum of spans of singletons.  (Contributed by NM,
       8-Apr-2015.) $)
    lsmspsn $p |- ( ph -> ( U e. ( ( N ` { X } ) .(+) ( N ` { Y } ) )
            <-> E. j e. K E. k e. K U = ( ( j .x. X ) .+ ( k .x. Y ) ) ) ) $=
      ( vv vw csn cfv co wcel cv wceq wrex wa csubg wb clmod lspsnsubg lsmelval
      syl2anc lspsnel anbi12d biimpa biantrurd r19.41v rexbii 3bitrri 2rexbidva
      reeanv anbi1i syl6bb adantr simprl lspsneli simprr oveq1 eqeq2d ceqsrex2v
      rexrot4 oveq2 3bitrd ) AEMUGJUHZNUGJUHZCUIUJZEUEUKZUFUKZBUIZULZUFWCUMUEWB
      UMZWEFUKZMDUIZULZWFGUKZNDUIZULZUNZWHUNZUFWCUMUEWBUMZGIUMFIUMZEWKWNBUIZULZ
      GIUMFIUMAWBLUOUHZUJZWCXBUJZWDWIUPALUQUJZMKUJZXCUBUCJKLMOUAURUTAXENKUJZXDU
      BUDJKLNOUAURUTUEUFBCWBWCLEPTUSUTAWIWQGIUMZFIUMZUFWCUMUEWBUMWSAWHXIUEUFWBW
      CAWEWBUJZWFWCUJZUNZUNZWHWLFIUMZWOGIUMZUNZWHUNZXIXMXPWHAXLXPAXJXNXKXOAXEXF
      XJXNUPUBUCDWEFHIJKLMQROSUAVAUTAXEXGXKXOUPUBUDDWFGHIJKLNQROSUAVAUTVBVCVDXI
      WPGIUMZWHUNZFIUMXRFIUMZWHUNXQXHXSFIWPWHGIVEVFXRWHFIVEXTXPWHWLWOFGIIVIVJVG
      VKVHWQUEUFFGWBWCIIVSVKAWRXAFGIIAWJIUJZWMIUJZUNZUNZWKWBUJWNWCUJWRXAUPYDWJD
      HIJKLMOSQRUAAXEYCUBVLZAYAYBVMAXFYCUCVLVNYDWMDHIJKLNOSQRUAYEAYAYBVOAXGYCUD
      VLVNWHEWKWFBUIZULXAUEUFWKWNWBWCWLWGYFEWEWKWFBVPVQWOYFWTEWFWNWKBVTVQVRUTVH
      WA $.
  $}

  ${
    $d y z .(+) $.  $d y z T $.  $d y z U $.  $d y z V $.  $d y z W $.
    $d y z X $.  $d y z ph $.
    lsmelval2.v $e |- V = ( Base ` W ) $.
    lsmelval2.s $e |- S = ( LSubSp ` W ) $.
    lsmelval2.p $e |- .(+) = ( LSSum ` W ) $.
    lsmelval2.n $e |- N = ( LSpan ` W ) $.
    lsmelval2.w $e |- ( ph -> W e. LMod ) $.
    lsmelval2.t $e |- ( ph -> T e. S ) $.
    lsmelval2.u $e |- ( ph -> U e. S ) $.
    $( Subspace sum membership in terms of a sum of 1-dim subspaces (atoms),
       which can be useful for treating subspaces as projective lattice
       elements.  (Contributed by NM, 9-Aug-2014.) $)
    lsmelval2 $p |- ( ph -> ( X e. ( T .(+) U ) <-> ( X e. V /\ E. y e. T
       E. z e. U ( N ` { X } ) C_ ( ( N ` { y } ) .(+) ( N ` { z } ) ) ) ) ) $=
      ( wcel syl2anc co csn cfv cv wa wrex cplusg wceq csubg clmod lsssubg eqid
      wss wb lsmelval wi adantr simprl lssel lspsncl lspsnid lsmelvali syl22anc
      simprr eleq1a syl lsmcl syl3anc lspsnel6 sylibd reximdva sylbid lspsnel5a
      anassrs lsmless1 lsmless2 sstrd sseld sylbird impbid r19.42v rexbii bitri
      rexlimdvva syl6bb ) AKFGDUAZSZKISZKUBHUCBUDZUBHUCZCUDZUBHUCZDUAZUMZUEZCGU
      FZBFUFZWHWNCGUFZBFUFUEZAWGWQAWGKWIWKJUGUCZUAZUHZCGUFZBFUFZWQAFJUIUCZSZGXE
      SZWGXDUNAJUJSZFESZXFPQEFJMUKTZAXHGESZXGPREGJMUKTZBCWTDFGJKWTULZNUOTAXCWPB
      FAWIFSZUEXBWOCGAXNWKGSZXBWOUPAXNXOUEZUEZXBKWMSZWOXQXAWMSZXBXRUPXQWJXESZWL
      XESZWIWJSZWKWLSZXSXQXHWJESZXTAXHXPPUQZXQXHWIISZYDYEXQXIXNYFAXIXPQUQZAXNXO
      URZEFIJWILMUSTZEHIJWILMOUTTZEWJJMUKTXQXHWLESZYAYEXQXHWKISZYKYEXQXKXOYLAXK
      XPRUQZAXNXOVDZEGIJWKLMUSTZEHIJWKLMOUTTZEWLJMUKTZXQXHYFYBYEYIHIJWILOVATXQX
      HYLYCYEYOHIJWKLOVATWTDWJWLJWIWKXMNVBVCXAWMKVEVFXQEWMHIJKLMOYEXQXHYDYKWMES
      YEYJYPDEWJWLJMNVGVHVIZVJVNVKVKVLAWOWGBCFGXQWOXRWGYRXQWMWFKXQWMFWLDUAZWFXQ
      XFYAWJFUMWMYSUMAXFXPXJUQZYQXQEFHJWIMOYEYGYHVMDWJFWLJNVOVHXQXFXGWLGUMYSWFU
      MYTAXGXPXLUQXQEGHJWKMOYEYMYNVMDFWLGJNVPVHVQVRVSWDVTWQWHWRUEZBFUFWSWPUUABF
      WHWNCGWAWBWHWRBFWAWCWE $.
  $}

  ${
    lsmsp.s $e |- S = ( LSubSp ` W ) $.
    lsmsp.n $e |- N = ( LSpan ` W ) $.
    lsmsp.p $e |- .(+) = ( LSSum ` W ) $.
    $( Subspace sum in terms of span.  (Contributed by NM, 6-Feb-2014.)  (Proof
       shortened by Mario Carneiro, 21-Jun-2014.) $)
    lsmsp $p |- ( ( W e. LMod /\ T e. S /\ U e. S )
       -> ( T .(+) U ) = ( N ` ( T u. U ) ) ) $=
      ( clmod wcel w3a co cun cfv wss lssss syl2anc sseldd syl3anc cbs 3ad2ant2
      simp1 3ad2ant3 unssd lspssid unssad unssbd csubg wa wb lsssssubg 3ad2ant1
      eqid simp2 simp3 lspcl lsmlub mpbi2and lsmcl lsmunss lspssp eqssd ) FJKZC
      BKZDBKZLZCDAMZCDNZEOZVGCVJPZDVJPZVHVJPZVGCDVJVGVDVIFUAOZPZVIVJPVDVEVFUCZV
      GCDVNVEVDCVNPVFBCVNFVNUNZGQUBVFVDDVNPVEBDVNFVQGQUDUEZVIEVNFVQHUFRZUGVGCDV
      JVSUHVGCFUIOZKZDVTKZVJVTKVKVLUJVMUKVGBVTCVDVEBVTPVFBFGULUMZVDVEVFUOSZVGBV
      TDWCVDVEVFUPSZVGBVTVJWCVGVDVOVJBKVPVRBVIEVNFVQGHUQRSACDVJFIURTUSVGVDVHBKV
      IVHPZVJVHPVPABCDFGIUTVGWAWBWFWDWEACDFIVARBVIVHEFGHVBTVC $.
  $}

  ${
    lsmsp2.v $e |- V = ( Base ` W ) $.
    lsmsp2.n $e |- N = ( LSpan ` W ) $.
    lsmsp2.p $e |- .(+) = ( LSSum ` W ) $.
    $( Subspace sum of spans of subsets is the span of their union.
       ( ~ spanuni analog.)  (Contributed by NM, 22-Feb-2014.)  (Revised by
       Mario Carneiro, 21-Jun-2014.) $)
    lsmsp2 $p |- ( ( W e. LMod /\ T C_ V /\ U C_ V )
       -> ( ( N ` T ) .(+) ( N ` U ) ) = ( N ` ( T u. U ) ) ) $=
      ( clmod wcel wss w3a cfv co cun clss wceq simp1 lspcl 3adant3 lsmsp lspun
      eqid 3adant2 syl3anc eqtr4d ) FJKZBELZCELZMZBDNZCDNZAOZULUMPDNZBCPDNUKUHU
      LFQNZKZUMUPKZUNUORUHUIUJSUHUIUQUJUPBDEFGUPUDZHTUAUHUJURUIUPCDEFGUSHTUEAUP
      ULUMDFUSHIUBUFBCDEFGHUCUG $.

    lsmssspx.t $e |- ( ph -> T C_ V ) $.
    lsmssspx.u $e |- ( ph -> U C_ V ) $.
    lsmssspx.w $e |- ( ph -> W e. LMod ) $.
    $( Subspace sum (in its extended domain) is a subset of the span of the
       union of its arguments.  (Contributed by NM, 6-Aug-2014.) $)
    lsmssspx $p |- ( ph -> ( T .(+) U ) C_ ( N ` ( T u. U ) ) ) $=
      ( co cfv clmod wss lspssv syl2anc lspssid wcel lsmless1x lsmless2x lsmsp2
      cun syl31anc sstrd wceq syl3anc sseqtrd ) ACDBNZCEOZDEOZBNZCDUEEOZAUKULDB
      NZUNAGPUAZULFQZDFQZCULQZUKUPQMAUQCFQZURMKCEFGHIRSZLAUQVAUTMKCEFGHITSFBCUL
      DGPHJUBUFAUQURUMFQZDUMQZUPUNQMVBAUQUSVCMLDEFGHIRSAUQUSVDMLDEFGHITSFBULDUM
      GPHJUCUFUGAUQVAUSUNUOUHMKLBCDEFGHIJUDUIUJ $.
  $}

  ${
    lsmpr.v $e |- V = ( Base ` W ) $.
    lsmpr.n $e |- N = ( LSpan ` W ) $.
    lsmpr.p $e |- .(+) = ( LSSum ` W ) $.
    lsmpr.w $e |- ( ph -> W e. LMod ) $.
    lsmpr.x $e |- ( ph -> X e. V ) $.
    lsmpr.y $e |- ( ph -> Y e. V ) $.
    $( The span of a pair of vectors equals the sum of the spans of their
       singletons.  (Contributed by NM, 13-Jan-2015.) $)
    lsmpr $p |- ( ph
         -> ( N ` { X , Y } ) = ( ( N ` { X } ) .(+) ( N ` { Y } ) ) ) $=
      ( csn cun cfv wcel wss wceq snssd cpr co clmod lspun syl3anc df-pr fveq2i
      a1i clss eqid lspsncl syl2anc lsmsp 3eqtr4d ) AFNZGNZOZCPZUOCPZUPCPZOCPZF
      GUAZCPZUSUTBUBZAEUCQZUODRUPDRURVASKAFDLTAGDMTUOUPCDEHIUDUEVCURSAVBUQCFGUF
      UGUHAVEUSEUIPZQZUTVFQZVDVASKAVEFDQVGKLVFCDEFHVFUJZIUKULAVEGDQVHKMVFCDEGHV
      IIUKULBVFUSUTCEVIIJUMUEUN $.
  $}

  ${
    lsppreli.v $e |- V = ( Base ` W ) $.
    lsppreli.p $e |- .+ = ( +g ` W ) $.
    lsppreli.t $e |- .x. = ( .s ` W ) $.
    lsppreli.f $e |- F = ( Scalar ` W ) $.
    lsppreli.k $e |- K = ( Base ` F ) $.
    lsppreli.n $e |- N = ( LSpan ` W ) $.
    lsppreli.w $e |- ( ph -> W e. LMod ) $.
    lsppreli.a $e |- ( ph -> A e. K ) $.
    lsppreli.b $e |- ( ph -> B e. K ) $.
    lsppreli.x $e |- ( ph -> X e. V ) $.
    lsppreli.y $e |- ( ph -> Y e. V ) $.
    $( A vector expressed as a sum belongs to the span of its components.
       (Contributed by NM, 9-Apr-2015.) $)
    lsppreli $p |- ( ph ->
      ( ( A .x. X ) .+ ( B .x. Y ) ) e. ( N ` { X , Y } ) ) $=
      ( csn cfv clsm csubg wcel clmod lspsnsubg syl2anc lspsneli eqid lsmelvali
      co cpr syl22anc lsmpr eleqtrrd ) ABKEUOZCLEUOZDUOZKUDHUEZLUDHUEZJUFUEZUOZ
      KLUPHUEAVCJUGUEZUHZVDVGUHZUTVCUHVAVDUHVBVFUHAJUIUHZKIUHVHSUBHIJKMRUJUKAVJ
      LIUHVISUCHIJLMRUJUKABEFGHIJKMOPQRSTUBULACEFGHIJLMOPQRSUAUCULDVEVCVDJUTVAN
      VEUMZUNUQAVEHIJKLMRVKSUBUCURUS $.
  $}

  ${
    lsmelpr.v $e |- V = ( Base ` W ) $.
    lsmelpr.n $e |- N = ( LSpan ` W ) $.
    lsmelpr.p $e |- .(+) = ( LSSum ` W ) $.
    lsmelpr.w $e |- ( ph -> W e. LMod ) $.
    lsmelpr.x $e |- ( ph -> X e. V ) $.
    lsmelpr.y $e |- ( ph -> Y e. V ) $.
    lsmelpr.z $e |- ( ph -> Z e. V ) $.
    $( Two ways to say that a vector belongs to the span of a pair of vectors.
       (Contributed by NM, 14-Jan-2015.) $)
    lsmelpr $p |- ( ph -> ( X e. ( N ` { Y , Z } )
           <-> ( N ` { X } ) C_ ( ( N ` { Y } ) .(+) ( N ` { Z } ) ) ) ) $=
      ( cpr cfv wcel csn wss co clss eqid lspprcl lspsnel5 lsmpr sseq2d bitrd )
      AFGHPCQZRFSCQZUITUJGSCQHSCQBUAZTAEUBQZUICDEFIULUCZJLAULCDEGHIUMJLNOUDMUEA
      UIUKUJABCDEGHIJKLNOUFUGUH $.
  $}

  ${
    lsppr0.v $e |- V = ( Base ` W ) $.
    lsppr0.z $e |- .0. = ( 0g ` W ) $.
    lsppr0.n $e |- N = ( LSpan ` W ) $.
    lsppr0.w $e |- ( ph -> W e. LMod ) $.
    lsppr0.x $e |- ( ph -> X e. V ) $.
    $( The span of a vector paired with zero equals the span of the singleton
       of the vector.  (Contributed by NM, 29-Aug-2014.) $)
    lsppr0 $p |- ( ph -> ( N ` { X , .0. } ) = ( N ` { X } ) ) $=
      ( cpr cfv csn clsm co eqid wcel syl wceq lmod0vcl lspsn0 oveq2d lspsnsubg
      clmod lsmpr csubg syl2anc lsm01 3eqtrd ) AEFLBMENBMZFNZBMZDOMZPUKULUNPZUK
      AUNBCDEFGIUNQZJKADUERZFCRJCDFGHUASUFAUMULUKUNAUQUMULTJBDFHIUBSUCAUKDUGMRZ
      UOUKTAUQECRURJKBCDEGIUDUHUNDUKFHUPUISUJ $.
  $}

  ${
    $d k l x y .+ $.  $d k l F $.  $d k l x y K $.  $d k l v x y N $.
    $d k l x y .x. $.  $d k l V $.  $d k l v x y W $.  $d k l v x y X $.
    $d k l v x y Y $.  $d k l v x y ph $.
    lsppr.v $e |- V = ( Base ` W ) $.
    lsppr.a $e |- .+ = ( +g ` W ) $.
    lsppr.f $e |- F = ( Scalar ` W ) $.
    lsppr.k $e |- K = ( Base ` F ) $.
    lsppr.t $e |- .x. = ( .s ` W ) $.
    lsppr.n $e |- N = ( LSpan ` W ) $.
    lsppr.w $e |- ( ph -> W e. LMod ) $.
    lsppr.x $e |- ( ph -> X e. V ) $.
    lsppr.y $e |- ( ph -> Y e. V ) $.
    $( Span of a pair of vectors.  (Contributed by NM, 22-Aug-2014.) $)
    lsppr $p |- ( ph -> ( N ` { X , Y } )
          = { v | E. k e. K E. l e. K v = ( ( k .x. X ) .+ ( l .x. Y ) ) } ) $=
      ( cpr cfv csn cun cv wceq wrex cab df-pr fveq2i clsm clmod wcel wss snssd
      co lspun syl3anc clss eqid lspsncl syl2anc lsmspsn abbi2dv 3eqtr2d syl5eq
      lsmsp ) AKLUCZHUDKUEZLUEZUFZHUDZBUGZEUGKDURMUGLDURCURUHMGUIEGUIZBUJZVJVMH
      KLUKULAVNVKHUDZVLHUDZUFHUDZVRVSJUMUDZURZVQAJUNUOZVKIUPVLIUPVNVTUHTAKIUAUQ
      ALIUBUQVKVLHIJNSUSUTAWCVRJVAUDZUOZVSWDUOZWBVTUHTAWCKIUOWETUAWDHIJKNWDVBZS
      VCVDAWCLIUOWFTUBWDHIJLNWGSVCVDWAWDVRVSHJWGSWAVBZVIUTAVPBWBACWADVOEMFGHIJK
      LNOPQRWHSTUAUBVEVFVGVH $.

    $d k l v Z $.  $d v .+ $.  $d v .x. $.  $d v K $.
    $( Member of the span of a pair of vectors.  (Contributed by NM,
       10-Apr-2015.) $)
    lspprel $p |- ( ph -> ( Z e. ( N ` { X , Y } )
            <-> E. k e. K E. l e. K Z = ( ( k .x. X ) .+ ( l .x. Y ) ) ) ) $=
      ( vv cpr cfv wcel cv co wceq wrex cab lsppr eleq2d cvv syl6eqel rexlimivw
      id ovex eqeq1 2rexbidv elab3 syl6bb ) ALJKUDGUEZUFLUCUGZDUGJCUHZMUGKCUHZB
      UHZUIZMFUJDFUJZUCUKZUFLVGUIZMFUJZDFUJZAVCVJLAUCBCDEFGHIJKMNOPQRSTUAUBULUM
      VIVMUCLVLLUNUFZDFVKVNMFVKLVGUNVKUQVEVFBURUOUPUPVDLUIVHVKDMFFVDLVGUSUTVAVB
      $.
  $}

  ${
    lspprabs.v $e |- V = ( Base ` W ) $.
    lspprabs.p $e |- .+ = ( +g ` W ) $.
    lspprabs.n $e |- N = ( LSpan ` W ) $.
    lspprabs.w $e |- ( ph -> W e. LMod ) $.
    lspprabs.x $e |- ( ph -> X e. V ) $.
    lspprabs.y $e |- ( ph -> Y e. V ) $.
    $( Absorption of vector sum into span of pair.  (Contributed by NM,
       27-Apr-2015.) $)
    lspprabs $p |- ( ph -> ( N ` { X , ( X .+ Y ) } ) = ( N ` { X , Y } ) ) $=
      ( cfv co wss wcel syl2anc sseldd syl3anc csn clsm cpr clss eqid lsssssubg
      csubg clmod syl lspsncl lsmub1 lsmcl lspsnid lsmelvali syl22anc lspsnel5a
      wa wb lmodvacl lsmlub mpbi2and csg lsmelvalmi cabel wceq ablpncan2 lsmcom
      lmodabl 3eltr3d eqssd lsmpr 3eqtr4d ) AFUACNZFGBOZUACNZEUBNZOZVMGUACNZVPO
      ZFVNUCCNFGUCCNAVQVSAVMVSPZVOVSPZVQVSPZAVMEUGNZQZVRWCQZVTAEUDNZWCVMAEUHQZW
      FWCPKWFEWFUEZUFUIZAWGFDQZVMWFQZKLWFCDEFHWHJUJRZSZAWFWCVRWIAWGGDQZVRWFQZKM
      WFCDEGHWHJUJRZSZVPVMVREVPUEZUKRAWFVSCEVNWHJKAWGWKWOVSWFQKWLWPVPWFVMVREWHW
      RULTZAWDWEFVMQZGVRQZVNVSQWMWQAWGWJWTKLCDEFHJUMRZAWGWNXAKMCDEGHJUMRBVPVMVR
      EFGIWRUNUOUPAWDVOWCQZVSWCQVTWAUQWBURWMAWFWCVOWIAWGVNDQZVOWFQZKAWGWJWNXDKL
      MBDEFGHIUSTZWFCDEVNHWHJUJRZSZAWFWCVSWIWSSVPVMVOVSEWRUTTVAAVMVQPZVRVQPZVSV
      QPZAWDXCXIWMXHVPVMVOEWRUKRAWFVQCEGWHJKAWGWKXEVQWFQKWLXGVPWFVMVOEWHWRULTZA
      VNFEVBNZOZVOVMVPOZGVQAVPVOVMEXMVNFXMUEZWRXHWMAWGXDVNVOQKXFCDEVNHJUMRXBVCA
      EVDQZWJWNXNGVEAWGXQKEVHUIZLMDBEXMFGHIXPVFTAXQXCWDXOVQVEXRXHWMVPVOVMEWRVGT
      VIUPAWDWEVQWCQXIXJUQXKURWMWQAWFWCVQWIXLSVPVMVRVQEWRUTTVAVJAVPCDEFVNHJWRKL
      XFVKAVPCDEFGHJWRKLMVKVL $.
  $}

  ${
    lspvadd.v $e |- V = ( Base ` W ) $.
    lspvadd.a $e |- .+ = ( +g ` W ) $.
    lspvadd.n $e |- N = ( LSpan ` W ) $.
    $( The span of a vector sum is included in the span of its arguments.
       (Contributed by NM, 22-Feb-2014.)  (Proof shortened by Mario Carneiro,
       21-Jun-2014.) $)
    lspvadd $p |- ( ( W e. LMod /\ X e. V /\ Y e. V )
       -> ( N ` { ( X .+ Y ) } ) C_ ( N ` { X , Y } ) ) $=
      ( clmod wcel w3a clss cfv cpr co eqid wss 3adant1 syl2anc simp1 wa mpbird
      prssi lspcl lspssid wb prssg lssvacl syl21anc lspsnel5a ) DJKZECKZFCKZLZD
      MNZEFOZBNZBDEFAPZUPQZIULUMUNUAZUOULUQCRZURUPKZVAUMUNVBULEFCUDSZUPUQBCDGUT
      IUETZUOULVCEURKFURKUBZUSURKVAVEUOVFUQURRZUOULVBVGVAVDUQBCDGIUFTUMUNVFVGUG
      ULEFURCCUHSUCAUPURDEFHUTUIUJUK $.
  $}

  ${
    lspsntri.v $e |- V = ( Base ` W ) $.
    lspsntri.a $e |- .+ = ( +g ` W ) $.
    lspsntri.n $e |- N = ( LSpan ` W ) $.
    lspsntri.p $e |- .(+) = ( LSSum ` W ) $.
    $( Triangle-type inequality for span of a singleton.  (Contributed by NM,
       24-Feb-2014.)  (Revised by Mario Carneiro, 21-Jun-2014.) $)
    lspsntri $p |- ( ( W e. LMod /\ X e. V /\ Y e. V )
       -> ( N ` { ( X .+ Y ) } ) C_ ( ( N ` { X } ) .(+) ( N ` { Y } ) ) ) $=
      ( clmod wcel w3a co csn cfv cun wss snssd cpr lspvadd df-pr syl6sseq wceq
      fveq2i simp1 simp2 simp3 lsmsp2 syl3anc sseqtr4d ) ELMZFDMZGDMZNZFGAOPCQZ
      FPZGPZRZCQZURCQUSCQBOZUPUQFGUAZCQVAACDEFGHIJUBVCUTCFGUCUFUDUPUMURDSUSDSVB
      VAUEUMUNUOUGUPFDUMUNUOUHTUPGDUMUNUOUITBURUSCDEHJKUJUKUL $.
  $}

  ${
    lspsntrim.v $e |- V = ( Base ` W ) $.
    lspsntrim.s $e |- .- = ( -g ` W ) $.
    lspsntrim.p $e |- .(+) = ( LSSum ` W ) $.
    lspsntrim.n $e |- N = ( LSpan ` W ) $.
    $( Triangle-type inequality for span of a singleton of vector difference.
       (Contributed by NM, 25-Apr-2014.)  (Revised by Mario Carneiro,
       21-Jun-2014.) $)
    lspsntrim $p |- ( ( W e. LMod /\ X e. V /\ Y e. V )
        -> ( N ` { ( X .- Y ) } ) C_ ( ( N ` { X } ) .(+) ( N ` { Y } ) ) ) $=
      ( clmod wcel w3a cfv co csn eqid 3adant2 wceq cminusg cplusg wss lspsntri
      lmodvnegcl syld3an3 grpsubval sneqd fveq2d 3adant1 lspsnneg eqcomd oveq2d
      wa 3sstr4d ) ELMZFDMZGDMZNZFGEUAOZOZEUBOZPZQZCOZFQCOZVAQCOZAPZFGBPZQZCOZV
      FGQCOZAPUPUQURVADMZVEVHUCUPURVMUQUTDEGHUTRZUESVBACDEFVAHVBRZKJUDUFUQURVKV
      ETUPUQURUNZVJVDCVPVIVCDVBEUTBFGHVOVNIUGUHUIUJUSVLVGVFAUSVGVLUPURVGVLTUQUT
      CDEGHVNKUKSULUMUO $.
  $}

  ${
    $d u v x y B $.  $d u v x y z K $.  $d u v x y z L $.  $d u v x y z ph $.
    $d u v x y F $.  $d u v x y G $.  $d v x y P $.  $d x y W $.
    lbspropd.b1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lbspropd.b2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lbspropd.w $e |- ( ph -> B C_ W ) $.
    lbspropd.p $e |- ( ( ph /\ ( x e. W /\ y e. W ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lbspropd.s1 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) e. W ) $.
    lbspropd.s2 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    lbspropd.f $e |- F = ( Scalar ` K ) $.
    lbspropd.g $e |- G = ( Scalar ` L ) $.
    lbspropd.p1 $e |- ( ph -> P = ( Base ` F ) ) $.
    lbspropd.p2 $e |- ( ph -> P = ( Base ` G ) ) $.
    lbspropd.a $e |- ( ( ph /\ ( x e. P /\ y e. P ) ) ->
      ( x ( +g ` F ) y ) = ( x ( +g ` G ) y ) ) $.
    lbspropd.v1 $e |- ( ph -> K e. _V ) $.
    lbspropd.v2 $e |- ( ph -> L e. _V ) $.
    $( If two structures have the same components (properties), they have the
       same set of bases.  (Contributed by Mario Carneiro, 9-Feb-2015.)
       (Revised by Mario Carneiro, 14-Jun-2015.) $)
    lbspropd $p |- ( ph -> ( LBasis ` K ) = ( LBasis ` L ) ) $=
      ( vz vv vu clbs cfv cv cbs wss clspn wceq cvsca co csn cdif wcel c0g wral
      wn w3a wa simplll eldifi adantl simpr sselda adantr proplem syl12anc csca
      fveq2i syl6eq lsppropd syl fveq1d eleq12d notbid ralbidva difeq1d raleqdv
      ad2antrr grpidpropd difeq12d 3bitr3d anbi2d pm5.32da sseq2d anbi1d eqtr3d
      sneqd eqeq12d anbi12d 3anass 3bitr4g cvv wb eqid islbs 3bitr4d eqrdv ) AU
      DHUGUHZIUGUHZAUDUIZHUJUHZUKZXEHULUHZUHZXFUMZUEUIZUFUIZHUNUHZUOZXEXLUPUQZX
      HUHZURZVAZUEFUJUHZFUSUHZUPZUQZUTZUFXEUTZVBZXEIUJUHZUKZXEIULUHZUHZYFUMZXKX
      LIUNUHZUOZXOYHUHZURZVAZUEGUJUHZGUSUHZUPZUQZUTZUFXEUTZVBZXEXCURZXEXDURZAXG
      XJYDVCZVCZYGYJUUAVCZVCZYEUUBAXEDUKZUUEVCUUIXJUUAVCZVCUUFUUHAUUIUUEUUJAUUI
      VCZYDUUAXJUUKYCYTUFXEUUKXLXEURZVCZXRUEEYAUQZUTYOUEUUNUTYCYTUUMXRYOUEUUNUU
      MXKUUNURZVCZXQYNUUPXNYLXPYMUUPAXKEURZXLDURZXNYLUMAUUIUULUUOVDZUUOUUQUUMXK
      EYAVEVFUUMUURUUOUUKXEDXLAUUIVGVHVIABCEDXMYKXKXLPVJVKUUPXOXHYHUUPAXHYHUMUU
      SABCDEHIJKLMNOPAEXSHVLUHZUJUHSFUUTUJQVMVNAEYPIVLUHZUJUHTGUVAUJRVMVNUBUCVO
      ZVPVQVRVSVTUUMXRUEUUNYBUUMEXSYAAEXSUMUUIUULSWCWAWBUUMYOUEUUNYSUUMEYPYAYRA
      EYPUMUUIUULTWCUUMXTYQAXTYQUMUUIUULABCEFGSTUAWDWCWLWEWBWFVTWGWHAUUIXGUUEAD
      XFXEKWIWJAUUIYGUUJUUGADYFXELWIAXJYJUUAAXIYIXFYFAXEXHYHUVBVQADXFYFKLWKWMWJ
      WNWFXGXJYDWOYGYJUUAWOWPAHWQURUUCYEWRUBUFUEXEXMFXCXSXHXFHWQXTXFWSQXMWSXSWS
      XCWSXHWSXTWSWTVPAIWQURUUDUUBWRUCUFUEXEYKGXDYPYHYFIWQYQYFWSRYKWSYPWSXDWSYH
      WSYQWSWTVPXAXB $.
  $}

  ${
    $d x y .(+) $.  $d x y P $.  $d x y ph $.  $d x y T $.  $d x y U $.
    $d x y W $.
    pj1lmhm.l $e |- L = ( LSubSp ` W ) $.
    pj1lmhm.s $e |- .(+) = ( LSSum ` W ) $.
    pj1lmhm.z $e |- .0. = ( 0g ` W ) $.
    pj1lmhm.p $e |- P = ( proj1 ` W ) $.
    pj1lmhm.1 $e |- ( ph -> W e. LMod ) $.
    pj1lmhm.2 $e |- ( ph -> T e. L ) $.
    pj1lmhm.3 $e |- ( ph -> U e. L ) $.
    pj1lmhm.4 $e |- ( ph -> ( T i^i U ) = { .0. } ) $.
    $( The left projection function is a linear operator.  (Contributed by
       Mario Carneiro, 15-Oct-2015.)  (Revised by Mario Carneiro,
       21-Apr-2016.) $)
    pj1lmhm $p |- ( ph -> ( T P U ) e. ( ( W |`s ( T .(+) U ) ) LMHom W ) ) $=
      ( co wcel cfv wceq vx vy cress clmhm cghm csca cv cvsca wral cplusg ccntz
      cbs eqid csubg clmod wss lsssssubg syl sseldd lmodabl ablcntzd pj1ghm a1i
      cabel wa pj1id adantrl oveq2d adantr simprl lssss cin csn simprr ffvelrnd
      lmodvsdi syl13anc eqtrd lsmcl syl3anc lssvscl syl22anc pj1eq mpbid simpld
      pj1f pj2f ralrimivva subgbas raleqdv ralbidv w3a lsslmod syl2anc cvv ovex
      wb resssca ax-mp ressvsca islmhm3 mpbir3and ) ADEBQZGDECQZUCQZGUDQRZXCXEG
      UEQRZGUFSZXHTZUAUGZUBUGZGUHSZQZXCSXJXKXCSZXLQZTZUBXEULSZUIZUAXHULSZUIZABG
      UJSZCDEGHGUKSZYAUMZJKYBUMZAFGUNSZDAGUORZFYEUPMFGIUQURZNUSZAFYEEYGOUSZPADE
      GYBYDAYFGVDRMGUTURYHYIVAZLVBXIAXHUMZVCAXPUBXDUIZUAXSUIXTAXPUAUBXSXDAXJXSR
      ZXKXDRZVEZVEZXPXMEDBQZSXJXKYQSZXLQZTZYPXMXOYSYAQZTXPYTVEYPXMXJXNYRYAQZXLQ
      ZUUAYPXKUUBXJXLAYNXKUUBTYMABYACDEGXKHYBYCJKYDYHYIPYJLVFVGVHYPYFYMXNGULSZR
      YRUUDRUUCUUATAYFYOMVIZAYMYNVJZYPDUUDXNYPDFRZDUUDUPAUUGYONVIZFDUUDGUUDUMZI
      VKURYPXDDXKXCYPBYACDEGHYBYCJKYDADYERYOYHVIZAEYERYOYIVIZADEVLHVMTYOPVIZADE
      YBSUPYOYJVIZLWFAYMYNVNZVOZUSYPEUUDYRYPEFRZEUUDUPAUUPYOOVIZFEUUDGUUIIVKURY
      PXDEXKYQYPBYACDEGHYBYCJKYDUUJUUKUULUUMLWGUUNVOZUSYAXJXLXHXSUUDGXNYRUUIYCY
      KXLUMZXSUMZVPVQVRYPXOYSBYACDEGXMHYBYCJKYDUUJUUKUULUUMLYPYFXDFRZYMYNXMXDRU
      UEAUVAYOAYFUUGUUPUVAMNOCFDEGIJVSVTZVIUUFUUNXSFXLXDXHGXJXKYKUUSUUTIWAWBYPY
      FUUGYMXNDRXODRUUEUUHUUFUUOXSFXLDXHGXJXNYKUUSUUTIWAWBYPYFUUPYMYRERYSERUUEU
      UQUUFUURXSFXLEXHGXJYRYKUUSUUTIWAWBWCWDWEWHAYLXRUAXSAXPUBXDXQAXDYERXDXQTAF
      YEXDYGUVBUSXDGXEXEUMZWIURWJWKWDAXEUORZYFXFXGXIXTWLWQAYFUVAUVDMUVBFXDGXEUV
      CIWMWNMUAUBXSXEGXLXLXQXCXHXHXDWORZXHXEUFSTDECWPZXDXHGXEWOUVCYKWRWSYKUUTXQ
      UMUVEXLXEUHSTUVFXDXLGXEWOUVCUUSWTWSUUSXAWNXB $.

    $( The left projection function is a linear operator.  (Contributed by
       Mario Carneiro, 15-Oct-2015.)  (Revised by Mario Carneiro,
       21-Apr-2016.) $)
    pj1lmhm2 $p |- ( ph ->
      ( T P U ) e. ( ( W |`s ( T .(+) U ) ) LMHom ( W |`s T ) ) ) $=
      ( co wcel cfv eqid cress clmhm pj1lmhm clmod crn wb wf cplusg ccntz csubg
      wss lsssssubg syl cabel lmodabl ablcntzd pj1f frn reslmhm2b syl3anc mpbid
      sseldd ) ADEBQZGDECQZUAQZGUBQRZVCVEGDUAQZUBQRZABCDEFGHIJKLMNOPUCAGUDRZDFR
      VCUEDUKZVFVHUFMNAVDDVCUGVJABGUHSZCDEGHGUISZVKTJKVLTZAFGUJSZDAVIFVNUKMFGIU
      LUMZNVBZAFVNEVOOVBZPADEGVLVMAVIGUNRMGUOUMVPVQUPLUQVDDVCURUMVEGVGVCFDVGTIU
      SUTVA $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LVec $.

  $( Extend class notation with class of all left vector spaces. $)
  clvec $a class LVec $.

  $( Define the class of all left vector spaces.  A left vector space over a
     division ring is an Abelian group (vectors) together with a division ring
     (scalars) and a left scalar product connecting them.  Some authors call
     this a "left module over a division ring", reserving "vector space" for
     those where the division ring multiplication is commutative i.e. a field.
     (Contributed by NM, 11-Nov-2013.) $)
  df-lvec $a |- LVec = { f e. LMod | ( Scalar ` f ) e. DivRing } $.

  ${
    $d f F $.  $d f W $.
    islvec.1 $e |- F = ( Scalar ` W ) $.
    $( The predicate "is a left vector space".  (Contributed by NM,
       11-Nov-2013.) $)
    islvec $p |- ( W e. LVec <-> ( W e. LMod /\ F e. DivRing ) ) $=
      ( vf cv csca cfv cdr wcel clmod clvec fveq2 syl6eqr eleq1d df-lvec elrab2
      wceq ) DEZFGZHIAHIDBJKRBQZSAHTSBFGARBFLCMNDOP $.

    $( The set of scalars of a left vector space is a division ring.
       (Contributed by NM, 17-Apr-2014.) $)
    lvecdrng $p |- ( W e. LVec -> F e. DivRing ) $=
      ( clvec wcel clmod cdr islvec simprbi ) BDEBFEAGEABCHI $.
  $}

  $( A left vector space is a left module.  (Contributed by NM, 9-Dec-2013.) $)
  lveclmod $p |- ( W e. LVec -> W e. LMod ) $=
    ( clvec wcel clmod csca cfv cdr eqid islvec simplbi ) ABCADCAEFZGCKAKHIJ $.

  ${
    lsslvec.x $e |- X = ( W |`s U ) $.
    lsslvec.s $e |- S = ( LSubSp ` W ) $.
    $( A vector subspace is a vector space.  (Contributed by NM,
       14-Mar-2015.) $)
    lsslvec $p |- ( ( W e. LVec /\ U e. S ) -> X e. LVec ) $=
      ( clvec wcel wa clmod csca cfv lveclmod lsslmod sylan wceq resssca adantl
      cdr eqid lvecdrng adantr eqeltrrd islvec sylanbrc ) CGHZBAHZIZDJHZDKLZSHD
      GHUFCJHUGUICMABCDEFNOUHCKLZUJSUGUKUJPUFBUKCDAEUKTZQRUFUKSHUGUKCULUAUBUCUJ
      DUJTUDUE $.
  $}

  ${
    lvecmul0or.v $e |- V = ( Base ` W ) $.
    lvecmul0or.s $e |- .x. = ( .s ` W ) $.
    lvecmul0or.f $e |- F = ( Scalar ` W ) $.
    lvecmul0or.k $e |- K = ( Base ` F ) $.
    lvecmul0or.o $e |- O = ( 0g ` F ) $.
    lvecmul0or.z $e |- .0. = ( 0g ` W ) $.
    lvecmul0or.w $e |- ( ph -> W e. LVec ) $.
    lvecmul0or.a $e |- ( ph -> A e. K ) $.
    lvecmul0or.x $e |- ( ph -> X e. V ) $.
    $( If a scalar product is zero, one of its factors must be zero.
       ( ~ hvmul0or analog.)  (Contributed by NM, 2-Jul-2014.) $)
    lvecvs0or $p |- ( ph -> ( ( A .x. X ) = .0. <-> ( A = O \/ X = .0. ) ) ) $=
      ( wceq co wo wa wn wne df-ne cinvr cfv oveq2 ad2antlr cmulr cur cdr clvec
      wcel adantr lvecdrng simpr eqid drnginvrl syl3anc oveq1d clmod drnginvrcl
      syl lveclmod lmodvsass lmodvs1 syl2anc 3eqtr3d adantlr lmodvs0 ex syl5bir
      syl13anc orrd lmod0vs oveq1 eqeq1d syl5ibrcom jaod impbid ) ABICUAZJTZBFT
      ZIJTZUBZAWDWGAWDUCZWEWFWEUDBFUEZWHWFBFUFWHWIWFWHWIUCZBDUGUHZUHZWCCUAZWLJC
      UAZIJWDWMWNTAWIWCJWLCUIUJAWIWMITWDAWIUCZWLBDUKUHZUAZICUAZDULUHZICUAZWMIWO
      WQWSICWODUMUOZBEUOZWIWQWSTWOHUNUOZXAAXCWIQUPDHMUQVEZAXBWIRUPZAWIURZEDWPWS
      WKBFNOWPUSZWSUSZWKUSZUTVAVBWOHVCUOZWLEUOZXBIGUOZWRWMTAXJWIAXCXJQHVFVEZUPW
      OXAXBWIXKXDXEXFEDWKBFNOXIVDVAZXEAXLWISUPWLBCWPDEGHIKMLNXGVGVOAWTITZWIAXJX
      LXOXMSCWSDGHIKMLXHVHVIUPVJVKWJXJXKWNJTWHXJWIAXJWDXMUPUPAWIXKWDXNVKCDEHWLJ
      MLNPVLVIVJVMVNVPVMAWEWDWFAWDWEFICUAZJTZAXJXLXQXMSCDFGHIJKMLOPVQVIWEWCXPJB
      FICVRVSVTAWDWFBJCUAZJTZAXJXBXSXMRCDEHBJMLNPVLVIWFWCXRJIJBCUIVSVTWAWB $.

    $( A scalar product is nonzero iff both of its factors are nonzero.
       (Contributed by NM, 3-Jan-2015.) $)
    lvecvsn0 $p |- ( ph ->
      ( ( A .x. X ) =/= .0. <-> ( A =/= O /\ X =/= .0. ) ) ) $=
      ( wne co wceq wo wn wa lvecvs0or necon3abid neanior syl6bbr ) ABICUAZJTBF
      UBIJUBUCZUDBFTIJTUEAUKUJJABCDEFGHIJKLMNOPQRSUFUGBFIJUHUI $.
  $}

  ${
    lssvs0or.v $e |- V = ( Base ` W ) $.
    lssvs0or.t $e |- .x. = ( .s ` W ) $.
    lssvs0or.f $e |- F = ( Scalar ` W ) $.
    lssvs0or.k $e |- K = ( Base ` F ) $.
    lssvs0or.o $e |- .0. = ( 0g ` F ) $.
    lssvs0or.s $e |- S = ( LSubSp ` W ) $.
    lssvs0or.w $e |- ( ph -> W e. LVec ) $.
    lssvs0or.u $e |- ( ph -> U e. S ) $.
    lssvs0or.x $e |- ( ph -> X e. V ) $.
    lssvs0or.a $e |- ( ph -> A e. K ) $.
    $( If a scalar product belongs to a subspace, either the scalar component
       is zero or the vector component also belongs.  (Contributed by NM,
       5-Apr-2015.) $)
    lssvs0or $p |- ( ph -> ( ( A .x. X ) e. U <-> ( A = .0. \/ X e. U ) ) ) $=
      ( co wcel wceq wo wne cinvr cfv cmulr cur cdr clvec lvecdrng syl ad2antrr
      wa simpr eqid drnginvrl syl3anc oveq1d clmod lveclmod drnginvrcl syl13anc
      lmodvsass lmodvs1 syl2anc 3eqtr3rd lssvscl syl22anc eqeltrd necon1bd orrd
      simplr ex orcomd oveq1 adantl c0g lmod0vs lss0cl adantr jaodan impbida )
      ABJDUBZEUCZBKUDZJEUCZUEAWGUPZWIWHWJWIWHWJWIBKWJBKUFZWIWJWKUPZJBFUGUHZUHZW
      FDUBZEWLWNBFUIUHZUBZJDUBZFUJUHZJDUBZWOJWLWQWSJDWLFUKUCZBGUCZWKWQWSUDAXAWG
      WKAIULUCZXARFINUMUNUOZAXBWGWKUAUOZWJWKUQZGFWPWSWMBKOPWPURZWSURZWMURZUSUTV
      AWLIVBUCZWNGUCZXBJHUCZWRWOUDAXJWGWKAXCXJRIVCUNZUOZWLXAXBWKXKXDXEXFGFWMBKO
      PXIVDUTZXEAXLWGWKTUOZWNBDWPFGHIJLNMOXGVFVEWLXJXLWTJUDXNXPDWSFHIJLNMXHVGVH
      VIWLXJECUCZXKWGWOEUCXNAXQWGWKSUOXOAWGWKVOGCDEFIWNWFNMOQVJVKVLVPVMVNVQAWHW
      GWIAWHUPWFKJDUBZEWHWFXRUDABKJDVRVSAXREUCWHAXRIVTUHZEAXJXLXRXSUDXMTDFKHIJX
      SLNMPXSURZWAVHAXJXQXSEUCXMSCEIXSXTQWBVHVLWCVLAWIUPXJXQXBWIWGAXJWIXMWCAXQW
      ISWCAXBWIUAWCAWIUQGCDEFIBJNMOQVJVKWDWE $.
  $}

  ${
    lvecmulcan.v $e |- V = ( Base ` W ) $.
    lvecmulcan.s $e |- .x. = ( .s ` W ) $.
    lvecmulcan.f $e |- F = ( Scalar ` W ) $.
    lvecmulcan.k $e |- K = ( Base ` F ) $.
    lvecmulcan.o $e |- .0. = ( 0g ` F ) $.
    lvecmulcan.w $e |- ( ph -> W e. LVec ) $.
    lvecmulcan.a $e |- ( ph -> A e. K ) $.
    lvecmulcan.x $e |- ( ph -> X e. V ) $.
    lvecmulcan.y $e |- ( ph -> Y e. V ) $.
    lvecmulcan.n $e |- ( ph -> A =/= .0. ) $.
    $( Cancellation law for scalar multiplication.  ( ~ hvmulcan analog.)
       (Contributed by NM, 2-Jul-2014.) $)
    lvecvscan $p |- ( ph -> ( ( A .x. X ) = ( A .x. Y ) <-> X = Y ) ) $=
      ( csg cfv co c0g wceq wo wne wb wn df-ne biorf sylbi syl clmod wcel clvec
      lveclmod lmodsubeq0 syl3anc lmodsubdi eqeq1d lmodvsubcl lvecvs0or 3bitr3d
      eqid lmodvscl 3bitr3rd ) AHIGUAUBZUCZGUDUBZUEZBJUEZVKUFZHIUEZBHCUCZBICUCZ
      UEZABJUGZVKVMUHZTVRVLUIVSBJUJVLVKUKULUMAGUNUOZHFUOZIFUOZVKVNUHAGUPUOVTPGU
      QUMZRSHIVHFGVJKVJVEZVHVEZURUSABVICUCZVJUEVOVPVHUCZVJUEZVMVQAWFWGVJABCDEVH
      FGHIKLMNWEWCQRSUTVAABCDEJFGVIVJKLMNOWDPQAVTWAWBVIFUOWCRSVHFGHIKWEVBUSVCAV
      TVOFUOZVPFUOZWHVQUHWCAVTBEUOZWAWIWCQRBCDEFGHKMLNVFUSAVTWKWBWJWCQSBCDEFGIK
      MLNVFUSVOVPVHFGVJKWDWEURUSVDVG $.
  $}

  ${
    lvecmulcan2.v $e |- V = ( Base ` W ) $.
    lvecmulcan2.s $e |- .x. = ( .s ` W ) $.
    lvecmulcan2.f $e |- F = ( Scalar ` W ) $.
    lvecmulcan2.k $e |- K = ( Base ` F ) $.
    lvecmulcan2.o $e |- .0. = ( 0g ` W ) $.
    lvecmulcan2.w $e |- ( ph -> W e. LVec ) $.
    lvecmulcan2.a $e |- ( ph -> A e. K ) $.
    lvecmulcan2.b $e |- ( ph -> B e. K ) $.
    lvecmulcan2.x $e |- ( ph -> X e. V ) $.
    lvecmulcan2.n $e |- ( ph -> X =/= .0. ) $.
    $( Cancellation law for scalar multiplication.  ( ~ hvmulcan2 analog.)
       (Contributed by NM, 2-Jul-2014.) $)
    lvecvscan2 $p |- ( ph -> ( ( A .x. X ) = ( B .x. X ) <-> A = B ) ) $=
      ( co csg cfv wceq c0g wo wn neneqd biorf orcom syl6bb syl eqid cgrp clmod
      wcel clvec lveclmod lmodfgrp grpsubcl syl3anc lvecvs0or lmodsubdir eqeq1d
      wb 3bitr2rd lmodvscl lmodsubeq0 grpsubeq0 3bitr3d ) ABIDUAZCIDUAZHUBUCZUA
      ZJUDZBCEUBUCZUAZEUEUCZUDZVKVLUDZBCUDZAVSVSIJUDZUFZVQIDUAZJUDVOAWBUGZVSWCV
      EAIJTUHWEVSWBVSUFWCWBVSUIWBVSUJUKULAVQDEFVRGHIJKLMNVRUMZOPAEUNUPZBFUPZCFU
      PZVQFUPAHUOUPZWGAHUQUPWJPHURULZEHMUSULZQRFEVPBCNVPUMZUTVASVBAWDVNJABCVPDE
      FVMGHIKLMNVMUMZWMWKQRSVCVDVFAWJVKGUPZVLGUPZVOVTVEWKAWJWHIGUPZWOWKQSBDEFGH
      IKMLNVGVAAWJWIWQWPWKRSCDEFGHIKMLNVGVAVKVLVMGHJKOWNVHVAAWGWHWIVSWAVEWLQRFE
      VPBCVRNWFWMVIVAVJ $.
  $}

  ${
    lvecinv.v $e |- V = ( Base ` W ) $.
    lvecinv.t $e |- .x. = ( .s ` W ) $.
    lvecinv.f $e |- F = ( Scalar ` W ) $.
    lvecinv.k $e |- K = ( Base ` F ) $.
    lvecinv.o $e |- .0. = ( 0g ` F ) $.
    lvecinv.i $e |- I = ( invr ` F ) $.
    lvecinv.w $e |- ( ph -> W e. LVec ) $.
    lvecinv.a $e |- ( ph -> A e. ( K \ { .0. } ) ) $.
    lvecinv.x $e |- ( ph -> X e. V ) $.
    lvecinv.y $e |- ( ph -> Y e. V ) $.
    $( Invert coefficient of scalar product.  (Contributed by NM,
       11-Apr-2015.) $)
    lvecinv $p |- ( ph -> ( X = ( A .x. Y ) <-> Y = ( ( I ` A ) .x. X ) ) ) $=
      ( co wceq cfv oveq2 cmulr cur cdr wcel wne clvec lvecdrng syl csn eldifad
      cdif eldifsni eqid drnginvrl syl3anc oveq1d lveclmod drnginvrcl lmodvsass
      clmod syl13anc lmodvs1 syl2anc 3eqtr3d sylan9eqr drnginvrr 3eqtr3rd eqcom
      sylan9eq impbida syl6bb ) AIBJCUBZUCZBEUDZICUBZJUCZJVTUCAVRWAVRAVTVSVQCUB
      ZJIVQVSCUEAVSBDUFUDZUBZJCUBZDUGUDZJCUBZWBJAWDWFJCADUHUIZBFUIZBKUJZWDWFUCA
      HUKUIZWHRDHNULUMZABFKUNZSUOZABFWMUPUIWJSBFKUQUMZFDWCWFEBKOPWCURZWFURZQUSU
      TVAAHVEUIZVSFUIZWIJGUIZWEWBUCAWKWRRHVBUMZAWHWIWJWSWLWNWOFDEBKOPQVCUTZWNUA
      VSBCWCDFGHJLNMOWPVDVFAWRWTWGJUCXAUACWFDGHJLNMWQVGVHVIVJAWAIBVTCUBZVQABVSW
      CUBZICUBZWFICUBZXCIAXDWFICAWHWIWJXDWFUCWLWNWOFDWCWFEBKOPWPWQQVKUTVAAWRWIW
      SIGUIZXEXCUCXAWNXBTBVSCWCDFGHILNMOWPVDVFAWRXGXFIUCXATCWFDGHILNMWQVGVHVLVT
      JBCUEVNVOVTJVMVP $.
  $}

  ${
    lspsnvs.v $e |- V = ( Base ` W ) $.
    lspsnvs.f $e |- F = ( Scalar ` W ) $.
    lspsnvs.t $e |- .x. = ( .s ` W ) $.
    lspsnvs.k $e |- K = ( Base ` F ) $.
    lspsnvs.o $e |- .0. = ( 0g ` F ) $.
    lspsnvs.n $e |- N = ( LSpan ` W ) $.
    $( A non-zero scalar product does not change the span of a singleton.
       ( ~ spansncol analog.)  (Contributed by NM, 23-Apr-2014.) $)
    lspsnvs $p |- ( ( W e. LVec /\ ( R e. K /\ R =/= .0. ) /\ X e. V )
        -> ( N ` { ( R .x. X ) } ) = ( N ` { X } ) ) $=
      ( wcel co csn cfv syl3anc clvec wne wa w3a clmod lveclmod 3ad2ant1 simp2l
      wss simp3 lspsnvsi cinvr cmulr wceq lvecdrng simp2r eqid drnginvrl oveq1d
      cur drnginvrcl lmodvsass syl13anc lmodvs1 syl2anc 3eqtr3d fveq2d lmodvscl
      cdr sneqd eqsstr3d eqssd ) GUAPZADPZAIUBZUCZHFPZUDZAHBQZRESZHRZESZVRGUEPZ
      VNVQVTWBUIVMVPWCVQGUFUGZVMVNVOVQUHZVMVPVQUJZABCDEFGHKMJLOUKTVRWBACULSZSZV
      SBQZRZESZVTVRWJWAEVRWIHVRWHACUMSZQZHBQZCUTSZHBQZWIHVRWMWOHBVRCVIPZVNVOWMW
      OUNVMVPWQVQCGKUOUGZWEVMVNVOVQUPZDCWLWOWGAIMNWLUQZWOUQZWGUQZURTUSVRWCWHDPZ
      VNVQWNWIUNWDVRWQVNVOXCWRWEWSDCWGAIMNXBVATZWEWFWHABWLCDFGHJKLMWTVBVCVRWCVQ
      WPHUNWDWFBWOCFGHJKLXAVDVEVFVJVGVRWCXCVSFPZWKVTUIWDXDVRWCVNVQXEWDWEWFABCDF
      GHJKLMVHTWHBCDEFGVSKMJLOUKTVKVL $.
  $}

  ${
    $d k N $.  $d k V $.  $d k W $.  $d k X $.  $d k Y $.  $d k ph $.
    lspsneleq.v $e |- V = ( Base ` W ) $.
    lspsneleq.o $e |- .0. = ( 0g ` W ) $.
    lspsneleq.n $e |- N = ( LSpan ` W ) $.
    lspsneleq.w $e |- ( ph -> W e. LVec ) $.
    lspsneleq.x $e |- ( ph -> X e. V ) $.
    lspsneleq.y $e |- ( ph -> Y e. ( N ` { X } ) ) $.
    lspsneleq.z $e |- ( ph -> Y =/= .0. ) $.
    $( Membership relation that implies equality of spans.  ( ~ spansneleq
       analog.)  (Contributed by NM, 4-Jul-2014.) $)
    lspsneleq $p |- ( ph -> ( N ` { Y } ) = ( N ` { X } ) ) $=
      ( vk csn cfv wcel wceq eqid cv cvsca co csca wrex clmod wb clvec lveclmod
      cbs syl lspsnel syl2anc simpr sneqd fveq2d c0g wne ad2antrr simplr oveq1d
      wa lmod0vs ad3antrrr 3eqtrd necon3d mpd lspsnvs syl121anc eqtrd rexlimdva
      ex sylbid ) AFEPBQZRZFPZBQZVNSZMAVOFOUAZEDUBQZUCZSZODUDQZUJQZUEZVRADUFRZE
      CRZVOWEUGADUHRZWFKDUIUKZLVTFOWCWDBCDEWCTZWDTZHVTTZJULUMAWBVROWDAVSWDRZVBZ
      WBVRWNWBVBZVQWAPZBQZVNWOVPWPBWOFWAWNWBUNUOUPWOWHWMVSWCUQQZURZWGWQVNSAWHWM
      WBKUSAWMWBUTWOFGURZWSAWTWMWBNUSWOVSWRFGWOVSWRSZFGSWOXAVBZFWAWREVTUCZGWNWB
      XAUTXBVSWREVTWOXAUNVAAXCGSZWMWBXAAWFWGXDWILVTWCWRCDEGHWJWLWRTZIVCUMVDVEVL
      VFVGAWGWMWBLUSVSVTWCWDBCDEWRHWJWLWKXEJVHVIVJVLVKVMVG $.
  $}

  ${
    lspsncmp.v $e |- V = ( Base ` W ) $.
    lspsncmp.o $e |- .0. = ( 0g ` W ) $.
    lspsncmp.n $e |- N = ( LSpan ` W ) $.
    lspsncmp.w $e |- ( ph -> W e. LVec ) $.
    lspsncmp.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lspsncmp.y $e |- ( ph -> Y e. V ) $.
    $( Comparable spans of nonzero singletons are equal.  (Contributed by NM,
       27-Apr-2015.) $)
    lspsncmp $p |- ( ph
   -> ( ( N ` { X } ) C_ ( N ` { Y } ) <-> ( N ` { X } ) = ( N ` { Y } ) ) ) $=
      ( csn cfv wss wceq wcel adantr syl clvec clss eqid clmod lveclmod lspsncl
      wa syl2anc eldifad lspsnel5 biimpar wne cdif eldifsni lspsneleq ex eqimss
      impbid1 ) AENBOZFNBOZPZUSUTQZAVAVBAVAUGBCDFEGHIJADUARZVAKSAFCRZVAMSAEUTRV
      AADUBOZUTBCDEHVEUCZJAVCDUDRZKDUETZAVGVDUTVERVHMVEBCDFHVFJUFUHAECGNZLUIUJU
      KAEGULZVAAECVIUMRVJLECGUNTSUOUPUSUTUQUR $.
  $}

  ${
    lspsnne1.v $e |- V = ( Base ` W ) $.
    lspsnne1.o $e |- .0. = ( 0g ` W ) $.
    lspsnne1.n $e |- N = ( LSpan ` W ) $.
    lspsnne1.w $e |- ( ph -> W e. LVec ) $.
    lspsnne1.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lspsnne1.y $e |- ( ph -> Y e. V ) $.
    lspsnne1.e $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    $( Two ways to express that vectors have different spans.  (Contributed by
       NM, 28-May-2015.) $)
    lspsnne1 $p |- ( ph -> -. X e. ( N ` { Y } ) ) $=
      ( csn cfv wcel wn wne wss clss clvec lveclmod syl lspsncl syl2anc eldifad
      eqid clmod lspsnel5 notbid lspsncmp necon3bbid bitrd mpbird ) AEFOBPZQZRZ
      EOBPZUPSZNAURUSUPTZRUTAUQVAADUAPZUPBCDEHVBUHZJADUBQDUIQZKDUCUDZAVDFCQUPVB
      QVEMVBBCDFHVCJUEUFAECGOLUGUJUKAVAUSUPABCDEFGHIJKLMULUMUNUO $.
  $}

  ${
    lspsnne2.v $e |- V = ( Base ` W ) $.
    lspsnne2.n $e |- N = ( LSpan ` W ) $.
    lspsnne2.w $e |- ( ph -> W e. LMod ) $.
    lspsnne2.x $e |- ( ph -> X e. V ) $.
    lspsnne2.y $e |- ( ph -> Y e. V ) $.
    lspsnne2.e $e |- ( ph -> -. X e. ( N ` { Y } ) ) $.
    $( Two ways to express that vectors have different spans.  (Contributed by
       NM, 20-May-2015.) $)
    lspsnne2 $p |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $=
      ( csn cfv wcel wn wne wceq wss eqimss clss clmod lspsncl syl2anc lspsnel5
      eqid syl5ibr necon3bd mpd ) AEFMBNZOZPEMBNZUJQLAUKULUJULUJRUKAULUJSULUJTA
      DUANZUJBCDEGUMUFZHIADUBOFCOUJUMOIKUMBCDFGUNHUCUDJUEUGUHUI $.
  $}

  ${
    lspsnnecom.v $e |- V = ( Base ` W ) $.
    lspsnnecom.o $e |- .0. = ( 0g ` W ) $.
    lspsnnecom.n $e |- N = ( LSpan ` W ) $.
    lspsnnecom.w $e |- ( ph -> W e. LVec ) $.
    lspsnnecom.x $e |- ( ph -> X e. V ) $.
    lspsnnecom.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    lspsnnecom.e $e |- ( ph -> -. X e. ( N ` { Y } ) ) $.
    $( Swap two vectors with different spans.  (Contributed by NM,
       20-May-2015.) $)
    lspsnnecom $p |- ( ph -> -. Y e. ( N ` { X } ) ) $=
      ( csn cfv clvec wcel clmod lveclmod syl eldifad lspsnne2 necomd lspsnne1
      ) ABCDFEGHIJKMLAEOBPFOBPABCDEFHJADQRDSRKDTUALAFCGOMUBNUCUDUE $.
  $}

  ${
    lspabs2.v $e |- V = ( Base ` W ) $.
    lspabs2.p $e |- .+ = ( +g ` W ) $.
    lspabs2.o $e |- .0. = ( 0g ` W ) $.
    lspabs2.n $e |- N = ( LSpan ` W ) $.
    lspabs2.w $e |- ( ph -> W e. LVec ) $.
    lspabs2.x $e |- ( ph -> X e. V ) $.
    ${
      lspabs2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      lspabs2.e $e |- ( ph -> ( N ` { X } ) = ( N ` { ( X .+ Y ) } ) ) $.
      $( Absorption law for span of vector sum.  (Contributed by NM,
         30-Apr-2015.) $)
      lspabs2 $p |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $=
        ( csn cfv co wcel wss wceq csubg clmod clvec lveclmod lspsnsubg syl2anc
        clsm syl eldifad eqid lsmub2 oveq2d cpr lspprabs lmodvacl syl3anc lsmpr
        lsmidm 3eqtr3d 3eqtr3rd sseqtrd lspsncmp mpbid eqcomd ) AGQCRZFQCRZAVGV
        HUAVGVHUBAVGVHVGEUIRZSZVHAVHEUCRZTZVGVKTZVGVJUAAEUDTZFDTZVLAEUETVNMEUFU
        JZNCDEFILUGUHZAVNGDTZVMVPAGDHQOUKZCDEGILUGUHVIVHVGEVIULZUMUHAVHVHVISZVH
        FGBSZQCRZVISZVHVJAVHWCVHVIPUNAVLWAVHUBVQVIVHEVTUTUJAFWBUOCRFGUOCRWDVJAB
        CDEFGIJLVPNVSUPAVICDEFWBILVTVPNAVNVOVRWBDTVPNVSBDEFGIJUQURUSAVICDEFGILV
        TVPNVSUSVAVBVCACDEGFHIKLMONVDVEVF $.
    $}

    lspabs3.y $e |- ( ph -> Y e. V ) $.
    lspabs3.xy $e |- ( ph -> ( X .+ Y ) =/= .0. ) $.
    lspabs3.e $e |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $.
    $( Absorption law for span of vector sum.  (Contributed by NM,
       30-Apr-2015.) $)
    lspabs3 $p |- ( ph -> ( N ` { X } ) = ( N ` { ( X .+ Y ) } ) ) $=
      ( cfv wcel syl2anc co csn wss wceq clsm clss clvec clmod lveclmod lspsncl
      syl lsmcl syl3anc lspsnsubg eqeltrrd lspsnid lsmelvali syl22anc lspsnel5a
      csubg oveq2d lsmidm eqtr3d sseqtrd wne lmodvacl eldifsn sylanbrc lspsncmp
      eqid cdif mpbid eqcomd ) AFGBUAZUBCRZFUBCRZAVOVPUCVOVPUDAVOVPGUBCRZEUERZU
      AZVPAEUFRZVSCEVNVTVJZLAEUGSEUHSZMEUIUKZAWBVPVTSZVQVTSZVSVTSWCAWBFDSZWDWCN
      VTCDEFIWALUJTAWBGDSZWEWCOVTCDEGIWALUJTVRVTVPVQEWAVRVJZULUMAVPEUTRZSZVQWIS
      FVPSZGVQSZVNVSSAWBWFWJWCNCDEFILUNTZAVPVQWIQWMUOAWBWFWKWCNCDEFILUPTAWBWGWL
      WCOCDEGILUPTBVRVPVQEFGJWHUQURUSAVPVPVRUAZVSVPAVPVQVPVRQVAAWJWNVPUDWMVRVPE
      WHVBUKVCVDACDEVNFHIKLMAVNDSZVNHVEVNDHUBVKSAWBWFWGWOWCNOBDEFGIJVFUMPVNDHVG
      VHNVIVLVM $.
  $}

  ${
    $d j k K $.  $d j N $.  $d j k .0. $.  $d j S $.  $d j k .x. $.  $d j V $.
    $d j W $.  $d j k X $.  $d j k Y $.  $d j ph $.
    lspsneq.v $e |- V = ( Base ` W ) $.
    lspsneq.s $e |- S = ( Scalar ` W ) $.
    lspsneq.k $e |- K = ( Base ` S ) $.
    lspsneq.o $e |- .0. = ( 0g ` S ) $.
    lspsneq.t $e |- .x. = ( .s ` W ) $.
    lspsneq.n $e |- N = ( LSpan ` W ) $.
    lspsneq.w $e |- ( ph -> W e. LVec ) $.
    lspsneq.x $e |- ( ph -> X e. V ) $.
    lspsneq.y $e |- ( ph -> Y e. V ) $.
    $( Equal spans of singletons must have proportional vectors.  See
       ~ lspsnss2 for comparable span version.  TODO: can proof be shortened?
       (Contributed by NM, 21-Mar-2015.) $)
    lspsneq $p |- ( ph -> ( ( N ` { X } ) = ( N ` { Y } ) <->
      E. k e. ( K \ { .0. } ) X = ( k .x. Y ) ) ) $=
      ( vj csn cfv wceq cv co cdif wrex wa c0g cur wne clmod crg clvec lveclmod
      wcel syl lmodrng eqid rngidcl 3syl cdr lvecdrng drngunz sylanbrc ad2antrr
      eldifsn lmod0vcl lmodvs1 syl2anc adantl adantr lspsneq0b biimpar 3eqtr4rd
      oveq2 simpr eqeq2d rspcev wss eqimss clss lspsncl lspsnel5 mpbird lspsnel
      oveq1 wb mpbid simprl biimpd necon3d eqnetrrd lvecvsn0 simpld ex reximdv2
      imp jca mpd pm2.61dane wi eldifi eldifsni lspsnvs syl121anc fveq2d eqeq1d
      sneq biimprcd syl6 rexlimdv impbid weq cbvrexv syl6bb ) AIUBZFUCZJUBFUCZU
      DZIUAUEZJCUFZUDZUAEKUBZUGZUHZIDUEZJCUFZUDZDYFUHAYAYGAYAYGAYAUIZYGJHUJUCZY
      KJYLUDZUIZBUKUCZYFUQZIYOJCUFZUDZYGAYPYAYMAYOEUQZYOKULZYPAHUMUQZBUNUQYSAHU
      OUQZUUARHUPZURZBHMUSEBYONYOUTZVAVBAUUBBVCUQYTRBHMVDBYOKOUUEVEVBYOEKVHVFVG
      YNYOYLCUFZYLYQIAUUFYLUDZYAYMAUUAYLGUQZUUGUUDAUUBUUAUUHRUUCGHYLLYLUTZVIVBC
      YOBGHYLLMPUUEVJVKVGYMYQUUFUDYKJYLYOCVQVLYKIYLUDZYMYKFGHIJYLLUUIQAUUAYAUUD
      VMZAIGUQYASVMZAJGUQZYATVMZAYAVRVNZVOVPYDYRUAYOYFYBYOUDYCYQIYBYOJCWHVSVTVK
      YKJYLULZUIZYDUAEUHZYGYKUURUUPYKIXTUQZUURYKUUSXSXTWAZYAUUTAXSXTWBVLYKHWCUC
      ZXTFGHILUVAUTZQUUKAXTUVAUQZYAAUUAUUMUVCUUDTUVAFGHJLUVBQWDVKVMUULWEWFYKUUA
      UUMUUSUURWIUUKUUNCIUABEFGHJMNLPQWGVKWJVMUUQYDYDUAEYFUUQYBEUQZYDUIZYBYFUQZ
      YDUIUUQUVEUIZUVFYDUVGUVDYBKULZUVFUUQUVDYDWKZUVGUVHUUPUVGYCYLULUVHUUPUIUVG
      IYCYLUVEYDUUQUVDYDVRVLZUUQIYLULZUVEYKUUPUVKYKIYLJYLYKUUJYMUUOWLWMWSVMWNUV
      GYBCBEKGHJYLLPMNOUUIYKUUBUUPUVEAUUBYARVMVGUVIYKUUMUUPUVEUUNVGWOWJWPYBEKVH
      VFUVJWTWQWRXAXBWQAYDYAUAYFAUVFYCUBZFUCZXTUDZYDYAXCAUVFUVNAUVFUIUUBUVDUVHU
      UMUVNAUUBUVFRVMUVFUVDAYBEYEXDVLUVFUVHAYBEKXEVLAUUMUVFTVMYBCBEFGHJKLMPNOQX
      FXGWQYDYAUVNYDXSUVMXTYDXRUVLFIYCXJXHXIXKXLXMXNYDYJUADYFUADXOYCYIIYBYHJCWH
      VSXPXQ $.
  $}

  ${
    $d i j k K $.  $d i j N $.  $d i j k O $.  $d i j k .x. $.  $d i j k X $.
    $d i j k Y $.  $d i j ph $.
    lspsneu.v $e |- V = ( Base ` W ) $.
    lspsneu.s $e |- S = ( Scalar ` W ) $.
    lspsneu.k $e |- K = ( Base ` S ) $.
    lspsneu.o $e |- O = ( 0g ` S ) $.
    lspsneu.t $e |- .x. = ( .s ` W ) $.
    lspsneu.z $e |- .0. = ( 0g ` W ) $.
    lspsneu.n $e |- N = ( LSpan ` W ) $.
    lspsneu.w $e |- ( ph -> W e. LVec ) $.
    lspsneu.x $e |- ( ph -> X e. V ) $.
    lspsneu.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    $( Nonzero vectors with equal singleton spans have a unique proportionality
       constant.  (Contributed by NM, 31-May-2015.) $)
    lspsneu $p |- ( ph -> ( ( N ` { X } ) = ( N ` { Y } ) <->
      E! k e. ( K \ { O } ) X = ( k .x. Y ) ) ) $=
      ( vj vi csn cfv wceq cv co cdif wreu wrex weq wral eldifad lspsneq biimpd
      wa wi wcel w3a eqtr2 3ad2ant3 clvec simp1l syl simp2l simp2r wne eldifsni
      3syl lvecvscan2 mpbid 3exp ex ralrimdvv jcad oveq1 eqeq2d syl6ibr syl5ibr
      reu4 reurex impbid cbvreuv syl6bb ) AJUEFUFKUEFUFUGZJUCUHZKCUIZUGZUCEGUEZ
      UJZUKZJDUHZKCUIZUGZDWLUKAWGWMAWGWJUCWLULZWJJUDUHZKCUIZUGZURZUCUDUMZUSZUDW
      LUNUCWLUNZURWMAWGWQXDAWGWQABCUCEFHIJKGMNOPQSTUAAKHLUEZUBUOZUPZUQAWGXCUCUD
      WLWLAWGWHWLUTZWRWLUTZURZXCUSAWGURZXJXAXBXKXJXAVAZWIWSUGZXBXAXKXMXJJWIWSVB
      VCXLWHWRCBEHIKLMQNORXLAIVDUTAWGXJXAVEZTVFXLWHEWKXKXHXIXAVGUOXLWREWKXKXHXI
      XAVHUOXLAKHUTXNXFVFXLAKHXEUJUTKLVIXNUBKHLVJVKVLVMVNVOVPVQWJWTUCUDWLXBWIWS
      JWHWRKCVRVSWBVTWMWGAWQWJUCWLWCXGWAWDWJWPUCDWLUCDUMWIWOJWHWNKCVRVSWEWF $.
  $}

  ${
    lspsnel4.v $e |- V = ( Base ` W ) $.
    lspsnel4.o $e |- .0. = ( 0g ` W ) $.
    lspsnel4.s $e |- S = ( LSubSp ` W ) $.
    lspsnel4.n $e |- N = ( LSpan ` W ) $.
    lspsnel4.w $e |- ( ph -> W e. LVec ) $.
    lspsnel4.u $e |- ( ph -> U e. S ) $.
    lspsnel4.x $e |- ( ph -> X e. V ) $.
    lspsnel4.y $e |- ( ph -> Y e. ( N ` { X } ) ) $.
    lspsnel4.z $e |- ( ph -> Y =/= .0. ) $.
    $( A member of the span of the singleton of a vector is a member of a
       subspace containing the vector.  ( ~ elspansn4 analog.)  (Contributed by
       NM, 4-Jul-2014.) $)
    lspsnel4 $p |- ( ph -> ( X e. U <-> Y e. U ) ) $=
      ( wcel adantr clmod clvec lveclmod syl simpr csn lspsnel3 lspsnid syl2anc
      wa cfv lspsneleq eleqtrrd impbida ) AGCSZHCSZAUOUJBCDFGHLMAFUASZUOAFUBSUQ
      NFUCUDZTACBSZUOOTAUOUEAHGUFDUKZSUOQTUGAUPUJBCDFHGLMAUQUPURTAUSUPOTAUPUEAG
      HUFDUKZSUPAGUTVAAUQGESGUTSURPDEFGJMUHUIADEFGHIJKMNPQRULUMTUGUN $.
  $}

  ${
    $d k v N $.  $d k v .0. $.  $d k v U $.  $d k V $.  $d k W $.  $d k v X $.
    $d k v ph $.
    lspdisj.v $e |- V = ( Base ` W ) $.
    lspdisj.o $e |- .0. = ( 0g ` W ) $.
    lspdisj.n $e |- N = ( LSpan ` W ) $.
    lspdisj.s $e |- S = ( LSubSp ` W ) $.
    lspdisj.w $e |- ( ph -> W e. LVec ) $.
    lspdisj.u $e |- ( ph -> U e. S ) $.
    lspdisj.x $e |- ( ph -> X e. V ) $.
    lspdisj.e $e |- ( ph -> -. X e. U ) $.
    $( The span of a vector not in a subspace is disjoint with the subspace.
       (Contributed by NM, 6-Apr-2015.) $)
    lspdisj $p |- ( ph -> ( ( N ` { X } ) i^i U ) = { .0. } ) $=
      ( cfv wcel wa syl2anc vv vk csn cin cv wceq cvsca co csca cbs clmod clvec
      wrex wb lveclmod syl eqid lspsnel biimpa adantrr wi simprr wn ad2antrr wo
      c0g simplr eqeltrrd simprl lssvs0or mpbid orcomd ord oveq1d lmod0vs exp32
      mpd 3eqtrd adantrl rexlimdv ex elin elsn 3imtr4g ssrdv wss lspsncl lss0ss
      ssind eqssd ) AGUCDQZCUDZHUCZAUAWLWMAUAUEZWKRZWNCRZSZWNHUFZWNWLRWNWMRAWQW
      RAWQSZWNUBUEZGFUGQZUHZUFZUBFUIQZUJQZUMZWRAWOXFWPAWOXFAFUKRZGERZWOXFUNAFUL
      RZXGMFUOUPZOXAWNUBXDXEDEFGXDUQZXEUQZIXAUQZKURTUSUTWSXCWRUBXEAWPWTXERZXCWR
      VAVAWOAWPSZXNXCWRXOXNXCSZSZWNXBXDVFQZGXAUHZHXOXNXCVBZXQWTXRGXAXQGCRZVCZWT
      XRUFZAYBWPXPPVDXQYAYCXQYCYAXQXBCRYCYAVEXQWNXBCXTAWPXPVGVHXQWTBXACXDXEEFGX
      RIXMXKXLXRUQZLAXIWPXPMVDACBRZWPXPNVDAXHWPXPOVDZXOXNXCVIVJVKVLVMVQVNXQXGXH
      XSHUFAXGWPXPXJVDYFXAXDXREFGHIXKXMYDJVOTVRVPVSVTVQWAWNWKCWBUAHWCWDWEAWMWKC
      AXGWKBRZWMWKWFXJAXGXHYGXJOBDEFGILKWGTBFWKHJLWHTAXGYEWMCWFXJNBFCHJLWHTWIWJ
      $.
  $}

  ${
    lspdisjb.v $e |- V = ( Base ` W ) $.
    lspdisjb.o $e |- .0. = ( 0g ` W ) $.
    lspdisjb.n $e |- N = ( LSpan ` W ) $.
    lspdisjb.s $e |- S = ( LSubSp ` W ) $.
    lspdisjb.w $e |- ( ph -> W e. LVec ) $.
    lspdisjb.u $e |- ( ph -> U e. S ) $.
    lspdisjb.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( A nonzero vector is not in a subspace iff its span is disjoint with the
       subspace.  (Contributed by NM, 23-Apr-2015.) $)
    lspdisjb $p |- ( ph
          -> ( -. X e. U <-> ( ( N ` { X } ) i^i U ) = { .0. } ) ) $=
      ( wcel csn wceq wa adantr wn cfv cin clvec eldifad simpr lspdisj wne cdif
      eldifsni syl wi clmod lveclmod lspsnid syl2anc eleq2 elsni syl6bi syl5bir
      elin exp3a mpan9 necon3ad mpd impbida ) AGCPZUAZGQDUBZCUCZHQZRZAVHSBCDEFG
      HIJKLAFUDPZVHMTACBPVHNTAGEPZVHAGEVKOUEZTAVHUFUGAVLSZGHUHZVHAVQVLAGEVKUIPV
      QOGEHUJUKTVPVGGHAGVIPZVLVGGHRZULAFUMPZVNVRAVMVTMFUNUKVODEFGIKUOUPVLVRVGVS
      VRVGSGVJPZVLVSGVICVAVLWAGVKPVSVJVKGUQGHURUSUTVBVCVDVEVF $.
  $}

  ${
    lspdisj2.v $e |- V = ( Base ` W ) $.
    lspdisj2.o $e |- .0. = ( 0g ` W ) $.
    lspdisj2.n $e |- N = ( LSpan ` W ) $.
    lspdisj2.w $e |- ( ph -> W e. LVec ) $.
    lspdisj2.x $e |- ( ph -> X e. V ) $.
    lspdisj2.y $e |- ( ph -> Y e. V ) $.
    lspdisj2.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    $( Unequal spans are disjoint (share only the zero vector).  (Contributed
       by NM, 22-Mar-2015.) $)
    lspdisj2 $p |- ( ph -> ( ( N ` { X } ) i^i ( N ` { Y } ) ) = { .0. } ) $=
      ( csn cfv wceq wa wcel adantr cin sneq fveq2d clmod clvec lveclmod lspsn0
      syl sylan9eqr ineq1d wss clss eqid lspsncl syl2anc lss0ss df-ss sylib wne
      eqtrd wn simpr simplr lspsneleq ex necon3ad mpd lspdisj pm2.61dane ) AEOZ
      BPZFOBPZUAZGOZQEGAEGQZRZVMVNVLUAZVNVPVKVNVLVOAVKVNBPZVNVOVJVNBEGUBUCADUDS
      ZVRVNQADUESZVSKDUFUHZBDGIJUGUHUIUJAVQVNQZVOAVNVLUKZWBAVSVLDULPZSZWCWAAVSF
      CSZWEWAMWDBCDFHWDUMZJUNUOZWDDVLGIWGUPUOVNVLUQURTUTAEGUSZRZWDVLBCDEGHIJWGA
      VTWIKTZAWEWIWHTAECSWILTWJVKVLUSZEVLSZVAAWLWINTWJWMVKVLWJWMVKVLQWJWMRBCDFE
      GHIJWJVTWMWKTWJWFWMAWFWIMTTWJWMVBAWIWMVCVDVEVFVGVHVI $.
  $}

  ${
    $d k l z N $.  $d k l z .0. $.  $d k l z .+ $.  $d k l V $.  $d k l z W $.
    $d k l z X $.  $d k l z Y $.  $d k l z Z $.  $d k l ph $.
    lspfixed.v $e |- V = ( Base ` W ) $.
    lspfixed.p $e |- .+ = ( +g ` W ) $.
    lspfixed.o $e |- .0. = ( 0g ` W ) $.
    lspfixed.n $e |- N = ( LSpan ` W ) $.
    lspfixed.w $e |- ( ph -> W e. LVec ) $.
    lspfixed.x $e |- ( ph -> X e. V ) $.
    lspfixed.y $e |- ( ph -> Y e. V ) $.
    lspfixed.z $e |- ( ph -> Z e. V ) $.
    lspfixed.e $e |- ( ph -> -. X e. ( N ` { Y } ) ) $.
    lspfixed.f $e |- ( ph -> -. X e. ( N ` { Z } ) ) $.
    lspfixed.g $e |- ( ph -> X e. ( N ` { Y , Z } ) ) $.
    $( Show membership in the span of the sum of two vectors, one of which
       ( ` Y ` ) is fixed in advance.  (Contributed by NM, 27-May-2015.) $)
    lspfixed $p |- ( ph
    -> E. z e. ( ( N ` { Z } ) \ { .0. } ) X e. ( N ` { ( Y .+ z ) } ) ) $=
      ( vk vl cv cvsca cfv co wceq csca cbs wrex csn wcel cdif eqid clvec clmod
      cpr lveclmod syl lspprel mpbid wa w3a cinvr clss 3ad2ant1 lspsncl syl2anc
      wne cdr c0g lvecdrng simp2l wn simpl3 simpr oveq1d lmod0vs eqtrd lmodvscl
      simpl1 simp2r syl3anc adantr lmod0vlid 3eqtrd simpl2r lspsnid syl22anc ex
      lssvscl eqeltrd necon3bd mpd drnginvrcl drnginvrn0 oveq1 sylan9eqr oveq2d
      lmod0vrid preq2 fveq2d lsppr0 eleqtrd lvecvsn0 mpbir2and eldifsn sylanbrc
      simp3 lmodvacl lspsnvs syl121anc lmodvsdi cur drnginvrl lmodvsass lmodvs1
      syl13anc cmulr 3eqtr3d sneqd eqtr3d oveq2 eleq2d rspcev 3exp rexlimdvv )
      AGUBUDZHFUEUFZUGZUCUDZJYJUGZCUGZUHZUCFUIUFZUJUFZUKUBYQUKZGHBUDZCUGZULZDUF
      ZUMZBJULDUFZIULUNZUKZAGHJURZDUFZUMZYRUAACYJUBYPYQDEFHJGUCKLYPUOZYQUOZYJUO
      ZNAFUPUMZFUQUMZOFUSUTZQRVAVBAYOUUFUBUCYQYQAYIYQUMZYLYQUMZVCZYOUUFAUURYOVD
      ZYIYPVEUFZUFZYMYJUGZUUEUMZGHUVBCUGZULZDUFZUMZUUFUUSUVBUUDUMZUVBIVJZUVCUUS
      UUNUUDFVFUFZUMZUVAYQUMZYMUUDUMZUVHAUURUUNYOUUOVGZAUURUVKYOAUUNJEUMZUVKUUO
      RUVJDEFJKUVJUOZNVHVIZVGZUUSYPVKUMZUUPYIYPVLUFZVJZUVLUUSUUMUVSAUURUUMYOOVG
      ZYPFUUJVMUTZAUUPUUQYOVNZUUSGUUDUMZVOZUWAAUURUWFYOTVGUUSUWEYIUVTUUSYIUVTUH
      ZUWEUUSUWGVCZGYMUUDUWHGYNIYMCUGZYMAUURYOUWGVPUWHYKIYMCUWHYKUVTHYJUGZIUWHY
      IUVTHYJUUSUWGVQVRUWHUUNHEUMZUWJIUHUWHAUUNAUURYOUWGWBZUUOUTZUWHAUWKUWLQUTY
      JYPUVTEFHIKUUJUULUVTUOZMVSVIVTVRUWHUUNYMEUMZUWIYMUHUWMUUSUWOUWGUUSUUNUUQU
      VOUWOUVNAUUPUUQYOWCZAUURUVOYORVGZYLYJYPYQEFJKUUJUULUUKWAWDZWECEFYMIKLMWFV
      IWGUWHUUNUVKUUQJUUDUMZUVMUWMUWHAUVKUWLUVQUTUUPUUQAYOUWGWHUWHAUWSUWLAUUNUV
      OUWSUUORDEFJKNWIVIZUTYQUVJYJUUDYPFYLJUUJUULUUKUVPWLZWJWMWKWNWOZYQYPUUTYIU
      VTUUKUWNUUTUOZWPWDZUUSUUNUVKUUQUWSUVMUVNUVRUWPAUURUWSYOUWTVGUXAWJYQUVJYJU
      UDYPFUVAYMUUJUULUUKUVPWLWJUUSUVIUVAUVTVJZYMIVJZUUSUVSUUPUWAUXEUWCUWDUXBYQ
      YPUUTYIUVTUUKUWNUXCWQWDZUUSUXFYLUVTVJZJIVJZUUSGHULDUFZUMZVOZUXHAUURUXLYOS
      VGZUUSUXKYLUVTUUSYLUVTUHZUXKUUSUXNVCZGYKUXJUXOGYNYKICUGZYKAUURYOUXNVPUXOY
      MIYKCUXNUUSYMUVTJYJUGZIYLUVTJYJWRUUSUUNUVOUXQIUHUVNUWQYJYPUVTEFJIKUUJUULU
      WNMVSVIWSWTUUSUXPYKUHZUXNUUSUUNYKEUMZUXRUVNUUSUUNUUPUWKUXSUVNUWDAUURUWKYO
      QVGZYIYJYPYQEFHKUUJUULUUKWAWDZCEFYKIKLMXAVIWEWGUUSYKUXJUMZUXNUUSUUNUXJUVJ
      UMZUUPHUXJUMZUYBUVNAUURUYCYOAUUNUWKUYCUUOQUVJDEFHKUVPNVHVIVGUWDAUURUYDYOA
      UUNUWKUYDUUOQDEFHKNWIVIVGYQUVJYJUXJYPFYIHUUJUULUUKUVPWLWJWEWMWKWNWOUUSUXL
      UXIUXMUUSUXKJIUUSJIUHZUXKUUSUYEVCZGUUHUXJUYFAUUIAUURYOUYEWBUAUTUYEUUSUUHH
      IURZDUFUXJUYEUUGUYGDJIHXBXCUUSDEFHIKMNUVNUXTXDWSXEWKWNWOUUSYLYJYPYQUVTEFJ
      IKUULUUJUUKUWNMUWBUWPUWQXFXGUUSUVAYJYPYQUVTEFYMIKUULUUJUUKUWNMUWBUXDUWRXF
      XGUVBUUDIXHXIUUSGYNULDUFZUVFUUSGYNUYHAUURYOXJUUSUUNYNEUMZYNUYHUMUVNUUSUUN
      UXSUWOUYIUVNUYAUWRCEFYKYMKLXKWDZDEFYNKNWIVIWMUUSUVAYNYJUGZULZDUFZUYHUVFUU
      SUUMUVLUXEUYIUYMUYHUHUWBUXDUXGUYJUVAYJYPYQDEFYNUVTKUUJUULUUKUWNNXLXMUUSUY
      LUVEDUUSUYKUVDUUSUYKUVAYKYJUGZUVBCUGZUVDUUSUUNUVLUXSUWOUYKUYOUHUVNUXDUYAU
      WRCUVAYJYPYQEFYKYMKLUUJUULUUKXNXSUUSUYNHUVBCUUSUVAYIYPXTUFZUGZHYJUGZYPXOU
      FZHYJUGZUYNHUUSUYQUYSHYJUUSUVSUUPUWAUYQUYSUHUWCUWDUXBYQYPUYPUYSUUTYIUVTUU
      KUWNUYPUOZUYSUOZUXCXPWDVRUUSUUNUVLUUPUWKUYRUYNUHUVNUXDUWDUXTUVAYIYJUYPYPY
      QEFHKUUJUULUUKVUAXQXSUUSUUNUWKUYTHUHUVNUXTYJUYSYPEFHKUUJUULVUBXRVIYAVRVTY
      BXCYCXEUUCUVGBUVBUUEYSUVBUHZUUBUVFGVUCUUAUVEDVUCYTUVDYSUVBHCYDYBXCYEYFVIY
      GYHWO $.
  $}

  ${
    $d j k N $.  $d j k V $.  $d j k W $.  $d j k X $.  $d j k Y $.
    $d j k Z $.  $d j k ph $.
    lspexch.v $e |- V = ( Base ` W ) $.
    lspexch.o $e |- .0. = ( 0g ` W ) $.
    lspexch.n $e |- N = ( LSpan ` W ) $.
    lspexch.w $e |- ( ph -> W e. LVec ) $.
    lspexch.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lspexch.y $e |- ( ph -> Y e. V ) $.
    lspexch.z $e |- ( ph -> Z e. V ) $.
    lspexch.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Z } ) ) $.
    lspexch.e $e |- ( ph -> X e. ( N ` { Y , Z } ) ) $.
    $( Exchange property for span of a pair.  TODO: see if a version with Y,Z
       and X,Z reversed will shorten proofs (analogous to ~ lspexchn1 vs.
       ~ lspexchn2 ); look for ~ lspexch and ~ prcom in same proof.  TODO:
       would a hypothesis of ` -. X e. ( N `` { Z } ) ` instead of
       ` ( N `` { X } ) =/= ( N ` { Z } ) `` be better overall?  This would be
       shorter and also satisfy the ` X =/= .0. ` condition.  Here and also
       lspindp* and all proofs affected by them (all in NM's mathbox); there
       are 58 hypotheses with the ` =/= ` pattern as of 24-May-2015.
       (Contributed by NM, 11-Apr-2015.) $)
    lspexch $p |- ( ph -> Y e. ( N ` { X , Z } ) ) $=
      ( cfv co wcel vj vk cv cvsca cplusg wceq csca cbs wrex cpr clvec lveclmod
      eqid clmod syl lspprel mpbid wa w3a cinvr cminusg csg 3ad2ant1 simp2r csn
      cdif eldifad lmodsubvs simp3 eqcomd wb lmodgrp lmodvscl syl3anc grpsubadd
      simp2l syl13anc mpbird eqtr3d c0g wne adantr oveq1 oveq1d lmod0vs syl2anc
      cgrp lmod0vlid eqtrd sylan9eqr lspsneli eqeltrd eldifsni lspsneleq ex mpd
      necon3d eldifsn sylanbrc lmodfgrp grpinvcl lmodvacl lvecinv clss lvecdrng
      lspprcl cdr drnginvrcl cur lmodvs1 lmodrng rngidcl 3syl lsppreli eqeltrrd
      crg lssvscl syl22anc 3exp rexlimdvv ) AEUAUCZFDUDRZSZUBUCZHYBSZDUERZSZUFZ
      UBDUGRZUHRZUIUAYJUIZFEHUJBRZTZAEFHUJBRTYKQAYFYBUAYIYJBCDFHEUBIYFUMZYIUMZY
      JUMZYBUMZKADUKTZDUNTZLDULZUOZNOUPUQAYHYMUAUBYJYJAYAYJTZYDYJTZURZYHYMAUUDY
      HUSZFYAYIUTRZRZEYDYIVARZRZHYBSZYFSZYBSZYLUUEUUKYCUFFUULUFUUEEYEDVBRZSZUUK
      YCUUEYDYFYBYIYJUUMUUHCDEHIYNUUMUMZYQYOYPUUHUMZUUEYRYSAUUDYRYHLVCZYTUOZAUU
      BUUCYHVDZUUEECGVEZAUUDECUUTVFTZYHMVCZVGZAUUDHCTZYHOVCZVHUUEUUNYCUFZYGEUFZ
      UUEEYGAUUDYHVIZVJUUEDWGTZECTZYECTZYCCTZUVFUVGVKUUEYSUVIAUUDYSYHUUAVCZDVLU
      OUVCUUEYSUUCUVDUVKUURUUSUVEYDYBYIYJCDHIYOYQYPVMVNZUUEYSUUBFCTZUVLUURAUUBU
      UCYHVPZAUUDUVOYHNVCZYAYBYIYJCDFIYOYQYPVMVNCYFDUUMEYEYCIYNUUOVOVQVRVSUUEYA
      YBYIUUFYJCDUUKFYIVTRZIYQYOYPUVRUMZUUFUMZUUQUUEUUBYAUVRWAZYAYJUVRVEVFTUVPU
      UEEVEBRZHVEBRZWAZUWAAUUDUWDYHPVCUUEYAUVRUWBUWCUUEYAUVRUFZUWBUWCUFUUEUWEUR
      ZBCDHEGIJKUUEYRUWEUUQWBUUEUVDUWEUVEWBUWFEYEUWCUWFEYGYEUUEYHUWEUVHWBUWEUUE
      YGUVRFYBSZYEYFSZYEUWEYCUWGYEYFYAUVRFYBWCWDUUEUWHGYEYFSZYEUUEUWGGYEYFUUEYS
      UVOUWGGUFUURUVQYBYIUVRCDFGIYOYQUVSJWEWFWDUUEYSUVKUWIYEUFUURUVNYFCDYEGIYNJ
      WHWFWIWJWIUUEYEUWCTUWEUUEYDYBYIYJBCDHIYQYOYPKUURUUSUVEWKWBWLUUEEGWAZUWEUU
      EUVAUWJUVBECGWMUOWBWNWOWQWPZYAYJUVRWRWSUUEYSUVJUUJCTZUUKCTUURUVCUUEYSUUIY
      JTZUVDUWLUURUUEYIWGTZUUCUWMUUEYSUWNUVMYIDYOWTUOUUSYJYIUUHYDYPUUPXAWFZUVEU
      UIYBYIYJCDHIYOYQYPVMVNYFCDEUUJIYNXBVNUVQXCUQUUEYSYLDXDRZTUUGYJTZUUKYLTUUL
      YLTUURUUEUWPBCDEHIUWPUMZKUURUVCUVEXFUUEYIXGTZUUBUWAUWQUUEYRUWSUUQYIDYOXEU
      OUVPUWKYJYIUUFYAUVRYPUVSUVTXHVNUUEYIXIRZEYBSZUUJYFSUUKYLUUEUXAEUUJYFUUEYS
      UVJUXAEUFUURUVCYBUWTYICDEIYOYQUWTUMZXJWFWDUUEUWTUUIYFYBYIYJBCDEHIYNYQYOYP
      KUURUUEYSYIXPTUWTYJTUURYIDYOXKYJYIUWTYPUXBXLXMUWOUVCUVEXNXOYJUWPYBYLYIDUU
      GUUKYOYQYPUWRXQXRWLXSXTWP $.
  $}

  ${
    lspexchn1.v $e |- V = ( Base ` W ) $.
    lspexchn1.n $e |- N = ( LSpan ` W ) $.
    lspexchn1.w $e |- ( ph -> W e. LVec ) $.
    lspexchn1.x $e |- ( ph -> X e. V ) $.
    lspexchn1.y $e |- ( ph -> Y e. V ) $.
    lspexchn1.z $e |- ( ph -> Z e. V ) $.
    lspexchn1.q $e |- ( ph -> -. Y e. ( N ` { Z } ) ) $.
    lspexchn1.e $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    $( Exchange property for span of a pair with negated membership.  TODO:
       look at uses of ~ lspexch to see if this will shorten proofs.
       (Contributed by NM, 20-May-2015.) $)
    lspexchn1 $p |- ( ph -> -. Y e. ( N ` { X , Z } ) ) $=
      ( cpr cfv wcel adantr csn c0g eqid clvec cdif clss clmod lveclmod lspsncl
      wa syl syl2anc lssneln0 wne lspsnne2 simpr lspexch mtand ) AFEGPBQRZEFGPB
      QROAURUIBCDFEDUAQZGHUSUBZIADUCRZURJSAFCUSTUDRURADUEQZGTBQZCDFUSHUTVBUBZAV
      ADUFRZJDUGUJZAVEGCRZVCVBRVFMVBBCDGHVDIUHUKLNULSAECRURKSAVGURMSAFTBQVCUMUR
      ABCDFGHIVFLMNUNSAURUOUPUQ $.
  $}

  ${
    lspexchn2.v $e |- V = ( Base ` W ) $.
    lspexchn2.n $e |- N = ( LSpan ` W ) $.
    lspexchn2.w $e |- ( ph -> W e. LVec ) $.
    lspexchn2.x $e |- ( ph -> X e. V ) $.
    lspexchn2.y $e |- ( ph -> Y e. V ) $.
    lspexchn2.z $e |- ( ph -> Z e. V ) $.
    lspexchn2.q $e |- ( ph -> -. Y e. ( N ` { Z } ) ) $.
    lspexchn2.e $e |- ( ph -> -. X e. ( N ` { Z , Y } ) ) $.
    $( Exchange property for span of a pair with negated membership.  TODO:
       look at uses of ~ lspexch to see if this will shorten proofs.
       (Contributed by NM, 24-May-2015.) $)
    lspexchn2 $p |- ( ph -> -. Y e. ( N ` { Z , X } ) ) $=
      ( cpr cfv wcel prcom fveq2i eleq2i sylnib lspexchn1 ) AFEGPZBQZRFGEPZBQZR
      ABCDEFGHIJKLMNAEGFPZBQZREFGPZBQZROUIUKEUHUJBGFSTUAUBUCUEUGFUDUFBEGSTUAUB
      $.
  $}

  ${
    lspindpi.v $e |- V = ( Base ` W ) $.
    lspindpi.n $e |- N = ( LSpan ` W ) $.
    lspindpi.w $e |- ( ph -> W e. LVec ) $.
    lspindpi.x $e |- ( ph -> X e. V ) $.
    lspindpi.y $e |- ( ph -> Y e. V ) $.
    lspindpi.z $e |- ( ph -> Z e. V ) $.
    lspindpi.e $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    $( Partial independence property.  (Contributed by NM, 23-Apr-2015.) $)
    lspindpi $p |- ( ph
 -> ( ( N ` { X } ) =/= ( N ` { Y } ) /\ ( N ` { X } ) =/= ( N ` { Z } ) ) ) $=
      ( csn cfv wne wcel wss syl2anc cpr wn wceq clsm co csubg clss clmod clvec
      lveclmod syl eqid lsssssubg sseldd lsmub1 lsmpr sseqtr4d sseq1 syl5ibrcom
      lspsncl lspprcl lspsnel5 sylibrd necon3bd mpd lsmub2 jca ) AEOBPZFOBPZQZV
      HGOBPZQZAEFGUABPZRZUBZVJNAVNVHVIAVHVIUCZVHVMSZVNAVQVPVIVMSAVIVIVKDUDPZUEZ
      VMAVIDUFPZRZVKVTRZVIVSSADUGPZVTVIADUHRZWCVTSADUIRWDJDUJUKZWCDWCULZUMUKZAW
      DFCRVIWCRWELWCBCDFHWFIUTTUNZAWCVTVKWGAWDGCRVKWCRWEMWCBCDGHWFIUTTUNZVRVIVK
      DVRULZUOTAVRBCDFGHIWJWELMUPZUQVHVIVMURUSAWCVMBCDEHWFIWEAWCBCDFGHWFIWELMVA
      KVBZVCVDVEAVOVLNAVNVHVKAVHVKUCZVQVNAVQWMVKVMSAVKVSVMAWAWBVKVSSWHWIVRVIVKD
      WJVFTWKUQVHVKVMURUSWLVCVDVEVG $.
  $}

  ${
    lspindp1.v $e |- V = ( Base ` W ) $.
    lspindp1.o $e |- .0. = ( 0g ` W ) $.
    lspindp1.n $e |- N = ( LSpan ` W ) $.
    lspindp1.w $e |- ( ph -> W e. LVec ) $.
    ${
      lspindp1.y $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      lspindp1.z $e |- ( ph -> Y e. V ) $.
      lspindp1.x $e |- ( ph -> Z e. V ) $.
      lspindp1.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      lspindp1.e $e |- ( ph -> -. Z e. ( N ` { X , Y } ) ) $.
      $( Alternate way to say 3 vectors are mutually independent (swap 1st and
         2nd).  (Contributed by NM, 11-Apr-2015.) $)
      lspindp1 $p |- ( ph
       -> ( ( N ` { Z } ) =/= ( N ` { Y } ) /\ -. X e. ( N ` { Z , Y } ) ) ) $=
        ( cfv wcel adantr csn wne cpr wn eldifad lspindpi simprd wa clvec simpr
        cdif lspexch mtand jca ) AHUABRZFUABRZUBZEHFUCBRSZUDAUOEUABRZUBUQABCDHE
        FIKLOAECGUAZMUENQUFUGAURHEFUCBRSQAURUHBCDEHGFIJKADUISURLTAECUTUKSURMTAH
        CSUROTAFCSURNTAUSUPUBURPTAURUJULUMUN $.

      $( Alternate way to say 3 vectors are mutually independent (rotate
         left).  (Contributed by NM, 10-May-2015.) $)
      lspindp2l $p |- ( ph
      -> ( ( N ` { Y } ) =/= ( N ` { Z } ) /\ -. X e. ( N ` { Y , Z } ) ) ) $=
        ( csn cfv wne wcel wn lspindp1 simpld necomd simprd prcom fveq2i eleq2i
        cpr sylnib jca ) AFRBSZHRBSZTEFHUJZBSZUAZUBAUNUMAUNUMTZEHFUJZBSZUAZUBZA
        BCDEFGHIJKLMNOPQUCZUDUEAVAUQAURVBVCUFUTUPEUSUOBHFUGUHUIUKUL $.
    $}

    ${
      lspindp2.x $e |- ( ph -> X e. V ) $.
      lspindp2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      lspindp2.z $e |- ( ph -> Z e. V ) $.
      lspindp2.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      lspindp2.e $e |- ( ph -> -. Z e. ( N ` { X , Y } ) ) $.
      $( Alternate way to say 3 vectors are mutually independent (rotate
         right).  (Contributed by NM, 12-Apr-2015.) $)
      lspindp2 $p |- ( ph
      -> ( ( N ` { Z } ) =/= ( N ` { X } ) /\ -. Y e. ( N ` { Z , X } ) ) ) $=
        ( csn cfv cpr necomd wcel prcom fveq2i eleq2i sylnib lspindp1 ) ABCDFEG
        HIJKLNMOAERBSFRBSPUAAHEFTZBSZUBHFETZBSZUBQUIUKHUHUJBEFUCUDUEUFUG $.
    $}
  $}

  ${
    lspindp3.v $e |- V = ( Base ` W ) $.
    lspindp3.p $e |- .+ = ( +g ` W ) $.
    ${
      lspindp3.o $e |- .0. = ( 0g ` W ) $.
      lspindp3.n $e |- N = ( LSpan ` W ) $.
      lspindp3.w $e |- ( ph -> W e. LVec ) $.
      lspindp3.x $e |- ( ph -> X e. V ) $.
      lspindp3.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      lspindp3.e $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      $( Independence of 2 vectors is preserved by vector sum.  (Contributed by
         NM, 26-Apr-2015.) $)
      lspindp3 $p |- ( ph -> ( N ` { X } ) =/= ( N ` { ( X .+ Y ) } ) ) $=
        ( csn cfv wcel adantr wne co wceq wa clvec simpr lspabs2 ex necon3d mpd
        cdif ) AFQCRZGQCRZUAULFGBUBQCRZUAPAULUNULUMAULUNUCZULUMUCAUOUDBCDEFGHIJ
        KLAEUESUOMTAFDSUONTAGDHQUKSUOOTAUOUFUGUHUIUJ $.
    $}

    lspindp4.n $e |- N = ( LSpan ` W ) $.
    lspindp4.w $e |- ( ph -> W e. LMod ) $.
    lspindp4.x $e |- ( ph -> X e. V ) $.
    lspindp4.y $e |- ( ph -> Y e. V ) $.
    lspindp4.z $e |- ( ph -> Z e. V ) $.
    lspindp4.e $e |- ( ph -> -. Z e. ( N ` { X , Y } ) ) $.
    $( (Partial) independence of 3 vectors is preserved by vector sum.
       (Contributed by NM, 26-Apr-2015.) $)
    lspindp4 $p |- ( ph -> -. Z e. ( N ` { X , ( X .+ Y ) } ) ) $=
      ( co cpr cfv lspprabs neleqtrrd ) AFFGBQRCSFGRCSHPABCDEFGIJKLMNTUA $.
  $}

  ${
    lvecindp.v $e |- V = ( Base ` W ) $.
    lvecindp.p $e |- .+ = ( +g ` W ) $.
    lvecindp.f $e |- F = ( Scalar ` W ) $.
    lvecindp.k $e |- K = ( Base ` F ) $.
    lvecindp.t $e |- .x. = ( .s ` W ) $.
    lvecindp.s $e |- S = ( LSubSp ` W ) $.
    lvecindp.w $e |- ( ph -> W e. LVec ) $.
    lvecindp.u $e |- ( ph -> U e. S ) $.
    lvecindp.x $e |- ( ph -> X e. V ) $.
    lvecindp.n $e |- ( ph -> -. X e. U ) $.
    lvecindp.y $e |- ( ph -> Y e. U ) $.
    lvecindp.z $e |- ( ph -> Z e. U ) $.
    lvecindp.a $e |- ( ph -> A e. K ) $.
    lvecindp.b $e |- ( ph -> B e. K ) $.
    lvecindp.e $e |- ( ph -> ( ( A .x. X ) .+ Y ) = ( ( B .x. X ) .+ Z ) ) $.
    $( Compute the ` X ` coefficient in a sum with an independent vector ` X `
       (first conjunct), which can then be removed to continue with the
       remaining vectors summed in expressions ` Y ` and ` Z ` (second
       conjunct).  Typically, ` U ` is the span of the remaining vectors.
       (Contributed by NM, 5-Apr-2015.)  (Revised by Mario Carneiro,
       21-Apr-2016.) $)
    lvecindp $p |- ( ph -> ( A = B /\ Y = Z ) ) $=
      ( wceq csn clspn cfv ccntz eqid clmod wcel csubg clvec lveclmod lspsnsubg
      co c0g syl syl2anc wss lsssssubg sseldd lspdisj lmodabl ablcntzd lspsneli
      cabel subgdisj1 cdif wne lssneln0 eldifsni lvecvscan2 mpbid subgdisj2 jca
      ) ABCUJZMNUJABLFVBZCLFVBZUJWCAWDMWENDLUKKULUMZUMZGKKVCUMZKUNUMZPWHUOZWIUO
      ZAKUPUQZLJUQWGKURUMZUQAKUSUQWLUAKUTVDZUCWFJKLOWFUOZVAVEZAEWMGAWLEWMVFWNEK
      TVGVDUBVHZAEGWFJKLWHOWJWOTUAUBUCUDVIZAWGGKWIWKAWLKVMUQWNKVJVDWPWQVKZABFHI
      WFJKLOSQRWOWNUGUCVLZACFHIWFJKLOSQRWOWNUHUCVLZUEUFUIVNABCFHIJKLWHOSQRWJUAU
      GUHUCALJWHUKVOUQLWHVPAEGJKLWHOWJTWNUBUCUDVQLJWHVRVDVSVTAWDMWENDWGGKWHWIPW
      JWKWPWQWRWSWTXAUEUFUIWAWB $.
  $}

  ${
    lvecindp2.v $e |- V = ( Base ` W ) $.
    lvecindp2.p $e |- .+ = ( +g ` W ) $.
    lvecindp2.f $e |- F = ( Scalar ` W ) $.
    lvecindp2.k $e |- K = ( Base ` F ) $.
    lvecindp2.t $e |- .x. = ( .s ` W ) $.
    lvecindp2.o $e |- .0. = ( 0g ` W ) $.
    lvecindp2.n $e |- N = ( LSpan ` W ) $.
    lvecindp2.w $e |- ( ph -> W e. LVec ) $.
    lvecindp2.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lvecindp2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    lvecindp2.a $e |- ( ph -> A e. K ) $.
    lvecindp2.b $e |- ( ph -> B e. K ) $.
    lvecindp2.c $e |- ( ph -> C e. K ) $.
    lvecindp2.d $e |- ( ph -> D e. K ) $.
    lvecindp2.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    lvecindp2.e $e |- ( ph
       -> ( ( A .x. X ) .+ ( B .x. Y ) ) = ( ( C .x. X ) .+ ( D .x. Y ) ) ) $.
    $( Sums of independent vectors must have equal coefficients.  (Contributed
       by NM, 22-Mar-2015.) $)
    lvecindp2 $p |- ( ph -> ( A = C /\ B = D ) ) $=
      ( co wceq wa csn cfv ccntz eqid clmod wcel csubg clvec lveclmod lspsnsubg
      syl eldifad syl2anc lspdisj2 cabel ablcntzd lspsneli subgdisjb mpbid cdif
      lmodabl wne eldifsni lvecvscan2 anbi12d ) ABMGULZDMGULZUMZCNGULZENGULZUMZ
      UNZBDUMZCEUMZUNAVTWCFULWAWDFULUMWFUKAVTWCWAWDFMUOJUPZNUOJUPZLOLUQUPZQUAWK
      URZALUSUTZMKUTWILVAUPZUTALVBUTWMUCLVCVEZAMKOUOZUDVFZJKLMPUBVDVGZAWMNKUTWJ
      WNUTWOANKWPUEVFZJKLNPUBVDVGZAJKLMNOPUAUBUCWQWSUJVHAWIWJLWKWLAWMLVIUTWOLVO
      VEWRWTVJABGHIJKLMPTRSUBWOUFWQVKADGHIJKLMPTRSUBWOUHWQVKACGHIJKLNPTRSUBWOUG
      WSVKAEGHIJKLNPTRSUBWOUIWSVKVLVMAWBWGWEWHABDGHIKLMOPTRSUAUCUFUHWQAMKWPVNZU
      TMOVPUDMKOVQVEVRACEGHIKLNOPTRSUAUCUGUIWSANXAUTNOVPUENKOVQVEVRVSVM $.
  $}

  ${
    lspsnsubn0.v $e |- V = ( Base ` W ) $.
    lspsnsubn0.o $e |- .0. = ( 0g ` W ) $.
    lspsnsubn0.m $e |- .- = ( -g ` W ) $.
    lspsnsubn0.w $e |- ( ph -> W e. LMod ) $.
    lspsnsubn0.x $e |- ( ph -> X e. V ) $.
    lspsnsubn0.y $e |- ( ph -> Y e. V ) $.
    lspsnsubn0.e $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    $( Unequal singleton spans imply nonzero vector subtraction.  (Contributed
       by NM, 19-Mar-2015.) $)
    lspsnsubn0 $p |- ( ph -> ( X .- Y ) =/= .0. ) $=
      ( csn cfv wne wceq wcel co clmod wb lmodsubeq0 syl3anc sneq fveq2d syl6bi
      necon3d mpd ) AFPZCQZGPZCQZRFGBUAZHROAUOHULUNAUOHSZFGSZULUNSAEUBTFDTGDTUP
      UQUCLMNFGBDEHIJKUDUEUQUKUMCFGUFUGUHUIUJ $.
  $}

  ${
    $d x y z N $.  $d x y z .(+) $.  $d x y z T $.  $d x y z U $.  $d y z W $.
    $d x y z X $.  $d x y z ph $.
    lsmcv.v $e |- V = ( Base ` W ) $.
    lsmcv.s $e |- S = ( LSubSp ` W ) $.
    lsmcv.n $e |- N = ( LSpan ` W ) $.
    lsmcv.p $e |- .(+) = ( LSSum ` W ) $.
    lsmcv.w $e |- ( ph -> W e. LVec ) $.
    lsmcv.t $e |- ( ph -> T e. S ) $.
    lsmcv.u $e |- ( ph -> U e. S ) $.
    lsmcv.x $e |- ( ph -> X e. V ) $.
    $( Subspace sum has the covering property (using spans of singletons to
       represent atoms).  Similar to Exercise 5 of [Kalmbach] p. 153.
       ( ~ spansncvi analog.)  TODO: ugly proof; can it be shortened?
       (Contributed by NM, 2-Oct-2014.) $)
    lsmcv $p |- ( ( ph /\ T C. U /\ U C_ ( T .(+) ( N ` { X } ) ) )
      -> U = ( T .(+) ( N ` { X } ) ) ) $=
      ( syl wcel syl2anc vx vy vz csn cfv co wss w3a simp3 simp2 pssss cv wn wa
      wpss pssnel cplusg wceq wrex simpl3 simprl sseldd wb csubg clmod lveclmod
      wex clvec lsssssubg lspsncl eqid lsmelval 3ad2ant1 adantr c0g wne simp1rr
      mpbid simp2l wi oveq2 eqeq2d biimpac ad2antrr lssel lmod0vrid biimpd syl7
      ex exp4a 3imp eleq1 biimparc ee12an necon3bd mpd csg cabel lmodabl simp2r
      simp1l1 ablpncan2 syl3anc eqeltrrd lssvsubcl syl22anc lspsneleq lspsnel5a
      simp1rl simp1l2 sselda eqsstr3d mpd3an23 3exp rexlimdvv exlimddv mpbi2and
      simp12r lsmlub eqssd ) ADEUOZEDIUDFUEZBUFZUGZUHZEYCAYAYDUIYEDEUGZYBEUGZYC
      EUGZYEYAYFAYAYDUJZDEUKZRYEUAULZESZYKDSZUMZUNZYGUAYEYAYOUAVGYIUADEUPRYEYOU
      NZYKUBULZUCULZHUQUEZUFZURZUCYBUSUBDUSZYGYPYKYCSZUUBYPEYCYKAYAYDYOUTYEYLYN
      VAVBYEUUCUUBVCZYOAYAUUDYDADHVDUEZSZYBUUESZUUDACUUEDAHVESZCUUEUGAHVHSZUUHN
      HVFZRZCHKVIRZOVBZACUUEYBUULAUUHIGSZYBCSZUUKQCFGHIJKLVJZTVBZUBUCYSBDYBHYKY
      SVKZMVLTVMVNVRYPUUAYGUBUCDYBYPYQDSZYRYBSZUNZUUAYGYPUVAUUAUHZYRHVOUEZVPZYR
      ESZYGUVBYNUVDYLYNYEUVAUUAVQUVBYMYRUVCUVBUUSYRUVCURZYKYQURZYMYPUUSUUTUUAVS
      ZYPUVAUUAUVFUVGVTYPUVAUUAUVFUVGUUAUVFUNYKYQUVCYSUFZURZYPUVAUVGUVFUUAUVJUV
      FYTUVIYKYRUVCYQYSWAWBWCYPUVAUVJUVGVTYPUVAUNZUVJUVGUVKUVIYQYKUVKUUHYQGSZUV
      IYQURYEUUHYOUVAAYAUUHYDUUKVMWDUVKDCSZUUSUVLYEUVMYOUVAAYAUVMYDOVMWDYPUUSUU
      TVACDGHYQJKWEZTYSGHYQUVCJUURUVCVKZWFTWBWGWIWHWJWKUVGYMUUSYKYQDWLWMWNWOWPU
      VBYTYQHWQUEZUFZYREUVBHWRSZUVLYRGSZUVQYRURUVBUUIUVRYPUVAUUIUUAYEUUIYOAYAUU
      IYDNVMVNVMZUUIUUHUVRUUJHWSRRUVBUVMUUSUVLUVBAUVMAYAYDYOUVAUUAXAZORUVHUVNTU
      VBUUOUUTUVSUVBUUHUUNUUOUVBUUIUUHUVTUUJRZUVBAUUNUWAQRUUPTYPUUSUUTUUAWTCYBG
      HYRJKWETGYSHUVPYQYRJUURUVPVKZXBXCUVBUUHECSZYTESYQESZUVQESUWBUVBAUWDUWAPRU
      VBYKYTEYPUVAUUAUIYLYNYEUVAUUAXIXDUVBYAUUSUWEAYAYDYOUVAUUAXJUVHYADEYQYJXKT
      CEUVPHYTYQUWCKXEXFXDUVBUVDUVEUHZYBYRUDFUEEUWFFGHIYRUVCJUVOLUVBUVDUUIUVEUV
      TVMZUWFAUUNUVBUVDAUVEUWAVMZQRUUSUUTYPUUAUVDUVEXRUVBUVDUVEUJXGUWFCEFHYRKLU
      WFUUIUUHUWGUUJRUWFAUWDUWHPRUVBUVDUVEUIXHXLXMXNXOWPXPAYAYFYGUNYHVCZYDAUUFU
      UGEUUESUWIUUMUUQACUUEEUULPVBBDYBEHMXSXCVMXQXT $.
  $}

  ${
    $d r s t z A $.  $d r s t x y z B $.  $d r s t z N $.  $d a s t x y z ph $.
    $d r F $.  $d a s t x y Q $.  $d r S $.  $d r s t z V $.  $d a r x y z W $.
    $d r s t z .+ $.  $d r s t z .x. $.  $d r z X $.  $d r s t z Y $.
    lspsolv.v $e |- V = ( Base ` W ) $.
    lspsolv.s $e |- S = ( LSubSp ` W ) $.
    lspsolv.n $e |- N = ( LSpan ` W ) $.
    ${
      lspsolv.f $e |- F = ( Scalar ` W ) $.
      lspsolv.b $e |- B = ( Base ` F ) $.
      lspsolv.p $e |- .+ = ( +g ` W ) $.
      lspsolv.t $e |- .x. = ( .s ` W ) $.
      lspsolv.q $e |- Q = { z e. V |
                            E. r e. B ( z .+ ( r .x. Y ) ) e. ( N ` A ) } $.
      lspsolv.w $e |- ( ph -> W e. LMod ) $.
      lspsolv.ss $e |- ( ph -> A C_ V ) $.
      lspsolv.y $e |- ( ph -> Y e. V ) $.
      lspsolv.x $e |- ( ph -> X e. ( N ` ( A u. { Y } ) ) ) $.
      $( Lemma for ~ lspsolv .  (Contributed by Mario Carneiro,
         25-Jun-2014.) $)
      lspsolvlem $p |- ( ph -> E. r e. B ( X .+ ( r .x. Y ) ) e. ( N ` A ) ) $=
        ( va vx vy vs vt wcel cv cfv wrex csn cun clmod wss crab ssrab2 eqsstri
        co a1i wa c0g adantr eqid lmod0cl wceq lmod0vs syl2anc oveq2d lmod0vrid
        syl sselda eqtrd lspssid eqeltrd oveq1 eleq1d ssrabdv syl6sseqr cminusg
        rspcev cur cgrp lmodfgrp lmod1cl lmodvneg1 lmodgrp grprinv lspcl lss0cl
        grpinvcl rexbidv elrab2 sylanbrc snssd unssd lspss syl3anc cplusg cvsca
        csca cbs clss c0 wne ne0i weq cbvrexv syl6bb anbi12i an4 reeanv simp1ll
        bitri w3a simp1lr simp1rl lmodvscl simp1rr lmodvacl cmulr simp2l simp2r
        lmodmcl lmodacl syl122anc lmodvsdir syl13anc lmodvsass lmodvsdi 3eqtr4d
        lmod4 oveq1d simp3l simp3r lsscl rexlimdvv syl5bir expimpd syl5bi exp4b
        3exp 3imp2 islssd lspid sseqtrd sseldd simprbi ) AMFUMZMOUNZNHVDZEVDZCJ
        UOZUMZODUPZACNUQZURZJUOZFMAUVCFJUOZFALUSUMZFKUTZUVBFUTUVCUVDUTUDUVFAFBU
        NZUUPEVDZUURUMZODUPZBKVAZKUCUVJBKVBVCVEZACUVAFACUVKFAUVJBKCUEAUVGCUMZVF
        ZIVGUOZDUMZUVGUVONHVDZEVDZUURUMZUVJUVNUVEUVPAUVEUVMUDVHZIDLUVOSTUVOVIZV
        JVPUVNUVRUVGUURUVNUVRUVGLVGUOZEVDZUVGUVNUVQUWBUVGEAUVQUWBVKZUVMAUVENKUM
        ZUWDUDUFHIUVOKLNUWBPSUBUWAUWBVIZVLVMVHVNUVNUVEUVGKUMUWCUVGVKUVTACKUVGUE
        VQEKLUVGUWBPUAUWFVOVMVRACUURUVGAUVECKUTZCUURUTUDUECJKLPRVSVMVQVTUVIUVSO
        UVODUUOUVOVKZUVHUVRUURUWHUUPUVQUVGEUUOUVONHWAVNWBWFVMWCUCWDANFAUWENUUPE
        VDZUURUMZODUPZNFUMZUFAIWGUOZIWEUOZUOZDUMZNUWONHVDZEVDZUURUMZUWKAIWHUMZU
        WMDUMZUWPAUVEUWTUDILSWIVPAUVEUXAUDUWMIDLSTUWMVIZWJVPDIUWNUWMTUWNVIZWPVM
        AUWRUWBUURAUWRNNLWEUOZUOZEVDZUWBAUWQUXENEAUVEUWEUWQUXEVKUDUFHUWMIUWNUXD
        KLNPUXDVIZSUBUXBUXCWKVMVNALWHUMZUWEUXFUWBVKAUVEUXHUDLWLVPUFKELUXDNUWBPU
        AUWFUXGWMVMVRAUVEUURGUMZUWBUURUMUDAUVEUWGUXIUDUEGCJKLPQRWNVMZGUURLUWBUW
        FQWOVMVTUWJUWSOUWODUUOUWOVKZUWIUWRUURUXKUUPUWQNEUUOUWONHWAVNWBWFVMUVJUW
        KBNKFUVGNVKZUVIUWJODUXLUVHUWIUURUVGNUUPEWAWBWQUCWRWSZWTXAUVBFJKLPRXBXCA
        UVEFGUMUVDFVKUDAUHDEGHFIKLUIUJILXFUOVKASVEDIXGUOVKATVEKLXGUOVKAPVEELXDU
        OVKAUAVEHLXEUOVKAUBVEGLXHUOVKAQVEUVLAUWLFXIXJUXMFNXKVPAUHUNZDUMZUIUNZFU
        MZUJUNZFUMZUXNUXPHVDZUXREVDZFUMZAUXOUXQUXSUYBUXQUXSVFZUXPKUMZUXRKUMZVFZ
        UXPUKUNZNHVDZEVDZUURUMZUKDUPZUXRULUNZNHVDZEVDZUURUMZULDUPZVFZVFZAUXOVFZ
        UYBUYCUYDUYKVFZUYEUYPVFZVFUYRUXQUYTUXSVUAUVJUYKBUXPKFBUIXLZUVJUXPUUPEVD
        ZUURUMZODUPUYKVUBUVIVUDODVUBUVHVUCUURUVGUXPUUPEWAWBWQVUDUYJOUKDOUKXLZVU
        CUYIUURVUEUUPUYHUXPEUUOUYGNHWAVNWBXMXNUCWRUVJUYPBUXRKFBUJXLZUVJUXRUUPEV
        DZUURUMZODUPUYPVUFUVIVUHODVUFUVHVUGUURUVGUXRUUPEWAWBWQVUHUYOOULDOULXLZV
        UGUYNUURVUIUUPUYMUXREUUOUYLNHWAVNWBXMXNUCWRXOUYDUYKUYEUYPXPXSUYSUYFUYQU
        YBUYQUYJUYOVFZULDUPUKDUPUYSUYFVFZUYBUYJUYOUKULDDXQVUKVUJUYBUKULDDVUKUYG
        DUMZUYLDUMZVFZVUJUYBVUKVUNVUJXTZUYAKUMZUYAUUPEVDZUURUMZODUPZUYBVUOUVEUX
        TKUMZUYEVUPVUOAUVEAUXOUYFVUNVUJXRZUDVPZVUOUVEUXOUYDVUTVVBAUXOUYFVUNVUJY
        AZUYDUYEUYSVUNVUJYBZUXNHIDKLUXPPSUBTYCXCZUYDUYEUYSVUNVUJYDZEKLUXTUXRPUA
        YEXCVUOUXNUYGIYFUOZVDZUYLIXDUOZVDZDUMZUYAVVJNHVDZEVDZUURUMZVUSVUOUVEVVH
        DUMZVUMVVKVVBVUOUVEUXOVULVVOVVBVVCVUKVULVUMVUJYGZVVGIDLUXNUYGSTVVGVIZYI
        XCZVUKVULVUMVUJYHZVVIIDLVVHUYLSTVVIVIZYJXCVUOVVMUXNUYIHVDZUYNEVDZUURVUO
        UYAUXNUYHHVDZUYMEVDZEVDZUXTVWCEVDZUYNEVDZVVMVWBVUOUVEVUTUYEVWCKUMZUYMKU
        MZVWEVWGVKVVBVVEVVFVUOUVEUXOUYHKUMZVWHVVBVVCVUOUVEVULUWEVWJVVBVVPVUOAUW
        EVVAUFVPZUYGHIDKLNPSUBTYCXCZUXNHIDKLUYHPSUBTYCXCVUOUVEVUMUWEVWIVVBVVSVW
        KUYLHIDKLNPSUBTYCXCEUYMKLUXTUXRVWCPUAYQYKVUOVVLVWDUYAEVUOVVLVVHNHVDZUYM
        EVDZVWDVUOUVEVVOVUMUWEVVLVWNVKVVBVVRVVSVWKEVVIVVHUYLHIDKLNPUASUBTVVTYLY
        MVUOVWMVWCUYMEVUOUVEUXOVULUWEVWMVWCVKVVBVVCVVPVWKUXNUYGHVVGIDKLNPSUBTVV
        QYNYMYRVRVNVUOVWAVWFUYNEVUOUVEUXOUYDVWJVWAVWFVKVVBVVCVVDVWLEUXNHIDKLUXP
        UYHPUASUBTYOYMYRYPVUOUXIUXOUYJUYOVWBUURUMVUOAUXIVVAUXJVPVVCVUKVUNUYJUYO
        YSVUKVUNUYJUYOYTDEGHUURILUYIUYNUXNSTUAUBQUUAYMVTVURVVNOVVJDUUOVVJVKZVUQ
        VVMUURVWOUUPVVLUYAEUUOVVJNHWAVNWBWFVMUVJVUSBUYAKFUVGUYAVKZUVIVURODVWPUV
        HVUQUURUVGUYAUUPEWAWBWQUCWRWSUUGUUBUUCUUDUUEUUFUUHUUIGFJLQRUUJVMUUKUGUU
        LUUNMKUMUUTUVJUUTBMKFUVGMVKZUVIUUSODVWQUVHUUQUURUVGMUUPEWAWBWQUCWRUUMVP
        $.
    $}

    $( If ` X ` is in the span of ` A u. { Y } ` but not ` A ` , then ` Y ` is
       in the span of ` A u. { X } ` .  (Contributed by Mario Carneiro,
       25-Jun-2014.) $)
    lspsolv $p |- ( ( W e. LVec /\ ( A C_ V /\ Y e. V /\
                      X e. ( ( N ` ( A u. { Y } ) ) \ ( N ` A ) ) ) ) ->
                    Y e. ( N ` ( A u. { X } ) ) ) $=
      ( vr wcel wss cfv co eqid adantr wceq syl2anc syl3anc vz csn cun cdif w3a
      clvec wa cv cvsca cplusg csca cbs wrex crab lveclmod simpr1 simpr2 simpr3
      clmod eldifad lspsolvlem cinvr cmulr cur cdr c0g lvecdrng ad2antrr simprl
      wne wn lmod0vs oveq2d snssd unssd lspssv ssdifssd lmod0vrid eqtrd eqeltrd
      sseldd simprr oveq1 eleq1d syl5ibcom necon3bd drnginvrl oveq1d drnginvrcl
      eldifbd mpd lmodvsass syl13anc lmodvs1 3eqtr3d lspcl csg lmodvscl lmodcom
      lmodvpncan ssun1 a1i lspss lspssid snidg 3syl lssvsubcl syl22anc eqeltrrd
      elun2 lssvscl rexlimddv ) EUFLZADMZGDLZFAGUBZUCZCNZACNZUDZLZUEZUGZFKUHZGE
      UINZOZEUJNZOZXSLZGAFUBZUCZCNZLKEUKNZULNZYCUAAYNYGUAUHYFYGOXSLKYNUMUADUNZB
      YEYMCDEFGKHIJYMPZYNPZYGPZYEPZYOPXMEUSLZYBEUOQZXMXNXOYAUPZXMXNXOYAUQZYCFXR
      XSXMXNXOYAURZUTVAYCYDYNLZYIUGZUGZYDYMVBNZNZYFYEOZGYLUUGUUIYDYMVCNZOZGYEOZ
      YMVDNZGYEOZUUJGUUGUULUUNGYEUUGYMVELZUUEYDYMVFNZVJZUULUUNRXMUUPYBUUFYMEYPV
      GVHZYCUUEYIVIZUUGFUUQGYEOZYGOZXSLZVKUURUUGUVBXRXSUUGUVBFXTUUGUVBFEVFNZYGO
      ZFUUGUVAUVDFYGUUGYTXOUVAUVDRYCYTUUFUUAQZYCXOUUFUUCQZYEYMUUQDEGUVDHYPYSUUQ
      PZUVDPZVLSVMUUGYTFDLZUVEFRUVFUUGXTDFUUGXRDXSUUGYTXQDMXRDMUVFUUGAXPDYCXNUU
      FUUBQZUUGGDUVGVNVOXQCDEHJVPSVQYCYAUUFUUDQZWAZYGDEFUVDHYRUVIVRSVSUVLVTWJUU
      GUVCYDUUQUUGYIYDUUQRZUVCYCUUEYIWBZUVNYHUVBXSUVNYFUVAFYGYDUUQGYEWCVMWDWEWF
      WKZYNYMUUKUUNUUHYDUUQYQUVHUUKPZUUNPZUUHPZWGTWHUUGYTUUIYNLZUUEXOUUMUUJRUVF
      UUGUUPUUEUURUVTUUSUUTUVPYNYMUUHYDUUQYQUVHUVSWITZUUTUVGUUIYDYEUUKYMYNDEGHY
      PYSYQUVQWLWMUUGYTXOUUOGRUVFUVGYEUUNYMDEGHYPYSUVRWNSWOUUGYTYLBLZUVTYFYLLUU
      JYLLUVFUUGYTYKDMZUWBUVFUUGAYJDUVKUUGFDUVMVNVOZBYKCDEHIJWPSZUWAUUGYFFYGOZF
      EWQNZOZYFYLUUGYTYFDLZUVJUWHYFRUVFUUGYTUUEXOUWIUVFUUTUVGYDYEYMYNDEGHYPYSYQ
      WRTZUVMYFFYGUWGDEHYRUWGPZWTTUUGYTUWBUWFYLLFYLLUWHYLLUVFUWEUUGUWFYHYLUUGYT
      UWIUVJUWFYHRUVFUWJUVMYGDEYFFHYRWSTUUGXSYLYHUUGYTUWCAYKMZXSYLMUVFUWDUWLUUG
      AYJXAXBAYKCDEHJXCTUVOWAVTUUGYKYLFUUGYTUWCYKYLMUVFUWDYKCDEHJXDSUUGUVJFYJLF
      YKLUVMFDXEFYJAXJXFWABYLUWGEUWFFUWKIXGXHXIYNBYEYLYMEUUIYFYPYSYQIXKXHXIXL
      $.
  $}

  ${
    $d s W y z $.  $d X y z $.
    lssacsex.1 $e |- A = ( LSubSp ` W ) $.
    lssacsex.2 $e |- N = ( mrCls ` A ) $.
    lssacsex.3 $e |- X = ( Base ` W ) $.
    $( In a vector space, subspaces form an algebraic closure system whose
       closure operator has the exchange property.  Strengthening of ~ lssacs
       by ~ lspsolv .  (Contributed by David Moews, 1-May-2017.) $)
    lssacsex $p |- ( W e. LVec -> ( A e. ( ACS ` X ) /\
                                 A. s e. ~P X A. y e. X
                                 A. z e. ( ( N ` ( s u. { y } ) ) \ ( N ` s ) )
                                 y e. ( N ` ( s u. { z } ) ) ) ) $=
      ( wcel cfv cv csn cun cdif wral wa fveq1d ralrimiva clvec cacs cpw lssacs
      clmod lveclmod syl clspn wss simplll elpwid simplr simpr wceq eqid mrclsp
      simpllr 3syl difeq12d eleqtrrd lspsolv syl13anc eleqtrd jca ) EUAKZCFUBLK
      ZAMZGMZBMZNOZDLZKZBVHVGNOZDLZVHDLZPZQZAFQZGFUCZQVEEUEKZVFEUFZFCEJHUDUGVEV
      RGVSVEVHVSKZRZVQAFWCVGFKZRZVLBVPWEVIVPKZRZVGVJEUHLZLZVKWGVEVHFUIWDVIVMWHL
      ZVHWHLZPZKVGWIKVEWBWDWFUJZWGVHFVEWBWDWFUQUKWCWDWFULWGVIVPWLWEWFUMWGWJVNWK
      VOWGVMWHDWGVEVTWHDUNWMWACDWHEHWHUOZIUPURZSWGVHWHDWOSUSUTVHCWHFEVIVGJHWNVA
      VBWGVJWHDWOSVCTTTVD $.
  $}

  ${
    $d r x N $.  $d r x S $.  $d r x U $.  $d r x V $.  $d r x W $.
    $d r x X $.  $d r x .0. $.
    lspsnat.v $e |- V = ( Base ` W ) $.
    lspsnat.z $e |- .0. = ( 0g ` W ) $.
    lspsnat.s $e |- S = ( LSubSp ` W ) $.
    lspsnat.n $e |- N = ( LSpan ` W ) $.
    $( There is no subspace strictly between the zero subspace and the span of
       a vector (i.e. a 1-dimensional subspace is an atom).  ( ~ h1datomi
       analog.)  (Contributed by NM, 20-Apr-2014.)  (Proof shortened by Mario
       Carneiro, 22-Jun-2014.) $)
    lspsnat $p |- ( ( ( W e. LVec /\ U e. S /\ X e. V ) /\
       U C_ ( N ` { X } ) ) -> ( U = ( N ` { X } ) \/ U = { .0. } ) ) $=
      ( vx wcel csn cfv wss wa wceq c0 cun clvec w3a wn wne cv wex simprl clmod
      cdif n0 simpl1 lveclmod syl simpl2 simprr eldifad lspsnel5a 0ss a1i ssdif
      simpl3 ad2antrl sseldd uncom eqtri fveq2i lsp0 difeq12d eleqtrrd syl13anc
      un0 lspsolv syl6eleq eqssd expr exlimdv syl5bi necon1bd ssdif0 syl6ibr wb
      lssle0 syl2anc sylibd orrd ) EUAMZBAMZFDMZUBZBFNZCOZPZQZBWKRZBGNZRZWMWNUC
      ZBWOPZWPWMWQBWOUIZSRWRWMWNWSSWSSUDLUEZWSMZLUFWMWNLWSUJWMXAWNLWIWLXAWNWIWL
      XAQZQZBWKWIWLXAUGXCABCEFJKXCWFEUHMZWFWGWHXBUKZEULZUMZWFWGWHXBUNZXCWTNZCOZ
      BFXCABCEWTJKXGXHXCWTBWOWIWLXAUOZUPUQXCFSXITZCOZXJXCWFSDPZWHWTSWJTZCOZSCOZ
      UIZMFXMMXEXNXCDURUSWFWGWHXBVAXCWTWKWOUIZXRXCWSXSWTWLWSXSPWIXABWKWOUTVBXKV
      CXCXPWKXQWOXPWKRXCXOWJCXOWJSTWJSWJVDWJVKVEVFUSXCXDXQWORXGCEGIKVGUMVHVISAC
      DEWTFHJKVLVJXLXICXLXISTXISXIVDXIVKVEVFVMVCUQVNVOVPVQVRBWOVSVTWMXDWGWRWPWA
      WMWFXDWFWGWHWLUKXFUMWFWGWHWLUNAEBGIJWBWCWDWE $.
  $}

  ${
    $d y ph $.
    lspsncv0.v $e |- V = ( Base ` W ) $.
    lspsncv0.z $e |- .0. = ( 0g ` W ) $.
    lspsncv0.s $e |- S = ( LSubSp ` W ) $.
    lspsncv0.n $e |- N = ( LSpan ` W ) $.
    lspsncv0.w $e |- ( ph -> W e. LVec ) $.
    lspsncv0.x $e |- ( ph -> X e. V ) $.
    lspsncv0.e $e |- ( ph -> X =/= .0. ) $.
    $( The span of a singleton covers the zero subspace, using Definition
       3.2.18 of [PtakPulmannova] p. 68 for "covers".)  (Contributed by NM,
       12-Aug-2014.) $)
    lspsncv0 $p |- ( ph
       -> -. E. y e. S ( { .0. } C. y /\ y C. ( N ` { X } ) ) ) $=
      ( csn wn wi wa wcel cv wpss cfv wral wrex wceq wss wne df-pss simpr nesym
      sylib sylbi clvec wo ad2antrr simplr lspsnat syl31anc orcomd ord ex com23
      npss syl6ibr syl5 ralrimiva ralinexa ) AHPZBUAZUBZVJGPDUCZUBZQZRZBCUDVKVM
      SBCUEQAVOBCVKVJVIUFZQZAVJCTZSZVNVKVIVJUGZVIVJUHZSZVQVIVJUIWBWAVQVTWAUJVIV
      JUKULUMVSVQVJVLUGZVJVLUFZRVNVSWCVQWDVSWCVQWDRVSWCSZVPWDWEWDVPWEFUNTZVRGET
      ZWCWDVPUOAWFVRWCMUPAVRWCUQAWGVRWCNUPVSWCUJCVJDEFGHIJKLURUSUTVAVBVCVJVLVDV
      EVFVGVKVMBCVHUL $.
  $}

  ${
    lspprat.v $e |- V = ( Base ` W ) $.
    lspprat.s $e |- S = ( LSubSp ` W ) $.
    lspprat.n $e |- N = ( LSpan ` W ) $.
    lspprat.w $e |- ( ph -> W e. LVec ) $.
    lspprat.u $e |- ( ph -> U e. S ) $.
    lspprat.x $e |- ( ph -> X e. V ) $.
    lspprat.y $e |- ( ph -> Y e. V ) $.
    lspprat.p $e |- ( ph -> U C. ( N ` { X , Y } ) ) $.
    ${
      lsppratlem1.o $e |- .0. = ( 0g ` W ) $.
      lsppratlem1.x2 $e |- ( ph -> x e. ( U \ { .0. } ) ) $.
      lsppratlem1.y2 $e |- ( ph -> y e. ( U \ ( N ` { x } ) ) ) $.
      $( Lemma for ~ lspprat .  Let ` x e. ( U \ { 0 } ) ` (if there is no such
         ` x ` then ` U ` is the zero subspace), and let
         ` y e. ( U \ ( N `` { x } ) ) ` (assuming the conclusion is false).
         The goal is to write ` X ` , ` Y ` in terms of ` x ` , ` y ` , which
         would normally be done by solving the system of linear equations.  The
         span equivalent of this process is ~ lspsolv (hence the name), which
         we use extensively below.  In this lemma, we show that since
         ` x e. ( N `` { X , Y } ) ` , either ` x e. ( N `` { Y } ) ` or
         ` X e. ( N `` { x , Y } ) ` .  (Contributed by NM, 29-Aug-2014.) $)
      lsppratlem1 $p |- ( ph
          -> ( x e. ( N ` { Y } ) \/ X e. ( N ` { x , Y } ) ) ) $=
        ( cv csn cfv wcel cpr wn cun clvec wss cdif adantr snssd pssssd eldifad
        wa sseldd prcom df-pr eqtri fveq2i syl6eleq anim1i eldif sylibr lspsolv
        syl13anc eqtr3i ex orrd ) ABUCZJUDZFUEZUFZIVLJUGZFUEZUFZAVOUHZVRAVSUQZI
        VMVLUDUIZFUEZVQVTHUJUFZVMGUKZIGUFZVLVMIUDUIZFUEZVNULUFZIWBUFAWCVSOUMAWD
        VSAJGRUNUMAWEVSQUMVTVLWGUFZVSUQWHAWIVSAVLIJUGZFUEZWGAEWKVLAEWKSUOAVLEKU
        DUAUPURWJWFFWJJIUGWFIJUSJIUTVAVBVCVDVLWGVNVEVFVMDFGHVLILMNVGVHWAVPFJVLU
        GWAVPJVLUTJVLUSVIVBVCVJVK $.

      ${
        lsppratlem2.x1 $e |- ( ph -> X e. ( N ` { x , y } ) ) $.
        lsppratlem2.y1 $e |- ( ph -> Y e. ( N ` { x , y } ) ) $.
        $( Lemma for ~ lspprat .  Show that if ` X ` and ` Y ` are both in
           ` ( N `` { x , y } ) ` (which will be our goal for each of the two
           cases above), then ` ( N `` { X , Y } ) C_ U ` , contradicting the
           hypothesis for ` U ` .  (Contributed by NM, 29-Aug-2014.)  (Revised
           by Mario Carneiro, 5-Sep-2014.) $)
        lsppratlem2 $p |- ( ph -> ( N ` { X , Y } ) C_ U ) $=
          ( cpr cfv clvec wcel clmod lveclmod syl wss csn eldifad prssi syl2anc
          cv lssss sstrd lspcl lspprss ) AIJUEFUFBUQZCUQZUEZFUFZEADVEFHIJMNAHUG
          UHHUIUHZOHUJUKZAVFVDGULVEDUHVGAVDEGAVBEUHVCEUHVDEULAVBEKUMUAUNZAVCEVB
          UMFUFUBUNZVBVCEUOUPAEDUHEGULPDEGHLMURUKUSDVDFGHLMNUTUPUCUDVAADEFHVBVC
          MNVGPVHVIVAUS $.
      $}

      ${
        lsppratlem3.x3 $e |- ( ph -> x e. ( N ` { Y } ) ) $.
        $( Lemma for ~ lspprat .  In the first case of ~ lsppratlem1 , since
           ` x e/ ( N `` (/) ) ` , also ` Y e. ( N `` { x } ) ` , and since
           ` y e. ( N `` { X , Y } ) C_ ( N `` { X , x } ) ` and
           ` y e/ ( N `` { x } ) ` , we have ` X e. ( N `` { x , y } ) ` as
           desired.  (Contributed by NM, 29-Aug-2014.) $)
        lsppratlem3 $p |- ( ph
            -> ( X e. ( N ` { x , y } ) /\ Y e. ( N ` { x , y } ) ) ) $=
          ( cpr cfv wcel csn cun clvec wss cdif clmod lveclmod syl snssd lspssv
          cv syl2anc sseldd pssssd unssd lspcl df-pr lspssid unssbd ssun1 lspss
          a1i syl3anc c0 0ss uncom un0 eqtri fveq2i syl6eleqr eldifbd wceq lsp0
          neleqtrrd eldifd syl13anc syl6eleq syl5eqss lspssp sstrd ssdifd lssss
          lspsolv ssdifssd snsspr1 jca ) AIBUQZCUQZUDZFUEZUFJWPUFAIWMUGZWNUGZUH
          ZFUEZWPAHUIUFZWQGUJIGUFWNWQIUGZUHZFUEZWQFUEZUKZUFIWTUFOAWMGAJUGZFUEZG
          WMAHULUFZXGGUJXHGUJAXAXIOHUMUNZAJGRUOXGFGHLNUPURUCUSUOZQAEXEUKZXFWNAE
          XDXEAEIJUDZFUEZXDAEXNSUTAXIXDDUFZXMXDUJXNXDUJXJAXIXCGUJZXOXJAWQXBGXKA
          IGQUOVAZDXCFGHLMNVBURAXMXBXGUHXDIJVCAXBXGXDAWQXBXDAXIXPXCXDUJXJXQXCFG
          HLNVDURVEAJXDAXEXDJAXIXPWQXCUJZXEXDUJXJXQXRAWQXBVFVHWQXCFGHLNVGVIAJVJ
          WQUHZFUEZXEAXAVJGUJZJGUFWMVJXGUHZFUEZVJFUEZUKUFJXTUFOYAAGVKVHRAWMYCYD
          AWMXHYCUCYBXGFYBXGVJUHXGVJXGVLXGVMVNVOVPAYDKUGZWMAWMEYEUAVQAXIYDYEVRX
          JFHKTNVSUNVTWAVJDFGHWMJLMNWIWBXSWQFXSWQVJUHWQVJWQVLWQVMVNVOWCZUSUOVAW
          DDXMXDFHMNWEVIWFWGUBUSWQDFGHWNILMNWIWBWOWSFWMWNVCZVOVPAXEWPJAXIWOGUJW
          QWOUJZXEWPUJXJAWOWSGYGAWQWRGXKAWNGAXLGWNAEGXEAEDUFEGUJPDEGHLMWHUNWJUB
          USUOVAWDYHAWMWNWKVHWQWOFGHLNVGVIYFUSWL $.
      $}

      ${
        lsppratlem4.x3 $e |- ( ph -> X e. ( N ` { x , Y } ) ) $.
        $( Lemma for ~ lspprat .  In the second case of ~ lsppratlem1 ,
           ` y e. ( N `` { X , Y } ) C_ ( N `` { x , Y } ) ` and
           ` y e/ ( N `` { x } ) ` implies ` Y e. ( N `` { x , y } ) ` and thus
           ` X e. ( N `` { x , Y } ) C_ ( N `` { x , y } ) ` as well.
           (Contributed by NM, 29-Aug-2014.) $)
        lsppratlem4 $p |- ( ph
            -> ( X e. ( N ` { x , y } ) /\ Y e. ( N ` { x , y } ) ) ) $=
          ( cpr cfv wcel clmod wss clvec lveclmod syl csn lssss ssdifssd sseldd
          cv cdif lspprcl cun df-pr snsspr1 prssi syl2anc lspssid syl5ss pssssd
          snssd snsspr2 syl5eqss lspssp syl3anc fveq2i syl6sseq ssdifd syl13anc
          unssd sstrd lspsolv syl6eleqr jca ) AIBUPZCUPZUDZFUEZUFJWDUFAWAJUDZFU
          EZWDIAHUGUFZWDDUFWEWDUHWFWDUHAHUIUFZWGOHUJUKZADFGHWAWBLMNWIAEKULZUQGW
          AAEGWJAEDUFEGUHPDEGHLMUMUKZUNUAUOZAEWAULZFUEZUQZGWBAEGWNWKUNUBUOZURAW
          EWMJULZUSZWDWAJUTZAWMWQWDAWMWCWDWAWBVAAWGWCGUHZWCWDUHWIAWAGUFZWBGUFWT
          WLWPWAWBGVBVCWCFGHLNVDVCVEAJWDAJWMWBULUSZFUEZWDAWHWMGUHJGUFZWBWRFUEZW
          NUQZUFJXCUFOAWAGWLVGRAWOXFWBAEXEWNAEWFXEAEIJUDZFUEZWFAEXHSVFAWGWFDUFX
          GWFUHXHWFUHWIADFGHWAJLMNWIWLRURAXGIULZWQUSWFIJUTAXIWQWFAIWFUCVGAWQWEW
          FWAJVHAWGWEGUHZWEWFUHWIAXAXDXJWLRWAJGVBVCWEFGHLNVDVCVEVPVIDXGWFFHMNVJ
          VKVQWEWRFWSVLVMVNUBUOWMDFGHWBJLMNVRVOWCXBFWAWBUTVLVSZVGVPVIDWEWDFHMNV
          JVKUCUOXKVT $.
      $}

      $( Lemma for ~ lspprat .  Combine the two cases and show a contradiction
         to ` U C. ( N `` { X , Y } ) ` under the assumptions on ` x ` and
         ` y ` .  (Contributed by NM, 29-Aug-2014.) $)
      lsppratlem5 $p |- ( ph -> ( N ` { X , Y } ) C_ U ) $=
        ( cv cpr cfv wcel wa wss clvec adantr wpss cdif lsppratlem3 lsppratlem4
        csn simpr lsppratlem1 mpjaodan simprl simprr lsppratlem2 mpdan ) AIBUCZ
        CUCZUDFUEZUFZJVEUFZUGZIJUDFUEZEUHAVCJUOFUEUFZVHIVCJUDFUEUFZAVJUGBCDEFGH
        IJKLMNAHUIUFZVJOUJAEDUFZVJPUJAIGUFZVJQUJAJGUFZVJRUJAEVIUKZVJSUJTAVCEKUO
        ULUFZVJUAUJAVDEVCUOFUEULUFZVJUBUJAVJUPUMAVKUGBCDEFGHIJKLMNAVLVKOUJAVMVK
        PUJAVNVKQUJAVOVKRUJAVPVKSUJTAVQVKUAUJAVRVKUBUJAVKUPUNABCDEFGHIJKLMNOPQR
        STUAUBUQURAVHUGBCDEFGHIJKLMNAVLVHOUJAVMVHPUJAVNVHQUJAVOVHRUJAVPVHSUJTAV
        QVHUAUJAVRVHUBUJAVFVGUSAVFVGUTVAVB $.
    $}

    ${
      $d y N $.  $d y .0. $.  $d y U $.  $d y ph $.  $d x y $.
      lsppratlem6.o $e |- .0. = ( 0g ` W ) $.
      $( Lemma for ~ lspprat .  Negating the assumption on ` y ` , we arrive
         close to the desired conclusion.  (Contributed by NM, 29-Aug-2014.) $)
      lsppratlem6 $p |- ( ph -> ( x e. ( U \ { .0. } )
       -> U = ( N ` { x } ) ) ) $=
        ( wcel vy cv csn cdif cfv wceq wa c0 wss cpr adantr clvec simprl simprr
        wpss wn lsppratlem5 ssnpss syl expr eq0rdv ssdif0 sylibr clmod lveclmod
        mt2d eldifi adantl lspsnel5a eqssd ex ) ABUBZDJUCZUDTZDVLUCEUEZUFAVNUGZ
        DVOVPDVOUDZUHUFDVOUIVPUAVQVPUAUBVQTZDHIUJEUEZUOZAVTVNRUKAVNVRVTUPZAVNVR
        UGZUGZVSDUIWAWCBUACDEFGHIJKLMAGULTZWBNUKADCTZWBOUKAHFTWBPUKAIFTWBQUKAVT
        WBRUKSAVNVRUMAVNVRUNUQVSDURUSUTVFVADVOVBVCVPCDEGVLLMAGVDTZVNAWDWFNGVEUS
        UKAWEVNOUKVNVLDTAVLDVMVGVHVIVJVK $.
    $}

    $d z N $.  $d z U $.  $d z V $.  $d z W $.  $d z ph $.
    $( A proper subspace of the span of a pair of vectors is the span of a
       singleton (an atom) or the zero subspace (if ` z ` is zero).  Proof
       suggested by Mario Carneiro, 28-Aug-2014.  (Contributed by NM,
       29-Aug-2014.) $)
    lspprat $p |- ( ph -> E. z e. V U = ( N ` { z } ) ) $=
      ( wceq wcel syl cv csn cfv wrex c0g c0 wss ssdif0 wa clmod clvec lveclmod
      cdif eqid lmod0vcl adantr simpr lss0ss syl2anc eqssd lspsn0 eqtr4d fveq2d
      sneq eqeq2d rspcev ex syl5bir wex lssss ssdifssd sseld lsppratlem6 eximdv
      wne jcad n0 df-rex 3imtr4g pm2.61dne ) ADBUAZUBZEUCZRZBFUDZDGUEUCZUBZUMZU
      FWHUFRDWGUGZAWEDWGUHAWIWEAWIUIZWFFSZDWGEUCZRZWEAWKWIAGUJSZWKAGUKSWNMGULTZ
      FGWFJWFUNZUOTUPWJDWGWLWJDWGAWIUQAWGDUGZWIAWNDCSZWQWONCGDWFWPKURUSUPUTAWLW
      GRZWIAWNWSWOEGWFWPLVATUPVBWDWMBWFFWAWFRZWCWLDWTWBWGEWAWFVDVCVEVFUSVGVHAWA
      WHSZBVIWAFSZWDUIZBVIWHUFVOWEAXAXCBAXAXBWDAWHFWAADFWGAWRDFUGNCDFGJKVJTVKVL
      ABCDEFGHIWFJKLMNOPQWPVMVPVNBWHVQWDBFVRVSVT $.
  $}

  ${
    $d s x y z B $.  $d s x y z N $.  $d s x y z V $.  $d s x y z W $.
    $d s x J $.
    islbs2.v $e |- V = ( Base ` W ) $.
    islbs2.j $e |- J = ( LBasis ` W ) $.
    islbs2.n $e |- N = ( LSpan ` W ) $.
    $( An equivalent formulation of the basis predicate in a vector space: a
       subset is a basis iff no element is in the span of the rest of the set.
       (Contributed by Mario Carneiro, 14-Jan-2015.) $)
    islbs2 $p |- ( W e. LVec -> ( B e. J <-> ( B C_ V /\
      ( N ` B ) = V /\ A. x e. B -. x e. ( N ` ( B \ { x } ) ) ) ) ) $=
      ( vz vy wcel wss cfv wceq cv csn wa eqid adantr clvec cdif wral w3a lbsss
      adantl lbssp clmod csca cur c0g wne lveclmod cdr lvecdrng drngunz syl jca
      wn lbsind2 syl3an1 3expa ralrimiva 3jca cvsca co cbs simpr1 simpr2 simprl
      simplr3 id sneq difeq2d fveq2d eleq12d notbid rspcv simpll simprr eldifsn
      sylc sylib sseldd lspsnvs syl3anc sseq1d ssdifssd syl2anc simpld lmodvscl
      clss lspcl lspsnel5 3bitr4d mtbird ralrimivva wb islbs mpbir3and impbida
      ) FUALZBCLZBEMZBDNEOZAPZBXFQZUBZDNZLZUSZABUCZUDZXBXCRZXDXEXLXCXDXBBCEFGHU
      EUFXCXEXBBCDEFGHIUGUFXNXKABXBXCXFBLZXKXBFUHLZFUINZUJNZXQUKNZULZRXCXOXKXBX
      PXTFUMZXBXQUNLXTXQFXQSZUOXQXRXSXSSZXRSZUPUQURBXRXFXQCDFXSHIYBYDYCUTVAVBVC
      VDXBXMRZXCXDXEJPZKPZFVENZVFZBYGQZUBZDNZLZUSZJXQVGNZXSQUBZUCKBUCZXBXDXEXLV
      HZXBXDXEXLVIYEYNKJBYPYEYGBLZYFYPLZRZRZYMYGYLLZUUBYSXLUUCUSZYEYSYTVJZXDXEX
      LXBUUAVKXKUUDAYGBXFYGOZXJUUCUUFXFYGXIYLUUFVLUUFXHYKDUUFXGYJBXFYGVMVNVOVPV
      QVRWBUUBYIQDNZYLMYJDNZYLMYMUUCUUBUUGUUHYLUUBXBYFYOLZYFXSULZRZYGELZUUGUUHO
      XBXMUUAVSUUBYTUUKYEYSYTVTYFYOXSWAWCZUUBBEYGYEXDUUAYRTZUUEWDZYFYHXQYODEFYG
      XSGYBYHSZYOSZYCIWEWFWGUUBFWLNZYLDEFYIGUURSZIYEXPUUAXBXPXMYATTZUUBXPYKEMYL
      UURLUUTUUBBEYJUUNWHUURYKDEFGUUSIWMWIZUUBXPUUIUULYIELUUTUUBUUIUUJUUMWJUUOY
      FYHXQYOEFYGGYBUUPUUQWKWFWNUUBUURYLDEFYGGUUSIUUTUVAUUOWNWOWPWQXBXCXDXEYQUD
      WRXMKJBYHXQCYODEFUAXSGYBUUPUUQHIYCWSTWTXA $.

    $( An equivalent formulation of the basis predicate: a subset is a basis
       iff it is a minimal spanning set.  (Contributed by Mario Carneiro,
       25-Jun-2014.) $)
    islbs3 $p |- ( W e. LVec -> ( B e. J <-> ( B C_ V /\
      ( N ` B ) = V /\ A. s ( s C. B -> ( N ` s ) C. V ) ) ) ) $=
      ( vx wcel wss cfv wpss w3a wa wne syl2anc eqid cvv clvec wceq cv wi lbsss
      wal adantl lbssp clmod lveclmod 3ad2ant1 pssss sylan9ssr 3adant1 csca cur
      lspssv c0g cdr lvecdrng drngunz syl lbspss syl3an1 df-pss sylanbrc 3expia
      jca alrimiv 3jca csn cdif wn wral simpr1 simpr2 simplr1 ssdifssd cbs fvex
      eqeltri ssexg sylancl simplr3 difssd simpr neldifsn nelne1 necomd psseq1d
      psseq1 fveq2 imbi12d spcgv syl3c dfpss3 simprbi simplr2 clss ad2antrr cun
      adantrr lspcl ssun1 undif1 sseqtr4i lspssid simprr syl5ss lspssp eqsstr3d
      snssd unssd syl3anc expr mtod ralrimiva islbs2 adantr mpbir3and impbida
      wb ) EUAKZABKZADLZACMZDUBZFUCZANZYHCMZDNZUDZFUFZOZYCYDPZYEYGYMYDYEYCABDEG
      HUEZUGYDYGYCABCDEGHIUHUGYOYLFYCYDYIYKYCYDYIOZYJDLZYJDQZYKYQEUIKZYHDLZYRYC
      YDYTYIEUJZUKYDYIUUAYCYIYDYHADYHAULYPUMUNYHCDEGIUQRYCYTEUOMZUPMZUUCURMZQZP
      YDYIYSYCYTUUFUUBYCUUCUSKUUFUUCEUUCSZUTUUCUUDUUEUUESZUUDSZVAVBVHAYHUUDUUCB
      CDEUUEHIUUGUUIUUHGVCVDYJDVEVFVGVIVJYCYNPZYDYEYGJUCZAUUKVKZVLZCMZKZVMZJAVN
      ZYCYEYGYMVOYCYEYGYMVPUUJUUPJAUUJUUKAKZPZUUODUUNLZUUSUUNDNZUUTVMZUUSUUMTKZ
      YMUUMANZUVAUUSUUMDLZDTKUVCUUSADUULYEYGYMYCUURVQVRZDEVSMTGEVSVTWAUUMDTWBWC
      YEYGYMYCUURWDUUSUUMALUUMAQUVDUUSAUULWEUUSAUUMUUSUURUUKUUMKVMAUUMQUUJUURWF
      UUKAWGUUKAUUMWHWCWIUUMAVEVFYLUVDUVAUDFUUMTYHUUMUBZYIUVDYKUVAYHUUMAWKUVGYJ
      UUNDYHUUMCWLWJWMWNWOUVAUUNDLUVBUUNDWPWQVBUUJUURUUOUUTUUJUURUUOPZPZDYFUUNY
      EYGYMYCUVHWRUVIYTUUNEWSMZKZAUUNLYFUUNLYCYTYNUVHUUBWTZUVIYTUVEUVKUVLUUJUUR
      UVEUUOUVFXBZUVJUUMCDEGUVJSZIXCRUVIAUUMUULXAZUUNAAUULXAUVOAUULXDAUULXEXFUV
      IUUMUULUUNUVIYTUVEUUMUUNLUVLUVMUUMCDEGIXGRUVIUUKUUNUUJUURUUOXHXLXMXIUVJAU
      UNCEUVNIXJXNXKXOXPXQYCYDYEYGUUQOYBYNJABCDEGHIXRXSXTYA $.
  $}

  ${
    $d A x $.  $d S x $.  $d W x $.  $d x X $.  $d x J $.
    lbsacsbs.1 $e |- A = ( LSubSp ` W ) $.
    lbsacsbs.2 $e |- N = ( mrCls ` A ) $.
    lbsacsbs.3 $e |- X = ( Base ` W ) $.
    lbsacsbs.4 $e |- I = ( mrInd ` A ) $.
    lbsacsbs.5 $e |- J = ( LBasis ` W ) $.
    $( Being a basis in a vector space is equivalent to being a basis in the
       associated algebraic closure system.  Equivalent to ~ islbs2 .
       (Contributed by David Moews, 1-May-2017.) $)
    lbsacsbs $p |- ( W e. LVec -> ( S e. J <-> ( S e. I /\ ( N ` S ) = X ) ) )
      $=
      ( vx wcel cfv wceq wn wral w3a wa clvec wss clspn cv csn cdif eqid islbs2
      clmod lveclmod mrclsp syl fveq1d eqeq1d eleq2d notbid ralbidv 3anbi23d wb
      cmre lssmre ismri 3syl anbi1d 3anan32 syl6rbbr 3bitrd ) FUANZBDNBGUBZBFUC
      OZOZGPZMUDZBVMUEUFZVJOZNZQZMBRZSVIBEOZGPZVMVNEOZNZQZMBRZSZBCNZVTTZMBDVJGF
      JLVJUGZUHVHVLVTVRWDVIVHVKVSGVHBVJEVHFUINZVJEPFUJZAEVJFHWHIUKULZUMUNVHVQWC
      MBVHVPWBVHVOWAVMVHVNVJEWKUMUOUPUQURVHWGVIWDTZVTTWEVHWFWLVTVHWIAGUTONWFWLU
      SWJGAFJHVAMABCEGIKVBVCVDVIVTWDVEVFVG $.
  $}

  ${
    $d S x y z $.  $d T x y z $.  $d W x y z $.  $d x y z J $.
    lvecdim.1 $e |- J = ( LBasis ` W ) $.
    $( The dimension theorem for vector spaces: any two bases of the same
       vector space are equinumerous.  Proven by using ~ lssacsex and
       ~ lbsacsbs to show that being a basis for a vector space is equivalent
       to being a basis for the associated algebraic closure system, and then
       using ~ acsexdimd .  (Contributed by David Moews, 1-May-2017.) $)
    lvecdim $p |- ( ( W e. LVec /\ S e. J /\ T e. J ) -> S ~~ T ) $=
      ( vy vz vx wcel cfv cv csn cun wral wa eqid 3ad2ant1 simpld simprd wceq
      clvec w3a clss cmri cmrc cbs cacs cpw lssacsex simp2 lbsacsbs mpbid simp3
      cdif wb eqtr4d acsexdimd ) DUAIZACIZBCIZUBZFGDUCJZABVBUDJZVBUEJZDUFJZHVAV
      BVEUGJIZFKZHKZGKLMVDJIGVHVGLMVDJVHVDJUNNFVENHVEUHNZURUSVFVIOUTFGVBVDDVEHV
      BPZVDPZVEPZUIQZRVKVCPZVAVFVIVMSVAAVCIZAVDJZVETZVAUSVOVQOZURUSUTUJURUSUSVR
      UOUTVBAVCCVDDVEVJVKVLVNEUKQULZRVABVCIZBVDJZVETZVAUTVTWBOZURUSUTUMURUSUTWC
      UOUTVBBVCCVDDVEVJVKVLVNEUKQULZRVAVPVEWAVAVOVQVSSVAVTWBWDSUPUQ $.
  $}

  ${
    $d x J $.  $d m n r u v w x y ph $.  $d s t u w x y S $.  $d m n r v w T $.
    $d x z C $.  $d m n u w x y z N $.  $d u w x z V $.  $d m n r u v w x W $.
    $d m n s t u x y z A $.
    lbsext.v $e |- V = ( Base ` W ) $.
    lbsext.j $e |- J = ( LBasis ` W ) $.
    lbsext.n $e |- N = ( LSpan ` W ) $.
    lbsext.w $e |- ( ph -> W e. LVec ) $.
    lbsext.c $e |- ( ph -> C C_ V ) $.
    lbsext.x $e |- ( ph -> A. x e. C -. x e. ( N ` ( C \ { x } ) ) ) $.
    lbsext.s $e |- S = { z e. ~P V | ( C C_ z /\
                         A. x e. z -. x e. ( N ` ( z \ { x } ) ) ) } $.
    $( Lemma for ~ lbsext .  The set ` S ` is the set of all linearly
       independent sets containing ` C ` ; we show here that it is nonempty.
       (Contributed by Mario Carneiro, 25-Jun-2014.) $)
    lbsextlem1 $p |- ( ph -> S =/= (/) ) $=
      ( wcel wss cv cfv c0 wne cpw csn cdif wn wral cbs cvv fvex eqeltri sylibr
      elpw2 ssid jctil wceq sseq2 difeq1 fveq2d eleq2d notbid raleqbi1dv elrab2
      wa anbi12d sylanbrc ne0i syl ) ADEQZEUAUBADHUCZQZDDRZBSZDVMUDZUEZGTZQZUFZ
      BDUGZVDZVIADHRVKNDHHIUHTUIJIUHUJUKUMULAVSVLODUNUODCSZRZVMWAVNUEZGTZQZUFZB
      WAUGZVDVTCDVJEWADUPZWBVLWGVSWADDUQWFVRBWADWHWEVQWHWDVPVMWHWCVOGWADVNURUSU
      TVAVBVEPVCVFEDVGVH $.

    ${
      lbsext.p $e |- P = ( LSubSp ` W ) $.
      lbsext.a $e |- ( ph -> A C_ S ) $.
      lbsext.z $e |- ( ph -> A =/= (/) ) $.
      lbsext.r $e |- ( ph -> [C.] Or A ) $.
      lbsext.t $e |- T = U_ u e. A ( N ` ( u \ { x } ) ) $.
      $( Lemma for ~ lbsext .  Since ` A ` is a chain (actually, we only need
         it to be closed under binary union), the union ` T ` of the spans of
         each individual element of ` A ` is a subspace, and it contains all of
         ` U. A ` (except for our target vector ` x ` - we are trying to make
         ` x ` a linear combination of all the other vectors in some set from
         ` A ` ).  (Contributed by Mario Carneiro, 25-Jun-2014.) $)
      lbsextlem2 $p |- ( ph -> ( T e. P /\ ( U. A \ { x } ) C_ T ) ) $=
        ( vr vv vw vm vn vy wcel cuni cv csn cdif wss csca cfv cbs cplusg cvsca
        eqidd wceq a1i clss ciun wral wa clmod clvec lveclmod syl adantr cpw wn
        crab ssrab2 eqsstri syl6ss sselda elpwid lspssv syl2anc ralrimiva iunss
        ssdifssd sylibr syl5eqss c0 wrex lspcl lssn0 r19.2z iunn0 sylib eqnetrd
        wne eleq2i eliun weq difeq1 fveq2d eleq2d cbvrexv 3bitri anbi12i reeanv
        co bitr4i w3a cun crpss wor simp1l simp2 sorpssun elssuni sspwuni sstrd
        simp1r ssun1 ssdif mp1i lspss syl3anc simp3l sseldd ssun2 eqid syl13anc
        simp3r lsscl rspcev syl6eleqr 3expia rexlimdvva syl5bi exp4b 3imp2 mpd
        islssd eldifi adantl eldifn ad2antlr eldif lspssid adantlr sseld mpan2d
        syl5bir reximdva eluni2 3imtr4g ex ssrdv syl6sseqr jca ) AIGULEUMZBUNZU
        OZUPZIUQAUFMURUSZUTUSZMVAUSZGMVBUSZIUVDLMUGUHAUVDVCAUVEVCLMUTUSVDANVEAU
        VFVCAUVGVCGMVFUSVDAUAVEAIDEDUNZUVBUPZKUSZVGZLUEAUVJLUQZDEVHUVKLUQAUVLDE
        AUVHEULZVIZMVJULZUVILUQZUVLAUVOUVMAMVKULUVOQMVLVMZVNZUVNUVHLUVBUVNUVHLA
        ELVOZUVHAEHUVSUBHFCUNZUQUVAUVTUVBUPKUSULVPBUVTVHVIZCUVSVQUVSTUWACUVSVRV
        SVTZWAWBWGZUVIKLMNPWCWDWEDEUVJLWFWHWIAIUVKWJIUVKVDAUEVEAUVJWJWRZDEWKZUV
        KWJWRAEWJWRUWDDEVHUWEUCAUWDDEUVNUVJGULZUWDUVNUVOUVPUWFUVRUWCGUVIKLMNUAP
        WLWDGUVJMUAWMVMWEUWDDEWNWDDEUVJWOWPWQAUFUNZUVEULZUGUNZIULZUHUNZIULZUWGU
        WIUVGXIUWKUVFXIZIULZAUWHUWJUWLUWNUWJUWLVIZUWIUIUNZUVBUPZKUSZULZUWKUJUNZ
        UVBUPZKUSZULZVIZUJEWKUIEWKZAUWHVIZUWNUWOUWSUIEWKZUXCUJEWKZVIUXEUWJUXGUW
        LUXHUWJUWIUVKULUWIUVJULZDEWKUXGIUVKUWIUEWSDUWIEUVJWTUXIUWSDUIEDUIXAZUVJ
        UWRUWIUXJUVIUWQKUVHUWPUVBXBXCXDXEXFUWLUWKUVKULUWKUVJULZDEWKUXHIUVKUWKUE
        WSDUWKEUVJWTUXKUXCDUJEDUJXAZUVJUXBUWKUXLUVIUXAKUVHUWTUVBXBXCXDXEXFXGUWS
        UXCUIUJEEXHXJUXFUXDUWNUIUJEEUXFUWPEULUWTEULVIZUXDUWNUXFUXMUXDXKZUWMUVKI
        UXNUWMUVJULZDEWKZUWMUVKULUXNUWPUWTXLZEULZUWMUXQUVBUPZKUSZULZUXPUXNEXMXN
        ZUXMUXRUXNAUYBAUWHUXMUXDXOZUDVMUXFUXMUXDXPEUWPUWTXQWDZUXNUXTGULZUWHUWIU
        XTULUWKUXTULUYAUXNUVOUXSLUQZUYEUXNAUVOUYCUVQVMZUXNUXQLUVBUXNUXQUUTLUXNU
        XRUXQUUTUQUYDUXQEXRVMUXNAUUTLUQZUYCAEUVSUQUYHUWBELXSWPVMXTWGZGUXSKLMNUA
        PWLWDAUWHUXMUXDYAUXNUWRUXTUWIUXNUVOUYFUWQUXSUQZUWRUXTUQUYGUYIUWPUXQUQUY
        JUXNUWPUWTYBUWPUXQUVBYCYDUWQUXSKLMNPYEYFUXFUXMUWSUXCYGYHUXNUXBUXTUWKUXN
        UVOUYFUXAUXSUQZUXBUXTUQUYGUYIUWTUXQUQUYKUXNUWTUWPYIUWTUXQUVBYCYDUXAUXSK
        LMNPYEYFUXFUXMUWSUXCYLYHUVEUVFGUVGUXTUVDMUWIUWKUWGUVDYJUVEYJUVFYJUVGYJU
        AYMYKUXOUYADUXQEUVHUXQVDZUVJUXTUWMUYLUVIUXSKUVHUXQUVBXBXCXDYNWDDUWMEUVJ
        WTWHUEYOYPYQYRYSYTUUBAUVCUVKIAUKUVCUVKAUKUNZUVCULZUYMUVKULZAUYNVIZUYMUU
        TULZUYOUYNUYQAUYMUUTUVBUUCUUDUYPUYMUVHULZDEWKUYMUVJULZDEWKUYQUYOUYPUYRU
        YSDEUYPUVMVIZUYRUYMUVBULVPZUYSUYNVUAAUVMUYMUUTUVBUUEUUFUYRVUAVIUYMUVIUL
        UYTUYSUYMUVHUVBUUGUYTUVIUVJUYMAUVMUVIUVJUQZUYNUVNUVOUVPVUBUVRUWCUVIKLMN
        PUUHWDUUIUUJUULUUKUUMDUYMEUUNDUYMEUVJWTUUOUUAUUPUUQUEUURUUS $.

      $( Lemma for ~ lbsext .  A chain in ` S ` has an upper bound in ` S ` .
         (Contributed by Mario Carneiro, 25-Jun-2014.) $)
      lbsextlem3 $p |- ( ph -> U. A e. S ) $=
        ( vy cuni cpw wcel wss cv csn cdif cfv wn wral wa ssrab2 eqsstri syl6ss
        crab sspwuni sylib cbs cvv fvex eqeltri elpw2 sylibr cint ssintub simpl
        wi a1i ss2rabi intss syl syl5ss c0 wne intssuni sstrd wrex eluni2 clmod
        w3a cun simpll1 clvec lveclmod crpss wor simpll2 simplr sorpssun sseldd
        syl12anc sseldi elpwid ssdifssd ssun2 ssdif mp1i lspss simpr wceq sseq2
        syl3anc difeq1 fveq2d eleq2d notbid anbi12d elrab2 simprbi simprd elun1
        raleqbi1dv simpll3 rsp sylc pm2.65da nrexdv ciun lbsextlem2 lssss lspid
        simpld syl2anc sseqtrd 3ad2ant1 syl6sseq sseld eliun syl6ib mtod syl5bi
        rexlimdv3a ralrimiv jca sylanbrc ) AEUGZLUHZUIZFUUBUJZBUKZUUBUUFULZUMZK
        UNZUIZUOZBUUBUPZUQZUUBHUIAUUBLUJZUUDAEUUCUJUUNAEHUUCUBHFCUKZUJZUUFUUOUU
        GUMZKUNZUIZUOZBUUOUPZUQZCUUCVAZUUCTUVBCUUCURUSZUTELVBVCUUBLLMVDUNVENMVD
        VFVGVHVIAUUEUULAFEVJZUUBAFUUPCUUCVAZVJZUVECFUUCVKAEUVFUJUVGUVEUJAEHUVFU
        BHUVCUVFTUVBUUPCUUCUVBUUPVMUUOUUCUIUUPUVAVLVNVOUSUTEUVFVPVQVRAEVSVTUVEU
        UBUJUCEWAVQWBAUUKBUUBUUFUUBUIUUFUFUKZUIZUFEWCAUUKUFUUFEWDAUVIUUKUFEAUVH
        EUIZUVIWFZUUJUUFDUKZUUGUMZKUNZUIZDEWCZUVKUVODEUVKUVLEUIZUQZUVOUUFUVHUVL
        WGZUUGUMZKUNZUIZUVRUVOUQZUVNUWAUUFUWCMWEUIZUVTLUJUVMUVTUJZUVNUWAUJUWCAU
        WDAUVJUVIUVQUVOWHZAMWIUIUWDQMWJVQZVQUWCUVSLUUGUWCUVSLUWCHUUCUVSUVDUWCEH
        UVSUWCAEHUJUWFUBVQUWCEWKWLZUVJUVQUVSEUIUWCAUWHUWFUDVQAUVJUVIUVQUVOWMUVK
        UVQUVOWNEUVHUVLWOWQWPZWRWSWTUVLUVSUJUWEUWCUVLUVHXAUVLUVSUUGXBXCUVMUVTKL
        MNPXDXHUVRUVOXEWPUWCUWBUOZBUVSUPZUUFUVSUIZUWJUWCUVSHUIZUWKUWIUWMFUVSUJZ
        UWKUWMUVSUUCUIUWNUWKUQZUVBUWOCUVSUUCHUUOUVSXFZUUPUWNUVAUWKUUOUVSFXGUUTU
        WJBUUOUVSUWPUUSUWBUWPUURUWAUUFUWPUUQUVTKUUOUVSUUGXIXJXKXLXRXMTXNXOXPVQU
        WCUVIUWLAUVJUVIUVQUVOXSUUFUVHUVLXQVQUWJBUVSXTYAYBYCUVKUUJUUFDEUVNYDZUIU
        VPUVKUUIUWQUUFUVKUUIIUWQAUVJUUIIUJUVIAUUIIKUNZIAUWDILUJZUUHIUJZUUIUWRUJ
        UWGAIGUIZUWSAUXAUWTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEYEZYHZGILMNUAYFVQAUXAU
        WTUXBXPUUHIKLMNPXDXHAUWDUXAUWRIXFUWGUXCGIKMUAPYGYIYJYKUEYLYMDUUFEUVNYNY
        OYPYRYQYSYTUVBUUMCUUBUUCHUUOUUBXFZUUPUUEUVAUULUUOUUBFXGUUTUUKBUUOUUBUXD
        UUSUUJUXDUURUUIUUFUXDUUQUUHKUUOUUBUUGXIXJXKXLXRXMTXNUUA $.
    $}

    $d s ph $.
    lbsext.k $e |- ( ph -> ~P V e. dom card ) $.
    $( Lemma for ~ lbsext . ~ lbsextlem3 satisfies the conditions for the
       application of Zorn's lemma ~ zorn (thus invoking AC), and so there is a
       maximal linearly independent set extending ` C ` .  Here we prove that
       such a set is a basis.  (Contributed by Mario Carneiro, 25-Jun-2014.) $)
    lbsextlem4 $p |- ( ph -> E. s e. J C C_ s ) $=
      ( wss wcel vt vy vu vw cv wpss wn wral wrex ccrd cdm c0 wne crpss wor w3a
      cuni wi wal cpw csn cdif cfv crab ssrab2 eqsstri ssnum sylancl lbsextlem1
      wa clss ciun clvec adantr eqid simpr1 simpr2 simpr3 lbsextlem3 ex alrimiv
      zornn0g syl3anc wceq simprl weq sseq2 difeq1 fveq2d eleq2d notbid anbi12d
      raleqbi1dv elrab2 sylib simpld elpwid clmod lveclmod lspssv syl2anc ssun1
      syl cun a1i wel ssun2 sselii lspssid eldifn adantl ssneldd nelne1 sylancr
      vex snid necomd df-pss sylanbrc eldifi snssd unssd cbs fvex eqeltri elpw2
      cvv sylibr simprd syl6ss ad2antrr ssdifssd adantrr simprrr simprrl nelne2
      cin eleqtrd sylc jca elsni necon3ai disjsn disj3 uneq2d difundir syl6reqr
      rsp eldifd lspsolv syl13anc undif1 syl5eq expr mtod imnan ralrimiv difssd
      ssequn2 lspss id difeq2d difun2 syl6eq eleq12d ralsn ralun simplrr psseq2
      sneq rspcv pm2.65da eq0rdv ssdif0 eqssd wb islbs2 mpbir3and reximdv2 mpd
      ) AJUEZUAUEZUFZUGZUAEUHZJEUIZDUWASZJFUIAEUJUKZTZEULUMUBUEZESZUWJULUMZUWJU
      NUOZUPZUWJUQETZURZUBUSUWFAHUTZUWHTEUWQSUWIREDCUEZSZBUEZUWRUWTVAZVBZGVCZTZ
      UGZBUWRUHZVJZCUWQVDUWQQUXGCUWQVEVFUWQEVGVHABCDEFGHIKLMNOPQVIAUWPUBAUWNUWO
      AUWNVJBCUCUWJDIVKVCZEUCUWJUCUEUXAVBGVCVLZFGHIKLMAIVMTZUWNNVNADHSUWNOVNAUW
      TDUXAVBGVCTUGBDUHUWNPVNQUXHVOZAUWKUWLUWMVPAUWKUWLUWMVQAUWKUWLUWMVRUXIVOVS
      VTWAJUAUBEWBWCAUWEUWGJEFAUWAETZUWEVJZUWAFTZUWGVJAUXMVJZUXNUWGUXOUXNUWAHSZ
      UWAGVCZHWDZUWTUWAUXAVBZGVCZTZUGZBUWAUHZUXOUWAHUXOUWAUWQTZUWGUYCVJZUXOUXLU
      YDUYEVJAUXLUWEWEUXGUYECUWAUWQECJWFZUWSUWGUXFUYCUWRUWADWGUXEUYBBUWRUWAUYFU
      XDUYAUYFUXCUXTUWTUYFUXBUXSGUWRUWAUXAWHWIWJWKWMWLQWNWOZWPWQZUXOUXQHUXOIWRT
      ZUXPUXQHSAUYIUXMAUXJUYINIWSXCVNZUYHUWAGHIKMWTXAUXOHUXQVBZULWDHUXQSUXOUDUY
      KUXOUDUEZUYKTZUWAUWAUYLVAZXDZUFZUXOUYMVJZUWAUYOSZUWAUYOUMUYPUYRUYQUWAUYNX
      BZXEUYQUYOUWAUYQUYLUYOTUDJXFUGZUYOUWAUMUYNUYOUYLUYNUWAXGUYLUDXOZXPXHUYQUW
      AUXQUYLUXOUWAUXQSZUYMUXOUYIUXPVUBUYJUYHUWAGHIKMXIXAVNUYMUYLUXQTZUGUXOUYLH
      UXQXJXKZXLZUYLUYOUWAXMXNXQUWAUYOXRXSUYQUYOETZUWEUYPUGZUYQUYOUWQTZDUYOSZUW
      TUYOUXAVBZGVCZTZUGZBUYOUHZVJZVUFUYQUYOHSVUHUYQUWAUYNHUXOUXPUYMUYHVNUYQUYL
      HUYMUYLHTZUXOUYLHUXQXTXKZYAYBUYOHHIYCVCYGKIYCYDYEYFYHUYQVUIVUNUYQDUWAUYOU
      XOUWGUYMUXOUWGUYCUXOUYDUYEUYGYIZWPZVNUYSYJUYQVUMBUWAUHVUMBUYNUHZVUNUYQVUM
      BUWAUYQBJXFZVULVJZUGVVAVUMURUYQVVBVUCVUDUXOUYMVVBVUCUXOUYMVVBVJZVJZUYLUXS
      UXAXDZGVCZUXQVVDUXJUXSHSVUPUWTUXSUYNXDZGVCZUXTVBTUYLVVFTAUXJUXMVVCNYKVVDU
      WAHUXAUXOUXPVVCUYHVNYLUXOUYMVUPVVBVUQYMVVDUWTVVHUXTVVDUWTVUKVVHUXOUYMVVAV
      ULYNVVDVUJVVGGVVDVVGUXSUYNUXAVBZXDVUJVVDUYNVVIUXSVVDUYNUXAYQULWDZUYNVVIWD
      VVDUWTUYNTZUGZVVJVVDUWTUYLUMZVVLVVDVVAUYTVVMUXOUYMVVAVULYOZUXOUYMUYTVVBVU
      EYMUWTUYLUWAYPXAVVKUWTUYLUWTUYLUUAUUBXCUYNUWTUUCYHUYNUXAUUDWOUUEUWAUYNUXA
      UUFUUGWIYRVVDUYCVVAUYBUXOUYCVVCUXOUWGUYCVURYIZVNVVNUYBBUWAUUHYSUUIUXSUXHG
      HIUWTUYLKUXKMUUJUUKVVDVVEUWAGVVDVVEUWAUXAXDZUWAUWAUXAUULVVDUXAUWASVVPUWAW
      DVVDUWTUWAVVNYAUXAUWAUUSWOUUMWIYRUUNUUOVVAVULUUPYHUUQUYQUYLUWAUYNVBZGVCZT
      ZUGZVUTUYQVVRUXQUYLUXOVVRUXQSZUYMUXOUYIUXPVVQUWASVWAUYJUYHUXOUWAUYNUURVVQ
      UWAGHIKMUUTWCVNVUDXLVUMVVTBUYLVUABUDWFZVULVVSVWBUWTUYLVUKVVRVWBUVAVWBVUJV
      VQGVWBVUJUYOUYNVBVVQVWBUXAUYNUYOUWTUYLUVJUVBUWAUYNUVCUVDWIUVEWKUVFYHVUMBU
      WAUYNUVGXAYTUXGVUOCUYOUWQEUWRUYOWDZUWSVUIUXFVUNUWRUYODWGUXEVUMBUWRUYOVWCU
      XDVULVWCUXCVUKUWTVWCUXBVUJGUWRUYOUXAWHWIWJWKWMWLQWNXSAUXLUWEUYMUVHUWDVUGU
      AUYOEUWBUYOWDUWCUYPUWBUYOUWAUVIWKUVKYSUVLUVMHUXQUVNYHUVOVVOUXOUXJUXNUXPUX
      RUYCUPUVPAUXJUXMNVNBUWAFGHIKLMUVQXCUVRVUSYTVTUVSUVT $.
  $}

  ${
    $d s x y z C $.  $d s y J $.  $d s x y z N $.  $d s y z V $.  $d s x y W $.
    lbsex.j $e |- J = ( LBasis ` W ) $.
    ${
      lbsex.v $e |- V = ( Base ` W ) $.
      lbsex.n $e |- N = ( LSpan ` W ) $.
      $( For any linearly independent subset ` C ` of ` V ` , there is a basis
         containing the vectors in ` C ` .  (Contributed by Mario Carneiro,
         17-May-2015.) $)
      lbsextg $p |- ( ( ( W e. LVec /\ ~P V e. dom card ) /\ C C_ V /\
                       A. x e. C -. x e. ( N ` ( C \ { x } ) ) ) ->
                     E. s e. J C C_ s ) $=
        ( vy vz wcel wa wss cv cdif cfv wn wral clvec cpw ccrd cdm csn w3a crab
        simp1l simp2 simp3 weq sneq difeq2d fveq2d eleq12d notbid cbvralv sylib
        id wb anbi2i a1i rabbiia simp1r lbsextlem4 ) FUAMZEUBZUCUDMZNZBEOZAPZBV
        KUEZQZDRZMZSZABTZUFZKLBBLPZOZVKVSVLQZDRZMZSZAVSTZNZLVGUGCDEFGIHJVFVHVJV
        QUHVIVJVQUIVRVQKPZBWGUEZQZDRZMZSZKBTVIVJVQUJVPWLAKBAKUKZVOWKWMVKWGVNWJW
        MUSZWMVMWIDWMVLWHBVKWGULZUMUNUOUPUQURWFVTWGVSWHQZDRZMZSZKVSTZNZLVGWFXAU
        TVSVGMWEWTVTWDWSAKVSWMWCWRWMVKWGWBWQWNWMWAWPDWMVLWHVSWOUMUNUOUPUQVAVBVC
        VFVHVJVQVDVE $.

      $( For any linearly independent subset ` C ` of ` V ` , there is a basis
         containing the vectors in ` C ` .  (Contributed by Mario Carneiro,
         25-Jun-2014.)  (Revised by Mario Carneiro, 17-May-2015.) $)
      lbsext $p |- ( ( W e. LVec /\ C C_ V /\
                       A. x e. C -. x e. ( N ` ( C \ { x } ) ) ) ->
                     E. s e. J C C_ s ) $=
        ( clvec wcel cpw ccrd cdm wss cv cfv cvv cbs wa csn cdif wral wrex fvex
        wn eqeltri pwex numth3 ax-mp jctr lbsextg syl3an1 ) FKLZUOEMZNOLZUABEPA
        QZBURUBUCDRLUGABUDBGQPGCUEUOUQUPSLUQEEFTRSIFTUFUHUIUPSUJUKULABCDEFGHIJU
        MUN $.
    $}

    $( Every vector space has a basis.  This theorem is an AC equivalent; this
       is the forward implication.  (Contributed by Mario Carneiro,
       17-May-2015.) $)
    lbsexg $p |- ( ( CHOICE /\ W e. LVec ) -> J =/= (/) ) $=
      ( vs vx wac clvec wcel wa c0 cv wss wrex wne cbs cfv cpw ccrd cvv eqid id
      cdm fvex pwex wceq dfac10 biimpi syl5eleqr csn cdif clspn wn wral lbsextg
      0ss ral0 mp3an23 syl2anr rexn0 syl ) FBGHZIJDKLZDAMZAJNVAVABOPZQZRUBZHZVC
      FVAUAFVESVFVDBOUCUDFVFSUEUFUGUHVAVGIJVDLEKZJVHUIUJBUKPZPHULZEJUMVCVDUOVJE
      UPEJAVIVDBDCVDTVITUNUQURVBDAUSUT $.

    $( Every vector space has a basis.  This theorem is an AC equivalent.
       (Contributed by Mario Carneiro, 25-Jun-2014.) $)
    lbsex $p |- ( W e. LVec -> J =/= (/) ) $=
      ( wac clvec wcel c0 wne axac3 lbsexg mpan ) DBEFAGHIABCJK $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y G $.  $d x y K $.  $d x y ph $.
    $d x y L $.  $d x y P $.
    lvecprop2d.b1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lvecprop2d.b2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lvecprop2d.f $e |- F = ( Scalar ` K ) $.
    lvecprop2d.g $e |- G = ( Scalar ` L ) $.
    lvecprop2d.p1 $e |- ( ph -> P = ( Base ` F ) ) $.
    lvecprop2d.p2 $e |- ( ph -> P = ( Base ` G ) ) $.
    lvecprop2d.1 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lvecprop2d.2 $e |- ( ( ph /\ ( x e. P /\ y e. P ) ) ->
      ( x ( +g ` F ) y ) = ( x ( +g ` G ) y ) ) $.
    lvecprop2d.3 $e |- ( ( ph /\ ( x e. P /\ y e. P ) ) ->
      ( x ( .r ` F ) y ) = ( x ( .r ` G ) y ) ) $.
    lvecprop2d.4 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    $( If two structures have the same components (properties), one is a left
       vector space iff the other one is.  This version of ~ lvecpropd also
       breaks up the components of the scalar ring.  (Contributed by Mario
       Carneiro, 27-Jun-2015.) $)
    lvecprop2d $p |- ( ph -> ( K e. LVec <-> L e. LVec ) ) $=
      ( wcel clmod cdr wa clvec lmodprop2d drngpropd anbi12d islvec 3bitr4g ) A
      HUATZFUBTZUCIUATZGUBTZUCHUDTIUDTAUJULUKUMABCDEFGHIJKLMNOPQRSUEABCEFGNOQRU
      FUGFHLUHGIMUHUI $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y L $.  $d x y P $.  $d x y ph $.
    lvecpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lvecpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lvecpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lvecpropd.4 $e |- ( ph -> F = ( Scalar ` K ) ) $.
    lvecpropd.5 $e |- ( ph -> F = ( Scalar ` L ) ) $.
    lvecpropd.6 $e |- P = ( Base ` F ) $.
    lvecpropd.7 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    $( If two structures have the same components (properties), one is a left
       vector space iff the other one is.  (Contributed by Mario Carneiro,
       27-Jun-2015.) $)
    lvecpropd $p |- ( ph -> ( K e. LVec <-> L e. LVec ) ) $=
      ( clmod wcel csca cfv cdr wa clvec lmodpropd eqtr3d eleq1d anbi12d islvec
      eqid 3bitr4g ) AGPQZGRSZTQZUAHPQZHRSZTQZUAGUBQHUBQAUJUMULUOABCDEFGHIJKLMN
      OUCAUKUNTAFUKUNLMUDUEUFUKGUKUHUGUNHUNUHUGUI $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Ideals
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The subring algebra; ideals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c subringAlg $.
  $c ringLMod $.
  $c RSpan $. $( Ring span function $)
  $c LIdeal $.

  $( Extend class notation with the subring algebra generator. $)
  csra $a class subringAlg $.

  $( Extend class notation with the left module induced by a ring over
     itself. $)
  crglmod $a class ringLMod $.

  $( Ring left-ideal function. $)
  clidl $a class LIdeal $.

  $( Ring span function. $)
  crsp $a class RSpan $.

  ${
    $d a w s t $.
    $( Given any subring of a ring, we can construct a left-algebra by
       regarding the elements of the subring as scalars and the ring itself as
       a set of vectors.  (Contributed by Mario Carneiro, 27-Nov-2014.) $)
    df-sra $a |- subringAlg = ( w e. _V |-> ( s e. ~P ( Base ` w ) |->
        ( ( w sSet <. ( Scalar ` ndx ) , ( w |`s s ) >. )
              sSet <. ( .s ` ndx ) , ( .r ` w ) >. ) ) ) $.

    $( Every ring can be viewed as a left module over itself.  (Contributed by
       Stefan O'Rear, 6-Dec-2014.) $)
    df-rgmod $a |- ringLMod = ( w e. _V |->
        ( ( subringAlg ` w ) ` ( Base ` w ) ) ) $.

    $( Define the class of left ideals of a given ring.  An ideal is a
       submodule of the ring viewed as a module over itself.  (Contributed by
       Stefan O'Rear, 31-Mar-2015.) $)
    df-lidl $a |- LIdeal = ( LSubSp o. ringLMod ) $.

    $( Define the linear span function in a ring (Ideal generator).
       (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    df-rsp $a |- RSpan = ( LSpan o. ringLMod ) $.
  $}

  ${
    $d s S $.  $d s V $.  $d s w W $.
    $( Lemma for ~ srabase through ~ sravsca .  (Contributed by Mario Carneiro,
       27-Nov-2014.) $)
    sraval $p |- ( ( W e. V /\ S C_ ( Base ` W ) ) ->
        ( ( subringAlg ` W ) ` S ) = ( ( W
        sSet <. ( Scalar ` ndx ) , ( W |`s S ) >. )
        sSet <. ( .s ` ndx ) , ( .r ` W ) >. ) ) $=
      ( vs vw wcel cbs cfv wa cnx cv cress cop csts cmulr cpw cvv wceq opeq2d
      co wss csca cvsca csra cmpt adantr fveq2 pweqd id oveq1 oveq12d mpteq12dv
      elex df-sra fvex pwex mptex fvmpt syl simpr oveq2d oveq1d sylibr ovex a1i
      elpw2 fvmptd ) CBFZACGHZUAZIZDACJUBHZCDKZLTZMZNTZJUCHZCOHZMZNTZCVLCALTZMZ
      NTZVSNTZVIPZCUDHZQVKCQFZWFDWEVTUEZRVHWGVJCBUMUFECDEKZGHZPZWIVLWIVMLTZMZNT
      ZVQWIOHZMZNTZUEWHQUDWICRZDWKWQWEVTWRWJVIWICGUGUHWRWNVPWPVSNWRWICWMVONWRUI
      WRWLVNVLWICVMLUJSUKWRWOVRVQWICOUGSUKULEDUNDWEVTVICGUOZUPUQURUSVKVMARZIZVP
      WCVSNXAVOWBCNXAVNWAVLXAVMACLVKWTUTVASVAVBVKVJAWEFVHVJUTAVIWSVFVCWDQFVKWCV
      SNVDVEVG $.

    srapart.a $e |- ( ph -> A = ( ( subringAlg ` W ) ` S ) ) $.
    srapart.s $e |- ( ph -> S C_ ( Base ` W ) ) $.
    ${
      sralem.1 $e |- E = Slot N $.
      sralem.2 $e |- N e. NN $.
      sralem.3 $e |- ( N < 5 \/ 6 < N ) $.
      $( Lemma for ~ srabase and similar theorems.  (Contributed by Mario
         Carneiro, 4-Oct-2015.) $)
      sralem $p |- ( ph -> ( E ` W ) = ( E ` A ) ) $=
        ( cfv wceq wne c5 clt wbr c6 5re c0 cvv wcel wa cnx csca cress cop csts
        co cvsca cmulr adantl cbs wss sraval sylan2 eqtrd fveq2d ndxid wo nnrei
        csra ltnei necomd 5lt6 6re lttri mpan ax-mp ndxarg scandx neeq12i mpbir
        syl jaoi setsnid mpan2 vscandx eqtri syl6reqr wn str0 adantr fveq1d 0fv
        fvprc syl6eq sylan9eqr 3eqtr4a pm2.61ian ) FUAUBZAFDLZBDLZMWKAUCZWMFUDU
        ELZFCUFUIZUGUHUIZUDUJLZFUKLZUGUHUIZDLZWLWNBWTDWNBCFVBLZLZWTABXCMWKGULAW
        KCFUMLUNXCWTMHCUAFUOUPUQURWLWQDLXAWPWODFDEIJUSZUDDLZWONEONZEOPQZREPQZUT
        ZXFKXGXFXHXGOEEOEJVAZSVCVDXHOEPQZXFORPQZXHXKVEORESVFXJVGVHOESXJVCVNVOVI
        XEEWOODEIJVJZVKVLVMVPWSWRDWQXDXEWRNERNZXIXNKXGXNXHXGREXGERPQZRENXGXLXOV
        EEORXJSVFVGVQERXJVFVCVNVDREVFXJVCVOVIXEEWRRXMVRVLVMVPVSVTWKWAZAUCZTTDLW
        LWMDEIWBXPWLTMAFDWFWCXQBTDAXPBXCTGXPXCCTLTXPCXBTFVBWFWDCWEWGWHURWIWJ $.
    $}

    $( Base set of a subring algebra.  (Contributed by Stefan O'Rear,
       27-Nov-2014.)  (Revised by Mario Carneiro, 4-Oct-2015.) $)
    srabase $p |- ( ph -> ( Base ` W ) = ( Base ` A ) ) $=
      ( cbs c1 df-base 1nn c5 clt wbr c6 1lt5 orci sralem ) ABCGHDEFIJHKLMNHLMO
      PQ $.

    $( Additive operation of a subring algebra.  (Contributed by Stefan O'Rear,
       27-Nov-2014.)  (Revised by Mario Carneiro, 4-Oct-2015.) $)
    sraaddg $p |- ( ph -> ( +g ` W ) = ( +g ` A ) ) $=
      ( cplusg c2 df-plusg 2nn c5 clt wbr c6 2lt5 orci sralem ) ABCGHDEFIJHKLMN
      HLMOPQ $.

    $( Multiplicative operation of a subring algebra.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro, 4-Oct-2015.) $)
    sramulr $p |- ( ph -> ( .r ` W ) = ( .r ` A ) ) $=
      ( cmulr c3 df-mulr 3nn c5 clt wbr c6 3lt5 orci sralem ) ABCGHDEFIJHKLMNHL
      MOPQ $.

    $( The set of scalars of a subring algebra.  (Contributed by Stefan O'Rear,
       27-Nov-2014.)  (Revised by Mario Carneiro, 4-Oct-2015.) $)
    srasca $p |- ( ph -> ( W |`s S ) = ( Scalar ` A ) ) $=
      ( cvv wcel cress co csca cfv wceq wa cnx cop scaid c5 c6 c0 cvsca wne 5re
      csts cmulr 5lt6 ltneii scandx vscandx neeq12i mpbir setsnid setsid sylan2
      ovex a1i csra adantl cbs wss sraval eqtrd fveq2d 3eqtr4a reldmress ovprc1
      wn str0 adantr fvprc fveq1d 0fv syl6eq sylan9eqr pm2.61ian ) DGHZADCIJZBK
      LZMVPANZDOKLZVQPUDJZKLZWAOUALZDUELZPUDJZKLVQVRWDWCKWAQVTWCUBRSUBRSUCUFUGV
      TRWCSUHUIUJUKULAVPVQGHZVQWBMWFADCIUOUPGVQKGDQUMUNVSBWEKVSBCDUQLZLZWEABWHM
      VPEURAVPCDUSLUTWHWEMFCGDVAUNVBVCVDVPVGZANZTTKLVQVRKVTQVHWIVQTMADCIVEVFVIW
      JBTKAWIBWHTEWIWHCTLTWICWGTDUQVJVKCVLVMVNVCVDVO $.

    $( The scalar product operation of a subring algebra.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro,
       4-Oct-2015.) $)
    sravsca $p |- ( ph -> ( .r ` W ) = ( .s ` A ) ) $=
      ( cvv wcel cmulr cfv cvsca wceq wa cnx co cop csts csra fveq2d c0 cbs wss
      csca cress adantl sraval sylan2 eqtrd ovex fvex vscaid setsid syl6reqr wn
      mp2an str0 fvprc adantr fveq1d 0fv syl6eq sylan9eqr 3eqtr4a pm2.61ian ) D
      GHZADIJZBKJZLVEAMZVGDNUCJDCUDOPZQOZNKJZVFPQOZKJZVFVHBVLKVHBCDRJZJZVLABVOL
      VEEUEAVECDUAJUBVOVLLFCGDUFUGUHSVJGHVFGHVFVMLDVIQUIDIUJGVFKGVJUKULUOUMVEUN
      ZAMZTTKJVFVGKVKUKUPVPVFTLADIUQURVQBTKAVPBVOTEVPVOCTJTVPCVNTDRUQUSCUTVAVBS
      VCVD $.

    $( Topology component of a subring algebra.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    sratset $p |- ( ph -> ( TopSet ` W ) = ( TopSet ` A ) ) $=
      ( cts c9 df-tset 9nn c6 clt wbr c5 6lt9 olci sralem ) ABCGHDEFIJKHLMHNLMO
      PQ $.

    $( Topology component of a subring algebra.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    sratopn $p |- ( ph -> ( TopOpen ` W ) = ( TopOpen ` A ) ) $=
      ( srabase sratset topnpropd ) ADBABCDEFGABCDEFHI $.

    $( Distance function of a subring algebra.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    srads $p |- ( ph -> ( dist ` W ) = ( dist ` A ) ) $=
      ( cds c1 c2 cdc df-ds 1nn0 2nn decnncl c6 clt wbr c5 1nn 2nn0 6nn0 declti
      6lt10 olci sralem ) ABCGHIJZDEFKHILMNOUFPQUFRPQHIOSTUAUCUBUDUE $.
  $}

  ${
    $d x y z S $.  $d x y A $.  $d x y z W $.
    sralmod.a $e |- A = ( ( subringAlg ` W ) ` S ) $.
    $( The subring algebra is a left module.  (Contributed by Stefan O'Rear,
       27-Nov-2014.) $)
    sralmod $p |- ( S e. ( SubRing ` W ) -> A e. LMod ) $=
      ( vx vy vz cfv wcel cplusg co wceq eqid cgrp cv wa adantr sseldi syl13anc
      w3a csubrg cbs cin cmulr cur cress subrgss srabase sraaddg srasca sravsca
      csra a1i ressbas ressplusg ressmulr subrg1 subrgrng subrgrcl rnggrp eqidd
      crg syl proplem3 grppropd mpbid 3ad2ant1 inss2 sseli 3ad2ant2 simp3 rngcl
      syl3anc simpr1 simpr2 simpr3 rngdi rngdir rngass rnglidm sylan islmodd )
      BCUAHZIZEFGBCUBHZUCZCJHZWGCUDHZWHCUEHZCBUFKZWEAWDABCABCULHHLWDDUMZBWECWEM
      ZUGZUHZWDABCWKWMUIZWDABCWKWMUJWDABCWKWMUKBWEWJWCCWJMZWLUNBWGCWJWCWPWGMZUO
      BCWJWHWCWPWHMZUPBCWJWIWPWIMZUQBCWJWPURWDCNIZANIWDCVBIZWTBCUSZCUTVCWDEFWEC
      AWDWEVAWNWDEOZWEIZFOZWEIZPEFWGAJHWOVDVEVFWDXCWFIZXFTXAXDXFXCXEWHKZWEIWDXG
      XAXFXBVGXGWDXDXFWFWEXCBWEVHZVIVJWDXGXFVKWECWHXCXEWLWRVLVMWDXGXFGOZWEIZTZP
      ZXAXDXFXKXCXEXJWGKWHKXHXCXJWHKZWGKLWDXAXLXBQXMWFWEXCXIWDXGXFXKVNRWDXGXFXK
      VOWDXGXFXKVPWEWGCWHXCXEXJWLWQWRVQSWDXGXEWFIZXKTZPZXAXDXFXKXCXEWGKXJWHKXNX
      EXJWHKZWGKLWDXAXPXBQZXQWFWEXCXIWDXGXOXKVNRZXQWFWEXEXIWDXGXOXKVORZWDXGXOXK
      VPZWEWGCWHXCXEXJWLWQWRVRSXQXAXDXFXKXHXJWHKXCXRWHKLXSXTYAYBWECWHXCXEXJWLWR
      VSSWDXAXDWIXCWHKXCLXBWECWHWIXCWLWRWSVTWAWB $.
  $}

  ${
    $d a b A $.  $d a b ph $.  $d a b W $.
    sralmod0.a $e |- ( ph -> A = ( ( subringAlg ` W ) ` S ) ) $.
    sralmod0.z $e |- ( ph -> .0. = ( 0g ` W ) ) $.
    sralmod0.s $e |- ( ph -> S C_ ( Base ` W ) ) $.
    $( The subring module inherits a zero from its ring.  (Contributed by
       Stefan O'Rear, 27-Dec-2014.) $)
    sralmod0 $p |- ( ph -> .0. = ( 0g ` A ) ) $=
      ( va vb c0g cfv cbs eqidd srabase cv wcel wa cplusg sraaddg grpidpropd
      proplem3 eqtrd ) AEDKLBKLGAIJDMLZDBAUDNABCDFHOAIPUDQJPUDQRIJDSLBSLABCDFHT
      UBUAUC $.
  $}

  ${
    $d x y z .0. $.  $d x y z D $.  $d x y z I $.  $d x y z N $.  $d x y z O $.
    $d x y z .+ $.  $d x y z ph $.  $d x y z S $.  $d x y z .x. $.
    issubgrpd.s $e |- ( ph -> S = ( I |`s D ) ) $.
    issubgrpd.z $e |- ( ph -> .0. = ( 0g ` I ) ) $.
    issubgrpd.p $e |- ( ph -> .+ = ( +g ` I ) ) $.
    issubgrpd.ss $e |- ( ph -> D C_ ( Base ` I ) ) $.
    issubgrpd.zcl $e |- ( ph -> .0. e. D ) $.
    issubgrpd.acl $e |- ( ( ph /\ x e. D /\ y e. D ) -> ( x .+ y ) e. D ) $.
    issubgrpd.ncl $e |- ( ( ph /\ x e. D ) -> ( ( invg ` I ) ` x ) e. D ) $.

    ${
      issubgrpd.g $e |- ( ph -> I e. Grp ) $.
      $( Prove a subgroup by closure (definition version).  (Contributed by
         Stefan O'Rear, 7-Dec-2014.) $)
      issubgrpd2 $p |- ( ph -> D e. ( SubGrp ` I ) ) $=
        ( cfv wcel wa eqid csubg cbs wss c0 wne cv cplusg wral cminusg ne0i syl
        co wceq oveqd ad2antrr 3expa eqeltrrd ralrimiva jca cgrp w3a wb issubg2
        mpbir3and ) ADGUAQRZDGUBQZUCZDUDUEZBUFZCUFZGUGQZULZDRZCDUHZVIGUIQZQDRZS
        ZBDUHZLAHDRVHMDHUJUKAVQBDAVIDRZSZVNVPVTVMCDVTVJDRZSVIVJEULZVLDAWBVLUMVS
        WAAEVKVIVJKUNUOAVSWAWBDRNUPUQUROUSURAGUTRVEVGVHVRVAVBPBCVFVKDGVOVFTVKTV
        OTVCUKVD $.

      $( Prove a subgroup by closure.  (Contributed by Stefan O'Rear,
         7-Dec-2014.) $)
      issubgrpd $p |- ( ph -> S e. Grp ) $=
        ( cress co cgrp wcel csubg cfv issubgrpd2 eqid subggrp syl eqeltrd ) AF
        GDQRZSIADGUAUBTUHSTABCDEFGHIJKLMNOPUCDGUHUHUDUEUFUG $.
    $}

    issubrngd.o $e |- ( ph -> .1. = ( 1r ` I ) ) $.
    issubrngd.t $e |- ( ph -> .x. = ( .r ` I ) ) $.
    issubrngd.ocl $e |- ( ph -> .1. e. D ) $.
    issubrngd.tcl $e |- ( ( ph /\ x e. D /\ y e. D ) -> ( x .x. y ) e. D ) $.
    issubrngd.g $e |- ( ph -> I e. Ring ) $.
    $( Prove a subring by closure (definition version).  (Contributed by Stefan
       O'Rear, 7-Dec-2014.) $)
    issubrngd2 $p |- ( ph -> D e. ( SubRing ` I ) ) $=
      ( csubrg cfv wcel csubg cur cv cmulr co wral crg cgrp rnggrp syl eqeltrrd
      issubgrpd2 wa proplem3 3expb ralrimivva w3a cbs eqid issubrg2 mpbir3and
      wb ) ADIUCUDUEZDIUFUDUEZIUGUDZDUEZBUHZCUHZIUIUDZUJZDUEZCDUKBDUKZABCDEFIJK
      LMNOPQAIULUEZIUMUEUBIUNUOUQAHVJDRTUPAVPBCDDAVLDUEZVMDUEZURZURVLVMGUJZVODA
      WABCGVNSUSAVSVTWBDUEUAUTUPVAAVRVHVIVKVQVBVGUBBCDIVCUDZIVNVJWCVDVJVDVNVDVE
      UOVF $.
  $}

  ${
    $d W a $.
    $( ` ringLMod ` is a function.  (Contributed by Stefan O'Rear,
       6-Dec-2014.) $)
    rlmfn $p |- ringLMod Fn _V $=
      ( va cvv cv cbs cfv csra crglmod fvex df-rgmod fnmpti ) ABACZDEZKFEZEGLMH
      AIJ $.

    $( Value of the ring module.  (Contributed by Stefan O'Rear,
       31-Mar-2015.) $)
    rlmval $p |- ( ringLMod ` W ) = ( ( subringAlg ` W ) ` ( Base ` W ) ) $=
      ( va cvv wcel crglmod cfv cbs csra wceq fveq2 fveq12d df-rgmod fvex fvmpt
      cv wn c0 0fv eqcomi fvprc fveq1d 3eqtr4a pm2.61i ) ACDZAEFZAGFZAHFZFZIBAB
      OZGFZUIHFZFUHCEUIAIUJUFUKUGUIAHJUIAGJKBLUFUGMNUDPZQUFQFZUEUHUMQUFRSAETULU
      FUGQAHTUAUBUC $.

    $( Value of the set of ring ideals.  (Contributed by Stefan O'Rear,
       31-Mar-2015.) $)
    lidlval $p |- ( LIdeal ` W ) = ( LSubSp ` ( ringLMod ` W ) ) $=
      ( clidl cfv clss crglmod ccom df-lidl fveq1i 00lss wfun rlmfn fnfun ax-mp
      cvv wfn fvco4i eqtri ) ABCADEFZCAECDCABRGHDEAIENOEJKNELMPQ $.

    $( Value of the ring span function.  (Contributed by Stefan O'Rear,
       4-Apr-2015.) $)
    rspval $p |- ( RSpan ` W ) = ( LSpan ` ( ringLMod ` W ) ) $=
      ( crsp cfv clspn crglmod ccom df-rsp 00lsp cvv wfn wfun rlmfn fnfun ax-mp
      fveq1i fvco4i eqtri ) ABCADEFZCAECDCABRGODEAHEIJEKLIEMNPQ $.
  $}

  $( Base set of the ring module.  (Contributed by Stefan O'Rear,
     31-Mar-2015.) $)
  rlmbas $p |- ( Base ` R ) = ( Base ` ( ringLMod ` R ) ) $=
    ( cbs cfv crglmod wceq wtru csra rlmval a1i wss ssid srabase trud ) ABCZADC
    ZBCEFONAONAGCCEFAHINNJFNKILM $.

  $( Vector addition in the ring module.  (Contributed by Stefan O'Rear,
     31-Mar-2015.) $)
  rlmplusg $p |- ( +g ` R ) = ( +g ` ( ringLMod ` R ) ) $=
    ( cplusg cfv crglmod wceq wtru cbs csra rlmval a1i wss ssid sraaddg trud )
    ABCADCZBCEFOAGCZAOPAHCCEFAIJPPKFPLJMN $.

  $( Zero vector in the ring module.  (Contributed by Stefan O'Rear,
     6-Dec-2014.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
  rlm0 $p |- ( 0g ` R ) = ( 0g ` ( ringLMod ` R ) ) $=
    ( c0g cfv crglmod wceq wtru cbs csra rlmval a1i eqidd ssid sralmod0 trud
    wss ) ABCZADCZBCEFQAGCZAPQRAHCCEFAIJFPKRROFRLJMN $.

  $( Ring multiplication in the ring module.  (Contributed by Mario Carneiro,
     6-Oct-2015.) $)
  rlmmulr $p |- ( .r ` R ) = ( .r ` ( ringLMod ` R ) ) $=
    ( cmulr cfv crglmod wceq wtru cbs csra rlmval a1i wss ssid sramulr trud ) A
    BCADCZBCEFOAGCZAOPAHCCEFAIJPPKFPLJMN $.

  $( Scalars in the ring module.  (Contributed by Stefan O'Rear,
     6-Dec-2014.) $)
  rlmsca $p |- ( R e. X -> R = ( Scalar ` ( ringLMod ` R ) ) ) $=
    ( wcel cbs cfv cress crglmod csca eqid ressid csra wceq rlmval a1i wss ssid
    co srasca eqtr3d ) ABCZAADEZFQAAGEZHEUAABUAIJTUBUAAUBUAAKEELTAMNUAUAOTUAPNR
    S $.

  $( Scalars in the ring module.  (Contributed by Stefan O'Rear,
     1-Apr-2015.) $)
  rlmsca2 $p |- ( _I ` R ) = ( Scalar ` ( ringLMod ` R ) ) $=
    ( cid cfv cbs cress co crglmod csca cvv wcel wceq fvi eqid ressid eqtr4d wn
    c0 fvprc wtru a1i reldmress ovprc1 pm2.61i csra rlmval wss ssid srasca trud
    eqtri ) ABCZAADCZEFZAGCZHCZAIJZUKUMKUPUKAUMAILULAIULMNOUPPUKQUMABRAULEUAUBO
    UCUMUOKSUNULAUNULAUDCCKSAUETULULUFSULUGTUHUIUJ $.

  $( Scalar multiplication in the ring module.  (Contributed by Stefan O'Rear,
     31-Mar-2015.) $)
  rlmvsca $p |- ( .r ` R ) = ( .s ` ( ringLMod ` R ) ) $=
    ( cmulr cfv crglmod cvsca wceq wtru cbs csra rlmval a1i ssid sravsca trud
    wss ) ABCADCZECFGPAHCZAPQAICCFGAJKQQOGQLKMN $.

  $( Topology component of the ring module.  (Contributed by Mario Carneiro,
     6-Oct-2015.) $)
  rlmtopn $p |- ( TopOpen ` R ) = ( TopOpen ` ( ringLMod ` R ) ) $=
    ( ctopn cfv crglmod wceq wtru cbs csra rlmval a1i wss ssid sratopn trud ) A
    BCADCZBCEFOAGCZAOPAHCCEFAIJPPKFPLJMN $.

  $( Metric component of the ring module.  (Contributed by Mario Carneiro,
     6-Oct-2015.) $)
  rlmds $p |- ( dist ` R ) = ( dist ` ( ringLMod ` R ) ) $=
    ( cds cfv crglmod wceq wtru cbs csra rlmval a1i wss ssid srads trud ) ABCAD
    CZBCEFOAGCZAOPAHCCEFAIJPPKFPLJMN $.

  $( The ring module is a module.  (Contributed by Stefan O'Rear,
     6-Dec-2014.) $)
  rlmlmod $p |- ( R e. Ring -> ( ringLMod ` R ) e. LMod ) $=
    ( crg wcel crglmod cfv cbs csra rlmval csubrg eqid subrgid sralmod syl5eqel
    clmod syl ) ABCZADEAFEZAGEEZNAHPQAIECRNCQAQJKRQARJLOM $.

  $( The ring module over a division ring is a vector space.  (Contributed by
     Mario Carneiro, 4-Oct-2015.) $)
  rlmlvec $p |- ( R e. DivRing -> ( ringLMod ` R ) e. LVec ) $=
    ( cdr wcel crglmod cfv clmod csca clvec crg drngrng rlmlmod rlmsca eqeltrrd
    syl id eqid islvec sylanbrc ) ABCZADEZFCZTGEZBCTHCSAICUAAJAKNSAUBBABLSOMUBT
    UBPQR $.

  ${
    $d x y R $.
    $( Vector negation in the ring module.  (Contributed by Stefan O'Rear,
       6-Dec-2014.)  (Revised by Mario Carneiro, 5-Jun-2015.) $)
    rlmvneg $p |- ( invg ` R ) = ( invg ` ( ringLMod ` R ) ) $=
      ( vx vy cminusg cfv crglmod wceq wtru cbs eqidd rlmbas a1i cv wcel cplusg
      wa rlmplusg oveqd grpinvpropd trud ) ADEAFEZDEGHBCAIEZAUAHUBJUBUAIEGHAKLH
      BMZUBNCMZUBNPPZAOEZUAOEZUCUDUFUGGUEAQLRST $.

    $( Functionalized scalar multiplication in the ring module.  (Contributed
       by Mario Carneiro, 6-Oct-2015.) $)
    rlmscaf $p |- ( +f ` ( mulGrp ` R ) ) = ( .sf ` ( ringLMod ` R ) ) $=
      ( vx vy cmgp cfv cplusf cbs cv cmulr co cmpt2 crglmod cscaf eqid mgpplusg
      mgpbas plusffval cid rlmbas rlmsca2 c1 df-base strfvi rlmvsca scaffval
      eqtr4i ) ADEZFEZBCAGEZUIBHCHAIEZJKALEZMEZBCUIUJUHUGUIAUGUGNZUINZPAUJUGUMU
      JNOUHNQBCUIULUJAREUIUKASATAGUAUIUBUNUCULNAUDUEUF $.
  $}

  ${
    lidlss.b $e |- B = ( Base ` W ) $.
    lidlss.i $e |- I = ( LIdeal ` W ) $.
    $( An ideal is a subset of the base set.  (Contributed by Stefan O'Rear,
       28-Mar-2015.) $)
    lidlss $p |- ( U e. I -> U C_ B ) $=
      ( crglmod cfv cbs rlmbas eqtri clidl clss lidlval lssss ) CBADGHZADIHPIHE
      DJKCDLHPMHFDNKO $.

    $( An ideal is a subset of the base set.  (Contributed by Stefan O'Rear,
       3-Jan-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    lidlssOLD $p |- ( ( W e. V /\ U e. I ) -> U C_ B ) $=
      ( wcel wss lidlss adantl ) BCHBAIEDHABCEFGJK $.
  $}

  ${
    $d B x $.  $d I a b x $.  $d R a b x $.
    islidl.s $e |- U = ( LIdeal ` R ) $.
    islidl.b $e |- B = ( Base ` R ) $.
    islidl.p $e |- .+ = ( +g ` R ) $.
    islidl.t $e |- .x. = ( .r ` R ) $.
    $( Predicate of being a (left) ideal.  (Contributed by Stefan O'Rear,
       1-Apr-2015.) $)
    islidl $p |- ( I e. U <-> ( I C_ B /\ I =/= (/) /\
          A. x e. B A. a e. I A. b e. I ( ( x .x. a ) .+ b ) e. I ) ) $=
      ( cid cfv crglmod rlmsca2 cbs eqtri cplusg cnx baseid strfvi rlmbas cmulr
      rlmplusg cvsca rlmvsca clidl clss lidlval islss ) ABCFEGDNOBDPOZHIDQDRUAR
      OBUBKUCBDROUMROKDUDSCDTOUMTOLDUFSEDUEOUMUGOMDUHSFDUIOUMUJOJDUKSUL $.
  $}

  ${
    lidlcl.u $e |- U = ( LIdeal ` R ) $.
    ${
      lidl0cl.z $e |- .0. = ( 0g ` R ) $.
      $( An ideal contains 0.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
      lidl0cl $p |- ( ( R e. Ring /\ I e. U ) -> .0. e. I ) $=
        ( crg wcel wa crglmod cfv c0g rlm0 eqtri clmod clss rlmlmod adantr eqid
        simpr clidl lidlval syl6eleq lss0cl syl2anc syl5eqel ) AGHZCBHZIZDAJKZL
        KZCDALKUKFAMNUIUJOHZCUJPKZHUKCHUGULUHAQRUICBUMUGUHTBAUAKUMEAUBNUCUMCUJU
        KUKSUMSUDUEUF $.
    $}

    ${
      lidlacl.p $e |- .+ = ( +g ` R ) $.
      $( An ideal is closed under addition.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      lidlacl $p |- ( ( ( R e. Ring /\ I e. U ) /\ ( X e. I /\ Y e. I ) ) ->
          ( X .+ Y ) e. I ) $=
        ( crg wcel wa co crglmod cfv cplusg rlmplusg eqtri oveqi clmod eqid jca
        clss rlmlmod adantr simpr clidl lidlval syl6eleq lssvacl sylan syl5eqel
        ) BIJZDCJZKZEDJFDJKZKEFALEFBMNZONZLZDAUQEFABONUQHBPQRUNUPSJZDUPUBNZJZKU
        OURDJUNUSVAULUSUMBUCUDUNDCUTULUMUECBUFNUTGBUGQUHUAUQUTDUPEFUQTUTTUIUJUK
        $.
    $}

    ${
      lidlnegcl.n $e |- N = ( invg ` R ) $.
      $( An ideal contains negatives.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      lidlnegcl $p |- ( ( R e. Ring /\ I e. U /\ X e. I ) ->
          ( N ` X ) e. I ) $=
        ( crg wcel w3a cfv crglmod cminusg rlmvneg eqtri fveq1i clmod clss eqid
        rlmlmod 3ad2ant1 simpr clidl lidlval syl6eleq 3adant3 lssvnegcl syl3anc
        wa simp3 syl5eqel ) AHIZCBIZECIZJZEDKEALKZMKZKZCEDUQDAMKUQGANOPUOUPQIZC
        UPRKZIZUNURCIULUMUSUNATUAULUMVAUNULUMUICBUTULUMUBBAUCKUTFAUDOUEUFULUMUN
        UJUTCUQUPEUTSUQSUGUHUK $.
    $}

    $d x y I $.  $d x y R $.  $d x y U $.
    $( An ideal is a subgroup of the additive group.  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    lidlsubg $p |- ( ( R e. Ring /\ I e. U ) -> I e. ( SubGrp ` R ) ) $=
      ( vx vy crg wcel wa csubg cfv cbs wss c0 wne cv wral eqid syl ralrimiva
      cplusg cminusg lidlss adantl lidl0cl ne0i lidlacl anassrs lidlnegcl 3expa
      co c0g jca cgrp w3a wb rnggrp adantr issubg2 mpbir3and ) AGHZCBHZIZCAJKHZ
      CALKZMZCNOZEPZFPZAUAKZUKCHZFCQZVHAUBKZKCHZIZECQZVBVFVAVECBAVERZDUCUDVCAUL
      KZCHVGABCVRDVRRUECVRUFSVCVOECVCVHCHZIZVLVNVTVKFCVCVSVICHVKVJABCVHVIDVJRZU
      GUHTVAVBVSVNABCVMVHDVMRZUIUJUMTVCAUNHZVDVFVGVPUOUPVAWCVBAUQUREFVEVJCAVMVQ
      WAWBUSSUT $.

    ${
      lidlsubcl.m $e |- .- = ( -g ` R ) $.
      $( An ideal is closed under subtraction.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      lidlsubcl $p |- ( ( ( R e. Ring /\ I e. U ) /\ ( X e. I /\ Y e. I ) ) ->
          ( X .- Y ) e. I ) $=
        ( crg wcel wa co cminusg cfv cplusg cbs wceq eqid lidlss sselda syl2anc
        ad2ant2lr grpsubval simpl simprl simpll simplr simprr lidlnegcl syl3anc
        ad2ant2l lidlacl syl12anc eqeltrd ) AIJZCBJZKZECJZFCJZKZKZEFDLZEFAMNZNZ
        AONZLZCVAEAPNZJZFVGJZVBVFQUPURVHUOUSUPCVGEVGCBAVGRZGSZTUBUPUSVIUOURUPCV
        GFVKTUKVGVEAVCDEFVJVERZVCRZHUCUAVAUQURVDCJZVFCJUQUTUDUQURUSUEVAUOUPUSVN
        UOUPUTUFUOUPUTUGUQURUSUHABCVCFGVMUIUJVEABCEVDGVLULUMUN $.
    $}

    lidlcl.b $e |- B = ( Base ` R ) $.
    ${
      lidlmcl.t $e |- .x. = ( .r ` R ) $.
      $( An ideal is closed under left-multiplication by elements of the full
         ring.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
      lidlmcl $p |- ( ( ( R e. Ring /\ I e. U ) /\ ( X e. B /\ Y e. I ) ) ->
          ( X .x. Y ) e. I ) $=
        ( crg wcel wa co crglmod cfv cvsca eqtri cbs eqid cmulr oveqi clss csca
        rlmvsca clmod rlmlmod ad2antrr simpr clidl lidlval adantr rlmsca fveq2d
        syl6eleq syl5eq eleq2d biimpa ad2ant2r simprr lssvscl syl22anc syl5eqel
        ) BKLZEDLZMZFALZGELZMZMZFGCNFGBOPZQPZNZECVLFGCBUAPVLJBUERUBVJVKUFLZEVKU
        CPZLZFVKUDPZSPZLZVHVMELVDVNVEVIBUGUHVFVPVIVFEDVOVDVEUIDBUJPVOHBUKRUOULV
        DVGVSVEVHVDVGVSVDAVRFVDABSPVRIVDBVQSBKUMUNUPUQURUSVFVGVHUTVRVOVLEVQVKFG
        VQTVLTVRTVOTVAVBVC $.
    $}

    ${
      $d B a $.  $d I a $.  $d .1. a $.  $d R a $.  $d U a $.
      lidl1el.o $e |- .1. = ( 1r ` R ) $.
      $( An ideal contains 1 iff it is the unit ideal.  (Contributed by Stefan
         O'Rear, 3-Jan-2015.) $)
      lidl1el $p |- ( ( R e. Ring /\ I e. U ) -> ( .1. e. I <-> I = B ) ) $=
        ( va crg wcel wa wceq wss lidlssOLD adantr cv cmulr cfv co eqid rngridm
        ad2ant2rl lidlmcl ancom2s eqeltrrd expr ssrdv eqssd ex eleq2 syl5ibrcom
        rngidcl impbid ) BJKZECKZLZDEKZEAMZUQURUSUQURLZEAUQEANURAECJBGFOPUTIAEU
        QURIQZAKZVAEKUQURVBLLVADBRSZTZVAEUOVBVDVAMUPURABVCDVAGVCUAZHUBUCUQVBURV
        DEKABVCCEVADFGVEUDUEUFUGUHUIUJUQURUSDAKZUOVFUPABDGHUMPEADUKULUN $.
    $}
  $}

  ${
    lidl0.u $e |- U = ( LIdeal ` R ) $.
    ${
      lidl0.z $e |- .0. = ( 0g ` R ) $.
      $( Every ring contains a zero ideal.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      lidl0 $p |- ( R e. Ring -> { .0. } e. U ) $=
        ( crg wcel csn crglmod cfv clss clmod rlmlmod c0g rlm0 eqtri lsssn0 syl
        eqid clidl lidlval syl6eleqr ) AFGZCHZAIJZKJZBUCUELGUDUFGAMUFUECCANJUEN
        JEAOPUFSQRBATJUFDAUAPUB $.
    $}

    lidl1.b $e |- B = ( Base ` R ) $.
    $( Every ring contains a unit ideal.  (Contributed by Stefan O'Rear,
       3-Jan-2015.) $)
    lidl1 $p |- ( R e. Ring -> B e. U ) $=
      ( crg wcel crglmod cfv clss clmod rlmlmod cbs rlmbas eqtri eqid syl clidl
      lss1 lidlval syl6eleqr ) BFGZABHIZJIZCUBUCKGAUDGBLUDAUCABMIUCMIEBNOUDPSQC
      BRIUDDBTOUA $.
  $}

  ${
    lidlacs.b $e |- B = ( Base ` W ) $.
    lidlacs.i $e |- I = ( LIdeal ` W ) $.
    $( The ideal system is an algebraic closure system on the base set.
       (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    lidlacs $p |- ( W e. Ring -> I e. ( ACS ` B ) ) $=
      ( crg wcel crglmod cfv clss cacs clidl lidlval eqtri clmod rlmlmod rlmbas
      cbs eqid lssacs syl syl5eqel ) CFGZBCHIZJIZAKIZBCLIUEECMNUCUDOGUEUFGCPAUE
      UDACRIUDRIDCQNUESTUAUB $.
  $}

  ${
    rspcl.k $e |- K = ( RSpan ` R ) $.
    ${
      rspcl.b $e |- B = ( Base ` R ) $.
      ${
        rspcl.u $e |- U = ( LIdeal ` R ) $.
        $( The span of a set of ring elements is an ideal.  (Contributed by
           Stefan O'Rear, 3-Jan-2015.)  (Revised by Mario Carneiro,
           2-Oct-2015.) $)
        rspcl $p |- ( ( R e. Ring /\ G C_ B ) -> ( K ` G ) e. U ) $=
          ( crg wcel crglmod cfv clmod wss rlmlmod cbs rlmbas eqtri clidl clss
          lidlval crsp clspn rspval lspcl sylan ) BIJBKLZMJDANDELCJBOCDEAUGABPL
          UGPLGBQRCBSLUGTLHBUAREBUBLUGUCLFBUDRUEUF $.
      $}

      $( The span of a set of ring elements contains those elements.
         (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
      rspssid $p |- ( ( R e. Ring /\ G C_ B ) -> G C_ ( K ` G ) ) $=
        ( crg wcel crglmod cfv clmod wss rlmlmod rlmbas eqtri crsp clspn rspval
        cbs lspssid sylan ) BGHBIJZKHCALCCDJLBMCDAUBABSJUBSJFBNODBPJUBQJEBROTUA
        $.

      ${
        rsp1.o $e |- .1. = ( 1r ` R ) $.
        $( The span of the identity element is the unit ideal.  (Contributed by
           Stefan O'Rear, 3-Jan-2015.) $)
        rsp1 $p |- ( R e. Ring -> ( K ` { .1. } ) = B ) $=
          ( crg wcel csn cfv wceq wss rngidcl snssd rspssid mpdan cur cvv fvex
          eqeltri snss sylibr clidl wb eqid rspcl lidl1el mpbid ) BHIZCCJZDKZIZ
          ULALZUJUKULMZUMUJUKAMZUOUJCAABCFGNOZABUKDEFPQCULCBRKSGBRTUAUBUCUJULBU
          DKZIZUMUNUEUJUPUSUQABURUKDEFURUFZUGQABURCULUTFGUHQUI $.
      $}
    $}

    ${
      rsp0.z $e |- .0. = ( 0g ` R ) $.
      $( The span of the zero element is the zero ideal.  (Contributed by
         Stefan O'Rear, 3-Jan-2015.) $)
      rsp0 $p |- ( R e. Ring -> ( K ` { .0. } ) = { .0. } ) $=
        ( crg wcel crglmod cfv clmod csn wceq rlmlmod c0g rlm0 eqtri crsp clspn
        rspval lspsn0 syl ) AFGAHIZJGCKZBIUCLAMBUBCCANIUBNIEAOPBAQIUBRIDASPTUA
        $.
    $}

    ${
      rspssp.u $e |- U = ( LIdeal ` R ) $.
      $( The ideal span of a set of elements in a ring is contained in any
         subring which contains those elements.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      rspssp $p |- ( ( R e. Ring /\ I e. U /\ G C_ I ) -> ( K ` G ) C_ I ) $=
        ( crg wcel crglmod cfv clmod wss rlmlmod clidl clss lidlval eqtri clspn
        crsp rspval lspssp syl3an1 ) AHIAJKZLIDBICDMCEKDMANBCDEUDBAOKUDPKGAQREA
        TKUDSKFAUARUBUC $.
    $}
  $}

  ${
    mrcrsp.u $e |- U = ( LIdeal ` R ) $.
    mrcrsp.k $e |- K = ( RSpan ` R ) $.
    mrcrsp.f $e |- F = ( mrCls ` U ) $.
    $( Moore closure generalizes ideal span.  (Contributed by Stefan O'Rear,
       4-Apr-2015.) $)
    mrcrsp $p |- ( R e. Ring -> K = F ) $=
      ( crg wcel crglmod clmod wceq rlmlmod clidl clss lidlval eqtri crsp clspn
      cfv rspval mrclsp syl ) AHIAJTZKIDCLAMBCDUDBANTUDOTEAPQDARTUDSTFAUAQGUBUC
      $.
  $}

  ${
    $d I x $.  $d .0. x $.
    lidlnz.u $e |- U = ( LIdeal ` R ) $.
    lidlnz.z $e |- .0. = ( 0g ` R ) $.
    $( A nonzero ideal contains a nonzero element.  (Contributed by Stefan
       O'Rear, 3-Jan-2015.) $)
    lidlnz $p |- ( ( R e. Ring /\ I e. U /\ I =/= { .0. } ) ->
        E. x e. I x =/= .0. ) $=
      ( crg wcel csn wne w3a cv wn wa wex wrex wpss wss lidl0cl necomd sylanbrc
      snssd 3adant3 simp3 df-pss pssnel syl elsn necon3bbii anbi2i exbii df-rex
      bitr4i sylib ) BHIZDCIZDEJZKZLZAMZDIZVAURIZNZOZAPZVAEKZADQZUTURDRZVFUTURD
      SZURDKVIUPUQVJUSUPUQOEDBCDEFGTUCUDUTDURUPUQUSUEUAURDUFUBAURDUGUHVFVBVGOZA
      PVHVEVKAVDVGVBVCVAEAEUIUJUKULVGADUMUNUO $.
  $}

  ${
    $d U a b $.  $d R a b $.  $d B a b $.  $d .0. a b $.
    drngnidl.b $e |- B = ( Base ` R ) $.
    drngnidl.z $e |- .0. = ( 0g ` R ) $.
    drngnidl.u $e |- U = ( LIdeal ` R ) $.
    $( A division ring has only the two trivial ideals.  (Contributed by Stefan
       O'Rear, 3-Jan-2015.) $)
    drngnidl $p |- ( R e. DivRing -> U = { { .0. } , B } ) $=
      ( va vb cdr wcel cv wa wceq simpr wne cfv ad2antrr syl3anc eqid orcd wrex
      csn cpr wo cur crg drngrng simplr lidlnz wel cinvr cmulr simpll lidlssOLD
      co sselda adantrr simprr drnginvrl drnginvrcl lidlmcl syl22anc rexlimdvaa
      simprl eqeltrrd imp syldan lidl1el sylan adantr mpbid olcd pm2.61dane vex
      wb elpr sylibr ex ssrdv wss lidl0 lidl1 snex cbs fvex eqeltri prss bicomi
      cvv sylanbrc syl eqssd ) BJKZCDUCZAUDZWNHCWPWNHLZCKZWQWPKZWNWRMZWQWONZWQA
      NZUEZWSWTXCWQWOWTXAMXAXBWTXAOUAWTWQWOPZMZXBXAXEBUFQZWQKZXBWTXDILZDPZIWQUB
      ZXGXEBUGKZWRXDXJWNXKWRXDBUHZRWNWRXDUIWTXDOIBCWQDGFUJSWTXJXGWTXIXGIWQWTIHU
      KZXIMZMZXHBULQZQZXHBUMQZUPZXFWQXOWNXHAKZXIXSXFNWNWRXNUNZWTXMXTXIWTWQAXHAW
      QCJBEGUOUQURZWTXMXIUSZABXRXFXPXHDEFXRTZXFTZXPTZUTSXOXKWRXQAKZXMXSWQKWNXKW
      RXNXLRWNWRXNUIXOWNXTXIYGYAYBYCABXPXHDEFYFVASWTXMXIVEABXRCWQXQXHGEYDVBVCVF
      VDVGVHWTXGXBVPZXDWNXKWRYHXLABCXFWQGEYEVIVJVKVLVMVNWQWOAHVOVQVRVSVTWNXKWPC
      WAZXLXKWOCKZACKZYIBCDGFWBABCGEWCYJYKMYIWOACDWDABWEQWJEBWEWFWGWHWIWKWLWM
      $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y L $.  $d x y ph $.  $d x y W $.
    lidlpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    lidlpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    lidlpropd.3 $e |- ( ph -> B C_ W ) $.
    lidlpropd.4 $e |- ( ( ph /\ ( x e. W /\ y e. W ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    lidlpropd.5 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) e. W ) $.
    lidlpropd.6 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( The left ideals and ring span of a ring depend only on the ring
       components.  Here ` W ` is expected to be either ` B ` (when closure is
       available) or ` _V ` (when strong equality is available).  (Contributed
       by Mario Carneiro, 14-Jun-2015.) $)
    lidlrsppropd $p |- ( ph ->
      ( ( LIdeal ` K ) = ( LIdeal ` L ) /\ ( RSpan ` K ) = ( RSpan ` L ) ) ) $=
      ( cfv crglmod cbs syl6eq wcel wa co clidl wceq crsp clss rlmbas cv cplusg
      rlmplusg oveqi 3eqtr3g cvsca cmulr rlmvsca syl5eqelr csca cid baseid eqid
      cnx strfvi rlmsca2 eqtri lsspropd lidlval 3eqtr4g clspn cvv fvex lsppropd
      fveq2i a1i rspval jca ) AEUANZFUANZUBEUCNZFUCNZUBAEONZUDNFONZUDNVNVOABCDD
      VRVSGADEPNZVRPNHEUEQZADFPNZVSPNIFUEQZJABUFZGRCUFZGRSSWDWEEUGNZTWDWEFUGNZT
      WDWEVRUGNZTWDWEVSUGNZTKWFWHWDWEEUHUIWGWIWDWEFUHUIUJZAWDDRWEDRSSZWDWEVRUKN
      ZTZWDWEEULNZTZGWNWLWDWEEUMUIZLUNZWKWOWDWEFULNZTWMWDWEVSUKNZTMWPWRWSWDWEFU
      MUIUJZADVTVRUONZPNZHVTEUPNZPNXBEPUSPNZVTUQVTURUTXCXAPEVAVJVBQZADWBVSUONZP
      NZIWBFUPNZPNXGFPXDWBUQWBURUTXHXFPFVAVJVBQZVCEVDFVDVEAVRVFNVSVFNVPVQABCDDV
      RVSGWAWCJWJWQWTXEXIVRVGRAEOVHVKVSVGRAFOVHVKVIEVLFVLVEVM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Two-sided ideals and quotient rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c 2Ideal $.

  $( Ring two-sided ideal function. $)
  c2idl $a class 2Ideal $.

  $( Define the class of two-sided ideals of a ring.  A two-sided ideal is a
     left ideal which is also a right ideal (or a left ideal over the opposite
     ring).  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
  df-2idl $a |- 2Ideal = ( r e. _V |->
    ( ( LIdeal ` r ) i^i ( LIdeal ` ( oppR ` r ) ) ) ) $.

  ${
    $d r I $.  $d r J $.  $d r R $.
    2idlval.i $e |- I = ( LIdeal ` R ) $.
    2idlval.o $e |- O = ( oppR ` R ) $.
    2idlval.j $e |- J = ( LIdeal ` O ) $.
    2idlval.t $e |- T = ( 2Ideal ` R ) $.
    $( Definition of a two-sided ideal.  (Contributed by Mario Carneiro,
       14-Jun-2015.) $)
    2idlval $p |- T = ( I i^i J ) $=
      ( vr c2idl cfv cin cvv wceq clidl coppr fveq2 syl6eqr c0 wcel fveq2d fvex
      cv ineq12d df-2idl eqeltri inex1 fvmpt wn fvprc inss1 syl5eq sseq0 eqtr4d
      wss sylancr pm2.61i eqtri ) BAKLZCDMZIANUAZUTVAOJAJUDZPLZVCQLZPLZMVANKVCA
      OZVDCVFDVGVDAPLZCVCAPRFSVGVFEPLDVGVEEPVGVEAQLEVCAQRGSUBHSUEJUFCDCVHNFAPUC
      UGUHUIVBUJZUTTVAAKUKVIVACUPCTOVATOCDULVICVHTFAPUKUMVACUNUQUOURUS $.
  $}

  ${
    2idlcpbl.x $e |- X = ( Base ` R ) $.
    2idlcpbl.r $e |- E = ( R ~QG S ) $.
    2idlcpbl.i $e |- I = ( 2Ideal ` R ) $.
    2idlcpbl.t $e |- .x. = ( .r ` R ) $.
    $( The coset equivalence relation for a two-sided ideal is compatible with
       ring multiplication.  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    2idlcpbl $p |- ( ( R e. Ring /\ S e. I ) ->
        ( ( A E C /\ B E D ) -> ( A .x. B ) E ( C .x. D ) ) ) $=
      ( wcel wbr co cfv eqid syl2anc crg csg simpll w3a csubg wer clidl 2idlval
      wa coppr elin2 simplbi ad2antlr lidlsubg eqger syl simprl ersym cabel wss
      wb rngabl ad2antrr lidlss eqgabl mpbid simp2d simprr simp1d rngcl syl3anc
      cgrp rnggrp grpnnncan2 syl13anc rngsubdi simp3d lidlmcl syl22anc eqeltrrd
      wceq opprmul rngsubdir syl5eq opprrng simprbi opprbas lidlsubcl mpbir3and
      cmulr ex ) EUAOZFIOZUIZACHPZBDHPZUIZABGQZCDGQZHPZWNWQUIZWTWRJOZWSJOZWSWRE
      UBRZQZFOZXAWLAJOZBJOZXBWLWMWQUCZXACJOZXGACXDQZFOZXACAHPZXJXGXLUDZXAACHJXA
      FEUEROZJHUFXAWLFEUGRZOZXOXIWMXQWLWQWMXQFEUJRZUGRZOZFXPXSIEIXPXSXRXPSZXRSZ
      XSSZMUHUKZULUMZEXPFYAUNTHEJFKLUOUPWNWOWPUQURXAEUSOZFJUTZXMXNVAWLYFWMWQEVB
      VCZXAXQYGYEJFXPEKYAVDUPZCAHFEXDJKXDSZLVETVFZVGZXAXHDJOZDBXDQZFOZXAWPXHYMY
      OUDZWNWOWPVHXAYFYGWPYPVAYHYIBDHFEXDJKYJLVETVFZVIZJEGABKNVJVKZXAWLXJYMXCXI
      XAXJXGXLYKVIZXAXHYMYOYQVGZJEGCDKNVJVKZXAWSCBGQZXDQZWRUUCXDQZXDQZXEFXAEVLO
      ZXCXBUUCJOZUUFXEWAWLUUGWMWQEVMVCUUBYSXAWLXJXHUUHXIYTYRJEGCBKNVJVKJEXDWSWR
      UUCKYJVNVOXAWLXQUUDFOUUEFOUUFFOXIYEXACYNGQZUUDFXAJEGXDCDBKNYJXIYTUUAYRVPX
      AWLXQXJYOUUIFOXIYEYTXAXHYMYOYQVQJEGXPFCYNYAKNVRVSVTXABXKXRWJRZQZUUEFXAUUK
      XKBGQUUEJEUUJGXRBXKKNYBUUJSZWBXAJEGXDACBKNYJXIYLYTYRWCWDXAXRUAOZXTXHXLUUK
      FOWLUUMWMWQEXRYBWEVCWMXTWLWQWMXQXTYDWFUMYRXAXJXGXLYKVQJXRUUJXSFBXKYCJEXRY
      BKWGUULVRVSVTEXPFXDUUDUUEYAYJWHVSVTXAYFYGWTXBXCXFUDVAYHYIWRWSHFEXDJKYJLVE
      TWIWK $.
  $}

  ${
    $d y z F $.  $d a b c d x y z I $.  $d c d .1. $.  $d a b c d x y z R $.
    $d a b c d x y z S $.  $d a b c d x y z U $.  $d a b c d x y z X $.
    divsrng.u $e |- U = ( R /s ( R ~QG S ) ) $.
    divsrng.i $e |- I = ( 2Ideal ` R ) $.
    ${
      divs1.o $e |- .1. = ( 1r ` R ) $.
      $( The multiplicative identity of the quotient ring.  (Contributed by
         Mario Carneiro, 14-Jun-2015.) $)
      divs1 $p |- ( ( R e. Ring /\ S e. I ) ->
          ( U e. Ring /\ [ .1. ] ( R ~QG S ) = ( 1r ` U ) ) ) $=
        ( vd vc va vb wcel cfv co wceq eqid syl cv wbr crg cplusg cqg cmulr cbs
        wa cqus a1i csubg wer clidl coppr 2idlval elin2 simplbi lidlsubg sylan2
        eqger cnsg cabel rngabl adantr eleqtrrd eqgcpbl 2idlcpbl simpl divsrng2
        wi ablnsg ) AUAMZBEMZUFZAUBNZABUCOZAAUDNZCDAUENZIJKLCAVNUGOPVLFUHVPVPPV
        LVPQZUHVMQZVOQZHVLBAUINZMZVPVNUJVKVJBAUKNZMZWAVKWCBAULNZUKNZMBWBWEEAEWB
        WEWDWBQZWDQWEQGUMUNUOAWBBWFUPUQZVNAVPBVQVNQZURRVLBAUSNZMKSZJSZVNTLSZISZ
        VNTUFWJWLVMOWKWMVMOVNTVHVLBVTWIWGVLAUTMZWIVTPVJWNVKAVAVBAVIRVCWJWLWKWMV
        MVNAVPBVQWHVRVDRWJWLWKWMABVOVNEVPVQWHGVSVEVJVKVFVG $.
    $}

    $( If ` S ` is a two-sided ideal in ` R ` , then ` U = R / S ` is a ring,
       called the quotient ring of ` R ` by ` S ` .  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    divsrng $p |- ( ( R e. Ring /\ S e. I ) -> U e. Ring ) $=
      ( crg wcel wa cur cfv cqg co cec wceq eqid divs1 simpld ) AGHBDHICGHAJKZA
      BLMNCJKOABCSDEFSPQR $.

    divsrhm.x $e |- X = ( Base ` R ) $.
    divsrhm.f $e |- F = ( x e. X |-> [ x ] ( R ~QG S ) ) $.
    $( If ` S ` is a two-sided ideal in ` R ` , then the "natural map" from
       elements to their cosets is a ring homomorphism from ` R ` to
       ` R / S ` .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    divsrhm $p |- ( ( R e. Ring /\ S e. I ) -> F e. ( R RingHom U ) ) $=
      ( wcel cfv eqid co cec a1i divsfval wceq cv vy vz vd vc va vb cmulr simpl
      crg wa cur divsrng cqg csubg wer clidl coppr 2idlval elin2 simplbi sylan2
      lidlsubg eqger syl cvv cbs fvex eqeltri divs1 simprd eqtrd 2idlcpbl rngcl
      cqus 3expb adantlr caovclg divsmulval adantr oveq12d 3eqtr4rd cnsg rngabl
      cghm cabel ablnsg eleqtrrd divsghm isrhm2d ) BUILZCFLZUJZUAUBGBDBUGMZDUGM
      ZBUKMZEDUKMZJWONZWPNWMNZWNNZWJWKUHZBCDFHIULWLWOEMWOBCUMOZPZWPWLAWOXAEGWLC
      BUNMZLZGXAUOZWKWJCBUPMZLZXDWKXGCBUQMZUPMZLCXFXIFBFXFXIXHXFNZXHNXINIURUSUT
      BXFCXJVBVAZXABGCJXANZVCVDZGVELZWLGBVFMZVEJBVFVGVHZQKRWLDUILXBWPSBCDWOFHIW
      QVIVJVKWLUATZGLZUBTZGLZUJZUJZXQXAPZXSXAPZWNOZXQXSWMOZXAPZXQEMZXSEMZWNOYFE
      MWLXRXTYEYGSWLXABWNWMDGXQXSUIUCUDUEUFDBXAVNOSWLHQGXOSWLJQXMWTUETUFTUDTZUC
      TZBCWMXAFGJXLIWRVLWLUAUBYJYKGGGWMWJYAYFGLZWKWJXRXTYLGBWMXQXSJWRVMVOVPVQWR
      WSVRVOYBYHYCYIYDWNYBAXQXAEGWLXEYAXMVSZXNYBXPQZKRYBAXSXAEGYMYNKRVTYBAYFXAE
      GYMYNKRWAWLCBWBMZLEBDWDOLWLCXCYOXKWLBWELZYOXCSWJYPWKBWCVSBWFVDWGAEBDGCJHK
      WHVDWI $.
  $}

  ${
    $d x y O $.  $d x y R $.
    crng2idl.i $e |- I = ( LIdeal ` R ) $.
    ${
      crngridl.o $e |- O = ( oppR ` R ) $.
      $( In a commutative ring, the left and right ideals coincide.
         (Contributed by Mario Carneiro, 14-Jun-2015.) $)
      crngridl $p |- ( R e. CRing -> I = ( LIdeal ` O ) ) $=
        ( vx vy wcel clidl cfv wceq crsp cbs cvv eqid a1i cv cplusg co wa eqidd
        ccrg opprbas wss ssv oppradd oveqi cmulr ovex 3expb lidlrsppropd simpld
        crngoppr syl5eq ) AUBHZBAIJZCIJZDUOUPUQKALJCLJKUOFGAMJZACNUOURUAURCMJKU
        OURACEUROZUCPURNUDUOURUEPFQZGQZARJZSUTVACRJZSKUOUTNHVANHTTVBVCUTVAVBACE
        VBOUFUGPUTVAAUHJZSZNHUOUTURHZVAURHZTTUTVAVDUIPUOVFVGVEUTVACUHJZSKURAVHV
        DCUTVAUSVDOEVHOUMUJUKULUN $.
    $}

    $( In a commutative ring, a two-sided ideal is the same as a left ideal.
       (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    crng2idl $p |- ( R e. CRing -> I = ( 2Ideal ` R ) ) $=
      ( ccrg wcel coppr cfv clidl cin c2idl inidm eqid crngridl syl5eqr 2idlval
      ineq2d syl6eqr ) ADEZBBAFGZHGZIZAJGZRBBBIUABKRBTBABSCSLZMPNAUBBTSCUCTLUBL
      OQ $.
  $}

  ${
    $d a b c d u v x y I $.  $d a b c d u v x y R $.  $d a b c d u v x y S $.
    $d a b c d u v x y U $.
    divscrng.u $e |- U = ( R /s ( R ~QG S ) ) $.
    divscrng.i $e |- I = ( LIdeal ` R ) $.
    $( The quotient of a commutative ring by an ideal is a commutative ring.
       (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    divscrng $p |- ( ( R e. CRing /\ S e. I ) -> U e. CRing ) $=
      ( vx vy vd vc va wcel wa crg cv cfv co wceq eqid cec vu vv ccrg cmulr cbs
      vb wral c2idl crngrng adantr crng2idl eleqtrd divsrng syl2anc cqg cqs cvv
      simpr cqus eqidd ovex divsbas eleq2d anbi12d oveq2 oveq1 eqeq12d 3adant1r
      a1i crngcom 3expa eceq1 syl csubg wer lidlsubg sylan eqger 2idlcpbl rngcl
      wi 3expb divsmulval an32s 3eqtr4rd ectocld expl sylbird ralrimivv iscrng2
      wbr sylanbrc ) AUCLZBDLZMZCNLZGOZHOZCUDPZQZWRWQWSQZRZHCUEPZUGGXCUGCUCLWOA
      NLZBAUHPZLZWPWMXDWNAUIZUJZWOBDXEWMWNURWMDXERWNADFUKUJULZABCXEEXESZUMUNWOX
      BGHXCXCWOWQXCLZWRXCLZMWQAUEPZABUOQZUPZLZWRXOLZMXBWOXPXKXQXLWOXOXCWQWOXNAC
      XMUQNCAXNUSQRWOEVIZWOXMUTZXNUQLWOABUOVAVIXHVBZVCWOXOXCWRXTVCVDWOXPXQXBWQU
      AOZXNTZWSQZYBWQWSQZRZXBWOXPMUAWRXMXNXOXOSZYBWRRYCWTYDXAYBWRWQWSVEYBWRWQWS
      VFVGWOYAXMLZXPYEUBOZXNTZYBWSQZYBYIWSQZRYEWOYGMZUBWQXMXNXOYFYIWQRYJYCYKYDY
      IWQYBWSVFYIWQYBWSVEVGYLYHXMLZMZYAYHAUDPZQZXNTZYHYAYOQZXNTZYKYJYNYPYRRZYQY
      SRWOYGYMYTWMYGYMYTWNXMAYOYAYHXMSZYOSZVJVHVKYPYRXNVLVMWOYGYMYKYQRWOXNAWSYO
      CXMYAYHNIJKUFXRXSWOBAVNPLZXMXNVOWMXDWNUUCXGADBFVPVQXNAXMBUUAXNSZVRVMZXHWO
      XDXFKOZJOZXNWKUFOZIOZXNWKMUUFUUHYOQUUGUUIYOQZXNWKWAXHXIUUFUUHUUGUUIABYOXN
      XEXMUUAUUDXJUUBVSUNZWOXDUUGXMLZUUIXMLZMUUJXMLZXHXDUULUUMUUNXMAYOUUGUUIUUA
      UUBVTWBVQZUUBWSSZWCVKWOYMYGYJYSRZWOYMYGUUQWOXNAWSYOCXMYHYANIJKUFXRXSUUEXH
      UUKUUOUUBUUPWCVKWDWEWFWDWFWGWHWIGHXCCWSXCSUUPWJWL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Principal ideal rings.  Divisibility in the integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LPIdeal LPIR $.

  $( Ring left-principal-ideal function. $)
  clpidl $a class LPIdeal $.

  $( Class of left principal ideal rings. $)
  clpir $a class LPIR $.

  ${
    $d w i g $.

    $( Define the class of left principal ideals of a ring, which are ideals
       with a single generator.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
    df-lpidl $a |- LPIdeal = ( w e. Ring |->
        U_ g e. ( Base ` w ) { ( ( RSpan ` w ) ` { g } ) } ) $.

    $( Define the class of left principal ideal rings, rings where every left
       ideal has a single generator.  (Contributed by Stefan O'Rear,
       3-Jan-2015.) $)
    df-lpir $a |- LPIR = { w e. Ring | ( LIdeal ` w ) = ( LPIdeal ` w ) } $.
  $}

  ${
    $d R r g $.  $d P r g $.  $d B r g $.  $d r K g $.  $d U g $.  $d I g $.
    $d .0. g $.  $d B g $.
    lpival.p $e |- P = ( LPIdeal ` R ) $.
    ${
      lpival.k $e |- K = ( RSpan ` R ) $.
      lpival.b $e |- B = ( Base ` R ) $.
      $( Value of the set of principal ideals.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      lpival $p |- ( R e. Ring -> P = U_ g e. B { ( K ` { g } ) } ) $=
        ( vr crg wcel clpidl cfv cbs cv csn crsp ciun wceq fveq2 sneqd iuneq12d
        fveq1d df-lpidl crn cun fvex rnex p0ex unex wss iunss fvrn0 snssi ax-mp
        c0 a1i mprgbir ssexi fvmpt iuneq1 fveq1i sneqi iuneq2i eqtri 3eqtr4g )
        CJKCLMDCNMZDOZPZCQMZMZPZRZBDAVIEMZPZRZICDIOZNMZVIVQQMZMZPZRVMJLVQCSZDVR
        VGWAVLVQCNTWBVTVKWBVIVSVJVQCQTUCUAUBIDUDVMVJUEZUPPZUFZWCWDVJCQUGUHUIUJV
        MWEUKVLWEUKZDVGDVGVLWEULWFVHVGKZVKWEKWFVJVIUMVKWEUNUOUQURUSUTFVPDVGVORZ
        VMAVGSVPWHSHDAVGVOVAUODVGVOVLVOVLSWGVNVKVIEVJGVBVCUQVDVEVF $.

      $( Property of being a principal ideal.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      islpidl $p |- ( R e. Ring -> ( I e. P <-> E. g e. B
          I = ( K ` { g } ) ) ) $=
        ( crg wcel cv csn cfv ciun wceq wrex lpival eleq2d eliun elsnc2 rexbii
        fvex bitri syl6bb ) CJKZEBKEDADLMZFNZMZOZKZEUHPZDAQZUFBUJEABCDFGHIRSUKE
        UIKZDAQUMDEAUITUNULDAEUHUGFUCUAUBUDUE $.
    $}

    ${
      lpi0.z $e |- .0. = ( 0g ` R ) $.
      $( The zero ideal is always principal.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      lpi0 $p |- ( R e. Ring -> { .0. } e. P ) $=
        ( vg crg wcel csn crsp cfv wceq cbs wrex eqid rng0cl rsp0 eqcomd sneq
        cv fveq2d eqeq2d rspcev syl2anc islpidl mpbird ) BGHZCIZAHUHFTZIZBJKZKZ
        LZFBMKZNZUGCUNHUHUHUKKZLZUOUNBCUNOZEPUGUPUHBUKCUKOZEQRUMUQFCUNUICLZULUP
        UHUTUJUHUKUICSUAUBUCUDUNABFUHUKDUSURUEUF $.
    $}

    ${
      lpi1.b $e |- B = ( Base ` R ) $.
      $( The unit ideal is always principal.  (Contributed by Stefan O'Rear,
         3-Jan-2015.) $)
      lpi1 $p |- ( R e. Ring -> B e. P ) $=
        ( vg crg wcel csn crsp cfv wceq wrex cur eqid rngidcl rsp1 eqcomd sneq
        cv fveq2d eqeq2d rspcev syl2anc islpidl mpbird ) CGHZABHAFTZIZCJKZKZLZF
        AMZUGCNKZAHAUNIZUJKZLZUMACUNEUNOZPUGUPAACUNUJUJOZEURQRULUQFUNAUHUNLZUKU
        PAUTUIUOUJUHUNSUAUBUCUDABCFAUJDUSEUEUF $.
    $}

    ${
      $d U r $.
      lpiss.u $e |- U = ( LIdeal ` R ) $.
      $( Principal ideal rings are where all ideals are principal.
         (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
      islpir $p |- ( R e. LPIR <-> ( R e. Ring /\ U = P ) ) $=
        ( vr cv clidl cfv clpidl wceq crg clpir eqeq12d eqeq12i syl6bbr df-lpir
        fveq2 elrab2 ) FGZHIZTJIZKZCAKZFBLMTBKZUCBHIZBJIZKUDUEUAUFUBUGTBHRTBJRN
        CUFAUGEDOPFQS $.

      $d P a g $.  $d U a g $.  $d R a g $.
      $( Principal ideals are a subclass of ideal.  (Contributed by Stefan
         O'Rear, 3-Jan-2015.) $)
      lpiss $p |- ( R e. Ring -> P C_ U ) $=
        ( va vg crg wcel cv csn crsp cfv wceq cbs wrex eqid islpidl wa wss
        snssi rspcl sylan2 eleq1 syl5ibrcom rexlimdva sylbid ssrdv ) BHIZFACUIF
        JZAIUJGJZKZBLMZMZNZGBOMZPUJCIZUPABGUJUMDUMQZUPQZRUIUOUQGUPUIUKUPIZSUQUO
        UNCIZUTUIULUPTVAUKUPUAUPBCULUMURUSEUBUCUJUNCUDUEUFUGUH $.

      $( Principal ideal rings are where all ideals are principal.
         (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
      islpir2 $p |- ( R e. LPIR <-> ( R e. Ring /\ U C_ P ) ) $=
        ( clpir wcel crg wceq wa wss lpiss biantrud eqss syl6rbbr pm5.32i bitri
        islpir ) BFGBHGZCAIZJSCAKZJABCDERSTUASUAUAACKZJTSUBUAABCDELMCANOPQ $.
    $}
  $}

  $( Principal ideal rings are rings.  (Contributed by Stefan O'Rear,
     24-Jan-2015.) $)
  lpirrng $p |- ( R e. LPIR -> R e. Ring ) $=
    ( clpir wcel crg clidl cfv clpidl wceq eqid islpir simplbi ) ABCADCAEFZAGFZ
    HMALMILIJK $.

  $( Division rings are principal ideal.  (Contributed by Stefan O'Rear,
     3-Jan-2015.) $)
  drnglpir $p |- ( R e. DivRing -> R e. LPIR ) $=
    ( cdr wcel crg clidl cfv clpidl wss clpir drngrng c0g csn cbs eqid drngnidl
    cpr lpi0 lpi1 wa sylanbrc snex fvex prss bicomi syl eqsstrd islpir2 ) ABCZA
    DCZAEFZAGFZHAICAJZUHUJAKFZLZAMFZPZUKUOAUJUMUONZUMNZUJNZOUHUIUPUKHZULUIUNUKC
    ZUOUKCZUTUKAUMUKNZURQUOUKAVCUQRVAVBSUTUNUOUKUMUAAMUBUCUDTUEUFUKAUJVCUSUGT
    $.

  ${
    $d a x R $.  $d G a x $.  $d B a x $.  $d K a x $.  $d .|| a x $.
    rspsn.b $e |- B = ( Base ` R ) $.
    rspsn.k $e |- K = ( RSpan ` R ) $.
    rspsn.d $e |- .|| = ( ||r ` R ) $.
    $( Membership in principal ideals is closely related to divisibility.
       (Contributed by Stefan O'Rear, 3-Jan-2015.)  (Revised by Mario Carneiro,
       6-May-2015.) $)
    rspsn $p |- ( ( R e. Ring /\ G e. B ) ->
        ( K ` { G } ) = { x | G .|| x } ) $=
      ( va crg wcel wa cv cfv wceq wrex wb cbs eqtri wbr csn cmulr co eqcom a1i
      rexbidv crglmod rlmlmod cid rlmsca2 cnx baseid strfvi rlmbas rlmvsca crsp
      clmod clspn rspval lspsnel sylan eqid dvdsr2 adantl 3bitr4d abbi2dv ) DKL
      ZEBLZMZEANZCUAZAEUBFOZVJVKJNEDUCOZUDZPZJBQZVOVKPZJBQZVKVMLZVLVJVPVRJBVPVR
      RVJVKVOUEUFUGVHDUHOZURLVIVTVQRDUIVNVKJDUJOBFBWAEDUKDSULSOBUMGUNBDSOWASOGD
      UOTDUPFDUQOWAUSOHDUTTVAVBVIVLVSRVHJBCDVNEVKGIVNVCVDVEVFVG $.
  $}

  ${
    $d U x y $.  $d B x y $.  $d .|| x y $.  $d R x y $.  $d I x y $.
    $d K x y $.  $d G x y $.
    lidldvgen.b $e |- B = ( Base ` R ) $.
    lidldvgen.u $e |- U = ( LIdeal ` R ) $.
    lidldvgen.k $e |- K = ( RSpan ` R ) $.
    lidldvgen.d $e |- .|| = ( ||r ` R ) $.
    $( An element generates an ideal iff it is contained in the ideal and all
       elements are right-divided by it.  (Contributed by Stefan O'Rear,
       3-Jan-2015.) $)
    lidldvgen $p |- ( ( R e. Ring /\ I e. U /\ G e. B ) ->
        ( I = ( K ` { G } ) <-> ( G e. I /\ A. x e. I G .|| x ) ) ) $=
      ( vy wcel wceq cv wbr wral wa wss crg w3a csn simp1 simp3 rspssid syl2anc
      cfv snssd snssg 3ad2ant3 mpbird cab rspsn 3adant2 eleq2d vex breq2 syl6bb
      wb elab biimpd ralrimiv jca eleq2 raleq anbi12d syl5ibrcom wi df-ral ssab
      bitr4i biimpi ad2antll adantr sseqtr4d simpl1 simpl2 snssi adantl syl3anc
      wal rspssp adantrr eqssd ex impbid ) DUANZGENZFBNZUBZGFUCZHUHZOZFGNZFAPZC
      QZAGRZSZWKWSWNFWMNZWQAWMRZSWKWTXAWKWTWLWMTZWKWHWLBTXBWHWIWJUDWKFBWHWIWJUE
      UIBDWLHKIUFUGWJWHWTXBUTWIFWMBUJUKULWKWQAWMWKWPWMNZWQWKXCWPFMPZCQZMUMZNWQW
      KWMXFWPWHWJWMXFOWIMBCDFHIKLUNUOUPXEWQMWPAUQXDWPFCURVAUSVBVCVDWNWOWTWRXAGW
      MFVEWQAGWMVFVGVHWKWSWNWKWSSZGWMXGGWQAUMZWMWRGXHTZWKWOWRXIWRWPGNWQVIAWBXIW
      QAGVJWQAGVKVLVMVNWKWMXHOZWSWHWJXJWIABCDFHIKLUNUOVOVPWKWOWMGTZWRWKWOSWHWIW
      LGTZXKWHWIWJWOVQWHWIWJWOVRWOXLWKFGVSVTDEWLGHKJWCWAWDWEWFWG $.
  $}

  ${
    $d R x y $.  $d I x y $.  $d U x y $.  $d P x y $.  $d .|| x y $.
    lpigen.u $e |- U = ( LIdeal ` R ) $.
    lpigen.p $e |- P = ( LPIdeal ` R ) $.
    lpigen.d $e |- .|| = ( ||r ` R ) $.
    $( An ideal is principal iff it contains an element which right-divides all
       elements.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
    lpigen $p |- ( ( R e. Ring /\ I e. U ) -> ( I e. P <->
        E. x e. I A. y e. I x .|| y ) ) $=
      ( crg wcel wa cv csn crsp cfv wrex wb eqid wceq cbs wbr islpidl lidldvgen
      wral adantr 3expa rexbidva simpr lidlssOLD sseld adantrd impbid2 rexbidv2
      ancrd 3bitrd ) EKLZGFLZMZGDLZGANZOEPQZQUAZAEUBQZRZVBGLZVBBNCUCBGUFZMZAVER
      VHAGRURVAVFSUSVEDEAGVCIVCTZVETZUDUGUTVDVIAVEURUSVBVELZVDVISBVECEFVBGVCVKH
      VJJUEUHUIUTVIVHAVEGUTVLVIMVIVLVIUJUTVIVLUTVGVLVHUTGVEVBVEGFKEVKHUKULUMUPU
      NUOUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Nonzero rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c NzRing $.

  $( The class of nonzero rings. $)
  cnzr $a class NzRing $.

  $( A nonzero or nontrivial ring is a ring with at least two values, or
     equivalently where 1 and 0 are different.  (Contributed by Stefan O'Rear,
     24-Feb-2015.) $)
  df-nzr $a |- NzRing = { r e. Ring | ( 1r ` r ) =/= ( 0g ` r ) } $.

  ${
    $d .1. r $.  $d R r $.  $d .0. r $.
    isnzr.o $e |- .1. = ( 1r ` R ) $.
    isnzr.z $e |- .0. = ( 0g ` R ) $.
    $( Property of a nonzero ring.  (Contributed by Stefan O'Rear,
       24-Feb-2015.) $)
    isnzr $p |- ( R e. NzRing <-> ( R e. Ring /\ .1. =/= .0. ) ) $=
      ( vr cv cur cfv c0g wne crg cnzr wceq fveq2 syl6eqr neeq12d df-nzr elrab2
      ) FGZHIZTJIZKBCKFALMTANZUABUBCUCUAAHIBTAHODPUCUBAJICTAJOEPQFRS $.

    $( One and zero are different in a nonzero ring.  (Contributed by Stefan
       O'Rear, 24-Feb-2015.) $)
    nzrnz $p |- ( R e. NzRing -> .1. =/= .0. ) $=
      ( cnzr wcel crg wne isnzr simprbi ) AFGAHGBCIABCDEJK $.
  $}

  $( A nonzero ring is a ring.  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
  nzrrng $p |- ( R e. NzRing -> R e. Ring ) $=
    ( cnzr wcel crg cur cfv c0g wne eqid isnzr simplbi ) ABCADCAEFZAGFZHALMLIMI
    JK $.

  $( All division rings are nonzero.  (Contributed by Stefan O'Rear,
     24-Feb-2015.) $)
  drngnzr $p |- ( R e. DivRing -> R e. NzRing ) $=
    ( cdr wcel crg cur cfv c0g wne cnzr drngrng eqid drngunz isnzr sylanbrc ) A
    BCADCAEFZAGFZHAICAJAOPPKZOKZLAOPRQMN $.

  ${
    $d B x y $.  $d R x y $.
    isnzr2.b $e |- B = ( Base ` R ) $.
    $( Equivalent characterization of nonzero rings: they have at least two
       elements.  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    isnzr2 $p |- ( R e. NzRing <-> ( R e. Ring /\ 2o ~<_ B ) ) $=
      ( vx vy wcel cfv wne wa c2o cdom wbr eqid c1o cv wceq wrex adantr cvv wb
      cnzr crg cur isnzr csdm wn rngidcl rng0cl simpr df-ne neeq1 syl5bbr neeq2
      c0g rspc2ev syl3anc ex wi rng1eq0 necon3bd rexlimdvva impbid fvex eqeltri
      3expb cbs 1sdom ax-mp syl6bbr csuc 1onn sucdom df-2o breq1i bitr4i syl6bb
      com pm5.32i bitri ) BUAFBUBFZBUCGZBUNGZHZIZVTJAKLZIBWAWBWAMZWBMZUDVTWCWEV
      TWCNAUELZWEVTWCDOZEOZPZUFZEAQDAQZWHVTWCWMVTWCWMWDWAAFZWBAFZWCWMVTWNWCABWA
      CWFUGRVTWOWCABWBCWGUHRVTWCUIWLWCWAWJHZDEWAWBAAWLWIWJHWIWAPWPWIWJUJWIWAWJU
      KULWJWBWAUMUOUPUQVTWLWCDEAAVTWIAFZWJAFZIIWKWAWBVTWQWRWAWBPWKURABWAWIWJWBC
      WFWGUSVEUTVAVBASFWHWMTABVFGSCBVFVCVDDEASVGVHVIWHNVJZAKLZWENVQFWHWTTVKNAVL
      VHJWSAKVMVNVOVPVRVS $.
  $}

  ${
    $d x y O $.  $d x y R $.
    opprnzr.1 $e |- O = ( oppR ` R ) $.
    $( The opposite of a nonzero ring is nonzero.  (Contributed by Mario
       Carneiro, 17-Jun-2015.) $)
    opprnzr $p |- ( R e. NzRing -> O e. NzRing ) $=
      ( cnzr wcel crg c2o cbs cfv wbr nzrrng opprrng syl isnzr2 simprbi opprbas
      cdom eqid sylanbrc ) ADEZBFEZGAHIZQJZBDETAFEZUAAKABCLMTUDUCUBAUBRZNOUBBUB
      ABCUEPNS $.
  $}

  ${
    rngelnzr.z $e |- .0. = ( 0g ` R ) $.
    rngelnzr.b $e |- B = ( Base ` R ) $.
    $( A ring is nonzero if it has a nonzero element.  (Contributed by Stefan
       O'Rear, 6-Feb-2015.)  (Revised by Mario Carneiro, 13-Jun-2015.) $)
    rngelnzr $p |- ( ( R e. Ring /\ X e. ( B \ { .0. } ) ) -> R e. NzRing ) $=
      ( crg wcel csn cdif wa cur cfv wne cnzr simpl eldifsni adantl wceq wi mpd
      eldifi rng0cl adantr eqid rng1eq0 syl3anc necon3d isnzr sylanbrc ) BGHZCA
      DIZJHZKZUKBLMZDNZBOHUKUMPZUNCDNZUPUMURUKCADQRUNUODCDUNUKCAHZDAHZUODSCDSTU
      QUMUSUKCAULUBRUKUTUMABDFEUCUDABUOCDDFUOUEZEUFUGUHUABUODVAEUIUJ $.
  $}

  ${
    nzrunit.1 $e |- U = ( Unit ` R ) $.
    nzrunit.2 $e |- .0. = ( 0g ` R ) $.
    $( A unit is nonzero in any nonzero ring.  (Contributed by Mario Carneiro,
       6-Oct-2015.) $)
    nzrunit $p |- ( ( R e. NzRing /\ A e. U ) -> A =/= .0. ) $=
      ( cnzr wcel wne wn wceq cur cfv eqid nzrnz crg wb nzrrng 0unit necon3bbid
      syl mpbird eleq1 notbid syl5ibrcom necon2ad imp ) BGHZACHZADIUHUIADUHUIJA
      DKZDCHZJZUHULBLMZDIZBUMDUMNZFOUHBPHZULUNQBRUPUKUMDBCUMDEFUOSTUAUBUJUIUKAD
      CUCUDUEUFUG $.
  $}

  ${
    subrgnzr.1 $e |- S = ( R |`s A ) $.
    $( A subring of a nonzero ring is nonzero.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    subrgnzr $p |- ( ( R e. NzRing /\ A e. ( SubRing ` R ) ) ->
        S e. NzRing ) $=
      ( cnzr wcel csubrg cfv wa crg cur c0g wne subrgrng adantl eqid nzrnz wceq
      adantr subrg1 subrg0 3netr3d isnzr sylanbrc ) BEFZABGHFZIZCJFZCKHZCLHZMCE
      FUFUHUEABCDNOUGBKHZBLHZUIUJUEUKULMUFBUKULUKPZULPZQSUFUKUIRUEABCUKDUMTOUFU
      LUJRUEABCULDUNUAOUBCUIUJUIPUJPUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Left regular elements.  More kinds of rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RLReg $. $( Left regular elemnts $)
  $c Domn $. $( Class of domains $)
  $c IDomn $. $( Class of integral domains $)
  $c PID $. $( Class of principal ideal domains $)

  $( Set of left-regular elements in a ring. $)
  crlreg $a class RLReg $.

  $( Class of (ring theoretic) domains. $)
  cdomn $a class Domn $.

  $( Class of integral domains. $)
  cidom $a class IDomn $.

  $( Class of principal ideal domains. $)
  cpid $a class PID $.

  ${
    $d b r x y z $.
    $( Define the set of _left-regular elements_ in a ring as those elements
       which are not left zero divisors, meaning that multiplying a nonzero
       element on the left by a left-regular element gives a nonzero product.
       (Contributed by Stefan O'Rear, 22-Mar-2015.) $)
    df-rlreg $a |- RLReg = ( r e. _V |-> { x e. ( Base ` r ) |
            A. y e. ( Base ` r ) ( ( x ( .r ` r ) y ) = ( 0g ` r ) ->
                y = ( 0g ` r ) ) } ) $.

    $( A _domain_ is a nonzero ring in which there are no nontrivial zero
       divisors.  (Contributed by Mario Carneiro, 28-Mar-2015.) $)
    df-domn $a |- Domn = { r e. NzRing | [. ( Base ` r ) / b ].
    [. ( 0g ` r ) / z ]. A. x e. b A. y e. b ( ( x ( .r ` r ) y ) = z ->
                    ( x = z \/ y = z ) ) } $.

    $( An _integral domain_ is a commutative domain.  (Contributed by Mario
       Carneiro, 17-Jun-2015.) $)
    df-idom $a |- IDomn = ( CRing i^i Domn ) $.

    $( A _principal ideal domain_ is an integral domain satisfying the left
       principal ideal property.  (Contributed by Stefan O'Rear,
       29-Mar-2015.) $)
    df-pid $a |- PID = ( IDomn i^i LPIR ) $.
  $}

  ${
    $d B r x y $.  $d R r x y $.  $d .x. r $.  $d .0. r $.
    rrgval.e $e |- E = ( RLReg ` R ) $.
    rrgval.b $e |- B = ( Base ` R ) $.
    rrgval.t $e |- .x. = ( .r ` R ) $.
    rrgval.z $e |- .0. = ( 0g ` R ) $.
    $( Value of the set or left-regular elements in a ring.  (Contributed by
       Stefan O'Rear, 22-Mar-2015.) $)
    rrgval $p |- E = { x e. B | A. y e. B ( ( x .x. y ) = .0. -> y = .0. ) } $=
      ( vr crlreg cfv cv wceq crab cvv cbs c0 co wi wral wcel cmulr c0g syl6eqr
      fveq2 oveqd eqeq12d eqeq2d imbi12d raleqbidv rabeqbidv fvex eqeltri rabex
      df-rlreg fvmpt wn fvprc syl5eq rabeq syl rab0 syl6eq eqtr4d pm2.61i eqtri
      ) FDMNZAOZBOZEUAZGPZVLGPZUBZBCUCZACQZHDRUDZVJVRPLDVKVLLOZUENZUAZVTUFNZPZV
      LWCPZUBZBVTSNZUCZAWGQVRRMVTDPZWHVQAWGCWIWGDSNZCVTDSUHIUGZWIWFVPBWGCWKWIWD
      VNWEVOWIWBVMWCGWIWAEVKVLWIWADUENEVTDUEUHJUGUIWIWCDUFNGVTDUFUHKUGZUJWIWCGV
      LWLUKULUMUNABLURVQACCWJRIDSUOUPUQUSVSUTZVJTVRDMVAWMVRVQATQZTWMCTPVRWNPWMC
      WJTIDSVAVBVQACTVCVDVQAVEVFVGVHVI $.

    $d .x. x $.  $d X x $.  $d X y $.  $d .0. x $.
    $( Membership in the set of left-regular elements.  (Contributed by Stefan
       O'Rear, 22-Mar-2015.) $)
    isrrg $p |- ( X e. E <-> ( X e. B /\
          A. y e. B ( ( X .x. y ) = .0. -> y = .0. ) ) ) $=
      ( vx cv co wceq wi wral oveq1 eqeq1d imbi1d ralbidv rrgval elrab2 ) LMZAM
      ZDNZGOZUEGOZPZABQFUEDNZGOZUHPZABQLFBEUDFOZUIULABUMUGUKUHUMUFUJGUDFUEDRSTU
      ALABCDEGHIJKUBUC $.

    $d .x. y $.  $d Y y $.  $d .0. y $.
    $( Property of a left-regular element.  (Contributed by Stefan O'Rear,
       22-Mar-2015.) $)
    rrgeq0i $p |- ( ( X e. E /\ Y e. B ) ->
      ( ( X .x. Y ) = .0. -> Y = .0. ) ) $=
      ( vy wcel cv co wceq wi wral isrrg simprbi oveq2 eqeq1d eqeq1 rspcv mpan9
      imbi12d ) EDMZELNZCOZGPZUHGPZQZLARZFAMEFCOZGPZFGPZQZUGEAMUMLABCDEGHIJKSTU
      LUQLFAUHFPZUJUOUKUPURUIUNGUHFECUAUBUHFGUCUFUDUE $.

    $( Left-multiplication by a left regular element does not change zeroness.
       (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
    rrgeq0 $p |- ( ( R e. Ring /\ X e. E /\ Y e. B ) ->
        ( ( X .x. Y ) = .0. <-> Y = .0. ) ) $=
      ( vx vy crg wcel w3a co wceq wi cv rrgeq0i 3adant1 simp1 wral crab rrgval
      ssrab2 eqsstri simp2 sseldi rngrz syl2anc oveq2 eqeq1d syl5ibrcom impbid
      ) BNOZEDOZFAOZPZEFCQZGRZFGRZURUSVBVCSUQABCDEFGHIJKUAUBUTVBVCEGCQZGRZUTUQE
      AOVEUQURUSUCUTDAEDLTMTZCQGRVFGRSMAUDZLAUEALMABCDGHIJKUFVGLAUGUHUQURUSUIUJ
      ABCEGIJKUKULVCVAVDGFGECUMUNUOUP $.

    ${
      $d ph x $.  $d E x $.  $d I x $.  $d Y x $.
      rrgsupp.i $e |- ( ph -> I e. V ) $.
      rrgsupp.r $e |- ( ph -> R e. Ring ) $.
      rrgsupp.x $e |- ( ph -> X e. E ) $.
      rrgsupp.y $e |- ( ph -> Y : I --> B ) $.
      $( Left multiplication by a left regular element does not change the
         support set of a vector.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      rrgsupp $p |- ( ph ->
        ( `' ( ( I X. { X } ) oF .x. Y ) " ( _V \ { .0. } ) ) =
             ( `' Y " ( _V \ { .0. } ) ) ) $=
        ( vx wcel cv cfv co cmpt ccnv cvv csn cdif cima cxp cof crab wa wne crg
        wceq wb adantr ffvelrnda syl3anc necon3bid ovex eldifsn mpbiran 3bitr4g
        rrgeq0 fvex rabbidva mptpreima 3eqtr4g fconstmpt feqmptd offval2 cnveqd
        eqid a1i imaeq1d 3eqtr4d ) ASFHSUAZIUBZDUCZUDZUEZUFJUGUHZUIZSFVTUDZUEZW
        DUIZFHUGUJZIDUKUCZUEZWDUIIUEZWDUIAWAWDTZSFULVTWDTZSFULWEWHAWMWNSFAVSFTZ
        UMZWAJUNZVTJUNZWMWNWPWAJVTJWPCUOTZHETZVTBTWAJUPVTJUPUQAWSWOPURAWTWOQURZ
        AFBVSIRUSBCDEHVTJKLMNVFUTVAWMWAUFTWQHVTDVBWAUFJVCVDWNVTUFTZWRVSIVGZVTUF
        JVCVDVEVHSFWAWDWBWBVOVISFVTWDWFWFVOVIVJAWKWCWDAWJWBASFHVTDWIIGEUFOXAXBW
        PXCVPWISFHUDUPASFHVKVPASFBIRVLZVMVNVQAWLWGWDAIWFXDVNVQVR $.
    $}
  $}

  ${
    $d B x y $.  $d R x y $.
    rrgss.e $e |- E = ( RLReg ` R ) $.
    rrgss.b $e |- B = ( Base ` R ) $.
    $( Left-regular elements are a subset of the base set.  (Contributed by
       Stefan O'Rear, 22-Mar-2015.) $)
    rrgss $p |- E C_ B $=
      ( vx vy cv cmulr cfv co c0g wceq wi wral crab eqid rrgval ssrab2 eqsstri
      ) CFHGHZBIJZKBLJZMUAUCMNGAOZFAPAFGABUBCUCDEUBQUCQRUDFAST $.
  $}

  ${
    $d E x $.  $d R x y $.  $d U x y $.
    unitrrg.e $e |- E = ( RLReg ` R ) $.
    unitrrg.u $e |- U = ( Unit ` R ) $.
    $( Units are regular elements.  (Contributed by Stefan O'Rear,
       22-Mar-2015.) $)
    unitrrg $p |- ( R e. Ring -> U C_ E ) $=
      ( vx vy crg wcel cv wa cbs cfv cmulr co c0g wceq wi eqid adantr cinvr cur
      unitcl adantl oveq2 unitlinv oveq1d simpll rnginvcl simpr rngass syl13anc
      wral rnglidm adantlr 3eqtr3d rngrz syl2anc eqeq12d syl5ib ralrimiva isrrg
      sylanbrc ex ssrdv ) AHIZFBCVFFJZBIZVGCIZVFVHKZVGALMZIZVGGJZANMZOZAPMZQZVM
      VPQZRZGVKUMVIVHVLVFVKABVGVKSZEUCUDZVJVSGVKVQVGAUAMZMZVOVNOZWCVPVNOZQVJVMV
      KIZKZVRVOVPWCVNUEWGWDVMWEVPWGWCVGVNOZVMVNOZAUBMZVMVNOZWDVMWGWHWJVMVNVJWHW
      JQWFAVNBWJWBVGEWBSZVNSZWJSZUFTUGWGVFWCVKIZVLWFWIWDQVFVHWFUHZVJWOWFVKABWBV
      GEWLVTUITZVJVLWFWATVJWFUJVKAVNWCVGVMVTWMUKULVFWFWKVMQVHVKAVNWJVMVTWMWNUNU
      OUPWGVFWOWEVPQWPWQVKAVNWCVPVTWMVPSZUQURUSUTVAGVKAVNCVGVPDVTWMWRVBVCVDVE
      $.
  $}

  ${
    $d B b r x y z $.  $d R b r x y z $.  $d .x. b r z $.  $d .0. b r x y z $.
    isdomn.b $e |- B = ( Base ` R ) $.
    isdomn.t $e |- .x. = ( .r ` R ) $.
    isdomn.z $e |- .0. = ( 0g ` R ) $.
    $( Expand definition of a domain.  (Contributed by Mario Carneiro,
       28-Mar-2015.) $)
    isdomn $p |- ( R e. Domn <-> ( R e. NzRing /\
     A. x e. B A. y e. B ( ( x .x. y ) = .0. -> ( x = .0. \/ y = .0. ) ) ) ) $=
      ( vr vz vb cv cmulr cfv wceq wral c0g cbs cvv co wo wi wsbc cnzr wcel a1i
      cdomn fvex fveq2 syl6eqr wa adantr proplem3 id eqeqan12d wb eqeq2 orbi12d
      simplr adantl imbi12d raleqbidv sbcied2 df-domn elrab2 ) AMZBMZJMZNOZUAZK
      MZPZVGVLPZVHVLPZUBZUCZBLMZQZAVRQZKVIROZUDZLVISOZUDVGVHEUAZFPZVGFPZVHFPZUB
      ZUCZBCQZACQZJDUEUHVIDPZWBWKLWCCTWCTUFWLVISUIUGWLWCDSOCVIDSUJGUKWLVRCPZULZ
      VTWKKWAFTWATUFWNVIRUIUGWNWADROZFWLWAWOPWMVIDRUJUMIUKWNVLFPZULZVSWJAVRCWLW
      MWPUTZWQVQWIBVRCWRWQVMWEVPWHWNWPVKWDVLFWLWMABVJEWLVJDNOEVIDNUJHUKUNWPUOUP
      WPVPWHUQWNWPVNWFVOWGVLFVGURVLFVHURUSVAVBVCVCVDVDABKJLVEVF $.
  $}

  ${
    $d x y .0. $.  $d x y B $.  $d x y R $.  $d x y .x. $.  $d x y X $.
    $d y Y $.
    $( A domain is a nonzero ring.  (Contributed by Mario Carneiro,
       28-Mar-2015.) $)
    domnnzr $p |- ( R e. Domn -> R e. NzRing ) $=
      ( vx vy cdomn wcel cnzr cv cmulr cfv co c0g wceq wo cbs wral eqid simplbi
      wi isdomn ) ADEAFEBGZCGZAHIZJAKIZLTUCLUAUCLMRCANIZOBUDOBCUDAUBUCUDPUBPUCP
      SQ $.

    $( A domain is a ring.  (Contributed by Mario Carneiro, 28-Mar-2015.) $)
    domnrng $p |- ( R e. Domn -> R e. Ring ) $=
      ( cdomn wcel cnzr crg domnnzr nzrrng syl ) ABCADCAECAFAGH $.

    domneq0.b $e |- B = ( Base ` R ) $.
    domneq0.t $e |- .x. = ( .r ` R ) $.
    domneq0.z $e |- .0. = ( 0g ` R ) $.
    $( In a domain, a product is zero iff it has a zero factor.  (Contributed
       by Mario Carneiro, 28-Mar-2015.) $)
    domneq0 $p |- ( ( R e. Domn /\ X e. B /\ Y e. B ) ->
        ( ( X .x. Y ) = .0. <-> ( X = .0. \/ Y = .0. ) ) ) $=
      ( vx vy wcel co wceq wo cv wi wral eqeq1d syl2anc cdomn w3a 3simpc isdomn
      cnzr simprbi 3ad2ant1 oveq1 eqeq1 orbi1d imbi12d oveq2 orbi2d rspc2va crg
      wa domnrng simp3 rnglz syl5ibrcom simp2 rngrz jaod impbid ) BUALZDALZEALZ
      UBZDECMZFNZDFNZEFNZOZVHVFVGUPJPZKPZCMZFNZVNFNZVOFNZOZQZKARJARZVJVMQZVEVFV
      GUCVEVFWBVGVEBUELWBJKABCFGHIUDUFUGWAWCDVOCMZFNZVKVSOZQJKDEAAVNDNZVQWEVTWF
      WGVPWDFVNDVOCUHSWGVRVKVSVNDFUIUJUKVOENZWEVJWFVMWHWDVIFVOEDCULSWHVSVLVKVOE
      FUIUMUKUNTVHVKVJVLVHVJVKFECMZFNZVHBUOLZVGWJVEVFWKVGBUQUGZVEVFVGURABCEFGHI
      USTVKVIWIFDFECUHSUTVHVJVLDFCMZFNZVHWKVFWNWLVEVFVGVAABCDFGHIVBTVLVIWMFEFDC
      ULSUTVCVD $.

    $( In a domain, a product of nonzero elements is nonzero.  (Contributed by
       Mario Carneiro, 6-May-2015.) $)
    domnmuln0 $p |- ( ( R e. Domn /\ ( X e. B /\ X =/= .0. ) /\
      ( Y e. B /\ Y =/= .0. ) ) -> ( X .x. Y ) =/= .0. ) $=
      ( cdomn wcel wne wa co an4 wceq wo wn wb domneq0 3expb necon3abid neanior
      syl6rbbr biimpd expimpd syl5bi 3impib ) BJKZDAKZDFLZMZEAKZEFLZMZDECNZFLZU
      LUOMUJUMMZUKUNMZMUIUQUJUKUMUNOUIURUSUQUIURMZUSUQUTUQDFPEFPQZRUSUTVAUPFUIU
      JUMUPFPVASABCDEFGHITUAUBDFEFUCUDUEUFUGUH $.
  $}

  ${
    $d B x y $.  $d E x $.  $d R x y $.  $d .0. x y $.
    isdomn2.b $e |- B = ( Base ` R ) $.
    isdomn2.t $e |- E = ( RLReg ` R ) $.
    isdomn2.z $e |- .0. = ( 0g ` R ) $.
    $( A ring is a domain iff all nonzero elements are non-zero-divisors.
       (Contributed by Mario Carneiro, 28-Mar-2015.) $)
    isdomn2 $p |- ( R e. Domn <-> ( R e. NzRing /\ ( B \ { .0. } ) C_ E ) ) $=
      ( vx vy wcel cv wceq wi wral wa imbi1i impexp bitri wn con34b cdomn cmulr
      cnzr cfv co csn cdif wss eqid isdomn dfss3 wne isrrg baib ralbiia eldifsn
      imbi2d ralbii2 ioran df-ne imbi12i 3bitr4i ralbii r19.21v bitr2i anbi2i
      wo ) BUAJBUCJZHKZIKZBUBUDZUEDLZVIDLZVJDLZVGZMZIANZHANZOVHADUFUGZCUHZOHIAB
      VKDEVKUIZGUJVRVTVHVTVICJZHVSNZVRHVSCUKVIDULZWBMZHANWDVLVNMZIANZMZHANWCVRW
      EWHHAVIAJZWBWGWDWBWIWGIABVKCVIDFEWAGUMUNUQUOWBWEHVSAVIVSJZWBMWIWDOZWBMWIW
      EMWJWKWBVIADUPPWIWDWBQRURVQWHHAVQWDWFMZIANWHVPWLIAVPVOSZVLSZMZWLVLVOTVMSZ
      VNSZOZWNMWPWQWNMZMWOWLWPWQWNQWMWRWNVMVNUSPWDWPWFWSVIDUTVLVNTVAVBRVCWDWFIA
      VDRVCVBVEVFR $.

    $( In a domain, any nonzero element is a non-zero-divisor.  (Contributed by
       Mario Carneiro, 28-Mar-2015.) $)
    domnrrg $p |- ( ( R e. Domn /\ X e. B /\ X =/= .0. ) -> X e. E ) $=
      ( cdomn wcel wne w3a csn cdif wss cnzr isdomn2 simprbi 3ad2ant1 simp2
      simp3 eldifsn sylanbrc sseldd ) BIJZDAJZDEKZLZAEMNZCDUEUFUICOZUGUEBPJUJAB
      CEFGHQRSUHUFUGDUIJUEUFUGTUEUFUGUADAEUBUCUD $.
  $}

  ${
    $d x y O $.  $d x y R $.
    opprdomn.1 $e |- O = ( oppR ` R ) $.
    $( The opposite of a domain is also a domain.  (Contributed by Mario
       Carneiro, 15-Jun-2015.) $)
    opprdomn $p |- ( R e. Domn -> O e. Domn ) $=
      ( vx vy cdomn wcel cnzr cv cmulr cfv co c0g wceq wo cbs wral domnnzr eqid
      wi opprnzr syl w3a domneq0 3com23 opprmul eqeq1i orcom 3bitr4g ralrimivva
      wb biimpd 3expb opprbas oppr0 isdomn sylanbrc ) AFGZBHGZDIZEIZBJKZLZAMKZN
      ZUTVDNZVAVDNZOZTZEAPKZQDVJQBFGURAHGUSARABCUAUBURVIDEVJVJURUTVJGZVAVJGZVIU
      RVKVLUCZVEVHVMVAUTAJKZLZVDNZVGVFOZVEVHURVLVKVPVQUKVJAVNVAUTVDVJSZVNSZVDSZ
      UDUEVCVOVDVJAVBVNBUTVAVRVSCVBSZUFUGVFVGUHUIULUMUJDEVJBVBVDVJABCVRUNWAABVD
      CVTUOUPUQ $.
  $}

  ${
    $d x y z A $.  $d x y z R $.
    abvn0b.b $e |- A = ( AbsVal ` R ) $.
    $( Another characterization of domains, hinted at in ~ abvtriv : a nonzero
       ring is a domain iff it has an absolute value.  (Contributed by Mario
       Carneiro, 6-May-2015.) $)
    abvn0b $p |- ( R e. Domn <-> ( R e. NzRing /\ A =/= (/) ) ) $=
      ( vx vy vz cdomn wcel cnzr c0 wne wa domnnzr cbs cfv c0g wceq eqid wral
      cv cc0 c1 cif cmpt cmulr domnrng domnmuln0 abvtrivd ne0i syl jca co wo wi
      wex n0 wn neanior abvdom 3expib syl5bi expdimp syl5bir ralrimivva exlimiv
      an4 necon4bd sylbi anim2i isdomn sylibr impbii ) BGHZBIHZAJKZLZVMVNVOBMVM
      DBNOZDTZBPOZQUAUBUCUDZAHVOVMDEFAVQBBUEOZVTVSCVQRZVSRZVTRWARZBUFVQBWAETZFT
      ZVSWBWDWCUGUHAVTUIUJUKVPVNWEWFWAULZVSQWEVSQWFVSQUMZUNZFVQSEVQSZLVMVOWJVNV
      OVRAHZDUOWJDAUPWKWJDWKWIEFVQVQWKWEVQHZWFVQHZLZLZWHWGVSWHUQWEVSKZWFVSKZLZW
      OWGVSKZWEVSWFVSURWKWNWRWSWNWRLWLWPLZWMWQLZLWKWSWLWMWPWQVFWKWTXAWSAVQBWAVR
      WEWFVSCWBWCWDUSUTVAVBVCVGVDVEVHVIEFVQBWAVSWBWDWCVJVKVL $.
  $}

  $( A division ring is a domain.  (Contributed by Mario Carneiro,
     29-Mar-2015.) $)
  drngdomn $p |- ( R e. DivRing -> R e. Domn ) $=
    ( cdr wcel cnzr cbs cfv c0g csn cdif crlreg wss cdomn drngnzr cui wceq eqid
    crg isdrng simprbi drngrng unitrrg syl eqsstr3d isdomn2 sylanbrc ) ABCZADCA
    EFZAGFZHIZAJFZKALCAMUFUIANFZUJUFAQCZUKUIOUGAUKUHUGPZUKPZUHPZRSUFULUKUJKATAU
    KUJUJPZUNUAUBUCUGAUJUHUMUPUOUDUE $.

  $( An integral domain is a commutative domain.  (Contributed by Mario
     Carneiro, 17-Jun-2015.) $)
  isidom $p |- ( R e. IDomn <-> ( R e. CRing /\ R e. Domn ) ) $=
    ( ccrg cdomn cidom df-idom elin2 ) ABCDEF $.

  $( A field is an integral domain.  (Contributed by Mario Carneiro,
     29-Mar-2015.) $)
  fldidom $p |- ( R e. Field -> R e. IDomn ) $=
    ( cfield wcel ccrg cdomn cidom cdr simprbi simplbi drngdomn isidom sylanbrc
    isfld syl ) ABCZADCZAECZAFCOAGCZPAMZHORQORPSIAJNAKL $.

  ${
    $d x y A $.  $d x y B $.  $d y F $.  $d y ph $.  $d x y R $.  $d x y .x. $.
    $d y .1. $.  $d y .0. $.
    fidomndrng.b $e |- B = ( Base ` R ) $.
    ${
      fidomndrng.z $e |- .0. = ( 0g ` R ) $.
      fidomndrng.o $e |- .1. = ( 1r ` R ) $.
      fidomndrng.d $e |- .|| = ( ||r ` R ) $.
      fidomndrng.t $e |- .x. = ( .r ` R ) $.
      fidomndrng.r $e |- ( ph -> R e. Domn ) $.
      fidomndrng.x $e |- ( ph -> B e. Fin ) $.
      fidomndrng.a $e |- ( ph -> A e. ( B \ { .0. } ) ) $.
      fidomndrng.f $e |- F = ( x e. B |-> ( x .x. A ) ) $.
      $( Lemma for ~ fidomndrng .  (Contributed by Mario Carneiro,
         15-Jun-2015.) $)
      fidomndrnglem $p |- ( ph -> A .|| .1. ) $=
        ( wcel vy ccnv cfv co wbr csn eldifad wf1o wf wf1 cv wceq wral wne cdif
        wi wa eldifsni syl ad2antrr oveq1 ovex fvmpt adantl eqeq1d cdomn adantr
        wo wb simpr domneq0 syl3anc bitrd biimpa ord necon1ad ex ralrimiva cghm
        mpd cmpt crg domnrng rngrghm syl2anc syl5eqel ghmf1 mpbird cen f1finf1o
        cfn enrefg f1ocnv f1of 3syl rngidcl ffvelrnd dvdsrmul cbvmptv f1ocnvfv2
        mpbid eqtri eqtr3d breqtrd ) ACHIUBZUCZCGUDZHEACDTZXFDTZCXGEUEACDJUFZRU
        GZADDHXEADDIUHZDDXEUHDDXEUIADDIUJZXLAXMUAUKZIUCZJULZXNJULZUPZUADUMZAXRU
        ADAXNDTZUQZXPXQYAXPUQZCJUNZXQAYCXTXPACDXJUOTYCRCDJURUSUTYBXQCJYBXQCJULZ
        YAXPXQYDVHZYAXPXNCGUDZJULZYEYAXOYFJXTXOYFULABXNBUKZCGUDZYFDIYHXNCGVAZSX
        NCGVBVCVDVEYAFVFTZXTXHYGYEVIAYKXTPVGAXTVJAXHXTXKVGDFGXNCJKOLVKVLVMVNVOV
        PVTVQVRAIFFVSUDZTXMXSVIAIBDYIWAZYLSAFWBTZXHYMYLTAYKYNPFWCUSZXKBDFGCKOWD
        WEWFUAFFJIDDJKKLLWGUSWHADDWIUEZDWKTZXMXLVIAYQYPQDWKWLUSQDDIWJWEXAZDDIWM
        DDXEWNWOAYNHDTZYODFHKMWPUSZWQZDEFGCXFKNOWRWEAXFIUCZXGHAXIUUBXGULUUAUAXF
        YFXGDIXNXFCGVAIYMUADYFWASBUADYIYFYJWSXBXFCGVBVCUSAXLYSUUBHULYRYTDDHIWTW
        EXCXD $.
    $}

    $( A finite domain is a division ring.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    fidomndrng $p |- ( B e. Fin -> ( R e. Domn <-> R e. DivRing ) ) $=
      ( vx vy wcel cdomn wa cfv wceq adantl wss eqid syl wb cv cdsr wbr cmulr
      co cfn cdr crg cui c0g csn cdif domnrng cin c0 cur cnzr wne domnnzr nzrnz
      neneqd 0unit mtbird disjsn sylibr unitss reldisj ax-mp sylib coppr simplr
      wn cmpt simpll simpr fidomndrnglem opprbas oppr0 opprdomn isunit sylanbrc
      oppr1 ex ssrdv eqssd isdrng drngdomn impbid1 ) AUAFZBGFZBUBFZWDWEWFWDWEHZ
      BUCFZBUDIZABUEIZUFZUGZJWFWEWHWDBUHKZWGWIWLWGWIWKUIUJJZWIWLLZWGWJWIFZVGWNW
      GWPBUKIZWJJZWGWQWJWGBULFZWQWJUMWEWSWDBUNKBWQWJWQMZWJMZUONUPWGWHWPWROWMBWI
      WQWJWIMZXAWTUQNURWIWJUSUTWIALWNWOOABWICXBVAWIWKAVBVCVDWGDWLWIWGDPZWLFZXCW
      IFZWGXDHZXCWQBQIZRXCWQBVEIZQIZRXEXFEXCAXGBBSIZWQEAEPZXCXJTVHZWJCXAWTXGMZX
      JMWDWEXDVFZWDWEXDVIZWGXDVJZXLMVKXFEXCAXIXHXHSIZWQEAXKXCXQTVHZWJABXHXHMZCV
      LBXHWJXSXAVMBWQXHXSWTVQXIMZXQMXFWEXHGFXNBXHXSVNNXOXPXRMVKXGBXHWIWQXIXCXBW
      TXMXSXTVOVPVRVSVTABWIWJCXBXAWAVPVRBWBWC $.

    $( A finite integral domain is a field.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    fiidomfld $p |- ( B e. Fin -> ( R e. IDomn <-> R e. Field ) ) $=
      ( cfn wcel cdomn wa cdr cidom cfield fidomndrng anbi2d isidom isfld ancom
      ccrg bitri 3bitr4g ) ADEZBPEZBFEZGTBHEZGZBIEBJEZSUAUBTABCKLBMUDUBTGUCBNUB
      TOQR $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Associative algebras
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c AssAlg $. $( Associative algebra $)
  $c AlgSpan $. $( Algebraic span $)
  $c algSc $.

  $( Associative algebra. $)
  casa $a class AssAlg $.

  $( Algebraic span function. $)
  casp $a class AlgSpan $.

  $( Class of algebra scalar injection function. $)
  cascl $a class algSc $.

  ${
    $d f r s t w x y $.
    $( Definition of an associative algebra.  An associative algebra is a set
       equipped with a left-module structure on a (commutative) ring, coupled
       with a multiplicative internal operation on the vectors of the module
       that is associative and distributive for the additive structure of the
       left-module (so giving the vectors a ring structure) and that is also
       bilinear under the scalar product.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    df-assa $a |- AssAlg = { w e. ( LMod i^i Ring )
      | [. ( Scalar ` w ) / f ].
        ( f e. CRing /\ A. r e. ( Base ` f ) A. x e. ( Base ` w )
        A. y e. ( Base ` w ) [. ( .s ` w ) / s ]. [. ( .r ` w ) / t ].
      ( ( ( r s x ) t y ) = ( r s ( x t y ) ) /\
        ( x t ( r s y ) ) = ( r s ( x t y ) ) ) ) } $.

    $( Define the algebraic span of a set of vectors in an algebra.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    df-asp $a |- AlgSpan = ( w e. AssAlg |-> ( s e. ~P ( Base ` w ) |->
      |^| { t e. ( ( SubRing ` w ) i^i ( LSubSp ` w ) ) | s C_ t } ) ) $.

    $( Every unital algebra contains a canonical homomorphic image of its ring
       of scalars as scalar multiples of the unit.  This names the
       homomorphism.  (Contributed by Mario Carneiro, 8-Mar-2015.) $)
    df-ascl $a |- algSc = ( w e. _V |-> ( x e. ( Base ` ( Scalar ` w ) ) |->
            ( x ( .s ` w ) ( 1r ` w ) ) ) ) $.
  $}

  ${
    $d r x y A $.  $d f r w B $.  $d f r w F $.  $d f r w x y V $.  $d x y X $.
    $d f r s t w x y .x. $.  $d f r s t w x y .X. $.  $d f r s t w x y W $.
    $d y Y $.
    isassa.v $e |- V = ( Base ` W ) $.
    isassa.f $e |- F = ( Scalar ` W ) $.
    isassa.b $e |- B = ( Base ` F ) $.
    isassa.s $e |- .x. = ( .s ` W ) $.
    isassa.t $e |- .X. = ( .r ` W ) $.
    $( The properties of an associative algebra.  (Contributed by Mario
       Carneiro, 29-Dec-2014.) $)
    isassa $p |- ( W e. AssAlg <-> ( ( W e. LMod /\ W e. Ring /\ F e. CRing )
                   /\ A. r e. B A. x e. V A. y e. V
      ( ( ( r .x. x ) .X. y ) = ( r .x. ( x .X. y ) ) /\
        ( x .X. ( r .x. y ) ) = ( r .x. ( x .X. y ) ) ) ) ) $=
      ( wcel cv co wceq wa cfv vf vs vt casa clmod crg cin ccrg wral cmulr wsbc
      vw w3a cvsca cbs csca cvv fvex fveq2 syl6eqr simpr eleq1d fveq2d ad2antrr
      a1i wb eqtrd simplr oveqd eqidd oveq123d eqeq12d anbi12d sbcied raleqbidv
      adantr sbcied2 df-assa elrab2 anass elin anbi1i df-3an bitr4i 3bitr2i ) H
      UDOHUEUFUGZOZFUHOZIPZAPZDQZBPZEQZWIWJWLEQZDQZRZWJWIWLDQZEQZWORZSZBGUIZAGU
      IZICUIZSZSWGWHSZXCSHUEOZHUFOZWHUMZXCSUAPZUHOZWIWJUBPZQZWLUCPZQZWIWJWLXMQZ
      XKQZRZWJWIWLXKQZXMQZXPRZSZUCULPZUJTZUKZUBYBUNTZUKZBYBUOTZUIZAYGUIZIXIUOTZ
      UIZSZUAYBUPTZUKXDULHWFUDYBHRZYLXDUAYMFUQYMUQOYNYBUPURVEYNYMHUPTFYBHUPUSKU
      TYNXIFRZSZXJWHYKXCYPXIFUHYNYOVAZVBYPYIXBIYJCYPYJFUOTCYPXIFUOYQVCLUTYNYIXB
      VFYOYNYHXAAYGGYNYGHUOTGYBHUOUSJUTZYNYFWTBYGGYRYNYDWTUBYEUQYEUQOYNYBUNURVE
      YNXKYERZSZYAWTUCYCUQYCUQOYTYBUJURVEYTXMYCRZSZXQWPXTWSUUBXNWMXPWOUUBXLWKWL
      WLXMEUUBXMYCEYTUUAVAUUBYCHUJTZEYNYCUUCRYSUUAYBHUJUSVDNUTVGZUUBXKDWIWJUUBX
      KYEDYNYSUUAVHUUBYEHUNTZDYNYEUUERYSUUAYBHUNUSVDMUTVGZVIUUBWLVJVKUUBWIWIXOW
      NXKDUUFUUBWIVJUUBXMEWJWLUUDVIVKZVLUUBXSWRXPWOUUBWJWJXRWQXMEUUDUUBWJVJUUBX
      KDWIWLUUFVIVKUUGVLVMVNVNVOVOVPVOVMVQABULUCUAUBIVRVSWGWHXCVTXEXHXCXEXFXGSZ
      WHSXHWGUUHWHHUEUFWAWBXFXGWHWCWDWBWE $.

    $( The properties of an associative algebra.  (Contributed by Mario
       Carneiro, 29-Dec-2014.) $)
    assalem $p |- ( ( W e. AssAlg /\ ( A e. B /\ X e. V /\ Y e. V ) ) ->
      ( ( ( A .x. X ) .X. Y ) = ( A .x. ( X .X. Y ) ) /\
        ( X .X. ( A .x. Y ) ) = ( A .x. ( X .X. Y ) ) ) ) $=
      ( vr wcel co wceq oveq1 eqeq12d vx vy casa cv wa wral w3a crg ccrg isassa
      clmod simprbi oveq1d oveq2d anbi12d oveq2 rspc3v mpan9 ) GUCPZOUDZUAUDZCQ
      ZUBUDZDQZUTVAVCDQZCQZRZVAUTVCCQZDQZVFRZUEZUBFUFUAFUFOBUFZABPHFPIFPUGAHCQZ
      IDQZAHIDQZCQZRZHAICQZDQZVPRZUEZUSGUKPGUHPEUIPUGVLUAUBBCDEFGOJKLMNUJULVKWA
      AVACQZVCDQZAVECQZRZVAAVCCQZDQZWDRZUEVMVCDQZAHVCDQZCQZRZHWFDQZWKRZUEOUAUBA
      HIBFFUTARZVGWEVJWHWOVDWCVFWDWOVBWBVCDUTAVACSUMUTAVECSZTWOVIWGVFWDWOVHWFVA
      DUTAVCCSUNWPTUOVAHRZWEWLWHWNWQWCWIWDWKWQWBVMVCDVAHACUPUMWQVEWJACVAHVCDSUN
      ZTWQWGWMWDWKVAHWFDSWRTUOVCIRZWLVQWNVTWSWIVNWKVPVCIVMDUPWSWJVOACVCIHDUPUNZ
      TWSWMVSWKVPWSWFVRHDVCIACUPUNWTTUOUQUR $.

    $( Left-associative property of an associative algebra.  (Contributed by
       Mario Carneiro, 29-Dec-2014.) $)
    assaass $p |- ( ( W e. AssAlg /\ ( A e. B /\ X e. V /\ Y e. V ) ) ->
      ( ( A .x. X ) .X. Y ) = ( A .x. ( X .X. Y ) ) ) $=
      ( casa wcel w3a wa co wceq assalem simpld ) GOPABPHFPIFPQRAHCSIDSAHIDSCSZ
      THAICSDSUCTABCDEFGHIJKLMNUAUB $.

    $( Right-associative property of an associative algebra.  (Contributed by
       Mario Carneiro, 29-Dec-2014.) $)
    assaassr $p |- ( ( W e. AssAlg /\ ( A e. B /\ X e. V /\ Y e. V ) ) ->
      ( X .X. ( A .x. Y ) ) = ( A .x. ( X .X. Y ) ) ) $=
      ( casa wcel w3a wa co wceq assalem simprd ) GOPABPHFPIFPQRAHCSIDSAHIDSCSZ
      THAICSDSUCTABCDEFGHIJKLMNUAUB $.
  $}

  ${
    $d x y z W $.  $d z F $.
    $( An associative algebra is a left module.  (Contributed by Mario
       Carneiro, 5-Dec-2014.) $)
    assalmod $p |- ( W e. AssAlg -> W e. LMod ) $=
      ( vz vx vy casa wcel clmod crg csca cfv ccrg w3a cv cvsca cmulr wceq wral
      co cbs eqid wa isassa simplbi simp1d ) AEFZAGFZAHFZAIJZKFZUEUFUGUILBMZCMZ
      ANJZRDMZAOJZRUJUKUMUNRULRZPUKUJUMULRUNRUOPUADASJZQCUPQBUHSJZQCDUQULUNUHUP
      ABUPTUHTUQTULTUNTUBUCUD $.

    $( An associative algebra is a ring.  (Contributed by Mario Carneiro,
       5-Dec-2014.) $)
    assarng $p |- ( W e. AssAlg -> W e. Ring ) $=
      ( vz vx vy casa wcel clmod crg csca cfv ccrg w3a cv cvsca cmulr wceq wral
      co cbs eqid wa isassa simplbi simp2d ) AEFZAGFZAHFZAIJZKFZUEUFUGUILBMZCMZ
      ANJZRDMZAOJZRUJUKUMUNRULRZPUKUJUMULRUNRUOPUADASJZQCUPQBUHSJZQCDUQULUNUHUP
      ABUPTUHTUQTULTUNTUBUCUD $.

    assasca.f $e |- F = ( Scalar ` W ) $.
    $( An associative algebra's scalar field is a commutative ring.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    assasca $p |- ( W e. AssAlg -> F e. CRing ) $=
      ( vz vx vy casa wcel clmod crg ccrg w3a cv cvsca cfv wceq cbs wral eqid
      co cmulr wa isassa simplbi simp3d ) BGHZBIHZBJHZAKHZUFUGUHUILDMZEMZBNOZTF
      MZBUAOZTUJUKUMUNTULTZPUKUJUMULTUNTUOPUBFBQOZREUPRDAQOZREFUQULUNAUPBDUPSCU
      QSULSUNSUCUDUE $.
  $}

  ${
    $d r x y B $.  $d r x y ph $.  $d x y V $.  $d r x y W $.
    isassad.v $e |- ( ph -> V = ( Base ` W ) ) $.
    isassad.f $e |- ( ph -> F = ( Scalar ` W ) ) $.
    isassad.b $e |- ( ph -> B = ( Base ` F ) ) $.
    isassad.s $e |- ( ph -> .x. = ( .s ` W ) ) $.
    isassad.t $e |- ( ph -> .X. = ( .r ` W ) ) $.
    isassad.1 $e |- ( ph -> W e. LMod ) $.
    isassad.2 $e |- ( ph -> W e. Ring ) $.
    isassad.3 $e |- ( ph -> F e. CRing ) $.
    isassad.4 $e |- ( ( ph /\ ( r e. B /\ x e. V /\ y e. V ) ) ->
      ( ( r .x. x ) .X. y ) = ( r .x. ( x .X. y ) ) ) $.
    isassad.5 $e |- ( ( ph /\ ( r e. B /\ x e. V /\ y e. V ) ) ->
      ( x .X. ( r .x. y ) ) = ( r .x. ( x .X. y ) ) ) $.
    $( Sufficient condition for being an associative algebra.  (Contributed by
       Mario Carneiro, 5-Dec-2014.) $)
    isassad $p |- ( ph -> W e. AssAlg ) $=
      ( clmod wcel crg csca cfv ccrg w3a cv cvsca co cmulr wceq wa cbs eqeltrrd
      wral casa 3jca jca ralrimivvva eqtrd oveqd eqidd oveq123d eqeq12d anbi12d
      fveq2d raleqbidv mpbid eqid isassa sylanbrc ) AIUAUBZIUCUBZIUDUEZUFUBZUGJ
      UHZBUHZIUIUEZUJZCUHZIUKUEZUJZVQVRWAWBUJZVSUJZULZVRVQWAVSUJZWBUJZWEULZUMZC
      IUNUEZUPZBWKUPZJVOUNUEZUPZIUQUBAVMVNVPPQAGVOUFLRUOURAVQVREUJZWAFUJZVQVRWA
      FUJZEUJZULZVRVQWAEUJZFUJZWSULZUMZCHUPZBHUPZJDUPWOAXDJBCDHHAVQDUBVRHUBWAHU
      BUGUMWTXCSTUSUTAXFWMJDWNADGUNUEWNMAGVOUNLVGVAAXEWLBHWKKAXDWJCHWKKAWTWFXCW
      IAWQWCWSWEAWPVTWAWAFWBOAEVSVQVRNVBAWAVCVDAVQVQWRWDEVSNAVQVCAFWBVRWAOVBVDZ
      VEAXBWHWSWEAVRVRXAWGFWBOAVRVCAEVSVQWANVBVDXGVEVFVHVHVHVIBCWNVSWBVOWKIJWKV
      JVOVJWNVJVSVJWBVJVKVL $.
  $}

  ${
    $d x y z A $.  $d x y z L $.  $d x y z S $.  $d x y z W $.
    issubassa.s $e |- S = ( W |`s A ) $.
    issubassa.l $e |- L = ( LSubSp ` W ) $.
    issubassa.v $e |- V = ( Base ` W ) $.
    issubassa.o $e |- .1. = ( 1r ` W ) $.
    $( The subalgebras of an associative algebra are exactly the subrings
       (under the ring multiplication) that are simultaneously subspaces (under
       the scalar multiplication from the vector space).  (Contributed by Mario
       Carneiro, 7-Jan-2015.) $)
    issubassa $p |- ( ( W e. AssAlg /\ .1. e. A /\ A C_ V ) ->
      ( S e. AssAlg <-> ( A e. ( SubRing ` W ) /\ A e. L ) ) ) $=
      ( wcel cfv wa crg co jca wceq ad2antrl eqid cv vy vz vx casa csubrg cress
      wss w3a simpl1 assarng syl adantl syl5eqelr simpl3 issubrg sylanbrc clmod
      simpl2 assalmod wb islss3 3syl mpbir2and cbs cvsca cmulr subrgss ressbas2
      csca resssca eqidd ressvsca ressmulr lsslmod syl2an subrgrng ccrg assasca
      simpr adantr simpll simpr1 simpr2 sseldd simpr3 assaass syl13anc assaassr
      isassad 3ad2antl1 impbida ) FUDKZCAKZAEUGZUHZBUDKZAFUELZKZADKZMZWOWPMZWRW
      SXAFNKZFAUFOZNKZMWNWMMWRXAXBXDXAWLXBWLWMWNWPUIZFUJUKXAXCBNGWPBNKZWOBUJULU
      MPXAWNWMWLWMWNWPUNZWLWMWNWPURPAEFCIJUOUPXAWSWNBUQKZXGWPXHWOBUSULXAWLFUQKZ
      WSWNXHMUTXEFUSZDAEFBGIHVAVBVCPWLWMWTWPWNWLWTMZUAUBFVILZVDLZFVELZFVFLZXLAB
      UCXKWNABVDLQWRWNWLWSAEFIVGRZAEBFGIVHUKWRXLBVILQWLWSAXLFBWQGXLSZVJRXKXMVKW
      RXNBVELQWLWSAXNFBWQGXNSZVLRWRXOBVFLQWLWSAFBXOWQGXOSZVMRWLXIWSXHWTXJWRWSVS
      DAFBGHVNVOWRXFWLWSAFBGVPRWLXLVQKWTXLFXQVRVTXKUCTZXMKZUATZAKZUBTZAKZUHZMZW
      LYAYBEKZYDEKZXTYBXNOYDXOOXTYBYDXOOXNOZQWLWTYFWAZXKYAYCYEWBZYGAEYBXKWNYFXP
      VTZXKYAYCYEWCWDZYGAEYDYMXKYAYCYEWEWDZXTXMXNXOXLEFYBYDIXQXMSZXRXSWFWGYGWLY
      AYHYIYBXTYDXNOXOOYJQYKYLYNYOXTXMXNXOXLEFYBYDIXQYPXRXSWHWGWIWJWK $.
  $}

  ${
    $d x y z A $.  $d x y z S $.  $d x y z W $.
    sraassa.a $e |- A = ( ( subringAlg ` W ) ` S ) $.
    $( The subring algebra over a commutative ring is an associative algebra.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    sraassa $p |- ( ( W e. CRing /\ S e. ( SubRing ` W ) ) ->
      A e. AssAlg ) $=
      ( vy vz vx wcel cfv wa cmulr co cbs wceq eqid adantl crg adantr cv cplusg
      ccrg csubrg cress a1i wss subrgss srabase srasca subrgbas sravsca sramulr
      clmod sralmod crngrng eqidd sraaddg proplem3 rngpropd mpbid subrgcrng w3a
      csra simpr1 sseldd simpr2 simpr3 rngass syl13anc cmgp ccmn crngmgp mgpbas
      ad2antrr mgpplusg cmn12 isassad ) CUAHZBCUBIHZJZEFBCKIZVTCBUCLZCMIZAGVSAB
      CABCVBIINVSDUDZVRBWBUEZVQBWBCWBOZUFPZUGZVSABCWCWFUHVRBWAMINVQBCWAWAOZUIPV
      SABCWCWFUJVSABCWCWFUKZVRAULHVQABCDUMPVSCQHZAQHVQWJVRCUNRZVSGEWBCAVSWBUOWG
      VSGSZWBHZESZWBHZJZGECTIATIVSABCWCWFUPUQVSWPGEVTAKIWIUQURUSBCWAWHUTVSWLBHZ
      WOFSZWBHZVAZJZWJWMWOWSWLWNVTLWRVTLWLWNWRVTLVTLZNVSWJWTWKRXABWBWLVSWDWTWFR
      VSWQWOWSVCVDZVSWQWOWSVEZVSWQWOWSVFZWBCVTWLWNWRWEVTOZVGVHXACVIIZVJHZWOWMWS
      WNWLWRVTLVTLXBNVQXHVRWTCXGXGOZVKVMXDXCXEWBVTXGWNWLWRWBCXGXIWEVLCVTXGXIXFV
      NVOVHVP $.
  $}

  $( The ring module over a commutative ring is an associative algebra.
     (Contributed by Mario Carneiro, 6-Oct-2015.) $)
  rlmassa $p |- ( R e. CRing -> ( ringLMod ` R ) e. AssAlg ) $=
    ( ccrg wcel cbs cfv csubrg crglmod casa crg crngrng eqid subrgid syl rlmval
    sraassa mpdan ) ABCZADEZAFECZAGEZHCQAICSAJRARKLMTRAANOP $.

  ${
    $d r w x y z K $.  $d r w x y z L $.  $d r w x y z P $.  $d r w x y z ph $.
    $d w x y z B $.
    assapropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    assapropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    assapropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    assapropd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    assapropd.5 $e |- ( ph -> F = ( Scalar ` K ) ) $.
    assapropd.6 $e |- ( ph -> F = ( Scalar ` L ) ) $.
    assapropd.7 $e |- P = ( Base ` F ) $.
    assapropd.8 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    $( If two structures have the same components (properties), one is an
       associative algebra iff the other one is.  (Contributed by Mario
       Carneiro, 8-Feb-2015.) $)
    assapropd $p |- ( ph -> ( K e. AssAlg <-> L e. AssAlg ) ) $=
      ( wcel co wceq wral vr vz vw clmod crg wa casa assalmod assarng lmodpropd
      wi jca a1i syl5ibr rngpropd jcad wb csca cfv ccrg w3a cv cvsca cbs eqtr3d
      cmulr eleq1d 3anbi123d adantr simpll simplrl simprl fveq2d syl5eq eleqtrd
      syl simprrl eqid lmodvscl syl3anc eleqtrrd simprrr proplem syl12anc eqtrd
      oveq1d simplrr rngcl eqeq12d anbi12d anassrs 2ralbidva ralbidva raleqbidv
      oveq2d raleqdv 3bitr3d isassa 3bitr4g ex pm5.21ndd ) AGUDQZGUEQZUFZGUGQZH
      UGQZXEXDUKAXEXBXCGUHGUIULUMAXFXBXCXFXBAHUDQZHUHABCDEFGHIJKMNOPUJZUNXFXCAH
      UEQZHUIABCDGHIJKLUOZUNUPAXDXEXFUQAXDUFZXBXCGURUSZUTQZVAZUAVBZUBVBZGVCUSZR
      ZUCVBZGVFUSZRZXOXPXSXTRZXQRZSZXPXOXSXQRZXTRZYCSZUFZUCGVDUSZTZUBYITZUAXLVD
      USZTZUFXGXIHURUSZUTQZVAZXOXPHVCUSZRZXSHVFUSZRZXOXPXSYSRZYQRZSZXPXOXSYQRZY
      SRZUUBSZUFZUCHVDUSZTZUBUUHTZUAYNVDUSZTZUFXEXFXKXNYPYMUULAXNYPUQXDAXBXGXCX
      IXMYOXHXJAXLYNUTAFXLYNMNVEVGVHVIXKYHUCDTZUBDTZUAETUUGUCDTZUBDTZUAETYMUULX
      KUUNUUPUAEXKXOEQZUFYHUUGUBUCDDXKUUQXPDQZXSDQZUFZYHUUGUQXKUUQUUTUFZUFZYDUU
      CYGUUFUVBYAYTYCUUBUVBYAXRXSYSRZYTUVBAXRDQUUSYAUVCSAXDUVAVJZUVBXRYIDUVBXBX
      OYLQZXPYIQZXRYIQAXBXCUVAVKZUVBXOEYLXKUUQUUTVLZUVBAEYLSZUVDAEFVDUSZYLOAFXL
      VDMVMVNZVPVOZUVBXPDYIXKUUQUURUUSVQZUVBADYISZUVDIVPZVOZXOXQXLYLYIGXPYIVRZX
      LVRZXQVRZYLVRZVSVTUVOWAXKUUQUURUUSWBZABCDDXTYSXRXSLWCWDUVBXRYRXSYSUVBAUUQ
      UURXRYRSUVDUVHUVMABCEDXQYQXOXPPWCWDWFWEUVBYCXOYBYQRZUUBUVBAUUQYBDQYCUWBSU
      VDUVHUVBYBYIDUVBXCUVFXSYIQZYBYIQAXBXCUVAWGUVPUVBXSDYIUWAUVOVOZYIGXTXPXSUV
      QXTVRZWHVTUVOWAABCEDXQYQXOYBPWCWDUVBYBUUAXOYQUVBAUURUUSYBUUASUVDUVMUWAABC
      DDXTYSXPXSLWCWDWOWEZWIUVBYFUUEYCUUBUVBYFXPYEYSRZUUEUVBAUURYEDQYFUWGSUVDUV
      MUVBYEYIDUVBXBUVEUWCYEYIQUVGUVLUWDXOXQXLYLYIGXSUVQUVRUVSUVTVSVTUVOWAABCDD
      XTYSXPYELWCWDUVBYEUUDXPYSUVBAUUQUUSYEUUDSUVDUVHUWAABCEDXQYQXOXSPWCWDWOWEU
      WFWIWJWKWLWMXKUUNYKUAEYLAUVIXDUVKVIXKUUMYJUBDYIAUVNXDIVIZXKYHUCDYIUWHWPWN
      WNXKUUPUUJUAEUUKAEUUKSXDAEUVJUUKOAFYNVDNVMVNVIXKUUOUUIUBDUUHADUUHSXDJVIZX
      KUUGUCDUUHUWIWPWNWNWQWJUBUCYLXQXTXLYIGUAUVQUVRUVTUVSUWEWRUBUCUUKYQYSYNUUH
      HUAUUHVRYNVRUUKVRYQVRYSVRWRWSWTXA $.
  $}

  ${
    $d s t w L $.  $d s t S $.  $d t T $.  $d s t w V $.  $d s t w W $.
    aspval.a $e |- A = ( AlgSpan ` W ) $.
    aspval.v $e |- V = ( Base ` W ) $.
    ${
      aspval.l $e |- L = ( LSubSp ` W ) $.
      $( Value of the algebraic closure operation inside an associative
         algebra.  (Contributed by Mario Carneiro, 7-Jan-2015.) $)
      aspval $p |- ( ( W e. AssAlg /\ S C_ V ) -> ( A ` S ) =
        |^| { t e. ( ( SubRing ` W ) i^i L ) | S C_ t } ) $=
        ( vs vw wcel wss cfv cv csubrg crab cint wceq cbs casa wa cpw cmpt casp
        cin clss fveq2 syl6eqr pweqd ineq12d rabeq inteqd mpteq12dv df-asp fvex
        syl cvv eqeltri pwex mptex fvmpt syl5eq fveq1d adantr simpr sylibr wrex
        elpw2 crg assarng subrgid clmod assalmod lss1 elin sylanbrc sseq2 sylan
        rspcev intexrab sylib sseq1 rabbidv eqid fvmptg syl2anc eqtrd ) FUALZCE
        MZUBZCBNZCJEUCZJOZAOZMZAFPNZDUFZQZRZUDZNZCWOMZAWRQZRZWIWLXBSWJWICBXAWIB
        FUENXAGKFJKOZTNZUCZWPAXFPNZXFUGNZUFZQZRZUDXAUAUEXFFSZJXHXMWMWTXNXGEXNXG
        FTNZEXFFTUHHUIUJXNXLWSXNXKWRSXLWSSXNXIWQXJDXFFPUHXNXJFUGNDXFFUGUHIUIUKW
        PAXKWRULUQUMUNKAJUOJWMWTEEXOURHFTUPUSZUTVAVBVCVDVEWKCWMLZXEURLZXBXESWKW
        JXQWIWJVFCEXPVIVGWKXCAWRVHZXRWIEWRLZWJXSWIEWQLZEDLZXTWIFVJLYAFVKEFHVLUQ
        WIFVMLYBFVNDEFHIVOUQEWQDVPVQXCWJAEWRWOECVRVTVSXCAWRWAWBJCWTXEWMURXAWNCS
        ZWSXDYCWPXCAWRWNCWOWCWDUMXAWEWFWGWH $.

      $( The algebraic span of a set of vectors is a vector subspace.
         (Contributed by Mario Carneiro, 7-Jan-2015.) $)
      asplss $p |- ( ( W e. AssAlg /\ S C_ V ) -> ( A ` S ) e. L ) $=
        ( vt casa wcel wss wa cfv cv csubrg cin crab cint cvv clmod c0 assalmod
        aspval wne adantr ssrab2 inss2 sstri a1i fvex syl6eqelr sylibr lssintcl
        intex syl3anc eqeltrd ) EJKZBDLZMZBANZBIOLZIEPNZCQZRZSZCIABCDEFGHUDZUTE
        UAKZVECLZVEUBUEZVFCKURVHUSEUCUFVIUTVEVDCVBIVDUGVCCUHUIUJUTVFTKVJUTVFVAT
        VGBAUKULVEUOUMVECEHUNUPUQ $.

      $( The algebraic span of a subalgebra is itself.  ( ~ spanid analog.)
         (Contributed by Mario Carneiro, 7-Jan-2015.) $)
      aspid $p |- ( ( W e. AssAlg /\ S e. ( SubRing ` W ) /\ S e. L ) ->
        ( A ` S ) = S ) $=
        ( vt casa wcel csubrg cfv w3a cv wss cin crab cint wceq 3ad2ant2 aspval
        simp1 subrgss syl2anc wa 3simpc elin sylibr intmin syl eqtrd ) EJKZBELM
        ZKZBCKZNZBAMZBIOPIUNCQZRSZBUQUMBDPZURUTTUMUOUPUCUOUMVAUPBDEGUDUAIABCDEF
        GHUBUEUQBUSKZUTBTUQUOUPUFVBUMUOUPUGBUNCUHUIIBUSUJUKUL $.
    $}

    $( The algebraic span of a set of vectors is a subring of the algebra.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    aspsubrg $p |- ( ( W e. AssAlg /\ S C_ V ) ->
      ( A ` S ) e. ( SubRing ` W ) ) $=
      ( vt casa wcel wss wa cfv cv csubrg clss cin crab cint eqid cvv aspval c0
      ssrab2 inss1 sstri fvex syl6eqelr intex sylibr subrgint sylancr eqeltrd
      wne ) DHIBCJKZBALZBGMJZGDNLZDOLZPZQZRZUQGABURCDEFURSUAZUNUTUQJUTUBUMZVAUQ
      IUTUSUQUPGUSUCUQURUDUEUNVATIVCUNVAUOTVBBAUFUGUTUHUIDUTUJUKUL $.

    $( Span preserves subset ordering.  ( ~ spanss analog.)  (Contributed by
       Mario Carneiro, 7-Jan-2015.) $)
    aspss $p |- ( ( W e. AssAlg /\ S C_ V /\ T C_ S ) ->
      ( A ` T ) C_ ( A ` S ) ) $=
      ( vt casa wcel wss w3a cv csubrg cfv crab cint syl wceq aspval clss wa wi
      cin simpl3 sstr2 ss2rabdv intss simp1 simp3 simp2 syl2anc 3adant3 3sstr4d
      sstrd eqid ) EIJZBDKZCBKZLZCHMZKZHENOEUAOZUDZPZQZBVAKZHVDPZQZCAOZBAOZUTVH
      VEKVFVIKUTVGVBHVDUTVAVDJZUBUSVGVBUCUQURUSVLUECBVAUFRUGVHVEUHRUTUQCDKVJVFS
      UQURUSUIUTCBDUQURUSUJUQURUSUKUOHACVCDEFGVCUPZTULUQURVKVISUSHABVCDEFGVMTUM
      UN $.

    $( A set of vectors is a subset of its span.  ( ~ spanss2 analog.)
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    aspssid $p |- ( ( W e. AssAlg /\ S C_ V ) -> S C_ ( A ` S ) ) $=
      ( vt casa wcel wss wa cv csubrg cfv clss cin crab cint ssintub eqid
      aspval syl5sseqr ) DHIBCJKBGLJGDMNDONZPZQRBBANGBUDSGABUCCDEFUCTUAUB $.
  $}

  ${
    $d w x K $.  $d w x .1. $.  $d w x .x. $.  $d w x W $.  $d x X $.
    asclfval.a $e |- A = ( algSc ` W ) $.
    asclfval.f $e |- F = ( Scalar ` W ) $.
    asclfval.k $e |- K = ( Base ` F ) $.
    asclfval.s $e |- .x. = ( .s ` W ) $.
    asclfval.o $e |- .1. = ( 1r ` W ) $.
    $( Function value of the algebraic scalars function.  (Contributed by Mario
       Carneiro, 8-Mar-2015.) $)
    asclfval $p |- A = ( x e. K |-> ( x .x. .1. ) ) $=
      ( vw cascl cfv cmpt csca cbs syl6eqr c0 cv cvv wcel wceq cur cvsca fveq2d
      co fveq2 eqidd oveq123d mpteq12dv df-ascl fveq2i eqtri fvex eqeltri mptex
      fvmpt wn fvprc mpt0 syl5eq base0 mpteq1d eqtr4d pm2.61i ) BGNOZAFAUAZDCUH
      ZPZHGUBUCZVHVKUDMGAMUAZQOZROZVIVMUEOZVMUFOZUHZPVKUBNVMGUDZAVOVRFVJVSVOERO
      ZFVSVNERVSVNGQOZEVMGQUIISUGJSVSVIVIVPDVQCVSVQGUFOCVMGUFUIKSVSVIUJVSVPGUEO
      DVMGUEUILSUKULAMUMAFVJFWAROZUBFVTWBJEWARIUNUOWARUPUQURUSVLUTZVHATVJPZVKWC
      VHTWDGNVAAVJVBSWCAFTVJWCFVTTJWCVTTROTWCETRWCEWATIGQVAVCUGVDSVCVEVFVGUO $.

    $( Value of a mapped algebra scalar.  (Contributed by Mario Carneiro,
       8-Mar-2015.) $)
    asclval $p |- ( X e. K -> ( A ` X ) = ( X .x. .1. ) ) $=
      ( vx cv co oveq1 asclfval ovex fvmpt ) MGMNZCBOGCBOEATGCBPMABCDEFHIJKLQGC
      BRS $.
  $}

  ${
    $d K x $.  $d W x $.
    asclfn.a $e |- A = ( algSc ` W ) $.
    asclfn.f $e |- F = ( Scalar ` W ) $.
    asclfn.k $e |- K = ( Base ` F ) $.
    $( Unconditional functionality of the algebra scalars function.
       (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    asclfn $p |- A Fn K $=
      ( vx cv cur cfv cvsca co ovex eqid asclfval fnmpti ) HCHIZDJKZDLKZMARSTNH
      ATSBCDEFGTOSOPQ $.
  $}

  ${
    $d x y A $.  $d x B $.  $d x y F $.  $d x K $.  $d x y ph $.  $d x y W $.
    asclf.a $e |- A = ( algSc ` W ) $.
    asclf.f $e |- F = ( Scalar ` W ) $.
    asclf.r $e |- ( ph -> W e. Ring ) $.
    asclf.l $e |- ( ph -> W e. LMod ) $.
    ${
      asclf.k $e |- K = ( Base ` F ) $.
      asclf.b $e |- B = ( Base ` W ) $.
      $( The algebra scalars function is a function into the base set.
         (Contributed by Mario Carneiro, 4-Jul-2015.) $)
      asclf $p |- ( ph -> A : K --> B ) $=
        ( vx cv cur cfv cvsca wcel adantr eqid co wa clmod crg rngidcl lmodvscl
        simpr syl syl3anc asclfval fmptd ) AMEMNZFOPZFQPZUAZCBAULERZUBFUCRZUPUM
        CRZUOCRAUQUPJSAUPUGAURUPAFUDRURICFUMLUMTZUEUHSULUNDECFUMLHUNTZKUFUIMBUN
        UMDEFGHKUTUSUJUK $.
    $}

    $( The algebra scalars function is a group homomorphism.  (Contributed by
       Mario Carneiro, 4-Jul-2015.) $)
    asclghm $p |- ( ph -> A e. ( F GrpHom W ) ) $=
      ( vx vy cplusg cfv cbs eqid crg wcel syl co wceq asclval cgrp clmod asclf
      lmodrng rnggrp cv cur cvsca adantr simprl simprr lmodvsdir syl13anc grpcl
      wa rngidcl 3expb sylan oveqan12d adantl 3eqtr4d isghmd ) AIJCKLZDKLZCDBCM
      LZDMLZVENZVFNZVCNZVDNZACOPZCUAPZADUBPZVKHCDFUDQCUEQZADOPZDUAPGDUEQABVFCVE
      DEFGHVGVHUCAIUFZVEPZJUFZVEPZUOZUOZVPVRVCRZDUGLZDUHLZRZVPWCWDRZVRWCWDRZVDR
      ZWBBLZVPBLZVRBLZVDRZWAVMVQVSWCVFPZWEWHSAVMVTHUIAVQVSUJAVQVSUKAWMVTAVOWMGV
      FDWCVHWCNZUPQUIVDVCVPVRWDCVEVFDWCVHVJFWDNZVGVIULUMWAWBVEPZWIWESAVLVTWPVNV
      LVQVSWPVEVCCVPVRVGVIUNUQURBWDWCCVEDWBEFVGWOWNTQVTWLWHSAVQVSWJWFWKWGVDBWDW
      CCVEDVPEFVGWOWNTBWDWCCVEDVREFVGWOWNTUSUTVAVB $.
  $}

  ${
    asclmul1.a $e |- A = ( algSc ` W ) $.
    asclmul1.f $e |- F = ( Scalar ` W ) $.
    asclmul1.k $e |- K = ( Base ` F ) $.
    asclmul1.v $e |- V = ( Base ` W ) $.
    asclmul1.t $e |- .X. = ( .r ` W ) $.
    asclmul1.s $e |- .x. = ( .s ` W ) $.
    $( Left multiplication by a lifted scalar is the same as the scalar
       operation.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    asclmul1 $p |- ( ( W e. AssAlg /\ R e. K /\ X e. V ) ->
        ( ( A ` R ) .X. X ) = ( R .x. X ) ) $=
      ( casa wcel cfv co wceq w3a cur eqid asclval 3ad2ant2 simp1 simp2 assarng
      oveq1d crg 3ad2ant1 rngidcl simp3 assaass syl13anc rnglidm syl2anc oveq2d
      syl 3eqtrd ) HPQZBFQZIGQZUAZBARZIDSBHUBRZCSZIDSZBVFIDSZCSZBICSVDVEVGIDVBV
      AVEVGTVCACVFEFHBJKLOVFUCZUDUEUIVDVAVBVFGQZVCVHVJTVAVBVCUFVAVBVCUGVDHUJQZV
      LVAVBVMVCHUHUKZGHVFMVKULUSVAVBVCUMZBFCDEGHVFIMKLONUNUOVDVIIBCVDVMVCVIITVN
      VOGHDVFIMNVKUPUQURUT $.

    $( Right multiplication by a lifted scalar is the same as the scalar
       operation.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    asclmul2 $p |- ( ( W e. AssAlg /\ R e. K /\ X e. V ) ->
        ( X .X. ( A ` R ) ) = ( R .x. X ) ) $=
      ( wcel cfv co wceq oveq2d casa w3a cur asclval 3ad2ant2 simp1 simp2 simp3
      crg assarng 3ad2ant1 rngidcl syl assaassr syl13anc rngridm syl2anc 3eqtrd
      eqid ) HUAPZBFPZIGPZUBZIBAQZDRIBHUCQZCRZDRZBIVEDRZCRZBICRVCVDVFIDVAUTVDVF
      SVBACVEEFHBJKLOVEUSZUDUETVCUTVAVBVEGPZVGVISUTVAVBUFUTVAVBUGUTVAVBUHZVCHUI
      PZVKUTVAVMVBHUJUKZGHVEMVJULUMBFCDEGHIVEMKLONUNUOVCVHIBCVCVMVBVHISVNVLGHDV
      EIMNVJUPUQTUR $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y W $.
    asclrhm.a $e |- A = ( algSc ` W ) $.
    asclrhm.f $e |- F = ( Scalar ` W ) $.
    $( The scalar injection is a ring homomorphism.  (Contributed by Mario
       Carneiro, 8-Mar-2015.) $)
    asclrhm $p |- ( W e. AssAlg -> A e. ( F RingHom W ) ) $=
      ( vx vy wcel cbs cfv cmulr cur eqid syl co asclval adantr oveq2d syl13anc
      wceq casa ccrg crg assasca crngrng assarng cvsca rngidcl assalmod lmodvs1
      3syl clmod syl2anc eqtrd cv rnglidm simpl simprl lmodvscl syl3anc assaass
      wa simprr assaassr lmodvsass 3eqtr4rd rngcl 3expb oveq12d 3eqtr4d asclghm
      sylan isrhm2d ) CUAHZFGBIJZBCBKJZCKJZBLJZACLJZVOMZVRMZVSMZVPMZVQMZVNBUBHB
      UCHZBCEUDBUENZCUFZVNVRAJZVRVSCUGJZOZVSVNWEVRVOHWHWJTWFVOBVRVTWAUHAWIVSBVO
      CVRDEVTWIMZWBPUKVNCULHZVSCIJZHZWJVSTCUIZVNCUCHZWNWGWMCVSWMMZWBUHNZWIVRBWM
      CVSWQEWKWAUJUMUNVNFUOZVOHZGUOZVOHZVBZVBZWSXAVPOZVSWIOZWSVSWIOZXAVSWIOZVQO
      ZXEAJZWSAJZXAAJZVQOXDWSXAVSVSVQOZWIOZWIOZWSXHWIOZXIXFXDXNXHWSWIXDXMVSXAWI
      VNXMVSTZXCVNWPWNXQWGWRWMCVQVSVSWQWDWBUPUMQRRXDXIWSVSXHVQOZWIOZXOXDVNWTWNX
      HWMHZXIXSTVNXCUQZVNWTXBURZVNWNXCWRQZXDWLXBWNXTVNWLXCWOQZVNWTXBVCZYCXAWIBV
      OWMCVSWQEWKVTUSUTWSVOWIVQBWMCVSXHWQEVTWKWDVASXDXRXNWSWIXDVNXBWNWNXRXNTYAY
      EYCYCXAVOWIVQBWMCVSVSWQEVTWKWDVDSRUNXDWLWTXBWNXFXPTYDYBYEYCWSXAWIVPBVOWMC
      VSWQEWKVTWCVESVFXDXEVOHZXJXFTVNWEXCYFWFWEWTXBYFVOBVPWSXAVTWCVGVHVLAWIVSBV
      OCXEDEVTWKWBPNXDXKXGXLXHVQXDWTXKXGTYBAWIVSBVOCWSDEVTWKWBPNXDXBXLXHTYEAWIV
      SBVOCXADEVTWKWBPNVIVJVNABCDEWGWOVKVM $.
  $}

  ${
    $d N x y $.  $d .1. x y $.  $d W x y $.
    rnascl.a $e |- A = ( algSc ` W ) $.
    rnascl.o $e |- .1. = ( 1r ` W ) $.
    rnascl.n $e |- N = ( LSpan ` W ) $.
    $( The set of injected scalars is also interpretable as the span of the
       identity.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    rnascl $p |- ( W e. AssAlg -> ran A = ( N ` { .1. } ) ) $=
      ( vx vy casa wcel csn cfv cv cvsca co wceq csca cbs eqid cab crn assalmod
      wrex clmod crg assarng rngidcl syl lspsn syl2anc asclfval rnmpt syl6reqr
      ) DJKZBLCMZHNINBDOMZPZQIDRMZSMZUDHUAZAUBUODUEKBDSMZKZUPVAQDUCUODUFKVCDUGV
      BDBVBTZFUHUIHUQIUSUTCVBDBUSTZUTTZVDUQTZGUJUKIHUTURAIAUQBUSUTDEVEVFVGFULUM
      UN $.
  $}

  ${
    $d S x $.  $d W x $.  $d X x $.
    ressascl.a $e |- A = ( algSc ` W ) $.
    ressascl.x $e |- X = ( W |`s S ) $.
    $( The injection of scalars is invariant between subalgebras and
       superalgebras.  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    ressascl $p |- ( S e. ( SubRing ` W ) -> A = ( algSc ` X ) ) $=
      ( vx csubrg cfv wcel csca cbs cv cur cvsca co cmpt cascl eqid asclfval
      resssca fveq2d ressvsca eqidd subrg1 oveq123d mpteq12dv 3eqtr4g ) BCHIZJZ
      GCKIZLIZGMZCNIZCOIZPZQGDKIZLIZUMDNIZDOIZPZQADRIZUJGULUPURVAUJUKUQLBUKCDUI
      FUKSZUAUBUJUMUMUNUSUOUTBUOCDUIFUOSZUCUJUMUDBCDUNFUNSZUEUFUGGAUOUNUKULCEVC
      ULSVDVETGVBUTUSUQURDVBSUQSURSUTSUSSTUH $.
  $}

  ${
    $d x y A $.  $d x y L $.  $d x y S $.  $d x y W $.
    issubassa2.a $e |- A = ( algSc ` W ) $.
    issubassa2.l $e |- L = ( LSubSp ` W ) $.
    $( A subring of a unital algebra is a subspace and thus a subalgebra iff it
       contains all scalar multiples of the identity.  (Contributed by Mario
       Carneiro, 9-Mar-2015.) $)
    issubassa2 $p |- ( ( W e. AssAlg /\ S e. ( SubRing ` W ) ) ->
        ( S e. L <-> ran A C_ S ) ) $=
      ( vx vy wcel cfv wa wss wceq eqid ad2antrr ad2antlr cv co wral cbs csubrg
      casa crn cur clspn rnascl clmod assalmod simpr subrg1cl lspsnel5a eqsstrd
      csubg cvsca csca subrgsubg simplll simprl subrgss sselda adantrl asclmul1
      csn cmulr syl3anc simpllr simplr wfn asclfn fnfvelrn sylan sseldd adantrr
      a1i simprr subrgmcl eqeltrrd ralrimivva wb islss4 syl mpbir2and impbida )
      DUBIZBDUAJIZKZBCIZAUCZBLZWFWGKZWHDUDJZVCDUEJZJZBWDWHWMMWEWGAWKWLDEWKNZWLN
      ZUFOWJCBWLDWKFWOWDDUGIZWEWGDUHZOWFWGUIWEWKBIWDWGBDWKWNUJPUKULWFWIKZWGBDUM
      JIZGQZHQZDUNJZRZBIZHBSGDUOJZTJZSZWEWSWDWIBDUPPWRXDGHXFBWRWTXFIZXABIZKZKZW
      TAJZXADVDJZRZXCBXKWDXHXADTJZIZXNXCMWDWEWIXJUQWRXHXIURWRXIXPXHWRBXOXAWEBXO
      LWDWIBXODXONZUSPUTVAAWTXBXMXEXFXODXAEXENZXFNZXQXMNZXBNZVBVEXKWEXLBIZXIXNB
      IWDWEWIXJVFWRXHYBXIWRXHKWHBXLWFWIXHVGWRAXFVHZXHXLWHIYCWRAXEXFDEXRXSVIVNXF
      WTAVJVKVLVMWRXHXIVOBDXMXLXAXTVPVEVQVRWDWGWSXGKVSZWEWIWDWPYDWQXFCXBBXEXODG
      HXRXSXQYAFVTWAOWBWC $.
  $}

  ${
    $d x y z K $.  $d x y z L $.  $d x y z P $.  $d x y z ph $.  $d x y W $.
    $d z F $.  $d z G $.
    asclpropd.f $e |- F = ( Scalar ` K ) $.
    asclpropd.g $e |- G = ( Scalar ` L ) $.
    asclpropd.1 $e |- ( ph -> P = ( Base ` F ) ) $.
    asclpropd.2 $e |- ( ph -> P = ( Base ` G ) ) $.
    asclpropd.3 $e |- ( ( ph /\ ( x e. P /\ y e. W ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    asclpropd.4 $e |- ( ph -> ( 1r ` K ) = ( 1r ` L ) ) $.
    asclpropd.5 $e |- ( ph -> ( 1r ` K ) e. W ) $.
    $( If two structures have the same components (properties), one is an
       associative algebra iff the other one is.  The last hypotheses on ` 1r `
       can be discharged either by letting ` W = _V ` (if strong equality is
       known on ` .s ` ) or assuming ` K ` is a ring.  (Contributed by Mario
       Carneiro, 5-Jul-2015.) $)
    asclpropd $p |- ( ph -> ( algSc ` K ) = ( algSc ` L ) ) $=
      ( vz cfv cmpt eqid cbs cv cur cvsca co cascl wcel wa wceq proplem anassrs
      adantr mpdan oveq2d eqtrd mpteq2dva mpteq1d 3eqtr3d asclfval 3eqtr4g ) AQ
      EUARZQUBZGUCRZGUDRZUEZSZQFUARZVBHUCRZHUDRZUEZSZGUFRZHUFRZAQDVESQDVJSVFVKA
      QDVEVJAVBDUGZUHZVEVBVCVIUEZVJVOVCIUGZVEVPUIZAVQVNPULAVNVQVRABCDIVDVIVBVCN
      UJUKUMAVPVJUIVNAVCVHVBVIOUNULUOUPAQDVAVELUQAQDVGVJMUQURQVLVDVCEVAGVLTJVAT
      VDTVCTUSQVMVIVHFVGHVMTKVGTVITVHTUSUT $.
  $}

  ${
    $d x C $.  $d x R $.  $d x S $.  $d x V $.  $d x W $.
    aspval2.a $e |- A = ( AlgSpan ` W ) $.
    aspval2.c $e |- C = ( algSc ` W ) $.
    aspval2.r $e |- R = ( mrCls ` ( SubRing ` W ) ) $.
    aspval2.v $e |- V = ( Base ` W ) $.
    $( The algebraic closure is the ring closure when the generating set is
       expanded to include all scalars. _EDITORIAL_ :  In light of this, is
       ` AlgSpan ` independently needed?  (Contributed by Stefan O'Rear,
       9-Mar-2015.) $)
    aspval2 $p |- ( ( W e. AssAlg /\ S C_ V ) -> ( A ` S ) =
        ( R ` ( ran C u. S ) ) ) $=
      ( vx wcel wss wa cfv crab cint cab eqid adantr casa cv csubrg cin crn cun
      clss wceq elin anbi1i anass issubassa2 anbi1d unss syl6bb pm5.32da syl5bb
      bitri abbidv df-rab 3eqtr4g inteqd cmre crg assarng subrgmre syl csca cbs
      aspval wf assalmod asclf frn simpr unssd mrcval syl2anc 3eqtr4d ) FUALZDE
      MZNZDKUBZMZKFUCOZFUGOZUDZPZQBUEZDUFZWCMZKWEPZQZDAOWJCOZWBWHWLWBWCWGLZWDNZ
      KRZWCWELZWKNZKRZWHWLVTWQWTUHWAVTWPWSKWPWRWCWFLZWDNZNZVTWSWPWRXANZWDNXCWOX
      DWDWCWEWFUIUJWRXAWDUKURVTWRXBWKVTWRNZXBWIWCMZWDNWKXEXAXFWDBWCWFFHWFSZULUM
      WIDWCUNUOUPUQUSTWDKWGUTWKKWEUTVAVBKADWFEFGJXGVJWBWEEVCOLZWJEMWNWMUHVTXHWA
      VTFVDLXHFVEZEFJVFVGTWBWIDEVTWIEMZWAVTFVHOZVIOZEBVKXJVTBEXKXLFHXKSXIFVLXLS
      JVMXLEBVNVGTVTWAVOVPWEWJCEKIVQVRVS $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Abstract multivariate polynomials
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c mPwSer $. $( Multivariate power series $)
  $c mVar $. $( Multivariate power series variables $)
  $c mPoly $. $( Multivariate polynomial $)
  $c evalSub $. $( Evaluation in a superring $)
  $c eval $. $( Evaluation of a multivariate polynomial $)
  $c mHomP $. $( Homogeneous polynomials $)
  $c mPSDer $. $( Polynomial or power series derivative $)
  $c <bag $. $( Order on terms $)
  $c ordPwSer $. $( Order on power series $)
  $c selectVars $. $( Treat polynomial as a polynomial of polynomials $)
  $c AlgInd $. $( Algebraically independent $)

  $( Multivariate power series. $)
  cmps $a class mPwSer $.

  $( Multivariate power series variables. $)
  cmvr $a class mVar $.

  $( Multivariate polynomials. $)
  cmpl $a class mPoly $.

  $( Evaluation in a superring. $)
  ces $a class evalSub $.

  $( Evaluation of a multivariate polynomial. $)
  cevl $a class eval $.

  $( Multivariate polynomials. $)
  cmhp $a class mHomP $.

  $( Power series partial derivative function. $)
  cpsd $a class mPSDer $.

  $( Ordering on terms of a multivariate polynomial. $)
  cltb $a class <bag $.

  $( Ordered set of power series. $)
  copws $a class ordPwSer $.

  $( Select a subset of variables in a multivariate polynomial. $)
  cslv $a class selectVars $.

  $( Algebraically independent. $)
  cai $a class AlgInd $.

  ${
    $d b c d f g h i j k n p r s v w x y z $.
    $( Define the algebra of power series over the index set ` i ` and with
       coefficients from the ring ` r ` .  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    df-psr $a |- mPwSer = ( i e. _V , r e. _V |->
    [_ { h e. ( NN0 ^m i ) | ( `' h " NN ) e. Fin } / d ]_
    [_ ( ( Base ` r ) ^m d ) / b ]_
    ( { <. ( Base ` ndx ) , b >. ,
        <. ( +g ` ndx ) , ( oF ( +g ` r ) |` ( b X. b ) ) >. ,
        <. ( .r ` ndx ) ,
          ( f e. b , g e. b |-> ( k e. d |->
            ( r gsum ( x e. { y e. d | y oR <_ k } |->
            ( ( f ` x ) ( .r ` r ) ( g ` ( k oF - x ) ) ) ) ) ) ) >. } u.
      { <. ( Scalar ` ndx ) , r >. ,
        <. ( .s ` ndx ) , ( x e. ( Base ` r ) , f e. b |->
             ( ( d X. { x } ) oF ( .r ` r ) f ) ) >. ,
        <. ( TopSet ` ndx ) ,
             ( Xt_ ` ( d X. { ( TopOpen ` r ) } ) ) >. } ) ) $.

    $( Define the generating elements of the power series algebra.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    df-mvr $a |- mVar = ( i e. _V , r e. _V |-> ( x e. i |->
      ( f e. { h e. ( NN0 ^m i ) | ( `' h " NN ) e. Fin } |->
        if ( f = ( y e. i |-> if ( y = x , 1 , 0 ) ) ,
             ( 1r ` r ) , ( 0g ` r ) ) ) ) ) $.

    $( Define the subalgebra of the power series algebra generated by the
       variables; this is the polynomial algebra (the set of power series with
       finite degree).  (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    df-mpl $a |- mPoly = ( i e. _V , r e. _V |-> [_ ( i mPwSer r ) / w ]_
      ( w |`s { f e. ( Base ` w ) |
        ( `' f " ( _V \ { ( 0g ` r ) } ) ) e. Fin } ) ) $.

    $( Define the evaluation map for the polynomial algebra.  The function
       ` ( ( I evalSub S ) `` R ) : V --> ( S ^m ( S ^m I ) ) ` makes sense
       when ` I ` is an index set, ` S ` is a ring, ` R ` is a subring of
       ` S ` , and where ` V ` is the set of polynomials in
       ` ( I mPoly R ) ` .  This function maps an element of the formal
       polynomial algebra (with coefficients in ` R ` ) to a function from
       assignments ` I --> S ` of the variables to elements of ` S ` formed by
       evaluating the polynomial with the given assignments.  (Contributed by
       Stefan O'Rear, 11-Mar-2015.) $)
    df-evls $a |- evalSub = ( i e. _V , s e. CRing |-> [_ ( Base ` s ) / b ]_
      ( r e. ( SubRing ` s ) |-> [_ ( i mPoly ( s |`s r ) ) / w ]_
        ( iota_ f e. ( w RingHom ( s ^s ( b ^m i ) ) )
        ( ( f o. ( algSc ` w ) ) = ( x e. r |-> ( ( b ^m i ) X. { x } ) ) /\
          ( f o. ( i mVar ( s |`s r ) ) ) = ( x e. i |-> ( g e. ( b ^m i ) |->
        ( g ` x ) ) ) ) ) ) ) $.

    $( A simplication of ` evalSub ` when the evaluation ring is the same as
       the coefficient ring.  (Contributed by Stefan O'Rear, 19-Mar-2015.) $)
    df-evl $a |- eval = ( i e. _V , r e. _V |->
      ( ( i evalSub r ) ` ( Base ` r ) ) ) $.

    $( Define the subspaces of order- ` n ` homogeneous polynomials.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    df-mhp $a |- mHomP = ( i e. _V , r e. _V |-> ( n e. NN0 |->
      { f e. ( Base ` ( i mPoly r ) ) | ( `' f " ( _V \ { ( 0g ` r ) } ) ) C_
        { g e. { h e. ( NN0 ^m i ) | ( `' h " NN ) e. Fin } |
          sum_ j e. NN0 ( g ` j ) = n } } ) ) $.

    $( Define the differentiation operation on multivariate polynomials.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    df-psd $a |- mPSDer = ( i e. _V , r e. _V |-> ( x e. i |->
      ( f e. ( Base ` ( i mPwSer r ) ) |->
        ( k e. { h e. ( NN0 ^m i ) | ( `' h " NN ) e. Fin } |->
          ( ( ( k ` x ) + 1 ) ( .g ` r ) ( f `
            ( k oF + ( y e. i |-> if ( y = x , 1 , 0 ) ) ) ) ) ) ) ) ) $.

    $( Define a well-order on the set of all finite bags from the index set
       ` i ` given a wellordering ` r ` of ` i ` .  (Contributed by Mario
       Carneiro, 8-Feb-2015.) $)
    df-ltbag $a |- <bag = ( r e. _V , i e. _V |-> { <. x , y >. |
      ( { x , y } C_ { h e. ( NN0 ^m i ) | ( `' h " NN ) e. Fin } /\
        E. z e. i ( ( x ` z ) < ( y ` z ) /\
          A. w e. i ( z r w -> ( x ` w ) = ( y ` w ) ) ) ) } ) $.

    $( Define a total order on the set of all power series in ` s ` from the
       index set ` i ` given a wellordering ` r ` of ` i ` and a totally
       ordered base ring ` s ` .  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    df-opsr $a |- ordPwSer = ( i e. _V , s e. _V |-> ( r e. ~P ( i X. i )
   |-> [_ ( i mPwSer s ) / p ]_ ( p sSet <. ( le ` ndx ) , { <. x , y >. |
     ( { x , y } C_ ( Base ` p ) /\ ( [. { h e. ( NN0 ^m i ) | ( `' h " NN ) e.
      Fin } / d ]. E. z e. d ( ( x ` z ) ( lt ` s ) ( y ` z ) /\ A. w e. d
     ( w ( r <bag i ) z -> ( x ` w ) = ( y ` w ) ) ) \/ x = y ) ) } >. ) ) ) $.

    $( Define the "variable selection" function.  The function
       ` ( ( I selectVars R ) `` J ) ` maps elements of ` ( I mPoly R ) `
       bijectively onto ` ( J mPoly ( ( I \ J ) mPoly R ) ) ` in the natural
       way, for example if ` I = { x , y } ` and ` J = { y } ` it would map
       ` 1 + x + y + x y e. ( { x , y } mPoly ZZ ) ` to
       ` ( 1 + x ) + ( 1 + x ) y e. ( { y } mPoly ( { x } mPoly ZZ ) ) ` .
       This, for example, allows one to treat a multivariate polynomial as a
       univariate polynomial with coefficients in a polynomial ring with one
       less variable.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    df-selv $a |- selectVars = ( i e. _V , r e. _V |->
      ( j e. ~P i |-> ( f e. ( i mPoly r ) |->
      [_ ( ( i \ j ) mPoly r ) / s ]_ [_ ( x e. ( Scalar ` s ) |->
      ( x ( .s ` s ) ( 1r ` s ) ) ) / c ]_
        ( ( ( ( i evalSub s ) ` ( c "s r ) ) ` ( c o. f ) ) `
          ( x e. i |-> if ( x e. j , ( ( j mVar ( ( i \ j ) mPoly r ) ) ` x ) ,
            ( c o. ( ( ( i \ j ) mVar r ) ` x ) ) ) ) ) ) ) ) $.

    $( Define the predicate "the set ` v ` is algebraically independent in the
       algebra ` w ` ".  A collection of vectors is algebraically independent
       if no nontrivial polynomial with elements from the subset evaluates to
       zero.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    df-algind $a |- AlgInd = ( w e. _V , k e. ~P ( Base ` w ) |->
      { v e. ~P ( Base ` w ) | Fun `' ( f e. ( Base ` ( v mPoly ( w |`s k ) ) )
        |-> ( ( ( ( v evalSub w ) ` k ) ` f ) ` ( _I |` v ) ) ) } ) $.
  $}

  ${
    $d h i r y $.  $d b d i r .+b $.  $d b d i r J $.  $d b d f g i k r x ph $.
    $d b d f g i k r x B $.  $d b d f g h i k r x I $.  $d b d f g i k r x R $.
    $d b d f g k x y D $.  $d b d i r .X. $.  $d b d i r .xb $.
    $( The multivariate power series constructor is a proper binary operator.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    reldmpsr $p |- Rel dom mPwSer $=
      ( vi vr vd vh vb vf vg vk vx vy cvv cv cmap co crab cfv cnx cop cof cxp
      ccnv cima cfn wcel cn0 cbs cplusg cres cmulr cle cofr wbr cmin cmpt cmpt2
      cn cgsu ctp csca cvsca csn cts ctopn cpt cun csb cmps df-psr reldmmpt2 )
      ABKKCDLUAUPUBUCUDDUEALMNOEBLZUFPZCLZMNQUFPELZRQUGPVJUGPSVMVMTUHRQUIPFGVMV
      MHVLVJIJLHLZUJUKULJVLOILZFLZPVNVOUMSNGLPVJUIPZNUNUQNUNUORURQUSPVJRQUTPIFV
      KVMVLVOVATVPVQSNUORQVBPVLVJVCPVATVDPRURVEVFVFVGIJFGDAHBECVHVI $.

    psrval.s $e |- S = ( I mPwSer R ) $.
    psrval.k $e |- K = ( Base ` R ) $.
    psrval.a $e |- .+ = ( +g ` R ) $.
    psrval.m $e |- .x. = ( .r ` R ) $.
    psrval.o $e |- O = ( TopOpen ` R ) $.
    psrval.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    psrval.b $e |- ( ph -> B = ( K ^m D ) ) $.
    psrval.p $e |- .+b = ( oF .+ |` ( B X. B ) ) $.
    psrval.t $e |- .X. = ( f e. B , g e. B |-> ( k e. D |->
            ( R gsum ( x e. { y e. D | y oR <_ k } |->
            ( ( f ` x ) .x. ( g ` ( k oF - x ) ) ) ) ) ) ) $.
    psrval.v $e |- .xb =
      ( x e. K , f e. B |-> ( ( D X. { x } ) oF .x. f ) ) $.
    psrval.j $e |- ( ph -> J = ( Xt_ ` ( D X. { O } ) ) ) $.
    psrval.i $e |- ( ph -> I e. W ) $.
    psrval.r $e |- ( ph -> R e. X ) $.
    $( Value of the multivariate power series structure.  (Contributed by Mario
       Carneiro, 29-Dec-2014.) $)
    psrval $p |- ( ph -> S = ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+b >. , <. ( .r ` ndx ) , .X. >. } u.
      { <. ( Scalar ` ndx ) , R >. , <. ( .s ` ndx ) , .xb >. ,
         <. ( TopSet ` ndx ) , J >. } ) ) $=
      ( vi vr vd vb cmps co cnx cbs cfv cop cplusg cmulr ctp csca cvsca cts cun
      cvv cv ccnv cn cima cfn wcel cn0 cmap crab cof cxp cres cle cofr wbr cmin
      cmpt cgsu cmpt2 csn ctopn cpt csb wceq df-psr a1i simprl oveq2d rabeq syl
      syl6eqr csbeq1d ovex rabex syl6eqelr simplrr fveq2d simpr ad2antrr eqtr4d
      wa oveq12d opeq2d adantr ofeq xpeq12d reseq12d oveqd mpt2eq123dv tpeq123d
      mpteq12dv xpeq1d eqidd oveq123d sneqd ad3antrrr uneq12d csbied eqtrd elex
      tpex unex ovmpt2d syl5eq ) AIQHUTVAVBVCVDZDVEZVBVFVDZGVEZVBVGVDZLVEZVHZVB
      VIVDZHVEZVBVJVDZJVEZVBVKVDZRVEZVHZVLZUCAUPUQQHVMVMUROVNVOVPVQVRVSZOVTUPVN
      ZWAVAZWBZUSUQVNZVCVDZURVNZWAVAZYRUSVNZVEZYTUUQVFVDZWCZUVAUVAWDZWEZVEZUUBM
      NUVAUVAPUUSUUQBCVNPVNZWFWGWHZCUUSWBZBVNZMVNZVDZUVHUVKWIWCVANVNVDZUUQVGVDZ
      VAZWJZWKVAZWJZWLZVEZVHZUUEUUQVEZUUGBMUURUVAUUSUVKWMZWDZUVLUVOWCZVAZWLZVEZ
      UUIUUSUUQWNVDZWMZWDZWOVDZVEZVHZVLZWPZWPZUULUTVMUTUPUQVMVMUWRWLWQABCMNOUPP
      UQUSURWRWSAUUNQWQZUUQHWQZXNZXNZUWRUREUWQWPUULUXBURUUPEUWQUXBUUPUUMOVTQWAV
      AZWBZEUXBUUOUXCWQUUPUXDWQUXBUUNQVTWAAUWSUWTWTXAUUMOUUOUXCXBXCUHXDZXEUXBUR
      EUWQUULVMUXBEUUPVMUXEUUMOUUOVTUUNWAXFXGXHUXBUUSEWQZXNZUWQUSDUWPWPUULUXGUS
      UUTDUWPUXGUUTSEWAVAZDUXGUURSUUSEWAUXGUURHVCVDSUXGUUQHVCAUWSUWTUXFXIZXJUDX
      DZUXBUXFXKZXOADUXHWQUXAUXFUIXLXMZXEUXGUSDUWPUULVMUXGDUUTVMUXLUURUUSWAXFXH
      UXGUVADWQZXNZUWBUUDUWOUUKUXNUVBYSUVGUUAUWAUUCUXNUVADYRUXGUXMXKZXPUXNUVFGY
      TUXNUVFFWCZDDWDZWEGUXNUVDUXPUVEUXQUXNUVCFWQUVDUXPWQUXNUVCHVFVDFUXNUUQHVFU
      XGUWTUXMUXIXQZXJUEXDUVCFXRXCUXNUVADUVADUXOUXOXSXTUJXDXPUXNUVTLUUBUXNUVTMN
      DDPEHBUVICEWBZUVMUVNKVAZWJZWKVAZWJZWLLUXNMNUVAUVAUVSDDUYCUXOUXOUXNPUUSUVR
      EUYBUXGUXFUXMUXKXQZUXNUUQHUVQUYAWKUXRUXNBUVJUVPUXSUXTUXNUXFUVJUXSWQUYDUVI
      CUUSEXBXCUXNUVOKUVMUVNUXNUVOHVGVDKUXNUUQHVGUXRXJUFXDZYAYDXOYDYBUKXDXPYCUX
      NUWCUUFUWIUUHUWNUUJUXNUUQHUUEUXRXPUXNUWHJUUGUXNUWHBMSDEUWDWDZUVLKWCZVAZWL
      JUXNBMUURUVAUWGSDUYHUXGUURSWQUXMUXJXQUXOUXNUWEUYFUVLUVLUWFUYGUXNUVOKWQUWF
      UYGWQUYEUVOKXRXCUXNUUSEUWDUYDYEUXNUVLYFYGYBULXDXPUXNUWMRUUIUXNUWMETWMZWDZ
      WOVDZRUXNUWLUYJWOUXNUUSEUWKUYIUYDUXNUWJTUXNUWJHWNVDTUXNUUQHWNUXRXJUGXDYHX
      SXJARUYKWQUXAUXFUXMUMYIXMXPYCYJYKYLYKYLAQUAVSQVMVSUNQUAYMXCAHUBVSHVMVSUOH
      UBYMXCUULVMVSAUUDUUKYSUUAUUCYNUUFUUHUUJYNYOWSYPYQ $.
  $}

  $( The multivariate power series structure is a function.  (Contributed by
     Mario Carneiro, 8-Feb-2015.) $)
  psrvalstr $p |- ( { <. ( Base ` ndx ) , B >. ,
      <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u.
    { <. ( Scalar ` ndx ) , R >. , <. ( .s ` ndx ) , .x. >. ,
       <. ( TopSet ` ndx ) , J >. } ) Struct <. 1 , 9 >. $=
    ( c1 c3 c5 c9 cnx cbs cfv cop cplusg cmulr ctp csca cvsca cts rngstr c6 5nn
    eqid scandx 5lt6 6nn vscandx 6lt9 9nn tsetndx strle3 3lt5 strleun ) GHIJKLM
    ANKOMBNKPMENQZKRMZCNKSMZDNKTMZFNQABUOEUOUDUAUPUQURIUBJCDFUCUEUFUGUHUIUJUKUL
    UMUN $.

  ${
    $d f g j k m n u v w x y z F $.  $d f j k m n x y G $.  $d g m n x y z V $.
    $d f g m n w x y z I $.  $d j k m u v w z ph $.  $d j k m n u v w x z S $.
    $d j k m B $.  $d g j k m n u v w x y z D $.  $d f m n u v w x y z X $.
    $d f k m u v w x y z Y $.
    psrbag.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    $( Elementhood in the set of finite bags.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    psrbag $p |- ( I e. V -> ( F e. D <->
      ( F : I --> NN0 /\ ( `' F " NN ) e. Fin ) ) ) $=
      ( wcel cn0 cmap co ccnv cn cima cfn wa wf cv wceq cnveq cvv eleq1d elrab2
      imaeq1d wb nn0ex elmapg mpan anbi1d syl5bb ) CAGCHDIJZGZCKZLMZNGZODEGZDHC
      PZUNOBQZKZLMZNGUNBCUJAUQCRZUSUMNUTURULLUQCSUCUAFUBUOUKUPUNHTGUOUKUPUDUEHD
      CTEUFUGUHUI $.

    $( A finite bag is a function.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    psrbagf $p |- ( ( I e. V /\ F e. D ) -> F : I --> NN0 ) $=
      ( wcel cn0 wf ccnv cn cima cfn psrbag simprbda ) DEGCAGDHCICJKLMGABCDEFNO
      $.

    $( The support of a dominated bag is smaller than the dominating bag.
       (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    psrbaglesupp $p |- ( ( I e. V /\ ( F e. D /\
      G : I --> NN0 /\ G oR <_ F ) ) -> ( `' G " NN ) C_ ( `' F " NN ) ) $=
      ( vx wcel cn0 wf cle wbr wa ccnv cn cima cc0 wceq syl cofr w3a cvv simpr2
      csn cdif nn0supp cfv eldifi wral simpr3 wfn psrbagf 3ad2antr1 simpl inidm
      cv ffn eqidd ofrfval mpbid r19.21bi sylan2 eqimss suppssr breqtrd ffvelrn
      wss 3syl syl2an nn0ge0d cr wb nn0red 0re letri3 mpbir2and suppss eqsstr3d
      sylancl ) EFIZCAIZEJDKZDCLUAMZUBZNZDOZPQZWGUCRUEUFZQZCOZPQZWFWCWJWHSWAWBW
      CWDUDZDEUGTWFEJHDWLRWMWFHUQZEWLUFIZNZWNDUHZRSZWQRLMZRWQLMZWPWQWNCUHZRLWOW
      FWNEIZWQXALMZWNEWLUIZWFXCHEWFWDXCHEUJWAWBWCWDUKWFHEEWQXALEDCFFWFWCDEULWME
      JDURTWFEJCKZCEULWAWCWBXEWDABCEFGUMUNZEJCURTWAWEUOZXGEUPWFXBNZWQUSXHXAUSUT
      VAVBVCWFEJCWLWNRXFWFXEWKWIQZWLSXIWLVHXFCEUGXIWLVDVIVEVFWPWQWFWCXBWQJIWOWM
      XDEJWNDVGVJZVKWPWQVLIRVLIWRWSWTNVMWPWQXJVNVOWQRVPVTVQVRVS $.

    $( The set of finite bags is downward-closed.  (Contributed by Mario
       Carneiro, 29-Dec-2014.) $)
    psrbaglecl $p |- ( ( I e. V /\
      ( F e. D /\ G : I --> NN0 /\ G oR <_ F ) ) -> G e. D ) $=
      ( wcel cn0 wf cle cofr wa ccnv cn cima cfn wb psrbag adantr simpr2 simpr1
      wbr w3a wss mpbid simprd psrbaglesupp ssfi syl2anc mpbir2and ) EFHZCAHZEI
      DJZDCKLUCZUDZMZDAHZUNDNOPZQHZULUMUNUOUAUQCNOPZQHZUSVAUEUTUQEICJZVBUQUMVCV
      BMZULUMUNUOUBULUMVDRUPABCEFGSTUFUGABCDEFGUHVAUSUIUJULURUNUTMRUPABDEFGSTUK
      $.

    $( The sum of two finite bags is a finite bag.  (Contributed by Mario
       Carneiro, 9-Jan-2015.) $)
    psrbagaddcl $p |- ( ( I e. V /\ F e. D /\ G e. D ) ->
      ( F oF + G ) e. D ) $=
      ( vx wcel caddc co cn0 wf ccnv cima cfn wa cvv cc0 a1i vy w3a cn nn0addcl
      cof cv adantl simp2 wb psrbag 3ad2ant1 mpbid simpld simp3 simp1 inidm off
      cfv cmpt csn cdif wceq nn0supp fvex feqmptd offval2 cnveqd imaeq1d eqtr3d
      syl cun wss simprd eqeltrd unfi syl2anc ssun1 suppssr oveq12d 00id syl6eq
      ssun2 suppss2 ssfi mpbir2and ) EFIZCAIZDAIZUBZCDJUEKZAIZELWJMZWJNZUCOZPIZ
      WIHUAEEEJLLLCDFFHUFZLIUAUFZLIQWPWQJKLIWIWPWQUDUGWIELCMZCNZUCOZPIZWIWGWRXA
      QZWFWGWHUHWFWGWGXBUIWHABCEFGUJUKULZUMZWIELDMZDNZUCOZPIZWIWHXEXHQZWFWGWHUN
      WFWGWHXIUIWHABDEFGUJUKULZUMZWFWGWHUOZXLEUPUQZWIWNHEWPCURZWPDURZJKZUSZNZRS
      UTVAZOZPWIWMXSOZWNXTWIWLYAWNVBXMWJEVCVJWIWMXRXSWIWJXQWIHEXNXOJCDFRRXLXNRI
      WIWPEIQZWPCVDTXORIYBWPDVDTWIHELCXDVEWIHELDXKVEVFVGVHVIWIWSXSOZXFXSOZVKZPI
      ZXTYEVLXTPIWIYCPIYDPIYFWIYCWTPWIWRYCWTVBXDCEVCVJWIWRXAXCVMVNWIYDXGPWIXEYD
      XGVBXKDEVCVJWIXEXHXJVMVNYCYDVOVPWIEXPHYESWIWPEYEVAIQZXPSSJKSYGXNSXOSJWIEL
      CYEWPSXDYCYEVLWIYCYDVQTVRWIELDYEWPSXKYDYEVLWIYDYCWBTVRVSVTWAWCYEXTWDVPVNW
      FWGWKWLWOQUIWHABWJEFGUJUKWE $.

    $( The analogue of the statement " ` 0 <_ G <_ F ` implies
       ` 0 <_ F - G <_ F ` " for finite bags.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    psrbagcon $p |- ( ( I e. V /\ ( F e. D /\ G : I --> NN0 /\
      G oR <_ F ) ) -> ( ( F oF - G ) e. D /\ ( F oF - G ) oR <_ F ) ) $=
      ( vx wcel cn0 wf cle wbr wa cmin wfn cfv wral wb mpbid cofr w3a cof co cn
      ccnv cima cfn simpr1 psrbag adantr simpld ffn syl simpr2 simpl inidm offn
      cv eqidd ofval simpr3 ofrfval r19.21bi ffvelrnda nn0sub syl2anc ralrimiva
      eqeltrd ffnfv sylanbrc wss simprd cc0 nn0ge0d nn0re subge02 syl2an mpbird
      cr psrbaglesupp syl13anc ssfi mpbir2and jca ) EFIZCAIZEJDKZDCLUAZMZUBZNZC
      DOUCUDZAIZWMCWIMZWLWNEJWMKZWMUFUEUGZUHIZWLWMEPHUSZWMQZJIZHERWPWLEEOECDFFW
      LEJCKZCEPWLXBCUFUEUGZUHIZWLWGXBXDNZWFWGWHWJUIZWFWGXESWKABCEFGUJUKTZULZEJC
      UMUNZWLWHDEPWFWGWHWJUOZEJDUMUNZWFWKUPZXLEUQZURZWLXAHEWLWSEINZWTWSCQZWSDQZ
      OUDZJWLEEXPXQOECDFFWSXIXKXLXLXMXOXPUTZXOXQUTZVAZXOXQXPLMZXRJIZWLYBHEWLWJY
      BHERWFWGWHWJVBWLHEEXQXPLEDCFFXKXIXLXLXMXTXSVCTVDXOXQJIZXPJIZYBYCSWLEJWSDX
      JVEZWLEJWSCXHVEZXQXPVFVGTVIVHHEJWMVJVKZWLXDWQXCVLZWRWLXBXDXGVMWLWFWGWPWOY
      IXLXFYHWLWOXRXPLMZHERWLYJHEXOVNXQLMZYJXOXQYFVOXOYEYDYKYJSZYGYFYEXPVTIXQVT
      IYLYDXPVPXQVPXPXQVQVRVGTVHWLHEEXRXPLEWMCFFXNXIXLXLXMYAXSVCVSZABCWMEFGWAWB
      XCWQWCVGWFWNWPWRNSWKABWMEFGUJUKWDYMWE $.

    $( There are finitely many bags dominated by a given bag.  (Contributed by
       Mario Carneiro, 29-Dec-2014.)  (Revised by Mario Carneiro,
       25-Jan-2015.) $)
    psrbaglefi $p |- ( ( I e. V /\ F e. D ) ->
      { y e. D | y oR <_ F } e. Fin ) $=
      ( vx wcel wa cv cle cc0 cfn cn0 cn cima wb wss wceq cofr wbr crab cfv cfz
      co cixp cab df-rab ccnv psrbag adantr simpl syl6bi adantrd ss2ixp elfznn0
      wf wi ssriv a1i mprg sseli vex elixpconst sylib wral wfn ffn adantl elixp
      baib syl cuz ffvelrn adantll nn0uz syl6eleq psrbagf ffvelrnda nn0zd elfz5
      syl2anc ralbidva simpll inidm eqidd ofrfval bitr4d psrbaglecl 3exp2 imp31
      cz pm4.71rd 3bitrrd ex pm5.21ndd abbi1dv syl5eq cmap simpr imaeq1d eleq1d
      cnveq elrab2 simprd fzfid cdif csn cvv nn0supp eqimss 3syl suppssr oveq2d
      0z fzsn ax-mp syl6eq ixpfi2 eqeltrd ) EFIZDBIZJZAKZDLUAUBZABUCZHEMHKZDUDZ
      UEUFZUGZNYDYGYEBIZYFJZAUHYKYFABUIYDYMAYKYDEOYEURZYMYEYKIZYDYLYNYFYDYLYNYE
      UJPQNIZJZYNYBYLYQRYCBCYEEFGUKULYNYPUMUNUOYOYNUSYDYOYEHEOUGZIYNYKYRYEYJOSZ
      YKYRSHEHEYJOUPYSYHEIZAYJOYEYIUQUTVAVBVCHEOYEAVDZVEVFVAYDYNYMYORYDYNJZYOYH
      YEUDZYJIZHEVGZYFYMUUBYEEVHZYOUUERYNUUFYDEOYEVIVJZYOUUFUUEHEYJYEUUAVKVLVMU
      UBUUEUUCYILUBZHEVGYFUUBUUDUUHHEUUBYTJZUUCMVNUDZIYIWMIUUDUUHRUUIUUCOUUJYNY
      TUUCOIYDEOYHYEVOVPVQVRUUIYIUUBEOYHDYDEODURZYNBCDEFGVSZULZVTWAUUCMYIWBWCWD
      UUBHEEUUCYILEYEDFFUUGUUBUUKDEVHUUMEODVIVMYBYCYNWEZUUNEWFUUIUUCWGUUIYIWGWH
      WIUUBYFYLYBYCYNYFYLUSYBYCYNYFYLBCDYEEFGWJWKWLWNWOWPWQWRWSYDHEYJDUJZPQZMYD
      DOEWTUFZIZUUPNIZYDYCUURUUSJYBYCXACKZUJZPQZNIUUSCDUUQBUUTDTZUVBUUPNUVCUVAU
      UOPUUTDXDXBXCGXEVFXFYDYTJMYIXGYDYHEUUPXHIJZYJMXIZTYJUVESUVDYJMMUEUFZUVEUV
      DYIMMUEYDEODUUPYHMUULYDUUKUUOXJUVEXHQZUUPTUVGUUPSUULDEXKUVGUUPXLXMXNXOMWM
      IUVFUVETXPMXQXRXSYJUVEXLVMXTYA $.

    psrbagconf1o.1 $e |- S = { y e. D | y oR <_ F } $.
    $( The complement of a bag is a bag.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    psrbagconcl $p |- ( ( I e. V /\ F e. D /\ X e. S ) ->
      ( F oF - X ) e. S ) $=
      ( wcel w3a cmin cof co cle wbr wa breq1 elrab2 cofr cn0 simp1 simp2 simp3
      wf cv sylib simpld psrbagf syl2anc simprd psrbagcon syl13anc sylibr ) FGK
      ZEBKZHCKZLZEHMNOZBKUTEPUAZQZRZUTCKUSUPUQFUBHUFZHEVAQZVCUPUQURUCZUPUQURUDU
      SUPHBKZVDVFUSVGVEUSURVGVERUPUQURUEAUGZEVAQZVEAHBCVHHEVASJTUHZUIBDHFGIUJUK
      USVGVEVJULBDEHFGIUMUNVIVBAUTBCVHUTEVASJTUO $.

    $( Bag complementation is a bijection on the set of bags dominated by a
       given bag ` F ` .  (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    psrbagconf1o $p |- ( ( I e. V /\ F e. D ) ->
      ( x e. S |-> ( F oF - x ) ) : S -1-1-onto-> S ) $=
      ( vn wcel wa cmin cn0 wf psrbagf syl2anc wceq cfv vz cv cof cmpt eqid cle
      co cofr wbr simpll simplr simpr breq1 elrab2 sylib simpld simprd syl13anc
      psrbagcon sylibr ralrimiva oveq2 eleq1d rspccva sylan wb adantr ffvelrnda
      wral crab ssrab2 eqsstri simprr sseldi adantrr cc subsub23 syl3an syl3anc
      nn0cn eqcom 3bitr4g wfn ffn syl inidm eqidd ofval eqeq2d 3bitr4d ralbidva
      adantrl eqfnfv f1o2d ) GHLZFCLZMZAUADDFAUBZNUCZUGZFUAUBZWSUGZADWTUDZXCUEW
      QWRDLZMZWTCLZWTFUFUHZUIZMZWTDLZXEWOWPGOWRPZWRFXGUIZXIWOWPXDUJZWOWPXDUKXEW
      OWRCLZXKXMXEXNXLXEXDXNXLMWQXDULBUBZFXGUIZXLBWRCDXOWRFXGUMJUNUOZUPCEWRGHIQ
      RZXEXNXLXQUQCEFWRGHIUSURXPXHBWTCDXOWTFXGUMJUNUTZWQXJADVIXADLZXBDLZWQXJADX
      SVAXJYAAXADWRXASWTXBDWRXAFWSVBVCVDVEZWQXDXTMZMZKUBZWRTZYEXBTZSZKGVIZYEXAT
      ZYEWTTZSZKGVIZWRXBSZXAWTSZYDYHYLKGYDYEGLMZYFYEFTZYJNUGZSZYJYQYFNUGZSZYHYL
      YPYRYFSZYTYJSZYSUUAYPYQOLZYJOLZYFOLZUUBUUCVFZYDGOYEFWQGOFPZYCCEFGHIQVGZVH
      YDGOYEXAYDWOXACLGOXAPZWOWPYCUJZYDDCXADXPBCVJCJXPBCVKVLZWQXDXTVMVNCEXAGHIQ
      RZVHYDGOYEWRWQXDXKXTXRVOZVHUUDYQVPLUUEYJVPLUUFYFVPLUUGYQVTYJVTYFVTYQYJYFV
      QVRVSYFYRWAYJYTWAWBYPYGYRYFYDGGYQYJNGFXAHHYEYDUUHFGWCUUIGOFWDWEZYDUUJXAGW
      CZUUMGOXAWDWEZUUKUUKGWFZYPYQWGZYPYJWGWHWIYPYKYTYJYDGGYQYFNGFWRHHYEUUOYDXK
      WRGWCZUUNGOWRWDWEZUUKUUKUURUUSYPYFWGWHWIWJWKYDUUTXBGWCZYNYIVFUVAYDGOXBPZU
      VBYDWOXBCLUVCUUKYDDCXBUULWQXTYAXDYBWLVNCEXBGHIQRGOXBWDWEKGWRXBWMRYDUUPWTG
      WCZYOYMVFUUQYDGOWTPZUVDYDWOXFUVEUUKYDDCWTUULWQXDXJXTXSVOVNCEWTGHIQRGOWTWD
      WEKGXAWTWMRWJWN $.

    gsumbagdiag.i $e |- ( ph -> I e. V ) $.
    gsumbagdiag.f $e |- ( ph -> F e. D ) $.
    $( Lemma for ~ gsumbagdiag .  (Contributed by Mario Carneiro,
       5-Jan-2015.) $)
    gsumbagdiaglem $p |- ( ( ph /\
        ( X e. S /\ Y e. { x e. D | x oR <_ ( F oF - X ) } ) ) ->
        ( Y e. S /\ X e. { x e. D | x oR <_ ( F oF - Y ) } ) ) $=
      ( vz wcel cle wbr cn0 vu vv vw cv cmin co cofr crab wa simprr breq1 elrab
      cof sylib simpld simprd wf adantr simprl elrab2 psrbagf syl2anc psrbagcon
      syl13anc w3a wi nn0re letr syl3an adantl caoftrn mp2and sylanbrc cfv wral
      cr wb ffvelrnda caddc leaddsub2 leaddsub bitr3d syl3anc ralbidva cvv ovex
      a1i feqmptd wfn ffn syl inidm eqidd offval ofrfval2 3bitr4d mpbid jca ) A
      JEQZKBUDZGJUEUMZUFZRUGZSZBDUHQZUIZUIZKEQZJWTGKXAUFZXCSZBDUHQZXGKDQZKGXCSZ
      XHXGXLKXBXCSZXGXEXLXNUIAWSXEUJXDXNBKDWTKXBXCUKULUNZUOZXGXNXBGXCSZXMXGXLXN
      XOUPZXGXBDQZXQXGHIQZGDQZHTJUQZJGXCSZXSXQUIAXTXFNURZAYAXFOURZXGXTJDQZYBYDX
      GYFYCXGWSYFYCUIAWSXEUSCUDZGXCSZYCCJDEYGJGXCUKMUTUNZUOZDFJHILVAVBZXGYFYCYI
      UPDFGJHILVCVDZUPXGUAUBUCHRTRRKXBGIYDXGXTXLHTKUQZYDXPDFKHILVAVBZXGXTXSHTXB
      UQYDXGXSXQYLUODFXBHILVAVBXGXTYAHTGUQZYDYEDFGHILVAVBZUAUDZTQZUBUDZTQZUCUDZ
      TQZVEYQYSRSYSUUARSUIYQUUARSVFZXGYRYQVPQYTYSVPQUUBUUAVPQUUCYQVGYSVGUUAVGYQ
      YSUUAVHVIVJVKVLYHXMCKDEYGKGXCUKMUTVMXGYFJXIXCSZXKYJXGXNUUDXRXGPUDZKVNZUUE
      GVNZUUEJVNZUEUFZRSZPHVOUUHUUGUUFUEUFZRSZPHVOXNUUDXGUUJUULPHXGUUEHQUIZUUHT
      QZUUFTQZUUGTQZUUJUULVQZXGHTUUEJYKVRZXGHTUUEKYNVRZXGHTUUEGYPVRUUNUUHVPQZUU
      OUUFVPQZUUPUUGVPQZUUQUUHVGUUFVGUUGVGUUTUVAUVBVEUUHUUFVSUFUUGRSUUJUULUUHUU
      FUUGVTUUHUUFUUGWAWBVIWCWDXGPHUUFUUIRKXBITWEYDUUSUUIWEQUUMUUGUUHUEWFWGXGPH
      TKYNWHXGPHHUUGUUHUEHGJIIXGYOGHWIYPHTGWJWKZXGYBJHWIYKHTJWJWKYDYDHWLZUUMUUG
      WMZUUMUUHWMWNWOXGPHUUHUUKRJXIITWEYDUURUUKWEQUUMUUGUUFUEWFWGXGPHTJYKWHXGPH
      HUUGUUFUEHGKIIUVCXGYMKHWIYNHTKWJWKYDYDUVDUVEUUMUUFWMWNWOWPWQXJUUDBJDWTJXI
      XCUKULVMWR $.

    gsumbagdiag.b $e |- B = ( Base ` G ) $.
    gsumbagdiag.g $e |- ( ph -> G e. CMnd ) $.
    gsumbagdiag.x $e |- ( ( ph /\
      ( j e. S /\ k e. { x e. D | x oR <_ ( F oF - j ) } ) ) -> X e. B ) $.
    $( Two-dimensional commutation of a group sum over a "triangular" region.
       ~ fsum0diag analogue for finite bags.  (Contributed by Mario Carneiro,
       5-Jan-2015.) $)
    gsumbagdiag $p |- ( ph ->
      ( G gsum ( j e. S , k e. { x e. D | x oR <_ ( F oF - j ) } |-> X ) ) =
      ( G gsum ( k e. S , j e. { x e. D | x oR <_ ( F oF - k ) } |-> X ) ) ) $=
      ( cv cmin cof co cle cofr wbr crab cxp cfn cvv c0g cfv psrbaglefi syl2anc
      eqid wcel syl5eqel wa ccnv cima cn0 cmap ovex rabex eqeltri a1i xpfi wceq
      cn wn simprl gsumbagdiaglem simpld brxp sylanbrc pm2.24d impbida gsumcom2
      impr ) AFDBUBZJHUBZUCUDZUEUFUGZUHZBEUIZFFFUJZHIWBJIUBZWDUEWEUHBEUIZKUKULN
      UKKUMUNZSWKUQTAFCUBJWEUHCEUIZUKPALMURJEURWLUKURQRCEGJLMOUOUPUSZWGULURAWCF
      URZUTWFBEEGUBVAVKVBUKURZGVCLVDUEZUIULOWOGWPVCLVDVEVFVGVFVHUAAFUKURZWQWHUK
      URWMWMFFVIUPAWNWIWGURZUTZWCWIWHUHZVLNWKVJZAWSUTZWTXAXBWNWIFURZWTAWNWRVMXB
      XCWCWJURZABCEFGJLMWCWIOPQRVNZVOWCWIFFVPVQVRWAWMAWSXCXDUTXEABCEFGJLMWIWCOP
      QRVNVSVT $.

    psrass1lem.y $e |- ( k = ( n oF - j ) -> X = Y ) $.
    $( A group sum commutation used by ~ psrass1 .  (Contributed by Mario
       Carneiro, 5-Jan-2015.) $)
    psrass1lem $p |- ( ph ->
    ( G gsum ( n e. S |->
      ( G gsum ( j e. { x e. D | x oR <_ n } |-> Y ) ) ) ) =
    ( G gsum ( j e. S |->
      ( G gsum ( k e. { x e. D | x oR <_ ( F oF - j ) } |-> X ) ) ) ) ) $=
      ( vm vz cv cmin cof cle cofr wbr crab cmpt cgsu cmpt2 wcel gsumbagdiaglem
      co csb wa wf wral ccom anassrs eqid fmptd wf1o adantr eqsstri psrbagconcl
      ssrab2 simpr syl3anc sseldi psrbagconf1o syl2anc f1of syl fco cfv psrbagf
      cn0 wceq ffvelrnda cc nn0cn syl3an mpteq2dva cvv ovex a1i feqmptd offval2
      sub32 3eqtr4d eqeltrrd nfcv nfcsb1v cbvmpt csbeq1 fmptco feq1d mpbid fmpt
      csbeq1a sylibr r19.21bi anasss syldan gsumbagdiag cxp psrbaglefi syl5eqel
      cfn xpfi wn simprl simpld brxp sylanbrc pm2.24d impr gsum2d2 3eqtr3d ccnv
      c0g cima wss cdm cnvimass dmmptss sstri ssfi sylancl eqidd oveq2d gsumf1o
      cres eqtrd ccmn csn cdif gsumcl f1ocnv 3syl coass f1ococnv2 coeq2d syl5eq
      cid breq2 rabbidv csbief oveq1 csbeq1d syl5eqr coeq1d coires1 ssid resmpt
      mpteq12dv ax-mp eqtri ) ALUEFLHBUGZKUEUGZUHUIZUSZUJUKZULZBEUMZIUVHHUGZUVG
      USZOUTZUNZUOUSZUNZUOUSZLHFLUEUVEKUVLUVGUSZUVIULZBEUMZUVNUNZUOUSZUNZUOUSZL
      JFLHUVEJUGZUVIULZBEUMZPUNZUOUSZUNZUOUSZLHFLIUWAOUNZUOUSZUNZUOUSALUEHFUVKU
      VNUPUOUSLHUEFUWAUVNUPUOUSUVRUWEABCDEFGUEHKLMNUVNQRSTUAUBAUVFFUQZUVLUVKUQZ
      VAZUVLFUQZUVFUWAUQZVAZUVNDUQZABCEFGKMNUVFUVLQRSTURZAUWSUWTUXBAUWSVAZUXBUE
      UWAUXDUWADUWBVBZUXBUEUWAVCUXDUWADUWMUEUWAUVSUVFUVGUSZUNZVDZVBZUXEUXDUWADU
      WMVBUWAUWAUXGVBZUXIUXDIUWAODUWMAUWSIUGUWAUQODUQUCVEUWMVFZVGZUXDUWAUWAUXGV
      HZUXJUXDMNUQZUVSEUQZUXMAUXNUWSSVIZUXDFEUVSFCUGKUVIULZCEUMZERUXQCEVLVJZUXD
      UXNKEUQZUWSUVSFUQUXPAUXTUWSTVIZAUWSVMZCEFGKMNUVLQRVKVNVOZUEBEUWAGUVSMNQUW
      AVFZVPVQZUWAUWAUXGVRVSUWAUWADUWMUXGVTVQUXDUWADUXHUWBUXDUEJUWAUWAUVMIUWFOU
      TZUVNUXGUWMUXDUWTVAZUXFUVMUWAUYGUFMUFUGZKWAZUYHUVLWAZUHUSZUYHUVFWAZUHUSZU
      NUFMUYIUYLUHUSZUYJUHUSZUNUXFUVMUYGUFMUYMUYOUYGUYHMUQVAZUYIWCUQZUYJWCUQZUY
      LWCUQZUYMUYOWDZUYGMWCUYHKUYGUXNUXTMWCKVBUXDUXNUWTUXPVIZUXDUXTUWTUYAVIEGKM
      NQWBVQZWEZUYGMWCUYHUVLUYGUXNUVLEUQMWCUVLVBVUAUYGFEUVLUXSUXDUWSUWTUYBVIVOE
      GUVLMNQWBVQZWEZUYGMWCUYHUVFUYGUXNUVFEUQMWCUVFVBVUAUYGUWAEUVFUVTBEVLUXDUWT
      VMZVOEGUVFMNQWBVQZWEZUYQUYIWFUQUYRUYJWFUQUYSUYLWFUQUYTUYIWGUYJWGUYLWGUYIU
      YJUYLWOWHVNWIUYGUFMUYKUYLUHUVSUVFNWJWCVUAUYKWJUQUYPUYIUYJUHWKWLVUHUYGUFMU
      YIUYJUHKUVLNWCWCVUAVUCVUEUYGUFMWCKVUBWMZUYGUFMWCUVLVUDWMZWNUYGUFMWCUVFVUG
      WMZWNUYGUFMUYNUYJUHUVHUVLNWJWCVUAUYNWJUQUYPUYIUYLUHWKWLVUEUYGUFMUYIUYLUHK
      UVFNWCWCVUAVUCVUHVUIVUKWNVUJWNWPZUYGUXNUXOUWTUXFUWAUQVUAUXDUXOUWTUYCVIVUF
      BEUWAGUVSMNUVFQUYDVKVNWQUXDUEUWAUXFUVMVULWIUWMJUWAUYFUNWDUXDIJUWAOUYFJOWR
      IUWFOWSIUWFOXFWTWLIUWFUVMOXAXBZXCXDUEUWADUVNUWBUWBVFXEXGXHXIZXJZXKAFDUVKF
      FXLZUEHLXOXOUVNLYGWAZUAVUQVFZUBAFUXRXORAUXNUXTUXRXOUQSTCEGKMNQXMVQXNZAUWP
      VAZUXNUVHEUQUVKXOUQZAUXNUWPSVIZVUTFEUVHUXSVUTUXNUXTUWPUVHFUQVVBAUXTUWPTVI
      AUWPVMCEFGKMNUVFQRVKVNZVOBEGUVHMNQXMVQZVUOAFXOUQZVVEVUPXOUQVUSVUSFFXPVQZA
      UWRUVFUVLVUPULZXQUVNVUQWDZAUWRVAZVVGVVHVVIUWPUWSVVGAUWPUWQXRVVIUWSUWTUXCX
      SUVFUVLFFXTYAYBYCYDAFDUWAVUPHUELXOXOUVNVUQUAVURUBVUSUXDUXNUXOUWAXOUQZUXPU
      YCBEGUVSMNQXMVQZVUNVVFAUXAUVLUVFVUPULZXQVVHAUXAVAZVVLVVHVVMUWSUWPVVLAUWSU
      WTXRVVMUWPUWQABCEFGKMNUVLUVFQRSTURXSUVLUVFFFXTYAYBYCYDYEAUWLLUWKUEFUVHUNZ
      VDZUOUSUVRAFDFUWKLVVNXOVUQUAVURUBVUSAFDUVQVVNYFZVDZVBZFDUWKVBAFDUVQVBFFVV
      PVBZVVRAUEFUVPDUVQVUTUVKDUVOLXOVUQUAVURALUUAUQZUWPUBVIVVDVUTHUVKUVNDUVOAU
      WPUWQUXBVUOVEUVOVFZVGVUTVVAUVOYFWJVUQUUBUUCZYHZUVKYIVWCXOUQVVDVWCUVOYJUVK
      UVOVWBYKHUVKUVNUVOVWAYLYMUVKVWCYNYOUUDUVQVFVGAFFVVNVHZFFVVPVHVVSAUXNUXTVW
      DSTUECEFGKMNQRVPVQZFFVVNUUEFFVVPVRUUFFFDUVQVVPVTVQAFDVVQUWKAVVOVVPVDZUWKU
      UKFYSZVDZVVQUWKAVWFUWKVVNVVPVDZVDVWHUWKVVNVVPUUGAVWIVWGUWKAVWDVWIVWGWDVWE
      FFVVNUUHVSUUIUUJAVVOUVQVVPAUEJFFUVHUWJUVPVVNUWKVVCAVVNYPAUWKYPUWFUVHWDZUW
      IUVOLUOVWJHUWHPUVKUVNVWJUWGUVJBEUWFUVHUVEUVIUULUUMVWJPIUWFUVLUVGUSZOUTUVN
      IVWKOPUWFUVLUVGWKIPWRUDUUNVWJIVWKUVMOUWFUVHUVLUVGUUOUUPUUQUVBYQXBZUURVWHU
      WKWDAVWHUWKFYSZUWKUWKFUUSFFYIVWMUWKWDFUUTJFFUWJUVAUVCUVDWLYEXCXDAVVEUWKYF
      VWBYHZFYIVWNXOUQVUSVWNUWKYJFUWKVWBYKJFUWJUWKUWKVFYLYMFVWNYNYOVWEYRAVVOUVQ
      LUOVWLYQYTAUWOUWDLUOAHFUWNUWCUXDUWNLUXHUOUSUWCUXDUWADUWAUWMLUXGXOVUQUAVUR
      AVVTUWSUBVIVVKUXLUXDVVJUWMYFVWBYHZUWAYIVWOXOUQVVKVWOUWMYJUWAUWMVWBYKIUWAO
      UWMUXKYLYMUWAVWOYNYOUYEYRUXDUXHUWBLUOVUMYQYTWIYQWP $.
  $}

  ${
    $d g h k x y D $.  $d f g h k x y I $.  $d g h k x K $.  $d g h k x ph $.
    $d g h k x R $.
    psrbas.s $e |- S = ( I mPwSer R ) $.
    psrbas.k $e |- K = ( Base ` R ) $.
    psrbas.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    psrbas.b $e |- B = ( Base ` S ) $.
    ${
      psrbas.i $e |- ( ph -> I e. V ) $.
      $( The base set of the multivariate power series structure.  (Contributed
         by Mario Carneiro, 28-Dec-2014.)  (Revised by Mario Carneiro,
         2-Oct-2015.) $)
      psrbas $p |- ( ph -> B = ( K ^m D ) ) $=
        ( vx cvv wcel cbs cfv c0 vg vh vk vy cmap co wceq wa cnx cop cplusg cof
        cxp cres cmulr cv cle cofr wbr crab cmin cmpt cgsu cmpt2 ctp csca cvsca
        csn cts ctopn cpt cun eqid eqidd adantr psrval fveq2d ovex c1 psrvalstr
        simpr c9 baseid snsstp1 ssun1 sstri strfv ax-mp 3eqtr4g reldmpsr ovprc2
        wn cmps adantl syl5eq base0 wne fvprc cc0 cn0 wf ccnv cima cfn 0nn0 a1i
        cn fmptd wss 0fin cdif nn0supp syl suppss2 eqsstr3d ssfi sylancr psrbag
        wb mpbir2and ne0i fvex eqeltri rabex map0 sylanbrc eqtr4d pm2.61dan ) A
        DPQZBHCUEUFZUGAYIUHZERSZUIRSYJUJZUIUKSDUKSZULYJYJUMUNZUJZUIUOSUAUBYJYJU
        CCDOUDUPUCUPZUQURUSUDCUTOUPZUAUPZSYQYRVAULUFUBUPSDUOSZUFVBVCUFVBVDZUJZV
        EZUIVFSDUJUIVGSOUAHYJCYRVHUMYSYTULUFVDZUJUIVISCDVJSZVHUMVKSZUJVEZVLZRSZ
        BYJYKEUUHRYKOUDYJCYNYODEUUDYTUUAUAUBFUCGUUFHUUEIPJKYNVMYTVMUUEVMLYKYJVN
        YOVMUUAVMUUDVMYKUUFVNAGIQZYINVOAYIWAVPVQMYJPQYJUUIUGHCUEVRYJUUHRPVSWBUJ
        YJYODUUDUUAUUFVTWCYMVHUUCUUHYMYPUUBWDUUCUUGWEWFWGWHWIAYIWLZUHZBTYJUULYL
        TRSBTUULETRUULEGDWMUFZTJUUKUUMTUGAGDWMWJWKWNWOVQMWPWIUULHTUGCTWQZYJTUGU
        ULHDRSZTKUUKUUOTUGADRWRWNWOUULOGWSVBZCQZUUNUULUUQGWTUUPXAZUUPXBZXGXCZXD
        QZUULOGWSWTUUPWSWTQUULYRGQUHXEXFUUPVMXHZUULTXDQUUTTXIUVAXJUULUUTUUSPWSV
        HXKXCZTUULUURUVCUUTUGUVBUUPGXLXMUULGWSOTWSUULYRGTXKQUHWSVNXNXOTUUTXPXQA
        UUQUURUVAUHXSZUUKAUUJUVDNCFUUPGILXRXMVOXTCUUPYAXMHCHUUOPKDRYBYCCFUPXBXG
        XCXDQZFWTGUEUFZUTPLUVEFUVFWTGUEVRYDYCYEYFYGYH $.
    $}

    psrelbas.x $e |- ( ph -> X e. B ) $.
    $( An element of the set of power series is a function on the
       coefficients.  (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psrelbas $p |- ( ph -> X : D --> K ) $=
      ( cmap co wcel cvv cbs eqeltri wf cmps reldmpsr elbasov syl simpld psrbas
      wa eleqtrd cfv fvex cv ccnv cn cima cfn cn0 crab ovex rabex elmap sylib )
      AIHCOPZQCHIUAAIBVCNABCDEFGHRJKLMAGRQZDRQZAIBQVDVEUHNIBEUBGDUCJMUDUEUFUGUI
      HCIHDSUJRKDSUKTCFULUMUNUOUPQZFUQGOPZURRLVFFVGUQGOUSUTTVAVB $.
  $}

  ${
    $d f g k x B $.  $d f g h k x y I $.  $d f g k x ph $.  $d f g k x R $.
    psrplusg.s $e |- S = ( I mPwSer R ) $.
    psrplusg.b $e |- B = ( Base ` S ) $.
    psrplusg.a $e |- .+ = ( +g ` R ) $.
    psrplusg.p $e |- .+b = ( +g ` S ) $.
    $( The addition operation of the multivariate power series structure.
       (Contributed by Mario Carneiro, 28-Dec-2014.)  (Revised by Mario
       Carneiro, 2-Oct-2015.) $)
    psrplusg $p |- .+b = ( oF .+ |` ( B X. B ) ) $=
      ( cvv cplusg cfv cnx cbs cop cv co eqid c0 vf vg vk vh vx vy wcel cof cxp
      wa cres wceq cmulr ccnv cn cima cfn cn0 cmap crab cle cofr cmin cmpt cgsu
      wbr cmpt2 ctp cvsca csn cts ctopn cpt cun simpl psrbas eqidd simpr psrval
      csca fveq2d fvex eqeltri xpex ofexg c1 c9 psrvalstr plusgid snsstp2 ssun1
      sstri strfv mp2b 3eqtr4g cmps reldmpsr ovprc syl5eq str0 base0 xpeq2d xp0
      wn syl6eq reseq2d res0 eqtr4d pm2.61i ) FKUGZDKUGZUJZCBUHZAAUIZUKZULXLELM
      ZNOMAPZNLMZXOPZNUMMUAUBAAUCUDQUNUOUPUQUGUDURFUSRUTZDUEUFQUCQZVAVBVFUFXTUT
      UEQZUAQZMYAYBVCUHRUBQMDUMMZRVDVERVDVGZPZVHZNVTMDPNVIMUEUADOMZAXTYBVJUIYCY
      DUHRVGZPNVKMXTDVLMZVJUIVMMZPVHZVNZLMZCXOXLEYMLXLUEUFAXTBXODEYIYDYEUAUBUDU
      CFYKYHYJKKGYHSZIYDSYJSXTSZXLAXTDEUDFYHKGYOYPHXJXKVOZVPXOSYESYISXLYKVQYQXJ
      XKVRVSWAJXNKUGXOKUGXOYNULAAAEOMZKHEOWBWCZYSWDXNBKWEXOYMLKWFWGPAXODYIYEYKW
      HWIXSVJYGYMXQXSYFWJYGYLWKWLWMWNWOXLXDZCTXOYTXPTLMCTYTETLYTEFDWPRTGFDWPWQW
      RWSZWAJLXRWIWTWOYTXOXMTUKTYTXNTXMYTXNATUITYTATAYTYRTOMATYTETOUUAWAHXAWOXB
      AXCXEXFXMXGXEXHXI $.

    psradd.x $e |- ( ph -> X e. B ) $.
    psradd.y $e |- ( ph -> Y e. B ) $.
    $( The addition operation of the multivariate power series structure.
       (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psradd $p |- ( ph -> ( X .+b Y ) = ( X oF .+ Y ) ) $=
      ( co cof cxp cres psrplusg oveqi ofmresval syl5eq ) AHIDPHICQZBBRSZPHIUDP
      DUEHIBCDEFGJKLMTUAABBCHINOUBUC $.
  $}

  ${
    $d f I $.  $d x y ph $.  $d x y R $.  $d x y X $.  $d y Y $.
    psraddcl.s $e |- S = ( I mPwSer R ) $.
    psraddcl.b $e |- B = ( Base ` S ) $.
    psraddcl.p $e |- .+ = ( +g ` S ) $.
    psraddcl.r $e |- ( ph -> R e. Grp ) $.
    psraddcl.x $e |- ( ph -> X e. B ) $.
    psraddcl.y $e |- ( ph -> Y e. B ) $.
    $( Closure of the power series addition operation.  (Contributed by Mario
       Carneiro, 28-Dec-2014.) $)
    psraddcl $p |- ( ph -> ( X .+ Y ) e. B ) $=
      ( vf co cv wcel cmap cvv vx vy cplusg cfv cof cbs ccnv cn cima cfn cn0 wf
      crab cgrp eqid grpcl 3expb sylan psrelbas ovex rabex a1i inidm fvex elmap
      wa off sylibr psradd cmps reldmpsr elbasov syl simpld psrbas 3eltr4d ) AG
      HDUCUDZUEPZDUFUDZOQUGUHUIUJRZOUKFSPZUMZSPZGHCPBAWBVSVRULVRWCRAUAUBWBWBWBV
      QVSVSVSGHTTADUNRZUAQZVSRZUBQZVSRZVFWEWGVQPVSRZLWDWFWHWIVSVQDWEWGVSUOZVQUO
      ZUPUQURABWBDEOFVSGIWJWBUOZJMUSABWBDEOFVSHIWJWLJNUSWBTRAVTOWAUKFSUTVAZVBZW
      NWBVCVGVSWBVRDUFVDWMVEVHABVQCDEFGHIJWKKMNVIABWBDEOFVSTIWJWLJAFTRZDTRZAGBR
      WOWPVFMGBEVJFDVKIJVLVMVNVOVP $.
  $}

  ${
    $d f g k x B $.  $d f g k x y D $.  $d f g h k x y I $.  $d f g k x ph $.
    $d f g k x F $.  $d f g k x G $.  $d f g k x .x. $.  $d f g k x R $.
    $d k x y X $.
    psrmulr.s $e |- S = ( I mPwSer R ) $.
    psrmulr.b $e |- B = ( Base ` S ) $.
    psrmulr.m $e |- .x. = ( .r ` R ) $.
    psrmulr.t $e |- .xb = ( .r ` S ) $.
    psrmulr.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    $( The multiplication operation of the multivariate power series
       structure.  (Contributed by Mario Carneiro, 28-Dec-2014.)  (Revised by
       Mario Carneiro, 2-Oct-2015.) $)
    psrmulr $p |- .xb = ( f e. B , g e. B |-> ( k e. D |->
            ( R gsum ( x e. { y e. D | y oR <_ k } |->
            ( ( f ` x ) .x. ( g ` ( k oF - x ) ) ) ) ) ) ) $=
      ( cfv c0 cvv wcel wa cv cle cofr wbr crab cmin cmpt cgsu cmpt2 wceq cmulr
      cof co cnx cbs cop cplusg ctp csca cvsca csn cxp cts ctopn cpt eqid simpl
      cun psrbas psrplusg eqidd simpr psrval fveq2d eqeltri mpt2ex c1 psrvalstr
      fvex c9 mulrid snsstp3 ssun1 sstri strfv ax-mp 3eqtr4g wn mpt20 str0 cmps
      eqtr2i reldmpsr ovprc syl5eq base0 mpt2eq12 syl2anc 3eqtr4a pm2.61i ) MUA
      UBZEUAUBZUCZGIJCCLDEABUDLUDZUEUFUGBDUHAUDZIUDZSXGXHUIUOUPJUDSHUPUJUKUPUJZ
      ULZUMXFFUNSZUQURSCUSZUQUTSFUTSZUSZUQUNSZXKUSZVAZUQVBSEUSUQVCSAIEURSZCDXHV
      DVEXIHUOUPULZUSUQVFSDEVGSZVDVEVHSZUSVAZVKZUNSZGXKXFFYDUNXFABCDEUTSZXNEFXT
      HXKIJKLMYBXSYAUAUANXSVIZYFVIZPYAVIRXFCDEFKMXSUANYGROXDXEVJZVLCYFXNEFMNOYH
      XNVIVMXKVIXTVIXFYBVNYIXDXEVOVPVQQXKUAUBXKYEUMIJCCXJCFURSZUAOFURWBVRZYKVSX
      KYDUNUAVTWCUSCXNEXTXKYBWAWDXQVDXRYDXMXOXQWEXRYCWFWGWHWIWJXFWKZTUNSZIJTTXJ
      ULZGXKYNTYMIJTXJWLUNXPWDWMWOYLGXLYMQYLFTUNYLFMEWNUPTNMEWNWPWQWRZVQWRYLCTU
      MZYPXKYNUMYLYJTURSCTYLFTURYOVQOWSWJZYQIJCCTTXJWTXAXBXC $.

    psrmulfval.i $e |- ( ph -> F e. B ) $.
    psrmulfval.r $e |- ( ph -> G e. B ) $.
    $( The multiplication operation of the multivariate power series
       structure.  (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psrmulfval $p |- ( ph -> ( F .xb G ) = ( k e. D |->
            ( R gsum ( x e. { y e. D | y oR <_ k } |->
            ( ( F ` x ) .x. ( G ` ( k oF - x ) ) ) ) ) ) ) $=
      ( vf vg wcel co cv cle cofr wbr crab cfv cmin cof cmpt cgsu wceq wa fveq1
      oveqan12d mpteq2dv oveq2d psrmulr ccnv cima cfn cn0 cmap cvv ovex eqeltri
      cn rabex mptex ovmpt2a syl2anc ) ALDUDMDUDLMHUEKEFBCUFKUFZUGUHUICEUJZBUFZ
      LUKZVPVRULUMUEZMUKZIUEZUNZUOUEZUNZUPTUAUBUCLMDDKEFBVQVRUBUFZUKZVTUCUFZUKZ
      IUEZUNZUOUEZUNWEHWFLUPZWHMUPZUQZKEWLWDWOWKWCFUOWOBVQWJWBWMWNWGVSWIWAIVRWF
      LURVTWHMURUSUTVAUTBCDEFGHIUBUCJKNOPQRSVBKEWDEJUFVCVKVDVEUDZJVFNVGUEZUJVHS
      WPJWQVFNVGVIVLVJVMVNVO $.

    psrmulval.r $e |- ( ph -> X e. D ) $.
    $( The multiplication operation of the multivariate power series
       structure.  (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psrmulval $p |- ( ph -> ( ( F .xb G ) ` X ) =
            ( R gsum ( k e. { y e. D | y oR <_ X } |->
            ( ( F ` k ) .x. ( G ` ( X oF - k ) ) ) ) ) ) $=
      ( vx cfv cle cofr wbr crab cmin cof cmpt cgsu psrmulfval fveq1d wcel wceq
      co breq2 rabbidv oveq1 fveq2d oveq2d mpteq12dv eqid ovex fvmpt syl eqtrd
      cv ) ANKLGUQZUDNUCDEJBVIZUCVIZUEUFZUGZBDUHZJVIZKUDZVLVPUIUJZUQZLUDZHUQZUK
      ZULUQZUKZUDZEJVKNVMUGZBDUHZVQNVPVRUQZLUDZHUQZUKZULUQZANVJWDAJBCDEFGHIUCKL
      MOPQRSTUAUMUNANDUOWEWLUPUBUCNWCWLDWDVLNUPZWBWKEULWMJVOWAWGWJWMVNWFBDVLNVK
      VMURUSWMVTWIVQHWMVSWHLVLNVPVRUTVAVBVCVBWDVDEWKULVEVFVGVH $.
  $}

  ${
    $d k x B $.  $d k x ph $.  $d k x R $.  $d y V $.  $d k x X $.  $d k x Y $.
    $d k x y D $.  $d f k x y I $.
    psrmulcl.s $e |- S = ( I mPwSer R ) $.
    psrmulcl.b $e |- B = ( Base ` S ) $.
    psrmulcl.t $e |- .x. = ( .r ` S ) $.
    psrmulcl.r $e |- ( ph -> R e. Ring ) $.
    psrmulcl.x $e |- ( ph -> X e. B ) $.
    psrmulcl.y $e |- ( ph -> Y e. B ) $.
    ${
      psrmulcl.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      $( Closure of the power series multiplication operation.  (Contributed by
         Mario Carneiro, 29-Dec-2014.) $)
      psrmulcllem $p |- ( ph -> ( X .x. Y ) e. B ) $=
        ( co wcel cvv vk vx vy cv cle cofr wbr crab cfv cmin cof cmulr cmpt cbs
        cgsu cmap cfn c0g eqid crg ccmn adantr rngcmn syl cmps reldmpsr elbasov
        wf wa simpld psrbaglefi sylan ad2antrr psrelbas simpr breq1 elrab sylib
        ffvelrnd simplr psrbagf syl2anc simprd psrbagcon syl13anc rngcl syl3anc
        cn0 fmptd csn cdif fisuppfi gsumcl fvex ccnv cn cima ovex rabex eqeltri
        elmap sylibr psrmulfval psrbas 3eltr4d ) AUACDUBUCUDZUAUDZUEUFZUGZUCCUH
        ZUBUDZIUIZXGXKUJUKRZJUIZDULUIZRZUMZUORZUMZDUNUIZCUPRZIJFRBACXTXSVHXSYAS
        AUACXRXTXSAXGCSZVIZXJXTXQDUQDURUIZXTUSZYDUSYCDUTSZDVASAYFYBNVBDVCVDAHTS
        ZYBXJUQSAYGDTSZAIBSYGYHVIOIBEVEHDVFKLVGVDVJZUCCGXGHTQVKVLZYCUBXJXPXTXQY
        CXKXJSZVIZYFXLXTSXNXTSXPXTSAYFYBYKNVMYLCXTXKIACXTIVHYBYKABCDEGHXTIKYEQL
        OVNVMYLXKCSZXKXGXHUGZYLYKYMYNVIYCYKVOXIYNUCXKCXFXKXGXHVPVQVRZVJZVSYLCXT
        XMJACXTJVHYBYKABCDEGHXTJKYEQLPVNVMYLXMCSZXMXGXHUGZYLYGYBHWHXKVHZYNYQYRV
        IAYGYBYKYIVMZAYBYKVTYLYGYMYSYTYPCGXKHTQWAWBYLYMYNYOWCCGXGXKHTQWDWEVJVSX
        TDXOXLXNYEXOUSZWFWGXQUSWIZYCXJXTTYDWJWKXQYJUUBWLWMXSUSWIXTCXSDUNWNCGUDW
        OWPWQUQSZGWHHUPRZUHTQUUCGUUDWHHUPWRWSWTXAXBAUBUCBCDEFXOGUAIJHKLUUAMQOPX
        CABCDEGHXTTKYEQLYIXDXE $.
    $}

    $( Closure of the power series multiplication operation.  (Contributed by
       Mario Carneiro, 29-Dec-2014.) $)
    psrmulcl $p |- ( ph -> ( X .x. Y ) e. B ) $=
      ( vf cv ccnv cn cima cfn wcel cn0 cmap co crab eqid psrmulcllem ) ABOPQRS
      TUAOUBFUCUDUEZCDEOFGHIJKLMNUHUFUG $.
  $}

  ${
    $d f h w x y z I $.  $d f w x z ph $.  $d f w x z R $.  $d f w x z S $.
    psrsca.s $e |- S = ( I mPwSer R ) $.
    psrsca.i $e |- ( ph -> I e. V ) $.
    psrsca.r $e |- ( ph -> R e. W ) $.
    $( The scalar field of the multivariate power series structure.
       (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psrsca $p |- ( ph -> R = ( Scalar ` S ) ) $=
      ( vx vf vh cnx cbs cfv cop cplusg cmulr csca eqid vy vz vw ctp cvsca ccnv
      cv cn cima cfn wcel cn0 cmap co crab csn cxp cof cmpt2 cts ctopn cpt wceq
      cun c1 c9 psrvalstr scaid snsstp1 ssun2 sstri syl psrbas psrplusg psrmulr
      strfv eqidd psrval fveq2d eqtr4d ) ABMNOCNOZPMQOCQOZPMROCROZPUDZMSOBPZMUE
      OJKBNOZWALUGUFUHUIUJUKLULDUMUNUOZJUGUPUQKUGBROZURUNUSZPZMUTOWGBVAOZUPUQVB
      OZPZUDZVDZSOZCSOABFUKBWPVCIBWOSFVEVFPWAWBBWIWCWLVGVHWEUPWNWOWEWJWMVIWNWDV
      JVKVPVLACWOSAJUAWAWGBQOZWBBCWIWHWCKUBLUCDWLWFWKEFGWFTZWQTZWHTZWKTWGTZAWAW
      GBCLDWFEGWRXAWATZHVMWAWQWBBCDGXBWSWBTVNJUAWAWGBCWCWHKUBLUCDGXBWTWCTXAVOWI
      TAWLVQHIVRVSVT $.
  $}

  ${
    $d f g k x B $.  $d f x F $.  $d f g h k x y I $.  $d f x K $.  $d f x X $.
    $d f g k x y D $.  $d f g k x R $.  $d f g k x .x. $.  $d f x .xb $.
    psrvsca.s $e |- S = ( I mPwSer R ) $.
    psrvsca.n $e |- .xb = ( .s ` S ) $.
    psrvsca.k $e |- K = ( Base ` R ) $.
    psrvsca.b $e |- B = ( Base ` S ) $.
    psrvsca.m $e |- .x. = ( .r ` R ) $.
    psrvsca.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    $( The scalar multiplication operation of the multivariate power series
       structure.  (Contributed by Mario Carneiro, 28-Dec-2014.)  (Revised by
       Mario Carneiro, 2-Oct-2015.) $)
    psrvscafval $p |- .xb = ( x e. K , f e. B |->
      ( ( D X. { x } ) oF .x. f ) ) $=
      ( cvv cfv c0 vy vg vk wcel wa cv csn cxp cof cmpt2 wceq cvsca cnx cbs cop
      co cplusg cmulr ctp csca cts ctopn cpt eqid simpl psrbas psrplusg psrmulr
      cun eqidd simpr psrval fveq2d fvex eqeltri mpt2ex c1 c9 psrvalstr snsstp2
      vscaid ssun2 sstri strfv ax-mp 3eqtr4g wfn fn0 mpbir cmps reldmpsr syl5eq
      wn ovprc c6 df-vsca elbasov con3i eq0rdv xpeq2d xp0 syl6eq fneq12d mpbiri
      str0 fnov sylib wi pm2.21d a1d 3imp mpt2eq3dva eqtr4d pm2.61i ) JRUDZDRUD
      ZUEZFAHKBCAUFZUGUHHUFZGUIUPZUJZUKXQEULSZUMUNSBUOUMUQSEUQSZUOUMURSEURSZUOU
      SZUMUTSDUOZUMULSYAUOZUMVASCDVBSZUGUHVCSZUOZUSZVIZULSZFYAXQEYLULXQAUABCDUQ
      SZYCDEYAGYDHUBIUCJYIKYHRRLNYNVDZPYHVDQXQBCDEIJKRLNQOXOXPVEZVFBYNYCDEJLOYO
      YCVDVGAUABCDEYDGHUBIUCJLOPYDVDQVHYAVDXQYIVJYPXOXPVKVLVMMYARUDYAYMUKAHKBXT
      KDUNSRNDUNVNVOBEUNSROEUNVNVOVPYAYLULRVQVRUOBYCDYAYDYIVSWAYGUGYKYLYFYGYJVT
      YKYEWBWCWDWEWFXQWMZFAHKBXRXSFUPZUJZYAYQFKBUHZWGZFYSUKYQUUATTWGZUUBTTUKTVD
      TWHWIYQYTTFTYQYBTULSFTYQETULYQEJDWJUPTLJDWJWKWNWLVMMULWOWPXEWFYQYTKTUHTYQ
      BTKYQHBXSBUDZXQXSBEWJJDWKLOWQWRZWSWTKXAXBXCXDAHKBFXFXGYQAHKBXTYRYQXRKUDZU
      UCXTYRUKZYQUUCUUFXHUUEYQUUCUUFUUDXIXJXKXLXMXN $.

    psrvsca.x $e |- ( ph -> X e. K ) $.
    psrvsca.y $e |- ( ph -> F e. B ) $.
    $( The scalar multiplication operation of the multivariate power series
       structure.  (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psrvsca $p |- ( ph -> ( X .xb F ) = ( ( D X. { X } ) oF .x. F ) ) $=
      ( vx vf wcel co csn cxp wceq cv sneq xpeq2d oveq1d oveq2 psrvscafval ovex
      cof ovmpt2 syl2anc ) ALKUCIBUCLIFUDCLUEZUFZIGUOZUDZUGSTUAUBLIKBCUAUHZUEZU
      FZUBUHZUTUDVAFUSVEUTUDVBLUGZVDUSVEUTVFVCURCVBLUIUJUKVEIUSUTULUABCDEFGUBHJ
      KMNOPQRUMUSIUTUNUPUQ $.

    psrvscaval.y $e |- ( ph -> Y e. D ) $.
    $( The scalar multiplication operation of the multivariate power series
       structure.  (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    psrvscaval $p |- ( ph -> ( ( X .xb F ) ` Y ) = ( X .x. ( F ` Y ) ) ) $=
      ( co cfv csn cxp cof psrvsca fveq1d wcel wceq cvv cv ccnv cn cima cfn cn0
      cmap crab ovex rabex eqeltri a1i wf wfn psrelbas ffn syl eqidd ofc1 mpdan
      wa eqtrd ) AMLIFUCZUDMCLUEUFIGUGUCZUDZLMIUDZGUCZAMVOVPABCDEFGHIJKLNOPQRST
      UAUHUIAMCUJZVQVSUKUBACLVRGIULKMCULUJACHUMUNUOUPUQUJZHURJUSUCZUTULSWAHWBUR
      JUSVAVBVCVDTACKIVEICVFABCDEHJKINPSQUAVGCKIVHVIAVTVMVRVJVKVLVN $.
  $}

  ${
    $d f x y I $.  $d x y K $.  $d x y ph $.  $d x y R $.  $d x y X $.
    $d y F $.
    psrvscacl.s $e |- S = ( I mPwSer R ) $.
    psrvscacl.n $e |- .x. = ( .s ` S ) $.
    psrvscacl.k $e |- K = ( Base ` R ) $.
    psrvscacl.b $e |- B = ( Base ` S ) $.
    psrvscacl.r $e |- ( ph -> R e. Ring ) $.
    psrvscacl.x $e |- ( ph -> X e. K ) $.
    psrvscacl.y $e |- ( ph -> F e. B ) $.
    $( Closure of the power series scalar multiplication operation.
       (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    psrvscacl $p |- ( ph -> ( X .x. F ) e. B ) $=
      ( vf wcel co cvv vx vy cv ccnv cn cima cfn cn0 cmap csn cxp cmulr cfv cof
      crab wf crg eqid rngcl 3expb sylan fconst6g syl psrelbas ovex rabex inidm
      wa a1i off fvex eqeltri elmap sylibr psrvsca cmps reldmpsr elbasov simpld
      cbs psrbas 3eltr4d ) AQUCUDUEUFUGRZQUHGUISZUOZIUJUKZFCULUMZUNSZHWEUISZIFE
      SBAWEHWHUPWHWIRAUAUBWEWEWEWGHHHWFFTTACUQRZUAUCZHRZUBUCZHRZVHWKWMWGSHRZNWJ
      WLWNWOHCWGWKWMLWGURZUSUTVAAIHRWEHWFUPOWEIHVBVCABWECDQGHFJLWEURZMPVDWETRAW
      CQWDUHGUIVEVFZVIZWSWEVGVJHWEWHHCVTUMTLCVTVKVLWRVMVNABWECDEWGQFGHIJKLMWPWQ
      OPVOABWECDQGHTJLWQMAGTRZCTRZAFBRWTXAVHPFBDVPGCVQJMVRVCVSWAWB $.
  $}

  ${
    $d x .0. $.  $d r s t x y z ph $.  $d r s t x y z R $.  $d r s t x y z S $.
    $d x D $.  $d f x y z I $.  $d x y N $.  $d x y X $.
    psrgrp.s $e |- S = ( I mPwSer R ) $.
    psrgrp.i $e |- ( ph -> I e. V ) $.
    psrgrp.r $e |- ( ph -> R e. Grp ) $.
    ${
      psr0cl.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      psr0cl.o $e |- .0. = ( 0g ` R ) $.
      psr0cl.b $e |- B = ( Base ` S ) $.
      $( The zero element of the ring of power series.  (Contributed by Mario
         Carneiro, 29-Dec-2014.) $)
      psr0cl $p |- ( ph -> ( D X. { .0. } ) e. B ) $=
        ( cbs cmap co wcel cn0 csn cxp cfv cgrp eqid grpidcl fconst6g 3syl fvex
        wf cv ccnv cn cima cfn crab cvv ovex rabex elmap sylibr psrbas eleqtrrd
        eqeltri ) ACIUAUBZDPUCZCQRZBACVFVEUJZVEVGSADUDSIVFSVHLVFDIVFUEZNUFCIVFU
        GUHVFCVEDPUICFUKULUMUNUOSZFTGQRZUPUQMVJFVKTGQURUSVDUTVAABCDEFGVFHJVIMOK
        VBVC $.

      psr0lid.p $e |- .+ = ( +g ` S ) $.
      psr0lid.x $e |- ( ph -> X e. B ) $.
      $( The zero element of the ring of power series is a left identity.
         (Contributed by Mario Carneiro, 29-Dec-2014.) $)
      psr0lid $p |- ( ph -> ( ( D X. { .0. } ) .+ X ) = X ) $=
        ( cvv vx csn cxp co cplusg cfv cof eqid psr0cl psradd wcel cv ccnv cima
        cbs cn cfn cn0 cmap crab ovex rabex eqeltri a1i psrelbas fvex cgrp wceq
        c0g grplid sylan caofid0l eqtrd ) ACKUBUCZJDUDVNJEUEUFZUGUDJABVODEFHVNJ
        LQVOUHZRABCEFGHIKLMNOPQUISUJAUACKVOEUOUFZJTTCTUKACGULUMUPUNUQUKZGURHUSU
        DZUTTOVRGVSURHUSVAVBVCVDABCEFGHVQJLVQUHZOQSVEKTUKAKEVIUFTPEVIVFVCVDAEVG
        UKUAULZVQUKKWAVOUDWAVHNVQVOEWAKVTVPPVJVKVLVM $.
    $}

    ${
      psrnegcl.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      psrnegcl.i $e |- N = ( invg ` R ) $.
      psrnegcl.b $e |- B = ( Base ` S ) $.
      psrnegcl.z $e |- ( ph -> X e. B ) $.
      $( The negative function in the ring of power series.  (Contributed by
         Mario Carneiro, 29-Dec-2014.) $)
      psrnegcl $p |- ( ph -> ( N o. X ) e. B ) $=
        ( cbs cmap wf ccom cfv co wcel wf1o eqid grpinvf1o syl psrelbas syl2anc
        f1of fco fvex cv ccnv cn cima cfn cn0 crab cvv ovex rabex eqeltri elmap
        sylibr psrbas eleqtrrd ) AHJUAZDRUBZCSUCZBACVJVITZVIVKUDAVJVJHTZCVJJTVL
        AVJVJHUEVMAVJDHVJUFZOMUGVJVJHUKUHABCDEFGVJJKVNNPQUICVJVJHJULUJVJCVIDRUM
        CFUNUOUPUQURUDZFUSGSUCZUTVANVOFVPUSGSVBVCVDVEVFABCDEFGVJIKVNNPLVGVH $.

      psrlinv.o $e |- .0. = ( 0g ` R ) $.
      psrlinv.p $e |- .+ = ( +g ` S ) $.
      $( The negative function in the ring of power series.  (Contributed by
         Mario Carneiro, 29-Dec-2014.) $)
      psrlinv $p |- ( ph -> ( ( N o. X ) .+ X ) = ( D X. { .0. } ) ) $=
        ( vx vy ccom cplusg cfv cof co cv cmpt csn cxp cvv cbs wcel ccnv cn cfn
        cima cn0 cmap crab ovex rabex eqeltri a1i wa fvex eqid psrelbas feqmptd
        ffvelrnda wf1o wf grpinvf1o f1of syl fveq2 fmptco offval2 psrnegcl wceq
        psradd cgrp grplinv sylan syldan mpteq2dva fconstmpt syl6reqr 3eqtr4d )
        AIKUDZKEUEUFZUGUHUBCUBUIZKUFZIUFZWOWMUHZUJZWLKDUHCLUKULZAUBCWPWOWMWLKUM
        UMEUNUFZCUMUOACGUIUPUQUSURUOZGUTHVAUHZVBUMPXAGXBUTHVAVCVDVEVFWPUMUOAWNC
        UOZVGWOIVHVFACWTWNKABCEFGHWTKMWTVIZPRSVJZVLZAUBUCCWTWOUCUIZIUFWPKIXFAUB
        CWTKXEVKZAUCWTWTIAWTWTIVMWTWTIVNAWTEIXDQOVOWTWTIVPVQVKXGWOIVRVSXHVTABWM
        DEFHWLKMRWMVIZUAABCEFGHIJKMNOPQRSWASWCAWRUBCLUJWSAUBCWQLAXCWOWTUOZWQLWB
        ZXFAEWDUOXJXKOWTWMEIWOLXDXITQWEWFWGWHUBCLWIWJWK $.
    $}

    $( The ring of power series is a group.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    psrgrp $p |- ( ph -> S e. Grp ) $=
      ( vx vy vf cfv cv wcel co w3a eqid psrelbas adantr psradd vz vr vs vt cbs
      cplusg cminusg ccom ccnv cn cima cfn cn0 cmap crab c0g csn cxp eqidd cgrp
      3ad2ant1 simp2 simp3 psraddcl cof cvv ovex rabex a1i simpr1 simpr2 simpr3
      wa wceq grpass sylan caofass oveq1d oveq2d 3eqtr4d 3adant3r3 psr0cl simpr
      psr0lid psrnegcl psrlinv isgrpd ) AIJUACUELZCUFLZCBUGLZIMZUHKMUIUJUKULNZK
      UMDUNOZUOZBUPLZUQURAWHUSAWIUSAWKWHNZJMZWHNZPWHWIBCDWKWQFWHQZWIQZAWPBUTNZW
      RHVAAWPWRVBAWPWRVCVDZAWPWRUAMZWHNZPZVMZWKWQWIOZXCBUFLZVEZOZWKWQXCWIOZXIOZ
      XGXCWIOWKXKWIOXFWKWQXIOZXCXIOWKWQXCXIOZXIOXJXLXFUBUCUDWNXHXHBUELZXHWKWQXC
      XHVFWNVFNXFWLKWMUMDUNVGVHVIXFWHWNBCKDXOWKFXOQZWNQZWSAWPWRXDVJZRXFWHWNBCKD
      XOWQFXPXQWSAWPWRXDVKZRXFWHWNBCKDXOXCFXPXQWSAWPWRXDVLZRXFXAUBMZXONUCMZXONU
      DMZXONPYAYBXHOYCXHOYAYBYCXHOXHOVNAXAXEHSZXOXHBYAYBYCXPXHQZVOVPVQXFXGXMXCX
      IXFWHXHWIBCDWKWQFWSYEWTXRXSTVRXFXKXNWKXIXFWHXHWIBCDWQXCFWSYEWTXSXTTVSVTXF
      WHXHWIBCDXGXCFWSYEWTAWPWRXGWHNXDXBWAXTTXFWHXHWIBCDWKXKFWSYEWTXRXFWHWIBCDW
      QXCFWSWTYDXSXTVDTVTAWHWNBCKDEWOFGHXQWOQZWSWBAWPVMZWHWNWIBCKDEWKWOFADENWPG
      SZAXAWPHSZXQYFWSWTAWPWCZWDYGWHWNBCKDWJEWKFYHYIXQWJQZWSYJWEYGWHWNWIBCKDWJE
      WKWOFYHYIXQYKWSYJYFWTWFWG $.

    ${
      psr0.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      psr0.o $e |- O = ( 0g ` R ) $.
      psr0.z $e |- .0. = ( 0g ` S ) $.
      $( The zero element of the ring of power series.  (Contributed by Mario
         Carneiro, 29-Dec-2014.) $)
      psr0 $p |- ( ph -> .0. = ( D X. { O } ) ) $=
        ( csn cfv wceq eqid wcel cxp cplusg co cbs psr0cl psr0lid cgrp wb grpid
        psrgrp syl2anc mpbid ) ABGPUAZUMDUBQZUCUMRZIUMRZADUDQZBUNCDEFHUMGJKLMNU
        QSZUNSZAUQBCDEFHGJKLMNURUEZUFADUGTUMUQTUOUPUHACDFHJKLUJUTUQUNDUMIURUSOU
        IUKUL $.
    $}

    ${
      psrneg.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      psrneg.i $e |- N = ( invg ` R ) $.
      psrneg.b $e |- B = ( Base ` S ) $.
      psrneg.m $e |- M = ( invg ` S ) $.
      psrneg.x $e |- ( ph -> X e. B ) $.
      $( The negative function of the ring of power series.  (Contributed by
         Mario Carneiro, 29-Dec-2014.) $)
      psrneg $p |- ( ph -> ( M ` X ) = ( N o. X ) ) $=
        ( cfv ccom wceq cplusg co c0g csn eqid psrlinv psr0 eqtr4d cgrp wcel wb
        cxp psrgrp psrnegcl grpinvid2 syl3anc mpbird ) AKHTIKUAZUBZUTKEUCTZUDZE
        UETZUBZAVCCDUETZUFUNVDABCVBDEFGIJKVFLMNOPQSVFUGZVBUGZUHACDEFGVFJVDLMNOV
        GVDUGZUIUJAEUKULKBULUTBULVAVEUMADEGJLMNUOSABCDEFGIJKLMNOPQSUPBVBEHKUTVD
        QVHVIRUQURUS $.
    $}
  $}

  ${
    $d k x .+ $.  $d f x y z .0. $.  $d f g h j k n r s t x y z I $.  $d k K $.
    $d k u v w x A $.  $d j k n x z B $.  $d f g h j k n r s t u v w x y z R $.
    $d g h j k n u v w x y z D $.  $d y z U $.  $d f g h j k n u v w x y z X $.
    $d j k n r s t u v w x y z ph $.  $d g h j k y V $.  $d f g h j k n x Z $.
    $d x y .1. $.  $d r s t x y z S $.  $d k x y .x. $.  $d j k x .X. $.
    $d f g h j k n u v w x Y $.
    psrrng.s $e |- S = ( I mPwSer R ) $.
    psrrng.i $e |- ( ph -> I e. V ) $.
    psrrng.r $e |- ( ph -> R e. Ring ) $.
    $( The ring of power series is a left module.  (Contributed by Mario
       Carneiro, 29-Dec-2014.) $)
    psrlmod $p |- ( ph -> S e. LMod ) $=
      ( vf vr cfv eqidd wcel syl cv eqid co csn cvv psrvsca vx vy vz cbs cplusg
      vs cvsca cmulr cur crg psrsca cgrp rnggrp psrgrp w3a 3ad2ant1 simp2 simp3
      vt psrvscacl wa ccnv cima cfn cn0 cmap crab cxp cof ovex rabex a1i simpr1
      cn fconst6g simpr2 psrelbas simpr3 wceq adantr rngdi caofdi psradd oveq2d
      wf sylan oveq12d 3eqtr4d psraddcl 3adant3r3 rngdir caofdir ofc12 3eqtr2rd
      oveq1d rngacl syl3anc rngass caofass rngcl rngidcl simpr rnglidm caofid0l
      eqtrd islmodd ) AUAUBUCBUDKZCUEKZBUEKZCUGKZBUHKZBUIKZBCUDKZCAXMLAXHLABCDE
      UJFGHUKAXJLAXGLAXILAXKLAXLLHABCDEFGABUJMZBULMZHBUMNZUNAUAOZXGMZUBOZXMMZUO
      XMBCXJXSDXGXQFXJPZXGPZXMPZAXRXNXTHUPAXRXTUQAXRXTURUTZAXRXTUCOZXMMZUOZVAZI
      OVBVNVCVDMZIVEDVFQZVGZXQRVHZXSYEXHQZXKVIZQZXQXSXJQZXQYEXJQZXIVIZQZXQYMXJQ
      YPYQXHQYHYLXSYEYRQZYNQYLXSYNQZYLYEYNQZYRQYOYSYHJUFUSYKXIXGXKYLXSYEXGXISYK
      SMZYHYIIYJVEDVFVJVKZVLYHXRYKXGYLWEZAXRXTYFVMZYKXQXGVOZNYHXMYKBCIDXGXSFYBY
      KPZYCAXRXTYFVPZVQYHXMYKBCIDXGYEFYBUUHYCAXRXTYFVRZVQYHXNJOZXGMZUFOZXGMUSOZ
      XGMUOZUUKUUMUUNXIQXKQUUKUUMXKQZUUKUUNXKQZXIQVSAXNYGHVTZXGXIBXKUUKUUMUUNYB
      XIPZXKPZWAWFWBYHYMYTYLYNYHXMXIXHBCDXSYEFYCUUSXHPZUUIUUJWCWDYHYPUUAYQUUBYR
      YHXMYKBCXJXKIXSDXGXQFYAYBYCUUTUUHUUFUUITYHXMYKBCXJXKIYEDXGXQFYAYBYCUUTUUH
      UUFUUJTWGWHYHXMYKBCXJXKIYMDXGXQFYAYBYCUUTUUHUUFYHXMXHBCDXSYEFYCUVAAXOYGXP
      VTUUIUUJWITYHXMXIXHBCDYPYQFYCUUSUVAAXRXTYPXMMYFYDWJYHXMBCXJYEDXGXQFYAYBYC
      UURUUFUUJUTWCWHAXRXSXGMZYFUOZVAZYKXQXSXIQZRVHZYEYNQZYQXSYEXJQZYRQZUVEYEXJ
      QYQUVHXHQUVDUVIUUBYKXSRVHZYEYNQZYRQYLUVJYRQZYEYNQUVGUVDYQUUBUVHUVKYRUVDXM
      YKBCXJXKIYEDXGXQFYAYBYCUUTUUHAXRUVBYFVMZAXRUVBYFVRZTUVDXMYKBCXJXKIYEDXGXS
      FYAYBYCUUTUUHAXRUVBYFVPZUVNTZWGUVDJUFUSYKXIXGXKYEYLUVJXGXISUUCUVDUUDVLZUV
      DXMYKBCIDXGYEFYBUUHYCUVNVQZUVDXRUUEUVMUUGNZUVDUVBYKXGUVJWEUVOYKXSXGVONZUV
      DXNUUOUUKUUMXIQUUNXKQUUQUUMUUNXKQZXIQVSAXNUVCHVTZXGXIBXKUUKUUMUUNYBUUSUUT
      WKWFWLUVDUVLUVFYEYNUVDYKXQXSXISXGXGUVQUVMUVOWMWOWNUVDXMYKBCXJXKIYEDXGUVEF
      YAYBYCUUTUUHUVDXNXRUVBUVEXGMUWBUVMUVOXGXIBXQXSYBUUSWPWQUVNTUVDXMXIXHBCDYQ
      UVHFYCUUSUVAUVDXMBCXJYEDXGXQFYAYBYCUWBUVMUVNUTUVDXMBCXJYEDXGXSFYAYBYCUWBU
      VOUVNUTZWCWHUVDYKXQXSXKQZRVHZYEYNQZYLUVHYNQZUWDYEXJQXQUVHXJQUVDUWGYLUVKYN
      QYLUVJYNQZYEYNQUWFUVDUVHUVKYLYNUVPWDUVDJUFUSYKXKXKXGXKYLUVJYEXKSUVQUVSUVT
      UVRUVDXNUUOUUPUUNXKQUUKUWAXKQVSUWBXGBXKUUKUUMUUNYBUUTWRWFWSUVDUWHUWEYEYNU
      VDYKXQXSXKSXGXGUVQUVMUVOWMWOWNUVDXMYKBCXJXKIYEDXGUWDFYAYBYCUUTUUHUVDXNXRU
      VBUWDXGMUWBUVMUVOXGBXKXQXSYBUUTWTWQUVNTUVDXMYKBCXJXKIUVHDXGXQFYAYBYCUUTUU
      HUVMUWCTWHAXQXMMZVAZXLXQXJQYKXLRVHXQYNQXQUWJXMYKBCXJXKIXQDXGXLFYAYBYCUUTU
      UHUWJXNXLXGMAXNUWIHVTZXGBXLYBXLPZXANZAUWIXBZTUWJJYKXLXKXGXQSXGUUCUWJUUDVL
      UWJXMYKBCIDXGXQFYBUUHYCUWNVQUWMUWJXNUULXLUUKXKQUUKVSUWKXGBXKXLUUKYBUUTUWL
      XCWFXDXEXF $.

    ${
      psr1cl.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      psr1cl.z $e |- .0. = ( 0g ` R ) $.
      psr1cl.o $e |- .1. = ( 1r ` R ) $.
      psr1cl.u $e |- U =
        ( x e. D |-> if ( x = ( I X. { 0 } ) , .1. , .0. ) ) $.
      psr1cl.b $e |- B = ( Base ` S ) $.
      $( The identity element of the ring of power series.  (Contributed by
         Mario Carneiro, 29-Dec-2014.) $)
      psr1cl $p |- ( ph -> U e. B ) $=
        ( cbs cfv cmap co wf wcel cv cc0 csn cxp wceq cif crg eqid rngidcl ifcl
        rng0cl syl2anc syl adantr fmptd fvex ccnv cn cima cfn cn0 crab cvv ovex
        rabex eqeltri elmap sylibr psrbas eleqtrrd ) AGEUAUBZDUCUDZCADVQGUEGVRU
        FABDBUGZJUHUIUJUKZHLULZVQGAWAVQUFZVSDUFAEUMUFZWBOWCHVQUFLVQUFWBVQEHVQUN
        ZRUOVQELWDQUQVTHLVQUPURUSUTSVAVQDGEUAVBDIUGVCVDVEVFUFZIVGJUCUDZVHVIPWEI
        WFVGJUCVJVKVLVMVNACDEFIJVQKMWDPTNVOVP $.

      psrlidm.t $e |- .x. = ( .r ` S ) $.
      psrlidm.x $e |- ( ph -> X e. B ) $.
      $( The identity element of the ring of power series is a left identity.
         (Contributed by Mario Carneiro, 29-Dec-2014.) $)
      psrlidm $p |- ( ph -> ( U .x. X ) = X ) $=
        ( vy vz vg co cbs cfv wf wfn eqid psr1cl psrmulcl psrelbas ffn syl wcel
        cv wa cle cofr wbr crab cmin cof cmpt cgsu cc0 csn cxp adantr psrmulval
        cmulr simpr cres wss wceq cn0 ccnv cn cima cfn 0nn0 fconst6 a1i c0 0fin
        cvv cdif nn0supp eldifi fvconst2g syl2an suppss eqsstr3d sylancr psrbag
        mp1i ssfi wb mpbir2and wral psrbagf sylan ffvelrnda nn0ge0d inidm eqidd
        ralrimiva ofrfval mpbird breq1 elrab sylanbrc resmpt oveq2d ccmn rngcmn
        snssd crg cmap rabex eqeltri ad2antrr simpld syl2anc syl3anc cif sylan2
        cur fvex c0g fvmpt wn adantl eqtrd fveq2d oveq12d ovex syldan psrbagcon
        sylib simprd syl13anc ffvelrnd rngcl fmptd eqeq1 ifbid ifex eldifn elsn
        sylnib iffalse oveq1d rnglz suppss2 gsumres rngmnd iftrue nn0cn subid1d
        snfi caofid0r rnglidm eqeltrd fveq2 oveq2 gsumsn 3eqtr3d 3eqtrd eqfnfvd
        cmnd ) AUEDHMGUHZMADEUIUJZUVPUKUVPDULACDEFJKUVQUVPOUVQUMZRUBACEFGKHMOUB
        UCQABCDEFHIJKLNOPQRSTUAUBUNZUDUOUPDUVQUVPUQURADUVQMUKZMDULACDEFJKUVQMOU
        VRRUBUDUPZDUVQMUQURAUEUTZDUSZVAZUWBUVPUJEUFUGUTZUWBVBVCZVDZUGDVEZUFUTZH
        UJZUWBUWIVFVGZUHZMUJZEVOUJZUHZVHZVIUHZKVJVKZVLZHUJZUWBUWSUWKUHZMUJZUWNU
        HZUWBMUJZUWDUGCDEFGUWNJUFHMKUWBOUBUWNUMZUCRAHCUSUWCUVSVMZAMCUSUWCUDVMAU
        WCVPZVNUWDEUWPUWSVKZVQZVIUHEUFUXHUWOVHZVIUHZUWQUXCUWDUXIUXJEVIUWDUXHUWH
        VRUXIUXJVSUWDUWSUWHUWDUWSDUSZUWSUWBUWFVDZUWSUWHUSAUXLUWCAUXLKVTUWSUKZUW
        SWAZWBWCZWDUSZUXNAKVJVTWEWFZWGZAWHWDUSUXPWHVRUXQWIAUXPUXOWJUWRWKWCZWHUX
        NUXTUXPVSAUXRUWSKWLWTAKVTBUWSWHVJUXSAVJVTUSZBUTZKUSZUYBUWSUJVJVSZUYBKWH
        WKUSUYAAWEWGUYBKWHWMKVJUYBVTWNZWOWPWQWHUXPXAWRAKLUSZUXLUXNUXQVAXBPDJUWS
        KLRWSURXCVMZUWDUXMVJUYBUWBUJZVBVDZBKXDUWDUYIBKUWDUYCVAZUYHUWDKVTUYBUWBA
        UYFUWCKVTUWBUKZPDJUWBKLRXEXFZXGXHXKUWDBKKVJUYHVBKUWSUWBLLUXNUWSKULUWDUX
        RKVTUWSUQWTUWDUYKUWBKULUYLKVTUWBUQURAUYFUWCPVMZUYMKXIUWDUYAUYCUYDUYAUWD
        WEWGZUYEXFUYJUYHXJXLXMUWGUXMUGUWSDUWEUWSUWBUWFXNXOXPYAUFUWHUXHUWOXQURXR
        UWDUWHUVQUWPEWJUXHNUVRSAEXSUSZUWCAEYBUSZUYOQEXTURVMUWHWJUSUWDUWGUGDDJUT
        WAWBWCWDUSZJVTKYCUHZVEWJRUYQJUYRVTKYCUUAYDYEYDWGUWDUFUWHUWOUVQUWPUWDUWI
        UWHUSZVAZUYPUWJUVQUSZUWMUVQUSZUWOUVQUSAUYPUWCUYSQYFUWDUYSUWIDUSZVUAUYTV
        UCUWIUWBUWFVDZUYTUYSVUCVUDVAZUWDUYSVPUWGVUDUGUWIDUWEUWIUWBUWFXNXOUUDZYG
        ZUWDDUVQUWIHUWDCDEFJKUVQHOUVRRUBUXFUPXGUUBUYTDUVQUWLMAUVTUWCUYSUWAYFUYT
        UWLDUSZUWLUWBUWFVDZUYTUYFUWCKVTUWIUKZVUDVUHVUIVAAUYFUWCUYSPYFZUWDUWCUYS
        UXGVMUYTUYFVUCVUJVUKVUGDJUWIKLRXEYHUYTVUCVUDVUFUUEDJUWBUWIKLRUUCUUFYGUU
        GZUVQEUWNUWJUWMUVRUXEUUHYIUWPUMUUIUWDUWHUWOUFUXHNUWDUWIUWHUXHWKUSZVAZUW
        ONUWMUWNUHZNVUNUWJNUWMUWNVUNUWJUWIUWSVSZINYJZNVUNVUCUWJVUQVSVUNVUCVUDVU
        MUWDUYSVUEUWIUWHUXHWMZVUFYKYGBUWIUYBUWSVSZINYJZVUQDHUYBUWIVSVUSVUPINUYB
        UWIUWSUUJUUKUAVUPINIEYLUJWJTEYLYMYEZNEYNUJWJSEYNYMYEUULYOURVUNVUPYPVUQN
        VSVUNUWIUXHUSZVUPVUMVVBYPUWDUWIUWHUXHUUMYQUFUWSUUNUUOVUPINUUPURYRUUQVUN
        UYPVUBVUONVSAUYPUWCVUMQYFVUMUWDUYSVUBVURVULYKUVQEUWNUWMNUVRUXESUURYHYRU
        USZUWDUXHWDUSUWPWAWJNVKWKWCZUXHVRVVDWDUSUWSUVEVVCUXHVVDXAWRUUTUWDEUVOUS
        ZUXLUXCUVQUSUXKUXCVSUWDUYPVVEAUYPUWCQVMZEUVAURUYGUWDUXCUXDUVQUWDUXCIUXD
        UWNUHZUXDUWDUWTIUXBUXDUWNUWDUXLUWTIVSUYGBUWSVUTIDHVUSINUVBUAVVAYOURUWDU
        XAUWBMUWDUFKVJVFVTUWBLVTUYMUYLUYNUWIVTUSZUWIVJVFUHUWIVSUWDVVHUWIUWIUVCU
        VDYQUVFYSYTUWDUYPUXDUVQUSVVGUXDVSVVFADUVQUWBMUWAXGZUVQEUWNIUXDUVRUXETUV
        GYHYRZVVIUVHUWOUVQUXCUFEUWSDUVRVUPUWJUWTUWMUXBUWNUWIUWSHUVIVUPUWLUXAMUW
        IUWSUWBUWKUVJYSYTUVKYIUVLVVJUVMUVN $.

      $( The identity element of the ring of power series is a right identity.
         (Contributed by Mario Carneiro, 29-Dec-2014.) $)
      psrridm $p |- ( ph -> ( X .x. U ) = X ) $=
        ( vy vz vg co cbs cfv wf wfn eqid psr1cl psrmulcl psrelbas ffn syl wcel
        cv wa cle cofr wbr crab cmin cof cmulr cmpt cgsu adantr simpr psrmulval
        csn cres wss wceq cn0 psrbagf sylan nn0re leidd adantl caofref sylanbrc
        breq1 elrab snssd resmpt oveq2d cvv ccmn crg rngcmn ccnv cima cmap ovex
        cn cfn rabex eqeltri a1i ad2antrr sylib simpld syl2anc simprd psrbagcon
        ffvelrnd syl13anc rngcl syl3anc fmptd cc0 cxp eldifi sylan2 eqeq1 ifbid
        cdif cif cur c0g fvmpt wne weq wb cc nn0sscn fss sylancl ofsubeq0 eqtrd
        fvex ssfi sylancr fveq2d 0nn0 c0 ifex eldifsni necomd necon3bbid mpbird
        wn iffalse suppss2 snfi gsumres cmnd rngmnd mpbiri fconst6 0fin nn0supp
        rngrz fvconst2g syl2an suppss psrbag mpbir2and iftrue ffvelrnda rngridm
        eqsstr3d eqeltrd fveq2 oveq2 oveq12d gsumsn 3eqtr3d 3eqtrd eqfnfvd ) AU
        EDMHGUHZMADEUIUJZUVOUKUVODULACDEFJKUVPUVOOUVPUMZRUBACEFGKMHOUBUCQUDABCD
        EFHIJKLNOPQRSTUAUBUNZUOUPDUVPUVOUQURADUVPMUKZMDULACDEFJKUVPMOUVQRUBUDUP
        ZDUVPMUQURAUEUTZDUSZVAZUWAUVOUJEUFUGUTZUWAVBVCZVDZUGDVEZUFUTZMUJZUWAUWH
        VFVGZUHZHUJZEVHUJZUHZVIZVJUHZUWAMUJZUWAUWAUWJUHZHUJZUWMUHZUWQUWCUGCDEFG
        UWMJUFMHKUWAOUBUWMUMZUCRAMCUSUWBUDVKAHCUSUWBUVRVKZAUWBVLZVMUWCEUWOUWAVN
        ZVOZVJUHEUFUXDUWNVIZVJUHZUWPUWTUWCUXEUXFEVJUWCUXDUWGVPUXEUXFVQUWCUWAUWG
        UWCUWBUWAUWAUWEVDZUWAUWGUSUXCUWCUFKVBVRUWALAKLUSZUWBPVKZAUXIUWBKVRUWAUK
        ZPDJUWAKLRVSVTZUWHVRUSZUWHUWHVBVDUWCUXMUWHUWHWAWBWCWDUWFUXHUGUWADUWDUWA
        UWAUWEWFWGWEWHUFUWGUXDUWNWIURWJUWCUWGUVPUWOEWKUXDNUVQSAEWLUSZUWBAEWMUSZ
        UXNQEWNURVKUWGWKUSUWCUWFUGDDJUTWOWSWPWTUSZJVRKWQUHZVEWKRUXPJUXQVRKWQWRX
        AXBXAXCUWCUFUWGUWNUVPUWOUWCUWHUWGUSZVAZUXOUWIUVPUSZUWLUVPUSUWNUVPUSAUXO
        UWBUXRQXDZUXSDUVPUWHMAUVSUWBUXRUVTXDUXSUWHDUSZUWHUWAUWEVDZUXSUXRUYBUYCV
        AUWCUXRVLUWFUYCUGUWHDUWDUWHUWAUWEWFWGXEZXFZXJZUXSDUVPUWKHUWCDUVPHUKUXRU
        WCCDEFJKUVPHOUVQRUBUXBUPVKUXSUWKDUSZUWKUWAUWEVDZUXSUXIUWBKVRUWHUKZUYCUY
        GUYHVAAUXIUWBUXRPXDZUWCUWBUXRUXCVKUXSUXIUYBUYIUYJUYEDJUWHKLRVSXGZUXSUYB
        UYCUYDXHDJUWAUWHKLRXIXKXFZXJUVPEUWMUWIUWLUVQUXAXLXMUWOUMXNUWCUWGUWNUFUX
        DNUWCUWHUWGUXDYAUSZVAZUWNUWINUWMUHZNUYNUWLNUWIUWMUYNUWLUWKKXOVNZXPZVQZI
        NYBZNUYNUYGUWLUYSVQUYMUWCUXRUYGUWHUWGUXDXQZUYLXRBUWKBUTZUYQVQZINYBZUYSD
        HVUAUWKVQVUBUYRINVUAUWKUYQXSXTUAUYRINIEYCUJWKTEYCYOXBZNEYDUJWKSEYDYOXBU
        UAYEURUYNUYRUUFZUYSNVQUYNVUEUWAUWHYFUYNUWHUWAUYMUWHUWAYFUWCUWHUWGUWAUUB
        WCUUCUYNUYRUWAUWHUYMUWCUXRUYRUEUFYGYHZUYTUXSUXIKYIUWAUKZKYIUWHUKZVUFUYJ
        UWCVUGUXRUWCUXKVRYIVPZVUGUXLYJKVRYIUWAYKYLZVKUXSUYIVUIVUHUYKYJKVRYIUWHY
        KYLKUWAUWHLYMXMXRUUDUUEUYRINUUGURYNWJUYMUWCUXRUYONVQZUYTUXSUXOUXTVUKUYA
        UYFUVPEUWMUWINUVQUXASUUQXGXRYNUUHZUWCUXDWTUSUWOWOWKNVNYAWPZUXDVPVUMWTUS
        UWAUUIVULUXDVUMYPYQUUJUWCEUUKUSZUWBUWTUVPUSUXGUWTVQUWCUXOVUNAUXOUWBQVKZ
        EUULURUXCUWCUWTUWQUVPUWCUWTUWQIUWMUHZUWQUWCUWSIUWQUWMUWCUWSUYQHUJZIUWCU
        WRUYQHUWCUWRUYQVQZUEUEYGZUWAUMUWCUXIVUGVUGVURVUSYHUXJVUJVUJKUWAUWALYMXM
        UUMYRUWCUYQDUSZVUQIVQAVUTUWBAVUTKVRUYQUKZUYQWOZWSWPZWTUSZVVAAKXOVRYSUUN
        XCZAYTWTUSVVCYTVPVVDUUOAVVCVVBWKUYPYAWPZYTAVVAVVFVVCVQVVEUYQKUUPURAKVRB
        UYQYTXOVVEAXOVRUSZVUAKUSVUAUYQUJXOVQVUAKYTYAUSVVGAYSXCVUAKYTXQKXOVUAVRU
        URUUSUUTUVFYTVVCYPYQAUXIVUTVVAVVDVAYHPDJUYQKLRUVAURUVBVKBUYQVUCIDHVUBIN
        UVCUAVUDYEURYNWJUWCUXOUWQUVPUSVUPUWQVQVUOADUVPUWAMUVTUVDZUVPEUWMIUWQUVQ
        UXATUVEXGYNZVVHUVGUWNUVPUWTUFEUWADUVQUFUEYGZUWIUWQUWLUWSUWMUWHUWAMUVHVV
        JUWKUWRHUWHUWAUWAUWJUVIYRUVJUVKXMUVLVVIUVMUVN $.
    $}

    ${
      psrass.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      psrass.t $e |- .X. = ( .r ` S ) $.
      psrass.b $e |- B = ( Base ` S ) $.
      psrass.x $e |- ( ph -> X e. B ) $.
      psrass.y $e |- ( ph -> Y e. B ) $.
      ${
        psrass.z $e |- ( ph -> Z e. B ) $.
        $( Associative identity for the ring of power series.  (Contributed by
           Mario Carneiro, 5-Jan-2015.) $)
        psrass1 $p |- ( ph ->
          ( ( X .X. Y ) .X. Z ) = ( X .X. ( Y .X. Z ) ) ) $=
          ( vx vk vg vj vh vn vz co cbs cfv wf wfn psrmulcl psrelbas ffn syl cv
          eqid wcel wa cle cofr wbr crab cmin cmulr cmpt cgsu adantr simpr ccmn
          cof crg rngcmn ad2antrr breq1 elrab sylib simpld ad3antrrr cn0 simplr
          ffvelrnd psrbagf syl2anc simprd psrbagcon syl13anc rngcl syl3anc wceq
          anasss fveq2 fveq2d oveq12d oveq2d psrass1lem psrmulval oveq1d cplusg
          oveq2 cfn c0g psrbaglefi cvv csn cdif fmptd fisuppfi gsummulc1 rngass
          sylan ffvelrnda cc nn0cn nnncan2 syl3an mpteq2dva a1i feqmptd offval2
          ovex 3eqtr4d eqtr4d 3eqtr2d ccnv cima wss cnvimass dmmptss sstri ssfi
          cdm sylancl gsummulc2 eqfnfvd ) AUBCJKFUIZLFUIZJKLFUIZFUIZACDUJUKZYSU
          LYSCUMABCDEGHUUBYSMUUBUSZPRABDEFHYRLMRQOABDEFHJKMRQOSTUNZUAUNUOCUUBYS
          UPUQACUUBUUAULUUACUMABCDEGHUUBUUAMUUCPRABDEFHJYTMRQOSABDEFHKLMRQOTUAU
          NZUNUOCUUBUUAUPUQAUBURZCUTZVAZDUCUDURZUUFVBVCZVDZUDCVEZUCURZYRUKZUUFU
          UMVFVMZUIZLUKZDVGUKZUIZVHZVIUIZDUEUULUEURZJUKZUUFUVBUUOUIZYTUKZUURUIZ
          VHZVIUIZUUFYSUKUUFUUAUKUUHDUCUULDUEUFURZUUMUUJVDZUFCVEZUVCUUMUVBUUOUI
          ZKUKZUVDUVLUUOUIZLUKZUURUIZUURUIZVHZVIUIZVHZVIUIDUEUULDUGUVIUVDUUJVDZ
          UFCVEZUVCUGURZKUKZUVDUWCUUOUIZLUKZUURUIZUURUIZVHVIUIZVHZVIUIUVAUVHUUH
          UFUDUUBCUULGUEUGUCUUFDHIUWHUVQPUULUSAHIUTZUUGNVJAUUGVKZUUCADVLUTZUUGA
          DVNUTZUWMODVOUQVJUUHUVBUULUTZUWCUWBUTZUWHUUBUTZUUHUWOVAZUWPVAZUWNUVCU
          UBUTZUWGUUBUTZUWQUWRUWNUWPAUWNUUGUWOOVPZVJZUWRUWTUWPUWRCUUBUVBJACUUBJ
          ULZUUGUWOABCDEGHUUBJMUUCPRSUOZVPUWRUVBCUTZUVBUUFUUJVDZUWRUWOUXFUXGVAU
          UHUWOVKUUKUXGUDUVBCUUIUVBUUFUUJVQVRVSZVTZWDZVJUWSUWNUWDUUBUTUWFUUBUTU
          XAUXCUWSCUUBUWCKACUUBKULZUUGUWOUWPABCDEGHUUBKMUUCPRTUOZWAUWSUWCCUTZUW
          CUVDUUJVDZUWSUWPUXMUXNVAUWRUWPVKUWAUXNUFUWCCUVIUWCUVDUUJVQVRVSZVTZWDU
          WSCUUBUWELACUUBLULZUUGUWOUWPABCDEGHUUBLMUUCPRUAUOZWAUWSUWECUTZUWEUVDU
          UJVDZUWSUWKUVDCUTZHWBUWCULZUXNUXSUXTVAUWRUWKUWPAUWKUUGUWONVPZVJZUWRUY
          AUWPUWRUYAUVDUUFUUJVDZUWRUWKUUGHWBUVBULZUXGUYAUYEVAUYCAUUGUWOWCUWRUWK
          UXFUYFUYCUXICGUVBHIPWEZWFUWRUXFUXGUXHWGCGUUFUVBHIPWHWIVTZVJUWSUWKUXMU
          YBUYDUXPCGUWCHIPWEWFUWSUXMUXNUXOWGCGUVDUWCHIPWHWIVTWDUUBDUURUWDUWFUUC
          UURUSZWJWKZUUBDUURUVCUWGUUCUYIWJWKWMUWCUVLWLZUWGUVPUVCUURUYKUWDUVMUWF
          UVOUURUWCUVLKWNUYKUWEUVNLUWCUVLUVDUUOXBWOWPWQWRUUHUUTUVTDVIUUHUCUULUU
          SUVSUUHUUMUULUTZVAZUUSDUEUVKUVCUVMUURUIZVHZVIUIZUUQUURUIDUEUVKUYNUUQU
          URUIZVHZVIUIUVSUYMUUNUYPUUQUURUYMUFBCDEFUURGUEJKHUUMMRUYIQPAJBUTZUUGU
          YLSVPAKBUTZUUGUYLTVPUYMUUMCUTZUUMUUFUUJVDZUYMUYLVUAVUBVAUUHUYLVKUUKVU
          BUDUUMCUUIUUMUUFUUJVQVRVSZVTZWSWTUYMUVKUUBDXAUKZDUURUEXCUYNUUQDXDUKZU
          UCVUFUSZVUEUSZUYIAUWNUUGUYLOVPZUYMUWKVUAUVKXCUTAUWKUUGUYLNVPZVUDUFCGU
          UMHIPXEWFZUYMCUUBUUPLAUXQUUGUYLUXRVPUYMUUPCUTZUUPUUFUUJVDZUYMUWKUUGHW
          BUUMULZVUBVULVUMVAVUJAUUGUYLWCUYMUWKVUAVUNVUJVUDCGUUMHIPWEWFZUYMVUAVU
          BVUCWGCGUUFUUMHIPWHWIVTWDZUYMUVBUVKUTZVAZUWNUWTUVMUUBUTZUYNUUBUTUYMUW
          NVUQVUIVJZVURCUUBUVBJAUXDUUGUYLVUQUXEWAVURUXFUVBUUMUUJVDZVURVUQUXFVVA
          VAUYMVUQVKUVJVVAUFUVBCUVIUVBUUMUUJVQVRVSZVTZWDZVURCUUBUVLKAUXKUUGUYLV
          UQUXLWAVURUVLCUTZUVLUUMUUJVDZVURUWKVUAUYFVVAVVEVVFVAUYMUWKVUQVUJVJZUY
          MVUAVUQVUDVJVURUWKUXFUYFVVGVVCUYGWFZVURUXFVVAVVBWGCGUUMUVBHIPWHWIVTWD
          ZUUBDUURUVCUVMUUCUYIWJWKZUYMUVKUUBXFVUFXGXHZUYOVUKUYMUEUVKUYNUUBUYOVV
          JUYOUSXIXJXKUYMUYRUVRDVIUYMUEUVKUYQUVQVURUYQUVCUVMUUQUURUIZUURUIZUVQV
          URUWNUWTVUSUUQUUBUTZUYQVVMWLVUTVVDVVIUYMVVNVUQVUPVJUUBDUURUVCUVMUUQUU
          CUYIXLWIVURUVPVVLUVCUURVURUVOUUQUVMUURVURUVNUUPLVURUHHUHURZUUFUKZVVOU
          VBUKZVFUIZVVOUUMUKZVVQVFUIZVFUIZVHUHHVVPVVSVFUIZVHUVNUUPVURUHHVWAVWBV
          URVVOHUTVAZVVPWBUTZVVSWBUTZVVQWBUTZVWAVWBWLZVURHWBVVOUUFUUHHWBUUFULZU
          YLVUQAUWKUUGVWHNCGUUFHIPWEXMVPZXNZVURHWBVVOUUMUYMVUNVUQVUOVJZXNZVURHW
          BVVOUVBVVHXNZVWDVVPXOUTVWEVVSXOUTVWFVVQXOUTVWGVVPXPVVSXPVVQXPVVPVVSVV
          QXQXRWKXSVURUHHVVRVVTVFUVDUVLIXFXFVVGVVRXFUTVWCVVPVVQVFYCXTVVTXFUTVWC
          VVSVVQVFYCXTVURUHHVVPVVQVFUUFUVBIWBWBVVGVWJVWMVURUHHWBUUFVWIYAZVURUHH
          WBUVBVVHYAZYBVURUHHVVSVVQVFUUMUVBIWBWBVVGVWLVWMVURUHHWBUUMVWKYAZVWOYB
          YBVURUHHVVPVVSVFUUFUUMIWBWBVVGVWJVWLVWNVWPYBYDWOWQWQYEXSWQYFXSWQUUHUV
          GUWJDVIUUHUEUULUVFUWIUWRUVFUVCDUGUWBUWGVHZVIUIZUURUIUWIUWRUVEVWRUVCUU
          RUWRUFBCDEFUURGUGKLHUVDMRUYIQPAUYTUUGUWOTVPALBUTZUUGUWOUAVPUYHWSWQUWR
          UWBUUBVUEDUURUGXCUWGUVCVUFUUCVUGVUHUYIUXBUWRUWKUYAUWBXCUTZUYCUYHUFCGU
          VDHIPXEWFZUXJUYJUWRVWTVWQYGVVKYHZUWBYIVXBXCUTVXAVXBVWQYNUWBVWQVVKYJUG
          UWBUWGVWQVWQUSYKYLUWBVXBYMYOYPYEXSWQYDUUHUDBCDEFUURGUCYRLHUUFMRUYIQPA
          YRBUTUUGUUDVJAVWSUUGUAVJUWLWSUUHUDBCDEFUURGUEJYTHUUFMRUYIQPAUYSUUGSVJ
          AYTBUTUUGUUEVJUWLWSYDYQ $.

        psrdi.a $e |- .+ = ( +g ` S ) $.
        $( Distributive law for the ring of power series.  (Contributed by
           Mario Carneiro, 7-Jan-2015.) $)
        psrdi $p |- ( ph ->
          ( X .X. ( Y .+ Z ) ) = ( ( X .X. Y ) .+ ( X .X. Z ) ) ) $=
          ( vk vx vy cv cle cofr wbr crab cfv cmin cof co cmpt cgsu cplusg wcel
          cmulr wa wceq eqid psradd fveq1d ad2antrr ssrab2 simplr simpr syl3anc
          psrbagconcl sseldi cvv cbs wf wfn psrelbas ffn syl ccnv cima cfn cmap
          cn cn0 ovex rabex eqeltri a1i inidm eqidd ofval mpdan oveq2d ffvelrnd
          eqtrd crg rngdi syl13anc mpteq2dva psrbaglefi sylan rngcl offval2 c0g
          eqtr4d ccmn adantr fmptd csn cdif wss cdm cnvimass dmmptss sstri ssfi
          rngcmn sylancl gsumadd rnggrp psraddcl psrmulfval psrmulcl 3eqtr4d
          cgrp ) AUDCEUEUFUGUDUGZUHUIUJZUFCUKZUEUGZKULZYGYJUMUNUOZLMDUOZULZEUTU
          LZUOZUPZUQUOZUPUDCEUEYIYKYLLULZYOUOZUPZUQUOZEUEYIYKYLMULZYOUOZUPZUQUO
          ZEURULZUOZUPZKYMGUOKLGUOZKMGUOZDUOZAUDCYRUUHAYGCUSZVAZYREUUAUUEUUGUNZ
          UOZUQUOUUHUUNYQUUPEUQUUNYQUEYIYTUUDUUGUOZUPUUPUUNUEYIYPUUQUUNYJYIUSZV
          AZYPYKYSUUCUUGUOZYOUOZUUQUUSYNUUTYKYOUUSYNYLLMUUOUOZULZUUTAYNUVCVBUUM
          UURAYLYMUVBABUUGDEFILMNSUUGVCZUCUAUBVDVEVFUUSYLCUSZUVCUUTVBUUSYICYLYH
          UFCVGZUUSIJUSZUUMUURYLYIUSAUVGUUMUUROVFAUUMUURVHUUNUURVIZUFCYIHYGIJYJ
          QYIVCVKVJVLZUUSCCYSUUCUUGCLMVMVMYLUUSCEVNULZLVOZLCVPAUVKUUMUURABCEFHI
          UVJLNUVJVCZQSUAVQVFZCUVJLVRVSUUSCUVJMVOZMCVPAUVNUUMUURABCEFHIUVJMNUVL
          QSUBVQVFZCUVJMVRVSCVMUSZUUSCHUGVTWDWAWBUSZHWEIWCUOZUKVMQUVQHUVRWEIWCW
          FWGWHZWIZUVTCWJUUSUVEVAZYSWKUWAUUCWKWLWMWPWNUUSEWQUSZYKUVJUSZYSUVJUSZ
          UUCUVJUSZUVAUUQVBAUWBUUMUURPVFZUUSCUVJYJKACUVJKVOUUMUURABCEFHIUVJKNUV
          LQSTVQVFUUSYICYJUVFUVHVLWOZUUSCUVJYLLUVMUVIWOZUUSCUVJYLMUVOUVIWOZUVJU
          UGEYOYKYSUUCUVLUVDYOVCZWRWSWPWTUUNUEYIYTUUDUUGUUAUUEWBUVJUVJAUVGUUMYI
          WBUSZOUFCHYGIJQXAXBZUUSUWBUWCUWDYTUVJUSUWFUWGUWHUVJEYOYKYSUVLUWJXCVJZ
          UUSUWBUWCUWEUUDUVJUSUWFUWGUWIUVJEYOYKUUCUVLUWJXCVJZUUNUUAWKUUNUUEWKXD
          XFWNUUNYIUVJUUGUUAEUUEWBEXEULZUVLUWOVCUVDUUNUWBEXGUSAUWBUUMPXHEXRVSUW
          LUUNUEYIYTUVJUUAUWMUUAVCZXIUUNUEYIUUDUVJUUEUWNUUEVCZXIUUNUWKUUAVTVMUW
          OXJXKZWAZYIXLUWSWBUSUWLUWSUUAXMYIUUAUWRXNUEYIYTUUAUWPXOXPYIUWSXQXSUUN
          UWKUUEVTUWRWAZYIXLUWTWBUSUWLUWTUUEXMYIUUEUWRXNUEYIUUDUUEUWQXOXPYIUWTX
          QXSXTWPWTAUEUFBCEFGYOHUDKYMINSUWJRQTABDEFILMNSUCAUWBEYFUSPEYAVSUAUBYB
          YCAUULUUJUUKUUOUOUUIABUUGDEFIUUJUUKNSUVDUCABEFGIKLNSRPTUAYDABEFGIKMNS
          RPTUBYDVDAUDCUUBUUFUUGUUJUUKVMVMVMUVPAUVSWIUUBVMUSUUNEUUAUQWFWIUUFVMU
          SUUNEUUEUQWFWIAUEUFBCEFGYOHUDKLINSUWJRQTUAYCAUEUFBCEFGYOHUDKMINSUWJRQ
          TUBYCXDWPYE $.

        $( Distributive law for the ring of power series.  (Contributed by
           Mario Carneiro, 7-Jan-2015.) $)
        psrdir $p |- ( ph ->
          ( ( X .+ Y ) .X. Z ) = ( ( X .X. Z ) .+ ( Y .X. Z ) ) ) $=
          ( vk vx vy cv cle cofr wbr crab co cfv cmin cof cmpt cgsu cplusg wcel
          cmulr wa wceq eqid psradd fveq1d ad2antrr ssrab2 simpr sseldi cvv cbs
          wf wfn psrelbas ffn syl ccnv cima cfn cn0 cmap ovex rabex eqeltri a1i
          inidm eqidd ofval mpdan eqtrd oveq1d crg ffvelrnd psrbagconcl syl3anc
          simplr rngdir syl13anc mpteq2dva psrbaglefi sylan rngcl eqtr4d oveq2d
          cn offval2 c0g ccmn adantr rngcmn fmptd csn cdif wss cnvimass dmmptss
          cdm sstri sylancl gsumadd rnggrp psraddcl psrmulfval psrmulcl 3eqtr4d
          ssfi cgrp ) AUDCEUEUFUGUDUGZUHUIUJZUFCUKZUEUGZKLDULZUMZYHYKUNUOULZMUM
          ZEUTUMZULZUPZUQULZUPUDCEUEYJYKKUMZYOYPULZUPZUQULZEUEYJYKLUMZYOYPULZUP
          ZUQULZEURUMZULZUPZYLMGULKMGULZLMGULZDULZAUDCYSUUIAYHCUSZVAZYSEUUBUUFU
          UHUOZULZUQULUUIUUOYRUUQEUQUUOYRUEYJUUAUUEUUHULZUPUUQUUOUEYJYQUURUUOYK
          YJUSZVAZYQYTUUDUUHULZYOYPULZUURUUTYMUVAYOYPUUTYMYKKLUUPULZUMZUVAAYMUV
          DVBUUNUUSAYKYLUVCABUUHDEFIKLNSUUHVCZUCTUAVDVEVFUUTYKCUSZUVDUVAVBUUTYJ
          CYKYIUFCVGZUUOUUSVHZVIZUUTCCYTUUDUUHCKLVJVJYKUUTCEVKUMZKVLZKCVMAUVKUU
          NUUSABCEFHIUVJKNUVJVCZQSTVNVFZCUVJKVOVPUUTCUVJLVLZLCVMAUVNUUNUUSABCEF
          HIUVJLNUVLQSUAVNVFZCUVJLVOVPCVJUSZUUTCHUGVQXEVRVSUSZHVTIWAULZUKVJQUVQ
          HUVRVTIWAWBWCWDZWEZUVTCWFUUTUVFVAZYTWGUWAUUDWGWHWIWJWKUUTEWLUSZYTUVJU
          SZUUDUVJUSZYOUVJUSZUVBUURVBAUWBUUNUUSPVFZUUTCUVJYKKUVMUVIWMZUUTCUVJYK
          LUVOUVIWMZUUTCUVJYNMACUVJMVLUUNUUSABCEFHIUVJMNUVLQSUBVNVFUUTYJCYNUVGU
          UTIJUSZUUNUUSYNYJUSAUWIUUNUUSOVFAUUNUUSWPUVHUFCYJHYHIJYKQYJVCWNWOVIWM
          ZUVJUUHEYPYTUUDYOUVLUVEYPVCZWQWRWJWSUUOUEYJUUAUUEUUHUUBUUFVSUVJUVJAUW
          IUUNYJVSUSZOUFCHYHIJQWTXAZUUTUWBUWCUWEUUAUVJUSUWFUWGUWJUVJEYPYTYOUVLU
          WKXBWOZUUTUWBUWDUWEUUEUVJUSUWFUWHUWJUVJEYPUUDYOUVLUWKXBWOZUUOUUBWGUUO
          UUFWGXFXCXDUUOYJUVJUUHUUBEUUFVSEXGUMZUVLUWPVCUVEUUOUWBEXHUSAUWBUUNPXI
          EXJVPUWMUUOUEYJUUAUVJUUBUWNUUBVCZXKUUOUEYJUUEUVJUUFUWOUUFVCZXKUUOUWLU
          UBVQVJUWPXLXMZVRZYJXNUWTVSUSUWMUWTUUBXQYJUUBUWSXOUEYJUUAUUBUWQXPXRYJU
          WTYFXSUUOUWLUUFVQUWSVRZYJXNUXAVSUSUWMUXAUUFXQYJUUFUWSXOUEYJUUEUUFUWRX
          PXRYJUXAYFXSXTWJWSAUEUFBCEFGYPHUDYLMINSUWKRQABDEFIKLNSUCAUWBEYGUSPEYA
          VPTUAYBUBYCAUUMUUKUULUUPULUUJABUUHDEFIUUKUULNSUVEUCABEFGIKMNSRPTUBYDA
          BEFGILMNSRPUAUBYDVDAUDCUUCUUGUUHUUKUULVJVJVJUVPAUVSWEUUCVJUSUUOEUUBUQ
          WBWEUUGVJUSUUOEUUFUQWBWEAUEUFBCEFGYPHUDKMINSUWKRQTUBYCAUEUFBCEFGYPHUD
          LMINSUWKRQUAUBYCXFWJYE $.
      $}

      psrcom.c $e |- ( ph -> R e. CRing ) $.
      $( Commutative law for the ring of power series.  (Contributed by Mario
         Carneiro, 7-Jan-2015.) $)
      psrcom $p |- ( ph -> ( X .X. Y ) = ( Y .X. X ) ) $=
        ( vx vk vg vj vz cv cle cofr wbr crab cfv cmin cof cmulr cmpt cgsu wcel
        co wa ccom cbs cfn c0g eqid ccmn crg rngcmn syl adantr psrbaglefi sylan
        ad2antrr wf psrelbas simpr breq1 elrab sylib simpld ffvelrnd cn0 simplr
        psrbagf syl2anc simprd psrbagcon syl13anc rngcl syl3anc fmptd ccnv cdif
        cvv csn cima wss cdm cnvimass dmmptss ssfi sylancl psrbagconf1o gsumf1o
        sstri wf1o psrbagconcl eqidd wceq fveq2 fveq2d oveq12d fmptco ffvelrnda
        oveq2 cc nn0cn syl2an mpteq2dva ovex a1i feqmptd offval2 3eqtr4d oveq2d
        nncan ccrg crngcom eqtrd psrmulfval ) AUACDUBUCUFZUAUFZUGUHZUIZUCCUJZUB
        UFZJUKZYKYOULUMZURZKUKZDUNUKZURZUOZUPURZUOUACDUDYNUDUFZKUKZYKUUDYQURZJU
        KZYTURZUOZUPURZUOJKFURKJFURAUACUUCUUJAYKCUQZUSZUUCDUUBUDYNUUFUOZUTZUPUR
        UUJUULYNDVAUKZYNUUBDUUMVBDVCUKZUUOVDZUUPVDADVEUQZUUKADVFUQZUURNDVGVHVIA
        HIUQZUUKYNVBUQZMUCCGYKHIOVJVKZUULUBYNUUAUUOUUBUULYOYNUQZUSZUUSYPUUOUQYS
        UUOUQUUAUUOUQAUUSUUKUVCNVLUVDCUUOYOJACUUOJVMZUUKUVCABCDEGHUUOJLUUQOQRVN
        ZVLUVDYOCUQZYOYKYLUIZUVDUVCUVGUVHUSUULUVCVOYMUVHUCYOCYJYOYKYLVPVQVRZVSZ
        VTUVDCUUOYRKACUUOKVMZUUKUVCABCDEGHUUOKLUUQOQSVNZVLUVDYRCUQZYRYKYLUIZUVD
        UUTUUKHWAYOVMZUVHUVMUVNUSAUUTUUKUVCMVLZAUUKUVCWBUVDUUTUVGUVOUVPUVJCGYOH
        IOWCWDUVDUVGUVHUVIWECGYKYOHIOWFWGVSVTUUODYTYPYSUUQYTVDZWHWIUUBVDZWJUULU
        VAUUBWKWMUUPWNWLZWOZYNWPUVTVBUQUVBUVTUUBWQYNUUBUVSWRUBYNUUAUUBUVRWSXDYN
        UVTWTXAAUUTUUKYNYNUUMXEMUDUCCYNGYKHIOYNVDZXBVKXCUULUUNUUIDUPUULUUNUDYNU
        UGYKUUFYQURZKUKZYTURZUOUUIUULUDUBYNYNUUFUUAUWDUUMUUBUULUUDYNUQZUSZUUTUU
        KUWEUUFYNUQAUUTUUKUWEMVLZAUUKUWEWBZUULUWEVOZUCCYNGYKHIUUDOUWAXFWIUULUUM
        XGUULUUBXGYOUUFXHZYPUUGYSUWCYTYOUUFJXIUWJYRUWBKYOUUFYKYQXNXJXKXLUULUDYN
        UWDUUHUWFUWDUUGUUEYTURZUUHUWFUWCUUEUUGYTUWFUWBUUDKUWFUEHUEUFZYKUKZUWMUW
        LUUDUKZULURZULURZUOUEHUWNUOUWBUUDUWFUEHUWPUWNUWFUWLHUQUSZUWMWAUQZUWNWAU
        QZUWPUWNXHZUWFHWAUWLYKUULHWAYKVMZUWEAUUTUUKUXAMCGYKHIOWCVKVIZXMZUWFHWAU
        WLUUDUWFUUTUUDCUQZHWAUUDVMZUWGUWFUXDUUDYKYLUIZUWFUWEUXDUXFUSUWIYMUXFUCU
        UDCYJUUDYKYLVPVQVRZVSZCGUUDHIOWCWDZXMZUWRUWMXOUQUWNXOUQUWTUWSUWMXPUWNXP
        UWMUWNYEXQWDXRUWFUEHUWMUWOULYKUUFIWAWMUWGUXCUWOWMUQUWQUWMUWNULXSXTUWFUE
        HWAYKUXBYAZUWFUEHUWMUWNULYKUUDIWAWAUWGUXCUXJUXKUWFUEHWAUUDUXIYAZYBYBUXL
        YCXJYDUWFDYFUQZUUGUUOUQUUEUUOUQUWKUUHXHAUXMUUKUWETVLUWFCUUOUUFJAUVEUUKU
        WEUVFVLUWFUUFCUQZUUFYKYLUIZUWFUUTUUKUXEUXFUXNUXOUSUWGUWHUXIUWFUXDUXFUXG
        WECGYKUUDHIOWFWGVSVTUWFCUUOUUDKAUVKUUKUWEUVLVLUXHVTUUODYTUUGUUEUUQUVQYG
        WIYHXRYHYDYHXRAUBUCBCDEFYTGUAJKHLQUVQPORSYIAUDUCBCDEFYTGUAKJHLQUVQPOSRY
        IYC $.

      psrass.k $e |- K = ( Base ` R ) $.
      psrass.n $e |- .x. = ( .s ` S ) $.
      psrass.a $e |- ( ph -> A e. K ) $.
      $( Associative identities for the ring of power series.  (Contributed by
         Mario Carneiro, 7-Jan-2015.) $)
      psrass23 $p |- ( ph -> ( ( ( A .x. X ) .X. Y ) = ( A .x. ( X .X. Y ) ) /\
        ( X .X. ( A .x. Y ) ) = ( A .x. ( X .X. Y ) ) ) ) $=
        ( vk vx vy vu vv vw co wceq cv cle cofr wbr crab cfv cmin cof cmpt cgsu
        cmulr wcel wa cbs eqid adantr syl6eleq ad2antrr ssrab2 simpr psrvscaval
        sseldi oveq1d crg psrelbas ffvelrnd simplr psrbagconcl syl3anc syl13anc
        rngass eqtrd mpteq2dva oveq2d cplusg cfn c0g psrbaglefi sylan rngcl cvv
        ccnv csn cdif cima wss cdm cnvimass dmmptss sylancl gsummulc2 psrvscacl
        sstri ssfi psrmulfval cxp psrmulcl psrvsca cn cn0 cmap ovex eqeltri a1i
        rabex fconstmpt offval2 3eqtr4d ccrg crngcom 3expb w3a caov12d jca ) AB
        MGUMZNHUMZBMNHUMZGUMZUNMBNGUMZHUMZYLUNAUGDEUHUIUOUGUOZUPUQURZUIDUSZUHUO
        ZYIUTZYOYRVAVBUMZNUTZEVEUTZUMZVCZVDUMZVCUGDBEUHYQYRMUTZUUAUUBUMZVCZVDUM
        ZUUBUMZVCZYJYLAUGDUUEUUJAYODVFZVGZUUEEUHYQBUUGUUBUMZVCZVDUMZUUJUUMUUDUU
        OEVDUUMUHYQUUCUUNUUMYRYQVFZVGZUUCBUUFUUBUMZUUAUUBUMZUUNUURYSUUSUUAUUBUU
        RCDEFGUUBIMJEVHUTZBYROUEUVAVIZTUUBVIZRUUMBUVAVFZUUQUUMBKUVAABKVFUULUFVJ
        ZUDVKZVJZAMCVFUULUUQUAVLZUURYQDYRYPUIDVMZUUMUUQVNZVPZVOVQUUREVRVFZUVDUU
        FUVAVFZUUAUVAVFZUUTUUNUNAUVLUULUUQQVLZUVGUURDUVAYRMUURCDEFIJUVAMOUVBRTU
        VHVSUVKVTZUURDUVAYTNUURCDEFIJUVANOUVBRTANCVFUULUUQUBVLZVSUURYQDYTUVIUUR
        JLVFZUULUUQYTYQVFAUVRUULUUQPVLAUULUUQWAUVJUIDYQIYOJLYRRYQVIWBWCVPZVTZUV
        AEUUBBUUFUUAUVBUVCWEWDWFWGWHUUMYQUVAEWIUTZEUUBUHWJUUGBEWKUTZUVBUWBVIUWA
        VIUVCAUVLUULQVJAUVRUULYQWJVFZPUIDIYOJLRWLWMZUVFUURUVLUVMUVNUUGUVAVFUVOU
        VPUVTUVAEUUBUUFUUAUVBUVCWNWCUUMUWCUUHWPWOUWBWQWRZWSZYQWTUWFWJVFUWDUWFUU
        HXAYQUUHUWEXBUHYQUUGUUHUUHVIXCXGYQUWFXHXDXEZWFWGAUHUICDEFHUUBIUGYINJOTU
        VCSRACEFGMJKBOUEUDTQUFUAXFUBXIAYLDBWQXJZYKUUBVBUMUUKACDEFGUUBIYKJKBOUEU
        DTUVCRUFACEFHJMNOTSQUAUBXKXLAUGDBUUIUUBUWHYKWOKWODWOVFADIUOWPXMWSWJVFZI
        XNJXOUMZUSWORUWIIUWJXNJXOXPXSXQXRUVEUUIWOVFUUMEUUHVDXPXRUWHUGDBVCUNAUGD
        BXTXRAUHUICDEFHUUBIUGMNJOTUVCSRUAUBXIYAWFZYBAUGDEUHYQUUFYTYMUTZUUBUMZVC
        ZVDUMZVCUUKYNYLAUGDUWOUUJUUMUWOUUPUUJUUMUWNUUOEVDUUMUHYQUWMUUNUURUWMUUF
        BUUAUUBUMZUUBUMUUNUURUWLUWPUUFUUBUURCDEFGUUBINJUVABYTOUEUVBTUVCRUVGUVQU
        VSVOWHUURUJUKULUUFBUUAUVAUUBUVPUVGUVTUUREYCVFZUJUOZUVAVFZUKUOZUVAVFZVGU
        WRUWTUUBUMZUWTUWRUUBUMUNZAUWQUULUUQUCVLUWQUWSUXAUXCUVAEUUBUWRUWTUVBUVCY
        DYEWMUURUVLUWSUXAULUOZUVAVFYFUXBUXDUUBUMUWRUWTUXDUUBUMUUBUMUNUVOUVAEUUB
        UWRUWTUXDUVBUVCWEWMYGWFWGWHUWGWFWGAUHUICDEFHUUBIUGMYMJOTUVCSRUAACEFGNJK
        BOUEUDTQUFUBXFXIUWKYBYH $.
    $}

    $( The ring of power series is a ring.  (Contributed by Mario Carneiro,
       29-Dec-2014.) $)
    psrrng $p |- ( ph -> S e. Ring ) $=
      ( vx vy vz vr vf cfv cv wcel eqidd w3a eqid adantr cplusg cmulr ccnv cima
      cbs cn cfn cn0 cmap co crab cc0 csn cxp wceq cur c0g cif cmpt cgrp rnggrp
      crg syl psrgrp 3ad2ant1 simp2 simp3 psrmulcl simpr1 simpr2 simpr3 psrass1
      wa psrdi psrdir psr1cl simpr psrlidm psrridm isrngd ) AIJKCUENZCUANZCCUBN
      ZLMOUCUFUDUGPMUHDUIUJUKZLODULUMUNUOBUPNZBUQNZURUSZAWAQAWBQAWCQABCDEFGABVB
      PZBUTPHBVAVCVDAIOZWAPZJOZWAPZRWABCWCDWIWKFWASZWCSZAWJWHWLHVEAWJWLVFAWJWLV
      GVHAWJWLKOZWAPZRZVMZWAWDBCWCMDEWIWKWOFADEPZWQGTZAWHWQHTZWDSZWNWMAWJWLWPVI
      ZAWJWLWPVJZAWJWLWPVKZVLWRWAWDWBBCWCMDEWIWKWOFWTXAXBWNWMXCXDXEWBSZVNWRWAWD
      WBBCWCMDEWIWKWOFWTXAXBWNWMXCXDXEXFVOALWAWDBCWGWEMDEWFFGHXBWFSZWESZWGSZWMV
      PAWJVMZLWAWDBCWCWGWEMDEWIWFFAWSWJGTZAWHWJHTZXBXGXHXIWMWNAWJVQZVRXJLWAWDBC
      WCWGWEMDEWIWFFXKXLXBXGXHXIWMWNXMVSVT $.

    psr1.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    psr1.z $e |- .0. = ( 0g ` R ) $.
    psr1.o $e |- .1. = ( 1r ` R ) $.
    psr1.u $e |- U = ( 1r ` S ) $.
    $( The identity element of the ring of power series.  (Contributed by Mario
       Carneiro, 8-Jan-2015.) $)
    psr1 $p |- ( ph ->
      U = ( x e. D |-> if ( x = ( I X. { 0 } ) , .1. , .0. ) ) ) $=
      ( vy wcel cv cc0 csn cxp wceq cif cmpt cbs cmulr co wa wral psr1cl adantr
      cfv eqid crg psrlidm psrridm jca ralrimiva wb psrrng isrngid syl mpbi2and
      simpr ) ABCBUAIUBUCUDUEGKUFUGZEUHUOZTZVHSUAZEUIUOZUJVKUEZVKVHVLUJVKUEZUKZ
      SVIULZFVHUEZABVICDEVHGHIJKLMNOPQVHUPZVIUPZUMAVOSVIAVKVITZUKZVMVNWABVICDEV
      LVHGHIJVKKLAIJTVTMUNZADUQTVTNUNZOPQVRVSVLUPZAVTVGZURWABVICDEVLVHGHIJVKKLW
      BWCOPQVRVSWDWEUSUTVAAEUQTVJVPUKVQVBADEIJLMNVCSVIEVLFVHVSWDRVDVEVF $.

  $}

  ${
    $d f I $.  $d x y z ph $.  $d f x y z R $.  $d x y z S $.
    psrcnrg.s $e |- S = ( I mPwSer R ) $.
    psrcnrg.i $e |- ( ph -> I e. V ) $.
    psrcnrg.r $e |- ( ph -> R e. CRing ) $.
    $( The ring of power series is commutative ring.  (Contributed by Mario
       Carneiro, 10-Jan-2015.) $)
    psrcrng $p |- ( ph -> S e. CRing ) $=
      ( vx vy vf crg wcel cfv ccrg syl cbs eqid cv 3ad2ant1 cmgp crngrng psrrng
      ccmn wceq mgpbas a1i cplusg mgpplusg cmnd rngmgp w3a ccnv cn cima cfn cn0
      cmulr cmap co crab simp2 simp3 psrcom iscmnd iscrng sylanbrc ) ACLMZCUANZ
      UDMCOMABCDEFGABOMZBLMZHBUBPZUCZAIJCQNZCURNZVIVNVIQNUEAVNCVIVIRZVNRZUFUGVO
      VIUHNUEACVOVIVPVORZUIUGAVHVIUJMVMCVIVPUKPAISZVNMZJSZVNMZULVNKSUMUNUOUPMKU
      QDUSUTVAZBCVOKDEVSWAFAVTDEMWBGTAVTVKWBVLTWCRVRVQAVTWBVBAVTWBVCAVTVJWBHTVD
      VECVIVPVFVG $.

    $( The ring of power series is an associative algebra.  (Contributed by
       Mario Carneiro, 29-Dec-2014.) $)
    psrassa $p |- ( ph -> S e. AssAlg ) $=
      ( vy vz vx vf cbs cfv eqidd wcel cv co adantr eqid cvsca cmulr psrsca crg
      ccrg crngrng syl psrlmod psrrng w3a wa wceq ccnv cima cfn cn0 cmap simpr2
      cn crab simpr3 simpr1 psrass23 simpld simprd isassad ) AIJBMNZCUANZCUBNZB
      CMNZCKAVJOABCDEUEFGHUCAVGOAVHOAVIOABCDEFGABUEPZBUDPZHBUFUGZUHABCDEFGVMUIH
      AKQZVGPZIQZVJPZJQZVJPZUJZUKZVNVPVHRVRVIRVNVPVRVIRVHRZULZVPVNVRVHRVIRWBULZ
      WAVNVJLQUMUSUNUOPLUPDUQRUTZBCVHVILDVGEVPVRFADEPVTGSAVLVTVMSWETVITVJTAVOVQ
      VSURAVOVQVSVAAVKVTHSVGTVHTAVOVQVSVBVCZVDWAWCWDWFVEVF $.
  $}

  ${
    $d k x B $.  $d k x H $.  $d k x ph $.  $d k x R $.  $d k x S $.  $d x T $.
    $d f k x y I $.  $d y V $.  $d k x X $.  $d k x Y $.
    resspsr.s $e |- S = ( I mPwSer R ) $.
    resspsr.h $e |- H = ( R |`s T ) $.
    resspsr.u $e |- U = ( I mPwSer H ) $.
    resspsr.b $e |- B = ( Base ` U ) $.
    resspsr.p $e |- P = ( S |`s B ) $.
    resspsr.2 $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    $( A restricted power series algebra has the same base set.  (Contributed
       by Mario Carneiro, 3-Jul-2015.) $)
    resspsrbas $p |- ( ph -> B = ( Base ` P ) ) $=
      ( vf cbs cfv cvv c0 wss wceq wcel wa cv ccnv cn cima cfn cn0 cmap co crab
      fvex csubrg subrgbas syl eqid subrgss eqsstr3d adantr mapss sylancr simpr
      psrbas 3sstr4d wn cmps reldmpsr ovprc1 syl5eq adantl fveq2d base0 3eqtr4g
      0ss syl6eqss pm2.61dan ressbas2 ) ABEQRZUAZBCQRUBAISUCZWAAWBUDZHQRZPUEUFU
      GUHUIUCPUJIUKULUMZUKULZDQRZWEUKULZBVTWCWGSUCWDWGUAZWFWHUADQUNAWIWBAWDFWGA
      FDUORUCZFWDUBOFDHKUPUQAWJFWGUAOFWGDWGURZUSUQUTVAWDWGWESVBVCWCBWEHGPIWDSLW
      DURWEURZMAWBVDZVEWCVTWEDEPIWGSJWKWLVTURZWMVEVFAWBVGZUDZBTVTWPGQRTQRBTWPGT
      QWOGTUBAWOGIHVHULTLIHVHVIVJVKVLVMMVNVOVTVPVQVRBVTCENWNVSUQ $.

    $( A restricted power series algebra has the same addition operation.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    resspsradd $p |- ( ( ph /\ ( X e. B /\ Y e. B ) ) ->
        ( X ( +g ` U ) Y ) = ( X ( +g ` P ) Y ) ) $=
      ( wcel cfv cvv vf wa cplusg co cof eqid simprl simprr psradd cv ccnv cima
      cbs cn cfn cn0 cmap crab wss fvex csubrg wceq subrgbas syl eqsstr3d mapss
      subrgss sylancr adantr cmps reldmpsr elbasov simpld psrbas 3sstr4d sseldd
      ad2antrl ressplusg ofeq oveqd eqtrd eqeltri mp1i 3eqtr2d ) AJBRZKBRZUBZUB
      ZJKGUCSZUDJKHUCSZUEZUDZJKEUCSZUDZJKCUCSZUDWHBWJWIHGIJKNOWJUFWIUFAWEWFUGZA
      WEWFUHZUIWHWNJKDUCSZUEZUDWLWHEUMSZWRWMDEIJKLWTUFZWRUFZWMUFZWHBWTJWHHUMSZU
      AUJUKUNULUORUAUPIUQUDURZUQUDZDUMSZXEUQUDZBWTAXFXHUSZWGAXGTRXDXGUSXIDUMUTA
      XDFXGAFDVASZRZFXDVBQFDHMVCVDAXKFXGUSQFXGDXGUFZVGVDVEXDXGXETVFVHVIWHBXEHGU
      AIXDTNXDUFXEUFZOWHITRZHTRZWEXNXOUBAWFJBGVJIHVKNOVLVQVMZVNWHWTXEDEUAIXGTLX
      LXMXAXPVNVOZWPVPWHBWTKXQWQVPUIWHWSWKJKWHWRWJVBZWSWKVBAXRWGAXKXRQFWRDHXJMX
      BVRVDVIWRWJVSVDVTWAWHWMWOJKBTRWMWOVBWHBGUMSTOGUMUTWBBWMECTPXCVRWCVTWD $.

    $( A restricted power series algebra has the same multiplication
       operation.  (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    resspsrmul $p |- ( ( ph /\ ( X e. B /\ Y e. B ) ) ->
        ( X ( .r ` U ) Y ) = ( X ( .r ` P ) Y ) ) $=
      ( wcel cfv co vk vf vx vy wa cmulr cv ccnv cn cima cfn cn0 cmap crab cofr
      cle wbr cmin cof cmpt cgsu cvv cmps reldmpsr elbasov ad2antrl simpld eqid
      psrbaglefi sylan csubmnd csubrg subrgsubg syl subgsubm ad2antrr ad3antrrr
      csubg cbs wf simprl psrelbas adantr elrabi ffvelrn wceq subrgbas eleqtrrd
      syl2an simprr ssrab2 simpr psrbagconcl syl3anc ffvelrnd subrgmcl gsumsubm
      simplr sseldi fmptd ressmulr oveqd mpteq2dva oveq2d fvex subrgss eqsstr3d
      eqtrd wss mapss sylancr psrbas 3sstr4d sseldd psrmulfval 3eqtr4rd eqeltri
      mp1i ) AJBRZKBRZUEZUEZJKGUFSZTZJKEUFSZTZJKCUFSZTYBUAUBUGUHUIUJUKRUBULIUMT
      UNZDUCUDUGUAUGZUPUOUQZUDYHUNZUCUGZJSZYIYLURUSTZKSZDUFSZTZUTZVATZUTUAYHHUC
      YKYMYOHUFSZTZUTZVATZUTYFYDYBUAYHYSUUCYBYIYHRZUEZYSHYRVATUUCUUEYKFYRDHUKYB
      IVBRZUUDYKUKRYBUUFHVBRZXSUUFUUGUEAXTJBGVCIHVDNOVEVFVGZUDYHUBYIIVBYHVHZVIV
      JAFDVKSRZYAUUDAFDVRSRZUUJAFDVLSZRZUUKQFDVMVNFDVOVNVPUUEUCYKYQFYRUUEYLYKRZ
      UEZUUMYMFRYOFRYQFRAUUMYAUUDUUNQVQZUUOYMHVSSZFUUEYHUUQJVTZYLYHRYMUUQRUUNYB
      UURUUDYBBYHHGUBIUUQJNUUQVHZUUIOAXSXTWAZWBWCYJUDYLYHWDYHUUQYLJWEWIUUOUUMFU
      UQWFZUUPFDHMWGZVNZWHUUOYOUUQFUUOYHUUQYNKYBYHUUQKVTUUDUUNYBBYHHGUBIUUQKNUU
      SUUIOAXSXTWJZWBVPUUOYKYHYNYJUDYHWKUUOUUFUUDUUNYNYKRYBUUFUUDUUNUUHVPYBUUDU
      UNWRUUEUUNWLUDYHYKUBYIIVBYLUUIYKVHWMWNWSWOUVCWHFDYPYMYOYPVHZWPWNYRVHWTMWQ
      UUEYRUUBHVAUUEUCYKYQUUAUUOYPYTYMYOAYPYTWFZYAUUDUUNAUUMUVFQFDHYPUULMUVEXAV
      NVQXBXCXDXHXCYBUCUDEVSSZYHDEYEYPUBUAJKILUVGVHZUVEYEVHZUUIYBBUVGJYBUUQYHUM
      TZDVSSZYHUMTZBUVGAUVJUVLXIZYAAUVKVBRUUQUVKXIUVMDVSXEAUUQFUVKAUUMUVAQUVBVN
      AUUMFUVKXIQFUVKDUVKVHZXFVNXGUUQUVKYHVBXJXKWCYBBYHHGUBIUUQVBNUUSUUIOUUHXLY
      BUVGYHDEUBIUVKVBLUVNUUIUVHUUHXLXMZUUTXNYBBUVGKUVOUVDXNXOYBUCUDBYHHGYCYTUB
      UAJKINOYTVHYCVHUUIUUTUVDXOXPYBYEYGJKBVBRYEYGWFYBBGVSSVBOGVSXEXQBECYEVBPUV
      IXAXRXBXH $.

    $( A restricted power series algebra has the same scalar multiplication
       operation.  (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    resspsrvsca $p |- ( ( ph /\ ( X e. T /\ Y e. B ) ) ->
        ( X ( .s ` U ) Y ) = ( X ( .s ` P ) Y ) ) $=
      ( cfv co eqid vf wcel wa cvsca cv ccnv cn cima cfn cn0 cmap csn cxp cmulr
      crab cof cbs simprl csubrg adantr subrgbas syl eleqtrd simprr psrvsca wss
      wceq subrgss resspsrbas ressbasss syl6eqss ressmulr ofeq 3syl oveqd eqtrd
      sseldd cvv fvex eqeltri ressvsca mp1i 3eqtr2d ) AJFUBZKBUBZUCZUCZJKGUDRZS
      UAUEUFUGUHUIUBUAUJIUKSUOZJULUMZKHUNRZUPZSZJKEUDRZSZJKCUDRZSWGBWIHGWHWKUAK
      IHUQRZJNWHTWQTOWKTWITZWGJFWQAWDWEURZWGFDUSRZUBZFWQVGAXAWFQUTZFDHMVAVBVCAW
      DWEVDZVEWGWOWJKDUNRZUPZSWMWGEUQRZWIDEWNXDUAKIDUQRZJLWNTZXGTZXFTZXDTZWRWGF
      XGJWGXAFXGVFXBFXGDXIVHVBWSVQWGBXFKABXFVFWFABCUQRXFABCDEFGHILMNOPQVIBXFCEP
      XJVJVKUTXCVQVEWGXEWLWJKWGXAXDWKVGXEWLVGXBFDHXDWTMXKVLXDWKVMVNVOVPWGWNWPJK
      BVRUBWNWPVGWGBGUQRVROGUQVSVTBWNECVRPXHWAWBVOWC $.
  $}

  ${
    $d x y B $.  $d x H $.  $d x y S $.  $d x y T $.  $d x y U $.  $d x y V $.
    $d f x y I $.  $d f x y R $.
    subrgpsr.s $e |- S = ( I mPwSer R ) $.
    subrgpsr.h $e |- H = ( R |`s T ) $.
    subrgpsr.u $e |- U = ( I mPwSer H ) $.
    subrgpsr.b $e |- B = ( Base ` U ) $.
    $( A subring of the base ring induces a subring of power series.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    subrgpsr $p |- ( ( I e. V /\ T e. ( SubRing ` R ) ) ->
        B e. ( SubRing ` S ) ) $=
      ( vx vf wcel cfv crg cbs adantl eqid vy csubrg wa cress co simpl subrgrcl
      wss cur subrgrng wceq a1i simpr resspsrbas resspsradd resspsrmul rngpropd
      psrrng cv mpbid jca ressbasss syl6eqss ccnv cn cima cfn cn0 cmap crab cc0
      wf csn cxp c0g cif cmpt subrg1cl csubg subrgsubg subg0cl syl ifcl syl2anc
      subrgbas eleqtrd adantr fmptd psr1 feq1d mpbird rabex elmap sylibr psrbas
      fvex ovex eleqtrrd issubrg sylanbrc ) GHOZDBUBPOZUCZCQOZCAUDUEZQOZUCACRPZ
      UHZCUIPZAOZUCACUBPOXCXDXFXCBCGHIXAXBUFZXBBQOXADBUGSZURXCEQOXFXCFEGHKXKXBF
      QOXADBFJUJSURXCMUAAEXEAERPUKXCLULXCAXEBCDEFGIJKLXETZXAXBUMZUNZXCAXEBCDEFG
      MUSZUAUSZIJKLXMXNUOXCAXEBCDEFGXPXQIJKLXMXNUPUQUTVAXCXHXJXCAXERPXGXOAXGXEC
      XMXGTZVBVCXCXIFRPZNUSVDVEVFVGOZNVHGVIUEZVJZVIUEZAXCYBXSXIVLZXIYCOXCYDYBXS
      MYBXPGVKVMVNUKZBUIPZBVOPZVPZVQZVLXCMYBYHXSYIXCYHXSOXPYBOXCYHDXSXBYHDOZXAX
      BYFDOYGDOZYJDBYFYFTZVRXBDBVSPOYKDBVTDBYGYGTZWAWBYEYFYGDWCWDSXBDXSUKXADBFJ
      WESWFWGYITWHXCYBXSXIYIXCMYBBCXIYFNGHYGIXKXLYBTZYMYLXITZWIWJWKXSYBXIFRWPXT
      NYAVHGVIWQWLWMWNXCAYBFENGXSHKXSTYNLXKWOWRVAAXGCXIXRYOWSWT $.
  $}

  ${
    $d h y I $.  $d y V $.  $d h y X $.
    mvridlem.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    $( A bag containing one element is a finite bag.  (Contributed by Mario
       Carneiro, 7-Jan-2015.) $)
    mvridlem $p |- ( I e. V -> ( y e. I |-> if ( y = X , 1 , 0 ) ) e. D ) $=
      ( wcel cv wceq c1 cc0 cif cmpt cn0 cima cfn csn cdif syl ccnv 1nn0 keepel
      wf cn wa 0nn0 a1i eqid fmptd cvv nn0supp wss snfi eldifsni neneqd iffalse
      wn adantl suppss2 ssfi sylancr eqeltrrd psrbag mpbir2and ) DEHZADAIZFJZKL
      MZNZBHDOVJUDZVJUAZUEPZQHVFADVIOVJVIOHVFVGDHUFVHKLOUBUGUCUHVJUIUJZVFVLUKLR
      SPZVMQVFVKVOVMJVNVJDULTVFFRZQHVOVPUMVOQHFUNVFDVIAVPLVGDVPSHZVILJZVFVQVHUR
      VRVQVGFVGDFUOUPVHKLUQTUSUTVPVOVAVBVCBCVJDEGVDVE $.
  $}

  ${
    $d f i r x .0. $.  $d f i r x .1. $.  $d f i r x D $.  $d f F $.  $d y W $.
    $d f h i r x y I $.  $d f i r x R $.  $d f h x y X $.
    mvrfval.v $e |- V = ( I mVar R ) $.
    mvrfval.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    mvrfval.z $e |- .0. = ( 0g ` R ) $.
    mvrfval.o $e |- .1. = ( 1r ` R ) $.
    mvrfval.i $e |- ( ph -> I e. W ) $.
    mvrfval.r $e |- ( ph -> R e. Y ) $.
    $( Value of the generating elements of the power series structure.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    mvrfval $p |- ( ph -> V = ( x e. I |-> ( f e. D |->
        if ( f = ( y e. I |-> if ( y = x , 1 , 0 ) ) , .1. , .0. ) ) ) ) $=
      ( wceq vi vr cmvr co cv c1 cc0 cif cmpt cvv wcel elex mptexg ccnv cn cima
      syl cfn cn0 cmap crab cur cfv wa simpl oveq2d rabeq syl6eqr mpteq1 adantr
      eqeq2d simpr fveq2d ifbieq12d mpteq12dv df-mvr ovmpt2ga syl3anc syl5eq
      c0g ) AJIEUCUDZBIGDGUEZCICUEBUETUFUGUHZUIZTZFMUHZUIZUIZNAIUJUKZEUJUKZWHUJ
      UKZWAWHTAIKUKZWIRIKULUQAELUKWJSELULUQAWLWKRBIWGKUMUQUAUBIEUJUJBUAUEZGHUEU
      NUOUPURUKZHUSWMUTUDZVAZWBCWMWCUIZTZUBUEZVBVCZWSVTVCZUHZUIZUIWHUCUJWMITZWS
      ETZVDZBWMXCIWGXDXEVEZXFGWPXBDWFXFWPWNHUSIUTUDZVAZDXFWOXHTWPXITXFWMIUSUTXG
      VFWNHWOXHVGUQOVHXFWRWEWTXAFMXFWQWDWBXDWQWDTXECWMIWCVIVJVKXFWTEVBVCFXFWSEV
      BXDXEVLZVMQVHXFXAEVTVCMXFWSEVTXJVMPVHVNVOVOBCGHUAUBVPVQVRVS $.

    mvrval.x $e |- ( ph -> X e. I ) $.
    $( Value of the generating elements of the power series structure.
       (Contributed by Mario Carneiro, 7-Jan-2015.) $)
    mvrval $p |- ( ph -> ( V ` X ) = ( f e. D |->
        if ( f = ( y e. I |-> if ( y = X , 1 , 0 ) ) , .1. , .0. ) ) ) $=
      ( vx cfv cv wceq c1 cc0 cif cmpt mvrfval fveq1d wcel eqeq2 ifbid mpteq2dv
      eqeq2d eqid ccnv cn cima cfn cn0 cmap crab ovex rabex eqeltri mptex fvmpt
      co cvv syl eqtrd ) AKIUBKUAHFCFUCZBHBUCZUAUCZUDZUEUFUGZUHZUDZEMUGZUHZUHZU
      BZFCVMBHVNKUDZUEUFUGZUHZUDZEMUGZUHZAKIWBAUABCDEFGHIJLMNOPQRSUIUJAKHUKWCWI
      UDTUAKWAWIHWBVOKUDZFCVTWHWJVSWGEMWJVRWFVMWJBHVQWEWJVPWDUEUFVOKVNULUMUNUOU
      MUNWBUPFCWHCGUCUQURUSUTUKZGVAHVBVIZVCVJOWKGWLVAHVBVDVEVFVGVHVKVL $.

    ${
      mvrval2.f $e |- ( ph -> F e. D ) $.
      $( Value of the generating elements of the power series structure.
         (Contributed by Mario Carneiro, 7-Jan-2015.) $)
      mvrval2 $p |- ( ph -> ( ( V ` X ) ` F ) =
          if ( F = ( y e. I |-> if ( y = X , 1 , 0 ) ) , .1. , .0. ) ) $=
        ( vf cfv cv wceq c1 cc0 cif cmpt mvrval fveq1d wcel eqeq1 ifbid cur cvv
        eqid fvex eqeltri c0g ifex fvmpt syl eqtrd ) AGKIUCZUCGUBCUBUDZBHBUDKUE
        UFUGUHUIZUEZEMUHZUIZUCZGVGUEZEMUHZAGVEVJABCDEUBFHIJKLMNOPQRSTUJUKAGCULV
        KVMUEUAUBGVIVMCVJVFGUEVHVLEMVFGVGUMUNVJUQVLEMEDUOUCUPQDUOURUSMDUTUCUPPD
        UTURUSVAVBVCVD $.
    $}

    $( The ` X i ` -th coefficient of the term ` X i ` is ` 1 ` .  (Contributed
       by Mario Carneiro, 7-Jan-2015.) $)
    mvrid $p |- ( ph -> ( ( V ` X ) ` ( y e. I |-> if ( y = X , 1 , 0 ) ) )
        = .1. ) $=
      ( wceq cv c1 cc0 cif cmpt cfv wcel mvridlem syl mvrval2 eqid iftrue ax-mp
      syl6eq ) ABGBUAJTUBUCUDUEZJHUFUFUOUOTZELUDZEABCDEFUOGHIJKLMNOPQRSAGIUGUOC
      UGQBCFGIJNUHUIUJUPUQETUOUKUPELULUMUN $.
  $}

  ${
    $d f h x y z I $.  $d f x y ph $.  $d f x R $.  $d x y V $.  $d y z W $.
    $d x B $.
    mvrf.s $e |- S = ( I mPwSer R ) $.
    mvrf.v $e |- V = ( I mVar R ) $.
    mvrf.b $e |- B = ( Base ` S ) $.
    mvrf.i $e |- ( ph -> I e. W ) $.
    mvrf.r $e |- ( ph -> R e. Ring ) $.
    $( The power series variable function is a function from the index set to
       elements of the power series structure representing ` X i ` for each
       ` i ` .  (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    mvrf $p |- ( ph -> V : I --> B ) $=
      ( vx vf vh vy wf cv wcel eqid ccnv cn cima cfn cn0 cmap crab wceq cc0 cif
      co c1 cmpt cur cfv c0g wa cbs crg rngidcl syl ifcl syl2anc ad2antrr fmptd
      rng0cl fvex ovex rabex elmap sylibr psrbas adantr eleqtrrd mvrfval mpbird
      feq1d ) AEBFQEBMENORUAUBUCUDSZOUEEUFUKZUGZNRZPEPRMRZUHULUIUJUMUHZCUNUOZCU
      PUOZUJZUMZUMZQAMEWGBWHAWBESZUQZWGCURUOZVTUFUKZBWJVTWKWGQWGWLSWJNVTWFWKWGA
      WFWKSZWIWAVTSAWDWKSZWEWKSZWMACUSSZWNLWKCWDWKTZWDTZUTVAAWPWOLWKCWEWQWETZVF
      VAWCWDWEWKVBVCVDWGTVEWKVTWGCURVGVROVSUEEUFVHVIVJVKABWLUHWIABVTCDOEWKGHWQV
      TTZJKVLVMVNWHTVEAEBFWHAMPVTCWDNOEFGUSWEIWTWSWRKLVOVQVP $.

    ${
      mvrf1.z $e |- .0. = ( 0g ` R ) $.
      mvrf1.o $e |- .1. = ( 1r ` R ) $.
      mvrf1.n $e |- ( ph -> .1. =/= .0. ) $.
      $( The power series variable function is injective if the base ring is
         nonzero.  (Contributed by Mario Carneiro, 29-Dec-2014.) $)
      mvrf1 $p |- ( ph -> V : I -1-1-> B ) $=
        ( vz c1 cc0 vx vy vh wf cv cfv wceq wi wral wf1 mvrf wcel wa wne adantr
        wn w3a cif cmpt simp2r fveq1d ccnv cn cima cfn cn0 cmap co crg 3ad2ant1
        crab simp2ll mvrid simp2lr mvridlem syl mvrval2 3eqtr3d simp3 wb mpteqb
        eqid 1nn0 0nn0 keepel a1i mprg iftrue eqeq1 ifbid eqeq12d rspcv ax-1ne0
        syl5bi necon3abid mpbii iffalse nsyl2 syl6 mtod eqtrd necon1ad mpd expr
        3expia ralrimivva dff13 sylanbrc ) AFBGUDUAUEZGUFZUBUEZGUFZUGZXIXKUGZUH
        ZUBFUIUAFUIFBGUJABCDFGHJKLMNUKAXOUAUBFFAXIFULZXKFULZUMZXMXNAXRXMUMZUMZE
        IUNZXNAYAXSQUOXTXNEIAXSXNUPZEIUGAXSYBUQZERFRUEZXIUGZSTURZUSZRFYDXKUGZST
        URZUSUGZEIURZIYCYGXJUFYGXLUFEYKYCYGXJXLAXRXMYBUTVAYCRUCUEVBVCVDVEULUCVF
        FVGVHVKZCEUCFGHXIVIIKYLWBZOPAXSFHULZYBMVJZAXSCVIULYBNVJZXPXQXMAYBVLZVMY
        CRYLCEUCYGFGHXKVIIKYMOPYOYPXPXQXMAYBVNYCYNYGYLULYORYLUCFHXIYMVOVPVQVRYC
        YJUPYKIUGYCYJXNAXSYBVSYCYJSXNSTURZUGZXNYCXPYJYSUHYQYJYFYIUGZRFUIZXPYSYF
        VFULZYJUUAVTRFRFYFYIVFWAUUBYDFULYESTVFWCWDWEWFWGYTYSRXIFYEYFSYIYRYESTWH
        YEYHXNSTYDXIXKWIWJWKWLWNVPYSYRTUGZXNYSSTUNUUCUPWMYSUUCSTSYRTWIWOWPXNSTW
        QWRWSWTYJEIWQVPXAXEXBXCXDXFUAUBFBGXGXH $.
    $}

    mvrcl2.x $e |- ( ph -> X e. I ) $.
    $( A power series variable is an element of the base set.  (Contributed by
       Mario Carneiro, 29-Dec-2014.) $)
    mvrcl2 $p |- ( ph -> ( V ` X ) e. B ) $=
      ( mvrf ffvelrnd ) AEBHFABCDEFGIJKLMONP $.
  $}

  ${
    $d f B $.  $d f i r s I $.  $d f i r s R $.  $d i r s S $.  $d i r s U $.
    $d f X $.  $d f .0. $.
    $( The multivariate polynomial constructor is a proper binary operator.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    reldmmpl $p |- Rel dom mPoly $=
      ( vi vr vs vf cvv cv cmps co ccnv c0g cfv csn cdif cima cfn wcel cbs crab
      cress csb cmpl df-mpl reldmmpt2 ) ABEECAFBFZGHCFZDFIEUDJKLMNOPDUEQKRSHTUA
      CDABUBUC $.

    mplval.p $e |- P = ( I mPoly R ) $.
    mplval.s $e |- S = ( I mPwSer R ) $.
    mplval.b $e |- B = ( Base ` S ) $.
    mplval.z $e |- .0. = ( 0g ` R ) $.
    ${
      mplval.u $e |- U = { f e. B | ( `' f " ( _V \ { .0. } ) ) e. Fin } $.
      $( Value of the set of multivariate polynomials.  (Contributed by Mario
         Carneiro, 7-Jan-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
      mplval $p |- P = ( S |`s U ) $=
        ( vs co cress cvv wcel cmps syl6eqr vi vr cmpl wa wceq ccnv c0g cfv csn
        cv cdif cima cfn cbs crab csb ovex a1i id oveq12 sylan9eqr fveq2d sneqd
        simplr difeq2d imaeq2d eleq1d rabeqbidv oveq12d csbied ovmpt2a reldmmpl
        df-mpl wn c0 ovprc ress0 reldmpsr syl5eq oveq1d eqtr4d pm2.61i eqtri )
        BGCUCOZDEPOZIGQRCQRUDZWDWEUEUAUBGCQQNUAUJZUBUJZSOZNUJZFUJUFZQWHUGUHZUIZ
        UKZULZUMRZFWJUNUHZUOZPOZUPWEUCWGGUEZWHCUEZUDZNWIWSWEQWIQRXBWGWHSUQURXBW
        JWIUEZUDZWJDWREPXDWJGCSOZDXCXBWJWIXEXCUSWGGWHCSUTVAJTZXDWRWKQHUIZUKZULZ
        UMRZFAUOEXDWPXJFWQAXDWQDUNUHAXDWJDUNXFVBKTXDWOXIUMXDWNXHWKXDWMXGQXDWLHX
        DWLCUGUHHXDWHCUGWTXAXCVDVBLTVCVEVFVGVHMTVIVJNFUAUBVMDEPUQVKWFVNZWDVOEPO
        ZWEXKWDVOXLGCUCVLVPEVQTXKDVOEPXKDXEVOJGCSVRVPVSVTWAWBWC $.
    $}

    mplbas.u $e |- U = ( Base ` P ) $.
    $( Base set of the set of multivariate polynomials.  (Contributed by Mario
       Carneiro, 7-Jan-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    mplbas $p |- U = { f e. B | ( `' f " ( _V \ { .0. } ) ) e. Fin } $=
      ( cbs cfv cv ccnv cvv csn cdif cima cfn wcel crab wceq ssrab2 eqid mplval
      wss ressbas2 ax-mp eqtr4i ) EBNOZFPQRHSTUAUBUCZFAUDZMUOAUIUOUMUEUNFAUFUOA
      BDABCDUOFGHIJKLUOUGUHKUJUKUL $.

    $( Property of being a polynomial.  (Contributed by Mario Carneiro,
       7-Jan-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    mplelbas $p |- ( X e. U <->
      ( X e. B /\ ( `' X " ( _V \ { .0. } ) ) e. Fin ) ) $=
      ( vf cv ccnv cvv cima cfn wcel csn cdif wceq imaeq1d eleq1d mplbas elrab2
      cnveq ) NOZPZQHUAUBZRZSTGPZUKRZSTNGAEUIGUCZULUNSUOUJUMUKUIGUHUDUEABCDENFH
      IJKLMUFUG $.
  $}

  ${
    $d f B $.  $d f I $.  $d f R $.  $d f S $.
    mplval2.p $e |- P = ( I mPoly R ) $.
    mplval2.s $e |- S = ( I mPwSer R ) $.
    mplval2.u $e |- U = ( Base ` P ) $.
    $( Self-referential expression for the set of multivariate polynomials.
       (Contributed by Mario Carneiro, 7-Jan-2015.)  (Revised by Mario
       Carneiro, 2-Oct-2015.) $)
    mplval2 $p |- P = ( S |`s U ) $=
      ( vf cbs cfv c0g eqid mplbas mplval ) CJKZABCDIEBLKZFGPMZQMZPABCDIEQFGRSH
      NO $.

    mplbasss.b $e |- B = ( Base ` S ) $.
    $( The set of polynomials is a subset of the set of power series.
       (Contributed by Mario Carneiro, 7-Jan-2015.)  (Revised by Mario
       Carneiro, 2-Oct-2015.) $)
    mplbasss $p |- U C_ B $=
      ( vf cv ccnv cvv c0g cfv csn cdif cima cfn wcel crab eqid mplbas eqsstri
      ssrab2 ) EKLMNCOPZQRSTUAZKAUBAABCDEKFUGGHJUGUCIUDUHKAUFUE $.
  $}

  ${
    $d f I $.
    mplelf.p $e |- P = ( I mPoly R ) $.
    mplelf.k $e |- K = ( Base ` R ) $.
    mplelf.b $e |- B = ( Base ` P ) $.
    mplelf.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplelf.x $e |- ( ph -> X e. B ) $.
    $( A polynomial is defined as a function on the coefficients.  (Contributed
       by Mario Carneiro, 7-Jan-2015.)  (Revised by Mario Carneiro,
       2-Oct-2015.) $)
    mplelf $p |- ( ph -> X : D --> K ) $=
      ( cmps co cbs cfv eqid mplbasss sseldi psrelbas ) AGEOPZQRZCEUCFGHIUCSZKM
      UDSZABUDIUDDEUCBGJUELUFTNUAUB $.
  $}

  ${
    $d f g k u x y .0. $.  $d f g x y A $.  $d f g B $.  $d g u D $.  $d f I $.
    $d k u v w x y ph $.  $d k v w R $.  $d f g k u v w y S $.  $d k u v w U $.
    mplsubglem.s $e |- S = ( I mPwSer R ) $.
    mplsubglem.b $e |- B = ( Base ` S ) $.
    mplsubglem.z $e |- .0. = ( 0g ` R ) $.
    mplsubglem.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplsubglem.i $e |- ( ph -> I e. W ) $.
    mplsubglem.0 $e |- ( ph -> (/) e. A ) $.
    mplsubglem.a $e |- ( ( ph /\ ( x e. A /\ y e. A ) ) -> ( x u. y ) e. A ) $.
    mplsubglem.y $e |- ( ( ph /\ ( x e. A /\ y C_ x ) ) -> y e. A ) $.
    mplsubglem.u $e |- ( ph ->
      U = { g e. B | ( `' g " ( _V \ { .0. } ) ) e. A } ) $.
    ${
      mplsubglem.r $e |- ( ph -> R e. Grp ) $.
      $( If ` A ` is an ideal of sets (a nonempty collection closed under
         subset and binary union) of the set ` D ` of finite bags (the primary
         applications being ` A = Fin ` and ` A = ~P B ` for some ` B ` ), then
         the set of all power series whose coefficient functions are supported
         on an element of ` A ` is a subgroup of the set of all power series.
         (Contributed by Mario Carneiro, 12-Jan-2015.) $)
      mplsubglem $p |- ( ph -> U e. ( SubGrp ` S ) ) $=
        ( vu vv vk csubg cfv wcel wss c0 wne cv cplusg co wral cminusg ccnv cvv
        wa csn cdif cima crab ssrab2 syl6eqss cxp psr0cl wceq cgrp eqid grpidcl
        cbs wf fconst6g 3syl eldifi c0g fvex eqeltri fvconst2 syl adantl suppss
        ss0 eqeltrd eleq2d cnveq imaeq1d eleq1d elrab syl6bb mpbir2and ad2antrr
        ne0i weq biimpa simpld adantr psraddcl wi simprd ralrimivva uneq1 uneq2
        cun wal rspc2va syl21anc psrelbas cof psradd wfn ffn cn0 cmap a1i eqidd
        fveq1d sylan2 sscon ax-mp sseli ssid eqtrd 3eqtrd ssexd ralrimiva sseq2
        suppssr imbi1d albidv rspcv sylc sseq1 eleq1 imbi12d spcgv syl3c cn cfn
        ovex rabex inidm ofval ssun1 adantlr ssun2 oveq12d grplid mpdan alrimiv
        expr psrgrp grpinvcl sylan syldan ccom psrneg fvco3 syl2an grpinvid jca
        fveq2d w3a wb issubg2 mpbir3and ) AIHUHUIUJZIEUKZIULUMZUEUNZUFUNZHUOUIZ
        UPZIUJZUFIUQZUVMHURUIZUIZIUJZVAZUEIUQZAIKUNZUSZUTNVBZVCZVDZDUJZKEVEZEUC
        UWIKEVFVGAFUWFVHZIUJZUVLAUWLUWKEUJZUWKUSZUWGVDZDUJZAEFGHJLMNOSUDRQPVIAU
        WOULDAUWOULUKUWOULVJAFGVNUIZUEUWKULNAGVKUJZNUWQUJZFUWQUWKVOUDUWQGNUWQVL
        ZQVMZFNUWQVPVQUVMFULVCUJZUVMUWKUINVJZAUXBUVMFUJUXCUVMFULVRFNUVMNGVSUIUT
        QGVSVTWAWBWCWDWEUWOWFWCTWGAUWLUWKUWJUJUWMUWPVAAIUWJUWKUCWHUWIUWPKUWKEUW
        DUWKVJZUWHUWODUXDUWEUWNUWGUWDUWKWIWJWKWLWMWNIUWKWPWCAUWBUEIAUVMIUJZVAZU
        VRUWAUXFUVQUFIUXFUVNIUJZVAZUVQUVPEUJZUVPUSZUWGVDZDUJZUXHEUVOGHLUVMUVNOP
        UVOVLZAUWRUXEUXGUDWOZUXFUVMEUJZUXGUXFUXOUVMUSZUWGVDZDUJZAUXEUXOUXRVAZAU
        XEUVMUWJUJUXSAIUWJUVMUCWHUWIUXRKUVMEKUEWQZUWHUXQDUXTUWEUXPUWGUWDUVMWIWJ
        WKWLWMWRZWSZWTZUXHUVNEUJZUVNUSZUWGVDZDUJZUXFUXGUYDUYGVAZUXFUXGUVNUWJUJU
        YHUXFIUWJUVNAIUWJVJZUXEUCWTZWHUWIUYGKUVNEKUFWQZUWHUYFDUYKUWEUYEUWGUWDUV
        NWIWJWKWLWMWRZWSZXAZUXHUXKUTUJCUNZUXQUYFXGZUKZUYODUJZXBZCXHZUXKUYPUKZUX
        LUXHUXKUYPDUXHUXRUYGBUNZUYOXGZDUJZCDUQBDUQZUYPDUJZUXFUXRUXGUXFUXOUXRUYA
        XCZWTUXHUYDUYGUYLXCAVUEUXEUXGAVUDBCDDUAXDWOVUDVUFUXQUYOXGZDUJBCUXQUYFDD
        VUBUXQVJZVUCVUHDVUBUXQUYOXEWKUYOUYFVJVUHUYPDUYOUYFUXQXFWKXIXJZUXHFUWQUG
        UVPUYPNUXHEFGHJLUWQUVPOUWTRPUYNXKUXHUGUNZFUYPVCZUJZVAZVUKUVPUIZVUKUVMUV
        NGUOUIZXLUPZUIZVUKUVMUIZVUKUVNUIZVUPUPZNUXHVUOVURVJVUMUXHVUKUVPVUQUXHEV
        UPUVOGHLUVMUVNOPVUPVLZUXMUYCUYMXMXTWTVUMUXHVUKFUJZVURVVAVJVUKFUYPVRUXHF
        FVUSVUTVUPFUVMUVNUTUTVUKUXHFUWQUVMVOZUVMFXNUXFVVDUXGUXFEFGHJLUWQUVMOUWT
        RPUYBXKZWTFUWQUVMXOWCUXHFUWQUVNVOUVNFXNUXHEFGHJLUWQUVNOUWTRPUYMXKZFUWQU
        VNXOWCFUTUJUXHFJUNUSUUAVDUUBUJZJXPLXQUPZVEUTRVVGJVVHXPLXQUUCUUDWAXRZVVI
        FUUEUXHVVCVAZVUSXSVVJVUTXSUUFYAVUNVVANNVUPUPZNVUNVUSNVUTNVUPVUMUXHVUKFU
        XQVCZUJZVUSNVJZVULVVLVUKUXQUYPUKVULVVLUKUXQUYFUUGUXQUYPFYBYCYDUXFVVMVVN
        UXGUXFFUWQUVMUXQVUKNVVEUXQUXQUKUXFUXQYEXRYKZUUHYAVUMUXHVUKFUYFVCZUJVUTN
        VJVULVVPVUKUYFUYPUKVULVVPUKUYFUXQUUIUYFUYPFYBYCYDUXHFUWQUVNUYFVUKNVVFUY
        FUYFUKUXHUYFYEXRYKYAUUJUXHVVKNVJZVUMUXHUWRVVQUXNUWRUWSVVQUXAUWQVUPGNNUW
        TVVBQUUKUULWCWTYFYGWEZYHUXHVUFUYOVUBUKZUYRXBZCXHZBDUQZUYTVUJAVWBUXEUXGA
        VWABDAVUBDUJZVAVVTCAVWCVVSUYRUBUUNUUMYIZWOVWAUYTBUYPDVUBUYPVJZVVTUYSCVW
        EVVSUYQUYRVUBUYPUYOYJYLYMYNYOVVRUYSVUAUXLXBCUXKUTUYOUXKVJUYQVUAUYRUXLUY
        OUXKUYPYPUYOUXKDYQYRYSYTUXHUVQUVPUWJUJUXIUXLVAUXHIUWJUVPAUYIUXEUXGUCWOW
        HUWIUXLKUVPEUWDUVPVJZUWHUXKDVWFUWEUXJUWGUWDUVPWIWJWKWLWMWNYIUXFUWAUVTEU
        JZUVTUSZUWGVDZDUJZAUXEUXOVWGUYBAHVKUJZUXOVWGAGHLMOSUDUUOZEHUVSUVMPUVSVL
        ZUUPUUQUURZUXFVWIUTUJUYOUXQUKZUYRXBZCXHZVWIUXQUKZVWJUXFVWIUXQDVUGUXFFUW
        QUGUVTUXQNUXFEFGHJLUWQUVTOUWTRPVWNXKUXFVVMVAZVUKUVTUIVUKGURUIZUVMUUSZUI
        ZVUSVWTUIZNVWSVUKUVTVXAUXFUVTVXAVJVVMUXFEFGHJLUVSVWTMUVMOALMUJUXESWTAUW
        RUXEUDWTZRVWTVLZPVWMUYBUUTWTXTUXFVVDVVCVXBVXCVJVVMVVEVUKFUXQVRFUWQVUKVW
        TUVMUVAUVBVWSVXCNVWTUIZNVWSVUSNVWTVVOUVEUXFVXFNVJZVVMUXFUWRVXGVXDGVWTNQ
        VXEUVCWCWTYFYGWEZYHUXFUXRVWBVWQVUGAVWBUXEVWDWTVWAVWQBUXQDVUIVVTVWPCVUIV
        VSVWOUYRVUBUXQUYOYJYLYMYNYOVXHVWPVWRVWJXBCVWIUTUYOVWIVJVWOVWRUYRVWJUYOV
        WIUXQYPUYOVWIDYQYRYSYTUXFUWAUVTUWJUJVWGVWJVAUXFIUWJUVTUYJWHUWIVWJKUVTEU
        WDUVTVJZUWHVWIDVXIUWEVWHUWGUWDUVTWIWJWKWLWMWNUVDYIAVWKUVJUVKUVLUWCUVFUV
        GVWLUEUFEUVOIHUVSPUXMVWMUVHWCUVI $.
    $}

    mpllsslem.r $e |- ( ph -> R e. Ring ) $.
    $( If ` A ` is an ideal of subsets (a nonempty collection closed under
       subset and binary union) of the set ` D ` of finite bags (the primary
       applications being ` A = Fin ` and ` A = ~P B ` for some ` B ` ), then
       the set of all power series whose coefficient functions are supported on
       an element of ` A ` is a linear subspace of the set of all power
       series.  (Contributed by Mario Carneiro, 12-Jan-2015.) $)
    mpllsslem $p |- ( ph -> U e. ( LSubSp ` S ) ) $=
      ( vu vv vw cbs cfv cplusg clss cvsca crg psrsca eqidd wceq a1i csubg wcel
      vk wss cgrp rnggrp syl mplsubglem subgss c0g c0 eqid subg0cl ne0i 3syl cv
      wne w3a wa co adantr ccnv cvv cdif cima simprl simprr crab eleq2d imaeq1d
      cnveq eleq1d elrab syl6bb mpbid simpld psrvscacl wi simprd psrelbas cmulr
      csn wal eldifi adantl psrvscaval ssid suppssr oveq2d rngrz syl2anc 3eqtrd
      suppss ssexd wral alrimiv ralrimiva sseq2 imbi1d albidv rspcv sseq1 eleq1
      expr imbi12d spcgv syl3c mpbir2and 3adantr3 simpr3 subgcl syl3anc islssd
      sylc ) AUEGUHUIZHUJUIZHUKUIZHULUIZIGEHUFUGAGHLMUMOSUDUNAYLUOEHUHUIUPAPUQA
      YMUOAYOUOAYNUOAIHURUIUSZIEVAABCDEFGHIJKLMNOPQRSTUAUBUCAGUMUSZGVBUSUDGVCVD
      VEZEIHPVFVDAYPHVGUIZIUSIVHVNYRIHYSYSVIVJIYSVKVLAUEVMZYLUSZUFVMZIUSZUGVMZI
      USZVOZVPYPYTUUBYOVQZIUSZUUEUUGUUDYMVQIUSAYPUUFYRVRAUUAUUCUUHUUEAUUAUUCVPZ
      VPZUUHUUGEUSZUUGVSZVTNWSWAZWBZDUSZUUJEGHYOUUBLYLYTOYOVIZYLVIZPAYQUUIUDVRZ
      AUUAUUCWCZUUJUUBEUSZUUBVSZUUMWBZDUSZUUJUUCUUTUVCVPZAUUAUUCWDUUJUUCUUBKVMZ
      VSZUUMWBZDUSZKEWEZUSUVDUUJIUVIUUBAIUVIUPUUIUCVRZWFUVHUVCKUUBEUVEUUBUPZUVG
      UVBDUVKUVFUVAUUMUVEUUBWHWGWIWJWKWLZWMZWNZUUJUUNVTUSCVMZUVBVAZUVODUSZWOZCW
      TZUUNUVBVAZUUOUUJUUNUVBDUUJUUTUVCUVLWPZUUJFYLUTUUGUVBNUUJEFGHJLYLUUGOUUQR
      PUVNWQUUJUTVMZFUVBWAUSZVPZUWBUUGUIYTUWBUUBUIZGWRUIZVQYTNUWFVQZNUWDEFGHYOU
      WFJUUBLYLYTUWBOUUPUUQPUWFVIZRUUJUUAUWCUUSVRUUJUUTUWCUVMVRUWCUWBFUSUUJUWBF
      UVBXAXBXCUWDUWENYTUWFUUJFYLUUBUVBUWBNUUJEFGHJLYLUUBOUUQRPUVMWQUVBUVBVAUUJ
      UVBXDUQXEXFUUJUWGNUPZUWCUUJYQUUAUWIUURUUSYLGUWFYTNUUQUWHQXGXHVRXIXJZXKUUJ
      UVCUVOBVMZVAZUVQWOZCWTZBDXLZUVSUWAAUWOUUIAUWNBDAUWKDUSZVPUWMCAUWPUWLUVQUB
      YAXMXNVRUWNUVSBUVBDUWKUVBUPZUWMUVRCUWQUWLUVPUVQUWKUVBUVOXOXPXQXRYKUWJUVRU
      VTUUOWOCUUNVTUVOUUNUPUVPUVTUVQUUOUVOUUNUVBXSUVOUUNDXTYBYCYDUUJUUHUUGUVIUS
      UUKUUOVPUUJIUVIUUGUVJWFUVHUUOKUUGEUVEUUGUPZUVGUUNDUWRUVFUULUUMUVEUUGWHWGW
      IWJWKYEYFAUUAUUCUUEYGYMIHUUGUUDYMVIYHYIYJ $.
  $}

  ${
    $d f g k n x y I $.  $d k n x y ph $.  $d f g k x y R $.  $d f g k x y S $.
    $d k n x A $.  $d n x y D $.  $d x y U $.  $d f g k x X $.  $d f g k x Y $.
    $d x .x. $.  $d y W $.  $d f g k .0. $.
    mplsubg.s $e |- S = ( I mPwSer R ) $.
    mplsubg.p $e |- P = ( I mPoly R ) $.
    mplsubg.u $e |- U = ( Base ` P ) $.
    mplsubg.i $e |- ( ph -> I e. W ) $.
    ${
      mplsubg.r $e |- ( ph -> R e. Grp ) $.
      $( The set of polynomials is closed under addition, i.e. it is a subgroup
         of the set of power series.  (Contributed by Mario Carneiro,
         8-Jan-2015.) $)
      mplsubg $p |- ( ph -> U e. ( SubGrp ` S ) ) $=
        ( vx vy vf vg cfn cv wcel eqid cbs cfv ccnv cn cima cn0 cmap co crab c0
        c0g 0fin a1i wa cun unfi adantl wss ssfi cvv csn cdif mplbas mplsubglem
        wceq ) AMNQDUAUBZORUCUDUEQSOUFFUGUHUIZCDEOPFGCUKUBZHVFTZVHTZVGTKUJQSAUL
        UMMRZQSZNRZQSZUNVKVMUOQSAVKVMUPUQVLVMVKURUNVNAVKVMUSUQEPRUCUTVHVAVBUEQS
        PVFUIVEAVFBCDEPFVHIHVIVJJVCUMLVD $.
    $}

    mpllss.r $e |- ( ph -> R e. Ring ) $.
    $( The set of polynomials is closed under scalar multiplication, i.e. it is
       a linear subspace of the set of power series.  (Contributed by Mario
       Carneiro, 7-Jan-2015.) $)
    mpllss $p |- ( ph -> U e. ( LSubSp ` S ) ) $=
      ( vx vy vf vg cfn cv wcel eqid cbs cfv ccnv cn cima cn0 cmap co crab 0fin
      c0g c0 a1i wa cun unfi adantl wss ssfi cvv csn cdif wceq mplbas mpllsslem
      ) AMNQDUAUBZORUCUDUEQSOUFFUGUHUIZCDEOPFGCUKUBZHVFTZVHTZVGTKULQSAUJUMMRZQS
      ZNRZQSZUNVKVMUOQSAVKVMUPUQVLVMVKURUNVNAVKVMUSUQEPRUCUTVHVAVBUEQSPVFUIVCAV
      FBCDEPFVHIHVIVJJVDUMLVE $.

    ${
      mplsubrglem.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
      mplsubrglem.z $e |- .0. = ( 0g ` R ) $.
      mplsubrglem.p $e |- A = ( oF + "
        ( ( `' X " ( _V \ { .0. } ) ) X. ( `' Y " ( _V \ { .0. } ) ) ) ) $.
      mplsubrglem.t $e |- .x. = ( .r ` R ) $.
      mplsubrglem.x $e |- ( ph -> X e. U ) $.
      mplsubrglem.y $e |- ( ph -> Y e. U ) $.
      $( Lemma for ~ mplsubrg .  (Contributed by Mario Carneiro,
         9-Jan-2015.) $)
      mplsubrglem $p |- ( ph -> ( X ( .r ` S ) Y ) e. U ) $=
        ( vg vk vx vy vn cmulr cfv cbs wcel ccnv cvv csn cdif cima cfn mplbasss
        co eqid sseldi psrmulcl wss caddc cof cxp crn df-ima eqtri wfo mplelbas
        cres simprbi syl xpfi syl2anc cv ofmres ovex fnmpt2i dffn4 mpbi sylancl
        wfn fofi syl5eqel psrelbas wa cle cofr wbr crab cmin cmpt adantr eldifi
        cgsu adantl psrmulval wceq crg ad2antrr mplelf ssrab2 simpr psrbagconcl
        wf syl3anc ffvelrnd rnglz oveq1 eqeq1d syl5ibrcom rngrz oveq2 wn wo cn0
        psrbagf ffvelrnda nn0cn pncan3 syl2an mpteq2dva feqmptd offval2 3eqtr4d
        cc a1i simplr wb eldif baib ssid suppssr ex sylbird eqeltrd eldifbd w3a
        ovres fnovrn syl6eleqr mp3an1 eqeltrrd nsyl ianor orim12d mpjaod oveq2d
        sylib mpd cmnd rngmnd psrbaglefi gsumz 3eqtrd suppss ssfi sylanbrc ) AL
        MFUKULZVBZFUMULZUNUVEUOUPNUQURZUSZUTUNZUVEHUNAUVFEFUVDJLMOUVFVCZUVDVCZS
        AHUVFLUVFDEFHJPOQUVJVAZUDVDZAHUVFMUVLUEVDZVEZABUTUNUVHBVFUVIABVGVHZLUOU
        VGUSZMUOUVGUSZVIZVOZVJZUTBUVPUVSUSUWAUBUVPUVSVKVLZAUVSUTUNZUVSUWAUVTVMZ
        UWAUTUNAUVQUTUNZUVRUTUNZUWCALHUNZUWEUDUWGLUVFUNZUWEUVFDEFHJLNPOUVJUAQVN
        VPVQAMHUNZUWFUEUWIMUVFUNZUWFUVFDEFHJMNPOUVJUAQVNVPVQUVQUVRVRVSUVTUVSWGZ
        UWDIUFUVQUVRIVTZUFVTZUVPVBUVTUVQUVRVGIUFWAUWLUWMUVPWBWCZUVSUVTWDWEUVSUW
        AUVTWHWFWIACEUMULZUGUVEBNAUVFCEFIJUWOUVEOUWOVCZTUVJUVOWJAUGVTZCBURZUNZW
        KZUWQUVEULEUHUIVTUWQWLWMWNZUICWOZUHVTZLULZUWQUXCWPVHVBZMULZGVBZWQZWTVBE
        UHUXBNWQZWTVBZNUWTUIUVFCEFUVDGIUHLMJUWQOUVJUCUVKTAUWHUWSUVMWRAUWJUWSUVN
        WRUWSUWQCUNZAUWQCBWSZXAZXBUWTUXHUXIEWTUWTUHUXBUXGNUWTUXCUXBUNZWKZUXDNXC
        ZUXGNXCZUXFNXCZUXOUXQUXPNUXFGVBZNXCZUXOEXDUNZUXFUWOUNUXTAUYAUWSUXNSXEZU
        XOCUWOUXEMACUWOMXJUWSUXNAHCDEIJUWOMPUWPQTUEXFXEZUXOUXBCUXEUXAUICXGZUXOJ
        KUNZUXKUXNUXEUXBUNAUYEUWSUXNRXEZUWTUXKUXNUXMWRZUWTUXNXHZUICUXBIUWQJKUXC
        TUXBVCXIXKVDZXLUWOEGUXFNUWPUCUAXMVSUXPUXGUXSNUXDNUXFGXNXOXPUXOUXQUXRUXD
        NGVBZNXCZUXOUYAUXDUWOUNUYKUYBUXOCUWOUXCLACUWOLXJUWSUXNAHCDEIJUWOLPUWPQT
        UDXFXEZUXOUXBCUXCUYDUYHVDZXLUWOEGUXDNUWPUCUAXQVSUXRUXGUYJNUXFNUXDGXRXOX
        PUXOUXCUVQUNZXSZUXEUVRUNZXSZXTZUXPUXRXTUXOUYNUYPWKZXSUYRUXOUXCUXEUVPVBZ
        BUNUYSUXOUYTCBUXOUYTUWQUWRUXOUJJUJVTZUXCULZVUAUWQULZVUBWPVBZVGVBZWQUJJV
        UCWQUYTUWQUXOUJJVUEVUCUXOVUAJUNWKZVUBYAUNZVUCYAUNZVUEVUCXCZUXOJYAVUAUXC
        UXOUYEUXCCUNZJYAUXCXJUYFUYMCIUXCJKTYBVSZYCZUXOJYAVUAUWQUXOUYEUXKJYAUWQX
        JUYFUYGCIUWQJKTYBVSZYCZVUGVUBYKUNVUCYKUNVUIVUHVUBYDVUCYDVUBVUCYEYFVSYGU
        XOUJJVUBVUDVGUXCUXEKYAUPUYFVULVUDUPUNVUFVUCVUBWPWBYLUXOUJJYAUXCVUKYHZUX
        OUJJVUCVUBWPUWQUXCKYAYAUYFVUNVULUXOUJJYAUWQVUMYHZVUOYIYIVUPYJAUWSUXNYMU
        UAUUBUYSUXCUXEUVTVBZUYTBUXCUXEUVQUVRUVPUUDUWKUYNUYPVUQBUNUWNUWKUYNUYPUU
        CVUQUWABUVQUVRUXCUXEUVTUUEUWBUUFUUGUUHUUIUYNUYPUUJUUNUXOUYOUXPUYQUXRUXO
        UYOUXCCUVQURUNZUXPUXOVUJVURUYOYNUYMVURVUJUYOUXCCUVQYOYPVQUXOVURUXPUXOCU
        WOLUVQUXCNUYLUVQUVQVFUXOUVQYQYLYRYSYTUXOUYQUXECUVRURUNZUXRUXOUXECUNZVUS
        UYQYNUYIVUSVUTUYQUXECUVRYOYPVQUXOVUSUXRUXOCUWOMUVRUXENUYCUVRUVRVFUXOUVR
        YQYLYRYSYTUUKUUOUULYGUUMUWTEUUPUNZUXBUTUNZUXJNXCUWTUYAVVAAUYAUWSSWREUUQ
        VQAUYEUXKVVBUWSRUXLUICIUWQJKTUURYFUXBUHEUTNUAUUSVSUUTUVABUVHUVBVSUVFDEF
        HJUVENPOUVJUAQVNUVC $.
    $}

    $( The set of polynomials is closed under multiplication, i.e. it is a
       subring of the set of power series.  (Contributed by Mario Carneiro,
       9-Jan-2015.) $)
    mplsubrg $p |- ( ph -> U e. ( SubRing ` S ) ) $=
      ( vx vy cfv wcel ccnv cima cfn eqid vk vf csubrg csubg cur cmulr wral crg
      cv co cgrp rnggrp syl mplsubg cbs cvv c0g csn cdif psrrng rngidcl cn cmap
      cn0 crab cc0 cxp wceq cif cmpt psr1 cnveqd imaeq1d wss snfi wa wne adantl
      eldifsni ifnefalse suppss2 sylancr eqeltrd mplelbas sylanbrc caddc adantr
      ssfi cof simprl simprr mplsubrglem ralrimivva w3a wb issubrg2 mpbir3and )
      AEDUCOPZEDUDOPZDUEOZEPZMUIZNUIZDUFOZUJEPZNEUGMEUGZABCDEFGHIJKACUHPZCUKPLC
      ULUMUNAWTDUOOZPZWTQZUPCUQOZURUSZRZSPXAADUHPZXIACDFGHKLUTZXHDWTXHTZWTTZVAU
      MAXMUAUBUIQVBRSPUBVDFVCUJVEZUAUIZFVFURVGZVHCUEOZXKVIZVJZQZXLRZSAXJYDXLAWT
      YCAUAXRCDWTYAUBFGXKHKLXRTZXKTZYATXQVKVLVMAXTURZSPYEYHVNYESPXTVOAXRYBUAYHX
      KAXSXRYHUSPZVPXSXTVQZYBXKVHYIYJAXSXRXTVSVRXSXTYAXKVTUMWAYHYEWHWBWCXHBCDEF
      WTXKIHXPYGJWDWEAXEMNEEAXBEPZXCEPZVPZVPWFWIXBQXLRXCQXLRVGRZXRBCDCUFOZEUBFG
      XBXCXKHIJAFGPYMKWGAXGYMLWGYFYGYNTYOTAYKYLWJAYKYLWKWLWMAXNWRWSXAXFWNWOXOMN
      EXHDXDWTXPXQXDTWPUMWQ $.
  $}

  ${
    $d f I $.
    mpl0.p $e |- P = ( I mPoly R ) $.
    mpl0.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mpl0.o $e |- O = ( 0g ` R ) $.
    mpl0.z $e |- .0. = ( 0g ` P ) $.
    mpl0.i $e |- ( ph -> I e. W ) $.
    mpl0.r $e |- ( ph -> R e. Grp ) $.
    $( The zero polynomial.  (Contributed by Mario Carneiro, 9-Jan-2015.) $)
    mpl0 $p |- ( ph -> .0. = ( D X. { O } ) ) $=
      ( c0g cfv csn cxp eqid cmps cbs csubg wcel wceq mplsubg mplval2 subg0 syl
      co psr0 eqtr3d syl5eq ) AICPQZBGRSZMAFDUAUJZPQZUNUOACUBQZUPUCQUDUQUNUEACD
      UPURFHUPTZJURTZNOUFURUPCUQCDUPURFJUSUTUGUQTZUHUIABDUPEFGHUQUSNOKLVAUKULUM
      $.
  $}

  ${
    mpladd.p $e |- P = ( I mPoly R ) $.
    mpladd.b $e |- B = ( Base ` P ) $.
    mpladd.a $e |- .+ = ( +g ` R ) $.
    mpladd.g $e |- .+b = ( +g ` P ) $.
    mpladd.x $e |- ( ph -> X e. B ) $.
    mpladd.y $e |- ( ph -> Y e. B ) $.
    $( The addition operation on multivariate polynomials.  (Contributed by
       Mario Carneiro, 9-Jan-2015.)  (Revised by Mario Carneiro,
       2-Oct-2015.) $)
    mpladd $p |- ( ph -> ( X .+b Y ) = ( X oF .+ Y ) ) $=
      ( cbs cfv eqid cplusg cvv cmps co wcel wceq fvex eqeltri ressplusg eqtr4i
      mplval2 ax-mp mplbasss sseldi psradd ) AGFUAUBZPQZDEFUNGHIUNRZUORZLECSQZU
      NSQZMBTUCUSURUDBCPQTKCPUEUFBUSUNCTCFUNBGJUPKUIUSRUGUJUHABUOHUOCFUNBGJUPKU
      QUKZNULABUOIUTOULUM $.
  $}

  ${
    $d k x y D $.  $d k x F $.  $d k x G $.  $d h k x y I $.  $d k x ph $.
    $d k x .x. $.  $d k x R $.
    mplmul.p $e |- P = ( I mPoly R ) $.
    mplmul.b $e |- B = ( Base ` P ) $.
    mplmul.m $e |- .x. = ( .r ` R ) $.
    mplmul.t $e |- .xb = ( .r ` P ) $.
    mplmul.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    mplmul.f $e |- ( ph -> F e. B ) $.
    mplmul.g $e |- ( ph -> G e. B ) $.
    $( The multiplication operation on multivariate polynomials.  (Contributed
       by Mario Carneiro, 9-Jan-2015.) $)
    mplmul $p |- ( ph -> ( F .xb G ) = ( k e. D |->
            ( R gsum ( x e. { y e. D | y oR <_ k } |->
            ( ( F ` x ) .x. ( G ` ( k oF - x ) ) ) ) ) ) ) $=
      ( cmps co cbs cfv eqid cmulr cvv wcel wceq eqeltri mplval2 ressmulr ax-mp
      fvex eqtr4i mplbasss sseldi psrmulfval ) ABCNGUBUCZUDUEZEGUTHIJKLMNUTUFZV
      AUFZQHFUGUEZUTUGUEZRDUHUIVEVDUJDFUDUEUHPFUDUOUKDUTFVEUHFGUTDNOVBPULVEUFUM
      UNUPSADVALVAFGUTDNOVBPVCUQZTURADVAMVFUAURUS $.
  $}

  ${
    $d x D $.  $d f x I $.  $d x .1. $.  $d x ph $.  $d f x R $.  $d f x .0. $.
    mpl1.p $e |- P = ( I mPoly R ) $.
    mpl1.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mpl1.z $e |- .0. = ( 0g ` R ) $.
    mpl1.o $e |- .1. = ( 1r ` R ) $.
    mpl1.u $e |- U = ( 1r ` P ) $.
    mpl1.i $e |- ( ph -> I e. W ) $.
    mpl1.r $e |- ( ph -> R e. Ring ) $.
    $( The identity element of the ring of polynomials.  (Contributed by Mario
       Carneiro, 10-Jan-2015.) $)
    mpl1 $p |- ( ph ->
      U = ( x e. D |-> if ( x = ( I X. { 0 } ) , .1. , .0. ) ) ) $=
      ( cfv eqid cur cv cc0 csn cxp wceq cif cmpt cmps cbs csubrg wcel mplsubrg
      co mplval2 subrg1 syl psr1 eqtr3d syl5eq ) AFDUASZBCBUBIUCUDUEUFGKUGUHZPA
      IEUIUNZUASZVAVBADUJSZVCUKSULVDVAUFADEVCVEIJVCTZLVETZQRUMVEVCDVDDEVCVEILVF
      VGUOVDTZUPUQABCEVCVDGHIJKVFQRMNOVHURUSUT $.
  $}

  ${
    mplsca.p $e |- P = ( I mPoly R ) $.
    mplsca.i $e |- ( ph -> I e. V ) $.
    mplsca.r $e |- ( ph -> R e. W ) $.
    $( The scalar field of a multivariate polynomial structure.  (Contributed
       by Mario Carneiro, 9-Jan-2015.) $)
    mplsca $p |- ( ph -> R = ( Scalar ` P ) ) $=
      ( cmps co csca cfv eqid psrsca cbs cvv wcel wceq fvex mplval2 resssca
      ax-mp syl6eq ) ACDCJKZLMZBLMZACUEDEFUENZHIOBPMZQRUFUGSBPTUIUFUEBQBCUEUIDG
      UHUINUAUFNUBUCUD $.
  $}

  ${
    mplvsca2.p $e |- P = ( I mPoly R ) $.
    mplvsca2.s $e |- S = ( I mPwSer R ) $.
    mplvsca2.n $e |- .x. = ( .s ` P ) $.
    $( The scalar multiplication operation on multivariate polynomials.
       (Contributed by Mario Carneiro, 9-Jan-2015.) $)
    mplvsca2 $p |- .x. = ( .s ` S ) $=
      ( cvsca cfv cbs cvv wcel wceq fvex eqid mplval2 ressvsca ax-mp eqtr4i ) D
      AIJZCIJZHAKJZLMUBUANAKOUCUBCALABCUCEFGUCPQUBPRST $.
  $}

  ${
    $d h I $.
    mplvsca.p $e |- P = ( I mPoly R ) $.
    mplvsca.n $e |- .xb = ( .s ` P ) $.
    mplvsca.k $e |- K = ( Base ` R ) $.
    mplvsca.b $e |- B = ( Base ` P ) $.
    mplvsca.m $e |- .x. = ( .r ` R ) $.
    mplvsca.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    mplvsca.x $e |- ( ph -> X e. K ) $.
    mplvsca.f $e |- ( ph -> F e. B ) $.
    $( The scalar multiplication operation on multivariate polynomials.
       (Contributed by Mario Carneiro, 9-Jan-2015.)  (Revised by Mario
       Carneiro, 2-Oct-2015.) $)
    mplvsca $p |- ( ph -> ( X .xb F ) = ( ( D X. { X } ) oF .x. F ) ) $=
      ( cmps co cbs cfv eqid mplvsca2 mplbasss sseldi psrvsca ) AJEUAUBZUCUDZCE
      UJFGHIJKLUJUEZDEUJFJMULNUFOUKUEZQRSABUKIUKDEUJBJMULPUMUGTUHUI $.

    mplvscaval.y $e |- ( ph -> Y e. D ) $.
    $( The scalar multiplication operation on multivariate polynomials.
       (Contributed by Mario Carneiro, 9-Jan-2015.) $)
    mplvscaval $p |- ( ph -> ( ( X .xb F ) ` Y ) = ( X .x. ( F ` Y ) ) ) $=
      ( co cfv csn cxp cof mplvsca fveq1d wcel wceq cvv cv ccnv cn cima cfn cn0
      cmap crab ovex rabex eqeltri a1i cbs wf wfn eqid mplelf ffn wa eqidd ofc1
      syl mpdan eqtrd ) AMLIFUCZUDMCLUEUFIGUGUCZUDZLMIUDZGUCZAMVQVRABCDEFGHIJKL
      NOPQRSTUAUHUIAMCUJZVSWAUKUBACLVTGIULKMCULUJACHUMUNUOUPUQUJZHURJUSUCZUTULS
      WCHWDURJUSVAVBVCVDTACEVEUDZIVFICVGABCDEHJWEINWEVHQSUAVICWEIVJVNAWBVKVTVLV
      MVOVP $.
  $}

  ${
    $d f x y I $.  $d x ph $.  $d x R $.  $d x V $.  $d y W $.  $d f x y X $.
    mvrcl.s $e |- P = ( I mPoly R ) $.
    mvrcl.v $e |- V = ( I mVar R ) $.
    mvrcl.b $e |- B = ( Base ` P ) $.
    mvrcl.i $e |- ( ph -> I e. W ) $.
    mvrcl.r $e |- ( ph -> R e. Ring ) $.
    mvrcl.x $e |- ( ph -> X e. I ) $.
    $( A power series variable is a polynomial.  (Contributed by Mario
       Carneiro, 9-Jan-2015.) $)
    mvrcl $p |- ( ph -> ( V ` X ) e. B ) $=
      ( vy vf cfv wcel cfn eqid vx cmps co cbs ccnv cvv c0g cdif cima mvrcl2 cv
      csn wceq c1 cc0 cif cmpt wss snfi cn cn0 cmap crab psrelbas wa cur adantr
      crg wne simpr eldifsn sylib simpld mvrval2 wn simprd neneqd iffalse eqtrd
      syl suppss ssfi sylancr mplelbas sylanbrc ) AHFQZEDUBUCZUDQZRWFUEUFDUGQZU
      LUHUIZSRZWFBRAWHDWGEFGHWGTZJWHTZLMNUJZAOEOUKHUMUNUOUPUQZULZSRWJWPURWKWOUS
      APUKUEUTUISRPVAEVBUCVCZDUDQZUAWFWPWIAWHWQDWGPEWRWFWLWRTWQTZWMWNVDAUAUKZWQ
      WPUHRZVEZWTWFQWTWOUMZDVFQZWIUPZWIXBOWQDXDPWTEFGHVHWIJWSWITZXDTAEGRXALVGAD
      VHRXAMVGAHERXANVGXBWTWQRZWTWOVIZXBXAXGXHVEAXAVJWTWQWOVKVLZVMVNXBXCVOXEWIU
      MXBWTWOXBXGXHXIVPVQXCXDWIVRVTVSWAWPWJWBWCWHCDWGBEWFWIIWLWMXFKWDWE $.
  $}

  ${
    mplgrp.p $e |- P = ( I mPoly R ) $.
    $( The polynomial ring is a group.  (Contributed by Mario Carneiro,
       9-Jan-2015.) $)
    mplgrp $p |- ( ( I e. V /\ R e. Grp ) -> P e. Grp ) $=
      ( wcel cgrp wa cbs cmps co csubg eqid simpl simpr mplsubg mplval2 subggrp
      cfv syl ) CDFZBGFZHZAISZCBJKZLSFAGFUCABUEUDCDUEMZEUDMZUAUBNUAUBOPUDUEAABU
      EUDCEUFUGQRT $.

    $( The polynomial ring is a left module.  (Contributed by Mario Carneiro,
       9-Jan-2015.) $)
    mpllmod $p |- ( ( I e. V /\ R e. Ring ) -> P e. LMod ) $=
      ( wcel crg wa cmps co clmod cbs cfv clss eqid simpl simpr psrlmod mplval2
      mpllss lsslmod syl2anc ) CDFZBGFZHZCBIJZKFALMZUFNMZFAKFUEBUFCDUFOZUCUDPZU
      CUDQZRUEABUFUGCDUIEUGOZUJUKTUHUGUFAABUFUGCEUIULSUHOUAUB $.

    $( The polynomial ring is a ring.  (Contributed by Mario Carneiro,
       9-Jan-2015.) $)
    mplrng $p |- ( ( I e. V /\ R e. Ring ) -> P e. Ring ) $=
      ( wcel crg wa cbs cfv cmps co csubrg eqid simpl mplsubrg mplval2 subrgrng
      simpr syl ) CDFZBGFZHZAIJZCBKLZMJFAGFUCABUEUDCDUENZEUDNZUAUBOUAUBSPUDUEAA
      BUEUDCEUFUGQRT $.

    $( The polynomial ring is a commutative ring.  (Contributed by Mario
       Carneiro, 9-Jan-2015.) $)
    mplcrng $p |- ( ( I e. V /\ R e. CRing ) -> P e. CRing ) $=
      ( wcel ccrg wa cmps co cbs cfv csubrg eqid simpl simpr psrcrng crg adantl
      crngrng mplsubrg mplval2 subrgcrng syl2anc ) CDFZBGFZHZCBIJZGFAKLZUHMLFAG
      FUGBUHCDUHNZUEUFOZUEUFPQUGABUHUICDUJEUINZUKUFBRFUEBTSUAUIUHAABUHUICEUJULU
      BUCUD $.

    $( The polynomial ring is an associative algebra.  (Contributed by Mario
       Carneiro, 9-Jan-2015.) $)
    mplassa $p |- ( ( I e. V /\ R e. CRing ) -> P e. AssAlg ) $=
      ( wcel ccrg wa casa cbs cfv cmps csubrg clss eqid simpl crg crngrng syl
      co adantl mplsubrg mpllss cur wb simpr psrassa subrg1cl subrgss issubassa
      wss mplval2 syl3anc mpbir2and ) CDFZBGFZHZAIFZAJKZCBLTZMKFZUSUTNKZFZUQABU
      TUSCDUTOZEUSOZUOUPPZUPBQFUOBRUAZUBZUQABUTUSCDVDEVEVFVGUCUQUTIFUTUDKZUSFZU
      SUTJKZUKZURVAVCHUEUQBUTCDVDVFUOUPUFUGUQVAVJVHUSUTVIVIOZUHSUQVAVLVHUSVKUTV
      KOZUISUSAVIVBVKUTABUTUSCEVDVEULVBOVNVMUJUMUN $.
  $}

  ${
    $d f C $.  $d f H $.  $d f I $.  $d f ph $.  $d f R $.
    ressmpl.s $e |- S = ( I mPoly R ) $.
    ressmpl.h $e |- H = ( R |`s T ) $.
    ressmpl.u $e |- U = ( I mPoly H ) $.
    ressmpl.b $e |- B = ( Base ` U ) $.
    ressmpl.1 $e |- ( ph -> I e. V ) $.
    ressmpl.2 $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    ${
      ressmplbas2.w $e |- W = ( I mPwSer H ) $.
      ressmplbas2.c $e |- C = ( Base ` W ) $.
      ressmplbas2.k $e |- K = ( Base ` S ) $.
      $( The base set of a restricted polynomial algebra consists of power
         series in the subring which are also polynomials (in the parent
         ring).  (Contributed by Mario Carneiro, 3-Jul-2015.) $)
      ressmplbas2 $p |- ( ph -> B = ( C i^i K ) ) $=
        ( vf cv ccnv cvv c0g cfv csn cdif cima cfn wcel cab cin cmps co cbs wss
        wceq csubrg eqid subrgpsr syl2anc subrgss syl df-ss sylib sneqd difeq2d
        subrg0 imaeq2d eleq1d abbidv ineq12d eqcomd mplbas dfrab3 ineq2i eqtr4i
        crab eqtri inass 3eqtr4g ) ACUBUCUDZUEHUFUGZUHZUIZUJZUKULZUBUMZUNZCIDUO
        UPZUQUGZUNZWDUEDUFUGZUHZUIZUJZUKULZUBUMZUNZBCJUNZAXAWKAWNCWTWJACWMURZWN
        CUSACWLUTUGULZXCAIKULFDUTUGULZXDQRCDWLFLHIKWLVAZNSTVBVCCWMWLWMVAZVDVECW
        MVFVGAWSWIUBAWRWHUKAWQWGWDAWPWFUEAWOWEAXEWOWEUSRFDHWONWOVAZVJVEVHVIVKVL
        VMVNVOBWIUBCVTWKCGHLBUBIWEOSTWEVAPVPWIUBCVQWAXBCWMWTUNZUNXAJXICJWSUBWMV
        TXIWMEDWLJUBIWOMXFXGXHUAVPWSUBWMVQWAVRCWMWTWBVSWC $.
    $}

    ressmpl.p $e |- P = ( S |`s B ) $.
    $( A restricted polynomial algebra has the same base set.  (Contributed by
       Mario Carneiro, 3-Jul-2015.) $)
    ressmplbas $p |- ( ph -> B = ( Base ` P ) ) $=
      ( cbs cfv eqid wss wceq cmps cin ressmplbas2 inss2 syl6eqss ressbas2 syl
      co ) ABERSZUABCRSUBABIHUCUJZRSZUKUDUKABUMDEFGHIUKJULKLMNOPULTUMTUKTZUEUMU
      KUFUGBUKCEQUNUHUI $.

    $( A restricted polynomial algebra has the same addition operation.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    ressmpladd $p |- ( ( ph /\ ( X e. B /\ Y e. B ) ) ->
        ( X ( +g ` U ) Y ) = ( X ( +g ` P ) Y ) ) $=
      ( cfv wcel wa cmps cplusg cbs cress wceq eqid mplbasss anim12i resspsradd
      co sseli sylan2 cvv eqeltri mplval2 ressplusg ax-mp oveqi 3eqtr3i 3eqtr3g
      fvex ) AKBUAZLBUAZUBZUBKLIHUCULZUDTZULZKLIDUCULZVGUETZUFULZUDTZULZKLGUDTZ
      ULKLCUDTZULVFAKVKUAZLVKUAZUBVIVNUGVDVQVEVRBVKKVKGHVGBIOVGUHZPVKUHZUIZUMBV
      KLWAUMUJAVKVLDVJFVGHIKLVJUHZNVSVTVLUHZRUKUNVHVOKLBUOUAZVHVOUGBGUETUOPGUEV
      CUPZBVHVGGUOGHVGBIOVSPUQVHUHURUSUTVMVPKLVJUDTZEUDTZVMVPEUETZUOUAWFWGUGEUE
      VCWHWFVJEUOEDVJWHIMWBWHUHUQWFUHZURUSVKUOUAWFVMUGVGUEVCVKWFVJVLUOWCWIURUSW
      DWGVPUGWEBWGECUOSWGUHURUSVAUTVB $.

    $( A restricted polynomial algebra has the same multiplication operation.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    ressmplmul $p |- ( ( ph /\ ( X e. B /\ Y e. B ) ) ->
        ( X ( .r ` U ) Y ) = ( X ( .r ` P ) Y ) ) $=
      ( cfv wcel wa cmps co cmulr cbs cress wceq eqid mplbasss sseli resspsrmul
      anim12i sylan2 fvex eqeltri mplval2 ressmulr ax-mp oveqi 3eqtr3i 3eqtr3g
      cvv ) AKBUAZLBUAZUBZUBKLIHUCUDZUETZUDZKLIDUCUDZVGUFTZUGUDZUETZUDZKLGUETZU
      DKLCUETZUDVFAKVKUAZLVKUAZUBVIVNUHVDVQVEVRBVKKVKGHVGBIOVGUIZPVKUIZUJZUKBVK
      LWAUKUMAVKVLDVJFVGHIKLVJUIZNVSVTVLUIZRULUNVHVOKLBVCUAZVHVOUHBGUFTVCPGUFUO
      UPZBVGGVHVCGHVGBIOVSPUQVHUIURUSUTVMVPKLVJUETZEUETZVMVPEUFTZVCUAWFWGUHEUFU
      OWHVJEWFVCEDVJWHIMWBWHUIUQWFUIZURUSVKVCUAWFVMUHVGUFUOVKVJVLWFVCWCWIURUSWD
      WGVPUHWEBECWGVCSWGUIURUSVAUTVB $.

    $( A restricted power series algebra has the same scalar multiplication
       operation.  (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    ressmplvsca $p |- ( ( ph /\ ( X e. T /\ Y e. B ) ) ->
        ( X ( .s ` U ) Y ) = ( X ( .s ` P ) Y ) ) $=
      ( cfv wcel wa cmps cvsca cbs cress wceq eqid mplbasss resspsrvsca sylanr2
      co sseli cvv fvex eqeltri mplval2 ressvsca ax-mp oveqi 3eqtr3i 3eqtr3g )
      AKFUAZLBUAZUBUBKLIHUCULZUDTZULZKLIDUCULZVEUETZUFULZUDTZULZKLGUDTZULKLCUDT
      ZULVDAVCLVIUAVGVLUGBVILVIGHVEBIOVEUHZPVIUHZUIUMAVIVJDVHFVEHIKLVHUHZNVOVPV
      JUHZRUJUKVFVMKLBUNUAZVFVMUGBGUETUNPGUEUOUPZBVFVEGUNGHVEBIOVOPUQVFUHURUSUT
      VKVNKLVHUDTZEUDTZVKVNEUETZUNUAWAWBUGEUEUOWCWAVHEUNEDVHWCIMVQWCUHUQWAUHZUR
      USVIUNUAWAVKUGVEUEUOVIWAVHVJUNVRWDURUSVSWBVNUGVTBWBECUNSWBUHURUSVAUTVB $.
  $}

  ${
    $d f I $.  $d x y z ph $.  $d f x y z R $.  $d x y z S $.
    subrgmpl.s $e |- S = ( I mPoly R ) $.
    subrgmpl.h $e |- H = ( R |`s T ) $.
    subrgmpl.u $e |- U = ( I mPoly H ) $.
    subrgmpl.b $e |- B = ( Base ` U ) $.
    $( A subring of the base ring induces a subring of polynomials.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    subrgmpl $p |- ( ( I e. V /\ T e. ( SubRing ` R ) ) ->
        B e. ( SubRing ` S ) ) $=
      ( wcel csubrg cfv wa cmps co cbs eqid wss cin simpl simpr ressmplbas2 crg
      subrgpsr subrgrcl mplsubrg subrgin syl2anc eqeltrd inss2 syl6eqss mplval2
      adantl wb subsubrg syl mpbir2and ) GHMZDBNOMZPZACNOMZAGBQRZNOZMZACSOZUAZV
      CAGFQRZSOZVHUBZVFVCAVKBCDEFGVHHVJIJKLVAVBUCZVAVBUDVJTZVKTZVHTZUEZVCVKVFMV
      HVFMZVLVFMVKBVEDVJFGHVETZJVNVOUGVCCBVEVHGHVSIVPVMVBBUFMVADBUHUPUIZVKVHVEU
      JUKULVCAVLVHVQVKVHUMUNVCVRVDVGVIPUQVTVHAVECCBVEVHGIVSVPUOURUSUT $.
  $}

  ${
    $d x B $.  $d x y H $.  $d f x y z I $.  $d x y ph $.  $d x V $.  $d z W $.
    $d x y R $.
    subrgmvr.v $e |- V = ( I mVar R ) $.
    subrgmvr.i $e |- ( ph -> I e. W ) $.
    subrgmvr.r $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    subrgmvr.h $e |- H = ( R |`s T ) $.
    $( The variables in a subring polynomial algebra are the same as the
       original ring.  (Contributed by Mario Carneiro, 4-Jul-2015.) $)
    subrgmvr $p |- ( ph -> V = ( I mVar H ) ) $=
      ( vx vy vf vz cv wcel cmpt cfv eqid ccnv cn cima cfn cmap co crab wceq c1
      cn0 cc0 cif cur c0g csubrg subrg1 syl subrg0 ifeq12d mpteq2dv crg mvrfval
      cmvr subrgrcl cvv cress ovex eqeltri a1i 3eqtr4d ) ALEMNPUAUBUCUDQNUJEUEU
      FUGZMPOEOPLPUHUIUKULRUHZBUMSZBUNSZULZRZRLEMVKVLDUMSZDUNSZULZRZRFEDVCUFZAL
      EVPVTAMVKVOVSAVLVMVQVNVRACBUOSQZVMVQUHJCBDVMKVMTZUPUQAWBVNVRUHJCBDVNKVNTZ
      URUQUSUTUTALOVKBVMMNEFGVAVNHVKTZWDWCIAWBBVAQJCBVDUQVBALOVKDVQMNEWAGVEVRWA
      TWEVRTVQTIDVEQADBCVFUFVEKBCVFVGVHVIVBVJ $.

    subrgmvrf.u $e |- U = ( I mPoly H ) $.
    subrgmvrf.b $e |- B = ( Base ` U ) $.
    $( The variables in a polynomial algebra are contained in every subring
       algebra.  (Contributed by Mario Carneiro, 4-Jul-2015.) $)
    subrgmvrf $p |- ( ph -> V : I --> B ) $=
      ( vx cfv wcel eqid syl wfn cv wral wf cmps co cbs csubrg crg subrgrcl ffn
      mvrf wa cmvr wceq subrgmvr fveq1d adantr subrgrng simpr eqeltrd ralrimiva
      mvrcl ffnfv sylanbrc ) AHGUAZPUBZHQZBRZPGUCGBHUDAGGCUEUFZUGQZHUDVFAVKCVJG
      HIVJSJVKSKADCUHQRZCUIRLDCUJTULGVKHUKTAVIPGAVGGRZUMZVHVGGFUNUFZQZBAVHVPUOV
      MAVGHVOACDFGHIJKLMUPUQURVNBEFGVOIVGNVOSOAGIRVMKURAFUIRZVMAVLVQLDCFMUSTURA
      VMUTVCVAVBPGBHVDVE $.
  $}

  ${
    $d j k x y z D $.  $d f j k x z I $.  $d j k y z ph $.  $d f j k x y z X $.
    $d j k y .0. $.  $d j k y .1. $.  $d j k y R $.  $d f j k x y z Y $.
    $d x W $.
    mplmon.s $e |- P = ( I mPoly R ) $.
    mplmon.b $e |- B = ( Base ` P ) $.
    mplmon.z $e |- .0. = ( 0g ` R ) $.
    mplmon.o $e |- .1. = ( 1r ` R ) $.
    mplmon.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplmon.i $e |- ( ph -> I e. W ) $.
    mplmon.r $e |- ( ph -> R e. Ring ) $.
    mplmon.x $e |- ( ph -> X e. D ) $.
    $( A monomial is a polynomial.  (Contributed by Mario Carneiro,
       9-Jan-2015.) $)
    mplmon $p |- ( ph -> ( y e. D |-> if ( y = X , .1. , .0. ) ) e. B ) $=
      ( cv wceq cif cmpt cmps co cbs cfv wcel ccnv cvv csn cdif cima cfn wf crg
      cmap eqid rngidcl rng0cl ifcl syl2anc syl adantr fmptd fvex cn0 crab ovex
      cn rabex eqeltri elmap sylibr psrbas eleqtrrd wss snfi wa wn wne eldifsni
      adantl neneqd iffalse suppss2 ssfi sylancr mplelbas sylanbrc ) ABDBUAZKUB
      ZGLUCZUDZIFUEUFZUGUHZUIWOUJUKLULUMUNZUOUIZWOCUIAWOFUGUHZDURUFZWQADWTWOUPW
      OXAUIABDWNWTWOAWNWTUIZWLDUIAFUQUIZXBSXCGWTUILWTUIXBWTFGWTUSZPUTWTFLXDOVAW
      MGLWTVBVCVDVEWOUSVFWTDWOFUGVGDHUAUJVKUNUOUIZHVHIURUFZVIUKQXEHXFVHIURVJVLV
      MVNVOAWQDFWPHIWTJWPUSZXDQWQUSZRVPVQAKULZUOUIWRXIVRWSKVSADWNBXILAWLDXIUMUI
      ZVTZWMWAWNLUBXKWLKXJWLKWBAWLDKWCWDWEWMGLWFVDWGXIWRWHWIWQEFWPCIWOLMXGXHONW
      JWK $.

    mplmonmul.t $e |- .x. = ( .r ` P ) $.
    mplmonmul.x $e |- ( ph -> Y e. D ) $.
    $( The product of two monomials adds the exponent vectors together.  For
       example, the product of ` ( x ^ 2 ) ( y ^ 2 ) ` with
       ` ( y ^ 1 ) ( z ^ 3 ) ` is ` ( x ^ 2 ) ( y ^ 3 ) ( z ^ 3 ) ` , where the
       exponent vectors ` <. 2 , 2 , 0 >. ` and ` <. 0 , 1 , 3 >. ` are added
       to give ` <. 2 , 3 , 3 >. ` .  (Contributed by Mario Carneiro,
       9-Jan-2015.) $)
    mplmonmul $p |- ( ph -> ( ( y e. D |-> if ( y = X , .1. , .0. ) ) .x.
                              ( y e. D |-> if ( y = Y , .1. , .0. ) ) ) =
                      ( y e. D |-> if ( y = ( X oF + Y ) , .1. , .0. ) ) ) $=
      ( vk vj vx vz cv wceq cif cmpt cle cofr wbr crab cfv cmin cof cmulr caddc
      co cgsu eqid mplmon mplmul eqeq1 ifbid cbvmptv wcel wa csn cres wss simpr
      snssd resmpt syl oveq2d cmnd cbs crg ad2antrr rngmnd cur cvv fvex eqeltri
      iftrue fvmpt ssrab2 simplr psrbagconcl syl3anc sseldi c0g oveq12d rngidcl
      ifex rng0cl ifcl syl2anc rnglidm wral cn0 wb wf psrbagf ffvelrnda adantlr
      adantr nn0cn subadd syl3an eqcom syl6bb ralbidva mpteqb ovex mprg 3bitr4g
      cc a1i feqmptd offval2 eqeq12d 3bitr4d 3eqtrd eqeltrrd fveq2 wn c0 mplelf
      eqeltrd ffvelrnd iffalse cfn cdif suppss2 sylan2 fveq2d gsumsn cin disjsn
      oveq2 gsum0 wfn rngcl ffn fnresdisj 3syl biimpa sylan2br nn0red nn0addge1
      fmptd ralrimiva ofrfval2 mpbird breq1 elrab sylanbrc breq2 rabbidv eleq2d
      cr syl5ibrcom con3and 3eqtr4a pm2.61dan ccmn psrbaglefi sylan ssdif ax-mp
      rngcmn sseli wne eldifsni adantl neneqd suppssr oveq1d eldifi rnglz eqtrd
      ccnv cima snfi ssfi sylancr gsumres eqtr3d mpteq2dva syl5eq eqtr4d ) ABDB
      UIZLUJZHNUKZULZBDUWQMUJZHNUKZULZGVBUEDFUFUGUIZUEUIZUMUNZUOZUGDUPZUFUIZUWT
      UQZUXEUXIURUSZVBZUXCUQZFUTUQZVBZULZVCVBZULZBDUWQLMVAUSVBZUJZHNUKZULZAUFUG
      CDEFGUXNIUEUWTUXCJOPUXNVDZUCSABCDEFHIJKLNOPQRSTUAUBVEZABCDEFHIJKMNOPQRSTU
      AUDVEZVFAUYBUEDUXEUXSUJZHNUKZULUXRBUEDUYAUYGUWQUXEUJUXTUYFHNUWQUXEUXSVGVH
      VIAUEDUYGUXQAUXEDVJZVKZFUXPLVLZVMZVCVBZUYGUXQUYILUXHVJZUYLUYGUJUYIUYMVKZU
      YLFUFUYJUXOULZVCVBZLUWTUQZUXELUXKVBZUXCUQZUXNVBZUYGUYNUYKUYOFVCUYNUYJUXHV
      NUYKUYOUJUYNLUXHUYIUYMVOZVPUFUXHUYJUXOVQVRVSUYNFVTVJZLDVJZUYTFWAUQZVJUYPU
      YTUJUYNFWBVJZVUBAVUEUYHUYMUAWCZFWDVRAVUCUYHUYMUBWCZUYNUYTUYGVUDUYNUYTHUYR
      MUJZHNUKZUXNVBZVUIUYGUYNUYQHUYSVUIUXNUYNVUCUYQHUJVUGBLUWSHDUWTUWRHNWIUWTV
      DHFWEUQWFRFWEWGWHZWJVRUYNUYRDVJUYSVUIUJUYNUXHDUYRUXGUGDWKZUYNJKVJZUYHUYMU
      YRUXHVJAVUMUYHUYMTWCZAUYHUYMWLZVUAUGDUXHIUXEJKLSUXHVDZWMWNWOBUYRUXBVUIDUX
      CUWQUYRUJUXAVUHHNUWQUYRMVGVHUXCVDVUHHNVUKNFWPUQWFQFWPWGWHWSWJVRWQUYNVUEVU
      IVUDVJZVUJVUIUJVUFUYNVUEVUQVUFVUEHVUDVJNVUDVJVUQVUDFHVUDVDZRWRVUDFNVURQWT
      VUHHNVUDXAXBVRZVUDFUXNHVUIVURUYCRXCXBUYNVUHUYFHNUYNUHJUHUIZUXEUQZVUTLUQZU
      RVBZULZUHJVUTMUQZULZUJZUHJVVAULZUHJVVBVVEVAVBZULZUJZVUHUYFUYNVVCVVEUJZUHJ
      XDZVVAVVIUJZUHJXDZVVGVVKUYNVVLVVNUHJUYNVUTJVJZVKZVVLVVIVVAUJZVVNVVQVVAXEV
      JZVVBXEVJZVVEXEVJZVVLVVRXFZUYNJXEVUTUXEUYNVUMUYHJXEUXEXGVUNVUODIUXEJKSXHX
      BZXIZUYIVVPVVTUYMUYIJXEVUTLUYIVUMVUCJXELXGAVUMUYHTXKZAVUCUYHUBXKZDILJKSXH
      XBZXIZXJZUYIVVPVWAUYMUYIJXEVUTMAJXEMXGZUYHAVUMMDVJVWJTUDDIMJKSXHXBXKZXIZX
      JVVSVVAYBVJVVTVVBYBVJVWAVVEYBVJVWBVVAXLVVBXLVVEXLVVAVVBVVEXMXNWNVVIVVAXOX
      PXQVVCWFVJZVVGVVMXFUHJUHJVVCVVEWFXRVWMVVPVVAVVBURXSYCXTVVAWFVJZVVKVVOXFUH
      JUHJVVAVVIWFXRVWNVVPVUTUXEWGYCXTYAUYNUYRVVDMVVFUYNUHJVVAVVBURUXELKXEXEVUN
      VWDVWIUYNUHJXEUXEVWCYDZUYILUHJVVBULUJUYMUYIUHJXELVWGYDZXKYEUYIMVVFUJUYMUY
      IUHJXEMVWKYDZXKYFUYNUXEVVHUXSVVJVWOUYIUXSVVJUJUYMUYIUHJVVBVVEVALMKXEXEVWE
      VWHVWLVWPVWQYEZXKYFYGVHZYHZUYNVUIUYGVUDVWSVUSYIYNUXOVUDUYTUFFLDVURUXILUJZ
      UXJUYQUXMUYSUXNUXILUWTYJVXAUXLUYRUXCUXILUXEUXKUUEUUAWQUUBWNVWTYHUYIUYMYKZ
      VKZFYLVCVBNUYLUYGFNQUUFVXCUYKYLFVCVXBUYIUXHUYJUUCYLUJZUYKYLUJZUXHLUUDUYIV
      XDVXEUYIUXHVUDUXPXGUXPUXHUUGVXDVXEXFUYIUFUXHUXOVUDUXPUYIUXIUXHVJZVKZVUEUX
      JVUDVJUXMVUDVJZUXOVUDVJAVUEUYHVXFUAWCZVXGDVUDUXIUWTADVUDUWTXGZUYHVXFACDEF
      IJVUDUWTOVURPSUYDYMZWCVXGUXHDUXIVULUYIVXFVOZWOYOVXGDVUDUXLUXCADVUDUXCXGUY
      HVXFACDEFIJVUDUXCOVURPSUYEYMWCVXGUXHDUXLVULVXGVUMUYHVXFUXLUXHVJAVUMUYHVXF
      TWCAUYHVXFWLVXLUGDUXHIUXEJKUXISVUPWMWNWOYOZVUDFUXNUXJUXMVURUYCUUHWNUXPVDU
      UPZUXHVUDUXPUUIUXHUYJUXPUUJUUKUULUUMVSVXCUYFYKUYGNUJUYIUYFUYMUYIUYMUYFLUX
      DUXSUXFUOZUGDUPZVJZUYIVUCLUXSUXFUOZVXQVWFUYIVXRVVBVVIUMUOZUHJXDUYIVXSUHJU
      YIVVPVKZVVBUVFVJVWAVXSVXTVVBVWHUUNVWLVVBVVEUUOXBUUQUYIUHJVVBVVIUMLUXSKXEW
      FVWEVWHVVIWFVJVXTVVBVVEVAXSYCVWPVWRUURUUSVXOVXRUGLDUXDLUXSUXFUUTUVAUVBUYF
      UXHVXPLUYFUXGVXOUGDUXEUXSUXDUXFUVCUVDUVEUVGUVHUYFHNYPVRUVIUVJUYIUXHVUDUXP
      FYQUYJNVURQUYIVUEFUVKVJAVUEUYHUAXKFUVPVRAVUMUYHUXHYQVJTUGDIUXEJKSUVLUVMVX
      NUYIUXHUXOUFUYJNUYIUXIUXHUYJYRZVJZVKZUXONUXMUXNVBZNVYCUXJNUXMUXNVYBUYIUXI
      DUYJYRZVJUXJNUJVYAVYEUXIUXHDVNVYAVYEVNVULUXHDUYJUVNUVOUVQUYIDVUDUWTUYJUXI
      NAVXJUYHVXKXKUYIDUWSBUYJNUYIUWQVYEVJZVKZUWRYKUWSNUJVYGUWQLVYFUWQLUVRUYIUW
      QDLUVSUVTUWAUWRHNYPVRYSUWBYTUWCVYBUYIVXFVYDNUJZUXIUXHUYJUWDVXGVUEVXHVYHVX
      IVXMVUDFUXNUXMNVURUYCQUWEXBYTUWFYSZUYIUYJYQVJUXPUWGWFNVLYRUWHZUYJVNVYJYQV
      JLUWIVYIUYJVYJUWJUWKUWLUWMUWNUWOUWP $.
  $}

  ${
    $d i k n w x z .^ $.  $d i k n w x y z .1. $.  $d k B $.  $d i k w x z G $.
    $d f i k n w x y z I $.  $d k x y N $.  $d i k n w x y z ph $.  $d f y R $.
    $d i k n w x y z D $.  $d i k w x z P $.  $d i k n w x z V $.  $d i k W $.
    $d f i k n w x y z .0. $.  $d f k n w x y z X $.  $d f i k w x y z Y $.
    $d k w x z .x. $.
    mplcoe1.p $e |- P = ( I mPoly R ) $.
    mplcoe1.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplcoe1.z $e |- .0. = ( 0g ` R ) $.
    mplcoe1.o $e |- .1. = ( 1r ` R ) $.
    mplcoe1.i $e |- ( ph -> I e. W ) $.
    ${
      mplcoe1.b $e |- B = ( Base ` P ) $.
      mplcoe1.n $e |- .x. = ( .s ` P ) $.
      mplcoe1.r $e |- ( ph -> R e. Ring ) $.
      mplcoe1.x $e |- ( ph -> X e. B ) $.
      $( Decompose a polynomial into a finite sum of monomials.  (Contributed
         by Mario Carneiro, 9-Jan-2015.) $)
      mplcoe1 $p |- ( ph -> X = ( P gsum ( k e. D |->
        ( ( X ` k ) .x. ( y e. D |-> if ( y = k , .1. , .0. ) ) ) ) ) ) $=
        ( vw vx vz ccnv cvv csn cdif cima cv cfv weq cif cmpt co cgsu wcel eqid
        cbs mplelf feqmptd wa wceq iftrue adantl wn eldif ifid wss ssid suppssr
        ifeq2d syl5reqr sylan2br anassrs pm2.61dan mpteq2dva eqtr4d cnvimass wf
        a1i cdm fdm syl syl5sseq cfn wi cmps mplelbas simprbi wel c0g cun sseq1
        c0 mpteq1 mpt0 syl6eq oveq2d gsum0 eleq2 iffalse eqeq12d imbi12d imbi2d
        mpteq2dv ifbid cxp crg fconstmpt cplusg syl2anc adantr ffvelrnda fveq2d
        eleqtrd simpr mplmon lmodvscl syl3anc sylibr oveq12d cmap ad2antrr ifcl
        cof fmptd cn0 ovex suppss2 ssfi eqidd offval2 eqtrd 3eqtr4d a2d oveq1d
        wo noel mtbiri cgrp rnggrp mpl0 a1d ssun1 sstr2 ax-mp imim1i oveq1 ccmn
        mplrng rngcmn simprll simprr unssad sselda clmod mpllmod mplsca adantlr
        csca syldan vex simprlr unssbd snss ffvelrnd fveq2 equequ2 cmulr rng0cl
        gsumunsn fvex cn crab rabex eqeltri elmap psrbas eleqtrrd eldifn mpladd
        sylanbrc mplvsca rngidcl grplid elsn sylib eqneltrd elun2 grprid sylnib
        rngridm rngrz biorf elun orcom bitri syl6rbbr 3eqtrrd syl5ibr expr syl5
        wb expcom findcard2s mpcom mpd cres resmpt eldifi syl5eq lmod0vs sylan2
        gsumres eqtr3d ) AMEJMUGUHNUIZUJZUKZJULZMUMZBDBJUNZHNUOZUPZGUQZUPZURUQZ
        EJDUYGUPZURUQZAMBDBULZUYAUSZUYLMUMZNUOZUPZUYIAMBDUYNUPUYPABDFVAUMZMACDE
        FIKUYQMOUYQUTZTPUCVBZVCABDUYOUYNAUYLDUSZVDZUYMUYOUYNVEZUYMVUBVUAUYMUYNN
        VFVGAUYTUYMVHZVUBUYTVUCVDAUYLDUYAUJZUSZVUBUYLDUYAVIAVUEVDZUYNUYMUYNUYNU
        OUYOUYMUYNVJVUFUYMUYNNUYNADUYQMUYAUYLNUYSUYAUYAVKAUYAVLWCZVMVNVOVPVQVRV
        SVTAUYADVKZUYIUYPVEZAMWDZUYADMUXTWAADUYQMWBZVUJDVEUYSDUYQMWEWFWGZUYAWHU
        SZAVUHVUIWIZAMCUSZVUMUCVUOMKFWJUQZVAUMZUSVUMVUQEFVUPCKMNOVUPUTZVUQUTZQT
        WKWLWFZAUDULZDVKZEJVVAUYGUPZURUQZBDBUDWMZUYNNUOZUPZVEZWIZWIAWQDVKZEWNUM
        ZBDNUPZVEZWIZWIAUEULZDVKZEJVVOUYGUPZURUQZBDBUEWMZUYNNUOZUPZVEZWIZWIAVVO
        UFULZUIZWOZDVKZEJVWFUYGUPZURUQZBDUYLVWFUSZUYNNUOZUPZVEZWIZWIAVUNWIUDUEU
        FUYAVVAWQVEZVVIVVNAVWOVVBVVJVVHVVMVVAWQDWPVWOVVDVVKVVGVVLVWOVVDEWQURUQV
        VKVWOVVCWQEURVWOVVCJWQUYGUPWQJVVAWQUYGWRJUYGWSWTXAEVVKVVKUTZXBWTVWOBDVV
        FNVWOVVEVHVVFNVEVWOVVEUYLWQUSUYLUUAVVAWQUYLXCUUBVVEUYNNXDWFXHXEXFXGUDUE
        UNZVVIVWCAVWQVVBVVPVVHVWBVVAVVODWPVWQVVDVVRVVGVWAVWQVVCVVQEURJVVAVVOUYG
        WRXAVWQBDVVFVVTVWQVVEVVSUYNNVVAVVOUYLXCXIXHXEXFXGVVAVWFVEZVVIVWNAVWRVVB
        VWGVVHVWMVVAVWFDWPVWRVVDVWIVVGVWLVWRVVCVWHEURJVVAVWFUYGWRXAVWRBDVVFVWKV
        WRVVEVWJUYNNVVAVWFUYLXCXIXHXEXFXGVVAUYAVEZVVIVUNAVWSVVBVUHVVHVUIVVAUYAD
        WPVWSVVDUYIVVGUYPVWSVVCUYHEURJVVAUYAUYGWRXAVWSBDVVFUYOVWSVVEUYMUYNNVVAU
        YAUYLXCXIXHXEXFXGAVVMVVJAVVKDUXSXJVVLADEFIKNLVVKOPQVWPSAFXKUSZFUUCUSZUB
        FUUDZWFZUUEBDNXLWTUUFVVOWHUSZUFUEWMVHZVDZAVWCVWNAVXFVWCVWNWIVWCVWGVWBWI
        AVXFVDZVWNVWGVVPVWBVVOVWFVKVWGVVPWIVVOVWEUUGVVOVWFDUUHUUIUUJVXGVWGVWBVW
        MAVXFVWGVWBVWMWIVWBVWMAVXFVWGVDZVDZVVRVWDMUMZBDBUFUNZHNUOZUPZGUQZEXMUMZ
        UQZVWAVXNVXOUQZVEVVRVWAVXNVXOUUKVXIVWIVXPVWLVXQVXIVVOCVXOJEVWDUHUYGVXNT
        VXOUTZAEUULUSZVXHAEXKUSZVXSAKLUSZVWTVXTSUBEFKLOUUMXNEUUNWFZXOAVXDVXEVWG
        UUOZVXIJUEWMUYBDUSZUYGCUSZVXIVVODUYBVXIVVOVWEDAVXFVWGUUPZUUQUURAVYDVYEV
        XHAVYDVDZEUUSUSZUYCEUVCUMZVAUMZUSUYFCUSZVYEVYGVYAVWTVYHAVYAVYDSXOZAVWTV
        YDUBXOZEFKLOUUTZXNZVYGUYCUYQVYJADUYQUYBMUYSXPVYGFVYIVAAFVYIVEZVYDAEFKLX
        KOSUBUVAZXOZXQXRVYGBCDEFHIKLUYBNOTQRPVYLVYMAVYDXSXTZUYCGVYIVYJCEUYFTVYI
        UTZUAVYJUTZYAYBZUVBUVDVWDUHUSVXIUFUVEZWCAVXDVXEVWGUVFZVXIVYHVXJVYJUSVXM
        CUSVXNCUSAVYHVXHAVYAVWTVYHSUBVYNXNXOVXIVXJUYQVYJVXIDUYQVWDMAVUKVXHUYSXO
        ZVXIVWEDVKVWDDUSVXIVVOVWEDVYFUVGVWDDWUCUVHYCZUVIZVXIFVYIVAAVYPVXHVYQXOX
        QXRVXIBCDEFHIKLVWDNOTQRPAVYAVXHSXOZAVWTVXHUBXOZWUFXTZVXJGVYIVYJCEVXMTVY
        TUAWUAYAYBZJUFUNZUYCVXJUYFVXMGUYBVWDMUVJWULBDUYEVXLWULUYDVXKHNJUFBUVKXI
        XHYDUVNVXIVXQVWAVXNFXMUMZYHUQBDVVTVXJVXLFUVLUMZUQZWUMUQZUPVWLVXICEWUMVX
        OFKVWAVXNOTWUMUTZVXRVXIVWAVUQUSVWAUGUXTUKZWHUSZVWACUSVXIVWAUYQDYEUQZVUQ
        VXIDUYQVWAWBVWAWUTUSVXIBDVVTUYQVWAVXIUYTVDZUYNUYQUSNUYQUSZVVTUYQUSZVXID
        UYQUYLMWUEXPAWVBVXHUYTAVWTWVBUBUYQFNUYRQUVMZWFYFVVSUYNNUYQYGXNZVWAUTYIU
        YQDVWAFVAUVODIULUGUVPUKWHUSZIYJKYEUQZUVQUHPWVFIWVGYJKYEYKUVRUVSZUVTYCVX
        IVUQDFVUPIKUYQLVURUYRPVUSWUHUWAUWBVXIVXDWURVVOVKWUSVYCVXIDVVTBVVONVXIUY
        LDVVOUJUSZVDVVSVHZVVTNVEZWVIWVJVXIUYLDVVOUWCVGVVSUYNNXDZWFYLVVOWURYMXNV
        UQEFVUPCKVWANOVURVUSQTWKUWEWUKUWDVXIBDVVTWUOWUMVWAVXNUHUYQUHDUHUSZVXIWV
        HWCZWVEWUOUHUSWVAVXJVXLWUNYKWCVXIVWAYNVXIVXNDVXJUIXJZVXMWUNYHUQBDWUOUPV
        XICDEFGWUNIVXMKUYQVXJOUAUYRTWUNUTZPWUGWUJUWFVXIBDVXJVXLWUNWVOVXMUHUYQUY
        QWVNVXIVXJUYQUSZUYTWUGXOAVXLUYQUSZVXHUYTAVWTWVRUBVWTHUYQUSWVBWVRUYQFHUY
        RRUWGWVDVXKHNUYQYGXNWFYFWVOBDVXJUPVEVXIBDVXJXLWCVXIVXMYNYOYPYOVXIBDWUPV
        WKWVAUYLVWEUSZWUPVWKVEWVAWVSVDZNVXJWUMUQZUYNWUPVWKWVTWWAVXJUYNVXIWWAVXJ
        VEZUYTWVSVXIVXAWVQWWBVXIVWTVXAWUIVXBWFWUGUYQWUMFVXJNUYRWUQQUWHXNYFWVTUY
        LVWDMWVTWVSVXKWVAWVSXSBVWDUWIZUWJZXQVTWVTVVTNWUOVXJWUMWVTWVJWVKWVTUYLVW
        DVVOWWDVXIVXEUYTWVSWUDYFUWKWVLWFWVTWUOVXJHWUNUQZVXJWVTVXLHVXJWUNWVTVXKV
        XLHVEWWDVXKHNVFWFXAVXIWWEVXJVEZUYTWVSVXIVWTWVQWWFWUIWUGUYQFWUNHVXJUYRWV
        PRUWOXNYFYPYDWVTVWJVWKUYNVEWVSVWJWVAUYLVWEVVOUWLVGVWJUYNNVFWFYQWVAWVSVH
        ZVDZVVTNWUMUQZVVTWUPVWKWVAWWIVVTVEZWWGWVAVXAWVCWWJAVXAVXHUYTVXCYFWVEUYQ
        WUMFVVTNUYRWUQQUWMXNXOWWHWUONVVTWUMWWHWUOVXJNWUNUQZNWWHVXLNVXJWUNWWHVXK
        VHVXLNVEWWHWVSVXKWVAWWGXSWWCUWNVXKHNXDWFXAVXIWWKNVEZUYTWWGVXIVWTWVQWWLW
        UIWUGUYQFWUNVXJNUYRWVPQUWPXNYFYPXAWWHVWJVVSUYNNWWGVWJVVSUXFWVAWWGVVSWVS
        VVSYTZVWJWVSVVSUWQVWJVVSWVSYTWWMUYLVVOVWEUWRVVSWVSUWSUWTUXAVGXIYQVRVSUX
        BXEUXCUXDYRUXEUXGYRUXHUXIUXJVTAEUYJUYAUXKZURUQUYIUYKAWWNUYHEURAVUHWWNUY
        HVEVULJDUYAUYGUXLWFXAADCUYJEUHUYAVVKTVWPVYBWVMAWVHWCAJDUYGCUYJWUBUYJUTY
        IADUYGJUYAVVKAUYBVUDUSZVDZUYGNUYFGUQZVVKWWPUYCNUYFGADUYQMUYAUYBNUYSVUGV
        MYSWWOAVYDWWQVVKVEUYBDUYAUXMVYGWWQVYIWNUMZUYFGUQZVVKVYGNWWRUYFGVYGNFWNU
        MWWRQVYGFVYIWNVYRXQUXNYSVYGVYHVYKWWSVVKVEVYOVYSGVYIWWRCEUYFVVKTVYTUAWWR
        UTVWPUXOXNYPUXPYPYLZAVUMUYJUGUHVVKUIUJUKZUYAVKWXAWHUSVUTWWTUYAWXAYMXNUX
        QUXRYP $.
    $}

    mplcoe2.g $e |- G = ( mulGrp ` P ) $.
    mplcoe2.m $e |- .^ = ( .g ` G ) $.
    mplcoe2.v $e |- V = ( I mVar R ) $.
    ${
      mplcoe3.r $e |- ( ph -> R e. Ring ) $.
      mplcoe3.x $e |- ( ph -> X e. I ) $.
      mplcoe3.n $e |- ( ph -> N e. NN0 ) $.
      $( Decompose a monomial in one variable into a power of a variable.
         (Contributed by Mario Carneiro, 7-Jan-2015.) $)
      mplcoe3 $p |- ( ph -> ( y e. D |-> if ( y = ( k e. I |->
        if ( k = X , N , 0 ) ) , .1. , .0. ) ) = ( N .^ ( V ` X ) ) ) $=
        ( vx vn cn0 wcel cv wceq cc0 cif cmpt cfv co wi csn c1 caddc ifeq1 ifid
        cxp syl6eq mpteq2dv fconstmpt syl6eqr eqeq2d ifbid oveq1 eqeq12d imbi2d
        cur cbs eqid mvrcl mgpbas rngidval mulg0 syl eqtr2d wa cmulr cof adantr
        mpl1 crg wf ccnv cn cima cfn simplr 0nn0 ifcl sylancl fmptd cvv nn0supp
        cdif wss wn wne eldifsni adantl neneqd iffalse suppss2 sylancr eqeltrrd
        snfi ssfi psrbag mpbir2and mvridlem mplmonmul mvrval eqcomd oveq2d 1nn0
        wb keepel a1i eqidd offval2 iftrue oveq12d 00id 3eqtr4a pm2.61i mpteq2i
        eqtr4d 3eqtr3rd cmnd mplrng syl2anc rngmgp simpr syl3anc syl5ibr expcom
        mgpplusg mulgnn0p1 a2d nn0ind mpcom ) LUJUKABCBULZHKHULZOUMZLUNUOZUPZUM
        ZFPUOZUPZLOMUQZIURZUMZUGABCUUIHKUUKUHULZUNUOZUPZUMZFPUOZUPZUUTUUQIURZUM
        ZUSABCUUIKUNUTZVEZUMZFPUOZUPZUNUUQIURZUMZUSABCUUIHKUUKUIULZUNUOZUPZUMZF
        PUOZUPZUVOUUQIURZUMZUSABCUUIHKUUKUVOVAVBURZUNUOZUPZUMZFPUOZUPZUWCUUQIUR
        ZUMZUSAUUSUSUHUILUUTUNUMZUVGUVNAUWKUVEUVLUVFUVMUWKBCUVDUVKUWKUVCUVJFPUW
        KUVBUVIUUIUWKUVBHKUNUPUVIUWKHKUVAUNUWKUVAUUKUNUNUOUNUUKUUTUNUNVCUUKUNVD
        VFVGHKUNVHVIVJVKVGUUTUNUUQIVLVMVNUUTUVOUMZUVGUWBAUWLUVEUVTUVFUWAUWLBCUV
        DUVSUWLUVCUVRFPUWLUVBUVQUUIUWLHKUVAUVPUUKUUTUVOUNVCVGVJVKVGUUTUVOUUQIVL
        VMVNUUTUWCUMZUVGUWJAUWMUVEUWHUVFUWIUWMBCUVDUWGUWMUVCUWFFPUWMUVBUWEUUIUW
        MHKUVAUWDUUKUUTUWCUNVCVGVJVKVGUUTUWCUUQIVLVMVNUUTLUMZUVGUUSAUWNUVEUUPUV
        FUURUWNBCUVDUUOUWNUVCUUNFPUWNUVBUUMUUIUWNHKUVAUULUUKUUTLUNVCVGVJVKVGUUT
        LUUQIVLVMVNAUVMDVOUQZUVLAUUQDVPUQZUKZUVMUWOUMAUWPDEKMNOQUDUWPVQZUAUEUFV
        RZUWPIJUUQUWOUWPDJUBUWRVSZDUWOJUBUWOVQZVTUCWAWBABCDEUWOFGKNPQRSTUXAUAUE
        WHWCUVOUJUKZAUWBUWJAUXBUWBUWJUSUWBUWJAUXBWDZUVTUUQDWEUQZURZUWAUUQUXDURZ
        UMUVTUWAUUQUXDVLUXCUWHUXEUWIUXFUXCUVTBCUUIHKUUKVAUNUOZUPZUMFPUOUPZUXDUR
        BCUUIUVQUXHVBWFURZUMZFPUOZUPUXEUWHUXCBUWPCDEUXDFGKNUVQUXHPQUWRSTRAKNUKZ
        UXBUAWGZAEWIUKZUXBUEWGZUXCUVQCUKZKUJUVQWJZUVQWKZWLWMZWNUKZUXCHKUVPUJUVQ
        UXCUUJKUKZWDZUXBUNUJUKUVPUJUKAUXBUYBWOWPUUKUVOUNUJWQWRZUVQVQWSZUXCUXSWT
        UVHXBWMZUXTWNUXCUXRUYFUXTUMUYEUVQKXAWBUXCOUTZWNUKUYFUYGXCUYFWNUKOXMUXCK
        UVPHUYGUNUXCUUJKUYGXBUKZWDZUUKXDZUVPUNUMUYIUUJOUYHUUJOXEUXCUUJKOXFXGXHU
        UKUVOUNXIZWBXJUYGUYFXNXKXLUXCUXMUXQUXRUYAWDYCUXNCGUVQKNRXOWBXPUXDVQZUXC
        UXMUXHCUKUXNHCGKNORXQWBXRUXCUXIUUQUVTUXDUXCUUQUXIUXCHCEFBGKMNOWIPUDRSTU
        XNUXPAOKUKUXBUFWGXSXTYAUXCBCUXLUWGUXCUXKUWFFPUXCUXJUWEUUIUXCUXJHKUVPUXG
        VBURZUPUWEUXCHKUVPUXGVBUVQUXHNUJUJUXNUYDUXGUJUKUYCUUKVAUNUJYBWPYDYEUXCU
        VQYFUXCUXHYFYGHKUYMUWDUUKUYMUWDUMUUKUYMUWCUWDUUKUVPUVOUXGVAVBUUKUVOUNYH
        UUKVAUNYHYIUUKUWCUNYHYNUYJUNUNVBURUNUYMUWDYJUYJUVPUNUXGUNVBUYKUUKVAUNXI
        YIUUKUWCUNXIYKYLYMVFVJVKVGYOUXCJYPUKZUXBUWQUWIUXFUMAUYNUXBADWIUKZUYNAUX
        MUXOUYOUAUEDEKNQYQYRDJUBYSWBWGAUXBYTAUWQUXBUWSWGUWPUXDIJUVOUUQUWTUCDUXD
        JUBUYLUUDUUEUUAVMUUBUUCUUFUUGUUH $.
    $}

    ${
      mplcoe2.r $e |- ( ph -> R e. CRing ) $.
      mplcoe2.y $e |- ( ph -> Y e. D ) $.
      $( Decompose a monomial into a finite product of powers of variables.
         (The assumption that ` R ` is a commutative ring is not strictly
         necessary, because the submonoid of monomials is in the center of the
         multiplicative monoid of polynomials, but it simplifies the proof.)
         (Contributed by Mario Carneiro, 10-Jan-2015.) $)
      mplcoe2 $p |- ( ph -> ( y e. D |-> if ( y = Y , .1. , .0. ) ) =
        ( G gsum ( k e. I |-> ( ( Y ` k ) .^ ( V ` k ) ) ) ) ) $=
        ( vi vw vx vz cv wceq cif cmpt ccnv cn cima wcel cfv cc0 co cgsu cn0 wf
        cfn wa wb psrbag syl mpbid simpld feqmptd iftrue adantl cdif eldif ifid
        wn cvv csn wss nn0supp eqimss suppssr ifeq2d syl5reqr anassrs pm2.61dan
        sylan2br mpteq2dva eqtr4d ifbid mpteq2dv cres cdm cnvimass fdm syl5sseq
        eqeq2d wi simprd wel cxp sseq1 eleq2 iffalse mpteq1 syl6eq eqid eqeq12d
        oveq2d imbi12d imbi2d weq ccrg caddc adantr ffvelrnda 0nn0 ifcl sylancl
        c0 fmptd suppss2 syl2anc eqeltrrd mpbir2and syl5ss eqidd nn0cnd oveq12d
        ssfi simpr 3eqtr4d wo eqtrd mvrcl mulgnn0cl syl3anc fveq2 a2d fconstmpt
        cur cun noel mtbiri syl6eqr mpt0 rngidval gsum0 crg crngrng mpl1 eqcomd
        a1d ssun1 sstr2 ax-mp imim1i cmulr oveq1 cof simprll eldifn simprr snss
        cbs ssun2 vex sylibr ffvelrnd snfi wne neneqd sylancr mplmonmul mplcoe3
        eldifsni offval2 addid2d elsni simprlr ad2antrr eqneltrd fveq2d addid1d
        sseldi elsn sylnib biorf elun orcom bitri syl6rbbr 3eqtr3rd mgpbas ccmn
        mgpplusg mplcrng crngmgp sselda cmnd cmnmnd adantlr syldan syl5ibr expr
        gsumunsn syl5 expcom findcard2s mpcom resmpt oveq1d eldifi sylan2 mulg0
        mpd gsumres 3eqtr2d ) ABCBUJZNUKZFOULZUMBCUXTUFKUFUJZNUNZUOUPZUQZUYCNUR
        ZUSULZUMZUKZFOULZUMZJHKHUJZNURZUYMLURZIUTZUMZVAUTZABCUYBUYKAUYAUYJFOANU
        YIUXTANUFKUYGUMUYIAUFKVBNAKVBNVCZUYEVDUQZANCUQZUYSUYTVEZUEAKMUQZVUAVUBV
        FTCGNKMQVGVHVIZVJZVKAUFKUYHUYGAUYCKUQZVEZUYFUYHUYGUKZUYFVUHVUGUYFUYGUSV
        LVMAVUFUYFVQZVUHVUFVUIVEAUYCKUYEVNZUQZVUHUYCKUYEVOAVUKVEZUYGUYFUYGUYGUL
        UYHUYFUYGVPVULUYFUYGUSUYGAKVBNUYEUYCUSVUEAUYDVRUSVSZVNZUPZUYEUKZVUOUYEV
        TAUYSVUPVUENKWAVHVUOUYEWBVHZWCWDWEWHWFWGWIWJWRWKWLAUYLJHUYEUYPUMZVAUTZJ
        UYQUYEWMZVAUTUYRAUYEKVTZUYLVUSUKZANWNZUYEKNUOWOAUYSVVCKUKVUEKVBNWPVHWQZ
        UYTAVVAVVBWSZAUYSUYTVUDWTZAUGUJZKVTZBCUXTUFKUFUGXAZUYGUSULZUMZUKZFOULZU
        MZJHVVGUYPUMZVAUTZUKZWSZWSAYAKVTZBCUXTKVUMXBZUKZFOULZUMZDUUBURZUKZWSZWS
        AUHUJZKVTZBCUXTUFKUFUHXAZUYGUSULZUMZUKZFOULZUMZJHVWGUYPUMZVAUTZUKZWSZWS
        AVWGUIUJZVSZUUCZKVTZBCUXTUFKUYCVXAUQZUYGUSULZUMZUKZFOULZUMZJHVXAUYPUMZV
        AUTZUKZWSZWSAVVEWSUGUHUIUYEVVGYAUKZVVRVWFAVXMVVHVVSVVQVWEVVGYAKXCVXMVVN
        VWCVVPVWDVXMBCVVMVWBVXMVVLVWAFOVXMVVKVVTUXTVXMVVKUFKUSUMVVTVXMUFKVVJUSV
        XMVVIVQVVJUSUKVXMVVIUYCYAUQUYCUUDVVGYAUYCXDUUEVVIUYGUSXEVHWLUFKUSUUAUUF
        WRWKWLVXMVVPJYAVAUTVWDVXMVVOYAJVAVXMVVOHYAUYPUMYAHVVGYAUYPXFHUYPUUGXGXJ
        JVWDDVWDJUAVWDXHZUUHZUUIXGXIXKXLUGUHXMZVVRVWRAVXPVVHVWHVVQVWQVVGVWGKXCV
        XPVVNVWNVVPVWPVXPBCVVMVWMVXPVVLVWLFOVXPVVKVWKUXTVXPUFKVVJVWJVXPVVIVWIUY
        GUSVVGVWGUYCXDWKWLWRWKWLVXPVVOVWOJVAHVVGVWGUYPXFXJXIXKXLVVGVXAUKZVVRVXL
        AVXQVVHVXBVVQVXKVVGVXAKXCVXQVVNVXHVVPVXJVXQBCVVMVXGVXQVVLVXFFOVXQVVKVXE
        UXTVXQUFKVVJVXDVXQVVIVXCUYGUSVVGVXAUYCXDWKWLWRWKWLVXQVVOVXIJVAHVVGVXAUY
        PXFXJXIXKXLVVGUYEUKZVVRVVEAVXRVVHVVAVVQVVBVVGUYEKXCVXRVVNUYLVVPVUSVXRBC
        VVMUYKVXRVVLUYJFOVXRVVKUYIUXTVXRUFKVVJUYHVXRVVIUYFUYGUSVVGUYEUYCXDWKWLW
        RWKWLVXRVVOVURJVAHVVGUYEUYPXFXJXIXKXLAVWEVVSAVWDVWCABCDEVWDFGKMOPQRSVXN
        TAEXNUQZEUUJUQZUDEUUKVHZUULUUMUUNVWGVDUQZUIUHXAVQZVEZAVWRVXLAVYDVWRVXLW
        SVWRVXBVWQWSAVYDVEZVXLVXBVWHVWQVWGVXAVTVXBVWHWSVWGVWTUUOZVWGVXAKUUPUUQU
        URVYEVXBVWQVXKAVYDVXBVWQVXKWSVWQVXKAVYDVXBVEZVEZVWNVWSNURZVWSLURZIUTZDU
        USURZUTZVWPVYKVYLUTZUKVWNVWPVYKVYLUUTVYHVXHVYMVXJVYNVYHVWNBCUXTUFKUFUIX
        MZVYIUSULZUMZUKFOULUMZVYLUTBCUXTVWKVYQXOUVAUTZUKZFOULZUMVYMVXHVYHBDUVFU
        RZCDEVYLFGKMVWKVYQOPWUBXHZRSQAVUCVYGTXPZAVXTVYGVYAXPZVYHVWKCUQZKVBVWKVC
        ZVWKUNZUOUPZVDUQZVYHUFKVWJVBVWKVYHVUFVEZUYGVBUQZUSVBUQZVWJVBUQZVYHKVBUY
        CNAUYSVYGVUEXPZXQZXRVWIUYGUSVBXSXTZVWKXHYBZVYHWUHVUNUPZWUIVDVYHWUGWUSWU
        IUKWURVWKKWAVHVYHVYBWUSVWGVTWUSVDUQAVYBVYCVXBUVBZVYHKVWJUFVWGUSVYHUYCKV
        WGVNUQZVEVWIVQZVWJUSUKZWVAWVBVYHUYCKVWGUVCVMVWIUYGUSXEZVHYCVWGWUSYKYDYE
        VYHVUCWUFWUGWUJVEVFWUDCGVWKKMQVGVHYFVYLXHZVYHVYQCUQZKVBVYQVCZVYQUNZUOUP
        ZVDUQZVYHUFKVYPVBVYQWUKVYIVBUQZWUMVYPVBUQVYHWVKVUFVYHKVBVWSNWUOVYHVWTKV
        TVWSKUQVYHVWTVXAKVWTVWGUVGZAVYDVXBUVDZYGVWSKUIUVHUVEUVIZUVJZXPXRVYOVYIU
        SVBXSXTZVYQXHYBZVYHWVHVUNUPZWVIVDVYHWVGWVRWVIUKWVQVYQKWAVHVYHVWTVDUQWVR
        VWTVTWVRVDUQVWSUVKVYHKVYPUFVWTUSVYHUYCKVWTVNUQZVEZVYOVQZVYPUSUKZWVTUYCV
        WSWVSUYCVWSUVLVYHUYCKVWSUVQVMUVMVYOVYIUSXEZVHYCVWTWVRYKUVNYEVYHVUCWVFWV
        GWVJVEVFWUDCGVYQKMQVGVHYFUVOVYHVYRVYKVWNVYLVYHBCDEFGUFIJKVYILMVWSOPQRSW
        UDUAUBUCWUEWVNWVOUVPXJVYHBCWUAVXGVYHVYTVXFFOVYHVYSVXEUXTVYHVYSUFKVWJVYP
        XOUTZUMVXEVYHUFKVWJVYPXOVWKVYQMVBVBWUDWUQWVPVYHVWKYHVYHVYQYHUVRVYHUFKWW
        DVXDWUKUYCVWTUQZWWDVXDUKWUKWWEVEZUSUYGXOUTUYGWWDVXDWWFUYGWWFUYGWUKWULWW
        EWUPXPYIUVSWWFVWJUSVYPUYGXOWWFWVBWVCWWFUYCVWSVWGWWEVYOWUKUYCVWSUVTVMZVY
        HVYCVUFWWEAVYBVYCVXBUWAZUWBUWCWVDVHWWFVYPVYIUYGWWFVYOVYPVYIUKWWGVYOVYIU
        SVLVHWWFUYCVWSNWWGUWDWJYJWWFVXCVXDUYGUKWWFVWTVXAUYCWVLWUKWWEYLUWFVXCUYG
        USVLVHYMWUKWWEVQZVEZVWJUSXOUTVWJWWDVXDWWJVWJWWJVWJWUKWUNWWIWUQXPYIUWEWW
        JVYPUSVWJXOWWJWWAWWBWWJWWEVYOWUKWWIYLUFVWSUWGUWHWWCVHXJWWJVXCVWIUYGUSWW
        IVXCVWIVFWUKWWIVWIWWEVWIYNZVXCWWEVWIUWIVXCVWIWWEYNWWKUYCVWGVWTUWJVWIWWE
        UWKUWLUWMVMWKYMWGWIYOWRWKWLUWNVYHVWGWUBVYLHJVWSKUYPVYKWUBDJUAWUCUWOZDVY
        LJUAWVEUWQAJUWPUQZVYGADXNUQZWWMAVUCVXSWWNTUDDEKMPUWRYDDJUAUWSVHZXPWUTVY
        HHUHXAUYMKUQZUYPWUBUQZVYHVWGKUYMVYHVWGVXAKVYFWVMYGUWTAWWPWWQVYGAWWPVEZJ
        UXAUQZUYNVBUQUYOWUBUQZWWQAWWSWWPAWWMWWSWWOJUXBVHZXPAKVBUYMNVUEXQWWRWUBD
        EKLMUYMPUCWUCAVUCWWPTXPAVXTWWPVYAXPAWWPYLYPZWUBIJUYNUYOWWLUBYQYRZUXCUXD
        WVNWWHVYHWWSWVKVYJWUBUQVYKWUBUQAWWSVYGWXAXPWVOVYHWUBDEKLMVWSPUCWUCWUDWU
        EWVNYPWUBIJVYIVYJWWLUBYQYRHUIXMUYNVYIUYOVYJIUYMVWSNYSUYMVWSLYSYJUXGXIUX
        EUXFYTUXHUXIYTUXJUXKUXQAVUTVURJVAAVVAVUTVURUKVVDHKUYEUYPUXLVHXJAKWUBUYQ
        JMUYEVWDWWLVXOWWOTAHKUYPWUBUYQWXCUYQXHYBAKUYPHUYEVWDAUYMVUJUQZVEZUYPUSU
        YOIUTZVWDWXEUYNUSUYOIAKVBNUYEUYMUSVUEVUQWCUXMWXEWWTWXFVWDUKWXDAWWPWWTUY
        MKUYEUXNWXBUXOWUBIJUYOVWDWWLVXOUBUXPVHYOYCZAUYTUYQUNVRVWDVSVNUPZUYEVTWX
        HVDUQVVFWXGUYEWXHYKYDUXRUXSYO $.
    $}
  $}

  ${
    $d k u v x z A $.  $d k u v x y z ph $.  $d f k y z R $.  $d k u v x z V $.
    $d f k u v x y z I $.  $d k u v x y z P $.  $d k z W $.
    mplbas2.p $e |- P = ( I mPoly R ) $.
    mplbas2.s $e |- S = ( I mPwSer R ) $.
    mplbas2.v $e |- V = ( I mVar R ) $.
    mplbas2.a $e |- A = ( AlgSpan ` S ) $.
    mplbas2.i $e |- ( ph -> I e. W ) $.
    mplbas2.r $e |- ( ph -> R e. CRing ) $.
    $( An alternative expression for the set of polynomials, as the smallest
       subalgebra of the set of power series that contains all the variable
       generators.  (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    mplbas2 $p |- ( ph -> ( A ` ran V ) = ( Base ` P ) ) $=
      ( cfv wcel wss eqid syl adantr vx vk vf vy vz vu vv crn cbs casa mplbasss
      psrassa a1i wf wfn cv wral ccrg crg crngrng mvrf wa simpr mvrcl ralrimiva
      ffn ffnfv sylanbrc aspss syl3anc csubrg clss wceq mplsubrg mpllss sseqtrd
      frn aspid ccnv cn cima cfn cn0 cmap co crab cur c0g cif cmpt cgsu mplcoe1
      cvsca cvv cabel mplrng syl2anc rngabl ovex rabex csubg syl6ss aspsubrg wb
      mplval2 subsubrg mpbir2and subrgsubg csca mpllmod ad2antrr asplss psrlmod
      clmod lsslss mplelf ffvelrnda mplsca fveq2d eleqtrd cmgp mplcoe2 rngidval
      cmg ccmn mplcrng crngmgp csubmnd fmptd csn cdif cc0 suppssr oveq1d eldifi
      adantl eqtrd suppss2 ssfi eqeltrd subrgsubm simplll psrbag biimpa aspssid
      simpld ad3antrrr fnfvelrn sylan sseldd mgpplusg subrgmcl syl3an1 subrg1cl
      cmulr mgpbas mulgnn0subcl simprd nn0supp eqimss mulg0 gsumsubmcl syl22anc
      3syl lssvscl mplelbas simprbi ssid mplmon lmod0vs sylan2 gsumsubgcl ssrdv
      ex eqssd ) AGUHZBOZCUIOZAUVQUVRBOZUVRAEUJPZUVREUIOZQZUVPUVRQZUVQUVSQADEFH
      JMNULZUWBAUWACDEUVRFIJUVRRZUWARZUKZUMAFUVRGUNZUWCAGFUOZUAUPZGOUVRPZUAFUQU
      WHAFUWAGUNUWIAUWADEFGHJKUWFMADURPZDUSPZNDUTSZVAFUWAGVFSZAUWKUAFAUWJFPZVBU
      VRCDFGHUWJIKUWEAFHPZUWPMTAUWMUWPUWNTAUWPVCVDVEUAFUVRGVGVHFUVRGVQSZBUVRUVP
      UWAELUWFVIVJAUVTUVREVKOZPZUVREVLOZPZUVSUVRVMUWDACDEUVRFHJIUWEMUWNVNZACDEU
      VRFHJIUWEMUWNVOZBUVRUXAUWAELUWFUXARZVRVJVPZAUAUVRUVQAUWJUVRPZUWJUVQPAUXGV
      BZUWJCUBUCUPVSVTWAWBPZUCWCFWDWEZWFZUBUPZUWJOZUDUXKUDUPUXLVMDWGOZDWHOZWIWJ
      ZCWMOZWEZWJZWKWEUVQUXHUDUVRUXKCDUXQUXNUCUBFHUWJUXOIUXKRZUXORZUXNRZAUWQUXG
      MTZUWEUXQRZAUWMUXGUWNTZAUXGVCZWLUXHUXKUVQUXSCWNCWHOZUYGRZACWOPZUXGACUSPZU
      YIAUWQUWMUYJMUWNCDFHIWPWQCWRSTUXKWNPUXHUXIUCUXJWCFWDWSWTUMAUVQCXAOPZUXGAU
      VQCVKOPZUYKAUYLUVQUWSPZUVQUVRQZAUVTUVPUWAQZUYMUWDAUVPUVRUWAUWRUWGXBZBUVPU
      WAELUWFXCWQUXFAUWTUYLUYMUYNVBXDUXCUVRUVQECCDEUVRFIJUWEXEZXFSXGZUVQCXHSTUX
      HUBUXKUXRUVQUXSUXHUXLUXKPZVBZCXNPZUVQCVLOZPZUXMCXIOZUIOZPUXPUVQPUXRUVQPAV
      UAUXGUYSAUWQUWMVUAMUWNCDFHIXJWQXKZAVUCUXGUYSAVUCUVQUXAPZUYNAUVTUYOVUGUWDU
      YPBUVPUXAUWAELUWFUXEXLWQUXFAEXNPUXBVUCVUGUYNVBXDADEFHJMUWNXMUXDUXAVUBUVRU
      VQECUYQUXEVUBRZXOWQXGXKUYTUXMDUIOZVUEUXHUXKVUIUXLUWJUXHUVRUXKCDUCFVUIUWJI
      VUIRUWEUXTUYFXPZXQUYTDVUDUIUXHDVUDVMUYSUXHCDFHUSIUYCUYEXRZTXSXTUYTUXPCYAO
      ZUEFUEUPZUXLOZVUMGOZVULYDOZWEZWJZWKWEUVQUYTUDUXKCDUXNUCUEVUPVULFGHUXLUXOI
      UXTUYAUYBUXHUWQUYSUYCTZVULRZVUPRZKUXHUWLUYSAUWLUXGNTTUXHUYSVCZYBUYTFUVQVU
      RVULHCWGOZCVVCVULVUTVVCRZYCZAVULYEPZUXGUYSACURPZVVFAUWQUWLVVGMNCDFHIYFWQC
      VULVUTYGSZXKVUSUYTUYLUVQVULYHOPAUYLUXGUYSUYRXKUVQCVULVUTUUASUYTUEFVUQUVQV
      URUYTVUMFPZVBZAVUNWCPVUOUVQPVUQUVQPAUXGUYSVVIUUBUYTFWCVUMUXLUYTFWCUXLUNZU
      XLVSZVTWAZWBPZUXHUYSVVKVVNVBZUXHUWQUYSVVOXDUYCUXKUCUXLFHUXTUUCSUUDZUUFZXQ
      VVJUVPUVQVUOAUVPUVQQZUXGUYSVVIAUVTUYOVVRUWDUYPBUVPUWAELUWFUUEWQUUGUYTUWIV
      VIVUOUVPPAUWIUXGUYSUWOXKFVUMGUUHUUIUUJAUFUGUVRCUUOOZUVQVUPVULVUNYEVUOVVCU
      VRCVULVUTUWEUUPZVVACVVSVULVUTVVSRZUUKVVHUXFAUYLUFUPZUVQPUGUPZUVQPVWBVWCVV
      SWEUVQPUYRUVQCVVSVWBVWCVWAUULUUMVVEAUYLVVCUVQPUYRUVQCVVCVVDUUNSUUQVJVURRY
      IUYTVVNVURVSWNVVCYJYKWAZVVMQVWDWBPUYTVVKVVNVVPUURUYTFVUQUEVVMVVCUYTVUMFVV
      MYKPZVBZVUQYLVUOVUPWEZVVCVWFVUNYLVUOVUPUYTFWCUXLVVMVUMYLVVQUYTVVKVVLWNYLY
      JYKWAZVVMVMVWHVVMQVVQUXLFUUSVWHVVMUUTUVDYMYNVWFVUOUVRPVWGVVCVMVWFUVRCDFGH
      VUMIKUWEUYTUWQVWEVUSTUYTUWMVWEUXHUWMUYSUYETZTVWEVVIUYTVUMFVVMYOYPVDUVRVUP
      VULVUOVVCVVTVVEVVAUVASYQYRVVMVWDYSWQUVBYTVUEVUBUXQUVQVUDCUXMUXPVUDRZUYDVU
      ERVUHUVEUVCUXSRYIUXHUWJVSWNUXOYJYKWAZWBPZUXSVSWNUYGYJYKWAZVWKQVWMWBPUXGVW
      LAUXGUWJUWAPVWLUWACDEUVRFUWJUXOIJUWFUYAUWEUVFUVGYPUXHUXKUXRUBVWKUYGUXHUXL
      UXKVWKYKPZVBZUXRVUDWHOZUXPUXQWEZUYGVWOUXMVWPUXPUXQVWOUXMUXOVWPUXHUXKVUIUW
      JVWKUXLUXOVUJVWKVWKQUXHVWKUVHUMYMUXHUXOVWPVMVWNUXHDVUDWHVUKXSTYQYNVWNUXHU
      YSVWQUYGVMZUXLUXKVWKYOUYTVUAUXPUVRPVWRVUFUYTUDUVRUXKCDUXNUCFHUXLUXOIUWEUY
      AUYBUXTVUSVWIVVBUVIUXQVUDVWPUVRCUXPUYGUWEVWJUYDVWPRUYHUVJWQUVKYQYRVWKVWMY
      SWQUVLYTUVNUVMUVO $.
  $}

  ${
    $d i r x y D $.  $d h i r w x y z I $.  $d x y ph $.  $d i r w x y z T $.
    ltbval.c $e |- C = ( T <bag I ) $.
    ltbval.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    ltbval.i $e |- ( ph -> I e. V ) $.
    ltbval.t $e |- ( ph -> T e. W ) $.
    $( Value of the well-order on finite bags.  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    ltbval $p |- ( ph -> C = { <. x , y >. | ( { x , y } C_ D /\
        E. z e. I ( ( x ` z ) < ( y ` z ) /\
          A. w e. I ( z T w -> ( x ` w ) = ( y ` w ) ) ) ) } ) $=
      ( cv wceq wa wcel vr vi cltb co cpr wss cfv clt wbr wi wral wrex cvv elex
      copab ccnv cn cima cfn cn0 cmap crab simpr oveq2d rabeq syl syl6eqr simpl
      sseq2d breqd imbi1d raleqbidv anbi2d rexeqbidv opabbidv df-ltbag vex prss
      anbi12d anbi1i opabbii cxp ovex rabex eqeltri xpex opabssxp ssexi ovmpt2a
      eqeltrri syl2an syl2anc syl5eq ) AFHJUCUDZBQZCQZUEZGUFZDQZWOUGWSWPUGUHUIZ
      WSEQZHUIZXAWOUGXAWPUGRZUJZEJUKZSZDJULZSZBCUOZMAHLTZJKTZWNXIRZPOXJHUMTJUMT
      XLXKHLUNJKUNUAUBHJUMUMWQIQUPUQURUSTZIUTUBQZVAUDZVBZUFZWTWSXAUAQZUIZXCUJZE
      XNUKZSZDXNULZSZBCUOXIUCXRHRZXNJRZSZYDXHBCYGXQWRYCXGYGXPGWQYGXPXMIUTJVAUDZ
      VBZGYGXOYHRXPYIRYGXNJUTVAYEYFVCZVDXMIXOYHVEVFNVGVIYGYBXFDXNJYJYGYAXEWTYGX
      TXDEXNJYJYGXSXBXCYGXRHWSXAYEYFVHVJVKVLVMVNVSVOBCDEIUBUAVPWOGTWPGTSZXGSZBC
      UOZXIUMYLXHBCYKWRXGWOWPGBVQCVQVRVTWAYMGGWBGGGYIUMNXMIYHUTJVAWCWDWEZYNWFXG
      BCGGWGWHWJWIWKWLWM $.

    ltbwe.w $e |- ( ph -> T We I ) $.
    $( The finite bag order is a well-order, given a well-order of the index
       set.  (Contributed by Mario Carneiro, 2-Jun-2015.) $)
    ltbwe $p |- ( ph -> C We D ) $=
      ( vx vy cfv clt cn0 cc0 wcel vz vw wwe cv wbr wceq wi wral wrex copab cxp
      wa cin coi chash com cres eqid ccnv cn cima cfn cmap co crab cvv csn cdif
      cnveq imaeq1d eleq1d cbvrabv elmapi nn0supp syl rabbiia 3eqtr4i cuz nn0uz
      wf ltweuz weeq2 mpbiri mp1i c0 0nn0 ne0i 0z hashgval2 om2uzoi oieq2 ax-mp
      wne eqtr4i peano1 fvres hash0 eqtr2i wemapwe weinxp sylib wb ltbval df-xp
      cpr wss vex prss opabbii ineq1i inopab incom 3eqtr3i syl6eq weeq1 mpbird
      ) ACBUCZCUAUDZNUDZPXROUDZPQUEXRUBUDZDUEYAXSPYAXTPUFUGUBFUHULUAFUIZNOUJZCC
      UKZUMZUCZACYCUCYFANOUAUBFRDQYCCFDUNZUOUPUQZSYCUREUDZUSZUTVAZVBTZERFVCVDZV
      EXSUSZUTVAZVBTZNYMVECYNVFSVGVHVAZVBTZNYMVEYLYPENYMYIXSUFZYKYOVBYSYJYNUTYI
      XSVIVJVKVLJYRYPNYMXSYMTZYQYOVBYTFRXSVTYQYOUFXSRFVMXSFVNVOVKVPVQMRSVRPZUFZ
      RQUCZAVSUUBUUCUUAQUCSWARUUAQWBWCWDSRTRWEWMAWFRSWGWDYGURYHUUAQUNZRQUNZNSYH
      WHNWIWJUUBUUEUUDUFVSRUUAQWKWLWNWEYHPZWEUOPZSWEUPTUUFUUGUFWOWEUPUOWPWLWQWR
      WSCYCWTXAABYEUFXQYFXBABXSXTXECXFZYBULNOUJZYEANOUAUBBCDEFGHIJKLXCUUHNOUJZY
      CUMYDYCUMUUIYEUUJYDYCYDXSCTXTCTULZNOUJUUJNOCCXDUUKUUHNOXSXTCNXGOXGXHXIWRX
      JUUHYBNOXKYDYCXLXMXNCBYEXOVOXP $.
  $}

  ${
    $d r .<_ $.  $d i p s B $.  $d d h i p r s w x y z I $.  $d r w x y z ph $.
    $d d i p s .< $.  $d d i p s w z D $.  $d i p r s S $.  $d r w x y z T $.
    $d d i p r s w x y z R $.
    $( Lemma for ordered power series.  (Contributed by Stefan O'Rear,
       2-Oct-2015.) $)
    reldmopsr $p |- Rel dom ordPwSer $=
      ( vi vs vr vp vx vy vz vw vd vh cvv cv cxp cpw cmps co cfv wbr wceq wa wi
      cnx cple cpr cbs wss cplt cltb wral wrex ccnv cima cfn wcel cn0 cmap crab
      cn wsbc wo copab cop csts csb cmpt copws df-opsr reldmmpt2 ) ABKKCALZVIMN
      DVIBLZOPDLZUBUCQELZFLZUDVKUEQUFGLZVLQVNVMQVJUGQRHLZVNCLVIUHPRVOVLQVOVMQSU
      AHILZUITGVPUJIJLUKURULUMUNJUOVIUPPUQUSVLVMSUTTEFVAVBVCPVDVEVFEFGHJABCDIVG
      VH $.

    opsrval.s $e |- S = ( I mPwSer R ) $.
    opsrval.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrval.b $e |- B = ( Base ` S ) $.
    opsrval.q $e |- .< = ( lt ` R ) $.
    opsrval.c $e |- C = ( T <bag I ) $.
    opsrval.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    opsrval.l $e |- .<_ = { <. x , y >. | ( { x , y } C_ B /\
      ( E. z e. D ( ( x ` z ) .< ( y ` z ) /\
        A. w e. D ( w C z -> ( x ` w ) = ( y ` w ) ) ) \/ x = y ) ) } $.
    opsrval.i $e |- ( ph -> I e. V ) $.
    opsrval.r $e |- ( ph -> R e. W ) $.
    opsrval.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    $( The value of the "ordered power series" function.  This is the same as
       ` mPwSer ` ~ psrval , but with the addition of a well-order on ` I ` we
       can turn a strict order on ` R ` into a strict order on the power series
       structure.  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
    opsrval $p |- ( ph -> O = ( S sSet <. ( le ` ndx ) , .<_ >. ) ) $=
      ( vr vi vs vp vd copws co cfv cnx cple cop csts cv cpr wss cltb wceq wral
      wbr wi wa wrex wo copab cxp cpw cvv wcel cmpt elex syl xpexg pwexg mptexg
      syl2anc 3syl cmps cbs cplt ccnv cima cfn cn0 cmap crab wsbc simpl xpeq12d
      cn csb pweqd ovex a1i oveq12 sylan9eqr syl6eqr fveq2d sseq2d rabex adantr
      id oveq2d rabeq simpllr imbi1d raleqbidv anbi12d rexeqbidv sbcied2 orbi1d
      opabbidv opeq2d oveq12d csbied mpteq12dv df-opsr ovmpt2ga syl3anc ralbidv
      simpr breqd oveq1d anbi2d rexbidv wb elpw2g mpbird fvmptd syl5eq ) APLNIU
      NUOZUPJUQURUPZOUSZUTUOZTAUILJYSBVAZCVAZVBZFVCZDVAZUUBUPZUUFUUCUPZKVGZEVAZ
      UUFUIVAZNVDUOZVGZUUJUUBUPUUJUUCUPVEZVHZEHVFZVIZDHVJZUUBUUCVEZVKZVIZBCVLZU
      SZUTUOZUUANNVMZVNZYRVOANVOVPZIVOVPZUIUVFUVDVQZVOVPZYRUVIVEANQVPZUVGUFNQVR
      VSAIRVPUVHUGIRVRVSAUVEVOVPZUVFVOVPUVJAUVKUVKUVLUFUFNNQQVTWCZUVEVOWAUIUVFU
      VDVOWBWDUJUKNIVOVOUIUJVAZUVNVMZVNZULUVNUKVAZWEUOZULVAZYSUUDUVSWFUPZVCZUUG
      UUHUVQWGUPZVGZUUJUUFUUKUVNVDUOZVGZUUNVHZEUMVAZVFZVIZDUWGVJZUMMVAWHWQWIWJV
      PZMWKUVNWLUOZWMZWNZUUSVKZVIZBCVLZUSZUTUOZWRZVQUVIUNVOUVNNVEZUVQIVEZVIZUIU
      VPUWTUVFUVDUXCUVOUVEUXCUVNNUVNNUXAUXBWOZUXDWPWSUXCULUVRUWSUVDVOUVRVOVPUXC
      UVNUVQWEWTXAUXCUVSUVRVEZVIZUVSJUWRUVCUTUXFUVSNIWEUOZJUXEUXCUVSUVRUXGUXEXI
      UVNNUVQIWEXBXCSXDZUXFUWQUVBYSUXFUWPUVABCUXFUWAUUEUWOUUTUXFUVTFUUDUXFUVTJW
      FUPFUXFUVSJWFUXHXEUAXDXFUXFUWNUURUUSUXFUWJUURUMUWMHVOUWMVOVPUXFUWKMUWLWKU
      VNWLWTXGXAUXFUWMUWKMWKNWLUOZWMZHUXFUWLUXIVEUWMUXJVEUXFUVNNWKWLUXCUXAUXEUX
      DXHZXJUWKMUWLUXIXKVSUDXDUXFUWGHVEZVIZUWIUUQDUWGHUXFUXLYHZUXMUWCUUIUWHUUPU
      XMUWBKUUGUUHUXMUWBIWGUPKUXMUVQIWGUXAUXBUXEUXLXLXEUBXDYIUXMUWFUUOEUWGHUXNU
      XMUWEUUMUUNUXMUWDUULUUJUUFUXMUVNNUUKVDUXFUXAUXLUXKXHXJYIXMXNXOXPXQXRXOXSX
      TYAYBYCBCDEMUJUKUIULUMYDYEYFAUUKLVEZVIZUVCYTJUTUXPUVBOYSUXPUVBUUEUUIUUJUU
      FGVGZUUNVHZEHVFZVIZDHVJZUUSVKZVIZBCVLOUXPUVAUYCBCUXPUUTUYBUUEUXPUURUYAUUS
      UXPUUQUXTDHUXPUUPUXSUUIUXPUUOUXREHUXPUUMUXQUUNUXPUULGUUJUUFUXPUULLNVDUOGU
      XPUUKLNVDAUXOYHYJUCXDYIXMYGYKYLXRYKXSUEXDXTXJALUVFVPZLUVEVCZUHAUVLUYDUYEY
      MUVMLUVEVOYNVSYOUUAVOVPAJYTUTWTXAYPYQ $.
  $}

  ${
    $d u x y B $.  $d u C $.  $d u w z D $.  $d h w x y z I $.  $d w x y z R $.
    $d w x y z ph $.  $d u Q $.  $d u S $.  $d w x y z T $.
    opsrle.s $e |- S = ( I mPwSer R ) $.
    opsrle.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrle.b $e |- B = ( Base ` S ) $.
    opsrle.q $e |- .< = ( lt ` R ) $.
    opsrle.c $e |- C = ( T <bag I ) $.
    opsrle.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    opsrle.l $e |- .<_ = ( le ` O ) $.
    opsrle.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    $( An alternative expression for the set of polynomials, as the smallest
       subalgebra of the set of power series that contains all the variable
       generators.  (Contributed by Mario Carneiro, 8-Feb-2015.)  (Revised by
       Mario Carneiro, 2-Oct-2015.) $)
    opsrle $p |- ( ph -> .<_ = { <. x , y >. | ( { x , y } C_ B /\
      ( E. z e. D ( ( x ` z ) .< ( y ` z ) /\
        A. w e. D ( w C z -> ( x ` w ) = ( y ` w ) ) ) \/ x = y ) ) } ) $=
      ( cvv wcel wa cv cpr wss cfv wbr wceq wi wral wrex wo copab cple cnx csts
      cop co eqid simprl simprr cxp adantr opsrval fveq2d cmps ovex eqeltri cbs
      fvex xpex vex anbi1i opabbii opabssxp eqsstr3i ssexi pleid setsid 3eqtr4g
      prss mp2an wn c0 copws reldmopsr adantl fveq1d syl5eq 0fv syl6eq reldmpsr
      ovprc str0 base0 xpeq2d xp0 sseq0 sylancr eqtr4d pm2.61dan ) ANUEUFZIUEUF
      ZUGZOBUHZCUHZUIFUJZDUHZXJUKXMXKUKKULEUHZXMGULXNXJUKXNXKUKUMUNEHUOUGDHUPXJ
      XKUMUQZUGZBCURZUMAXIUGZPUSUKZJUTUSUKZXQVBVAVCZUSUKZOXQXRPYAUSXRBCDEFGHIJK
      LMNXQPUEUEQRSTUAUBXQVDAXGXHVEAXGXHVFALNNVGUJXIUDVHVIVJUCJUEUFXQUEUFXQYBUM
      JNIVKVCZUEQNIVKVLVMXQFFVGZFFFJVNUKZUESJVNVOVMZYFVPXQXJFUFXKFUFUGZXOUGZBCU
      RYDYHXPBCYGXLXOXJXKFBVQCVQWFVRVSXOBCFFVTWAZWBUEXQUSUEJWCWDWGWEAXIWHZUGZOW
      IXQYKXSWIUSUKOWIYKPWIUSYKPLWIUKZWIYKPLNIWJVCZUKYLRYKLYMWIYJYMWIUMANIWJWKW
      RWLWMWNLWOWPVJUCUSXTWCWSWEYKXQYDUJYDWIUMXQWIUMYIYKYDFWIVGWIYKFWIFYKYEWIVN
      UKFWIYKJWIVNYKJYCWIQYJYCWIUMANIVKWQWRWLWNVJSWTWEXAFXBWPXQYDXCXDXEXF $.
  $}

  ${
    $d h w x y z I $.  $d w x y z R $.  $d x y S $.  $d w x y z T $.  $d z W $.
    $d w x y z ph $.  $d x z V $.
    opsrval2.s $e |- S = ( I mPwSer R ) $.
    opsrval2.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrval2.l $e |- .<_ = ( le ` O ) $.
    opsrval2.i $e |- ( ph -> I e. V ) $.
    opsrval2.r $e |- ( ph -> R e. W ) $.
    opsrval2.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    $( Self-referential expression for the ordered power series structure.
       (Contributed by Mario Carneiro, 8-Feb-2015.) $)
    opsrval2 $p |- ( ph -> O = ( S sSet <. ( le ` ndx ) , .<_ >. ) ) $=
      ( vx vy cfv cv eqid vz vw vh cnx cple cpr cbs wss cplt wbr cltb wceq ccnv
      co wi cn cima cfn wcel cn0 cmap crab wral wa wrex wo copab opsrval opsrle
      cop csts opeq2d oveq2d eqtr4d ) AGCUDUERZPSZQSZUFCUGRZUHUASZVPRVSVQRBUIRZ
      UJUBSZVSDEUKUNZUJWAVPRWAVQRULUOUBUCSUMUPUQURUSUCUTEVAUNVBZVCVDUAWCVEVPVQU
      LVFVDPQVGZVJZVKUNCVOFVJZVKUNAPQUAUBVRWBWCBCVTDUCEWDGHIJKVRTZVTTZWBTZWCTZW
      DTMNOVHAWFWECVKAFWDVOAPQUAUBVRWBWCBCVTDUCEFGJKWGWHWIWJLOVIVLVMVN $.
  $}

  ${
    $d s E $.  $d s N $.  $d s O $.  $d s S $.
    opsrbas.s $e |- S = ( I mPwSer R ) $.
    opsrbas.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrbas.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    ${
      opsrbaslem.1 $e |- E = Slot N $.
      opsrbaslem.2 $e |- N e. NN $.
      opsrbaslem.3 $e |- N < 10 $.
      $( Get a component of the ordered power series structure.  (Contributed
         by Mario Carneiro, 8-Feb-2015.)  (Revised by Mario Carneiro,
         2-Oct-2015.) $)
      opsrbaslem $p |- ( ph -> ( E ` S ) = ( E ` O ) ) $=
        ( cvv wa cfv co c10 c0 wcel wceq cnx cple cop csts simprl simprr adantr
        eqid cxp wss opsrval2 fveq2d ndxid wne nnrei ltneii ndxarg plendx mpbir
        neeq12i setsnid syl6reqr cmps copws 0fv eqcomi reldmpsr ovprc reldmopsr
        wn fveq1d 3eqtr4a adantl 3eqtr4g pm2.61dan ) AFOUAZBOUAZPZCEQZHEQZUBAVT
        PZWBCUCUDQZHUDQZUEUFRZEQWAWCHWFEWCBCDFWEHOOIJWEUJAVRVSUGAVRVSUHADFFUKUL
        VTKUIUMUNWEWDECEGLMUOUCEQZWDUPGSUPGSGMUQNURWGGWDSEGLMUSUTVBVAVCVDAVTVLZ
        PZCHEWIFBVERZDFBVFRZQZCHWHWJWLUBAWHTDTQZWJWLWMTDVGVHFBVEVIVJWHDWKTFBVFV
        KVJVMVNVOIJVPUNVQ $.
    $}

    $( The base set of the ordered power series structure.  (Contributed by
       Mario Carneiro, 8-Feb-2015.)  (Revised by Mario Carneiro,
       30-Aug-2015.) $)
    opsrbas $p |- ( ph -> ( Base ` S ) = ( Base ` O ) ) $=
      ( cbs c1 df-base 1nn 1lt10 opsrbaslem ) ABCDJEKFGHILMNO $.

    $( The addition operation of the ordered power series structure.
       (Contributed by Mario Carneiro, 8-Feb-2015.)  (Revised by Mario
       Carneiro, 30-Aug-2015.) $)
    opsrplusg $p |- ( ph -> ( +g ` S ) = ( +g ` O ) ) $=
      ( cplusg c2 df-plusg 2nn 2lt10 opsrbaslem ) ABCDJEKFGHILMNO $.

    $( The multiplication operation of the ordered power series structure.
       (Contributed by Mario Carneiro, 8-Feb-2015.)  (Revised by Mario
       Carneiro, 30-Aug-2015.) $)
    opsrmulr $p |- ( ph -> ( .r ` S ) = ( .r ` O ) ) $=
      ( cmulr c3 df-mulr 3nn 3lt10 opsrbaslem ) ABCDJEKFGHILMNO $.

    $( The scalar product operation of the ordered power series structure.
       (Contributed by Mario Carneiro, 8-Feb-2015.)  (Revised by Mario
       Carneiro, 30-Aug-2015.) $)
    opsrvsca $p |- ( ph -> ( .s ` S ) = ( .s ` O ) ) $=
      ( cvsca c6 df-vsca 6nn 6lt10 opsrbaslem ) ABCDJEKFGHILMNO $.

    opsrsca.i $e |- ( ph -> I e. V ) $.
    opsrsca.r $e |- ( ph -> R e. W ) $.
    $( The scalar ring of the ordered power series structure.  (Contributed by
       Mario Carneiro, 8-Feb-2015.)  (Revised by Mario Carneiro,
       30-Aug-2015.) $)
    opsrsca $p |- ( ph -> R = ( Scalar ` O ) ) $=
      ( csca cfv psrsca c5 df-sca 5nn 5lt10 opsrbaslem eqtrd ) ABCNOFNOABCEGHIL
      MPABCDNEQFIJKRSTUAUB $.
  $}

  ${
    $d a b x y B $.  $d w x y z C $.  $d h w x y z I $.  $d a b w x y z ph $.
    $d w x y z D $.  $d w x y z .< $.  $d w x y z R $.  $d w x y z T $.
    $d a b ps $.
    opsrso.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrso.i $e |- ( ph -> I e. V ) $.
    opsrso.r $e |- ( ph -> R e. Toset ) $.
    opsrso.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    opsrso.w $e |- ( ph -> T We I ) $.
    ${
      opsrtoslem.s $e |- S = ( I mPwSer R ) $.
      opsrtoslem.b $e |- B = ( Base ` S ) $.
      opsrtoslem.q $e |- .< = ( lt ` R ) $.
      opsrtoslem.c $e |- C = ( T <bag I ) $.
      opsrtoslem.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
      opsrtoslem.ps $e |- ( ps <-> E. z e. D ( ( x ` z ) .< ( y ` z ) /\
        A. w e. D ( w C z -> ( x ` w ) = ( y ` w ) ) ) ) $.
      opsrtoslem.l $e |- .<_ = ( le ` O ) $.
      $( Lemma for ~ opsrtos .  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
      opsrtoslem1 $p |- ( ph -> .<_ =
        ( ( { <. x , y >. | ps } i^i ( B X. B ) ) u. ( _I |` B ) ) ) $=
        ( cv cpr wss cfv wbr wceq wi wral wa wrex weq wo copab cxp cin cid cres
        cun opsrle unopab wcel inopab df-xp ineq2i vex prss anbi1i ancom bitr3i
        opabbii 3eqtr4i equcom anbi2i eleq1 biimpac pm4.71i an32 3bitri uneq12i
        opabresid eqtr3i orbi1i andi 3eqtr4ri syl6eq ) APCUKZDUKZULGUMZEUKZWPUN
        WSWQUNLUOFUKZWSHUOWTWPUNWTWQUNUPUQFIURUSEIUTZCDVAZVBZUSZCDVCZBCDVCZGGVD
        ZVEZVFGVGZVHZACDEFGHIJKLMNOPQUDSUEUFUGUHUJUBVIWRBUSZCDVCZWRXBUSZCDVCZVH
        XKXMVBZCDVCXJXEXKXMCDVJXHXLXIXNXFWPGVKZWQGVKZUSZCDVCZVEBXRUSZCDVCXHXLBX
        RCDVLXGXSXFCDGGVMVNXKXTCDXKXRBUSXTXRWRBWPWQGCVODVOVPZVQXRBVRVSVTWAXPDCV
        AZUSZCDVCXIXNCDGWJYCXMCDYCXPXBUSZXQUSZXRXBUSXMYCYDYEXBYBXPCDWBWCYDXQXBX
        PXQWPWQGWDWEWFVSXPXBXQWGXRWRXBYAVQWHVTWKWIXDXOCDXDWRBXBVBZUSXOYFXCWRBXA
        XBUIWLWCWRBXBWMVSVTWNWO $.

      $( Lemma for ~ opsrtos .  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
      opsrtoslem2 $p |- ( ph -> O e. Toset ) $=
        ( va cbs cfv cplt wor cid cres wss ctos wcel copab cxp cin cmap cvv wwe
        vb co cv ccnv cn cima cfn cn0 crab ovex rabex eqeltri a1i xpexg syl2anc
        ssexd ltbwe cple wa eqid tosso ibi syl simpld wceq wi wral wrex opabbii
        wbr wemapso syl3anc wb psrbas soeq2 mpbird soinxp sylib cdif copws fvex
        pltfval ax-mp cun c0 difundir ssdif0 mpbi uneq2i un0 3eqtri opsrtoslem1
        resss difeq1d wrel inss2 relxp relss mp2 cop df-br vex ideq bitr3i brin
        wn simprbi brxp sonr ex syl2im pm2.01d breq2 syl5eq syl6bb notbid con2d
        syl5ibcom syl5bi opex eldif mpbiran syl6ibr relssdv disj2 disj3 3eqtr4a
        sylibr soeq1 opsrbas mpbid reseq2d ssun2 syl6eqssr sseqtr4d sylanbrc )
        AQULUMZQUNUMZUOZUPUVCUQZPURZQUSUTZAGUVDUOZUVEAUVIGBCDVAZGGVBZVCZUOZAGUV
        JUOZUVMAUVNJULUMZIVDVHZUVJUOZAIVEUTZIHVFUVOLUOZUVQUVRAINVIVJVKVLVMUTZNV
        NOVDVHZVOVEUHUVTNUWAVNOVDVPVQVRVSAHIMNORVEUGUHTAMOOVBZVEAORUTZUWCUWBVEU
        TTTOORRVTWAUBWBUCWCAUVSUPUVOUQJWDUMZURZAJUSUTZUVSUWEWEZUAUWFUWGUVOLJUWD
        USUVOWFZUWDWFUFWGWHWIWJCDEFIUVOHLUVJVEBEVIZCVIZUMUWIDVIZUMLWPFVIZUWIHWP
        UWLUWJUMUWLUWKUMWKWLFIWMWEEIWNCDUIWOWQWRAGUVPWKUVNUVQWSAGIJKNOUVORUDUWH
        UHUETWTGUVPUVJXAWIXBGUVJXCXDZAUVDUVLWKUVIUVMWSAUVDPUPXEZUVLQVEUTZUVDUWN
        WKQMOJXFVHZUMVESMUWPXGVRZVEUVDQPUJUVDWFZXHXIAUVLUPGUQZXJZUPXEZUVLUPXEZU
        WNUVLUXAUXBUWSUPXEZXJUXBXKXJUXBUVLUWSUPXLUXCXKUXBUWSUPURUXCXKWKUPGXSUWS
        UPXMXNXOUXBXPXQAPUWTUPABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJXRZXTAUVL
        UPVCXKWKZUVLUXBWKAUVLVEUPXEZURUXEAUKVGUVLUXFUVLYAZAUVLUVKURUVKYAUXGUVJU
        VKYBGGYCUVLUVKYDYEVSAUKVIZVGVIZYFZUVLUTZUXJUPUTZYLZUXJUXFUTZAUXLUXKUXLU
        XHUXIWKZAUXKYLZUXLUXHUXIUPWPUXOUXHUXIUPYGUXHUXIVGYHYIYJAUXHUXHUVLWPZYLZ
        UXOUXPAUXQAUVMUXQUXHGUTZUXRUWMUXQUXHUXHUVKWPZUXSUXQUXHUXHUVJWPUXTUXHUXH
        UVJUVKYKYMUXTUXSUXSUXHUXHGGYNYMWIUVMUXSUXRGUXHUVLYOYPYQYRUXOUXQUXKUXOUX
        QUXHUXIUVLWPUXKUXHUXIUXHUVLYSUXHUXIUVLYGUUAUUBUUDUUEUUCUXNUXJVEUTUXMUXH
        UXIUUFUXJVEUPUUGUUHUUIUUJUVLUPUUKUUNUVLUPUULXDUUMYTGUVDUVLUUOWIXBAGUVCW
        KUVIUVEWSAGKULUMUVCUEAJKMOQUDSUBUUPYTZGUVCUVDXAWIUUQAUVFUWTPAUVFUWSUWTA
        GUVCUPUYAUURUWSUVLUUSUUTUXDUVAUWOUVHUVEUVGWEWSUWQUVCUVDQPVEUVCWFUJUWRWG
        XIUVB $.
    $}

    $( The ordered power series structure is a totally ordered set.
       (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    opsrtos $p |- ( ph -> O e. Toset ) $=
      ( vz vx vy vw vh cv cfv co eqid cplt wbr cltb wceq ccnv cima cfn wcel cn0
      wi cn cmap crab wral wa wrex cmps cbs cple biid opsrtoslem2 ) ALQZMQZRVBN
      QZRBUARZUBOQZVBCDUCSZUBVFVCRVFVDRUDUJOPQUEUKUFUGUHPUIDULSUMZUNUOLVHUPZMNL
      ODBUQSZURRZVGVHBVJVECPDEUSRZEFGHIJKVJTVKTVETVGTVHTVIUTVLTVA $.

    opsrso.l $e |- .<_ = ( lt ` O ) $.
    opsrso.b $e |- B = ( Base ` O ) $.
    $( The ordered power series structure is a totally ordered set.
       (Contributed by Mario Carneiro, 10-Jan-2015.) $)
    opsrso $p |- ( ph -> .<_ Or B ) $=
      ( wor cid cres cple ctos cfv wss wcel opsrtos eqid tosso ibi syl simpld
      wa ) ABFPZQBRGSUAZUBZAGTUCZUKUMUJZACDEGHIJKLMUDUNUOBFGULTOULUENUFUGUHUI
      $.
  $}

  ${
    $d x y I $.  $d x y O $.  $d x y ph $.  $d x y R $.
    opsrcrng.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrcrng.i $e |- ( ph -> I e. V ) $.
    opsrcrng.r $e |- ( ph -> R e. CRing ) $.
    opsrcrng.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    $( The ring of ordered power series is commutative ring.  (Contributed by
       Mario Carneiro, 10-Jan-2015.) $)
    opsrcrng $p |- ( ph -> O e. CRing ) $=
      ( vx vy cmps ccrg wcel cfv cv cplusg proplem3 cmulr co eqid psrcrng eqidd
      cbs opsrbas wa opsrplusg opsrmulr crngpropd mpbid ) ADBMUAZNOENOABULDFULU
      BZHIUCAKLULUEPZULEAUNUDABULCDEUMGJUFAKQUNOLQUNOUGZKLULRPERPABULCDEUMGJUHS
      AUOKLULTPETPABULCDEUMGJUISUJUK $.

    $( The ring of ordered power series is an associative algebra.
       (Contributed by Mario Carneiro, 29-Dec-2014.) $)
    opsrassa $p |- ( ph -> O e. AssAlg ) $=
      ( vx vy casa wcel eqid cbs cfv cv wa proplem3 cmps psrassa opsrbas cplusg
      co eqidd opsrplusg cmulr opsrmulr psrsca opsrsca cvsca opsrvsca assapropd
      ccrg mpbid ) ADBUAUEZMNEMNABUQDFUQOZHIUBAKLUQPQZBPQZBUQEAUSUFABUQCDEURGJU
      CAKRZUSNLRUSNZSZKLUQUDQEUDQABUQCDEURGJUGTAVCKLUQUHQEUHQABUQCDEURGJUITABUQ
      DFUOURHIUJABUQCDEFUOURGJHIUKUTOAVAUTNVBSKLUQULQEULQABUQCDEURGJUMTUNUP $.
  $}

  ${
    $d f i r w $.
    mplrcl.p $e |- P = ( I mPoly R ) $.
    mplrcl.b $e |- B = ( Base ` P ) $.
    $( Reverse closure for the polynomial index set.  (Contributed by Stefan
       O'Rear, 19-Mar-2015.)  (Revised by Mario Carneiro, 30-Aug-2015.) $)
    mplrcl $p |- ( X e. B -> I e. _V ) $=
      ( cvv wcel wn c0 noel cbs cfv cmpl co reldmmpl ovprc1 syl5eq fveq2d base0
      3eqtr4g eleq2d mtbiri con4i ) DHIZEAIZUFJZUGEKIELUHAKEUHBMNKMNAKUHBKMUHBD
      COPKFDCOQRSTGUAUBUCUDUE $.

    mplelsfi.z $e |- .0. = ( 0g ` R ) $.
    mplelsfi.f $e |- ( ph -> F e. B ) $.
    mplelsfi.r $e |- ( ph -> R e. V ) $.
    $( A polynomial treated as a coefficient function has finitely many nonzero
       terms.  (Contributed by Stefan O'Rear, 22-Mar-2015.) $)
    mplelsfi $p |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $=
      ( wcel ccnv cvv csn cdif cima eqid cfn cmps cbs cfv mplelbas simprbi syl
      co ) AEBNZEOPHQRSUANZLUIEFDUBUHZUCUDZNUJULCDUKBFEHIUKTULTKJUEUFUG $.
  $}

  ${
    $d ph x $.  $d B x $.  $d I x $.  $d V x $.
    mvrf2.p $e |- P = ( I mPoly R ) $.
    mvrf2.v $e |- V = ( I mVar R ) $.
    mvrf2.b $e |- B = ( Base ` P ) $.
    mvrf2.i $e |- ( ph -> I e. W ) $.
    mvrf2.r $e |- ( ph -> R e. Ring ) $.
    $( The power series/polynomial variable function maps indices to
       polynomials.  (Contributed by Stefan O'Rear, 8-Mar-2015.) $)
    mvrf2 $p |- ( ph -> V : I --> B ) $=
      ( vx wfn cv cfv wcel wf eqid adantr wral cmps co cbs ffn syl wa crg simpr
      mvrf mvrcl ralrimiva ffnfv sylanbrc ) AFENZMOZFPBQZMEUAEBFRAEEDUBUCZUDPZF
      RUOAUSDUREFGURSIUSSKLUJEUSFUEUFAUQMEAUPEQZUGBCDEFGUPHIJAEGQUTKTADUHQUTLTA
      UTUIUKULMEBFUMUN $.
  $}

  ${
    $d ph y $.  $d B y $.  $d D y $.  $d I f $.  $d K f y $.  $d .1. y $.
    $d R y $.  $d X y $.  $d .0. y $.
    mplmon2.p $e |- P = ( I mPoly R ) $.
    mplmon2.v $e |- .x. = ( .s ` P ) $.
    mplmon2.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplmon2.o $e |- .1. = ( 1r ` R ) $.
    mplmon2.z $e |- .0. = ( 0g ` R ) $.
    mplmon2.b $e |- B = ( Base ` R ) $.
    mplmon2.i $e |- ( ph -> I e. W ) $.
    mplmon2.r $e |- ( ph -> R e. Ring ) $.
    mplmon2.k $e |- ( ph -> K e. D ) $.
    mplmon2.x $e |- ( ph -> X e. B ) $.
    $( Express a scaled monomial.  (Contributed by Stefan O'Rear,
       8-Mar-2015.) $)
    mplmon2 $p |- ( ph -> ( X .x. ( y e. D |-> if ( y = K , .1. , .0. ) ) ) =
        ( y e. D |-> if ( y = K , X , .0. ) ) ) $=
      ( cv wceq cif cmpt csn cxp cmulr cfv cof cbs eqid mplmon mplvsca cvv wcel
      co ccnv cima cfn cn0 cmap crab ovex rabex eqeltri a1i adantr cur fvex c0g
      cn wa ifex fconstmpt eqidd offval2 oveq2 eqeq1d crg rngridm iftrue eqcomd
      syl2anc sylan9eq wn rngrz iffalse ifbothda mpteq2dv 3eqtrd ) AMBDBUEZKUFZ
      HNUGZUHZGUTDMUIUJZWRFUKULZUMUTBDMWQWTUTZUHBDWPMNUGZUHAEUNULZDEFGWTIWRJCMO
      PTXCUOZWTUOZQUDABXCDEFHIJLKNOXDSRQUAUBUCUPUQABDMWQWTWSWRURCURDURUSADIUEVA
      VOVBVCUSZIVDJVEUTZVFURQXFIXGVDJVEVGVHVIVJAMCUSZWODUSZUDVKWQURUSAXIVPWPHNH
      FVLULURRFVLVMVINFVNULURSFVNVMVIVQVJWSBDMUHUFABDMVRVJAWRVSVTABDXAXBWPMHWTU
      TZXBUFMNWTUTZXBUFXAXBUFAHNHWQUFXJXAXBHWQMWTWAWBNWQUFXKXAXBNWQMWTWAWBAWPXJ
      MXBAFWCUSZXHXJMUFUBUDCFWTHMTXERWDWGWPXBMWPMNWEWFWHAWPWIZXKNXBAXLXHXKNUFUB
      UDCFWTMNTXESWJWGXMXBNWPMNWKWFWHWLWMWN $.
  $}

  ${
    $d I f x $.  $d K f x $.
    psrbag0.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    $( The empty bag is a bag.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    psrbag0 $p |- ( I e. V -> ( I X. { 0 } ) e. D ) $=
      ( wcel cc0 csn cxp cn0 wf ccnv cn cima cfn wa 0nn0 c0 cin wceq c0ex incom
      fconst6 fconst wn 0nnn disjsn mpbir eqtri fimacnvdisj 0fin eqeltri pm3.2i
      mp2an psrbag mpbiri ) CDFCGHZIZAFCJURKZURLMNZOFZPUSVACGJQUCUTROCUQURKUQMS
      ZRTUTRTCGUAUDVBMUQSZRUQMUBVCRTGMFUEUFMGUGUHUICUQMURUJUNUKULUMABURCDEUOUP
      $.

    $( A singleton bag is a bag.  (Contributed by Stefan O'Rear,
       9-Mar-2015.) $)
    psrbagsn $p |- ( I e. V -> ( x e. I |-> if ( x = K , 1 , 0 ) ) e. D ) $=
      ( wcel c1 cc0 cn0 cn cfn wa wtru a1i crab wss ssfi mp2an cv wceq cif cmpt
      wf ccnv cima 1nn0 0nn0 keepel eqid fmptd trud mptpreima csn cab cin inss1
      snfi dfrab2 df-sn 3sstr4i wi wn 0nnn iffalse eleq1d con4i ss2rabi eqeltri
      mtbiri pm3.2i psrbag mpbiri ) DFHADAUAZEUBZIJUCZUDZBHDKVRUEZVRUFLUGZMHZNV
      SWAVSOADVQKVRVQKHOVODHZNVPIJKUHUIUJPVRUKZULUMVTVQLHZADQZMADVQLVRWCUNVPADQ
      ZMHZWEWFRWEMHEUOZMHWFWHRWGEUSVPAUPZDUQWIWFWHWIDURVPADUTAEVAVBWHWFSTWDVPAD
      WDVPVCWBVPWDVPVDZWDJLHVEWJVQJLVPIJVFVGVKVHPVIWFWESTVJVLBCVRDFGVMVN $.
  $}

  ${
    $d ph y $.  $d B y $.  $d D y $.  $d I f y $.  $d R f y $.  $d X y $.
    $d .0. f y $.
    mplascl.p $e |- P = ( I mPoly R ) $.
    mplascl.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplascl.z $e |- .0. = ( 0g ` R ) $.
    mplascl.b $e |- B = ( Base ` R ) $.
    mplascl.a $e |- A = ( algSc ` P ) $.
    mplascl.i $e |- ( ph -> I e. W ) $.
    mplascl.r $e |- ( ph -> R e. Ring ) $.
    mplascl.x $e |- ( ph -> X e. B ) $.
    $( Value of the scalar injection into the polynomial algebra.  (Contributed
       by Stefan O'Rear, 9-Mar-2015.) $)
    mplascl $p |- ( ph -> ( A ` X ) =
          ( y e. D |-> if ( y = ( I X. { 0 } ) , X , .0. ) ) ) $=
      ( cfv cur cvsca cc0 csn cxp wceq cif cmpt csca cbs wcel crg mplsca fveq2d
      co cv syl5eq eleqtrd eqid asclval syl mpl1 oveq2d psrbag0 mplmon2 3eqtrd
      ) AKCUAZKFUBUAZFUCUAZUPZKBEBUQIUDUEUFZUGZGUBUAZLUHUIZVJUPBEVMKLUHUIAKFUJU
      AZUKUAZULVHVKUGAKDVQTADGUKUAVQPAGVPUKAFGIJUMMRSUNUOURUSCVJVIVPVQFKQVPUTVQ
      UTVJUTZVIUTZVAVBAVIVOKVJABEFGVIVNHIJLMNOVNUTZVSRSVCVDABDEFGVJVNHIVLJKLMVR
      NVTOPRSAIJULVLEULREHIJNVEVBTVFVG $.
  $}

  ${
    $d ph y $.  $d B y $.  $d D y $.  $d I f y $.  $d R f y $.  $d X y $.
    $d .0. f y $.
    mplasclf.p $e |- P = ( I mPoly R ) $.
    mplasclf.b $e |- B = ( Base ` P ) $.
    mplasclf.k $e |- K = ( Base ` R ) $.
    mplasclf.a $e |- A = ( algSc ` P ) $.
    mplasclf.i $e |- ( ph -> I e. W ) $.
    mplasclf.r $e |- ( ph -> R e. Ring ) $.
    $( The scalar injection is a function into the polynomial algebra.
       (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    mplasclf $p |- ( ph -> A : K --> B ) $=
      ( wf cfv cbs wcel crg eqid csca mplrng mpllmod asclf mplsca fveq2d syl5eq
      wa syl2anc feq2d mpbird ) AGCBODUAPZQPZCBOZAFHRZESRZUNMNUOUPUHBCULUMDLULT
      DEFHIUBDEFHIUCUMTJUDUIAGUMCBAGEQPUMKAEULQADEFHSIMNUEUFUGUJUK $.
  $}

  ${
    $d x A $.  $d x C $.  $d f x y H $.  $d f x y I $.  $d x K $.  $d x y ph $.
    $d f x y R $.  $d x y T $.  $d x X $.
    subrgascl.p $e |- P = ( I mPoly R ) $.
    subrgascl.a $e |- A = ( algSc ` P ) $.
    subrgascl.h $e |- H = ( R |`s T ) $.
    subrgascl.u $e |- U = ( I mPoly H ) $.
    subrgascl.i $e |- ( ph -> I e. W ) $.
    subrgascl.r $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    ${
      subrgascl.c $e |- C = ( algSc ` U ) $.
      $( The scalar injection function in a subring algebra is the same up to a
         restriction to the subring.  (Contributed by Mario Carneiro,
         4-Jul-2015.) $)
      subrgascl $p |- ( ph -> C = ( A |` T ) ) $=
        ( cfv eqid wcel vx vy cres wfn csca cbs asclfn csubrg wceq subrgbas syl
        vf cvv cress ovex eqeltri a1i mplsca fveq2d eqtrd fneq2d mpbiri wss crg
        co subrgrcl subrgss fnssres syl2anc cv wa fvres adantl ccnv cn cima cfn
        cn0 cmap crab cc0 csn cxp c0g cmpt subrg0 ifeq2d adantr mpteq2dv sselda
        cif mplascl subrgrng eleq2d biimpa 3eqtr4d eqtr2d eqfnfvd ) AUAFCBFUCZA
        CFUDCGUERZUFRZUDCWTXAGQWTSXASUGAFXACAFHUFRZXAAFEUHRTZFXBUIPFEHMUJUKZAHW
        TUFAGHIJUMNOHUMTAHEFUNVEUMMEFUNUOUPUQURUSUTVAVBABEUFRZUDZFXEVCZWSFUDAXF
        BDUERZUFRZUDBXHXIDLXHSXISUGAXEXIBAEXHUFADEIJVDKOAXCEVDTZPFEVFUKZURUSVAV
        BAXCXGPFXEEXESZVGUKZXEFBVHVIAUAVJZFTZVKZXNWSRZXNBRZXNCRZXOXQXRUIAXNFBVL
        VMXPUBULVJVNVOVPVQTULVRIVSVEVTZUBVJIWAWBWCUIZXNEWDRZWKZWEUBXTYAXNHWDRZW
        KZWEXRXSXPUBXTYCYEAYCYEUIXOAYAYBYDXNAXCYBYDUIPFEHYBMYBSZWFUKWGWHWIXPUBB
        XEXTDEULIJXNYBKXTSZYFXLLAIJTXOOWHZAXJXOXKWHAFXEXNXMWJWLXPUBCXBXTGHULIJX
        NYDNYGYDSXBSQYHAHVDTZXOAXCYIPFEHMWMUKWHAXOXNXBTAFXBXNXDWNWOWLWPWQWR $.
    $}

    subrgasclcl.b $e |- B = ( Base ` U ) $.
    subrgasclcl.k $e |- K = ( Base ` R ) $.
    subrgasclcl.x $e |- ( ph -> X e. K ) $.
    $( The scalars in a polynomial algebra are in the subring algebra iff the
       scalar value is in the subring.  (Contributed by Mario Carneiro,
       4-Jul-2015.) $)
    subrgasclcl $p |- ( ph -> ( ( A ` X ) e. B <-> X e. T ) ) $=
      ( vf vx cfv wcel wa cbs cc0 csn cxp cv ccnv cn cima cfn cmap co crab wceq
      cn0 c0g cif wral adantr eqid psrbag0 syl cmpt wf cmps csubrg crg subrgrcl
      mplascl wss subrgrng mplsubrg sselda eqeltrrd psrelbas fmpt sylibr iftrue
      subrgss eleq1d rspcv sylc subrgbas eleqtrrd cascl cres subrgascl sylan9eq
      fveq1d fvres csca mplrng mpllmod asclf syl2anc mplsca fveq2d eqtrd eleq2d
      biimpa ffvelrnd impbida ) ALBUDZCUEZLFUEZAXIUFZLHUGUDZFXKIUHUIUJZUBUKULUM
      UNUOUEUBUTIUPUQURZUEZUCUKXMUSZLEVAUDZVBZXLUEZUCXNVCZLXLUEZXKIKUEZXOAYBXIQ
      VDXNUBIKXNVEZVFVGXKXNXLUCXNXRVHZVIXTXKIHVJUQZUGUDZXNHYEUBIXLYDYEVEZXLVEYC
      YFVEZXKXHYDYFAXHYDUSXIAUCBJXNDEUBIKLXQMYCXQVETNQAFEVKUDUEZEVLUERFEVMVGUAV
      NVDACYFXHACYEVKUDUECYFVOAGHYECIKYGPSQAYIHVLUEZRFEHOVPVGZVQCYFYEYHWDVGVRVS
      VTUCXNXLXRYDYDVEWAWBXSYAUCXMXNXPXRLXLXPLXQWCWEWFWGAFXLUSZXIAYIYLRFEHOWHVG
      ZVDWIAXJUFZLGWJUDZUDZXHCAXJYPLBFWKZUDXHALYOYQABYODEFGHIKMNOPQRYOVEZWLWNLF
      BWOWMYNGWPUDZUGUDZCLYOAYTCYOVIZXJAYBYJUUAQYKYBYJUFYOCYSYTGYRYSVEGHIKPWQGH
      IKPWRYTVESWSWTVDAXJLYTUEAFYTLAFXLYTYMAHYSUGAGHIKVLPQYKXAXBXCXDXEXFVSXG $.
  $}

  ${
    mplmon2cl.p $e |- P = ( I mPoly R ) $.
    mplmon2cl.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplmon2cl.z $e |- .0. = ( 0g ` R ) $.
    mplmon2cl.c $e |- C = ( Base ` R ) $.
    mplmon2cl.i $e |- ( ph -> I e. W ) $.

    ${
      $d ph y $.  $d C y $.  $d D y $.  $d I f $.  $d K f y $.  $d R y $.
      $d X y $.  $d .0. y $.
      mplmon2cl.r $e |- ( ph -> R e. Ring ) $.
      mplmon2cl.b $e |- B = ( Base ` P ) $.
      mplmon2cl.x $e |- ( ph -> X e. C ) $.
      mplmon2cl.k $e |- ( ph -> K e. D ) $.
      $( A scaled monomial is a polynomial.  (Contributed by Stefan O'Rear,
         8-Mar-2015.) $)
      mplmon2cl $p |- ( ph -> ( y e. D |-> if ( y = K , X , .0. ) ) e. B ) $=
        ( cv wceq cur cfv cif cmpt cvsca co eqid mplmon2 clmod wcel cbs mpllmod
        csca crg syl2anc mplsca fveq2d syl5eq eleqtrd lmodvscl syl3anc eqeltrrd
        mplmon ) ALBEBUCJUDZGUEUFZMUGUHZFUIUFZUJZBEVHLMUGUHCABDEFGVKVIHIJKLMNVK
        UKZOVIUKZPQRSUBUAULAFUMUNZLFUQUFZUOUFZUNVJCUNVLCUNAIKUNGURUNVORSFGIKNUP
        USALDVQUAADGUOUFVQQAGVPUOAFGIKURNRSUTVAVBVCABCEFGVIHIKJMNTPVNORSUBVGLVK
        VPVQCFVJTVPUKVMVQUKVDVEVF $.
    $}

    $d ph y $.  $d C y $.  $d D y $.  $d F y $.  $d G y $.  $d I f $.
    $d R y $.  $d .x. y $.  $d X f y $.  $d Y f y $.  $d .0. y $.
    mplmon2mul.r $e |- ( ph -> R e. CRing ) $.
    mplmon2mul.t $e |- .xb = ( .r ` P ) $.
    mplmon2mul.u $e |- .x. = ( .r ` R ) $.
    mplmon2mul.x $e |- ( ph -> X e. D ) $.
    mplmon2mul.y $e |- ( ph -> Y e. D ) $.
    mplmon2mul.f $e |- ( ph -> F e. C ) $.
    mplmon2mul.g $e |- ( ph -> G e. C ) $.
    $( Product of scaled monomials.  (Contributed by Stefan O'Rear,
       8-Mar-2015.) $)
    mplmon2mul $p |- ( ph -> ( ( y e. D |-> if ( y = X , F , .0. ) ) .xb
            ( y e. D |-> if ( y = Y , G , .0. ) ) ) =
          ( y e. D |-> if ( y = ( X oF + Y ) , ( F .x. G ) , .0. ) ) ) $=
      ( cv wceq cur cfv cif cmpt cvsca co caddc cof casa wcel csca ccrg mplassa
      cbs syl2anc mplsca fveq2d syl5eq eleqtrd eqid crg crngrng mplmon assalmod
      clmod lmodvscl syl3anc assaass syl13anc assaassr oveq2d cmulr psrbagaddcl
      syl mplmonmul lmodvsass syl5req oveqd oveq1d 3eqtr2d 3eqtrd mplmon2 rngcl
      oveq12d 3eqtr3d ) AJBDBUIZNUJZFUKULZPUMUNZEUOULZUPZKBDWPOUJZWRPUMUNZWTUPZ
      GUPZJKHUPZBDWPNOUQURUPZUJZWRPUMUNZWTUPZBDWQJPUMUNZBDXBKPUMUNZGUPBDXHXFPUM
      UNAXEJWSXDGUPZWTUPZJKWSXCGUPZWTUPZWTUPZXJAEUSUTZJEVAULZVDULZUTZWSEVDULZUT
      ZXDYBUTZXEXNUJALMUTZFVBUTZXRUAUBEFLMQVCVEZAJCXTUGACFVDULXTTAFXSVDAEFLMVBQ
      UAUBVFZVGVHZVIZABYBDEFWRILMNPQYBVJZSWRVJZRUAAYFFVKUTZUBFVLWDZUEVMZAEVOUTZ
      KXTUTZXCYBUTZYDAXRYPYGEVNWDZAKCXTUHYIVIZABYBDEFWRILMOPQYKSYLRUAYNUFVMZKWT
      XSXTYBEXCYKXSVJZWTVJZXTVJZVPVQJXTWTGXSYBEWSXDYKUUBUUDUUCUCVRVSAXMXPJWTAXR
      YQYCYRXMXPUJYGYTYOUUAKXTWTGXSYBEWSXCYKUUBUUDUUCUCVTVSWAAXQJKXIWTUPZWTUPZJ
      KXSWBULZUPZXIWTUPZXJAXPUUEJWTAXOXIKWTABYBDEFGWRILMNOPQYKSYLRUAYNUEUCUFWEW
      AWAAYPYAYQXIYBUTUUIUUFUJYSYJYTABYBDEFWRILMXGPQYKSYLRUAYNAYENDUTODUTXGDUTU
      AUEUFDINOLMRWCVQZVMJKWTUUGXSXTYBEXIYKUUBUUCUUDUUGVJWFVSAUUHXFXIWTAUUGHJKA
      HFWBULUUGUDAFXSWBYHVGWGWHWIWJWKAXAXKXDXLGABCDEFWTWRILNMJPQUUCRYLSTUAYNUEU
      GWLABCDEFWTWRILOMKPQUUCRYLSTUAYNUFUHWLWNABCDEFWTWRILXGMXFPQUUCRYLSTUAYNUU
      JAYMJCUTKCUTXFCUTYNUGUHCFHJKTUDWMVQWLWO $.
  $}

  ${
    $d w x y z .+ $.  $d w x y z B $.  $d x y C $.  $d x I $.  $d w x y z ph $.
    $d w x y z H $.  $d x K $.  $d x y .x. $.  $d x V $.  $d w x y z Y $.
    mplind.sk $e |- K = ( Base ` R ) $.
    mplind.sv $e |- V = ( I mVar R ) $.
    mplind.sy $e |- Y = ( I mPoly R ) $.
    mplind.sp $e |- .+ = ( +g ` Y ) $.
    mplind.st $e |- .x. = ( .r ` Y ) $.
    mplind.sc $e |- C = ( algSc ` Y ) $.
    mplind.sb $e |- B = ( Base ` Y ) $.
    mplind.p $e |- ( ( ph /\ ( x e. H /\ y e. H ) ) -> ( x .+ y ) e. H ) $.
    mplind.t $e |- ( ( ph /\ ( x e. H /\ y e. H ) ) -> ( x .x. y ) e. H ) $.
    mplind.s $e |- ( ( ph /\ x e. K ) -> ( C ` x ) e. H ) $.
    mplind.v $e |- ( ( ph /\ x e. I ) -> ( V ` x ) e. H ) $.
    mplind.x $e |- ( ph -> X e. B ) $.
    mplind.i $e |- ( ph -> I e. _V ) $.
    mplind.r $e |- ( ph -> R e. CRing ) $.
    $( Prove a property of polynomials by "structural" induction, under a
       simplified model of structure which loses the sum of products
       structure.  The commutativity condition is stronger than strictly
       needed.  (Contributed by Stefan O'Rear, 11-Mar-2015.) $)
    mplind $p |- ( ph -> X e. H ) $=
      ( vz vw cin inss1 crn cmps co casp cfv casa wcel cbs wss cvv eqid psrassa
      inss2 csubrg ccrg crg crngrng syl mplsubrg subrgss syl5ss wfn cv wf mvrf2
      wral ffn ralrimiva fnfvrnss syl2anc ssind aspss syl3anc mplbas2 clss wceq
      frn syl6eqr csubg cur c0 wne cminusg wa a1i csca crh mplassa asclrhm rhm1
      mplsca eqeltrrd rngidcl fveq2d syl5eq eleqtrrd eleq1d rspcva assarng elin
      fveq2 sylanbrc sseli anim12i caovclg sylan2 clmod assalmod lmodgrp adantr
      ne0i cgrp simprl sseldi simprr grpcl anassrs simpr rngnegl simpl grpinvcl
      cghm jca w3a wb mpbir3and ralrimivva simprbda rhmghm ghminv eqtrd issubg2
      rnggrp syl12anc issubrg2 mplval2 subsubrg mpllss asclmul1 syldan lmodvscl
      rngcl cvsca islss4 mpbir2and lsslss syl21anc aspid 3sstr3d sseldd ) AIDUK
      ZIMIDULZADUVCMALUMZJGUNUOZUPUQZUQZUVCUVGUQZDUVCAUVFURUSZUVCUVFUTUQZVAUVEU
      VCVAUVHUVIVAAGUVFJVBUVFVCZUGUHVDZAUVCDUVKIDVEZADUVFVFUQZUSZDUVKVAANGUVFDJ
      VBUVLQUAUGAGVGUSZGVHUSUHGVIVJZVKZDUVKUVFUVKVCZVLVJVMAUVEIDALJVNZBVOZLUQIU
      SZBJVRUVEIVAAJDLVPZUWAADNGJLVBQPUAUGUVRVQZJDLVSVJAUWCBJUEVTBJILWAWBAUWDUV
      EDVAUWEJDLWIVJWCUVGUVCUVEUVKUVFUVGVCZUVTWDWEAUVHNUTUQDAUVGNGUVFJLVBQUVLPU
      WFUGUHWFUAWJAUVJUVCUVOUSZUVCUVFWGUQZUSZUVIUVCWHUVMAUVPUVCNVFUQUSZUWGUVSAU
      WJUVCNWKUQUSZNWLUQZUVCUSZUWBCVOZHUOZUVCUSZCUVCVRBUVCVRZAUWKUVCDVAZUVCWMWN
      ZUIVOZUJVOZFUOZUVCUSZUJUVCVRZUWTNWOUQZUQZUVCUSZWPZUIUVCVRZUWRAUVNWQAUWMUW
      SAUWLIUSUWLDUSZUWMANWRUQZWLUQZEUQZUWLIAEUXKNWSUOUSZUXMUWLWHANURUSZUXNAJVB
      USUVQUXOUGUHNGJVBQWTWBZEUXKNTUXKVCZXAVJZUXKNUXLEUWLUXLVCZUWLVCZXBVJZAUXLK
      USUWBEUQZIUSZBKVRZUXMIUSZAUXLUXKUTUQZKAUXKVHUSZUXLUYFUSZAGUXKVHANGJVBVGQU
      GUHXCZUVRXDZUYFUXKUXLUYFVCZUXSXEVJZAKGUTUQUYFOAGUXKUTUYIXFXGZXHAUYCBKUDVT
      ZUYCUYEBUXLKUWBUXLWHUYBUXMIUWBUXLEXMXIXJWBXDANVHUSZUXJAUXOUYOUXPNXKVJZDNU
      WLUAUXTXEVJUWLIDXLXNZUVCUWLYCVJAUXHUIUVCAUWTUVCUSZWPZUXDUXGUYSUXCUJUVCAUY
      RUXAUVCUSZUXCAUYRUYTWPZWPZUXBIUSZUXBDUSZUXCVUAAUWTIUSZUXAIUSZWPVUCUYRVUEU
      YTVUFUVCIUWTUVDXOUVCIUXAUVDXOXPABCUWTUXAIIIFUBXQXRVUBNYDUSZUWTDUSZUXADUSZ
      VUDAVUGVUAANXSUSZVUGAUXOVUJUXPNXTVJZNYAVJZYBVUBUVCDUWTUVNAUYRUYTYEYFVUBUV
      CDUXAUVNAUYRUYTYGYFDFNUWTUXAUARYHWEUXBIDXLXNYIVTUYSUXFIUSUXFDUSZUXGUYSUWL
      UXEUQZUWTHUOZUXFIUYSDNHUWLUXEUWTUASUXTUXEVCZAUYOUYRUYPYBUYSUVCDUWTUVNAUYR
      YJZYFZYKUYSAVUNIUSZVUEVUOIUSAUYRYLAVUSUYRAUXLUXKWOUQZUQZEUQZVUNIAVVBUXMUX
      EUQZVUNAEUXKNYNUOUSZUYHVVBVVCWHAUXNVVDUXRUXKNEUUAVJUYLUYFUXKNEVUTUXEUXLUY
      KVUTVCZVUPUUBWBAUXMUWLUXEUYAXFUUCAVVAKUSUYDVVBIUSZAVVAUYFKAUXKYDUSZUYHVVA
      UYFUSAUYGVVGUYJUXKUUEVJUYLUYFUXKVUTUXLUYKVVEYMWBUYMXHUYNUYCVVFBVVAKUWBVVA
      WHUYBVVBIUWBVVAEXMXIXJWBXDYBUYSUVCIUWTUVDVUQYFABCVUNUWTIIIHUCXQUUFXDUYSVU
      GVUHVUMAVUGUYRVULYBVURDNUXEUWTUAVUPYMWBUXFIDXLXNYOVTAVUGUWKUWRUWSUXIYPYQV
      ULUIUJDFUVCNUXEUARVUPUUDVJYRZUYQAUWPBCUVCUVCAUWBUVCUSZUWNUVCUSZWPZWPZUWOI
      USZUWODUSZUWPVVKAUWBIUSZUWNIUSZWPVVMVVIVVOVVJVVPUVCIUWBUVDXOUVCIUWNUVDXOX
      PUCXRVVLUYOUWBDUSUWNDUSVVNAUYOVVKUYPYBVVLUVCDUWBUVNAVVIVVJYEYFVVLUVCDUWNU
      VNAVVIVVJYGYFDNHUWBUWNUASUUNWEUWOIDXLXNYSAUYOUWJUWKUWMUWQYPYQUYPBCUVCDNHU
      WLUAUXTSUUGVJYRUVPUWJUWGUWRDUVCUVFNNGUVFDJQUVLUAUUHZUUIYTWBAUVFXSUSZDUWHU
      SZUVCNWGUQZUSZUWIAUVJVVRUVMUVFXTVJANGUVFDJVBUVLQUAUGUVRUUJAVWAUWKUWTUXANU
      UOUQZUOZUVCUSZUJUVCVRUIUYFVRZVVHAVWDUIUJUYFUVCAUWTUYFUSZUYTWPZWPZVWCIUSVW
      CDUSZVWDVWHUWTEUQZUXAHUOZVWCIVWHUXOVWFVUIVWKVWCWHAUXOVWGUXPYBAVWFUYTYEZVW
      HUVCDUXAUVNAVWFUYTYGZYFZEUWTVWBHUXKUYFDNUXATUXQUYKUASVWBVCZUUKWEAVWGVWJIU
      SZVUFWPVWKIUSVWHVWPVUFVWHUWTKUSUYDVWPVWHUWTUYFKVWLAKUYFWHVWGUYMYBXHAUYDVW
      GUYNYBUYCVWPBUWTKUWBUWTWHUYBVWJIUWBUWTEXMXIXJWBVWHUVCIUXAUVDVWMYFYOABCVWJ
      UXAIIIHUCXQUULXDVWHVUJVWFVUIVWIAVUJVWGVUKYBVWLVWNUWTVWBUXKUYFDNUXAUAUXQVW
      OUYKUUMWEVWCIDXLXNYSAVUJVWAUWKVWEWPYQVUKUYFVVTVWBUVCUXKDNUIUJUXQUYKUAVWOV
      VTVCZUUPVJUUQVVRVVSWPVWAUWIUWRUWHVVTDUVCUVFNVVQUWHVCZVWQUURYTUUSUVGUVCUWH
      UVKUVFUWFUVTVWRUUTWEUVAUFUVBYF $.
  $}

  ${
    $d ph k y $.  $d B k $.  $d D k y $.  $d I f k y $.  $d P k y $.
    $d R f k y $.  $d W k $.  $d X f k y $.  $d .0. f k y $.
    mplcoe4.p $e |- P = ( I mPoly R ) $.
    mplcoe4.d $e |- D = { f e. ( NN0 ^m I ) | ( `' f " NN ) e. Fin } $.
    mplcoe4.z $e |- .0. = ( 0g ` R ) $.
    mplcoe4.b $e |- B = ( Base ` P ) $.
    mplcoe4.i $e |- ( ph -> I e. W ) $.
    mplcoe4.r $e |- ( ph -> R e. Ring ) $.
    mplcoe4.x $e |- ( ph -> X e. B ) $.
    $( Decompose a polynomial into a finite sum of scaled monomials.
       (Contributed by Stefan O'Rear, 8-Mar-2015.) $)
    mplcoe4 $p |- ( ph -> X = ( P gsum ( k e. D |->
              ( y e. D |-> if ( y = k , ( X ` k ) , .0. ) ) ) ) ) $=
      ( cfv cv weq cur cif cmpt cvsca co cgsu eqid mplcoe1 wcel wa adantr simpr
      cbs crg mplelf ffvelrnda mplmon2 mpteq2dva oveq2d eqtrd ) AKEHDHUAZKTZBDB
      HUBZFUCTZLUDUEEUFTZUGZUEZUHUGEHDBDVEVDLUDUEZUEZUHUGABCDEFVGVFGHIJKLMNOVFU
      IZQPVGUIZRSUJAVIVKEUHAHDVHVJAVCDUKZULBFUOTZDEFVGVFGIVCJVDLMVMNVLOVOUIZAIJ
      UKVNQUMAFUPUKVNRUMAVNUNADVOVCKACDEFGIVOKMVPPNSUQURUSUTVAVB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Polynomial evaluation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d i j k x y z I $.  $d i j k x y z J $.  $d x y z ph $.  $d i j k y z X $.
    $d z .0. $.  $d x y B $.  $d i j k x y z .x. $.  $d i j k x z Y $.
    evlslem4.b $e |- B = ( Base ` R ) $.
    evlslem4.z $e |- .0. = ( 0g ` R ) $.
    evlslem4.t $e |- .x. = ( .r ` R ) $.
    evlslem4.r $e |- ( ph -> R e. Ring ) $.
    evlslem4.x $e |- ( ( ph /\ x e. I ) -> X e. B ) $.
    evlslem4.y $e |- ( ( ph /\ y e. J ) -> Y e. B ) $.
    $( The support of a tensor product of ring element families is contained in
       the product of the supports.  (Contributed by Stefan O'Rear,
       8-Mar-2015.) $)
    evlslem4 $p |- ( ph ->
        ( `' ( x e. I , y e. J |-> ( X .x. Y ) ) " ( _V \ { .0. } ) ) C_
          ( ( `' ( x e. I |-> X ) " ( _V \ { .0. } ) ) X.
            ( `' ( y e. J |-> Y ) " ( _V \ { .0. } ) ) ) ) $=
      ( cfv wceq wcel vz vi vj co cmpt2 ccnv cvv csn cdif cima cxp cv c1st cmpt
      c2nd nfcv nffvmpt1 nfov fveq2 oveqan12d cbvmpt2 cop wa eqop2 adantl sylbi
      vex mpt2mpt eqtr4i w3a simp2 3adant3 fvmpt2 syl2anc simp3 3adant2 oveq12d
      eqid mpt2eq3dva syl5reqr cnveqd imaeq1d wo cun difxp eleq2i elun bitri wf
      fmptd xp1st id wss ssid a1i suppssr syl2an oveq1d crg xp2nd ffvelrn rnglz
      adantr eqtrd oveq2d rngrz jaodan sylan2b suppss2 eqsstrd ) ABCGHIJFUDZUEZ
      UFZUGKUHUIZUJUAGHUKZUAULZUMRZBGIUNZRZXPUORZCHJUNZRZFUDZUNZUFZXNUJXRUFXNUJ
      ZYAUFXNUJZUKZAXMYEXNAXLYDAYDBCGHBULZXRRZCULZYARZFUDZUEZXLYNUBUCGHUBULZXRR
      ZUCULZYARZFUDZUEYDBCUBUCGHYMYSUBYMUPUCYMUPBYPYRFBGIYOUQBFUPBYRUPURCYPYRFC
      YPUPCFUPCHJYQUQURYIYOSYKYQSYJYPYLYRFYIYOXRUSYKYQYAUSUTVAUBUCUAGHYCYSXPYOY
      QVBSXPUGUGUKTZXQYOSZXTYQSZVCZVCYCYSSZXPYOYQUBVGUCVGVDUUCUUDYTUUAUUBXSYPYB
      YRFXQYOXRUSXTYQYAUSUTVEVFVHVIABCGHYMXKAYIGTZYKHTZVJZYJIYLJFUUGUUEIDTZYJIS
      AUUEUUFVKAUUEUUHUUFPVLBGIDXRXRVRZVMVNUUGUUFJDTZYLJSAUUEUUFVOAUUFUUJUUEQVP
      CHJDYAYAVRZVMVNVQVSVTWAWBAXOYCUAYHKXPXOYHUIZTZAXPGYFUIZHUKZTZXPGHYGUIZUKZ
      TZWCZYCKSZUUMXPUUOUURWDZTUUTUULUVBXPYFYGGHWEWFXPUUOUURWGWHAUUPUVAUUSAUUPV
      CZYCKYBFUDZKUVCXSKYBFAGDXRWIZXQUUNTXSKSUUPABGIDXRPUUIWJZXPUUNHWKUVEGDXRYF
      XQKUVEWLYFYFWMUVEYFWNWOWPWQWRUVCEWSTZYBDTZUVDKSAUVGUUPOXCAHDYAWIZXTHTUVHU
      UPACHJDYAQUUKWJZXPUUNHWTHDXTYAXAWQDEFYBKLNMXBVNXDAUUSVCZYCXSKFUDZKUVKYBKX
      SFAUVIXTUUQTYBKSUUSUVJXPGUUQWTUVIHDYAYGXTKUVIWLYGYGWMUVIYGWNWOWPWQXEUVKUV
      GXSDTZUVLKSAUVGUUSOXCAUVEXQGTUVMUUSUVFXPGUUQWKGDXQXRXAWQDEFXSKLNMXFVNXDXG
      XHXIXJ $.
  $}

  ${
    $d I h $.  $d X h $.
    psrbagsuppfi.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    $( Finite bags have finite nonzero-support.  (Contributed by Stefan O'Rear,
       9-Mar-2015.) $)
    psrbagsuppfi $p |- ( ( X e. D /\ I e. V ) ->
        ( `' X " ( _V \ { 0 } ) ) e. Fin ) $=
      ( wcel wa ccnv cvv cc0 csn cdif cima cn cfn cn0 wf wceq psrbagf nn0supp
      ancoms syl psrbag biimpac simprd eqeltrd ) EAGZCDGZHZEIZJKLMNZUKONZPUJCQE
      RZULUMSUIUHUNABECDFTUBECUAUCUJUNUMPGZUIUHUNUOHABECDFUDUEUFUG $.
  $}

  ${
    $d ph y z $.  $d B h $.  $d B y z $.  $d C y z $.  $d G z $.  $d I h $.
    $d .x. y z $.  $d .0. z $.
    psrbagev1.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    psrbagev1.c $e |- C = ( Base ` T ) $.
    psrbagev1.x $e |- .x. = ( .g ` T ) $.
    psrbagev1.z $e |- .0. = ( 0g ` T ) $.
    psrbagev1.t $e |- ( ph -> T e. CMnd ) $.
    psrbagev1.b $e |- ( ph -> B e. D ) $.
    psrbagev1.g $e |- ( ph -> G : I --> C ) $.
    psrbagev1.i $e |- ( ph -> I e. _V ) $.
    $( A bag of multipliers provides the conditions for a valid sum.
       (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    psrbagev1 $p |- ( ph -> ( ( B oF .x. G ) : I --> C /\
          ( `' ( B oF .x. G ) " ( _V \ { .0. } ) ) e. Fin ) ) $=
      ( cvv wcel vy vz cof co wf ccnv csn cdif cima cfn cn0 cmnd cv ccmn cmnmnd
      syl mulgnn0cl 3expb sylan psrbagf syl2anc inidm off cc0 psrbagsuppfi ssid
      wa wss a1i wceq mulg0 adantl suppssof1 ssfi jca ) AICBHFUCUDZUEVPUFSJUGUH
      UIZUJTZAUAUBIIIFUKCCBHSSAEULTZUAUMZUKTZUBUMZCTZVGVTWBFUDCTZAEUNTVSOEUOUPV
      SWAWCWDCFEVTWBLMUQURUSAISTZBDTZIUKBUERPDGBISKUTVAZQRRIVBVCABUFSVDUGUHUIZU
      JTZVQWHVHVRAWFWEWIPRDGISBKVEVAAUBBHICWHFUKSVDJWHWHVHAWHVFVIWCVDWBFUDJVJAC
      FEWBJLNMVKVLWGQRVMWHVQVNVAVO $.

    $( Closure of a sum using a bag of multipliers.  (Contributed by Stefan
       O'Rear, 9-Mar-2015.) $)
    psrbagev2 $p |- ( ph -> ( T gsum ( B oF .x. G ) ) e. C ) $=
      ( cof cvv co ccnv csn cdif cima cfn wcel psrbagev1 simpld simprd gsumcl
      wf ) AICBHFSUAZETJLNORAICUMULZUMUBTJUCUDUEUFUGZABCDEFGHIJKLMNOPQRUHZUIAUN
      UOUPUJUK $.
  $}

  ${
    $d ph i j k y $.  $d B i j k x y z $.  $d D i j k x y z $.  $d E i j z $.
    $d I h i j k $.  $d .x. i j $.  $d P i j k x y z $.  $d R h i j k $.
    $d S i j $.  $d .0. h i j k x y $.  $d .0. z $.
    evlslem2.p $e |- P = ( I mPoly R ) $.
    evlslem2.b $e |- B = ( Base ` P ) $.
    evlslem2.m $e |- .x. = ( .r ` S ) $.
    evlslem2.z $e |- .0. = ( 0g ` R ) $.
    evlslem2.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    evlslem2.i $e |- ( ph -> I e. _V ) $.
    evlslem2.r $e |- ( ph -> R e. CRing ) $.
    evlslem2.s $e |- ( ph -> S e. CRing ) $.
    evlslem2.e1 $e |- ( ph -> E e. ( P GrpHom S ) ) $.
    evlslem2.e2 $e |- ( ( ph /\ ( ( x e. B /\ y e. B ) /\ ( j e. D /\
      i e. D ) ) ) -> ( E ` ( k e. D |-> if ( k = ( j oF + i ) , ( ( x ` j )
      ( .r ` R ) ( y ` i ) ) , .0. ) ) ) = ( ( E ` ( k e. D |-> if ( k = j ,
      ( x ` j ) , .0. ) ) ) .x. ( E ` ( k e. D |->
      if ( k = i , ( y ` i ) , .0. ) ) ) ) ) $.
    $( A linear function on the polynomial ring which is multiplicative on
       scaled monomials is generally multiplicative.  (Contributed by Stefan
       O'Rear, 9-Mar-2015.) $)
    evlslem2 $p |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( E ` ( x ( .r ` P ) y ) ) = ( ( E ` x ) .x. ( E ` y ) ) ) $=
      ( vz cv wcel wa weq cfv cif cmpt cgsu co cmulr ccom cmpt2 cvv c0g eqid cn
      ccnv cima cfn cn0 cmap crab ovex rabex eqeltri a1i crg crngrng syl mplrng
      ccrg syl2anc adantr cbs ad2antrr simprl mplelf ffvelrnda mplmon2cl simprr
      simpr csn cdif wral wss mplelsfi ssid suppssr ifeq1d ifid syl6eq mpteq2dv
      wceq cxp cgrp rnggrp mpl0 fconstmpt eqtr4d suppss2 ralrimiva fveq1 cnveqd
      ssfi imaeq1d cbvralv sylib r19.21bi adantrr equequ2 fveq2 eqidd ifbieq12d
      eleq1d cbvmptv cnveqi imaeq1i adantrl syl5eqel gsumdixp fveq2d wf gsummhm
      eqtrd oveq2d fmptco oveq12d ffvelrnd mptex suppssfv 3eqtr4d mplcoe4 fmptd
      ccmn rngcmn cmnd rngmnd xpex cmhm cghm ghmmhm rngcl ralrimivva fmpt2 xpfi
      syl3anc evlslem4 caddc mplmon2mul anassrs mpt2eq3dva ghmf feqmptd fmpt2co
      cof 3impb ghmid 3eqtr2d ) ABUHZDUIZCUHZDUIZUJZUJZFLEMEMLUKZLUHZUVFULZPUMZ
      UNZUNZUOUPZFKEMEMKUKZKUHZUVHULZPUMZUNZUNZUOUPZFUQULZUPZNULZHNUVQURZUOUPZH
      NUWDURZUOUPZIUPZUVFUVHUWFUPZNULUVFNULZUVHNULZIUPUVKUWHFLKEEUVPUWCUWFUPZUS
      ZUOUPZNULHNUWRURZUOUPZUWMUVKUWGUWSNUVKLKDFUWFEEUTUTUVPUWCFVAULZRUWFVBZUXB
      VBZEUTUIUVKEJUHVDVCVEVFUIZJVGOVHUPZVIUTUAUXEJUXFVGOVHVJVKVLZVMZUXHAFVNUIZ
      UVJAOUTUIZGVNUIZUXIUBAGVRUIZUXKUCGVOVPZFGOUTQVQVSZVTZUVKUVMEUIZUJZMDGWAUL
      ZEFGJOUVMUTUVNPQUATUXRVBZAUXJUVJUXPUBWBAUXKUVJUXPUXMWBRUVKEUXRUVMUVFUVKDE
      FGJOUXRUVFQUXSRUAAUVGUVIWCZWDWEZUVKUXPWHWFZUVKUVTEUIZUJZMDUXREFGJOUVTUTUW
      APQUATUXSAUXJUVJUYCUBWBAUXKUVJUYCUXMWBRUVKEUXRUVTUVHUVKDEFGJOUXRUVHQUXSRU
      AAUVGUVIWGZWDWEZUVKUYCWHWFZAUVGUVQVDZUTUXBWIWJZVEZVFUIZUVIAUYKBDALEMEUVLU
      VMUVHULZPUMZUNZUNZVDZUYIVEZVFUIZCDWKUYKBDWKAUYRCDAUVIUJZUVHVDUTPWIZWJVEZV
      FUIUYQVUAWLUYRUYSDFGUVHOVRPQRTAUVIWHZAUXLUVIUCVTWMUYSEUYNLVUAUXBUYSUVMEVU
      AWJUIZUJZUYNMEPUNZUXBVUDMEUYMPVUDUYMUVLPPUMPVUDUVLUYLPPUYSEUXRUVHVUAUVMPU
      YSDEFGJOUXRUVHQUXSRUAVUBWDVUAVUAWLUYSVUAWNVMWOWPUVLPWQWRWSAUXBVUEWTUVIVUC
      AUXBEUYTXAVUEAEFGJOPUTUXBQUATUXDUBAUXKGXBUIUXMGXCVPXDMEPXEWRWBXFXGVUAUYQX
      KVSZXHUYRUYKCBDCBUKZUYQUYJVFVUGUYPUYHUYIVUGUYOUVQVUGLEUYNUVPVUGMEUYMUVOVU
      GUVLUYLUVNPUVMUVHUVFXIWPWSWSXJXLYAXMXNXOXPZUVKUWDVDZUYIVEZUYQVFVUIUYPUYIU
      WDUYOKLEUWCUYNKLUKZMEUWBUYMVUKUVSUVLUWAPUYLPKLMXQUVTUVMUVHXRVUKPXSXTWSYBY
      CYDAUVIUYRUVGVUFYEYFZYGYHUVKEEXAZDUWRFHNUTUXBRUXDAFUUAUIZUVJAUXIVUNUXNFUU
      BVPVTZUVKHVNUIZHUUCUIAVUPUVJAHVRUIVUPUDHVOVPVTZHUUDVPZVUMUTUIUVKEEUXGUXGU
      UEVMANFHUUFUPUIZUVJANFHUUGUPUIZVUSUEFHNUUHVPVTZUVKUWQDUIZKEWKLEWKVUMDUWRY
      IUVKVVBLKEEUVKUXPUYCUJZUJZUXIUVPDUIZUWCDUIZVVBAUXIUVJVVCUXNWBUVKUXPVVEUYC
      UYBXPUVKUYCVVFUXPUYGYEDFUWFUVPUWCRUXCUUIUUMZUUJLKEEUWQDUWRUWRVBUUKXNUVKUY
      JVUJXAZVFUIZUWRVDUYIVEZVVHWLVVJVFUIUVKUYKVUJVFUIZVVIVUHVULUYJVUJUULVSUVKL
      KDFUWFEEUVPUWCUXBRUXDUXCUXOUYBUYGUUNVVHVVJXKVSYJUVKHLKEEUWQNULZUSZUOUPHLK
      EEUVPNULZUWCNULZIUPZUSZUOUPZUXAUWMUVKVVMVVQHUOUVKLKEEVVLVVPUVKUXPUYCVVLVV
      PWTVVDVVLMEMUHUVMUVTUUOUVBUPWTUVNUWAGUQULZUPPUMUNZNULZVVPVVDUWQVVTNVVDMUX
      REFGUWFVVSJUVNUWAOUTUVMUVTPQUATUXSAUXJUVJVVCUBWBAUXLUVJVVCUCWBUXCVVSVBUVK
      UXPUYCWCUVKUXPUYCWGUVKUXPUVNUXRUIUYCUYAXPUVKUYCUWAUXRUIUXPUYFYEUUPYHAUVJV
      VCVWAVVPWTUFUUQYKUVCUURYLUVKUWTVVMHUOUVKLKUGEEDUWQUGUHZNULZVVLUWRNVVGUVKU
      WRXSANUGDVWCUNWTUVJAUGDHWAULZNAVUTDVWDNYIZUEFHNDVWDRVWDVBZUUSVPZUUTVTZVWB
      UWQNXRUVAYLUVKUWMHLEVVNUNZUOUPZHKEVVOUNZUOUPZIUPVVRUVKUWJVWJUWLVWLIUVKUWI
      VWIHUOUVKLUGEDUVPVWCVVNUVQNUYBUVKUVQXSVWHVWBUVPNXRYMYLUVKUWKVWKHUOUVKKUGE
      DUWCVWCVVOUWDNUYGUVKUWDXSVWHVWBUWCNXRYMYLYNUVKLKVWDHIEEUTUTVVNVVOHVAULZVW
      FSVWMVBZUXHUXHVUQUXQDVWDUVPNAVWEUVJUXPVWGWBUYBYOUYDDVWDUWCNAVWEUVJUYCVWGW
      BUYGYOUVKUYKVWIVDUTVWMWIWJZVEZUYJWLZVWPVFUIVUHAVWQUVJALUVPENUYJUTUXBVWMUY
      JUYJWLAUYJWNVMAVUTUXBNULVWMWTUEFHNUXBVWMUXDVWNUVDVPZUVPUTUIAUXPUJMEUVOUXG
      YPVMYQVTUYJVWPXKVSUVKVVKVWKVDVWOVEZVUJWLZVWSVFUIVULAVWTUVJAKUWCENVUJUTUXB
      VWMVUJVUJWLAVUJWNVMVWRUWCUTUIAUYCUJMEUWBUXGYPVMYQVTVUJVWSXKVSYGYKYRUVEUVK
      UWNUWGNUVKUVFUVRUVHUWEUWFUVKMDEFGJLOUTUVFPQUATRAUXJUVJUBVTZAUXKUVJUXMVTZU
      XTYSZUVKMDEFGJKOUTUVHPQUATRVXAVXBUYEYSZYNYHUVKUWOUWJUWPUWLIUVKUWOUVRNULUW
      JUVKUVFUVRNVXCYHUVKEDUVQFHNUTUXBRUXDVUOVURUXHVVAUVKLEUVPDUVQUYBUVQVBYTVUH
      YJXFUVKUWPUWENULUWLUVKUVHUWENVXDYHUVKEDUWDFHNUTUXBRUXDVUOVURUXHVVAUVKKEUW
      CDUWDUYGUWDVBYTVULYJXFYNYR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Univariate polynomials
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c PwSer1 $. $( Univariate power series $)
  $c var1 $. $( Univariate power series variable $)
  $c Poly1 $. $( Univariate polynomial $)
  $c evalSub1 $. $( Evaluation in a subring $)
  $c eval1 $. $( Evaluation of a univariate polynomial $)
  $c coe1 $. $( Multivariate -> univariate $)
  $c toPoly1 $. $( Univariate -> multivariate $)

  $( Univariate power series. $)
  cps1 $a class PwSer1 $.

  $( The base variable of a univariate power series. $)
  cv1 $a class var1 $.

  $( Univariate polynomials. $)
  cpl1 $a class Poly1 $.

  $( Evaluation in a subring. $)
  ces1 $a class evalSub1 $.

  $( Evaluation of a univariate polynomial. $)
  ce1 $a class eval1 $.

  $( Convert a multivariate polynomial representation to univariate. $)
  cco1 $a class coe1 $.

  $( Convert a univariate polynomial representation to multivariate. $)
  ctp1 $a class toPoly1 $.

  ${
    $d b f n r s x y $.
    $( Define the algebra of univariate power series.  (Contributed by Mario
       Carneiro, 29-Dec-2014.) $)
    df-psr1 $a |- PwSer1 = ( r e. _V |-> ( ( 1o ordPwSer r ) ` (/) ) ) $.

    $( Define the base element of a univariate power series (the ` X ` element
       of the set ` R [ X ] ` of polynomials and also the ` X ` in the set
       ` R [ [ X ] ] ` of power series).  (Contributed by Mario Carneiro,
       8-Feb-2015.) $)
    df-vr1 $a |- var1 = ( r e. _V |-> ( ( 1o mVar r ) ` (/) ) ) $.

    $( Define the algebra of univariate polynomials.  (Contributed by Mario
       Carneiro, 9-Feb-2015.) $)
    df-ply1 $a |- Poly1 = ( r e. _V |->
      ( ( PwSer1 ` r ) |`s ( Base ` ( 1o mPoly r ) ) ) ) $.

    $( Define the evaluation map for the univariate polynomial algebra.  The
       function ` ( S evalSub1 R ) : V --> ( S ^m S ) ` makes sense when ` S `
       is a ring and ` R ` is a subring of ` S ` , and where ` V ` is the set
       of polynomials in ` ( Poly1 `` R ) ` .  This function maps an element of
       the formal polynomial algebra (with coefficients in ` R ` ) to a
       function from assignments to the variable from ` S ` into an element of
       ` S ` formed by evaluating the polynomial with the given assignment.
       (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    df-evls1 $a |- evalSub1 = ( s e. _V , r e. ~P ( Base ` s ) |->
      [_ ( Base ` s ) / b ]_ ( ( x e. ( b ^m ( b ^m 1o ) ) |-> ( x o.
        ( y e. b |-> ( 1o X. { y } ) ) ) ) o. ( ( 1o evalSub s ) ` r ) ) ) $.

    $( Define the evaluation map for the univariate polynomial algebra.  The
       function ` ( eval1 `` R ) : V --> ( R ^m R ) ` makes sense when ` R ` is
       a ring, and ` V ` is the set of polynomials in ` ( Poly1 `` R ) ` .
       This function maps an element of the formal polynomial algebra (with
       coefficients in ` R ` ) to a function from assignments to the variable
       from ` R ` into an element of ` R ` formed by evaluating the polynomial
       with the given assignment.  (Contributed by Mario Carneiro,
       12-Jun-2015.) $)
    df-evl1 $a |- eval1 = ( r e. _V |-> [_ ( Base ` r ) / b ]_
    ( ( x e. ( b ^m ( b ^m 1o ) ) |-> ( x o.
        ( y e. b |-> ( 1o X. { y } ) ) ) ) o. ( 1o eval r ) ) ) $.

    $( Define the coefficient function for a univariate polynomial.
       (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
    df-coe1 $a |- coe1 = ( f e. _V |-> ( n e. NN0 |->
      ( f ` ( 1o X. { n } ) ) ) ) $.

    $( Define a function which maps a coefficient function for a univariate
       polynomial to the corresponding polynomial object.  (Contributed by
       Mario Carneiro, 12-Jun-2015.) $)
    df-toply1 $a |- toPoly1 = ( f e. _V |-> ( n e. ( NN0 ^m 1o ) |->
      ( f ` ( n ` (/) ) ) ) ) $.
  $}


  $( The set of finite bags on ` 1o ` is just the set of all functions from
     ` 1o ` to ` NN0 ` .  (Contributed by Mario Carneiro, 9-Feb-2015.) $)
  psr1baslem $p |- ( NN0 ^m 1o ) =
    { f e. ( NN0 ^m 1o ) | ( `' f " NN ) e. Fin } $=
    ( cn0 c1o cmap co cv ccnv cn cima cfn wcel crab wceq rabid2 wss c0 csn snfi
    df1o2 eqeltri cdm cnvimass wf elmapi fdm syl syl5sseq ssfi sylancr mprgbir
    ) BCDEZAFZGHIZJKZAUKLMUNAUKUNAUKNULUKKZCJKUMCOUNCPQJSPRTUOULUAZUMCULHUBUOCB
    ULUCUPCMULBCUDCBULUEUFUGCUMUHUIUJ $.

  ${
    $d r R $.
    psr1val.1 $e |- S = ( PwSer1 ` R ) $.
    $( Value of the ring of univariate power series.  (Contributed by Mario
       Carneiro, 8-Feb-2015.) $)
    psr1val $p |- S = ( ( 1o ordPwSer R ) ` (/) ) $=
      ( vr cps1 cfv c0 c1o copws co cvv wcel wceq cv oveq2 fveq1d df-psr1 fvmpt
      fvex wn 0fv eqcomi fvprc reldmopsr ovprc2 3eqtr4a pm2.61i eqtri ) BAEFZGH
      AIJZFZCAKLZUIUKMDAGHDNZIJZFUKKEUMAMGUNUJUMAHIOPDQGUJSRULTZGGGFZUIUKUPGGUA
      UBAEUCUOGUJGHAIUDUEPUFUGUH $.

    $( The ring of univariate power series is a commutative ring.  (Contributed
       by Mario Carneiro, 8-Feb-2015.) $)
    psr1crng $p |- ( R e. CRing -> S e. CRing ) $=
      ( ccrg wcel c0 c1o con0 psr1val 1on a1i id cxp wss 0ss opsrcrng ) ADEZAFG
      BHABCIGHEQJKQLFGGMZNQROKP $.

    $( The ring of univariate power series is an associative algebra.
       (Contributed by Mario Carneiro, 8-Feb-2015.) $)
    psr1assa $p |- ( R e. CRing -> S e. AssAlg ) $=
      ( ccrg wcel c0 c1o con0 psr1val 1on a1i id cxp wss 0ss opsrassa ) ADEZAFG
      BHABCIGHEQJKQLFGGMZNQROKP $.

    $( The ordered power series structure is a totally ordered set.
       (Contributed by Mario Carneiro, 2-Jun-2015.) $)
    psr1tos $p |- ( R e. Toset -> S e. Toset ) $=
      ( ctos wcel c0 c1o con0 psr1val 1on a1i id cxp wss 0ss wwe 0we1 opsrtos )
      ADEZAFGBHABCIGHESJKSLFGGMZNSTOKGFPSQKR $.

    psr1bas2.b $e |- B = ( Base ` S ) $.
    ${
      psr1bas2.o $e |- O = ( 1o mPwSer R ) $.
      $( The base set of the ring of univariate power series.  (Contributed by
         Mario Carneiro, 3-Jul-2015.) $)
      psr1bas2 $p |- B = ( Base ` O ) $=
        ( cbs cfv wceq wtru c0 c1o psr1val cxp wss 0ss a1i opsrbas trud eqtr4i
        ) ACHIZDHIZFUCUBJKBDLMCGBCENLMMOZPKUDQRSTUA $.
    $}

    psr1bas.k $e |- K = ( Base ` R ) $.
    $( The base set of the ring of univariate power series.  (Contributed by
       Mario Carneiro, 8-Feb-2015.) $)
    psr1bas $p |- B = ( K ^m ( NN0 ^m 1o ) ) $=
      ( vf cn0 c1o cmap co wceq wtru cmps con0 eqid psr1baslem psr1bas2 wcel
      1on a1i psrbas trud ) ADIJKLZKLMNAUEBJBOLZHJDPUFQZGHRABCUFEFUGSJPTNUAUBUC
      UD $.
  $}

  ${
    $d f h i r x y R $.
    vr1val.1 $e |- X = ( var1 ` R ) $.
    $( The value of the generator of the power series algebra (the ` X ` in
       ` R [ [ X ] ] ` ).  Since all univariate polynomial rings over a fixed
       base ring ` R ` are isomorphic, we don't bother to pass this in as a
       parameter; internally we are actually using the empty set as this
       generator and ` 1o = { (/) } ` is the index set (but for most purposes
       this choice should not be visible anyway).  (Contributed by Mario
       Carneiro, 8-Feb-2015.)  (Revised by Mario Carneiro, 12-Jun-2015.) $)
    vr1val $p |- X = ( ( 1o mVar R ) ` (/) ) $=
      ( vr vi vx vf vh vy cvv wcel c0 c1o cmvr co cfv wceq cv1 cv cmpt oveq2 wn
      fveq1d df-vr1 fvex fvmpt syl5eq fvprc 0fv 3eqtr4g ccnv cima cfn cmap crab
      cn cn0 c1 cc0 cif cur c0g df-mvr reldmmpt2 ovprc2 eqtr4d pm2.61i ) AJKZBL
      MANOZPZQVHBARPZVJCDALMDSZNOZPVJJRVLAQLVMVIVLAMNUAUCDUDLVIUEUFUGVHUBZBLLPZ
      VJVNVKLBVOARUHCLUIUJVNLVILMANEDJJFESZGHSUKUPULUMKHUQVPUNOUOGSIVPISFSQURUS
      UTTQVLVAPVLVBPUTTTNFIGHEDVCVDVEUCVFVG $.

    vr1cl2.2 $e |- S = ( PwSer1 ` R ) $.
    vr1cl2.3 $e |- B = ( Base ` S ) $.
    $( The variable ` X ` is a member of the power series algebra
       ` R [ [ X ] ] ` .  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
    vr1cl2 $p |- ( R e. Ring -> X e. B ) $=
      ( crg wcel c0 c1o cmvr co cfv vr1val cmps cbs con0 eqid a1i 1on id mvrcl2
      0lt1o psr1val cxp wss 0ss opsrbas syl6eqr eleqtrd syl5eqel ) BHIZDJKBLMZN
      ZABDEOUMUOKBPMZQNZAUMUQBUPKUNRJUPSZUNSUQSKRIUMUATUMUBJKIUMUDTUCUMUQCQNAUM
      BUPJKCURBCFUEJKKUFZUGUMUSUHTUIGUJUKUL $.
  $}

  ${
    $d r x y R $.  $d r x y S $.
    ply1val.1 $e |- P = ( Poly1 ` R ) $.
    ${
      ply1val.2 $e |- S = ( PwSer1 ` R ) $.
      $( The value of the set of univariate polynomials.  (Contributed by Mario
         Carneiro, 9-Feb-2015.) $)
      ply1val $p |- P = ( S |`s ( Base ` ( 1o mPoly R ) ) ) $=
        ( vr cpl1 cfv c1o cmpl co cbs cress cvv wcel wceq cps1 syl6eqr c0 fvprc
        cv fveq2 oveq2 fveq2d oveq12d df-ply1 ovex fvmpt wn ress0 syl5eq oveq1d
        eqtr4d pm2.61i eqtri ) ABGHZCIBJKZLHZMKZDBNOZUPUSPFBFUAZQHZIVAJKZLHZMKU
        SNGVABPZVBCVDURMVEVBBQHZCVABQUBERVEVCUQLVABIJUCUDUEFUFCURMUGUHUTUIZUPSU
        RMKZUSVGUPSVHBGTURUJRVGCSURMVGCVFSEBQTUKULUMUNUO $.

      ply1bas.u $e |- U = ( Base ` P ) $.
      $( The value of the base set of univariate polynomials.  (Contributed by
         Mario Carneiro, 9-Feb-2015.) $)
      ply1bas $p |- U = ( Base ` ( 1o mPoly R ) ) $=
        ( cbs cfv c1o cmpl co wceq cmps eqid psr1bas2 mplbasss ply1val ressbas2
        wss ax-mp eqtr4i ) DAHIZJBKLZHIZGUECHIZTUEUCMUFUDBJBNLZUEJUDOUGOZUEOUFB
        CUGFUFOZUHPQUEUFACABCEFRUISUAUB $.

      $( Univariate polynomials form a linear subspace of the set of univariate
         power series.  (Contributed by Mario Carneiro, 9-Feb-2015.) $)
      ply1lss $p |- ( R e. Ring -> U e. ( LSubSp ` S ) ) $=
        ( vx vy crg wcel c1o co cfv con0 a1i cbs cvv c0 wa cmps clss ply1bas id
        cmpl eqid 1on mpllss eqidd psr1val cxp wss 0ss opsrbas ssv cv opsrplusg
        cplusg proplem3 cvsca ovex opsrvsca csca psrsca fveq2d opsrsca lsspropd
        eleqtrd ) BJKZDLBUAMZUBNCUBNVILBUEMZBVJDLOVJUFZVKUFABCDEFGUCLOKVIUGPZVI
        UDZUHVIHIVJQNZBQNZVJCRVIVOUIVIBVJSLCVLBCFUJZSLLUKZULVIVRUMPZUNVORULVIVO
        UOPVIHUPZRKIUPZRKTHIVJURNCURNVIBVJSLCVLVQVSUQUSVTWAVJUTNZMRKVIVTVPKWAVO
        KTZTVTWAWBVAPVIWCHIWBCUTNVIBVJSLCVLVQVSVBUSVIBVJVCNQVIBVJLOJVLVMVNVDVEV
        IBCVCNQVIBVJSLCOJVLVQVSVMVNVFVEVGVH $.

      $( Univariate polynomials form a subring of the set of univariate power
         series.  (Contributed by Mario Carneiro, 9-Feb-2015.) $)
      ply1subrg $p |- ( R e. Ring -> U e. ( SubRing ` S ) ) $=
        ( vx vy wcel c1o co csubrg cfv con0 eqid a1i c0 cv cplusg crg cmps cmpl
        ply1bas 1on id mplsubrg cbs eqidd psr1val cxp wss 0ss opsrbas opsrplusg
        wa proplem3 cmulr opsrmulr subrgpropd eleqtrd ) BUAJZDKBUBLZMNCMNVBKBUC
        LZBVCDKOVCPZVDPABCDEFGUDKOJVBUEQVBUFUGVBHIVCUHNZVCCVBVFUIVBBVCRKCVEBCFU
        JZRKKUKZULVBVHUMQZUNVBHSVFJISVFJUPZHIVCTNCTNVBBVCRKCVEVGVIUOUQVBVJHIVCU
        RNCURNVBBVCRKCVEVGVIUSUQUTVA $.
    $}

    $( The ring of univariate polynomials is a commutative ring.  (Contributed
       by Mario Carneiro, 9-Feb-2015.) $)
    ply1crng $p |- ( R e. CRing -> P e. CRing ) $=
      ( ccrg wcel cps1 cfv c1o cmpl co cbs csubrg eqid psr1crng ply1bas crngrng
      crg ply1subrg syl syl5eqelr ply1val subrgcrng syl2anc ) BDEZBFGZDEHBIJKGZ
      UELGZEADEBUEUEMZNUDUFAKGZUGABUEUICUHUIMZOUDBQEUIUGEBPABUEUICUHUJRSTUFUEAA
      BUECUHUAUBUC $.

    $( The ring of univariate polynomials is an associative algebra.
       (Contributed by Mario Carneiro, 9-Feb-2015.) $)
    ply1assa $p |- ( R e. CRing -> P e. AssAlg ) $=
      ( ccrg wcel casa cbs cfv cps1 clss crg crngrng eqid ply1subrg syl ply1lss
      csubrg cur co cress wss wa psr1assa subrg1cl subrgss cmpl ply1val ply1bas
      wb c1o oveq2i eqtr4i issubassa syl3anc mpbir2and ) BDEZAFEZAGHZBIHZQHEZUR
      USJHZEZUPBKEZUTBLZABUSURCUSMZURMZNOZUPVCVBVDABUSURCVEVFPOUPUSFEUSRHZUREZU
      RUSGHZUAZUQUTVBUBUIBUSVEUCUPUTVIVGURUSVHVHMZUDOUPUTVKVGURVJUSVJMZUEOURAVH
      VAVJUSAUSUJBUFSGHZTSUSURTSABUSCVEUGURVNUSTABUSURCVEVFUHUKULVAMVMVLUMUNUO
      $.
  $}

  ${
    psr1rcl.p $e |- P = ( PwSer1 ` R ) $.
    psr1rcl.b $e |- B = ( Base ` P ) $.
    $( A univariate power series is a multivariate power series on one index.
       (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
    psr1bascl $p |- ( F e. B -> F e. ( Base ` ( 1o mPwSer R ) ) ) $=
      ( wcel c1o cmps co cbs cfv id eqid psr1bas2 syl6eleq ) DAGZDAHCIJZKLQMACB
      REFRNOP $.

    psr1basf.k $e |- K = ( Base ` R ) $.
    $( Univariate power series base set elements are functions.  (Contributed
       by Stefan O'Rear, 25-Mar-2015.) $)
    psr1basf $p |- ( F e. B -> F : ( NN0 ^m 1o ) --> K ) $=
      ( cn0 c1o cmap co wf elmapi psr1bas eleq2s ) IJKLZEDMDEQKLADEQNACBEFGHOP
      $.
  $}

  ${
    ply1rcl.p $e |- P = ( Poly1 ` R ) $.
    ply1rcl.b $e |- B = ( Base ` P ) $.
    ply1basf.k $e |- K = ( Base ` R ) $.
    $( Univariate polynomial base set elements are functions.  (Contributed by
       Stefan O'Rear, 21-Mar-2015.) $)
    ply1basf $p |- ( F e. B -> F : ( NN0 ^m 1o ) --> K ) $=
      ( va wcel c1o cmpl co cbs cfv cn0 cmap eqid psr1baslem id syl6eleq mplelf
      cps1 ply1bas ) DAJZKCLMZNOZPKQMUFCIKEDUFRHUGRISUEDAUGUETBCCUCOZAFUHRGUDUA
      UB $.
  $}

  ${
    ply1bascl.p $e |- P = ( Poly1 ` R ) $.
    ply1bascl.b $e |- B = ( Base ` P ) $.
    $( A univariate polynomial is a univariate power series.  (Contributed by
       Stefan O'Rear, 25-Mar-2015.) $)
    ply1bascl $p |- ( F e. B -> F e. ( Base ` ( PwSer1 ` R ) ) ) $=
      ( cps1 cfv cbs c1o cmpl co eqid ply1val ressbasss eqsstri sseli ) ACGHZIH
      ZDABIHSFJCKLIHSBRBCRERMNSMOPQ $.

    $( A univariate polynomial is a multivariate polynomial on one index.
       (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
    ply1bascl2 $p |- ( F e. B -> F e. ( Base ` ( 1o mPoly R ) ) ) $=
      ( wcel c1o cmpl co cbs cfv cps1 eqid ply1bas eleq2i biimpi ) DAGDHCIJKLZG
      ARDBCCMLZAESNFOPQ $.
  $}

  ${
    $d F f n $.
    coe1fval.a $e |- A = ( coe1 ` F ) $.
    $( Value of the univariate polynomial coefficient function.  (Contributed
       by Stefan O'Rear, 21-Mar-2015.) $)
    coe1fval $p |- ( F e. V -> A =
        ( n e. NN0 |-> ( F ` ( 1o X. { n } ) ) ) ) $=
      ( vf wcel cvv cn0 c1o cv csn cxp cfv cmpt wceq elex cco1 fveq1 mpteq2dv
      df-coe1 nn0ex mptex fvmpt syl5eq syl ) CDGCHGZABIJBKLMZCNZOZPCDQUGACRNUJE
      FCBIUHFKZNZOUJHRUKCPBIULUIUHUKCSTFBUABIUIUBUCUDUEUF $.

    ${
      $d N n $.
      $( Value of an evaluated coefficient in a polynomial coefficient vector.
         (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
      coe1fv $p |- ( ( F e. V /\ N e. NN0 ) -> ( A ` N ) =
            ( F ` ( 1o X. { N } ) ) ) $=
        ( wcel cn0 cfv c1o csn cxp cmpt coe1fval fveq1d wceq sneq xpeq2d fveq2d
        vn cv eqid fvex fvmpt sylan9eq ) BDFZCGFCAHCSGISTZJZKZBHZLZHICJZKZBHZUE
        CAUJASBDEMNSCUIUMGUJUFCOZUHULBUNUGUKIUFCPQRUJUAULBUBUCUD $.

      $( Value of a multivariate coefficient in terms of the coefficient
         vector.  (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
      fvcoe1 $p |- ( ( F e. V /\ X e. ( NN0 ^m 1o ) ) ->
          ( F ` X ) = ( A ` ( X ` (/) ) ) ) $=
        ( wcel cn0 c1o cmap co wa cfv csn cxp wceq df1o2 nn0ex 0ex mapsnconst
        c0 adantl fveq2d wf elmapi 0lt1o ffvelrn sylancl coe1fv sylan2 eqtr4d )
        BCFZDGHIJFZKZDBLHTDLZMNZBLZUNALZUMDUOBULDUOOUKGHDTPQRSUAUBULUKUNGFZUQUP
        OULHGDUCTHFURDGHUDUEHGTDUFUGABUNCEUHUIUJ $.
    $}

    ${
      coe1f2.b $e |- B = ( Base ` P ) $.
      coe1f2.p $e |- P = ( PwSer1 ` R ) $.
      ${
        $d F x y $.
        coe1fval3.g $e |- G = ( y e. NN0 |-> ( 1o X. { y } ) ) $.
        $( Univariate power series coeffecient vectors expressed as a function
           composition.  (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
        coe1fval3 $p |- ( F e. B -> A = ( F o. G ) ) $=
          ( vx wcel cn0 c1o cv cfv cmpt cvv wf csn cxp ccom coe1fval co cbs wss
          cmap wceq eqid psr1basf ssv fss sylancl wa fconst6g adantl nn0ex con0
          1on elexi elmap sylibr a1i id feqmptd fveq2 fmptco syl eqtr4d ) FCMZB
          ANOAPZUAUBZFQZRZFGUCZBAFCHUDVKNOUHUEZSFTZVPVOUIVKVQEUFQZFTVSSUGVRCDEF
          VSJIVSUJUKVSULVQVSSFUMUNVRALNVQVMLPZFQVNGFVRVLNMZUOONVMTZVMVQMWAWBVRO
          VLNUPUQNOVMUROUSUTVAVBVCGANVMRUIVRKVDVRLVQSFVRVEVFVTVMFVGVHVIVJ $.
      $}

      $d B x $.  $d F x $.
      coe1f2.k $e |- K = ( Base ` R ) $.
      $( Functionality of univariate power series coefficient vectors.
         (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
      coe1f2 $p |- ( F e. B -> A : NN0 --> K ) $=
        ( vx wcel cn0 wf c1o cv csn cxp cmpt ccom cmap co psr1basf c0 df1o2 0ex
        wf1o nn0ex eqid mapsnf1o3 f1of ax-mp fco sylancl coe1fval3 feq1d mpbird
        ) EBLZMFANMFEKMOKPQRSZTZNZURMOUAUBZFENMVBUSNZVABCDEFIHJUCMVBUSUGVCKMOUS
        UDUEUHUFUSUIZUJMVBUSUKULMVBFEUSUMUNURMFAUTKABCDEUSGHIVDUOUPUQ $.
    $}

    coe1f.b $e |- B = ( Base ` P ) $.
    coe1f.p $e |- P = ( Poly1 ` R ) $.
    ${
      $d F y $.
      coe1fval2.g $e |- G = ( y e. NN0 |-> ( 1o X. { y } ) ) $.
      $( Univariate polynomial coeffecient vectors expressed as a function
         composition.  (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
      coe1fval2 $p |- ( F e. B -> A = ( F o. G ) ) $=
        ( wcel cps1 cfv cbs ccom wceq ply1bascl eqid coe1fval3 syl ) FCLFEMNZON
        ZLBFGPQCDEFJIRABUCUBEFGHUCSUBSKTUA $.
    $}

    $d B x $.  $d F x $.
    coe1f.k $e |- K = ( Base ` R ) $.
    $( Functionality of univariate polynomial coefficient vectors.
       (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
    coe1f $p |- ( F e. B -> A : NN0 --> K ) $=
      ( wcel cps1 cfv cbs cn0 wf ply1bascl eqid coe1f2 syl ) EBKEDLMZNMZKOFAPBC
      DEIHQAUBUADEFGUBRUARJST $.
  $}

  ${
    $d B y $.  $d F y $.  $d x y $.
    coe1sfi.a $e |- A = ( coe1 ` F ) $.
    coe1sfi.b $e |- B = ( Base ` P ) $.
    coe1sfi.p $e |- P = ( Poly1 ` R ) $.
    coe1sfi.z $e |- .0. = ( 0g ` R ) $.
    $( Finite support of univariate polynomial coefficient vectors.
       (Contributed by Stefan O'Rear, 21-Mar-2015.) $)
    coe1sfi $p |- ( F e. B -> ( `' A " ( _V \ { .0. } ) ) e. Fin ) $=
      ( vx vy ccnv cvv cima cn0 c1o co c0 eqid wcel csn cdif cmap cfv cmpt ccom
      cfn df1o2 nn0ex 0ex mapsncnv coe1fval2 cnveqd imaeq1d cmpl cbs ply1bascl2
      cv cpl1 elbasfv mplelsfi wf1 wf1o mapsnf1o2 f1ocnv f1of1 mp2b a1i eqeltrd
      suppfif1 ) EBUAZAMZNFUBUCZOEKPQUDRZSKUSUEUFZMZUGZMZVNOUHVLVMVSVNVLAVRLABC
      DEVQGHIKLPQVPSUIUJUKVPTZULUMUNUOVLEVQPVOFVLQDUPRZUQUEZWADEQNFWATWBTJBCDEI
      HURBCUTEDIHVAVBPVOVQVCZVLVOPVPVDPVOVQVDWCKPQVPSUIUJUKVTVEVOPVPVFPVOVQVGVH
      VIVKVJ $.
  $}

  ${
    vr1cl.x $e |- X = ( var1 ` R ) $.
    vr1cl.p $e |- P = ( Poly1 ` R ) $.
    vr1cl.b $e |- B = ( Base ` P ) $.
    $( The generator of a univariate polynomial algebra is contained in the
       base set.  (Contributed by Stefan O'Rear, 19-Mar-2015.) $)
    vr1cl $p |- ( R e. Ring -> X e. B ) $=
      ( crg wcel c0 c1o cmvr co cfv vr1val cmpl com eqid cps1 a1i ply1bas 0lt1o
      1onn id mvrcl syl5eqel ) CHIZDJKCLMZNACDEOUGAKCPMZCKUHQJUIRUHRBCCSNZAFUJR
      GUAKQIUGUCTUGUDJKIUGUBTUEUF $.
  $}

  ${
    $d ph x y $.  $d O x y $.  $d S x y $.
    opsr0.s $e |- S = ( I mPwSer R ) $.
    opsr0.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsr0.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    $( Zero in the ordered power series ring.  (Contributed by Stefan O'Rear,
       23-Mar-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    opsr0 $p |- ( ph -> ( 0g ` S ) = ( 0g ` O ) ) $=
      ( vx vy cbs cfv eqidd opsrbas cv wcel wa cplusg opsrplusg grpidpropd
      proplem3 ) AJKCLMZCFAUCNABCDEFGHIOAJPUCQKPUCQRJKCSMFSMABCDEFGHITUBUA $.

    $( One in the ordered power series ring.  (Contributed by Stefan O'Rear,
       23-Mar-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    opsr1 $p |- ( ph -> ( 1r ` S ) = ( 1r ` O ) ) $=
      ( vx vy cbs cfv eqidd opsrbas cv wcel wa cmulr opsrmulr rngidpropd
      proplem3 ) AJKCLMZCFAUCNABCDEFGHIOAJPUCQKPUCQRJKCSMFSMABCDEFGHITUBUA $.
  $}

  ${
    mplplusg.y $e |- Y = ( I mPoly R ) $.
    mplplusg.s $e |- S = ( I mPwSer R ) $.
    ${
      mplplusg.p $e |- .+ = ( +g ` Y ) $.
      $( Value of addition in a polynomial ring.  (Contributed by Stefan
         O'Rear, 21-Mar-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
      mplplusg $p |- .+ = ( +g ` S ) $=
        ( cplusg cfv cbs cvv wcel wceq fvex eqid mplval2 ressplusg ax-mp eqtr4i
        ) AEIJZCIJZHEKJZLMUBUANEKOUCUBCELEBCUCDFGUCPQUBPRST $.
    $}

    ${
      mplmulr.n $e |- .x. = ( .r ` Y ) $.
      $( Value of multiplication in a polynomial ring.  (Contributed by Stefan
         O'Rear, 21-Mar-2015.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
      mplmulr $p |- .x. = ( .r ` S ) $=
        ( cmulr cfv cbs cvv wcel wceq fvex eqid mplval2 ressmulr ax-mp eqtr4i )
        CEIJZBIJZHEKJZLMUBUANEKOUCBEUBLEABUCDFGUCPQUBPRST $.
    $}
  $}

  ${
    psr1plusg.y $e |- Y = ( PwSer1 ` R ) $.
    psr1plusg.s $e |- S = ( 1o mPwSer R ) $.
    ${
      psr1plusg.p $e |- .+ = ( +g ` Y ) $.
      $( Value of addition in a univariate power series ring.  (Contributed by
         Stefan O'Rear, 21-Mar-2015.)  (Revised by Mario Carneiro,
         2-Oct-2015.) $)
      psr1plusg $p |- .+ = ( +g ` S ) $=
        ( cplusg cfv wceq wtru c0 c1o psr1val cxp wss 0ss a1i opsrplusg trud
        eqtr4i ) ADHIZCHIZGUCUBJKBCLMDFBDENLMMOZPKUDQRSTUA $.
    $}

    ${
      psr1vscafval.n $e |- .x. = ( .s ` Y ) $.
      $( Value of scalar multiplication in a univariate power series ring.
         (Contributed by Stefan O'Rear, 21-Mar-2015.)  (Revised by Mario
         Carneiro, 2-Oct-2015.) $)
      psr1vsca $p |- .x. = ( .s ` S ) $=
        ( cvsca cfv wceq wtru c0 c1o psr1val cxp wss 0ss a1i opsrvsca trud
        eqtr4i ) CDHIZBHIZGUCUBJKABLMDFADENLMMOZPKUDQRSTUA $.
    $}

    ${
      psr1mulr.n $e |- .x. = ( .r ` Y ) $.
      $( Value of multiplication in a univariate power series ring.
         (Contributed by Stefan O'Rear, 21-Mar-2015.)  (Revised by Mario
         Carneiro, 2-Oct-2015.) $)
      psr1mulr $p |- .x. = ( .r ` S ) $=
        ( cmulr cfv wceq wtru c0 c1o psr1val cxp wss 0ss a1i opsrmulr trud
        eqtr4i ) CDHIZBHIZGUCUBJKABLMDFADENLMMOZPKUDQRSTUA $.
    $}
  $}

  ${
    ply1plusg.y $e |- Y = ( Poly1 ` R ) $.
    ply1plusg.s $e |- S = ( 1o mPoly R ) $.
    ${
      ply1plusg.p $e |- .+ = ( +g ` Y ) $.
      $( Value of addition in a univariate polynomial ring.  (Contributed by
         Stefan O'Rear, 21-Mar-2015.)  (Revised by Mario Carneiro,
         4-Jul-2015.) $)
      ply1plusg $p |- .+ = ( +g ` S ) $=
        ( cplusg cfv c1o cmps co cps1 eqid mplplusg psr1plusg cmpl cbs cvv wcel
        wceq fvex ply1val ressplusg ax-mp 3eqtr2i eqtr4i ) ADHIZCHIZGUIJBKLZHIB
        MIZHIZUHUIBUJJCFUJNZUINOULBUJUKUKNZUMULNZPJBQLZRIZSTULUHUAUPRUBUQULUKDS
        DBUKEUNUCUOUDUEUFUG $.
    $}

    ${
      ply1vscafval.n $e |- .x. = ( .s ` Y ) $.
      $( Value of scalar multiplication in a univariate polynomial ring.
         (Contributed by Stefan O'Rear, 21-Mar-2015.)  (Revised by Mario
         Carneiro, 4-Jul-2015.) $)
      ply1vsca $p |- .x. = ( .s ` S ) $=
        ( cvsca cfv c1o cmps co cps1 eqid mplvsca2 psr1vsca cmpl cbs cvv wcel
        wceq fvex ply1val ressvsca ax-mp 3eqtr2i eqtr4i ) CDHIZBHIZGUIJAKLZHIAM
        IZHIZUHBAUJUIJFUJNZUINOAUJULUKUKNZUMULNZPJAQLZRIZSTULUHUAUPRUBUQULUKDSD
        AUKEUNUCUOUDUEUFUG $.
    $}

    ${
      ply1mulr.n $e |- .x. = ( .r ` Y ) $.
      $( Value of multiplication in a univariate polynomial ring.  (Contributed
         by Stefan O'Rear, 21-Mar-2015.)  (Revised by Mario Carneiro,
         4-Jul-2015.) $)
      ply1mulr $p |- .x. = ( .r ` S ) $=
        ( cmulr cfv c1o cmps co cps1 eqid mplmulr psr1mulr cmpl cbs cvv wcel
        wceq fvex ply1val ressmulr ax-mp 3eqtr2i eqtr4i ) CDHIZBHIZGUIJAKLZHIAM
        IZHIZUHAUJUIJBFUJNZUINOAUJULUKUKNZUMULNZPJAQLZRIZSTULUHUAUPRUBUQUKDULSD
        AUKEUNUCUOUDUEUFUG $.
    $}
  $}

  ${
    $d f I $.  $d x y z ph $.  $d f x y z R $.  $d x y z S $.
    ressply1.s $e |- S = ( Poly1 ` R ) $.
    ressply1.h $e |- H = ( R |`s T ) $.
    ressply1.u $e |- U = ( Poly1 ` H ) $.
    ressply1.b $e |- B = ( Base ` U ) $.
    ressply1.2 $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    ${
      ressply1bas2.w $e |- W = ( PwSer1 ` H ) $.
      ressply1bas2.c $e |- C = ( Base ` W ) $.
      ressply1bas2.k $e |- K = ( Base ` S ) $.
      $( The base set of a restricted polynomial algebra consists of power
         series in the subring which are also polynomials (in the parent
         ring).  (Contributed by Mario Carneiro, 3-Jul-2015.) $)
      ressply1bas2 $p |- ( ph -> B = ( C i^i K ) ) $=
        ( c1o eqid cmpl co con0 cmps ply1bas wcel 1on psr1bas2 cps1 ressmplbas2
        a1i cfv ) ABCDSDUAUBZFSHUAUBZHSIUCSHUDUBZUMTLUNTGHJBMPNUESUCUFAUGUKOUOT
        ZCHJUOPQUPUHEDDUIULZIKUQTRUEUJ $.
    $}

    ressply1.p $e |- P = ( S |`s B ) $.
    $( A restricted polynomial algebra has the same base set.  (Contributed by
       Mario Carneiro, 3-Jul-2015.) $)
    ressply1bas $p |- ( ph -> B = ( Base ` P ) ) $=
      ( cbs cfv wss wceq cps1 eqid cin ressply1bas2 inss2 syl6eqss ressbas2 syl
      ) ABEOPZQBCOPRABHSPZOPZUGUAUGABUIDEFGHUGUHIJKLMUHTUITUGTZUBUIUGUCUDBUGCEN
      UJUEUF $.

    $( A restricted polynomial algebra has the same addition operation.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    ressply1add $p |- ( ( ph /\ ( X e. B /\ Y e. B ) ) ->
        ( X ( +g ` U ) Y ) = ( X ( +g ` P ) Y ) ) $=
      ( co cplusg cfv eqid wcel c1o cmpl cress con0 cps1 ply1bas 1on ressmpladd
      a1i ply1plusg oveqi cvv wceq fvex eqeltri ressplusg ax-mp 3eqtr3i 3eqtr4g
      wa cbs ) AIBUAJBUAVAVAIJUBHUCQZRSZQIJUBDUCQZBUDQZRSZQIJGRSZQIJCRSZQABVFDV
      EFVCHUBUEIJVETZLVCTZGHHUFSZBMVLTNUGUBUEUAAUHUJOVFTZUIVHVDIJVHHVCGMVKVHTUK
      ULVIVGIJERSZVERSZVIVGVNDVEEKVJVNTZUKBUMUAZVNVIUNBGVBSUMNGVBUOUPZBVNECUMPV
      PUQURVQVOVGUNVRBVOVEVFUMVMVOTUQURUSULUT $.

    $( A restricted polynomial algebra has the same multiplication operation.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    ressply1mul $p |- ( ( ph /\ ( X e. B /\ Y e. B ) ) ->
        ( X ( .r ` U ) Y ) = ( X ( .r ` P ) Y ) ) $=
      ( co cmulr cfv eqid wcel wa c1o cmpl con0 cps1 ply1bas 1on a1i ressmplmul
      cress ply1mulr oveqi cvv wceq fvex eqeltri ressmulr ax-mp 3eqtr3i 3eqtr4g
      cbs ) AIBUAJBUAUBUBIJUCHUDQZRSZQIJUCDUDQZBUKQZRSZQIJGRSZQIJCRSZQABVFDVEFV
      CHUCUEIJVETZLVCTZGHHUFSZBMVLTNUGUCUEUAAUHUIOVFTZUJVHVDIJHVCVHGMVKVHTULUMV
      IVGIJERSZVERSZVIVGDVEVNEKVJVNTZULBUNUAZVNVIUOBGVBSUNNGVBUPUQZBECVNUNPVPUR
      USVQVOVGUOVRBVEVFVOUNVMVOTURUSUTUMVA $.

    $( A restricted power series algebra has the same scalar multiplication
       operation.  (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    ressply1vsca $p |- ( ( ph /\ ( X e. T /\ Y e. B ) ) ->
        ( X ( .s ` U ) Y ) = ( X ( .s ` P ) Y ) ) $=
      ( co cvsca cfv eqid wcel c1o cmpl cress con0 cps1 ply1bas 1on ressmplvsca
      wa a1i ply1vsca oveqi cvv wceq cbs eqeltri ressvsca ax-mp 3eqtr3i 3eqtr4g
      fvex ) AIFUAJBUAUJUJIJUBHUCQZRSZQIJUBDUCQZBUDQZRSZQIJGRSZQIJCRSZQABVFDVEF
      VCHUBUEIJVETZLVCTZGHHUFSZBMVLTNUGUBUEUAAUHUKOVFTZUIVHVDIJHVCVHGMVKVHTULUM
      VIVGIJERSZVERSZVIVGDVEVNEKVJVNTZULBUNUAZVNVIUOBGUPSUNNGUPVBUQZBVNECUNPVPU
      RUSVQVOVGUOVRBVOVEVFUNVMVOTURUSUTUMVA $.
  $}

  ${
    $d x y R $.  $d x y S $.  $d x y T $.
    subrgply1.s $e |- S = ( Poly1 ` R ) $.
    subrgply1.h $e |- H = ( R |`s T ) $.
    subrgply1.u $e |- U = ( Poly1 ` H ) $.
    subrgply1.b $e |- B = ( Base ` U ) $.
    $( A subring of the base ring induces a subring of polynomials.
       (Contributed by Mario Carneiro, 3-Jul-2015.) $)
    subrgply1 $p |- ( T e. ( SubRing ` R ) -> B e. ( SubRing ` S ) ) $=
      ( vx vy csubrg cfv wcel c1o cmpl eqid wceq a1i con0 cps1 ply1bas subrgmpl
      co 1on mpan cbs eqidd cv wa cplusg ply1plusg proplem3 ply1mulr subrgpropd
      cmulr eleqtrrd ) DBMNOZAPBQUEZMNZCMNPUAOUSAVAOUFABUTDPFQUEZFPUAUTRZHVBREF
      FUBNZAIVDRJUCUDUGUSKLCUHNZCUTUSVEUIVEUTUHNSUSCBBUBNZVEGVFRVERUCTUSKUJVEOL
      UJVEOUKZKLCULNZUTULNZVHVISUSVHBUTCGVCVHRUMTUNUSVGKLCUQNZUTUQNZVJVKSUSBUTV
      JCGVCVJRUOTUNUPUR $.
  $}

  ${
    $d I a $.
    psrbaspropd.e $e |- ( ph -> ( Base ` R ) = ( Base ` S ) ) $.
    $( Property deduction for power series base set.  (Contributed by Stefan
       O'Rear, 27-Mar-2015.) $)
    psrbaspropd $p |- ( ph -> ( Base ` ( I mPwSer R ) ) =
                              ( Base ` ( I mPwSer S ) ) ) $=
      ( va cvv wcel cmps co cbs wceq wa cmap eqid psrbas eqtr4d reldmpsr ovprc1
      cfv cv ccnv cima cfn cn0 crab simpr adantr oveq1d fveq2d adantl pm2.61dan
      cn wn c0 ) ADGHZDBIJZKTZDCIJZKTZLZAUPMZURBKTZFUAUBUMUCUDHFUEDNJUFZNJZUTVB
      URVDBUQFDVCGUQOVCOVDOZUROAUPUGZPVBUTCKTZVDNJVEVBUTVDCUSFDVHGUSOVHOVFUTOVG
      PVBVCVHVDNAVCVHLUPEUHUIQQUPUNZVAAVIUQUSKVIUQUOUSDBIRSDCIRSQUJUKUL $.
  $}

  ${
    $d ph a b d y $.  $d ph x $.  $d B x y $.  $d I a b d $.  $d I c $.
    $d R a b d y $.  $d R x $.  $d S a b d y $.  $d S x $.  $d a x $.
    $d c d $.  $d d x $.
    psrplusgpropd.b1 $e |- ( ph -> B = ( Base ` R ) ) $.
    psrplusgpropd.b2 $e |- ( ph -> B = ( Base ` S ) ) $.
    psrplusgpropd.p $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` R ) y ) = ( x ( +g ` S ) y ) ) $.
    $( Property deduction for power series addition.  (Contributed by Stefan
       O'Rear, 27-Mar-2015.)  (Revised by Mario Carneiro, 3-Oct-2015.) $)
    psrplusgpropd $p |- ( ph -> ( +g ` ( I mPwSer R ) ) =
                                ( +g ` ( I mPwSer S ) ) ) $=
      ( va vb vd vc cplusg cfv co wcel eqid cvv cof cmps cbs cxp cres cmpt2 w3a
      cv ccnv cn cima cfn cn0 cmap crab cmpt wa simpl1 simp2 psrelbas ffvelrnda
      wceq syl eleqtrrd simp3 proplem syl12anc mpteq2dva wfn ffn ovex rabex a1i
      inidm eqidd offval 3eqtr4d mpt2eq3dva eqtr3d psrbaspropd mpt2eq12 syl2anc
      wf eqtrd ofmres 3eqtr4g psrplusg ) AEOPZUAZGEUBQZUCPZWKUDUEZFOPZUAZGFUBQZ
      UCPZWPUDUEZWJOPZWOOPZAKLWKWKKUHZLUHZWIQZUFZKLWPWPWTXAWNQZUFZWLWQAXCKLWKWK
      XDUFZXEAKLWKWKXBXDAWTWKRZXAWKRZUGZMNUHUIUJUKULRZNUMGUNQZUOZMUHZWTPZXMXAPZ
      WHQZUPMXLXNXOWMQZUPXBXDXIMXLXPXQXIXMXLRZUQZAXNDRXODRXPXQVBAXGXHXRURZXSXNE
      UCPZDXIXLYAXMWTXIWKXLEWJNGYAWTWJSZYASZXLSZWKSZAXGXHUSUTZVAXSADYAVBXTHVCZV
      DXSXOYADXIXLYAXMXAXIWKXLEWJNGYAXAYBYCYDYEAXGXHVEUTZVAYGVDABCDDWHWMXNXOJVF
      VGVHXIMXLXLXNXOWHXLWTXATTXIXLYAWTWCWTXLVIYFXLYAWTVJVCZXIXLYAXAWCXAXLVIYHX
      LYAXAVJVCZXLTRXIXJNXKUMGUNVKVLVMZYKXLVNZXSXNVOZXSXOVOZVPXIMXLXLXNXOWMXLWT
      XATTYIYJYKYKYLYMYNVPVQVRAWKWPVBZYOXFXEVBAEFGADYAFUCPHIVSVTZYPKLWKWKWPWPXD
      WAWBWDWKWKWHKLWEWPWPWMKLWEWFWKWHWREWJGYBYEWHSWRSWGWPWMWSFWOGWOSWPSWMSWSSW
      GWF $.

    $( Property deduction for polynomial base set.  (Contributed by Stefan
       O'Rear, 27-Mar-2015.) $)
    mplbaspropd $p |- ( ph -> ( Base ` ( I mPoly R ) ) =
                              ( Base ` ( I mPoly S ) ) ) $=
      ( va cvv wcel cmpl co cbs cfv wceq cfn eqid wa cv ccnv c0g cdif cima cmps
      crab eqtr3d psrbaspropd adantr wb grpidpropd sneqd difeq2d imaeq2d eleq1d
      csn rabeqbidv mplbas wn c0 reldmmpl ovprc1 eqtr4d fveq2d adantl pm2.61dan
      3eqtr4g ) AGLMZGENOZPQZGFNOZPQZRZAVJUAZKUBUCZLEUDQZURZUEZUFZSMZKGEUGOZPQZ
      UHVQLFUDQZURZUEZUFZSMZKGFUGOZPQZUHVLVNVPWBWIKWDWKAWDWKRVJAEFGADEPQFPQHIUI
      UJUKAWBWIULVJAWAWHSAVTWGVQAVSWFLAVRWEABCDEFHIJUMUNUOUPUQUKUSWDVKEWCVLKGVR
      VKTWCTWDTVRTVLTUTWKVMFWJVNKGWEVMTWJTWKTWETVNTUTVIVJVAZVOAWLVKVMPWLVKVBVMG
      ENVCVDGFNVCVDVEVFVGVH $.
  $}

  ${
    strov2rcl.s $e |- S = ( I F R ) $.
    strov2rcl.b $e |- B = ( Base ` S ) $.
    strov2rcl.f $e |- Rel dom F $.
    $( Reverse closure for polynomial-resembling things.  (Contributed by
       Stefan O'Rear, 27-Mar-2015.) $)
    strov2rcl $p |- ( X e. B -> I e. _V ) $=
      ( cvv wcel wn c0 noel cbs cfv co ovprc1 syl5eq fveq2d base0 eleq2d mtbiri
      3eqtr4g con4i ) EJKZFAKZUFLZUGFMKFNUHAMFUHCOPMOPAMUHCMOUHCEBDQMGEBDIRSTHU
      AUDUBUCUE $.
  $}

  ${
    $d B b c e f $.  $d F b c e f $.  $d G b c e f $.  $d I a b c d e f $.
    $d R b c e f $.  $d S b c $.  $d Z b c $.
    psropprmul.y $e |- Y = ( I mPwSer R ) $.
    psropprmul.s $e |- S = ( oppR ` R ) $.
    psropprmul.z $e |- Z = ( I mPwSer S ) $.
    psropprmul.t $e |- .x. = ( .r ` Y ) $.
    psropprmul.u $e |- .xb = ( .r ` Z ) $.
    psropprmul.b $e |- B = ( Base ` Y ) $.
    $( Reversing multiplication in a ring reverses multiplication in the power
       series ring.  (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
    psropprmul $p |- ( ( R e. Ring /\ F e. B /\ G e. B ) ->
        ( F .xb G ) = ( G .x. F ) ) $=
      ( wcel co cfv cvv vb va ve vd vc vf crg w3a cv ccnv cn cima cfn cmap crab
      cn0 cle cofr wbr cmin cof cmulr cmpt cgsu ccom cbs c0g eqid ccmn 3ad2ant1
      wa rngcmn adantr ovex rabex a1i simpll1 wf psrelbas elrabi ffvelrn syl2an
      simp3 simp2 ad2antrr ssrab2 cmps reldmpsr strov2rcl 3ad2ant3 simplr simpr
      psrbagconcl syl3anc sseldi ffvelrnd rngcl fmptd csn cdif psrbaglefi sylan
      wss cdm cnvimass dmmptss sstri ssfi sylancl wf1o psrbagconf1o eqidd fveq2
      gsumf1o wceq oveq2 fveq2d oveq12d fmptco psrbagf cc nn0cn adantl caonncan
      nncan opprmul syl6eqr mpteq2dva eqtrd mptex id coppr fvex eqeltri opprbas
      oveq2d cplusg psrmulfval fveq2i eleqtrd oppradd psrbaspropd eqtri 3eqtr4g
      gsumpropd 3eqtrd 3eqtr4rd ) BUGQZFAQZGAQZUHZUAUBUIUJUKULUMQZUBUPHUNRZUOZB
      UCUDUIUAUIZUQURUSZUDUUNUOZUCUIZGSZUUOUURUTVAZRZFSZBVBSZRZVCZVDRZVCUAUUNCU
      EUUQUEUIZFSZUUOUVGUUTRZGSZCVBSZRZVCZVDRZVCGFERFGDRUUKUAUUNUVFUVNUUKUUOUUN
      QZVKZUVFBUVEUEUUQUVIVCZVEZVDRBUVMVDRZUVNUVPUUQBVFSZUUQUVEBUVQTBVGSZUVTVHZ
      UWAVHUUKBVIQZUVOUUHUUIUWCUUJBVLVJVMUUQTQUVPUUPUDUUNUULUBUUMUPHUNVNVOVOZVP
      UVPUCUUQUVDUVTUVEUVPUURUUQQZVKZUUHUUSUVTQZUVBUVTQUVDUVTQUUHUUIUUJUVOUWEVQ
      UVPUUNUVTGVRZUURUUNQUWGUWEUUKUWHUVOUUKAUUNBIUBHUVTGKUWBUUNVHZPUUHUUIUUJWC
      ZVSVMUUPUDUURUUNVTUUNUVTUURGWAWBUWFUUNUVTUVAFUUKUUNUVTFVRUVOUWEUUKAUUNBIU
      BHUVTFKUWBUWIPUUHUUIUUJWDZVSWEUWFUUQUUNUVAUUPUDUUNWFUWFHTQZUVOUWEUVAUUQQU
      UKUWLUVOUWEUUJUUHUWLUUIABIWGHGKPWHWIWJZWEUUKUVOUWEWKUVPUWEWLUDUUNUUQUBUUO
      HTUURUWIUUQVHZWMWNWOWPUVTBUVCUUSUVBUWBUVCVHZWQWNUVEVHZWRUVPUUQUMQZUVEUJTU
      WAWSWTZULZUUQXCUWSUMQUUKUWLUVOUWQUWMUDUUNUBUUOHTUWIXAXBUWSUVEXDUUQUVEUWRX
      EUCUUQUVDUVEUWPXFXGUUQUWSXHXIUUKUWLUVOUUQUUQUVQXJUWMUEUDUUNUUQUBUUOHTUWIU
      WNXKXBXNUVPUVRUVMBVDUVPUVRUEUUQUVJUUOUVIUUTRZFSZUVCRZVCUVMUVPUEUCUUQUUQUV
      IUVDUXBUVQUVEUVPUVGUUQQZVKZUWLUVOUXCUVIUUQQUUKUWLUVOUXCUWMWEZUUKUVOUXCWKU
      VPUXCWLUDUUNUUQUBUUOHTUVGUWIUWNWMWNUVPUVQXLUVPUVEXLUURUVIXOZUUSUVJUVBUXAU
      VCUURUVIGXMUXFUVAUWTFUURUVIUUOUUTXPXQXRXSUVPUEUUQUXBUVLUXDUXBUVJUVHUVCRUV
      LUXDUXAUVHUVJUVCUXDUWTUVGFUXDUCUFUUOUVGUPHUTTUXEUVPHUPUUOVRZUXCUUKUWLUVOU
      XGUWMUUNUBUUOHTUWIXTXBVMUVPUWLUVGUUNQHUPUVGVRUXCUUKUWLUVOUWMVMUUPUDUVGUUN
      VTUUNUBUVGHTUWIXTWBUURUPQZUFUIZUPQZVKUURUURUXIUTRUTRUXIXOZUXDUXHUURYAQUXI
      YAQUXKUXJUURYBUXIYBUURUXIYEWBYCYDXQYPUVTBUVKUVCCUVHUVJUWBUWOLUVKVHZYFYGYH
      YIYPUUKUVSUVNXOZUVOUUHUUIUXMUUJUUHUVMBCTUGTUVMTQUUHUEUUQUVLUWDYJVPUUHYKCT
      QUUHCBYLSTLBYLYMYNVPUVTCVFSXOZUUHUVTBCLUWBYOZVPBYQSZCYQSXOUUHUXPBCLUXPVHU
      UAVPUUEVJVMUUFYHUUKUCUDAUUNBIEUVCUBUAGFHKPUWONUWIUWJUWKYRUUKUEUDJVFSZUUNC
      JDUVKUBUAFGHMUXQVHUXLOUWIUUKFAUXQUWKUUKHBWGRZVFSZHCWGRZVFSAUXQUUKBCHUXNUU
      KUXOVPUUBAIVFSUXSPIUXRVFKYSUUCJUXTVFMYSUUDZYTUUKGAUXQUWJUYAYTYRUUG $.
  $}

  ${
    ply1opprmul.y $e |- Y = ( Poly1 ` R ) $.
    ply1opprmul.s $e |- S = ( oppR ` R ) $.
    ply1opprmul.z $e |- Z = ( Poly1 ` S ) $.
    ply1opprmul.t $e |- .x. = ( .r ` Y ) $.
    ply1opprmul.u $e |- .xb = ( .r ` Z ) $.
    ply1opprmul.b $e |- B = ( Base ` Y ) $.
    $( Reversing multiplication in a ring reverses multiplication in the
       univariate polynomial ring.  (Contributed by Stefan O'Rear,
       27-Mar-2015.) $)
    ply1opprmul $p |- ( ( R e. Ring /\ F e. B /\ G e. B ) ->
        ( F .xb G ) = ( G .x. F ) ) $=
      ( wcel c1o co cfv eqid crg cmps cbs wceq id cps1 ply1bascl psr1bascl cmpl
      syl ply1mulr mplmulr psropprmul syl3an ) BUAPZUOFAPZFQBUBRZUCSZPZGAPZGURP
      ZFGDRGFERUDUOUEUPFBUFSZUCSZPUSAHBFJOUGVCVBBFVBTZVCTZUHUJUTGVCPVAAHBGJOUGV
      CVBBGVDVEUHUJURBCDEFGQUQQCUBRZUQTZKVFTZBUQEQQBUIRZVITZVGBVIEHJVJMUKULCVFD
      QQCUIRZVKTZVHCVKDILVLNUKULURTUMUN $.
  $}

  $( Lemma for ~ ply1basfvi and ~ deg1fvi .  (Contributed by Stefan O'Rear,
     28-Mar-2015.) $)
  00ply1bas $p |- (/) = ( Base ` ( Poly1 ` (/) ) ) $=
    ( va c0 cpl1 cfv cbs cv wcel noel c1o cc0 csn cxp cn0 cmap co wf eqid base0
    ply1basf 0nn0 fconst6 nn0ex con0 1on elexi elmap ffvelrn sylancl mto 2false
    mpbir eqriv ) ABBCDZEDZAFZBGUOUNGZUOHUPIJKLZUODZBGZURHUPMINOZBUOPUQUTGZUSUN
    UMBUOBUMQUNQRSVAIMUQPIJMTUAMIUQUBIUCUDUEUFUKUTBUQUOUGUHUIUJUL $.

  $( Protection compatibility of the univariate polynomial base set.
     (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
  ply1basfvi $p |- ( Base ` ( Poly1 ` R ) ) =
      ( Base ` ( Poly1 ` ( _I ` R ) ) ) $=
    ( cvv wcel cpl1 cfv cbs cid wceq eqcomd fveq2d wn c0 base0 00ply1bas eqtr3i
    fvi fvprc 3eqtr4a pm2.61i ) ABCZADEZFEZAGEZDEZFEZHTUAUDFTAUCDTUCAABPIJJTKZL
    FEZLDEZFEZUBUELUGUIMNOUFUALFADQJUFUDUHFUFUCLDAGQJJRS $.

  $( Protection compatibility of the univariate polynomial addition.
     (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
  ply1plusgfvi $p |- ( +g ` ( Poly1 ` R ) ) =
      ( +g ` ( Poly1 ` ( _I ` R ) ) ) $=
    ( va cid cfv cpl1 cplusg cvv wcel wceq fveq2d c0 c1o cres eqid cxp cn0 cmap
    co wtru con0 fvi wn cmpl cof ply1plusg cmps mplplusg cbs psr1baslem 1on a1i
    base0 psrbas trud cc0 csn wne wf 0nn0 fconst6 nn0ex elexi elmap mpbir map0b
    ne0i mp2b eqtr2i psrplusg xp0 reseq2i 3eqtri res0 df-plusg str0 eqtri fvprc
    c2 3eqtr4a pm2.61i eqcomi ) ACDZEDZFDZAEDZFDZAGHZWDWFIWGWCWEFWGWBAEAGUAJJWG
    UBZKEDZFDZKFDZWDWFWJLKUCRZFDZWKUDZKMZWKWJKWLWIWINWLNZWJNUEWMLKUFRZFDZWNKKOZ
    MWOWMKWQLWLWPWQNZWMNUGKWKWRKWQLWTWQUHDZKPLQRZQRZKXAXCISXAXBKWQBLKTWTULBUIXA
    NLTHSUJUKUMUNLUOUPOZXBHZXBKUQXCKIXELPXDURLUOPUSUTPLXDVALTUJVBVCVDXBXDVFXBVE
    VGVHWKNWRNVIWSKWNKVJVKVLWOKWKWNVMFVRVNVOVPVLWHWCWIFWHWBKEACVQJJWHWEKFAEVQJV
    SVTWA $.

  ${
    $d ph x y $.  $d B x y $.  $d R x y $.  $d S x y $.
    ply1baspropd.b1 $e |- ( ph -> B = ( Base ` R ) ) $.
    ply1baspropd.b2 $e |- ( ph -> B = ( Base ` S ) ) $.
    ply1baspropd.p $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` R ) y ) = ( x ( +g ` S ) y ) ) $.
    $( Property deduction for univariate polynomial base set.  (Contributed by
       Stefan O'Rear, 27-Mar-2015.) $)
    ply1baspropd $p |- ( ph -> ( Base ` ( Poly1 ` R ) ) =
          ( Base ` ( Poly1 ` S ) ) ) $=
      ( c1o cmpl co cbs cfv cpl1 mplbaspropd cps1 eqid ply1bas 3eqtr4g ) AJEKLM
      NJFKLMNEONZMNZFONZMNZABCDEFJGHIPUAEEQNZUBUARUERUBRSUCFFQNZUDUCRUFRUDRST
      $.

    $( Property deduction for univariate polynomial addition.  (Contributed by
       Stefan O'Rear, 27-Mar-2015.) $)
    ply1plusgpropd $p |- ( ph -> ( +g ` ( Poly1 ` R ) ) =
          ( +g ` ( Poly1 ` S ) ) ) $=
      ( c1o cmpl co cplusg cfv cpl1 cmps eqid mplplusg 3eqtr4g ply1plusg
      psrplusgpropd ) AJEKLZMNZJFKLZMNZEONZMNZFONZMNZAJEPLZMNJFPLZMNUCUEABCDEFJ
      GHIUAUCEUJJUBUBQZUJQUCQRUEFUKJUDUDQZUKQUEQRSUGEUBUFUFQULUGQTUIFUDUHUHQUMU
      IQTS $.
  $}

  ${
    $d ph x y $.  $d I x y $.  $d O x y $.  $d R x y $.
    opsrrng.o $e |- O = ( ( I ordPwSer R ) ` T ) $.
    opsrrng.i $e |- ( ph -> I e. V ) $.
    opsrrng.r $e |- ( ph -> R e. Ring ) $.
    opsrrng.t $e |- ( ph -> T C_ ( I X. I ) ) $.
    $( Ordered power series form a ring.  (Contributed by Stefan O'Rear,
       22-Mar-2015.) $)
    opsrrng $p |- ( ph -> O e. Ring ) $=
      ( vx vy cmps crg wcel cfv cv cplusg proplem3 cmulr co eqid psrrng opsrbas
      cbs eqidd wa opsrplusg opsrmulr rngpropd mpbid ) ADBMUAZNOENOABULDFULUBZH
      IUCAKLULUEPZULEAUNUFABULCDEUMGJUDAKQUNOLQUNOUGZKLULRPERPABULCDEUMGJUHSAUO
      KLULTPETPABULCDEUMGJUISUJUK $.

    $( Ordered power series form a left module.  (Contributed by Stefan O'Rear,
       26-Mar-2015.) $)
    opsrlmod $p |- ( ph -> O e. LMod ) $=
      ( vx vy clmod wcel eqid cbs cfv cv wa cplusg cmps psrlmod eqidd opsrplusg
      co opsrbas proplem3 crg psrsca opsrsca cvsca opsrvsca lmodpropd mpbid ) A
      DBUAUEZMNEMNABUODFUOOZHIUBAKLUOPQZBPQZBUOEAUQUCABUOCDEUPGJUFAKRZUQNLRUQNZ
      SKLUOTQETQABUOCDEUPGJUDUGABUODFUHUPHIUIABUOCDEFUHUPGJHIUJUROAUSURNUTSKLUO
      UKQEUKQABUOCDEUPGJULUGUMUN $.
  $}

  ${
    psr1rng.s $e |- S = ( PwSer1 ` R ) $.
    $( Univariate power series form a ring.  (Contributed by Stefan O'Rear,
       22-Mar-2015.) $)
    psr1rng $p |- ( R e. Ring -> S e. Ring ) $=
      ( crg wcel c0 c1o con0 psr1val 1on a1i id cxp wss 0ss opsrrng ) ADEZAFGBH
      ABCIGHEQJKQLFGGMZNQROKP $.
  $}

  ${
    ply1rng.p $e |- P = ( Poly1 ` R ) $.
    $( Univariate polynomials form a ring.  (Contributed by Stefan O'Rear,
       22-Mar-2015.) $)
    ply1rng $p |- ( R e. Ring -> P e. Ring ) $=
      ( crg wcel c1o cmpl co cbs cfv cps1 csubrg eqid ply1bas ply1subrg ply1val
      syl5eqelr subrgrng syl ) BDEZFBGHIJZBKJZLJZEADETUAAIJZUCABUBUDCUBMZUDMZNA
      BUBUDCUEUFOQUAUBAABUBCUEPRS $.
  $}

  ${
    psr1lmod.p $e |- P = ( PwSer1 ` R ) $.
    $( Univariate power series form a left module.  (Contributed by Stefan
       O'Rear, 26-Mar-2015.) $)
    psr1lmod $p |- ( R e. Ring -> P e. LMod ) $=
      ( crg wcel c0 c1o con0 psr1val 1on a1i id cxp wss 0ss opsrlmod ) BDEZBFGA
      HBACIGHEQJKQLFGGMZNQROKP $.

    $( Scalars of a univariate power series ring.  (Contributed by Stefan
       O'Rear, 4-Jul-2015.) $)
    psr1sca $p |- ( R e. V -> R = ( Scalar ` P ) ) $=
      ( wcel c1o cmps co c0 con0 eqid psr1val cxp wss 0ss a1i 1on id opsrsca )
      BCEZBFBGHZIFAJCUAKBADLIFFMZNTUBOPFJETQPTRS $.

    $( Scalars of a univariate power series ring.  (Contributed by Stefan
       O'Rear, 26-Mar-2015.)  (Revised by Mario Carneiro, 4-Jul-2015.) $)
    psr1sca2 $p |- ( _I ` R ) = ( Scalar ` P ) $=
      ( cvv wcel cid cfv csca wceq fvi psr1sca eqtrd wn c0 c5 df-sca str0 fvprc
      cps1 syl5eq fveq2d 3eqtr4a pm2.61i ) BDEZBFGZAHGZIUDUEBUFBDJABDCKLUDMZNNH
      GUEUFHOPQBFRUGANHUGABSGNCBSRTUAUBUC $.
  $}

  ${
    ply1lmod.p $e |- P = ( Poly1 ` R ) $.
    $( Univariate polynomials form a left module.  (Contributed by Stefan
       O'Rear, 26-Mar-2015.) $)
    ply1lmod $p |- ( R e. Ring -> P e. LMod ) $=
      ( crg wcel cps1 cfv clmod c1o cmpl co cbs clss eqid psr1lmod cpl1 ply1bas
      ply1lss syl5eqelr ply1val lsslmod syl2anc ) BDEZBFGZHEIBJKLGZUDMGZEAHEUDB
      UDNZOUCUEBPGZLGZUFUHBUDUIUHNZUGUINZQUHBUDUIUJUGUKRSUFUEUDAABUDCUGTUFNUAUB
      $.

    $( Scalars of a univariate polynomial ring.  (Contributed by Stefan O'Rear,
       26-Mar-2015.) $)
    ply1sca $p |- ( R e. V -> R = ( Scalar ` P ) ) $=
      ( wcel cps1 cfv csca eqid psr1sca c1o cmpl co cbs wceq fvex ply1val ax-mp
      cvv resssca syl6eq ) BCEBBFGZHGZAHGZUBBCUBIZJKBLMZNGZSEUCUDOUFNPUGUCUBASA
      BUBDUEQUCITRUA $.

    $( Scalars of a univariate polynomial ring.  (Contributed by Stefan O'Rear,
       26-Mar-2015.) $)
    ply1sca2 $p |- ( _I ` R ) = ( Scalar ` P ) $=
      ( cvv wcel cid cfv csca wceq ply1sca eqtrd wn c0 fvprc cpl1 fveq2d fveq2i
      fvi c5 df-sca str0 3eqtr4g eqtr4d pm2.61i ) BDEZBFGZAHGZIUEUFBUGBDRABDCJK
      UELZUFMUGBFNUHBOGZHGMHGUGMUHUIMHBONPAUIHCQHSTUAUBUCUD $.
  $}

  ${
    $d M x y $.  $d P x y $.  $d R x y $.  $d V x y $.
    ply1mpl0.m $e |- M = ( 1o mPoly R ) $.
    ply1mpl0.p $e |- P = ( Poly1 ` R ) $.
    ply1mpl0.z $e |- .0. = ( 0g ` P ) $.
    $( The univariate polynomial ring has the same zero as the corresponding
       multivariate polynomial ring.  (Contributed by Stefan O'Rear,
       23-Mar-2015.)  (Revised by Mario Carneiro, 3-Oct-2015.) $)
    ply1mpl0 $p |- .0. = ( 0g ` M ) $=
      ( vx vy c0g cfv wceq wtru cbs eqidd eqid a1i cv wcel cplusg c1o cmpl cps1
      co ply1bas fveq2i eqtr4i wa ply1plusg proplem3 grpidpropd trud eqtri ) DA
      JKZCJKZGUNUOLMHIANKZACMUPOUPCNKZLMUPUABUBUDZNKUQABBUCKZUPFUSPUPPUECURNEUF
      UGQMHRUPSIRUPSUHHIATKZCTKZUTVALMUTBCAFEUTPUIQUJUKULUM $.
  $}

  ${
    $d x y M $.  $d x y P $.
    ply1mpl1.m $e |- M = ( 1o mPoly R ) $.
    ply1mpl1.p $e |- P = ( Poly1 ` R ) $.
    ply1mpl1.o $e |- .1. = ( 1r ` P ) $.
    $( The univariate polynomial ring has the same one as the corresponding
       multivariate polynomial ring.  (Contributed by Stefan O'Rear,
       23-Mar-2015.)  (Revised by Mario Carneiro, 3-Oct-2015.) $)
    ply1mpl1 $p |- .1. = ( 1r ` M ) $=
      ( vx vy cur cfv wceq wtru cbs eqidd eqid a1i cv wcel cmulr c1o co ply1bas
      cmpl cps1 fveq2i eqtr4i wa ply1mulr proplem3 rngidpropd trud eqtri ) CAJK
      ZDJKZGUNUOLMHIANKZADMUPOUPDNKZLMUPUABUDUBZNKUQABBUEKZUPFUSPUPPUCDURNEUFUG
      QMHRUPSIRUPSUHHIATKZDTKZUTVALMBDUTAFEUTPUIQUJUKULUM $.
  $}

  ${
    $d x y P $.  $d x y R $.  $d x y V $.
    ply1ascl.p $e |- P = ( Poly1 ` R ) $.
    ply1ascl.a $e |- A = ( algSc ` P ) $.
    $( The univariate polynomial ring inherits the multivariate ring's scalar
       function.  (Contributed by Stefan O'Rear, 28-Mar-2015.)  (Proof
       shortened by Fan Zheng, 26-Jun-2016.) $)
    ply1ascl $p |- A = ( algSc ` ( 1o mPoly R ) ) $=
      ( vx vy cascl cfv c1o cmpl cvv wcel wceq cbs csca eqid fveq2d a1i cur 1on
      co ply1sca con0 id mplsca cv wa ply1vsca proplem3 ply1mpl1 fvex asclpropd
      cvsca wn c0 cpl1 fvprc syl5eq reldmmpl ovprc2 eqtr4d pm2.61i eqtri ) ABHI
      ZJCKUBZHIZECLMZVEVGNVHFGCOIZBPIZVFPIZBVFLVJQVKQVHCVJOBCLDUCRVHCVKOVHVFCJU
      DLVFQZJUDMVHUASVHUEUFRVHFUGVIMGUGLMUHFGBUNIZVFUNIZVMVNNVHCVFVMBDVLVMQUISU
      JBTIZVFTINVHBCVOVFVLDVOQUKSVOLMVHBTULSUMVHUOZBVFHVPBUPVFVPBCUQIUPDCUQURUS
      JCKUTVAVBRVCVD $.
  $}

  ${
    $d f I $.  $d x y z ph $.  $d f x y z R $.  $d x y z S $.
    subrg1ascl.p $e |- P = ( Poly1 ` R ) $.
    subrg1ascl.a $e |- A = ( algSc ` P ) $.
    subrg1ascl.h $e |- H = ( R |`s T ) $.
    subrg1ascl.u $e |- U = ( Poly1 ` H ) $.
    subrg1ascl.r $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    ${
      subrg1ascl.c $e |- C = ( algSc ` U ) $.
      $( The scalar injection function in a subring algebra is the same up to a
         restriction to the subring.  (Contributed by Mario Carneiro,
         4-Jul-2015.) $)
      subrg1ascl $p |- ( ph -> C = ( A |` T ) ) $=
        ( c1o cmpl co con0 eqid ply1ascl wcel 1on a1i subrgascl ) ABCOEPQZEFOHP
        QZHORUESBDEIJTKUFSORUAAUBUCMCGHLNTUD $.
    $}

    subrg1asclcl.b $e |- B = ( Base ` U ) $.
    subrg1asclcl.k $e |- K = ( Base ` R ) $.
    subrg1asclcl.x $e |- ( ph -> X e. K ) $.
    $( The scalars in a polynomial algebra are in the subring algebra iff the
       scalar value is in the subring.  (Contributed by Mario Carneiro,
       4-Jul-2015.) $)
    subrg1asclcl $p |- ( ph -> ( ( A ` X ) e. B <-> X e. T ) ) $=
      ( c1o eqid cmpl con0 ply1ascl wcel 1on a1i cps1 cfv ply1bas subrgasclcl
      co ) ABCSEUAUKZEFSHUAUKZHSIUBJULTBDEKLUCMUMTSUBUDAUEUFOGHHUGUHZCNUNTPUIQR
      UJ $.
  $}


  ${
    $d f I $.  $d x y z ph $.  $d f x y z R $.  $d x y z S $.
    subrgvr1.x $e |- X = ( var1 ` R ) $.
    subrgvr1.r $e |- ( ph -> T e. ( SubRing ` R ) ) $.
    subrgvr1.h $e |- H = ( R |`s T ) $.
    $( The variables in a subring polynomial algebra are the same as the
       original ring.  (Contributed by Mario Carneiro, 5-Jul-2015.) $)
    subrgvr1 $p |- ( ph -> X = ( var1 ` H ) ) $=
      ( c0 c1o cmvr co cfv cv1 con0 eqid wcel 1on a1i vr1val subrgmvr 3eqtr4g
      fveq1d ) AIJBKLZMIJDKLZMEDNMZAIUDUEABCDJUDOUDPJOQARSGHUAUCBEFTDUFUFPTUB
      $.

    subrgvr1cl.u $e |- U = ( Poly1 ` H ) $.
    subrgvr1cl.b $e |- B = ( Base ` U ) $.
    $( The variables in a polynomial algebra are contained in every subring
       algebra.  (Contributed by Mario Carneiro, 5-Jul-2015.) $)
    subrgvr1cl $p |- ( ph -> X e. B ) $=
      ( c0 c1o cmvr co cfv wcel con0 eqid vr1val wf cmpl 1on a1i cps1 subrgmvrf
      ply1bas 0lt1o ffvelrn sylancl syl5eqel ) AGMNCOPZQZBCGHUAANBUMUBMNRUNBRAB
      CDNFUCPZFNUMSUMTNSRAUDUEIJUOTEFFUFQZBKUPTLUHUGUINBMUMUJUKUL $.
  $}

  ${
    $d P a $.  $d R a $.  $d Y a b $.  $d .0. a $.
    coe1z.p $e |- P = ( Poly1 ` R ) $.
    coe1z.z $e |- .0. = ( 0g ` P ) $.
    coe1z.y $e |- Y = ( 0g ` R ) $.
    $( The coefficient vector of 0.  (Contributed by Stefan O'Rear,
       23-Mar-2015.) $)
    coe1z $p |- ( R e. Ring -> ( coe1 ` .0. ) = ( NN0 X. { Y } ) ) $=
      ( va vb vc crg wcel cn0 c1o cv cxp cmpt con0 eqid wceq csn ccom cco1 cmap
      cfv co wa wf fconst6g adantl nn0ex 1on elexi elmap sylibr cmpl psr1baslem
      eqidd ply1mpl0 a1i rnggrp mpl0 fconstmpt syl6eq fmptco cbs ply1rng rng0cl
      coe1fval2 3syl 3eqtr4d ) BKLZDHMNHOZUAPZQZUBZHMCQZDUCUEZMCUAZPZVLHIMMNUDU
      FZVNCCVODVLVMMLZUGNMVNUHZVNWALWBWCVLNVMMUIUJMNVNUKNRULUMUNUOVLVOURVLDWAVS
      PIWACQVLWANBUPUFZBJNCRDWDSZJUQGABWDDWEEFUSNRLVLULUTBVAVBIWACVCVDIOVNTCURV
      EVLAKLDAVFUEZLVRVPTABEVGWFADWFSZFVHHVRWFABDVOVRSWGEVOSVIVJVTVQTVLHMCVCUTV
      K $.
  $}

  ${
    $d B a $.  $d F a $.  $d G a $.  $d .+b a $.
    coe1add.y $e |- Y = ( Poly1 ` R ) $.
    coe1add.b $e |- B = ( Base ` Y ) $.
    coe1add.p $e |- .+b = ( +g ` Y ) $.
    coe1add.q $e |- .+ = ( +g ` R ) $.
    $( The coefficient vector of an addition.  (Contributed by Stefan O'Rear,
       24-Mar-2015.) $)
    coe1add $p |- ( ( R e. Ring /\ F e. B /\ G e. B ) ->
      ( coe1 ` ( F .+b G ) ) = ( ( coe1 ` F ) oF .+ ( coe1 ` G ) ) ) $=
      ( va wcel co cn0 c1o ccom cfv eqid cvv crg w3a csn cxp cmpt cof cco1 cmpl
      cv cps1 ply1bas ply1plusg simp2 simp3 mpladd coeq1d cmap wfn cbs ply1basf
      wf ffn syl 3ad2ant2 3ad2ant3 wf1o c0 df1o2 nn0ex mapsnf1o3 f1of mp1i ovex
      0ex a1i inidm ofco eqtrd ply1rng rngacl syl3an1 coe1fval2 oveq12d 3eqtr4d
      wceq ) DUAMZEAMZFAMZUBZEFCNZLOPLUIUCUDUEZQZEWKQZFWKQZBUFZNZWJUGRZEUGRZFUG
      RZWONWIWLEFWONZWKQWPWIWJWTWKWIAPDUHNZBCDPEFXASZGDDUJRZAHXCSIUKKCDXAGHXBJU
      LWFWGWHUMWFWGWHUNUOUPWIOPUQNZXDXDOBEFWKTTTWGWFEXDURZWHWGXDDUSRZEVAXEAGDEX
      FHIXFSZUTXDXFEVBVCVDWHWFFXDURZWGWHXDXFFVAXHAGDFXFHIXGUTXDXFFVBVCVEOXDWKVF
      OXDWKVAWILOPWKVGVHVIVNWKSZVJOXDWKVKVLXDTMWIOPUQVMVOZXJOTMWIVIVOXDVPVQVRWI
      WJAMZWQWLWEWFGUAMWGWHXKGDHVSACGEFIJVTWALWQAGDWJWKWQSIHXIWBVCWIWRWMWSWNWOW
      GWFWRWMWEWHLWRAGDEWKWRSIHXIWBVDWHWFWSWNWEWGLWSAGDFWKWSSIHXIWBVEWCWD $.

    $( A particular coefficient of an addition.  (Contributed by Stefan O'Rear,
       23-Mar-2015.) $)
    coe1addfv $p |- ( ( ( R e. Ring /\ F e. B /\ G e. B ) /\ X e. NN0 ) ->
        ( ( coe1 ` ( F .+b G ) ) ` X ) =
          ( ( ( coe1 ` F ) ` X ) .+ ( ( coe1 ` G ) ` X ) ) ) $=
      ( wcel cn0 co cco1 cfv wceq adantr eqid crg w3a wa cof coe1add fveq1d wfn
      cvv cbs wf coe1f ffn syl 3ad2ant2 3ad2ant3 nn0ex a1i simpr syl22anc eqtrd
      fnfvof ) DUAMZEAMZFAMZUBZGNMZUCZGEFCOPQZQGEPQZFPQZBUDOZQZGVIQGVJQBOZVGGVH
      VKVEVHVKRVFABCDEFHIJKLUESUFVGVINUGZVJNUGZNUHMZVFVLVMRVEVNVFVCVBVNVDVCNDUI
      QZVIUJVNVIAHDEVQVITJIVQTZUKNVQVIULUMUNSVEVOVFVDVBVOVCVDNVQVJUJVOVJAHDFVQV
      JTJIVRUKNVQVJULUMUOSVPVGUPUQVEVFURNBVIVJUHGVAUSUT $.
  $}

  ${
    coe1sub.y $e |- Y = ( Poly1 ` R ) $.
    coe1sub.b $e |- B = ( Base ` Y ) $.
    coe1sub.p $e |- .- = ( -g ` Y ) $.
    coe1sub.q $e |- N = ( -g ` R ) $.
    $( A particular coefficient of a subtraction.  (Contributed by Stefan
       O'Rear, 23-Mar-2015.) $)
    coe1subfv $p |- ( ( ( R e. Ring /\ F e. B /\ G e. B ) /\ X e. NN0 ) ->
        ( ( coe1 ` ( F .- G ) ) ` X ) =
          ( ( ( coe1 ` F ) ` X ) N ( ( coe1 ` G ) ` X ) ) ) $=
      ( wcel cn0 cco1 cfv co wceq adantr eqid crg wa cplusg simpl1 cgrp ply1rng
      w3a rnggrp syl grpsubcl syl3an1 simpl3 coe1addfv syl31anc 3ad2ant1 simpl2
      simpr grpnpcan syl3anc fveq2d fveq1d eqtr3d wb wf coe1f 3ad2ant2 3ad2ant3
      cbs ffvelrnda grpsubadd syl13anc mpbird eqcomd ) BUAMZCAMZDAMZUGZGNMZUBZG
      COPZPZGDOPZPZFQZGCDEQZOPZPZVSWDWGRZWGWCBUCPZQZWARZVSGWEDHUCPZQZOPZPZWJWAV
      SVNWEAMZVPVRWOWJRVNVOVPVRUDVQWPVRVNHUEMZVOVPWPVNHUAMWQHBIUFHUHUIZAHECDJKU
      JUKZSVNVOVPVRULZVQVRUQAWIWLBWEDGHIJWLTZWITZUMUNVSGWNVTVSWMCOVSWQVOVPWMCRV
      QWQVRVNVOWQVPWRUOSVNVOVPVRUPWTAWLHECDJXAKURUSUTVAVBVSBUEMZWABVHPZMWCXDMWG
      XDMWHWKVCVQXCVRVNVOXCVPBUHUOSVQNXDGVTVOVNNXDVTVDVPVTAHBCXDVTTJIXDTZVEVFVI
      VQNXDGWBVPVNNXDWBVDVOWBAHBDXDWBTJIXEVEVGVIVQNXDGWFVQWPNXDWFVDWSWFAHBWEXDW
      FTJIXEVEUIVIXDWIBFWAWCWGXEXBLVJVKVLVM $.
  $}

  ${
    $d A a $.  $d X a $.
    $( An equivalence for ~ coe1mul2 .  (Contributed by Stefan O'Rear,
       25-Mar-2015.) $)
    coe1mul2lem1 $p |- ( ( A e. NN0 /\ X e. ( NN0 ^m 1o ) ) ->
          ( X oR <_ ( 1o X. { A } ) <-> ( X ` (/) ) e. ( 0 ... A ) ) ) $=
      ( va cn0 wcel c1o co wa csn cxp cle wbr c0 con0 cvv cmpt adantl fconstmpt
      a1i wceq cmap cofr cfv wral cc0 cfz cv fvex simpll df1o2 nn0ex mapsnconst
      1on 0ex syl6eq ofrfval2 wne wb 1n0 r19.3rzv mp1i wf 0lt1o ffvelrn sylancl
      elmapi biantrurd fznn0 adantr bitr4d 3bitr2d ) ADEZBDFUAGEZHZBFAIJZKUBLMB
      UCZAKLZCFUDZVQVPUEAUFGEZVNCFVPAKBVONODFNEVNUMSVPOEVNCUGFEZHMBUHSVLVMVTUIV
      NBFVPIJZCFVPPVMBWATVLDFBMUJUKUNULQCFVPRUOVOCFAPTVNCFARSUPFMUQVQVRURVNUSVQ
      CFUTVAVNVQVPDEZVQHZVSVNWBVQVMWBVLVMFDBVBMFEWBBDFVFVCFDMBVDVEQVGVLVSWCURVM
      VPAVHVIVJVK $.

    $d H c $.  $d a k $.  $d c d k $.
    coe1mul2lem2.h $e |- H = { d e. ( NN0 ^m 1o ) |
          d oR <_ ( 1o X. { k } ) } $.
    $( An equivalence for ~ coe1mul2 .  (Contributed by Stefan O'Rear,
       25-Mar-2015.) $)
    coe1mul2lem2 $p |- ( k e. NN0 ->
        ( c e. H |-> ( c ` (/) ) ) : H -1-1-onto-> ( 0 ... k ) ) $=
      ( va cv cn0 wcel c1o co c0 cfv cmpt cima wf1o wss ax-mp crab wceq cc0 cfz
      cmap cres wf1 df1o2 nn0ex 0ex eqid mapsnf1o2 f1of1 csn cxp cle wbr ssrab2
      cofr eqsstri a1i f1ores sylancr ccnv coe1mul2lem1 rabbidva eleq1d cbvrabv
      wb fveq1 syl6eqr mptpreima 3eqtr4g imaeq2d wfo f1ofo ssriv foimacnv mp2an
      elfznn0 syl6eq f1oeq3 syl resmpt f1oeq1 3syl bitrd mpbid ) AGZHIZBCHJUCKZ
      LCGZMZNZBOZWLBUDZPZBUAWGUBKZCBWKNZPZWHWIHWLUEZBWIQZWOWIHWLPZWSCHJWLLUFUGU
      HWLUIZUJZWIHWLUKRWTWHBDGZJWGULUMUNUQUOZDWISZWIEXEDWIUPURUSZWIHBWLUTVAWHWO
      BWPWNPZWRWHWMWPTWOXHVGWHWMWLWLVBWPOZOZWPWHBXIWLWHXFWKWPIZCWISZBXIWHXFLXDM
      ZWPIZDWISXLWHXEXNDWIWGXDVCVDXKXNCDWIWJXDTWKXMWPLWJXDVHVEVFVIECWIWKWPWLXBV
      JVKVLWIHWLVMZWPHQXJWPTXAXOXCWIHWLVNRFWPHFGWGVRVOWIHWPWLVPVQVSWMWPBWNVTWAW
      HWTWNWQTXHWRVGXGCWIBWKWBBWPWNWQWCWDWEWF $.
  $}

  ${
    $d a b c d k x $.  $d b c k x B $.  $d b c k x F $.  $d b c k x .x. $.
    $d b c k x G $.  $d b c k x R $.  $d k .xb $.
    coe1mul2.s $e |- S = ( PwSer1 ` R ) $.
    coe1mul2.t $e |- .xb = ( .r ` S ) $.
    coe1mul2.u $e |- .x. = ( .r ` R ) $.
    coe1mul2.b $e |- B = ( Base ` S ) $.
    $( The coefficient vector of multiplication in the univariate power series
       ring.  (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
    coe1mul2 $p |- ( ( R e. Ring /\ F e. B /\ G e. B ) ->
        ( coe1 ` ( F .xb G ) ) = ( k e. NN0 |-> ( R gsum ( x e. ( 0 ... k ) |->
                ( ( ( coe1 ` F ) ` x ) .x.
                  ( ( coe1 ` G ) ` ( k - x ) ) ) ) ) ) ) $=
      ( vc wcel co cn0 c1o cfv eqid vd vb va crg w3a csn cxp cmpt ccom cle cofr
      cv wbr cmap crab cmin cof cgsu cco1 cc0 cfz fconst6g nn0ex con0 1on elexi
      wf elmap sylibr adantl eqidd cmps psr1bas2 psr1mulr psr1baslem psrmulfval
      simp2 simp3 wceq breq2 rabbidv oveq1 fveq2d oveq2d mpteq12dv fmptco rngcl
      psr1rng syl3an1 coe1fval3 syl cbs cfn c0g ccmn simpl1 rngcmn fzfi simpll1
      wa c0 simpll2 coe1f2 elfznn0 ffvelrnd simpll3 fznn0sub syl3anc fmptd ccnv
      a1i cvv cdif cima wss cnvimass dmmptss sstri ssfi mp2an wf1o coe1mul2lem2
      cdm gsumf1o breq1 elrab simprbi wb simplr elrabi coe1mul2lem1 mpbid fveq2
      syl2anc oveq2 oveq12d fvcoe1 eqtrd eqtr4d mpteq2dva df1o2 mapsnconst fvex
      0ex vex ofc12 coe1fv 3eqtr4d ) CUDOZHBOZIBOZUEZHIEPZGQRGULZUFUGZUHZUIZGQC
      NUAULZUUOUJUKZUMZUAQRUNPZUOZNULZHSZUUOUVCUPUQZPZISZFPZUHZURPZUHUUMUSSZGQC
      AUTUUNVAPZAULZHUSSZSZUUNUVMUPPZIUSSZSZFPZUHZURPZUHUULGUBQUVAUUOCNUURUBULZ
      UUSUMZUAUVAUOZUVDUWBUVCUVEPZISZFPZUHZURPUVJUUPUUMUUNQOZUUOUVAOZUULUWIRQUU
      OVGUWJRUUNQVBQRUUOVCRVDVEVFVHVIVJUULUUPVKUULNUABUVACRCVLPZEFUCUBHIRUWKTZB
      CDUWKJMUWLVMLCUWKEDJUWLKVNUCVOUUIUUJUUKVQUUIUUJUUKVRVPUWBUUOVSZUWHUVICURU
      WMNUWDUWGUVBUVHUWMUWCUUTUAUVAUWBUUOUURUUSVTWAUWMUWFUVGUVDFUWMUWEUVFIUWBUU
      OUVCUVEWBWCWDWEWDWFUULUUMBOZUVKUUQVSUUIDUDOUUJUUKUWNCDJWHBDEHIMKWGWIGUVKB
      DCUUMUUPUVKTMJUUPTWJWKUULGQUWAUVJUULUWIWTZUWACUVTNUVBXAUVCSZUHZUIZURPUVJU
      WOUVLCWLSZUVBUVTCUWQWMCWNSZUWSTZUWTTUWOUUICWOOUUIUUJUUKUWIWPCWQWKUVLWMOZU
      WOUTUUNWRZXKUWOAUVLUVSUWSUVTUWOUVMUVLOZWTZUUIUVOUWSOUVRUWSOUVSUWSOUUIUUJU
      UKUWIUXDWSUXEQUWSUVMUVNUXEUUJQUWSUVNVGUUIUUJUUKUWIUXDXBUVNBDCHUWSUVNTZMJU
      XAXCWKUXDUVMQOUWOUVMUUNXDVJXEUXEQUWSUVPUVQUXEUUKQUWSUVQVGUUIUUJUUKUWIUXDX
      FUVQBDCIUWSUVQTZMJUXAXCWKUXDUVPQOUWOUVMUTUUNXGVJXEUWSCFUVOUVRUXALWGXHUVTT
      ZXIUVTXJXLUWTUFXMZXNZWMOZUWOUXBUXJUVLXOUXKUXCUXJUVTYCUVLUVTUXIXPAUVLUVSUV
      TUXHXQXRUVLUXJXSXTXKUWIUVBUVLUWQYAUULGUVBNUAUVBTYBVJYDUWOUWRUVICURUWOUWRN
      UVBUWPUVNSZUUNUWPUPPZUVQSZFPZUHUVIUWONAUVBUVLUWPUVSUXOUWQUVTUWOUVCUVBOZWT
      ZUVCUUOUUSUMZUWPUVLOZUXPUXRUWOUXPUVCUVAOZUXRUUTUXRUAUVCUVAUURUVCUUOUUSYEY
      FYGVJUXQUWIUXTUXRUXSYHUULUWIUXPYIUXPUXTUWOUUTUAUVCUVAYJVJZUUNUVCYKYNYLZUW
      OUWQVKUWOUVTVKUVMUWPVSZUVOUXLUVRUXNFUVMUWPUVNYMUYCUVPUXMUVQUVMUWPUUNUPYOW
      CYPWFUWONUVBUVHUXOUXQUVDUXLUVGUXNFUXQUUJUXTUVDUXLVSUUIUUJUUKUWIUXPXBUYAUV
      NHBUVCUXFYQYNUXQUVGRUXMUFUGZISZUXNUXQUVFUYDIUXQUVFUUORUWPUFUGZUVEPUYDUXQU
      VCUYFUUOUVEUXQUXTUVCUYFVSUYAQRUVCXAUUAVCUUDUUBWKWDUXQRUUNUWPUPVDXLXLRVDOU
      XQVEXKUUNXLOUXQGUUEXKUWPXLOUXQXAUVCUUCXKUUFYRWCUXQUUKUXMQOZUXNUYEVSUUIUUJ
      UUKUWIUXPXFUXQUXSUYGUYBUWPUTUUNXGWKUVQIUXMBUXGUUGYNYSYPYTYSWDYRYTUUH $.
  $}

  ${
    $d k x F $.  $d k x G $.  $d k x R $.  $d k .xb $.  $d k x .x. $.
    coe1mul.s $e |- Y = ( Poly1 ` R ) $.
    coe1mul.t $e |- .xb = ( .r ` Y ) $.
    coe1mul.u $e |- .x. = ( .r ` R ) $.
    coe1mul.b $e |- B = ( Base ` Y ) $.
    $( The coefficient vector of multiplication in the univariate polynomial
       ring.  (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
    coe1mul $p |- ( ( R e. Ring /\ F e. B /\ G e. B ) ->
        ( coe1 ` ( F .xb G ) ) = ( k e. NN0 |-> ( R gsum ( x e. ( 0 ... k ) |->
                ( ( ( coe1 ` F ) ` x ) .x.
                  ( ( coe1 ` G ) ` ( k - x ) ) ) ) ) ) ) $=
      ( wcel cfv co cco1 cv eqid c1o crg cps1 cbs cn0 cc0 cfz cmin cmpt cgsu id
      wceq ply1bascl cmps cmpl ply1mulr mplmulr psr1mulr eqtr4i coe1mul2 syl3an
      cmulr ) CUANZVBGBNGCUBOZUCOZNHBNHVDNGHDPQOFUDCAUEFRZUFPARZGQOOVEVFUGPHQOO
      EPUHUIPUHUKVBUJBICGJMULBICHJMULAVDCVCDEFGHVCSZDTCUMPZVAOVCVAOZCVHDTTCUNPZ
      VJSZVHSZCVJDIJVKKUOUPCVHVIVCVGVLVISUQURLVDSUSUT $.
  $}

  ${
    ply1tmcl.k $e |- K = ( Base ` R ) $.
    ply1tmcl.p $e |- P = ( Poly1 ` R ) $.
    ply1tmcl.x $e |- X = ( var1 ` R ) $.
    ply1tmcl.m $e |- .x. = ( .s ` P ) $.
    ply1tmcl.n $e |- N = ( mulGrp ` P ) $.
    ply1tmcl.e $e |- .^ = ( .g ` N ) $.
    ply1tmcl.b $e |- B = ( Base ` P ) $.
    $( Closure of the expression for a univariate polynomial term.
       (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
    ply1tmcl $p |- ( ( R e. Ring /\ C e. K /\ D e. NN0 ) ->
        ( C .x. ( D .^ X ) ) e. B ) $=
      ( crg wcel 3ad2ant1 cn0 clmod co ply1lmod simp2 cmnd ply1rng rngmgp simp3
      w3a syl vr1cl mgpbas mulgnn0cl syl3anc cid cfv ply1sca2 c1 df-base strfvi
      cbs lmodvscl ) ERSZBHSZCUASZUJZDUBSZVECJGUCZASZBVIFUCASVDVEVHVFDELUDTVDVE
      VFUEVGIUFSZVFJASZVJVDVEVKVFVDDRSVKDELUGDIOUHUKTVDVEVFUIVDVEVLVFADEJMLQULT
      AGICJADIOQUMPUNUOBFEUPUQHADVIQDELURNEVBUSHUTKVAVCUO $.
  $}


  ${
    $d a b x y .0. $.  $d b x y C $.  $d a b x y D $.  $d x F $.  $d b x y K $.
    $d x y .^ $.  $d x y A $.  $d x y N $.  $d x y P $.  $d x y X $.  $d x Y $.
    $d x y ph $.  $d a b x y R $.  $d x y .x. $.  $d x y .X. $.  $d x .xb $.
    coe1tm.z $e |- .0. = ( 0g ` R ) $.
    coe1tm.k $e |- K = ( Base ` R ) $.
    coe1tm.p $e |- P = ( Poly1 ` R ) $.
    coe1tm.x $e |- X = ( var1 ` R ) $.
    coe1tm.m $e |- .x. = ( .s ` P ) $.
    coe1tm.n $e |- N = ( mulGrp ` P ) $.
    coe1tm.e $e |- .^ = ( .g ` N ) $.
    $( Coefficient vector of a polynomial term.  (Contributed by Stefan O'Rear,
       27-Mar-2015.) $)
    coe1tm $p |- ( ( R e. Ring /\ C e. K /\ D e. NN0 ) ->
        ( coe1 ` ( C .x. ( D .^ X ) ) ) =
          ( x e. NN0 |-> if ( x = D , C , .0. ) ) ) $=
      ( c1o wceq vb vy va crg wcel cn0 w3a co cco1 cfv cv csn cxp cmpt ccom cc0
      c0 cif cbs eqid ply1tmcl coe1fval2 syl cmap fconst6g nn0ex con0 1on elexi
      wf elmap sylibr adantl cmvr cmpl cmgp cmg cur cvv mgpbas a1i cps1 ply1bas
      eqidd wss ssv cplusg wa cmulr mgpplusg ply1mulr eqtr3i proplem3 mulgpropd
      ovex 3ad2ant1 vr1val oveq123d oveq2d psr1baslem simp1 0lt1o simp3 mplcoe3
      ply1vsca elsni eleq2s iftrue mpteq2dva fconstmpt syl6eqr 3ad2ant3 eqeltrd
      df1o2 simp2 mplmon2 3eqtr2d eqeq1 ifbid fmptco adantr eqeq2d vex fvconst2
      fveq1 simpl3 fvconst2g sylancl eqeq12d syl5ib xpeq2d impbid1 bitrd 3eqtrd
      mp1i sneq ) EUDUEZBHUEZCUFUEZUGZBCJGUHZFUHZUIUJZUUBAUFSAUKZULZUMZUNZUOZAU
      FUUFUASUAUKZUQTZCUPURZUNZTZBKURZUNAUFUUDCTZBKURZUNYTUUBDUSUJZUEUUCUUHTUUQ
      BCDEFGHIJMNOPQRUUQUTZVAAUUCUUQDEUUBUUGUUCUTUURNUUGUTVBVCYTAUBUFUFSVDUHZUU
      FUBUKZUULTZBKURZUUNUUGUUBUUDUFUEZUUFUUSUEZYTUVCSUFUUFVJUVDSUUDUFVEUFSUUFV
      FSVGVHVIZVKVLVMYTUUGWDYTUUBBCUQSEVNUHZUJZSEVOUHZVPUJZVQUJZUHZFUHBUBUUSUVA
      EVRUJZKURUNZFUHUBUUSUVBUNYTUUAUVKBFYTCCJUVGGUVJYQYRGUVJTYSYQAUBUUQGUVJIUV
      IVSRUVJUTZUUQIUSUJTYQUUQDIQUURVTWAUUQUVIUSUJTYQUUQUVHUVIUVIUTZDEEWBUJZUUQ
      NUVPUTUURWCVTWAUUQVSWEYQUUQWFWAUUDUUTIWGUJZUHVSUEYQUUDVSUEUUTVSUEWHZWHUUD
      UUTUVQWOWAYQUVRAUBUVQUVIWGUJZUVQUVSTYQDWIUJZUVQUVSDUVTIQUVTUTZWJUVHUVTUVI
      UVOEUVHUVTDNUVHUTZUWAWKWJWLWAWMWNWPYTCWDJUVGTYTEJOWQWAWRWSYTUVMUVKBFYTUBU
      USUVHEUVLUCUAUVJUVISCUVFVGUQKUWBUCWTZLUVLUTZSVGUEYTVHWAZUVOUVNUVFUTYQYRYS
      XAZUQSUEZYTXBWAYQYRYSXCXDWSYTUBHUUSUVHEFUVLUCSUULVGBKUWBEUVHFDNUWBPXEUWCU
      WDLMUWEUWFYTUULSCULZUMZUUSYTUULUASCUNUWIYTUASUUKCUUISUEZUUKCTZYTUWJUUJUWK
      UUJUUIUQULSUUIUQXFXNXGUUJCUPXHVCVMXIUASCXJXKZYSYQUWIUUSUEZYRYSSUFUWIVJUWM
      SCUFVEUFSUWIVFUVEVKVLXLXMYQYRYSXOXPXQUUTUUFTUVAUUMBKUUTUUFUULXRXSXTYTAUFU
      UNUUPYTUVCWHZUUMUUOBKUWNUUMUUFUWITZUUOUWNUULUWIUUFYTUULUWITUVCUWLYAYBUWNU
      WOUUOUWOUQUUFUJZUQUWIUJZTUWNUUOUQUUFUWIYEUWNUWPUUDUWQCUWGUWPUUDTUWNXBSUUD
      UQAYCYDYOUWNYSUWGUWQCTYQYRYSUVCYFXBSCUQUFYGYHYIYJUUOUUEUWHSUUDCYPYKYLYMXS
      XIYN $.

    ${
      $( Nonzero coefficient of a polynomial term.  (Contributed by Stefan
         O'Rear, 27-Mar-2015.) $)
      coe1tmfv1 $p |- ( ( R e. Ring /\ C e. K /\ D e. NN0 ) ->
          ( ( coe1 ` ( C .x. ( D .^ X ) ) ) ` D ) = C ) $=
        ( vx wcel cn0 crg w3a co cco1 cfv cv wceq cif coe1tm fveq1d simp3 simp2
        cmpt iftrue eqid fvmptg syl2anc eqtrd ) DUASZAGSZBTSZUBZBABIFUCEUCUDUEZ
        UEBRTRUFBUGZAJUHZUMZUEZAVBBVCVFRABCDEFGHIJKLMNOPQUIUJVBVAUTVGAUGUSUTVAU
        KUSUTVAULRBVEATGVFVDAJUNVFUOUPUQUR $.

      coe1tmfv2.r $e |- ( ph -> R e. Ring ) $.
      coe1tmfv2.c $e |- ( ph -> C e. K ) $.
      coe1tmfv2.d $e |- ( ph -> D e. NN0 ) $.
      coe1tmfv2.f $e |- ( ph -> F e. NN0 ) $.
      coe1tmfv2.q $e |- ( ph -> D =/= F ) $.
      $( Zero coefficient of a polynomial term.  (Contributed by Stefan O'Rear,
         27-Mar-2015.) $)
      coe1tmfv2 $p |- ( ph ->
        ( ( coe1 ` ( C .x. ( D .^ X ) ) ) ` F ) = .0. ) $=
        ( vx co cco1 cfv cn0 cv wceq cif cmpt wcel coe1tm syl3anc fveq1d rng0cl
        crg syl ifcl syl2anc eqeq1 ifbid fvmptg wn necomd neneqd iffalse 3eqtrd
        eqid ) AHBCKGUFFUFUGUHZUHHUEUIUEUJZCUKZBLULZUMZUHZHCUKZBLULZLAHVLVPAEUS
        UNZBIUNZCUIUNVLVPUKTUAUBUEBCDEFGIJKLMNOPQRSUOUPUQAHUIUNVSIUNZVQVSUKUCAW
        ALIUNZWBUAAVTWCTIELNMURUTVRBLIVAVBUEHVOVSUIIVPVMHUKVNVRBLVMHCVCVDVPVKVE
        VBAVRVFVSLUKAHCACHUDVGVHVRBLVIUTVJ $.
    $}

    coe1tmmul.b $e |- B = ( Base ` P ) $.
    coe1tmmul.t $e |- .xb = ( .r ` P ) $.
    coe1tmmul.u $e |- .X. = ( .r ` R ) $.
    coe1tmmul.a $e |- ( ph -> A e. B ) $.
    coe1tmmul.r $e |- ( ph -> R e. Ring ) $.
    coe1tmmul.c $e |- ( ph -> C e. K ) $.
    coe1tmmul.d $e |- ( ph -> D e. NN0 ) $.
    $( Coefficient vector of a polynomial multiplied on the right by a term.
       (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
    coe1tmmul2 $p |- ( ph -> ( coe1 ` ( A .xb ( C .x. ( D .^ X ) ) ) ) =
          ( x e. NN0 |-> if ( D <_ x ,
              ( ( ( coe1 ` A ) ` ( x - D ) ) .X. C ) , .0. ) ) ) $=
      ( vy co cco1 cfv cn0 cc0 cfz cmin cmpt cgsu cle wbr cif crg wcel ply1tmcl
      cv wceq syl3anc coe1mul wa eqeq2 cvv cmnd adantr rngmnd syl a1i simprr wb
      ovex simprl nn0sub syl2anc mpbid nn0ge0d cr nn0re ad2antrl subge02d fznn0
      nn0red mpbir2and ad2antrr wf coe1f elfznn0 adantl ffvelrnd fznn0sub rngcl
      eqid fmptd csn cdif eldifi wne eldifsn simplrl nn0cnd nncand eqcomd oveq2
      cc eqeq2d syl5ibrcom necon3d impr sylan2b coe1tmfv2 oveq2d sylan2 suppss2
      rngrz eqtrd gsumpt fveq2 fveq2d oveq12d fvmpt coe1tmfv1 3eqtrd anassrs wn
      ad2antll ad2antlr clt ltnled mpbird mpteq2dva lelttrd gtned gsumz sylancl
      ifbothda ) ACEFOLULJULZIULUMUNZBUOHUKUPBVGZUQULZUKVGZCUMUNZUNZUUHUUJURULZ
      UUFUMUNZUNZKULZUSZUTULZUSZBUOFUUHVAVBZUUHFURULZUUKUNZEKULZPVCZUSAHVDVEZCD
      VEZUUFDVEZUUGUUSVHUHUGAUVEEMVEZFUOVEZUVGUHUIUJDEFGHJLMNORSTUAUBUCUDVFVIZU
      KDHIKBCUUFGSUEUFUDVJVIABUOUURUVDUUTUURUVCVHZUURPVHUURUVDVHAUUHUOVEZVKZUVC
      PUVCUVDUURVLPUVDUURVLAUVLUUTUVKAUVLUUTVKZVKZUURUVAUUQUNZUVBUUHUVAURULZUUN
      UNZKULZUVCUVOUUIMUUQHVMUVAPRQUVOUVEHVNVEZAUVEUVNUHVOZHVPZVQUUIVMVEZUVOUPU
      UHUQWAZVRUVOUVAUUIVEZUVAUOVEZUVAUUHVAVBZUVOUUTUWFAUVLUUTVSUVOUVIUVLUUTUWF
      VTAUVIUVNUJVOZAUVLUUTWBZFUUHWCWDWEUVOUPFVAVBUWGUVOFUWHWFUVOUUHFUVLUUHWGVE
      ZAUUTUUHWHZWIAFWGVEZUVNAFUJWLZVOWJWEUVLUWEUWFUWGVKVTAUUTUVAUUHWKWIWMZUVOU
      KUUIUUPMUUQUVOUUJUUIVEZVKZUVEUULMVEZUUOMVEUUPMVEAUVEUVNUWOUHWNZUWPUOMUUJU
      UKAUOMUUKWOZUVNUWOAUVFUWSUGUUKDGHCMUUKXBUDSRWPVQZWNUWOUUJUOVEZUVOUUJUUHWQ
      ZWRWSZUWPUOMUUMUUNAUOMUUNWOZUVNUWOAUVGUXDUVJUUNDGHUUFMUUNXBUDSRWPVQWNUWOU
      UMUOVEZUVOUUJUPUUHWTZWRWSMHKUULUUORUFXAVIUUQXBZXCUVOUUIUUPUKUVAXDZPUVOUUJ
      UUIUXHXEVEZVKZUUPUULPKULZPUXJUUOPUULKUXJEFGHJLUUMMNOPQRSTUAUBUCAUVEUVNUXI
      UHWNAUVHUVNUXIUIWNAUVIUVNUXIUJWNUXIUXEUVOUXIUWOUXEUUJUUIUXHXFZUXFVQWRUXIU
      VOUWOUUJUVAXGZVKFUUMXGZUUJUUIUVAXHUVOUWOUXMUXNUWPFUUMUUJUVAUWPUUJUVAVHZFU
      UMVHZUUJUUHUUMURULZVHUWPUXQUUJUWPUUHUUJUWPUUHAUVLUUTUWOXIXJUWOUUJXNVEUVOU
      WOUUJUXBXJWRXKXLUXPUVAUXQUUJFUUMUUHURXMXOXPXQXRXSXTYAUXIUVOUWOUXKPVHZUXLU
      WPUVEUWQUXRUWRUXCMHKUULPRUFQYDZWDYBYEYCYFUVOUWEUVPUVSVHUWNUKUVAUUPUVSUUIU
      UQUXOUULUVBUUOUVRKUUJUVAUUKYGUXOUUMUVQUUNUUJUVAUUHURXMYHYIUXGUVBUVRKWAYJV
      QUVOUVREUVBKUVOUVRFUUNUNZEUVOUVQFUUNUVOUUHFUVOUUHUWIXJUVOFUWHXJXKYHUVOUVE
      UVHUVIUXTEVHUWAAUVHUVNUIVOUWHEFGHJLMNOPQRSTUAUBUCYKVIYEYAYLYMUVMUUTYNZVKZ
      UURHUKUUIPUSZUTULZPUYBUUQUYCHUTUYBUKUUIUUPPUVMUYAUWOUUPPVHUVMUYAUWOVKZVKZ
      UUPUXKPUYFUUOPUULKUYFEFGHJLUUMMNOPQRSTUAUBUCAUVEUVLUYEUHWNZAUVHUVLUYEUIWN
      AUVIUVLUYEUJWNUWOUXEUVMUYAUXFYOUYFUUMFUWOUUMWGVEUVMUYAUWOUUMUXFWLYOZUYFUU
      MUUHFUYHUVLUWJAUYEUWKYPZAUWLUVLUYEUWMWNZUYFUPUUJVAVBUUMUUHVAVBUYFUUJUWOUX
      AUVMUYAUXBYOZWFUYFUUHUUJUYIUWOUUJWGVEUVMUYAUWOUUJUXBWLYOWJWEUYFUUHFYQVBUY
      AUVMUYAUWOWBUYFUUHFUYIUYJYRYSUUAUUBXTYAUYFUVEUWQUXRUYGUYFUOMUUJUUKAUWSUVL
      UYEUWTWNUYKWSUXSWDYEYMYTYAAUYDPVHZUVLUYAAUVTUWCUYLAUVEUVTUHUWBVQUWDUUIUKH
      VMPQUUCUUDWNYEUUEYTYE $.

    $( Coefficient vector of a polynomial multiplied on the left by a term.
       (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    coe1tmmul $p |- ( ph -> ( coe1 ` ( ( C .x. ( D .^ X ) ) .xb A ) ) =
          ( x e. NN0 |-> if ( D <_ x ,
              ( C .X. ( ( coe1 ` A ) ` ( x - D ) ) ) , .0. ) ) ) $=
      ( vy co cco1 cfv cn0 cc0 cfz cmin cmpt cgsu cle wbr cif crg wcel ply1tmcl
      cv wceq syl3anc coe1mul eqeq2 cvv cmnd ad2antrr rngmnd syl ovex a1i simpr
      wa wb fznn0 ad2antlr mpbir2and eqid coe1f adantr elfznn0 ffvelrn fznn0sub
      wf syl2an rngcl fmptd csn cdif ad3antrrr eldifi adantl eldifsni coe1tmfv2
      wne necomd oveq1d rnglz syl2anc sylan2 adantlr eqtrd suppss2 gsumpt fveq2
      oveq2 fveq2d oveq12d fvmpt coe1tmfv1 wn elfzle2 breq1 syl5ibrcom necon3bd
      imp an32s mpteq2dva oveq2d gsumz ifbothda ) AEFOLULJULZCIULUMUNZBUOHUKUPB
      VGZUQULZUKVGZYIUMUNZUNZYKYMURULZCUMUNZUNZKULZUSZUTULZUSZBUOFYKVAVBZEYKFUR
      ULZYQUNZKULZPVCZUSAHVDVEZYIDVEZCDVEZYJUUBVHUHAUUHEMVEZFUOVEZUUIUHUIUJDEFG
      HJLMNORSTUAUBUCUDVFVIZUGUKDHIKBYICGSUEUFUDVJVIABUOUUAUUGUUCUUAUUFVHUUAPVH
      UUAUUGVHAYKUOVEZVTZUUFPUUFUUGUUAVKPUUGUUAVKUUOUUCVTZUUAFYTUNZUUFUUPYLMYTH
      VLFPRQUUPUUHHVMVEZAUUHUUNUUCUHVNHVOZVPYLVLVEZUUPUPYKUQVQZVRUUPFYLVEZUULUU
      CAUULUUNUUCUJVNUUOUUCVSUUNUVBUULUUCVTWAAUUCFYKWBWCWDZUUOYLMYTWKUUCUUOUKYL
      YSMYTUUOYMYLVEZVTZUUHYOMVEZYRMVEZYSMVEAUUHUUNUVDUHVNZUUOUOMYNWKZYMUOVEZUV
      FUVDAUVIUUNAUUIUVIUUMYNDGHYIMYNWEUDSRWFVPWGYMYKWHZUOMYMYNWIWLUUOUOMYQWKZY
      PUOVEUVGUVDAUVLUUNAUUJUVLUGYQDGHCMYQWEUDSRWFVPWGYMUPYKWJUOMYPYQWIWLZMHKYO
      YRRUFWMVIYTWEZWNWGUUPYLYSUKFWOZPUUPYMYLUVOWPVEZVTZYSPYRKULZPUVQYOPYRKUVQE
      FGHJLYMMNOPQRSTUAUBUCAUUHUUNUUCUVPUHWQAUUKUUNUUCUVPUIWQAUULUUNUUCUVPUJWQU
      VPUVJUUPUVPUVDUVJYMYLUVOWRZUVKVPWSUVPFYMXBZUUPUVPYMFYMYLFWTXCWSXAXDUUOUVP
      UVRPVHZUUCUVPUUOUVDUWAUVSUVEUUHUVGUWAUVHUVMMHKYRPRUFQXEXFZXGXHXIXJXKUUPUU
      QFYNUNZUUEKULZUUFUUPUVBUUQUWDVHUVCUKFYSUWDYLYTYMFVHZYOUWCYRUUEKYMFYNXLUWE
      YPUUDYQYMFYKURXMXNXOUVNUWCUUEKVQXPVPUUPUWCEUUEKAUWCEVHZUUNUUCAUUHUUKUULUW
      FUHUIUJEFGHJLMNOPQRSTUAUBUCXQVIVNXDXIXIUUOUUCXRZVTZUUAHUKYLPUSZUTULZPUWHY
      TUWIHUTUWHUKYLYSPUWHUVDVTZYSUVRPUWKYOPYRKUWKEFGHJLYMMNOPQRSTUAUBUCAUUHUUN
      UWGUVDUHWQAUUKUUNUWGUVDUIWQAUULUUNUWGUVDUJWQUVDUVJUWHUVKWSUUOUVDUWGUVTUVE
      UWGUVTUVEUUCFYMUVEUUCFYMVHYMYKVAVBZUVDUWLUUOYMUPYKXSWSFYMYKVAXTYAYBYCYDXA
      XDUUOUVDUWAUWGUWBXHXIYEYFUWHUURUUTUWJPVHAUURUUNUWGAUUHUURUHUUSVPVNUUTUWHU
      VAVRYLUKHVLPQYGXFXIYHYEXI $.

    coe1tmmul2fv.y $e |- ( ph -> Y e. NN0 ) $.
    $( Function value of a right-multiplication by a term in the shifted
       domain.  (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
    coe1tmmul2fv $p |- ( ph -> ( ( coe1 ` ( A .xb ( C .x. ( D .^ X ) ) ) ) `
            ( D + Y ) ) = ( ( ( coe1 ` A ) ` Y ) .X. C ) ) $=
      ( vx caddc cco1 cfv cn0 cle wbr cmin cif cmpt coe1tmmul2 fveq1d wcel wceq
      co nn0addcld breq2 oveq1 fveq2d oveq1d eqidd ifbieq12d eqid ovex c0g fvex
      cvv eqeltri ifex fvmpt syl nn0red nn0addge1 syl2anc iftrue nn0cnd pncan2d
      cv cr 3eqtrd eqtrd ) AEOUMVFZBDENKVFIVFHVFUNUOZUOWMULUPEULWIZUQURZWOEUSVF
      ZBUNUOZUOZDJVFZPUTZVAZUOZOWRUOZDJVFZAWMWNXBAULBCDEFGHIJKLMNPQRSTUAUBUCUDU
      EUFUGUHUIUJVBVCAXCEWMUQURZWMEUSVFZWRUOZDJVFZPUTZXIXEAWMUPVDXCXJVEAEOUJUKV
      GULWMXAXJUPXBWOWMVEZWPXFWTPXIPWOWMEUQVHXKWSXHDJXKWQXGWRWOWMEUSVIVJVKXKPVL
      VMXBVNXFXIPXHDJVOPGVPUOVRQGVPVQVSVTWAWBAXFXJXIVEAEWJVDOUPVDXFAEUJWCUKEOWD
      WEXFXIPWFWBAXHXDDJAXGOWRAEOAEUJWGAOUKWGWHVJVKWKWL $.
  $}

  ${
    $d x A $.  $d x D $.  $d x N $.  $d x P $.  $d x R $.  $d x X $.  $d x Y $.
    $d x .^ $.  $d x .0. $.  $d x ph $.  $d x .x. $.
    coe1pwmul.z $e |- .0. = ( 0g ` R ) $.
    coe1pwmul.p $e |- P = ( Poly1 ` R ) $.
    coe1pwmul.x $e |- X = ( var1 ` R ) $.
    coe1pwmul.n $e |- N = ( mulGrp ` P ) $.
    coe1pwmul.e $e |- .^ = ( .g ` N ) $.
    coe1pwmul.b $e |- B = ( Base ` P ) $.
    coe1pwmul.t $e |- .x. = ( .r ` P ) $.
    coe1pwmul.r $e |- ( ph -> R e. Ring ) $.
    coe1pwmul.a $e |- ( ph -> A e. B ) $.
    coe1pwmul.d $e |- ( ph -> D e. NN0 ) $.
    $( Coefficient vector of a polynomial multiplied on the left by a variable
       power.  (Contributed by Stefan O'Rear, 1-Apr-2015.) $)
    coe1pwmul $p |- ( ph -> ( coe1 ` ( ( D .^ X ) .x. A ) ) =
          ( x e. NN0 |-> if ( D <_ x ,
              ( ( coe1 ` A ) ` ( x - D ) ) , .0. ) ) ) $=
      ( cur cfv co cvsca cco1 cn0 cle wbr cmin cmulr cif cmpt cbs eqid crg wcel
      rngidcl syl coe1tmmul csca wceq ply1sca fveq2d oveq1d clmod ply1lmod cmnd
      cv ply1rng rngmgp vr1cl mgpbas mulgnn0cl syl3anc lmodvs1 syl2anc eqtrd wa
      ad2antrr wf coe1f simplr simpr nn0sub2 ffvelrnd rnglidm ifeq1da mpteq2dva
      3syl 3eqtr3d ) AGUCUDZEKIUEZFUFUDZUEZCHUEZUGUDBUHEBVJZUIUJZWMWREUKUEZCUGU
      DZUDZGULUDZUEZLUMZUNWNCHUEZUGUDBUHWSXBLUMZUNABCDWMEFGHWOXCIGUOUDZJKLMXHUP
      ZNOWOUPZPQRSXCUPZUATAGUQURZWMXHURTXHGWMXIWMUPZUSUTUBVAAWQXFUGAWPWNCHAWPFV
      BUDZUCUDZWNWOUEZWNAWMXOWNWOAGXNUCAXLGXNVCTFGUQNVDUTVEVFAFVGURZWNDURZXPWNV
      CAXLXQTFGNVHUTAJVIURZEUHURZKDURZXRAXLFUQURXSTFGNVKFJPVLWKUBAXLYATDFGKONRV
      MUTDIJEKDFJPRVNQVOVPWOXOXNDFWNRXNUPXJXOUPVQVRVSVFVEABUHXEXGAWRUHURZVTZWSX
      DXBLYCWSVTZXLXBXHURXDXBVCAXLYBWSTWAYDUHXHWTXAAUHXHXAWBZYBWSACDURYEUAXADFG
      CXHXAUPRNXIWCUTWAYDXTYBWSWTUHURAXTYBWSUBWAAYBWSWDYCWSWEEWRWFVPWGXHGXCWMXB
      XIXKXMWHVRWIWJWL $.

    coe1pwmulfv.y $e |- ( ph -> Y e. NN0 ) $.
    $( Function value of a right-multiplication by a variable power in the
       shifted domain.  (Contributed by Stefan O'Rear, 1-Apr-2015.) $)
    coe1pwmulfv $p |- ( ph -> ( ( coe1 ` ( ( D .^ X ) .x. A ) ) ` ( D + Y ) ) =
          ( ( coe1 ` A ) ` Y ) ) $=
      ( vx caddc co cco1 cfv cn0 cv cle wbr cmin cif cmpt coe1pwmul fveq1d wcel
      wceq nn0addcld breq2 oveq1 eqidd ifbieq12d eqid fvex c0g cvv eqeltri ifex
      fveq2d fvmpt syl cr nn0red nn0addge1 syl2anc iftrue nn0cnd pncan2d 3eqtrd
      eqtrd ) ADKUEUFZDJHUFBGUFUGUHZUHWCUDUIDUDUJZUKULZWEDUMUFZBUGUHZUHZLUNZUOZ
      UHZKWHUHZAWCWDWKAUDBCDEFGHIJLMNOPQRSTUAUBUPUQAWLDWCUKULZWCDUMUFZWHUHZLUNZ
      WPWMAWCUIURWLWQUSADKUBUCUTUDWCWJWQUIWKWEWCUSZWFWNWILWPLWEWCDUKVAWRWGWOWHW
      EWCDUMVBVKWRLVCVDWKVEWNWPLWOWHVFLFVGUHVHMFVGVFVIVJVLVMAWNWQWPUSADVNURKUIU
      RWNADUBVOUCDKVPVQWNWPLVRVMAWOKWHADKADUBVSAKUCVSVTVKWAWB $.
  $}

  ${
    ply1scltm.k $e |- K = ( Base ` R ) $.
    ply1scltm.p $e |- P = ( Poly1 ` R ) $.
    ply1scltm.x $e |- X = ( var1 ` R ) $.
    ply1scltm.m $e |- .x. = ( .s ` P ) $.
    ply1scltm.n $e |- N = ( mulGrp ` P ) $.
    ply1scltm.e $e |- .^ = ( .g ` N ) $.
    ply1scltm.a $e |- A = ( algSc ` P ) $.
    $( A scalar is a term with zero exponent.  (Contributed by Stefan O'Rear,
       29-Mar-2015.) $)
    ply1scltm $p |- ( ( R e. Ring /\ F e. K ) ->
        ( A ` F ) = ( F .x. ( 0 .^ X ) ) ) $=
      ( wcel cfv co wceq crg wa cur cc0 cid ply1sca2 cbs c1 df-base strfvi eqid
      asclval adantl vr1cl mgpbas rngidval mulg0 syl adantr oveq2d eqtr4d ) CUA
      QZFGQZUBZFARZFBUCRZDSZFUDIESZDSVCVEVGTVBADVFCUERGBFPBCKUFCUGUHGUIJUJMVFUK
      ZULUMVDVHVFFDVBVHVFTZVCVBIBUGRZQVJVKBCILKVKUKZUNVKEHIVFVKBHNVLUOBVFHNVIUP
      OUQURUSUTVA $.
  $}

  ${
    $d x B $.  $d x K $.  $d x P $.  $d x R $.  $d x .x. $.  $d x .xb $.
    $d x X $.  $d x Y $.
    coe1sclmul.p $e |- P = ( Poly1 ` R ) $.
    coe1sclmul.b $e |- B = ( Base ` P ) $.
    coe1sclmul.k $e |- K = ( Base ` R ) $.
    coe1sclmul.a $e |- A = ( algSc ` P ) $.
    coe1sclmul.t $e |- .xb = ( .r ` P ) $.
    coe1sclmul.u $e |- .x. = ( .r ` R ) $.
    $( Coefficient vector of a polynomial multiplied on the left by a scalar.
       (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    coe1sclmul $p |- ( ( R e. Ring /\ X e. K /\ Y e. B ) ->
        ( coe1 ` ( ( A ` X ) .xb Y ) ) =
          ( ( NN0 X. { X } ) oF .x. ( coe1 ` Y ) ) ) $=
      ( vx wcel cfv co cn0 crg w3a cc0 cv1 cmgp cmg cvsca cco1 cle wbr cmin c0g
      cif cmpt csn cxp cof eqid simp3 simp1 simp2 0nn0 coe1tmmul wceq ply1scltm
      cv a1i 3adant3 oveq1d fveq2d cvv nn0ex simpl2 wa fconstmpt coe1f 3ad2ant3
      fvex wf feqmptd offval2 nn0ge0 iftrue nn0cn subid1d oveq2d eqtrd mpteq2ia
      syl syl6eqr 3eqtr4d ) DUAQZHGQZIBQZUBZHUCDUDRZCUERZUFRZSCUGRZSZIESZUHRPTU
      CPVFZUIUJZHXBUCUKSZIUHRZRZFSZDULRZUMZUNZHARZIESZUHRTHUOUPZXEFUQSZWOPIBHUC
      CDEWSFWRGWQWPXHXHURLJWPURZWSURZWQURZWRURZKNOWLWMWNUSWLWMWNUTWLWMWNVAUCTQW
      OVBVGVCWOXLXAUHWOXKWTIEWLWMXKWTVDWNACDWSWRHGWQWPLJXOXPXQXRMVEVHVIVJWOXNPT
      HXBXERZFSZUNXJWOPTHXSFXMXEVKGVKTVKQWOVLVGWLWMWNXBTQZVMXSVKQWOYAVNXBXEVRVG
      XMPTHUNVDWOPTHVOVGWOPTGXEWNWLTGXEVSWMXEBCDIGXEURKJLVPVQVTWAPTXIXTYAXIXGXT
      YAXCXIXGVDXBWBXCXGXHWCWIYAXFXSHFYAXDXBXEYAXBXBWDWEVJWFWGWHWJWK $.

    ${
      $( A single coefficient of a polynomial multiplied on the left by a
         scalar.  (Contributed by Stefan O'Rear, 1-Apr-2015.) $)
      coe1sclmulfv $p |- ( ( R e. Ring /\ ( X e. K /\ Y e. B ) /\ .0. e. NN0 )
         -> ( ( coe1 ` ( ( A ` X ) .xb Y ) ) ` .0. ) =
            ( X .x. ( ( coe1 ` Y ) ` .0. ) ) ) $=
        ( wcel cn0 cfv co crg wa w3a cco1 csn cxp wceq coe1sclmul 3expb 3adant3
        cof fveq1d simp3 cvv nn0ex a1i simp2l cbs wf wfn simp2r eqid coe1f 3syl
        ffn eqidd ofc1 mpdan eqtrd ) DUAQZHGQZIBQZUBZJRQZUCZJHASIETUDSZSJRHUEUF
        IUDSZFUKTZSZHJVQSZFTZVOJVPVRVJVMVPVRUGZVNVJVKVLWBABCDEFGHIKLMNOPUHUIUJU
        LVOVNVSWAUGVJVMVNUMVORHVTFVQUNGJRUNQVOUOUPVJVKVLVNUQVOVLRDURSZVQUSVQRUT
        VJVKVLVNVAVQBCDIWCVQVBLKWCVBVCRWCVQVEVDVOVNUBVTVFVGVHVI $.
    $}

    $( Coefficient vector of a polynomial multiplied on the right by a scalar.
       (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    coe1sclmul2 $p |- ( ( R e. Ring /\ X e. K /\ Y e. B ) ->
        ( coe1 ` ( Y .xb ( A ` X ) ) ) =
          ( ( coe1 ` Y ) oF .x. ( NN0 X. { X } ) ) ) $=
      ( vx wcel cfv co cn0 crg w3a cc0 cv1 cmgp cmg cvsca cco1 cle wbr cmin c0g
      cif cmpt csn cxp cof eqid simp3 simp1 simp2 0nn0 a1i coe1tmmul2 ply1scltm
      cv wceq 3adant3 oveq2d fveq2d nn0ex wa fvex simpl2 coe1f feqmptd 3ad2ant3
      cvv fconstmpt offval2 nn0ge0 iftrue nn0cn subid1d oveq1d mpteq2ia syl6eqr
      syl eqtrd 3eqtr4d ) DUAQZHGQZIBQZUBZIHUCDUDRZCUERZUFRZSCUGRZSZESZUHRPTUCP
      VFZUIUJZXAUCUKSZIUHRZRZHFSZDULRZUMZUNZIHARZESZUHRXDTHUOUPZFUQSZWNPIBHUCCD
      EWRFWQGWPWOXGXGURLJWOURZWRURZWPURZWQURZKNOWKWLWMUSWKWLWMUTWKWLWMVAUCTQWNV
      BVCVDWNXKWTUHWNXJWSIEWKWLXJWSVGWMACDWRWQHGWPWOLJXNXOXPXQMVEVHVIVJWNXMPTXA
      XDRZHFSZUNXIWNPTXRHFXDXLVRVRGTVRQWNVKVCXRVRQWNXATQZVLXAXDVMVCWKWLWMXTVNWM
      WKXDPTXRUNVGWLWMPTGXDXDBCDIGXDURKJLVOVPVQXLPTHUNVGWNPTHVSVCVTPTXHXSXTXHXF
      XSXTXBXHXFVGXAWAXBXFXGWBWHXTXEXRHFXTXCXAXDXTXAXAWCWDVJWEWIWFWGWJ $.
  $}

  ${
    $d x y A $.  $d x y K $.  $d x P $.  $d x y R $.  $d x X $.  $d x .0. $.
    ply1scl.p $e |- P = ( Poly1 ` R ) $.
    ply1scl.a $e |- A = ( algSc ` P ) $.
    ${
      coe1scl.k $e |- K = ( Base ` R ) $.
      ${
        ply1sclf.b $e |- B = ( Base ` P ) $.
        $( A scalar polynomial is a polynomial.  (Contributed by Stefan O'Rear,
           28-Mar-2015.) $)
        ply1sclf $p |- ( R e. Ring -> A : K --> B ) $=
          ( crg wcel cid cfv ply1sca2 ply1rng ply1lmod cbs c1 df-base strfvi
          asclf ) DJKABDLMECGCDFNCDFOCDFPDQRESHTIUA $.
      $}

      coe1scl.z $e |- .0. = ( 0g ` R ) $.
      $( Coefficient vector of a scalar.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      coe1scl $p |- ( ( R e. Ring /\ X e. K ) -> ( coe1 ` ( A ` X ) ) =
            ( x e. NN0 |-> if ( x = 0 , X , .0. ) ) ) $=
        ( crg wcel cfv cco1 cc0 co cn0 wceq eqid wa cv1 cmgp cmg cvsca cif cmpt
        cv ply1scltm fveq2d 0nn0 coe1tm mp3an3 eqtrd ) DLMZFEMZUAZFBNZONFPDUBNZ
        CUCNZUDNZQCUENZQZONZARAUHPSFGUFUGZUQURVCOBCDVBVAFEUTUSJHUSTZVBTZUTTZVAT
        ZIUIUJUOUPPRMVDVESUKAFPCDVBVAEUTUSGKJHVFVGVHVIULUMUN $.
    $}

    ${
      ply1sclid.k $e |- K = ( Base ` R ) $.
      $( Recover the base scalar from a scalar polynomial.  (Contributed by
         Stefan O'Rear, 28-Mar-2015.) $)
      ply1sclid $p |- ( ( R e. Ring /\ X e. K ) ->
          X = ( ( coe1 ` ( A ` X ) ) ` 0 ) ) $=
        ( vx crg wcel wa cc0 cfv cco1 cn0 cv wceq c0g eqid cif cmpt fveq1d 0nn0
        coe1scl iftrue fvmptg mpan adantl eqtr2d ) CJKZEDKZLZMEANONZNMIPIQMRZEC
        SNZUAZUBZNZEUMMUNURIABCDEUPFGHUPTUEUCULUSERZUKMPKULUTUDIMUQEPDURUOEUPUF
        URTUGUHUIUJ $.

      ply1sclf1.b $e |- B = ( Base ` P ) $.
      $( The polynomial scalar function is injective.  (Contributed by Stefan
         O'Rear, 28-Mar-2015.) $)
      ply1sclf1 $p |- ( R e. Ring -> A : K -1-1-> B ) $=
        ( vx vy wcel cv cfv wceq wral wa cc0 cco1 ply1sclid crg wf weq ply1sclf
        wi wf1 fveq2 fveq1d adantrr adantrl eqeq12d syl5ibr ralrimivva sylanbrc
        dff13 ) DUALZEBAUBJMZANZKMZANZOZJKUCZUEZKEPJEPEBAUFABCDEFGHIUDUPVCJKEEV
        AVBUPUQELZUSELZQQZRURSNZNZRUTSNZNZOVARVGVIURUTSUGUHVFUQVHUSVJUPVDUQVHOV
        EACDEUQFGHTUIUPVEUSVJOVDACDEUSFGHTUJUKULUMJKEBAUOUN $.
    $}

    ${
      ply1scl0.z $e |- .0. = ( 0g ` R ) $.
      ply1scl0.y $e |- Y = ( 0g ` P ) $.
      $( The zero scalar is zero.  (Contributed by Stefan O'Rear,
         29-Mar-2015.) $)
      ply1scl0 $p |- ( R e. Ring -> ( A ` .0. ) = Y ) $=
        ( crg wcel cfv cur cvsca co c0g cbs wceq eqid syl cid rng0cl c1 df-base
        ply1sca2 strfvi asclval fveq2d syl6reqr oveq1d ply1lmod ply1rng rngidcl
        fvi clmod lmod0vs syl2anc 3eqtrd ) CJKZEALZEBMLZBNLZOZCUALZPLZVAVBOZDUS
        ECQLZKUTVCRVGCEVGSZHUBAVBVAVDVGBEGBCFUEZCQUCVGUDVHUFVBSZVASZUGTUSEVEVAV
        BUSVECPLEUSVDCPCJUNUHHUIUJUSBUOKVABQLZKZVFDRBCFUKUSBJKVMBCFULVLBVAVLSZV
        KUMTVBVDVEVLBVADVNVIVJVESIUPUQUR $.

      ply1scln0.k $e |- K = ( Base ` R ) $.
      $( Nonzero scalars create nonzero polynomials.  (Contributed by Stefan
         O'Rear, 29-Mar-2015.) $)
      ply1scln0 $p |- ( ( R e. Ring /\ X e. K /\ X =/= .0. ) ->
          ( A ` X ) =/= Y ) $=
        ( crg wcel wne w3a cfv wa wceq adantr cbs wf1 wb ply1sclf1 simpr rng0cl
        eqid f1fveq syl12anc biimpd necon3d 3impia ply1scl0 3ad2ant1 neeqtrd )
        CMNZEDNZEGOZPEAQZGAQZFUPUQURUSUTOUPUQRZUSUTEGVAUSUTSZEGSZVADBUAQZAUBZUQ
        GDNZVBVCUCUPVEUQAVDBCDHILVDUGUDTUPUQUEUPVFUQDCGLJUFTDVDEGAUHUIUJUKULUPU
        QUTFSURABCFGHIJKUMUNUO $.
    $}

    ${
      ply1scl1.o $e |- .1. = ( 1r ` R ) $.
      ply1scl1.n $e |- N = ( 1r ` P ) $.
      $( The one scalar is the unit polynomial.  (Contributed by Stefan O'Rear,
         1-Apr-2015.) $)
      ply1scl1 $p |- ( R e. Ring -> ( A ` .1. ) = N ) $=
        ( crg wcel cfv cvsca co cur cbs wceq eqid rngidcl syl c1 df-base strfvi
        cid ply1sca2 asclval fvi fveq2d syl6eqr oveq1d ply1lmod ply1rng lmodvs1
        clmod syl2anc 3eqtr2d ) CJKZDALZDEBMLZNZCUDLZOLZEUSNZEUQDCPLZKURUTQVDCD
        VDRZHSAUSEVAVDBDGBCFUEZCPUAVDUBVEUCUSRZIUFTUQVBDEUSUQVBCOLDUQVACOCJUGUH
        HUIUJUQBUNKEBPLZKZVCEQBCFUKUQBJKVIBCFULVHBEVHRZISTUSVBVAVHBEVJVFVGVBRUM
        UOUP $.
    $}
  $}

  ${
    $d a k A $.  $d a b c k B $.  $d a b c d k K $.  $d a b M $.  $d a c k X $.
    $d a k .^ $.  $d a b c d k R $.  $d a b k .x. $.
    ply1coe.p $e |- P = ( Poly1 ` R ) $.
    ply1coe.x $e |- X = ( var1 ` R ) $.
    ply1coe.b $e |- B = ( Base ` P ) $.
    ply1coe.n $e |- .x. = ( .s ` P ) $.
    ply1coe.m $e |- M = ( mulGrp ` P ) $.
    ply1coe.e $e |- .^ = ( .g ` M ) $.
    ply1coe.a $e |- A = ( coe1 ` K ) $.
    ply1coe.r $e |- R e. _V $.
    $( Decompose a univariate polynomial as a sum of powers.  (Contributed by
       Stefan O'Rear, 21-Mar-2015.) $)
    ply1coe $p |- ( ( R e. CRing /\ K e. B ) -> K =
          ( P gsum ( k e. NN0 |-> ( ( A ` k ) .x. ( k .^ X ) ) ) ) ) $=
      ( wcel cfv va vb vd vc ccrg wa c1o cmpl co cn0 cmap wceq cur c0g cif cmpt
      cv cgsu c0 com eqid psr1baslem 1onn a1i cps1 ply1bas ply1vsca crg crngrng
      adantr simpr mplcoe1 fvcoe1 adantll cmgp cmvr simpll mplcoe2 df1o2 mpteq1
      cmg csn ax-mp oveq2i cmnd cvv ccmn mplcrng mpan crngmgp syl cmnmnd mgpbas
      0ex cbs wss ssv cplusg ovex cmulr ply1mulr mgpplusg oveqi mulgpropd oveqd
      eqtr3i ply1crng rngmgp 3syl elmapi 0lt1o ffvelrn sylancl adantl mulgnn0cl
      vr1cl syl3anc eqeltrd fveq2 vr1val syl6eqr gsumsn syl5eq 3eqtrd mpteq2dva
      wf oveq12d oveq2d ccom nn0ex cpl1 fvex eqeltri syl2anc ccnv cdif cima cfn
      mptex eqidd ply1plusg gsumpropd clmod mpllmod coe1f ffvelrnda csca mplsca
      lmodcmn simpl mp2an lmodvscl fmptd coe1sfi feqmptd cnveqd imaeq1d eqimss2
      lmod0vs sylan suppssov1 ssfi wf1o mapsnf1o2 gsumf1o oveq1 fmptco 3eqtrrd
      ) DUESZHBSZUFZHUGDUHUIZUAUJUGUKUIZUAUQZHTZUBUVMUBUQZUVNULDUMTZDUNTZUOUPZE
      UIZUPZURUIUVLUAUVMUSUVNTZATZUWBJGUIZEUIZUPZURUIZCFUJFUQZATZUWHJGUIZEUIZUP
      ZURUIZUVKUBBUVMUVLDEUVQUCUAUGUTHUVRUVLVAZUCVBZUVRVAZUVQVAZUGUTSZUVKVCVDZC
      DDVETZBKUWTVAMVFZDUVLECKUWNNVGZUVIDVHSZUVJDVIVJZUVIUVJVKVLUVKUWAUWFUVLURU
      VKUAUVMUVTUWEUVKUVNUVMSZUFZUVOUWCUVSUWDEUVJUXEUVOUWCULUVIAHBUVNQVMVNUXFUV
      SUVLVOTZUDUGUDUQZUVNTZUXHUGDVPUIZTZUXGWATZUIZUPZURUIZUWBJUXLUIZUWDUXFUBUV
      MUVLDUVQUCUDUXLUXGUGUXJUTUVNUVRUWNUWOUWPUWQUWRUXFVCVDUXGVAZUXLVAZUXJVAUVI
      UVJUXEVQUVKUXEVKVRUXFUXOUXGUDUSWBZUXMUPZURUIZUXPUXNUXTUXGURUGUXSULUXNUXTU
      LVSUDUGUXSUXMVTWCWDUXFUXGWESZUSWFSZUXPBSUYAUXPULUXFUXGWGSZUYBUVKUYDUXEUVK
      UVLUESZUYDUVIUYEUVJUWRUVIUYEVCUVLDUGUTUWNWHWIVJUVLUXGUXQWJWKVJUXGWLWKUYCU
      XFWNVDUXFUXPUWDBUVKUXPUWDULUXEUVKUXLGUWBJUVKUAUBBUXLGUXGIWFUXRPBUXGWOTULU
      VKBUVLUXGUXQUXAWMZVDBIWOTULUVKBCIOMWMZVDBWFWPUVKBWQVDUVNUVPUXGWRTZUIZWFSU
      VKUVNWFSUVPWFSUFUFZUVNUVPUYHWSVDUYIUVNUVPIWRTZUIULUYJUYHUYKUVNUVPCWTTZUYH
      UYKUVLUYLUXGUXQDUVLUYLCKUWNUYLVAZXAXBCUYLIOUYMXBXFXCVDXDXEVJZUXFIWESZUWBU
      JSZJBSZUWDBSUVKUYOUXEUVKCUESZCVHSUYOUVIUYRUVJCDKXGVJCVICIOXHXIZVJUXEUYPUV
      KUXEUGUJUVNYFUSUGSUYPUVNUJUGXJXKUGUJUSUVNXLXMXNZUVKUYQUXEUVKUXCUYQUXDBCDJ
      LKMXPWKZVJBGIUWBJUYGPXOXQXRUXMBUXPUDUXGUSWFUYFUXHUSULZUXIUWBUXKJUXLUXHUSU
      VNXSVUBUXKUSUXJTJUXHUSUXJXSDJLXTYAYGYBXQYCUYNYDYGYEYHUVKUWMUVLUWLURUIUVLU
      WLUAUVMUWBUPZYIZURUIUWGUVKUWLCUVLWFWFWFUWLWFSUVKFUJUWKYJYSVDCWFSUVKCDYKTW
      FKDYKYLYMVDUVLWFSUVKUGDUHWSVDCWOTZUVLWOTZULUVKBVUEVUFMUXAXFVDCWRTZUVLWRTU
      LUVKVUGDUVLCKUWNVUGVAUUAVDUUBUVKUJBUVMUWLUVLVUCWFUVLUNTZUXAVUHVAZUVKUVLUU
      CSZUVLWGSUVKUWRUXCVUJUWSUXDUVLDUGUTUWNUUDYNZUVLUUIWKUJWFSUVKYJVDUVKFUJUWK
      BUWLUVKUWHUJSZUFZVUJUWIDWOTZSUWJBSZUWKBSUVKVUJVULVUKVJUVKUJVUNUWHAUVJUJVU
      NAYFUVIABCDHVUNQMKVUNVAZUUEXNZUUFVUMUYOVULUYQVUOUVKUYOVULUYSVJUVKVULVKUVK
      UYQVULVUAVJBGIUWHJUYGPXOXQZUWIEDVUNBUVLUWJUXAUWRDWFSZDUVLUUGTULVCRUWRVUSU
      FUVLDUGUTWFUWNUWRVUSUUJUWRVUSVKUUHUUKZUXBVUPUULXQUWLVAUUMUVKAYOZWFUVRWBYP
      ZYQZYRSZUWLYOWFVUHWBYPYQZVVCWPVVEYRSUVJVVDUVIABCDHUVRQMKUWPUUNXNUVKFUAUWI
      UWJUJBVVCEWFUVRVUHUVKVVCFUJUWIUPZYOZVVBYQZULVVHVVCWPUVKVVAVVGVVBUVKAVVFUV
      KFUJVUNAVUQUUOUUPUUQVVHVVCUURWKUVKVUJUVNBSUVRUVNEUIVUHULVUKEDUVRBUVLUVNVU
      HUXAVUTUXBUWPVUIUUSUUTUWIWFSVUMUWHAYLVDVURUVAVVCVVEUVBYNUVMUJVUCUVCUVKUAU
      JUGVUCUSVSYJWNVUCVAUVDVDUVEUVKVUDUWFUVLURUVKUAFUVMUJUWBUWKUWEVUCUWLUYTUVK
      VUCYTUVKUWLYTUWHUWBULUWIUWCUWJUWDEUWHUWBAXSUWHUWBJGUVFYGUVGYHUVHYD $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
         The complex numbers as an algebraic extensible structure
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols and define their syntactical properties. $)
  $c PsMet $.
  $c *Met $.
  $c Met $.
  $c ball $.
  $c fBas $.
  $c filGen $.
  $c MetOpen $.
  $c metUnifOLD $.
  $c metUnif $.

  $( Extend class notation with the class of all pseudometric spaces. $)
  cpsmet $a class PsMet $.

  $( Extend class notation with the class of all extended metric spaces. $)
  cxmt $a class *Met $.

  $( Extend class notation with the class of all metrics. $)
  cme $a class Met $.

  $( Extend class notation with the metric space ball function. $)
  cbl $a class ball $.

  $( Extend class definition to include the class of filter bases. $)
  cfbas $a class fBas $.

  $( Extend class definition to include the filter generating function. $)
  cfg $a class filGen $.

  $( Extend class notation with a function mapping each metric space to the
     family of its open sets. $)
  cmopn $a class MetOpen $.

  $( Extend class notation with the function mapping metrics to the uniform
     structure generated by that metric. $)
  cmetuOLD $a class metUnifOLD $.

  $( Extend class notation with the function mapping metrics to the uniform
     structure generated by that metric. $)
  cmetu $a class metUnif $.

  ${
    $d d x y z w $.
    $( Define the set of all pseudometrics on a given base set.  In a pseudo
       metric, two distinct points may have a distance zero.  (Contributed by
       Thierry Arnoux, 7-Feb-2018.) $)
    df-psmet $a |- PsMet = ( x e. _V |-> { d e. ( RR* ^m ( x X. x ) ) |
          A. y e. x ( ( y d y ) = 0 /\
          A. z e. x A. w e. x ( y d z ) <_ ( ( w d y ) +e ( w d z ) ) ) } ) $.

    $( Define the set of all extended metrics on a given base set.  The
       definition is similar to ~ df-met , but we also allow the metric to take
       on the value ` +oo ` .  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    df-xmet $a |- *Met = ( x e. _V |-> { d e. ( RR* ^m ( x X. x ) ) |
                 A. y e. x A. z e. x ( ( ( y d z ) = 0 <-> y = z ) /\
                 A. w e. x ( y d z ) <_ ( ( w d y ) +e ( w d z ) ) ) } ) $.

    $( Define the (proper) class of all metrics.  (A metric space is the
       metric's base set paired with the metric; see ~ df-ms .  However, we
       will often also call the metric itself a "metric space".)  Equivalent to
       Definition 14-1.1 of [Gleason] p. 223.  The 4 properties in Gleason's
       definition are shown by ~ met0 , ~ metgt0 , ~ metsym , and ~ mettri .
       (Contributed by NM, 25-Aug-2006.) $)
    df-met $a |- Met = ( x e. _V |-> { d e. ( RR ^m ( x X. x ) ) |
                 A. y e. x A. z e. x ( ( ( y d z ) = 0 <-> y = z ) /\
                 A. w e. x ( y d z ) <_ ( ( w d y ) + ( w d z ) ) ) } ) $.

    $( Define the metric space ball function.  See ~ blval for its value.
       (Contributed by NM, 30-Aug-2006.)  (Revised by Thierry Arnoux,
       11-Feb-2018.) $)
    df-bl $a |- ball = ( d e. _V |-> ( x e. dom dom d ,
      z e. RR* |-> { y e. dom dom d | ( x d y ) < z } ) ) $.

    $( Define a function whose value is the family of open sets of a metric
       space.  See ~ elmopn for its main property.  (Contributed by NM,
       1-Sep-2006.) $)
    df-mopn $a |- MetOpen = ( d e. U. ran *Met |->
      ( topGen ` ran ( ball ` d ) ) ) $.

    $( Define the class of all filter bases.  Note that a filter base on one
       set is also a filter base for any superset, so there is not a unique
       base set that can be recovered.  (Contributed by Jeff Hankins,
       1-Sep-2009.)  (Revised by Stefan O'Rear, 11-Jul-2015.) $)
    df-fbas $a |- fBas = ( w e. _V |-> { x e. ~P ~P w | ( x =/= (/) /\
      (/) e/ x /\ A. y e. x A. z e. x ( x i^i ~P ( y i^i z ) ) =/= (/) ) } ) $.

    $( Define the filter generating function.  (Contributed by Jeff Hankins,
       3-Sep-2009.)  (Revised by Stefan O'Rear, 11-Jul-2015.) $)
    df-fg $a |- filGen = ( w e. _V , x e. ( fBas ` w ) |->
        { y e. ~P w | ( x i^i ~P y ) =/= (/) } ) $.
  $}

  ${
    $d d a $.
    $( Define the function mapping metrics to the uniform structure generated
       by that metric.  (Contributed by Thierry Arnoux, 1-Dec-2017.)
       (New usage is discouraged.) $)
    df-metuOLD $a |- metUnifOLD = ( d e. U. ran *Met |-> ( ( dom dom d X. dom
      dom d ) filGen ran ( a e. RR+ |-> ( `' d " ( 0 [,) a ) ) ) ) ) $.

    $( Define the function mapping metrics to the uniform structure generated
       by that metric.  (Contributed by Thierry Arnoux, 1-Dec-2017.)  (Revised
       by Thierry Arnoux, 11-Feb-2018.) $)
    df-metu $a |- metUnif = ( d e. U. ran PsMet |-> ( ( dom dom d X. dom dom d
      ) filGen ran ( a e. RR+ |-> ( `' d " ( 0 [,) a ) ) ) ) ) $.
  $}

  $c CCfld $.

  $( Extend class notation with the field of complex numbers. $)
  ccnfld $a class CCfld $.

  $( The field of complex numbers.  Other number fields and rings can be
     constructed by applying the ` |``s ` restriction operator, for instance
     ` ( CCfld |`` AA ) ` is the field of algebraic numbers.

     The contract of this set is defined entirely by ~ cnfldex , ~ cnfldadd ,
     ~ cnfldmul , ~ cnfldcj , ~ cnfldtset , ~ cnfldle , ~ cnfldds , and
     ~ cnfldbas .  We may add additional members to this in the future.
     (Contributed by Stefan O'Rear, 27-Nov-2014.)  (Revised by Thierry Arnoux,
     15-Dec-2017.)  (New usage is discouraged.) $)
  df-cnfld $a |- CCfld = ( ( { <. ( Base ` ndx ) , CC >. ,
      <. ( +g ` ndx ) , + >. , <. ( .r ` ndx ) , x. >. } u.
      { <. ( *r ` ndx ) , * >. } ) u.
    ( { <. ( TopSet ` ndx ) , ( MetOpen ` ( abs o. - ) ) >. ,
        <. ( le ` ndx ) , <_ >. ,
        <. ( dist ` ndx ) , ( abs o. - ) >. } u.
      { <. ( UnifSet ` ndx ) , ( metUnif ` ( abs o. - ) ) >. } ) ) $.

  $( The field of complex numbers is a structure.  (Contributed by Mario
     Carneiro, 14-Aug-2015.)  (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldstr $p |- CCfld Struct <. 1 , ; 1 3 >. $=
    ( cnx cfv cc cop caddc cmul ctp ccj csn cun cle c1 c3 cdc c9 c2 c10 cc0 2nn
    1nn0 ccnfld cbs cplusg cmulr cstv cts cabs cmin ccom cmopn cple cunif cmetu
    cds cstr df-cnfld eqid srngfn 9nn tsetndx 9lt10 10nn plendx dec10 0nn0 2pos
    clt declt eqbrtri decnncl dsndx strle3 3nn unifndx strle1 2nn0 2lt3 strleun
    c4 4lt9 ) UAAUBBCDAUCBEDAUDBFDGAUEBHDIJZAUFBZUGUHUIZUJBZDAUKBZKDAUNBZWCDGZA
    ULBZWCUMBZDIZJZJLLMNZDUOUPLVSOWLWAWKCEWAFHWAUQUROLPNZWLWLWGWJWBWEWFOQWMWDKW
    CUSUTVAVBVCQLRNWMVGVDLRPTVESVFVHVILPTSVJVKVLWHWLWILMTVMVJVNVOLPMTVPVMVQVHVR
    VTVRVI $.

  $( The field of complex numbers is a set.  (Contributed by Stefan O'Rear,
     27-Nov-2014.)  (Revised by Mario Carneiro, 14-Aug-2015.)  (Revised by
     Thierry Arnoux, 17-Dec-2017.) $)
  cnfldex $p |- CCfld e. _V $=
    ( ccnfld c1 c3 cdc cop cstr wbr cvv wcel cnfldstr brstruct brrelexi ax-mp )
    ABBCDEZFGAHIJANFKLM $.

  $( The base set of the field of complex numbers.  (Contributed by Stefan
     O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro, 6-Oct-2015.)  (Revised
     by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldbas $p |- CC = ( Base ` CCfld ) $=
    ( cc cvv wcel ccnfld cbs cfv wceq c1 c3 cdc cop cnfldstr baseid cnx csn ctp
    cnex cun ssun1 sstri cplusg caddc cmulr cmul snsstp1 cstv ccj cts cabs cmin
    ccom cmopn cple cle cds cunif cmetu df-cnfld sseqtr4i strfv ax-mp ) ABCADEF
    GQADEBHHIJKLMNEFAKZOVBNUAFUBKZNUCFUDKZPZDVBVCVDUEVEVENUFFUGKOZRZDVEVFSVGVGN
    UHFUIUJUKZULFKNUMFUNKNUOFVHKPNUPFVHUQFKORZRDVGVISURUSTTUTVA $.

  $( The addition operation of the field of complex numbers.  (Contributed by
     Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro, 6-Oct-2015.)
     (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldadd $p |- + = ( +g ` CCfld ) $=
    ( caddc cvv wcel ccnfld cplusg cfv addex c1 c3 cdc cop cnfldstr plusgid cnx
    wceq csn ctp cun ssun1 sstri cbs cmulr cmul snsstp2 cstv ccj cabs cmin ccom
    cc cts cmopn cple cle cds cunif cmetu df-cnfld sseqtr4i strfv ax-mp ) ABCAD
    EFOGADEBHHIJKLMNEFAKZPNUAFUJKZVBNUBFUCKZQZDVCVBVDUDVEVENUEFUFKPZRZDVEVFSVGV
    GNUKFUGUHUIZULFKNUMFUNKNUOFVHKQNUPFVHUQFKPRZRDVGVISURUSTTUTVA $.

  $( The multiplication operation of the field of complex numbers.
     (Contributed by Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro,
     6-Oct-2015.)  (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldmul $p |- x. = ( .r ` CCfld ) $=
    ( cmul cvv wcel ccnfld cmulr cfv wceq mulex cdc cop cnfldstr mulrid cnx csn
    c1 c3 ctp cun ssun1 sstri cbs cc cplusg snsstp3 cstv ccj cts cabs cmin ccom
    caddc cmopn cple cle cds cunif cmetu df-cnfld sseqtr4i strfv ax-mp ) ABCADE
    FGHADEBOOPIJKLMEFAJZNMUAFUBJZMUCFUKJZVBQZDVCVDVBUDVEVEMUEFUFJNZRZDVEVFSVGVG
    MUGFUHUIUJZULFJMUMFUNJMUOFVHJQMUPFVHUQFJNRZRDVGVISURUSTTUTVA $.

  $( The conjugation operation of the field of complex numbers.  (Contributed
     by Mario Carneiro, 6-Oct-2015.)  (Revised by Thierry Arnoux,
     17-Dec-2017.)  (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldcj $p |- * = ( *r ` CCfld ) $=
    ( ccj cvv wcel ccnfld cstv cfv wceq cc wf cjf cnex fex2 mp3an c1 c3 cop cnx
    csn ctp cun cdc cnfldstr starvid cbs cplusg caddc cmulr cmul ssun2 cts cabs
    cmin ccom cmopn cple cunif cmetu ssun1 df-cnfld sseqtr4i sstri strfv ax-mp
    cle cds ) ABCZADEFGHHAIHBCZVGVFJKKHHABBLMADEBNNOUAPUBUCQEFAPRZQUDFHPQUEFUFP
    QUGFUHPSZVHTZDVHVIUIVJVJQUJFUKULUMZUNFPQUOFVDPQVEFVKPSQUPFVKUQFPRTZTDVJVLUR
    USUTVAVBVC $.

  $( The topology component of the field of complex numbers.  (Contributed by
     Mario Carneiro, 14-Aug-2015.)  (Revised by Mario Carneiro, 6-Oct-2015.)
     (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldtset $p |- ( MetOpen ` ( abs o. - ) ) = ( TopSet ` CCfld ) $=
    ( cabs cmin ccom cmopn cfv cvv wcel ccnfld cts wceq fvex c1 cdc cop cnx csn
    c3 ctp cun sstri cnfldstr tsetid cple cle cds snsstp1 cunif cmetu ssun1 cbs
    cc cplusg caddc cmulr cmul cstv ccj ssun2 df-cnfld sseqtr4i strfv ax-mp ) A
    BCZDEZFGVDHIEJVCDKVDHIFLLQMNUAUBOIEVDNZPVEOUCEUDNZOUEEVCNZRZHVEVFVGUFVHVHOU
    GEVCUHENPZSZHVHVIUIVJOUJEUKNOULEUMNOUNEUONROUPEUQNPSZVJSHVJVKURUSUTTTVAVB
    $.

  $( The ordering of the field of complex numbers.  (Note that this is not
     actually an ordering on ` CC ` , but we put it in the structure anyway
     because restricting to ` RR ` does not affect this component, so that
     ` ( CCfld |``s RR ) ` is an ordered field even though ` CCfld ` itself is
     not.)  (Contributed by Mario Carneiro, 14-Aug-2015.)  (Revised by Mario
     Carneiro, 6-Oct-2015.)  (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldle $p |- <_ = ( le ` CCfld ) $=
    ( cle ctsr wcel ccnfld cple cfv wceq letsr c1 c3 cdc cop cnfldstr pleid cnx
    csn cts ctp cun sstri cabs cmin ccom cmopn cds snsstp2 cunif cmetu ssun1 cc
    cbs cplusg caddc cmulr cmul cstv ccj ssun2 df-cnfld sseqtr4i strfv ax-mp )
    ABCADEFGHADEBIIJKLMNOEFALZPOQFUAUBUCZUDFLZVCOUEFVDLZRZDVEVCVFUFVGVGOUGFVDUH
    FLPZSZDVGVHUIVIOUKFUJLOULFUMLOUNFUOLROUPFUQLPSZVISDVIVJURUSUTTTVAVB $.

  $( The metric of the field of complex numbers.  (Contributed by Mario
     Carneiro, 14-Aug-2015.)  (Revised by Mario Carneiro, 6-Oct-2015.)
     (Revised by Thierry Arnoux, 17-Dec-2017.) $)
  cnfldds $p |- ( abs o. - ) = ( dist ` CCfld ) $=
    ( cabs cmin ccom cvv wcel ccnfld cds cfv wceq cc cr wf cnex cop cnx csn ctp
    c1 cun sstri cxp absf subf fco mp2an xpex reex fex2 mp3an cdc cnfldstr dsid
    c3 cts cmopn cple cle snsstp3 cunif cmetu ssun1 cbs cplusg caddc cmulr cmul
    cstv ccj ssun2 df-cnfld sseqtr4i strfv ax-mp ) ABCZDEZVNFGHIJJUAZKVNLZVPDEK
    DEVOJKALVPJBLVQUBUCVPJKABUDUEJJMMUFUGVPKVNDDUHUIVNFGDRRUMUJNUKULOGHVNNZPOUN
    HVNUOHNZOUPHUQNZVRQZFVSVTVRURWAWAOUSHVNUTHNPZSZFWAWBVAWCOVBHJNOVCHVDNOVEHVF
    NQOVGHVHNPSZWCSFWCWDVIVJVKTTVLVM $.

  $( The uniform structure component of the complex numbers.  (Contributed by
     Thierry Arnoux, 17-Dec-2017.) $)
  cnfldunif $p |- ( metUnif ` ( abs o. - ) ) = ( UnifSet ` CCfld ) $=
    ( cabs cmin ccom cmetu cfv cvv wcel ccnfld cunif wceq c1 c3 cdc cop cnx csn
    fvex ctp cun ssun2 cnfldstr unifid cts cmopn cle cds cbs cplusg caddc cmulr
    cple cc cmul cstv ccj df-cnfld sseqtr4i sstri strfv ax-mp ) ABCZDEZFGVBHIEJ
    VADQVBHIFKKLMNUAUBOIEVBNPZOUCEVAUDENOUKEUENOUFEVANRZVCSZHVCVDTVEOUGEULNOUHE
    UINOUJEUMNROUNEUONPSZVESHVEVFTUPUQURUSUT $.

  ${
    $d x y z A $.  $d x y B $.
    $( The extended real structure is a structure.  (Contributed by Mario
       Carneiro, 21-Aug-2015.) $)
    xrsstr $p |- RR*s Struct <. 1 , ; 1 2 >. $=
      ( vx vy cxr cv cle wbr cxne cxad cif cmpt2 cxmu cordt cfv df-xrs odrngstr
      co cxrs ) CABCCADZBDZEFSRGHPRSGHPIJHKELMEQABNO $.

    $( The extended real structure is a set.  (Contributed by Mario Carneiro,
       21-Aug-2015.) $)
    xrsex $p |- RR*s e. _V $=
      ( vx vy cxrs cnx cbs cfv cxr cop cplusg cxad cmulr cxmu ctp cts cle cordt
      cv cxne co tpex cple cds wbr cif cmpt2 cun cvv df-xrs unex eqeltri ) CDEF
      GHZDIFJHZDKFLHZMZDNFOPFHZDUAFOHZDUBFABGGAQZBQZOUCURUQRJSUQURRJSUDUEHZMZUF
      UGABUHUNUTUKULUMTUOUPUSTUIUJ $.

    $( The base set of the extended real number structure.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    xrsbas $p |- RR* = ( Base ` RR*s ) $=
      ( vx vy cxr cvv wcel cxrs cbs cfv wceq xrex cv cle wbr cxne cxad co cmpt2
      cif cxmu cordt df-xrs odrngbas ax-mp ) CDECFGHIJCABCCAKZBKZLMUEUDNOPUDUEN
      OPRQOSLTHLDFABUAUBUC $.

    $( The addition operation of the extended real number structure.
       (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    xrsadd $p |- +e = ( +g ` RR*s ) $=
      ( vx vy cxad cvv wcel cxrs cplusg cfv wceq cxr wf xaddf xrex xpex fex2 cv
      cxp cle cxne co mp3an wbr cif cmpt2 cxmu cordt df-xrs odrngplusg ax-mp )
      CDEZCFGHIJJQZJCKUKDEJDEUJLJJMMNMUKJCDDOUAJABJJAPZBPZRUBUMULSCTULUMSCTUCUD
      CUERUFHRDFABUGUHUI $.

    $( The multiplication operation of the extended real number structure.
       (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    xrsmul $p |- *e = ( .r ` RR*s ) $=
      ( vx vy cxmu cvv wcel cxrs cmulr cfv wceq cxr cxp wf xmulf xrex xpex cxne
      cv cle cxad co fex2 mp3an wbr cif cmpt2 cordt df-xrs odrngmulr ax-mp ) CD
      EZCFGHIJJKZJCLUKDEJDEUJMJJNNONUKJCDDUAUBJABJJAQZBQZRUCUMULPSTULUMPSTUDUES
      CRUFHRDFABUGUHUI $.

    $( The topology component of the extended real number structure.
       (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    xrstset $p |- ( ordTop ` <_ ) = ( TopSet ` RR*s ) $=
      ( vx vy cle cordt cfv cvv wcel cxrs cts wceq fvex cxr cv wbr cxne cxad co
      cif cmpt2 cxmu df-xrs odrngtset ax-mp ) CDEZFGUDHIEJCDKLABLLAMZBMZCNUFUEO
      PQUEUFOPQRSPTUDCFHABUAUBUC $.

    $( The ordering of the extended real number structure.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    xrsle $p |- <_ = ( le ` RR*s ) $=
      ( vx vy cle cvv wcel cxrs cple cfv wceq cxr cxp xrex lerelxr ssexi cv wbr
      xpex cxne cxad co cif cmpt2 cxmu cordt df-xrs odrngle ax-mp ) CDECFGHICJJ
      KJJLLQMNJABJJAOZBOZCPUIUHRSTUHUIRSTUAUBSUCCUDHCDFABUEUFUG $.

    $( The complex numbers form a commutative ring.  (Contributed by Mario
       Carneiro, 8-Jan-2015.) $)
    cncrng $p |- CCfld e. CRing $=
      ( vx vy vz ccnfld wcel wtru cc caddc cmul c1 cfv cnfldbas a1i cnfldadd cv
      wceq cc0 co 3adant1 adantl ccrg cbs cplusg cmulr cnfldmul cgrp cneg addcl
      addass 0cn addid2 negcl addcom mpancom negid eqtrd isgrpi mulcl w3a adddi
      mulass adddir ax-1cn mulid2 mulid1 mulcom iscrngd trud ) DUAEFABCGHDIJGDU
      BKPFLMHDUCKPFNMIDUDKPFUEMDUFEFABCGHDAOZUGZQLNVIBOZUHVIVKCOZUIUJVIUKVIULZV
      IGEZVJVIHRZVIVJHRZQVJGEVNVOVPPVMVJVIUMUNVIUOUPUQMVNVKGEZVIVKIRZGEFVIVKURS
      VNVQVLGEUSZVRVLIRVIVKVLIRZIRPFVIVKVLVATVSVIVKVLHRIRVRVIVLIRZHRPFVIVKVLUTT
      VSVIVKHRVLIRWAVTHRPFVIVKVLVBTJGEFVCMVNJVIIRVIPFVIVDTVNVIJIRVIPFVIVETVNVQV
      RVKVIIRPFVIVKVFSVGVH $.

    $( The complex numbers form a ring.  (Contributed by Stefan O'Rear,
       27-Nov-2014.) $)
    cnrng $p |- CCfld e. Ring $=
      ( ccnfld ccrg wcel crg cncrng crngrng ax-mp ) ABCADCEAFG $.

    $( The multiplicative group of the extended reals forms a commutative
       monoid (even though the additive group is not, see ~ xrs1mnd .)
       (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    xrsmcmn $p |- ( mulGrp ` RR*s ) e. CMnd $=
      ( vx vy vz cxrs cmgp cfv ccmn wcel wtru cxr cxmu cbs wceq eqid c1 3adant1
      a1i cv co adantl xrsbas mgpbas cplusg xrsmul mgpplusg xmulcl xmulass rexr
      w3a cr 1re mp1i xmulid2 xmulid1 ismndd xmulcom iscmnd trud ) DEFZGHIABJKU
      SJUSLFMIJDUSUSNZUAUBQZKUSUCFMIDKUSUTUDUEQZIABCJKUSOVAVBARZJHZBRZJHZVCVEKS
      ZJHIVCVEUFPVDVFCRZJHUIVGVHKSVCVEVHKSKSMIVCVEVHUGTOUJHOJHIUKOUHULVDOVCKSVC
      MIVCUMTVDVCOKSVCMIVCUNTUOVDVFVGVEVCKSMIVCVEUPPUQUR $.

    $( The zero element of the field of complex numbers.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.) $)
    cnfld0 $p |- 0 = ( 0g ` CCfld ) $=
      ( ccnfld c0g cfv cc0 caddc co wceq 00id cgrp cc wb crg cnrng rnggrp ax-mp
      wcel 0cn cnfldbas cnfldadd eqid grpid mp2an mpbi eqcomi ) ABCZDDDEFDGZUED
      GZHAIPZDJPUFUGKALPUHMANOQJEADUERSUETUAUBUCUD $.

    $( The unit element of the field of complex numbers.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.) $)
    cnfld1 $p |- 1 = ( 1r ` CCfld ) $=
      ( vx ccnfld cur cfv c1 cc wcel cv cmul wceq wral ax-1cn mulid2 mulid1 jca
      co wa rgen pm3.2i crg wb cnrng cnfldbas cnfldmul eqid isrngid mpbi eqcomi
      ax-mp ) BCDZEEFGZEAHZIPULJZULEIPULJZQZAFKZQZUJEJZUKUPLUOAFULFGUMUNULMULNO
      RSBTGUQURUAUBAFBIUJEUCUDUJUEUFUIUGUH $.

    $( The additive inverse in the field of complex numbers.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.) $)
    cnfldneg $p |- ( X e. CC -> ( ( invg ` CCfld ) ` X ) = -u X ) $=
      ( cc wcel ccnfld cminusg cfv cneg wceq caddc co negid wb negcl cgrp cnrng
      cc0 crg rnggrp ax-mp cnfldbas cnfldadd cnfld0 eqid grpinvid1 mp3an1 mpdan
      mpbird ) ABCZADEFZFAGZHZAUJIJPHZAKUHUJBCZUKULLZAMDNCZUHUMUNDQCUOODRSBIDUI
      AUJPTUAUBUIUCUDUEUFUG $.

    $( The functionalized addition operation of the field of complex numbers.
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    cnfldplusf $p |- + = ( +f ` CCfld ) $=
      ( ccnfld cplusf cfv caddc cxp wfn wceq ax-addf ffn cnfldbas cnfldadd eqid
      cc wf plusfeq mp2b eqcomi ) ABCZDMMEZMDNDSFRDGHSMDIMDRAJKRLOPQ $.

    $( The subtraction operator in the field of complex numbers.  (Contributed
       by Mario Carneiro, 15-Jun-2015.) $)
    cnfldsub $p |- - = ( -g ` CCfld ) $=
      ( vx vy cc cv cmin cmpt2 ccnfld cfv wcel caddc cnfldbas eqid wceq wfn ffn
      co wf ax-mp fnov mpbi csg cminusg cneg cnfldadd grpsubval cnfldneg adantl
      wa oveq2d negsub 3eqtrrd mpt2eq3ia cxp subf cgrp crg cnrng rnggrp grpsubf
      mp2b 3eqtr4i ) ABCCADZBDZEPZFZABCCVBVCGUAHZPZFZEVFABCCVDVGVBCIZVCCIZUHZVG
      VBVCGUBHZHZJPVBVCUCZJPVDCJGVLVFVBVCKUDVLLVFLZUEVKVMVNVBJVJVMVNMVIVCUFUGUI
      VBVCUJUKULECCUMZNZEVEMVPCEQVQUNVPCEORABCCESTVFVPNZVFVHMGUOIZVPCVFQVRGUPIV
      SUQGURRCGVFKVOUSVPCVFOUTABCCVFSTVA $.

    $( The complex numbers form a division ring.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.) $)
    cndrng $p |- CCfld e. DivRing $=
      ( vx vy ccnfld cdr wcel wtru cc cmul c1 cv cdiv co cc0 cbs cfv a1i wne wa
      wceq adantl cnfldbas cmulr c0g cnfld0 cur cnfld1 crg cnrng mulne0 3adant1
      cnfldmul ax-1ne0 reccl recne0 recid2 isdrngd trud ) CDEFABGCHIIAJZKLZMGCN
      OSFUAPHCUBOSFUKPMCUCOSFUDPICUEOSFUFPCUGEFUHPURGEURMQRZBJZGEVAMQRURVAHLMQF
      URVAUIUJIMQFULPUTUSGEFURUMTUTUSMQFURUNTUTUSURHLISFURUOTUPUQ $.

    $( The division operation in the field of complex numbers.  (Contributed by
       Stefan O'Rear, 27-Nov-2014.)  (Revised by Mario Carneiro,
       2-Dec-2014.) $)
    cnflddiv $p |- / = ( /r ` CCfld ) $=
      ( vx vy vz cc cc0 cv cmul co wceq cmpt2 ccnfld cfv cdiv wa cnrng cnfldbas
      wcel eqid cnfldmul eqtr3d csn cdif crio cdvr cnfld0 cndrng drngui dvrcan1
      cinvr crg mp3an1 oveq1d dvrcl wne simpr eldifsn sylib simpld simprd simpl
      divcan4d divval syl3anc dvrval mpt2eq3ia df-div dvrfval 3eqtr4i ) ABDDEUA
      UBZBFZCFGHAFZICDUCZJABDVIVKVJKUILZLGHZJMKUDLZABDVIVLVNVKDQZVJVIQZNZVKVJVO
      HZVLVNVRVKVJMHZVSVLVRVSVJGHZVJMHVTVSVRWAVKVJMKUJQZVPVQWAVKIODVOKGVIVKVJPD
      KEPUEUFUGZVORZSUHUKULVRVSVJWBVPVQVSDQODVOKVIVKVJPWCWDUMUKVRVJDQZVJEUNZVRV
      QWEWFNVPVQUOVJDEUPUQZURZVRWEWFWGUSZVATVRVPWEWFVTVLIVPVQUTWHWICVKVJVBVCTDV
      OKGVIVMVKVJPSWCVMRZWDVDTVEABCVFABDVOKGVIVMPSWCWJWDVGVH $.

    $( The multiplicative inverse in the field of complex numbers.
       (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    cnfldinv $p |- ( ( X e. CC /\ X =/= 0 ) ->
      ( ( invr ` CCfld ) ` X ) = ( 1 / X ) ) $=
      ( cc wcel cc0 wne wa csn cdif ccnfld cinvr cfv c1 cdiv wceq eldifsn cnrng
      co crg cnfldbas cnfld0 cndrng drngui cnflddiv cnfld1 eqid rnginvdv sylbir
      mpan ) ABCADEFABDGHZCZAIJKZKLAMQNZABDOIRCUJULPBMIUILUKASBIDSTUAUBUCUDUKUE
      UFUHUG $.

    $( The group multiple function in the field of complex numbers.
       (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    cnfldmulg $p |- ( ( A e. ZZ /\ B e. CC ) ->
        ( A ( .g ` CCfld ) B ) = ( A x. B ) ) $=
      ( vx vy cc wcel ccnfld cfv co cmul wceq cv cneg c1 caddc eqeq12d cnfldbas
      cc0 oveq1 eqid cz cmg cnfld0 mulg0 mul02 eqtr4d cn0 wi wa cmnd crg rngmnd
      cnrng ax-mp mulgnn0p1 mp3an1 nn0cn adantr ax-1cn a1i simpr adddird mulid2
      cnfldadd adantl oveq2d eqtrd syl5ibr expcom cn cminusg fveq2 nncn mulneg1
      mulgnegnn sylan mulcl cnfldneg syl zindd impcom ) BEFZAUAFABGUBHZIZABJIZK
      ZCLZBWCIZWGBJIZKRBWCIZRBJIZKDLZBWCIZWLBJIZKZWLMZBWCIZWPBJIZKZWLNOIZBWCIZW
      TBJIZKZWFWBCDAWGRKWHWJWIWKWGRBWCSWGRBJSPWGWLKWHWMWIWNWGWLBWCSWGWLBJSPWGWT
      KWHXAWIXBWGWTBWCSWGWTBJSPWGWPKWHWQWIWRWGWPBWCSWGWPBJSPWGAKWHWDWIWEWGABWCS
      WGABJSPWBWJRWKEWCGBRQUCWCTZUDBUEUFWLUGFZWBWOXCUHWOXCXEWBUIZWMBOIZWNBOIZKW
      MWNBOSXFXAXGXBXHGUJFZXEWBXAXGKGUKFXIUMGULUNEOWCGWLBQXDVDUOUPXFXBWNNBJIZOI
      XHXFWLNBXEWLEFZWBWLUQURNEFXFUSUTXEWBVAVBXFXJBWNOWBXJBKXEBVCVEVFVGPVHVIWLV
      JFZWBWOWSUHWOWSXLWBUIZWMGVKHZHZWNXNHZKWMWNXNVLXMWQXOWRXPEWCGXNWLBQXDXNTVO
      XMWRWNMZXPXLXKWBWRXQKWLVMZWLBVNVPXMWNEFZXPXQKXLXKWBXSXRWLBVQVPWNVRVSUFPVH
      VIVTWA $.

    $( The exponentiation operator in the field of complex numbers (for
       nonnegative exponents).  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    cnfldexp $p |- ( ( A e. CC /\ B e. NN0 ) ->
        ( B ( .g ` ( mulGrp ` CCfld ) ) A ) = ( A ^ B ) ) $=
      ( vx vy cn0 wcel cc ccnfld cfv co cexp wceq wi cc0 c1 oveq1 oveq2 eqeq12d
      imbi2d cmul cmgp cv caddc eqid cnfldbas mgpbas cnfld1 rngidval mulg0 exp0
      cmg eqtr4d cmnd crg cnrng rngmgp ax-mp cnfldmul mgpplusg mulgnn0p1 mp3an1
      wa ancoms expp1 syl5ibr expcom a2d nn0ind impcom ) BEFAGFZBAHUAIZUKIZJZAB
      KJZLZVJCUBZAVLJZAVPKJZLZMVJNAVLJZANKJZLZMVJDUBZAVLJZAWCKJZLZMVJWCOUCJZAVL
      JZAWGKJZLZMVJVOMCDBVPNLZVSWBVJWKVQVTVRWAVPNAVLPVPNAKQRSVPWCLZVSWFVJWLVQWD
      VRWEVPWCAVLPVPWCAKQRSVPWGLZVSWJVJWMVQWHVRWIVPWGAVLPVPWGAKQRSVPBLZVSVOVJWN
      VQVMVRVNVPBAVLPVPBAKQRSVJVTOWAGVLVKAOGHVKVKUDZUEUFZHOVKWOUGUHVLUDZUIAUJUL
      WCEFZVJWFWJVJWRWFWJMWFWJVJWRVBZWDATJZWEATJZLWDWEATPWSWHWTWIXAWRVJWHWTLZVK
      UMFZWRVJXBHUNFXCUOHVKWOUPUQGTVLVKWCAWPWQHTVKWOURUSUTVAVCAWCVDRVEVFVGVHVI
      $.

    $( The complex numbers form a *-ring.  (Contributed by Mario Carneiro,
       6-Oct-2015.) $)
    cnsrng $p |- CCfld e. *Ring $=
      ( vx ccnfld csr wcel wtru caddc cmul ccj cbs cfv wceq cnfldbas a1i cplusg
      vy cc cv adantl co 3adant1 cnfldadd cmulr cnfldmul cstv cnfldcj crg cnrng
      cjcl cjadd wa mulcom fveq2d cjmul ancoms eqtrd cjcj issrngd trud ) BCDEAO
      FBGHPPBIJKELMFBNJKEUAMGBUBJKEUCMHBUDJKEUEMBUFDEUGMAQZPDZUSHJZPDEUSUHRUTOQ
      ZPDZUSVBFSHJVAVBHJZFSKEUSVBUITUTVCUSVBGSZHJZVDVAGSZKEUTVCUJZVFVBUSGSZHJZV
      GVHVEVIHUSVBUKULVCUTVJVGKVBUSUMUNUOTUTVAHJUSKEUSUPRUQUR $.
  $}

  ${
    $d x y z R $.
    xrs1mnd.1 $e |- R = ( RR*s |`s ( RR* \ { -oo } ) ) $.
    $( The extended real numbers, restricted to ` RR* \ { -oo } ` , form a
       monoid.  The full structure is not a monoid or even a semigroup because
       associativity fails for
       ` 1 + ( -oo + +oo ) = 1 =/= ( 1 + -oo ) + +oo = 0 ` .  (Contributed by
       Mario Carneiro, 27-Nov-2014.) $)
    xrs1mnd $p |- R e. Mnd $=
      ( vx vy vz wcel wtru cxr cmnf cxad cc0 cfv wceq mp1i cvv cv co wa eldifsn
      wne cmnd csn cdif wss difss cxrs xrsbas ressbas2 cplusg xrex difexg ax-mp
      cbs xrsadd ressplusg xaddcl ad2ant2r sylanbrc syl2anb 3adant1 w3a xaddass
      xaddnemnf syl3anb adantl cr 0re renemnf eldifi xaddid2 syl xaddid1 ismndd
      rexr trud ) AUAFGCDEHIUBZUCZJAKVQHUDVQAUMLMGHVPUEVQHAUFBUGUHNVQOFZJAUILMG
      HOFVRUJHVPOUKULVQJUFAOBUNUONCPZVQFZDPZVQFZVSWAJQZVQFZGVTVSHFZVSITZRZWAHFZ
      WAITZRZWDWBVSHISZWAHISZWGWJRWCHFZWCITWDWEWHWMWFWIVSWAUPUQVSWAVCWCHISURUSU
      TVTWBEPZVQFZVAWCWNJQVSWAWNJQJQMZGVTWGWBWJWOWNHFWNITRWPWKWLWNHISVSWAWNVBVD
      VEKVFFZKVQFZGVGWQKHFKITWRKVNKVHKHISURNGVTRZWEKVSJQVSMVTWEGVSHVPVIVEZVSVJV
      KWSWEVSKJQVSMWTVSVLVKVMVO $.

    $( The zero of the extended real number monoid.  (Contributed by Mario
       Carneiro, 21-Aug-2015.) $)
    xrs10 $p |- 0 = ( 0g ` R ) $=
      ( vx cc0 c0g cfv wceq wtru cxr cmnf csn cdif cxad wss cxrs ax-mp cvv wcel
      co syl cbs difss xrsbas ressbas2 eqid cplusg xrex xrsadd ressplusg cr 0re
      ssexi wne rexr renemnf eldifsn sylanbrc mp1i cv wa eldifi xaddid2 xaddid1
      adantl ismgmid2 trud ) DAEFZGHCIJKZLZMDAVGVIINVIAUAFGIVHUBZVIIAOBUCUDPVGU
      EVIQRMAUFFGVIIUGVJULVIMOAQBUHUIPDUJRZDVIRZHUKVKDIRDJUMVLDUNDUODIJUPUQURHC
      USZVIRZUTZVMIRZDVMMSVMGVNVPHVMIVHVAVDZVMVBTVOVPVMDMSVMGVQVMVCTVEVF $.

    $( The extended real numbers restricted to ` RR* \ { -oo } ` form a
       commutative monoid.  They are not a group because ` 1 + +oo = 2 + +oo `
       even though ` 1 =/= 2 ` .  (Contributed by Mario Carneiro,
       27-Nov-2014.) $)
    xrs1cmn $p |- R e. CMnd $=
      ( vx vy ccmn wcel cmnd cv cxad co wceq cxr cmnf csn wral eldifi cfv ax-mp
      cxrs cvv cdif xrs1mnd xaddcom syl2an rgen2a wss cbs difss xrsbas ressbas2
      cplusg xrex difexg xrsadd ressplusg iscmn mpbir2an ) AEFAGFCHZDHZIJUSURIJ
      KZDLMNZUAZOCVBOABUBUTCDVBURVBFURLFUSLFUTUSVBFURLVAPUSLVAPURUSUCUDUECDVBIA
      VBLUFVBAUGQKLVAUHVBLASBUIUJRVBTFZIAUKQKLTFVCULLVATUMRVBISATBUNUORUPUQ $.

    $( The nonnegative extended real numbers are a submonoid of the
       non-negative-infinite extended reals.  (Contributed by Mario Carneiro,
       21-Aug-2015.) $)
    xrge0subm $p |- ( 0 [,] +oo ) e. ( SubMnd ` R ) $=
      ( vx vy cc0 co cfv wcel cxr cmnf wss cv cxad cle wbr wa elxrge0 ax-mp cvv
      wral cpnf cicc csubmnd csn cdif wne simpl ge0nemnf jca eldifsn ssriv 0le0
      3imtr4i 0xr mpbir2an ge0xaddcl rgen2a cmnd w3a wb xrs1mnd wceq difss cxrs
      xrsbas ressbas2 xrs10 cplusg xrex difexg xrsadd ressplusg issubm mpbir3an
      cbs ) EUAUBFZAUCGHZVPIJUDZUEZKZEVPHZCLZDLZMFVPHZDVPTCVPTZCVPVSWBIHZEWBNOZ
      PZWFWBJUFZPWBVPHWBVSHWHWFWIWFWGUGWBUHUIWBQWBIJUJUMUKWAEIHEENOUNULEQUOWDCD
      VPWBWCUPUQAURHVQVTWAWEUSUTABVACDVSMVPAEVSIKVSAVOGVBIVRVCVSIAVDBVEVFRABVGV
      SSHZMAVHGVBISHWJVIIVRSVJRVSMVDASBVKVLRVMRVN $.
  $}

  ${
    $( The nonnegative extended real numbers are a monoid.  (Contributed by
       Mario Carneiro, 30-Aug-2015.) $)
    xrge0cmn $p |- ( RR*s |`s ( 0 [,] +oo ) ) e. CMnd $=
      ( cxrs cxr cmnf csn cdif co ccmn wcel cc0 cpnf cicc cmnd eqid cfv cvv wss
      cress wceq ax-mp mp2an xrs1cmn csubmnd xrge0subm difss ssexi cbs ressbas2
      xrex xrsbas submss ressabs eqcomi submmnd subcmn ) ABCDZEZQFZGHAIJKFZQFZL
      HZUSGHUQUQMZUAURUQUBNHZUTUQVAUCZURUSUQUQURQFZUSUPOHURUPPZVDUSRUPBUHBUOUDZ
      UEVBVEVCUPURUQUPBPUPUQUFNRVFUPBUQAVAUIUGSUJSUPURAOUKTULZUMSURUQUSVGUNT $.
  $}

  ${
    $d x y A $.  $d x y B $.
    xrsds.d $e |- D = ( dist ` RR*s ) $.
    $( The metric of the extended real number structure.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xrsds $p |- D = ( x e. RR* , y e. RR* |->
            if ( x <_ y , ( y +e -e x ) , ( x +e -e y ) ) ) $=
      ( cxrs cds cfv cxr cv cle wbr cxne cxad cvv wcel wral xnegcl xaddcl xrex
      co cif cmpt2 wceq cxp wf wa syl2anr sylan2 ifcl syl2anc rgen2a eqid fmpt2
      id mpbi xpex fex2 mp3an cxmu cordt df-xrs odrngds ax-mp eqtr4i ) CEFGZABH
      HAIZBIZJKZVGVFLZMTZVFVGLZMTZUAZUBZDVNNOZVNVEUCHHUDZHVNUEZVPNOHNOVOVMHOZBH
      PAHPVQVRABHVFHOZVGHOZUFVJHOZVLHOZVRVTVTVIHOWAVSVTUNVFQVGVIRUGVTVSVKHOWBVG
      QVFVKRUHVHVJVLHUIUJUKABHHVMHVNVNULUMUOHHSSUPSVPHVNNNUQURHVNMUSJUTGJNEABVA
      VBVCVD $.

    $( The metric of the extended real number structure.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xrsdsval $p |- ( ( A e. RR* /\ B e. RR* ) ->
      ( A D B ) = if ( A <_ B , ( B +e -e A ) , ( A +e -e B ) ) ) $=
      ( vx vy cxr cv cle wbr cxne cxad co cif wceq wa breq12 id xnegeq ovex
      oveqan12rd oveqan12d ifbieq12d xrsds ifex ovmpt2a ) EFABGGEHZFHZIJZUHUGKZ
      LMZUGUHKZLMZNABIJZBAKZLMZABKZLMZNCUGAOZUHBOZPUIUNUKUMUPURUGAUHBIQUTUSUHBU
      JUOLUTRUGASUAUSUTUGAULUQLUSRUHBSUBUCEFCDUDUNUPURBUOLTAUQLTUEUF $.

    $( The metric of the extended real number structure coincides with the real
       number metric on the reals.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    xrsdsreval $p |- ( ( A e. RR /\ B e. RR ) ->
      ( A D B ) = ( abs ` ( A - B ) ) ) $=
      ( cr wcel wa co cle wbr cxne cxad cmin cxr wceq eqeq1 rexsub adantr 3expa
      rexr cif cabs xrsdsval syl2an ancoms abssuble0 eqtr4d wn letric abssubge0
      cfv orcanai 3com12 syldan ifbothda eqtrd ) AEFZBEFZGZABCHZABIJZBAKLHZABKL
      HZUAZABMHZUBUKZUQANFBNFUTVDOURATBTABCDUCUDVAVBVFOVCVFOVDVFOUSVBVCVBVDVFPV
      CVDVFPUSVAGVBBAMHZVFUSVBVGOZVAURUQVHBAQUERUQURVAVFVGOABUFSUGUSVAUHZGVCVEV
      FUSVCVEOVIABQRUSVIBAIJZVFVEOZUSVAVJABUIULUQURVJVKURUQVJVKBAUJUMSUNUGUOUP
      $.

    $( Lemma for ~ xrsdsreclb .  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    xrsdsreclblem $p |- ( ( ( A e. RR* /\ B e. RR* /\ A =/= B ) /\ A <_ B ) ->
      ( ( B +e -e A ) e. RR -> ( A e. RR /\ B e. RR ) ) ) $=
      ( cxr wcel wne cle wbr cxne cxad co cr wi clt cmnf cpnf wceq syl eleq1d
      wa w3a necom xrleltne mnfxr a1i simpl1 simpl2 pnfnre neli mnfle xrlelttrd
      simpl3 xrltne syl3anc xaddpnf1 syl2anc mtbiri wn wb ngtmnft simpr xnegmnf
      xnegeq syl6eq syl5ibcom sylbird mt3d xrre2 syl32anc pnfxr xnegcld xnegpnf
      oveq2d pnfge xrltletrd xltnegi syl5eqbrr xaddpnf2 nltpnft oveq1 ex 3expia
      jca 3adant3 syl5bi 3exp com34 3imp1 ) AEFZBEFZABGZABHIZBAJZKLZMFZAMFZBMFZ
      UAZNZWJWKWMWLWTWJWKWMWLWTNWLBAGZWJWKWMUBZWTABUCXBXAABOIZWTABUDWJWKXCWTNWM
      WJWKXCWTWJWKXCUBZWPWSXDWPUAZWQWRXEPEFZWJWKPAOIZXCWQXFXEUEUFZWJWKXCWPUGZWJ
      WKXCWPUHZXEXGBQKLZMFZXEXLQMFZQMUIUJZXEXKQMXEWKBPGZXKQRXJXEXFWKPBOIXOXHXJX
      EPABXHXIXJXEWJPAHIXIAUKSWJWKXCWPUMZULPBUNUOBUPUQTURXEXGUSZAPRZXLXEWJXRXQU
      TXIAVASXEWPXRXLXDWPVBZXRWOXKMXRWNQBKXRWNPJQAPVDVCVEVNTVFVGVHXPPABVIVJXEWJ
      WKQEFZXCBQOIZWRXIXJXTXEVKUFZXPXEYAQWNKLZMFZXEYDXMXNXEYCQMXEWNEFZWNPGZYCQR
      XEAXIVLZXEXFYEPWNOIYFXHYGXEPQJZWNOVMXEWJXTAQOIYHWNOIXIYBXEABQXIXJYBXPXEWK
      BQHIXJBVOSVPAQVQUOVRPWNUNUOWNVSUQTURXEYAUSZBQRZYDXEWKYJYIUTXJBVTSXEWPYJYD
      XSYJWOYCMBQWNKWATVFVGVHABQVIVJWDWBWCWEVGWFWGWHWI $.

    $( The metric of the extended real number structure is only real when both
       arguments are real.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    xrsdsreclb $p |- ( ( A e. RR* /\ B e. RR* /\ A =/= B ) ->
      ( ( A D B ) e. RR <-> ( A e. RR /\ B e. RR ) ) ) $=
      ( cxr wcel wne w3a co cr wa cle wbr cxne cxad wceq 3adant3 wi eleq1 cc wn
      cif xrsdsval eleq1d imbi1d xrsdsreclblem wo xrletri orcanai necom 3anbi3i
      bitri sylanb ancom syl6ib syldan ifbothda sylbid cmin cabs cfv xrsdsreval
      3ancoma recn subcl syl2an abscld eqeltrd impbid1 ) AEFZBEFZABGZHZABCIZJFZ
      AJFZBJFZKZVMVOABLMZBANOIZABNOIZUBZJFZVRVMVNWBJVJVKVNWBPVLABCDUCQUDVSVTJFZ
      VRRWAJFZVRRZWCVRRVMVTWAVTWBPWDWCVRVTWBJSUEWAWBPWEWCVRWAWBJSUEABCDUFVMVSUA
      BALMZWFVMVSWGVJVKVSWGUGVLABUHQUIVMWGKWEVQVPKZVRVMVKVJBAGZHZWGWEWHRVMVJVKW
      IHWJVLWIVJVKABUJUKVJVKWIVCULBACDUFUMVQVPUNUOUPUQURVRVNABUSIZUTVAJABCDVBVR
      WKVPATFBTFWKTFVQAVDBVDABVEVFVGVHVI $.
  $}

  ${
    $d x y A $.
    cnsubglem.1 $e |- ( x e. A -> x e. CC ) $.
    cnsubglem.2 $e |- ( ( x e. A /\ y e. A ) -> ( x + y ) e. A ) $.
    ${
      cnsubmlem.3 $e |- 0 e. A $.
      $( Lemma for ~ nn0subm and friends.  (Contributed by Mario Carneiro,
         18-Jun-2015.) $)
      cnsubmlem $p |- A e. ( SubMnd ` CCfld ) $=
        ( ccnfld csubmnd cfv wcel cc wss cc0 cv caddc co wral ssriv rgen2a crg
        cmnd w3a wb cnrng rngmnd cnfldbas cnfld0 cnfldadd issubm mp2b mpbir3an
        ) CGHIJZCKLZMCJZANBNOPCJZBCQACQZACKDRFUOABCESGTJGUAJULUMUNUPUBUCUDGUEAB
        KOCGMUFUGUHUIUJUK $.
    $}

    cnsubglem.3 $e |- ( x e. A -> -u x e. A ) $.
    ${
      cnsubglem.4 $e |- B e. A $.
      $( Lemma for ~ resubdrg and friends.  (Contributed by Mario Carneiro,
         4-Dec-2014.) $)
      cnsubglem $p |- A e. ( SubGrp ` CCfld ) $=
        ( ccnfld csubg cfv wcel cc wss c0 wne cv caddc wral ax-mp co cminusg wa
        ssriv ne0i ralrimiva cneg wceq cnfldneg syl eqeltrd jca rgen w3a wb crg
        cgrp cnrng rnggrp cnfldbas cnfldadd eqid issubg2 mpbir3an ) CIJKLZCMNZC
        OPZAQZBQRUACLZBCSZVHIUBKZKZCLZUCZACSZACMEUDDCLVGHCDUETVNACVHCLZVJVMVPVI
        BCFUFVPVLVHUGZCVPVHMLVLVQUHEVHUIUJGUKULUMIUQLZVEVFVGVOUNUOIUPLVRURIUSTA
        BMRCIVKUTVAVKVBVCTVD $.
    $}

    cnsubrglem.4 $e |- 1 e. A $.
    cnsubrglem.5 $e |- ( ( x e. A /\ y e. A ) -> ( x x. y ) e. A ) $.
    $( Lemma for ~ resubdrg and friends.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    cnsubrglem $p |- A e. ( SubRing ` CCfld ) $=
      ( ccnfld csubrg cfv wcel csubg c1 cv cmul co wral cnsubglem rgen2a crg wb
      w3a cnrng cc cnfldbas cnfld1 cnfldmul issubrg2 ax-mp mpbir3an ) CIJKLZCIM
      KLZNCLZAOBOPQCLZBCRACRZABCNDEFGSGUOABCHTIUALULUMUNUPUCUBUDABCUEIPNUFUGUHU
      IUJUK $.

    cnsubrglem.6 $e |- ( ( x e. A /\ x =/= 0 ) -> ( 1 / x ) e. A ) $.
    $( Lemma for ~ resubdrg and friends.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    cnsubdrglem $p |-
        ( A e. ( SubRing ` CCfld ) /\ ( CCfld |`s A ) e. DivRing ) $=
      ( ccnfld cfv wcel co cdr cc0 cdif cndrng eqid cnfld0 cc csubrg cnsubrglem
      cress cv cinvr csn wral wb issubdrg mp2an cdiv crg wceq cnrng ssriv ssdif
      c1 wss ax-mp cnfldbas drngui cnflddiv cnfld1 rnginvdv sylancr wne eldifsn
      sseli wa sylbi eqeltrd mprgbir pm3.2i ) CJUAKLZJCUCMZNLZABCDEFGHUBZVPAUDZ
      JUEKZKZCLZACOUFZPZJNLVNVPWAAWCUGUHQVQACJVOVSOVORSVSRZUIUJVRWCLZVTUQVRUKMZ
      CWEJULLVRTWBPZLVTWFUMUNWCWGVRCTURWCWGURACTDUOCTWBUPUSVHTUKJWGUQVSVRUTTJOU
      TSQVAVBVCWDVDVEWEVRCLVROVFVIWFCLVRCOVGIVJVKVLVM $.
  $}

  ${
    $d x y z R $.
    $( The real numbers form a division subring of the complexes.  (Contributed
       by Mario Carneiro, 4-Dec-2014.) $)
    resubdrg $p |-
        ( RR e. ( SubRing ` CCfld ) /\ ( CCfld |`s RR ) e. DivRing ) $=
      ( vx vy cr cv recn readdcl renegcl 1re remulcl rereccl cnsubdrglem ) ABCA
      DZELBDZFLGHLMILJK $.

    $( The rational numbers form a division subring of the complexes.
       (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    qsubdrg $p |-
        ( QQ e. ( SubRing ` CCfld ) /\ ( CCfld |`s QQ ) e. DivRing ) $=
      ( vx vy cq cv qcn qaddcl qnegcl cz c1 1z sselii qmulcl qreccl cnsubdrglem
      zssq ) ABCADZEPBDZFPGHCIOJKPQLPMN $.

    $( The integers form a subring of the complexes.  (Contributed by Mario
       Carneiro, 4-Dec-2014.) $)
    zsubrg $p |- ZZ e. ( SubRing ` CCfld ) $=
      ( vx vy cz cv zcn zaddcl znegcl 1z zmulcl cnsubrglem ) ABCADZEKBDZFKGHKLI
      J $.

    $( The gaussian integers form a subring of the complexes.  (Contributed by
       Mario Carneiro, 4-Dec-2014.) $)
    gzsubrg $p |- Z[i] e. ( SubRing ` CCfld ) $=
      ( vx vy cgz cv gzcn gzaddcl gznegcl c1 cz 1z zgz ax-mp gzmulcl cnsubrglem
      wcel ) ABCADZEPBDZFPGHIOHCOJHKLPQMN $.

    $( The nonnegative integers form a submonoid of the complexes.
       (Contributed by Mario Carneiro, 18-Jun-2015.) $)
    nn0subm $p |- NN0 e. ( SubMnd ` CCfld ) $=
      ( vx vy cn0 cv nn0cn nn0addcl 0nn0 cnsubmlem ) ABCADZEIBDFGH $.

    $( The nonnegative reals form a submonoid of the complexes.  (Contributed
       by Mario Carneiro, 20-Jun-2015.) $)
    rege0subm $p |- ( 0 [,) +oo ) e. ( SubMnd ` CCfld ) $=
      ( vx vy cc0 cpnf cico co cv wcel cr cxr wss 0re pnfxr icossre mp2an sseli
      recnd ge0addcl cle wbr 0le0 elrege0 mpbir2an cnsubmlem ) ABCDEFZAGZUEHUFU
      EIUFCIHZDJHUEIKLMCDNOPQUFBGRCUEHUGCCSTLUACUBUCUD $.

    $( The regular absolute value function on the complex numbers is in fact an
       absolute value under our definition.  (Contributed by Mario Carneiro,
       4-Dec-2014.) $)
    absabv $p |- abs e. ( AbsVal ` CCfld ) $=
      ( vx vy cabs ccnfld cfv wcel wtru caddc cmul cc0 wceq a1i wne wbr 3adant1
      cc cv wa co ad2ant2r cabv eqidd cbs cnfldbas cplusg cnfldadd cnfldmul c0g
      cmulr cnfld0 crg cnrng cr wf absf abs0 absgt0 biimpa absmul abstri isabvd
      clt cle trud ) CDUAEZFGABVEPHDICJGVEUBPDUCEKGUDLHDUEEKGUFLIDUIEKGUGLJDUHE
      KGUJLDUKFGULLPUMCUNGUOLJCEJKGUPLAQZPFZVFJMZJVFCEZVBNZGVGVHVJVFUQUROVGVHRZ
      BQZPFZVLJMZRZVFVLISCEVIVLCEZISKZGVGVMVQVHVNVFVLUSTOVKVOVFVLHSCEVIVPHSVCNZ
      GVGVMVRVHVNVFVLUTTOVAVD $.

    $( The integers are a subset of any subring of the complexes.  (Contributed
       by Mario Carneiro, 15-Oct-2015.) $)
    zsssubrg $p |- ( R e. ( SubRing ` CCfld ) -> ZZ C_ R ) $=
      ( vx ccnfld csubrg cfv wcel cz cv wa c1 cmg co cmul wceq ax-1cn cnfldmulg
      cc simpr sylancl adantr zcn adantl mulid1d eqtrd csubg subrgsubg subrg1cl
      cnfld1 eqid subgmulgcl syl3anc eqeltrrd ex ssrdv ) ACDEFZBGAUOBHZGFZUPAFU
      OUQIZUPJCKEZLZUPAURUTUPJMLZUPURUQJQFUTVANUOUQRZOUPJPSURUPUQUPQFUOUPUAUBUC
      UDURACUEEFZUQJAFZUTAFUOVCUQACUFTVBUOVDUQACJUHUGTAUSCUPJUSUIUJUKULUMUN $.

    $( The rational numbers are a subset of any subfield of the complexes.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    qsssubdrg $p |- ( ( R e. ( SubRing ` CCfld ) /\
      ( CCfld |`s R ) e. DivRing ) -> QQ C_ R ) $=
      ( vz vx vy ccnfld cfv wcel co wa cq cv cdiv wceq cn wrex cz ad2antrr eqid
      sseldd cc0 csubrg cress cdr elq cbs crg cui drngrng ad2antlr wss zsssubrg
      cdvr subrgbas sseqtrd simprl c0g wne ad2antll nnne0 cnfld0 subrg0 neeqtrd
      wb drngunit mpbir2and dvrcl syl3anc simpll cnflddiv subrgdv 3eltr4d eleq1
      nnz syl5ibrcom rexlimdvva syl5bi ssrdv ) AEUAFGZEAUBHZUCGZIZBJABKZJGWBCKZ
      DKZLHZMZDNOCPOWAWBAGZCDWBUDWAWFWGCDPNWAWCPGZWDNGZIZIZWGWFWEAGWKWCWDVSULFZ
      HZVSUEFZWEAWKVSUFGZWCWNGWDVSUGFZGZWMWNGVTWOVRWJVSUHUIWKPWNWCWKPAWNVRPAUJV
      TWJAUKQZVRAWNMVTWJAEVSVSRZUMQZUNZWAWHWIUOZSWKWQWDWNGZWDVSUPFZUQZWKPWNWDXA
      WIWDPGWAWHWDVMURSWKWDTXDWIWDTUQWAWHWDUSURVRTXDMVTWJAEVSTWSUTVAQVBVTWQXCXE
      IVCVRWJWNVSWPWDXDWNRZWPRZXDRVDUIVEZWNWLVSWPWCWDXFXGWLRZVFVGWKVRWCAGWQWEWM
      MVRVTWJVHWKPAWCWRXBSXHALEVSWPWLWCWDWSVIXGXIVJVGWTVKWBWEAVLVNVOVPVQ $.

    $( There are no subrings of the complexes strictly between ` RR ` and
       ` CC ` .  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    cnsubrg $p |- ( ( R e. ( SubRing ` CCfld ) /\ RR C_ R ) ->
      R e. { RR , CC } ) $=
      ( vx ccnfld cfv wcel cr wss wa cc wceq c0 simplr syl ci co caddc ad2antll
      cmul sseldd syl3anc vy csubrg cpr wo cdif ssdif0 simpr eqssd sylan2br wne
      orcd cv wex n0 simpll cnfldbas subrgss cre cim replim recl c1 cdiv ax-icn
      a1i eldifi adantl recnd wn cc0 eldifn wb reim0b necon3bbid mpbid divcan4d
      imcl mulcl sylancr divrecd eqtr3d cneg cmin negsubd oveq1d pncan2d 3eqtrd
      recld renegcld cnfldadd subrgacl eqeltrrd rereccld cnfldmul subrgmcl expr
      eqeltrd adantrr ssrdv olcd ex exlimdv imp sylan2b pm2.61dane elprg adantr
      mpbird ) ACUBDZEZFAGZHZAFIUCEZAFJZAIJZUDZXLXPAFUEZKXQKJXLAFGZXPAFUFXLXRHZ
      XNXOXSAFXLXRUGXJXKXRLUHUKUIXQKUJXLBULZXQEZBUMZXPBXQUNXLYBXPXLYAXPBXLYAXPX
      LYAHZXOXNYCAIYCXJAIGXJXKYAUOZAICUPUQMZYCUAIAXLYAUAULZIEZYFAEXLYAYGHZHZYFY
      FURDZNYFUSDZROZPOZAYGYFYMJXLYAYFUTQYIXJYJAEYLAEZYMAEXJXKYHUOZYIFAYJXJXKYH
      LZYGYJFEXLYAYFVAQSYIXJNAEZYKAEYNYOXLYAYQYGYCNNXTUSDZROZVBYRVCOZROZAYCYSYR
      VCONUUAYCNYRNIEZYCVDVEYCYRYCXTIEZYRFEYCAIXTYEYAXTAEZXLXTAFVFVGZSZXTVQMZVH
      ZYCXTFEZVIZYRVJUJZYAUUJXLXTAFVKVGYCUUCUUJUUKVLUUFUUCUUIYRVJXTVMVNMVOZVPYC
      YSYRYCUUBYRIEYSIEVDUUHNYRVRVSZUUHUULVTWAYCXJYSAEYTAEUUAAEYDYCXTXTURDZWBZP
      OZYSAYCUUPXTUUNWCOUUNYSPOZUUNWCOYSYCXTUUNUUFYCUUNYCXTUUFWHZVHZWDYCXTUUQUU
      NWCYCUUCXTUUQJUUFXTUTMWEYCUUNYSUUSUUMWFWGYCXJUUDUUOAEUUPAEYDUUEYCFAUUOXJX
      KYALZYCUUNUURWISAPCXTUUOWJWKTWLYCFAYTUUTYCYRUUGUULWMSACRYSYTWNWOTWQWRYIFA
      YKYPYGYKFEXLYAYFVQQSACRNYKWNWOTAPCYJYLWJWKTWQWPWSUHWTXAXBXCXDXEXJXMXPVLXK
      AFIXIXFXGXH $.
  $}

  ${
    $d x y A $.  $d x y M $.
    cnmgpabl.m $e |- M = ( ( mulGrp ` CCfld ) |`s ( CC \ { 0 } ) ) $.
    $( The unit group of the complex numbers is an abelian group.  (Contributed
       by Mario Carneiro, 21-Jun-2015.) $)
    cnmgpabl $p |- M e. Abel $=
      ( ccnfld ccrg wcel cabel cncrng cc cc0 cdif cnfldbas cnfld0 cndrng drngui
      csn unitabl ax-mp ) CDEAFEGCHIOJAHCIKLMNBPQ $.

    ${
      cnmsubglem.1 $e |- ( x e. A -> x e. CC ) $.
      cnmsubglem.2 $e |- ( x e. A -> x =/= 0 ) $.
      cnmsubglem.3 $e |- ( ( x e. A /\ y e. A ) -> ( x x. y ) e. A ) $.
      cnmsubglem.4 $e |- 1 e. A $.
      cnmsubglem.5 $e |- ( x e. A -> ( 1 / x ) e. A ) $.
      $( Lemma for ~ rpmsubg and friends.  (Contributed by Mario Carneiro,
         21-Jun-2015.) $)
      cnmsubglem $p |- A e. ( SubGrp ` M ) $=
        ( cfv wcel cc cc0 wss cmul ccnfld c1 wceq cvv csubg csn cdif c0 cv wral
        wne co cinvr wa eldifsn sylanbrc ssriv ax-mp ralrimiva cnfldinv syl2anc
        ne0i cdiv eqeltrd jca rgen cabel cgrp w3a wb cnmgpabl ablgrp difss cmgp
        cbs eqid cnfldbas mgpbas ressbas2 cplusg cnex difexg cnfldmul ressplusg
        mgpplusg mp2b cnfld0 cndrng drngui invrfval issubg2 mpbir3an ) CDUAKLZC
        MNUBZUCZOZCUDUGZAUEZBUEPUHCLZBCUFZWNQUIKZKZCLZUJZACUFZACWKWNCLZWNMLZWNN
        UGZWNWKLFGWNMNUKULUMRCLWMICRURUNWTACXBWPWSXBWOBCHUOXBWRRWNUSUHZCXBXCXDW
        RXESFGWNUPUQJUTVAVBDVCLDVDLWIWLWMXAVEVFDEVGDVHABWKPCDWQWKMOWKDVKKSMWJVI
        WKMDQVJKZEMQXFXFVLZVMVNVOUNMTLWKTLPDVPKSVQMWJTVRWKPXFDTEQPXFXGVSWAVTWBQ
        WKDWQMQNVMWCWDWEEWQVLWFWGWBWH $.
    $}

    $( The positive reals form a multiplicative subgroup of the complexes.
       (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    rpmsubg $p |- RR+ e. ( SubGrp ` M ) $=
      ( vx vy crp cv rpcn rpne0 rpmulcl 1rp rpreccl cnmsubglem ) CDEABCFZGMHMDF
      IJMKL $.
  $}

  ${
    gzrng.1 $e |- Z = ( CCfld |`s Z[i] ) $.
    $( Lemma for ~ gzrngunit .  (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    gzrngunitlem $p |- ( A e. ( Unit ` Z ) -> 1 <_ ( abs ` A ) ) $=
      ( cfv wcel c1 cle wbr c2 cexp co cc0 cgz ccnfld wceq wb gzsubrg ax-mp syl
      mp2b cui cabs sq1 cn ax-1ne0 csubrg crg subrgrng eqid csubg c0g subrgsubg
      cnfld0 subg0 cur cnfld1 subrg1 0unit nemtbir wn cn0 wo subrgbas gzabssqcl
      cbs unitcl elnn0 sylib ord gzcn abscld recnd sqeq0 abs00ad biimpcd sylbid
      cc eleq1 syld mt3i nnge1d syl5eqbr cr absge0d wa 1re 0le1 mpanl12 syl2anc
      le2sq mpbird ) ABUADZEZFAUBDZGHZFIJKZWNIJKZGHZWMWPFWQGUCWMWQWMWQUDEZLWLEZ
      WTFLUEMNUFDEZBUGEWTFLOPQMNBCUHBWLFLWLUIZXAMNUJDELBUKDOQMNULMNBLCUMUNTXAFB
      UODOQMNBFCUPUQRURTUSWMWSUTWQLOZWTWMWSXCWMWQVAEZWSXCVBWMAMEZXDMBWLAXAMBVED
      OQMNBCVCRXBVFZAVDSWQVGVHVIWMXCWNLOZWTWMWNVQEXCXGPWMWNWMAWMXEAVQEXFAVJSZVK
      ZVLWNVMSWMXGALOZWTWMAXHVNXJWMWTALWLVRVOVPVPVSVTWAWBWMWNWCEZLWNGHZWOWRPZXI
      WMAXHWDFWCELFGHXKXLWEXMWFWGFWNWJWHWIWK $.

    $( The units on ` ZZ [ _i ] ` are the gaussian integers with norm ` 1 ` .
       (Contributed by Mario Carneiro, 4-Dec-2014.) $)
    gzrngunit $p |- ( A e. ( Unit ` Z ) <->
      ( A e. Z[i] /\ ( abs ` A ) = 1 ) ) $=
      ( cfv wcel cgz cabs c1 wceq ccnfld gzsubrg ax-mp eqid cle wbr cdiv co cc0
      cc a1i cui wa csubrg cbs subrgbas unitcl cinvr subrginv mpan wne gzcn syl
      cr 0re 1re abscld clt 0lt1 gzrngunitlem ltletrd gt0ne0d abs00ad necon3bid
      mpbid cnfldinv syl2anc eqtr3d subrgrng unitinvcl eqeltrrd absdivd breqtrd
      crg ax-1cn div1i abs1 eqcomi oveq1i 3brtr4g lerec syl22anc mpbird sylancl
      wb letri3 mpbir2and jca csn cdif adantr simpr ax-1ne0 eqnetrd abs0 syl6eq
      fveq2 necon3i eldifsn sylanbrc simpl ccj cmul cexp absvalsqd oveq1d cjcld
      c2 sq1 divcan3d 3eqtr2d gzcjcl eqeltrd w3a cnfld0 cndrng drngui subrgunit
      cnfldbas syl3anbrc impbii ) ABUADZEZAFEZAGDZHIZUBZYBYCYEFBYAAFJUCDEZFBUDD
      IKFJBCUELYAMZUFZYBYEYDHNOZHYDNOZYBYJHHPQZHYDPQZNOZYBHHGDZYDPQZYLYMNYBHHAP
      QZGDZYPNYBYQYAEHYRNOYBABUGDZDZYQYAYBAJUGDZDZYTYQYGYBUUBYTIKFJBYAUUAYSACUU
      AMZYHYSMZUHUIYBASEZARUJZUUBYQIZYBYCUUEYIAUKZULZYBYDRUJZUUFYBYDYBRHYDRUMEY
      BUNTHUMEZYBUOTZYBAUUIUPZRHUQOZYBURTZABCUSZUTZVAYBYDRARYBAUUIVBVCVDZAVEZVF
      VGBVMEZYBYTYAEYGUUTKFJBCVHLBYAYSAYHUUDVIUIVJYQBCUSULYBHAHSEYBVNTUUIUURVKV
      LHVNVOHYOYDPYOHVPVQVRVSYBYDUMEZRYDUQOUUKUUNYJYNWDUUMUUQUULUUOYDHVTWAWBUUP
      YBUVAUUKYEYJYKUBWDUUMUOYDHWEWCWFWGYFASRWHWIZEZYCUUBFEZYBYFUUEUUFUVCYCUUEY
      EUUHWJZYFUUJUUFYFYDHRYCYEWKZHRUJYFWLTWMARYDRARIYDRGDRARGWPWNWOWQULZASRWRW
      SYCYEWTYFUUBAXADZFYFUUBYQAUVHXBQZAPQUVHYFUUEUUFUUGUVEUVGUUSVFYFUVIHAPYFYD
      XGXCQZUVIHYFAUVEXDYFUVJHXGXCQHYFYDHXGXCUVFXEXHWOVGXEYFUVHAYFAUVEXFUVEUVGX
      IXJYCUVHFEYEAXKWJXLYGYBUVCYCUVDXMWDKFJBUVBUUAYAACSJRXRXNXOXPYHUUCXQLXSXT
      $.
  $}

  ${
    zrng.1 $e |- Z = ( CCfld |`s ZZ ) $.
    $( The units of ` ZZ ` are the integers with norm ` 1 ` , i.e. ` 1 ` and
       ` -u 1 ` .  (Contributed by Mario Carneiro, 5-Dec-2014.) $)
    zrngunit $p |- ( A e. ( Unit ` Z ) <-> ( A e. ZZ /\ ( abs ` A ) = 1 ) ) $=
      ( cfv wcel cz cabs c1 wceq ccnfld zsubrg ax-mp eqid cgz cress co cc0 cexp
      cc c2 vx cui wa csubrg cbs subrgbas unitcl wss zgz ssriv gzsubrg subsubrg
      cv mpbir2an ressabs mp2an eqtr4i subrguss sseli gzrngunit simprbi syl jca
      csn cdif cinvr wne zcn adantr simpr ax-1ne0 a1i eqnetrd fveq2 abs0 syl6eq
      wb necon3i eldifsn sylanbrc simpl cdiv cnfldinv syl2anc cr absresq oveq1d
      cmul zre sq1 sqvald 3eqtr3rd ax-1cn divmuld mpbird eqtrd eqeltrd cnfldbas
      w3a cnfld0 cndrng drngui subrgunit syl3anbrc impbii ) ABUBDZEZAFEZAGDZHIZ
      UCZXGXHXJFBXFAFJUDDZEZFBUEDIKFJBCUFLXFMZUGXGAJNOPZUBDZEZXJXFXPAFXOUDDEZXF
      XPUHXRXMFNUHZKUAFNUAUMUIUJZNXLEZXRXMXSUCVQUKNFJXOXOMZULLUNFXOBXPXFBJFOPZX
      OFOPZCYAXSYDYCIUKXTNFJXLUOUPUQXPMXNURLUSXQANEXJAXOYBUTVAVBVCXKASQVDVEZEZX
      HAJVFDZDZFEZXGXKASEZAQVGZYFXHYJXJAVHVIZXKXIQVGYKXKXIHQXHXJVJZHQVGXKVKVLVM
      AQXIQAQIXIQGDQAQGVNVOVPVRVBZASQVSVTXHXJWAZXKYHAFXKYHHAWBPZAXKYJYKYHYPIYLY
      NAWCWDXKYPAIAAWHPZHIXKXITRPZATRPZHYQXKAWEEZYRYSIXHYTXJAWIVIAWFVBXKYRHTRPH
      XKXIHTRYMWGWJVPXKAYLWKWLXKHAAHSEXKWMVLYLYLYNWNWOWPYOWQXMXGYFXHYIWSVQKFJBY
      EYGXFACSJQWRWTXAXBXNYGMXCLXDXE $.
  $}

  ${
    $d f k n x A $.  $d f n x B $.  $d f k n x ph $.
    gsumfsum.1 $e |- ( ph -> A e. Fin ) $.
    gsumfsum.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( Relate a group sum on ` CCfld ` to a finite sum on the complexes.
       (Contributed by Mario Carneiro, 28-Dec-2014.) $)
    gsumfsum $p |- ( ph -> ( CCfld gsum ( k e. A |-> B ) ) = sum_ k e. A B ) $=
      ( vf vx c0 wceq ccnfld cgsu co csu cfv wcel wa cc0 cc syl vn chash cn cfz
      cmpt c1 cv wf1o wex wi mpteq1 mpt0 syl6eq oveq2d cnfld0 gsum0 sum0 eqtr4i
      sumeq1 eqtr4d a1i caddc ccom cseq cfn ccnv cvv csn cdif cnfldbas cnfldadd
      cima ccntz eqid crg cmnd cnrng rngmnd mp1i adantr wf ccmn rngcmn cntzcmnf
      fmptd simprl wf1 simprr f1of1 crn cdm cnvimass fdm syl5sseq wfo forn 3syl
      f1ofo sseqtr4d gsumval3 sumfc fveq2 ffvelrnda fvco3 sylan syl5eqr exlimdv
      f1of fsum expr expimpd wo fz1f1o mpjaod ) ABIJZKDBCUEZLMZBCDNZJZBUBOZUCPZ
      UFXTUDMZBGUGZUHZGUIZQZXOXSUJAXOXQICDNZXRXOXQKILMZYGXOXPIKLXOXPDICUEIDBICU
      KDCULUMUNYHRYGKRUOUPCDUQURUMBICDUSUTVAAYAYEXSAYAQYDXSGAYAYDXSAYAYDQZQZXQX
      TVBXPYCVCZUFVDOZXRYJBSVBXPKYCXTVEYKVFVGRVHVIZVLZRKVMOZVJUOVKYOVNZKVOPZKVP
      PYJVQKVRVSABVEPZYIEVTABSXPWAZYIADBCSXPFXPVNWEVTZYJBSXPKYOVJYPYQKWBPYJVQKW
      CVSYTWDAYAYDWFZYJYDYBBYCWGAYAYDWHZYBBYCWITYJXPVFYMVLZBYCWJZYJXPWKZUUCBXPY
      MWLYJYSUUEBJYTBSXPWMTWNYJYDYBBYCWOUUDBJUUBYBBYCWRYBBYCWPWQWSYNVNWTYJXRBHU
      GZXPOZHNYLBCHDXAYJBUUGUAUGZYCOZXPOZHUAYCYKXTUUFUUIXPXBUUAUUBYJBSUUFXPYTXC
      YJYBBYCWAZUUHYBPUUHYKOUUJJYJYDUUKUUBYBBYCXHTYBBUUHXPYCXDXEXIXFUTXJXGXKAYR
      XOYFXLEBGXMTXN $.
  $}

  ${
    $d Z x y z $.
    dvdsrz.z $e |- Z = ( CCfld |`s ZZ ) $.
    $( Ring divisibility in ` ZZ ` corresponds to ordinary divisibility.
       (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
    dvdsrz $p |- || = ( ||r ` Z ) $=
      ( vx vy vz cv cz wcel wa cmul co wceq copab cfv simpl cc ccnfld ax-mp cvv
      wrex cdivides anim1i zmulcl ancoms eleq1 syl5ibcom rexlimdva simpr impbii
      cdsr imp jca31 opabbii df-dvds wss cbs zsscn cnfldbas ressbas2 eqid cmulr
      zex cnfldmul ressmulr dvdsrval 3eqtr4i ) CFZGHZDFZGHZIZEFZVGJKZVILZEGTZIZ
      CDMVHVOIZCDMUAAUJNZVPVQCDVPVQVKVHVOVHVJOUBVQVHVJVOVHVOOVHVOVJVHVNVJEGVHVL
      GHZIVMGHZVNVJVSVHVTVLVGUCUDVMVIGUEUFUGUKVHVOUHULUIUMCDEUNCDEGVRAJGPUOGAUP
      NLUQGPAQBURUSRVRUTGSHJAVANLVBGQAJSBVCVDRVEVF $.
  $}

  ${
    $d Z a $.  $d I a $.  $d ph a $.  $d X a $.  $d G a $.
    zlpirlem.z $e |- Z = ( CCfld |`s ZZ ) $.
    zlpirlem.i $e |- ( ph -> I e. ( LIdeal ` Z ) ) $.
    zlpirlem.n0 $e |- ( ph -> I =/= { 0 } ) $.
    $( Lemma for ~ zlpir .  A nonzero ideal of integers contains some positive
       integers.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
    zlpirlem1 $p |- ( ph -> ( I i^i NN ) =/= (/) ) $=
      ( va cc0 wne cn wcel cfv cz ccnfld zsubrg ax-mp eqid wceq cc adantr cv c0
      cin crg clidl csn csubrg subrgrng a1i c0g cnfld0 subrg0 lidlnz syl3anc wa
      wrex cabs cneg simplr eleq1 syl5ibrcom cminusg subrgsubg wss cbs cnfldbas
      csubg zsscn ressbas2 lidlssOLD sylancr sselda subginv cnfldneg syl eqtr3d
      zcnd simpr lidlnegcl eqeltrrd wo zred absord mpjaod nnabscl elin sylanbrc
      sylan ne0i ex rexlimdva mpd ) AGUAZHIZGBUPZBJUCZUBIZACUDKZBCUELZKZBHUFIWO
      WRAMNUGLKZWROMNCDUHPZUIEFGCWSBHWSQZXAHCUJLROMNCHDUKULPUMUNAWNWQGBAWMBKZUO
      ZWNWQXEWNUOZWMUQLZWPKZWQXFXGBKZXGJKZXHXFXGWMRZXIXGWMURZRZXFXIXKXDAXDWNUSX
      GWMBUTVAXFXIXMXLBKZXEXNWNXEWMCVBLZLZXLBXEWMNVBLZLZXPXLXEMNVGLKZWMMKZXRXPR
      XAXSOMNVCPABMWMAWRWTBMVDXBEMBWSUDCMSVDMCVELRVHMSCNDVFVIPXCVJVKVLZMNCXQXOW
      MDXQQXOQZVMVKXEWMSKXRXLRXEWMYAVQWMVNVOVPXEWRWTXDXPBKWRXEXBUIAWTXDETAXDVRC
      WSBXOWMXCYBVSUNVTTXGXLBUTVAXEXKXMWAWNXEWMXEWMYAWBWCTWDXEXTWNXJYAWMWEWHXGB
      JWFWGWPXGWIVOWJWKWL $.

    zlpirlem.g $e |- G = sup ( ( I i^i NN ) , RR , `' < ) $.
    $( Lemma for ~ zlpir .  A nonzero ideal of integers contains the least
       positive element.  (Contributed by Stefan O'Rear, 3-Jan-2015.) $)
    zlpirlem2 $p |- ( ph -> G e. I ) $=
      ( cn cin cr clt ccnv csup inss1 c1 cuz cfv wss c0 wcel inss2 nnuz sseqtri
      wne zlpirlem1 infmssuzcl sylancr sseldi syl5eqel ) ABCIJZKLMNZCHAUKCULCIO
      AUKPQRZSUKTUEULUKUAUKIUMCIUBUCUDACDEFGUFUKPUGUHUIUJ $.

    zlpirlem.x $e |- ( ph -> X e. I ) $.
    $( Lemma for ~ zlpir .  All elements of a nonzero ideal of integers are
       divided by the least one.  (Contributed by Stefan O'Rear,
       3-Jan-2015.) $)
    zlpirlem3 $p |- ( ph -> G || X ) $=
      ( wbr co wceq cn wcel cz cfv ccnfld cmul caddc cdivides cmo cc0 wn wo cle
      clt cr crp crg clidl wss csubrg zsubrg subrgrng mp1i cc cnfldbas ressbas2
      cbs zsscn ax-mp eqid lidlssOLD syl2anc sseldd zred cin inss2 ccnv csup c1
      cuz c0 wne nnuz sseqtri zlpirlem1 infmssuzcl sylancr syl5eqel nnrpd modlt
      sseldi zmodcld nn0red nnred ltnled mpbid wa cdiv cfl cneg cmin zcnd nncnd
      nndivred flcld mulcld negsubd znegcld mulcomd mulneg2d 3eqtr4rd zlpirlem2
      eqtrd oveq2d modval cvv cmulr cnfldmul ressmulr lidlmcl syl22anc cnfldadd
      cplusg ressplusg lidlacl eqeltrd adantr elin sylanbrc infmssuzle syl5eqbr
      zex simpr mtand cn0 elnn0 sylib orel1 sylc wb dvdsval3 mpbird ) ABDUAKZDB
      UBLZUCMZAYQNOZUDYSYRUEZYRAYSBYQUFKZAYQBUGKZUUAUDADUHOZBUIOZUUBADACPDAEUJO
      ZCEUKQZOZCPULPRUMQOUUEAUNPREFUOUPZGPCUUFUJEPUQULPEUTQMVAPUQERFURUSVBZUUFV
      CZVDVEJVFZVGZABACNVHZNBCNVIZABUUMUHUGVJVKZUUMIAUUMVLVMQZULZUUMVNVOUUOUUMO
      UUMNUUPUUNVPVQZACEFGHVRUUMVLVSVTWAWDZWBZDBWCVEAYQBAYQADBUUKUUSWEZWFABUUSW
      GWHWIAYSWJZBUUOYQUFIUVBUUQYQUUMOZUUOYQUFKUURUVBYQCOZYSUVCAUVDYSAYQDDBWKLZ
      WLQZWMZBSLZTLZCADBUVFSLZWMZTLDUVJWNLZUVIYQADUVJADUUKWOABUVFABUUSWPZAUVFAU
      VEADBUULUUSWQWRZWOZWSWTAUVHUVKDTAUVHBUVGSLUVKAUVGBAUVGAUVFUVNXAZWOUVMXBAB
      UVFUVMUVOXCXFXGAUUCUUDYQUVLMUULUUTDBXHVEXDAUUEUUGDCOUVHCOZUVICOUUHGJAUUEU
      UGUVGPOBCOUVQUUHGUVPABCEFGHIXEPESUUFCUVGBUUJUUIPXIOZSEXJQMYEPRESXIFXKXLVB
      XMXNTEUUFCDUVHUUJUVRTEXPQMYEPTREXIFXOXQVBXRXNXSXTAYSYFYQCNYAYBYQUUMVLYCVT
      YDYGAYQYHOYTUVAYQYIYJYSYRYKYLABNODPOYPYRYMUUSUUKBDYNVEYO $.
  $}

  ${
    $d Z n x y z $.
    zlpir.z $e |- Z = ( CCfld |`s ZZ ) $.
    $( The integers are a principal ideal ring but not a field.  (Contributed
       by Stefan O'Rear, 3-Jan-2015.) $)
    zlpir $p |- Z e. LPIR $=
      ( vx vy vz wcel cfv cz ccnfld zsubrg ax-mp cv cc0 cdivides wbr wral simpr
      wa eqid wceq clpir crg clidl clpidl wss csubrg subrgrng csn eleq1 wrex cn
      wne cin cr clt ccnv simpl zlpirlem2 wel simpll simplr zlpirlem3 ralrimiva
      csup breq1 ralbidv rspcev syl2anc wb dvdsrz lpigen mpan adantr mpbird c0g
      cnfld0 subrg0 lpi0 mp1i pm2.61ne ssriv islpir2 mpbir2an ) AUAFAUBFZAUCGZA
      UDGZUEHIUFGFZWDJHIABUGKZCWEWFCLZWEFZWIWFFZMUHZWFFZWIWLWIWLWFUIWJWIWLULZRZ
      WKDLZELZNOZEWIPZDWIUJZWOWIUKUMUNUOUPVDZWIFXAWQNOZEWIPZWTWOXAWIABWJWNUQWJW
      NQXASZURWOXBEWIWOECUSZRXAWIWQABWJWNXEUTWJWNXEVAXDWOXEQVBVCWSXCDXAWIWPXATW
      RXBEWIWPXAWQNVEVFVGVHWJWKWTVIZWNWDWJXFWHDENWFAWEWIWESZWFSZABVJVKVLVMVNWDW
      MWJWHWFAMXHWGMAVOGTJHIAMBVPVQKVRVSVTWAWFAWEXHXGWBWC $.

    $( The integers are a cyclic group.  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    zcyg $p |- Z e. CycGrp $=
      ( vx vn ccyg wcel wtru cz cmg cfv c1 ccnfld csubg cbs wceq ax-mp 1z cv co
      eqid csubrg zsubrg subrgsubg subgbas cgrp subggrp mp1i a1i wrex cc ax-1cn
      cnfldmulg mpan2 subgmulg mp3an13 zcn mulid1d 3eqtr3rd oveq1 eqeq2d rspcev
      cmul mpdan adantl iscygd trud ) AEFGCHAIJZDAKHLMJFZHANJOHLUAJFVHUBHLUCPZH
      LABUDPVGTZVHAUEFGVIHLABUFUGKHFZGQUHCRZHFZVLDRZKVGSZOZDHUIZGVMVLVLKVGSZOZV
      QVMVLKLIJZSZVLKVBSZVRVLVMKUJFWAWBOUKVLKULUMVHVMVKWAVROVIQHVGVTLAVLKVTTBVJ
      UNUOVMVLVLUPUQURVPVSDVLHVNVLOVOVRVLVNVLKVGUSUTVAVCVDVEVF $.
  $}

  ${
    $d x y A $.  $d x y I $.  $d x y Z $.
    prmirred.1 $e |- Z = ( CCfld |`s ZZ ) $.
    prmirred.2 $e |- I = ( Irred ` Z ) $.
    $( A natural number is irreducible over ` ZZ ` iff it is a prime number.
       (Contributed by Mario Carneiro, 5-Dec-2014.) $)
    prmirredlem $p |- ( A e. NN -> ( A e. I <-> A e. Prime ) ) $=
      ( vy cn wcel wa cfv cdivides wbr c1 wceq cz co cmul cc0 ad2antrr syl wral
      vx cprime c2 cuz cv wo wi wne crg ccnfld csubrg zsubrg subrgrng ax-mp cur
      cnfld1 subrg1 irredn1 mpan anim2i eluz2b3 sylibr cui cdiv ad2antrl simprr
      nnz wb nnne0 dvdsval2 syl3anc mpbid zcnd nncn divcan2d simplr eqeltrd cbs
      subrgbas eqid cvv cmulr zex cnfldmul ressmulr irredmul cabs zrngunit baib
      cc cn0 nnnn0 nn0re nn0ge0 absidd eqeq1d bitrd cr nnre simprl nndivred cle
      clt nnred nngt0 divge0 syl22anc ax-1cn a1i divmuld mulid1d 3bitrd orbi12d
      expr ralrimiva isprm2 sylanbrc wn prmz 1nprm prmnn 3syl syl5ibcom adantld
      id eleq1 syl5bi simplrl nnne0d simpr simplrr mul02d 3netr4d oveq1 necon3i
      mtoi eqeq1 abscld recnd absne0d neneqd nn0abscl elnn0 sylib mt3d dvdsmul1
      ord simprbi ad2antlr breqtrd absdvdsb syl2anc breq1 imbi12d rspcv mulcand
      syl3c fveq2d absmuld 3eqtr3d eqeq12d eqcom syl6bb 3bitr2d mpbird isirred2
      ex ralrimivva syl3anbrc adantl impbida ) AGHZABHZAUCHZUVMUVNIZAUDUEJHZFUF
      ZAKLZUVRMNZUVRANZUGZUHZFGUAZUVOUVPUVMAMUIZIUVQUVNUWEUVMCUJHZUVNUWEOUKULJH
      ZUWFUMOUKCDUNUOCMBAEUWGMCUPJNUMOUKCMDUQURUOUSUTVAAVBVCUVPUWCFGUVPUVRGHZUV
      SUWBUVPUWHUVSIZIZUVRCVDJZHZAUVRVEPZUWKHZUGZUWBUWJUVROHZUWMOHZUVRUWMQPZBHU
      WOUWHUWPUVPUVSUVRVHVFZUWJUVSUWQUVPUWHUVSVGUWJUWPUVRRUIZAOHZUVSUWQVIUWSUWH
      UWTUVPUVSUVRVJVFZUVMUXAUVNUWIAVHSZUVRAVKVLVMZUWJUWRABUWJAUVRUWJAUXCVNZUWH
      UVRWKHUVPUVSUVRVOVFZUXBVPUVMUVNUWIVQVROCQUWKBUVRUWMEUWGOCVSJNUMOUKCDVTUOZ
      UWKWAZOWBHQCWCJNWDOUKCQWBDWEWFUOZWGVLUWJUWLUVTUWNUWAUWJUWLUVRWHJZMNZUVTUW
      JUWPUWLUXKVIZUWSUWLUWPUXKUVRCDWIWJZTUWJUXJUVRMUWHUXJUVRNZUVPUVSUWHUVRWLHZ
      UXNUVRWMUXOUVRUVRWNUVRWOWPTVFWQWRUWJUWNUWMWHJZMNZUWAUWJUWQUWNUXQVIUXDUWNU
      WQUXQUWMCDWIWJTUWJUXQUWMMNUVRMQPZANUWAUWJUXPUWMMUWJUWMUWJAUVRUVMAWSHZUVNU
      WIAWTSZUVPUWHUVSXAZXBUWJUXSRAXCLZUVRWSHRUVRXDLZRUWMXCLUXTUVMUYBUVNUWIUVMA
      WLHZUYBAWMZAWOZTSUWJUVRUYAXEUWHUYCUVPUVSUVRXFVFAUVRXGXHWPWQUWJAUVRMUXEUXF
      MWKHZUWJXIXJUXBXKUWJUXRUVRAUWJUVRUXFXLWQXMWRXNVMXOXPFAXQZXRUVOUVNUVMUVOUX
      AAUWKHZXSUBUFZUVRQPZANZUYJUWKHZUWLUGZUHZFOUAUBOUAUVNAXTZUVOUYIMUCHZYAUYIU
      XAAWHJZMNZIUVOUYQACDWIUVOUYSUYQUXAUVOUYRUCHUYSUYQUVOUYRAUCUVOUVMUYDUYRANZ
      AYBZUYEUYDAAWNUYFWPYCZUVOYFVRUYRMUCYGYDYEYHYQUVOUYOUBFOOUVOUYJOHZUWPIZIZU
      YLUYNVUEUYLIZUYNUYJWHJZMNZVUGANZUGZVUFVUGGHZUWDVUGAKLZVUJVUFVUKVUGRNZVUFV
      UGRVUFUYJVUFUYJUVOVUCUWPUYLYIZVNZVUFUYKRUVRQPZUIUYJRUIVUFARUYKVUPVUFAUVOU
      VMVUDUYLVUASYJVUEUYLYKZVUFUVRVUFUVRUVOVUCUWPUYLYLZVNZYMYNUYJRUYKVUPUYJRUV
      RQYOYPTUUAZUUBVUFVUKVUMVUFVUGWLHZVUKVUMUGVUFVUCVVAVUNUYJUUCTVUGUUDUUEUUHU
      UFUVOUWDVUDUYLUVOUVQUWDUYHUUISVUFUYJAKLZVULVUFUYJUYKAKVUDUYJUYKKLUVOUYLUY
      JUVRUUGUUJVUQUUKVUFVUCUXAVVBVULVIVUNUVOUXAVUDUYLUYPSUYJAUULUUMVMUWCVULVUJ
      UHFVUGGUVRVUGNZUVSVULUWBVUJUVRVUGAKUUNVVCUVTVUHUWAVUIUVRVUGMYRUVRVUGAYRXN
      UUOUUPUURVUFUYMVUHUWLVUIVUFVUCUYMVUHVIVUNUYMVUCVUHUYJCDWIWJTVUFUWLUXKVUGU
      XJQPZVUGMQPZNZVUIVUFUWPUXLVURUXMTVUFUXJMVUGVUFUXJVUFUVRVUSYSYTUYGVUFXIXJV
      UFVUGVUFUYJVUOYSYTZVUTUUQVUFVVFAVUGNVUIVUFVVDAVVEVUGVUFUYKWHJUYRVVDAVUFUY
      KAWHVUQUUSVUFUYJUVRVUOVUSUUTUVOUYTVUDUYLVUBSUVAVUFVUGVVGXLUVBAVUGUVCUVDUV
      EXNUVFUVHUVIUBFOCQUWKBAUXGUXHEUXIUVGUVJUVKUVL $.

    $( The positive irreducible elements of ` ZZ ` are the prime numbers.  This
       is an alternative way to define ` Prime ` .  (Contributed by Mario
       Carneiro, 5-Dec-2014.) $)
    dfprm2 $p |- Prime = ( NN i^i I ) $=
      ( vx cprime cn cin cv wcel wa prmnn prmirredlem bicomd biadan2 elin eqriv
      bitr4i ) EFGAHZEIZFJZTGJZTAJZKTSJUAUBUCTLUBUCUATABCDMNOTGAPRQ $.

    $( The irreducible elements of ` ZZ ` are exactly the prime numbers (and
       their negatives).  (Contributed by Mario Carneiro, 5-Dec-2014.) $)
    prmirred $p |- ( A e. I <-> ( A e. ZZ /\ ( abs ` A ) e. Prime ) ) $=
      ( wcel cz cfv cprime ccnfld wceq zsubrg ax-mp wb cn wi mpan eleq1d adantl
      cc0 cabs csubrg cbs subrgbas irredcl cn0 cr cneg wa wo elnn0 ax-1 crg wne
      subrgrng csubg subrgsubg cnfld0 subg0 irredn0 necon2bi pm2.21d jaoi sylbi
      c0g prmnn a1i prmirredlem pm5.21ndd nn0re nn0ge0 absidd cminusg irrednegb
      bitr4d eqid subginv cc zcn cnfldneg syl eqtr3d bitrd adantr zre cle nnnn0
      nn0ge0d le0neg1d mpbird absnidd 3bitr4d adantrl elznn0nn mpjaodan biadan2
      wbr biimpi ) ABFZAGFZAUAHZIFZGCBAEGJUBHFZGCUCHKLGJCDUDMZUEWTAUFFZWSXBNZAU
      GFZAUHZOFZUIZXEXFWTXEWSAIFZXBXEAOFZWSXKXEXLATKZUJWSXLPZAUKXLXNXMXLWSULXMW
      SXLWSATCUMFZWSATUNXCXOLGJCDUOMZCBATEGJUPHFZTCVEHKXCXQLGJUQMZGJCTDURUSMUTQ
      VAVBVCVDXKXLPXEAVFVGXLWSXKNPXEABCDEVHVGVIXEXAAIXEAAVJAVKVLRVOSWTXIXFXGWTX
      IUIZXHBFZXHIFZWSXBXIXTYANWTXHBCDEVHSWTWSXTNXIWTWSACVMHZHZBFZXTXOWTWSYDNXP
      GCBYBAEYBVPZXDVNQWTYCXHBWTAJVMHZHZYCXHXQWTYGYCKXRGJCYFYBADYFVPYEVQQWTAVRF
      YGXHKAVSAVTWAWBRWCWDXSXAXHIXSAWTXGXIAWEWDZXSATWFWQTXHWFWQZXIYIWTXIXHXHWGW
      HSXSAYHWIWJWKRWLWMWTXEXJUJAWNWRWOWP $.
  $}

  ${
    $d x y z A $.  $d y z M $.  $d y z N $.
    expmhm.1 $e |- N = ( CCfld |`s NN0 ) $.
    expmhm.2 $e |- M = ( mulGrp ` CCfld ) $.
    $( Exponentiation is a monoid homomorphism from addition to
       multiplication.  (Contributed by Mario Carneiro, 18-Jun-2015.) $)
    expmhm $p |- ( A e. CC -> ( x e. NN0 |-> ( A ^ x ) ) e. ( N MndHom M ) ) $=
      ( vy vz cc wcel cn0 cexp co caddc cfv cmul wceq cc0 ax-mp ccnfld cv wf c1
      cmpt wral cmhm expcl eqid fmptd wa expadd 3expb nn0addcl oveq2 ovex fvmpt
      adantl syl oveqan12d 3eqtr4d ralrimivva 0nn0 exp0 syl5eq cmnd w3a csubmnd
      nn0subm submmnd crg rngmgp pm3.2i submbas cnfldbas mgpbas cplusg cnfldadd
      cnrng cbs ressplusg cnfldmul mgpplusg cnfld0 subm0 rngidval ismhm mpbiran
      c0g cnfld1 syl3anbrc ) BIJZKIAKBAUAZLMZUDZUBZGUAZHUAZNMZWNOZWPWNOZWQWNOZP
      MZQZHKUEGKUEZRWNOZUCQZWNDCUFMJZWKAKWMIWNBWLUGWNUHZUIWKXCGHKKWKWPKJZWQKJZU
      JZUJZBWRLMZBWPLMZBWQLMZPMZWSXBWKXIXJXMXPQBWPWQUKULXLWRKJZWSXMQXKXQWKWPWQU
      MUQAWRWMXMKWNWLWRBLUNXHBWRLUOUPURXKXBXPQWKXIXJWTXNXAXOPAWPWMXNKWNWLWPBLUN
      XHBWPLUOUPAWQWMXOKWNWLWQBLUNXHBWQLUOUPUSUQUTVAWKXEBRLMZUCRKJXEXRQVBARWMXR
      KWNWLRBLUNXHBRLUOUPSBVCVDXGDVEJZCVEJZUJWOXDXFVFXSXTKTVGOZJZXSVHKDTEVISTVJ
      JXTVRTCFVKSVLGHKINPDCWNUCRYBKDVSOQVHKDTEVMSITCFVNVOYBNDVPOQVHKNTDYAEVQVTS
      TPCFWAWBYBRDWHOQVHKDTREWCWDSTUCCFWIWEWFWGWJ $.
  $}

  ${
    $d x y z A $.  $d y z U $.  $d y z Z $.
    expghm.1 $e |- Z = ( CCfld |`s ZZ ) $.
    expghm.2 $e |- M = ( mulGrp ` CCfld ) $.
    expghm.3 $e |- U = ( M |`s ( CC \ { 0 } ) ) $.
    $( Exponentiation is a group homomorphism from addition to multiplication.
       (Contributed by Mario Carneiro, 18-Jun-2015.) $)
    expghm $p |- ( ( A e. CC /\ A =/= 0 ) ->
        ( x e. ZZ |-> ( A ^ x ) ) e. ( Z GrpHom U ) ) $=
      ( vy cc wcel wa cz cexp co cfv cmul wceq ccnfld ax-mp vz cc0 wne csn cdif
      cv cmpt wf caddc wral cghm expclzlem 3expa eqid fmptd zaddcl adantl oveq2
      expaddz ovex fvmpt syl oveqan12d 3eqtr4d ralrimivva cgrp csubrg subrgsubg
      csubg zsubrg subggrp crg cnrng cnfldbas cnfld0 cndrng drngui cress oveq1i
      cmgp eqtri unitgrp pm3.2i cbs subrgbas wss difss mgpbas ressbas2 cnfldadd
      cplusg ressplusg cvv cui eqeltri cnfldmul mgpplusg isghm mpbiran sylanbrc
      fvex ) BJKZBUBUCZLZMJUBUDZUEZAMBAUFZNOZUGZUHZIUFZUAUFZUIOZXIPZXKXIPZXLXIP
      ZQOZRZUAMUJIMUJZXIECUKOKZXDAMXHXFXIXBXCXGMKXHXFKBXGULUMXIUNZUOXDXRIUAMMXD
      XKMKZXLMKZLZLZBXMNOZBXKNOZBXLNOZQOZXNXQBXKXLUSYEXMMKZXNYFRYDYJXDXKXLUPUQA
      XMXHYFMXIXGXMBNURYABXMNUTVAVBYDXQYIRXDYBYCXOYGXPYHQAXKXHYGMXIXGXKBNURYABX
      KNUTVAAXLXHYHMXIXGXLBNURYABXLNUTVAVCUQVDVEXTEVFKZCVFKZLXJXSLYKYLMSVIPKZYK
      MSVGPZKZYMVJMSVHTMSEFVKTSVLKYLVMSXFCJSUBVNVOVPVQZCDXFVROSVTPZXFVROHDYQXFV
      RGVSWAWBTWCUAIUIQECXIMXFYOMEWDPRVJMSEFWETXFJWFXFCWDPRJXEWGXFJCDHJSDGVNWHW
      ITYOUIEWKPRVJMUISEYNFWJWLTXFWMKQCWKPRXFSWNPWMYPSWNXAWOXFQDCWMHSQDGWPWQWLT
      WRWSWT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Algebraic constructions based on the complexes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ZRHom $. $( Map the integers into a field $)
  $c ZMod $. $( Turn an abelian group into a ZZ-module $)
  $c chr $.
  $c Z/nZ $. $( Integers mod n $)

  $( Map the rationals into a field, or the integers into a ring. $)
  czrh $a class ZRHom $.

  $( Augment an abelian group with vector space operations to turn it into a
     ` ZZ ` -module. $)
  czlm $a class ZMod $.

  $( Syntax for ring characteristic. $)
  cchr $a class chr $.

  $( The ring of integers modulo ` n ` . $)
  czn $a class Z/nZ $.

  ${
    $d n z s f r x $.
    $( Define the unique homomorphism from the integers into a ring.  This
       encodes the usual notation of ` n = 1r + 1r + ... + 1r ` for integers
       (see also ~ df-mulg ).  (Contributed by Mario Carneiro, 13-Jun-2015.) $)
    df-zrh $a |- ZRHom = ( r e. _V |-> U. ( ( CCfld |`s ZZ ) RingHom r ) ) $.

    $( Augment an abelian group with vector space operations to turn it into a
       ` ZZ ` -module.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    df-zlm $a |- ZMod = ( g e. _V |-> ( ( g
      sSet <. ( Scalar ` ndx ) , ( CCfld |`s ZZ ) >. )
      sSet <. ( .s ` ndx ) , ( .g ` g ) >. ) ) $.

    $( The characteristic of a ring is the smallest positive integer which is
       equal to 0 when interpreted in the ring, or 0 if there is no such
       positive integer.  (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
    df-chr $a |- chr = ( g e. _V |-> ( ( od ` g ) ` ( 1r ` g ) ) ) $.

    $( Define the ring of integers ` mod n ` .  This is literally the quotient
       ring of ` ZZ ` by the ideal ` n ZZ ` , but we augment it with a total
       order.  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    df-zn $a |- Z/nZ = ( n e. NN0 |-> [_ ( CCfld |`s ZZ ) / z ]_
      [_ ( z /s ( z ~QG ( ( RSpan ` z ) ` { n } ) ) ) / s ]_
      ( s sSet <. ( le ` ndx ) , [_ ( ( ZRHom ` s ) |`
      if ( n = 0 , ZZ , ( 0 ..^ n ) ) ) / f ]_
        ( ( f o. <_ ) o. `' f ) >. ) ) $.
  $}

  ${
    $d n x y B $.  $d f x y F $.  $d f n x y R $.  $d n .x. $.  $d f n x y Z $.
    $d n x y .1. $.
    mulgghm2.1 $e |- Z = ( CCfld |`s ZZ ) $.
    mulgghm2.2 $e |- .x. = ( .g ` R ) $.
    mulgghm2.3 $e |- F = ( n e. ZZ |-> ( n .x. .1. ) ) $.
    ${
      mulgghm2.4 $e |- B = ( Base ` R ) $.
      $( The powers of a group element give a homomorphism from ` ZZ ` to a
         group.  (Contributed by Mario Carneiro, 13-Jun-2015.) $)
      mulgghm2 $p |- ( ( R e. Grp /\ .1. e. B ) -> F e. ( Z GrpHom R ) ) $=
        ( vx vy wcel wa cz caddc co cfv wceq cgrp wf cv cplusg wral cghm ccnfld
        simpl csubrg zsubrg subrgrng rnggrp mp2b jctil mulgcl 3expa an32s fmptd
        crg eqid mulgdir 3exp2 imp42 zaddcl adantl oveq1 ovex fvmpt syl 3eqtr4d
        oveqan12d ralrimivva jca cbs subrgbas ax-mp cnfldadd ressplusg sylanbrc
        isghm ) BUANZDANZOZGUANZWAOPAFUBZLUCZMUCZQRZFSZWFFSZWGFSZBUDSZRZTZMPUEL
        PUEZOFGBUFRNWCWAWDWAWBUHPUGUISZNZGUSNWDUJPUGGHUKGULUMUNWCWEWOWCEPEUCZDC
        RZAFWAWRPNZWBWSANZWAWTWBXAACBWRDKIUOUPUQJURWCWNLMPPWCWFPNZWGPNZOZOZWHDC
        RZWFDCRZWGDCRZWLRZWIWMWAXDWBXFXITZWAXBXCWBXJWAXBXCWBXJAWLCBWFWGDKIWLUTZ
        VAVBVCUQXEWHPNZWIXFTXDXLWCWFWGVDVEEWHWSXFPFWRWHDCVFJWHDCVGVHVIXDWMXITWC
        XBXCWJXGWKXHWLEWFWSXGPFWRWFDCVFJWFDCVGVHEWGWSXHPFWRWGDCVFJWGDCVGVHVKVEV
        JVLVMMLQWLGBFPAWQPGVNSTUJPUGGHVOVPKWQQGUDSTUJPQUGGWPHVQVRVPXKVTVS $.
    $}

    mulgrhm.4 $e |- .1. = ( 1r ` R ) $.
    $( The powers of the element ` 1 ` give a ring homomorphism from ` ZZ ` to
       a ring.  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    mulgrhm $p |- ( R e. Ring -> F e. ( Z RingHom R ) ) $=
      ( wcel cz cmul cfv c1 ccnfld wceq zsubrg ax-mp co vx crg cmulr csubrg cbs
      vy subrgbas cur cnfld1 subrg1 cnfldmul ressmulr eqid subrgrng id 1z oveq1
      mp1i ovex fvmpt rngidcl mulg1 syl syl5eq cgrp rnggrp adantr simprr mulgcl
      cv syl3anc rnglidm syldan oveq2d simpl mulgass2 syl13anc mulgass 3eqtr4rd
      wa simprl zmulcl adantl oveqan12d 3eqtr4d cghm mulgghm2 syl2anc isrhm2d )
      AUBKZUAUFLFAMAUCNZOECLPUDNZKZLFUENQRLPFGUGSWMOFUHNQRLPFOGUIUJSJWMMFUCNQRL
      PFMWLGUKULSWKUMZWMFUBKWJRLPFGUNURWJUOWJOENZOCBTZCOLKWOWPQUPDODVJZCBTZWPLE
      WQOCBUQIOCBUSUTSWJCAUENZKZWPCQWSACWSUMZJVAZWSBACXAHVBVCVDWJUAVJZLKZUFVJZL
      KZVTZVTZXCXEMTZCBTZXCCBTZXECBTZWKTZXIENZXCENZXEENZWKTZXHXCCXLWKTZBTZXCXLB
      TZXMXJXHXRXLXCBWJXGXLWSKZXRXLQXHAVEKZXFWTYAWJYBXGAVFZVGZWJXDXFVHZWJWTXGXB
      VGZWSBAXECXAHVIVKZWSAWKCXLXAWNJVLVMVNXHWJXDWTYAXMXSQWJXGVOWJXDXFWAZYFYGWS
      ABWKXCCXLXAHWNVPVQXHYBXDXFWTXJXTQYDYHYEYFWSBAXCXECXAHVRVQVSXHXILKZXNXJQXG
      YIWJXCXEWBWCDXIWRXJLEWQXICBUQIXICBUSUTVCXGXQXMQWJXDXFXOXKXPXLWKDXCWRXKLEW
      QXCCBUQIXCCBUSUTDXEWRXLLEWQXECBUQIXECBUSUTWDWCWEWJYBWTEFAWFTKYCXBWSABCDEF
      GHIXAWGWHWI $.

    $( The powers of the element ` 1 ` give the unique ring homomorphism from
       ` ZZ ` to a ring.  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    mulgrhm2 $p |- ( R e. Ring -> ( Z RingHom R ) = { F } ) $=
      ( vf wcel co wceq cz cfv ccnfld zsubrg eqid c1 crg crh csn cv wa cmpt cbs
      wf csubrg subrgbas ax-mp rhmf adantl feqmptd cmg rhmghm ad2antlr simpr 1z
      cghm a1i ghmmulg syl3anc cmul ax-1cn cnfldmulg mpan2 csubg subrgsubg mp1i
      cc subgmulg zcn mulid1d 3eqtr3d fveq2d cur cnfld1 subrg1 oveq2d mpteq2dva
      id rhm1 eqtrd syl6eqr elsn sylibr ex ssrdv mulgrhm snssd eqssd ) AUALZFAU
      BMZEUCZWMKWNWOWMKUDZWNLZWPWOLZWMWQUEZWPENWRWSWPDODUDZCBMZUFZEWSWPDOWTWPPZ
      UFXBWSDOAUGPZWPWQOXDWPUHWMOXDFAWPOQUIPLZOFUGPNROQFGUJUKZXDSULUMUNWSDOXCXA
      WSWTOLZUEZWTTFUOPZMZWPPZWTTWPPZBMZXCXAXHWPFAUTMLZXGTOLZXKXMNWQXNWMXGFAWPU
      PUQWSXGURXOXHUSVAOXIBWPFAWTTXFXISZHVBVCXHXJWTWPXGXJWTNWSXGWTTQUOPZMZWTTVD
      MZXJWTXGTVKLXRXSNVEWTTVFVGXGOQVHPLZXGXOXRXJNXEXTXGROQVIVJXGWBXOXGUSVAOXIX
      QQFWTTXQSGXPVLVCXGWTWTVMVNVOUMVPXHXLCWTBWQXLCNWMXGFATWPCXETFVQPNROQFTGVRV
      SUKJWCUQVTVOWAWDIWEKEWFWGWHWIWMEWNABCDEFGHIJWJWKWL $.

  $}

  ${
    $d r s $.  $d n N $.  $d n .1. $.  $d n r R $.  $d n .x. $.  $d n r Z $.
    zrhval.1 $e |- Z = ( CCfld |`s ZZ ) $.
    zrhval.2 $e |- L = ( ZRHom ` R ) $.
    $( Define the unique homomorphism from the integers to a ring or field.
       (Contributed by Mario Carneiro, 13-Jun-2015.) $)
    zrhval $p |- L = U. ( Z RingHom R ) $=
      ( vr vs czrh cfv crh co cuni cvv wcel wceq cv unieqd c0 crg cmgp cz cress
      ccnfld oveq1i oveq2 syl5eqr df-zrh ovex uniex fvmpt fvprc cghm cin dfrhm2
      wn cmhm reldmmpt2 ovprc2 uni0 syl6eq eqtr4d pm2.61i eqtri ) BAHIZCAJKZLZE
      AMNZVDVFOFAUCUAUBKZFPZJKZLVFMHVIAOZVJVEVKVJCVIJKVECVHVIJDUDVIACJUEUFQFUGV
      ECAJUHUIUJVGUOZVDRVFAHUKVLVFRLRVLVERCAJFGSSVIGPZULKVITIVMTIUPKUMJGFUNUQUR
      QUSUTVAVBVC $.

    ${
      zrhval2.3 $e |- .x. = ( .g ` R ) $.
      zrhval2.4 $e |- .1. = ( 1r ` R ) $.
      $( Alternate value of the ` ZRHom ` homomorphism.  (Contributed by Mario
         Carneiro, 12-Jun-2015.) $)
      zrhval2 $p |- ( R e. Ring -> L = ( n e. ZZ |-> ( n .x. .1. ) ) ) $=
        ( crg wcel crh co cuni cz cv cmpt zrhval csn eqid mulgrhm2 unieqd mptex
        zex unisn syl6eq syl5eq ) AKLZEFAMNZOZDPDQCBNZRZAEFGHSUIUKUMTZOUMUIUJUN
        ABCDUMFGIUMUAJUBUCUMDPULUEUDUFUGUH $.

      $( Value of the ` ZRHom ` homomorphism.  (Contributed by Mario Carneiro,
         14-Jun-2015.) $)
      zrhmulg $p |- ( ( R e. Ring /\ N e. ZZ ) ->
        ( L ` N ) = ( N .x. .1. ) ) $=
        ( vn crg wcel cz cfv cv co cmpt zrhval2 fveq1d oveq1 eqid ovex sylan9eq
        fvmpt ) ALMZENMEDOEKNKPZCBQZRZOECBQZUFEDUIABCKDFGHIJSTKEUHUJNUIUGECBUAU
        IUBECBUCUEUD $.
    $}

    $( The ` ZRHom ` homomorphism is the unique ring homomorphism from ` Z ` .
       (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    zrhrhmb $p |- ( R e. Ring -> ( F e. ( Z RingHom R ) <-> F = L ) ) $=
      ( vn crg wcel crh co csn wceq cz cv cur cfv cmg eqid czrh mulgrhm2 eqtr4d
      cmpt zrhval2 sneqd eleq2d cvv fvex eqeltri elsnc2 syl6bb ) AHIZBDAJKZIBCL
      ZIBCMULUMUNBULUMGNGOAPQZARQZKUCZLUNAUPUOGUQDEUPSZUQSUOSZUAULCUQAUPUOGCDEF
      URUSUDUEUBUFBCCATQUGFATUHUIUJUK $.

    $( The ` ZRHom ` homomorphism is a homomorphism.  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    zrhrhm $p |- ( R e. Ring -> L e. ( Z RingHom R ) ) $=
      ( crg wcel crh co wceq eqid zrhrhmb mpbiri ) AFGBCAHIGBBJBKABBCDELM $.
  $}

  ${
    zrh1.l $e |- L = ( ZRHom ` R ) $.
    zrh1.o $e |- .1. = ( 1r ` R ) $.
    $( Interpretation of 1 in a ring.  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    zrh1 $p |- ( R e. Ring -> ( L ` 1 ) = .1. ) $=
      ( crg wcel ccnfld cz cress co crh cfv wceq eqid zrhrhm csubrg cur zsubrg
      c1 cnfld1 subrg1 ax-mp rhm1 syl ) AFGCHIJKZALKGTCMBNACUFUFOZDPUFATCBIHQMG
      TUFRMNSIHUFTUGUAUBUCEUDUE $.
  $}

  ${
    zrh0.l $e |- L = ( ZRHom ` R ) $.
    zrh0.z $e |- .0. = ( 0g ` R ) $.
    $( Interpretation of 0 in a ring.  (Contributed by Stefan O'Rear,
       6-Sep-2015.) $)
    zrh0 $p |- ( R e. Ring -> ( L ` 0 ) = .0. ) $=
      ( crg wcel ccnfld cz cress co crh cghm cc0 wceq eqid zrhrhm rhmghm csubrg
      cfv c0g zsubrg cnfld0 subrg0 ax-mp ghmid 3syl ) AFGBHIJKZALKGBUHAMKGNBTCO
      ABUHUHPZDQUHABRUHABNCIHSTGNUHUATOUBIHUHNUIUCUDUEEUFUG $.
  $}

  ${
    $d s u v w x y B $.  $d s u v w x y K $.  $d s u v w x y ph $.
    $d s u v w x y L $.
    zrhpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    zrhpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    zrhpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    zrhpropd.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( .r ` K ) y ) = ( x ( .r ` L ) y ) ) $.
    $( The ` ZZ ` ring homomorphism depends only on the ring attributes of a
       structure.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    zrhpropd $p |- ( ph -> ( ZRHom ` K ) = ( ZRHom ` L ) ) $=
      ( co crh cuni czrh cfv eqidd cv wcel wa eqid ccnfld cz cress cplusg cmulr
      cbs rhmpropd unieqd zrhval 3eqtr4g ) AUAUBUCKZELKZMUKFLKZMENOZFNOZAULUMAB
      CUKUFOZDUKEUKFAUPPZGUQHABQZUPRCQZUPRSSZURUSUKUDOKPIUTURUSUKUEOKPJUGUHEUNU
      KUKTZUNTUIFUOUKVAUOTUIUJ $.
  $}

  ${
    $d g G $.  $d g .x. $.  $d g Z $.
    zlmval.w $e |- W = ( ZMod ` G ) $.
    zlmval.z $e |- Z = ( CCfld |`s ZZ ) $.
    zlmval.m $e |- .x. = ( .g ` G ) $.
    $( Augment an abelian group with vector space operations to turn it into a
       ` ZZ ` -module.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    zlmval $p |- ( G e. V -> W = ( ( G sSet <. ( Scalar ` ndx ) , Z >. )
                                       sSet <. ( .s ` ndx ) , .x. >. ) ) $=
      ( vg wcel czlm cfv cnx csca cop csts co cvv wceq cmg cvsca elex cv ccnfld
      cress opeq2i oveq2i oveq1 syl5eqr fveq2 syl6eqr opeq2d oveq12d ovex fvmpt
      cz df-zlm syl syl5eq ) BCJZDBKLZBMNLZEOZPQZMUALZAOZPQZFUTBRJVAVGSBCUBIBIU
      CZVBUDUPUEQZOZPQZVEVHTLZOZPQVGRKVHBSZVKVDVMVFPVNVKVHVCPQVDVCVJVHPEVIVBGUF
      UGVHBVCPUHUIVNVLAVEVNVLBTLAVHBTUJHUKULUMIUQVDVFPUNUOURUS $.
  $}

  ${
    zlmbas.w $e |- W = ( ZMod ` G ) $.
    ${
      zlmlem.2 $e |- E = Slot N $.
      zlmlem.3 $e |- N e. NN $.
      zlmlem.4 $e |- N < 5 $.
      $( Lemma for ~ zlmbas and ~ zlmplusg .  (Contributed by Mario Carneiro,
         2-Oct-2015.) $)
      zlmlem $p |- ( E ` G ) = ( E ` W ) $=
        ( cvv cfv cnx co cop csts eqid c5 clt c6 wbr c0 wcel wceq csca cz cress
        ccnfld cvsca zlmval fveq2d ndxid cr ndxarg nnrei eqeltri eqbrtri ltneii
        cmg scandx neeqtrri setsnid 5lt6 5re lttri mp2an vscandx eqtri syl6reqr
        6re wn str0 fvprc czlm syl5eq 3eqtr4a pm2.61i ) BIUAZBAJZDAJZUBVPVRBKUC
        JZUFUDUELZMNLZKUGJZBUQJZMNLZAJZVQVPDWDAWCBIDVTEVTOWCOUHUIVQWAAJWEVTVSAB
        ACFGUJZKAJZPVSWGPWGCUKACFGULZCGUMUNZWGCPQWHHUOZUPURUSUTWCWBAWAWFWGRWBWG
        RWIWGPQSPRQSWGRQSWJVAWGPRWIVBVHVCVDUPVEUSUTVFVGVPVIZTTAJVQVRACFVJBAVKWK
        DTAWKDBVLJTEBVLVKVMUIVNVO $.
    $}

    ${
      zlmbas.2 $e |- B = ( Base ` G ) $.
      $( Base set of a ` ZZ ` -module.  (Contributed by Mario Carneiro,
         2-Oct-2015.) $)
      zlmbas $p |- B = ( Base ` W ) $=
        ( cbs cfv c1 df-base 1nn 1lt5 zlmlem eqtri ) ABFGCFGEFBHCDIJKLM $.
    $}

    ${
      zlmplusg.2 $e |- .+ = ( +g ` G ) $.
      $( Group operation of a ` ZZ ` -module.  (Contributed by Mario Carneiro,
         2-Oct-2015.) $)
      zlmplusg $p |- .+ = ( +g ` W ) $=
        ( cplusg cfv c2 df-plusg 2nn 2lt5 zlmlem eqtri ) ABFGCFGEFBHCDIJKLM $.
    $}

    ${
      zlmmulr.2 $e |- .x. = ( .r ` G ) $.
      $( Ring operation of a ` ZZ ` -module (if present).  (Contributed by
         Mario Carneiro, 2-Oct-2015.) $)
      zlmmulr $p |- .x. = ( .r ` W ) $=
        ( cmulr cfv c3 df-mulr 3nn 3lt5 zlmlem eqtri ) ABFGCFGEFBHCDIJKLM $.
    $}

    ${
      zlmsca.2 $e |- Z = ( CCfld |`s ZZ ) $.
      $( Scalar ring of a ` ZZ ` -module.  (Contributed by Mario Carneiro,
         2-Oct-2015.) $)
      zlmsca $p |- ( G e. V -> Z = ( Scalar ` W ) ) $=
        ( wcel cnx csca cfv cop csts co scaid wne c5 c6 cvv ccnfld cz cvsca cmg
        5re 5lt6 ltneii scandx vscandx neeq12i mpbir setsnid wceq cress eqeltri
        ovex setsid mpan2 eqid zlmval fveq2d 3eqtr4a ) ABGZAHIJZDKLMZIJZVCHUAJZ
        AUBJZKLMZIJDCIJVFVEIVCNVBVEOPQOPQUCUDUEVBPVEQUFUGUHUIUJVADRGDVDUKDSTULM
        RFSTULUNUMBDIRANUOUPVACVGIVFABCDEFVFUQURUSUT $.
    $}

    ${
      zlmvsca.2 $e |- .x. = ( .g ` G ) $.
      $( Scalar multiplication operation of a ` ZZ ` -module.  (Contributed by
         Mario Carneiro, 2-Oct-2015.) $)
      zlmvsca $p |- .x. = ( .s ` W ) $=
        ( cvv wcel cvsca cfv wceq cnx co cop csts fveq2d vscaid c0 fvprc syl5eq
        cmg csca ccnfld cz cress eqid zlmval ovex eqeltri setsid mp2an syl6reqr
        fvex wn str0 czlm 3eqtr4a pm2.61i ) BFGZACHIZJURUSBKUAIUBUCUDLZMZNLZKHI
        ZAMNLZHIZAURCVDHABFCUTDUTUEEUFOVBFGAFGAVEJBVANUGABTIZFEBTULUHFAHFVBPUIU
        JUKURUMZQQHIAUSHVCPUNVGAVFQEBTRSVGCQHVGCBUOIQDBUORSOUPUQ $.
    $}
  $}

  ${
    $d x y z G $.  $d x y z W $.
    zlmlmod.w $e |- W = ( ZMod ` G ) $.
    $( The ` ZZ ` -module operation turns an arbitrary abelian group into a
       left module over ` ZZ ` .  (Contributed by Mario Carneiro,
       2-Oct-2015.) $)
    zlmlmod $p |- ( G e. Abel <-> W e. LMod ) $=
      ( cabel wcel cz cplusg cfv caddc cmul c1 ccnfld co cbs wceq eqid a1i mp1i
      zsubrg cv vx vy vz clmod cmg cress zlmbas zlmplusg cvsca zlmvsca subrgbas
      zlmsca csubrg cnfldadd ressplusg cnfldmul ressmulr cnfld1 subrg1 subrgrng
      cmulr cur crg cgrp ablprop ablgrp sylbi mulgcl syl3an1 mulgdi w3a mulgdir
      sylan mulgass mulg1 adantl islmodd lmodabl sylibr impbii ) ADEZBUDEZWAUAU
      BUCFAGHZIAUEHZJKLFUFMZANHZBWFBNHOWAWFABCWFPZUGZQWCBGHOWAWCABCWCPZUHZQADBW
      ECWEPZULWDBUIHOWAWDABCWDPZUJQFLUMHZEZFWENHOWASFLWEWKUKRWNIWEGHOWASFILWEWM
      WKUNUORWNJWEVAHOWASFLWEJWMWKUPUQRWNKWEVBHOWASFLWEKWKURUSRWNWEVCEWASFLWEWK
      UTRWABDEZBVDEABWHWJVEZBVFVGWAAVDEZUATZFEZUBTZWFEWRWTWDMWFEAVFZWFWDAWRWTWG
      WLVHVIWFWCWDAWRWTUCTZWGWLWIVJWAWQWSWTFEXBWFEVKZWRWTIMXBWDMWRXBWDMWTXBWDMZ
      WCMOXAWFWCWDAWRWTXBWGWLWIVLVMWAWQXCWRWTJMXBWDMWRXDWDMOXAWFWDAWRWTXBWGWLVN
      VMWRWFEKWRWDMWROWAWFWDAWRWGWLVOVPVQWBWOWABVRWPVSVT $.

    $( The ` ZZ ` -module operation turns a ring into an associative algebra
       over ` ZZ ` .  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    zlmassa $p |- ( G e. Ring <-> W e. AssAlg ) $=
      ( vy vz vx crg wcel cz cfv cmulr ccnfld cbs wceq eqid zsubrg mp1i ccrg cv
      a1i casa cmg cress co zlmbas zlmsca csubrg subrgbas cvsca zlmvsca zlmmulr
      cabel clmod rngabl zlmlmod sylib cplusg zlmplusg rngprop biimpi subrgcrng
      cncrng mpan mulgass2 mulgass3 isassad assarng sylibr impbii ) AGHZBUAHZVJ
      DEIAUBJZAKJZLIUCUDZAMJZBFVOBMJNVJVOABCVOOZUEZTAGBVNCVNOZUFILUGJHZIVNMJNVJ
      PILVNVRUHQVLBUIJNVJVLABCVLOZUJTVMBKJNVJVMABCVMOZUKZTVJAULHBUMHAUNABCUOUPV
      JBGHZABVQAUQJZABCWDOURWBUSZUTVSVNRHZVJPLRHVSWFVBILVNVRVAVCQVOAVLVMFSZDSZE
      SZVPVTWAVDVOAVLVMWGWHWIVPVTWAVEVFVKWCVJBVGWEVHVI $.
  $}

  ${
    $d r O $.  $d r R $.  $d r .1. $.
    chrval.o $e |- O = ( od ` R ) $.
    chrval.u $e |- .1. = ( 1r ` R ) $.
    chrval.c $e |- C = ( chr ` R ) $.
    $( Definition substitution of the ring characteristic.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    chrval $p |- ( O ` .1. ) = C $=
      ( vr cchr cfv cvv wcel wceq cv cur cod fveq2 syl6eqr c0 fvprc df-chr fvex
      fveq12d fvmpt wn syl5eq fveq1d 0fv syl6eq eqtr4d pm2.61i eqtr2i ) ABIJZCD
      JZGBKLZUMUNMHBHNZOJZUPPJZJUNKIUPBMZUQCURDUSURBPJZDUPBPQERUSUQBOJCUPBOQFRU
      CHUACDUBUDUOUEZUMSUNBITVAUNCSJSVACDSVADUTSEBPTUFUGCUHUIUJUKUL $.
  $}

  ${
    chrcl.c $e |- C = ( chr ` R ) $.
    $( Closure of the characteristic.  (Contributed by Mario Carneiro,
       23-Sep-2015.) $)
    chrcl $p |- ( R e. Ring -> C e. NN0 ) $=
      ( crg wcel cur cfv cod cn0 eqid chrval cbs rngidcl odcl syl syl5eqelr ) B
      DEZABFGZBHGZGZIABRSSJZRJZCKQRBLGZETIEUCBRUCJZUBMRBSUCUDUANOP $.

    chrid.l $e |- L = ( ZRHom ` R ) $.
    chrid.z $e |- .0. = ( 0g ` R ) $.
    $( The canonical ` ZZ ` ring homomorphism applied to a ring's
       characteristic is zero.  (Contributed by Mario Carneiro,
       23-Sep-2015.) $)
    chrid $p |- ( R e. Ring -> ( L ` C ) = .0. ) $=
      ( crg wcel cfv cur cmg co cz wceq chrcl nn0zd ccnfld cress eqid mpdan cod
      zrhmulg chrval oveq1i cbs rngidcl odid syl syl5eqr eqtrd ) BHIZACJZABKJZB
      LJZMZDULANIUMUPOULAABEPQBUOUNCARNSMZUQTFUOTZUNTZUCUAULUPUNBUBJZJZUNUOMZDV
      AAUNUOABUNUTUTTZUSEUDUEULUNBUFJZIVBDOVDBUNVDTZUSUGUNUOBUTVDDVEVCURGUHUIUJ
      UK $.

    $( The ` ZZ ` ring homomorphism is zero only at multiples of the
       characteristic.  (Contributed by Mario Carneiro, 23-Sep-2015.) $)
    chrdvds $p |- ( ( R e. Ring /\ N e. ZZ ) ->
      ( C || N <-> ( L ` N ) = .0. ) ) $=
      ( crg wcel cz wa cdivides wbr cur cfv co wceq eqid adantr cmg chrval cgrp
      cod breq1i cbs rnggrp rngidcl simpr oddvds syl3anc syl5bbr ccnfld zrhmulg
      wb cress eqeq1d bitr4d ) BIJZDKJZLZADMNZDBOPZBUAPZQZERZDCPZERVBVCBUDPZPZD
      MNZVAVFVIADMABVCVHVHSZVCSZFUBUEVABUCJZVCBUFPZJZUTVJVFUOUSVMUTBUGTUSVOUTVN
      BVCVNSZVLUHTUSUTUIVCVDBDVHVNEVPVKVDSZHUJUKULVAVGVEEBVDVCCDUMKUPQZVRSGVQVL
      UNUQUR $.

    $( If two integers are congruent relative to the ring characteristic, their
       images in the ring are the same.  (Contributed by Mario Carneiro,
       24-Sep-2015.) $)
    chrcong $p |- ( ( R e. Ring /\ M e. ZZ /\ N e. ZZ ) ->
      ( C || ( M - N ) <-> ( L ` M ) = ( L ` N ) ) ) $=
      ( crg wcel cz co cdivides wbr cfv wceq eqid 3ad2ant1 zrhmulg w3a cmin cur
      cmg cod chrval breq1i cgrp wb rnggrp rngidcl simp2 simp3 odcong syl112anc
      cbs syl5bbr ccnfld cress 3adant3 3adant2 eqeq12d bitr4d ) BJKZDLKZELKZUAZ
      ADEUBMZNOZDBUCPZBUDPZMZEVJVKMZQZDCPZECPZQVIVJBUEPZPZVHNOZVGVNVRAVHNABVJVQ
      VQRZVJRZGUFUGVGBUHKZVJBUPPZKZVEVFVSVNUIVDVEWBVFBUJSVDVEWDVFWCBVJWCRZWAUKS
      VDVEVFULVDVEVFUMVJVKBDEVQWCFWEVTVKRZIUNUOUQVGVOVLVPVMVDVEVOVLQVFBVKVJCDUR
      LUSMZWGRZHWFWATUTVDVFVPVMQVEBVKVJCEWGWHHWFWATVAVBVC $.
  $}

  $( Nonzero rings are precisely those with characteristic not 1.  (Contributed
     by Stefan O'Rear, 6-Sep-2015.) $)
  chrnzr $p |- ( R e. Ring -> ( R e. NzRing <-> ( chr ` R ) =/= 1 ) ) $=
    ( crg wcel cnzr cur cfv c0g wne cchr eqid isnzr baib cdivides wbr czrh wceq
    c1 cz wb 1z chrdvds mpan2 cn0 chrcl dvds1 syl zrh1 eqeq1d 3bitr3d necon3bid
    bitr4d ) ABCZADCZAEFZAGFZHZAIFZQHUMULUPAUNUOUNJZUOJZKLULUQQUNUOULUQQMNZQAOF
    ZFZUOPZUQQPZUNUOPULQRCUTVCSTUQAVAQUOUQJZVAJZUSUAUBULUQUCCUTVDSUQAVEUDUQUEUF
    ULVBUNUOAUNVAVFURUGUHUIUJUK $.

  $( The characteristic restriction on ring homomorphisms.  (Contributed by
     Stefan O'Rear, 6-Sep-2015.) $)
  chrrhm $p |- ( F e. ( R RingHom S ) -> ( chr ` S ) || ( chr ` R ) ) $=
    ( crh co wcel cchr cfv czrh c0g wceq cz ccnfld cbs crg eqid cc 3syl syl2anc
    syl cdivides wbr ccom cress wf rhmrcl1 zrhrhm zsscn cnfldbas ressbas2 ax-mp
    wfn wss rhmf ffn chrcl nn0z fvco2 chrid fveq2d eqtrd rhmco mpdan wb rhmrcl2
    cn0 zrhrhmb mpbid fveq1d cghm rhmghm ghmid 3eqtr3d chrdvds mpbird ) CABDEFZ
    BGHZAGHZUAUBZVRBIHZHZBJHZKZVPVRCAIHZUCZHZAJHZCHZWAWBVPWFVRWDHZCHZWHVPWDLULZ
    VRLFZWFWJKVPWDMLUDEZADEFZLANHZWDUEWKVPAOFZWNABCUFZAWDWMWMPZWDPZUGTZLWOWMAWD
    LQUMLWMNHKUHLQWMMWRUIUJUKWOPUNLWOWDUORVPWPVRVFFWLWQVRAVRPZUPVRUQRZLCWDVRURS
    VPWIWGCVPWPWIWGKWQVRAWDWGXAWSWGPZUSTUTVAVPVRWEVTVPWEWMBDEFZWEVTKZVPWNXDWTWM
    ABCWDVBVCVPBOFZXDXEVDABCVEZBWEVTWMWRVTPZVGTVHVIVPCABVJEFWHWBKABCVKABCWGWBXC
    WBPZVLTVMVPXFWLVSWCVDXGXBVQBVTVRWBVQPXHXIVNSVO $.

  ${
    $d x y R $.
    $( The characteristic of a domain can only be zero or a prime.
       (Contributed by Stefan O'Rear, 6-Sep-2015.) $)
    domnchr $p |- ( R e. Domn -> ( ( chr ` R ) = 0 \/
        ( chr ` R ) e. Prime ) ) $=
      ( vx vy wcel cfv cc0 wceq wa cmul co cdivides wbr cz cn0 eqid sylanbrc wb
      syl ccnfld chrdvds cdomn cchr cprime wn wne df-ne c2 cuz cv wo wi wral cn
      c1 csn cdif crg domnrng chrcl adantr simpr eldifsn dfn2 syl6eleqr domnnzr
      cnzr nzrrng chrnzr ibi eluz2b3 c0g cmulr cress crh ad2antrr zrhrhm simprl
      simprr cc wss cbs zsscn cnfldbas ressbas2 ax-mp cvv zex cnfldmul ressmulr
      czrh rhmmul syl3anc eqeq1d simpll wf ffvelrnd domneq0 bitrd biimpd zmulcl
      rhmf adantl syl2anc orbi12d 3imtr4d ralrimivva isprm6 ex syl5bir orrd ) A
      UADZAUBEZFGZXLUCDZXMUDXLFUEZXKXNXLFUFXKXOXNXKXOHZXLUGUHEDZXLBUIZCUIZIJZKL
      ZXLXRKLZXLXSKLZUJZUKZCMULBMULXNXPXLUMDXLUNUEZXQXPXLNFUOUPZUMXPXLNDZXOXLYG
      DXKYHXOXKAUQDZYHAURZXLAXLOZUSRUTXKXOVAXLNFVBPVCVDXKYFXOXKAVFDZYFAVEYLYFYL
      YIYLYFQAVGAVHRVIRUTXLVJPXPYEBCMMXPXRMDZXSMDZHZHZXTAWJEZEZAVKEZGZXRYQEZYSG
      ZXSYQEZYSGZUJZYAYDYPYTUUEYPYTUUAUUCAVLEZJZYSGZUUEYPYRUUGYSYPYQSMVMJZAVNJD
      ZYMYNYRUUGGYPYIUUJXKYIXOYOYJVOZAYQUUIUUIOZYQOZVPRZXPYMYNVQZXPYMYNVRZXRXSU
      UIAIUUFYQMMVSVTMUUIWAEGWBMVSUUISUULWCWDWEZMWFDIUUIVLEGWGMSUUIIWFUULWHWIWE
      UUFOZWKWLWMYPXKUUAAWAEZDUUCUUSDUUHUUEQXKXOYOWNYPMUUSXRYQYPUUJMUUSYQWOUUNM
      UUSUUIAYQUUQUUSOZXARZUUOWPYPMUUSXSYQUVAUUPWPUUSAUUFUUAUUCYSUUTUURYSOZWQWL
      WRWSYPYIXTMDZYAYTQUUKYOUVCXPXRXSWTXBXLAYQXTYSYKUUMUVBTXCYPYBUUBYCUUDYPYIY
      MYBUUBQUUKUUOXLAYQXRYSYKUUMUVBTXCYPYIYNYCUUDQUUKUUPXLAYQXSYSYKUUMUVBTXCXD
      XEXFBCXLXGPXHXIXJ $.
  $}

  ${
    $d x F $.  $d f n s z .<_ $.  $d f n s z N $.  $d n s x z U $.
    znval.z $e |- Z = ( CCfld |`s ZZ ) $.
    znval.s $e |- S = ( RSpan ` Z ) $.
    $( The set ` n ZZ ` is an ideal in ` ZZ ` .  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    znlidl $p |- ( N e. ZZ -> ( S ` { N } ) e. ( LIdeal ` Z ) ) $=
      ( cz wcel crg csn wss cfv clidl ccnfld csubrg zsubrg subrgrng ax-mp snssi
      cbs wceq subrgbas eqid rspcl sylancr ) BFGCHGZBIZFJUFAKCLKZGFMNKGZUEOFMCD
      PQBFRFCUGUFAEUHFCSKTOFMCDUAQUGUBUCUD $.

    znval.u $e |- U = ( Z /s ( Z ~QG ( S ` { N } ) ) ) $.
    $( The value of the ` Z/nZ ` structure.  It is defined as the quotient ring
       ` ZZ / n ZZ ` , with an "artificial" ordering added to make it a
       ` Toset ` .  (In other words, ` Z/nZ ` is a _ring_ with an _order_ , but
       it is not an _ordered ring_ , which as a term implies that the order is
       compatible with the ring operations in some way.)  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    zncrng2 $p |- ( N e. ZZ -> U e. CRing ) $=
      ( cz wcel ccrg csn cfv clidl ccnfld csubrg cncrng zsubrg subrgcrng znlidl
      mp2an eqid divscrng sylancr ) CHIDJIZCKALZDMLZIBJINJIHNOLIUDPQHNDERTACDEF
      SDUEBUFGUFUAUBUC $.

    znval.y $e |- Y = ( Z/nZ ` N ) $.
    znval.f $e |- F = ( ( ZRHom ` U ) |` W ) $.
    znval.w $e |- W = if ( N = 0 , ZZ , ( 0 ..^ N ) ) $.
    ${
      znval.l $e |- .<_ = ( ( F o. <_ ) o. `' F ) $.
      $( The value of the ` Z/nZ ` structure.  It is defined as the quotient
         ring ` ZZ / n ZZ ` , with an "artificial" ordering added to make it a
         ` Toset ` .  (In other words, ` Z/nZ ` is a _ring_ with an _order_ ,
         but it is not an _ordered ring_ , which as a term implies that the
         order is compatible with the ring operations in some way.)
         (Contributed by Mario Carneiro, 14-Jun-2015.)  (Revised by Mario
         Carneiro, 2-May-2016.) $)
      znval $p |- ( N e. NN0 -> Y = ( U sSet <. ( le ` ndx ) , .<_ >. ) ) $=
        ( cfv co cc0 wceq cvv vn vz vs vf cn0 wcel czn cnx cple cop csts ccnfld
        cz cress cv csn crsp cqg cqus czrh cfzo cif cres cle ccom ccnv csb ovex
        a1i wa simpr syl6eqr fveq2d simpl sneqd fveq12d oveq12d sylan9eqr resex
        fvex simpll eqeq1d oveq2d ifbieq2d reseq12d coeq1d cnveqd csbied opeq2d
        id coeq12d df-zn fvmpt syl5eq ) EUEUFGEUGPBUHUIPZDUJZUKQZLUAEUBULUMUNQZ
        UCUBUOZWSUAUOZUPZWSUQPZPZURQZUSQZUCUOZWOUDXFUTPZWTRSZUMRWTVAQZVBZVCZUDU
        OZVDVEZXLVFZVEZVGZUJZUKQZVGZVGWQUEUGWTESZUBWRXSWQTWRTUFXTULUMUNVHVIXTWS
        WRSZVJZUCXEXRWQTXETUFYBWSXDUSVHVIYBXFXESZVJZXFBXQWPUKYCYBXFXEBYCWJYBXEH
        HEUPZAPZURQZUSQBYBWSHXDYGUSYBWSWRHXTYAVKIVLZYBWSHXCYFURYHYBXAYEXBAYBXBH
        UQPAYBWSHUQYHVMJVLYBWTEXTYAVNVOVPVQVQKVLVRZYDXPDWOYDUDXKXODTXKTUFYDXGXJ
        XFUTVTVSVIYDXLXKSZVJZXOCVDVEZCVFZVEDYKXMYLXNYMYKXLCVDYJYDXLXKCYJWJYDXKB
        UTPZFVCCYDXGYNXJFYDXFBUTYIVMYDXJERSZUMREVAQZVBFYDXHYOXIYPUMYDWTERXTYAYC
        WAZWBYDWTERVAYQWCWDNVLWEMVLVRZWFYKXLCYRWGWKOVLWHWIVQWHWHUBUDUAUCWLBWPUK
        VHWMWN $.
    $}

    znle.l $e |- .<_ = ( le ` Y ) $.
    $( The value of the ` Z/nZ ` structure.  It is defined as the quotient ring
       ` ZZ / n ZZ ` , with an "artificial" ordering added to make it a
       ` Toset ` .  (In other words, ` Z/nZ ` is a _ring_ with an _order_ , but
       it is not an _ordered ring_ , which as a term implies that the order is
       compatible with the ring operations in some way.)  (Contributed by Mario
       Carneiro, 14-Jun-2015.) $)
    znle $p |- ( N e. NN0 -> .<_ = ( ( F o. <_ ) o. `' F ) ) $=
      ( wcel cple cfv cvv cxr cn0 cnx cle ccom ccnv cop csts co eqid znval wceq
      fveq2d csn cqg cqus ovex eqeltri czrh cres fvex resex cxp xrex xpex ssexi
      lerelxr coex cnvex pleid setsid mp2an 3eqtr4g ) EUAPZGQRBUBQRCUCUDZCUEZUD
      ZUFUGUHZQRZDVPVMGVQQABCVPEFGHIJKLMNVPUIUJULOBSPVPSPVPVRUKBHHEUMARUNUHZUOU
      HSKHVSUOUPUQVNVOCUCCBURRZFUSSMVTFBURUTVAUQZUCTTVBTTVCVCVDVFVEVGCWAVHVGSVP
      QSBVIVJVKVL $.
  $}

  ${
    $d x E $.  $d x K $.  $d x y N $.  $d x y U $.  $d x y Y $.
    znval2.z $e |- Z = ( CCfld |`s ZZ ) $.
    znval2.s $e |- S = ( RSpan ` Z ) $.
    znval2.u $e |- U = ( Z /s ( Z ~QG ( S ` { N } ) ) ) $.
    znval2.y $e |- Y = ( Z/nZ ` N ) $.
    ${
      znval2.l $e |- .<_ = ( le ` Y ) $.
      $( Self-referential expression for the ` Z/nZ ` structure.  (Contributed
         by Mario Carneiro, 14-Jun-2015.) $)
      znval2 $p |- ( N e. NN0 -> Y = ( U sSet <. ( le ` ndx ) , .<_ >. ) ) $=
        ( cn0 wcel cfv cc0 co ccom cop csts eqid cnx cple czrh wceq cz cfzo cif
        cres cle ccnv znval znle opeq2d oveq2d eqtr4d ) DLMZEBUAUBNZBUCNDOUDUEO
        DUFPUGZUHZUIQUSUJQZRZSPBUQCRZSPABUSUTDUREFGHIJUSTZURTZUTTUKUPVBVABSUPCU
        TUQABUSCDUREFGHIJVCVDKULUMUNUO $.
    $}

    ${
      znbaslem.1 $e |- E = Slot K $.
      znbaslem.2 $e |- K e. NN $.
      znbaslem.3 $e |- K < 10 $.
      $( Lemma for ~ znbas .  (Contributed by Mario Carneiro, 14-Jun-2015.)
         (Revised by Mario Carneiro, 14-Aug-2015.) $)
      znbaslem $p |- ( N e. NN0 -> ( E ` U ) = ( E ` Y ) ) $=
        ( cn0 cfv cnx cple wne c10 wcel cop csts eqid znval2 fveq2d ndxid nnrei
        co ltneii ndxarg plendx neeq12i mpbir setsnid syl6reqr ) EOUAZFCPBQRPZF
        RPZUBUCUIZCPBCPUQFUTCABUSEFGHIJKUSUDUEUFUSURCBCDLMUGQCPZURSDTSDTDMUHNUJ
        VADURTCDLMUKULUMUNUOUP $.
    $}

    $( The base set of ` Z/nZ ` is the same as the quotient ring it is based
       on.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znbas2 $p |- ( N e. NN0 -> ( Base ` U ) = ( Base ` Y ) ) $=
      ( cbs c1 df-base 1nn 1lt10 znbaslem ) ABJKCDEFGHILMNO $.

    $( The additive structure of ` Z/nZ ` is the same as the quotient ring it
       is based on.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znadd $p |- ( N e. NN0 -> ( +g ` U ) = ( +g ` Y ) ) $=
      ( cplusg c2 df-plusg 2nn 2lt10 znbaslem ) ABJKCDEFGHILMNO $.

    $( The multiplicative structure of ` Z/nZ ` is the same as the quotient
       ring it is based on.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znmul $p |- ( N e. NN0 -> ( .r ` U ) = ( .r ` Y ) ) $=
      ( cmulr c3 df-mulr 3nn 3lt10 znbaslem ) ABJKCDEFGHILMNO $.

    $( The ` ZZ ` ring homomorphism of ` Z/nZ ` is inherited from the quotient
       ring it is based on.  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
    znzrh $p |- ( N e. NN0 -> ( ZRHom ` U ) = ( ZRHom ` Y ) ) $=
      ( vx vy cn0 wcel cbs cfv eqidd cv cplusg proplem3 cmulr wa znadd zrhpropd
      znbas2 znmul ) CLMZJKBNOZBDUFUGPABCDEFGHIUDUFJQUGMKQUGMUAZJKBRODROABCDEFG
      HIUBSUFUHJKBTODTOABCDEFGHIUESUC $.
  $}

  ${
    znbas.z $e |- Z = ( CCfld |`s ZZ ) $.
    znbas.s $e |- S = ( RSpan ` Z ) $.
    znbas.y $e |- Y = ( Z/nZ ` N ) $.
    znbas.r $e |- R = ( Z ~QG ( S ` { N } ) ) $.
    $( The base set of ` Z/nZ ` structure.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    znbas $p |- ( N e. NN0 -> ( ZZ /. R ) = ( Base ` Y ) ) $=
      ( wcel cz cqus co cbs cfv cvv ccnfld cqg ovex eqeltri cn0 cqs csubrg wceq
      eqidd zsubrg subrgbas mp1i csn a1i cress divsbas oveq2i znbas2 eqtrd ) CU
      AJZKAUBEALMZNODNOUPAEUQKPPUPUQUEKQUCOJKENOUDUPUFKQEFUGUHAPJUPAECUIBOZRMZP
      IEURRSTUJEPJUPEQKUKMPFQKUKSTUJULBUQCDEFGAUSELIUMHUNUO $.
  $}

  ${
    $d x y N $.  $d x y Y $.
    zncrng.y $e |- Y = ( Z/nZ ` N ) $.
    $( ` Z/nZ ` is a commutative ring.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    zncrng $p |- ( N e. NN0 -> Y e. CRing ) $=
      ( vx vy cn0 wcel ccnfld cz cress co csn crsp ccrg eqid cv cplusg proplem3
      cfv cmulr cqg cqus nn0z zncrng2 syl eqidd znbas2 wa znadd znmul crngpropd
      cbs mpbid ) AFGZHIJKZUOALUOMSZSUAKUBKZNGZBNGUNAIGURAUCUPUQAUOUOOZUPOZUQOZ
      UDUEUNDEUQULSZUQBUNVBUFUPUQABUOUSUTVACUGUNDPVBGEPVBGUHZDEUQQSBQSUPUQABUOU
      SUTVACUIRUNVCDEUQTSBTSUPUQABUOUSUTVACUJRUKUM $.
  $}

  ${
    $d x A $.  $d x N $.  $d x .~ $.  $d x S $.  $d x Z $.
    znzrh2.z $e |- Z = ( CCfld |`s ZZ ) $.
    znzrh2.s $e |- S = ( RSpan ` Z ) $.
    znzrh2.r $e |- .~ = ( Z ~QG ( S ` { N } ) ) $.
    znzrh2.y $e |- Y = ( Z/nZ ` N ) $.
    znzrh2.2 $e |- L = ( ZRHom ` Y ) $.
    $( The ` ZZ ` ring homomorphism maps elements to their equivalence
       classes.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znzrh2 $p |- ( N e. NN0 -> L = ( x e. ZZ |-> [ x ] .~ ) ) $=
      ( wcel cfv cz co wceq ccnfld zsubrg ax-mp cn0 czrh cv cec cmpt cqus clidl
      crh crg csn csubrg subrgrng nn0z znlidl syl oveq2i c2idl cncrng subrgcrng
      cqg ccrg mp2an eqid crng2idl cbs subrgbas mpteq2i divsrhm sylancr zncrng2
      eceq2 wb crngrng zrhrhmb 4syl mpbid znzrh eqtr2d syl5eq ) EUAMZDFUBNZAOAU
      CZBUDZUEZLVTWDGBUFPZUBNZWAVTWDGWEUHPMZWDWFQZVTGUIMZEUJCNZGUGNZMZWGORUKNMZ
      WISORGHULTVTEOMZWLEUMZCEGHIUNUOAGWJWEWDWKOBGWJUTPZGUFJUPZGVAMZWKGUQNQRVAM
      WMWRURSORGHUSVBGWKWKVCVDTWMOGVENQSORGHVFTAOWCWBWPUDZBWPQWCWSQJBWPWBVKTVGV
      HVIVTWNWEVAMWEUIMWGWHVLWOCWEEGHIWQVJWEVMWEWDWFGHWFVCVNVOVPCWEEFGHIWQKVQVR
      VS $.

    $( The ` ZZ ` ring homomorphism maps elements to their equivalence
       classes.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znzrhval $p |- ( ( N e. NN0 /\ A e. ZZ ) -> ( L ` A ) = [ A ] .~ ) $=
      ( vx cn0 wcel cz cfv cec cvv cqg cv cmpt znzrh2 fveq1d eceq1 eqid co ovex
      csn eqeltri ecexg ax-mp fvmpt sylan9eq ) ENOZAPOADQAMPMUAZBRZUBZQABRZUOAD
      URMBCDEFGHIJKLUCUDMAUQUSPURUPABUEURUFBSOUSSOBGEUICQZTUGSJGUTTUHUJASBUKULU
      MUN $.
  $}

  ${
    $d x N $.
    znzrhfo.y $e |- Y = ( Z/nZ ` N ) $.
    znzrhfo.b $e |- B = ( Base ` Y ) $.
    znzrhfo.2 $e |- L = ( ZRHom ` Y ) $.
    $( The ` ZZ ` ring homomorphism is a surjection onto ` ZZ / n ZZ ` .
       (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znzrhfo $p |- ( N e. NN0 -> L : ZZ -onto-> B ) $=
      ( vx wcel cz wfo ccnfld cress co cfv cqg cvv cbs wceq eqid cn0 cv csn cec
      crsp cmpt cqs cqus eqidd csubrg zsubrg subrgbas mp1i a1i divslem wb znbas
      ovex syl6eqr foeq3 syl mpbid znzrh2 foeq1 mpbird ) CUAIZJABKZJAHJHUBLJMNZ
      CUCVHUEOZOZPNZUDUFZKZVFJJVKUGZVLKZVMVFHVKVHVHVKUHNZVLJQQVFVPUIJLUJOIJVHRO
      SVFUKJLVHVHTZULUMVLTVKQIVFVHVJPURUNVHQIVFLJMURUNUOVFVNASVOVMUPVFVNDROAVKV
      ICDVHVQVITZEVKTZUQFUSVNAJVLUTVAVBVFBVLSVGVMUPHVKVIBCDVHVQVRVSEGVCJABVLVDV
      AVE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x N $.  $d n x Y $.
    zncyg.y $e |- Y = ( Z/nZ ` N ) $.
    $( The group ` ZZ / n ZZ ` is cyclic for all ` n ` (including ` n = 0 ` ).
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    zncyg $p |- ( N e. NN0 -> Y e. CycGrp ) $=
      ( vn vx cn0 wcel cgrp cz cv cmg cfv co cmpt crn cbs wceq syl eqid rneqd
      wrex ccyg crg ccrg zncrng crngrng rnggrp cur rngidcl ccnfld cress zrhval2
      czrh wfo znzrhfo forn eqtr3d oveq2 mpteq2dv eqeq1d syl2anc iscyg sylanbrc
      rspcev ) AFGZBHGZDIDJZEJZBKLZMZNZOZBPLZQZEVMUAZBUBGVEBUCGZVFVEBUDGVPABCUE
      BUFRZBUGRVEBUHLZVMGZDIVGVRVIMZNZOZVMQZVOVEVPVSVQVMBVRVMSZVRSZUIRVEBUMLZOZ
      WBVMVEWFWAVEVPWFWAQVQBVIVRDWFUJIUKMZWHSWFSZVISZWEULRTVEIVMWFUNWGVMQVMWFAB
      CWDWIUOIVMWFUPRUQVNWCEVRVMVHVRQZVLWBVMWKVKWAWKDIVJVTVHVRVGVIURUSTUTVDVAEV
      MVIDBWDWJVBVC $.

    zndvds.2 $e |- L = ( ZRHom ` Y ) $.
    $( Express equality of equivalence classes in ` ZZ / n ZZ ` in terms of
       divisibility.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    zndvds $p |- ( ( N e. NN0 /\ A e. ZZ /\ B e. ZZ ) ->
      ( ( L ` A ) = ( L ` B ) <-> N || ( A - B ) ) ) $=
      ( vx cfv wceq wcel cz cmin co cdivides wbr ccnfld eqid zsubrg sylancr cn0
      w3a eqcom cress csn crsp cqg cec znzrhval 3adant2 3adant3 eqeq12d wer crg
      csubg clidl csubrg subrgrng ax-mp wss nn0z 3ad2ant1 cbs subrgbas lidlsubg
      snssd rspcl eqger syl simp3 erth csg cabel wb rngabl lidlss eqgabl wa jca
      simp2 biantrurd df-3an syl6bbr cv cab subrgsubg cnfldsub subgsub syld3an1
      mp1i eqcomd dvdsrz rspsn eleq12d ovex breq2 elab syl6bb 3bitr2d syl5bb )
      ACIZBCIZJXBXAJZDUAKZALKZBLKZUBZDABMNZOPZXAXBUCXGXCBQLUDNZDUEZXJUFIZIZUGNZ
      UHZAXNUHZJBAXNPZXIXGXBXOXAXPXDXFXBXOJXEBXNXLCDEXJXJRZXLRZXNRZFGUIUJXDXEXA
      XPJXFAXNXLCDEXJXRXSXTFGUIUKULXGBAXNLXGXMXJUOIKZLXNUMXGXJUNKZXMXJUPIZKZYAL
      QUQIKZYBSLQXJXRURUSZXGYBXKLUTYDYFXGDLXDXEDLKZXFDVAVBZVFLXJYCXKXLXSYELXJVC
      IJSLQXJXRVDUSZYCRZVGTZXJYCXMYJVETXNXJLXMYIXTVHVIXDXEXFVJZVKXGXQXFXEABXJVL
      IZNZXMKZUBZYOXIXGXJVMKZXMLUTZXQYPVNYBYQYFXJVOUSXGYDYRYKLXMYCXJYIYJVPVIBAX
      NXMXJYMLYIYMRZXTVQTXGYOXFXEVRZYOVRYPXGYTYOXGXFXEYLXDXEXFVTVSWAXFXEYOWBWCX
      GYOXHDHWDZOPZHWEZKXIXGYNXHXMUUCXGXHYNLQUOIKZXEXDXFXHYNJYEUUDXGSLQWFWJLQXJ
      MYMABWGXRYSWHWIWKXGYBYGXMUUCJYFYHHLOXJDXLYIXSXJXRWLWMTWNUUBXIHXHABMWOUUAX
      HDOWPWQWRWSWSWT $.

    zndvds0.3 $e |- .0. = ( 0g ` Y ) $.
    $( Special case of ~ zndvds when one argument is zero.  (Contributed by
       Mario Carneiro, 15-Jun-2015.) $)
    zndvds0 $p |- ( ( N e. NN0 /\ A e. ZZ ) ->
        ( ( L ` A ) = .0. <-> N || A ) ) $=
      ( cn0 wcel cz wa cfv cc0 wceq co cdivides wbr ccnfld 3syl wb zndvds cress
      cmin 0z mp3an3 crh cghm ccrg crg zncrng adantr crngrng eqid zrhrhm rhmghm
      csubrg zsubrg cnfld0 subrg0 ax-mp ghmid eqeq2d simpr zcnd subid1d 3bitr3d
      c0g breq2d ) CIJZAKJZLZABMZNBMZOZCANUDPZQRZVMEOCAQRVJVKNKJVOVQUAUEANBCDFG
      UBUFVLVNEVMVLBSKUCPZDUGPJZBVRDUHPJVNEOVLDUIJZDUJJVSVJVTVKCDFUKULDUMDBVRVR
      UNZGUOTVRDBUPVRDBNEKSUQMJNVRVHMOURKSVRNWAUSUTVAHVBTVCVLVPACQVLAVLAVJVKVDV
      EVFVIVG $.
  $}

  ${
    $d x y B $.  $d x y z F $.  $d x y z N $.  $d x y z W $.  $d x y z Y $.
    znf1o.z $e |- Z = ( CCfld |`s ZZ ) $.
    znf1o.y $e |- Y = ( Z/nZ ` N ) $.
    znf1o.b $e |- B = ( Base ` Y ) $.
    znf1o.f $e |- F = ( ( ZRHom ` Y ) |` W ) $.
    znf1o.w $e |- W = if ( N = 0 , ZZ , ( 0 ..^ N ) ) $.
    $( The function ` F ` enumerates all equivalence classes in ` Z/nZ ` for
       each ` n ` .  When ` n = 0 ` , ` ZZ / 0 ZZ = ZZ / { 0 } ~~ ZZ ` so we
       let ` W = ZZ ` ; otherwise ` W = { 0 , ... , n - 1 } ` enumerates all
       the equivalence classes.  (Contributed by Mario Carneiro, 15-Jun-2015.)
       (Revised by Mario Carneiro, 2-May-2016.) $)
    znf1o $p |- ( N e. NN0 -> F : W -1-1-onto-> B ) $=
      ( vx vy wcel cfv wceq cz co cc0 wa vz cn0 wf1 wfo wf1o wf cv wi wral czrh
      weq cres wss ccrg crg crh zncrng crngrng eqid zrhrhm ccnfld csubrg zsubrg
      cbs subrgbas ax-mp rhmf 4syl cfzo cif sseq1 ssid elfzoelz keephyp eqsstri
      ssriv fssres sylancl feq1i sylibr cmin cdivides wbr fveq1i fvres ad2antrl
      syl5eq ad2antll eqeq12d wb simpl simprl sseldi simprr syl3anc cn wo elnn0
      zndvds cmo moddvds cr crp cle clt zred adantr wne nnne0 ifnefalse eleqtrd
      nnrp syl elfzole1 elfzolt2 modid syl22anc bitr3d breq1d id syl6eqel sylan
      0nn0 zsubcld 0dvds zcnd subeq0ad 3bitrd jaoian sylanb ralrimivva sylanbrc
      biimpd wrex mpbid mpbird fveq2 eqeq2d rspcev syl2anc dff13 zmodfzo ancoms
      crn eleqtrrd zre modabs2 syl2anr simpr nnnn0 eqcomd iftrue eleq2d biimpar
      syl6eleqr eqidd rexbiia ralrimiva wfn znzrhfo eqeq1 rexbidv ralrn raleqdv
      fofn 3syl forn dffo3 df-f1o ) CUBNZDABUCZDABUDZDABUEUVJDABUFZLUGZBOZMUGZB
      OZPZLMUKZUHZMDUILDUIUVKUVJDAEUJOZDULZUFZUVMUVJQAUWAUFZDQUMUWCUVJEUNNEUONU
      WAFEUPRNUWDCEHUQEUREUWAFGUWAUSZUTQAFEUWAQVAVBONQFVDOPVCQVAFGVEVFIVGVHDCSP
      ZQSCVIRZVJZQKUWFQQUMUWGQUMUWHQUMQUWGQUWHQVKUWGUWHQVKQVLLUWGQUVNSCVMVPZVNV
      OZQADUWAVQVRDABUWBJVSVTZUVJUVTLMDDUVJUVNDNZUVPDNZTZTZUVRUVSUWOUVRUVNUWAOZ
      UVPUWAOZPZCUVNUVPWARZWBWCZUVSUWOUVOUWPUVQUWQUWOUVOUVNUWBOZUWPUVNBUWBJWDUW
      LUXAUWPPUVJUWMUVNDUWAWEWFWGUWOUVQUVPUWBOZUWQUVPBUWBJWDZUWMUXBUWQPUVJUWLUV
      PDUWAWEZWHWGWIUWOUVJUVNQNZUVPQNZUWRUWTWJUVJUWNWKUWODQUVNUWJUVJUWLUWMWLWMZ
      UWODQUVPUWJUVJUWLUWMWNWMZUVNUVPUWACEHUWEWSWOUVJCWPNZUWFWQZUWNUWTUVSWJZCWR
      ZUXIUWNUXKUWFUXIUWNTZUVNCWTRZUVPCWTRZPZUWTUVSUXMUXIUXEUXFUXPUWTWJUXIUWNWK
      UXMDQUVNUWJUXIUWLUWMWLZWMZUXMDQUVPUWJUXIUWLUWMWNZWMZUVNUVPCXAWOUXMUXNUVNU
      XOUVPUXMUVNXBNCXCNZSUVNXDWCZUVNCXEWCZUXNUVNPUXMUVNUXRXFUXIUYAUWNCXLZXGZUX
      MUVNUWGNZUYBUXMUVNDUWGUXQUXIDUWGPZUWNUXIDUWHUWGKUXICSXHUWHUWGPCXICSQUWGXJ
      XMWGZXGZXKZUVNSCXNXMUXMUYFUYCUYJUVNSCXOXMUVNCXPXQUXMUVPXBNUYASUVPXDWCZUVP
      CXEWCZUXOUVPPUXMUVPUXTXFUYEUXMUVPUWGNZUYKUXMUVPDUWGUXSUYIXKZUVPSCXNXMUXMU
      YMUYLUYNUVPSCXOXMUVPCXPXQWIXRUWFUWNTZUWTSUWSWBWCZUWSSPZUVSUYOCSUWSWBUWFUW
      NWKXSUYOUWSQNUYPUYQWJUYOUVNUVPUWFUVJUWNUXEUWFCSUBUWFXTYCYAZUXGYBZUWFUVJUW
      NUXFUYRUXHYBZYDUWSYEXMUYOUVNUVPUYOUVNUYSYFUYOUVPUYTYFYGYHYIYJYHYMYKLMDABU
      UAYLUVJUVMUVNUVQPZMDYNZLAUIZUVLUWKUVJVUBLUWAUUDZUIZVUCUVJVUEUAUGZUWAOZUVQ
      PZMDYNZUAQUIZUVJVUIUAQUVJVUFQNZTVUGUWQPZMDYNZVUIUVJUXJVUKVUMUXLUXIVUKVUMU
      WFUXIVUKTZVUFCWTRZDNVUGVUOUWAOZPZVUMVUNVUOUWGDVUKUXIVUOUWGNVUFCUUBUUCZUXI
      UYGVUKUYHXGUUEVUNVUPVUGVUNVUPVUGPZCVUOVUFWARWBWCZVUNVUOCWTRVUOPZVUTVUKVUF
      XBNUYAVVAUXIVUFUUFUYDVUFCUUGUUHVUNUXIVUOQNZVUKVVAVUTWJUXIVUKWKVUNUWGQVUOU
      WIVURWMZUXIVUKUUIZVUOVUFCXAWOYOVUNUVJVVBVUKVUSVUTWJUXIUVJVUKCUUJXGVVCVVDV
      UOVUFUWACEHUWEWSWOYPUUKVULVUQMVUODUVPVUOPUWQVUPVUGUVPVUOUWAYQYRYSYTUWFVUK
      TZVUFDNVUGVUGPZVUMVVEVUFUWHDUWFVUFUWHNVUKUWFUWHQVUFUWFQUWGUULUUMUUNKUUOVV
      EVUGUUPVULVVFMVUFDMUAUKUWQVUGVUGUVPVUFUWAYQYRYSYTYIYJVUHVULMDUWMUVQUWQVUG
      UWMUVQUXBUWQUXCUXDWGYRUUQVTUURUVJQAUWAUDZUWAQUUSVUEVUJWJAUWACEHIUWEUUTZQA
      UWAUVEVUBVUILUAQUWAUVNVUGPVUAVUHMDUVNVUGUVQUVAUVBUVCUVFYPUVJVUBLVUDAUVJVV
      GVUDAPVVHQAUWAUVGXMUVDYOMLDABUVHYLDABUVIYL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x N $.
    zzngim.y $e |- Y = ( Z/nZ ` 0 ) $.
    zzngim.2 $e |- L = ( ZRHom ` Y ) $.
    $( The ` ZZ ` ring homomorphism is an isomorphism for ` N = 0 ` .  (We only
       show group isomorphism here, but ring isomorphism follows, since it is a
       bijective ring homomorphism.)  (Contributed by Mario Carneiro,
       21-Apr-2016.) $)
    zzngim $p |- L e. ( ( CCfld |`s ZZ ) GrpIso Y ) $=
      ( ccnfld cz cress co cgim wcel cghm cbs cfv cc0 0nn0 mp2b eqid cres ax-mp
      wceq wf1o crg crh cn0 ccrg zncrng crngrng zrhrhm rhmghm czrh wfo wfn fofn
      znzrhfo fnresdm reseq1i eqtr3i cfzo cif iftrue eqcomi znf1o csubrg zsubrg
      subrgbas isgim mpbir2an ) AEFGHZBIHJAVHBKHJZFBLMZAUAZBUBJZAVHBUCHJVINUDJZ
      BUEJVLONBCUFBUGPBAVHVHQZDUHVHBAUIPVMVKOVJANFBVHVNCVJQZAFRZABUJMZFRFVJAUKZ
      AFULVPATVMVROVJANBCVODUNSFVJAUMFAUOPAVQFDUPUQNNTZFNNURHZUSZFVSWAFTNQVSFVT
      UTSVAVBSFVJVHBAFEVCMJFVHLMTVDFEVHVNVESVOVFVG $.
  $}

  ${
    $d x y .<_ $.  $d x A $.  $d x y z N $.  $d x y z X $.  $d x y z Y $.
    $d x B $.  $d x F $.
    znle2.z $e |- Z = ( CCfld |`s ZZ ) $.
    znle2.y $e |- Y = ( Z/nZ ` N ) $.
    znle2.f $e |- F = ( ( ZRHom ` Y ) |` W ) $.
    znle2.w $e |- W = if ( N = 0 , ZZ , ( 0 ..^ N ) ) $.
    znle2.l $e |- .<_ = ( le ` Y ) $.
    $( The ordering of the ` Z/nZ ` structure.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    znle2 $p |- ( N e. NN0 -> .<_ = ( ( F o. <_ ) o. `' F ) ) $=
      ( cn0 cfv co czrh cres cle ccom ccnv eqid wcel csn crsp cqus znle reseq1d
      cqg znzrh syl6eqr coeq1d cnveqd coeq12d eqtrd ) CLUAZBFFCUBFUCMZMUGNUDNZO
      MZDPZQRZURSZRAQRZASZRUOUPURBCDEFGUOTZUPTZHURTJKUEUNUSVAUTVBUNURAQUNUREOMZ
      DPAUNUQVEDUOUPCEFGVCVDHUHUFIUIZUJUNURAVFUKULUM $.

    znleval.x $e |- X = ( Base ` Y ) $.
    $( The ordering of the ` Z/nZ ` structure.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    znleval $p |- ( N e. NN0 -> ( A .<_ B <-> ( A e. X /\ B e. X /\
        ( `' F ` A ) <_ ( `' F ` B ) ) ) ) $=
      ( vx wbr wa cle wceq cn0 wcel ccnv cfv w3a cxp ccom cdm crn wss relssdmrn
      znle2 wrel relco ax-mp dmcoss df-rn wf1o wfo znf1o f1ofo syl5eqr syl5sseq
      forn 3syl rncoss syl5ss xpss12 syl2anc eqsstrd ssbrd brxp syl6ib pm4.71rd
      cv wex adantr breqd wb brcog adantl eqcom wfn f1ocnv f1ofn simprl fnbrfvb
      syl5rbb anbi1d exbidv bitrd breq1 ceqsexv cvv simprr sylancr breq2 syl5bb
      fvex vex brcnvg sylancl ancom syl6bbr syl5bbr bitr4d pm5.32da df-3an ) EU
      AUBZABDQZAGUBZBGUBZRZXJRZXKXLACUCZUDZBXOUDZSQZUEZXIXJXMXIXJABGGUFZQXMXIDX
      TABXIDCSUGZXOUGZXTCDEFHIJKLMNULZXIYBYBUHZYBUIZUFZXTYBUMYBYFUJYAXOUNYBUKUO
      XIYDGUJYEGUJYFXTUJXIXOUHZYDGYAXOUPXIYGCUIZGCUQXIFGCURZFGCUSYHGTGCEFHIJKOL
      MUTZFGCVAFGCVDVEZVBVCXIYEYAUIZGYAXOVFXIYHYLGCSVFYKVCVGYDGYEGVHVIVGVJVKABG
      GVLVMVNXIXNXMXRRXSXIXMXJXRXIXMRZXJPVOZXPTZYNBYAQZRZPVPZXRYMXJABYBQZYRYMDY
      BABXIDYBTXMYCVQVRYMYSAYNXOQZYPRZPVPZYRXMYSUUBVSXIPABYAXOGGVTWAYMUUAYQPYMY
      TYOYPYOXPYNTZYMYTYNXPWBYMXOGWCZXKUUCYTVSYMYIGFXOURUUDXIYIXMYJVQFGCWDGFXOW
      EVEZXIXKXLWFGAYNXOWGVIWHWIWJWKWKYRXPBYAQZYMXRYPUUFPXPAXOWSZYNXPBYAWLWMYMU
      UFXPYNSQZYNBCQZRZPVPZXRYMXPWNUBXLUUFUUKVSUUGXIXKXLWOZPXPBCSWNGVTWPXRYNXQT
      ZUUHRZPVPYMUUKUUHXRPXQBXOWSYNXQXPSWQWMYMUUNUUJPYMUUNUUIUUHRUUJYMUUMUUIUUH
      YMUUMBYNXOQZUUIUUMXQYNTZYMUUOYNXQWBYMUUDXLUUPUUOVSUUEUULGBYNXOWGVIWRYMXLY
      NWNUBUUOUUIVSUULPWTBYNGWNCXAXBWKWIUUHUUIXCXDWJXEXFWRWKXGXKXLXRXHXDWK $.

    $( The ordering of the ` Z/nZ ` structure.  (Contributed by Mario Carneiro,
       15-Jun-2015.) $)
    znleval2 $p |- ( ( N e. NN0 /\ A e. X /\ B e. X ) ->
        ( A .<_ B <-> ( `' F ` A ) <_ ( `' F ` B ) ) ) $=
      ( wcel w3a wbr cfv wa cn0 cle wb znleval 3ad2ant1 3simpc biantrurd df-3an
      ccnv syl6bbr bitr4d ) EUAPZAGPZBGPZQZABDRZUMUNACUIZSBUQSUBRZQZURULUMUPUSU
      CUNABCDEFGHIJKLMNOUDUEUOURUMUNTZURTUSUOUTURULUMUNUFUGUMUNURUHUJUK $.

    $( Lemma for ~ zntos .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    zntoslem $p |- ( N e. NN0 -> Y e. Toset ) $=
      ( vx wcel wbr cfv wa cr cz vy vz cn0 cpo cv wo wral ctos cvv fvex eqeltri
      czn a1i cbs wceq cple ccnv cle wf wss wf1o znf1o f1ocnv syl f1of cc0 cfzo
      co cif sseq1 elfzoelz ssriv keephyp eqsstri zssre sstri sylancl ffvelrnda
      ssid fss leidd wb znleval2 3anidm23 mpbird 3com23 anbi12d 3adant3 3adant2
      w3a letri3d f1of1 f1fveq sylan 3impb biimpd 3ad2antr1 3ad2antr2 3ad2antr3
      wf1 3bitr2d wi letr syl3anc 3adant3r3 3adant3r1 3adant3r2 3imtr4d orbi12d
      isposd letrid 3expb ralrimivva istos sylanbrc ) CUCOZFUDONUEZUAUEZBPZXRXQ
      BPZUFZUAEUGNEUGFUHOXPNUAUBEFBFUIOXPFCULQUIICULUJUKUMEFUNQUOXPMUMBFUPQUOXP
      LUMXPXQEOZRZXQXQBPZXQAUQZQZYFURPZYCYFXPESXQYEXPEDYEUSZDSUTESYEUSXPEDYEVAZ
      YHXPDEAVAYIEACDFGHIMJKVBDEAVCVDZEDYEVEVDDTSDCVFUOZTVFCVGVHZVIZTKYKTTUTYLT
      UTYMTUTTYLTYMTVJYLYMTVJTVSNYLTXQVFCVKVLVMVNVOVPEDSYEVTVQZVRZWAXPYBYDYGWBX
      QXQABCDEFGHIJKLMWCWDWEXPYBXREOZWJZXSXTRZXQXRUOZYQYRYFXRYEQZURPZYTYFURPZRY
      FYTUOZYSYQXSUUAXTUUBXQXRABCDEFGHIJKLMWCZXPYPYBXTUUBWBXRXQABCDEFGHIJKLMWCW
      FZWGYQYFYTXPYBYFSOZYPYOWHZXPYPYTSOZYBXPESXRYEYNVRZWIZWKXPYBYPUUCYSWBZXPED
      YEWTZYBYPRUUKXPYIUULYJEDYEWLVDEDXQXRYEWMWNWOXAWPXPYBYPUBUEZEOZWJRZUUAYTUU
      MYEQZURPZRZYFUUPURPZXSXRUUMBPZRXQUUMBPZUUOUUFUUHUUPSOZUURUUSXBXPYPYBUUFUU
      NYOWQXPYBYPUUHUUNUUIWRXPYBUUNUVBYPXPESUUMYEYNVRWSYFYTUUPXCXDUUOXSUUAUUTUU
      QXPYBYPXSUUAWBUUNUUDXEXPYPUUNUUTUUQWBYBXRUUMABCDEFGHIJKLMWCXFWGXPYBUUNUVA
      UUSWBYPXQUUMABCDEFGHIJKLMWCXGXHXJXPYANUAEEXPYBYPYAYQYAUUAUUBUFYQYFYTUUGUU
      JXKYQXSUUAXTUUBUUDUUEXIWEXLXMNUAEFBMLXNXO $.
  $}

  ${
    $d w x y z N $.  $d w x y z Y $.
    zntos.y $e |- Y = ( Z/nZ ` N ) $.
    $( The ` Z/nZ ` structure is a totally ordered set.  (The order is not
       respected by the operations, except in the case ` N = 0 ` when it
       coincides with the ordering on ` ZZ ` .)  (Contributed by Mario
       Carneiro, 15-Jun-2015.) $)
    zntos $p |- ( N e. NN0 -> Y e. Toset ) $=
      ( czrh cfv cc0 wceq cz cfzo cif cres cple cbs ccnfld cress eqid zntoslem
      co ) BDEAFGHFAIRJZKZBLEZASBMEZBNHORZUCPCTPSPUAPUBPQ $.

    ${
      znhash.1 $e |- B = ( Base ` Y ) $.
      $( The ` Z/nZ ` structure has ` n ` elements.  (Contributed by Mario
         Carneiro, 15-Jun-2015.) $)
      znhash $p |- ( N e. NN -> ( # ` B ) = N ) $=
        ( cn wcel chash cfv cc0 cfzo co czrh wceq cz wf1o cen wbr eqid syl cres
        cif cn0 nnnn0 ccnfld cress znf1o wne wb nnne0 ifnefalse 3syl mpbid ovex
        f1oeq2 f1oen ensym hasheni 4syl hashfzo0 eqtrd ) BFGZAHIZJBKLZHIZBVBVDA
        CMIBJNOVDUBZUAZPZVDAQRAVDQRVCVENVBVFAVGPZVHVBBUCGZVIBUDZAVGBVFCUEOUFLZV
        LSDEVGSVFSUGTVBBJUHVFVDNVIVHUIBUJBJOVDUKVFVDAVGUOULUMVDAVGJBKUNUPVDAUQA
        VDURUSVBVJVEBNVKBUTTVA $.

      $( The ` Z/nZ ` structure is a finite ring.  (Contributed by Mario
         Carneiro, 2-May-2016.) $)
      znfi $p |- ( N e. NN -> B e. Fin ) $=
        ( cn wcel chash cfv cn0 cfn znhash nnnn0 eqeltrd cvv wb eqeltri hashclb
        cbs fvex ax-mp sylibr ) BFGZAHIZJGZAKGZUCUDBJABCDELBMNAOGUFUEPACSIOECST
        QAORUAUB $.
    $}

    $( The ` Z/nZ ` structure is a finite field when ` n ` is prime.
       (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znfld $p |- ( N e. Prime -> Y e. Field ) $=
      ( vx vy vz vw wcel syl cv cfv co wceq c2o wbr c2 eqid wb wa cz cidom ccrg
      cprime cfield cdomn cn0 cn prmnn nnnn0 zncrng cnzr cmulr c0g cbs wral crg
      wo wi cdom crngrng 4syl chash cle hash2 cuz prmuz2 eluzle znhash breqtrrd
      syl5eqbr cfn cvv 2onn nnfi ax-mp fvex hashdom mp2an sylib isnzr2 sylanbrc
      com czrh wrex wfo znzrhfo foelrn anim12dan sylan reeanv cdivides euclemma
      3expb ccnfld cress crh adantr zrhrhm simprl simprr csubrg zsubrg subrgbas
      cmul cnfldmul ressmulr rhmmul syl3anc eqeq1d zmulcl zndvds0 syl2an bitr3d
      syl2anc orbi12d 3bitr4d biimpd oveq12 orbi1d orbi2d syl5ibrcom rexlimdvva
      eqeq1 sylan9bb imbi12d imp syldan ralrimivva isdomn isidom znfi fiidomfld
      syl5bir mpbid ) AUCHZBUAHZBUDHZYOBUBHZBUEHZYPYOAUFHZYRYOAUGHZYTAUHZAUIZIZ
      ABCUJZIYOBUKHZDJZEJZBULKZLZBUMKZMZUUGUUKMZUUHUUKMZUQZURZEBUNKZUODUUQUOYSY
      OBUPHZNUUQUSOZUUFYOUUAYTYRUURUUBUUCUUEBUTVAZYONVBKZUUQVBKZVCOZUUSYOUVAPUV
      BVCVDYOPAUVBVCYOAPVEKHPAVCOAVFPAVGIYOUUAUVBAMUUBUUQABCUUQQZVHIVIVJNVKHZUU
      QVLHUVCUUSRNWBHUVEVMNVNVOBUNVPNUUQVLVQVRVSUUQBUVDVTWAYOUUPDEUUQUUQYOUUGUU
      QHZUUHUUQHZSZUUGFJZBWCKZKZMZFTWDZUUHGJZUVJKZMZGTWDZSZUUPYOTUUQUVJWEZUVHUV
      RYOYTUVSUUDUUQUVJABCUVDUVJQZWFIUVSUVFUVMUVGUVQFTUUQUUGUVJWGGTUUQUUHUVJWGW
      HWIYOUVRUUPUVRUVLUVPSZGTWDFTWDYOUUPUVLUVPFGTTWJYOUWAUUPFGTTYOUVITHZUVNTHZ
      SZSZUUPUWAUVKUVOUUILZUUKMZUVKUUKMZUVOUUKMZUQZURUWEUWGUWJUWEAUVIUVNXDLZWKO
      ZAUVIWKOZAUVNWKOZUQZUWGUWJYOUWBUWCUWLUWORAUVIUVNWLWMUWEUWKUVJKZUUKMZUWGUW
      LUWEUWPUWFUUKUWEUVJWNTWOLZBWPLHZUWBUWCUWPUWFMUWEUURUWSYOUURUWDUUTWQBUVJUW
      RUWRQZUVTWRIYOUWBUWCWSZYOUWBUWCWTZUVIUVNUWRBXDUUIUVJTTWNXAKZHZTUWRUNKMXBT
      WNUWRUWTXCVOUXDXDUWRULKMXBTWNUWRXDUXCUWTXEXFVOUUIQZXGXHXIYOYTUWKTHUWQUWLR
      UWDUUDUVIUVNXJUWKUVJABUUKCUVTUUKQZXKXLXMUWEUWHUWMUWIUWNUWEYTUWBUWHUWMRYOY
      TUWDUUDWQZUXAUVIUVJABUUKCUVTUXFXKXNUWEYTUWCUWIUWNRUXGUXBUVNUVJABUUKCUVTUX
      FXKXNXOXPXQUWAUULUWGUUOUWJUWAUUJUWFUUKUUGUVKUUHUVOUUIXRXIUVLUUOUWHUUNUQUV
      PUWJUVLUUMUWHUUNUUGUVKUUKYCXSUVPUUNUWIUWHUUHUVOUUKYCXTYDYEYAYBYMYFYGYHDEU
      UQBUUIUUKUVDUXEUXFYIWABYJWAYOUUQVKHZYPYQRYOUUAUXHUUBUUQABCUVDYKIUUQBUVDYL
      IYN $.

    $( The ` Z/nZ ` structure is a domain (and hence a field) precisely when
       ` n ` is prime.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    znidomb $p |- ( N e. NN -> ( Y e. IDomn <-> N e. Prime ) ) $=
      ( cn wcel c2 cfv wbr c1 wceq cz cle c2o syl eqid wb ad2antrr ad2antrl cc0
      co vx cidom cprime wa cuz cv cdivides wo wi wral a1i nnz adantr cbs chash
      2z hash2 cdom cnzr cdomn isidom simprbi domnnzr crg isnzr2 adantl cfn cvv
      ccrg c0 csn df2o2 prfi eqeltri fvex hashdom mp2an sylibr syl5eqbrr znhash
      cpr breqtrd eluz2 syl3anbrc cdiv czrh c0g cmulr cmul cc nncn wne divcan1d
      nnne0 fveq2d ccnfld cress ad2antlr domnrng zrhrhm simprr dvdsval2 syl3anc
      crh mpbid csubrg zsubrg subrgbas ax-mp cnfldmul ressmulr rhmmul cn0 nnnn0
      iddvds zndvds0 syl2anc mpbird 3eqtr3d wf rhmf ffvelrnd domneq0 nnre nngt0
      clt cr divgt0d elnnz sylanbrc dvdsle 0lt1 lediv2 syl222anc nnle1eq1 div1d
      1re breq1d sylbid expr 3bitr3rd sylibd dvdseq syl21anc orim12d mpd isprm2
      ralrimiva ex cfield znfld fldidom impbid1 ) ADEZBUBEZAUCEZUUNUUOUUPUUNUUO
      UDZAFUEGEZUAUFZAUGHZUUSIJZUUSAJZUHZUIZUADUJUUPUUQFKEZAKEZFALHUURUVEUUQUPU
      KUUNUVFUUOAULZUMUUQFBUNGZUOGZALUUQFMUOGZUVILUQUUQMUVHURHZUVJUVILHZUUOUVKU
      UNUUOBUSEZUVKUUOBUTEZUVMUUOBVIEUVNBVAVBZBVCNUVMBVDEZUVKUVHBUVHOZVEVBNVFMV
      GEUVHVHEUVLUVKPMVJVJVKZWAVGVLVJUVRVMVNBUNVOMUVHVHVPVQVRVSUUNUVIAJUUOUVHAB
      CUVQVTUMWBFAWCWDUUQUVDUADUUQUUSDEZUUTUVCUUQUVSUUTUDZUDZAUUSWETZBWFGZGZBWG
      GZJZUUSUWCGZUWEJZUHZUVCUWAUWDUWGBWHGZTZUWEJZUWIUWAUWBUUSWITZUWCGZAUWCGZUW
      KUWEUWAUWMAUWCUWAAUUSUUNAWJEUUOUVTAWKQZUVSUUSWJEUUQUUTUUSWKRUVSUUSSWLZUUQ
      UUTUUSWNRZWMWOUWAUWCWPKWQTZBXDTEZUWBKEZUUSKEZUWNUWKJUWAUVPUWTUWAUVNUVPUUO
      UVNUUNUVTUVOWRZBWSNBUWCUWSUWSOZUWCOZWTNZUWAUUTUXAUUQUVSUUTXAZUWAUXBUWQUVF
      UUTUXAPUVSUXBUUQUUTUUSULRZUWRUUNUVFUUOUVTUVGQZUUSAXBXCXEZUXHUWBUUSUWSBWIU
      WJUWCKKWPXFGZEZKUWSUNGJXGKWPUWSUXDXHXIZUXLWIUWSWHGJXGKWPUWSWIUXKUXDXJXKXI
      UWJOZXLXCUWAUWOUWEJZAAUGHZUWAUVFUXPUXIAXONUWAAXMEZUVFUXOUXPPUUNUXQUUOUVTA
      XNQZUXIAUWCABUWECUXEUWEOZXPXQXRXSUWAUVNUWDUVHEUWGUVHEUWLUWIPUXCUWAKUVHUWB
      UWCUWAUWTKUVHUWCXTUXFKUVHUWSBUWCUXMUVQYANZUXJYBUWAKUVHUUSUWCUXTUXHYBUVHBU
      WJUWDUWGUWEUVQUXNUXSYCXCXEUWAUWFUVAUWHUVBUWAUWFAUWBUGHZUVAUWAUXQUXAUWFUYA
      PUXRUXJUWBUWCABUWECUXEUXSXPXQUWAUYAAUWBLHZUVAUWAUVFUWBDEZUYAUYBUIUXIUWAUX
      ASUWBYFHUYCUXJUWAAUUSUUNAYGEZUUOUVTAYDQZUVSUUSYGEZUUQUUTUUSYDRZUUNSAYFHZU
      UOUVTAYEQZUVSSUUSYFHZUUQUUTUUSYERZYHUWBYIYJAUWBYKXQUWAUUSILHZAIWETZUWBLHZ
      UVAUYBUWAUYFUYJIYGEZSIYFHZUYDUYHUYLUYNPUYGUYKUYOUWAYQUKUYPUWAYLUKUYEUYIUU
      SIAYMYNUVSUYLUVAPUUQUUTUUSYORUWAUYMAUWBLUWAAUWPYPYRUUAUUBYSUWAUWHAUUSUGHZ
      UVBUWAUXQUXBUWHUYQPUXRUXHUUSUWCABUWECUXEUXSXPXQUWAUUSXMEZUXQUUTUYQUVBUIUV
      SUYRUUQUUTUUSXNRUXRUXGUYRUXQUDUUTUYQUVBUUSAUUCYTUUDYSUUEUUFYTUUHUAAUUGYJU
      UIUUPBUUJEUUOABCUUKBUULNUUM $.
  $}

  ${
    $d m n x A $.  $d n x E $.  $d n x L $.  $d m n x N $.  $d n x U $.
    $d n x Y $.
    znchr.y $e |- Y = ( Z/nZ ` N ) $.
    $( Cyclic rings are defined by their characteristic.  (Contributed by
       Stefan O'Rear, 6-Sep-2015.) $)
    znchr $p |- ( N e. NN0 -> ( chr ` Y ) = N ) $=
      ( vx cn0 wcel cchr cfv wceq cv cdivides wbr wb wral czrh c0g crg syl eqid
      wa ccrg zncrng crngrng nn0z chrdvds syl2an zndvds0 sylan2 bitrd ralrimiva
      cz chrcl dvdsext mpancom mpbird ) AEFZBGHZAIZUQDJZKLZAUSKLZMZDENZUPVBDEUP
      USEFZTUTUSBOHZHBPHZIZVAUPBQFZUSUKFZUTVGMVDUPBUAFVHABCUBBUCRZUSUDZUQBVEUSV
      FUQSZVESZVFSZUEUFVDUPVIVGVAMVKUSVEABVFCVMVNUGUHUIUJUQEFZUPURVCMUPVHVOVJUQ
      BVLULRDUQAUMUNUO $.

    znunit.u $e |- U = ( Unit ` Y ) $.
    ${
      znunit.l $e |- L = ( ZRHom ` Y ) $.
      $( The units of ` Z/nZ ` are the integers coprime to the base.
         (Contributed by Mario Carneiro, 18-Apr-2016.) $)
      znunit $p |- ( ( N e. NN0 /\ A e. ZZ ) ->
        ( ( L ` A ) e. U <-> ( A gcd N ) = 1 ) ) $=
        ( vn wcel cz wa cfv wbr co wceq wrex c1 syl cdivides vx vm cn0 cur cdsr
        cv cmulr cbs cgcd ccrg wb zncrng adantr crngunit wf wfo znzrhfo ffvelrn
        eqid fof sylancom dvdsr2 cmul cmin crn forn rexeqdv wfn ffn oveq1 rexrn
        eqeq1d 3syl bitr3d ccnfld cress crh crngrng zrhrhm simplr csubrg zsubrg
        crg simpr subrgbas ax-mp cvv zex cnfldmul ressmulr syl3anc zrh1 eqeq12d
        rhmmul simpll zmulcld a1i zndvds rexbidva nn0z ad2antrr gcddvds syl2anc
        1z simpld wi gcdcld nn0zd adantrr dvdsmultr2 mpd simprd simprr peano2zm
        dvdstr mp2and dvdssub2 syl31anc mpbid dvds1 caddc bezout eqeq1 2rexbidv
        rexlimdvaa syl5ibcom cneg ad3antrrr dvdsmul1 dvdsnegb zcnd zcn ad2antlr
        zmulcl cc mulcomd oveq1d mulcld subnegd 3bitrd eqtr4d oveq2d syl5ibrcom
        negcld nncand eqtrd breqtrrd oveq2 breq2d rexlimdva reximdva impbid
        syld ) DUCJZAKJZLZACMZBJZUUQEUDMZEUEMZNZUAUFZUUQEUGMZOZUUSPZUAEUHMZQZAD
        UIOZRPZUUPEUJJZUURUVAUKUUNUVJUUODEFULUMZUUTEBUUSUUQGUUSUSZUUTUSZUNSUUPU
        UQUVFJZUVAUVGUKUUNUUOKUVFCUOZUVNUUPKUVFCUPZUVOUUNUVPUUOUVFCDEFUVFUSZHUQ
        UMZKUVFCUTSZKUVFACURVAUAUVFUUTEUVCUUQUUSUVQUVMUVCUSZVBSUUPUVGIUFZCMZUUQ
        UVCOZUUSPZIKQZDUWAAVCOZRVDOZTNZIKQZUVIUUPUVEUACVEZQZUVGUWEUUPUVEUAUWJUV
        FUUPUVPUWJUVFPUVRKUVFCVFSVGUUPUVOCKVHUWKUWEUKUVSKUVFCVIUVEUWDUAIKCUVBUW
        BPUVDUWCUUSUVBUWBUUQUVCVJVLVKVMVNUUPUWDUWHIKUUPUWAKJZLZUWFCMZRCMZPZUWDU
        WHUWMUWNUWCUWOUUSUWMCVOKVPOZEVQOJZUWLUUOUWNUWCPUUPUWRUWLUUPEWCJZUWRUUPU
        VJUWSUVKEVRSZECUWQUWQUSZHVSSUMUUPUWLWDZUUNUUOUWLVTZUWAAUWQEVCUVCCKKVOWA
        MJKUWQUHMPWBKVOUWQUXAWEWFKWGJVCUWQUGMPWHKVOUWQVCWGUXAWIWJWFUVTWNWKUWMUW
        SUWOUUSPUUPUWSUWLUWTUMEUUSCHUVLWLSWMUWMUUNUWFKJZRKJZUWPUWHUKUUNUUOUWLWO
        UWMUWAAUXBUXCWPZUXEUWMXDWQUWFRCDEFHWRWKVNWSUUPUWIUVIUUPUWHUVIIKUUPUWLUW
        HLZLZUVHRTNZUVIUXHUVHUWFTNZUXIUXHUVHATNZUXJUXHUXKUVHDTNZUXHUUODKJZUXKUX
        LLUUNUUOUXGVTZUUNUXMUUOUXGDWTZXAZADXBXCZXEUXHUVHKJZUWLUUOUXKUXJXFUXHUVH
        UXHADUXNUXPXGZXHZUUPUWLUWLUWHUXBXIUXNUVHUWAAXJWKXKUXHUXRUXDUXEUVHUWGTNZ
        UXJUXIUKUXTUUPUWLUXDUWHUXFXIZUXEUXHXDWQUXHUXLUWHUYAUXHUXKUXLUXQXLUUPUWL
        UWHXMUXHUXRUXMUWGKJZUXLUWHLUYAXFUXTUXPUXHUXDUYCUYBUWFXNSUVHDUWGXOWKXPUV
        HUWFRXQXRXSUXHUVHUCJUXIUVIUKUXSUVHXTSXSYEUUPUVIRAUWAVCOZDUBUFZVCOZYAOZP
        ZUBKQZIKQZUWIUUPUVHUYGPZUBKQIKQZUVIUYJUUPUUOUXMUYLUUNUUOWDUUNUXMUUOUXOU
        MIUBADYBXCUVIUYKUYHIUBKKUVHRUYGYCYDYFUUPUYIUWHIKUWMUYHUWHUBKUWMUYEKJZLZ
        UWHUYHDUWFUYGVDOZTNUYNDUYFYGZUYOTUYNDUYFTNZDUYPTNZUWMUYMUXMUYQUUNUXMUUO
        UWLUYMUXOYHZDUYEYIVAUYNUXMUYFKJZUYQUYRUKUYSUWMUYMUXMUYTUYSDUYEYNVAZDUYF
        YJXCXSUYNUYOUWFUWFUYPVDOZVDOUYPUYNUYGVUBUWFVDUYNUYGUWFUYFYAOVUBUYNUYDUW
        FUYFYAUYNAUWAUYNAUWMUUOUYMUXCUMYKZUWLUWAYOJUUPUYMUWAYLYMZYPYQUYNUWFUYFU
        YNUWAAVUDVUCYRZUYNUYFVUAYKZYSUUAUUBUYNUWFUYPVUEUYNUYFVUFUUDUUEUUFUUGUYH
        UWGUYODTRUYGUWFVDUUHUUIUUCUUJUUKUUMUULYTYT $.
    $}

    $( The size of the unit group of ` Z/nZ ` .  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    znunithash $p |- ( N e. NN -> ( # ` U ) = ( phi ` N ) ) $=
      ( vx wcel cfv co wceq cc0 chash wa wf1o wb cz eqid syl bitrd cvv cn cv c1
      cphi cgcd cfzo crab czrh cres ccnv cima dfphi2 cab cbs wfn cif cn0 ccnfld
      nnnn0 cress znf1o wne nnne0 ifnefalse reseq2 f1oeq1 f1oeq2 mpbid elpreima
      f1ofn fvres adantl eleq1d elfzoelz znunit syl2an pm5.32da abbi2dv syl6eqr
      3syl df-rab fveq2d cen wbr wf1 wss f1ocnv f1of1 ovex a1i cui fvex eqeltri
      unitss f1imaen2g syl22anc hasheni 3eqtr2rd ) BUAGZBUDHFUBZBUEIUCJZFKBUFIZ
      UGZLHCUHHZXBUIZUJZAUKZLHZALHZFBULWSXGXCLWSXGWTXBGZXAMZFUMXCWSXKFXGWSWTXGG
      ZXJWTXEHZAGZMZXKWSXBCUNHZXENZXEXBUOXLXOOWSBKJPXBUPZXPXDXRUIZNZXQWSBUQGZXT
      BUSZXPXSBXRCURPUTIZYCQDXPQZXSQXRQVARWSBKVBXRXBJZXTXQOBVCBKPXBVDYEXTXRXPXE
      NZXQYEXSXEJXTYFOXRXBXDVEXRXPXSXEVFRXRXBXPXEVGSVTVHZXBXPXEVJXBWTAXEVIVTWSX
      JXNXAWSXJMZXNWTXDHZAGZXAYHXMYIAXJXMYIJWSWTXBXDVKVLVMWSYAWTPGYJXAOXJYBWTKB
      VNWTAXDBCDEXDQVOVPSVQSVRXAFXBWAVSWBWSXGAWCWDZXHXIJWSXPXBXFWEZXBTGZAXPWFZA
      TGZYKWSXQXPXBXFNYLYGXBXPXEWGXPXBXFWHVTYMWSKBUFWIWJYNWSXPCAYDEWNWJYOWSACWK
      HTECWKWLWMWJXPXBAXFTWOWPXGAWQRWR $.

    znrrg.e $e |- E = ( RLReg ` Y ) $.
    $( The regular elements of ` Z/nZ ` are exactly the units.  (This theorem
       fails for ` N = 0 ` , where all nonzero integers are regular, but only
       ` +- 1 ` are units.)  (Contributed by Mario Carneiro, 18-Apr-2016.) $)
    znrrg $p |- ( N e. NN -> E = U ) $=
      ( wcel cfv wceq cz eqid syl co c1 cdivides wbr cmul syl2anc wb vx vn czrh
      cn cv wrex cbs wfo cn0 nnnn0 znzrhfo rrgss sseli foelrn syl2an ex wi cgcd
      wa cdiv cc nncn ad2antrr cc0 simplr nnz wne nnne0 simpr necon3ai syl21anc
      wn gcdn0cl nncnd nnne0d divcan2d gcddvds simpld simprd nndivdvds dvdsmulc
      simpll mpbid syl3anc mpd eqbrtrrd cmulr c0g wf fof ffvelrnd rrgeq0i cress
      ccnfld crh crg zncrng crngrng zrhrhm csubrg zsubrg subrgbas ax-mp cvv zex
      cnfldmul ressmulr rhmmul zmulcld zndvds0 3imtr3d divcan1d mulid1d 3brtr4d
      eqeq1d bitr3d 1z a1i dvdscmulr syl112anc gcdcld dvds1 znunit mpbird eleq1
      ccrg imbi12d syl5ibrcom rexlimdva com23 mpdd ssrdv wss unitrrg eqssd ) CU
      DHZBAYPUABAYPUAUEZBHZYQUBUEZDUCIZIZJZUBKUFZYQAHZYPYRUUCYPKDUGIZYTUHZYQUUE
      HUUCYRYPCUIHZUUFCUJZUUEYTCDEUUELZYTLZUKZMBUUEYQUUEDBGUUIULUMUBKUUEYQYTUNU
      OUPYPUUCYRUUDYPUUBYRUUDUQZUBKYPYSKHZUSZUULUUBUUABHZUUAAHZUQUUNUUOUUPUUNUU
      OUSZUUPYSCURNZOJZUUQUUROPQZUUSUUQCUURUTNZUURRNZUVAORNZPQZUUTUUQCUVAUVBUVC
      PUUQCYSUVARNZPQZCUVAPQZUUQUURUVARNZCUVEPUUQCUURYPCVAHUUMUUOCVBVCZUUQUURUU
      QUUMCKHZYSVDJZCVDJZUSZVLZUURUDHZYPUUMUUOVEZYPUVJUUMUUOCVFVCZUUQCVDVGZUVNY
      PUVRUUMUUOCVHVCUVMCVDUVKUVLVIVJMYSCVMVKZVNZUUQUURUVSVOZVPUUQUURYSPQZUVHUV
      EPQZUUQUWBUURCPQZUUQUUMUVJUWBUWDUSUVPUVQYSCVQSZVRUUQUURKHZUUMUVAKHZUWBUWC
      UQUUQUVOUWFUVSUURVFMZUVPUUQUVAUDHZUWGUUQUWDUWIUUQUWBUWDUWEVSUUQYPUVOUWDUW
      ITYPUUMUUOWBUVSCUURVTSWCZUVAVFMZUVAUURYSWAWDWEWFUUQUUAUVAYTIZDWGIZNZDWHIZ
      JZUWLUWOJZUVFUVGUUQUUOUWLUUEHUWPUWQUQUUNUUOVIUUQKUUEUVAYTUUQUUFKUUEYTWIUU
      QUUGUUFYPUUGUUMUUOUUHVCZUUKMKUUEYTWJMUWKWKUUEDUWMBUUAUWLUWOGUUIUWMLZUWOLZ
      WLSUUQUVEYTIZUWOJZUWPUVFUUQUXAUWNUWOUUQYTWNKWMNZDWONHZUUMUWGUXAUWNJUUQDWP
      HZUXDYPUXEUUMUUOYPDYFHZUXEYPUUGUXFUUHCDEWQMDWRMZVCDYTUXCUXCLZUUJWSMUVPUWK
      YSUVAUXCDRUWMYTKKWNWTIHKUXCUGIJXAKWNUXCUXHXBXCKXDHRUXCWGIJXEKWNUXCRXDUXHX
      FXGXCUWSXHWDXOUUQUUGUVEKHUXBUVFTUWRUUQYSUVAUVPUWKXIUVEYTCDUWOEUUJUWTXJSXP
      UUQUUGUWGUWQUVGTUWRUWKUVAYTCDUWOEUUJUWTXJSXKWEUUQCUURUVIUVTUWAXLUUQUVAUUQ
      UVAUWJVNXMXNUUQUWFOKHZUWGUVAVDVGUVDUUTTUWHUXIUUQXQXRUWKUUQUVAUWJVOUVAUURO
      XSXTWCUUQUURUIHUUTUUSTUUQYSCUVPUVQYAUURYBMWCUUQUUGUUMUUPUUSTUWRUVPYSAYTCD
      EFUUJYCSYDUPUUBYRUUOUUDUUPYQUUABYEYQUUAAYEYGYHYIYJYKYLYPUXEABYMUXGDABGFYN
      MYO $.
  $}

  ${
    $d a b g h i j k m n x y z B $.  $d y z E $.  $d a b g h i j m n x y z G $.
    $d h m y M $.  $d a h j k m n x y z .x. $.  $d a b g h i j m n x y z Y $.
    $d a h i j k m n x y L $.  $d x N $.  $d a b h i j k m y z ph $.
    $d a b i j k n x z F $.  $d a h j k m n x y z X $.
    cygzn.b $e |- B = ( Base ` G ) $.
    cygzn.n $e |- N = if ( B e. Fin , ( # ` B ) , 0 ) $.
    cygzn.y $e |- Y = ( Z/nZ ` N ) $.
    ${
      cygzn.m $e |- .x. = ( .g ` G ) $.
      cygzn.l $e |- L = ( ZRHom ` Y ) $.
      cygzn.e $e |- E = { x e. B | ran ( n e. ZZ |-> ( n .x. x ) ) = B } $.
      cygzn.g $e |- ( ph -> G e. CycGrp ) $.
      cygzn.x $e |- ( ph -> X e. E ) $.
      $( Lemma for ~ cygzn .  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      cygznlem1 $p |- ( ( ph /\ ( K e. ZZ /\ M e. ZZ ) ) ->
        ( ( L ` K ) = ( L ` M ) <-> ( K .x. X ) = ( M .x. X ) ) ) $=
        ( cz wcel wa cfv wceq cmin co cdivides wbr cod cn0 wb cfn chash cc0 cif
        hashcl adantl 0nn0 a1i ifclda syl5eqel adantr simprl simprr zndvds cgrp
        wn syl3anc ccyg cyggrp syl eqid cyggenod2 syl2anc syl6eqr breq1d cv crn
        cmpt iscyggen simplbi c0g odcong syl112anc 3bitr2d ) AHUBUCZJUBUCZUDZUD
        ZHIUEJIUEUFZKHJUGUHZUIUJZLGUKUEZUEZWMUIUJZHLDUHJLDUHUFZWKKULUCZWHWIWLWN
        UMAWSWJAKCUNUCZCUOUEZUPUQZULOAWTXAUPULWTXAULUCACURUSUPULUCAWTVIUDUTVAVB
        VCVDAWHWIVEZAWHWIVFZHJIKMPRVGVJWKWPKWMUIAWPKUFWJAWPXBKAGVHUCZLFUCZWPXBU
        FAGVKUCXETGVLVMZUABCDEFGWOLNQSWOVNZVOVPOVQVDVRWKXELCUCZWHWIWQWRUMAXEWJX
        GVDAXIWJAXFXIUAXFXIEUBEVSLDUHWAVTCUFBCDEFGLNQSWBWCVMVDXCXDLDGHJWOCGWDUE
        ZNXHQXJVNWEWFWG $.

      cygzn.f $e |- F = ran ( m e. ZZ |-> <. ( L ` m ) , ( m .x. X ) >. ) $.
      $( Lemma for ~ cygzn .  (Contributed by Mario Carneiro, 23-Dec-2016.) $)
      cygznlem2a $p |- ( ph -> F : ( Base ` Y ) --> B ) $=
        ( vk cz cv cfv cmpt crn wf cbs wfun co cvv wcel wa fvex a1i cgrp cyggrp
        ccyg adantr simpr wceq ssrab2 eqsstri sseldi mulgcl syl3anc fveq2 oveq1
        syl crab wi cygznlem1 biimpd exp32 3imp2 fliftfund fliftf mpbid wfo cn0
        cfn chash cc0 cif hashcl adantl wn 0nn0 ifclda syl5eqel znzrhfo feqmptd
        eqid fof rneqd forn eqtr3d feq2d ) AEUDEUEZJUFZUGZUHZCHUIZMUJUFZCHUIAHU
        KXEAEUCXBXALDULZUCUEZJUFZXHLDULZUMCHUDUBXBUMUNAXAUDUNZUOZXAJUPUQZXLIURU
        NZXKLCUNZXGCUNAXNXKAIUTUNXNTIUSVKVAAXKVBAXOXKAGCLGFUDFUEBUEDULUGUHCVCZB
        CVLCSXPBCVDVEUAVFVACDIXALNQVGVHZXAXHJVIXAXHLDVJAXKXHUDUNZXBXIVCZXGXJVCZ
        AXKXRXSXTVMAXKXRUOUOXSXTABCDFGIXAJXHKLMNOPQRSTUAVNVOVPVQVRAEXBXGUMCHUDU
        BXMXQVSVTAXDXFCHAJUHZXDXFAJXCAEUDXFJAUDXFJWAZUDXFJUIAKWBUNYBAKCWCUNZCWD
        UFZWEWFWBOAYCYDWEWBYCYDWBUNACWGWHWEWBUNAYCWIUOWJUQWKWLXFJKMPXFWORWMVKZU
        DXFJWPVKWNWQAYBYAXFVCYEUDXFJWRVKWSWTVT $.

      $( Lemma for ~ cygzn .  (Contributed by Mario Carneiro, 21-Apr-2016.)
         (Revised by Mario Carneiro, 23-Dec-2016.) $)
      cygznlem2 $p |- ( ( ph /\ M e. ZZ ) ->
        ( F ` ( L ` M ) ) = ( M .x. X ) ) $=
        ( cv cfv co cvv cz wcel wa fvex a1i ovex fveq2 oveq1 wf wfun cygznlem2a
        cbs ffun syl fliftval ) AEEUDZJUEZVCMDUFZKJUEKMDUFUGUGHUHKUCVDUGUIAVCUH
        UIUJZVCJUKULVEUGUIVFVCMDUMULVCKJUNVCKMDUOANUSUEZCHUPHUQABCDEFGHIJLMNOPQ
        RSTUAUBUCURVGCHUTVAVB $.

      $( A cyclic group with ` n ` elements is isomorphic to ` ZZ / n ZZ ` .
         (Contributed by Mario Carneiro, 21-Apr-2016.) $)
      cygznlem3 $p |- ( ph -> G ~=g Y ) $=
        ( va vb vi vj cgim wcel cgic wbr cghm cbs cfv wf1o cplusg eqid cn0 ccrg
        vz co crg cgrp cfn chash cc0 cif hashcl adantl 0nn0 a1i ifclda syl5eqel
        wn wa zncrng crngrng rnggrp 4syl ccyg cyggrp cygznlem2a cv wceq cz wrex
        syl wfo znzrhfo foelrn sylan anim12dan reeanv adantr simprl simprr cmpt
        caddc crn iscyggen simplbi mulgdir syl13anc ccnfld zrhrhm rhmghm csubrg
        cress crh zsubrg subrgbas ax-mp cvv zex ressplusg ghmlin syl3anc fveq2d
        cnfldadd zaddcl cygznlem2 sylan2 eqtr3d adantrr adantrl oveq12d 3eqtr4d
        oveq12 fveq2 eqeq12d syl5ibrcom rexlimdvva syl5bir imp syldan wf weq wi
        wral sylanbrc eqeq2d oveqan12d isghmd cygznlem1 bitr4d biimpd eqeqan12d
        eqeq12 imbi12d ralrimivva dff13 wb iscyggen2 mpbid simprd oveq1 cbvrexv
        wf1 fof ffvelrnda adantlr eqcomd rspcev syl2anc eqeq1 rexbidv rexlimdva
        syl5bi ralimdva mpd dffo3 df-f1o isgim brgici gicsym 3syl ) AHMIUGUTUHZ
        MIUIUJIMUIUJAHMIUKUTUHMULUMZCHUNZUVPAUCUDMUOUMZIUOUMZMIHUVQCUVQUPZNUVSU
        PZUVTUPZAKUQUHZMURUHZMVAUHZMVBUHAKCVCUHZCVDUMZVEVFUQOAUWGUWHVEUQUWGUWHU
        QUHACVGVHVEUQUHAUWGVMVNVIVJVKVLZKMPVOZMVPZMVQVRAIVSUHIVBUHZTIVTWFZABCDE
        FGHIJKLMNOPQRSTUAUBWAZAUCWBZUVQUHZUDWBZUVQUHZVNZUWOUEWBZJUMZWCZUEWDWEZU
        WQUFWBZJUMZWCZUFWDWEZVNZUWOUWQUVSUTZHUMZUWOHUMZUWQHUMZUVTUTZWCZAUWPUXCU
        WRUXGAWDUVQJWGZUWPUXCAUWDUXOUWIUVQJKMPUWARWHWFZUEWDUVQUWOJWIWJAUXOUWRUX
        GUXPUFWDUVQUWQJWIWJWKZAUXHUXNUXHUXBUXFVNZUFWDWEUEWDWEZAUXNUXBUXFUEUFWDW
        DWLZAUXRUXNUEUFWDWDAUWTWDUHZUXDWDUHZVNZVNZUXNUXRUXAUXEUVSUTZHUMZUXAHUMZ
        UXEHUMZUVTUTZWCUYDUWTUXDWQUTZLDUTZUWTLDUTZUXDLDUTZUVTUTZUYFUYIUYDUWLUYA
        UYBLCUHZUYKUYNWCAUWLUYCUWMWMAUYAUYBWNZAUYAUYBWOZAUYOUYCALGUHZUYOUAUYRUY
        OFWDFWBZLDUTZWPWRCWCBCDFGILNQSWSWTWFWMCUVTDIUWTUXDLNQUWCXAXBUYDUYJJUMZH
        UMZUYFUYKUYDVUAUYEHUYDJXCWDXGUTZMUKUTUHZUYAUYBVUAUYEWCAVUDUYCAUWEUWFJVU
        CMXHUTUHVUDAUWDUWEUWIUWJWFUWKMJVUCVUCUPZRXDVUCMJXEVRWMUYPUYQWQUVSVUCMUW
        TJUXDWDWDXCXFUMUHWDVUCULUMWCXIWDXCVUCVUEXJXKWDXLUHWQVUCUOUMWCXMWDWQXCVU
        CXLVUEXRXNXKUWBXOXPXQUYCAUYJWDUHVUBUYKWCUWTUXDXSABCDEFGHIJUYJKLMNOPQRST
        UAUBXTYAYBUYDUYGUYLUYHUYMUVTAUYAUYGUYLWCUYBABCDEFGHIJUWTKLMNOPQRSTUAUBX
        TYCZAUYBUYHUYMWCZUYAABCDEFGHIJUXDKLMNOPQRSTUAUBXTZYDZYEYFUXRUXJUYFUXMUY
        IUXRUXIUYEHUWOUXAUWQUXEUVSYGXQUXBUXFUXKUYGUXLUYHUVTUWOUXAHYHZUWQUXEHYHZ
        UUAYIYJYKYLYMYNUUBAUVQCHUUQZUVQCHWGZUVRAUVQCHYOZUXKUXLWCZUCUDYPZYQZUDUV
        QYRUCUVQYRVULUWNAVUQUCUDUVQUVQAUWSUXHVUQUXQAUXHVUQUXHUXSAVUQUXTAUXRVUQU
        EUFWDWDUYDVUQUXRUYGUYHWCZUXAUXEWCZYQUYDVURVUSUYDVURUYLUYMWCVUSUYDUYGUYL
        UYHUYMVUFVUIYIABCDFGIUWTJUXDKLMNOPQRSTUAUUCUUDUUEUXRVUOVURVUPVUSUXBUXFU
        XKUYGUXLUYHVUJVUKUUFUWOUXAUWQUXEUUGUUHYJYKYLYMYNUUIUCUDUVQCHUUJYSAVUNUS
        WBZUXKWCZUCUVQWEZUSCYRZVUMUWNAVUTUYTWCZFWDWEZUSCYRZVVCAUYOVVFAUYRUYOVVF
        VNZUAAUWLUYRVVGUUKUWMBUSCDFGILNQSUULWFUUMUUNAVVEVVBUSCVVEVUTUYMWCZUFWDW
        EAVUTCUHZVNZVVBVVDVVHFUFWDFUFYPUYTUYMVUTUYSUXDLDUUOYTUUPVVJVVHVVBUFWDVV
        JUYBVNZVVBVVHUYMUXKWCZUCUVQWEZVVKUXEUVQUHUYMUYHWCZVVMVVJWDUVQUXDJVVJUXO
        WDUVQJYOAUXOVVIUXPWMWDUVQJUURWFUUSVVKUYHUYMAUYBVUGVVIVUHUUTUVAVVLVVNUCU
        XEUVQUWOUXEWCUXKUYHUYMUWOUXEHYHYTUVBUVCVVHVVAVVLUCUVQVUTUYMUXKUVDUVEYJU
        VFUVGUVHUVIUCUSUVQCHUVJYSUVQCHUVKYSUVQCMIHUWANUVLYSMIHUVMMIUVNUVO $.
    $}

    $( A cyclic group with ` n ` elements is isomorphic to ` ZZ / n ZZ ` , and
       an infinite cyclic group is isomorphic to ` ZZ / 0 ZZ ~~ ZZ ` .
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    cygzn $p |- ( G e. CycGrp -> G ~=g Y ) $=
      ( vg vn vx vm ccyg wcel cv cz cfv co cmpt crn eqid cmg wceq crab cgic wbr
      c0 wne wex cgrp iscyg2 simprbi n0 sylib wa czrh cop simpl simpr cygznlem3
      exlimddv ) BLMZHNZIOINJNBUAPZQRSAUBJAUCZMZBDUDUEHVAVDUFUGZVEHUHVABUIMVFJA
      VCIVDBEVCTZVDTZUJUKHVDULUMVAVEUNJAVCKIVDKOKNZDUOPZPVIVBVCQUPRSZBVJCVBDEFG
      VGVJTVHVAVEUQVAVEURVKTUSUT $.
  $}

  ${
    $d n G $.
    $( The "fundamental theorem of cyclic groups".  Cyclic groups are exactly
       the additive groups ` ZZ / n ZZ ` , for ` 0 <_ n ` (where ` n = 0 ` is
       the infinite cyclic group ` ZZ ` ), up to isomorphism.  (Contributed by
       Mario Carneiro, 21-Apr-2016.) $)
    cygth $p |- ( G e. CycGrp <-> E. n e. NN0 G ~=g ( Z/nZ ` n ) ) $=
      ( ccyg wcel czn cfv cgic wbr cn0 wrex cbs cfn chash cc0 cif hashcl adantl
      cv wn eqid wa 0nn0 a1i ifclda cygzn wceq fveq2 breq2d rspcev gicsym zncyg
      syl2anc giccyg syl5com syl5 rexlimiv impbii ) BCDZBARZEFZGHZAIJZURBKFZLDZ
      VCMFZNOZIDBVFEFZGHZVBURVDVENIVDVEIDURVCPQNIDURVDSUAUBUCUDVCBVFVGVCTVFTVGT
      UEVAVHAVFIUSVFUFUTVGBGUSVFEUGUHUIULVAURAIVAUTBGHZUSIDZURBUTUJVJUTCDVIURUS
      UTUTTUKUTBUMUNUOUPUQ $.
  $}

  ${
    cygctb.b $e |- B = ( Base ` G ) $.
    cygctb.c $e |- C = ( Base ` H ) $.
    $( Cyclic groups are isomorphic precisely when they have the same order.
       (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    cyggic $p |- ( ( G e. CycGrp /\ H e. CycGrp ) ->
      ( G ~=g H <-> B ~~ C ) ) $=
      ( ccyg wcel wa cgic wbr cfn chash cfv cc0 cif czn eqid cygzn adantl gicen
      cen ad2antrr enfi wceq hasheni eqidd ifbieq12d fveq2d ad2antlr gicsym syl
      wb eqbrtrd gictr syl2anc ex impbid2 ) CGHZDGHZIZCDJKZABUBKZABCDEFUAVAVCVB
      VAVCIZCALHZAMNZOPZQNZJKZVHDJKVBUSVIUTVCACVGVHEVGRVHRSUCVDVHBLHZBMNZOPZQNZ
      DJVDVGVLQVDVEVJVFOVKOVCVEVJUMVAABUDTVCVFVKUEVAABUFTVDOUGUHUIVDDVMJKZVMDJK
      UTVNUSVCBDVLVMFVLRVMRSUJDVMUKULUNCVHDUOUPUQUR $.
  $}

  ${
    $d f g n x y G $.  $d f g n x y I $.
    frgpcyg.g $e |- G = ( freeGrp ` I ) $.
    $( A free group is cyclic iff it has zero or one generator.  (Contributed
       by Mario Carneiro, 21-Apr-2016.) $)
    frgpcyg $p |- ( I ~<_ 1o <-> G e. CycGrp ) $=
      ( vx vn vf vg vy c1o wcel wceq cfv cvv eqid syl c1 ccnfld cz co adantr wo
      cdom wbr ccyg csdm cen brdom2 c0 sdom1 cfrgp fveq2 syl5eq cbs 0ex frgpgrp
      cgrp ax-mp 0frgp 0cyg mp2an syl6eqel sylbi cuni cvrgp relen brrelexi cefg
      cmg wf vrgpf csn wss en1b eqimss2 wb uniexg snssg mpbird ffvelrnd cv ccom
      wa cop cress cghm wrex wreu csubg csubrg zsubrg subrgsubg subggrp mp1i 1z
      wf1o f1osng sylancl f1of biimpi feq2d fss subrgbas frgpup3 syl3anc reurex
      snssi wi fveq1 fvco3 syl2anc fvsng eqeq12d syl5ib ad2antrr ghmf ffvelrnda
      ad2antrl an32s cmpt wral cid cres mptresid wrmo idghm fcoi2 feqmptd eqidd
      reurmo oveq1 fmptco mulgghm2 simprl eqeltrrd eleq2d oveq1d fveq2d eqeq1d
      ghmco coeq1 simprr mulg1 eqtrd elsni syl5ibrcom sylbid imp mpteq2dva rmoi
      3eqtr4d syl122anc mpteqb mprg sylib r19.21bi eqeq2d rspcev expr rexlimdva
      id syld mpd iscygd jaoi cabel cygabl wn frgpnabl con2i cfn ablgrp grpidcl
      c0g elbasfv 3syl com 1onn nnfi fidomtri2 impbii ) BIUBUCZAUDJZUWABIUEUCZB
      IUFUCZUAUWBBIUGUWCUWBUWDUWCBUHKZUWBBUIUWEAUHUJLZUDUWEABUJLUWFCBUHUJUKULUW
      FUPJZUWFUMLZIUFUCUWFUDJUHMJUWGUNUWFUHMUWFNZUOUQUWHUWFUWIUWHNZURUWHUWFUWJU
      SUTVAVBUWDDAUMLZAVHLZEABVCZBVDLZLZUWKNZUWLNZUWDBMJZAUPJZBIUFVEVFZABMCUOOZ
      UWDBUWKUWMUWNUWDUWRBUWKUWNVIZUWTBVGLZUWNABMUWKUXCNUWNNZCUWPVJOZUWDUWMBJZU
      WMVKZBVLZUWDBUXGKZUXHBVMZUXGBVNVBUWDUWMMJZUXFUXHVOUWDUWRUXKUWTBMVPOZUWMBM
      VQOVRZVSZUWDDVTZUWKJZWBZFVTZUWNWAZUWMPWCVKZKZFAQRWDSZWESZWFZUXOEVTZUWOUWL
      SZKZERWFZUXQUYAFUYCWGZUYDUWDUYIUXPUWDUYBUPJZUWRBRUXTVIZUYIRQWHLJZUYJUWDRQ
      WILJZUYLWJRQWKUQRQUYBUYBNZWLWMUWTUWDBPVKZUXTVIZUYORVLZUYKUWDUYPUXGUYOUXTV
      IZUWDUXGUYOUXTWOZUYRUWDUXKPRJZUYSUXLWNUWMPMRWPWQUXGUYOUXTWROUWDBUXGUYOUXT
      UWDUXIUXJWSZWTVRUYTUYQWNPRXFUQBUYORUXTXAWQRUWNFUXTAUYBBMCUYMRUYBUMLKWJRQU
      YBUYNXBUQZUXDXCXDTUYAFUYCXEOUXQUYAUYHFUYCUXQUXRUYCJZWBUYAUWOUXRLZPKZUYHUW
      DUYAVUEXGUXPVUCUYAUWMUXSLZUWMUXTLZKUWDVUEUWMUXSUXTXHUWDVUFVUDVUGPUWDUXBUX
      FVUFVUDKUXEUXMBUWKUWMUXRUWNXIXJUWDUXKUYTVUGPKUXLWNUWMPMRXKWQXLXMXNUXQVUCV
      UEUYHUXQVUCVUEWBZWBUXOUXRLZRJZUXOVUIUWOUWLSZKZUYHUWDVUHUXPVUJUWDVUHWBZUWK
      RUXOUXRVUCUWKRUXRVIUWDVUEAUYBUXRUWKRUWPVUBXOXQZXPZXRUWDVUHUXPVULVUMVULDUW
      KVUMDUWKUXOXSZDUWKVUKXSZKZVULDUWKXTZVUMVUPYAUWKYBZVUQDUWKYCVUMGVTZUWNWAZU
      WNKZGAAWESZYDZVUTVVDJZVUTUWNWAZUWNKZVUQVVDJVUQUWNWAZUWNKZVUTVUQKUWDVVEVUH
      UWDVVCGVVDWGZVVEUWDUWSUWRUXBVVKUXAUWTUXEUWKUWNGUWNAABMCUWPUXDXCXDVVCGVVDY
      IOTVUMUWSVVFUWDUWSVUHUXATZUWKAUWPYEOVUMUXBVVHUWDUXBVUHUXETZBUWKUWNYFOVUME
      RUYFXSZUXRWAZVUQVVDVUMDEUWKRVUIUYFVUKUXRVVNVUOVUMDUWKRUXRVUNYGVUMVVNYHUYE
      VUIUWOUWLYJZYKVUMVVNUYBAWESJZVUCVVOVVDJVUMUWSUWOUWKJZVVQVVLUWDVVRVUHUXNTZ
      UWKAUWLUWOEVVNUYBUYNUWQVVNNUWPYLXJUWDVUCVUEYMAUYBAVVNUXRYSXJYNVUMHBHVTZUW
      NLZUXRLZUWOUWLSZXSHBVWAXSVVIUWNVUMHBVWCVWAVUMVVTBJZVWCVWAKZVUMVWDVVTUXGJZ
      VWEVUMBUXGVVTUWDUXIVUHVUATYOVUMVWEVWFVUDUWOUWLSZUWOKVUMVWGPUWOUWLSZUWOVUM
      VUDPUWOUWLUWDVUCVUEUUAYPVUMVVRVWHUWOKVVSUWKUWLAUWOUWPUWQUUBOUUCVWFVWCVWGV
      WAUWOVWFVWBVUDUWOUWLVWFVWAUWOUXRVWFVVTUWMUWNVVTUWMUUDYQZYQYPVWIXLUUEUUFUU
      GUUHVUMHDBUWKVWAVUKVWCUWNVUQVUMBUWKVVTUWNVVMXPVUMHBUWKUWNVVMYGZVUMVUQYHUX
      OVWAKVUIVWBUWOUWLUXOVWAUXRUKYPYKVWJUUJVVCVVHVVJGVVDVUTVUQVVAVUTKVVBVVGUWN
      VVAVUTUWNYTYRVVAVUQKVVBVVIUWNVVAVUQUWNYTYRUUIUUKULUXPVURVUSVODUWKDUWKUXOV
      UKUWKUULUXPUUTUUMUUNUUOXRUYGVULEVUIRUYEVUIKUYFVUKUXOVVPUUPUUQXJUURUVAUUSU
      VBUVCUVDVBUWBAUVEJZUWAAUVFVWKUWAIBUEUCZUVGZVWLVWKABCUVHUVIVWKUWRIUVJJZUWA
      VWMVOVWKUWSAUVMLZUWKJUWRAUVKUWKAVWOUWPVWONUVLUWKAUJVWOBCUWPUVNUVOIUVPJVWN
      UVQIUVRUQBIMUVSWQVROUVT $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Generalized pre-Hilbert and Hilbert spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c PreHil $.
  $c .if $.

  $( Extend class notation with class all pre-Hilbert spaces. $)
  cphl $a class PreHil $.

  $( Extend class notation with inner product function. $)
  cipf $a class .if $.

  ${
    $d f g h v F $.  $d f g h v ., $.  $d f g h v x y V $.  $d f g h v x y W $.
    $d f g h v .* $.  $d f g h v .0. $.  $d f g h v Z $.
    $( Define class all generalized pre-Hilbert (inner product) spaces.
       (Contributed by NM, 22-Sep-2011.) $)
    df-phl $a |- PreHil = { g e. LVec |
      [. ( Base ` g ) / v ]. [. ( .i ` g ) / h ]. [. ( Scalar ` g ) / f ].
        ( f e. *Ring /\ A. x e. v
         ( ( y e. v |-> ( y h x ) ) e. ( g LMHom ( ringLMod ` f ) )
        /\ ( ( x h x ) = ( 0g ` f ) -> x = ( 0g ` g ) )
        /\ A. y e. v ( ( *r ` f ) ` ( x h y ) ) = ( y h x ) ) ) } $.

    $( Define group addition function.  Usually we will use ` +g ` directly
       instead of ` +f ` , and they have the same behavior in most cases.  The
       main advantage of ` +f ` is that it is a guaranteed function
       ( ~ mndplusf ), while ` +g ` only has closure ( ~ mndcl ).  (Contributed
       by Mario Carneiro, 12-Aug-2015.) $)
    df-ipf $a |- .if = ( g e. _V |->
      ( x e. ( Base ` g ) , y e. ( Base ` g ) |-> ( x ( .i ` g ) y ) ) ) $.

    isphl.v $e |- V = ( Base ` W ) $.
    isphl.f $e |- F = ( Scalar ` W ) $.
    isphl.h $e |- ., = ( .i ` W ) $.
    isphl.o $e |- .0. = ( 0g ` W ) $.
    isphl.i $e |- .* = ( *r ` F ) $.
    isphl.z $e |- Z = ( 0g ` F ) $.
    $( The predicate "is a generalized pre-Hilbert (inner product) space".
       (Contributed by NM, 22-Sep-2011.)  (Revised by Mario Carneiro,
       7-Oct-2015.) $)
    isphl $p |- ( W e. PreHil <-> ( W e. LVec /\ F e. *Ring /\ A. x e. V
          ( ( y e. V |-> ( y ., x ) ) e. ( W LMHom ( ringLMod ` F ) )
         /\ ( ( x ., x ) = Z -> x = .0. )
         /\ A. y e. V ( .* ` ( x ., y ) ) = ( y ., x ) ) ) ) $=
      ( wcel co cfv wceq fveq2d vf vv vh vg cphl clvec cv cmpt crglmod clmhm wi
      csr wral w3a wa c0g cstv csca wsbc cip cbs cvv fvex a1i id simpll syl6eqr
      sylan9eqr eleq1d simpllr simplll simplr mpteq12dv oveq12d eleq12d eqeq12d
      eqtrd oveqd eqeq2d imbi12d fveq12d raleqbidv anbi12d sbcied df-phl elrab2
      3anbi123d 3anass bitr4i ) GUEPGUFPZCULPZBFBUGZAUGZDQZUHZGCUIRZUJQZPZWMWMD
      QZISZWMHSZUKZWMWLDQZERZWNSZBFUMZUNZAFUMZUOZUOWJWKXHUNUAUGZULPZBUBUGZWLWMU
      CUGZQZUHZUDUGZXJUIRZUJQZPZWMWMXMQZXJUPRZSZWMXPUPRZSZUKZWMWLXMQZXJUQRZRZXN
      SZBXLUMZUNZAXLUMZUOZUAXPURRZUSZUCXPUTRZUSZUBXPVARZUSXIUDGUFUEXPGSZYQXIUBY
      RVBYRVBPYSXPVAVCVDYSXLYRSZUOZYOXIUCYPVBYPVBPUUAXPUTVCVDUUAXMYPSZUOZYMXIUA
      YNVBYNVBPUUCXPURVCVDUUCXJYNSZUOZXKWKYLXHUUEXJCULUUDUUCXJYNCUUDVEUUCYNGURR
      CUUCXPGURYSYTUUBVFTKVGVHZVIUUEYKXGAXLFUUEXLYRFYSYTUUBUUDVJUUEYRGVARFUUEXP
      GVAYSYTUUBUUDVKZTJVGVQZUUEXSWRYEXBYJXFUUEXOWOXRWQUUEBXLXNFWNUUHUUEXMDWLWM
      UUEXMYPDUUAUUBUUDVLUUEYPGUTRDUUEXPGUTUUGTLVGVQZVRZVMUUEXPGXQWPUJUUGUUEXJC
      UIUUFTVNVOUUEYBWTYDXAUUEXTWSYAIUUEXMDWMWMUUIVRUUEYACUPRIUUEXJCUPUUFTOVGVP
      UUEYCHWMUUEYCGUPRHUUEXPGUPUUGTMVGVSVTUUEYIXEBXLFUUHUUEYHXDXNWNUUEYFXCYGEU
      UEYGCUQREUUEXJCUQUUFTNVGUUEXMDWMWLUUIVRWAUUJVPWBWGWBWCWDWDWDABUBUAUDUCWEW
      FWJWKXHWHWI $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.  $d y G $.  $d x y ., $.  $d x y .* $.
    $d y F $.  $d x K $.  $d x .0. $.  $d x .x. $.  $d x y V $.  $d x y W $.
    $d x Z $.
    $( A pre-Hilbert space is a left vector space.  (Contributed by Mario
       Carneiro, 7-Oct-2015.) $)
    phllvec $p |- ( W e. PreHil -> W e. LVec ) $=
      ( vy vx cphl wcel clvec csca cfv csr cbs cv cip co cmpt crglmod clmhm c0g
      wceq wral eqid wi cstv w3a isphl simp1bi ) ADEAFEAGHZIEBAJHZBKZCKZALHZMZN
      AUFOHPMEUIUIUJMUFQHZRUIAQHZRUAUIUHUJMUFUBHZHUKRBUGSUCCUGSCBUFUJUNUGAUMULU
      GTUFTUJTUMTUNTULTUDUE $.

    $( A pre-Hilbert space is a left module.  (Contributed by Mario Carneiro,
       7-Oct-2015.) $)
    phllmod $p |- ( W e. PreHil -> W e. LMod ) $=
      ( cphl wcel clvec clmod phllvec lveclmod syl ) ABCADCAECAFAGH $.

    phlsrng.f $e |- F = ( Scalar ` W ) $.
    $( The scalar ring of a pre-Hilbert space is a star ring.  (Contributed by
       Mario Carneiro, 7-Oct-2015.) $)
    phlsrng $p |- ( W e. PreHil -> F e. *Ring ) $=
      ( vy vx cphl wcel clvec csr cbs cfv cv cip co cmpt crglmod wceq wral eqid
      c0g clmhm wi cstv w3a isphl simp2bi ) BFGBHGAIGDBJKZDLZELZBMKZNZOBAPKUANG
      UIUIUJNATKZQUIBTKZQUBUIUHUJNAUCKZKUKQDUGRUDEUGREDAUJUNUGBUMULUGSCUJSUMSUN
      SULSUEUF $.

    phllmhm.h $e |- ., = ( .i ` W ) $.
    phllmhm.v $e |- V = ( Base ` W ) $.
    ${
      phllmhm.g $e |- G = ( x e. V |-> ( x ., A ) ) $.
      $( The inner product of a pre-Hilbert space is linear in its left
         argument.  (Contributed by Mario Carneiro, 7-Oct-2015.) $)
      phllmhm $p |- ( ( W e. PreHil /\ A e. V ) ->
        G e. ( W LMHom ( ringLMod ` F ) ) ) $=
        ( vy wcel cv co cmpt cfv wral wceq eqid cphl crglmod clmhm c0g cstv w3a
        clvec csr isphl simp3bi simp1 ralimi syl oveq2 mpteq2dv syl6eqr rspccva
        wi eleq1d sylan ) GUAMZAFANZLNZEOZPZGCUBQUCOZMZLFRZBFMDVFMZVAVGVCVCEOCU
        DQZSVCGUDQZSURZVCVBEOCUEQZQVDSAFRZUFZLFRZVHVAGUGMCUHMVPLACEVMFGVKVJJHIV
        KTVMTVJTUIUJVOVGLFVGVLVNUKULUMVGVILBFVCBSZVEDVFVQVEAFVBBEOZPDVQAFVDVRVC
        BVBEUNUOKUPUSUQUT $.
    $}

    ${
      ipcl.f $e |- K = ( Base ` F ) $.
      $( Closure of the inner product operation in a pre-Hilbert space.
         (Contributed by Mario Carneiro, 7-Oct-2015.) $)
      ipcl $p |- ( ( W e. PreHil /\ A e. V /\ B e. V ) -> ( A ., B ) e. K ) $=
        ( vx cphl wcel co wa cv wral cfv cbs cmpt wf crglmod clmhm eqid phllmhm
        rlmbas eqtri lmhmf syl fmpt sylibr wceq oveq1 eleq1d sylan 3impa 3com23
        rspccva ) GMNZBFNZAFNZABDOZENZUTVAVBVDUTVAPZLQZBDOZENZLFRZVBVDVEFELFVGU
        AZUBZVIVEVJGCUCSZUDONVKLBCVJDFGHIJVJUEZUFFEGVLVJJECTSVLTSKCUGUHUIUJLFEV
        GVJVMUKULVHVDLAFVFAUMVGVCEVFABDUNUOUSUPUQUR $.
    $}

    ${
      ipcj.i $e |- .* = ( *r ` F ) $.
      $( Conjugate of an inner product in a pre-Hilbert space.  (Contributed by
         Mario Carneiro, 7-Oct-2015.) $)
      ipcj $p |- ( ( W e. PreHil /\ A e. V /\ B e. V ) ->
        ( .* ` ( A ., B ) ) = ( B ., A ) ) $=
        ( vx vy wcel co cfv wceq cv wral c0g cphl wa crglmod clmhm wi w3a clvec
        cmpt csr eqid isphl simp3bi simp3 ralimi syl oveq1 fveq2d oveq2 eqeq12d
        rspc2v syl5com 3impib ) GUANZAFNZBFNZABDOZEPZBADOZQZVCLRZMRZDOZEPZVKVJD
        OZQZMFSZLFSZVDVEUBVIVCMFVNUHGCUCPUDONZVJVJDOCTPZQVJGTPZQUEZVPUFZLFSZVQV
        CGUGNCUINWCLMCDEFGVTVSJHIVTUJKVSUJUKULWBVPLFVRWAVPUMUNUOVOVIAVKDOZEPZVK
        ADOZQLMABFFVJAQZVMWEVNWFWGVLWDEVJAVKDUPUQVJAVKDURUSVKBQZWEVGWFVHWHWDVFE
        VKBADURUQVKBADUPUSUTVAVB $.
    $}

    ${
      ip0l.z $e |- Z = ( 0g ` F ) $.
      $( Orthogonality (meaning inner product is 0) is commutative.
         (Contributed by NM, 17-Apr-2008.)  (Revised by Mario Carneiro,
         7-Oct-2015.) $)
      iporthcom $p |- ( ( W e. PreHil /\ A e. V /\ B e. V ) ->
        ( ( A ., B ) = Z <-> ( B ., A ) = Z ) ) $=
        ( wcel co cfv wceq 3ad2ant1 eqid syl stafval eqtrd cphl w3a cstf cbs wb
        wf1 wf1o phlsrng srngf1o f1of1 3syl ipcl clmod phllmod lmod0cl syl12anc
        csr f1fveq cstv ipcj srng0 eqeq12d bitr3d ) FUALZAELZBELZUBZABDMZCUCNZN
        ZGVINZOZVHGOZBADMZGOVGCUDNZVOVIUFZVHVOLZGVOLZVLVMUEVGCUQLZVOVOVIUGVPVDV
        EVSVFCFHUHPZVOCVIVIQZVOQZUIVOVOVIUJUKABCDVOEFHIJWBULZVGFUMLZVRVDVEWDVFF
        UNPCVOFGHWBKUORZVOVOVHGVIURUPVGVJVNVKGVGVJVHCUSNZNZVNVGVQVJWGOWCVHVOCVI
        WFWBWFQZWASRABCDWFEFHIJWHUTTVGVKGWFNZGVGVRVKWIOWEGVOCVIWFWBWHWASRVGVSWI
        GOVTCWFGWHKVARTVBVC $.

      ip0l.o $e |- .0. = ( 0g ` W ) $.
      $( Inner product with a zero first argument.  Part of proof of Theorem
         6.44 of [Ponnusamy] p. 361.  (Contributed by NM, 5-Feb-2007.)
         (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ip0l $p |- ( ( W e. PreHil /\ A e. V ) -> ( .0. ., A ) = Z ) $=
        ( vx cphl wcel co cfv wceq 3syl c0g wa cv clmod phllmod lmodgrp grpidcl
        cmpt cgrp adantr oveq1 eqid ovex fvmpt crglmod clmhm cghm phllmhm lmghm
        syl rlm0 eqtri ghmid eqtr3d ) ENOZADOZUAZFMDMUBZACPZUGZQZFACPZGVFFDOZVJ
        VKRVDVLVEVDEUCOEUHOVLEUDEUEDEFJLUFSUIMFVHVKDVIVGFACUJVIUKZFACULUMUSVFVI
        EBUNQZUOPOVIEVNUPPOVJGRMABVICDEHIJVMUQEVNVIUREVNVIFGLGBTQVNTQKBUTVAVBSV
        C $.

      $( Inner product with a zero second argument.  (Contributed by NM,
         5-Feb-2007.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ip0r $p |- ( ( W e. PreHil /\ A e. V ) -> ( A ., .0. ) = Z ) $=
        ( cphl wcel wa co cfv wceq adantr syl cstv ip0l fveq2d phllmod lmod0vcl
        clmod eqid ipcj 3expa an32s mpdan csr phlsrng srng0 3eqtr3d ) EMNZADNZO
        ZFACPZBUAQZQZGUTQZAFCPZGURUSGUTABCDEFGHIJKLUBUCURFDNZVAVCRZUREUFNZVDUPV
        FUQEUDSDEFJLUETUPVDUQVEUPVDUQVEFABCUTDEHIJUTUGZUHUIUJUKURBULNZVBGRUPVHU
        QBEHUMSBUTGVGKUNTUO $.

      $( The inner product of a vector with itself is zero iff the vector is
         zero.  Part of Definition 3.1-1 of [Kreyszig] p. 129.  (Contributed by
         NM, 24-Jan-2008.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ipeq0 $p |- ( ( W e. PreHil /\ A e. V ) ->
        ( ( A ., A ) = Z <-> A = .0. ) ) $=
        ( vx vy wcel co wceq cv wral cfv cphl wa wi cmpt crglmod clmhm cstv w3a
        clvec csr isphl simp3bi simp2 ralimi oveq12 anidms eqeq1d eqeq1 imbi12d
        eqid syl rspccva sylan ip0l oveq1 syl5ibrcom impbid ) EUAOZADOZUBZAACPZ
        GQZAFQZVHMRZVNCPZGQZVNFQZUCZMDSZVIVLVMUCZVHNDNRZVNCPZUDEBUETUFPOZVRVNWA
        CPBUGTZTWBQNDSZUHZMDSZVSVHEUIOBUJOWGMNBCWDDEFGJHILWDUTKUKULWFVRMDWCVRWE
        UMUNVAVRVTMADVNAQZVPVLVQVMWHVOVKGWHVOVKQVNAVNACUOUPUQVNAFURUSVBVCVJVLVM
        FACPZGQABCDEFGHIJKLVDVMVKWIGAFACVEUQVFVG $.
    $}

    ${
      $d x .+ $.
      ipdir.g $e |- .+ = ( +g ` W ) $.
      ipdir.p $e |- .+^ = ( +g ` F ) $.
      $( Distributive law for inner product.  Equation I3 of [Ponnusamy]
         p. 362.  (Contributed by NM, 25-Aug-2007.)  (Revised by Mario
         Carneiro, 7-Oct-2015.) $)
      ipdir $p |- ( ( W e. PreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( ( A .+ B ) ., C ) = ( ( A ., C ) .+^ ( B ., C ) ) ) $=
        ( vx wcel co cfv wceq syl cphl w3a wa cv cmpt crglmod cghm eqid phllmhm
        clmhm 3ad2antr3 lmghm simpr1 simpr2 cplusg rlmplusg eqtri syl3anc clmod
        ghmlin phllmod lmodvacl syl3an1 3adant3r3 oveq1 fvmpt3i oveq12d 3eqtr3d
        ovex ) IUAPZAHPZBHPZCHPZUBUCZABDQZOHOUDZCGQZUEZRZAVRRZBVRRZEQZVOCGQZACG
        QZBCGQZEQVNVRIFUFRZUGQPZVKVLVSWBSVNVRIWFUJQPZWGVJVKVMWHVLOCFVRGHIJKLVRU
        HZUIUKIWFVRULTVJVKVLVMUMZVJVKVLVMUNZDEIWFAVRBHLMEFUORWFUORNFUPUQUTURVNV
        OHPZVSWCSVJVKVLWLVMVJIUSPVKVLWLIVADHIABLMVBVCVDOVOVQWCHVRVPVOCGVEWIVPCG
        VIZVFTVNVTWDWAWEEVNVKVTWDSWJOAVQWDHVRVPACGVEWIWMVFTVNVLWAWESWKOBVQWEHVR
        VPBCGVEWIWMVFTVGVH $.

      $( Distributive law for inner product.  (Contributed by NM,
         20-Nov-2007.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ipdi $p |- ( ( W e. PreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( A ., ( B .+ C ) ) = ( ( A ., B ) .+^ ( A ., C ) ) ) $=
        ( wcel co cfv wceq syl3anc ipcj cphl wa cstv simpl simpr2 simpr3 simpr1
        w3a ipdir syl13anc fveq2d csr cbs phlsrng eqid ipcl srngadd eqtrd clmod
        adantr phllmod lmodvacl oveq12d 3eqtr3d ) IUAOZAHOZBHOZCHOZUHZUBZBCDPZA
        GPZFUCQZQZBAGPZVMQZCAGPZVMQZEPZAVKGPZABGPZACGPZEPVJVNVOVQEPZVMQZVSVJVLW
        CVMVJVEVGVHVFVLWCRVEVIUDZVEVFVGVHUEZVEVFVGVHUFZVEVFVGVHUGZBCADEFGHIJKLM
        NUIUJUKVJFULOZVOFUMQZOZVQWJOZWDVSRVEWIVIFIJUNUTVJVEVGVFWKWEWFWHBAFGWJHI
        JKLWJUOZUPSVJVEVHVFWLWEWGWHCAFGWJHIJKLWMUPSWJEFVMVOVQVMUOZWMNUQSURVJVEV
        KHOZVFVNVTRWEVJIUSOZVGVHWOVEWPVIIVAUTWFWGDHIBCLMVBSWHVKAFGVMHIJKLWNTSVJ
        VPWAVRWBEVJVEVGVFVPWARWEWFWHBAFGVMHIJKLWNTSVJVEVHVFVRWBRWEWGWHCAFGVMHIJ
        KLWNTSVCVD $.

      ip2di.1 $e |- ( ph -> W e. PreHil ) $.
      ip2di.2 $e |- ( ph -> A e. V ) $.
      ip2di.3 $e |- ( ph -> B e. V ) $.
      ip2di.4 $e |- ( ph -> C e. V ) $.
      ip2di.5 $e |- ( ph -> D e. V ) $.
      $( Distributive law for inner product.  (Contributed by NM,
         17-Apr-2008.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ip2di $p |- ( ph -> ( ( A .+ B ) ., ( C .+ D ) ) =
       ( ( ( A ., C ) .+^ ( B ., D ) ) .+^ ( ( A ., D ) .+^ ( B ., C ) ) ) ) $=
        ( cphl wcel wceq clmod phllmod syl lmodvacl syl3anc ipdir syl13anc ipdi
        ccmn cbs cfv csr crg phlsrng srngrng rngcmn 4syl eqid ipcl cmncom eqtrd
        co oveq12d cmn4 syl122anc 3eqtrd ) ABCFVFDEFVFZIVFZBVKIVFZCVKIVFZGVFZBD
        IVFZBEIVFZGVFZCEIVFZCDIVFZGVFZGVFZVPVSGVFVQVTGVFGVFZAKUBUCZBJUCZCJUCZVK
        JUCZVLVOUDQRSAKUEUCZDJUCZEJUCZWGAWDWHQKUFUGTUAFJKDENOUHUIBCVKFGHIJKLMNO
        PUJUKAVMVRVNWAGAWDWEWIWJVMVRUDQRTUABDEFGHIJKLMNOPULUKAVNVTVSGVFZWAAWDWF
        WIWJVNWKUDQSTUACDEFGHIJKLMNOPULUKAHUMUCZVTHUNUOZUCZVSWMUCZWKWAUDAWDHUPU
        CHUQUCWLQHKLURHUSHUTVAZAWDWFWIWNQSTCDHIWMJKLMNWMVBZVCUIZAWDWFWJWOQSUACE
        HIWMJKLMNWQVCUIZWMGHVTVSWQPVDUIVEVGAWLVPWMUCZVQWMUCZWOWNWBWCUDWPAWDWEWI
        WTQRTBDHIWMJKLMNWQVCUIAWDWEWJXAQRUABEHIWMJKLMNWQVCUIWSWRWMGHVTVPVQVSWQP
        VHVIVJ $.
    $}

    ${
      ipsubdir.m $e |- .- = ( -g ` W ) $.
      ipsubdir.s $e |- S = ( -g ` F ) $.
      $( Distributive law for inner product subtraction.  (Contributed by NM,
         20-Nov-2007.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ipsubdir $p |- ( ( W e. PreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( ( A .- B ) ., C ) = ( ( A ., C ) S ( B ., C ) ) ) $=
        ( wcel co wceq cfv syl3anc eqid cphl wa cplusg simpl cgrp clmod phllmod
        w3a adantr simpr1 simpr2 grpsubcl simpr3 ipdir syl13anc grpnpcan oveq1d
        lmodgrp syl eqtr3d cbs wb lmodfgrp ipcl grpsubadd mpbird eqcomd ) IUAOZ
        AHOZBHOZCHOZUHZUBZACFPZBCFPZDPZABGPZCFPZVMVPVRQZVRVOEUCRZPZVNQZVMVQBIUC
        RZPZCFPZWAVNVMVHVQHOZVJVKWEWAQVHVLUDZVMIUEOZVIVJWFVMIUFOZWHVHWIVLIUGUIZ
        IURUSZVHVIVJVKUJZVHVIVJVKUKZHIGABLMULSZWMVHVIVJVKUMZVQBCWCVTEFHIJKLWCTZ
        VTTZUNUOVMWDACFVMWHVIVJWDAQWKWLWMHWCIGABLWPMUPSUQUTVMEUEOZVNEVARZOZVOWS
        OZVRWSOZVSWBVBVMWIWRWJEIJVCUSVMVHVIVKWTWGWLWOACEFWSHIJKLWSTZVDSVMVHVJVK
        XAWGWMWOBCEFWSHIJKLXCVDSVMVHWFVKXBWGWNWOVQCEFWSHIJKLXCVDSWSVTEDVNVOVRXC
        WQNVEUOVFVG $.

      $( Distributive law for inner product subtraction.  (Contributed by NM,
         20-Nov-2007.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
      ipsubdi $p |- ( ( W e. PreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( A ., ( B .- C ) ) = ( ( A ., B ) S ( A ., C ) ) ) $=
        ( wcel co wceq cfv syl3anc eqid cphl w3a cplusg simpl simpr1 cgrp clmod
        wa phllmod adantr lmodgrp simpr2 simpr3 grpsubcl ipdi syl13anc grpnpcan
        syl oveq2d eqtr3d cbs wb lmodfgrp ipcl grpsubadd mpbird eqcomd ) IUAOZA
        HOZBHOZCHOZUBZUHZABFPZACFPZDPZABCGPZFPZVMVPVRQZVRVOEUCRZPZVNQZVMAVQCIUC
        RZPZFPZWAVNVMVHVIVQHOZVKWEWAQVHVLUDZVHVIVJVKUEZVMIUFOZVJVKWFVMIUGOZWIVH
        WJVLIUIUJZIUKURZVHVIVJVKULZVHVIVJVKUMZHIGBCLMUNSZWNAVQCWCVTEFHIJKLWCTZV
        TTZUOUPVMWDBAFVMWIVJVKWDBQWLWMWNHWCIGBCLWPMUQSUSUTVMEUFOZVNEVARZOZVOWSO
        ZVRWSOZVSWBVBVMWJWRWKEIJVCURVMVHVIVJWTWGWHWMABEFWSHIJKLWSTZVDSVMVHVIVKX
        AWGWHWNACEFWSHIJKLXCVDSVMVHVIWFXBWGWHWOAVQEFWSHIJKLXCVDSWSVTEDVNVOVRXCW
        QNVEUPVFVG $.

      ip2subdi.p $e |- .+ = ( +g ` F ) $.
      ip2subdi.1 $e |- ( ph -> W e. PreHil ) $.
      ip2subdi.2 $e |- ( ph -> A e. V ) $.
      ip2subdi.3 $e |- ( ph -> B e. V ) $.
      ip2subdi.4 $e |- ( ph -> C e. V ) $.
      ip2subdi.5 $e |- ( ph -> D e. V ) $.
      $( Distributive law for inner product subtraction.  (Contributed by Mario
         Carneiro, 8-Oct-2015.) $)
      ip2subdi $p |- ( ph -> ( ( A .- B ) ., ( C .- D ) ) =
        ( ( ( A ., C ) .+ ( B ., D ) ) S ( ( A ., D ) .+ ( B ., C ) ) ) ) $=
        ( co cbs cfv eqid crg wcel cabel clmod cphl phllmod lmodrng rngabl ipcl
        syl syl3anc ablsubsub4 oveq1d wceq lmodvsubcl ipsubdir syl13anc ipsubdi
        oveq12d cgrp rnggrp grpsubcl ablsubsub 3eqtrd rngacl abladdsub 3eqtr4d
        ) ABDIUDZBEIUDZGUDZCDIUDZGUDZCEIUDZFUDZVOVPVRFUDZGUDZVTFUDZBCJUDDEJUDZI
        UDZVOVTFUDWBGUDZAVSWCVTFAHUEUFZFHGVOVPVRWHUGZRQAHUHUIZHUJUIZALUKUIZWJAL
        ULUIZWLSLUMUQZHLMUNUQZHUOUQZAWMBKUIZDKUIZVOWHUIZSTUBBDHIWHKLMNOWIUPURZA
        WMWQEKUIZVPWHUIZSTUCBEHIWHKLMNOWIUPURZAWMCKUIZWRVRWHUIZSUAUBCDHIWHKLMNO
        WIUPURZUSUTAWFBWEIUDZCWEIUDZGUDZVQVRVTGUDZGUDWAAWMWQXDWEKUIZWFXIVASTUAA
        WLWRXAXKWNUBUCJKLDEOPVBURBCWEGHIJKLMNOPQVCVDAXGVQXHXJGAWMWQWRXAXGVQVAST
        UBUCBDEGHIJKLMNOPQVEVDAWMXDWRXAXHXJVASUAUBUCCDEGHIJKLMNOPQVEVDVFAWHFHGV
        QVRVTWIRQWPAHVGUIZWSXBVQWHUIAWJXLWOHVHUQWTXCWHHGVOVPWIQVIURXFAWMXDXAVTW
        HUIZSUAUCCEHIWHKLMNOWIUPURZVJVKAWKWSXMWBWHUIZWGWDVAWPWTXNAWJXBXEXOWOXCX
        FWHFHVPVRWIRVLURWHFHGVOVTWBWIRQVMVDVN $.
    $}

    ipdir.f $e |- K = ( Base ` F ) $.
    ${
      ipass.s $e |- .x. = ( .s ` W ) $.
      ipass.p $e |- .X. = ( .r ` F ) $.
      $( Associative law for inner product.  Equation I2 of [Ponnusamy]
         p. 363.  (Contributed by NM, 25-Aug-2007.)  (Revised by Mario
         Carneiro, 7-Oct-2015.) $)
      ipass $p |- ( ( W e. PreHil /\ ( A e. K /\ B e. V /\ C e. V ) ) ->
        ( ( A .x. B ) ., C ) = ( A .X. ( B ., C ) ) ) $=
        ( vx wcel co cfv cphl wa cmpt crglmod clmhm wceq eqid phllmhm 3ad2antr3
        cv simpr1 simpr2 cmulr cvsca rlmvsca eqtri lmhmlin syl3anc clmod adantr
        w3a phllmod lmodvscl oveq1 ovex fvmpt3i syl oveq2d 3eqtr3d ) JUARZAHRZB
        IRZCIRZVAZUBZABDSZQIQUJZCGSZUCZTZABVSTZESZVPCGSZABCGSZESVOVSJFUDTZUESRZ
        VKVLVTWBUFVJVKVMWFVLQCFVSGIJKLMVSUGZUHUIVJVKVLVMUKZVJVKVLVMULZHJWEDEIVS
        FABKNMOEFUMTWEUNTPFUOUPUQURVOVPIRZVTWCUFVOJUSRZVKVLWJVJWKVNJVBUTWHWIADF
        HIJBMKONVCURQVPVRWCIVSVQVPCGVDWGVQCGVEZVFVGVOWAWDAEVOVLWAWDUFWIQBVRWDIV
        SVQBCGVDWGWLVFVGVHVI $.

      ipassr.i $e |- .* = ( *r ` F ) $.
      $( "Associative" law for second argument of inner product (compare
         ~ ipass ).  (Contributed by NM, 25-Aug-2007.)  (Revised by Mario
         Carneiro, 7-Oct-2015.) $)
      ipassr $p |- ( ( W e. PreHil /\ ( A e. V /\ B e. V /\ C e. K ) ) ->
        ( A ., ( C .x. B ) ) = ( ( A ., B ) .X. ( .* ` C ) ) ) $=
        ( wcel co cphl w3a cfv simpl simpr3 simpr2 simpr1 ipass syl13anc fveq2d
        wa wceq clmod phllmod adantr lmodvscl syl3anc ipcj phlsrng ipcl srngmul
        csr 3eqtr3d oveq1d eqtrd ) KUASZAJSZBJSZCISZUBZUKZACBDTZGTZBAGTZHUCZCHU
        CZETZABGTZVPETVKVLAGTZHUCZCVNETZHUCZVMVQVKVSWAHVKVFVIVHVGVSWAULVFVJUDZV
        FVGVHVIUEZVFVGVHVIUFZVFVGVHVIUGZCBADEFGIJKLMNOPQUHUIUJVKVFVLJSZVGVTVMUL
        WCVKKUMSZVIVHWGVFWHVJKUNUOWDWECDFIJKBNLPOUPUQWFVLAFGHJKLMNRURUQVKFVBSZV
        IVNISZWBVQULVFWIVJFKLUSUOWDVKVFVHVGWJWCWEWFBAFGIJKLMNOUTUQIFEHCVNROQVAU
        QVCVKVOVRVPEVKVFVHVGVOVRULWCWEWFBAFGHJKLMNRURUQVDVE $.

      $( "Associative" law for inner product.  Conjugate version of ~ ipassr .
         (Contributed by NM, 25-Aug-2007.)  (Revised by Mario Carneiro,
         7-Oct-2015.) $)
      ipassr2 $p |- ( ( W e. PreHil /\ ( A e. V /\ B e. V /\ C e. K ) ) ->
        ( ( A ., B ) .X. C ) = ( A ., ( ( .* ` C ) .x. B ) ) ) $=
        ( wcel co cphl w3a wa cfv simpl simpr1 simpr2 csr phlsrng adantr simpr3
        wceq srngcl syl2anc ipassr syl13anc srngnvl oveq2d eqtr2d ) KUASZAJSZBJ
        SZCISZUBZUCZACHUDZBDTGTZABGTZVFHUDZETZVHCETVEUTVAVBVFISZVGVJULUTVDUEUTV
        AVBVCUFUTVAVBVCUGVEFUHSZVCVKUTVLVDFKLUIUJZUTVAVBVCUKZIFHCROUMUNABVFDEFG
        HIJKLMNOPQRUOUPVEVICVHEVEVLVCVICULVMVNIFHCROUQUNURUS $.
    $}
  $}

  ${
    $d g x y ., $.  $d g x y V $.  $d g x y W $.  $d x y X $.  $d x y Y $.
    ipffval.1 $e |- V = ( Base ` W ) $.
    ipffval.2 $e |- ., = ( .i ` W ) $.
    ipffval.3 $e |- .x. = ( .if ` W ) $.
    $( The inner product operation as a function.  (Contributed by Mario
       Carneiro, 12-Oct-2015.) $)
    ipffval $p |- .x. = ( x e. V , y e. V |-> ( x ., y ) ) $=
      ( vg cipf cfv cv cmpt2 cvv wcel wceq cbs cip c0 fveq2 syl6eqr mpt2eq123dv
      co oveqd df-ipf cxp crn csn cun wral cop df-ov fvrn0 eqeltri rgen2w fmpt2
      wf eqid mpbi fvex xpex rnex p0ex unex fex2 mp3an fvmpt fvprc mpt20 syl5eq
      wn mpt2eq12 syl2anc eqtr4d pm2.61i eqtri ) CFKLZABEEAMZBMZDUDZNZIFOPZVRWB
      QJFABJMZRLZWEVSVTWDSLZUDZNWBOKWDFQZABWEWEWGEEWAWHWEFRLZEWDFRUAGUBZWJWHWFD
      VSVTWHWFFSLZDWDFSUAHUBUEUCABJUFEEUGZDUHZTUIZUJZWBURZWLOPWOOPWBOPWAWOPZBEU
      KAEUKWPWQABEEWAVSVTULZDLWOVSVTDUMDWRUNUOUPABEEWAWOWBWBUSUQUTEEEWIOGFRVAUO
      ZWSVBWMWNDDWKOHFSVAUOVCVDVEWLWOWBOOVFVGVHWCVLZVRABTTWANZWBWTVRTXAFKVIABTW
      AVJUBWTETQZXBWBXAQWTEWITGFRVIVKZXCABEETTWAVMVNVOVPVQ $.

    $( The inner product operation as a function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    ipfval $p |- ( ( X e. V /\ Y e. V ) -> ( X .x. Y ) = ( X ., Y ) ) $=
      ( vx vy cv co oveq12 ipffval ovex ovmpt2a ) JKEFCCJLZKLZBMEFBMARESFBNJKAB
      CDGHIOEFBPQ $.

    $( If the inner product operation is already a function, the
       functionalization of it is equal to the original operation.
       (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    ipfeq $p |- ( ., Fn ( V X. V ) -> .x. = ., ) $=
      ( vx vy cxp wfn cv co cmpt2 wceq fnov biimpi ipffval syl6reqr ) BCCJKZBHI
      CCHLILBMNZATBUAOHICCBPQHIABCDEFGRS $.
  $}

  ${
    $d x y K $.  $d x y V $.  $d x y W $.
    ipffn.1 $e |- V = ( Base ` W ) $.
    ipffn.2 $e |- ., = ( .if ` W ) $.
    $( The inner product operation is a function.  (Contributed by Mario
       Carneiro, 20-Sep-2015.) $)
    ipffn $p |- ., Fn ( V X. V ) $=
      ( vx vy cv cip cfv co eqid ipffval ovex fnmpt2i ) FGBBFHZGHZCIJZKAFGARBCD
      RLEMPQRNO $.

    phlipf.s $e |- S = ( Scalar ` W ) $.
    phlipf.k $e |- K = ( Base ` S ) $.
    $( The inner product operation is a function.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    phlipf $p |- ( W e. PreHil -> ., : ( V X. V ) --> K ) $=
      ( vx vy cphl wcel cv cip cfv co wral cxp wf eqid 3expb ralrimivva ipffval
      ipcl fmpt2 sylib ) ELMZJNZKNZEOPZQZCMZKDRJDRDDSCBTUHUMJKDDUHUIDMUJDMUMUIU
      JAUKCDEHUKUAZFIUEUBUCJKDDULCBJKBUKDEFUNGUDUFUG $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ., $.  $d x V $.  $d x W $.
    ip2eq.h $e |- ., = ( .i ` W ) $.
    ip2eq.v $e |- V = ( Base ` W ) $.
    $( Two vectors are equal iff their inner products with all other vectors
       are equal.  (Contributed by NM, 24-Jan-2008.)  (Revised by Mario
       Carneiro, 7-Oct-2015.) $)
    ip2eq $p |- ( ( W e. PreHil /\ A e. V /\ B e. V ) -> ( A = B <->
      A. x e. V ( x ., A ) = ( x ., B ) ) ) $=
      ( wcel wceq co csg cfv eqid syl3an1 oveq1 syl c0g wb syl3anc cphl cv wral
      w3a oveq2 ralrimivw wi clmod phllmod lmodvsubcl eqeq12d rspcv simp1 simp2
      csca simp3 ipsubdi syl13anc eqeq1d ipeq0 syl2anc bitr3d cgrp cbs 3ad2ant1
      lmodfgrp ipcl grpsubeq0 lmodgrp 3bitr3d sylibd impbid2 ) FUAIZBEIZCEIZUDZ
      BCJZAUBZBDKZVRCDKZJZAEUCZVQWAAEBCVRDUEUFVPWBBCFLMZKZBDKZWDCDKZJZVQVPWDEIZ
      WBWGUGVMFUHIZVNVOWHFUIZWCEFBCHWCNZUJOZWAWGAWDEVRWDJVSWEVTWFVRWDBDPVRWDCDP
      UKULQVPWEWFFUOMZLMZKZWMRMZJZWDFRMZJZWGVQVPWDWDDKZWPJZWQWSVPWTWOWPVPVMWHVN
      VOWTWOJVMVNVOUMZWLVMVNVOUNZVMVNVOUPZWDBCWNWMDWCEFWMNZGHWKWNNZUQURUSVPVMWH
      XAWSSXBWLWDWMDEFWRWPXEGHWPNZWRNZUTVAVBVPWMVCIZWEWMVDMZIZWFXJIZWQWGSVPWIXI
      VMVNWIVOWJVEWMFXEVFQVPVMWHVNXKXBWLXCWDBWMDXJEFXEGHXJNZVGTVPVMWHVOXLXBWLXD
      WDCWMDXJEFXEGHXMVGTXJWMWNWEWFWPXMXGXFVHTVMFVCIZVNVOWSVQSVMWIXNWJFVIQEFWCB
      CWRHXHWKVHOVJVKVL $.
  $}

  ${
    $d q x y z ph $.  $d q w x y z W $.
    $( Set of vectors $)
    isphld.v $e |- ( ph -> V = ( Base ` W ) ) $.
    $( Vector addition $)
    isphld.a $e |- ( ph -> .+ = ( +g ` W ) ) $.
    $( Scalar product $)
    isphld.s $e |- ( ph -> .x. = ( .s ` W ) ) $.
    $( Inner product (Hermitian form) $)
    isphld.i $e |- ( ph -> I = ( .i ` W ) ) $.
    $( Zero vector $)
    isphld.z $e |- ( ph -> .0. = ( 0g ` W ) ) $.
    $( Set of scalars $)
    isphld.f $e |- ( ph -> F = ( Scalar ` W ) ) $.
    $( Division ring (skew field) base $)
    isphld.k $e |- ( ph -> K = ( Base ` F ) ) $.
    $( Division ring (skew field) plus $)
    isphld.p $e |- ( ph -> .+^ = ( +g ` F ) ) $.
    $( Division ring (skew field) times $)
    isphld.t $e |- ( ph -> .X. = ( .r ` F ) ) $.
    $( Involution (e.g. complex conjugate) $)
    isphld.c $e |- ( ph -> .* = ( *r ` F ) ) $.
    $( Division ring zero $)
    isphld.o $e |- ( ph -> O = ( 0g ` F ) ) $.
    isphld.l $e |- ( ph -> W e. LVec ) $.
    isphld.r $e |- ( ph -> F e. *Ring ) $.
    $( Closure of inner product $)
    isphld.cl $e |- ( ( ph /\ x e. V /\ y e. V ) -> ( x I y ) e. K ) $.
    $( Distributive law for inner product $)
    isphld.d $e |- ( ( ph /\ q e. K /\ ( x e. V /\ y e. V /\ z e. V ) ) ->
      ( ( ( q .x. x ) .+ y ) I z ) = ( ( q .X. ( x I z ) ) .+^ ( y I z ) ) ) $.
    $( Nonsingularity $)
    isphld.ns $e |- ( ( ph /\ x e. V /\ ( x I x ) = O ) -> x = .0. ) $.
    $( Conjugation law $)
    isphld.cj $e |- ( ( ph /\ x e. V /\ y e. V )
            -> ( .* ` ( x I y ) ) = ( y I x ) ) $.
    $( Properties that determine a pre-Hilbert (inner product) space.
       (Contributed by Mario Carneiro, 18-Nov-2013.)  (Revised by Mario
       Carneiro, 7-Oct-2015.) $)
    isphld $p |- ( ph -> W e. PreHil ) $=
      ( vw clvec wcel csca cfv csr cbs cv cip co cmpt crglmod clmhm c0g wceq wi
      cstv wral w3a cphl eqeltrrd wa oveq1 cbvmptv wf cvsca cplusg cmulr 3expib
      eleq2d anbi12d oveqd eqtrd eleq12d 3imtr3d impl an32s fmptd ralrimiva weq
      fveq2d oveq2 mpteq2dv feq1d rspccva sylan eqidd 3anrot 3anbi123d oveq123d
      3exp syl5bbr eqeq12d imbi12d imp31 3exp2 impancom 3imp2 clss lveclmod syl
      clmod adantr eqid lss1 sylancom ovex fvmpt3i simpr2 oveq2d simpr3 oveq12d
      lsscl 3eqtr4d ralrimivvva crg lmodrng rlmlmod 3syl rlmbas cvv fvex rlmsca
      wb ax-mp rlmplusg rlmvsca islmhm2 syl2anc mpbir3and eleq1d eqeq2d fveq12d
      syl5eqel imp expdimp ralrimiv 3jca isphl syl3anbrc ) AOUPUQZOURUSZUTUQCOV
      AUSZCVBZBVBZOVCUSZVDZVEZOUUPVFUSZVGVDZUQZUUSUUSUUTVDZUUPVHUSZVIZUUSOVHUSZ
      VIZVJZUUSUURUUTVDZUUPVKUSZUSZUVAVIZCUUQVLZVMZBUUQVLOVNUQUIAIUUPUTUCUJVOAU
      VQBUUQAUUSUUQUQZVPZUVEUVKUVPUVSUVBUOUUQUOVBZUUSUUTVDZVEZUVDCUOUUQUVAUWAUU
      RUVTUUSUUTVQVRAUOUUQUVTDVBZUUTVDZVEZUVDUQZDUUQVLUVRUWBUVDUQZAUWFDUUQAUWCU
      UQUQZVPZUWFUUQUUPVAUSZUWEVSZUUPUUPVIZQVBZUUSOVTUSZVDZUUROWAUSZVDZUWEUSZUW
      MUUSUWEUSZUUPWBUSZVDZUURUWEUSZUUPWAUSZVDZVIZCUUQVLBUUQVLQUWJVLZAUUQUWJUOU
      UQUVTUURUUTVDZVEZVSZCUUQVLUWHUWKAUXICUUQAUURUUQUQZVPBUUQUVLUWJUXHAUVRUXJU
      VLUWJUQZAUVRUXJUXKAUUSNUQZUURNUQZVPZUUSUURJVDZLUQZUVRUXJVPZUXKAUXLUXMUXPU
      KWCAUXLUVRUXMUXJANUUQUUSRWDZANUUQUURRWDZWEZAUXOUVLLUWJAJUUTUUSUURUAWFZALI
      VAUSUWJUDAIUUPVAUCWOWGZWHWIWJWKUOBUUQUXGUVLUVTUUSUURUUTVQVRWLWMUXIUWKCUWC
      UUQCDWNZUUQUWJUXHUWEUYCUOUUQUXGUWDUURUWCUVTUUTWPWQWRWSWTUWIUUPXAUWIUXEQBC
      UWJUUQUUQUWIUWMUWJUQZUVRUXJVMZVPZUWQUWCUUTVDZUWMUUSUWCUUTVDZUWTVDZUURUWCU
      UTVDZUXCVDZUWRUXDUWIUYDUVRUXJUYGUYKVIZAUYDUWHUVRUXJUYLVJVJAUYDVPUWHUVRUXJ
      UYLAUYDUWHUVRUXJVMZUYLAUWMLUQZUXLUXMUWCNUQZVMZUWMUUSGVDZUUREVDZUWCJVDZUWM
      UUSUWCJVDZHVDZUURUWCJVDZFVDZVIZVJUYDUYMUYLVJAUYNUYPVUDULXEALUWJUWMUYBWDAU
      YPUYMVUDUYLUYPUYOUXLUXMVMAUYMUYOUXLUXMXBAUYOUWHUXLUVRUXMUXJANUUQUWCRWDUXR
      UXSXCXFAUYSUYGVUCUYKAUYRUWQUWCUWCJUUTUAAUYQUWOUURUUREUWPSAGUWNUWMUUSTWFAU
      URXAXDAUWCXAXDAVUAUYIVUBUYJFUXCAFIWAUSUXCUEAIUUPWAUCWOWGAUWMUWMUYTUYHHUWT
      AHIWBUSUWTUFAIUUPWBUCWOWGAUWMXAAJUUTUUSUWCUAWFXDAJUUTUURUWCUAWFXDXGXHWIXI
      XJXKXLUYFUWQUUQUQZUWRUYGVIUWIUYEUUQOXMUSZUQZVUEUYFOXPUQZVUGUWIVUHUYEAVUHU
      WHAUUOVUHUIOXNXOZXQZXQVUFUUQOUUQXRZVUFXRZXSXOUWJUWPVUFUWNUUQUUPOUUSUURUWM
      UUPXRZUWJXRZUWPXRZUWNXRZVULYGXTUOUWQUWDUYGUUQUWEUVTUWQUWCUUTVQUWEXRZUVTUW
      CUUTYAZYBXOUYFUXAUYIUXBUYJUXCUYFUWSUYHUWMUWTUYFUVRUWSUYHVIUWIUYDUVRUXJYCU
      OUUSUWDUYHUUQUWEUVTUUSUWCUUTVQVUQVURYBXOYDUYFUXJUXBUYJVIUWIUYDUVRUXJYEUOU
      URUWDUYJUUQUWEUVTUURUWCUUTVQVUQVURYBXOYFYHYIUWIVUHUVCXPUQZUWFUWKUWLUXFVMY
      RVUJAVUSUWHAVUHUUPYJUQVUSVUIUUPOVUMYKUUPYLYMXQQBCUUQUWJUWPUXCOUVCUWNUWTUW
      JUWEUUPUUPVUKUUPYNVUMUUPYOUQUUPUVCURUSVIOURYPUUPYOYQYSVUNVUOUUPYTVUPUUPUU
      AUUBUUCUUDWMUWFUWGDUUSUUQDBWNZUWEUWBUVDVUTUOUUQUWDUWAUWCUUSUVTUUTWPWQUUEW
      SWTUUHAUVRUVKAUXLUUSUUSJVDZMVIZUUSPVIZVJUVRUVKAUXLVVBVVCUMXEUXRAVVBUVHVVC
      UVJAVVAUVFMUVGAJUUTUUSUUSUAWFAMIVHUSUVGUHAIUUPVHUCWOWGXGAPUVIUUSUBUUFXHWI
      UUIUVSUVOCUUQAUVRUXJUVOAUXNUXOKUSZUURUUSJVDZVIZUXQUVOAUXLUXMVVFUNWCUXTAVV
      DUVNVVEUVAAUXOUVLKUVMAKIVKUSUVMUGAIUUPVKUCWOWGUYAUUGAJUUTUURUUSUAWFXGWIUU
      JUUKUULWMBCUUPUUTUVMUUQOUVIUVGVUKVUMUUTXRUVIXRUVMXRUVGXRUUMUUN $.
  $}

  ${
    $d a b x y B $.  $d x y F $.  $d a b x y K $.  $d a b x y L $.  $d x y P $.
    $d a b x y ph $.
    phlpropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    phlpropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    phlpropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    phlpropd.4 $e |- ( ph -> F = ( Scalar ` K ) ) $.
    phlpropd.5 $e |- ( ph -> F = ( Scalar ` L ) ) $.
    phlpropd.6 $e |- P = ( Base ` F ) $.
    phlpropd.7 $e |- ( ( ph /\ ( x e. P /\ y e. B ) ) ->
      ( x ( .s ` K ) y ) = ( x ( .s ` L ) y ) ) $.
    phlpropd.8 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( .i ` K ) y ) = ( x ( .i ` L ) y ) ) $.
    $( If two structures have the same components (properties), one is a
       pre-Hilbert space iff the other one is.  (Contributed by Mario Carneiro,
       8-Oct-2015.) $)
    phlpropd $p |- ( ph -> ( K e. PreHil <-> L e. PreHil ) ) $=
      ( vb wcel cfv wceq va clvec csca csr cbs cv cip co cmpt crglmod clmhm c0g
      wi cstv wral w3a cphl lvecpropd eqtr3d eleq1d wa proplem mpteq2dva adantr
      anass1rs mpteq1d 3eqtr3d rlmbas eqtri a1i cvv fvex syl6eqel rlmsca cplusg
      syl eqidd cvsca lmhmpropd fveq2d oveq2d eleq12d eqeq12d grpidpropd eqeq2d
      anabsan2 imbi12d fveq12d anassrs ralbidva raleqdv 3bitr3d 3anbi123d isphl
      eqid 3bitr4g ) AGUBRZGUCSZUDRZQGUESZQUFZUAUFZGUGSZUHZUIZGWRUJSZUKUHZRZXBX
      BXCUHZWRULSZTZXBGULSZTZUMZXBXAXCUHZWRUNSZSZXDTZQWTUOZUPZUAWTUOZUPHUBRZHUC
      SZUDRZQHUESZXAXBHUGSZUHZUIZHYCUJSZUKUHZRZXBXBYFUHZYCULSZTZXBHULSZTZUMZXBX
      AYFUHZYCUNSZSZYGTZQYEUOZUPZUAYEUOZUPGUQRHUQRAWQYBWSYDYAUUDABCDEFGHIJKLMNO
      URAWRYCUDAFWRYCLMUSZUTAXTUADUOUUCUADUOYAUUDAXTUUCUADAXBDRZVAZXHYKXNYQXSUU
      BUUGXEYHXGYJUUGQDXDUIQDYGUIXEYHUUGQDXDYGAXADRZUUFXDYGTABCDDXCYFXAXBPVBVEZ
      VCUUGQDWTXDADWTTUUFIVDZVFUUGQDYEYGADYETUUFJVDZVFVGAXGYJTUUFAGFUJSZUKUHHUU
      LUKUHXGYJABCDEEEFFGUULHUULIEUULUESZTAEFUESUUMNFVHVIVJZJUUNLAFVKRFUULUCSTA
      FWRVKLGUCVLVMFVKVNVPZMUUONNKABUFZERCUFZERVAVAZUUPUUQUULVOSUHVQOUURUUPUUQU
      ULVRSUHVQVSAUULXFGUKAFWRUJLVTWAAUULYIHUKAFYCUJMVTWAVGVDWBUUGXKYNXMYPUUGXI
      YLXJYMAUUFXIYLTABCDDXCYFXBXBPVBWFAXJYMTUUFAWRYCULUUEVTVDWCUUGXLYOXBAXLYOT
      UUFABCDGHIJKWDVDWEWGUUGXRQDUOUUAQDUOXSUUBUUGXRUUAQDUUGUUHVAXQYTXDYGAUUFUU
      HXQYTTAUUFUUHVAZVAXOYRXPYSAXPYSTUUSAWRYCUNUUEVTVDABCDDXCYFXBXAPVBWHWIUUIW
      CWJUUGXRQDWTUUJWKUUGUUAQDYEUUKWKWLWMWJAXTUADWTIWKAUUCUADYEJWKWLWMUAQWRXCX
      PWTGXLXJWTWOWRWOXCWOXLWOXPWOXJWOWNUAQYCYFYSYEHYOYMYEWOYCWOYFWOYOWOYSWOYMW
      OWNWP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Orthocomplements and closed subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ocv $.
  $c CSubSp $.
  $c toHL $.

  $( Extend class notation with orthocomplement of a subspace. $)
  cocv $a class ocv $.

  $( Extend class notation with set of closed subspaces. $)
  ccss $a class CSubSp $.

  $( Extend class notation with the Hilbert lattice. $)
  cthl $a class toHL $.

  ${
    $d h s x y $.
    $( Define orthocomplement of a subspace.  (Contributed by NM,
       7-Oct-2011.) $)
    df-ocv $a |- ocv = ( h e. _V |-> ( s e. ~P ( Base ` h ) |->
   { x e. ( Base ` h ) | A. y e. s ( x ( .i ` h ) y )
           = ( 0g ` ( Scalar ` h ) ) } ) ) $.

    $( Define set of closed subspaces.  (Contributed by NM, 7-Oct-2011.) $)
    df-css $a |- CSubSp = ( h e. _V |->
      { s | s = ( ( ocv ` h ) ` ( ( ocv ` h ) ` s ) ) } ) $.
  $}

  $( Define the Hilbert lattice of closed subspaces.  (Contributed by Mario
     Carneiro, 25-Oct-2015.) $)
  df-thl $a |- toHL = ( h e. _V |-> ( ( toInc ` ( CSubSp ` h ) ) sSet
    <. ( oc ` ndx ) , ( ocv ` h ) >. ) ) $.

  ${
    $d h s x y .0. $.  $d x y A $.  $d x B $.  $d h s x y V $.  $d h s x y W $.
    $d h s x y ., $.  $d s x y S $.
    ocvfval.v $e |- V = ( Base ` W ) $.
    ocvfval.i $e |- ., = ( .i ` W ) $.
    ocvfval.f $e |- F = ( Scalar ` W ) $.
    ocvfval.z $e |- .0. = ( 0g ` F ) $.
    ocvfval.o $e |- ._|_ = ( ocv ` W ) $.
    $( The orthocomplement operation.  (Contributed by NM, 7-Oct-2011.)
       (Revised by Mario Carneiro, 13-Oct-2015.) $)
    ocvfval $p |- ( W e. X -> ._|_ = ( s e. ~P V |->
                          { x e. V | A. y e. s ( x ., y ) = .0. } ) ) $=
      ( wcel cfv cv wceq cvv vh cocv cpw wral crab cmpt elex cbs cip csca fveq2
      c0g syl6eqr pweqd oveqd fveq2d eqeq12d ralbidv rabeqbidv mpteq12dv df-ocv
      co wf eqid wss ssrab2 fvex eqeltri elpw2 mpbir a1i fmpti pwex mp3an fvmpt
      fex2 syl syl5eq ) GHPZEGUBQZJFUCZARZBRZDVBZISZBJRZUDZAFUEZUFZOVSGTPVTWISG
      HUGUAGJUARZUHQZUCZWBWCWJUIQZVBZWJUJQZULQZSZBWFUDZAWKUEZUFWITUBWJGSZJWLWSW
      AWHWTWKFWTWKGUHQZFWJGUHUKKUMZUNWTWRWGAWKFXBWTWQWEBWFWTWNWDWPIWTWMDWBWCWTW
      MGUIQDWJGUIUKLUMUOWTWPCULQIWTWOCULWTWOGUJQCWJGUJUKMUMUPNUMUQURUSUTABUAJVA
      WAWAWIVCWATPZXCWITPJWAWAWHWIWIVDWHWAPZWFWAPXDWHFVEWGAFVFWHFFXATKGUHVGVHZV
      IVJVKVLFXEVMZXFWAWAWITTVPVNVOVQVR $.

    $( Value of the orthocomplement of a subset (normally a subspace) of a
       pre-Hilbert space.  (Contributed by NM, 7-Oct-2011.)  (Revised by Mario
       Carneiro, 13-Oct-2015.) $)
    ocvval $p |- ( S C_ V ->
      ( ._|_ ` S ) = { x e. V | A. y e. S ( x ., y ) = .0. } ) $=
      ( vs cfv cv wceq cbs c0 wss cpw wcel co wral crab fvex eqeltri elpw2 cmpt
      cvv ocvfval fveq1d raleq rabbidv eqid rabex fvmpt sylan9eq 0fv cocv fvprc
      wn syl5eq ssrab2 sseq0 sylancr 3eqtr4a adantr pm2.61ian sylbir ) CGUACGUB
      ZUCZCFPZAQBQEUDIRZBCUEZAGUFZRZCGGHSPZUKJHSUGUHZUIHUKUCZVMVRWAVMVNCOVLVOBO
      QZUEZAGUFZUJZPVQWACFWEABDEFGHUKIOJKLMNULUMOCWDVQVLWEWBCRWCVPAGVOBWBCUNUOW
      EUPVPAGVTUQURUSWAVCZVRVMWFCTPTVNVQCUTWFCFTWFFHVAPTNHVAVBVDUMWFVQGUAGTRVQT
      RVPAGVEWFGVSTJHSVBVDVQGVFVGVHVIVJVK $.

    $( Elementhood in the orthocomplement of a subset (normally a subspace) of
       a pre-Hilbert space.  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    elocv $p |- ( A e. ( ._|_ ` S ) <->
        ( S C_ V /\ A e. V /\ A. x e. S ( A ., x ) = .0. ) ) $=
      ( vs vy cfv wcel wceq c0 wss cv wral w3a cdm cpw elfvdm crab cmpt cvv n0i
      co wa wn cocv fvprc syl5eq fveq1d 0fv syl6eq nsyl2 ocvfval syl dmeqd fvex
      cbs eqeltri rabex eqid dmmpti eleqtrd elpwid ocvval eleq2d eqeq1d ralbidv
      oveq1 elrab syl6bb biadan2 3anass bitr4i ) BCFQZRZCGUAZBGRZBAUBZEULZISZAC
      UCZUMZUMWEWFWJUDWDWEWKWDCGWDCFUEZGUFZBCFUGWDWLOWMPUBZWGEULZISZAOUBUCZPGUH
      ZUIZUEWMWDFWSWDHUJRZFWSSWDWCTSWTWCBUKWTUNZWCCTQTXACFTXAFHUOQTNHUOUPUQURCU
      SUTVAPADEFGHUJIOJKLMNVBVCVDOWMWRWSWQPGGHVFQUJJHVFVEVGVHWSVIVJUTVKVLWEWDBW
      PACUCZPGUHZRWKWEWCXCBPACDEFGHIJKLMNVMVNXBWJPBGWNBSZWPWIACXDWOWHIWNBWGEVQV
      OVPVRVSVTWEWFWJWAWB $.

    $( Property of a member of the orthocomplement of a subset.  (Contributed
       by Mario Carneiro, 13-Oct-2015.) $)
    ocvi $p |- ( ( A e. ( ._|_ ` S ) /\ B e. S ) -> ( A ., B ) = .0. ) $=
      ( vx cfv wcel cv co wceq wral elocv simp3bi oveq2 eqeq1d rspccva sylan
      wss ) ACFPQZAORZESZITZOCUAZBCQABESZITZUICGUHAGQUMOACDEFGHIJKLMNUBUCULUOOB
      CUJBTUKUNIUJBAEUDUEUFUG $.
  $}

  ${
    $d r x y z ._|_ $.  $d r x y z S $.  $d r x y z V $.  $d r x y z W $.
    ocvss.v $e |- V = ( Base ` W ) $.
    ocvss.o $e |- ._|_ = ( ocv ` W ) $.
    $( The orthocomplement of a subset is a subset of the base.  (Contributed
       by Mario Carneiro, 13-Oct-2015.) $)
    ocvss $p |- ( ._|_ ` S ) C_ V $=
      ( vx vy cfv cv wcel wss cip co csca c0g wceq wral eqid elocv simp2bi
      ssriv ) GABIZCGJZUCKACLUDCKUDHJDMIZNDOIZPIZQHARHUDAUFUEBCDUGEUESUFSUGSFTU
      AUB $.

    $( A set is contained in its double orthocomplement.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    ocvocv $p |- ( ( W e. PreHil /\ S C_ V ) ->
      S C_ ( ._|_ ` ( ._|_ ` S ) ) ) $=
      ( vx vy cphl wcel wss wa cfv cv cip co csca wceq sselda eqid c0g wral a1i
      ocvss simpr ocvi ancoms adantll wb simplll adantr iporthcom syl3anc mpbid
      ralrimiva elocv syl3anbrc ex ssrdv ) DIJZACKZLZGAABMZBMZVBGNZAJZVEVDJZVBV
      FLZVCCKZVECJZVEHNZDOMZPDQMZUAMZRZHVCUBVGVIVHABCDEFUDUCZVBACVEUTVAUESZVHVO
      HVCVHVKVCJZLZVKVEVLPVNRZVOVFVRVTVBVRVFVTVKVEAVMVLBCDVNEVLTZVMTZVNTZFUFUGU
      HVSUTVKCJVJVTVOUIUTVAVFVRUJVHVCCVKVPSVHVJVRVQUKVKVEVMVLCDVNWBWAEWCULUMUNU
      OHVEVCVMVLBCDVNEWAWBWCFUPUQURUS $.

    ocvlss.l $e |- L = ( LSubSp ` W ) $.
    $( The orthocomplement of a subset is a linear subspace of the pre-Hilbert
       space.  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    ocvlss $p |- ( ( W e. PreHil /\ S C_ V ) -> ( ._|_ ` S ) e. L ) $=
      ( vr vy vz vx wcel wa cfv co wral wceq adantr eqid cphl wss c0 wne cplusg
      cv cvsca cbs ocvss a1i c0g cip simpr clmod phllmod lmod0vcl simpll sselda
      csca syl ip0l syl2anc ralrimiva elocv syl3anbrc ne0i simpr1 simpr2 sseldi
      lmodvscl syl3anc simpr3 lmodvacl adantlr ipdir syl13anc cmulr ipass sylan
      w3a ocvi oveq2d lmodrng rngrz 3eqtrd oveq12d cgrp lmodfgrp grpidcl grplid
      crg mpdan 3syl ralrimivvva islss ) EUAMZADUBZNZACOZDUBZWSUCUDZIUFZJUFZEUG
      OZPZKUFZEUEOZPZWSMZKWSQJWSQIEUSOZUHOZQWSBMWTWRACDEFGUIZUJWREUKOZWSMZXAWRW
      QXMDMZXMLUFZEULOZPXJUKOZRZLAQXNWPWQUMZWREUNMZXOWPYAWQEUOSZDEXMFXMTZUPUTWR
      XSLAWRXPAMZNWPXPDMZXSWPWQYDUQZWRADXPXTURZXPXJXQDEXMXRXJTZXQTZFXRTZYCVAVBV
      CLXMAXJXQCDEXRFYIYHYJGVDVEWSXMVFUTWRXIIJKXKWSWSWRXBXKMZXCWSMZXFWSMZVTZNZW
      QXHDMZXHXPXQPZXRRZLAQXIWRWQYNXTSYOYAXEDMZXFDMZYPWRYAYNYBSZYOYAYKXCDMZYSUU
      AWRYKYLYMVGZYOWSDXCXLWRYKYLYMVHZVIZXBXDXJXKDEXCFYHXDTZXKTZVJVKZYOWSDXFXLW
      RYKYLYMVLZVIZXGDEXEXFFXGTZVMVKYOYRLAYOYDNZYQXEXPXQPZXFXPXQPZXJUEOZPZXRXRU
      UOPZXRUULWPYSYTYEYQUUPRWRYDWPYNYFVNZYOYSYDUUHSYOYTYDUUJSWRYDYEYNYGVNZXEXF
      XPXGUUOXJXQDEYHYIFUUKUUOTZVOVPUULUUMXRUUNXRUUOUULUUMXBXCXPXQPZXJVQOZPZXBX
      RUVBPZXRUULWPYKUUBYEUUMUVCRUURYOYKYDUUCSZYOUUBYDUUESUUSXBXCXPXDUVBXJXQXKD
      EYHYIFUUGUUFUVBTZVRVPUULUVAXRXBUVBYOYLYDUVAXRRUUDXCXPAXJXQCDEXRFYIYHYJGWA
      VSWBUULXJWKMZYKUVDXRRUULYAUVGYOYAYDUUASZXJEYHWCUTUVEXKXJUVBXBXRUUGUVFYJWD
      VBWEYOYMYDUUNXRRUUIXFXPAXJXQCDEXRFYIYHYJGWAVSWFUULYAXJWGMZUUQXRRZUVHXJEYH
      WHUVIXRXKMUVJXKXJXRUUGYJWIXKUUOXJXRXRUUGUUTYJWJWLWMWEVCLXHAXJXQCDEXRFYIYH
      YJGVDVEWNIXKXGBXDWSXJDEJKYHUUGFUUKUUFHWOVE $.
  $}

  ${
    $d x L $.  $d x ._|_ $.  $d x y S $.  $d x y T $.  $d x y W $.  $d x .0. $.
    ocv2ss.o $e |- ._|_ = ( ocv ` W ) $.
    $( Orthocomplements reverse subset inclusion.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    ocv2ss $p |- ( T C_ S -> ( ._|_ ` S ) C_ ( ._|_ ` T ) ) $=
      ( vx vy wss cfv cbs cv wcel cip co csca c0g wral w3a eqid elocv sstr2 idd
      wceq ssralv 3anim123d 3imtr4g ssrdv ) BAHZFACIZBCIZUHADJIZHZFKZUKLZUMGKDM
      IZNDOIZPIZUCZGAQZRBUKHZUNURGBQZRUMUILUMUJLUHULUTUNUNUSVABAUKUAUHUNUBURGBA
      UDUEGUMAUPUOCUKDUQUKSZUOSZUPSZUQSZETGUMBUPUOCUKDUQVBVCVDVEETUFUG $.

    ocvin.l $e |- L = ( LSubSp ` W ) $.
    ocvin.z $e |- .0. = ( 0g ` W ) $.
    $( An orthocomplement has trivial intersection with the original subspace.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    ocvin $p |- ( ( W e. PreHil /\ S e. L ) ->
      ( S i^i ( ._|_ ` S ) ) = { .0. } ) $=
      ( vx cphl wcel wa cfv cin csn cv wceq eqid syl2anc wss cip co csca ancoms
      c0g cbs ocvi adantl wb simpll lssel ad2ant2lr ipeq0 mpbid ex elin 3imtr4g
      elsn ssrdv clmod phllmod adantr lssss ocvlss sylan2 lssincl syl3an1 eqssd
      mpd3an3 lss0ss ) DJKZABKZLZAACMZNZEOZVMIVOVPVMIPZAKZVQVNKZLZVQEQZVQVOKVQV
      PKVMVTWAVMVTLZVQVQDUAMZUBDUCMZUEMZQZWAVTWFVMVSVRWFVQVQAWDWCCDUFMZDWEWGRZW
      CRZWDRZWERZFUGUDUHWBVKVQWGKZWFWAUIVKVLVTUJVLVRWLVKVSBAWGDVQWHGUKULVQWDWCW
      GDEWEWJWIWHWKHUMSUNUOVQAVNUPIEURUQUSVMDUTKZVOBKZVPVOTVKWMVLDVAZVBVKVLVNBK
      ZWNVLVKAWGTWPBAWGDWHGVCABCWGDWHFGVDVEVKWMVLWPWNWOBAVNDGVFVGVIBDVOEHGVJSVH
      $.
  $}

  ${
    ocvlsp.v $e |- V = ( Base ` W ) $.
    ocvlsp.o $e |- ._|_ = ( ocv ` W ) $.
    $( Two ways to say that ` S ` and ` T ` are orthogonal subspaces.
       (Contributed by Mario Carneiro, 23-Oct-2015.) $)
    ocvsscon $p |- ( ( W e. PreHil /\ S C_ V /\ T C_ V ) ->
      ( S C_ ( ._|_ ` T ) <-> T C_ ( ._|_ ` S ) ) ) $=
      ( cphl wcel wss w3a cfv ocvocv 3adant2 ocv2ss sstr2 syl2im 3adant3 impbid
      ) EHIZADJZBDJZKZABCLZJZBACLZJZUCBUDCLZJZUEUHUFJUGTUBUIUABCDEFGMNUDACEGOBU
      HUFPQUCAUFCLZJZUGUJUDJUETUAUKUBACDEFGMRUFBCEGOAUJUDPQS $.

    ocvlsp.n $e |- N = ( LSpan ` W ) $.
    $( The orthocomplement of a linear span.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    ocvlsp $p |- ( ( W e. PreHil /\ S C_ V ) ->
      ( ._|_ ` ( N ` S ) ) = ( ._|_ ` S ) ) $=
      ( cphl wcel wss wa cfv clmod phllmod lspssid ocv2ss syl ocvocv syldan a1i
      sylan ocvss clss adantr eqid ocvlss lspssp syl3anc sstrd eqssd ) EIJZADKZ
      LZABMZCMZACMZUNAUOKZUPUQKULENJZUMUREOZABDEFHPUBUOACEGQRUNUQUQCMZCMZUPULUM
      UQDKZUQVBKVCUNACDEFGUCUAZUQCDEFGSTUNUOVAKZVBUPKUNUSVAEUDMZJZAVAKVEULUSUMU
      TUEULUMVCVGVDUQVFCDEFGVFUFZUGTACDEFGSVFAVABEVHHUHUIVAUOCEGQRUJUK $.
  $}

  ${
    $d x y V $.  $d x y W $.
    ocvz.v $e |- V = ( Base ` W ) $.
    ocvz.o $e |- ._|_ = ( ocv ` W ) $.
    $( The orthocomplement of the empty set.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    ocv0 $p |- ( ._|_ ` (/) ) = V $=
      ( vx vy c0 cfv cv cip co csca c0g wceq wral crab wss 0ss eqid ocvval ral0
      ax-mp rgenw rabid2 mpbir eqtr4i ) HAIZFJGJCKIZLCMIZNIZOZGHPZFBQZBHBRUHUNO
      BSFGHUJUIABCUKDUITUJTUKTEUAUCBUNOUMFBPUMFBULGUBUDUMFBUEUFUG $.

    ocvz.z $e |- .0. = ( 0g ` W ) $.
    $( The orthocomplement of the zero subspace.  (Contributed by Mario
       Carneiro, 23-Oct-2015.) $)
    ocvz $p |- ( W e. PreHil -> ( ._|_ ` { .0. } ) = V ) $=
      ( cphl wcel c0 clspn cfv csn clmod wceq phllmod eqid lsp0 syl fveq2d ocv0
      wss 0ss ocvlsp mpan2 syl6eq eqtr3d ) CHIZJCKLZLZALZDMZALBUHUJULAUHCNIUJUL
      OCPUICDGUIQZRSTUHUKJALZBUHJBUBUKUNOBUCJUIABCEFUMUDUEABCEFUAUFUG $.

    $( The orthocomplement of the base set.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    ocv1 $p |- ( W e. PreHil -> ( ._|_ ` V ) = { .0. } ) $=
      ( cphl wcel cfv cin csn wss wceq ocvss dfss1 mpbi clss clmod phllmod eqid
      lss1 syl ocvin mpdan syl5eqr ) CHIZBAJZBUHKZDLZUHBMUIUHNBABCEFOUHBPQUGBCR
      JZIZUIUJNUGCSIULCTUKBCEUKUAZUBUCBUKACDFUMGUDUEUF $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d z ._|_ $.  $d x y z V $.  $d x y W $.
    inocv.o $e |- ._|_ = ( ocv ` W ) $.
    $( The orthocomplement of a union.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    unocv $p |- ( ._|_ ` ( A u. B ) ) = ( ( ._|_ ` A ) i^i ( ._|_ ` B ) ) $=
      ( vz vy cfv cv wcel wss wral anbi12i bitri w3a eqid elocv 3anan12 3bitr4i
      wa cun cin cbs cip co csca c0g wceq unss bicomi ralunb anbi2i elin anandi
      an4 eqriv ) FABUAZCHZACHZBCHZUBZFIZDUCHZJZUQVCKZVBGIDUDHZUEDUFHZUGHZUHZGU
      QLZTZTZVDAVCKZVIGALZTZBVCKZVIGBLZTZTZTZVBURJZVBVAJZVKVSVDVKVMVPTZVNVQTZTV
      SVEWCVJWDWCVEABVCUIUJVIGABUKMVMVPVNVQUONULWAVEVDVJOVLGVBUQVGVFCVCDVHVCPZV
      FPZVGPZVHPZEQVEVDVJRNVBUSJZVBUTJZTVDVOTZVDVRTZTWBVTWIWKWJWLWIVMVDVNOWKGVB
      AVGVFCVCDVHWEWFWGWHEQVMVDVNRNWJVPVDVQOWLGVBBVGVFCVCDVHWEWFWGWHEQVPVDVQRNM
      VBUSUTUMVDVOVRUNSSUP $.

    iunocv.v $e |- V = ( Base ` W ) $.
    $( The orthocomplement of an indexed union.  (Contributed by Mario
       Carneiro, 23-Oct-2015.) $)
    iunocv $p |- ( ._|_ ` U_ x e. A B ) = ( V i^i |^|_ x e. A ( ._|_ ` B ) ) $=
      ( vz vy cfv cv wcel wss wral wa wi wal bitri eqid ciun ciin cin csca wceq
      cip co iunss wrex eliun imbi1i r19.23v bitr4i albii df-ral ralbii ralcom4
      c0g 3bitr4i anbi12i r19.26 eliin elocv 3anan12 baib ralbidv bitr2d syl5bb
      w3a pm5.32i elin eqriv ) IABCUAZDKZEABCDKZUBZUCZILZEMZVMENZVRJLZFUFKZUGFU
      DKZURKZUEZJVMOZPZPZVSVRVPMZPVRVNMZVRVQMVSWGWIWGCENZWEJCOZPZABOZVSWIWGWKAB
      OZWLABOZPWNVTWOWFWPABCEUHWAVMMZWEQZJRWACMZWEQZABOZJRZWFWPWRXAJWRWSABUIZWE
      QXAWQXCWEAWABCUJUKWSWEABULUMUNWEJVMUOWPWTJRZABOXBWLXDABWEJCUOUPWTAJBUQSUS
      UTWKWLABVAUMVSWIVRVOMZABOWNAVRBVOEVBVSXEWMABXEVSWMXEWKVSWLVIVSWMPJVRCWCWB
      DEFWDHWBTZWCTZWDTZGVCWKVSWLVDSVEVFVGVHVJWJVTVSWFVIWHJVRVMWCWBDEFWDHXFXGXH
      GVCVTVSWFVDSVREVPVKUSVL $.
  $}

  ${
    $d s w ._|_ $.  $d s S $.  $d s w W $.
    cssval.o $e |- ._|_ = ( ocv ` W ) $.
    cssval.c $e |- C = ( CSubSp ` W ) $.
    $( The set of closed subspaces of a pre-Hilbert space.  (Contributed by NM,
       7-Oct-2011.)  (Revised by Mario Carneiro, 13-Oct-2015.) $)
    cssval $p |- ( W e. X -> C = { s | s = ( ._|_ ` ( ._|_ ` s ) ) } ) $=
      ( vw wcel cvv cv cfv wceq cab elex ccss cocv fveq2 cbs fvex fveq1d eqeq2d
      syl6eqr fveq12d abbidv df-css cpw pwex wss eqid ocvss elpw mpbir syl6eqel
      id abssi ssexi fvmpt syl5eq syl ) CDICJIZAEKZVBBLZBLZMZENZMCDOVAACPLVFGHC
      VBVBHKZQLZLZVHLZMZENVFJPVGCMZVKVEEVLVJVDVBVLVIVCVHBVLVHCQLBVGCQRFUCZVLVBV
      HBVMUAUDUBUEHEUFVFCSLZUGZVNCSTUHVEEVOVEVBVDVOVEUOVDVOIVDVNUIVCBVNCVNUJFUK
      VDVNVCBTULUMUNUPUQURUSUT $.

    $( The predicate "is a closed subspace" (of a pre-Hilbert space).
       (Contributed by NM, 7-Oct-2011.)  (Revised by Mario Carneiro,
       13-Oct-2015.) $)
    iscss $p |- ( W e. X -> ( S e. C <-> S = ( ._|_ ` ( ._|_ ` S ) ) ) ) $=
      ( vs wcel cv cfv wceq cab cssval eleq2d cvv id fvex syl6eqel fveq2 fveq2d
      eqeq12d elab3 syl6bb ) DEIZBAIBHJZUFCKZCKZLZHMZIBBCKZCKZLZUEAUJBACDEHFGNO
      UIUMHBUMBULPUMQUKCRSUFBLZUFBUHULUNQUNUGUKCUFBCTUAUBUCUD $.

    $( Property of a closed subspace (of a pre-Hilbert space).  (Contributed by
       Mario Carneiro, 13-Oct-2015.) $)
    cssi $p |- ( S e. C -> S = ( ._|_ ` ( ._|_ ` S ) ) ) $=
      ( wcel cfv wceq ccss cdm wb elfvdm eleq2s iscss syl ibi ) BAGZBBCHCHIZRDJ
      KZGZRSLUABDJHABDJMFNABCDTEFOPQ $.
  $}

  ${
    cssss.v $e |- V = ( Base ` W ) $.
    cssss.c $e |- C = ( CSubSp ` W ) $.
    $( A closed subspace is a subset of the base.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    cssss $p |- ( S e. C -> S C_ V ) $=
      ( wcel cocv cfv eqid cssi ocvss syl6eqss ) BAGBBDHIZIZNICABNDNJZFKONCDEPL
      M $.

    ocvcss.o $e |- ._|_ = ( ocv ` W ) $.
    $( It is sufficient to prove that the double orthocomplement is a subset of
       the target set to show that the set is a closed subspace.  (Contributed
       by Mario Carneiro, 13-Oct-2015.) $)
    iscss2 $p |- ( ( W e. PreHil /\ S C_ V ) ->
      ( S e. C <-> ( ._|_ ` ( ._|_ ` S ) ) C_ S ) ) $=
      ( cphl wcel wss wa cfv wceq wb iscss adantr ocvocv eqss baib syl bitrd )
      EIJZBDKZLZBAJZBBCMCMZNZUGBKZUCUFUHOUDABCEIHGPQUEBUGKZUHUIOBCDEFHRUHUJUIBU
      GSTUAUB $.

    $( The orthocomplement of any set is a closed subspace.  (Contributed by
       Mario Carneiro, 13-Oct-2015.) $)
    ocvcss $p |- ( ( W e. PreHil /\ S C_ V ) -> ( ._|_ ` S ) e. C ) $=
      ( cphl wcel wss wa cfv ocvocv ocv2ss syl wb ocvss a1i iscss2 sylan2
      mpbird ) EIJZBDKZLZBCMZAJZUFCMZCMUFKZUEBUHKUIBCDEFHNUHBCEHOPUDUCUFDKZUGUI
      QUJUDBCDEFHRSAUFCDEFGHTUAUB $.
  $}

  ${
    css0.c $e |- C = ( CSubSp ` W ) $.
    $( The zero subspace is a closed subspace.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    cssincl $p |- ( ( W e. PreHil /\ A e. C /\ B e. C ) ->
                    ( A i^i B ) e. C ) $=
      ( cphl wcel cin cocv cfv cun cbs wss eqid ocvss unssi ocvcss mpan2 cssi
      wa ineqan12d unocv syl6eqr eleq1d syl5ibrcom 3impib ) DFGZACGZBCGZABHZCGZ
      UGUKUHUITZADIJZJZBUMJZKZUMJZCGZUGUPDLJZMURUNUOUSAUMUSDUSNZUMNZOBUMUSDUTVA
      OPCUPUMUSDUTEVAQRULUJUQCULUJUNUMJZUOUMJZHUQUHUIAVBBVCCAUMDVAESCBUMDVAESUA
      UNUOUMDVAUBUCUDUEUF $.

    css0.z $e |- .0. = ( 0g ` W ) $.
    $( The zero subspace is a closed subspace.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    css0 $p |- ( W e. PreHil -> { .0. } e. C ) $=
      ( cphl wcel cbs cfv cocv csn eqid ocv1 wss ssid ocvcss mpan2 eqeltrrd ) B
      FGZBHIZBJIZIZCKAUATBCTLZUALZEMSTTNUBAGTOATUATBUCDUDPQR $.
  $}

  ${
    css1.v $e |- V = ( Base ` W ) $.
    css1.c $e |- C = ( CSubSp ` W ) $.
    $( The whole space is a closed subspace.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    css1 $p |- ( W e. PreHil -> V e. C ) $=
      ( cphl wcel c0 cocv cfv eqid ocv0 wss 0ss ocvcss mpan2 syl5eqelr ) CFGZBH
      CIJZJZASBCDSKZLRHBMTAGBNAHSBCDEUAOPQ $.
  $}

  ${
    csslss.c $e |- C = ( CSubSp ` W ) $.
    csslss.l $e |- L = ( LSubSp ` W ) $.
    $( A closed subspace of a pre-Hilbert space is a linear subspace.
       (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    csslss $p |- ( ( W e. PreHil /\ S e. C ) -> S e. L ) $=
      ( cphl wcel wa cocv cfv wceq eqid cssi adantl cbs wss ocvss a1i ocvlss
      sylan2 eqeltrd ) DGHZBAHZIBBDJKZKZUEKZCUDBUGLUCABUEDUEMZENOUDUCUFDPKZQZUG
      CHUJUDBUEUIDUIMZUHRSUFCUEUIDUKUHFTUAUB $.
  $}

  ${
    $d x y z ._|_ $.  $d x y z ph $.  $d x y z S $.  $d y z V $.  $d y z W $.
    lsmcss.c $e |- C = ( CSubSp ` W ) $.
    lsmcss.j $e |- V = ( Base ` W ) $.
    lsmcss.o $e |- ._|_ = ( ocv ` W ) $.
    lsmcss.p $e |- .(+) = ( LSSum ` W ) $.
    lsmcss.1 $e |- ( ph -> W e. PreHil ) $.
    lsmcss.2 $e |- ( ph -> S C_ V ) $.
    lsmcss.3 $e |- ( ph ->
      ( ._|_ ` ( ._|_ ` S ) ) C_ ( S .(+) ( ._|_ ` S ) ) ) $.
    $( A subset of a pre-Hilbert space whose double orthocomplement has a
       projection decomposition is a closed subspace.  This is the core of the
       proof that a topologically closed subspace is algebraically closed in a
       Hilbert space.  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    lsmcss $p |- ( ph -> S e. C ) $=
      ( wcel cfv co wceq eqid syl2anc vx vy vz cv cplusg wrex wi sseld clmod wb
      wss cphl phllmod syl ocvss a1i lsmelvalx syl3anc sylibd c0g csca ad2antrr
      wa cip simplrl sseldd simplrr sseldi ipdir syl13anc ocvi iporthcom oveq1d
      mpbid cgrp lmodfgrp ipcl grplid 3eqtrd simpr eqtr3d oveq2d lmodgrp grprid
      cbs ipeq0 eqtrd eqeltrd ex eleq1 imbi12d syl5ibrcom rexlimdvva syld ssrdv
      pm2.43d iscss2 mpbird ) ADBOZDEPZEPZDUKZAUAXADAUAUDZXAOZXCDOZAXDXCUBUDZUC
      UDZGUEPZQZRZUCWTUFUBDUFZXDXEUGZAXDXCDWTCQZOZXKAXAXMXCNUHAGUIOZDFUKZWTFUKZ
      XNXKUJAGULOZXOLGUMZUNZMXQADEFGIJUOZUPUBUCFXHCDWTGUIXCIXHSZKUQURUSAXJXLUBU
      CDWTAXFDOZXGWTOZVCZVCZXLXJXIXAOZXIDOZUGYFYGYHYFYGVCZXIXFDYIXIXFGUTPZXHQZX
      FYIXGYJXFXHYIXGXGGVDPZQZGVAPZUTPZRZXGYJRZYIXIXGYLQZYMYOYIYRXFXGYLQZYMYNUE
      PZQZYOYMYTQZYMYIXRXFFOZXGFOZUUDYRUUARAXRYEYGLVBZYIDFXFAXPYEYGMVBAYCYDYGVE
      ZVFZYIWTFXGYAAYCYDYGVGZVHZUUIXFXGXGXHYTYNYLFGYNSZYLSZIYBYTSZVIVJYIYSYOYMY
      TYIXGXFYLQYORZYSYORZYIYDYCUUMUUHUUFXGXFDYNYLEFGYOIUUKUUJYOSZJVKTYIXRUUDUU
      CUUMUUNUJUUEUUIUUGXGXFYNYLFGYOUUJUUKIUUOVLURVNVMYIYNVOOZYMYNWEPZOZUUBYMRY
      IXOUUPYIXRXOUUEXSUNYNGUUJVPUNYIXRUUDUUDUURUUEUUIUUIXGXGYNYLUUQFGUUJUUKIUU
      QSZVQURUUQYTYNYMYOUUSUULUUOVRTVSYIYGYDYRYORYFYGVTUUHXIXGWTYNYLEFGYOIUUKUU
      JUUOJVKTWAYIXRUUDYPYQUJUUEUUIXGYNYLFGYJYOUUJUUKIUUOYJSZWFTVNWBYIGVOOZUUCY
      KXFRAUVAYEYGAXOUVAXTGWCUNVBUUGFXHGXFYJIYBUUTWDTWGUUFWHWIXJXDYGXEYHXCXIXAW
      JXCXIDWJWKWLWMWNWPWOAXRXPWSXBUJLMBDEFGIHJWQTWR $.
  $}

  ${
    $d x y z C $.  $d x V $.  $d x y z W $.
    cssmre.v $e |- V = ( Base ` W ) $.
    cssmre.c $e |- C = ( CSubSp ` W ) $.
    $( The closed subspaces of a pre-Hilbert space are a Moore system.  Unlike
       many of our other examples of closure systems, this one is _not_ usually
       an algebraic closure system ~ df-acs : consider the Hilbert space of
       sequences ` NN --> RR ` with convergent sum; the subspace of all
       sequences with finite support is the classic example of a non-closed
       subspace, but for every finite set of sequences of finite support, there
       is a finite-dimensional (and hence closed) subspace containing all of
       the sequences, so if closed subspaces were an algebraic closure system
       this would violate ~ acsfiel .  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    cssmre $p |- ( W e. PreHil -> C e. ( Moore ` V ) ) $=
      ( vx vy vz wcel cv wi wss vex sylibr ssrdv cfv wa ocv2ss sseldd sstrd cpw
      cphl cssss elpw a1i css1 c0 wne w3a cint cocv wal intss1 eqid 3syl simprl
      ad2antll wceq simpl2 simprr cssi syl eleqtrrd expr alrimiv elint ex simp1
      cuni intssuni 3ad2ant3 simp2 3ad2ant1 sspwuni sylib iscss2 syl2anc mpbird
      wb ismred ) CUBIZABFWAFABUAZFJZAIZWCWBIZKWAWDWCBLWEAWCBCDEUCWCBFMUDNUEOZA
      BCDEUFWAWCALZWCUGUHZUIZWCUJZAIZWJCUKPZPZWLPZWJLZWIGWNWJWIGJZWNIZWPWJIZWIW
      QQZHJZWCIZWPWTIZKZHULWRWSXCHWIWQXAXBWIWQXAQZQZWPWTWLPZWLPZWTXEWNXGWPXAWNX
      GLZWIWQXAWJWTLXFWMLXHWTWCUMWTWJWLCWLUNZRWMXFWLCXIRUOUQWIWQXAUPSXEWTAIWTXG
      URXEWCAWTWAWGWHXDUSWIWQXAUTSAWTWLCXIEVAVBVCVDVEHWPWCGMVFNVGOWIWAWJBLWKWOV
      SWAWGWHVHWIWJWCVIZBWHWAWJXJLWGWCVJVKWIWCWBLXJBLWIWCAWBWAWGWHVLWAWGAWBLWHW
      FVMTWCBVNVOTAWJWLBCDEXIVPVQVRVT $.
  $}

  ${
    mrccss.v $e |- V = ( Base ` W ) $.
    mrccss.o $e |- ._|_ = ( ocv ` W ) $.
    mrccss.c $e |- C = ( CSubSp ` W ) $.
    mrccss.f $e |- F = ( mrCls ` C ) $.
    $( The Moore closure corresponding to the system of closed subspaces is the
       double orthocomplement operation.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    mrccss $p |- ( ( W e. PreHil /\ S C_ V ) ->
      ( F ` S ) = ( ._|_ ` ( ._|_ ` S ) ) ) $=
      ( cphl wcel wss wa cfv cmre cssmre adantr sylan ocv2ss ocvocv a1i mrcsscl
      ocvss ocvcss sylan2 syl3anc mrcssid 3syl wceq mrccl cssi sseqtr4d eqssd
      syl ) FKLZBEMZNZBCOZBDOZDOZURAEPOLZBVAMVAALZUSVAMUPVBUQAEFGIQZRBDEFGHUAUQ
      UPUTEMZVCVEUQBDEFGHUDUBAUTDEFGIHUEUFABCVAEJUCUGURVAUSDOZDOZUSURBUSMZVFUTM
      VAVGMUPVBUQVHVDABCEJUHSUSBDFHTUTVFDFHTUIURUSALZUSVGUJUPVBUQVIVDABCEJUKSAU
      SDFHIULUOUMUN $.
  $}

  ${
    $d x y C $.  $d h x y I $.  $d h ._|_ $.  $d h x y W $.
    thlval.k $e |- K = ( toHL ` W ) $.
    ${
      thlval.c $e |- C = ( CSubSp ` W ) $.
      thlval.i $e |- I = ( toInc ` C ) $.
      thlval.o $e |- ._|_ = ( ocv ` W ) $.
      $( Value of the Hilbert lattice.  (Contributed by Mario Carneiro,
         25-Oct-2015.) $)
      thlval $p |- ( W e. V -> K = ( I sSet <. ( oc ` ndx ) , ._|_ >. ) ) $=
        ( vh wcel cvv cfv cop csts ccss cipo cocv syl6eqr cnx co wceq elex cthl
        coc cv fveq2 fveq2d opeq2d oveq12d df-thl ovex fvmpt syl5eq syl ) FELFM
        LZCBUAUFNZDOZPUBZUCFEUDUQCFUENUTGKFKUGZQNZRNZURVASNZOZPUBUTMUEVAFUCZVCB
        VEUSPVFVCARNBVFVBARVFVBFQNAVAFQUHHTUIITVFVDDURVFVDFSNDVAFSUHJTUJUKKULBU
        SPUMUNUOUP $.
    $}

    ${
      thlbas.c $e |- C = ( CSubSp ` W ) $.
      $( Base set of the Hilbert lattice of closed subspaces.  (Contributed by
         Mario Carneiro, 25-Oct-2015.) $)
      thlbas $p |- C = ( Base ` K ) $=
        ( cvv wcel cbs cfv wceq cnx eqid fveq2d ccss wne c1 1nn0 fvprc syl5eq
        c0 cipo coc cocv cop csts co thlval eqeltri ipobas ax-mp baseid cdc 1re
        fvex 1nn 1lt10 declti ltneii basendx ocndx neeq12i mpbir eqtri syl6reqr
        setsnid wn base0 cthl 3eqtr4a pm2.61i ) CFGZABHIZJVKVLAUAIZKUBIZCUCIZUD
        UEUFZHIZAVKBVPHAVMBVOFCDEVMLZVOLUGMAVMHIZVQAFGAVSJACNIZFECNUNUHAVMFVRUI
        UJVOVNHVMUKKHIZVNOPPPULZOPWBUMPPPUOQQUPUQURWAPVNWBUSUTVAVBVEVCVDVKVFZTT
        HIAVLVGWCAVTTECNRSWCBTHWCBCVHITDCVHRSMVIVJ $.

      ${
        thlle.i $e |- I = ( toInc ` C ) $.
        thlle.l $e |- .<_ = ( le ` I ) $.
        $( Ordering on the Hilbert lattice of closed subspaces.  (Contributed
           by Mario Carneiro, 25-Oct-2015.) $)
        thlle $p |- .<_ = ( le ` K ) $=
          ( vx vy cvv wcel cple cfv wne c10 c1 c0 ccss wceq cnx coc cocv cop co
          csts eqid thlval fveq2d pleid cdc 10re cc0 dec10 1nn0 0nn0 0lt1 declt
          clt 1nn eqbrtri ltneii plendx ocndx neeq12i mpbir setsnid syl6reqr wn
          eqtri str0 cv cpr wa copab fvex eqeltri ipolerval ax-mp eqtr4i opabn0
          wss wex vex prss elfvex eleq2s ad2antrr sylanbr exlimivv sylbi syl5eq
          necon1bi cthl fvprc 3eqtr4a pm2.61i ) ELMZDCNOZUAWSWTBUBUCOZEUDOZUEUG
          UFZNOZDWSCXCNABCXBLEFGHXBUHUIUJDBNOZXDIXBXANBUKUBNOZXAPQRRULZPQXGUMQR
          UNULXGUTUORUNRUPUQVAURUSVBVCXFQXAXGVDVEVFVGVHVKVIWSVJZSSNODWTNXFUKVLX
          HDJVMZKVMZVNAWCZXIXJWCZVOZJKVPZSDXEXNIALMXNXEUAAETOZLGETVQVRJKABLHVSV
          TWAWSXNSXNSPXMKWDJWDWSXMJKWBXMWSJKXKXIAMZXJAMZVOXLWSXIXJAJWEKWEWFXPWS
          XQXLWSXIXOAXIETWGGWHWIWJWKWLWNWMXHCSNXHCEWOOSFEWOWPWMUJWQWR $.
      $}

      ${
        thlleval.l $e |- .<_ = ( le ` K ) $.
        $( Ordering on the Hilbert lattice of closed subspaces.  (Contributed
           by Mario Carneiro, 25-Oct-2015.) $)
        thlleval $p |- ( ( S e. C /\ T e. C ) -> ( S .<_ T <-> S C_ T ) ) $=
          ( cvv wcel wbr wss wb ccss cfv fvex eqeltri eqid cple eqtr4i mp3an1
          cipo thlle ipole ) AJKBAKCAKBCELBCMNAFOPJHFOQRAAUCPZEJBCUFSZEDTPUFTPZ
          IAUFDUHFGHUGUHSUDUAUEUB $.
      $}
    $}

    ${
      thloc.c $e |- ._|_ = ( ocv ` W ) $.
      $( Orthocomplement on the Hilbert lattice of closed subspaces.
         (Contributed by Mario Carneiro, 25-Oct-2015.) $)
      thloc $p |- ._|_ = ( oc ` K ) $=
        ( cvv wcel coc cfv wceq cipo eqid fveq2d fvex cocv ocid c0 fvprc syl5eq
        cthl ccss cnx csts co thlval eqeltri setsid mp2an syl6reqr str0 3eqtr4a
        cop wn pm2.61i ) CFGZBAHIZJUOUPCUAIZKIZUBHIZBULUCUDZHIZBUOAUTHUQURABFCD
        UQLURLEUEMURFGBFGBVAJUQKNBCOIZFECONUFFBHFURPUGUHUIUOUMZQQHIBUPHUSPUJVCB
        VBQECORSVCAQHVCACTIQDCTRSMUKUN $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Orthogonal projection and orthonormal bases
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c proj $.
  $c Hil $.
  $c OBasis $.

  $( Extend class notation with orthogonal projection function. $)
  cpj $a class proj $.

  $( Extend class notation with class of all Hilbert spaces. $)
  chs $a class Hil $.

  $( Extend class notation with the set of orthonormal bases. $)
  cobs $a class OBasis $.

  ${
    $d b h x y $.
    $( Define orthogonal projection onto a subspace.  This is just a wrapping
       of ~ df-pj1 , but we restrict the domain of this function to only total
       projection functions.  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    df-pj $a |- proj = ( h e. _V |-> ( ( x e. ( LSubSp ` h ) |->
      ( x ( proj1 ` h ) ( ( ocv ` h ) ` x ) ) ) i^i
        ( _V X. ( ( Base ` h ) ^m ( Base ` h ) ) ) ) ) $.

    $( Define class of all Hilbert spaces.  Based on Proposition 4.5, p. 176,
       Gudrun Kalmbach, Quantum Measures and Spaces, Kluwer, Dordrecht, 1998.
       (Contributed by NM, 7-Oct-2011.)  (Revised by Mario Carneiro,
       16-Oct-2015.) $)
    df-hil $a |- Hil = { h e. PreHil | dom ( proj ` h ) = ( CSubSp ` h ) } $.

    $( Define the set of all orthonormal bases for a pre-Hilbert space.  An
       orthonormal basis is a set of mutually orthogonal vectors with norm 1
       and such that the linear span is dense in the whole space.  (As this is
       an "algebraic" definition, before we have topology available, we express
       this denseness by saying that the double orthocomplement is the whole
       space, or equivalently, the single orthocomplement is trivial.)
       (Contributed by Mario Carneiro, 23-Oct-2015.) $)
    df-obs $a |- OBasis = ( h e. PreHil |-> { b e. ~P ( Base ` h ) |
      ( A. x e. b A. y e. b ( x ( .i ` h ) y ) =
        if ( x = y , ( 1r ` ( Scalar ` h ) ) , ( 0g ` ( Scalar ` h ) ) ) /\
        ( ( ocv ` h ) ` b ) = { ( 0g ` h ) } ) } ) $.

    $d w x ._|_ $.  $d w x L $.  $d w x P $.  $d w x V $.  $d w x W $.
    $d x T $.
    pjfval.v $e |- V = ( Base ` W ) $.
    pjfval.l $e |- L = ( LSubSp ` W ) $.
    pjfval.o $e |- ._|_ = ( ocv ` W ) $.
    pjfval.p $e |- P = ( proj1 ` W ) $.
    pjfval.k $e |- K = ( proj ` W ) $.
    $( The value of the projection function.  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    pjfval $p |- K =
      ( ( x e. L |-> ( x P ( ._|_ ` x ) ) ) i^i ( _V X. ( V ^m V ) ) ) $=
      ( cfv co cvv cmap cxp cin clss c0 vw cpj cv cmpt wcel wceq cocv cbs fveq2
      cpj1 syl6eqr eqidd fveq1d oveq123d mpteq12dv oveq12d xpeq2d ineq12d df-pj
      fvex eqeltri inex1 ovex inex2 xpex wf wss eqid a1i fmpti fssxp ssrin mp2b
      inxp sseqtri ssexi fvmpt wn fvprc inss1 syl5eq mpteq1d mpt0 sseq0 sylancr
      syl6eq eqtr4d pm2.61i eqtri ) CGUBMZADAUCZWKEMZBNZUDZOFFPNZQZRZLGOUEZWJWQ
      UFUAGAUAUCZSMZWKWKWSUGMZMZWSUJMZNZUDZOWSUHMZXFPNZQZRWQOUBWSGUFZXEWNXHWPXI
      AWTXDDWMXIWTGSMZDWSGSUIIUKXIWKWKXBWLXCBXIXCGUJMBWSGUJUIKUKXIWKULXIWKXAEXI
      XAGUGMEWSGUGUIJUKUMUNUOXIXGWOOXIXFFXFFPXIXFGUHMFWSGUHUIHUKZXKUPUQURAUAUSW
      QDORZOWORZQZXLXMDODXJOIGSUTVAVBWOOFFPVCVDVEWQDOQZWPRZXNDOWNVFWNXOVGWQXPVG
      ADOWMWNWNVHWMOUEWKDUEWKWLBVCVIVJDOWNVKWNXOWPVLVMDOOWOVNVOVPVQWRVRZWJTWQGU
      BVSXQWQWNVGWNTUFWQTUFWNWPVTXQWNATWMUDTXQADTWMXQDXJTIGSVSWAWBAWMWCWFWQWNWD
      WEWGWHWI $.

    $( A subspace is in the domain of the projection function iff the subspace
       admits a projection decomposition of the whole space.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    pjdm $p |- ( T e. dom K <->
      ( T e. L /\ ( T P ( ._|_ ` T ) ) : V --> V ) ) $=
      ( vx cfv co wcel cbs cvv ccnv cin cv cmap wf wceq id fveq2 oveq12d eleq1d
      cdm fvex eqeltri elmap syl6bb cmpt cima crab crn cnvin cnvxp ineq2i eqtri
      cres cxp pjfval cnveqi df-res 3eqtr4i rneqi dfdm4 df-ima mptpreima elrab2
      eqid ) MUAZVNENZAOZFFUBOZPZFFBBENZAOZUCZMBDCUIZVNBUDZVRVTVQPWAWCVPVTVQWCV
      NBVOVSAWCUEVNBEUFUGUHFFVTFGQNRHGQUJUKZWDULUMWBMDVPUNZSZVQUOZVRMDUPCSZUQWF
      VQVBZUQWBWGWHWIWERVQVCZTZSZWFVQRVCZTZWHWIWLWFWJSZTWNWEWJURWOWMWFRVQUSUTVA
      CWKMACDEFGHIJKLVDVEWFVQVFVGVHCVIWFVQVJVGMDVPVQWEWEVMVKVAVL $.
  $}

  ${
    $d x L $.  $d x V $.  $d x W $.
    pjpm.v $e |- V = ( Base ` W ) $.
    pjpm.l $e |- L = ( LSubSp ` W ) $.
    pjpm.k $e |- K = ( proj ` W ) $.
    $( The projection map is a partial function from subspaces of the
       pre-Hilbert space to total operators.  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    pjpm $p |- K e. ( ( V ^m V ) ^pm L ) $=
      ( vx cmap co wcel wfun cxp wss cfv cvv cin eqid eqsstri ovex cv cocv cpj1
      cpm cmpt pjfval inss1 funmpt funss mp2 wf a1i fmpti fssxp ssrin mp2b inxp
      inv1 incom eqtri xpeq12i sseqtri clss fvex eqeltri elpm mpbir2an ) ACCIJZ
      BUDJKALZABVHMZNAHBHUAZVKDUBOZOZDUCOZJZUEZNVPLVIAVPPVHMZQZVPHVNABVLCDEFVLR
      VNRGUFZVPVQUGSHBVOUHAVPUIUJABPMZVQQZVJAVRWAVSBPVPUKVPVTNVRWANHBPVOVPVPRVO
      PKVKBKVKVMVNTULUMBPVPUNVPVTVQUOUPSWABPQZPVHQZMVJBPPVHUQWBBWCVHBURWCVHPQVH
      PVHUSVHURUTVAUTVBVHBACCITBDVCOPFDVCVDVEVFVG $.
  $}

  ${
    $d x y K $.  $d x y ._|_ $.  $d x y P $.  $d x T $.  $d x y W $.
    pjfval2.o $e |- ._|_ = ( ocv ` W ) $.
    pjfval2.p $e |- P = ( proj1 ` W ) $.
    pjfval2.k $e |- K = ( proj ` W ) $.
    $( Value of the projection map with implicit domain.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    pjfval2 $p |- K = ( x e. dom K |-> ( x P ( ._|_ ` x ) ) ) $=
      ( vy cfv cv co cmpt cvv cbs cin wcel wa copab df-mpt clss cmap wceq df-xp
      cxp cdm ineq12i eqid pjfval pjdm eleq1 fvex elmap syl6rbb anbi2d pm5.32ri
      wf syl5bb an32 vex biantrur anbi2i 3bitri opabbii inopab 3eqtr4i ) AEUAJZ
      AKZVHDJBLZMZNEOJZVKUBLZUEZPVHVGQZIKZVIUCZRZAISZVHNQZVOVLQZRZAISZPZCACUFZV
      IMZVJVRVMWBAIVGVITAINVLUDUGABCVGDVKEVKUHZVGUHZFGHUIVHWDQZVPRZAISVQWARZAIS
      WEWCWIWJAIWIVNVTRZVPRVQVTRWJVPWHWKWHVNVKVKVIUQZRVPWKBVHCVGDVKEWFWGFGHUJVP
      WLVTVNVPVTVIVLQWLVOVIVLUKVKVKVIEOULZWMUMUNUOURUPVNVTVPUSVTWAVQVSVTAUTVAVB
      VCVDAIWDVITVQWAAIVEVFVF $.

    $( Value of the projection map.  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    pjval $p |- ( T e. dom K -> ( K ` T ) = ( T P ( ._|_ ` T ) ) ) $=
      ( vx cv cfv co cdm wceq id fveq2 oveq12d pjfval2 ovex fvmpt ) IBIJZUADKZA
      LBBDKZALCMCUABNZUABUBUCAUDOUABDPQIACDEFGHRBUCAST $.
  $}

  ${
    pjdm2.v $e |- V = ( Base ` W ) $.
    pjdm2.l $e |- L = ( LSubSp ` W ) $.
    pjdm2.o $e |- ._|_ = ( ocv ` W ) $.
    pjdm2.s $e |- .(+) = ( LSSum ` W ) $.
    pjdm2.k $e |- K = ( proj ` W ) $.
    $( A subspace is in the domain of the projection function iff the subspace
       admits a projection decomposition of the whole space.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    pjdm2 $p |- ( W e. PreHil ->
      ( T e. dom K <-> ( T e. L /\ ( T .(+) ( ._|_ ` T ) ) = V ) ) ) $=
      ( cdm wcel cfv co wf wa eqid syl cpj1 cphl wceq pjdm wss cplusg c0g ccntz
      csubg clmod adantr lsssssubg simpr sseldd lssss ocvlss sylan2 ocvin cabel
      wb phllmod lmodabl ablcntzd pj1f adantl fss syl2anc eqcomd syl5ibcom feq2
      fdm eqeq2d biimpcd impbid pm5.32da syl5bb ) BCMNBDNZFFBBEOZGUAOZPZQZRGUBN
      ZVQBVRAPZFUCZRVSBCDEFGHIJVSSZLUDWBVQWAWDWBVQRZWCFVTQZWAWDUTWFWCBVTQBFUEZW
      GWFVSGUFOZABVRGGUGOZGUHOZWISKWJSZWKSZWFDGUIOZBWFGUJNZDWNUEWBWOVQGVAUKZDGI
      ULTZWBVQUMUNZWFDWNVRWQVQWBWHVRDNDBFGHIUOZBDEFGHJIUPUQUNZBDEGWJJIWLURWFBVR
      GWKWMWFWOGUSNWPGVBTWRWTVCWEVDVQWHWBWSVEWCBFVTVFVGWGWAWDWGWCVTMZUCWAWDWGXA
      WCWCFVTVKVHWAXAFWCFFVTVKVLVIWDWGWAWCFFVTVJVMVNTVOVP $.
  $}

  ${
    $d x K $.  $d x T $.  $d x W $.
    pjf.k $e |- K = ( proj ` W ) $.
    $( A projection is a linear operator.  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    pjff $p |- ( W e. PreHil -> K : dom K --> ( W LMHom W ) ) $=
      ( vx cphl wcel cdm cv cocv cpj1 co clmhm wa clsm cress eqid adantr syldan
      cfv wceq clss c0g clmod phllmod cbs pjdm2 simprbda wss syl ocvlss cin csn
      lssss ocvin pj1lmhm simplbda oveq2d ressid eqtrd oveq1d eleqtrd pjfval2
      fmptd ) BEFZDAGZDHZVFBISZSZBJSZKZBBLKZAVDVFVEFZMZVJBVFVHBNSZKZOKZBLKVKVMV
      IVNVFVHBUASZBBUBSZVQPZVNPZVRPZVIPZVDBUCFVLBUDQVDVLVFVQFZVOBUESZTZVNVFAVQV
      GWDBWDPZVSVGPZVTCUFZUGZVDVLVFWDUHZVHVQFVMWCWJWIVQVFWDBWFVSUMUIVFVQVGWDBWF
      WGVSUJRVDVLWCVFVHUKVRULTWIVFVQVGBVRWGVSWAUNRUOVMVPBBLVMVPBWDOKZBVMVOWDBOV
      DVLWCWEWHUPUQVDWKBTVLWDBEWFURQUSUTVADVIAVGBWGWBCVBVC $.

    pjf.v $e |- V = ( Base ` W ) $.
    $( A projection is a function on the base set.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    pjf $p |- ( T e. dom K -> ( K ` T ) : V --> V ) $=
      ( cdm wcel cfv wf cocv cpj1 co clss eqid pjdm simprbi pjval feq1d mpbird
      ) ABGHZCCABIZJCCAADKIZIDLIZMZJZUAADNIZHUFUDABUGUCCDFUGOUCOZUDOZEPQUACCUBU
      EUDABUCDUHUIERST $.

    $( A projection is a function from the base set to the subspace.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    pjf2 $p |- ( ( W e. PreHil /\ T e. dom K ) -> ( K ` T ) : V --> T ) $=
      ( cphl wcel cdm wa cocv cfv co wf eqid wss syl wceq sseldd syldan phllmod
      clsm cpj1 cplusg c0g ccntz clss csubg clmod adantr lsssssubg pjdm2 ocvlss
      simprbda lssss cin csn ocvin cabel lmodabl ablcntzd pjval adantl simplbda
      pj1f eqcomd feq12d mpbid ) DGHZABIHZJZAADKLZLZDUBLZMZAAVMDUCLZMZNCAABLZNV
      KVPDUDLZVNAVMDDUELZDUFLZVSOVNOZVTOZWAOZVKDUGLZDUHLZAVKDUIHZWEWFPVIWGVJDUA
      UJZWEDWEOZUKQZVIVJAWEHZVOCRZVNABWEVLCDFWIVLOZWBEULZUNZSZVKWEWFVMWJVIVJACP
      ZVMWEHVKWKWQWOWEACDFWIUOQAWEVLCDFWMWIUMTSZVIVJWKAVMUPVTUQRWOAWEVLDVTWMWIW
      CURTVKAVMDWAWDVKWGDUSHWHDUTQWPWRVAVPOZVEVKVOCAVQVRVKVRVQVJVRVQRVIVPABVLDW
      MWSEVBVCVFVIVJWKWLWNVDVGVH $.

    $( A projection is a surjection onto the subspace.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    pjfo $p |- ( ( W e. PreHil /\ T e. dom K ) -> ( K ` T ) : V -onto-> T ) $=
      ( vx cphl wcel cdm wa cfv wceq wss syl co eqid adantr sseldd syldan wf cv
      crn wfo pjf2 cocv cpj1 pjval ad2antlr fveq1d cplusg clsm ccntz clss csubg
      frn c0g clmod phllmod lsssssubg pjdm2 simprbda lssss ocvlss cin csn ocvin
      cabel lmodabl ablcntzd pj1lid wfn ffn sselda fnfvelrn syl2anc eqeltrrd ex
      eqtrd ssrdv eqssd dffo2 sylanbrc ) DHIZABJIZKZCAABLZUAZWGUCZAMCAWGUDABCDE
      FUEZWFWIAWFWHWIANWJCAWGUPOWFGAWIWFGUBZAIZWKWIIWFWLKZWKWGLZWKWIWMWNWKAADUF
      LZLZDUGLZPZLWKWMWKWGWRWEWGWRMWDWLWQABWODWOQZWQQZEUHUIUJWFWQDUKLZDULLZAWPD
      WKDUQLZDUMLZXAQXBQZXCQZXDQZWFDUNLZDUOLZAWFDURIZXHXINWDXJWEDUSRZXHDXHQZUTO
      ZWDWEAXHIZAWPXBPCMXBABXHWOCDFXLWSXEEVAVBZSZWFXHXIWPXMWDWEACNZWPXHIWFXNXQX
      OXHACDFXLVCOZAXHWOCDFWSXLVDTSZWDWEXNAWPVEXCVFMXOAXHWODXCWSXLXFVGTWFAWPDXD
      XGWFXJDVHIXKDVIOXPXSVJWTVKVSWMWGCVLZWKCIWNWIIWFXTWLWFWHXTWJCAWGVMORWFACWK
      XRVNCWKWGVOVPVQVRVTWACAWGWBWC $.
  $}

  ${
    $d x C $.  $d x K $.  $d x W $.
    pjcss.k $e |- K = ( proj ` W ) $.
    pjcss.c $e |- C = ( CSubSp ` W ) $.
    $( A projection subspace is an (algebraically) closed subspace.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    pjcss $p |- ( W e. PreHil -> dom K C_ C ) $=
      ( vx cphl wcel cdm cv wa clsm cfv cocv cbs eqid simpl clss wss co wceq ex
      pjdm2 simprbda lssss syl ocvss simplbda syl5sseqr lsmcss ssrdv ) CGHZFBIZ
      AULFJZUMHZUNAHULUOKZACLMZUNCNMZCOMZCEUSPZURPZUQPZULUOQUPUNCRMZHZUNUSSULUO
      VDUNUNURMZUQTZUSUAZUQUNBVCURUSCUTVCPZVAVBDUCZUDVCUNUSCUTVHUEUFUPUSVEURMVF
      VEURUSCUTVAUGULUOVDVGVIUHUIUJUBUK $.
  $}

  ${
    ocvpj.k $e |- K = ( proj ` W ) $.
    ocvpj.o $e |- ._|_ = ( ocv ` W ) $.
    $( The orthocomplement of a projection subspace is a projection subspace.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    ocvpj $p |- ( ( W e. PreHil /\ T e. dom K ) -> ( ._|_ ` T ) e. dom K ) $=
      ( cphl wcel cdm wa cfv co wceq wss eqid syl syldan adantr sseldd pjdm2 wb
      clss clsm cbs pjcss sselda cssss ocvlss cabel csubg clmod phllmod lmodabl
      ccss lsssssubg csslss lsmcom syl3anc oveq2d simplbda 3eqtr3d mpbir2and
      cssi ) DGHZABIZHZJZACKZVEHZVHDUBKZHZVHVHCKZDUCKZLZDUDKZMZVDVFAVONZVKVGADU
      NKZHZVQVDVEVRAVRBDEVROZUEUFZVRAVODVOOZVTUGPAVJCVODWBFVJOZUHQZVGVHAVMLZAVH
      VMLZVNVOVGDUIHZVHDUJKZHAWHHWEWFMVGDUKHZWGVDWIVFDULRZDUMPVGVJWHVHVGWIVJWHN
      WJVJDWCUOPZWDSVGVJWHAWKVDVFVSAVJHZWAVRAVJDVTWCUPQSVMVHADVMOZUQURVGAVLVHVM
      VGVSAVLMWAVRACDFVTVCPUSVDVFWLWFVOMVMABVJCVODWBWCFWMETUTVAVDVIVKVPJUAVFVMV
      HBVJCVODWBWCFWMETRVB $.
  $}

  ${
    $d h C $.  $d h H $.  $d h K $.
    ishil.k $e |- K = ( proj ` H ) $.
    ishil.c $e |- C = ( CSubSp ` H ) $.
    $( The predicate "is a Hilbert space" (over a *-division ring).  A Hilbert
       space is a pre-Hilbert space such that all closed subspaces have a
       projection decomposition.  (Contributed by NM, 7-Oct-2011.)  (Revised by
       Mario Carneiro, 22-Jun-2014.) $)
    ishil $p |- ( H e. Hil <-> ( H e. PreHil /\ dom K = C ) ) $=
      ( vh cv cpj cfv cdm ccss wceq cphl chs fveq2 syl6eqr dmeqd eqeq12d df-hil
      elrab2 ) FGZHIZJZUAKIZLCJZALFBMNUABLZUCUEUDAUFUBCUFUBBHICUABHODPQUFUDBKIA
      UABKOEPRFST $.
  $}

  ${
    $d s C $.  $d s H $.
    ishil2.v $e |- V = ( Base ` H ) $.
    ishil2.s $e |- .(+) = ( LSSum ` H ) $.
    ishil2.o $e |- ._|_ = ( ocv ` H ) $.
    ishil2.c $e |- C = ( CSubSp ` H ) $.
    $( The predicate "is a Hilbert space" (over a *-division ring).
       (Contributed by NM, 7-Oct-2011.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    ishil2 $p |- ( H e. Hil
        <-> ( H e. PreHil /\ A. s e. C ( s .(+) ( ._|_ ` s ) ) = V ) ) $=
      ( chs wcel cphl cfv wceq wa wral eqid wss wb cpj cv ishil pjcss eqss baib
      cdm co dfss3 syl6bb clss csslss pjdm2 baibd syldan ralbidva bitrd pm5.32i
      syl bitri ) CKLCMLZCUANZUGZAOZPVAFUBZVEDNBUHEOZFAQZPACVBVBRZJUCVAVDVGVAVD
      VEVCLZFAQZVGVAVDAVCSZVJVAVCASZVDVKTAVBCVHJUDVDVLVKVCAUEUFUSFAVCUIUJVAVIVF
      FAVAVEALVECUKNZLZVIVFTAVEVMCJVMRZULVAVIVNVFBVEVBVMDECGVOIHVHUMUNUOUPUQURU
      T $.
  $}

  ${
    $d b h x y ., $.  $d b h ._|_ $.  $d b h x y .0. $.  $d x y P $.  $d y Q $.
    $d b h x y .1. $.  $d b x y B $.  $d b h V $.  $d b h x y W $.  $d b h Y $.
    isobs.v $e |- V = ( Base ` W ) $.
    isobs.h $e |- ., = ( .i ` W ) $.
    isobs.f $e |- F = ( Scalar ` W ) $.
    isobs.u $e |- .1. = ( 1r ` F ) $.
    isobs.z $e |- .0. = ( 0g ` F ) $.
    ${
      isobs.o $e |- ._|_ = ( ocv ` W ) $.
      isobs.y $e |- Y = ( 0g ` W ) $.
      $( The predicate "is an orthonormal basis" (over a pre-Hilbert space).
         (Contributed by Mario Carneiro, 23-Oct-2015.) $)
      isobs $p |- ( B e. ( OBasis ` W ) <-> ( W e. PreHil /\ B C_ V /\
        ( A. x e. B A. y e. B ( x ., y ) = if ( x = y , .1. , .0. ) /\
          ( ._|_ ` B ) = { Y } ) ) ) $=
        ( cfv wceq vh vb cobs wcel cphl wss cv co cif wral csn w3a cdm cip csca
        wa cur c0g cocv cbs cpw crab df-obs dmmptss elfvdm sseldi fveq2 syl6eqr
        pweqd oveqd fveq2d ifeq12d eqeq12d 2ralbidv sneqd anbi12d rabeqbidv cvv
        fveq1d fvex pwex rabex fvmpt eleq2d raleq raleqbi1dv eqeq1d elrab elpw2
        eqeltri anbi1i bitri syl6bb biadan2 3anass bitr4i ) CIUCSZUDZIUEUDZCHUF
        ZAUGZBUGZFUHZXAXBTZDKUIZTZBCUJZACUJZCGSZJUKZTZUPZUPZUPWSWTXLULWRWSXMWRU
        CUMUEIUAUEXAXBUAUGZUNSZUHZXDXNUOSZUQSZXQURSZUIZTZBUBUGZUJAYBUJZYBXNUSSZ
        SZXNURSZUKZTZUPZUBXNUTSZVAZVBZUCABUAUBVCZVDCIUCVEVFWSWRCXFBYBUJZAYBUJZY
        BGSZXJTZUPZUBHVAZVBZUDZXMWSWQYTCUAIYLYTUEUCXNITZYIYRUBYKYSUUBYJHUUBYJIU
        TSZHXNIUTVGLVHVIUUBYCYOYHYQUUBYAXFABYBYBUUBXPXCXTXEUUBXOFXAXBUUBXOIUNSF
        XNIUNVGMVHVJUUBXDXRDXSKUUBXREUQSDUUBXQEUQUUBXQIUOSEXNIUOVGNVHZVKOVHUUBX
        SEURSKUUBXQEURUUDVKPVHVLVMVNUUBYEYPYGXJUUBYBYDGUUBYDIUSSGXNIUSVGQVHVSUU
        BYFJUUBYFIURSJXNIURVGRVHVOVMVPVQYMYRUBYSHHUUCVRLIUTVTWJZWAWBWCWDUUACYSU
        DZXLUPXMYRXLUBCYSYBCTZYOXHYQXKYNXGAYBCXFBYBCWEWFUUGYPXIXJYBCGVGWGVPWHUU
        FWTXLCHUUEWIWKWLWMWNWSWTXLWOWP $.
    $}

    $( The inner product of two elements of an orthonormal basis.  (Contributed
       by Mario Carneiro, 23-Oct-2015.) $)
    obsip $p |- ( ( B e. ( OBasis ` W ) /\ P e. B /\ Q e. B ) ->
                  ( P ., Q ) = if ( P = Q , .1. , .0. ) ) $=
      ( vx vy cfv wcel co wceq cobs cif cv wral wa cocv c0g csn cphl eqid isobs
      wss simp3bi simpld oveq1 eqeq1 ifbid eqeq12d oveq2 rspc2v syl5com 3impib
      eqeq2 ) AHUAQRZBARZCARZBCFSZBCTZDIUBZTZVDOUCZPUCZFSZVKVLTZDIUBZTZPAUDOAUD
      ZVEVFUEVJVDVQAHUFQZQHUGQZUHTZVDHUIRAGULVQVTUEOPADEFVRGHVSIJKLMNVRUJVSUJUK
      UMUNVPVJBVLFSZBVLTZDIUBZTOPBCAAVKBTZVMWAVOWCVKBVLFUOWDVNWBDIVKBVLUPUQURVL
      CTZWAVGWCVIVLCBFUSWEWBVHDIVLCBVCUQURUTVAVB $.
  $}

  ${
    obsipid.h $e |- ., = ( .i ` W ) $.
    obsipid.f $e |- F = ( Scalar ` W ) $.
    obsipid.u $e |- .1. = ( 1r ` F ) $.
    $( A basis element has unit length.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    obsipid $p |- ( ( B e. ( OBasis ` W ) /\ A e. B ) -> ( A ., A ) = .1. ) $=
      ( cobs cfv wcel wa co wceq c0g cif cbs eqid obsip 3anidm23 iftrue syl6eq
      ax-mp ) BFJKLZABLZMAAENZAAOZCDPKZQZCUEUFUGUJOBAACDEFRKZFUIUKSGHIUISTUAUHU
      JCOASUHCUIUBUDUC $.
  $}

  ${
    $d x y B $.  $d x y W $.
    $( Reverse closure for an orthonormal basis.  (Contributed by Mario
       Carneiro, 23-Oct-2015.) $)
    obsrcl $p |- ( B e. ( OBasis ` W ) -> W e. PreHil ) $=
      ( vx vy cobs cfv wcel cphl cbs wss cv cip wceq csca cur c0g cif wral eqid
      co cocv csn wa isobs simp1bi ) ABEFGBHGABIFZJCKZDKZBLFZTUGUHMBNFZOFZUJPFZ
      QMDARCARABUAFZFBPFZUBMUCCDAUKUJUIUMUFBUNULUFSUISUJSUKSULSUMSUNSUDUE $.

    obsss.v $e |- V = ( Base ` W ) $.
    $( An orthonormal basis is a subset of the base set.  (Contributed by Mario
       Carneiro, 23-Oct-2015.) $)
    obsss $p |- ( B e. ( OBasis ` W ) -> B C_ V ) $=
      ( vx vy cobs cfv wcel cphl wss cv cip co wceq csca cur c0g wral eqid cocv
      cif csn wa isobs simp2bi ) ACGHICJIABKELZFLZCMHZNUGUHOCPHZQHZUJRHZUBOFASE
      ASACUAHZHCRHZUCOUDEFAUKUJUIUMBCUNULDUITUJTUKTULTUMTUNTUEUF $.
  $}

  ${
    $d x y B $.  $d x y W $.
    obsocv.z $e |- .0. = ( 0g ` W ) $.
    $( A basis element is nonzero.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    obsne0 $p |- ( ( B e. ( OBasis ` W ) /\ A e. B ) -> A =/= .0. ) $=
      ( cobs cfv wcel csca cur c0g wne cdr cphl clvec obsrcl eqid adantr wceq
      wa phllvec lvecdrng drngunz syl cip co obsipid eqeq1d cbs wb obsss sselda
      3syl ipeq0 syl2anc bitr3d necon3bid mpbid ) BCFGHZABHZTZCIGZJGZVBKGZLZADL
      VAVBMHZVEUSVFUTUSCNHZCOHVFBCPZCUAVBCVBQZUBUMRVBVCVDVDQZVCQZUCUDVAVCVDADVA
      AACUEGZUFZVDSZVCVDSADSZVAVMVCVDABVCVBVLCVLQZVIVKUGUHVAVGACUIGZHVNVOUJUSVG
      UTVHRUSBVQABVQCVQQZUKULAVBVLVQCDVDVIVPVRVJEUNUOUPUQUR $.

    obsocv.o $e |- ._|_ = ( ocv ` W ) $.
    $( An orthonormal basis has trivial orthocomplement.  (Contributed by Mario
       Carneiro, 23-Oct-2015.) $)
    obsocv $p |- ( B e. ( OBasis ` W ) -> ( ._|_ ` B ) = { .0. } ) $=
      ( vx vy cobs cfv wcel cv cip co wceq csca cur c0g wral eqid cif csn isobs
      cphl cbs wss wa simp3bi simprd ) ACIJKZGLZHLZCMJZNUKULOCPJZQJZUNRJZUAOHAS
      GASZABJDUBOZUJCUDKACUEJZUFUQURUGGHAUOUNUMBUSCDUPUSTUMTUNTUOTUPTFEUCUHUI
      $.
  $}

  ${
    obs2ocv.o $e |- ._|_ = ( ocv ` W ) $.
    obs2ocv.v $e |- V = ( Base ` W ) $.
    $( The double orthocomplement (closure) of an orthonormal basis is the
       whole space.  (Contributed by Mario Carneiro, 23-Oct-2015.) $)
    obs2ocv $p |- ( B e. ( OBasis ` W ) -> ( ._|_ ` ( ._|_ ` B ) ) = V ) $=
      ( cobs cfv wcel c0g csn eqid obsocv fveq2d cphl wceq obsrcl ocvz eqtrd
      syl ) ADGHIZABHZBHDJHZKZBHZCUAUBUDBABDUCUCLZEMNUADOIUECPADQBCDUCFEUFRTS
      $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x W $.
    obselocv.o $e |- ._|_ = ( ocv ` W ) $.
    $( A basis element is in the orthocomplement of a subset of the basis iff
       it is not in the subset.  (Contributed by Mario Carneiro,
       23-Oct-2015.) $)
    obselocv $p |- ( ( B e. ( OBasis ` W ) /\ C C_ B /\ A e. B ) ->
       ( A e. ( ._|_ ` C ) <-> -. A e. C ) ) $=
      ( vx cfv wcel wss w3a wn wa c0g eqid wceq cin 3ad2ant1 syl syl2anc wi wne
      cobs obsne0 3adant2 csn elin clspn clmod obsrcl phllmod simp2 obsss sstrd
      cphl lspssid ssrin ocvlsp ineq2d lspcl ocvin eqtr3d sseqtrd sseld syl5bir
      cbs clss elsni syl6 necon3ad mpd imnan sylibr con2d cv co csca wral simpr
      cip eleq1 syl5ibrcom con3d cur simpl1 simpl3 sselda obsip syl3anc iffalse
      cif eqeq2d syl5ibcom ralrimdva wb simp3 sseldd elocv df-3an bitri sylibrd
      syld baib impbid ) BEUCHIZCBJZABIZKZACDHZIZACIZLZXHXKXJXHXKXJMZLZXKXJLUAX
      HAENHZUBZXNXEXGXPXFABEXOXOOZUDUEXHXMAXOXHXMAXOUFZIZAXOPXMACXIQZIXHXSACXIU
      GXHXTXRAXHXTCEUHHZHZXIQZXRXHCYBJZXTYCJXHEUIIZCEVFHZJZYDXHEUOIZYEXEXFYHXGB
      EUJRZEUKSZXHCBYFXEXFXGULZXEXFBYFJXGBYFEYFOZUMRZUNZCYAYFEYLYAOZUPTCYBXIUQS
      XHYBYBDHZQZYCXRXHYPXIYBXHYHYGYPXIPYIYNCYADYFEYLFYOURTUSXHYHYBEVGHZIZYQXRP
      YIXHYEYGYSYJYNYRCYAYFEYLYROZYOUTTYBYRDEXOFYTXQVATVBVCVDVEAXOVHVIVJVKXKXJV
      LVMVNXHXLAGVOZEVTHZVPZEVQHZNHZPZGCVRZXJXHXLUUFGCXHUUACIZMZXLAUUAPZLZUUFUU
      IUUJXKUUIXKUUJUUHXHUUHVSAUUACWAWBWCUUIUUCUUJUUDWDHZUUEWKZPZUUKUUFUUIXEXGU
      UABIUUNXEXFXGUUHWEXEXFXGUUHWFXHCBUUAYKWGBAUUAUULUUDUUBYFEUUEYLUUBOZUUDOZU
      ULOUUEOZWHWIUUKUUMUUEUUCUUJUULUUEWJWLWMXBWNXHYGAYFIZXJUUGWOYNXHBYFAYMXEXF
      XGWPWQXJYGUURMZUUGXJYGUURUUGKUUSUUGMGACUUDUUBDYFEUUEYLUUOUUPUUQFWRYGUURUU
      GWSWTXCTXAXD $.
  $}

  ${
    $d x B $.  $d x C $.  $d x W $.
    $( A basis has no proper subsets that are also bases.  (Contributed by
       Mario Carneiro, 23-Oct-2015.) $)
    obs2ss $p |- ( ( B e. ( OBasis ` W ) /\ C e. ( OBasis ` W ) /\ C C_ B ) ->
                   C = B ) $=
      ( vx cobs cfv wcel wss w3a simp3 cv wa c0g wne eqid obsne0 3ad2antl1 cocv
      wn wceq obselocv 3expa 3adantl2 csn simpl2 obsocv syl eleq2d elsni syl6bi
      wb sylbird necon1ad mpd ex ssrdv eqssd ) ACEFZGZBURGZBAHZIZBAUSUTVAJVBDAB
      VBDKZAGZVCBGZVBVDLZVCCMFZNZVEUSUTVDVHVAVCACVGVGOZPQVFVEVCVGVFVESZVCBCRFZF
      ZGZVCVGTZUSVAVDVMVJUKZUTUSVAVDVOVCABVKCVKOZUAUBUCVFVMVCVGUDZGVNVFVLVQVCVF
      UTVLVQTUSUTVAVDUEBVKCVGVIVPUFUGUHVCVGUIUJULUMUNUOUPUQ $.
  $}

  ${
    $d x y B $.  $d x J $.  $d x y N $.  $d x y W $.
    obslbs.j $e |- J = ( LBasis ` W ) $.
    obslbs.n $e |- N = ( LSpan ` W ) $.
    obslbs.c $e |- C = ( CSubSp ` W ) $.
    $( An orthogonal basis is a linear basis iff the span of the basis elements
       is closed (which is usually not true).  (Contributed by Mario Carneiro,
       29-Oct-2015.) $)
    obslbs $p |- ( B e. ( OBasis ` W ) -> ( B e. J <-> ( N ` B ) e. C ) ) $=
      ( vx vy cfv wcel wceq wss eqid syl2anc wb syl wi wa cobs cocv cphl obsrcl
      cbs obsss ocvlsp fveq2d obs2ocv eqtrd eqeq2d iscss clvec wpss wal phllvec
      cv wn wex pssnel adantl c0g csn wne pssss ad2antlr simpr obselocv syl3anc
      simpll obsne0 elsni necon3ai nelne1 expcom sylbird clmod phllmod ad2antrr
      npss sstrd lspssv fveq2 ocv1 eqeq12d syl5ib embantd necon1ad syld expimpd
      syl5bi exlimdv mpd ex alrimiv w3a islbs3 3anan32 syl6bb syl12anc 3bitr4rd
      baibd ) AEUAKLZADKZXDEUBKZKZXEKZMZXDEUEKZMZXDBLZACLZXCXGXIXDXCXGAXEKZXEKX
      IXCXFXMXEXCEUCLZAXINZXFXMMAEUDZAXIEXIOZUFZADXEXIEXQXEOZGUGPUHAXEXIEXSXQUI
      UJUKXCXNXKXHQXPBXDXEEUCXSHULRXCEUMLZXOIUQZAUNZYADKZXIUNZSZIUOZXLXJQXCXNXT
      XPEUPRXRXCYEIXCYBYDXCYBTZJUQZALZYHYALURZTZJUSZYDYBYLXCJYAAUTVAYGYKYDJYGYI
      YJYDYGYITZYJYAXEKZEVBKZVCZVDZYDYMYJYHYNLZYQYMXCYAANZYIYRYJQXCYBYIVJZYBYSX
      CYIYAAVEVFZYGYIVGZYHAYAXEEXSVHVIYMYHYPLZURZYRYQSYMYHYOVDZUUDYMXCYIUUEYTUU
      BYHAEYOYOOZVKPUUCYHYOYHYOVLVMRYRUUDYQYHYNYPVNVORVPYMYDYNYPYDURYCXINZYCXIM
      ZSYMYNYPMZYCXIVTYMUUGUUHUUIYMEVQLZYAXINZUUGXCUUJYBYIXCXNUUJXPEVRRVSYMYAAX
      IUUAXCXOYBYIXRVSWAZYADXIEXQGWBPUUHYCXEKZXIXEKZMYMUUIYCXIXEWCYMUUMYNUUNYPY
      MXNUUKUUMYNMXCXNYBYIXPVSZUULYADXEXIEXQXSGUGPYMXNUUNYPMUUOXEXIEYOXQXSUUFWD
      RWEWFWGWKWHWIWJWLWMWNWOXTXLXOYFTZXJXTXLXOXJYFWPUUPXJTACDXIEIXQFGWQXOXJYFW
      RWSXBWTXA $.
  $}

$(
###############################################################################
                         BASIC TOPOLOGY
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Topology
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Topological spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare new constant symbols and define their syntactical properties. $)

  $c Top $.
  $c TopOn $.
  $c TopSpOLD $.
  $c TopSp $.
  $c TopBases $.

  $( Extend class notation with the class of all topologies. $)
  ctop $a class Top $.

  $( The class function of all topologies over a base set. $)
  ctopon $a class TopOn $.

  $( Extend class notation with the class of all topological spaces.
     (New usage is discouraged.) $)
  ctpsOLD $a class TopSpOLD $.

  $( Extend class notation with the class of all topological spaces. $)
  ctps $a class TopSp $.

  $( Extend class notation with the class of all topological bases. $)
  ctb $a class TopBases $.

  ${
    $d b j x y z w v $.
    $( Define the (proper) class of all topologies.  See ~ istop2g for an
       alternate way to express finite intersection and ~ istps5OLD for a
       standard definition in terms of both members of a topological space.
       (Contributed by NM, 3-Mar-2006.) $)
    df-top $a |- Top = { x | ( A. y e. ~P x U. y e. x /\
                             A. y e. x A. z e. x ( y i^i z ) e. x ) } $.

    $( Define the class of all topological spaces, each of which is an ordered
       pair the second of which is a topology on the first.  See ~ istps5OLD
       for a standard way to express a topological space.  (Contributed by NM,
       8-Mar-2006.)  (New usage is discouraged.) $)
    df-topspOLD $a |- TopSpOLD = { <. x , y >. | ( y e. Top /\ x = U. y ) } $.

    $( Define the class of all topological bases.  Equivalent to definition of
       basis in [Munkres] p. 78 (see ~ isbasis2g ).  Note that "bases" is the
       plural of "basis."  (Contributed by NM, 17-Jul-2006.) $)
    df-bases $a |- TopBases = { x | A. y e. x A. z e. x ( y i^i z ) C_
                      U. ( x i^i ~P ( y i^i z ) ) } $.

    $( Define the set of topologies with a given base set.  (Contributed by
       Stefan O'Rear, 31-Jan-2015.) $)
    df-topon $a |- TopOn = ( b e. _V |-> { j e. Top | b = U. j } ) $.
  $}

  $( Define the class of all topological spaces (structures).  (Contributed by
     Stefan O'Rear, 13-Aug-2015.) $)
  df-topsp $a |- TopSp = { f | ( TopOpen ` f ) e. ( TopOn ` ( Base ` f ) ) } $.

  ${
    $d x y z J $.  $d x A $.
    $( Express the predicate " ` J ` is a topology."  Note:  In the literature,
       a topology is often represented by a script letter T, which resembles
       the letter J. This confusion may have led to J being used by some
       authors - e.g.  K. D. Joshi, _Introduction to General Topology_ (1983),
       p. 114 - and it is convenient for us since we later use ` T ` to
       represent linear transformations (operators).  (Contributed by Stefan
       Allan, 3-Mar-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    istopg $p |- ( J e. A -> ( J e. Top <-> ( A. x ( x C_ J -> U. x e. J )
                  /\ A. x e. J A. y e. J ( x i^i y ) e. J ) ) ) $=
      ( vz wcel ctop cv cuni cpw wral cin wa wss wal wceq pweq eleq2 raleqbi1dv
      wi anbi12d df-top elab2g df-ral elpw2g imbi1d albidv syl5bb anbi1d bitrd
      raleqbidv ) DCFZDGFAHZIZDFZADJZKZUMBHLZDFZBDKZADKZMZUMDNZUOTZAOZVAMUNEHZF
      ZAVFJZKZURVFFZBVFKZAVFKZMVBEDGCVFDPZVIUQVLVAVMVGUOAVHUPVFDQVFDUNRUKVKUTAV
      FDVJUSBVFDVFDURRSSUAEABUBUCULUQVEVAUQUMUPFZUOTZAOULVEUOAUPUDULVOVDAULVNVC
      UOUMDCUEUFUGUHUIUJ $.

    $( Express the predicate " ` J ` is a topology," using "the intersection of
       the elements of any finite subcollection" instead of the intersection of
       any two elements.  (Contributed by NM, 19-Jul-2006.) $)
    istop2g $p |- ( J e. A -> ( J e. Top <-> ( A. x ( x C_ J -> U. x e. J )
         /\ A. x ( ( x C_ J /\ x =/= (/) /\ x e. Fin ) -> |^| x e. J ) ) ) ) $=
      ( vy wcel ctop cv wss cuni wi wal cin wral wa c0 wne cfn w3a cint istopg
      fiint anbi2i syl6bb ) CBECFEAGZCHZUDICEJAKZUDDGLCEDCMACMZNUFUEUDOPUDQERUD
      SCEJAKZNADBCTUGUHUFADCUAUBUC $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y J $.
    $( The union of a subset of a topology is an open set.  (Contributed by
       Stefan Allan, 27-Feb-2006.) $)
    uniopn $p |- ( ( J e. Top /\ A C_ J ) -> U. A e. J ) $=
      ( vx vy ctop wcel wss cuni cv wi wal cin wral wa istopg ibi simpld elpw2g
      cpw biimpar wceq sseq1 unieq eleq1d imbi12d spcgv syl ex pm2.43d mpid imp
      com23 ) BEFZABGZAHZBFZUMUNCIZBGZUQHZBFZJZCKZUPUMVBUQDILBFDBMCBMZUMVBVCNCD
      EBOPQUMUNVBUPJZUMUNUNVDJUMUNNZVBUNUPVEABSZFZVBUNUPJZJUMVGUNABERTVAVHCAVFU
      QAUAZURUNUTUPUQABUBVIUSUOBUQAUCUDUEUFUGULUHUIUJUK $.

    $( The indexed union of a subset of a topology is an open set.
       (Contributed by NM, 5-Oct-2006.) $)
    iunopn $p |- ( ( J e. Top /\ A. x e. A B e. J ) -> U_ x e. A B e. J ) $=
      ( vy ctop wcel wral wa ciun cv wceq wrex cab dfiun2g adantl wss uniiunlem
      cuni ibi uniopn sylan2 eqeltrd ) DFGZCDGABHZIABCJZEKCLABMENZSZDUEUFUHLUDA
      EBCDOPUEUDUGDQZUHDGUEUIAEBCDDRTUGDUAUBUC $.

    $( The intersection of two open sets of a topology is also an open set.
       (Contributed by NM, 17-Jul-2006.) $)
    inopn $p |- ( ( J e. Top /\ A e. J /\ B e. J ) -> ( A i^i B ) e. J ) $=
      ( vx vy ctop wcel cin cv wral wa wss cuni wi wal istopg ibi simprd eleq1d
      wceq ineq1 ineq2 rspc2v syl5com 3impib ) CFGZACGZBCGZABHZCGZUFDIZEIZHZCGZ
      ECJDCJZUGUHKUJUFUKCLUKMCGNDOZUOUFUPUOKDEFCPQRUNUJAULHZCGDEABCCUKATUMUQCUK
      AULUASULBTUQUICULBAUBSUCUDUE $.

    $( A topology is closed under finite intersections.  (Contributed by Jeff
       Hankins, 7-Oct-2009.) $)
    fitop $p |- ( J e. Top -> ( fi ` J ) = J ) $=
      ( vx vy ctop wcel cv cin wral cfi cfv inopn 3expib ralrimivv inficl mpbid
      wceq ) ADEZBFZCFZGAEZCAHBAHAIJAPQTBCAAQRAESAETRSAKLMBCADNO $.

    $( The intersection of a non-empty finite family of open sets is open.
       (Contributed by FL, 20-Apr-2012.) $)
    fiinopn $p |- ( J e. Top -> ( ( A C_ J /\ A =/= (/) /\ A e. Fin )
        -> |^| A e. J ) ) $=
      ( vx wss c0 wne cfn wcel w3a ctop cint wi elpwg cv wceq sseq1 neeq1 com12
      cpw wal eleq1 3anbi123d inteq eleq1d imbi2d imbi12d wa istop2g ibi adantl
      cuni sp syl vtoclg 3exp com3r com4r syl6bir pm2.43a com4l pm2.43i 3imp )
      ABDZAEFZAGHZIZBJHZAKZBHZVCVDVEVGVILZVCVDVEVJLLVEVCVCVDVJVCVEVCVDVJLLZVEVC
      ABSZHZVEVKLABGMVEVCVDVMVJVCVDVEVMVJLZVCVDVEVNVMVFVJCNZBDZVOEFZVOGHZIZVGVO
      KZBHZLZLVFVJLCAVLVOAOZVSVFWBVJWCVPVCVQVDVRVEVOABPVOAEQVOAGUAUBWCWAVIVGWCV
      TVHBVOAUCUDUEUFVGVSWAVGVPVOUKBHLCTZVSWALZCTZUGZWEVGWGCJBUHUIWFWEWDWECULUJ
      UMRUNRUOUPUQURUSUTVAVBR $.

    $( The intersection of a non-empty finite family of open sets is open.
       (Contributed by Mario Carneiro, 14-Sep-2014.) $)
    iinopn $p |- ( ( J e. Top /\ ( A e. Fin /\ A =/= (/) /\
      A. x e. A B e. J ) ) -> |^|_ x e. A B e. J ) $=
      ( vy ctop wcel cfn c0 wne wral w3a wa ciin cv wceq wrex syl wss sylib cab
      cint simpr3 dfiin2g simpl cmpt crn eqid rnmpt wf frn syl5eqssr cdm simpr2
      fmpt fdm eqnetrd dm0rn0 eqeq1i bitri necon3bii simpr1 abrexfi fiinopn imp
      syl13anc eqeltrd ) DFGZBHGZBIJZCDGABKZLZMZABCNZEOCPABQEUAZUBZDVMVKVNVPPVH
      VIVJVKUCZAEBCDUDRVMVHVODSZVOIJZVOHGZVPDGZVHVLUEVMVOABCUFZUGZDAEBCWBWBUHZU
      IZVMBDWBUJZWCDSVMVKWFVQABDCWBWDUOTZBDWBUKRULVMWBUMZIJVSVMWHBIVMWFWHBPWGBD
      WBUPRVHVIVJVKUNUQWHIVOIWHIPWCIPVOIPWBURWCVOIWEUSUTVATVMVIVTVHVIVJVKVBAEBC
      VCRVHVRVSVTLWAVODVDVEVFVG $.
  $}

  $( The union of two open sets is open.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  unopn $p |- ( ( J e. Top /\ A e. J /\ B e. J ) -> ( A u. B ) e. J ) $=
    ( ctop wcel w3a cpr cuni cun wceq uniprg 3adant1 wa wss prssi uniopn sylan2
    3impb eqeltrrd ) CDEZACEZBCEZFABGZHZABIZCUAUBUDUEJTABCCKLTUAUBUDCEZUAUBMTUC
    CNUFABCOUCCPQRS $.

  $( The empty set is an open subset of a topology.  (Contributed by Stefan
     Allan, 27-Feb-2006.) $)
  0opn $p |- ( J e. Top -> (/) e. J ) $=
    ( ctop wcel c0 cuni uni0 wss 0ss uniopn mpan2 syl5eqelr ) ABCZDDEZAFLDAGMAC
    AHDAIJK $.

  $( The empty set is not a topology.  (Contributed by FL, 1-Jun-2008.) $)
  0ntop $p |- -. (/) e. Top $=
    ( c0 ctop wcel noel 0opn mto ) ABCAACADAEF $.

  ${
    $d x A $.  $d x J $.  $d x X $.
    1open.1 $e |- X = U. J $.
    $( The underlying set of a topology is an open set.  (Contributed by NM,
       17-Jul-2006.) $)
    topopn $p |- ( J e. Top -> X e. J ) $=
      ( ctop wcel cuni wss ssid uniopn mpan2 syl5eqel ) ADEZBAFZACLAAGMAEAHAAIJ
      K $.

    $( A member of a topology is a subset of its underlying set.  (Contributed
       by NM, 12-Sep-2006.) $)
    eltopss $p |- ( ( J e. Top /\ A e. J ) -> A C_ X ) $=
      ( wcel wss ctop cuni elssuni syl6sseqr adantl ) ABEZACFBGELABHCABIDJK $.

    $( A finite indexed relative intersection of open sets is open.
       (Contributed by Mario Carneiro, 22-Aug-2015.) $)
    riinopn $p |- ( ( J e. Top /\ A e. Fin /\ A. x e. A B e. J ) ->
        ( X i^i |^|_ x e. A B ) e. J ) $=
      ( ctop wcel cfn wral w3a ciin cin c0 wceq wa riin0 adantl simpl1 eqeltrd
      topopn syl wne wss wi eltopss ex adantr ralimdv 3impia riinn0 sylan 3exp2
      iinopn com34 3imp1 pm2.61dane ) DGHZBIHZCDHZABJZKZEABCLZMZDHBNVBBNOZPZVDE
      DVEVDEOVBAECBQRVFUREDHURUSVAVESDEFUAUBTVBBNUCZPVDVCDVBCEUDZABJZVGVDVCOURU
      SVAVIURUSPUTVHABURUTVHUEUSURUTVHCDEFUFUGUHUIUJAECBUKULURUSVAVGVCDHZURUSVG
      VAVJURUSVGVAVJABCDUNUMUOUPTUQ $.

    $( A finite relative intersection of open sets is open.  (Contributed by
       Mario Carneiro, 22-Aug-2015.) $)
    rintopn $p |- ( ( J e. Top /\ A C_ J /\ A e. Fin ) ->
        ( X i^i |^| A ) e. J ) $=
      ( vx ctop wcel wss cfn w3a cint cin ciin intiin ineq2i wral dfss3 riinopn
      cv 3com23 syl3an2b syl5eqel ) BFGZABHZAIGZJCAKZLCEAESZMZLZBUFUHCEANOUDUCU
      GBGEAPZUEUIBGZEABQUCUEUJUKEAUGBCDRTUAUB $.
  $}

  ${
    $d x y A $.  $d x y J $.
    $( Construct a topological space from a topology and vice-versa.  We say
       that ` A ` is a topology on ` U. A ` .  (This could be proved more
       efficiently from ~ istpsOLD , but the proof here does not require the
       Axiom of Regularity.)  (Contributed by NM, 8-Mar-2006.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eltopspOLD $p |- ( <. U. J , J >. e. TopSpOLD <-> J e. Top ) $=
      ( vy vx cuni cop ctpsOLD wcel cvv wa ctop wbr df-br wrel cv copab relopab
      wceq df-topspOLD releqi jca mpbir sylbir uniexb sylibr uniexg elex anbi2d
      brrelexi eqeq1 eleq1 eqeq2d anbi12d opelopabg eleq2i eqid biantru 3bitr4g
      unieq pm5.21nii ) ADZAEZFGZUTHGZAHGZIZAJGZVBVCVDVBUTAFKVCUTAFLUTAFFMBNZJG
      ZCNZVGDZQZIZCBOZMVLCBPFVMCBRZSUAUHUBZVBVCVDVOAUCUDTVFVCVDAJUEAJUFTVEVAVMG
      VFUTUTQZIZVBVFVLVHUTVJQZIVQCBUTAHHVIUTQVKVRVHVIUTVJUIUGVGAQZVHVFVRVPVGAJU
      JVSVJUTUTVGAURUKULUMFVMVAVNUNVPVFUTUOUPUQUS $.

    $( Existence implied by membership in a topological space.  (Contributed by
       NM, 18-Jul-2006.)  (Revised by Mario Carneiro, 30-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    tpsexOLD $p |- ( <. A , J >. e. TopSpOLD -> ( A e. _V /\ J e. _V ) ) $=
      ( vy vx cop ctpsOLD wcel wbr cvv wa df-br wrel ctop cuni wceq df-topspOLD
      cv relopabi brrelex12 mpan sylbir ) ABEFGABFHZAIGBIGJZABFKFLUBUCCQZMGDQUD
      NOJDCFDCPRABFSTUA $.

    $( Express the predicate "is a topological space."  (Contributed by NM,
       18-Jul-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    istpsOLD $p |- ( <. A , J >. e. TopSpOLD <-> ( J e. Top /\ A = U. J ) ) $=
      ( vy vx cop ctpsOLD wcel cvv ctop cuni wceq tpsexOLD simpr uniexg eqeltrd
      wa adantr elex jca cv copab df-topspOLD eleq2i eqeq1 anbi2d eleq1 anbi12d
      unieq eqeq2d opelopabg syl5bb pm5.21nii ) ABEZFGZAHGZBHGZPZBIGZABJZKZPZAB
      LVAUOUPVAAUSHURUTMURUSHGUTBINQOURUPUTBIRQSUNUMCTZIGZDTZVBJZKZPZDCUAZGUQVA
      FVHUMDCUBUCVGVCAVEKZPVADCABHHVDAKVFVIVCVDAVEUDUEVBBKZVCURVIUTVBBIUFVJVEUS
      AVBBUHUIUGUJUKUL $.

    $( Express the predicate "is a topological space."  (Contributed by NM,
       18-Jul-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    istps2OLD $p |- ( <. A , J >. e. TopSpOLD <-> ( ( J e. Top /\ J C_ ~P A )
                  /\ ( (/) e. J /\ A e. J ) ) ) $=
      ( ctop wcel cuni wceq wa cpw wss c0 cop ctpsOLD eqimss adantl 0opn adantr
      simpr eqid topopn eqeltrrd jca32 ex unissel adantrl impbid1 eqcom sspwuni
      anbi1i 3bitr4g pm5.32i istpsOLD anass 3bitr4i ) BCDZABEZFZGUNBAHIZJBDZABD
      ZGZGZGABKLDUNUQGUTGUNUPVAUNUOAFZUOAIZUTGZUPVAUNVBVDUNVBVDUNVBGZVCURUSVBVC
      UNUOAMNUNURVBBOPVEUOABUNVBQUNUOBDVBBUOUORSPTUAUBVCUSVBURBAUCUDUEAUOUFUQVC
      UTBAUGUHUIUJABUKUNUQUTULUM $.

    $( A standard textbook definition of a topological space.  (Contributed by
       NM, 18-Jul-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    istps3OLD $p |- ( <. A , J >. e. TopSpOLD <-> ( ( J C_ ~P A /\ (/) e. J /\
                 A e. J ) /\ ( A. x ( x C_ J -> U. x e. J ) /\
                 A. x e. J A. y e. J ( x i^i y ) e. J ) ) ) $=
      ( cop ctpsOLD wcel ctop cpw wss wa c0 w3a cv cuni wi wal cin wral cvv syl
      istps2OLD anass ancom 3anass anbi1i wb pwexg ssexg sylan2 3adant2 pm5.32i
      istopg 3bitr2i 3bitri ) CDEFGDHGZDCIZJZKLDGZCDGZKZKUPURVAKZKZURUSUTMZANZD
      JVEODGPAQVEBNRDGBDSADSKZKZCDUBUPURVAUCVCVBUPKVDUPKVGUPVBUDVDVBUPURUSUTUEU
      FVDUPVFVDDTGZUPVFUGURUTVHUSUTURUQTGVHCDUHDUQTUIUJUKABTDUMUAULUNUO $.

    $( A standard textbook definition of a topological space.  (Contributed by
       NM, 19-Jul-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    istps4OLD $p |- ( <. A , J >. e. TopSpOLD <-> ( ( J C_ ~P A /\ (/) e. J /\
       A e. J ) /\ ( A. x ( x C_ J -> U. x e. J ) /\ A. x ( ( x C_ J /\
       x =/= (/) /\ x e. Fin ) -> |^| x e. J ) ) ) ) $=
      ( vy cop ctpsOLD wcel cpw wss c0 w3a cv cuni wi wal cin wral wne anbi2i
      wa cfn cint istps3OLD fiint bitri ) BCEFGCBHIJCGBCGKZALZCIZUGMCGNAOZUGDLP
      CGDCQACQZTZTUFUIUHUGJRUGUAGKUGUBCGNAOZTZTADBCUCUKUMUFUJULUIADCUDSSUE $.

    $( A standard textbook definition of a topological space ` <. A , J >. ` :
       a topology on ` A ` is a collection ` J ` of subsets of ` A ` such that
       ` (/) ` and ` A ` are in ` J ` and that is closed under union and finite
       intersection.  Definition of topological space in [Munkres] p. 76.
       (Contributed by NM, 19-Jul-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    istps5OLD $p |- ( <. A , J >. e. TopSpOLD <-> ( ( A. x e. J x C_ A /\ (/)
        e. J
                 /\ A e. J ) /\ ( A. x ( x C_ J -> U. x e. J ) /\
           A. x ( ( x C_ J /\ x =/= (/) /\ x e. Fin ) -> |^| x e. J ) ) ) ) $=
      ( cop ctpsOLD wcel cpw wss c0 w3a cv cuni wal wne cfn cint wral istps4OLD
      wi wa pwssb 3anbi1i anbi1i bitri ) BCDEFCBGHZICFZBCFZJZAKZCHZUILCFSAMUJUI
      INUIOFJUIPCFSAMTZTUIBHACQZUFUGJZUKTABCRUHUMUKUEULUFUGACBUAUBUCUD $.
  $}

  ${
    $d B b j $.  $d J b j $.
    $( Property of being a topology with a given base set.  (Contributed by
       Stefan O'Rear, 31-Jan-2015.)  (Revised by Mario Carneiro,
       13-Aug-2015.) $)
    istopon $p |- ( J e. ( TopOn ` B ) <-> ( J e. Top /\ B = U. J ) ) $=
      ( vj vb ctopon cfv wcel cvv ctop cuni wceq wa elfvex uniexg crab cpw pwex
      cv vex wss eleq1 syl5ibrcom imp eqeq1 rabbidv df-topon wi rabss syl5sseqr
      pwuni pweq elpw sylibr a1i mprgbir ssexi eleq2d unieq eqeq2d elrab syl6bb
      fvmpt3i pm5.21nii ) BAEFZGZAHGZBIGZABJZKZLZBAEMVGVIVFVGVFVIVHHGBINAVHHUAU
      BUCVFVEBACRZJZKZCIOZGVJVFVDVNBDADRZVLKZCIOZVNHEVOAKVPVMCIVOAVLUDUECDUFVQV
      OPZPZVRVODSQQVQVSTVPVKVSGZUGZCIVPCIVSUHWAVKIGVPVKVRTVTVPVLPVKVRVKUJVOVLUK
      UIVKVRCSULUMUNUOUPVBUQVMVICBIVKBKVLVHAVKBURUSUTVAVC $.
  $}

  $( A topology on a given base set is a topology.  (Contributed by Mario
     Carneiro, 13-Aug-2015.) $)
  topontop $p |- ( J e. ( TopOn ` B ) -> J e. Top ) $=
    ( ctopon cfv wcel ctop cuni wceq istopon simplbi ) BACDEBFEABGHABIJ $.

  $( The base set of a topology on a given base set.  (Contributed by Mario
     Carneiro, 13-Aug-2015.) $)
  toponuni $p |- ( J e. ( TopOn ` B ) -> B = U. J ) $=
    ( ctopon cfv wcel ctop cuni wceq istopon simprbi ) BACDEBFEABGHABIJ $.

  $( The base set of a topology is an open set.  (Contributed by Mario
     Carneiro, 13-Aug-2015.) $)
  toponmax $p |- ( J e. ( TopOn ` B ) -> B e. J ) $=
    ( ctopon cfv wcel cuni toponuni ctop topontop eqid topopn syl eqeltrd ) BAC
    DEZABFZBABGNBHEOBEABIBOOJKLM $.

  $( A member of a topology is a subset of its underlying set.  (Contributed by
     Mario Carneiro, 21-Aug-2015.) $)
  toponss $p |- ( ( J e. ( TopOn ` X ) /\ A e. J ) -> A C_ X ) $=
    ( ctopon cfv wcel wa cuni wss elssuni adantl wceq toponuni adantr sseqtr4d
    ) BCDEFZABFZGABHZCQARIPABJKPCRLQCBMNO $.

  $( If ` K ` is a topology on the base set of topology ` J ` , then ` J ` is a
     topology on the base of ` K ` .  (Contributed by Mario Carneiro,
     22-Aug-2015.) $)
  toponcom $p |- ( ( J e. Top /\ K e. ( TopOn ` U. J ) ) ->
      J e. ( TopOn ` U. K ) ) $=
    ( ctop wcel cuni ctopon cfv wa wceq toponuni eqcomd anim2i istopon sylibr )
    ACDZBAEZFGDZHOBEZPIZHARFGDQSOQPRPBJKLRAMN $.

  ${
    topontopi.1 $e |- J e. ( TopOn ` B ) $.
    $( A topology on a given base set is a topology.  (Contributed by Mario
       Carneiro, 13-Aug-2015.) $)
    topontopi $p |- J e. Top $=
      ( ctopon cfv wcel ctop topontop ax-mp ) BADEFBGFCABHI $.

    $( The base set of a topology on a given base set.  (Contributed by Mario
       Carneiro, 13-Aug-2015.) $)
    toponunii $p |- B = U. J $=
      ( ctopon cfv wcel cuni wceq toponuni ax-mp ) BADEFABGHCABIJ $.
  $}

  ${
    toptopon.1 $e |- X = U. J $.
    $( Alternative definition of ` Top ` in terms of ` TopOn ` .  (Contributed
       by Mario Carneiro, 13-Aug-2015.) $)
    toptopon $p |- ( J e. Top <-> J e. ( TopOn ` X ) ) $=
      ( ctopon cfv wcel ctop cuni wceq istopon mpbiran2 bicomi ) ABDEFZAGFZMNBA
      HICBAJKL $.
  $}

  $( The topologies over the same set have the greatest element (the discrete
     topology) and the least element (the indiscrete topology).  (Contributed
     by FL, 18-Apr-2010.)  (Revised by Mario Carneiro, 16-Sep-2015.) $)
  topgele $p |- ( J e. ( TopOn ` X ) -> ( { (/) , X } C_ J /\ J C_ ~P X ) ) $=
    ( ctopon cfv wcel c0 cpr wss cpw ctop topontop 0opn syl toponmax cvv wa 0ex
    wb prssg sylancr mpbi2and cuni wceq toponuni eqimss2 sspwuni sylibr jca ) A
    BCDEZFBGAHZABIHZUIFAEZBAEZUJUIAJEULBAKALMBANZUIFOEUMULUMPUJRQUNFBAOASTUAUIA
    UBZBHZUKUIBUOUCUPBAUDUOBUEMABUFUGUH $.

  $( The only topology on a singleton is the discrete topology (which is also
     the indiscrete topology by ~ pwsn ).  (Contributed by FL, 5-Jan-2009.)
     (Revised by Mario Carneiro, 16-Sep-2015.) $)
  topsn $p |- ( J e. ( TopOn ` { A } ) -> J = ~P { A } ) $=
    ( csn ctopon cfv wcel cpw cpr wss topgele simprd pwsn simpld syl5eqss eqssd
    c0 ) BACZDEFZBQGZRPQHZBIZBSIZBQJZKRSTBALRUAUBUCMNO $.

  ${
    $d f A $.  $d f J $.  $d f K $.
    istps.a $e |- A = ( Base ` K ) $.
    istps.j $e |- J = ( TopOpen ` K ) $.
    $( Express the predicate "is a topological space."  (Contributed by Mario
       Carneiro, 13-Aug-2015.) $)
    istps $p |- ( K e. TopSp <-> J e. ( TopOn ` A ) ) $=
      ( vf ctps wcel cv ctopn cfv cbs ctopon df-topsp eleq2i ctop fveq2 syl6eqr
      cab c0 cvv topontop wn 0ntop fvprc syl5eq eleq1d mtbiri con4i wceq fveq2d
      syl eleq12d elab3 bitri ) CGHCFIZJKZUPLKZMKZHZFSZHBAMKZHZGVACFNOUTVCFCVCB
      PHZCUAHZABUBVEVDVEUCZVDTPHUDVFBTPVFBCJKZTECJUEUFUGUHUIULUPCUJZUQBUSVBVHUQ
      VGBUPCJQERVHURAMVHURCLKAUPCLQDRUKUMUNUO $.

    $( Express the predicate "is a topological space."  (Contributed by NM,
       20-Oct-2012.) $)
    istps2 $p |- ( K e. TopSp <-> ( J e. Top /\ A = U. J ) ) $=
      ( ctps wcel ctopon cfv ctop cuni wceq wa istps istopon bitri ) CFGBAHIGBJ
      GABKLMABCDENABOP $.

    $( The base set of a topological space.  (Contributed by FL,
       27-Jun-2014.) $)
    tpsuni $p |- ( K e. TopSp -> A = U. J ) $=
      ( ctps wcel ctop cuni wceq istps2 simprbi ) CFGBHGABIJABCDEKL $.
  $}

  ${
    tpstop.j $e |- J = ( TopOpen ` K ) $.
    $( The topology extractor on a topological space is a topology.
       (Contributed by FL, 27-Jun-2014.) $)
    tpstop $p |- ( K e. TopSp -> J e. Top ) $=
      ( ctps wcel ctop cbs cfv cuni wceq eqid istps2 simplbi ) BDEAFEBGHZAIJNAB
      NKCLM $.
  $}

  ${
    tpspropd.1 $e |- ( ph -> ( Base ` K ) = ( Base ` L ) ) $.
    tpspropd.2 $e |- ( ph -> ( TopOpen ` K ) = ( TopOpen ` L ) ) $.
    $( A topological space depends only on the base and topology components.
       (Contributed by NM, 18-Jul-2006.)  (Revised by Mario Carneiro,
       13-Aug-2015.) $)
    tpspropd $p |- ( ph -> ( K e. TopSp <-> L e. TopSp ) ) $=
      ( ctopn cfv cbs ctopon wcel ctps fveq2d eleq12d eqid istps 3bitr4g ) ABFG
      ZBHGZIGZJCFGZCHGZIGZJBKJCKJAQTSUBEARUAIDLMRQBRNQNOUATCUANTNOP $.
  $}

  ${
    tpsprop2d.1 $e |- ( ph -> ( Base ` K ) = ( Base ` L ) ) $.
    tpsprop2d.2 $e |- ( ph -> ( TopSet ` K ) = ( TopSet ` L ) ) $.
    $( A topological space depends only on the base and topology components.
       (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    tpsprop2d $p |- ( ph -> ( K e. TopSp <-> L e. TopSp ) ) $=
      ( topnpropd tpspropd ) ABCDABCDEFG $.
  $}

  ${
    $d f A $.  $d f J $.  $d f K $.
    tsettps.a $e |- A = ( Base ` K ) $.
    tsettps.j $e |- J = ( TopSet ` K ) $.
    $( Express the predicate "is a topological space."  (Contributed by Mario
       Carneiro, 13-Aug-2015.) $)
    topontopn $p |- ( J e. ( TopOn ` A ) -> J = ( TopOpen ` K ) ) $=
      ( ctopon cfv wcel cpw wss ctopn wceq cuni toponuni eqimss2 sspwuni sylibr
      syl topnid ) BAFGHZBAIJZBCKGLTBMZAJZUATAUBLUCABNUBAORBAPQABCDESR $.

    $( If the topology component is already correctly truncated, then it forms
       a topological space (with the topology extractor function coming out the
       same as the component).  (Contributed by Mario Carneiro,
       13-Aug-2015.) $)
    tsettps $p |- ( J e. ( TopOn ` A ) -> K e. TopSp ) $=
      ( ctopon cfv wcel ctopn ctps topontopn id eqeltrrd eqid istps sylibr ) BA
      FGZHZCIGZQHCJHRBSQABCDEKRLMASCDSNOP $.
  $}

  ${
    istpsi.b $e |- ( Base ` K ) = A $.
    istpsi.j $e |- ( TopOpen ` K ) = J $.
    istpsi.1 $e |- A = U. J $.
    istpsi.2 $e |- J e. Top $.
    $( Properties that determine a topological space.  (Contributed by NM,
       20-Oct-2012.) $)
    istpsi $p |- K e. TopSp $=
      ( ctps wcel ctop cuni wceq cbs cfv eqcomi ctopn istps2 mpbir2an ) CHIBJIA
      BKLGFABCCMNADOCPNBEOQR $.
  $}

  ${
    eltpsi.k $e |- K
         = { <. ( Base ` ndx ) , A >. , <. ( TopSet ` ndx ) , J >. } $.
    $( Properties that determine a topological space from a construction (using
       no explicit indices).  (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    eltpsg $p |- ( J e. ( TopOn ` A ) -> K e. TopSp ) $=
      ( ctopon cfv wcel cts cbs ctps c9 df-tset 9nn 2strop toponmax 2strbas syl
      1lt9 wceq eqid fveq2d eleq12d ibi tsettps ) BAEFZGZCHFZCIFZEFZGZCJGUFUJUF
      BUGUEUIABHCKUEDLRMNUFAUHEUFABGAUHSABOABHCKBDLRMPQUAUBUCUHUGCUHTUGTUDQ $.

    eltpsi.u $e |- A = U. J $.
    eltpsi.j $e |- J e. Top $.
    $( Properties that determine a topological space from a construction (using
       no explicit indices).  (Contributed by NM, 20-Oct-2012.)  (Revised by
       Mario Carneiro, 13-Aug-2015.) $)
    eltpsi $p |- K e. TopSp $=
      ( ctopon cfv wcel ctps ctop toptopon mpbi eltpsg ax-mp ) BAGHIZCJIBKIPFBA
      ELMABCDNO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      TopBases for topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z B $.
    $( Express the predicate " ` B ` is a basis for a topology."  (Contributed
       by NM, 17-Jul-2006.) $)
    isbasisg $p |- ( B e. C -> ( B e. TopBases <->
          A. x e. B A. y e. B ( x i^i y ) C_ U. ( B i^i ~P ( x i^i y ) ) ) ) $=
      ( vz cv cin cpw cuni wss wral ctb ineq1 unieqd sseq2d raleqbi1dv df-bases
      wceq elab2g ) AFBFGZEFZTHZGZIZJZBUAKZAUAKTCUBGZIZJZBCKZACKECLDUFUJAUACUEU
      IBUACUACRZUDUHTUKUCUGUACUBMNOPPEABQS $.

    $( Express the predicate " ` B ` is a basis for a topology."  (Contributed
       by NM, 17-Jul-2006.) $)
    isbasis2g $p |- ( B e. C -> ( B e. TopBases <->
           A. x e. B A. y e. B A. z e. ( x i^i y )
              E. w e. B ( z e. w /\ w C_ ( x i^i y ) ) ) ) $=
      ( wcel ctb cv cin cpw cuni wss wral wa wrex isbasisg wex anbi2i bitri
      dfss3 elin df-pw abeq2i exbii eluni df-rex 3bitr4i ralbii 2ralbii syl6bb
      an12 ) EFGEHGAIBIJZEUMKZJZLZMZBENAENCIZDIZGZUSUMMZOZDEPZCUMNZBENAENABEFQU
      QVDABEEUQURUPGZCUMNVDCUMUPUAVEVCCUMUTUSUOGZOZDRUSEGZVBOZDRVEVCVGVIDVGUTVH
      VAOZOVIVFVJUTVFVHUSUNGZOVJUSEUNUBVKVAVHVADUNDUMUCUDSTSUTVHVAULTUEDURUOUFV
      BDEUGUHUITUJUK $.

    $( Express the predicate " ` B ` is a basis for a topology."  Definition of
       basis in [Munkres] p. 78.  (Contributed by NM, 17-Jul-2006.) $)
    isbasis3g $p |- ( B e. C -> ( B e. TopBases <-> ( A. x e. B x C_ U. B /\
     A. x e. U. B E. y e. B x e. y /\ A. x e. B A. y e. B A. z e. ( x i^i y )
     E. w e. B ( z e. w /\ w C_ ( x i^i y ) ) ) ) ) $=
      ( wcel ctb wel cv cin wss wa wrex wral cuni w3a isbasis2g elssuni rgen
      eluni2 biimpi pm3.2i biantrur df-3an bitr4i syl6bb ) EFGEHGCDIDJAJZBJKZLM
      DENCUIOBEOAEOZUHEPZLZAEOZABIBENZAUKOZUJQZABCDEFRUJUMUOMZUJMUPUQUJUMUOULAE
      UHESTUNAUKUHUKGUNBUHEUAUBTUCUDUMUOUJUEUFUG $.
  $}

  ${
    $d w x A $.  $d w x y z B $.  $d w x y z C $.  $d w x y z D $.
    $( Property of a basis.  (Contributed by NM, 16-Jul-2006.) $)
    basis1 $p |- ( ( B e. TopBases /\ C e. B /\ D e. B ) ->
                    ( C i^i D ) C_ U. ( B i^i ~P ( C i^i D ) ) ) $=
      ( vx vy ctb wcel cin cpw cuni wss cv wral wa isbasisg pweqd ineq2d unieqd
      wceq sseq12d ibi ineq1 ineq2 rspc2v syl5com 3impib ) AFGZBAGZCAGZBCHZAUJI
      ZHZJZKZUGDLZELZHZAUQIZHZJZKZEAMDAMZUHUINUNUGVBDEAFOUAVAUNBUPHZAVCIZHZJZKD
      EBCAAUOBSZUQVCUTVFUOBUPUBZVGUSVEVGURVDAVGUQVCVHPQRTUPCSZVCUJVFUMUPCBUCZVI
      VEULVIVDUKAVIVCUJVJPQRTUDUEUF $.

    $( Property of a basis.  (Contributed by NM, 17-Jul-2006.) $)
    basis2 $p |- ( ( ( B e. TopBases /\ C e. B ) /\ ( D e. B /\
          A e. ( C i^i D ) ) ) -> E. x e. B ( A e. x /\ x C_ ( C i^i D ) ) ) $=
      ( vw vy vz ctb wcel cin cv wss wa wrex wi wral wceq rexbidv syl isbasis2g
      wb ineq1 sseq2 anbi2d raleqbi1dv ineq2 rspc2v eleq1 anbi1d rspccv syl6com
      ibi exp3a imp43 ) CIJZDCJZECJZBDEKZJZBALZJZVAUSMZNZACOZUPUQURUTVEPZUPFLZV
      AJZVAGLZHLZKZMZNZACOZFVKQZHCQGCQZUQURNZVFPUPVPGHFACIUAUMVQVPVHVCNZACOZFUS
      QZVFVOVTVHVADVJKZMZNZACOZFWAQZGHDECCVIDRVKWARZVOWEUBVIDVJUCVNWDFVKWAWFVMW
      CACWFVLWBVHVKWAVAUDUESUFTVJERWAUSRZWEVTUBVJEDUGWDVSFWAUSWGWCVRACWGWBVCVHW
      AUSVAUDUESUFTUHVSVEFBUSVGBRZVRVDACWHVHVBVCVGBVAUIUJSUKULTUNUO $.
  $}

  ${
    $d B w x y z $.  $d C w x y z $.
    $( If a set is closed under finite intersection, then it is a basis for a
       topology.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    fiinbas $p |- ( ( B e. C /\ A. x e. B A. y e. B ( x i^i y ) e. B )
                       -> B e. TopBases ) $=
      ( vz vw wcel cv cin wral ctb wss wa wrex wi ssid wceq eleq2 sseq1 ralimdv
      anbi12d rspcev mpanr2 ralrimiva a1i isbasis2g sylibrd imp ) CDGZAHBHIZCGZ
      BCJZACJZCKGZUIUMEHZFHZGZUPUJLZMZFCNZEUJJZBCJZACJUNUIULVBACUIUKVABCUKVAOUI
      UKUTEUJUKUOUJGZUJUJLZUTUJPUSVCVDMFUJCUPUJQUQVCURVDUPUJUORUPUJUJSUAUBUCUDU
      ETTABEFCDUFUGUH $.

    $( A basis is not affected by the addition or removal of the empty set.
       (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    basdif0 $p |- ( ( B \ { (/) } ) e. TopBases <-> B e. TopBases ) $=
      ( vx vy c0 cdif ctb wcel cvv cun wss cv cin cuni wral wb inss2 wceq sseli
      ralbii syl csn ssun1 undif1 sseqtr4i snex unexg mpan2 sylancr elex indif1
      ssexg cpw unieqi unidif0 eqtri sseq2i syl6eqss syl5ss rgen ralunb mpbiran
      elsni 0ss inundif raleqi 3bitr2i inss1 ralrimivw difexg 3bitr4d pm5.21nii
      a1i isbasisg ) ADUAZEZFGZAHGZAFGZVPAVOVNIZJVSHGZVQAAVNIVSAVNUBAVNUCUDVPVN
      HGVTDUEVOVNFHUFUGAVSHUKUHAFUIVQBKZCKZLZVOWCULZLZMZJZCVONZBVONZWCAWDLZMZJZ
      CANZBANZVPVRWIWNOVQWIWMBVONZWMBAVNLZVOIZNZWNWHWMBVOWHWLCVONZWLCWQNZWMWGWL
      CVOWFWKWCWFWJVNEZMWKWEXAAWDVNUJUMWJUNUOUPSWTWLCWPNWSWLCWPWBWPGZWCWBWKWAWB
      PXBWBDWKXBWBVNGWBDQWPVNWBAVNPZRWBDVBTWKVCZUQURUSWLCWPVOUTVAWLCWQAAVNVDZVE
      VFSWRWMBWPNWOWMBWPWAWPGZWLCAXFWCWAWKWAWBVGXFWADWKXFWAVNGWADQWPVNWAXCRWADV
      BTXDUQURVHUSWMBWPVOUTVAWMBWQAXEVEVFVLVQVOHGVPWIOAVNHVIBCVOHVMTBCAHVMVJVK
      $.
  $}

  ${
    $d P x y $.
    $( A disjoint system of sets is a basis for a topology.  (Contributed by
       Stefan O'Rear, 22-Feb-2015.) $)
    baspartn $p |- ( ( P e. V /\ A. x e. P A. y e. P
              ( x = y \/ ( x i^i y ) = (/) ) ) -> P e. TopBases ) $=
      ( wcel weq cv cin c0 wceq wo wral wa ctb cpw cuni wss id pwidg elin inidm
      sylanbrc elssuni syl ineq2 syl5eqr ineq2d unieqd sseq12d syl5ibcom wi 0ss
      pweqd sseq1 mpbiri a1i jaod ralimdv ralimia adantl isbasisg adantr mpbird
      wb ) CDEZABFZAGZBGZHZIJZKZBCLZACLZMCNEZVICVIOZHZPZQZBCLZACLZVMVTVEVLVSACV
      GCEZVKVRBCWAVFVRVJWAVGCVGOZHZPZQZVFVRWAVGWCEZWEWAWAVGWBEWFWARVGCSVGCWBTUB
      VGWCUCUDVFVGVIWDVQVFVGVGVGHVIVGUAVGVHVGUEUFZVFWCVPVFWBVOCVFVGVIWGUMUGUHUI
      UJVJVRUKWAVJVRIVQQVQULVIIVQUNUOUPUQURUSUTVEVNVTVDVMABCDVAVBVC $.
  $}

  ${
    $d x y z A $.  $d t u v w x y z B $.  $d w x y z J $.  $d x y z V $.
    $d x y C $.
    $( The topology generated by a basis.  (Contributed by NM, 16-Jul-2006.)
       (Revised by Mario Carneiro, 10-Jan-2015.) $)
    tgval $p |- ( B e. V -> ( topGen ` B ) =
                  { x | x C_ U. ( B i^i ~P x ) } ) $=
      ( vy wcel cvv cv cpw cin cuni wss cab ctg cfv wceq elex wa uniexg abssexg
      uniin sstr mpan2 ssin sylibr ss2abi ssexg mpan ineq1 unieqd sseq2d abbidv
      3syl df-topgen fvmptg syl2anc ) BCEZBFEAGZBUQHZIZJZKZALZFEZBMNVBOBCPUPBJZ
      FEUQVDKUQURJZKZQZALZFEZVCBCRVFAVDFSVBVHKVIVCVAVGAVAUQVDVEIZKZVGVAUTVJKVKB
      URTUQUTVJUAUBUQVDVEUCUDUEVBVHFUFUGULDBUQDGZURIZJZKZALVBFFMVLBOZVOVAAVPVNU
      TUQVPVMUSVLBURUHUIUJUKDAUMUNUO $.

    $( Definition of a topology generated by a basis in [Munkres] p. 78.  Later
       we show (in ~ tgcl ) that ` ( topGen `` B ) ` is indeed a topology (on
       ` U. B ` ; see ~ unitg ).  (Contributed by NM, 15-Jul-2006.)  (Revised
       by Mario Carneiro, 10-Jan-2015.) $)
    tgval2 $p |- ( B e. V -> ( topGen ` B ) =
         { x | ( x C_ U. B /\ A. y e. x E. z e. B ( y e. z /\ z C_ x ) ) } ) $=
      ( wcel ctg cv cuni wss cab wa wrex wral ralbii bitri dfss3 anbi2i 3bitr4i
      wex cfv cpw cin tgval inss1 unissi sseli pm4.71ri r19.26 elin exbii eluni
      an12 df-rex vex elpw rexbii bitr2i anbi12i abbii syl6eq ) DEFDGUAAHZDVBUB
      ZUCZIZJZAKVBDIZJZBHZCHZFZVJVBJZLZCDMZBVBNZLZAKADEUDVFVPAVIVEFZBVBNZVIVGFZ
      BVBNZVRLZVFVPVRVSVQLZBVBNWAVQWBBVBVQVSVEVGVIVDDDVCUEUFUGUHOVSVQBVBUIPBVBV
      EQVHVTVOVRBVBVGQVNVQBVBVQVKVJVCFZLZCDMZVNVKVJVDFZLZCTVJDFZWDLZCTVQWEWGWIC
      WGVKWHWCLZLWIWFWJVKVJDVCUJRVKWHWCUMPUKCVIVDULWDCDUNSWDVMCDWCVLVKVJVBCUOUP
      RUQUROUSSUTVA $.

    $( Membership in a topology generated by a basis.  (Contributed by NM,
       16-Jul-2006.)  (Revised by Mario Carneiro, 10-Jan-2015.) $)
    eltg $p |- ( B e. V -> ( A e. ( topGen ` B ) <->
           A C_ U. ( B i^i ~P A ) ) ) $=
      ( vx wcel ctg cfv cv cpw cin cuni wss cab tgval eleq2d elex adantl inex1g
      cvv uniexg syl ssexg sylan2 ancoms wceq id ineq2d unieqd sseq12d pm5.21nd
      pweq elabg bitrd ) BCEZABFGZEADHZBUPIZJZKZLZDMZEZABAIZJZKZLZUNUOVAADBCNOU
      NVBVFASEZVBVGUNAVAPQVFUNVGUNVFVESEZVGUNVDSEVHBVCCRVDSTUAAVESUBUCUDUTVFDAS
      UPAUEZUPAUSVEVIUFVIURVDVIUQVCBUPAUKUGUHUIULUJUM $.

    $( Membership in a topology generated by a basis.  (Contributed by NM,
       15-Jul-2006.)  (Revised by Mario Carneiro, 10-Jan-2015.) $)
    eltg2 $p |- ( B e. V -> ( A e. ( topGen ` B ) <->
           ( A C_ U. B /\ A. x e. A E. y e. B ( x e. y /\ y C_ A ) ) ) ) $=
      ( vz wcel ctg cfv cv cuni wss wa wrex wral cab tgval2 eleq2d cvv elex
      adantl uniexg ssexg sylan2 ancoms adantrr wceq sseq1 sseq2 anbi2d rexbidv
      raleqbi1dv anbi12d elabg pm5.21nd bitrd ) DEGZCDHIZGCFJZDKZLZAJBJZGZVBUSL
      ZMZBDNZAUSOZMZFPZGZCUTLZVCVBCLZMZBDNZACOZMZUQURVICFABDEQRUQVJVPCSGZVJVQUQ
      CVITUAUQVKVQVOVKUQVQUQVKUTSGVQDEUBCUTSUCUDUEUFVHVPFCSUSCUGZVAVKVGVOUSCUTU
      HVFVNAUSCVRVEVMBDVRVDVLVCUSCVBUIUJUKULUMUNUOUP $.

    $( Membership in a topology generated by a basis.  (Contributed by Mario
       Carneiro, 17-Jun-2014.)  (Revised by Mario Carneiro, 10-Jan-2015.) $)
    eltg2b $p |- ( B e. V -> ( A e. ( topGen ` B ) <->
                   A. x e. A E. y e. B ( x e. y /\ y C_ A ) ) ) $=
      ( wcel ctg cfv cuni wss cv wa wrex wral eltg2 reximi eluni2 sylibr ralimi
      simpl dfss3 pm4.71ri syl6bbr ) DEFCDGHFCDIZJZAKZBKZFZUGCJZLZBDMZACNZLULAB
      CDEOULUEULUFUDFZACNUEUKUMACUKUHBDMUMUJUHBDUHUITPBUFDQRSACUDUARUBUC $.

    $( An open set in a topology generated by a basis is the union of all basic
       open sets contained in it.  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    eltg4i $p |- ( A e. ( topGen ` B ) -> A = U. ( B i^i ~P A ) ) $=
      ( ctg cfv wcel cpw cin cuni wss cdm wb elfvdm eltg syl inss2 unissi unipw
      ibi sseqtri a1i eqssd ) ABCDEZABAFZGZHZUBAUEIZUBBCJZEUBUFKABCLABUGMNRUEAI
      UBUEUCHAUDUCBUCOPAQSTUA $.

    $( The union of a set of basic open sets is in the generated topology.
       (Contributed by Mario Carneiro, 30-Aug-2015.) $)
    eltg3i $p |- ( ( B e. V /\ A C_ B ) -> U. A e. ( topGen ` B ) ) $=
      ( wcel wss wa cuni ctg cfv cpw cin simpr pwuni jctir ssin sylib unissd wb
      eltg adantr mpbird ) BCDZABEZFZAGZBHIDZUEBUEJZKZGEZUDAUHUDUCAUGEZFAUHEUDU
      CUJUBUCLAMNABUGOPQUBUFUIRUCUEBCSTUA $.

    $( Membership in a topology generated by a basis.  (Contributed by NM,
       15-Jul-2006.)  (Proof shortened by Mario Carneiro, 30-Aug-2015.) $)
    eltg3 $p |- ( B e. V -> ( A e. ( topGen ` B ) <->
           E. x ( x C_ B /\ A = U. x ) ) ) $=
      ( wcel ctg cfv cv wss cuni wceq wa wex cpw cin cvv cdm elfvdm inex1g syl
      eltg4i inss1 sseq1 mpbiri biantrurd unieq eqeq2d bitr3d spcegv sylc eleq1
      eltg3i syl5ibrcom expimpd exlimdv impbid2 ) CDEZBCFGZEZAHZCIZBUTJZKZLZAMZ
      USCBNZOZPEZBVGJZKZVEUSCFQZEVHBCFRCVFVKSTBCUAVDVJAVGPUTVGKZVCVDVJVLVAVCVLV
      AVGCICVFUBUTVGCUCUDUEVLVBVIBUTVGUFUGUHUIUJUQVDUSAUQVAVCUSUQVALUSVCVBUREUT
      CDULBVBURUKUMUNUOUP $.

    $( Alternate expression for the topology generated by a basis.  Lemma 2.1
       of [Munkres] p. 80.  (Contributed by NM, 17-Jul-2006.)  (Revised by
       Mario Carneiro, 30-Aug-2015.) $)
    tgval3 $p |- ( B e. V ->
               ( topGen ` B ) = { x | E. y ( y C_ B /\ x = U. y ) } ) $=
      ( wcel cv wss cuni wceq wa wex ctg cfv eltg3 abbi2dv ) CDEBFZCGAFZPHIJBKA
      CLMBQCDNO $.

    $( Property of a member of a topology generated by a basis.  (Contributed
       by NM, 20-Jul-2006.) $)
    tg1 $p |- ( A e. ( topGen ` B ) -> A C_ U. B ) $=
      ( vx vy ctg cdm wcel cfv cuni wss elfvdm cv wa wrex wral simprbda mpancom
      eltg2 ) BEFZGZABEHGZABIJZABEKTUAUBCLDLZGUCAJMDBNCAOCDABSRPQ $.

    $( Property of a member of a topology generated by a basis.  (Contributed
       by NM, 20-Jul-2006.) $)
    tg2 $p |- ( ( A e. ( topGen ` B ) /\ C e. A ) ->
               E. x e. B ( C e. x /\ x C_ A ) ) $=
      ( vy ctg cfv wcel cv wss wa wrex cdm elfvdm wral eltg2b wceq eleq1 anbi1d
      wi rexbidv rspccv syl6bi mpcom imp ) BCFGHZDBHZDAIZHZUHBJZKZACLZCFMZHZUFU
      GULTZBCFNUNUFEIZUHHZUJKZACLZEBOUOEABCUMPUSULEDBUPDQZURUKACUTUQUIUJUPDUHRS
      UAUBUCUDUE $.

    $( A member of a basis is a subset of the topology it generates.
       (Contributed by NM, 16-Jul-2006.)  (Revised by Mario Carneiro,
       10-Jan-2015.) $)
    bastg $p |- ( B e. V -> B C_ ( topGen ` B ) ) $=
      ( vx wcel ctg cfv cv cpw cin cuni wss wa simpr vex pwid a1i elin sylanbrc
      elssuni syl ex eltg sylibrd ssrdv ) ABDZCAAEFZUECGZADZUGAUGHZIZJKZUGUFDUE
      UHUKUEUHLZUGUJDZUKULUHUGUIDZUMUEUHMUNULUGCNOPUGAUIQRUGUJSTUAUGABUBUCUD $.

    $( The topology generated by a basis ` B ` is a topology on ` U. B ` .
       Importantly, this theorem means that we don't have to specify separately
       the base set for the topological space generated by a basis.  In other
       words, any member of the class ` TopBases ` completely specifies the
       basis it corresponds to.  (Contributed by NM, 16-Jul-2006.) $)
    unitg $p |- ( B e. V -> U. ( topGen ` B ) = U. B ) $=
      ( vx vy wcel ctg cfv cuni cv wrex eluni2 cpw cin wss wi eltg inss1 unissi
      sstr sseld mpan2 syl6bi rexlimdv syl5bi bastg unissd impbid eqrdv ) ABEZC
      AFGZHZAHZUICIZUKEZUMULEZUNUMDIZEZDUJJUIUODUMUJKUIUQUODUJUIUPUJEUPAUPLZMZH
      ZNZUQUOOUPABPVAUPULUMVAUTULNUPULNUSAAURQRUPUTULSUATUBUCUDUIULUKUMUIAUJABU
      EUFTUGUH $.

    $( Subset relation for generated topologies.  (Contributed by NM,
       7-May-2007.) $)
    tgss $p |- ( ( C e. V /\ B C_ C ) -> ( topGen ` B ) C_ ( topGen ` C ) ) $=
      ( vx wcel wss wa ctg cfv cv cpw cin cuni wi ssrin unissd sstr2 cvv eltg
      wb syl5com adantl ssexg ancoms syl adantr 3imtr4d ssrdv ) BCEZABFZGZDAHIZ
      BHIZUKDJZAUNKZLZMZFZUNBUOLZMZFZUNULEZUNUMEZUJURVANUIUJUQUTFURVAUJUPUSABUO
      OPUNUQUTQUAUBUKAREZVBURTUJUIVDABCUCUDUNARSUEUIVCVATUJUNBCSUFUGUH $.

    $( Show that a basis generates a topology.  Remark in [Munkres] p. 79.
       (Contributed by NM, 17-Jul-2006.) $)
    tgcl $p |- ( B e. TopBases -> ( topGen ` B ) e. Top ) $=
      ( vu vv vx vy vt vz vw ctb wcel cv wss cuni wi wral wel wa wrex rsp eltg2
      ctg cfv wal cin ctop uniss adantl wceq unitg adantr sseqtrd eluni2 eltg2b
      ssel2 syl6bi imp31 an32s sylan2 an42s elssuni syl5com anim2d ad2antrl mpd
      sstr2 reximdv rexlimdvaa syl5bi ralrimiv jca ex sylibrd alrimiv inss1 tg1
      syl5ss simplbda syl im2anan9 reeanv 3imtr4g anandis biimpri ss2in anim12i
      elin basis2 adantllr adantrrr com12 ad2antll sylanr2 rexlimdva a2d syldan
      an4s imp ralrimivv cvv wb fvex istopg ax-mp sylanbrc ) AIJZBKZAUAUBZLZXFM
      ZXGJZNZBUCZXFCKZUDZXGJZCXGOBXGOZXGUEJZXEXKBXEXHXIAMZLZDEPZEKZXILZQZEARZDX
      IOZQZXJXEXHYFXEXHQZXSYEYGXIXGMZXRXHXIYHLXEXFXGUFUGXEYHXRUHXHAIUIUJUKYGYDD
      XIDKZXIJDFPZFXFRYGYDFYIXFULYGYJYDFXFYGFBPZYJQQXTYAFKZLZQZEARZYDXEYJXHYKYO
      XHYKQXEYJQYLXGJZYOXFXGYLUNXEYPYJYOXEYPYJYOXEYPYODYLOYJYONDEYLAIUMYODYLSUO
      UPUQURUSYKYOYDNYGYJYKYNYCEAYKYMYBXTYKYLXILYMYBYLXFUTYAYLXIVEVAVBVFVCVDVGV
      HVIVJVKDEXIAITVLVMXEXOBCXGXGXEXFXGJZXMXGJZQZXNXRLZYJYLXNLZQZFARZDXNOZQZXO
      XEYSUUEXEYSQZYTUUDYQYTXEYRYQXNXFXRXFXMVNXFAVOVPVCUUFUUCDXNXEYSYIXNJZDGPZG
      KZXFLZQZDHPZHKZXMLZQZQZHARZGARZNZUUGUUCNZXEYQYRUUSXEYQQZXEYRQZQDBPZDCPZQU
      UKGARZUUOHARZQUUGUURUVAUVCUVEUVBUVDUVFUVAUVEDXFOZUVCUVENXEYQXFXRLUVGDGXFA
      ITVQUVEDXFSVRUVBUVFDXMOZUVDUVFNXEYRXMXRLUVHDHXMAITVQUVFDXMSVRVSYIXFXMWFUU
      KUUOGHAAVTWAWBXEUUSUUTXEUUGUURUUCXEUUGUURUUCNXEUUGQZUUQUUCGAUVIUUIAJZQZUU
      PUUCHAUUPUVKUUMAJZYIUUIUUMUDZJZUVMXNLZQZUUCUUHUULUUJUUNUVPUUHUULQZUVNUUJU
      UNQUVOUVNUVQYIUUIUUMWFWCUUIXFUUMXMWDWEWPUVKUVLUVPQQYJYLUVMLZQZFARZUUCUVKU
      VLUVNUVTUVOXEUVJUVLUVNQUVTUUGFYIAUUIUUMWGWHWIUVPUVTUUCNZUVKUVLUVOUWAUVNUV
      OUVSUUBFAUVOUVRUUAYJUVRUVOUUAYLUVMXNVEWJVBVFUGWKVDWLVGWMVKWNWQWOVIVJVKDFX
      NAITVLWRXGWSJXQXLXPQWTAUAXABCWSXGXBXCXD $.

    $( The property ~ tgcl can be reversed: if the topology generated by ` B `
       is actually a topology, then ` B ` must be a topological basis.  This
       yields an alternative definition of ` TopBases ` .  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    tgclb $p |- ( B e. TopBases <-> ( topGen ` B ) e. Top ) $=
      ( vz vw vx vy ctb wcel ctg cfv ctop tgcl cin wss wrex wral cvv syl sselda
      cv wa c0 0opn bastg anim12dan inopn 3expb syldan tg2 ralrimiva ralrimivva
      elfvexd wb isbasis2g mpbird impbii ) AFGZAHIZJGZAKURUPBSZCSZGUTDSZESZLZMT
      CANZBVCOZEAODAOZURVEDEAAURVAAGZVBAGZTZTVCUQGZVEURVIVAUQGZVBUQGZTVJURVGVKV
      HVLURAUQVAURAPGZAUQMURUAHAUQUBUKZAPUCQZRURAUQVBVORUDURVKVLVJVAVBUQUEUFUGV
      JVDBVCCVCAUSUHUIQUJURVMUPVFULVNDEBCAPUMQUNUO $.

    $( A basis generates a topology on ` U. B ` .  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    tgtopon $p |- ( B e. TopBases -> ( topGen ` B ) e. ( TopOn ` U. B ) ) $=
      ( ctb wcel ctg ctop cuni wceq ctopon tgcl unitg eqcomd istopon sylanbrc
      cfv ) ABCZADNZECAFZPFZGPQHNCAIORQABJKQPLM $.

    $( A topology is its own basis.  (Contributed by NM, 17-Jul-2006.) $)
    topbas $p |- ( J e. Top -> J e. TopBases ) $=
      ( vz vw vx vy ctop wcel ctb cv cin wss wrex wral inopn 3expb adantr simpr
      wa ssid jctir eleq2 sseq1 anbi12d rspcev syl2anc exp31 ralrimdv ralrimivv
      wceq isbasis2g mpbird ) AFGZAHGBIZCIZGZUNDIZEIZJZKZRZCALZBURMZEAMDAMULVBD
      EAAULUPAGZUQAGZRZVABURULVEUMURGZVAULVERZVFRZURAGZVFURURKZRZVAVGVIVFULVCVD
      VIUPUQANOPVHVFVJVGVFQURSTUTVKCURAUNURUIUOVFUSVJUNURUMUAUNURURUBUCUDUEUFUG
      UHDEBCAFUJUK $.

    $( A topology is its own basis.  (Contributed by NM, 18-Jul-2006.) $)
    tgtop $p |- ( J e. Top -> ( topGen ` J ) = J ) $=
      ( vx vy ctop wcel ctg cfv cv wss cuni wceq wex eltg3 simpr uniopn eqeltrd
      wa adantr expl exlimdv sylbid ssrdv bastg eqssd ) ADEZAFGZAUEBUFAUEBHZUFE
      CHZAIZUGUHJZKZQZCLUGAEZCUGADMUEULUMCUEUIUKUMUEUIQZUKQUGUJAUNUKNUNUJAEUKUH
      AORPSTUAUBADUCUD $.

    $( Membership in a topology, expressed without quantifiers.  (Contributed
       by NM, 19-Jul-2006.) $)
    eltop $p |- ( J e. Top -> ( A e. J <-> A C_ U. ( J i^i ~P A ) ) ) $=
      ( ctop wcel ctg cfv cpw cin cuni wss tgtop eleq2d eltg bitr3d ) BCDZABEFZ
      DABDABAGHIJOPBABKLABCMN $.

    $( Membership in a topology.  (Contributed by NM, 19-Jul-2006.) $)
    eltop2 $p |- ( J e. Top -> ( A e. J <->
                   A. x e. A E. y e. J ( x e. y /\ y C_ A ) ) ) $=
      ( ctop wcel ctg cfv cv wss wa wrex wral tgtop eleq2d eltg2b bitr3d ) DEFZ
      CDGHZFCDFAIBIZFTCJKBDLACMRSDCDNOABCDEPQ $.

    $( Membership in a topology.  (Contributed by NM, 19-Jul-2006.) $)
    eltop3 $p |- ( J e. Top -> ( A e. J <-> E. x ( x C_ J /\ A = U. x ) ) ) $=
      ( ctop wcel ctg cfv cv wss cuni wceq wa wex tgtop eleq2d eltg3 bitr3d ) C
      DEZBCFGZEBCEAHZCIBTJKLAMRSCBCNOABCDPQ $.

    $( A collection of finite intersections is a basis.  The initial set is a
       subbasis for the topology.  (Contributed by Jeff Hankins, 25-Aug-2009.)
       (Revised by Mario Carneiro, 24-Nov-2013.) $)
    fibas $p |- ( fi ` A ) e. TopBases $=
      ( vx vy cfi cfv cvv wcel cv cin wral ctb fvex fiin rgen2a fiinbas mp2an )
      ADEZFGBHZCHZIQGZCQJBQJQKGADLTBCQRSAMNBCQFOP $.

    $( A space has no more open sets than subsets of a basis.  (Contributed by
       Stefan O'Rear, 22-Feb-2015.)  (Revised by Mario Carneiro,
       9-Apr-2015.) $)
    tgdom $p |- ( B e. V -> ( topGen ` B ) ~<_ ~P B ) $=
      ( vx vy wcel cpw cvv ctg cfv cdom wbr pwexg cv cin wss inss1 wa wceq cuni
      eltg4i vex pwex inex2 mpbir a1i unieq adantl ad2antrr ad2antlr 3eqtr4d ex
      elpw pweq ineq2d impbid1 dom2 syl ) ABEAFZGEAHIZURJKABLCDUSURACMZFZNZADMZ
      FZNZGVBUREZUTUSEZVFVBAOAVAPVBAVAAUTCUAUBUCULUDUEVGVCUSEZQZVBVERZUTVCRZVIV
      JVKVIVJQVBSZVESZUTVCVJVLVMRVIVBVEUFUGVGUTVLRVHVJUTATUHVHVCVMRVGVJVCATUIUJ
      UKVKVAVDAUTVCUMUNUOUPUQ $.
  $}

  ${
    $d x A $.  $d x y z B $.  $d x y z V $.
    $( The indexed union of a set of basic open sets is in the generated
       topology.  (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    tgiun $p |- ( ( B e. V /\ A. x e. A C e. B ) ->
      U_ x e. A C e. ( topGen ` B ) ) $=
      ( wcel wral wa ciun cmpt crn cuni ctg cfv wceq dfiun3g adantl wss wf eqid
      fmpt frn sylbi eltg3i sylan2 eqeltrd ) CEFZDCFABGZHABDIZABDJZKZLZCMNZUHUI
      ULOUGABDCPQUHUGUKCRZULUMFUHBCUJSUNABCDUJUJTUABCUJUBUCUKCEUDUEUF $.

    $( The topology generator function is idempotent.  (Contributed by NM,
       18-Jul-2006.)  (Revised by Mario Carneiro, 2-Sep-2015.) $)
    tgidm $p |- ( B e. V ->
                 ( topGen ` ( topGen ` B ) ) = ( topGen ` B ) ) $=
      ( vx vy vz wcel ctg cfv cv wss cuni wceq wa wex cvv fvex eltg3 ax-mp ciun
      wb cpw cin uniiun simpr sselda eltg4i iuneq2dv syl5eq iuncom4 syl6eq wral
      syl inss1 rgenw iunss mpbir a1i eltg3i eqeltrd syl5ibrcom expimpd exlimdv
      sylan2 eleq1 syl5bi ssrdv bastg tgss sylancr eqssd ) ABFZAGHZGHZVLVKCVMVL
      CIZVMFZDIZVLJZVNVPKZLZMZDNZVKVNVLFZVLOFZVOWATAGPZDVNVLOQRVKVTWBDVKVQVSWBV
      KVQMZWBVSVRVLFWEVREVPAEIZUAZUBZSZKZVLWEVREVPWHKZSZWJWEVREVPWFSWLEVPUCWEEV
      PWFWKWEWFVPFMWFVLFWFWKLWEVPVLWFVKVQUDUEWFAUFULUGUHEVPWHUIUJVQVKWIAJZWJVLF
      WMVQWMWHAJZEVPUKWNEVPAWGUMUNEVPWHAUOUPUQWIABURVCUSVNVRVLVDUTVAVBVEVFVKWCA
      VLJVLVMJWDABVGAVLOVHVIVJ $.
  $}

  $( Two ways to express that a basis is a topology.  (Contributed by NM,
     18-Jul-2006.) $)
  bastop $p |- ( B e. TopBases -> ( B e. Top <-> ( topGen ` B ) = B ) ) $=
    ( ctb wcel ctop ctg cfv wceq tgtop tgcl eleq1 syl5ibcom impbid2 ) ABCZADCZA
    EFZAGZAHMODCPNAIOADJKL $.

  $( The topology generation function is one-to-one when applied to completed
     topologies.  (Contributed by NM, 18-Jul-2006.) $)
  tgtop11 $p |- ( ( J e. Top /\ K e. Top /\ ( topGen ` J ) = ( topGen ` K ) )
                 -> J = K ) $=
    ( ctop wcel ctg cfv wceq tgtop eqeqan12d biimp3a ) ACDZBCDZAEFZBEFZGABGKLMA
    NBAHBHIJ $.

  $( The singleton of the empty set is the only topology possible for an empty
     underlying set.  (Contributed by NM, 9-Sep-2006.) $)
  0top $p |- ( J e. Top -> ( U. J = (/) <-> J = { (/) } ) ) $=
    ( ctop wcel c0 csn wceq wo cuni olc wn 0opn n0i syl pm2.21d idd impbid2 wss
    jaod uni0b sssn bitr2i syl6rbb ) ABCZADEZFZADFZUEGZAHDFZUCUEUGUEUFIUCUFUEUE
    UCUFUEUCDACUFJAKADLMNUCUEORPUHAUDQUGASADTUAUB $.

  $( ` { (/) } ` is the only topology with one element.  (Contributed by FL,
     18-Aug-2008.) $)
  en1top $p |- ( J e. Top -> ( J ~~ 1o <-> J = { (/) } ) ) $=
    ( ctop wcel c1o cen wbr c0 csn wceq wi en1eqsn ex syl id 0ex ensn1 syl6eqbr
    0opn impbid1 ) ABCZADEFZAGHZIZTGACZUAUCJARUDUAUCGAKLMUCAUBDEUCNGOPQS $.

  ${
    $d x J $.  $d x X $.
    $( If a topology has two elements, it is the indiscrete topology.
       (Contributed by FL, 11-Aug-2008.)  (Revised by Mario Carneiro,
       10-Sep-2015.) $)
    en2top $p |- ( J e. ( TopOn ` X ) ->
      ( J ~~ 2o <-> ( J = { (/) , X } /\ X =/= (/) ) ) ) $=
      ( vx wcel c2o cen wbr c0 wceq wne wa c1o simprl sylibr syl 0ex mpd necomd
      adantr syl3anc ctopon cfv cpr simpr wn csdm wo csn cv wss ad2ant2rl sseq0
      toponss elsn expr ssrdv ctop topontop ad2antrr snssd eqssd ensn1 syl6eqbr
      syl2anc 0opn olcd sdom2en01 sdomnen necon2ad toponmax en2eqpr jca cvv a1i
      ex wi simprr pr2nelem eqbrtrd impbida ) ABUAUBDZAEFGZAHBUCZIZBHJZKZWAWBKZ
      WDWEWGHBJZWDWGBHWGWBWEWAWBUDZWGWBBHWGBHIZWBUEZWGWJKZAEUFGZWKWLAHIZALFGZUG
      WMWLWOWNWLAHUHZLFWLAWPWLCAWPWGWJCUIZADZWQWPDZWGWJWRKKZWQHIZWSWTWQBUJZWJXA
      WAWRXBWBWJWQABUMUKWGWJWRMWQBULVDCHUNNUOUPWLHAWAHADZWBWJWAAUQDXCBAURAVEOZU
      SUTVAHPVBVCVFAVGNAEVHOVOVIQZRWGWBXCBADZWHWDVPWIWAXCWBXDSWAXFWBBAVJZSHBAVK
      TQXEVLWAWFKZAWCEFWAWDWEMXHHVMDZXFWHWCEFGXIXHPVNWAXFWFXGSXHBHWAWDWEVQRHBVM
      AVRTVSVT $.
  $}

  ${
    $d u v w x y z B $.  $d u v w x y z C $.  $d v w x y z J $.  $d x y V $.
    $( A criterion for determining whether one topology is finer than another.
       Lemma 2.2 of [Munkres] p. 80 using abbreviations.  (Contributed by NM,
       20-Jul-2006.)  (Proof shortened by Mario Carneiro, 2-Sep-2015.) $)
    tgss3 $p |- ( ( B e. V /\ C e. W ) ->
      ( ( topGen ` B ) C_ ( topGen ` C ) <-> B C_ ( topGen ` C ) ) ) $=
      ( wcel wa ctg cfv wss wi bastg adantr sstr2 syl fvex tgss mpan wceq tgidm
      cvv adantl sseq2d syl5ib impbid ) ACEZBDEZFZAGHZBGHZIZAUIIZUGAUHIZUJUKJUE
      ULUFACKLAUHUIMNUKUHUIGHZIZUGUJUITEUKUNBGOAUITPQUGUMUIUHUFUMUIRUEBDSUAUBUC
      UD $.

    $( A criterion for determining whether one topology is finer than another,
       based on a comparison of their bases.  Lemma 2.2 of [Munkres] p. 80.
       (Contributed by NM, 20-Jul-2006.)  (Proof shortened by Mario Carneiro,
       2-Sep-2015.) $)
    tgss2 $p |- ( ( B e. V /\ U. B = U. C ) ->
                    ( ( topGen ` B ) C_ ( topGen ` C ) <->
     A. x e. U. B A. y e. B ( x e. y -> E. z e. C ( x e. z /\ z C_ y ) ) ) ) $=
      ( wcel cuni wa ctg cfv wss wel cv wi wral cvv wb syl ralbidva wceq uniexg
      wrex simpr adantr eqeltrrd uniexb sylibr tgss3 syldan eltg2b elunii biimt
      ancoms sylan9bb ralcom3 syl6bb dfss3 ralcom 3bitr4g bitrd ) DFGZDHZEHZUAZ
      IZDJKEJKZLZDVGLZABMZACMCNBNZLICEUCZOZBDPAVCPZVBVEEQGZVHVIRVFVDQGVOVFVCVDQ
      VBVEUDVBVCQGVEDFUBUEUFEUGUHZDEFQUIUJVFVKVGGZBDPVMAVCPZBDPVIVNVFVQVRBDVFVK
      DGZIVQANZVCGZVLOZAVKPZVRVFVQVLAVKPZVSWCVFVOVQWDRVPACVKEQUKSVSVLWBAVKVSVJI
      WAVLWBRVJVSWAVTVKDULUNWAVLUMSTUOVLAVKVCUPUQTBDVGURVMABVCDUSUTVA $.

    $( Given a topology ` J ` , show that a subset ` B ` satisfying the third
       antecedent is a basis for it.  Lemma 2.3 of [Munkres] p. 81 using
       abbreviations.  (Contributed by NM, 22-Jul-2006.)  (Revised by Mario
       Carneiro, 2-Sep-2015.) $)
    basgen $p |- ( ( J e. Top /\ B C_ J /\ J C_ ( topGen ` B ) ) ->
      ( topGen ` B ) = J ) $=
      ( ctop wcel wss ctg cfv w3a tgss 3adant3 wceq tgtop 3ad2ant1 simp3 eqssd
      sseqtrd ) BCDZABEZBAFGZEZHZSBUASBFGZBQRSUBETABCIJQRUBBKTBLMPQRTNO $.

    $( Given a topology ` J ` , show that a subset ` B ` satisfying the third
       antecedent is a basis for it.  Lemma 2.3 of [Munkres] p. 81.
       (Contributed by NM, 20-Jul-2006.)  (Proof shortened by Mario Carneiro,
       2-Sep-2015.) $)
    basgen2 $p |- ( ( J e. Top /\ B C_ J /\ A. x e. J A. y e. x E. z e. B
            ( y e. z /\ z C_ x ) ) -> ( topGen ` B ) = J ) $=
      ( ctop wcel wss cv wa wrex wral ctg cfv wceq dfss3 cvv wb ssexg ancoms
      eltg2b syl ralbidv syl5bb biimp3ar basgen syld3an3 ) EFGZDEHZBICIZGUJAIZH
      JCDKBUKLZAELZEDMNZHZUNEOUHUIUOUMUOUKUNGZAELUHUIJZUMAEUNPUQUPULAEUQDQGZUPU
      LRUIUHURDEFSTBCUKDQUAUBUCUDUEDEUFUG $.

    $( Conditions that determine the equality of two generated topologies.
       (Contributed by NM, 8-May-2007.)  (Revised by Mario Carneiro,
       2-Sep-2015.) $)
    2basgen $p |- ( ( B C_ C /\ C C_ ( topGen ` B ) ) ->
      ( topGen ` B ) = ( topGen ` C ) ) $=
      ( wss ctg cfv wa cvv wcel fvex ssex adantl simpl tgss syl2anc simpr ssexg
      wb sylan2 tgss3 mpbird eqssd ) ABCZBADEZCZFZUCBDEZUEBGHZUBUCUFCUDUGUBBUCA
      DIJZKZUBUDLABGMNUEUFUCCZUDUBUDOUEUGAGHZUJUDQUIUDUBUGUKUHABGPRBAGGSNTUA $.

    $( If a subbase is included into a topology, so is the generated topology.
       (Contributed by FL, 20-Apr-2012.)  (Proof shortened by Mario Carneiro,
       10-Jan-2015.) $)
    tgfiss $p |- ( ( J e. Top /\ A C_ J ) -> ( topGen ` ( fi ` A ) ) C_ J ) $=
      ( ctop wcel wss wa cfi cfv ctg fiss wceq fitop adantr sseqtrd tgss syldan
      tgtop ) BCDZABEZFZAGHZIHZBIHZBRSUABEUBUCETUABGHZBABCJRUDBKSBLMNUABCOPRUCB
      KSBQMN $.

    $( A generated topology is not affected by the addition or removal of the
       empty set from the base.  (Contributed by Mario Carneiro,
       28-Aug-2015.) $)
    tgdif0 $p |- ( topGen ` ( B \ { (/) } ) ) = ( topGen ` B ) $=
      ( vx cvv wcel c0 csn cdif ctg cfv wceq cv cin cuni wss cab tgval wn fvprc
      syl cun cpw indif1 unieqi unidif0 eqtri sseq2i abbii difexg 3eqtr4a ssun1
      undif1 sseqtr4i p0ex unexg mpan2 ssexg sylancr con3i eqtr4d pm2.61i ) ACD
      ZAEFZGZHIZAHIZJVABKZVCVFUAZLZMZNZBOZVFAVGLZMZNZBOVDVEVJVNBVIVMVFVIVLVBGZM
      VMVHVOAVGVBUBUCVLUDUEUFUGVAVCCDZVDVKJAVBCUHBVCCPSBACPUIVAQZVDEVEVQVPQVDEJ
      VPVAVPAVCVBTZNVRCDZVAAAVBTVRAVBUJAVBUKULVPVBCDVSUMVCVBCCUNUOAVRCUPUQURVCH
      RSAHRUSUT $.
  $}

  ${
    $d u v w x y z B $.  $d v w x y z J $.
    $( A subset of a topology is a basis for the topology iff every member of
       the topology is a union of members of the basis.  We use the
       idiom " ` ( topGen `` B ) = J ` " to express " ` B ` is a basis for
       topology ` J ` ," since we do not have a separate notation for this.
       Definition 15.35 of [Schechter] p. 428.  (Contributed by NM,
       2-Feb-2008.)  (Proof shortened by Mario Carneiro, 2-Sep-2015.) $)
    bastop1 $p |- ( ( J e. Top /\ B C_ J ) -> ( ( topGen ` B ) = J <->
      A. x e. J E. y ( y C_ B /\ x = U. y ) ) ) $=
      ( ctop wcel wss wa ctg cfv wceq cv wral cuni wex wb tgss tgtop syl cvv
      adantr sseqtrd eqss baib dfss3 syl6bb ssexg ancoms eltg3 ralbidv bitrd )
      DEFZCDGZHZCIJZDKZALZUOFZADMZBLZCGUQUTNKHBOZADMUNUPDUOGZUSUNUODGZUPVBPUNUO
      DIJZDCDEQULVDDKUMDRUAUBUPVCVBUODUCUDSADUOUEUFUNURVAADUNCTFZURVAPUMULVECDE
      UGUHBUQCTUISUJUK $.

    $( A version of ~ bastop1 that doesn't have ` B C_ J ` in the antecedent.
       (Contributed by NM, 3-Feb-2008.) $)
    bastop2 $p |- ( J e. Top -> ( ( topGen ` B ) = J <->
           ( B C_ J /\ A. x e. J E. y ( y C_ B /\ x = U. y ) ) ) ) $=
      ( ctop wcel ctg cfv wceq wss wa cv cuni wex wral ctb eleq1 biimparc tgclb
      sylibr bastg syl simpr sseqtrd ex pm4.71rd bastop1 pm5.32da bitrd ) DEFZC
      GHZDIZCDJZULKUMBLZCJALUNMIKBNADOZKUJULUMUJULUMUJULKZCUKDUPCPFZCUKJUPUKEFZ
      UQULURUJUKDEQRCSTCPUAUBUJULUCUDUEUFUJUMULUOABCDUGUHUI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Examples of topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y V $.
    $( The discrete topology on a set ` A ` .  Part of Example 2 in [Munkres]
       p. 77.  (Contributed by FL, 17-Jul-2006.)  (Revised by Mario Carneiro,
       19-Mar-2015.) $)
    distop $p |- ( A e. V -> ~P A e. Top ) $=
      ( vx vy wcel cpw ctop cv wss cuni wi wal cin wral uniss vex a1i sylbi cvv
      elpw unipw syl6sseq uniex sylibr ax-gen ssinss1 inex2 com12 ralrimiv rgen
      syl6ibr wa wb pwexg istopg syl mpbir2and ) ABEZAFZGEZCHZUSIZVAJZUSEZKZCLZ
      VADHZMZUSEZDUSNZCUSNZVFURVECVBVCAIVDVBVCUSJAVAUSOAUAUBVCAVACPZUCTUDUEQVKU
      RVJCUSVAUSEZVIDUSVMVAAIZVGUSEZVIKVAAVLTVOVNVIVOVGAIZVNVIKVGADPZTVPVNVHAIZ
      VIVNVRKVPVAVGAUFQVHAVGVAVQUGTUKRUHRUIUJQURUSSEUTVFVKULUMABUNCDSUSUOUPUQ
      $.

    $( The discrete topology on a set ` A ` , with base set.  (Contributed by
       Mario Carneiro, 13-Aug-2015.) $)
    distopon $p |- ( A e. V -> ~P A e. ( TopOn ` A ) ) $=
      ( wcel cpw ctop cuni wceq ctopon cfv distop unipw eqcomi istopon sylanbrc
      a1i ) ABCZADZECAQFZGZQAHICABJSPRAAKLOAQMN $.

    $( The singleton of the empty set is a topology on the empty set.
       (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    sn0topon $p |- { (/) } e. ( TopOn ` (/) ) $=
      ( c0 cpw csn ctopon cfv pw0 cvv wcel 0ex distopon ax-mp eqeltrri ) ABZACA
      DEZFAGHMNHIAGJKL $.

    $( The singleton of the empty set is a topology.  (Contributed by Stefan
       Allan, 3-Mar-2006.)  (Proof shortened by Mario Carneiro,
       13-Aug-2015.) $)
    sn0top $p |- { (/) } e. Top $=
      ( c0 csn sn0topon topontopi ) AABCD $.

    $( A lemma to eliminate some sethood hypotheses when dealing with the
       indiscrete topology.  (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    indislem $p |- { (/) , ( _I ` A ) } = { (/) , A } $=
      ( cvv wcel c0 cid cfv cpr wceq fvi preq2d csn dfsn2 eqcomi prprc2 3eqtr4a
      wn fvprc pm2.61i ) ABCZDAEFZGZDAGZHSTADABIJSPZDDGZDKZUAUBUEUDDLMUCTDDAEQJ
      DANOR $.

    $( The indiscrete topology on a set ` A ` .  Part of Example 2 in [Munkres]
       p. 77.  (Contributed by Mario Carneiro, 13-Aug-2015.) $)
    indistopon $p |- ( A e. V -> { (/) , A } e. ( TopOn ` A ) ) $=
      ( vx vy wcel c0 cuni wceq wi cin wo unieq 0ex syl6eqel a1i jaod wa ex cvv
      syl6eq cpr ctop ctopon cfv wss wal wral csn sspr uni0 prid1 eqeltri unisn
      cv unisng sylan9eqr prid2g adantr eqeltrd cun uniprg mpan uncom un0 eqtri
      syl5bi alrimiv vex elpr simpr ineq2d in0 simpl ineq1d incom ineq12 adantl
      inidm ccased expdimp ralrimiv prex istopg mp1i mpbir2and istopon sylanbrc
      wb eqcomd ) ABEZFAUAZUBEZAWKGZHWKAUCUDEWJWLCUNZWKUEZWNGZWKEZIZCUFZWNDUNZJ
      ZWKEZDWKUGZCWKUGZWJWRCWOWNFHZWNFUHZHZKZWNAUHZHZWNWKHZKZKWJWQWNFAUIWJXHWQX
      LWJXEWQXGXEWQIWJXEWPFGZWKWNFLXMFWKUJFAMUKZULNOXGWQIWJXGWPXFGZWKWNXFLXOFWK
      FMUMXNULNOPWJXJWQXKWJXJWQWJXJQWPAWKXJWJWPXIGAWNXILABUOUPWJAWKEZXJFABUQZUR
      USRWJXKWQWJXKQWPAWKXKWJWPWMAWNWKLWJWMFAUTZAFSEWJWMXRHMFASBVAVBXRAFUTAFAVC
      AVDVETZUPWJXPXKXQURUSRPPVFVGWJXCCWKWNWKEXEWNAHZKZWJXCWNFACVHVIWJYAXCWJYAQ
      ZXBDWKWTWKEWTFHZWTAHZKZYBXBWTFADVHVIWJYAYEXBWJXEYCXTYDXBXEYCQZXBIWJYFXAFW
      KYFXAWNFJZFYFWTFWNXEYCVJVKWNVLZTXNNOXTYCQZXBIWJYIXAFWKYIXAYGFYIWTFWNXTYCV
      JVKYHTXNNOXEYDQZXBIWJYJXAFWKYJXAFWTJZFYJWNFWTXEYDVMVNYKWTFJFFWTVOWTVLVETX
      NNOWJXTYDQZXBWJYLQZXAAWKYMXAAAJZAYLXAYNHWJWNAWTAVPVQAVRTWJXPYLXQURUSRVSVT
      VFWARVFWAWKSEWLWSXDQWHWJFAWBCDSWKWCWDWEWJWMAXSWIAWKWFWG $.

    $( The indiscrete topology on a set ` A ` .  Part of Example 2 in [Munkres]
       p. 77.  (Contributed by FL, 16-Jul-2006.)  (Revised by Stefan Allan,
       6-Nov-2008.)  (Revised by Mario Carneiro, 13-Aug-2015.) $)
    indistop $p |- { (/) , A } e. Top $=
      ( c0 cid cfv cpr ctop indislem cvv wcel ctopon indistopon ax-mp topontopi
      fvex eqeltrri ) BACDZEZBAEFAGPQPHIQPJDIACNPHKLMO $.

    $( The base set of the indiscrete topology.  (Contributed by Mario
       Carneiro, 14-Aug-2015.) $)
    indisuni $p |- ( _I ` A ) = U. { (/) , A } $=
      ( cid cfv c0 cpr ctopon indislem cvv wcel fvex indistopon ax-mp toponunii
      eqeltrri ) ABCZDAEZDOEZPOFCZAGOHIQRIABJOHKLNM $.
  $}

  ${
    $d x y z A $.
    $( The finite complement topology on a set ` A ` .  Example 3 in [Munkres]
       p. 77.  (Contributed by FL, 15-Aug-2006.)  (Revised by Mario Carneiro,
       13-Aug-2015.) $)
    fctop $p |- ( A e. V ->
        { x e. ~P A | ( ( A \ x ) e. Fin \/ x = (/) ) } e. ( TopOn ` A ) ) $=
      ( vy vz wcel cdif cfn c0 wceq wo wss wa difeq2 eleq1d eqeq1 orbi12d elrab
      cin cvv cv cpw crab ctop cuni ctopon cfv wi wal wral uniss ssrab2 sspwuni
      mpbi syl6ss vex uniex elpw sylibr wn wrex uni0c notbii rexnal ssel2 sylib
      bitr4i simprd ord con1d imp elssuni sscond ssfi sylan2 ad2antlr mpd exp31
      expcom rexlimdv syl5bi sylanbrc ax-gen ssinss1 inex1 3imtr4i ad2antrr cun
      orrd difindi unfi syl5eqel orcd ineq1 incom in0 eqtri syl6eq ineq2 ccase2
      olcd ad2ant2l jca anbi12i rgen2a pm3.2i wb pwexg rabexg istopg 3syl pwidg
      mpbiri 0fin orci a1i difid syl eqssd istopon ) BCFZBAUAZGZHFZYBIJZKZABUBZ
      UCZUDFZBYHUEZJYHBUFUGFYAYIDUAZYHLZYKUEZYHFZUHZDUIZYKEUAZSZYHFZEYHUJDYHUJZ
      MZYPYTYODYLYMYGFZBYMGZHFZYMIJZKZYNYLYMBLUUBYLYMYJBYKYHUKYHYGLYJBLZYFAYGUL
      YHBUMUNZUOYMBYKDUPZUQURUSYLUUDUUEYLUUEUUDUUEUTZYQIJZUTZEYKVAZYLUUDUUJUUKE
      YKUJZUTUUMUUEUUNEYKVBVCUUKEYKVDVGYLUULUUDEYKYLYQYKFZUULUUDYLUUOMZUULMBYQG
      ZHFZUUDUUPUULUURUUPUURUUKUUPUURUUKUUPYQYGFZUURUUKKZUUPYQYHFZUUSUUTMZYKYHY
      QVEYFUUTAYQYGYBYQJZYDUURYEUUKUVCYCUUQHYBYQBNOYBYQIPQRZVFVHVIVJVKUUOUURUUD
      UHYLUULUURUUOUUDUUOUURUUCUUQLUUDUUOYQYMBYQYKVLVMUUQUUCVNVOVSVPVQVRVTWAVJW
      IYFUUFAYMYGYBYMJZYDUUDYEUUEUVEYCUUCHYBYMBNOYBYMIPQRWBWCYSDEYHYKYGFZBYKGZH
      FZYKIJZKZMZUVBMZYRYGFZBYRGZHFZYRIJZKZMYKYHFZUVAMYSUVLUVMUVQUVFUVMUVJUVBYK
      BLYRBLUVFUVMYKYQBWDYKBUUIURYRBYKYQUUIWEURWFWGUVJUUTUVQUVFUUSUVHUURUVIUUKU
      VQUVHUURMZUVOUVPUVSUVNUVGUUQWHHBYKYQWJUVGUUQWKWLWMUVIUVPUVOUVIYRIYQSZIYKI
      YQWNUVTYQISIIYQWOYQWPWQWRXAUUKUVPUVOUUKYRYKISIYQIYKWSYKWPWRXAWTXBXCUVRUVK
      UVAUVBYFUVJAYKYGYBYKJZYDUVHYEUVIUWAYCUVGHYBYKBNOYBYKIPQRUVDXDYFUVQAYRYGYB
      YRJZYDUVOYEUVPUWBYCUVNHYBYRBNOYBYRIPQRWFXEXFYAYGTFYHTFYIUUAXGBCXHYFAYGTXI
      DETYHXJXKXMYABYJYABYHFZBYJLYABYGFIHFZBIJZKZUWCBCXLUWFYAUWDUWEXNXOXPYFUWFA
      BYGYBBJZYDUWDYEUWEUWGYCIHUWGYCBBGIYBBBNBXQWROYBBIPQRWBBYHVLXRUUGYAUUHXPXS
      BYHXTWB $.

    $( The finite complement topology on a set ` A ` .  Example 3 in [Munkres]
       p. 77.  (This version of ~ fctop requires the Axiom of Infinity.)
       (Contributed by FL, 20-Aug-2006.) $)
    fctop2 $p |- ( A e. V ->
        { x e. ~P A | ( ( A \ x ) ~< om \/ x = (/) ) } e. ( TopOn ` A ) ) $=
      ( wcel cv cdif com csdm wbr c0 wceq wo cpw cfn ctopon cfv isfinite orbi1i
      crab wb a1i rabbiia fctop syl5eqelr ) BCDBAEZFZGHIZUEJKZLZABMZSUFNDZUHLZA
      UJSBOPULUIAUJULUITUEUJDUKUGUHUFQRUAUBABCUCUD $.

    $( The countable complement topology on a set ` A ` .  Example 4 in
       [Munkres] p. 77.  (Contributed by FL, 23-Aug-2006.)  (Revised by Mario
       Carneiro, 13-Aug-2015.) $)
    cctop $p |- ( A e. V ->
        { x e. ~P A | ( ( A \ x ) ~<_ om \/ x = (/) ) } e. ( TopOn ` A ) ) $=
      ( vy vz wcel cdif com cdom wbr c0 wceq wo wss difeq2 breq1d eqeq1 orbi12d
      wa cvv cv cpw crab ctop cuni ctopon cfv wal cin wral uniss ssrab2 sspwuni
      wi mpbi syl6ss uniex elpw sylibr wn wrex uni0c notbii rexnal bitr4i ssel2
      vex elrab sylib simprd ord con1d imp reldom brrelexi adantl simpllr sscon
      3syl ssdomg sylc domtr sylancom mpdan exp31 rexlimdv syl5bi orrd sylanbrc
      elssuni ax-gen ssinss1 inex1 3imtr4i ad2antrr difindi unctb syl5eqbr orcd
      cun ineq1 incom in0 eqtri syl6eq ineq2 ccase2 ad2ant2l jca anbi12i rgen2a
      olcd pm3.2i pwexg rabexg istopg mpbiri pwidg omex 0dom orci a1i difid syl
      wb eqssd istopon ) BCFZBAUAZGZHIJZYIKLZMZABUBZUCZUDFZBYOUEZLYOBUFUGFYHYPD
      UAZYONZYRUEZYOFZUNZDUHZYREUAZUIZYOFZEYOUJDYOUJZSZUUCUUGUUBDYSYTYNFZBYTGZH
      IJZYTKLZMZUUAYSYTBNUUIYSYTYQBYRYOUKYOYNNYQBNZYMAYNULYOBUMUOZUPYTBYRDVGZUQ
      URUSYSUUKUULYSUULUUKUULUTZUUDKLZUTZEYRVAZYSUUKUUQUUREYRUJZUTUUTUULUVAEYRV
      BVCUUREYRVDVEYSUUSUUKEYRYSUUDYRFZUUSUUKYSUVBSZUUSSZBUUDGZHIJZUUKUVCUUSUVF
      UVCUVFUURUVCUVFUURUVCUUDYNFZUVFUURMZUVCUUDYOFZUVGUVHSZYRYOUUDVFYMUVHAUUDY
      NYIUUDLZYKUVFYLUURUVKYJUVEHIYIUUDBOPYIUUDKQRVHZVIVJVKVLVMUVDUVFUUJUVEIJZU
      UKUVDUVFSZUVETFZUUJUVENZUVMUVFUVOUVDUVEHIVNVOVPUVNUVBUUDYTNUVPYSUVBUUSUVF
      VQUUDYRWJUUDYTBVRVSUUJUVETVTWAUUJUVEHWBWCWDWEWFWGVLWHYMUUMAYTYNYIYTLZYKUU
      KYLUULUVQYJUUJHIYIYTBOPYIYTKQRVHWIWKUUFDEYOYRYNFZBYRGZHIJZYRKLZMZSZUVJSZU
      UEYNFZBUUEGZHIJZUUEKLZMZSYRYOFZUVISUUFUWDUWEUWIUVRUWEUWBUVJYRBNUUEBNUVRUW
      EYRUUDBWLYRBUUPURUUEBYRUUDUUPWMURWNWOUWBUVHUWIUVRUVGUVTUVFUWAUURUWIUVTUVF
      SZUWGUWHUWKUWFUVSUVEWTHIBYRUUDWPUVSUVEWQWRWSUWAUWHUWGUWAUUEKUUDUIZKYRKUUD
      XAUWLUUDKUIKKUUDXBUUDXCXDXEXLUURUWHUWGUURUUEYRKUIKUUDKYRXFYRXCXEXLXGXHXIU
      WJUWCUVIUVJYMUWBAYRYNYIYRLZYKUVTYLUWAUWMYJUVSHIYIYRBOPYIYRKQRVHUVLXJYMUWI
      AUUEYNYIUUELZYKUWGYLUWHUWNYJUWFHIYIUUEBOPYIUUEKQRVHWNXKXMYHYNTFYOTFYPUUHY
      EBCXNYMAYNTXODETYOXPVSXQYHBYQYHBYOFZBYQNYHBYNFKHIJZBKLZMZUWOBCXRUWRYHUWPU
      WQHXSXTYAYBYMUWRABYNYIBLZYKUWPYLUWQUWSYJKHIUWSYJBBGKYIBBOBYCXEPYIBKQRVHWI
      BYOWJYDUUNYHUUOYBYFBYOYGWI $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z P $.  $d w x y z V $.
    $( The particular point topology.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ppttop $p |- ( ( A e. V /\ P e. A ) ->
        { x e. ~P A | ( P e. x \/ x = (/) ) } e. ( TopOn ` A ) ) $=
      ( vy vz wcel wa c0 wceq wo wss wn syl syl5bi eleq2 eqeq1 orbi12d sylanbrc
      elrab cv cpw crab ctop cuni ctopon cfv wi wal cin wral ssrab simprl sylib
      sspwuni vex uniex elpw sylibr wex neq0 eluni2 r19.29 n0i adantl simpl ord
      wrex mt3d elunii syl2anc rexlimiva ex ad2antll exlimdv con1d orrd alrimiv
      anbi12i inss1 simprll elpwid inex1 ianor xchnxbir simprlr simprrr orim12d
      syl5ss elin inss ss0b orbi12i 3imtr3i syl6 ralrimivv cvv wb adantr rabexg
      pwexg istopg mpbir2and pwidg simpr orcd elssuni ssrab2 mpbi eqssd istopon
      a1i ) BDGZCBGZHZCAUAZGZXPIJZKZABUBZUCZUDGZBYAUEZJYABUFUGGXOYBEUAZYALZYDUE
      ZYAGZUHZEUIZYDFUAZUJZYAGZFYAUKEYAUKZXOYHEYEYDXTLZXSAYDUKZHZXOYGXSAXTYDULX
      OYPYGXOYPHZYFXTGZCYFGZYFIJZKZYGYQYFBLZYRYQYNUUBXOYNYOUMYDBUOUNYFBYDEUPZUQ
      URUSYQYSYTYQYTYSYTMYJYFGZFUTYQYSFYFVAYQUUDYSFUUDYJXPGZAYDVHZYQYSAYJYDVBYO
      UUFYSUHXOYNYOUUFYSYOUUFHXSUUEHZAYDVHYSXSUUEAYDVCUUGYSAYDXPYDGZUUGHXQUUHYS
      UUGXQUUHUUGXQXRUUEXRMXSXPYJVDVEUUGXQXRXSUUEVFVGVIVEUUHUUGVFCXPYDVJVKVLNVM
      VNOVOOVPVQXSUUAAYFXTXPYFJXQYSXRYTXPYFCPXPYFIQRTSVMOVRXOYLEFYAYAYDYAGZYJYA
      GZHYDXTGZCYDGZYDIJZKZHZYJXTGZCYJGZYJIJZKZHZHZXOYLUUIUUOUUJUUTXSUUNAYDXTXP
      YDJXQUULXRUUMXPYDCPXPYDIQRTXSUUSAYJXTXPYJJXQUUQXRUURXPYJCPXPYJIQRTVSXOUVA
      YLXOUVAHZYKXTGZCYKGZYKIJZKZYLUVBYKBLUVCUVBYKYDBYDYJVTUVBYDBXOUUKUUNUUTWAW
      BWIYKBYDYJUUCWCURUSUVBUVDUVEUVBUVDMZUUMUURKZUVEUVGUULMZUUQMZKZUVBUVHUULUU
      QHUVKUVDUULUUQWDCYDYJWJWEUVBUVIUUMUVJUURUVBUULUUMXOUUKUUNUUTWFVGUVBUUQUUR
      XOUUOUUPUUSWGVGWHOYDILZYJILZKYKILUVHUVEYDYJIWKUVLUUMUVMUURYDWLYJWLWMYKWLW
      NWOVQXSUVFAYKXTXPYKJXQUVDXRUVEXPYKCPXPYKIQRTSVMOWPXOYAWQGZYBYIYMHWRXOXTWQ
      GZUVNXMUVOXNBDXAWSXSAXTWQWTNEFWQYAXBNXCXOBYCXOBYAGZBYCLXOBXTGZXNBIJZKZUVP
      XMUVQXNBDXDWSXOXNUVRXMXNXEXFXSUVSABXTXPBJXQXNXRUVRXPBCPXPBIQRTSBYAXGNYCBL
      ZXOYAXTLUVTXSAXTXHYABUOXIXLXJBYAXKS $.

    $( The particular point topology is generated by a basis consisting of
       pairs ` { x , P } ` for each ` x e. A ` .  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    pptbas $p |- ( ( A e. V /\ P e. A ) ->
        { x e. ~P A | ( P e. x \/ x = (/) ) } =
        ( topGen ` ran ( x e. A |-> { x , P } ) ) ) $=
      ( vy vw vv vz wcel wa cv cpr c0 wceq wo wss wral eleq2 eqeq1 orbi12d cmpt
      crn ctg cfv cpw crab ctop wrex ctopon ppttop topontop syl wf simpr simplr
      prssi prex elpw sylibr prid2g ad2antlr orcd elrab sylanbrc eqid fmptd frn
      syl2anc elpwi ad2antrl sselda prid1g adantl wn n0i simplrr ord mt3d preq1
      eleq2d sseq1d rspcev syl12anc cvv wb rgenw sseq1 rexrnmpt ax-mp ralrimiva
      anbi12d ex syl5bi ralrimiv basgen2 syl3anc cbvrabv syl6req ) BDIZCBIZJZAB
      AKZCLZUAZUBZUCUDZCEKZIZXGMNZOZEBUEZUFZCXBIZXBMNZOZAXKUFXAXLUGIZXEXLPZFKZG
      KZIZXSHKZPZJZGXEUHZFYAQZHXLQXFXLNXAXLBUIUDIXPEBCDUJBXLUKULXABXLXDUMXQXAAB
      XCXLXDXAXBBIZJZXCXKIZCXCIZXCMNZOZXCXLIYGXCBPZYHYGYFWTYLXAYFUNWSWTYFUOXBCB
      UPVHXCBXBCUQZURUSYGYIYJWTYIWSYFXBCBUTVAVBXJYKEXCXKXGXCNXHYIXIYJXGXCCRXGXC
      MSTVCVDXDVEZVFBXLXDVGULXAYEHXLYAXLIYAXKIZCYAIZYAMNZOZJZXAYEXJYREYAXKXGYAN
      XHYPXIYQXGYACRXGYAMSTVCXAYSYEXAYSJZYDFYAYTXRYAIZJZXRXCIZXCYAPZJZABUHZYDUU
      BXRBIXRXRCLZIZUUGYAPZUUFYTYABXRYOYABPXAYRYABVIVJVKUUAUUHYTXRCYAVLVMUUBUUA
      YPUUIYTUUAUNUUBYPYQUUAYQVNYTYAXRVOVMUUBYPYQXAYOYRUUAVPVQVRXRCYAUPVHUUEUUH
      UUIJAXRBXBXRNZUUCUUHUUDUUIUUJXCUUGXRXBXRCVSZVTUUJXCUUGYAUUKWAWKWBWCXCWDIZ
      ABQYDUUFWEUULABYMWFYCUUEAGBXCXDWDYNXSXCNXTUUCYBUUDXSXCXRRXSXCYAWGWKWHWIUS
      WJWLWMWNHFGXEXLWOWPXJXOEAXKXGXBNXHXMXIXNXGXBCRXGXBMSTWQWR $.
  $}

  ${
    $d x y z A $.  $d x y z P $.  $d y z V $.
    $( The excluded point topology.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    epttop $p |- ( ( A e. V /\ P e. A ) ->
        { x e. ~P A | ( P e. x -> x = A ) } e. ( TopOn ` A ) ) $=
      ( vy vz wcel wa cv wceq wss wral adantr syl eleq2 eqeq1 imbi12d elrab cvv
      wi cpw crab ctop cuni ctopon cfv wal cin ssrab simprl sspwuni sylib uniex
      vex elpw sylibr wrex eluni2 r19.29 simpr impr eqsstr3d rexlimiva ad2antll
      elssuni syl5bi jctild eqss syl6ibr sylanbrc alrimiv simprll elpwid syl5ss
      inss1 inex1 elin simprlr simprrr anim12d ineq12 inidm syl6eq syl6 anbi12i
      ex jca 3imtr4g ralrimivv wb pwexg rabexg istopg mpbir2and pwidg eqidd a1d
      ssrab2 mpbi a1i eqssd istopon ) BDGZCBGZHZCAIZGZXFBJZTZABUAZUBZUCGZBXKUDZ
      JXKBUEUFGXEXLEIZXKKZXNUDZXKGZTZEUGZXNFIZUHZXKGZFXKLEXKLZXEXREXOXNXJKZXIAX
      NLZHZXEXQXIAXJXNUIXEYFXQXEYFHZXPXJGZCXPGZXPBJZTZXQYGXPBKZYHYGYDYLXEYDYEUJ
      XNBUKULZXPBXNEUNZUMUOUPYGYIYLBXPKZHYJYGYIYOYLYIXGAXNUQZYGYOACXNURYEYPYOTX
      EYDYEYPYOYEYPHXIXGHZAXNUQYOXIXGAXNUSYQYOAXNXFXNGZYQHBXFXPYRXIXGXHYRXIUTVA
      YRXFXPKYQXFXNVEMVBVCNWFVDVFYMVGXPBVHVIXIYKAXPXJXFXPJXGYIXHYJXFXPCOXFXPBPQ
      RVJWFVFVKXEYBEFXKXKXEXNXJGZCXNGZXNBJZTZHZXTXJGZCXTGZXTBJZTZHZHZYAXJGZCYAG
      ZYABJZTZHZXNXKGZXTXKGZHYBXEUUIUUNXEUUIHZUUJUUMUUQYABKUUJUUQYAXNBXNXTVOUUQ
      XNBXEYSUUBUUHVLVMVNYABXNXTYNVPUOUPUUKYTUUEHZUUQUULCXNXTVQUUQUURUUAUUFHZUU
      LUUQYTUUAUUEUUFXEYSUUBUUHVRXEUUCUUDUUGVSVTUUSYABBUHBXNBXTBWABWBWCWDVFWGWF
      UUOUUCUUPUUHXIUUBAXNXJXFXNJXGYTXHUUAXFXNCOXFXNBPQRXIUUGAXTXJXFXTJXGUUEXHU
      UFXFXTCOXFXTBPQRWEXIUUMAYAXJXFYAJXGUUKXHUULXFYACOXFYABPQRWHWIXEXKSGZXLXSY
      CHWJXEXJSGZUUTXCUVAXDBDWKMXIAXJSWLNEFSXKWMNWNXEBXMXEBXKGZBXMKXEBXJGZXDBBJ
      ZTZUVBXCUVCXDBDWOMXEUVDXDXEBWPWQXIUVEABXJXHXGXDXHUVDXFBCOXFBBPQRVJBXKVENX
      MBKZXEXKXJKUVFXIAXJWRXKBUKWSWTXABXKXBVJ $.
  $}

  ${
    indistpsx.a $e |- A e. _V $.
    indistpsx.k $e |- K = { <. 1 , A >. , <. 9 , { (/) , A } >. } $.
    $( The indiscrete topology on a set ` A ` expressed as a topological space,
       using explicit structure component references.  Compare with ~ indistps
       and ~ indistps2 .  The advantage of this version is that the actual
       function for the structure is evident, and ~ df-ndx is not needed, nor
       any other special definition outside of basic set theory.  The
       disadvantage is that if the indices of the component definitions
       ~ df-base and ~ df-tset are changed in the future, this theorem will
       also have to be changed.  Note:  This theorem has hard-coded structure
       indices for demonstration purposes.  It is not intended for general use;
       use ~ indistps instead.  (New usage is discouraged.)  (Contributed by
       FL, 19-Jul-2006.) $)
    indistpsx $p |- K e. TopSp $=
      ( c0 cpr c1 cop cnx cbs cfv cts basendx opeq1i tsetndx preq12i eqtr4i cvv
      c9 wcel ctopon indistopon ax-mp toponunii indistop eltpsi ) AEAFZBBGAHZSU
      GHZFIJKZAHZILKZUGHZFDUKUHUMUIUJGAMNULSUGONPQAUGARTUGAUAKTCARUBUCUDAUEUF
      $.
  $}

  ${
    indistps.a $e |- A e. _V $.
    indistps.k $e |- K
      = { <. ( Base ` ndx ) , A >. , <. ( TopSet ` ndx ) , { (/) , A } >. } $.
    $( The indiscrete topology on a set ` A ` expressed as a topological space,
       using implicit structure indices.  The advantage of this version over
       ~ indistpsx is that it is independent of the indices of the component
       definitions ~ df-base and ~ df-tset , and if they are changed in the
       future, this theorem will not be affected.  The advantage over
       ~ indistps2 is that it is easy to eliminate the hypotheses with ~ eqid
       and ~ vtoclg to result in a closed theorem.  Theorems ~ indistpsALT and
       ~ indistps2ALT show that the two forms can be derived from each other.
       (Contributed by FL, 19-Jul-2006.) $)
    indistps $p |- K e. TopSp $=
      ( c0 cpr cuni cun 0ex unipr uncom un0 3eqtrri indistop eltpsi ) AEAFZBDPG
      EAHAEHAEAICJEAKALMANO $.
  $}

  ${
    indistps2.a $e |- ( Base ` K ) = A $.
    indistps2.j $e |- ( TopOpen ` K ) = { (/) , A } $.
    $( The indiscrete topology on a set ` A ` expressed as a topological space,
       using direct component assignments.  Compare with ~ indistps .  The
       advantage of this version is that it is the shortest to state and
       easiest to work with in most situations.  Theorems ~ indistpsALT and
       ~ indistps2ALT show that the two forms can be derived from each other.
       (Contributed by NM, 24-Oct-2012.) $)
    indistps2 $p |- K e. TopSp $=
      ( cpr cuni cun 0ex cbs cfv cvv fvex eqeltrri unipr uncom 3eqtrri indistop
      c0 un0 istpsi ) ARAEZBCDUAFRAGARGARAHBIJAKCBILMNRAOASPAQT $.
  $}

  ${
    indistpsALT.a $e |- A e. _V $.
    indistpsALT.k $e |- K
      = { <. ( Base ` ndx ) , A >. , <. ( TopSet ` ndx ) , { (/) , A } >. } $.
    $( The indiscrete topology on a set ` A ` expressed as a topological
       space.  Here we show how to derive the structural version ~ indistps
       from the direct component assignment version ~ indistps2 .  (Contributed
       by NM, 24-Oct-2012.)  (Proof modification is discouraged.) $)
    indistpsALT $p |- K e. TopSp $=
      ( cvv wcel c0 cpr ctopon cfv ctps indistopon cbs wceq cts c9 df-tset 1lt9
      9nn ax-mp 2strbas prex 2strop tsettps mp2b ) AEFZGAHZAIJFBKFCAELAUGBUFABM
      JNCAUGOBPEDQRSUATUGEFUGBOJNGAUBAUGOBPEDQRSUCTUDUE $.
  $}

  ${
    indistps2ALT.a $e |- ( Base ` K ) = A $.
    indistps2ALT.j $e |- ( TopOpen ` K ) = { (/) , A } $.
    $( The indiscrete topology on a set ` A ` expressed as a topological space,
       using direct component assignments.  Here we show how to derive the
       direct component assignment version ~ indistps2 from the structural
       version ~ indistps .  (Contributed by NM, 24-Oct-2012.)
       (Proof modification is discouraged.) $)
    indistps2ALT $p |- K e. TopSp $=
      ( ctps wcel cpr ctopon cfv cvv cbs eqeltrri indistopon ax-mp eqcomi ctopn
      c0 fvex istps mpbir ) BEFQAGZAHIFZAJFUBBKIZAJCBKRLAJMNAUABUCACOBPIUADOST
      $.
  $}

  ${
    distps.a $e |- A e. _V $.
    distps.k $e |- K
             = { <. ( Base ` ndx ) , A >. , <. ( TopSet ` ndx ) , ~P A >. } $.
    $( The discrete topology on a set ` A ` expressed as a topological space.
       (Contributed by FL, 20-Aug-2006.) $)
    distps $p |- K e. TopSp $=
      ( cpw cuni unipw eqcomi cvv wcel ctop distop ax-mp eltpsi ) AAEZBDOFAAGHA
      IJOKJCAILMN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Closure and interior
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c int $.
  $c cls $.
  $c Clsd $.

  $( Extend class notation with the set of closed sets of a topology. $)
  ccld $a class Clsd $.

  $( Extend class notation with interior of a subset of a topology base set. $)
  cnt $a class int $.

  $( Extend class notation with closure of a subset of a topology base set. $)
  ccl $a class cls $.

  ${
    $d j x y $.
    $( Define a function on topologies whose value is the set of closed sets of
       the topology.  (Contributed by NM, 2-Oct-2006.) $)
    df-cld $a |- Clsd =
                 ( j e. Top |-> { x e. ~P U. j | ( U. j \ x ) e. j } ) $.

    $( Define a function on topologies whose value is the interior function on
       the subsets of the base set.  See ~ ntrval .  (Contributed by NM,
       10-Sep-2006.) $)
    df-ntr $a |- int = ( j e. Top |->
                        ( x e. ~P U. j |-> U. ( j i^i ~P x ) ) ) $.

    $( Define a function on topologies whose value is the closure function on
       the subsets of the base set.  See ~ clsval .  (Contributed by NM,
       3-Oct-2006.) $)
    df-cls $a |- cls = ( j e. Top |-> ( x e. ~P U. j |->
                        |^| { y e. ( Clsd ` j ) | x C_ y } ) ) $.

    $( The closed-set generator is a well-behaved function.  (Contributed by
       Stefan O'Rear, 1-Feb-2015.) $)
    fncld $p |- Clsd Fn Top $=
      ( vj vx ctop cv cuni cdif wcel cpw crab ccld vex uniex pwex df-cld fnmpti
      rabex ) ACADZEZBDFQGZBRHZIJSBTRQAKLMPBANO $.
  $}

  ${
    $d x y j J $.  $d x j X $.
    cldval.1 $e |- X = U. J $.
    $( The set of closed sets of a topology.  (Note that the set of open sets
       is just the topology itself, so we don't have a separate definition.)
       (Contributed by NM, 2-Oct-2006.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    cldval $p |- ( J e. Top ->
               ( Clsd ` J ) = { x e. ~P X | ( X \ x ) e. J } ) $=
      ( vj ctop wcel cv cdif cpw crab cvv ccld cfv wceq topopn rabexg 3syl cuni
      pwexg unieq syl6eqr pweqd wb difeq1d eleq12 rabeqbidv df-cld fvmptg mpdan
      mpancom ) BFGZCAHZIZBGZACJZKZLGZBMNUQOULCBGUPLGURBCDPCBTUOAUPLQREBEHZSZUM
      IZUSGZAUTJZKUQFLMUSBOZVBUOAVCUPVDUTCVDUTBSCUSBUADUBZUCVAUNOVDVBUOUDVDUTCU
      MVEUEVAUNUSBUFUKUGAEUHUIUJ $.

    $( The interior function on the subsets of a topology's base set.
       (Contributed by NM, 10-Sep-2006.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    ntrfval $p |- ( J e. Top -> ( int ` J ) = ( x e. ~P X |->
                     U. ( J i^i ~P x ) ) ) $=
      ( vj ctop wcel cpw cv cin cuni cmpt cvv cnt wceq topopn pwexg mptexg 3syl
      cfv unieq syl6eqr pweqd ineq1 unieqd mpteq12dv df-ntr fvmptg mpdan ) BFGZ
      ACHZBAIHZJZKZLZMGZBNTUOOUJCBGUKMGUPBCDPCBQAUKUNMRSEBAEIZKZHZUQULJZKZLUOFM
      NUQBOZAUSVAUKUNVBURCVBURBKCUQBUADUBUCVBUTUMUQBULUDUEUFAEUGUHUI $.

    $( The closure function on the subsets of a topology's base set.
       (Contributed by NM, 3-Oct-2006.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    clsfval $p |- ( J e. Top -> ( cls ` J ) = ( x e. ~P X |->
                     |^| { y e. ( Clsd ` J ) | x C_ y } ) ) $=
      ( vj ctop wcel cpw cv wss ccld cfv crab cint cmpt cvv ccl wceq cuni pwexg
      topopn mptexg unieq syl6eqr pweqd fveq2 rabeq syl inteqd mpteq12dv df-cls
      3syl fvmptg mpdan ) CGHZADIZAJBJKZBCLMZNZOZPZQHZCRMVBSUPDCHUQQHVCCDEUBDCU
      AAUQVAQUCUMFCAFJZTZIZURBVDLMZNZOZPVBGQRVDCSZAVFVIUQVAVJVEDVJVECTDVDCUDEUE
      UFVJVHUTVJVGUSSVHUTSVDCLUGURBVGUSUHUIUJUKABFULUNUO $.
  $}

  $( Reverse closure of the closed set operation.  (Contributed by Stefan
     O'Rear, 22-Feb-2015.) $)
  cldrcl $p |- ( C e. ( Clsd ` J ) -> J e. Top ) $=
    ( ccld cfv wcel cdm ctop elfvdm wfn wceq fncld fndm ax-mp syl6eleq ) ABCDEB
    CFZGABCHCGIOGJKGCLMN $.

  ${
    $d x y z J $.  $d x y z S $.  $d x y z X $.  $d x T $.
    iscld.1 $e |- X = U. J $.
    $( The predicate " ` S ` is a closed set."  (Contributed by NM,
       2-Oct-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    iscld $p |- ( J e. Top -> ( S e. ( Clsd ` J ) <->
                 ( S C_ X /\ ( X \ S ) e. J ) ) ) $=
      ( vx ctop wcel ccld cfv cpw cdif wa wss cv crab cldval eleq2d wceq difeq2
      eleq1d elrab syl6bb wb topopn elpw2g syl anbi1d bitrd ) BFGZABHIZGZACJZGZ
      CAKZBGZLZACMZUOLUIUKACENZKZBGZEULOZGUPUIUJVAAEBCDPQUTUOEAULURARUSUNBURACS
      TUAUBUIUMUQUOUICBGUMUQUCBCDUDACBUEUFUGUH $.

    $( A subset of the underlying set of a topology is closed iff its
       complement is open.  (Contributed by NM, 4-Oct-2006.) $)
    iscld2 $p |- ( ( J e. Top /\ S C_ X ) ->
                  ( S e. ( Clsd ` J ) <-> ( X \ S ) e. J ) ) $=
      ( ctop wcel ccld cfv wss cdif iscld baibd ) BEFABGHFACICAJBFABCDKL $.

    $( A closed set is a subset of the underlying set of a topology.
       (Contributed by NM, 5-Oct-2006.)  (Revised by Stefan O'Rear,
       22-Feb-2015.) $)
    cldss $p |- ( S e. ( Clsd ` J ) -> S C_ X ) $=
      ( ctop wcel ccld cfv wss cldrcl cdif iscld simprbda mpancom ) BEFZABGHFZA
      CIZABJOPQCAKBFABCDLMN $.

    $( The set of closed sets is contained in the powerset of the base.
       (Contributed by Mario Carneiro, 6-Jan-2014.) $)
    cldss2 $p |- ( Clsd ` J ) C_ ~P X $=
      ( vx ccld cfv cpw cv wcel wss cldss vex elpw sylibr ssriv ) DAEFZBGZDHZPI
      RBJRQIRABCKRBDLMNO $.

    $( The complement of a closed set is open.  (Contributed by NM,
       5-Oct-2006.)  (Revised by Stefan O'Rear, 22-Feb-2015.) $)
    cldopn $p |- ( S e. ( Clsd ` J ) -> ( X \ S ) e. J ) $=
      ( ctop wcel ccld cfv cdif cldrcl wss iscld simplbda mpancom ) BEFZABGHFZC
      AIBFZABJOPACKQABCDLMN $.

    $( A subset of the underlying set of a topology is open iff its complement
       is closed.  (Contributed by NM, 4-Oct-2006.) $)
    isopn2 $p |- ( ( J e. Top /\ S C_ X ) ->
                  ( S e. J <-> ( X \ S ) e. ( Clsd ` J ) ) ) $=
      ( ctop wcel wss wa cdif ccld cfv wb difss iscld2 mpan2 wceq biimpi eleq1d
      dfss4 sylan9bb bicomd ) BEFZACGZHCAIZBJKFZABFZUBUECUDIZBFZUCUFUBUDCGUEUHL
      CAMUDBCDNOUCUGABUCUGAPACSQRTUA $.

    $( The complement of an open set is closed.  (Contributed by NM,
       6-Oct-2006.) $)
    opncld $p |- ( ( J e. Top /\ S e. J ) -> ( X \ S ) e. ( Clsd ` J ) ) $=
      ( ctop wcel wa cdif ccld cfv simpr wss wb eltopss isopn2 syldan mpbid ) B
      EFZABFZGSCAHBIJFZRSKRSACLSTMABCDNABCDOPQ $.

    $( The difference of a closed set with an open set is open.  (Contributed
       by Mario Carneiro, 6-Jan-2014.) $)
    difopn $p |- ( ( A e. J /\ B e. ( Clsd ` J ) ) -> ( A \ B ) e. J ) $=
      ( wcel ccld cfv wa cin cdif wss wceq elssuni syl6sseqr adantr df-ss sylib
      cuni adantl difeq1d indif2 cldrcl simpl cldopn syl3anc syl5eqelr eqeltrrd
      ctop inopn ) ACFZBCGHFZIZADJZBKZABKCUMUNABUMADLZUNAMUKUPULUKACSDACNEOPADQ
      RUAUMUOADBKZJZCADBUBUMCUIFZUKUQCFZURCFULUSUKBCUCTUKULUDULUTUKBCDEUETAUQCU
      JUFUGUH $.

    $( The underlying set of a topology is closed.  Part of Theorem 6.1(1) of
       [Munkres] p. 93.  (Contributed by NM, 3-Oct-2006.) $)
    topcld $p |- ( J e. Top -> X e. ( Clsd ` J ) ) $=
      ( ctop wcel ccld cfv wss cdif wa c0 difid 0opn syl5eqel ssid jctil mpbird
      iscld ) ADEZBAFGEBBHZBBIZAEZJSUBTSUAKABLAMNBOPBABCRQ $.

    $( The interior of a subset of a topology's base set is the union of all
       the open sets it includes.  Definition of interior of [Munkres] p. 94.
       (Contributed by NM, 10-Sep-2006.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    ntrval $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) =
                 U. ( J i^i ~P S ) ) $=
      ( vx ctop wcel wss wa cnt cfv cpw cv cin cuni cmpt wceq adantr cvv syl wb
      ntrfval fveq1d topopn elpw2g inex1g uniexg pweq ineq2d unieqd eqid fvmptg
      biimpar syl2anc eqtrd ) BFGZACHZIZABJKZKZAECLZBEMZLZNZOZPZKZBALZNZOZUPUTV
      GQUQUPAUSVFEBCDUBUCRURAVAGZVJSGZVGVJQUPVKUQUPCBGVKUQUABCDUDACBUETUMURVISG
      ZVLUPVMUQBVHFUFRVISUGTEAVEVJVASVFVBAQZVDVIVNVCVHBVBAUHUIUJVFUKULUNUO $.

    $( The closure of a subset of a topology's base set is the intersection of
       all the closed sets that include it.  Definition of closure of [Munkres]
       p. 94.  (Contributed by NM, 10-Sep-2006.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    clsval $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) =
                 |^| { x e. ( Clsd ` J ) | S C_ x } ) $=
      ( vy ctop wcel wss wa ccl cfv cpw cv ccld crab cint cmpt wceq cvv clsfval
      fveq1d adantr wb topopn elpw2g syl biimpar wrex topcld sseq2 rspcev sylan
      intexrab sylib sseq1 rabbidv inteqd eqid fvmptg syl2anc eqtrd ) CGHZBDIZJ
      ZBCKLZLZBFDMZFNZANZIZACOLZPZQZRZLZBVJIZAVLPZQZVCVGVPSVDVCBVFVOFACDEUAUBUC
      VEBVHHZVSTHZVPVSSVCVTVDVCDCHVTVDUDCDEUEBDCUFUGUHVEVQAVLUIZWAVCDVLHVDWBCDE
      UJVQVDADVLVJDBUKULUMVQAVLUNUOFBVNVSVHTVOVIBSZVMVRWCVKVQAVLVIBVJUPUQURVOUS
      UTVAVB $.
  $}

  $( The empty set is closed.  Part of Theorem 6.1(1) of [Munkres] p. 93.
     (Contributed by NM, 4-Oct-2006.) $)
  0cld $p |- ( J e. Top -> (/) e. ( Clsd ` J ) ) $=
    ( ctop wcel c0 ccld cfv cuni cdif dif0 topopn wss wb 0ss eqid iscld2 mpbird
    mpan2 ) ABCZDAEFCZAGZDHZACZAUATIJRDTKSUBLTMDATTNOQP $.

  ${
    $d x A $.  $d x J $.  $d x S $.
    $( The indexed intersection of a collection ` B ( x ) ` of closed sets is
       closed.  Theorem 6.1(2) of [Munkres] p. 93.  (Contributed by NM,
       5-Oct-2006.)  (Revised by Mario Carneiro, 3-Sep-2015.) $)
    iincld $p |- ( ( A =/= (/) /\ A. x e. A B e. ( Clsd ` J ) ) ->
                  |^|_ x e. A B e. ( Clsd ` J ) ) $=
      ( c0 wne ccld cfv wcel wral wa ciin cuni cdif ciun wceq ralimi syl adantl
      syl2anc wss eqid cldss dfss4 sylib iineq2 iindif2 adantr eqtr3d ctop wrex
      r19.2z cldrcl rexlimivw cldopn iunopn opncld eqeltrd ) BEFZCDGHZIZABJZKZA
      BCLZDMZABVECNZOZNZUTVCABVEVFNZLZVDVHVBVJVDPZUSVBVICPZABJVKVAVLABVACVEUAVL
      CDVEVEUBZUCCVEUDUEQABVICUFRSUSVJVHPVBABVEVFUGUHUIVCDUJIZVGDIZVHUTIVCVAABU
      KVNVAABULVAVNABCDUMUNRZVCVNVFDIZABJZVOVPVBVRUSVAVQABCDVEVMUOQSABVFDUPTVGD
      VEVMUQTUR $.

    $( The intersection of a set of closed sets is closed.  (Contributed by NM,
       5-Oct-2006.) $)
    intcld $p |- ( ( A =/= (/) /\ A C_ ( Clsd ` J ) ) ->
                  |^| A e. ( Clsd ` J ) ) $=
      ( vx c0 wne ccld cfv wss wa cint cv ciin intiin wcel dfss3 iincld sylan2b
      wral syl5eqel ) ADEZABFGZHZIAJCACKZLZUACAMUBTUCUANCARUDUANCAUAOCAUCBPQS
      $.

    $( The union of two closed sets is closed.  Equivalent to Theorem 6.1(3) of
       [Munkres] p. 93.  (Contributed by NM, 5-Oct-2006.) $)
    uncld $p |- ( ( A e. ( Clsd ` J ) /\ B e. ( Clsd ` J ) ) ->
                 ( A u. B ) e. ( Clsd ` J ) ) $=
      ( ccld cfv wcel wa cun cuni cdif difundi ctop cldrcl adantr cldopn adantl
      cin eqid wss cldss inopn syl3anc syl5eqel wb anim12i sylib iscld2 syl2anc
      unss mpbird ) ACDEZFZBUKFZGZABHZUKFZCIZUOJZCFZUNURUQAJZUQBJZQZCUQABKUNCLF
      ZUTCFZVACFZVBCFULVCUMACMNZULVDUMACUQUQRZONUMVEULBCUQVGOPUTVACUAUBUCUNVCUO
      UQSZUPUSUDVFUNAUQSZBUQSZGVHULVIUMVJACUQVGTBCUQVGTUEABUQUIUFUOCUQVGUGUHUJ
      $.

    $( A closed subset equals its own closure.  (Contributed by NM,
       15-Mar-2007.) $)
    cldcls $p |- ( S e. ( Clsd ` J ) ->
                 ( ( cls ` J ) ` S ) = S ) $=
      ( vx ccld cfv wcel ccl cv wss crab cint ctop cuni wceq cldrcl eqid clsval
      cldss syl2anc intmin eqtrd ) ABDEZFZABGEEZACHICUBJKZAUCBLFABMZIUDUENABOAB
      UFUFPZRCABUFUGQSCAUBTUA $.
  $}

  ${
    $d A x $.  $d B x $.
    $( The intersection of two closed sets is closed.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 3-Sep-2015.) $)
    incld $p |- ( ( A e. ( Clsd ` J ) /\ B e. ( Clsd ` J ) )
                                      -> ( A i^i B ) e. ( Clsd ` J ) ) $=
      ( ccld cfv wcel wa cpr cint cin intprg wne wss prnzg adantr prssi syl2anc
      c0 intcld eqeltrrd ) ACDEZFZBUAFZGZABHZIZABJUAABUAUAKUDUERLZUEUAMUFUAFUBU
      GUCABUANOABUAPUECSQT $.
  $}

  ${
    $d x y z J $.  $d x P $.  $d x y z S $.  $d x U $.  $d x y z X $.
    $d x T $.  $d x A $.
    clscld.1 $e |- X = U. J $.
    $( An indexed relative intersection of closed sets is closed.  (Contributed
       by Stefan O'Rear, 22-Feb-2015.) $)
    riincld $p |- ( ( J e. Top /\ A. x e. A B e. ( Clsd ` J ) ) ->
        ( X i^i |^|_ x e. A B ) e. ( Clsd ` J ) ) $=
      ( ctop wcel ccld cfv wral wa ciin cin wceq riin0 adantl ad2antrr syl2anc
      c0 topcld eqeltrd wne simpr simplr iincld incld pm2.61dane ) DGHZCDIJZHAB
      KZLZEABCMZNZUJHZBTULBTOZLUNEUJUPUNEOULAECBPQUIEUJHZUKUPDEFUAZRUBULBTUCZLZ
      UQUMUJHZUOUIUQUKUSURRUTUSUKVAULUSUDUIUKUSUEABCDUFSEUMDUGSUH $.

    $( A finite indexed union of closed sets is closed.  (Contributed by Mario
       Carneiro, 19-Sep-2015.) $)
    iuncld $p |- ( ( J e. Top /\ A e. Fin /\ A. x e. A B e. ( Clsd ` J ) ) ->
        U_ x e. A B e. ( Clsd ` J ) ) $=
      ( ctop wcel cfn ccld cfv wral w3a cdif ciin cin ciun difin wceq ralimi
      iundif2 eqtr4i wss cldss dfss4 sylib 3ad2ant3 iuneq2 syl5eq simp1 riinopn
      syl cldopn syl3an3 opncld syl2anc eqeltrrd ) DGHZBIHZCDJKZHZABLZMZEEABECN
      ZOZPZNZABCQZUTVCVGABEVDNZQZVHVGEVENVJEVERABEVDUAUBVCVICSZABLZVJVHSVBURVLU
      SVAVKABVACEUCVKCDEFUDCEUEUFTUGABVICUHULUIVCURVFDHZVGUTHURUSVBUJVBURUSVDDH
      ZABLVMVAVNABCDEFUMTABVDDEFUKUNVFDEFUOUPUQ $.

    $( A finite union of closed sets is closed.  (Contributed by Mario
       Carneiro, 19-Sep-2015.) $)
    unicld $p |- ( ( J e. Top /\ A e. Fin /\ A C_ ( Clsd ` J ) ) ->
        U. A e. ( Clsd ` J ) ) $=
      ( vx ctop wcel cfn ccld cfv wss w3a cuni cv ciun uniiun wral dfss3 iuncld
      syl3an3b syl5eqel ) BFGZAHGZABIJZKZLAMEAENZOZUDEAPUEUBUCUFUDGEAQUGUDGEAUD
      REAUFBCDSTUA $.

    $( The closure of a subset of a topology's underlying set is closed.
       (Contributed by NM, 4-Oct-2006.) $)
    clscld $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( ( cls ` J ) ` S ) e. ( Clsd ` J ) ) $=
      ( vx ctop wcel wss wa ccl cfv cv ccld crab cint clsval wne topcld anim1i
      c0 sseq2 elrab sylibr ne0i syl ssrab2 intcld sylancl eqeltrd ) BFGZACHZIZ
      ABJKKAELZHZEBMKZNZOZUOEABCDPULUPTQZUPUOHUQUOGULCUPGZURULCUOGZUKIUSUJUTUKB
      CDRSUNUKECUOUMCAUAUBUCUPCUDUEUNEUOUFUPBUGUHUI $.

    $( The closure function is a function from subsets of the base to closed
       sets.  (Contributed by Mario Carneiro, 11-Apr-2015.) $)
    clsf $p |- ( J e. Top -> ( cls ` J ) : ~P X --> ( Clsd ` J ) ) $=
      ( vx vy ctop wcel cpw cv wss ccld cfv crab ccl cvv elpwi wa clsval sylan2
      cint fvex syl6eqelr clsfval clscld fmpt2d ) AFGZDEBHZDIZEIZJEAKLZMTZUJANL
      ZOUHUGGUFUHBJZUKOGUHBPUFUMQUKUHULLOEUHABCRUHULUAUBSDEABCUCUIUGGUFUIBJUIUL
      LUJGUIBPUIABCUDSUE $.

    $( The interior of a subset of a topology's underlying set is open.
       (Contributed by NM, 11-Sep-2006.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    ntropn $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) e. J ) $=
      ( ctop wcel wss wa cnt cfv cpw cin cuni ntrval inss1 uniopn mpan2 eqeltrd
      adantr ) BEFZACGZHABIJJBAKZLZMZBABCDNTUDBFZUATUCBGUEBUBOUCBPQSR $.

    $( Express closure in terms of interior.  (Contributed by NM,
       10-Sep-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    clsval2 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) =
                 ( X \ ( ( int ` J ) ` ( X \ S ) ) ) ) $=
      ( vz vx wcel wss wa cfv cdif cv cint wceq cab cvv 3syl elin eqtr4d c0 ccl
      ctop cpw cin cuni cnt ccld crab ciin wrex df-rab cldopn ad2antrl ad2antll
      sscon wb topopn difexg elpwg ad2antrr mpbird sylanbrc cldss eqcomd difeq2
      dfss4 sylib eqeq2d rspcev syl2anc ex simplbi opncld syl2an simprbi adantl
      simpl elpwid difss2d simplr ssconb mpbid eleq1 sseq2 syl5ibrcom rexlimdva
      jca anbi12d impbid abbidv syl5eq inteqd wral ralrimivw adantr clsval ciun
      dfiin2g uniiun difeq2i a1i wne 0elpw iindif2 3eqtr4d difssd ntrval sylan2
      0opn ne0i difeq2d ) BUBGZACHZIZABUAJJZCBCAKZUCZUDZUEZKZCXPBUFJJZKXNAELZHZ
      EBUGJZUHZMZFXRCFLZKZUIZXOXTXNYFYBYHNZFXRUJZEOZMZYIXNYEYLXNYEYBYDGZYCIZEOY
      LYCEYDUKXNYOYKEXNYOYKXNYOYKXNYOIZCYBKZXRGZYBCYQKZNZYKYPYQBGZYQXQGZYRYNUUA
      XNYCYBBCDULUMYPUUBYQXPHZYCUUCXNYNAYBCUOUNXLUUBUUCUPZXMYOXLCBGZYQPGUUDBCDU
      QZCYBBURYQXPPUSQUTVAYQBXQRVBYPYSYBYPYBCHZYSYBNYNUUGXNYCYBBCDVCUMYBCVFVGVD
      YJYTFYQXRYGYQNYHYSYBYGYQCVEVHVIVJVKXNYJYOFXRXNYGXRGZIZYOYJYHYDGZAYHHZIUUI
      UUJUUKXNXLYGBGZUUJUUHXLXMVQUUHUULYGXQGZYGBXQRZVLYGBCDVMVNUUIYGXPHZUUKUUIY
      GXPUUHUUMXNUUHUULUUMUUNVOVPVRZUUIYGCHXMUUOUUKUPUUIYGCAUUPVSXLXMUUHVTYGACW
      AVJWBWGYJYNUUJYCUUKYBYHYDWCYBYHAWDWHWEWFWIWJWKWLXLYIYMNZXMXLUUEYHPGZFXRWM
      UUQUUFUUEUURFXRCYGBURWNFEXRYHPWRQWOSEABCDWPXNXTCFXRYGWQZKZYIXTUUTNXNXSUUS
      CFXRWSWTXAXNTXRGZXRTXBYIUUTNXNTBGZTXQGZUVAXLUVBXMBXIWOUVCXNXPXCXATBXQRVBX
      RTXJFXRCYGXDQSXEXNYAXSCXMXLXPCHYAXSNXMCAXFXPBCDXGXHXKS $.

    $( Interior expressed in terms of closure.  (Contributed by NM,
       1-Oct-2007.) $)
    ntrval2 $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( ( int ` J ) ` S ) = ( X \ ( ( cls ` J ) ` ( X \ S ) ) ) ) $=
      ( ctop wcel wss wa cdif ccl cfv cnt wceq difss clsval2 mpan2 adantr dfss4
      biimpi difeq2d fveq2d adantl eqtrd ntropn eltopss syldan sylib eqtr2d ) B
      EFZACGZHZCCAIZBJKKZICCABLKZKZIZIZUOUKUMUPCUKUMCCULIZUNKZIZUPUIUMUTMZUJUIU
      LCGVACANULBCDOPQUKUSUOCUJUSUOMUIUJURAUNUJURAMACRSUAUBTUCTUKUOCGZUQUOMUIUJ
      UOBFVBABCDUDUOBCDUEUFUOCRUGUH $.

    $( An interior of a complement is the complement of the closure.  This set
       is also known as the exterior of ` A ` .  (Contributed by Jeff Hankins,
       31-Aug-2009.) $)
    ntrdif $p |- ( ( J e. Top /\ A C_ X ) -> ( ( int ` J ) ` ( X \ A ) ) = ( X
    \ ( ( cls ` J ) ` A ) ) ) $=
      ( ctop wcel wss wa cdif cnt cfv ccl wceq difss ntrval2 mpan2 adantr simpr
      dfss4 sylib fveq2d difeq2d eqtrd ) BEFZACGZHZCAIZBJKKZCCUGIZBLKZKZIZCAUJK
      ZIUDUHULMZUEUDUGCGUNCANUGBCDOPQUFUKUMCUFUIAUJUFUEUIAMUDUERACSTUAUBUC $.

    $( A closure of a complement is the complement of the interior.
       (Contributed by Jeff Hankins, 31-Aug-2009.) $)
    clsdif $p |- ( ( J e. Top /\ A C_ X ) -> ( ( cls ` J ) ` ( X \ A ) ) = ( X
    \ ( ( int ` J ) ` A ) ) ) $=
      ( ctop wcel wss wa cdif ccl cfv cnt wceq difss clsval2 mpan2 adantr simpr
      dfss4 sylib fveq2d difeq2d eqtrd ) BEFZACGZHZCAIZBJKKZCCUGIZBLKZKZIZCAUJK
      ZIUDUHULMZUEUDUGCGUNCANUGBCDOPQUFUKUMCUFUIAUJUFUEUIAMUDUERACSTUAUBUC $.

    $( Subset relationship for closure.  (Contributed by NM, 10-Feb-2007.) $)
    clsss $p |- ( ( J e. Top /\ S C_ X /\ T C_ S ) -> ( ( cls ` J ) ` T ) C_
                 ( ( cls ` J ) ` S ) ) $=
      ( vx ctop wcel wss w3a cv ccld cfv crab cint ccl wi sstr2 wceq clsval syl
      adantr ss2rabdv intss 3ad2ant3 impcom 3adant1 syl2anc 3adant3 3sstr4d
      simp1 ) CGHZADIZBAIZJZBFKZIZFCLMZNZOZAUPIZFURNZOZBCPMZMZAVDMZUNULUTVCIZUM
      UNVBUSIVGUNVAUQFURUNVAUQQUPURHBAUPRUBUCVBUSUDUAUEUOULBDIZVEUTSULUMUNUKUMU
      NVHULUNUMVHBADRUFUGFBCDETUHULUMVFVCSUNFACDETUIUJ $.

    $( Subset relationship for interior.  (Contributed by NM, 3-Oct-2007.) $)
    ntrss $p |- ( ( J e. Top /\ S C_ X /\ T C_ S ) -> ( ( int ` J ) ` T ) C_
                 ( ( int ` J ) ` S ) ) $=
      ( ctop wcel wss cnt cfv wa cdif ccl sscon adantl difss jctil wceq ntrval2
      sylan2 clsss 3expb sscond sstr2 impcom adantrr 3sstr4d 3impb ) CFGZADHZBA
      HZBCIJZJZAULJZHUIUJUKKZKZDDBLZCMJZJZLZDDALZURJZLZUMUNUPVBUSDUOUIUQDHZVAUQ
      HZKVBUSHZUOVEVDUKVEUJBADNODBPQUIVDVEVFUQVACDEUAUBTUCUOUIBDHZUMUTRUKUJVGBA
      DUDUEBCDESTUIUJUNVCRUKACDESUFUGUH $.

    $( A subset of a topology's underlying set is included in its closure.
       (Contributed by NM, 22-Feb-2007.) $)
    sscls $p |- ( ( J e. Top /\ S C_ X ) -> S C_ ( ( cls ` J ) ` S ) ) $=
      ( vx ctop wcel wss wa cv ccld cfv crab cint ccl ssintub clsval syl5sseqr
      ) BFGACHIAEJHEBKLZMNAABOLLEASPEABCDQR $.

    $( A subset includes its interior.  (Contributed by NM, 3-Oct-2007.)
       (Revised by Mario Carneiro, 11-Nov-2013.) $)
    ntrss2 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) C_ S ) $=
      ( ctop wcel wss wa cnt cfv cpw cin cuni ntrval inss2 unissi unipw sseqtri
      syl6eqss ) BEFACGHABIJJBAKZLZMZAABCDNUBTMAUATBTOPAQRS $.

    $( An open subset of a set is a subset of the set's interior.  (Contributed
       by Jeff Hankins, 31-Aug-2009.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    ssntr $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( O e. J /\ O C_ S ) ) -> O C_ (
    ( int ` J ) ` S ) ) $=
      ( ctop wcel wss wa cpw cin cuni cnt cfv elin elpwg pm5.32i bitr2i elssuni
      sylbi adantl wceq ntrval adantr sseqtr4d ) BFGADHIZCBGZCAHZIZICBAJZKZLZAB
      MNNZUICULHZUFUICUKGZUNUOUGCUJGZIUICBUJOUGUPUHCABPQRCUKSTUAUFUMULUBUIABDEU
      CUDUE $.

    $( The closure of a subset of a topological space is included in the
       space.  (Contributed by NM, 26-Feb-2007.) $)
    clsss3 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) C_ X ) $=
      ( ctop wcel wss wa ccl cfv ccld clscld cldss syl ) BEFACGHABIJJZBKJFOCGAB
      CDLOBCDMN $.

    $( The interior of a subset of a topological space is included in the
       space.  (Contributed by NM, 1-Oct-2007.) $)
    ntrss3 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( int ` J ) ` S ) C_ X ) $=
      ( ctop wcel wss cnt cfv ntropn eltopss syldan ) BEFACGABHIIZBFMCGABCDJMBC
      DKL $.

    $( A pairwise intersection of interiors is the interior of the
       intersection.  This does not always hold for arbitrary intersections.
       (Contributed by Jeff Hankins, 31-Aug-2009.) $)
    ntrin $p |- ( ( J e. Top /\ A C_ X /\ B C_ X ) -> ( ( int ` J ) ` ( A i^i B
    ) ) = ( ( ( int ` J ) ` A ) i^i ( ( int ` J ) ` B ) ) ) $=
      ( ctop wcel wss cin inss1 ntrss mp3an3 3adant3 inss2 3adant2 ssind ntropn
      cfv ntrss2 syl5ss w3a simp1 ssinss1 3ad2ant2 inopn syl3anc ssntr syl22anc
      cnt eqssd ) CFGZADHZBDHZUAZABIZCUIRZRZAUPRZBUPRZIZUNUQURUSUKULUQURHZUMUKU
      LUOAHVAABJAUOCDEKLMUKUMUQUSHZULUKUMUOBHVBABNBUOCDEKLOPUNUKUODHZUTCGZUTUOH
      UTUQHUKULUMUBZULUKVCUMABDUCUDUNUKURCGZUSCGZVDVEUKULVFUMACDEQMUKUMVGULBCDE
      QOURUSCUEUFUNUTABUNUTURAURUSJUKULURAHUMACDESMTUNUTUSBURUSNUKUMUSBHULBCDES
      OTPUOCUTDEUGUHUJ $.

    $( The complement of a closure is open.  (Contributed by NM,
       11-Sep-2006.) $)
    cmclsopn $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( X \ ( ( cls ` J ) ` S ) ) e. J ) $=
      ( ctop wcel wss wa ccl cfv cdif clsval2 difeq2d wceq difss ntropn eltopss
      cnt mpan2 eqeltrd mpdan dfss4 sylib adantr ) BEFZACGZHZCABIJJZKCCCAKZBRJJ
      ZKZKZBUGUHUKCABCDLMUEULBFUFUEULUJBUEUJCGZULUJNUEUJBFZUMUEUICGUNCAOUIBCDPS
      ZUJBCDQUAUJCUBUCUOTUDT $.

    $( The complement of an interior is closed.  (Contributed by NM,
       1-Oct-2007.) $)
    cmntrcld $p |- ( ( J e. Top /\ S C_ X ) ->
                 ( X \ ( ( int ` J ) ` S ) ) e. ( Clsd ` J ) ) $=
      ( ctop wcel wss wa cnt cfv cdif ccl ccld ntrval2 difeq2d wceq difss mpan2
      clsss3 eqeltrd dfss4 sylib clscld adantr ) BEFZACGZHZCABIJJZKCCCAKZBLJJZK
      ZKZBMJZUGUHUKCABCDNOUEULUMFUFUEULUJUMUEUJCGZULUJPUEUICGZUNCAQZUIBCDSRUJCU
      AUBUEUOUJUMFUPUIBCDUCRTUDT $.

    $( A subset is closed iff it equals its own closure.  (Contributed by NM,
       2-Oct-2006.) $)
    iscld3 $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                 ( ( cls ` J ) ` S ) = S ) ) $=
      ( ctop wcel wss ccld cfv ccl wceq cldcls clscld eleq1 syl5ibcom impbid2
      wa ) BEFACGQZABHIZFZABJIIZAKZABLRUASFUBTABCDMUAASNOP $.

    $( A subset is closed iff it contains its own closure.  (Contributed by NM,
       31-Jan-2008.) $)
    iscld4 $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                 ( ( cls ` J ) ` S ) C_ S ) ) $=
      ( ctop wcel wss wa ccld cfv ccl wceq iscld3 sscls biantrud syl6rbbr bitrd
      eqss ) BEFACGHZABIJFABKJJZALZTAGZABCDMSUBUBATGZHUASUCUBABCDNOTARPQ $.

    $( A subset is open iff it equals its own interior.  (Contributed by NM,
       9-Oct-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    isopn3 $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. J <->
                 ( ( int ` J ) ` S ) = S ) ) $=
      ( ctop wcel wss wa cnt cfv wceq cpw cin ntrval inss2 unissi unipw sseqtri
      cuni a1i id pwidg sylanbrc elssuni syl eqssd sylan9eq ex ntropn syl5ibcom
      elin eleq1 impbid ) BEFACGHZABFZABIJJZAKZUNUOUQUNUOUPBALZMZSZAABCDNUOUTAU
      TAGUOUTURSAUSURBUROPAQRTUOAUSFZAUTGUOUOAURFVAUOUAABUBABURUKUCAUSUDUEUFUGU
      HUNUPBFUQUOABCDUIUPABULUJUM $.

    $( The closure operation is idempotent.  (Contributed by NM,
       2-Oct-2007.) $)
    clsidm $p |- ( ( J e. Top /\ S C_ X ) ->
               ( ( cls ` J ) ` ( ( cls ` J ) ` S ) ) = ( ( cls ` J ) ` S ) ) $=
      ( ctop wcel wss wa ccl cfv ccld wceq clscld wb clsss3 iscld3 syldan mpbid
      ) BEFZACGZHABIJZJZBKJFZUBUAJUBLZABCDMSTUBCGUCUDNABCDOUBBCDPQR $.

    $( The interior operation is idempotent.  (Contributed by NM,
       2-Oct-2007.) $)
    ntridm $p |- ( ( J e. Top /\ S C_ X ) ->
               ( ( int ` J ) ` ( ( int ` J ) ` S ) ) = ( ( int ` J ) ` S ) ) $=
      ( ctop wcel wss wa cnt cfv wceq ntropn wb ntrss3 isopn3 syldan mpbid ) BE
      FZACGZHABIJZJZBFZUATJUAKZABCDLRSUACGUBUCMABCDNUABCDOPQ $.

    $( The closure of a topology's underlying set is entire set.  (Contributed
       by NM, 5-Oct-2007.) $)
    clstop $p |- ( J e. Top -> ( ( cls ` J ) ` X ) = X ) $=
      ( ctop wcel ccld cfv ccl wceq topcld wss wb ssid iscld3 mpan2 mpbid ) ADE
      ZBAFGEZBAHGGBIZABCJQBBKRSLBMBABCNOP $.

    $( The interior of a topology's underlying set is entire set.  (Contributed
       by NM, 12-Sep-2006.) $)
    ntrtop $p |- ( J e. Top -> ( ( int ` J ) ` X ) = X ) $=
      ( ctop wcel cnt cfv wceq topopn wss wb ssid isopn3 mpan2 mpbid ) ADEZBAEZ
      BAFGGBHZABCIPBBJQRKBLBABCMNO $.

    $( A subset with an empty interior cannot cover a whole (nonempty)
       topology.  (Contributed by NM, 12-Sep-2006.) $)
    0ntr $p |- ( ( ( J e. Top /\ X =/= (/) ) /\ ( S C_ X
               /\ ( ( int ` J ) ` S ) = (/) ) ) -> ( X \ S ) =/= (/) ) $=
      ( ctop wcel wss cnt cfv c0 wceq wa wne cdif ssdif0 wi eqss ntrtop syl5bir
      fveq2 sylan9eqr eqeq1d biimpd ex exp3a com34 imp32 necon3d imp an32s ) BE
      FZACGZABHIZIZJKZLZCJMZCANZJMZUKUPLZUQUSUTURJCJURJKCAGZUTCJKZCAOUKULUOVAVB
      PUKULVAUOVBUKULVAUOVBPZULVALACKZUKVCACQUKVDVCUKVDLZUOVBVEUNCJVDUKUNCUMICA
      CUMTBCDRUAUBUCUDSUEUFUGSUHUIUJ $.

    $( If a subset is included in a closed set, so is the subset's closure.
       (Contributed by NM, 22-Feb-2007.) $)
    clsss2 $p |- ( ( C e. ( Clsd ` J ) /\ S C_ C ) ->
                 ( ( cls ` J ) ` S ) C_ C ) $=
      ( ccld cfv wcel wss ccl ctop cldrcl adantr cldss simpr clsss syl3anc wceq
      wa cldcls sseqtrd ) ACFGHZBAIZSZBCJGZGZAUEGZAUDCKHZADIZUCUFUGIUBUHUCACLMU
      BUIUCACDENMUBUCOABCDEPQUBUGARUCACTMUA $.

    $( Membership in a closure.  Theorem 6.5(a) of [Munkres] p. 95.
       (Contributed by NM, 22-Feb-2007.) $)
    elcls $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) -> ( P e. ( ( cls ` J ) ` S
                ) <-> A. x e. J ( P e. x -> ( x i^i S ) =/= (/) ) ) ) $=
      ( wcel wss cfv cin c0 wne wi wn wa cdif 3adant3 adantr wceq reldisj eldif
      ctop w3a ccl wral wrex cmclsopn biimpri 3ad2antl3 simpr sscls ssind dfin4
      cv syl6sseq wb adantl mpbird incom eqeq1i bitri sylibr eleq2 ineq1 neeq1d
      notbid anbi12d rspcev syl12anc con2bii ccld opncld adantlr biimpa adantll
      nne df-ne clsss2 syl2anc sseld eldifn con2d sylan2br exp31 com34 rexlimdv
      syl6 imp4a imp 3adantl3 impbida rexanali syl6bb con4bid ) DUBGZCEHZBEGZUC
      ZBCDUDIIZGZBAUNZGZXACJZKLZMADUEZWRWTNZXBXDNZOZADUFZXENWRXFXIWRXFOEWSPZDGZ
      BXJGZXJCJZKLZNZXIWRXKXFWOWPXKWQCDEFUGQRWQWOXFXLWPXLWQXFOBEWSUAUHUIWRXOXFW
      OWPXOWQWOWPOZCXJJZKSZXOXPXRCEXJPZHZXPCEWSJXSXPCEWSWOWPUJCDEFUKULEWSUMUOWP
      XRXTUPWOCXJETUQURXOXMKSXRXMKVPXMXQKXJCUSUTVAVBQRXHXLXOOAXJDXAXJSZXBXLXGXO
      XAXJBVCYAXDXNYAXCXMKXAXJCVDVEVFVGVHVIWOWPXIXFWQXPXIXFXPXHXFADXPXADGZXBXGX
      FXPYBXGXBXFXPYBXGXBXFMZXGXPYBOZCXAJZKSZYCYFXCKSZXGYEXCKCXAUSUTXDYGXCKVQVJ
      VAYDYFOZWTXBYHWTBEXAPZGXBNYHWSYIBYHYIDVKIGZCYIHZWSYIHYDYJYFWOYBYJWPXADEFV
      LVMRXPYFYKYBWPYFYKWOWPYFYKCXAETVNVOVMYICDEFVRVSVTBEXAWAWGWBWCWDWEWHWFWIWJ
      WKXBXDADWLWMWN $.

    $( Membership in a closure.  (Contributed by NM, 5-Mar-2007.) $)
    elcls2 $p |- ( ( J e. Top /\ S C_ X ) -> ( P e. ( ( cls ` J ) ` S
         ) <-> ( P e. X /\ A. x e. J ( P e. x -> ( x i^i S ) =/= (/) ) ) ) ) $=
      ( ctop wcel wss wa ccl cfv cv cin c0 wne wi wral wb clsss3 pm4.71rd elcls
      ssel syl 3expa pm5.32da bitrd ) DGHZCEIZJZBCDKLLZHZBEHZULJZUMBAMZHUOCNOPQ
      ADRZJUJUKEIZULUNSCDEFTUQULUMUKEBUCUAUDUJUMULUPUHUIUMULUPSABCDEFUBUEUFUG
      $.

    $( Any open set containing a point that belongs to the closure of a subset
       intersects the subset.  One direction of Theorem 6.5(a) of [Munkres]
       p. 95.  (Contributed by NM, 26-Feb-2007.) $)
    clsndisj $p |- ( ( ( J e. Top /\ S C_ X /\ P e. ( ( cls ` J ) ` S ) ) /\
               ( U e. J /\ P e. U ) ) -> ( U i^i S ) =/= (/) ) $=
      ( vx ctop wcel wss ccl cfv w3a cv cin c0 wne wi wral wa simp1 simp2 sseld
      clsss3 3impia simp3 elcls biimpa syl31anc wceq eleq2 ineq1 neeq1d imbi12d
      rspccv imp32 sylan ) DHIZBEJZABDKLLZIZMZAGNZIZVCBOZPQZRZGDSZCDIZACIZTCBOZ
      PQZVBURUSAEIZVAVHURUSVAUAURUSVAUBURUSVAVMURUSTUTEABDEFUDUCUEURUSVAUFURUSV
      MMVAVHGABDEFUGUHUIVHVIVJVLVGVJVLRGCDVCCUJZVDVJVFVLVCCAUKVNVEVKPVCCBULUMUN
      UOUPUQ $.

    $( A subset whose closure has an empty interior also has an empty
       interior.  (Contributed by NM, 4-Oct-2007.) $)
    ntrcls0 $p |- ( ( J e. Top /\ S C_ X /\ ( ( int ` J ) `
                ( ( cls ` J ) ` S ) ) = (/) ) -> ( ( int ` J ) ` S ) = (/) ) $=
      ( ctop wcel wss ccl cfv cnt c0 wceq wa simpl clsss3 sscls syl3anc 3adant3
      w3a ntrss wb sseq2 3ad2ant3 mpbid ss0 syl ) BEFZACGZABHIIZBJIZIZKLZSZAUJI
      ZKGZUNKLUMUNUKGZUOUGUHUPULUGUHMUGUICGAUIGUPUGUHNABCDOABCDPUIABCDTQRULUGUP
      UOUAUHUKKUNUBUCUDUNUEUF $.

    $( Two ways to say that a subset has an empty interior.  (Contributed by
       NM, 3-Oct-2007.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    ntreq0 $p |- ( ( J e. Top /\ S C_ X ) -> ( ( ( int ` J ) ` S ) = (/) <->
               A. x e. J ( x C_ S -> x = (/) ) ) ) $=
      ( vy wcel wss wa cfv c0 wceq cv wi wral wex wrex wn neq0 con1bii ctop cnt
      cpw cuni ntrval eqeq1d ancom elin anbi1i anass 3bitri exbii eluni 3bitr4i
      cin df-rex rexcom4 19.42v rexbii 3bitr2i notbii ralinexa vex elpw imbi12i
      bitr3i ralbii syl6bb ) CUAGBDHIZBCUBJJZKLCBUCZUOZUDZKLZAMZBHZVOKLZNZACOZV
      IVJVMKBCDEUEUFVNVOVKGZFMZVOGZFPZIZACQZRZVTWCRZNZACOVSVNWAVMGZFPZRWFVNWJFV
      MSTWJWEWJVTWBIZACQZFPWKFPZACQWEWIWLFWBVOVLGZIZAPVOCGZWKIZAPWIWLWOWQAWOWNW
      BIWPVTIZWBIWQWBWNUGWNWRWBVOCVKUHUIWPVTWBUJUKULAWAVLUMWKACUPUNULWKAFCUQWMW
      DACVTWBFURUSUTVAVFVTWCACVBWHVRACVTVPWGVQVOBAVCVDVQWCFVOSTVEVGUTVH $.

    $( The closed sets of a topology comprise a Moore system on the points of
       the topology.  (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    cldmre $p |- ( J e. Top -> ( Clsd ` J ) e. ( Moore ` X ) ) $=
      ( vx ctop wcel ccld cfv cpw wss cldss2 a1i topcld cv c0 wne intcld ancoms
      cint 3adant1 ismred ) AEFZAGHZBDUCBIJUBABCKLABCMDNZUCJZUDOPZUDSUCFZUBUFUE
      UGUDAQRTUA $.
  $}

  ${
    $d J a b c $.  $d F a b c $.
    mrccls.f $e |- F = ( mrCls ` ( Clsd ` J ) ) $.
    $( Moore closure generalizes closure in a topology.  (Contributed by Stefan
       O'Rear, 31-Jan-2015.) $)
    mrccls $p |- ( J e. Top -> ( cls ` J ) = F ) $=
      ( va ctop wcel ccl cfv cuni cpw wss ccld crab cint cmpt eqid clsfval cmre
      vb cv wceq cldmre mrcfval syl eqtr4d ) BEFZBGHDBIZJDTSTKSBLHZMNOZADSBUGUG
      PZQUFUHUGRHFAUIUABUGUJUBDUHAUGSCUCUDUE $.
  $}

  $( The closure of the empty set.  (Contributed by NM, 2-Oct-2007.) $)
  cls0 $p |- ( J e. Top -> ( ( cls ` J ) ` (/) ) = (/) ) $=
    ( ctop wcel c0 ccld cfv ccl wceq 0cld cuni wss 0ss eqid iscld3 mpan2 mpbid
    wb ) ABCZDAEFCZDAGFFDHZAIRDAJZKSTQUALDAUAUAMNOP $.

  $( The interior of the empty set.  (Contributed by NM, 2-Oct-2007.) $)
  ntr0 $p |- ( J e. Top -> ( ( int ` J ) ` (/) ) = (/) ) $=
    ( ctop wcel c0 cnt cfv wceq 0opn cuni wss wb 0ss eqid isopn3 mpan2 mpbid )
    ABCZDACZDAEFFDGZAHQDAIZJRSKTLDATTMNOP $.

  $( An open subset equals its own interior.  (Contributed by Mario Carneiro,
     30-Dec-2016.) $)
  isopn3i $p |- ( ( J e. Top /\ S e. J ) -> ( ( int ` J ) ` S ) = S ) $=
    ( ctop wcel wa cnt cfv wceq simpr cuni wss elssuni eqid isopn3 sylan2 mpbid
    wb ) BCDZABDZESABFGGAHZRSISRABJZKSTQABLABUAUAMNOP $.

  ${
    $d x y z B $.  $d y J $.  $d x y z P $.  $d y ph $.  $d x y z S $.
    elcls3.1 $e |- ( ph -> J = ( topGen ` B ) ) $.
    elcls3.2 $e |- ( ph -> X = U. J ) $.
    elcls3.3 $e |- ( ph -> B e. TopBases ) $.
    elcls3.4 $e |- ( ph -> S C_ X ) $.
    elcls3.5 $e |- ( ph -> P e. X ) $.
    $( Membership in a closure in terms of the members of a basis.  Theorem
       6.5(b) of [Munkres] p. 95.  (Contributed by NM, 26-Feb-2007.)  (Revised
       by Mario Carneiro, 3-Sep-2015.) $)
    elcls3 $p |- ( ph -> ( P e. ( ( cls ` J ) ` S ) <->
      A. x e. B ( P e. x -> ( x i^i S ) =/= (/) ) ) ) $=
      ( vy vz cfv wcel c0 wi wceq wa ccl cv cin wne wral ctop cuni wss ctg tgcl
      wb ctb syl eqeltrd sseqtrd eleqtrd eqid elcls bastg sseqtr4d sseld imim1d
      syl3anc ralimdv2 eleq2 neeq1d imbi12d cbvralv syl6ib wrex simprl ad2antrr
      ineq1 simprr tg2 syl2anc rspccva ssdisj ex necon3d syl5com exp31 rexlimdv
      imp imp4a ad2antlr mpd exp43 ralrimdv impbid bitrd ) ADEFUAOOPZDMUBZPZWME
      UCZQUDZRZMFUEZDBUBZPZWSEUCZQUDZRZBCUEZAFUFPEFUGZUHDXEPWLWRUKAFCUIOZUFHACU
      LPZXFUFPJCUJUMUNAEGXEKIUOADGXELIUPMDEFXEXEUQURVCAWRXDAWRWQMCUEXDAWQWQMFCA
      WMCPWMFPZWQACFWMACXFFAXGCXFUHJCULUSUMHUTVAVBVDWQXCMBCWMWSSZWNWTWPXBWMWSDV
      EXIWOXAQWMWSEVMVFVGVHVIAXDWQMFAXDXHWNWPAXDTZXHWNTZTZDNUBZPZXMWMUHZTZNCVJZ
      WPXLWMXFPWNXQXLWMFXFXJXHWNVKAFXFSXDXKHVLUPXJXHWNVNNWMCDVOVPXDXQWPRAXKXDXP
      WPNCXDXMCPZXNXOWPXDXRXNXOWPRXDXRTZXNTXMEUCZQUDZXOWPXSXNYAXCXNYARBXMCWSXMS
      ZWTXNXBYAWSXMDVEYBXAXTQWSXMEVMVFVGVQWDXOWOQXTQXOWOQSXTQSXMWMEVRVSVTWAWBWE
      WCWFWGWHWIWJWK $.
  $}

  ${
    $d u A $.  $d x B $.  $d x F $.  $d u x J $.  $d u x X $.
    opncldf.1 $e |- X = U. J $.
    opncldf.2 $e |- F = ( u e. J |-> ( X \ u ) ) $.
    $( A bijection useful for converting statements about open sets to
       statements about closed sets and vice versa.  (Contributed by Jeff
       Hankins, 27-Aug-2009.)  (Proof shortened by Mario Carneiro,
       1-Sep-2015.) $)
    opncldf1 $p |- ( J e. Top -> ( F : J -1-1-onto-> ( Clsd ` J ) /\
        `' F = ( x e. ( Clsd ` J ) |-> ( X \ x ) ) ) ) $=
      ( ctop wcel cv cdif wceq wss dfss4 sylib eqcomd difeq2 eqeq2d syl5ibrcom
      wa ccld cfv opncld cldopn adantl ad2antll eltopss adantrr impbid f1ocnv2d
      cldss ) DHIZBADDUAUBZEBJZKZEAJZKZCGUNDEFUCUPUMIZUQDIULUPDEFUDUEULUNDIZURT
      TZUNUQLZUPUOLZUTVBVAUPEUQKZLUTVCUPUTUPEMZVCUPLURVDULUSUPDEFUKUFUPENOPVAUO
      VCUPUNUQEQRSUTVAVBUNEUOKZLUTVEUNUTUNEMZVEUNLULUSVFURUNDEFUGUHUNENOPVBUQVE
      UNUPUOEQRSUIUJ $.

    $( The values of the open-closed bijection.  (Contributed by Jeff Hankins,
       27-Aug-2009.)  (Proof shortened by Mario Carneiro, 1-Sep-2015.) $)
    opncldf2 $p |- ( ( J e. Top /\ A e. J ) -> ( F ` A ) = ( X \ A ) ) $=
      ( ctop wcel wa cdif ccld cfv wceq simpr opncld cv difeq2 fvmptg syl2anc )
      DHIZBDIZJUBEBKZDLMZIBCMUCNUAUBOBDEFPABEAQZKUCDUDCUEBERGST $.

    $( The values of the converse/inverse of the open-closed bijection.
       (Contributed by Jeff Hankins, 27-Aug-2009.)  (Proof shortened by Mario
       Carneiro, 1-Sep-2015.) $)
    opncldf3 $p |- ( B e. ( Clsd ` J ) -> ( `' F ` B ) = ( X \ B ) ) $=
      ( vx ccld cfv wcel ccnv cv cdif cmpt ctop wceq cldrcl wf1o opncldf1 mpdan
      simprd syl fveq1d cldopn difeq2 eqid fvmptg eqtrd ) BDIJZKZBCLZJBHUJEHMZN
      ZOZJZEBNZUKBULUOUKDPKZULUOQZBDRURDUJCSUSHACDEFGTUBUCUDUKUQDKUPUQQBDEFUEHB
      UNUQUJDUOUMBEUFUOUGUHUAUI $.
  $}

  ${
    $d w x y z A $.  $d x y z J $.  $d x y z X $.
    isclo.1 $e |- X = U. J $.
    $( A set ` A ` is clopen iff for every point ` x ` in the space there is a
       neighborhood ` y ` such that all the points in ` y ` are in ` A ` iff
       ` x ` is.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
    isclo $p |- ( ( J e. Top /\ A C_ X ) -> ( A e. ( J i^i ( Clsd ` J ) ) <->
      A. x e. X E. y e. J ( x e. y /\ A. z e. y ( x e. A <-> z e. A ) ) ) ) $=
      ( wcel wa wss cv wb wral wrex anbi2d eltop2 dfss3 syl5bb ralbiia syl6bb
      ccld cfv cin ctop elin cdif iscld2 pm5.501 ralbidv rexbidv wn cuni elunii
      id simpr syl2anr syl6eleqr eldif baib eldifn nbn2 ad2antrr bitrd ralbidva
      syl rexbidva anbi12d adantr cun ralunb undif sylib raleqdv syl5bbr 3bitrd
      wceq ) DEEUAUBZUCHDEHZDVQHZIZEUDHZDFJZIZAKZBKZHZWDDHZCKZDHZLZCWEMZIZBENZA
      FMZDEVQUEWCVTVRFDUFZEHZIZWMADMZWMAWOMZIZWNWCVSWPVRDEFGUGOWAWQWTLWBWAVRWRW
      PWSWAVRWFWEDJZIZBENZADMWRABDEPXCWMADWGXBWLBEWGXAWKWFXAWICWEMWGWKCWEDQWGWI
      WJCWEWGWIUHUIROUJSTWAWPWFWEWOJZIZBENZAWOMWSABWOEPXFWMAWOWDWOHZXEWLBEXGWEE
      HZIZXDWKWFXDWHWOHZCWEMXIWKCWEWOQXIXJWJCWEXIWHWEHZIZXJWIUKZWJXLWHFHZXJXMLX
      LWHEULZFXKXKXHWHXOHXIXKUNXGXHUOWHWEEUMUPGUQXJXNXMWHFDURUSVEXGXMWJLZXHXKXG
      WGUKXPWDFDUTWGWIVAVEVBVCVDROVFSTVGVHWTWMADWOVIZMWCWNWMADWOVJWCWMAXQFWCWBX
      QFVPWAWBUODFVKVLVMVNVOR $.

    $( A set ` A ` is clopen iff for every point ` x ` in the space there is a
       neighborhood ` y ` of ` x ` which is either disjoint from ` A ` or
       contained in ` A ` .  (Contributed by Mario Carneiro, 7-Jul-2015.) $)
    isclo2 $p |- ( ( J e. Top /\ A C_ X ) -> ( A e. ( J i^i ( Clsd ` J ) ) <->
      A. x e. X E. y e. J ( x e. y /\ A. z e. y ( z e. A -> y C_ A ) ) ) ) $=
      ( vw wcel wss wa cv wb wral wrex wi weq eleq1 ralimdv com12 ctop ccld cfv
      cin isclo bibi2d cbvralv anbi2i pm4.24 raaanv 3bitr4i bibi1 biimpcd dfss3
      biimpa syl6ibr ralimi sylbi imbi1d rspcv imbi2i bitr4i syl6ib ssel imim2d
      r19.21v jcad ralbiim impbid2 pm5.32i rexbii ralbii syl6bb ) EUAIDFJKDEEUB
      UCUDIALZBLZIZVNDIZCLZDIZMZCVONZKZBEOZAFNVPVSVODJZPZCVONZKZBEOZAFNABCDEFGU
      EWCWHAFWBWGBEVPWAWFVPWAWFWAVTVQHLZDIZMZKZHVONZCVONZWFWAWAKWAWKHVONZKWAWNW
      AWOWAVTWKCHVOCHQVSWJVQVRWIDRUFUGUHWAUIVTWKCHVOUJUKWMWECVOWMVSWJHVONZWDVSW
      MWPVSWLWJHVOWLVSWJVTWKVSWJMVQVSWJULUOUMSTHVODUNUPUQURVPWFVQVSPCVONZVSVQPZ
      CVONZKWAVPWFWQWSVPWFVQWDPZWQWEWTCVNVOCAQVSVQWDVRVNDRUSUTWTVQVSCVONZPWQWDX
      AVQCVODUNVAVQVSCVOVFVBVCVPWEWRCVOVPWDVQVSWDVPVQVODVNVDTVESVGVQVSCVOVHUPVI
      VJVKVLVM $.
  $}

  ${
    $d x A $.  $d x V $.
    $( The open sets of a discrete topology are closed and its closed sets are
       open.  (Contributed by FL, 7-Jun-2007.)  (Revised by Mario Carneiro,
       7-Apr-2015.) $)
    discld $p |- ( A e. V -> ( Clsd ` ~P A ) = ~P A ) $=
      ( vx wcel cpw ccld cfv cv wss cdif wa ctop distop cuni unipw eqcomi iscld
      wb syl difss elpw2g mpbiri biantrud bitr4d vex elpw syl6bbr eqrdv ) ABDZC
      AEZFGZUJUICHZUKDZULAIZULUJDUIUMUNAULJZUJDZKZUNUIUJLDUMUQRABMULUJAUJNAAOPQ
      SUIUPUNUIUPUOAIAULTUOABUAUBUCUDULACUEUFUGUH $.

    $( The closed sets of the topology ` { (/) } ` .  (Contributed by FL,
       5-Jan-2009.) $)
    sn0cld $p |- ( Clsd ` { (/) } ) = { (/) } $=
      ( c0 cpw ccld cfv csn cvv wcel wceq 0ex discld ax-mp pw0 fveq2i 3eqtr3i )
      ABZCDZOAEZCDQAFGPOHIAFJKOQCLMLN $.

    $( The closed sets of an indiscrete topology.  (Contributed by FL,
       5-Jan-2009.)  (Revised by Mario Carneiro, 14-Aug-2015.) $)
    indiscld $p |- ( Clsd ` { (/) , A } ) = { (/) , A } $=
      ( vx c0 cpr ccld cfv cv wcel cid wss cdif wa ctop wb indistop wceq difeq2
      ax-mp syl6eq syl6eqel indisuni iscld simpl dfss4 sylib wo simpr syl6eleqr
      indislem elpri dif0 fvex prid2 eleqtri difid 0ex prid1 jaoi 3syl eqeltrrd
      sylbi ssriv 0cld topcld prssi mp2an eqsstr3i eqssi ) CADZEFZVIBVJVIBGZVJH
      ZVKAIFZJZVMVKKZVIHZLZVKVIHVIMHZVLVQNAOZVKVIVMAUAZUBRVQVMVOKZVKVIVQVNWAVKP
      VNVPUCVKVMUDUEVQVOCVMDZHVOCPZVOVMPZUFWAVIHZVQVOVIWBVNVPUGAUIZUHVOCVMUJWCW
      EWDWCWAVMVIWCWAVMCKVMVOCVMQVMUKSVMWBVICVMAIULUMWFUNTWDWACVIWDWAVMVMKCVOVM
      VMQVMUOSCAUPUQTURUSUTVAVBVIWBVJWFCVJHZVMVJHZWBVJJVRWGVSVIVCRVRWHVSVIVMVTV
      DRCVMVJVEVFVGVH $.
  $}

  ${
    $d ph a b c x y z $.  $d M a b c x y z $.  $d J a b c x y $.
    $d B a b c x y z $.
    mretopd.m $e |- ( ph -> M e. ( Moore ` B ) ) $.
    mretopd.z $e |- ( ph -> (/) e. M ) $.
    mretopd.u $e |- ( ( ph /\ x e. M /\ y e. M ) -> ( x u. y ) e. M ) $.
    mretopd.j $e |- J = { z e. ~P B | ( B \ z ) e. M } $.
    $( A Moore collection which is closed under finite unions called
       _topological_; such a collection is the closed sets of a canonically
       associated topology.  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    mretopd $p |- ( ph -> ( J e. ( TopOn ` B ) /\ M = ( Clsd ` J ) ) ) $=
      ( va vb wcel wceq wss c0 eleq1d cdif syl ctopon cfv ccld ctop cuni cv wal
      wi cin wral wa unieq uni0 syl6eq wne cpw crab ssrab2 eqsstri mpan2 adantl
      sstr sspwuni sylib vex uniex elpw sylibr adantr ciun difeq2i ciin iindif2
      uniiun cmre ad2antrr simpr weq difeq2 elrab2 simprbi rgen ssralv mreiincl
      mpi syl3anc eqeltrrd syl5eqel sylanbrc 0elpw mre1cl dif0 pm2.61ne alrimiv
      a1i inss1 simplbi elpwid ad2antrl syl5ss inex1 cun difindi ad2antll simpl
      ex uneq1 imbi2d uneq2 3expb expcom vtocl2ga imp syl21anc ralrimivva pwexg
      cvv wb rabexg istopg mpbir2and unissi unipw sseqtri pwidg unissel sylancr
      difid eqcomd istopon eqid cldval pweqd difeq1d eleq2i difss elpw2g mpbiri
      rabeqbidv elrab3 syl5bb elpwi dfss4 bitrd incom dfin5 eqtri mresspw df-ss
      rabbidva syl5eqr eqtrd 3eqtrrd jca ) AFEUAUBNZGFUCUBZOAFUDNZEFUEZOUUOAUUQ
      LUFZFPZUUSUEZFNZUHZLUGZUUSMUFZUIZFNZMFUJLFUJZAUVCLAUUTUVBAUUTUKZUVBQFNZUU
      SQUUSQOZUVAQFUVKUVAQUEQUUSQULUMUNRUVIUUSQUOZUKZUVAEUPZNZEUVASZGNZUVBUVIUV
      OUVLUVIUVAEPZUVOUVIUUSUVNPZUVRUUTUVSAUUTFUVNPUVSFEDUFZSZGNZDUVNUQZUVNKUWB
      DUVNURUSZUUSFUVNVBUTVAUUSEVCVDUVAEUUSLVEZVFVGVHVIUVMUVPEMUUSUVEVJZSZGUVAU
      WFEMUUSVNVKUVMMUUSEUVESZVLZUWGGUVLUWIUWGOUVIMUUSEUVEVMVAUVMGEVOUBNZUVLUWH
      GNZMUUSUJZUWIGNAUWJUUTUVLHVPUVIUVLVQUVIUWLUVLUVIUWKMFUJZUWLUWKMFUVEFNZUVE
      UVNNUWKUWBUWKDUVEUVNFDMVRUWAUWHGUVTUVEEVSRKVTWAZWBUUTUWMUWLUHAUWKMUUSFWCV
      AWEVIMGUWHUUSEWDWFWGWHUWBUVQDUVAUVNFUVTUVAOUWAUVPGUVTUVAEVSRKVTWIAUVJUUTA
      QUVNNZEGNZUVJUWPAEWJWOAUWJUWQHGEWKTZUWBUWQDQUVNFUVTQOZUWAEGUWSUWAEQSEUVTQ
      EVSEWLUNRKVTWIVIWMXFWNAUVGLMFFAUUSFNZUWNUKZUKZUVFUVNNZEUVFSZGNZUVGUXBUVFE
      PUXCUXBUVFUUSEUUSUVEWPUWTUUSEPAUWNUWTUUSEUWTUUSUVNNZEUUSSZGNZUWBUXHDUUSUV
      NFDLVRUWAUXGGUVTUUSEVSRKVTZWQWRWSWTUVFEUUSUVEUWEXAVGVHUXBUXDUXGUWHXBZGEUU
      SUVEXCUXBUXHUWKAUXJGNZUWTUXHAUWNUWTUXFUXHUXIWAWSUWNUWKAUWTUWOXDAUXAXEUXHU
      WKUKAUXKABUFZCUFZXBZGNZUHAUXGUXMXBZGNZUHAUXKUHBCUXGUWHGGUXLUXGOZUXOUXQAUX
      RUXNUXPGUXLUXGUXMXGRXHUXMUWHOZUXQUXKAUXSUXPUXJGUXMUWHUXGXIRXHAUXLGNZUXMGN
      ZUKUXOAUXTUYAUXOJXJXKXLXMXNWHUWBUXEDUVFUVNFUVTUVFOUWAUXDGUVTUVFEVSRKVTWIX
      OAFXQNUUQUVDUVHUKXRAFUWCXQKAUVNXQNZUWCXQNAUWQUYBUWREGXPTUWBDUVNXQXSTWHLMX
      QFXTTYAZAUUREAUUREPEFNZUUREOUURUVNUEEFUVNUWDYBEYCYDAEUVNNZEESZGNZUYDAUWQU
      YEUWREGYETAUYFQGEYHIWHUWBUYGDEUVNFUVTEOUWAUYFGUVTEEVSRKVTWIFEYFYGZYIEFYJW
      IAUUPUURUXLSZFNZBUURUPZUQZEUXLSZFNZBUVNUQZGAUUQUUPUYLOUYCBFUURUURYKYLTAUY
      JUYNBUYKUVNAUUREUYHYMAUYIUYMFAUUREUXLUYHYNRYSAUYOUXTBUVNUQZGAUYNUXTBUVNAU
      XLUVNNZUKZUYNEUYMSZGNZUXTUYNUYMUWCNZUYRUYTFUWCUYMKYOAVUAUYTXRZUYQAUYMUVNN
      ZVUBAVUCUYMEPZEUXLYPAUWQVUCVUDXRUWRUYMEGYQTYRUWBUYTDUYMUVNUVTUYMOUWAUYSGU
      VTUYMEVSRYTTVIUUAUYRUYSUXLGUYQUYSUXLOZAUYQUXLEPVUEUXLEUUBUXLEUUCVDVARUUDU
      UJAUYPGUVNUIZGVUFUVNGUIUYPGUVNUUEBUVNGUUFUUGAGUVNPZVUFGOAUWJVUGHGEUUHTGUV
      NUUIVDUUKUULUUMUUN $.
  $}

  ${
    $d B a b c x y $.  $d V a b c x y $.  $d K x y $.
    $( The topologies over a given base set form a Moore collection: the
       intersection of any family of them is a topology, including the empty
       (relative) intersection which gives the discrete topology ~ distop .
       (Contributed by Stefan O'Rear, 31-Jan-2015.)  (Revised by Mario
       Carneiro, 5-May-2015.) $)
    toponmre $p |- ( B e. V -> ( TopOn ` B ) e. ( Moore ` ~P B ) ) $=
      ( vb vc vx vy wcel wss cuni wceq toponuni sylibr syl ctop wral wel sselda
      cv wa adantl ctopon cfv cpw eqimss2 sspwuni vex ssriv a1i distopon c0 wne
      elpw w3a cint wi wal cin simpl adantrl topontop intss1 sstrd syl2anc expr
      uniopn ralrimiv uniex elint2 alrimiv simpll simplrl simplrr inopn syl3anc
      ex sseldd ralrimiva inex1 ralrimivva cvv wb intex biimpi istopg mpbir2and
      3adant1 wex n0 ad2antlr ancoms elssuni sseqtr4d exlimdv mpd unissb topopn
      eqid 3syl eqeltrd elintg 3ad2ant1 mpbird unissel eqcomd istopon sylanbrc
      ismred ) ABGZAUAUBZAUCZCXIXJUCZHXHCXIXKCRZXIGZXLXJHZXLXKGXMAXLIZJZXNAXLKX
      PXOAHXNXOAUDXLAUELMXLXJCUFULLUGUHABUIXHXLXIHZXLUJUKZUMZXLUNZNGZAXTIZJXTXI
      GXQXRYAXHXQXRSZYADRZXTHZYDIZXTGZUOZDUPZYDERZUQZXTGZEXTODXTOZYCYHDYCYEYGYC
      YESZYFYJGZEXLOYGYNYOEXLYCYEECPZYOYCYEYPSZSZYJNGZYDYJHZYOYRYJXIGZYSYCYPUUA
      YEYCXLXIYJXQXRURZQZUSAYJUTMYQYTYCYQYDXTYJYEYPURYPXTYJHYEYJXLVAZTVBTYDYJVE
      VCVDVFEYFXLYDDUFZVGVHLVOVIYCYLDEXTXTYCYDXTGZYJXTGZSZSZYKFRZGZFXLOYLUUIUUK
      FXLUUIFCPZSZUUJNGZDFPEFPUUKUUMUUJXIGUUNUUIXLXIUUJXQXRUUHVJQAUUJUTMUUMXTUU
      JYDUULXTUUJHUUIUUJXLVATZYCUUFUUGUULVKVPUUMXTUUJYJUUOYCUUFUUGUULVLVPYDYJUU
      JVMVNVQFYKXLYDYJUUEVRVHLVSYCXTVTGZYAYIYMSWAXRUUPXQXRUUPXLWBWCTDEVTXTWDMWE
      WFXSYBAXSYBAHZAXTGZYBAJXQXRUUQXHYCYDAHZDXTOUUQYCUUSDXTYCUUFSZYPEWGZUUSXRU
      VAXQUUFXRUVAEXLWHWCWIUUTYPUUSEYCUUFYPUUSYCUUFYPSZSZYDYJIZAUVBYDUVDHZYCUVB
      DEPZUVEYPUUFUVFYPXTYJYDUUDQWJYDYJWKMTUVCUUAAUVDJYCYPUUAUUFUUCUSAYJKMWLVDW
      MWNVQDXTAWOLWFXSUURAYDGZDXLOZXQXRUVHXHYCUVGDXLYCDCPSZAYFYDUVIYDXIGZAYFJYC
      XLXIYDUUBQZAYDKMUVIUVJYDNGYFYDGUVKAYDUTYDYFYFWQWPWRWSVQWFXHXQUURUVHWAXRDA
      XLBWTXAXBXTAXCVCXDAXTXEXFXG $.

    $( The closed sets of a topology over a set are a Moore collection over the
       same set.  (Contributed by Stefan O'Rear, 31-Jan-2015.) $)
    cldmreon $p |- ( J e. ( TopOn ` B ) -> ( Clsd ` J ) e. ( Moore ` B ) ) $=
      ( ctopon cfv wcel ccld cuni cmre ctop topontop cldmre syl toponuni fveq2d
      eqid eleqtrrd ) BACDEZBFDZBGZHDZAHDQBIERTEABJBSSOKLQASHABMNP $.

    $d K a b c d $.
    $( A family is the closed sets of a topology iff it is a Moore collection
       and closed under finite union.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    iscldtop $p |- ( K e. ( Clsd " ( TopOn ` B ) ) <-> ( K e. ( Moore ` B ) /\
          (/) e. K /\ A. x e. K A. y e. K ( x u. y ) e. K ) ) $=
      ( va vb vc ccld cfv wcel c0 cv cun wral w3a wceq ctop fncld ax-mp syl wfn
      ctopon cima cmre wrex wfun fnfun fvelima mpan cldmreon topontop wa adantl
      0cld uncld ralrimivva eleq1 eleq2 raleqbi1dv 3anbi123d syl5ibcom rexlimiv
      3jca cdif cpw simp1 simp2 uneq1 eleq1d uneq2 rspc2v com12 3ad2ant3 3impib
      crab wi eqid mretopd simprd simpld cdm wss ssriv sseqtr4i funfvima2 mp2an
      fndm eqeltrd impbii ) DHCUBIZUCZJZDCUDIZJZKDJZALZBLZMZDJZBDNZADNZOZWLELZH
      IZDPZEWJUEZXBHUFZWLXFHQUAZXGRQHUGSZEDWJHUHUIXEXBEWJXCWJJZXDWMJZKXDJZWRXDJ
      ZBXDNZAXDNZOXEXBXJXKXLXOCXCUJXJXCQJXLCXCUKZXCUNTXJXMABXDXDWPXDJWQXDJULXMX
      JWPWQXCUOUMUPVCXEXKWNXLWOXOXAXDDWMUQXDDKURXNWTAXDDXMWSBXDDXDDWRURUSUSUTVA
      VBTXBDCXCVDDJECVEVOZHIZWKXBXQWJJZDXRPZXBFGECXQDWNWOXAVFWNWOXAVGXBFLZDJZGL
      ZDJZYAYCMZDJZXAWNYBYDULZYFVPWOYGXAYFWSYFYAWQMZDJABYAYCDDWPYAPWRYHDWPYAWQV
      HVIWQYCPYHYEDWQYCYAVJVIVKVLVMVNXQVQVRZVSXBXSXRWKJZXBXSXTYIVTXGWJHWAZWBXSY
      JVPXIWJQYKEWJQXPWCXHYKQPRQHWGSWDWJXQHWEWFTWHWI $.
  $}

  $( The closed subspaces of a topology-bearing module form a complete
     lattice.  Demonstration for ~ mreclat .  (Contributed by Stefan O'Rear,
     31-Jan-2015.) $)
  mreclatdemo $p |- ( W e. ( TopSp i^i LMod ) -> ( toInc `
        ( ( LSubSp ` W ) i^i ( Clsd ` ( TopOpen ` W ) ) ) ) e. CLat ) $=
    ( ctps clmod cin wcel clss cfv ctopn ccld cuni cmre cipo ccla cpw cvv uniex
    fvex sseli eqid syl mremre mp1i cbs inss2 lssmre wceq tpsuni fveq2d eleqtrd
    inss1 ctop tpstop cldmre 3syl mreincl syl3anc mreclat ) ABCDZEZAFGZAHGZIGZD
    ZVAJZKGZEZVCLGZMEUSVEVDNZKGEZUTVEEVBVEEZVFVDOEVIUSVAAHQPOVDUAUBUSUTAUCGZKGZ
    VEUSACEUTVLEURCABCUDRVKUTAVKSZUTSUETUSABEZVLVEUFURBABCUJRZVNVKVDKVKVAAVMVAS
    ZUGUHTUIUSVNVAUKEVJVOVAAVPULVAVDVDSUMUNUTVBVEVHUOUPVCVGVDVGSUQT $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Neighborhoods
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c nei $.

  $( Extend class notation with neighborhood relation for topologies. $)
  cnei $a class nei $.

  ${
    $d g j x y $.
    $( Define a function on topologies whose value is a map from a subset to
       its neighborhoods.  (Contributed by NM, 11-Feb-2007.) $)
    df-nei $a |- nei = ( j e. Top |-> ( x e. ~P U. j |->
                   { y e. ~P U. j | E. g e. j ( x C_ g /\ g C_ y ) } ) ) $.
  $}

  ${
    $d g j v x J $.  $d g v N $.  $d g P $.  $d g v x S $.  $d g j v x X $.
    neifval.1 $e |- X = U. J $.
    $( The neighborhood function on the subsets of a topology's base set.
       (Contributed by NM, 11-Feb-2007.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    neifval $p |- ( J e. Top -> ( nei ` J ) = ( x e. ~P X |->
                   { v e. ~P X | E. g e. J ( x C_ g /\ g C_ v ) } ) ) $=
      ( vj ctop wcel cpw cv wss wa wrex crab cmpt cvv cnei wceq cuni cfv topopn
      pwexg mptexg 3syl unieq syl6eqr pweqd rexeq rabeqbidv df-nei fvmptg mpdan
      mpteq12dv ) DHIZAEJZAKCKZLUQBKLMZCDNZBUPOZPZQIZDRUAVASUOEDIUPQIVBDEFUBEDU
      CAUPUTQUDUEGDAGKZTZJZURCVCNZBVEOZPVAHQRVCDSZAVEVGUPUTVHVDEVHVDDTEVCDUFFUG
      UHZVHVFUSBVEUPVIURCVCDUIUJUNABCGUKULUM $.

    $( The neighborhood function is a function of the subsets of a topology's
       base set.  (Contributed by NM, 12-Feb-2007.)  (Revised by Mario
       Carneiro, 11-Nov-2013.) $)
    neif $p |- ( J e. Top -> ( nei ` J ) Fn ~P X ) $=
      ( vx vg vv ctop wcel cnei cfv cpw wfn cv wss wa wrex crab cmpt cvv wral
      topopn pwexg rabexg 3syl ralrimivw eqid fnmpt syl neifval fneq1d mpbird )
      AGHZAIJZBKZLDUNDMEMZNUOFMNOEAPZFUNQZRZUNLZULUQSHZDUNTUSULUTDUNULBAHUNSHUT
      ABCUABAUBUPFUNSUCUDUEDUNUQURSURUFUGUHULUNUMURDFEABCUIUJUK $.

    $( A set with a neighborhood is a subset of the topology's base set.  (This
       theorem depends on a function's value being empty outside of its domain,
       but it will make later theorems simpler to state.)  (Contributed by NM,
       12-Feb-2007.) $)
    neiss2 $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) -> S C_ X ) $=
      ( ctop wcel cnei cfv wa cdm cpw elfvdm adantl wb wfn wceq neif fndm syl
      eleq2d adantr mpbid elpwid ) BFGZCABHIZIGZJZADUHAUFKZGZADLZGZUGUJUECAUFMN
      UEUJULOUGUEUIUKAUEUFUKPUIUKQBDERUKUFSTUAUBUCUD $.

    $( The set of neighborhoods of a subset of the base set of a topology.
       (Contributed by NM, 11-Feb-2007.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    neival $p |- ( ( J e. Top /\ S C_ X ) -> ( ( nei ` J ) ` S ) =
                 { v e. ~P X | E. g e. J ( S C_ g /\ g C_ v ) } ) $=
      ( vx ctop wcel wss wa cnei cfv cpw cv wrex crab wceq adantr cvv fveq1d wb
      cmpt neifval topopn elpw2g biimpar pwexg rabexg 3syl sseq1 anbi1d rexbidv
      syl rabbidv eqid fvmptg syl2anc eqtrd ) DHIZBEJZKZBDLMZMZBGENZGOZCOZJZVGA
      OJZKZCDPZAVEQZUCZMZBVGJZVIKZCDPZAVEQZUTVDVNRVAUTBVCVMGACDEFUDUASVBBVEIZVR
      TIZVNVRRUTVSVAUTEDIZVSVAUBDEFUEZBEDUFUNUGUTVTVAUTWAVETIVTWBEDUHVQAVETUIUJ
      SGBVLVRVETVMVFBRZVKVQAVEWCVJVPCDWCVHVOVIVFBVGUKULUMUOVMUPUQURUS $.

    $( The predicate " ` N ` is a neighborhood of ` S ` ."  (Contributed by FL,
       25-Sep-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    isnei $p |- ( ( J e. Top /\ S C_ X ) -> ( N e. ( ( nei ` J ) ` S ) <->
                 ( N C_ X /\ E. g e. J ( S C_ g /\ g C_ N ) ) ) ) $=
      ( vv ctop wcel wss wa cnei cfv cv wrex cpw crab neival eleq2d wb wceq syl
      sseq2 anbi2d rexbidv elrab topopn elpw2g anbi1d syl5bb adantr bitrd ) CHI
      ZAEJZKZDACLMMZIDABNZJZUQGNZJZKZBCOZGEPZQZIZDEJZURUQDJZKZBCOZKZUOUPVDDGABC
      EFRSUMVEVJTUNVEDVCIZVIKUMVJVBVIGDVCUSDUAZVAVHBCVLUTVGURUSDUQUCUDUEUFUMVKV
      FVIUMECIVKVFTCEFUGDECUHUBUIUJUKUL $.

    $( An intuitive definition of a neighborhood in terms of interior.
       (Contributed by Szymon Jaroszewicz, 18-Dec-2007.)  (Revised by Mario
       Carneiro, 11-Nov-2013.) $)
    neiint $p |- ( ( J e. Top /\ S C_ X /\ N C_ X ) ->
           ( N e. ( ( nei ` J ) ` S ) <-> S C_ ( ( int ` J ) ` N ) ) ) $=
      ( vv ctop wcel wss w3a cnei cfv cv wa wrex cnt wb isnei 3adant3 syl2anc
      3anibar simprrl ssntr 3adantl2 adantrrl sstrd simpl1 simpl3 ntropn ntrss2
      rexlimdvaa simpr wceq sseq2 sseq1 anbi12d rspcev syl12anc ex impbid bitrd
      ) BGHZADIZCDIZJZCABKLLHZAFMZIZVGCIZNZFBOZACBPLLZIZVBVCVDVFVKVBVCVFVDVKNQV
      DAFBCDERSUAVEVKVMVEVJVMFBVEVGBHZVJNNAVGVLVEVNVHVIUBVEVNVIVGVLIZVHVBVDVNVI
      NVOVCCBVGDEUCUDUEUFUKVEVMVKVEVMNZVLBHZVMVLCIZVKVPVBVDVQVBVCVDVMUGZVBVCVDV
      MUHZCBDEUITVEVMULVPVBVDVRVSVTCBDEUJTVJVMVRNFVLBVGVLUMVHVMVIVRVGVLAUNVGVLC
      UOUPUQURUSUTVA $.

    $( The predicate " ` N ` is a neighborhood of point ` P ` ."  (Contributed
       by NM, 26-Feb-2007.) $)
    isneip $p |- ( ( J e. Top /\ P e. X ) -> ( N e. ( ( nei ` J ) ` { P } ) <->
                 ( N C_ X /\ E. g e. J ( P e. g /\ g C_ N ) ) ) ) $=
      ( ctop wcel wa csn cnei cfv wss cv wrex wb snssi isnei sylan2 snssg
      anbi1d rexbidv anbi2d adantl bitr4d ) CGHZAEHZIDAJZCKLLHZDEMZUHBNZMZUKDMZ
      IZBCOZIZUJAUKHZUMIZBCOZIZUGUFUHEMUIUPPAEQUHBCDEFRSUGUTUPPUFUGUSUOUJUGURUN
      BCUGUQULUMAUKETUAUBUCUDUE $.

    $( A neighborhood is included in the topology's base set.  (Contributed by
       NM, 12-Feb-2007.) $)
    neii1 $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) -> N C_ X ) $=
      ( vg ctop wcel cnei cfv wa wss neiss2 cv wrex isnei simpl syl6bi impancom
      mpd ) BGHZCABIJJHZKADLZCDLZABCDEMUAUCUBUDUAUCKUBUDAFNZLUECLKFBOZKUDAFBCDE
      PUDUFQRST $.

    $( The neighborhoods of any set are subsets of the base set.  (Contributed
       by Stefan O'Rear, 6-Aug-2015.) $)
    neisspw $p |- ( J e. Top -> ( ( nei ` J ) ` S ) C_ ~P X ) $=
      ( vv ctop wcel cnei cfv cpw cv wa wss neii1 vex elpw sylibr ex ssrdv ) BF
      GZEABHIIZCJZTEKZUAGZUCUBGZTUDLUCCMUEABUCCDNUCCEOPQRS $.
  $}

  ${
    $d g J $.  $d g N $.  $d g R $.  $d g S $.
    $( Property of a neighborhood.  (Contributed by NM, 12-Feb-2007.) $)
    neii2 $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) ->
                 E. g e. J ( S C_ g /\ g C_ N ) ) $=
      ( ctop wcel cnei cfv wa cuni wss cv wrex eqid neiss2 isnei simpr impancom
      syl6bi mpd ) CEFZDACGHHFZIACJZKZABLZKUEDKIBCMZACDUCUCNZOUAUDUBUFUAUDIUBDU
      CKZUFIUFABCDUCUGPUHUFQSRT $.

    $( Any neighborhood of a set ` S ` is also a neighborhood of any subset
       ` R C_ S ` .  Theorem of [BourbakiTop1] p.  I.2.  (Contributed by FL,
       25-Sep-2006.) $)
    neiss $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) /\ R C_ S ) ->
                 N e. ( ( nei ` J ) ` R ) ) $=
      ( vg ctop wcel cnei cfv wss w3a cuni cv wa wrex eqid neii1 3adant3 neii2
      wi sstr2 anim1d reximdv 3ad2ant3 mpd wb simp1 simp3 sstrd isnei mpbir2and
      neiss2 syl2anc ) CFGZDBCHIZIGZABJZKZDAUOIGZDCLZJZAEMZJZVBDJZNZECOZUNUPVAU
      QBCDUTUTPZQRURBVBJZVDNZECOZVFUNUPVJUQBECDSRUQUNVJVFTUPUQVIVEECUQVHVCVDABV
      BUAUBUCUDUEURUNAUTJUSVAVFNUFUNUPUQUGURABUTUNUPUQUHUNUPBUTJUQBCDUTVGULRUIA
      ECDUTVGUJUMUK $.

    $( A set is included in its neighborhoods.  Proposition Viii of
       [BourbakiTop1] p.  I.3 .  (Contributed by FL, 16-Nov-2006.) $)
    ssnei $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) -> S C_ N ) $=
      ( vg ctop wcel cnei cfv wa cv wss wrex neii2 sstr rexlimivw syl ) BEFCABG
      HHFIADJZKQCKIZDBLACKZADBCMRSDBAQCNOP $.
  $}

  $( A point belongs to any of its neighborhoods.  Proposition Viii of
     [BourbakiTop1] p.  I.3.  (Contributed by FL, 28-Sep-2006.) $)
  elnei $p |- ( ( J e. Top /\ P e. A /\ N e. ( ( nei ` J ) ` { P } ) ) ->
              P e. N ) $=
    ( ctop wcel csn cnei cfv w3a wss ssnei 3adant2 wb snssg 3ad2ant2 mpbird ) C
    EFZBAFZDBGZCHIIFZJBDFZTDKZRUAUCSTCDLMSRUBUCNUABDAOPQ $.

  $( The empty set is not a neighborhood of a nonempty set.  (Contributed by
     FL, 18-Sep-2007.) $)
  0nnei $p |- ( ( J e. Top /\ S =/= (/) ) -> -. (/) e. ( ( nei ` J ) ` S ) ) $=
    ( ctop wcel c0 wne cnei cfv wn wceq wa wss ssnei ss0b sylib ex necon3ad imp
    ) BCDZAEFEABGHHDZISTAESTAEJZSTKAELUAABEMANOPQR $.

  ${
    $d g h p v J $.  $d g M $.  $d g h p v N $.  $d g P $.  $d g h p S $.
    $d g h p X $.
    neips.1 $e |- X = U. J $.
    $( A neighborhood of a set is a neighborhood of every point in the set.
       Proposition of [BourbakiTop1] p.  I.2.  (Contributed by FL,
       16-Nov-2006.) $)
    neips $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) ->
                ( N e. ( ( nei ` J ) ` S ) <->
                A. p e. S N e. ( ( nei ` J ) ` { p } ) ) ) $=
      ( vg vh vv wcel wss cfv cv wral wi wa wrex wb sseq1 3adant3 ctop wne cnei
      w3a csn snssi neiss syl3an3 3exp ralrimdv 3ad2ant1 r19.28zv 3ad2ant3 crab
      ssrab2 uniopn mpan2 ad2antrr elrab elunii sylan2br an12s rexlimiva ralimi
      cuni dfss3 sylibr adantl unissb simprbi mprgbir jctir wceq anbi12d rspcev
      c0 sseq2 syl2anc anim2d sylbid ssel2 isneip sylan2 anassrs ralbidva isnei
      ex 3imtr4d impbid ) BUAJZADKZAVPUBZUDZCABUCLZLJZCEMZUEZWNLJZEANZWJWKWOWSO
      WLWJWOWREAWJWOWPAJZWRWTWJWOWQAKWRWPAUFWQABCUGUHUIUJUKWMCDKZWPGMZJZXBCKZPZ
      GBQZPZEANZXAAHMZKZXICKZPZHBQZPZWSWOWMXHXAXFEANZPZXNWLWJXHXPRWKXAXFEAULUMW
      JWKXPXNOWLWJWKPZXOXMXAXQXOXMXQXOPZIMZCKZIBUNZVEZBJZAYBKZYBCKZPZXMWJYCWKXO
      WJYABKYCXTIBUOYABUPUQURXRYDYEXOYDXQXOWPYBJZEANYDXFYGEAXEYGGBXCXBBJZXDYGYH
      XDPXCXBYAJYGXTXDIXBBXSXBCSUSWPXBYAUTVAVBVCVDEAYBVFVGVHYEXKHYAHYACVIXIYAJX
      IBJXKXTXKIXIBXSXICSUSVJVKVLXLYFHYBBXIYBVMXJYDXKYEXIYBAVQXIYBCSVNVOVRWGVST
      VTWJWKWSXHRWLXQWRXGEAWJWKWTWRXGRZWKWTPWJWPDJYIADWPWAWPGBCDFWBWCWDWETWJWKW
      OXNRWLAHBCDFWFTWHWI $.

    $( An open set is a neighborhood of any of its subsets.  (Contributed by
       FL, 2-Oct-2006.) $)
    opnneissb $p |- ( ( J e. Top /\ N e. J /\ S C_ X ) ->
                   ( S C_ N <-> N e. ( ( nei ` J ) ` S ) ) ) $=
      ( vg ctop wcel wss w3a cnei cfv wi wa cv wrex eltopss adantr ssid wceq wb
      sseq2 sseq1 anbi12d rspcev mpanr2 ad2ant2l isnei ad2ant2r mpbir2and exp43
      3imp ssnei ex 3ad2ant1 impbid ) BGHZCBHZADIZJACIZCABKLLHZUQURUSUTVAMUQURU
      SUTVAUQURNZUSUTNZNVACDIZAFOZIZVECIZNZFBPZVBVDVCCBDEQRURUTVIUQUSURUTCCIZVI
      CSVHUTVJNFCBVECTVFUTVGVJVECAUBVECCUCUDUEUFUGUQUSVAVDVINUAURUTAFBCDEUHUIUJ
      UKULUQURVAUTMUSUQVAUTABCUMUNUOUP $.

    $( Any superset of an open set is a neighborhood of it.  (Contributed by
       NM, 14-Feb-2007.) $)
    opnssneib $p |- ( ( J e. Top /\ S e. J /\ N C_ X ) ->
                   ( S C_ N <-> N e. ( ( nei ` J ) ` S ) ) ) $=
      ( vg ctop wcel wss w3a cnei cfv cv wa wrex wi simplr wceq sseq2 ex rspcev
      sseq1 anbi12d ssid biantrur syl6bbr adantlr jca 3adant1 wb eltopss syldan
      isnei 3adant3 sylibrd ssnei 3ad2ant1 impbid ) BGHZABHZCDIZJZACIZCABKLLHZV
      BVCVAAFMZIZVECIZNZFBOZNZVDUTVAVCVJPUSUTVANZVCVJVKVCNVAVIUTVAVCQUTVCVIVAVH
      VCFABVEARZVHAAIZVCNVCVLVFVMVGVCVEAASVEACUBUCVMVCAUDUEUFUAUGUHTUIUSUTVDVJU
      JZVAUSUTADIVNABDEUKAFBCDEUMULUNUOUSUTVDVCPVAUSVDVCABCUPTUQUR $.

    $( Any subset of ` X ` containing a neigborhood of a set is a neighborhood
       of this set.  Proposition Vi of [BourbakiTop1] p.  I.3.  (Contributed by
       FL, 2-Oct-2006.) $)
    ssnei2 $p |- ( ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) /\
                 ( N C_ M /\ M C_ X ) ) -> M e. ( ( nei ` J ) ` S ) ) $=
      ( vg ctop wcel cnei cfv wa wss cv wrex simprr neii2 sstr2 com12 anim2d wb
      reximdv mpan9 adantrr neiss2 isnei syldan adantr mpbir2and ) BHIZDABJKKZI
      ZLZDCMZCEMZLZLCUKIZUOAGNZMZURCMZLZGBOZUMUNUOPUMUNVBUOUMUSURDMZLZGBOUNVBAG
      BDQUNVDVAGBUNVCUTUSVCUNUTURDCRSTUBUCUDUMUQUOVBLUAZUPUJULAEMVEABDEFUEAGBCE
      FUFUGUHUI $.

    $( Any neighborhood of an element in the closure of a subset intersects the
       subset.  Part of proof of Theorem 6.6 of [Munkres] p. 97.  (Contributed
       by NM, 26-Feb-2007.) $)
    neindisj $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( P e. ( ( cls ` J ) ` S ) /\
                   N e. ( ( nei ` J ) ` { P } ) ) ) -> ( N i^i S ) =/= (/) ) $=
      ( vg ctop wcel wss ccl cfv csn cin c0 wne wi wa wceq ex cnei cv wb clsss3
      wrex sseld impr isneip syldan w3a 3anass clsndisj sylanbr anassrs adantrr
      adantllr ssdisj necon3d ad2antll mpd rexlimdva expimpd sylbid exp32 imp43
      ) CHIZBEJZABCKLLZIZDAMCUALLIZDBNZOPZVFVGVIVJVLQVFVGVIRZRZVJDEJZAGUBZIZVPD
      JZRZGCUEZRZVLVFVMAEIZVJWAUCVFVGVIWBVFVGRVHEABCEFUDUFUGAGCDEFUHUIVNVOVTVLV
      NVORZVSVLGCWCVPCIZRZVSVLWEVSRVPBNZOPZVLWEVQWGVRVNWDVQWGVOVNWDVQWGVNVFVGVI
      UJWDVQRWGVFVGVIUKABVPCEFULUMUNUPUOVRWGVLQWEVQVRVKOWFOVRVKOSWFOSVPDBUQTURU
      SUTTVAVBVCVDVE $.
  $}

  $( An open set is a neighborhood of any of its subsets.  (Contributed by NM,
     13-Feb-2007.) $)
  opnneiss $p |- ( ( J e. Top /\ N e. J /\ S C_ N ) ->
                  N e. ( ( nei ` J ) ` S ) ) $=
    ( ctop wcel wss w3a cnei cfv simp3 cuni wb wa eqid eltopss sstr sylan 3impa
    ancoms opnneissb syld3an3 mpbid ) BDEZCBEZACFZGUECABHIIEZUCUDUEJUCUDUEABKZF
    ZUEUFLUCUDUEUHUCUDMCUGFZUEUHCBUGUGNZOUEUIUHACUGPSQRABCUGUJTUAUB $.

  $( An open set is a neighborhood of any of its members.  (Contributed by NM,
     8-Mar-2007.) $)
  opnneip $p |- ( ( J e. Top /\ N e. J /\ P e. N ) ->
                  N e. ( ( nei ` J ) ` { P } ) ) $=
    ( wcel ctop csn wss cnei cfv snssi opnneiss syl3an3 ) ACDBEDCBDAFZCGCMBHIID
    ACJMBCKL $.

  ${
    $d x J $.  $d x S $.
    $( A set is open iff it is a neighborhood of all its points.  ( Contributed
       by Jeff Hankins, 15-Sep-2009.)  (Contributed by NM, 16-Sep-2009.) $)
    opnnei $p |- ( J e. Top -> ( S e. J <-> A. x e. S S e. ( (
    nei ` J ) ` { x } ) ) ) $=
      ( ctop wcel c0 wceq cv csn cnei cfv wral wb wa adantr adantl wi wss snss
      ex 0opn eleq1 mpbird rzal 2thd wn opnneip 3expia ralrimiv cuni wrex df-ne
      wne r19.2z sylbir neii1 rexlimdvw sylan9r cnt ntrss2 ralbii dfss3 biimpri
      eqid vex sylan2br eqssd sstr2 com12 syl5bi imp neiint 3com23 3expa syldan
      ralbidva isopn3 3imtr4d com23 mpdd impbid pm2.61dan ) CDEZBFGZBCEZBAHZIZC
      JKKEZABLZMWCWDNZWEWIWJWEFCEZWCWKWDCUAOWDWEWKMWCBFCUBPUCWDWIWCWHABUDPUEWCW
      DUFZNZWEWIWCWEWIQWLWCWEWIWCWENWHABWCWEWFBEZWHWFCBUGUHUITOWMWIBCUJZRZWEWLW
      IWHABUKZWCWPWLBFUMZWIWQQBFULWRWIWQWHABUNTUOWCWHWPABWCWHWPWGCBWOWOVDZUPTUQ
      URWCWIWPWEQQWLWCWPWIWEWCWPWIWEQWCWPNZWGBCUSKKZRZABLZXABGZWIWEWTXCXDWTXCNX
      ABWTXABRXCBCWOWSUTOXCWTWFXAEZABLZBXARZXEXBABWFXAAVEZSVAXFXGWTXGXFABXAVBVC
      PVFVGTWTWHXBABWTWNWGWORZWHXBMZWTWNXIWNWGBRZWTXIWFBXHSWPXKXIQWCXKWPXIWGBWO
      VHVIPVJVKWCWPXIXJWCXIWPXJWGCBWOWSVLVMVNVOVPBCWOWSVQVRTVSOVTWAWB $.
  $}

  ${
    $d J x n $.  $d K x $.  $d P x n $.  $d S x n $.  $d X x n $.  $d Y x $.
    tpnei.1 $e |- X = U. J $.
    $( The underlying set of a topology is a neighborhood of any of its
       subsets.  Special case of ~ opnneiss .  (Contributed by FL,
       2-Oct-2006.) $)
    tpnei $p |- ( J e. Top -> ( S C_ X <-> X e. ( ( nei ` J ) ` S ) ) ) $=
      ( ctop wcel wss cnei cfv wi topopn opnneiss 3exp mpd ssnei ex impbid ) BE
      FZACGZCABHIIFZRCBFZSTJBCDKRUASTABCLMNRTSABCOPQ $.

    $( The union of the neighborhoods of a set equals the topology's underlying
       set.  (Contributed by FL, 18-Sep-2007.)  (Revised by Mario Carneiro,
       9-Apr-2015.) $)
    neiuni $p |- ( ( J e. Top /\ S C_ X ) -> X = U. ( ( nei ` J ) ` S ) ) $=
      ( vx ctop wcel wss wa cnei cfv cuni tpnei biimpa elssuni cv wral wi neii1
      syl ex adantr ralrimiv unissb sylibr eqssd ) BFGZACHZIZCABJKKZLZUICUJGZCU
      KHUGUHULABCDMNCUJOTUIEPZCHZEUJQUKCHUIUNEUJUGUMUJGZUNRUHUGUOUNABUMCDSUAUBU
      CEUJCUDUEUF $.

    $( A point ` P ` belongs to the closure of a set ` S ` iff every
       neighborhood of ` P ` meets ` S ` .  (Contributed by FL,
       15-Sep-2013.) $)
    neindisj2 $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) ->
        ( P e. ( ( cls ` J ) ` S ) <->
          A. n e. ( ( nei ` J ) ` { P } ) ( n i^i S ) =/= (/) ) ) $=
      ( vx wcel wss w3a cfv cv cin c0 wne wi wral wa wrex ex ctop ccl csn elcls
      cnei isneip r19.29r pm3.35 ssrin sseq2 syl6bi syl5com necon3d com23 imp31
      wceq ss0 rexlimivw syl adantl 3adant2 imp ralrimiv opnneip neeq1d rspccva
      weq ineq1 idd 3exp com14 com3l mpcom 3expia com25 3imp1 impbida bitrd ) D
      UAHZBEIZAEHZJZABDUBKKHAGLZHZWCBMZNOZPZGDQZCLZBMZNOZCAUCDUEKKZQZGABDEFUDWB
      WHWMWBWHRWKCWLWBWHWIWLHZWKPWBWNWHWKVSWAWNWHWKPZPVTVSWARWNWIEIZWDWCWIIZRZG
      DSZRWOAGDWIEFUFWSWOWPWSWHWKWSWHRWRWGRZGDSWKWRWGGDUGWTWKGDWDWQWGWKWDWGWQWK
      WDWGWQWKPWDWGRWFWQWKWDWFUHWQWJNWENWQWEWJIZWJNUPZWENUPZWCWIBUIXBXAWENIXCWJ
      NWEUJWEUQUKULUMULTUNUOURUSTUTUKVAUNVBVCWBWMRWGGDVSVTWAWMWCDHZWGPVSXDWAWMV
      TWGVSXDWAWMVTWGPPPVSXDRWDWMVTWAWFVSXDWDWMVTWAWFPPZPZWCWLHZVSXDWDJZXFADWCV
      DWMXGXHXEWMXGXHXEPZWMXGRWFXIWKWFCWCWLCGVGWJWENWIWCBVHVEVFWAXHVTWFWFWAXHVT
      WFWFPWAXHVTJWFVIVJVKUSTVLVMVNVOTVOVPVCVQVR $.

    topssnei.2 $e |- Y = U. K $.
    $( A finer topology has more neighborhoods.  (Contributed by Mario
       Carneiro, 9-Apr-2015.) $)
    topssnei $p |- ( ( ( J e. Top /\ K e. Top /\ X = Y ) /\ J C_ K ) ->
       ( ( nei ` J ) ` S ) C_ ( ( nei ` K ) ` S ) ) $=
      ( vx ctop wcel wceq w3a wss wa cnei cfv cv cnt syl2anc syl3anc wb sseqtrd
      simpl2 simprl simpl1 simprr ntropn sseldd neiss2 neiint opnneiss syl22anc
      neii1 mpbid ntrss2 simpl3 ssnei2 expr ssrdv ) BIJZCIJZDEKZLZBCMZNHABOPPZA
      COPPZVCVDHQZVEJZVGVFJZVCVDVHNZNZVAVGBRPPZVFJZVLVGMZVGEMVIUTVAVBVJUCZVKVAV
      LCJAVLMZVMVOVKBCVLVCVDVHUDVKUTVGDMZVLBJUTVAVBVJUEZVKUTVHVQVRVCVDVHUFZABVG
      DFUMSZVGBDFUGSUHVKVHVPVSVKUTADMZVQVHVPUAVRVKUTVHWAVRVSABVGDFUISVTABVGDFUJ
      TUNACVLUKTVKUTVQVNVRVTVGBDFUOSVKVGDEVTUTVAVBVJUPUBACVGVLEGUQULURUS $.
  $}

  ${
    $d g h v x y J $.  $d g h v M $.  $d g h v x y N $.  $d g h v x y S $.
    $( The intersection of two neighborhoods of a set is also a neighborhood of
       the set.  Proposition Vii of [BourbakiTop1] p.  I.3 .  (Contributed by
       FL, 28-Sep-2006.) $)
    innei $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S )
   /\ M e. ( ( nei ` J ) ` S ) ) -> ( N i^i M ) e. ( ( nei ` J ) ` S ) ) $=
      ( vg vh vv ctop wcel cfv cin cv wa wrex 3adant3 neii2 wi rexlimdva syldan
      wss cnei w3a cuni eqid neii1 ssinss1 syl anim12dan inopn 3expa ssin ss2in
      biimpi anim12i an4s wceq sseq2 sseq1 anbi12d rspcev syl2an an32s ex imp32
      expr 3impb wb neiss2 isnei mpbir2and ) BHIZDABUAJJZIZCVLIZUBDCKZVLIZVOBUC
      ZTZAELZTZVSVOTZMZEBNZVKVMVRVNVKVMMDVQTVRABDVQVQUDZUEDCVQUFUGOVKVMVNWCVKVM
      VNMAFLZTZWEDTZMZFBNZAGLZTZWJCTZMZGBNZMWCVKVMWIVNWNAFBDPAGBCPUHVKWIWNWCVKW
      HWNWCQZFBVKWEBIZMZWHWOWQWHMWMWCGBWQWJBIZWHWMWCQWQWRMZWHWMWCWSWEWJKZBIZAWT
      TZWTVOTZMZWCWHWMMVKWPWRXAWEWJBUIUJWFWKWGWLXDWFWKMZXBWGWLMXCXEXBAWEWJUKUMW
      EDWJCULUNUOWBXDEWTBVSWTUPVTXBWAXCVSWTAUQVSWTVOURUSUTVAVEVBRVCRVDSVFVKVMVP
      VRWCMVGZVNVKVMAVQTXFABDVQWDVHAEBVOVQWDVISOVJ $.

    $( Only an open set is a neighborhood of itself.  (Contributed by FL,
       2-Oct-2006.) $)
    opnneiid $p |- ( J e. Top -> ( N e. ( ( nei ` J ) ` N ) <-> N e. J ) ) $=
      ( vx ctop wcel cnei cfv wa cv wss wrex neii2 wceq eleq1a syl5bir rexlimiv
      eqss syl ex ssid opnneiss 3exp mpii impbid ) ADEZBBAFGGEZBAEZUEUFUGUEUFHB
      CIZJUHBJHZCAKUGBCABLUIUGCAUIBUHMUHAEUGBUHQUHABNOPRSUEUGBBJZUFBTUEUGUJUFBA
      BUAUBUCUD $.

    $( For any neighborhood ` N ` of ` S ` , there is a neighborhood ` x ` of
       ` S ` such that ` N ` is a neighborhood of all subsets of ` x ` .
       Proposition Viv of [BourbakiTop1] p.  I.3 .  (Contributed by FL,
       2-Oct-2006.) $)
    neissex $p |- ( ( J e. Top /\ N e. ( ( nei ` J ) ` S ) ) ->
   E. x e. ( ( nei ` J ) ` S ) A. y ( y C_ x -> N e. ( ( nei ` J ) ` y ) ) ) $=
      ( ctop wcel cnei cfv wa cv wss wrex wi wal neii2 simpr adantr syl3anc ex
      opnneiss 3expb adantrrr adantlr simplll cuni simpll eqid opnssneib biimpa
      wb neii1 anasss neiss adantrrl alrimiv jca reximdv2 mpd ) DFGZECDHIZIZGZJ
      ZCAKZLZVEELZJZADMBKZVELZEVIVAIGZNZBOZAVBMCADEPVDVHVMADVBVDVEDGZVHJZVEVBGZ
      VMJVDVOJZVPVMUTVOVPVCUTVNVFVPVGUTVNVFVPCDVEUAUBUCUDVQVLBVDVNVGVLVFVDVNVGJ
      ZJZVJVKVSVJJUTEVEVAIGZVJVKUTVCVRVJUEVSVTVJVDVNVGVTVDVNJZVGVTWAUTVNEDUFZLZ
      VGVTUKUTVCVNUGVDVNQVDWCVNCDEWBWBUHZULRVEDEWBWDUISUJUMRVSVJQVIVEDEUNSTUOUP
      UQTURUS $.
  $}

  $( The empty set is a neighborhood of itself.  (Contributed by FL,
     10-Dec-2006.) $)
  0nei $p |- ( J e. Top -> (/) e. ( ( nei ` J ) ` (/) ) ) $=
    ( ctop wcel c0 cnei cfv 0opn opnneiid mpbird ) ABCDDAEFFCDACAGADHI $.

  ${
    $d a p C $.  $d a N $.  $d a X $.
    neiptop.o $e |- J = { a e. ~P X | A. p e. a a e. ( N ` p ) } $.
    $( Lemma for ~ neiptopreu (Contributed by Thierry Arnoux, 6-Jan-2018.) $)
    neipeltop $p |- ( C e. J <-> ( C C_ X /\ A. p e. C C e. ( N ` p ) ) ) $=
      ( wcel cpw cv cfv wral wa wss eleq1 raleqbi1dv elrab2 cvv wb c0 wceq elex
      0ex mpbiri adantl wne ralimi r19.3rzv biimparc sylan pm2.61dane elpwg syl
      pm5.32ri bitri ) ABHADIZHZAEJCKZHZEALZMADNZUTMFJZURHZEVBLUTFAUPBVCUSEVBAV
      BAUROPGQUTUQVAUTARHZUQVASUTVDATATUAZVDUTVEVDTRHUCATROUDUEUTVDEALZATUFZVDU
      SVDEAAURUBUGVGVDVFVDEAUHUIUJUKADRULUMUNUO $.

    $d a b p $.  $d a p J $.  $d a p X $.  $d p ph $.
    neiptop.0 $e |- ( ph -> N : X --> ~P ~P X ) $.
    neiptop.1 $e |- ( ( ( ( ph /\ p e. X ) /\ a C_ b /\ b C_ X )
                                     /\ a e. ( N ` p ) ) -> b e. ( N ` p ) ) $.
    neiptop.2 $e |- ( ( ph /\ p e. X ) -> ( fi ` ( N ` p ) ) C_ ( N ` p ) ) $.
    neiptop.3 $e |- ( ( ( ph /\ p e. X ) /\ a e. ( N ` p ) ) -> p e. a ) $.
    neiptop.4 $e |- ( ( ( ph /\ p e. X ) /\ a e. ( N ` p ) )
                      -> E. b e. ( N ` p ) A. q e. b a e. ( N ` q ) ) $.
    neiptop.5 $e |- ( ( ph /\ p e. X ) -> X e. ( N ` p ) ) $.
    $( Lemma for ~ neiptopreu (Contributed by Thierry Arnoux, 6-Jan-2018.) $)
    neiptopuni $p |- ( ph -> X = U. J ) $=
      ( cuni wss wcel cv wa wceq cpw elpwi ad2antlr simpr sseldd wral wrex crab
      wi cfv unieqi eleq2i elunirab bitri simpl reximi sylbi r19.29a ssrdv ssid
      a1i ralrimiva neipeltop sylanbrc unissel syl2anc eqcomd ) ABPZDAVIDQDBRZV
      IDUAAFVIDFSZVIRZVKDRZUJAVLVKGSZRZVMGDUBZVLVNVPRZTZVOTVNDVKVQVNDQVLVOVNDUC
      UDVRVOUEUFVLVOVNVKCUKZRFVNUGZTZGVPUHZVOGVPUHVLVKVTGVPUIZPZRWBVIWDVKBWCIUL
      UMVTGVKVPUNUOWAVOGVPVOVTUPUQURUSVBUTADDQZDVSRZFDUGVJWEADVAVBAWFFDOVCDBCDF
      GIVDVEBDVFVGVH $.

    $d a p C $.  $d a c e f p J $.  $d a b c N $.  $d a b p X $.
    $d a b c e f p ph $.
    $( Lemma for ~ neiptopreu (Contributed by Thierry Arnoux, 7-Jan-2018.) $)
    neiptoptop $p |- ( ph -> J e. Top ) $=
      ( wcel wss wral wa cvv ve vf vc ctop cv cuni wi wal cin uniss adantl wceq
      cfv neiptopuni adantr sseqtr4d w3a simp-4l ad3antrrr simpllr jca ad2antlr
      sseldd elssuni simpr sselda neipeltop simprbi syl r19.21bi adantllr sseq1
      3jca 3anbi2d eleq1 anbi12d imbi1d imbi2d cpw crab ssid ralrimiva sylanbrc
      a1i pwexg rabexg 3syl syl5eqel ssexd uniexg sseq2 3anbi23d anbi1d imbi12d
      vtoclg chvarv mp2and eluni2 sylib r19.29a ex alrimiv inss1 simplbi syl5ss
      wrex cfi simplll sseldi syl2anc simplr inss2 fvex inelfi mp3an1 wb istopg
      mpbir2and ) ABUDPZUAUEZBQZXTUFZBPZUGZUAUHZXTUBUEZUIZBPZUBBRZUABRZAYDUAAYA
      YCAYASZYBDQZYBFUEZCUMZPZFYBRYCYKYBBUFZDYAYBYPQAXTBUJUKADYPULYAABCDEFGHIJK
      LMNOUNUOUPZYKYOFYBYKYMYBPZSZYMUCUEZPZYOUCXTYSYTXTPZSUUASZAYMDPZSZYTYBQZYL
      UQZYTYNPZYOUUCUUEUUFYLUUCAUUDAYAYRUUBUUAURUUCYBDYMYKYLYRUUBUUAYQUSZYKYRUU
      BUUAUTVCVAUUBUUFYSUUAYTXTVDVBUUIVMYKUUBUUAUUHYRYKUUBSZUUHFYTUUJYTBPZUUHFY
      TRZYKXTBYTAYAVEZVFUUKYTDQUULYTBCDFGIVGVHVIVJVKYKUUGUUHSZYOUGZYRUUBUUAYKUU
      EGUEZYBQZYLUQZUUPYNPZSZYOUGZUGYKUUOUGGUCUUPYTULZUVAUUOYKUVBUUTUUNYOUVBUUR
      UUGUUSUUHUVBUUQUUFUUEYLUUPYTYBVLVNUUPYTYNVOVPVQVRYKXTTPYBTPUVAYKXTBTABTPZ
      YAABUUSFUUPRZGDVSZVTZTIADBPZUVETPUVFTPADDQZDYNPZFDRUVGUVHADWAWDAUVIFDOWBD
      BCDFGIVGWCDBWEUVDGUVETWFWGWHZUOUUMWIXTTWJUUEUUPHUEZQZUVKDQZUQZUUSSZUVKYNP
      ZUGUVAHYBTUVKYBULZUVOUUTUVPYOUVQUVNUURUUSUVQUVLUUQUVMYLUUEUVKYBUUPWKUVKYB
      DVLWLWMUVKYBYNVOWNKWOWGWPUSWQYSYRUUAUCXTXFYKYRVEUCYMXTWRWSWTWBYBBCDFGIVGW
      CXAXBAYIUABAXTBPZSZYHUBBUVSYFBPZSZYGDQYGYNPZFYGRYHUWAYGXTDXTYFXCZUVRXTDQZ
      AUVTUVRUWDXTYNPZFXTRZXTBCDFGIVGZXDZVBXEUWAUWBFYGUWAYMYGPZSZYNXGUMZYNYGUWJ
      AUUDUWKYNQAUVRUVTUWIXHUWJXTDYMUWJUVRUWDAUVRUVTUWIUTZUWHVIUWJYGXTYMUWCUWAU
      WIVEZXIZVCLXJUWJUWEYFYNPZYGUWKPZUWJUVRYMXTPUWEUWLUWNUVRUWEFXTUVRUWDUWFUWG
      VHVJXJUWJUVTYMYFPUWOUVSUVTUWIXKUWJYGYFYMXTYFXLUWMXIUVTUWOFYFUVTYFDQUWOFYF
      RYFBCDFGIVGVHVJXJYNTPUWEUWOUWPYMCXMXTYFTYNXNXOXJVCWBYGBCDFGIVGWCWBWBAUVCX
      SYEYJSXPUVJUAUBTBXQVIXR $.

    $d a c d e f p J $.  $d a b c d p q r s N $.  $d a b c d p q r s X $.
    $d a b c d e f p q r s ph $.
    $( Lemma for ~ neiptopreu (Contributed by Thierry Arnoux, 7-Jan-2018.) $)
    neiptopnei $p |- ( ph -> N = ( p e. X |-> ( ( nei ` J ) ` { p } ) ) ) $=
      ( vc vd wcel wa wi vr vs cfv cmpt csn cnei cpw feqmptd cuni wss ffvelrnda
      cv wel wrex adantr elpwid sseldd wceq neiptopuni sseqtrd crab wral ssrab2
      simpr a1i weq fveq2 eleq2d elrab simp-5l simpr1l simplr w3a sseq1 3anbi2d
      3anassrs anbi12d imbi1d simpl1l cvv ctop neiptoptop uniexg eqeltrd rabexg
      eleq1 syl sseq2 3anbi23d anbi1d imbi12d anbi2d 3anbi1d chvarv vtoclg 3syl
      mpcom 3an1rs syl211anc simplll simprl simprr cbvralv rexeqbidv rexralbidv
      mpan2 sselda a1d ancrd ralimdva reximdva mpd ralbii rexbii sylibr biimpri
      dfss3 reximi syl21anc r19.29a sylan2b ralrimiva neipeltop sylanbrc anim1i
      wb nfv nfrab1 nfcv rabid elequ1 elequ2 ex syl5bi ssrd rspcev syl12anc jca
      eleq2 nfan nfre1 sseqtr4d syl31anc simprbi anasss reximi2 impbida eleqtrd
      r19.21bi ad2antll r19.29af isneip syl2anc bitr4d eqrdv mpteq2dva eqtrd
      eqid ) ACFDFULZCUCZUDFDUUSUEBUFUCUCZUDAFDDUGZUGZCJUHAFDUUTUVAAUUSDRZSZPUU
      TUVAUVEPULZUUTRZUVFBUIZUJZFQUMZQULZUVFUJZSZQBUNZSZUVFUVARZUVEUVGUVOUVEUVG
      SZUVIUVNUVQUVFDUVHUVQUVFDUVQUUTUVBUVFUVQUUTUVBUVEUUTUVCRUVGADUVCUUSCJUKUO
      UPUVEUVGVDUQUPUVEDUVHURZUVGAUVRUVDABCDEFGHIJKLMNOUSZUOZUOUTUVQUVFEULZCUCZ
      RZEDVAZBRZUUSUWDRZUWDUVFUJZUVNUVQUWDDUJZUWDUUTRZFUWDVBZUWEUWHUVQUWCEDVCZV
      EUVQUWDUAULZCUCZRZUAUWDVBUWJUVQUWNUAUWDUWLUWDRUVQUWLDRZUVFUWMRZSZUWNUWCUW
      PEUWLDEUAVFUWBUWMUVFUWAUWLCVGVHVIUVQUWQSZHULZUWDUJZUWNHUWMUWRUWSUWMRZSZUW
      TSAUWOUWTUXAUWNAUVDUVGUWQUXAUWTVJUVQUWQUXAUWTUWOUWOUWPUXAUWTUVQVKVPUXBUWT
      VDUWRUXAUWTVLAUWOSZUWTUXAVMUWHUWNUWKUXCUWTUWHUXAUWNUXCGULZUWDUJZUWHVMZUXD
      UWMRZSZUWNTZUXCUWTUWHVMZUXASZUWNTGHGHVFZUXHUXKUWNUXLUXFUXJUXGUXAUXLUXEUWT
      UXCUWHUXDUWSUWDVNVOUXDUWSUWMWFVQVRAUXHUWNAUWOUXEUWHUXGVSADVTRUWDVTRUXIADU
      VHVTUVSABWARZUVHVTRABCDEFGHIJKLMNOWBZBWAWCWGWDUWCEDVTWEUXCUXDUWSUJZUWSDUJ
      ZVMZUXGSZUXATZUXIHUWDVTUWSUWDURZUXRUXHUXAUWNUXTUXQUXFUXGUXTUXOUXEUXPUWHUX
      CUWSUWDUXDWHUWSUWDDVNWIWJUWSUWDUWMWFWKUVEUXOUXPVMZUXDUUTRZSZUWSUUTRZTZUXS
      FUAFUAVFZUYCUXRUYDUXAUYFUYAUXQUYBUXGUYFUVEUXCUXOUXPUYFUVDUWOAUUSUWLDWFWLZ
      WMUYFUUTUWMUXDUUSUWLCVGZVHVQUYFUUTUWMUWSUYHVHWKKWNWOWPWQWNWRXFWSUWRAUWOUW
      PUWTHUWMUNZAUVDUVGUWQWTUVQUWOUWPXAUVQUWOUWPXBUXCUWPSZUBULZUWDRZUBUWSVBZHU
      WMUNZUYIUYJUYKDRZUVFUYKCUCZRZSZUBUWSVBZHUWMUNZUYNUYJUYQUBUWSVBZHUWMUNZUYT
      UVQUWCEUWSVBZHUUTUNZTZUYJVUBTFUAUYFUVQUYJVUDVUBUYFUVEUXCUVGUWPUYGUYFUUTUW
      MUVFUYHVHVQUYFVUCVUAHUUTUWMUYHVUCVUAYFUYFUWCUYQEUBUWSEUBVFUWBUYPUVFUWAUYK
      CVGVHZXCVEXDWKUVEUYBSZUXDUWBRZEUWSVBHUUTUNZTVUEGPGPVFZVUGUVQVUIVUDVUJUYBU
      VGUVEUXDUVFUUTWFWLZVUJVUHUWCHEUUTUWSUXDUVFUWBWFXEWKNWNWNUXCVUBUYTTUWPUXCV
      UAUYSHUWMUXCUXASZUYQUYRUBUWSVULUBHUMSZUYQUYOVUMUYOUYQVULUWSDUYKVULUWSDUXC
      UWMUVBUWSUXCUWMUVBADUVCUWLCJUKUPXGUPXGXHXIXJXKUOXLUYMUYSHUWMUYLUYRUBUWSUW
      CUYQEUYKDVUFVIXMXNXOUYMUWTHUWMUWTUYMUBUWSUWDXQXPXRWGXSXTYAYBUWIUWNFUAUWDU
      YFUUTUWMUWDUYHVHXCXOUWDBCDFGIYCYDUVQUVDUVGSUWFUVEUVDUVGAUVDVDZYEUWCUVGEUU
      SDEFVFUWBUUTUVFUWAUUSCVGVHVIXOUVQEUWDUVFUVQEYGUWCEDYHEUVFYIUWAUWDRUWADRZU
      WCSZUVQEPUMZUWCEDYJUVQVUPVUQUVQVUPSAVUOUWCVUQAUVDUVGVUPWTUVQVUOUWCXAUVQVU
      OUWCXBUVQFPUMZTZAVUOSZUWCSZVUQTFEFEVFZUVQVVAVURVUQVVBUVEVUTUVGUWCVVBUVDVU
      OAUUSUWADWFWLVVBUUTUWBUVFUUSUWACVGVHVQFEPYKWKVUGFGUMZTVUSGPVUJVUGUVQVVCVU
      RVUKGPFYLWKMWNWNXSYMYNYOUVMUWFUWGSQUWDBUVKUWDURUVJUWFUVLUWGUVKUWDUUSYSUVK
      UWDUVFVNVQYPYQYRUVEUVOSZUVLUVGQUUTUVEUVOQUVEQYGUVIUVNQUVIQYGUVMQBUUAYTYTV
      VDUVKUUTRZSZUVLSZUVEUVLUVFDUJZVVEUVGUVEUVOVVEUVLWTZVVFUVLVDVVGUVFUVHDUVEU
      VOVVEUVLUVIUVIUVNVVEUVLUVEVKVPVVGUVEUVRVVIUVTWGUUBVVDVVEUVLVLUVEUXDUVFUJZ
      VVHVMZUYBSZUVGTZUVEUVLVVHVMZVVESZUVGTGQGQVFZVVLVVOUVGVVPVVKVVNUYBVVEVVPVV
      JUVLUVEVVHUXDUVKUVFVNVOUXDUVKUUTWFVQVRUYEVVMHPHPVFZUYCVVLUYDUVGVVQUYAVVKU
      YBVVQUXOVVJUXPVVHUVEUWSUVFUXDWHUWSUVFDVNWIWJUWSUVFUUTWFWKKWNWNUUCUVNUVLQU
      UTUNUVEUVIUVMUVLQBUUTUVKBRZUVJUVLVVEUVLSVVRUVJSVVEUVLVVRVVEFUVKVVRUVKDUJV
      VEFUVKVBUVKBCDFGIYCUUDUUIYEUUEUUFUUJUUKUUGUVEUXMUUSUVHRUVPUVOYFAUXMUVDUXN
      UOUVEUUSDUVHVUNUVTUUHUUSQBUVFUVHUVHUURUULUUMUUNUUOUUPUUQ $.

    $d a p C $.  $d a b c d e f j p J $.  $d a b c d n j p q r s N $.
    $d a b c d j p q r s X $.  $d a b c d e f j p q r s ph $.
    $( If, to each element ` P ` of a set ` X ` , we associate a set
       ` ( N `` P ) ` fulfilling the properties V_i, V_ii, V_iii and property
       V_iv of [BourbakiTop1] p.  I.2. , corresponding to ~ ssnei , ~ innei ,
       ~ elnei and ~ neissex , then there is a unique topology ` j ` such that
       for any point ` p ` , ` ( N `` p ) ` is the set of neighborhoods of
       ` p ` .  Proposition 2 of [BourbakiTop1] p.  I.3.  This can be used to
       build a topology from a set of neighborhoods.  Note that the additional
       condition that ` X ` is a neighborhood of all points was added.
       (Contributed by Thierry Arnoux, 6-Jan-2018.) $)
    neiptopreu $p |- ( ph ->
      E! j e. ( TopOn ` X ) N = ( p e. X |-> ( ( nei ` j ) ` { p } ) ) ) $=
      ( cfv wcel wceq wa ctopon cv csn cnei cmpt wral wreu cuni ctop neiptoptop
      wi eqid toptopon sylib neiptopuni fveq2d eleqtrrd neiptopnei nfmpt1 nfeq2
      wss nfv nfan simpllr sselda cvv id fvex a1i fvmpt2d syl2anc eqcomd eleq2d
      simpr ralbida pm5.32da toponss wb topontop ad2antlr opnnei syl biimpa jca
      biimpar adantrl impbida neipeltop 3bitr4d eqrdv ex ralrimiva simpl fveq1d
      mpteq2dva eqeq2d eqreu syl3anc ) ACEUAQZRDGEGUBZUCZCUDQZQZUEZSZDGEXABUBZU
      DQZQZUEZSZXFCSZUKZBWSUFXJBWSUGACCUHZUAQZWSACUIRCXNRACDEFGHIJKLMNOPUJCXMXM
      ULUMUNAEXMUAACDEFGHIJKLMNOPUOUPUQACDEFGHIJKLMNOPURAXLBWSAXFWSRZTZXJXKXPXJ
      TZIXFCXQIUBZEVAZXRXHRZGXRUFZTZXSXRWTDQZRZGXRUFZTZXRXFRZXRCRZXQXSYAYEXQXST
      ZXTYDGXRXQXSGXPXJGXPGVBGDXIGEXHUSUTVCXSGVBVCYIWTXRRZTZXHYCXRYKYCXHYKXJWTE
      RZYCXHSXPXJXSYJVDYIXREWTXQXSVNVEXJGEXHDVFXJVGXHVFRXJYLTXAXGVHVIVJVKVLVMVO
      VPXQYGYBXQYGTZXSYAYMXOYGXSAXOXJYGVDXQYGVNXRXFEVQVKXQYGYAXQXFUIRZYGYAVRXOY
      NAXJEXFVSVTGXRXFWAWBZWCWDXQYAYGXSXQYGYAYOWEWFWGYHYFVRXQXRCDEGHJWHVIWIWJWK
      WLXJXEBWSCXKXIXDDXKGEXHXCXKYLTZXAXGXBYPXFCUDXKYLWMUPWNWOWPWQWR $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Limit points and perfect sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c limPt $.
  $c Perf $.

  $( Extend class notation with the limit point function for topologies. $)
  clp $a class limPt $.

  $( Extend class notation with the class of all perfect spaces. $)
  cperf $a class Perf $.

  ${
    $d j x y $.
    $( Define a function on topologies whose value is the set of limit points
       of the subsets of the base set.  See ~ lpval .  (Contributed by NM,
       10-Feb-2007.) $)
    df-lp $a |- limPt = ( j e. Top |-> ( x e. ~P U. j |->
                  { y | y e. ( ( cls ` j ) ` ( x \ { y } ) ) } ) ) $.
  $}

  $( Define the class of all perfect spaces.  A perfect space is one for which
     every point in the set is a limit point of the whole space.  (Contributed
     by Mario Carneiro, 24-Dec-2016.) $)
  df-perf $a |- Perf = { j e. Top | ( ( limPt ` j ) ` U. j ) = U. j } $.

  ${
    $d j n x y J $.  $d n x y P $.  $d n x y S $.  $d x T $.  $d j n x y X $.
    lpfval.1 $e |- X = U. J $.
    $( The limit point function on the subsets of a topology's base set.
       (Contributed by NM, 10-Feb-2007.)  (Revised by Mario Carneiro,
       11-Nov-2013.) $)
    lpfval $p |- ( J e. Top -> ( limPt ` J ) = ( x e. ~P X |->
                  { y | y e. ( ( cls ` J ) ` ( x \ { y } ) ) } ) ) $=
      ( vj ctop wcel cpw cv csn cdif ccl cfv cab cmpt cvv clp wceq cuni syl6eqr
      topopn pwexg mptexg 3syl unieq pweqd fveq2 fveq1d eleq2d abbidv mpteq12dv
      df-lp fvmptg mpdan ) CGHZADIZBJZAJURKLZCMNZNZHZBOZPZQHZCRNVDSUPDCHUQQHVEC
      DEUBDCUCAUQVCQUDUEFCAFJZTZIZURUSVFMNZNZHZBOZPVDGQRVFCSZAVHVLUQVCVMVGDVMVG
      CTDVFCUFEUAUGVMVKVBBVMVJVAURVMUSVIUTVFCMUHUIUJUKULABFUMUNUO $.

    $( The set of limit points of a subset of the base set of a topology.
       Alternate definition of limit point in [Munkres] p. 97.  (Contributed by
       NM, 10-Feb-2007.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    lpval $p |- ( ( J e. Top /\ S C_ X ) -> ( ( limPt ` J ) ` S ) =
                 { x | x e. ( ( cls ` J ) ` ( S \ { x } ) ) } ) $=
      ( vy ctop wcel wss wa clp cfv cpw cv csn cdif cab wceq adantr cvv cmpt wb
      ccl lpfval fveq1d topopn elpw2g syl biimpar wi clsss3 sseld sylan2 abssdv
      ssdifss ssexd difeq1 fveq2d eleq2d abbidv eqid fvmptg syl2anc eqtrd ) CGH
      ZBDIZJZBCKLZLZBFDMZANZFNZVKOZPZCUCLZLZHZAQZUAZLZVKBVMPZVOLZHZAQZVEVIVTRVF
      VEBVHVSFACDEUDUESVGBVJHZWDTHVTWDRVEWEVFVEDCHZWEVFUBCDEUFZBDCUGUHUIVGWDDCV
      EWFVFWGSVGWCADVFVEWADIZWCVKDHUJBDVMUOVEWHJWBDVKWACDEUKULUMUNUPFBVRWDVJTVS
      VLBRZVQWCAWIVPWBVKWIVNWAVOVLBVMUQURUSUTVSVAVBVCVD $.

    $( The predicate " ` P ` is a limit point of ` S ` ."  (Contributed by NM,
       10-Feb-2007.) $)
    islp $p |- ( ( J e. Top /\ S C_ X ) -> ( P e. ( ( limPt ` J ) ` S ) <->
               P e. ( ( cls ` J ) ` ( S \ { P } ) ) ) ) $=
      ( vx ctop wcel wss wa clp cfv cv csn cdif ccl cab lpval eleq2d elex elab3
      wceq id sneq difeq2d fveq2d eleq12d syl6bb ) CGHBDIJZABCKLLZHAFMZBUKNZOZC
      PLZLZHZFQZHABANZOZUNLZHZUIUJUQAFBCDERSUPVAFAAUTTUKAUBZUKAUOUTVBUCVBUMUSUN
      VBULURBUKAUDUEUFUGUAUH $.

    $( The limit points of a subset are included in the subset's closure.
       (Contributed by NM, 26-Feb-2007.) $)
    lpsscls $p |- ( ( J e. Top /\ S C_ X ) -> ( ( limPt ` J ) ` S ) C_
               ( ( cls ` J ) ` S ) ) $=
      ( vx ctop wcel wss wa clp cfv csn cdif ccl cab lpval difss clsss mp3an3
      cv sseld abssdv eqsstrd ) BFGZACHZIZABJKKETZAUGLZMZBNKZKZGZEOAUJKZEABCDPU
      FULEUMUFUKUMUGUDUEUIAHUKUMHAUHQAUIBCDRSUAUBUC $.

    $( The limit points of a subset are included in the base set.  (Contributed
       by NM, 9-Nov-2007.) $)
    lpss $p |- ( ( J e. Top /\ S C_ X ) -> ( ( limPt ` J ) ` S ) C_ X ) $=
      ( ctop wcel wss wa clp cfv ccl lpsscls clsss3 sstrd ) BEFACGHABIJJABKJJCA
      BCDLABCDMN $.

    $( ` P ` is a limit point of ` S ` iff it is a limit point of
       ` S \ { P } ` .  (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    lpdifsn $p |- ( ( J e. Top /\ S C_ X ) -> ( P e. ( ( limPt ` J ) ` S ) <->
               P e. ( ( limPt ` J ) ` ( S \ { P } ) ) ) ) $=
      ( ctop wcel wss wa clp cfv csn cdif ccl islp ssdifss sylan2 difabs fveq2i
      wb eleq2i syl6bb bitr4d ) CFGZBDHZIZABCJKZKGABALZMZCNKZKZGZAUIUGKGZABCDEO
      UFUMAUIUHMZUJKZGZULUEUDUIDHUMUPTBDUHPAUICDEOQUOUKAUNUIUJBUHRSUAUBUC $.

    $( Subset relationship for limit points.  (Contributed by Mario Carneiro,
       25-Dec-2016.) $)
    lpss3 $p |- ( ( J e. Top /\ S C_ X /\ T C_ S ) ->
      ( ( limPt ` J ) ` T ) C_ ( ( limPt ` J ) ` S ) ) $=
      ( vx ctop wcel wss w3a clp cfv cv csn cdif ccl simp1 wb islp syl2anc
      simp2 ssdifssd simp3 ssdifd clsss syl3anc sseld sstrd 3imtr4d ssrdv ) CGH
      ZADIZBAIZJZFBCKLZLZAUOLZUNFMZBURNZOZCPLZLZHZURAUSOZVALZHZURUPHZURUQHZUNVB
      VEURUNUKVDDIUTVDIVBVEIUKULUMQZUNADUSUKULUMUAZUBUNBAUSUKULUMUCZUDVDUTCDEUE
      UFUGUNUKBDIVGVCRVIUNBADVKVJUHURBCDESTUNUKULVHVFRVIVJURACDESTUIUJ $.

    $( The predicate " ` P ` is a limit point of ` S ` ," in terms of
       neighborhoods.  Definition of limit point in [Munkres] p. 97.  Although
       Munkres uses open neighborhoods, it also works for our more general
       neighborhoods.  (Contributed by NM, 26-Feb-2007.)  (Proof shortened by
       Mario Carneiro, 25-Dec-2016.) $)
    islp2 $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) ->
                ( P e. ( ( limPt ` J ) ` S ) <->
         A. n e. ( ( nei ` J ) ` { P } ) ( n i^i ( S \ { P } ) ) =/= (/) ) ) $=
      ( ctop wcel wss w3a clp cfv csn cdif ccl cv cin c0 wne wb 3adant3 ssdifss
      cnei wral islp neindisj2 syl3an2 bitrd ) DGHZBEIZAEHZJABDKLLHZABAMZNZDOLL
      HZCPUNQRSCUMDUCLLUDZUIUJULUOTUKABDEFUEUAUJUIUNEIUKUOUPTBEUMUBAUNCDEFUFUGU
      H $.

    $( The predicate " ` P ` is a limit point of ` S ` " in terms of open sets.
       see ~ islp2 , ~ elcls , ~ islp .  (Contributed by FL, 31-Jul-2009.) $)
    islp3 $p |- ( ( J e. Top /\ S C_ X /\ P e. X ) ->
     ( P e. ( ( limPt ` J ) ` S ) <->
        A. x e. J ( P e. x -> ( x i^i ( S \ { P } ) ) =/= (/) ) ) ) $=
      ( ctop wcel wss w3a clp cfv csn cdif ccl cv cin c0 wne wb wi wral 3adant3
      islp difss simp2 syl5ss elcls syld3an2 bitrd ) DGHZCEIZBEHZJZBCDKLLHZBCBM
      ZNZDOLLHZBAPZHUSUQQRSUAADUBZUKULUOURTUMBCDEFUDUCUKUQEIULUMURUTTUNUQCECUPU
      EUKULUMUFUGABUQDEFUHUIUJ $.

    $( A point is a limit point of the whole space iff the singleton of the
       point is not open.  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    maxlp $p |- ( J e. Top ->
      ( P e. ( ( limPt ` J ) ` X ) <-> ( P e. X /\ -. { P } e. J ) ) ) $=
      ( ctop wcel clp cfv wa csn wn wss cdif wb wceq snssi sylan2 adantl adantr
      bitrd ssid lpss mpan2 sseld pm4.71rd ccl simpl islp sylancl clsdif eleq2d
      cnt eldif baib ntrss2 eqssd ntropn eqeltrd snidg ad2antlr isopn3i adantlr
      eleqtrrd impbida notbid 3bitrd pm5.32da ) BEFZACBGHHZFZACFZVJIVKAJZBFZKZI
      VHVJVKVHVICAVHCCLZVICLCUAZCBCDUBUCUDUEVHVKVJVNVHVKIZVJACVLMBUFHHZFZACVLBU
      LHHZMZFZVNVQVHVOVJVSNVHVKUGVPACBCDUHUIVQVRWAAVKVHVLCLZVRWAOACPZVLBCDUJQUK
      VQWBAVTFZKZVNVKWBWFNVHWBVKWFACVTUMUNRVQWEVMVQWEVMVQWEIZVLVTBWGVLVTWEVLVTL
      VQAVTPRVQVTVLLZWEVKVHWCWHWDVLBCDUOQSUPVQVTBFZWEVKVHWCWIWDVLBCDUQQSURVQVMI
      AVLVTVKAVLFVHVMACUSUTVHVMVTVLOVKVLBVAVBVCVDVETVFVGT $.

    $( The closure of a subset of a topological space is the subset together
       with its limit points.  Theorem 6.6 of [Munkres] p. 97.  (Contributed by
       NM, 26-Feb-2007.) $)
    clslp $p |- ( ( J e. Top /\ S C_ X ) -> ( ( cls ` J ) ` S ) =
                ( S u. ( ( limPt ` J ) ` S ) ) ) $=
      ( vx vn ctop wcel wss wa ccl cfv cv cin c0 wne wi wb sylibrd ex clp wo wn
      cun csn cdif cnei wral neindisj expr adantr ineq2d neeq1d adantl ralrimdv
      difsn simpll simplr clsss3 sselda islp2 syl3anc orrd sylibr ssrdv lpsscls
      elun sscls unssd eqssd ) BGHZACIZJZABKLLZAABUALLZUDZVMEVNVPVMEMZVNHZVQVPH
      ZVMVRJZVQAHZVQVOHZUBVSVTWAWBVTWAUCZFMZAVQUEZUFZNZOPZFWEBUGLLZUHZWBVTWCWHF
      WIVTWCWDWIHZWHQVTWCJWKWDANZOPZWHVTWKWMQWCVMVRWKWMVQABWDCDUIUJUKWCWHWMRVTW
      CWGWLOWCWFAWDVQAUPULUMUNSTUOVTVKVLVQCHWBWJRVKVLVRUQVKVLVRURVMVNCVQABCDUSU
      TVQAFBCDVAVBSVCVQAVOVGVDTVEVMAVOVNABCDVHABCDVFVIVJ $.

    $( A point belonging to a set's closure but not the set itself is a limit
       point.  (Contributed by NM, 8-Nov-2007.) $)
    islpi $p |- ( ( ( J e. Top /\ S C_ X ) /\ ( P e. ( ( cls ` J ) ` S ) /\
       -. P e. S ) ) -> P e. ( ( limPt ` J ) ` S ) ) $=
      ( ctop wcel wss wa ccl cfv wn clp wi cun clslp eleq2d wo elun df-or bitri
      syl6bb biimpd imp32 ) CFGBDHIZABCJKKZGZABGZLZABCMKKZGZUEUGUIUKNZUEUGABUJO
      ZGZULUEUFUMABCDEPQUNUHUKRULABUJSUHUKTUAUBUCUD $.

    $( A subset of a topological space is closed iff it contains all its limit
       points.  Corollary 6.7 of [Munkres] p. 97.  (Contributed by NM,
       26-Feb-2007.) $)
    cldlp $p |- ( ( J e. Top /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                 ( ( limPt ` J ) ` S ) C_ S ) ) $=
      ( ctop wcel wss wa ccld cfv ccl wceq clp iscld3 cun clslp ssequn2 syl6bbr
      eqeq1d bitrd ) BEFACGHZABIJFABKJJZALZABMJJZAGZABCDNUAUCAUDOZALUEUAUBUFAAB
      CDPSUDAQRT $.

    $( Definition of a perfect space.  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    isperf $p |- ( J e. Perf <-> ( J e. Top /\ ( ( limPt ` J ) ` X ) = X ) ) $=
      ( vj cuni clp wceq ctop cperf fveq2 unieq syl6eqr fveq12d eqeq12d df-perf
      cv cfv elrab2 ) DPZEZSFQZQZTGBAFQZQZBGDAHISAGZUBUDTBUETBUAUCSAFJUETAEBSAK
      CLZMUFNDOR $.

    $( Definition of a perfect space.  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    isperf2 $p |- ( J e. Perf <->
      ( J e. Top /\ X C_ ( ( limPt ` J ) ` X ) ) ) $=
      ( cperf wcel ctop clp cfv wceq wa wss isperf wb ssid lpss mpan2 eqss baib
      syl pm5.32i bitri ) ADEAFEZBAGHHZBIZJUBBUCKZJABCLUBUDUEUBUCBKZUDUEMUBBBKU
      FBNBABCOPUDUFUEUCBQRSTUA $.

    $( A perfect space is a topology which has no open singletons.
       (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    isperf3 $p |- ( J e. Perf <->
      ( J e. Top /\ A. x e. X -. { x } e. J ) ) $=
      ( cperf wcel ctop clp cfv wss wa cv csn wn wral isperf2 dfss3 maxlp baibd
      ralbidva syl5bb pm5.32i bitri ) BEFBGFZCCBHIIZJZKUDALZMBFNZACOZKBCDPUDUFU
      IUFUGUEFZACOUDUIACUEQUDUJUHACUDUJUGCFUHUGBCDRSTUAUBUC $.

    $( The limit points of a perfect space.  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    perflp $p |- ( J e. Perf -> ( ( limPt ` J ) ` X ) = X ) $=
      ( cperf wcel ctop clp cfv wceq isperf simprbi ) ADEAFEBAGHHBIABCJK $.

    $( Property of a perfect space.  (Contributed by Mario Carneiro,
       24-Dec-2016.) $)
    perfi $p |- ( ( J e. Perf /\ P e. X ) -> -. { P } e. J ) $=
      ( vx cperf wcel cv csn wral ctop isperf3 simprbi wceq sneq eleq1d rspccva
      wn notbid sylan ) BFGZEHZIZBGZRZECJZACGAIZBGZRZUABKGUFEBCDLMUEUIEACUBANZU
      DUHUJUCUGBUBAOPSQT $.
  $}

  $( A perfect space is a topology.  (Contributed by Mario Carneiro,
     25-Dec-2016.) $)
  perftop $p |- ( J e. Perf -> J e. Top ) $=
    ( cperf wcel ctop cuni clp cfv wceq eqid isperf simplbi ) ABCADCAEZAFGGLHAL
    LIJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Subspace topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Reverse closure for the subspace topology.  (Contributed by Mario
     Carneiro, 19-Mar-2015.)  (Revised by Mario Carneiro, 1-May-2015.) $)
  restrcl $p |- ( ( J |`t A ) e. Top -> ( J e. _V /\ A e. _V ) ) $=
    ( crest co ctop wcel c0 wceq cvv wa wn 0opn n0i syl cxp wfn cdm restfn fndm
    ax-mp ndmov nsyl2 ) BACDZEFZUCGHZBIFAIFJUDGUCFUEKUCLUCGMNBAICCIIOZPCQUFHRUF
    CSTUAUB $.

  ${
    $d a b c u v w x y z A $.  $d a b c u v w x y z B $.  $d x J $.  $d x X $.
    $d w x y z V $.  $d w x y z W $.
    $( A subspace topology basis is a basis. ` Y ` is normally a subset of the
       base set of ` J ` .  (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    restbas $p |- ( B e. TopBases -> ( B |`t A ) e. TopBases ) $=
      ( vc vw va vb vu vv vz ctb wcel cvv crest wa cv cin wss wrex wceq c0 wral
      elrest anbi12d reeanv syl6bbr simplll simplrl simplrr inss1 sseldi basis2
      co simpr syl22anc simpld simprd simprl elrestr syl3anc simprrl inss2 elin
      simplr sylanbrc ssrin syl eleq2 sseq1 rspcev syl12anc rexlimddv ralrimiva
      simprrr ineq12 inindir syl6eqr sseq2d anbi2d rexbidv raleqbidv syl5ibrcom
      rexlimdvva sylbid ralrimivv wb ovex isbasis2g ax-mp sylibr cdm wrel relxp
      cxp wfn restfn fndm releqi mpbir ovprc2 adantl cfi cfv fi0 fibas eqeltrri
      wn syl6eqel pm2.61dan ) BJKZALKZBAMULZJKZXIXJNZCOZDOZKZXOEOZFOZPZQZNZDXKR
      ZCXSUAZFXKUAEXKUAZXLXMYCEFXKXKXMXQXKKZXRXKKZNZXQGOZAPZSZXRHOZAPZSZNZHBRGB
      RZYCXMYGYJGBRZYMHBRZNYOXMYEYPYFYQGXQABJLUBHXRABJLUBUCYJYMGHBBUDUEXMYNYCGH
      BBXMYHBKZYKBKZNZNZYCYNXPXOYHYKPZAPZQZNZDXKRZCUUCUAUUAUUFCUUCUUAXNUUCKZNZX
      NIOZKZUUIUUBQZNZUUFIBUUHXIYRYSXNUUBKUULIBRXIXJYTUUGUFXMYRYSUUGUGXMYRYSUUG
      UHUUHUUCUUBXNUUBAUIUUAUUGUMUJIXNBYHYKUKUNUUHUUIBKZUULNZNZUUIAPZXKKZXNUUPK
      ZUUPUUCQZUUFUUOXIXJUUMUUQUUOXIXJXMYTUUGUUNUFZUOUUOXIXJUUTUPUUHUUMUULUQUUI
      ABJLURUSUUOUUJXNAKUURUUHUUMUUJUUKUTUUOUUCAXNUUBAVAUUAUUGUUNVCUJXNUUIAVBVD
      UUOUUKUUSUUHUUMUUJUUKVMUUIUUBAVEVFUUEUURUUSNDUUPXKXOUUPSXPUURUUDUUSXOUUPX
      NVGXOUUPUUCVHUCVIVJVKVLYNYBUUFCXSUUCYNXSYIYLPUUCXQYIXRYLVNYHYKAVOVPZYNYAU
      UEDXKYNXTUUDXPYNXSUUCXOUVAVQVRVSVTWAWBWCWDXKLKXLYDWEBAMWFEFCDXKLWGWHWIXIX
      JXFZNXKTJUVBXKTSXIBAMMWJZWKLLWMZWKLLWLUVCUVDMUVDWNUVCUVDSWOUVDMWPWHWQWRWS
      WTTXAXBTJXCTXDXEXGXH $.

    $( A subspace can be generated by restricted sets from a basis for the
       original topology.  (Contributed by Mario Carneiro, 19-Mar-2015.)
       (Proof shortened by Mario Carneiro, 30-Aug-2015.) $)
    tgrest $p |- ( ( B e. V /\ A e. W ) ->
      ( topGen ` ( B |`t A ) ) = ( ( topGen ` B ) |`t A ) ) $=
      ( vx vy vz vw wcel wa crest ctg cv wss cuni wceq wex cvv cin crn cfv ovex
      co wb eltg3 ax-mp cmpt cima wfun simpll funmpt restval sseq2d biimpa wral
      a1i wfn inex1 rgenw eqid fnmpt fnima mp2b syl6sseqr ssimaexg syl3anc ciun
      vex wi cres df-ima resmpt adantl rneqd syl5eq unieqd dfiun3 iunin1 syl6eq
      syl6eqr fvex simpr adantr uniiun eltg3i syl5eqelr adantlr elrestr eqeltrd
      unieq eleq1d syl5ibrcom expimpd exlimdv mpd eleq1 syl5bi ssrdv sylancr wf
      ineq1i eqtr4i simplll simpllr sselda fmptd frn syl syl5eqel ineq1 eqsstrd
      sylbid imp eqssd ) BCIZADIZJZBAKUCZLUAZBLUAZAKUCZXQEXSYAEMZXSIZFMZXRNZYBY
      DOZPZJZFQZXQYBYAIZXRRIZYCYIUDBAKUBZFYBXRRUEUFXQYHYJFXQYEYGYJXQYEJZYJYGYFY
      AIZYMGMZBNZYDEBYBASZUGZYOUHZPZJZGQZYNYMXOYRUIZYDYRBUHZNUUBXOXPYEUJUUCYMEB
      YQUKUPYMYDYRTZUUDXQYEYDUUENXQXRUUEYDEABCDULUMUNYQRIZEBUOYRBUQUUDUUEPUUFEB
      YBAEVHURZUSEBYQYRRYRUTVABYRVBVCVDGBYDCYRVEVFXQUUBYNVIYEXQUUAYNGXQYPYTYNXQ
      YPJZYNYTYSOZYAIUUHUUIEYOYBVGZASZYAUUHUUIEYOYQVGZUUKUUHUUIEYOYQUGZTZOZUULU
      UHYSUUNUUHYSYRYOVJZTUUNYRYOVKUUHUUPUUMYPUUPUUMPXQEBYOYQVLVMVNVOVPEYOYQUUG
      VQZVTEYOAYBVRZVSUUHXTRIZXPUUJXTIZUUKYAIUUSUUHBLWAZUPXQXPYPXOXPWBZWCXOYPUU
      TXPXOYPJUUJYOOZXTEYOWDZYOBCWEWFWGUUJAXTRDWHVFWIYTYFUUIYAYDYSWJWKWLWMWNWCW
      OYBYFYAWPWLWMWNWQWRXQYAHXTHMZASZUGZTZXSXQUUSXPYAUVHPUVAUVBHAXTRDULWSXQXTX
      SUVGWTUVHXSNXQHXTUVFXSUVGXQUVEXTIZUVFXSIZXQUVIYPUVEUVCPZJZGQZUVJXOUVIUVMU
      DXPGUVEBCUEWCXQUVLUVJGXQYPUVKUVJUUHUVJUVKUVCASZXSIUUHUVNUULXSUVNUUKUULUVC
      UUJAUVDXAUURXBUUHUULUUOXSUUQUUHYKUUNXRNZUUOXSIYLUUHYOXRUUMWTUVOUUHEYOYQXR
      UUMUUHYBYOIZJXOXPYBBIYQXRIXOXPYPUVPXCXOXPYPUVPXDUUHYOBYBXQYPWBXEYBABCDWHV
      FUUMUTXFYOXRUUMXGXHUUNXRRWEWSXIXIUVKUVFUVNXSUVEUVCAXJWKWLWMWNXLXMUVGUTXFX
      TXSUVGXGXHXKXN $.

    $( A subspace topology is a topology.  Definition of subspace topology in
       [Munkres] p. 89. ` A ` is normally a subset of the base set of ` J ` .
       (Contributed by FL, 15-Apr-2007.)  (Revised by Mario Carneiro,
       1-May-2015.) $)
    resttop $p |- ( ( J e. Top /\ A e. V ) -> ( J |`t A ) e. Top ) $=
      ( ctop wcel wa crest co ctg cfv tgrest wceq tgtop adantr oveq1d eqtrd ctb
      topbas restbas tgcl 3syl eqeltrrd ) BDEZACEZFZBAGHZIJZUFDUEUGBIJZAGHUFABD
      CKUEUHBAGUCUHBLUDBMNOPUEBQEZUFQEUGDEUCUIUDBRNABSUFTUAUB $.

    $( A subspace topology is a topology on the base set.  (Contributed by
       Mario Carneiro, 13-Aug-2015.) $)
    resttopon $p |- ( ( J e. ( TopOn ` X ) /\ A C_ X ) ->
        ( J |`t A ) e. ( TopOn ` A ) ) $=
      ( vx ctopon cfv wcel wss wa crest co ctop cuni wceq topontop adantr sylib
      cvv cin syl id toponmax ssexg syl2anr resttop syl2anc simpr dfss1 elrestr
      simpl syl3anc eqeltrrd elssuni cpw cv cmpt crn restval syldan inss2 inex1
      vex elpw mpbir a1i eqid fmptd frn eqsstrd sspwuni eqssd istopon sylanbrc
      wf ) BCEFZGZACHZIZBAJKZLGZAVSMZNVSAEFGVRBLGZARGZVTVPWBVQCBOPVQVQCBGZWCVPV
      QUACBUBZACBUCUDZABRUEUFVRAWAVRAVSGAWAHVRCASZAVSVRVQWGANVPVQUGACUHQVRVPWCW
      DWGVSGVPVQUJWFVPWDVQWEPCABVORUIUKULAVSUMTVRVSAUNZHWAAHVRVSDBDUOZASZUPZUQZ
      WHVPVQWCVSWLNWFDABVORURUSVRBWHWKVNWLWHHVRDBWJWHWKWJWHGZVRWIBGIWMWJAHWIAUT
      WJAWIADVBVAVCVDVEWKVFVGBWHWKVHTVIVSAVJQVKAVSVLVM $.

    restuni.1 $e |- X = U. J $.
    $( The underlying set of a subspace topology.  (Contributed by FL,
       5-Jan-2009.)  (Revised by Mario Carneiro, 13-Aug-2015.) $)
    restuni $p |- ( ( J e. Top /\ A C_ X ) -> A = U. ( J |`t A ) ) $=
      ( ctop wcel wss wa crest ctopon cfv cuni wceq toptopon resttopon toponuni
      co sylanb syl ) BEFZACGZHBAIQZAJKFZAUBLMTBCJKFUAUCBCDNABCORAUBPS $.

    $( The topological space built with a subspace topology.  (Contributed by
       FL, 5-Jan-2009.)  (Proof shortened by Mario Carneiro, 1-May-2015.) $)
    stoig $p |- ( ( J e. Top /\ A C_ X ) ->
     { <. ( Base ` ndx ) , A >. ,
         <. ( TopSet ` ndx ) , ( J |`t A ) >. } e. TopSp ) $=
      ( ctop wcel wss wa crest co ctopon cfv cnx cbs cop cts cpr ctps resttopon
      toptopon sylanb eqid eltpsg syl ) BEFZACGZHBAIJZAKLFZMNLAOMPLUGOQZRFUEBCK
      LFUFUHBCDTABCSUAAUGUIUIUBUCUD $.
  $}

  ${
    $d w x y z A $.  $d x y z B $.  $d w x y z J $.
    $( Composition of subspaces.  (Contributed by Mario Carneiro,
       15-Dec-2013.)  (Revised by Mario Carneiro, 1-May-2015.) $)
    restco $p |- ( ( J e. V /\ A e. W /\ B e. X ) ->
                     ( ( J |`t A ) |`t B ) = ( J |`t ( A i^i B ) ) ) $=
      ( vx vy vz vw wcel cv cin cmpt crn crest co wceq wrex cvv w3a inex1 ineq1
      cab inass syl6eq abrexco eqid rnmpt mpteq1 3eqtr4i restval 3adant3 oveq1d
      ax-mp ovex syl6eqelr simp3 syl2anc eqtrd simp1 inex1g 3ad2ant2 3eqtr4a
      vex ) CDKZAEKZBFKZUAZGHCHLZAMZNZOZGLZBMZNZOZHCVJABMZMZNZOZCAPQZBPQZCVRPQZ
      ILZVORGJLVKRHCSJUDZSIUDWEVSRHCSIUDVQWAIGJHCVKVOVSVJAHVEUBVNVKRVOVKBMVSVNV
      KBUCVJABUEUFUGGIWFVOVPVMWFRVPGWFVONRHJCVKVLVLUHUIGVMWFVOUJUOUIHICVSVTVTUH
      UIUKVIWCVMBPQZVQVIWBVMBPVFVGWBVMRVHHACDEULUMZUNVIVMTKVHWGVQRVIVMWBTWHCAPU
      PUQVFVGVHURGBVMTFULUSUTVIVFVRTKZWDWARVFVGVHVAVGVFWIVHABEVBVCHVRCDTULUSVD
      $.
  $}

  $( Equivalence of being a subspace of a subspace and being a subspace of the
     original.  (Contributed by Jeff Hankins, 11-Jul-2009.)  (Proof shortened
     by Mario Carneiro, 1-May-2015.) $)
  restabs $p |- ( ( J e. V /\ S C_ T /\ T e. W ) ->
                  ( ( J |`t T ) |`t S ) = ( J |`t S ) ) $=
    ( wcel wss w3a crest co cin cvv wceq simp1 simp3 ssexg 3adant1 restco simp2
    syl3anc dfss1 sylib oveq2d eqtrd ) CDFZABGZBEFZHZCBIJAIJZCBAKZIJZCAIJUHUEUG
    ALFZUIUKMUEUFUGNUEUFUGOUFUGULUEABEPQBACDELRTUHUJACIUHUFUJAMUEUFUGSABUAUBUCU
    D $.

  ${
    restin.1 $e |- X = U. J $.
    $( When the subspace region is not a subset of the base of the topology,
       the resulting set is the same as the subspace restricted to the base.
       (Contributed by Mario Carneiro, 15-Dec-2013.) $)
    restin $p |- ( ( J e. V /\ A e. W ) ->
      ( J |`t A ) = ( J |`t ( A i^i X ) ) ) $=
      ( wcel wa crest co cin cvv wceq cuni uniexg syl5eqel adantr restco 3com23
      mpd3an3 restid oveq1d incom oveq2i a1i 3eqtr3d ) BCGZADGZHZBEIJZAIJZBEAKZ
      IJZBAIJBAEKZIJZUGUHELGZUKUMMZUGUPUHUGEBNLFBCOPQUGUPUHUQEABCLDRSTUIUJBAIUG
      UJBMUHBCEFUAQUBUMUOMUIULUNBIEAUCUDUEUF $.

    $( The underlying set of a subspace topology.  (Contributed by Mario
       Carneiro, 21-Mar-2015.) $)
    restuni2 $p |- ( ( J e. Top /\ A e. V ) ->
                   ( A i^i X ) = U. ( J |`t A ) ) $=
      ( ctop wcel wa cin crest cuni wss wceq simpl inss2 restuni sylancl restin
      co unieqd eqtr4d ) BFGZACGZHZADIZBUEJSZKZBAJSZKUDUBUEDLUEUGMUBUCNADOUEBDE
      PQUDUHUFABFCDERTUA $.
  $}

  $( The underlying set of a subspace topology.  (Contributed by Mario
     Carneiro, 13-Aug-2015.) $)
  resttopon2 $p |- ( ( J e. ( TopOn ` X ) /\ A e. V ) ->
                 ( J |`t A ) e. ( TopOn ` ( A i^i X ) ) ) $=
    ( ctopon cfv wcel wa crest co ctop cin cuni topontop resttop sylan toponuni
    wceq ineq2d adantr eqid restuni2 eqtrd istopon sylanbrc ) BDEFGZACGZHZBAIJZ
    KGZADLZUIMZRUIUKEFGUFBKGZUGUJDBNZABCOPUHUKABMZLZULUFUKUPRUGUFDUOADBQSTUFUMU
    GUPULRUNABCUOUOUAUBPUCUKUIUDUE $.

  ${
    $d x J $.
    $( The subspace topology induced by the topology ` J ` on the empty set.
       (Contributed by FL, 22-Dec-2008.)  (Revised by Mario Carneiro,
       1-May-2015.) $)
    rest0 $p |- ( J e. Top -> ( J |`t (/) ) = { (/) } ) $=
      ( vx ctop wcel c0 crest co csn cv cin cmpt crn cvv wceq 0ex restval mpan2
      wf wss syl in0 elsnc2 mpbir a1i eqid fmptd frn eqsstrd resttop 0opn snssd
      wa eqssd ) ACDZAEFGZEHZUNUOBABIZEJZKZLZUPUNEMDZUOUTNOBEACMPQUNAUPUSRUTUPS
      UNBAURUPUSURUPDZUNUQADULVBURENUQUAUREOUBUCUDUSUEUFAUPUSUGTUHUNEUOUNUOCDZE
      UODUNVAVCOEAMUIQUOUJTUKUM $.
  $}

  ${
    $d A x y $.  $d V x $.
    $( The only subspace topology induced by the topology ` { (/) } ` .
       (Contributed by FL, 5-Jan-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.) $)
    restsn $p |- ( A e. V -> ( { (/) } |`t A ) = { (/) } ) $=
      ( vx vy wcel c0 csn crest co cv cin wceq wrex ctop sn0top elrest mpan 0ex
      wb ineq1 incom in0 eqtri syl6eq eqeq2d rexsn elsn bitr4i syl6bb eqrdv ) A
      BEZCFGZAHIZULUKCJZUMEZUNDJZAKZLZDULMZUNULEZULNEUKUOUSSODUNAULNBPQUSUNFLZU
      TURVADFRUPFLZUQFUNVBUQFAKZFUPFATVCAFKFFAUAAUBUCUDUEUFCFUGUHUIUJ $.
  $}

  ${
    $( The subspace topology induced by a singleton.  (Contributed by FL,
       5-Jan-2009.)  (Revised by Mario Carneiro, 16-Sep-2015.) $)
    restsn2 $p |- ( ( J e. ( TopOn ` X ) /\ A e. X ) ->
      ( J |`t { A } ) = ~P { A } ) $=
      ( ctopon cfv wcel wa csn crest co cpw wceq wss snssi resttopon sylan2 syl
      topsn ) BCDEFZACFZGBAHZIJZUADEFZUBUAKLTSUACMUCACNUABCOPAUBRQ $.
  $}

  ${
    $d o x A $.  $d o x J $.  $d o x S $.  $d o x X $.
    restcld.1 $e |- X = U. J $.
    $( A closed set of a subspace topology is a closed set of the original
       topology intersected with the subset.  (Contributed by FL,
       11-Jul-2009.)  (Proof shortened by Mario Carneiro, 15-Dec-2013.) $)
    restcld $p |- ( ( J e. Top /\ S C_ X ) ->
                   ( A e. ( Clsd ` ( J |`t S ) ) <->
                     E. x e. ( Clsd ` J ) A = ( x i^i S ) ) ) $=
      ( vo ctop wcel wss wa ccld cdif cin wceq cvv adantr cun c0 adantl co cuni
      crest cfv cv wrex wb id topopn ssexg syl2anr resttop syldan iscld restuni
      eqid syl sseq2d difeq1d eleq1d anbi12d elrest anbi2d opncld adantlr incom
      df-ss biimpi syl5eq ad4antlr difeq2 difindi difid uneq2i un0 3eqtri dfss4
      syl6eq ad3antlr 3eqtr2rd difeq1i indif2 3eqtr2i ineq1 eqeq2d ex rexlimdva
      rspcev syl2anc expimpd sylbid difin2 simpll elrestr syl3anc eqeltrd inss2
      cldopn jctil sseq1 syl5ibrcom impbid 3bitr2d ) DHIZCEJZKZBDCUCUAZLUDIZBXG
      UBZJZXIBMZXGIZKZBCJZCBMZXGIZKZBAUEZCNZOZADLUDZUFZXFXGHIZXHXMUGXDXECPIZYCX
      EXEEDIYDXDXEUHDEFUICEDUJUKZCDPULUMBXGXIXIUPUNUQXFXNXJXPXLXFCXIBCDEFUOZURX
      FXOXKXGXFCXIBYFUSUTVAXFXQYBXFXQXNXOGUEZCNZOZGDUFZKYBXFXPYJXNXDXEYDXPYJUGY
      EGXOCDHPVBUMVCXFXNYJYBXFXNKZYIYBGDYKYGDIZKZYIYBYMYIKZEYGMZYAIZBYOCNZOZYBY
      MYPYIXFYLYPXNXDYLYPXEYGDEFVDVEVEQYNBECNZYGMZYQYNYTCYGMZCXOMZBYNYSCYGXEYSC
      OXDXNYLYIXEYSCENZCECVFZXEUUCCOCEVGVHVIVJUSYIUUBUUAOYMYIUUBCYHMZUUAXOYHCVK
      UUEUUACCMZRUUASRUUACYGCVLUUFSUUACVMZVNUUAVOVPVRTXNUUBBOZXFYLYIXNUUHBCVQVH
      VSVTYTUUCYGMCYONYQYSUUCYGUUDWACEYGWBCYOVFWCVRXTYRAYOYAXRYOOXSYQBXRYOCWDWE
      WHWIWFWGWJWKXFXTXQAYAXFXRYAIZKZXQXTXSCJZCXSMZXGIZKUUJUUMUUKUUJUULEXRMZCNZ
      XGXFUULUUOOUUIXFUULCXRMZUUOUULUUPUUFRUUPSRUUPCXRCVLUUFSUUPUUGVNUUPVOVPXEU
      UPUUOOXDCXREWLTVIQUUJXDYDUUNDIZUUOXGIXDXEUUIWMXFYDUUIYEQUUIUUQXFXRDEFWRTU
      UNCDHPWNWOWPXRCWQWSXTXNUUKXPUUMBXSCWTXTXOUULXGBXSCVKUTVAXAWGXBXC $.
  $}

  ${
    $d J v $.  $d X v $.  $d A v $.  $d B v $.
    restcldi.1 $e |- X = U. J $.
    $( A closed set is closed in the subspace topology.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    restcldi $p |- ( ( A C_ X /\ B e. ( Clsd ` J ) /\ B C_ A ) ->
      B e. ( Clsd ` ( J |`t A ) ) ) $=
      ( vv wss ccld cfv wcel w3a crest co cv cin wceq wrex simp2 dfss syl2anc
      biimpi 3ad2ant3 ineq1 eqeq2d rspcev ctop wb cldrcl 3ad2ant2 simp1 restcld
      mpbird ) ADGZBCHIZJZBAGZKZBCALMHIJZBFNZAOZPZFUNQZUQUOBBAOZPZVBUMUOUPRUPUM
      VDUOUPVDBASUAUBVAVDFBUNUSBPUTVCBUSBAUCUDUETUQCUFJZUMURVBUGUOUMVEUPBCUHUIU
      MUOUPUJFBACDEUKTUL $.
  $}

  ${
    $d v x y A $.  $d v B $.  $d v x y J $.  $d x y K $.  $d v x V $.
    $d v C $.
    $( A set which is closed in the subspace topology induced by a closed set
       is closed in the original topology.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    restcldr $p |- ( ( A e. ( Clsd ` J ) /\ B e. ( Clsd ` ( J |`t A ) ) ) ->
      B e. ( Clsd ` J ) ) $=
      ( vv ccld cfv wcel crest co cv cin wceq wrex ctop cuni wss wb cldrcl eqid
      cldss restcld syl2anc incld ancoms eleq1 syl5ibrcom rexlimdva sylbid imp
      wa ) ACEFZGZBCAHIEFGZBUKGZULUMBDJZAKZLZDUKMZUNULCNGACOZPUMURQACRACUSUSSZT
      DBACUSUTUAUBULUQUNDUKULUOUKGZUJUNUQUPUKGZVAULVBUOACUCUDBUPUKUEUFUGUHUI $.

    $( If ` B ` is an open subset of the subspace base set ` A ` , then any
       subset of ` B ` is open iff it is open in ` A ` .  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    restopnb $p |- ( ( ( J e. Top /\ A e. V ) /\ ( B e. J /\ B C_ A /\
        C C_ B ) ) -> ( C e. J <-> C e. ( J |`t A ) ) ) $=
      ( vv ctop wcel wa wss w3a cv cin wceq wrex crest co df-ss sylib adantrr
      wi simpr3 simpr2 sstrd eqcomd ineq1 eqeq2d rspcev expcom syl inass simprr
      ineq1d simplr3 eqtr3d simplr2 dfss1 ineq2d 3eqtr3a simplll simprl simplr1
      inopn syl3anc eqeltrd rexlimdvaa impbid wb elrest adantr bitr4d ) DGHZAEH
      ZIZBDHZBAJZCBJZKZIZCDHZCFLZAMZNZFDOZCDAPQHZVSVTWDVSCCAMZNZVTWDUAVSWFCVSCA
      JWFCNVSCBAVNVOVPVQUBVNVOVPVQUCUDCARSUEVTWGWDWCWGFCDWACNWBWFCWACAUFUGUHUIU
      JVSWCVTFDVSWADHZWCIZIZCWABMZDWJWBBMZWAABMZMZCWKWAABUKWJCBMZWLCWJCWBBVSWHW
      CULUMVSWHWOCNZWCVSWHIZVQWPVOVPVQVNWHUNCBRSTUOVSWHWNWKNWCWQWMBWAWQVPWMBNVO
      VPVQVNWHUPBAUQSURTUSWJVLWHVOWKDHVLVMVRWIUTVSWHWCVAVOVPVQVNWIVBWABDVCVDVEV
      FVGVNWEWDVHVRFCADGEVIVJVK $.

    $( If ` K ` is a finer topology than ` J ` , then the subspace topologies
       induced by ` A ` maintain this relationship.  (Contributed by Mario
       Carneiro, 21-Mar-2015.)  (Revised by Mario Carneiro, 1-May-2015.) $)
    ssrest $p |- ( ( K e. V /\ J C_ K ) -> ( J |`t A ) C_ ( K |`t A ) ) $=
      ( vx vy wcel wss wa crest co cv simpr cin wceq wrex wi cvv wb elrest fndm
      ssrexv ad2antlr c0 n0i cxp wfn cdm restfn ax-mp ndmov nsyl2 adantl simpll
      syl simprd syl2anc 3imtr4d mpd ex ssrdv ) CDGZBCHZIZEBAJKZCAJKZVDELZVEGZV
      GVFGZVDVHIZVHVIVDVHMVJVGFLANOZFBPZVKFCPZVHVIVCVLVMQVBVHVKFBCUBUCVJBRGZARG
      ZIZVHVLSVHVPVDVHVEUDOVPVEVGUEBARJJRRUFZUGJUHVQOUIVQJUAUJUKULUMZFVGABRRTUO
      VJVBVOVIVMSVBVCVHUNVJVNVOVRUPFVGACDRTUQURUSUTVA $.
  $}

  $( The if ` A ` is open, then ` B ` is open in ` A ` iff it is an open subset
     of ` A ` .  (Contributed by Mario Carneiro, 2-Mar-2015.) $)
  restopn2 $p |- ( ( J e. Top /\ A e. J ) ->
    ( B e. ( J |`t A ) <-> ( B e. J /\ B C_ A ) ) ) $=
    ( ctop wcel wa crest co wss cuni elssuni wceq restuni sylan2 sseq2d syl5ibr
    eqid pm4.71rd wb simpll simplr ssid simpr restopnb syl23anc pm5.32da bitr4d
    a1i ancom syl6bb ) CDEZACEZFZBCAGHZEZBAIZBCEZFZUQUPFUMUOUPUOFURUMUOUPUOUPUM
    BUNJZIBUNKUMAUSBULUKACJZIAUSLACKACUTUTQMNOPRUMUPUQUOUMUPFZUKULULAAIZUPUQUOS
    UKULUPTUKULUPUAZVCVBVAAUBUHUMUPUCAABCCUDUEUFUGUPUQUIUJ $.

  ${
    $d x A $.  $d x B $.  $d x V $.
    $( A subspace of a discrete topology is discrete.  (Contributed by Mario
       Carneiro, 19-Mar-2015.) $)
    restdis $p |- ( ( A e. V /\ B C_ A ) -> ( ~P A |`t B ) = ~P B ) $=
      ( vx wcel wss wa cpw crest co cv wb distop adantr elpw2g biimpar restopn2
      ctop syl2anc elpw vex wi sstr expcom adantl syl6ibr pm4.71rd syl5bb eqrdv
      bitr4d ) ACEZBAFZGZDAHZBIJZBHZUMDKZUOEZUQUNEZUQBFZGZUQUPEZUMUNREZBUNEZURV
      ALUKVCULACMNUKVDULBACOPBUQUNQSVBUTUMVAUQBDUAZTUMUTUSUMUTUQAFZUSULUTVFUBUK
      UTULVFUQBAUCUDUEUQAVETUFUGUHUJUI $.

    $( The restriction of the set of finite subsets of ` A ` is the set of
       finite subsets of ` B ` .  (Contributed by Mario Carneiro,
       18-Sep-2015.) $)
    restfpw $p |- ( ( A e. V /\ B C_ A ) ->
      ( ( ~P A i^i Fin ) |`t B ) = ( ~P B i^i Fin ) ) $=
      ( vx wcel wss wa cpw cfn cin crest co cvv adantr syl elfpw simprbi adantl
      wceq sylanbrc cv cmpt crn pwexg inex1g ssexg ancoms restval syl2anc inss2
      wf a1i inss1 ssfi sylancl eqid fmptd frn eqsstrd df-ss sylib simplr sstrd
      simplbi elrestr syl3anc eqeltrrd ex ssrdv eqssd ) ACEZBAFZGZAHZIJZBKLZBHI
      JZVMVPDVODUAZBJZUBZUCZVQVMVOMEZBMEZVPWASVMVNMEZWBVKWDVLACUDNVNIMUEOZVLVKW
      CBACUFUGZDBVOMMUHUIVMVOVQVTUKWAVQFVMDVOVSVQVTVMVRVOEZGZVSBFZVSIEZVSVQEWIW
      HVRBUJULWHVRIEZVSVRFWJWGWKVMWGVRAFZWKVRAPZQRVRBUMVRVSUNUOVSBPTVTUPUQVOVQV
      TUROUSVMDVQVPVMVRVQEZVRVPEVMWNGZVSVRVPWOVRBFZVSVRSWNWPVMWNWPWKVRBPZVDRZVR
      BUTVAWOWBWCWGVSVPEVMWBWNWENVMWCWNWFNWOWLWKWGWOVRBAWRVKVLWNVBVCWNWKVMWNWPW
      KWQQRWMTVRBVOMMVEVFVGVHVIVJ $.
  $}

  ${
    $d a b c d e A $.  $d a b c d e B $.  $d a b c d e J $.  $d a b c d e X $.
    neitr.1 $e |- X = U. J $.
    $( The neighborhood of a trace is the trace of the neighborhood.
       (Contributed by Thierry Arnoux, 17-Jan-2018.) $)
    neitr $p |- ( ( J e. Top /\ A C_ X /\ B C_ A ) ->
      ( ( nei ` ( J |`t A ) ) ` B ) = ( ( ( nei ` J ) ` B ) |`t A ) ) $=
      ( vd va vb ve ctop wcel wss cv wa wrex cin wceq syl2anc syl cvv w3a crest
      vc cnei cfv cuni wex nfv nfre1 nfan simpl anim2i cdif simp-5r simp1 simp2
      cun restuni ad5antr sseqtr4d sstrd simplr eltopss ssdifssd unssd 3anassrs
      simpr1l simpr sseqtrd inss1 syl6ss inundif eqsstr3d unss1 syl5eqssr sseq2
      co simpr1r sseq1 anbi12d rspcev syl12anc c0 indir incom eqtr3i uneq2i un0
      disjdif 3eqtri df-ss biimpi syl5req vex difexg ax-mp anbi2d rexbidv ineq1
      unex eqeq2d spcev syl21anc ad3antrrr uniexg syl5eqel ssexd elrest r19.29a
      biimpa sylanl1 simprr r19.29af inss2 mpbiri adantl exlimiv adantr ad4antr
      elrestr syl3anc simprl simp3 ssind ssrin simp-4r jca32 reximdva impr expl
      ex an32s exlimdv imp rexlimivw jca impbida wb eqid isnei resttop cmpt crn
      fvex restval sylancr eleq2d df-rex bitri anbi1d exbidv syl5bb bitrd eqrdv
      elrnmpt 3bitr4d ) CJKZADLZBALZUAZUCBCAUBVQZUDUEUEZBCUDUEZUEZAUBVQZUUTUCMZ
      UVAUFZLZBFMZLZUVIUVFLZNZFUVAOZNZGMZDLZBHMZLZUVQUVOLZNZHCOZNZUVFUVOAPZQZNZ
      GUGZUVFUVBKZUVFUVEKZUUTUVNUWFUUTUVNNZUVLUWFFUVAUUTUVNFUUTFUHUVHUVMFUVHFUH
      UVLFUVAUIUJUJUWIUUTUVHNZUVIUVAKZUVLUWFUVNUVHUUTUVHUVMUKULUWJUWKNZUVLNZUVI
      IMZAPZQZUWFICUWMUWNCKZNZUWPNZUVFUWNAUMZUQZDLZUVRUVQUXALZNZHCOZUVFUXAAPZQZ
      UWFUWSUVFUWTDUWSUVFADUWSUVFUVGAUUTUVHUWKUVLUWQUWPUNUUTAUVGQZUVHUWKUVLUWQU
      WPUUTUUQUURUXHUUQUURUUSUOZUUQUURUUSUPZACDEURRZUSUTZUUTUURUVHUWKUVLUWQUWPU
      XJUSVAUWSUWNDAUWSUUQUWQUWNDLUUTUUQUVHUWKUVLUWQUWPUXIUSUWMUWQUWPVBZUWNCDEV
      CRVDVEUWSUWQBUWNLZUWNUXALZUXEUXMUWSBUWOUWNUWSBUVIUWOUWLUVLUWQUWPUVJUVJUVK
      UWQUWPUWLVGVFUWRUWPVHZVIUWNAVJVKUWSUWNUWOUWTUQZUXAUWNAVLUWSUWOUVFLUXQUXAL
      UWSUWOUVIUVFUXPUWLUVLUWQUWPUVKUVJUVKUWQUWPUWLVRVFVMUWOUVFUWTVNSVOUXDUXNUX
      ONHUWNCUVQUWNQUVRUXNUXCUXOUVQUWNBVPUVQUWNUXAVSVTWAWBUWSUVFALZUXGUXLUXRUXF
      UVFAPZUVFUXFUXSUWTAPZUQUXSWCUQUXSUVFUWTAWDUXTWCUXSAUWTPUXTWCAUWTWEAUWNWIW
      FWGUXSWHWJUXRUXSUVFQUVFAWKWLWMSUWEUXBUXENZUXGNGUXAUVFUWTUCWNZUWNTKUWTTKIW
      NUWNATWOWPWTUVOUXAQZUWBUYAUWDUXGUYCUVPUXBUWAUXEUVOUXADVSUYCUVTUXDHCUYCUVS
      UXCUVRUVOUXAUVQVPWQWRVTUYCUWCUXFUVFUVOUXAAWSXAVTXBXCUWMUUQATKZUWKUWPICOZU
      UTUUQUVHUWKUVLUXIXDUUTUYDUVHUWKUVLUUTADTUUTDCUFZTEUUTUUQUYFTKUXICJXESXFUX
      JXGZXDUWJUWKUVLVBUUQUYDNUWKUYEIUVIACJTXHXJXCXIXKUUTUVHUVMXLXMUUTUWFNZUVHU
      VMUYHUVFAUVGUWFUXRUUTUWEUXRGUWDUXRUWBUWDUXRUWCALUVOAXNUVFUWCAVSXOXPXQXPUU
      TUXHUWFUXKXRVIUYHUVQAPZUVAKZBUYILZUYIUVFLZNZNZHCOZUVMUUTUWFUYOUUTUWEUYOGU
      UTUWBUWDUYOUUTUWDUWBUYOUUTUWDNZUVPUWAUYOUYPUVPNZUVTUYNHCUYQUVQCKZNZUVTUYN
      UYSUVTNZUYJUYKUYLUYTUUQUYDUYRUYJUUTUUQUWDUVPUYRUVTUXIXSUUTUYDUWDUVPUYRUVT
      UYGXSUYQUYRUVTVBUVQACJTXTYAUYTBUVQAUYSUVRUVSYBUUTUUSUWDUVPUYRUVTUUQUURUUS
      YCZXSYDUYTUYIUWCUVFUYTUVSUYIUWCLUYSUVRUVSXLUVQUVOAYESUUTUWDUVPUYRUVTYFUTY
      GYKYHYIYLYJYMYNUYNUVMHCUVLUYMFUYIUVAUVIUYIQUVJUYKUVKUYLUVIUYIBVPUVIUYIUVF
      VSVTWAYOSYPYQUUTUVAJKZBUVGLUWGUVNYRUUTUUQUYDVUBUXIUYGACTUUARUUTBAUVGVUAUX
      KVIBFUVAUVFUVGUVGYSYTRUUTUWHUVFGUVDUWCUUBZUUCZKZUWFUUTUVEVUDUVFUUTUVDTKUY
      DUVEVUDQBUVCUUDUYGGAUVDTTUUEUUFUUGUUTUUQBDLZVUEUWFYRUXIUUTBADVUAUXJVAVUEU
      VOUVDKZUWDNZGUGZUUQVUFNZUWFVUEUWDGUVDOZVUIUVFTKVUEVUKYRUYBGUVDUWCUVFVUCTV
      UCYSUUOWPUWDGUVDUUHUUIVUJVUHUWEGVUJVUGUWBUWDBHCUVODEYTUUJUUKUULRUUMUUPUUN
      $.
  $}

  ${
    $d o x J $.  $d o x K $.  $d o x S $.  $d o x X $.  $d o x Y $.
    restcls.1 $e |- X = U. J $.
    restcls.2 $e |- K = ( J |`t Y ) $.
    $( A closure in a subspace topology.  (Contributed by Jeff Hankins,
       22-Jan-2010.)  (Revised by Mario Carneiro, 15-Dec-2013.) $)
    restcls $p |- ( ( J e. Top /\ Y C_ X /\ S C_ Y ) ->
      ( ( cls ` K ) ` S ) = ( ( ( cls ` J ) ` S ) i^i Y ) ) $=
      ( vx ctop wcel wss ccl cfv cin ccld wceq syl2anc eqid 3adant3 wa w3a wrex
      simp1 sstr ancoms 3adant1 clscld ineq1 eqeq2d rspcev sylancl crest fveq2i
      cv co eleq2i wb restcld syl5bb mpbird sscls simp3 ssind clsss2 fveq1i cvv
      cuni id topopn ssexg syl2anr resttop syldan restuni syl5eqel mpbid unieqi
      eqcomi adantr inss1 sseq1 mpbiri ad2antll sstrd wi adantl ssrin syl sseq2
      sseqtrd syl5ibrcom expr com23 impr mpd rexlimddv eqssd ) BIJZEDKZAEKZUAZA
      CLMZMZABLMMZENZXAXECOMZJZAXEKXCXEKXAXGXEHUNZENZPZHBOMZUBZXAXDXKJZXEXEPZXL
      XAWRADKZXMWRWSWTUCZWSWTXOWRWTWSXOAEDUDUEUFZABDFUGQXERXJXNHXDXKXHXDPXIXEXE
      XHXDEUHUIUJUKXGXEBEULUOZOMZJZXAXLXFXSXECXROGUMUPWRWSXTXLUQWTHXEEBDFURSUSU
      TXAAXDEXAWRXOAXDKXPXQABDFVAQWRWSWTVBZVCXEACCVGZYBRVDQXAXCXIPZXEXCKZHXKXAX
      CXSJZYCHXKUBZXAXCAXRLMZMZXSAXBYGCXRLGUMVEXAXRIJZAXRVGZKZYHXSJWRWSYIWTWRWS
      EVFJZYIWSWSDBJYLWRWSVHBDFVIEDBVJVKEBVFVLVMZSXAAEYJYAWRWSEYJPWTEBDFVNSWJZA
      XRYJYJRUGQVOWRWSYEYFUQWTHXCEBDFURSVPXAXHXKJZYCTZTZAXHKZYDYQAXCXHXAAXCKZYP
      XACIJZYKYSWRWSYTWTWRWSTCXRIGYMVOSYNACYJYBYJCXRGVQVRVAQVSYCXCXHKZXAYOYCUUA
      XIXHKXHEVTXCXIXHWAWBWCWDXAYOYCYRYDWEXAYOTYRYCYDXAYOYRYCYDWEXAYOYRTZTZYDYC
      XEXIKZUUCXDXHKZUUDUUBUUEXAXHABDFVDWFXDXHEWGWHXCXIXEWIWKWLWMWNWOWPWQ $.

    $( An interior in a subspace topology.  Willard in _General Topology_ says
       that there is no analog of ~ restcls for interiors.  In some sense, that
       is true.  (Contributed by Jeff Hankins, 23-Jan-2010.)  (Revised by Mario
       Carneiro, 15-Dec-2013.) $)
    restntr $p |- ( ( J e. Top /\ Y C_ X /\ S C_ Y ) ->
      ( ( int ` K ) ` S ) = ( ( ( int ` J ) ` ( S u. ( X \ Y ) ) ) i^i Y ) ) $=
      ( vo vx ctop wcel wss cnt cfv cvv wa syl2anc syl5eqel wi syl w3a cdif cun
      cin cv wceq crest co wrex fveq2i fveq1i topopn ssexg ancoms sylan resttop
      cuni syldan 3adant3 restuni sseq2d biimp3a ntropn wb uniexg sylan2 elrest
      eqid simp1 mpbid wo eltopss sseld adantrr 3ad2antl1 wn simplbi2 orrd syl6
      eldif elin eleq2 elun1 syl6bir ad2antll syl5bir expdimp elun2 a1i jaod ex
      mpdd ssrdv adantr unieqi eqcomi ntrss2 unss1 sstrd simpl1 sstr difss unss
      3adant1 jctir sylib simprl simprr ssntr ssrin sseq1 syl5ibrcom expr com23
      syl22anc impr rexlimddv elrestr syl3anc syl6eleqr elun orcom df-or anbi1i
      mpd bitri elndif pm2.27 impcom syl5bi eqssd ) BJKZEDLZAELZUAZACMNZNZADEUB
      ZUCZBMNNZEUDZYOYQHUEZEUDZUFZYQUUALZHBYOYQBEUGUHZKZUUDHBUIZYOYQAUUFMNZNZUU
      FAYPUUICUUFMGUJUKYOUUFJKZAUUFUQZLZUUJUUFKYLYMUUKYNYLYMEOKZUUKYLDBKZYMUUNB
      DFULYMUUOUUNEDBUMUNUOZEBOUPURUSZYLYMYNUUMYLYMPEUULAEBDFUTVAVBZAUUFUULUULV
      HVCQRYOYLUUNUUGUUHVDYLYMYNVIZYLYMUUNYNYMYLUUNYLYMDOKUUNYLDBUQOFBJVEREDOUM
      VFUNUSHYQEBJOVGQVJYOUUBBKZUUDPZPZUUBYSLZUUEUVBUUBYQYRUCZYSUVBIUUBUVDUVBIU
      EZUUBKZUVEEKZUVEYRKZVKZUVEUVDKZUVBUVFUVEDKZUVIYLYMUVAUVFUVKSZYNYLUUTUVLUU
      DYLUUTPUUBDUVEUUBBDFVLVMVNVOUVKUVGUVHUVHUVKUVGVPUVEDEVTVQVRVSUVBUVFUVIUVJ
      SUVBUVFPZUVGUVJUVHUVBUVFUVGUVJUVFUVGPUVEUUCKZUVBUVJUVEUUBEWAUUDUVNUVJSYOU
      UTUUDUVNUVEYQKUVJYQUUCUVEWBUVEYQYRWCWDWEWFWGUVHUVJSUVMUVEYRYQWHWIWJWKWLWM
      UVBYQALZUVDYSLUVBCJKZUUMUVOUVBCUUFJGYOUUKUVAUUQWNRYOUUMUVAUURWNACUULCUQUU
      LCUUFGWOWPZWQQYQAYRWRTWSYOUUTUUDUVCUUESYOUUTPUVCUUDUUEYOUUTUVCUUDUUESYOUU
      TUVCPZPZUUEUUDUUCUUALZUVSUUBYTLZUVTUVSYLYSDLZUUTUVCUWAYLYMYNUVRWTUVSADLZY
      RDLZPZUWBUVSUWCUWDYOUWCUVRYMYNUWCYLYNYMUWCAEDXAUNXDZWNDEXBZXEAYRDXCZXFYOU
      UTUVCXGYOUUTUVCXHYSBUUBDFXIXOUUBYTEXJTYQUUCUUAXKXLXMXNXPYEXQYOUVPUUMUUACK
      UUAALUUAYQLYOCUUFJGUUQRUURYOUUAUUFCYOYLUUNYTBKZUUAUUFKUUSYLYMUUNYNUUPUSYO
      YLUWBUWIUUSYOUWEUWBYOUWCUWDUWFUWGXEUWHXFZYSBDFVCQYTEBJOXRXSGXTYOUUAYSEUDZ
      AYOYTYSLZUUAUWKLYOYLUWBUWLUUSUWJYSBDFWQQYTYSEXJTYOIUWKAUVEUWKKZUVHVPZUVEA
      KZSZUVGPZYOUWOUWMUVEYSKZUVGPUWQUVEYSEWAUWRUWPUVGUWRUWOUVHVKZUWPUVEAYRYAUW
      SUVHUWOVKUWPUWOUVHYBUVHUWOYCYFYFYDYFUWQUWOSYOUVGUWPUWOUVGUWNUWPUWOSUVEEDY
      GUWNUWOYHTYIWIYJWMWSACUUAUULUVQXIXOYK $.

    $( The limit points of a subset restrict naturally in a subspace.
       (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    restlp $p |- ( ( J e. Top /\ Y C_ X /\ S C_ Y ) ->
      ( ( limPt ` K ) ` S ) = ( ( ( limPt ` J ) ` S ) i^i Y ) ) $=
      ( vx ctop wcel wss clp cfv cin ccl wa wceq elin wb syl2anc w3a cdif simp3
      cv csn ssdifssd restcls syld3an3 eleq2d syl6bb cuni ctopon crest co simp1
      toptopon sylib resttopon syl5eqel topontop syl toponuni sseqtrd eqid islp
      simp2 sstrd anbi1d syl5bb 3bitr4d eqrdv ) BIJZEDKZAEKZUAZHACLMMZABLMMZENZ
      VOHUDZAVSUEZUBZCOMMZJZVSWABOMMZJZVSEJZPZVSVPJZVSVRJZVOWCVSWDENZJWGVOWBWJV
      SVLVMVNWAEKWBWJQVOAEVTVLVMVNUCZUFWABCDEFGUGUHUIVSWDERUJVOCIJZACUKZKWHWCSV
      OCEULMZJZWLVOCBEUMUNZWNGVOBDULMJZVMWPWNJVOVLWQVLVMVNUOZBDFUPUQVLVMVNVFZEB
      DURTUSZECUTVAVOAEWMWKVOWOEWMQWTECVBVAVCVSACWMWMVDVETWIVSVQJZWFPVOWGVSVQER
      VOXAWEWFVOVLADKXAWESWRVOAEDWKWSVGVSABDFVETVHVIVJVK $.

    $( Perfection of a subspace.  Note that the term "perfect set" is reserved
       for _closed_ sets which are perfect in the subspace topology.
       (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    restperf $p |- ( ( J e. Top /\ Y C_ X ) ->
      ( K e. Perf <-> Y C_ ( ( limPt ` J ) ` Y ) ) ) $=
      ( ctop wcel wss wa cperf cuni clp cfv wceq wb ctopon crest co syl eqeq12d
      toptopon resttopon sylanb syl5eqel topontop eqid isperf baib dfss1 restlp
      cin ssid mp3an3 toponuni fveq2d eqtr3d syl5bb bitr4d ) AGHZDCIZJZBKHZBLZB
      MNZNZVDOZDDAMNNZIZVBBGHZVCVGPVBBDQNZHZVJVBBADRSZVKFUTACQNHVAVMVKHACEUBDAC
      UCUDUEZDBUFTVCVJVGBVDVDUGUHUITVIVHDULZDOVBVGDVHUJVBVOVFDVDVBDVENZVOVFUTVA
      DDIVPVOODUMDABCDEFUKUNVBDVDVEVBVLDVDOVNDBUOTZUPUQVQUAURUS $.

    $( An open subset of a perfect space is perfect.  (Contributed by Mario
       Carneiro, 25-Dec-2016.) $)
    perfopn $p |- ( ( J e. Perf /\ Y e. J ) -> K e. Perf ) $=
      ( vx cperf wcel wa ctop cv wn cuni wral ctopon cfv wss adantr syl perftop
      csn crest co toptopon elssuni adantl syl6sseqr resttopon syl2anc syl5eqel
      sylib topontop sselda perfi adantlr syldan eleq2i wb restopn2 sylan simpl
      syl6bi syl5bi mtod ralrimiva wceq toponuni raleqdv mpbid isperf3 sylanbrc
      eqid ) AHIZDAIZJZBKIZGLZUBZBIZMZGBNZOZBHIVPBDPQZIZVQVPBADUCUDZWDFVPACPQIZ
      DCRWFWDIVPAKIZWGVNWHVOAUAZSACEUEULVPDANZCVODWJRVNDAUFUGEUHZDACUIUJUKZDBUM
      TVPWAGDOWCVPWAGDVPVRDIZJZVTVSAIZVPWMVRCIZWOMZVPDCVRWKUNVNWPWQVOVRACEUOUPU
      QVTVSWFIZWNWOBWFVSFURWNWRWOVSDRZJZWOVPWRWTUSZWMVNWHVOXAWIDVSAUTVASWOWSVBV
      CVDVEVFVPWAGDWBVPWEDWBVGWLDBVHTVIVJGBWBWBVMVKVL $.
  $}

  ${
    resstopn.1 $e |- H = ( K |`s A ) $.
    resstopn.2 $e |- J = ( TopOpen ` K ) $.
    $( The topology of a restricted structure.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    resstopn $p |- ( J |`t A ) = ( TopOpen ` H ) $=
      ( cvv wcel crest co ctopn cfv wceq cts cbs cin fvex eqid syl5eq c0 restco
      mp3an12 resstset incom ressbas oveq12d eqtrd topnval eqtr4i 3eqtr3g wn wa
      oveq1i simpr con3i cxp wfn restfn fndm ax-mp ndmov cress reldmress ovprc2
      cdm syl fveq2d c9 df-tset str0 syl6eqr oveq1d 0rest eqtr4d pm2.61i ) AGHZ
      CAIJZBKLZMVPDNLZDOLZIJZAIJZBNLZBOLZIJZVQVRVPWBVSVTAPZIJZWEVSGHVTGHVPWBWGM
      DNQDOQVTAVSGGGUAUBVPVSWCWFWDIADBVSGEVSRZUCVPWFAVTPWDVTAUDAVTBGDEVTRZUESUF
      UGWACAIWADKLCVTVSDWIWHUHFUIUMWDWCBWDRWCRUHZUJVPUKZVQTVRWKCGHZVPULZUKVQTMW
      MVPWLVPUNUOCAGIIGGUPZUQIVEWNMURWNIUSUTVAVFWKWETWDIJVRTWKWCTWDIWKWCTNLTWKB
      TNWKBDAVBJTEDAVBVCVDSVGNVHVIVJVKVLWJWDVMUJVNVO $.
  $}

  $( A restricted topological space is a topological space.  Note that this
     theorem would not be true if ` TopSp ` was defined directly in terms of
     the ` TopSet ` slot instead of the ` TopOpen ` derived function.
     (Contributed by Mario Carneiro, 13-Aug-2015.) $)
  resstps $p |- ( ( K e. TopSp /\ A e. V ) -> ( K |`s A ) e. TopSp ) $=
    ( ctps wcel wa ctopn cfv crest cress cbs ctopon cin istps resttopon2 sylanb
    co eqid wceq ressbas adantl fveq2d eleqtrd resstopn sylibr ) BDEZACEZFZBGHZ
    AIQZBAJQZKHZLHZEUKDEUHUJABKHZMZLHZUMUFUIUNLHEUGUJUPEUNUIBUNRZUIRZNAUICUNOPU
    HUOULLUGUOULSUFAUNUKCBUKRZUQTUAUBUCULUJUKULRAUKUIBUSURUDNUE $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Order topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b m n r w z A $.  $d a b m n r w x y z R $.  $d a b m n r w x y z X $.
    $d a b m n r z B $.  $d m n z C $.  $d x V $.
    ordtval.1 $e |- X = dom R $.
    ordtval.2 $e |- A = ran ( x e. X |-> { y e. X | -. y R x } ) $.
    $( Lemma for ~ ordtbas .  In a total order, unbounded-above intervals are
       closed under intersection.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtbaslem $p |- ( R e. TosetRel -> ( fi ` A ) = A ) $=
      ( vz vw vb va wcel cv wral wceq wbr wn wa cvv syl ctsr cin cfi cfv crn wo
      crab cmpt cif wb 3anrot tsrlemax sylan2br 3exp2 imp42 notbid ioran syl6bb
      w3a rabbidva ifcl ancoms adantl dmexg syl5eqel adantr rabexg eqeltrd eqid
      cdm breq2 rabbidv elrnmpt1s syl6eleqr syl2anc eqeltrrd ralrimivva cbvmptv
      ralrimivw ineq1 inrab syl6eq eleq1d ralrnmpt mpbird ineq2 raleqi raleqbii
      ralbidv sylibr cpw pwexg wf wss ssrab2 elpw2g mpbiri fmptd syl5eqss ssexd
      frn inficl mpbid ) DUALZHMZIMZUBZCLZICNZHCNZCUCUDCOZXDXHIAEBMZAMZDPZQZBEU
      GZUHZUEZNZHXRNZXJXDXTXEXLJMZDPZQZBEUGZUBZCLZJENZHXRNZXDYHXLKMZDPZQZYCRZBE
      UGZCLZJENZKENZXDYNKJEEXDYIELZYAELZRZRZXLYIYADPZYAYIUIZDPZQZBEUGZYMCYTUUDY
      LBEYTXLELZRZUUDYJYBUFZQYLUUGUUCUUHXDYQYRUUFUUCUUHUJZXDYQYRUUFUUIYQYRUUFUS
      XDUUFYQYRUSUUIUUFYQYRUKXLYIYADEFULUMUNUOUPYJYBUQURUTZYTUUBELZUUESLZUUECLY
      SUUKXDYRYQUUKUUAYAYIEVAVBVCYTUUEYMSUUJYTESLZYMSLXDUUMYSXDEDVJSFDUAVDVEZVF
      YLBESVGTVHUUKUULRUUEXRCAEXPUUEUUBXQSXQVIZXMUUBOZXOUUDBEUUPXNUUCXMUUBXLDVK
      UPVLVMGVNVOVPVQXDYKBEUGZSLZKENYHYPUJXDUURKEXDUUMUURUUNYKBESVGTVSYGYOKHEUU
      QXQSAKEXPUUQXMYIOZXOYKBEUUSXNYJXMYIXLDVKUPVLVRXEUUQOZYFYNJEUUTYEYMCUUTYEU
      UQYDUBYMXEUUQYDVTYKYCBEWAWBWCWIWDTWEXDXSYGHXRXDYDSLZJENXSYGUJXDUVAJEXDUUM
      UVAUUNYCBESVGTVSXHYFJIEYDXQSAJEXPYDXMYAOZXOYCBEUVBXNYBXMYAXLDVKUPVLVRXFYD
      OXGYECXFYDXEWFWCWDTWIWEXIXSHCXRGXHICXRGWGWHWJXDCSLXJXKUJXDCEWKZSXDUUMUVCS
      LUUNESWLTXDCXRUVCGXDEUVCXQWMXRUVCWNXDAEXPUVCXQXDXMELZRZXPUVCLZXPEWNZXOBEW
      OUVEUUMUVFUVGUJXDUUMUVDUUNVFXPESWPTWQUUOWREUVCXQXATWSWTHICSXBTXC $.

    ordtval.3 $e |- B = ran ( x e. X |-> { y e. X | -. x R y } ) $.
    $( Value of the order topology.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtval $p |- ( R e. V -> ( ordTop ` R ) =
      ( topGen ` ( fi ` ( { X } u. ( A u. B ) ) ) ) ) $=
      ( vr cfv cun cfi ctg wbr wn crab cmpt crn wcel cvv cordt csn wceq elex cv
      cdm dmeq syl6eqr sneqd rnun breq notbid rabeqbidv mpteq12dv rneqd uneq12d
      syl5eq fveq2d df-ordt fvex fvmpt syl ) EFUAEUBUAEUCLGUDZCDMZMZNLZOLZUEEFU
      FKEKUGZUHZUDZAVKBUGZAUGZVJPZQZBVKRZSZAVKVNVMVJPZQZBVKRZSZMTZMZNLZOLVIUBUC
      VJEUEZWEVHOWFWDVGNWFVLVEWCVFWFVKGWFVKEUHGVJEUIHUJZUKWFWCVRTZWBTZMVFVRWBUL
      WFWHCWIDWFWHAGVMVNEPZQZBGRZSZTCWFVRWMWFAVKVQGWLWGWFVPWKBVKGWGWFVOWJVMVNVJ
      EUMUNUOUPUQIUJWFWIAGVNVMEPZQZBGRZSZTDWFWBWQWFAVKWAGWPWGWFVTWOBVKGWGWFVSWN
      VNVMVJEUMUNUOUPUQJUJURUSURUTUTABKVAVHOVBVCVD $.

    $( Value of the order topology.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtuni $p |- ( R e. V -> X = U. ( { X } u. ( A u. B ) ) ) $=
      ( wcel cuni cun cvv wceq syl wss cv wbr wn csn cdm syl5eqel unisng uneq1d
      dmexg cpw crab cmpt crn wf wa ssrab2 wb adantr elpw2g eqid fmptd syl5eqss
      mpbiri frn unssd sspwuni sylib ssequn2 eqtr2d uniun syl6eqr ) EFKZGGUAZLZ
      CDMZLZMZVJVLMLVIVNGVMMZGVIVKGVMVIGNKZVKGOVIGEUBNHEFUFUCZGNUDPUEVIVMGQZVOG
      OVIVLGUGZQVRVICDVSVICAGBRZARZESTZBGUHZUIZUJZVSIVIGVSWDUKWEVSQVIAGWCVSWDVI
      WAGKZULZWCVSKZWCGQZWBBGUMWGVPWHWIUNVIVPWFVQUOZWCGNUPPUTWDUQURGVSWDVAPUSVI
      DAGWAVTESTZBGUHZUIZUJZVSJVIGVSWMUKWNVSQVIAGWLVSWMWGWLVSKZWLGQZWKBGUMWGVPW
      OWPUNWJWLGNUPPUTWMUQURGVSWMVAPUSVBVLGVCVDVMGVEVDVFVJVLVGVH $.

    ordtval.4 $e |- C = ran ( a e. X , b e. X |->
      { y e. X | ( -. y R a /\ -. b R y ) } ) $.
    $( Lemma for ~ ordtbas .  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    ordtbas2 $p |- ( R e. TosetRel -> ( fi ` ( A u. B ) ) =
      ( ( A u. B ) u. C ) ) $=
      ( wcel cv wceq wrex cvv wb wa vz vm vn ctsr cun cfi cfv cin w3o wss ssun1
      csn ssun2 ordtuni cdm dmexg syl5eqel eqeltrrd uniexb sylibr ssexg sylancr
      cuni elfiun syl2anc ordtbaslem syl6eqss syl6ss sseld crn ccnv wbr wn crab
      cmpt cnvtsr df-rn eqid syl cps tsrps psrn vex bicomi notbii a1i rabeqbidv
      brcnv mpteq12dv rneqd syl5eq fveq2d 3eqtr4d cmpt2 syl6eq eleq2d weq breq2
      notbid rabbidv cbvmptv elrnmpt syl6bb anbi12d reeanv ineq12 reximi sylbir
      ax-mp breq1 inrab syl6bi imp inex1 elrnmpt2g sseldi syl5ibrcom rexlimdvva
      syl6eleqr eleq1 3jaod sylbid ssrdv ssfii cxp wf wral adantr simprl eqeq2d
      eqidd rspcev rabexg 3syl mpbird sseldd simprr fiin syl5eqelr ralrimivva
      fmpt2 sylib frn syl5eqss unssd eqssd ) FUDNZCDUEZUFUGZUUHEUEZUUGUAUUIUUJU
      UGUAOZUUINZUUKCUFUGZNZUUKDUFUGZNZUUKUBOZUCOZUHZPZUCUUOQUBUUMQZUIZUUKUUJNZ
      UUGCRNZDRNZUULUVBSUUGCUUHUJUUHRNZUVDCDUKZUUGUUHGULZUUHUEZUJUVIRNZUVFUUHUV
      HUMUUGUVIVCZRNUVJUUGGUVKRABCDFUDGJKLUNUUGGFUORJFUDUPUQZURUVIUSUTUUHUVIRVA
      VBZCUUHRVAVBUUGDUUHUJUVFUVEDCUMZUVMDUUHRVAVBUBUCUUKCDRRVDVEUUGUUNUVCUUPUV
      AUUGUUMUUJUUKUUGUUMUUHUUJUUGUUMCUUHABCFGJKVFZUVGVGUUHEUKZVHVIUUGUUOUUJUUK
      UUGUUOUUHUUJUUGUUODUUHUUGAFVJZBOZAOZFVKZVLZVMZBUVQVNZVOZVJZUFUGZUWEUUODUU
      GUVTUDNUWFUWEPFVPABUWEUVTUVQFVQUWEVRVFVSUUGDUWEUFUUGDAGUVSUVRFVLZVMZBGVNZ
      VOZVJZUWELUUGUWJUWDUUGAGUWIUVQUWCUUGFVTNGUVQPFWAFGJWBVSZUUGUWHUWBBGUVQUWL
      UWHUWBSUUGUWGUWAUWAUWGUVRUVSFBWCAWCWHWDWEWFWGWIWJWKZWLUWMWMZUVNVGUVPVHVIU
      UGUUTUVCUBUCUUMUUOUUGUUQUUMNZUURUUONZTZTZUVCUUTUUSUUJNUWREUUJUUSEUUHUMUWR
      UUSHIGGUVRHOZFVLZVMZIOZUVRFVLZVMZTBGVNZWNZVJZEUWRUUSUXEPZIGQZHGQZUUSUXGNZ
      UUGUWQUXJUUGUWQUUQUXABGVNZPZHGQZUURUXDBGVNZPZIGQZTZUXJUUGUWOUXNUWPUXQUUGU
      WOUUQAGUVRUVSFVLZVMZBGVNZVOZVJZNZUXNUUGUUMUYCUUQUUGUUMCUYCUVOKWOWPUUQRNUY
      DUXNSUBWCZHGUXLUUQUYBRAHGUYAUXLAHWQZUXTUXABGUYFUXSUWTUVSUWSUVRFWRWSWTZXAX
      BXIXCUUGUWPUURUWKNZUXQUUGUUOUWKUURUUGUUODUWKUWNLWOWPUURRNUYHUXQSUCWCIGUXO
      UURUWJRAIGUWIUXOAIWQZUWHUXDBGUYIUWGUXCUVSUXBUVRFXJWSWTZXAXBXIXCXDUXRUXMUX
      PTZIGQZHGQUXJUXMUXPHIGGXEUYLUXIHGUYKUXHIGUYKUUSUXLUXOUHZUXEUUQUXLUURUXOXF
      UXAUXDBGXKZWOXGXGXHXLXMUUSRNUXKUXJSUUQUURUYEXNHIGGUXEUUSUXFRUXFVRZXOXIUTM
      XSXPUUKUUSUUJXTXQXRYAYBYCUUGUUHEUUIUUGUVFUUHUUIUJZUVMUUHRYDVSZUUGEUXGUUIM
      UUGGGYEZUUIUXFYFZUXGUUIUJUUGUXEUUINZIGYGHGYGUYSUUGUYTHIGGUUGUWSGNZUXBGNZT
      ZTZUXEUYMUUIUYNVUDUXLUUINUXOUUINUYMUUINVUDUUHUUIUXLUUGUYPVUCUYQYHZVUDCUUH
      UXLUVGVUDUXLUYCCVUDUXLUYCNZUXLUYAPZAGQZVUDVUAUXLUXLPZVUHUUGVUAVUBYIVUDUXL
      YKVUGVUIAUWSGUYFUYAUXLUXLUYGYJYLVEVUDGRNZUXLRNVUFVUHSUUGVUJVUCUVLYHZUXABG
      RYMAGUYAUXLUYBRUYBVRXBYNYOKXSXPYPVUDUUHUUIUXOVUEVUDDUUHUXOUVNVUDUXOUWKDVU
      DUXOUWKNZUXOUWIPZAGQZVUDVUBUXOUXOPZVUNUUGVUAVUBYQVUDUXOYKVUMVUOAUXBGUYIUW
      IUXOUXOUYJYJYLVEVUDVUJUXORNVULVUNSVUKUXDBGRYMAGUWIUXOUWJRUWJVRXBYNYOLXSXP
      YPUXLUXOUUHYRVEYSYTHIGGUXEUUIUXFUYOUUAUUBUYRUUIUXFUUCVSUUDUUEUUF $.

    $( In a total order, the finite intersections of the open rays generates
       the set of open intervals, but no more - these four collections form a
       subbasis for the order topology.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtbas $p |- ( R e. TosetRel -> ( fi ` ( { X } u. ( A u. B ) ) ) =
      ( ( { X } u. ( A u. B ) ) u. C ) ) $=
      ( vm vn ctsr wcel cun cvv wss vz csn cfi cfv cv cin wceq wrex w3o wb snex
      ssun2 cuni ordtuni cdm dmexg syl5eqel eqeltrrd uniexb sylibr ssexg elfiun
      sylancr wi ssun1 eqsstri sseli a1i ordtbas2 syl6eqss sseld wa cpw fipwuni
      fisn elpwid ad2antll unissi syl5sseqr adantr simprl syl6eleq syl sseqtr4d
      sstrd elsni dfss1 sylib adantrl eqeltrd eleq1 syl5ibrcom rexlimdvva 3jaod
      sselda sylbid ssrdv ssfii fiss sylancl eqsstr3d unssd eqssd unass syl6eqr
      unssad ) FPQZGUBZCDRZRZUCUDZXHXIERZRZXJERXGXKXMXGUAXKXMXGUAUEZXKQZXNXHUCU
      DZQZXNXIUCUDZQZXNNUEZOUEZUFZUGZOXRUHNXPUHZUIZXNXMQZXGXHSQXISQZXOYEUJGUKXG
      XIXJTZXJSQZYGXIXHULZXGXJUMZSQYIXGGYKSABCDFPGJKLUNZXGGFUOSJFPUPUQURXJUSUTZ
      XIXJSVAVCNOXNXHXISSVBVCXGXQYFXSYDXQYFVDXGXPXMXNXPXHXMGVOZXHXLVEVFVGVHXGXR
      XMXNXGXRXLXMABCDEFGHIJKLMVIZXLXHULVJZVKXGYCYFNOXPXRXGXTXPQZYAXRQZVLZVLZYF
      YCYBXMQYTYBYAXMYTYAXTTYBYAUGYTYAGXTYTYAXIUMZGYRYAUUATXGYQYRYAUUAXRUUAVMYA
      XIVNVGVPVQXGUUAGTYSXGYKUUAGXIXJYJVRYLVSVTWEYTXTXHQXTGUGYTXTXPXHXGYQYRWAYN
      WBXTGWFWCWDYAXTWGWHXGYRYAXMQYQXGXRXMYAYPWOWIWJXNYBXMWKWLWMWNWPWQXGXHXLXKX
      GXHXIXKXGYIXJXKTYMXJSWRWCXFXGXLXRXKYOXGYIYHXRXKTYMYJXIXJSWSWTXAXBXCXHXIEX
      DXE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x y P $.  $d x y R $.  $d x y V $.  $d x y X $.
    ordttopon.3 $e |- X = dom R $.
    $( Value of the order topology.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordttopon $p |- ( R e. V -> ( ordTop ` R ) e. ( TopOn ` X ) ) $=
      ( vx vy wcel cordt cfv cv wbr wn crab cmpt crn cun cuni ctopon eqid cvv
      csn cfi ctg ordtval ctb fibas tgtopon ax-mp syl6eqel ordtuni cdm syl5eqel
      wceq dmexg eqeltrrd uniexb sylibr fiuni syl eqtrd fveq2d eleqtrrd ) ABGZA
      HIZCUAECFJZEJZAKLFCMNOZECVFVEAKLFCMNOZPPZUBIZQZRIZCRIVCVDVJUCIZVLEFVGVHAB
      CDVGSZVHSZUDVJUEGVMVLGVIUFVJUGUHUIVCCVKRVCCVIQZVKEFVGVHABCDVNVOUJZVCVITGZ
      VPVKUMVCVPTGVRVCCVPTVQVCCAUKTDABUNULUOVIUPUQVITURUSUTVAVB $.

    $( An upward ray ` ( P , +oo ) ` is open.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtopn1 $p |- ( ( R e. V /\ P e. X ) ->
      { x e. X | -. x R P } e. ( ordTop ` R ) ) $=
      ( vy wcel cv wbr wn crab cmpt crn cun cfv cvv wceq eqid adantr wa csn cfi
      cordt ctg wss ordtuni cdm dmexg syl5eqel eqeltrrd uniexb sylibr ssfii syl
      cuni ctb fibas bastg ax-mp syl6ss ordtval sseqtr4d ssun2 ssun1 wrex simpr
      eqidd breq2 notbid rabbidv eqeq2d rspcev syl2anc wb rabexg elrnmpt mpbird
      3syl sseldi sseldd ) CDHZBEHZUAZEUBZGEAIZGIZCJZKZAELZMZNZGEWGWFCJKAELMNZO
      ZOZCUDPZWFBCJZKZAELZWDWOWOUCPZUEPZWPWDWOWTXAWDWOQHZWOWTUFWDWOUPZQHXBWDEXC
      QWBEXCRWCGAWLWMCDEFWLSZWMSZUGTWBEQHZWCWBECUHQFCDUIUJTZUKWOULUMWOQUNUOWTUQ
      HWTXAUFWOURWTUQUSUTVAWBWPXARWCGAWLWMCDEFXDXEVBTVCWDWNWOWSWNWEVDWDWLWNWSWL
      WMVEWDWSWLHZWSWJRZGEVFZWDWCWSWSRZXJWBWCVGWDWSVHXIXKGBEWGBRZWJWSWSXLWIWRAE
      XLWHWQWGBWFCVIVJVKVLVMVNWDXFWSQHXHXJVOXGWRAEQVPGEWJWSWKQWKSVQVSVRVTVTWA
      $.

    $( A downward ray ` ( -oo , P ) ` is open.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtopn2 $p |- ( ( R e. V /\ P e. X ) ->
      { x e. X | -. P R x } e. ( ordTop ` R ) ) $=
      ( vy wcel cv wbr wn crab cmpt crn cun cfv cvv wceq eqid adantr wa csn cfi
      cordt ctg wss ordtuni cdm dmexg syl5eqel eqeltrrd uniexb sylibr ssfii syl
      cuni ctb fibas bastg ax-mp syl6ss ordtval sseqtr4d ssun2 wrex simpr eqidd
      notbid rabbidv eqeq2d rspcev syl2anc wb rabexg elrnmpt 3syl mpbird sseldi
      breq1 sseldd ) CDHZBEHZUAZEUBZGEAIZGIZCJKAELMNZGEWFWECJZKZAELZMZNZOZOZCUD
      PZBWECJZKZAELZWCWNWNUCPZUEPZWOWCWNWSWTWCWNQHZWNWSUFWCWNUPZQHXAWCEXBQWAEXB
      RWBGAWGWLCDEFWGSZWLSZUGTWAEQHZWBWAECUHQFCDUIUJTZUKWNULUMWNQUNUOWSUQHWSWTU
      FWNURWSUQUSUTVAWAWOWTRWBGAWGWLCDEFXCXDVBTVCWCWMWNWRWMWDVDWCWLWMWRWLWGVDWC
      WRWLHZWRWJRZGEVEZWCWBWRWRRZXIWAWBVFWCWRVGXHXJGBEWFBRZWJWRWRXKWIWQAEXKWHWP
      WFBWECVSVHVIVJVKVLWCXEWRQHXGXIVMXFWQAEQVNGEWJWRWKQWKSVOVPVQVRVRVT $.

    $( An open interval ` ( A , B ) ` is open.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    ordtopn3 $p |- ( ( R e. V /\ A e. X /\ B e. X ) ->
      { x e. X | ( -. x R A /\ -. B R x ) } e. ( ordTop ` R ) ) $=
      ( wcel w3a cv wbr wn wa crab cin cordt cfv inrab ctop ctopon 3ad2ant1 syl
      ordttopon topontop ordtopn1 3adant3 ordtopn2 3adant2 syl3anc syl5eqelr
      inopn ) DEHZBFHZCFHZIZAJZBDKLZCUPDKLZMAFNUQAFNZURAFNZOZDPQZUQURAFRUOVBSHZ
      USVBHZUTVBHZVAVBHUOVBFTQHZVCULUMVFUNDEFGUCUAFVBUDUBULUMVDUNABDEFGUEUFULUN
      VEUMACDEFGUGUHUSUTVBUKUIUJ $.

    $( A downward ray ` ( -oo , P ] ` is closed.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    ordtcld1 $p |- ( ( R e. V /\ P e. X ) ->
      { x e. X | x R P } e. ( Clsd ` ( ordTop ` R ) ) ) $=
      ( wcel wa cv wbr crab cordt cfv ccld cuni wss cdif ssrab2 ctopon wceq syl
      ordttopon adantr toponuni syl5sseq difeq1d syl5eqr ordtopn1 eqeltrrd ctop
      wn notrab wb topontop eqid iscld 3syl mpbir2and ) CDGZBEGZHZAIBCJZAEKZCLM
      ZNMGZVCVDOZPZVFVCQZVDGZVAEVCVFVBAERVAVDESMGZEVFTUSVJUTCDEFUBUCZEVDUDUAZUE
      VAVBUKAEKZVHVDVAVMEVCQVHVBAEULVAEVFVCVLUFUGABCDEFUHUIVAVJVDUJGVEVGVIHUMVK
      EVDUNVCVDVFVFUOUPUQUR $.

    $( An upward ray ` [ P , +oo ) ` is closed.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    ordtcld2 $p |- ( ( R e. V /\ P e. X ) ->
      { x e. X | P R x } e. ( Clsd ` ( ordTop ` R ) ) ) $=
      ( wcel wa cv wbr crab cordt cfv ccld cuni wss cdif ssrab2 ctopon wceq syl
      ordttopon adantr toponuni syl5sseq difeq1d syl5eqr ordtopn2 eqeltrrd ctop
      wn notrab wb topontop eqid iscld 3syl mpbir2and ) CDGZBEGZHZBAICJZAEKZCLM
      ZNMGZVCVDOZPZVFVCQZVDGZVAEVCVFVBAERVAVDESMGZEVFTUSVJUTCDEFUBUCZEVDUDUAZUE
      VAVBUKAEKZVHVDVAVMEVCQVHVBAEULVAEVFVCVLUFUGABCDEFUHUIVAVJVDUJGVEVGVIHUMVK
      EVDUNVCVDVFVFUOUPUQUR $.

    $( A closed interval ` [ A , B ] ` is closed.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    ordtcld3 $p |- ( ( R e. V /\ A e. X /\ B e. X ) ->
      { x e. X | ( A R x /\ x R B ) } e. ( Clsd ` ( ordTop ` R ) ) ) $=
      ( wcel w3a cv wbr wa crab cin cordt cfv ccld inrab ordtcld2 3adant3 incld
      ordtcld1 3adant2 syl2anc syl5eqelr ) DEHZBFHZCFHZIZBAJZDKZUJCDKZLAFMUKAFM
      ZULAFMZNZDOPZQPZUKULAFRUIUMUQHZUNUQHZUOUQHUFUGURUHABDEFGSTUFUHUSUGACDEFGU
      BUCUMUNUPUAUDUE $.
  $}

  $( The order topology is a topology.  (Contributed by Mario Carneiro,
     3-Sep-2015.) $)
  ordttop $p |- ( R e. V -> ( ordTop ` R ) e. Top ) $=
    ( wcel cordt cfv cdm ctopon ctop eqid ordttopon topontop syl ) ABCADEZAFZGE
    CMHCABNNIJNMKL $.

  ${
    $d v w x y z A $.  $d v w x y z ph $.  $d v w x y z R $.  $d v w x y z X $.
    $d x y V $.
    $( The order dual generates the same topology as the original order.
       (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    ordtcnv $p |- ( R e. PosetRel -> ( ordTop ` `' R ) = ( ordTop ` R ) ) $=
      ( vx vy cps wcel crn csn cv wbr wn crab cmpt cun cfi cfv ctg cordt wb vex
      eqid ccnv cdm eqcomd sneqd brcnv notbid rabeqbidv mpteq12dv rneqd uneq12d
      psrn a1i uncom syl6eq fveq2d wceq cnvps df-rn ordtval syl 3eqtr4d ) ADEZA
      FZGZBVCCHZBHZAUAZIZJZCVCKZLZFZBVCVFVEVGIZJZCVCKZLZFZMZMZNOZPOZAUBZGZBWBVE
      VFAIZJZCWBKZLZFZBWBVFVEAIZJZCWBKZLZFZMZMZNOZPOVGQOZAQOVBVTWPPVBVSWONVBVDW
      CVRWNVBVCWBVBWBVCAWBWBTZUKUCZUDVBVRWMWHMWNVBVLWMVQWHVBVKWLVBBVCVJWBWKWSVB
      VIWJCVCWBWSVBVHWIVHWIRVBVEVFACSZBSZUEULUFUGUHUIVBVPWGVBBVCVOWBWFWSVBVNWEC
      VCWBWSVBVMWDVMWDRVBVFVEAXAWTUEULUFUGUHUIUJWMWHUMUNUJUOUOVBVGDEWQWAUPAUQBC
      VLVQVGDVCAURVLTVQTUSUTBCWHWMADWBWRWHTWMTUSVA $.

    $( The subspace topology of an order topology is in general finer than the
       topology generated by the restricted order, but we do have inclusion in
       one direction.  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    ordtrest $p |- ( ( R e. PosetRel /\ A e. V ) ->
      ( ordTop ` ( R i^i ( A X. A ) ) ) C_ ( ( ordTop ` R ) |`t A ) ) $=
      ( vx vy cps wcel cin cfv wbr crab cmpt crn wceq adantr eqid syl ctop wss
      wn wa cxp cordt cdm csn cv cun cfi ctg cvv inex1g ordtval ordttop resttop
      crest sylan psssdm2 simpr ctopon ordttopon toponmax elrestr syl3anc snssd
      co eqeltrd rabeq mpteq12dv rneqd wf inrab2 wb inss2 sseldi brinxp syl2anc
      notbid rabbidva syl5eq simpl inss1 sseli ordtopn1 syl2an eqeltrrd eqsstrd
      fmptd frn ordtopn2 unssd tgfiss ) BFGZACGZUAZBAAUBZHZUCIZWPUDZUEZDWREUFZD
      UFZWPJZTZEWRKZLZMZDWRXAWTWPJZTZEWRKZLZMZUGZUGZUHIUIIZBUCIZAUOVEZWNWPUJGZW
      QXNNWLXQWMBWOFUKODEXFXKWPUJWRWRPXFPXKPULQWNXPRGZXMXPSXNXPSWLXORGZWMXRBFUM
      ZAXOCUNUPWNWSXLXPWNWRXPWNWRBUDZAHZXPWLWRYBNZWMABYAYAPZUQOZWNXSWMYAXOGZYBX
      PGWLXSWMXTOZWLWMURZWNXOYAUSIGZYFWLYIWMBFYAYDUTOYAXOVAQYAAXORCVBVCVFVDWNXF
      XKXPWNXFDYBXCEYBKZLZMZXPWNXEYKWNDWRXDYBYJYEWNYCXDYJNYEXCEWRYBVGQVHVIWNYBX
      PYKVJYLXPSWNDYBYJXPYKWNXAYBGZUAZWTXABJZTZEYAKZAHZYJXPYNYRYPEYBKYJYPEYAAVK
      YNYPXCEYBYNWTYBGZUAZYOXBYTWTAGZXAAGZYOXBVLYTYBAWTYAAVMZYNYSURVNZYNUUBYSYN
      YBAXAUUCWNYMURVNOZWTXAAABVOVPVQVRVSYNXSWMYQXOGZYRXPGWNXSYMYGOZWNWMYMYHOZW
      NWLXAYAGZUUFYMWLWMVTZYBYAXAYAAWAWBZEXABFYAYDWCWDYQAXORCVBVCWEYKPWGYBXPYKW
      HQWFWNXKDYBXHEYBKZLZMZXPWNXJUUMWNDWRXIYBUULYEWNYCXIUULNYEXHEWRYBVGQVHVIWN
      YBXPUUMVJUUNXPSWNDYBUULXPUUMYNXAWTBJZTZEYAKZAHZUULXPYNUURUUPEYBKUULUUPEYA
      AVKYNUUPXHEYBYTUUOXGYTUUBUUAUUOXGVLUUEUUDXAWTAABVOVPVQVRVSYNXSWMUUQXOGZUU
      RXPGUUGUUHWNWLUUIUUSYMUUJUUKEXABFYAYDWIWDUUQAXORCVBVCWEUUMPWGYBXPUUMWHQWF
      WJWJXMXPWKVPWF $.

    ordtrest2.1 $e |- X = dom R $.
    ordtrest2.2 $e |- ( ph -> R e. TosetRel ) $.
    ordtrest2.3 $e |- ( ph -> A C_ X ) $.
    ordtrest2.4 $e |- ( ( ph /\ ( x e. A /\ y e. A ) ) ->
       { z e. X | ( x R z /\ z R y ) } C_ A ) $.
    $( Lemma for ~ ordtrest2 .  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    ordtrest2lem $p |- ( ph -> A. v e. ran ( z e. X |-> { w e. X | -. w R z } )
      ( v i^i A ) e. ( ordTop ` ( R i^i ( A X. A ) ) ) ) $=
      ( cv wcel crab wa wceq syl cvv cin cxp cordt cfv wbr cmpt crn wral inrab2
      wss dfss1 sylib adantr rabeq syl5eq ctopon cdm ctsr inex1g eqid ordttopon
      wn tsrps psssdm syl2anc fveq2d eleqtrd toponmax wb rabid2 eleq1 syl5ibcom
      cps sylbir wrex dfrex2 cbvrexv bitr3i c0 ctop ordttop 0opn syl5ibrcom wne
      breq1 rabn0 notbid bitri ad3antrrr ad2antrr sselda simpllr tsrlin syl3anc
      wo ord wi rabss r19.21bi an32s impr sylan2b brinxp ancoms rabbidva eqtr4d
      an4 eleqtrrd ordtopn1 eqeltrd anassrs expr rexlimdva pm2.61dne rexlimdvaa
      syld syl5bi pm2.61d ralrimiva dmexg syl5eqel rabexg ineq1 eleq1d ralrnmpt
      ralrimivw mpbird ) AFNZGUAZHGGUBZUAZUCUDZOZFDIENZDNZHUEZVBZEIPZUFZUGUHZYR
      GUAZYLOZDIUHZAUUBDIAYOIOZQZUUAYQEGPZYLUUEUUAYQEIGUAZPZUUFYQEIGUIUUEUUGGRZ
      UUHUUFRAUUIUUDAGIUJZUUILGIUKULUMYQEUUGGUNSUOUUEYQEGUHZUUFYLOZUUEGYLOZUUKU
      ULAUUMUUDAYLGUPUDZOUUMAYLYKUQZUPUDZUUNAYKTOZYLUUPOAHUROZUUQKHYJURUSSZYKTU
      UOUUOUTZVASAUUOGUPAHVMOZUUJUUOGRZAUURUVAKHVCSLGHIJVDVEZVFVGGYLVHSUMUUKGUU
      FRUUMUULVIYQEGVJGUUFYLVKVNVLUUKVBZBNZYOHUEZBGVOZUUEUULUVDYPEGVOUVGYPEGVPY
      PUVFEBGYNUVEYOHWEVQVRUUEUVFUULBGUUEUVEGOZUVFQZQZUULUUFVSUVJUULUUFVSRVSYLO
      ZUUEUVKUVIUUEYLVTOZUVKAUVLUUDAUUQUVLUUSYKTWASUMYLWBSUMUUFVSYLVKWCUUFVSWDZ
      CNZYOHUEZVBZCGVOZUVJUULUVMYQEGVOUVQYQEGWFYQUVPECGYNUVNRYPUVOYNUVNYOHWEWGV
      QWHUVJUVPUULCGUVJUVNGOZQZUVPYOUVNHUEZUULUVSUVOUVTUVSUURUVNIOUUDUVOUVTWOAU
      URUUDUVIUVRKWIUVJGIUVNAUUJUUDUVILWJWKAUUDUVIUVRWLUVNYOHIJWMWNWPUVJUVRUVTU
      ULUUEUVIUVRUVTQZUULUUEUVIUWAQZQZUUFYNYOYKUEZVBZEUUOPZYLUWCUUFUWEEGPZUWFUW
      CYOGOZUUFUWGRUWBUUEUVHUVRQZUVFUVTQZQUWHUVHUVFUVRUVTXGUUEUWIUWJUWHAUWIUUDU
      WJUWHWQZAUWIQZUWKDIUWLUWJDIPGUJUWKDIUHMUWJDIGWRULWSWTXAXBZUWHYQUWEEGUWHYN
      GOZQYPUWDUWNUWHYPUWDVIYNYOGGHXCXDWGXESUWCUVBUWFUWGRAUVBUUDUWBUVCWJZUWEEUU
      OGUNSXFUWCUUQYOUUOOUWFYLOAUUQUUDUWBUUSWJUWCYOGUUOUWMUWOXHEYOYKTUUOUUTXIVE
      XJXKXLXPXMXQXNXOXQXRXJXSAYRTOZDIUHYTUUCVIAUWPDIAITOUWPAIHUQZTJAUURUWQTOKH
      URXTSYAYQEITYBSYFYMUUBDFIYRYSTYSUTYHYRRYIUUAYLYHYRGYCYDYESYG $.

    $( An interval-closed set ` A ` in a total order has the same subspace
       topology as the restricted order topology.  (An interval-closed set is
       the same thing as an open or half-open or closed interval in ` RR ` ,
       but in other sets like ` QQ ` there are interval-closed sets like
       ` ( pi , +oo ) i^i QQ ` that are not intervals.)  (Contributed by Mario
       Carneiro, 9-Sep-2015.) $)
    ordtrest2 $p |- ( ph ->
      ( ordTop ` ( R i^i ( A X. A ) ) ) = ( ( ordTop ` R ) |`t A ) ) $=
      ( vw vv cfv wcel cvv wss syl wbr wceq cxp cin cordt crest co cps ctsr cdm
      tsrps dmexg syl5eqel ssexd ordtrest syl2anc csn crab cmpt crn cun cfi ctg
      cv wn eqid ordtval oveq1d ctb tgrest sylancr eqtr4d firest fveq2i syl6eqr
      fibas ctop inex1g ordttop ordtuni eqeltrrd uniexb sylibr restval wf dfss1
      cuni sylib ctopon ordttopon psssdm fveq2d eleqtrd toponmax eqeltrd ineq1d
      wral elsni eleq1d syl5ibrcom ralrimiv ordtrest2lem ccnv df-rn cnvtsr psrn
      sseqtrd wa adantr rabeq wb vex brcnv anbi12ci a1i rabbiia eqsstr3d bicomi
      ancom2s notbid rabeqbidv mpteq12dv rneqd cnvin cnvxp ineq2i eqtri ordtcnv
      psss syl5reqr eleq2d raleqbidv mpbird ralunb sylanbrc fmpt eqsstrd tgfiss
      frn eqssd ) AFEEUAZUBZUCNZFUCNZEUDUEZAFUFOZEPOZUUAUUCQAFUGOZUUDIFUIRZAEGP
      AGFUHZPHAUUFUUHPOIFUGUJRUKZJULZEFPUMUNAUUCGUOZDGLVBZDVBZFSVCLGUPUQURZDGUU
      MUULFSZVCZLGUPZUQZURZUSZUSZEUDUEZUTNZVANZUUAAUUCUVAUTNZEUDUEZVANZUVDAUUCU
      VEVANZEUDUEZUVGAUUBUVHEUDAUUFUUBUVHTIDLUUNUUSFUGGHUUNVDZUUSVDZVERVFAUVEVG
      OUUEUVGUVITUVAVNUUJEUVEVGPVHVIVJUVCUVFVAEUVAVKVLVMAUUAVOOZUVBUUAQUVDUUAQA
      YTPOZUVLAUUFUVMIFYSUGVPRZYTPVQRAUVBMUVAMVBZEUBZUQZURZUUAAUVAPOZUUEUVBUVRT
      AUVAWEZPOUVSAGUVTPAUUFGUVTTIDLUUNUUSFUGGHUVJUVKVRRUUIVSUVAVTWAUUJMEUVAPPW
      BUNAUVAUUAUVQWCZUVRUUAQAUVPUUAOZMUVAWOZUWAAUWBMUUKWOUWBMUUTWOZUWCAUWBMUUK
      AUWBUVOUUKOZGEUBZUUAOAUWFEUUAAEGQZUWFETJEGWDWFAUUAEWGNZOEUUAOAUUAYTUHZWGN
      ZUWHAUVMUUAUWJOUVNYTPUWIUWIVDWHRAUWIEWGAUUDUWGUWIETUUGJEFGHWIUNWJWKEUUAWL
      RWMUWEUVPUWFUUAUWEUVOGEUVOGWPWNWQWRWSAUWBMUUNWOUWBMUUSWOZUWDABCDLMEFGHIJK
      WTAUWKUVPFXAZYSUBZUCNZOZMDFURZUULUUMUWLSZVCZLUWPUPZUQZURZWOACBDLMEUWLUWPF
      XBAUUFUWLUGOIFXCRAEGUWPJAUUDGUWPTZUUGFGHXDRZXEABVBZEOZCVBZEOZUXFUUMUWLSZU
      UMUXDUWLSZXFZDUWPUPZEQAUXEUXGXFZXFZUXKUXDUUMFSZUUMUXFFSZXFZDGUPZEUXMUXQUX
      PDUWPUPZUXKUXMUXBUXQUXRTAUXBUXLUXCXGUXPDGUWPXHRUXJUXPDUWPUXJUXPXIUUMUWPOU
      XHUXOUXIUXNUXFUUMFCXJDXJZXKUUMUXDFUXSBXJXKXLXMXNVMKXOXQWTAUWBUWOMUUSUXAAU
      URUWTADGUUQUWPUWSUXCAUUPUWRLGUWPUXCAUUOUWQUUOUWQXIAUWQUUOUULUUMFLXJUXSXKX
      PXMXRXSXTYAAUUAUWNUVPAUWNYTXAZUCNZUUAUXTUWMUCUXTUWLYSXAZUBUWMFYSYBUYBYSUW
      LEEYCYDYEVLAYTUFOZUYAUUATAUUDUYCUUGEFYGRYTYFRYHYIYJYKUWBMUUNUUSYLYMUWBMUU
      KUUTYLYMMUVAUUAUVPUVQUVQVDYNWFUVAUUAUVQYQRYOUVBUUAYPUNYOYR $.
  $}

  $( The topology of the extended reals.  (Contributed by Mario Carneiro,
     3-Sep-2015.) $)
  letopon $p |- ( ordTop ` <_ ) e. ( TopOn ` RR* ) $=
    ( cle ctsr wcel cordt cfv cxr ctopon letsr ledm ordttopon ax-mp ) ABCADEFGE
    CHABFIJK $.

  $( The topology of the extended reals.  (Contributed by Mario Carneiro,
     3-Sep-2015.) $)
  letop $p |- ( ordTop ` <_ ) e. Top $=
    ( cxr cle cordt cfv letopon topontopi ) ABCDEF $.

  $( The topology of the extended reals.  (Contributed by Mario Carneiro,
     3-Sep-2015.) $)
  letopuni $p |- RR* = U. ( ordTop ` <_ ) $=
    ( cxr cle cordt cfv letopon toponunii ) ABCDEF $.

  $( The topology component of the extended real number structure.
     (Contributed by Mario Carneiro, 21-Aug-2015.) $)
  xrstopn $p |- ( ordTop ` <_ ) = ( TopOpen ` RR*s ) $=
    ( cle cordt cfv cxr ctopon wcel cxrs ctopn letopon xrsbas xrstset topontopn
    wceq ax-mp ) ABCZDECFOGHCMIDOGJKLN $.

  $( The extended real number structure is a topological space.  (Contributed
     by Mario Carneiro, 21-Aug-2015.) $)
  xrstps $p |- RR*s e. TopSp $=
    ( cle cordt cfv ctopon wcel cxrs ctps letopon xrsbas xrstset tsettps ax-mp
    cxr ) ABCZMDCEFGEHMNFIJKL $.

  ${
    $d a b w x y z $.  $d a b A $.  $d a b B $.
    leordtval.1 $e |- A = ran ( x e. RR* |-> ( x (,] +oo ) ) $.
    $( Lemma for ~ leordtval .  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    leordtvallem1 $p |- A = ran ( x e. RR* |-> { y e. RR* | -. y <_ x } ) $=
      ( cxr cv cpnf cioc co cmpt crn cle wbr wn crab wcel cin wss wceq wa dfss1
      iocssxr mpbi clt w3a wb simpl pnfxr elioc1 sylancl simpr pnfge adantl jca
      biantrurd 3anan32 syl6bbr xrltnle 3bitr2d rabbi2dva mpteq2ia rneqi eqtri
      syl5eqr ) CAEAFZGHIZJZKAEBFZVELMNZBEOZJZKDVGVKAEVFVJVEEPZVFEVFQZVJVFERVMV
      FSVEGUBVFEUAUCVLVIBEVFVLVHEPZTZVHVFPZVNVEVHUDMZVHGLMZUEZVQVIVOVLGEPVPVSUF
      VLVNUGUHVEGVHUIUJVOVQVNVRTZVQTVSVOVTVQVOVNVRVLVNUKVNVRVLVHULUMUNUOVNVQVRU
      PUQVEVHURUSUTVDVAVBVC $.

    leordtval.2 $e |- B = ran ( x e. RR* |-> ( -oo [,) x ) ) $.
    $( Lemma for ~ leordtval .  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    leordtvallem2 $p |- B = ran ( x e. RR* |-> { y e. RR* | -. x <_ y } ) $=
      ( cxr cmnf cv cico co cmpt crn cle wbr wn crab wcel wa wb cin wss icossxr
      wceq dfss1 mpbi clt w3a mnfxr simpl elico1 sylancr simpr mnfle adantl jca
      biantrurd df-3an syl6bbr xrltnle 3bitr2d rabbi2dva syl5eqr mpteq2ia rneqi
      ancoms eqtri ) DAGHAIZJKZLZMAGVHBIZNOPZBGQZLZMFVJVNAGVIVMVHGRZVIGVIUAZVMV
      IGUBVPVIUDHVHUCVIGUEUFVOVLBGVIVOVKGRZSZVKVIRZVQHVKNOZVKVHUGOZUHZWAVLVRHGR
      VOVSWBTUIVOVQUJHVHVKUKULVRWAVQVTSZWASWBVRWCWAVRVQVTVOVQUMVQVTVOVKUNUOUPUQ
      VQVTWAURUSVQVOWAVLTVKVHUTVFVAVBVCVDVEVG $.

    $( The topology of the extended reals.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    leordtval2 $p |- ( ordTop ` <_ ) = ( topGen ` ( fi ` ( A u. B ) ) ) $=
      ( vy cle cfv cxr wcel wceq ax-mp wss cvv cpnf cmnf mp2an cc0 c1 clt vz vw
      cordt csn cun cfi ctg ctsr letsr ledm leordtvallem1 leordtvallem2 ordtval
      snex cpw xrex pwex cv cioc co cmpt crn eqid iocssxr elpw2 mpbir a1i fmpti
      frn eqsstri cico icossxr unssi ssexi unex ssun2 fiss fvex cuni ovex unipr
      wf cpr cicc mnfxr 0xr pnfxr w3a wbr 0re mnflt pnfge df-icc df-ioc xrltnle
      cr xrletr wa xrlttr wi xrltle 3adant2 syld ixxun mpanr12 mp3an rexri 0lt1
      1re df-ico xrlelttr ixxss2 unss1 eqsstr3i uncom 3sstr3i eqssi eqtri ssun1
      iccmax wrex oveq1 eqeq2d rspcev elrnmpti eleqtrri oveq2 prssi ssfii sstri
      sselii eltg3i eqeltrri snssi bastg ctb ctop fibas tgcl fitop mp2b sseqtri
      2basgen eqtr4i ) GUCHZIUDZBCUEZUEZUFHZUGHZUUGUFHZUGHZGUHJUUEUUJKUIAFBCGUH
      IUJAFBDUKAFBCDEULUMLUUKUUIMZUUIUULMUULUUJKUUHNJUUGUUHMUUMUUFUUGIUNUUGIUOZ
      IUPUQBCUUNBAIAURZOUSUTZVAZVBZUUNDIUUNUUQWBUURUUNMAIUUNUUPUUQUUQVCZUUPUUNJ
      ZUUOIJZUUTUUPIMUUOOVDUUPIUPVEVFVGVHIUUNUUQVILVJCAIPUUOVKUTZVAZVBZUUNEIUUN
      UVCWBUVDUUNMAIUUNUVBUVCUVCVCZUVBUUNJZUVAUVFUVBIMPUUOVLUVBIUPVEVFVGVHIUUNU
      VCVILVJVMVNZVOUUGUUFVPUUGUUHNVQQUUIUULUFHZUULUULNJUUHUULMUUIUVHMUUKUGVRUU
      FUUGUULIUULJUUFUULMROUSUTZPSVKUTZWCZVSZIUULUVLUVIUVJUEZIUVIUVJROUSVTPSVKV
      TWAUVMIUVIUVJIROVDPSVLVMPOWDUTZUVJUVIUEZIUVMUVNPRWDUTZUVIUEZUVOPIJZRIJZOI
      JZUVQUVNKZWEWFWGUVRUVSUVTWHPRTWIZROGWIZUWARWPJUWBWJRWKLUVSUWCWFRWLLAFUAUB
      PROUSWDGGTGWDTGAFUAWMZAFUAWNRUBURZWOUWDUWEROWQUVRUVSUWEIJZWHUWBRUWETWIWRP
      UWETWIZPUWEGWIZPRUWEWSUVRUWFUWGUWHWTUVSPUWEXAXBXCXDXEXFUVPUVJMZUVQUVOMSIJ
      ZRSTWIUWISXIXGZXHAFUAUBPRSWDGTGVKTAFUAXJUWDUWERSXKXLQUVPUVJUVIXMLXNXTUVJU
      VIXOXPXQXRUUKNJZUVKUUKMUVLUULJUUGUFVRZUVKUUGUUKUVIUUGJUVJUUGJUVKUUGMBUUGU
      VIBCXSUVIUURBUVIUURJUVIUUPKZAIYAZUVSUVIUVIKZUWOWFUVIVCUWNUWPARIUUORKUUPUV
      IUVIUUOROUSYBYCYDQAIUUPUVIUUQUUSUUOOUSVTYEVFDYFYKCUUGUVJCBVPUVJUVDCUVJUVD
      JUVJUVBKZAIYAZUWJUVJUVJKZUWRUWKUVJVCUWQUWSASIUUOSKUVBUVJUVJUUOSPVKYGYCYDQ
      AIUVBUVJUVCUVEPUUOVKVTYEVFEYFYKUVIUVJUUGYHQUUGNJUUGUUKMUVGUUGNYILZYJUVKUU
      KNYLQYMIUULYNLUUGUUKUULUWTUWLUUKUULMUWMUUKNYOLYJVMUUHUULNVQQUUKYPJUULYQJU
      VHUULKUUGYRUUKYSUULYTUUAUUBUUKUUIUUCQUUD $.

    leordtval.3 $e |- C = ran (,) $.
    $( The topology of the extended reals.  (Contributed by Mario Carneiro,
       3-Sep-2015.) $)
    leordtval $p |- ( ordTop ` <_ ) = ( topGen ` ( ( A u. B ) u. C ) ) $=
      ( vy va vb cle cfv ctg wcel cxr cioo cv wbr wa eqtri cordt cun leordtval2
      cfi ctsr wceq letsr ledm leordtvallem1 leordtvallem2 wn crab cmpt2 df-ioo
      crn wb xrltnle adantlr ancoms adantll anbi12d rabbidva mpt2eq3ia ordtbas2
      clt rneqi ax-mp fveq2i ) KUALBCUBZUDLZMLVIDUBZMLABCEFUCVJVKMKUENVJVKUFUGA
      HBCDKOIJUHAHBEUIAHBCEFUJDPUOIJOOHQZIQZKRUKZJQZVLKRUKZSZHOULZUMZUOGPVSPIJO
      OVMVLVERZVLVOVERZSZHOULZUMVSIJHUNIJOOWCVRVMONZVOONZSZWBVQHOWFVLONZSVTVNWA
      VPWDWGVTVNUPWEVMVLUQURWEWGWAVPUPZWDWGWEWHVLVOUQUSUTVAVBVCTVFTVDVGVHT $.
  $}

  ${
    $d x y z $.  $d x A $.
    $( A closed interval is closed in the order topology of the extended
       reals.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    iccordt $p |- ( A [,] B ) e. ( Clsd ` ( ordTop ` <_ ) ) $=
      ( vx vz vy cicc co cop cfv cle cordt ccld df-ov cxr cxp cv wcel wral ctsr
      wbr wa crab wf letsr ledm ordtcld3 mp3an1 rgen2a fmpt2 mpbi ctop c0 letop
      df-icc 0cld ax-mp f0cli eqeltri ) ABFGABHZFIJKIZLIZABFMNNOZVAUSFCPZDPZJTV
      DEPZJTUADNUBZVAQZENRCNRVBVAFUCVGCENJSQVCNQVENQVGUDDVCVEJSNUEUFUGUHCENNVFV
      AFCEDUNUIUJUTUKQULVAQUMUTUOUPUQUR $.

    $( An unbounded above open interval is open in the order topology of the
       extended reals.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    iocpnfordt $p |- ( A (,] +oo ) e. ( ordTop ` <_ ) $=
      ( vx vy vz cxr wcel cpnf cioc co cle cfv cmpt crn cun ctb ctop eqid letop
      wceq sseldi wa cordt cv cmnf cico cioo ctg leordtval eqeltrri tgclb mpbir
      wss bastg ax-mp sseqtr4i ssun1 wrex oveq1 eqeq2d rspcev mpan2 ovex sylibr
      elrnmpti adantr wn c0 cxp cpw clt df-ioc ixxf fdmi ndmov syl6eqel pm2.61i
      0opn ) AEFZGEFZUAZAGHIZJUBKZFZVRWCVSVRBEBUCZGHIZLZMZBEUDWDUEILMZNZUFMZNZW
      BWAWKWKUGKZWBWKOFZWKWLULWMWLPFWBWLPBWGWHWJWGQWHQWJQUHZRUIWKUJUKWKOUMUNWNU
      OVRWIWKWAWIWJUPVRWGWIWAWGWHUPVRWAWESZBEUQZWAWGFVRWAWASZWPWAQWOWQBAEWDASWE
      WAWAWDAGHURUSUTVABEWEWAWFWFQWDGHVBVDVCTTTVEVTVFWAVGWBAGEHEEVHEVIHBCDVJJHB
      CDVKVLVMVNWBPFVGWBFRWBVQUNVOVP $.

    $( An unbounded above open interval is open in the order topology of the
       extended reals.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    icomnfordt $p |- ( -oo [,) A ) e. ( ordTop ` <_ ) $=
      ( vx vy vz cmnf cxr wcel cico co cle cfv cmpt crn cun ctb ctop eqid letop
      wceq sseldi wa cordt cv cpnf cioc cioo ctg leordtval eqeltrri tgclb mpbir
      wss bastg ax-mp sseqtr4i ssun1 ssun2 wrex oveq2 eqeq2d rspcev ovex sylibr
      mpan2 elrnmpti adantl wn cxp cpw clt df-ico ixxf fdmi ndmov 0opn syl6eqel
      c0 pm2.61i ) EFGZAFGZUAZEAHIZJUBKZGZVTWDVSVTBFBUCZUDUEILMZBFEWEHIZLZMZNZU
      FMZNZWCWBWLWLUGKZWCWLOGZWLWMULWNWMPGWCWMPBWFWIWKWFQWIQWKQUHZRUIWLUJUKWLOU
      MUNWOUOVTWJWLWBWJWKUPVTWIWJWBWIWFUQVTWBWGSZBFURZWBWIGVTWBWBSZWQWBQWPWRBAF
      WEASWGWBWBWEAEHUSUTVAVDBFWGWBWHWHQEWEHVBVEVCTTTVFWAVGWBVQWCEAFHFFVHFVIHBC
      DJVJHBCDVKVLVMVNWCPGVQWCGRWCVOUNVPVR $.
  $}

  $( An open interval is open in the order topology of the extended reals.
     (Contributed by Mario Carneiro, 3-Sep-2015.) $)
  iooordt $p |- ( A (,) B ) e. ( ordTop ` <_ ) $=
    ( vx cxr cv cpnf cioc co cmpt crn cmnf cico cun cioo cfv ctb wcel ctop eqid
    sselii cle cordt ctg leordtval letop eqeltrri tgclb mpbir bastg ax-mp ssun2
    wss sseqtr4i ioorebas ) CDCEZFGHIJZCDKUOLHIJZMZNJZMZUAUBOZABNHZUTUTUCOZVAUT
    PQZUTVCULVDVCRQVAVCRCUPUQUSUPSUQSUSSUDZUEUFUTUGUHUTPUIUJVEUMUSUTVBUSURUKABU
    NTT $.

  $( The real numbers are an open set in the topology of the extended reals.
     (Contributed by Mario Carneiro, 3-Sep-2015.) $)
  reordt $p |- RR e. ( ordTop ` <_ ) $=
    ( cmnf cpnf cioo co cr cle cordt cfv ioomax iooordt eqeltrri ) ABCDEFGHIABJ
    K $.

  ${
    $d a b c x y z $.  $d y F $.
    lecldbas.1 $e |- F = ( x e. ran [,] |-> ( RR* \ x ) ) $.
    $( The set of closed intervals forms a closed subbasis for the topology on
       the extended reals.  Since our definition of a basis is in terms of open
       sets, we express this by showing that the complements of closed
       intervals form an open subbasis for the topology.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    lecldbas $p |- ( ordTop ` <_ ) = ( topGen ` ( fi ` ran F ) ) $=
      ( vy va vb vc cle cfv cxr cpnf cmnf cvv wcel wss cicc wceq ax-mp wbr clt
      vz cordt crn cfi ctg cv cioc cmpt cico cun eqid leordtval2 fvex cdif wrex
      co wf cxp wfn wb cpw iccf ffn ovelrn difeq2 ccld letopuni cldopn syl6eqel
      iccordt rexlimivw sylbi fmpti frn ssexi mnfxr fnovrn mp3an12 a1i id pnfxr
      mnfle pnfge df-icc df-ioc xrltnle xrletr w3a xrlelttr xrltle 3adant2 syld
      wa wi ixxun syl32anc iccmax syl6eq cin c0 iccssxr ixxdisj mp3an13 sylancr
      uneqdifeq eqcomd eqeq2d rspcev syl2anc xrex difexg elrnmpti sylibr df-ico
      mpbid xrlenlt xrltletr uncom 3eqtr3g incom syl5eq unssi fiss tgss eqsstri
      mp2an ctop letop tgfiss eqssi ) HUBIZBUCZUDIZUEIZYKDJDUFZKUGUPZUHZUCZDJLY
      OUIUPZUHZUCZUJZUDIZUEIZYNDYRUUAYRUKUUAUKULYMMNUUCYMOZUUDYNOYLUDUMYLMNUUBY
      LOUUEYLYKHUBUMPUCZYKBUQYLYKOZAUUFYKJAUFZUNZBCUUHUUFNZUUHEUFZFUFZPUPZQZFJU
      OZEJUOZUUIYKNZPJJURZUSZUUJUUPUTUURJVAZPUQUUSVBUURUUTPVCRZEFJJUUHPVDRUUOUU
      QEJUUNUUQFJUUNUUIJUUMUNZYKUUHUUMJVEUUMYKVFINUVBYKNUUKUULVJUUMYKJVGVHRVIVK
      VKVLVMUUFYKBVNRZVOYRUUAYLJYLYQUQYRYLODJYLYPYQYQUKYOJNZYPUUIQZAUUFUOZYPYLN
      UVDLYOPUPZUUFNZYPJUVGUNZQZUVFUUSLJNZUVDUVHUVAVPJJLYOPVQVRUVDUVIYPUVDUVGYP
      UJZJQZUVIYPQZUVDUVLLKPUPZJUVDUVKUVDKJNZLYOHSZYOKHSZUVLUVOQUVKUVDVPVSZUVDV
      TZUVPUVDWAVSZYOWBZYOWCZEFGUALYOKUGPHHTHPHHEFGWDZEFGWEZYOUAUFZWFZUWDUWFYOK
      WGUVKUVDUWFJNZWHUVQYOUWFTSWMLUWFTSZLUWFHSZLYOUWFWIUVKUWHUWIUWJWNUVDLUWFWJ
      WKWLWOWPWQWRUVDUVGJOUVGYPWSWTQZUVMUVNUTLYOXAUVKUVDUVPUWKVPWAEFGUALYOKUGHH
      THPUWDUWEUWGXBXCUVGYPJXEXDXOXFUVEUVJAUVGUUFUUHUVGQUUIUVIYPUUHUVGJVEXGXHXI
      AUUFUUIYPBCJMNUUIMNXJJUUHMXKRZXLXMVMJYLYQVNRJYLYTUQUUAYLODJYLYSYTYTUKUVDY
      SUUIQZAUUFUOZYSYLNUVDYOKPUPZUUFNZYSJUWOUNZQZUWNUUSUVDUVPUWPUVAWAJJYOKPVQX
      CUVDUWQYSUVDUWOYSUJZJQZUWQYSQZUVDYSUWOUJZUVOUWSJUVDUVKUVDUVPUVQUVRUXBUVOQ
      UVSUVTUWAUWBUWCEFGUALYOKPPHTHHUIHHEFGXNZUWDYOUWFXPZUWDUWHUVDUVPWHUWFYOTSU
      VRWMUWFKTSZUWFKHSZUWFYOKXQUWHUVPUXEUXFWNUVDUWFKWJWKWLLYOUWFWGWOWPYSUWOXRW
      QXSUVDUWOJOUWOYSWSZWTQUWTUXAUTYOKXAUVDUXGYSUWOWSZWTUWOYSXTUVKUVDUVPUXHWTQ
      VPWAEFGUALYOKPHTHHUIUXCUWDUXDXBXCYAUWOYSJXEXDXOXFUWMUWRAUWOUUFUUHUWOQUUIU
      WQYSUUHUWOJVEXGXHXIAUUFUUIYSBCUWLXLXMVMJYLYTVNRYBUUBYLMYCYFUUCYMMYDYFYEYK
      YGNUUGYNYKOYHUVCYLYKYIYFYJ $.
  $}

  ${
    $d a b c u x y z A $.
    $( A neighborhood of ` +oo ` contains an unbounded interval based at a real
       number.  Together with ~ xrtgioo (which describes neighborhoods of
       ` RR ` ) and ~ mnfnei , this gives all "negative" topological
       information ensuring that it is not too fine (and of course ~ iooordt
       and similar ensure that it has all the sets we want).  (Contributed by
       Mario Carneiro, 3-Sep-2015.) $)
    pnfnei $p |- ( ( A e. ( ordTop ` <_ ) /\ +oo e. A ) ->
        E. x e. RR ( x (,] +oo ) C_ A ) $=
      ( vy vu cle wcel cxr cpnf cioc co cmnf wss cr wrex eqid wa wb cc0 wbr clt
      va vb vc cordt cfv cv cmpt crn cico cun cioo ctg leordtval eleq2i wo elun
      tg2 wi wceq cvv vex elrnmpt ax-mp cif mnfxr a1i simprl ifcl sylancl pnfxr
      0xr xrmax1 sylancr ge0gtmnf syl2anc w3a simpll simprr elioc1 mpbid simp2d
      eleqtrd 0re ltpnf breq1 ifboth xrre2 syl32anc xrmax2 df-ioc ixxss1 simplr
      xrlelttr eqsstr3d sstrd oveq1 sseq1d rspcev rexlimdvaa com12 sylbi pnfnlt
      wn elico1 mpan simp3 syl6bi mtod eleq2 notbid syl5ibrcom rexlimiv pm2.21d
      adantrd jaoi pnfnre neli cuni elssuni unirnioo syl6sseqr sseld syl sylanb
      mtoi ) BEUDUEZFBCGCUFZHIJZUGZUHZCGKYGUIJZUGZUHZUJZUKUHZUJZULUEZFZHBFZAUFZ
      HIJZBLZAMNZYFYQBCYJYMYOYJOYMOYOOUMUNYRYSPHDUFZFZUUDBLZPZDYPNUUCDBYPHUQUUG
      UUCDYPUUDYPFUUDYNFZUUDYOFZUOUUGUUCURZUUDYNYOUPUUHUUJUUIUUHUUDYJFZUUDYMFZU
      OUUJUUDYJYMUPUUKUUJUULUUKUUDYHUSZCGNZUUJUUDUTFZUUKUUNQDVAZCGYHUUDYIUTYIOV
      BVCUUGUUNUUCUUGUUMUUCCGUUGYGGFZUUMPZPZRYGESZYGRVDZMFZUVAHIJZBLZUUCUUSKGFZ
      UVAGFZHGFZKUVATSZUVAHTSZUVBUVEUUSVEVFUUSUUQRGFZUVFUUGUUQUUMVGZVKUUTYGRGVH
      VIZUVGUUSVJVFUUSUVFRUVAESZUVHUVLUUSUVJUUQUVMVKUVKRYGVLVMUVAVNVOUUSYGHTSZR
      HTSZUVIUUSUVGUVNHHESZUUSHYHFZUVGUVNUVPVPZUUSHUUDYHUUEUUFUURVQUUGUUQUUMVRZ
      WBUUSUUQUVGUVQUVRQUVKVJYGHHVSVIVTWARMFUVOWCRWDVCUUTUVNUVOUVIYGRYGUVAHTWER
      UVAHTWEWFVIKUVAHWGWHUUSUVCYHBUUSUUQYGUVAESZUVCYHLUVKUUSUVJUUQUVTVKUVKRYGW
      IVMUAUBUCAYGUVAHITETIEUAUBUCWJZUWAYGUVAYTWMWKVOUUSYHUUDBUVSUUEUUFUURWLWNW
      OUUBUVDAUVAMYTUVAUSUUAUVCBYTUVAHIWPWQWRVOWSWTXAUULUUDYKUSZCGNZUUJUUOUULUW
      CQUUPCGYKUUDYLUTYLOVBVCUWCUUEUUCUUFUWCUUEUUCUWBUUEXCZCGUUQUWDUWBHYKFZXCUU
      QUWEHYGTSZYGXBUUQUWEUVGKHESZUWFVPZUWFUVEUUQUWEUWHQVEKYGHXDXEUVGUWGUWFXFXG
      XHUWBUUEUWEUUDYKHXIXJXKXLXMXNXAXOXAUUIUUEUUCUUFUUIUUEUUCUUIUUEHMFHMXPXQUU
      IUUDMHUUIUUDYOXRMUUDYOXSXTYAYBYEXMXNXOXAXLYCYD $.

    $( A neighborhood of ` -oo ` contains an unbounded interval based at a real
       number.  (Contributed by Mario Carneiro, 3-Sep-2015.) $)
    mnfnei $p |- ( ( A e. ( ordTop ` <_ ) /\ -oo e. A ) ->
        E. x e. RR ( -oo [,) x ) C_ A ) $=
      ( vy vu cle wcel cxr cpnf co cmnf cico wss cr wrex wa clt wbr cc0 sylancr
      eqid va vb vc cordt cfv cv cioc cmpt crn cun cioo ctg leordtval eleq2i wo
      tg2 wi elun wceq cvv wb vex elrnmpt ax-mp wn nltmnf w3a pnfxr mpan2 simp2
      elioc1 syl6bi mtod eleq2 notbid syl5ibrcom rexlimiv pm2.21d adantrd sylbi
      cif mnfxr a1i 0xr simprl ifcl 0re mnflt simpll simprr elico1 mpbid simp3d
      eleqtrd breq2 ifboth xrmin1 ltpnf mp1i xrlelttrd syl32anc xrmin2 xrltletr
      xrre2 df-ico ixxss2 syl2anc simplr eqsstr3d sstrd oveq2 sseq1d rexlimdvaa
      rspcev com12 jaoi mnfnre neli cuni elssuni unirnioo syl6sseqr mtoi sylanb
      sseld syl ) BEUDUEZFBCGCUFZHUGIZUHZUIZCGJYHKIZUHZUIZUJZUKUIZUJZULUEZFZJBF
      ZJAUFZKIZBLZAMNZYGYRBCYKYNYPYKTYNTYPTUMUNYSYTOJDUFZFZUUEBLZOZDYQNUUDDBYQJ
      UPUUHUUDDYQUUEYQFUUEYOFZUUEYPFZUOUUHUUDUQZUUEYOYPURUUIUUKUUJUUIUUEYKFZUUE
      YNFZUOUUKUUEYKYNURUULUUKUUMUULUUEYIUSZCGNZUUKUUEUTFZUULUUOVADVBZCGYIUUEYJ
      UTYJTVCVDUUOUUFUUDUUGUUOUUFUUDUUNUUFVEZCGYHGFZUURUUNJYIFZVEUUSUUTYHJPQZYH
      VFUUSUUTJGFZUVAJHEQZVGZUVAUUSHGFZUUTUVDVAVHYHHJVKVIUVBUVAUVCVJVLVMUUNUUFU
      UTUUEYIJVNVOVPVQVRVSVTUUMUUEYLUSZCGNZUUKUUPUUMUVGVAUUQCGYLUUEYMUTYMTVCVDU
      UHUVGUUDUUHUVFUUDCGUUHUUSUVFOZOZRYHEQZRYHWAZMFZJUVKKIZBLZUUDUVIUVBUVKGFZU
      VEJUVKPQZUVKHPQUVLUVBUVIWBWCUVIRGFZUUSUVOWDUUHUUSUVFWEZUVJRYHGWFSZUVEUVIV
      HWCZUVIJRPQZJYHPQZUVPRMFZUWAWGRWHVDUVIUVBJJEQZUWBUVIJYLFZUVBUWDUWBVGZUVIJ
      UUEYLUUFUUGUVHWIUUHUUSUVFWJZWNUVIUVBUUSUWEUWFVAWBUVRJYHJWKSWLWMUVJUWAUWBU
      VPRYHRUVKJPWOYHUVKJPWOWPSUVIUVKRHUVSUVQUVIWDWCUVTUVIUVQUUSUVKREQWDUVRRYHW
      QSUWCRHPQUVIWGRWRWSWTJUVKHXDXAUVIUVMYLBUVIUUSUVKYHEQZUVMYLLUVRUVIUVQUUSUW
      HWDUVRRYHXBSUAUBUCAJUVKYHKEPPKEUAUBUCXEZUWIUUAUVKYHXCXFXGUVIYLUUEBUWGUUFU
      UGUVHXHXIXJUUCUVNAUVKMUUAUVKUSUUBUVMBUUAUVKJKXKXLXNXGXMXOVTXPVTUUJUUFUUDU
      UGUUJUUFUUDUUJUUFJMFJMXQXRUUJUUEMJUUJUUEYPXSMUUEYPXTYAYBYEYCVRVSXPVTVQYFY
      D $.

    ordtrestixx.1 $e |- A C_ RR* $.
    ordtrestixx.2 $e |- ( ( x e. A /\ y e. A ) -> ( x [,] y ) C_ A ) $.
    $( The restriction of the less than order to an interval gives the same
       topology as the subspace topology.  (Contributed by Mario Carneiro,
       9-Sep-2015.) $)
    ordtrestixx $p |- ( ( ordTop ` <_ ) |`t A ) =
      ( ordTop ` ( <_ i^i ( A X. A ) ) ) $=
      ( vz cle cordt cfv co wceq wtru cxr wcel a1i wss cv wa wbr sseli cxp ledm
      crest ctsr letsr crab cicc iccval syl2an eqsstr3d adantl ordtrest2 eqcomd
      cin trud ) GHICUCJZGCCUAUNHIZKLUQUPLABFCGMUBGUDNLUEOCMPLDOAQZCNZBQZCNZRZU
      RFQZGSVCUTGSRFMUFZCPLVBVDURUTUGJZCUSURMNUTMNVEVDKVACMURDTCMUTDTFURUTUHUIE
      UJUKULUMUO $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The restriction of the less than order to a closed interval gives the
       same topology as the subspace topology.  (Contributed by Mario Carneiro,
       9-Sep-2015.) $)
    ordtresticc $p |- ( ( ordTop ` <_ ) |`t ( A [,] B ) ) =
      ( ordTop ` ( <_ i^i ( ( A [,] B ) X. ( A [,] B ) ) ) ) $=
      ( vx vy cicc co iccssxr cv iccss2 ordtrestixx ) CDABEFABGABCHDHIJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Limits and continuity in topological spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Cn $.
  $c CnP $.
  $c ~~>t $.  $( Limit arrow. $)

  $( Extend class notation with the set of continuous functions between
     topologies. $)
  ccn $a class Cn $.

  $( Extend class notation with the set of functions between topologies
     continuous at a point. $)
  ccnp $a class CnP $.

  $( Extend class notation with a function on topological spaces whose value is
     the convergence relation for limit sequences in the space. $)
  clm $a class ~~>t $.

  ${
    $d j k f x y g u J $.
    $( Define a function on two topologies whose value is the set of continuous
       mappings from the first topology to the second.  Based on definition of
       continuous function in [Munkres] p. 102.  See ~ iscn for the predicate
       form.  (Contributed by NM, 17-Oct-2006.) $)
    df-cn $a |- Cn = ( j e. Top , k e. Top |->
                  { f e. ( U. k ^m U. j ) | A. y e. k ( `' f " y ) e. j } ) $.

    $( Define a function on two topologies whose value is the set of continuous
       mappings at a specified point in the first topology.  Based on Theorem
       7.2(g) of [Munkres] p. 107.  (Contributed by NM, 17-Oct-2006.) $)
    df-cnp $a |- CnP = ( j e. Top , k e. Top |-> ( x e. U. j |->
                  { f e. ( U. k ^m U. j ) | A. y e. k ( ( f ` x ) e. y ->
                    E. g e. j ( x e. g /\ ( f " g ) C_ y ) ) } ) ) $.

    $( Define a function on topologies whose value is the convergence relation
       for the space.  Although ` f ` is typically a function from upper
       integers to the topological space, it doesn't have to be.
       Unfortunately, the value of the function must exist to use ~ fvmpt , and
       we use the otherwise unnecessary conjunct ` dom f C_ CC ` to ensure
       that.  (Contributed by NM, 7-Sep-2006.) $)
    df-lm $a |- ~~>t = ( j e. Top |-> { <. f , x >. |
      ( f e. ( U. j ^pm CC ) /\ x e. U. j /\ A. u e. j ( x e. u ->
        E. y e. ran ZZ>= ( f |` y ) : y --> u ) ) } ) $.

    $( The topological space convergence relation is a relation.  (Contributed
       by NM, 7-Dec-2006.)  (Revised by Mario Carneiro, 14-Nov-2013.) $)
    lmrel $p |- Rel ( ~~>t ` J ) $=
      ( vf vj vx vu vy cv cuni cc cpm co wcel cres wf cuz crn wrex wi wral w3a
      ctop clm df-lm relmptopab ) BGZCGZHZIJKLDGZUGLUHEGZLFGZUIUEUJMNFOPQREUFST
      CBDUAAUBDFEBCUCUD $.

    $( Reverse closure for the convergence relation.  (Contributed by Mario
       Carneiro, 7-Sep-2015.) $)
    lmrcl $p |- ( F ( ~~>t ` J ) P -> J e. Top ) $=
      ( vj vf vx vu vy clm cfv wbr cdm ctop cv cuni cc cpm co wcel cres cuz crn
      wf wrex wi wral w3a copab df-lm dmmptss cop df-br elfvdm sylbi sseldi ) B
      ACIJZKZILZMCDMENZDNZOZPQRSFNZVASVBGNZSHNZVCUSVDTUCHUAUBUDUEGUTUFUGEFUHIFH
      GEDUIUJUQBAUKZUPSCURSBAUPULVECIUMUNUO $.
  $}

  ${
    $d f y F $.  $d f j k w x y K $.  $d f j k w x y X $.  $d f j k w x y Y $.
    $d f j k u v w x y J $.
    $( The relation "sequence ` f ` converges to point ` y ` " in a metric
       space.  (Contributed by NM, 7-Sep-2006.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    lmfval $p |- ( J e. ( TopOn ` X ) -> ( ~~>t ` J ) =
      { <. f , x >. | ( f e. ( X ^pm CC ) /\ x e. X /\
        A. u e. J ( x e. u -> E. y e. ran ZZ>= ( f |` y ) : y --> u ) ) } ) $=
      ( vj wcel cv cuni cc cpm co wral w3a copab ctop cvv wceq wa ctopon cfv wf
      cres cuz crn wrex wi clm cmpt df-lm a1i simpr unieqd adantr eqtr4d oveq1d
      toponuni eleq2d raleqdv opabbidv topontop cxp wss df-3an opabbii opabssxp
      3anbi123d eqsstri ovex toponmax xpexg sylancr ssexg fvmptd ) EFUAUBHZGEDI
      ZGIZJZKLMZHZAIZVSHZWBCIZHBIZWDVQWEUDUCBUEUFUGUHZCVRNZOZDAPZVQFKLMZHZWBFHZ
      WFCENZOZDAPZQUIRUIGQWIUJSVPABCDGUKULVPVRESZTZWHWNDAWQWAWKWCWLWGWMWQVTWJVQ
      WQVSFKLWQVSEJZFWQVREVPWPUMZUNVPFWRSWPFEURUOUPZUQUSWQVSFWBWTUSWQWFCVREWSUT
      VHVAFEVBVPWOWJFVCZVDXARHZWORHWOWKWLTWMTZDAPXAWNXCDAWKWLWMVEVFWMDAWJFVGVIV
      PWJRHFEHXBFKLVJFEVKWJFREVLVMWOXARVNVMVO $.

    $( The set of all continuous functions from topology ` J ` to topology
       ` K ` .  (Contributed by NM, 17-Oct-2006.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    cnfval $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( J Cn K ) = { f e. ( Y ^m X ) | A. y e. K ( `' f " y ) e. J } ) $=
      ( vj vk ctopon cfv wcel wa ctop cv wral cuni cmap co crab wceq ccnv cmpt2
      cima ccn cvv df-cn simprr unieqd toponuni ad2antlr eqtr4d simprl ad2antrr
      a1i oveq12d eleq2d raleqbidv rabeqbidv topontop adantr ovex rabex ovmpt2d
      adantl ) CEIJKZDFIJKZLZGHCDMMBNUAANUCZGNZKZAHNZOZBVKPZVIPZQRZSZVHCKZADOZB
      FEQRZSZUDUEUDGHMMVPUBTVGABGHUFUNVGVICTZVKDTZLZLZVLVRBVOVSWDVMFVNEQWDVMDPZ
      FWDVKDVGWAWBUGZUHVFFWETVEWCFDUIUJUKWDVNCPZEWDVICVGWAWBULZUHVEEWGTVFWCECUI
      UMUKUOWDVJVQAVKDWFWDVICVHWHUPUQURVECMKVFECUSUTVFDMKVEFDUSVDVTUEKVGVRBVSFE
      QVAVBUNVC $.

    $( The function mapping the points in a topology ` J ` to the set of all
       functions from ` J ` to topology ` K ` continuous at that point.
       (Contributed by NM, 17-Oct-2006.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    cnpfval $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
        ( J CnP K ) = ( x e. X |-> { f e. ( Y ^m X ) | A. w e. K
        ( ( f ` x ) e. w -> E. v e. J ( x e. v /\ ( f " v ) C_ w ) ) } ) ) $=
      ( vj vk cfv wcel wa ctop cv cuni cmap cvv wceq a1i ctopon cima wrex wi co
      wss wral crab cmpt ccnp cmpt2 df-cnp simprl unieqd toponuni eqtr4d simprr
      ad2antrr ad2antlr oveq12d rexeqdv imbi2d raleqbidv topontop adantr adantl
      rabeqbidv mpteq12dv cpw wf ovex elpw2 mpbir eqid fmptd toponmax pwex fex2
      ssrab2 syl3anc ovmpt2d ) EGUAKLZFHUAKLZMZIJEFNNAIOZPZAOZDOZKBOZLZWGCOZLWH
      WKUBWIUFMZCWEUCZUDZBJOZUGZDWOPZWFQUEZUHZUIZAGWJWLCEUCZUDZBFUGZDHGQUEZUHZU
      IZUJRUJIJNNWTUKSWDABDCIJULTWDWEESZWOFSZMZMZAWFWSGXEXJWFEPZGXJWEEWDXGXHUMZ
      UNWBGXKSWCXIGEUOURUPZXJWPXCDWRXDXJWQHWFGQXJWQFPZHXJWOFWDXGXHUQZUNWCHXNSWB
      XIHFUOUSUPXMUTXJWNXBBWOFXOXJWMXAWJXJWLCWEEXLVAVBVCVGVHWBENLWCGEVDVEWCFNLW
      BHFVDVFWDGXDVIZXFVJGELZXPRLZXFRLWDAGXEXPXFXEXPLZWDWGGLMXSXEXDUFXCDXDVSXEX
      DHGQVKZVLVMTXFVNVOWBXQWCGEVPVEXRWDXDXTVQTGXPXFERVRVTWA $.
  $}

  ${
    $d f g j k u v w x y J $.  $d f j k v w x y K $.  $d f j k v w x y X $.
    $d f x y F $.  $d f v x y P $.  $d f j k v w x y Y $.
    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` ."  Definition of continuous function in [Munkres]
       p. 102.  (Contributed by NM, 17-Oct-2006.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    iscn $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
    ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. y e. K ( `' F " y ) e. J ) ) ) $=
      ( vf ctopon cfv wcel wa ccn co cv ccnv cima wral cmap crab toponmax cnveq
      wf cnfval eleq2d wceq imaeq1d eleq1d ralbidv elmapg syl2anr anbi1d syl5bb
      elrab wb bitrd ) CEHIJZDFHIJZKZBCDLMZJBGNZOZANZPZCJZADQZGFERMZSZJZEFBUBZB
      OZVBPZCJZADQZKZURUSVGBAGCDEFUCUDVHBVFJZVMKURVNVEVMGBVFUTBUEZVDVLADVPVCVKC
      VPVAVJVBUTBUAUFUGUHUMURVOVIVMUQFDJECJVOVIUNUPFDTECTFEBDCUIUJUKULUO $.

    $( The set of all functions from topology ` J ` to topology ` K ` that are
       continuous at a point ` P ` .  (Contributed by NM, 17-Oct-2006.)
       (Revised by Mario Carneiro, 11-Nov-2013.) $)
    cnpval $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ P e. X ) ->
      ( ( J CnP K ) ` P ) = { f e. ( Y ^m X ) | A. y e. K
            ( ( f ` P ) e. y -> E. x e. J ( P e. x /\ ( f " x ) C_ y ) ) } ) $=
      ( vv ctopon cfv wcel co cv wa wrex wi wral cmap crab ccnp cima wss fveq1d
      wceq cmpt cnpfval fveq2 eleq1d eleq1 rexbidv imbi12d ralbidv rabbidv eqid
      anbi1d ovex rabex fvmpt sylan9eq 3impa ) EGJKLZFHJKLZCGLZCEFUAMZKZCDNZKZB
      NZLZCANZLZVGVKUBVIUCZOZAEPZQZBFRZDHGSMZTZUEVBVCOZVDVFCIGINZVGKZVILZWAVKLZ
      VMOZAEPZQZBFRZDVRTZUFZKVSVTCVEWJIBADEFGHUGUDICWIVSGWJWACUEZWHVQDVRWKWGVPB
      FWKWCVJWFVOWKWBVHVIWACVGUHUIWKWEVNAEWKWDVLVMWACVKUJUPUKULUMUNWJUOVQDVRHGS
      UQURUSUTVA $.

    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ."  Based on Theorem 7.2(g) of [Munkres]
       p. 107.  (Contributed by NM, 17-Oct-2006.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    iscnp $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ P e. X ) ->
      ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\ A. y e. K
          ( ( F ` P ) e. y -> E. x e. J ( P e. x /\ ( F " x ) C_ y ) ) ) ) ) $=
      ( vf ctopon cfv wcel co cv cima wss wa wrex wi wral w3a ccnp cmap crab wf
      cnpval eleq2d wb wceq eleq1d imaeq1 sseq1d anbi2d rexbidv imbi12d ralbidv
      fveq1 elrab toponmax elmapg syl2anr anbi1d syl5bb 3adant3 bitrd ) EGJKLZF
      HJKLZCGLZUAZDCEFUBMKZLDCINZKZBNZLZCANZLZVKVOOZVMPZQZAERZSZBFTZIHGUCMZUDZL
      ZGHDUEZCDKZVMLZVPDVOOZVMPZQZAERZSZBFTZQZVIVJWDDABCIEFGHUFUGVFVGWEWOUHVHWE
      DWCLZWNQVFVGQZWOWBWNIDWCVKDUIZWAWMBFWRVNWHVTWLWRVLWGVMCVKDUQUJWRVSWKAEWRV
      RWJVPWRVQWIVMVKDVOUKULUMUNUOUPURWQWPWFWNVGHFLGELWPWFUHVFHFUSGEUSHGDFEUTVA
      VBVCVDVE $.

    iscn.1 $e |- X = U. J $.
    iscn.2 $e |- Y = U. K $.
    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` ."  Definition of continuous function in [Munkres]
       p. 102.  (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    iscn2 $p |- ( F e. ( J Cn K ) <-> ( ( J e. Top /\ K e. Top ) /\
               ( F : X --> Y /\ A. y e. K ( `' F " y ) e. J ) ) ) $=
      ( vj vk vf ccn co wcel ctop wa ccnv cv cima wral cuni cmap df-cn elmpt2cl
      wf crab ctopon cfv wb toptopon iscn syl2anb biadan2 ) BCDLMNZCONZDONZPEFB
      UEBQARZSCNADTPZIJOOKRQUQSIRZNAJRZTKUTUAUSUAUBMUFCDLBAKIJUCUDUOCEUGUHNDFUG
      UHNUNURUIUPCEGUJDFHUJABCDEFUKULUM $.

    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ."  Based on Theorem 7.2(g) of [Munkres]
       p. 107.  (Contributed by Mario Carneiro, 21-Aug-2015.) $)
    iscnp2 $p |- ( F e. ( ( J CnP K ) ` P ) <->
      ( ( J e. Top /\ K e. Top /\ P e. X ) /\ ( F : X --> Y /\ A. y e. K
          ( ( F ` P ) e. y -> E. x e. J ( P e. x /\ ( F " x ) C_ y ) ) ) ) ) $=
      ( vf ccnp cfv wcel ctop cv wa wral c0 cvv vj vk vg vw vv co w3a cima wrex
      wf wss wi cop cxp cdm wceq n0i df-ov ndmfv syl5eq fveq1d 0fv syl6eq nsyl2
      wn cuni cmap crab cmpt df-cnp cpw ssrab2 ovex elpw2 mpbir rgenw eqid fmpt
      mpbi vex uniex pwex fex2 mp3an dmmpt2 syl6eleq opelxp sylib simpld simprd
      elfvdm ctopon toptopon cnpfval syl2anb syl dmeqd rabex ax-mp eleqtrd 3jca
      dmmptg wb biid iscnp syl3anb biadan2 ) DCEFLUFZMZNZEONZFONZCGNZUGGHDUJCDM
      BPZNCAPZNDXOUHXNUKQAEUIULBFRQZXJXKXLXMXJXKXLXJEFUMZOOUNZNXKXLQZXJXQLUOZXR
      XJXISUPXQXTNZXIDUQYAVEZXICSMSYBCXHSYBXHXQLMSEFLURXQLUSUTVACVBVCVDUAUBOOAU
      APZVFZXOKPZMZXNNXOUCPZNYEYGUHXNUKQUCYCUIULBUBPZRZKYHVFZYDVGUFZVHZVIZLABKU
      CUAUBVJYDYKVKZYMUJZYDTNYNTNYMTNYLYNNZAYDRYOYPAYDYPYLYKUKYIKYKVLYLYKYJYDVG
      VMZVNVOVPAYDYNYLYMYMVQVRVSYCUAVTWAYKYQWBYDYNYMTTWCWDWEWFEFOOWGWHZWIXJXKXL
      YRWJXJCXHUOZGDCXHWKXJYSAGYFUDPZNXOUEPZNYEUUAUHYTUKQUEEUIULUDFRZKHGVGUFZVH
      ZVIZUOZGXJXHUUEXJXSXHUUEUPZYRXKEGWLMNZFHWLMNZUUGXLEGIWMZFHJWMZAUDUEKEFGHW
      NWOWPWQUUDTNZAGRUUFGUPUULAGUUBKUUCHGVGVMWRVPAGUUDTXBWSVCWTXAXKUUHXLUUIXMX
      MXJXPXCUUJUUKXMXDABCDEFGHXEXFXG $.
  $}

  ${
    $d x y F $.  $d x y J $.  $d x y K $.  $d x y X $.  $d x y Y $.
    $d P x y $.
    $( Reverse closure for a continuous function.  (Contributed by Mario
       Carneiro, 21-Aug-2015.) $)
    cntop1 $p |- ( F e. ( J Cn K ) -> J e. Top ) $=
      ( vx ccn co wcel ctop wa cuni wf ccnv cima wral eqid iscn2 simplbi simpld
      cv ) ABCEFGZBHGZCHGZTUAUBIBJZCJZAKALDSMBGDCNIDABCUCUDUCOUDOPQR $.

    $( Reverse closure for a continuous function.  (Contributed by Mario
       Carneiro, 21-Aug-2015.) $)
    cntop2 $p |- ( F e. ( J Cn K ) -> K e. Top ) $=
      ( vx ccn co wcel ctop wa cuni wf ccnv cima wral eqid iscn2 simplbi simprd
      cv ) ABCEFGZBHGZCHGZTUAUBIBJZCJZAKALDSMBGDCNIDABCUCUDUCOUDOPQR $.

    $( Reverse closure for a function continuous at a point.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    cnptop1 $p |- ( F e. ( ( J CnP K ) ` P ) -> J e. Top ) $=
      ( vy vx ccnp co cfv wcel ctop cuni w3a wf cv cima wss wa wrex eqid iscnp2
      wi wral simplbi simp1d ) BACDGHIJZCKJZDKJZACLZJZUFUGUHUJMUIDLZBNABIEOZJAF
      OZJBUMPULQRFCSUBEDUCRFEABCDUIUKUITUKTUAUDUE $.

    $( Reverse closure for a function continuous at a point.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    cnptop2 $p |- ( F e. ( ( J CnP K ) ` P ) -> K e. Top ) $=
      ( vy vx ccnp co cfv wcel ctop cuni w3a wf cv cima wss wa wrex eqid iscnp2
      wi wral simplbi simp2d ) BACDGHIJZCKJZDKJZACLZJZUFUGUHUJMUIDLZBNABIEOZJAF
      OZJBUMPULQRFCSUBEDUCRFEABCDUIUKUITUKTUAUDUE $.

    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ."  (Contributed by NM, 15-May-2007.) $)
    iscnp3 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ P e. X ) ->
                   ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\ A. y e. K
       ( ( F ` P ) e. y -> E. x e. J ( P e. x /\ x C_ ( `' F " y ) ) ) ) ) ) $=
      ( ctopon cfv wcel cv cima wss wa wrex wi wral wb ad2antlr ccnp co wf ccnv
      w3a iscnp wfun cdm ffun toponss adantlr wceq fdm funimass3 syl2anc anbi2d
      sseqtr4d rexbidva imbi2d ralbidv pm5.32da 3ad2ant1 bitrd ) EGIJKZFHIJKZCG
      KZUEDCEFUAUBJKGHDUCZCDJBLZKZCALZKZDVJMVHNZOZAEPZQZBFRZOZVGVIVKVJDUDVHMNZO
      ZAEPZQZBFRZOZABCDEFGHUFVDVEVQWCSVFVDVGVPWBVDVGOZVOWABFWDVNVTVIWDVMVSAEWDV
      JEKZOZVLVRVKWFDUGZVJDUHZNVLVRSVGWGVDWEGHDUITWFVJGWHVDWEVJGNVGVJEGUJUKVGWH
      GULVDWEGHDUMTUQVJVHDUNUOUPURUSUTVAVBVC $.

    iscnp2.1 $e |- X = U. J $.
    $( Reverse closure for a function continuous at a point.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    cnprcl $p |- ( F e. ( ( J CnP K ) ` P ) -> P e. X ) $=
      ( vy vx ccnp co cfv wcel ctop w3a cuni wf cv cima wss wa wrex wral iscnp2
      wi eqid simplbi simp3d ) BACDIJKLZCMLZDMLZAELZUHUIUJUKNEDOZBPABKGQZLAHQZL
      BUNRUMSTHCUAUDGDUBTHGABCDEULFULUEUCUFUG $.

    iscnp2.2 $e |- Y = U. K $.
    $( A continuous function is a mapping.  (Contributed by FL, 8-Dec-2006.)
       (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnf $p |- ( F e. ( J Cn K ) -> F : X --> Y ) $=
      ( vx ccn co wcel wf ccnv cv cima wral ctop wa iscn2 simprbi simpld ) ABCI
      JKZDEALZAMHNOBKHCPZUBBQKCQKRUCUDRHABCDEFGSTUA $.

    $( A continuous function at point ` P ` is a mapping.  (Contributed by FL,
       17-Nov-2006.)  (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnpf $p |- ( F e. ( ( J CnP K ) ` P ) -> F : X --> Y ) $=
      ( vy vx ccnp co cfv wcel wf cv cima wss wa ctop wrex wi w3a iscnp2 simpld
      wral simprbi ) BACDKLMNZEFBOZABMIPZNAJPZNBUKQUJRSJCUAUBIDUFZUHCTNDTNAENUC
      UIULSJIABCDEFGHUDUGUE $.

    $( The value of a continuous function from ` J ` to ` K ` at point ` P `
       belongs to the underlying set of topology ` K ` .  (Contributed by FL,
       27-Dec-2006.)  (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnpcl $p |- ( ( F e. ( ( J CnP K ) ` P ) /\ A e. X ) -> ( F ` A ) e. Y ) $=
      ( ccnp co cfv wcel cnpf ffvelrnda ) CBDEJKLMFGACBCDEFGHINO $.
  $}

  ${
    $d x F $.  $d x J $.  $d x K $.  $d x X $.  $d x Y $.
    $( A continuous function is a mapping.  (Contributed by Mario Carneiro,
       21-Aug-2015.) $)
    cnf2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\
        F e. ( J Cn K ) ) -> F : X --> Y ) $=
      ( vx ctopon cfv wcel ccn co wf wa ccnv cv cima wral iscn simprbda 3impa )
      BDGHIZCEGHIZABCJKIZDEALZUAUBMUCUDANFOPBIFCQFABCDERST $.

    $( A continuous function at point ` P ` is a mapping.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    cnpf2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\
        F e. ( ( J CnP K ) ` P ) ) -> F : X --> Y ) $=
      ( ctopon cfv wcel ccnp co wf wa cuni eqid cnpf toponuni feq2d wceq wb syl
      feq3 sylan9bb syl5ibr 3impia ) CEGHIZDFGHIZBACDJKHIZEFBLZUHUIUFUGMCNZDNZB
      LZABCDUJUKUJOUKOPUFUIUJFBLZUGULUFEUJFBECQRUGFUKSUMULTFDQFUKUJBUBUAUCUDUE
      $.

    $( Reverse closure for a function continuous at a point.  (Contributed by
       Mario Carneiro, 21-Aug-2015.) $)
    cnprcl2 $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( ( J CnP K ) ` P ) ) ->
        P e. X ) $=
      ( ctopon cfv wcel ccnp co wa cuni eqid cnprcl adantl wceq toponuni adantr
      eleqtrrd ) CEFGHZBACDIJGHZKACLZEUAAUBHTABCDUBUBMNOTEUBPUAECQRS $.
  $}

  ${
    $d x y z B $.  $d x y z F $.  $d x y z J $.  $d x y z K $.  $d x y z P $.
    $d x z ph $.  $d x y z X $.  $d x y z Y $.
    tgcn.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    tgcn.3 $e |- ( ph -> K = ( topGen ` B ) ) $.
    tgcn.4 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    $( The contininuity predicate when the range is given by a basis for a
       topology.  (Contributed by Mario Carneiro, 7-Feb-2015.)  (Revised by
       Mario Carneiro, 22-Aug-2015.) $)
    tgcn $p |- ( ph -> ( F e. ( J Cn K ) <->
      ( F : X --> Y /\ A. y e. B ( `' F " y ) e. J ) ) ) $=
      ( vx vz wcel cv wral wa wi ctop syl ccn co wf ccnv cima ctopon wb syl2anc
      cfv iscn wss ctg ctb topontop eqeltrrd tgclb sylibr bastg sseqtr4d ssralv
      cuni wceq wex eleq2d eltg3 bitrd ciun iunopn sylan9r imaeq2 imauni syl6eq
      eleq1d imbi2d syl5ibrcom expimpd exlimdv sylbid imp cbvralv syl6ib impbid
      ex ralrimdva anbi2d ) ADEFUAUBNZGHDUCZDUDZBOZUEZENZBFPZQZWGWKBCPZQAEGUFUI
      NZFHUFUINZWFWMUGIKBDEFGHUJUHAWLWNWGAWLWNACFUKWLWNRACCULUIZFACUMNZCWQUKAWQ
      SNWRAFWQSJAWPFSNKHFUNTUOCUPUQZCUMURTJUSWKBCFUTTAWNWHLOZUEZENZLFPWLAWNXBLF
      AWTFNZWNXBRZAXCMOZCUKZWTXEVAZVBZQZMVCZXDAXCWTWQNZXJAFWQWTJVDAWRXKXJUGWSMW
      TCUMVETVFAXIXDMAXFXHXDAXFQXDXHWNBXEWJVGZENZRXFWNWKBXEPZAXMWKBXECUTAESNZXN
      XMRAWOXOIGEUNTXOXNXMBXEWJEVHWCTVIXHXBXMWNXHXAXLEXHXAWHXGUEXLWTXGWHVJBWHXE
      VKVLVMVNVOVPVQVRVSWDXBWKLBFWTWIVBXAWJEWTWIWHVJVMVTWAWBWEVF $.

    tgcnp.5 $e |- ( ph -> P e. X ) $.
    $( The "continuous at a point" predicate when the range is given by a basis
       for a topology.  (Contributed by Mario Carneiro, 3-Feb-2015.)  (Revised
       by Mario Carneiro, 22-Aug-2015.) $)
    tgcnp $p |- ( ph ->
                   ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\ A. y e. B
       ( ( F ` P ) e. y -> E. x e. J ( P e. x /\ ( F " x ) C_ y ) ) ) ) ) $=
      ( cfv wcel wss wa wi syl vz ccnp co wf cv cima wrex wral wb iscnp syl3anc
      ctopon ctg ctb ctop topontop eqeltrrd tgclb sylibr sseqtr4d ssralv anim2d
      bastg sylbid eleq2d biimpa tg2 r19.29 sstr expcom reximdv com12 rexlimivw
      imim2i imp32 ex com23 ralrimdva sylibrd impbid ) AFEGHUBUCOPZIJFUDZEFOZCU
      EZPZEBUEZPZFWFUFZWDQZRZBGUGZSZCDUHZRZAWAWBWLCHUHZRZWNAGIULOPZHJULOPZEIPZW
      AWPUIKMNBCEFGHIJUJUKAWOWMWBADHQWOWMSADDUMOZHADUNPZDWTQAWTUOPXAAHWTUOLAWRH
      UOPMJHUPTUQDURUSDUNVCTLUTWLCDHVATVBVDAWNWBWCUAUEZPZWGWHXBQZRZBGUGZSZUAHUH
      ZRZWAAWMXHWBAWMXGUAHAXBHPZRXBWTPZWMXGSAXJXKAHWTXBLVEVFXKXCWMXFXKXCWMXFSZX
      KXCRWEWDXBQZRZCDUGZXLCXBDWCVGWMXOXFWMXORWLXNRZCDUGXFWLXNCDVHXPXFCDWLWEXMX
      FWKXMXFSWEXMWKXFXMWJXEBGXMWIXDWGWIXMXDWHWDXBVIVJVBVKVLVNVOVMTVJTVPVQTVRVB
      AWQWRWSWAXIUIKMNBUAEFGHIJUJUKVSVT $.
  $}

  ${
    $d x y z B $.  $d x y z F $.  $d x y z J $.  $d x y z X $.  $d x y z Y $.
    $d y K $.  $d x z ph $.  $d z V $.
    subbascn.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    subbascn.2 $e |- ( ph -> B e. V ) $.
    subbascn.3 $e |- ( ph -> K = ( topGen ` ( fi ` B ) ) ) $.
    subbascn.4 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    $( The contininuity predicate when the range is given by a subbasis for a
       topology.  (Contributed by Mario Carneiro, 7-Feb-2015.)  (Revised by
       Mario Carneiro, 22-Aug-2015.) $)
    subbascn $p |- ( ph -> ( F e. ( J Cn K ) <-> ( F : X --> Y /\
        A. y e. B ( `' F " y ) e. J ) ) ) $=
      ( vx vz wcel wral wa cfn cvv ccn co wf ccnv cv cima cfi cfv wss wi adantr
      tgcn ssfii ssralv 3syl cint wceq cpw cin wrex vex elfi sylancr w3a simpr2
      wb ciin imaeq2d wfun wne ffun ad2antlr syl6eqelr sylibr intpreima syl2anc
      intex eqtrd ctopon topontop syl ad2antrr inss2 simpr1 sseldi inss1 elpwid
      c0 ctop simpr3 sylc iinopn syl13anc eqeltrd 3exp2 rexlimdv com23 ralrimdv
      sylbid imaeq2 eleq1d cbvralv syl6ibr impbid pm5.32da bitrd ) ADEFUAUBPHID
      UCZDUDZBUEZUFZEPZBCUGUHZQZRXGXKBCQZRABXLDEFHIJLMULAXGXMXNAXGRZXMXNXOCGPZC
      XLUIXMXNUJAXPXGKUKZCGUMXKBCXLUNUOXOXNXHNUEZUFZEPZNXLQXMXOXNXTNXLXOXRXLPZX
      NXTXOYAXROUEZUPZUQZOCURZSUSZUTZXNXTUJZXOXRTPXPYAYGVFNVAZXQOXRCTGVBVCXOYDY
      HOYFXOYBYFPZYDXNXTXOYJYDXNVDZRZXSBYBXJVGZEYLXSXHYCUFZYMYLXRYCXHXOYJYDXNVE
      ZVHYLDVIZYBWHVJZYNYMUQXGYPAYKHIDVKVLYLYCTPYQYLYCXRTYOYIVMYBVQVNZBYBDVOVPV
      RYLEWIPZYBSPYQXKBYBQZYMEPAYSXGYKAEHVSUHPYSJHEVTWAWBYLYFSYBYESWCXOYJYDXNWD
      ZWEYRYLYBCUIXNYTYLYBCYLYFYEYBYESWFUUAWEWGXOYJYDXNWJXKBYBCUNWKBYBXJEWLWMWN
      WOWPWSWQWRXKXTBNXLXIXRUQXJXSEXIXRXHWTXAXBXCXDXEXF $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y J $.  $d x y K $.  $d x y P $.  $d x X $.
    $( The identity function is a continuous function from one topology to
       another topology on the same set iff the domain is finer than the
       codomain.  (Contributed by Mario Carneiro, 21-Mar-2015.)  (Revised by
       Mario Carneiro, 21-Aug-2015.) $)
    ssidcn $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` X ) ) ->
      ( ( _I |` X ) e. ( J Cn K ) <-> K C_ J ) ) $=
      ( vx ctopon cfv wcel wa cid cres ccn co ccnv cv cima wral wf syl6bbr wceq
      wss iscn wf1o f1oi f1of biantrur cnvresid imaeq1i elssuni adantl toponuni
      ax-mp cuni ad2antlr sseqtr4d resiima syl5eq eleq1d ralbidva dfss3 bitrd
      syl ) ACEFZGZBVBGZHZICJZABKLGZVFMZDNZOZAGZDBPZBATZVEVGCCVFQZVLHVLDVFABCCU
      AVNVLCCVFUBVNCUCCCVFUDUKUERVEVLVIAGZDBPVMVEVKVODBVEVIBGZHZVJVIAVQVJVFVIOZ
      VIVHVFVICUFUGVQVICTVRVISVQVIBULZCVPVIVSTVEVIBUHUIVDCVSSVCVPCBUJUMUNCVIUOV
      AUPUQURDBAUSRUT $.

    $( Property of a function continuous at a point.  (Contributed by FL,
       31-Dec-2006.) $)
    cnpimaex $p |- ( ( F e. ( ( J CnP K ) ` P ) /\ A e. K /\ ( F ` P ) e. A )
       -> E. x e. J ( P e. x /\ ( F " x ) C_ A ) ) $=
      ( vy ccnp co cfv wcel cv cima wss wa wrex wi cuni ctop eqid wf w3a iscnp2
      wral simprbi simprd wceq eleq2 sseq2 anbi2d rexbidv imbi12d rspccv 3imp
      syl ) DCEFHIJKZBFKZCDJZBKZCALZKZDUTMZBNZOZAEPZUPURGLZKZVAVBVFNZOZAEPZQZGF
      UDZUQUSVEQZQUPERZFRZDUAZVLUPESKFSKCVNKUBVPVLOAGCDEFVNVOVNTVOTUCUEUFVKVMGB
      FVFBUGZVGUSVJVEVFBURUHVQVIVDAEVQVHVCVAVFBVBUIUJUKULUMUOUN $.

    $( A restricted identity function is a continuous function.  (Contributed
       by FL, 27-Dec-2006.)  (Proof shortened by Mario Carneiro,
       21-Mar-2015.) $)
    idcn $p |- ( J e. ( TopOn ` X ) -> ( _I |` X ) e. ( J Cn J ) ) $=
      ( ctopon cfv wcel cid cres ccn co wss ssid wb ssidcn anidms mpbiri ) ABCD
      EZFBGAAHIEZAAJZAKPQRLAABMNO $.
  $}

  ${
    $d f j k u x y z F $.  $d f j k u x y z J $.  $d j k u ph $.  $d j k u Z $.
    $d j M $.  $d f j k u x z P $.  $d f j k u x y z X $.
    lmbr.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a topological space.  Definition 1.4-1 of [Kreyszig] p. 25.
       The condition ` F C_ ( CC X. X ) ` allows us to use objects more general
       than sequences when convenient; see the comment in ~ df-lm .
       (Contributed by Mario Carneiro, 14-Nov-2013.) $)
    lmbr $p |- ( ph -> ( F ( ~~>t ` J ) P <->
      ( F e. ( X ^pm CC ) /\ P e. X /\ A. u e. J ( P e. u ->
        E. y e. ran ZZ>= ( F |` y ) : y --> u ) ) ) ) $=
      ( vf vx cfv wbr cv wcel cres wf wi wral wceq wa clm cc cpm co cuz crn w3a
      wrex copab ctopon lmfval breqd reseq1 feq1d rexbidv imbi2d ralbidv imbi1d
      syl eleq1 sylan9bb df-3an opabbii brab2ga bitr4i syl6bb ) AEDFUAKZLEDIMZG
      UBUCUDZNZJMZGNZVKCMZNZBMZVMVHVOOZPZBUEUFZUHZQZCFRZUGZIJUIZLZEVINZDGNZDVMN
      ZVOVMEVOOZPZBVRUHZQZCFRZUGZAVGWCEDAFGUJKNVGWCSHJBCIFGUKUSULWDWEWFTWLTWMWA
      WLIJEDVIGWCVHESZWAVNWJQZCFRVKDSZWLWNVTWOCFWNVSWJVNWNVQWIBVRWNVOVMVPWHVHEV
      OUMUNUOUPUQWPWOWKCFWPVNWGWJVKDVMUTURUQVAWBVJVLTWATIJVJVLWAVBVCVDWEWFWLVBV
      EVF $.

    lmbr2.4 $e |- Z = ( ZZ>= ` M ) $.
    lmbr2.5 $e |- ( ph -> M e. ZZ ) $.
    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a metric space using an arbitrary set of upper integers.
       (Contributed by Mario Carneiro, 14-Nov-2013.) $)
    lmbr2 $p |- ( ph -> ( F ( ~~>t ` J ) P <->
            ( F e. ( X ^pm CC ) /\ P e. X /\ A. u e. J ( P e. u -> E. j e. Z
              A. k e. ( ZZ>= ` j ) ( k e. dom F /\ ( F ` k ) e. u ) ) ) ) ) $=
      ( vz wcel cv cuz wrex wa cz clm cfv wbr cc cpm co cres wf crn wi wral w3a
      cdm lmbr cpw wfn wb uzf ffn wceq reseq2 id rexrn mp2b wfun pmfun ad2antrl
      feq12d ffvresb rexbidv adantr rexuz3 bitr4d syl5bb imbi2d pm5.32da df-3an
      syl ralbidv 3bitr4g bitrd ) AFCGUAUBUCFIUDUEUFOZCIOZCBPZOZNPZWDFWFUGZUHZN
      QUIRZUJZBGUKZULZWBWCWEEPZFUMOWMFUBWDOSZEDPQUBZUKZDJRZUJZBGUKZULZANBCFGIKU
      NAWBWCSZWKSXAWSSWLWTAXAWKWSAXASZWJWRBGXBWIWQWEWIWOWDFWOUGZUHZDTRZXBWQTTUO
      ZQUHQTUPWIXEUQURTXFQUSWHXDNDTQWFWOUTZWFWOWDWGXCWFWOFVAXGVBVHVCVDXBXEWPDTR
      ZWQXBXDWPDTXBFVEZXDWPUQWBXIAWCIUDFVFVGEWOWDFVIVRVJXBHTOZWQXHUQAXJXAMVKWND
      EHJLVLVRVMVNVOVSVPWBWCWKVQWBWCWSVQVTWA $.

    lmbrf.6 $e |- ( ph -> F : Z --> X ) $.
    lmbrf.7 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a metric space using an arbitrary set of upper integers.
       This version of ~ lmbr2 presupposes that ` F ` is a function.
       (Contributed by Mario Carneiro, 14-Nov-2013.) $)
    lmbrf $p |- ( ph -> ( F ( ~~>t ` J ) P <-> ( P e. X /\
         A. u e. J ( P e. u -> E. j e. Z A. k e. ( ZZ>= ` j ) A e. u ) ) ) ) $=
      ( cfv cc wcel wa clm wbr cpm co cv cdm cuz wral wrex wi w3a 3anass uztrn2
      lmbr2 wb eleq1d wf fdm syl eleq2d biimpar biantrurd bitr3d sylan2 anassrs
      wceq ralbidva rexbidva imbi2d ralbidv anbi2d cvv wss ctopon toponmax cnex
      jctir cz uzssz zsscn sstri eqsstri elpm2r syl2anc bitr2d syl5bb bitrd ) A
      GDHUAQUBGJRUCUDSZDJSZDBUEZSZFUEZGUFZSZWLGQZWJSZTZFEUEZUGQZUHZEKUIZUJZBHUH
      ZUKZWIWKCWJSZFWSUHZEKUIZUJZBHUHZTZABDEFGHIJKLMNUNXDWHWIXCTZTZAXJWHWIXCULA
      XJXKXLAXIXCWIAXHXBBHAXGXAWKAXFWTEKAWRKSZTXEWQFWSAXMWLWSSZXEWQUOZXMXNTAWLK
      SZXOIWLWRKMUMAXPTZWPXEWQXQWOCWJPUPXQWNWPAWNXPAWMKWLAKJGUQZWMKVFOKJGURUSUT
      VAVBVCVDVEVGVHVIVJVKAWHXKAJHSZRVLSZTXRKRVMZTWHAXSXTAHJVNQSXSLJHVOUSVPVQAX
      RYAOKIUGQZRMYBVRRIVSVTWAWBVQJRKGHVLWCWDVBWEWFWG $.
  $}

  ${
    $d j k u J $.  $d j k u M $.  $d j k u P $.  $d j k u X $.  $d j k u Z $.
    lmconst.2 $e |- Z = ( ZZ>= ` M ) $.
    $( A constant sequence converges to its value.  (Contributed by NM,
       8-Nov-2007.)  (Revised by Mario Carneiro, 14-Nov-2013.) $)
    lmconst $p |- ( ( J e. ( TopOn ` X ) /\ P e. X /\ M e. ZZ ) ->
                   ( Z X. { P } ) ( ~~>t ` J ) P ) $=
      ( vu vk vj ctopon cfv wcel cz w3a csn cv cuz wral syl wceq cxp clm wbr wi
      wrex simp2 simp3 uzid syl6eleqr idd ralrimdva fveq2 raleqdv rspcev ee12an
      wa ralrimivw simp1 wf fconst6g fvconst2g sylan lmbrf mpbir2and ) BDJKLZAD
      LZCMLZNZEAOUAZABUBKUCVFAGPLZVJHIPZQKZRZIEUEZUDZGBRVEVFVGUFZVHVOGBVHCELVJV
      JHCQKZRZVNVHCVQEVHVGCVQLVEVFVGUGZCUHSFUIVHVJVJHVQVHHPZVQLUPVJUJUKVMVRICEV
      KCTVJHVLVQVKCQULUMUNUOUQVHGAAIHVIBCDEVEVFVGURFVSVHVFEDVIUSVPEADUTSVHVFVTE
      LVTVIKATVPEAVTDVAVBVCVD $.
  $}

  ${
    $d j k u F $.  $d j k u J $.  $d j k u P $.  $d j k u ph $.  $d j k u U $.
    $d j M $.  $d j k u Z $.
    lmcvg.1 $e |- Z = ( ZZ>= ` M ) $.
    lmcvg.3 $e |- ( ph -> P e. U ) $.
    lmcvg.4 $e |- ( ph -> M e. ZZ ) $.
    lmcvg.5 $e |- ( ph -> F ( ~~>t ` J ) P ) $.
    lmcvg.6 $e |- ( ph -> U e. J ) $.
    $( Convergence property of a converging sequence.  (Contributed by Mario
       Carneiro, 14-Nov-2013.) $)
    lmcvg $p |- ( ph -> E. j e. Z A. k e. ( ZZ>= ` j ) ( F ` k ) e. U ) $=
      ( vu wcel cv cfv wral wrex cuz wi cdm wa cuni cpm clm wbr w3a ctop ctopon
      cc lmrcl syl toptopon sylib lmbr2 mpbid simp3d simpr ralimi reximi imim2i
      co eqid wceq eleq2 rexralbidv imbi12d rspcv syl3c ) ACGPBOQZPZEQZFRZVLPZE
      DQUARZSZDITZUBZOGSZBCPZVOCPZEVQSDITZNAVMVNFUCPZVPUDZEVQSZDITZUBZOGSZWAAFG
      UEZULUFVDPZBWKPZWJAFBGUGRUHZWLWMWJUIMAOBDEFGHWKIAGUJPZGWKUKRPAWNWOMBFGUMU
      NGWKWKVEUOUPJLUQURUSWIVTOGWHVSVMWGVRDIWFVPEVQWEVPUTVAVBVCVAUNKVTWBWDUBOCG
      VLCVFZVMWBVSWDVLCBVGWPVPWCDEIVQVLCVOVGVHVIVJVK $.
  $}

  ${
    $d x y z F $.  $d x y z J $.  $d x y z K $.  $d x y z P $.  $d x y z X $.
    $d x y z Y $.
    $( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ." in terms of neighborhoods.
       (Contributed by FL, 18-Jul-2011.)  (Revised by Mario Carneiro,
       10-Sep-2015.) $)
    iscnp4 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ P e. X ) ->
      ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y
          /\ A. y e. ( ( nei ` K ) ` { ( F ` P ) } )
          E. x e. ( ( nei ` J ) ` { P } ) ( F " x ) C_ y ) ) ) $=
      ( vz cfv wcel cv cima wss wrex wa syl syl2anc wb syl3anc ctopon w3a co wf
      ccnp csn cnei wral cnpf2 3expa 3adantl3 simplr ctop cuni simpll2 topontop
      cnt eqid neii1 sylancom ntropn simpr adantr simpll3 ffvelrnd wceq eleqtrd
      toponuni snssd neiint fvex sylibr cnpimaex simpl1 ad2antrr simprl simprrl
      mpbid snss opnneip simprrr ntrss2 sstrd jca reximdv2 mpd ralrimiva simprr
      ex wi snssg mpbird imass2 eleq2 imaeq2 sseq1d anbi12d syl12anc rexlimdvaa
      rspcev embantd com23 exp4a ralimdv2 imdistanda iscnp sylibrd impbid ) EGU
      AJKZFHUAJKZCGKZUBZDCEFUEUCJKZGHDUDZDALZMZBLZNZACUFZEUGJJZOZBCDJZUFZFUGJJZ
      UHZPZXLXMYFXLXMPZXNYEXIXJXMXNXKXIXJXMXNCDEFGHUIUJUKZYGYABYDYGXQYDKZPZCXOK
      ZXPXQFUQJJZNZPZAEOZYAYJXMYLFKZYBYLKZYOXLXMYIULYJFUMKZXQFUNZNZYPYJXJYRXIXJ
      XKXMYIUOZHFUPZQZYGYIYRYTUUCYCFXQYSYSURZUSUTZXQFYSUUDVARYJYCYLNZYQYJYIUUFY
      GYIVBYJYRYCYSNYTYIUUFSUUCYJYBYSYJYBHYSYJGHCDYGXNYIYHVCXIXJXKXMYIVDVEYJXJH
      YSVFUUAHFVHQVGVIUUEYCFXQYSUUDVJTVRYBYLCDVKVSVLAYLCDEFVMTYJYNXRAEXTYJXOEKZ
      YNPZXOXTKZXRPZYJUUHPZUUIXRUUKEUMKZUUGYKUUIUUKXIUULYGXIYIUUHXIXJXKXMVNVOGE
      UPZQYJUUGYNVPYJUUGYKYMVQCEXOVTTUUKXPYLXQYJUUGYKYMWAYJYLXQNZUUHYJYRYTUUNUU
      CUUEXQFYSUUDWBRVCWCWDWIWEWFWGWDWIXLYFXNYBXQKZCILZKZDUUPMZXQNZPZIEOZWJZBFU
      HZPXMXLXNYEUVCXLXNPZYAUVBBYDFUVDYIYAWJZXQFKZUUOUVAUVDUVFUUOPZUVEUVAUVDUVG
      UVEUVAWJUVDUVGPZYIYAUVAUVHYRUVFUUOYIUVHXJYRXIXJXKXNUVGUOUUBQUVDUVFUUOVPUV
      DUVFUUOWHYBFXQVTTUVHXRUVAAXTUVHUUJPZXOEUQJJZEKZCUVJKZDUVJMZXQNZUVAUVIUULX
      OEUNZNZUVKUVIXIUULUVDXIUVGUUJXIXJXKXNVNVOZUUMQZUVIUULUUIUVPUVRUVHUUIXRVPZ
      XSEXOUVOUVOURZUSRZXOEUVOUVTVARUVIUVLXSUVJNZUVIUUIUWBUVSUVIUULXSUVONUVPUUI
      UWBSUVRUVICUVOUVICGUVOUVHXKUUJXIXJXKXNUVGVDVCZUVIXIGUVOVFUVQGEVHQVGVIUWAX
      SEXOUVOUVTVJTVRUVIXKUVLUWBSUWCCUVJGWKQWLUVIUVMXPXQUVIUVJXONZUVMXPNUVIUULU
      VPUWDUVRUWAXOEUVOUVTWBRUVJXODWMQUVHUUIXRWHWCUUTUVLUVNPIUVJEUUPUVJVFZUUQUV
      LUUSUVNUUPUVJCWNUWEUURUVMXQUUPUVJDWOWPWQWTWRWSXAWIXBXCXDXEIBCDEFGHXFXGXH
      $.
  $}

  ${
    $d g o y A $.  $d g o y F $.  $d g o y J $.  $d g o y K $.  $d g o y X $.
    $d g o y Y $.
    cnpnei.1 $e |- X = U. J $.
    cnpnei.2 $e |- Y = U. K $.
    $( A condition for continuity at a point in terms of neighborhoods.
       (Contributed by Jeff Hankins, 7-Sep-2009.) $)
    cnpnei $p |- ( ( ( J e. Top /\ K e. Top /\ F : X --> Y ) /\ A e. X ) ->
      ( F e. ( ( J CnP K ) ` A ) <-> A. y e. ( ( nei ` K ) ` { ( F ` A ) } )
        ( `' F " y ) e. ( ( nei ` J ) ` { A } ) ) ) $=
      ( vo vg wcel w3a wa cfv wss wrex wi wb adantlr ctop wf ccnp ccnv cima csn
      cnei wral cdm cnvimass fdm syl5sseq 3ad2ant3 ad2antrr 3ad2antl2 ad2ant2rl
      co cv neii2 simpll simprl fvex snss biimpri adantr ad2antll 3jca cnpimaex
      adantll syl sstr2 com12 ad2antlr wfun ffun eltopss sseq2d mpbird 3adantl2
      funimass3 sylibd anim2d reximdva mpd rexlimddv isneip 3ad2antl1 mpbir2and
      syl2anc exp32 ralrimdv simpll3 opnneip imaeq2 eleq1d rspcv 3expb 3ad2ant1
      weq 3com23 ex snssg ad3antlr ad3antrrr biimpar syldan anbi12d 3syld com24
      biimprd imp ralrimiv iscnp2 baib 3expa 3adantl3 impbid ) DUALZEUALZFGCUBZ
      MZBFLZNZCBDEUCUQOLZCUDZAURZUEZBUFZDUGOOZLZABCOZUFZEUGOOZUHZYCYDYJAYMYCYDY
      FYMLZYJYCYDYONZNZYJYGFPZBJURZLZYSYGPZNZJDQZYAYRYBYPXTXRYRXSXTCUIZYGFCYFUJ
      FGCUKZULUMUNYQYLKURZPZUUFYFPZNZUUCKEYAYOUUIKEQZYBYDXSXRYOUUJXTYLKEYFUSUOU
      PYQUUFELZUUINZNZYTCYSUEZUUFPZNZJDQZUUCUUMYDUUKYKUUFLZMZUUQYPUULUUSYCYPUUL
      NYDUUKUURYDYOUULUTYPUUKUUIVAUUIUURYPUUKUUGUURUUHUURUUGYKUUFBCVBVCVDVEVFVG
      VIJUUFBCDEVHVJUUMUUPUUBJDUUMYSDLZNZUUOUUAYTUVAUUOUUNYFPZUUAUULUUOUVBRZYQU
      UTUUHUVCUUKUUGUUOUUHUVBUUNUUFYFVKVLVFVMUVACVNZYSUUDPZUVBUUASYQUVDUULUUTYA
      UVDYBYPXTXRUVDXSFGCVOUMZUNUNYQUUTUVEUULYCUUTUVEYPYAUUTUVEYBXRXTUUTUVEXSXR
      XTNUUTNUVEYSFPZXRUUTUVGXTYSDFHVPTXTUVEUVGSXRUUTXTUUDFYSUUEVQVMVRVSTTTYSYF
      CVTWIWAWBWCWDWEYCYJYRUUCNSZYPXRXSYBUVHXTBJDYGFHWFWGVEWHWJWKYCYNYDYCYNNZYD
      XTYKYSLZBUUFLZCUUFUEYSPZNZKDQZRZJEUHZXRXSXTYBYNWLUVIUVOJEYCYNYSELZUVORYCU
      VJUVQYNUVNYCUVJUVQYNUVNRYCUVJUVQNZNZYNYEYSUEZYILZYHUUFPZUUFUVTPZNZKDQZUVN
      YAUVRYNUWARZYBXSXRUVRUWFXTXSUVJUVQUWFXSUVQUVJUWFXSUVQUVJMYSYMLUWFYKEYSWMY
      JUWAAYSYMAJWSYGUVTYIYFYSYEWNWOWPVJWTWQUOTYAUWAUWERZYBUVRXRXSUWGXTXRUWAUWE
      YHKDUVTUSXAWRUNUVSUWDUVMKDUVSUUFDLZNZUVMUWDUWIUVKUWBUVLUWCYBUVKUWBSYAUVRU
      WHBUUFFXBXCUWIUVDUUFUUDPZUVLUWCSYAUVDYBUVRUWHUVFXDYCUWHUWJUVRYAUWHUWJYBYA
      UWHUUFFPZUWJXRXSUWHUWKXTUUFDFHVPWGYAUWJUWKXTXRUWJUWKSXSXTUUDFUUFUUEVQUMXE
      XFTTUUFYSCVTWIXGXJWCXHWJXIXKXLYCYDXTUVPNZSZYNXRXSYBUWMXTXRXSYBUWMYDXRXSYB
      MUWLKJBCDEFGHIXMXNXOXPVEWHXAXQ $.
  $}

  ${
    $d x A $.  $d x F $.  $d x J $.  $d x K $.
    $( An open subset of the codomain of a continuous function has an open
       preimage.  (Contributed by FL, 15-Dec-2006.) $)
    cnima $p |- ( ( F e. ( J Cn K ) /\ A e. K ) -> ( `' F " A ) e. J ) $=
      ( vx ccn co wcel ccnv cv cima wral cuni wf ctop eqid iscn2 simprbi simprd
      wa wceq imaeq2 eleq1d rspccva sylan ) BCDFGHZBIZEJZKZCHZEDLZADHUGAKZCHZUF
      CMZDMZBNZUKUFCOHDOHTUPUKTEBCDUNUOUNPUOPQRSUJUMEADUHAUAUIULCUHAUGUBUCUDUE
      $.
  $}

  ${
    $d x F $.  $d x G $.  $d x J $.  $d x K $.  $d x L $.
    $( The composition of two continuous functions is a continuous function.
       (Contributed by FL, 8-Dec-2006.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    cnco $p |- ( ( F e. ( J Cn K ) /\ G e. ( K Cn L ) ) ->
        ( G o. F ) e. ( J Cn L ) ) $=
      ( vx ccn co wcel wa ctop cuni ccom wf ccnv cv cima eqid cnf cnima anim12i
      wral cntop1 cntop2 fco syl2anr cnvco imaeq1i imaco simpll adantll syl2anc
      eqtri syl5eqel ralrimiva jca iscn2 sylanbrc ) ACDGHIZBDEGHIZJZCKIZEKIZJCL
      ZELZBAMZNZVFOZFPZQZCIZFEUBZJVFCEGHIUSVBUTVCACDUCBDEUDUAVAVGVLUTDLZVEBNVDV
      MANVGUSBDEVMVEVMRZVERZSACDVDVMVDRZVNSVDVMVEBAUEUFVAVKFEVAVIEIZJZVJAOZBOZV
      IQZQZCVJVSVTMZVIQWBVHWCVIBAUGUHVSVTVIUIUMVRUSWADIZWBCIUSUTVQUJUTVQWDUSVIB
      DETUKWAACDTULUNUOUPFVFCEVDVEVPVOUQUR $.
  $}

  ${
    $d x y z F $.  $d x y z G $.  $d x y z J $.  $d x y z K $.  $d x y z L $.
    $d x y z P $.  $d x y z X $.
    $( The composition of two continuous functions at point ` P ` is a
       continuous function at point ` P ` .  Proposition of [BourbakiTop1] p.
       I.9.  (Contributed by FL, 16-Nov-2006.)  (Proof shortened by Mario
       Carneiro, 27-Dec-2014.) $)
    cnpco $p |- ( ( F e. ( ( J CnP K ) ` P ) /\
                    G e. ( ( K CnP L ) ` ( F ` P ) ) ) ->
                  ( G o. F ) e. ( ( J CnP L ) ` P ) ) $=
      ( vz vx vy ccnp co cfv wcel wa cuni wf cv cima wss adantr ctop wi cnptop1
      w3a ccom wrex wral cnptop2 adantl eqid cnprcl 3jca cnpf fco simplr simprl
      syl2anc wceq fvco3 simprr eqeltrrd cnpimaex syl3anc simplll simprrl imaco
      imass2 syl5eqss simprrr sstr2 syl5com syl5 anim2d mpd rexlimddv ralrimiva
      reximdv expr jca iscnp2 sylanbrc ) BADEJKLMZCABLZEFJKLMZNZDUAMZFUAMZADOZM
      ZUDWHFOZCBUEZPZAWKLZGQZMZAHQZMZWKWPRZWNSZNZHDUFZUBZGFUGZNWKADFJKLMWEWFWGW
      IWBWFWDABDEUCTWDWGWBWCCEFUHUIWBWIWDABDEWHWHUJZUKTZULWEWLXCWEEOZWJCPZWHXFB
      PZWLWDXGWBWCCEFXFWJXFUJZWJUJZUMUIWBXHWDABDEWHXFXDXIUMTZWHXFWJCBUNUQWEXBGF
      WEWNFMZWOXAWEXLWONZNZWCIQZMZCXORZWNSZNZXAIEXNWDXLWCCLZWNMXSIEUFWBWDXMUOWE
      XLWOUPXNWMXTWNWEWMXTURZXMWEXHWIYAXKXEWHXFACBUSUQTWEXLWOUTVAIWNWCCEFVBVCXN
      XOEMZXSNZNZWQBWPRZXOSZNZHDUFZXAYDWBYBXPYHWBWDXMYCVDXNYBXSUPXNYBXPXRVEHXOA
      BDEVBVCYDYGWTHDYDYFWSWQYFWRXQSZYDWSYFWRCYERXQCBWPVFYEXOCVGVHYDXRYIWSXNYBX
      PXRVIWRXQWNVJVKVLVMVQVNVOVRVPVSHGAWKDFWHWJXDXJVTWA $.
  $}

  $( A closed subset of the codomain of a continuous function has a closed
     preimage.  (Contributed by NM, 15-Mar-2007.)  (Revised by Mario Carneiro,
     21-Aug-2015.) $)
  cnclima $p |- ( ( F e. ( J Cn K ) /\ A e. ( Clsd ` K ) ) ->
    ( `' F " A ) e. ( Clsd ` J ) ) $=
    ( ccn co wcel ccld cfv wa ccnv cima cuni cdif wf wceq eqid adantr wfun syl
    cnf ffun funcnvcnv imadif 3syl fimacnv difeq1d eqtr2d cldopn sylan2 eqeltrd
    cnima ctop wss wb cntop1 cdm cnvimass fdm syl5sseq iscld2 syl2anc mpbird )
    BCDEFGZADHIGZJZBKZALZCHIGZCMZVHNZCGZVFVKVGDMZANZLZCVFVJVMBOZVKVOPVDVPVEBCDV
    JVMVJQZVMQZUARZVPVOVGVMLZVHNZVKVPBSVGKSVOWAPVJVMBUBBUCVMAVGUDUEVPVTVJVHVJVM
    BUFUGUHTVEVDVNDGVOCGADVMVRUIVNBCDULUJUKVFCUMGZVHVJUNVIVLUOVDWBVEBCDUPRVFBUQ
    ZVHVJBAURVFVPWCVJPVSVJVMBUSTUTVHCVJVQVAVBVC $.

  ${
    $d F x y $.  $d J x y $.  $d K x y $.  $d X x y $.  $d Y x y $.
    $( A definition of a continuous function using closed sets.  Theorem 1 (d)
       of [BourbakiTop1] p.  I.9.  (Contributed by FL, 19-Nov-2006.)  (Proof
       shortened by Mario Carneiro, 21-Aug-2015.) $)
    iscncl $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\
        A. y e. ( Clsd ` K ) ( `' F " y ) e. ( Clsd ` J ) ) ) ) $=
      ( vx ctopon cfv wcel wa ccnv cv cima ccld wral ralrimiva cuni cdif wceq
      ccn co wf cnf2 3expa cnclima adantl jca simprl toponuni ad3antrrr simplrl
      fimacnv eqcomd syl eqtr3d wfun ffun funcnvcnv imadif 4syl eqtr4d ad3antlr
      difeq1d ctop topontop opncld sylancom eqeltrd simplrr imaeq2 eleq1d rspcv
      eqid sylc wss wb cdm cnvimass syl5sseq sseqtrd isopn2 syl2anc mpbird iscn
      fdm adantr mpbir2and impbida ) CEHIJZDFHIJZKZBCDUAUBJZEFBUCZBLZAMZNZCOIZJ
      ZADOIZPZKZWLWMKWNXAWJWKWMWNBCDEFUDUEWMXAWLWMWSAWTWPBCDUFQUGUHWLXBKZWMWNWO
      GMZNZCJZGDPZWLWNXAUIXCXFGDXCXDDJZKZXFCRZXESZWRJZXIXKWOFXDSZNZWRXIXKWOFNZX
      ESZXNXIXJXOXEXIEXJXOWJEXJTWKXBXHECUJUKZXIWNEXOTWLWNXAXHULZWNXOEEFBUMUNUOU
      PVDXIWNBUQWOLUQXNXPTXREFBURBUSFXDWOUTVAVBXIXMWTJXAXNWRJZXIXMDRZXDSZWTXIFX
      TXDWKFXTTWJXBXHFDUJVCVDXCXHDVEJZYAWTJWKYBWJXBXHFDVFVCXDDXTXTVNVGVHVIWLWNX
      AXHVJWSXSAXMWTWPXMTWQXNWRWPXMWOVKVLVMVOVIXICVEJZXEXJVPXFXLVQWJYCWKXBXHECV
      FUKXIXEEXJXIBVRZXEEBXDVSXIWNYDETXREFBWFUOVTXQWAXECXJXJVNWBWCWDQWLWMWNXGKV
      QXBGBCDEFWEWGWHWI $.
  $}

  ${
    cncls2i.1 $e |- Y = U. K $.
    $( Property of the preimage of a closure.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    cncls2i $p |- ( ( F e. ( J Cn K ) /\ S C_ Y ) ->
      ( ( cls ` J ) ` ( `' F " S ) ) C_ ( `' F " ( ( cls ` K ) ` S ) ) ) $=
      ( ccn co wcel wss wa ccnv ccl cfv cima ccld ctop cntop2 clscld sylan cuni
      cnclima syldan sscls imass2 syl eqid clsss2 syl2anc ) BCDGHIZAEJZKZBLZADM
      NNZOZCPNIZUMAOZUOJZUQCMNNUOJUJUKUNDPNIZUPUJDQIZUKUSBCDRZADEFSTUNBCDUBUCUL
      AUNJZURUJUTUKVBVAADEFUDTAUNUMUEUFUOUQCCUAZVCUGUHUI $.

    $( Property of the preimage of an interior.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    cnntri $p |- ( ( F e. ( J Cn K ) /\ S C_ Y ) ->
      ( `' F " ( ( int ` K ) ` S ) ) C_ ( ( int ` J ) ` ( `' F " S ) ) ) $=
      ( ccn co wcel wss wa ctop ccnv cima cuni cnt cfv adantr syl sylan wceq wf
      cntop1 cdm cnvimass eqid cnf fdm cntop2 ntropn cnima syldan ntrss2 imass2
      syl5sseq ssntr syl22anc ) BCDGHIZAEJZKZCLIZBMZANZCOZJVBADPQQZNZCIZVFVCJZV
      FVCCPQQJURVAUSBCDUCRUTBUDZVCVDBAUEURVIVDUAZUSURVDEBUBVJBCDVDEVDUFZFUGVDEB
      UHSRUOURUSVEDIZVGURDLIZUSVLBCDUIZADEFUJTVEBCDUKULUTVEAJZVHURVMUSVOVNADEFU
      MTVEAVBUNSVCCVFVDVKUPUQ $.
  $}

  ${
    cnclsi.1 $e |- X = U. J $.
    $( Property of the image of a closure.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    cnclsi $p |- ( ( F e. ( J Cn K ) /\ S C_ X ) ->
        ( F " ( ( cls ` J ) ` S ) ) C_ ( ( cls ` K ) ` ( F " S ) ) ) $=
      ( ccn co wcel wss wa ccl cfv cima ccnv ctop adantr wceq syl sseqtr4d cuni
      cntop1 cdm cnvimass wf eqid cnf fdm syl5sseq cin simpr dfss1 sylib dminss
      syl6eqssr clsss syl3anc crn imassrn syl5ss cncls2i syldan sstrd wfun ffun
      frn wb clsss3 sylan funimass3 syl2anc mpbird ) BCDGHIZAEJZKZBACLMZMZNBANZ
      DLMMZJZVQBOZVSNZJZVOVQWAVRNZVPMZWBVOCPIZWDEJAWDJVQWEJVMWFVNBCDUBZQVOBUCZW
      DEBVRUDVOEDUAZBUEZWHERVMWJVNBCDEWIFWIUFZUGQZEWIBUHSZUIVOAWHAUJZWDVOAWHJWN
      ARVOAEWHVMVNUKWMTAWHULUMABUNUOWDACEFUPUQVMVNVRWIJWEWBJVOVRBURZWIBAUSVOWJW
      OWIJWLEWIBVFSUTVRBCDWIWKVAVBVCVOBVDZVQWHJVTWCVGVOWJWPWLEWIBVESVOVQEWHVMWF
      VNVQEJWGACEFVHVIWMTVQVSBVJVKVL $.
  $}

  ${
    $d c o x y F $.  $d c o x y J $.  $d c o x y K $.  $d c o x y X $.
    $d c o x y Y $.
    $( Continuity in terms of closure.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    cncls2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. x e. ~P Y
      ( ( cls ` J ) ` ( `' F " x ) ) C_ ( `' F " ( ( cls ` K ) ` x ) ) ) ) ) $=
      ( ctopon cfv wcel wa cima ccl wss cpw wral cuni wi wceq toponuni ad2antlr
      ccn co wf ccnv cv cnf2 3expia elpwi adantl sseqtrd eqid cncls2i ralrimdva
      expcom syl jcad ccld cldss2 pweqd syl5sseqr sseld imim1d ad2antll imaeq2d
      cldcls sseq2d ctop topontop ad2antrr cdm cnvimass ad2antrl eqtrd syl5sseq
      fdm iscld4 syl2anc bitr4d expr pm5.74d sylibd ralimdv2 imdistanda sylibrd
      wb iscncl impbid ) CEGHIZDFGHIZJZBCDUAUBIZEFBUCZBUDZAUEZKZCLHHZWMWNDLHHZK
      ZMZAFNZOZJZWJWKWLXAWHWIWKWLBCDEFUFUGWJWKWSAWTWJWNWTIZJZWNDPZMZWKWSQXDWNFX
      EXCWNFMWJWNFUHUIWIFXERZWHXCFDSZTUJWKXFWSWNBCDXEXEUKZULUNUOUMUPWJXBWLWOCUQ
      HIZADUQHZOZJWKWJWLXAXLWJWLJZWSXJAWTXKXMXCWSQWNXKIZWSQXNXJQXMXNXCWSXMXKWTW
      NXMXENXKWTDXEXIURXMFXEWIXGWHWLXHTUSUTVAVBXMXNWSXJWJWLXNWSXJWEWJWLXNJZJZWS
      WPWOMZXJXPWRWOWPXPWQWNWMXNWQWNRWJWLWNDVEVCVDVFXPCVGIZWOCPZMXJXQWEWHXRWIXO
      ECVHVIXPBVJZWOXSBWNVKXPXTEXSWLXTERWJXNEFBVOVLWHEXSRWIXOECSVIVMVNWOCXSXSUK
      VPVQVRVSVTWAWBWCABCDEFWFWDWG $.

    $( Continuity in terms of closure.  (Contributed by Jeff Hankins,
       1-Oct-2009.)  (Proof shortened by Mario Carneiro, 25-Aug-2015.) $)
    cncls $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. x e. ~P X
        ( F " ( ( cls ` J ) ` x ) ) C_ ( ( cls ` K ) ` ( F " x ) ) ) ) ) $=
      ( vy ctopon cfv wcel wa cv ccl cima wss cpw wral wceq syl ad3antrrr co wf
      ccn cnf2 3expia cuni elpwi adantl toponuni ad2antrr sseqtrd cnclsi expcom
      wi eqid ralrimdva jcad cdm cnvimass fdm ad2antlr syl5sseq toponmax elpw2g
      ccnv wb mpbird fveq2 imaeq2d imaeq2 fveq2d sseq12d ctop topontop ad3antlr
      rspcv crn cin wfun ffun funimacnv inss1 clsss syl3anc sstr2 syl5com eqtrd
      syl6eqss clsss3 syl2anc sseqtr4d funimass3 sylibd syld imdistanda sylibrd
      cncls2 impbid ) CEHIJZDFHIJZKZBCDUCUAJZEFBUBZBALZCMIZIZNZBXDNZDMIZIZOZAEP
      ZQZKZXAXBXCXMWSWTXBXCBCDEFUDUEXAXBXKAXLXAXDXLJZKZXDCUFZOZXBXKUNXPXDEXQXOX
      DEOXAXDEUGUHWSEXQRZWTXOECUIZUJUKXBXRXKXDBCDXQXQUOZULUMSUPUQXAXNXCBVEZGLZN
      ZXEIZYBYCXIIZNOZGFPZQZKXBXAXCXMYIXAXCKZXMYGGYHYJYCYHJZKZXMBYENZBYDNZXIIZO
      ZYGYLYDXLJZXMYPUNYLYQYDEOZYLBURZYDEBYCUSZXCYSERXAYKEFBUTVAZVBYLECJZYQYRVF
      WSUUBWTXCYKECVCTYDECVDSVGXKYPAYDXLXDYDRZXGYMXJYOUUCXFYEBXDYDXEVHVIUUCXHYN
      XIXDYDBVJVKVLVPSYLYPYMYFOZYGYLYOYFOZYPUUDYLDVMJZYCDUFZOYNYCOUUEWTUUFWSXCY
      KFDVNVOYLYCFUUGYKYCFOYJYCFUGUHWTFUUGRWSXCYKFDUIVOUKYLYNYCBVQZVRZYCYLBVSZY
      NUUIRXCUUJXAYKEFBVTVAZYCBWASYCUUHWBWHYCYNDUUGUUGUOWCWDYMYOYFWEWFYLUUJYEYS
      OUUDYGVFUUKYLYEXQYSYLCVMJZYDXQOYEXQOWSUULWTXCYKECVNTYLYSYDXQYTYLYSEXQUUAW
      SXSWTXCYKXTTWGZVBYDCXQYAWIWJUUMWKYEYFBWLWJWMWNUPWOGBCDEFWQWPWR $.

    $( Continuity in terms of interior.  (Contributed by Jeff Hankins,
       2-Oct-2009.)  (Proof shortened by Mario Carneiro, 25-Aug-2015.) $)
    cnntr $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. x e. ~P Y
      ( `' F " ( ( int ` K ) ` x ) ) C_ ( ( int ` J ) ` ( `' F " x ) ) ) ) ) $=
      ( ctopon cfv wcel wa cnt cima wss wral cuni wceq toponuni ad2antlr eqid
      wi ccn co wf ccnv cv cpw cnf2 3expia elpwi adantl cnntri expcom ralrimdva
      sseqtrd syl jcad toponss elpw sylibr ex imim1d wb ctop topontop ad3antrrr
      vex cdm cnvimass eqtrd syl5sseq ntrss2 syl2anc eqss baib ad3antlr isopn3i
      fdm isopn3 sylancom imaeq2d sseq1d 3bitr4rd pm5.74da sylibd ralimdv2 iscn
      imdistanda sylibrd impbid ) CEGHIZDFGHIZJZBCDUAUBIZEFBUCZBUDZAUEZDKHHZLZW
      OWPLZCKHHZMZAFUFZNZJZWLWMWNXCWJWKWMWNBCDEFUGUHWLWMXAAXBWLWPXBIZJZWPDOZMZW
      MXATXFWPFXGXEWPFMZWLWPFUIUJWKFXGPWJXEFDQRUNWMXHXAWPBCDXGXGSUKULUOUMUPWLXD
      WNWSCIZADNZJWMWLWNXCXKWLWNJZXAXJAXBDXLXEXATWPDIZXATXMXJTXLXMXEXAWKXMXETWJ
      WNWKXMXEWKXMJXIXEWPDFUQWPFAVFURUSUTRVAXLXMXAXJXLXMJZWTWSPZWSWTMZXJXAXNWTW
      SMZXOXPVBXNCVCIZWSCOZMZXQWJXRWKWNXMECVDVEZXNBVGZWSXSBWPVHXNYBEXSWNYBEPWLX
      MEFBVQRWJEXSPWKWNXMECQVEVIVJZWSCXSXSSZVKVLXOXQXPWTWSVMVNUOXNXRXTXJXOVBYAY
      CWSCXSYDVRVLXNWRWSWTXNWQWPWOXLXMDVCIZWQWPPWKYEWJWNXMFDVDVOWPDVPVSVTWAWBWC
      WDWEWGABCDEFWFWHWI $.
  $}

  ${
    $d f x J $.  $d f x K $.  $d f x L $.  $d f x X $.
    cnss1.1 $e |- X = U. J $.
    $( If the topology ` K ` is finer than ` J ` , then there are more
       continuous functions from ` K ` than from ` J ` .  (Contributed by Mario
       Carneiro, 19-Mar-2015.)  (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnss1 $p |- ( ( K e. ( TopOn ` X ) /\ J C_ K ) ->
        ( J Cn L ) C_ ( K Cn L ) ) $=
      ( vf vx ctopon cfv wcel wss wa ccn co cv cuni wf ccnv cima adantl simpllr
      wral eqid cnf cnima adantll sseldd ralrimiva simpll cntop2 toptopon sylib
      wb ctop iscn syl2anc mpbir2and ex ssrdv ) BDHIJZABKZLZFACMNZBCMNZVBFOZVCJ
      ZVEVDJZVBVFLZVGDCPZVEQZVERGOZSZBJZGCUBZVFVJVBVEACDVIEVIUCZUDTVHVMGCVHVKCJ
      ZLABVLUTVAVFVPUAVFVPVLAJVBVKVEACUEUFUGUHVHUTCVIHIJZVGVJVNLUMUTVAVFUIVHCUN
      JZVQVFVRVBVEACUJTCVIVOUKULGVEBCDVIUOUPUQURUS $.
  $}

  ${
    $d f x J $.  $d f x K $.  $d f x L $.  $d f x Y $.
    cnss2.1 $e |- Y = U. K $.
    $( If the topology ` K ` is finer than ` J ` , then there are fewer
       continuous functions into ` K ` than into ` J ` from some other space.
       (Contributed by Mario Carneiro, 19-Mar-2015.)  (Revised by Mario
       Carneiro, 21-Aug-2015.) $)
    cnss2 $p |- ( ( L e. ( TopOn ` Y ) /\ L C_ K ) ->
        ( J Cn K ) C_ ( J Cn L ) ) $=
      ( vf vx ctopon cfv wcel wss wa ccn co cv cuni wf ccnv wral adantl cima wb
      eqid simplr cnima ralrimiva ssralv sylc ctop cntop1 toptopon sylib simpll
      cnf iscn syl2anc mpbir2and ex ssrdv ) CDHIJZCBKZLZFABMNZACMNZVBFOZVCJZVEV
      DJZVBVFLZVGAPZDVEQZVERGOZUAAJZGCSZVFVJVBVEABVIDVIUCZEUNTVHVAVLGBSZVMUTVAV
      FUDVFVOVBVFVLGBVKVEABUEUFTVLGCBUGUHVHAVIHIJZUTVGVJVMLUBVHAUIJZVPVFVQVBVEA
      BUJTAVIVNUKULUTVAVFUMGVEACVIDUOUPUQURUS $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d f x y J $.  $d f x y K $.  $d f x y X $.
    $d f P $.
    cnsscnp.1 $e |- X = U. J $.
    $( A continuous function is continuous at all points.  One direction of
       Theorem 7.2(g) of [Munkres] p. 107.  (Contributed by Raph Levien,
       20-Nov-2006.)  (Proof shortened by Mario Carneiro, 21-Aug-2015.) $)
    cncnpi $p |- ( ( F e. ( J Cn K ) /\ A e. X ) ->
        F e. ( ( J CnP K ) ` A ) ) $=
      ( vy vx co wcel wa cfv cv adantr wb mpbir2and ctopon ctop toptopon sylib
      ccn ccnp cuni wf ccnv cima wss wrex wi wral eqid cnf cnima ad2ant2r simpr
      simprr wfn ad2antrr ffn elpreima 3syl eqimss biantrud eleq2 bitr3d rspcev
      wceq syl2anc expr ralrimiva cntop1 cntop2 iscnp3 syl3anc ) BCDUAIJZAEJZKZ
      BACDUBILJZEDUCZBUDZABLGMZJZAHMZJZWCBUEWAUFZUGZKZHCUHZUIZGDUJZVOVTVPBCDEVS
      FVSUKZULZNVQWIGDVQWADJZWBWHVQWMWBKZKZWECJZAWEJZWHVOWMWPVPWBWABCDUMUNWOWQV
      PWBVQVPWNVOVPUOZNVQWMWBUPWOVTBEUQWQVPWBKOVOVTVPWNWLUREVSBUSEAWABUTVAPWGWQ
      HWECWCWEVGZWDWGWQWSWFWDWCWEVBVCWCWEAVDVEVFVHVIVJVQCEQLJZDVSQLJZVPVRVTWJKO
      VQCRJZWTVOXBVPBCDVKNCEFSTVQDRJZXAVOXCVPBCDVLNDVSWKSTWRHGABCDEVSVMVNP $.

    $( The set of continuous functions is a subset of the set of continuous
       functions at a point.  (Contributed by Raph Levien, 21-Oct-2006.)
       (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnsscnp $p |- ( P e. X -> ( J Cn K ) C_ ( ( J CnP K ) ` P ) ) $=
      ( vf wcel ccn co ccnp cfv cv cncnpi expcom ssrdv ) ADGZFBCHIZABCJIKZFLZQG
      PSRGASBCDEMNO $.
  $}

  ${
    $d u x y F $.  $d u x y J $.  $d u x y K $.  $d u x y X $.  $d u x y Y $.
    $( A continuous function is continuous at all points.  Theorem 7.2(g) of
       [Munkres] p. 107.  (Contributed by NM, 15-May-2007.)  (Proof shortened
       by Mario Carneiro, 21-Aug-2015.) $)
    cncnp $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\
        A. x e. X F e. ( ( J CnP K ) ` x ) ) ) ) $=
      ( vy vu ctopon cfv wcel wa co cv wral cima ralrimiva wss syl wb ccnp ccnv
      ccn wf iscn simprbda cuni eqid cncnpi adantl wceq toponuni raleqdv mpbird
      ad2antrr jca simprl wrex cdm cnvimass fdm syl5sseq ssralv simpllr wfn ffn
      wi simprr ad2antlr elpreima simplbda syl2anc syl3anc wfun simp-4l toponss
      cnpimaex ffun sylan sseqtr4d funimass3 anbi2d rexbidva expr ralimdva syld
      mpbid impr an32s ctop topontop ad3antrrr eltop2 adantr mpbir2and impbida
      ) CEIJKZDFIJKZLZBCDUCMKZEFBUDZBANZCDUAMJKZAEOZLZWSWTLZXAXDWSWTXABUBGNZPZC
      KZGDOZGBCDEFUEZUFXFXDXCACUGZOZWTXMWSWTXCAXLXBBCDXLXLUHUIQUJXFXCAEXLWQEXLU
      KWRWTECULUOUMUNUPWSXELZWTXAXJWSXAXDUQXNXIGDXNXGDKZLZXIXBHNZKZXQXHRZLZHCUR
      ZAXHOZWSXOXEYBWSXOLZXAXDYBYCXALZXDXCAXHOZYBYDXHERXDYEVGYDBUSZXHEBXGUTXAYF
      EUKZYCEFBVAZUJVBXCAXHEVCSYDXCYAAXHYDXBXHKZXCYAYDYIXCLZLZXRBXQPXGRZLZHCURZ
      YAYKXCXOXBBJXGKZYNYDYIXCVHWSXOXAYJVDYKBEVEZYIYOXAYPYCYJEFBVFVIYDYIXCUQYPY
      IXBEKYOEXBXGBVJVKVLHXGXBBCDVQVMYKYMXTHCYKXQCKZLZYLXSXRYRBVNZXQYFRYLXSTYRX
      AYSYCXAYJYQVDZEFBVRSYRXQEYFYKWQYQXQERWQWRXOXAYJVOXQCEVPVSYRXAYGYTYHSVTXQX
      GBWAVLWBWCWGWDWEWFWHWIXPCWJKZXIYBTWQUUAWRXEXOECWKWLAHXHCWMSUNQWSWTXAXJLTX
      EXKWNWOWP $.

    cncnp.1 $e |- X = U. J $.
    cncnp.2 $e |- Y = U. K $.
    $( A continuous function is continuous at all points.  Theorem 7.2(g) of
       [Munkres] p. 107.  (Contributed by Raph Levien, 20-Nov-2006.)  (Proof
       shortened by Mario Carneiro, 21-Aug-2015.) $)
    cncnp2 $p |- ( X =/= (/) -> ( F e. ( J Cn K ) <->
        A. x e. X F e. ( ( J CnP K ) ` x ) ) ) $=
      ( c0 wne ccn co wcel cfv ctopon wa ctop toptopon sylib jca31 cv ccnp wral
      cntop1 cntop2 cnf adantl wrex r19.2z cnptop1 cnptop2 cnpf rexlimivw cncnp
      wf syl baibd pm5.21nd ) EIJZBCDKLMZBAUAZCDUBLNMZAEUCZCEONMZDFONMZPZEFBUOZ
      PZUTVHUSUTVDVEVGUTCQMZVDBCDUDCEGRZSUTDQMZVEBCDUEDFHRZSBCDEFGHUFTUGUSVCPVB
      AEUHVHVBAEUIVBVHAEVBVDVEVGVBVIVDVABCDUJVJSVBVKVEVABCDUKVLSVABCDEFGHULTUMU
      PVFUTVGVCABCDEFUNUQUR $.
  $}

  ${
    $d p v w F $.  $d p v w J $.  $d p v w K $.  $d p v w X $.  $d p v w Y $.
    cnnei.x $e |- X = U. J $.
    cnnei.y $e |- Y = U. K $.
    $( Continuity in terms of neighborhoods.  (Contributed by Thierry Arnoux,
       3-Jan-2018.) $)
    cnnei $p |- ( ( J e. Top /\ K e. Top /\ F : X --> Y ) ->
      ( F e. ( J Cn K ) <-> A. p e. X A. w e. ( ( nei ` K ) ` { ( F ` p ) } )
         E. v e. ( ( nei ` J ) ` { p } ) ( F " v ) C_ w ) ) $=
      ( ctop wcel co cv csn cnei cfv wral wb wa ccn cima wss wrex ccnp toptopon
      ctopon anbi12i cncnp baibd sylanb anbi1i 3expa an32s ralbidva bitrd 3impa
      wf iscnp4 ) DKLZEKLZFGCURZCDEUAMLZCBNUBANUCBHNZODPQQUDAVDCQOEPQQRZHFRZSUT
      VATZVBTZVCCVDDEUEMQLZHFRZVFVGDFUGQLZEGUGQLZTZVBVCVJSUTVKVAVLDFIUFEGJUFUHZ
      VMVCVBVJHCDEFGUIUJUKVHVIVEHFVHVMVBTVDFLZVIVESZVGVMVBVNULVMVOVBVPVMVOTVIVB
      VEVKVLVOVIVBVETSBAVDCDEFGUSUMUJUNUKUOUPUQ $.
  $}

  ${
    $d u x y B $.  $d u x y J $.  $d u x y K $.  $d u x y X $.  $d u x y Y $.
    $( A constant function is continuous.  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    cnconst2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ B e. Y ) ->
      ( X X. { B } ) e. ( J Cn K ) ) $=
      ( vx vy vu ctopon cfv wcel co cv wral wa cima wss wceq simplr crn w3a csn
      cxp ccn wf ccnp fconst6g 3ad2ant3 wrex wi adantr simpll3 fvconst2g eleq1d
      syl2anc simpll1 toponmax syl cres df-ima ssid xpssres ax-mp rneqi eqsstri
      rnxpss simprr snssd syl5ss syl5eqss imaeq2 sseq1d anbi12d rspcev syl12anc
      eleq2 expr sylbid ralrimiva wb simpl1 simpr iscnp syl3anc mpbir2and cncnp
      simpl2 3adant3 ) BDIJKZCEIJKZAEKZUAZDAUBZUCZBCUDLKZDEWNUEZWNFMZBCUFLJKZFD
      NZWKWIWPWJDAEUGUHZWLWRFDWLWQDKZOZWRWPWQWNJZGMZKZWQHMZKZWNXFPZXDQZOZHBUIZU
      JZGCNZWLWPXAWTUKXBXLGCXBXDCKZOZXEAXDKZXKXOXCAXDXOWKXAXCARWIWJWKXAXNULWLXA
      XNSDAWQEUMUOUNXBXNXPXKXBXNXPOZOZDBKZXAWNDPZXDQZXKXRWIXSWIWJWKXAXQUPDBUQUR
      WLXAXQSXRXTWNDUSZTZXDWNDUTXRYCWMXDYCWNTWMYBWNDDQYBWNRDVADWMDVBVCVDDWMVFVE
      XRAXDXBXNXPVGVHVIVJXJXAYAOHDBXFDRZXGXAXIYAXFDWQVPYDXHXTXDXFDWNVKVLVMVNVOV
      QVRVSXBWIWJXAWRWPXMOVTWIWJWKXAWAWIWJWKXAWGWLXAWBHGWQWNBCDEWCWDWEVSWIWJWOW
      PWSOVTWKFWNBCDEWFWHWE $.

    $( A constant function is continuous.  (Contributed by FL, 15-Jan-2007.)
       (Proof shortened by Mario Carneiro, 19-Mar-2015.) $)
    cnconst $p |- ( ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) /\
      ( B e. Y /\ F : X --> { B } ) ) -> F e. ( J Cn K ) ) $=
      ( ctopon cfv wcel wa csn wf ccn co cxp wceq wb fconst2g adantl cnconst2
      3expa eleq1 syl5ibrcom sylbid impr ) CEGHIZDFGHIZJZAFIZEAKZBLZBCDMNZIZUHU
      IJZUKBEUJOZPZUMUIUKUPQUHEAFBRSUNUMUPUOULIZUFUGUIUQACDEFTUABUOULUBUCUDUE
      $.
  $}

  ${
    $d o s t A $.  $d o s t F $.  $d o s t J $.  $d o s t K $.  $d o s t X $.
    cnrest.1 $e |- X = U. J $.
    $( Continuity of a restriction from a subspace.  (Contributed by Jeff
       Hankins, 11-Jul-2009.)  (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnrest $p |- ( ( F e. ( J Cn K ) /\ A C_ X ) ->
        ( F |` A ) e. ( ( J |`t A ) Cn K ) ) $=
      ( vo ccn co wcel wss wa wf ccnv adantr sylib ctop sylan ctopon cfv cv cdm
      cres crest cuni cima wral wfun wceq crn eqid cnf ffun funres 3syl fdm syl
      simpr sseqtr4d ssdmres jca resss rnss ax-mp frn syl5ss df-fn anbi1i bitri
      wfn sylanbrc cin cnvresima cvv cntop1 topopn ssexg ancoms adantlr elrestr
      df-f syl3anc syl5eqel ralrimiva wb toptopon resttopon cntop2 iscn syl2anc
      cnima mpbir2and ) BCDHIJZAEKZLZBAUCZCAUDIZDHIJZADUEZWPMZWPNGUAZUFZWQJZGDU
      GZWOWPUHZWPUBAUIZLZWPUJZWSKZWTWOXEXFWMXEWNWMEWSBMZBUHXEBCDEWSFWSUKZULZEWS
      BUMABUNUOOWOABUBZKXFWOAEXMWMWNURWOXJXMEUIWMXJWNXLOZEWSBUPUQUSABUTPVAWOXHB
      UJZWSWPBKXHXOKBAVBWPBVCVDWOXJXOWSKXNEWSBVEUQVFWTWPAVJZXILXGXILAWSWPWAXPXG
      XIWPAVGVHVIVKWOXCGDWOXADJZLZXBBNXAUFZAVLZWQAXABVMXRCQJZAVNJZXSCJZXTWQJWOY
      AXQWMYAWNBCDVOZOOWOYBXQWMYAWNYBYDYAECJZWNYBCEFVPWNYEYBAECVQVRRROWMXQYCWNX
      ABCDWKVSXSACQVNVTWBWCWDWOWQASTJZDWSSTJZWRWTXDLWEWMCESTJZWNYFWMYAYHYDCEFWF
      PACEWGRWODQJZYGWMYIWNBCDWHODWSXKWFPGWPWQDAWSWIWJWL $.
  $}

  ${
    $d f x y B $.  $d x y F $.  $d f x y J $.  $d f x y K $.  $d x y Y $.
    $( Equivalence of continuity in the parent topology and continuity in a
       subspace.  (Contributed by Jeff Hankins, 10-Jul-2009.)  (Proof shortened
       by Mario Carneiro, 21-Aug-2015.) $)
    cnrest2 $p |- ( ( K e. ( TopOn ` Y ) /\ ran F C_ B /\ B C_ Y ) ->
        ( F e. ( J Cn K ) <-> F e. ( J Cn ( K |`t B ) ) ) ) $=
      ( vx vy ctopon cfv wcel wss wf wa co a1i syl wb cima cvv syl2anc crn ctop
      w3a cuni ccn crest cntop1 wfn eqid cnf ffn simp2 jctird df-f syl6ibr jcad
      wi adantl toptopon sylib resttopon 3adant2 adantr simpr cnf2 syl3anc ccnv
      jca ex wral cin vex inex1 wceq simpl1 toponmax simpl3 ssexd elrest imaeq2
      cv wrex eleq1d ralxfr2d wfun simplrr ffun inpreima 3syl cnvimass sseqtr4i
      cdm cnvimarndm simpll2 imass2 syl5ss df-ss eqtrd simprr biantrurd 3bitrrd
      ralbidva fss bitrd simprl iscn 3bitr4d pm5.21ndd ) DEHIZJZBUAZAKZAEKZUCZC
      UBJZCUDZABLZMZBCDUENJZBCDAUFNZUENJZXNXSXOXQXSXOUQXNBCDUGOXNXSBXPUHZXLMXQX
      NXSYBXLXSYBUQXNXSXPDUDZBLYBBCDXPYCXPUIZYCUIUJXPYCBUKPOXJXLXMULUMXPABUNUOU
      PXNYAXRXNYAMZXOXQYAXOXNBCXTUGURZYECXPHIJZXTAHIJZYAXQYEXOYGYFCXPYDUSZUTXNY
      HYAXJXMYHXLADEVAVBZVCXNYAVDBCXTXPAVEVFVHVIXNXRXSYAQXNXRMZXPEBLZBVGZFWAZRZ
      CJZFDVJZMZXQYMGWAZRZCJZGXTVJZMZXSYAYKYRUUBUUCYKUUBYMYNAVKZRZCJZFDVJYQYRYK
      UUAUUFGFUUDXTDSUUDSJYKYNDJZMZYNAFVLVMOYKXJASJYSXTJYSUUDVNZFDWBQXJXLXMXRVO
      ZYKAEDYKXJEDJUUJEDVPPXJXLXMXRVQZVRFYSADXISVSTUUIUUAUUFQYKUUIYTUUECYSUUDYM
      VTWCURWDYKUUFYPFDUUHUUEYOCUUHUUEYOYMARZVKZYOUUHXQBWEUUEUUMVNXNXOXQUUGWFXP
      ABWGYNABWHWIUUHYOUULKUUMYOVNUUHYOYMXKRZUULYOBWLUUNBYNWJBWMWKUUHXLUUNUULKX
      JXLXMXRUUGWNXKAYMWOPWPYOUULWQUTWRWCXBYKYLYQYKXQXMYLXNXOXQWSZUUKXPAEBXCTWT
      XAYKXQUUBUUOWTXDYKYGXJXSYRQYKXOYGXNXOXQXEYIUTZUUJFBCDXPEXFTYKYGYHYAUUCQUU
      PXNYHXRYJVCGBCXTXPAXFTXGVIXH $.

    $( Equivalence of continuity in the parent topology and continuity in a
       subspace.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 7-Jun-2014.) $)
    cnrest2r $p |- ( K e. Top -> ( J Cn ( K |`t B ) ) C_ ( J Cn K ) ) $=
      ( vf ctop wcel crest co ccn wa cuni cvv adantl eqid ctopon toptopon sylib
      cfv wss syl3anc cv cin wceq cntop2 restrcl restin 3syl oveq2d eleqtrd crn
      simpr wb simpl wf cntop1 inss2 resttopon sylancl cnf2 frn syl a1i cnrest2
      mpbird ex ssrdv ) CEFZDBCAGHZIHZBCIHZVGDUAZVIFZVKVJFZVGVLJZVMVKBCACKZUBZG
      HZIHZFZVNVKVIVRVGVLUKVNVHVQBIVNVHEFZCLFALFJVHVQUCVLVTVGVKBVHUDMACUEACLLVO
      VONZUFUGUHUIZVNCVOORFZVKUJVPSZVPVOSZVMVSULVNVGWCVGVLUMCVOWAPQZVNBKZVPVKUN
      ZWDVNBWGORFZVQVPORFZVSWHVNBEFZWIVLWKVGVKBVHUOMBWGWGNPQVNWCWEWJWFAVOUPZVPC
      VOUQURWBVKBVQWGVPUSTWGVPVKUTVAWEVNWLVBVPVKBCVOVCTVDVEVF $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z J $.  $d x y z K $.
    $d x y z P $.  $d x y z X $.  $d x y z Y $.
    cnprest.1 $e |- X = U. J $.
    $( One direction of ~ cnprest under the weaker condition that the point is
       in the subset rather than the interior of the subset.  (Contributed by
       Mario Carneiro, 9-Feb-2015.)  (Revised by Mario Carneiro,
       1-May-2015.) $)
    cnpresti $p |- ( ( A C_ X /\ P e. A /\ F e. ( ( J CnP K ) ` P ) ) ->
      ( F |` A ) e. ( ( ( J |`t A ) CnP K ) ` P ) ) $=
      ( vy vz vx wss wcel co cfv cima wa wrex wi cvv ctop ccnp w3a cres cuni wf
      crest cv wral eqid cnpf 3ad2ant3 simp1 fssres syl2anc simpl2 fvres eleq1d
      wceq syl cnpimaex 3expia 3ad2antl3 cin idd simp2 jctird elin inss1 imass2
      syl6ibr ax-mp id syl5ss a1i anim12d reximdv vex inex1 wb cnptop1 syl6sseq
      uniexg ssexd elrest eleq2d imaeq2d resima2 syl6eq sseq1d anbi12d rexxfr2d
      simpr inss2 sylibrd adantr syld sylbid ralrimiva toptopon sylib resttopon
      ctopon cnptop2 iscnp syl3anc mpbir2and ) AFKZBALZCBDEUAMNLZUBZCAUCZBDAUFM
      ZEUAMNLZAEUDZXKUEZBXKNZHUGZLZBIUGZLZXKXSOZXQKZPZIXLQZRZHEUHZXJFXNCUEZXGXO
      XIXGYGXHBCDEFXNGXNUIZUJUKXGXHXIULZFXNACUMUNXJYEHEXJXQELZPZXRBCNZXQLZYDYKX
      PYLXQYKXHXPYLURXGXHXIYJUOBACUPUSUQYKYMBJUGZLZCYNOZXQKZPZJDQZYDXIXGYJYMYSR
      XHXIYJYMYSJXQBCDEUTVAVBXJYSYDRYJXJYSBYNAVCZLZCYTOZXQKZPZJDQYDXJYRUUDJDXJY
      OUUAYQUUCXJYOYOXHPUUAXJYOYOXHXJYOVDXGXHXIVEZVFBYNAVGVJYQUUCRXJYQUUBYPXQYT
      YNKUUBYPKYNAVHYTYNCVIVKYQVLVMVNVOVPXJYCUUDIJYTXLDSYTSLXJYNDLPYNAJVQVRVNXJ
      DTLZASLXSXLLXSYTURZJDQVSXIXGUUFXHBCDEVTUKZXJADUDZSXJUUFUUISLUUHDTWBUSXJAF
      UUIYIGWAWCJXSADTSWDUNXJUUGPZXTUUAYBUUCUUJXSYTBXJUUGWLZWEUUJYAUUBXQUUJYAXK
      YTOZUUBUUJXSYTXKUUKWFYTAKUULUUBURYNAWMCYTAWGVKWHWIWJWKWNWOWPWQWRXJXLAXBNL
      ZEXNXBNLZXHXMXOYFPVSXJDFXBNLZXGUUMXJUUFUUOUUHDFGWSWTYIADFXAUNXJETLZUUNXIX
      GUUPXHBCDEXCUKEXNYHWSWTUUEIHBXKXLEAXNXDXEXF $.

    cnprest.2 $e |- Y = U. K $.
    $( Equivalence of continuity at a point and continuity of the restricted
       function at a point.  (Contributed by Mario Carneiro, 8-Aug-2014.) $)
    cnprest $p |- ( ( ( J e. Top /\ A C_ X ) /\
                      ( P e. ( ( int ` J ) ` A ) /\ F : X --> Y ) ) ->
      ( F e. ( ( J CnP K ) ` P ) <->
        ( F |` A ) e. ( ( ( J |`t A ) CnP K ) ` P ) ) ) $=
      ( vy vx vz wcel wss wa cfv wi cima syl cvv ctop cnt wf ccnp co cres crest
      cnptop2 a1i wb w3a cv wrex wral wceq ntrss2 3ad2ant1 simp2l sseldd eqcomd
      fvres eleq1d inss1 imass2 sstr2 anim2i reximi simp1l ntropn 3com23 3expia
      cin mp2b inopn syl2anc elin simplbi2com sslin anim12d eleq2 imaeq2 sseq1d
      anbi12d rspcev syl6 expdimp rexlimdva cbvrexv syl6ib impbid2 inex1 uniexg
      vex cuni simp1r syl6sseq ssexd elrest rbaib sylan9bbr simpr imaeq2d inss2
      resima2 ax-mp syl6eq rexxfr2d bitr4d imbi12d ralbidv simp3 iscnp2 syl3anc
      simp2r biantrurd ctopon toptopon sylib resttopon fssres 3bitr4d pm5.21ndd
      baib iscnp ) DUAMZAFNZOZBADUBPPZMZFGCUCZOZOZEUAMZCBDEUDUEPMZCAUFZBDAUGUEZ
      EUDUEPMZYNYMQYLBCDEUHUIYQYMQYLBYOYPEUHUIYGYKYMYNYQUJYGYKYMUKZBCPZJULZMZBK
      ULZMZCUUBRZYTNZOZKDUMZQZJEUNZBYOPZYTMZBLULZMZYOUULRZYTNZOZLYPUMZQZJEUNZYN
      YQYRUUHUURJEYRUUAUUKUUGUUQYRYSUUJYTYRUUJYSYRBAMZUUJYSUOYRYHABYGYKYHANZYMA
      DFHUPUQZYGYIYJYMURZUSZBACVASUTVBYRUUGUUCCUUBAVLZRZYTNZOZKDUMZUUQYRUUGUVIU
      UFUVHKDUUEUVGUUCUVEUUBNUVFUUDNUUEUVGQUUBAVCUVEUUBCVDUVFUUDYTVEVMVFVGYRUVI
      UUMCUULRZYTNZOZLDUMZUUGYRUVHUVMKDYRUUBDMZUVHUVMYRUVNUVHOUUBYHVLZDMZBUVOMZ
      CUVORZYTNZOZOUVMYRUVNUVPUVHUVTYRYEYHDMZUVNUVPQYEYFYKYMVHZYGYKUWAYMADFHVIU
      QYEUWAUVNUVPYEUVNUWAUVPUUBYHDVNVJVKVOYRUUCUVQUVGUVSYRYIUUCUVQQUVCUVQUUCYI
      BUUBYHVPVQSYRUVRUVFNZUVGUVSQYRUVOUVENZUWCYRUVAUWDUVBYHAUUBVRSUVOUVECVDSUV
      RUVFYTVESVSVSUVLUVTLUVODUULUVOUOZUUMUVQUVKUVSUULUVOBVTUWEUVJUVRYTUULUVOCW
      AWBWCWDWEWFWGUVLUUFLKDUULUUBUOZUUMUUCUVKUUEUULUUBBVTUWFUVJUUDYTUULUUBCWAW
      BWCWHWIWJYRUUPUVHLKUVEYPDTUVETMYRUVNOUUBAKWMWKUIYRYEATMUULYPMUULUVEUOZKDU
      MUJUWBYRADWNZTYRYEUWHTMUWBDUAWLSYRAFUWHYEYFYKYMWOZHWPWQKUULADUATWRVOYRUWG
      OZUUMUUCUUOUVGUWGUUMBUVEMZYRUUCUULUVEBVTYRUUTUWKUUCUJUVDUWKUUCUUTBUUBAVPW
      SSWTUWJUUNUVFYTUWJUUNYOUVERZUVFUWJUULUVEYOYRUWGXAXBUVEANUWLUVFUOUUBAXCCUV
      EAXDXEXFWBWCXGXHXIXJYRYNYJUUIOZUUIYRYEYMBFMZYNUWMUJUWBYGYKYMXKZYRAFBUWIUV
      DUSYNYEYMUWNUKUWMKJBCDEFGHIXLYCXMYRYJUUIYGYIYJYMXNZXOXHYRYQAGYOUCZUUSOZUU
      SYRYPAXPPMZEGXPPMZUUTYQUWRUJYRDFXPPMZYFUWSYRYEUXAUWBDFHXQXRUWIADFXSVOYRYM
      UWTUWOEGIXQXRUVDLJBYOYPEAGYDXMYRUWQUUSYRYJYFUWQUWPUWIFGACXTVOXOXHYAVKYB
      $.

    $( Equivalence of point-continuity in the parent topology and
       point-continuity in a subspace.  (Contributed by Mario Carneiro,
       9-Aug-2014.)  (Revised by Mario Carneiro, 21-Aug-2015.) $)
    cnprest2 $p |- ( ( K e. Top /\ F : X --> B /\ B C_ Y ) ->
       ( F e. ( ( J CnP K ) ` P ) <-> F e. ( ( J CnP ( K |`t B ) ) ` P ) ) ) $=
      ( vx vy vz ctop wcel wss wa cfv wi wb cvv wf ccnp co crest cnptop1 cnprcl
      w3a jca a1i cv cima wrex wral cin simpl2 simprr ffvelrnd biantrud syl6bbr
      elin crn imassrn frn syl syl5ss syl6bb anbi2d rexbidv imbi12d ralbidv vex
      ssin inex1 simpl1 uniexg syl5eqel simpl3 ssexd elrest syl2anc eleq2 sseq2
      wceq cuni adantl ralxfr2d bitr4d simprl iscnp2 baib syl3anc fss biantrurd
      ctopon toptopon sylib resttopon iscnp 3bitr4d ex pm5.21ndd ) EMNZFACUAZAG
      OZUGZDMNZBFNZPZCBDEUBUCQNZCBDEAUDUCZUBUCQNZXIXHRXEXIXFXGBCDEUEBCDEFHUFUHU
      IXKXHRXEXKXFXGBCDXJUEBCDXJFHUFUHUIXEXHXIXKSXEXHPZBCQZJUJZNZBKUJZNZCXPUKZX
      NOZPZKDULZRZJEUMZXMLUJZNZXQXRYDOZPZKDULZRZLXJUMZXIXKXLYCXMXNAUNZNZXQXRYKO
      ZPZKDULZRZJEUMYJXLYBYPJEXLXOYLYAYOXLXOXOXMANZPYLXLYQXOXLFABCXBXCXDXHUOZXE
      XFXGUPZUQURXMXNAUTUSXLXTYNKDXLXSYMXQXLXSXSXRAOZPYMXLYTXSXLXRCVAZACXPVBXLX
      CUUAAOYRFACVCVDVEURXRXNAVLVFVGVHVIVJXLYIYPLJYKXJETYKTNXLXNENPXNAJVKVMUIXL
      XBATNYDXJNYDYKWCZJEULSXBXCXDXHVNZXLAGTXLXBGTNUUCXBGEWDTIEMVOVPVDXBXCXDXHV
      QZVRJYDAEMTVSVTUUBYIYPSXLUUBYEYLYHYOYDYKXMWAUUBYGYNKDUUBYFYMXQYDYKXRWBVGV
      HVIWEWFWGXLXIFGCUAZYCPZYCXLXFXBXGXIUUFSXEXFXGWHZUUCYSXIXFXBXGUGUUFKJBCDEF
      GHIWIWJWKXLUUEYCXLXCXDUUEYRUUDFAGCWLVTWMWGXLXKXCYJPZYJXLDFWNQNZXJAWNQNZXG
      XKUUHSXLXFUUIUUGDFHWOWPXLEGWNQNZXDUUJXLXBUUKUUCEGIWOWPUUDAEGWQVTYSKLBCDXJ
      FAWRWKXLXCYJYRWMWGWSWTXA $.
  $}

  ${
    $d f x y A $.  $d f x y J $.  $d f x y K $.  $d f x y X $.  $d f x y Y $.
    $d f x V $.
    $( Every function is continuous when the domain is discrete.  (Contributed
       by Mario Carneiro, 19-Mar-2015.)  (Revised by Mario Carneiro,
       21-Aug-2015.) $)
    cndis $p |- ( ( A e. V /\ J e. ( TopOn ` X ) ) ->
        ( ~P A Cn J ) = ( X ^m A ) ) $=
      ( vf vx wcel ctopon cfv wa cpw ccn co cmap cv wf ccnv cima wral wb adantl
      wss cdm cnvimass fdm syl5sseq elpw2g ad2antrr mpbird ralrimivw ex pm4.71d
      wceq toponmax id elmapg syl2anr distopon iscn sylan 3bitr4rd eqrdv ) ACGZ
      BDHIGZJZEAKZBLMZDANMZVEADEOZPZVJVIQFOZRZVFGZFBSZJZVIVHGZVIVGGZVEVJVNVEVJV
      NVEVJJZVMFBVRVMVLAUBZVRVIUCZVLAVIVKUDVJVTAUMVEADVIUEUAUFVCVMVSTVDVJVLACUG
      UHUIUJUKULVDDBGVCVPVJTVCDBUNVCUODAVIBCUPUQVCVFAHIGVDVQVOTACURFVIVFBADUSUT
      VAVB $.

    $( Every function is continuous when the codomain is indiscrete (trivial).
       (Contributed by Mario Carneiro, 9-Apr-2015.)  (Revised by Mario
       Carneiro, 21-Aug-2015.) $)
    cnindis $p |- ( ( J e. ( TopOn ` X ) /\ A e. V ) ->
      ( J Cn { (/) , A } ) = ( A ^m X ) ) $=
      ( vf vx ctopon cfv wcel wa c0 cima wceq ad2antrr imaeq2 eleq1d syl5ibrcom
      co cv wb cpr ccn cmap wf ccnv wral wo elpri ctop topontop 0opn syl syl6eq
      ima0 fimacnv adantl toponmax eqeltrd jaod syl5 ralrimiv ex pm4.71d elmapg
      id syl2anr indistopon iscn sylan2 3bitr4rd eqrdv ) BDGHIZACIZJZEBKAUAZUBR
      ZADUCRZVNDAESZUDZVSVRUEZFSZLZBIZFVOUFZJZVRVQIZVRVPIZVNVSWDVNVSWDVNVSJZWCF
      VOWAVOIWAKMZWAAMZUGWHWCWAKAUHWHWIWCWJWHWCWIKBIZWHBUIIZWKVLWLVMVSDBUJNBUKU
      LWIWBKBWIWBVTKLKWAKVTOVTUNUMPQWHWCWJVTALZBIWHWMDBVSWMDMVNDAVRUOUPVLDBIZVM
      VSDBUQZNURWJWBWMBWAAVTOPQUSUTVAVBVCVMVMWNWFVSTVLVMVEWOADVRCBVDVFVMVLVOAGH
      IWGWETACVGFVRBVODAVHVIVJVK $.

    $( If ` A ` is an isolated point in ` X ` (or equivalently, the singleton
       ` { A } ` is open in ` X ` ), then every function is continuous at
       ` A ` .  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    cnpdis $p |- ( ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ A e. X ) /\
       { A } e. J ) -> ( ( J CnP K ) ` A ) = ( Y ^m X ) ) $=
      ( vf vx vy ctopon cfv wcel w3a wa co cv wss syl wb expr toponmax csn ccnp
      cmap wf ccnv cima wrex wral simplrl simpll3 snidg simprr simplrr elpreima
      wi wfn ffn 3syl mpbir2and snssd wceq eleq2 sseq1 anbi12d rspcev ralrimiva
      syl12anc pm4.71d simpl2 simpl1 elmapg syl2anc iscnp3 adantr 3bitr4rd
      eqrdv ) BDIJKZCEIJKZADKZLZAUAZBKZMZFABCUBNJZEDUCNZWCDEFOZUDZWGAWFJGOZKZAH
      OZKZWJWFUEWHUFZPZMZHBUGZUOZGCUHZMZWFWEKZWFWDKZWCWGWQVTWBWGWQVTWBWGMZMZWPG
      CXBWHCKZWIWOXBXCWIMZMZWBAWAKZWAWLPZWOVTWBWGXDUIXEVSXFVQVRVSXAXDUJZADUKQXE
      AWLXEAWLKZVSWIXHXBXCWIULXEWGWFDUPXIVSWIMRVTWBWGXDUMDEWFUQDAWHWFUNURUSUTWN
      XFXGMHWABWJWAVAWKXFWMXGWJWAAVBWJWAWLVCVDVEVGSVFSVHWCECKZDBKZWSWGRWCVRXJVQ
      VRVSWBVIECTQWCVQXKVQVRVSWBVJDBTQEDWFCBVKVLVTWTWRRWBHGAWFBCDEVMVNVOVP $.
  $}

  ${
    $d y F $.  $d y J $.  $d y K $.  $d y ph $.  $d y X $.  $d y Y $.
    paste.1 $e |- X = U. J $.
    paste.2 $e |- Y = U. K $.
    paste.4 $e |- ( ph -> A e. ( Clsd ` J ) ) $.
    paste.5 $e |- ( ph -> B e. ( Clsd ` J ) ) $.
    paste.6 $e |- ( ph -> ( A u. B ) = X ) $.
    paste.7 $e |- ( ph -> F : X --> Y ) $.
    paste.8 $e |- ( ph -> ( F |` A ) e. ( ( J |`t A ) Cn K ) ) $.
    paste.9 $e |- ( ph -> ( F |` B ) e. ( ( J |`t B ) Cn K ) ) $.
    $( Pasting lemma.  If ` A ` and ` B ` are closed sets in ` X ` with
       ` A u. B = X ` , then any function whose restrictions to ` A ` and ` B `
       are continuous is continuous on all of ` X ` .  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       21-Aug-2015.) $)
    paste $p |- ( ph -> F e. ( J Cn K ) ) $=
      ( co wcel cfv syl vy ccn wf ccnv cv cima ccld wral wa cres cun cin ineq2d
      wceq wfun ffun respreima uneq12d syl6reqr wss crn imassrn cdm fdm syl5eqr
      dfdm4 syl5sseq df-ss sylib 3eqtr3rd adantr crest cnclima restcldr syl2anc
      indi sylan eqeltrd ralrimiva ctop wb cldrcl cntop2 ctopon toptopon iscncl
      uncld syl2anb mpbir2and ) ADEFUBQRZGHDUCZDUDZUAUEZUFZEUGSZRZUAFUGSZUHZNAW
      PUAWQAWMWQRZUIZWNDBUJZUDWMUFZDCUJZUDWMUFZUKZWOAWNXEUNWSAWNBCUKZULZWNGULZX
      EWNAXFGWNMUMAXEWNBULZWNCULZUKZXGADUOZXEXKUNAWKXLNGHDUPTXLXBXIXDXJWMBDUQWM
      CDUQURTWNBCVPUSAWNGUTZXHWNUNAWKXMNWKWLVAZWNGWLWMVBWKXNDVCGDVFGHDVDVEVGTWN
      GVHVIVJVKWTXBWORZXDWORZXEWORWTBWORZXBEBVLQZUGSRZXOAXQWSKVKAXAXRFUBQRZWSXS
      OWMXAXRFVMVQBXBEVNVOWTCWORZXDECVLQZUGSRZXPAYAWSLVKAXCYBFUBQRWSYCPWMXCYBFV
      MVQCXDEVNVOXBXDEWGVOVRVSAEVTRZFVTRZWJWKWRUIWAZAXQYDKBEWBTAXTYEOXAXRFWCTYD
      EGWDSRFHWDSRYFYEEGIWEFHJWEUADEFGHWFWHVOWI $.
  $}

  ${
    $d u y F $.  $d u y J $.  $d u P $.  $d u y X $.
    $( If ` F ` converges, then ` F ` is a partial function.  (Contributed by
       Mario Carneiro, 23-Dec-2013.) $)
    lmfpm $p |- ( ( J e. ( TopOn ` X ) /\ F ( ~~>t ` J ) P ) ->
      F e. ( X ^pm CC ) ) $=
      ( vu vy ctopon cfv wcel clm wbr wa cc cpm co cv cres wf cuz crn wrex wral
      wi w3a id lmbr biimpa simp1d ) CDGHIZBACJHKZLBDMNOIZADIZAEPZIFPZUMBUNQRFS
      TUAUCECUBZUIUJUKULUOUDUIFEABCDUIUEUFUGUH $.

    $( Inclusion of a function having a limit (used to ensure the limit
       relation is a set, under our definition).  (Contributed by NM,
       7-Dec-2006.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    lmfss $p |- ( ( J e. ( TopOn ` X ) /\ F ( ~~>t ` J ) P ) ->
      F C_ ( CC X. X ) ) $=
      ( ctopon cfv wcel clm wbr wa wfun cc cxp wss cpm co lmfpm wb cvv toponmax
      cnex elpmg sylancl adantr mpbid simprd ) CDEFGZBACHFIZJZBKZBLDMNZUIBDLOPG
      ZUJUKJZABCDQUGULUMRZUHUGDCGLSGUNDCTUADLBCSUBUCUDUEUF $.

    $( Closure of a limit.  (Contributed by NM, 19-Dec-2006.)  (Revised by
       Mario Carneiro, 23-Dec-2013.) $)
    lmcl $p |- ( ( J e. ( TopOn ` X ) /\ F ( ~~>t ` J ) P ) -> P e. X ) $=
      ( vu vy ctopon cfv wcel clm wbr wa cc cpm co cv cres wf cuz crn wrex wral
      wi w3a id lmbr biimpa simp2d ) CDGHIZBACJHKZLBDMNOIZADIZAEPZIFPZUMBUNQRFS
      TUAUCECUBZUIUJUKULUOUDUIFEABCDUIUEUFUGUH $.
  $}

  ${
    $d j k u v F $.  $d j k u v J $.  $d j k u v K $.  $d j k u v ph $.
    $d j k M $.  $d j k u v P $.  $d j k u v Y $.  $d j k u v Z $.
    lmss.1 $e |- K = ( J |`t Y ) $.
    lmss.2 $e |- Z = ( ZZ>= ` M ) $.
    lmss.3 $e |- ( ph -> Y e. V ) $.
    lmss.4 $e |- ( ph -> J e. Top ) $.
    lmss.5 $e |- ( ph -> P e. Y ) $.
    lmss.6 $e |- ( ph -> M e. ZZ ) $.
    lmss.7 $e |- ( ph -> F : Z --> Y ) $.
    $( Limit on a subspace.  (Contributed by NM, 30-Jan-2008.)  (Revised by
       Mario Carneiro, 30-Dec-2013.) $)
    lmss $p |- ( ph -> ( F ( ~~>t ` J ) P <-> F ( ~~>t ` K ) P ) ) $=
      ( vu wcel wa adantr vk cuni crn wss clm cfv wbr ctopon ctop eqid toptopon
      vj vv sylib lmcl sylan cc cxp lmfss rnss syl rnxpss syl6ss ex inss2 crest
      jca cin co resttopon2 syl2anc syl5eqel sseldi wb cv cuz wral wrex wi elin
      simprl sylanbrc 2thd eleq2i elrest biimpa sylan2b r19.29r biantrud uztrn2
      wceq syl6bbr wf ffvelrnda sylan2 anassrs ralbidva rexbidva imbi12d biimpd
      eleq2 rexralbidv imbi2d syl5ibrcom imp3a rexlimdva syl5 expdimp ralrimdva
      syldan simpr elrestr syl3anc syl6eleqr rspcv sylibrd impbid cz wfn simprr
      anbi12d ffn df-f eqidd lmbrf frn ssind 3bitr4d pm5.21ndd ) ABDUBZRZCUCZYJ
      UDZSZCBDUEUFUGZCBEUEUFUGZAYOYNAYOSZYKYMADYJUHUFRZYOYKADUIRZYRMDYJYJUJUKZU
      NZBCDYJUOUPYQYLUQYJURZUCZYJYQCUUBUDZYLUUCUDAYRYOUUDUUABCDYJUSUPCUUBUTVAUQ
      YJVBVCVGVDAYPYNAYPSZYKYMUUEHYJVHZYJBHYJVEZAEUUFUHUFZRZYPBUUFRZAEDHVFVIZUU
      HJAYRHGRZUUKUUHRUUALHDGYJVJVKVLZBCEUUFUOUPVMUUEYLUUFYJUUEYLUQUUFURZUCZUUF
      UUECUUNUDZYLUUOUDAUUIYPUUPUUMBCEUUFUSUPCUUNUTVAUQUUFVBVCUUGVCVGVDAYNYOYPV
      NAYNSZYKBQVOZRZUAVOZCUFZUURRZUAULVOZVPUFZVQZULIVRZVSZQDVQZSUUJBUMVOZRZUVA
      UVIRZUAUVDVQULIVRZVSZUMEVQZSYOYPUUQYKUUJUVHUVNUUQYKUUJAYKYMWAZUUQBHRZYKUU
      JAUVPYNNTZUVOBHYJVTWBWCUUQUVHUVNUUQUVHUVMUMEUUQUVIERZUVIUURHVHZWKZQDVRZUV
      HUVMVSUVRUUQUVIUUKRZUWAEUUKUVIJWDUUQUWBUWAUUQYSUULUWBUWAVNAYSYNMTZAUULYNL
      TZQUVIHDUIGWEVKWFWGUUQUWAUVHUVMUWAUVHSUVTUVGSZQDVRUUQUVMUVTUVGQDWHUUQUWEU
      VMQDUUQUURDRZSZUVTUVGUVMUWGUVGUVMVSUVTUVGBUVSRZUVAUVSRZUAUVDVQZULIVRZVSZV
      SUWGUVGUWLUUQUVGUWLVNUWFUUQUUSUWHUVFUWKUUQUUSUUSUVPSUWHUUQUVPUUSUVQWIBUUR
      HVTWLUUQUVEUWJULIUUQUVCIRZSUVBUWIUAUVDUUQUWMUUTUVDRZUVBUWIVNZUWMUWNSUUQUU
      TIRZUWOFUUTUVCIKWJUUQUWPSZUVBUVBUVAHRZSUWIUWQUWRUVBUUQIHUUTCAIHCWMZYNPTZW
      NWIUVAUURHVTWLWOWPWQWRWSTZWTUVTUVMUWLUVGUVTUVJUWHUVLUWKUVIUVSBXAUVTUVKUWI
      ULUAIUVDUVIUVSUVAXAXBWSZXCXDXEXFXGXHXJXIUUQUVNUVGQDUWGUVNUWLUVGUWGUVSERUV
      NUWLVSUWGUVSUUKEUWGYSUULUWFUVSUUKRUUQYSUWFUWCTUUQUULUWFUWDTUUQUWFXKUURHDU
      IGXLXMJXNUVMUWLUMUVSEUXBXOVAUXAXPXIXQYAUUQQUVABULUACDFYJIUUQYSYRUWCYTUNKA
      FXRRYNOTZUUQCIXSZYMIYJCWMUUQUWSUXDUWTIHCYBVAZAYKYMXTZIYJCYCWBUWQUVAYDZYEU
      UQUMUVABULUACEFUUFIAUUIYNUUMTKUXCUUQUXDYLUUFUDIUUFCWMUXEUUQYLHYJUUQUWSYLH
      UDUWTIHCYFVAUXFYGIUUFCYCWBUXGYEYHVDYI $.
  $}

  ${
    $d f u x y J $.  $d f u x y K $.  $d f x y X $.
    $( A finer topology has fewer convergent sequences (but the sequences that
       do converge, converge to the same value).  (Contributed by Mario
       Carneiro, 15-Sep-2015.) $)
    sslm $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` X ) /\ J C_ K ) ->
                 ( ~~>t ` K ) C_ ( ~~>t ` J ) ) $=
      ( vf vx vu vy ctopon cfv wcel wss w3a cv wral copab clm idd wceq lmfval
      cc cpm co cres wf cuz crn wi ssralv 3anim123d ssopab2dv 3ad2ant3 3ad2ant2
      wrex 3ad2ant1 3sstr4d ) ACHIZJZBUPJZABKZLDMZCTUAUBJZEMZCJZVBFMZJGMZVDUTVE
      UCUDGUEUFUMUGZFBNZLZDEOZVAVCVFFANZLZDEOZBPIZAPIZUSUQVIVLKURUSVHVKDEUSVAVA
      VCVCVGVJUSVAQUSVCQVFFABUHUIUJUKURUQVMVIRUSEGFDBCSULUQURVNVLRUSEGFDACSUNUO
      $.
  $}

  ${
    $d j k u F $.  $d j k u J $.  $d j k u M $.  $d j k u P $.  $d j k u ph $.
    $d j k u V $.  $d j k u X $.
    lmres.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    lmres.4 $e |- ( ph -> F e. ( X ^pm CC ) ) $.
    lmres.5 $e |- ( ph -> M e. ZZ ) $.
    $( A function converges iff its restriction to an upper integers set
       converges.  (Contributed by Mario Carneiro, 31-Dec-2013.) $)
    lmres $p |- ( ph -> ( F ( ~~>t ` J ) P <->
                          ( F |` ( ZZ>= ` M ) ) ( ~~>t ` J ) P ) ) $=
      ( vu vk vj cuz cfv cc wcel cv wa wral cvv cres cpm co cdm wrex wi w3a clm
      wbr wss ctopon toponmax syl cnex ssid uzssz zsscn pmss12g mpanl12 sylancl
      cz sstri fvex pmresg sylancr sseldd 2thd wb eqid uztrn2 dmres elin2 fvres
      eleq1d anbi12d ralbidva rexbiia imbi2i ralbii a1i 3anbi13d lmbr2 3bitr4rd
      baib ) ACEMNZUAZFOUBUCZPZBFPZBJQZPZKQZWFUDZPZWLWFNZWJPZRZKLQZMNZSZLWEUEZU
      FZJDSZUGCWGPZWIWKWLCUDZPZWLCNZWJPZRZKWSSZLWEUEZUFZJDSZUGWFBDUHNZUICBXNUIA
      WHXDXCXMWIAWHXDAFWEUBUCZWGWFAFDPZOTPZXOWGUJZADFUKNPXPGFDULUMUNFFUJWEOUJXP
      XQRXRFUOWEVAOEUPUQVBFWEFODTURUSUTAWETPXDWFXOPEMVCHFWEOCTVDVEVFHVGXCXMVHAX
      BXLJDXAXKWKWTXJLWEWRWEPZWQXIKWSXSWLWSPRWLWEPZWQXIVHEWLWRWEWEVIZVJXTWNXFWP
      XHWNXTXFWLWEXEWMCWEVKVLWDXTWOXGWJWLWECVMVNVOUMVPVQVRVSVTWAAJBLKWFDEFWEGYA
      IWBAJBLKCDEFWEGYAIWBWC $.
  $}

  ${
    $d j k u x y F $.  $d j k u x y J $.  $d j k M $.  $d j k u P $.
    $d k u S $.  $d j k u y ph $.  $d j k u V $.  $d j k u x y X $.
    $d j k u x Z $.
    lmff.1 $e |- Z = ( ZZ>= ` M ) $.
    lmff.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    lmff.4 $e |- ( ph -> M e. ZZ ) $.
    ${
      lmff.5 $e |- ( ph -> F e. dom ( ~~>t ` J ) ) $.
      $( If ` F ` converges, there is some upper integer set on which ` F ` is
         a total function.  (Contributed by Mario Carneiro, 31-Dec-2013.) $)
      lmff $p |- ( ph ->
                   E. j e. Z ( F |` ( ZZ>= ` j ) ) : ( ZZ>= ` j ) --> X ) $=
        ( vx vy cuz cfv wf wrex cz wcel syl cres crn clm wbr cop wex cdm eldm2g
        cv ibi df-br exbii sylibr wa wi wral ctopon toponmax adantr cc cpm lmbr
        co biimpa simp3d lmcl sylan wceq eleq2 feq3 rexbidv imbi12d rspcv syl3c
        w3a exlimddv cpw wfn wb uzf ffn reseq2 id feq12d rexrn mp2b rexuz3 wfun
        sylib simp1d pmfun ffvresb 3bitr4d mpbird ) ABUIZNOZFCWPUAZPZBGQZWRBRQZ
        ALUIZFCXAUAZPZLNUBZQZWTACMUIZDUCOZUDZXEMACXFUEXGSZMUFZXHMUFACXGUGZSZXJK
        XLXJMCXGXKUHUJTXHXIMCXFXGUKULUMZAXHUNZFDSZXFWOSZXAWOXBPZLXDQZUOZBDUPZXF
        FSZXEAXOXHADFUQOSZXOIFDURTUSXNCFUTVAVCSZYAXTAXHYCYAXTVOALBXFCDFIVBVDZVE
        AYBXHYAIXFCDFVFVGXSYAXEUOBFDWOFVHZXPYAXRXEWOFXFVIYEXQXCLXDWOFXAXBVJVKVL
        VMVNVPRRVQZNPNRVRXEWTVSVTRYFNWAXCWRLBRNXAWPVHZXAWPFXBWQXAWPCWBYGWCWDWEW
        FWIAXACUGSXACOFSUNZLWPUPZBGQZYIBRQZWSWTAERSYJYKVSJYHBLEGHWGTAWRYIBGACWH
        ZWRYIVSAYCYLAXHYCMXMXNYCYAXTYDWJVPFUTCWKTLWPFCWLTZVKAWRYIBRYMVKWMWN $.
    $}

    lmcls.5 $e |- ( ph -> F ( ~~>t ` J ) P ) $.
    lmcls.7 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. S ) $.
    ${
      lmcls.8 $e |- ( ph -> S C_ X ) $.
      $( Any convergent sequence of points in a subset of a topological space
         converges to a point in the closure of the subset.  (Contributed by
         Mario Carneiro, 30-Dec-2013.)  (Revised by Mario Carneiro,
         1-May-2014.) $)
      lmcls $p |- ( ph -> P e. ( ( cls ` J ) ` S ) ) $=
        ( vu vj cfv wcel cv ccl cin c0 wne wi wral cdm wa cuz cc cpm co clm wbr
        wrex w3a lmbr2 mpbid simp3d r19.2uz inelcm a1i mpan2d adantld rexlimdva
        syl5 imim2d ralimdv mpd ctop cuni wss ctopon topontop syl wceq toponuni
        wb sseqtrd lmcl syl2anc eleqtrd eqid elcls syl3anc mpbird ) ABCFUARRSZB
        PTZSZWHCUBUCUDZUEZPFUFZAWIDTZEUGSZWMERZWHSZUHZDQTUIRUFQIUOZUEZPFUFZWLAE
        HUJUKULSZBHSZWTAEBFUMRUNZXAXBWTUPMAPBQDEFGHIKJLUQURUSAWSWKPFAWRWJWIWRWQ
        DIUOAWJWQQDGIJUTAWQWJDIAWMISUHZWPWJWNXDWPWOCSZWJNWPXEUHWJUEXDWOWHCVAVBV
        CVDVEVFVGVHVIAFVJSZCFVKZVLBXGSWGWLVRAFHVMRSZXFKHFVNVOACHXGOAXHHXGVPKHFV
        QVOZVSABHXGAXHXCXBKMBEFHVTWAXIWBPBCFXGXGWCWDWEWF $.
    $}

    lmcld.8 $e |- ( ph -> S e. ( Clsd ` J ) ) $.
    $( Any convergent sequence of points in a closed subset of a topological
       space converges to a point in the set.  (Contributed by Mario Carneiro,
       30-Dec-2013.) $)
    lmcld $p |- ( ph -> P e. S ) $=
      ( ccl cfv wcel syl wceq cuni ccld wss eqid cldss ctopon toponuni sseqtr4d
      lmcls cldcls eleqtrd ) ABCFPQQZCABCDEFGHIJKLMNACFUAZHACFUBQRZCUMUCOCFUMUM
      UDUESAFHUFQRHUMTKHFUGSUHUIAUNULCTOCFUJSUK $.
  $}

  ${
    $d j k u v F $.  $d j k u v G $.  $d j k u v K $.  $d j k u v ph $.
    $d j k v J $.  $d j k u v P $.
    lmcnp.3 $e |- ( ph -> F ( ~~>t ` J ) P ) $.
    ${
      lmcnp.4 $e |- ( ph -> G e. ( ( J CnP K ) ` P ) ) $.
      $( The image of a convergent sequence under a continuous map is
         convergent to the image of the original point.  (Contributed by Mario
         Carneiro, 3-May-2014.) $)
      lmcnp $p |- ( ph -> ( G o. F ) ( ~~>t ` K ) ( G ` P ) ) $=
        ( vu vk vj vv cfv cc wcel wa cn wrex syl cvv ccom clm wbr cpm co cv cdm
        cuni cuz wral wi wf wss ccnp eqid cnpf w3a ctop ctopon cnptop1 toptopon
        c1 sylib nnuz cz 1z a1i lmbr2 mpbid simp1d wb uniexg cnex elpm2g simpld
        sylancl fco syl2anc wceq fdm feq2d mpbird simprd eqsstrd cnptop2 simp2d
        mpbir2and ffvelrnd simp3d adantr cnpimaex 3expb sylan r19.29 pm3.45 imp
        cima reximi wfn ad3antrrr simplrl elssuni fnfvima 3expia ad2antrr fvco3
        eleq1d sylibrd simplrr sseld syld simpr eleqtrrd jctild expimpd ralimdv
        ffn reximdv expr com23 imp3a rexlimdva syl5 mp2and ralrimiva mpbir3and
        ) ADCUAZBDMZFUBMUCYGFUHZNUDUEOZYHYIOYHIUFZOZJUFZYGUGZOZYMYGMZYKOZPZJKUF
        UIMZUJZKQRZUKZIFUJAYJYNYIYGULZYNNUMZAUUCCUGZYIYGULZAEUHZYIDULZUUEUUGCUL
        ZUUFADBEFUNUEMOZUUHHBDEFUUGYIUUGUOZYIUOZUPSZAUUIUUENUMZACUUGNUDUEOZUUIU
        UNPZAUUOBUUGOZBLUFZOZYMUUEOZYMCMZUUROZPZJYSUJZKQRZUKZLEUJZACBEUBMUCUUOU
        UQUVGUQGALBKJCEVBUUGQAEUROZEUUGUSMOAUUJUVHHBDEFUTSZEUUGUUKVAVCVDVBVEOAV
        FVGZVHVIZVJAUUGTOZNTOZUUOUUPVKAUVHUVLUVIEURVLSVMUUGNCTTVNVPVIZVOZUUEUUG
        YIDCVQVRZAYNUUEYIYGAUUFYNUUEVSZUVPUUEYIYGVTSZWAWBAYNUUENUVRAUUIUUNUVNWC
        WDAYITOZUVMYJUUCUUDPVKAFUROZUVSAUUJUVTHBDEFWESZFURVLSVMYINYGTTVNVPWGAUU
        GYIBDUUMAUUOUUQUVGUVKWFWHAUUBIFAYKFOZYLUUAAUWBYLPZPZUVGUUSDUURWQZYKUMZP
        ZLERZUUAAUVGUWCAUUOUUQUVGUVKWIWJAUUJUWCUWHHUUJUWBYLUWHLYKBDEFWKWLWMUVGU
        WHPZUVEUWFPZLERZUWDUUAUWIUVFUWGPZLERUWKUVFUWGLEWNUWLUWJLEUVFUWGUWJUUSUV
        EUWFWOWPWRSUWDUWJUUALEUWDUUREOZPZUVEUWFUUAUWNUWFUVEUUAUWDUWMUWFUVEUUAUK
        UWDUWMUWFPZPZUVDYTKQUWPUVCYRJYSUWPUUTUVBYRUWPUUTPZUVBYQYOUWQUVBYPUWEOZY
        QUWQUVBUVADMZUWEOZUWRUWQDUUGWSZUURUUGUMZUVBUWTUKUWQUUHUXAAUUHUWCUWOUUTU
        UMWTUUGYIDXQSUWQUWMUXBUWDUWMUWFUUTXAUUREXBSUXAUXBUVBUWTUUGUURDUVAXCXDVR
        UWQYPUWSUWEUWPUUIUUTYPUWSVSAUUIUWCUWOUVOXEUUEUUGYMDCXFWMXGXHUWQUWEYKYPU
        WDUWMUWFUUTXIXJXKUWQYMUUEYNUWPUUTXLAUVQUWCUWOUUTUVRWTXMXNXOXPXRXSXTYAYB
        YCYDXSYEAIYHKJYGFVBYIQAUVTFYIUSMOUWAFYIUULVAVCVDUVJVHYF $.
    $}

    lmcn.4 $e |- ( ph -> G e. ( J Cn K ) ) $.
    $( The image of a convergent sequence under a continuous map is convergent
       to the image of the original point.  (Contributed by Mario Carneiro,
       3-May-2014.) $)
    lmcn $p |- ( ph -> ( G o. F ) ( ~~>t ` K ) ( G ` P ) ) $=
      ( ccn co wcel cuni ccnp cfv ctopon clm wbr ctop cntop1 syl2anc eqid sylib
      syl toptopon lmcl cncnpi lmcnp ) ABCDEFGADEFIJKZBELZKZDBEFMJNKHAEUIONKZCB
      EPNQUJAERKZUKAUHULHDEFSUCEUIUIUAZUDUBGBCEUIUETBDEFUIUMUFTUG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Separated spaces: T0, T1, T2 (Hausdorff) ...
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Kol2 $.
  $c Fre $. $( The class of all the T1-spaces. $)
  $c Haus $. $( Declare new symbol for Hausdorff space. $)
  $c Reg $.
  $c Nrm $.
  $c CNrm $.
  $c PNrm $.

  $( Extend class notation with the class of all T0 spaces. $)
  ct0 $a class Kol2 $.

  $( Extend class notation to include T_1 spaces (also called Fr&eacute;chet
     spaces). $)
  ct1 $a class Fre $.

  $( Extend class notation with the class of all Hausdorff spaces. $)
  cha $a class Haus $.

  $( Extend class notation with the class of all regular topologies. $)
  creg $a class Reg $.

  $( Extend class notation with the class of all normal topologies. $)
  cnrm $a class Nrm $.

  $( Extend class notation with the class of all completely normal
     topologies. $)
  ccnrm $a class CNrm $.

  $( Extend class notation with the class of all perfectly normal
     topologies. $)
  cpnrm $a class PNrm $.

  ${
    $d a f j m n o x y z $.
    $( Define T0 or Kolmogorov spaces.  A T_0 space satisfies a kind of
       "topological extensionality" principle (compare ~ ax-ext ): any two
       points which are members of the same open sets are equal, or in
       contraposition, for any two distinct points there is an open set which
       contains one point but not the other.  This differs from T_1 spaces (see
       ~ ist1-2 ) in that in a T_1 space you can choose which point will be in
       the open set and which outside; in a T_0 space you only know that one of
       the two points is in the set.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    df-t0 $a |- Kol2 = { j e. Top | A. x e. U. j A. y e. U. j
      ( A. o e. j ( x e. o <-> y e. o ) -> x = y ) } $.

    $( The class of all T_1 spaces, also called Fr&eacute;chet spaces.  Morris,
       Topology without tears, p. 30 ex. 3.  (Contributed by FL,
       18-Jun-2007.) $)
    df-t1 $a |- Fre = { x e. Top | A. a e. U. x { a } e. ( Clsd ` x ) } $.

    $( Define the class of all Hausdorff spaces.  A Hausdorff space is a
       topology in which distinct points have disjoint open neighborhoods.
       Definition of Hausdorff space in [Munkres] p. 98.  (Contributed by NM,
       8-Mar-2007.) $)
    df-haus $a |- Haus = { j e. Top | A. x e. U. j A. y e. U. j ( x =/= y ->
           E. n e. j E. m e. j ( x e. n /\ y e. m /\ ( n i^i m ) = (/) ) ) } $.

    $( Define regular spaces.  A space is regular if a point and a closed set
       can be separated by neighborhoods.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    df-reg $a |- Reg = { j e. Top | A. x e. j A. y e. x
      E. z e. j ( y e. z /\ ( ( cls ` j ) ` z ) C_ x ) } $.

    $( Define normal spaces.  A space is normal if disjoint closed sets can be
       separated by neighborhoods.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    df-nrm $a |- Nrm = { j e. Top | A. x e. j A. y e. ( ( Clsd ` j ) i^i ~P x )
      E. z e. j ( y C_ z /\ ( ( cls ` j ) ` z ) C_ x ) } $.

    $( Define completely normal spaces.  A space is completely normal if all
       its subspaces are normal.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    df-cnrm $a |- CNrm = { j e. Top | A. x e. ~P U. j ( j |`t x ) e. Nrm } $.

    $( Define perfectly normal spaces.  A space is perfectly normal if it is
       normal and every closed set is a G_&delta; set, meaning that it is a
       countable intersection of open sets.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    df-pnrm $a |- PNrm = { j e. Nrm | ( Clsd ` j ) C_
      ran ( f e. ( j ^m NN ) |-> |^| ran f ) } $.
  $}

  ${
    $d o x y z A $.  $d o x z B $.  $d a j m n o x y z J $.  $d j o x y z X $.
    $d m n x y P $.  $d m n y Q $.
    ist0.1 $e |- X = U. J $.
    $( The predicate "is a T_0 space."  Every pair of distinct points is
       topologically distinguishable.  For the way this definition is usually
       encountered, see ~ ist0-3 .  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    ist0 $p |- ( J e. Kol2 <-> ( J e. Top /\ A. x e. X A. y e. X
      ( A. o e. J ( x e. o <-> y e. o ) -> x = y ) ) ) $=
      ( vj wel wb cv wral wceq wi cuni ctop ct0 unieq syl6eqr raleq raleqbidv
      imbi1d df-t0 elrab2 ) ACHBCHIZCGJZKZAJBJLZMZBUENZKZAUIKUDCDKZUGMZBEKZAEKG
      DOPUEDLZUJUMAUIEUNUIDNEUEDQFRZUNUHULBUIEUOUNUFUKUGUDCUEDSUATTABGCUBUC $.

    $( The predicate ` J ` is T_1.  (Contributed by FL, 18-Jun-2007.) $)
    ist1 $p |- ( J e. Fre <->
      ( J e. Top /\ A. a e. X { a } e. ( Clsd ` J ) ) ) $=
      ( vx csn ccld cfv wcel cuni wral ctop ct1 wceq unieq syl6eqr eleq2d fveq2
      cv imbi12d ralbidv2 df-t1 elrab2 ) CSZFZESZGHZIZCUFJZKUEAGHZIZCBKEALMUFAN
      ZUHUKCUIBULUDUIIUDBIUHUKULUIBUDULUIAJBUFAODPQULUGUJUEUFAGRQTUAECUBUC $.

    $( Express the predicate " ` J ` is a Hausdorff space."  (Contributed by
       NM, 8-Mar-2007.) $)
    ishaus $p |- ( J e. Haus <-> ( J e. Top /\ A. x e. X A. y e. X ( x =/= y ->
               E. n e. J E. m e. J ( x e. n /\ y e. m /\
                   ( n i^i m ) = (/) ) ) ) ) $=
      ( vj cv wne wel cin c0 wceq w3a wrex wi cuni wral raleqbidv unieq syl6eqr
      ctop cha rexeq rexeqbi1dv imbi2d df-haus elrab2 ) AIBIJZADKBCKDICILMNOZCH
      IZPZDULPZQZBULRZSZAUPSUJUKCEPZDEPZQZBFSZAFSHEUCUDULENZUQVAAUPFVBUPERFULEU
      AGUBZVBUOUTBUPFVCVBUNUSUJUMURDULEUKCULEUEUFUGTTABHCDUHUI $.

    $( The property of being completely or hereditarily normal.  (Contributed
       by Mario Carneiro, 26-Aug-2015.) $)
    iscnrm $p |- ( J e. CNrm <->
        ( J e. Top /\ A. x e. ~P X ( J |`t x ) e. Nrm ) ) $=
      ( vj cv crest cnrm wcel cuni cpw wral ctop ccnrm wceq unieq syl6eqr pweqd
      co oveq1 eleq1d raleqbidv df-cnrm elrab2 ) EFZAFZGSZHIZAUEJZKZLBUFGSZHIZA
      CKZLEBMNUEBOZUHULAUJUMUNUICUNUIBJCUEBPDQRUNUGUKHUEBUFGTUAUBAEUCUD $.

    $( Any two topologically indistinguishable points in a T_0 space are
       identical.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    t0sep $p |- ( ( J e. Kol2 /\ ( A e. X /\ B e. X ) ) ->
      ( A. x e. J ( A e. x <-> B e. x ) -> A = B ) ) $=
      ( vy vz ct0 wcel cv wb wral wceq wi wa ctop eleq1 ralbidv imbi12d simprbi
      ist0 bibi1d eqeq1 bibi2d eqeq2 rspc2va ancoms sylan ) DIJZGKZAKZJZHKZULJZ
      LZADMZUKUNNZOZHEMGEMZBEJCEJPZBULJZCULJZLZADMZBCNZOZUJDQJUTGHADEFUBUAVAUTV
      GUSVGVBUOLZADMZBUNNZOGHBCEEUKBNZUQVIURVJVKUPVHADVKUMVBUOUKBULRUCSUKBUNUDT
      UNCNZVIVEVJVFVLVHVDADVLUOVCVBUNCULRUESUNCBUFTUGUHUI $.

    $( Any two distinct points in a T_0 space are topologically
       distinguishable.  (Contributed by Jeff Hankins, 1-Feb-2010.) $)
    t0dist $p |- ( ( J e. Kol2 /\ ( A e. X /\ B e. X /\ A =/= B ) ) -> E. o e.
    J -. ( A e. o <-> B e. o ) ) $=
      ( ct0 wcel wne w3a wa cv wb wral wn wrex wi t0sep necon3ad exp32 rexnal
      3imp2 sylibr ) DGHZAEHZBEHZABIZJKACLZHBUHHMZCDNZOZUIOCDPUDUEUFUGUKUDUEUFU
      GUKQUDUEUFKKUJABCABDEFRSTUBUICDUAUC $.

    $( In a T_1 space, one-point sets are closed.  (Contributed by Jeff
       Hankins, 1-Feb-2010.) $)
    t1sncld $p |- ( ( J e. Fre /\ A e. X ) -> { A } e. ( Clsd ` J ) ) $=
      ( vx ct1 wcel csn ccld cfv wral ctop ist1 simprbi wceq sneq eleq1d rspccv
      cv wi syl imp ) BFGZACGZAHZBIJZGZUCESZHZUFGZECKZUDUGTUCBLGUKBCEDMNUJUGEAC
      UHAOUIUEUFUHAPQRUAUB $.

    $( In a T_1 space, finite sets are closed.  (Contributed by Mario Carneiro,
       25-Dec-2016.) $)
    t1ficld $p |- ( ( J e. Fre /\ A C_ X /\ A e. Fin ) ->
      A e. ( Clsd ` J ) ) $=
      ( vx ct1 wcel wss cfn w3a csn ciun ccld cfv iunid ctop wral ist1 simplbi
      cv 3ad2ant1 simp3 simprbi ssralv mpan9 3adant3 iuncld syl3anc syl5eqelr )
      BFGZACHZAIGZJZAEAETKZLZBMNZEAOUMBPGZULUNUPGZEAQZUOUPGUJUKUQULUJUQURECQZBC
      EDRZSUAUJUKULUBUJUKUSULUJUTUKUSUJUQUTVAUCUREACUDUEUFEAUNBCDUGUHUI $.

    $( Neighborhood property of a Hausdorff space.  (Contributed by NM,
       8-Mar-2007.) $)
    hausnei $p |- ( ( J e. Haus /\ ( P e. X /\ Q e. X /\ P =/= Q ) ) ->
           E. n e. J E. m e. J ( P e. n /\ Q e. m /\
                   ( n i^i m ) = (/) ) ) $=
      ( vx vy wcel wne cv wceq w3a wrex wi wral eleq1 2rexbidv imbi12d cha ctop
      cin c0 wa ishaus simprbi neeq1 3anbi1d neeq2 3anbi2d rspc2v syl5 ex com3r
      3imp2 ) EUAJZAFJZBFJZABKZADLZJZBCLZJZVAVCUCUDMZNZCEODEOZURUSUQUTVGPZURUSU
      QVHPUQHLZILZKZVIVAJZVJVCJZVENZCEODEOZPZIFQHFQZURUSUEVHUQEUBJVQHICDEFGUFUG
      VPVHAVJKZVBVMVENZCEODEOZPHIABFFVIAMZVKVRVOVTVIAVJUHWAVNVSDCEEWAVLVBVMVEVI
      AVARUISTVJBMZVRUTVTVGVJBAUJWBVSVFDCEEWBVMVDVBVEVJBVCRUKSTULUMUNUOUP $.
  $}

  ${
    $d f g x y z A $.  $d x z B $.  $d x y C $.  $d x y D $.  $d u v w x y K $.
    $d m n u v w x y z F $.  $d c d f g j m n o u v w x y z J $.  $d x y z U $.
    $d x V $.  $d o u v w x y X $.  $d u v w x y Y $.
    $( A T_0 space is a topological space.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    t0top $p |- ( J e. Kol2 -> J e. Top ) $=
      ( vx vo vy ct0 wcel ctop wel wb wral weq wi cuni eqid ist0 simplbi ) AEFA
      GFBCHDCHICAJBDKLDAMZJBQJBDCAQQNOP $.

    $( A T_1 space is a topological space.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    t1top $p |- ( J e. Fre -> J e. Top ) $=
      ( vx ct1 wcel ctop cv csn ccld cfv cuni wral eqid ist1 simplbi ) ACDAEDBF
      GAHIDBAJZKAOBOLMN $.

    $( A Hausdorff space is a topology.  (Contributed by NM, 5-Mar-2007.) $)
    haustop $p |- ( J e. Haus -> J e. Top ) $=
      ( vx vy vn vm cha wcel ctop cv wne wel cin c0 wceq wrex wi cuni wral eqid
      w3a ishaus simplbi ) AFGAHGBICIJBDKCEKDIEILMNTEAODAOPCAQZRBUCRBCEDAUCUCSU
      AUB $.

    $( The predicate "is a regular space."  In a regular space, any open
       neighborhood has a closed subneighborhood.  Note that some authors
       require the space to be Hausdorff (which would make it the same as T_3),
       but we reserve the phrase "regular Hausdorff" for that as many
       topologists do.  (Contributed by Jeff Hankins, 1-Feb-2010.)  (Revised by
       Mario Carneiro, 25-Aug-2015.) $)
    isreg $p |- ( J e. Reg <-> ( J e. Top /\ A. x e. J A. y e. x
      E. z e. J ( y e. z /\ ( ( cls ` J ) ` z ) C_ x ) ) ) $=
      ( vj wel cv ccl cfv wss wa wrex wral ctop creg fveq2 fveq1d sseq1d anbi2d
      wceq rexeqbi1dv ralbidv raleqbi1dv df-reg elrab2 ) BCFZCGZEGZHIZIZAGZJZKZ
      CUHLZBUKMZAUHMUFUGDHIZIZUKJZKZCDLZBUKMZADMEDNOUOVAAUHDUHDTZUNUTBUKUMUSCUH
      DVBULURUFVBUJUQUKVBUGUIUPUHDHPQRSUAUBUCABCEUDUE $.

    $( A regular space is a topological space.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    regtop $p |- ( J e. Reg -> J e. Top ) $=
      ( vy vz vx creg wcel ctop cv ccl cfv wss wa wrex wral isreg simplbi ) AEF
      AGFBHCHZFQAIJJDHZKLCAMBRNDANDBCAOP $.

    $( In a regular space, every neighborhood of a point contains a closed
       subneighborhood.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    regsep $p |- ( ( J e. Reg /\ U e. J /\ A e. U ) ->
      E. x e. J ( A e. x /\ ( ( cls ` J ) ` x ) C_ U ) ) $=
      ( vz vy creg wcel cv ccl cfv wss wa wrex wral wi ctop wceq rexbidv rspccv
      isreg simprbi sseq2 anbi2d raleqbi1dv syl eleq1 anbi1d syl6 3imp ) DGHZCD
      HZBCHZBAIZHZUNDJKKZCLZMZADNZUKULEIZUNHZUQMZADNZECOZUMUSPUKVAUPFIZLZMZADNZ
      EVEOZFDOZULVDPUKDQHVJFEADUAUBVIVDFCDVHVCEVECVECRZVGVBADVKVFUQVAVECUPUCUDS
      UETUFVCUSEBCUTBRZVBURADVLVAUOUQUTBUNUGUHSTUIUJ $.

    $( The predicate "is a normal space."  Much like the case for regular
       spaces, normal does not imply Hausdorff or even regular.  (Contributed
       by Jeff Hankins, 1-Feb-2010.)  (Revised by Mario Carneiro,
       24-Aug-2015.) $)
    isnrm $p |- ( J e. Nrm <-> ( J e. Top /\
      A. x e. J A. y e. ( ( Clsd ` J ) i^i ~P x ) E. z e. J
        ( y C_ z /\ ( ( cls ` J ) ` z ) C_ x ) ) ) $=
      ( vj cv wss ccl cfv wa wrex ccld cpw cin wral ctop cnrm wceq fveq2 ineq1d
      fveq1d sseq1d anbi2d rexeqbi1dv raleqbidv raleqbi1dv df-nrm elrab2 ) BFCF
      ZGZUIEFZHIZIZAFZGZJZCUKKZBUKLIZUNMZNZOZAUKOUJUIDHIZIZUNGZJZCDKZBDLIZUSNZO
      ZADOEDPQVAVIAUKDUKDRZUQVFBUTVHVJURVGUSUKDLSTUPVECUKDVJUOVDUJVJUMVCUNVJUIU
      LVBUKDHSUAUBUCUDUEUFABCEUGUH $.

    $( A normal space is a topological space.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    nrmtop $p |- ( J e. Nrm -> J e. Top ) $=
      ( vy vz vx cnrm wcel ctop cv wss ccl cfv wrex ccld cpw wral isnrm simplbi
      wa cin ) AEFAGFBHCHZITAJKKDHZIRCALBAMKUANSODAODBCAPQ $.

    $( A completely normal space is a topological space.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    cnrmtop $p |- ( J e. CNrm -> J e. Top ) $=
      ( vx ccnrm wcel ctop cv crest co cnrm cuni cpw wral eqid iscnrm simplbi )
      ACDAEDABFGHIDBAJZKLBAPPMNO $.

    $( The property of being completely or hereditarily normal.  (Contributed
       by Mario Carneiro, 26-Aug-2015.) $)
    iscnrm2 $p |- ( J e. ( TopOn ` X ) ->
        ( J e. CNrm <-> A. x e. ~P X ( J |`t x ) e. Nrm ) ) $=
      ( ctopon cfv wcel ccnrm cv crest co cnrm cuni cpw wral ctop topontop eqid
      wb iscnrm baib syl toponuni pweqd raleqdv bitr4d ) BCDEFZBGFZBAHIJKFZABLZ
      MZNZUHACMZNUFBOFZUGUKRCBPUGUMUKABUIUIQSTUAUFUHAULUJUFCUICBUBUCUDUE $.

    $( The property of being perfectly normal.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    ispnrm $p |- ( J e. PNrm <-> ( J e. Nrm /\
        ( Clsd ` J ) C_ ran ( f e. ( J ^m NN ) |-> |^| ran f ) ) ) $=
      ( vj cv ccld cfv cn cmap co crn cint cmpt wss cnrm cpnrm wceq fveq2 oveq1
      mpteq1d rneqd sseq12d df-pnrm elrab2 ) CDZEFZAUDGHIZADJKZLZJZMBEFZABGHIZU
      GLZJZMCBNOUDBPZUEUJUIUMUDBEQUNUHULUNAUFUKUGUDBGHRSTUAACUBUC $.

    $( A perfectly normal space is normal.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    pnrmnrm $p |- ( J e. PNrm -> J e. Nrm ) $=
      ( vx cpnrm wcel cnrm ccld cfv cn cmap co crn cint cmpt wss ispnrm simplbi
      cv ) ACDAEDAFGBAHIJBQKLMKNBAOP $.

    $( A perfectly normal space is a topological space.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    pnrmtop $p |- ( J e. PNrm -> J e. Top ) $=
      ( cpnrm wcel cnrm ctop pnrmnrm nrmtop syl ) ABCADCAECAFAGH $.

    $( A closed set in a perfectly normal space is a countable intersection of
       open sets.  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    pnrmcld $p |- ( ( J e. PNrm /\ A e. ( Clsd ` J ) ) ->
        E. f e. ( J ^m NN ) A = |^| ran f ) $=
      ( cpnrm wcel ccld cfv wa cn cmap co cv crn cint cmpt wceq wrex wss ispnrm
      cnrm simprbi sselda wb eqid elrnmpt adantl mpbid ) CDEZACFGZEZHABCIJKZBLM
      NZOZMZEZAULPBUKQZUHUIUNAUHCTEUIUNRBCSUAUBUJUOUPUCUHBUKULAUMUIUMUDUEUFUG
      $.

    $( An open set in a perfectly normal space is a countable union of closed
       sets.  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    pnrmopn $p |- ( ( J e. PNrm /\ A e. J ) ->
        E. f e. ( ( Clsd ` J ) ^m NN ) A = U. ran f ) $=
      ( vg vx cpnrm wcel wa cuni cdif cv crn wceq ccld cfv cn cmap co wrex cvv
      cint ctop pnrmtop eqid opncld sylan pnrmcld syldan ad2antrr elmapi adantl
      cmpt ffvelrnda syl2anc fmptd fvex nnex elmap sylibr ciun ciin iundif2 wfn
      wf ffn fniinfv 3syl difeq2d syl5eq cab uniexg difexg syl ralrimivw adantr
      wral dfiun2g rnmpt unieqi syl6eqr eqtr3d rneq unieqd eqeq2d rspcev difeq2
      ad2ant2r eqcomd wss elssuni dfss4 sylib sylan9eqr ad2ant2l eqeq1d rexbidv
      mpbid rexlimddv ) CFGZACGZHZCIZAJZDKZLUAZMZABKZLZIZMZBCNOZPQRZSZDCPQRZWSW
      TXCXKGZXFDXNSWSCUBGZWTXOCUCZACXBXBUDZUEUFXCDCUGUHXAXDXNGZXFHHZXBXEJZXIMZB
      XLSZXMWSXSYCWTXFWSXSHZEPXBEKZXDOZJZULZXLGZYAYHLZIZMZYCYDPXKYHVDYIYDEPYGXK
      YHYDYEPGZHXPYFCGYGXKGWSXPXSYMXQUIYDPCYEXDXSPCXDVDZWSXDCPUJUKZUMYFCXBXRUEU
      NYHUDZUOXKPYHCNUPUQURUSYDEPYGUTZYAYKYDYQXBEPYFVAZJYAEPXBYFVBYDYRXEXBYDYNX
      DPVCYRXEMYOPCXDVEEPXDVFVGVHVIYDYQXGYGMEPSBVJZIZYKYDYGTGZEPVPZYQYTMWSUUBXS
      WSUUAEPWSXBTGUUACFVKXBYFTVLVMVNVOEBPYGTVQVMYJYSEBPYGYHYPVRVSVTWAYBYLBYHXL
      XGYHMZXIYKYAUUCXHYJXGYHWBWCWDWEUNWGXTYBXJBXLXTYAAXIWTXFYAAMWSXSXFWTYAXBXC
      JZAXFUUDYAXCXEXBWFWHWTAXBWIUUDAMACWJAXBWKWLWMWNWOWPWQWR $.

    $( The predicate "is a T_0 space".  (Contributed by Mario Carneiro,
       24-Aug-2015.) $)
    ist0-2 $p |- ( J e. ( TopOn ` X ) -> ( J e. Kol2 <-> A. x e. X A. y e. X
        ( A. o e. J ( x e. o <-> y e. o ) -> x = y ) ) ) $=
      ( ctopon cfv wcel ct0 wel wb wral weq cuni ctop topontop eqid ist0 baib
      wi syl toponuni raleqdv raleqbidv bitr4d ) DEFGHZDIHZACJBCJKCDLABMTZBDNZL
      ZAUILZUHBELZAELUFDOHZUGUKKEDPUGUMUKABCDUIUIQRSUAUFULUJAEUIEDUBZUFUHBEUIUN
      UCUDUE $.

    $( The predicate "is a T_0 space," expressed in more familiar terms.
       (Contributed by Jeff Hankins, 1-Feb-2010.) $)
    ist0-3 $p |- ( J e. ( TopOn ` X ) -> ( J e. Kol2 <->
       A. x e. X A. y e. X ( x =/= y -> E. o e. J
         ( ( x e. o /\ -. y e. o ) \/ ( -. x e. o /\ y e. o ) ) ) ) ) $=
      ( ctopon cfv wcel ct0 wel wb wral weq wi cv wne wn wa wo wrex df-ne ancom
      ist0-2 con34b xor orbi2i bitri rexbii rexnal bitr3i imbi12i bitr4i syl6bb
      2ralbii ) DEFGHDIHACJZBCJZKZCDLZABMZNZBELAELAOZBOZPZUOUPQRZUOQZUPRZSZCDTZ
      NZBELAELABCDEUCUTVIABEEUTUSQZURQZNVIURUSUDVCVJVHVKVAVBUAVHUQQZCDTVKVLVGCD
      VLVDUPVERZSVGUOUPUEVMVFVDUPVEUBUFUGUHUQCDUIUJUKULUNUM $.

    $( The preimage of a T_0 topology under an injective map is T_0.
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    cnt0 $p |- ( ( K e. Kol2 /\ F : X -1-1-> Y /\ F e. ( J Cn K ) ) ->
        J e. Kol2 ) $=
      ( vx vz vy vw ct0 wcel cv wb wral wceq wi cuni wa cfv syl wf1 ccn co ctop
      w3a cntop1 3ad2ant3 ccnv cima simpl3 cnima sylan eleq2 bibi12d rspcv eqid
      wfn cnf ffn simprl biantrurd bitr4d simprr adantr sylibd ralrimdva simpl1
      wf elpreima ffvelrnd t0sep syl12anc syld simpl2 cdm eqtr3d eleqtrd f1fveq
      fdm f1dm ralrimivva ist0 sylanbrc ) CJKZDEAUAZABCUBUCKZUEZBUDKZFLZGLZKZHL
      ZWJKZMZGBNZWIWLOZPZHBQZNFWRNBJKWFWDWHWEABCUFUGWGWQFHWRWRWGWIWRKZWLWRKZRZR
      ZWOWIASZWLASZOZWPXBWOXCILZKZXDXFKZMZICNZXEXBWOXIICXBXFCKZRZWOWIAUHXFUIZKZ
      WLXMKZMZXIXLXMBKZWOXPPXBWFXKXQWDWEWFXAUJZXFABCUKULWNXPGXMBWJXMOWKXNWMXOWJ
      XMWIUMWJXMWLUMUNUOTXBXPXIMXKXBXNXGXOXHXBXNWSXGRZXGXBAWRUQZXNXSMXBWRCQZAVH
      ZXTXBWFYBXRABCWRYAWRUPZYAUPZURTZWRYAAUSTZWRWIXFAVITXBWSXGWGWSWTUTZVAVBXBX
      OWTXHRZXHXBXTXOYHMYFWRWLXFAVITXBWTXHWGWSWTVCZVAVBUNVDVEVFXBWDXCYAKXDYAKXJ
      XEPWDWEWFXAVGXBWRYAWIAYEYGVJXBWRYAWLAYEYIVJIXCXDCYAYDVKVLVMXBWEWIDKWLDKXE
      WPMWDWEWFXAVNZXBWIWRDYGXBAVOZWRDXBYBYKWROYEWRYAAVSTXBWEYKDOYJDEAVTTVPZVQX
      BWLWRDYIYLVQDEWIWLAVRVLVEWAFHGBWRYCWBWC $.

    $( An alternate characterization of T_1 spaces.  (Contributed by Jeff
       Hankins, 31-Jan-2010.)  (Proof shortened by Mario Carneiro,
       24-Aug-2015.) $)
    ist1-2 $p |- ( J e. ( TopOn ` X ) -> ( J e. Fre <-> A. x e. X A. y e. X
        ( A. o e. J ( x e. o -> y e. o ) -> x = y ) ) ) $=
      ( cfv wcel cv wral wi wceq wb syl wa wss wrex adantr eleq2d wn imbi1i ct1
      ctopon csn ccld cuni ctop topontop eqid ist1 baib toponuni raleqdv eltop2
      cdif biimpa snssd iscld2 syl2anc wne imbi1d con1b df-ne c0 disjsn elssuni
      cin reldisj syl5bbr anbi2d rexbiia rexanali bitr3i con2bii imbi2i eldifsn
      3bitr4ri impexp 3bitr4g ralbidv2 3bitr4d ralbidva ralcom syl6bb 3bitr2d
      bitri ) DEUBFGZDUAGZBHZUCZDUDFGZBDUEZIZWJBEIZAHZCHZGZWHWOGZJCDIZWNWHKZJZB
      EIAEIZWFDUFGZWGWLLEDUGZWGXBWLDWKBWKUHZUIUJMWFWJBEWKEDUKZULWFWMWTAEIZBEIXA
      WFWJXFBEWFWHEGZNZWKWIUNZDGZWPWOXIOZNZCDPZAXIIZWJXFXHXBXJXNLWFXBXGXCQZACXI
      DUMMXHXBWIWKOWJXJLXOXHWHWKWFXGWHWKGWFEWKWHXERUOUPWIDWKXDUQURXHWTXMAEXIXHW
      NEGZWNWHUSZXMJZJWNWKGZXRJZXPWTJWNXIGZXMJZXHXPXSXRXHEWKWNWFEWKKXGXEQRUTWTX
      RXPWSSZXMJXMSZWSJXRWTWSXMVAXQYCXMWNWHVBTWRYDWSXMWRXMWPWQSZNZCDPWRSYFXLCDW
      ODGZYEXKWPYEWOWIVFVCKZYGXKWOWHVDYGWOWKOYHXKLWODVEWOWIWKVGMVHVIVJWPWQCDVKV
      LVMTVPVNYBXSXQNZXMJXTYAYIXMWNWKWHVOTXSXQXMVQWEVRVSVTWAWTBAEEWBWCWD $.

    $( A T_1 space is a T_0 space.  (Contributed by Jeff Hankins,
       1-Feb-2010.) $)
    t1t0 $p |- ( J e. Fre -> J e. Kol2 ) $=
      ( vx vo vy cuni ctopon cfv wcel ct1 ct0 ctop t1top eqid toptopon sylib wi
      wel wral weq ralimi wb bi1 imim1i a1i ist1-2 ist0-2 3imtr4d mpcom ) AAEZF
      GHZAIHZAJHZUKAKHUJALAUIUIMNOUJBCQZDCQZPZCARZBDSZPZDUIRZBUIRZUMUNUAZCARZUQ
      PZDUIRZBUIRZUKULUTVEPUJUSVDBUIURVCDUIVBUPUQVAUOCAUMUNUBTUCTTUDBDCAUIUEBDC
      AUIUFUGUH $.

    $( A space is T_1 iff every point is the only point in the intersection of
       all open sets containing that point.  (Contributed by Jeff Hankins,
       31-Jan-2010.)  (Proof shortened by Mario Carneiro, 24-Aug-2015.) $)
    ist1-3 $p |- ( J e. ( TopOn ` X ) -> ( J e. Fre <->
      A. x e. X |^| { o e. J | x e. o } = { x } ) ) $=
      ( vy ctopon cfv wcel ct1 wel wi wral cv wceq wa wss ralbidva vex elintrab
      bitri crab cint csn ist1-2 toponmax eleq2 intminss sylan sselda biimt syl
      wb rgenw mpbir snssi ax-mp eqss mpbiran2 dfss3 elsn equcom imbi12i ralbii
      id ralcom3 bitr3i 3bitr4g bitr4d ) CDFGHZCIHABJZEBJKBCLZAMZEMZNZKZEDLZADL
      VJBCUAUBZVLUCZNZADLAEBCDUDVIVSVPADVIVLDHZOZVMVRHZEVQLZVMDHZWBKZEVQLZVSVPW
      AWBWEEVQWAVMVQHZOWDWBWEULWAVQDVMVIDCHVTVQDPDCUEVJVTBDCBMDVLUFUGUHUIWDWBUJ
      UKQVSVQVRPZWCVSWHVRVQPZVLVQHZWIWJVJVJKZBCLWKBCVJVDUMVJBVLCARSUNVLVQUOUPVQ
      VRUQUREVQVRUSTVPWGWBKZEDLWFWLVOEDWGVKWBVNVJBVMCERSWBVMVLNVNEVLUTEAVATVBVC
      WBEDVQVEVFVGQVH $.

    $( The preimage of a T_1 topology under an injective map is T_1.
       (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    cnt1 $p |- ( ( K e. Fre /\ F : X -1-1-> Y /\ F e. ( J Cn K ) ) ->
        J e. Fre ) $=
      ( ct1 wcel wf1 ccn csn ccld cfv cuni 3ad2ant3 cima wceq eqid syl syl2anc
      vx co w3a ctop cv wral cntop1 wa ccnv wfn wf cnf ffn fnsnfv sylan imaeq2d
      wss simpl2 f1dm 3ad2ant2 eqtr3d eleq2d biimpa snssd f1imacnv eqtrd simpl3
      cdm fdm simpl1 ffvelrnda t1sncld cnclima eqeltrrd ralrimiva ist1 sylanbrc
      ) CFGZDEAHZABCIUAGZUBZBUCGZTUDZJZBKLZGZTBMZUEBFGVSVQWAVRABCUFNVTWETWFVTWB
      WFGZUGZAUHZWBALZJZOZWCWDWHWLWIAWCOZOZWCWHWKWMWIVTAWFUIZWGWKWMPVTWFCMZAUJZ
      WOVSVQWQVRABCWFWPWFQZWPQZUKNZWFWPAULRWFWBAUMUNUOWHVRWCDUPWNWCPVQVRVSWGUQW
      HWBDVTWGWBDGVTWFDWBVTAVGZWFDVTWQXAWFPWTWFWPAVHRVRVQXADPVSDEAURUSUTVAVBVCD
      EWCAVDSVEWHVSWKCKLGZWLWDGVQVRVSWGVFWHVQWJWPGXBVQVRVSWGVIVTWFWPWBAWTVJWJCW
      PWSVKSWKABCVLSVMVNBWFTWRVOVP $.

    $( Express the predicate " ` J ` is a Hausdorff space."  (Contributed by
       NM, 8-Mar-2007.) $)
    ishaus2 $p |- ( J e. ( TopOn ` X ) -> ( J e. Haus <-> A. x e. X A. y e. X
      ( x =/= y -> E. n e. J E. m e. J ( x e. n /\ y e. m /\
                   ( n i^i m ) = (/) ) ) ) ) $=
      ( ctopon cfv wcel cha cv wne wel cin c0 wceq w3a wrex wi wral wb topontop
      cuni ctop eqid ishaus baib syl toponuni raleqdv raleqbidv bitr4d ) EFGHIZ
      EJIZAKBKLADMBCMDKCKNOPQCERDERSZBEUCZTZAUPTZUOBFTZAFTUMEUDIZUNURUAFEUBUNUT
      URABCDEUPUPUEUFUGUHUMUSUQAFUPFEUIZUMUOBFUPVAUJUKUL $.

    $( A Hausdorff space is a T_1 space.  (Contributed by FL, 11-Jun-2007.)
       (Proof shortened by Mario Carneiro, 24-Aug-2015.) $)
    haust1 $p |- ( J e. Haus -> J e. Fre ) $=
      ( vx vz vy vw cha wcel ct1 wel wi wral cv wceq wa wn w3a wrex syl sylib
      c0 cuni wne cin hausnei simprr1 simprr3 eleq2d mtbiri simprr2 simplbi2com
      eqid noel elin mtod jca rexlimdvaa reximdva rexanali 3exp2 imp32 necon4ad
      mpd ralrimivva ctopon cfv wb ctop haustop toptopon ist1-2 mpbird ) AFGZAH
      GZBCIZDCIZJCAKZBLZDLZMJZDAUAZKBVTKZVLVSBDVTVTVLVQVTGZVRVTGZNNVPVQVRVLWBWC
      VQVRUBZVPOZJVLWBWCWDWEVLWBWCWDPNZVNVOOZNZCAQZWEWFVNDEIZCLZELZUCZTMZPZEAQZ
      CAQWIVQVRECAVTVTUKZUDWFWPWHCAWFWKAGNZWOWHEAWRWLAGZWONNZVNWGVNWJWNWSWRUEWT
      VOVRWMGZWTXAVRTGVRULWTWMTVRVNWJWNWSWRUFUGUHWTWJVOXAJVNWJWNWSWRUIXAVOWJVRW
      KWLUMUJRUNUOUPUQVBVNVOCAURSUSUTVAVCVLAVTVDVEGZVMWAVFVLAVGGXBAVHAVTWQVISBD
      CAVTVJRVK $.

    $( The Hausdorff condition still holds if one considers general
       neighborhoods instead of open sets.  (Contributed by Jeff Hankins,
       5-Sep-2009.) $)
    hausnei2 $p |- ( J e. ( TopOn ` X ) -> ( J e. Haus <->
                     A. x e. X A. y e. X ( x =/= y ->
               E. u e. ( ( nei ` J ) ` { x } ) E. v e. ( ( nei ` J ) ` { y } )
                  ( u i^i v ) = (/) ) ) ) $=
      ( vm vn cfv wcel cv c0 wceq w3a wrex wi wral wa ex wss ctopon cha wne cin
      csn cnei ishaus2 ctop wb topontop simp1 adantr simp2 adantl opnneip simp3
      syl3anc ineq1 eqeq1d ineq2 rspc2ev 3expib rexlimdvv neii2 vex snss anbi1i
      simp1l simp2l ss2in ssn0 necon4d syl ad2ant2l 3jca 3exp syl5bir com3r imp
      3impia 3adant1 reximdv com34 3imp com24 imp3a syl2and impbid imbi2d bitrd
      2ralbidv ) EFUAIJZEUBJAKZBKZUCZWMGKZJZWNHKZJZWPWRUDZLMZNZHEOZGEOZPZBFQAFQ
      ZWODKZCKZUDZLMZCWNUEZEUFIZIZODWMUEZXLIZOZPZBFQAFQZABHGEFUGWLEUHJZXFXRUIFE
      UJXSXEXQABFFXSXDXPWOXSXDXPXSXBXPGHEEXSWPEJZWREJZXBXPPXSXTYANZXBXPYBXBRZWP
      XOJZWRXMJZXAXPYCXSXTWQYDYBXSXBXSXTYAUKULZYBXTXBXSXTYAUMULXBWQYBWQWSXAUKUN
      WMEWPUOUQYCXSYAWSYEYFYBYAXBXSXTYAUPULXBWSYBWQWSXAUMUNWNEWRUOUQXBXAYBWQWSX
      AUPUNXJXAWPXHUDZLMDCWPWRXOXMXGWPMXIYGLXGWPXHURUSXHWRMYGWTLXHWRWPUTUSVAUQS
      VBVCXSXJXDDCXOXMXSXGXOJZXNWPTZWPXGTZRZGEOZXHXMJZXKWRTZWRXHTZRZHEOZXJXDPZX
      SYHYLXNGEXGVDSXSYMYQXKHEXHVDSXSYLYQYRXSXJYQYLXDXSXJYQYLXDPXSXJYQNZYKXCGEY
      KWQYJRZYSXCWQYIYJWMWPAVEVFVGXSXJYQYTXCPXSXJYTYQXCXSXJYTYQXCPXSXJYTNYPXBHE
      XJYTYPXBPZXSXJYTUUAYTYPXJXBYPWSYORZYTXJXBPWSYNYOWNWRBVEVFVGYTUUBXJXBYTUUB
      XJNWQWSXAWQYJUUBXJVHYTWSYOXJVIYTUUBXJXAYJYOXJXAPZWQWSYJYORWTXITZUUCWPXGWR
      XHVJUUDWTLXILUUDWTLUCXILUCWTXIVKSVLVMVNVTVOVPVQVRVSWAWBVPWCWDVQWBVPWEWFWG
      VCWHWIWKVMWJ $.

    $( The preimage of a Hausdorff topology under an injective map is
       Hausdorff.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    cnhaus $p |- ( ( K e. Haus /\ F : X -1-1-> Y /\ F e. ( J Cn K ) ) ->
        J e. Haus ) $=
      ( vx vy vm vn vu vv wcel w3a cv cin c0 wceq wrex wa syl cha wf1 ccn co wi
      ctop wne cuni wral cntop1 3ad2ant3 cfv simpl1 wf simpl3 eqid cnf ffvelrnd
      simprll simprlr simprr simpl2 cdm fdm f1dm eqtr3d eleqtrd f1fveq syl12anc
      necon3bid mpbird hausnei syl13anc ccnv cima simpll3 cnima syl2anc simprr1
      adantr wfn ffn elpreima mpbir2and simprr2 wfun ffun inpreima 3syl simprr3
      wb imaeq2d ima0 syl6eq eleq2 ineq1 eqeq1d 3anbi13d ineq2 3anbi23d rspc2ev
      syl113anc expr rexlimdvva mpd ralrimivva ishaus sylanbrc ) CUALZDEAUBZABC
      UCUDLZMZBUFLZFNZGNZUGZXNHNZLZXOINZLZXQXSOZPQZMZIBRHBRZUEZGBUHZUIFYFUIBUAL
      XKXIXMXJABCUJUKXLYEFGYFYFXLXNYFLZXOYFLZSZXPYDXLYIXPSZSZXNAULZJNZLZXOAULZK
      NZLZYMYPOZPQZMZKCRJCRZYDYKXIYLCUHZLYOUUBLYLYOUGZUUAXIXJXKYJUMYKYFUUBXNAYK
      XKYFUUBAUNZXIXJXKYJUOABCYFUUBYFUPZUUBUPZUQTZXLYGYHXPUSZURYKYFUUBXOAUUGXLY
      GYHXPUTZURYKUUCXPXLYIXPVAYKYLYOXNXOYKXJXNDLXODLYLYOQXNXOQWKXIXJXKYJVBZYKX
      NYFDUUHYKAVCZYFDYKUUDUUKYFQUUGYFUUBAVDTYKXJUUKDQUUJDEAVETVFZVGYKXOYFDUUIU
      ULVGDEXNXOAVHVIVJVKYLYOKJCUUBUUFVLVMYKYTYDJKCCYKYMCLZYPCLZSZYTYDYKUUOYTSZ
      SZAVNZYMVOZBLZUURYPVOZBLZXNUUSLZXOUVALZUUSUVAOZPQZYDUUQXKUUMUUTXIXJXKYJUU
      PVPZYKUUMUUNYTUSYMABCVQVRUUQXKUUNUVBUVGYKUUMUUNYTUTYPABCVQVRUUQUVCYGYNYKY
      GUUPUUHVTYNYQYSUUOYKVSUUQAYFWAZUVCYGYNSWKUUQUUDUVHYKUUDUUPUUGVTZYFUUBAWBT
      ZYFXNYMAWCTWDUUQUVDYHYQYKYHUUPUUIVTYNYQYSUUOYKWEUUQUVHUVDYHYQSWKUVJYFXOYP
      AWCTWDUUQUURYRVOZUVEPUUQUUDAWFUVKUVEQUVIYFUUBAWGYMYPAWHWIUUQUVKUURPVOPUUQ
      YRPUURYNYQYSUUOYKWJWLUURWMWNVFYCUVCUVDUVFMUVCXTUUSXSOZPQZMHIUUSUVABBXQUUS
      QZXRUVCYBUVMXTXQUUSXNWOUVNYAUVLPXQUUSXSWPWQWRXSUVAQZXTUVDUVMUVFUVCXSUVAXO
      WOUVOUVLUVEPXSUVAUUSWSWQWTXAXBXCXDXEXCXFFGIHBYFUUEXGXH $.

    $( In a normal space, given a closed set ` B ` inside an open set ` A ` ,
       there is an open set ` x ` such that ` B C_ x C_ cls ( x ) C_ A ` .
       (Contributed by Mario Carneiro, 24-Aug-2015.) $)
    nrmsep3 $p |- ( ( J e. Nrm /\ ( A e. J /\ B e. ( Clsd ` J ) /\ B C_ A ) )
      -> E. x e. J ( B C_ x /\ ( ( cls ` J ) ` x ) C_ A ) ) $=
      ( vz vy cnrm wcel cfv wss cv wa wrex cpw cin wral wi wceq rexbidv rspccv
      ccld ccl ctop isnrm simprbi pweq ineq2d sseq2 anbi2d raleqbidv elin elpwg
      syl pm5.32i bitri sseq1 anbi1d syl5bir syl6 exp4a 3imp2 ) DGHZBDHZCDUAIZH
      ZCBJZCAKZJZVGDUBIIZBJZLZADMZVBVCVEVFVLVBVCEKZVGJZVJLZADMZEVDBNZOZPZVEVFLZ
      VLQVBVNVIFKZJZLZADMZEVDWANZOZPZFDPZVCVSQVBDUCHWHFEADUDUEWGVSFBDWABRZWDVPE
      WFVRWIWEVQVDWABUFUGWIWCVOADWIWBVJVNWABVIUHUISUJTUMVTCVRHZVSVLWJVECVQHZLVT
      CVDVQUKVEWKVFCBVDULUNUOVPVLECVRVMCRZVOVKADWLVNVHVJVMCVGUPUQSTURUSUTVA $.

    $( In a normal space, any two disjoint closed sets have the property that
       each one is a subset of an open set whose closure is disjoint from the
       other.  (Contributed by Jeff Hankins, 1-Feb-2010.)  (Revised by Mario
       Carneiro, 24-Aug-2015.) $)
    nrmsep2 $p |- ( ( J e. Nrm /\ ( C e. ( Clsd ` J ) /\ D e. ( Clsd ` J ) /\
      ( C i^i D ) = (/) ) ) -> E. x e. J ( C C_ x /\
        ( ( ( cls ` J ) ` x ) i^i D ) = (/) ) ) $=
      ( cnrm wcel ccld cfv cin c0 wceq w3a wa cv wss ccl cuni cdif wrex syl wb
      simpl simpr2 eqid cldopn simpr1 cldss reldisj 3syl mpbid nrmsep3 syl13anc
      simpr3 ssdifin0 anim2i reximi ) DEFZBDGHZFZCURFZBCIJKZLZMZBANZOZVDDPHHZDQ
      ZCRZOZMZADSZVEVFCIJKZMZADSVCUQVHDFZUSBVHOZVKUQVBUBVCUTVNUQUSUTVAUCCDVGVGU
      DZUETUQUSUTVAUFZVCVAVOUQUSUTVAUMVCUSBVGOVAVOUAVQBDVGVPUGBCVGUHUIUJAVHBDUK
      ULVJVMADVIVLVEVFVGCUNUOUPT $.

    $( In a normal space, disjoint closed sets are separated by open sets.
       (Contributed by Jeff Hankins, 1-Feb-2010.) $)
    nrmsep $p |- ( ( J e. Nrm /\ ( C e. ( Clsd ` J ) /\ D e. ( Clsd ` J ) /\
        ( C i^i D ) = (/) ) ) -> E. x e. J E. y e. J
      ( C C_ x /\ D C_ y /\ ( x i^i y ) = (/) ) ) $=
      ( cnrm wcel ccld cfv cin c0 wceq w3a wa cv wss ccl wrex syl2anc syl incom
      nrmsep2 cuni cdif ctop nrmtop ad2antrr elssuni eqid clscld cldopn simprrl
      ad2antrl simprrr syl5eq wb simplr2 cldss reldisj 3syl mpbid sscls disjdif
      ssrin sseq0 sseq2 ineq2 eqeq1d 3anbi23d rspcev syl13anc expr reximdva mpd
      sylancl ) EFGZCEHIZGZDVQGZCDJKLZMZNZCAOZPZWCEQIIZDJZKLZNZAERWDDBOZPZWCWIJ
      ZKLZMZBERZAERACDEUBWBWHWNAEWBWCEGZWHWNWBWOWHNZNZEUCZWEUDZEGZWDDWSPZWCWSJZ
      KLZWNWQWEVQGZWTWQEUEGZWCWRPZXDVPXEWAWPEUFUGZWOXFWBWHWCEUHUMZWCEWRWRUIZUJS
      WEEWRXIUKTWBWOWDWGULWQDWEJZKLZXAWQXJWFKDWEUAWBWOWDWGUNUOWQVSDWRPXKXAUPVRV
      SVTVPWPUQDEWRXIURDWEWRUSUTVAWQXBWEWSJZPZXLKLXCWQWCWEPZXMWQXEXFXNXGXHWCEWR
      XIVBSWCWEWSVDTWEWRVCXBXLVEVOWMWDXAXCMBWSEWIWSLZWJXAWLXCWDWIWSDVFXOWKXBKWI
      WSWCVGVHVIVJVKVLVMVN $.

    $( An alternate characterization of normality.  This is the important
       property in the proof of Urysohn's lemma.  (Contributed by Jeff Hankins,
       1-Feb-2010.)  (Proof shortened by Mario Carneiro, 24-Aug-2015.) $)
    isnrm2 $p |- ( J e. Nrm <-> ( J e. Top /\
      A. c e. ( Clsd ` J ) A. d e. ( Clsd ` J ) ( ( c i^i d ) = (/) ->
        E. o e. J ( c C_ o /\ ( ( ( cls ` J ) ` o ) i^i d ) = (/) ) ) ) ) $=
      ( vx wcel cv cin c0 wceq wss cfv wa wrex wral ineq2 eqeq1d anbi2d imbi12d
      wi cnrm ctop ccl ccld nrmtop nrmsep2 3exp2 imp3a ralrimivv jca simpl cuni
      cpw cdif eqid opncld adantr rexbidv rspcv syl inssdif0 cldss adantl df-ss
      sseq1d syl5bbr simpll elssuni clsss3 syl2an rexbidva sylibd ralimdva elin
      sylib vex elpw anbi2i bitri imbi1i impexp ralbii2 syl6ibr ralrimdva isnrm
      imp sylanbrc impbii ) BUAFZBUBFZCGZDGZHZIJZWKAGZKZWOBUCLLZWLHZIJZMZABNZTZ
      DBUDLZOZCXCOZMZWIWJXEBUEWIXBCDXCXCWIWKXCFZWLXCFZXBWIXGXHWNXAAWKWLBUFUGUHU
      IUJXFWJWPWQEGZKZMZABNZCXCXIUMZHZOZEBOZWIWJXEUKWJXEXPWJXEXOEBWJXIBFZMZXEWK
      XIKZXLTZCXCOXOXRXDXTCXCXRXGMZXDWKBULZXIUNZHZIJZWPWQYCHZIJZMZABNZTZXTYAYCX
      CFZXDYJTXRYKXGXIBYBYBUOZUPUQXBYJDYCXCWLYCJZWNYEXAYIYMWMYDIWLYCWKPQYMWTYHA
      BYMWSYGWPYMWRYFIWLYCWQPQRURSUSUTYAYEXSYIXLYEWKYBHZXIKYAXSWKYBXIVAYAYNWKXI
      YAWKYBKZYNWKJXGYOXRWKBYBYLVBVCWKYBVDVOVEVFYAYHXKABYAWOBFZMZYGXJWPYGWQYBHZ
      XIKYQXJWQYBXIVAYQYRWQXIYQWQYBKZYRWQJYAWJWOYBKYSYPWJXQXGVGWOBVHWOBYBYLVIVJ
      WQYBVDVOVEVFRVKSVLVMXLXTCXNXCWKXNFZXLTXGXSMZXLTXGXTTYTUUAXLYTXGWKXMFZMUUA
      WKXCXMVNUUBXSXGWKXICVPVQVRVSVTXGXSXLWAVSWBWCWDWFECABWEWGWH $.

    $( A topological space is normal iff any two disjoint closed sets are
       separated by open sets.  (Contributed by Mario Carneiro,
       24-Aug-2015.) $)
    isnrm3 $p |- ( J e. Nrm <-> ( J e. Top /\ A. c e. ( Clsd ` J ) A. d e. (
    Clsd ` J ) ( ( c i^i d ) = (/) -> E. x e. J E. y e. J ( c C_ x /\ d C_ y /\
    ( x i^i y ) = (/) ) ) ) ) $=
      ( wcel cv cin c0 wceq wss wrex wi cfv wral wa jca syl syl2anc ralimdv w3a
      cnrm ctop ccld nrmtop nrmsep 3exp2 imp3a ralrimivv ccl simpl simpr1 sslin
      simpr2 cuni cdif simplll simplr eqid opncld simpllr elssuni reldisj mpbid
      simpr3 wb 3syl clsss2 ssdifin0 sseq0 rexlimdva reximdva imim2d imp isnrm2
      ex sylanbrc impbii ) CUBFZCUCFZDGZEGZHIJZWAAGZKZWBBGZKZWDWFHIJZUAZBCLZACL
      ZMZECUDNZOZDWMOZPZVSVTWOCUEVSWLDEWMWMVSWAWMFZWBWMFZWLVSWQWRWCWKABWAWBCUFU
      GUHUIQWPVTWCWEWDCUJNNZWBHZIJZPZACLZMZEWMOZDWMOZVSVTWOUKVTWOXFVTWNXEDWMVTW
      LXDEWMVTWKXCWCVTWJXBACVTWDCFZPZWIXBBCXHWFCFZPZWIXBXJWIPZWEXAXJWEWGWHULXKW
      TWSWFHZKZXLIJZXAXKWGXMXJWEWGWHUNWBWFWSUMRXKCUOZWFUPZWMFZWDXPKZXNXKVTXIXQV
      TXGXIWIUQXHXIWIURWFCXOXOUSZUTSXKWHXRXJWEWGWHVEXKXGWDXOKWHXRVFVTXGXIWIVAWD
      CVBWDWFXOVCVGVDXQXRPWSXPKXNXPWDCXOXSVHWSXOWFVIRSWTXLVJSQVPVKVLVMTTVNACDEV
      OVQVR $.

    $( A subspace of a completely normal space is normal.  (Contributed by
       Mario Carneiro, 26-Aug-2015.) $)
    cnrmi $p |- ( ( J e. CNrm /\ A e. V ) -> ( J |`t A ) e. Nrm ) $=
      ( vx ccnrm wcel wa crest co cuni cin cnrm eqid restin cpw cv wral wss cvv
      inss2 wb inex1g elpwg mpbiri adantl ctop iscnrm simprbi adantr wceq oveq2
      syl eleq1d rspcv sylc eqeltrd ) BEFZACFZGZBAHIBABJZKZHIZLABECUTUTMZNUSVAU
      TOZFZBDPZHIZLFZDVDQZVBLFZURVEUQURVEVAUTRZAUTTURVASFVEVKUAAUTCUBVAUTSUCULU
      DUEUQVIURUQBUFFVIDBUTVCUGUHUIVHVJDVAVDVFVAUJVGVBLVFVABHUKUMUNUOUP $.

    $( A completely normal space is normal.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    cnrmnrm $p |- ( J e. CNrm -> J e. Nrm ) $=
      ( ccnrm wcel cuni crest cnrm eqid restid cvv uniexg cnrmi mpdan eqeltrrd
      co ) ABCZAADZENZAFABPPGHOPICQFCABJPAIKLM $.

    $( A subspace of a completely normal space is completely normal.
       (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    restcnrm $p |- ( ( J e. CNrm /\ A e. V ) -> ( J |`t A ) e. CNrm ) $=
      ( vx ccnrm wcel wa crest cuni cin eqid restin cnrm wss cvv eqeltrd ctopon
      co cv cfv cpw wral wceq simpll elpwi adantl inex1g ad2antlr restabs cnrmi
      syl3anc adantlr ralrimiva wb ctop cnrmtop adantr toptopon sylib resttopon
      inss2 sylancl iscnrm2 syl mpbird ) BEFZACFZGZBAHRBABIZJZHRZEABECVIVIKZLVH
      VKEFZVKDSZHRZMFZDVJUAZUBZVHVPDVQVHVNVQFZGZVOBVNHRZMVTVFVNVJNZVJOFZVOWAUCV
      FVGVSUDVSWBVHVNVJUEUFVGWCVFVSAVICUGUHVNVJBEOUIUKVFVSWAMFVGVNBVQUJULPUMVHV
      KVJQTFZVMVRUNVHBVIQTFZVJVINWDVHBUOFZWEVFWFVGBUPUQBVIVLURUSAVIVAVJBVIUTVBD
      VKVJVCVDVEP $.
  $}

  ${
    resthauslem.1 $e |- ( J e. A -> J e. Top ) $.
    resthauslem.2 $e |- ( ( J e. A /\
      ( _I |` ( S i^i U. J ) ) : ( S i^i U. J ) -1-1-> ( S i^i U. J ) /\
    ( _I |` ( S i^i U. J ) ) e. ( ( J |`t S ) Cn J ) ) -> ( J |`t S ) e. A ) $.
    $( Lemma for ~ resthaus and similar theorems.  If the topological property
       ` A ` is preserved under injective preimages, then property ` A ` passes
       to subspaces.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    resthauslem $p |- ( ( J e. A /\ S e. V ) -> ( J |`t S ) e. A ) $=
      ( wcel wa cuni cin cid cres wf1 crest co ccn simpl wf1o f1oi f1of1 ctopon
      mp1i wss wceq inss2 resabs1 ax-mp cfv ctop adantr eqid toptopon sylib syl
      idcn cnrest sylancl syl5eqelr restin oveq1d eleqtrrd syl3anc ) CAGZBDGZHZ
      VCBCIZJZVGKVGLZMZVHCBNOZCPOZGVJAGVCVDQVGVGVHRVIVEVGSVGVGVHTUBVEVHCVGNOZCP
      OZVKVEVHKVFLZVGLZVMVGVFUCZVOVHUDBVFUEZKVGVFUFUGVEVNCCPOGZVPVOVMGVECVFUAUH
      GZVRVECUIGZVSVCVTVDEUJCVFVFUKZULUMCVFUOUNVQVGVNCCVFWAUPUQURVEVJVLCPBCADVF
      WAUSUTVAFVB $.
  $}

  ${
    $d x J $.  $d x S $.  $d x X $.
    lpcls.1 $e |- X = U. J $.
    $( The limit points of the closure of a subset are the same as the limit
       points of the set in a T_1 space.  (Contributed by Mario Carneiro,
       26-Dec-2016.) $)
    lpcls $p |- ( ( J e. Fre /\ S C_ X ) ->
      ( ( limPt ` J ) ` ( ( cls ` J ) ` S ) ) = ( ( limPt ` J ) ` S ) ) $=
      ( vx wcel wss cfv cdif clsss3 ssdifssd syldan sylan syl2an adantr syl2anc
      wa sseld sscls ssundif ct1 ccl clp csn ctop t1top ccld ssdifss clscld cun
      cv wi t1sncld adantlr uncld sylibr clsss2 sylib com23 mpdd ssdifd syl3anc
      ex clsss impbid wb islp 3bitr4d eqrdv ) BUAFZACGZQZEABUBHZHZBUCHZHZAVOHZV
      LEUKZVNVRUDZIZVMHZFZVRAVSIZVMHZFZVRVPFZVRVQFZVLWBWEVLWBVRCFZWEVLWACVRVJBU
      EFZVKWACGZBUFZWIVKVTCGZWJWIVKQVNCVSABCDJZKVTBCDJLMRVLWHWBWEVLWHWBWEULVLWH
      QZWAWDVRWNWDBUGHZFZVTWDGZWAWDGVLWPWHVJWIWCCGZWPVKWKACVSUHZWCBCDUINOZWNVNV
      SWDUJZGZWQWNXAWOFZAXAGZXBWNVSWOFZWPXCVJWHXEVKVRBCDUMUNWTVSWDBUOPVLXDWHVLW
      CWDGZXDVJWIWRXFVKWKWSWCBCDSNAVSWDTUPOXAABCDUQPVNVSWDTURWDVTBCDUQPRVCUSUTV
      LWDWAVRVLWIWLWCVTGWDWAGVJWIVKWKOVLVNCVSVJWIVKVNCGZWKWMMKVLAVNVSVJWIVKAVNG
      WKABCDSMVAVTWCBCDVDVBRVEVJWIVKWFWBVFZWKWIVKXGXHWMVRVNBCDVGLMVJWIVKWGWEVFW
      KVRABCDVGMVHVI $.

    $( A subset of a perfect space is perfect iff its closure is perfect (and
       the closure is an actual perfect set, since it is both closed and
       perfect in the subspace topology).  (Contributed by Mario Carneiro,
       26-Dec-2016.) $)
    perfcls $p |- ( ( J e. Fre /\ S C_ X ) ->
      ( ( J |`t S ) e. Perf <-> ( J |`t ( ( cls ` J ) ` S ) ) e. Perf ) ) $=
      ( ct1 wcel wss wa clp cfv ccl crest co cperf lpcls wceq sylan wb restperf
      eqid sseq2d cun ctop t1top clslp sseq1d ssequn1 ssun2 eqss mpbiran2 bitri
      syl6bbr bitr2d clsss3 syldan 3bitr4d ) BEFZACGZHZAABIJZJZGZABKJJZVCUTJZGZ
      BALMZNFZBVCLMZNFZUSVEVCVAGZVBUSVDVAVCABCDOUAUSVJAVAUBZVAGZVBUSVCVKVAUQBUC
      FZURVCVKPBUDZABCDUEQUFVBVKVAPZVLAVAUGVOVLVAVKGVAAUHVKVAUIUJUKULUMUQVMURVG
      VBRVNBVFCADVFTSQUQVMURVIVERZVNVMURVCCGVPABCDUNBVHCVCDVHTSUOQUP $.
  $}

  $( A subspace of a T_0 topology is T_0.  (Contributed by Mario Carneiro,
     25-Aug-2015.) $)
  restt0 $p |- ( ( J e. Kol2 /\ A e. V ) -> ( J |`t A ) e. Kol2 ) $=
    ( ct0 t0top cid cuni cin cres crest co cnt0 resthauslem ) DABCBEFABGHZIBAJK
    BNNLM $.

  $( A subspace of a T_1 topology is T_1.  (Contributed by Mario Carneiro,
     25-Aug-2015.) $)
  restt1 $p |- ( ( J e. Fre /\ A e. V ) -> ( J |`t A ) e. Fre ) $=
    ( ct1 t1top cid cuni cin cres crest co cnt1 resthauslem ) DABCBEFABGHZIBAJK
    BNNLM $.

  $( A subspace of a Hausdorff topology is Hausdorff.  (Contributed by Mario
     Carneiro, 2-Mar-2015.)  (Proof shortened by Mario Carneiro,
     25-Aug-2015.) $)
  resthaus $p |- ( ( J e. Haus /\ A e. V ) -> ( J |`t A ) e. Haus ) $=
    ( cha haustop cid cuni cin cres crest co cnhaus resthauslem ) DABCBEFABGHZI
    BAJKBNNLM $.

  ${
    $d o x y A $.  $d o y B $.  $d x y C $.  $d o x y J $.  $d o x y X $.
    t1sep.1 $e |- X = U. J $.
    $( Any two points in a T_1 space which have no separation are equal.
       (Contributed by Jeff Hankins, 1-Feb-2010.) $)
    t1sep2 $p |- ( ( J e. Fre /\ A e. X /\ B e. X ) ->
      ( A. o e. J ( A e. o -> B e. o ) -> A = B ) ) $=
      ( vx vy ct1 wcel cv wi wral wceq wa ctopon cfv eleq1 ralbidv imbi12d ctop
      wb t1top toptopon sylib ist1-2 syl imbi1d eqeq1 imbi2d eqeq2 rspc2v mpan9
      ibi 3impb ) DIJZAEJZBEJZACKZJZBUSJZLZCDMZABNZLZUPGKZUSJZHKZUSJZLZCDMZVFVH
      NZLZHEMGEMZUQUROVEUPVNUPDEPQJZUPVNUBUPDUAJVODUCDEFUDUEGHCDEUFUGUNVMVEUTVI
      LZCDMZAVHNZLGHABEEVFANZVKVQVLVRVSVJVPCDVSVGUTVIVFAUSRUHSVFAVHUITVHBNZVQVC
      VRVDVTVPVBCDVTVIVAUTVHBUSRUJSVHBAUKTULUMUO $.

    $( Any two distinct points in a T_1 space are separated by an open set.
       (Contributed by Jeff Hankins, 1-Feb-2010.) $)
    t1sep $p |- ( ( J e. Fre /\ ( A e. X /\ B e. X /\ A =/= B ) ) ->
      E. o e. J ( A e. o /\ -. B e. o ) ) $=
      ( ct1 wcel wne w3a wa cv wi wral wn wrex simpr3 wceq t1sep2 3adant3r3 mpd
      necon3ad rexanali sylibr ) DGHZAEHZBEHZABIZJKZACLZHZBUJHZMCDNZOZUKULOKCDP
      UIUHUNUEUFUGUHQUIUMABUEUFUGUMABRMUHABCDEFSTUBUAUKULCDUCUD $.

    $( A singleton is closed in a Hausdorff space.  (Contributed by NM,
       5-Mar-2007.)  (Revised by Mario Carneiro, 24-Aug-2015.) $)
    sncld $p |- ( ( J e. Haus /\ P e. X ) -> { P } e. ( Clsd ` J ) ) $=
      ( cha wcel ct1 csn ccld cfv haust1 t1sncld sylan ) BEFBGFACFAHBIJFBKABCDL
      M $.

    ${
      sshauslem.2 $e |- ( J e. A -> J e. Top ) $.
      sshauslem.3 $e |- ( ( J e. A /\
        ( _I |` X ) : X -1-1-> X /\ ( _I |` X ) e. ( K Cn J ) ) -> K e. A ) $.
      $( Lemma for ~ sshaus and similar theorems.  If the topological property
         ` A ` is preserved under injective preimages, then a topology finer
         than one with property ` A ` also has property ` A ` .  (Contributed
         by Mario Carneiro, 25-Aug-2015.) $)
      sshauslem $p |- ( ( J e. A /\ K e. ( TopOn ` X ) /\ J C_ K ) ->
        K e. A ) $=
        ( wcel ctopon cfv wss w3a cid cres wf1 ccn co simp1 wf1o f1oi mp1i ctop
        f1of1 simp3 simp2 3ad2ant1 toptopon sylib ssidcn syl2anc mpbird syl3anc
        wb ) BAHZCDIJZHZBCKZLZUNDDMDNZOZUSCBPQHZCAHUNUPUQRDDUSSUTURDTDDUSUCUAUR
        VAUQUNUPUQUDURUPBUOHZVAUQUMUNUPUQUEURBUBHZVBUNUPVCUQFUFBDEUGUHCBDUIUJUK
        GUL $.
    $}

    $( A topology finer than a T_0 topology is T_0.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    sst0 $p |- ( ( J e. Kol2 /\ K e. ( TopOn ` X ) /\ J C_ K ) ->
      K e. Kol2 ) $=
      ( ct0 t0top cid cres cnt0 sshauslem ) EABCDAFGCHBACCIJ $.

    $( A topology finer than a T_1 topology is T_1.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    sst1 $p |- ( ( J e. Fre /\ K e. ( TopOn ` X ) /\ J C_ K ) ->
      K e. Fre ) $=
      ( ct1 t1top cid cres cnt1 sshauslem ) EABCDAFGCHBACCIJ $.

    $( A topology finer than a Hausdorff topology is Hausdorff.  (Contributed
       by Mario Carneiro, 2-Mar-2015.) $)
    sshaus $p |- ( ( J e. Haus /\ K e. ( TopOn ` X ) /\ J C_ K ) ->
      K e. Haus ) $=
      ( cha haustop cid cres cnhaus sshauslem ) EABCDAFGCHBACCIJ $.

    $( In a regular space, a closed set is separated by open sets from a point
       not in it.  (Contributed by Jeff Hankins, 1-Feb-2010.)  (Revised by
       Mario Carneiro, 25-Aug-2015.) $)
    regsep2 $p |- ( ( J e. Reg /\
      ( C e. ( Clsd ` J ) /\ A e. X /\ -. A e. C ) ) ->
        E. x e. J E. y e. J ( C C_ x /\ A e. y /\ ( x i^i y ) = (/) ) ) $=
      ( wcel cfv w3a wa cv wss cin c0 wceq wrex cdif syl syl2anc creg ccl simpl
      ccld wn simpr1 cldopn simpr2 simpr3 eldifd regsep syl3anc regtop ad2antrr
      ctop cuni elssuni syl6sseqr ad2antrl clscld simprrr clsss3 simplr1 ssconb
      wb cldss mpbid simprrl sscls sslin incom disjdif eqtri sseq0 sseq2 eqeq1d
      sylancl ineq1 3anbi13d rspcev syl13anc expr reximdva mpd rexcom sylib ) E
      UAHZDEUDIZHZCFHZCDHUEZJZKZDALZMZCBLZHZWNWPNZOPZJZAEQZBEQZWTBEQAEQWMWQWPEU
      BIIZFDRZMZKZBEQZXBWMWGXDEHZCXDHXGWGWLUCWMWIXHWGWIWJWKUFDEFGUGSWMCFDWGWIWJ
      WKUHWGWIWJWKUIUJBCXDEUKULWMXFXABEWMWPEHZXFXAWMXIXFKZKZFXCRZEHZDXLMZWQXLWP
      NZOPZXAXKXCWHHZXMXKEUOHZWPFMZXQWGXRWLXJEUMUNZXIXSWMXFXIWPEUPFWPEUQGURUSZW
      PEFGUTTXCEFGUGSXKXEXNWMXIWQXEVAXKXCFMZDFMZXEXNVEXKXRXSYBXTYAWPEFGVBTXKWIY
      CWIWJWKWGXJVCDEFGVFSXCDFVDTVGWMXIWQXEVHXKXOXLXCNZMZYDOPXPXKWPXCMZYEXKXRXS
      YFXTYAWPEFGVITWPXCXLVJSYDXCXLNOXLXCVKXCFVLVMXOYDVNVQWTXNWQXPJAXLEWNXLPZWO
      XNWSXPWQWNXLDVOYGWRXOOWNXLWPVRVPVSVTWAWBWCWDWTBAEEWEWF $.
  $}

  ${
    $d c o p x y J $.  $d c o p x y X $.
    $( A topological space is regular if any closed set is separated from any
       point not in it by neighborhoods.  (Contributed by Jeff Hankins,
       1-Feb-2010.)  (Revised by Mario Carneiro, 25-Aug-2015.) $)
    isreg2 $p |- ( J e. ( TopOn ` X ) -> ( J e. Reg <-> A. c e. ( Clsd ` J )
      A. x e. X ( -. x e. c -> E. o e. J E. p e. J
        ( c C_ o /\ x e. p /\ ( o i^i p ) = (/) ) ) ) ) $=
      ( vy cfv wcel cv wn wss c0 wceq w3a wrex wi wral wa cdif ctopon creg ccld
      cin cuni simp1r simp2l simp2r simp1l toponuni eleqtrd simp3 eqid syl13anc
      syl regsep2 3expia ralrimivva ctop topontop adantr difeq1d opncld eqeltrd
      ccl sylan eleq2 notbid eldif baibr con1bid sylan9bb simpl sseq1d 2rexbidv
      3anbi1d imbi12d ralbidva ralcom3 toponss sselda simprr2 ad3antrrr simprll
      rspcv syl2anc incom simprr3 syl5eq simplll simprlr reldisj clsss2 simprr1
      mpbid difcom sylib sstrd expr anassrs reximdva rexlimdva embantd ralimdva
      wb jca syl5bi syld ralrimdva imp isreg sylanbrc impbida ) CDUAHIZCUBIZAJZ
      FJZIZKZXQBJZLZXPEJZIZXTYBUDZMNZOZECPBCPZQZADRZFCUCHZRZXNXOSZYHFAYJDYLXQYJ
      IZXPDIZSZXSYGYLYOXSOZXOYMXPCUEZIXSYGXNXOYOXSUFYLYMYNXSUGYPXPDYQYLYMYNXSUH
      YPXNDYQNZXNXOYOXSUIDCUJZUOUKYLYOXSULBEXPXQCYQYQUMZUPUNUQURXNYKSCUSIZYCYBC
      VEHHZGJZLZSZECPZAUUCRZGCRZXOXNUUAYKDCUTZVAXNYKUUHXNYKUUGGCXNUUCCIZSZYKXPU
      UCIZDUUCTZXTLZYCYEOZECPZBCPZQZADRZUUGUUKUUMYJIYKUUSQUUKUUMYQUUCTZYJUUKDYQ
      UUCXNYRUUJYSVAVBXNUUAUUJUUTYJIUUIUUCCYQYTVCVFVDYIUUSFUUMYJXQUUMNZYHUURADU
      VAYNSZXSUULYGUUQUVAXSXPUUMIZKYNUULUVAXRUVCXQUUMXPVGVHYNUULUVCUVCYNUULKXPD
      UUCVIVJVKVLUVBYFUUOBECCUVBYAUUNYCYEUVBXQUUMXTUVAYNVMVNVPVOVQVRWEUOUUSYNUU
      QQZAUUCRUUKUUGUUQADUUCVSUUKUVDUUFAUUCUUKUULSZYNUUQUUFUUKUUCDXPUUCCDVTWAUV
      EUUPUUFBCUVEXTCIZSUUOUUEECUVEUVFYBCIZUUOUUEQUVEUVFUVGSZUUOUUEUVEUVHUUOSZS
      ZYCUUDUUNYCYEUVHUVEWBUVJUUBDXTTZUUCUVJUVKYJIYBUVKLZUUBUVKLUVJUVKYQXTTZYJU
      VJDYQXTXNYRUUJUULUVIYSWCVBUVJUUAUVFUVMYJIXNUUAUUJUULUVIUUIWCUVEUVFUVGUUOW
      DXTCYQYTVCWFVDUVJYBXTUDZMNZUVLUVJUVNYDMYBXTWGUUNYCYEUVHUVEWHWIUVJYBDLZUVO
      UVLXEUVJXNUVGUVPXNUUJUULUVIWJUVEUVFUVGUUOWKYBCDVTWFYBXTDWLUOWOUVKYBCYQYTW
      MWFUVJUUNUVKUUCLUUNYCYEUVHUVEWNDUUCXTWPWQWRXFWSWTXAXBXCXDXGXHXIXJGAECXKXL
      XM $.
  $}

  ${
    dnsconst.1 $e |- X = U. J $.
    dnsconst.2 $e |- Y = U. K $.
    $( If a continuous mapping to a T_1 space is constant on a dense subset, it
       is constant on the entire space.  Note that
       ` ( ( cls `` J ) `` A ) = X ` means " ` A ` is dense in ` X ` " and
       ` A C_ ( ``' F " { P } ) ` means " ` F ` is constant on ` A ` " (see
       ~ funconstss ).  (Contributed by NM, 15-Mar-2007.)  (Proof shortened by
       Mario Carneiro, 21-Aug-2015.) $)
    dnsconst $p |- ( ( ( K e. Fre /\ F e. ( J Cn K ) ) /\
      ( P e. Y /\ A C_ ( `' F " { P } ) /\ ( ( cls ` J ) ` A ) = X ) ) ->
        F : X --> { P } ) $=
      ( ct1 wcel ccn co wa ccnv wss cfv wf ccld syl2anc csn cima ccl w3a simplr
      wceq wfn cnf ffn 3syl simpr3 simpll simpr1 t1sncld simpr2 clsss2 eqsstr3d
      cnclima fconst3 sylanbrc ) EJKZCDELMKZNZBGKZACOBUAZUBZPZADUCQQZFUFZUDZNZC
      FUGZFVFPFVECRVKVBFGCRVLVAVBVJUEZCDEFGHIUHFGCUIUJVKFVHVFVCVDVGVIUKVKVFDSQK
      ZVGVHVFPVKVBVEESQKZVNVMVKVAVDVOVAVBVJULVCVDVGVIUMBEGIUNTVECDEURTVCVDVGVIU
      OVFADFHUPTUQFBCUSUT $.
  $}

  ${
    $d x y R $.
    $( The order topology is T_1 for any poset.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    ordtt1 $p |- ( R e. PosetRel -> ( ordTop ` R ) e. Fre ) $=
      ( vx vy cps wcel cordt cfv ctop cv csn ccld cuni wral ct1 ordttop cdm wbr
      wa wceq eqid crab cin wss snssi adantl dfss1 sylib psref adantr jca breq2
      elsn breq1 anbi12d syl5ibrcom wi w3a psasym eqcomd 3expib ad2antrr impbid
      syl5bb rabbi2dva eqtr3d ordtcld3 3anidm23 eqeltrd ralrimiva ordttopon syl
      ctopon toponuni raleqdv mpbid ist1 sylanbrc ) ADEZAFGZHEBIZJZVSKGZEZBVSLZ
      MZVSNEADOVRWCBAPZMWEVRWCBWFVRVTWFEZRZWAVTCIZAQZWIVTAQZRZCWFUAZWBWHWFWAUBZ
      WAWMWHWAWFUCZWNWASWGWOVRVTWFUDUEWAWFUFUGWHWLCWFWAWIWAEWIVTSZWHWIWFEZRZWLC
      VTULWRWPWLWRWLWPVTVTAQZWSRWRWSWSWHWSWQVTAWFWFTZUHUIZXAUJWPWJWSWKWSWIVTVTA
      UKWIVTVTAUMUNUOVRWLWPUPWGWQVRWJWKWPVRWJWKUQVTWIVTWIAURUSUTVAVBVCVDVEVRWGW
      MWBECVTVTADWFWTVFVGVHVIVRWCBWFWDVRVSWFVLGEWFWDSADWFWTVJWFVSVMVKVNVOVSWDBW
      DTVPVQ $.
  $}

  ${
    $d j k x y A $.  $d j k x y B $.  $d j k x y J $.  $d j k x y ph $.
    $d j k F $.
    lmmo.1 $e |- ( ph -> J e. Haus ) $.
    lmmo.4 $e |- ( ph -> F ( ~~>t ` J ) A ) $.
    lmmo.5 $e |- ( ph -> F ( ~~>t ` J ) B ) $.
    $( A sequence in a Hausdorff space converges to at most one limit.  Part of
       Lemma 1.4-2(a) of [Kreyszig] p. 26.  (Contributed by NM, 31-Jan-2008.)
       (Proof shortened by Mario Carneiro, 1-May-2014.) $)
    lmmo $p |- ( ph -> A = B ) $=
      ( vx vy vk vj cv wcel wrex wn wa cfv cn c1 cin wceq w3a an4 cuz wral nnuz
      c0 wi simprr cz a1i clm wbr adantr simprl lmcvg anim12d rexanuz2 wne uzid
      1z ex nnz ne0i 3syl r19.2z elin n0i sylbir rexlimivw sylan rexlimiva syl6
      syl5bi expdimp imnan sylib df-3an sylnibr anassrs nrexdv cuni ctopon ctop
      syl cha haustop eqid toptopon lmcl syl2anc hausnei 3exp2 syl3c necon1bd
      mpd ) ABIMZNZCJMZNZWRWTUAZUHUBZUCZJEOZIEOZPBCUBAXEIEAWRENZQXDJEAXGWTENZXD
      PAXGXHQZQZWSXAQZXCQZXDXJXKXCPZUIXLPAXIXKXMXIXKQXGWSQZXHXAQZQZAXMXGXHWSXAU
      DAXPKMDRZWRNZKLMZUERZUFLSOZXQWTNZKXTUFLSOZQZXMAXNYAXOYCAXNYAAXNQZBWRLKDET
      SUGAXGWSUJTUKNZYEVBULADBEUMRZUNZXNGUOAXGWSUPUQVCAXOYCAXOQZCWTLKDETSUGAXHX
      AUJYFYIVBULADCYGUNZXOHUOAXHXAUPUQVCURYDXRYBQZKXTUFZLSOXMXRYBLKTSUGUSYLXML
      SXSSNZXTUHUTZYLXMYMXSUKNXSXTNYNXSVDXSVAXTXSVEVFYNYLQYKKXTOXMYKKXTVGYKXMKX
      TYKXQXBNXMXQWRWTVHXBXQVIVJVKWFVLVMVJVNVOVPXKXCVQVRWSXAXCVSVTWAWBWBAXFBCAE
      WGNZBEWCZNZCYPNZBCUTZXFUIFAEYPWDRNZYHYQAEWENZYTAYOUUAFEWHWFEYPYPWIZWJVRZG
      BDEYPWKWLAYTYJYRUUCHCDEYPWKWLYOYQYRYSXFBCJIEYPUUBWMWNWOWPWQ $.
  $}

  ${
    $d x y z J $.
    $( The convergence relation is function-like in a Hausdorff space.
       (Contributed by Mario Carneiro, 26-Dec-2013.) $)
    lmfun $p |- ( J e. Haus -> Fun ( ~~>t ` J ) ) $=
      ( vx vy vz cha wcel clm cfv wrel cv wbr wa weq wal wfun lmrel a1i alrimiv
      wi simpl simprl simprr lmmo ex dffun2 sylanbrc ) AEFZAGHZIZBJZCJZUHKZUJDJ
      ZUHKZLZCDMZSZDNZCNZBNUHOUIUGAPQUGUSBUGURCUGUQDUGUOUPUGUOLUKUMUJAUGUOTUGUL
      UNUAUGULUNUBUCUDRRRBCDUHUEUF $.
  $}

  ${
    $d u v x y A $.  $d x y V $.
    $( A discrete topology is Hausdorff.  Morris, Topology without tears, p.72,
       ex. 13.  (Contributed by FL, 24-Jun-2007.)  (Proof shortened by Mario
       Carneiro, 8-Apr-2015.) $)
    dishaus $p |- ( A e. V -> ~P A e. Haus ) $=
      ( vx vy vu vv wcel cv cin c0 wceq w3a wrex wral csn wss snssd snex elpw
      wa cpw ctop wne wi cha distop simplrl sylibr simplrr vex snid a1i disjsn2
      adantl eleq2 ineq1 eqeq1d 3anbi13d ineq2 3anbi23d syl113anc ex ralrimivva
      rspc2ev cuni unipw eqcomi ishaus sylanbrc ) ABGZAUAZUBGCHZDHZUCZVLEHZGZVM
      FHZGZVOVQIZJKZLZFVKMEVKMZUDZDANCANVKUEGABUFVJWCCDAAVJVLAGZVMAGZTTZVNWBWFV
      NTZVLOZVKGZVMOZVKGZVLWHGZVMWJGZWHWJIZJKZWBWGWHAPWIWGVLAVJWDWEVNUGQWHAVLRS
      UHWGWJAPWKWGVMAVJWDWEVNUIQWJAVMRSUHWLWGVLCUJUKULWMWGVMDUJUKULVNWOWFVLVMUM
      UNWAWLWMWOLWLVRWHVQIZJKZLEFWHWJVKVKVOWHKZVPWLVTWQVRVOWHVLUOWRVSWPJVOWHVQU
      PUQURVQWJKZVRWMWQWOWLVQWJVMUOWSWPWNJVQWJWHUSUQUTVDVAVBVCCDFEVKAVKVEAAVFVG
      VHVI $.
  $}

  ${
    $d m n x y A $.  $d m n x y B $.  $d m n x y R $.  $d m n x y X $.
    ordthauslem.1 $e |- X = dom R $.
    $( Lemma for ~ ordthaus .  (Contributed by Mario Carneiro, 13-Sep-2015.) $)
    ordthauslem $p |- ( ( R e. TosetRel /\ A e. X /\ B e. X ) -> ( A R B ->
      ( A =/= B -> E. m e. ( ordTop ` R ) E. n e. ( ordTop ` R )
        ( A e. m /\ B e. n /\ ( m i^i n ) = (/) ) ) ) ) $=
      ( vx vy ctsr wcel w3a wbr cin c0 wceq wa wn crab syl2anc wne cv cordt cfv
      wrex simpll1 simpll3 ordtopn2 simpll2 ordtopn1 simprr cps wi simpl1 tsrps
      syl simprl psasym 3expia necon3ad adantr breq2 elrab sylanbrc breq1 simpr
      notbid eleq2 ineq1 eqeq1d 3anbi13d ineq2 inrab 3anbi23d rspc2ev syl113anc
      mpd syl6eq ex rabn0 simprrr simprrl wral wo tsrlin 3expa sylan oran sylib
      jca ralrimiva rabeq0 sylibr rexlimdvaa syl5bi pm2.61dne exp32 ) CJKZAFKZB
      FKZLZABCMZABUAZADUBZKZBEUBZKZXDXFNZOPZLZECUCUDZUEDXKUEZXAXBXCQZQZXLBHUBZC
      MZRZXOACMZRZQZHFSZOXNYAOPZXLXNYBQZXQHFSZXKKZXSHFSZXKKZAYDKZBYFKZYBXLYCWRW
      TYEWRWSWTXMYBUFZWRWSWTXMYBUGZHBCJFGUHTYCWRWSYGYJWRWSWTXMYBUIZHACJFGUJTYCW
      SBACMZRZYHYLXNYNYBXNXCYNXAXBXCUKXNYMABXNCULKZXBYMABPZUMXNWRYOWRWSWTXMUNCU
      OUPXAXBXCUQYOXBYMYPABCURUSTUTVQVAZXQYNHAFXOAPXPYMXOABCVBVGVCVDYCWTYNYIYKY
      QXSYNHBFXOBPXRYMXOBACVEVGVCVDXNYBVFXJYHYIYBLYHXGYDXFNZOPZLDEYDYFXKXKXDYDP
      ZXEYHXIYSXGXDYDAVHYTXHYROXDYDXFVIVJVKXFYFPZXGYIYSYBYHXFYFBVHUUAYRYAOUUAYR
      YDYFNYAXFYFYDVLXQXSHFVMVRVJVNVOVPVSYAOUAXTHFUEXNXLXTHFVTXNXTXLHFXNXOFKZXT
      QZQZXOIUBZCMZRZIFSZXKKZUUEXOCMZRZIFSZXKKZAUUHKZBUULKZUUGUUKQZIFSZOPZXLUUD
      WRUUBUUIWRWSWTXMUUCUFZXNUUBXTUQZIXOCJFGUHTUUDWRUUBUUMUUSUUTIXOCJFGUJTUUDW
      SXSUUNWRWSWTXMUUCUIXNUUBXQXSWAUUGXSIAFUUEAPUUFXRUUEAXOCVBVGVCVDUUDWTXQUUO
      WRWSWTXMUUCUGXNUUBXQXSWBUUKXQIBFUUEBPUUJXPUUEBXOCVEVGVCVDUUDUUPRZIFWCUURU
      UDUVAIFUUDUUEFKZQUUFUUJWDZUVAUUDWRUUBQUVBUVCUUDWRUUBUUSUUTWJWRUUBUVBUVCXO
      UUECFGWEWFWGUUFUUJWHWIWKUUPIFWLWMXJUUNUUOUURLUUNXGUUHXFNZOPZLDEUUHUULXKXK
      XDUUHPZXEUUNXIUVEXGXDUUHAVHUVFXHUVDOXDUUHXFVIVJVKXFUULPZXGUUOUVEUURUUNXFU
      ULBVHUVGUVDUUQOUVGUVDUUHUULNUUQXFUULUUHVLUUGUUKIFVMVRVJVNVOVPWNWOWPWQ $.
  $}

  ${
    $d m n x y R $.
    $( The order topology of a total order is Hausdorff.  (Contributed by Mario
       Carneiro, 13-Sep-2015.) $)
    ordthaus $p |- ( R e. TosetRel -> ( ordTop ` R ) e. Haus ) $=
      ( vx vy vm vn ctsr wcel cfv cv wne cin wceq w3a wrex wral wbr ordthauslem
      c0 wi bitri cordt cha cdm eqid necom 3ancoma incom eqeq1i 3anbi3i 2rexbii
      rexcom imbi12i syl6ib 3com23 tsrlin mpjaod ralrimivva ctopon wb ordttopon
      3expb ishaus2 syl mpbird ) AFGZAUAHZUBGZBIZCIZJZVHDIZGZVIEIZGZVKVMKZRLZMZ
      EVFNDVFNZSZCAUCZOBVTOZVEVSBCVTVTVEVHVTGZVIVTGZVSVEWBWCMVHVIAPVSVIVHAPZVHV
      IADEVTVTUDZQVEWCWBWDVSSVEWCWBMWDVIVHJZVNVLVMVKKZRLZMZDVFNEVFNZSVSVIVHAEDV
      TWEQWFVJWJVRVIVHUEWJVQDVFNEVFNVRWIVQEDVFVFWIVLVNWHMVQVNVLWHUFWHVPVLVNWGVO
      RVMVKUGUHUITUJVQEDVFVFUKTULUMUNVHVIAVTWEUOUPVAUQVEVFVTURHGVGWAUSAFVTWEUTB
      CEDVFVTVBVCVD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Compactness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Comp $.

  $( Extend class notation with the class of all compact spaces. $)
  ccmp $a class Comp $.

  ${
    $d x y z $.
    $( Definition of a compact topology.  A topology is compact iff any open
       covering of its underlying set contains a finite sub-covering
       (Heine-Borel property).  Definition C''' of [BourbakiTop1] p.  I.59.
       Note:  Bourbaki uses the term quasi-compact topology but it is not the
       modern usage (which we follow).  (Contributed by FL, 22-Dec-2008.) $)
    df-cmp $a |- Comp = { x e. Top | A. y e. ~P x ( U. x = U. y
      -> E. z e. ( ~P y i^i Fin ) U. x = U. z ) } $.
  $}

  ${
    $d f s u x y z A $.  $d r s u x y z J $.  $d f s u x ph $.  $d s u z ps $.
    $d r s S $.  $d r u x X $.
    iscmp.1 $e |- X = U. J $.
    $( The predicate "is a compact topology".  (Contributed by FL,
       22-Dec-2008.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    iscmp $p |- ( J e. Comp <-> ( J e. Top /\ A. y e. ~P J
      ( X = U. y -> E. z e. ( ~P y i^i Fin ) X = U. z ) ) ) $=
      ( vx cv cuni wceq cpw cfn cin wrex wi wral ctop ccmp pweq unieq eqeq1d
      syl6eqr rexbidv imbi12d raleqbidv df-cmp elrab2 ) FGZHZAGZHZIZUHBGHZIZBUI
      JKLZMZNZAUGJZODUJIZDULIZBUNMZNZACJZOFCPQUGCIZUPVAAUQVBUGCRVCUKURUOUTVCUHD
      UJVCUHCHDUGCSEUAZTVCUMUSBUNVCUHDULVDTUBUCUDFABUEUF $.

    $( An open cover of a compact topology has a finite subcover.  (Contributed
       by Jeff Hankins, 29-Jun-2009.) $)
    cmpcov $p |- ( ( J e. Comp /\ S C_ J /\ X = U. S ) ->
                    E. s e. ( ~P S i^i Fin ) X = U. s ) $=
      ( vr ccmp wcel wss cuni wceq cv cpw cfn cin wrex wa wi wral cvv wb ancoms
      simpr ssexg elpwg syl mpbird ctop iscmp simprbi adantr eqeq2d pweq ineq1d
      unieq rexeqdv imbi12d rspcv sylc 3impia ) BGHZABIZCAJZKZCDLJKZDAMZNOZPZVA
      VBQZABMZHZCFLZJZKZVEDVLMZNOZPZRZFVJSZVDVHRZVIVKVBVAVBUCVIATHZVKVBUAVBVAWA
      ABGUDUBABTUEUFUGVAVSVBVABUHHVSFDBCEUIUJUKVRVTFAVJVLAKZVNVDVQVHWBVMVCCVLAU
      OULWBVEDVPVGWBVOVFNVLAUMUNUPUQURUSUT $.

    $( Rewrite ~ cmpcov for the cover ` { y e. J | ph } ` .  (Contributed by
       Mario Carneiro, 11-Sep-2015.) $)
    cmpcov2 $p |- ( ( J e. Comp /\ A. x e. X E. y e. J ( x e. y /\ ph ) ) ->
                    E. s e. ( ~P J i^i Fin ) ( X = U. s /\ A. y e. s ph ) ) $=
      ( wcel cv wa wrex wral cuni wceq cpw cfn wss bitri anbi1i an32 ccmp dfss3
      crab cin elunirab ralbii biimpri ssrab2 unissi sseqtr4i a1i cmpcov mp3an2
      eqssd sylan2 ssrab anass 3bitr4i elfpw rexbii2 sylib ) DUAHZBIZCIHAJCDKZB
      ELZJEFIZMNZFACDUCZOPUDZKZVGACVFLZJZFDOPUDZKVEVBEVHMZNZVJVEEVNEVNQZVEVPVCV
      NHZBELVEBEVNUBVQVDBEACVCDUEUFRUGVNEQVEVNDMEVHDACDUHZUIGUJUKUNVBVHDQVOVJVR
      VHDEFGULUMUOVGVLFVIVMVFVHQZVFPHZJZVGJZVFDQZVTJZVLJZVFVIHZVGJVFVMHZVLJVSVG
      JZVTJWCVLJZVTJWBWEWHWIVTWHWCVKJZVGJZWIVSWJVGACDVFUPSWKWCVGJVKJWIWCVKVGTWC
      VGVKUQRRSVSVTVGTWCVTVLTURWFWAVGVFVHUSSWGWDVLVFDUSSURUTVA $.

    $d s X $.
    cmpcovf.2 $e |- ( z = ( f ` y ) -> ( ph <-> ps ) ) $.
    $( Combine ~ cmpcov with ~ ac6sfi to show the existence of a function that
       indexes the elements that are generating the open cover.  (Contributed
       by Mario Carneiro, 14-Sep-2014.) $)
    cmpcovf $p |- ( ( J e. Comp /\
      A. x e. X E. y e. J ( x e. y /\ E. z e. A ph ) ) ->
      E. s e. ( ~P J i^i Fin ) ( X = U. s /\
        E. f ( f : s --> A /\ A. y e. s ps ) ) ) $=
      ( vu wcel cv wrex wa wral wceq cfn ccmp cuni cpw cin wf wex simpl cmpcov2
      wss wi simplrl vex elpw sylibr simplrr elin sylanbrc simprl simprr ac6sfi
      elfpw syl2anc unieq eqeq2d feq2 anbi12d exbidv rspcev syl12anc ex sylan2b
      raleq rexlimdva sylc ) HUANZCODONAEFPZQDHPCIRZQVOIMOZUBZSZVPDVRRZQZMHUCZT
      UDZPIJOZUBZSZWEFGOZUEZBDWERZQZGUFZQZJWDPZVOVQUGVPCDHIMKUHVOWBWNMWDVRWDNZV
      OVRHUIZVRTNZQZWBWNUJVRHVAVOWRQZWBWNWSWBQZWOVTVRFWHUEZBDVRRZQZGUFZWNWTVRWC
      NZWQWOWTWPXEVOWPWQWBUKVRHMULUMUNVOWPWQWBUOZVRWCTUPUQWSVTWAURWTWQWAXDXFWSV
      TWAUSABDEVRFGLUTVBWMVTXDQJVRWDWEVRSZWGVTWLXDXGWFVSIWEVRVCVDXGWKXCGXGWIXAW
      JXBWEVRFWHVEBDWEVRVLVFVGVFVHVIVJVKVMVN $.
  $}

  ${
    $d c d o r s u v x y F $.  $d c d o r s u v x y J $.
    $d c d o r s u v x y K $.  $d c d o r s u v x y X $.
    $d c d o r s u v x y Y $.
    cncmp.2 $e |- Y = U. K $.
    $( Compactness is respected by a continuous onto map.  (Contributed by Jeff
       Hankins, 12-Jul-2009.)  (Proof shortened by Mario Carneiro,
       22-Aug-2015.) $)
    cncmp $p |- ( ( J e. Comp /\ F : X -onto-> Y /\ F e. ( J Cn K ) ) ->
        K e. Comp ) $=
      ( vu vy vc vd wcel cv cuni wceq cfn wral wss wa cima syl vv vs vx wfo ccn
      ccmp co w3a ctop cpw cin wrex wi cntop2 3ad2ant3 elpwi ccnv crn simpl1 wf
      cmpt simprl sselda simpl3 cnima sylan syldan fmptd frn simprr imaeq2d cnf
      eqid fimacnv ralrimiva dfiun2g imauni rnmpt unieqi 3eqtr4g 3eqtr3d cmpcov
      ciun cab syl3anc elfpw simprll simpll2 elssuni syl6sseqr foimacnv syl2anc
      eqeltrd wb imaeq2 eleq1d ralrnmpt mpbird adantr r19.21bi simprlr syl5eqel
      simpr abrexfi sylanbrc cdm fdm fof 3syl foima unieq eqeq2d rspcev sylan2b
      expr rexlimdva mpd sylan2 iscmp ) BUFKZDEAUDZABCUEUGKZUHZCUIKZEGLZMZNZEUA
      LZMZNZUAYEUJOUKZULZUMZGCUJZPCUFKYBXTYDYAABCUNUOYCYMGYNYEYNKYCYECQZYMYECUP
      YCYOYGYLYCYOYGRZRZBMZUBLZMZNZUBHYEAUQZHLZSZVAZURZUJOUKZULZYLYQXTUUFBQZYRU
      UFMZNUUHXTYAYBYPUSYQYEBUUEUTUUIYQHYEUUDBUUEYQUUCYEKZUUCCKZUUDBKZYQYECUUCY
      CYOYGVBVCZYQYBUULUUMXTYAYBYPVDZUUCABCVEVFVGZUUEVMZVHYEBUUEVITYQUUBESZUUBY
      FSZYRUUJYQEYFUUBYCYOYGVJVKYQYREAUTZUURYRNYQYBUUTUUOABCYREYRVMZFVLTZYREAVN
      TYQHYEUUDWCZUCLUUDNHYEULUCWDZMZUUSUUJYQUUMHYEPZUVCUVENYQUUMHYEUUPVOZHUCYE
      UUDBVPTHUUBYEVQUUFUVDHUCYEUUDUUEUUQVRVSVTWAUUFBYRUBUVAWBWEYQUUAYLUBUUGYSU
      UGKYQYSUUFQZYSOKZRZUUAYLUMYSUUFWFYQUVJUUAYLYQUVJUUARZRZIYSAILZSZVAZURZYKK
      ZEUVPMZNZYLUVLUVPYEQZUVPOKZUVQUVLYSYEUVOUTUVTUVLIYSUVNYEUVOUVLUVMYSKUVMUU
      FKUVNYEKZUVLYSUUFUVMYQUVHUVIUUAWGVCUVLUWBIUUFYQUWBIUUFPZUVKYQUWCAUUDSZYEK
      ZHYEPZYQUWEHYEYQUUKRZUWDUUCYEUWGYAUUCEQZUWDUUCNXTYAYBYPUUKWHUWGUULUWHUUNU
      ULUUCCMEUUCCWIFWJTDEUUCAWKWLYQUUKXCWMVOYQUVFUWCUWFWNUVGUWBUWEHIYEUUDUUEBU
      UQUVMUUDNUVNUWDYEUVMUUDAWOWPWQTWRWSWTVGZUVOVMZVHYSYEUVOVITUVLUVIUWAYQUVHU
      VIUUAXAUVIUVPJLUVNNIYSULJWDZOIJYSUVNUVOUWJVRZIJYSUVNXDXBTUVPYEWFXEUVLADSZ
      AYTSZEUVRUVLDYTAUVLAXFZYRDYTUVLUUTUWOYRNYQUUTUVKUVBWSYREAXGTUVLYADEAUTUWO
      DNXTYAYBYPUVKWHZDEAXHDEAXGXIYQUVJUUAVJWAVKUVLYAUWMENUWPDEAXJTUVLIYSUVNWCZ
      UWKMZUWNUVRUVLUWBIYSPUWQUWRNUVLUWBIYSUWIVOIJYSUVNYEVPTIAYSVQUVPUWKUWLVSVT
      WAYJUVSUAUVPYKYHUVPNYIUVREYHUVPXKXLXMWLXOXNXPXQXOXRVOGUACEFXSXE $.
  $}

  ${
    $d J y z $.
    $( A finite topology is compact.  (Contributed by FL, 22-Dec-2008.) $)
    fincmp $p |- ( J e. ( Top i^i Fin ) -> J e. Comp ) $=
      ( vy vz ctop cfn cin wcel cuni cv wceq cpw wrex wi wral inss1 sseli inss2
      ccmp wa vex pwid wss elpw ssfi sylan2b elin unieq eqeq2d rspcev ex sylbir
      sylancr ralrimiva syl eqid iscmp sylanbrc ) ADEFZGZADGAHZBIZHZJZUTCIZHZJZ
      CVAKZEFZLZMZBAKZNZARGURDADEOPUSAEGZVLUREADEQPVMVJBVKVMVAVKGZSVAVGGZVAEGZV
      JVABTZUAVNVMVAAUBVPVAAVQUCAVAUDUEVOVPSVAVHGZVJVAVGEUFVRVCVIVFVCCVAVHVDVAJ
      VEVBUTVDVAUGUHUIUJUKULUMUNBCAUTUTUOUPUQ $.
  $}

  $( The singleton of the empty set is compact.  (Contributed by FL,
     2-Aug-2009.) $)
  0cmp $p |- { (/) } e. Comp $=
    ( c0 csn ctop cfn cin wcel ccmp sn0top snfi elin mpbir2an fincmp ax-mp ) AB
    ZCDEFZNGFONCFNDFHAINCDJKNLM $.

  ${
    $d r s J $.
    $( A compact topology is a topology.  (Contributed by Jeff Hankins,
       29-Jun-2009.) $)
    cmptop $p |- ( J e. Comp -> J e. Top ) $=
      ( vr vs ccmp wcel ctop cuni cv wceq cpw cfn cin wrex wi wral eqid simplbi
      iscmp ) ADEAFEAGZBHZGISCHGICTJKLMNBAJOBCASSPRQ $.
  $}

  ${
    $d f s u x y z A $.  $d r s u x y J $.  $d f u x ph $.  $d s u z ps $.
    $d r s S $.  $d r u x X $.
    $( The image of a compact set under a continuous function is compact.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    rncmp $p |- ( ( J e. Comp /\ F e. ( J Cn K ) ) ->
      ( K |`t ran F ) e. Comp ) $=
      ( ccmp wcel ccn co wa cuni crn crest wfo eqid adantl syl sylib wb syl3anc
      wss mpbid simpl wfn wf cnf ffn dffn4 wceq ctop cntop2 frn restuni syl2anc
      foeq3 simpr ctopon cfv toptopon ssid a1i cnrest2 cncmp ) BDEZABCFGEZHZVBB
      IZCAJZKGZIZALZABVGFGEZVGDEVBVCUAVDVEVFALZVIVDAVEUBZVKVDVECIZAUCZVLVCVNVBA
      BCVEVMVEMVMMZUDNZVEVMAUEOVEAUFPVDVFVHUGZVKVIQVDCUHEZVFVMSZVQVCVRVBABCUINZ
      VDVNVSVPVEVMAUJOZVFCVMVOUKULVFVHVEAUMOTVDVCVJVBVCUNVDCVMUOUPEZVFVFSZVSVCV
      JQVDVRWBVTCVMVOUQPWCVDVFURUSWAVFABCVMUTRTABVGVEVHVHMVAR $.

    $( The image of a compact set under a continuous function is compact.
       (Contributed by Mario Carneiro, 18-Feb-2015.)  (Revised by Mario
       Carneiro, 22-Aug-2015.) $)
    imacmp $p |- ( ( F e. ( J Cn K ) /\ ( J |`t A ) e. Comp ) ->
      ( K |`t ( F " A ) ) e. Comp ) $=
      ( ccn co wcel crest ccmp wa cima cres crn cuni cin eqid cdm wceq 3syl cvv
      df-ima oveq2i simpr wss simpl inss2 cnrest sylancl resdmres dmres cnf fdm
      wf ineq2d syl5eq reseq2d syl5eqr ctop cmptop adantl restrcl restin oveq1d
      3eltr4d rncmp syl2anc syl5eqel ) BCDEFGZCAHFZIGZJZDBAKZHFDBALZMZHFZIVLVND
      HBAUAUBVKVJVMVIDEFZGVOIGVHVJUCVKBACNZOZLZCVRHFZDEFZVMVPVKVHVRVQUDVSWAGVHV
      JUEZAVQUFVRBCDVQVQPZUGUHVKVMBVMQZLVSBAUIVKWDVRBVKWDABQZOVRBAUJVKWEVQAVKVH
      VQDNZBUMWEVQRWBBCDVQWFWCWFPUKVQWFBULSUNUOUPUQVKVIVTDEVKVIURGZCTGATGJVIVTR
      VJWGVHVIUSUTACVAACTTVQWCVBSVCVDVMVIDVEVFVG $.
  $}

  ${
    $d x y A $.  $d c d f s t u v w y z J $.  $d c d f s t u v w x y z S $.
    $d c d f s t u w y z X $.
    $( A discrete topology is compact iff the base set is finite.  (Contributed
       by Mario Carneiro, 19-Mar-2015.) $)
    discmp $p |- ( A e. Fin <-> ~P A e. Comp ) $=
      ( vy vx cfn wcel cpw ccmp ctop cin distop pwfi elin syl cv cuni wceq wrex
      wss wf frn biimpi sylanbrc fincmp csn cmpt crn wa simpr snssd snex sylibr
      elpw eqid fmptd cab ciun rnmpt unieqi dfiun2 iunid 3eqtr2ri eqcomi cmpcov
      a1i unipw mpd3an23 simprbi simplbi elpwid wral snfi rgenw fmpt mpbi sstrd
      mp1i unifi syl2anc eleq1 syl5ibrcom rexlimiv impbii ) ADEZAFZGEZWCWDHDIEZ
      WEWCWDHEWDDEZWFADJWCWGAKUAWDHDLUBWDUCMWEABNZOZPZBCACNZUDZUEZUFZFZDIZQZWCW
      EWNWDRZAWNOZPZWQWEAWDWMSWRWECAWLWDWMWEWKAEZUGZWLARWLWDEXBWKAWEXAUHUIWLAWK
      UJZULUKWMUMZUNAWDWMTMWTWEWSWHWLPCAQBUOZOCAWLUPAWNXECBAWLWMXDUQURCBAWLXCUS
      CAUTVAVDWNWDABWDOAAVEVBVCVFWJWCBWPWHWPEZWCWJWIDEZXFWHDEZWHDRXGXFWHWOEZXHW
      HWODLZVGXFWHWNDXFWHWNXFXIXHXJVHVIADWMSZWNDRXFWLDEZCAVJXKXLCAWKVKVLCADWLWM
      XDVMVNADWMTVPVOWHVQVRAWIDVSVTWAMWB $.


    cmpsub.1 $e |- X = U. J $.
    $( Lemma for ~ cmpsub .  (Contributed by Jeff Hankins, 28-Jun-2009.) $)
    cmpsublem $p |- ( ( J e. Top /\ S C_ X ) ->
    ( A. c e. ~P J ( S C_ U. c -> E. d e. ( ~P c i^i Fin ) S C_ U. d ) ->
      A. s e. ~P ( J |`t S ) ( U. ( J |`t S ) = U. s ->
      E. t e. ( ~P s i^i Fin ) U. ( J |`t S ) = U. t ) ) ) $=
      ( vy vw vz wcel wss wa cv cuni cfn cin wi wceq vv vu ctop wrex wral crest
      vx cpw crab cvv rabexg ad2antrr ssrab2 elpwg mpbiri syl unieq sseq2d pweq
      co ineq1d rexeqdv imbi12d rspcva sylan restuni adantr eqeq1d wel wex elpw
      ex vex eleq2 eluni syl6bb adantl ssel sseq2i uniexg ancoms sylan2b elrest
      ssexg syldan w3a inss1 sseq1 sselda 3ad2antl3 3adant2 simp12 eleq1 biimpa
      wb 3adant3 weq ineq1 elrab sylanbrc anbi12d spcev syl2anc 3exp rexlimdv3a
      eleq1d sylbid com23 com4l sylcom com24 impcom imp3a exlimdv syl6ibr ssrdv
      imp pm2.27 elin eqeq1 rexbidv elab eleq1a sylbi syl6 sylanb 3imp rexlimdv
      cab a1d syl5bi abrexex sylibr abrexfi ad2antlr ciun dfss biimpi uniiun
      a1i ineq2i iunin2 iuneq2i 3eqtr2i syl6eq 3ad2ant2 ad2antrl 3adant1 dfiun2
      incom inex1 3eqtr3d eqeq2d rspcev rexlimiv com3r sylbird syld ralrimdva
      mpd ) CUCLZBDMZNZBFOZPZMZBGOZPZMZGUVDUHZQRZUDZSZFCUHZUEZCBUFUTZPZEOZPZTZU
      VQAOZPZTZAUVRUHZQRZUDZSZEUVPUHZUVCUVRUWHLZNZUVOBIOZBRZUVRLZICUIZPZMZUVIGU
      WNUHZQRZUDZSZUWGUWJUVOUWTUWJUWNUVNLZUVOUWTUWJUWNUJLZUXAUVAUXBUVBUWIUWMICU
      CUKULUXBUXAUWNCMUWMICUMUWNCUJUNUOUPUVMUWTFUWNUVNUVDUWNTZUVFUWPUVLUWSUXCUV
      EUWOBUVDUWNUQURUXCUVIGUVKUWRUXCUVJUWQQUVDUWNUSVAVBVCVDVEVLUWJUVTUWTUWFUWJ
      UVTBUVSTZUWTUWFSZUWJBUVQUVSUVCBUVQTZUWIBCDHVFVGZVHUWJUXDUXEUWJUXDNZUWPUXE
      UXHABUWOUXHUWABLZAUAVIZUAOZUWNLZNZUAVJZUWAUWOLUWJUXDUXIUXNSZUWIUVCUVRUVPM
      ZUXDUXOSUVRUVPEVMVKUVCUXPNZUXDUXOUXQUXDNUXIAUBVIZUBEVIZNZUBVJZUXNUXDUXIUY
      AWOUXQUXDUXIUWAUVSLUYABUVSUWAVNUBUWAUVRVOVPVQUXQUYAUXNSUXDUXQUXTUXNUBUXQU
      XRUXSUXNUXPUVCUXRUXSUXNSSUXPUXSUXRUVCUXNUXPUXSUBOZUVPLZUXRUVCUXNSSUVRUVPU
      YBVRUVCUXSUYCUXRUXNUVCUYCUXSUXRUXNSZUVCUYCUYBJOZBRZTZJCUDZUXSUYDSZUVAUVBB
      UJLZUYCUYHWOUVBUVABCPZMZUYJDUYKBHVSUVAUYKUJLZUYLUYJCUCVTUYLUYMUYJBUYKUJWD
      WAVEWBJUYBBCUCUJWCWEUVCUYGUYIJCUVCUYECLZUYGWFZUXSUXRUXNUYOUXSUXRWFZAJVIZU
      YEUWNLZUXNUYOUXRUYQUXSUYGUVCUXRUYQUYNUYGUYBUYEUWAUYGUYBUYEMUYFUYEMUYEBWGU
      YBUYFUYEWHUOWIWJWKUYPUYNUYFUVRLZUYRUVCUYNUYGUXSUXRWLUYOUXSUYSUXRUYGUVCUXS
      UYSUYNUYGUXSUYSUYBUYFUVRWMWNWJWPUWMUYSIUYECIJWQUWLUYFUVRUWKUYEBWRXFWSWTUX
      MUYQUYRNUAUYEJVMUAJWQUXJUYQUXLUYRUXKUYEUWAVNUXKUYEUWNWMXAXBXCXDXEXGXHXIXJ
      XKXLXMXNVGXGVLWBXQUAUWAUWNVOXOXPUWPUWTUXHUWFUWPUWTUWSUXHUWFSZUWPUWSXRUVIU
      YTGUWRUVGUWRLUVGUWQLZUVGQLZNZUVIUYTSUVGUWQQXSVUCUVIUXHUWFVUCUVIUXHWFZUGOZ
      KOZBRZTZKUVGUDZUGYIZUWELZUVQVUJPZTZUWFVUDVUJUWDLZVUJQLZVUKVUDVUJUVRMVUNVU
      DAVUJUVRUWAVUJLUWAVUGTZKUVGUDZVUDAEVIZVUIVUQUGUWAAVMUGAWQVUHVUPKUVGVUEUWA
      VUGXTYAYBVUDVUPVURKUVGVUCUVIUXHKGVIZVUPVURSZSZVUAUVGUWNMZVUBUVIUXHVVASZSZ
      UVGUWNGVMZVKVVBVVDVUBVVBVVCUVIVVBVVAUXHVVBVUSVUFUWNLZVUTUVGUWNVUFVRVVFVUF
      CLZVUGUVRLZNVUTUWMVVHIVUFCIKWQUWLVUGUVRUWKVUFBWRXFWSVVHVUTVVGVUGUVRUWAYCV
      QYDYEYJYJVGYFYGYHYKXPVUJUVRKUGUVGVUGVVEYLVKYMVUCUVIVUOUXHVUBVUOVUAUVIKUGU
      VGVUGYNYOWPVUJUWDQXSWTVUDBKUVGVUGYPZUVQVULUVIVUCBVVITUXHUVIBBUVHRZVVIUVIB
      VVJTBUVHYQYRVVJBKUVGVUFYPZRKUVGBVUFRZYPVVIUVHVVKBKUVGYSUUAKUVGBVUFUUBKUVG
      VVLVUGVVLVUGTVUSBVUFUUJYTUUCUUDUUEUUFUVIUXHUXFVUCUWJUXFUVIUXDUXGUUGUUHVVI
      VULTVUDKUGUVGVUGVUFBKVMUUKUUIYTUULUWCVUMAVUJUWEUWAVUJTUWBVULUVQUWAVUJUQUU
      MUUNXCXDYDUUOYEUUPUUTVLUUQXHUURUUS $.

    $( Two equivalent ways of describing a compact subset of a topological
       space.  Inspired by Sue E. Goodman's _Beginning Topology_.  (Contributed
       by Jeff Hankins, 22-Jun-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.) $)
    cmpsub $p |- ( ( J e. Top /\ S C_ X ) ->
                   ( ( J |`t S ) e. Comp <-> A. c e. ~P J
                 ( S C_ U. c -> E. d e. ( ~P c i^i Fin ) S C_ U. d ) ) ) $=
      ( vs vt vx vy wcel wss wa cuni cv wceq cfn cin wrex wi vf vw vu ctop ccmp
      vv crest co cpw wral eqid iscmp wb id topopn ssexg syl2anr resttop syldan
      cvv ibar bicomd syl syl5bb cab vex weq eqeq1 rexbidv elab wel ssel2 ineq1
      eqeq2d rspcev ex sylbi adantl rexlimdv simpll sseq2i uniexg sylan2 ancoms
      elpw sylan2b adantr elrest syl2anc sylibrd syl5bi ssrdv sylibr unieq pweq
      abrexex ineq1d rexeqdv imbi12d rspcva sylan restuni ad2antrr inex1 dfiun2
      ciun incom a1i iuneq2dv syl5eqr iunin2 uniiun eqcomi ineq2d biimpi syl5eq
      sseqin2 eqtrd eqtr2d eqeq12d eqeq1d a1bi dfss3 ralbii 3bitri anbi1i bitri
      elin wf cfv wex ac6sfi crn frn ad2antrl adantll sseq1 syld eluni com23
      rnex cdom wbr simprr wfo wfn ffn dffn4 sylib fodomfi ad2ant2r domfi fveq2
      sylanbrc rspccv pm2.27 w3a mpbiri ssel a1dd 3imp fnfvelrn expcom 3ad2ant1
      inss1 syl5 jcad 3exp com3r imp com3l impcom fvex eleq2 eleq1 anbi12d syl6
      spcev exlimdv 3imtr4g ad2antlr mpbird jca eximdv sseq2d exlimiv rexlimdva
      syl8 mpd syl5bir sylbird ralrimdva cmpsublem impbid bitrd ) BUDKZACLZMZBA
      UGUHZUEKZUWSNZGOZNZPZUXAHOZNZPZHUXBUIZQRZSZTZGUWSUIZUJZADOZNZLZAEOZNZLZEU
      XNUIZQRZSZTZDBUIZUJZUWTUWSUDKZUXMMZUWRUXMGHUWSUXAUXAUKULUWRUYFUYGUXMUMUWP
      UWQAUTKZUYFUWQUWQCBKUYHUWPUWQUNBCFUOACBUPUQABUTURUSUYFUXMUYGUYFUXMVAVBVCV
      DUWRUXMUYEUWRUXMUYCDUYDUWRUXNUYDKZMZUXMUXAIOZJOZARZPZJUXNSZIVEZNZPZUXGHUY
      PUIZQRZSZTZUYCUYJUXMVUBUYJUYPUXLKZUXMVUBUYJUYPUWSLVUCUYJHUYPUWSUXEUYPKUXE
      UYMPZJUXNSZUYJUXEUWSKZUYOVUEIUXEHVFZIHVGUYNVUDJUXNUYKUXEUYMVHVIVJUYJVUEUX
      EUXQARZPZEBSZVUFUYJVUDVUJJUXNUYIJDVKZVUDVUJTZTZUWRUYIUXNBLZVUMUXNBDVFZWEV
      UNVUKVULVUNVUKMUYLBKZVULUXNBUYLVLVUPVUDVUJVUIVUDEUYLBEJVGVUHUYMUXEUXQUYLA
      VMVNVOVPVCVPVQVRVSUYJUWPUYHVUFVUJUMUWPUWQUYIVTUWRUYHUYIUWQUWPABNZLZUYHCVU
      QAFWAVURUWPUYHUWPVURVUQUTKUYHBUDWBAVUQUTUPWCWDWFWGEUXEABUDUTWHWIWJWKWLUYP
      UWSJIUXNUYMVUOWPWEWMUXKVUBGUYPUXLUXBUYPPZUXDUYRUXJVUAVUSUXCUYQUXAUXBUYPWN
      VNVUSUXGHUXIUYTVUSUXHUYSQUXBUYPWOWQWRWSWTXAVPUYJUXPVUBUYBUYJUXPVUBUYBTUYJ
      UXPMZVUBAAPZAUXFPZHUYTSZTZUYBVUTVVAUYRVVCVUAVUTAUXAAUYQUWRAUXAPUYIUXPABCF
      XBXCZVUTUYQJUXNAUYLRZXFZAVUTUYQJUXNUYMXFVVGJIUXNUYMUYLAJVFXDXEVUTJUXNUYMV
      VFUYMVVFPVUTVUKMUYLAXGXHXIXJVUTVVGAJUXNUYLXFZRZAJUXNAUYLXKVUTVVIAUXORZAVU
      TVVHUXOAVVHUXOPVUTUXOVVHJUXNXLXMXHXNUXPVVJAPUYJUXPVVJUXOARZAAUXOXGUXPVVKA
      PAUXOXQXOXPVRXRXPXSXTVUTVVBUXGHUYTVUTAUXAUXFVVEYAVIWSVVDVVCVUTUYBVVAVVCAU
      KYBVUTVVBUYBHUYTUXEUYTKZVUTUXBUYMPZJUXNSZGUXEUJZUXEQKZMZVVBUYBTZVVLUXEUYS
      KZVVPMVVQUXEUYSQYHVVSVVOVVPVVSUXEUYPLUXBUYPKZGUXEUJVVOUXEUYPVUGWEGUXEUYPY
      CVVTVVNGUXEUYOVVNIUXBGVFIGVGUYNVVMJUXNUYKUXBUYMVHVIVJYDYEYFYGVUTVVQMZUXEU
      XNUAOZYIZUXBUXBVWBYJZARZPZGUXEUJZMZUAYKZVVRVVQVWIVUTVVPVVOVWIVVMVWFGJUXEU
      XNUAUYLVWDPUYMVWEUXBUYLVWDAVMVNYLWDVRVWAVWIVVBVWBYMZUYAKZAVWJNZLZMZUAYKZU
      YBVWAVVBVWIVWOVWAVVBVWIVWOTVWAVVBMZVWHVWNUAVWPVWHVWNVWPVWHMZVWKVWMVWQVWJU
      XTKZVWJQKZVWKVWQVWJUXNLZVWRVWCVWTVWPVWGUXEUXNVWBYNYOVWJUXNVWBUAVFUUAWEWMV
      WQVVPVWJUXEUUBUUCZVWSVWAVVPVVBVWHVUTVVOVVPUUDXCVWAVWCVXAVVBVWGVVQVWCVXAVU
      TVVPVWCVXAVVOVWCVVPUXEVWJVWBUUEZVXAVWCVWBUXEUUFZVXBUXEUXNVWBUUGZUXEVWBUUH
      UUIUXEVWJVWBUUJWCYPYPUUKUXEVWJUULWIVWJUXTQYHUUNVWQVWMUXFVWLLZVWHVXEVWPVWH
      UBUXFVWLVWHUBUCVKZUCHVKZMZUCYKUBUFVKZUFOZVWJKZMZUFYKZUBOZUXFKVXNVWLKVWHVX
      HVXMUCVWHVXHVXNUCOZVWBYJZKZVXPVWJKZMZVXMVWGVWCVXGVXOVXPARZPZTZVXHVXSTZVWF
      VYAGVXOUXEGUCVGZUXBVXOVWEVXTVYDUNVYDVWDVXPAUXBVXOVWBUUMWQXTUUOVYBVWCVYCVX
      HVYBVWCVXSVXFVXGVYBVWCVXSTZTVXGVYBVXFVYEVXGVYBVYAVXFVYETVXGVYAUUPVXGVYAVX
      FVYEVXGVYAVXFUUQZVWCVXQVXRVXGVYAVXFVWCVXQTZVYAVXFVYGTZTVXGVYAVXOVXPLZVYHV
      YAVYIVXTVXPLVXPAUVEVXOVXTVXPYQUURVYIVXFVXQVWCVXOVXPVXNUUSUUTVCXHUVAVWCVXC
      VYFVXRVXDVXGVYAVXCVXRTVXFVXCVXGVXRUXEVXOVWBUVBUVCUVDUVFUVGUVHYRUVIUVJUVKU
      VLWCVXLVXSUFVXPVXOVWBUVMVXJVXPPVXIVXQVXKVXRVXJVXPVXNUVNVXJVXPVWJUVOUVPUVR
      UVQUVSUCVXNUXEYSUFVXNVWJYSUVTWLVRVVBVWMVXEUMVWAVWHAUXFVWLYQUWAUWBUWCVPUWD
      VPYTVWNUYBUAUXSVWMEVWJUYAUXQVWJPUXRVWLAUXQVWJWNUWEVOUWFUWHUWIWFUWGUWJUWKV
      PYTYRUWLHABCGDEFUWMUWNUWO $.
  $}

  ${
    $d f t u v w y z B $.  $d f t u v y z X $.
    $( A topology generated by a basis is compact iff open covers drawn from
       the basis have finite subcovers.  (See also ~ alexsub , which further
       specializes to subbases, assuming the ultrafilter lemma.)  (Contributed
       by Mario Carneiro, 26-Aug-2015.) $)
    tgcmp $p |- ( ( B e. TopBases /\ X = U. B ) -> ( ( topGen ` B ) e. Comp <->
      A. y e. ~P B ( X = U. y -> E. z e. ( ~P y i^i Fin ) X = U. z ) ) ) $=
      ( vu vv vw vt wcel cuni wceq wa cv cpw cfn wrex wi wral wss syl ccmp ctop
      vf ctb ctg cfv cin iscmp simprbi unitg eqtr3 sylan eqeq1d rexbidv imbi12d
      eqid ralbidv bastg adantr sspwb sylib ssralv sylbid syl5 elpwi simprr wel
      simprl sselda adantrr tg2 syl2anc reximdva eluni2 elunirab r19.42v rexbii
      crab expr rexcom 3bitr2i 3imtr4g ssrdv eqsstrd ssrab2 unissi simplr eqssd
      syl5sseqr wb elpw2g ad2antrr mpbiri unieq eqeq2d pweq ineq1d rexeqdv mpid
      rspcv wex elfpw ad2antrl simplbi ssrab sseq2 ac6sfi crn frn wfo wfn dffn4
      wf ffn fofi syl2an sylanbrc simplrr ciun uniiun syl5eqss ad2antll fniunfv
      ss2iun sseqtrd unissd sseqtr4d rspcev exlimddv rexlimdvaa com23 ralrimdva
      syld sylan2 tgcl baib bitrd sylibrd impbid ) CUDIZDCJZKZLZCUEUFZUAIZDAMZJ
      ZKZDBMZJZKZBUUFNZOUGZPZQZACNZRZUUEUUDJZUUGKZUURUUJKZBUUMPZQZAUUDNZRZUUCUU
      QUUEUUDUBIZUVDABUUDUURUURUPZUHUIUUCUVDUUOAUVCRZUUQUUCUVBUUOAUVCUUCUUSUUHU
      VAUUNUUCUURDUUGYTUURUUAKUUBUURDKCUDUJUURDUUAUKULZUMUUCUUTUUKBUUMUUCUURDUU
      JUVHUMUNUOUQUUCUUPUVCSZUVGUUQQUUCCUUDSZUVIYTUVJUUBCUDURUSCUUDUTVAUUOAUUPU
      VCVBTVCVDUUCUUQDEMZJZKZDFMZJZKZFUVKNOUGZPZQZEUVCRZUUEUUCUUQUVSEUVCUVKUVCI
      UUCUVKUUDSZUUQUVSQUVKUUDVEUUCUWALUVMUUQUVRUUCUWAUVMUUQUVRQUUCUWAUVMLZLZUU
      QUUKBGMZHMZSZHUVKPZGCVRZNZOUGZPZUVRUWCUUQDUWHJZKZUWKUWCDUWLUWCDUVLUWLUUCU
      WAUVMVFZUWCAUVLUWLUWCAHVGZHUVKPAGVGZUWFLZGCPZHUVKPZUUFUVLIUUFUWLIZUWCUWOU
      WRHUVKUWCHEVGZUWOUWRUWCUXAUWOLLUWEUUDIZUWOUWRUWCUXAUXBUWOUWCUVKUUDUWEUUCU
      WAUVMVHVIVJUWCUXAUWOVFGUWECUUFVKVLVSVMHUUFUVKVNUWTUWPUWGLZGCPUWQHUVKPZGCP
      UWSUWGGUUFCVOUXDUXCGCUWPUWFHUVKVPVQUWQGHCUVKVTWAWBWCWDUWCUUAUWLDUWHCUWGGC
      WEZWFYTUUBUWBWGWIWHUWCUWHUUPIZUUQUWMUWKQZQUWCUXFUWHCSZUXEYTUXFUXHWJUUBUWB
      UWHCUDWKWLWMUUOUXGAUWHUUPUUFUWHKZUUHUWMUUNUWKUXIUUGUWLDUUFUWHWNWOUXIUUKBU
      UMUWJUXIUULUWIOUUFUWHWPWQWRUOWTTWSUWCUUKUVRBUWJUWCUUIUWJIZUUKLZLZUUIUVKUC
      MZXMZUWDUWDUXMUFZSZGUUIRZLZUVRUCUXLUUIOIZUWGGUUIRZUXRUCXAUXJUXSUWCUUKUXJU
      UIUWHSZUXSUUIUWHXBZUIXCZUXLUYAUXTUXJUYAUWCUUKUXJUYAUXSUYBXDXCUYAUUICSUXTU
      WGGCUUIXEUITUWFUXPGHUUIUVKUCUWEUXOUWDXFXGVLUXLUXRLZUXMXHZUVQIZDUYEJZKZUVR
      UYDUYEUVKSZUYEOIZUYFUXNUYIUXLUXQUUIUVKUXMXIXCZUXLUXSUUIUYEUXMXJZUYJUXRUYC
      UXNUYLUXQUXNUXMUUIXKZUYLUUIUVKUXMXNZUUIUXMXLVAUSUUIUYEUXMXOXPUYEUVKXBXQUY
      DDUYGUYDDUUJUYGUWCUXJUUKUXRXRUYDUUJGUUIUXOXSZUYGUXQUUJUYOSUXLUXNUXQUUJGUU
      IUWDXSUYOGUUIXTGUUIUWDUXOYDYAYBUXNUYOUYGKZUXLUXQUXNUYMUYPUYNGUUIUXMYCTXCY
      EWDUYDUYGUVLDUYDUYEUVKUYKYFUWCUVMUXKUXRUWNWLYGWHUVPUYHFUYEUVQUVNUYEKUVOUY
      GDUVNUYEWNWOYHVLYIYJYMVSYKYNYLUUCUUEUURUVLKZUURUVOKZFUVQPZQZEUVCRZUVTUUCU
      VEUUEVUAWJYTUVEUUBCYOUSUUEUVEVUAEFUUDUURUVFUHYPTUUCUYTUVSEUVCUUCUYQUVMUYS
      UVRUUCUURDUVLUVHUMUUCUYRUVPFUVQUUCUURDUVOUVHUMUNUOUQYQYRYS $.
  $}

  ${
    $d s t u v w J $.  $d s t u v w S $.
    $( A closed subset of a compact space is compact.  (Contributed by Jeff
       Hankins, 29-Jun-2009.) $)
    cmpcld $p |- ( ( J e. Comp /\ S e. ( Clsd ` J ) ) ->
                   ( J |`t S ) e. Comp ) $=
      ( vs vt vu vw ccmp wcel wa cv cuni wss cpw cfn wi wceq cun 3ad2ant1 sylib
      cvv vv ccld cfv crest co cin wrex wral vex elpw w3a cdif csn simp1l simp2
      cldopn adantl snssd unssd simp3 uniss 3ad2ant2 sstrd undif unss1 3ad2ant3
      eqid eqsstr3d difss jctir unss uniexg ad2antrr 3adant3 difexg unisng 3syl
      eqssd uneq2d eqtr4d uniun syl6eqr cmpcov syl3anc elfpw simp2l uncom diffi
      syl6sseq ssundif ad2antll sylanbrc wex sseqtrd sselda eluni a1i wn elndif
      simpl simpr ad2antlr eleq2 biimpd imp mtod ex adantrd elsn notbii syl6ibr
      com23 jcad eldif eximdv mpd ssrdv unieq sseq2d rspcev syl3an2b rexlimdv3a
      syl2anc 3exp syl5bi ralrimiv ctop wb cmptop cldss cmpsub syl2an mpbird )
      BGHZABUBUCHZIZBAUDUEGHZACJZKZLZADJZKZLZDYRMNUFZUGZOZCBMZUHZYPUUFCUUGYRUUG
      HYRBLZYPUUFYRBCUIUJYPUUIYTUUEYPUUIYTUKZBKZEJZKZPZEYRUUKAULZUMZQZMNUFZUGZU
      UEUUJYNUUQBLUUKUUQKZPUUSYNYOUUIYTUNUUJYRUUPBYPUUIYTUOUUJUUOBYPUUIUUOBHZYT
      YOUVAYNABUUKUUKVGZUPUQRURUSUUJUUKYSUUPKZQZUUTUUJUUKYSUUOQZUVDUUJUUKUVEUUJ
      UUKAUUOQZUVEUUJAUUKLZUVFUUKPUUJAYSUUKYPUUIYTUTZUUIYPYSUUKLZYTYRBVAVBZVCAU
      UKVDSYTYPUVFUVELUUIAYSUUOVEVFVHUUJUVIUUOUUKLZIUVEUUKLUUJUVIUVKUVJUUKAVIVJ
      YSUUOUUKVKSVRUUJUVCUUOYSUUJUUKTHZUUOTHUVCUUOPYPUUIUVLYTYNUVLYOUUIBGVLVMVN
      UUKATVOUUOTVPVQVSVTYRUUPWAWBUUQBUUKEUVBWCWDUUJUUNUUEEUURUULUURHUUJUULUUQL
      ZUULNHZIZUUNUUEUULUUQWEUUJUVOUUNUKZUULUUPULZUUDHZAUVQKZLZUUEUVPUVQYRLZUVQ
      NHZUVRUVPUULUUPYRQZLUWAUVPUULUUQUWCUUJUVMUVNUUNWFYRUUPWGWIUULUUPYRWJSUUJU
      VOUWBUUNUVNUWBUUJUVMUULUUPWHWKVNUVQYRWEWLUVPUAAUVSUVPUAJZAHZUWDFJZHZUWFUV
      QHZIZFWMZUWDUVSHUVPUWEUWJUVPUWEIZUWGUWFUULHZIZFWMZUWJUWKUWDUUMHUWNUVPAUUM
      UWDUVPAYSUUMUUJUVOYTUUNUVHRUVPYSUUKUUMUUJUVOUVIUUNUVJRUUJUVOUUNUTWNVCWOFU
      WDUULWPSUWKUWMUWIFUWKUWMUWGUWHUWMUWGOUWKUWGUWLWTWQUWKUWMUWLUWFUUPHZWRZIUW
      HUWKUWMUWLUWPUWMUWLOUWKUWGUWLXAWQUWKUWMUWFUUOPZWRZUWPUWKUWGUWRUWLUWKUWGUW
      RUWKUWGIUWQUWDUUOHZUWEUWSWRUVPUWGUWDAUUKWSXBUWKUWGUWQUWSOUWKUWQUWGUWSUWQU
      WGUWSOOUWKUWQUWGUWSUWFUUOUWDXCXDWQXLXEXFXGXHUWOUWQFUUOXIXJXKXMUWFUULUUPXN
      XKXMXOXPXGFUWDUVQWPXKXQUUCUVTDUVQUUDUUAUVQPUUBUVSAUUAUVQXRXSXTYCYAYBXPYDY
      EYFYNBYGHUVGYQUUHYHYOBYIABUUKUVBYJABUUKCDUVBYKYLYM $.
  $}

  ${
    $d c d m n r s J $.  $d c d m n r s S $.  $d c d m n r s T $.
    $d c d m n r s X $.
    uncmp.1 $e |- X = U. J $.
    $( The union of two compact sets is compact.  (Contributed by Jeff Hankins,
       30-Jan-2010.) $)
    uncmp $p |- ( ( ( J e. Top /\ X = ( S u. T ) ) /\
      ( ( J |`t S ) e. Comp /\ ( J |`t T ) e. Comp ) ) -> J e. Comp ) $=
      ( vc vd vn vs vm vr wcel wceq wa cv cuni cfn wrex wi wss ctop cun co ccmp
      crest cpw cin simpll wb ssun1 sseq2 mpbiri ad2antlr cmpsub syl2anc simprr
      wral sseqtrd unieq sseq2d pweq ineq1d rexeqdv imbi12d rspcv ad2antrl mpid
      sylbid ssun2 reeanv elin simplbi elpwid anim12i unss sylib simprbi syl2an
      unfi jca vex elpw2 anbi1i bitr2i simpllr ssun3 ad2antll eqsstrd syl6sseqr
      ssun4 uniun elpwi adantr sstrd uniss eqssd eqeq2d exp32 rexlimdvv syl5bir
      syl rspcev syl2and impancom exp3a ralrimiv iscmp sylanbrc ) CUALZDABUBZMZ
      NZCAUEUCUDLZCBUEUCUDLZNZNZXIDFOZPZMZDGOZPZMZGXQUFZQUGZRZSZFCUFZUQCUDLXIXK
      XOUHXPYFFYGXPXQYGLZXSYEXLYHXSNZXOYEXLYINZXMAHOZPZTZHYDRZXNBIOZPZTZIYDRZYE
      YJXMAJOZPZTZYMHYSUFZQUGZRZSZJYGUQZYNYJXIADTZXMUUFUIXIXKYIUHZXKUUGXIYIXKUU
      GAXJTABUJDXJAUKULUMZACDJHEUNUOYJUUFAXRTZYNYJADXRUUIXLYHXSUPZURYHUUFUUJYNS
      ZSXLXSUUEUULJXQYGYSXQMZUUAUUJUUDYNUUMYTXRAYSXQUSUTUUMYMHUUCYDUUMUUBYCQYSX
      QVAVBVCVDVEVFVGVHYJXNBKOZPZTZYQIUUNUFZQUGZRZSZKYGUQZYRYJXIBDTZXNUVAUIUUHX
      KUVBXIYIXKUVBBXJTBAVIDXJBUKULUMZBCDKIEUNUOYJUVABXRTZYRYJBDXRUVCUUKURYHUVA
      UVDYRSZSXLXSUUTUVEKXQYGUUNXQMZUUPUVDUUSYRUVFUUOXRBUUNXQUSUTUVFYQIUURYDUVF
      UUQYCQUUNXQVAVBVCVDVEVFVGVHYNYRNYMYQNZIYDRHYDRYJYEYMYQHIYDYDVJYJUVGYEHIYD
      YDYJYKYDLZYOYDLZNZUVGYEYJUVJUVGNZNZYKYOUBZYDLZDUVMPZMZYEUVLUVMXQTZUVMQLZN
      ZUVNUVLUVQUVRUVLYKXQTZYOXQTZNZUVQUVJUWBYJUVGUVHUVTUVIUWAUVHYKXQUVHYKYCLZY
      KQLZYKYCQVKZVLVMUVIYOXQUVIYOYCLZYOQLZYOYCQVKZVLVMVNVFYKYOXQVOVPZUVJUVRYJU
      VGUVHUWDUWGUVRUVIUVHUWCUWDUWEVQUVIUWFUWGUWHVQYKYOVSVRVFVTUVNUVMYCLZUVRNUV
      SUVMYCQVKUWJUVQUVRUVMXQFWAWBWCWDVPUVLDUVOUVLDYLYPUBZUVOUVLDXJUWKXIXKYIUVK
      WEUVLAUWKTZBUWKTZNZXJUWKTUVGUWNYJUVJYMUWLYQUWMAYLYPWFBYPYLWJVNWGABUWKVOVP
      WHYKYOWKWIUVLUVMCTZUVODTUVLUVMXQCUWIYIXQCTZXLUVKYHUWPXSXQCWLWMUMWNUWOUVOC
      PDUVMCWOEWIXAWPYBUVPGUVMYDXTUVMMYAUVODXTUVMUSWQXBUOWRWSWTXCXDXEXFFGCDEXGX
      H $.
  $}

  ${
    $d t x y z A $.  $d t y z B $.  $d t x y z J $.
    fiuncmp.1 $e |- X = U. J $.
    $( A finite union of compact sets is compact.  (Contributed by Mario
       Carneiro, 19-Mar-2015.) $)
    fiuncmp $p |- ( ( J e. Top /\ A e. Fin /\ A. x e. A ( J |`t B ) e. Comp )
      -> ( J |`t U_ x e. A B ) e. Comp ) $=
      ( vt ctop wcel crest co ccmp wss ciun wi c0 wceq oveq2d eleq1d cvv vy cfn
      vz wral w3a ssid simp2 cv csn cun sseq1 iuneq1 0iun syl6eq imbi12d imbi2d
      rest0 0cmp syl6eqel 3ad2ant1 a1d ssun1 id syl5ss imim1i wa cin csb simpl1
      cuni iunxun simprr cmptop restrcl simprd 3syl nfcv nfcsb1v csbeq1a cbviun
      vex csbeq1 iunxsn eqtri ssun2 simprl snss sylibr simpl3 nfov nfel1 cbvral
      nfv sylib rspcv sylc syl5eqel syl2anc resttop eqid restin unieqd sseqtr4i
      unexg inss2 restuni sylancl eqtr4d uneq2i indir inss1 a1i restabs syl3anc
      ineq1i sstri eqeltrd eqsstr3i uncmp syl22anc exp32 a2d syl5 a2i findcard2
      mpcom mpi ) DHIZBUBIZDCJKZLIZABUDZUEZBBMZDABCNZJKZLIZBUFYIYMYNYQOZYHYIYLU
      GYMGUHZBMZDAYSCNZJKZLIZOZOYMPBMZDPJKZLIZOZOYMUAUHZBMZDAUUICNZJKZLIZOZOZYM
      UUIUCUHZUIZUJZBMZDAUURCNZJKZLIZOZOZYMYROGUAUCBYSPQZUUDUUHYMUVEYTUUEUUCUUG
      YSPBUKUVEUUBUUFLUVEUUAPDJUVEUUAAPCNPAYSPCULACUMUNRSUOUPYSUUIQZUUDUUNYMUVF
      YTUUJUUCUUMYSUUIBUKUVFUUBUULLUVFUUAUUKDJAYSUUICULRSUOUPYSUURQZUUDUVCYMUVG
      YTUUSUUCUVBYSUURBUKUVGUUBUVALUVGUUAUUTDJAYSUURCULRSUOUPYSBQZUUDYRYMUVHYTY
      NUUCYQYSBBUKUVHUUBYPLUVHUUAYODJAYSBCULRSUOUPYMUUGUUEYHYIUUGYLYHUUFPUILDUQ
      URUSUTVAUUOUVDOUUIUBIYMUUNUVCUUNUUSUUMOYMUVCUUSUUJUUMUUSUUIUURBUUIUUQVBUU
      SVCVDVEYMUUSUUMUVBYMUUSUUMUVBYMUUSUUMVFZVFZUVAHIZUVAVJZUUKDVJZVGZAUUPCVHZ
      UVMVGZUJZQUVAUVNJKZLIUVAUVPJKZLIUVBUVJYHUUTTIZUVKYHYIYLUVIVIZUVJUUTUUKAUU
      QCNZUJZTAUUIUUQCVKZUVJUUKTIZUWBTIUWCTIUVJUUMUULHIZUWEYMUUSUUMVLZUULVMUWFD
      TIZUWEUUKDVNVOVPZUVJUWBUVOTUWBGUUQAYSCVHZNUVOAGUUQCUWJGCVQAYSCVRZAYSCVSZV
      TGUUPUWJUVOUCWAZAYSUUPCWBZWCWDZUVJDUVOJKZLIZUWPHIZUVOTIZUVJUUPBIZDUWJJKZL
      IZGBUDZUWQUVJUUQBMUWTUVJUUQUURBUUQUUIWEYMUUSUUMWFVDUUPBUWMWGWHUVJYLUXCYHY
      IYLUVIWIYKUXBAGBYKGWMAUXALADUWJJADVQAJVQUWKWJWKAUHYSQZYJUXALUXDCUWJDJUWLR
      SWLWNUXBUWQGUUPBYSUUPQZUXAUWPLUXEUWJUVODJUWNRSWOWPZUWPVMUWRUWHUWSUVODVNVO
      VPZWQUUKUWBTTXDWRWQZUUTDTWSWRUVJUVLUUTUVMVGZUVQUVJUVLDUXIJKZVJZUXIUVJUVAU
      XJUVJYHUVTUVAUXJQUWAUXHUUTDHTUVMUVMWTZXAWRXBUVJYHUXIEMUXIUXKQUWAUXIUVMEUU
      TUVMXEFXCUXIDEFXFXGXHUXIUUKUVOUJZUVMVGUVQUUTUXMUVMUUTUWCUXMUWDUWBUVOUUKUW
      OXIWDXOUUKUVOUVMXJWDUNUVJUVRUULLUVJUVRDUVNJKZUULUVJYHUVNUUTMZUVTUVRUXNQUW
      AUXOUVJUVNUUKUUTUUKUVMXKUUKUWCUUTUUKUWBVBUWDXCXPXLUXHUVNUUTDHTXMXNUVJYHUW
      EUULUXNQUWAUWIUUKDHTUVMUXLXAWRXHUWGXQUVJUVSUWPLUVJUVSDUVPJKZUWPUVJYHUVPUU
      TMZUVTUVSUXPQUWAUXQUVJUVPUVOUUTUVOUVMXKUVOUWBUUTUWOUWBUWCUUTUWBUUKWEUWDXC
      XRXPXLUXHUVPUUTDHTXMXNUVJYHUWSUWPUXPQUWAUXGUVODHTUVMUXLXAWRXHUXFXQUVNUVPU
      VAUVLUVLWTXSXTYAYBYCYDXLYEYFYG $.
  $}

  ${
    $d x y J $.  $d x y K $.  $d x y X $.  $d x y Y $.
    sscmp.1 $e |- X = U. K $.
    $( A subset of a compact topology (i.e. a coarser topology) is compact.
       (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    sscmp $p |- ( ( J e. ( TopOn ` X ) /\ K e. Comp /\ J C_ K ) ->
      J e. Comp ) $=
      ( vx vy ctopon cfv wcel ccmp wss w3a ctop cuni cv wceq cpw cfn wrex wa wi
      cin wral topontop 3ad2ant1 elpwi simpl2 simprl simpl3 simpl1 toponuni syl
      sstrd simprr eqtrd cmpcov syl3anc eqeq1d mpbid expr sylan2 ralrimiva eqid
      rexbidv iscmp sylanbrc ) ACGHIZBJIZABKZLZAMIZANZEOZNZPZVLFONZPZFVMQRUBZSZ
      UAZEAQZUCAJIVGVHVKVICAUDUEVJVTEWAVMWAIVJVMAKZVTVMAUFVJWBVOVSVJWBVOTZTZCVP
      PZFVRSZVSWDVHVMBKCVNPWFVGVHVIWCUGWDVMABVJWBVOUHVGVHVIWCUIUMWDCVLVNWDVGCVL
      PVGVHVIWCUJCAUKULZVJWBVOUNUOVMBCFDUPUQWDWEVQFVRWDCVLVPWGURVDUSUTVAVBEFAVL
      VLVCVEVF $.
  $}

  ${
    $d f w x y z A $.  $d f w x y z J $.  $d f w x y z ph $.  $d f w x y z S $.
    $d f x z O $.  $d f w x y z X $.
    hauscmp.1 $e |- X = U. J $.
    ${
      hauscmplem.2 $e |- O = { y e. J |
        E. w e. J ( A e. w /\ ( ( cls ` J ) ` w ) C_ ( X \ y ) ) } $.
      hauscmplem.3 $e |- ( ph -> J e. Haus ) $.
      hauscmplem.4 $e |- ( ph -> S C_ X ) $.
      hauscmplem.5 $e |- ( ph -> ( J |`t S ) e. Comp ) $.
      hauscmplem.6 $e |- ( ph -> A e. ( X \ S ) ) $.
      $( Lemma for ~ hauscmp .  (Contributed by Mario Carneiro,
         27-Nov-2013.) $)
      hauscmplem $p |- ( ph ->
        E. z e. J ( A e. z /\ ( ( cls ` J ) ` z ) C_ ( X \ S ) ) ) $=
        ( wss wcel wa c0 wceq vx cuni cpw cfn cin wrex ccl cfv cdif w3a cha wne
        vf cv adantr sselda eldifad wn id eldifbd nelne2 syl2anr hausnei 3anass
        syl13anc wb elssuni syl6sseqr adantl incom eqeq1i reldisj syl5bb syl wi
        ccld ctop haustop opncld sylan clsss2 ex sylbid anim2d reximdva r19.42v
        syl5bi syl6ib mpd crab unieqi eleq2i elunirab bitri sylibr ssrdv ssrab2
        wral eqsstri elpw2g mpbiri crest co cmpsub biimp3a syl3anc unieq sseq2d
        ccmp ineq1d rexeqdv syl2anc ad3antrrr syl6eq eleq2 fveq2 sseq1d anbi12d
        pweq rspcev syl12anc sylbi ad2antlr cint ad2antrl simpl syl2an ad2antll
        simprbi ciin eliin ralrimiva adantrr ssel ral2imi ax-mp 3imtr4g eqsstrd
        cvv sstrd imbi12d rspcva topopn clstop simplr uni0 sseqtrd difeq2d dif0
        ss0 eqtr4d eqimss wf elin elpwi sseld difeq2 anbi2d rexbidv elrab2 syl6
        wex ralrimiv ac6sfi crn frn simprr cdm dm0rn0 eqeq1d syl5rbbr necon3bid
        fdm biimpac wfo wfn ffn dffn4 fofi fiinopn imp ralimi mpbird cab fnrnfv
        sylib inteqd fvex dfiin2 syl6eqr eleqtrrd ad4antr ffvelrn clscld iincld
        adantll sscls ciun iindif2 simplrl uniiun sseq2i sscon exlimddv anassrs
        vex pm2.61dane rexlimdva ) AFUAUNZUBZPZUAHUCZUDUEZUFZECUNZQZUXOGUGUHZUH
        ZIFUIZPZRZCGUFZAFHUBZPZUXNAUAFUYCAUXIFQZUXIUYCQZAUYERZUXIBUNZQZEDUNZQZU
        YJUXQUHZIUYHUIZPZRZDGUFZRZBGUFZUYFUYGUYIUYKUYHUYJUEZSTZUJZDGUFZBGUFZUYR
        UYGGUKQZUXIIQEIQZUXIEULZVUCAVUDUYELUOZAFIUXIMUPAVUEUYEAEIFOUQZUOUYEUYEE
        FQURVUFAUYEUSAEIFOUTUXIEFVAVBUXIEDBGIJVCVEUYGVUBUYQBGUYGUYHGQZRZVUBUYIU
        YORZDGUFUYQVUJVUAVUKDGVUAUYIUYKUYTRZRVUJUYJGQZRZVUKUYIUYKUYTVDVUNVULUYO
        UYIVUNUYTUYNUYKVUNUYTUYJUYMPZUYNVUNUYJIPZUYTVUOVFVUMVUPVUJVUMUYJGUBZIUY
        JGVGJVHVIUYTUYJUYHUEZSTVUPVUOUYSVURSUYHUYJVJVKUYJUYHIVLVMVNVUNUYMGVPUHZ
        QZVUOUYNVOVUJVUTVUMUYGGVQQZVUIVUTUYGVUDVVAVUGGVRZVNUYHGIJVSVTUOVUTVUOUY
        NUYMUYJGIJWAWBVNWCWDWDWGWEUYIUYODGWFWHWEWIUYFUXIUYPBGWJZUBZQUYRUYCVVDUX
        IHVVCKWKWLUYPBUXIGWMWNWOWBWPAHGUCZQZFUXOUBZPZUXKUAUXOUCZUDUEZUFZVOZCVVE
        WRZUYDUXNVOZAVVFHGPZHVVCGKUYPBGWQWSAVUDVVFVVOVFLHGUKWTVNXAAVVAFIPZGFXBX
        CXIQZVVMAVUDVVALVVBVNZMNVVAVVPVVQVVMFGICUAJXDXEXFVVLVVNCHVVEUXOHTZVVHUY
        DVVKUXNVVSVVGUYCFUXOHXGXHVVSUXKUAVVJUXMVVSVVIUXLUDUXOHXSXJXKUUAUUBXLWIA
        UXKUYBUAUXMAUXIUXMQZRZUXKUYBVWAUXKRZUYBUXISVWBUXISTZRZIGQZVUEIUXQUHZUXS
        PZUYBVWDVVAVWEAVVAVVTUXKVWCVVRXMZGIJUUCVNAVUEVVTUXKVWCVUHXMVWDVWFUXSTVW
        GVWDVWFIUXSVWDVVAVWFITVWHGIJUUDVNVWDUXSISUIIVWDFSIVWDFSPFSTVWDFUXJSVWAU
        XKVWCUUEVWCUXJSTVWBVWCUXJSUBSUXISXGUUFXNVIUUGFUUJVNUUHIUUIXNUUKVWFUXSUU
        LVNUYAVUEVWGRCIGUXOITZUXPVUEUXTVWGUXOIEXOVWIUXRVWFUXSUXOIUXQXPXQXRXTYAV
        WAUXKUXISULZUYBVWAUXKVWJRZRZUXIGUMUNZUUMZEUXOVWMUHZQZVWOUXQUHZIUXOUIZPZ
        RZCUXIWRZRZUYBUMVVTVXBUMUVBZAVWKVVTUXIUXLQZUXIUDQZRVXCUXIUXLUDUUNZVXEVX
        EUYKUYLVWRPZRZDGUFZCUXIWRVXCVXDVXEUSVXDVXICUXIVXDUXOUXIQZUXOHQZVXIVXDUX
        IHUXOUXIHUUOUUPVXKUXOGQVXIUYPVXIBUXOGHUYHUXOTZUYOVXHDGVXLUYNVXGUYKVXLUY
        MVWRUYLUYHUXOIUUQXHUURUUSKUUTYIUVAUVCVXHVWTCDUXIGUMUYJVWOTZUYKVWPVXGVWS
        UYJVWOEXOVXMUYLVWQVWRUYJVWOUXQXPXQXRUVDVBYBYCVWLVXBRZVWMUVEZYDZGQZEVXPQ
        ZVXPUXQUHZUXSPZUYBVXNVVAVXOGPZVXOSULZVXOUDQZVXQAVVAVVTVWKVXBVVRXMVWNVYA
        VWLVXAUXIGVWMUVFYEVWLVWJVWNVYBVXBVWAUXKVWJUVGZVWNVXAYFVWNVWJVYBVWNUXISV
        XOSVXOSTVWMUVHZSTVWNVWCVWMUVIVWNVYEUXISUXIGVWMUVMUVJUVKUVLUVNYGVWLVXEUX
        IVXOVWMUVOZVYCVXBVVTVXEAVWKVVTVXDVXEVXFYIYCVWNVYFVXAVWNVWMUXIUVPZVYFUXI
        GVWMUVQZUXIVWMUVRUWFUOUXIVXOVWMUVSYGVVAVYAVYBVYCUJVXQVXOGUVTUWAVEVXNECU
        XIVWOYJZVXPVXNEVYIQZVWPCUXIWRZVXAVYKVWLVWNVWTVWPCUXIVWPVWSYFUWBYHVXNEUX
        SQZVYJVYKVFAVYLVVTVWKVXBOXMCEUXIVWOUXSYKVNUWCVXNVYGVXPVYITVWNVYGVWLVXAV
        YHYEVYGVXPUYHVWOTCUXIUFBUWDZYDVYIVYGVXOVYMCBUXIVWMUWEUWGCBUXIVWOUXOVWMU
        WHUWIUWJVNZUWKVXNVXSCUXIVWQYJZUXSVXNVYOVUSQZVXPVYOPVXSVYOPVXNVWJVWQVUSQ
        ZCUXIWRZVYPVWLVWJVXBVYDUOZVWLVWNVYRVXAVWLVWNRZVYQCUXIVYTVXJRZVVAVWOIPZV
        YQAVVAVVTVWKVWNVXJVVRUWLZWUAVWOVUQIWUAVWOGQZVWOVUQPVWNVXJWUDVWLUXIGUXOV
        WMUWMUWPVWOGVGVNJVHZVWOGIJUWNXLYLYMCUXIVWQGUWOXLVXNVXPVYIVYOVYNVWLVWNVY
        IVYOPZVXAVYTVWOVWQPZCUXIWRZWUFVYTWUGCUXIWUAVVAWUBWUGWUCWUEVWOGIJUWQXLYL
        WUHBVYIVYOWUHUYHVWOQZCUXIWRZUYHVWQQZCUXIWRZUYHVYIQZUYHVYOQZWUGWUIWUKCUX
        IVWOVWQUYHYNYOUYHYSQZWUMWUJVFBUXFZCUYHUXIVWOYSYKYPWUOWUNWULVFWUPCUYHUXI
        VWQYSYKYPZYQWPVNYMYRVYOVXPGIJWAXLVXNVYOCUXIVWRYJZUXSVXAVYOWURPVWLVWNVXA
        BVYOWURVXAWULUYHVWRQZCUXIWRZWUNUYHWURQZVWTWUKWUSCUXIVWSWUKWUSVOVWPVWQVW
        RUYHYNVIYOWUQWUOWVAWUTVFWUPCUYHUXIVWRYSYKYPYQWPYHVXNWURICUXIUXOUWRZUIZU
        XSVXNVWJWURWVCTVYSCUXIIUXOUWSVNVXNUXKWVCUXSPZVWAUXKVWJVXBUWTUXKFWVBPWVD
        UXJWVBFCUXIUXAUXBFWVBIUXCYBVNYRYTYTUYAVXRVXTRCVXPGUXOVXPTZUXPVXRUXTVXTU
        XOVXPEXOWVEUXRVXSUXSUXOVXPUXQXPXQXRXTYAUXDUXEUXGWBUXHWI $.
    $}

    $( A compact subspace of a T2 space is closed.  (Contributed by Jeff
       Hankins, 16-Jan-2010.)  (Proof shortened by Mario Carneiro,
       14-Dec-2013.) $)
    hauscmp $p |- ( ( J e. Haus /\ S C_ X /\
                    ( J |`t S ) e. Comp ) -> S e. ( Clsd ` J ) ) $=
      ( vx vz vy vw cha wcel wss cfv cdif wel cv wa wrex wi syl wb crest co w3a
      ccmp ccld simp2 wral crab eqid simpl1 simpl2 simpl3 simpr hauscmplem ctop
      ccl haustop 3ad2ant1 elssuni syl6sseqr sscls syl2an sstr2 anim2d reximdva
      cuni adantr mpd ralrimiva eltop2 mpbird iscld mpbir2and ) BIJZACKZBAUAUBU
      DJZUCZABUELJZVOCAMZBJZVNVOVPUFVQVTEFNZFOZVSKZPZFBQZEVSUGZVQWEEVSVQEOZVSJZ
      PZWAWBBUPLZLZVSKZPZFBQZWEWIGFHWGABEHNHOWJLCGOMKPHBQGBUHZCDWOUIVNVOVPWHUJV
      NVOVPWHUKVNVOVPWHULVQWHUMUNVQWNWERWHVQWMWDFBVQWBBJZPZWLWCWAWQWBWKKZWLWCRV
      QBUOJZWBCKWRWPVNVOWSVPBUQURZWPWBBVFCWBBUSDUTWBBCDVAVBWBWKVSVCSVDVEVGVHVIV
      QWSVTWFTWTEFVSBVJSVKVQWSVRVOVTPTWTABCDVLSVM $.
  $}

  ${
    $d c r s u v w x y z J $.
    $( If a topology is compact and a collection of closed sets has the finite
       intersection property, its intersection is nonempty.  (Contributed by
       Jeff Hankins, 25-Aug-2009.)  (Proof shortened by Mario Carneiro,
       1-Sep-2015.) $)
    cmpfi $p |- ( J e. Top -> ( J e. Comp <-> A. x e. ~P ( Clsd ` J )
                  ( -. (/) e. ( fi ` x ) -> |^| x =/= (/) ) ) ) $=
      ( vy vz vr wcel cv wceq cfn wrex c0 cdif cint wne wss wb cvv adantl syl
      wa vw vv ctop cuni cpw cin wi wral cmpt cima cfi cfv ccmp ccld elpwi ciin
      wn 0ss 0fin elfpw mpbir2an simprr simprl unieqd eqtrd unieq eqeq2d rspcev
      sylancr expr vn0 iineq1 0iin syl6eq eqeq1d necon3bbid mpbiri pm2.21d 2thd
      uniss ad2antlr eqss baib eqcom ssdif0 3bitr3g ciun iindif2 uniiun difeq2i
      syl6eqr bitr4d imassrn cres df-ima resmpt rneqd syl5eq ad2antrr syl5sseqr
      crn wfun funmpt simprbi imafi sylanbrc eqid topopn difexg ralrimivw fnmpt
      wfn ad3antrrr simpr simpld sseqtrd simprd fipreima syl3anc rexbii rexxfrd
      sylib inteqd 0ex wfo wf1o opncldf1 f1ofo sylibr a1i eldifsn bitri dfiin3g
      ccnv bitrd neeq1d syl6bbr imbi12d adantr wex forn syl5sseq fvex elpw2 csn
      elfi wo cun inundif rexeqi rexun bitr3i inss2 sseli elsni biimpd rexlimiv
      uni0 ssid syl6eqss eqssd eqtr3d syl6eqel pwfi pwuni ssfi sylancl syl5 idd
      syl2anc jaod impbid1 syl5bb eldifi simpllr unissd 3eqtr2d rexbidva imaeq2
      olc sstrd ima0 necomd necon2i rbaibr pm5.32ri rexbii2 3bitr4rd pm2.61dane
      int0 eqtr4d imbi1d con1b syl6bb sylan2 ralbidva iscmp simpl foima syl5ibr
      nne sseq2d imp ssimaexg df-rex vex elpw anbi1i exbii fveq2d eleq2d notbid
      ralxfrd 3bitr4d ) BUCFZBUDZCGZUDZHZUXPDGZUDZHZDUXQUEIUFZJZUGZCBUEZUHZKEBU
      XPEGZLZUIZUXQUJZUKULZFZUQZUYKMZKNZUGZCUYFUHBUMFZKAGZUKULZFZUQZUYSMZKNZUGZ
      ABUNULZUEZUHUXOUYEUYQCUYFUXQUYFFZUXOUXQBOZUYEUYQPUXQBUOUXOVUITZUYEUYPUQZU
      YMUGZUYQVUJUYEEUXQUYIUPZKHZUYMUGZVULVUJUYEVUOPUXQKVUJUXQKHZTZUYEVUOVUJVUP
      UXSUYDVUJVUPUXSTTZKUYCFZUXPKUDZHZUYDVUSKUXQOKIFUXQURUSKUXQUTVAVURUXPUXRVU
      TVUJVUPUXSVBVURUXQKVUJVUPUXSVCVDVEUYBVVADKUYCUXTKHZUYAVUTUXPUXTKVFVGVHVIV
      JVUQVUNUYMVUQVUNUQQKNZVKVUQVUNQKVUQVUMQKVUQVUMEKUYIUPZQVUPVUMVVDHVUJEUXQK
      UYIVLREUYIVMVNVOVPVQVRVSVUJUXQKNZTZUXSVUNUYDUYMVVFUXSUXPUXRLZKHZVUNVVFUXR
      UXPHZUXPUXROZUXSVVHVVFUXRUXPOZVVIVVJPVUIVVKUXOVVEUXQBVTZWAVVIVVKVVJUXRUXP
      WBWCSUXRUXPWDUXPUXRWEWFVVFVUMVVGKVVFVUMUXPEUXQUYHWGZLZVVGVVEVUMVVNHVUJEUX
      QUXPUYHWHRUXRVVMUXPEUXQWIWJWKVOWLVVFKUAGZMZHZUAUYKUEIUFZJZKEUXQUYIUIZUXTU
      JZMZHZDUYCJZUYMUYDVVFVVQVWCUADVWAVVRUYCVVFUXTUYCFZTZVWAUYKOVWAIFZVWAVVRFV
      WFVVTXAZVWAUYKVVTUXTWMVUJUYKVWHHZVVEVWEVUJUYKUYJUXQWNZXAVWHUYJUXQWOVUJVWJ
      VVTVUIVWJVVTHUXOEBUXQUYIWPRWQWRZWSWTVWFVVTXBUXTIFZVWGEUXQUYIXCVWEVWLVVFVW
      EUXTUXQOZVWLUXTUXQUTZXDRVVTUXTXEVIVWAUYKUTXFVVFVVOVVRFZTZVWAVVOHZDUYCJZVV
      OVWAHZDUYCJVWPVVTUXQXLZVVOVWHOVVOIFZVWRUXOVWTVUIVVEVWOUXOUYIQFZEUXQUHZVWT
      UXOVXBEUXQUXOUXPBFVXBBUXPUXPXGZXHUXPUYHBXISZXJZEUXQUYIVVTQVVTXGXKSXMVWPVV
      OUYKVWHVWPVVOUYKOZVXAVWPVWOVXGVXATVVFVWOXNVVOUYKUTYBZXOVUJVWIVVEVWOVWKWSX
      PVWPVXGVXAVXHXQVVOUXQVVTDXRXSVWQVWSDUYCVWAVVOWDXTYBVVFVWSTZVVPVWBKVXIVVOV
      WAVVFVWSXNYCVGYAVVFKQFUYKVUGFZUYMVVSPYDUXOVXJVUIVVEUXOUYKVUFOVXJUXOUYJXAZ
      UYKVUFUYJUXQWMUXOBVUFUYJYEZVXKVUFHUXOBVUFUYJYFZVXLUXOVXMUYJYNUBVUFUXPUBGL
      UIHUBEUYJBUXPVXDUYJXGYGXOBVUFUYJYHSZBVUFUYJUUASUUBUYKVUFBUNUUCUUDYIZWSUAK
      UYKQVUGUUFVIVVFUYDVWCDUYCKUUEZLZJZVWDVVFUYDUYBDVXQJZVXRUYDUYBDUYCVXPUFZJZ
      VXSUUGZVVFVXSUYDUYBDVXTVXQUUHZJVYBUYBDVYCUYCUYCVXPUUIUUJUYBDVXTVXQUUKUULV
      VFVYBVXSVVFVYAVXSVXSVYAUXPKHZVVFVXSUYBVYDDVXTUXTVXTFZUYBVYDVYEUYAKUXPVYEU
      YAVUTKVYEUXTKVYEUXTVXPFVVBVXTVXPUXTUYCVXPUUMUUNUXTKUUOSVDUURVNVGUUPUUQVUJ
      VVEVYDVXSVUJVVEVYDTZTZUXQVXQFZUXSVXSVYGUXQUYCFZVVEVYHVYGUXQUXQOZUXQIFZVYI
      VYJVYGUXQUUSYJVYGUXRUEZIFZUXQVYLOVYKVYGUXRIFVYMVYGUXRKIVYGUXPUXRKVYGUXPUX
      RVYGUXPKUXRVUJVVEVYDVBZUXRURUUTVUIVVKUXOVYFVVLWAUVAZVYNUVBUSUVCUXRUVDYBUX
      QUVEVYLUXQUVFUVGUXQUXQUTXFVUJVVEVYDVCUXQUYCKYKXFVYOUYBUXSDUXQVXQUXTUXQHUY
      AUXRUXPUXTUXQVFVGVHUVJVJUVHVVFVXSUVIUVKVXSVYAUVTUVLUVMVVFUYBVWCDVXQVVFUXT
      VXQFZTZUYBKUXPUYALZHZVWCVYQUYAUXPHZUXPUYAOZUYBVYSVYQUYAUXPOZVYTWUAPVYQUXT
      BVYQUXTUXQBVYQVWMVWLVYQVWEVWMVWLTVYPVWEVVFUXTUYCVXPUVNRVWNYBXOZUXOVUIVVEV
      YPUVOUWAUVPVYTWUBWUAUYAUXPWBWCSUYAUXPWDWUAVYRKHVYSUXPUYAWEVYRKWDYLWFVYQVW
      BVYRKVYQVWBUXPEUXTUYHWGZLZVYRVYQVWBEUXTUYIUIZXAZMZEUXTUYIUPZWUEVYQVWAWUGV
      YQVWAVVTUXTWNZXAWUGVVTUXTWOVYQWUJWUFVYQVWMWUJWUFHWUCEUXQUXTUYIWPSWQWRYCVY
      QVXBEUXTUHZWUIWUHHUXOWUKVUIVVEVYPUXOVXBEUXTVXEXJXMEUXTUYIQYMSVYQUXTKNZWUI
      WUEHVYPWULVVFVYPVWEWULUXTUYCKYKZXDREUXTUXPUYHWHSUVQUYAWUDUXPEUXTWIWJWKVGW
      LUVRYOVWCVWCDUYCVXQVWCVWEVYPVWCWULVWEVYPPUXTKKVWBVVBVWBKVVBVWBKNVVCVKVVBV
      WBQKVVBVWBKMQVVBVWAKVVBVWAVVTKUJKUXTKVVTUVSVVTUWBVNYCUWJVNYPVQUWCUWDVYPVW
      EWULWUMUWESUWFUWGYQUWHYRUWIVUJVUNVUKUYMVUJVUNUYOKHVUKVUJVUMUYOKVUJVUMVWHM
      ZUYOVUJVXCVUMWUNHUXOVXCVUIVXFYSEUXQUYIQYMSVUJUYKVWHVWKYCUWKVOUYOKUXAYQUWL
      YOUYPUYMUWMUWNUWOUWPUYRUXOUYGCDBUXPVXDUWQWCUXOVUEUYQACUYKVUGUYFUXOVXJVUHV
      XOYSUXOUYSVUGFZTZVUIUYSUYKHZTZCYTZWUQCUYFJZWUPUXOUYJXBZUYSUYJBUJZOZWUSUXO
      WUOUWRWVAWUPEBUYIXCYJUXOWUOWVCWUOWVCUXOUYSVUFOUYSVUFUOUXOWVBVUFUYSUXOVXLW
      VBVUFHVXNBVUFUYJUWSSUXBUWTUXCCBUYSUCUYJUXDXSWUTVUHWUQTZCYTWUSWUQCUYFUXEWV
      DWURCVUHVUIWUQUXQBCUXFUXGUXHUXIYLYIUXOWUQTZVUBUYNVUDUYPWVEVUAUYMWVEUYTUYL
      KWVEUYSUYKUKUXOWUQXNZUXJUXKUXLWVEVUCUYOKWVEUYSUYKWVFYCYPYRUXMUXN $.
  $}

  ${
    $d J x $.  $d X x $.
    $( In a compact topology, a system of closed sets with nonempty finite
       intersections has a nonempty intersection.  (Contributed by Stefan
       O'Rear, 22-Feb-2015.) $)
    cmpfii $p |- ( ( J e. Comp /\ X C_ ( Clsd ` J ) /\ -. (/) e. ( fi ` X ) )
        -> |^| X =/= (/) ) $=
      ( vx ccmp wcel ccld cfv wss c0 cfi wn cint wne cv wral fvex elpw2 biimpri
      cpw wi ctop wb cmptop cmpfi syl ibi wceq fveq2 eleq2d notbid inteq neeq1d
      imbi12d rspcva syl2anr 3impia ) ADEZBAFGZHZIBJGZEZKZBLZIMZUSBURSZEZICNZJG
      ZEZKZVGLZIMZTZCVEOZVBVDTZUQVFUSBURAFPQRUQVNUQAUAEUQVNUBAUCCAUDUEUFVMVOCBV
      EVGBUGZVJVBVLVDVPVIVAVPVHUTIVGBJUHUIUJVPVKVCIVGBUKULUMUNUOUP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Bolzano-Weierstrass theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d b f o x z A $.  $d a b f o x z J $.  $d a b f o x z X $.
    bwt2.1 $e |- X = U. J $.
    $( The glorious Bolzano-Weierstrass theorem.  Certainly the first general
       topology theorem ever proved.  In his course Weierstrass called it a
       lemma.  He certainly didn't know how famous this theorem would be.  He
       used an euclidian space instead of a general compact space.  And he was
       not conscious of the Heine-Borel property.  Cantor was one of his
       students.  He used the concept of neighborhood and limit point invented
       by his master when he studied the linear point sets and the rest of the
       general topology followed from that.  (Contributed by FL, 2-Aug-2009.)
       (Revised by Mario Carneiro, 15-Dec-2013.) $)
    bwth $p |- ( ( J e. Comp /\ A C_ X /\ -. A e. Fin ) ->
     E. x e. X x e. ( ( limPt ` J ) ` A ) ) $=
      ( vo vz wcel wss cfn wn cv wrex cdif cin c0 wi wa syl wceq vf va ccmp w3a
      vb clp cfv csn wne wral wb ctop cmptop islp3 3exp rexbidva notbid 3adant3
      imp31 nrexralim wf wex cvv cuni uniexg syl5eqel eleq2 ineq1 eqeq1d syl5bb
      nne anbi12d ac6sg 3ad2ant1 crn cpw frn rnex sylibr adantr uniss syl6sseqr
      vex elpw wal df-ral pm2.27 cdm fdm biimpd wfun ffun fvelrn elunii idd a1i
      ex com13 syl6 com4l com23 mpcom com12 syl6com eqcoms impcom alimdv syl5bi
      pm2.43a 3impia dfss2 simp1 eqssd imp jca iscmp eqeq2d pweq ineq1d rexeqdv
      unieq imbi12d rspcv elin sseq2 infssuni com3l elelpwi wfn nfim eqtr eqtr2
      difindir mpan adantl sylbi com3r syl6bi rexlimiv syl8 fvelrnb nfra1 nfre1
      ffn nfv ineq2 eleq1d difeq1 0dif difabs ineq2i eqcomi 0fin difeq1i eleq1i
      incom eleq1 syl5bbr mpbiri snfi difinf mpan2 con4i 3syl ax-mp ee10 imim2i
      pm2.24d rexlimi com24 com4r 3impd 3expd 3imp exlimiv syld sylbid pm2.18d
      sps ) CUCHZBDIZBJHKZUDZALZBCUFUGUGHZADMZUWCUWFKZUWDFLZHZUWHBUWDUHZNZOZPUI
      ZQFCUJZADMZKZUWFUVTUWAUWGUWPUKUWBUVTUWARZUWFUWOUWQUWEUWNADUVTUWAUWDDHZUWE
      UWNUKZUVTCULHZUWAUWRUWSQQCUMUWTUWAUWRUWSFUWDBCDEUNUOSUSUPUQURUWPUWIUWMKZR
      ZFCMADUJZUWCUWFUWIUWMAFDCUTUWCUXCDCUALZVAZUWDUWDUXDUGZHZUXFUWKOZPTZRZADUJ
      ZRZUAVBZUWFUVTUWAUXCUXMQZUWBUVTDVCHUXNUVTDCVDZVCECUCVEVFUXBUXJAFDCUAVCUWH
      UXFTZUWIUXGUXAUXIUWHUXFUWDVGUXAUWLPTUXPUXIUWLPVKUXPUWLUXHPUWHUXFUWKVHVIVJ
      VLVMSVNUXMUWCUWFUXLUWCUWFQZUAUXDVOZCVPZHZDUXRVDZTZRZUXLUXQUXLUXTUYBUXEUXT
      UXKUXEUXRCIZUXTDCUXDVQZUXRCUXDUAWCVRWDVSVTUXEUXKUYBUYADIZUXEUXKUYBQUXEUYA
      UXODUXEUYDUYAUXOIUYEUXRCWASEWBUYFUXEUXKUYBUYFUXEUXKUDZDUYAUYGUWRUWDUYAHZQ
      ZAWEZDUYAIUYFUXEUXKUYJUXKUWRUXJQZAWEZUYFUXERZUYJUXJADWFZUYMUYKUYIAUWRUYKU
      YMUYHUYKUWRUYMUYHQZUWRUYKUXJUWRUYOQZUWRUXJWGUXGUYPUXIUYMUWRUXGUYHUXEUYFUW
      RUXGUYHQZQZUXDWHZDTUXEUYFUYRQZDCUXDWIUXEUYTQDUYSUWRDUYSTZUXEUYFUYQVUAUWRU
      WDUYSHZUXEUYFUYQQZQZVUAUWRVUBDUYSUWDVGWJUXEVUBVUCUXDWKZUXEVUBVUCQDCUXDWLV
      UEVUBUXEVUCVUEVUBUXFUXRHZVUDVUEVUBVUFUWDUXDWMWQUXGVUFUXEUYFUYHUXGVUFUYHUX
      EUYFUYHQQUXGVUFUYHUWDUXFUXRWNWQUYFUXEUYHUYHUXEUYHUYHQQUYFUXEUYHWOWPWRWSWT
      WSXAXBXCXDWTXEXBXFWRVTWSXIWRXGXHXJADUYAXKVSUYFUXEUXKXLXMUOXBXNXOUWCUXLUYC
      UWFUVTUWAUWBUXLUYCUWFQZQZUVTUWTDUBLZVDZTZDGLZVDZTZGVUIVPZJOZMZQZUBUXSUJZR
      UWAUWBVUHQQZUBGCDEXPVUSVUTUWTVUSUWAUWBUXLVUGUYCVUSUWAUWBUXLUDZUWFUXTUYBVU
      SVVAUWFQZQUXTVUSUYBVVBUXTVUSUYBVUNGUXRVPZJOZMZVVBVURUYBVVEQUBUXRUXSVUIUXR
      TZVUKUYBVUQVVEVVFVUJUYADVUIUXRYAXQVVFVUNGVUPVVDVVFVUOVVCJVUIUXRXRXSXTYBYC
      VVEUWAUWBUXLUWFVUNUWAUWBUXLUWFQZQZQZGVVDVULVVDHVULVVCHZVULJHZRZVUNVVIQVUL
      VVCJYDVUNUWAVVLVVHVUNUWABVUMIZVVLVVHQDVUMBYEVVLVVMVVHVVJVVKVVMVVHQVVKVVMU
      WBVVJVVGVVKVVMUWBBUELZOZJHZKZUEVULMZVVJVVGQZUWBVVKVVMVVRUWBVVKVVMVVRUEBVU
      LYFUOYGVVQVVSUEVULVVNVULHZVVJVVQVVGVVTVVJVVNUXRHZVVQVVGQVVTVVJVWAVVNVULUX
      RYHWQUXLVVQVWAUWFUXEUXKVVQVWAUWFQQZUXEUXDDYIZUXKVWBQDCUXDUUDVWCVWAVVQUXKU
      WFVWCVWAUXFVVNTZADMVVQUXKUWFQZQZADVVNUXDUUAVWDVWFADVVQVWEAVVQAUUEUXKUWFAU
      XJADUUBUWEADUUCYJYJVWDVVQUWRVWEVWDVVQBUXFOZJHZKZUWRVWEQVVQVWIQVVNUXFVVNUX
      FTZVVQVWIVWJVVPVWHVWJVVOVWGJVVNUXFBUUFUUGUQWJXEUXKUWRVWIUWFUXKUYLUWRVWIUW
      FQZQZUYNUYKVWLAUXJVWKUWRUXIVWKUXGUXIUXHUWJNZPUWJNZTZVWNPTZVWKUXHPUWJUUHUW
      JUUIVWOVWPVWMPTZVWKVWOVWPVWQVWMVWNPYKWQVWMUXFUWJNZUWKUWJNZOZTVWQVWKQZUXFU
      WKUWJYMVXAVWTVWMVWTVWMTZVWQVWKVXBVWQRVWTPTZVWKVWTVWMPYKVXCVWHUWFVWTVWRUWK
      OZTZVXCVWHVWSUWKVWRBUWJUUJUUKVXEVXCRVXDPTZVWHVWTVXDPYLVXDUXFBOZUWJNZTZVXF
      VWHVXHVXDUXFBUWJYMUULVXIVXFRVXHPTZVWGUWJNZJHZVWHVXDVXHPYLVXJVXLPJHZUUMVXL
      VXHJHVXJVXMVXHVXKJVXGVWGUWJUXFBUUPUUNUUOVXHPJUUQUURUUSVWHVXLVWIUWJJHVXLKU
      WDUUTVWGUWJUVAUVBUVCUVDYNSYNUVHSWQXEUVEWSUVFYOUVGUVSYPWRWSYQUVIYRUVJSXNWR
      WSXAYSYTUVKXNXCYRYQYPYSUVLYTXAXNYGUVMYOYPUVNWRXBUVOXCUVPXHUVQUVR $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Connectedness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Con $.
  $( Extend class notation with the class of all connected topologies. $)
  ccon $a class Con $.

  $( Topologies are connected when only ` (/) ` and ` U. j ` are both open and
     closed.  (Contributed by FL, 17-Nov-2008.) $)
  df-con $a |- Con = { j e. Top | ( j i^i ( Clsd ` j ) ) = { (/) , U. j } } $.

  ${
    $d j J $.  $d j X $.
    iscon.1 $e |- X = U. J $.
    $( The predicate ` J ` is a connected topology .  (Contributed by FL,
       17-Nov-2008.) $)
    iscon $p |- ( J e. Con <-> ( J e. Top /\ ( J i^i ( Clsd ` J ) ) =
      { (/) , X } ) ) $=
      ( vj cv ccld cfv cin c0 cuni cpr wceq ctop id fveq2 ineq12d unieq syl6eqr
      ccon preq2d eqeq12d df-con elrab2 ) DEZUDFGZHZIUDJZKZLAAFGZHZIBKZLDAMSUDA
      LZUFUJUHUKULUDAUEUIULNUDAFOPULUGBIULUGAJBUDAQCRTUADUBUC $.

    $( The predicate ` J ` is a connected topology .  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    iscon2 $p |- ( J e. Con <-> ( J e. Top /\
      ( J i^i ( Clsd ` J ) ) C_ { (/) , X } ) ) $=
      ( ccon wcel ctop ccld cfv cin c0 cpr wceq wa wss iscon 0opn 0cld sylanbrc
      elin topopn topcld prssi syl2anc biantrud eqss syl6rbbr pm5.32i bitri ) A
      DEAFEZAAGHZIZJBKZLZMUIUKULNZMABCOUIUMUNUIUNUNULUKNZMUMUIUOUNUIJUKEZBUKEZU
      OUIJAEJUJEUPAPAQJAUJSRUIBAEBUJEUQABCTABCUABAUJSRJBUKUBUCUDUKULUEUFUGUH $.

    conclo.1 $e |- ( ph -> J e. Con ) $.
    conclo.2 $e |- ( ph -> A e. J ) $.
    conclo.3 $e |- ( ph -> A =/= (/) ) $.
    ${
      conclo.4 $e |- ( ph -> A e. ( Clsd ` J ) ) $.
      $( The only nonempty clopen set of a connected topology is the whole
         space.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
      conclo $p |- ( ph -> A = X ) $=
        ( c0 wceq wn neneqd cpr wcel wo ccld cfv cin syl elin ccon ctop simprbi
        sylanbrc iscon eleqtrd elpri ord mpd ) ABJKZLBDKZABJHMAUKULABJDNZOUKULP
        ABCCQRZSZUMABCOBUNOBUOOGIBCUNUAUEACUBOZUOUMKZFUPCUCOUQCDEUFUDTUGBJDUHTU
        IUJ $.
    $}

    conndisj.4 $e |- ( ph -> B e. J ) $.
    conndisj.5 $e |- ( ph -> B =/= (/) ) $.
    conndisj.6 $e |- ( ph -> ( A i^i B ) = (/) ) $.
    $( If a topology is connected, its underlying set can't be partitioned into
       two non-empty non-overlapping open sets.  (Contributed by FL,
       16-Nov-2008.)  (Proof shortened by Mario Carneiro, 10-Mar-2015.) $)
    conndisj $p |- ( ph -> ( A u. B ) =/= X ) $=
      ( c0 wne wceq cdif wss cin wcel adantr cun wb elssuni syl6sseqr uneqdifeq
      cuni syl syl2anc simpr difeq2d dfss4 sylib ccon ccld cfv ctop cpr simplbi
      wa iscon opncld eqeltrrd conclo difid syl6eq 3eqtr3d sylbid necon3d mpd
      ex ) ABMNBCUAZENIAVKEBMAVKEOZEBPZCOZBMOZABEQZBCRMOVLVNUBABDUFZEABDSZBVQQH
      BDUCUGFUDZLBCEUEUHAVNVOAVNUSZEVMPZECPZBMVTVMCEAVNUIZUJAWABOZVNAVPWDVSBEUK
      ULTVTWBEEPMVTCEEVTCDEFADUMSZVNGTACDSVNJTACMNVNKTVTVMCDUNUOZWCAVMWFSZVNADU
      PSZVRWGAWEWHGWEWHDWFRMEUQODEFUTURUGHBDEFVAUHTVBVCUJEVDVEVFVJVGVHVI $.
  $}

  $( A connected topology is a topology.  (Contributed by FL, 22-Dec-2008.)
     (Revised by Mario Carneiro, 14-Dec-2013.) $)
  contop $p |- ( J e. Con -> J e. Top ) $=
    ( ccon wcel ctop ccld cfv cin c0 cuni cpr wceq eqid iscon simplbi ) ABCADCA
    AEFGHAIZJKAOOLMN $.

  $( The indiscrete topology (or trivial topology) on any set is connected.
     (Contributed by FL, 5-Jan-2009.)  (Revised by Mario Carneiro,
     14-Aug-2015.) $)
  indiscon $p |- { (/) , A } e. Con $=
    ( c0 cpr ccon wcel ctop cfv cin cid wss indistop indislem sseqtr4i indisuni
    ccld inss1 iscon2 mpbir2an ) BACZDESFESSOGZHZBAIGZCZJAKUASUCSTPALMSUBANQR
    $.

  ${
    $d o x y J $.  $d o x y X $.
    $( An alternate definition of connectedness.  (Contributed by Jeff Hankins,
       9-Jul-2009.)  (Proof shortened by Mario Carneiro, 10-Mar-2015.) $)
    dfcon2 $p |- ( J e. ( TopOn ` X ) -> ( J e. Con <-> A. x e. J A. y e. J
 ( ( x =/= (/) /\ y =/= (/) /\ ( x i^i y ) = (/) ) -> ( x u. y ) =/= X ) ) ) $=
      ( cfv wcel cv c0 wne cin wceq cun wi wral wa ex wss wal adantl bitri ccon
      ctopon w3a cuni eqid simpll simplrl simpr1 simplrr simpr2 simpr3 conndisj
      ralrimivva ctop topontop ccld cpr cdif cldopn df-3an ineq2 disjdif syl6eq
      biantrud neeq1 anbi2d bitr3d syl5bb uneq2 undif2 neeq1d imbi12d rspcv syl
      cldss ssequn1 sylib ssdif0 idd jctild eqss syl6ibr syl5bir embantd orim2d
      wo impexp wn df-ne necon4d necon3d impbii imbi12i pm4.64 vex elpr 3imtr4g
      id syld com23 imim2d elin imbi1i alimdv df-ral dfss2 baib sylibrd impbid2
      iscon2 toponuni neeq2d imbi2d 2ralbidv bitr4d ) CDUBEFZCUAFZAGZHIZBGZHIZX
      RXTJZHKZUCZXRXTLZCUDZIZMZBCNZACNZYDYEDIZMZBCNACNXPXQYJXQYHABCCXQXRCFZXTCF
      ZOZOZYDYGYPYDOXRXTCYFYFUEZXQYOYDUFXQYMYNYDUGYPXSYAYCUHXQYMYNYDUIYPXSYAYCU
      JYPXSYAYCUKULPUMXPCUNFZYJXQMDCUOYRYJCCUPEZJZHYFUQZQZXQYRYMYIMZARXRYTFZXRU
      UAFZMZARYJUUBYRUUCUUFAYRUUCYMXRYSFZUUEMZMZUUFYRYIUUHYMYRUUGYIUUEYRUUGYIUU
      EMYRUUGOZYIXSYFXRURZHIZOZXRYFLZYFIZMZUUEUUJUUKCFZYIUUPMUUGUUQYRXRCYFYQUSS
      YHUUPBUUKCXTUUKKZYDUUMYGUUOYDXSYAOZYCOZUURUUMXSYAYCUTUURUUSUUTUUMUURYCUUS
      UURYBXRUUKJHXTUUKXRVAXRYFVBVCVDUURYAUULXSXTUUKHVEVFVGVHUURYEUUNYFUURYEXRU
      UKLUUNXTUUKXRVIXRYFVJVCVKVLVMVNUUJXRHKZUUNYFKZUUKHKZMZWFZUVAXRYFKZWFUUPUU
      EUUJUVDUVFUVAUUJUVBUVCUVFUUJXRYFQZUVBUUGUVGYRXRCYFYQVOSZXRYFVPVQUVCYFXRQZ
      UUJUVFYFXRVRUUJUVIUVGUVIOUVFUUJUVIUVIUVGUUJUVIVSUVHVTXRYFWAWBWCWDWEUUPXSU
      ULUUOMZMZUVEXSUULUUOWGUVKUVAWHZUVDMUVEXSUVLUVJUVDXRHWIUVJUVDUVJUUKHUUNYFU
      VJWRWJUVDUUNYFUUKHUVDWRWKWLWMUVAUVDWNTTXRHYFAWOWPWQWSPWTXAUUFYMUUGOZUUEMU
      UIUUDUVMUUEXRCYSXBXCYMUUGUUEWGTWBXDYIACXEAYTUUAXFWQXQYRUUBCYFYQXJXGXHVNXI
      XPYLYHABCCXPYKYGYDXPDYFYEDCXKXLXMXNXO $.
  $}

  ${
    $d u v x y A $.  $d u v x y J $.  $d x y S $.  $d u v x y X $.
    $( Connectedness for a subspace.  See ~ connsub .  (Contributed by FL,
       29-May-2014.)  (Proof shortened by Mario Carneiro, 10-Mar-2015.) $)
    consuba $p |- ( ( J e. ( TopOn ` X ) /\ A C_ X ) -> ( ( J |`t A ) e. Con
      <-> A. x e. J A. y e. J ( ( ( x i^i A ) =/= (/) /\
          ( y i^i A ) =/= (/) /\ ( ( x i^i y ) i^i A ) = (/) )
          -> ( ( x u. y ) i^i A ) =/= A ) ) ) $=
      ( vu vv ctopon wcel wa cv c0 wne cin wceq cun wral wb cvv neeq1d crest co
      cfv wss ccon w3a resttopon dfcon2 syl vex inex1 a1i toponmax adantr simpr
      wi wrex ssexd elrest syldan simplr ineq12d inindir syl6eqr eqeq1d uneq12d
      3anbi123d indir imbi12d ralxfr2d bitrd ) DEHUCZIZCEUDZJZDCUAUBZUEIZFKZLMZ
      GKZLMZVRVTNZLOZUFZVRVTPZCMZUPZGVPQZFVPQZAKZCNZLMZBKZCNZLMZWJWMNCNZLOZUFZW
      JWMPCNZCMZUPZBDQZADQVOVPCHUCIVQWIRCDEUGFGVPCUHUIVOWHXBFAWKVPDSWKSIVOWJDIJ
      WJCAUJUKULVMVNCSIZVRVPIVRWKOZADUQRVOCEDVMEDIVNEDUMUNVMVNUOURZAVRCDVLSUSUT
      VOXDJZWGXAGBWNVPDSWNSIXFWMDIJWMCBUJUKULVOVTVPIVTWNOZBDUQRZXDVMVNXCXHXEBVT
      CDVLSUSUTUNXFXGJZWDWRWFWTXIVSWLWAWOWCWQXIVRWKLVOXDXGVAZTXIVTWNLXFXGUOZTXI
      WBWPLXIWBWKWNNWPXIVRWKVTWNXJXKVBWJWMCVCVDVEVGXIWEWSCXIWEWKWNPWSXIVRWKVTWN
      XJXKVFWJWMCVHVDTVIVJVJVK $.

    $( Two equivalent ways of saying that a subspace topology is connected.
       (Contributed by Jeff Hankins, 9-Jul-2009.)  (Proof shortened by Mario
       Carneiro, 10-Mar-2015.) $)
    connsub $p |- ( ( J e. ( TopOn ` X ) /\ S C_ X ) -> ( ( J |`t S ) e. Con
    <-> A. x e. J A. y e. J ( ( ( x i^i S ) =/= (/) /\ ( y i^i S ) =/= (/) /\ (
    x i^i y ) C_ ( X \ S ) ) -> -. S C_ ( x u. y ) ) ) ) $=
      ( ctopon cfv wcel wss wa crest cv cin c0 wne wceq w3a wi wral wb ccon cun
      co wn consuba inss1 toponss ad2ant2r syl5ss reldisj syl 3anbi3d dfss1 a1i
      cdif bicomd necon3abid imbi12d 2ralbidva bitrd ) DEFGHZCEIZJZDCKUCUAHALZC
      MNOZBLZCMNOZVDVFMZCMNPZQZVDVFUBZCMZCOZRZBDSADSVEVGVHECUOIZQZCVKIZUDZRZBDS
      ADSABCDEUEVCVNVSABDDVCVDDHZVFDHZJJZVJVPVMVRWBVIVOVEVGWBVHEIVIVOTWBVHVDEVD
      VFUFVAVTVDEIVBWAVDDEUGUHUIVHCEUJUKULWBVQVLCWBVQVLCPZVQWCTWBCVKUMUNUPUQURU
      SUT $.
  $}

  ${
    $d f x y F $.  $d f x y J $.  $d f x y K $.  $d f x y X $.  $d f x y Y $.
    cnconn.2 $e |- Y = U. K $.
    $( Connectedness is respected by a continuous onto map.  (Contributed by
       Jeff Hankins, 12-Jul-2009.)  (Proof shortened by Mario Carneiro,
       10-Mar-2015.) $)
    cnconn $p |- ( ( J e. Con /\ F : X -onto-> Y /\ F e. ( J Cn K ) ) ->
        K e. Con ) $=
      ( vx ccon wcel ccld cfv cin c0 wss wa wceq wne cima syl2anc syl co cntop2
      wfo ccn w3a ctop cpr 3ad2ant3 cv wo wn df-ne ccnv cuni eqid simpl1 simpl3
      cdm inss1 simprl sseldi cnima crn elssuni syl6sseqr simpl2 sseqtr4d df-rn
      forn syl6sseq dfss1 sylib simprr eqnetrd imadisj necon3bii sylibr cnclima
      inss2 conclo cnf fdm 3syl fof 3eqtr2d imaeq2d foimacnv foima 3eqtr3d expr
      wf syl5bir orrd vex elpr ex ssrdv iscon2 sylanbrc ) BHIZDEAUCZABCUDUAIZUE
      ZCUFIZCCJKZLZMEUGZNCHIXBWTXDXAABCUBUHXCGXFXGXCGUIZXFIZXHXGIZXCXIOZXHMPZXH
      EPZUJXJXKXLXMXLUKXHMQZXKXMXHMULXCXIXNXMXCXIXNOZOZAAUMZXHRZRZADRZXHEXPXRDA
      XPXRBUNZAURZDXPXRBYAYAUOZWTXAXBXOUPXPXBXHCIZXRBIWTXAXBXOUQZXPXFCXHCXEUSXC
      XIXNUTZVAZXHABCVBSXPXQURZXHLZMQXRMQXPYIXHMXPXHYHNYIXHPXPXHAVCZYHXPXHEYJXP
      XHCUNZEXPYDXHYKNYGXHCVDTFVEZXPXAYJEPWTXAXBXOVFZDEAVITVGAVHVJXHYHVKVLXCXIX
      NVMVNXRMYIMXQXHVOVPVQXPXBXHXEIXRBJKIYEXPXFXEXHCXEVSYFVAXHABCVRSVTXPXBYAEA
      WKYBYAPYEABCYAEYCFWAYAEAWBWCXPXADEAWKYBDPYMDEAWDDEAWBWCWEWFXPXAXHENXSXHPY
      MYLDEXHAWGSXPXAXTEPYMDEAWHTWIWJWLWMXHMEGWNWOVQWPWQCEFWRWS $.
  $}

  ${
    $d x y A $.  $d x y J $.  $d x y U $.  $d y V $.  $d x y X $.
    nconsubb.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    nconsubb.3 $e |- ( ph -> A C_ X ) $.
    nconsubb.4 $e |- ( ph -> U e. J ) $.
    nconsubb.5 $e |- ( ph -> V e. J ) $.
    nconsubb.6 $e |- ( ph -> ( U i^i A ) =/= (/) ) $.
    nconsubb.7 $e |- ( ph -> ( V i^i A ) =/= (/) ) $.
    nconsubb.8 $e |- ( ph -> ( ( U i^i V ) i^i A ) = (/) ) $.
    nconsubb.9 $e |- ( ph -> A C_ ( U u. V ) ) $.
    $( Disconnectedness for a subspace.  (Contributed by FL, 29-May-2014.)
       (Proof shortened by Mario Carneiro, 10-Mar-2015.) $)
    nconsubb $p |- ( ph -> -. ( J |`t A ) e. Con ) $=
      ( vx vy cin c0 wne wceq crest co ccon wcel cun wss cv w3a wral ctopon cfv
      wi wn wb consuba syl2anc 3jca ineq1 neeq1d ineq1d eqeq1d 3anbi13d imbi12d
      uneq1 ineq2 3anbi23d dfss1 necon3bbii sseq2d notbid syl5bbr rspc2v sylbid
      uneq2 mpid mt2d ) ADBUAUBUCUDZBCEUEZUFZNAVQOUGZBQZRSZPUGZBQZRSZVTWCQZBQZR
      TZUHZVTWCUEZBQZBSZULZPDUIODUIZVSUMZADFUJUKUDBFUFVQWNUNGHOPBDFUOUPAWNCBQZR
      SZEBQZRSZCEQZBQZRTZUHZWOAWQWSXBKLMUQACDUDEDUDWNXCWOULZULIJWMXDWQWECWCQZBQ
      ZRTZUHZCWCUEZBQZBSZULOPCEDDVTCTZWIXHWLXKXLWBWQWHXGWEXLWAWPRVTCBURUSXLWGXF
      RXLWFXEBVTCWCURUTVAVBXLWKXJBXLWJXIBVTCWCVDUTUSVCWCETZXHXCXKWOXMWEWSXGXBWQ
      XMWDWRRWCEBURUSXMXFXARXMXEWTBWCECVEUTVAVFXKBXIUFZUMXMWOXNXJBBXIVGVHXMXNVS
      XMXIVRBWCECVNVIVJVKVCVLUPVOVMVP $.
  $}

  ${
    $d x A $.  $d x B $.  $d x J $.  $d x X $.
    consubclo.1 $e |- X = U. J $.
    consubclo.3 $e |- ( ph -> A C_ X ) $.
    consubclo.4 $e |- ( ph -> ( J |`t A ) e. Con ) $.
    consubclo.5 $e |- ( ph -> B e. J ) $.
    consubclo.6 $e |- ( ph -> ( B i^i A ) =/= (/) ) $.
    consubclo.7 $e |- ( ph -> B e. ( Clsd ` J ) ) $.
    $( If a clopen set meets a connected subspace, it must contain the entire
       subspace.  (Contributed by Mario Carneiro, 10-Mar-2015.) $)
    consubclo $p |- ( ph -> A C_ B ) $=
      ( vx cin wceq wss eqid ctop wcel cvv ccld crest co cuni cfv cldrcl topopn
      ssexd elrestr syl3anc cv wrex ineq1 eqeq2d rspcev sylancl restcld syl2anc
      syl wb mpbird conclo restuni eqtr4d dfss1 sylibr ) ACBMZBNBCOAVFDBUAUBZUC
      ZBAVFVGVHVHPHADQRZBSRCDRVFVGRACDTUDZRZVIKCDUEURZABEDAVIEDRVLDEFUFURGUGICB
      DQSUHUIJAVFVGTUDRZVFLUJZBMZNZLVJUKZAVKVFVFNZVQKVFPVPVRLCVJVNCNVOVFVFVNCBU
      LUMUNUOAVIBEOZVMVQUSVLGLVFBDEFUPUQUTVAAVIVSBVHNVLGBDEFVBUQVCBCVDVE $.
  $}

  ${
    conima.x $e |- X = U. J $.
    conima.f $e |- ( ph -> F e. ( J Cn K ) ) $.
    conima.a $e |- ( ph -> A C_ X ) $.
    conima.c $e |- ( ph -> ( J |`t A ) e. Con ) $.
    $( The image of a connected set is connected.  (Contributed by Mario
       Carneiro, 7-Jul-2015.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    conima $p |- ( ph -> ( K |`t ( F " A ) ) e. Con ) $=
      ( crest co ccon wcel cuni ccn wss syl wceq syl2anc cima cres wfo wfun cdm
      wf eqid cnf ffun fdm sseqtr4d fores wb ctop cntop2 crn imassrn frn syl5ss
      restuni foeq3 mpbid cnrest ctopon cfv toptopon sylib eqimss2 mp1i cnrest2
      df-ima syl3anc cnconn ) ADBKLZMNBECBUAZKLZOZCBUBZUCZVRVNVPPLNZVPMNJABVOVR
      UCZVSACUDZBCUEZQWAAFEOZCUFZWBACDEPLNZWEHCDEFWDGWDUGZUHRZFWDCUIRABFWCIAWEW
      CFSWHFWDCUJRUKBCULTAVOVQSZWAVSUMAEUNNZVOWDQZWIAWFWJHCDEUORZAVOCUPZWDCBUQA
      WEWMWDQWHFWDCURRUSZVOEWDWGUTTVOVQBVRVARVBAVRVNEPLNZVTAWFBFQWOHIBCDEFGVCTA
      EWDVDVENZVRUPZVOQZWKWOVTUMAWJWPWLEWDWGVFVGVOWQSWRACBVKWQVOVHVIWNVOVRVNEWD
      VJVLVBVRVNVPBVQVQUGVMVL $.
  $}

  ${
    concn.x $e |- X = U. J $.
    concn.j $e |- ( ph -> J e. Con ) $.
    concn.f $e |- ( ph -> F e. ( J Cn K ) ) $.
    concn.u $e |- ( ph -> U e. K ) $.
    concn.c $e |- ( ph -> U e. ( Clsd ` K ) ) $.
    concn.a $e |- ( ph -> A e. X ) $.
    concn.1 $e |- ( ph -> ( F ` A ) e. U ) $.
    $( A continuous function from a connected topology with one point in a
       clopen set must lie entirely within the set.  (Contributed by Mario
       Carneiro, 16-Feb-2015.) $)
    concn $p |- ( ph -> F : X --> U ) $=
      ( wss wf co wcel syl syl2anc wfn crn cuni ccn eqid cnf ffn frn ccon crest
      wfo dffn4 sylib wceq ctop cntop2 restuni foeq3 mpbid ctopon toptopon ssid
      cfv a1i cnrest2 syl3anc cnconn cin wne fnfvelrn inelcm consubclo sylanbrc
      wb c0 df-f ) ADGUAZDUBZCOGCDPAGFUCZDPZVQADEFUDQRZVTJDEFGVSHVSUEZUFSZGVSDU
      GSZAVRCFVSWBAVTVRVSOZWCGVSDUHSZAEUIRGFVRUJQZUCZDUKZDEWGUDQRZWGUIRIAGVRDUK
      ZWIAVQWKWDGDULUMAVRWHUNZWKWIVNAFUORZWEWLAWAWMJDEFUPSZWFVRFVSWBUQTVRWHGDUR
      SUSAWAWJJAFVSUTVCRZVRVROZWEWAWJVNAWMWOWNFVSWBVAUMWPAVRVBVDWFVRDEFVSVEVFUS
      DEWGGWHWHUEVGVFKABDVCZCRWQVRRZCVRVHVOVINAVQBGRWRWDMGBDVJTWQCVRVKTLVLGCDVP
      VM $.
  $}

  ${
    $d k u v x A $.  $d u v x B $.  $d k u v J $.  $d k x P $.  $d k u v x X $.
    $d u v x ph $.  $d k x U $.  $d k x V $.
    iuncon.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    iuncon.3 $e |- ( ( ph /\ k e. A ) -> B C_ X ) $.
    iuncon.4 $e |- ( ( ph /\ k e. A ) -> P e. B ) $.
    iuncon.5 $e |- ( ( ph /\ k e. A ) -> ( J |`t B ) e. Con ) $.
    ${
      iuncon.6 $e |- ( ph -> U e. J ) $.
      iuncon.7 $e |- ( ph -> V e. J ) $.
      iuncon.8 $e |- ( ph -> ( V i^i U_ k e. A B ) =/= (/) ) $.
      iuncon.9 $e |- ( ph -> ( U i^i V ) C_ ( X \ U_ k e. A B ) ) $.
      iuncon.10 $e |- ( ph -> U_ k e. A B C_ ( U u. V ) ) $.
      iuncon.11 $e |- F/ k ph $.
      $( Lemma for ~ iuncon .  (Contributed by Mario Carneiro, 11-Jun-2014.) $)
      iunconlem $p |- ( ph -> -. P e. U ) $=
        ( wcel vx cv ciun cin wex wn c0 wne n0 sylib elin wrex eliun nfan crest
        wa nfv co adantr ctopon cfv ad2antrr wss simprr inelcm syl2anc ad2antrl
        ccon wceq cdif ssiun2 ad2antlr sscond sstrd wb inss1 toponss syl5ss syl
        reldisj mpbird cun nconsubb expr mt2d an4s exp32 rexlimd syl5bi expimpd
        exlimdv mpd ) AUAUBZHFBCUCZUDZTZUAUEZDETZUFZAWOUGUHWQPUAWOUIUJAWPWSUAWP
        WMHTZWMWNTZUPAWSWMHWNUKAWTXAWSXAWMCTZFBULAWTUPZWSFWMBCUMXCXBWSFBAWTFSWT
        FUQUNWSFUQXCFUBBTZXBWSAXDWTXBWSAXDUPZWTXBUPZUPWRGCUOURVHTZXEXGXFMUSXEXF
        WRXGUFXEXFWRUPZUPZCEGHIAGIUTVATZXDXHJVBZXECIVCXHKUSAEGTZXDXHNVBZAHGTXDX
        HOVBXIWRDCTZECUDUGUHXEXFWRVDXEXNXHLUSDECVEVFXFHCUDUGUHXEWRWMHCVEVGXIEHU
        DZCUDUGVIZXOICVJZVCZXIXOIWNVJZXQAXOXSVCXDXHQVBXICWNIXDCWNVCAXHFBCVKVLZV
        MVNXIXOIVCXPXRVOXIXOEIEHVPXIXJXLEIVCXKXMEGIVQVFVRXOCIVTVSWAXICWNEHWBZXT
        AWNYAVCXDXHRVBVNWCWDWEWFWGWHWIWJWIWKWL $.
    $}

    $d k ph $.
    $( The indexed union of connected overlapping subspaces sharing a common
       point is connected.  (Contributed by Mario Carneiro, 11-Jun-2014.) $)
    iuncon $p |- ( ph -> ( J |`t U_ k e. A B ) e. Con ) $=
      ( vu vv wcel cin c0 wss wn wral nfcv ciun crest co ccon cv wne w3a cun wi
      cdif wa wo simpr simplr1 wex n0 inss2 sseli eliun rexn0 sylbi syl exlimiv
      wrex simplll ralrimiva r19.2z syl2anc sylibr sseldd elun sylib ctopon cfv
      sylan simpllr simpld simplr2 simplr3 nfv nfiu1 nfin nfne nfdif nfss nf3an
      nfan nfun iunconlem incom syl5eqss uncom syl6sseq ioran sylanbrc pm2.65da
      simprd ex ralrimivva wb iunss connsub mpbird ) AFEBCUAZUBUCUDNZLUEZXDOZPU
      FZMUEZXDOZPUFZXFXIOZGXDUJZQZUGZXDXFXIUHZQZRZUIZMFSLFSZAXSLMFFAXFFNZXIFNZU
      KZUKZXOXRYDXOUKZXQDXFNZDXINZULZYEXQUKZDXPNYHYIXDXPDYEXQUMZYIDCNZEBVDZDXDN
      YIBPUFZYKEBSZYLYIXHYMXHXKXNYDXQUNZXHXIXGNZMUOYMMXGUPYPYMMYPXIXDNZYMXGXDXI
      XFXDUQURYQXICNZEBVDYMEXIBCUSYREBUTVAVBVCVAVBYIAYNAYCXOXQVEZAYKEBJVFVBYKEB
      VGVHEDBCUSVIVJDXFXIVKVLYIYFRYGRYHRYIBCDXFEFXIGYIAFGVMVNNZYSHVBZYIAEUEBNZC
      GQZYSIVOZYIAUUBYKYSJVOZYIAUUBFCUBUCUDNYSKVOZYIYAYBAYCXOXQVPZVQZYIYAYBUUGW
      QZXHXKXNYDXQVRXHXKXNYDXQVSZYJYEXQEYDXOEYDEVTXHXKXNEEXGPEXFXDEXFTZEBCWAZWB
      EPTZWCEXJPEXIXDEXITZUULWBUUMWCEXLXMEXLTEGXDEGTUULWDWEWFWGEXDXPUULEXFXIUUK
      UUNWHWEWGZWIYIBCDXIEFXFGUUAUUDUUEUUFUUIUUHYOYIXIXFOXLXMXIXFWJUUJWKYIXDXPX
      IXFUHYJXFXIWLWMUUOWIYFYGWNWOWPWRWSAYTXDGQZXEXTWTHAUUCEBSUUPAUUCEBIVFEBCGX
      AVILMXDFGXBVHXC $.
  $}

  ${
    $d k x y z A $.  $d k x B $.  $d k x y z J $.  $d y T $.  $d k x y z X $.
    $( The union of two connected overlapping subspaces is connected.
       (Contributed by FL, 29-May-2014.)  (Proof shortened by Mario Carneiro,
       11-Jun-2014.) $)
    uncon $p |- ( ( J e. ( TopOn ` X ) /\ ( A C_ X /\ B C_ X ) /\
     ( A i^i B ) =/= (/) ) -> ( ( ( J |`t A ) e. Con /\ ( J |`t B ) e. Con ) ->
      ( J |`t ( A u. B ) ) e. Con ) ) $=
      ( vx vk wcel wss wa crest co ccon cv cvv wceq ssexd biimprd mpan9 sylan2b
      jaoa ctopon cfv cin c0 wne cun wi wex w3a cpr ciun uniiun simpl1 toponmax
      n0 cuni syl simpl2l simpl2r uniprg syl2anc syl5eqr oveq2d vex elpr simpl2
      wo sseq1 simpl3 sylib eleq2 simpr oveq2 eleq1d iuncon eqeltrrd ex exlimdv
      elin 3expia syl5bi 3impia ) CDUAUBGZADHZBDHZIZABUCZUDUEZCAJKZLGZCBJKZLGZI
      ZCABUFZJKZLGZUGZWHEMZWGGZEUHWCWFIZWQEWGUOWTWSWQEWCWFWSWQWCWFWSUIZWMWPXAWM
      IZCFABUJZFMZUKZJKWOLXBXEWNCJXBXEXCUPZWNFXCULXBANGBNGXFWNOXBADCXBWCDCGWCWF
      WSWMUMZDCUNUQZWDWEWCWSWMURPXBBDCXHWDWEWCWSWMUSPABNNUTVAVBVCXBXCXDWRFCDXGX
      DXCGZXBXDAOZXDBOZVGZXDDHZXDABFVDVEZXBWFXLXMWCWFWSWMVFXJWDXMXKWEXJXMWDXDAD
      VHQXKXMWEXDBDVHQTRSXIXBXLWRXDGZXNXBWRAGZWRBGZIZXLXOXBWSXRWCWFWSWMVIWRABVS
      VJXJXPXOXKXQXJXOXPXDAWRVKQXKXOXQXDBWRVKQTRSXIXBXLCXDJKZLGZXNXBWMXLXTXAWMV
      LXJWJXTXKWLXJXTWJXJXSWILXDACJVMVNQXKXTWLXKXSWKLXDBCJVMVNQTRSVOVPVQVTVRWAW
      B $.

    $( The closure of a connected set is connected.  (Contributed by Mario
       Carneiro, 19-Mar-2015.) $)
    clscon $p |- ( ( J e. ( TopOn ` X ) /\ A C_ X /\ ( J |`t A ) e. Con )
      -> ( J |`t ( ( cls ` J ) ` A ) ) e. Con ) $=
      ( vx vy vz cfv wcel wss cv cin c0 wne cdif adantr syl sseqtrd sseldi cvv
      wa ctopon crest co ccon w3a ccl cun wn wi simpll3 simpll1 simpll2 simplrl
      wral simplrr wex simprl1 n0 sylib ctop cuni topontop toponuni inss2 simpr
      wceq inss1 eqid clsndisj syl32anc exlimddv simprl2 simprl3 syl2anc sscond
      sscls sstrd ssv ssdif ax-mp syl6ss disj2 sylibr simprr nconsubb expr mt2d
      ex ralrimivva wb simp1 sseq2d biimpa clsss3 sylan syldan sseqtr4d 3adant3
      connsub mpbird ) BCUAGHZACIZBAUBUCUDHZUEZBABUFGGZUBUCUDHZDJZXEKZLMZEJZXEK
      ZLMZXGXJKZCXENZIZUEZXEXGXJUGZIZUHZUIZEBUNDBUNZXDXTDEBBXDXGBHZXJBHZTZTZXPX
      SYEXPTXRXCXAXBXCYDXPUJYEXPXRXCUHYEXPXRTZTZAXGBXJCXAXBXCYDYFUKZXAXBXCYDYFU
      LZXDYBYCYFUMZXDYBYCYFUOZYGFJZXHHZXGAKLMZFYGXIYMFUPXIXLXOXRYEUQFXHURUSYGYM
      TZBUTHZABVAZIZYLXEHZYBYLXGHYNYOXAYPYGXAYMYHOZCBVBZPYOACYQYGXBYMYIOYOXACYQ
      VFZYTCBVCZPQYOXHXEYLXGXEVDYGYMVEZRYGYBYMYJOYOXHXGYLXGXEVGUUDRYLAXGBYQYQVH
      ZVIVJVKYGYLXKHZXJAKLMZFYGXLUUFFUPXIXLXOXRYEVLFXKURUSYGUUFTZYPYRYSYCYLXJHU
      UGUUHXAYPYGXAUUFYHOZUUAPUUHACYQYGXBUUFYIOUUHXAUUBUUIUUCPQUUHXKXEYLXJXEVDY
      GUUFVEZRYGYCUUFYKOUUHXKXJYLXJXEVGUUJRYLAXJBYQUUEVIVJVKYGXMSANZIXMAKLVFYGX
      MCANZUUKYGXMXNUULXIXLXOXRYEVMYGAXECYGYPYRAXEIYGXAYPYHUUAPYGACYQYIYGXAUUBY
      HUUCPQABYQUUEVPVNZVOVQCSIUULUUKICVRCSAVSVTWAXMAWBWCYGAXEXQUUMYEXPXRWDVQWE
      WFWGWHWIXDXAXECIZXFYAWJXAXBXCWKXAXBUUNXCXAXBTXEYQCXAXBYRXEYQIZXAXBYRXACYQ
      AUUCWLWMXAYPYRUUOUUAABYQUUEWNWOWPXAUUBXBUUCOWQWRDEXEBCWSVNWT $.

    concomp.2 $e |- S = U. { x e. ~P X | ( A e. x /\ ( J |`t x ) e. Con ) } $.
    $( The connected component containing ` A ` contains ` A ` .  (Contributed
       by Mario Carneiro, 19-Mar-2015.) $)
    concompid $p |- ( ( J e. ( TopOn ` X ) /\ A e. X ) -> A e. S ) $=
      ( ctopon cfv wcel wa cv crest co ccon cpw crab cuni wrex sylibr anbi12d
      csn wss simpr snssd snex elpw adantl restsn2 c0 cpr pwsn indiscon eqeltri
      snidg syl6eqel wceq eleq2 oveq2 eleq1d rspcev syl12anc elunirab syl6eleqr
      jca ) DEGHIZBEIZJZBBAKZIZDVHLMZNIZJZAEOZPQZCVGVIVLJZAVMRZBVNIVGBUAZVMIZBV
      QIZVSDVQLMZNIZJZVPVGVQEUBVRVGBEVEVFUCUDVQEBUEUFSVFVSVEBEUNUGZVGVSWAWCVGVT
      VQOZNBDEUHWDUIVQUJNBUKVQULUMUOVDVOVSWBJAVQVMVHVQUPZVIVSVLWBVHVQBUQZWEVIVS
      VKWAWFWEVJVTNVHVQDLURUSTTUTVAVLABVMVBSFVC $.

    $( The connected component containing ` A ` is connected.  (Contributed by
       Mario Carneiro, 19-Mar-2015.) $)
    concompcon $p |- ( ( J e. ( TopOn ` X ) /\ A e. X ) ->
      ( J |`t S ) e. Con ) $=
      ( vy ctopon cfv wcel wa crest co cv ccon cpw crab ciun simpld simprd cuni
      uniiun eqtri oveq2i simpl simpr weq eleq2 oveq2 eleq1d elrab sylib elpwid
      anbi12d iuncon syl5eqel ) DEHIJZBEJZKZDCLMDGBANZJZDUTLMZOJZKZAEPZQZGNZRZL
      MOCVHDLCVFUAVHFGVFUBUCUDUSVFVGBGDEUQURUEUSVGVFJZKZVGEVJVGVEJZBVGJZDVGLMZO
      JZKZVJVIVKVOKUSVIUFVDVOAVGVEAGUGZVAVLVCVNUTVGBUHVPVBVMOUTVGDLUIUJUNUKULZS
      UMVJVLVNVJVKVOVQTZSVJVLVNVRTUOUP $.

    $( The connected component containing ` A ` is a superset of any other
       connected set containing ` A ` .  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    concompss $p |- ( ( T C_ X /\ A e. T /\ ( J |`t T ) e. Con ) -> T C_ S ) $=
      ( vy wss wcel crest co ccon cv wa cvv wceq eleq2 oveq2 eleq1d w3a crab wb
      cpw cuni simp1 contop 3ad2ant3 restrcl simprd elpwg mpbird 3simpc anbi12d
      ctop 3syl cbvrabv elrab2 sylanbrc elssuni syl syl6sseqr ) DFIZBDJZEDKLZMJ
      ZUAZDBANZJZEVHKLZMJZOZAFUDZUBZUEZCVGDVNJZDVOIVGDVMJZVDVFOZVPVGVQVCVCVDVFU
      FVGVEUOJZDPJZVQVCUCVFVCVSVDVEUGUHVSEPJVTDEUIUJDFPUKUPULVCVDVFUMBHNZJZEWAK
      LZMJZOZVRHDVMVNWADQZWBVDWDVFWADBRWFWCVEMWADEKSTUNVLWEAHVMVHWAQZVIWBVKWDVH
      WABRWGVJWCMVHWAEKSTUNUQURUSDVNUTVAGVB $.

    $( The connected component containing ` A ` is a closed set.  (Contributed
       by Mario Carneiro, 19-Mar-2015.) $)
    concompcld $p |- ( ( J e. ( TopOn ` X ) /\ A e. X ) ->
      S e. ( Clsd ` J ) ) $=
      ( ctopon cfv wcel wa ccld ccl wss crest ccon cuni adantr syl2anc syl3anc
      co ctop topontop cpw crab ssrab2 sspwuni mpbi wceq toponuni syl5sseq eqid
      cv eqsstri clsss3 sseqtr4d sscls concompid sseldd simpl concompcon clscon
      a1i concompss wb iscld4 mpbird ) DEGHIZBEIZJZCDKHIZCDLHHZCMZVIVKEMBVKIDVK
      NTOIZVLVIVKDPZEVIDUAIZCVNMZVKVNMVGVOVHEDUBQZVIECVNCBAULZIDVRNTOIJZAEUCZUD
      ZPZEFWAVTMWBEMVSAVTUEWAEUFUGUMZVGEVNUHVHEDUIQZUJZCDVNVNUKZUNRWDUOVICVKBVI
      VOVPCVKMVQWECDVNWFUPRABCDEFUQURVIVGCEMZDCNTOIVMVGVHUSWGVIWCVBABCDEFUTCDEV
      ASABCVKDEFVCSVIVOVPVJVLVDVQWECDVNWFVERVF $.

    $( The connected component containing ` A ` is a subset of any clopen set
       containing ` A ` .  (Contributed by Mario Carneiro, 20-Sep-2015.) $)
    concompclo $p |- ( ( J e. ( TopOn ` X ) /\ T e. ( J i^i ( Clsd ` J ) ) /\
      A e. T ) -> S C_ T ) $=
      ( ctopon cfv wcel ccld cin w3a cuni eqid wss simp1 inss1 sseldi syl2anc
      simp2 toponss simp3 sseldd concompcld cldss syl crest ccon concompcon wne
      co c0 concompid inelcm inss2 consubclo ) EFHIJZDEEKIZLZJZBDJZMZCDEENZVDOZ
      VCCUSJZCVDPVCURBFJZVFURVAVBQZVCDFBVCURDEJDFPVHVCUTEDEUSRURVAVBUAZSZDEFUBT
      URVAVBUCZUDZABCEFGUETCEVDVEUFUGVCURVGECUHULUIJVHVLABCEFGUJTVJVCVBBCJZDCLU
      MUKVKVCURVGVMVHVLABCEFGUNTBDCUOTVCUTUSDEUSUPVISUQ $.
  $}

  ${
    $d x J $.  $d x X $.
    t1conperf.1 $e |- X = U. J $.
    $( A connected T_1 space is perfect, unless it is the topology of a
       singleton.  (Contributed by Mario Carneiro, 26-Dec-2016.) $)
    t1conperf $p |- ( ( J e. Fre /\ J e. Con /\ -. X ~~ 1o ) -> J e. Perf ) $=
      ( vx ct1 wcel ccon c1o cen wbr wn cperf wa cv csn wral wrex simplr simprr
      c0 wne vex snnz a1i ccld cfv t1sncld ad2ant2r conclo syl6eqbrr rexlimdvaa
      ensn1 con3d ralnex syl6ibr ctop wb adantr isperf3 baib syl sylibrd 3impia
      t1top ) AEFZAGFZBHIJZKZALFZVEVFMZVHDNZOZAFZKDBPZVIVJVHVMDBQZKVNVJVOVGVJVM
      VGDBVJVKBFZVMMZMZBVLHIVRVLABCVEVFVQRVJVPVMSVLTUAVRVKDUBZUCUDVEVPVLAUEUFFV
      FVMVKABCUGUHUIVKVSULUJUKUMVMDBUNUOVJAUPFZVIVNUQVEVTVFAVDURVIVTVNDABCUSUTV
      AVBVC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                First- and second-countability
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c 1stc $.
  $( Extend class definition to include the class of all first-countable
     topologies. $)
  c1stc $a class 1stc $.

  $c 2ndc $.
  $( Extend class definition to include the class of all second-countable
     topologies. $)
  c2ndc $a class 2ndc $.


  ${
    $d j x y z $.
    $( Define the class of all first-countable topologies.  (Contributed by
       Jeff Hankins, 22-Aug-2009.) $)
    df-1stc $a |- 1stc = { j e. Top | A. x e. U. j E. y e. ~P j
      ( y ~<_ om /\ A. z e. j ( x e. z -> x e. U. ( y i^i ~P z ) ) ) } $.

    $( Define the class of all second-countable topologies.  (Contributed by
       Jeff Hankins, 17-Jan-2010.) $)
    df-2ndc $a |- 2ndc = { j | E. x e. TopBases ( x ~<_ om
       /\ ( topGen ` x ) = j ) } $.
  $}

  ${
    $d w x y z $.  $d j x y z J $.  $d j x X $.
    is1stc.1 $e |- X = U. J $.
    $( The predicate "is a first-countable topology."  This can be described as
       "every point has a countable local basis" - that is, every point has a
       countable collection of open sets containing it such that every open set
       containing the point has an open set from this collection as a subset.
       (Contributed by Jeff Hankins, 22-Aug-2009.) $)
    is1stc $p |- ( J e. 1stc <-> ( J e. Top /\ A. x e. X E. y e. ~P J
      ( y ~<_ om /\ A. z e. J ( x e. z -> x e. U. ( y i^i ~P z ) ) ) ) ) $=
      ( vj cv com cdom wbr wcel cpw cin cuni wi wral wa wrex ctop c1stc syl6eqr
      wceq unieq pweq raleq anbi2d rexeqbidv raleqbidv df-1stc elrab2 ) BHZIJKZ
      AHZCHZLUNULUOMNOLPZCGHZQZRZBUQMZSZAUQOZQUMUPCDQZRZBDMZSZAEQGDTUAUQDUCZVAV
      FAVBEVGVBDOEUQDUDFUBVGUSVDBUTVEUQDUEVGURVCUMUPCUQDUFUGUHUIABCGUJUK $.

    $( An equivalent way of saying "is a first-countable topology."
       (Contributed by Jeff Hankins, 22-Aug-2009.)  (Revised by Mario Carneiro,
       21-Mar-2015.) $)
    is1stc2 $p |- ( J e. 1stc <-> ( J e. Top /\ A. x e. X E. y e. ~P J
  ( y ~<_ om /\ A. z e. J ( x e. z -> E. w e. y ( x e. w /\ w C_ z ) ) ) ) ) $=
      ( c1stc wcel cv wel cpw wi wral wa wrex wex anbi2i bitri ralbii ctop cdom
      com wbr cin cuni wss is1stc elin vex elpw an12 exbii eluni df-rex 3bitr4i
      imbi2i rexbii ) EHIEUAIZBJZUCUBUDZACKZAJZUTCJZLZUEZUFIZMZCENZOZBELZPZAFNZ
      OUSVAVBADKZDJZVDUGZOZDUTPZMZCENZOZBVKPZAFNZOABCEFGUHVMWCUSVLWBAFVJWABVKVI
      VTVAVHVSCEVGVRVBVNVOVFIZOZDQDBKZVQOZDQVGVRWEWGDWEVNWFVPOZOWGWDWHVNWDWFVOV
      EIZOWHVOUTVEUIWIVPWFVOVDDUJUKRSRVNWFVPULSUMDVCVFUNVQDUTUOUPUQTRURTRS $.
  $}

  ${
    $d x y z J $.
    $( A first-countable topology is a topology.  (Contributed by Jeff Hankins,
       22-Aug-2009.) $)
    1stctop $p |- ( J e. 1stc -> J e. Top ) $=
      ( vy vx vz c1stc wcel ctop cv com cdom wbr cpw cin cuni wi wral wrex eqid
      wa is1stc simplbi ) AEFAGFBHZIJKCHZDHZFUCUBUDLMNFODAPSBALQCANZPCBDAUEUERT
      UA $.
  $}

  ${
    $d a f g k n w x y z A $.  $d f g k n w x y z J $.  $d g k n w x y z X $.
    1stcclb.1 $e |- X = U. J $.
    $( A property of points in a first-countable topology.  (Contributed by
       Jeff Hankins, 22-Aug-2009.) $)
    1stcclb $p |- ( ( J e. 1stc /\ A e. X ) -> E. x e. ~P J ( x ~<_ om /\
      A. y e. J ( A e. y -> E. z e. x ( A e. z /\ z C_ y ) ) ) ) $=
      ( vw c1stc wcel cv com cdom wbr wa wrex wi wral eleq1 rexbidv wss is1stc2
      cpw ctop simprbi wceq anbi1d imbi12d ralbidv anbi2d rspcv mpan9 ) EIJZAKZ
      LMNZHKZBKZJZUPCKZJZUSUQUAZOZCUNPZQZBERZOZAEUCZPZHFRZDFJUODUQJZDUSJZVAOZCU
      NPZQZBERZOZAVGPZUMEUDJVIHABCEFGUBUEVHVQHDFUPDUFZVFVPAVGVRVEVOUOVRVDVNBEVR
      URVJVCVMUPDUQSVRVBVLCUNVRUTVKVAUPDUSSUGTUHUIUJTUKUL $.

    $( For any point ` A ` in a first-countable topology, there is a function
       ` f : NN --> J ` enumerating neighborhoods of ` A ` which is decreasing
       and forms a local base.  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    1stcfb $p |- ( ( J e. 1stc /\ A e. X ) -> E. f ( f : NN --> J /\
       A. k e. NN ( A e. ( f ` k ) /\ ( f ` ( k + 1 ) ) C_ ( f ` k ) ) /\
       A. y e. J ( A e. y -> E. k e. NN ( f ` k ) C_ y ) ) ) $=
      ( vw va vn wcel wa cv wss wrex wi wral cn c1 c0 vx vz vg c1stc com wbr wf
      cdom cfv caddc co w3a wex cpw 1stcclb crab wfo csdm ctop 1stctop ad2antrr
      wne topopn syl simprrr simplr wceq eleq2 sseq2 anbi2d rexbidv rspcv syl3c
      imbi12d simpl reximi cbvrexv sylib rabn0 sylibr rabex 0sdom ssrab2 ssdomg
      vex cvv mp2 cen simprrl nnenom ensymi domentr sylancl sylancr syl2anc cfz
      domtr fodomr cima cint cmpt cfn ad3antrrr crn imassrn forn simprll elpwid
      ad2antll syl5ss eqsstrd adantr cdm cin ssriv fof syl5sseqr dfss1 elfz1end
      elfznn fdm ne0i adantl sylan2b eqnetrd imadisj imp wb ralrimiva weq oveq2
      imaeq2d inteqd eleq1d rspccva sylan fvmptg sseq1d fveq1 ralbidv necon3bii
      cres fzfid wfun ffun fores fofi fiinopn syl13anc fmptd syl5sseq id ralrab
      eqid rgenw mpbir ssralv ee10 elintg ad3antlr mpbird simpr eleqtrrd fzssp1
      imass2 mp1i intss peano2nn syl2an 3sstr4d jca simprlr rexrab rexeqdv fofn
      wfn sseq1 rexrn bitr3d funfvima2 intss1 3syl reximdva sylbid syl5bir syld
      sstr2 rexbidva sylibrd nnex mptex eleq2d sseq12d anbi12d imbi2d 3anbi123d
      feq1 spcev syl3anc expr adantrrl exlimdv mpd rexlimddv ) EUDKZBFKZLZUAMZU
      EUHUFZBUBMZKZBHMZKZUXLUXJNZLZHUXHOZPZUBEQZLZRECMZUGZBDMZUXTUIZKZUYBSUJUKZ
      UXTUIZUYCNZLZDRQZBAMZKZUYCUYJNZDROZPZAEQZULZCUMZUAEUNZUAUBHBEFGUOUXGUXHUY
      RKZUXSLZLZRBIMZKZIUXHUPZUCMZUQZUCUMZUYQVUATVUDURUFZVUDRUHUFZVUGVUAVUDTVBZ
      VUHVUAVUCIUXHOZVUJVUAUXMHUXHOZVUKVUAUXMUXLFNZLZHUXHOZVULVUAFEKZUXRUXFVUOV
      UAEUSKZVUPUXEVUQUXFUYTEUTZVAEFGVCVDUXGUYSUXIUXRVEUXEUXFUYTVFUXQUXFVUOPUBF
      EUXJFVGZUXKUXFUXPVUOUXJFBVHVUSUXOVUNHUXHVUSUXNVUMUXMUXJFUXLVIVJVKVNVLVMVU
      NUXMHUXHUXMVUMVOVPVDUXMVUCHIUXHUXLVUBBVHVQVRVUCIUXHVSVTVUDVUCIUXHUAWEZWAW
      BVTVUAVUDUXHUHUFZUXHRUHUFZVUIUXHWFKVUDUXHNVVAVUTVUCIUXHWCZVUDUXHWFWDWGVUA
      UXIUERWHUFVVBUXGUYSUXIUXRWIRUEWJWKUXHUERWLWMVUDUXHRWQWNRVUDUCWRWOVUAVUFUY
      QUCUXGUYSUXRVUFUYQPUXIUXGUYSUXRLZVUFUYQUXGVVDVUFLZLZREJRVUESJMZWPUKZWSZWT
      ZXAZUGZBUYBVVKUIZKZUYEVVKUIZVVMNZLZDRQZUYKVVMUYJNZDROZPZAEQZUYQVVFJRVVJEV
      VKVVFVVGRKZLZVUQVVIENZVVITVBZVVIXBKZVVJEKZUXEVUQUXFVVEVWCVURXCVWDVVIVUEXD
      ZEVUEVVHXEVVFVWIENVWCVVFVWIVUDEVUFVWIVUDVGZUXGVVDRVUDVUEXFXIZVVFVUDUXHEVV
      CVVFUXHEUXGUYSUXRVUFXGXHXJXKXLXJVWDVUEXMZVVHXNZTVBVWFVWDVWMVVHTVWDVVHVWLN
      ZVWMVVHVGVVFVWNVWCVVFRVVHVWLDVVHRUYBVVGXTXOVVFRVUDVUEUGZVWLRVGZVUFVWOUXGV
      VDRVUDVUEXPXIZRVUDVUEYAVDZXQXLZVVHVWLXRVRVWCVVFVVGVVHKZVVHTVBZVVGXSVWTVXA
      VVFVVHVVGYBYCYDYEVVITVWMTVUEVVHYFUUAVTVWDVVHXBKVVHVVIVUEVVHUUBZUQZVWGVWDS
      VVGUUCVWDVUEUUDZVWNVXCVVFVXDVWCVVFVWOVXDVWQRVUDVUEUUEVDZXLVWSVVHVUEUUFWOV
      VHVVIVXBUUGWOVUQVWEVWFVWGULVWHVVIEUUHYGUUIZVVKUUNZUUJVVFVVQDRVVFUYBRKZLZV
      VNVVPVXIBVUESUYBWPUKZWSZWTZVVMVXIBVXLKZBVVGKZJVXKQZVXIVXKVUDNVXNJVUDQZVXO
      VXIVWIVXKVUDVUEVXJXEVVFVWJVXHVWKXLUUKVXPVXNVXNPZJUXHQVXQJUXHVXNUULUUOVUCV
      XNVXNJIUXHVUBVVGBVHUUMUUPVXNJVXKVUDUUQUURUXFVXMVXOYHUXEVVEVXHJBVXKFUUSUUT
      UVAVXIVXHVXLEKZVVMVXLVGVVFVXHUVBVVFVWHJRQZVXHVXRVVFVWHJRVXFYIZVWHVXRJUYBR
      JDYJZVVJVXLEVYAVVIVXKVYAVVHVXJVUEVVGUYBSWPYKYLYMZYNYOYPJUYBVVJVXLREVVKVYB
      VXGYQWOZUVCVXIVUESUYEWPUKZWSZWTZVXLVVOVVMVXIVXKVYENZVYFVXLNVXJVYDNVYGVXIS
      UYBUVDVXJVYDVUEUVEUVFVXKVYEUVGVDVXIUYERKZVYFEKZVVOVYFVGVXHVYHVVFUYBUVHZYC
      VVFVXSVYHVYIVXHVXTVYJVWHVYIJUYERVVGUYEVGZVVJVYFEVYKVVIVYEVYKVVHVYDVUEVVGU
      YESWPYKYLYMZYNYOUVIJUYEVVJVYFREVVKVYLVXGYQWOVYCUVJUVKYIVVFVWAAEVVFUYJEKZL
      ZUYKVXLUYJNZDROZVVTVYNUYKUXMUXLUYJNZLZHUXHOZVYPVVFUXRVYMUYKVYSPZUXGUYSUXR
      VUFUVLUXQVYTUBUYJEUBAYJZUXKUYKUXPVYSUXJUYJBVHWUAUXOVYRHUXHWUAUXNVYQUXMUXJ
      UYJUXLVIVJVKVNYOYPVYSVYQHVUDOZVYNVYPVUCUXMVYQHIUXHVUBUXLBVHUVMVYNWUBUYBVU
      EUIZUYJNZDROZVYPVVFWUBWUEYHVYMVVFVYQHVWIOZWUBWUEVVFVYQHVWIVUDVWKUVNVVFVUE
      RUVPZWUFWUEYHVUFWUGUXGVVDRVUDVUEUVOXIVYQWUDHDRVUEUXLWUCUYJUVQUVRVDUVSXLVY
      NWUDVYODRVYNVXHLWUCVXKKZVXLWUCNWUDVYOPVXHVYNUYBVXJKZWUHUYBXSVYNWUIWUHVYNV
      XDVXJVWLNWUIWUHPVVFVXDVYMVXEXLVYNRVXJVWLJVXJRVVGUYBXTXOVVFVWPVYMVWRXLXQVX
      JUYBVUEUVTWOYGYDWUCVXKUWAVXLWUCUYJUWGUWBUWCUWDUWEUWFVVFVVTVYPYHVYMVVFVVSV
      YODRVXIVVMVXLUYJVYCYRUWHXLUWIYIUYPVVLVVRVWBULCVVKJRVVJUWJUWKUXTVVKVGZUYAV
      VLUYIVVRUYOVWBREUXTVVKUWQWUJUYHVVQDRWUJUYDVVNUYGVVPWUJUYCVVMBUYBUXTVVKYSZ
      UWLWUJUYFVVOUYCVVMUYEUXTVVKYSWUKUWMUWNYTWUJUYNVWAAEWUJUYMVVTUYKWUJUYLVVSD
      RWUJUYCVVMUYJWUKYRVKUWOYTUWPUWRUWSUWTUXAUXBUXCUXD $.
  $}

  ${
    $d j x y J $.  $d x B $.
    $( The property of being second-countable.  (Contributed by Jeff Hankins,
       17-Jan-2010.)  (Revised by Mario Carneiro, 21-Mar-2015.) $)
    is2ndc $p |- ( J e. 2ndc <-> E. x e. TopBases ( x ~<_ om /\
      ( topGen ` x ) = J ) ) $=
      ( vj c2ndc wcel com cdom wbr ctg cfv wceq ctb wrex cab df-2ndc eleq2i cvv
      cv wa simpr fvex syl6eqelr rexlimivw eqeq2 anbi2d rexbidv elab3 bitri ) B
      DEBARZFGHZUIIJZCRZKZSZALMZCNZEUJUKBKZSZALMZDUPBACOPUOUSCBURBQEALURBUKQUJU
      QTUIIUAUBUCULBKZUNURALUTUMUQUJULBUKUDUEUFUGUH $.

    $( A second-countable topology is a topology.  (Contributed by Jeff
       Hankins, 17-Jan-2010.)  (Revised by Mario Carneiro, 21-Mar-2015.) $)
    2ndctop $p |- ( J e. 2ndc -> J e. Top ) $=
      ( vx c2ndc wcel cv com cdom wbr ctg cfv wceq wa ctb wrex ctop is2ndc tgcl
      simprr adantr eqeltrrd rexlimiva sylbi ) ACDBEZFGHZUCIJZAKZLZBMNAODZBAPUG
      UHBMUCMDZUGLUEAOUIUDUFRUIUEODUGUCQSTUAUB $.

    $( A countable basis generates a second-countable topology.  (Contributed
       by Mario Carneiro, 21-Mar-2015.) $)
    2ndci $p |- ( ( B e. TopBases /\ B ~<_ om ) -> ( topGen ` B ) e. 2ndc ) $=
      ( vx ctb wcel com cdom wbr wa ctg wceq wrex c2ndc simpl simpr eqidd breq1
      cv cfv fveq2 eqeq1d anbi12d rspcev syl12anc is2ndc sylibr ) ACDZAEFGZHZBQ
      ZEFGZUIIRZAIRZJZHZBCKZULLDUHUFUGULULJZUOUFUGMUFUGNUHULOUNUGUPHBACUIAJZUJU
      GUMUPUIAEFPUQUKULULUIAISTUAUBUCBULUDUE $.

    $( Having a countable subbase is a sufficient condition for
       second-countability.  (Contributed by Jeff Hankins, 17-Jan-2010.)
       (Proof shortened by Mario Carneiro, 21-Mar-2015.) $)
    2ndcsb $p |- ( J e. 2ndc <-> E. x ( x ~<_ om /\
      ( topGen ` ( fi ` x ) ) = J ) ) $=
      ( vy wcel cv com cdom wbr cfi cfv ctg wceq wex ctb wrex is2ndc wss adantr
      wa cvv c2ndc df-rex ssfii fvex bastg fiss sylancr ctop tgcl fitop sseqtrd
      simprl syl 2basgen syl2anc simprr eqtr3d eximi sylbi fibas simpl wb fictb
      jca vex ax-mp sylib simpr breq1 fveq2 eqeq1d anbi12d rspcev sylibr impbii
      exlimiv ) BUADZAEZFGHZVRIJZKJZBLZSZAMZVQVSVRKJZBLZSZANOZWDABPWHVRNDZWGSZA
      MWDWGANUBWJWCAWJVSWBWIVSWFULWJWEWABWJVRVTQZVTWEQWEWALWIWKWGVRNUCRWJVTWEIJ
      ZWEWJWETDVRWEQZVTWLQVRKUDWIWMWGVRNUERVRWETUFUGWJWEUHDZWLWELWIWNWGVRUIRWEU
      JUMUKVRVTUNUOWIVSWFUPUQVDURUSUSWCVQAWCCEZFGHZWOKJZBLZSZCNOZVQWCVTNDVTFGHZ
      WBSZWTVRUTWCXAWBWCVSXAVSWBVAVRTDVSXAVBAVEVRTVCVFVGVSWBVHVDWSXBCVTNWOVTLZW
      PXAWRWBWOVTFGVIXCWQWABWOVTKVJVKVLVMUGCBPVNVPVO $.

    $( A second-countable space has at most the cardinality of the continuum.
       (Contributed by Mario Carneiro, 9-Apr-2015.) $)
    2ndcredom $p |- ( J e. 2ndc -> J ~<_ RR ) $=
      ( vx c2ndc wcel cv com cdom wbr ctg cfv wceq wa ctb cr cpw cn cen domentr
      ensymi sylancl wrex is2ndc tgdom adantr simpr nnenom pwdom rpnnen syl2anc
      syl domtr breq1 syl5ibcom expimpd rexlimiv sylbi ) ACDBEZFGHZUQIJZAKZLZBM
      UAANGHZBAUBVAVBBMUQMDZURUTVBVCURLZUSNGHZUTVBVDUSUQOZGHZVFNGHZVEVCVGURUQMU
      CUDVDVFPOZGHZVINQHVHVDUQPGHZVJVDURFPQHVKVCURUEPFUFSUQFPRTUQPUGUJNVIUHSVFV
      INRTUSVFNUKUIUSANGULUMUNUOUP $.
  $}

  ${
    $d b o p q s t x y J $.
    $( A second-countable space is first-countable.  (Contributed by Jeff
       Hankins, 17-Jan-2010.) $)
    2ndc1stc $p |- ( J e. 2ndc -> J e. 1stc ) $=
      ( vs vx vo vp vb vq vy vt wcel cv com cdom wbr wss wa wrex wi wral ctb wb
      c2ndc ctop cpw cuni c1stc 2ndctop ctg cfv wceq is2ndc w3a ssrab2 3ad2ant1
      crab bastg syl5ss fvex elpw2 sylibr cvv vex ssdomg mp2 simp2 domtr eltg2b
      sylancr elequ1 anbi1d rexbidv rspccv id adantrr elequ2 elrab adantl sseq1
      simprr anbi12d rspcev rexlimdvaa syl9r sylbid ralrimiv breq1 rexeq imbi2d
      syl2anc ralbidv syl12anc 3expia unieq eleq2d pweq raleq rexeqbidv imbi12d
      anbi2d syl5ibcom expimpd rexlimiv sylbi eqid is1stc2 sylanbrc ) AUBJZAUCJ
      BKZLMNZCKZDKZJZXJEKZJZXMXKOZPZEXHQZRZDASZPZBAUDZQZCAUEZSAUFJAUGXGYBCYCXGF
      KZLMNZYDUHUIZAUJZPZFTQXJYCJZYBRZFAUKYHYJFTYDTJZYEYGYJYKYEPXJYFUEZJZXIXRDY
      FSZPZBYFUDZQZRYGYJYKYEYMYQYKYEYMULZXJGKJZGYDUOZYPJZYTLMNZXLXPEYTQZRZDYFSZ
      YQYRYTYFOUUAYRYTYDYFYSGYDUMZYKYEYDYFOYMYDTUPUNUQYTYFYDUHURUSUTYRYTYDMNZYE
      UUBYDVAJYTYDOUUGFVBUUFYTYDVAVCVDYKYEYMVEYTYDLVFVHYRUUDDYFYRXKYFJZHKZIKZJZ
      UUJXKOZPZIYDQZHXKSZUUDYKYEUUHUUOUAYMHIXKYDTVGUNUUOXLXJUUJJZUULPZIYDQZYRUU
      CUUNUURHXJXKUUIXJUJZUUMUUQIYDUUSUUKUUPUULHCIVIVJVKVLYRUUQUUCIYDYRUUJYDJZU
      UQPZPUUJYTJZUUQUUCUVAUVBYRUVAUUTUUPPZUVBUUTUUPUVCUULUVCVMVNYSUUPGUUJYDGIC
      VOVPUTVQYRUUTUUQVSXPUUQEUUJYTXMUUJUJXNUUPXOUULEICVOXMUUJXKVRVTWAWIWBWCWDW
      EYOUUBUUEPBYTYPXHYTUJZXIUUBYNUUEXHYTLMWFUVDXRUUDDYFUVDXQUUCXLXPEXHYTWGWHW
      JVTWAWKWLYGYMYIYQYBYGYLYCXJYFAWMWNYGYOXTBYPYAYFAWOYGYNXSXIXRDYFAWPWSWQWRW
      TXAXBXCWECBDEAYCYCXDXEXF $.
  $}

  ${
    $d a t v w x y z A $.  $d x B $.  $d a t w x y z J $.  $d a t w x y z V $.
    $( Lemma for ~ 1stcrest .  (Contributed by Mario Carneiro, 21-Mar-2015.)
       (Revised by Mario Carneiro, 30-Apr-2015.) $)
    1stcrestlem $p |- ( B ~<_ om -> ran ( x e. B |-> C ) ~<_ om ) $=
      ( com cdom wbr cmpt crn cdm ccrd wcel wfo wss con0 word cvv mpancom domtr
      reldom ee10 ordom brrelex2i elong syl mpbiri ondomen eqid dmmptss sylancl
      wb ssnum wfun funmpt funforn mpbi fodomnum brrelexi ssdomg syl2anc ) BDEF
      ZABCGZHZVAIZEFZVCDEFZVBDEFUTVCJIZKZVCVBVALZVDUTBVFKZVCBMZVGDNKZUTVIUTVKDO
      ZUAUTDPKVKVLUJBDESUBDPUCUDUEDBUFQABCVAVAUGUHZBVCUKUIVAULVHABCUMVAUNUOVCVB
      VAUPTVCBEFZUTVEUTBPKVJVNBDESUQVMVCBPURTVCBDRQVBVCDRUS $.

    $( A subspace of a first-countable space is first-countable.  (Contributed
       by Mario Carneiro, 21-Mar-2015.) $)
    1stcrest $p |- ( ( J e. 1stc /\ A e. V ) -> ( J |`t A ) e. 1stc ) $=
      ( vy vx vz vw vt va vv wcel wa cv com cdom wss wrex wi wceq cvv c1stc wbr
      crest co ctop wral cpw cuni 1stctop resttop sylan cin eqid eleq2d biimpar
      restuni2 simpl inss2 sseli 1stcclb syl2an simplll ad2antrl ssrest syl2anc
      elpwi ovex elpw2 cmpt crn vex simpllr restval sylancr simprrl 1stcrestlem
      sylibr syl eqbrtrd wb ad3antrrr elrest r19.29 simprr a1d ancld elin ssrin
      syl6ibr anim12d reximdv inex1 simp-4r eleq2 sseq1 anbi12d adantl rexxfr2d
      sylibrd com23 imim2d imp4b syl6bb sseq2 anbi2d rexbidv imbi12d syl5ibrcom
      a1i expr expimpd rexlimdva syl5 exp3a impr adantrrl sylbid ralrimiv breq1
      rexeq imbi2d ralbidv rspcev syl12anc rexlimddv ralrimiva is1stc2 sylanbrc
      syldan ) BUAKZACKZLZBAUCUDZUEKZDMZNOUBZEMZFMZKZYQGMZKZYTYRPZLZGYOQZRZFYMU
      FZLZDYMUGZQZEYMUHZUFYMUAKYJBUEKZYKYNBUIZABCUJUKYLUUIEUUJYLYQUUJKZYQABUHZU
      LZKZUUIYLUUPUUMYLUUOUUJYQYJUUKYKUUOUUJSUULABCUUNUUNUMZUPUKUNUOYLUUPLZHMZN
      OUBZYQIMZKZYQYOKZYOUVAPZLZDUUSQZRZIBUFZLZUUIHBUGZYLYJYQUUNKUVIHUVJQUUPYJY
      KUQUUOUUNYQAUUNURUSHIDYQBUUNUUQUTVAUURUUSUVJKZUVILZLZUUSAUCUDZUUHKZUVNNOU
      BZYSUUCGUVNQZRZFYMUFZUUIUVMUVNYMPZUVOUVMYJUUSBPZUVTYJYKUUPUVLVBUVKUWAUURU
      VIUUSBVFVCAUUSBUAVDVEUVNYMBAUCVGVHVQUVMUVNJUUSJMAULZVIVJZNOUVMUUSTKZYKUVN
      UWCSHVKZYJYKUUPUVLVLZJAUUSTCVMVNUVMUUTUWCNOUBUURUVKUUTUVHVOJUUSUWBVPVRVSU
      VMUVRFYMUVMYRYMKZYRUVAAULZSZIBQZUVRUVMUUKYKUWGUWJVTYJUUKYKUUPUVLUULWAUWFI
      YRABUECWBVEUURUVKUVHUWJUVRRZUUTUURUVKUVHUWKUURUVKLZUVHUWJUVRUVHUWJLUVGUWI
      LZIBQUWLUVRUVGUWIIBWCUWLUWMUVRIBUWLUVABKZLZUVGUWIUVRUWOUVGLUVRUWIUVBYQAKZ
      LZUUAYTUWHPZLZGUVNQZRUWOUVGUVBUWPUWTUWOUVFUWPUWTRUVBUWOUWPUVFUWTUWLUWNUWP
      UVFUWTRUWLUWNUWPLZLZUVFYQYOAULZKZUXCUWHPZLZDUUSQUWTUXBUVEUXFDUUSUXBUVCUXD
      UVDUXEUXBUVCUVCUWPLUXDUXBUVCUWPUXBUWPUVCUWLUWNUWPWDWEWFYQYOAWGWIUVDUXERUX
      BYOUVAAWHXIWJWKUXBUWSUXFGDUXCUVNUUSTUXCTKUXBYOUUSKLYOADVKWLXIUXBUWDYKYTUV
      NKYTUXCSZDUUSQVTUWEYJYKUUPUVKUXAWMDYTAUUSTCWBVNUXGUWSUXFVTUXBUXGUUAUXDUWR
      UXEYTUXCYQWNYTUXCUWHWOWPWQWRWSXJWTXAXBUWIYSUWQUVQUWTUWIYSYQUWHKUWQYRUWHYQ
      WNYQUVAAWGXCUWIUUCUWSGUVNUWIUUBUWRUUAYRUWHYTXDXEXFXGXHXKXLXMXNXOXPXQXRUUG
      UVPUVSLDUVNUUHYOUVNSZYPUVPUUFUVSYOUVNNOXSUXHUUEUVRFYMUXHUUDUVQYSUUCGYOUVN
      XTYAYBWPYCYDYEYIYFEDFGYMUUJUUJUMYGYH $.

    $( A subspace of a second-countable space is second-countable.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    2ndcrest $p |- ( ( J e. 2ndc /\ A e. V ) -> ( J |`t A ) e. 2ndc ) $=
      ( vx vy wcel c2ndc crest co cv com cdom wbr ctg cfv wceq ctb wrex syl2anc
      wa is2ndc simplr simpll restbas ad2antlr cin cmpt crn restval 1stcrestlem
      tgrest adantl eqbrtrd 2ndci eqeltrrd oveq1 eleq1d syl5ibcom syl5bi impcom
      expimpd rexlimdva ) ACFZBGFZBAHIZGFZVDDJZKLMZVGNOZBPZTZDQRVCVFDBUAVCVKVFD
      QVCVGQFZTZVHVJVFVMVHTZVIAHIZGFVJVFVNVGAHIZNOZVOGVNVLVCVQVOPVCVLVHUBZVCVLV
      HUCZAVGQCUKSVNVPQFZVPKLMVQGFVLVTVCVHAVGUDUEVNVPEVGEJAUFZUGUHZKLVNVLVCVPWB
      PVRVSEAVGQCUISVHWBKLMVMEVGWAUJULUMVPUNSUOVJVOVEGVIBAHUPUQURVAVBUSUT $.
  $}

  ${
    $d b c d f m n o t u v w x B $.  $d b c d f m n o t x J $.
    $d d f m n o t x S $.
    2ndcctbss.1 $e |- X = U. B $.
    2ndcctbss.2 $e |- J = ( topGen ` B ) $.
    2ndcctbss.3 $e |- S = { <. u , v >. |
      ( u e. c /\ v e. c /\ E. w e. B ( u C_ w /\ w C_ v ) ) } $.
    $( If a topology is second-countable, every base has a countable subset
       which is a base.  Exercise 16B2 in Willard.  (Contributed by Jeff
       Hankins, 28-Jan-2010.)  (Proof shortened by Mario Carneiro,
       21-Mar-2015.) $)
    2ndcctbss $p |- ( ( B e. TopBases /\ J e. 2ndc ) -> E. b e. TopBases
      ( b ~<_ om /\ b C_ B /\ J = ( topGen ` b ) ) ) $=
      ( wcel wa cv com cdom wbr wceq wss vf vx vt vo vd vm vn ctb c2ndc ctg cfv
      w3a wrex simpr is2ndc sylib cid c1st c2nd wral wex cxp cvv vex xpex copab
      wel 3simpa ssopab2i df-xp 3sstr4i ssdomg mp2 cen xpdom1 omex xpdom2 domtr
      wf syl2anc xpomen domentr sylancl adantr ad2antll sylancr cop wrel 1st2nd
      relopabi eqeltrrd df-br fvex simpl sseq1 sseq2 bi2anan9 rexbidv 3anbi123d
      eleq1d bitr3i simp3bi syl fvi ad3antrrr rexeqdv mpbird ralrimiva axcc4dom
      braba anbi12d ad2antrr feq3 anbi1d crn ctop 2ndctop adantl ad2antrl bastg
      wb sstrd simprrl simprr ad2antlr simprrr tg2 sseqtrd simprl sseldd rspcev
      simplrl weq syl12anc syl3anbrc wi fveq2 sseq12d ex rexlimddv frn eleqtrrd
      syl6sseqr eqeq2i biimpi syl6req wfn ffn fnfvelrn rspcv op1st sseq1i op2nd
      simplll sseq2i anbi12i simplrr jca syld com12 exp4c imp41 eleq2 ralrimivv
      syl5bi expr basgen2 syl3anc eqeltrd tgclb sylibr ccrd cdm wfo con0 omelon
      ondomen dffn4 fodomnum sylc eqcomd breq1 eqeq2d syl13anc sylbid exlimdv
      mpd ) DUHMZFUIMZNZIOZPQRZUWKUJUKZFSZNZHOZPQRZUWPDTZFUWPUJUKZSZULZHUHUMZIU
      HUWJUWIUWOIUHUMUWHUWIUNIFUOUPUWJUWKUHMZUWONZNZEDUQUKZUAOZVSZUBOZURUKZUXIU
      XGUKZTZUXKUXIUSUKZTZNZUBEUTZNZUAVAZUXBUXEEPQRZUXJAOZTZUXTUXMTZNZAUXFUMZUB
      EUTUXRUXEEUWKUWKVBZQRZUYEPQRZUXSUYEVCMEUYETUYFUWKUWKIVDZUYHVECIVGZBIVGZCO
      ZUXTTZUXTBOZTZNZADUMZULZCBVFUYIUYJNZCBVFEUYEUYQUYRCBUYIUYJUYPVHVILCBUWKUW
      KVJVKEUYEVCVLVMUWOUYGUWJUXCUWLUYGUWNUWLUYEPPVBZQRZUYSPVNRUYGUWLUYEPUWKVBZ
      QRVUAUYSQRUYTUWKPUWKUYHVOUWKPPVPVQUYEVUAUYSVRVTWAUYEUYSPWBWCWDWEEUYEPVRWF
      ZUXEUYDUBEUXEUXIEMZNZUYDUYCADUMZVUDUXJUXMWGZEMZVUEVUDUXIVUFEVUDEWHVUCUXIV
      UFSUYQCBELWJUXEVUCUNZUXIEWIWFVUHWKVUGUXJUWKMZUXMUWKMZVUEVUGUXJUXMERVUIVUJ
      VUEULZUXJUXMEWLUYQVUKCBUXJUXMEUXIURWMUXIUSWMUYKUXJSZUYMUXMSZNZUYIVUIUYJVU
      JUYPVUEVUNUYKUXJUWKVULVUMWNWTVUNUYMUXMUWKVULVUMUNWTVUNUYOUYCADVULUYLUYAVU
      MUYNUYBUYKUXJUXTWOUYMUXMUXTWPWQWRWSLXJXAXBXCVUDUYCAUXFDUWHUXFDSZUWIUXDVUC
      DUHXDZXEXFXGXHUYCUXOAUXFUAUBEDUQWMUXTUXKSUYAUXLUYBUXNUXTUXKUXJWPUXTUXKUXM
      WOXKXIVTUXEUXQUXBUAUXEUXQEDUXGVSZUXPNZUXBUXEUXHVUQUXPUXEVUOUXHVUQYAUWHVUO
      UWIUXDVUPXLUXFDEUXGXMXCXNUXEVURUXBUXEVURNZUXGXOZUHMZVUTPQRZVUTDTZFVUTUJUK
      ZSZUXBVUSVVDXPMVVAVUSVVDFXPVUSFXPMZVUTFTUCHVGZUWPUDOZTZNZHVUTUMZUCVVHUTUD
      FUTVVDFSUWJVVFUXDVURUWIVVFUWHFXQXRXLZVUSVUTDFVUQVVCUXEUXPEDUXGUUAXSZVUSDD
      UJUKZFUWHDVVNTZUWIUXDVURDUHXTZXEKUUCYBVUSVVKUDUCFVVHUXEVURVVHFMZUCUDVGZNZ
      VVKUXEVURVVSNZNZUCUEVGZUEOZVVHTZNZVVKUEUWKVWAVVHUWMMVVRVWEUEUWKUMVWAVVHFU
      WMUXEVURVVQVVRYCUXDUWNUWJVVTUXCUWLUWNYDYEZUUBUXEVURVVQVVRYFUEVVHUWKUCOZYG
      VTVWAUEIVGZVWENZNZUCUFVGZUFOZVWCTZNZVVKUFDVWJVWCVVNMVWBVWNUFDUMVWJUWKVVNV
      WCVWJUWKUWMVVNUXEUWKUWMTZVVTVWIUXCVWOUWJUWOUWKUHXTXSXLUXEUWMVVNSZVVTVWIUW
      OVWPUWJUXCUWNVWPUWLUWNVWPFVVNUWMKUUDUUEXRWEXLYHVWAVWHVWEYIZYJVWAVWHVWBVWD
      YCUFVWCDVWGYGVTVWJVWLDMZVWNNZNZUCUGVGZUGOZVWLTZNZVVKUGUWKVWTVWLUWMMVWKVXD
      UGUWKUMVWTDUWMVWLVWTDVVNUWMVWAVVOVWIVWSUWHVVOUWIUXDVVTVVPXEXLVWTUWMFVVNVW
      AUWNVWIVWSVWFXLKUUFYHVWJVWRVWNYIYJVWJVWRVWKVWMYCUGVWLUWKVWGYGVTVWTUGIVGZV
      XDNZNZVXBVWCWGZUXGUKZVUTMZVWGVXIMZVXIVVHTZNZVVKVXGUXGEUUGZVXHEMZVXJVWJVXN
      VWSVXFVVTVXNUXEVWIVUQVXNUXPVVSEDUXGUUHZXLYEXLVXGVXEVWHVXBUXTTZUXTVWCTZNZA
      DUMZVXOVWTVXEVXDYIVWJVWHVWSVXFVWQXLVXGVWRVXCVWMVXTVWJVWRVWNVXFYLVWTVXEVXA
      VXCYFVWSVWMVWJVXFVWRVWKVWMYDZYEVXSVXCVWMNAVWLDAUFYMVXQVXCVXRVWMUXTVWLVXBW
      PUXTVWLVWCWOXKYKZYNVXOVXBVWCERVXEVWHVXTULZVXBVWCEWLUYQVYCCBVXBVWCEUGVDZUE
      VDZCUGYMZBUEYMZNZUYIVXEUYJVWHUYPVXTVYHUYKVXBUWKVYFVYGWNWTVYHUYMVWCUWKVYFV
      YGUNWTVYHUYOVXSADVYFUYLVXQVYGUYNVXRUYKVXBUXTWOUYMVWCUXTWPWQWRWSLXJXAZYOEV
      XHUXGUUIVTVWAVWIVWSVXFVXMVVTVWIVWSVXFVXMYPYPYPZUXEUXPVYJVUQVVSUXPVWIVWSVX
      FVXMVWIVWSNZVXFNZUXPVXMVYLUXPVXHURUKZVXITZVXIVXHUSUKZTZNZVXMVYLVXOUXPVYQY
      PVYLVXEVWHVXTVXOVYKVXEVXDYIVWHVWEVWSVXFUUNVYLVWRVXCVWMVXTVWIVWRVWNVXFYLVY
      KVXEVXAVXCYFVWSVWMVWIVXFVYAYEVYBYNVYIYOUXOVYQUBVXHEUXIVXHSZUXLVYNUXNVYPVY
      RUXJVYMUXKVXIUXIVXHURYQUXIVXHUXGYQZYRVYRUXKVXIUXMVYOVYSUXIVXHUSYQYRXKUUJX
      CVYQVXBVXITZVXIVWCTZNZVYLVXMVYNVYTVYPWUAVYMVXBVXIVXBVWCVYDVYEUUKUULVYOVWC
      VXIVXBVWCVYDVYEUUMUUOUUPVYLWUBVXMVYLWUBNZVXKVXLWUCVXBVXIVWGVYLVYTWUAYIVXF
      VXAVYKWUBVXEVXAVXCYIYEYJWUCVXIVWCVVHVYLVYTWUAYDVYKVWDVXFWUBVWHVWBVWDVWSUU
      QXLYBUURYSUVEUUSUUTUVAYEXRUVBVVJVXMHVXIVUTUWPVXISVVGVXKVVIVXLUWPVXIVWGUVC
      UWPVXIVVHWOXKYKVTYTYTYTUVFUVDUDUCHVUTFUVGUVHZVVLUVIVUTUVJUVKVUSVUTEQRZUXS
      VVBVUSEUVLUVMMZEVUTUXGUVNZWUEVUSPUVOMUXSWUFUVPUXEUXSVURVUBWDZPEUVQWFVUSVX
      NWUGVUQVXNUXEUXPVXPXSEUXGUVRUPEVUTUXGUVSUVTWUHVUTEPVRVTVVMVUSVVDFWUDUWAUX
      AVVBVVCVVEULHVUTUHUWPVUTSZUWQVVBUWRVVCUWTVVEUWPVUTPQUWBUWPVUTDWOWUIUWSVVD
      FUWPVUTUJYQUWCWSYKUWDYSUWEUWFUWGYT $.
  $}

  ${
    $d b f w x y z A $.  $d b f n w y z B $.  $d b f x J $.
    $( Any disjoint family of open sets in a second-countable space is
       countable.  (The sets are required to be nonempty because otherwise
       there could be many empty sets in the family.)  (Contributed by Mario
       Carneiro, 21-Mar-2015.)  (Proof shortened by Mario Carneiro,
       9-Apr-2015.)  (Revised by NM, 17-Jun-2017.) $)
    2ndcdisj $p |- ( ( J e. 2ndc /\ A. x e. A B e. ( J \ { (/) } ) /\
        A. y E* x e. A y e. B ) -> A ~<_ om ) $=
      ( vb vn vw vz wcel c0 cv com cfv wceq wa wi syl wne c1o vf c2ndc csn cdif
      wral wrmo wal cdom wbr ctg ctb wrex is2ndc wf1 wex omex brdom cvv cpw crn
      ccnv crab cint cmpt wf wmo wss ssrab2 f1f adantl syl5ss adantr eldifsn n0
      frn wel tg2 con0 omsson syl6ss ad2antrr wfn f1fn ad3antlr simprl fnfvelrn
      syl2anc wf1o f1f1orn f1ocnvfv1 simprrr elpw simprrl ne0i sylanbrc eqeltrd
      vex sylibr fveq2 eleq1d rspcev rabn0 onint rexlimdvaa syl5 expdimp syl5bi
      exlimdv expimpd impr sseldd expr ralimdva imp adantrr eqid fmpt sylib cif
      neeq1 1n0 elimhyp mpbi 19.29r mpan eleq1 syl5ibrcom simprbi simprd iftrue
      weq elrab simpld elpwid eqsstrd sseld exp31 com23 nfcv ex exp4a com25 nfv
      imp31 an32s rmoim nfmpt1 nfbr breq1 cop copab df-mpt eleq2i opabid 3bitri
      df-br syl6bb cbvmo df-rmo bitr4i alrimiv dff12 f1domg mpsyl difeq1 eleq2d
      ralbidv anbi1d imbi1d syl5ibcom imp3a rexlimiv sylbi 3impib ) EUBJZDEKUCZ
      UDZJZACUEZBLZDJZACUFZBUGZCMUHUIZUVOFLZMUHUIZUWEUJNZEOZPZFUKULUVSUWCPZUWDQ
      ZFEUMUWIUWKFUKUWEUKJZUWFUWHUWKUWFUWEMUALZUNZUAUOUWLUWHUWKQZUWEMUAUPUQUWLU
      WNUWOUAUWLUWNUWOUWLUWNPZDUWGUVPUDZJZACUEZUWCPZUWDQUWHUWKUWPUWTUWDMURJUWPU
      WTPZCMACGLZUWMVAZNZDUSZUVPUDZJZGUWMUTZVBZVCZVDZUNZUWDUPUXACMUXKVEZHLZILZU
      XKUIZHVFZIUGUXLUXAUXJMJZACUEZUXMUWPUWSUXSUWCUWPUWSUXSUWPUWRUXRACUWPALZCJZ
      UWRUXRUWPUYAUWRPZPZUXIMUXJUWPUXIMVGUYBUWPUXIUXHMUXGGUXHVHUWNUXHMVGZUWLUWN
      UWEMUWMVEUYDUWEMUWMVIUWEMUWMVORVJVKZVLUWPUYAUWRUXJUXIJZUWRDUWGJZDKSZPUWPU
      YAPZUYFDUWGKVMUYIUYGUYHUYFUYHUWABUOUYIUYGPZUYFBDVNUYJUWAUYFBUYIUYGUWAUYFU
      YGUWAPBIVPZUXODVGZPZIUWEULUYIUYFIDUWEUVTVQUYIUYMUYFIUWEUYIIFVPZUYMPZPZUXI
      VRVGZUXIKSZUYFUWPUYQUYAUYOUWPUXIMVRUYEVSVTWAUYPUXGGUXHULZUYRUYPUXOUWMNZUX
      HJZUYTUXCNZUXFJZUYSUYPUWMUWEWBZUYNVUAUWNVUDUWLUYAUYOUWEMUWMWCWDUYIUYNUYMW
      EZUWEUXOUWMWFWGUYPVUBUXOUXFUYPUWEUXHUWMWHZUYNVUBUXOOUWNVUFUWLUYAUYOUWEMUW
      MWIWDVUEUWEUXHUXOUWMWJWGUYPUXOUXEJZUXOKSZUXOUXFJUYPUYLVUGUYIUYNUYKUYLWKUX
      ODIWQWLWRUYPUYKVUHUYIUYNUYKUYLWMUXOUVTWNRUXOUXEKVMWOWPUXGVUCGUYTUXHUXBUYT
      OUXDVUBUXFUXBUYTUXCWSWTXAWGUXGGUXHXBWRUXIXCWGXDXEXFXHXGXIXGXJZXKXLXMXNXOA
      CMUXJUXKUXKXPXQXRUXAUXQIUXAUXOUXJOZACUFZUXQUWPUWSUWCVUKUWCUVTUXOUXCNZKSZV
      ULTXSZJZUWBPZBUOZUWPUWSPZVUKVUOBUOZUWCVUQVUNKSZVUSVUMVUTTKSVULTVULVUNKXTT
      VUNKXTYAYBBVUNVNYCVUOUWBBYDYEVURVUPVUKBVURVUOUWBVUKVURVUOPVUJUWAQZACUEZUW
      BVUKQUWPVUOUWSVVBUWPVUOPZUWSVVBVVCUWRVVAACUWPVUOUYAUWRVVAQUWPVUJUYAUWRVUO
      UWAUWPVUJUYAUWRVUOUWAQZUWPUYBVUJVVDUWPUYBVUJVVDUYCVUJPZVUNDUVTVVEVUNVULDV
      VEVUMVUNVULOVVEVULUXEJZVUMVVEVULUXFJZVVFVUMPVVEUXOUXIJZVVGUYCVUJVVHUYCVVH
      VUJUYFVUIUXOUXJUXIYFYGXNVVHUXOUXHJVVGUXGVVGGUXOUXHGIYKUXDVULUXFUXBUXOUXCW
      SWTYLYHRVULUXEKVMXRZYIVUMVULTYJRVVEVULDVVEVVFVUMVVIYMYNYOYPYQYRUUAUUBUUDX
      MXNUUEVUJUWAACUUFRXIXHXEXJUXQUYAVUJPZAVFVUKUXPVVJHAAUXNUXOUXKAUXNYSACUXJU
      UGAUXOYSUUHVVJHUUCHAYKUXPUXTUXOUXKUIZVVJUXNUXTUXOUXKUUIVVKUXTUXOUUJZUXKJV
      VLVVJAIUUKZJVVJUXTUXOUXKUUPUXKVVMVVLAICUXJUULUUMVVJAIUUNUUOUUQUURVUJACUUS
      UUTWRUVAHICMUXKUVBWOCMURUXKUVCUVDYTUWHUWTUWJUWDUWHUWSUVSUWCUWHUWRUVRACUWH
      UWQUVQDUWGEUVPUVEUVFUVGUVHUVIUVJYTXHXGUVKUVLUVMUVN $.

    $( Any disjoint collection of open sets in a second-countable space is
       countable.  (Contributed by Mario Carneiro, 21-Mar-2015.)  (Proof
       shortened by Mario Carneiro, 9-Apr-2015.)  (Revised by NM,
       17-Jun-2017.) $)
    2ndcdisj2 $p |- ( ( J e. 2ndc /\ A C_ J /\ A. y E* x e. A y e. x )
        -> A ~<_ om ) $=
      ( wrmo wal wcel wss wa wmo com cdom wbr df-rmo albii cun cvv cdif ssdomg
      c0 wel c2ndc cv w3a csn undif2 omex peano1 snssi ax-mp mp2 id ssdif dfss3
      sylib eldifi anim1i moimi alimi 2ndcdisj syl3an3br syl3an unctb syl5eqbrr
      wral sylancr reldom brrelexi syl ssun2 ee10 domtr syl2anc syl3an3b ) BAUA
      ZACEZBFDUBGZCDHZAUCZCGZVOIZAJZBFZCKLMZVPWBBVOACNOVQVRWCUDZCTUEZCPZLMZWGKL
      MZWDWEWGQGZCWGHWHWEWIWJWEWGWFCWFRZPZKLWFCUFWEWFKLMZWKKLMZWLKLMKQGWFKHZWMU
      GTKGWOUHTKUIUJWFKQSUKVQVQVRVSDWFRZGAWKVEZWCVSWKGZVOIZAJZBFZWNVQULVRWKWPHW
      QCDWFUMAWKWPUNUOWBWTBWSWAAWRVTVOVSCWFUPUQURUSXAVQWQVOAWKEZBFWNXBWTBVOAWKN
      OABWKVSDUTVAVBWFWKVCVFVDZWGKLVGVHVICWFVJCWGQSVKXCCWGKVLVMVN $.
  $}

  ${
    $d k m t w x z F $.  $d b k m t x z J $.  $d b k m t x z ph $.  $d m t X $.
    $d b k m t w x z K $.
    2ndcomap.2 $e |- Y = U. K $.
    2ndcomap.3 $e |- ( ph -> J e. 2ndc ) $.
    2ndcomap.5 $e |- ( ph -> F e. ( J Cn K ) ) $.
    2ndcomap.6 $e |- ( ph -> ran F = Y ) $.
    2ndcomap.7 $e |- ( ( ph /\ x e. J ) -> ( F " x ) e. K ) $.
    $( A surjective continuous open map maps second-countable spaces to
       second-countable spaces.  (Contributed by Mario Carneiro,
       9-Apr-2015.) $)
    2ndcomap $p |- ( ph -> K e. 2ndc ) $=
      ( vb vz vk cv wceq wa wcel syl syl2anc vw vt vm com cdom wbr ctg cfv wrex
      ctb c2ndc is2ndc sylib cima cmpt crn ctop wss wel wral co cntop2 ad2antrr
      ccn wf simplll bastg ad2antlr simprr sseqtrd sselda eqid fmptd frn elunii
      cuni syl6eleqr ancoms adantl ad3antrrr eleqtrrd wfn cnf ffn fvelrnb mpbid
      wb 3syl ccnv simprll cnima adantr simprrl simprrr simprlr eqeltrd adantrr
      elpreima mpbir2and tg2 simprl imaeq2 eqeq2d rspcev sylancl cvv wfun fnfun
      funimass2 vex ssexg elrnmpt mpbird cdm cnvimass syl6ss funfvima2 eqeltrrd
      eleq2 sseq1 anbi12d syl12anc rexlimddv anassrs ralrimivva basgen2 syl3anc
      mpd tgclb sylibr ccrd wfo con0 omelon ondomen sylancr dffn4 fodomnum sylc
      wi domtr 2ndci ex rexlimdva ) ALOZUDUEUFZUUEUGUHZDPZQZLUJUIZEUKRZADUKRUUJ
      HLDULUMAUUIUUKLUJAUUEUJRZQZUUIUUKUUMUUIQZBUUECBOZUNZUOZUPZUGUHZEUKUUNEUQR
      ZUUREURZMUAUSZUAOZNOZURZQZUAUURUIZMUVDUTNEUTUUSEPAUUTUULUUIACDEVDVARZUUTI
      CDEVBSVCZUUNUUEEUUQVEZUVAUUNBUUEUUPEUUQUUNBLUSZQAUUODRUUPERAUULUUIUVKVFUU
      NUUEDUUOUUNUUEUUGDUULUUEUUGURAUUIUUEUJVGVHUUMUUFUUHVIZVJVKKTUUQVLZVMZUUEE
      UUQVNSUUNUVGNMEUVDUUNUVDERZMNUSZQZQZUBOZCUHZMOZPZUVGUBDVPZUVRUWACUPZRZUWB
      UBUWCUIZUVRUWAFUWDUVQUWAFRZUUNUVPUVOUWGUVPUVOQUWAEVPFUWAUVDEVOGVQVRVSAUWD
      FPUULUUIUVQJVTWAUVRUWCFCVEZCUWCWBZUWEUWFWGAUWHUULUUIUVQAUVHUWHICDEUWCFUWC
      VLGWCSVTZUWCFCWDZUBUWCUWACWEWHWFUUNUVQUVSUWCRZUWBQZUVGUUNUVQUWMQZQZUBUCUS
      ZUCOZCWIUVDUNZURZQZUVGUCUUEUWOUWRUUGRUVSUWRRZUWTUCUUEUIUWOUWRDUUGUWOUVHUV
      OUWRDRAUVHUULUUIUWNIVTUUNUVOUVPUWMWJUVDCDEWKTUUNUUHUWNUVLWLWAUWOUXAUWLUVT
      UVDRZUUNUVQUWLUWBWMUWOUVTUWAUVDUUNUVQUWLUWBWNZUUNUVOUVPUWMWOWPUWOUWIUXAUW
      LUXBQWGUUNUVQUWIUWMUVRUWHUWIUWJUWKSWQZUWCUVSUVDCWRSWSUCUWRUUEUVSWTTUWOUCL
      USZUWTQZQZCUWQUNZUURRZUWAUXHRZUXHUVDURZUVGUXGUXIUXHUUPPZBUUEUIZUXGUXEUXHU
      XHPZUXMUWOUXEUWTXAUXHVLUXLUXNBUWQUUEUUOUWQPUUPUXHUXHUUOUWQCXBXCXDXEUXGUXH
      XFRZUXIUXMWGUXGUXKUVDXFRUXOUXGCXGZUWSUXKUXGUWIUXPUWOUWIUXFUXDWLUWCCXHSZUW
      OUXEUWPUWSWNZUWQUVDCXITZNXJUXHUVDXFXKXEBUUEUUPUXHUUQXFUVMXLSXMUXGUVTUWAUX
      HUWOUWBUXFUXCWLUXGUWPUVTUXHRZUWOUXEUWPUWSWMUXGUXPUWQCXNZURUWPUXTYTUXQUXGU
      WQUWRUYAUXRCUVDXOXPUWQUVSCXQTYHXRUXSUVFUXJUXKQUAUXHUURUVCUXHPUVBUXJUVEUXK
      UVCUXHUWAXSUVCUXHUVDXTYAXDYBYCYDYCYENMUAUUREYFYGZUUNUURUJRZUURUDUEUFZUUSU
      KRUUNUUSUQRUYCUUNUUSEUQUYBUVIWPUURYIYJUUNUURUUEUEUFZUUFUYDUUNUUEYKXNRZUUE
      UURUUQYLZUYEUUNUDYMRUUFUYFYNUUMUUFUUHXAZUDUUEYOYPUUNUUQUUEWBZUYGUUNUVJUYI
      UVNUUEEUUQWDSUUEUUQYQUMUUEUURUUQYRYSUYHUURUUEUDUUATUURUUBTXRUUCUUDYH $.
  $}

  ${
    $d b f x y z $.  $d b x J $.  $d b x X $.
    2ndcsep.1 $e |- X = U. J $.
    $( A second-countable topology is separable, which is to say it contains a
       countable dense subset.  (Contributed by Mario Carneiro,
       13-Apr-2015.) $)
    2ndcsep $p |- ( J e. 2ndc ->
      E. x e. ~P X ( x ~<_ om /\ ( ( cls ` J ) ` x ) = X ) ) $=
      ( vb vf vy vz wcel cv com cdom wbr cfv wceq wa ctb wrex ccl c0 ctg is2ndc
      c2ndc cpw cuni csn cdif wral wel wex cvv wss vex difss ssdomg simpr domtr
      wf mp2 sylancr wne eldifsn n0 elunii jca expcom eximdv imp df-rex sylan2b
      simpl sylibr sylbi rgen uniex axcc4dom sylancl crn frn ad2antrl rnex elpw
      eleq1 ccrd cdm wfo con0 omelon ondomen ssnum wfn ffn dffn4 sylib fodomnum
      adantr sylc syl2anc ctop tgcl ad2antrr unitg ax-mp eqcomi clsss3 cin ne0i
      wi anim2i fnfvelrn sylan inelcm syl ex syl7 exp4a ralimdv2 ad2antlr eqidd
      a2d simplll elcls3 mpbird ssrdv eqssd breq1 fveq2 eqeq1d anbi12d syl12anc
      a1i rspcev exlimddv unieq 3eqtr4g pweqd fveq1d eqeq12d anbi2d rexeqbidv
      syl5ibcom impr rexlimiva ) BUCIEJZKLMZUUDUANZBOZPZEQRAJZKLMZUUIBSNZNZCOZP
      ZACUDZRZEBUBUUHUUPEQUUDQIZUUEUUGUUPUUQUUEPZUUJUUIUUFSNZNZUUDUEZOZPZAUVAUD
      ZRZUUGUUPUURUUDTUFZUGZUVAFJZURZGJZUVHNZUVJIZGUVGUHZPZUVEFUURUVGKLMZHGUIZH
      UVARZGUVGUHUVNFUJUURUVGUUDLMZUUEUVOUUDUKIZUVGUUDULZUVREUMZUUDUVFUNZUVGUUD
      UKUOUSUUQUUEUPZUVGUUDKUQUTZUVQGUVGUVJUVGIZGEUIZUVJTVAZPZUVQUVJUUDTVBZUWGU
      WFUVPHUJZUVQHUVJVCUWFUWJPHJZUVAIZUVPPZHUJZUVQUWFUWJUWNUWFUVPUWMHUVPUWFUWM
      UVPUWFPUWLUVPUWKUVJUUDVDUVPUWFVKVEVFVGVHUVPHUVAVIVLVJVMVNUVPUVLHUVAFGUVGU
      UDUWAVOUWKUVKUVJWCVPVQUURUVNPZUVHVRZUVDIZUWPKLMZUWPUUSNZUVAOZUVEUWOUWPUVA
      ULZUWQUVIUXAUURUVMUVGUVAUVHVSVTZUWPUVAUVHFUMWAWBVLUWOUWPUVGLMZUVOUWRUWOUV
      GWDWEZIZUVGUWPUVHWFZUXCUWOUUDUXDIZUVTUXEUWOKWGIUUEUXGWHUURUUEUVNUWCWPKUUD
      WIUTUWBUUDUVGWJVQUWOUVHUVGWKZUXFUVIUXHUURUVMUVGUVAUVHWLZVTUVGUVHWMWNUVGUW
      PUVHWOWQUURUVOUVNUWDWPUWPUVGKUQWRUWOUWSUVAUWOUUFWSIZUXAUWSUVAULUUQUXJUUEU
      VNUUDWTXAUXBUWPUUFUVAUUFUEZUVAUVSUXKUVAOUWAUUDUKXBXCXDZXEWRUWOAUVAUWSUWOU
      UIUVAIZUUIUWSIZUWOUXMPZUXNAGUIZUVJUWPXFTVAZXHZGUUDUHZUVNUXSUURUXMUVIUVMUX
      SUVIUVLUXRGUVGUUDUVIUWEUVLXHZUWFUXPUXQUWFUXPPZUWEUVIUXTUXQUYAUWHUWEUXPUWG
      UWFUVJUUIXGXIUWIVLUVIUWEUVLUXQUVIUWEUVLUXQXHZUVIUWEPUVKUWPIZUYBUVIUXHUWEU
      YCUXIUVGUVJUVHXJXKUVLUYCUXQUVKUVJUWPXLVFXMXNXTXOXPXQVHXRUXOGUUDUUIUWPUUFU
      VAUXOUUFXSUVAUXKOUXOUXLYKUUQUUEUVNUXMYAUWOUXAUXMUXBWPUWOUXMUPYBYCXNYDYEUV
      CUWRUWTPAUWPUVDUUIUWPOZUUJUWRUVBUWTUUIUWPKLYFUYDUUTUWSUVAUUIUWPUUSYGYHYIY
      LYJYMUUGUVCUUNAUVDUUOUUGUVACUUGUXKBUEUVACUUFBYNUXLDYOZYPUUGUVBUUMUUJUUGUU
      TUULUVACUUGUUIUUSUUKUUFBSYGYQUYEYRYSYTUUAUUBUUCVM $.
  $}

  ${
    $d b w x y z X $.
    $( A discrete space is second-countable iff it is countable.  (Contributed
       by Mario Carneiro, 13-Apr-2015.) $)
    dis2ndc $p |- ( X ~<_ om <-> ~P X e. 2ndc ) $=
      ( vx vy vz vw vb com cdom wbr cvv wcel c2ndc cv wceq syl wss wel wrex ctb
      wa cpw reldom brrelexi elex sylibr csn cmpt crn cen wb wf1o wf1 snex a1ii
      pwexb vex sneqr sneq impbii dom2lem f1f1orn f1oeng syl2anc domen1 ctg cfv
      ctop wral distop wf simpr snelpw sylib eqid fmptd frn elpwi simprr sseldd
      ad2antrl eqidd eqeq2d rspcev elrnmpt ax-mp snid snssd eleq2 sseq1 anbi12d
      a1i syl12anc ralrimivva basgen2 syl3anc adantr tgclb 2ndci sylan eqeltrrd
      eqeltrd is2ndc simplrr tg2 sylancl simprrl simprrr eqssd simprl rexlimddv
      eleqtrrd ssdomg mpsyl domtr rexlimdva syl5bi imp impbida bitrd pm5.21nii
      ex ) AGHIZAJKZAUAZLKZAGHUBUCYEYDJKYCYDLUDAUOUEYCYBBABMZUFZUGZUHZGHIZYEYCA
      YIUIIZYBYJUJYCYCAYIYHUKZYKAJUDYCAJYHULYLYCBCAJYGCMZUFZYCYFAKZYGJKYFUMUNYC
      YOYMAKTYGYNNZYFYMNZUJYPYQYFYMBUPZUQYFYMURUSUNUTAJYHVAOAYIJYHVBVCAYIGVDOYC
      YJYEYCYJTYIVEVFZYDLYCYSYDNZYJYCYDVGKYIYDPZDEQZEMZYMPZTZEYIRZDYMVHCYDVHYTA
      JVIZYCAYDYHVJUUAYCBAYGYDYHYCYOTYOYGYDKZYCYOVKYFAYRVLZVMYHVNZVOAYDYHVPOYCU
      UFCDYDYMYCYMYDKZDCQZTTZDMZUFZYIKZUUNUUOKZUUOYMPZUUFUUMUUOYGNZBARZUUPUUMUU
      NAKUUOUUONZUUTUUMYMAUUNUUKYMAPYCUULYMAVQVTYCUUKUULVRZVSUUMUUOWAUUSUVABUUN
      AYFUUNNYGUUOUUOYFUUNURWBWCVCUUOJKUUPUUTUJUUNUMBAYGUUOYHJUUJWDWEUEUUQUUMUU
      NDUPWFWKUUMUUNYMUVBWGUUEUUQUURTEUUOYIUUCUUONUUBUUQUUDUURUUCUUOUUNWHUUCUUO
      YMWIWJWCWLWMCDEYIYDWNWOZWPYCYISKZYJYSLKYCYSVGKUVDYCYSYDVGUVCUUGXAYIWQUEYI
      WRWSWTYCYEYJYEFMZGHIZUVEVEVFZYDNZTZFSRYCYJFYDXBYCUVIYJFSYCUVESKTZUVIYJUVJ
      UVITZYIUVEHIZUVFYJUVEJKUVKYIUVEPZUVLFUPUVKAUVEYHVJUVMUVKBAYGUVEYHUVKYOTZB
      CQZYMYGPZTZYGUVEKCUVEUVNYGUVGKYFYGKUVQCUVERUVNYGYDUVGUVNYOUUHUVKYOVKUUIVM
      UVJUVFUVHYOXCXKYFYRWFCYGUVEYFXDXEUVNCFQZUVQTTZYGYMUVEUVSYGYMUVSYFYMUVNUVR
      UVOUVPXFWGUVNUVRUVOUVPXGXHUVNUVRUVQXIXAXJUUJVOAUVEYHVPOYIUVEJXLXMUVJUVFUV
      HXIYIUVEGXNVCYAXOXPXQXRXSXT $.
  $}

  ${
    $d f g j k m n x y J $.  $d f g j k m n x y P $.  $d f g j k m n x y S $.
    $d f g j k m n y V $.  $d f g j k m n x y X $.
    1stcelcls.1 $e |- X = U. J $.
    $( A point belongs to the closure of a subset iff there is a sequence in
       the subset converging to it.  Theorem 1.4-6(a) of [Kreyszig] p. 30.
       This proof uses countable choice ~ ax-cc .  A space satisfying the
       conclusion of this theorem is called a sequential space, so the theorem
       can also be stated as "every first-countable space is a sequential
       space".  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    1stcelcls $p |- ( ( J e. 1stc /\ S C_ X ) -> ( P e. ( ( cls ` J ) ` S ) <->
        E. f ( f : NN --> S /\ f ( ~~>t ` J ) P ) ) ) $=
      ( vk vx vn vy vm vj wcel wss wa cfv cn cv wral wi vg c1stc ccl wf clm wbr
      wex c1 caddc co wrex w3a simpll ctop 1stctop clsss3 sselda 1stcfb syl2anc
      sylan cid cin wne simpr1 ffvelrnda elcls2 simplbda ad2antrr simpr2 ralimi
      c0 wb simpl syl weq fveq2 eleq2d rspccva eleq2 ineq1 neeq1d imbi12d rspcv
      wceq syl3c elin ancom bitri exbii n0 df-rex sylib cvv topopn simplr ssexd
      3bitr4i fvi rexeqdv mpbird ralrimiva fvex nnenom eleq1 feq3 biimpd adantr
      axcc4 simplr3 sseq1d cbvrexv sseq2 rexbidv syl5bb simpr simprrr imbi2d cz
      cuz ssid a1ii uztrn2 oveq1 fveq2d sseq12d sylan2 anassrs sstr2 expcom a2d
      nnuz uzind4 com12 ralrimiv ad2antlr eleq12d 1z a1i simprl ex r19.26 ssel2
      sylc sylanbrc ssel ralimdv syl5com reximdva syld toptopon fss eqidd lmbrf
      ctopon mpbir2and expr imdistanda syland eximdv mpd exlimddv lmcls exlimdv
      simprr impbid ) DUBMZBENZOZABDUCPPZMZQBCRZUDZUVKADUEPUFZOZCUGZUVHUVJUVOUV
      HUVJOZQDUARZUDZAGRZUVQPZMZUVSUHUIUJZUVQPZUVTNZOZGQSZAHRZMZUVTUWGNZGQUKZTZ
      HDSZULZUVOUAUVPUVFAEMZUWMUAUGUVFUVGUVJUMUVHUVIEAUVFDUNMZUVGUVIENDUOZBDEFU
      PUTUQZHAUAGDEFURUSUVPUWMOZQBVAPZUVKUDZIRZUVKPZUXAUVQPZMZIQSZOZCUGZUVOUWRU
      WGUXCMZHUWSUKZIQSUXGUWRUXIIQUWRUXAQMZOZUXIUXHHBUKZUXKUXCBVBZVKVCZUXLUXKUX
      CDMAJRZMZUXOBVBZVKVCZTZJDSZAUXCMZUXNUWRQDUXAUVQUVPUVRUWFUWLVDVEUVPUXTUWMU
      XJUVHUVJUWNUXTUVFUWOUVGUVJUWNUXTOVLUWPJABDEFVFUTVGVHUWRUWAGQSZUXJUYAUWRUW
      FUYBUVPUVRUWFUWLVIZUWEUWAGQUWAUWDVMVJVNUWAUYAGUXAQGIVOUVTUXCAUVSUXAUVQVPV
      QVRUTUXSUYAUXNTJUXCDUXOUXCWDZUXPUYAUXRUXNUXOUXCAVSUYDUXQUXMVKUXOUXCBVTWAW
      BWCWEUWGUXMMZHUGUWGBMZUXHOZHUGUXNUXLUYEUYGHUYEUXHUYFOUYGUWGUXCBWFUXHUYFWG
      WHWIHUXMWJUXHHBWKWQWLUXKUXHHUWSBUVPUWSBWDZUWMUXJUVPBWMMUYHUVPBEDUVPUWOEDM
      UVFUWOUVGUVJUWPVHZDEFWNVNUVFUVGUVJWOZWPBWMWRVNZVHWSWTXAUXHUXDHUWSCIQBVAXB
      XCUWGUXBUXCXDXHVNUWRUXFUVNCUWRUWTUVLUXEUVNUVPUWTUVLTUWMUVPUWTUVLUVPUYHUWT
      UVLVLUYKUWSBQUVKXEVNXFXGUWRUVLUXEUVMUWRUVLUXEUVMUWRUVLUXEOZOZUVMUWNUXPKRZ
      UVKPZUXOMZKLRZXSPZSZLQUKZTZJDSUVPUWNUWMUYLUWQVHUYMVUAJDUYMUXODMZOZUXPUYQU
      VQPZUXONZLQUKZUYTUYMUWLVUBUXPVUFTZUVRUWFUWLUVPUYLXIUWKVUGHUXODHJVOZUWHUXP
      UWJVUFUWGUXOAVSUWJVUDUWGNZLQUKVUHVUFUWIVUIGLQGLVOUVTVUDUWGUVSUYQUVQVPXJXK
      VUHVUIVUELQUWGUXOVUDXLXMXNWBVRUTVUCVUEUYSLQUYMVUBUYQQMZVUEUYSTZUWRUYLVUBV
      UJOZVUKUWRUYLVULOZOZUYOVUDMZKUYRSZVUEUYSVUNUYNUVQPZVUDNZUYOVUQMZOZKUYRSZV
      UPVUNVURKUYRSZVUSKUYRSVVAVUNUWDGQSZVUJVVBUWRVVCVUMUWRUWFVVCUYCUWEUWDGQUWA
      UWDXOVJVNXGUWRUYLVUBVUJXPZVVCVUJOZVURKUYRUYNUYRMZVVEVURVVEUXCVUDNZTVVEVUD
      VUDNZTVVEVURTZVVEUYNUHUIUJZUVQPZVUDNZTVVIIKUYQUYNILVOZVVGVVHVVEVVMUXCVUDV
      UDUXAUYQUVQVPXJXQIKVOZVVGVURVVEVVNUXCVUQVUDUXAUYNUVQVPZXJXQZUXAVVJWDZVVGV
      VLVVEVVQUXCVVKVUDUXAVVJUVQVPXJXQVVPUYQXRMVVEVVHVUDXTYAVVFVVEVURVVLVVEVVFV
      URVVLTZVVEVVFOVVKVUQNZVVRVVCVUJVVFVVSVUJVVFOVVCUYNQMZVVSUHUYNUYQQYKYBZUWD
      VVSGUYNQGKVOZUWCVVKUVTVUQVWBUWBVVJUVQUVSUYNUHUIYCYDUVSUYNUVQVPYEVRYFYGVVK
      VUQVUDYHVNYIYJYLYMYNUSVUNVUSKUYRVUNVVFOVVTUXEVUSVUNVUJVVFVVTVVDVWAUTVUMUX
      EUWRVVFUVLUXEVULWOYOUXDVUSIUYNQVVNUXBUYOUXCVUQUXAUYNUVKVPVVOYPWCUUCXAVURV
      USKUYRUUAUUDVUTVUOKUYRVUQVUDUYOUUBVJVNVUEVUOUYPKUYRVUDUXOUYOUUEUUFUUGYGYG
      UUHUUIXAUYMJUYOALKUVKDUHEQUYMUWODEUUNPMZUVPUWOUWMUYLUYIVHDEFUUJZWLYKUHXRM
      ZUYMYQYRUYMUVLUVGQEUVKUDUWRUVLUXEYSUVPUVGUWMUYLUYJVHQBEUVKUUKUSUYMVVTOUYO
      UULUUMUUOUUPUUQUURUUSUUTUVAYTUVHUVNUVJCUVHUVNUVJUVHUVNOZABGUVKDUHEQYKVWFU
      WOVWCUVFUWOUVGUVNUWPVHVWDWLVWEVWFYQYRUVHUVLUVMUVDVWFQBUVSUVKUVHUVLUVMYSVE
      UVFUVGUVNWOUVBYTUVCUVE $.
  $}

  ${
    $d f j k u v x F $.  $d f j k u v x J $.  $d f j k u v x ph $.
    $d f j k u v x K $.  $d f j k u v x X $.  $d f j k u v x Y $.
    $d f j k u v P $.
    1stccnp.1 $e |- ( ph -> J e. 1stc ) $.
    1stccnp.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    1stccnp.3 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    ${
      1stccnp.4 $e |- ( ph -> P e. X ) $.
      $( A mapping is continuous at ` P ` in a first-countable space ` X ` iff
         it is sequentially continuous at ` P ` , meaning that the image under
         ` F ` of every sequence converging at ` P ` converges to
         ` F ( P ) ` .  This proof uses ~ ax-cc , but only via ~ 1stcelcls , so
         it could be refactored into a proof that continuity and sequential
         continuity are the same in sequential spaces.  (Contributed by Mario
         Carneiro, 7-Sep-2015.) $)
      1stccnp $p |- ( ph -> ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\
                      A. f ( ( f : NN --> X /\ f ( ~~>t ` J ) P ) ->
                             ( F o. f ) ( ~~>t ` K ) ( F ` P ) ) ) ) ) $=
        ( vv vk cfv wcel cn wa wss wfal vu vj ccnp co wf cv clm wbr ccom wi wal
        ctopon jca cnpf2 3expa sylan simprr simplr lmcnp alrimiv cima wrex wral
        ex simprl ccnv cin c0 wne wn ccl wex fal 19.29 difss fss sylancl cuz c1
        cdif nnuz simplrr cz a1i simplrl lmcvg r19.2uz wfn wceq simprll ffn syl
        1z fvco2 ffvelrnda eldifad wb ad2antrr elpreima eldifbd pm2.21d sylbird
        eleq1d 3syl mpand sylbid rexlimdva syl5 mpd embantd com23 imp3a exlimdv
        expr exp4b impr imp mtoi c1stc cuni toponuni syl5sseq 1stcelcls syl2anc
        eqid mtbird ctop topontop eleqtrd elcls syl3anc mtbid wfun ffun toponss
        cdm fdm sseqtr4d funimass3 df-ss sylib sseq1d bitr4d nne bitr4i syl6bbr
        inssdif0 anbi2d rexbidva syl6bb mpbird ralrimiva iscnp adantr mpbir2and
        rexanali impbida ) ADBEFUCUDOPZGHDUEZQGCUFZUEZUUTBEUGOUHZRZDUUTUIZBDOZF
        UGOUHZUJZCUKZRZAUURRZUUSUVHAEGULOPZFHULOPZRUURUUSAUVKUVLJKUMUVKUVLUURUU
        SBDEFGHUNUOUPUVJUVGCUVJUVCUVFUVJUVCRBUUTDEFUVJUVAUVBUQAUURUVCURUSVDUTUM
        AUVIRZUURUUSUVEUAUFZPZBMUFZPZDUVPVAUVNSZRZMEVBZUJZUAFVCZAUUSUVHVEZUVMUW
        AUAFUVMUVNFPZUVOUVTUVMUWDUVORZRZUVTUVQUVPGDVFUVNVAZVTZVGZVHVIZUJMEVCZVJ
        ZUWFBUWHEVKOOPZUWKUWFUWMQUWHUUTUEZUVBRZCVLZUWFUWPTVMUVMUWEUWPTUJZAUUSUV
        HUWEUWQUJAUUSRZUWEUVHUWQUWRUWEUVHUWPTUVHUWPRUVGUWORZCVLUWRUWERZTUVGUWOC
        VNUWTUWSTCUWTUVGUWOTUWTUWOUVGTUWTUWOUVGTUJUWTUWORZUVCUVFTUXAUVAUVBUXAUW
        NUWHGSUVAUWTUWNUVBVEGUWGVOZQUWHGUUTVPVQUWTUWNUVBUQUMUWTUWOUVFTUWTUWOUVF
        RZRZNUFZUVDOZUVNPZNUBUFVROVCUBQVBZTUXDUVEUVNUBNUVDFVSQWAUWRUWDUVOUXCWBV
        SWCPUXDWMWDUWTUWOUVFUQUWRUWDUVOUXCWEWFUXHUXGNQVBUXDTUXGUBNVSQWAWGUXDUXG
        TNQUXDUXEQPZRZUXGUXEUUTOZDOZUVNPZTUXJUXFUXLUVNUXDUUTQWHZUXIUXFUXLWIUXDU
        WNUXNUWTUWNUVBUVFWJZQUWHUUTWKWLQDUUTUXEWNUPXCUXJUXKGPZUXMTUXJUXKGUWGUXD
        QUWHUXEUUTUXOWOZWPUXJUXPUXMRZUXKUWGPZTUXJUUSDGWHUXSUXRWQUWTUUSUXCUXIAUU
        SUWEURWRGHDWKGUXKUVNDWSXDUXJUXSTUXJUXKGUWGUXQWTXAXBXEXFXGXHXIXNXJVDXKXL
        XMXHXOXKXPXQXRUWFEXSPZUWHEXTZSZUWMUWPWQAUXTUVIUWEIWRUWFGUWHUYAUXBUWFUVK
        GUYAWIAUVKUVIUWEJWRZGEYAWLZYBZBUWHCEUYAUYAYEZYCYDYFUWFEYGPZUYBBUYAPUWMU
        WKWQUWFUVKUYGUYCGEYHWLUYEUWFBGUYAABGPZUVIUWELWRUYDYIMBUWHEUYAUYFYJYKYLU
        WFUVTUVQUWJVJZRZMEVBUWLUWFUVSUYJMEUWFUVPEPZRZUVRUYIUVQUYLUVRUVPGVGZUWGS
        ZUYIUYLUVRUVPUWGSZUYNUYLDYMZUVPDYPZSUVRUYOWQUYLUUSUYPUVMUUSUWEUYKUWCWRZ
        GHDYNWLUYLUVPGUYQUWFUVKUYKUVPGSZUYCUVPEGYOUPZUYLUUSUYQGWIUYRGHDYQWLYRUV
        PUVNDYSYDUYLUYMUVPUWGUYLUYSUYMUVPWIUYTUVPGYTUUAUUBUUCUYIUWIVHWIUYNUWIVH
        UUDUVPGUWGUUGUUEUUFUUHUUIUVQUWJMEUUPUUJUUKXNUULAUURUUSUWBRWQZUVIAUVKUVL
        UYHVUAJKLMUABDEFGHUUMYKUUNUUOUUQ $.
    $}

    1stccn.7 $e |- ( ph -> F : X --> Y ) $.
    $( A mapping ` X --> Y ` , where ` X ` is first-countable, is continuous
       iff it is sequentially continuous, meaning that for any sequence
       ` f ( n ) ` converging to ` x ` , its image under ` F ` converges to
       ` F ( x ) ` .  (Contributed by Mario Carneiro, 7-Sep-2015.) $)
    1stccn $p |- ( ph -> ( F e. ( J Cn K ) <-> A. f ( f : NN --> X ->
        A. x ( f ( ~~>t ` J ) x -> ( F o. f ) ( ~~>t ` K ) ( F ` x ) ) ) ) ) $=
      ( wcel cfv wral wa wi wal adantr syl5bb ccn co cv ccnp cn wf clm wbr ccom
      ctopon cncnp syl2anc biantrurd bitr4d c1stc simpr 1stccnp ralbidva impexp
      wb ralcom4 ralbii r19.21v bitri df-ral lmcl sylan pm4.71rd imbi1d syl6rbb
      ex albidv imbi2d 3bitrd ) ADEFUAUBMZDBUCZEFUDUBNMZBGOZUEGCUCZUFZVSVPEUGNU
      HZPDVSUIVPDNFUGNUHZQZCRZBGOZVTWAWBQZBRZQZCRZAVOGHDUFZVRPZVRAEGUJNMZFHUJNM
      ZVOWKUTJKBDEFGHUKULAWJVRLUMUNAVQWDBGAVPGMZPZVQWJWDPWDWOVPCDEFGHAEUOMWNISA
      WLWNJSAWMWNKSAWNUPUQWOWJWDAWJWNLSUMUNURWEWCBGOZCRAWIWCBCGVAAWPWHCWPVTWFBG
      OZQZAWHWPVTWFQZBGOWRWCWSBGVTWAWBUSVBVTWFBGVCVDAWQWGVTWQWNWFQZBRAWGWFBGVEA
      WTWFBAWFWNWAPZWBQWTAWAXAWBAWAWNAWAWNAWLWAWNJVPVSEGVFVGVKVHVIWNWAWBUSVJVLT
      VMTVLTVN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Local topological properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Locally $.
  $c N-Locally $.

  $( Extend class notation with the "locally ` A ` " predicate of a topological
     space. $)
  clly $a class Locally A $.

  $( Extend class notation with the "N-locally ` A ` " predicate of a
     topological space. $)
  cnlly $a class N-Locally A $.

  ${
    $d f j u x y A $.
    $( Define a space that is locally ` A ` , where ` A ` is a topological
       property like "compact", "connected", or "path-connected".  A
       topological space is locally ` A ` if every neighborhood of a point
       contains an open sub-neighborhood that is ` A ` in the subspace
       topology.  (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    df-lly $a |- Locally A = { j e. Top | A. x e. j A. y e. x
      E. u e. ( j i^i ~P x ) ( y e. u /\ ( j |`t u ) e. A ) } $.

    $( Define a space that is n-locally ` A ` , where ` A ` is a topological
       property like "compact", "connected", or "path-connected".  A
       topological space is n-locally ` A ` if every neighborhood of a point
       contains a sub-neighborhood that is ` A ` in the subspace topology.

       The terminology "n-locally", where 'n' stands for "neighborhood", is not
       standard, although this is sometimes called "weakly locally ` A ` ".
       The reason for the distinction is that some notions only make sense for
       arbitrary neighborhoods (such as "locally compact", which is actually
       ` N-Locally Comp ` in our teminology - open compact sets are not very
       useful), while others such as "locally connected" are strictly weaker
       notions if the neighborhoods are not required to be open.  (Contributed
       by Mario Carneiro, 2-Mar-2015.) $)
    df-nlly $a |- N-Locally A = { j e. Top | A. x e. j A. y e. x
      E. u e. ( ( ( nei ` j ) ` { y } ) i^i ~P x ) ( j |`t u ) e. A } $.
  $}

  ${
    $d j s u w x y z A $.  $d j u w x y z B $.  $d s u y P $.  $d s u x y U $.
    $d j s u w x y z J $.  $d u w x y z V $.
    $( The property of being a locally ` A ` topological space.  (Contributed
       by Mario Carneiro, 2-Mar-2015.) $)
    islly $p |- ( J e. Locally A <-> ( J e. Top /\ A. x e. J A. y e. x
      E. u e. ( J i^i ~P x ) ( y e. u /\ ( J |`t u ) e. A ) ) ) $=
      ( vj cv wcel crest co wa cpw cin wrex wral ctop clly wceq ineq1 oveq1
      eleq1d anbi2d rexeqbidv ralbidv raleqbi1dv df-lly elrab2 ) BGCGZHZFGZUHIJ
      ZDHZKZCUJAGZLZMZNZBUNOZAUJOUIEUHIJZDHZKZCEUOMZNZBUNOZAEOFEPDQURVDAUJEUJER
      ZUQVCBUNVEUMVACUPVBUJEUOSVEULUTUIVEUKUSDUJEUHITUAUBUCUDUEABCDFUFUG $.

    $( The property of being an n-locally ` A ` topological space.
       (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    isnlly $p |- ( J e. N-Locally A <-> ( J e. Top /\
      A. x e. J A. y e. x E. u e. ( ( ( nei ` J ) ` { y } ) i^i ~P x )
        ( J |`t u ) e. A ) ) $=
      ( vj cv crest co wcel csn cnei cfv cpw cin wrex wral ctop cnlly wceq
      fveq2 fveq1d ineq1d eleq1d rexeqbidv ralbidv raleqbi1dv df-nlly elrab2
      oveq1 ) FGZCGZHIZDJZCBGKZUKLMZMZAGZNZOZPZBURQZAUKQEULHIZDJZCUOELMZMZUSOZP
      ZBURQZAEQFERDSVBVIAUKEUKETZVAVHBURVJUNVDCUTVGVJUQVFUSVJUOUPVEUKELUAUBUCVJ
      UMVCDUKEULHUJUDUEUFUGABCDFUHUI $.

    $( Equality theorem for the ` Locally A ` predicate.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    llyeq $p |- ( A = B -> Locally A = Locally B ) $=
      ( vy vu vj vx wceq cv wcel crest co wa cpw cin wrex wral ctop crab df-lly
      clly eleq2 anbi2d rexbidv 2ralbidv rabbidv 3eqtr4g ) ABGZCHDHZIZEHZUHJKZA
      IZLZDUJFHZMNZOZCUNPFUJPZEQRUIUKBIZLZDUOOZCUNPFUJPZEQRATBTUGUQVAEQUGUPUTFC
      UJUNUGUMUSDUOUGULURUIABUKUAUBUCUDUEFCDAESFCDBESUF $.

    $( Equality theorem for the ` Locally A ` predicate.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    nllyeq $p |- ( A = B -> N-Locally A = N-Locally B ) $=
      ( vj vu vy vx wceq cv crest wcel csn cnei cfv wrex wral ctop crab df-nlly
      co cnlly cpw cin eleq2 rexbidv 2ralbidv rabbidv 3eqtr4g ) ABGZCHZDHISZAJZ
      DEHKUILMMFHZUAUBZNZEULOFUIOZCPQUJBJZDUMNZEULOFUIOZCPQATBTUHUOURCPUHUNUQFE
      UIULUHUKUPDUMABUJUCUDUEUFFEDACRFEDBCRUG $.

    $( A locally ` A ` space is a topological space.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    llytop $p |- ( J e. Locally A -> J e. Top ) $=
      ( vy vu vx clly wcel ctop cv crest co wa cpw cin wrex wral islly simplbi
      ) BAFGBHGCIDIZGBSJKAGLDBEIZMNOCTPEBPECDABQR $.

    $( A locally ` A ` space is a topological space.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    nllytop $p |- ( J e. N-Locally A -> J e. Top ) $=
      ( vu vy vx cnlly wcel ctop cv crest csn cnei cfv cpw cin wrex wral isnlly
      co simplbi ) BAFGBHGBCIJSAGCDIKBLMMEIZNOPDUAQEBQEDCABRT $.

    $( The property of a locally ` A ` topological space.  (Contributed by
       Mario Carneiro, 2-Mar-2015.) $)
    llyi $p |- ( ( J e. Locally A /\ U e. J /\ P e. U ) -> E. u e. J
      ( u C_ U /\ P e. u /\ ( J |`t u ) e. A ) ) $=
      ( vy vx clly wcel cv wss wrex wa cpw cin wral wceq rspccva sylan anbi2i
      crest w3a ctop islly simprbi pweq ineq2d rexeqdv raleqbi1dv anbi1d anbi2d
      co eleq1 anass elin vex bitri anbi1i 3anass 3bitr4i syl6bb rexbidv2 3impa
      elpw ) EBHIZDEIZCDIZAJZDKZCVHIZEVHUAULBIZUBZAELZVEVFMFJZVHIZVKMZAEDNZOZLZ
      FDPZVGVMVEVPAEGJZNZOZLZFWAPZGEPZVFVTVEEUCIWFGFABEUDUEWEVTGDEWDVSFWADWADQZ
      VPAWCVRWGWBVQEWADUFUGUHUIRSVSVMFCDVNCQZVPVLAVREWHVHVRIZVPMWIVJVKMZMZVHEIZ
      VLMZWHVPWJWIWHVOVJVKVNCVHUMUJUKWLVIMZWJMWLVIWJMZMWKWMWLVIWJUNWIWNWJWIWLVH
      VQIZMWNVHEVQUOWPVIWLVHDAUPVDTUQURVLWOWLVIVJVKUSTUTVAVBRSVC $.

    $( The property of an n-locally ` A ` topological space.  (Contributed by
       Mario Carneiro, 2-Mar-2015.) $)
    nllyi $p |- ( ( J e. N-Locally A /\ U e. J /\ P e. U ) -> E. u e.
      ( ( nei ` J ) ` { P } ) ( u C_ U /\ ( J |`t u ) e. A ) ) $=
      ( vy vx cnlly wcel cv wa csn cfv wrex cpw cin wral wceq rspccva sylan wss
      crest cnei ctop isnlly simprbi pweq ineq2d rexeqdv raleqbi1dv elin fveq2d
      co sneq eleq2d wb vex elpw a1i anbi12d syl5bb anbi1d anass rexbidv2 3impa
      syl6bb ) EBHIZDEIZCDIZAJZDUAZEVJUBUMBIZKZACLZEUCMZMZNZVGVHKVLAFJZLZVOMZDO
      ZPZNZFDQZVIVQVGVLAVTGJZOZPZNZFWEQZGEQZVHWDVGEUDIWJGFABEUEUFWIWDGDEWHWCFWE
      DWEDRZVLAWGWBWKWFWAVTWEDUGUHUIUJSTWCVQFCDVRCRZVLVMAWBVPWLVJWBIZVLKVJVPIZV
      KKZVLKWNVMKWLWMWOVLWMVJVTIZVJWAIZKWLWOVJVTWAUKWLWPWNWQVKWLVTVPVJWLVSVNVOV
      RCUNULUOWQVKUPWLVJDAUQURUSUTVAVBWNVKVLVCVFVDSTVE $.

    $( Eliminate the neighborhood symbol from ~ nllyi .  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    nlly2i $p |- ( ( J e. N-Locally A /\ U e. J /\ P e. U ) -> E. s e. ~P U
      E. u e. J ( P e. u /\ u C_ s /\ ( J |`t s ) e. A ) ) $=
      ( cnlly wcel w3a cv wss crest co wa cfv wrex syl simprl ex mpd cnei nllyi
      csn cpw simprrl vex elpw sylibr ctop simpl1 nllytop neii2 syl2anc simpll3
      wb snssg mpbird simprr simprrr adantr 3jca reximdv jca reximdv2 ) EBGHZDE
      HZCDHZIZFJZDKZEVILMBHZNZFCUCZEUAOOZPCAJZHZVOVIKZVKIZAEPZFDUDZPFBCDEUBVHVL
      VSFVNVTVHVIVNHZVLNZVIVTHZVSNVHWBNZWCVSWDVJWCVHWAVJVKUEVIDFUFUGUHWDVMVOKZV
      QNZAEPZVSWDEUIHZWAWGWDVEWHVEVFVGWBUJBEUKQVHWAVLRVMAEVIULUMWDWFVRAEWDWFVRW
      DWFNZVPVQVKWIVPWEWDWEVQRWIVGVPWEUOVEVFVGWBWFUNCVODUPQUQWDWEVQURWDVKWFVHWA
      VJVKUSUTVASVBTVCSVDT $.

    $( A locally ` A ` space is n-locally ` A ` : the "n-locally" predicate is
       the weaker notion.  (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    llynlly $p |- ( J e. Locally A -> J e. N-Locally A ) $=
      ( vu vy vx clly wcel ctop cv crest co csn cnei cfv cpw wrex wral sylanbrc
      w3a wa cin cnlly llytop wss simpl1 simprl simprr2 opnneip syl3anc simprr1
      llyi syl vex elpw sylibr elin simprr3 ex reximdv2 3expb ralrimivva isnlly
      jca mpd ) BAFGZBHGZBCIZJKAGZCDIZLBMNNZEIZOZUAZPZDVKQEBQBAUBGABUCZVEVNEDBV
      KVEVKBGZVIVKGZVNVEVPVQSZVGVKUDZVIVGGZVHSZCBPVNCAVIVKBUKVRWAVHCBVMVRVGBGZW
      ATZVGVMGZVHTVRWCTZWDVHWEVGVJGZVGVLGZWDWEVFWBVTWFWEVEVFVEVPVQWCUEVOULVRWBW
      AUFVSVTVHWBVRUGVIBVGUHUIWEVSWGVSVTVHWBVRUJVGVKCUMUNUOVGVJVLUPRVSVTVHWBVRU
      QVCURUSVDUTVAEDCABVBR $.

    $( A locally ` A ` space is n-locally ` A ` .  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    llyssnlly $p |- Locally A C_ N-Locally A $=
      ( vj clly cnlly cv llynlly ssriv ) BACADABEFG $.

    $( The "locally" predicate respects inclusion.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    llyss $p |- ( A C_ B -> Locally A C_ Locally B ) $=
      ( vj vy vu vx wss clly cv ctop wcel crest co cpw wrex wral anim2d ralimdv
      wa islly cin ssel reximdv 3imtr4g ssrdv ) ABGZCAHZBHZUFCIZJKZDIEIZKZUIUKL
      MZAKZSZEUIFIZNUAZOZDUPPZFUIPZSUJULUMBKZSZEUQOZDUPPZFUIPZSUIUGKUIUHKUFUTVE
      UJUFUSVDFUIUFURVCDUPUFUOVBEUQUFUNVAULABUMUBQUCRRQFDEAUITFDEBUITUDUE $.

    $( The "n-locally" predicate respects inclusion.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    nllyss $p |- ( A C_ B -> N-Locally A C_ N-Locally B ) $=
      ( vj vu vy vx wss cnlly cv ctop wcel crest co csn cfv wrex wral wa isnlly
      ralimdv cnei cpw cin ssel reximdv anim2d 3imtr4g ssrdv ) ABGZCAHZBHZUICIZ
      JKZULDILMZAKZDEINULUAOOFIZUBUCZPZEUPQZFULQZRUMUNBKZDUQPZEUPQZFULQZRULUJKU
      LUKKUIUTVDUMUIUSVCFULUIURVBEUPUIUOVADUQABUNUDUETTUFFEDAULSFEDBULSUGUH $.

    $( The property of a subspace being locally ` A ` .  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    subislly $p |- ( ( J e. Top /\ B e. V ) ->
      ( ( J |`t B ) e. Locally A <-> A. x e. J A. y e. ( x i^i B )
        E. u e. J ( ( u i^i B ) C_ x /\ y e. u /\
          ( J |`t ( u i^i B ) ) e. A ) ) ) $=
      ( vw vz ctop wcel wa crest co cv cin wrex wral wss cvv cpw w3a wb resttop
      clly islly baib syl vex inex1 elrest wceq simpr raleqdv elin anbi1i anass
      a1i bitri rexbii2 ad2antrr 3anass simpllr sseq12d elpw inss2 biantru ssin
      3bitr4g eleq2d simplr sseldi biantrud syl6bbr bitr4d oveq2d simp-4l eqtrd
      restabs syl3anc eleq1d 3anbi123d syl5bbr rexxfr2d ralbidva bitrd ralxfr2d
      syl5bb ) FJKZEGKZLZFEMNZDUEKZBOZHOZKZWLWOMNZDKZLZHWLIOZUAZPZQZBWTRZIWLRZC
      OZEPZAOZSZWNXFKZFXGMNZDKZUBZCFQZBXHEPZRZAFRWKWLJKZWMXEUCEFGUDWMXQXEIBHDWL
      UFUGUHWKXDXPIAXOWLFTXOTKWKXHFKLXHEAUIUJURAWTEFJGUKWKWTXOULZLZXDXCBXORXPXS
      XCBWTXOWKXRUMUNXSXCXNBXOXCWOXAKZWSLZHWLQXSWNXOKZLZXNWSYAHXBWLWOXBKZWSLWOW
      LKZXTLZWSLYEYALYDYFWSWOWLXAUOUPYEXTWSUQUSUTYCYAXMHCXGWLFTXGTKYCXFFKLXFECU
      IUJURWKYEWOXGULZCFQUCXRYBCWOEFJGUKVAYAXTWPWRUBYCYGLZXMXTWPWRVBYHXTXIWPXJW
      RXLYHWOWTSXGXOSZXTXIYHWOXGWTXOYCYGUMZWKXRYBYGVCVDWOWTHUIVEXIXIXGESZLYIYKX
      IXFEVFZVGXGXHEVHUSVIYHWPWNXGKZXJYHWOXGWNYJVJYHXJXJWNEKZLYMYHYNXJYHXOEWNXH
      EVFXSYBYGVKVLVMWNXFEUOVNVOYHWQXKDYHWQWLXGMNZXKYHWOXGWLMYJVPYHWIYKWJYOXKUL
      WIWJXRYBYGVQYKYHYLURXSWJYBYGWIWJXRVKVAXGEFJGVSVTVRWAWBWCWDWHWEWFWGWF $.
  $}

  ${
    $d j k s u v x y z A $.  $d j u v x y z J $.  $d j k s u x y z ph $.
    $d u y z X $.
    restlly.1 $e |- ( ( ph /\ ( j e. A /\ x e. j ) ) -> ( j |`t x ) e. A ) $.
    $( If the property ` A ` passes to open subspaces, then a space is
       n-locally ` A ` iff it is locally ` A ` .  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    restnlly $p |- ( ph -> N-Locally A = Locally A ) $=
      ( vk vu vy vs cv wcel wa ctop wel crest co wrex wral wss wceq cpw nllytop
      cnlly clly cin adantl w3a nlly2i 3adant1l simprl simprr2 simplr sstrd vex
      elpwid elpw sylibr sylanbrc simprr1 simpll1 simprd syl restabs syl3anc wi
      elin simprr3 simpld expr ralrimiva df-ss sylib elrestr eleq2 oveq1 eleq1d
      eqeltrrd imbi12d rspcv syl3c jca32 ex reximdv2 rexlimdva 3expb ralrimivva
      mpd islly ssrdv llyssnlly a1i eqssd ) ACUCZCUDZAFWMWNAFJZWMKZWOWNKZAWPLZW
      OMKZGBNZWOBJZOPZCKZLZBWOHJZUAZUEZQZGXERHWORWQWPWSACWOUBZUFWRXHHGWOXEWRHFN
      ZGHNZXHWRXJXKUGZWTXAIJZSZWOXMOPZCKZUGZBWOQZIXFQZXHWPXJXKXSABCGJXEWOIUHUIX
      LXRXHIXFXLXMXFKZLZXQXDBWOXGYABFNZXQLZXAXGKZXDLYAYCLZYDWTXCYEYBXAXFKZYDYAY
      BXQUJZYEXAXESYFYEXAXMXEWTXNXPYBYAUKZYEXMXEXLXTYCULZUOUMXAXEBUNUPUQXAWOXFV
      FURWTXNXPYBYAUSYEXOXAOPZXBCYEWSXNXTYJXBTYEWPWSYEAWPWRXJXKXTYCUTZVAXIVBZYH
      YIXAXMWOMXFVCVDYEXPBDNZDJZXAOPZCKZVEZDCRZXAXOKZYJCKZWTXNXPYBYAVGYEAYRYEAW
      PYKVHAYQDCAYNCKYMYPEVIVJVBYEXAXMUEZXAXOYEXNUUAXATYHXAXMVKVLYEWSXTYBUUAXOK
      YLYIYGXAXMWOMXFVMVDVQYQYSYTVEDXOCYNXOTZYMYSYPYTYNXOXAVNUUBYOYJCYNXOXAOVOV
      PVRVSVTVQWAWBWCWDWGWEWFHGBCWOWHURWBWIWNWMSACWJWKWL $.

    ${
      restlly.2 $e |- ( ph -> A C_ Top ) $.
      $( If the property ` A ` passes to open subspaces, then a space which is
         ` A ` is also locally ` A ` .  (Contributed by Mario Carneiro,
         2-Mar-2015.) $)
      restlly $p |- ( ph -> A C_ Locally A ) $=
        ( vy vu clly cv wcel wa ctop wel crest co cpw cin wral sylanbrc vex a1i
        wrex sselda simprl pwid elin simprr anassrs adantrr eleq2 oveq2 anbi12d
        weq eleq1d rspcev syl12anc ralrimivva islly ex ssrdv ) ADCCIZADJZCKZVCV
        BKZAVDLZVCMKGHNZVCHJZOPZCKZLZHVCBJZQZRZUCZGVLSBVCSVEACMVCFUDVFVOBGVCVLV
        FBDNZGBNZLLZVLVNKZVQVCVLOPZCKZVOVRVPVLVMKZVSVFVPVQUEWBVRVLBUAUFUBVLVCVM
        UGTVFVPVQUHVFVPWAVQAVDVPWAEUIUJVKVQWALHVLVNHBUNZVGVQVJWAVHVLGJUKWCVIVTC
        VHVLVCOULUOUMUPUQURBGHCVCUSTUTVA $.
    $}

    islly2.2 $e |- X = U. J $.
    $( An alternative expression for ` J e. Locally A ` when ` A ` passes to
       open subspaces:  A space is locally ` A ` if every point is contained in
       an open neighborhood with property ` A ` .  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    islly2 $p |- ( ph -> ( J e. Locally A <-> ( J e. Top /\ A. y e. X
      E. u e. J ( y e. u /\ ( J |`t u ) e. A ) ) ) ) $=
      ( vv vz wcel cv crest co wa wral wss syl3anc clly ctop wrex llytop adantl
      w3a simplr adantr topopn syl simpr 3simpc reximi ralrimiva jca cpw simprl
      llyi cin wi cuni elssuni syl6sseqr ssralv simpllr simplrl inopn inss1 vex
      elpw2 mpbir elin sylanbrc simplrr simprrl wceq restabs elrestr ralrimivva
      inss2 simprrr ad3antrrr oveq1 eleq1d raleqbi1dv rspcv sylc oveq2 eqeltrrd
      a1i eleq2 anbi12d rspcev syl12anc rexlimdvaa ralimdva syld ralrimdva impr
      anassrs islly impbida ) AGEUAMZGUBMZCNZDNZMZGXFOPZEMZQZDGUCZCHRZQZAXCQZXD
      XLXCXDAEGUDUEZXNXKCHXNXEHMZQZXFHSZXGXIUFZDGUCZXKXQXCHGMZXPXTAXCXPUGXQXDYA
      XNXDXPXOUHGHJUIUJXNXPUKDEXEHGURTXSXJDGXRXGXIULUMUJUNUOAXMQXDXEKNZMZGYBOPZ
      EMZQZKGLNZUPZUSZUCZCYGRZLGRZXCAXDXLUQAXDXLYLAXDQZXLYKLGYMYGGMZQZXLXKCYGRZ
      YKYOYGHSZXLYPUTYNYQYMYNYGGVAHYGGVBJVCUEXKCYGHVDUJYOXKYJCYGYMYNXEYGMZXKYJU
      TYMYNYRQZQZXJYJDGYTXFGMZXJQZQZYGXFUSZYIMZXEUUDMZGUUDOPZEMZYJUUCUUDGMZUUDY
      HMZUUEUUCXDYNUUAUUIAXDYSUUBVEZYMYNYRUUBVFZYTUUAXJUQZYGXFGVGTUUJUUCUUJUUDY
      GSYGXFVHUUDYGLVIVJVKWJUUDGYHVLVMUUCYRXGUUFYMYNYRUUBVNYTUUAXGXIVOXEYGXFVLV
      MUUCXHUUDOPZUUGEUUCXDUUDXFSZUUAUUNUUGVPUUKUUOUUCYGXFVTWJUUMUUDXFGUBGVQTUU
      CUUDXHMZXHBNZOPZEMZBXHRZUUNEMZUUCXDUUAYNUUPUUKUUMUULYGXFGUBGVRTUUCXIFNZUU
      QOPZEMZBUVBRZFERZUUTYTUUAXGXIWAAUVFXDYSUUBAUVDFBEUVBIVSWBUVEUUTFXHEUVDUUS
      BUVBXHUVBXHVPUVCUUREUVBXHUUQOWCWDWEWFWGUUSUVABUUDXHUUQUUDVPUURUUNEUUQUUDX
      HOWHWDWFWGWIYFUUFUUHQKUUDYIYBUUDVPZYCUUFYEUUHYBUUDXEWKUVGYDUUGEYBUUDGOWHW
      DWLWMWNWOWTWPWQWRWSLCKEGXAVMXB $.
  $}

  ${
    $d j s u v x y z A $.  $d s u v x y B $.  $d s u v x y J $.
    $( An open subspace of a locally ` A ` space is also locally ` A ` .
       (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    llyrest $p |- ( ( J e. Locally A /\ B e. J ) ->
      ( J |`t B ) e. Locally A ) $=
      ( vy vv vx wcel wa crest co ctop wrex wral sylan wss restopn2 w3a syl3anc
      cv wb clly cpw cin llytop resttop simp1l simp2l simp3 llyi simprl simprr1
      simpl2r sstrd syl adantr simpl1r syl2anc mpbir2and vex elpw elin sylanbrc
      sylibr simprr2 restabs simprr3 eqeltrd jca32 reximdv2 mpd 3expa ralrimiva
      wceq ex sylbid ralrimiv islly ) CAUAZGZBCGZHZCBIJZKGZDSZESZGZWBWEIJZAGZHZ
      EWBFSZUBZUCZLZDWJMZFWBMWBVRGVSCKGZVTWCACUDZBCCUENWAWNFWBWAWJWBGZWJCGZWJBO
      ZHZWNVSWOVTWQWTTWPBWJCPNWAWTWNWAWTHWMDWJWAWTWDWJGZWMWAWTXAQZWEWJOZWFCWEIJ
      ZAGZQZECLZWMXBVSWRXAXGVSVTWTXAUFZWAWRWSXAUGWAWTXAUHEAWDWJCUIRXBXFWIECWLXB
      WECGZXFHZWEWLGZWIHXBXJHZXKWFWHXLWEWBGZWEWKGZXKXLXMXIWEBOZXBXIXFUJXLWEWJBX
      CWFXEXIXBUKZWRWSWAXAXJULUMZXLWOVTXMXIXOHTXBWOXJXBVSWOXHWPUNUOZVSVTWTXAXJU
      PZBWECPUQURXLXCXNXPWEWJEUSUTVCWEWBWKVAVBXCWFXEXIXBVDXLWGXDAXLWOXOVTWGXDVM
      XRXQXSWEBCKCVERXCWFXEXIXBVFVGVHVNVIVJVKVLVNVOVPFDEAWBVQVB $.

    $( An open subspace of an n-locally ` A ` space is also n-locally ` A ` .
       (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    nllyrest $p |- ( ( J e. N-Locally A /\ B e. J ) ->
      ( J |`t B ) e. N-Locally A ) $=
      ( vs vy vx vu wcel wa crest co ctop cv cfv wrex wral wss syl3anc 3ad2ant1
      w3a cnlly csn cnei cpw cin nllytop resttop sylan wb restopn2 simp1l simp3
      simp2l nlly2i cuni simp3l simp3r2 simp2 simp12r sstrd syl simp11r syl2anc
      elpwid mpbir2and simp3r1 opnneip wceq elssuni eqid restuni sseqtrd ssnei2
      syl22anc elin sylanbrc restabs simp3r3 eqeltrd jca 3expa expimpd reximdv2
      rexlimdvaa mpd ralrimiva ex sylbid ralrimiv isnlly ) CAUAZHZBCHZIZCBJKZLH
      ZWODMZJKZAHZDEMZUBZWOUCNNZFMZUDZUEZOZEXCPZFWOPWOWKHWLCLHZWMWPACUFZBCCUGUH
      ZWNXGFWOWNXCWOHZXCCHZXCBQZIZXGWLXHWMXKXNUIXIBXCCUJUHWNXNXGWNXNIXFEXCWNXNW
      TXCHZXFWNXNXOTZWTGMZHZXQWQQZCWQJKZAHZTZGCOZDXDOZXFXPWLXLXOYDWLWMXNXOUKZWN
      XLXMXOUMWNXNXOULGAWTXCCDUNRXPYCWSDXDXEXPWQXDHZYCWQXEHZWSIZXPYFIYBYHGCXPYF
      XQCHZYBIZYHXPYFYJTZYGWSYKWQXBHZYFYGYKWPXQXBHZXSWQWOUOZQYLXPYFWPYJWNXNWPXO
      XJSSZYKWPXQWOHZXRYMYOYKYPYIXQBQZXPYFYIYBUPYKXQWQBXRXSYAYIXPYFUQZYKWQXCBYK
      WQXCXPYFYJURZVDXLXMWNXOYFYJUSUTZUTYKXHWMYPYIYQIUIYKWLXHXPYFWLYJYESXIVAZWL
      WMXNXOYFYJVBZBXQCUJVCVEXRXSYAYIXPYFVFWTWOXQVGRYRYKWQBYNYTYKXHBCUOZQZBYNVH
      UUAYKWMUUDUUBBCVIVABCUUCUUCVJVKVCVLXAWOWQXQYNYNVJVMVNYSWQXBXDVOVPYKWRXTAY
      KXHWQBQWMWRXTVHUUAYTUUBWQBCLCVQRXRXSYAYIXPYFVRVSVTWAWDWBWCWEWAWFWGWHWIFED
      AWOWJVP $.

    $( If ` A ` is a local property, then both ` Locally A ` and
       ` N-Locally A ` simplify to ` A ` .  (Contributed by Mario Carneiro,
       2-Mar-2015.) $)
    loclly $p |- ( Locally A = A <-> N-Locally A = A ) $=
      ( vx vj clly wceq cnlly cv wcel wa crest co simprl simpl eleqtrrd llyrest
      simprr syl2anc eleqtrd restnlly id eqtrd nllyrest eqtr3d impbii ) ADZAEZA
      FZAEZUFUGUEAUFBACUFCGZAHZBGZUIHZIZIZUIUKJKZUEAUNUIUEHULUOUEHUNUIAUEUFUJUL
      LUFUMMZNUFUJULPAUKUIOQUPRSUFTUAUHUGUEAUHBACUHUMIZUOUGAUQUIUGHULUOUGHUQUIA
      UGUHUJULLUHUMMZNUHUJULPAUKUIUBQURRSUHTUCUD $.

    $( Idempotence of the "locally" predicate, i.e. being "locally ` A ` " is a
       local property.  (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    llyidm $p |- Locally Locally A = Locally A $=
      ( vj vy vv vx vu clly cv wcel ctop wel crest co wa wrex wral w3a wss wtru
      adantr cpw cin llytop llyi simprr3 simprl a1i 3ad2ant1 restopn2 mpbir2and
      ssid wb syl2anc simprr2 syl3anc simpl syl6bi simprr1 vex elpw sylibr elin
      sstrd sylanbrc wceq simplrl restabs eqeltrrd jca32 ex syland reximdv2 mpd
      rexlimddv 3expb ralrimivva islly ssriv llyrest adantl restlly trud eqssi
      ) AGZGZWDBWEWDBHZWEIZWFJIZCDKZWFDHZLMZAIZNZDWFEHZUAZUBZOZCWNPEWFPWFWDIZWD
      WFUCZWGWQECWFWNWGEBKZCEKZWQWGWTXAQZFHZWNRZCFKZWFXCLMZWDIZQZWQFWFFWDCHZWNW
      FUDXBFBKZXHNZNZWJXCRZWIXFWJLMZAIZQZDXFOZWQXLXGXCXFIZXEXQXDXEXGXJXBUEXLXRX
      JXCXCRZXBXJXHUFZXSXLXCUKUGXLWHXJXRXJXSNULXBWHXKWGWTWHXAWSUHTZXTXCXCWFUIUM
      UJXDXEXGXJXBUNDAXIXCXFUDUOXLXPWMDXFWPXLWJXFIZDBKZXPWJWPIZWMNZXLYBYCXMNZYC
      XLWHXJYBYFULYAXTXCWJWFUIUMYCXMUPUQXLYCXPNZYEXLYGNZYDWIWLYHYCWJWOIZYDXLYCX
      PUFYHWJWNRYIYHWJXCWNXMWIXOYCXLURZXLXDYGXDXEXGXJXBURTVCWJWNDUSUTVAWJWFWOVB
      VDXMWIXOYCXLUNYHXNWKAYHWHXMXJXNWKVEXLWHYGYATYJXBXJXHYGVFWJXCWFJWFVGUOXMWI
      XOYCXLUEVHVIVJVKVLVMVNVOVPECDAWFVQVDVRWDWERSEWDBWRWTNWFWNLMWDISAWNWFVSVTW
      DJRSBWDJAWFUCVRUGWAWBWC $.

    $( Idempotence of the "n-locally" predicate, i.e. being "n-locally
       ` A ` " is a local property.  (Use ~ loclly to show
       ` N-Locally N-Locally A = N-Locally A ` .)  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    nllyidm $p |- Locally N-Locally A = N-Locally A $=
      ( vj vv vy vx vu vz cv wcel ctop crest co wrex wel w3a wss syl3anc adantr
      wa wtru cnlly clly csn cnei cfv cpw cin wral llytop llyi simprr3 ssid a1i
      simprl wb simpl1 syl restopn2 syl2anc mpbir2and simprr2 nlly2i wi simpr2l
      cuni simpr31 opnneip simpr32 simpr1 elpwid elssuni sstrd syl22anc simprr1
      eqid ssnei2 elpw sylibr elin sylanbrc wceq restabs simpr33 eqeltrrd 3exp2
      vex jca imp sylbid rexlimdv expimpd mpd rexlimddv 3expb ralrimivva isnlly
      reximdv2 ssriv nllyrest adantl nllytop restlly trud eqssi ) AUAZUBZXEBXFX
      EBHZXFIZXGJIZXGCHZKLZAIZCDHZUCZXGUDUEUEZEHZUFZUGZMZDXPUHEXGUHXGXEIZXEXGUI
      ZXHXSEDXGXPXHEBNZDENZXSXHYBYCOZFHZXPPZDFNZXGYEKLZXEIZOZXSFXGFXEXMXPXGUJYD
      FBNZYJSZSZDGNZGHZXJPZYHXJKLZAIZOZGYHMZCYEUFZMZXSYMYIYEYHIZYGUUBYFYGYIYKYD
      UKYMUUCYKYEYEPZYDYKYJUNZUUDYMYEULUMYMXIYKUUCYKUUDSUOYMXHXIXHYBYCYLUPYAUQZ
      UUEYEYEXGURUSUTYFYGYIYKYDVAGAXMYEYHCVBQYMYTXLCUUAXRYMXJUUAIZYTXJXRIZXLSZY
      MUUGSZYSUUIGYHUUJYOYHIZGBNZYOYEPZSZYSUUIVCZYMUUKUUNUOZUUGYMXIYKUUPUUFUUEY
      EYOXGURUSRYMUUGUUNUUOVCYMUUGUUNYSUUIYMUUGUUNYSOZSZUUHXLUURXJXOIZXJXQIZUUH
      UURXIYOXOIZYPXJXGVEZPUUSYMXIUUQUUFRZUURXIUULYNUVAUVCUULUUMUUGYSYMVDYNYPYR
      UUGUUNYMVFXMXGYOVGQYNYPYRUUGUUNYMVHUURXJYEUVBUURXJYEYMUUGUUNYSVIVJZUURYKY
      EUVBPYMYKUUQUUERZYEXGVKUQVLXNXGXJYOUVBUVBVOVPVMUURXJXPPUUTUURXJYEXPUVDYMY
      FUUQYFYGYIYKYDVNRVLXJXPCWFVQVRXJXOXQVSVTUURYQXKAUURXIXJYEPYKYQXKWAUVCUVDU
      VEXJYEXGJXGWBQYNYPYRUUGUUNYMWCWDWGWEWHWIWJWKWQWLWMWNWOEDCAXGWPVTWRXEXFPTE
      XEBXTYBSXGXPKLXEITAXPXGWSWTXEJPTBXEJAXGXAWRUMXBXCXD $.
  $}

  ${
    $d a j n t u v w x y z $.  $d s u v w x y A $.  $d x y V $.  $d u x y X $.
    $d s u v w x y z J $.
    $( A topology is locally a topology.  (Contributed by Mario Carneiro,
       2-Mar-2015.) $)
    toplly $p |- Locally Top = Top $=
      ( vj vx ctop clly cv llytop ssriv wss wtru wcel crest resttop adantl ssid
      wa co a1i restlly trud eqssi ) CDZCAUACCAEZFGCUAHIBCAUBCJBEZUBJOUBUCKPCJI
      UCUBUBLMCCHICNQRST $.

    $( A topology is n-locally a topology.  (Contributed by Mario Carneiro,
       2-Mar-2015.) $)
    topnlly $p |- N-Locally Top = Top $=
      ( ctop clly wceq cnlly toplly loclly mpbi ) ABACADACEAFG $.

    $( A Hausdorff space is locally Hausdorff.  (Contributed by Mario Carneiro,
       2-Mar-2015.) $)
    hauslly $p |- ( J e. Haus -> J e. Locally Haus ) $=
      ( vx vj cha clly wss wtru cv wcel wa crest co resthaus ctop haustop ssriv
      adantl a1i restlly trud sseli ) DDEZADUBFGBDCCHZDIBHZUCIJUCUDKLDIGUDUCUCM
      QDNFGCDNUCOPRSTUA $.

    $( A Hausdorff space is n-locally Hausdorff iff it is locally Hausdorff
       (both notions are thus referred to as "locally Hausdorff").
       (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    hausnlly $p |- ( J e. N-Locally Haus <-> J e. Locally Haus ) $=
      ( vx vj cnlly clly wceq wtru cv wcel wa crest co resthaus adantl restnlly
      cha trud eleq2i ) PDZPEZASTFGBPCCHZPIBHZUAIJUAUBKLPIGUBUAUAMNOQR $.

    $( A compact Hausdorff space is locally compact.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    hausllycmp $p |- ( ( J e. Haus /\ J e. Comp ) -> J e. N-Locally Comp ) $=
      ( vv vy vx vu vz wcel ccmp wa cv crest cfv wrex wral adantr wss cdif eqid
      co syl2anc cha ctop csn cnei cpw cin cnlly haustop ccl cuni simpll difssd
      crab ccld simplr ad2antrr simprl opncld cmpcld simprr wceq ad2antrl dfss4
      elssuni eleqtrrd hauscmplem sseq2d anbi2d rexbidv simprrl opnneip syl3anc
      sylib mpbid sscls clsss3 ssnei2 syl22anc simprrr vex sylibr elin sylanbrc
      elpw2 clscld oveq2 eleq1d rspcev rexlimddv ralrimivva isnlly ) AUAGZAHGZI
      ZAUBGZABJZKSZHGZBCJZUCZAUDLLZDJZUEZUFZMZCXBNDANAHUGGWLWOWMAUHZOWNXEDCAXBW
      NXBAGZWSXBGZIZIZWSEJZGZXKAUILZLZXBPZIZXEEAXJXLXNAUJZXQXBQZQZPZIZEAMXPEAMX
      JFEBWSXRAWSWPGWPXMLXQFJQPIBAMFAUMZXQXQRZYBRWLWMXIUKXJXQXBULXJWMXRAUNLZGZA
      XRKSHGWLWMXIUOZXJWOXGYEWLWOWMXIXFUPZWNXGXHUQXBAXQYCURTXRAUSTXJWSXBXSWNXGX
      HUTXJXBXQPZXSXBVAXGYHWNXHXBAVDVBXBXQVCVMZVEVFXJYAXPEAXJXTXOXLXJXSXBXNYIVG
      VHVIVNXJXKAGZXPIZIZXNXDGZAXNKSZHGZXEYLXNXAGZXNXCGZYMYLWOXKXAGZXKXNPZXNXQP
      ZYPXJWOYKYGOZYLWOYJXLYRUUAXJYJXPUQXJYJXLXOVJWSAXKVKVLYLWOXKXQPZYSUUAYJUUB
      XJXPXKAVDVBZXKAXQYCVOTYLWOUUBYTUUAUUCXKAXQYCVPTWTAXNXKXQYCVQVRYLXOYQXJYJX
      LXOVSXNXBDVTWDWAXNXAXCWBWCYLWMXNYDGZYOXJWMYKYFOYLWOUUBUUDUUAUUCXKAXQYCWET
      XNAUSTWRYOBXNXDWPXNVAWQYNHWPXNAKWFWGWHTWIWJDCBHAWKWC $.

    $( A closed subspace of a locally compact space is also locally compact.
       (The analogous result for open subspaces follows from the more general
       ~ nllyrest .)  (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    cldllycmp $p |- ( ( J e. N-Locally Comp /\ A e. ( Clsd ` J ) ) ->
      ( J |`t A ) e. N-Locally Comp ) $=
      ( vv vy vx vu vw vs ccmp wcel wa crest co ctop cin wrex wceq wss syl3anc
      cv cnlly ccld cfv csn cnei cpw nllytop resttop sylan elrest simpll simprl
      wral w3a inss1 simprr sseldi nlly2i cuni ad2antrr simpllr simprlr elrestr
      ad3antrrr simprr1 inss2 simplrr elin sylanbrc opnneip simprr2 ssrin cldss
      syl eqid restuni syl2anc syl5sseq ssnei2 syl22anc simprll elpwid vex elpw
      inex1 sylibr a1i restabs eqtr4d simprr3 incom ineq1 eqeq2d rspcev sylancl
      simplrl elssuni sstrd restcld mpbird syl5eqel cmpcld eqeltrd oveq2 eleq1d
      wb expr rexlimdvva anassrs ralrimiva ineq2d rexeqdv raleqbi1dv syl5ibrcom
      mpd pweq rexlimdva sylbid ralrimiv isnlly ) BIUAZJZABUBUCZJZKZBALMZNJZYFC
      TZLMZIJZCDTZUDZYFUEUCUCZETZUFZOZPZDYNUMZEYFUMYFYAJYBBNJZYDYGIBUGZABYCUHUI
      ZYEYREYFYEYNYFJYNFTZAOZQZFBPYRFYNABYAYCUJYEUUDYRFBYEUUBBJZKZYRUUDYJCYMUUC
      UFZOZPZDUUCUMUUFUUIDUUCYEUUEYKUUCJZUUIYEUUEUUJKZKZYKGTZJZUUMHTZRZBUUOLMZI
      JZUNZGBPHUUBUFZPZUUIUULYBUUEYKUUBJUVAYBYDUUKUKYEUUEUUJULUULUUCUUBYKUUBAUO
      YEUUEUUJUPUQGIYKUUBBHURSUULUUSUUIHGUUTBUULUUOUUTJZUUMBJZKZUUSUUIUULUVDUUS
      KZKZUUOAOZUUHJZYFUVGLMZIJZUUIUVFUVGYMJZUVGUUGJZUVHUVFYGUUMAOZYMJZUVMUVGRZ
      UVGYFUSZRUVKYEYGUUKUVEUUAUTZUVFYGUVMYFJZYKUVMJZUVNUVQUVFYSYDUVCUVRYBYSYDU
      UKUVEYTVDZYBYDUUKUVEVAZUULUVBUVCUUSVBUUMABNYCVCSUVFUUNYKAJUVSUUNUUPUURUVD
      UULVEUVFUUCAYKUUBAVFYEUUEUUJUVEVGUQYKUUMAVHVIYKYFUVMVJSUVFUUPUVOUUNUUPUUR
      UVDUULVKUUMUUOAVLVNUVFAUVGUVPUUOAVFZUVFYSABUSZRZAUVPQUVTUVFYDUWDUWAABUWCU
      WCVOZVMVNABUWCUWEVPVQVRYLYFUVGUVMUVPUVPVOVSVTUVFUVGUUCRZUVLUVFUUOUUBRUWFU
      VFUUOUUBUULUVBUVCUUSWAZWBZUUOUUBAVLVNUVGUUCUUOAHWCWEWDWFUVGYMUUGVHVIUVFUV
      IUUQUVGLMZIUVFUVIBUVGLMZUWIUVFYSUVGARZYDUVIUWJQUVTUWKUVFUWBWGUWAUVGABNYCW
      HSUVFYSUVGUUORZUVBUWIUWJQUVTUWLUVFUUOAUOWGUWGUVGUUOBNUUTWHSWIUVFUURUVGUUQ
      UBUCZJUWIIJUUNUUPUURUVDUULWJUVFUVGAUUOOZUWMUUOAWKUVFUWNUWMJZUWNYHUUOOZQZC
      YCPZUVFYDUWNUWNQZUWRUWAUWNVOUWQUWSCAYCYHAQUWPUWNUWNYHAUUOWLWMWNWOUVFYSUUO
      UWCRUWOUWRXFUVTUVFUUOUUBUWCUWHUVFUUEUUBUWCRYEUUEUUJUVEWPUUBBWQVNWRCUWNUUO
      BUWCUWEWSVQWTXAUVGUUQXBVQXCYJUVJCUVGUUHYHUVGQYIUVIIYHUVGYFLXDXEWNVQXGXHXO
      XIXJYQUUIDYNUUCUUDYJCYPUUHUUDYOUUGYMYNUUCXPXKXLXMXNXQXRXSEDCIYFXTVI $.

    $( First-countability is a local property (unlike second-countability).
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    lly1stc $p |- Locally 1stc = 1stc $=
      ( vj vy vx vz vw vu vt vv vn c1stc cv wcel wel wss wa wrex wi wral adantr
      wceq va clly ctop com cdom wbr cpw cuni llytop crest co simpl eqid topopn
      w3a syl simpr llyi syl3anc simprr simprl elssuni ad2antlr restuni syl2anc
      ad3antrrr eleqtrd 1stcclb cin cmpt crn wf elpwi adantl sselda wb restopn2
      simpllr simplbda df-ss sylib simprbda eqeltrd ineq1 cbvmptv fmptd adantrr
      syldan frn elpw2 sylibr simprrl 1stcrestlem ad2antrr elrestr simprrr elin
      vex sylanbrc eleq2 sseq2 rexbidv imbi12d rspcv syl3c simplbi2com biantrud
      anbi2d ssin syl6bb ssinss1 syl6bir anim12d reximdva cvv inex1 rgenw sseq1
      anbi12d rexrnmpt ax-mp syl6ibr expr ralrimiva breq1 imbi2d ralbidv rspcev
      mpd rexeq syl12anc rexlimddv 3adantr1 ex rexlimdva is1stc2 ssriv 1stcrest
      wtru 1stctop a1i restlly trud eqssi ) JUBZJAUUEJAKZUUELZUUFUCLZBKZUDUEUFZ
      CDMZCEMZEKZDKZNZOZEUUIPZQZDUUFRZOZBUUFUGZPZCUUFUHZRUUFJLZJUUFUIZUUGUVBCUV
      CUUGCKZUVCLZOZFKZUVCNZCFMZUUFUVIUJUKZJLZUOZFUUFPZUVBUVHUUGUVCUUFLZUVGUVOU
      UGUVGULUVHUUHUVPUUGUUHUVGUVESUUFUVCUVCUMZUNUPUUGUVGUQFJUVFUVCUUFURUSUVHUV
      NUVBFUUFUVHFAMZOZUVNUVBUVSUVKUVMUVBUVJUVSUVKUVMOZOZGKZUDUEUFZCHMZCIMZIKZH
      KZNZOZIUWBPZQZHUVLRZOZUVBGUVLUGZUWAUVMUVFUVLUHZLUWMGUWNPUVSUVKUVMUTUWAUVF
      UVIUWOUVSUVKUVMVAZUWAUUHUVJUVIUWOTUUGUUHUVGUVRUVTUVEVFZUVRUVJUVHUVTUVIUUF
      VBVCUVIUUFUVCUVQVDVEVGGHIUVFUVLUWOUWOUMVHVEUWAUWBUWNLZUWMOZOZUAUWBUAKZUVI
      VIZVJZVKZUVALZUXDUDUEUFZUUKUUPEUXDPZQZDUUFRZUVBUWTUXDUUFNZUXEUWAUWRUXJUWM
      UWAUWROZUWBUUFUXCVLUXJUXKIUWBUWFUVIVIZUUFUXCUXKIGMZOZUXLUWFUUFUXNUWFUVINZ
      UXLUWFTUXKUXMUWFUVLLZUXOUXKUWBUVLUWFUWRUWBUVLNUWAUWBUVLVMVNVOZUXKUXPIAMZU
      XOUXKUUHUVRUXPUXRUXOOVPUWAUUHUWRUWQSUVHUVRUVTUWRVRUVIUWFUUFVQVEZVSWHZUWFU
      VIVTWAUXKUXMUXPUXRUXQUXKUXPUXRUXOUXSWBWHWCUAIUWBUXBUXLUXAUWFUVIWDWEZWFUWB
      UUFUXCWIUPWGUXDUUFAWRWJWKUWTUWCUXFUWAUWRUWCUWLWLUAUWBUXBWMUPUWTUXHDUUFUWT
      DAMZUUKUXGUWTUYBUUKOZOZUWEUWFUUNUVIVIZNZOZIUWBPZUXGUYDUYEUVLLZUWLUVFUYELZ
      UYHUYDUUHUVRUYBUYIUWAUUHUWSUYCUWQWNUWTUVRUYCUVHUVRUVTUWSVRSUWTUYBUUKVAUUN
      UVIUUFUCUUFWOUSUWTUWLUYCUWAUWRUWCUWLWPSUYDUUKUVKUYJUWTUYBUUKUTUWAUVKUWSUY
      CUWPWNUVFUUNUVIWQWSUWKUYJUYHQHUYEUVLUWGUYETZUWDUYJUWJUYHUWGUYEUVFWTUYKUWI
      UYGIUWBUYKUWHUYFUWEUWGUYEUWFXAXHXBXCXDXEUWTUYHUXGQZUYCUWAUWRUYLUWMUXKUYHU
      VFUXLLZUXLUUNNZOZIUWBPZUXGUXKUYGUYOIUWBUXNUWEUYMUYFUYNUXNUVKUWEUYMQUWAUVK
      UWRUXMUWPWNUYMUWEUVKUVFUWFUVIWQXFUPUXNUYFUWFUUNNZUYNUXNUYQUYQUXOOUYFUXNUX
      OUYQUXTXGUWFUUNUVIXIXJUWFUVIUUNXKXLXMXNUXLXOLZIUWBRUXGUYPVPUYRIUWBUWFUVII
      WRXPXQUUPUYOIEUWBUXLUXCXOUYAUUMUXLTUULUYMUUOUYNUUMUXLUVFWTUUMUXLUUNXRXSXT
      YAYBWGSYIYCYDUUTUXFUXIOBUXDUVAUUIUXDTZUUJUXFUUSUXIUUIUXDUDUEYEUYSUURUXHDU
      UFUYSUUQUXGUUKUUPEUUIUXDYJYFYGXSYHYKYLYMYNYOYIYDCBDEUUFUVCUVQYPWSYQJUUENY
      SCJAUVDCAMOUUFUVFUJUKJLYSUVFUUFUUFYRVNJUCNYSAJUCUUFYTYQUUAUUBUUCUUD $.

    $( The discrete space ` ~P X ` is locally ` A ` if and only if every
       singleton space has property ` A ` .  (Contributed by Mario Carneiro,
       20-Mar-2015.) $)
    dislly $p |- ( X e. V -> ( ~P X e. Locally A <->
      A. x e. X ~P { x } e. A ) ) $=
      ( vy vu wcel cpw cv wral wa wss crest co wrex simplr snssd wceq ralrimiva
      syl2anc clly csn w3a simpr vex snelpw snid a1i llyi syl3anc simpr1 simpr2
      sylib eqssd oveq2d simplll restdis eqtrd simpr3 eqeltrrd ex rexlimdvw mpd
      ctop cin distop adantr wi elpwi adantl ssralv syl simprl snex elpw sylibr
      sstrd elin sylanbrc snidg simpll simprr eqeltrd eleq2 oveq2 eleq1d rspcev
      ad2antrl anbi12d syl12anc expr ralimdva syld imp an32s islly impbida ) DC
      GZDHZBUAGZAIZUBZHZBGZADJZWRWTKZXDADXFXADGZKZEIZXBLZXAXIGZWSXIMNZBGZUCZEWS
      OZXDXHWTXBWSGZXAXBGZXOWRWTXGPXHXGXPXFXGUDXADAUEZUFUMXQXHXAXRUGUHEBXAXBWSU
      IUJXHXNXDEWSXHXNXDXHXNKZXLXCBXSXLWSXBMNZXCXSXIXBWSMXSXIXBXHXJXKXMUKXSXAXI
      XHXJXKXMULQUNUOXSWRXBDLZXTXCRZWRWTXGXNUPXSXADXFXGXNPQDXBCUQZTURXHXJXKXMUS
      UTVAVBVCSWRXEKZWSVDGZXAFIZGZWSYFMNZBGZKZFWSXIHZVEZOZAXIJZEWSJWTWRYEXEDCVF
      VGYDYNEWSWRXIWSGZXEYNWRYOKZXEYNYPXEXDAXIJZYNYPXIDLZXEYQVHYOYRWRXIDVIVJZXD
      AXIDVKVLYPXDYMAXIYPXKXDYMYPXKXDKZKZXBYLGZXQXTBGZYMUUAXPXBYKGZUUBUUAYAXPUU
      AXBXIDUUAXAXIYPXKXDVMQZYPYRYTYSVGVQZXBDXAVNZVOVPUUAXBXILUUDUUEXBXIUUGVOVP
      XBWSYKVRVSXKXQYPXDXAXIVTWHUUAXTXCBUUAWRYAYBWRYOYTWAUUFYCTYPXKXDWBWCYJXQUU
      CKFXBYLYFXBRZYGXQYIUUCYFXBXAWDUUHYHXTBYFXBWSMWEWFWIWGWJWKWLWMWNWOSEAFBWSW
      PVSWQ $.

    $( A discrete space is locally compact.  (Contributed by Mario Carneiro,
       20-Mar-2015.) $)
    disllycmp $p |- ( X e. V -> ~P X e. Locally Comp ) $=
      ( vx wcel cpw ccmp clly csn wral cfn snfi discmp mpbi rgenw dislly mpbiri
      cv ) BADBEFGDCQZHZEFDZCBITCBSJDTRKSLMNCFABOP $.

    $( A discrete space is first-countable.  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    dis1stc $p |- ( X e. V -> ~P X e. 1stc ) $=
      ( vx wcel cpw c1stc clly cv csn wral c2ndc ctg cfv ctop cvv ax-mp com wbr
      cfn mpbi wceq snex distop ctb cdom topbas csdm snfi pwfi isfinite sdomdom
      tgtop 2ndci mp2an eqeltrri 2ndc1stc rgenw dislly mpbiri lly1stc syl6eleq
      ) BADZBEZFGZFVBVCVDDCHZIZEZFDZCBJVHCBVGKDVHVGLMZVGKVGNDZVIVGUAVFODVJVEUBV
      FOUCPZVGULPVGUDDZVGQUERZVIKDVJVLVKVGUFPVGQUGRZVMVGSDZVNVFSDVOVEUHVFUITVGU
      JTVGQUKPVGUMUNUOVGUPPUQCFABURUSUTVA $.
  $}

  ${
    $d f x A $.  $d f x J $.  $d f x X $.
    hauspwdom.1 $e |- X = U. J $.
    $( If ` X ` is a first-countable Hausdorff space, then the cardinality of
       the closure of a set ` A ` is bounded by ` NN ` to the power ` A ` .  In
       particular, a first-countable Hausdorff space with a dense subset ` A `
       has cardinality at most ` A ^ NN ` , and a separable first-countable
       Hausdorff space has cardinality at most ` ~P NN ` .  (Compare
       ~ hauspwpwdom to see a weaker result if the assumption of
       first-countability is omitted.)  (Contributed by Mario Carneiro,
       9-Apr-2015.) $)
    hausmapdom $p |- ( ( J e. Haus /\ J e. 1stc /\ A C_ X ) ->
      ( ( cls ` J ) ` A ) ~<_ ( A ^m NN ) ) $=
      ( vx vf cha wcel cfv cn cmap cdom cv wbr wa wex wb cvv 3ad2ant1 syl6bbr
      c1stc wss w3a ccl clm co cima wrex 1stcelcls 3adant1 cuni uniexg syl5eqel
      wf simp3 ssexd elmapg sylancl anbi1d exbidv bitr4d df-rex vex elima eqrdv
      nnex wfun ovex lmfun imadomg mpsyl eqbrtrd ) BGHZBUAHZACUBZUCZABUDIIZBUEI
      ZAJKUFZUGZVSLVPEVQVTVPEMZVQHZFMZWAVRNZFVSUHZWAVTHVPWBWCVSHZWDOZFPZWEVPWBJ
      AWCUNZWDOZFPZWHVNVOWBWKQVMWAAFBCDUIUJVPWGWJFVPWFWIWDVPARHJRHWFWIQVPACRVPC
      BUKZRDVMVNWLRHVOBGULSUMVMVNVOUOUPVFAJWCRRUQURUSUTVAWDFVSVBTFWAVRVSEVCVDTV
      EVSRHVPVRVGZVTVSLNAJKVHVMVNWMVOBVISVSRVRVJVKVL $.

    $( Simplify the cardinal ` A ^ NN ` of ~ hausmapdom to ` ~P B = 2 ^ B `
       when ` B ` is an infinite cardinal greater than ` A ` .  (Contributed by
       Mario Carneiro, 9-Apr-2015.)  (Revised by Mario Carneiro,
       30-Apr-2015.) $)
    hauspwdom $p |- ( ( ( J e. Haus /\ J e. 1stc /\ A C_ X ) /\
      ( A ~<_ ~P B /\ NN ~<_ B ) ) -> ( ( cls ` J ) ` A ) ~<_ ~P B ) $=
      ( wcel cdom wbr cn wa cmap adantr c0 c1 c2o cen syl cvv cfn com cha c1stc
      wss w3a cpw ccl cfv co hausmapdom wceq wn simprr 1nn eleq2 mtbiri mapdom2
      noel sylancl csdm sdomdom adantl mapdom1 reldom brrelex2i ad2antll pw2eng
      mt2 ensym 3syl domentr syl2anc wb con0 onfin2 inss2 eqsstri sselii simprl
      cin 2onn brrelexi fidomtri sylancr biimpar ccrd cdm numth3 nnenom endomtr
      ensymi simpr mappwen syl22anc endom syldan pm2.61dan domtr ) CUAFCUBFADUC
      UDZABUEZGHZIBGHZJZJZACUFUGUGZAIKUHZGHZXEWSGHZXDWSGHWRXFXBACDEUILXCXEABKUH
      ZGHZXHWSGHZXGXCXAIMUJZAMUJZJZUKXIWRWTXAULZXMNIFZUMXKXOUKXLXKXONMFNUQIMNUN
      UOLVGIBAUPURXCAOUSHZXJXCXPJZXHOBKUHZGHZXRWSPHZXJXQAOGHZXSXPYAXCAOUTVAAOBV
      BQXCXTXPXCBRFZWSXRPHXTXAYBWRWTIBGVCVDVEZBRVFWSXRVHVILXHXRWSVJVKXCXPUKZOAG
      HZXJXCYEYDXCOSFARFZYEYDVLTSOTVMSVSSVNVMSVOVPVTVQXCWTYFWRWTXAVRZAWSGVCWAQO
      ARWBWCWDXCYEJZXHWSPHZXJYHBWEWFFZTBGHZYEWTYIXCYJYEXCYBYJYCBRWGQLXCYKYEXCTI
      PHXAYKITWHWJXNTIBWIWCLXCYEWKXCWTYEYGLABWLWMXHWSWNQWOWPXEXHWSWQVKXDXEWSWQV
      K $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Compactly generated spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c kGen $.

  $( Extend class notation with the compact generator operation. $)
  ckgen $a class kGen $.

  ${
    $d j k x $.
    $( Define the "compact generator", the functor from topological spaces to
       compactly generated spaces.  Also known as the k-ification operation.  A
       set is k-open, i.e. ` x e. ( kGen `` j ) ` , iff the preimage of ` x `
       is open in all compact Hausdorff spaces.  (Contributed by Mario
       Carneiro, 20-Mar-2015.) $)
    df-kgen $a |- kGen = ( j e. Top |-> { x e. ~P U. j | A. k e. ~P U. j
      ( ( j |`t k ) e. Comp -> ( x i^i k ) e. ( j |`t k ) ) } ) $.
  $}

  ${
    $d k x A $.  $d j k x J $.  $d j k x X $.
    $( Value of the compact generator.  (The "k" in ` kGen ` comes from the
       name "k-space" for these spaces, after the German word kompakt.)
       (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    kgenval $p |- ( J e. ( TopOn ` X ) -> ( kGen ` J ) = { x e. ~P X |
      A. k e. ~P X ( ( J |`t k ) e. Comp -> ( x i^i k ) e. ( J |`t k ) ) } ) $=
      ( vj ctopon wcel cv crest co ccmp cuni cpw wral crab ctop ckgen cvv wceq
      wi cfv cin cmpt df-kgen wa unieq toponuni eqcomd sylan9eqr pweqd wb oveq1
      eleq1d eleq2d imbi12d adantl raleqbidv rabeqbidv topontop toponmax rabexg
      a1i pwexg 3syl fvmptd ) CDFUAGZECEHZBHZIJZKGZAHVHUBZVIGZTZBVGLZMZNZAVOOZC
      VHIJZKGZVKVRGZTZBDMZNZAWBOZPQRQEPVQUCSVFAEBUDVBVFVGCSZUEZVPWCAVOWBWFVNDWE
      VFVNCLZDVGCUFVFDWGDCUGUHUIUJZWFVMWABVOWBWHWEVMWAUKVFWEVJVSVLVTWEVIVRKVGCV
      HIULZUMWEVIVRVKWIUNUOUPUQURDCUSVFDCGWBRGWDRGDCUTDCVCWCAWBRVAVDVE $.

    $( Value of the compact generator.  (Contributed by Mario Carneiro,
       20-Mar-2015.) $)
    elkgen $p |- ( J e. ( TopOn ` X ) -> ( A e. ( kGen ` J ) <-> ( A C_ X /\
    A. k e. ~P X ( ( J |`t k ) e. Comp -> ( A i^i k ) e. ( J |`t k ) ) ) ) ) $=
      ( vx ctopon cfv wcel ckgen cv crest co ccmp cin wi cpw wral crab wss wa
      kgenval eleq2d wceq ineq1 eleq1d imbi2d ralbidv elrab toponmax elpw2g syl
      wb anbi1d syl5bb bitrd ) CDFGHZACIGZHACBJZKLZMHZEJZURNZUSHZOZBDPZQZEVERZH
      ZADSZUTAURNZUSHZOZBVEQZTZUPUQVGAEBCDUAUBVHAVEHZVMTUPVNVFVMEAVEVAAUCZVDVLB
      VEVPVCVKUTVPVBVJUSVAAURUDUEUFUGUHUPVOVIVMUPDCHVOVIULDCUIADCUJUKUMUNUO $.
  $}

  ${
    $d y A $.  $d k x y J $.  $d y K $.  $d j k x y X $.
    $( Property of the open sets in the compact generator.  (Contributed by
       Mario Carneiro, 20-Mar-2015.) $)
    kgeni $p |- ( ( A e. ( kGen ` J ) /\ ( J |`t K ) e. Comp ) ->
      ( A i^i K ) e. ( J |`t K ) ) $=
      ( vy vj vx ckgen cfv wcel crest co ccmp wa cin cuni wceq cv wi ctop cvv
      inass in32 eqtr3i wss cpw ctopon cdm df-kgen dmmptss elfvdm sseldi adantr
      wral crab toptopon sylib simpl elkgen biimpa syl2anc simpld ineq1d syl5eq
      eqid df-ss inss2 wb cmptop adantl restrcl simprd inex1g elpwg 3syl mpbiri
      syl restin simpr eqeltrrd oveq2 eleq1d ineq2 eleq12d rspcv syl3c eleqtrrd
      imbi12d ) ABGHIZBCJKZLIZMZACNZBCBOZNZJKZWIWKAWNNZWLWOWKWPAWMNZCNZWLWLWMNW
      PWRACWMUAACWMUBUCWKWQACWKAWMUDZWQAPWKWSBDQZJKZLIZAWTNZXAIZRZDWMUEZUMZWKBW
      MUFHIZWHWSXGMZWKBSIZXHWHXJWJWHGUGSBESEQZWTJKZLIFQWTNXLIRDXKOUEZUMFXMUNGFE
      DUHUIABGUJUKULZBWMWMVDZUOUPWHWJUQXHWHXIADBWMURUSUTZVAAWMVEUPVBVCWKWNXFIZX
      GWOLIZWPWOIZWKXQWNWMUDZCWMVFWKCTIZWNTIXQXTVGWKWISIZYAWJYBWHWIVHVIYBBTIYAC
      BVJVKVPZCWMTVLWNWMTVMVNVOWKWSXGXPVKWKWIWOLWKXJYAWIWOPXNYCCBSTWMXOVQUTZWHW
      JVRVSXEXRXSRDWNXFWTWNPZXBXRXDXSYEXAWOLWTWNBJVTZWAYEXCWPXAWOWTWNAWBYFWCWGW
      DWEVSYDWF $.

    $( The compact generator generates a topology.  (Contributed by Mario
       Carneiro, 22-Aug-2015.) $)
    kgentopon $p |- ( J e. ( TopOn ` X ) -> ( kGen ` J ) e. ( TopOn ` X ) ) $=
      ( vx vy vk cfv wcel cv wss wi cin wral wa syl2anc ralrimiva elkgen adantr
      expr wb mpbir2and ctopon ckgen ctop cuni wceq wal crest co ccmp cpw uniss
      crab kgenval ssrab2 syl6eqss sspwuni sylib sylan9ssr iunin2 uniiun ineq2i
      ciun incom 3eqtr2i cmptop ad2antll simplr sselda simplrr syl5eqelr iunopn
      kgeni ex alrimiv inss1 elssuni ad2antrl ssid elpwi dfss1 resttopon sylan2
      a1i toponmax eqeltrd eqssd sseqtr4d syl5ss inindir simplrl simprr syl3anc
      syl inopn syl5eqel ralrimivva cvv fvex istopg ax-mp sylanbrc istopon ) AB
      UAFZGZAUBFZUCGZBXEUDZUEZXEXCGXDCHZXEIZXIUDZXEGZJZCUFZXIDHZKZXEGZDXELCXELZ
      XFXDXMCXDXJXLXDXJMZXLXKBIZAEHZUGUHZUIGZXKYAKZYBGZJZEBUJZLZXJXDXKXGBXIXEUK
      XDXEYGIXGBIXDXEYCXIYAKZYBGZJEYGLZCYGULYGCEABUMYKCYGUNUOXEBUPUQZURXSYFEYGX
      SYAYGGZYCYEXSYMYCMZMZYDDXIYAXOKZVBZYBYQYADXIXOVBZKYAXKKYDDXIYAXOUSXKYRYAD
      XIUTVAYAXKVCVDYOYBUCGZYPYBGZDXILYQYBGYCYSXSYMYBVEZVFYOYTDXIYOXOXIGZMZYPXO
      YAKZYBXOYAVCUUCXOXEGZYCUUDYBGZYOXIXEXOXDXJYNVGVHXSYMYCUUBVIXOAYAVLZNVJODX
      IYPYBVKNVJROXDXLXTYHMSXJXKEABPQTVMVNXDXQCDXEXEXDXIXEGZUUEMZMZXQXPBIZYCXPY
      AKZYBGZJZEYGLZUUJXPXIBXIXOVOUUJXIXGBUUHXIXGIXDUUEXIXEVPVQXDXHUUIXDBXGXDBX
      EGZBXGIXDUUPBBIZYCBYAKZYBGZJZEYGLUUQXDBVRWCXDUUTEYGXDYMYCUUSXDYNMZUURYAYB
      UVAYABIZUURYAUEYMUVBXDYCYABVSZVQYABVTUQUVAYBYAUAFGZYAYBGYNXDUVBUVDYMUVBYC
      UVCQYAABWAWBYAYBWDWMWEROBEABPTBXEVPWMYLWFZQWGWHUUJUUNEYGUUJYMYCUUMUUJYNMZ
      UULYIUUDKZYBXIXOYAWIUVFYSYJUUFUVGYBGYCYSUUJYMUUAVFUVFUUHYCYJXDUUHUUEYNWJU
      UJYMYCWKZXIAYAVLNUVFUUEYCUUFXDUUHUUEYNVIUVHUUGNYIUUDYBWNWLWOROXDXQUUKUUOM
      SUUIXPEABPQTWPXEWQGXFXNXRMSAUBWRCDWQXEWSWTXAUVEBXEXBXA $.
  $}

  ${
    $d k x J $.  $d k x X $.
    kgenuni.1 $e |- X = U. J $.
    $( The base set of the compact generator is the same as the original
       topology.  (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    kgenuni $p |- ( J e. Top -> X = U. ( kGen ` J ) ) $=
      ( ctop wcel ckgen cfv ctopon cuni wceq toptopon kgentopon sylbi toponuni
      syl ) ADEZAFGZBHGZEZBQIJPARESABCKABLMBQNO $.
  $}

  ${
    $d j k x y J $.  $d x y K $.
    $( The compact generator generates a topology.  (Contributed by Mario
       Carneiro, 20-Mar-2015.) $)
    kgenftop $p |- ( J e. Top -> ( kGen ` J ) e. Top ) $=
      ( ctop wcel ckgen cfv cuni ctopon eqid toptopon kgentopon sylbi topontop
      syl ) ABCZADEZAFZGEZCZOBCNAQCRAPPHIAPJKPOLM $.

    $( The compact generator is a function on topologies.  (Contributed by
       Mario Carneiro, 20-Mar-2015.) $)
    kgenf $p |- kGen : Top --> Top $=
      ( vj vx vk ctop ckgen wf wtru cv crest co ccmp wcel cin wi cuni wral crab
      cpw cvv a1i wa vex uniex pwex rabex cmpt wceq df-kgen cfv kgenftop adantl
      fmpt2d trud ) DDEFGABDAHZCHZIJZKLBHZUOMUPLNCUNOZRZPZBUSQZDESVASLGUNDLUAUT
      BUSURUNAUBUCUDUETEADVAUFUGGBACUHTUQDLUQEUIDLGUQUJUKULUM $.

    $( A compactly generated space is a topology.  (Note: henceforth we will
       use the idiom " ` J e. ran kGen ` " to denote " ` J ` is compactly
       generated", since as we will show a space is compactly generated iff it
       is in the range of the compact generator.)  (Contributed by Mario
       Carneiro, 20-Mar-2015.) $)
    kgentop $p |- ( J e. ran kGen -> J e. Top ) $=
      ( ckgen crn ctop wf wss kgenf frn ax-mp sseli ) BCZDADDBEKDFGDDBHIJ $.

    $( The compact generator generates a finer topology than the original.
       (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    kgenss $p |- ( J e. Top -> J C_ ( kGen ` J ) ) $=
      ( vx vk ctop wcel ckgen cfv cv cuni wss crest co ccmp cin wi wral elssuni
      cpw wa a1i elrestr 3expa an32s a1d ralrimiva ex jcad ctopon eqid toptopon
      wb elkgen sylbi sylibrd ssrdv ) ADEZBAAFGZUPBHZAEZURAIZJZACHZKLZMEZURVBNV
      CEZOZCUTRZPZSZURUQEZUPUSVAVHUSVAOUPURAQTUPUSVHUPUSSZVFCVGVKVBVGEZSVEVDUPV
      LUSVEUPVLUSVEURVBADVGUAUBUCUDUEUFUGUPAUTUHGEVJVIUKAUTUTUIUJURCAUTULUMUNUO
      $.

    $( The compact generator generates another Hausdorff topology given a
       Hausdorff topology to start from.  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    kgenhaus $p |- ( J e. Haus -> ( kGen ` J ) e. Haus ) $=
      ( cha wcel ckgen cfv cuni ctopon wss ctop haustop eqid toptopon kgentopon
      sylib syl kgenss sshaus mpd3an23 ) ABCZADEZAFZGEZCZATHZTBCSAUBCZUCSAICZUE
      AJZAUAUAKZLNAUAMOSUFUDUGAPOATUAUHQR $.

    $( The compact generator topology is the same as the original topology on
       compact subspaces.  (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    kgencmp $p |- ( ( J e. Top /\ ( J |`t K ) e. Comp )
      -> ( J |`t K ) = ( ( kGen ` J ) |`t K ) ) $=
      ( vx ctop wcel crest co ccmp ckgen cfv wss kgenftop adantr kgenss syl2anc
      wa ssrest cv cvv syl cin cmpt crn cmptop adantl restrcl simprd restval wf
      wceq simpr simplr kgeni eqid fmptd frn eqsstrd eqssd ) ADEZABFGZHEZPZUTAI
      JZBFGZVBVCDEZAVCKZUTVDKUSVEVAALMZUSVFVAANMBAVCDQOVBVDCVCCRZBUAZUBZUCZUTVB
      VEBSEZVDVKUJVGVBUTDEZVLVAVMUSUTUDUEVMASEVLBAUFUGTCBVCDSUHOVBVCUTVJUIVKUTK
      VBCVCVIUTVJVBVHVCEZPVNVAVIUTEVBVNUKUSVAVNULVHABUMOVJUNUOVCUTVJUPTUQUR $.

    $( The compact generator topology has the same compact sets as the original
       topology.  (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    kgencmp2 $p |- ( J e. Top -> ( ( J |`t K ) e. Comp <->
        ( ( kGen ` J ) |`t K ) e. Comp ) ) $=
      ( ctop wcel crest co ccmp cfv wa cuni ctopon wss cvv sylan2 eqid cin wceq
      simpr adantr restuni2 kgencmp eqeltrrd cmptop restrcl simprd syl toptopon
      ckgen resttop sylib kgenuni ineq2d kgenftop syl2an 3eqtr3d fveq2d eleqtrd
      kgenss ssrest syl2anc sscmp syl3anc impbida ) ACDZABEFZGDZAUHHZBEFZGDZVDV
      FIVEVHGABUAVDVFRUBVDVIIZVEVHJZKHZDVIVEVHLZVFVJVEVEJZKHZVLVJVECDZVEVODVIVD
      BMDZVPVIVHCDZVQVHUCVRVGMDVQBVGUDUEUFZBAMUINVEVNVNOUGUJVJVNVKKVJBAJZPZBVGJ
      ZPZVNVKVJVTWBBVDVTWBQVIAVTVTOZUKSULVIVDVQWAVNQVSBAMVTWDTNVDVGCDZVQWCVKQVI
      AUMZVSBVGMWBWBOTUNUOUPUQVDVIRVJWEAVGLZVMVDWEVIWFSVDWGVIAURSBAVGCUSUTVEVHV
      KVKOVAVBVC $.

    $( The compact generator is idempotent on compactly generated spaces.
       (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    kgenidm $p |- ( J e. ran kGen -> ( kGen ` J ) = J ) $=
      ( vj vx vk ckgen wcel cfv cv wceq ctop wss wb wa crest co kgentopon sylbi
      ccmp syl ad2ant2rl crn wrex wf wfn kgenf ffn fvelrnb mp2b cuni cin wi cpw
      wral ctopon toptopon toponss sylan simplr kgencmp2 biimpa syl2anc kgencmp
      eqid kgeni eleqtrrd ralrimiva simpl sylib elkgen mpbir2and ex ssrdv fveq2
      expr id sseq12d syl5ibcom rexlimiv kgentop kgenss eqssd ) AEUAFZAEGZAWBBH
      ZEGZAIZBJUBZWCAKZJJEUCEJUDWBWGLUEJJEUFBJAEUGUHWFWHBJWDJFZWEEGZWEKWFWHWICW
      JWEWICHZWJFZWKWEFZWIWLMZWMWKWDUIZKZWDDHZNOZRFZWKWQUJZWRFZUKZDWOULZUMZWIWJ
      WOUNGZFZWLWPWIWEXEFZXFWIWDXEFZXGWDWOWOVCUOZWDWOPQWEWOPSWKWJWOUPUQWNXBDXCW
      NWQXCFZWSXAWNXJWSMZMZWTWEWQNOZWRXLWLXMRFZWTXMFWIWLXKURWIWSXNWLXJWIWSXNWDW
      QUSUTTWKWEWQVDVAWIWSWRXMIWLXJWDWQVBTVEVNVFWNXHWMWPXDMLWNWIXHWIWLVGXIVHWKD
      WDWOVISVJVKVLWFWJWCWEAWEAEVMWFVOVPVQVRQWBAJFAWCKAVSAVTSWA $.

    $( A space is compactly generated iff it contains its image under the
       compact generator.  (Contributed by Mario Carneiro, 20-Mar-2015.) $)
    iskgen2 $p |- ( J e. ran kGen <-> ( J e. Top /\ ( kGen ` J ) C_ J ) ) $=
      ( ckgen crn wcel ctop cfv wss wa kgentop wceq kgenidm eqimss simpr kgenss
      syl jca adantr eqssd wfn wf kgenf ffn ax-mp fnfvelrn mpan eqeltrrd impbii
      ) ABCZDZAEDZABFZAGZHZUIUJULAIUIUKAJULAKUKALOPUMUKAUHUMUKAUJULMUJAUKGULANQ
      RUJUKUHDZULBESZUJUNEEBTUOUAEEBUBUCEABUDUEQUFUG $.
  $}

  ${
    $d k u x z J $.  $d k u x ph $.  $d k z X $.
    iskgen3.1 $e |- X = U. J $.
    $( Derive the usual definition of "compactly generated".  A topology is
       compactly generated if every subset of ` X ` that is open in every
       compact subset is open.  (Contributed by Mario Carneiro,
       20-Mar-2015.) $)
    iskgen3 $p |- ( J e. ran kGen <-> ( J e. Top /\ A. x e. ~P X ( A. k e. ~P X
      ( ( J |`t k ) e. Comp -> ( x i^i k ) e. ( J |`t k ) ) -> x e. J ) ) ) $=
      ( ckgen crn wcel ctop cfv wss wa cv crest co ccmp cin wi wral wal iskgen2
      cpw ctopon wb toptopon elkgen sylbi vex elpw anbi1i syl6bbr imbi1d impexp
      syl6bb albidv dfss2 df-ral 3bitr4g pm5.32i bitri ) CFGHCIHZCFJZCKZLVACBMZ
      NOZPHAMZVDQVEHRBDUBZSZVFCHZRZAVGSZLCUAVAVCVKVAVFVBHZVIRZATVFVGHZVJRZATVCV
      KVAVMVOAVAVMVNVHLZVIRVOVAVLVPVIVAVLVFDKZVHLZVPVACDUCJHVLVRUDCDEUEVFBCDUFU
      GVNVQVHVFDAUHUIUJUKULVNVHVIUMUNUOAVBCUPVJAVGUQURUSUT $.

    llycmpkgen2.2 $e |- ( ph -> J e. Top ) $.
    llycmpkgen2.3 $e |- ( ( ph /\ x e. X ) ->
      E. k e. ( ( nei ` J ) ` { x } ) ( J |`t k ) e. Comp ) $.
    $( A locally compact space is compactly generated.  (This variant of
       ~ llycmpkgen uses the weaker definition of locally compact, "every point
       has a compact neighborhood", instead of "every point has a local base of
       compact neighborhoods".)  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    llycmpkgen2 $p |- ( ph -> J e. ran kGen ) $=
      ( vz wcel cfv wss cv wa wceq syl cdif cin syl2anc wb ctop ckgen wrex wral
      vu crn crest co ccmp csn cnei cuni elssuni adantl kgenuni adantr sseqtr4d
      sselda adantlr syldan ad3antrrr difss ntropn sylancl simprl neii1 syl3anc
      cnt inopn cun inss1 simplr ntrss2 snssd neiint mpbid vex snss sylibr elin
      sseldd sylanbrc simpllr simprr kgeni resttop restuni syl5sseq eqid isopn3
      cvv inss2 restntr eqtr3d eleqtrd sseldi undif3 incom difeq2i difin syl5ss
      eqtri ssequn1 sylib difeq1d syl5eq fveq2d sslin c0 difss2d reldisj mpbird
      inssdif0 sstrd eleq2 sseq1 anbi12d rspcev syl12anc rexlimddv ralrimiva ex
      a1i eltop2 sylibrd ssrdv iskgen2 ) ADUAJZDUBKZDLDUBUFJGAUEYIDAUEMZYIJZBMZ
      IMZJZYMYJLZNZIDUCZBYJUDZYJDJZAYKYRAYKNZYQBYJYTYLYJJZNZDCMZUGUHZUIJZYQCYLU
      JZDUKKKZYTUUAYLEJZUUECUUGUCZYTYJEYLYTYJYIULZEYKYJUUJLAYJYIUMUNAEUUJOZYKAY
      HUUKGDEFUOPUPUQURZAUUHUUIYKHUSUTUUBUUCUUGJZUUENZNZEUUCYJQZQZDVHKZKZUUCUUR
      KZRZDJZYLUVAJZUVAYJLZYQUUOYHUUSDJZUUTDJZUVBAYHYKUUAUUNGVAZUUOYHUUQELZUVEU
      VGEUUPVBZUUQDEFVCVDUUOYHUUCELZUVFUVGUUOYHUUMUVJUVGUUBUUMUUEVEZUUFDUUCEFVF
      SZUUCDEFVCSUUSUUTDVIVGUUOYLUUSJYLUUTJZUVCUUOYLYJUUCRZEUUCQVJZUURKZUUSUUOU
      VPUUCRZUVPYLUVPUUCVKUUOYLUVNUVQUUOUUAYLUUCJYLUVNJYTUUAUUNVLUUOUUTUUCYLUUO
      YHUVJUUTUUCLZUVGUVLUUCDEFVMSZUUOUUFUUTLZUVMUUOUUMUVTUVKUUOYHUUFELUVJUUMUV
      TTUVGUUOYLEUUBUUHUUNUULUPVNUVLUUFDUUCEFVOVGVPYLUUTBVQVRVSZWAYLYJUUCVTWBUU
      OUVNUUDVHKKZUVNUVQUUOUVNUUDJZUWBUVNOZUUOYKUUEUWCAYKUUAUUNWCUUBUUMUUEWDYJD
      UUCWESUUOUUDUAJZUVNUUDULZLUWCUWDTUUOYHUUCWKJUWEUVGCVQUUCDWKWFVDUUOUUCUVNU
      WFYJUUCWLZUUOYHUVJUUCUWFOUVGUVLUUCDEFWGSWHUVNUUDUWFUWFWIWJSVPUUOYHUVJUVNU
      UCLZUWBUVQOUVGUVLUWHUUOUWGYCUVNDUUDEUUCFUUDWIWMVGWNWOWPUUOUVOUUQUURUUOUVO
      UVNEVJZUUPQZUUQUVOUWIUUCUVNQZQUWJUVNEUUCWQUWKUUPUWIUWKUUCUUCYJRZQUUPUVNUW
      LUUCYJUUCWRWSUUCYJWTXBWSXBUUOUWIEUUPUUOUVNELUWIEOUUOUVNUUCEUWGUVLXAUVNEXC
      XDXEXFXGWOUWAYLUUSUUTVTWBUUOUVAUUSUUCRZYJUUOUVRUVAUWMLUVSUUTUUCUUSXHPUUOU
      USUUPRXIOZUWMYJLUUOUWNUUSUUQLZUUOYHUVHUWOUVGUVIUUQDEFVMVDZUUOUUSELUWNUWOT
      UUOUUSEUUPUWPXJUUSUUPEXKPXLUUSUUCYJXMVSXNYPUVCUVDNIUVADYMUVAOYNUVCYOUVDYM
      UVAYLXOYMUVAYJXPXQXRXSXTYAYBAYHYSYRTGBIYJDYDPYEYFDYGWB $.
  $}

  ${
    $d j k n s u v w A $.  $d j k n s u v w F $.  $d f j k n s u v w x y J $.
    $d j k n s u w ph $.
    $( A compact space is compactly generated.  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    cmpkgen $p |- ( J e. Comp -> J e. ran kGen ) $=
      ( vx vk ccmp wcel cuni eqid cmptop cv wa csn cnei cfv crest wrex ctop wss
      co syl wceq adantr topopn simpr snssd opnneiss syl3anc restid simpl oveq2
      eqeltrd eleq1d rspcev syl2anc llycmpkgen2 ) ADEZBCAAFZUPGZAHZUOBIZUPEZJZU
      PUSKZALMMZEZAUPNRZDEZACIZNRZDEZCVCOVAAPEZUPAEZVBUPQVDUOVJUTURUAZVAVJVKVLA
      UPUQUBSVAUSUPUOUTUCUDVBAUPUEUFVAVEADVAVJVEATVLAPUPUQUGSUOUTUHUJVIVFCUPVCV
      GUPTVHVEDVGUPANUIUKULUMUN $.

    $( A locally compact space is compactly generated.  (Contributed by Mario
       Carneiro, 21-Mar-2015.) $)
    llycmpkgen $p |- ( J e. N-Locally Comp -> J e. ran kGen ) $=
      ( vx vk ccmp cnlly wcel cuni eqid nllytop cv wa wss crest co csn cnei cfv
      wrex syl simpr simpl ctop topopn adantr nllyi syl3anc reximi llycmpkgen2
      ) ADEFZBCAAGZUJHZDAIZUIBJZUJFZKZCJZUJLZAUPMNDFZKZCUMOAPQQZRZURCUTRUOUIUJA
      FZUNVAUIUNUAUIVBUNUIAUBFVBULAUJUKUCSUDUIUNTCDUMUJAUEUFUSURCUTUQURTUGSUH
      $.

    ${
      1stckgen.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
      1stckgen.2 $e |- ( ph -> F : NN --> X ) $.
      1stckgen.3 $e |- ( ph -> F ( ~~>t ` J ) A ) $.
      $( The one-point compactification of ` NN ` is compact.  (Contributed by
         Mario Carneiro, 21-Mar-2015.) $)
      1stckgenlem $p |- ( ph -> ( J |`t ( ran F u. { A } ) ) e. Comp ) $=
        ( vu vn wcel cv cuni wss cfn wa cfv syl2anc syl cn vv vw vk crn csn cun
        vj vs crest co ccmp cpw cin wrex wi wral simprr ssun2 wb ctopon clm wbr
        lmcl snssg mpbiri adantr sseldd eluni2 sylib cuz c1 nnuz cz 1z ad2antrr
        a1i simplrl elpwid simprl lmcvg cima imassrn ssun1 sstri id syl5ss ctop
        cfz wf frn resttopon topontop cres wfo fzfid wfun cdm ffun elfznn ssriv
        wceq fdm syl5sseqr fofi pwfi restsspw ssfi sylancl elin sylanbrc fincmp
        fores toponuni sseqtrd eqid cmpsub mpbid syl5 impr inss1 sseldi simprll
        r19.21bi snssd unssd elpw2 sylibr inss2 snfi unfi ad3antrrr sylan elun2
        vex wfn anassrs ad2antlr nnz ralrimiva rexlimddv simprrr eleq1d rspccva
        ffn fveq2 adantlr elnnuz anbi1i elfzuzb bitr4i funimass4 sylan2b uztric
        elun1 syl2an mpjaodan fnfvrnss uniun unisn uneq2i eqtri syl6sseqr unieq
        wo sseq2d rspcev expr mpbird ) ADCUDZBUEZUFZUIUJUKKZUVKILZMZNZUVKUALZMZ
        NZUAUVMULZOUMZUNZUOZIDULZUPZAUWBIUWCAUVMUWCKZUVOUWAAUWEUVOPZPZBUBLZKZUW
        AUBUVMUWGBUVNKUWIUBUVMUNUWGUVKUVNBAUWEUVOUQABUVKKZUWFAUWJUVJUVKNZUVJUVI
        URABEKZUWJUWKUSADEUTQKZCBDVAQVBZUWLFHBCDEVCRZBUVKEVDSVEVFVGUBBUVMVHVIUW
        GUWHUVMKZUWIPZPZUCLZCQZUWHKZUCUGLZVJQZUPZUWAUGTUWRBUWHUGUCCDVKTVLUWGUWP
        UWIUQVKVMKUWRVNVPAUWNUWFUWQHVOUWRUVMDUWHUWRUVMDAUWEUVOUWQVQVRUWGUWPUWIV
        SVGVTUWGUWQUXBTKZUXDPZUWAUWGUWQUXFPZPZCVKUXBWHUJZWAZUHLZMZNZUWAUHUVTUWG
        UXMUHUVTUNZUXGAUWEUVOUXNUVOUXJUVNNZAUWEPUXNUVOUXJUVKUVNUXJUVIUVKCUXIWBZ
        UVIUVJWCWDUVOWEWFAUXOUXNUOZIUWCADUXJUIUJZUKKZUXQIUWCUPZAUXRWGOUMKZUXSAU
        XRWGKZUXROKZUYAAUXRUXJUTQKZUYBAUWMUXJENUYDFAUXJUVIEUXPATECWIZUVIENGTECW
        JSZWFZUXJDEWKRUXJUXRWLSAUXJULZOKZUXRUYHNUYCAUXJOKZUYIAUXIOKUXIUXJCUXIWM
        ZWNZUYJAVKUXBWOACWPZUXICWQZNZUYLAUYEUYMGTECWRSZATUXIUYNJUXITJLZUXBWSWTA
        UYEUYNTXAGTECXBSXCZUXICXLRUXIUXJUYKXDRUXJXEVIUXJDXFUYHUXRXGXHUXRWGOXIXJ
        UXRXKSADWGKZUXJDMZNUXSUXTUSAUWMUYSFEDWLSZAUXJEUYTUYGAUWMEUYTXAFEDXMSZXN
        UXJDUYTIUHUYTXOZXPRXQYCXRXSVFUXHUXKUVTKZUXMPZPZUXKUWHUEZUFZUVTKZUVKVUHM
        ZNZUWAVUFVUHUVSKZVUHOKZVUIVUFVUHUVMNVULVUFUXKVUGUVMVUFUXKUVMVUFUVTUVSUX
        KUVSOXTUXHVUDUXMVSZYAVRVUFUWHUVMUXHUWPVUEUWGUWPUWIUXFYBVFYDYEVUHUVMIYNY
        FYGVUFUXKOKVUGOKVUMVUFUVTOUXKUVSOYHVUNYAUWHYIUXKVUGYJXHVUHUVSOXIXJVUFUV
        KUXLUWHUFZVUJVUFUVIUVJVUOVUFCTYOZUYQCQZVUOKZJTUPUVIVUONAVUPUWFUXGVUEAUY
        EVUPGTECUUDSYKVUFVURJTVUFUYQTKZPUYQUXCKZVURUXBUYQVJQKZVUFVUTVURVUSVUFVU
        TPVUQUWHKZVURVUFUXDVUTVVBUXHUXDVUEUWGUWQUXEUXDUUAVFUXAVVBUCUYQUXCUWSUYQ
        XAUWTVUQUWHUWSUYQCUUEUUBUUCYLVUQUWHUXLYMSUUFVUFVUSVVAVURVUSVVAPZVUFUYQU
        XIKZVURVVCUYQVKVJQKZVVAPVVDVUSVVEVVAUYQUUGUUHUYQVKUXBUUIUUJVUFVVDPVUQUX
        LKZVURVUFVVFJUXIVUFUXMVVFJUXIUPZUXHVUDUXMUQAUXMVVGUSZUWFUXGVUEAUYMUYOVV
        HUYPUYRJUXIUXLCUUKRYKXQYCVUQUXLUWHUUNSUULYPVUFUXEVUSVUTVVAUVDZUXGUXEUWG
        VUEUWQUXEUXDVSYQUXEUXBVMKUYQVMKVVIVUSUXBYRUYQYRUXBUYQUUMUUOYLUUPYSJTVUO
        CUUQRVUFBVUOUXGBVUOKZUWGVUEUWIVVJUWPUXFBUWHUXLYMYQYQYDYEVUJUXLVUGMZUFVU
        OUXKVUGUURVVKUWHUXLUWHUBYNUUSUUTUVAUVBUVRVUKUAVUHUVTUVPVUHXAUVQVUJUVKUV
        PVUHUVCUVEUVFRYTYPYTYTUVGYSAUYSUVKUYTNUVLUWDUSVUAAUVKEUYTAUVIUVJEUYFABE
        UWOYDYEVUBXNUVKDUYTIUAVUCXPRUVH $.
    $}

    $( A first-countable space is compactly generated.  (Contributed by Mario
       Carneiro, 21-Mar-2015.) $)
    1stckgen $p |- ( J e. 1stc -> J e. ran kGen ) $=
      ( vy vf wcel cfv wss cv wa cuni cdif cn wf wb adantr sylib syl2anc c1 cvv
      eqid sylancl vx vk c1stc ctop ckgen crn 1stctop ccl clm wbr wex 1stcelcls
      ccld difss mpan2 ctopon toptopon simprr lmcl csn cun crest nnuz rnex snex
      co vex unex resttop cz 1z a1i ssun2 snss mpbir wfn ffn ad2antrl dffn3 fss
      ssun1 lmss mpbid ffvelrnda simprl eldifbd eldifd cin difin wceq frn snssd
      difss2d unssd restuni difeq1d syl5eqr incom ccmp simplr 1stckgenlem kgeni
      syl5eqel opncld eqeltrd lmcld exlimdv sylbid iscld4 mpbird elssuni adantl
      ex ssrdv kgenuni syl sseqtr4d isopn2 iskgen2 sylanbrc ) AUCDZAUDDZAUEEZAF
      AUEUFDAUGZYAUAYCAYAUAGZYCDZYEADZYAYFHZYGAIZYEJZAUMEDZYHYKYJAUHEEZYJFZYHBY
      LYJYHBGZYLDZKYJCGZLZYPYNAUIEUJZHZCUKZYNYJDZYAYOYTMZYFYAYJYIFZUUBYIYEUNZYN
      YJCAYIYISZULUONYHYSUUACYHYSUUAYHYSHZYNYIYEUUFAYIUPEDZYRYNYIDUUFYBUUGYHYBY
      SYAYBYFYDNZNZAYIUUEUQOZYHYQYRURZYNYPAYIUSPZUUFYNYPUFZYNUTZVAZYEUUFYNUUOYE
      JZUBYPAUUOVBVFZQUUQIZKVCUUFUUQUDDZUUQUURUPEDUUFYBUUORDZUUSUUIUUMUUNYPCVGV
      DYNVEVHZUUOARVITZUUQUURUURSZUQOQVJDUUFVKVLZUUFYRYPYNUUQUIEUJUUKUUFYNYPAUU
      QQRUUOKUUQSVCUUTUUFUVAVLUUIYNUUODZUUFUVEUUNUUOFUUNUUMVMYNUUOBVGVNVOVLUVDU
      UFKUUMYPLZUUMUUOFKUUOYPLUUFYPKVPZUVFYQUVGYHYRKYJYPVQVRKYPVSOUUMUUNWAKUUMU
      UOYPVTTZWBWCUUFUBGZKDHZUVIYPEZUUOYEUUFKUUOUVIYPUVHWDUVJUVKYIYEUUFKYJUVIYP
      YHYQYRWEZWDWFWGUUFUUPUURUUOYEWHZJZUUQUMEZUUFUUPUUOUVMJUVNUUOYEWIUUFUUOUUR
      UVMUUFYBUUOYIFUUOUURWJUUIUUFUUMUUNYIUUFUUMYIYEYQUUMYJFYHYRKYJYPWKVRWMUUFY
      NYIUULWLWNUUOAYIUUEWOPWPWQUUFUUSUVMUUQDUVNUVODUVBUUFUVMYEUUOWHZUUQUUOYEWR
      UUFYFUUQWSDUVPUUQDYAYFYSWTUUFYNYPAYIUUJUUFYQUUCKYIYPLUVLUUDKYJYIYPVTTUUKX
      AYEAUUOXBPXCUVMUUQUURUVCXDPXEXFWFWGXMXGXHXNYHYBUUCYKYMMUUHUUDYJAYIUUEXITX
      JYHYBYEYIFYGYKMUUHYHYEYCIZYIYFYEUVQFYAYEYCXKXLYHYBYIUVQWJUUHAYIUUEXOXPXQY
      EAYIUUEXRPXJXMXNAXSXT $.
  $}

  ${
    $d g k x z F $.  $d g k x z J $.  $d g k x z K $.  $d g k x z X $.
    $d g k x z Y $.
    $( The compact generator preserves the subset (fineness) relationship on
       topologies.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    kgen2ss $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` X ) /\ J C_ K ) ->
      ( kGen ` J ) C_ ( kGen ` K ) ) $=
      ( vx vk ctopon cfv wcel wss ckgen cv crest co ccmp wi wa resttopon syl2an
      wral syl w3a cin cuni simp1 elpwi wceq simp2 toponuni fveq2d eleqtrd ctop
      cpw simpl2 topontop simpl3 ssrest syl2anc eqid sscmp 3com23 sseld imim12d
      3expia ralimdva anim2d wb elkgen 3ad2ant1 3ad2ant2 3imtr4d ssrdv ) ACFGZH
      ZBVLHZABIZUAZDAJGZBJGZVPDKZCIZAEKZLMZNHZVSWAUBZWBHZOZECULZSZPZVTBWALMZNHZ
      WDWJHZOZEWGSZPZVSVQHZVSVRHZVPWHWNVTVPWFWMEWGVPWAWGHZPZWKWCWEWLWSWBWJUCZFG
      ZHZWBWJIZWKWCOWSWBWAFGZXAVPVMWACIZWBXDHWRVMVNVOUDWACUEZWAACQRWSWAWTFWSWJX
      DHZWAWTUFVPVNXEXGWRVMVNVOUGXFWABCQRWAWJUHTUIUJWSBUKHZVOXCWSVNXHVMVNVOWRUM
      CBUNTVMVNVOWRUOWAABUKUPUQZXBXCWKWCXBWKXCWCWBWJWTWTURUSUTVCUQWSWBWJWDXIVAV
      BVDVEVMVNWPWIVFVOVSEACVGVHVNVMWQWOVFVOVSEBCVGVIVJVK $.

    $( A function from a compactly generated space is continuous iff it is
       continuous "on compacta".  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    kgencn $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( ( kGen ` J ) Cn K ) <->
        ( F : X --> Y /\ A. k e. ~P X ( ( J |`t k ) e. Comp ->
          ( F |` k ) e. ( ( J |`t k ) Cn K ) ) ) ) ) $=
      ( vx ctopon cfv wcel wa ccn co wf ccnv cv cima wral wi wb ckgen ccmp cres
      crest cpw kgentopon iscn cin wss elkgen ad2antrr cdm cnvimass wceq adantl
      sylan fdm syl5sseq biantrurd bitr4d ralbidv simpll elpwi resttopon syl2an
      simpllr syl2anc simpr fssres eleq1i ralbii syl6bb imbi2d r19.21v ralbidva
      cnvresima syl6bbr ralcom syl6rbbr bitrd pm5.32da ) CEHIZJZDFHIJZKZBCUAIZD
      LMJZEFBNZBOGPZQZWFJZGDRZKZWHCAPZUDMZUBJZBWNUCZWODLMJZSZAEUEZRZKWCWFWBJWDW
      GWMTCEUFGBWFDEFUGUPWEWHWLXAWEWHKZWLWPWJWNUHZWOJZSZAWTRZGDRZXAXBWKXFGDXBWK
      WJEUIZXFKZXFWCWKXITWDWHWJACEUJUKXBXHXFXBBULZWJEBWIUMWHXJEUNWEEFBUQUOURUSU
      TVAXBXAXEGDRZAWTRXGXBWSXKAWTXBWNWTJZKZWSWPXDGDRZSXKXMWRXNWPXMWRWQOWIQZWOJ
      ZGDRZXNXMWRWNFWQNZXQKZXQXMWOWNHIJZWDWRXSTXBWCWNEUIZXTXLWCWDWHVBWNEVCZWNCE
      VDVEWCWDWHXLVFGWQWODWNFUGVGXMXRXQXBWHYAXRXLWEWHVHYBEFWNBVIVEUSUTXPXDGDXOX
      CWOWNWIBVPVJVKVLVMWPXDGDVNVQVOXEGADWTVRVSVTWAVT $.

    $( A function ` F : J --> K ` from a compactly generated space is
       continuous iff for all compact spaces ` z ` and continuous
       ` g : z --> J ` , the composite ` F o. g : z --> K ` is continuous.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    kgencn2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( ( kGen ` J ) Cn K ) <-> ( F : X --> Y /\
        A. z e. Comp A. g e. ( z Cn J ) ( F o. g ) e. ( z Cn K ) ) ) ) $=
      ( vk cfv wcel wa ccn co ccmp cres wi wral wss wceq syl ctopon ckgen wf cv
      crest cpw ccom kgencn crn rncmp adantl cuni simprr eqid cnf 3syl toponuni
      frn ad3antrrr sseqtr4d vex rnex sylibr oveq2 eleq1d reseq2 oveq1d eleq12d
      elpw imbi12d rspcv mpid wb simplll ssid a1i cnrest2 syl3anc mpbid cnco ex
      cores ax-mp eleq1i syl6ib ralrimdvva oveq1 eleq2d raleqbidv elpwi resabs1
      syld cid idcn sseqtrd cnrest syl2anc eqeltrrd coeq2 syl9r com23 ralrimdva
      coires1 impbid pm5.32da bitrd ) DFUAIJZEGUAIJZKZCDUBIELMJFGCUCZDHUDZUEMZN
      JZCXKOZXLELMZJZPZHFUFZQZKXJCBUDZUGZAUDZELMZJZBYBDLMZQZANQZKHCDEFGUHXIXJXS
      YGXIXJKZXSYGYHXSYDABNYEYHYBNJZXTYEJZKZKZXSCXTUIZOZDYMUEMZELMZJZYDYLXSYONJ
      ZYQYKYRYHXTYBDUJUKYLYMXRJZXSYRYQPZPYLYMFRZYSYLYMDULZFYLYJYBULZUUBXTUCYMUU
      BRYHYIYJUMZXTYBDUUCUUBUUCUNUUBUNZUOUUCUUBXTURUPXGFUUBSZXHXJYKFDUQZUSUTZYM
      FXTBVAVBVIVCXQYTHYMXRXKYMSZXMYRXPYQUUIXLYONXKYMDUEVDZVEUUIXNYNXOYPXKYMCVF
      UUIXLYOELUUJVGVHVJVKTVLYLYQYNXTUGZYCJZYDYLXTYBYOLMJZYQUULPYLYJUUMUUDYLXGY
      MYMRZUUAYJUUMVMXGXHXJYKVNUUNYLYMVOZVPUUHYMXTYBDFVQVRVSUUMYQUULXTYNYBYOEVT
      WATUUKYAYCUUNUUKYASUUOCXTYMWBWCWDWEWLWFYHYGXQHXRYHXKXRJZKZXMYGXPXMYGYAXOJ
      ZBXLDLMZQZUUQXPYFUUTAXLNYBXLSZYDUURBYEUUSYBXLDLWGUVAYCXOYAYBXLELWGWHWIVKU
      UQUUTCWMXKOZUGZXOJZXPUUQUVBUUSJUUTUVDPUUQWMFOZXKOZUVBUUSUUQXKFRZUVFUVBSUU
      PUVGYHXKFWJUKZWMXKFWKTUUQUVEDDLMJZXKUUBRUVFUUSJXGUVIXHXJUUPDFWNUSUUQXKFUU
      BUVHXGUUFXHXJUUPUUGUSWOXKUVEDDUUBUUEWPWQWRUURUVDBUVBUUSXTUVBSYAUVCXOXTUVB
      CWSVEVKTUVCXNXOCXKXCWDWEWTXAXBXDXEXF $.
  $}

  ${
    $d f x y J $.  $d f x y K $.
    $( The set of continuous functions from ` J ` to ` K ` is unaffected by
       k-ification of ` K ` , if ` J ` is already compactly generated.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    kgencn3 $p |- ( ( J e. ran kGen /\ K e. Top ) ->
      ( J Cn K ) = ( J Cn ( kGen ` K ) ) ) $=
      ( vx vy ckgen crn wcel wa ccn co cfv cv cuni cima eqid wss cin wceq sylib
      syl2anc vf ctop wf ccnv wral cnf adantl crest wi cpw cdm cnvimass fdm syl
      ccmp adantr syl5sseq cres cnvresima wfun ad2antrr ffun inpreima 3syl in32
      ineq1d ssrin ax-mp dminss sstri a1i df-ss syl5eq eqtrd simpr elpwi cnrest
      ad2antrl ctopon wb ad3antrrr toptopon df-ima eqimss2i imassrn frn cnrest2
      syl5ss syl3anc mpbid simplr simprr kgeni cnima eqeltrrd ralrimiva kgentop
      imacmp expr elkgen mpbir2and kgenidm eleqtrd kgentopon sylbi syl2an ssrdv
      iscn ex toponcom kgenss cnss2 eqssd ) AEFGZBUBGZHZABIJZABEKZIJZXPUAXQXSXP
      UALZXQGZXTXSGZXPYAHZYBAMZBMZXTUCZXTUDZCLZNZAGZCXRUEZYAYFXPXTABYDYEYDOZYEO
      ZUFUGZYCYJCXRYCYHXRGZHZYIAEKZAYPYIYQGZYIYDPZADLZUHJZUOGZYIYTQZUUAGZUIZDYD
      UJZUEZYPXTUKZYIYDXTYHULZYCUUHYDRZYOYCYFUUJYNYDYEXTUMUNUPUQYPUUEDUUFYPYTUU
      FGZUUBUUDYPUUKUUBHZHZXTYTURZUDYHXTYTNZQZNZUUCUUAUUMUUQYGUUPNZYTQZUUCYTUUP
      XTUSUUMUUSYIYGUUONZQZYTQZUUCUUMUURUVAYTUUMYFXTUTUURUVARYCYFYOUULYNVAZYDYE
      XTVBYHUUOXTVCVDVFUUMUVBUUCUUTQZUUCYIUUTYTVEUUMUUCUUTPZUVDUUCRUVEUUMUUCUUH
      YTQZUUTYIUUHPUUCUVFPUUIYIUUHYTVGVHYTXTVIVJVKUUCUUTVLSVMVNVMUUMUUNUUABUUOU
      HJZIJGZUUPUVGGZUUQUUAGUUMUUNUUABIJGZUVHUUMYAYTYDPZUVJYCYAYOUULXPYAVOVAZUU
      KUVKYPUUBYTYDVPVRYTXTABYDYLVQTUUMBYEVSKZGZUUNFZUUOPZUUOYEPUVJUVHVTUUMXOUV
      NXPXOYAYOUULXNXOVOZWABYEYMWBZSUVPUUMUUOUVOXTYTWCWDVKUUMUUOXTFZYEXTYTWEUUM
      YFUVSYEPUVCYDYEXTWFUNWHUUOUUNUUABYEWGWIWJUUMYOUVGUOGZUVIYCYOUULWKUUMYAUUB
      UVTUVLYPUUKUUBWLYTXTABWRTYHBUUOWMTUUPUUNUUAUVGWNTWOWSWPYPAYDVSKGZYRYSUUGH
      VTYPAUBGZUWAXNUWBXOYAYOAWQZWAAYDYLWBZSYIDAYDWTUNXAXNYQARXOYAYOAXBWAXCWPXP
      YBYFYKHVTZYAXNUWAXRUVMGZUWEXOXNUWBUWAUWCUWDSXOUVNUWFUVRBYEXDXEZCXTAXRYDYE
      XHXFUPXAXIXGXPBXRMZVSKGZBXRPZXSXQPXPXOUWFUWIUVQXOUWFXNUWGUGBXRXJTXOUWJXNB
      XKUGAXRBUWHUWHOXLTXM $.

    $( A continuous function is also continuous with the domain and codomain
       replaced by their compact generator topologies.  (Contributed by Mario
       Carneiro, 21-Mar-2015.) $)
    kgen2cn $p |- ( F e. ( J Cn K ) ->
      F e. ( ( kGen ` J ) Cn ( kGen ` K ) ) ) $=
      ( ccn wcel ckgen cfv cuni ctopon wss ctop cntop1 toptopon sylib kgentopon
      co eqid syl kgenss syl2anc cnss1 crn wceq wfn wf kgenf ffn ax-mp fnfvelrn
      sylancr cntop2 kgencn3 sseqtrd id sseldd ) ABCDPZEZUPBFGZCFGDPZAUQUPURCDP
      ZUSUQURBHZIGZEZBURJZUPUTJUQBVBEZVCUQBKEZVEABCLZBVAVAQZMNBVAORUQVFVDVGBSRB
      URCVAVHUATUQURFUBEZCKEUTUSUCUQFKUDZVFVIKKFUEVJUFKKFUGUHVGKBFUIUJABCUKURCU
      LTUMUQUNUO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Product topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c tX $.
  $c ^ko $.

  $( Extend class notation with the binary topological product operation. $)
  ctx $a class tX $.

  $( Extend class notation with a function whose value is the compact-open
     topology. $)
  cxko $a class ^ko $.

  ${
    $d f k r s v x y $.
    $( Define the binary topological product, which is homeomorphic to the
       general topological product over a two element set, but is more
       convenient to use.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    df-tx $a |- tX = ( r e. _V , s e. _V |->
             ( topGen ` ran ( x e. r , y e. s |-> ( x X. y ) ) ) ) $.

    $( Define the compact-open topology, which is the natural topology on the
       set of continuous functions between two topological spaces.
       (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    df-xko $a |- ^ko = ( s e. Top , r e. Top |-> ( topGen ` ( fi `
       ran ( k e. { x e. ~P U. r | ( r |`t x ) e. Comp } , v e. s |->
         { f e. ( r Cn s ) | ( f " k ) C_ v } ) ) ) ) $.
  $}

  ${
    $d a b c d p r s t u v x y z R $.  $d a b c d p r s t u v x y z S $.
    $d a b c d p r s t u v w z B $.  $d w x y z X $.  $d w x y z Y $.
    txval.1 $e |- B = ran ( x e. R , y e. S |-> ( x X. y ) ) $.
    $( Value of the binary topological product operation.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 30-Aug-2015.) $)
    txval $p |- ( ( R e. V /\ S e. W ) -> ( R tX S ) = ( topGen ` B ) ) $=
      ( vr vs wcel cvv ctx ctg cfv wceq elex cv cmpt2 crn co cxp mpt2eq12 rneqd
      wa syl6eqr fveq2d df-tx fvex ovmpt2a syl2an ) DFKDLKELKDEMUACNOZPEGKDFQEG
      QIJDELLABIRZJRZARBRUBZSZTZNOULMUMDPUNEPUEZUQCNURUQABDEUOSZTCURUPUSABUMUND
      EUOUCUDHUFUGABJIUHCNUIUJUK $.

    ${
      txuni2.1 $e |- X = U. R $.
      txuni2.2 $e |- Y = U. S $.
      $( The underlying set of the product of two topologies.  (Contributed by
         Mario Carneiro, 31-Aug-2015.) $)
      txuni2 $p |- ( X X. Y ) = U. B $=
        ( vz vr vs cxp cv wcel wa wrex wss wceq vw cuni relxp cop eleq2i eluni2
        bitri anbi12i opelxp reeanv 3bitr4i eqid xpeq1 eqeq2d xpeq2 rspc2ev vex
        mp3an3 xpex eqeq1 2rexbidv cmpt2 crn cab rnmpt2 eqtri elab2 elssuni syl
        sylibr sseld syl5bir rexlimivv sylbi relssi cpw syl6sseqr xpss12 syl2an
        wf wral elpw rgen2 fmpt2 mpbi frn ax-mp eqsstri sspwuni eqssi ) FGNZCUB
        ZKUAWKWLFGUCKOZUAOZUDZWKPZWMLOZPZWNMOZPZQZMERLDRZWOWLPZWMFPZWNGPZQWRLDR
        ZWTMERZQWPXBXDXFXEXGXDWMDUBZPXFFXHWMIUELWMDUFUGXEWNEUBZPXGGXIWNJUEMWNEU
        FUGUHWMWNFGUIWRWTLMDEUJUKXAXCLMDEXAWOWQWSNZPWQDPZWSEPZQZXCWMWNWQWSUIXMX
        JWLWOXMXJCPZXJWLSXMXJAOZBOZNZTZBERADRZXNXKXLXJXJTZXSXJULXRXTXJWQXPNZTAB
        WQWSDEXOWQTXQYAXJXOWQXPUMUNXPWSTYAXJXJXPWSWQUOUNUPURWMXQTZBERADRZXSKXJC
        WQWSLUQMUQUSWMXJTYBXRABDEWMXJXQUTVACABDEXQVBZVCZYCKVDHABKDEXQYDYDULZVEV
        FVGVJXJCVHVIVKVLVMVNVOCWKVPZSWLWKSCYEYGHDENZYGYDVTZYEYGSXQYGPZBEWAADWAY
        IYJABDEXODPZXPEPZQXQWKSZYJYKXOFSXPGSYMYLYKXOXHFXODVHIVQYLXPXIGXPEVHJVQX
        OFXPGVRVSXQWKXOXPAUQBUQUSWBVJWCABDEXQYGYDYFWDWEYHYGYDWFWGWHCWKWIWEWJ $.
    $}

    $( The basis for the product topology is a set.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    txbasex $p |- ( ( R e. V /\ S e. W ) -> B e. _V ) $=
      ( wcel wa cuni cvv cxp eqid txuni2 uniexg xpexg syl2an syl5eqelr uniexb
      sylibr ) DFIZEGIZJZCKZLICLIUDUEDKZEKZMZLABCDEUFUGHUFNUGNOUBUFLIUGLIUHLIUC
      DFPEGPUFUGLLQRSCTUA $.

    $( The set of Cartesian products of elements from two topological bases is
       a basis.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 31-Aug-2015.) $)
    txbas $p |- ( ( R e. TopBases /\ S e. TopBases ) -> B e. TopBases ) $=
      ( vt vu vv va vb vc vd vz wcel wa cv wrex wral cxp ctb cin wss wceq cmpt2
      vp crn cab xpeq1 xpeq2 cbvmpt2v rnmpt2 eqtri abeq2i anbi12i reeanv bitr4i
      basis2 exp43 imp42 opelxpi xpss12 anim12i reximi sylbir syl2an ralrimivva
      an4s eleq1 anbi1d 2rexbidv ralxp sylibr anassrs ineq12 inxp syl6eq sseq2d
      cop anbi2d rexbidv c1st cfv c2nd rexeqi cvv wb fvex xpex rgenw vex op1std
      cmpt op2ndd xpeq12d mpt2mpt eqcomi eleq2 sseq1 anbi12d ax-mp eleq2d rexxp
      rexrnmpt sseq1d 3bitri syl6bb raleqbidv syl5ibrcom syl5bir syl5bi txbasex
      rexlimdvva ralrimivv isbasis2g syl mpbird ) DUAOZEUAOZPZCUAOZUFQZGQZOZYCH
      QZIQZUBZUCZPZGCRZUFYGSZICSHCSZXTYKHICCYECOZYFCOZPZYEJQZKQZTZUDZKERZYFLQZM
      QZTZUDZMERZPZLDRJDRZXTYKYOYTJDRZUUELDRZPUUGYMUUHYNUUIUUHHCCABDEAQZBQZTZUE
      ZUGZUUHHUHFJKHDEYRUUMABJKDEUULYRYPUUKTUUJYPUUKUIUUKYQYPUJUKULUMUNUUIICCUU
      NUUIIUHFLMIDEUUCUUMABLMDEUULUUCUUAUUKTUUJUUAUUKUIUUKUUBUUAUJUKULUMUNUOYTU
      UEJLDDUPUQXTUUFYKJLDDUUFYSUUDPZMERKERXTYPDOZUUADOZPZPZYKYSUUDKMEEUPUUSUUO
      YKKMEEUUSYQEOZUUBEOZPZPYKUUOYBUULOZUULYPUUAUBZYQUUBUBZTZUCZPZBERADRZUFUVF
      SZXTUURUVBUVJXRUURXSUVBUVJXRUURPZXSUVBPZPZYEYFVSZUULOZUVGPZBERZADRZIUVESH
      UVDSUVJUVMUVRHIUVDUVEUVKYEUVDOZUVLYFUVEOZUVRUVKUVSPYEUUJOZUUJUVDUCZPZADRZ
      YFUUKOZUUKUVEUCZPZBERZUVRUVLUVTPXRUUPUUQUVSUWDXRUUPUUQUVSUWDAYEDYPUUAURUS
      UTXSUUTUVAUVTUWHXSUUTUVAUVTUWHBYFEYQUUBURUSUTUWDUWHPUWCUWGPZBERZADRUVRUWC
      UWGABDEUPUWJUVQADUWIUVPBEUWAUWEUWBUWFUVPUWAUWEPUVOUWBUWFPUVGYEYFUUJUUKVAU
      UJUVDUUKUVEVBVCVHVDVDVEVFVHVGUVIUVRUFHIUVDUVEYBUVNUDZUVHUVPABDEUWKUVCUVOU
      VGYBUVNUULVIVJVKVLVMVHVNUUOYJUVIUFYGUVFUUOYGYRUUCUBUVFYEYRYFUUCVOYPYQUUAU
      UBVPVQZUUOYJYDYCUVFUCZPZGCRZUVIUUOYIUWNGCUUOYHUWMYDUUOYGUVFYCUWLVRVTWAUWO
      UWNGUUNRZYBNQZWBWCZUWQWDWCZTZOZUWTUVFUCZPZNDETZRZUVIUWNGCUUNFWEUWTWFOZNUX
      DSUWPUXEWGUXFNUXDUWRUWSUWQWBWHUWQWDWHWIWJUWNUXCNGUXDUWTUUMWFNUXDUWTWMUUMA
      BNDEUWTUULUWQUUJUUKVSUDZUWRUUJUWSUUKUUJUUKUWQAWKZBWKZWLUUJUUKUWQUXHUXIWNW
      OZWPWQYCUWTUDYDUXAUWMUXBYCUWTYBWRYCUWTUVFWSWTXDXAUXCUVHNABDEUXGUXAUVCUXBU
      VGUXGUWTUULYBUXJXBUXGUWTUULUVFUXJXEWTXCXFXGXHXIXMXJXMXKXNXTCWFOYAYLWGABCD
      EUAUAFXLHIUFGCWFXOXPXQ $.
  $}

  ${
    $d p x y z J $.  $d p x y z K $.  $d p x y z S $.
    $( A set in a product is open iff each point is surrounded by an open
       rectangle.  (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    eltx $p |- ( ( J e. V /\ K e. W ) -> ( S e. ( J tX K ) <-> A. p e. S
          E. x e. J E. y e. K ( p e. ( x X. y ) /\ ( x X. y ) C_ S ) ) ) $=
      ( vz wcel wa ctx cv wss wrex wral eqid cvv wb vex cxp cmpt2 crn ctg txval
      co cfv eleq2d txbasex eltg2b syl xpex rgen2w wceq eleq2 anbi12d rexrnmpt2
      sseq1 ax-mp ralbii syl6bb bitrd ) DFJEGJKZCDELUFZJCABDEAMZBMZUAZUBZUCZUDU
      GZJZHMZVGJZVGCNZKZBEOADOZHCPZVCVDVJCABVIDEFGVIQZUEUHVCVKVLIMZJZVSCNZKZIVI
      OZHCPZVQVCVIRJVKWDSABVIDEFGVRUIHICVIRUJUKWCVPHCVGRJZBEPADPWCVPSWEABDEVEVF
      ATBTULUMWBVOABIDEVGVHRVHQVSVGUNVTVMWAVNVSVGVLUOVSVGCURUPUQUSUTVAVB $.
  $}

  ${
    $d R u v z $.  $d S u v z $.  $d T u v z $.
    $( The product of two topologies is a topology.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    txtop $p |- ( ( R e. Top /\ S e. Top ) -> ( R tX S ) e. Top ) $=
      ( vu vv ctop wcel wa ctx co cv cxp cmpt2 crn ctg cfv eqid txval ctb txbas
      topbas syl2an tgcl syl eqeltrd ) AEFZBEFZGZABHICDABCJDJKLMZNOZECDUHABEEUH
      PZQUGUHRFZUIEFUEARFBRFUKUFATBTCDUHABUJSUAUHUBUCUD $.
  $}

  ${
    $d f g x y z A $.  $d f B $.  $d f g x y z F $.  $d f g x y z V $.
    ptval.1 $e |- B = { x | E. g ( ( g Fn A /\ A. y e. A ( g ` y ) e. ( F ` y )
    /\ E. z e. Fin A. y e. ( A \ z ) ( g ` y ) = U. ( F ` y ) ) /\
      x = X_ y e. A ( g ` y ) ) } $.
    $( The value of the product topology function.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    ptval $p |- ( ( A e. V /\ F Fn A ) -> ( Xt_ ` F ) = ( topGen ` B ) ) $=
      ( vf wcel wfn wa cv cfv wral wceq cfn ctg cvv cdm cuni cdif wrex w3a cixp
      wex cab cpt cmpt df-pt a1i simpr dmeqd fndm ad2antlr fneq2d fveq1d eleq2d
      raleqbidv difeq1d unieqd eqeq2d rexbidv 3anbi123d ixpeq1d anbi12d syl6eqr
      eqtrd exbidv abbidv fveq2d fnex ancoms fvex fvmptd ) DHKZGDLZMZJGFNZJNZUA
      ZLZBNZVTOZWDWAOZKZBWBPZWEWFUBZQZBWBCNZUCZPZCRUDZUEZANZBWBWEUFZQZMZFUGZAUH
      ZSOZESOZTUITUIJTXBUJQVSABCJFUKULVSWAGQZMZXAESXEXAVTDLZWEWDGOZKZBDPZWEXGUB
      ZQZBDWKUCZPZCRUDZUEZWPBDWEUFZQZMZFUGZAUHEXEWTXSAXEWSXRFXEWOXOWRXQXEWCXFWH
      XIWNXNXEWBDVTXEWBGUAZDXEWAGVSXDUMZUNVRXTDQVQXDDGUOUPVIZUQXEWGXHBWBDYBXEWF
      XGWEXEWDWAGYAURZUSUTXEWMXMCRXEWJXKBWLXLXEWBDWKYBVAXEWIXJWEXEWFXGYCVBVCUTV
      DVEXEWQXPWPXEBWBDWEYBVFVCVGVJVKIVHVLVRVQGTKDHGVMVNXCTKVSESVOULVP $.
  $}

  ${
    $d k w z A $.  $d k w z F $.  $d k w z I $.  $d k w z U $.  $d k w z V $.
    $d w z X $.
    ptpjpre1.1 $e |- X = X_ k e. A U. ( F ` k ) $.
    $( The preimage of a projection function can be expressed as an indexed
       cartesian product.  (Contributed by Mario Carneiro, 6-Feb-2015.) $)
    ptpjpre1 $p |- ( ( ( A e. V /\ F : A --> Top ) /\
      ( I e. A /\ U e. ( F ` I ) ) ) -> ( `' ( w e. X |-> ( w ` I ) ) " U ) =
        X_ k e. A if ( k = I , U , U. ( F ` k ) ) ) $=
      ( vz wcel wa cfv cv wfn wral elixp fveq2 bitri syl5ibrcom ctop wf cmpt wb
      ccnv cima wceq cuni cif cixp simplrl simprbi eleq2s adantl unieqd eleq12d
      vex rspcv sylc eqid fmptd elpreima 3syl fveq1 fvmpt eleq1d pm5.32i eleq2i
      ffn fvex anbi1i anass simprl iftrue wn simprr iffalse eleq2d pm2.61d expr
      ralimdv expimpd ancomsd wss elssuni ad2antll ssid syl6eqss pm2.61d1 sseld
      sseq12d wi ad2antrl jcad impbid anbi2d syl5bb bitrd syl6bbr eqrdv ) BGKBU
      AEUBLZFBKZCFEMZKZLLZJAHFANZMZUCZUECUFZDBDNZFUGZCXJEMZUHZUIZUJZXEJNZXIKZXP
      BOZXJXPMZXNKZDBPZLZXPXOKXEXQXPHKZXPXHMZCKZLZYBXEHXCUHZXHUBXHHOXQYFUDXEAHX
      GYGXHXEXFHKZLXBXJXFMZXMKZDBPZXGYGKZXAXBXDYHUKYHYKXEYKXFDBXMUJZHXFYMKXFBOY
      KDBXMXFAUQQULIUMUNYJYLDFBXKYIXGXMYGXJFXFRXKXLXCXJFERUOZUPURUSXHUTZVAHYGXH
      VIHXPCXHVBVCYFXRXSXMKZDBPZFXPMZCKZLZLZXEYBYFYCYSLZUUAYCYEYSYCYDYRCAXPXGYR
      HXHFXFXPVDYOFXPVJVEVFVGUUBXRYQLZYSLUUAYCUUCYSYCXPYMKUUCHYMXPIVHDBXMXPJUQZ
      QSVKXRYQYSVLSSXEYTYAXRXEYTYAXEYSYQYAXEYSYQYAXEYSLYPXTDBXEYSYPXTXEYSYPLLZX
      KXTUUEXTXKYSXEYSYPVMXKXSYRXNCXJFXPRXKCXMVNZUPZTUUEXTXKVOZYPXEYSYPVPUUHXNX
      MXSXKCXMVQZVRTVSVTWAWBWCXEYAYQYSXEXTYPDBXEXNXMXSXEXKXNXMWDZXEUUJXKCYGWDZX
      DUUKXAXBCXCWEWFXKXNCXMYGUUFYNWKTUUHXNXMXMUUIXMWGWHWIWJWAXBYAYSWLXAXDXTYSD
      FBUUGURWMWNWOWPWQWRDBXNXPUUDQWSWT $.
  $}

  ${
    $d a b c d k n s u v B $.  $d g h w x y G $.  $d g n w x y I $.  $d k ph $.
    $d a b c d g h k m n s u v w x y z A $.  $d g n w x y U $.  $d a b g x Y $.
    $d a b c d g h k m n s u v w x y z F $.  $d a b g h k m s u w x z X $.
    $d g h x S $.  $d a b c d g h k m n s u v w x y z V $.  $d k w y W $.
    ptbas.1 $e |- B = { x | E. g ( ( g Fn A /\ A. y e. A ( g ` y ) e. ( F ` y )
    /\ E. z e. Fin A. y e. ( A \ z ) ( g ` y ) = U. ( F ` y ) ) /\
      x = X_ y e. A ( g ` y ) ) } $.
    $( Elementhood in the bases of a product topology.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    elpt $p |- ( S e. B <-> E. h ( ( h Fn A /\ A. y e. A ( h ` y ) e. ( F ` y )
    /\ E. w e. Fin A. y e. ( A \ w ) ( h ` y ) = U. ( F ` y ) ) /\
      S = X_ y e. A ( h ` y ) ) ) $=
      ( wcel cv cfv wral wceq cfn wrex wa cvv wfn cuni cdif w3a cixp wex eleq2i
      cab simpr ixpexg fvex a1i mprg syl6eqel exlimiv eqeq1 anbi2d exbidv elab3
      fneq1 fveq1 eleq1d ralbidv eqeq1d difeq2 raleqdv cbvrexv syl6bb 3anbi123d
      rexralbidv ixpeq2dv eqeq2d anbi12d cbvexv 3bitri ) GFLGHMZEUAZBMZVPNZVRJN
      ZLZBEOZVSVTUBZPZBECMZUCZOCQRZUDZAMZBEVSUEZPZSZHUFZAUHZLWHGWJPZSZHUFZIMZEU
      AZVRWRNZVTLZBEOZWTWCPZBEDMZUCZOZDQRZUDZGBEWTUEZPZSZIUFFWNGKUGWMWQAGWPGTLH
      WPGWJTWHWOUIVSTLZWJTLBEBEVSTUJXLVRELVRVPUKULUMUNUOWIGPZWLWPHXMWKWOWHWIGWJ
      UPUQURUSWPXKHIVPWRPZWHXHWOXJXNVQWSWBXBWGXGEVPWRUTXNWAXABEXNVSWTVTVRVPWRVA
      ZVBVCXNWGXCBWFOZCQRXGXNWDXCCBQWFXNVSWTWCXOVDVJXPXFCDQWEXDPXCBWFXEWEXDEVEV
      FVGVHVIXNWJXIGXNBEVSWTXOVKVLVMVNVO $.

    $( A basic open set in the product topology.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    elptr $p |- ( ( A e. V /\ ( G Fn A /\ A. y e. A ( G ` y ) e. ( F ` y ) )
    /\ ( W e. Fin /\ A. y e. ( A \ W ) ( G ` y ) = U. ( F ` y ) ) ) ->
      X_ y e. A ( G ` y ) e. B ) $=
      ( vh vw wcel cv cfv wral wa cfn wceq wfn cuni cdif w3a wrex wex cvv simp1
      cixp simp2l fnex syl2anc simp2r difeq2 raleqdv rspcev 3ad2ant3 3jca fveq1
      eqcomd ixpeq2dv biantrud fneq1 eleq1d ralbidv eqeq1d rexralbidv 3anbi123d
      bitr3d spcegv sylc elpt sylibr ) DINZHDUAZBOZHPZVPGPZNZBDQZRZJSNVQVRUBZTZ
      BDJUCZQZRZUDZLOZDUAZVPWHPZVRNZBDQZWJWBTZBDMOZUCZQMSUEZUDZBDVQUIZBDWJUITZR
      ZLUFZWRENWGHUGNZVOVTWCBWOQZMSUEZUDZXAWGVOVNXBVNVOVTWFUJZVNWAWFUHDIHUKULWG
      VOVTXDXFVNVOVTWFUMWFVNXDWAXCWEMJSWNJTWCBWOWDWNJDUNUOUPUQURWTXELHUGWHHTZWQ
      WTXEXGWSWQXGBDVQWJXGWJVQVPWHHUSZUTVAVBXGWIVOWLVTWPXDDWHHVCXGWKVSBDXGWJVQV
      RXHVDVEXGWMWCMBSWOXGWJVQWBXHVFVGVHVIVJVKABCMDEWRFLGKVLVM $.

    ${
      $d y S $.
      elptr2.1 $e |- ( ph -> A e. V ) $.
      elptr2.2 $e |- ( ph -> W e. Fin ) $.
      elptr2.3 $e |- ( ( ph /\ k e. A ) -> S e. ( F ` k ) ) $.
      elptr2.4 $e |- ( ( ph /\ k e. ( A \ W ) ) -> S = U. ( F ` k ) ) $.
      $( A basic open set in the product topology.  (Contributed by Mario
         Carneiro, 3-Feb-2015.) $)
      elptr2 $p |- ( ph -> X_ k e. A S e. B ) $=
        ( cfv wcel wral cv cmpt cixp nffvmpt1 nfcv fveq2 cbvixp wceq simpr eqid
        wa fvmpt2 syl2anc ixpeq2dva syl5eq wfn cfn cuni ralrimiva fnmpt eqeltrd
        cdif syl nfel1 eleq12d cbvral sylibr eldifi sylan2 eqtrd unieqd eqeq12d
        nfv nfeq1 elptr syl122anc eqeltrrd ) ACECUAZIEGUBZRZUCZIEGUCZFAWAIEIUAZ
        VSRZUCWBCIEVTWDIEGVRUDZCWDUEVRWCVSUFZUGAIEWDGAWCESZUKZWGGWCJRZSZWDGUHZA
        WGUIPIEGWIVSVSUJZULUMZUNUOAEKSVSEUPZVTVRJRZSZCETZLUQSVTWOURZUHZCELVBZTZ
        WAFSNAWJIETWNAWJIEPUSIEGVSWIWLUTVCAWDWISZIETWQAXBIEWHWDGWIWMPVAUSWPXBCI
        EIVTWOWEVDXBCVMVRWCUHZVTWDWOWIWFVRWCJUFZVEVFVGOAWDWIURZUHZIWTTXAAXFIWTA
        WCWTSZUKWDGXEXGAWGWKWCELVHWMVIQVJUSWSXFCIWTIVTWRWEVNXFCVMXCVTWDWRXEWFXC
        WOWIXDVKVLVFVGBCDEFHJVSKLMVOVPVQ $.
    $}

    $( The base set of the product topology is a basic open set.  (Contributed
       by Mario Carneiro, 3-Feb-2015.) $)
    ptbasid $p |- ( ( A e. V /\ F : A --> Top ) ->
      X_ k e. A U. ( F ` k ) e. B ) $=
      ( wcel ctop wf wa cv cfv cuni c0 simpl cfn a1i ffvelrn adantll topopn syl
      0fin eqid cdif eqidd elptr2 ) DIKZDLHMZNZABCDEGOZHPZQZFGHIRJUKULSRTKUMUFU
      AUMUNDKZNUOLKZUPUOKULUQURUKDLUNHUBUCUOUPUPUGUDUEUMUNDRUHKNUPUIUJ $.

    $( The base set for the product topology.  (Contributed by Mario Carneiro,
       3-Feb-2015.) $)
    ptuni2 $p |- ( ( A e. V /\ F : A --> Top ) ->
      X_ k e. A U. ( F ` k ) = U. B ) $=
      ( wcel wa cv cfv cuni cixp wss elssuni wral wceq ctop ptbasid syl cpw wfn
      cdif cfn wrex w3a wex cab simpr2 ralimi ss2ixp 3syl fveq2 unieqd syl6sseq
      cbvixpv vex elpw sseq1 syl5bb syl5ibrcom expimpd exlimdv syl5eqss sspwuni
      wf abssdv sylib eqssd ) DIKDUAHVILZGDGMZHNZOZPZEOZVMVQEKVQVRQABCDEFGHIJUB
      VQERUCVMEVQUDZQVRVQQVMEFMZDUEZBMZVTNZWBHNZKZBDSZWCWDOZTBDCMUFSCUGUHZUIZAM
      ZBDWCPZTZLZFUJZAUKVSJVMWNAVSVMWMWJVSKZFVMWIWLWOVMWILZWOWLWKVQQZWPWKBDWGPZ
      VQWPWFWCWGQZBDSWKWRQVMWAWFWHULWEWSBDWCWDRUMBDWCWGUNUOBGDWGVPWBVNTWDVOWBVN
      HUPUQUSURWOWJVQQWLWQWJVQAUTVAWJWKVQVBVCVDVEVFVJVGEVQVHVKVL $.

    $( The basis for a product topology is closed under intersections.
       (Contributed by Mario Carneiro, 3-Feb-2015.) $)
    ptbasin $p |- ( ( ( A e. V /\ F : A --> Top ) /\ ( X e. B /\ Y e. B ) ) ->
      ( X i^i Y ) e. B ) $=
      ( va vc vb vd wcel wa cv wceq cfn vk ctop cin wfn cfv wral cuni cdif wrex
      wf w3a cixp wex anbi12i eeanv bitr4i an4 an6 df-3an bitri wi reeanv fveq2
      elpt ineq12d cbvixpv cun simpl1l ad2antrl simpl1r simpl3l eleq12d rspccva
      ffvelrnda sylan simpl3r inopn syl3anc simprrl wss ssun1 sscon ax-mp sseli
      unfi unieqd eqeq12d syl2an simprrr ssun2 inidm syl6eq syl5eqel rexlimdvva
      elptr2 expr syl5bir 3expb sylan2b ineq12 ixpin syl6eqr syl5ibrcom expimpd
      impr eleq1d syl5bi exlimdvv imp ) DHPZDUBGUJZQZIEPZJEPZQZIJUCZEPZXOLRZDUD
      ZBRZXRUEZXTGUEZPZBDUFZYAYBUGZSZBDMRZUHZUFZMTUIZUKZIBDYAULZSZQZNRZDUDZXTYO
      UEZYBPZBDUFZYQYESZBDORZUHZUFZOTUIZUKZJBDYQULZSZQZQZNUMLUMZXLXQXOYNLUMZUUH
      NUMZQUUJXMUUKXNUULABCMDEIFLGKVDABCODEJFNGKVDUNYNUUHLNUOUPXLUUIXQLNUUIYKUU
      EQZYMUUGQZQXLXQYKYMUUEUUGUQXLUUMUUNXQXLUUMQXQUUNBDYAYQUCZULZEPZUUMXLXSYPQ
      ZYDYSQZQZYJUUDQZQZUUQUUMUURUUSUVAUKUVBXSYDYJYPYSUUDURUURUUSUVAUSUTXLUUTUV
      AUUQXLUURUUSUVAUUQVAUVAYIUUCQZOTUIMTUIXLUURUUSUKZUUQYIUUCMOTTVBUVDUVCUUQM
      OTTUVDYGTPUUATPQZUVCUUQUVDUVEUVCQZQZUUPUADUARZXRUEZUVHYOUEZUCZULEBUADUUOU
      VKXTUVHSZYAUVIYQUVJXTUVHXRVCZXTUVHYOVCZVEVFUVGABCDEUVKFUAGHYGUUAVGZKXJXKU
      URUUSUVFVHUVEUVOTPUVDUVCYGUUAWEVIUVGUVHDPZQUVHGUEZUBPUVIUVQPZUVJUVQPZUVKU
      VQPUVGDUBUVHGXJXKUURUUSUVFVJVNUVGYDUVPUVRYDYSXLUURUVFVKYCUVRBUVHDUVLYAUVI
      YBUVQUVMXTUVHGVCZVLVMVOUVGYSUVPUVSYDYSXLUURUVFVPYRUVSBUVHDUVLYQUVJYBUVQUV
      NUVTVLVMVOUVIUVJUVQVQVRUVGUVHDUVOUHZPZQZUVKUVQUGZUWDUCUWDUWCUVIUWDUVJUWDU
      VGYIUVHYHPUVIUWDSZUWBUVDUVEYIUUCVSUWAYHUVHYGUVOVTUWAYHVTYGUUAWAYGUVODWBWC
      WDYFUWEBUVHYHUVLYAUVIYEUWDUVMUVLYBUVQUVTWFZWGVMWHUVGUUCUVHUUBPUVJUWDSZUWB
      UVDUVEYIUUCWIUWAUUBUVHUUAUVOVTUWAUUBVTUUAYGWJUUAUVODWBWCWDYTUWGBUVHUUBUVL
      YQUVJYEUWDUVNUWFWGVMWHVEUWDWKWLWOWMWPWNWQWRXEWSUUNXPUUPEUUNXPYLUUFUCUUPIY
      LJUUFWTBDYAYQXAXBXFXCXDXGXHXGXI $.

    $( The basis for a product topology is closed under intersections.
       (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    ptbasin2 $p |- ( ( A e. V /\ F : A --> Top ) -> ( fi ` B ) = B ) $=
      ( vu vv vk wcel ctop wf cv wral cfv cvv cuni wa cin ptbasin ralrimivva wb
      cfi wceq cixp ptuni2 ixpexg fvex uniex a1i syl6eqelr uniexb sylibr inficl
      mprg syl mpbid ) DHMDNGOUAZJPZKPZUBEMZKEQJEQZEUFREUGZVAVDJKEEABCDEFGHVBVC
      IUCUDVAESMZVEVFUEVAETZSMVGVAVHLDLPZGRZTZUHZSABCDEFLGHIUIVKSMZVLSMLDLDVKSU
      JVMVIDMVJVIGUKULUMURUNEUOUPJKESUQUSUT $.

    $( The basis for a product topology is a basis.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    ptbas $p |- ( ( A e. V /\ F : A --> Top ) -> B e. TopBases ) $=
      ( wcel ctop wf wa cfi cfv ctb ptbasin2 fibas syl6eqelr ) DHJDKGLMEENOPABC
      DEFGHIQERS $.

    ptbasfi.2 $e |- X = X_ n e. A U. ( F ` n ) $.
    $( The basis for a product topology is a basis.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    ptpjpre2 $p |- ( ( ( A e. V /\ F : A --> Top ) /\
      ( I e. A /\ U e. ( F ` I ) ) ) ->
      ( `' ( w e. X |-> ( w ` I ) ) " U ) e. B ) $=
      ( wcel ctop wa cfv cv wf cmpt ccnv cima wceq cuni cif ptpjpre1 csn simpll
      cixp cfn snfi a1i simprr ad2antrr simpr fveq2d eleqtrrd wn ffvelrnda eqid
      simplr topopn syl adantr ifclda cdif neneqd adantl iffalse elptr2 eqeltrd
      eldifsni ) ELPZEQJUAZRZKEPZGKJSZPZRZRZDMKDTSUBUCGUDIEITZKUEZGWCJSZUFZUGZU
      KFDEGIJKLMOUHWBABCEFWGHIJLKUIZNVOVPWAUJWHULPWBKUMUNWBWCEPZRZWDGWFWEWJWDRZ
      GVSWEWBVTWIWDVQVRVTUOUPWKWCKJWJWDUQURUSWJWFWEPZWDUTZWJWEQPWLWBEQWCJVOVPWA
      VCVAWEWFWFVBVDVEVFVGWBWCEWHVHPZRWMWGWFUEWNWMWBWNWCKWCEKVNVIVJWDGWFVKVEVLV
      M $.

    $( The basis for the product topology can also be written as the set of
       finite intersections of "cylinder sets", the preimages of projections
       into one factor from open sets in the factor.  (We have to add ` X `
       itself to the list because if ` A ` is empty we get
       ` ( fi `` (/) ) = (/) ` while ` B = { (/) } ` .)  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    ptbasfi $p |- ( ( A e. V /\ F : A --> Top ) -> B = ( fi ` ( { X } u. ran
   ( k e. A , u e. ( F ` k ) |-> ( `' ( w e. X |-> ( w ` k ) ) " u ) ) ) ) ) $=
      ( wcel wa wceq wss cvv vs vh vm ctop wf csn cv cfv cmpt ccnv cima crn cun
      cmpt2 cfi wfn wral cuni cdif cfn wrex w3a cixp wex elpt df-3an cin simprr
      ciin c0 difeq2 difin dif0 3eqtr3g raleqdv biimpac ixpeq2 syl fveq2 unieqd
      weq cbvixpv eqtri syl6eqr sylan iineq1 0iin syl6eq syl5sseqr adantl df-ss
      ssv sylib eqtr4d wne cif simplll inss1 simpr sseldi ad2antrr eleq12d sylc
      rspcv ptpjpre1 syl12anc adantlr iineq2dv cdm cnvimass sylancl iinss ax-mp
      eqid wi wn syl5ibrcom sylibr eqtrd adantr eqssd eleq1 sylanbrc pm2.61dane
      elssuni cint a1i syl5eq ctb cxp ciun eqeltrd ad3antrrr nfcv syl2anc snssd
      syl5eqel sspwuni unssd sseqtrd dmmptss sstri rgenw r19.2z syl6sseqr dfss1
      sseqtri ssralv iffalse sseq2d ssid iftrue pm2.61d2 ralrimivw ssiin sseq1d
      equcoms rspcev mpan2 ralimiaa eldifn ad2antlr inss2 iinconst eqtr2d eqeq1
      3syl mtod ralimdva mpan9 inundif raleqi ralunb bitr3i ixpiin 3eqtr4rd cab
      ixpexg fvex uniex mprg eqeltri mptex cnvex imaexg dfiin2 int0 ineq2d inv1
      inteq snex ptbas ptpjpre2 ralrimivva fmpt2x frn ssexd unexg sylancr ssfii
      ssun1 snss mpbir sseldd nfixp1 nfcxfr nfmpt nfcnv nfima nfmpt2 nfrn nfcri
      nfv cop co df-ov mpteq2dv cnveqd imaeq1d sylan9eq ovmpt2x syl3anc syl5eqr
      imaeq2 ffn opeliunxp xpeq12d cbviunv syl6eleq fnfvelrn eqeltrrd ex abssdv
      sneq rexlimd ssun2 syl6ss simplrl abrexfi elfir syl13anc fiuni cpw ptuni2
      ssfi eqimss2 sstrd eqtr3d rexlimdvaa sylan2b expimpd exlimdv syl5bi ssrdv
      pwid impr ptbasid fiss ptbasin2 ) FLPFUDKUEQZGMUFZIEFIUGZKUHZDMVVBDUGZUHZ
      UIZUJZEUGZUKZUNZULZUMZUOUHZVUTUAGVVMUAUGZGPUBUGZFUPZBUGZVVOUHZVVQKUHZPZBF
      UQZVVRVVSURZRZBFUCUGZUSZUQZUCUTVAZVBZVVNBFVVRVCZRZQZUBVDVUTVVNVVMPZABCUCF
      GVVNHUBKNVEVUTVWKVWLUBVUTVWHVWJVWLVUTVWHQVWLVWJVWIVVMPZVWHVUTVVPVWAQZVWGQ
      VWMVVPVWAVWGVFVUTVWNVWGVWMVUTVWNQZVWFVWMUCUTVWOVWDUTPZVWFQZQZVWIMJFVWDVGZ
      DMJUGZVVDUHZUIZUJZVWTVVOUHZUKZVIZVGZVVMVWRVWIVXGRVWSVJVWRVWSVJRZQZVWIMVXG
      VWRVWFVXHVWIMRVWOVWPVWFVHZVWFVXHQZVWIBFVWBVCZMVXKVWCBFUQZVWIVXLRVXHVWFVXM
      VXHVWCBVWEFVXHFVWSUSFVJUSVWEFVWSVJFVKFVWDVLFVMVNVOVPBFVVRVWBVQVRMJFVWTKUH
      ZURZVCZVXLOJBFVXOVWBJBWAZVXNVVSVWTVVQKVSVTWBWCZWDWEVXIMVXFSZVXGMRZVXHVXSV
      WRVXHTMVXFMWLVXHVXFJVJVXEVITJVWSVJVXEWFJVXEWGWHWIWJMVXFWKWMWNVWRVWSVJWOZQ
      ZVXFJVWSBFBJWAZVXDVWBWPZVCZVIZVXGVWIVYBJVWSVXEVYEVWRVWTVWSPZVXEVYERZVYAVW
      RVYGQZVUTVWTFPZVXDVXNPZVYHVUTVWNVWQVYGWQVYIVWSFVWTFVWDWRZVWRVYGWSWTZVYIVY
      JVWAVYKVYMVWOVWAVWQVYGVUTVVPVWAVHZXAVVTVYKBVWTFVYCVVRVXDVVSVXNVVQVWTVVOVS
      ZVVQVWTKVSXBXDXCZDFVXDBKVWTLMVXRXEXFXGXHVYBVXFMSZVXGVXFRZVYBVXFVXLMVYBVXE
      VXLSZJVWSVAZVXFVXLSVYBVYAVYSJVWSUQVYTVWRVYAWSVYSJVWSVXEMVXLVXEVXBXIMVXBVX
      DXJDMVXAVXBVXBXNUUAUUBVXRUUGUUCVYSJVWSUUDXKJVWSVXEVXLXLVRVXRUUEVXFMUUFZWM
      VYBVWIBFJVWSVYDVIZVCZVYFVYBVVRWUBRZBFUQZVWIWUCRVYBWUDBVWSUQZWUDBVWEUQZWUE
      VYBVWAVVTBVWSUQZWUFVWOVWAVWQVYAVYNXAVWSFSVWAWUHXOVYLVVTBVWSFUUHXMVVTWUDBV
      WSVVQVWSPZVVTQVVRWUBVVTVVRWUBSZWUIVVTVVRVYDSZJVWSUQWUJVVTWUKJVWSVVTVYCWUK
      VVTWUKVYCXPZVVRVWBSVVRVVSYEWULVYDVWBVVRVYCVXDVWBUUIZUUJXQVYCVVRVVRVYDVVRU
      UKZVYCVYDVXDVVRVYCVXDVWBUULZVYOWNWIUUMUUNJVWSVYDVVRUUOXRWJWUIWUBVVRSZVVTW
      UIVYDVVRSZJVWSVAZWUPWUIVVRVVRSZWURWUNWUQWUSJVVQVWSVXQVYDVVRVVRVXQVYDVXDVV
      RVYDVXDRBJWUOUUQVWTVVQVVOVSXSUUPUURUUSJVWSVYDVVRXLVRXTYAUUTUVGVWRVWFVYAWU
      GVXJVYAVWCWUDBVWEVYAVVQVWEPZQZWUDVWCVWBWUBRWVAWUBJVWSVWBVIZVWBWVAJVWSVYDV
      WBWVAVYGQZWULVYDVWBRWVCVYCVVQVWDPZWUTWVDXPVYAVYGVVQFVWDUVAUVBWVCWVDVYCVWT
      VWDPWVCVWSVWDVWTFVWDUVCZWVAVYGWSWTVVQVWTVWDYBXQUVHWUMVRXHVYAWVBVWBRWUTJVW
      SVWBUVDXTUVEVVRVWBWUBUVFXQUVIUVJWUEWUDBVWSVWEUMZUQWUFWUGQWUDBWVFFFVWDUVKU
      VLWUDBVWSVWEUVMUVNYCBFVVRWUBVQVRVYAWUCVYFRVWRBJFVWSVYDUVOWJXSUVPYDVWRVXGV
      VMPCUGZVXERZJVWSVAZCUVQZVJVWRWVJVJRZQVXGMVVMWVKVXTVWRWVKVXGMTVGMWVKVXFTMW
      VKVXFVJYFZTWVKVXFWVJYFZWVLJCVWSVXEVXCTPVXETPZVXBDMVXAMVXPTOVXOTPZVXPTPJFJ
      FVXOTUVRWVOVYJVXNVWTKUVSUVTYGUWAUWBZUWCUWDVXCVXDTUWEXMZUWFZWVJVJUWJYHUWGW
      HUWHMUWIWHWJVWRMVVMPWVKVWRVVLVVMMVUTVVLVVMSZVWNVWQVUTVVLTPZWVSVUTVVATPVVK
      TPWVTMUWKVUTVVKGYIABCFGHKLNUWLZVUTIFVVBUFZVVCYJZYKZGVVJUEZVVKGSVUTVVIGPZE
      VVCUQIFUQWWEVUTWWFIEFVVCABCDFGVVHHJKVVBLMNOUWMUWNIEFVVCVVIGVVJVVJXNZUWOWM
      ZWWDGVVJUWPVRZUWQVVAVVKTTUWRUWSZVVLTUWTVRXAMVVLPZVWRWWKVVAVVLSVVAVVKUXAMV
      VLWVPUXBUXCZYGUXDXTYLVWRWVJVJWOZQZVXGVXFVVMWWNVYQVYRWWNVXFVVMURZMWWNVXFVV
      MPVXFWWOSWWNVXFWVMVVMWVRWWNWVTWVJVVLSZWWMWVJUTPZWVMVVMPVUTWVTVWNVWQWWMWWJ
      YMVWRWWPWWMVWRWVJVVKVVLVWRWVICVVKVWRWVHWVGVVKPZJVWSVWRJUXMJCVVKJVVJIEJFVV
      CVVIJFYNJVVCYNJVVGVVHJVVFJDMVVEJMVXPOJFVXOUXEUXFJVVEYNUXGUXHJVVHYNUXIUXJU
      XKUXLVWRVYGWVHWWRXOVYIWWRWVHVXEVVKPVYIVWTVXDUXNZVVJUHZVXEVVKVYIWWTVWTVXDV
      VJUXOZVXEVWTVXDVVJUXPVYIVYJVYKWVNWXAVXERVYMVYPWVNVYIWVQYGIEVWTVXDFVVCVVIV
      XEVVJTVXNIJWAZVVHVXDRVVIVXCVVHUKVXEWXBVVGVXCVVHWXBVVFVXBWXBDMVVEVXAVVBVWT
      VVDVSUXQUXRUXSVVHVXDVXCUYDUXTVVBVWTKVSWWGUYAUYBUYCVYIVVJWWDUPZWWSWWDPWWTV
      VKPVYIWWEWXCVUTWWEVWNVWQVYGWWHYMWWDGVVJUYEVRVYIWWSJFVWTUFZVXNYJZYKZWWDVYI
      VYJVYKWWSWXFPVYMVYPJFVXNVXDUYFYCJIFWXEWWCJIWAWXDWWBVXNVVCVWTVVBUYNVWTVVBK
      VSUYGUYHUYIWWDWWSVVJUYJYOUYKWVGVXEVVKYBXQUYLUYOUYMVVKVVAUYPUYQXTVWRWWMWSW
      WNVWSUTPZWWQWWNVWPVWSVWDSWXGVWOVWPVWFWWMUYRWVEVWDVWSVUEXKJCVWSVXEUYSVRWVJ
      VVLTUYTVUAYQZVXFVVMYEVRVUTWWOMRVWNVWQWWMVUTVVLURZWWOMVUTWVTWXIWWORWWJVVLT
      VUBVRVUTWXIMVUTVVLMVUCZSWXIMSVUTVVAVVKWXJVUTMWXJMWXJPVUTMWVPVUOYGYPVUTVVK
      GWXJWWIVUTGURZMSZGWXJSVUTMWXKRWXLVUTMVXPWXKOABCFGHJKLNVUDYHWXKMVUFVRGMYRX
      RVUGYSVVLMYRWMMWXISZVUTWWKWXMWWLMVVLYEXMYGYAVUHYMYTWUAWMWXHYLYDYLVUIVUPVU
      JVVNVWIVVMYBXQVUKVULVUMVUNVUTVVMGUOUHZGVUTGYIPVVLGSVVMWXNSWWAVUTVVAVVKGVU
      TMGVUTMVXPGOABCFGHJKLNVUQYQYPWWIYSVVLGYIVURYOABCFGHKLNVUSYTYA $.
  $}

  ${
    $d g x y z A $.  $d g x y z F $.  $d g x y z V $.
    $( The product topology is a topology.  (Contributed by Mario Carneiro,
       3-Feb-2015.) $)
    pttop $p |- ( ( A e. V /\ F : A --> Top ) -> ( Xt_ ` F ) e. Top ) $=
      ( vg vy vz vx wcel ctop wf wa cpt cfv cv wfn wral cuni wceq cdif cfn wrex
      w3a cixp wex cab ctg ffn eqid ptval sylan2 ctb ptbas tgcl syl eqeltrd ) A
      CHZAIBJZKZBLMZDNZAOENZUTMZVABMZHEAPVBVCQREAFNSPFTUAUBGNEAVBUCRKDUDGUEZUFM
      ZIUQUPBAOUSVERAIBUGGEFAVDDBCVDUHZUIUJURVDUKHVEIHGEFAVDDBCVFULVDUMUNUO $.
  $}

  ${
    $d g k x y z A $.  $d g k x y z F $.  $d g x y S $.  $d g k x y z V $.
    $d k ph $.  $d k y W $.
    ptopn.1 $e |- ( ph -> A e. V ) $.
    ptopn.2 $e |- ( ph -> F : A --> Top ) $.
    ptopn.3 $e |- ( ph -> W e. Fin ) $.
    ptopn.4 $e |- ( ( ph /\ k e. A ) -> S e. ( F ` k ) ) $.
    ptopn.5 $e |- ( ( ph /\ k e. ( A \ W ) ) -> S = U. ( F ` k ) ) $.
    $( A basic open set in the product topology.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    ptopn $p |- ( ph -> X_ k e. A S e. ( Xt_ ` F ) ) $=
      ( vg vy vz vx cv cfv wcel wceq wfn wral cuni cdif cfn wrex w3a wa wex cab
      cixp cpt ctg ctb wss ctop eqid ptbas syl2anc bastg syl ffn ptval sseqtr4d
      wf elptr2 sseldd ) AMQZBUANQZVHRZVIERZSNBUBVJVKUCTNBOQUDUBOUEUFUGPQNBVJUK
      TUHMUIPUJZEULRZDBCUKAVLVLUMRZVMAVLUNSZVLVNUOABFSZBUPEVEZVOHIPNOBVLMEFVLUQ
      ZURUSVLUNUTVAAVPEBUAZVMVNTHAVQVSIBUPEVBVAPNOBVLMEFVRVCUSVDAPNOBVLCMDEFGVR
      HJKLVFVG $.
  $}

  ${
    $d ph k $.  $d A k $.  $d F k $.  $d V k $.  $d Y k $.
    ptopn2.a $e |- ( ph -> A e. V ) $.
    ptopn2.f $e |- ( ph -> F : A --> Top ) $.
    ptopn2.o $e |- ( ph -> O e. ( F ` Y ) ) $.
    $( A sub-basic open set in the product topology.  (Contributed by Stefan
       O'Rear, 22-Feb-2015.) $)
    ptopn2 $p |- ( ph ->
        X_ k e. A if ( k = Y , O , U. ( F ` k ) ) e. ( Xt_ ` F ) ) $=
      ( cv wceq cfv cuni cif csn wcel adantr ctop syl cfn snfi a1i fveq2 eleq2d
      wa syl5ibrcom imp wn ffvelrnda eqid topopn ifclda cdif eldifn elsn sylnib
      iffalse adantl ptopn ) ABCKZGLZEVADMZNZOZCDFGPZHIVFUAQAGUBUCAVABQZUFZVBEV
      DVCVHVBEVCQZVHVIVBEGDMZQZAVKVGJRVBVCVJEVAGDUDUEUGUHVHVDVCQZVBUIZVHVCSQVLA
      BSVADIUJVCVDVDUKULTRUMVABVFUNQZVEVDLZAVNVMVOVNVAVFQVBVABVFUOCGUPUQVBEVDUR
      TUSUT $.
  $}

  ${
    $d k s v K $.  $d f k r s v x R $.  $d f k r s v x S $.  $d r s T $.
    $d k x X $.
    xkoval.x $e |- X = U. R $.
    xkoval.k $e |- K = { x e. ~P X | ( R |`t x ) e. Comp } $.
    xkoval.t $e |- T = ( k e. K , v e. S |->
      { f e. ( R Cn S ) | ( f " k ) C_ v } ) $.
    $( Functionality of function ` T ` .  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    xkotf $p |- T : ( K X. S ) --> ~P ( R Cn S ) $=
      ( cv cima wss ccn co crab cpw wral wcel wf ssrab2 ovex elpw2 mpbir rgen2w
      cxp fmpt2 mpbi ) FMGMNBMOZFCDPQZRZULSZUAZBDTGHTHDUHUNEUBUOGBHDUOUMULOUKFU
      LUCUMULCDPUDUEUFUGGBHDUMUNELUIUJ $.

    $( Alternative expression for the subbase of the compact-open topology.
       (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    xkobval $p |- ran T = { s | E. k e. ~P X E. v e. S
      ( ( R |`t k ) e. Comp /\ s = { f e. ( R Cn S ) | ( f " k ) C_ v } ) } $=
      ( cv co crab wceq wrex crest ccmp crn cima wss ccn cab wcel wa cpw rnmpt2
      oveq2 eleq1d rexrab rexeqi r19.42v rexbii 3bitr4i abbii eqtri ) EUAJNFNGN
      ZUBBNUCFCDUDOPZQZBDRZGHRZJUECUSSOZTUFZVAUGBDRZGIUHZRZJUEGBJHDUTEMUIVCVHJV
      BGCANZSOZTUFZAVGPZRVEVBUGZGVGRVCVHVKVEVBGAVGVIUSQVJVDTVIUSCSUJUKULVBGHVLL
      UMVFVMGVGVEVABDUNUOUPUQUR $.

    $( Value of the compact-open topology.  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    xkoval $p |- ( ( R e. Top /\ S e. Top ) ->
      ( S ^ko R ) = ( topGen ` ( fi ` ran T ) ) ) $=
      ( ctop wcel co cfv ctg wceq cv crab vs vr cxko crn cfi ccmp cuni cpw cima
      crest wss ccn cmpt2 wa simpr unieqd syl6eqr pweqd oveq1d eleq1d rabeqbidv
      simpl oveq12d rabeq mpt2eq123dv rneqd fveq2d df-xko fvex ovmpt2a ancoms
      syl ) DMNCMNDCUCOEUDZUEPZQPZRUAUBDCMMGBUBSZASZUJOZUFNZAVPUGZUHZTZUASZFSGS
      UIBSUKZFVPWCULOZTZUMZUDZUEPZQPVOUCWCDRZVPCRZUNZWIVNQWLWHVMUEWLWGEWLWGGBHD
      WDFCDULOZTZUMEWLGBWBWCWFHDWNWLWBCVQUJOZUFNZAIUHZTHWLVSWPAWAWQWLVTIWLVTCUG
      IWLVPCWJWKUOZUPJUQURWLVRWOUFWLVPCVQUJWRUSUTVAKUQWJWKVBZWLWEWMRWFWNRWLVPCW
      CDULWRWSVCWDFWEWMVDVLVELUQVFVGVGABFGUAUBVHVNQVIVJVK $.
  $}

  ${
    $d f k v x y A $.  $d f k v x y R $.  $d f k v x y S $.  $d f k v y U $.
    $d k v x y X $.
    $( The compact-open topology is a topology.  (Contributed by Mario
       Carneiro, 19-Mar-2015.) $)
    xkotop $p |- ( ( R e. Top /\ S e. Top ) -> ( S ^ko R ) e. Top ) $=
      ( vk vv vx vf ctop wcel wa cxko co crest ccmp cuni cpw crab cima cfv eqid
      cv wss ccn cmpt2 crn cfi ctg xkoval ctb fibas tgcl ax-mp syl6eqel ) AGHBG
      HIBAJKCDAETLKMHEANZOPZBFTCTQDTUAFABUBKPUCZUDZUERZUFRZGEDABUOFCUNUMUMSUNSU
      OSUGUQUHHURGHUPUIUQUJUKUL $.

    xkoopn.x $e |- X = U. R $.
    xkoopn.r $e |- ( ph -> R e. Top ) $.
    xkoopn.s $e |- ( ph -> S e. Top ) $.
    xkoopn.a $e |- ( ph -> A C_ X ) $.
    xkoopn.c $e |- ( ph -> ( R |`t A ) e. Comp ) $.
    xkoopn.u $e |- ( ph -> U e. S ) $.
    $( A basic open set of the compact-open topology.  (Contributed by Mario
       Carneiro, 19-Mar-2015.) $)
    xkoopn $p |- ( ph ->
      { f e. ( R Cn S ) | ( f " A ) C_ U } e. ( S ^ko R ) ) $=
      ( vk vv vx cv wss wcel wceq vy cima ccn crab crest ccmp cpw cmpt2 crn cfi
      co cfv ctg cxko cvv ovex pwex cxp eqid xkotf ax-mp ssexi ssfii fvex bastg
      wf frn sstri wrex ctop wb topopn elpw2g 3syl mpbird oveq2 eleq1d sylanbrc
      elrab eqidd imaeq2 sseq1d rabbidv eqeq2d sseq2 rspc2ev rabex eqeq1 rnmpt2
      syl3anc 2rexbidv elab2 sylibr sseldi xkoval syl2anc eleqtrrd ) AFQZBUBZER
      ZFCDUCUKZUDZNOCPQZUEUKZUFSZPGUGZUDZDWRNQZUBZOQZRZFXAUDZUHZUIZUJULZUMULZDC
      UNUKZAXNXPXBXNXOXPXNUOSXNXORXNXAUGZXACDUCUPZUQXGDURZXRXMVFXNXRRPOCDXMFNXG
      GHXGUSZXMUSZUTXTXRXMVGVAVBXNUOVCVAXOUOSXOXPRXNUJVDXOUOVEVAVHAXBXLTZODVINX
      GVIZXBXNSABXGSZEDSXBXBTZYDABXFSZCBUEUKZUFSZYEAYGBGRZKACVJSZGCSYGYJVKICGHV
      LBGCVMVNVOLXEYIPBXFXCBTXDYHUFXCBCUEVPVQVSVRMAXBVTYCYFXBWSXJRZFXAUDZTNOBEX
      GDXHBTZXLYMXBYNXKYLFXAYNXIWSXJXHBWRWAWBWCWDXJETZYMXBXBYOYLWTFXAXJEWSWEWCW
      DWFWJUAQZXLTZODVINXGVIYDUAXBXNWTFXAXSWGYPXBTYQYCNOXGDYPXBXLWHWKNOUAXGDXLX
      MYBWIWLWMWNAYKDVJSXQXPTIJPOCDXMFNXGGHYAYBWOWPWQ $.
  $}

  ${
    txtopi.1 $e |- R e. Top $.
    txtopi.2 $e |- S e. Top $.
    $( The product of two topologies is a topology.  (Contributed by Jeff
       Madsen, 15-Jun-2010.) $)
    txtopi $p |- ( R tX S ) e. Top $=
      ( ctop wcel ctx co txtop mp2an ) AEFBEFABGHEFCDABIJ $.
  $}

  ${
    $d u v R $.  $d u v S $.
    $( The underlying set of the product of two topologies.  (Contributed by
       Mario Carneiro, 22-Aug-2015.)  (Revised by Mario Carneiro,
       2-Sep-2015.) $)
    txtopon $p |- ( ( R e. ( TopOn ` X ) /\ S e. ( TopOn ` Y ) ) ->
      ( R tX S ) e. ( TopOn ` ( X X. Y ) ) ) $=
      ( vu vv ctopon cfv wcel wa ctop cxp cuni wceq topontop syl2an cv toponuni
      eqid cvv ctx co txtop cmpt2 crn ctg txuni2 xpeq12 txbasex unitg syl txval
      3eqtr4a unieqd eqtr4d istopon sylanbrc ) ACGHZIZBDGHZIZJZABUAUBZKIZCDLZVC
      MZNVCVEGHIUSAKIBKIVDVACAODBOABUCPVBVEEFABEQFQLUDUEZUFHZMZVFVBAMZBMZLZVGMZ
      VEVIEFVGABVJVKVGSZVJSVKSUGUSCVJNDVKNVEVLNVACARDBRCVJDVKUHPVBVGTIVIVMNEFVG
      ABURUTVNUIVGTUJUKUMVBVCVHEFVGABURUTVNULUNUOVEVCUPUQ $.
  $}

  ${
    $d R u v x z $.  $d S u v x z $.  $d T u v x z $.  $d X u v x z $.
    $d Y u v x z $.
    txuni.1 $e |- X = U. R $.
    txuni.2 $e |- Y = U. S $.
    $( The underlying set of the product of two topologies.  (Contributed by
       Jeff Madsen, 2-Sep-2009.) $)
    txuni $p |- ( ( R e. Top /\ S e. Top ) -> ( X X. Y ) = U. ( R tX S ) ) $=
      ( ctop wcel wa ctx cxp ctopon cuni wceq toptopon txtopon syl2anb toponuni
      co cfv syl ) AGHZBGHZIABJSZCDKZLTHZUEUDMNUBACLTHBDLTHUFUCACEOBDFOABCDPQUE
      UDRUA $.
  $}

  ${
    txunii.1 $e |- R e. Top $.
    txunii.2 $e |- S e. Top $.
    txunii.3 $e |- X = U. R $.
    txunii.4 $e |- Y = U. S $.
    $( The underlying set of the product of two topologies.  (Contributed by
       Jeff Madsen, 15-Jun-2010.) $)
    txunii $p |- ( X X. Y ) = U. ( R tX S ) $=
      ( ctop wcel cxp ctx co cuni wceq txuni mp2an ) AIJBIJCDKABLMNOEFABCDGHPQ
      $.
  $}

  ${
    $d g k x y z A $.  $d g k x y z F $.  $d g k x y z V $.
    ptuni.1 $e |- J = ( Xt_ ` F ) $.
    $( The base set for the product topology.  (Contributed by Mario Carneiro,
       3-Feb-2015.) $)
    ptuni $p |- ( ( A e. V /\ F : A --> Top ) ->
      X_ x e. A U. ( F ` x ) = U. J ) $=
      ( vg vy vz vk wcel ctop wa cv wfn cfv wral cuni wceq cixp wf cdif cfn w3a
      wrex wex cab ctg ctb eqid ptbas unitg syl cpt sylan2 syl5eq unieqd ptuni2
      ffn ptval 3eqtr4rd ) BEKZBLCUAZMZGNZBOHNZVEPZVFCPZKHBQVGVHRSHBINUBQIUCUEU
      DJNHBVGTSMGUFJUGZUHPZRZVIRZDRABANCPRTVDVIUIKVKVLSJHIBVIGCEVIUJZUKVIUIULUM
      VDDVJVDDCUNPZVJFVCVBCBOVNVJSBLCUSJHIBVIGCEVMUTUOUPUQJHIBVIGACEVMURVA $.
  $}

  ${
    $d A x y z $.  $d K y z $.  $d V y $.
    ptunimpt.j $e |- J = ( Xt_ ` ( x e. A |-> K ) ) $.
    $( Base set of a product topology given by substitution.  (Contributed by
       Stefan O'Rear, 22-Feb-2015.) $)
    ptunimpt $p |- ( ( A e. V /\ A. x e. A K e. Top ) ->
        X_ x e. A U. K = U. J ) $=
      ( vy wcel ctop wral wa cuni cixp cv cmpt cfv wceq eqid fvmpt2 unieqd nfcv
      eqcomd ralimiaa adantl ixpeq2 nffvmpt1 nfuni fveq2 cbvixp syl6eqr wf fmpt
      syl ptuni sylan2b eqtrd ) BEHZDIHZABJZKZABDLZMZGBGNZABDOZPZLZMZCLZUTVBABA
      NZVDPZLZMZVGUTVAVKQZABJZVBVLQUSVNUQURVMABVIBHURKZDVJVOVJDABDIVDVDRZSUBTUC
      UDABVAVKUEUMGABVFVKAVEABDVCUFUGGVKUAVCVIQVEVJVCVIVDUHTUIUJUSUQBIVDUKVGVHQ
      ABIDVDVPULGBVDCEFUNUOUP $.

    $( The base set for the product topology.  (Contributed by Mario Carneiro,
       22-Aug-2015.) $)
    pttopon $p |- ( ( A e. V /\ A. x e. A K e. ( TopOn ` B ) ) ->
      J e. ( TopOn ` X_ x e. A B ) ) $=
      ( wcel ctopon cfv wral wa ctop cixp cuni wceq cmpt wf ralimi sylan2 sylib
      topontop eqid fmpt cpt pttop syl5eqel toponuni ixpeq2 syl adantl ptunimpt
      eqtrd istopon sylanbrc ) BFHZECIJHZABKZLZDMHZABCNZDOZPDVAIJHURUPBMABEQZRZ
      UTUREMHZABKZVDUQVEABCEUBSZABMEVCVCUCUDUAUPVDLDVCUEJMGBVCFUFUGTUSVAABEOZNZ
      VBURVAVIPZUPURCVHPZABKVJUQVKABCEUHSABCVHUIUJUKURUPVFVIVBPVGABDEFGULTUMVAD
      UNUO $.
  $}

  ${
    $d x A $.  $d x R $.  $d x V $.  $d x X $.
    ptuniconst.2 $e |- J = ( Xt_ ` ( A X. { R } ) ) $.
    $( The base set for a product topology when all factors are the same.
       (Contributed by Mario Carneiro, 22-Aug-2015.) $)
    pttoponconst $p |- ( ( A e. V /\ R e. ( TopOn ` X ) ) ->
        J e. ( TopOn ` ( X ^m A ) ) ) $=
      ( vx wcel ctopon cfv wa cixp cmap co wral id ralrimivw csn cpt sylan2 cxp
      cmpt fconstmpt fveq2i eqtri pttopon toponmax ixpconstg fveq2d eleqtrd
      wceq ) ADHZBEIJHZKZCGAELZIJZEAMNZIJUMULUMGAOCUPHUMUMGAUMPQGAECBDCABRUAZSJ
      GABUBZSJFURUSSGABUCUDUEUFTUNUOUQIUMULEBHUOUQUKEBUGGAEDBUHTUIUJ $.

    ptuniconst.1 $e |- X = U. R $.
    $( The base set for a product topology when all factors are the same.
       (Contributed by Mario Carneiro, 3-Feb-2015.) $)
    ptuniconst $p |- ( ( A e. V /\ R e. Top ) -> ( X ^m A ) = U. J ) $=
      ( wcel ctop wa cmap co ctopon cfv cuni wceq toptopon pttoponconst sylan2b
      toponuni syl ) ADHZBIHZJCEAKLZMNHZUDCOPUCUBBEMNHUEBEGQABCDEFRSUDCTUA $.
  $}

  ${
    $d f k v x R $.  $d f k v x S $.
    xkouni.1 $e |- J = ( S ^ko R ) $.
    $( The base set of the compact-open topology.  (Contributed by Mario
       Carneiro, 19-Mar-2015.) $)
    xkouni $p |- ( ( R e. Top /\ S e. Top ) -> ( R Cn S ) = U. J ) $=
      ( vf vk vv vx wcel co cuni wss cv c0 crab wceq a1i eqid cvv ax-mp ctop wa
      ccn cxko cima wral ima0 eqsstri ralrimiva rabid2 sylibr simpl simpr crest
      0ss csn ccmp rest0 adantr syl6eqel topopn adantl xkoopn eqeltrd syl6eleqr
      0cmp elssuni syl cpw cmpt2 crn cfi cfv ctg xkoval unieqd unieqi ovex pwex
      cxp xkotf frn ssexi fiuni fvex unitg eqtr4i 3eqtr4g sspwuni sylib eqsstrd
      wf eqssd ) AUAIZBUAIZUBZABUCJZCKZWPWQCIWQWRLWPWQBAUDJZCWPWQEMZNUEZBKZLZEW
      QOZWSWPXCEWQUFWQXDPWPXCEWQXCWPWTWQIUBXANXBWTUGXBUOUHQUIXCEWQUJUKWPNABXBEA
      KZXERZWNWOULWNWOUMNXELWPXEUOQWPANUNJZNUPZUQWNXGXHPWOAURUSVFUTWOXBBIWNBXBX
      BRVAVBVCVDDVEWQCVGVHWPWRFGAHMUNJUQIHXEVIOZBWTFMUEGMLEWQOVJZVKZKZWQWPWSKXK
      VLVMZVNVMZKZWRXLWPWSXNHGABXJEFXIXEXFXIRZXJRZVOVPCWSDVQXLXMKZXOXKSIXLXRPXK
      WQVIZWQABUCVRVSXIBVTZXSXJWLXKXSLZHGABXJEFXIXEXFXPXQWAXTXSXJWBTZWCXKSWDTXM
      SIXOXRPXKVLWEXMSWFTWGWHWPYAXLWQLYAWPYBQXKWQWIWJWKWM $.

    $( The base set of the compact-open topology.  (Contributed by Mario
       Carneiro, 22-Aug-2015.) $)
    xkotopon $p |- ( ( R e. Top /\ S e. Top ) ->
        J e. ( TopOn ` ( R Cn S ) ) ) $=
      ( ctop wcel wa ccn co cuni wceq ctopon cfv xkotop syl5eqel xkouni istopon
      cxko sylanbrc ) AEFBEFGZCEFABHIZCJKCUALMFTCBARIEDABNOABCDPUACQS $.
  $}

  ${
    $d g k n u w x y z A $.  $d g k n u w x y z F $.  $d g k n u w x y z V $.
    $d w X $.
    ptval2.1 $e |- J = ( Xt_ ` F ) $.
    ptval2.2 $e |- X = U. J $.
    ptval2.3 $e |- G =
      ( k e. A , u e. ( F ` k ) |-> ( `' ( w e. X |-> ( w ` k ) ) " u ) ) $.
    $( The value of the product topology function.  (Contributed by Mario
       Carneiro, 7-Feb-2015.) $)
    ptval2 $p |- ( ( A e. V /\ F : A --> Top ) -> J =
      ( topGen ` ( fi ` ( { X } u. ran G ) ) ) ) $=
      ( vg vy vz vx vn wcel cv cfv ctop wf wfn wral cuni wceq cdif cfn wrex w3a
      wa cixp wex cab ctg csn crn cun cfi ffn cpt eqid ptval syl5eq sylan2 cmpt
      ccnv cmpt2 ptbasfi ptuni syl6eqr sneqd 3ad2ant1 mpteq1d cnveqd mpt2eq3dva
      cima imaeq1d rneqd uneq12d fveq2d eqtrd ) CHRZCUAEUBZUKZGMSZCUCNSZWFTZWGE
      TZRNCUDWHWIUEUFNCOSUGUDOUHUIUJPSNCWHULUFUKMUMPUNZUOTZIUPZFUQZURZUSTZUOTWD
      WCECUCZGWKUFCUAEUTWCWPUKGEVATWKJPNOCWJMEHWJVBZVCVDVEWEWJWOUOWEWJQCQSETUEU
      LZUPZDBCDSZETZAWRWTASTZVFZVGZBSZVQZVHZUQZURZUSTWOPNOABCWJMDQEHWRWQWRVBVIW
      EXIWNUSWEWSWLXHWMWEWRIWEWRGUEIQCEGHJVJKVKZVLWEXGFWEXGDBCXAAIXBVFZVGZXEVQZ
      VHFWEDBCXAXFXMWEWTCRZXEXARZUJZXDXLXEXPXCXKXPAWRIXBWEXNWRIUFXOXJVMVNVOVRVP
      LVKVSVTWAWBWAWB $.
  $}

  ${
    $d R u v z $.  $d S u v z $.  $d T u v z $.  $d A u v z $.  $d B u v z $.
    $( The product of two open sets is open in the product topology.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    txopn $p |- ( ( ( R e. V /\ S e. W ) /\ ( A e. R /\ B e. S ) )
                                               -> ( A X. B ) e. ( R tX S ) ) $=
      ( vu vv wcel wa cxp cv cmpt2 cvv eqid syl adantr wceq wrex eqeq2d crn ctg
      cfv ctx co wss txbasex bastg xpeq1 xpeq2 mp3an3 wb xpexg elrnmpt2g mpbird
      rspc2ev adantl sseldd txval eleqtrrd ) CEIDFIJZACIZBDIZJZJZABKZGHCDGLZHLZ
      KZMZUAZUBUCZCDUDUEZVEVKVLVFVAVKVLUFZVDVAVKNIVNGHVKCDEFVKOZUGVKNUHPQVDVFVK
      IZVAVDVPVFVIRZHDSGCSZVBVCVFVFRZVRVFOVQVSVFAVHKZRGHABCDVGARVIVTVFVGAVHUITV
      HBRVTVFVFVHBAUJTUPUKVDVFNIVPVRULABCDUMGHCDVIVFVJNVJOUNPUOUQURVAVMVLRVDGHV
      KCDEFVOUSQUT $.
  $}

  $( The product of two closed sets is closed in the product topology.
     (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
     3-Sep-2015.) $)
  txcld $p |- ( ( A e. ( Clsd ` R ) /\ B e. ( Clsd ` S ) ) ->
      ( A X. B ) e. ( Clsd ` ( R tX S ) ) ) $=
    ( ccld cfv wcel wa cxp cuni wss cdif eqid cldss syl2an cldrcl adantr adantl
    ctop syl ctx co xpss12 txuni sseqtrd cun difxp difeq1d syl5eqr txtop cldopn
    wceq topopn txopn syl22anc unopn syl3anc eqeltrrd wb iscld mpbir2and ) ACEF
    GZBDEFGZHZABIZCDUAUBZEFGZVEVFJZKZVHVELZVFGZVDVECJZDJZIZVHVBAVLKBVMKVEVNKVCA
    CVLVLMZNBDVMVMMZNAVLBVMUCOVBCSGZDSGZVNVHULVCACPZBDPZCDVLVMVOVPUDOZUEVDVLALZ
    VMIZVLVMBLZIZUFZVJVFVDWFVNVELVJABVLVMUGVDVNVHVEWAUHUIVDVFSGZWCVFGZWEVFGZWFV
    FGVBVQVRWGVCVSVTCDUJOZVDVQVRWBCGZVMDGZWHVBVQVCVSQZVCVRVBVTRZVBWKVCACVLVOUKQ
    VDVRWLWNDVMVPUMTWBVMCDSSUNUOVDVQVRVLCGZWDDGZWIWMWNVDVQWOWMCVLVOUMTVCWPVBBDV
    MVPUKRVLWDCDSSUNUOWCWEVFUPUQURVDWGVGVIVKHUSWJVEVFVHVHMUTTVA $.

  ${
    $d r s u w x y z A $.  $d r s u w x y z B $.  $d r s u w x y z R $.
    $d r s u w x y z S $.  $d r s u w x y z X $.  $d r s u w x y z Y $.
    $( Closure of a rectangle in the product topology.  (Contributed by Mario
       Carneiro, 17-Sep-2015.) $)
    txcls $p |- ( ( ( R e. ( TopOn ` X ) /\ S e. ( TopOn ` Y ) ) /\
      ( A C_ X /\ B C_ Y ) ) -> ( ( cls ` ( R tX S ) ) ` ( A X. B ) ) =
        ( ( ( cls ` R ) ` A ) X. ( ( cls ` S ) ` B ) ) ) $=
      ( vu vz vr vs vw cfv wcel wa wss cxp ad2antrr wceq syl2anc cv ctopon ccld
      vx vy ctx co ccl ctop cuni topontop simprl toponuni sseqtrd eqid ad2antlr
      clscld simprr txcld sscls xpss12 clsss2 wrel relxp a1i cop opelxp cin wne
      c0 wi wral wrex wb eltx eleq1 anbi1d 2rexbidv rspccva wex simplrl simprll
      simprrl sylib simpld clsndisj syl32anc simplrr simprlr simprd eeanv inss1
      opelxpi inxp syl6eleqr sseldi simprrr sselda sylan2 inss2 adantl exlimdvv
      n0 inelcm ex syl5bir mp2and expr rexlimdvva exp3a sylbid ralrimiv txtopon
      syl5 clsss3 sseqtr4d adantrr adantrl eleqtrd elcls syl3anc mpbird relssdv
      syl syl5bi eqssd ) CEUALZMZDFUALZMZNZAEOZBFOZNZNZABPZCDUEUFZUGLLZACUGLLZB
      DUGLLZPZYNYTYPUBLMZYOYTOZYQYTOYNYRCUBLMZYSDUBLMZUUAYNCUHMZACUIZOZUUCYGUUE
      YIYMECUJQZYNAEUUFYJYKYLUKYGEUUFRYIYMECULQZUMZACUUFUUFUNZUPSYNDUHMZBDUIZOZ
      UUDYIUULYGYMFDUJUOZYNBFUUMYJYKYLUQYIFUUMRYGYMFDULUOZUMZBDUUMUUMUNZUPSYRYS
      CDURSYNAYROZBYSOZUUBYNUUEUUGUUSUUHUUJACUUFUUKUSSYNUULUUNUUTUUOUUQBDUUMUUR
      USSAYRBYSUTSYTYOYPYPUIZUVAUNZVASYNUCUDYTYQYTVBYNYRYSVCVDUCTZUDTZVEZYTMUVC
      YRMZUVDYSMZNZYNUVEYQMZUVCUVDYRYSVFYNUVHUVIYNUVHNZUVIUVEGTZMZUVKYOVGVIVHZV
      JZGYPVKZUVJUVNGYPUVJUVKYPMZHTZITZJTZPZMZUVTUVKOZNZJDVLICVLZHUVKVKZUVNYJUV
      PUWEVMYMUVHIJUVKCDYFYHHVNQUVJUWEUVLUVMUWEUVLNUVEUVTMZUWBNZJDVLICVLZUVJUVM
      UWDUWHHUVEUVKUVQUVERZUWCUWGIJCDUWIUWAUWFUWBUVQUVEUVTVOVPVQVRUVJUWGUVMIJCD
      UVJUVRCMZUVSDMZNZUWGUVMUVJUWLUWGNZNZUVQUVRAVGZMZHVSZKTZUVSBVGZMZKVSZUVMUW
      NUWOVIVHZUWQUWNUUEUUGUVFUWJUVCUVRMZUXBYNUUEUVHUWMUUHQYNUUGUVHUWMUUJQYNUVF
      UVGUWMVTUVJUWJUWKUWGWAUWNUXCUVDUVSMZUWNUWFUXCUXDNUVJUWLUWFUWBWBUVCUVDUVRU
      VSVFWCZWDUVCAUVRCUUFUUKWEWFHUWOXBWCUWNUWSVIVHZUXAUWNUULUUNUVGUWKUXDUXFYNU
      ULUVHUWMUUOQYNUUNUVHUWMUUQQYNUVFUVGUWMWGUVJUWJUWKUWGWHUWNUXCUXDUXEWIUVDBU
      VSDUUMUURWEWFKUWSXBWCUWQUXANUWPUWTNZKVSHVSUWNUVMUWPUWTHKWJUWNUXGUVMHKUWNU
      XGUVMUWNUXGNUVQUWRVEZUVKMZUXHYOMZUVMUXGUWNUXHUVTMUXIUXGUVTYOVGZUVTUXHUVTY
      OWKUXGUXHUWOUWSPUXKUVQUWRUWOUWSWLUVRUVSABWMWNZWOUWNUVTUVKUXHUVJUWLUWFUWBW
      PWQWRUXGUXJUWNUXGUXKYOUXHUVTYOWSUXLWOWTUXHUVKYOXCSXDXAXEXFXGXHXMXIXJXKUVJ
      YPUHMZYOUVAOUVEUVAMUVIUVOVMUVJYPEFPZUALMZUXMYJUXOYMUVHCDEFXLQZUXNYPUJYCUV
      JYOUXNUVAYMYOUXNOYJUVHAEBFUTUOUVJUXOUXNUVARUXPUXNYPULYCZUMUVJUVEUXNUVAUVJ
      UVCEMZUVDFMZUVEUXNMYNUVFUXRUVGYNYREUVCYNYRUUFEYNUUEUUGYRUUFOUUHUUJACUUFUU
      KXNSUUIXOWQXPYNUVGUXSUVFYNYSFUVDYNYSUUMFYNUULUUNYSUUMOUUOUUQBDUUMUURXNSUU
      PXOWQXQUVCUVDEFWLSUXQXRGUVEYOYPUVAUVBXSXTYAXDYDYBYE $.
  $}

  ${
    $d x y A $.  $d m n u v x y R $.  $d m n u v x y S $.  $d m n u v x y V $.
    $d x y B $.  $d x y C $.  $d x y D $.  $d m n u v x y W $.
    $( Subset property of the topological product.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    txss12 $p |- ( ( ( B e. V /\ D e. W ) /\ ( A C_ B /\ C C_ D ) ) ->
      ( A tX C ) C_ ( B tX D ) ) $=
      ( vx vy wcel wa wss cv cxp cmpt2 crn ctg cfv ctx co cvv eqid txbasex cres
      adantr resmpt2 resss syl6eqssr adantl rnss tgss syl2anc wceq ssexg syl2an
      syl txval an4s ancoms 3sstr4d ) BEIZDFIZJZABKZCDKZJZJZGHACGLHLMZNZOZPQZGH
      BDVGNZOZPQZACRSZBDRSZVFVLTIZVIVLKZVJVMKVBVPVEGHVLBDEFVLUAZUBUDVFVHVKKZVQV
      EVSVBVEVHVKACMZUCVKGHBDACVGUEVKVTUFUGUHVHVKUIUOVIVLTUJUKVEVBVNVJULZVCUTVD
      VAWAVCUTJATICTIWAVDVAJABEUMCDFUMGHVIACTTVIUAUPUNUQURVBVOVMULVEGHVLBDEFVRU
      PUDUS $.

    $( It is sufficient to consider products of the bases for the topologies in
       the topological product.  (Contributed by Mario Carneiro,
       25-Aug-2014.) $)
    txbasval $p |- ( ( R e. V /\ S e. W ) ->
      ( ( topGen ` R ) tX ( topGen ` S ) ) = ( R tX S ) ) $=
      ( vu vv vm vn vx vy wcel wa cv cxp ctg cfv wss wceq ciun cvv ctx co cmpt2
      crn eqid txval cres bastg resmpt2 syl2an resss syl6eqssr rnss syl wf wral
      cuni wex eltg3 bi2anan9 eeanv an4 uniiun xpeq12i xpiundir xpiundi iuneq2i
      a1i 3eqtri ovex ssel2 anim12i an4s txopn sylan2 anassrs ralrimiva sylancr
      tgiun txbasex tgidm fveq2d 3eqtr4d adantr eleqtrd syl5eqel xpeq12 expimpd
      eleq1d syl5ibrcom syl5bi syl5bir sylbid ralrimivv fmpt2 sylib frn sseqtrd
      exlimdvv 2basgen syl2anc fvex mp2an syl6eqr eqtr2d ) ACKZBDKZLZABUAUBZEFA
      BEMZFMZNZUCZUDZOPZAOPZBOPZUAUBZEFXNABCDXNUEZUFZXHXOEFXPXQXLUCZUDZOPZXRXHX
      NYBQZYBXOQXOYCRXHXMYAQYDXHXMYAABNZUGZYAXFAXPQBXQQYFXMRXGACUHBDUHEFXPXQABX
      LUIUJYAYEUKULXMYAUMUNXHYBXIXOXHXPXQNZXIYAUOZYBXIQXHXLXIKZFXQUPEXPUPYHXHYI
      EFXPXQXHXJXPKZXKXQKZLGMZAQZXJYLUQZRZLZGURZHMZBQZXKYRUQZRZLZHURZLZYIXFYJYQ
      XGYKUUCGXJACUSHXKBDUSUTUUDYPUUBLZHURGURXHYIYPUUBGHVAXHUUEYIGHUUEYMYSLZYOU
      UALZLXHYIYMYOYSUUAVBXHUUFUUGYIXHUUFLZYIUUGYNYTNZXIKUUHUUIIYLJYRIMZJMZNZSZ
      SZXIUUIIYLUUJSZJYRUUKSZNIYLUUJUUPNZSUUNYNUUOYTUUPIYLVCJYRVCVDIYLUUJUUPVEI
      YLUUQUUMUUQUUMRUUJYLKZJYRUUKUUJVFVHVGVIUUHUUNXIOPZXIUUHXITKZUUMXIKZIYLUPU
      UNUUSKABUAVJZUUHUVAIYLUUHUURLZUUMUUSXIUVCUUTUULXIKZJYRUPUUMUUSKUVBUVCUVDJ
      YRUUHUURUUKYRKZUVDXHUUFUURUVELZUVDUUFUVFLXHUUJAKZUUKBKZLZUVDYMUURYSUVEUVI
      YMUURLUVGYSUVELUVHYLAUUJVKYRBUUKVKVLVMUUJUUKABCDVNVOVPVPVQJYRXIUULTVSVRUU
      HUUSXIRZUURXHUVJUUFXHXOOPZXOUUSXIXHXNTKUVKXOREFXNABCDXSVTXNTWAUNXHXIXOOXT
      WBXTWCWDZWDWEVQIYLXIUUMTVSVRUVLWEWFUUGXLUUIXIXJYNXKYTWGWIWJWHWKWSWLWMWNEF
      XPXQXLXIYAYAUEWOWPYGXIYAWQUNXTWRXNYBWTXAXPTKXQTKXRYCRAOXBBOXBEFYBXPXQTTYB
      UEUFXCXDXE $.
  $}

  ${
    $d a b c A $.  $d a b c B $.  $d a b c C $.  $d a b c D $.
    $d a b c e f p J $.  $d a b c e f p K $.  $d a X $.  $d b Y $.
    neitx.x $e |- X = U. J $.
    neitx.y $e |- Y = U. K $.
    $( The cross product of two neighborhoods is a neighborhood in the product
       topology.  (Contributed by Thierry Arnoux, 13-Jan-2018.) $)
    neitx $p |- ( ( ( J e. Top /\ K e. Top ) /\
      ( A e. ( ( nei ` J ) ` C ) /\ B e. ( ( nei ` K ) ` D ) ) )
      -> ( A X. B ) e. ( ( nei ` ( J tX K ) ) ` ( C X. D ) ) ) $=
      ( vc va vb ctop wcel wa cfv cxp wss syl2anc cnei co cuni cv wrex ad2ant2r
      ctx neii1 ad2ant2l xpss12 wceq txuni adantr sseqtrd simp-5l simp-4r txopn
      simplr syl12anc simpr1l 3anassrs simprl simpr1r simprr sseq2 sseq1 rspcev
      anbi12d neii2 ad2antrr r19.29a wb txtop neiss2 eqid isnei mpbir2and ) ENO
      ZFNOZPZACEUAQQOZBDFUAQQOZPZPZABRZCDRZEFUGUBZUAQQOZWEWGUCZSZWFKUDZSZWKWESZ
      PZKWGUEZWDWEGHRZWIWDAGSZBHSZWEWPSVRWAWQVSWBCEAGIUHUFVSWBWRVRWADFBHJUHUIAG
      BHUJTVTWPWIUKWCEFGHIJULUMZUNWDCLUDZSZWTASZPZWOLEWDWTEOZPZXCPZDMUDZSZXGBSZ
      PZWOMFXFXGFOZPZXJPZWTXGRZWGOZWFXNSZXNWESZWOXMVTXDXKXOVTWCXDXCXKXJUOWDXDXC
      XKXJUPXFXKXJURWTXGEFNNUQUSXMXAXHXPXEXCXKXJXAXAXBXKXJXEUTVAXLXHXIVBCWTDXGU
      JTXMXBXIXQXEXCXKXJXBXAXBXKXJXEVCVAXLXHXIVDWTAXGBUJTWNXPXQPKXNWGWKXNUKWLXP
      WMXQWKXNWFVEWKXNWEVFVHVGUSWDXJMFUEZXDXCVSWBXRVRWADMFBVIUIVJVKVRWAXCLEUEVS
      WBCLEAVIUFVKWDWGNOZWFWISWHWJWOPVLVTXSWCEFVMUMWDWFWPWIWDCGSZDHSZWFWPSVRWAX
      TVSWBCEAGIVNUFVSWBYAVRWADFBHJVNUICGDHUJTWSUNWFKWGWEWIWIVOVPTVQ $.
  $}

  ${
    $d u v w z A $.  $d u v w z B $.  $d u v w F $.  $d u v w z J $.  $d w L $.
    $d u v w z K $.  $d w ph $.  $d u v w U $.
    txcnpi.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    txcnpi.2 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    txcnpi.3 $e |- ( ph -> F e. ( ( ( J tX K ) CnP L ) ` <. A , B >. ) ) $.
    txcnpi.4 $e |- ( ph -> U e. L ) $.
    txcnpi.5 $e |- ( ph -> A e. X ) $.
    txcnpi.6 $e |- ( ph -> B e. Y ) $.
    txcnpi.7 $e |- ( ph -> ( A F B ) e. U ) $.
    $( Continuity of a two-argument function at a point.  (Contributed by Mario
       Carneiro, 20-Sep-2015.) $)
    txcnpi $p |- ( ph -> E. u e. J E. v e. K
        ( A e. u /\ B e. v /\ ( u X. v ) C_ ( `' F " U ) ) ) $=
      ( wcel vw vz cop cv cima wss wa ctx co wrex cxp ccnv ccnp df-ov syl5eqelr
      w3a cfv cnpimaex syl3anc wfun cdm wb cuni wf eqid cnpf syl adantr elssuni
      ffun wceq fdm sseq2d biimpar sylan2 funimass3 syl2anc anbi2d wral wi eltx
      ctopon biimpa eleq1 anbi1d rspccv sstr2 com12 anim2d opelxp anbi1i df-3an
      2rexbidv 3imtr4g reximdv syl6 imp3a sylbid rexlimdva mpd ) ADEUCZUAUDZTZG
      XBUEFUFZUGZUAHIUHUIZUJZDCUDZTZEBUDZTZXHXJUKZGULFUEZUFZUPZBIUJZCHUJZAGXAXF
      JUMUIUQTZFJTXAGUQZFTXGOPAXSDEGUIFDEGUNSUOUAFXAGXFJURUSAXEXQUAXFAXBXFTZUGZ
      XEXCXBXMUFZUGZXQYAXDYBXCYAGUTZXBGVAZUFZXDYBVBYAXFVCZJVCZGVDZYDAYIXTAXRYIO
      XAGXFJYGYHYGVEYHVEVFVGZVHYGYHGVJVGXTAXBYGUFZYFXBXFVIAYFYKAYEYGXBAYIYEYGVK
      YJYGYHGVLVGVMVNVOXBFGVPVQVRYAUBUDZXLTZXLXBUFZUGZBIUJCHUJZUBXBVSZYCXQVTAXT
      YQAHKWBUQZTILWBUQZTXTYQVBMNCBXBHIYRYSUBWAVQWCYQXCYBXQYQXCXAXLTZYNUGZBIUJZ
      CHUJZYBXQVTYPUUCUBXAXBYLXAVKZYOUUACBHIUUDYMYTYNYLXAXLWDWEWMWFYBUUCXQYBUUB
      XPCHYBUUAXOBIYBXIXKUGZYNUGUUEXNUGUUAXOYBYNXNUUEYNYBXNXLXBXMWGWHWIYTUUEYND
      EXHXJWJWKXIXKXNWLWNWOWOWHWPWQVGWRWSWT $.
  $}

  ${
    $d R u v w x z $.  $d S u v w x z $.  $d T u v w x z $.  $d X u v w x z $.
    $d Y u v w x z $.  $d Z u v w x z $.
    $( Continuity of the first projection map of a topological product.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 22-Aug-2015.) $)
    tx1cn $p |- ( ( R e. ( TopOn ` X ) /\ S e. ( TopOn ` Y ) ) ->
                  ( 1st |` ( X X. Y ) ) e. ( ( R tX S ) Cn R ) ) $=
      ( vw vz ctopon cfv wcel wa c1st cxp cres ctx co ccn cv wss wb syl2anc a1i
      wf ccnv cima wral f1stres toponss adantlr xpss1 syl pm4.71rd wfn elpreima
      sseld ffn mp2b fvres c2nd cop wceq 1st2nd2 xp2nd elxp6 anass an32 3bitr2i
      eleq1d baib bitr4d pm5.32i bitri syl6rbbr eqrdv toponmax ad2antlr anassrs
      txopn mpdan eqeltrd ralrimiva txtopon simpl iscn mpbir2and ) ACGHZIZBDGHZ
      IZJZKCDLZMZABNOZAPOIZWJCWKUBZWKUCEQZUDZWLIZEAUEZWNWICDUFZUAWIWQEAWIWOAIZJ
      ZWPWODLZWLXAFWPXBXAFQZXBIZXCWJIZXDJZXCWPIZXAXDXEXAXBWJXCXAWOCRZXBWJRWFWTX
      HWHWOACUGUHWOCDUIUJUNUKXGXEXCWKHZWOIZJZXFWNWKWJULXGXKSWSWJCWKUOWJXCWOWKUM
      UPXEXJXDXEXJXCKHZWOIZXDXEXIXLWOXCWJKUQVGXEXCXLXCURHZUSUTZXNDIZXDXMSXCCDVA
      XCCDVBXDXOXPJZXMXDXOXMXPJJXOXMJXPJXQXMJXCWODVCXOXMXPVDXOXMXPVEVFVHTVIVJVK
      VLVMXADBIZXBWLIZWHXRWFWTDBVNVOWIWTXRXSWODABWEWGVQVPVRVSVTWIWLWJGHIWFWMWNW
      RJSABCDWAWFWHWBEWKWLAWJCWCTWD $.
  $}

  ${
    $d R u v w x z $.  $d S u v w x z $.  $d T u v w x z $.  $d X u v w x z $.
    $d Y u v w x z $.  $d Z u v w x z $.
    $( Continuity of the second projection map of a topological product.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 22-Aug-2015.) $)
    tx2cn $p |- ( ( R e. ( TopOn ` X ) /\ S e. ( TopOn ` Y ) ) ->
                  ( 2nd |` ( X X. Y ) ) e. ( ( R tX S ) Cn S ) ) $=
      ( vw vz ctopon cfv wcel wa c2nd cxp cres ctx co ccn wf cv wss wb ccnv a1i
      cima wral f2ndres toponss adantll xpss2 syl sseld pm4.71rd elpreima fvres
      wfn ffn mp2b eleq1d c1st cop wceq 1st2nd2 xp1st elxp6 bitr4i baib syl2anc
      anass bitr4d pm5.32i bitri syl6rbbr eqrdv toponmax adantr txopn mpdan imp
      wi expr eqeltrd ralrimiva txtopon iscn sylancom mpbir2and ) ACGHZIZBDGHZI
      ZJZKCDLZMZABNOZBPOIZWKDWLQZWLUAERZUCZWMIZEBUDZWOWJCDUEZUBWJWREBWJWPBIZJZW
      QCWPLZWMXBFWQXCXBFRZXCIZXDWKIZXEJZXDWQIZXBXEXFXBXCWKXDXBWPDSZXCWKSWIXAXIW
      GWPBDUFUGWPDCUHUIUJUKXHXFXDWLHZWPIZJZXGWOWLWKUNXHXLTWTWKDWLUOWKXDWPWLULUP
      XFXKXEXFXKXDKHZWPIZXEXFXJXMWPXDWKKUMUQXFXDXDURHZXMUSUTZXOCIZXEXNTXDCDVAXD
      CDVBXEXPXQJZXNXEXPXQXNJJXRXNJXDCWPVCXPXQXNVGVDVEVFVHVIVJVKVLWJXAXCWMIZWJC
      AIZXAXSVRWGXTWICAVMVNWJXTXAXSCWPABWFWHVOVSVPVQVTWAWGWIWMWKGHIWNWOWSJTABCD
      WBEWLWMBWKDWCWDWE $.
  $}

  ${
    $d g k n s u w x y z A $.  $d g k n s u w x y z F $.  $d g k n s u w J $.
    $d g k n s u w x y z I $.  $d g k n s u w x y z V $.  $d u x Y $.
    $d g k n s w x y z U $.
    ptpjcn.1 $e |- Y = U. J $.
    ptpjcn.2 $e |- J = ( Xt_ ` F ) $.
    $( Continuity of a projection map into a topological product.  (Contributed
       by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       3-Feb-2015.) $)
    ptpjcn $p |- ( ( A e. V /\ F : A --> Top /\ I e. A ) ->
      ( x e. Y |-> ( x ` I ) ) e. ( J Cn ( F ` I ) ) ) $=
      ( vk vg vy vz vw wcel ctop cv cfv wceq wa vu wf w3a cmpt cuni cixp ccn co
      ptuni 3adant3 syl6reqr mpteq1d ccnv cima cpt syl5eqel ffvelrn 3adant1 jca
      wral pttop wfn elixp simprbi fveq2 unieqd eleq12d rspcva sylan2 3ad2antl3
      vex eqid fmptd feq2d mpbird cdif cfn wrex wex cab wss ctg ctb ptbas bastg
      syl ffn ptval syl5eq sseqtr4d adantr ptpjpre2 sseldd ralrimiv 3impa iscn2
      expr sylanbrc eqeltrd ) BFOZBPCUBZDBOZUCZAGDAQZRZUDAJBJQZCRZUEZUFZXEUDZED
      CRZUGUHZXCAGXIXEXCXIEUEZGWTXAXIXMSXBJBCEFIUIUJHUKZULXCEPOZXKPOZTGXKUEZXJU
      BZXJUMUAQZUNZEOZUAXKUTZTXJXLOXCXOXPXCECUORZPIWTXAYCPOXBBCFVAUJUPXAXBXPWTB
      PDCUQURUSXCXRYBXCXRXIXQXJUBXCAXIXEXQXJXBWTXDXIOZXEXQOZXAYDXBXFXDRZXHOZJBU
      TZYEYDXDBVBYHJBXHXDAVKVCVDYGYEJDBXFDSZYFXEXHXQXFDXDVEYIXGXKXFDCVEVFVGVHVI
      VJXJVLVMXCGXIXQXJXNVNVOWTXAXBYBWTXATZXBTYAUAXKYJXBXSXKOZYAYJXBYKTZTKQZBVB
      LQZYMRZYNCRZOLBUTYOYPUESLBMQVPUTMVQVRUCNQLBYOUFSTKVSNVTZEXTYJYQEWAYLYJYQY
      QWBRZEYJYQWCOYQYRWANLMBYQKCFYQVLZWDYQWCWEWFXAWTCBVBZEYRSBPCWGWTYTTEYCYRIN
      LMBYQKCFYSWHWIVIWJWKNLMABYQXSKJCDFXIYSXIVLWLWMWQWNWOUSUAXJEXKGXQHXQVLWPWR
      WS $.

    $( The projection map is an open map.  (Contributed by Mario Carneiro,
       2-Sep-2015.) $)
    ptpjopn $p |- ( ( ( A e. V /\ F : A --> Top /\ I e. A ) /\ U e. J ) ->
      ( ( x e. Y |-> ( x ` I ) ) " U ) e. ( F ` I ) ) $=
      ( vy vz vs vw vn wcel wa cv cfv wceq vg vk ctop wf w3a cmpt cima crn cres
      df-ima wss cuni elssuni syl6sseqr adantl resmpt syl rneqd syl5eq wel wrex
      wral wfn cdif cfn cixp wex cab ctg cpt ptval sylan2 3adant3 eleq2d biimpa
      ffn eqid tg2 sylan wi vex weq anbi2d exbidv elab simpl3 ad3antrrr simplr2
      eqeq1 fveq2 eleq12d rspcv sylc elixp simprbi ad2antrl cif simplrr simplrl
      eleqtrrd simprr adantr ifclda anassrs ralrimiva simpll1 mptelixpg cbvixpv
      wn mpbird syl6eleq sseldd iftrue fvmpt eqcomd fveq1 eqeq2d rspcev syl2anc
      wb cvv elrnmpt ax-mp sylibr ssrdv eleq2 sseq1 anbi12d syl12anc syl5ibrcom
      ex imbi1d expimpd exlimdv syl5bi rexlimdv mpd fvex rgenw cbvmptv ralrnmpt
      eleq1 anbi1d rexbidv simpl2 ffvelrnd eltop2 eqeltrd ) BGPZBUCDUDZEBPZUEZC
      FPZQZAHEARZSZUFZCUGZACUUPUFZUHZEDSZUUNUURUUQCUIZUHUUTUUQCUJUUNUVBUUSUUNCH
      UKZUVBUUSTUUMUVCUULUUMCFULHCFUMIUNUOAHCUUPUPUQURUSUUNUUTUVAPZKLUTZLRZUUTU
      KZQZLUVAVAZKUUTVBZUUNEMRZSZUVFPZUVGQZLUVAVAZMCVBZUVJUUNUVOMCUUNUVKCPZQZMN
      UTZNRZCUKZQZNUARZBVCZKRZUWCSZUWEDSZPZKBVBZUWFUWGULTKBUVFVDVBLVEVAZUEZUVKK
      BUWFVFZTZQZUAVGZMVHZVAZUVOUUNCUWPVISZPZUVQUWQUULUUMUWSUULFUWRCUUIUUJFUWRT
      UUKUUIUUJQFDVJSZUWRJUUJUUIDBVCUWTUWRTBUCDVPMKLBUWPUADGUWPVQVKVLUSVMVNVONC
      UWPUVKVRVSUVRUWBUVONUWPUVTUWPPUWKUVTUWLTZQZUAVGZUVRUWBUVOVTZUWOUXCMUVTNWA
      MNWBZUWNUXBUAUXEUWMUXAUWKUVKUVTUWLWIWCWDWEUVRUXBUXDUAUVRUWKUXAUXDUVRUWKQZ
      UXDUXAUVKUWLPZUWLCUKZQZUVOVTUXFUXIUVOUXFUXIQZEUWCSZUVAPZUVLUXKPZUXKUUTUKZ
      UVOUXJUUKUWIUXLUUNUUKUVQUWKUXIUUIUUJUUKUUMWFZWGZUWDUWIUWJUVRUXIWHUWHUXLKE
      BUWEETZUWFUXKUWGUVAUWEEUWCWJZUWEEDWJWKWLWMUXJUUKUWEUVKSZUWFPZKBVBZUXMUXPU
      XGUYAUXFUXHUXGUVKBVCUYAKBUWFUVKMWAWNWOZWPUXTUXMKEBUXQUXSUVLUWFUXKUWEEUVKW
      JUXRWKWLWMUXJUBUXKUUTUXJUBRZUXKPZUYCUUTPZUXJUYDQZUYCUUPTZACVAZUYEUYFOBORZ
      ETZUYCUYIUVKSZWQZUFZCPUYCEUYMSZTZUYHUYFUWLCUYMUXFUXGUXHUYDWRUYFUYMOBUYIUW
      CSZVFZUWLUYFUYMUYQPZUYLUYPPZOBVBZUYFUYSOBUXJUYDUYIBPZUYSUXJUYDVUAQZQZUYJU
      YCUYKUYPVUCUYJQUYCUXKUYPUXJUYDVUAUYJWSUYJUYPUXKTVUCUYIEUWCWJUOWTVUCUYKUYP
      PZUYJXIVUCVUAUYAVUDUXJUYDVUAXAVUCUXGUYAUXFUXGUXHVUBWSUYBUQUXTVUDKUYIBKOWB
      UXSUYKUWFUYPUWEUYIUVKWJUWEUYIUWCWJWKWLWMXBXCXDXEUYFUUIUYRUYTXTUVRUUIUWKUX
      IUYDUUIUUJUUKUUMUVQXFWGOBUYLUYPGXGUQXJOKBUYPUWFUYIUWEUWCWJXHXKXLUYFUYNUYC
      UYFUUKUYNUYCTUXJUUKUYDUXPXBOEUYLUYCBUYMUYJUYCUYKXMUYMVQUBWAZXNUQXOUYGUYOA
      UYMCUUOUYMTUUPUYNUYCEUUOUYMXPXQXRXSUYCYAPUYEUYHXTVUEACUUPUYCUUSYAUUSVQYBY
      CYDYKYEUVNUXMUXNQLUXKUVAUVFUXKTUVMUXMUVGUXNUVFUXKUVLYFUVFUXKUUTYGYHXRYIYK
      UXAUWBUXIUVOUXAUVSUXGUWAUXHUVTUWLUVKYFUVTUWLCYGYHYLYJYMYNYOYPYQXEUVLYAPZM
      CVBUVJUVPXTVUFMCEUVKYRYSUVIUVOMKCUVLUUSYAAMCUUPUVLEUUOUVKXPYTUWEUVLTZUVHU
      VNLUVAVUGUVEUVMUVGUWEUVLUVFUUBUUCUUDUUAYCYDUUNUVAUCPUVDUVJXTUUNBUCEDUUIUU
      JUUKUUMUUEUXOUUFKLUUTUVAUUGUQXJUUH $.
  $}

  ${
    $d ph k x $.  $d A k x $.  $d C x z $.  $d F k x z $.  $d V k $.
    ptcld.a $e |- ( ph -> A e. V ) $.
    ptcld.f $e |- ( ph -> F : A --> Top ) $.
    ptcld.c $e |- ( ( ph /\ k e. A ) -> C e. ( Clsd ` ( F ` k ) ) ) $.
    $( A closed box in the product topology.  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    ptcld $p |- ( ph -> X_ k e. A C e. ( Clsd ` ( Xt_ ` F ) ) ) $=
      ( vx cixp cfv wceq ccld wss wral wcel wa eqid adantr cv cuni cif ciin cin
      cpt cldss ralrimiva boxriin ctop wf ptuni syl2anc ineq1d pttop cdif sseq1
      syl simpl ssid a1i ifbothda ralimi ss2ixp 3syl sseqtrd csb eqcomd difeq1d
      wn simpr boxcutc ixpeq2 fveq2 unieqd csbeq1a difeq12d adantl ifeq1da mprg
      3eqtrd nfcsb1v nfel1 fveq2d eleq12d cbvral r19.21bi cldopn ptopn2 eqeltrd
      nfv sylib wb iscld mpbir2and riincld ) ADBCKZDBDUAZELZUBZKZJBDBWRJUAZMZCW
      TUCZKZUDZUEZEUFLZNLZACWTOZDBPZWQXGMAXJDBAWRBQZRCWSNLZQZXJICWSWTWTSUGURUHZ
      DJCWTBUIURAXGXHUBZXFUEZXIAXAXPXFABFQZBUJEUKZXAXPMZGHDBEXHFXHSULUMZUNAXHUJ
      QZXEXIQZJBPXQXIQAXRXSYBGHBEFUOUMZAYCJBAXBBQZRZYCXEXPOZXPXEUPZXHQZYFXEXAXP
      AXEXAOZYEAXKXDWTOZDBPYJXOXJYKDBXCXJWTWTOZYKXJCWTCXDWTUQWTXDWTUQXJXCUSYLXJ
      XCVJRWTUTVAVBVCDBXDWTVDVETAXTYEYATVFYFYHDBXCXBELZUBZDXBCVGZUPZWTUCZKZXHYF
      YHXAXEUPZDBXCWTCUPZWTUCZKZYRAYHYSMYEAXPXAXEAXAXPYAVHVITYFYEXKYSUUBMAYEVKA
      XKYEXOTBWTCDXBVLUMUUBYRMZYFUUAYQMUUCDBDBUUAYQVMXLXCYTYPWTXCYTYPMXLXCWTYNC
      YOXCWSYMWRXBEVNZVODXBCVPZVQVRVSVTVAWAYFBDEYPFXBAXRYEGTAXSYEHTYFYOYMNLZQZY
      PYMQAUUGJBAXNDBPUUGJBPAXNDBIUHXNUUGDJBXNJWKDYOUUFDXBCWBWCXCCYOXMUUFUUEXCW
      SYMNUUDWDWEWFWLWGYOYMYNYNSWHURWIWJAYCYGYIRWMZYEAYBUUHYDXEXHXPXPSZWNURTWOU
      HJBXEXHXPUUIWPUMWJWJ $.
  $}

  ${
    $d ph k l $.  $d A k l z $.  $d C l z $.  $d J l z $.  $d V l $.
    ptcldmpt.a $e |- ( ph -> A e. V ) $.
    ptcldmpt.j $e |- ( ( ph /\ k e. A ) -> J e. Top ) $.
    ptcldmpt.c $e |- ( ( ph /\ k e. A ) -> C e. ( Clsd ` J ) ) $.
    $( A closed box in the product topology.  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    ptcldmpt $p |- ( ph -> X_ k e. A C e.
          ( Clsd ` ( Xt_ ` ( k e. A |-> J ) ) ) ) $=
      ( vl cixp cv cfv ccld nfcv ctop wcel wa wi wceq csb cmpt cpt nfcsb1v eqid
      csbeq1a cbvixp fmptd nffvmpt1 nffv nfel eleq1 anbi2d fveq2 fveq2d eleq12d
      nfv nfim imbi12d simpr fvmpt2 syl2anc eleqtrrd chvar ptcld syl5eqel ) ADB
      CKJBDJLZCUAZKDBEUBZUCMNMDJBCVHJCODVGCUDZDVGCUFZUGABVHJVIFGADBEPVIHVIUEZUH
      ADLZBQZRZCVMVIMZNMZQZSAVGBQZRZVHVGVIMZNMZQZSDJVTWCDVTDUQDVHWBVJDWANDNODBE
      VGUIUJUKURVMVGTZVOVTVRWCWDVNVSAVMVGBULUMWDCVHVQWBVKWDVPWANVMVGVIUNUOUPUSV
      OCENMVQIVOVPENVOVNEPQVPETAVNUTHDBEPVIVLVAVBUOVCVDVEVF $.
  $}

  ${
    $d f g k u ph $.  $d f g u x y z R $.  $d f g h u y z S $.  $d g x y z V $.
    $d f g h k u x y z A $.  $d f J $.
    ptcls.2 $e |- J = ( Xt_ ` ( k e. A |-> R ) ) $.
    ptcls.a $e |- ( ph -> A e. V ) $.
    ptcls.j $e |- ( ( ph /\ k e. A ) -> R e. ( TopOn ` X ) ) $.
    ptcls.c $e |- ( ( ph /\ k e. A ) -> S C_ X ) $.
    ${
      ptclsg.1 $e |- ( ph -> U_ k e. A S e. AC_ A ) $.
      $( The closure of a box in the product topology is the box formed from
         the closures of the factors.  The proof uses the axiom of choice; the
         last hypothesis is the choice assumption.  (Contributed by Mario
         Carneiro, 3-Sep-2015.) $)
      ptclsg $p |- ( ph ->
        ( ( cls ` J ) ` X_ k e. A S ) = X_ k e. A ( ( cls ` R ) ` S ) ) $=
        ( vy vz cfv wcel wss wa wral vf vu vg vx vh cixp ccl ccld cpt cv ctopon
        cmpt ctop topontop syl cuni wceq toponuni sseqtrd eqid syl2anc ptcldmpt
        clscld fveq2i syl6eleqr sscls ralrimiva ss2ixp clsss2 cin c0 wne wi wfn
        cdif cfn wrex w3a wex cab vex weq eqeq1 anbi2d exbidv wb nffvmpt1 nfel2
        elab nfv fveq2 cbvral simpr fvmpt2 eleq2d ralbidva syl5bb adantr biimpa
        eleq12d ciun wf wacn ad2antrr simpll elixp simprbi ad2antlr clsndisj ex
        csb 3expia ralimdva sylc simprlr simprr cbvixpv syl6eleq sylanbrc ralim
        r19.26 crab rabn0 dfin5 inss2 ssiun2 syl5ss dfss1 sylib syl5eqr syl5bbr
        neeq1d ralbiia sylibr nfiu1 nfcv nfcsb1v nfin nfrex ffn csbeq1a ineq12d
        rexbidv eleq1 acni3 ixpin ineq1i eqtr4i neeq1i 3imtr3i sylan2br exlimiv
        ne0i sylan expr 3adantr3 eleq2 ineq1 imbi12d syl5ibrcom expimpd exlimdv
        syldan syl5bi ralrimiv fmptd ptval syl5eq pttopon ptbas clsss3 sseqtr4d
        ctg ctb sselda elcls3 mpbird ssrdv eqssd ) AEBDUFZFUGPPZEBDCUGPPZUFZAUW
        CFUHPZQUVTUWCRZUWAUWCRAUWCEBCULZUIPZUHPUWDABUWBECGJAEUJZBQZSZCHUKPZQZCU
        MQZKHCUNUOZUWJUWMDCUPZRZUWBCUHPQUWNUWJDHUWOLUWJUWLHUWOUQKHCURUOZUSZDCUW
        OUWOUTZVCVAVBFUWGUHIVDVEADUWBRZEBTUWEAUWTEBUWJUWMUWPUWTUWNUWRDCUWOUWSVF
        VAVGEBDUWBVHUOUWCUVTFFUPZUXAUTVIVAAUAUWCUWAAUAUJZUWCQZUXBUWAQZAUXCSZUXD
        UXBUBUJZQZUXFUVTVJZVKVLZVMZUBUCUJZBVNZNUJZUXKPZUXMUWFPZQZNBTZUXNUXOUPUQ
        NBOUJZVOTOVPVQZVRZUDUJZNBUXNUFZUQZSZUCVSZUDVTZTUXEUXJUBUYFUXFUYFQUXTUXF
        UYBUQZSZUCVSZUXEUXJUYEUYIUDUXFUBWAUDUBWBZUYDUYHUCUYJUYCUYGUXTUYAUXFUYBW
        CWDWEWIUXEUYHUXJUCUXEUXTUYGUXJUXEUXTSUXJUYGUXBUYBQZUYBUVTVJZVKVLZVMZUXE
        UXLUXQUYNUXSUXEUXLUXQSZUXLUWHUXKPZCQZEBTZSZUYNUXEUYOUYSAUYOUYSWFUXCAUXQ
        UYRUXLUXQUYPUWHUWFPZQZEBTAUYRUXPVUANEBEUXNUXOEBCUXMWGWHVUANWJNEWBUXNUYP
        UXOUYTUXMUWHUXKWKZUXMUWHUWFWKWTWLAVUAUYQEBUWJUYTCUYPUWJUWIUWLUYTCUQAUWI
        WMKEBCUWKUWFUWFUTZWNVAWOWPWQWDWRWSUXEUYSUYKUYMUXEUYSUYKSZSZBEBDXAZUEUJZ
        XBZUXMVUGPZUXNEUXMDXKZVJZQZNBTZSZUEVSZUYMVUEVUFBXCQZUXRVUKQZOVUFVQZNBTZ
        VUOAVUPUXCVUDMXDVUEUXRUYPDVJZQZOVUFVQZEBTZVUSVUEVUTVKVLZEBTZVVCVUEUYQUW
        HUXBPZUYPQZSZVVDVMZEBTZVVHEBTZVVEVUEAVVFUWBQZEBTZVVJAUXCVUDXEUXCVVMAVUD
        UXCUXBBVNZVVMEBUWBUXBUAWAZXFXGXHAVVLVVIEBUWJUWMUWPVVLVVIVMUWNUWRUWMUWPV
        VLVVIUWMUWPVVLVRVVHVVDVVFDUYPCUWOUWSXIXJXLVAXMXNVUEUYRVVGEBTZVVKUXEUXLU
        YRUYKXOVUEUXBEBUYPUFZQZVVPVUEUXBUYBVVQUXEUYSUYKXPNEBUXNUYPVUBXQZXRVVRVV
        NVVPEBUYPUXBVVOXFXGUOUYQVVGEBYAXSVVHVVDEBXTXNVVBVVDEBVVBVVAOVUFYBZVKVLU
        WIVVDVVAOVUFYCUWIVVTVUTVKUWIVVTVUFVUTVJZVUTOVUFVUTYDUWIVUTVUFRVWAVUTUQU
        WIVUTDVUFUYPDYEEBDYFYGVUTVUFYHYIYJYLYKYMYNVVBVURENBVVBNWJVUQEOVUFEBDYOE
        UXRVUKEUXNVUJEUXNYPEUXMDYQYRZWHYSENWBZVVAVUQOVUFVWCVUTVUKUXRVWCUYPUXNDV
        UJUWHUXMUXKWKEUXMDUUAUUBZWOUUCWLYIVUQVULNOBUEVUFUXRVUIVUKUUDUUEVAVUNUYM
        UEVUHVUGBVNZVUMUYMBVUFVUGYTVUMVWEUWHVUGPZVUTQZEBTZUYMVWGVULENBVWGNWJEVU
        IVUKVWBWHVWCVWFVUIVUTVUKUWHUXMVUGWKVWDWTWLVUGEBVUTUFZQVWIVKVLVWEVWHSUYM
        VWIVUGUUMEBVUTVUGUEWAXFVWIUYLVKVWIVVQUVTVJUYLEBUYPDUUFUYBVVQUVTVVSUUGUU
        HUUIUUJUUKUUNUULUOUUOUVCUUPUYGUXGUYKUXIUYMUXFUYBUXBUUQUYGUXHUYLVKUXFUYB
        UVTUURYLUUSUUTUVAUVBUVDUVEUXEUBUYFUXBUVTFEBHUFZAFUYFUVMPZUQUXCAFUWGVWKI
        ABGQZUWFBVNZUWGVWKUQJABUMUWFXBZVWMAEBCUMUWFUWNVUCUVFZBUMUWFYTUOUDNOBUYF
        UCUWFGUYFUTZUVGVAUVHWRAVWJUXAUQZUXCAFVWJUKPQZVWQAVWLUWLEBTVWRJAUWLEBKVG
        EBHFCGIUVIVAVWJFURUOWRAUYFUVNQZUXCAVWLVWNVWSJVWOUDNOBUYFUCUWFGVWPUVJVAW
        RAUVTVWJRZUXCADHRZEBTVWTAVXAEBLVGEBDHVHUOWRAUWCVWJUXBAUWBHRZEBTUWCVWJRA
        VXBEBUWJUWBUWOHUWJUWMUWPUWBUWORUWNUWRDCUWOUWSUVKVAUWQUVLVGEBUWBHVHUOUVO
        UVPUVQXJUVRUVS $.
    $}

    $( The closure of a box in the product topology is the box formed from the
       closures of the factors.  This theorem is an AC equivalent.
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    ptcls $p |- ( ph ->
      ( ( cls ` J ) ` X_ k e. A S ) = X_ k e. A ( ( cls ` R ) ` S ) ) $=
      ( ciun cvv wacn wcel wral cv wa ctopon cfv toponmax syl ralrimiva syl2anc
      ssexd iunexg wac wceq axac3 acacni sylancr eleqtrrd ptclsg ) ABCDEFGHIJKL
      AEBDMZNBOZABGPZDNPZEBQUONPJAUREBAERBPSZDHCUSCHTUAPHCPKHCUBUCLUFUDEBDGNUGU
      EAUHUQUPNUIUJJBGUKULUMUN $.
  $}

  ${
    $d x z I $.  $d y z P $.  $d x z ph $.  $d z R $.  $d y z S $.
    dfac14lem.i $e |- ( ph -> I e. V ) $.
    dfac14lem.s $e |- ( ( ph /\ x e. I ) -> S e. W ) $.
    dfac14lem.0 $e |- ( ( ph /\ x e. I ) -> S =/= (/) ) $.
    dfac14lem.p $e |- P = ~P U. S $.
    dfac14lem.r $e |- R = { y e. ~P ( S u. { P } ) |
      ( P e. y -> y = ( S u. { P } ) ) } $.
    dfac14lem.j $e |- J = ( Xt_ ` ( x e. I |-> R ) ) $.
    dfac14lem.c $e |- ( ph ->
      ( ( cls ` J ) ` X_ x e. I S ) = X_ x e. I ( ( cls ` R ) ` S ) ) $.
    $( Lemma for ~ dfac14 .  By equipping ` S u. { P } ` for some ` P e/ S `
       with the particular point topology, we can show that ` P ` is in the
       closure of ` S ` ; hence the sequence ` P ( x ) ` is in the product of
       the closures, and we can utilize this instance of ~ ptcls to extract an
       element of the closure of ` X_ k e. I S ` .  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    dfac14lem $p |- ( ph -> X_ x e. I S =/= (/) ) $=
      ( c0 wcel cvv vz cixp ccl cfv wne cmpt wral cv wa cin wi csn cun cpw wceq
      eleq2 eqeq1 imbi12d elrab2 adantr ineq1 wss ssun1 dfss1 syl6eq syl5ibrcom
      mpbi neeq1d imim2d expimpd syl5bi ralrimiv ctop cuni wb ctopon crab unexg
      snex sylancl ssun2 uniexg pwexg 3syl syl5eqel snidg sseldi epttop syl2anc
      topontop toponuni syl5sseq eleqtrd eqid elcls syl3anc ralrimiva mptelixpg
      syl mpbird ne0i pttopon cls0 3netr4d fveq2 necon3i ) ABGFUBZHUCUDZUDZRXHU
      DZUEXGRUEABGFEUCUDUDZUBZRXIXJABGDUFZXLSZXLRUEAXNDXKSZBGUGZAXOBGABUHGSUIZX
      ODUAUHZSZXRFUJZRUEZUKZUAEUGZXQYBUAEXRESXRFDULZUMZUNZSZXSXRYEUOZUKZUIXQYBD
      CUHZSZYJYEUOZUKZYICXRYFEYJXRUOYKXSYLYHYJXRDUPYJXRYEUQUROUSXQYGYIYBXQYGUIZ
      YHYAXSYNYAYHFRUEZXQYOYGMUTYHXTFRYHXTYEFUJZFXRYEFVAFYEVBYPFUOFYDVCZFYEVDVG
      VEVHVFVIVJVKVLXQEVMSZFEVNZVBDYSSXOYCVOXQEYEVPUDZSZYRXQEYMCYFVQZYTOXQYETSZ
      DYESUUBYTSXQFJSZYDTSUUCLDVSFYDJTVRVTXQYDYEDYDFWAXQDTSDYDSXQDFVNZUNZTNXQUU
      DUUETSUUFTSLFJWBUUETWCWDWEDTWFWSWGZCYEDTWHWIWEZYEEWJWSXQYEFYSYQXQUUAYEYSU
      OUUHYEEWKWSZWLXQDYEYSUUGUUIWMUADFEYSYSWNWOWPWTWQAGISZXNXPVOKBGDXKIWRWSWTX
      LXMXAWSQAHBGYEUBZVPUDSZHVMSXJRUOAUUJUUABGUGUULKAUUABGUUHWQBGYEHEIPXBWIUUK
      HWJHXCWDXDXGRXIXJXGRXHXEXFWS $.
  $}

  ${
    $d f g k s x y $.
    $( Theorem ~ ptcls is an equivalent of the axiom of choice.  (Contributed
       by Mario Carneiro, 3-Sep-2015.) $)
    dfac14 $p |- ( CHOICE <-> A. f ( f : dom f --> Top ->
      A. s e. X_ k e. dom f ~P U. ( f ` k )
        ( ( cls ` ( Xt_ ` f ) ) ` X_ k e. dom f ( s ` k ) ) =
        X_ k e. dom f ( ( cls ` ( f ` k ) ) ` ( s ` k ) ) ) ) $=
      ( vx vg vy wac cv ctop cfv cixp ccl wceq cpw wa wcel pweqd fveq2d cvv c0
      cdm wf cpt cuni wral wi wal weq unieqd cbvixpv eleq2i cmpt simplr feqmptd
      fveq2 fveq1d eqid vex dmex a1i ctopon ffvelrnda toptopon sylib sylibr wfn
      simpr elixp simprbi r19.21bi elpwid ciun wacn iunex simpll acacni sylancl
      syl fvex syl5eleqr ptclsg eqtrd sylan2b ralrimiva ex alrimiv wfun crn wne
      wnel csn cun crab simplrr df-nel wfo funforn fof sylbi ad2antrl syl5ibcom
      eleq1 necon3bd mpd simprl funfn wss ssun1 elpw mpbir rgenw sylanbrc simpl
      snex unex ssun2 uniex pwex snid sselii epttop mp2an topontopi fmptd rabex
      wn syl6eq ixpeq1d fveq1 uneq12d eleq1d eqeq2d imbi12d rabeqbidv ixpeq2dva
      sneqd fveq12d eqeq12d sylc ixpeq2dv mptex id dmmpti feq12d fvmpt sylan9eq
      dmeq toponunii syl6eqr raleqbidv spcv rspcv dfac14lem dfac9 impbii ) GAHZ
      UAZIUUPUBZBUUQBHZCHZJZKZUUPUCJZLJZJZBUUQUVAUUSUUPJZLJZJZKZMZCBUUQUVFUDZNZ
      KZUEZUFZAUGZGUVOAGUURUVNGUUROZUVJCUVMUUTUVMPZUVQUUTDUUQDHZUUPJZUDZNZKZPZU
      VJUVMUWCUUTBDUUQUVLUWBBDUHZUVKUWAUWEUVFUVTUUSUVSUUPUOUIQUJUKZUVQUWDOZUVEU
      VBBUUQUVFULZUCJZLJZJUVIUWGUVBUVDUWJUWGUVCUWILUWGUUPUWHUCUWGBUUQIUUPGUURUW
      DUMZUNRRUPUWGUUQUVFUVABUWISUVKUWIUQUUQSPZUWGUUPAURUSZUTUWGUUSUUQPOZUVFIPU
      VFUVKVAJPUWGUUQIUUSUUPUWKVBUVFUVKUVKUQVCVDUWNUVAUVKUWGUVAUVLPZBUUQUWGUVRU
      WOBUUQUEZUWGUWDUVRUVQUWDVGUWFVEUVRUUTUUQVFUWPBUUQUVLUUTCURVHVIVRVJVKUWGBU
      UQUVAVLSUUQVMZBUUQUVAUWMUUSUUTVSVNUWGGUWLUWQSMGUURUWDVOUWMUUQSVPVQVTWAWBW
      CWDWEWFUVPEHZWGZTUWRWHZWJZOZDUWRUAZUVSUWRJZKZTWIZUFZEUGGUVPUXGEUVPUXBUXFU
      VPUXBOZDFUXDUDZNZUXJFHZPZUXKUXDUXJWKZWLZMZUFZFUXNNZWMZUXDUXCDUXCUXRULZUCJ
      ZSSUXCSPUXHUWREURZUSZUTUXDSPUXHUVSUXCPZOZUVSUWRVSZUTUYDTUWTPZYFZUXDTWIUYD
      UXAUYGUVPUWSUXAUYCWNTUWTWOVDUYDUYFUXDTUYDUXDUWTPUXDTMUYFUXHUXCUWTUVSUWRUW
      SUXCUWTUWRUBZUVPUXAUWSUXCUWTUWRWPUYHUWRWQUXCUWTUWRWRWSWTVBUXDTUWTXBXAXCXD
      UXJUQUXRUQUXTUQUXHUWRBUXCUUSUWRJZUYIUDZNZWKZWLZNZKZPZBUXCUVAKZUXTLJZJZBUX
      CUVAUYKUXKPZUXKUYMMZUFZFUYNWMZLJZJZKZMZCUYOUEZUXEUYRJZDUXCUXDUXRLJZJZKZMZ
      UXHUWRUXCVFZUYIUYNPZBUXCUEZUYPUXHUWSVUNUVPUWSUXAXEUWRXFVDVUPUXHVUOBUXCVUO
      UYIUYMXGUYIUYLXHUYIUYMUUSUWRVSZXIXJXKUTBUXCUYNUWRUYAVHXLUXHUVPUXCIUXSUBZV
      UHUVPUXBXMUXHDUXCUXRIUXSUXRIPUYDUXNUXRUXNSPUXJUXNPUXRUXNVAJPUXDUXMUYEUXJX
      NXOZUXMUXNUXJUXMUXDXPUXJUXIUXDUYEXQXRXSXTFUXNUXJSYAYBYCUTUXSUQZYDUVOVURVU
      HUFAUXSDUXCUXRUYBUUAUUPUXSMZUURVURUVNVUHVVAUUQUXCIUUPUXSVVAUUBVVAUUQUXSUA
      UXCUUPUXSUUGDUXCUXRUXSUXPFUXQUXNVUSXRYEVUTUUCYGZUUDVVAUVJVUGCUVMUYOVVAUVM
      BUXCUVLKUYOVVABUUQUXCUVLVVBYHVVABUXCUVLUYNVVAUUSUXCPZOZUVKUYMVVDUVKVUCUDU
      YMVVDUVFVUCVVAVVCUVFUUSUXSJVUCUUSUUPUXSYIDUUSUXRVUCUXCUXSDBUHZUXPVUBFUXQU
      YNVVEUXNUYMVVEUXDUYIUXMUYLUVSUUSUWRUOZVVEUXJUYKVVEUXIUYJVVEUXDUYIVVFUIQZY
      PYJZQVVEUXLUYTUXOVUAVVEUXJUYKUXKVVGYKVVEUXNUYMUXKVVHYLYMYNVUTVUBFUYNUYMUY
      IUYLVUQUYKXNXOZXRYEUUEUUFZUIUYMVUCUYMSPUYKUYMPVUCUYMVAJPVVIUYLUYMUYKUYLUY
      IXPUYKUYJUYIVUQXQXRXSXTFUYMUYKSYAYBUUHUUIQYOWBVVAUVEUYSUVIVUFVVAUVBUYQUVD
      UYRVVAUVCUXTLUUPUXSUCUORVVABUUQUXCUVAVVBYHYQVVAUVIBUXCUVHKVUFVVABUUQUXCUV
      HVVBYHVVABUXCUVHVUEVVDUVAUVGVUDVVDUVFVUCLVVJRUPYOWBYRUUJYMUUKYSVUGVUMCUWR
      UYOCEUHZUYSVUIVUFVULVVKUYQUXEUYRVVKUYQBUXCUYIKUXEVVKBUXCUVAUYIUUSUUTUWRYI
      ZYTBDUXCUYIUXDUUSUVSUWRUOZUJYGRVVKVUFBUXCUYIVUDJZKVULVVKBUXCVUEVVNVVKUVAU
      YIVUDVVLRYTBDUXCVVNVUKUWEUYIUXDVUDVUJUWEVUCUXRLUWEVUBUXPFUYNUXQUWEUYMUXNU
      WEUYIUXDUYLUXMVVMUWEUYKUXJUWEUYJUXIUWEUYIUXDVVMUIQZYPYJZQUWEUYTUXLVUAUXOU
      WEUYKUXJUXKVVOYKUWEUYMUXNUXKVVPYLYMYNRVVMYQUJYGYRUULYSUUMWEWFDEUUNVEUUO
      $.
  $}

  ${
    $d x J $.  $d f k v x y z R $.  $d f k v x y z S $.  $d f k v x y z X $.
    $d k v x y Y $.
    $( The "constant function" function which maps ` x e. Y ` to the constant
       function ` z e. X |-> x ` is a continuous function from ` X ` into the
       space of continuous functions from ` Y ` to ` X ` .  This can also be
       understood as the currying of the first projection function.  (The
       currying of the second projection function is
       ` x e. Y |-> ( z e. X |-> z ) ` , which we already know is continuous
       because it is a constant function.)  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    xkoccn $p |- ( ( R e. ( TopOn ` X ) /\ S e. ( TopOn ` Y ) ) ->
      ( x e. Y |-> ( X X. { x } ) ) e. ( S Cn ( S ^ko R ) ) ) $=
      ( vy vk vv vz vf cfv wcel wa cv co cima wss eqid wceq c0 ctopon cmpt cxko
      csn cxp ccn ccnv crest ccmp cuni cpw crab cmpt2 wral cnconst2 3expa fmptd
      wf crn wrex xkobval abeq2i adantlr simplr imaeq2d ima0 0ss eqsstri imaeq1
      syl6eqss sseq1d elrab sylanbrc ralrimiva rabid2 sylibr simpllr syl adantr
      toponmax eqeltrrd wne cin cif ifnefalse ad2antlr eleq2d vex syl6bb df-ima
      snss cres simplrl ad2antrr elpwid toponuni ad5antr sseqtr4d xpssres rneqd
      syl5eq biantrurd 3bitr2d bitr3d syl6bbr rabbi2dva simplrr toponss syl2anc
      rnxp eqtrd dfss1 eqtr3d eqeltrd pm2.61dane imaeq2 mptpreima syl6eq eleq1d
      sylib syl5ibrcom expimpd rexlimdvva syl5bi ralrimiv simpr ovex pwex xkotf
      cvv frn ax-mp ssexi a1i ctop cfi ctg topontop xkoval syl2an mpbir2and
      xkotopon subbascn ) BDUAKLZCEUAKLZMZAEDANZUDZUEZUBZCCBUCOZUFOLEBCUFOZUUJU
      RUUJUGZFNZPZCLZFGHBINUHOUILIBUJZUKZULZCJNZGNZPZHNZQZJUULULZUMZUSZUNUUFAEU
      UIUULUUJUUDUUEUUGELZUUIUULLZUUGBCDEUOUPZUUJRZUQUUFUUPFUVGUUNUVGLBUVAUHOUI
      LZUUNUVESZMZHCUTGUURUTZUUFUUPUVOFUVGIHBCUVFJGUUSUUQFUUQRZUUSRZUVFRZVAVBUU
      FUVNUUPGHUURCUUFUVAUURLZUVCCLZMZMZUVLUVMUUPUWBUVLMZUUPUVMUUIUVELZAEULZCLZ
      UWCUWFUVATUWCUVATSZMZEUWECUWHUWDAEUNEUWESUWHUWDAEUWHUVHMZUVIUUIUVAPZUVCQZ
      UWDUWCUVHUVIUWGUWBUVHUVIUVLUUFUVHUVIUWAUVJVCVCZVCUWIUWJUUITPZUVCUWIUVATUU
      IUWCUWGUVHVDVEUWMTUVCUUIVFUVCVGVHVJUVDUWKJUUIUULUUTUUISUVBUWJUVCUUTUUIUVA
      VIVKVLZVMVNUWDAEVOVPUWCECLZUWGUWCUUEUWOUUDUUEUWAUVLVQZECVTVRVSWAUWCUVATWB
      ZMZUWEUVCCUWREUVCWCZUWEUVCUWRUWDAEUVCUWRUVHMZUUGUVCLZUVIUWKMZUWDUWTUUGUWG
      EUVCWDZLZUXAUXBUWTUXCUVCUUGUWQUXCUVCSUWCUVHUVATEUVCWEWFWGZUWTUXDUUHUVCQZU
      WKUXBUWTUXDUXAUXFUXEUUGUVCAWHWKWIUWTUWJUUHUVCUWTUWJUVAUUHUEZUSZUUHUWTUWJU
      UIUVAWLZUSUXHUUIUVAWJUWTUXIUXGUWTUVADQUXIUXGSUWTUVAUUQDUWTUVAUUQUWCUVSUWQ
      UVHUUFUVSUVTUVLWMWNWOUUDDUUQSUUEUWAUVLUWQUVHDBWPWQWRDUUHUVAWSVRWTXAUWQUXH
      UUHSUWCUVHUVAUUHXJWFXKVKUWTUVIUWKUWCUVHUVIUWQUWLVCXBXCXDUWNXEXFUWRUVCEQZU
      WSUVCSUWCUXJUWQUWCUUEUVTUXJUWPUUFUVSUVTUVLXGZUVCCEXHXIVSUVCEXLXTXMUWCUVTU
      WQUXKVSXNXOUVMUUOUWECUVMUUOUUMUVEPUWEUUNUVEUUMXPAEUUIUVEUUJUVKXQXRXSYAYBY
      CYDYEUUFFUVGUUJCUUKYJEUULUUDUUEYFUVGYJLUUFUVGUULUKZUULBCUFYGYHUUSCUEZUXLU
      VFURUVGUXLQIHBCUVFJGUUSUUQUVPUVQUVRYIUXMUXLUVFYKYLYMYNUUDBYOLZCYOLZUUKUVG
      YPKYQKSUUEDBYRZECYRZIHBCUVFJGUUSUUQUVPUVQUVRYSYTUUDUXNUXOUUKUULUAKLUUEUXP
      UXQBCUUKUUKRUUBYTUUCUUA $.
  $}

  ${
    $d r s t v w y z A $.  $d r s t v w x z ph $.  $d x y z Y $.  $d x y z Z $.
    $d r s t v w y z B $.  $d r s v w x y z D $.  $d r s t v w x y z X $.
    $d r s v w y z J $.  $d r s v w y z K $.  $d r s v w y z L $.
    txcnp.4 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    txcnp.5 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    txcnp.6 $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
    txcnp.7 $e |- ( ph -> D e. X ) $.
    txcnp.8 $e |- ( ph -> ( x e. X |-> A ) e. ( ( J CnP K ) ` D ) ) $.
    txcnp.9 $e |- ( ph -> ( x e. X |-> B ) e. ( ( J CnP L ) ` D ) ) $.
    $( If two functions are continuous at ` D ` , then the ordered pair of them
       is continuous at ` D ` into the product topology.  (Contributed by Mario
       Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    txcnp $p |- ( ph -> ( x e. X |-> <. A , B >. ) e.
      ( ( J CnP ( K tX L ) ) ` D ) ) $=
      ( cfv wcel wa vy vz vv vw vr vs vt cop cmpt ctx co ccnp cxp cima wss wrex
      wf cv wi cmpt2 crn wral ctopon cnpf2 syl3anc eqid sylibr r19.21bi opelxpi
      fmpt syl2anc fmptd wb wceq cvv simpr opex fvmpt2 sylancl eqtr4d ralrimiva
      opeq12d nffvmpt1 nfop nfeq fveq2 eqeq12d rspc sylc eleq1d adantr ad2antrr
      simplrl simprl simplrr simprr jca ex opelxp reeanv 3imtr4g sylbid cin an4
      cnpimaex elin biimpri a1i simpl toponss syl2an adantl sselda inss1 sseldi
      ssinss1 wfun cdm syl fdm sseqtr4d sseldd funfvima inss2 eqeltrd funimass4
      ffun mpd mpbird syldan adantlr xpss12 syl2im anim12d syl5bi ctop topontop
      sstr2 eleq2 vex inopn 3expb sylan jctild expimpd imaeq2 sseq1d syl6 exp3a
      anbi12d rspcev rexlimdvv syld ralrimivva xpex rgen2w sseq2 anbi2d rexbidv
      imbi12d ralrnmpt2 ax-mp ctg txval txtopon tgcnp mpbir2and ) ABICDUHZUIZEF
      GHUJUKZULUKRSIJKUMZUVIUQZEUVIRZUAURZSZEUBURZSZUVIUVPUNZUVNUOZTZUBFUPZUSZU
      AUCUDGHUCURZUDURZUMZUTZVAZVBZABIUVHUVKUVIABURZISZTZCJSZDKSZUVHUVKSAUWLBIA
      IJBICUIZUQZUWLBIVBAFIVCRSZGJVCRSZUWNEFGULUKRSZUWOLMPEUWNFGIJVDVEZBIJCUWNU
      WNVFZVJVGVHZAUWMBIAIKBIDUIZUQZUWMBIVBAUWPHKVCRSZUXBEFHULUKRSZUXCLNQEUXBFH
      IKVDVEZBIKDUXBUXBVFZVJVGVHZCDJKVIVKUVIVFZVLZAUVMUWESZUVQUVRUWEUOZTZUBFUPZ
      USZUDHVBUCGVBZUWHAUXOUCUDGHAUWCGSZUWDHSZTZTZUXKEUEURZSZUWNUYAUNZUWCUOZTZE
      UFURZSZUXBUYFUNZUWDUOZTZTZUFFUPUEFUPZUXNUXTUXKEUWNRZEUXBRZUHZUWESZUYLAUXK
      UYPVMUXSAUVMUYOUWEAEISUWIUVIRZUWIUWNRZUWIUXBRZUHZVNZBIVBZUVMUYOVNZOAVUABI
      UWKUYQUVHUYTUWKUWJUVHVOSUYQUVHVNAUWJVPZCDVQBIUVHVOUVIUXIVRVSUWKUYRCUYSDUW
      KUWJUWLUYRCVNVUDUXABICJUWNUWTVRVKUWKUWJUWMUYSDVNVUDUXHBIDKUXBUXGVRVKWBVTW
      AZVUAVUCBEIBUVMUYOBIUVHEWCBUYMUYNBICEWCBIDEWCWDWEUWIEVNZUYQUVMUYTUYOUWIEU
      VIWFVUFUYRUYMUYSUYNUWIEUWNWFUWIEUXBWFWBWGWHWIWJWKUXTUYMUWCSZUYNUWDSZTZUYE
      UEFUPZUYJUFFUPZTZUYPUYLUXTVUIVULUXTVUITZVUJVUKVUMUWRUXQVUGVUJAUWRUXSVUIPW
      LAUXQUXRVUIWMUXTVUGVUHWNUEUWCEUWNFGXEVEVUMUXEUXRVUHVUKAUXEUXSVUIQWLAUXQUX
      RVUIWOUXTVUGVUHWPUFUWDEUXBFHXEVEWQWRUYMUYNUWCUWDWSUYEUYJUEUFFFWTXAXBUXTUY
      KUXNUEUFFFUXTUYAFSZUYFFSZTZUYKUXNUXTVUPUYKTUYAUYFXCZFSZEVUQSZUVIVUQUNZUWE
      UOZTZTZUXNUXTVUPUYKVVCUXTVUPTZUYKVVBVURUYKUYBUYGTZUYDUYITZTVVDVVBUYBUYDUY
      GUYIXDVVDVVEVUSVVFVVAVVEVUSUSVVDVUSVVEEUYAUYFXFXGXHVVDVUTUYCUYHUMZUOZVVFV
      VGUWEUOVVAAVUPVVHUXSAVUPUYAIUOZVVHAUWPVUNVVIVUPLVUNVUOXIUYAFIXJXKAVVITZVV
      HUGURZUVIRZVVGSZUGVUQVBZVVJVVMUGVUQVVJVVKVUQSZTZVVLVVKUWNRZVVKUXBRZUHZVVG
      VVPVVKISVUBVVLVVSVNZVVJVUQIVVKVVIVUQIUOZAUYAUYFIXPXLZXMAVUBVVIVVOVUEWLVUA
      VVTBVVKIBVVLVVSBIUVHVVKWCBVVQVVRBICVVKWCBIDVVKWCWDWEUWIVVKVNZUYQVVLUYTVVS
      UWIVVKUVIWFVWCUYRVVQUYSVVRUWIVVKUWNWFUWIVVKUXBWFWBWGWHWIVVPVVQUYCSZVVRUYH
      SZVVSVVGSVVPVVKUYASZVWDVVPVUQUYAVVKUYAUYFXNVVJVVOVPZXOVVPUWNXQZVVKUWNXRZS
      VWFVWDUSVVPUWOVWHAUWOVVIVVOUWSWLZIJUWNYGXSVVPVUQVWIVVKVVPVUQIVWIVVJVWAVVO
      VWBWKZVVPUWOVWIIVNVWJIJUWNXTXSYAVWGYBUYAVVKUWNYCVKYHVVPVVKUYFSZVWEVVPVUQU
      YFVVKUYAUYFYDVWGXOVVPUXBXQZVVKUXBXRZSVWLVWEUSVVPUXCVWMAUXCVVIVVOUXFWLZIKU
      XBYGXSVVPVUQVWNVVKVVPVUQIVWNVWKVVPUXCVWNIVNVWOIKUXBXTXSYAVWGYBUYFVVKUXBYC
      VKYHVVQVVRUYCUYHVIVKYEWAVVJUVIXQZVUQUVIXRZUOVVHVVNVMAVWPVVIAUVLVWPUXJIUVK
      UVIYGXSWKVVJVUQIVWQVWBAVWQIVNZVVIAUVLVWRUXJIUVKUVIXTXSWKYAUGVUQVVGUVIYFVK
      YIYJYKUYCUWCUYHUWDYLVUTVVGUWEYRYMYNYOAVUPVURUXSAFYPSZVUPVURAUWPVWSLIFYQXS
      VWSVUNVUOVURUYAUYFFUUAUUBUUCYKUUDUUEUXMVVBUBVUQFUVPVUQVNZUVQVUSUXLVVAUVPV
      UQEYSVWTUVRVUTUWEUVPVUQUVIUUFUUGUUJUUKUUHUUIUULUUMUUNUWEVOSZUDHVBUCGVBUWH
      UXPVMVXAUCUDGHUWCUWDUCYTUDYTUUOUUPUWBUXOUCUDUAGHUWEUWFVOUWFVFUVNUWEVNZUVO
      UXKUWAUXNUVNUWEUVMYSVXBUVTUXMUBFVXBUVSUXLUVQUVNUWEUVRUUQUURUUSUUTUVAUVBVG
      AUBUAUWGEUVIFUVJIUVKLAGYPSZHYPSZUVJUWGUVCRVNAUWQVXCMJGYQXSAUXDVXDNKHYQXSU
      CUDUWGGHYPYPUWGVFUVDVKAUWQUXDUVJUVKVCRSMNGHJKUVEVKOUVFUVG $.
  $}

  ${
    $d f g t u w y z A $.  $d f g k u w x y z D $.  $d a f g k n t w x y z I $.
    $d f t u x y z G $.  $d f g k u w z J $.  $d f z K $.  $d f g k w x z ph $.
    $d a f g k n u w x z F $.  $d f ps $.  $d a g k n w x V $.  $d f k z W $.
    $d f g k t u w x y z X $.
    ptcnp.2 $e |- K = ( Xt_ ` F ) $.
    ptcnp.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    ptcnp.4 $e |- ( ph -> I e. V ) $.
    ptcnp.5 $e |- ( ph -> F : I --> Top ) $.
    ptcnp.6 $e |- ( ph -> D e. X ) $.
    ptcnp.7 $e |- ( ( ph /\ k e. I ) ->
      ( x e. X |-> A ) e. ( ( J CnP ( F ` k ) ) ` D ) ) $.
    ${
      ptcnplem.1 $e |- F/ k ps $.
      ptcnplem.2 $e |- ( ( ph /\ ps ) -> G Fn I ) $.
      ptcnplem.3 $e |- ( ( ( ph /\ ps ) /\ k e. I ) ->
                         ( G ` k ) e. ( F ` k ) ) $.
      ptcnplem.4 $e |- ( ( ph /\ ps ) -> W e. Fin ) $.
      ptcnplem.5 $e |- ( ( ( ph /\ ps ) /\ k e. ( I \ W ) ) ->
                         ( G ` k ) = U. ( F ` k ) ) $.
      ptcnplem.6 $e |- ( ( ph /\ ps ) ->
        ( ( x e. X |-> ( k e. I |-> A ) ) ` D ) e. X_ k e. I ( G ` k ) ) $.
      $( Lemma for ~ ptcnp .  (Contributed by Mario Carneiro, 3-Feb-2015.)
         (Revised by Mario Carneiro, 22-Aug-2015.) $)
      ptcnplem $p |- ( ( ph /\ ps ) -> E. z e. J ( D e. z /\
        ( ( x e. X |-> ( k e. I |-> A ) ) " z ) C_ X_ k e. I ( G ` k ) ) ) $=
        ( vf vu vt wa cin cv wf cfv wcel cmpt cima wss wral cixp wrex cfn inss2
        wex ssfi sylancl nfv nfan inss1 sseli ccnp co adantlr wceq adantr simpr
        cuni ctopon ctop ffvelrnda toptopon sylib cnpf2 syl3anc sylibr r19.21bi
        eqid fmpt fvmpt2 syl2anc mpteq2dva cvv mptexg syl eqtr4d ralrimiva nfcv
        an32s nffvmpt1 nfmpt nfeq fveq2 mpteq2dv eqeq12d rspc eqeltrd mptelixpg
        sylc wb mpbid cnpimaex sylan2 ex ralrimi eleq2 imaeq2 sseq1d ac6sfi crn
        anbi12d cint ad2antrr toponuni ineq1d ad2antrl mpbird sylanbrc wfun cdm
        simpl funmpt dmmptg funimass4 sylancr eleq1d cbvral ssralv expimpd
        nfel1 topontop frn wfo wfn ffn dffn4 fofi rintopn ralimi ad2antll ralrn
        elrint cdif simp-4l simpllr simplr ffvelrnd toponss sseldi syl6bb mpsyl
        sseqtr4d intss1 syl5ss r19.26 sylan biimpd ralimia sylbir ee12an sylbid
        wi fnfvelrn ralimdaa eldifi syl2an ralbidv inundif raleqi ralunb bitr3i
        impr cun ralcom syl2anr bitrd ralbidva syl5bb ralrimivw rspcev syl12anc
        syl5sseqr exlimddv ) ABUKZJNULZKUHUMZUNZFGUMZUWPUOZUPZCOEUQZUWSURZUWRIU
        OZUSZUKZGUWOUTZUKZFDUMZUPZCOGJEUQZUQZUXHURZGJUXCVAZUSZUKZDKVBZUHUWNUWOV
        CUPZFUIUMZUPZUXAUXRURZUXCUSZUKZUIKVBZGUWOUTUXGUHVEUWNNVCUPUWONUSUXQUEJN
        VDNUWOVFVGZUWNUYCGUWOABGAGVHUBVIZUWNUWRUWOUPZUYCUYFUWNUWRJUPZUYCUWOJUWR
        JNVJZVKUWNUYGUKUXAFKUWRHUOZVLVMUOUPZUXCUYIUPFUXAUOZUXCUPZUYCAUYGUYJBUAV
        NUDUWNUYLGJUWNGJUYKUQZUXMUPZUYLGJUTZUWNUYMFUXKUOZUXMUWNFOUPZGJCUMZUXAUO
        ZUQZUYRUXKUOZVOZCOUTZUYMUYPVOZAUYQBTVPAVUCBAVUBCOAUYROUPZUKZUYTUXJVUAVU
        FGJUYSEAUYGVUEUYSEVOZAUYGUKZVUEUKVUEEUYIVRZUPZVUGVUHVUEVQVUHVUJCOVUHOVU
        IUXAUNZVUJCOUTZVUHKOVSUOUPZUYIVUIVSUOUPZUYJVUKAVUMUYGQVPVUHUYIVTUPVUNAJ
        VTUWRHSWAUYIVUIVUIWHWBWCUAFUXAKUYIOVUIWDWECOVUIEUXAUXAWHZWIWFZWGZCOEVUI
        UXAVUOWJZWKWSWLVUFVUEUXJWMUPZVUAUXJVOZAVUEVQVUFJMUPZVUSAVVAVUERVPGJEMWN
        ZWOCOUXJWMUXKUXKWHWJZWKWPWQVPVUBVUDCFOCUYMUYPCGJUYKCJWRCOEFWTXACOUXJFWT
        XBUYRFVOZUYTUYMVUAUYPVVDGJUYSUYKUYRFUXAXCXDUYRFUXKXCXEXFXIUGXGUWNVVAUYN
        UYOXJAVVABRVPGJUYKUXCMXHWOXKWGUIUXCFUXAKUYIXLWEXMXNXOUYBUXEGUIUWOKUHUXR
        UWSVOZUXSUWTUYAUXDUXRUWSFXPVVEUXTUXBUXCUXRUWSUXAXQXRYAXSWKUWNUXGUKZOUWP
        XTZYBZULZKUPFVVIUPZUXKVVIURZUXMUSZUXPVVFVVIKVRZVVHULZKVVFOVVMVVHVVFVUMO
        VVMVOAVUMBUXGQYCOKYDWOYEVVFKVTUPZVVGKUSZVVGVCUPZVVNKUPAVVOBUXGAVUMVVOQO
        KUUAWOYCUWQVVPUWNUXFUWOKUWPUUBYFVVFUXQUWOVVGUWPUUCZVVQUWNUXQUXGUYDVPVVF
        UWPUWOUUDZVVRUWQVVSUWNUXFUWOKUWPUUEZYFZUWOUWPUUFWCUWOVVGUWPUUGWKVVGKVVM
        VVMWHUUHWEXGVVFUYQUXIDVVGUTZVVJAUYQBUXGTYCVVFVWBUWTGUWOUTZUXFVWCUWNUWQU
        XEUWTGUWOUWTUXDYKUUIUUJVVFVVSVWBVWCXJVWAUXIUWTDGUWOUWPUXHUWSFXPUUKWOYGD
        OVVGFUULYHVVFVVLUJUMZUXKUOZUXMUPZUJVVIUTZVVFVWGEUXCUPZGJUTZCVVIUTZVVFVW
        HCVVIUTZGJUTZVWJVVFVWKGUWOUTZVWKGJNUUMZUTZVWLUWNUWQUXFVWMUWNUWQUKZUXEVW
        KGUWOUWNUWQGUYEUWQGVHVIVWPUYFUKZUWTUXDVWKVWQUWTUKZUXDUYSUXCUPZCUWSUTZVW
        KVWRUXDVWDUXAUOZUXCUPZUJUWSUTZVWTVWRUXAYIUWSUXAYJZUSUXDVXCXJCOEYLVWRUWS
        OVXDVWRVUMUWSKUPUWSOUSVWRAVUMABUWQUYFUWTUUNZQWOVWRUWOKUWRUWPUWNUWQUYFUW
        TUUOZVWPUYFUWTUUPZUUQUWSKOUURWKVWRVULVXDOVOVWRAUYGVULVXEVWRUWOJUWRUYHVX
        GUUSVUPWKZCOEVUIYMWOUVBUJUWSUXCUXAYNYOVXBVWSUJCUWSCVXAUXCCOEVWDWTYTVWSU
        JVHVWDUYRVOZVXAUYSUXCVWDUYRUXAXCYPYQUUTVWRVUJCVVIUTZVWTVWSCVVIUTZVWKVVI
        OUSVWRVULVXJOVVHVJZVXHVUJCVVIOYRUVAVWRVVIUWSUSVWTVXKUVLVWRVVIVVHUWSOVVH
        VDVWRUWSVVGUPZVVHUWSUSVWRVVSUYFVXMVWRUWQVVSVXFVVTWOVXGUWOUWRUWPUVMWKUWS
        VVGUVCWOUVDVWSCVVIUWSYRWOVXJVXKUKVUJVWSUKZCVVIUTVWKVUJVWSCVVIUVEVXNVWHC
        VVIUYRVVIUPZVUJVWSVWHVXOVUJUKZVWSVWHVXPUYSEUXCVXOVUEVUJVUGVVIOUYRVXLVKZ
        VURUVFYPUVGYSUVHUVIUVJUVKYSUVNUWBUWNVWOUXGUWNVWKGVWNUYEUWNUWRVWNUPZVWKU
        WNVXRUKZVWKVXJUWNAUYGVXJVXRABYKUWRJNUVOVUHVUJCVVIVXOVUHVUEVUJVXQVUQXMWQ
        UVPVXSUXCVUIVOZVWKVXJXJUFVXTVWHVUJCVVIUXCVUIEXPUVQWOYGXNXOVPVWLVWKGUWOV
        WNUWCZUTVWMVWOUKVWKGVYAJJNUVRUVSVWKGUWOVWNUVTUWAYHVWHCGVVIJUWDWFVVFVVAV
        WGVWJXJAVVABUXGRYCVWGVUAUXMUPZCVVIUTVVAVWJVWFVYBUJCVVICVWEUXMCOUXJVWDWT
        YTVYBUJVHVXIVWEVUAUXMVWDUYRUXKXCYPYQVVAVYBVWICVVIVVAVXOUKZVYBUXJUXMUPZV
        WIVYCVUAUXJUXMVXOVUEVUSVUTVVAVXQVVBVVCUWEYPVVAVYDVWIXJVXOGJEUXCMXHVPUWF
        UWGUWHWOYGVVFUXKYIVVIUXKYJZUSVVLVWGXJCOUXJYLVVFOVVIVYEVXLVVFVUSCOUTZVYE
        OVOAVYFBUXGAVUSCOAVVAVUSRVVBWOUWIYCCOUXJWMYMWOUWLUJVVIUXMUXKYNYOYGUXOVV
        JVVLUKDVVIKUXHVVIVOZUXIVVJUXNVVLUXHVVIFXPVYGUXLVVKUXMUXHVVIUXKXQXRYAUWJ
        UWKUWM $.
    $}

    $( If every projection of a function is continuous at ` D ` , then the
       function itself is continuous at ` D ` into the product topology.
       (Contributed by Mario Carneiro, 3-Feb-2015.)  (Revised by Mario
       Carneiro, 22-Aug-2015.) $)
    ptcnp $p |- ( ph -> ( x e. X |-> ( k e. I |-> A ) ) e.
      ( ( J CnP K ) ` D ) ) $=
      ( cfv wcel wa vf vz vg vn vw va cmpt ccnp co cv cuni cixp wf cima wrex wi
      wss wfn wral wceq cdif cfn w3a ctopon adantr ctop ffvelrnda eqid toptopon
      wex sylib cnpf2 syl3anc fmpt sylibr r19.21bi an32s ralrimiva wb mptelixpg
      cab syl mpbird fmptd wal df-3an nfcv nfmpt1 nfmpt nffv nfel1 nfan simprll
      simprlr fveq2 eleq12d rspccva sylan simprrl simpld simprd eqeq12d simprrr
      nfv unieqd cbvixpv syl6eleq ptcnplem anassrs expr rexlimdvaa impr sylan2b
      eleq2 eqeq2i biimpi sseq2d anbi2d rexbidv imbi12d expimpd exlimdv alrimiv
      syl5ibrcom eqeq1 exbidv ralab cpt ctg ptval syl2anc syl5eq feqmptd fveq2d
      ffn pttopon eqeltrd tgcnp mpbir2and ) ABKEGCUGZUGZDHIUHUIRSKEGEUJZFRZUKZU
      LZUUAUMDUUARZUAUJZSZDUBUJZSZUUAUUIUNZUUGUQZTZUBHUOZUPZUAUCUJZGURZUDUJZUUP
      RZUURFRZSZUDGUSZUUSUUTUKZUTZUDGUEUJZVAZUSZUEVBUOZVCZUFUJZUDGUUSULZUTZTZUC
      VJZUFWAZUSZABKYTUUEUUAABUJKSZTZYTUUESZCUUDSZEGUSZUVRUVTEGAUUBGSZUVQUVTAUW
      BTZUVTBKUWCKUUDBKCUGZUMZUVTBKUSUWCHKVDRSZUUCUUDVDRSZUWDDHUUCUHUIRSUWEAUWF
      UWBMVEUWCUUCVFSUWGAGVFUUBFOVGUUCUUDUUDVHVIVKZQDUWDHUUCKUUDVLVMBKUUDCUWDUW
      DVHVNVOVPVQVRUVRGJSZUVSUWAVSAUWIUVQNVEEGCUUDJVTWBWCUUAVHWDAUVIUUGUVKUTZTZ
      UCVJZUUOUPZUAWEUVPAUWMUAAUWKUUOUCAUVIUWJUUOAUVITUUOUWJUUFUVKSZUUJUUKEGUUB
      UUPRZULZUQZTZUBHUOZUPZUVIAUUQUVBTZUVHTUWTUUQUVBUVHWFAUXAUVHUWTAUXATZUVGUW
      TUEVBUXBUVEVBSZUVGTZUWNUWSAUXAUXDUWNTZUWSAUXAUXETZBUBCDEFUUPGHIJUVEKLMNOP
      QUXAUXEEUXAEXDUXDUWNEUXDEXDEUUFUVKEDUUAEBKYTEKWGEGCWHWIEDWGWJWKWLWLAUUQUV
      BUXEWMAUXFTZUVBUWBUWOUUCSZAUUQUVBUXEWNUVAUXHUDUUBGUURUUBUTZUUSUWOUUTUUCUU
      RUUBUUPWOZUURUUBFWOZWPWQWRUXGUXCUVGAUXAUXDUWNWSZWTUXGUVGUUBUVFSUWOUUDUTZU
      XGUXCUVGUXLXAUVDUXMUDUUBUVFUXIUUSUWOUVCUUDUXJUXIUUTUUCUXKXEXBWQWRUXGUUFUV
      KUWPAUXAUXDUWNXCUDEGUUSUWOUXJXFZXGXHXIXJXKXLXMUWJUUHUWNUUNUWSUUGUVKUUFXNU
      WJUUMUWRUBHUWJUULUWQUUJUWJUUGUWPUUKUWJUUGUWPUTUVKUWPUUGUXNXOXPXQXRXSXTYDY
      AYBYCUVNUWLUUOUAUFUVJUUGUTZUVMUWKUCUXOUVLUWJUVIUVJUUGUVKYEXRYFYGVOAUBUAUV
      ODUUAHIKUUEMAIFYHRZUVOYIRZLAUWIFGURZUXPUXQUTNAGVFFUMUXROGVFFYOWBUFUDUEGUV
      OUCFJUVOVHYJYKYLAIEGUUCUGZYHRZUUEVDRZAIUXPUXTLAFUXSYHAEGVFFOYMYNYLAUWIUWG
      EGUSUXTUYASNAUWGEGUWHVREGUUDUXTUUCJUXTVHYPYKYQPYRYS $.
  $}

  ${
    $d h x z A $.  $d h x z B $.  $d h x z C $.  $d h x z F $.  $d h x z G $.
    $d h z D $.  $d z P $.  $d z Q $.
    upxp.1 $e |- P = ( 1st |` ( B X. C ) ) $.
    upxp.2 $e |- Q = ( 2nd |` ( B X. C ) ) $.
    $( Universal property of the Cartesian product considered as a categorical
       product in the category of sets.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
    upxp $p |- ( ( A e. D /\ F : A --> B /\ G : A --> C ) ->
        E! h ( h : A --> ( B X. C ) /\ F = ( P o. h ) /\ G = ( Q o. h ) ) ) $=
      ( wcel ccom wceq cfv cvv wa wfn c1st c2nd vx vz wf w3a cxp weu cop mptexg
      cmpt eueq sylib 3ad2ant1 ffn adantl wral ffvelrn opelxpi syl2an ralrimiva
      anandirs 3adant1 eqid fmpt syl adantr xpss sseldi 3ad2antl1 adantll fveq1
      cv cres coeq1i fveq1i syl6eq 3ad2ant2 ad2antlr simpr1 fvco3 sylan 3eqtrrd
      fvres 3ad2ant3 eqopi syl12anc fveq2 opeq12d opex fvmpt eqtr4d eqfnfvd crn
      ex wss wfo fo1st fofn ax-mp ssv fnssres mp2an a1i frn fnco syl3anc fveq2d
      3adantl1 fvex op1st syl6eqr fo2nd op2nd 3jca feq1 coeq2 eqeq2d syl5ibrcom
      3anbi123d impbid eubidv mpbird ) ADLZABHUCZACIUCZUDZABCUEZGVKZUCZHEYGMZNZ
      IFYGMZNZUDZGUFYGUAAUAVKZHOZYNIOZUGZUIZNZGUFZYBYCYTYDYBYRPLYTUAAYQDUHGYRUJ
      UKULYEYMYSGYEYMYSYEYMYSYEYMQZUBAYGYRYMYGARZYEYHYJUUBYLAYFYGUMULUNYEYRARZY
      MYEAYFYRUCZUUCYEYQYFLZUAAUOZUUDYCYDUUFYBYCYDQUUEUAAYCYDYNALZUUEYCUUGQYOBL
      YPCLUUEYDUUGQABYNHUPACYNIUPYOYPBCUQURUTUSVAUAAYFYQYRYRVBZVCUKZAYFYRUMVDZV
      EUUAUBVKZALZQZUUKYGOZUUKHOZUUKIOZUGZUUKYROZUUMUUNPPUEZLZUUNSOZUUONUUNTOZU
      UPNUUNUUQNYMUULUUTYEYHYJUULUUTYLYHUULQYFUUSUUNBCVFAYFUUKYGUPZVGVHVIUUMUUO
      UUKSYFVLZYGMZOZUUNUVDOZUVAYMUUOUVFNZYEUULYJYHUVHYLYJUUOUUKYIOUVFUUKHYIVJU
      UKYIUVEEUVDYGJVMVNVOVPVQUUAYHUULUVFUVGNYEYHYJYLVRZAYFUUKUVDYGVSVTUUMUUNYF
      LZUVGUVANYMUULUVJYEYHYJUULUVJYLUVCVHVIZUUNYFSWBVDWAUUMUUPUUKTYFVLZYGMZOZU
      UNUVLOZUVBYMUUPUVNNZYEUULYLYHUVPYJYLUUPUUKYKOUVNUUKIYKVJUUKYKUVMFUVLYGKVM
      VNVOWCVQUUAYHUULUVNUVONUVIAYFUUKUVLYGVSVTUUMUVJUVOUVBNUVKUUNYFTWBVDWAUUNU
      UOUUPPPWDWEUULUURUUQNZUUAUAUUKYQUUQAYRYNUUKNYOUUOYPUUPYNUUKHWFYNUUKIWFWGU
      UHUUOUUPWHWIZUNWJWKWMYEYMYSUUDHEYRMZNZIFYRMZNZUDYEUUDUVTUWBUUIYEHUVDYRMZU
      VSYEUBAHUWCYCYBHARYDABHUMVPYEUVDYFRZUUCYRWLYFWNZUWCARUWDYESPRZYFPWNZUWDPP
      SWOUWFWPPPSWQWRYFWSZPYFSWTXAXBUUJYEUUDUWEUUIAYFYRXCVDZYFAUVDYRXDXEYEUULQZ
      UUKUWCOZUURUVDOZUUQUVDOZUUOYEUUDUULUWKUWLNUUIAYFUUKUVDYRVSVTUWJUURUUQUVDU
      ULUVQYEUVRUNZXFUWJUWMUUQSOZUUOUWJUUQYFLZUWMUWONYCYDUULUWPYBYCYDUULUWPYCUU
      LQUUOBLUUPCLUWPYDUULQABUUKHUPACUUKIUPUUOUUPBCUQURUTXGZUUQYFSWBVDUUOUUPUUK
      HXHZUUKIXHZXIVOWAWKEUVDYRJVMXJYEIUVLYRMZUWAYEUBAIUWTYDYBIARYCACIUMWCYEUVL
      YFRZUUCUWEUWTARUXAYETPRZUWGUXAPPTWOUXBXKPPTWQWRUWHPYFTWTXAXBUUJUWIYFAUVLY
      RXDXEUWJUUKUWTOZUURUVLOZUUQUVLOZUUPYEUUDUULUXCUXDNUUIAYFUUKUVLYRVSVTUWJUU
      RUUQUVLUWNXFUWJUXEUUQTOZUUPUWJUWPUXEUXFNUWQUUQYFTWBVDUUOUUPUWRUWSXLVOWAWK
      FUVLYRKVMXJXMYSYHUUDYJUVTYLUWBAYFYGYRXNYSYIUVSHYGYREXOXPYSYKUWAIYGYRFXOXP
      XRXQXSXTYA $.
  $}

  ${
    $d r s x z F $.  $d r s x z G $.  $d r s w x y z R $.  $d r s w x y z S $.
    $d r s y z H $.  $d r s x y z U $.  $d x y z W $.
    txcnmpt.1 $e |- W = U. U $.
    txcnmpt.2 $e |- H = ( x e. W |-> <. ( F ` x ) , ( G ` x ) >. ) $.
    $( A map into the product of two topological spaces is continuous if both
       of its projections are continuous.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    txcnmpt $p |- ( ( F e. ( U Cn R ) /\ G e. ( U Cn S ) )
                 -> H e. ( U Cn ( R tX S ) ) ) $=
      ( vz vr vs co wcel wa wral cfv wb ctop ccn ctx cuni wf ccnv cv cima cmpt2
      cxp crn cop eqid cnf adantr ffvelrnda opelxpi syl2anc fmptd cin mptpreima
      adantl crab wfn elpreima 3syl ibar bitr4d ad2antrr anbi12d opelxp 3bitr4g
      ffn elin rabbi2dva wss wceq cdm inss1 cnvimass sstri syl5sseq dfss1 sylib
      fdm eqtr3d syl5eq cntop1 cnima ad2ant2r ad2ant2l inopn syl3anc ralrimivva
      syl eqeltrd cvv xpex rgen2w imaeq2 eleq1d ralrnmpt2 ax-mp sylibr toptopon
      vex ctopon ctg cntop2 txval syl2an txtopon tgcn mpbir2and ) EDBUANOZFDCUA
      NOZPZGDBCUBNZUANOHBUCZCUCZUIZGUDGUEZKUFZUGZDOZKLMBCLUFZMUFZUIZUHZUJZQZXPA
      HAUFZERZYKFRZUKZXTGXPYKHOZPYLXROYMXSOYNXTOXPHXRYKEXNHXREUDZXOEDBHXRIXRULZ
      UMUNZUOXPHXSYKFXOHXSFUDZXNFDCHXSIXSULZUMVAZUOYLYMXRXSUPUQJURXPYAYGUGZDOZM
      CQLBQZYJXPUUCLMBCXPYEBOZYFCOZPZPZUUBEUEYEUGZFUEYFUGZUSZDUUHUUBYNYGOZAHVBZ
      UUKAHYNYGGJUTUUHHUUKUSZUUMUUKUUHUULAHUUKUUHYOPZYKUUIOZYKUUJOZPYLYEOZYMYFO
      ZPYKUUKOUULUUOUUPUURUUQUUSUUOUUPYOUURPZUURUUOYPEHVCUUPUUTSUUHYPYOXPYPUUGY
      RUNZUNHXREVLHYKYEEVDVEYOUURUUTSUUHYOUURVFVAVGUUOUUQYOUUSPZUUSUUOYSFHVCUUQ
      UVBSXPYSUUGYOUUAVHHXSFVLHYKYFFVDVEYOUUSUVBSUUHYOUUSVFVAVGVIYKUUIUUJVMYLYM
      YEYFVJVKVNUUHUUKHVOUUNUUKVPUUHEVQZUUKHUUKUUIUVCUUIUUJVREYEVSVTUUHYPUVCHVP
      UVAHXREWDWNWAUUKHWBWCWEWFUUHDTOZUUIDOZUUJDOZUUKDOXPUVDUUGXOUVDXNFDCWGVAZU
      NXNUUEUVEXOUUFYEEDBWHWIXOUUFUVFXNUUEYFFDCWHWJUUIUUJDWKWLWOWMYGWPOZMCQLBQY
      JUUDSUVHLMBCYEYFLXEMXEWQWRYDUUCLMKBCYGYHWPYHULYBYGVPYCUUBDYBYGYAWSWTXAXBX
      CXPKYIGDXQHXTXPUVDDHXFROUVGDHIXDWCXNBTOZCTOZXQYIXGRVPXOEDBXHZFDCXHZLMYIBC
      TTYIULXIXJXNBXRXFROZCXSXFROZXQXTXFROXOXNUVIUVMUVKBXRYQXDWCXOUVJUVNUVLCXSY
      TXDWCBCXRXSXKXJXLXM $.
  $}

  ${
    $d h x z F $.  $d h x z G $.  $d h P $.  $d h Q $.  $d h x R $.  $d h T $.
    $d h x S $.  $d h x z U $.  $d h x z X $.  $d h x z Y $.
    uptx.1 $e |- T = ( R tX S ) $.
    uptx.2 $e |- X = U. R $.
    uptx.3 $e |- Y = U. S $.
    uptx.4 $e |- Z = ( X X. Y ) $.
    uptx.5 $e |- P = ( 1st |` Z ) $.
    uptx.6 $e |- Q = ( 2nd |` Z ) $.
    $( Universal property of the binary topological product.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       22-Aug-2015.) $)
    uptx $p |- ( ( F e. ( U Cn R ) /\ G e. ( U Cn S ) ) ->
                  E! h e. ( U Cn T ) ( F = ( P o. h ) /\ G = ( Q o. h ) ) ) $=
      ( wcel cvv vx vz ccn co ccom wceq wex wmo wreu cuni cfv cop cmpt ctx eqid
      wa cv txcnmpt oveq2i syl6eleqr wf cnf c1st cxp wfn ffn adantr crn wss wfo
      cres fo1st fofn ax-mp ssv fnssres mp2an a1i ffvelrn syl2an anandirs fmptd
      opelxpi syl frn fnco syl3anc fvco3 sylan fveq2 opeq12d opex adantl fveq2d
      fvmpt fvres fvex op1st syl6eq 3eqtrrd eqfnfvd reseq2i coeq1i syl6eqr c2nd
      eqtri fo2nd op2nd jca32 eleq1 coeq2 eqeq2d anbi12d spcegv sylc w3a wi wal
      wb ctop cntop2 txuni unieqi syl6reqr syl5ib anim1d 3anass syl6ibr alrimiv
      feq3 weu cntop1 uniexg upxp eumo moim df-reu eu5 bitri sylanbrc ) HFCUCUD
      SZIFDUCUDSZUPZGUQZFEUCUDZSZHAUUDUEZUFZIBUUDUEZUFZUPZUPZGUGZUULGUHZUUKGUUE
      UIZUUCUAFUJZUAUQZHUKZUUQIUKZULZUMZUUESZUVBHAUVAUEZUFZIBUVAUEZUFZUPZUPZUUM
      UUCUVAFCDUNUDZUCUDUUEUACDFHIUVAUUPUUPUOZUVAUOZUREUVIFUCMUSUTZUUCUVBUVDUVF
      UVLUUAUUPJHVAZUUPKIVAZUVDUUBHFCUUPJUVJNVBZIFDUUPKUVJOVBZUVMUVNUPZHVCJKVDZ
      VKZUVAUEZUVCUVQUBUUPHUVTUVMHUUPVEUVNUUPJHVFVGUVQUVSUVRVEZUVAUUPVEZUVAVHUV
      RVIZUVTUUPVEUWAUVQVCTVEZUVRTVIZUWATTVCVJUWDVLTTVCVMVNUVRVOZTUVRVCVPVQVRUV
      QUUPUVRUVAVAZUWBUVQUAUUPUUTUVRUVAUVMUVNUUQUUPSZUUTUVRSZUVMUWHUPUURJSUUSKS
      UWIUVNUWHUPUUPJUUQHVSUUPKUUQIVSUURUUSJKWCVTWAUVKWBZUUPUVRUVAVFWDZUVQUWGUW
      CUWJUUPUVRUVAWEWDZUVRUUPUVSUVAWFWGUVQUBUQZUUPSZUPZUWMUVTUKZUWMUVAUKZUVSUK
      ZUWMHUKZUWMIUKZULZUVSUKZUWSUVQUWGUWNUWPUWRUFUWJUUPUVRUWMUVSUVAWHWIUWOUWQU
      XAUVSUWNUWQUXAUFUVQUAUWMUUTUXAUUPUVAUUQUWMUFUURUWSUUSUWTUUQUWMHWJUUQUWMIW
      JWKUVKUWSUWTWLWOWMZWNUWOUXBUXAVCUKZUWSUWOUXAUVRSZUXBUXDUFUVMUVNUWNUXEUVMU
      WNUPUWSJSUWTKSUXEUVNUWNUPUUPJUWMHVSUUPKUWMIVSUWSUWTJKWCVTWAZUXAUVRVCWPWDU
      WSUWTUWMHWQZUWMIWQZWRWSWTXAAUVSUVAAVCLVKUVSQLUVRVCPXBXFZXCXDVTUUAUVMUVNUV
      FUUBUVOUVPUVQIXEUVRVKZUVAUEZUVEUVQUBUUPIUXKUVNIUUPVEUVMUUPKIVFWMUVQUXJUVR
      VEZUWBUWCUXKUUPVEUXLUVQXETVEZUWEUXLTTXEVJUXMXGTTXEVMVNUWFTUVRXEVPVQVRUWKU
      WLUVRUUPUXJUVAWFWGUWOUWMUXKUKZUWQUXJUKZUXAUXJUKZUWTUVQUWGUWNUXNUXOUFUWJUU
      PUVRUWMUXJUVAWHWIUWOUWQUXAUXJUXCWNUWOUXPUXAXEUKZUWTUWOUXEUXPUXQUFUXFUXAUV
      RXEWPWDUWSUWTUXGUXHXHWSWTXABUXJUVABXELVKUXJRLUVRXEPXBXFZXCXDVTXIUULUVHGUV
      AUUEUUDUVAUFZUUFUVBUUKUVGUUDUVAUUEXJUXSUUHUVDUUJUVFUXSUUGUVCHUUDUVAAXKXLU
      XSUUIUVEIUUDUVABXKXLXMXMXNXOUUCUULUUPUVRUUDVAZUUHUUJXPZXQZGXRUYAGUHZUUNUU
      CUYBGUUCUULUXTUUKUPUYAUUCUUFUXTUUKUUFUUPEUJZUUDVAZUUCUXTUUDFEUUPUYDUVJUYD
      UOVBUUCUYDUVRUFZUYEUXTXSUUACXTSZDXTSZUYFUUBHFCYAIFDYAUYGUYHUPUVRUVIUJUYDC
      DJKNOYBEUVIMYCYDVTUYDUVRUUPUUDYJWDYEYFUXTUUHUUJYGYHYIUUCUYAGYKZUYCUUCUUPT
      SZUVMUVNUYIUUAUYJUUBUUAFXTSUYJHFCYLFXTYMWDVGUUAUVMUUBUVOVGUUBUVNUUAUVPWMU
      UPJKTABGHIUXIUXRYNWGUYAGYOWDUULUYAGYPXOUUOUULGYKUUMUUNUPUUKGUUEYQUULGYRYS
      YT $.
  $}

  ${
    $d R h x y $.  $d S h x y $.  $d T h x y $.  $d U h x y $.  $d W h x y $.
    $d X h x y $.  $d Y h x y $.  $d Z h x y $.  $d P h x y $.  $d Q h x y $.
    $d F h x y $.
    txcn.1 $e |- X = U. R $.
    txcn.2 $e |- Y = U. S $.
    txcn.3 $e |- Z = ( X X. Y ) $.
    txcn.4 $e |- W = U. U $.
    txcn.5 $e |- P = ( 1st |` Z ) $.
    txcn.6 $e |- Q = ( 2nd |` Z ) $.
    $( A map into the product of two topological spaces is continuous iff both
       of its projections are continuous.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 22-Aug-2015.) $)
    txcn $p |- ( ( R e. Top /\ S e. Top /\ F : W --> Z ) ->
         ( F e. ( U Cn ( R tX S ) ) <-> ( ( P o. F ) e. ( U Cn R ) /\
                                          ( Q o. F ) e. ( U Cn S ) ) ) ) $=
      ( vh wcel wf wa ctop w3a ctx co ccn ccom wi ctopon cfv toptopon c1st cres
      cxp reseq2i eqtri tx1cn syl5eqel c2nd tx2cn cnco anim12dan expcom syl2anc
      syl2anb 3adant3 wceq weu wex cntop1 ad2antrl topopn syl cnf ad2antll upxp
      cv wb feq3 ax-mp 3anbi1i eubii sylibr syl3anc euex cvv wmo simpll3 adantr
      xpexg syl2an ad2antrr fex2 eumo simpr 3anass coeq2 eqcoms biantrud bitr3d
      feq1 syl5bb moi2 syl22anc wreu eqid uptx adantl df-reu sylbi txuni syl5eq
      jca cuni syl5ibr anim1d syl6ibr simpl a1i jcad eximdv syl5 mpd eupick imp
      eqeltrrd exlimddv ex impbid ) CUARZDUARZGJFSZUBZFECDUCUDZUEUDZRZAFUFZECUE
      UDRZBFUFZEDUEUDRZTZYIYJYOYTUGZYKYICHUHUIRZDIUHUIRZUUAYJCHKUJDILUJUUBUUCTZ
      AYMCUEUDZRZBYMDUEUDZRZUUAUUDAUKHIUMZULZUUEAUKJULUUJOJUUIUKMUNUOZCDHIUPUQU
      UDBURUUIULZUUGBURJULUULPJUUIURMUNUOZCDHIUSUQYOUUFUUHTYTYOUUFYQUUHYSFAEYMC
      UTFBEYMDUTVAVBVCVDVEYLYTYOYLYTTZGJQVPZSZYPAUUOUFVFZYRBUUOUFVFZUBZYOQUUNUU
      SQVGZUUSQVHUUNGERZGHYPSZGIYRSZUUTUUNEUARZUVAYQUVDYLYSYPECVIVJEGNVKVLZYQUV
      BYLYSYPECGHNKVMVJYSUVCYLYQYREDGINLVMVNUVAUVBUVCUBGUUIUUOSZUUQUURUBZQVGUUT
      GHIEABQYPYRUUKUUMVOUUSUVGQUUPUVFUUQUURJUUIVFUUPUVFVQMJUUIGUUOVRVSVTWAWBWC
      ZUUSQWDVLUUNUUSTZUUOFYNUVIFWERZUUSQWFZUUSYKUUOFVFZUVIYKUVAJWERZUVJYIYJYKY
      TUUSWGZUUNUVAUUSUVEWHYLUVMYTUUSYIYJUVMYKYIHCRZIDRZUVMYJCHKVKDILVKUVOUVPTJ
      UUIWEMHICDWIUQWJVEWKGJFEWEWLWCUUNUVKUUSUUNUUTUVKUVHUUSQWMVLWHUUNUUSWNUVNU
      USYKQFWEUUSUUPUUQUURTZTZUVLYKUUPUUQUURWOZUVLUUPUVRYKUVLUVQUUPUVQFUUOFUUOV
      FUUQUURFUUOAWPFUUOBWPXLWQWRGJUUOFWTWSXAXBXCUUNUUSUUOYNRZUUNUUTUUSUVTTZQVH
      ZUUSUVTUGUVHUUNUVQQYNXDZUWBYTUWCYLABCDYMEQYPYRHIJYMXEKLMOPXFXGUWCUVTUVQTZ
      QVHZUUNUWBUWCUWDQVGUWEUVQQYNXHUWDQWDXIUUNUWDUWAQUUNUWDUUSUVTUUNUWDUVRUUSU
      UNUVTUUPUVQUVTUUPUUNGYMXMZUUOSZUUOEYMGUWFNUWFXEVMUUNJUWFVFZUUPUWGVQYLUWHY
      TYIYJUWHYKYIYJTJUUIUWFMCDHIKLXJXKVEWHJUWFGUUOVRVLXNXOUVSXPUWDUVTUGUUNUVTU
      VQXQXRXSXTYAYBUUSUVTQYCVCYDYEYFYGYH $.
  $}

  ${
    $d k x F $.  $d k x z I $.  $d k z J $.  $d k x z ph $.  $d k x z X $.
    $d z A $.  $d x z K $.  $d k x V $.
    ptcn.2 $e |- K = ( Xt_ ` F ) $.
    ptcn.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    ptcn.4 $e |- ( ph -> I e. V ) $.
    ptcn.5 $e |- ( ph -> F : I --> Top ) $.
    ptcn.6 $e |- ( ( ph /\ k e. I ) ->
      ( x e. X |-> A ) e. ( J Cn ( F ` k ) ) ) $.
    $( If every projection of a function is continuous, then the function
       itself is continuous into the product topology.  (Contributed by Mario
       Carneiro, 3-Feb-2015.) $)
    ptcn $p |- ( ph -> ( x e. X |-> ( k e. I |-> A ) ) e. ( J Cn K ) ) $=
      ( wcel cfv wa adantr ctop vz cmpt ccn co cuni wf cv ccnp wral cixp ctopon
      ffvelrnda eqid toptopon sylib cnf2 syl3anc fmpt sylibr r19.21bi ralrimiva
      an32s mptelixpg syl mpbird wceq ptuni syl2anc eleqtrd fmptd simpr adantlr
      simplr toponuni ad2antrr cncnpi ptcnp cpt pttop syl5eqel cncnp mpbir2and
      wb ) ABJDFCUBZUBZGHUCUDPZJHUEZWEUFZWEUAUGZGHUHUDQPZUAJUIZABJWDWGWEABUGJPZ
      RZWDDFDUGZEQZUEZUJZWGWMWDWQPZCWPPZDFUIZWMWSDFAWNFPZWLWSAXARZWSBJXBJWPBJCU
      BZUFZWSBJUIXBGJUKQPZWOWPUKQPZXCGWOUCUDPZXDAXEXALSXBWOTPXFAFTWNENULWOWPWPU
      MUNUOOXCGWOJWPUPUQBJWPCXCXCUMURUSUTVBVAWMFIPZWRWTWCAXHWLMSDFCWPIVCVDVEAWQ
      WGVFZWLAXHFTEUFZXIMNDFEHIKVGVHSVIWEUMVJAWJUAJAWIJPZRZBCWIDEFGHIJKAXEXKLSA
      XHXKMSAXJXKNSAXKVKXLXARZXGWIGUEZPXCWIGWOUHUDQPAXAXGXKOVLXMWIJXNAXKXAVMAJX
      NVFZXKXAAXEXOLJGVNVDVOVIWIXCGWOXNXNUMVPVHVQVAAXEHWGUKQPZWFWHWKRWCLAHTPXPA
      HEVRQZTKAXHXJXQTPMNFEIVSVHVTHWGWGUMUNUOUAWEGHJWGWAVHWB $.
  $}

  ${
    $d g x y z I $.  $d g x y z R $.  $d y V $.  $d g x y z W $.  $d g x y Y $.
    $d g x y ph $.  $d x y S $.
    prdstopn.y $e |- Y = ( S Xs_ R ) $.
    prdstopn.s $e |- ( ph -> S e. V ) $.
    prdstopn.i $e |- ( ph -> I e. W ) $.
    ${
      prdstopn.r $e |- ( ph -> R Fn I ) $.
      prdstopn.o $e |- O = ( TopOpen ` Y ) $.
      $( Topology of a structure product.  (Contributed by Mario Carneiro,
         27-Aug-2015.) $)
      prdstopn $p |- ( ph -> O = ( Xt_ ` ( TopOpen o. R ) ) ) $=
        ( vy cfv ctopn wss wceq cvv wcel vg vz vx cts ccom cpt cbs cpw cdm fnex
        wfn syl2anc eqid eqidd prdstset cuni cv wral cdif cfn wrex w3a cixp wex
        wa cab ctg wf topnfn dffn2 sylib fnfco sylancr ptval unieqd fvco2 sylan
        simpl2 crest co topnval restsspw eqsstr3i syl6eqss fvex syl6ib ralimdva
        sseld elpw imp sylan2 ss2ixp syl simprr prdsbas2 adantr 3sstr4d exlimdv
        ex vex syl6ibr abssdv pwex ssex unitg 3syl eqtrd sspwuni eqsstrd sylibr
        topnid syl6eqr eqtr3d ) AHUDOZEPBUEZUFOZAXNHPOZEAXNHUGOZUHZQXNXQRAXNXPX
        SAXRHBCBUIZXNFSIJABDUKZDGTZBSTLKDGBUJULXRUMZAXTUNXNUMZUOZAXPUPZXRQXPXSQ
        AYFUAUQZDUKZNUQZYGOZYIXOOZTZNDURZYJYKUPRNDUBUQUSURUBUTVAZVBZUCUQZNDYJVC
        ZRZVEZUAVDZUCVFZUPZXRAYFUUAVGOZUPZUUBAXPUUCAYBXODUKZXPUUCRKAPSUKDSBVHZU
        UEVIAYAUUFLDBVJVKSDPBVLVMUCNUBDUUAUAXOGUUAUMVNULVOAUUAXSQZUUASTUUDUUBRA
        YTUCXSAYTYPXRQZYPXSTAYSUUHUAAYSUUHAYSVEZYQNDYIBOZUGOZVCZYPXRUUIYJUUKQZN
        DURZYQUULQYSAYMUUNYHYMYNYRVRAYMUUNAYLUUMNDAYIDTZVEZYLYJUUKUHZTUUMUUPYKU
        UQYJUUPYKUUJPOZUUQAYAUUOYKUURRLDPBYIVPVQUURUUJUDOZUUKVSVTUUQUUKUUSUUJUU
        KUMUUSUMWAUUKUUSWBWCWDWHYJUUKYIYGWEWIWFWGWJWKNDYJUUKWLWMAYOYRWNAXRUULRY
        SANXRBCDFGHIYCJKLWOWPWQWSWRYPXRUCWTWIXAXBZUUAXSXRHUGWEXCXDUUASXEXFXGAUU
        GUUBXRQUUTUUAXRXHVKXIXPXRXHXJXIXRXNHYCYDXKWMMXLYEXM $.
    $}

    prdstps.r $e |- ( ph -> R : I --> TopSp ) $.
    $( A structure product of topologies is a topological space.  (Contributed
       by Mario Carneiro, 27-Aug-2015.) $)
    prdstps $p |- ( ph -> Y e. TopSp ) $=
      ( vx cfv ctopon wcel ctps ctopn cpt eqid cvv cts cbs cv cmpt cixp wral wa
      ffvelrnda istps sylib ralrimiva pttopon syl2anc ccom fex cdm wceq fdm syl
      wf prdstset wfn topnfn dffn2 mpbi wss ssv fss sylancl fcompt fveq2d eqtrd
      sylancr prdsbas 3eltr4d tsettps ) AGUAMZGUBMZNMZOGPOALDLUCZBMZQMZUDZRMZLD
      WAUBMZUEZNMZVQVSADFOZWBWENMOZLDUFWDWGOJAWILDAVTDOUGWAPOWIADPVTBKUHWEWBWAW
      ESWBSUIUJUKLDWEWDWBFWDSULUMAVQQBUNZRMWDAVRGBCDVQETHIADPBUTZWHBTOKJDPFBUOU
      MZVRSZAWKBUPDUQKDPBURUSZVQSZVAAWJWCRATTQUTZDTBUTZWJWCUQQTVBWPVCTQVDVEAWKP
      TVFWQKPVGDPTBVHVILQBDTTVJVMVKVLAVRWFNALVRGBCDETHIWLWMWNVNVKVOVRVQGWMWOVPU
      S $.
  $}

  ${
    pwstps.y $e |- Y = ( R ^s I ) $.
    $( A structure product of topologies is a topological space.  (Contributed
       by Mario Carneiro, 27-Aug-2015.) $)
    pwstps $p |- ( ( R e. TopSp /\ I e. V ) -> Y e. TopSp ) $=
      ( ctps wcel wa csca cfv csn cxp cprds co eqid pwsval cvv fvex a1i simpr
      wf fconst6g adantr prdstps eqeltrd ) AFGZBCGZHZDAIJZBAKLZMNZFAUIBFCDEUIOP
      UHUJUIBQCUKUKOUIQGUHAIRSUFUGTUFBFUJUAUGBAFUBUCUDUE $.
  $}

  ${
    $d r s u v x V $.  $d r s u v x W $.  $d r s u v x X $.  $d r s u v x Y $.
    $d r s u v w x A $.  $d r s u v w x B $.  $d r s u v w x R $.
    $d r s u v w x S $.
    $( The subspace of a topological product space induced by a subset with a
       Cartesian product representation is a topological product of the
       subspaces induced by the subspaces of the terms of the products.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 2-Sep-2015.) $)
    txrest $p |- ( ( ( R e. V /\ S e. W ) /\ ( A e. X /\ B e. Y ) ) ->
      ( ( R tX S ) |`t ( A X. B ) ) = ( ( R |`t A ) tX ( S |`t B ) ) ) $=
      ( vu vv vr vs wcel wa co crest cv wceq cvv wrex vx vw ctx cxp crn ctg cfv
      cmpt2 eqid txval adantr oveq1d txbasex xpexg tgrest syl2an cab cin elrest
      wb vex inex1 ad2ant2r xpeq1 eqeq2d rexbidv ad2ant2l xpeq2 adantl rexxfr2d
      a1i sylan9bbr wral xpex rgen2w ineq1 inxp syl6eq rexrnmpt2 syl6bbr bitr4d
      ax-mp abbi2dv rnmpt2 syl6eqr fveq2d 3eqtr2d ovex mp2an ) CEMZDFMZNZAGMZBH
      MZNZNZCDUCOZABUDZPOZIJCAPOZDBPOZIQZJQZUDZUHZUEZUFUGZWTXAUCOZWPWSKLCDKQZLQ
      ZUDZUHZUEZUFUGZWRPOZXMWRPOZUFUGZXGWPWQXNWRPWLWQXNRWOKLXMCDEFXMUIZUJUKULWL
      XMSMZWRSMZXQXORWOKLXMCDEFXRUMZABGHUNZWRXMSSUOUPWPXPXFUFWPXPUAQZXDRZJXATZI
      WTTZUAUQXFWPYFUAXPWPYCXPMZYCUBQZWRURZRZUBXMTZYFWLXSXTYGYKUTWOYAYBUBYCWRXM
      SSUSUPWPYFYCXIAURZXJBURZUDZRZLDTZKCTZYKWPYEYPIKYLWTCSYLSMWPXICMNXIAKVAZVB
      VKWJWMXBWTMXBYLRZKCTUTWKWNKXBACEGUSVCYSYEYCYLXCUDZRZJXATWPYPYSYDUUAJXAYSX
      DYTYCXBYLXCVDVEVFWPUUAYOJLYMXADSYMSMWPXJDMNXJBLVAZVBVKWKWNXCXAMXCYMRZLDTU
      TWJWMLXCBDFHUSVGUUCUUAYOUTWPUUCYTYNYCXCYMYLVHVEVIVJVLVJXKSMZLDVMKCVMYKYQU
      TUUDKLCDXIXJYRUUBVNVOYJYOKLUBCDXKXLSXLUIYHXKRZYIYNYCUUEYIXKWRURYNYHXKWRVP
      XIXJABVQVRVEVSWBVTWAWCIJUAWTXAXDXEXEUIWDWEWFWGWTSMXASMXHXGRCAPWHDBPWHIJXF
      WTXASSXFUIUJWIWE $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y V $.  $d x y W $.
    $( The topological product of discrete spaces is discrete.  (Contributed by
       Mario Carneiro, 14-Aug-2015.) $)
    txdis $p |- ( ( A e. V /\ B e. W ) -> ( ~P A tX ~P B ) = ~P ( A X. B ) ) $=
      ( vx vy vz vw wcel wa cpw cxp cuni wss wceq ctop distop unipw cv csn wrex
      ctx eqcomi txuni syl2an eqimss2 syl sspwuni sylibr wral c1st cfv c2nd cop
      co elelpwi adantl xp1st snelpwi 3syl xp2nd vex snid sneqd syl5eleq simprl
      1st2nd2 eqeltrrd snssd xpeq1 eleq2d sseq1d anbi12d xpeq2 fvex xpsn syl6eq
      rspc2ev syl112anc expr ralrimdva wb eltx sylibrd ssrdv eqssd ) ACIZBDIZJZ
      AKZBKZUBUOZABLZKZWIWLMZWMNZWLWNNWIWMWOOZWPWGWJPIZWKPIZWQWHACQZBDQZWJWKABW
      JMAARUCWKMBBRUCUDUEWOWMUFUGWLWMUHUIWIEWNWLWIESZWNIZFSZGSZHSZLZIZXGXBNZJZH
      WKUAGWJUAZFXBUJZXBWLIZWIXCXKFXBWIXDXBIZXCXKWIXNXCJZJZXDUKULZTZWJIZXDUMULZ
      TZWKIZXDXQXTUNZTZIZYDXBNZXKXPXDWMIZXQAIXSXOYGWIXDXBWMUPUQZXDABURXQAUSUTXP
      YGXTBIYBYHXDABVAXTBUSUTXPXDXDTYDXDFVBVCXPXDYCXPYGXDYCOYHXDABVGUGZVDVEXPYC
      XBXPXDYCXBYIWIXNXCVFVHVIXJYEYFJXDXRXFLZIZYJXBNZJGHXRYAWJWKXEXROZXHYKXIYLY
      MXGYJXDXEXRXFVJZVKYMXGYJXBYNVLVMXFYAOZYKYEYLYFYOYJYDXDYOYJXRYALYDXFYAXRVN
      XQXTXDUKVOXDUMVOVPVQZVKYOYJYDXBYPVLVMVRVSVTWAWGWRWSXMXLWBWHWTXAGHXBWJWKPP
      FWCUEWDWEWF $.

    $( Lemma for ~ txindis .  (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    txindislem $p |- ( ( _I ` A ) X. ( _I ` B ) ) = ( _I ` ( A X. B ) ) $=
      ( cvv wcel cid cfv cxp wceq wn c0 0xp fvprc xpeq1d wa simpr xpeq2d syl6eq
      xp0 fvi syl fveq2d 0ex ax-mp wne cdm dmexg eleq1d syl5ib con3d pm2.61dane
      dmxp impcom 3eqtr4a crn rnexg rnxp xpeq12 syl2an xpexg eqtr4d ecase ) ACD
      ZBCDZAEFZBEFZGZABGZEFZHVBIZJVEGJVFVHVEKVIVDJVEAELMVIVHJHZBJVIBJHZNZVHJEFZ
      JVLVGJEVLVGAJGJVLBJAVIVKOPARQUAJCDVMJHUBJCSUCZQVIBJUDZNVGCDZIZVJVOVIVQVOV
      PVBVPVGUEZCDVOVBVGCUFVOVRACABUKUGUHUIULVGELZTUJUMVCIZVDJGJVFVHVDRVTVEJVDB
      ELPVTVJAJVTAJHZNZVHVMJWBVGJEWBVGJBGJWBAJBVTWAOMBKQUAVNQVTAJUDZNVQVJWCVTVQ
      WCVPVCVPVGUNZCDWCVCVGCUOWCWDBCABUPUGUHUIULVSTUJUMVBVCNZVFVGVHVBVDAHVEBHVF
      VGHVCACSBCSVDAVEBUQURWEVPVHVGHABCCUSVGCSTUTVA $.

    $( The topological product of indiscrete spaces is indiscrete.
       (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    txindis $p |- ( { (/) , A } tX { (/) , B } ) = { (/) , ( A X. B ) } $=
      ( vx vy vz vw c0 cpr cid cfv cxp cv wcel wceq wo wn wss wa ctop wne co wi
      ctx wex neq0 wrex wral wb indistop eltx mp2an sylbi cuni elssuni indisuni
      rsp txunii syl6sseqr ad2antrr ne0i ad2antrl sylibr simpld neneqd indislem
      xpnz simpll syl6eleqr elpri syl ord simprd simplr xpeq12d simprr eqsstr3d
      mpd adantll eqssd ex rexlimdvva syld exlimdv syl5bi orrd vex ssriv ctopon
      elpr toptopon txtopon topgele ax-mp simpli eqssi txindislem preq2i 3eqtri
      cpw mpbi ) GAHZGBHZUCUAZGAIJZBIJZKZHZGABKZIJZHGXHHXCXGCXCXGCLZXCMZXJGNZXJ
      XFNZOXJXGMXKXLXMXLPDLZXJMZDUDXKXMDXJUEXKXOXMDXKXOXNELZFLZKZMZXRXJQZRZFXBU
      FEXAUFZXMXKYBDXJUGZXOYBUBXASMZXBSMZXKYCUHAUIZBUIZEFXJXAXBSSDUJUKYBDXJUPUL
      XKYAXMEFXAXBXKXPXAMZXQXBMZRZRZYAXMYKYARXJXFXKXJXFQYJYAXKXJXCUMXFXJXCUNXAX
      BXDXEYFYGAUOZBUOZUQURUSYJYAXFXJQXKYJYARZXFXRXJYNXPXDXQXEYNXPGNZPXPXDNZYNX
      PGYNXPGTZXQGTZYNXRGTZYQYRRXSYSYJXTXRXNUTVAXPXQVFVBZVCVDYNYOYPYNXPGXDHZMYO
      YPOYNXPXAUUAYHYIYAVGAVEVHXPGXDVIVJVKVQYNXQGNZPXQXENZYNXQGYNYQYRYTVLVDYNUU
      BUUCYNXQGXEHZMUUBUUCOYNXQXBUUDYHYIYAVMBVEVHXQGXEVIVJVKVQVNYJXSXTVOVPVRVSV
      TWAWBWCWDWEXJGXFCWFWIVBWGXGXCQZXCXFWSQZXCXFWHJMZUUEUUFRXAXDWHJMZXBXEWHJMZ
      UUGYDUUHYFXAXDYLWJWTYEUUIYGXBXEYMWJWTXAXBXDXEWKUKXCXFWLWMWNWOXFXIGABWPWQX
      HVEWR $.
  $}

  ${
    $d a b m n u v x y z F $.  $d a b u v x z J $.  $d a b m n u v x y z X $.
    $d m n u x y z K $.  $d m n u x z ph $.  $d b m n u x y Y $.
    txdis1cn.x $e |- ( ph -> X e. V ) $.
    txdis1cn.j $e |- ( ph -> J e. ( TopOn ` Y ) ) $.
    txdis1cn.k $e |- ( ph -> K e. Top ) $.
    txdis1cn.f $e |- ( ph -> F Fn ( X X. Y ) ) $.
    txdis1cn.1 $e |- ( ( ph /\ x e. X ) ->
      ( y e. Y |-> ( x F y ) ) e. ( J Cn K ) ) $.
    $( A function is jointly continuous on a discrete left topology iff it is
       continuous as a function of its right argument, for each fixed left
       value.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    txdis1cn $p |- ( ph -> F e. ( ( ~P X tX J ) Cn K ) ) $=
      ( vv va co wcel cv wa vu vb vz vn cpw ctx ccn cxp cuni ccnv cima wral wfn
      vm wf cmpt ctopon cfv adantr ctop eqid toptopon sylib cnf2 syl3anc sylibr
      fmpt ralrimiva sylanbrc wss wrex cab wrel cdm cnvimass wceq fndm syl5sseq
      ffnov syl relxp relss ee10 wb elpreima opelxp df-ov eqcomi eleq1i anbi12i
      cop csn simprll snelpwi mptpreima adantrr ad2ant2r simplr cnima syl5eqelr
      crab syl2anc simprlr simprr vex snid mpbiran weq oveq2 eleq1d elrab bitri
      a1i snssd sselda elrabi ad2antll elsni ad2antrl syl5eqr simprbi ad3antrrr
      oveq1d eqeltrd mpbir2and syl5bi relssdv xpeq1 eleq2d sseq1d anbi12d xpeq2
      ex rspc2ev syl112anc opex eleq1 anbi1d 2rexbidv elab sylbid distopon eltx
      ssabral mpbird txtopon iscn ) ADHUEZEUFQZFUGQRZHIUHZFUIZDUOZDUJUASZUKZUUI
      RZUAFULZADUUKUMZBSZCSZDQZUULRCIULZBHULUUMMAUVBBHAUUSHRZTZIUULCIUVAUPZUOZU
      VBUVDEIUQURZRZFUULUQURRZUVEEFUGQRZUVFAUVHUVCKUSAUVIUVCAFUTRUVILFUULUULVAV
      BVCZUSNUVEEFIUULVDVECIUULUVAUVEUVEVAZVGVFVHBCHIUULDVSVIAUUPUAFAUUNFRZTZUU
      POSZPSZUBSZUHZRZUVRUUOVJZTZUBEVKPUUHVKZOUUOULZUVNUUOUWBOVLZVJUWCUVNBUCUUO
      UWDUVNUUOUUKVJUUKVMUUOVMUVNDVNZUUOUUKDUUNVOUVNUURUWEUUKVPAUURUVMMUSZUUKDV
      QVTVRHIWAUUOUUKWBWCUVNUUSUCSZWKZUUORZUWHUUKRZUWHDURZUUNRZTZUWHUWDRZUVNUUR
      UWIUWMWDUWFUUKUWHUUNDWEVTUWMUVCUWGIRZTZUUSUWGDQZUUNRZTZUVNUWNUWJUWPUWLUWR
      UUSUWGHIWFUWKUWQUUNUWQUWKUUSUWGDWGWHWIWJUVNUWSUWNUVNUWSTZUWHUVRRZUVTTZUBE
      VKPUUHVKZUWNUWTUUSWLZUUHRZUVAUUNRZCIXAZERUWHUXDUXGUHZRZUXHUUOVJZUXCUWTUVC
      UXEUVNUVCUWOUWRWMZUUSHWNVTUWTUXGUVEUJUUNUKZECIUVAUUNUVEUVLWOUWTUVJUVMUXLE
      RAUWPUVJUVMUWRAUVCUVJUWONWPWQAUVMUWSWRUUNUVEEFWSXBWTUWTUWOUWRUXIUVNUVCUWO
      UWRXCUVNUWPUWRXDUXIUWGUXGRZUWOUWRTUXIUUSUXDRUXMUUSBXEXFUUSUWGUXDUXGWFXGUX
      FUWRCUWGICUCXHUVAUWQUUNUUTUWGUUSDXIXJXKXLVIUWTUDUNUXHUUOUXHVMUWTUXDUXGWAX
      MUDSZUNSZWKZUXHRUXNUXDRZUXOUXGRZTZUWTUXPUUORZUXNUXOUXDUXGWFUWTUXSUXTUWTUX
      STZUXTUXPUUKRZUXPDURZUUNRZUYAUXNHRZUXOIRZUYBUWTUXQUYEUXRUWTUXDHUXNUWTUUSH
      UXKXNXOWPUXRUYFUWTUXQUXFCUXOIXPXQUXNUXOHIWFVIUYAUYCUUSUXODQZUUNUYAUYCUXNU
      XODQUYGUXNUXODWGUYAUXNUUSUXODUXQUDBXHUWTUXRUXNUUSXRXSYCXTUXRUYGUUNRZUWTUX
      QUXRUYFUYHUXFUYHCUXOICUNXHUVAUYGUUNUUTUXOUUSDXIXJXKYAXQYDAUXTUYBUYDTWDZUV
      MUWSUXSAUURUYIMUUKUXPUUNDWEVTYBYEYMYFYGUXBUXIUXJTUWHUXDUVQUHZRZUYJUUOVJZT
      PUBUXDUXGUUHEUVPUXDVPZUXAUYKUVTUYLUYMUVRUYJUWHUVPUXDUVQYHZYIUYMUVRUYJUUOU
      YNYJYKUVQUXGVPZUYKUXIUYLUXJUYOUYJUXHUWHUVQUXGUXDYLZYIUYOUYJUXHUUOUYPYJYKY
      NYOUWBUXCOUWHUUSUWGYPUVOUWHVPZUWAUXBPUBUUHEUYQUVSUXAUVTUVOUWHUVRYQYRYSYTV
      FYMYFUUAYGUWBOUUOUUDVCUVNUUHHUQURZRZUVHUUPUWCWDAUYSUVMAHGRUYSJHGUUBVTZUSA
      UVHUVMKUSPUBUUOUUHEUYRUVGOUUCXBUUEVHAUUIUUKUQURRZUVIUUJUUMUUQTWDAUYSUVHVU
      AUYTKUUHEHIUUFXBUVKUADUUIFUUKUULUUGXBYE $.
  $}

  ${
    $d a b j k r s u v x y z A $.  $d a b j k r s u v x y z R $.
    $d a b k r s u v x y z S $.
    txlly.1 $e |- ( ( j e. A /\ k e. A ) -> ( j tX k ) e. A ) $.
    $( If the property ` A ` is preserved under topological products, then so
       is the property of being locally ` A ` .  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    txlly $p |- ( ( R e. Locally A /\ S e. Locally A ) ->
      ( R tX S ) e. Locally A ) $=
      ( vy vz vx vu vr vs wcel wa co ctop cv crest wrex wss vv clly ctx cpw cin
      wral llytop txtop syl2an cxp eltx c1st cfv w3a c2nd simprll simprrl xp1st
      simpll syl llyi syl3anc simplr simprlr reeanv ad3antrrr ad3antlr syl22anc
      xp2nd txopn simprl1 simprr1 xpss12 syl2anc simprrr sylan9ssr elpw2 sylibr
      vex elin sylanbrc cop wceq 1st2nd2 adantr simprl2 simprr2 opelxpi eqeltrd
      adantl txrest simprl3 simprr3 caovcl eleq2 eleq1d anbi12d rspcev syl12anc
      oveq2 expr rexlimdvva syl5bir mp2and ralimdv sylbid ralrimiv islly ) BAUB
      ZMZCXIMZNZBCUCOZPMZGQZHQZMZXMXPROZAMZNZHXMIQZUDZUEZSZGYAUFZIXMUFXMXIMXJBP
      MZCPMZXNXKABUGZACUGZBCUHUIXLYEIXMXLYAXMMXOJQZUAQZUJZMZYLYATZNZUACSJBSZGYA
      UFYEJUAYABCXIXIGUKXLYPYDGYAXLYOYDJUABCXLYJBMZYKCMZNZYOYDXLYSYONZNZKQZYJTZ
      XOULUMZUUBMZBUUBROZAMZUNZKBSZLQZYKTZXOUOUMZUUJMZCUUJROZAMZUNZLCSZYDUUAXJY
      QUUDYJMZUUIXJXKYTUSXLYQYRYOUPUUAYMUURXLYSYMYNUQZXOYJYKURUTKAUUDYJBVAVBUUA
      XKYRUULYKMZUUQXJXKYTVCXLYQYRYOVDUUAYMUUTUUSXOYJYKVIUTLAUULYKCVAVBUUIUUQNU
      UHUUPNZLCSKBSUUAYDUUHUUPKLBCVEUUAUVAYDKLBCUUAUUBBMZUUJCMZNZUVAYDUUAUVDUVA
      NZNZUUBUUJUJZYCMZXOUVGMZXMUVGROZAMZYDUVFUVGXMMZUVGYBMZUVHUVFYFYGUVBUVCUVL
      XJYFXKYTUVEYHVFZXKYGXJYTUVEYIVGZUUAUVBUVCUVAUPZUUAUVBUVCUVAVDZUUBUUJBCPPV
      JVHUVFUVGYATUVMUVEUUAUVGYLYAUVEUUCUUKUVGYLTUUCUUEUUGUUPUVDVKUUKUUMUUOUUHU
      VDVLUUBYJUUJYKVMVNXLYSYMYNVOVPUVGYAIVSVQVRUVGXMYBVTWAUVFXOUUDUULWBZUVGUUA
      XOUVRWCZUVEUUAYMUVSUUSXOYJYKWDUTWEUVEUVRUVGMZUUAUVEUUEUUMUVTUUCUUEUUGUUPU
      VDWFUUKUUMUUOUUHUVDWGUUDUULUUBUUJWHVNWJWIUVFUVJUUFUUNUCOZAUVFYFYGUVBUVCUV
      JUWAWCUVNUVOUVPUVQUUBUUJBCPPBCWKVHUVEUWAAMZUUAUVEUUGUUOUWBUUCUUEUUGUUPUVD
      WLUUKUUMUUOUUHUVDWMDEUUFUUNAUCFWNVNWJWIXTUVIUVKNHUVGYCXPUVGWCZXQUVIXSUVKX
      PUVGXOWOUWCXRUVJAXPUVGXMRWTWPWQWRWSXAXBXCXDXAXBXEXFXGIGHAXMXHWA $.

    $( If the property ` A ` is preserved under topological products, then so
       is the property of being n-locally ` A ` .  (Contributed by Mario
       Carneiro, 13-Apr-2015.) $)
    txnlly $p |- ( ( R e. N-Locally A /\ S e. N-Locally A ) ->
      ( R tX S ) e. N-Locally A ) $=
      ( vy vr va vs vb wcel wa co ctop cv wrex wss ad2antrr syl2anc vz vx vu vv
      cnlly ctx crest csn cnei cfv cpw cin wral nllytop txtop cxp eltx c1st w3a
      syl2an c2nd simpll simprll simprrl xp1st syl nlly2i syl3anc simprlr xp2nd
      simplr reeanv wi cuni ad3antrrr adantr simprrr txopn syl22anc cop 1st2nd2
      wceq simprl1 simprr1 opelxpi eqeltrd opnneip simprl2 simprr2 xpss12 sstrd
      elpwid elssuni eqid txuni sseqtrd ssnei2 vex elpw2 sylibr sylanbrc txrest
      elin simprl3 simprr3 caovcl oveq2 eleq1d rspcev anassrs rexlimdvva mp2and
      ex syl5bir expr ralimdv sylbid ralrimiv isnlly ) BAUEZLZCXTLZMZBCUFNZOLZY
      DUAPZUGNZALZUAGPZUHZYDUIUJUJZUBPZUKZULZQZGYLUMZUBYDUMYDXTLYABOLZCOLZYEYBA
      BUNZACUNZBCUOUTZYCYPUBYDYCYLYDLYIUCPZUDPZUPZLZUUDYLRZMZUDCQUCBQZGYLUMYPUC
      UDYLBCXTXTGUQYCUUHYOGYLYCUUGYOUCUDBCYCUUBBLZUUCCLZMZUUGYOYCUUKUUGMZMZYIUR
      UJZHPZLZUUOIPZRZBUUQUGNZALZUSZHBQZIUUBUKZQZYIVAUJZJPZLZUVFKPZRZCUVHUGNZAL
      ZUSZJCQZKUUCUKZQZYOUUMYAUUIUUNUUBLZUVDYAYBUULVBYCUUIUUJUUGVCZUUMUUEUVPYCU
      UKUUEUUFVDZYIUUBUUCVEVFHAUUNUUBBIVGVHUUMYBUUJUVEUUCLZUVOYAYBUULVKZYCUUIUU
      JUUGVIZUUMUUEUVSUVRYIUUBUUCVJVFJAUVEUUCCKVGVHUVDUVOMUVBUVMMZKUVNQIUVCQUUM
      YOUVBUVMIKUVCUVNVLUUMUWBYOIKUVCUVNUWBUVAUVLMZJCQHBQUUMUUQUVCLZUVHUVNLZMZM
      ZYOUVAUVLHJBCVLUWGUWCYOHJBCUUMUWFUUOBLZUVFCLZMZUWCYOVMUUMUWFUWJMZMZUWCYOU
      WLUWCMZUUQUVHUPZYNLZYDUWNUGNZALZYOUWMUWNYKLZUWNYMLZUWOUWMYEUUOUVFUPZYKLZU
      WTUWNRZUWNYDVNZRUWRYCYEUULUWKUWCUUAVOZUWMYEUWTYDLZYIUWTLUXAUXDUWMYQYRUWHU
      WIUXEUUMYQUWKUWCYAYQYBUULYSSSZUUMYRUWKUWCUUMYBYRUVTYTVFSZUWLUWHUWCUUMUWFU
      WHUWIVDVPUWLUWIUWCUUMUWFUWHUWIVQVPUUOUVFBCOOVRVSUWMYIUUNUVEVTZUWTUWMUUEYI
      UXHWBUUMUUEUWKUWCUVRSYIUUBUUCWAVFUWMUUPUVGUXHUWTLUUPUURUUTUVLUWLWCUVGUVIU
      VKUVAUWLWDUUNUVEUUOUVFWETWFYIYDUWTWGVHUWMUURUVIUXBUUPUURUUTUVLUWLWHUVGUVI
      UVKUVAUWLWIUUOUUQUVFUVHWJTUWMUWNBVNZCVNZUPZUXCUWMUUQUXIRUVHUXJRUWNUXKRUWM
      UUQUUBUXIUWMUUQUUBUWLUWDUWCUUMUWDUWEUWJVCVPZWLZUWMUUIUUBUXIRUUMUUIUWKUWCU
      VQSUUBBWMVFWKUWMUVHUUCUXJUWMUVHUUCUWLUWEUWCUUMUWDUWEUWJVIVPZWLZUWMUUJUUCU
      XJRUUMUUJUWKUWCUWASUUCCWMVFWKUUQUXIUVHUXJWJTUWMYQYRUXKUXCWBUXFUXGBCUXIUXJ
      UXIWNUXJWNWOTWPYJYDUWNUWTUXCUXCWNWQVSUWMUWNYLRUWSUWMUWNUUDYLUWMUUQUUBRUVH
      UUCRUWNUUDRUXMUXOUUQUUBUVHUUCWJTUUMUUFUWKUWCYCUUKUUEUUFVQSWKUWNYLUBWRWSWT
      UWNYKYMXCXAUWMUWPUUSUVJUFNZAUWMYQYRUWDUWEUWPUXPWBUXFUXGUXLUXNUUQUVHBCOOUV
      CUVNXBVSUWMUUTUVKUXPALUUPUURUUTUVLUWLXDUVGUVIUVKUVAUWLXEDEUUSUVJAUFFXFTWF
      YHUWQUAUWNYNYFUWNWBYGUWPAYFUWNYDUGXGXHXITXMXJXKXNXKXNXLXOXKXPXQXRUBGUAAYD
      XSXA $.
  $}

  ${
    $d k m n x y z A $.  $d k m n u v x y z F $.  $d k m n x y z V $.
    $( The product of a collection of Hausdorff spaces is Hausdorff.
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    pthaus $p |- ( ( A e. V /\ F : A --> Haus ) -> ( Xt_ ` F ) e. Haus ) $=
      ( vx vy vu vv vk vz wcel cha wa cfv ctop cv c0 wceq wrex wral syl cpt wne
      vm vn wf cin w3a wi cuni wss haustop ssriv fss mpan2 pttop sylan2 wfn weq
      wn cixp simprl eqid ptuni adantr eleqtrrd ixpfn simprr syl2anc necon3abid
      wb eqfnfv rexnal df-ne simpllr ffvelrnd vex elixp simprbi adantrr hausnei
      r19.21bi syl13anc crab cmpt ccn simp-4l ad4antlr ptpjcn syl3anc ccnv cima
      co simprll mptpreima cnima syl5eqelr simprlr ad2antrr simprr1 fveq1 elrab
      eleq1d sylanbrc simprr2 inrab simprr3 inelcm necon2bi rabeq0 sylibr eleq2
      ralrimivw syl5eq ineq1 eqeq1d 3anbi13d ineq2 rspc2ev syl113anc rexlimdvva
      3anbi23d expr mpd syl5bir rexlimdva sylbid ralrimivva ishaus ) ACJZAKBUEZ
      LZBUAMZNJZDOZEOZUBZYNFOZJZYOGOZJZYQYSUFZPQZUGZGYLRFYLRZUHZEYLUIZSDUUFSYLK
      JYJYIANBUEZYMYJKNUJUUGDKNYNUKULAKNBUMUNZABCUOUPYKUUEDEUUFUUFYKYNUUFJZYOUU
      FJZLZLZYPHOZYNMZUUMYOMZQZHASZUSZUUDUULUUQYNYOUULYNAUQZYOAUQZDEURUUQVJUULY
      NHAUUMBMZUIZUTZJZUUSUULYNUUFUVCYKUUIUUJVAZYKUVCUUFQZUUKYJYIUUGUVFUUHHABYL
      CYLVBZVCUPVDZVEZHAUVBYNVFTUULYOUVCJZUUTUULYOUUFUVCYKUUIUUJVGZUVHVEZHAUVBY
      OVFTHAYNYOVKVHVIUURUUPUSZHARUULUUDUUPHAVLUULUVMUUDHAUVMUUNUUOUBZUULUUMAJZ
      LUUDUUNUUOVMUULUVOUVNUUDUULUVOUVNLZLZUUNUCOZJZUUOUDOZJZUVRUVTUFZPQZUGZUDU
      VARUCUVARZUUDUVQUVAKJUUNUVBJZUUOUVBJZUVNUWEUVQAKUUMBYIYJUUKUVPVNUULUVOUVN
      VAZVOUULUVOUWFUVNUULUWFHAUULUVDUWFHASZUVIUVDUUSUWIHAUVBYNDVPVQVRTWAVSUULU
      VOUWGUVNUULUWGHAUULUVJUWGHASZUVLUVJUUTUWJHAUVBYOEVPVQVRTWAVSUULUVOUVNVGUU
      NUUOUDUCUVAUVBUVBVBVTWBUVQUWDUUDUCUDUVAUVAUVQUVRUVAJZUVTUVAJZLZUWDUUDUVQU
      WMUWDLZLZUUMIOZMZUVRJZIUUFWCZYLJZUWQUVTJZIUUFWCZYLJZYNUWSJZYOUXBJZUWSUXBU
      FZPQZUUDUWOIUUFUWQWDZYLUVAWEWLJZUWKUWTUWOYIUUGUVOUXIYIYJUUKUVPUWNWFYJUUGY
      IUUKUVPUWNUUHWGUVQUVOUWNUWHVDIABUUMYLCUUFUUFVBZUVGWHWIZUVQUWKUWLUWDWMUXIU
      WKLUWSUXHWJZUVRWKYLIUUFUWQUVRUXHUXHVBZWNUVRUXHYLUVAWOWPVHUWOUXIUWLUXCUXKU
      VQUWKUWLUWDWQUXIUWLLUXBUXLUVTWKYLIUUFUWQUVTUXHUXMWNUVTUXHYLUVAWOWPVHUWOUU
      IUVSUXDUULUUIUVPUWNUVEWRUVSUWAUWCUWMUVQWSUWRUVSIYNUUFIDURUWQUUNUVRUUMUWPY
      NWTXBXAXCUWOUUJUWAUXEUULUUJUVPUWNUVKWRUVSUWAUWCUWMUVQXDUXAUWAIYOUUFIEURUW
      QUUOUVTUUMUWPYOWTXBXAXCUWOUXFUWRUXALZIUUFWCZPUWRUXAIUUFXEUWOUXNUSZIUUFSUX
      OPQUWOUXPIUUFUWOUWCUXPUVSUWAUWCUWMUVQXFUXNUWBPUWQUVRUVTXGXHTXLUXNIUUFXIXJ
      XMUUCUXDUXEUXGUGUXDYTUWSYSUFZPQZUGFGUWSUXBYLYLYQUWSQZYRUXDUUBUXRYTYQUWSYN
      XKUXSUUAUXQPYQUWSYSXNXOXPYSUXBQZYTUXEUXRUXGUXDYSUXBYOXKUXTUXQUXFPYSUXBUWS
      XQXOYAXRXSYBXTYCYBYDYEYDYFYGDEGFYLUUFUXJYHXC $.
  $}

  ${
    $d k u v x A $.  $d k u v x y z B $.  $d k u v x y z F $.  $d v x y z K $.
    $d k u v J $.  $d k u v x V $.  $d k u v x X $.
    ptrescn.1 $e |- X = U. J $.
    ptrescn.2 $e |- J = ( Xt_ ` F ) $.
    ptrescn.3 $e |- K = ( Xt_ ` ( F |` B ) ) $.
    $( Restriction is a continuous function on product topologies.
       (Contributed by Mario Carneiro, 7-Feb-2015.) $)
    ptrescn $p |- ( ( A e. V /\ F : A --> Top /\ B C_ A ) ->
      ( x e. X |-> ( x |` B ) ) e. ( J Cn K ) ) $=
      ( vv vk vu vy wcel ctop cfv wceq cvv vz wf wss w3a cv cres cmpt cuni ccnv
      ccn co cima csn cmpt2 crn cun wral wa simpl3 ptuni 3adant3 syl6eqr eleq2d
      cixp biimpar resixp syl2anc ixpeq2 fvres unieqd mprg ssexg ancoms 3adant2
      fssres 3adant1 syl5eqr adantr eleqtrd eqid fmptd fimacnv syl cpt syl5eqel
      pttop topopn eqeltrd elsni imaeq2d eleq1d syl5ibrcom ralrimiv wrex wi wal
      ccom imaco cnvco adantlr eqidd fveq1 fmptco ad2antrl eqtrd cnveqd imaeq1d
      simpl1 simpl2 simprl sseldd ptpjcn syl3anc simprr cnima imaeq2 rexlimdvva
      mpteq2dv alrimiv cab rnmpt2 raleqi rexeqdv eqeq1 sylan9bbr rexbidva ralab
      rexbidv bitri sylibr ralunb sylanbrc ctopon sylib snex fvex abrexex rgenw
      toptopon abrexex2g sylancl unexg sylancr cfi ptval2 subbascn mpbir2and
      ctg ) BGPZBQDUBZCBUCZUDZAHAUEZCUFZUGZEFUJUKPHFUHZUUOUBZUUOUIZLUEZULZEPZLU
      UPUMZMNCMUEZDCUFZRZUAUUPUVCUAUEZRZUGZUIZNUEZULZUNZUOZUPZUQZUULAHUUNUUPUUO
      UULUUMHPZURZUUNMCUVCDRZUHZVDZUUPUVQUUKUUMMBUVSVDZPZUUNUVTPUUIUUJUUKUVPUSU
      ULUWBUVPUULUWAHUUMUULUWAEUHZHUUIUUJUWAUWCSUUKMBDEGJUTVAIVBVCVEMBCUVSUUMVF
      VGUULUVTUUPSUVPUULUVTMCUVEUHZVDZUUPUWDUVSSUWEUVTSMCMCUWDUVSVHUVCCPZUVEUVR
      UVCCDVIZVJVKUULCTPZCQUVDUBZUWEUUPSUUIUUKUWHUUJUUKUUIUWHCBGVLVMVNZUUJUUKUW
      IUUIBQCDVOVPZMCUVDFTKUTVGVQVRVSZUUOVTWAZUULUVALUVBUQUVALUVMUQZUVOUULUVALU
      VBUULUVAUUSUVBPZUURUUPULZEPUULUWPHEUULUUQUWPHSUWMHUUPUUOWBWCUULEQPZHEPUUI
      UUJUWQUUKUUIUUJUREDWDRQJBDGWFWEVAZEHIWGWCWHUWOUUTUWPEUWOUUSUUPUURUUSUUPWI
      WJWKWLWMUULUUSUVKSZNUVRWNZMCWNZUVAWOZLWPZUWNUULUXBLUULUWSUVAMNCUVRUULUWFU
      VJUVRPZURZURZUVAUWSUURUVKULZEPUXFUXGAHUVCUUMRZUGZUIZUVJULZEUXFUXGUURUVIWQ
      ZUVJULUXKUURUVIUVJWRUXFUXLUXJUVJUXFUXLUVHUUOWQZUIUXJUVHUUOWSUXFUXMUXIUXFU
      XMAHUVCUUNRZUGUXIUXFAUAHUUPUUNUVGUXNUUOUVHUULUVPUUNUUPPUXEUWLWTUXFUUOXAUX
      FUVHXAUVCUVFUUNXBXCUXFAHUXNUXHUWFUXNUXHSUULUXDUVCCUUMVIXDXRXEXFVQXGVQUXFU
      XIEUVRUJUKPZUXDUXKEPUXFUUIUUJUVCBPUXOUUIUUJUUKUXEXHUUIUUJUUKUXEXIUXFCBUVC
      UUIUUJUUKUXEUSUULUWFUXDXJXKABDUVCEGHIJXLXMUULUWFUXDXNUVJUXIEUVRXOVGWHUWSU
      UTUXGEUUSUVKUURXPWKWLXQXSUWNUVALOUEZUVKSZNUVEWNZMCWNZOXTZUQUXCUVALUVMUXTM
      NOCUVEUVKUVLUVLVTZYAZYBUXSUXAUVALOUXPUUSSZUXRUWTMCUWFUXRUXQNUVRWNUYCUWTUW
      FUXQNUVEUVRUWGYCUYCUXQUWSNUVRUXPUUSUVKYDYHYEYFYGYIYJUVALUVBUVMYKYLUULLUVN
      UUOEFTHUUPUULUWQEHYMRPUWREHIYSYNUULUVBTPUVMTPUVNTPUUPYOUULUVMUXTTUYBUULUW
      HUXROXTTPZMCUQUXTTPUWJUYDMCNOUVEUVKUVCUVDYPYQYRUXRMOCTTYTUUAWEUVBUVMTTUUB
      UUCUULUWHUWIFUVNUUDRUUHRSUWJUWKUANCMUVDUVLFTUUPKUUPVTZUYAUUEVGUULFQPFUUPY
      MRPUULFUVDWDRZQKUULUWHUWIUYFQPUWJUWKCUVDTWFVGWEFUUPUYEYSYNUUFUUG $.
  $}

  ${
    $d f t u v x y A $.  $d f t u v x y R $.  $d f t u v x y S $.  $d u Y $.
    $d f t u v x ph $.  $d f t u v x y U $.  $d f t u v x X $.
    txtube.x $e |- X = U. R $.
    txtube.y $e |- Y = U. S $.
    txtube.r $e |- ( ph -> R e. Comp ) $.
    txtube.s $e |- ( ph -> S e. Top ) $.
    txtube.w $e |- ( ph -> U e. ( R tX S ) ) $.
    txtube.u $e |- ( ph -> ( X X. { A } ) C_ U ) $.
    txtube.a $e |- ( ph -> A e. Y ) $.
    $( The "tube lemma".  If ` X ` is compact and there is an open set ` U `
       containing the line ` X X. { A } ` , then there is a "tube" ` X X. u `
       for some neighborhood ` u ` of ` A ` which is entirely contained within
       ` U ` .  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    txtube $p |- ( ph -> E. u e. S ( A e. u /\ ( X X. u ) C_ U ) ) $=
      ( vv wcel wss wa wrex vt vf vx vy cv cuni wceq wf cfv cxp wex cpw cfn cin
      wral ccmp cop csn adantr id snidg syl opelxpi syl2anr sseldd co ctop eltx
      ctx wb syl2anc mpbid eleq1 anbi1d 2rexbidv rspcv sylc opelxp anbi1i anass
      bitri rexbii r19.42v sylib ralrimiva eleq2 xpeq2 anbi12d cmpcovf crn cint
      sseq1d c0 rint0 adantl topopn ad3antrrr eqeltrd wne simprrl frn simpr wfo
      inss2 simplr sseldi wfn ffn dffn4 fofi w3a fiinopn imp syl13anc syl6sseqr
      elssuni dfss1 pm2.61dane ad2antrr ciin simprrr simpl ralimi eliin fniinfv
      mpbird eleqtrd elin sylanbrc ciun simprl uniiun syl6eq xpeq1d xpiundir wi
      iinss2 eqsstr3d syl5ss xpss2 sstr2 ralimdva iunss sylibr eqsstrd syl12anc
      3syl rspcev expr exlimdv expimpd rexlimdva mpd ) AGUAUEZUFZUGZUUNEUBUEZUH
      ZCBUEZUUQUIZQZUUSUUTUJZFRZSZBUUNUOZSZUBUKZSZUADULZUMUNZTZCUUSQZGUUSUJZFRZ
      SZBETZADUPQZUCUEZUUSQZCPUEZQZUUSUVTUJZFRZSZPETSZBDTZUCGUOUVKKAUWFUCGAUVRG
      QZSZUVRCUQZUWBQZUWCSZPETZBDTZUWFUWHUWIFQUDUEZUWBQZUWCSZPETBDTZUDFUOZUWMUW
      HGCURZUJZFUWIAUWTFRUWGNUSUWGUWGCUWSQZUWIUWTQAUWGUTACHQZUXAOCHVAVBUVRCGUWS
      VCVDVEAUWRUWGAFDEVIVFQZUWRMAUVQEVGQZUXCUWRVJKLBPFDEUPVGUDVHVKVLUSUWQUWMUD
      UWIFUWNUWIUGZUWPUWKBPDEUXEUWOUWJUWCUWNUWIUWBVMVNVOVPVQUWLUWEBDUWLUVSUWDSZ
      PETUWEUWKUXFPEUWKUVSUWASZUWCSUXFUWJUXGUWCUVRCUUSUVTVRVSUVSUWAUWCVTWAWBUVS
      UWDPEWCWAWBWDWEUWDUVDUCBPEUBDGUAIUVTUUTUGZUWAUVAUWCUVCUVTUUTCWFUXHUWBUVBF
      UVTUUTUUSWGWLWHWIVKAUVHUVPUAUVJAUUNUVJQZSZUUPUVGUVPUXJUUPSUVFUVPUBUXJUUPU
      VFUVPUXJUUPUVFSZSZHUUQWJZWKZUNZEQZCUXOQZGUXOUJZFRZUVPUXLUXPUXMWMUXLUXMWMU
      GZSUXOHEUXTUXOHUGUXLHUXMWNWOAHEQZUXIUXKUXTAUXDUYALEHJWPVBWQWRUXLUXMWMWSZS
      ZUXOUXNEUYCUXNHRUXOUXNUGUYCUXNEUFZHUYCUXNEQZUXNUYDRUYCUXDUXMERZUYBUXMUMQZ
      UYEAUXDUXIUXKUYBLWQUXLUYFUYBUXLUURUYFUXJUUPUURUVEWTZUUNEUUQXAVBUSUXLUYBXB
      UXLUYGUYBUXLUUNUMQUUNUXMUUQXCZUYGUXLUVJUMUUNUVIUMXDAUXIUXKXEXFUXLUUQUUNXG
      ZUYIUXLUURUYJUYHUUNEUUQXHVBZUUNUUQXIWDUUNUXMUUQXJVKUSUXDUYFUYBUYGXKUYEUXM
      EXLXMXNZUXNEXPVBJXOUXNHXQWDUYLWRXRUXLUXBCUXNQUXQAUXBUXIUXKOXSZUXLCBUUNUUT
      XTZUXNUXLCUYNQZUVABUUNUOZUXLUVEUYPUXJUUPUURUVEYAZUVDUVABUUNUVAUVCYBYCVBUX
      LUXBUYOUYPVJUYMBCUUNUUTHYDVBYFUXLUYJUYNUXNUGZUYKBUUNUUQYEZVBYGCHUXNYHYIUX
      LUXRBUUNUUSUXOUJZYJZFUXLUXRBUUNUUSYJZUXOUJVUAUXLGVUBUXOUXLGUUOVUBUXJUUPUV
      FYKBUUNYLYMYNBUUNUUSUXOYOYMUXLUYTFRZBUUNUOZVUAFRUXLUYJUVCBUUNUOZVUDUYKUXL
      UVEVUEUYQUVDUVCBUUNUVAUVCXBYCVBUYJUVCVUCBUUNUYJUUSUUNQZSZUXOUUTRUYTUVBRUV
      CVUCYPVUGUXOUXNUUTHUXNXDVUGUXNUYNUUTUYJUYRVUFUYSUSVUFUYNUUTRUYJBUUNUUTYQW
      OYRYSUXOUUTUUSYTUYTUVBFUUAUUGUUBVQBUUNUYTFUUCUUDUUEUVOUXQUXSSBUXOEUUSUXOU
      GZUVLUXQUVNUXSUUSUXOCWFVUHUVMUXRFUUSUXOGWGWLWHUUHUUFUUIUUJUUKUULUUM $.
  $}

  ${
    $d f k r s t u x y A $.  $d f r s t u v w x y z S $.  $d f u v w x z Y $.
    $d f k r s t u v w x z W $.  $d f k r s t u v w x z X $.
    $d f k r s t u w x z ph $.  $d f k r s t u x y R $.
    txcmp.x $e |- X = U. R $.
    txcmp.y $e |- Y = U. S $.
    txcmp.r $e |- ( ph -> R e. Comp ) $.
    txcmp.s $e |- ( ph -> S e. Comp ) $.
    txcmp.w $e |- ( ph -> W C_ ( R tX S ) ) $.
    txcmp.u $e |- ( ph -> ( X X. Y ) = U. W ) $.
    ${
      txcmp.a $e |- ( ph -> A e. Y ) $.
      $( Lemma for ~ txcmp .  (Contributed by Mario Carneiro, 14-Sep-2014.) $)
      txcmplem1 $p |- ( ph -> E. u e. S ( A e. u /\
        E. v e. ( ~P W i^i Fin ) ( X X. u ) C_ U. v ) ) $=
        ( vr wa wrex wcel vt vf vx vk vs vy cv cuni wceq wf csn cxp cfv wss wex
        wral cpw cfn cin ccmp id opelxpi syl2anr adantr eleqtrd eluni2 sylib wi
        cop ctx co sselda wb syl2anc biimpa syldan eleq1 anbi1d 2rexbidv rspccv
        eltx syl opelxp1 ad2antrl opelxp2 snssd xpss2 simprr sstrd ex rexlimdvw
        jca reximdv syld reximdva rexcom r19.42v rexbii bitri ralrimiva cmpcovf
        mpd sseq2 crn ad2antrr ctop cmptop txtop simprrl frn uniopn ciun ss2iun
        simprrr simprl uniiun syl6eq xpeq1d xpiundir syl6req wfn fniunfv txtube
        ffn 3sstr3d vex rnex elpw sylibr wfo inss2 simplr sseldi dffn4 sylanbrc
        fofi elin unieq sseq2d rspcev anim2d expr exlimdv expimpd rexlimdva ) A
        HUAUGZUHZUIZUUFGUBUGZUJZQUGZDUKZULZUUKUUIUMZUNZQUUFUPZRZUBUOZRZUAEUQZUR
        USZSZDCUGZTZHUVCULZBUGZUHZUNZBGUQZURUSZSZRZCFSZAEUTTZUCUGZUUKTZUUMUDUGZ
        UNZUDGSRZQESZUCHUPUVBLAUVTUCHAUVOHTZRZUVPUVRRZQESZUDGSZUVTUWBUVODVIZUVQ
        TZUDGSZUWEUWBUWFGUHZTUWHUWBUWFHIULZUWIUWAUWADITZUWFUWJTAUWAVAPUVODHIVBV
        CAUWJUWIUIUWAOVDVEUDUWFGVFVGUWBUWGUWDUDGUWBUVQGTZRZUWGUWFUUKUEUGZULZTZU
        WOUVQUNZRZUEFSZQESZUWDUWMUFUGZUWOTZUWQRZUEFSQESZUFUVQUPZUWGUWTVHUWBUWLU
        VQEFVJVKZTZUXEUWBGUXFUVQAGUXFUNZUWANVDVLUWBUXGUXEAUXGUXEVMZUWAAUVNFUTTZ
        UXILMQUEUVQEFUTUTUFWAVNVDVOVPUXDUWTUFUWFUVQUXAUWFUIZUXCUWRQUEEFUXKUXBUW
        PUWQUXAUWFUWOVQVRVSVTWBUWMUWSUWCQEUWMUWRUWCUEFUWMUWRUWCUWMUWRRZUVPUVRUW
        PUVPUWMUWQUVODUUKUWNWCWDUXLUUMUWOUVQUXLUULUWNUNUUMUWOUNUXLDUWNUWPDUWNTU
        WMUWQUVODUUKUWNWEWDWFUULUWNUUKWGWBUWMUWPUWQWHWIWLWJWKWMWNWOXBUWEUWCUDGS
        ZQESUVTUWCUDQGEWPUXMUVSQEUVPUVRUDGWQWRWSVGWTUVRUUOUCQUDGUBEHUAJUVQUUNUU
        MXCXAVNAUUSUVMUAUVAAUUFUVATZRZUUHUURUVMUXOUUHRUUQUVMUBUXOUUHUUQUVMUXOUU
        HUUQRZRZUVDUVEUUIXDZUHZUNZRZCFSUVMUXQCDEFUXSHIJKAUVNUXNUXPLXEZAFXFTZUXN
        UXPAUXJUYCMFXGWBXEZUXQUXFXFTZUXRUXFUNUXSUXFTUXQEXFTZUYCUYEUXQUVNUYFUYBE
        XGWBUYDEFXHVNUXQUXRGUXFUXQUUJUXRGUNZUXOUUHUUJUUPXIZUUFGUUIXJWBZAUXHUXNU
        XPNXEWIUXRUXFXKVNUXQQUUFUUMXLZQUUFUUNXLZHUULULZUXSUXQUUPUYJUYKUNUXOUUHU
        UJUUPXNQUUFUUMUUNXMWBUXQUYLQUUFUUKXLZUULULUYJUXQHUYMUULUXQHUUGUYMUXOUUH
        UUQXOQUUFXPXQXRQUUFUUKUULXSXTUXQUUIUUFYAZUYKUXSUIUXQUUJUYNUYHUUFGUUIYDW
        BZQUUFUUIYBWBYEAUWKUXNUXPPXEYCUXQUYAUVLCFUXQUXTUVKUVDUXQUXRUVJTZUXTUVKV
        HUXQUXRUVITZUXRURTZUYPUXQUYGUYQUYIUXRGUUIUBYFYGYHYIUXQUUFURTUUFUXRUUIYJ
        ZUYRUXQUVAURUUFUUTURYKAUXNUXPYLYMUXQUYNUYSUYOUUFUUIYNVGUUFUXRUUIYPVNUXR
        UVIURYQYOUYPUXTUVKUVHUXTBUXRUVJUVFUXRUIUVGUXSUVEUVFUXRYRYSYTWJWBUUAWMXB
        UUBUUCUUDUUEXB $.
    $}

    $( Lemma for ~ txcmp .  (Contributed by Mario Carneiro, 14-Sep-2014.) $)
    txcmplem2 $p |- ( ph -> E. v e. ( ~P W i^i Fin ) ( X X. Y ) = U. v ) $=
      ( vz cuni wceq cfn wss wa wcel vw vf vu vx cv cpw cin wf cxp cfv wral wex
      wrex adantr ctx co simpr txcmplem1 ralrimiva unieq sseq2d cmpcovf syl2anc
      ccmp ciun crn wfn simprrl ffn fniunfv 3syl frn inss1 syl6ss sspwuni sylib
      syl eqsstrd vex fvex iunex sylibr inss2 simplr sseldi fss sylancl ffvelrn
      elpw iunfi elin sylanbrc simprl uniiun syl6eq xpiundi simprrr xpeq2 fveq2
      xpeq2d unieqd sseq12d cbvralv ss2iun ffvelrnda elpwi uniss sseqtr4d iunss
      ad3antrrr eqssd iuncom4 eqeq2d rspcev expr exlimdv expimpd rexlimdva mpd
      ) AGUAUEZOZPZXTEUFZQUGZUBUEZUHZFUCUEZUIZYGYEUJZOZRZUCXTUKZSZUBULZSZUADUFZ
      QUGZUMZFGUIZBUEZOZPZBYDUMZADVDTZUDUEZYGTYHUUARZBYDUMSUCDUMZUDGUKYRKAUUGUD
      GAUUEGTZSBUCUUECDEFGHIACVDTUUHJUNAUUDUUHKUNAECDUOUPRUUHLUNAYSEOZPZUUHMUNA
      UUHUQURUSUUFYKUDUCBYDUBDGUAIYTYIPUUAYJYHYTYIUTVAVBVCAYOUUCUAYQAXTYQTZSZYB
      YNUUCUULYBSYMUUCUBUULYBYMUUCUULYBYMSZSZNXTNUEZYEUJZVEZYDTZYSUUQOZPZUUCUUN
      UUQYCTZUUQQTZUURUUNUUQERUVAUUNUUQYEVFZOZEUUNYFYEXTVGUUQUVDPUULYBYFYLVHZXT
      YDYEVINXTYEVJVKUUNUVCYCRUVDERUUNUVCYDYCUUNYFUVCYDRUVEXTYDYEVLVQYCQVMZVNUV
      CEVOVPVRUUQENXTUUPUAVSUUOYEVTWAWIWBUUNXTQTUUPQTZNXTUKZUVBUUNYQQXTYPQWCAUU
      KUUMWDWEUUNXTQYEUHZUVHUUNYFYDQRUVIUVEYCQWCXTYDQYEWFWGUVIUVGNXTXTQUUOYEWHU
      SVQNXTUUPWJVCUUQYCQWKWLUUNYSNXTUUPOZVEZUUSUUNYSUVKUUNYSNXTFUUOUIZVEZUVKUU
      NYSFNXTUUOVEZUIUVMUUNGUVNFUUNGYAUVNUULYBYMWMNXTWNWOWTNXTUUOFWPWOUUNUVLUVJ
      RZNXTUKZUVMUVKRUUNYLUVPUULYBYFYLWQYKUVOUCNXTYGUUOPZYHUVLYJUVJYGUUOFWRUVQY
      IUUPYGUUOYEWSXAXBXCVPNXTUVLUVJXDVQVRUUNUVJYSRZNXTUKUVKYSRUUNUVRNXTUUNUUOX
      TTZSZUVJUUIYSUVTUUPYCTUUPERUVJUUIRUVTYDYCUUPUVFUUNXTYDUUOYEUVEXEWEUUPEXFU
      UPEXGVKAUUJUUKUUMUVSMXJXHUSNXTUVJYSXIWBXKNXTUUPXLWOUUBUUTBUUQYDYTUUQPUUAU
      USYSYTUUQUTXMXNVCXOXPXQXRXS $.
  $}

  ${
    $d v w R $.  $d v w S $.
    $( The topological product of two compact spaces is compact.  (Contributed
       by Mario Carneiro, 14-Sep-2014.)  (Proof shortened 21-Mar-2015.) $)
    txcmp $p |- ( ( R e. Comp /\ S e. Comp ) -> ( R tX S ) e. Comp ) $=
      ( vw vv ccmp wcel wa ctx co ctop cuni wceq cpw cfn cin wrex cmptop syl2an
      cv eqid wi txtop cxp simpll simplr wss elpwi ad2antrl txuni adantr simprr
      wral eqtrd txcmplem2 eqeq1d rexbidv mpbid expr ralrimiva iscmp sylanbrc )
      AEFZBEFZGZABHIZJFZVEKZCSZKZLZVGDSKZLZDVHMNOZPZUAZCVEMZULVEEFVBAJFZBJFZVFV
      CAQZBQZABUBRVDVOCVPVDVHVPFZVJVNVDWAVJGZGZAKZBKZUCZVKLZDVMPVNWCDABVHWDWEWD
      TZWETZVBVCWBUDVBVCWBUEWAVHVEUFVDVJVHVEUGUHWCWFVGVIVDWFVGLZWBVBVQVRWJVCVSV
      TABWDWEWHWIUIRUJZVDWAVJUKUMUNWCWGVLDVMWCWFVGVKWKUOUPUQURUSCDVEVGVGTUTVA
      $.
  $}

  ${
    txcmpb.1 $e |- X = U. R $.
    txcmpb.2 $e |- Y = U. S $.
    $( The topological product of two nonempty topologies is compact iff the
       component topologies are both compact.  (Contributed by Mario Carneiro,
       14-Sep-2014.) $)
    txcmpb $p |- ( ( ( R e. Top /\ S e. Top ) /\ ( X =/= (/) /\ Y =/= (/) ) )
      -> ( ( R tX S ) e. Comp <-> ( R e. Comp /\ S e. Comp ) ) ) $=
      ( ctop wcel wa c0 wne co ccmp cres wfo ccn syl wb ad2antrr foeq2 ctx cuni
      c1st cxp simpr simplrr fo1stres wceq txuni mpbid ctopon cfv tx1cn syl2anb
      toptopon cncmp syl3anc c2nd simplrl fo2ndres tx2cn jca ex txcmp impbid1 )
      AGHZBGHZIZCJKZDJKZIZIZABUALZMHZAMHZBMHZIZVLVNVQVLVNIZVOVPVRVNVMUBZCUCCDUD
      ZNZOZWAVMAPLHZVOVLVNUEZVRVTCWAOZWBVRVJWEVHVIVJVNUFCDUGQVRVTVSUHZWEWBRVHWF
      VKVNABCDEFUISZVTVSCWATQUJVHWCVKVNVFACUKULHZBDUKULHZWCVGACEUOZBDFUOZABCDUM
      UNSWAVMAVSCEUPUQVRVNVSDURVTNZOZWLVMBPLHZVPWDVRVTDWLOZWMVRVIWOVHVIVJVNUSCD
      UTQVRWFWOWMRWGVTVSDWLTQUJVHWNVKVNVFWHWIWNVGWJWKABCDVAUNSWLVMBVSDFUPUQVBVC
      ABVDVE $.
  $}

  ${
    $d X a b c d e $.  $d J a b c d e $.
    hausdiag.x $e |- X = U. J $.
    $( A topology is Hausdorff iff the diagonal set is closed in the topology's
       product with itself. _EDITORIAL_: very clumsy proof, can probably be
       shortened substantially.  (Contributed by Stefan O'Rear,
       25-Jan-2015.) $)
    hausdiag $p |- ( J e. Haus <-> ( J e. Top /\ ( _I |` X ) e.
        ( Clsd ` ( J tX J ) ) ) ) $=
      ( va vb vc vd ve wcel ctop cv cin wceq wrex wi wral wa cid wss wb cha wne
      c0 w3a cres ctx ccld cfv ishaus cuni cdif cxp txtop anidms wf1o f1oi f1of
      co wf fssxp mp2b txuni syl5sseq eqid iscld2 syl2anc eltx cop eldif eqcomd
      eleq2d anbi1d syl5bb imbi1d impexp syl6bb ralbidv2 eleq1 2rexbidv imbi12d
      notbid ralxp vex opelres wbr df-br ideq bitr3i iba adantr syl5rbbr adantl
      wn necon3bbid elssuni xpss12 syl2an xpeq12i syl6sseqr sseqtrd reldisj syl
      ad2antrr cvv df-res ineq2i inass inss1 syl5ss ssv xpss2 ax-mp df-ss sylib
      syl6ss syl5eqr syl5eq eqeq1d wal opelxp elin 3bitr4i notbii intirr bitr3d
      albii eq0 anbi2d anbi1i 3bitr4g 2rexbidva 2ralbidva bitrd 3bitrrd pm5.32i
      df-3an bitri ) AUAIAJIZDKZEKZUBZYSFKZIZYTGKZIZUUBUUDLZUCMZUDZGANFANZOZEBP
      DBPZQYRRBUEZAAUFURZUGUHIZQDEGFABCUIYRUUKUUNYRUUNUUMUJZUULUKZUUMIZHKZUUBUU
      DULZIZUUSUUPSZQZGANFANZHUUPPZUUKYRUUMJIZUULUUOSUUNUUQTYRUVEAAUMUNYRBBULZU
      ULUUOBBUULUOBBUULUSUULUVFSBUPBBUULUQBBUULUTVAYRUVFUUOMZAABBCCVBUNZVCUULUU
      MUUOUUOVDVEVFYRUUQUVDTFGUUPAAJJHVGUNYRUVDYSYTVHZUULIZWMZUVIUUSIZUVAQZGANF
      ANZOZEBPDBPZUUKYRUVDUURUULIZWMZUVCOZHUVFPUVPYRUVCUVSHUUPUVFYRUURUUPIZUVCO
      UURUVFIZUVRQZUVCOUWAUVSOYRUVTUWBUVCUVTUURUUOIZUVRQYRUWBUURUUOUULVIYRUWCUW
      AUVRYRUUOUVFUURYRUVFUUOUVHVJVKVLVMVNUWAUVRUVCVOVPVQUVSUVOHDEBBUURUVIMZUVR
      UVKUVCUVNUWDUVQUVJUURUVIUULVRWAUWDUVBUVMFGAAUWDUUTUVLUVAUURUVIUUSVRVLVSVT
      WBVPYRUVOUUJDEBBYRYSBIZYTBIZQZQZUVKUUAUVNUUIUWHUVJYSYTUWGUVJYSYTMZTYRUVJU
      VIRIZUWEQZUWGUWIYSYTRBEWCZWDUWIUWJUWGUWKUWJYSYTRWEUWIYSYTRWFYSYTUWLWGWHUW
      EUWJUWKTUWFUWEUWJWIWJWKVMWLWNUWHUVMUUHFGAAUWHUUBAIZUUDAIZQZQZUUCUUEQZUVAQ
      UWQUUGQUVMUUHUWPUVAUUGUWQUWPUUSUULLZUCMZUVAUUGUWPUUSUUOSUWSUVATUWPUUSUVFU
      UOUWOUUSUVFSUWHUWOUUSAUJZUWTULZUVFUWMUUBUWTSUUDUWTSUUSUXASUWNUUBAWOUUDAWO
      UUBUWTUUDUWTWPWQBUWTBUWTCCWRWSWLZYRUVGUWGUWOUVHXCWTUUSUULUUOXAXBUWPUWSUUS
      RLZUCMZUUGUWPUWRUXCUCUWPUWRUUSRBXDULZLZLZUXCUULUXFUUSRBXEXFUWPUXGUXCUXELZ
      UXCUUSRUXEXGUWPUXCUXESUXHUXCMUWPUXCUVFUXEUWPUXCUUSUVFUUSRXHUXBXIBXDSUVFUX
      ESBXJBXDBXKXLXOUXCUXEXMXNXPXQXRYSYSUUSWEZWMZDXSYSUUFIZWMZDXSUXDUUGUXJUXLD
      UXIUXKYSYSVHUUSIUUCYSUUDIQUXIUXKYSYSUUBUUDXTYSYSUUSWFYSUUBUUDYAYBYCYFDUUS
      YDDUUFYGYBVPYEYHUVLUWQUVAYSYTUUBUUDXTYIUUCUUEUUGYPYJYKVTYLYMYNYOYQ $.
  $}

  ${
    $d J a b $.  $d K a b $.  $d F a b $.  $d G a b $.  $d ph a b $.
    hauseqlcld.k $e |- ( ph -> K e. Haus ) $.
    hauseqlcld.f $e |- ( ph -> F e. ( J Cn K ) ) $.
    hauseqlcld.g $e |- ( ph -> G e. ( J Cn K ) ) $.
    $( In a Hausdorff topology, the equalizer of two continuous functions is
       closed (thus, two continuous functions which agree on a dense set agree
       everywhere).  (Contributed by Stefan O'Rear, 25-Jan-2015.)  (Revised by
       Mario Carneiro, 22-Aug-2015.) $)
    hauseqlcld $p |- ( ph -> dom ( F i^i G ) e. ( Clsd ` J ) ) $=
      ( va vb cfv cid wcel wceq wa co eqid syl wfn syl2anc cin cdm cuni cv cmpt
      cop ccnv cres cima ccld ccn wf cnf ffvelrnda biantrud wbr fvex ideq df-br
      bitr3i opelres 3bitr4g fveq2 opeq12d opex fvmpt adantl eleq1d bitr4d crab
      pm5.32da fndmin eleq2d rabid syl6bb wb fnmpti elpreima mp1i 3bitr4d eqrdv
      ffn ctx txcnmpt cha ctop hausdiag simprbi cnclima eqeltrd ) ABCUAUBZIDUCZ
      IUDZBKZWMCKZUFZUEZUGLEUCZUHZUIZDUJKZAJWKWTAJUDZWLMZXBBKZXBCKZNZOZXCXBWQKZ
      WSMZOZXBWKMZXBWTMZAXCXFXIAXCOZXFXDXEUFZWSMZXIXMXNLMZXPXDWRMZOXFXOXMXQXPAW
      LWRXBBABDEUKPZMZWLWRBULZGBDEWLWRWLQZWRQZUMRZUNUOXFXDXELUPXPXDXEXBCUQZURXD
      XELUSUTXDXELWRYDVAVBXMXHXNWSXCXHXNNAIXBWPXNWLWQWMXBNWNXDWOXEWMXBBVCWMXBCV
      CVDWQQZXDXEVEVFVGVHVIVKAXKXBXFJWLVJZMXGAWKYFXBABWLSZCWLSZWKYFNAXTYGYCWLWR
      BWBRAWLWRCULZYHACXRMZYIHCDEWLWRYAYBUMRWLWRCWBRJWLBCVLTVMXFJWLVNVOWQWLSXLX
      JVPAIWLWPWQWNWOVEYEVQWLXBWSWQVRVSVTWAAWQDEEWCPZUKPMZWSYKUJKMZWTXAMAXSYJYL
      GHIEEDBCWQWLYAYEWDTAEWEMZYMFYNEWFMYMEWRYBWGWHRWSWQDYKWITWJ $.
  $}

  ${
    $d u v w x y z R $.  $d u v w x y z S $.
    $( The topological product of two Hausdorff spaces is Hausdorff.
       (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    txhaus $p |- ( ( R e. Haus /\ S e. Haus ) -> ( R tX S ) e. Haus ) $=
      ( vx vy vz vw vu vv wcel wa ctop cv cin c0 wceq w3a cxp ad2antrr sylanbrc
      wrex cha ctx co wne wi cuni wral haustop txtop syl2an eqid eleq2d anbi12d
      txuni c1st cfv c2nd wo wn neorian xpopth adantl necon3bbid syl5bb simplll
      wb xp1st ad2antrl adantr ad2antll simpr hausnei syl13anc ad4antlr simprll
      topopn syl txopn syl22anc simprlr cop 1st2nd2 simprr1 xp2nd elxp6 simprr2
      jca simprr3 xpeq1d xpindir 0xp eleq2 ineq1 eqeq1d 3anbi13d ineq2 3anbi23d
      3eqtr3g rspc2ev syl113anc rexlimdvva mpd simpllr xpeq2d xpindi xp0 jaodan
      expr ex sylbird ralrimivv ishaus ) AUAIZBUAIZJZABUBUCZKIZCLZDLZUDZXRELZIZ
      XSFLZIZYAYCMZNOZPZFXPTEXPTZUEZDXPUFZUGCYJUGXPUAIXMAKIZBKIZXQXNAUHZBUHZABU
      IUJXOYICDYJYJXOXRYJIZXSYJIZJXRAUFZBUFZQZIZXSYSIZJZYIXOYTYOUUAYPXOYSYJXRXM
      YKYLYSYJOXNYMYNABYQYRYQUKZYRUKZUNUJZULXOYSYJXSUUEULUMXOUUBYIXOUUBJZXTXRUO
      UPZXSUOUPZUDZXRUQUPZXSUQUPZUDZURZYHUUMUUGUUHOUUJUUKOJZUSUUFXTUUGUUHUUJUUK
      UTUUFUUNXRXSUUBUUNXRXSOVFXOXRXSYQYRYQYRVAVBVCVDUUFUUMYHUUFUUIYHUULUUFUUIJ
      ZUUGGLZIZUUHHLZIZUUPUURMZNOZPZHATGATZYHUUOXMUUGYQIZUUHYQIZUUIUVCXMXNUUBUU
      IVEUUFUVDUUIYTUVDXOUUAXRYQYRVGVHZVIUUFUVEUUIUUAUVEXOYTXSYQYRVGVJZVIUUFUUI
      VKUUGUUHHGAYQUUCVLVMUUOUVBYHGHAAUUOUUPAIZUURAIZJZUVBYHUUOUVJUVBJZJZUUPYRQ
      ZXPIZUURYRQZXPIZXRUVMIZXSUVOIZUVMUVOMZNOZYHUVLYKYLUVHYRBIZUVNUUFYKUUIUVKX
      MYKXNUUBYMRZRZXNYLXMUUBUUIUVKYNVNZUUOUVHUVIUVBVOUVLYLUWAUWDBYRUUDVPVQZUUP
      YRABKKVRVSUVLYKYLUVIUWAUVPUWCUWDUUOUVHUVIUVBVTUWEUURYRABKKVRVSUVLXRUUGUUJ
      WAOZUUQUUJYRIZJUVQUUFUWFUUIUVKYTUWFXOUUAXRYQYRWBVHZRUVLUUQUWGUUQUUSUVAUVJ
      UUOWCUUFUWGUUIUVKYTUWGXOUUAXRYQYRWDVHZRWGXRUUPYRWESUVLXSUUHUUKWAOZUUSUUKY
      RIZJUVRUUFUWJUUIUVKUUAUWJXOYTXSYQYRWBVJZRUVLUUSUWKUUQUUSUVAUVJUUOWFUUFUWK
      UUIUVKUUAUWKXOYTXSYQYRWDVJZRWGXSUURYRWESUVLUUTYRQNYRQUVSNUVLUUTNYRUUQUUSU
      VAUVJUUOWHWIUUPUURYRWJYRWKWRYGUVQUVRUVTPUVQYDUVMYCMZNOZPEFUVMUVOXPXPYAUVM
      OZYBUVQYFUWOYDYAUVMXRWLUWPYEUWNNYAUVMYCWMWNWOYCUVOOZYDUVRUWOUVTUVQYCUVOXS
      WLUWQUWNUVSNYCUVOUVMWPWNWQWSWTXHXAXBUUFUULJZUUJUUPIZUUKUURIZUVAPZHBTGBTZY
      HUWRXNUWGUWKUULUXBXMXNUUBUULXCUUFUWGUULUWIVIUUFUWKUULUWMVIUUFUULVKUUJUUKH
      GBYRUUDVLVMUWRUXAYHGHBBUWRUUPBIZUURBIZJZUXAYHUWRUXEUXAJZJZYQUUPQZXPIZYQUU
      RQZXPIZXRUXHIZXSUXJIZUXHUXJMZNOZYHUXGYKYLYQAIZUXCUXIUUFYKUULUXFUWBRZXNYLX
      MUUBUULUXFYNVNZUXGYKUXPUXQAYQUUCVPVQZUWRUXCUXDUXAVOYQUUPABKKVRVSUXGYKYLUX
      PUXDUXKUXQUXRUXSUWRUXCUXDUXAVTYQUURABKKVRVSUXGUWFUVDUWSJUXLUUFUWFUULUXFUW
      HRUXGUVDUWSUUFUVDUULUXFUVFRUWSUWTUVAUXEUWRWCWGXRYQUUPWESUXGUWJUVEUWTJUXMU
      UFUWJUULUXFUWLRUXGUVEUWTUUFUVEUULUXFUVGRUWSUWTUVAUXEUWRWFWGXSYQUURWESUXGY
      QUUTQYQNQUXNNUXGUUTNYQUWSUWTUVAUXEUWRWHXDYQUUPUURXEYQXFWRYGUXLUXMUXOPUXLY
      DUXHYCMZNOZPEFUXHUXJXPXPYAUXHOZYBUXLYFUYAYDYAUXHXRWLUYBYEUXTNYAUXHYCWMWNW
      OYCUXJOZYDUXMUYAUXOUXLYCUXJXSWLUYCUXTUXNNYCUXJUXHWPWNWQWSWTXHXAXBXGXIXJXI
      XJXKCDFEXPYJYJUKXLS $.
  $}

  ${
    $d j k n u v w x F $.  $d j k u v w H $.  $d n x O $.  $d j k n u v w ph $.
    $d j k n u v w x G $.  $d j k M $.  $d j k t u v w R $.
    $d j k t u v w S $.  $d j k n t u v w J $.  $d j k n t u v w K $.
    $d j k n u v w x X $.  $d j k n u v w x Y $.  $d j k n u v w Z $.
    txlm.z $e |- Z = ( ZZ>= ` M ) $.
    txlm.m $e |- ( ph -> M e. ZZ ) $.
    txlm.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    txlm.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    txlm.f $e |- ( ph -> F : Z --> X ) $.
    txlm.g $e |- ( ph -> G : Z --> Y ) $.
    ${
      txlm.h $e |- H = ( n e. Z |-> <. ( F ` n ) , ( G ` n ) >. ) $.
      $( Two sequences converge iff the sequence of their ordered pairs
         converges.  Proposition 14-2.6 of [Gleason] p. 230.  (Contributed by
         NM, 16-Jul-2007.)  (Revised by Mario Carneiro, 5-May-2014.) $)
      txlm $p |- ( ph -> ( ( F ( ~~>t ` J ) R /\ G ( ~~>t ` K ) S ) <->
                           H ( ~~>t ` ( J tX K ) ) <. R , S >. ) ) $=
        ( vu vk vj vv vw vt wcel wa cv cfv cuz wral wrex wi cop cxp ctx clm wbr
        co r19.27av r19.28av ralimi syl wss cmpt2 crn simprl wceq ctop topontop
        ctg ctopon eqid txval syl2anc adantr eleqtrd simprr tg2 cvv wb vex xpex
        rgen2w eleq2 sseq1 anbi12d rexrnmpt2 ax-mp sylib r19.29 opelxp im2anan9
        pm2.27 rexanuz2 uztrn2 opelxpi fveq2 opeq12d opex eleq1d syl5ibr adantl
        fvmpt simplrr sseld syld sylan2 anassrs ralimdva reximdva syl5bir com23
        ex imp3a rexlimdva exp3acom23 expdimp ralrimdva toponmax txopn syl22anc
        syl5 rexralbidv imbi12d rspcv expcom opelxp1 syl6bi reximia a1i imim12d
        adantrl ad2antrl opelxp2 adantrr eqidd lmbrf ffvelrnda pm5.32da syl6bbr
        jcad impbid anbi1i an4 syl6bb txtopon fmptd 3bitr4d ) ABKUGZCLUGZUHZBUA
        UIZUGZUBUIZEUJZUUNUGZUBUCUIZUKUJZULZUCMUMZUNZUAHULZCUDUIZUGZUUPFUJZUVEU
        GZUBUUTULZUCMUMZUNZUDIULZUHZUHZBCUOZKLUPZUGZUVOUEUIZUGZUUPGUJZUVRUGZUBU
        UTULZUCMUMZUNZUEHIUQUTZULZUHZEBHURUJUSZFCIURUJUSZUHZGUVOUWEURUJUSAUVNUU
        MUWFUHUWGAUUMUVMUWFAUUMUHZUVMUWFAUVMUWFUNUUMUVMUVCUVKUHZUDIULZUAHULZAUW
        FUVMUVCUVLUHZUAHULUWNUVCUVLUAHVAUWOUWMUAHUVCUVKUDIVBVCVDAUWNUWDUEUWEAUV
        RUWEUGZUHUVSUWNUWCAUWPUVSUWNUWCUNZAUWPUVSUHZUVOUUNUVEUPZUGZUWSUVRVEZUHZ
        UDIUMZUAHUMZUWQAUWRUXDAUWRUHZUVOUFUIZUGZUXFUVRVEZUHZUFUAUDHIUWSVFZVGZUM
        ZUXDUXEUVRUXKVLUJZUGUVSUXLUXEUVRUWEUXMAUWPUVSVHAUWEUXMVIZUWRAHVJUGZIVJU
        GZUXNAHKVMUJUGZUXOPKHVKVDZAILVMUJUGZUXPQLIVKVDZUAUDUXKHIVJVJUXKVNVOVPVQ
        VRAUWPUVSVSUFUVRUXKUVOVTVPUWSWAUGZUDIULUAHULUXLUXDWBUYAUAUDHIUUNUVEUAWC
        UDWCWDWEUXIUXBUAUDUFHIUWSUXJWAUXJVNUXFUWSVIUXGUWTUXHUXAUXFUWSUVOWFUXFUW
        SUVRWGWHWIWJWKXOAUWNUXDUWCUWNUXDUHUWMUXCUHZUAHUMAUWCUWMUXCUAHWLAUYBUWCU
        AHUYBUWLUXBUHZUDIUMAUUNHUGZUHZUWCUWLUXBUDIWLUYEUYCUWCUDIUYEUVEIUGZUHZUW
        LUXBUWCUYGUXBUWLUWCUYGUXBUWLUWCUNUYGUXBUHZUWLUVBUVJUHZUWCUYHUUOUVFUHZUW
        LUYIUNUYHUWTUYJUYGUWTUXAVHBCUUNUVEWMWKUUOUVCUVBUVFUVKUVJUUOUVBWOUVFUVJW
        OWNVDUYIUURUVHUHZUBUUTULZUCMUMUYHUWCUURUVHUCUBJMNWPUYHUYLUWBUCMUYHUUSMU
        GZUHUYKUWAUBUUTUYHUYMUUPUUTUGZUYKUWAUNZUYMUYNUHZUYHUUPMUGZUYOJUUPUUSMNW
        QZUYHUYQUHZUYKUVTUWSUGZUWAUYQUYKUYTUNUYHUYKUYTUYQUUQUVGUOZUWSUGUUQUVGUU
        NUVEWRUYQUVTVUAUWSDUUPDUIZEUJZVUBFUJZUOZVUAMGVUBUUPVIVUCUUQVUDUVGVUBUUP
        EWSVUBUUPFWSWTTUUQUVGXAXEZXBXCXDUYSUWSUVRUVTUYGUWTUXAUYQXFXGXHXIXJXKXLX
        MXHXOXNXPXQYDXQYDXRXHXSXNXTYDVQUWKUWFUVDUVLAUULUWFUVDUNUUKAUULUHUWFUVCU
        AHAUULUYDUWFUVCUNAUULUYDUHZUHZUWFUVOUUNLUPZUGZUVTVUIUGZUBUUTULZUCMUMZUN
        ZUVCVUHVUIUWEUGZUWFVUNUNVUHUXOUXPUYDLIUGZVUOAUXOVUGUXRVQAUXPVUGUXTVQAUU
        LUYDVSAVUPVUGAUXSVUPQLIYAVDVQUUNLHIVJVJYBYCUWDVUNUEVUIUWEUVRVUIVIZUVSVU
        JUWCVUMUVRVUIUVOWFVUQUWAVUKUCUBMUUTUVRVUIUVTWFYEYFYGVDVUHUUOVUJVUMUVBUU
        OVUHVUJVUHUUOUULVUJAUULUYDVHBCUUNLWRXIYHVUMUVBUNVUHVULUVAUCMUYMVUKUURUB
        UUTUYPUYQVUKUURUNUYRUYQVUKVUAVUIUGUURUYQUVTVUAVUIVUFXBUUQUVGUUNLYIYJVDX
        KYKYLYMXHXJXTYNAUUKUWFUVLUNUULAUUKUHUWFUVKUDIAUUKUYFUWFUVKUNAUUKUYFUHZU
        HZUWFUVOKUVEUPZUGZUVTVUTUGZUBUUTULZUCMUMZUNZUVKVUSVUTUWEUGZUWFVVEUNVUSU
        XOUXPKHUGZUYFVVFAUXOVURUXRVQAUXPVURUXTVQAVVGVURAUXQVVGPKHYAVDVQAUUKUYFV
        SKUVEHIVJVJYBYCUWDVVEUEVUTUWEUVRVUTVIZUVSVVAUWCVVDUVRVUTUVOWFVVHUWAVVBU
        CUBMUUTUVRVUTUVTWFYEYFYGVDVUSUVFVVAVVDUVJUUKUVFVVAUNAUYFUUKUVFVVABCKUVE
        WRXOYOVVDUVJUNVUSVVCUVIUCMUYMVVBUVHUBUUTUYPUYQVVBUVHUNUYRUYQVVBVUAVUTUG
        UVHUYQUVTVUAVUTVUFXBUUQUVGKUVEYPYJVDXKYKYLYMXHXJXTYQUUCUUDUUAUVQUUMUWFB
        CKLWMUUEUUBAUWJUUKUVDUHZUULUVLUHZUHUVNAUWHVVIUWIVVJAUAUUQBUCUBEHJKMPNOR
        AUYQUHZUUQYRYSAUDUVGCUCUBFIJLMQNOSVVKUVGYRYSWHUUKUVDUULUVLUUFUUGAUEUVTU
        VOUCUBGUWEJUVPMAUXQUXSUWEUVPVMUJUGPQHIKLUUHVPNOADMVUEUVPGAVUBMUGUHVUCKU
        GVUDLUGVUEUVPUGAMKVUBERYTAMLVUBFSYTVUCVUDKLWRVPTUUIVVKUVTYRYSUUJ $.
    $}

    lmcn2.fl $e |- ( ph -> F ( ~~>t ` J ) R ) $.
    lmcn2.gl $e |- ( ph -> G ( ~~>t ` K ) S ) $.
    lmcn2.o $e |- ( ph -> O e. ( ( J tX K ) Cn N ) ) $.
    lmcn2.h $e |- H = ( n e. Z |-> ( ( F ` n ) O ( G ` n ) ) ) $.
    $( The image of a convergent sequence under a continuous map is convergent
       to the image of the original point.  Binary operation version.
       (Contributed by Mario Carneiro, 15-May-2014.) $)
    lmcn2 $p |- ( ph -> H ( ~~>t ` N ) ( R O S ) ) $=
      ( vx cop cfv co clm cv cmpt ccom cxp wcel ffvelrnda opelxpi syl2anc eqidd
      wa cuni ctx ctopon ccn wf txtopon ctop cntop2 eqid toptopon sylib syl3anc
      syl cnf2 feqmptd wceq fveq2 df-ov syl6eqr wbr txlm mpbi2and lmcn eqbrtrrd
      fmptco syl6breqr ) AGBCUGZLUHZBCLUIKUJUHZALDODUKZEUHZWJFUHZUGZULZUMZGWHWI
      AWODOWKWLLUIZULGADUFOMNUNZWMUFUKZLUHZWPWNLAWJOUOUTWKMUOWLNUOWMWQUOAOMWJET
      UPAONWJFUAUPWKWLMNUQURAWNUSAUFWQKVAZLAHIVBUIZWQVCUHUOZKWTVCUHUOZLXAKVDUIU
      OZWQWTLVEAHMVCUHUOINVCUHUOXBRSHIMNVFURAKVGUOZXCAXDXEUDLXAKVHVMKWTWTVIVJVK
      UDLXAKWQWTVNVLVOWRWMVPWSWMLUHWPWRWMLVQWKWLLVRVSWEUEVSAWGWNLXAKAEBHUJUHVTF
      CIUJUHVTWNWGXAUJUHVTUBUCABCDEFWNHIJMNOPQRSTUAWNVIWAWBUDWCWDBCLVRWF $.
  $}

  ${
    $d a b m n p q r s u v w x y z R $.  $d a b m n p q r s u v w x y z S $.
    $( The topological product of two first-countable spaces is
       first-countable.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    tx1stc $p |- ( ( R e. 1stc /\ S e. 1stc ) -> ( R tX S ) e. 1stc ) $=
      ( vx vz vw vr vp vs vq vm vn wcel wa cv com cdom wbr wrex wral wceq vy vu
      vv va vb c1stc ctx co ctop wel wss cpw cuni 1stctop txtop syl2an cxp eqid
      wi cop 1stcclb ad2ant2r ad2ant2l reeanv an4 cmpt2 crn wf txopn ralrimivva
      adantr elpwi ssralv syl ralimdv sylan9 mpan9 fmpt2 sylib frn elpw2 sylibr
      ovex ccrd cdm wfo con0 omelon cen xpdom1 omex xpdom2 domtr xpomen domentr
      vex sylancl ondomen sylancr xpex fnmpt2i dffn4 mpbi fodomnum ee10 syl2anc
      wfn ad2antrl anim12i ad3antrrr eltx eleq1 anbi1d 2rexbidv rspccv r19.27av
      wb r19.29 opelxp pm3.35 an4s sylanb anim1i anasss an12s expl reximdv syl5
      impl reximi weq eqeq2d anbi12d rspcev syl12anc syl5bir rexlimdvva ralbidv
      sylan rexbidv w3a simpr1l simpr1r eqidd xpeq1 xpeq2 rspc2ev syl3anc eqeq1
      cab rnmpt2 syl6eleqr simpr2 opelxpi xpss12 simpr3 sstrd eleq2 sseq1 3exp2
      elab rexlimdvv imp3a exp3a impr syl9r sylbid ralrimiv breq1 imbi2d syl5bi
      rexeq ex mp2and imbi12d anbi2d ralxp txuni raleqdv mpbid is1stc2 sylanbrc
      ) AUFLZBUFLZMZABUGUHZUILZUANZOPQZCDUJZCEUJZENZDNZUKZMZEUWHRZUSZDUWFSZMZUA
      UWFULZRZCUWFUMZSZUWFUFLUWCAUILZBUILZUWGUWDAUNZBUNZABUOUPUWEUXACAUMZBUMZUQ
      ZSZUXCUWEUWIUBNZUCNZUTZUWMLZUXNUWLLZUWNMZEUWHRZUSZDUWFSZMZUAUWTRZUCUXISUB
      UXHSUXKUWEUYBUBUCUXHUXIUWEUXLUXHLZUXMUXILZMZMZUDNZOPQZUBFUJZUBGUJZGNZFNZU
      KZMZGUYGRZUSZFASZMZUDAULZRZUENZOPQZUCHUJZUCIUJZINZHNZUKZMZIVUARZUSZHBSZMZ
      UEBULZRZUYBUWCUYCUYTUWDUYDUDFGUXLAUXHUXHURZVAVBUWDUYDVUNUWCUYCUEHIUXMBUXI
      UXIURZVAVCUYTVUNMUYRVULMZUEVUMRUDUYSRUYFUYBUYRVULUDUEUYSVUMVDUYFVUQUYBUDU
      EUYSVUMVUQUYHVUBMZUYQVUKMZMZUYFUYGUYSLZVUAVUMLZMZMZUYBUYHUYQVUBVUKVEVVDVU
      TUYBVVDVUTMZJKUYGVUAJNZKNZUQZVFZVGZUWTLZVVJOPQZUXOUXQEVVJRZUSZDUWFSZUYBVV
      DVVKVUTVVDVVJUWFUKZVVKVVDUYGVUAUQZUWFVVIVHZVVPVVDVVHUWFLZKVUASZJUYGSZVVRU
      YFVVSKBSZJASZVVCVWAUWEVWCUYEUWCUXDUXEVWCUWDUXFUXGUXDUXEMZVVSJKABVVFVVGABU
      IUIVIVJUPVKVVAVWCVWBJUYGSZVVBVWAVVAUYGAUKVWCVWEUSUYGAVLVWBJUYGAVMVNVVBVWB
      VVTJUYGVVBVUABUKVWBVVTUSVUABVLVVSKVUABVMVNVOVPVQJKUYGVUAVVHUWFVVIVVIURZVR
      VSVVQUWFVVIVTVNVVJUWFABUGWCWAWBVKVURVVLVVDVUSVURVVJVVQPQZVVQOPQZVVLVURVVQ
      WDWELZVVQVVJVVIWFZVWGVUROWGLVWHVWIWHVURVVQOOUQZPQZVWKOWIQVWHUYHVVQOVUAUQZ
      PQVWMVWKPQVWLVUBUYGOVUAUEWPWJVUAOOWKWLVVQVWMVWKWMUPWNVVQVWKOWOWQZOVVQWRWS
      VVIVVQXGVWJJKUYGVUAVVHVVIVWFVVFVVGJWPKWPWTXAVVQVVIXBXCVVQVVJVVIXDXEVWNVVJ
      VVQOWMXFXHVVEVVNDUWFVVEUWMUWFLZUWLUYLVUFUQZLZVWPUWMUKZMZHBRFARZEUWMSZVVNV
      VEVWDVWOVXAXQUWEVWDUYEVVCVUTUWCUXDUWDUXEUXFUXGXIXJFHUWMABUIUIEXKVNVXAUXOU
      XNVWPLZVWRMZHBRZFARZVVEVVMVWTVXEEUXNUWMUWLUXNTZVWSVXCFHABVXFVWQVXBVWRUWLU
      XNVWPXLXMXNXOVVDVURVUSVXEVVMUSVVDVURMZVUSVXEVVMVUSVXEMUYOVUIMZVWRMZHBRZFA
      RZVXGVVMVUSUYPVUKMZFASZVXEVXKUYPVUKFAXPVXMVXEMVXLVXDMZFARVXKVXLVXDFAXRVXN
      VXJFAUYPVUKVXDVXJVUKVXDMVUJVXCMZHBRUYPVXJVUJVXCHBXRUYPVXOVXIHBUYPVUJVXCVX
      IVXBUYPVUJMZVWRVXIVXBVXPVWRVXIVXBVXPMVXHVWRVXBUYIVUCMVXPVXHUXLUXMUYLVUFXS
      UYIUYPVUCVUJVXHUYIUYPMUYOVUCVUJMVUIUYIUYOXTVUCVUIXTXIYAYBYCYDYEYFYGYHYIYJ
      VNYSVXGVXIVVMFHABVXGUYLALVUFBLMMZVXHVWRVVMVXHUYNVUHMZIVUARGUYGRVXQVWRVVMU
      SZUYNVUHGIUYGVUAVDVXQVXRVXSGIUYGVUAVXQGUDUJZIUEUJZMZVXRVWRVVMVXQVYBVXRVWR
      UUAMZUYKVUEUQZVVJLUXNVYDLZVYDUWMUKZVVMVYCVYDCNZVVHTZKVUARJUYGRZCUUJZVVJVY
      CVYDVVHTZKVUARJUYGRZVYDVYJLVYCVXTVYAVYDVYDTZVYLVXTVYAVXRVWRVXQUUBVXTVYAVX
      RVWRVXQUUCVYCVYDUUDVYKVYMVYDUYKVVGUQZTJKUYKVUEUYGVUAJGYKVVHVYNVYDVVFUYKVV
      GUUEYLKIYKVYNVYDVYDVVGVUEUYKUUFYLUUGUUHVYIVYLCVYDUYKVUEGWPIWPWTVYGVYDTVYH
      VYKJKUYGVUAVYGVYDVVHUUIXNUVAWBJKCUYGVUAVVHVVIVWFUUKUULVYCVXRVYEVXQVYBVXRV
      WRUUMZUYJVUDVYEUYMVUGUXLUXMUYKVUEUUNVBVNVYCVYDVWPUWMVYCVXRVYDVWPUKZVYOUYM
      VUGVYPUYJVUDUYKUYLVUEVUFUUOVCVNVXQVYBVXRVWRUUPUUQUXQVYEVYFMEVYDVVJUWLVYDT
      UXPVYEUWNVYFUWLVYDUXNUURUWLVYDUWMUUSYMYNYOUUTUVBYPUVCYQYHUVDUVEUVFUVGUVHU
      YAVVLVVOMUAVVJUWTUWHVVJTZUWIVVLUXTVVOUWHVVJOPUVIVYQUXSVVNDUWFVYQUXRVVMUXO
      UXQEUWHVVJUVLUVJYRYMYNYOUVMUVKYQYPUVNVJUXAUYBCUBUCUXHUXIVYGUXNTZUWSUYAUAU
      WTVYRUWRUXTUWIVYRUWQUXSDUWFVYRUWJUXOUWPUXRVYGUXNUWMXLVYRUWOUXQEUWHVYRUWKU
      XPUWNVYGUXNUWLXLXMYTUVOYRUVPYTUVQWBUWEUXACUXJUXBUWCUXDUXEUXJUXBTUWDUXFUXG
      ABUXHUXIVUOVUPUVRUPUVSUVTCUADEUWFUXBUXBURUWAUWB $.
  $}

  ${
    $d r s u x y $.  $d r s R $.  $d r s S $.
    $( The topological product of two second-countable spaces is
       second-countable.  (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    tx2ndc $p |- ( ( R e. 2ndc /\ S e. 2ndc ) -> ( R tX S ) e. 2ndc ) $=
      ( vr vs vx vy c2ndc wcel cv com cdom wbr ctg cfv wceq wa ctb wrex ctx cxp
      co is2ndc reeanv an4 cmpt2 crn txbasval eqid txval eqtrd adantr txbas cdm
      ccrd wfo con0 omelon cen xpdom1 xpdom2 domtr syl2an adantl xpomen domentr
      vex omex sylancl ondomen sylancr wfn xpex fnmpt2i a1i dffn4 fodomnum sylc
      sylib syl2anc 2ndci eqeltrd oveq12 eleq1d syl5ibcom expimpd syl5bi sylbir
      rexlimivv syl2anb ) AGHCIZJKLZWJMNZAOZPZCQRZDIZJKLZWPMNZBOZPZDQRZABSUAZGH
      ZBGHCAUBDBUBWOXAPWNWTPZDQRCQRXCWNWTCDQQUCXDXCCDQQXDWKWQPZWMWSPZPWJQHWPQHP
      ZXCWKWMWQWSUDXGXEXFXCXGXEPZWLWRSUAZGHXFXCXHXIEFWJWPEIZFIZTZUEZUFZMNZGXGXI
      XOOXEXGXIWJWPSUAXOWJWPQQUGEFXNWJWPQQXNUHZUIUJUKXHXNQHZXNJKLZXOGHXGXQXEEFX
      NWJWPXPULUKXHXNWJWPTZKLZXSJKLZXRXHXSUNUMHZXSXNXMUOZXTXHJUPHYAYBUQXHXSJJTZ
      KLZYDJURLYAXEYEXGWKXSJWPTZKLYFYDKLYEWQWJJWPDVFUSWPJJVGUTXSYFYDVAVBVCVDXSY
      DJVEVHZJXSVIVJXHXMXSVKZYCYHXHEFWJWPXLXMXMUHXJXKEVFFVFVLVMVNXSXMVOVRXSXNXM
      VPVQYGXNXSJVAVSXNVTVSWAXFXIXBGWLAWRBSWBWCWDWEWFWHWGWI $.
  $}

  ${
    $d a b k s t u x y R $.  $d a b k s t u v x y S $.
    $( The topological product of a locally compact space and a compactly
       generated Hausdorff space is compactly generated.  (The condition on
       ` S ` can also be replaced with either "comactly generated weak
       Hausdorff (CGWH)" or "compact Hausdorff-ly generated (CHG)", where WH
       means that all images of compact Hausdorff spaces are closed and CHG
       means that a set is open iff it is open in all compact Hausdorff
       spaces.)  (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    txkgen $p |- ( ( R e. N-Locally Comp /\ S e. ( ran kGen i^i Haus ) ) ->
      ( R tX S ) e. ran kGen ) $=
      ( vt vu vk vb va ccmp wcel wa co ctop cfv wss cv wrex syl2anc wceq adantr
      syl vx vy vs vv cnlly ckgen crn cha cin nllytop inss1 sseli kgentop txtop
      ctx wel wral c1st crest w3a c2nd cop cuni crab cpw simplll cmpt cima eqid
      syl2an ccn cres csn cxp ctopon ad3antrrr sylib simpr simplr eqtrd syl3anc
      toptopon ad2antrr eleqtrd eqeltrrd opeq1 eleq1d elrab sylanbrc ssrab2 a1i
      incom cdif ccld eldif bitri eqeq1d eleq1 notbid anbi12d syl5bb weq sselda
      wn opelxpi rexbidva opeq2 syl6bb wb wf f2ndres ax-mp syl5ss xpeq2d sseq1d
      vex sneq difin restuni difeq1d syl5eqr inss2 eqsstri cvv syl22anc eqeltrd
      sstri resttop sylancl syl5eqel mpbird expr ralrimiva relxp opelxp simprbi
      wrel expimpd syl5bi relssdv ccnv mptpreima cid idcn simpllr txuni kgenuni
      elunii eleqtrrd cnconst2 fvresi fvex fvconst2 opeq12d mpteq2ia llycmpkgen
      xp2nd eqcomi txcnmpt kgencn3 cnima syl5eqelr xp1st 1st2nd2 nlly2i simprlr
      simprll elpwid syl6ss elpwi ad2antrl anbi1i anass ancom fveq2 rexxp simpl
      wi rexbii2 fvres op2nd syl6eq anbi1d ceqsrexbv r19.42v wfn difss fvelimab
      ffn xpss12 sylancr dfss3 ralxp ralsn ralbii 3bitri elrab3 rexnal pm5.32da
      syl6bbr 3bitr4d eqrdv sseldi df-ima resres ssres2 rnss tx2cn xpex restabs
      frn simprl txrest simprr3 simprr txcmp sseqtrd kgeni opncld cmpcld imacmp
      hauscmp restcldi isopn2 elkgen mpbir2and kgenidm txopn simprr1 syl5ibrcom
      syl5sseq elsni opeq2d simprr2 snid ssel syl5com syl5 eleq2 sseq1 syl12anc
      rspcev rexlimdvva mpd eltop2 ex ssrdv iskgen2 ) AHUEIZBUFUGZUHUIZIZJZABUO
      KZLIZVUNUFMZVUNNVUNVUJIVUIALIZBLIZVUOVULHAUJZVULBVUJIZVURVUKVUJBVUJUHUKUL
      ZBUMTZABUNZVJZVUMUAVUPVUNVUMUAOZVUPIZVVEVUNIZVUMVVFJZVVGUBCUPZCOZVVENZJZC
      VUNPZUBVVEUQZVVHVVMUBVVEVVHUBUAUPZJZUBOZURMZDOZIZVVSUCOZNZAVWAUSKZHIZUTZD
      APUCVVJVVQVAMZVBZVVEIZCAVCZVDZVEZPZVVMVVPVUIVWJAIVVRVWJIZVWLVUIVULVVFVVOV
      FVVPVWJCVWIVWGVGZUUAVVEVHZACVWIVWGVVEVWNVWNVIUUBVVPVWNAVUPVKKZIVVFVWOAIVV
      PVWNAVUNVKKZVWPVVPUUCVWIVLZAAVKKIZVWIVWFVMZVNZABVKKIZVWNVWQIVVPAVWIVOMIZV
      WSVVPVUQVXCVUIVUQVULVVFVVOVUSVPZAVWIVWIVIZWBVQZAVWIUUDTVVPVXCBBVCZVOMIZVW
      FVXGIZVXBVXFVVPVURVXHVVPVULVURVUIVULVVFVVOUUEZVVBTZBVXGVXGVIZWBZVQVVPVVQV
      WIVXGVNZIZVXIVVPVVQVUPVCZVXNVVPVVOVVFVVQVXPIVVHVVOVRZVUMVVFVVOVSZVVQVVEVU
      PUUHQVVPVXNVUNVCZVXPVVPVUQVURVXNVXSRZVXDVXKABVWIVXGVXEVXLUUFZQVVPVUOVXSVX
      PRVVPVUQVURVUOVXDVXKVVCQZVUNVXSVXSVIZUUGTVTUUIZVVQVWIVXGUUQTZVWFABVWIVXGU
      UJWACABAVWRVXAVWNVWIVXECVWIVVJVWRMZVVJVXAMZVBZVGVWNCVWIVYHVWGVVJVWIIVYFVV
      JVYGVWFVWIVVJUUKVWIVWFVVJVVQVAUULUUMUUNUUOUURUUSQVVPAVUJIZVUOVWQVWPRVUIVY
      IVULVVFVVOAUUPVPVUMVUOVVFVVOVVDWCAVUNUUTQWDVXRVVEVWNAVUPUVAQUVBVVPVVRVWII
      ZVVRVWFVBZVVEIZVWMVVPVXOVYJVYDVVQVWIVXGUVCTVVPVVQVYKVVEVVPVXOVVQVYKRZVYDV
      VQVWIVXGUVDTZVXQWEVWHVYLCVVRVWIVVJVVRRVWGVYKVVEVVJVVRVWFWFWGWHWIDHVVRVWJA
      UCUVEWAVVPVWEVVMUCDVWKAVVPVWAVWKIZVVSAIZJZVWEVVMVVPVYQVWEJZJZVVSVWAUDOZVM
      ZVNZVVENZUDVXGVDZVNZVUNIZVVQWUEIZWUEVVENZVVMVYSVUQVURVYPWUDBIWUFVVPVUQVYR
      VXDSZVVPVURVYRVXKSZVVPVYOVYPVWEUVFVYSWUDBUFMZBVYSWUDWUKIZWUDVXGNZBEOZUSKZ
      HIZWUDWUNUIZWUOIZUVRZEVXGVEZUQZWUMVYSWUCUDVXGWJWKVYSWUSEWUTVYSWUNWUTIZWUP
      WURVYSWVBWUPJZJZWUQWUNWUDUIZWUOWUDWUNWLWVDWVEWUOIZWUOVCZWVEWMZWUOWNMZIZWV
      DVAVXNVLZVWAWUNVNZVVEWMZVHZWVHWVIWVDWVNWUNWUDWMZWVHWVDVWAVWINZWUNVXGNZWVN
      WVORVYSWVPWVCVYSVWAVWJVWIVYSVWAVWJVVPVYOVYPVWEUVGUVHZVWHCVWIWJUVISZWVBWVQ
      VYSWUPWUNVXGUVJUVKZWVPWVQJZFWVNWVOWWAVVJWVKMZFOZRZCWVMPZFEUPZGOZWWCVBZVVE
      IZXDZGVWAPZJZWWCWVNIZWWCWVOIZWWEWWGVVSVBZWVKMZWWCRZWWOVVEIZXDZJZDWUNPZGVW
      APZWWAWWLWWECUAUPZXDZWWDJZCWVLPWXBWWDWXECWVMWVLVVJWVMIZWWDJVVJWVLIZWXDJZW
      WDJWXGWXEJWXFWXHWWDVVJWVLVVEWOUVLWXGWXDWWDUVMWPUVSWXEWWTCGDVWAWUNWXEWWDWX
      DJVVJWWORZWWTWXDWWDUVNWXIWWDWWQWXDWWSWXIWWBWWPWWCVVJWWOWVKUVOWQWXIWXCWWRV
      VJWWOVVEWRWSWTXAUVPWPWWAWXBWWFWWJJZGVWAPWWLWWAWXAWXJGVWAWWAGUCUPZJZWXADFX
      BZWWSJZDWUNPWXJWXLWWTWXNDWUNWXLDEUPZJZWWQWXMWWSWXPWWPVVSWWCWXPWWPWWOVAMZV
      VSWXPWWOVXNIZWWPWXQRWXPWWGVWIIZVVSVXGIWXRWXLWXSWXOWWAVWAVWIWWGWVPWVQUVQXC
      SWXLWUNVXGVVSWVPWVQWXKVSXCWWGVVSVWIVXGXEQWWOVXNVAUVTTWWGVVSGXPDXPUWAUWBWQ
      UWCXFWWSWWJDWWCWUNWXMWWRWWIWXMWWOWWHVVEVVSWWCWWGXGWGWSUWDXHXFWWFWWJGVWAUW
      EXHXAWWAWVKVXNUWFZWVMVXNNWWMWWEXIVXNVXGWVKXJWXTVWIVXGXKVXNVXGWVKUWIXLWWAW
      VMWVLVXNWVLVVEUWGZVWAVWIWUNVXGUWJZXMCVXNWVMWWCWVKUWHUWKWWNWWFWWCWUDIZXDZJ
      WWAWWLWWCWUNWUDWOWWAWWFWYDWWKWWAWWFJZWYDWWIGVWAUQZXDWWKWYEWYCWYFWYEWWCVXG
      IZWYCWYFXIWWAWUNVXGWWCWVPWVQVRXCWUCWYFUDWWCVXGUDFXBZWUCVWAWWCVMZVNZVVENZW
      YFWYHWUBWYJVVEWYHWUAWYIVWAVYTWWCXQXNXOZWYKEUAUPZEWYJUQWWGVVJVBZVVEIZCWYIU
      QZGVWAUQWYFEWYJVVEUWLWYMWYOEGCVWAWYIWUNWYNVVEWRUWMWYPWWIGVWAWYOWWICWWCFXP
      ZCFXBWYNWWHVVEVVJWWCWWGXGWGUWNUWOUWPXHUWQTWSWWIGVWAUWRUWTUWSXAUXAUXBQWVDW
      VOWUNWVEWMWVHWUNWUDXRWVDWUNWVGWVEWVDVURWVQWUNWVGRVYSVURWVCWUJSZWVTWUNBVXG
      VXLXSQZXTYAVTWVDWVQWVNBWNMIZWVNWUNNZWVNWVIIWVTWVDBUHIWVNVXGNBWVNUSKHIZWYT
      WVDVUKUHBVUJUHYBVVPVULVYRWVCVXJWCZUXCWVDWVNWUNVXGWVNVAWVLVLZUGZWUNWVNWVKW
      VMVLZUGZXUEWVKWVMUXDXUFXUDNXUGXUENXUFVAVXNWVMUIZVLZXUDVAVXNWVMUXEXUHWVLNX
      UIXUDNXUHWVMWVLVXNWVMYBWYAYGXUHWVLVAUXFXLYCXUFXUDUXGXLYCWVLWUNXUDXJXUEWUN
      NVWAWUNXKWVLWUNXUDUXKXLYGZWVTXMWVDWVKVUNBVKKIZVUNWVMUSKZHIXUBWVDVXCVXHXUK
      VVPVXCVYRWVCVXFWCWVDVURVXHWYRVXMVQABVWIVXGUXHQWVDVUNWVLUSKZWVMUSKZXULHWVD
      VUOWVMWVLNZWVLYDIZXUNXULRVVPVUOVYRWVCVYBWCZXUOWVDWYAWKXUPWVDVWAWUNUCXPZEX
      PUXIZWKWVMWVLVUNLYDUXJWAWVDXUMHIZWVMXUMWNMZIXUNHIWVDXUMVWCWUOUOKZHWVDVUQV
      URVWAYDIZWVBXUMXVBRVYSVUQWVCWUISZWVDVULVURXUCVVBTXVCWVDXURWKVYSWVBWUPUXLZ
      VWAWUNABLLYDWUTUXMYEWVDVWDWUPXVBHIVYSVWDWVCVVTVWBVWDVYQVVPUXNSVYSWVBWUPUX
      OVWCWUOUXPQYFZWVDWVMXUMVCZWVLVVEUIZWMZXVAWVDWVMWVLXVHWMXVIWVLVVEXRWVDWVLX
      VGXVHWVDVUOWVLVXSNWVLXVGRXUQWVDWVLVXNVXSWVDWVPWVQWVLVXNNWVSWVTWYBQWVDVUQV
      URVXTXVDWYRVYAQUXQWVLVUNVXSVYCXSQXTYAWVDXUMLIZXVHXUMIXVIXVAIWVDVUOXUPXVJX
      UQXUSWVLVUNYDYHYIWVDXVHVVEWVLUIZXUMWVLVVEWLWVDVVFXUTXVKXUMIVVPVVFVYRWVCVX
      RWCXVFVVEVUNWVLUXRQYJXVHXUMXVGXVGVIUXSQYFWVMXUMUXTQWEWVMWVKVUNBUYAQWVNBVX
      GVXLUYBWAXUAWVDXUJWKWUNWVNBVXGVXLUYCWAWEWVDWUOLIZWVEWVGNWVFWVJXIWVDVURWVB
      XVLWYRXVEWUNBWUTYHQWVDWUNWVEWVGWUNWUDUKWYSUYKWVEWUOWVGWVGVIUYDQYKYJYLYMVY
      SVXHWULWUMWVAJXIVYSVURVXHWUJVXMVQWUDEBVXGUYETUYFVYSVUTWUKBRVYSVULVUTVVPVU
      LVYRVXJSVVATBUYGTWDVVSWUDABLLUYHYEVYSVVQVYKWUEVVPVYMVYRVYNSVYSVVTVWFWUDIZ
      VYKWUEIVVTVWBVWDVYQVVPUYIVYSVXIVWAVWTVNZVVENZXVMVVPVXIVYRVYESVYSGFXVNVVEX
      VNYQVYSVWAVWTYNWKWWHXVNIWXKWWCVWTIZJVYSWWIWWGWWCVWAVWTYOVYSWXKXVPWWIVYSWX
      KJZWWIXVPWWGVWFVBZVVEIZXVQWWGVWJIZXVSVYSVWAVWJWWGWVRXCXVTWXSXVSVWHXVSCWWG
      VWICGXBVWGXVRVVEVVJWWGVWFWFWGWHYPTXVPWWHXVRVVEXVPWWCVWFWWGWWCVWFUYLUYMWGU
      YJYRYSYTWUCXVOUDVWFVXGVYTVWFRZWUBXVNVVEXWAWUAVWTVWAVYTVWFXQXNXOWHWIVVRVWF
      VVSWUDXEQYFVYSGFWUEVVEWUEYQVYSVVSWUDYNWKWWHWUEIGDUPZWYCJVYSWWIWWGWWCVVSWU
      DYOVYSXWBWYCWWIWYCWYKVYSXWBJZWWIWYCWYGWYKWUCWYKUDWWCVXGWYLWHYPXWCWWHWYJIZ
      WYKWWIXWCWXKWWCWYIIXWDVYSVVSVWAWWGVVTVWBVWDVYQVVPUYNXCWWCWYQUYOWWGWWCVWAW
      YIXEYIWYJVVEWWHUYPUYQUYRYRYSYTVVLWUGWUHJCWUEVUNVVJWUERVVIWUGVVKWUHVVJWUEV
      VQUYSVVJWUEVVEUYTWTVUBVUAYLVUCVUDYMVVHVUOVVGVVNXIVUMVUOVVFVVDSUBCVVEVUNVU
      ETYKVUFVUGVUNVUHWI $.
  $}

  ${
    $d a b f g h u v x R $.  $d a b f g h u v x S $.
    $( If the codomain space is Hausdorff, then the compact-open topology of
       continuous functions is also Hausdorff.  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    xkohaus $p |- ( ( R e. Top /\ S e. Haus ) -> ( S ^ko R ) e. Haus ) $=
      ( vf vg vu vv vx va vb vh wcel wa cv cin c0 wceq w3a wrex syl wss ctop co
      cha cxko wne wel wi cuni wral haustop xkotop sylan2 xkouni eleq2d anbi12d
      ccn eqid cfv wn wfn weq wb wf simprl cnf simprr eqfnfv syl2anc necon3abid
      ffn rexnal simpllr adantr ffvelrnd hausnei syl13anc expr syl5bir csn cima
      df-ne crab simp-4l ad4antlr simplr snssd crest ccmp ctopon toptopon sylib
      cpw restsn2 cfn snfi discmp mpbi syl6eqel simprll xkoopn simprlr ad2antrr
      fnsnfv simprr1 eqsstr3d imaeq1 sseq1d elrab sylanbrc simprr2 inrab adantl
      cdm fdm eleqtrrd simprr3 sseq0 expcom imadisj disjsn bitri syl6ib sylnibr
      mt2d ssin rabeq0 sylibr syl5eq eleq2 ineq1 eqeq1d 3anbi13d ineq2 3anbi23d
      ralrimiva rspc2ev syl113anc rexlimdvva syld rexlimdva sylbid ex ralrimivv
      sylbird ishaus ) AUAKZBUCKZLZBAUDUBZUAKZCMZDMZUEZCEUFZDFUFZEMZFMZNZOPZQZF
      UUIREUUIRZUGZDUUIUHZUICUVCUIUUIUCKUUGUUFBUAKZUUJBUJZABUKULUUHUVBCDUVCUVCU
      UHUUKUVCKZUULUVCKZLUUKABUPUBZKZUULUVHKZLZUVBUUHUVIUVFUVJUVGUUHUVHUVCUUKUU
      GUUFUVDUVHUVCPUVEABUUIUUIUQUMULZUNUUHUVHUVCUULUVLUNUOUUHUVKUVBUUHUVKLZUUM
      GMZUUKURZUVNUULURZPZGAUHZUIZUSZUVAUVMUVSUUKUULUVMUUKUVRUTZUULUVRUTZCDVAUV
      SVBUVMUVRBUHZUUKVCZUWAUVMUVIUWDUUHUVIUVJVDZUUKABUVRUWCUVRUQZUWCUQZVESZUVR
      UWCUUKVJSZUVMUVRUWCUULVCZUWBUVMUVJUWJUUHUVIUVJVFZUULABUVRUWCUWFUWGVESZUVR
      UWCUULVJSZGUVRUUKUULVGVHVIUVTUVQUSZGUVRRUVMUVAUVQGUVRVKUVMUWNUVAGUVRUVMUV
      NUVRKZLZUWNUVOHMZKZUVPIMZKZUWQUWSNZOPZQZIBRHBRZUVAUWNUVOUVPUEZUWPUXDUVOUV
      PWAUVMUWOUXEUXDUVMUWOUXELZLZUUGUVOUWCKUVPUWCKUXEUXDUUFUUGUVKUXFVLUXGUVRUW
      CUVNUUKUVMUWDUXFUWHVMUVMUWOUXEVDZVNUXGUVRUWCUVNUULUVMUWJUXFUWLVMUXHVNUVMU
      WOUXEVFUVOUVPIHBUWCUWGVOVPVQVRUWPUXCUVAHIBBUWPUWQBKZUWSBKZLZUXCUVAUWPUXKU
      XCLZLZJMZUVNVSZVTZUWQTZJUVHWBZUUIKUXPUWSTZJUVHWBZUUIKUUKUXRKZUULUXTKZUXRU
      XTNZOPZUVAUXMUXOABUWQJUVRUWFUUFUUGUVKUWOUXLWCZUUGUVDUUFUVKUWOUXLUVEWDZUXM
      UVNUVRUVMUWOUXLWEZWFZUXMAUXOWGUBZUXOWLZWHUXMAUVRWIURKZUWOUYIUYJPUXMUUFUYK
      UYEAUVRUWFWJWKUYGUVNAUVRWMVHUXOWNKUYJWHKUVNWOUXOWPWQWRZUWPUXIUXJUXCWSWTUX
      MUXOABUWSJUVRUWFUYEUYFUYHUYLUWPUXIUXJUXCXAWTUXMUVIUUKUXOVTZUWQTZUYAUVMUVI
      UWOUXLUWEXBUXMUYMUVOVSZUWQUXMUWAUWOUYOUYMPUVMUWAUWOUXLUWIXBUYGUVRUVNUUKXC
      VHUXMUVOUWQUWRUWTUXBUXKUWPXDWFXEUXQUYNJUUKUVHJCVAUXPUYMUWQUXNUUKUXOXFXGXH
      XIUXMUVJUULUXOVTZUWSTZUYBUVMUVJUWOUXLUWKXBUXMUYPUVPVSZUWSUXMUWBUWOUYRUYPP
      UVMUWBUWOUXLUWMXBUYGUVRUVNUULXCVHUXMUVPUWSUWRUWTUXBUXKUWPXJWFXEUXSUYQJUUL
      UVHJDVAUXPUYPUWSUXNUULUXOXFXGXHXIUXMUYCUXQUXSLZJUVHWBZOUXQUXSJUVHXKUXMUYS
      USZJUVHUIUYTOPUXMVUAJUVHUXMUXNUVHKZLZUXPUXATZUYSVUCVUDUVNUXNXMZKZVUCUVNUV
      RVUEUVMUWOUXLVUBVLVUBVUEUVRPZUXMVUBUVRUWCUXNVCVUGUXNABUVRUWCUWFUWGVEUVRUW
      CUXNXNSXLXOVUCVUDUXPOPZVUFUSZVUCUXBVUDVUHUGUXMUXBVUBUWRUWTUXBUXKUWPXPVMVU
      DUXBVUHUXPUXAXQXRSVUHVUEUXONOPVUIUXNUXOXSVUEUVNXTYAYBYDUXPUWQUWSYEYCYOUYS
      JUVHYFYGYHUUTUYAUYBUYDQUYAUUOUXRUUQNZOPZQEFUXRUXTUUIUUIUUPUXRPZUUNUYAUUSV
      UKUUOUUPUXRUUKYIVULUURVUJOUUPUXRUUQYJYKYLUUQUXTPZUUOUYBVUKUYDUYAUUQUXTUUL
      YIVUMVUJUYCOUUQUXTUXRYMYKYNYPYQVQYRYSYTVRUUAUUBUUDUUCCDFEUUIUVCUVCUQUUEXI
      $.
  $}

  ${
    $d f g k n u w x y z R $.  $d f g k n u w x y z S $.
    $d f g k n u w x y z X $.
    xkoptsub.x $e |- X = U. R $.
    xkoptsub.j $e |- J = ( Xt_ ` ( X X. { S } ) ) $.
    $( The compact-open topology is finer than the product topology restricted
       to continuous functions.  (Contributed by Mario Carneiro,
       19-Mar-2015.) $)
    xkoptsub $p |- ( ( R e. Top /\ S e. Top ) ->
      ( J |`t ( R Cn S ) ) C_ ( S ^ko R ) ) $=
      ( vk vu vw vx ctop wcel wa co cv cfv wceq eqid wss cvv vg vy vz vn vf ccn
      crest cuni cmap csn cmpt ccnv cima cmpt2 crn cun cfi ctg cxko cxp cpt wfn
      wral cdif cfn wrex w3a cixp wex cab topopn adantr wf fconstg adantl ptval
      ffn syl syl2anc simpr snssd ptbasfi fvconst2g adantll ixpeq2dva ixpconstg
      fss unieqd syl2an eqtrd mpteq1d imaeq1d ralrimivw jca ralrimiva mpt2eq123
      sneqd cnveqd sylancr uneq12d fveq2d syl5eq oveq1d firest fveq2i fvex ovex
      rneqd tgrest mp2an eqtri syl6eqr xkotop snex mpt2exga sylan rnexg restval
      cin unexg sylancl wo elun cnf elmapg syl2anr syl5ibr ssrdv elsni sseqtr4d
      wb dfss1 sylib xkouni eqeltrd eleq1d bitrd ccmp sylan2b eqsstrd crab cres
      rnmpt2 abeq2i cnvresima resmpt rgenw fnmpt mp1i elpreima fveq1 fvmpt snss
      syl5eqr sselda elmapi simplrl fnsnfv sseq1d syl5bb pm5.32da df-rab simpll
      3syl abbi2dv simprl cpw ctopon toptopon restsn2 snfi discmp mpbi syl6eqel
      simprr xkoopn ineq1 syl5ibrcom rexlimdvva imp jaodan fmptd frn tgfiss ) A
      KLZBKLZMZCABUFNZUGNZBUHZDUINZUJZGHDBIUWKGOZIOZPZUKZULZHOZUMZUNZUOZUPZUWHU
      GNZUQPZURPZBAUSNZUWGUWIUXBUQPZURPZUWHUGNZUXEUWGCUXHUWHUGUWGCDBUJZUTZVAPZU
      XHFUWGUXLUAOZDVBUBOZUXMPZUXNUXKPZLUBDVCUXOUXPUHQUBDUCOVDVCUCVEVFVGJOZUBDU
      XOVHQMUAVIJVJZURPZUXHUWGDALZUXKDVBZUXLUXSQUWEUXTUWFADEVKZVLZUWGDUXJUXKVMZ
      UYAUWFUYDUWEDBKVNVOZDUXJUXKVQVRJUBUCDUXRUAUXKAUXRRZVPVSUWGUXRUXGURUWGUXRU
      DDUDOZUXKPZUHZVHZUJZGHDUWMUXKPZIUYJUWOUKZULZUWRUMZUNZUOZUPZUQPZUXGUWGUXTD
      KUXKVMZUXRUYSQUYCUWGUYDUXJKSUYTUYEUWGBKUWEUWFVTZWADUXJKUXKWGVSJUBUCIHDUXR
      UAGUDUXKAUYJUYFUYJRWBVSUWGUYRUXBUQUWGUYKUWLUYQUXAUWGUYJUWKUWGUYJUDDUWJVHZ
      UWKUWGUDDUYIUWJUWGUYGDLZMUYHBUWFVUCUYHBQUWEDBUYGKWCWDWHWEUWEUXTUWJBLZVUBU
      WKQUWFUYBBUWJUWJRZVKZUDDUWJABWFWIWJZWQUWGUYPUWTUWGDDQUYLBQZUYOUWSQZHUYLVC
      ZMZGDVCUYPUWTQDRUWGVUKGDUWGUWMDLZMZVUHVUJUWFVULVUHUWEDBUWMKWCWDVUMVUIHUYL
      VUMUYNUWQUWRVUMUYMUWPVUMIUYJUWKUWOUWGUYJUWKQVULVUGVLWKWRWLWMWNWOGHDUYLUYO
      DBUWSWPWSXHWTXAWJXAWJXBXCUXEUXGUWHUGNZURPZUXIUXDVUNURUWHUXBXDXEUXGTLUWHTL
      ZVUOUXIQUXBUQXFABUFXGZUWHUXGTTXIXJXKXLUWGUXFKLZUXCUXFSUXEUXFSABXMZUWGUXCJ
      UXBUXQUWHXSZUKZUOZUXFUWGUXBTLZVUPUXCVVBQUWGUWLTLUXATLZVVCUWKXNUWGUWTTLZVV
      DUWEUXTUWFVVEUYBGHDBUWSAKXOXPUWTTXQVRUWLUXATTXTWSVUQJUWHUXBTTXRYAUWGUXBUX
      FVVAVMVVBUXFSUWGJUXBVUTUXFVVAUXQUXBLUWGUXQUWLLZUXQUXALZYBVUTUXFLZUXQUWLUX
      AYCUWGVVFVVHVVGUWGVVFMZVUTUWHUXFVVIUWHUXQSVUTUWHQVVIUWHUWKUXQUWGUWHUWKSZV
      VFUWGJUWHUWKUXQUWHLUXQUWKLZUWGDUWJUXQVMZUXQABDUWJEVUEYDUWFVUDUXTVVKVVLYKU
      WEVUFUYBUWJDUXQBAYEYFYGYHZVLVVFUXQUWKQUWGUXQUWKYIVOYJUWHUXQYLYMUWGUWHUXFL
      VVFUWGUWHUXFUHZUXFABUXFUXFRYNUWGVURVVNUXFLVUSUXFVVNVVNRVKVRYOVLYOVVGUWGUX
      QUWSQZHBVFGDVFZVVHVVPJUXAGHJDBUWSUWTUWTRUUCUUDUWGVVPVVHUWGVVOVVHGHDBUWGVU
      LUWRBLZMZMZVVHVVOUWSUWHXSZUXFLVVSVVTUEOZUWMUJZUMZUWRSZUEUWHUUAZUXFVVSVVTI
      UWHUWOUKZULZUWRUMZVWEVVSVVTUWPUWHUUBZULZUWRUMVWHUWHUWRUWPUUEVVSVWJVWGUWRV
      VSVWIVWFVVSVVJVWIVWFQUWGVVJVVRVVMVLZIUWKUWHUWOUUFVRWRWLUUNVVSVWHVWAUWHLZV
      WDMZUEVJVWEVVSVWMUEVWHVVSVWAVWHLZVWLVWAVWFPZUWRLZMZVWMVVSVWFUWHVBZVWNVWQY
      KUWOTLZIUWHVCVWRVVSVWSIUWHUWMUWNXFUUGIUWHUWOVWFTVWFRZUUHUUIUWHVWAUWRVWFUU
      JVRVVSVWLVWPVWDVVSVWLMZVWPUWMVWAPZUWRLZVWDVXAVWOVXBUWRVWLVWOVXBQVVSIVWAUW
      OVXBUWHVWFUWMUWNVWAUUKVWTUWMVWAXFZUULVOYPVXCVXBUJZUWRSVXAVWDVXBUWRVXDUUMV
      XAVXEVWCUWRVXAVWADVBZVULVXEVWCQVXAVWAUWKLDUWJVWAVMVXFVVSUWHUWKVWAVWKUUOVW
      AUWJDUUPDUWJVWAVQUVDUWGVULVVQVWLUUQDUWMVWAUURVSUUSUUTYQUVAYQUVEVWDUEUWHUV
      BXLWJVVSVWBABUWRUEDEUWEUWFVVRUVCZUWGUWFVVRVUAVLVVSUWMDUWGVULVVQUVFZWAVVSA
      VWBUGNZVWBUVGZYRVVSADUVHPLZVULVXIVXJQVVSUWEVXKVXGADEUVIYMVXHUWMADUVJVSVWB
      VELVXJYRLUWMUVKVWBUVLUVMUVNUWGVULVVQUVOUVPYOVVOVUTVVTUXFUXQUWSUWHUVQYPUVR
      UVSUVTYSUWAYSVVARUWBUXBUXFVVAUWCVRYTUXCUXFUWDVSYT $.
  $}

  ${
    $d f g k v x y z A $.  $d f g k v x y z R $.  $d f g k v x y z V $.
    $( The compact-open topology on a discrete set coincides with the product
       topology where all the factors are the same.  (Contributed by Mario
       Carneiro, 19-Mar-2015.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
    xkopt $p |- ( ( R e. Top /\ A e. V ) ->
      ( R ^ko ~P A ) = ( Xt_ ` ( A X. { R } ) ) ) $=
      ( vk vv vx vf ctop wcel wa co cfv wss wceq adantl eqid syl2anc cfn syl wb
      cpw cxko csn cxp cpt cv crest ccmp crab cima ccn cmpt2 crn cfi ctg distop
      simpl cuni unipw eqcomi xkoval wf simpr fconst6g adantr cmap wrex cin cab
      pttop elpwi restdis sylan2 adantll eleq1d discmp syl6bbr rabbidva syl6eqr
      dfin5 eqidd ctopon toptopon cndis ancoms sylanb mpt2eq123dv rnmpt2 syl6eq
      rabeq rneqd cif cixp elmapi wral eleq2 imbi2d bibi1d simprl sseldi elpwid
      wi inss1 sselda imbi1d wn ffvelrn ex pm2.21 ifbothda ralbidv2 wfn ffn vex
      2thd elixp baib wfun cdm fdm sseqtr4d funimass4 3bitr4d rabbi2dva elssuni
      ffun ad2antll ssid ifboth sylancl ralrimivw ss2ixp simplr uniexg ad2antrr
      sseq1 cvv ixpconstg eqsstrd eqtrd sseqtrd dfss1 sylib eqtr3d inss2 topopn
      simplrr ad3antrrr ifcl simpll fvconst2g sylan eleqtrrd cdif eldifn eldifi
      iffalse unieqd eqtr4d ptopn eleq1 syl5ibrcom rexlimdvva abssdv ptuniconst
      eqeltrd tgfiss oveq2d restid xkoptsub eqsstr3d eqssd ) BHIZACIZJZBAUAZUBK
      ZABUCUDZUELZUVOUVQDEUVPFUFZUGKZUHIZFUVPUIZBGUFZDUFZUJEUFZMZGUVPBUKKZUIZUL
      ZUMZUNLUOLZUVSUVOUVPHIZUVMUVQUWLNUVNUWMUVMACUPOZUVMUVNUQZFEUVPBUWJGDUWCAU
      VPURAAUSUTZUWCPUWJPVAQUVOUVSHIZUWKUVSMUWLUVSMUVOUVNAHUVRVBZUWQUVMUVNVCUVM
      UWRUVNABHVDZVEAUVRCVJQZUVOUWKUVTUWGGBURZAVFKZUIZNZEBVGDUVPRVHZVGZFVIZUVSU
      VOUWKDEUXEBUXCULZUMUXGUVOUWJUXHUVODEUWCBUWIUXEBUXCUVOUWCUVTRIZFUVPUIUXEUV
      OUWBUXIFUVPUVOUVTUVPIZJZUWBUVTUAZUHIUXIUXKUWAUXLUHUVNUXJUWAUXLNZUVMUXJUVN
      UVTAMUXMUVTAVKAUVTCVLVMVNVOUVTVPVQVRFUVPRVTVSUVOBWAUVOUWHUXBNZUWIUXCNUVMB
      UXAWBLIZUVNUXNBUXAUXAPZWCUVNUXOUXNABCUXAWDWEWFZUWGGUWHUXBWJSWGWKDEFUXEBUX
      CUXHUXHPWHWIUVOUXFFUVSUVOUXDUVTUVSIZDEUXEBUVOUWEUXEIZUWFBIZJZJZUXRUXDUXCU
      VSIUYBUXCFAUVTUWEIZUWFUXAWLZWMZUVSUYBUXBUYEVHZUXCUYEUYBUWGGUXBUYEUWDUXBIU
      YBAUXAUWDVBZUWDUYEIZUWGTUWDUXAAWNUYBUYGJZUVTUWDLZUYDIZFAWOZUYJUWFIZFUWEWO
      ZUYHUWGUYIUYKUYMFAUWEUYCUVTAIZUYMXBZUYCUYMXBZTUYOUYJUXAIZXBZUYQTUYOUYKXBZ
      UYQTUYIUWFUXAUWFUYDNZUYPUYTUYQVUAUYMUYKUYOUWFUYDUYJWPWQWRUXAUYDNZUYSUYTUY
      QVUBUYRUYKUYOUXAUYDUYJWPWQWRUYIUYCJZUYOUYCUYMVUCUYOUYCUYIUWEAUVTUYBUWEAMU
      YGUYBUWEAUYBUXEUVPUWEUVPRXCUVOUXSUXTWSZWTXAVEZXDUYIUYCVCXOXEUYIUYCXFZJUYS
      UYQUYIUYSVUFUYGUYSUYBUYGUYOUYRAUXAUVTUWDXGXHOVEVUFUYQUYIUYCUYMXIOXOXJXKUY
      IUWDAXLZUYHUYLTUYGVUGUYBAUXAUWDXMOUYHVUGUYLFAUYDUWDGXNXPXQSUYIUWDXRZUWEUW
      DXSZMUWGUYNTUYGVUHUYBAUXAUWDYFOUYIUWEAVUIVUEUYGVUIANUYBAUXAUWDXTOYAFUWEUW
      FUWDYBQYCVMYDUYBUYEUXBMUYFUYENUYBUYEFAUXAWMZUXBUYBUYDUXAMZFAWOUYEVUJMUYBV
      UKFAUYBUWFUXAMZUXAUXAMZVUKUXTVULUVOUXSUWFBYEYGUXAYHUYCVULVUMVUKUWFUXAUWFU
      YDUXAYPUXAUYDUXAYPYIYJYKFAUYDUXAYLSUYBUVNUXAYQIZVUJUXBNUVMUVNUYAYMZUVMVUN
      UVNUYABHYNYOFAUXACYQYRQUUAUYEUXBUUBUUCUUDUYBAUYDFUVRCUWEVUOUVMUWRUVNUYAUW
      SYOUYBUXERUWEUVPRUUEVUDWTUYBUYOJZUYDBUVTUVRLZVUPUXTUXABIZUYDBIUVOUXSUXTUY
      OUUGUVMVURUVNUYAUYOBUXAUXPUUFUUHUYCUWFUXABUUIQUYBUVMUYOVUQBNZUVMUVNUYAUUJ
      ABUVTHUUKUULZUUMUYBUVTAUWEUUNIZJZUYDUXAVUQURVVAUYDUXANZUYBVVAVUFVVCUVTAUW
      EUUOUYCUWFUXAUUQSOVVBVUQBVVAUYBUYOVUSUVTAUWEUUPVUTVMUURUUSUUTUVFUVTUXCUVS
      UVAUVBUVCUVDYSUWKUVSUVGQYSUVOUVSUVSUWHUGKZUVQUVOVVDUVSUVSURZUGKZUVSUVOUWH
      VVEUVSUGUVOUWHUXBVVEUXQUVNUVMUXBVVENABUVSCUXAUVSPZUXPUVEWEYTUVHUVOUWQVVFU
      VSNUWTUVSHVVEVVEPUVISYTUVOUWMUVMVVDUVQMUWNUWOUVPBUVSAUWPVVGUVJQUVKUVL $.
  $}

  ${
    $d f A $.  $d f R $.  $d f S $.  $d f X $.
    xkopjcn.1 $e |- X = U. R $.
    $( Continuity of a projection map from the space of continuous functions.
       (This theorem can be strengthened, to joint continuity in both ` f ` and
       ` A ` as a function on ` ( S ^ko R ) tX R ` , but not without stronger
       assumptions on ` R ` ; see ~ xkofvcn .)  (Contributed by Mario Carneiro,
       3-Feb-2015.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    xkopjcn $p |- ( ( R e. Top /\ S e. Top /\ A e. X ) ->
      ( f e. ( R Cn S ) |-> ( f ` A ) ) e. ( ( S ^ko R ) Cn S ) ) $=
      ( ctop wcel cfv ccn co cmpt cuni ctopon wss eqid 3adant3 wceq wf syl2anc
      w3a csn cxp cpt crest cv xkotopon topopn 3ad2ant1 fconst6g 3ad2ant2 pttop
      cxko cmap cnf cvv wb uniexg elmapg syl5ibr ssrdv simp2 ptuniconst sseqtrd
      restuni fveq2d eleqtrd xkoptsub cnss1 cres resmpt simp3 syl3anc fvconst2g
      syl ptpjcn 3adant1 oveq2d cnrest eqeltrrd sseldd ) BGHZCGHZAEHZUAZECUBUCZ
      UDIZBCJKZUEKZCJKZCBUMKZCJKZDWHADUFZIZLZWEWKWIMZNIZHWIWKOZWJWLOWEWKWHNIZWQ
      WBWCWKWSHWDBCWKWKPUGQWEWHWPNWEWGGHZWHWGMZOZWHWPRWEEBHZEGWFSZWTWBWCXCWDBEF
      UHUIZWCWBXDWDECGUJUKZEWFBULTWEWHCMZEUNKZXAWEDWHXHWMWHHWMXHHZWEEXGWMSZWMBC
      EXGFXGPZUOWEXGUPHZXCXIXJUQWCWBXLWDCGURUKXEXGEWMUPBUSTUTVAWEXCWCXHXARXEWBW
      CWDVBECWGBXGWGPZXKVCTVDZWHWGXAXAPZVETVFVGWBWCWRWDBCWGEFXMVHQWIWKCWPWPPVIT
      WEDXAWNLZWHVJZWOWJWEXBXQWORXNDXAWHWNVKVOWEXPWGCJKZHXBXQWJHWEXPWGAWFIZJKZX
      RWEXCXDWDXPXTHXEXFWBWCWDVLDEWFAWGBXAXOXMVPVMWEXSCWGJWCWDXSCRWBECAGVNVQVRV
      GXNWHXPWGCXAXOVSTVTWA $.
  $}

  ${
    $d g k v x ph $.  $d g h k v x y R $.  $d g k v x S $.  $d g h k v x y T $.
    $d g h k v x F $.
    xkoco1cn.t $e |- ( ph -> T e. Top ) $.
    xkoco1cn.f $e |- ( ph -> F e. ( R Cn S ) ) $.
    $( If ` F ` is a continuous function, then ` g |-> g o. F ` is a continuous
       function on function spaces.  (The reason we prove this and ~ xkoco2cn
       independently of the more general ~ xkococn is because that requires
       some inconvenient extra assumptions on ` S ` .)  (Contributed by Mario
       Carneiro, 20-Mar-2015.) $)
    xkoco1cn $p |- ( ph ->
      ( g e. ( S Cn T ) |-> ( g o. F ) ) e. ( ( T ^ko S ) Cn ( T ^ko R ) ) ) $=
      ( vx vk vv vy vh ccn co cv wcel cima eqid wa ccom cmpt cxko wf ccnv crest
      ccmp cuni cpw crab wss cmpt2 crn wral cnco sylan wceq wrex xkobval abeq2i
      fmptd ad2antrr imaeq1 imaco syl6eq sseq1d elrab3 syl rabbidva ctop cntop2
      imassrn cnf frn 3syl syl5ss imacmp sylancom simplrr xkoopn eqeltrd imaeq2
      mptpreima eleq1d syl5ibrcom expimpd rexlimdvva syl5bi ralrimiv cvv ctopon
      wb cfv xkotopon syl2anc ovex pwex cxp xkotf ax-mp ssexi a1i cntop1 xkoval
      cfi ctg subbascn mpbir2and ) AECDNOZEPZFUAZUBZDCUCOZDBUCOZNOQXIBDNOZXLUDX
      LUEZIPZRZXMQZIJKBLPUFOUGQLBUHZUIZUJZDMPZJPZRZKPZUKZMXOUJZULZUMZUNAEXIXKXO
      XLAFBCNOQZXJXIQZXKXOQZHFXJBCDUOZUPXLSZVAAXSIYJXQYJQBYDUFOUGQZXQYHUQZTZKDU
      RJYAURZAXSYSIYJLKBDYIMJYBXTIXTSZYBSZYISZUSUTAYRXSJKYADAYDYAQZYFDQZTZTZYPY
      QXSUUFYPTZXSYQXKYHQZEXIUJZXMQUUGUUIXJFYDRZRZYFUKZEXIUJXMUUGUUHUULEXIUUGYL
      TYMUUHUULWLUUGYKYLYMAYKUUEYPHVBZYNUPYGUULMXKXOYCXKUQZYEUUKYFUUNYEXKYDRUUK
      YCXKYDVCXJFYDVDVEVFVGVHVIUUGUUJCDYFECUHZUUOSZACVJQZUUEYPAYKUUQHFBCVKVHZVB
      ADVJQZUUEYPGVBUUGUUJFUMZUUOFYDVLUUGYKXTUUOFUDUUTUUOUKUUMFBCXTUUOYTUUPVMXT
      UUOFVNVOVPUUFYPYKCUUJUFOUGQUUMYDFBCVQVRAUUCUUDYPVSVTWAYQXRUUIXMYQXRXPYHRU
      UIXQYHXPWBEXIXKYHXLYOWCVEWDWEWFWGWHWIAIYJXLXMXNWJXIXOAUUQUUSXMXIWKWMQUURG
      CDXMXMSWNWOYJWJQAYJXOUIZXOBDNWPWQYBDWRZUVAYIUDYJUVAUKLKBDYIMJYBXTYTUUAUUB
      WSUVBUVAYIVNWTXAXBABVJQZUUSXNYJXEWMXFWMUQAYKUVCHFBCXCVHZGLKBDYIMJYBXTYTUU
      AUUBXDWOAUVCUUSXNXOWKWMQUVDGBDXNXNSWNWOXGXH $.
  $}

  ${
    $d g k v x ph $.  $d g h k v x y R $.  $d g k v x S $.  $d g h k v x y T $.
    $d g h k v x F $.
    xkoco2cn.r $e |- ( ph -> R e. Top ) $.
    xkoco2cn.f $e |- ( ph -> F e. ( S Cn T ) ) $.
    $( If ` F ` is a continuous function, then ` g |-> F o. g ` is a continuous
       function on function spaces.  (Contributed by Mario Carneiro,
       23-Mar-2015.) $)
    xkoco2cn $p |- ( ph ->
      ( g e. ( R Cn S ) |-> ( F o. g ) ) e. ( ( S ^ko R ) Cn ( T ^ko R ) ) ) $=
      ( vx vk vv vh co cv wcel cima wss syl2anc eqid syl vy ccom cmpt cxko ccnv
      ccn wf crest ccmp cuni cpw crab cmpt2 crn wral wa simpr adantr cnco fmptd
      wceq wrex xkobval abeq2i ad3antrrr imaeq1 imaco syl6eq sseq1d elrab3 wfun
      wb cdm cnf ffun imassrn frn syl5ss sseqtr4d funimass3 bitrd rabbidva ctop
      fdm ad2antrr cntop1 simplrl elpwid simplrr cnima xkoopn eqeltrd mptpreima
      imaeq2 eleq1d syl5ibrcom expimpd rexlimdvva syl5bi ralrimiv xkotopon ovex
      cvv ctopon cfv pwex cxp xkotf ax-mp ssexi a1i cfi cntop2 xkoval mpbir2and
      ctg subbascn ) AEBCUFMZFENZUBZUCZCBUDMZDBUDMZUFMOXRBDUFMZYAUGYAUEZINZPZYB
      OZIJKBUANUHMUIOUABUJZUKZULZDLNZJNZPZKNZQZLYDULZUMZUNZUOAEXRXTYDYAAXSXROZU
      PYTFCDUFMOZXTYDOZAYTUQAUUAYTHURXSFBCDUSZRYASZUTAYHIYSYFYSOBYMUHMUIOZYFYQV
      AZUPZKDVBJYJVBZAYHUUHIYSUAKBDYRLJYKYIIYISZYKSZYRSZVCVDAUUGYHJKYJDAYMYJOZY
      ODOZUPZUPZUUEUUFYHUUOUUEUPZYHUUFXTYQOZEXRULZYBOUUPUURXSYMPZFUEYOPZQZEXRUL
      YBUUPUUQUVAEXRUUPYTUPZUUQFUUSPZYOQZUVAUVBUUBUUQUVDVLUVBYTUUAUUBUUPYTUQZAU
      UAUUNUUEYTHVEUUCRYPUVDLXTYDYLXTVAZYNUVCYOUVFYNXTYMPUVCYLXTYMVFFXSYMVGVHVI
      VJTUVBFVKZUUSFVMZQUVDUVAVLUVBCUJZDUJZFUGZUVGAUVKUUNUUEYTAUUAUVKHFCDUVIUVJ
      UVISZUVJSVNTVEZUVIUVJFVOTUVBUUSUVIUVHUVBUUSXSUNZUVIXSYMVPUVBYIUVIXSUGZUVN
      UVIQUVBYTUVOUVEXSBCYIUVIUUIUVLVNTYIUVIXSVQTVRUVBUVKUVHUVIVAUVMUVIUVJFWDTV
      SUUSYOFVTRWAWBUUPYMBCUUTEYIUUIABWCOZUUNUUEGWEACWCOZUUNUUEAUUAUVQHFCDWFTZW
      EUUPYMYIAUULUUMUUEWGWHUUOUUEUQUUPUUAUUMUUTCOAUUAUUNUUEHWEAUULUUMUUEWIYOFC
      DWJRWKWLUUFYGUURYBUUFYGYEYQPUURYFYQYEWNEXRXTYQYAUUDWMVHWOWPWQWRWSWTAIYSYA
      YBYCXCXRYDAUVPUVQYBXRXDXEOGUVRBCYBYBSXARYSXCOAYSYDUKZYDBDUFXBXFYKDXGZUVSY
      RUGYSUVSQUAKBDYRLJYKYIUUIUUJUUKXHUVTUVSYRVQXIXJXKAUVPDWCOZYCYSXLXEXPXEVAG
      AUUAUWAHFCDXMTZUAKBDYRLJYKYIUUIUUJUUKXNRAUVPUWAYCYDXDXEOGUWBBDYCYCSXARXQX
      O $.
  $}

  ${
    $d a k s u v w x y z A $.  $d b k s u v w x y z B $.  $d k s u v w x ph $.
    $d a b f g h k u v w x y z R $.  $d a b f g k s u v w x y z S $.
    $d b h k s u v w x y z K $.  $d a b f g h k u v w x y z T $.
    $d a b k u v w x y z F $.  $d a h k s u v w x y z V $.
    xkococn.1 $e |- F = ( f e. ( S Cn T ) , g e. ( R Cn S ) |-> ( f o. g ) ) $.
    ${
      xkococn.s $e |- ( ph -> S e. N-Locally Comp ) $.
      xkococn.k $e |- ( ph -> K C_ U. R ) $.
      xkococn.c $e |- ( ph -> ( R |`t K ) e. Comp ) $.
      xkococn.v $e |- ( ph -> V e. T ) $.
      xkococn.a $e |- ( ph -> A e. ( S Cn T ) ) $.
      xkococn.b $e |- ( ph -> B e. ( R Cn S ) ) $.
      xkococn.i $e |- ( ph -> ( ( A o. B ) " K ) C_ V ) $.
      $( Continuity of the composition operation as a function on continuous
         function spaces.  (Contributed by Mario Carneiro, 20-Mar-2015.)
         (Revised by Mario Carneiro, 22-Aug-2015.) $)
      xkococnlem $p |- ( ph -> E. z e. ( ( T ^ko S ) tX ( S ^ko R ) )
        ( <. A , B >. e. z /\
          z C_ ( `' F " { h e. ( R Cn T ) | ( h " K ) C_ V } ) ) ) $=
        ( vw vk vy vx vs vu va vb vv cima crest co cuni cv wceq ccnv cpw wf cfv
        cnt wss ccmp wcel wa wral wex cfn cin wrex cop ccn crab cxko ctx imacmp
        wel syl2anc w3a cnlly adantr cnima ccom imaco syl5eqssr wfun cdm wb cnf
        eqid ffun 3syl crn imassrn frn syl5ss fdm funimass3 mpbid sselda nlly2i
        sseqtr4d syl3anc ctop cvv nllytop syl ad3antrrr sylanbrc sstrd syl22anc
        simprl eleq2 sseq1 anbi12d rspcev syl12anc mpd ciun cxp ad2antrr xkotop
        sylib simprrl simprrr ralimi xkoopn eqsstrd iunss ralimdv imaeq1 sseq1d
        ex sylc elrab ss2iun vex coex ssrab2 mp2an elrestr simprr1 simpllr elin
        imaexg inss1 elpwi ad2antlr elssuni simprr2 ssntr jca anbi1d rexlimdvaa
        simprr3 reximdva rexcom r19.42v rexbii ralrimiva restuni raleqdv sseq2d
        bitri fveq2 eleq1d cmpcovf eqeq1d biimpar cntop2 cntop1 sspwuni wfn ffn
        oveq2 wi fniunfv oveq2d inss2 simplr sseldi simpr fiuncmp ntropn iunopn
        eqeltrrd txopn imaiun imaeq2d syl5eqr simpl1 3ad2ant2 r19.21bi ralbidva
        simp3 3bitr4g mpbird eqsstr3d uniiun syl6eq simpl opelxpi anbi12i coeq1
        simprll coeq2 ovmpt2 cnco ntrss2 sseqtrd imass2 simprlr eqeltrd sylan2b
        syl5eqss ralrimivva mpt2fun xpss12 dmmpt2 funimassov sylibr expr syldan
        sseqtr4i exlimdv expimpd rexlimdva ) AFDLUKZULUMZUNZUBUOZUNZUPZUYKCUQMU
        KZURZUCUOZUSZUDUOZUYRUYPUTZFVAUTZUTZVBZFUYSULUMZVCVDZVEZUDUYKVFZVEZUCVG
        ZVEZUBUYIURZVHVIZVJZCDVKZBUOZVDZVUNKUQJUOZLUKZMVBZJEGVLUMZVMZUKZVBZVEZB
        GFVNUMZFEVNUMZVOUMZVJZAUYIVCVDZUEUDVQZUYRUFUOZUYTUTZVBZFVVJULUMZVCVDZVE
        ZUFUYOVJVEZUDUYIVJZUEUYJVFZVULADEFVLUMZVDZELULUMVCVDZVVHTQLDEFVPVRAVVQU
        EUYHVFVVRAVVQUEUYHAUEUOZUYHVDZVEZVVIVVOVEZUDUYIVJZUFUYOVJZVVQVWDUEUGVQZ
        UGUOZVVJVBZVVNVSZUGFVJZUFUYOVJZVWGVWDFVCVTVDZUYNFVDZVWBUYNVDVWMAVWNVWCO
        WAAVWOVWCACFGVLUMZVDZMGVDZVWOSRMCFGWBVRZWAAUYHUYNVWBACUYHUKZMVBZUYHUYNV
        BZAVWTCDWCLUKMCDLWDUAWEACWFZUYHCWGZVBVXAVXBWHAVWQFUNZGUNZCUSZVXCSCFGVXE
        VXFVXEWJZVXFWJWIZVXEVXFCWKWLZAUYHVXEVXDAUYHDWMZVXEDLWNAVVTEUNZVXEDUSVXK
        VXEVBTDEFVXLVXEVXLWJZVXHWIVXLVXEDWOWLWPZAVWQVXGVXDVXEUPZSVXIVXEVXFCWQWL
        ZXBUYHMCWRVRWSWTUGVCVWBUYNFUFXAXCVWDVWLVWFUFUYOVWDVVJUYOVDZVEZVWKVWFUGF
        VXRVWIFVDZVWKVEZVEZVWIUYHVIZUYIVDZVWBVYBVDZVYBVVKVBZVVNVEZVWFVYAFXDVDZU
        YHXEVDZVXSVYCAVYGVWCVXQVXTAVWNVYGOVCFXFXGZXHZAVYHVWCVXQVXTAVVTVYHTDLVVS
        UUEXGXHVXRVXSVWKXLZVWIUYHFXDXEUUAXCVYAVWHVWCVYDVWHVWJVVNVXSVXRUUBAVWCVX
        QVXTUUCVWBVWIUYHUUDXIVYAVYEVVNVYAVYBVWIVVKVWIUYHUUFVYAVYGVVJVXEVBVXSVWJ
        VWIVVKVBVYJVYAVVJUYNVXEVXQVVJUYNVBVWDVXTVVJUYNUUGUUHAUYNVXEVBZVWCVXQVXT
        AVWOVYLVWSUYNFUUIZXGXHXJVYKVWHVWJVVNVXSVXRUUJVVJFVWIVXEVXHUUKXKWPVWHVWJ
        VVNVXSVXRUUOUULVWEVYDVYFVEUDVYBUYIUYRVYBUPZVVIVYDVVOVYFUYRVYBVWBXMVYNVV
        LVYEVVNUYRVYBVVKXNUUMXOXPXQUUNUUPXRVWGVWEUFUYOVJZUDUYIVJVVQVWEUFUDUYOUY
        IUUQVYOVVPUDUYIVVIVVOUFUYOUURUUSUVDYCUUTAVVQUEUYHUYJAVYGUYHVXEVBUYHUYJU
        PZVYIVXNUYHFVXEVXHUVAVRZUVBWSVVOVUEUEUDUFUYOUCUYIUYJUBUYJWJVVJUYSUPZVVL
        VUBVVNVUDVYRVVKVUAUYRVVJUYSUYTUVEUVCVYRVVMVUCVCVVJUYSFULUVOUVFXOUVGVRAV
        UIVVGUBVUKAUYKVUKVDZVEZUYMVUHVVGVYTUYMUYHUYLUPZVUHVVGUVPVYTWUAUYMVYTUYH
        UYJUYLAVYPVYSVYQWAUVHUVIVYTWUAVEVUGVVGUCVYTWUAVUGVVGVYTWUAVUGVEZVEZUHUO
        ZUYPWMZUNZUKZMVBZUHVWPVMZUIUOZLUKZUDUYKVUAXSZVBZUIVVSVMZXTZVVFVDZVUMWUO
        VDZWUOVVAVBZVVGWUCVVDXDVDZVVEXDVDZWUIVVDVDWUNVVEVDWUPWUCVYGGXDVDZWUSAVY
        GVYSWUBVYIYAZAWVAVYSWUBAVWQWVASCFGUVJXGYAZFGYBVRWUCEXDVDZVYGWUTAWVDVYSW
        UBAVVTWVDTDEFUVKXGYAZWVBEFYBVRWUCWUFFGMUHVXEVXHWVBWVCWUCWUFUYNVXEWUCWUE
        UYOVBZWUFUYNVBWUCUYQWVFVYTWUAUYQVUFYDZUYKUYOUYPWOXGWUEUYNUVLYCZWUCVWOVY
        LAVWOVYSWUBVWSYAVYMXGXJZWUCFUDUYKUYSXSZULUMZFWUFULUMVCWUCWVJWUFFULWUCUY
        QUYPUYKUVMZWVJWUFUPZWVGUYKUYOUYPUVNZUDUYKUYPUVQZWLZUVRWUCVYGUYKVHVDVUDU
        DUYKVFZWVKVCVDWVBWUCVUKVHUYKVUJVHUVSAVYSWUBUVTUWAWUCVUFWVQVYTWUAUYQVUFY
        EZVUEVUDUDUYKVUBVUDUWBYFXGUDUYKUYSFVXEVXHUWCXCUWFAVWRVYSWUBRYAYGWUCLEFW
        ULUIVXLVXMWVEWVBALVXLVBVYSWUBPYAAVWAVYSWUBQYAWUCVYGVUAFVDZUDUYKVFZWULFV
        DWVBWUCVYGUYSVXEVBZUDUYKVFZWVTWVBWUCWVJVXEVBWWBWUCWVJWUFVXEWVPWVIYHUDUY
        KUYSVXEYIYCZVYGWWAWVSUDUYKVYGWWAWVSUYSFVXEVXHUWDYMYJYNUDUYKVUAFUWEVRYGW
        UIWUNVVDVVEXDXDUWGXKWUCCWUIVDZDWUNVDZWUQWUCVWQCWUFUKZMVBZWWDAVWQVYSWUBS
        YAWUCWWFUDUYKCUYSUKZXSZMWUCWWICWVJUKWWFUDCUYKUYSUWHWUCWVJWUFCWVPUWIUWJW
        UCWWIMVBZWVJUYNVBZWUCWVJWUFUYNWVPWVHYHWUCVXCWVLWUFVXDVBZWWJWWKWHAVXCVYS
        WUBVXJYAWUCUYQWVLWVGWVNXGWUCWUFVXEVXDWVIAVXOVYSWUBVXPYAXBVXCWVLWWLVSZWW
        HMVBZUDUYKVFUYSUYNVBZUDUYKVFWWJWWKWWMWWNWWOUDUYKWWMUDUBVQZVEVXCUYSVXDVB
        ZWWNWWOWHVXCWVLWWLWWPUWKWWMWWQUDUYKWWMWVJVXDVBWWQUDUYKVFWWMWVJWUFVXDWVL
        VXCWVMWWLWVOUWLVXCWVLWWLUWOYHUDUYKUYSVXDYIYCUWMUYSMCWRVRUWNUDUYKWWHMYIU
        DUYKUYSUYNYIUWPXCUWQUWRWUHWWGUHCVWPWUDCUPWUGWWFMWUDCWUFYKYLYOXIWUCVVTUY
        HWULVBZWWEAVVTVYSWUBTYAWUCUYHUDUYKUYRXSZWULWUCUYHUYLWWSVYTWUAVUGXLUDUYK
        UWSUWTWUCVUFVUBUDUYKVFWWSWULVBWVRVUEVUBUDUYKVUBVUDUXAYFUDUYKUYRVUAYPWLY
        HWUMWWRUIDVVSWUJDUPWUKUYHWULWUJDLYKYLYOXICDWUIWUNUXBVRWUCKWUOUKVUTVBZWU
        RWUCVWIUJUOZKUMZVUTVDZUJWUNVFUGWUIVFZWWTWUCWXCUGUJWUIWUNVWIWUIVDZWXAWUN
        VDZVEWUCVWIVWPVDZVWIWUFUKZMVBZVEZWXAVVSVDZWXALUKZWULVBZVEZVEZWXCWXEWXJW
        XFWXNWUHWXIUHVWIVWPWUDVWIUPWUGWXHMWUDVWIWUFYKYLYOWUMWXMUIWXAVVSWUJWXAUP
        WUKWXLWULWUJWXALYKYLYOUXCWUCWXOVEZWXBVWIWXAWCZVUTWXPWXGWXKWXBWXQUPWUCWX
        GWXIWXNUXEZWUCWXJWXKWXMYDZHIVWIWXAVWPVVSHUOZIUOZWCZWXQKVWIWYAWCWXTVWIWY
        AUXDWYAWXAVWIUXFNVWIWXAUGYQUJYQYRUXGVRWXPWXQVUSVDZWXQLUKZMVBZWXQVUTVDWX
        PWXKWXGWYCWXSWXRWXAVWIEFGUXHVRWXPWYDVWIWXLUKZMVWIWXALWDWXPWYFWXHMWXPWXL
        WUFVBWYFWXHVBWXPWXLWULWUFWUCWXJWXKWXMYEWUCWULWUFVBWXOWUCWULWVJWUFWUCVUA
        UYSVBZUDUYKVFZWULWVJVBWUCVYGWWBWYHWVBWWCVYGWWAWYGUDUYKVYGWWAWYGUYSFVXEV
        XHUXIYMYJYNUDUYKVUAUYSYPXGWVPUXJWAXJWXLWUFVWIUXKXGWUCWXGWXIWXNUXLXJUXOV
        URWYEJWXQVUSVUPWXQUPVUQWYDMVUPWXQLYKYLYOXIUXMUXNUXPKWFZWUOKWGZVBZWWTWXD
        WHHIVWPVVSWYBKNUXQZWUOVWPVVSXTZWYJWUIVWPVBWUNVVSVBWUOWYMVBWUHUHVWPYSWUM
        UIVVSYSWUIVWPWUNVVSUXRYTHIVWPVVSWYBKNWXTWYAHYQIYQYRUXSUYDZUGUJWUIWUNVUT
        KUXTYTUYAWYIWYKWWTWURWHWYLWYNWUOVUTKWRYTYCVVCWUQWURVEBWUOVVFVUNWUOUPVUO
        WUQVVBWURVUNWUOVUMXMVUNWUOVVAXNXOXPXQUYBUYEUYCUYFUYGXR $.
    $}

    $( Continuity of the composition operation as a function on continuous
       function spaces.  (Contributed by Mario Carneiro, 20-Mar-2015.)
       (Revised by Mario Carneiro, 22-Aug-2015.) $)
    xkococn $p |- ( ( R e. Top /\ S e. N-Locally Comp /\ T e. Top ) ->
      F e. ( ( ( T ^ko S ) tX ( S ^ko R ) ) Cn ( T ^ko R ) ) ) $=
      ( vx vk vv vy vh vz wcel co cv wral wa syl2anc cfv va ctop ccmp cnlly w3a
      vb cxko ctx ccn cxp wf ccnv cima crest cuni cpw crab wss cmpt2 crn simprr
      ccom simprl cnco ralrimivva fmpt2 sylib wceq wrex eqid rnmpt2 eleq2i abid
      cab oveq2 eleq1d rexrab 3bitri wi wfn wb ad2antrr ffn elpreima 3syl coeq1
      cop coeq2 ovmpt2 adantl imaeq1 sseq1d elrab simprbi simp2 ad3antrrr elpwi
      vex coex ad2antrl simplr simprll simprlr xkococnlem expr syl5 fveq2 df-ov
      sylbid syl6eqr eleq1 anbi1d rexbidv imbi12d ralxp sylibr r19.21bi expimpd
      ralrimiv nllytop 3ad2ant2 simp3 xkotop simp1 eltop2 syl mpbird syl5ibrcom
      txtop imaeq2 rexlimdva anassrs syl5bi cvv ctopon xkotopon txtopon 3adant2
      ovex pwex xkotf frn ax-mp ssexi a1i cfi ctg xkoval subbascn mpbir2and ) A
      UBNZBUCUDNZCUBNZUEZFCBUGOZBAUGOZUHOZCAUGOZUIONBCUIOZABUIOZUJZACUIOZFUKZFU
      LZHPZUMZUUQNZHIJAKPZUNOZUCNZKAUOZUPZUQZCLPZIPZUMZJPZURZLUVBUQZUSZUTZQUUND
      PZEPZVBZUVBNZEUUTQDUUSQUVCUUNUWEDEUUSUUTUUNUWBUUSNZUWCUUTNZRRUWGUWFUWEUUN
      UWFUWGVAUUNUWFUWGVCUWCUWBABCVDSVEDEUUSUUTUWDUVBFGVFVGZUUNUVGHUWAUVEUWANZA
      UVOUNOZUCNZUVEUVSVHZJCVIZRZIUVLVIZUUNUVGUWIUVEUWMIUVMVIZHVNZNUWPUWOUWAUWQ
      UVEIJHUVMCUVSUVTUVTVJZVKVLUWPHVMUVJUWKUWMIKUVLUVHUVOVHUVIUWJUCUVHUVOAUNVO
      VPVQVRUUNUWNUVGIUVLUUNUVOUVLNZRUWKUWMUVGUUNUWSUWKUWMUVGVSUUNUWSUWKRZRZUWL
      UVGJCUXAUVQCNZRZUVGUWLUVDUVSUMZUUQNZUXCUXEUVHMPZNZUXFUXDURZRZMUUQVIZKUXDQ
      ZUXCUXJKUXDUXCUVHUXDNZUVHUVANZUVHFTZUVSNZRZUXJUXCUVCFUVAVTUXLUXPWAUUNUVCU
      WTUXBUWHWBUVAUVBFWCUVAUVHUVSFWDWEUXCUXMUXOUXJUXCUXOUXJVSZKUVAUXCUAPZUFPZF
      OZUVSNZUXRUXSWGZUXFNZUXHRZMUUQVIZVSZUFUUTQUAUUSQUXQKUVAQUXCUYFUAUFUUSUUTU
      XCUXRUUSNZUXSUUTNZRZRZUYAUXRUXSVBZUVSNZUYEUYJUXTUYKUVSUYIUXTUYKVHUXCDEUXR
      UXSUUSUUTUWDUYKFUXRUWCVBUWBUXRUWCWFUWCUXSUXRWHGUXRUXSUAWRUFWRWSWIWJVPUYLU
      YKUVOUMZUVQURZUYJUYEUYLUYKUVBNUYNUVRUYNLUYKUVBUVNUYKVHUVPUYMUVQUVNUYKUVOW
      KWLWMWNUXCUYIUYNUYEUXCUYIUYNRZRMUXRUXSABCDELFUVOUVQGUUNUULUWTUXBUYOUUKUUL
      UUMWOWPUXAUVOUVKURZUXBUYOUWSUYPUUNUWKUVOUVKWQWTWBUXAUWKUXBUYOUUNUWSUWKVAW
      BUXAUXBUYOXAUXCUYGUYHUYNXBUXCUYGUYHUYNXCUXCUYIUYNVAXDXEXFXIVEUXQUYFKUAUFU
      USUUTUVHUYBVHZUXOUYAUXJUYEUYQUXNUXTUVSUYQUXNUYBFTUXTUVHUYBFXGUXRUXSFXHXJV
      PUYQUXIUYDMUUQUYQUXGUYCUXHUVHUYBUXFXKXLXMXNXOXPXQXRXIXSUXCUUQUBNZUXEUXKWA
      UUNUYRUWTUXBUUNUUOUBNZUUPUBNZUYRUUNBUBNZUUMUYSUULUUKVUAUUMUCBXTYAZUUKUULU
      UMYBZBCYCSUUNUUKVUAUYTUUKUULUUMYDZVUBABYCSUUOUUPYISWBKMUXDUUQYEYFYGUWLUVF
      UXDUUQUVEUVSUVDYJVPYHYKYLXRYKYMXSUUNHUWAFUUQUURYNUVAUVBUUNUUOUUSYOTNZUUPU
      UTYOTNZUUQUVAYOTNUUNVUAUUMVUEVUBVUCBCUUOUUOVJYPSUUNUUKVUAVUFVUDVUBABUUPUU
      PVJYPSUUOUUPUUSUUTYQSUWAYNNUUNUWAUVBUPZUVBACUIYSYTUVMCUJZVUGUVTUKUWAVUGUR
      KJACUVTLIUVMUVKUVKVJZUVMVJZUWRUUAVUHVUGUVTUUBUUCUUDUUEUUKUUMUURUWAUUFTUUG
      TVHUULKJACUVTLIUVMUVKVUIVUJUWRUUHYRUUKUUMUURUVBYOTNUULACUURUURVJYPYRUUIUU
      J $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Continuous function-builders
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w y z A $.  $d w z B $.  $d w C $.  $d y z D $.  $d x y F $.  $d x ph $.
    $d x y J $.  $d x y z M $.  $d w x y z X $.  $d w x y z Y $.  $d x y z Z $.
    $d x y K $.  $d x y L $.  $d x y P $.
    cnmptid.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    $( The identity function is continuous.  (Contributed by Mario Carneiro,
       5-May-2014.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    cnmptid $p |- ( ph -> ( x e. X |-> x ) e. ( J Cn J ) ) $=
      ( vy cv cmpt cid cres ccn co cvv weq copab equcom opabbii dfid3 mptv wcel
      3eqtr4i reseq1i wss wceq ssv resmpt ax-mp eqtri ctopon cfv idcn syl5eqelr
      syl ) ABDBGZHZIDJZCCKLZUPBMUNHZDJZUOIURDBFNZBFOFBNZBFOIURUTVABFBFPQBFRBFU
      NSUAUBDMUCUSUOUDDUEBMDUNUFUGUHACDUIUJTUPUQTECDUKUMUL $.

    ${
      cnmptc.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
      cnmptc.p $e |- ( ph -> P e. Y ) $.
      $( A constant function is continuous.  (Contributed by Mario Carneiro,
         5-May-2014.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
      cnmptc $p |- ( ph -> ( x e. X |-> P ) e. ( J Cn K ) ) $=
        ( cmpt csn cxp ccn co fconstmpt ctopon cfv wcel cnconst2 syl5eqelr
        syl3anc ) ABFCKFCLMZDENOZBFCPADFQRSEGQRSCGSUCUDSHIJCDEFGTUBUA $.
    $}

    cnmpt11.a $e |- ( ph -> ( x e. X |-> A ) e. ( J Cn K ) ) $.
    ${
      $d x B $.  $d y z C $.
      cnmpt11.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
      cnmpt11.b $e |- ( ph -> ( y e. Y |-> B ) e. ( K Cn L ) ) $.
      cnmpt11.c $e |- ( y = A -> B = C ) $.
      $( The composition of continuous functions is continuous.  (Contributed
         by Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
         22-Aug-2015.) $)
      cnmpt11 $p |- ( ph -> ( x e. X |-> C ) e. ( J Cn L ) ) $=
        ( wceq cfv wcel syl2anc vz cmpt ccom co cv wral wa simpr wf ctopon cnf2
        ccn syl3anc eqid fmpt sylibr r19.21bi fvmpt2 fveq2d cntop2 syl toptopon
        cuni ctop sylib adantr eleq1d rspcv sylc fvmptg eqtrd 3eqtr4d ralrimiva
        fvco3 sylan nfv nfcv nfmpt1 nfco nffv nfeq fveq2 eqeq12d cbvral wfn fco
        wb ffn fmptd eqfnfv mpbird cnco eqeltrrd ) ACKEUBZBJDUBZUCZBJFUBZGIULUD
        ZAWPWQQZUAUEZWPRZWTWQRZQZUAJUFZABUEZWPRZXEWQRZQZBJUFXDAXHBJAXEJSZUGZXEW
        ORZWNRZFXFXGXJXLDWNRZFXJXKDWNXJXIDKSZXKDQAXIUHZAXNBJAJKWOUIZXNBJUFAGJUJ
        RSHKUJRSZWOGHULUDSZXPLNMWOGHJKUKUMZBJKDWOWOUNZUOUPUQZBJDKWOXTURTUSXJXNF
        IVCZSZXMFQYAXJXNEYBSZCKUFZYCYAAYEXIAKYBWNUIZYEAXQIYBUJRSZWNHIULUDSZYFNA
        IVDSZYGAYHYIOWNHIUTVAIYBYBUNVBVEOWNHIKYBUKUMZCKYBEWNWNUNZUOUPVFYDYCCDKC
        UEDQEFYBPVGVHVIZCDEFKYBWNPYKVJTVKAXPXIXFXLQXSJKXEWNWOVNVOXJXIYCXGFQXOYL
        BJFYBWQWQUNZURTVLVMXHXCBUAJXHUAVPBXAXBBWTWPBWNWOBWNVQBJDVRVSBWTVQZVTBWT
        WQBJFVRYNVTWAXEWTQXFXAXGXBXEWTWPWBXEWTWQWBWCWDVEAWPJWEZWQJWEZWSXDWGAJYB
        WPUIZYOAYFXPYQYJXSJKYBWNWOWFTJYBWPWHVAAJYBWQUIYPABJFYBWQYLYMWIJYBWQWHVA
        UAJWPWQWJTWKAXRYHWPWRSMOWOWNGHIWLTWM $.
    $}

    ${
      cnmpt11f.f $e |- ( ph -> F e. ( K Cn L ) ) $.
      $( The composition of continuous functions is continuous.  (Contributed
         by Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
         22-Aug-2015.) $)
      cnmpt11f $p |- ( ph -> ( x e. X |-> ( F ` A ) ) e. ( J Cn L ) ) $=
        ( vy cfv cuni wcel cmpt ccn co syl eqid cv ctopon cntop2 toptopon sylib
        ctop wf cnf feqmptd eqeltrrd fveq2 cnmpt11 ) ABLCLUAZDMZCDMEFGHFNZIJAFU
        FOZFUOUBMOABHCPZEFQROUPJUQEFUCSFUOUOTZUDUEADLUOUNPFGQRZALUOGNZDADUSOUOU
        TDUGKDFGUOUTURUTTUHSUIKUJUMCDUKUL $.
    $}

    $d y B $.  $d x C $.
    cnmpt1t.b $e |- ( ph -> ( x e. X |-> B ) e. ( J Cn L ) ) $.
    $( The composition of continuous functions is continuous.  (Contributed by
       Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmpt1t $p |- ( ph ->
                    ( x e. X |-> <. A , B >. ) e. ( J Cn ( K tX L ) ) ) $=
      ( vy cuni cmpt cfv cop co wcel wceq eqid cv ctx ctopon toponuni mpteq1 wa
      ccn 3syl simpr wf wral ctop cntop2 syl toptopon sylib cnf2 syl3anc sylibr
      fmpt r19.21bi fvmpt2 syl2anc opeq12d mpteq2dva eqtr3d nfcv nffvmpt1 fveq2
      nfop cbvmpt txcnmpt eqeltrrd ) ABEMZBUAZBHCNZOZVOBHDNZOZPZNZBHCDPZNZEFGUB
      QUGQZABHVTNZWAWCAEHUCORZHVNSWEWASIHEUDBHVNVTUEUHABHVTWBAVOHRZUFZVQCVSDWHW
      GCFMZRZVQCSAWGUIZAWJBHAHWIVPUJZWJBHUKAWFFWIUCORZVPEFUGQRZWLIAFULRZWMAWNWO
      JVPEFUMUNFWIWITUOUPJVPEFHWIUQURBHWICVPVPTZUTUSVABHCWIVPWPVBVCWHWGDGMZRZVS
      DSWKAWRBHAHWQVRUJZWRBHUKAWFGWQUCORZVREGUGQRZWSIAGULRZWTAXAXBKVREGUMUNGWQW
      QTUOUPKVREGHWQUQURBHWQDVRVRTZUTUSVABHDWQVRXCVBVCVDVEVFAWNXAWAWDRJKLFGEVPV
      RWAVNVNTBLVNVTLUAZVPOZXDVROZPLVTVGBXEXFBHCXDVHBHDXDVHVJVOXDSVQXEVSXFVOXDV
      PVIVOXDVRVIVDVKVLVCVM $.

    ${
      cnmpt12f.f $e |- ( ph -> F e. ( ( K tX L ) Cn M ) ) $.
      $( The composition of continuous functions is continuous.  (Contributed
         by Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
         22-Aug-2015.) $)
      cnmpt12f $p |- ( ph -> ( x e. X |-> ( A F B ) ) e. ( J Cn M ) ) $=
        ( co cmpt cop cfv ccn df-ov mpteq2i ctx cnmpt1t cnmpt11f syl5eqel ) ABJ
        CDEOZPBJCDQZERZPFISOBJUFUHCDETUAABUGEFGHUBOIJKABCDFGHJKLMUCNUDUE $.
    $}

    cnmpt12.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    cnmpt12.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
    cnmpt12.c $e |- ( ph ->
                      ( y e. Y , z e. Z |-> C ) e. ( ( K tX L ) Cn M ) ) $.
    cnmpt12.d $e |- ( ( y = A /\ z = B ) -> C = D ) $.
    $( The composition of continuous functions is continuous.  (Contributed by
       Mario Carneiro, 12-Jun-2014.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmpt12 $p |- ( ph -> ( x e. X |-> D ) e. ( J Cn M ) ) $=
      ( cmpt2 co cmpt ccn cv wcel wa cuni wceq wf wral ctopon cnf2 syl3anc eqid
      cfv fmpt sylibr r19.21bi wi wal jca cxp ctx txtopon syl2anc ctop toptopon
      cntop2 sylib fmpt2 r2al adantr eleq1 bi2anan9 eleq1d imbi12d spc2gv syl3c
      syl ovmpt2ga mpteq2dva cnmpt12f eqeltrrd ) ABMEFCDNOGUCZUDZUEBMHUEILUFUDA
      BMWHHABUGMUHZUIZENUHZFOUHZHLUJZUHZWHHUKAWKBMAMNBMEUEZULZWKBMUMAIMUNURUHZJ
      NUNURUHZWOIJUFUDUHWPPSQWOIJMNUOUPBMNEWOWOUQUSUTVAZAWLBMAMOBMFUEZULZWLBMUM
      AWQKOUNURUHZWTIKUFUDUHXAPTRWTIKMOUOUPBMOFWTWTUQUSUTVAZWJWKWLUIZCUGZNUHZDU
      GZOUHZUIZGWMUHZVBZDVCCVCZXDWNWJWKWLWSXCVDZAXLWIAXJDOUMCNUMZXLANOVEZWMWGUL
      ZXNAJKVFUDZXOUNURUHZLWMUNURUHZWGXQLUFUDUHZXPAWRXBXRSTJKNOVGVHALVIUHZXSAXT
      YAUAWGXQLVKWBLWMWMUQVJVLUAWGXQLXOWMUOUPCDNOGWMWGWGUQZVMUTXJCDNOVNVLVOXMXK
      XDWNVBCDEFNOXEEUKZXGFUKZUIZXIXDXJWNYCXFWKYDXHWLXEENVPXGFOVPVQYEGHWMUBVRVS
      VTWACDEFNOGHWGWMUBYBWCUPWDABEFWGIJKLMPQRUAWEWF $.
  $}

  ${
    $d t u v w z A $.  $d t u v w B $.  $d t u v C $.  $d w z D $.  $d v z J $.
    $d w x y z F $.  $d v w x y z L $.  $d v x y z ph $.  $d t u v w x y z X $.
    $d v w x y z M $.  $d v w x y z N $.  $d x y z P $.  $d t u v w x y z Y $.
    $d v z K $.  $d v w x y z W $.  $d t u v w x y z Z $.
    cnmpt21.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmpt21.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    $( The projection onto the first coordinate is continuous.  (Contributed by
       Mario Carneiro, 6-May-2014.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmpt1st $p |- ( ph ->
                     ( x e. X , y e. Y |-> x ) e. ( ( J tX K ) Cn J ) ) $=
      ( vz cv c1st co cfv cmpt wfn cvv vex ctopon wcel cxp cres ctx ccn wss wfo
      cmpt2 wceq fo1st fofn ax-mp ssv fnssres mp2an dffn5 fvres mpteq2ia op1std
      mpbi mpt2mpt 3eqtri tx1cn syl2anc syl5eqelr ) ABCFGBKZUGZLFGUAZUBZDEUCMDU
      DMZVHJVGJKZVHNZOZJVGVJLNZOVFVHVGPZVHVLUHLQPZVGQUEVNQQLUFVOUIQQLUJUKVGULQV
      GLUMUNJVGVHUOUSJVGVKVMVJVGLUPUQBCJFGVMVEVECKVJBRCRURUTVAADFSNTEGSNTVHVITH
      IDEFGVBVCVD $.

    $( The projection onto the second coordinate is continuous.  (Contributed
       by Mario Carneiro, 6-May-2014.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmpt2nd $p |- ( ph ->
                     ( x e. X , y e. Y |-> y ) e. ( ( J tX K ) Cn K ) ) $=
      ( vz cv c2nd co cfv cmpt wfn cvv vex ctopon wcel cxp cres ctx ccn wss wfo
      cmpt2 wceq fo2nd fofn ax-mp ssv fnssres mp2an dffn5 fvres mpteq2ia op2ndd
      mpbi mpt2mpt 3eqtri tx2cn syl2anc syl5eqelr ) ABCFGCKZUGZLFGUAZUBZDEUCMEU
      DMZVHJVGJKZVHNZOZJVGVJLNZOVFVHVGPZVHVLUHLQPZVGQUEVNQQLUFVOUIQQLUJUKVGULQV
      GLUMUNJVGVHUOUSJVGVKVMVJVGLUPUQBCJFGVMVEBKVEVJBRCRURUTVAADFSNTEGSNTVHVITH
      IDEFGVBVCVD $.

    ${
      cnmpt2c.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
      cnmpt2c.p $e |- ( ph -> P e. Z ) $.
      $( A constant function is continuous.  (Contributed by Mario Carneiro,
         5-May-2014.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
      cnmpt2c $p |- ( ph -> ( x e. X , y e. Y |-> P ) e.
                            ( ( J tX K ) Cn L ) ) $=
        ( vz co cv ctopon cfv wcel cmpt2 cxp cmpt ctx ccn eqidd mpt2mpt txtopon
        cop wceq syl2anc cnmptc syl5eqelr ) ABCHIDUAOHIUBZDUCEFUDPZGUEPBCOHIDDO
        QBQCQUIUJDUFUGAODUOGUNJAEHRSTFIRSTUOUNRSTKLEFHIUHUKMNULUM $.
    $}

    cnmpt21.a $e |- ( ph ->
                      ( x e. X , y e. Y |-> A ) e. ( ( J tX K ) Cn L ) ) $.
    ${
      $d x y B $.  $d w z C $.
      cnmpt21.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
      cnmpt21.b $e |- ( ph -> ( z e. Z |-> B ) e. ( L Cn M ) ) $.
      cnmpt21.c $e |- ( z = A -> B = C ) $.
      $( The composition of continuous functions is continuous.  (Contributed
         by Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
         22-Aug-2015.) $)
      cnmpt21 $p |- ( ph ->
                      ( x e. X , y e. Y |-> C ) e. ( ( J tX K ) Cn M ) ) $=
        ( vw vu vv cmpt cmpt2 ccom ctx co ccn wceq cv cfv cxp wral cop wa df-ov
        wcel simprl simprr wi wf ctopon txtopon syl2anc cnf2 syl3anc eqid fmpt2
        sylibr rsp2 syl imp ovmpt4g fveq2d cuni ctop cntop2 toptopon sylib fmpt
        syl5eqr adantr eleq1d rspcv sylc fvmptg eqtrd opelxpi syl2an ralrimivva
        fvco3 3eqtr4d nfcv nfmpt21 nfco nffv nfral nfmpt22 opeq2 eqeq12d cbvral
        nfv nfeq opeq1 ralbidv syl5bb fveq2 ralxp wfn wb fco eqfnfv mpbird cnco
        ffn eqeltrrd ) ADNFUDZBCLMEUEZUFZBCLMGUEZHIUGUHZKUIUHZAXTYAUJZUAUKZXTUL
        ZYEYAULZUJZUALMUMZUNZAUBUKZUCUKZUOZXTULZYMYAULZUJZUCMUNZUBLUNZYJABUKZCU
        KZUOZXTULZUUAYAULZUJZCMUNZBLUNYRAUUDBCLMAYSLURZYTMURZUPZUPZUUAXSULZXRUL
        ZGUUBUUCUUIUUKEXRULZGUUIUUJEXRUUIUUJYSYTXSUHZEYSYTXSUQUUIUUFUUGENURZUUM
        EUJAUUFUUGUSZAUUFUUGUTZAUUHUUNAUUNCMUNBLUNZUUHUUNVAAYINXSVBZUUQAYBYIVCU
        LURZJNVCULURZXSYBJUIUHURZUURAHLVCULURIMVCULURUUSOPHILMVDVERQXSYBJYINVFV
        GZBCLMENXSXSVHZVIVJUUNBCLMVKVLVMZBCLMEXSNUVCVNVGWBVOUUIUUNGKVPZURZUULGU
        JUVDUUIUUNFUVEURZDNUNZUVFUVDAUVHUUHANUVEXRVBZUVHAUUTKUVEVCULURZXRJKUIUH
        URZUVIRAKVQURZUVJAUVKUVLSXRJKVRVLKUVEUVEVHVSVTSXRJKNUVEVFVGZDNUVEFXRXRV
        HZWAVJWCUVGUVFDENDUKEUJFGUVETWDWEWFZDEFGNUVEXRTUVNWGVEWHAUURUUAYIURUUBU
        UKUJUUHUVBYSYTLMWIYINUUAXRXSWLWJUUIUUCYSYTYAUHZGYSYTYAUQUUIUUFUUGUVFUVP
        GUJUUOUUPUVOBCLMGYAUVEYAVHZVNVGWBWMWKUUEYQBUBLUUEUBXCYPBUCMBMWNBYNYOBYM
        XTBXRXSBXRWNBCLMEWOWPBYMWNZWQBYMYABCLMGWOUVRWQXDWRUUEYSYLUOZXTULZUVSYAU
        LZUJZUCMUNYSYKUJZYQUUDUWBCUCMUUDUCXCCUVTUWACUVSXTCXRXSCXRWNBCLMEWSWPCUV
        SWNZWQCUVSYABCLMGWSUWDWQXDYTYLUJZUUBUVTUUCUWAUWEUUAUVSXTYTYLYSWTZVOUWEU
        UAUVSYAUWFVOXAXBUWCUWBYPUCMUWCUVTYNUWAYOUWCUVSYMXTYSYKYLXEZVOUWCUVSYMYA
        UWGVOXAXFXGXBVTYHYPUAUBUCLMYEYMUJYFYNYGYOYEYMXTXHYEYMYAXHXAXIVJAXTYIXJZ
        YAYIXJZYDYJXKAYIUVEXTVBZUWHAUVIUURUWJUVMUVBYINUVEXRXSXLVEYIUVEXTXPVLAYI
        UVEYAVBZUWIAUVFCMUNBLUNUWKAUVFBCLMUVOWKBCLMGUVEYAUVQVIVTYIUVEYAXPVLUAYI
        XTYAXMVEXNAUVAUVKXTYCURQSXSXRYBJKXOVEXQ $.
    $}

    ${
      $d x y B $.  $d w z C $.
      cnmpt21f.f $e |- ( ph -> F e. ( L Cn M ) ) $.
      $( The composition of continuous functions is continuous.  (Contributed
         by Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
         22-Aug-2015.) $)
      cnmpt21f $p |- ( ph ->
                  ( x e. X , y e. Y |-> ( F ` A ) ) e. ( ( J tX K ) Cn M ) ) $=
        ( vz cfv cuni wcel syl cv ctop ctopon ccn co cntop1 eqid toptopon sylib
        cmpt wf cnf feqmptd eqeltrrd fveq2 cnmpt21 ) ABCPDPUAZEQZDEQFGHIJKHRZLM
        NAHUBSZHUSUCQSAEHIUDUEZSZUTOEHIUFTHUSUSUGZUHUIAEPUSURUJVAAPUSIRZEAVBUSV
        DEUKOEHIUSVDVCVDUGULTUMOUNUQDEUOUP $.
    $}

    $d z B $.  $d x y C $.
    cnmpt2t.b $e |- ( ph ->
                      ( x e. X , y e. Y |-> B ) e. ( ( J tX K ) Cn M ) ) $.
    $( The composition of continuous functions is continuous.  (Contributed by
       Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmpt2t $p |- ( ph ->
       ( x e. X , y e. Y |-> <. A , B >. ) e. ( ( J tX K ) Cn ( L tX M ) ) ) $=
      ( vz co cfv wceq wcel vu vv ctx cuni cmpt2 cop cmpt ccn cxp fveq2 syl6eqr
      cv df-ov opeq12d mpt2mpt nfcv nfmpt21 nfov nfop nfmpt22 wa oveq12 cbvmpt2
      eqtri ctopon txtopon syl2anc toponuni mpteq1 3syl w3a simp2 simp3 wral wi
      ctop cntop2 syl eqid toptopon sylib cnf2 syl3anc fmpt2 sylibr rsp2 3impib
      wf ovmpt4g mpt2eq3dva 3eqtr3a txcnmpt eqeltrrd ) APFGUCQZUDZPULZBCJKDUEZR
      ZWPBCJKEUEZRZUFZUGZBCJKDEUFZUEZWNHIUCQUHQZAPJKUIZXAUGZBCJKBULZCULZWQQZXHX
      IWSQZUFZUEZXBXDXGUAUBJKUAULZUBULZWQQZXNXOWSQZUFZUEXMUAUBPJKXAXRWPXNXOUFZS
      ZWRXPWTXQXTWRXSWQRXPWPXSWQUJXNXOWQUMUKXTWTXSWSRXQWPXSWSUJXNXOWSUMUKUNUOUA
      UBBCJKXRXLBXPXQBXNXOWQBXNUPZBCJKDUQBXOUPZURBXNXOWSYABCJKEUQYBURUSCXPXQCXN
      XOWQCXNUPZBCJKDUTCXOUPZURCXNXOWSYCBCJKEUTYDURUSUAXLUPUBXLUPXNXHSXOXISVAXP
      XJXQXKXNXHXOXIWQVBXNXHXOXIWSVBUNVCVDAWNXFVERTZXFWOSXGXBSAFJVERTGKVERTYELM
      FGJKVFVGZXFWNVHPXFWOXAVIVJABCJKXLXCAXHJTZXIKTZVKZXJDXKEYIYGYHDHUDZTZXJDSA
      YGYHVLZAYGYHVMZAYGYHYKAYKCKVNBJVNZYGYHVAZYKVOAXFYJWQWHZYNAYEHYJVERTZWQWNH
      UHQTZYPYFAHVPTZYQAYRYSNWQWNHVQVRHYJYJVSVTWANWQWNHXFYJWBWCBCJKDYJWQWQVSZWD
      WEYKBCJKWFVRWGBCJKDWQYJYTWIWCYIYGYHEIUDZTZXKESYLYMAYGYHUUBAUUBCKVNBJVNZYO
      UUBVOAXFUUAWSWHZUUCAYEIUUAVERTZWSWNIUHQTZUUDYFAIVPTZUUEAUUFUUGOWSWNIVQVRI
      UUAUUAVSVTWAOWSWNIXFUUAWBWCBCJKEUUAWSWSVSZWDWEUUBBCJKWFVRWGBCJKEWSUUAUUHW
      IWCUNWJWKAYRUUFXBXETNOPHIWNWQWSXBWOWOVSXBVSWLVGWM $.

    ${
      cnmpt22.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
      cnmpt22.m $e |- ( ph -> M e. ( TopOn ` W ) ) $.
      cnmpt22.c $e |- ( ph ->
                        ( z e. Z , w e. W |-> C ) e. ( ( L tX M ) Cn N ) ) $.
      cnmpt22.d $e |- ( ( z = A /\ w = B ) -> C = D ) $.
      $( The composition of continuous functions is continuous.  (Contributed
         by Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
         22-Aug-2015.) $)
      cnmpt22 $p |- ( ph ->
                      ( x e. X , y e. Y |-> D ) e. ( ( J tX K ) Cn N ) ) $=
        ( cop cmpt2 cfv ctx co ccn cv wcel w3a df-ov cuni wceq wa wi cxp ctopon
        wral txtopon syl2anc cnf2 syl3anc eqid fmpt2 sylibr rsp2 syl 3impib wal
        wf jca ctop cntop2 toptopon sylib r2al 3ad2ant1 bi2anan9 eleq1d imbi12d
        eleq1 spc2gv ovmpt2ga syl5eqr mpt2eq3dva cnmpt2t cnmpt21f eqeltrrd
        syl3c ) ABCPQFGUGZDEROHUHZUIZUHBCPQIUHJKUJUKZNULUKABCPQWQIABUMPUNZCUMQU
        NZUOZWQFGWPUKZIFGWPUPXAFRUNZGOUNZINUQZUNZXBIURAWSWTXCAXCCQVCBPVCZWSWTUS
        ZXCUTAPQVAZRBCPQFUHZVOZXGAWRXIVBUIUNZLRVBUIUNZXJWRLULUKUNXKAJPVBUIUNKQV
        BUIUNXLSTJKPQVDVEZUCUAXJWRLXIRVFVGBCPQFRXJXJVHVIVJXCBCPQVKVLVMZAWSWTXDA
        XDCQVCBPVCZXHXDUTAXIOBCPQGUHZVOZXPAXLMOVBUIUNZXQWRMULUKUNXRXNUDUBXQWRMX
        IOVFVGBCPQGOXQXQVHVIVJXDBCPQVKVLVMZXAXCXDUSZDUMZRUNZEUMZOUNZUSZHXEUNZUT
        ZEVNDVNZYAXFXAXCXDXOXTVPZAWSYIWTAYGEOVCDRVCZYIAROVAZXEWPVOZYKALMUJUKZYL
        VBUIUNZNXEVBUIUNZWPYNNULUKUNZYMAXMXSYOUCUDLMROVDVEANVQUNZYPAYQYRUEWPYNN
        VRVLNXEXEVHVSVTUEWPYNNYLXEVFVGDEROHXEWPWPVHZVIVJYGDEROWAVTWBYJYHYAXFUTD
        EFGROYBFURZYDGURZUSZYFYAYGXFYTYCXCUUAYEXDYBFRWFYDGOWFWCUUBHIXEUFWDWEWGW
        NDEFGROHIWPXEUFYSWHVGWIWJABCWOWPJKYNNPQSTABCFGJKLMPQSTUAUBWKUEWLWM $.
    $}

    cnmpt22f.f $e |- ( ph -> F e. ( ( L tX M ) Cn N ) ) $.
    $( The composition of continuous functions is continuous.  (Contributed by
       Mario Carneiro, 5-May-2014.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmpt22f $p |- ( ph -> ( x e. X , y e. Y |-> ( A F B ) ) e.
                           ( ( J tX K ) Cn N ) ) $=
      ( co wcel vz vw cv cuni ctop ctopon cfv cmpt2 ctx ccn cntop2 syl toptopon
      eqid sylib cxp wfn wceq wf txtopon syl2anc cnf2 syl3anc ffn fnov eqeltrrd
      oveq12 cnmpt22 ) ABCUAUBDEUAUCZUBUCZFSZDEFSGHIJKJUDZLMIUDZNOPQAIUETZIVMUF
      UGTZABCLMDUHZGHUISZIUJSTVNPVPVQIUKULIVMVMUNUMUOZAJUETZJVLUFUGTZABCLMEUHZV
      QJUJSTVSQWAVQJUKULJVLVLUNUMUOZAFUAUBVMVLVKUHZIJUISZKUJSZAFVMVLUPZUQZFWCUR
      AWFKUDZFUSZWGAWDWFUFUGTZKWHUFUGTZFWETZWIAVOVTWJVRWBIJVMVLUTVAAKUETZWKAWLW
      MRFWDKUKULKWHWHUNUMUORFWDKWFWHVBVCWFWHFVDULUAUBVMVLFVEUORVFVIDVJEFVGVH $.
  $}

  ${
    $d x y W $.  $d x y X $.  $d x y Y $.  $d x y Z $.
    cnmpt1res.2 $e |- K = ( J |`t Y ) $.
    cnmpt1res.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmpt1res.5 $e |- ( ph -> Y C_ X ) $.
    ${
      cnmpt1res.6 $e |- ( ph -> ( x e. X |-> A ) e. ( J Cn L ) ) $.
      $( The restriction of a continuous function to a subset is continuous.
         (Contributed by Mario Carneiro, 5-Jun-2014.) $)
      cnmpt1res $p |- ( ph -> ( x e. Y |-> A ) e. ( K Cn L ) ) $=
        ( cmpt cres ccn co wss wceq syl wcel resmpt crest cuni toponuni sseqtrd
        ctopon cfv eqid cnrest syl2anc oveq1i syl6eleqr eqeltrrd ) ABGCMZHNZBHC
        MZEFOPZAHGQUOUPRKBGHCUASAUODHUBPZFOPZUQAUNDFOPTHDUCZQUOUSTLAHGUTKADGUFU
        GTGUTRJGDUDSUEHUNDFUTUTUHUIUJEURFOIUKULUM $.
    $}

    cnmpt2res.7 $e |- N = ( M |`t W ) $.
    cnmpt2res.8 $e |- ( ph -> M e. ( TopOn ` Z ) ) $.
    cnmpt2res.9 $e |- ( ph -> W C_ Z ) $.
    cnmpt2res.10 $e |- ( ph -> ( x e. X , y e. Z |-> A ) e.
                               ( ( J tX M ) Cn L ) ) $.
    $( The restriction of a continuous function to a subset is continuous.
       (Contributed by Mario Carneiro, 6-Jun-2014.) $)
    cnmpt2res $p |- ( ph -> ( x e. Y , y e. W |-> A ) e.
                            ( ( K tX N ) Cn L ) ) $=
      ( cmpt2 cxp cres ctx co crest ccn wcel cuni wss xpss12 syl2anc ctopon cfv
      wceq txtopon toponuni syl sseqtrd eqid resmpt2 ctop cvv topontop toponmax
      cnrest ssexd txrest syl22anc oveq12i syl6eqr oveq1d 3eltr3d ) ABCKMDUAZLJ
      UBZUCZEHUDUEZVOUFUEZGUGUEZBCLJDUAZFIUDUEZGUGUEAVNVQGUGUEUHVOVQUIZUJVPVSUH
      TAVOKMUBZWBALKUJZJMUJZVOWCUJPSLKJMUKULAVQWCUMUNUHZWCWBUOAEKUMUNUHZHMUMUNU
      HZWFOREHKMUPULWCVQUQURUSVOVNVQGWBWBUTVFULAWDWEVPVTUOPSBCKMLJDVAULAVRWAGUG
      AVRELUFUEZHJUFUEZUDUEZWAAEVBUHZHVBUHZLVCUHJVCUHVRWKUOAWGWLOKEVDURAWHWMRMH
      VDURALKEAWGKEUHOKEVEURPVGAJMHAWHMHUHRMHVEURSVGLJEHVBVBVCVCVHVIFWIIWJUDNQV
      JVKVLVM $.
  $}

  ${
    $d t w z A $.  $d w z J $.  $d w z K $.  $d w x y z L $.  $d t w x y z X $.
    $d w x y z ph $.  $d t w x y z Y $.
    cnmptcom.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmptcom.4 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    cnmptcom.6 $e |- ( ph ->
                       ( x e. X , y e. Y |-> A ) e. ( ( J tX K ) Cn L ) ) $.
    $( The argument converse of a continuous function is continuous.
       (Contributed by Mario Carneiro, 6-Jun-2014.) $)
    cnmptcom $p |- ( ph ->
                     ( y e. Y , x e. X |-> A ) e. ( ( K tX J ) Cn L ) ) $=
      ( vz vw cmpt2 cv co wceq wcel wral ctx ccn cxp wfn cuni wf ctopon txtopon
      cfv syl2anc ctop cntop2 syl eqid toptopon sylib cnf2 syl3anc fmpt2 ralcom
      bitr3i ffn fnov wa wi nfcv nfv nfmpt22 nfov nfmpt21 nfeq nfim oveq2 oveq1
      eqeq12d imbi2d rsp2 com12 w3a ovmpt4g 3com12 eqtr4d 3expia syld vtocl2gaf
      3impib mpt2eq3dva cnmpt2nd cnmpt1st cnmpt22f eqeltrd ) ACBIHDOZMNIHNPZMPZ
      BCHIDOZQZOZFEUAQGUBQAWLMNIHWNWMWLQZOZWQAWLIHUCZUDZWLWSRAWTGUEZWLUFZXAADXB
      SZBHTCITZXCAHIUCZXBWOUFZXEAEFUAQZXFUGUISZGXBUGUISZWOXHGUBQSZXGAEHUGUISFIU
      GUISXIJKEFHIUHUJAGUKSZXJAXKXLLWOXHGULUMGXBXBUNUOUPLWOXHGXFXBUQURXGXDCITBH
      TXEBCHIDXBWOWOUNZUSXDBCHIUTVAUPZCBIHDXBWLWLUNZUSUPWTXBWLVBUMMNIHWLVCUPAMN
      IHWPWRAWNISZWMHSZWPWRRZXPXQVDAXRABPZCPZWOQZXTXSWLQZRZVEAXSWNWOQZWNXSWLQZR
      ZVEAXRVECBWNWMIHCWNVFZBWNVFZBWMVFZAYFCACVGCYDYECXSWNWOCXSVFZBCHIDVHYGVICW
      NXSWLYGCBIHDVJYJVIVKVLAXRBABVGBWPWRBWMWNWOYIBCHIDVJYHVIBWNWMWLYHCBIHDVHYI
      VIVKVLXTWNRZYCYFAYKYAYDYBYEXTWNXSWOVMXTWNXSWLVNVOVPXSWMRZYFXRAYLYDWPYEWRX
      SWMWNWOVNXSWMWNWLVMVOVPXTISZXSHSZVDZAXDYCAYOXDAXEYOXDVEXNXDCBIHVQUMVRYMYN
      XDYCYMYNXDVSYADYBYNYMXDYADRBCHIDWOXBXMVTWACBIHDWLXBXOVTWBWCWDWEVRWFWGWBAM
      NWMWNWOFEEFGIHKJAMNFEIHKJWHAMNFEIHKJWILWJWK $.
  $}

  ${
    $d w x y J $.  $d w x y K $.  $d w x y L $.  $d w x y M $.  $d w x y z Z $.
    $d w z A $.  $d w x B $.  $d w x y ph $.  $d w x y X $.  $d w x y Y $.
    $d z C $.
    cnmptk1.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmptk1.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    $( The curried first projection function is continuous.  (Contributed by
       Mario Carneiro, 23-Mar-2015.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmptkc $p |- ( ph ->
      ( x e. X |-> ( y e. Y |-> x ) ) e. ( J Cn ( J ^ko K ) ) ) $=
      ( cv cmpt csn cxp cxko co ccn fconstmpt ctopon cfv wcel mpteq2i syl5eqelr
      xkoccn syl2anc ) ABFCGBJZKZKBFGUELMZKZDDENOPOZBFUGUFCGUEQUAAEGRSTDFRSTUHU
      ITIHBEDGFUCUDUB $.

    cnmptk1.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
    ${
      $d y B $.  $d y C $.
      cnmptkp.a $e |- ( ph ->
        ( x e. X |-> ( y e. Y |-> A ) ) e. ( J Cn ( L ^ko K ) ) ) $.
      cnmptkp.b $e |- ( ph -> B e. Y ) $.
      cnmptkp.c $e |- ( y = B -> A = C ) $.
      $( The evaluation of the inner function in a curried function is
         continuous.  (Contributed by Mario Carneiro, 23-Mar-2015.)  (Revised
         by Mario Carneiro, 22-Aug-2015.) $)
      cnmptkp $p |- ( ph -> ( x e. X |-> C ) e. ( J Cn L ) ) $=
        ( cfv wcel vw cmpt ccn co cv cuni wceq adantr wral ctopon ctop topontop
        wa wf syl eqid toptopon sylib cxko xkotopon syl2anc cnf2 syl3anc sylibr
        fmpt r19.21bi eleq1d rspcv sylc fvmptg mpteq2dva toponuni eleqtrd fveq1
        xkopjcn cnmpt11 eqeltrrd ) ABJECKDUBZSZUBBJFUBGIUCUDABJVSFABUEJTZUMZEKT
        ZFIUFZTZVSFUGAWBVTQUHZWAWBDWCTZCKUIZWDWEWAKWCVRUNZWGWAHKUJSTZIWCUJSTZVR
        HIUCUDZTZWHAWIVTNUHWAIUKTZWJAWMVTAILUJSTWMOLIULUOZUHIWCWCUPUQURAWLBJAJW
        KBJVRUBZUNZWLBJUIAGJUJSTIHUSUDZWKUJSTZWOGWQUCUDTWPMAHUKTZWMWRAWIWSNKHUL
        UOZWNHIWQWQUPUTVAZPWOGWQJWKVBVCBJWKVRWOWOUPVEVDVFVRHIKWCVBVCCKWCDVRVRUP
        ZVEVDWFWDCEKCUEEUGDFWCRVGVHVICEDFKWCVRRXBVJVAVKABUAVREUAUEZSZVSGWQIJWKM
        PXAAWSWMEHUFZTUAWKXDUBWQIUCUDTWTWNAEKXEQAWIKXEUGNKHVLUOVMEHIUAXEXEUPVOV
        CEXCVRVNVPVQ $.
    $}

    ${
      $d y B $.
      cnmptk1.a $e |- ( ph ->
        ( x e. X |-> ( y e. Y |-> A ) ) e. ( J Cn ( L ^ko K ) ) ) $.
      cnmptk1.b $e |- ( ph -> ( z e. Z |-> B ) e. ( L Cn M ) ) $.
      cnmptk1.c $e |- ( z = A -> B = C ) $.
      $( The composition of a curried function with a one-arg function is
         continuous.  (Contributed by Mario Carneiro, 23-Mar-2015.) $)
      cnmptk1 $p |- ( ph ->
        ( x e. X |-> ( y e. Y |-> C ) ) e. ( J Cn ( M ^ko K ) ) ) $=
        ( vw cmpt ccom cxko co ccn cv wcel wral ctopon cfv adantr ctop topontop
        wa wf syl eqid xkotopon syl2anc cnf2 syl3anc fmpt sylibr r19.21bi eqidd
        fmptcof mpteq2dva xkoco2cn coeq2 cnmpt11 eqeltrrd ) ABLDNFUBZCMEUBZUCZU
        BBLCMGUBZUBHKIUDUEZUFUEABLVOVPABUGLUHZUOZCDMNEFGVNVMVSMNVNUPZENUHCMUIVS
        IMUJUKUHZJNUJUKUHZVNIJUFUEZUHZVTAWAVRPULAWBVRQULAWDBLALWCBLVNUBZUPZWDBL
        UIAHLUJUKUHJIUDUEZWCUJUKUHZWEHWGUFUEUHWFOAIUMUHZJUMUHZWHAWAWIPMIUNUQZAW
        BWJQNJUNUQIJWGWGURUSUTZRWEHWGLWCVAVBBLWCVNWEWEURVCVDVEVNIJMNVAVBCMNEVNV
        NURVCVDVSVNVFVSVMVFTVGVHABUAVNVMUAUGZUCVOHWGVQLWCORWLAIJKUAVMWKSVIWMVNV
        MVJVKVL $.
    $}

    ${
      $d y A $.
      cnmpt1k.m $e |- ( ph -> M e. ( TopOn ` W ) ) $.
      cnmpt1k.a $e |- ( ph -> ( x e. X |-> A ) e. ( J Cn L ) ) $.
      cnmpt1k.b $e |- ( ph ->
        ( y e. Y |-> ( z e. Z |-> B ) ) e. ( K Cn ( M ^ko L ) ) ) $.
      cnmpt1k.c $e |- ( z = A -> B = C ) $.
      $( The composition of a one-arg function with a curried function is
         continuous.  (Contributed by Mario Carneiro, 23-Mar-2015.)  (Revised
         by Mario Carneiro, 22-Aug-2015.) $)
      cnmpt1k $p |- ( ph ->
        ( y e. Y |-> ( x e. X |-> C ) ) e. ( K Cn ( M ^ko J ) ) ) $=
        ( vw cmpt ccom cxko co ccn cv wcel wa wral ctopon cfv cnf2 syl3anc eqid
        wf fmpt sylibr adantr eqidd fmptcof mpteq2dva ctop topontop syl syl2anc
        xkotopon xkoco1cn coeq1 cnmpt11 eqeltrrd ) ACNDOFUDZBMEUDZUEZUDCNBMGUDZ
        UDIKHUFUGZUHUGACNVPVQACUINUJZUKZBDMOEFGVOVNAEOUJBMULZVSAMOVOURZWAAHMUMU
        NUJJOUMUNUJZVOHJUHUGUJWBPRTVOHJMOUOUPBMOEVOVOUQUSUTVAVTVOVBVTVNVBUBVCVD
        ACUCVNUCUIZVOUEVPIKJUFUGZVRNJKUHUGZQUAAJVEUJZKVEUJZWEWFUMUNUJAWCWGROJVF
        VGAKLUMUNUJWHSLKVFVGZJKWEWEUQVIVHAHJKUCVOWITVJWDVNVOVKVLVM $.
    $}
  $}

  ${
    $d f g z A $.  $d f g y B $.  $d f g x K $.  $d f g x L $.  $d f g x y X $.
    $d f x J $.  $d f g x M $.  $d x y ph $.  $d f g y Y $.  $d f g y z Z $.
    $d z C $.
    cnmptkk.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmptkk.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    cnmptkk.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
    cnmptkk.m $e |- ( ph -> M e. ( TopOn ` W ) ) $.
    cnmptkk.n $e |- ( ph -> L e. N-Locally Comp ) $.
    cnmptkk.a $e |- ( ph ->
      ( x e. X |-> ( y e. Y |-> A ) ) e. ( J Cn ( L ^ko K ) ) ) $.
    cnmptkk.b $e |- ( ph ->
      ( x e. X |-> ( z e. Z |-> B ) ) e. ( J Cn ( M ^ko L ) ) ) $.
    cnmptkk.c $e |- ( z = A -> B = C ) $.
    $( The composition of two curried functions is jointly continuous.
       (Contributed by Mario Carneiro, 23-Mar-2015.)  (Revised by Mario
       Carneiro, 22-Aug-2015.) $)
    cnmptkk $p |- ( ph ->
      ( x e. X |-> ( y e. Y |-> C ) ) e. ( J Cn ( M ^ko K ) ) ) $=
      ( vf vg cmpt ccom cxko co ccn cv wcel wa wf wral ctopon cfv ctop topontop
      adantr syl ccmp cnlly nllytop eqid xkotopon syl2anc cnf2 syl3anc r19.21bi
      fmpt sylibr eqidd fmptcof mpteq2dva cmpt2 ctx xkococn wceq coeq1 sylan9eq
      coeq2 cnmpt12 eqeltrrd ) ABMDOFUFZCNEUFZUGZUFBMCNGUFZUFHKIUHUIZUJUIABMWGW
      HABUKMULZUMZCDNOEFGWFWEWKNOWFUNZEOULCNUOWKINUPUQULZJOUPUQULZWFIJUJUIZULZW
      LAWMWJQUTAWNWJRUTAWPBMAMWOBMWFUFZUNZWPBMUOAHMUPUQULJIUHUIZWOUPUQULZWQHWSU
      JUIULWRPAIURULZJURULZWTAWMXAQNIUSVAZAJVBVCULZXBTVBJVDVAZIJWSWSVEVFVGZUAWQ
      HWSMWOVHVIBMWOWFWQWQVEVKVLVJWFIJNOVHVICNOEWFWFVEVKVLWKWFVMWKWEVMUCVNVOABU
      DUEWEWFUDUKZUEUKZUGZWGHKJUHUIZWSWIMJKUJUIZWOPUBUAAXBKURULZXJXKUPUQULXEAKL
      UPUQULXLSLKUSVAZJKXJXJVEVFVGXFAXAXDXLUDUEXKWOXIVPZXJWSVQUIWIUJUIULXCTXMIJ
      KUDUEXNXNVEVRVIXGWEVSXHWFVSXIWEXHUGWGXGWEXHVTXHWFWEWBWAWCWD $.
  $}

  ${
    $d f g h x y R $.  $d f g h x y S $.  $d f g h x y X $.
    xkofvcn.1 $e |- X = U. R $.
    xkofvcn.2 $e |- F = ( f e. ( R Cn S ) , x e. X |-> ( f ` x ) ) $.
    $( Joint continuity of the function value operation as a function on
       continuous function spaces.  (Compare ~ xkopjcn .)  (Contributed by
       Mario Carneiro, 20-Mar-2015.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    xkofvcn $p |- ( ( R e. N-Locally Comp /\ S e. Top ) ->
      F e. ( ( ( S ^ko R ) tX R ) Cn S ) ) $=
      ( vg vh vy wcel ccn co cv cfv c1o c0 ctopon wceq ccmp cnlly ctop wa cmpt2
      cxko ctx csn cxp ccom cpw nllytop xkotopon sylan adantr toptopon cnmpt1st
      eqid sylib cnmpt2nd cmpt con0 distopon mp1i xkoccn syl2anc xpeq2d cnmpt21
      1on distop simpl simpr xkococn syl3anc coeq1 coeq2 sylan9eq cnmpt22 0lt1o
      sneq cuni unipw eqcomi xkopjcn fveq1 wf fconst fvco3 mp2an fvconst2 ax-mp
      a1i vex fveq2i eqtri syl6eq syl5eqel ) BUAUBLZCUCLZUDZEDABCMNZFAOZDOZPZUE
      CBUFNZBUGNCMNHWTDAIXCQXBUHZUIZUJZRIOZPZXDXEBCQUKZUFNZCXAFXKCMNZWRBUCLZWSX
      EXASPLUABULZBCXEXEURUMUNZWTXNBFSPLZWRXNWSXOUOZBFGUPUSZWTDAIJXCXGXIJOZUJZX
      HXEBXEBXKUFNZXLXKBMNZXAFXAXPXSWTDAXEBXAFXPXSUQWTDAKXBQKOZUHZUIZXGXEBBYBXA
      FFXPXSWTDAXEBXAFXPXSUTXSWTXKQSPLZXQKFYFVABYBMNLQVBLZYGWTVIQVBVCVDXSKXKBQF
      VEVFYDXBTYEXFQYDXBVTVGVHXPWTXKUCLZXNYBYCSPLYHYIWTVIQVBVJVDZXRXKBYBYBURUMV
      FWTYIWRWSIJXAYCYAUEZXEYBUGNXLMNLYJWRWSVKWRWSVLZXKBCIJYKYKURVMVNXIXCTXTXGT
      YAXCXTUJXHXIXCXTVOXTXGXCVPVQVRWTYIWSXLXMSPLYJYLXKCXLXLURUMVFWTYIWSRQLZIXM
      XJVAXLCMNLYJYLYMWTVSWLRXKCIQXKWAQQWBWCWDVNXIXHTXJRXHPZXDRXIXHWEYNRXGPZXCP
      ZXDQXFXGWFYMYNYPTQXBAWMZWGVSQXFRXCXGWHWIYOXBXCYMYOXBTVSQXBRYQWJWKWNWOWPVH
      WQ $.
  $}

  ${
    $d f k t w z A $.  $d f k w x z J $.  $d f k w x z K $.  $d f k w x z L $.
    $d f y z B $.  $d y C $.  $d f k t w x y z X $.  $d f k t w x y z Y $.
    $d f k w x y z ph $.  $d y Z $.
    cnmptk1p.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmptk1p.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    cnmptk1p.l $e |- ( ph -> L e. ( TopOn ` Z ) ) $.
    cnmptk1p.n $e |- ( ph -> K e. N-Locally Comp ) $.
    ${
      cnmptk1p.a $e |- ( ph ->
        ( x e. X |-> ( y e. Y |-> A ) ) e. ( J Cn ( L ^ko K ) ) ) $.
      cnmptk1p.b $e |- ( ph -> ( x e. X |-> B ) e. ( J Cn K ) ) $.
      cnmptk1p.c $e |- ( y = B -> A = C ) $.
      $( The evaluation of a curried function by a one-arg function is jointly
         continuous.  (Contributed by Mario Carneiro, 23-Mar-2015.)  (Revised
         by Mario Carneiro, 22-Aug-2015.) $)
      cnmptk1p $p |- ( ph -> ( x e. X |-> C ) e. ( J Cn L ) ) $=
        ( wcel vf vz cmpt cfv ccn co cv wceq wral ctopon cnf2 syl3anc eqid fmpt
        wa wf sylibr r19.21bi adantr cxko ctop ccmp cnlly syl topontop xkotopon
        nllytop eleq1d rspcv sylc fvmptg mpteq2dva cmpt2 cuni toponuni mpt2eq12
        syl2anc sylancr xkofvcn eqeltrd fveq1 fveq2 sylan9eq cnmpt12 eqeltrrd
        ctx ) ABJECKDUCZUDZUCBJFUCGIUEUFABJWHFABUGJTZUOZEKTZFLTZWHFUHAWKBJAJKBJ
        EUCZUPZWKBJUIAGJUJUDTZHKUJUDTZWMGHUEUFTWNMNRWMGHJKUKULBJKEWMWMUMUNUQURZ
        WJWKDLTZCKUIZWLWQWJKLWGUPZWSWJWPILUJUDTZWGHIUEUFZTZWTAWPWINUSAXAWIOUSAX
        CBJAJXBBJWGUCZUPZXCBJUIAWOIHUTUFZXBUJUDTZXDGXFUEUFTXEMAHVATZIVATZXGAHVB
        VCTZXHPVBHVGVDAXAXIOLIVEVDZHIXFXFUMVFVQZQXDGXFJXBUKULBJXBWGXDXDUMUNUQUR
        WGHIKLUKULCKLDWGWGUMZUNUQWRWLCEKCUGEUHDFLSVHVIVJCEDFKLWGSXMVKVQVLABUAUB
        WGEUBUGZUAUGZUDZWHGXFHIJXBKMQRXLNAUAUBXBKXPVMZUAUBXBHVNZXPVMZXFHWFUFIUE
        UFZAXBXBUHKXRUHZXQXSUHXBUMAWPYANKHVOVDUAUBXBKXBXRXPVPVRAXJXIXSXTTPXKUBH
        IUAXSXRXRUMXSUMVSVQVTXOWGUHXNEUHXPXNWGUDWHXNXOWGWAXNEWGWBWCWDWE $.
    $}

    cnmptk2.a $e |- ( ph ->
      ( x e. X |-> ( y e. Y |-> A ) ) e. ( J Cn ( L ^ko K ) ) ) $.
    $( The uncurrying of a curried function is continuous.  (Contributed by
       Mario Carneiro, 23-Mar-2015.)  (Revised by Mario Carneiro,
       22-Aug-2015.) $)
    cnmptk2 $p |- ( ph -> ( x e. X , y e. Y |-> A ) e. ( ( J tX K ) Cn L ) ) $=
      ( vw vk cfv wceq wcel vf vz cv cmpt cmpt2 ctx co ccn nffvmpt1 nfcv nfmpt1
      nffv nfmpt fveq2 fveq1d sylan9eq cbvmpt2 wa simplr wf wral cxko ctop ccmp
      ctopon cnlly nllytop syl topontop eqid xkotopon syl2anc cnf2 syl3anc fmpt
      sylibr r19.21bi adantr fvmpt2 simpr mpt2eq3dva cnmpt1st cnmpt21f cnmpt2nd
      eqtrd 3impa syl5eq cuni toponuni mpt2eq12 sylancr xkofvcn eqeltrd cnmpt22
      fveq1 eqeltrrd ) APQHIQUCZPUCZBHCIDUDZUDZRZRZUEZBCHIDUEZEFUFUGGUHUGAXCBCH
      ICUCZBUCZWTRZRZUEXDPQBCHIXBXHBWQXABHWSWRUIBWQUJULCWQXACWRWTCBHWSCHUJCIDUK
      UMCWRUJULCWQUJULPXHUJQXHUJWRXFSZWQXESXBWQXGRXHXIWQXAXGWRXFWTUNUOWQXEXGUNU
      PUQABCHIXHDAXFHTZXEITZXHDSAXJURZXKURZXHXEWSRZDXMXEXGWSXMXJWSFGUHUGZTZXGWS
      SAXJXKUSXLXPXKAXPBHAHXOWTUTZXPBHVAAEHVERTGFVBUGZXOVERTZWTEXRUHUGTXQKAFVCT
      ZGVCTZXSAFVDVFTZXTNVDFVGVHAGJVERTZYAMJGVIVHZFGXRXRVJVKVLZOWTEXRHXOVMVNBHX
      OWSWTWTVJZVOVPVQZVRBHWSXOWTYFVSVLUOXMXKDJTZXNDSXLXKVTXLYHCIXLIJWSUTZYHCIV
      AXLFIVERTZYCXPYIAYJXJLVRAYCXJMVRYGWSFGIJVMVNCIJDWSWSVJZVOVPVQCIDJWSYKVSVL
      WEWFWAWGAPQUAUBXAWQUBUCZUAUCZRZXBEFXRFGIHIXOKLAPQWRWTEFEXRHIKLAPQEFHIKLWB
      OWCAPQEFHIKLWDYELAUAUBXOIYNUEZUAUBXOFWHZYNUEZXRFUFUGGUHUGZAXOXOSIYPSZYOYQ
      SXOVJAYJYSLIFWIVHUAUBXOIXOYPYNWJWKAYBYAYQYRTNYDUBFGUAYQYPYPVJYQVJWLVLWMYM
      XASYLWQSYNYLXARXBYLYMXAWOYLWQXAUNUPWNWP $.
  $}

  ${
    $d f k r v w x y z R $.  $d f k r v w x y z S $.  $d f k r v w x y z Y $.
    $d k t v w x z $.  $d k v z F $.  $d k r v w x y z X $.
    xkoinjcn.3 $e |- F = ( x e. X |-> ( y e. Y |-> <. y , x >. ) ) $.
    $( Continuity of "injection", i.e. currying, as a function on continuous
       function spaces.  (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    xkoinjcn $p |- ( ( R e. ( TopOn ` X ) /\ S e. ( TopOn ` Y ) ) ->
      F e. ( R Cn ( ( S tX R ) ^ko S ) ) ) $=
      ( vz vk vv vw wcel wa co cv wss wceq syl cvv vf vt vr ctopon cfv ctx cxko
      ccn wf ccnv cima crest ccmp cuni cpw crab cmpt2 crn wral cop cmpt cnmptid
      simplr simpll simpr cnmptc cnmpt1t fmptd wrex eqid xkobval abeq2i csn cxp
      sylan imaeq1 sseq1d elrab3 wfun cdm funmpt simplrl elpwid simprd toponuni
      wb sseqtr4d adantr dmmptg opex a1i syl6sseqr funimass4 sylancr wel sselda
      opeq1 fvmpt eleq1d vex weq opeq2 ralsn syl6bbr ralbidva dfss3 eleq1 ralxp
      mprg bitri 3bitrd rabbidva sneq xpeq2d elrab cin ad2antrr topontop adantl
      ctop txtop syl2anc ad3antrrr toponmax xpexg simprr elrestr syl3anc txrest
      syl22anc oveq2d restid eqtrd eleqtrd resttopon xpeq1d simprl xpss2 mpbird
      ciun snssd ssind eqsstr3d txtube toponss ssrab baib biantrud iunid xpeq2i
      xpiundi eqtr3i sseq1i iunss ssin 3bitr3g anbi2d rexbidva ralrimiva eltop2
      sylan2b 3syl eqeltrd imaeq2 mptpreima syl6eq syl5ibrcom rexlimdvva syl5bi
      expimpd ralrimiv simpl ovex xkotf frn ax-mp ssexi cfi ctg xkoval xkotopon
      pwex subbascn mpbir2and ) CFUDUEZMZDGUDUEMZNZECDCUFOZDUGOZUHOMFDUWIUHOZEU
      IEUJZIPZUKZCMZIJKDLPZULOUMMLDUNZUOZUPZUWIUAPZJPZUKZKPZQZUAUWKUPZUQZURZUSU
      WHAFBGBPZAPZUTZVAZUWKEUWHUXIFMZNZBUXHUXIDDCGUWFUWGUXLVCZUXMBDGUXNVBUXMBUX
      IDCGFUXNUWFUWGUXLVDUWHUXLVEVFVGZHVHUWHUWOIUXGUWMUXGMDUXAULOZUMMZUWMUXERZN
      ZKUWIVIJUWRVIZUWHUWOUXTIUXGLKDUWIUXFUAJUWSUWQIUWQVJZUWSVJZUXFVJZVKVLUWHUX
      SUWOJKUWRUWIUWHUXAUWRMZUXCUWIMZNZNZUXQUXRUWOUYGUXQNZUWOUXRUXKUXEMZAFUPZCM
      UYHUYJUXAUXIVMZVNZUXCQZAFUPZCUYHUYIUYMAFUYHUXLNZUYIUXKUXAUKZUXCQZUWMUXKUE
      ZUXCMZIUXAUSZUYMUYOUXKUWKMZUYIUYQWFUYHUWHUXLVUAUWHUYFUXQVDZUXOVOUXDUYQUAU
      XKUWKUWTUXKRUXBUYPUXCUWTUXKUXAVPVQVRSUYOUXKVSUXAUXKVTZQUYQUYTWFBGUXJWAUYO
      UXAGVUCUYHUXAGQZUXLUYHUXAUWQGUYHUXAUWQUWHUYDUYEUXQWBWCUYHUWGGUWQRUYHUWFUW
      GVUBWDZGDWESWGZWHZUXJTMZVUCGRBGBGUXJTWIVUHUXHGMUXHUXIWJWKXIWLIUXAUXCUXKWM
      WNUYOUYTUWMUWPUTZUXCMZLUYKUSZIUXAUSZUYMUYOUYSVUKIUXAUYOIJWONZUYSUWMUXIUTZ
      UXCMZVUKVUMUYRVUNUXCVUMUWMGMUYRVUNRUYOUXAGUWMVUGWPBUWMUXJVUNGUXKUXHUWMUXI
      WQUXKVJUWMUXIWJWRSWSVUJVUOLUXIAWTLAXAVUIVUNUXCUWPUXIUWMXBWSXCXDXEUYMUBKWO
      ZUBUYLUSVULUBUYLUXCXFVUPVUJUBILUXAUYKUBPVUIUXCXGXHXJXDXKXLUYHUYNCMZLUCWOZ
      UCPZUYNQZNZUCCVIZLUYNUSZUYHVVBLUYNUWPUYNMUYHUWPFMZUXAUWPVMZVNZUXCQZNZVVBU
      YMVVGAUWPFALXAZUYLVVFUXCVVIUYKVVEUXAUXIUWPXMXNVQXOUYHVVHNZVVBVURUXPUNZVUS
      VNZUXCUXAFVNZXPZQZNZUCCVIVVJUCUWPUXPCVVNVVKCUNZVVKVJVVQVJZUYGUXQVVHVCVVJU
      WFCXTMZUYGUWFUXQVVHUWFUWGUYFVDXQZFCXRZSZVVJVVNUWIVVMULOZUXPCUFOZVVJUWIXTM
      ZVVMTMZUYEVVNVWCMUWHVWEUYFUXQVVHUWHDXTMZVVSVWEUWGVWGUWFGDXRXSZUWFVVSUWGVW
      AWHZDCYAYBZYCVVJUXATMZFCMZVWFJWTZVVJUWFVWLVVTFCYDSZUXAFTCYEWNUYGUYEUXQVVH
      UWHUYDUYEYFXQUXCVVMUWIXTTYGYHVVJVWCUXPCFULOZUFOZVWDVVJVWGVVSVWKVWLVWCVWPR
      UWHVWGUYFUXQVVHVWHYCVWBVWKVVJVWMWKVWNUXAFDCXTXTTCYIYJVVJVWOCUXPUFVVJVWOCV
      VQULOZCVVJFVVQCULVVJUWFFVVQRVVTFCWESZYKVVJUWFVWQCRVVTCUWEVVQVVRYLSYMYKYMY
      NVVJVVKVVEVNVVFVVNVVJUXAVVKVVEVVJUXPUXAUDUEMZUXAVVKRZVVJUWGVUDVWSUYHUWGVV
      HVUEWHUYHVUDVVHVUFWHUXADGYOYBUXAUXPWESZYPVVJVVFUXCVVMUYHVVDVVGYFVVJVVEFQV
      VFVVMQVVJUWPFUYHVVDVVGYQZUUAVVEFUXAYRSUUBUUCVVJUWPFVVQVXBVWRYNUUDVVJVVAVV
      PUCCVVJVUSCMZNZVUTVVOVURVXDVUTUYMAVUSUSZUXAVUSVNZVVNQZVVOVXDVUSFQZVUTVXEW
      FVVJUWFVXCVXHVVTVUSCFUUEVOZVUTVXHVXEUYMAFVUSUUFUUGSVXDVXFUXCQZVXJVXFVVMQZ
      NVXEVXGVXDVXKVXJVXDVXHVXKVXIVUSFUXAYRSUUHVXJAVUSUYLYTZUXCQVXEVXFVXLUXCUXA
      AVUSUYKYTZVNVXFVXLVXMVUSUXAAVUSUUIUUJAVUSUYKUXAUUKUULUUMAVUSUYLUXCUUNXJVX
      FUXCVVMUUOUUPVXDVXFVVLVVNVXDUXAVVKVUSVVJVWTVXCVXAWHYPVQXKUUQUURYSUVAUUSUY
      HUWHVVSVUQVVCWFVUBVWILUCUYNCUUTUVBYSUVCUXRUWNUYJCUXRUWNUWLUXEUKUYJUWMUXEU
      WLUVDAFUXKUXEEHUVEUVFWSUVGUVJUVHUVIUVKUWHIUXGECUWJTFUWKUWFUWGUVLUXGTMUWHU
      XGUWKUOZUWKDUWIUHUVMUWBUWSUWIVNZVXNUXFUIUXGVXNQLKDUWIUXFUAJUWSUWQUYAUYBUY
      CUVNVXOVXNUXFUVOUVPUVQWKUWHVWGVWEUWJUXGUVRUEUVSUERVWHVWJLKDUWIUXFUAJUWSUW
      QUYAUYBUYCUVTYBUWHVWGVWEUWJUWKUDUEMVWHVWJDUWIUWJUWJVJUWAYBUWCUWD $.
  $}

  ${
    $d v w x y L $.  $d v w x y ph $.  $d v w x y z X $.  $d v w x y z Y $.
    $d v w z A $.  $d v w z J $.  $d v w z K $.
    cnmpt2k.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmpt2k.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    cnmpt2k.a $e |- ( ph ->
      ( x e. X , y e. Y |-> A ) e. ( ( J tX K ) Cn L ) ) $.
    $( The currying of a two-argument function is continuous.  (Contributed by
       Mario Carneiro, 23-Mar-2015.) $)
    cnmpt2k $p |- ( ph ->
      ( x e. X |-> ( y e. Y |-> A ) ) e. ( J Cn ( L ^ko K ) ) ) $=
      ( vw vv cv co cmpt nfcv wcel cfv vz cmpt2 cxko nfmpt22 nfov nfmpt nfmpt21
      ccn wceq oveq1 cbvmpt oveq2 mpteq2dv syl5eq wa cuni simpr simplr wral cxp
      wf ctx ctopon txtopon syl2anc ctop cntop2 syl eqid toptopon cnmptcom cnf2
      sylib syl3anc fmpt2 r19.21bi an32s ovmpt4g mpteq2dva cop xkoinjcn feqmptd
      sylibr eqeltrrd fveq2 df-ov syl6eqr cnmptk1 ) AMHNINOZMOZCBIHDUBZPZQZQZBH
      CIDQZQZEGFUCPUHPAWNBHCICOZBOZWKPZQZQWPMBHWMWTBNIWLBIRBWIWJWKBWIRCBIHDUDBW
      JRUEUFMWTRWJWRUIZWMCIWQWJWKPZQWTNCIWLXBCWIWJWKCWIRCBIHDUGCWJRUENXBRWIWQWJ
      WKUJUKXACIXBWSWJWRWQWKULUMUNUKABHWTWOAWRHSZUOZCIWSDXDWQISZUOXEXCDGUPZSZWS
      DUIXDXEUQAXCXEURAXEXCXGAXEUOXGBHAXGBHUSZCIAIHUTZXFWKVAZXHCIUSAFEVBPZXIVCT
      SZGXFVCTSZWKXKGUHPZSXJAFIVCTSZEHVCTSZXLKJFEIHVDVEZAGVFSZXMABCHIDUBZEFVBPZ
      GUHPSXRLXSXTGVGVHGXFXFVIVJVMABCDEFGHIJKLVKZWKXKGXIXFVLVNZCBIHDXFWKWKVIZVO
      WCVPVPVQCBIHDWKXFYCVRVNVSVSUNAMNUAWIWJVTZUAOZWKTZWLEFXKGHIXIJKXQAXPXOMHNI
      YDQQZEXKFUCPUHPSJKMNEFYGHIYGVIWAVEAWKUAXIYFQXNAUAXIXFWKYBWBYAWDYEYDUIYFYD
      WKTWLYEYDWKWEWIWJWKWFWGWHWD $.
  $}

  ${
    $d a w x z R $.  $d a w x z S $.
    $( The topological product of two connected spaces is connected.
       (Contributed by Mario Carneiro, 29-Mar-2015.) $)
    txcon $p |- ( ( R e. Con /\ S e. Con ) -> ( R tX S ) e. Con ) $=
      ( vx vz va ccon wcel wa co cfv c0 cv wceq syl cop eqid eleqtrrd syl5eqelr
      syl2anc eleq1d vw ctx ctop ccld cin cpr wss contop txtop syl2an wo wn wex
      cuni neq0 inss1 simplr sseldi elssuni c1st c2nd cxp simplll simpllr txuni
      simprr 1st2nd2 crab xp2nd cmpt ccnv cima mptpreima ccn ctopon sylib xp1st
      toptopon cnmptc cnmptid cnmpt1t cnima wrex wne simprl elunii opeq1 rspcev
      eqeltrrd rabn0 sylibr inss2 cnclima conclo elrab simprbi opeq2 expr ssrdv
      eqeltrd eqssd ex exlimdv syl5bi orrd vex elpr syl6ibr iscon2 sylanbrc ) A
      FGZBFGZHZABUBIZUCGZXNXNUDJZUEZKXNUNZUFZUGXNFGXKAUCGZBUCGZXOXLAUHZBUHZABUI
      UJXMCXQXSXMCLZXQGZYDKMZYDXRMZUKZYDXSGXMYEYHXMYEHZYFYGYFULDLZYDGZDUMYIYGDY
      DUOYIYKYGDYIYKYGYIYKHZYDXRYLYDXNGZYDXRUGYLXQXNYDXNXPUPZXMYEYKUQURYDXNUSNY
      LUAXRYDYIYKUALZXRGZYOYDGYIYKYPHZHZYOYOUTJZYOVAJZOZYDYRYOAUNZBUNZVBZGZYOUU
      AMYRYOXRUUDYIYKYPVFYRXTYAUUDXRMYRXKXTXKXLYEYQVCZYBNZYRXLYAXKXLYEYQVDZYCNZ
      ABUUBUUCUUBPZUUCPZVESZQZYOUUBUUCVGNYRYTYSELZOZYDGZEUUCVHZGZUUAYDGZYRYTUUC
      UUQYRUUEYTUUCGZUUMYOUUBUUCVINYRUUQBUUCUUKUUHYRUUQEUUCUUOVJZVKYDVLZBEUUCUU
      OYDUVAUVAPVMZYRUVABXNVNIGZYMUVBBGYREYSUUNBABUUCYRYABUUCVOJGUUIBUUCUUKVRVP
      ZYREYSBAUUCUUBUVEYRXTAUUBVOJGUUGAUUBUUJVRVPZYRUUEYSUUBGZUUMYOUUBUUCVQNZVS
      YREBUUCUVEVTWAZYRXQXNYDYNXMYEYQUQZURZYDUVABXNWBSRYRUUPEUUCWCZUUQKWDYRYJVA
      JZUUCGZYSUVMOZYDGZUVLYRYJUUDGZUVNYRYJXRUUDYRYKYMYJXRGYIYKYPWEZUVKYJYDXNWF
      SUULQZYJUUBUUCVINZYRYSUUNUVMOZYDGZEUUBVHZGZUVPYRYSUUBUWCUVHYRUWCAUUBUUJUU
      FYRUWCEUUBUWAVJZVKYDVLZAEUUBUWAYDUWEUWEPVMZYRUWEAXNVNIGZYMUWFAGYREUUNUVMA
      ABUUBUVFYREAUUBUVFVTYREUVMABUUBUUCUVFUVEUVTVSWAZUVKYDUWEAXNWBSRYRUWBEUUBW
      CZUWCKWDYRYJUTJZUUBGZUWKUVMOZYDGZUWJYRUVQUWLUVSYJUUBUUCVQNYRYJUWMYDYRUVQY
      JUWMMUVSYJUUBUUCVGNUVRWIUWBUWNEUWKUUBUUNUWKMUWAUWMYDUUNUWKUVMWGTWHSUWBEUU
      BWJWKYRUWCUWFAUDJZUWGYRUWHYDXPGZUWFUWOGUWIYRXQXPYDXNXPWLUVJURZYDUWEAXNWMS
      RWNQUWDUVGUVPUWBUVPEYSUUBUUNYSMUWAUVOYDUUNYSUVMWGTWOWPNUUPUVPEUVMUUCUUNUV
      MMUUOUVOYDUUNUVMYSWQTWHSUUPEUUCWJWKYRUUQUVBBUDJZUVCYRUVDUWPUVBUWRGUVIUWQY
      DUVABXNWMSRWNQUURUUTUUSUUPUUSEYTUUCUUNYTMUUOUUAYDUUNYTYSWQTWOWPNWTWRWSXAX
      BXCXDXEXBYDKXRCXFXGXHWSXNXRXRPXIXJ $.
  $}

  ${
    $d y A $.  $d y J $.  $d y K $.  $d y R $.  $d y X $.
    imasnopn.1 $e |- X = U. J $.
    $( If a relation graph is opened, then an image set of a singleton is also
       opened.  Corollary of proposition 4 of [BourbakiTop1] p.  I.26.
       (Contributed by Thierry Arnoux, 14-Jan-2018.) $)
    imasnopn $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( R e. ( J tX K ) /\
      A e. X ) ) -> ( R " { A } ) e. K ) $=
      ( vy ctop wcel wa co cima cuni wss adantr eqid syl2anc wceq ad2antll cvv
      ctx csn cop cmpt ccnv crab nfv nfcv nfrab1 cxp txtop simprl eltopss txuni
      cv sseqtr4d imass1 syl xpimasn sseqtrd sseld pm4.71rd vex elimasng anbi2d
      wb mpan2 bitrd rabid syl6bbr eqrd mptpreima syl6eqr ccn ctopon cfv biimpi
      toptopon ad2antlr ad2antrr simprr cnmptc cnmptid cnmpt1t cnima eqeltrd )
      CHIZDHIZJZBCDUAKZIZAEIZJZJZBAUBZLZGDMZAGUOZUCZUDZUEBLZDWNWPWSBIZGWQUFZXAW
      NGWPXCWNGUGGWPUHXBGWQUIWNWRWPIZWRWQIZXBJZWRXCIWNXDXEXDJXFWNXDXEWNWPWQWRWN
      WPEWQUJZWOLZWQWNBXGNWPXHNWNBWJMZXGWNWJHIZWKBXINWIXJWMCDUKOWIWKWLULZBWJXIX
      IPUMQWIXGXIRWMCDEWQFWQPZUNOUPBXGWOUQURWLXHWQRWIWKEWQAUSSUTVAVBWNXDXBXEWLX
      DXBVFZWIWKWLWRTIXMGVCBAWRETVDVGSVEVHXBGWQVIVJVKGWQWSBWTWTPVLVMWNWTDWJVNKI
      WKXADIWNGAWRDCDWQWHDWQVOVPIZWGWMWHXNDWQXLVRVQVSZWNGADCWQEXOWGCEVOVPIZWHWM
      WGXPCEFVRVQVTWIWKWLWAWBWNGDWQXOWCWDXKBWTDWJWEQWF $.

    $( If a relation graph is closed, then an image set of a singleton is also
       closed.  Corollary of proposition 4 of [BourbakiTop1] p.  I.26.
       (Contributed by Thierry Arnoux, 14-Jan-2018.) $)
    imasncld $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( R e. ( Clsd ` ( J tX K ) )
      /\ A e. X ) ) -> ( R " { A } ) e. ( Clsd ` K ) ) $=
      ( vy ctop wcel wa co ccld cfv cima cuni wss eqid syl wceq ad2antll ctx cv
      csn cop cmpt ccnv crab nfv nfcv nfrab1 simprl cldss txuni adantr sseqtr4d
      cxp imass1 xpimasn sseqtrd sseld pm4.71rd wb cvv vex elimasng mpan2 bitrd
      anbi2d syl6bbr eqrd mptpreima syl6eqr ccn ctopon toptopon biimpi ad2antlr
      rabid ad2antrr simprr cnmptc cnmptid cnmpt1t cnclima syl2anc eqeltrd ) CH
      IZDHIZJZBCDUAKZLMIZAEIZJZJZBAUCZNZGDOZAGUBZUDZUEZUFBNZDLMZWNWPWSBIZGWQUGZ
      XAWNGWPXDWNGUHGWPUIXCGWQUJWNWRWPIZWRWQIZXCJZWRXDIWNXEXFXEJXGWNXEXFWNWPWQW
      RWNWPEWQUPZWONZWQWNBXHPWPXIPWNBWJOZXHWNWKBXJPWIWKWLUKZBWJXJXJQULRWIXHXJSW
      MCDEWQFWQQZUMUNUOBXHWOUQRWLXIWQSWIWKEWQAURTUSUTVAWNXEXCXFWLXEXCVBZWIWKWLW
      RVCIXMGVDBAWREVCVEVFTVHVGXCGWQVRVIVJGWQWSBWTWTQVKVLWNWTDWJVMKIWKXAXBIWNGA
      WRDCDWQWHDWQVNMIZWGWMWHXNDWQXLVOVPVQZWNGADCWQEXOWGCEVNMIZWHWMWGXPCEFVOVPV
      SWIWKWLVTWAWNGDWQXOWBWCXKBWTDWJWDWEWF $.

    $d y Y $.
    imasnopn.2 $e |- Y = U. K $.
    $( If a relation graph is closed, then an image set of a singleton is also
       closed.  Corollary of proposition 4 of [BourbakiTop1] p.  I.26.
       (Contributed by Thierry Arnoux, 14-Jan-2018.) $)
    imasncls $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( R C_ ( X X. Y )
      /\ A e. X ) ) -> ( ( cls ` K ) ` ( R " { A } ) )
        C_ ( ( ( cls ` ( J tX K ) ) ` R ) " { A } ) ) $=
      ( vy ctop wcel wa wss cima ccl cfv co sseqtrd ad2antll cvv cxp cv cop ctx
      cmpt ccnv csn cuni ctopon toptopon biimpi ad2antlr ad2antrr simprr cnmptc
      ccn cnmptid cnmpt1t simprl wceq adantr eqid cncls2i syl2anc crab nfv nfcv
      txuni nfrab1 imass1 xpimasn sseld pm4.71rd wb elimasng mpan2 anbi2d bitrd
      syl vex rabid syl6bbr eqrd mptpreima syl6eqr fveq2d txtop clsss3 sseqtr4d
      3sstr4d ) CJKZDJKZLZBEFUAZMZAEKZLZLZIFAIUBZUCZUEZUFZBNZDOPZPZXBBCDUDQZOPP
      ZNZBAUGZNZXDPXGXINZWRXADXFUPQKBXFUHZMZXEXHMWRIAWSDCDFWLDFUIPKZWKWQWLXNDFH
      UJUKULZWRIADCFEXOWKCEUIPKZWLWQWKXPCEGUJUKUMWMWOWPUNUOWRIDFXOUQURWRBWNXLWM
      WOWPUSZWMWNXLUTWQCDEFGHVHVAZRZBXADXFXLXLVBZVCVDWRXJXCXDWRXJWTBKZIFVEZXCWR
      IXJYBWRIVFZIXJVGYAIFVIWRWSXJKZWSFKZYALZWSYBKWRYDYEYDLYFWRYDYEWRXJFWSWRXJW
      NXINZFWRWOXJYGMXQBWNXIVJVSWPYGFUTWMWOEFAVKSZRVLVMWRYDYAYEWPYDYAVNZWMWOWPW
      STKZYIIVTZBAWSETVOVPSVQVRYAIFWAWBWCIFWTBXAXAVBZWDWEWFWRXKWTXGKZIFVEZXHWRI
      XKYNYCIXKVGYMIFVIWRWSXKKZYEYMLZWSYNKWRYOYEYOLYPWRYOYEWRXKFWSWRXKYGFWRXGWN
      MXKYGMWRXGXLWNWRXFJKZXMXGXLMWMYQWQCDWGVAXSBXFXLXTWHVDXRWIXGWNXIVJVSYHRVLV
      MWRYOYMYEWPYOYMVNZWMWOWPYJYRYKXGAWSETVOVPSVQVRYMIFWAWBWCIFWTXGXAYLWDWEWJ
      $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Quotient maps and quotient topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c KQ $.

  $( Extend class notation with the Kolmogorov quotient function. $)
  ckq $a class KQ $.

  ${
    $d j x y $.
    $( Define the Kolmogorov quotient.  This is a function on topologies which
       maps a topology to its quotient under the topological distinguishability
       map, which takes a point to the set of open sets that contain it.  Two
       points are mapped to the same image under this function iff they are
       topologically indistinguishable.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    df-kq $a |- KQ = ( j e. Top |-> ( j qTop
      ( x e. U. j |-> { y e. j | x e. y } ) ) ) $.
  $}

  ${
    $d s A $.  $d f j s F $.  $d f j s J $.  $d s V $.  $d s Y $.  $d s Z $.
    $d f j s X $.
    qtopval.1 $e |- X = U. J $.
    $( Value of the quotient topology function.  (Contributed by Mario
       Carneiro, 23-Mar-2015.) $)
    qtopval $p |- ( ( J e. V /\ F e. W ) ->
      ( J qTop F ) = { s e. ~P ( F " X ) | ( ( `' F " s ) i^i X ) e. J } ) $=
      ( vj vf wcel cvv cqtop ccnv cv cima cin cpw crab wceq elex co imaexg 3syl
      pwexg rabexg adantl cuni simpr simpl unieqd syl6eqr imaeq12d pweqd cnveqd
      wa imaeq1d ineq12d eleq12d rabeqbidv df-qtop ovmpt2ga mpd3an3 syl2an ) BC
      JBKJZAKJZBALUAAMZFNZOZEPZBJZFAEOZQZRZSZADJBCTADTVDVEVMKJZVNVEVOVDVEVKKJVL
      KJVOAEKUBVKKUDVJFVLKUEUCUFHIBAKKINZMZVGOZHNZUGZPZVSJZFVPVTOZQZRVMLKVSBSZV
      PASZUOZWBVJFWDVLWGWCVKWGVPAVTEWEWFUHZWGVTBUGEWGVSBWEWFUIZUJGUKZULUMWGWAVI
      VSBWGVRVHVTEWGVQVFVGWGVPAWHUNUPWJUQWIURUSIHFUTVAVBVC $.

    $( Value of the quotient topology function when ` F ` is a function on the
       base set.  (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    qtopval2 $p |- ( ( J e. V /\ F : Z -onto-> Y /\ Z C_ X ) ->
      ( J qTop F ) = { s e. ~P Y | ( `' F " s ) e. J } ) $=
      ( wcel wfo wss cima cpw crab cvv wceq 3ad2ant2 syl2anc syl5sseq syl cqtop
      w3a co ccnv cv cin simp1 wf fof cuni uniexg 3ad2ant1 syl5eqel simp3 ssexd
      fex qtopval crn imassrn forn foima imass2 eqsstr3d eqssd cdm cnvimass fdm
      pweqd sstrd df-ss sylib eleq1d rabeqbidv eqtrd ) BCIZFEAJZFDKZUBZBAUAUCZA
      UDGUEZLZDUFZBIZGADLZMZNZWABIZGEMZNVRVOAOIZVSWFPVOVPVQUGVRFEAUHZFOIWIVPVOW
      JVQFEAUIQZVRFDOVRDBUJZOHVOVPWLOIVQBCUKULUMVOVPVQUNZUOFEOAUPRABCODGHUQRVRW
      CWGGWEWHVRWDEVRWDEVRAURZWDEADUSVPVOWNEPVQFEAUTQSVREAFLZWDVPVOWOEPVQFEAVAQ
      VRVQWOWDKWMFDAVBTVCVDVHVRWBWABVRWADKWBWAPVRWAFDVRAVEZWAFAVTVFVRWJWPFPWKFE
      AVGTSWMVIWADVJVKVLVMVN $.

    $( Value of the quotient topology function.  (Contributed by Mario
       Carneiro, 23-Mar-2015.) $)
    elqtop $p |- ( ( J e. V /\ F : Z -onto-> Y /\ Z C_ X ) ->
      ( A e. ( J qTop F ) <-> ( A C_ Y /\ ( `' F " A ) e. J ) ) ) $=
      ( vs wcel wfo wss w3a cqtop co ccnv cv cima wa cvv cpw crab qtopval2 wceq
      eleq2d imaeq2 eleq1d elrab wb uniexg syl5eqel 3ad2ant1 simp3 ssexd fornex
      cuni simp2 sylc elpw2g syl anbi1d syl5bb bitrd ) CDJZGFBKZGELZMZACBNOZJAB
      PZIQZRZCJZIFUAZUBZJZAFLZVIARZCJZSZVGVHVNABCDEFGIHUCUEVOAVMJZVRSVGVSVLVRIA
      VMVJAUDVKVQCVJAVIUFUGUHVGVTVPVRVGFTJZVTVPUIVGGTJVEWAVGGETVDVEETJVFVDECUPT
      HCDUJUKULVDVEVFUMUNVDVEVFUQGFTBUOURAFTUSUTVAVBVC $.

    $( The quotient topology is unaffected by restriction to the base set.
       This property makes it slightly more convenient to use, since we don't
       have to require that ` F ` be a function with domain ` X ` .
       (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    qtopres $p |- ( F e. V -> ( J qTop F ) = ( J qTop ( F |` X ) ) ) $=
      ( vs vj vf wcel cvv cqtop co cres wceq ccnv cv cima cin cpw crab wa pweqi
      resima rabeq ax-mp residm cnveqi imaeq1i cnvresima 3eqtr3i eleq1i rabbiia
      wb a1i eqtr2i qtopval resexg sylan2 3eqtr4a expcom cuni df-qtop reldmmpt2
      wn c0 ovprc1 eqtr4d pm2.61d1 ) ACIZBJIZBAKLZBADMZKLZNZVJVIVNVJVIUAAOFPZQD
      RZBIZFADQZSZTZVLOZVOQZDRZBIZFVLDQZSZTZVKVMWGWDFVSTZVTWFVSNWGWHNWEVRADUCUB
      WDFWFVSUDUEWDVQFVSWDVQUMVOVSIWCVPBVLDMZOZVOQWBWCVPWJWAVOWIVLADUFUGUHDVOVL
      UIDVOAUIUJUKUNULUOABJCDFEUPVIVJVLJIVMWGNADCUQVLBJJDFEUPURUSUTVJVDVKVEVMBA
      KGHJJHPZOVOQGPZVAZRWLIFWKWMQSTKHGFVBVCZVFBVLKWNVFVGVH $.
  $}

  ${
    $d f g w x y F $.  $d f g x K $.  $d x y V $.  $d w x y X $.  $d f w x Y $.
    $d f g w x y G $.  $d f g x y J $.  $d f g x y ph $.  $d w x Z $.
    $( The quotient topology is a topology.  (Contributed by Mario Carneiro,
       23-Mar-2015.) $)
    qtoptop2 $p |- ( ( J e. Top /\ F e. V /\ Fun F ) ->
      ( J qTop F ) e. Top ) $=
      ( vx vy ctop wcel wfun cqtop cuni wss cin wral cima elqtop syl3anc adantr
      co wa wb w3a cres wceq eqid qtopres 3ad2ant2 cv wi wal crn ccnv cpw simp1
      cdm wfo funres 3ad2ant3 funforn sylib dmres eqsstri a1i simprbda vex elpw
      inss1 sylibr ex ssrdv sstr2 syl5com sspwuni syl6ib imauni simpl1 simplbda
      ciun ralrimiva ssralv iunopn syl2anc syl5eqel jcad sylibrd alrimiv biimpa
      mpan9 adantrr simpld syl5ss inpreima syl simprd adantrl eqeltrd mpbir2and
      inopn ralrimivva cvv ovex istopg ax-mp sylanbrc ) BFGZACGZAHZUAZBAIRZBABJ
      ZUBZIRZFXEXDXHXKUCXFABCXIXIUDZUEUFXGDUGZXKKZXMJZXKGZUHZDUIZXMEUGZLZXKGZEX
      KMDXKMZXKFGZXGXQDXGXNXOXJUJZKZXJUKZXONZBGZSZXPXGXNYEYHXGXNXMYDULZKZYEXGXK
      YJKXNYKXGEXKYJXGXSXKGZXSYJGZXGYLSXSYDKZYMXGYLYNYFXSNZBGZXGXDXJUNZYDXJUOZY
      QXIKZYLYNYPSTXDXEXFUMZXGXJHZYRXFXDUUAXEXIAUPUQZXJURUSZYSXGYQXIAUNZLXIAXIU
      TXIUUDVFVAVBZXSXJBFXIYDYQXLOPZVCXSYDEVDVEVGVHVIXMXKYJVJVKXMYDVLVMXGXNYHXG
      XNSZYGEXMYOVQZBEYFXMVNUUGXDYPEXMMZUUHBGXDXEXFXNVOXGYPEXKMXNUUIXGYPEXKXGYL
      YNYPUUFVPZVRYPEXMXKVSWGEXMYOBVTWAWBVHWCXGXDYRYSXPYITYTUUCUUEXOXJBFXIYDYQX
      LOPWDWEXGYADEXKXKXGXMXKGZYLSZSZYAXTYDKZYFXTNZBGZUUMXTXMYDXMXSVFUUMXMYDKZY
      FXMNZBGZXGUUKUUQUUSSZYLXGUUKUUTXGXDYRYSUUKUUTTYTUUCUUEXMXJBFXIYDYQXLOPWFW
      HZWIWJUUMUUOUURYOLZBUUMUUAUUOUVBUCXGUUAUULUUBQXMXSXJWKWLUUMXDUUSYPUVBBGXG
      XDUULYTQUUMUUQUUSUVAWMXGYLYPUUKUUJWNUURYOBWQPWOXGYAUUNUUPSTZUULXGXDYRYSUV
      CYTUUCUUEXTXJBFXIYDYQXLOPQWPWRXKWSGYCXRYBSTBXJIWTDEWSXKXAXBXCWO $.

    qtoptop.1 $e |- X = U. J $.
    $( The quotient topology is a topology.  (Contributed by Mario Carneiro,
       23-Mar-2015.) $)
    qtoptop $p |- ( ( J e. Top /\ F Fn X ) -> ( J qTop F ) e. Top ) $=
      ( ctop wcel wfn wa cvv wfun cqtop co simpl id topopn syl2anr fnfun adantl
      fnex qtoptop2 syl3anc ) BEFZACGZHUBAIFZAJZBAKLEFUBUCMUCUCCBFUDUBUCNBCDOCB
      ASPUCUEUBCAQRABITUA $.

    $( Value of the quotient topology function.  (Contributed by Mario
       Carneiro, 9-Apr-2015.) $)
    elqtop2 $p |- ( ( J e. V /\ F : X -onto-> Y ) ->
      ( A e. ( J qTop F ) <-> ( A C_ Y /\ ( `' F " A ) e. J ) ) ) $=
      ( wcel wfo wss cqtop co ccnv cima wa wb ssid elqtop mp3an3 ) CDHEFBIEEJAC
      BKLHAFJBMANCHOPEQABCDEFEGRS $.

    $( The base set of the quotient topology.  (Contributed by Mario Carneiro,
       23-Mar-2015.) $)
    qtopuni $p |- ( ( J e. Top /\ F : X -onto-> Y ) ->
      Y = U. ( J qTop F ) ) $=
      ( vx ctop wcel wfo wa cqtop co cuni wss ccnv cima ssid a1i syl elqtop2 wf
      wceq fof adantl fimacnv topopn adantr eqeltrd mpbir2and elssuni cpw simpl
      cv vex elpw sylibr syl6bi ssrdv sspwuni sylib eqssd ) BGHZCDAIZJZDBAKLZMZ
      VDDVEHZDVFNVDVGDDNZAOZDPZBHVHVDDQRVDVJCBVDCDAUAZVJCUBVCVKVBCDAUCUDCDAUESV
      BCBHVCBCEUFUGUHDABGCDETUIDVEUJSVDVEDUKZNVFDNVDFVEVLVDFUMZVEHVMDNZVIVMPBHZ
      JZVMVLHZVMABGCDETVPVNVQVNVOULVMDFUNUOUPUQURVEDUSUTVA $.
  $}

  $( Value of the quotient topology function.  (Contributed by Mario Carneiro,
     9-Apr-2015.) $)
  elqtop3 $p |- ( ( J e. ( TopOn ` X ) /\ F : X -onto-> Y ) ->
    ( A e. ( J qTop F ) <-> ( A C_ Y /\ ( `' F " A ) e. J ) ) ) $=
    ( ctopon cfv wcel wfo cuni wss cqtop co ccnv cima wa wceq toponuni eqimss
    wb syl adantr eqid elqtop mpd3an3 ) CDFGZHZDEBIZDCJZKZACBLMHAEKBNAOCHPTUGUJ
    UHUGDUIQUJDCRDUISUAUBABCUFUIEDUIUCUDUE $.

  $( The base set of the quotient topology.  (Contributed by Mario Carneiro,
     22-Aug-2015.) $)
  qtoptopon $p |- ( ( J e. ( TopOn ` X ) /\ F : X -onto-> Y ) ->
    ( J qTop F ) e. ( TopOn ` Y ) ) $=
    ( ctopon cfv wcel wfo wa cqtop co ctop cuni wceq wfn wb toponuni syl syldan
    sylan foeq2 biimpa fofn topontop eqid qtoptop qtopuni istopon sylanbrc ) BC
    EFGZCDAHZIZBAJKZLGZDUMMNZUMDEFGUJUKABMZOZUNULUPDAHZUQUJUKURUJCUPNUKURPCBQCU
    PDAUARUBZUPDAUCRUJBLGZUQUNCBUDZABUPUPUEZUFTSUJUKURUOUSUJUTURUOVAABUPDVBUGTS
    DUMUHUI $.

  ${
    $d w x y z F $.  $d w x y z J $.  $d w x y z X $.  $d w x y z Y $.
    $( A quotient map is a continuous function into its quotient topology.
       (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    qtopid $p |- ( ( J e. ( TopOn ` X ) /\ F Fn X ) ->
        F e. ( J Cn ( J qTop F ) ) ) $=
      ( vx ctopon cfv wcel wfn wa cqtop co ccn crn wf ccnv cv cima wral syldan
      wb wfo simpr dffn4 sylib fof syl wss elqtop3 simplbda ralrimiva qtoptopon
      iscn mpbir2and ) BCEFGZACHZIZABBAJKZLKGZCAMZANZAODPZQBGZDUQRZUPCUSAUAZUTU
      PUOVDUNUOUBCAUCUDZCUSAUEUFUPVBDUQUPVAUQGZVAUSUGZVBUNUOVDVFVGVBITVEVAABCUS
      UHSUIUJUNUOUQUSEFGZURUTVCITUNUOVDVHVEABCUSUKSDABUQCUSULSUM $.

    $( The quotient topology induced by the identity function is the original
       topology.  (Contributed by Mario Carneiro, 30-Aug-2015.) $)
    idqtop $p |- ( J e. ( TopOn ` X ) -> ( J qTop ( _I |` X ) ) = J ) $=
      ( vx ctopon cfv wcel cid cres cqtop co cv ccnv cima cnvresid imaeq1i wceq
      wss wa resiima adantl syl5eq eleq1d pm5.32da wf1o f1oi f1ofo mp1i elqtop3
      wfo wb mpdan toponss ex pm4.71rd 3bitr4d eqrdv ) ABDEFZCAGBHZIJZAUQCKZBQZ
      URLZUTMZAFZRZVAUTAFZRUTUSFZVFUQVAVDVFUQVARZVCUTAVHVCURUTMZUTVBURUTBNOVAVI
      UTPUQBUTSTUAUBUCUQBBURUIZVGVEUJBBURUDVJUQBUEBBURUFUGUTURABBUHUKUQVFVAUQVF
      VAUTABULUMUNUOUP $.

    qtopcmp.1 $e |- X = U. J $.
    ${
      qtopcmplem.1 $e |- ( J e. A -> J e. Top ) $.
      qtopcmplem.2 $e |- ( ( J e. A /\ F : X -onto-> U. ( J qTop F ) /\
         F e. ( J Cn ( J qTop F ) ) ) -> ( J qTop F ) e. A ) $.
      $( Lemma for ~ qtopcmp and ~ qtopcon .  (Contributed by Mario Carneiro,
         24-Mar-2015.) $)
      qtopcmplem $p |- ( ( J e. A /\ F Fn X ) -> ( J qTop F ) e. A ) $=
        ( wcel wfn wa cqtop co cuni wfo ccn simpl crn simpr sylib sylan wceq wb
        dffn4 ctop qtopuni sylan2b foeq3 syl ctopon cfv toptopon qtopid syl3anc
        mpbid ) CAHZBDIZJZUODCBKLZMZBNZBCUROLHZURAHUOUPPUQDBQZBNZUTUQUPVCUOUPRD
        BUCZSUQVBUSUAZVCUTUBUPUOVCVEVDUOCUDHZVCVEFBCDVBEUETUFVBUSDBUGUHUNUOCDUI
        UJHZUPVAUOVFVGFCDEUKSBCDULTGUM $.
    $}

    $( A quotient of a compact space is compact.  (Contributed by Mario
       Carneiro, 24-Mar-2015.) $)
    qtopcmp $p |- ( ( J e. Comp /\ F Fn X ) -> ( J qTop F ) e. Comp ) $=
      ( ccmp cmptop cqtop co cuni eqid cncmp qtopcmplem ) EABCDBFABBAGHZCMIZNJK
      L $.

    $( A quotient of a connected space is connected.  (Contributed by Mario
       Carneiro, 24-Mar-2015.) $)
    qtopcon $p |- ( ( J e. Con /\ F Fn X ) -> ( J qTop F ) e. Con ) $=
      ( ccon contop cqtop co cuni eqid cnconn qtopcmplem ) EABCDBFABBAGHZCMIZNJ
      KL $.

    $( A quotient of a compactly generated space is compactly generated.
       (Contributed by Mario Carneiro, 9-Apr-2015.) $)
    qtopkgen $p |- ( ( J e. ran kGen /\ F Fn X ) ->
      ( J qTop F ) e. ran kGen ) $=
      ( vx ckgen crn wcel wa co ctop cfv wss cuni wceq syl sseqtr4d syl2anc ccn
      sylib cqtop kgentop qtoptop sylan cv ccnv cima elssuni adantl adantr eqid
      wfn kgenuni wfo simpll simplr dffn4 qtopuni ctopon qtopid kgencn3 eleqtrd
      toptopon cnima sylancom wb elqtop2 mpbir2and ex ssrdv iskgen2 sylanbrc )
      BFGZHZACULZIZBAUAJZKHZVQFLZVQMVQVMHVNBKHZVOVRBUBZABCDUCUDZVPEVSVQVPEUEZVS
      HZWCVQHZVPWDIZWEWCAGZMZAUFWCUGBHZWFWCVQNZWGWFWCVSNZWJWDWCWKMVPWCVSUHUIWFV
      RWJWKOVPVRWDWBUJZVQWJWJUKUMPQWFVTCWGAUNZWGWJOWFVNVTVNVOWDUOZWAPZWFVOWMVNV
      OWDUPZCAUQTZABCWGDURRQVPWDABVSSJZHWIWFABVQSJZWRWFBCUSLHZVOAWSHWFVTWTWOBCD
      VCTWPABCUTRWFVNVRWSWROWNWLBVQVARVBWCABVSVDVEWFVNWMWEWHWIIVFWNWQWCABVMCWGD
      VGRVHVIVJVQVKVL $.

    $( An injection maps bases to bases.  (Contributed by Mario Carneiro,
       27-Aug-2015.) $)
    basqtop $p |- ( ( J e. TopBases /\ F : X -1-1-onto-> Y ) ->
      ( J qTop F ) e. TopBases ) $=
      ( vx vy vw ctb wcel wa cv cin wss cima wb elqtop2 wceq syl2anc syl vz cpw
      wf1o cqtop co cuni wral ccnv wfo f1ofo anbi12d sylan2 w3a simpl1l simpl2r
      cfv wrex simpl3r wfn simpl1r f1ocnv f1ofn 3syl simpl2l inss1 simpr sseldi
      fnfvima syl3anc simpl3l inss2 elin sylanbrc basis2 syl22anc adantr simp2l
      syl5ss sselda f1ocnvfv2 simprrr cdm cnvimass f1odm syl5sseq sstrd simprrl
      syl6ss eqeltrrd crn imassrn forn wf1 f1of1 f1imacnv simprl mpbir2and wfun
      fnfun inpreima sseqtr4d funimass3 mpbird vex inex1 elpw2 sylibr rexlimddv
      eqeltrd elunii ex ssrdv 3expib sylbid ralrimivv cvv ovex isbasisg ax-mp )
      BIJZCDAUCZKZFLZGLZMZBAUDUEZYEUBZMZUFZNZGYFUGFYFUGZYFIJZYBYJFGYFYFYBYCYFJZ
      YDYFJZKZYCDNZAUHZYCOZBJZKZYDDNZYQYDOZBJZKZKZYJYAXTCDAUIZYOUUEPCDAUJZXTUUF
      KYMYTYNUUDYCABICDEQYDABICDEQUKULYBYTUUDYJYBYTUUDUMZUAYEYIUUHUALZYEJZUUIYI
      JZUUHUUJKZUUIYQUPZHLZJZUUNYRUUBMZNZKZUUKHBUULXTYSUUCUUMUUPJZUURHBUQXTYAYT
      UUDUUJUNZYPYSYBUUDUUJUOUUAUUCYBYTUUJURUULUUMYRJZUUMUUBJZUUSUULYQDUSZYPUUI
      YCJUVAUULYADCYQUCUVCXTYAYTUUDUUJUTZCDAVADCYQVBVCZYPYSYBUUDUUJVDUULYEYCUUI
      YCYDVEZUUHUUJVFZVGDYCYQUUIVHVIUULUVCUUAUUIYDJUVBUVEUUAUUCYBYTUUJVJUULYEYD
      UUIYCYDVKUVGVGDYDYQUUIVHVIUUMYRUUBVLVMHUUMBYRUUBVNVOUULUUNBJZUURKZKZUUIAU
      UNOZJUVKYHJZUUKUVJUUMAUPZUUIUVKUVJYAUUIDJZUVMUUIRUULYAUVIUVDVPZUULUVNUVIU
      UHYEDUUIUUHYEYCDUVFYBYPYSUUDVQVRVSVPCDUUIAVTSUVJACUSZUUNCNZUUOUVMUVKJUVJY
      AUVPUVOCDAVBTZUVJUUNYRCUVJUUNUUPYRUULUVHUUOUUQWAZYRUUBVEWHZUVJAWBZYRCAYCW
      CZUVJYAUWACRUVOCDAWDTWEWFZUULUVHUUOUUQWGCUUNAUUMVHVIWIUVJUVKYFJZUVKYGJZUV
      LUVJUWDUVKDNZYQUVKOZBJZUVJAWJZUVKDAUUNWKUVJUUFUWIDRUVJYAUUFUVOUUGTZCDAWLT
      WEUVJUWGUUNBUVJCDAWMZUVQUWGUUNRUVJYAUWKUVOCDAWNTUWCCDUUNAWOSUULUVHUURWPXI
      UVJXTUUFUWDUWFUWHKPUULXTUVIUUTVPUWJUVKABICDEQSWQUVJUVKYENZUWEUVJUWLUUNYQY
      EOZNZUVJUUNUUPUWMUVSUVJUVPAWRZUWMUUPRUVRCAWSZYCYDAWTVCXAUVJUWOUUNUWANUWLU
      WNPUVJUVPUWOUVRUWPTUVJUUNYRUWAUVTUWBWHUUNYEAXBSXCUVKYEYCYDFXDXEXFXGUVKYFY
      GVLVMUUIUVKYHXJSXHXKXLXMXNXOYFXPJYLYKPBAUDXQFGYFXPXRXSXG $.

    $( An injection maps generated topologies to each other.  (Contributed by
       Mario Carneiro, 27-Aug-2015.) $)
    tgqtop $p |- ( ( J e. TopBases /\ F : X -1-1-onto-> Y ) ->
      ( ( topGen ` J ) qTop F ) = ( topGen ` ( J qTop F ) ) ) $=
      ( vx vy vz vw ctb wcel wa cfv cv wss cima cuni wb syl syl2anc wf1o ctg co
      cqtop ccnv cpw cin wral wfun cdm f1ocnv ad2antlr simpr crn df-rn wfo wceq
      f1ofun f1ofo syl5eqr sseqtr4d funimass4 dfss3 inss1 simprl sseldi elqtop2
      forn wrex sylan2 ad3antrrr mpbid simprd inss2 elpwid imass2 elin sylanbrc
      elpwg mpbird wfn simp-4r f1ofn ad2antrr sstrd simprr fnfvima eleq2 rspcev
      syl3anc rexlimdvaa funimass2 wf1 f1of1 elssuni syl6sseqr f1imacnv eqeltrd
      mpbir2and vex elpw2 sylibr sselda adantr f1ocnvfv2 adantl eqeltrrd impbid
      eluni2 3bitr4g ralbidva syl5bb bitr4d eltg cvv ovex mp1i 3bitr4d pm5.32da
      ctopon tgtopon fveq2i elqtop3 unitg ax-mp simpl elpw syl6bi ssrdv sspwuni
      syl6eleqr sylib syl5eqss sseld elpwi syl6 pm4.71rd eqrdv ) BJKZCDAUAZLZFB
      UBMZAUDUCZBAUDUCZUBMZUUAFNZDOZAUEZUUFPZUUBKZLZUUGUUFUUEKZLUUFUUCKZUULUUAU
      UGUUJUULUUAUUGLZUUIBUUIUFZUGZQZOZUUFUUDUUFUFZUGZQZOZUUJUULUUNUURGNZUUHMZU
      UQKZGUUFUHZUVBUUNUUHUIZUUFUUHUJZOUURUVFRYTUVGYSUUGYTDCUUHUAZUVGCDAUKZDCUU
      HURSULUUNUUFDUVHUUAUUGUMZUUNUVHAUNZDAUOUUNCDAUPZUVLDUQYTUVMYSUUGCDAUSZULC
      DAVHSUTVAGUUFUUQUUHVBTUVBUVCUVAKZGUUFUHUUNUVFGUUFUVAVCUUNUVOUVEGUUFUUNUVC
      UUFKZLZUVCHNZKZHUUTVIZUVDINZKZIUUPVIZUVOUVEUVQUVTUWCUVQUVSUWCHUUTUVQUVRUU
      TKZUVSLZLZUUHUVRPZUUPKZUVDUWGKZUWCUWFUWGBKZUWGUUOKZUWHUWFUVRDOZUWJUWFUVRU
      UDKZUWLUWJLZUWFUUTUUDUVRUUDUUSVDUVQUWDUVSVEZVFUUAUWMUWNRZUUGUVPUWEYTYSUVM
      UWPUVNUVRABJCDEVGVJVKVLVMZUWFUWKUWGUUIOZUWFUVRUUFOUWRUWFUVRUUFUWFUUTUUSUV
      RUUDUUSVNUWOVFVOZUVRUUFUUHVPSUWFUWJUWKUWRRUWQUWGUUIBVSSVTUWGBUUOVQVRUWFUU
      HDWAZUWLUVSUWIUWFUVIUWTUWFYTUVIYSYTUUGUVPUWEWBUVJSDCUUHWCSUWFUVRUUFDUWSUU
      NUUGUVPUWEUVKWDWEUVQUWDUVSWFDUVRUUHUVCWGWJUWBUWIIUWGUUPUWAUWGUVDWHWITWKUV
      QUWBUVTIUUPUVQUWAUUPKZUWBLZLZAUWAPZUUTKZUVCUXDKZUVTUXCUXDUUDKZUXDUUSKZUXE
      UXCUXGUXDDOZUUHUXDPZBKZUXCUXDUUFDUXCAUIZUWAUUIOUXDUUFOZUXCYTUXLYSYTUUGUVP
      UXBWBZCDAURSUXCUWAUUIUXCUUPUUOUWABUUOVNUVQUXAUWBVEZVFVOUWAUUFAWLTZUUNUUGU
      VPUXBUVKWDWEUXCUXJUWABUXCCDAWMZUWACOZUXJUWAUQUXCYTUXQUXNCDAWNSUXCUWABKZUX
      RUXCUUPBUWABUUOVDUXOVFZUXSUWABQZCUWABWOEWPSZCDUWAAWQTUXTWRUUAUXGUXIUXKLRZ
      UUGUVPUXBYTYSUVMUYCUVNUXDABJCDEVGVJVKWSUXCUXMUXHUXPUXDUUFFWTZXAXBUXDUUDUU
      SVQVRUXCUVDAMZUVCUXDUXCYTUVCDKZUYEUVCUQUXNUVQUYFUXBUUNUUFDUVCUVKXCXDCDUVC
      AXETUXCACWAZUXRUWBUYEUXDKUUAUYGUUGUVPUXBYTUYGYSCDAWCXFVKUYBUVQUXAUWBWFCUW
      AAUVDWGWJXGUVSUXFHUXDUUTUVRUXDUVCWHWITWKXHHUVCUUTXIIUVDUUPXIXJXKXLXMYSUUJ
      UURRYTUUGUUIBJXNWDUUDXOKZUULUVBRUUNBAUDXPZUUFUUDXOXNXQXRXSUUAUUBCXTMZKUVM
      UUMUUKRUUAUUBUYAXTMZUYJYSUUBUYKKYTBYAXDCUYAXTEYBYKYTUVMYSUVNXFUUFAUUBCDYC
      TUUAUULUUGUUAUULUUFDUFZKZUUGUUAUUEUYLUUFUUAUUEQZDOUUEUYLOUUAUYNUUDQZDUYHU
      YNUYOUQUYIUUDXOYDYEUUAUUDUYLOUYODOUUAFUUDUYLUUAUUFUUDKZUUGUUIBKZLZUYMYTYS
      UVMUYPUYRRUVNUUFABJCDEVGVJUYRUUGUYMUUGUYQYFUUFDUYDYGXBYHYIUUDDYJYLYMUUEDY
      JXBYNUUFDYOYPYQXRYR $.
  $}

  $( The property of being a closed set in the quotient topology.  (Contributed
     by Mario Carneiro, 24-Mar-2015.) $)
  qtopcld $p |- ( ( J e. ( TopOn ` X ) /\ F : X -onto-> Y ) ->
    ( A e. ( Clsd ` ( J qTop F ) ) <->
      ( A C_ Y /\ ( `' F " A ) e. ( Clsd ` J ) ) ) ) $=
    ( ctopon cfv wcel wa ccld cuni wss cdif ccnv cima ctop wb wceq syl ad2antlr
    wfo cqtop qtoptopon topontop eqid iscld 3syl toponuni sseq2d difeq1d eleq1d
    co anbi12d elqtop3 adantr difss biantrur wfun fofun funcnvcnv imadif wf fof
    fimacnv ad2antrr cdm cnvimass wfn fofn fndm syl5sseq sseqtrd iscld2 syl2anc
    eqtrd bitr4d syl5bbr bitrd pm5.32da 3bitr2d ) CDFGHZDEBUAZIZACBUBULZJGHZAWD
    KZLZWFAMZWDHZIZAELZEAMZWDHZIWKBNZAOZCJGHZIWCWDEFGHZWDPHWEWJQBCDEUCZEWDUDAWD
    WFWFUEUFUGWCWKWGWMWIWCEWFAWCWQEWFRWREWDUHSZUIWCWLWHWDWCEWFAWSUJUKUMWCWKWMWP
    WCWKIZWMWLELZWNWLOZCHZIZWPWCWMXDQWKWLBCDEUNUOXDXCWTWPXAXCEAUPUQWTXCCKZWOMZC
    HZWPWTXBXFCWTXBWNEOZWOMZXFWTBURZWNNURXBXIRWBXJWAWKDEBUSTBUTEAWNVAUGWTXHXEWO
    WTXHDXEWBXHDRZWAWKWBDEBVBXKDEBVCDEBVDSTWADXERWBWKDCUHVEZVOUJVOUKWTCPHZWOXEL
    WPXGQWAXMWBWKDCUDVEWTWODXEWTBVFZWODBAVGWBXNDRZWAWKWBBDVHXODEBVIDBVJSTVKXLVL
    WOCXEXEUEVMVNVPVQVRVSVT $.

  ${
    $d f g w x y F $.  $d f g x J $.  $d f g w x K $.  $d w x y X $.  $d x Z $.
    $d f g w x y G $.  $d f g x y ph $.  $d f w x Y $.
    $( Universal property of a quotient map.  (Contributed by Mario Carneiro,
       23-Mar-2015.) $)
    qtopcn $p |- ( ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Z ) ) /\
      ( F : X -onto-> Y /\ G : Y --> Z ) ) ->
      ( G e. ( ( J qTop F ) Cn K ) <-> ( G o. F ) e. ( J Cn K ) ) ) $=
      ( vx ctopon cfv wcel wa wf ccnv cima co wral wb syl2anc biantrurd cv ccom
      wfo ccn wss simplll simplrl elqtop3 cdm cnvimass simplrr fdm syl syl5sseq
      cqtop bitr4d cnvco imaeq1i imaco eqtri eleq1i syl6bbr ralbidva simprr fof
      wceq ad2antrl fco 3bitr3d qtoptopon ad2ant2r simplr iscn adantr 3bitr4d )
      CEIJKZDGIJKZLZEFAUCZFGBMZLZLZVTBNZHUAZOZCAUOPZKZHDQZLZEGBAUBZMZWJNZWDOZCK
      ZHDQZLZBWFDUDPKZWJCDUDPKZWBWHWOWIWPWBWGWNHDWBWDDKZLZWGANZWEOZCKZWNWTWGWEF
      UEZXCLZXCWTVPVSWGXERVPVQWAWSUFVRVSVTWSUGWEACEFUHSWTXDXCWTBUIZWEFBWDUJWTVT
      XFFVFVRVSVTWSUKFGBULUMUNTUPWMXBCWMXAWCUBZWDOXBWLXGWDBAUQURXAWCWDUSUTVAVBV
      CWBVTWHVRVSVTVDZTWBWKWOWBVTEFAMZWKXHVSXIVRVTEFAVEVGEFGBAVHSTVIWBWFFIJKZVQ
      WQWIRVPVSXJVQVTACEFVJVKVPVQWAVLHBWFDFGVMSVRWRWPRWAHWJCDEGVMVNVO $.

    $( A surjective continuous function from ` J ` to ` K ` induces a topology
       ` J qTop F ` on the base set of ` K ` .  This topology is in general
       finer than ` K ` .  Together with ~ qtopid , this implies that
       ` J qTop F ` is the finest topology making ` F ` continuous, i.e. the
       final topology with respect to the family ` { F } ` .  (Contributed by
       Mario Carneiro, 24-Mar-2015.) $)
    qtopss $p |- ( ( F e. ( J Cn K ) /\ K e. ( TopOn ` Y ) /\ ran F = Y ) ->
        K C_ ( J qTop F ) ) $=
      ( vx ccn co wcel ctopon cfv crn wceq w3a cqtop cv wa wss ccnv cima syl wb
      3ad2antl2 cnima 3ad2antl1 cuni wfo ctop simpl1 cntop1 eqid toptopon sylib
      toponss wfn simpl2 cnf2 syl3anc ffn simpl3 df-fo sylanbrc elqtop3 syl2anc
      wf mpbir2and ex ssrdv ) ABCFGHZCDIJHZAKDLZMZECBANGZVKEOZCHZVMVLHZVKVNPZVO
      VMDQZARVMSBHZVIVHVNVQVJVMCDUMUBVHVIVNVRVJVMABCUCUDVPBBUEZIJHZVSDAUFZVOVQV
      RPUAVPBUGHZVTVPVHWBVHVIVJVNUHZABCUITBVSVSUJUKULZVPAVSUNZVJWAVPVSDAVDZWEVP
      VTVIVHWFWDVHVIVJVNUOWCABCVSDUPUQVSDAURTVHVIVJVNUSVSDAUTVAVMABVSDVBVCVEVFV
      G $.

    qtopeu.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    qtopeu.3 $e |- ( ph -> F : X -onto-> Y ) $.
    qtopeu.4 $e |- ( ph -> G e. ( J Cn K ) ) $.
    qtopeu.5 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ ( F ` x ) = ( F ` y ) ) )
      -> ( G ` x ) = ( G ` y ) ) $.
    $( Universal property of the quotient topology.  If ` G ` is a function
       from ` J ` to ` K ` which is equal on all equivalent elements under
       ` F ` , then there is a unique continuous map ` f : ( J / F ) --> K `
       such that ` G = f o. F ` , and we say that ` G ` "passes to the
       quotient".  (Contributed by Mario Carneiro, 24-Mar-2015.) $)
    qtopeu $p |- ( ph -> E! f e. ( ( J qTop F ) Cn K ) G = ( f o. F ) ) $=
      ( vw wceq wa wcel cfv syl vg cv ccom cqtop co ccn wrex wral wreu ccnv csn
      wi cima cuni cmpt wfn wb wfo fofn adantr fniniseg w3a eqcom 3anbi3i bitri
      3anass sylan2br eqcomd expr sylbid ralrimiv wss wf ctopon cntop2 toptopon
      ctop eqid sylib cnf2 syl3anc ffn cdm cnvimass fof syl5sseq ralima syl2anc
      fdm eqeq1 mpbird c0 wne cin eleq2d biimpar simpr mpbir2and inelcm imadisj
      eqidd necon3bii sylibr eqsn unieqd fvex unisn syl6req mpteq2dva ffvelrnda
      feqmptd sneq imaeq2d fmptco 3eqtr4d eqeltrrd ralrimiva eqcoms cbvfo mpbid
      eleq1d qtopcn syl22anc coeq1 eqeq2d rspcev qtoptopon simprl simprr cocan2
      fmpt eqtr2 syl5ib ralrimivva reu4 sylanbrc ) AFDUBZEUCZPZDGEUDUEZHUFUEZUG
      ZYSFUAUBZEUCZPZQZYQUUCPZULZUAUUAUHDUUAUHYSDUUAUIAOJFEUJZOUBZUKZUMZUMZUNZU
      OZUUARZFUUOEUCZPZUUBAUUPUUQGHUFUEZRZAFUUQUUSABIBUBZFSZUOBIFUUIUVAESZUKZUM
      ZUMZUNZUOFUUQABIUVBUVGAUVAIRZQZUVGUVBUKZUNUVBUVIUVFUVJUVIUVFUVJPZUUJUVBPZ
      OUVFUHZUVIUVMCUBZFSZUVBPZCUVEUHZUVIUVPCUVEUVIUVNUVERZUVNIRZUVNESZUVCPZQZU
      VPUVIEIUPZUVRUWBUQAUWCUVHAIJEURZUWCLIJEUSTUTZIUVCUVNEVATAUVHUWBUVPAUVHUWB
      QZQUVBUVOUWFAUVHUVSUVCUVTPZVBZUVBUVOPUWHUVHUVSUWAVBUWFUWGUWAUVHUVSUVCUVTV
      CVDUVHUVSUWAVFVENVGVHVIVJVKUVIFIUPZUVEIVLUVMUVQUQAUWIUVHAIHUNZFVMZUWIAGIV
      NSRZHUWJVNSRZFUUSRZUWKKAHVQRZUWMAUWNUWOMFGHVOTHUWJUWJVRVPVSZMFGHIUWJVTWAZ
      IUWJFWBTUTUVIEWCZUVEIEUVDWDAUWRIPZUVHAIJEVMZUWSAUWDUWTLIJEWETZIJEWITUTWFU
      VLUVPOCIUVEFUUJUVOUVBWJWGWHWKUVIUVFWLWMZUVKUVMUQUVIFWCZUVEWNZWLWMZUXBUVIU
      VAUXCRZUVAUVERZUXEAUXFUVHAUXCIUVAAUWKUXCIPUWQIUWJFWITWOWPUVIUXGUVHUVCUVCP
      ZAUVHWQUVIUVCXAUVIUWCUXGUVHUXHQUQUWEIUVCUVAEVATWRUVAUXCUVEWSWHUVFWLUXDWLF
      UVEWTXBXCOUVFUVBXDTWKXEUVBUVAFXFXGXHZXIABIUWJFUWQXKABOIJUVCUUNUVGEUUOAIJU
      VAEUXAXJABIJEUXAXKAUUOXAUUJUVCPZUUMUVFUXJUULUVEFUXJUUKUVDUUIUUJUVCXLXMXMX
      EZXNXOZMXPAUWLUWMUWDJUWJUUOVMZUUPUUTUQKUWPLAUUNUWJRZOJUHZUXMAUVGUWJRZBIUH
      ZUXOAUXPBIUVIUVBUVGUWJUXIAIUWJUVAFUWQXJXPXQAUWDUXQUXOUQLUXPUXNBOIJEUVCUUJ
      PUVGUUNUWJUVGUUNPUUJUVCUXJUUNUVGUXKVHXRYAXSTXTOJUWJUUNUUOUUOVRYKVSEUUOGHI
      JUWJYBYCWKUXLYSUURDUUOUUAYQUUOPYRUUQFYQUUOEYDYEYFWHAUUHDUAUUAUUAUUFYRUUDP
      ZAYQUUARZUUCUUARZQZQZUUGFYRUUDYLUYBUWDYQJUPZUUCJUPZUXRUUGUQAUWDUYALUTUYBJ
      UWJYQVMZUYCUYBYTJVNSRZUWMUXSUYEAUYFUYAAUWLUWDUYFKLEGIJYGWHUTZAUWMUYAUWPUT
      ZAUXSUXTYHYQYTHJUWJVTWAJUWJYQWBTUYBJUWJUUCVMZUYDUYBUYFUWMUXTUYIUYGUYHAUXS
      UXTYIUUCYTHJUWJVTWAJUWJUUCWBTIJEYQUUCYJWAYMYNYSUUEDUAUUAUUGYRUUDFYQUUCEYD
      YEYOYP $.
  $}

  ${
    $d x A $.  $d x F $.  $d x J $.  $d x ph $.  $d x U $.
    qtoprest.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    qtoprest.3 $e |- ( ph -> F : X -onto-> Y ) $.
    qtoprest.4 $e |- ( ph -> U C_ Y ) $.
    qtoprest.5 $e |- ( ph -> A = ( `' F " U ) ) $.
    qtoprest.6 $e |- ( ph -> ( A e. J \/ A e. ( Clsd ` J ) ) ) $.
    $( If ` A ` is a saturated open or closed set (where saturated means that
       ` A = ( ``' F " U ) ` for some ` U ` ), then the restriction of the
       quotient map ` F ` to ` A ` is a quotient map.  (Contributed by Mario
       Carneiro, 24-Mar-2015.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    qtoprest $p |- ( ph -> ( ( J qTop F ) |`t U ) =
      ( ( J |`t A ) qTop ( F |` A ) ) ) $=
      ( wcel cfv wceq wss syl syl2anc wa ad2antrr vx cqtop co crest cres ctopon
      ccn crn cuni wfn wfo fofn qtopid ccnv cima cnvimass fndm syl5sseq eqsstrd
      toponuni sseqtrd eqid cnrest wb qtoptopon df-ima imaeq2d foimacnv syl5eqr
      cdm eqtrd eqimss cnrest2 syl3anc mpbid resttopon qtopss cv fnfun sseqtr4d
      fores foeq3 elqtop3 cin cnvresima imass2 adantl adantr df-ss sylib syl5eq
      wfun eleq1d ccld simplrl ctop cvv topontop toponmax fornex ssexd restopn2
      sylc sstrd sylan simprbda adantrl mpbir2and elrestr eqeltrrd cdif difeq1d
      an32s ssdifssd funcnvcnv imadif 3syl eqtr4d simpr simplrr opncld restcldr
      eqeltrd qtopcld difssd restcldi isopn2 mpbird mpjaodan expr expimpd ssrdv
      wo sylbid eqssd ) AEDUBUCZCUDUCZEBUDUCZDBUEZUBUCZAYSYRYQUGUCMZYQCUFNMZYSU
      HZCOZYQYTPAYSYRYPUGUCMZUUAADEYPUGUCMZBEUIZPUUEAEFUFNMZDFUJZUUFHAFGDUKZUUI
      IFGDULQZDEFUMRABFUUGABDUNZCUOZFKADVJZUUMFDCUPAUUIUUNFOUUKFDUQQZURUSZAUUHF
      UUGOHFEUTQVABDEYPUUGUUGVBVCRAYPGUFNMZUUCCPZCGPZUUEUUAVDAUUHUUJUUQHIDEFGVE
      RZAUUDUURAUUCDBUOZCDBVFAUVADUUMUOZCABUUMDKVGAUUJUUSUVBCOIJFGCDVHRVKZVIZUU
      CCVLQJCYSYRYPGVMVNVOAUUQUUSUUBUUTJCYPGVPRZUVDYSYRYQCVQVNAUAYTYQAUAVRZYTMZ
      UVFCPZYSUNUVFUOZYRMZSZUVFYQMZAYRBUFNMZBCYSUKZUVGUVKVDAUUHBFPUVMHUUPBEFVPR
      ZABUVAYSUKZUVNADWLZBUUNPUVPAUUIUVQUUKFDVSQZABFUUNUUPUUOVTBDWARAUVACOUVPUV
      NVDUVCUVACBYSWBQVOUVFYSYRBCWCRAUVHUVJUVLAUVHSZUVJUULUVFUOZYRMZUVLUVSUVIUV
      TYRUVSUVIUVTBWDZUVTBUVFDWEUVSUVTBPZUWBUVTOUVSUVTUUMBUVHUVTUUMPAUVFCUULWFW
      GABUUMOZUVHKWHVTUVTBWIWJWKWMAUVHUWAUVLAUVHUWASZSZBEMZUVLBEWNNZMZUWFUWGSZU
      VFCWDZUVFYQUWJUVHUWKUVFOAUVHUWAUWGWOZUVFCWIWJUWJYPWPMZCWQMZUVFYPMZUWKYQMA
      UWMUWEUWGAUUQUWMUUTGYPWRQTAUWNUWEUWGACGWQAFEMZUUJGWQMAUUHUWPHFEWSQIFGEDWT
      XCJXATUWJUWOUVFGPZUVTEMZUWJUVFCGUWLAUUSUWEUWGJTXDAUWGUWEUWRAUWGSZUWAUWRUV
      HUWSUWAUWRUWCAEWPMZUWGUWAUWRUWCSVDAUUHUWTHFEWRQBUVTEXBXEXFXGXMAUWOUWQUWRS
      VDZUWEUWGAUUHUUJUXAHIUVFDEFGWCRTXHUVFCYPWPWQXIVNXJUWFUWISZUVLYQUIZUVFXKZY
      QWNNZMZUXBCUVFXKZUXDUXEUXBCUXCUVFUXBUUBCUXCOAUUBUWEUWIUVETZCYQUTQZXLUXBCY
      PUIZPUXGYPWNNMZUXGCPUXGUXEMUXBCGUXJAUUSUWEUWIJTZUXBUUQGUXJOAUUQUWEUWIUUTT
      GYPUTQVAUXBUXKUXGGPZUULUXGUOZUWHMZUXBCGUVFUXLXNUXBUXNBUVTXKZUWHUXBUXNUUMU
      VTXKZUXPUXBUVQUULUNWLUXNUXQOAUVQUWEUWIUVRTDXOCUVFUULXPXQUXBBUUMUVTAUWDUWE
      UWIKTXLXRUXBUWIUXPYRWNNZMUXPUWHMUWFUWIXSUXBUXPYRUIZUVTXKZUXRUXBBUXSUVTUXB
      UVMBUXSOAUVMUWEUWIUVOTZBYRUTQXLUXBYRWPMZUWAUXTUXRMUXBUVMUYBUYABYRWRQAUVHU
      WAUWIXTUVTYRUXSUXSVBYARYCBUXPEYBRYCAUXKUXMUXOSVDZUWEUWIAUUHUUJUYCHIUXGDEF
      GYDRTXHUXBCUVFYECUXGYPUXJUXJVBYFVNXJUXBYQWPMZUVFUXCPUVLUXFVDUXBUUBUYDUXHC
      YQWRQUXBUVFCUXCAUVHUWAUWIWOUXIVAUVFYQUXCUXCVBYGRYHAUWGUWIYMUWELWHYIYJYNYK
      YNYLYO $.
  $}

  ${
    $d x y F $.  $d x y J $.  $d x y K $.  $d x y ph $.  $d x Y $.
    qtopomap.4 $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    qtopomap.5 $e |- ( ph -> F e. ( J Cn K ) ) $.
    qtopomap.6 $e |- ( ph -> ran F = Y ) $.
    ${
      qtopomap.7 $e |- ( ( ph /\ x e. J ) -> ( F " x ) e. K ) $.
      $( If ` F ` is a surjective continuous open map, then it is a quotient
         map.  (An open map is a function that maps open sets to open sets.)
         (Contributed by Mario Carneiro, 24-Mar-2015.) $)
      qtopomap $p |- ( ph -> K = ( J qTop F ) ) $=
        ( vy co wcel ctopon cfv wceq wss syl3anc cv cima ccn crn qtopss ccnv wa
        cqtop cuni wfo wb ctop cntop1 syl eqid toptopon sylib wfn wf cnf2 df-fo
        sylanbrc elqtop3 syl2anc foimacnv sylan adantrr simprr ralrimiva adantr
        ffn wral imaeq2 eleq1d rspcv sylc eqeltrrd ex sylbid ssrdv eqssd ) AEDC
        UFLZACDEUALMZEFNOMZCUBFPZEVTQHGICDEFUCRAKVTEAKSZVTMZWDFQZCUDWDTZDMZUEZW
        DEMZADDUGZNOMZWKFCUHZWEWIUIADUJMZWLAWAWNHCDEUKULDWKWKUMUNUOZACWKUPZWCWM
        AWKFCUQZWPAWLWBWAWQWOGHCDEWKFURRWKFCVIULIWKFCUSUTZWDCDWKFVAVBAWIWJAWIUE
        ZCWGTZWDEAWFWTWDPZWHAWMWFXAWRWKFWDCVCVDVEWSWHCBSZTZEMZBDVJZWTEMZAWFWHVF
        AXEWIAXDBDJVGVHXDXFBWGDXBWGPXCWTEXBWGCVKVLVMVNVOVPVQVRVS $.
    $}

    qtopcmap.7 $e |- ( ( ph /\ x e. ( Clsd ` J ) ) ->
      ( F " x ) e. ( Clsd ` K ) ) $.
    $( If ` F ` is a surjective continuous closed map, then it is a quotient
       map.  (A closed map is a function that maps closed sets to closed
       sets.)  (Contributed by Mario Carneiro, 24-Mar-2015.) $)
    qtopcmap $p |- ( ph -> K = ( J qTop F ) ) $=
      ( wcel cfv wceq wss cima ctop syl syl2anc cdif adantr vy cqtop ccn ctopon
      co crn qtopss syl3anc cv ccnv wa cuni wfo wb cntop1 wfn wf toptopon sylib
      eqid cnf2 ffn df-fo sylanbrc elqtop2 ccld difss foimacnv sylancl toponuni
      difeq1d eqtrd wral wfun fofun funcnvcnv imadif 4syl fimacnv simprr opncld
      eqeltrd ralrimiva imaeq2 eleq1d rspcv sylc eqeltrrd simprl sseqtrd isopn2
      topontop mpbird ex sylbid ssrdv eqssd ) AEDCUBUEZACDEUCUEKZEFUDLKZCUFFMZE
      WRNHGICDEFUGUHAUAWREAUAUIZWRKZXBFNZCUJZXBOZDKZUKZXBEKZADPKZDULZFCUMZXCXHU
      NAWSXJHCDEUOQZACXKUPZXAXLAXKFCUQZXNADXKUDLKZWTWSXOAXJXPXMDXKXKUTZURUSGHCD
      EXKFVAUHZXKFCVBQIXKFCVCVDZXBCDPXKFXQVERAXHXIAXHUKZXIEULZXBSZEVFLZKZXTCXEF
      XBSZOZOZYBYCXTYGYEYBXTXLYEFNYGYEMAXLXHXSTZFXBVGXKFYECVHVIXTFYAXBXTWTFYAMA
      WTXHGTZFEVJQZVKVLXTYFDVFLZKCBUIZOZYCKZBYKVMZYGYCKZXTYFXKXFSZYKXTYFXEFOZXF
      SZYQXTXLCVNXEUJVNYFYSMYHXKFCVOCVPFXBXEVQVRXTYRXKXFXTXOYRXKMAXOXHXRTXKFCVS
      QVKVLXTXJXGYQYKKAXJXHXMTAXDXGVTXFDXKXQWARWBAYOXHAYNBYKJWCTYNYPBYFYKYLYFMY
      MYGYCYLYFCWDWEWFWGWHXTEPKZXBYANXIYDUNXTWTYTYIFEWLQXTXBFYAAXDXGWIYJWJXBEYA
      YAUTWKRWMWNWOWPWQ $.
  $}

  ${
    $d x F $.  $d x J $.
    imastps.u $e |- ( ph -> U = ( F "s R ) ) $.
    imastps.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imastps.f $e |- ( ph -> F : V -onto-> B ) $.
    ${
      imastopn.r $e |- ( ph -> R e. W ) $.
      imastopn.j $e |- J = ( TopOpen ` R ) $.
      imastopn.o $e |- O = ( TopOpen ` U ) $.
      $( The topology of an image structure.  (Contributed by Mario Carneiro,
         27-Aug-2015.) $)
      imastopn $p |- ( ph -> O = ( J qTop F ) ) $=
        ( vx cfv ctopn wcel cvv cts cqtop co cbs cpw wss wceq ccnv cv cima cuni
        cin crab eqid imastset fvex eqeltri wfn wfo syl syl2anc qtopval sylancr
        fofn syl6eqel fnex eqtrd ssrab2 crn imassrn forn imasbas syl5sseq sspwb
        sylib syl5ss eqsstrd topnid syl6eqr eqtr3d ) ADUAQZGFEUBUCZAWADRQZGAWAD
        UDQZUEZUFWAWCUGAWAEUHPUIUJFUKZULFSZPEWFUJZUEZUMZWEAWAWBWJABCDEFWAHIJKLM
        NWAUNZUOZAFTSETSZWBWJUGFCRQTNCRUPUQAEHURZHTSWMAHBEUSZWNLHBEVDUTAHCUDQTK
        CUDUPVEHTEVFVAEFTTWFPWFUNVBVCVGAWJWIWEWGPWIVHAWHWDUFWIWEUFAEVIZWHWDEWFV
        JAWPBWDAWOWPBUGLHBEVKUTABCDEHIJKLMVLVGVMWHWDVNVOVPVQWDWADWDUNWKVRUTOVSW
        LVT $.
    $}

    imastps.r $e |- ( ph -> R e. TopSp ) $.
    $( The image of a topological space under a function is a topological
       space.  (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    imastps $p |- ( ph -> U e. TopSp ) $=
      ( ctopn cfv cbs ctopon wcel ctps cqtop eqid istps fveq2d co wfo qtoptopon
      imastopn sylib eleqtrrd syl2anc imasbas eleqtrd eqeltrd sylibr ) ADKLZDML
      ZNLZODPOAULCKLZEQUAZUNABCDEUOULFPGHIJUORZULRZUDAUPBNLZUNAUOFNLZOFBEUBUPUS
      OAUOCMLZNLZUTACPOUOVBOJVAUOCVARUQSUEAFVANHTUFIEUOFBUCUGABUMNABCDEFPGHIJUH
      TUIUJUMULDUMRURSUK $.
  $}

  ${
    $d x E $.  $d x ph $.  $d x R $.  $d x V $.
    divstps.u $e |- ( ph -> U = ( R /s E ) ) $.
    divstps.v $e |- ( ph -> V = ( Base ` R ) ) $.
    divstps.e $e |- ( ph -> E e. W ) $.
    divstps.r $e |- ( ph -> R e. TopSp ) $.
    $( A quotient structure is a topological space.  (Contributed by Mario
       Carneiro, 27-Aug-2015.) $)
    divstps $p |- ( ph -> U e. TopSp ) $=
      ( vx cqs cv cec cmpt ctps eqid divsval divslem imastps ) AEDLBCKEKMDNOZEA
      KDBCUAEFPGHUAQZIJRHAKDBCUAEFPGHUBIJSJT $.
  $}

  ${
    $d m n o w x y z A $.  $d m n w x y z B $.  $d a b j m n o u v w x y z J $.
    $d a b m n o u v w z F $.  $d w z ph $.  $d a b m n o u v w x y z X $.
    $d w z U $.  $d x V $.
    kqval.2 $e |- F = ( x e. X |-> { y e. J | x e. y } ) $.
    $( Value of the function appearing in ~ df-kq .  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    kqfval $p |- ( ( J e. V /\ A e. X ) ->
        ( F ` A ) = { y e. J | A e. y } ) $=
      ( wcel cv crab cvv cfv wceq id rabexg eleq1 rabbidv fvmptg syl2anr ) CGIZ
      UACBJZIZBEKZLICDMUDNEFIUAOUCBEFPACAJZUBIZBEKUDGLDUECNUFUCBEUECUBQRHST $.

    $( Two points in the Kolmogorov quotient are equal iff the original points
       are topologically indistinguishable.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    kqfeq $p |- ( ( J e. V /\ A e. X /\ B e. X ) ->
        ( ( F ` A ) = ( F ` B ) <-> A. y e. J ( A e. y <-> B e. y ) ) ) $=
      ( wcel w3a cfv wceq cv crab wb wral kqfval 3adant3 3adant2 eqeq12d rabbi
      syl6bbr ) FGJZCHJZDHJZKZCELZDELZMCBNZJZBFOZDUJJZBFOZMUKUMPBFQUGUHULUIUNUD
      UEUHULMUFABCEFGHIRSUDUFUIUNMUEABDEFGHIRTUAUKUMBFUBUC $.

    $( The topological indistinguishability map is a function on the base.
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqffn $p |- ( J e. V -> F Fn X ) $=
      ( wcel cpw wf wfn cv crab wss ssrab2 elpw2g mpbiri adantr fmptd ffn syl )
      DEHZFDIZCJCFKUBAFALZBLHZBDMZUCCUBUFUCHZUDFHUBUGUFDNUEBDOUFDEPQRGSFUCCTUA
      $.

    $( Value of the quotient topology function.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    kqval $p |- ( J e. ( TopOn ` X ) -> ( KQ ` J ) = ( J qTop F ) ) $=
      ( vj ctopon cfv wcel ckq cuni cv crab cmpt cqtop co ctop wceq topontop id
      unieq rabeq mpteq12dv oveq12d df-kq ovex fvmpt syl toponuni syl5eq oveq2d
      mpteq1d eqtr4d ) DEHIJZDKIZDADLZAMBMJZBDNZOZPQZDCPQUODRJUPVASEDTGDGMZAVBL
      ZURBVBNZOZPQVARKVBDSZVBDVEUTPVFUAVFAVCVDUQUSVBDUBURBVBDUCUDUEABGUFDUTPUGU
      HUIUOCUTDPUOCAEUSOUTFUOAEUQUSEDUJUMUKULUN $.

    $( The Kolmogorov quotient is a topology on the quotient set.  (Contributed
       by Mario Carneiro, 25-Aug-2015.) $)
    kqtopon $p |- ( J e. ( TopOn ` X ) ->
        ( KQ ` J ) e. ( TopOn ` ran F ) ) $=
      ( ctopon cfv wcel ckq cqtop crn kqval wfo wfn kqffn dffn4 sylib qtoptopon
      co mpdan eqeltrd ) DEGHZIZDJHDCKTZCLZGHZABCDEFMUDEUFCNZUEUGIUDCEOUHABCDUC
      EFPECQRCDEUFSUAUB $.

    $( The topological indistinguishability map is a continuous function into
       the Kolmogorov quotient.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    kqid $p |- ( J e. ( TopOn ` X ) -> F e. ( J Cn ( KQ ` J ) ) ) $=
      ( ctopon cfv wcel cqtop co ccn ckq wfn kqffn qtopid mpdan oveq2d eleqtrrd
      kqval ) DEGHZIZCDDCJKZLKZDDMHZLKUBCENCUDIABCDUAEFOCDEPQUBUEUCDLABCDEFTRS
      $.

    $( The topological indistinguishability map is injective iff the space is
       T_0.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    ist0-4 $p |- ( J e. ( TopOn ` X ) -> ( J e. Kol2 <-> F : X -1-1-> _V ) ) $=
      ( vz vw ctopon cfv wcel cv wceq wi wral wel wb cvv wf1 wa ct0 kqfeq 3expb
      imbi1d 2ralbidva wf wfn kqffn dffn2 sylib dff13 baib syl ist0-2 3bitr4rd
      ) DEIJZKZGLZCJHLZCJMZURUSMZNZHEOGEOZGBPHBPQBDOZVANZHEOGEOERCSZDUAKUQVBVEG
      HEEUQUREKZUSEKZTTUTVDVAUQVGVHUTVDQABURUSCDUPEFUBUCUDUEUQERCUFZVFVCQUQCEUG
      VIABCDUPEFUHECUIUJVFVIVCGHERCUKULUMGHBDEUNUO $.

    $( When the image set is open, the quotient map satisfies a partial
       converse to ~ fnfvima , which is normally only true for injective
       functions.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqfvima $p |- ( ( J e. ( TopOn ` X ) /\ U e. J /\ A e. X ) ->
        ( A e. U <-> ( F ` A ) e. ( F " U ) ) ) $=
      ( vz vw ctopon cfv wcel wi cv wceq wb wral eleq2 bibi12d w3a cima wfn wss
      kqffn 3ad2ant1 toponss 3adant3 fnfvima syl2anc wrex wfun fnfun fvelima ex
      3expia 3syl simpr simpl1 sselda simpl3 kqfeq syl3anc cbvralv syl6bb rspcv
      wa simpl2 syl sylbid bi1 syl6 mpid rexlimdva syld impbid ) FGKLZMZDFMZCGM
      ZUAZCDMZCELZEDUBMZWAEGUCZDGUDZWBWDNVRVSWEVTABEFVQGHUEUFZVRVSWFVTDFGUGUHZW
      EWFWBWDGDECUIUPUJWAWDIOZELWCPZIDUKZWBWAWEEULZWDWKNWGGEUMWLWDWKIWCDEUNUOUQ
      WAWJWBIDWAWIDMZVGZWJWMWBWAWMURWNWJWMWBQZWMWBNWNWJWIJOZMZCWPMZQZJFRZWOWNWJ
      WIBOZMZCXAMZQZBFRZWTWNVRWIGMVTWJXEQVRVSVTWMUSWADGWIWHUTVRVSVTWMVAABWICEFV
      QGHVBVCXDWSBJFXAWPPXBWQXCWRXAWPWISXAWPCSTVDVEWNVSWTWONVRVSVTWMVHWSWOJDFWP
      DPWQWMWRWBWPDWISWPDCSTVFVIVJWMWBVKVLVMVNVOVP $.

    $( Any open set is saturated with respect to the topological
       indistinguishability map (in the terminology of ~ qtoprest ).
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqsat $p |- ( ( J e. ( TopOn ` X ) /\ U e. J ) ->
        ( `' F " ( F " U ) ) = U ) $=
      ( vz ctopon cfv wcel wa ccnv cima cv wb wfn syl adantr wceq kqffn kqfvima
      elpreima 3expa biimprd expimpd sylbid ssrdv cdm cin toponss fndm sseqtr4d
      wss dfss1 sylib dminss syl6eqssr eqssd ) EFIJZKZCEKZLZDMDCNZNZCVCHVECVCHO
      ZVEKZVFFKZVFDJVDKZLZVFCKZVAVGVJPZVBVADFQZVLABDEUTFGUAZFVFVDDUCRSVCVHVIVKV
      CVHLVKVIVAVBVHVKVIPABVFCDEFGUBUDUEUFUGUHVCCDUIZCUJZVEVCCVOUNVPCTVCCFVOCEF
      UKVAVOFTZVBVAVMVQVNFDULRSUMCVOUOUPCDUQURUS $.

    $( A version of ~ imain for the topological indistinguishability map.
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqdisj $p |- ( ( J e. ( TopOn ` X ) /\ U e. J ) ->
        ( ( F " U ) i^i ( F " ( A \ U ) ) ) = (/) ) $=
      ( vz vw cfv wcel wa cima cdif cin wss c0 wceq wn ctopon cres cdm imadmres
      dmres wfn kqffn adantr fndm syl ineq2d syl5eq imaeq2d syl5eqr inss2 ssdif
      indif1 ax-mp eqsstri imass2 mp1i eqsstrd sslin cv eldifn adantl wb simpll
      simplr eldifi kqfvima syl3anc mtbid ralrimiva difss notbid ralima sylancl
      wral eleq1 mpbird disjr sylibr sseq0 syl2anc ) FGUAKZLZDFLZMZEDNZECDOZNZP
      ZWJEGDOZNZPZQZWPRSZWMRSWIWLWOQWQWIWLEWKGPZNZWOWIWLEEWKUBUCZNWTEWKUDWIXAWS
      EWIXAWKEUCZPWSEWKUEWIXBGWKWIEGUFZXBGSWGXCWHABEFWFGHUGUHZGEUIUJUKULUMUNWSW
      NQWTWOQWIWSCGPZDOZWNCGDUQXEGQXFWNQCGUOXEGDUPURUSWSWNEUTVAVBWLWOWJVCUJWIIV
      DZWJLZTZIWOVSZWRWIXJJVDZEKZWJLZTZJWNVSZWIXNJWNWIXKWNLZMZXKDLZXMXPXRTWIXKG
      DVEVFXQWGWHXKGLZXRXMVGWGWHXPVHWGWHXPVIXPXSWIXKGDVJVFABXKDEFGHVKVLVMVNWIXC
      WNGQXJXOVGXDGDVOXIXNIJGWNEXGXLSXHXMXGXLWJVTVPVQVRWAIWJWOWBWCWMWPWDWE $.

    $( Any closed set is saturated with respect to the topological
       indistinguishability map (in the terminology of ~ qtoprest ).
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqcldsat $p |- ( ( J e. ( TopOn ` X ) /\ U e. ( Clsd ` J ) ) ->
        ( `' F " ( F " U ) ) = U ) $=
      ( cfv wcel wa cima wb adantr cdif wn c0 cin wss wceq adantl vz ctopon wfn
      ccld ccnv cv kqffn elpreima syl wi noel elin incom cdm cuni eqid toponuni
      cldss fndm eqtrd sseqtrd dfss4 sylib imaeq2d ineq2d simpll difeq1d cldopn
      sseqtr4d eqeltrd kqdisj syl2anc eqtr3d syl5eq eleq2d syl5bbr mtbiri imnan
      sylibr eldif baibr simpr kqfvima syl3anc bitrd con1bid sylibd ssrdv dfss1
      expimpd sylbid dminss syl6eqssr eqssd ) EFUBHZIZCEUDHIZJZDUEDCKZKZCWRUAWT
      CWRUAUFZWTIZXAFIZXADHZWSIZJZXACIZWPXBXFLZWQWPDFUCZXHABDEWOFGUGZFXAWSDUHUI
      MWRXCXEXGWRXCJZXEXDDFCNZKZIZOZXGXKXEXNJZOXEXOUJXKXPXDPIZXDUKXPXDWSXMQZIXK
      XQXDWSXMULXKXRPXDXKXRXMWSQZPWSXMUMXKXMDFXLNZKZQZXSPXKYAWSXMXKXTCDXKCFRZXT
      CSWRYCXCWRCDUNZFWRCEUOZYDWQCYERWPCEYEYEUPZURTWPYDYESWQWPYDFYEWPXIYDFSZXJF
      DUSUIZFEUQZUTMVIZWPYGWQYHMVAMCFVBVCVDVEXKWPXLEIZYBPSWPWQXCVFZWRYKXCWRXLYE
      CNZEWRFYECWPFYESWQYIMVGWQYMEIWPCEYEYFVHTVJMZABFXLDEFGVKVLVMVNVOVPVQXEXNVR
      VSXKXGXNXKXGOZXAXLIZXNXCYOYPLWRYPXCYOXAFCVTWATXKWPYKXCYPXNLYLYNWRXCWBABXA
      XLDEFGWCWDWEWFWGWJWKWHWRCYDCQZWTWRCYDRYQCSYJCYDWIVCCDWLWMWN $.

    $( The topological indistinguishability map is an open map.  (Contributed
       by Mario Carneiro, 25-Aug-2015.) $)
    kqopn $p |- ( ( J e. ( TopOn ` X ) /\ U e. J ) ->
        ( F " U ) e. ( KQ ` J ) ) $=
      ( ctopon cfv wcel wa cima cqtop co ckq crn wss ccnv imassrn adantr a1i wb
      kqsat simpr eqeltrd wfo wfn kqffn dffn4 sylib syldan mpbir2and wceq kqval
      elqtop3 eleqtrrd ) EFHIZJZCEJZKZDCLZEDMNZEOIZUTVAVBJZVADPZQZDRVALZEJZVFUT
      DCSUAUTVGCEABCDEFGUCURUSUDUEURUSFVEDUFZVDVFVHKUBURVIUSURDFUGVIABDEUQFGUHF
      DUIUJTVADEFVEUOUKULURVCVBUMUSABDEFGUNTUP $.

    $( The topological indistinguishability map is a closed map.  (Contributed
       by Mario Carneiro, 25-Aug-2015.) $)
    kqcld $p |- ( ( J e. ( TopOn ` X ) /\ U e. ( Clsd ` J ) ) ->
        ( F " U ) e. ( Clsd ` ( KQ ` J ) ) ) $=
      ( ctopon cfv wcel ccld wa cima cqtop co ckq crn wss ccnv adantr a1i simpr
      imassrn kqcldsat eqeltrd wb wfo kqffn dffn4 sylib qtopcld mpdan mpbir2and
      wfn wceq kqval fveq2d eleqtrrd ) EFHIZJZCEKIZJZLZDCMZEDNOZKIZEPIZKIVCVDVF
      JZVDDQZRZDSVDMZVAJZVJVCDCUCUAVCVKCVAABCDEFGUDUTVBUBUEUTVHVJVLLUFZVBUTFVID
      UGZVMUTDFUNVNABDEUSFGUHFDUIUJVDDEFVIUKULTUMVCVGVEKUTVGVEUOVBABDEFGUPTUQUR
      $.

    $( Lemma for ~ kqt0 .  (Contributed by Mario Carneiro, 23-Mar-2015.) $)
    kqt0lem $p |- ( J e. ( TopOn ` X ) -> ( KQ ` J ) e. Kol2 ) $=
      ( vu vz vv va vb vw cfv wcel wel wb wral cv wceq wa ctopon ckq ct0 wi crn
      kqopn adantlr eleq2 bibi12d rspcv syl kqfvima 3expa adantrr adantrl an32s
      cima sylibrd ralrimdva kqfeq 3expb elequ2 cbvralv syl6bb ralrimivva kqffn
      eleq1 bibi1d ralbidv eqeq1 imbi12d ralrn bibi2d eqeq2 bitrd mpbird ist0-2
      wfn kqtopon ) DEUAMZNZDUBMZUCNZGHOZIHOZPZHWBQZGRZIRZSZUDZICUEZQZGWLQZWAWN
      JRZCMZHRZNZKRZCMZWQNZPZHWBQZWPWTSZUDZKEQZJEQZWAXEJKEEWAWOENZWSENZTZTZXCJL
      OZKLOZPZLDQZXDXKXCXNLDXKLRZDNZTZXCWPCXPUQZNZWTXSNZPZXNXRXSWBNZXCYBUDWAXQY
      CXJABXPCDEFUFUGXBYBHXSWBWQXSSWRXTXAYAWQXSWPUHWQXSWTUHUIUJUKWAXQXJXNYBPWAX
      QTZXJTXLXTXMYAYDXHXLXTPZXIWAXQXHYEABWOXPCDEFULUMUNYDXIXMYAPZXHWAXQXIYFABW
      SXPCDEFULUMUOUIUPURUSXKXDJBOZKBOZPZBDQZXOWAXHXIXDYJPABWOWSCDVTEFUTVAYIXNB
      LDBRXPSYGXLYHXMBLJVBBLKVBUIVCVDURVEWACEVRZWNXGPABCDVTEFVFYKWNWRWEPZHWBQZW
      PWISZUDZIWLQZJEQXGWMYPGJECWHWPSZWKYOIWLYQWGYMWJYNYQWFYLHWBYQWDWRWEWHWPWQV
      GVHVIWHWPWIVJVKVIVLYKYPXFJEYOXEIKECWIWTSZYMXCYNXDYRYLXBHWBYRWEXAWRWIWTWQV
      GVMVIWIWTWPVNVKVLVIVOUKVPWAWBWLUAMNWCWNPABCDEFVSGIHWBWLVQUKVP $.

    $( The property " ` J ` is an R_0 space".  A space is R_0 if any two
       topologically distinguishable points are separated (there is an open set
       containing each one and disjoint from the other).  Or in contraposition,
       if every open set which contains ` x ` also contains ` y ` , so there is
       no separation, then ` x ` and ` y ` are members of the same open sets.
       We have chosen not to give this definition a name, because it turns out
       that a space is R_0 if and only if its Kolmogorov quotient is T_1, so
       that is what we prove here.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    isr0 $p |- ( J e. ( TopOn ` X ) ->
         ( ( KQ ` J ) e. Fre <-> A. z e. X A. w e. X
   ( A. o e. J ( z e. o -> w e. o ) -> A. o e. J ( z e. o <-> w e. o ) ) ) ) $=
      ( vv vb wcel cv wi wral wb wa wceq eleq2 syl ctopon cfv ckq ct1 ccnv cima
      va ccn co kqid ad2antrr cnima sylan imbi12d rspcv wfun kqffn adantr fnfun
      cdm simprl fndm eleqtrrd fvimacnv syl2anc simprr sylibrd ralrimdva simplr
      wfn cuni fnfvelrn kqtopon toponuni eleqtrd eqid t1sep2 syl3anc syld kqfeq
      crn w3a bibi12d cbvralv syl6bbr 3expb adantlr sylibd ralrimivva ex simpll
      kqopn kqfvima 3expa an32s crab kqfval eqeq12d rabbi bitri biimprd imim12d
      adantllr ralimdva eleq1 imbi1d ralbidv eqeq1 ralrn imbi2d ist1-2 impbid
      eqeq2 bitrd ) GHUAUBZLZGUCUBZUDLZCMZEMZLZDMZXTLZNZEGOZYAYCPZEGOZNZDHOZCHO
      ZXPXRYJXPXRQZYHCDHHYKXSHLZYBHLZQZQZYEXSFUBZYBFUBZRZYGYOYEYPJMZLZYQYSLZNZJ
      XQOZYRYOYEUUBJXQYOYSXQLZQZYEXSFUEYSUFZLZYBUUFLZNZUUBUUEUUFGLZYEUUINYOFGXQ
      UHUILZUUDUUJXPUUKXRYNABFGHIUJUKYSFGXQULUMYDUUIEUUFGXTUUFRYAUUGYCUUHXTUUFX
      SSXTUUFYBSUNUOTUUEYTUUGUUAUUHUUEFUPZXSFUTZLYTUUGPUUEFHVJZUULYOUUNUUDXPUUN
      XRYNABFGXOHIUQZUKZURZHFUSTZUUEXSHUUMYOYLUUDYKYLYMVAZURUUEUUNUUMHRUUQHFVBT
      ZVCXSYSFVDVEUUEUULYBUUMLUUAUUHPUURUUEYBHUUMYOYMUUDYKYLYMVFZURUUTVCYBYSFVD
      VEUNVGVHYOXRYPXQVKZLYQUVBLUUCYRNZXPXRYNVIYOYPFWAZUVBYOUUNYLYPUVDLUUPUUSHX
      SFVLVEYOXQUVDUAUBLZUVDUVBRXPUVEXRYNABFGHIVMZUKUVDXQVNTZVOYOYQUVDUVBYOUUNY
      MYQUVDLUUPUVAHYBFVLVEUVGVOYPYQJXQUVBUVBVPVQVRVSXPYNYRYGPZXRXPYLYMUVHXPYLY
      MWBYRXSBMZLZYBUVILZPZBGOZYGABXSYBFGXOHIVTYFUVLEBGXTUVIRYAUVJYCUVKXTUVIXSS
      XTUVIYBSWCWDZWEWFWGWHWIWJXPYJUGMZYSLZKMZYSLZNZJXQOZUVOUVQRZNZKUVDOZUGUVDO
      ZXRXPYJUVCDHOZCHOZUWDXPYIUWECHXPYLQZYHUVCDHUWGYMQZUUCYEYGYRUWHUUCYDEGUWHX
      TGLZQZUUCYPFXTUFZLZYQUWKLZNZYDUWJUWKXQLZUUCUWNNUWHXPUWIUWOXPYLYMWKABXTFGH
      IWLUMUUBUWNJUWKXQYSUWKRYTUWLUUAUWMYSUWKYPSYSUWKYQSUNUOTUWJYAUWLYCUWMUWGUW
      IYAUWLPZYMXPUWIYLUWPXPUWIYLUWPABXSXTFGHIWMWNWOWGXPYMUWIYCUWMPZYLXPUWIYMUW
      QXPUWIYMUWQABYBXTFGHIWMWNWOXCUNVGVHUWHYRYGUWHYRUVJBGWPZUVKBGWPZRZYGUWHYPU
      WRYQUWSUWGYPUWRRYMABXSFGXOHIWQURXPYMYQUWSRYLABYBFGXOHIWQWGWRYGUVMUWTUVNUV
      JUVKBGWSWTWEXAXBXDXDXPUUNUWDUWFPUUOUUNUWDYTUVRNZJXQOZYPUVQRZNZKUVDOZCHOUW
      FUWCUXEUGCHFUVOYPRZUWBUXDKUVDUXFUVTUXBUWAUXCUXFUVSUXAJXQUXFUVPYTUVRUVOYPY
      SXEXFXGUVOYPUVQXHUNXGXIUUNUXEUWECHUXDUVCKDHFUVQYQRZUXBUUCUXCYRUXGUXAUUBJX
      QUXGUVRUUAYTUVQYQYSXEXJXGUVQYQYPXMUNXIXGXNTVGXPUVEXRUWDPUVFUGKJXQUVDXKTVG
      XL $.

    $( The analogue of the T_1 axiom (singletons are closed) for an R_0 space.
       In an R_0 space the set of all points topologically indistinguishable
       from ` A ` is closed.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    r0cld $p |- ( ( J e. ( TopOn ` X ) /\ ( KQ ` J ) e. Fre /\ A e. X ) ->
      { z e. X | A. o e. J ( z e. o <-> A e. o ) } e. ( Clsd ` J ) ) $=
      ( ctopon cfv wcel w3a cv wb wral crab wceq 3ad2ant1 syl2anc ckq ccnv cima
      ct1 csn ccld wfn kqffn fncnvima2 syl fvex elsnc simpl1 simpr simpl3 kqfeq
      wa eleq2 bibi12d cbvralv syl6bb syl3anc syl5bb rabbidva eqtrd ccn co kqid
      cuni simp2 crn fnfvelrn kqtopon toponuni eleqtrd t1sncld cnclima eqeltrrd
      simp3 eqid ) GHJKZLZGUAKZUDLZDHLZMZFUBDFKZUEZUCZCNZENZLZDWKLZOZEGPZCHQZGU
      FKZWFWIWJFKZWHLZCHQZWPWFFHUGZWIWTRWBWDXAWEABFGWAHIUHSZCHWHFUIUJWFWSWOCHWS
      WRWGRZWFWJHLZUQZWOWRWGWJFUKULXEWBXDWEXCWOOWBWDWEXDUMWFXDUNWBWDWEXDUOWBXDW
      EMXCWJBNZLZDXFLZOZBGPWOABWJDFGWAHIUPXIWNBEGXFWKRXGWLXHWMXFWKWJURXFWKDURUS
      UTVAVBVCVDVEWFFGWCVFVGLZWHWCUFKLZWIWQLWBWDXJWEABFGHIVHSWFWDWGWCVIZLXKWBWD
      WEVJWFWGFVKZXLWFXAWEWGXMLXBWBWDWEVSHDFVLTWFWCXMJKLZXMXLRWBWDXNWEABFGHIVMS
      XMWCVNUJVOWGWCXLXLVTVPTWHFGWCVQTVR $.

    ${
      regr1lem.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
      regr1lem.3 $e |- ( ph -> J e. Reg ) $.
      regr1lem.4 $e |- ( ph -> A e. X ) $.
      regr1lem.5 $e |- ( ph -> B e. X ) $.
      regr1lem.6 $e |- ( ph -> U e. J ) $.
      regr1lem.7 $e |- ( ph -> -. E. m e. ( KQ ` J ) E. n e. ( KQ ` J )
        ( ( F ` A ) e. m /\ ( F ` B ) e. n /\ ( m i^i n ) = (/) ) ) $.
      $( Lemma for ~ regr1 .  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
      regr1lem $p |- ( ph -> ( A e. U -> B e. U ) ) $=
        ( wcel cfv vz wa ccl wss creg wrex adantr simpr regsep syl3anc cin wceq
        cv c0 w3a ckq ad2antrr cima cdif ctopon ad3antrrr simplrl kqopn syl2anc
        cuni toponuni syl difeq1d ccld ctop topontop elssuni eqid clscld cldopn
        wn eqeltrd simprrl wb kqfvima mpbid simprrr sseld con3and eldifd sscond
        sscls imass2 sslin 3syl kqdisj sseq0 eleq2 ineq1 3anbi13d ineq2 rspc2ev
        eqeq1d 3anbi23d syl113anc ex mt3d rexlimddv ) ADFSZEFSZAXDUBZDUAUMZSZXG
        JUCTTZFUDZUBZXEUAJXFJUESZFJSZXDXKUAJUFAXLXDNUGAXMXDQUGAXDUHUADFJUIUJXFX
        GJSZXKUBZUBZXEDITZGUMZSZEITZHUMZSZXRYAUKZUNULZUOZHJUPTZUFGYFUFZAYGVPXDX
        ORUQXPXEVPZYGXPYHUBZIXGURZYFSZIKXIUSZURZYFSZXQYJSZXTYMSZYJYMUKZUNULZYGY
        IJKUTTSZXNYKAYSXDXOYHMVAZXFXNXKYHVBZBCXGIJKLVCVDYIYSYLJSZYNYTYIYLJVEZXI
        USZJYIKUUCXIYIYSKUUCULYTKJVFVGVHYIXIJVITSZUUDJSYIJVJSZXGUUCUDZUUEYIYSUU
        FYTKJVKVGZYIXNUUGUUAXGJVLVGZXGJUUCUUCVMZVNVDXIJUUCUUJVOVGVQZBCYLIJKLVCV
        DYIXHYOXPXHYHXFXNXHXJVRUGYIYSXNDKSZXHYOVSYTUUAAUULXDXOYHOVABCDXGIJKLVTU
        JWAYIEYLSZYPYIEKXIAEKSZXDXOYHPVAZXPEXISXEXPXIFEXFXNXHXJWBWCWDWEYIYSUUBU
        UNUUMYPVSYTUUKUUOBCEYLIJKLVTUJWAYIYQYJIKXGUSZURZUKZUDZUURUNULZYRYIYLUUP
        UDYMUUQUDUUSYIXGXIKYIUUFUUGXGXIUDUUHUUIXGJUUCUUJWGVDWFYLUUPIWHYMUUQYJWI
        WJYIYSXNUUTYTUUABCKXGIJKLWKVDYQUURWLVDYEYOYPYRUOYOYBYJYAUKZUNULZUOGHYJY
        MYFYFXRYJULZXSYOYDUVBYBXRYJXQWMUVCYCUVAUNXRYJYAWNWRWOYAYMULZYBYPUVBYRYO
        YAYMXTWMUVDUVAYQUNYAYMYJWPWRWSWQWTXAXBXCXA $.
    $}

    $( A Kolmogorov quotient of a regular space is Hausdorff.  (Contributed by
       Mario Carneiro, 25-Aug-2015.) $)
    regr1lem2 $p |- ( ( J e. ( TopOn ` X ) /\ J e. Reg ) ->
        ( KQ ` J ) e. Haus ) $=
      ( va vb vm vn vz vw cfv wcel cv wel wceq w3a wrex wral ctopon creg wa ckq
      cha wne cin c0 wi crn wn wb simplll simpllr simplrl simplrr simprl simprr
      3ancoma incom eqeq1i 3anbi3i bitri 2rexbii rexcom sylnib impbid ralrimdva
      regr1lem expr kqfeq elequ2 bibi12d cbvralv 3expb adantlr sylibrd necon1ad
      syl6bb ralrimivva wfn kqffn adantr neeq1 3anbi1d 2rexbidv imbi12d ralbidv
      eleq1 ralrn neeq2 3anbi2d bitrd syl mpbird kqtopon ishaus2 ) DEUAMZNZDUBN
      ZUCZDUDMZUENZGOZHOZUFZGIPZHJPZIOZJOZUGZUHQZRZJXBSIXBSZUIZHCUJZTZGXPTZXAXR
      KOZCMZLOZCMZUFZXTXINZYBXJNZXLRZJXBSIXBSZUIZLETZKETZXAYHKLEEXAXSENZYAENZUC
      ZUCZYGXTYBYNYGUKZKGPZLGPZULZGDTZXTYBQZYNYOYRGDYNXDDNZYOYRYNUUAYOUCZUCZYPY
      QUUCABXSYAXDIJCDEFWSWTYMUUBUMZWSWTYMUUBUNZXAYKYLUUBUOZXAYKYLUUBUPZYNUUAYO
      UQZYNUUAYOURZVIUUCABYAXSXDJICDEFUUDUUEUUGUUFUUHUUCYGYEYDXJXIUGZUHQZRZIXBS
      JXBSZUUIYGUULJXBSIXBSUUMYFUULIJXBXBYFYEYDXLRUULYDYEXLUSXLUUKYEYDXKUUJUHXI
      XJUTVAVBVCVDUULIJXBXBVEVCVFVIVGVJVHWSYMYTYSULZWTWSYKYLUUNWSYKYLRYTKBPZLBP
      ZULZBDTYSABXSYACDWREFVKUUQYRBGDBOXDQUUOYPUUPYQBGKVLBGLVLVMVNVSVOVPVQVRVTX
      ACEWAZXRYJULWSUURWTABCDWREFWBWCUURXRXTXEUFZYDXHXLRZJXBSIXBSZUIZHXPTZKETYJ
      XQUVCGKECXDXTQZXOUVBHXPUVDXFUUSXNUVAXDXTXEWDUVDXMUUTIJXBXBUVDXGYDXHXLXDXT
      XIWIWEWFWGWHWJUURUVCYIKEUVBYHHLECXEYBQZUUSYCUVAYGXEYBXTWKUVEUUTYFIJXBXBUV
      EXHYEYDXLXEYBXJWIWLWFWGWJWHWMWNWOXAXBXPUAMNZXCXRULWSUVFWTABCDEFWPWCGHJIXB
      XPWQWNWO $.

    $( A Kolmogorov quotient of a regular space is regular.  (Contributed by
       Mario Carneiro, 25-Aug-2015.) $)
    kqreglem1 $p |- ( ( J e. ( TopOn ` X ) /\ J e. Reg ) ->
        ( KQ ` J ) e. Reg ) $=
      ( vb vm va vz vw cfv wcel wa cv wss wrex adantr syl syl2anc creg ckq ctop
      ctopon ccl wral crn kqtopon topontop wceq toponss sselda wfn wb ad3antrrr
      sylan kqffn fvelrnb mpbid wi ccnv cima simpllr ccn co kqid cnima elpreima
      simplr biimpar regsep syl3anc simp-4l simprl simprrl simplrl kqfvima ccld
      kqopn cuni elssuni ad2antrl eqid clscld kqcld sscls imass2 clsss2 simprrr
      wfun fnfun funimass2 sstrd eleq2 sseq1d anbi12d rspcev syl12anc rexlimddv
      fveq2 expr eleq1 anbi1d rexbidv imbi12d syl5ibcom com23 imp rexlimdva mpd
      an32s anasss ralrimivva isreg sylanbrc ) DEUDLZMZDUAMZNZDUBLZUCMZGOZHOZMZ
      YCXTUELZLZIOZPZNZHXTQZGYGUFIXTUFXTUAMXSXTCUGZUDLMZYAXQYLXRABCDEFUHRZYKXTU
      ISXSYJIGXTYGXSYGXTMZYBYGMZYJXSYNNZYONZJOZCLZYBUJZJEQZYJYQYBYKMZUUAYPYGYKY
      BXSYLYNYGYKPYMYGXTYKUKUPULYQCEUMZUUBUUAUNXQUUCXRYNYOABCDXPEFUQZUOJEYBCURS
      USYQYTYJJEYPYREMZYOYTYJUTZYPUUENZYOUUFUUGYTYOYJUUGYSYGMZYSYCMZYHNZHXTQZUT
      YTYOYJUTYPUUEUUHUUKYPUUEUUHNZNZYRKOZMZUUNDUELLZCVAYGVBZPZNZUUKKDUUMXRUUQD
      MZYRUUQMZUUSKDQXQXRYNUULVCUUMCDXTVDVEMZYNUUTXQUVBXRYNUULABCDEFVFUOXSYNUUL
      VIYGCDXTVGTYPUVAUULYPUUCUVAUULUNXSUUCYNXQUUCXRUUDRZREYRYGCVHSVJKYRUUQDVKV
      LUUMUUNDMZUUSNZNZCUUNVBZXTMZYSUVGMZUVGYELZYGPZUUKUVFXQUVDUVHXQXRYNUULUVEV
      MZUUMUVDUUSVNZABUUNCDEFVSTUVFUUOUVIUUMUVDUUOUURVOUVFXQUVDUUEUUOUVIUNUVLUV
      MYPUUEUUHUVEVPABYRUUNCDEFVQVLUSUVFUVJCUUPVBZYGUVFUVNXTVRLMZUVGUVNPZUVJUVN
      PUVFXQUUPDVRLMZUVOUVLUVFDUCMZUUNDVTZPZUVQUVFXQUVRUVLEDUISZUVDUVTUUMUUSUUN
      DWAWBZUUNDUVSUVSWCZWDTABUUPCDEFWETUVFUUNUUPPZUVPUVFUVRUVTUWDUWAUWBUUNDUVS
      UWCWFTUUNUUPCWGSUVNUVGXTXTVTZUWEWCWHTUVFCWJZUURUVNYGPUVFUUCUWFXSUUCYNUULU
      VEUVCUOECWKSUUMUVDUUOUURWIUUPYGCWLTWMUUJUVIUVKNHUVGXTYCUVGUJZUUIUVIYHUVKY
      CUVGYSWNUWGYFUVJYGYCUVGYEWTWOWPWQWRWSXAYTUUHYOUUKYJYSYBYGXBYTUUJYIHXTYTUU
      IYDYHYSYBYCXBXCXDXEXFXGXHXKXIXJXLXMIGHXTXNXO $.

    $( If the Kolmogorov quotient of a space is regular then so is the original
       space.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqreglem2 $p |- ( ( J e. ( TopOn ` X ) /\ ( KQ ` J ) e. Reg ) ->
        J e. Reg ) $=
      ( vw vm vz vn ctopon cfv wcel wa cv wss adantr cima syl2anc syl creg ctop
      ckq ccl wrex topontop simplr simpll simprl kqopn simprr wb toponss sseldd
      wral kqfvima syl3anc mpbid regsep ccnv ccn co kqid cnima simprrl elpreima
      wfn kqffn 3syl mpbir2and ccld crn kqtopon elssuni ad2antrl clscld cnclima
      cuni eqid sscls imass2 clsss2 simprrr wceq kqsat sstrd eleq2 fveq2 sseq1d
      sseqtrd anbi12d rspcev syl12anc rexlimddv ralrimivva isreg sylanbrc ) DEK
      LZMZDUCLZUAMZNZDUBMZGOZHOZMZXEDUDLZLZIOZPZNZHDUEZGXIUOIDUODUAMWSXCXAEDUFQ
      XBXLIGDXIXBXIDMZXDXIMZNZNZXDCLZJOZMZXRWTUDLLZCXIRZPZNZXLJWTXPXAYAWTMZXQYA
      MZYCJWTUEWSXAXOUGXPWSXMYDWSXAXOUHZXBXMXNUIZABXICDEFUJSXPXNYEXBXMXNUKZXPWS
      XMXDEMZXNYEULYFYGXPXIEXDXPWSXMXIEPYFYGXIDEUMSYHUNZABXDXICDEFUPUQURJXQYAWT
      USUQXPXRWTMZYCNZNZCUTZXRRZDMZXDYOMZYOXGLZXIPZXLYMCDWTVAVBMZYKYPYMWSYTXPWS
      YLYFQZABCDEFVCTZXPYKYCUIXRCDWTVDSYMYQYIXSXPYIYLYJQXPYKXSYBVEYMWSCEVGYQYIX
      SNULUUAABCDWREFVHEXDXRCVFVIVJYMYRYNXTRZXIYMUUCDVKLMZYOUUCPZYRUUCPYMYTXTWT
      VKLMZUUDUUBYMWTUBMZXRWTVRZPZUUFYMWSWTCVLZKLMUUGUUAABCDEFVMUUJWTUFVIZYKUUI
      XPYCXRWTVNVOZXRWTUUHUUHVSZVPSXTCDWTVQSYMXRXTPZUUEYMUUGUUIUUNUUKUULXRWTUUH
      UUMVTSXRXTYNWATUUCYODDVRZUUOVSWBSYMUUCYNYARZXIYMYBUUCUUPPXPYKXSYBWCXTYAYN
      WATYMWSXMUUPXIWDUUAXPXMYLYGQABXICDEFWESWJWFXKYQYSNHYODXEYOWDZXFYQXJYSXEYO
      XDWGUUQXHYRXIXEYOXGWHWIWKWLWMWNWOIGHDWPWQ $.

    $( A Kolmogorov quotient of a normal space is normal.  (Contributed by
       Mario Carneiro, 25-Aug-2015.) $)
    kqnrmlem1 $p |- ( ( J e. ( TopOn ` X ) /\ J e. Nrm ) ->
        ( KQ ` J ) e. Nrm ) $=
      ( vw vm vz vu cfv wcel wa cv wss syl cima syl2anc 3syl wceq cnrm ckq ctop
      ctopon ccl wrex ccld cpw cin wral crn kqtopon adantr topontop ccnv simplr
      ccn co kqid ad2antrr simprl cnima inss1 simprr sseldi cnclima inss2 elpwi
      imass2 nrmsep3 syl13anc simplll kqopn simprrl wfun wi wfn kqffn cuni eqid
      fnfun cldss toponuni sseqtr4d funimass1 mpd elssuni ad2antrl clscld kqcld
      sscls clsss2 simprrr cdm wb clsss3 fndm eqtrd funimass3 sstrd sseq2 fveq2
      mpbird sseq1d anbi12d rspcev syl12anc rexlimddv ralrimivva isnrm sylanbrc
      ) DEUDKZLZDUALZMZDUBKZUCLZGNZHNZOZXSXPUEKZKZINZOZMZHXPUFZGXPUGKZYCUHZUIZU
      JIXPUJXPUALXOXPCUKZUDKLZXQXMYKXNABCDEFULZUMYJXPUNPXOYFIGXPYIXOYCXPLZXRYIL
      ZMZMZCUOZXRQZJNZOZYSDUEKKZYQYCQZOZMZYFJDYPXNUUBDLZYRDUGKZLZYRUUBOZUUDJDUF
      XMXNYOUPYPCDXPUQURLZYMUUEXMUUIXNYOABCDEFUSUTZXOYMYNVAYCCDXPVBRYPUUIXRYGLZ
      UUGUUJYPYIYGXRYGYHVCXOYMYNVDZVEZXRCDXPVFRYPXRYHLXRYCOUUHYPYIYHXRYGYHVGUUL
      VEXRYCVHXRYCYQVISJUUBYRDVJVKYPYSDLZUUDMZMZCYSQZXPLZXRUUQOZUUQYAKZYCOZYFUU
      PXMUUNUURXMXNYOUUOVLZYPUUNUUDVAABYSCDEFVMRUUPYTUUSYPUUNYTUUCVNUUPCVOZXRYJ
      OYTUUSVPUUPXMCEVQZUVCUVBABCDXLEFVRZECWASZUUPXRXPVSZYJUUPUUKXRUVGOYPUUKUUO
      UUMUMXRXPUVGUVGVTZWBPUUPXMYKYJUVGTUVBYLYJXPWCSWDXRYSCWERWFUUPUUTCUUAQZYCU
      UPUVIYGLZUUQUVIOZUUTUVIOUUPXMUUAUUFLZUVJUVBUUPDUCLZYSDVSZOZUVLUUPXMUVMUVB
      EDUNPZUUNUVOYPUUDYSDWGWHZYSDUVNUVNVTZWIRABUUACDEFWJRUUPYSUUAOZUVKUUPUVMUV
      OUVSUVPUVQYSDUVNUVRWKRYSUUACVIPUVIUUQXPUVGUVHWLRUUPUVIYCOZUUCYPUUNYTUUCWM
      UUPUVCUUACWNZOUVTUUCWOUVFUUPUUAUVNUWAUUPUVMUVOUUAUVNOUVPUVQYSDUVNUVRWPRUU
      PUWAEUVNUUPXMUVDUWAETUVBUVEECWQSUUPXMEUVNTUVBEDWCPWRWDUUAYCCWSRXCWTYEUUSU
      VAMHUUQXPXSUUQTZXTUUSYDUVAXSUUQXRXAUWBYBUUTYCXSUUQYAXBXDXEXFXGXHXIIGHXPXJ
      XK $.

    $( If the Kolmogorov quotient of a space is normal then so is the original
       space.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqnrmlem2 $p |- ( ( J e. ( TopOn ` X ) /\ ( KQ ` J ) e. Nrm ) ->
        J e. Nrm ) $=
      ( vw vu vz vm cfv wcel wa cv wss cima syl2anc 3syl syl wceq ckq cnrm ctop
      ctopon ccl wrex ccld cpw cin wral adantr simplr simpll simprl kqopn inss1
      topontop simprr sseldi kqcld inss2 elpwi imass2 nrmsep3 syl13anc ccnv ccn
      co simplll kqid cnima simprrl wfun cdm wb wfn kqffn fnfun cuni eqid cldss
      fndm toponuni eqtrd sseqtr4d funimass3 mpbid crn kqtopon elssuni ad2antrl
      clscld cnclima sscls clsss2 simprrr kqsat sstrd sseq2 fveq2 sseq1d rspcev
      sseqtrd anbi12d syl12anc rexlimddv ralrimivva isnrm sylanbrc ) DEUDKZLZDU
      AKZUBLZMZDUCLZGNZHNZOZXQDUEKZKZINZOZMZHDUFZGDUGKZYAUHZUIZUJIDUJDUBLXKXOXM
      EDUQUKXNYDIGDYGXNYADLZXPYGLZMZMZCXPPZJNZOZYMXLUEKKZCYAPZOZMZYDJXLYKXMYPXL
      LZYLXLUGKZLZYLYPOZYRJXLUFXKXMYJULYKXKYHYSXKXMYJUMZXNYHYIUNZABYACDEFUOQYKX
      KXPYELZUUAUUCYKYGYEXPYEYFUPXNYHYIURZUSZABXPCDEFUTQYKXPYFLXPYAOUUBYKYGYFXP
      YEYFVAUUFUSXPYAVBXPYACVCRJYPYLXLVDVEYKYMXLLZYRMZMZCVFZYMPZDLZXPUULOZUULXS
      KZYAOZYDUUJCDXLVGVHLZUUHUUMUUJXKUUQXKXMYJUUIVIZABCDEFVJSZYKUUHYRUNYMCDXLV
      KQUUJYNUUNYKUUHYNYQVLUUJCVMZXPCVNZOYNUUNVOUUJXKCEVPZUUTUURABCDXJEFVQZECVR
      RUUJXPDVSZUVAUUJUUEXPUVDOYKUUEUUIUUGUKXPDUVDUVDVTZWASUUJUVAEUVDUUJXKUVBUV
      AETUURUVCECWBRUUJXKEUVDTUUREDWCSWDWEXPYMCWFQWGUUJUUOUUKYOPZYAUUJUVFYELZUU
      LUVFOZUUOUVFOUUJUUQYOYTLZUVGUUSUUJXLUCLZYMXLVSZOZUVIUUJXKXLCWHZUDKLUVJUUR
      ABCDEFWIUVMXLUQRZUUHUVLYKYRYMXLWJWKZYMXLUVKUVKVTZWLQYOCDXLWMQUUJYMYOOZUVH
      UUJUVJUVLUVQUVNUVOYMXLUVKUVPWNQYMYOUUKVCSUVFUULDUVDUVEWOQUUJUVFUUKYPPZYAU
      UJYQUVFUVROYKUUHYNYQWPYOYPUUKVCSUUJXKYHUVRYATUURYKYHUUIUUDUKABYACDEFWQQXC
      WRYCUUNUUPMHUULDXQUULTZXRUUNYBUUPXQUULXPWSUVSXTUUOYAXQUULXSWTXAXDXBXEXFXG
      IGHDXHXI $.
  $}

  ${
    $d o x y A $.  $d o y B $.  $d a b j o w x y z J $.  $d o w x y z X $.
    $( The Kolmogorov quotient is a topology on the quotient set.  (Contributed
       by Mario Carneiro, 25-Aug-2015.) $)
    kqtop $p |- ( J e. Top <-> ( KQ ` J ) e. Top ) $=
      ( vx vy ctop wcel ckq cfv cuni crab cmpt crn ctopon eqid toptopon kqtopon
      vj cv syl c0 cqtop sylbi topontop cdm 0opn elfvdm co ovex dmmpti syl6eleq
      df-kq impbii ) ADEZAFGZDEZULUMBAHZBQCQEZCAIJZKZLGEZUNULAUOLGEUSAUOUOMNBCU
      QAUOUQMOUAURUMUBRUNAFUCZDUNSUMEAUTEUMUDSAFUERPDPQZBVAHUPCVAIJZTUFFVAVBTUG
      BCPUJUHUIUK $.

    $( The Kolmogorov quotient is T_0 even if the original topology is not.
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqt0 $p |- ( J e. Top <-> ( KQ ` J ) e. Kol2 ) $=
      ( vx vy ctop wcel ckq cfv ct0 cuni ctopon eqid toptopon crab cmpt kqt0lem
      wel sylbi t0top kqtop sylibr impbii ) ADEZAFGZHEZUBAAIZJGEUDAUEUEKLBCBUEB
      CPCAMNZAUEUFKOQUDUCDEUBUCRASTUA $.

    $( The Kolmogorov quotient is a topology on the quotient set.  (Contributed
       by Mario Carneiro, 25-Aug-2015.) $)
    kqf $p |- KQ : Top --> Kol2 $=
      ( vx vj vy ctop ct0 ckq wf wfn cv cfv wcel wral cuni crab cmpt cqtop ovex
      co df-kq fnmpti kqt0 biimpi rgen ffnfv mpbir2an ) DEFGFDHAIZFJEKZADLBDBIZ
      AUHMUFCIKCUHNOZPRFUHUIPQACBSTUGADUFDKUGUFUAUBUCADEFUDUE $.

    $( The separation property of an R_0 space.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    r0sep $p |- ( ( ( J e. ( TopOn ` X ) /\ ( KQ ` J ) e. Fre ) /\
      ( A e. X /\ B e. X ) ) -> ( A. o e. J ( A e. o -> B e. o ) ->
                                  A. o e. J ( A e. o <-> B e. o ) ) ) $=
      ( vx vy vz vw cfv wcel wa wel wi wral wb cv wceq eleq1 ralbidv ctopon ckq
      ct1 crab cmpt eqid isr0 biimpa imbi1d bibi1d imbi12d imbi2d bibi2d rspc2v
      mpan9 ) DEUAJKZDUBJUCKZLFCMZGCMZNZCDOZURUSPZCDOZNZGEOFEOZAEKBEKLACQZKZBVF
      KZNZCDOZVGVHPZCDOZNZUPUQVEHIFGCHEHIMIDUDUEZDEVNUFUGUHVDVMVGUSNZCDOZVGUSPZ
      CDOZNFGABEEFQZARZVAVPVCVRVTUTVOCDVTURVGUSVSAVFSZUITVTVBVQCDVTURVGUSWAUJTU
      KGQZBRZVPVJVRVLWCVOVICDWCUSVHVGWBBVFSZULTWCVQVKCDWCUSVHVGWDUMTUKUNUO $.

    $( A normal R_0 space is also regular.  These spaces are usually referred
       to as normal regular spaces.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    nrmr0reg $p |- ( ( J e. Nrm /\ ( KQ ` J ) e. Fre ) -> J e. Reg ) $=
      ( vy vz vx va vb vw wcel cfv wa wel cv wss wrex wral adantr crab eqid weq
      wb cnrm ckq ct1 ctop ccl creg nrmtop cuni ccld simpll simprl ctopon sylib
      toptopon simplr simprr elunii syl2anc r0cld syl3anc w3a simp1rr wi elequ2
      cmpt bibi12d rspcv 3impia mpbird rabssdv nrmsep3 syl13anc biidd ralrimivw
      syl elequ1 bibi1d ralbidv sylanbrc ssel syl5com anim1d reximdv ralrimivva
      elrab mpd isreg ) AUAHZAUBIUCHZJZAUDHZBCKZCLZAUEIIDLZMZJZCANZBWNODAOAUFHW
      HWKWIAUGPZWJWQDBAWNWJWNAHZBDKZJZJZEFKZBFKZTZFAOZEAUHZQZWMMZWOJZCANZWQXBWH
      WSXHAUIIHZXHWNMXKWHWIXAUJWJWSWTUKZXBAXGULIHZWIBLZXGHZXLXBWKXNWJWKXAWRPAXG
      XGRUNUMWHWIXAUOXBWTWSXPWJWSWTUPXMXOWNAUQURZCGEXOFCXGCGKGAQVEZAXGXRRUSUTXB
      XFEXGWNXBELXGHZXFVAEDKZWTWSWTWJXSXFVBXBXSXFXTWTTZXBXSJWSXFYAVCXBWSXSXMPXE
      YAFWNAFDSXCXTXDWTFDEVDFDBVDVFVGVOVHVIVJCWNXHAVKVLXBXJWPCAXBXIWLWOXBXOXHHZ
      XIWLXBXPXDXDTZFAOZYBXQXBYCFAXBXDVMVNXFYDEXOXGEBSZXEYCFAYEXCXDXDEBFVPVQVRW
      EVSXHWMXOVTWAWBWCWFWDDBCAWGVS $.

    $( A regular space is R_1, which means that any two topologically distinct
       points can be separated by neighborhoods.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    regr1 $p |- ( J e. Reg -> ( KQ ` J ) e. Haus ) $=
      ( vx vy cuni ctopon cfv wcel creg ckq cha ctop regtop eqid toptopon sylib
      wel crab cmpt regr1lem2 mpancom ) AADZEFGZAHGZAIFJGUCAKGUBALAUAUAMNOBCBUA
      BCPCAQRZAUAUDMST $.

    $( The Kolmogorov quotient of a regular space is regular.  By ~ regr1 it is
       also Hausdorff, so we can also say that a space is regular iff the
       Kolmogorov quotient is regular Hausdorff (T_3).  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    kqreg $p |- ( J e. Reg <-> ( KQ ` J ) e. Reg ) $=
      ( vx vy creg wcel ckq cfv cuni ctopon ctop regtop eqid toptopon sylib wel
      crab cmpt kqreglem1 mpancom kqtop sylibr kqreglem2 impbii ) ADEZAFGZDEZAA
      HZIGEZUDUFUDAJEZUHAKAUGUGLMZNBCBUGBCOCAPQZAUGUKLZRSUHUFUDUFUIUHUFUEJEUIUE
      KATUAUJNBCUKAUGULUBSUC $.

    $( The Kolmogorov quotient of a normal space is normal.  (Contributed by
       Mario Carneiro, 25-Aug-2015.) $)
    kqnrm $p |- ( J e. Nrm <-> ( KQ ` J ) e. Nrm ) $=
      ( vx vy cnrm wcel ckq cfv cuni ctopon ctop nrmtop eqid toptopon sylib wel
      crab cmpt kqnrmlem1 mpancom kqtop sylibr kqnrmlem2 impbii ) ADEZAFGZDEZAA
      HZIGEZUDUFUDAJEZUHAKAUGUGLMZNBCBUGBCOCAPQZAUGUKLZRSUHUFUDUFUIUHUFUEJEUIUE
      KATUAUJNBCUKAUGULUBSUC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Homeomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Homeo $. $( Class of all homeomorphisms. $)
  $c ~= $. $( The relation "is homeomorph to." $)

  $( Extend class notation with the class of all homeomorphisms. $)
  chmeo $a class Homeo $.

  $( Extend class notation with the relation "is homeomorph to.". $)
  chmph $a class ~= $.

  ${
    $d f j k J $.  $d f j k K $.
    $( Function returning all the homeomorphisms from topology ` j ` to
       topology ` k ` .  (Contributed by FL, 14-Feb-2007.) $)
    df-hmeo $a |- Homeo = ( j e. Top , k e. Top |->
            { f e. ( j Cn k ) | `' f e. ( k Cn j ) } ) $.

    $( Definition of the relation ` x ` is homeomorph to ` y ` .  (Contributed
       by FL, 14-Feb-2007.) $)
    df-hmph $a |- ~= = ( `' Homeo " ( _V \ 1o ) ) $.

    $( The set of homeomorphisms is a function on topologies.  (Contributed by
       Mario Carneiro, 23-Aug-2015.) $)
    hmeofn $p |- Homeo Fn ( Top X. Top ) $=
      ( vj vk vf ctop cv ccnv ccn co wcel crab chmeo df-hmeo ovex rabex fnmpt2i
      ) ABDDCEFBEZAEZGHIZCQPGHZJKCABLRCSQPGMNO $.

    $( The set of all the homeomorphisms between two topologies.  (Contributed
       by FL, 14-Feb-2007.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    hmeofval $p |- ( J Homeo K ) = { f e. ( J Cn K ) | `' f e. ( K Cn J ) } $=
      ( vj vk ctop wcel wa chmeo co cv ccnv ccn crab oveq12 ancoms eleq2d wn c0
      wceq rabeqbidv df-hmeo ovex rabex ovmpt2a mpt2ndm0 wral cntop1 cntop2 jca
      a1d con3rr3 ralrimiv rabeq0 sylibr eqtr4d pm2.61i ) BFGZCFGZHZBCIJZAKZLZC
      BMJZGZABCMJZNZTDEBCFFVCEKZDKZMJZGZAVIVHMJZNZVGIVIBTZVHCTZHZVKVEAVLVFVIBVH
      CMOVPVJVDVCVOVNVJVDTVHCVIBMOPQUAADEUBZVEAVFBCMUCUDUEUTRZVASVGDEVMIBCFFVQU
      FVRVERZAVFUGVGSTVRVSAVFVBVFGZVEUTVTUTVEVTURUSVBBCUHVBBCUIUJUKULUMVEAVFUNU
      OUPUQ $.
  $}

  ${
    $d F f x $.  $d J f x $.  $d K f x $.  $d X f $.  $d Y f $.
    $( The predicate F is a homeomorphism between topology ` J ` and topology
       ` K ` .  Proposition of [BourbakiTop1] p.  I.2.  (Contributed by FL,
       14-Feb-2007.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
    ishmeo $p |- ( F e. ( J Homeo K ) <->
        ( F e. ( J Cn K ) /\ `' F e. ( K Cn J ) ) ) $=
      ( vf cv ccnv ccn co wcel chmeo wceq cnveq eleq1d hmeofval elrab2 ) DEZFZC
      BGHZIAFZRIDABCGHBCJHPAKQSRPALMDBCNO $.
  $}

  $( A homeomorphism is continuous.  (Contributed by Mario Carneiro,
     22-Aug-2015.) $)
  hmeocn $p |- ( F e. ( J Homeo K ) -> F e. ( J Cn K ) ) $=
    ( chmeo co wcel ccn ccnv ishmeo simplbi ) ABCDEFABCGEFAHCBGEFABCIJ $.

  $( The converse of a homeomorphism is continuous.  (Contributed by Mario
     Carneiro, 22-Aug-2015.) $)
  hmeocnvcn $p |- ( F e. ( J Homeo K ) -> `' F e. ( K Cn J ) ) $=
    ( chmeo co wcel ccn ccnv ishmeo simprbi ) ABCDEFABCGEFAHCBGEFABCIJ $.

  $( The converse of a homeomorphism is a homeomorphism.  (Contributed by FL,
     5-Mar-2007.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
  hmeocnv $p |- ( F e. ( J Homeo K ) -> `' F e. ( K Homeo J ) ) $=
    ( chmeo co wcel ccnv ccn hmeocnvcn wrel wceq cuni hmeocn eqid cnf frel 3syl
    wf dfrel2 sylib eqeltrd ishmeo sylanbrc ) ABCDEFZAGZCBHEFUEGZBCHEZFUECBDEFA
    BCIUDUFAUGUDAJZUFAKUDAUGFBLZCLZARUHABCMZABCUIUJUINUJNOUIUJAPQASTUKUAUECBUBU
    C $.

  $( A homeomorphism is a 1-1-onto mapping.  (Contributed by Mario Carneiro,
     22-Aug-2015.) $)
  hmeof1o2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\
    F e. ( J Homeo K ) ) -> F : X -1-1-onto-> Y ) $=
    ( ctopon cfv wcel chmeo co w3a wfn ccnv wf1o wf ccn cnf2 syl3an3 ffn syl
    hmeocn hmeocnvcn 3com12 dff1o4 sylanbrc ) BDFGHZCEFGHZABCIJHZKZADLZAMZELZDE
    ANUIDEAOZUJUHUFUGABCPJHUMABCUAABCDEQRDEASTUIEDUKOZULUHUFUGUKCBPJHZUNABCUBUG
    UFUOUNUKCBEDQUCREDUKSTDEAUDUE $.

  ${
    $d F x $.  $d J x $.  $d K x $.
    hmeof1o.1 $e |- X = U. J $.
    hmeof1o.2 $e |- Y = U. K $.
    $( A homeomorphism is a 1-1-onto mapping.  (Contributed by FL,
       5-Mar-2007.)  (Revised by Mario Carneiro, 30-May-2014.) $)
    hmeof1o $p |- ( F e. ( J Homeo K ) -> F : X -1-1-onto-> Y ) $=
      ( ctopon cfv wcel wa chmeo co wf1o ccn hmeocn ctop cntop1 toptopon sylib
      cntop2 jca syl hmeof1o2 3expia mpcom ) BDHIJZCEHIJZKZABCLMJZDEANZUJABCOMJ
      ZUIABCPULUGUHULBQJUGABCRBDFSTULCQJUHABCUACEGSTUBUCUGUHUJUKABCDEUDUEUF $.
  $}

  $( The image of an open set by a homeomorphism is an open set.  (Contributed
     by FL, 5-Mar-2007.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
  hmeoima $p |- ( ( F e. ( J Homeo K ) /\ A e. J ) -> ( F " A ) e. K ) $=
    ( chmeo co wcel ccnv ccn cima hmeocnvcn wa imacnvcnv cnima syl5eqelr sylan
    ) BCDEFGBHZDCIFGZACGZBAJZDGBCDKRSLTQHAJDBAMAQDCNOP $.

  ${
    $d X x y $.  $d J x y $.  $d K x y $.  $d A x y $.  $d F x y $.
    hmeoopn.1 $e |- X = U. J $.
    $( Homeomorphisms preserve openness.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 25-Aug-2015.) $)
    hmeoopn $p |- ( ( F e. ( J Homeo K ) /\ A C_ X ) ->
        ( A e. J <-> ( F " A ) e. K ) ) $=
      ( chmeo co wcel wss wa cima wi hmeoima ex adantr ccnv ccn hmeocn syl cuni
      cnima wceq wf1o eqid hmeof1o f1of1 f1imacnv sylan eleq1d sylibd impbid
      wf1 ) BCDGHIZAEJZKZACIZBALZDIZUNUQUSMUOUNUQUSABCDNOPUPUSBQURLZCIZUQUNUSVA
      MZUOUNBCDRHIZVBBCDSVCUSVAURBCDUBOTPUPUTACUNEDUAZBUMZUOUTAUCUNEVDBUDVEBCDE
      VDFVDUEUFEVDBUGTEVDABUHUIUJUKUL $.

    $( Homeomorphisms preserve closedness.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 25-Aug-2015.) $)
    hmeocld $p |- ( ( F e. ( J Homeo K ) /\ A C_ X ) ->
        ( A e. ( Clsd ` J ) <-> ( F " A ) e. ( Clsd ` K ) ) ) $=
      ( chmeo co wcel wa ccld cfv cima ccnv ccn wi adantr cnclima ex syl hmeocn
      wss hmeocnvcn imacnvcnv syl5eqelr cuni wceq wf1o eqid hmeof1o f1of1 sylan
      wf1 f1imacnv eleq1d sylibd impbid ) BCDGHIZAEUBZJZACKLZIZBAMZDKLZIZUTBNZD
      COHIZVBVEPURVGUSBCDUCQVGVBVEVGVBJVCVFNAMVDBAUDAVFDCRUESTUTVEVFVCMZVAIZVBU
      TBCDOHIZVEVIPURVJUSBCDUAQVJVEVIVCBCDRSTUTVHAVAUREDUFZBUMZUSVHAUGUREVKBUHV
      LBCDEVKFVKUIUJEVKBUKTEVKABUNULUOUPUQ $.

    $( Homeomorphisms preserve closures.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    hmeocls $p |- ( ( F e. ( J Homeo K ) /\ A C_ X ) ->
        ( ( cls ` K ) ` ( F " A ) ) = ( F " ( ( cls ` J ) ` A ) ) ) $=
      ( chmeo co wcel wss wa cima ccl cfv ccn hmeocnvcn cncls2i sylan imacnvcnv
      ccnv fveq2i 3sstr3g hmeocn cnclsi eqssd ) BCDGHIZAEJZKZBALZDMNZNZBACMNNZL
      ZUHBTZTZALZUJNZUOULLZUKUMUFUNDCOHIUGUQURJBCDPAUNDCEFQRUPUIUJBASUABULSUBUF
      BCDOHIUGUMUKJBCDUCABCDEFUDRUE $.

    $( Homeomorphisms preserve interiors.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    hmeontr $p |- ( ( F e. ( J Homeo K ) /\ A C_ X ) ->
        ( ( int ` K ) ` ( F " A ) ) = ( F " ( ( int ` J ) ` A ) ) ) $=
      ( wcel wss cima cnt cfv ccnv ccn adantr wceq cnntri syl2anc syl imacnvcnv
      co chmeo wa cuni hmeocn crn imassrn wf1o wfo eqid hmeof1o f1ofo forn 3syl
      syl5sseq wf1 f1of1 f1imacnv sylancom fveq2d sseqtrd wfun wi f1ofun cntop2
      ctop ntrss3 sseqtr4d funimass1 mpd hmeocnvcn sylan fveq2i 3sstr3g eqssd )
      BCDUATGZAEHZUBZBAIZDJKZKZBACJKZKZIZVQBLZVTIZWBHZVTWCHZVQWEWDVRIZWAKZWBVQB
      CDMTGZVRDUCZHZWEWIHVOWJVPBCDUDNZVQBUEZVRWKBAUFVQEWKBUGZEWKBUHWNWKOVOWOVPB
      CDEWKFWKUIZUJNZEWKBUKEWKBULUMZUNZVRBCDWKWPPQVQWHAWAVOVPEWKBUOZWHAOVQWOWTW
      QEWKBUPREWKABUQURUSUTVQBVAZVTWNHWFWGVBVQWOXAWQEWKBVCRVQVTWKWNVQDVEGZWLVTW
      KHVQWJXBWMBCDVDRWSVRDWKWPVFQWRVGVTWBBVHQVIVQWDLZWBIZXCAIZVSKZWCVTVOWDDCMT
      GVPXDXFHBCDVJAWDDCEFPVKBWBSXEVRVSBASVLVMVN $.
  $}

  ${
    $d x y F $.  $d x y J $.  $d x y K $.
    hmeoimaf1o.1 $e |- G = ( x e. J |-> ( F " x ) ) $.
    $( The function mapping open sets to their images under a homeomorphism is
       a bijection of topologies.  (Contributed by Mario Carneiro,
       10-Sep-2015.) $)
    hmeoimaf1o $p |- ( F e. ( J Homeo K ) -> G : J -1-1-onto-> K ) $=
      ( vy chmeo co wcel cv cima ccnv wa wceq cuni wss eqid syl elssuni hmeoima
      ccn hmeocn cnima sylan wf1 wb wf1o hmeof1o adantr f1of1 ad2antrl cnvimass
      cdm f1dm syl5sseq f1imaeq syl12anc f1ofo ad2antll foimacnv syl2anc eqeq2d
      wfo eqcom syl6bb bitr3d f1o2d ) BDEHIJZAGDEBAKZLZBMGKZLZCFVJBDEUAVIBDEUBI
      JVLEJZVMDJBDEUCVLBDEUDUEVIVJDJZVNNZNZVKBVMLZOZVJVMOZVLVKOZVQDPZEPZBUFZVJW
      BQZVMWBQVSVTUGVQWBWCBUHZWDVIWFVPBDEWBWCWBRWCRUIUJZWBWCBUKSZVOWEVIVNVJDTUL
      VQBUNZVMWBBVLUMVQWDWIWBOWHWBWCBUOSUPWBWCVJVMBUQURVQVSVKVLOWAVQVRVLVKVQWBW
      CBVDZVLWCQZVRVLOVQWFWJWGWBWCBUSSVNWKVIVOVLETUTWBWCVLBVAVBVCVKVLVEVFVGVH
      $.
  $}

  ${
    hmeores.1 $e |- X = U. J $.
    $( The restriction of a homeomorphism is a homeomorphism.  (Contributed by
       Mario Carneiro, 14-Sep-2014.)  (Proof shortened by Mario Carneiro,
       22-Aug-2015.) $)
    hmeores $p |- ( ( F e. ( J Homeo K ) /\ Y C_ X ) ->
      ( F |` Y ) e. ( ( J |`t Y ) Homeo ( K |`t ( F " Y ) ) ) ) $=
      ( chmeo co wcel wss cres crest ccn ccnv adantr cnrest crn syl wf wceq cfv
      wa cima hmeocn sylancom cuni ctopon wb ctop cntop2 eqid toptopon eqimss2i
      sylib df-ima a1i imassrn cnf frn syl5ss cnrest2 mpbid wfun hmeocnvcn ffun
      syl3anc funcnvres 4syl syl2anc eqeltrd cntop1 cdm dfdm4 fssres fdm eqimss
      syl5eqr simpr ishmeo sylanbrc ) ABCGHIZEDJZUBZAEKZBELHZCAEUCZLHZMHIZWDNZW
      GWEMHIZWDWEWGGHIWCWDWECMHIZWHWAWBABCMHIZWKWAWLWBABCUDOZEABCDFPUEWCCCUFZUG
      UAIZWDQZWFJZWFWNJZWKWHUHWCCUIIZWOWCWLWSWMABCUJRCWNWNUKZULUNWQWCWFWPAEUOUM
      UPWCWFAQZWNAEUQWCDWNASZXAWNJWCWLXBWMABCDWNFWTURRZDWNAUSRUTZWFWDWECWNVAVFV
      BWCWIWGBMHZIZWJWCWIANZWFKZXEWCXGCBMHIZWNDXGSXGVCWIXHTWAXIWBABCVDOZXGCBWND
      WTFURWNDXGVEEAVGVHWCXIWRXHXEIXJXDWFXGCBWNWTPVIVJWCBDUGUAIZWIQZEJZWBXFWJUH
      WCBUIIZXKWCWLXNWMABCVKRBDFULUNWCXLETXMWCXLWDVLZEWDVMWCEWNWDSZXOETWAWBXBXP
      XCDWNEAVNUEEWNWDVORVQXLEVPRWAWBVREWIWGBDVAVFVBWDWEWGVSVT $.
  $}

  $( The composite of two homeomorphisms is a homeomorphism.  (Contributed by
     FL, 9-Mar-2007.)  (Proof shortened by Mario Carneiro, 23-Aug-2015.) $)
  hmeoco $p |- ( ( F e. ( J Homeo K ) /\ G e. ( K Homeo L ) ) ->
      ( G o. F ) e. ( J Homeo L ) ) $=
    ( chmeo co wcel wa ccom ccn ccnv hmeocn cnco syl2an cnvco hmeocnvcn syl2anr
    syl5eqel ishmeo sylanbrc ) ACDFGHZBDEFGHZIZBAJZCEKGHZUELZECKGZHUECEFGHUBACD
    KGHBDEKGHUFUCACDMBDEMABCDENOUDUGALZBLZJZUHBAPUCUJEDKGHUIDCKGHUKUHHUBBDEQACD
    QUJUIEDCNRSUECETUA $.

  $( The identity function is a homeomorphism.  (Contributed by FL,
     14-Feb-2007.)  (Proof shortened by Mario Carneiro, 23-Aug-2015.) $)
  idhmeo $p |- ( J e. ( TopOn ` X ) -> ( _I |` X ) e. ( J Homeo J ) ) $=
    ( ctopon cfv wcel cid cres ccn ccnv chmeo cnvresid syl5eqel ishmeo sylanbrc
    co idcn ) ABCDEZFBGZAAHOZERIZSERAAJOEABPZQTRSBKUALRAAMN $.

  $( The converse of a homeomorphism is a homeomorphism.  (Contributed by FL,
     5-Mar-2007.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
  hmeocnvb $p |- ( Rel F ->
    ( `' F e. ( J Homeo K ) <-> F e. ( K Homeo J ) ) ) $=
    ( wrel ccnv chmeo co wcel hmeocnv wceq wb dfrel2 eleq1 sylbi syl5ib impbid1
    ) ADZAEZBCFGHZACBFGZHZSREZTHZQUARBCIQUBAJUCUAKALUBATMNOACBIP $.

  ${
    $d F x $.  $d J x $.  $d K x $.
    $( A homeomorphism is a quotient map.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    hmeoqtop $p |- ( F e. ( J Homeo K ) -> K = ( J qTop F ) ) $=
      ( vx chmeo wcel cuni ctop ctopon cfv ccn hmeocn cntop2 syl toptopon sylib
      co eqid wf1o wfo crn wceq hmeof1o f1ofo forn 3syl cv hmeoima qtopomap ) A
      BCEQFZDABCCGZUJCHFZCUKIJFUJABCKQFULABCLZABCMNCUKUKRZOPUMUJBGZUKASUOUKATAU
      AUKUBABCUOUKUORUNUCUOUKAUDUOUKAUEUFDUGABCUHUI $.
  $}

  $( Express the predicate ` J ` is homeomorph to ` K ` .  (Contributed by FL,
     14-Feb-2007.)  (Revised by Mario Carneiro, 22-Aug-2015.) $)
  hmph $p |- ( J ~= K <-> ( J Homeo K ) =/= (/) ) $=
    ( chmph chmeo ctop cxp df-hmph hmeofn brwitnlem ) ABCDEEFGHI $.

  $( If there is a homeomorphism between spaces, then the spaces are
     homeomorphic.  (Contributed by Mario Carneiro, 23-Aug-2015.) $)
  hmphi $p |- ( F e. ( J Homeo K ) -> J ~= K ) $=
    ( chmeo co wcel c0 wne chmph wbr ne0i hmph sylibr ) ABCDEZFNGHBCIJNAKBCLM
    $.

  $( Reverse closure for the homeomorphic predicate.  (Contributed by Mario
     Carneiro, 22-Aug-2015.) $)
  hmphtop $p |- ( J ~= K -> ( J e. Top /\ K e. Top ) ) $=
    ( ctop chmph chmeo ccnv cvv c1o cdif cima cxp df-hmph cdm cnvimass wfn wceq
    hmeofn fndm ax-mp sseqtri eqsstri brel ) ABCCDDEFGHIZJZCCKZLUDEMZUEEUCNEUEO
    UFUEPQUEERSTUAUB $.

  $( The relation "being homeomorph to" implies the operands are topologies.
     (Contributed by FL, 23-Mar-2007.)  (Revised by Mario Carneiro,
     23-Aug-2015.) $)
  hmphtop1 $p |- ( J ~= K -> J e. Top ) $=
    ( chmph wbr ctop wcel hmphtop simpld ) ABCDAEFBEFABGH $.

  $( The relation "being homeomorph to" implies the operands are topologies.
     (Contributed by FL, 23-Mar-2007.)  (Revised by Mario Carneiro,
     23-Aug-2015.) $)
  hmphtop2 $p |- ( J ~= K -> K e. Top ) $=
    ( chmph wbr ctop wcel hmphtop simprd ) ABCDAEFBEFABGH $.

  $( "Is homeomorph to" is reflexive.  (Contributed by FL, 25-Feb-2007.)
     (Proof shortened by Mario Carneiro, 23-Aug-2015.) $)
  hmphref $p |- ( J e. Top -> J ~= J ) $=
    ( ctop wcel cid cuni cres chmeo co chmph wbr ctopon cfv eqid toptopon sylbi
    idhmeo hmphi syl ) ABCZDAEZFZAAGHCZAAIJSATKLCUBATTMNATPOUAAAQR $.

  ${
    $d x y z $.  $d f g x J $.  $d f g x K $.  $d f g L $.
    $( "Is homeomorph to" is symmetric.  (Contributed by FL, 8-Mar-2007.)
       (Proof shortened by Mario Carneiro, 30-May-2014.) $)
    hmphsym $p |- ( J ~= K -> K ~= J ) $=
      ( vf chmph wbr cv chmeo co wcel wex c0 wne hmph n0 bitri ccnv hmeocnv syl
      hmphi exlimiv sylbi ) ABDEZCFZABGHZIZCJZBADEZUBUDKLUFABMCUDNOUEUGCUEUCPZB
      AGHIUGUCABQUHBASRTUA $.

    $( "Is homeomorph to" is transitive.  (Contributed by FL, 9-Mar-2007.)
       (Revised by Mario Carneiro, 23-Aug-2015.) $)
    hmphtr $p |- ( ( J ~= K /\ K ~= L ) -> J ~= L ) $=
      ( vf vg chmph wbr chmeo co c0 wne hmph cv wcel wex n0 eeanv ccom syl2anb
      wa hmeoco hmphi syl exlimivv sylbir ) ABFGABHIZJKZBCHIZJKZACFGZBCFGABLBCL
      UGDMZUFNZDOZEMZUHNZEOZUJUIDUFPEUHPUMUPTULUOTZEODOUJULUODEQUQUJDEUQUNUKRZA
      CHINUJUKUNABCUAURACUBUCUDUESS $.

    $( "Is homeomorph to" is an equivalence relation.  (Contributed by FL,
       22-Mar-2007.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
    hmpher $p |- ~= Er Top $=
      ( vx vy ctop chmph wer wtru wrel cxp wss chmeo ccnv cvv c1o cdif cima a1i
      vz cv wbr adantl df-hmph cdm cnvimass wfn wceq fndm ax-mp sseqtri eqsstri
      hmeofn relxp relss mp2 hmphsym wa hmphtr wb hmphref hmphtop1 impbii iserd
      wcel trud ) CDEFABQCDDGZFDCCHZIVEGVDDJKLMNZOZVEUAVGJUBZVEJVFUCJVEUDVHVEUE
      UJVEJUFUGUHUICCUKDVEULUMPARZBRZDSZVJVIDSFVIVJUNTVKVJQRZDSUOVIVLDSFVIVJVLU
      PTVICVBZVIVIDSZUQFVMVNVIURVIVIUSUTPVAVC $.

    $( Homeomorphisms preserve the cardinality of the topologies.  (Contributed
       by FL, 1-Jun-2008.)  (Revised by Mario Carneiro, 10-Sep-2015.) $)
    hmphen $p |- ( J ~= K -> J ~~ K ) $=
      ( vf vx chmph wbr chmeo co c0 wne cen hmph cv wcel wex n0 ctop cima sylbi
      syl cmpt wf1o ccn hmeocn cntop1 cntop2 hmeoimaf1o f1oen2g syl3anc exlimiv
      eqid ) ABEFABGHZIJZABKFZABLUMCMZULNZCOUNCULPUPUNCUPAQNZBQNZABDAUODMRUAZUB
      UNUPUOABUCHNZUQUOABUDZUOABUETUPUTURVAUOABUFTDUOUSABUSUKUGABUSQQUHUIUJSS
      $.
  $}

  $( "Is homeomorph to" is symmetric.  (Contributed by FL, 22-Feb-2007.) $)
  hmphsymb $p |- ( J ~= K <-> K ~= J ) $=
    ( chmph wbr hmphsym impbii ) ABCDBACDABEBAEF $.

  ${
    $d f A $.  $d f J $.  $d f K $.
    haushmphlem.1 $e |- ( J e. A -> J e. Top ) $.
    haushmphlem.2 $e |- ( ( J e. A /\
      f : U. K -1-1-> U. J /\ f e. ( K Cn J ) ) -> K e. A ) $.
    $( Lemma for ~ haushmph and similar theorems.  If the topological property
       ` A ` is preserved under injective preimages, then property ` A ` is
       preserved under homeomorphisms.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    haushmphlem $p |- ( J ~= K -> ( J e. A -> K e. A ) ) $=
      ( chmph wbr wcel wi hmphsym chmeo co c0 wne cuni eqid adantl syl sylbi cv
      hmph wex n0 wa wf1 simpl wf1o hmeof1o f1of1 hmeocn syl3anc expcom exlimiv
      ccn ) CDGHDCGHZCAIZDAIZJZCDKUPDCLMZNOZUSDCUBVABUAZUTIZBUCUSBUTUDVCUSBUQVC
      URUQVCUEZUQDPZCPZVBUFZVBDCUOMIZURUQVCUGVDVEVFVBUHZVGVCVIUQVBDCVEVFVEQVFQU
      IRVEVFVBUJSVCVHUQVBDCUKRFULUMUNTTS $.
  $}

  ${
    $d f w x y J $.  $d f w x y z K $.
    $( Compactness is a topological property-that is, for any two homeomorphic
       topologies, either both are compact or neither is.  (Contributed by Jeff
       Hankins, 30-Jun-2009.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
    cmphmph $p |- ( J ~= K -> ( J e. Comp -> K e. Comp ) ) $=
      ( vf chmph wbr chmeo co c0 wne ccmp wcel wi hmph cv wex n0 cuni wfo sylbi
      eqid ccn wf1o hmeof1o f1ofo syl hmeocn cncmp 3expb expcom syl2anc exlimiv
      wa ) ABDEABFGZHIZAJKZBJKZLZABMUNCNZUMKZCOUQCUMPUSUQCUSAQZBQZURRZURABUAGKZ
      UQUSUTVAURUBVBURABUTVAUTTVATZUCUTVAURUDUEURABUFUOVBVCULUPUOVBVCUPURABUTVA
      VDUGUHUIUJUKSS $.

    $( Connectedness is a topological property.  (Contributed by Jeff Hankins,
       3-Jul-2009.) $)
    conhmph $p |- ( J ~= K -> ( J e. Con -> K e. Con ) ) $=
      ( vf chmph wbr chmeo co c0 wne ccon wcel wi hmph cv wex n0 cuni wfo sylbi
      eqid ccn wf1o hmeof1o f1ofo hmeocn wa cnconn 3expb expcom syl2anc exlimiv
      syl ) ABDEABFGZHIZAJKZBJKZLZABMUNCNZUMKZCOUQCUMPUSUQCUSAQZBQZURRZURABUAGK
      ZUQUSUTVAURUBVBURABUTVAUTTVATZUCUTVAURUDULURABUEUOVBVCUFUPUOVBVCUPURABUTV
      AVDUGUHUIUJUKSS $.

    $( T_0 is a topological property.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    t0hmph $p |- ( J ~= K -> ( J e. Kol2 -> K e. Kol2 ) ) $=
      ( vf ct0 t0top cv cuni cnt0 haushmphlem ) DCABAECFBABGAGHI $.

    $( T_1 is a topological property.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    t1hmph $p |- ( J ~= K -> ( J e. Fre -> K e. Fre ) ) $=
      ( vf ct1 t1top cv cuni cnt1 haushmphlem ) DCABAECFBABGAGHI $.

    $( Hausdorff-ness is a topological property.  (Contributed by Mario
       Carneiro, 25-Aug-2015.) $)
    haushmph $p |- ( J ~= K -> ( J e. Haus -> K e. Haus ) ) $=
      ( vf cha haustop cv cuni cnhaus haushmphlem ) DCABAECFBABGAGHI $.

    $( Regularity is a topological property.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    reghmph $p |- ( J ~= K -> ( J e. Reg -> K e. Reg ) ) $=
      ( vf vy vz vx vw co creg wcel cv wa ctop cfv wss cima adantr syl2anc wceq
      syl chmph wbr chmeo c0 wne wi hmph wex n0 ccl wrex wral ccn hmeocn adantl
      cntop2 ccnv simpll simprl cnima cuni wfn wf1o eqid hmeof1o ad2antlr f1ofn
      f1ocnv 3syl elssuni ad2antrl simprr fnfvima syl3anc regsep simpllr sseldd
      hmeoima simprrl elpreima mpbir2and imacnvcnv syl6eleq hmeocls simprrr cdm
      wb wfun f1ofun regtop clsss3 f1odm sseqtr4d funimass3 eqsstrd eleq2 fveq2
      mpbird sseq1d anbi12d rspcev syl12anc rexlimddv ralrimivva isreg sylanbrc
      expcom exlimiv sylbi ) ABUAUBABUCHZUDUEZAIJZBIJZUFZABUGXKCKZXJJZCUHXNCXJU
      IXPXNCXLXPXMXLXPLZBMJZDKZEKZJZXTBUJNZNZFKZOZLZEBUKZDYDULFBULXMXQXOABUMHJZ
      XRXPYHXLXOABUNUOZXOABUPTXQYGFDBYDXQYDBJZXSYDJZLZLZXSXOUQZNZGKZJZYPAUJNNZY
      NYDPZOZLZYGGAYMXLYSAJZYOYSJZUUAGAUKXLXPYLURZYMYHYJUUBXQYHYLYIQXQYJYKUSYDX
      OABUTRYMYNBVAZVBZYDUUEOZYKUUCYMAVAZUUEXOVCZUUEUUHYNVCUUFXPUUIXLYLXOABUUHU
      UEUUHVDZUUEVDVEVFZUUHUUEXOVHUUEUUHYNVGVIZYJUUGXQYKYDBVJVKZXQYJYKVLZUUEYDY
      NXSVMVNGYOYSAVOVNYMYPAJZUUALZLZXOYPPZBJZXSUURJZUURYBNZYDOZYGUUQXPUUOUUSXL
      XPYLUUPVPZYMUUOUUAUSYPXOABVRRUUQXSYNUQYPPZUURUUQXSUVDJZXSUUEJZYQYMUVFUUPY
      MYDUUEXSUUMUUNVQQYMUUOYQYTVSUUQUUFUVEUVFYQLWGYMUUFUUPUULQUUEXSYPYNVTTWAXO
      YPWBWCUUQUVAXOYRPZYDUUQXPYPUUHOZUVAUVGSUVCUUOUVHYMUUAYPAVJVKZYPXOABUUHUUJ
      WDRUUQUVGYDOZYTYMUUOYQYTWEUUQXOWHZYRXOWFZOUVJYTWGUUQUUIUVKYMUUIUUPUUKQZUU
      HUUEXOWITUUQYRUUHUVLUUQAMJZUVHYRUUHOUUQXLUVNYMXLUUPUUDQAWJTUVIYPAUUHUUJWK
      RUUQUUIUVLUUHSUVMUUHUUEXOWLTWMYRYDXOWNRWRWOYFUUTUVBLEUURBXTUURSZYAUUTYEUV
      BXTUURXSWPUVOYCUVAYDXTUURYBWQWSWTXAXBXCXDFDEBXEXFXGXHXIXI $.

    $( Normality is a topological property.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    nrmhmph $p |- ( J ~= K -> ( J e. Nrm -> K e. Nrm ) ) $=
      ( vf vy vz vx vw co cnrm wcel wi cv wa ctop wss cfv syl cima syl2anc wceq
      chmph wbr chmeo wne hmph wex ccl wrex ccld cpw cin wral ccn hmeocn adantl
      c0 n0 cntop2 simpll adantr simprl cnima inss1 simprr sseldi cnclima inss2
      ccnv elpwid imass2 nrmsep3 syl13anc simpllr hmeoima simprrl wfun crn cuni
      wf1o eqid hmeof1o f1ofun cldss wfo f1ofo forn 3syl sseqtr4d funimass1 mpd
      elssuni ad2antrl hmeocls simprrr cdm wb nrmtop ad3antrrr clsss3 funimass3
      f1odm mpbird eqsstrd sseq2 fveq2 sseq1d anbi12d rspcev syl12anc rexlimddv
      ralrimivva isnrm sylanbrc expcom exlimiv sylbi ) ABUAUBABUCHZUPUDZAIJZBIJ
      ZKZABUEXRCLZXQJZCUFYACXQUQYCYACXSYCXTXSYCMZBNJZDLZELZOZYGBUGPZPZFLZOZMZEB
      UHZDBUIPZYKUJZUKZULFBULXTYDYBABUMHJZYEYCYRXSYBABUNUOZYBABURQYDYNFDBYQYDYK
      BJZYFYQJZMZMZYBVHZYFRZGLZOZUUFAUGPPZUUDYKRZOZMZYNGAUUCXSUUIAJZUUEAUIPJZUU
      EUUIOZUUKGAUHXSYCUUBUSUUCYRYTUULYDYRUUBYSUTZYDYTUUAVAYKYBABVBSUUCYRYFYOJZ
      UUMUUOUUCYQYOYFYOYPVCYDYTUUAVDZVEZYFYBABVFSUUCYFYKOUUNUUCYFYKUUCYQYPYFYOY
      PVGUUQVEVIYFYKUUDVJQGUUIUUEAVKVLUUCUUFAJZUUKMZMZYBUUFRZBJZYFUVBOZUVBYIPZY
      KOZYNUVAYCUUSUVCXSYCUUBUUTVMZUUCUUSUUKVAUUFYBABVNSUVAUUGUVDUUCUUSUUGUUJVO
      UVAYBVPZYFYBVQZOUUGUVDKUVAAVRZBVRZYBVSZUVHUVAYCUVLUVGYBABUVJUVKUVJVTZUVKV
      TZWAQZUVJUVKYBWBQZUVAYFUVKUVIUVAUUPYFUVKOUUCUUPUUTUURUTYFBUVKUVNWCQUVAUVL
      UVJUVKYBWDUVIUVKTUVOUVJUVKYBWEUVJUVKYBWFWGWHYFUUFYBWISWJUVAUVEYBUUHRZYKUV
      AYCUUFUVJOZUVEUVQTUVGUUSUVRUUCUUKUUFAWKWLZUUFYBABUVJUVMWMSUVAUVQYKOZUUJUU
      CUUSUUGUUJWNUVAUVHUUHYBWOZOUVTUUJWPUVPUVAUUHUVJUWAUVAANJZUVRUUHUVJOXSUWBY
      CUUBUUTAWQWRUVSUUFAUVJUVMWSSUVAUVLUWAUVJTUVOUVJUVKYBXAQWHUUHYKYBWTSXBXCYM
      UVDUVFMEUVBBYGUVBTZYHUVDYLUVFYGUVBYFXDUWCYJUVEYKYGUVBYIXEXFXGXHXIXJXKFDEB
      XLXMXNXOXPXP $.
  $}

  $( A topology homeomorphic to the empty set is empty.  (Contributed by FL,
     18-Aug-2008.)  (Revised by Mario Carneiro, 10-Sep-2015.) $)
  hmph0 $p |- ( J ~= { (/) } <-> J = { (/) } ) $=
    ( c0 csn chmph wbr wceq c1o cen hmphen df1o2 syl6breqr ctop hmphtop1 en1top
    wcel wb syl mpbid id sn0top hmphref ax-mp syl6eqbr impbii ) ABCZDEZAUEFZUFA
    GHEZUGUFAUEGHAUEIJKUFALOUHUGPAUEMANQRUGAUEUEDUGSUELOUEUEDETUEUAUBUCUD $.

  ${
    $d f x A $.  $d f x J $.  $d f x X $.
    hmphdis.1 $e |- X = U. J $.
    $( Homeomorphisms preserve topological discretion.  (Contributed by Mario
       Carneiro, 10-Sep-2015.) $)
    hmphdis $p |- ( J ~= ~P A -> J = ~P X ) $=
      ( vf vx cpw chmph wbr wss cuni pwuni pweqi sseqtr4i a1i chmeo cv wcel cvv
      sylbi co c0 wne hmph wex n0 elpwi wa cima crn imassrn wf1o eqcomi hmeof1o
      wf unipw f1of frn 3syl adantr syl5ss vex imaexg ax-mp elpw sylibr hmeoopn
      mpbird ex syl5 ssrdv exlimiv eqssd ) BAGZHIZBCGZBVPJVOBBKZGVPBLCVQDMNOVOB
      VNPUAZUBUCZVPBJZBVNUDVSEQZVRRZEUEVTEVRUFWBVTEWBFVPBFQZVPRWCCJZWBWCBRZWCCU
      GWBWDWEWBWDUHZWEWAWCUIZVNRZWFWGAJWHWFWGWAUJZAWAWCUKWBWIAJZWDWBCAWAULCAWAU
      OWJWABVNCADVNKAAUPUMUNCAWAUQCAWAURUSUTVAWGAWASRWGSREVBWAWCSVCVDVEVFWCWABV
      NCDVGVHVIVJVKVLTTVM $.

    $( Homeomorphisms preserve topological indiscretion.  (Contributed by FL,
       18-Aug-2008.)  (Revised by Mario Carneiro, 10-Sep-2015.) $)
    hmphindis $p |- ( J ~= { (/) , A } -> J = { (/) , X } ) $=
      ( c0 cpr chmph wbr wceq cid cfv wa sylib cuni 0ex wne c2o cen cvv wcel wb
      csn dfsn2 indislem preq2 syl6eqr syl5eqr breq2d hmph0 unieqd unisn eqcomi
      biimpac 3eqtr4g preq2d 3eqtr4a hmphen adantr necom pr2nelem mp3an12 sylbi
      fvex adantl syl5eqbrr entr ctopon ctop hmphtop1 toptopon en2top syl mpbid
      syl2anc simpld pm2.61dane ) BEAFZGHZBECFZIZAJKZEVRWAEIZLZEUBZEEFZBVSEUCZW
      CBWDGHZBWDIWBVRWGWBVQWDBGWBVQEWAFZWDAUDZWBWHWEWDWAEEUEWFUFUGUHUMBUIMZWCCE
      EWCBNWDNZCEWCBWDWJUJDWKEEOUKULUNUOUPVRWAEPZLZVTCEPZWMBQRHZVTWNLZWMBVQRHZV
      QQRHWOVRWQWLBVQUQURWMVQWHQRWIWLWHQRHZVRWLEWAPZWRWAEUSESTWASTWSWROAJVCEWAS
      SUTVAVBVDVEBVQQVFVNWMBCVGKTZWOWPUAWMBVHTZWTVRXAWLBVQVIURBCDVJMBCVKVLVMVOV
      P $.
  $}

  ${
    $d A f x $.  $d B f x $.
    $( Equinumerous sets equipped with their indiscrete topologies are
       homeomorph (which means in that particular case that a segment is
       homeomorph to a circle contrary to what Wikipedia claims).  (Contributed
       by FL, 17-Aug-2008.)  (Proof shortened by Mario Carneiro,
       10-Sep-2015.) $)
    indishmph $p |- ( A ~~ B -> { (/) , A } ~= { (/) , B } ) $=
      ( vf wbr wf1o c0 cpr co wcel ccn cmap wf f1of cvv wb elmapg mpbird ctopon
      syl2anc syl cen cv wex chmph bren chmeo ccnv wfo cdm f1odm dmex syl6eqelr
      vex f1ofo fornex sylc cfv wceq indistopon eleqtrrd f1ocnv ishmeo sylanbrc
      cnindis hmphi exlimiv sylbi ) ABUADABCUBZEZCUCFAGZFBGZUDDZABCUEVIVLCVIVHV
      JVKUFHIZVLVIVHVJVKJHZIVHUGZVKVJJHZIVMVIVHBAKHZVNVIVHVQIZABVHLZABVHMVIBNIZ
      ANIZVRVSOVIWAABVHUHVTVIAVHUINABVHUJVHCUMUKULZABVHUNABNVHUOUPZWBBAVHNNPSQV
      IVJARUQIZVTVNVQURVIWAWDWBANUSTWCBVJNAVDSUTVIVOABKHZVPVIVOWEIZBAVOLZVIBAVO
      EWGABVHVABAVOMTVIWAVTWFWGOWBWCABVONNPSQVIVKBRUQIZWAVPWEURVIVTWHWCBNUSTWBA
      VKNBVDSUTVHVJVKVBVCVHVJVKVETVFVG $.
  $}

  ${
    $d x F $.  $d f x J $.  $d f x K $.  $d f x X $.  $d f x Y $.
    cmphaushmeo.1 $e |- X = U. J $.
    cmphaushmeo.2 $e |- Y = U. K $.
    $( Homeomorphisms preserve the cardinality of the underlying sets.
       (Contributed by FL, 17-Aug-2008.)  (Revised by Mario Carneiro,
       10-Sep-2015.) $)
    hmphen2 $p |- ( J ~= K -> X ~~ Y ) $=
      ( vf chmph wbr chmeo co c0 wne cen hmph cv wcel wex n0 sylbi wf1o hmeof1o
      f1oen3g mpdan exlimiv ) ABHIABJKZLMZCDNIZABOUGGPZUFQZGRUHGUFSUJUHGUJCDUIU
      AUHUIABCDEFUBCDUIUFUCUDUETT $.

    $( A continuous bijection from a compact space to a Hausdorff space is a
       homeomorphism.  (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    cmphaushmeo $p |- ( ( J e. Comp /\ K e. Haus /\ F e. ( J Cn K ) ) ->
      ( F e. ( J Homeo K ) <-> F : X -1-1-onto-> Y ) ) $=
      ( vx ccmp wcel ccn co wf1o ccnv wa cima cfv syl sylib syl2anc cha hmeof1o
      w3a chmeo wf cv ccld wral wi f1ocnv f1of wrel wceq f1orel ad2antll dfrel2
      a1i imaeq1d wss crest simp2 adantr crn imassrn f1ofo forn syl5sseq simpl3
      wfo simp1 simprl cmpcld imacmp hauscmp syl3anc expr ralrimdva jcad ctopon
      eqeltrd ctop haustop toptopon cmptop iscncl sylibrd jctild ishmeo syl6ibr
      wb simp3 impbid2 ) BIJZCUAJZABCKLJZUCZABCUDLJZDEAMZABCDEFGUBWPWRWOANZCBKL
      JZOWQWPWRWTWOWPWREDWSUEZWSNZHUFZPZCUGQZJZHBUGQZUHZOZWTWPWRXAXHWRXAUIWPWRE
      DWSMXADEAUJEDWSUKRUQWPWRXFHXGWPXCXGJZWRXFWPXJWROZOZXDAXCPZXEXLXBAXCXLAULZ
      XBAUMWRXNWPXJDEAUNUOAUPSURXLWNXMEUSCXMUTLIJZXMXEJWPWNXKWMWNWOVAZVBXLAVCZX
      MEAXCVDXLDEAVIZXQEUMWRXRWPXJDEAVEUODEAVFRVGXLWOBXCUTLIJZXOWMWNWOXKVHXLWMX
      JXSWPWMXKWMWNWOVJZVBWPXJWRVKXCBVLTXCABCVMTXMCEGVNVOVTVPVQVRWPCEVSQJZBDVSQ
      JZWTXIWJWPCWAJZYAWPWNYCXPCWBRCEGWCSWPBWAJZYBWPWMYDXTBWDRBDFWCSHWSCBEDWETW
      FWMWNWOWKWGABCWHWIWL $.
  $}

  ${
    $d x y z F $.  $d x z R $.  $d x y z S $.  $d x z V $.  $d x y z Y $.
    $d x z W $.  $d x z X $.
    ordthmeo.1 $e |- X = dom R $.
    ordthmeo.2 $e |- Y = dom S $.
    $( Lemma for ~ ordthmeo .  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    ordthmeolem $p |- ( ( R e. V /\ S e. W /\ F Isom R , S ( X , Y ) ) ->
      F e. ( ( ordTop ` R ) Cn ( ordTop ` S ) ) ) $=
      ( vz vx vy wcel cfv wbr wral syl wceq wb cvv wiso w3a cordt co wf ccnv cv
      ccn cima csn wn crab cmpt crn wf1o isof1o 3ad2ant3 f1of fimacnv ordttopon
      ctopon 3ad2ant1 toponmax eqeltrd elsni imaeq2d eleq1d syl5ibrcom ralrimiv
      cun cin wss cdm cnvimass f1odm adantr syl5sseq dfss1 sylib ad2antrr f1ofn
      wfn elpreima simpr biantrurd ffvelrnda breq1 notbid elrab3 simpll3 f1ocnv
      3syl isorel syl12anc f1ocnvfv2 sylan breq2d bitrd bitr4d rabbi2dva eqtr3d
      3bitr2d simpl1 ordtopn1 syl2anc ralrimiva dmexg syl5eqel rabexg ralrimivw
      wa 3ad2ant2 eqid imaeq2 ralrnmpt mpbird breq2 breq1d ordtopn2 ralunb cuni
      sylanbrc ordtuni eqeltrrd uniexb sylibr cfi ordtval subbascn mpbir2and
      ctg ) ADMZBEMZFGABCUAZUBZCAUCNZBUCNZUHUDMFGCUEZCUFZJUGZUIZYPMZJGUJZKGLUGZ
      KUGZBOZUKZLGULZUMZUNZKGUUEUUDBOZUKZLGULZUMZUNZVJZVJZPZYOFGCUOZYRYNYLUUSYM
      FGABCUPUQZFGCURQZYOUUBJUUCPUUBJUUPPZUURYOUUBJUUCYOUUBYTUUCMZYSGUIZYPMYOUV
      DFYPYOYRUVDFRUVAFGCUSQYOYPFVANMZFYPMYLYMUVEYNADFHUTVBZFYPVCQVDUVCUUAUVDYP
      UVCYTGYSYTGVEVFVGVHVIYOUUBJUUJPZUUBJUUOPZUVBYOUVGYSUUHUIZYPMZKGPZYOUVJKGY
      OUUEGMZXKZUVIYTUUEYSNZAOZUKZJFULZYPUVMFUVIVKZUVIUVQUVMUVIFVLUVRUVIRUVMCVM
      ZUVIFCUUHVNYOUVSFRZUVLYOUUSUVTUUTFGCVOQVPZVQUVIFVRVSUVMUVPJFUVIUVMYTFMZXK
      ZYTUVIMZUWBYTCNZUUHMZXKZUWFUVPUWCCFWBZUWDUWGSUWCUUSUWHYOUUSUVLUWBUUTVTFGC
      WAQZFYTUUHCWCQUWCUWBUWFUVMUWBWDZWEUWCUWFUWEUUEBOZUKZUVPUWCUWEGMZUWFUWLSUV
      MFGYTCYOYRUVLUVAVPWFZUUGUWLLUWEGUUDUWERZUUFUWKUUDUWEUUEBWGWHWIQUWCUVOUWKU
      WCUVOUWEUVNCNZBOZUWKUWCYNUWBUVNFMZUVOUWQSYLYMYNUVLUWBWJZUWJUVMUWRUWBYOGFU
      UEYSYOUUSGFYSUOGFYSUEUUTFGCWKGFYSURWLWFZVPZFGYTUVNABCWMWNUWCUWPUUEUWEBUVM
      UWPUUERZUWBYOUUSUVLUXBUUTFGUUECWOWPVPZWQWRWHWSXBWTXAUVMYLUWRUVQYPMYLYMYNU
      VLXCZUWTJUVNADFHXDXEVDXFYOUUHTMZKGPUVGUVKSYOUXEKGYOGTMZUXEYMYLUXFYNYMGBVM
      TIBEXGXHZXLZUUGLGTXIQXJUUBUVJKJGUUHUUITUUIXMYTUUHRUUAUVIYPYTUUHYSXNVGXOQX
      PYOUVHYSUUMUIZYPMZKGPZYOUXJKGUVMUXIUVNYTAOZUKZJFULZYPUVMFUXIVKZUXIUXNUVMU
      XIFVLUXOUXIRUVMUVSUXIFCUUMVNUWAVQUXIFVRVSUVMUXMJFUXIUWCYTUXIMZUWBUWEUUMMZ
      XKZUXQUXMUWCUWHUXPUXRSUWIFYTUUMCWCQUWCUWBUXQUWJWEUWCUXQUUEUWEBOZUKZUXMUWC
      UWMUXQUXTSUWNUULUXTLUWEGUWOUUKUXSUUDUWEUUEBXQWHWIQUWCUXLUXSUWCUXLUWPUWEBO
      ZUXSUWCYNUWRUWBUXLUYASUWSUXAUWJFGUVNYTABCWMWNUWCUWPUUEUWEBUXCXRWRWHWSXBWT
      XAUVMYLUWRUXNYPMUXDUWTJUVNADFHXSXEVDXFYOUUMTMZKGPUVHUXKSYOUYBKGYOUXFUYBUX
      HUULLGTXIQXJUUBUXJKJGUUMUUNTUUNXMYTUUMRUUAUXIYPYTUUMYSXNVGXOQXPUUBJUUJUUO
      XTYBUUBJUUCUUPXTYBYOJUUQCYPYQTFGUVFYMYLUUQTMZYNYMUUQYAZTMUYCYMGUYDTKLUUJU
      UOBEGIUUJXMZUUOXMZYCUXGYDUUQYEYFXLYMYLYQUUQYGNYKNRYNKLUUJUUOBEGIUYEUYFYHX
      LYMYLYQGVANMYNBEGIUTXLYIYJ $.

    $( An order isomorphism is a homeomorphism on the respective order
       topologies.  (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    ordthmeo $p |- ( ( R e. V /\ S e. W /\ F Isom R , S ( X , Y ) ) ->
      F e. ( ( ordTop ` R ) Homeo ( ordTop ` S ) ) ) $=
      ( wcel wiso w3a cordt cfv ccn co ccnv chmeo ordthmeolem isocnv sylanbrc
      3com12 syl3an3 ishmeo ) ADJZBEJZFGABCKZLCAMNZBMNZOPJCQZUIUHOPJZCUHUIRPJAB
      CDEFGHISUGUEUFGFBAUJKZUKFGABCTUFUEULUKBAUJEDGFIHSUBUCCUHUIUDUA $.
  $}

  ${
    $d u v w x y z F $.  $d w x y z J $.  $d w x y z K $.  $d u v w x y z ph $.
    $d u v w x y z G $.  $d u v w x y z L $.  $d u v x y X $.  $d u v x y Y $.
    $d u v w x y z M $.
    txhmeo.1 $e |- X = U. J $.
    txhmeo.2 $e |- Y = U. K $.
    txhmeo.3 $e |- ( ph -> F e. ( J Homeo L ) ) $.
    txhmeo.4 $e |- ( ph -> G e. ( K Homeo M ) ) $.
    $( Lift a pair of homeomorphisms on the factors to a homeomorphism of
       product topologies.  (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    txhmeo $p |- ( ph -> ( x e. X , y e. Y |-> <. ( F ` x ) , ( G ` y ) >. ) e.
                         ( ( J tX K ) Homeo ( L tX M ) ) ) $=
      ( cfv co wcel syl wceq vz vw vv vu cv cop cmpt2 ctx ccn ccnv chmeo ctopon
      ctop hmeocn cntop1 toptopon sylib cnmpt1st cnmpt21f cnmpt2nd cnmpt2t cuni
      cxp c1st c2nd cmpt wf1o op1std fveq2d op2ndd opeq12d mpt2mpt eqcomi wa wf
      vex eqid cnf xp1st ffvelrn syl2an xp2nd opelxpi syl2anc hmeof1o f1of 3syl
      f1ocnv wb adantr ad2antrl ad2antll f1ocnvfvb syl3anc 3bitr4g anbi12d eqop
      3bitr4rd f1ocnv2d simprd syl6eq cntop2 hmeocnvcn eqeltrd ishmeo sylanbrc
      eqcom ) ABCJKBUEZDPZCUEZEPZUFZUGZFGUHQZHIUHQZUIQRXMUJZXOXNUIQZRXMXNXOUKQR
      ABCXIXKFGHIJKAFUMRZFJULPRADFHUIQRZXRADFHUKQRZXSNDFHUNSZDFHUOSFJLUPUQZAGUM
      RZGKULPRAEGIUIQRZYCAEGIUKQRZYDOEGIUNSZEGIUOSGKMUPUQZABCXHDFGFHJKYBYGABCFG
      JKYBYGURYAUSABCXJEFGGIJKYBYGABCFGJKYBYGUTYFUSVAAXPUAUBHVBZIVBZUAUEZDUJZPZ
      UBUEZEUJZPZUFZUGZXQAXPUCYHYIVCZUCUEZVDPZYKPZYSVEPZYNPZUFZVFZYQAJKVCZYRXMV
      GXPUUETAUDUCUUFYRUDUEZVDPZDPZUUGVEPZEPZUFZUUDXMUDUUFUULVFXMBCUDJKUULXLUUG
      XHXJUFTZUUIXIUUKXKUUMUUHXHDXHXJUUGBVPZCVPZVHVIUUMUUJXJEXHXJUUGUUNUUOVJVIV
      KVLVMAUUGUUFRZVNUUIYHRZUUKYIRZUULYRRAJYHDVOZUUHJRZUUQUUPAXSUUSYADFHJYHLYH
      VQZVRSUUGJKVSZJYHUUHDVTWAAKYIEVOZUUJKRZUURUUPAYDUVCYFEGIKYIMYIVQZVRSUUGJK
      WBZKYIUUJEVTWAUUIUUKYHYIWCWDAYSYRRZVNUUAJRZUUCKRZUUDUUFRAYHJYKVOZYTYHRZUV
      HUVGAJYHDVGZYHJYKVGUVJAXTUVLNDFHJYHLUVAWESZJYHDWHYHJYKWFWGYSYHYIVSZYHJYTY
      KVTWAAYIKYNVOZUUBYIRZUVIUVGAKYIEVGZYIKYNVGUVOAYEUVQOEGIKYIMUVEWESZKYIEWHY
      IKYNWFWGYSYHYIWBZYIKUUBYNVTWAUUAUUCJKWCWDAUUPUVGVNZVNZYTUUITZUUBUUKTZVNZU
      UHUUATZUUJUUCTZVNZYSUULTZUUGUUDTZUWAUWBUWEUWCUWFUWAUUIYTTZUUAUUHTZUWBUWEU
      WAUVLUUTUVKUWJUWKWIAUVLUVTUVMWJUUPUUTAUVGUVBWKUVGUVKAUUPUVNWLJYHUUHYTDWMW
      NYTUUIXGUUHUUAXGWOUWAUUKUUBTZUUCUUJTZUWCUWFUWAUVQUVDUVPUWLUWMWIAUVQUVTUVR
      WJUUPUVDAUVGUVFWKUVGUVPAUUPUVSWLKYIUUJUUBEWMWNUUBUUKXGUUJUUCXGWOWPUVGUWHU
      WDWIAUUPYSUUIUUKYHYIWQWLUUPUWIUWGWIAUVGUUGUUAUUCJKWQWKWRWSWTUAUBUCYHYIUUD
      YPYSYJYMUFTZUUAYLUUCYOUWNYTYJYKYJYMYSUAVPZUBVPZVHVIUWNUUBYMYNYJYMYSUWOUWP
      VJVIVKVLXAAUAUBYLYOHIFGYHYIAHUMRZHYHULPRAXSUWQYADFHXBSHYHUVAUPUQZAIUMRZIY
      IULPRAYDUWSYFEGIXBSIYIUVEUPUQZAUAUBYJYKHIHFYHYIUWRUWTAUAUBHIYHYIUWRUWTURA
      XTYKHFUIQRNDFHXCSUSAUAUBYMYNHIIGYHYIUWRUWTAUAUBHIYHYIUWRUWTUTAYEYNIGUIQRO
      EGIXCSUSVAXDXMXNXOXEXF $.
  $}

  ${
    $d x y J $.  $d x y K $.  $d x y z X $.  $d x y z Y $.
    $( Show inverse for the "swap components" operation on a cross product.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    txswaphmeolem $p |- ( ( y e. Y , x e. X |-> <. x , y >. ) o.
        ( x e. X , y e. Y |-> <. y , x >. ) ) = ( _I |` ( X X. Y ) ) $=
      ( vz cv cop cmpt2 ccom cxp cmpt cid cres wceq wtru ccnv cuni wcel mpt2mpt
      csn wa opelxpi ancoms adantl eqidd cnveqd unieqd opswap syl6eq eqcomi a1i
      sneq fmpt2co trud id mptresid 3eqtr2i ) BADCAFZBFZGZHZABCDUSURGZHZIZABCDU
      THZECDJZEFZKLVFMVDVENOABECDDCJZVBVGTZPZQZUTVCVAURCRZUSDRZUAVBVHRZOVMVLVNU
      SURDCUBUCUDOVCUEVAEVHVKKZNOVOVABAEDCVKUTVGVBNZVKVBTZPZQUTVPVJVRVPVIVQVGVB
      ULUFUGUSURUHUIZSUJUKVSUMUNABECDVGUTVGUTNUOSEVFUPUQ $.

    $( There is a homeomorphism from ` X X. Y ` to ` Y X. X ` .  (Contributed
       by Mario Carneiro, 21-Mar-2015.) $)
    txswaphmeo $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
    ( x e. X , y e. Y |-> <. y , x >. ) e. ( ( J tX K ) Homeo ( K tX J ) ) ) $=
      ( ctopon cfv wcel wa cv cop cmpt2 ctx co ccn cnmpt2nd cnmpt1st wceq wral
      ccnv chmeo simpl simpr cnmpt2t cxp wf1o wf opelxpi ancoms ralrimivva eqid
      adantl fmpt2 sylib ccom cres txswaphmeolem fcof1o mpanr12 syl2anc eqeltrd
      cid simprd ishmeo sylanbrc ) CEGHIZDFGHIZJZABEFBKZAKZLZMZCDNOZDCNOZPOIVMU
      AZVOVNPOZIVMVNVOUBOIVIABVJVKCDDCEFVGVHUCZVGVHUDZVIABCDEFVRVSQVIABCDEFVRVS
      RUEVIVPBAFEVKVJLZMZVQVIEFUFZFEUFZVMUGZVPWASZVIWBWCVMUHZWCWBWAUHZWDWEJZVIV
      LWCIZBFTAETWFVIWIABEFVKEIZVJFIZJWIVIWKWJWIVJVKFEUIUJUMUKABEFVLWCVMVMULUNU
      OVIVTWBIZAETBFTWGVIWLBAFEWKWJJWLVIWJWKWLVKVJEFUIUJUMUKBAFEVTWBWAWAULUNUOW
      FWGJVMWAUPVCWCUQSWAVMUPVCWBUQSWHBAFEURABEFURWBWCVMWAUSUTVAVDVIBAVKVJDCCDF
      EVSVRVIBADCFEVSVRQVIBADCFEVSVRRUEVBVMVNVOVEVF $.
  $}

  ${
    $d k x y A $.  $d k x y J $.  $d x y K $.  $d k x y ph $.  $d k x y X $.
    pt1hmeo.j $e |- K = ( Xt_ ` { <. A , J >. } ) $.
    pt1hmeo.a $e |- ( ph -> A e. V ) $.
    pt1hmeo.r $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    $( The canonical homeomorphism from a topological product on a singleton to
       the topology of the factor.  (Contributed by Mario Carneiro,
       3-Feb-2015.) $)
    pt1hmeo $p |- ( ph -> ( x e. X |-> { <. A , x >. } ) e. ( J Homeo K ) ) $=
      ( vk vy csn ccn co wcel wa wceq adantr cfv cv cop cmpt ccnv cxp fconstmpt
      chmeo sneq xpeq1d opeq1 eqeq12d vex xpsn vtoclg syl syl5eqr mpteq2dva cvv
      sneqd snex a1i wf ctop wss wf1o ctopon f1osng syl2anc f1of topontop snssd
      fss cnmptid elsni fveq2d fvsng sylan9eqr eleqtrrd ptcn eqeltrrd cuni cmap
      oveq2d copab simprr adantrr eqtr4d simprl eqid wb toponmax elmapg sylancl
      fmptd mpbird fveq1d eqtr2d jca mpbid snidg ffvelrnd feq2d fveq2 eleq1d id
      eqeltrd opeq12d eqeq2d anbi12d fsn2 vtoclbg simprd opeq2d opabbidv df-mpt
      impbida cnveqi cnvopab eqtri 3eqtr4g cpt xpsng eqcomd syl5eq pttoponconst
      toponuni mpteq1d eqtrd ptpjcn syl3anc eleqtrd ishmeo sylanbrc ) ABGCBUAZU
      BZMZUCZDENOZPYQUDZEDNOZPYQDEUGOPABGKCMZYNUCZUCYQYRABGUUBYPAYNGPZQZUUBUUAY
      NMZUEZYPKUUAYNUFUUDCFPZUUFYPRZAUUGUUCISKUAZMZUUEUEZUUIYNUBZMZRUUHKCFUUICR
      ZUUKUUFUUMYPUUNUUJUUAUUEUUICUHZUIUUNUULYOUUICYNUJUSUKUUIYNKULZBULUMUNUOUP
      ZUQABYNKCDUBMZUUADEURGHJUUAURPZACUTZVAZAUUADMZUURVBZUVBVCVDUUAVCUURVBZAUU
      AUVBUURVEZUVCAUUGDGVFTZPZUVEIJCDFUVFVGVHUUAUVBUURVIUOADVCAUVGDVCPJGDVJUOV
      KUUAUVBVCUURVLVHZAUUIUUAPZQZBGYNUCZDDNOZDUUIUURTZNOAUVKUVLPUVIABDGJVMSUVJ
      UVMDDNUVIAUVMCUURTZDUVIUUICUURUUICVNVOAUUGUVGUVNDRIJCDFUVFVPVHZVQWCVRVSVT
      AYSLEWAZCLUAZTZUCZYTAYSLGUUAWBOZUVRUCZUVSAUUCUVQYPRZQZLBWDZUVQUVTPZYNUVRR
      ZQZLBWDYSUWAAUWCUWGLBAUWCUWGAUWCQZUWEUWFUWHUVQUUBUVTUWHUVQYPUUBAUUCUWBWEZ
      AUUCUUBYPRUWBUUQWFWGUWHUUBUVTPZUUAGUUBVBZUWHKUUAYNGUUBUWHUUCUVIAUUCUWBWHZ
      SUUBWIWNUWHGDPZUUSUWJUWKWJAUWMUWCAUVGUWMJGDWKUOZSUUTGUUAUUBDURWLWMWOXFUWH
      UVRCYPTZYNUWHCUVQYPUWIWPUWHUUGUUCUWOYNRAUUGUWCISUWLCYNFGVPVHWQWRAUWGQZUUC
      UWBUWPYNUVRGAUWEUWFWEZUWPUUAGCUVQUWPUWEUUAGUVQVBZAUWEUWFWHUWPUWMUUSUWEUWR
      WJAUWMUWGUWNSUUTGUUAUVQDURWLWMWSZACUUAPZUWGAUUGUWTICFWTUOZSXAXFUWPUVQCUVR
      UBZMZYPUWPUVRGPZUVQUXCRZUWPUWRUXDUXEQZUWSUWPUUGUWRUXFWJAUUGUWGISUUJGUVQVB
      UUIUVQTZGPZUVQUUIUXGUBZMZRZQUWRUXFKCFUUNUUJUUAGUVQUUOXBUUNUXHUXDUXKUXEUUN
      UXGUVRGUUICUVQXCZXDUUNUXJUXCUVQUUNUXIUXBUUNUUICUXGUVRUUNXEUXLXGUSXHXIUUIG
      UVQUUPXJXKUOWSXLUWPYOUXBUWPYNUVRCUWQXMUSWGWRXPXNYSUWCBLWDZUDUWDYQUXMBLGYP
      XOXQUWCBLXRXSLBUVTUVRXOXTALUVTUVPUVRAEUVTVFTZPUVTUVPRAEUUAUVBUEZYATZUXNAE
      UURYATUXPHAUURUXOYAAUXOUURAUUGUVGUXOUURRIJCDFUVFYBVHYCVOYDAUUSUVGUXPUXNPU
      VAJUUADUXPURGUXPWIYEVHXFUVTEYFUOYGYHAUVSEUVNNOZYTAUUSUVDUWTUVSUXQPUVAUVHU
      XALUUAUURCEURUVPUVPWIHYIYJAUVNDENUVOWCYKXFYQDEYLYM $.
  $}

  ${
    $d f k n w x y z A $.  $d f k n w x y z B $.  $d z G $.  $d k w x y z ph $.
    $d k n x y z C $.  $d f k n x y z F $.  $d w x y z J $.  $d f k x y z K $.
    $d f k x y z L $.  $d k z V $.  $d f k w x y z X $.  $d f k w x y z Y $.
    ptunhmeo.x $e |- X = U. K $.
    ptunhmeo.y $e |- Y = U. L $.
    ptunhmeo.j $e |- J = ( Xt_ ` F ) $.
    ptunhmeo.k $e |- K = ( Xt_ ` ( F |` A ) ) $.
    ptunhmeo.l $e |- L = ( Xt_ ` ( F |` B ) ) $.
    ptunhmeo.g $e |- G = ( x e. X , y e. Y |-> ( x u. y ) ) $.
    ptunhmeo.c $e |- ( ph -> C e. V ) $.
    ptunhmeo.f $e |- ( ph -> F : C --> Top ) $.
    ptunhmeo.u $e |- ( ph -> C = ( A u. B ) ) $.
    ptunhmeo.i $e |- ( ph -> ( A i^i B ) = (/) ) $.
    $( Exhibit the converse function of the map ` G ` which joins two product
       topologies on disjoint index sets.  (Contributed by Mario Carneiro,
       8-Feb-2015.)  (Proof shortened by Mario Carneiro, 23-Aug-2015.) $)
    ptuncnv $p |- ( ph ->
      `' G = ( z e. U. J |-> <. ( z |` A ) , ( z |` B ) >. ) ) $=
      ( vw vk cxp cuni wf1o ccnv cres cop cmpt wceq c1st cfv c2nd cun cmpt2 vex
      cv op1std op2ndd uneq12d mpt2mpt eqtr4i wcel cixp wss xp1st adantl ixpeq2
      wa cdif fvres unieqd mprg cvv ctop wf ssun1 syl5sseqr ssexd syl2anc ptuni
      fssres syl5eqr syl6eqr adantr eleqtrrd xp2nd eqcomd c0 wb uneqdifeq mpbid
      ixpeq1d ssun2 undifixp syl3anc eleqtrd eleq2d biimpar resixp opelxpi eqop
      cin eqtrd ad2antrl wfn adantrl fnresdm 3syl reseq2d eqtr3d resundi syl6eq
      ixpfn uneq12 eqeq2d syl5ibrcom syl adantrr dffn2 res0 3eqtr4a fresaunres1
      sylib fresaunres2 jca reseq1 anbi12d impbid bitrd f1ocnv2d simprd ) ANOUH
      ZJUIZIUJIUKDYSDVBZEULZYTFULZUMZUNUOAUFDYRYSUFVBZUPUQZUUDURUQZUSZUUCIIBCNO
      BVBZCVBZUSZUTUFYRUUGUNUABCUFNOUUGUUJUUDUUHUUIUMUOUUEUUHUUFUUIUUHUUIUUDBVA
      ZCVAZVCUUHUUIUUDUUKUULVDVEVFVGAUUDYRVHZVNZUUGUGGUGVBZHUQZUIZVIZYSUUNUUEUG
      EUUQVIZVHZUUFUGGEVOZUUQVIZVHEGVJZUUGUURVHUUNUUENUUSUUMUUENVHAUUDNOVKVLAUU
      SNUOZUUMAUUSKUIZNAUUSUGEUUOHEULZUQZUIZVIZUVEUVHUUQUOUVIUUSUOUGEUGEUVHUUQV
      MUUOEVHUVGUUPUUOEHVPVQVRAEVSVHEVTUVFWAZUVIUVEUOAEGMUBAEFUSZEGEFWBUDWCZWDA
      GVTHWAZUVCUVJUCUVLGVTEHWGWEUGEUVFKVSSWFWEWHPWIZWJWKZUUNUUFOUVBUUMUUFOVHAU
      UDNOWLVLZAUVBOUOUUMAUVBUGFUUQVIZOAUGUVAFUUQAUVKGUOZUVAFUOZAGUVKUDWMAUVCEF
      XHZWNUOZUVRUVSWOUVLUEEFGWPWEWQWRAUVQLUIZOAUVQUGFUUOHFULZUQZUIZVIZUWBUWEUU
      QUOUWFUVQUOUGFUGFUWEUUQVMUUOFVHUWDUUPUUOFHVPVQVRAFVSVHFVTUWCWAZUWFUWBUOAF
      GMUBAUVKFGFEWSUDWCZWDAUVMFGVJZUWGUCUWHGVTFHWGWEUGFUWCLVSTWFWEWHQWIZXIWJWK
      AUVCUUMUVLWJUGGEUUQUUEUUFWTXAAUURYSUOZUUMAGMVHUVMUWKUBUCUGGHJMRWFWEZWJXBA
      YTYSVHZVNZUUANVHUUBOVHUUCYRVHUWNUUAUUSNUWNUVCYTUURVHZUUAUUSVHAUVCUWMUVLWJ
      AUWOUWMAUURYSYTUWLXCXDZUGGEUUQYTXEWEAUVDUWMUVNWJXBUWNUUBUVQOUWNUWIUWOUUBU
      VQVHAUWIUWMUWHWJUWPUGGFUUQYTXEWEAUVQOUOZUWMUWJWJXBUUAUUBNOXFWEAUUMUWMVNZV
      NZUUDUUCUOZUUEUUAUOZUUFUUBUOZVNZYTUUGUOZUUMUWTUXCWOAUWMUUDUUAUUBNOXGXJUWS
      UXCUXDUWSUXDUXCYTUUAUUBUSZUOUWSYTYTUVKULZUXEUWSYTGULZYTUXFUWSUWOYTGXKUXGY
      TUOAUWMUWOUUMUWPXLUGGUUQYTXSGYTXMXNAUXGUXFUOUWRAGUVKYTUDXOWJXPYTEFXQXRUXC
      UUGUXEYTUUEUUAUUFUUBXTYAYBUWSUXCUXDUUEUUGEULZUOZUUFUUGFULZUOZVNUWSUXIUXKU
      WSUXHUUEUWSEVSUUEWAZFVSUUFWAZUUEUVTULZUUFUVTULZUOZUXHUUEUOUWSUUEEXKZUXLAU
      UMUXQUWMUUNUUTUXQUVOUGEUUQUUEXSYCYDEUUEYEYIZUWSUUFFXKZUXMAUUMUXSUWMUUNUUF
      UVQVHUXSUUNUUFOUVQUVPAUWQUUMUWJWJWKUGFUUQUUFXSYCYDFUUFYEYIZUWSUUEWNULZUUF
      WNULZUXNUXOUYAWNUYBUUEYFUUFYFVGUWSUVTWNUUEAUWAUWRUEWJZXOUWSUVTWNUUFUYCXOY
      GZEFVSUUEUUFYHXAWMUWSUXJUUFUWSUXLUXMUXPUXJUUFUOUXRUXTUYDEFVSUUEUUFYJXAWMY
      KUXDUXAUXIUXBUXKUXDUUAUXHUUEYTUUGEYLYAUXDUUBUXJUUFYTUUGFYLYAYMYBYNYOYPYQ
      $.

    $( Define a homeomorphism from a binary product of indexed product
       topologies to an indexed product topology on the union of the index
       sets.  This is the topological analogue of
       ` ( A ^ B ) x. ( A ^ C ) = A ^ ( B + C ) ` .  (Contributed by Mario
       Carneiro, 8-Feb-2015.)  (Proof shortened by Mario Carneiro,
       23-Aug-2015.) $)
    ptunhmeo $p |- ( ph -> G e. ( ( K tX L ) Homeo J ) ) $=
      ( vz vk vn vf ctx co ccn wcel ccnv chmeo cxp c1st cfv c2nd cun cmpt cmpt2
      cv cop wceq vex op1std op2ndd uneq12d mpt2mpt eqtr4i wa wfn cuni cixp wss
      cdif xp1st adantl cres ixpeq2 fvres unieqd mprg cvv ssun1 syl5sseqr ssexd
      ctop wf fssres syl2anc ptuni syl5eqr syl6eqr adantr eleqtrrd xp2nd eqcomd
      c0 uneqdifeq mpbid ixpeq1d ssun2 eqtrd undifixp syl3anc ixpfn dffn5 sylib
      cin wb syl mpteq2dva syl5eq ctopon cpt pttop syl5eqel toptopon txtopon wo
      eleq2d biimpa elun adantlr ad2antrr simplr fvun1 syl112anc cnmpt1st simpr
      ptpjcn oveq2d eleqtrd fveq1 cnmpt11 eqeltrd fvun2 cnmpt2nd ptrescn jaodan
      syldan ptcn ptuncnv eqid cnmpt1t ishmeo sylanbrc ) AHJKUIUJZIUKUJZULHUMZI
      UUIUKUJZULHUUIIUNUJULAHUEMNUOZUFFUFVBZUEVBZUPUQZUUOURUQZUSZUQZUTZUTZUUJAH
      UEUUMUURUTZUVAHBCMNBVBZCVBZUSZVAUVBTBCUEMNUURUVEUUOUVCUVDVCVDUUPUVCUUQUVD
      UVCUVDUUOBVEZCVEZVFZUVCUVDUUOUVFUVGVGZVHVIVJAUEUUMUURUUTAUUOUUMULZVKZUURF
      VLZUURUUTVDUVKUURUGFUGVBZGUQZVMZVNULZUVLUVKUUPUGDUVOVNZULZUUQUGFDVPZUVOVN
      ZULDFVOZUVPUVKUUPMUVQUVJUUPMULAUUOMNVQVRAUVQMVDUVJAUVQJVMZMAUVQUGDUVMGDVS
      ZUQZVMZVNZUWBUWEUVOVDUWFUVQVDUGDUGDUWEUVOVTUVMDULUWDUVNUVMDGWAWBWCADWDULZ
      DWHUWCWIZUWFUWBVDADFLUAADEUSZDFDEWEUCWFZWGZAFWHGWIZUWAUWHUBUWJFWHDGWJWKZU
      GDUWCJWDRWLWKWMOWNWOWPZUVKUUQNUVTUVJUUQNULAUUOMNWQVRZAUVTNVDUVJAUVTUGEUVO
      VNZNAUGUVSEUVOAUWIFVDZUVSEVDZAFUWIUCWRAUWADEXJWSVDZUWQUWRXKUWJUDDEFWTWKXA
      XBAUWPKVMZNAUWPUGEUVMGEVSZUQZVMZVNZUWTUXCUVOVDUXDUWPVDUGEUGEUXCUVOVTUVMEU
      LUXBUVNUVMEGWAWBWCAEWDULZEWHUXAWIZUXDUWTVDAEFLUAAUWIEFEDXCUCWFZWGZAUWLEFV
      OZUXFUBUXGFWHEGWJWKZUGEUXAKWDSWLWKWMPWNZXDWOWPAUWAUVJUWJWOUGFDUVOUUPUUQXE
      XFUGFUVOUURXGXLUFFUURXHXIXMXNAUEUUSUFGFUUIILUUMQAJMXOUQULZKNXOUQULZUUIUUM
      XOUQULZAJWHULUXLAJUWCXPUQZWHRAUWGUWHUXOWHULUWKUWMDUWCWDXQWKXRJMOXSXIZAKWH
      ULUXMAKUXAXPUQZWHSAUXEUXFUXQWHULUXHUXJEUXAWDXQWKXRKNPXSXIZJKMNXTWKZUAUBAU
      UNFULZUUNDULZUUNEULZYAZUEUUMUUSUTZUUIUUNGUQZUKUJZULZAUXTVKUUNUWIULZUYCAUX
      TUYHAFUWIUUNUCYBYCUUNDEYDXIAUYAUYGUYBAUYAVKZUYDUEUUMUUNUUPUQZUTUYFUYIUEUU
      MUUSUYJUYIUVJVKUUPDVLZUUQEVLZUWSUYAUUSUYJVDAUVJUYKUYAUVKUVRUYKUWNUGDUVOUU
      PXGXLZYEAUVJUYLUYAUVKUUQUWPULUYLUVKUUQNUWPUWOAUWPNVDUVJUXKWOWPUGEUVOUUQXG
      XLZYEAUWSUYAUVJUDYFAUYAUVJYGDEUUPUUQUUNYHYIXMUYIUEUHUUPUUNUHVBZUQZUYJUUIJ
      UYEUUMMAUXNUYAUXSWOUYIUEUUMUUPUTBCMNUVCVAUUIJUKUJBCUEMNUUPUVCUVHVIUYIBCJK
      MNAUXLUYAUXPWOZAUXMUYAUXRWOYJXRUYQUYIUHMUYPUTZJUUNUWCUQZUKUJZJUYEUKUJUYIU
      WGUWHUYAUYRUYTULAUWGUYAUWKWOAUWHUYAUWMWOAUYAYKUHDUWCUUNJWDMORYLXFUYIUYSUY
      EJUKUYAUYSUYEVDAUUNDGWAVRYMYNUUNUYOUUPYOYPYQAUYBVKZUYDUEUUMUUNUUQUQZUTUYF
      VUAUEUUMUUSVUBVUAUVJVKUYKUYLUWSUYBUUSVUBVDAUVJUYKUYBUYMYEAUVJUYLUYBUYNYEA
      UWSUYBUVJUDYFAUYBUVJYGDEUUPUUQUUNYRYIXMVUAUEUHUUQUYPVUBUUIKUYEUUMNAUXNUYB
      UXSWOVUAUEUUMUUQUTBCMNUVDVAUUIKUKUJBCUEMNUUQUVDUVIVIVUABCJKMNAUXLUYBUXPWO
      AUXMUYBUXRWOZYSXRVUCVUAUHNUYPUTZKUUNUXAUQZUKUJZKUYEUKUJVUAUXEUXFUYBVUDVUF
      ULAUXEUYBUXHWOAUXFUYBUXJWOAUYBYKUHEUXAUUNKWDNPSYLXFVUAVUEUYEKUKUYBVUEUYEV
      DAUUNEGWAVRYMYNUUNUYOUUQYOYPYQUUAUUBUUCYQAUUKUEIVMZUUODVSZUUOEVSZVCUTUULA
      BCUEDEFGHIJKLMNOPQRSTUAUBUCUDUUDAUEVUHVUIIJKVUGAIWHULIVUGXOUQULAIGXPUQZWH
      QAFLULZUWLVUJWHULUAUBFGLXQWKXRIVUGVUGUUEZXSXIAVUKUWLUWAUEVUGVUHUTIJUKUJUL
      UAUBUWJUEFDGIJLVUGVULQRYTXFAVUKUWLUXIUEVUGVUIUTIKUKUJULUAUBUXGUEFEGIKLVUG
      VULQSYTXFUUFYQHUUIIUUGUUH $.
  $}

  ${
    $d x y z J $.  $d x y z K $.  $d x y z ph $.  $d x y z X $.  $d x y z Y $.
    xpstopnlem1.f $e |- F = ( x e. X , y e. Y |-> `' ( { x } +c { y } ) ) $.
    xpstopnlem1.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    xpstopnlem1.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    $( The function ` F ` used in ~ xpsval is a homeomorphism from the binary
       product topology to the indexed product topology.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    xpstopnlem1 $p |- ( ph ->
      F e. ( ( J tX K ) Homeo ( Xt_ ` `' ( { J } +c { K } ) ) ) ) $=
      ( c0 csn cfv c1o co wcel eqid wceq c2o vz cop cpt cuni cun cmpt2 ccom ctx
      cv ccda ccnv chmeo cxp c1st c2nd wa wral ctopon txtopon syl2anc ctop cmpt
      wf ccn cvv 0ex pt1hmeo hmeocn cntop2 3syl toptopon sylib con0 opeq2 sneqd
      a1i 1on snex opeq12 syl2an mpt2eq3ia toponuni syl mpt2eq12 syl5eqr txhmeo
      fvmpt eqeltrd cnf2 syl3anc fmpt2 sylibr r19.21bi anasss vex op1std op2ndd
      eqidd uneq12d mpt2mpt eqcomi cpr xpscg mp2an df-pr eqtri syl6eqr syl6reqr
      fmpt2co cres 2on topontop xpscf sylanbrc df2o3 wne cin 1n0 necomi disjsn2
      mp1i ptunhmeo wfn xpscfn prid1 eleqtrri fnressn xpsc0 opeq2d eqtrd fveq2d
      sylancl unieqd elexi prid2 xpsc1 mpt2eq123dv oveq12d oveq1d 3eltr3d
      hmeoco ) ADBCLEUBZMZUCNZUDZOFUBZMZUCNZUDZBUIZCUIZUEZUFZBCGHLUUJUBZMZOUUKU
      BZMZUBZUFZUGZEFUHPZEMFMUJPUKZUCNZULPZAUUTBCGHUUJMUUKMUJPUKZUFDABCUAGHUUEU
      UIUMZUURUAUIZUNNZUVGUONZUEZUVEUUSUUMAUUJGQZUUKHQZUURUVFQZAUVKUPUVMCHAUVMC
      HUQZBGAGHUMZUVFUUSVCZUVNBGUQAUVAUVOURNQZUUDUUHUHPZUVFURNQZUUSUVAUVRVDPQZU
      VPAEGURNZQZFHURNZQZUVQJKEFGHUSUTAUUDUUEURNQZUUHUUIURNQZUVSAUUDVAQZUWEAUAG
      LUVGUBZMZVBZEUUDULPQUWJEUUDVDPQUWGAUALEUUDVEGUUDRLVEQAVFVPJVGZUWJEUUDVHUW
      JEUUDVIVJUUDUUEUUERVKVLAUUHVAQZUWFAUAHOUVGUBZMZVBZFUUHULPQUWOFUUHVDPQUWLA
      UAOFUUHVMHUUHROVMQAVQVPKVGZUWOFUUHVHUWOFUUHVIVJUUHUUIUUIRVKVLUUDUUHUUEUUI
      USUTAUUSUVAUVRULPZQZUVTAUUSBCEUDZFUDZUUJUWJNZUUKUWONZUBZUFZUWQAUUSBCGHUXC
      UFZUXDBCGHUXCUURUVKUXAUUOSUXBUUQSUXCUURSUVLUAUUJUWIUUOGUWJUVGUUJSUWHUUNUV
      GUUJLVNVOUWJRUUNVRZWGUAUUKUWNUUQHUWOUVGUUKSUWMUUPUVGUUKOVNVOUWORUUPVRZWGU
      XAUXBUUOUUQVSVTWAAGUWSSZHUWTSZUXEUXDSAUWBUXHJGEWBWCAUWDUXIKHFWBWCBCGHUWSU
      WTUXCWDUTWEABCUWJUWOEFUUDUUHUWSUWTUWSRUWTRUWKUWPWFWHZUUSUVAUVRVHWCUUSUVAU
      VRUVOUVFWIWJBCGHUURUVFUUSUUSRWKWLWMWMWNAUUSWRUUMUAUVFUVJVBZSAUXKUUMBCUAUU
      EUUIUVJUULUVGUUJUUKUBSUVHUUJUVIUUKUUJUUKUVGBWOZCWOZWPUUJUUKUVGUXLUXMWQWSW
      TXAVPUVGUURSZUVJUUOUUQUEZUVEUXNUVHUUOUVIUUQUUOUUQUVGUXFUXGWPUUOUUQUVGUXFU
      XGWQWSUVEUUNUUPXBZUXOUUJVEQUUKVEQUVEUXPSUXLUXMUUJUUKVEVEXCXDUUNUUPXEXFXGX
      IIXHAUWRUUMUVRUVCULPZQUUTUVDQUXJABCUVBLMZXJZUCNZUDZUVBOMZXJZUCNZUDZUULUFZ
      UXTUYDUHPZUVCULPUUMUXQABCUXRUYBTUVBUYFUVCUXTUYDVMUYAUYEUYARUYERUVCRUXTRUY
      DRUYFRTVMQAXKVPAEVAQZFVAQZTVAUVBVCAUWBUYHJGEXLWCAUWDUYIKHFXLWCVAEFXMXNTUX
      RUYBUEZSATLOXBZUYJXOLOXEXFVPLOXPUXRUYBXQLSAOLXRXSLOXTYAYBABCUYAUYEUULUUEU
      UIUULAUXTUUDAUXSUUCUCAUXSLLUVBNZUBZMZUUCAUVBTYCZLTQUXSUYNSAUWBUWDUYOJKEFU
      WAUWCYDUTZLUYKTLOVFYEXOYFTLUVBYGYLAUYMUUBAUYLELAUWBUYLESJEFUWAYHWCYIVOYJY
      KZYMAUYDUUHAUYCUUGUCAUYCOOUVBNZUBZMZUUGAUYOOTQUYCUYTSUYPOUYKTLOOVMVQYNYOX
      OYFTOUVBYGYLAUYSUUFAUYRFOAUWDUYRFSKEFUWCYPWCYIVOYJYKZYMAUULWRYQAUYGUVRUVC
      ULAUXTUUDUYDUUHUHUYQVUAYRYSYTUUSUUMUVAUVRUVCUUAUTWH $.
  $}

  ${
    $d x y J $.  $d x y K $.  $d x y R $.  $d x y S $.  $d x y X $.
    $d x y Y $.
    xpstps.t $e |- T = ( R Xs. S ) $.
    $( A binary product of topologies is a topological space.  (Contributed by
       Mario Carneiro, 27-Aug-2015.) $)
    xpstps $p |- ( ( R e. TopSp /\ S e. TopSp ) -> T e. TopSp ) $=
      ( vx vy ctps wcel cbs cfv csca csn ccda co ccnv cv eqid wf1o a1i c2o 3syl
      wa cxp cprds cmpt2 crn simpl simpr xpsval xpslem wfo xpsff1o2 f1ocnv con0
      f1ofo cvv fvex 2on wf xpscf biimpri prdstps imastps ) AGHZBGHZUBZAIJZBIJZ
      UCZAKJZALBLMNOZUDNZCEFVGVHEPLFPLMNOUEZOZVMUFZVFEFABCVLVMVJGGVGVHDVGQZVHQZ
      VDVEUGZVDVEUHZVMQZVJQZVLQZUIVFEFABCVLVMVJGGVGVHDVPVQVRVSVTWAWBUJVFVIVOVMR
      ZVOVIVNRVOVIVNUKWCVFEFVGVHVMVTULSVIVOVMUMVOVIVNUOUAVFVKVJTUPUNVLWBVJUPHVF
      AKUQSTUNHVFURSTGVKUSVFGABUTVAVBVC $.

    xpstopn.j $e |- J = ( TopOpen ` R ) $.
    xpstopn.k $e |- K = ( TopOpen ` S ) $.
    xpstopn.o $e |- O = ( TopOpen ` T ) $.
    ${
      xpstopnlem.x $e |- X = ( Base ` R ) $.
      xpstopnlem.y $e |- Y = ( Base ` S ) $.
      xpstopnlem.f $e |- F = ( x e. X , y e. Y |-> `' ( { x } +c { y } ) ) $.
      $( Lemma for ~ xpstopn .  (Contributed by Mario Carneiro,
         27-Aug-2015.) $)
      xpstopnlem2 $p |- ( ( R e. TopSp /\ S e. TopSp ) -> O = ( J tX K ) ) $=
        ( cfv c2o ctps wcel wa csca csn ccda co ccnv cprds ctopn cqtop cpt ccom
        ctx cvv con0 eqid fvex a1i 2on xpscfn prdstopn c0 c1o wfn wceq wf dffn2
        topnfn sylib fnfco sylancr xpsfeq syl cpr 0ex prid1 df2o3 fvco2 sylancl
        eleqtrri xpsc0 adantr fveq2d syl6eqr eqtrd sneqd 1on elexi prid2 adantl
        xpsc1 oveq12d cnveqd eqtr3d oveq1d cxp crn simpl xpsval xpslem wf1o wfo
        simpr xpsff1o2 f1ocnv mp1i f1ofo ovex imastopn chmeo ctopon xpstopnlem1
        istps hmeocnv hmeoqtop 3syl 3eqtr4d ) CUAUBZDUAUBZUCZCUDSZCUEDUEUFUGUHZ
        UIUGZUJSZFUHZUKUGGUEZHUEZUFUGZUHZULSZYFUKUGZIGHUNUGZYAYEYKYFUKYAYEUJYCU
        MZULSYKYAYCYBTYEUOUPYDYDUQZYBUOUBYACUDURUSTUPUBYAUTUSCDUAUAVAZYEUQZVBYA
        YNYJULYAVCYNSZUEZVDYNSZUEZUFUGZUHZYNYJYAYNTVEZUUCYNVFYAUJUOVETUOYCVGZUU
        DVIYAYCTVEZUUEYPTYCVHVJUOTUJYCVKVLYNVMVNYAUUBYIYAYSYGUUAYHUFYAYRGYAYRVC
        YCSZUJSZGYAUUFVCTUBYRUUHVFYPVCVCVDVOZTVCVDVPVQVRWATUJYCVCVSVTYAUUHCUJSG
        YAUUGCUJXSUUGCVFXTCDUAWBWCWDMWEWFWGYAYTHYAYTVDYCSZUJSZHYAUUFVDTUBYTUUKV
        FYPVDUUITVCVDVDUPWHWIWJVRWATUJYCVDVSVTYAUUKDUJSHYAUUJDUJXTUUJDVFXSCDUAW
        LWKWDNWEWFWGWMWNWOWDWFWPYAJKWQZYDEYFYEIFWRZUOYAABCDEYDFYBUAUAJKLPQXSXTW
        SZXSXTXDZRYBUQZYOWTYAABCDEYDFYBUAUAJKLPQUUNUUORUUPYOXAYAUUMUULYFXBZUUMU
        ULYFXCUULUUMFXBUUQYAABJKFRXEUULUUMFXFXGUUMUULYFXHVNYDUOUBYAYBYCUIXIUSYQ
        OXJYAFYMYKXKUGUBYFYKYMXKUGUBYMYLVFYAABFGHJKRYAXSGJXLSUBUUNJGCPMXNVJYAXT
        HKXLSUBUUOKHDQNXNVJXMFYMYKXOYFYKYMXPXQXR $.
    $}

    $( The topology on a binary product of topological spaces, as we have
       defined it (transferring the indexed product topology on functions on
       ` { (/) , 1o } ` to ` ( X X. Y ) ` by the canonical bijection),
       coincides with the usual topological product (generated by a base of
       rectangles).  (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    xpstopn $p |- ( ( R e. TopSp /\ S e. TopSp ) -> O = ( J tX K ) ) $=
      ( vx vy cbs cfv cv csn ccda co ccnv eqid cmpt2 xpstopnlem2 ) KLABCKLAMNZB
      MNZKOPLOPQRSUAZDEFUCUDGHIJUCTUDTUETUB $.
  $}

  ${
    $d u v x y z A $.  $d u v x y z F $.
    $( A topological product of finitely many compact spaces is compact.  This
       weak version of Tychonoff's theorem does not require the axiom of
       choice.  (Contributed by Mario Carneiro, 8-Feb-2015.) $)
    ptcmpfi $p |- ( ( A e. Fin /\ F : A --> Comp ) -> ( Xt_ ` F ) e. Comp ) $=
      ( vx cfn wcel ccmp wf cres cpt cfv wceq fveq2d wss wi cv c0 ctop cvv cuni
      eqid vy vz vu vv wa wfn ffn fnresdm syl adantl ssid csn sseq1 reseq2 res0
      cun syl6eq eleq1d imbi2d imbi12d cin 0ex pttop mp2an cpw cixp ptuni ixp0x
      f0 snfi eqeltri eqeltrri pwfi mpbi pwuni ssfi elin mpbir2an ax-mp a1ii wn
      fincmp ssun1 id syl5ss imim1i ctx co chmph wbr cmpt2 chmeo resabs1 eqcomi
      fveq2i ssun2 vex snex unex a1i simplr cmptop ssriv sylancl simprr syl2anc
      fss fssres eqidd simprl disjsn sylibr ptunhmeo hmphi cop ad2antlr fnressn
      snss cmpt ctopon ffvelrnd sseldi sylib pt1hmeo cmphmph sylc eqeltrd txcmp
      toptopon expcom sylsyld a2d ex syl5 findcard2s mpi anabsi5 eqeltrrd ) ADE
      ZAFBGZUEZBAHZIJZBIJFUUAUUBBIYTUUBBKZYSYTBAUFZUUDAFBUGZABUHUIUJLYSYTUUCFEZ
      YSAAMZUUAUUGNZAUKCOZAMZUUABUUJHZIJZFEZNZNPAMZUUAPIJZFEZNZNUAOZAMZUUABUUTH
      ZIJZFEZNZNZUUTUBOZULZUPZAMZUUABUVIHZIJZFEZNZNZUUHUUINCUAUBAUUJPKZUUKUUPUU
      OUUSUUJPAUMUVPUUNUURUUAUVPUUMUUQFUVPUULPIUVPUULBPHPUUJPBUNBUOUQLURUSUTUUJ
      UUTKZUUKUVAUUOUVEUUJUUTAUMUVQUUNUVDUUAUVQUUMUVCFUVQUULUVBIUUJUUTBUNLURUSU
      TUUJUVIKZUUKUVJUUOUVNUUJUVIAUMUVRUUNUVMUUAUVRUUMUVLFUVRUULUVKIUUJUVIBUNLU
      RUSUTUUJAKZUUKUUHUUOUUIUUJAAUMUVSUUNUUGUUAUVSUUMUUCFUVSUULUUBIUUJABUNLURU
      SUTUUPUUAUURUUQQDVAEZUURUVTUUQQEZUUQDEZPREZPQPGZUWAVBQVIZPPRVCVDUUQSZVEZD
      EZUUQUWGMUWBUWFDEUWHCPUUJPJSZVFZUWFDUWCUWDUWJUWFKVBUWECPPUUQRUUQTVGVDUWJP
      ULDCUWIVHPVJVKVLUWFVMVNUUQVOUWGUUQVPVDUUQQDVQVRUUQWBVSVTUVGUUTEWAZUVFUVON
      UUTDEUVFUVJUVENUWKUVOUVJUVAUVEUVJUUTUVIAUUTUVHWCZUVJWDWEWFUWKUVJUVEUVNUWK
      UVJUVEUVNNUWKUVJUEZUUAUVDUVMUUAUWMUVDUVMNUUAUWMUEZUVCBUVHHZIJZWGWHZUVLWIW
      JZUVDUWQFEZUVMUWNUCUDUVCSZUWPSZUCOUDOUPWKZUWQUVLWLWHEUWRUWNUCUDUUTUVHUVIU
      VKUXBUVLUVCUWPRUWTUXAUWTTUXATUVLTUVBUVKUUTHZIUXCUVBUUTUVIMUXCUVBKUWLBUUTU
      VIWMVSWNWOUWOUVKUVHHZIUXDUWOUVHUVIMUXDUWOKUVHUUTWPZBUVHUVIWMVSWNWOUXBTUVI
      REUWNUUTUVHUAWQUVGWRWSWTUWNAQBGZUVJUVIQUVKGUWNYTFQMUXFYSYTUWMXAZCFQUUJXBX
      CZAFQBXGXDUUAUWKUVJXEZAQUVIBXHXFUWNUVIXIUWNUWKUUTUVHVAPKUUAUWKUVJXJUUTUVG
      XKXLXMUXBUWQUVLXNUIUWNUWPFEZUVDUWSNUWNUWPUVGUVGBJZXOULZIJZFUWNUWOUXLIUWNU
      UEUVGAEZUWOUXLKYTUUEYSUWMUUFXPUWNUVHAMUXNUWNUVHUVIAUXEUXIWEUVGAUBWQZXRXLZ
      AUVGBXQXFLUWNUXKUXMWIWJZUXKFEUXMFEUWNCUXKSZUVGUUJXOULXSZUXKUXMWLWHEUXQUWN
      CUVGUXKUXMRUXRUXMTUVGREUWNUXOWTUWNUXKQEUXKUXRXTJEUWNFQUXKUXHUWNAFUVGBUXGU
      XPYAZYBUXKUXRUXRTYIYCYDUXSUXKUXMXNUIUXTUXKUXMYEYFYGUVDUXJUWSUVCUWPYHYJUIU
      WQUVLYEYKYJYLYMYLYNUJYOYPYQYR $.
  $}

  ${
    $d f g t u w x y z J $.  $d f g t u w x y z K $.  $d f g t u w x y z ph $.
    $d f g t u w x y z L $.  $d f g t u w x y z X $.  $d f g t u w x y z Y $.
    $d f g x y F $.
    xkohmeo.x $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    xkohmeo.y $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    xkohmeo.f $e |- F = ( f e. ( ( J tX K ) Cn L ) |->
      ( x e. X |-> ( y e. Y |-> ( x f y ) ) ) ) $.
    xkohmeo.j $e |- ( ph -> J e. N-Locally Comp ) $.
    xkohmeo.k $e |- ( ph -> K e. N-Locally Comp ) $.
    xkohmeo.l $e |- ( ph -> L e. Top ) $.
    $( The inverse of the "currying" function ` F ` is the uncurrying
       function.  (Contributed by Mario Carneiro, 13-Apr-2015.) $)
    xkocnv $p |- ( ph -> `' F = ( g e. ( J Cn ( L ^ko K ) ) |->
      ( x e. X , y e. Y |-> ( ( g ` x ) ` y ) ) ) ) $=
      ( wcel wceq wa cv ctx co ccn cmpt copab cxko cfv cmpt2 ccnv simprr ctopon
      adantr cxp cuni wf txtopon syl2anc ctop eqid toptopon sylib simpr syl3anc
      wfn cnf2 ffn fnov eqeltrrd cnmpt2k adantrr eqeltrd wral nfmpt1 nfeq2 nfan
      syl nfv nfcv nfmpt simplrr fveq1d cvv simprl toponmax mptexg fvmpt2 eqtrd
      ad2antrr ovex sylancl expr ralrimi jctil ex mpt2eq123 sylancr eqtr4d ccmp
      jca cnlly nllytop xkotopon feqmptd ffvelrnda cnmptk2 nfmpt21 nfmpt22 fvex
      mpteq2dva oveqd ovmpt4g mp3an3 sylan9eq mpteq12 mpteq2da impbida opabbidv
      df-mpt eqtri cnveqi cnvopab 3eqtr4g ) ADUAZGHUBUCZIUDUCZRZEUAZBJCKBUAZCUA
      ZYDUCZUEZUEZSZTZEDUFZYHGIHUGUCZUDUCZRZYDBCJKYJYIYHUHZUHZUIZSZTZEDUFFUJZEY
      RUUBUEAYOUUDEDAYOUUDAYOTZYSUUCUUFYHYMYRAYGYNUKAYGYMYRRYNAYGTZBCYKGHIJKAGJ
      ULUHRZYGLUMAHKULUHRZYGMUMUUGYDBCJKYKUIZYFUUGYDJKUNZVEZYDUUJSZUUGUUKIUOZYD
      UPZUULUUGYEUUKULUHRZIUUNULUHRZYGUUOAUUPYGAUUHUUIUUPLMGHJKUQURUMAUUQYGAIUS
      RZUUQQIUUNUUNUTVAVBZUMAYGVCZYDYEIUUKUUNVFVDUUKUUNYDVGVQBCJKYDVHVBZUUTVIVJ
      VKVLUUFYDUUJUUBAYGUUMYNUVAVKUUFJJSKKSZUUAYKSZCKVMZTZBJVMUUBUUJSJUTUUFUVEB
      JAYOBABVRZYGYNBYGBVRBYHYMBJYLVNVOVPVPUUFYIJRZUVEUUFUVGTZUVDUVBUVHUVCCKUUF
      UVGCAYOCACVRZYGYNCYGCVRCYHYMCBJYLCJVSCKYKVNVTVOVPVPUVGCVRZVPUUFUVGYJKRZUV
      CUUFUVGUVKTZTZUUAYJYLUHZYKUVMYJYTYLUVMYTYIYMUHZYLUVMYIYHYMAYGYNUVLWAWBUVM
      UVGYLWCRZUVOYLSUUFUVGUVKWDUVMKHRZUVPAUVQYOUVLAUUIUVQMKHWEVQWICKYKHWFVQBJY
      LWCYMYMUTWGURWHWBUVMUVKYKWCRUVNYKSUUFUVGUVKUKYIYJYDWJCKYKWCYLYLUTWGWKWHWL
      WMKUTZWNWOWMBCJKUUAJKYKWPWQWRWTAUUDTZYGYNUVSYDUUBYFAYSUUCUKZAYSUUBYFRUUCA
      YSTZBCUUAGHIJKUUNAUUHYSLUMZAUUIYSMUMAUUQYSUUSUMAHWSXARZYSPUMZUWAYHBJCKUUA
      UEZUEZYRUWAYHBJYTUEUWFUWABJHIUDUCZYHUWAUUHYQUWGULUHRZYSJUWGYHUPUWBUWAHUSR
      ZUURUWHUWAUWCUWIUWDWSHXBVQAUURYSQUMHIYQYQUTXCURAYSVCZYHGYQJUWGVFVDZXDUWAB
      JYTUWEUWAUVGTZCKUUNYTUWLUUIUUQYTUWGRKUUNYTUPAUUIYSUVGMWIAUUQYSUVGUUSWIUWA
      JUWGYIYHUWKXEYTHIKUUNVFVDXDXJWHZUWJVIXFVKVLUVSYHUWFYMAYSYHUWFSUUCUWMVKUVS
      BJYLUWEAUUDBUVFYSUUCBYSBVRBYDUUBBCJKUUAXGVOVPVPUVSUVGTZUVBYKUUASZCKVMYLUW
      ESUVRUWNUWOCKUVSUVGCAUUDCUVIYSUUCCYSCVRCYDUUBBCJKUUAXHVOVPVPUVJVPUVSUVGUV
      KUWOUVSUVLYKYIYJUUBUCZUUAUVSYDUUBYIYJUVTXKUVGUVKUUAWCRUWPUUASYJYTXIBCJKUU
      AUUBWCUUBUTXLXMXNWLWMCKYKKUUAXOWQXPWRWTXQXRUUEYODEUFZUJYPFUWQFDYFYMUEUWQN
      DEYFYMXSXTYAYODEYBXTEDYRUUBXSYC $.

    $( The Exponential Law for topological spaces.  The "currying" function
       ` F ` is a homeomorphism on function spaces when ` J ` and ` K ` are
       exponentiable spaces (by ~ xkococn , it is sufficient to assume that
       ` J , K ` are locally compact to ensure exponentiability).  (Contributed
       by Mario Carneiro, 13-Apr-2015.)  (Proof shortened by Mario Carneiro,
       23-Aug-2015.) $)
    xkohmeo $p |- ( ph ->
      F e. ( ( L ^ko ( J tX K ) ) Homeo ( ( L ^ko K ) ^ko J ) ) ) $=
      ( vz co cmpt cfv vw vu vt vg ctx cxko ccn wcel ccnv chmeo ctop ctopon cxp
      cv txtopon syl2anc topontop syl eqid xkotopon cmpt2 c2nd c1st wceq op1std
      cop vex op2ndd eqidd oveq123d mpteq2dv mpt2mpt fveq2d cuni toptopon sylib
      ccmp cnlly txcmp txnlly wa wf adantr xp1st cnf2 syl3anc feqmptd mpteq2dva
      syl5eqr cnmpt1st fveq2 cbvmptv syl5eqel cnmpt21 eqeltrrd cnmpt2nd cnmpt1t
      adantl df-ov syl6eqr cnmptk1p cnmpt2k xkocnv fveq12d mpteq2i xkotop xp2nd
      syl5eqelr nllytop ffvelrnd eqeltrd ishmeo sylanbrc ) AEHFGUERZUFRZHGUFRZF
      UFRZUGRZUHEUIZXQXOUGRZUHEXOXQUJRUHAEDXNHUGRZBICJBUNZCUNZDUNZRZSZSSXRMADBY
      FXOFXPYAIAXNUKUHZHUKUHZXOYAULTUHZAXNIJUMZULTUHZYGAFIULTUHZGJULTUHZYKKLFGI
      JUOUPZYJXNUQURPXNHXOXOUSUTUPZKADBYAIYFVAQYAIUMZCJQUNZVBTZYCYQVCTZRZSZSXOF
      UERZXPUGRDBQYAIUUAYFYQYDYBVFVDZCJYTYEUUCYRYBYCYCYSYDYDYBYQDVGZBVGZVEZYDYB
      YQUUDUUEVHZUUCYCVIVJVKVLAQCYTUUBGHYPJAYIYLUUBYPULTUHZYOKXOFYAIUOUPZLAQCYP
      JYTVAUAYPJUMZUAUNZVCTZVBTZUUKVBTZUULVCTZRZSUUBGUERZHUGRQCUAYPJUUPYTUUKYQY
      CVFVDZUUMYRUUNYCUUOYSUURUULYQVCYQYCUUKQVGZCVGZVEZVMZUURUULYQVBUVAVMZYQYCU
      UKUUSUUTVHZVJVLAUAUBUBUNZUUOTZUUMUUNVFZUUPUUQXNHUUJYJHVNZAUUHYMUUQUUJULTU
      HUUILUUBGYPJUOUPZYNAYHHUVHULTUHZPHUVHUVHUSVOVPZAFVQVRZUHZGUVLUHZXNUVLUHNO
      VQFGBCYBYCVSVTUPAQCYPJYSVAZUAUUJUBYJUVFSZSZUUQXOUGRAUVOUAUUJUUOSUVQQCUAYP
      JUUOYSUVBVLAUAUUJUUOUVPAUUKUUJUHZWAZUBYJUVHUUOUVSYKUVJUUOYAUHZYJUVHUUOWBA
      YKUVRYNWCAUVJUVRUVKWCUVSUULYPUHZUVTUVRUWAAUUKYPJWDWRUULYAIWDURUUOXNHYJUVH
      WEWFWGWHWIAQCUCYQUCUNZVCTZYSUUBGUUBXOYPJYPUUILAQCUUBGYPJUUILWJZUUIAUCYPUW
      CSQYPYSSZUUBXOUGRZUCQYPUWCYSUWBYQVCWKZWLAUWEDBYAIYDVAUWFDBQYAIYSYDUUFVLAD
      BXOFYAIYOKWJWMWMUWGWNWOAUAUUMUUNUUQFGUUJUVIAUAUUJUUMSQCYPJYRVAUUQFUGRQCUA
      YPJUUMYRUVCVLAQCUCYQUWBVBTZYRUUBGUUBFYPJYPUUILUWDUUIAUCYPUWHSQYPYRSZUUBFU
      GRZUCQYPUWHYRUWBYQVBWKZWLAUWIDBYAIYBVAUWJDBQYAIYRYBUUGVLADBXOFYAIYOKWPWMW
      MUWKWNWMAUAUUJUUNSQCYPJYCVAUUQGUGRQCUAYPJUUNYCUVDVLAQCUUBGYPJUUILWPWMWQUV
      EUVGVDUVFUVGUUOTUUPUVEUVGUUOWKUUMUUNUUOWSWTXAXHXBXHXBWMAXSUDFXPUGRZQYJYRY
      SUDUNZTZTZSZSZXTAXSUDUWLBCIJYCYBUWMTZTZVAZSUWQABCDUDEFGHIJKLMNOPXCUDUWLUW
      PUWTBCQIJUWOUWSYQYBYCVFVDZYRYCUWNUWRUXAYSYBUWMYBYCYQUUEUUTVEZVMYBYCYQUUEU
      UTVHZXDVLXEWTAUDQUWOXQXNHUWLYJAFUKUHZXPUKUHZXQUWLULTUHZAUVMUXDNVQFXIURAGU
      KUHZYHUXEAUVNUXGOVQGXIURZPGHXFUPFXPXQXQUSUTUPZYNAUDQUWLYJUWOVAUAUWLYJUMZU
      UNVBTZUUNVCTZUULTZTZSXQXNUERZHUGRUDQUAUWLYJUXNUWOUUKUWMYQVFVDZUXKYRUXMUWN
      UXPUXLYSUULUWMUWMYQUUKUDVGZUUSVEZUXPUUNYQVCUWMYQUUKUXQUUSVHZVMZXDUXPUUNYQ
      VBUXSVMZXDVLAUACYCUXMTZUXKUXNUXOGHUXJJUVHAUXFYKUXOUXJULTUHUXIYNXQXNUWLYJU
      OUPZLUVKOAUAUXJUXMSUAUXJCJUYBSZSUXOXPUGRAUAUXJUXMUYDAUUKUXJUHZWAZCJUVHUXM
      UYFYMUVJUXMGHUGRZUHJUVHUXMWBAYMUYELWCAUVJUYEUVKWCUYFIUYGUXLUULUYFYLXPUYGU
      LTUHZUULUWLUHZIUYGUULWBAYLUYEKWCAUYHUYEAUXGYHUYHUXHPGHXPXPUSUTUPZWCUYEUYI
      AUUKUWLYJWDWRUULFXPIUYGWEWFZUYFUUNYJUHZUXLIUHUYEUYLAUUKUWLYJXGWRUUNIJWDUR
      XJUXMGHJUVHWEWFWGWHAUABYBUULTZUXLUXMUXOFXPUXJIUYGUYCKUYJNAUDQUWLYJUWMVAZU
      AUXJBIUYMSZSZUXOXQUGRAUYNUAUXJUULSUYPUDQUAUWLYJUULUWMUXRVLAUAUXJUULUYOUYF
      BIUYGUULUYKWGWHWIAUDQXQXNUWLYJUXIYNWJWOAUAUXJUXLSUDQUWLYJYSVAUXOFUGRUDQUA
      UWLYJUXLYSUXTVLAUDQUCYQUWCYSXQXNXNFUWLYJYJUXIYNAUDQXQXNUWLYJUXIYNWPZYNAUC
      YJUWCSQYJYSSZXNFUGRZUCQYJUWCYSUWGWLAUYRBCIJYBVAUYSBCQIJYSYBUXBVLABCFGIJKL
      WJWMWMUWGWNWMYBUXLUULWKXAWOAUAUXJUXKSUDQUWLYJYRVAUXOGUGRUDQUAUWLYJUXKYRUY
      AVLAUDQUCYQUWHYRXQXNXNGUWLYJYJUXIYNUYQYNAUCYJUWHSQYJYRSZXNGUGRZUCQYJUWHYR
      UWKWLAUYTBCIJYCVAVUABCQIJYRYCUXCVLABCFGIJKLWPWMWMUWKWNWMYCUXKUXMWKXAXHXBX
      KEXOXQXLXM $.
  $}

  ${
    $d f g h x y F $.  $d f g h x y G $.  $d f g h x y J $.  $d f g h x y ph $.
    $d x y X $.  $d f g h x Y $.
    qtopf1.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    qtopf1.2 $e |- ( ph -> F : X -1-1-> Y ) $.
    $( If a quotient map is injective, then it is a homeomorphism.
       (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    qtopf1 $p |- ( ph -> F e. ( J Homeo ( J qTop F ) ) ) $=
      ( vx co ccn wcel ccnv ctopon cfv syl2anc cima wf1o wa wss adantr wfn f1fn
      cqtop chmeo wf1 syl qtopid crn wf wral f1f1orn f1ocnv f1of 4syl imacnvcnv
      cv imassrn a1i wceq toponss sylan f1imacnv simpr eqeltrd wb dffn4 elqtop3
      wfo sylib mpbir2and syl5eqel ralrimiva qtoptopon iscn ishmeo sylanbrc ) A
      BCCBUCIZJIKZBLZVQCJIKZBCVQUDIKACDMNKZBDUAZVRFADEBUEZWBGDEBUBUFZBCDUGOAVTB
      UHZDVSUIZVSLHUPZPZVQKZHCUJZAWCDWEBQWEDVSQWFGDEBUKDWEBULWEDVSUMUNAWIHCAWGC
      KZRZWHBWGPZVQBWGUOWLWMVQKZWMWESZVSWMPZCKZWOWLBWGUQURWLWPWGCWLWCWGDSZWPWGU
      SAWCWKGTAWAWKWRFWGCDUTVADEWGBVBOAWKVCVDAWNWOWQRVEZWKAWADWEBVHZWSFAWBWTWDD
      BVFVIZWMBCDWEVGOTVJVKVLAVQWEMNKZWAVTWFWJRVEAWAWTXBFXABCDWEVMOFHVSVQCWEDVN
      OVJBCVQVOVP $.
  $}

  ${
    $d f g h x y F $.  $d f g h x y G $.  $d f g h x y J $.  $d f g h x y ph $.
    $d x y X $.  $d f g h x Y $.
    qtophmeo.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    qtophmeo.3 $e |- ( ph -> F : X -onto-> Y ) $.
    qtophmeo.4 $e |- ( ph -> G : X -onto-> Y ) $.
    qtophmeo.5 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( ( F ` x ) = ( F ` y ) <-> ( G ` x ) = ( G ` y ) ) ) $.
    $( If two functions on a base topology ` J ` make the same identifications
       in order to create quotient spaces ` J qTop F ` and ` J qTop G ` , then
       not only are ` J qTop F ` and ` J qTop G ` homeomorphic, but there is a
       unique homeomorhism that makes the diagram commute.  (Contributed by
       Mario Carneiro, 24-Mar-2015.)  (Proof shortened by Mario Carneiro,
       23-Aug-2015.) $)
    qtophmeo $p |- ( ph -> E! f e. ( ( J qTop F ) Homeo ( J qTop G ) )
      G = ( f o. F ) ) $=
      ( vg vh ccom wceq wa wcel syl cv cqtop co chmeo wrex weq wi wral wreu ccn
      ctopon cfv wfn wfo qtopid syl2anc w3a df-3an biimpd sylan2b qtopeu reurex
      fofn impr ccnv simprl biimprd adantr wf1o cres qtoptopon ad2antrr simplrl
      wf cnf2 syl3anc wrmo simpr3 reurmo cnco simplrr simprr coeq2d eqtrd coass
      cid syl6eqr idcn fcoi2 eqcomd coeq1 eqeq2d rmoi syl122anc fcof1o syl22anc
      fof simprd eqeltrd rexlimddv ishmeo sylanbrc jca ex reximdv2 mpd eqtr2 wb
      hmeof1o2 f1ofn cocan2 syl5ib ralrimivva reu4 ) AFDUAZEPZQZDGEUBUCZGFUBUCZ
      UDUCZUEZXQFNUAZEPZQZRZDNUFZUGZNXTUHDXTUHXQDXTUIAXQDXRXSUJUCZUEZYAAXQDYHUI
      YIABCDEFGXSHIJKAGHUKULSZFHUMZFGXSUJUCSJAHIFUNZYKLHIFVCTFGHUOUPZBUAZHSZCUA
      ZHSZYNEULYPEULQZUQAYOYQRZYRRYNFULYPFULQZYOYQYRURAYSYRYTAYSRZYRYTMUSVDUTVA
      XQDYHVBTAXQXQDYHXTAXOYHSZXQRZXOXTSZXQRAUUCRZUUDXQUUEUUBXOVEZXSXRUJUCZSZUU
      DAUUBXQVFUUEEYBFPZQZUUHNUUGUUEUUJNUUGUIZUUJNUUGUEAUUKUUCABCNFEGXRHIJLAYJE
      HUMZEGXRUJUCSJAHIEUNZUULKHIEVCTEGHUOUPZYOYQYTUQAYSYTRYRYOYQYTURAYSYTYRUUA
      YRYTMVGVDUTVAVHUUJNUUGVBTUUEYBUUGSZUUJRZRZUUFYBUUGUUQIIXOVIZUUFYBQZUUQIIX
      OVNZIIYBVNZXOYBPZWFIVJZQZYBXOPZUVCQZUURUUSRUUQXRIUKULZSZXSUVGSZUUBUUTAUVH
      UUCUUPAYJUUMUVHJKEGHIVKUPZVLZAUVIUUCUUPAYJYLUVIJLFGHIVKUPZVLZAUUBXQUUPVMZ
      XOXRXSIIVOVPUUQUVIUVHUUOUVAUVMUVKUUEUUOUUJVFZYBXSXRIIVOVPUUQFOUAZFPZQZOXS
      XSUJUCZVQZUVBUVSSZFUVBFPZQZUVCUVSSZFUVCFPZQZUVDUUQUVROUVSUIZUVTAUWGUUCUUP
      ABCOFFGXSHIJLYMAYOYQYTVRVAVLUVROUVSVSTUUQUUOUUBUWAUVOUVNYBXOXSXRXSVTUPUUQ
      FXOUUIPZUWBUUQFXPUWHAUUBXQUUPWAZUUQEUUIXOUUEUUOUUJWBZWCWDXOYBFWEWGAUWDUUC
      UUPAUVIUWDUVLXSIWHTVLUUQUWEFUUQHIFVNZUWEFQAUWKUUCUUPAYLUWKLHIFWQTVLHIFWIT
      WJUVRUWCUWFOUVSUVBUVCUVPUVBQUVQUWBFUVPUVBFWKWLUVPUVCQZUVQUWEFUVPUVCFWKWLW
      MWNUUQEUVPEPZQZOXRXRUJUCZVQZUVEUWOSZEUVEEPZQZUVCUWOSZEUVCEPZQZUVFUUQUWNOU
      WOUIZUWPAUXCUUCUUPABCOEEGXRHIJKUUNAYOYQYRVRVAVLUWNOUWOVSTUUQUUBUUOUWQUVNU
      VOXOYBXRXSXRVTUPUUQEYBXPPZUWRUUQEUUIUXDUWJUUQFXPYBUWIWCWDYBXOEWEWGAUWTUUC
      UUPAUVHUWTUVJXRIWHTVLUUQUXAEUUQHIEVNZUXAEQAUXEUUCUUPAUUMUXEKHIEWQTVLHIEWI
      TWJUWNUWSUXBOUWOUVEUVCUVPUVEQUWMUWREUVPUVEEWKWLUWLUWMUXAEUVPUVCEWKWLWMWNI
      IXOYBWOWPWRUVOWSWTXOXRXSXAXBAUUBXQWBXCXDXEXFAYGDNXTXTYEXPYCQZAUUDYBXTSZRZ
      RZYFFXPYCXGUXIUUMXOIUMZYBIUMZUXFYFXHAUUMUXHKVHUXIUURUXJUXIUVHUVIUUDUURAUV
      HUXHUVJVHZAUVIUXHUVLVHZAUUDUXGVFXOXRXSIIXIVPIIXOXJTUXIIIYBVIZUXKUXIUVHUVI
      UXGUXNUXLUXMAUUDUXGWBYBXRXSIIXIVPIIYBXJTHIEXOYBXKVPXLXMXQYDDNXTYFXPYCFXOY
      BEWKWLXNXB $.
  $}

  ${
    $d x y J $.  $d x y X $.
    t0kq.1 $e |- F = ( x e. X |-> { y e. J | x e. y } ) $.
    $( A topological space is T_0 iff the quotient map is a homeomorphism onto
       the space's Kolmogorov quotient.  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    t0kq $p |- ( J e. ( TopOn ` X ) ->
        ( J e. Kol2 <-> F e. ( J Homeo ( KQ ` J ) ) ) ) $=
      ( ctopon cfv wcel ct0 ckq chmeo co wa cqtop cvv simpl wf1 chmph wbr kqval
      ist0-4 biimpa qtopf1 wceq adantr oveq2d eleqtrrd hmphi hmphsym syl t0hmph
      kqt0lem syl2im impcom impbida ) DEGHIZDJIZCDDKHZLMZIZUQURNZCDDCOMZLMUTVBC
      DEPUQURQUQUREPCRABCDEFUBUCUDVBUSVCDLUQUSVCUEURABCDEFUAUFUGUHVAUQURVAUSDST
      ZUQUSJIURVADUSSTVDCDUSUIDUSUJUKABCDEFUMUSDULUNUOUP $.
  $}

  ${
    $d x y J $.
    $( A topological space is T_0 iff it is homeomorphic to its Kolmogorov
       quotient.  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
    kqhmph $p |- ( J e. Kol2 <-> J ~= ( KQ ` J ) ) $=
      ( vx vy ct0 wcel ckq cfv chmph wbr cuni crab cmpt chmeo co ctopon wb eqid
      wel sylib syl ctop t0top toptopon t0kq hmphi hmphsym hmphtop1 kqt0 t0hmph
      ibi sylc impbii ) ADEZAAFGZHIZUMBAJZBCRCAKLZAUNMNEZUOUMURUMAUPOGEZUMURPUM
      AUAEZUSAUBAUPUPQUCSBCUQAUPUQQUDTUJUQAUNUETUOUNAHIUNDEZUMAUNUFUOUTVAAUNUGA
      UHSUNAUIUKUL $.
  $}

  ${
    ist1-5lem.1 $e |- ( J e. A -> J e. Kol2 ) $.
    ist1-5lem.2 $e |- ( J ~= ( KQ ` J ) ->
      ( J e. A -> ( KQ ` J ) e. A ) ) $.
    ist1-5lem.3 $e |- ( ( KQ ` J ) ~= J ->
      ( ( KQ ` J ) e. A -> J e. A ) ) $.
    $( Lemma for ~ ist1-5 and similar theorems.  If ` A ` is a topological
       property which implies T_0, such as T_1 or T_2, the property can be
       "decomposed" into T_0 and a non-T_0 version of property ` A ` (which is
       defined as stating that the Kolmogorov quotient of the space has
       property ` A ` ).  For example, if ` A ` is T_1, then the theorem states
       that a space is T_1 iff it is T_0 and its Kolmogorov quotient is T_1 (we
       call this property R_0).  (Contributed by Mario Carneiro,
       25-Aug-2015.) $)
    ist1-5lem $p |- ( J e. A <-> ( J e. Kol2 /\ ( KQ ` J ) e. A ) ) $=
      ( wcel ct0 ckq cfv wa chmph wbr kqhmph sylib mpcom jca hmphsym sylbi syl
      wi imp impbii ) BAFZBGFZBHIZAFZJUCUDUFCBUEKLZUCUFUCUDUGCBMZNDOPUDUFUCUDUE
      BKLZUFUCTUDUGUIUHBUEQRESUAUB $.
  $}

  $( A T_1 space is R_0.  That is, the Kolmogorov quotient of a T_1 space is
     also T_1 (because they are homeomorphic).  (Contributed by Mario Carneiro,
     25-Aug-2015.) $)
  t1r0 $p |- ( J e. Fre -> ( KQ ` J ) e. Fre ) $=
    ( ckq cfv chmph wbr ct1 wcel ct0 t1t0 kqhmph sylib t1hmph mpcom ) AABCZDEZA
    FGZNFGPAHGOAIAJKANLM $.

  $( A topological space is T_1 iff it is both T_0 and R_0.  (Contributed by
     Mario Carneiro, 25-Aug-2015.) $)
  ist1-5 $p |- ( J e. Fre <-> ( J e. Kol2 /\ ( KQ ` J ) e. Fre ) ) $=
    ( ct1 t1t0 ckq cfv t1hmph ist1-5lem ) BAACAADEZFHAFG $.

  $( A topological space is Hausdorff iff it is both T_0 and R_1 (where R_1
     means that any two topologically distinct points are separated by
     neighborhoods).  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
  ishaus3 $p |- ( J e. Haus <-> ( J e. Kol2 /\ ( KQ ` J ) e. Haus ) ) $=
    ( cha wcel ct1 ct0 haust1 t1t0 syl ckq cfv haushmph ist1-5lem ) BAABCADCAEC
    AFAGHAAIJZKMAKL $.

  $( A normal T_1 space is regular Hausdorff.  In other words, a T_4 space is
     T_3 .  One can get away with slightly weaker assumptions; see
     ~ nrmr0reg .  (Contributed by Mario Carneiro, 25-Aug-2015.) $)
  nrmreg $p |- ( ( J e. Nrm /\ J e. Fre ) -> J e. Reg ) $=
    ( ct1 wcel cnrm ckq cfv creg t1r0 nrmr0reg sylan2 ) ABCADCAEFBCAGCAHAIJ $.

  $( A regular T_0 space is Hausdorff.  In other words, a T_3 space is T_2 .  A
     regular Hausdorff or T_0 space is also known as a T_3 space.  (Contributed
     by Mario Carneiro, 24-Aug-2015.) $)
  reghaus $p |- ( J e. Reg -> ( J e. Haus <-> J e. Kol2 ) ) $=
    ( creg wcel cha ct0 ct1 haust1 t1t0 syl ckq cfv regr1 anim2i ishaus3 sylibr
    wa expcom impbid2 ) ABCZADCZAECZTAFCUAAGAHIUASTUASPUAAJKDCZPTSUBUAALMANOQR
    $.

  $( A T_1 normal space is Hausdorff.  A Hausdorff or T_1 normal space is also
     known as a T_4 space.  (Contributed by Mario Carneiro, 24-Aug-2015.) $)
  nrmhaus $p |- ( J e. Nrm -> ( J e. Haus <-> J e. Fre ) ) $=
    ( cnrm wcel cha ct1 haust1 creg nrmreg ex reghaus syl5ibrcom sylcom impbid2
    ct0 t1t0 ) ABCZADCZAECZAFPRAGCZQPRSAHIRQSANCAOAJKLM $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
              Filters and filter bases
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filter bases
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d v w x y z X $.  $d v w y z B $.  $d v x y C $.  $d v x z D $.
    $d v x y V $.  $d v w z ph $.  $d w x y Y $.  $d x y ps $.
    elmptrab.f $e |- F = ( x e. D |-> { y e. B | ph } ) $.
    elmptrab.s1 $e |- ( ( x = X /\ y = Y ) -> ( ph <-> ps ) ) $.
    elmptrab.s2 $e |- ( x = X -> B = C ) $.
    elmptrab.ex $e |- ( x e. D -> B e. V ) $.
    $( Membership in a one-parameter class of sets.  (Contributed by Stefan
       O'Rear, 28-Jul-2015.) $)
    elmptrab $p |- ( Y e. ( F ` X ) <-> ( X e. D /\ Y e. C /\ ps ) ) $=
      ( vw vz wcel wsbc nfv cfv w3a cdm crab dmmptss elfvdm sseldi simp1 cv csb
      wa cvv wceq csbeq1 dfsbcq rabeqbidv cmpt nfcv nfsbc1v nfcsb1v weq csbeq1a
      nfrab sbceq1a nfsbc wb equcoms sbccom syl6rbbr cbvrab syl6eqr eqtri nfel1
      cbvmpt wi nfim eleq1 eleq1d imbi12d chvar rabexg syl fvmpt3 sbcbidv elrab
      eleq2d a1i nfcvd csbiegf anbi1d sbc2iegf pm5.32da 3bitrd 3anass pm5.21nii
      baibr ) KJHUAZRZJGRZWSKFRZBUBZWRHUCGJCGADEUDZHLUEKJHUFUGWSWTBUHWSWRKADPUI
      ZSZCJSZPCJEUJZUDZRZWTBUKZXAWSWQXGKQJXDCQUIZSZPCXJEUJZUDZXGGHULXJJUMXKXEPX
      LXFCXJJEUNXDCXJJUOUPHCGXBUQQGXMUQLCQGXBXMQXBURXKCPXLXDCXJUSCXJEUTZVCCQVAZ
      XBACXJSZDXLUDXMXOAXPDEXLCXJEVBZACXJVDUPXKXPPDXLPXLURDXLURXDDCXJDXJURADXCU
      SVEXPPTPDVAXPXPDXCSZXKXPXRVFDPXPDXCVDVGACDXJXCVHVIVJVKVNVLXJGRZXLIRZXMULR
      CUIZGRZEIRZVOXSXTVOCQXSXTCXSCTCXLIXNVMVPXOYBXSYCXTYAXJGVQXOEXLIXQVRVSOVTX
      KPXLIWAWBWCWFWSXHKXFRZADKSZCJSZUKZWTYFUKXIXHYGVFWSXEYFPKXFXCKUMXDYECJADXC
      KUOWDWEWGWSYDWTYFWSXFFKCJEFGWSCFWHNWIWFWJWSWTYFBABCDJKGFBCTBDTWTCTMWKWLWM
      XAWSXIWSWTBWNWPWMWO $.
  $}

  ${
    $d x y ps $.  $d x y X $.  $d x y Y $.  $d x y C $.  $d x y V $.
    $d x y W $.  $d y B $.
    elmptrab2.f $e |- F = ( x e. _V |-> { y e. B | ph } ) $.
    elmptrab2.s1 $e |- ( ( x = X /\ y = Y ) -> ( ph <-> ps ) ) $.
    elmptrab2.s2 $e |- ( x = X -> B = C ) $.
    elmptrab2.ex $e |- B e. V $.
    elmptrab2.rc $e |- ( Y e. C -> X e. W ) $.
    $( Membership in a one-parameter class of sets, indexed by arbitrary base
       sets.  (Contributed by Stefan O'Rear, 28-Jul-2015.) $)
    elmptrab2 $p |- ( Y e. ( F ` X ) <-> ( Y e. C /\ ps ) ) $=
      ( cfv wcel cvv w3a wa cv a1i elmptrab 3simpc elex adantr simpl simpr 3jca
      syl impbii bitri ) KJGQRJSRZKFRZBTZUOBUAZABCDEFSGHJKLMNEHRCUBSROUCUDUPUQU
      NUOBUEUQUNUOBUOUNBUOJIRUNPJIUFUKUGUOBUHUOBUIUJULUM $.
  $}

  ${
    $d x y z w F $.  $d x y z w B $.
    $( The predicate " ` F ` is a filter base."  Note that some authors require
       filter bases to be closed under pairwise intersections, but that is not
       necessary under our definition.  One advantage of this definition is
       that tails in a directed set form a filter base under our meaning.
       (Contributed by Jeff Hankins, 1-Sep-2009.)  (Revised by Mario Carneiro,
       28-Jul-2015.) $)
    isfbas $p |- ( B e. A -> ( F e. ( fBas ` B ) <->
          ( F C_ ~P B /\ ( F =/= (/) /\ (/) e/ F /\
              A. x e. F A. y e. F ( F i^i ~P ( x i^i y ) ) =/= (/) ) ) ) ) $=
      ( vw vz wcel cpw c0 wne wnel cv cin wral w3a wa cvv cfbas wb pwexg elpw2g
      wss cfv syl anbi1d elex biantrurd bitr3d df-fbas wceq neeq1 neleq2 neeq1d
      ineq1 raleqbi1dv 3anbi123d adantl pweq pweqd vex pwex a1i elmptrab 3anass
      bitri syl6rbbr ) DCHZEDIZUCZEJKZJELZEAMBMNIZNZJKZBEOZAEOZPZQZDRHZEVIIZHZV
      RQZQZEDSUDHZVHWCVSWDVHWBVJVRVHVIRHWBVJTDCUAEVIRUBUEUFVHVTWCDCUGUHUIWEVTWB
      VRPWDFMZJKZJWFLZWFVMNZJKZBWFOZAWFOZPZVRGFGMZIZIZWARSRDEFABGUJWFEUKZWMVRTW
      NDUKZWQWGVKWHVLWLVQWFEJULWFEJUMWKVPAWFEWJVOBWFEWQWIVNJWFEVMUOUNUPUPUQURWR
      WOVIWNDUSUTWPRHWNRHWOWNGVAVBVBVCVDVTWBVRVEVFVG $.
  $}

  ${
    $d x y F $.  $d x y B $.
    $( There are no empty filter bases.  (Contributed by Jeff Hankins,
       1-Sep-2009.)  (Revised by Mario Carneiro, 28-Jul-2015.) $)
    fbasne0 $p |- ( F e. ( fBas ` B ) -> F =/= (/) ) $=
      ( vx vy cfbas cfv wcel cpw wss c0 wne wnel cv cin wral w3a wa cdm wb syl
      elfvdm isfbas ibi simpr1 ) BAEFGZBAHIZBJKZJBLZBCMDMNHNJKDBOCBOZPQZUGUEUJU
      EAERZGUEUJSBAEUACDUKABUBTUCUFUGUHUIUDT $.
  $}

  ${
    $d x y F $.  $d x y B $.
    $( No filter base contains the empty set.  (Contributed by Jeff Hankins,
       1-Sep-2009.)  (Revised by Mario Carneiro, 28-Jul-2015.) $)
    0nelfb $p |- ( F e. ( fBas ` B ) -> -. (/) e. F ) $=
      ( vx vy cfbas cfv wcel c0 wnel wn cpw wss wne cv cin wral w3a wa cdm syl
      wb elfvdm isfbas ibi simpr2 df-nel sylib ) BAEFGZHBIZHBGJUHBAKLZBHMZUIBCN
      DNOKOHMDBPCBPZQRZUIUHUMUHAESZGUHUMUABAEUBCDUNABUCTUDUJUKUIULUETHBUFUG $.
  $}

  ${
    $d F x y z $.  $d B x y z $.
    $( A filter base on a set is a subset of the power set.  (Contributed by
       Stefan O'Rear, 28-Jul-2015.) $)
    fbsspw $p |- ( F e. ( fBas ` B ) -> F C_ ~P B ) $=
      ( vx vy cfbas cfv wcel cpw wss c0 wne wnel cv cin wral w3a wa cdm elfvdm
      wb isfbas syl ibi simpld ) BAEFGZBAHIZBJKJBLBCMDMNHNJKDBOCBOPZUEUFUGQZUEA
      ERZGUEUHTBAESCDUIABUAUBUCUD $.

    $( An element of the filter base is a subset of the base set.  (Contributed
       by Stefan O'Rear, 28-Jul-2015.) $)
    fbelss $p |- ( ( F e. ( fBas ` B ) /\ X e. F ) -> X C_ B ) $=
      ( cfbas cfv wcel wa cpw fbsspw sselda elpwid ) BADEFZCBFGCALBAHCABIJK $.

    $( The domain of a filter base is nonempty.  (Contributed by Mario
       Carneiro, 28-Nov-2013.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    fbdmn0 $p |- ( F e. ( fBas ` B ) -> B =/= (/) ) $=
      ( vx cfbas cfv wcel c0 wn wne 0nelfb wceq fveq2 eleq2d biimpd wex fbasne0
      cv n0 sylib wa wss fbelss ss0 syl eqeltrrd exlimddv syl6com necon3bd mpd
      simpr ) BADEZFZGBFZHAGIABJULUMAGAGKZULBGDEZFZUMUNULUPUNUKUOBAGDLMNUPCQZBF
      ZUMCUPBGIURCOGBPCBRSUPURTZUQGBUSUQGUAUQGKGBUQUBUQUCUDUPURUJUEUFUGUHUI $.
  $}

  ${
    $d x y z F $.  $d x y z B $.
    $( The predicate " ` F ` is a filter base."  (Contributed by Jeff Hankins,
       1-Sep-2009.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    isfbas2 $p |- ( B e. A -> ( F e. ( fBas ` B ) <->
          ( F C_ ~P B /\ ( F =/= (/) /\ (/) e/ F /\
              A. x e. F A. y e. F E. z e. F z C_ ( x i^i y ) ) ) ) ) $=
      ( wcel cfbas cfv cpw wss c0 wne cv cin wral w3a wa wex anbi2i wnel isfbas
      wrex elin vex elpw bitri exbii n0 df-rex 3bitr4i 2ralbii 3anbi3i syl6bb )
      EDGFEHIGFEJKZFLMZLFUAZFANBNOZJZOZLMZBFPAFPZQZRUOUPUQCNZURKZCFUCZBFPAFPZQZ
      RABDEFUBVCVHUOVBVGUPUQVAVFABFFVDUTGZCSVDFGZVERZCSVAVFVIVKCVIVJVDUSGZRVKVD
      FUSUDVLVEVJVDURCUEUFTUGUHCUTUIVECFUJUKULUMTUN $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z X $.
    $( A filter base contains subsets of its pairwise intersections.
       (Contributed by Jeff Hankins, 1-Sep-2009.)  (Revised by Jeff Hankins,
       1-Dec-2010.) $)
    fbasssin $p |- ( ( F e. ( fBas ` X ) /\ A e. F /\ B e. F ) ->
        E. x e. F x C_ ( A i^i B ) ) $=
      ( vy vz cfbas cfv wcel cv cin wss wrex wral wa c0 wceq sseq2d rexbidv wne
      wnel cpw w3a cdm elfvdm isfbas2 syl ibi simprd simp3d ineq1 ineq2 syl5com
      wb rspc2v 3impib ) DEHIJZBDJZCDJZAKZBCLZMZADNZURVAFKZGKZLZMZADNZGDOFDOZUS
      UTPVDURDQUAZQDUBZVJURDEUCMZVKVLVJUDZURVMVNPZUREHUEZJURVOUODEHUFFGAVPEDUGU
      HUIUJUKVIVDVABVFLZMZADNFGBCDDVEBRZVHVRADVSVGVQVAVEBVFULSTVFCRZVRVCADVTVQV
      BVAVFCBUMSTUPUNUQ $.
  $}

  ${
    $d t x A $.  $d t u v x y z F $.  $d t u v x y z B $.  $d u v x y z X $.
    $( A filter base contains subsets of its finite intersections.
       (Contributed by Mario Carneiro, 26-Nov-2013.)  (Revised by Stefan
       O'Rear, 28-Jul-2015.) $)
    fbssfi $p |- ( ( F e. ( fBas ` X ) /\ A e. ( fi ` F ) ) ->
        E. x e. F x C_ A ) $=
      ( vt vz vu vv vy wcel wa cv wss wrex wral wi wceq sseq2 rexbidv cvv cfbas
      cfv cfi cuni cpw crab cin cab cint dffi2 inss1 simp1r elpwid syl5ss inex1
      w3a vex elpw sylibr simpl fbasssin syl3an ss2in ad2ant2l 3adant1 sstr syl
      expcom reximdv mpd elrab sylanbrc 3expa rexlimdvaa ralrimivw sseq1 syl6bb
      ralrab ralrimiva pwuni ssid rspcev mpan2 rgen ssrab mpbir2an jctil uniexg
      cbvrexv wb pwexg rabexg eleq2 raleqbi1dv anbi12d elabg 4syl mpbird intss1
      eqsstrd sselda simprbi ) CDUAUBZJZBCUCUBZJKBALZELZMZACNZECUDZUEZUFZJZXFBM
      ZACNZXDXEXLBXDXECFLZMZGLZHLZUGZXPJZHXPOZGXPOZKZFUHZUIZXLGHFCXCUJXDXLYEJZY
      FXLMXDYGCXLMZXTXLJZHXLOZGXLOZKZXDYKYHXDILZXRMZICNZYJPZGXKOYKXDYPGXKXDXRXK
      JZKZYNYJICYRYMCJZYNKZKZXPXSMZFCNZYIPZHXKOYJUUAUUDHXKUUAUUBYIFCYRYTXPCJZUU
      BKZYIYRYTUUFUPZXTXKJZXFXTMZACNZYIUUGXTXJMUUHUUGXTXRXJXRXSUKUUGXRXJXDYQYTU
      UFULUMUNXTXJXRXSGUQUOURUSUUGXFYMXPUGZMZACNZUUJYRXDYTYSUUFUUEUUMXDYQUTYSYN
      UTUUEUUBUTAYMXPCDVAVBUUGUULUUIACUUGUUKXTMZUULUUIPYTUUFUUNYRYNUUBUUNYSUUEY
      MXRXPXSVCVDVEUULUUNUUIXFUUKXTVFVHVGVIVJXIUUJEXTXKXGXTQXHUUIACXGXTXFRSVKVL
      VMVNVOXIUUCYIHEXKXGXSQZXIXFXSMZACNUUCUUOXHUUPACXGXSXFRSUUPUUBAFCXFXPXSVPW
      IVQVRUSVNVSXIYOYJGEXKXGXRQZXIXFXRMZACNYOUUQXHUURACXGXRXFRSUURYNAICXFYMXRV
      PWIVQVRUSYHCXKMXIECOCVTXIECXGCJXGXGMZXIXGWAXHUUSAXGCXFXGXGVPWBWCWDXIEXKCW
      EWFWGXDXJTJXKTJXLTJYGYLWJCXCWHXJTWKXIEXKTWLYDYLFXLTXPXLQXQYHYCYKXPXLCRYBY
      JGXPXLYAYIHXPXLXPXLXTWMWNWNWOWPWQWRXLYEWSVGWTXAXMBXKJXOXIXOEBXKXGBQXHXNAC
      XGBXFRSVKXBVG $.
  $}

  ${
    $d f g k n t x y z A $.  $d f g k n t x y z F $.  $d x B $.
    $( A filter base contains subsets of its finite intersections.
       (Contributed by Jeff Hankins, 1-Sep-2009.)  (Revised by Stefan O'Rear,
       28-Jul-2015.) $)
    fbssint $p |- ( ( F e. ( fBas ` B ) /\ A C_ F /\ A e. Fin ) ->
        E. x e. F x C_ |^| A ) $=
      ( cfbas cfv wcel wss cfn w3a cv cint wrex c0 wceq wi cvv wex wne wa sylib
      fbasne0 ssv jctr eximi df-rex sylibr syl inteq int0 syl6eq sseq2d rexbidv
      syl5ibrcom 3ad2ant1 cfi simpl1 simpl2 simpr simpl3 elfir syl13anc syl2anc
      n0 fbssfi ex pm2.61dne ) DCEFZGZBDHZBIGZJZAKZBLZHZADMZBNVIVJBNOZVPPVKVIVP
      VQVMQHZADMZVIVMDGZARZVSVIDNSWACDUBADVDUAWAVTVRTZARVSVTWBAVTVRVMUCUDUEVRAD
      UFUGUHVQVOVRADVQVNQVMVQVNNLQBNUIUJUKULUMUNUOVLBNSZVPVLWCTZVIVNDUPFGZVPVIV
      JVKWCUQZWDVIVJWCVKWEWFVIVJVKWCURVLWCUSVIVJVKWCUTBDVHVAVBAVNDCVEVCVFVG $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x X $.
    $( A filter base does not contain complements of its elements.
       (Contributed by Mario Carneiro, 26-Nov-2013.)  (Revised by Stefan
       O'Rear, 28-Jul-2015.) $)
    fbncp $p |- ( ( F e. ( fBas ` X ) /\ A e. F ) -> -. ( B \ A ) e. F ) $=
      ( vx cfbas cfv wcel wa cdif c0 wn 0nelfb adantr w3a cin wss wrex fbasssin
      cv wceq disjdif sseq2i ss0 sylbi biimpac sylan2 rexlimiva syl 3expia mtod
      eleq1 ) CDFGHZACHZIBAJZCHZKCHZUMUQLUNDCMNUMUNUPUQUMUNUPOETZAUOPZQZECRUQEA
      UOCDSUTUQECUTURCHZURKUAZUQUTURKQVBUSKURABUBUCURUDUEVBVAUQURKCULUFUGUHUIUJ
      UK $.
  $}

  ${
    $d w x y z G $.  $d w x y z F $.  $d w x y z X $.
    $( A necessary and sufficient condition for the union of two filter bases
       to also be a filter base.  (Contributed by Mario Carneiro,
       28-Nov-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    fbun $p |- ( ( F e. ( fBas ` X ) /\ G e. ( fBas ` X ) ) ->
        ( ( F u. G ) e. ( fBas ` X ) <->
          A. x e. F A. y e. G E. z e. ( F u. G ) z C_ ( x i^i y ) ) ) $=
      ( vw cfbas wcel wa cv cin wss wrex wral fbasssin 3expb c0 adantr wn elun1
      cfv cun elun2 anim12i sylan2 ralrimivva cpw wne wnel w3a fbsspw unssd a1d
      adantl ssun1 fbasne0 ssn0 sylancr 0nelfb df-nel elun notbii ioran biimpri
      wo 3bitri syl2an ssrexv mpsyl pm3.2 syl r19.26 ralun ralimi sylbir ralcom
      wi syl6 weq ineq1 sseq2d rexbidv cbvralv ralbii ineq2 incom syl6eq biimpi
      cbvral2v ssun2 expcom jcad 3jcad cdm wb elfvdm isfbas2 sylibrd impbid2 )
      DFHUBZIZEXAIZJZDEUCZXAIZCKZAKZBKZLZMZCXENZBEOZADOZXFXLABDEXHDIZXIEIZJXFXH
      XEIZXIXEIZJXLXOXQXPXRXHDEUAXIEDUDUEXFXQXRXLCXHXIXEFPQUFUGXDXNXEFUHZMZXERU
      IZRXEUJZXLBXEOZAXEOZUKZJZXFXDXNXTYEXDXTXNXDDEXSXBDXSMXCFDULSXCEXSMXBFEULU
      OUMUNXDXNYAYBYDXDYAXNXBYAXCXBDXEMZDRUIYADEUPZFDUQDXEURUSSUNXDYBXNXBRDIZTZ
      REIZTZYBXCFDUTFEUTYBYJYLJZYBRXEIZTYIYKVFZTYMRXEVAYNYORDEVBVCYIYKVDVGVEVHU
      NXDXNYCADOZYCAEOZJYDXDXNYPYQXDXNXLBDOZADOZXNJZYPXDYSXNYTVRXBYSXCXBXLABDDX
      BXOXIDIZXLYGXBXOUUAUKXKCDNXLYHCXHXIDFPXKCDXEVIVJQUGSYSXNVKVLYTYRXMJZADOYP
      YRXMADVMUUBYCADXLBDEVNZVOVPVSXDXNYRAEOZXMAEOZJZYQXNXDUUFXNUUDXDUUEXNUUDXN
      XLADOZBEOXGGKZXILZMZCXENZGDOZBEOUUDXLABDEVQUUGUULBEXLUUKAGDAGVTZXKUUJCXEU
      UMXJUUIXGXHUUHXIWAWBWCWDWEUUKXLXGUUHXHLZMZCXENBGABEDBAVTZUUJUUOCXEUUPUUIU
      UNXGXIXHUUHWFWBWCGBVTZUUOXKCXEUUQUUNXJXGUUQUUNXIXHLXJUUHXIXHWAXIXHWGWHWBW
      CWJVGWIXCUUEXBXCXLABEEXCXHEIZXPXLEXEMXCUURXPUKXKCENXLEDWKCXHXIEFPXKCEXEVI
      VJQUGUOUEWLUUFUUBAEOYQYRXMAEVMUUBYCAEUUCVOVPVSWMYCADEVNVSWNWMXDFHWOZIZXFY
      FWPXBUUTXCDFHWQSABCUUSFXEWRVLWSWT $.
  $}

  ${
    $d x y z F $.  $d x S $.  $d x y z B $.
    $( No filter base containing a finite element is free.  (Contributed by
       Jeff Hankins, 5-Dec-2009.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    fbfinnfr $p |- ( ( F e. ( fBas ` B ) /\ S e. F /\ S e. Fin ) ->
        |^| F =/= (/) ) $=
      ( vx vy vz wcel cfn c0 wne wa cv wi wceq eleq1 anbi2d imbi1d wss wn wrex
      cfbas cfv cint wpss wal wral wb ibar adantr bi2.04 syl6rbbr albidv df-ral
      syl6bbr 0nelfb notbid syl5ibrcom necon2ad imp ssn0 ex syl5com a1dd notbii
      rexnal bitr4i w3a fbasssin nssinpss sspsstr sylan2b expcom reximdv 3expia
      ssint cin rexlimdv syl5bi r19.29 id rexlimivw syl syl6 pm2.61d sylbid a1i
      com12 findcard3 3impia ) CAUAUBGZBCGZBHGZCUCZIJZWLWJWKKZWNWJDLZCGZKZWNMZW
      JELZCGZKZWNMZWOWNMDEBWPWTNZWRXBWNXDWQXAWJWPWTCOPQWPBNZWRWOWNXEWQWKWJWPBCO
      PQWPWTUDZWSMZDUEZXCMWTHGXBXHWNXBXHXFWNMZDCUFZWNXBXHWQXIMZDUEXJXBXGXKDXBXK
      WRXIMXGXBWQWRXIWJWQWRUGXAWJWQUHUIQXFWRWNUJUKULXIDCUMUNXBWTWMRZXJWNMZXBXLW
      NXJXBWTIJZXLWNWJXAXNWJXAWTIWJXASWTINZICGZSACUOXOXAXPWTICOUPUQURUSXLXNWNWT
      WMUTVAVBVCXBXLSZXFDCTZXMXQWTFLZRZSZFCTZXBXRXQXTFCUFZSYBXLYCFWTCVOVDXTFCVE
      VFXBYAXRFCWJXAXSCGZYAXRMWJXAYDVGWPWTXSVPZRZDCTYAXRDWTXSCAVHYAYFXFDCYFYAXF
      YAYFYEWTUDXFWTXSVIWPYEWTVJVKVLVMVBVNVQVRXJXRWNXJXRKXIXFKZDCTWNXIXFDCVSYGW
      NDCXIXFWNXIVTUSWAWBVLWCWDWEWGWFWHWGWI $.
  $}

  ${
    $d r s t x J $.  $d r s t x S $.  $d r s t x X $.
    opnfbas.1 $e |- X = U. J $.
    $( The collection of open supersets of a nonempty set in a topology is a
       neighborhoods of the set, one of the motivations for the filter
       concept.  (Contributed by Jeff Hankins, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 7-Aug-2015.) $)
    opnfbas $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) ->
        { x e. J | S C_ x } e. ( fBas ` X ) ) $=
      ( vt vr vs wcel wss c0 wne w3a cv wral wa sseq2 elrab sylibr wn ctop crab
      cfbas cfv cpw wnel cin wrex ssrab2 cuni eqimss2i sspwuni mpbir a1i topopn
      sstri anim1i 3adant3 ne0i syl ss0 necon3ai 3ad2ant3 intnand df-nel notbii
      bitr2i sylib anbi12i simpl simprll simprrl syl3anc biimpi ad2ant2l adantl
      inopn ssin jca 3ad2antl1 ssid sseq1 rspcev sylancl ex syl5bi ralrimivv wb
      3jca isfbas2 3ad2ant1 mpbir2and ) CUAIZBDJZBKLZMZBANZJZACUBZDUCUDIZWSDUEZ
      JZWSKLZKWSUFZFNZGNZHNZUGZJZFWSUHZHWSOGWSOZMZXBWPWSCXAWRACUICXAJCUJZDJDXME
      UKCDULUMUPUNWPXCXDXKWPDWSIZXCWPDCIZWNPZXNWMWNXPWOWMXOWNCDEUOZUQURWRWNADCW
      QDBQRSWSDUSUTWPKCIZBKJZPZTZXDWPXSXRWOWMXSTWNXSBKBVAVBVCVDXDKWSIZTYAKWSVEY
      BXTWRXSAKCWQKBQRVFVGVHWPXJGHWSWSXFWSIZXGWSIZPXFCIZBXFJZPZXGCIZBXGJZPZPZWP
      XJYCYGYDYJWRYFAXFCWQXFBQRWRYIAXGCWQXGBQRVIWPYKXJWPYKPZXHWSIZXHXHJZXJYLXHC
      IZBXHJZPZYMWMWNYKYQWOWMYKPZYOYPYRWMYEYHYOWMYKVJWMYEYFYJVKWMYGYHYIVLXFXGCV
      QVMYKYPWMYFYIYPYEYHYFYIPYPBXFXGVRVNVOVPVSVTWRYPAXHCWQXHBQRSXHWAXIYNFXHWSX
      EXHXHWBWCWDWEWFWGWIWMWNWTXBXLPWHZWOWMXOYSXQGHFCDWSWJUTWKWL $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z F $.  $d w x y z Y $.
    $( Conditions for the trace of a filter base ` F ` to be a filter base.
       (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    trfbas2 $p |- ( ( F e. ( fBas ` Y ) /\ A C_ Y ) ->
      ( ( F |`t A ) e. ( fBas ` A ) <-> -. (/) e. ( F |`t A ) ) ) $=
      ( vx vy vz vw cfbas wcel wss wa c0 cvv cpw wne cv cin wral wb a1i co wnel
      cfv crest wn cdm elfvdm ssexg ancoms sylan restsspw wex fbasne0 adantr n0
      sylib elrestr 3expia syldan ne0i syl6 exlimdv wrex fbasssin 3expb adantlr
      wi mpd simplll ad2antrr simprl syl3anc ssrin ad2antll inex1 sylibr inelcm
      vex elpw syl2anc rexlimddv ralrimivva elrest ineq12 inindir syl6eqr pweqd
      wceq ineq2d neeq1d adantll ralxfr2d mpbird isfbas 3anan32 syl6bb syl22anc
      w3a baibd df-nel ) BCHUCZIZACJZKZBAUDUAZAHUCIZLXEUBZLXEIUEXDAMIZXEANJZXEL
      OZXEDPZEPZQZNZQZLOZEXERZDXERZXFXGSXBCHUFZIZXCXHBCHUGXCXTXHACXSUHUIUJZXIXD
      ABUKTXDXKBIZDULZXJXDBLOZYCXBYDXCCBUMUNDBUOUPXDYBXJDXDYBXKAQZXEIZXJXBXCXHY
      BYFVGYAXBXHYBYFXKABXAMUQZURUSXEYEUTVAVBVHXDXRXEFPZGPZQZAQZNZQZLOZGBRZFBRX
      DYNFGBBXDYHBIZYIBIZKZKZXKYJJZYNDBXBYRYTDBVCZXCXBYPYQUUADYHYIBCVDVEVFYSYBY
      TKZKZYFYEYLIZYNUUCXBXHYBYFXBXCYRUUBVIXDXHYRUUBYAVJYSYBYTVKYGVLUUCYEYKJZUU
      DYTUUEYSYBXKYJAVMVNYEYKXKADVRVOVSVPYEXEYLVQVTWAWBXDXQYODFYHAQZXEBMUUFMIXD
      YPKYHAFVRVOTXBXCXHXKXEIXKUUFWHZFBVCSYAFXKABXAMWCUSXDUUGKZXPYNEGYIAQZXEBMU
      UIMIUUHYQKYIAGVRVOTXDXLXEIXLUUIWHZGBVCSZUUGXBXCXHUUKYAGXLABXAMWCUSUNUUGUU
      JXPYNSXDUUGUUJKZXOYMLUULXNYLXEUULXMYKUULXMUUFUUIQYKXKUUFXLUUIWDYHYIAWEWFW
      GWIWJWKWLWLWMXHXIKZXFXJXRKZXGUUMXFXJXGXRWRZUUNXGKXHXFXIUUODEMAXEWNWSXJXGX
      RWOWPWSWQLXEWTWP $.

    $( Conditions for the trace of a filter base ` F ` to be a filter base.
       (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    trfbas $p |- ( ( F e. ( fBas ` Y ) /\ A C_ Y ) ->
      ( ( F |`t A ) e. ( fBas ` A ) <-> A. v e. F ( v i^i A ) =/= (/) ) ) $=
      ( cfbas cfv wcel wss wa crest co c0 wn cv cin wne wral trfbas2 wceq cvv
      wb cdm elfvdm ssexg ancoms sylan elrest syldan notbid nesym ralbii ralnex
      wrex bitri syl6bbr bitrd ) CDEFZGZBDHZIZCBJKZBEFGLVAGZMZANBOZLPZACQZBCDRU
      TVCLVDSZACUMZMZVFUTVBVHURUSBTGZVBVHUAURDEUBZGZUSVJCDEUCUSVLVJBDVKUDUEUFAL
      BCUQTUGUHUIVFVGMZACQVIVEVMACVDLUJUKVGACULUNUOUP $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filters
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Fil $. $( The class of all filters. $)

  $( Extend class notation with the set of filters on a set. $)
  cfil $a class Fil $.

  ${
    $d f x y z $.
    $( The set of filters on a set.  Definition 1 (axioms FI, FIIa, FIIb, FIII)
       of [BourbakiTop1] p.  I.36.  Filters are used to define the concept of
       limit in the general case.  They are a generalization of the idea of
       neighborhoods.  Suppose you are in ` RR ` .  With neighborhoods you can
       express the idea of a variable that tends to a specific number but you
       can't express the idea of a variable that tends to infinity.  Filters
       relax the "axioms" of neighborhoods and then succeed in expressing the
       idea of something that tends to infinity.  Filters were invented by
       Cartan in 1937 and made famous by Bourbaki in his treatise.  A notion
       similar to the notion of filter is the concept of net invented by Moore
       and Smith in 1922.  (Contributed by FL, 20-Jul-2007.)  (Revised by
       Stefan O'Rear, 28-Jul-2015.) $)
    df-fil $a |- Fil = ( z e. _V |-> { f e. ( fBas ` z ) |
      A. x e. ~P z ( ( f i^i ~P x ) =/= (/) -> x e. f ) } ) $.
  $}

  ${
    $d F f x z $.  $d X f x z $.
    $( The predicate "is a filter."  (Contributed by FL, 20-Jul-2007.)
       (Revised by Mario Carneiro, 28-Jul-2015.) $)
    isfil $p |- ( F e. ( Fil ` X ) <-> ( F e. ( fBas ` X ) /\
          A. x e. ~P X ( ( F i^i ~P x ) =/= (/) -> x e. F ) ) ) $=
      ( vf vz cv cpw cin c0 wne wcel wi wral cfbas cfv cfil cvv cdm df-fil wceq
      wa pweq adantr wb ineq1 neeq1d eleq2 imbi12d adantl raleqbidv fvex elfvdm
      fveq2 elmptrab2 ) DFZAFZGZHZIJZUPUOKZLZAEFZGZMBUQHZIJZUPBKZLZACGZMEDVBNOC
      NOPQNRCBAEDSVBCTZUOBTZUAVAVGAVCVHVIVCVHTVJVBCUBUCVJVAVGUDVIVJUSVEUTVFVJUR
      VDIUOBUQUEUFUOBUPUGUHUIUJVBCNUMVBNUKBCNULUN $.
  $}

  ${
    $d x y F $.  $d x y X $.
    $( A filter is a filter base.  (Contributed by Jeff Hankins, 2-Sep-2009.)
       (Revised by Mario Carneiro, 28-Jul-2015.) $)
    filfbas $p |- ( F e. ( Fil ` X ) -> F e. ( fBas ` X ) ) $=
      ( vx cfil cfv wcel cfbas cv cpw cin c0 wne wi wral isfil simplbi ) ABDEFA
      BGEFACHZIJKLQAFMCBINCABOP $.
  $}

  $( The empty set doesn't belong to a filter.  (Contributed by FL,
     20-Jul-2007.)  (Revised by Mario Carneiro, 28-Jul-2015.) $)
  0nelfil $p |- ( F e. ( Fil ` X ) -> -. (/) e. F ) $=
    ( cfil cfv wcel cfbas c0 wn filfbas 0nelfb syl ) ABCDEABFDEGAEHABIBAJK $.

  $( An element of a filter is nonempty.  (Contributed by FL, 24-May-2011.)
     (Revised by Mario Carneiro, 28-Jul-2015.) $)
  fileln0 $p |- ( ( F e. ( Fil ` X ) /\ A e. F ) -> A =/= (/) ) $=
    ( wcel c0 wn wne cfil cfv id 0nelfil nelne2 syl2anr ) ABDZNEBDFAEGBCHIDNJBC
    KAEBLM $.

  $( A filter is a subset of the power set of the base set.  (Contributed by
     Stefan O'Rear, 28-Jul-2015.) $)
  filsspw $p |- ( F e. ( Fil ` X ) -> F C_ ~P X ) $=
    ( cfil cfv wcel cfbas cpw wss filfbas fbsspw syl ) ABCDEABFDEABGHABIBAJK $.

  $( An element of a filter is a subset of the base set.  (Contributed by
     Stefan O'Rear, 28-Jul-2015.) $)
  filelss $p |- ( ( F e. ( Fil ` X ) /\ A e. F ) -> A C_ X ) $=
    ( cfil cfv wcel cfbas wss filfbas fbelss sylan ) BCDEFBCGEFABFACHBCICBAJK
    $.

  ${
    $d B x $.  $d F x $.  $d X x $.
    $( A filter is closed under taking supersets.  (Contributed by FL,
       20-Jul-2007.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    filss $p |- ( ( F e. ( Fil ` X ) /\ ( A e. F /\ B C_ X /\ A C_ B ) ) ->
        B e. F ) $=
      ( vx cfil cfv wcel wss w3a wa cv cpw cin c0 wne wi wral cfbas isfil simp2
      simprbi adantr elfvdm elpw2g biimpar syl2an simpr1 simpr3 wb elpwg mpbird
      cdm syl inelcm syl2anc wceq pweq ineq2d neeq1d eleq1 imbi12d rspccv syl3c
      ) CDFGHZACHZBDIZABIZJZKZCELZMZNZOPZVKCHZQZEDMZRZBVQHZCBMZNZOPZBCHZVEVRVIV
      ECDSGHVRECDTUBUCVEDFUMZHZVGVSVICDFUDVFVGVHUAWEVSVGBDWDUEUFUGVJVFAVTHZWBVE
      VFVGVHUHZVJWFVHVEVFVGVHUIVJVFWFVHUJWGABCUKUNULACVTUOUPVPWBWCQEBVQVKBUQZVN
      WBVOWCWHVMWAOWHVLVTCVKBURUSUTVKBCVAVBVCVD $.
  $}

  ${
    $d A x $.  $d B x $.  $d F x $.  $d X x $.
    $( A filter is closed under taking intersections.  (Contributed by FL,
       20-Jul-2007.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    filin $p |- ( ( F e. ( Fil ` X ) /\ A e. F /\ B e. F ) ->
        ( A i^i B ) e. F ) $=
      ( vx cfil cfv wcel w3a cv cin wss cfbas filfbas fbasssin syl3an1 wi inss1
      wrex wa filelss syl5ss filss 3exp2 com23 imp rexlimdv syldan 3adant3 mpd
      ) CDFGHZACHZBCHZIEJZABKZLZECSZUOCHZUKCDMGHULUMUQCDNEABCDOPUKULUQURQZUMUKU
      LUODLZUSUKULTUOADABRACDUAUBUKUTTUPURECUKUTUNCHZUPURQZQUKVAUTVBUKVAUTUPURU
      NUOCDUCUDUEUFUGUHUIUJ $.
  $}

  ${
    $d F x $.  $d X x $.
    $( The underlying set belongs to the filter.  (Contributed by FL,
       20-Jul-2007.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    filtop $p |- ( F e. ( Fil ` X ) -> X e. F ) $=
      ( vx cfil cfv wcel c0 wne cfbas filfbas fbasne0 syl cv wex n0 wss filelss
      wa wi mpd ssid filss 3exp2 imp mpi ex exlimdv syl5bi ) ABDEFZAGHZBAFZUIAB
      IEFUJABJBAKLUJCMZAFZCNUIUKCAOUIUMUKCUIUMUKUIUMRZULBPZUKULABQUNBBPZUOUKSZB
      UAUIUMUPUQSUIUMUPUOUKULBABUBUCUDUETUFUGUHT $.
  $}

  ${
    $d F x y z $.  $d X x y z $.
    $( Derive the standard axioms of a filter.  (Contributed by Mario Carneiro,
       27-Nov-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    isfil2 $p |- ( F e. ( Fil ` X ) <->
        ( ( F C_ ~P X /\ -. (/) e. F /\ X e. F ) /\
          A. x e. ~P X ( E. y e. F y C_ x -> x e. F ) /\
          A. x e. F A. y e. F ( x i^i y ) e. F ) ) $=
      ( vz cfv wcel cpw wss c0 w3a cv wrex wi wral cin 3jca elpwi wa ralimi imp
      cfil wn filsspw 0nelfil filtop filss 3exp2 com23 rexlimdv ralrimiva filin
      sylan2 3expb ralrimivva cfbas wne wnel simp11 simp13 simp12 df-nel sylibr
      ne0i syl ssid sseq1 rspcev mpan2 3ad2ant3 wb isfbas2 mpbir2and wex anim2i
      n0 elin sylbi eximi df-rex imim1i 3ad2ant2 isfil sylanbrc impbii ) CDUBFG
      ZCDHZIZJCGUCZDCGZKZBLZALZIZBCMZWMCGZNZAWGOZWMWLPZCGZBCOZACOZKZWFWKWRXBWFW
      HWIWJCDUDCDUECDUFQWFWQAWGWMWGGWFWMDIZWQWMDRWFXDSWNWPBCWFXDWLCGZWNWPNZNWFX
      EXDXFWFXEXDWNWPWLWMCDUGUHUIUAUJUMUKWFWTABCCWFWPXEWTWMWLCDULUNUOQXCCDUPFGZ
      CWMHZPZJUQZWPNZAWGOZWFXCXGWHCJUQZJCURZELZWSIZECMZBCOZACOZKZWHWIWJWRXBUSXC
      XMXNXSXCWJXMWHWIWJWRXBUTZCDVDVEXCWIXNWHWIWJWRXBVAJCVBVCXBWKXSWRXAXRACWTXQ
      BCWTWSWSIZXQWSVFXPYBEWSCXOWSWSVGVHVITTVJQXCWJXGWHXTSVKYAABECDCVLVEVMWRWKX
      LXBWQXKAWGXJWOWPXJXEWNSZBVNZWOXJWLXIGZBVNYDBXIVPYEYCBYEXEWLXHGZSYCWLCXHVQ
      YFWNXEWLWMRVOVRVSVRWNBCVTVCWATWBACDWCWDWE $.
  $}

  ${
    $d x y A $.  $d z A $.  $d x y F $.  $d y z F $.  $d x y ph $.
    $d y z ph $.  $d y ps $.  $d y B $.
    isfild.1 $e |- ( ph -> ( x e. F <-> ( x C_ A /\ ps ) ) ) $.
    isfild.2 $e |- ( ph -> A e. _V ) $.
    $( Lemma for ~ isfild .  (Contributed by Mario Carneiro, 1-Dec-2013.) $)
    isfildlem $p |- ( ph -> ( B e. F <-> ( B C_ A /\ [. B / x ]. ps ) ) ) $=
      ( vy cvv wcel wss wsbc wa wi wb cv eleq1 sseq1 nfv elex a1i ssexg adantrd
      expcom syl wceq dfsbcq anbi12d bibi12d nfsbc1v nfan nfbi nfim weq sbceq1a
      imbi2d chvar vtoclg com12 pm5.21ndd ) AEJKZEFKZEDLZBCEMZNZVCVBOAEFUAUBAVD
      VBVEADJKZVDVBOHVDVGVBEDJUCUEUFUDVBAVCVFPZAIQZFKZVIDLZBCVIMZNZPZOZAVHOIEJV
      IEUGZVNVHAVPVJVCVMVFVIEFRVPVKVDVLVEVIEDSBCVIEUHUIUJUQACQZFKZVQDLZBNZPZOVO
      CIAVNCACTVJVMCVJCTVKVLCVKCTBCVIUKULUMUNCIUOZWAVNAWBVRVJVTVMVQVIFRWBVSVKBV
      LVQVIDSBCVIUPUIUJUQGURUSUTVA $.

    isfild.3 $e |- ( ph -> [. A / x ]. ps ) $.
    isfild.4 $e |- ( ph -> -. [. (/) / x ]. ps ) $.
    isfild.5 $e |- ( ( ph /\ y C_ A /\ z C_ y ) ->
                     ( [. z / x ]. ps -> [. y / x ]. ps ) ) $.
    isfild.6 $e |- ( ( ph /\ y C_ A /\ z C_ A )
      -> ( ( [. y / x ]. ps /\ [. z / x ]. ps )
          -> [. ( y i^i z ) / x ]. ps ) ) $.
    $( Sufficient condition for a set of the form ` { x e. ~P A | ph } ` to be
       a filter.  (Contributed by Mario Carneiro, 1-Dec-2013.)  (Revised by
       Stefan O'Rear, 2-Aug-2015.) $)
    isfild $p |- ( ph -> F e. ( Fil ` A ) ) $=
      ( wss c0 wcel wi wa wsbc isfildlem cpw wn w3a wrex wral cin cfil cfv elpw
      cv vex biimpri adantr syl6bi ssrdv simpr mtod ssid jctil 3jca elpwi simp2
      mpbird adantld wb 3ad2ant1 3imtr4d 3expa impancom rexlimdva syl5 ralrimiv
      jctild ex ssinss1 ad2antrr a1i an4 3expb expimpd syl5bi anbi12d ralrimivv
      jcad isfil2 syl3anbrc ) AGFUAZNZOGPZUBZFGPZUCEUJZDUJZNZEGUDWMGPZQZDWGUEWM
      WLUFZGPZEGUEDGUEGFUGUHPAWHWJWKACGWGACUJZGPWSFNZBRWSWGPZHWTXABXAWTWSFCUKUI
      ULUMUNUOAWIBCOSZKAWIOFNZXBRXBABCFOGHITXCXBUPUNUQAWKFFNZBCFSZRAXEXDJFURUSA
      BCFFGHITVCUTAWPDWGWMWGPWMFNZAWPWMFVAAXFWPAXFRZWNWOEGXGWNWLGPZWOAXFWNXHWOQ
      AXFWNUCZWLFNZBCWLSZRZXFBCWMSZRZXHWOXIXKXNXJXIXKXMXFLAXFWNVBVMVDAXFXHXLVEW
      NABCFWLGHITZVFAXFWOXNVEWNABCFWMGHITZVFVGVHVIVJVNVKVLAWRDEGGAXNXLRZWQFNZBC
      WQSZRWOXHRWRAXQXRXSXQXRQAXFXRXMXLWMWLFVOVPVQXQXFXJRZXMXKRZRAXSXFXMXJXKVRA
      XTYAXSAXFXJYAXSQMVSVTWAWDAWOXNXHXLXPXOWBABCFWQGHITVGWCDEGFWEWF $.
  $}

  ${
    $d F x y $.  $d X x y $.
    $( A filter is closed under taking intersections.  (Contributed by Mario
       Carneiro, 27-Nov-2013.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
    filfi $p |- ( F e. ( Fil ` X ) -> ( fi ` F ) = F ) $=
      ( vx vy cfil cfv wcel cv cin wral cfi filin 3expib ralrimivv inficl mpbid
      wceq ) ABEFZGZCHZDHZIAGZDAJCAJAKFAQSUBCDAASTAGUAAGUBTUAABLMNCDAROP $.
  $}

  $( The intersection of two elements of a filter can't be empty.  (Contributed
     by FL, 16-Sep-2007.)  (Revised by Stefan O'Rear, 28-Jul-2015.) $)
  filinn0 $p |- ( ( F e. ( Fil ` X ) /\ A e. F /\ B e. F ) ->
      ( A i^i B ) =/= (/) ) $=
    ( cfil cfv wcel w3a cin c0 wne simp1 filin fileln0 syl2anc ) CDEFGZACGZBCGZ
    HPABIZCGSJKPQRLABCDMSCDNO $.

  $( A filter has the finite intersection property.  Remark below definition 1
     of [BourbakiTop1] p.  I.36.  (Contributed by FL, 20-Sep-2007.)  (Revised
     by Stefan O'Rear, 28-Jul-2015.) $)
  filintn0 $p |- ( ( F e. ( Fil ` X ) /\ ( A C_ F /\ A =/= (/) /\
          A e. Fin ) ) -> |^| A =/= (/) ) $=
    ( cfil cfv wcel wss c0 wne cfn w3a cint cfi elfir wceq filfi adantr eleqtrd
    wa fileln0 syldan ) BCDEZFZABGAHIAJFKZALZBFUEHIUCUDSUEBMEZBABUBNUCUFBOUDBCP
    QRUEBCTUA $.

  $( The empty set is not a filter.  Remark below def. 1 of [BourbakiTop1] p.
     I.36.  (Contributed by FL, 30-Oct-2007.)  (Revised by Stefan O'Rear,
     28-Jul-2015.) $)
  filn0 $p |- ( F e. ( Fil ` X ) -> F =/= (/) ) $=
    ( cfil cfv wcel c0 wne filtop ne0i syl ) ABCDEBAEAFGABHABIJ $.

  ${
    $d F x y $.  $d G x y $.  $d X x y $.
    $( The intersection of two filters is a filter.  Use ~ fiint to extend this
       property to the intersection of a finite set of filters.  Paragraph 3 of
       [BourbakiTop1] p.  I.36.  (Contributed by FL, 17-Sep-2007.)  (Revised by
       Stefan O'Rear, 2-Aug-2015.) $)
    infil $p |- ( ( F e. ( Fil ` X ) /\ G e. ( Fil ` X ) ) ->
        ( F i^i G ) e. ( Fil ` X ) ) $=
      ( vy vx wcel wa cin wss c0 wn w3a cv wi wral adantr sseli filtop sylanbrc
      elin cfil cfv wrex inss1 filsspw syl5ss 0nelfil nsyl adantl simpll simpr2
      cpw 3jca syl simpr1 elpwid simpr3 filss syl13anc inss2 3exp2 imp rexlimdv
      simplr ralrimiva simpl anim12i filin 3expb syl2an simpr ralrimivva isfil2
      syl3anbrc ) ACUAUBZFZBVOFZGZABHZCULZIZJVSFZKZCVSFZLDMZEMZIZDVSUCWFVSFZNZE
      VTOWFWEHZVSFZDVSOEVSOVSVOFVRWAWCWDVRVSAVTABUDZVPAVTIVQACUEPUFVRJAFZWBVPWM
      KVQACUGPVSAJWLQUHVRCAFZCBFZWDVPWNVQACRPVQWOVPBCRUICABTSUMVRWIEVTVRWFVTFZG
      WGWHDVSVRWPWEVSFZWGWHNNVRWPWQWGWHVRWPWQWGLZGZWFAFZWFBFZWHWSVPWEAFZWFCIZWG
      WTVPVQWRUJWSWQXBVRWPWQWGUKZVSAWEWLQZUNWSWFCVRWPWQWGUOUPZVRWPWQWGUQZWEWFAC
      URUSWSVQWEBFZXCWGXAVPVQWRVDWSWQXHXDVSBWEABUTZQZUNXFXGWEWFBCURUSWFABTSVAVB
      VCVEVRWKEDVSVSVRWHWQGZGWJAFZWJBFZWKVRVPWTXBGXLXKVPVQVFWHWTWQXBVSAWFWLQXEV
      GVPWTXBXLWFWEACVHVIVJVRVQXAXHGXMXKVPVQVKWHXAWQXHVSBWFXIQXJVGVQXAXHXMWFWEB
      CVHVIVJWJABTSVLEDVSCVMVN $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( A singleton is a filter.  Example 1 of [BourbakiTop1] p.  I.36.
       (Contributed by FL, 16-Sep-2007.)  (Revised by Stefan O'Rear,
       2-Aug-2015.) $)
    snfil $p |- ( ( A e. B /\ A =/= (/) ) -> { A } e. ( Fil ` A ) ) $=
      ( vx vy wcel c0 wa cv wceq wss wb a1i cvv adantr wsbc eqsbc3 ax-mp w3a wi
      cin wne csn elsn eqimss pm4.71ri bitri elex eqid mpbiri necomd neneqd 0ex
      simpr sylnibr sseq1 anbi2d biimpri syl6bi com12 3adant1 sbcid vex 3imtr4g
      eqss ineq12 inidm syl6eq syl2anb inex1 sylibr isfild ) ABEZAFUAZGZCHZAIZC
      DCAAUBZVOVQEZVOAJZVPGZKVNVRVPVTCAUCVPVSVOAUDUEUFLVLAMEVMABUGNVLVPCAOZVMVL
      WAAAIAUHCAABPUINVNFAIZVPCFOZVNFAVNAFVLVMUMUJUKFMEWCWBKULCFAMPQUNVNDHZAJZV
      OWDJZRVPWDAIZVPCVOOZVPCWDOZWEWFVPWGSVNVPWEWFGZWGVPWJWEAWDJZGZWGVPWFWKWEVO
      AWDUOUPWGWLWDAVDUQURUSUTVPCVAZWDMEWIWGKDVBZCWDAMPQZVCWIWHGZVPCWDVOTZOZSVN
      WEVSRWPWQAIZWRWIWGVPWSWHWOWMWGVPGWQAATAWDAVOAVEAVFVGVHWQMEWRWSKWDVOWNVICW
      QAMPQVJLVK $.
  $}

  ${
    $d x y F $.  $d x y X $.  $d x y Y $.
    $( A filter base on any set is also a filter base on any larger set.
       (Contributed by Stefan O'Rear, 2-Aug-2015.) $)
    fbasweak $p |- ( ( F e. ( fBas ` X ) /\ F C_ ~P Y /\ Y e. V ) ->
        F e. ( fBas ` Y ) ) $=
      ( vx vy cfbas cfv wcel cpw wss w3a c0 wne cv cin wral wa wb isfbas elfvdm
      wnel simp2 simp1 cdm 3ad2ant1 syl mpbid simprd 3ad2ant3 mpbir2and ) ACGHI
      ZADJKZDBIZLZADGHIZUMAMNMAUBAEOFOPJPMNFAQEAQLZULUMUNUCUOACJKZUQUOULURUQRZU
      LUMUNUDUOCGUEZIZULUSSULUMVAUNACGUAUFEFUTCATUGUHUIUNULUPUMUQRSUMEFBDATUJUK
      $.

    $( Condition for a singleton to be a filter base.  (Contributed by Stefan
       O'Rear, 2-Aug-2015.) $)
    snfbas $p |- ( ( A C_ B /\ A =/= (/) /\ B e. V ) ->
        { A } e. ( fBas ` B ) ) $=
      ( wss wne wcel w3a csn cfbas cfv cpw cfil cvv ssexg 3adant2 simp2 syl2anc
      c0 snfil filfbas syl simp1 wb elpw2g 3ad2ant3 mpbird snssd simp3 fbasweak
      syl3anc ) ABDZAREZBCFZGZAHZAIJFZUOBKZDUMUOBIJFUNUOALJFZUPUNAMFZULURUKUMUS
      ULABCNOUKULUMPAMSQUOATUAUNAUQUNAUQFZUKUKULUMUBUMUKUTUKUCULABCUDUEUFUGUKUL
      UMUHUOCABUIUJ $.
  $}

  ${
    $d x y z A $.  $d x y V $.  $d x y z X $.
    $( A condition for a set to generate a filter base.  (Contributed by Jeff
       Hankins, 2-Sep-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    fsubbas $p |- ( X e. V -> ( ( fi ` A ) e. ( fBas ` X ) <->
          ( A C_ ~P X /\ A =/= (/) /\ -. (/) e. ( fi ` A ) ) ) ) $=
      ( vz vx vy wcel cfi cfv wss c0 wne w3a cvv syl syl2anc 3jca wa cv wral wn
      cfbas cpw fbasne0 fvprc ssfii fbsspw sstrd fieq0 necon3bid biimpar 0nelfb
      necon1ai wnel wrex simpr1 fipwss pwexg adantr simpr2 biimpa simpr3 df-nel
      cin ssexd sylibr fiin ssid rspcev sylancl rgen2a a1i wb isfbas2 mpbir2and
      sseq1 ex impbid2 ) CBGZAHIZCUBIGZACUCZJZAKLZKVTGUAZMZWAWCWDWEWAAVTWBWAANG
      ZAVTJWAVTKLZWGCVTUDZWGVTKAHUEUMOZANUFOCVTUGUHWAWGWHWDWJWIWGWDWHWGAKVTKANU
      IUJZUKPCVTULQVSWFWAVSWFRZWAVTWBJZWHKVTUNZDSZESZFSZVDZJZDVTUOZFVTTEVTTZMZW
      LWCWMVSWCWDWEUPZACUQOWLWHWNXAWLWGWDWHWLAWBNVSWBNGWFCBURUSXCVEVSWCWDWEUTWG
      WDWHWKVAPWLWEWNVSWCWDWEVBKVTVCVFXAWLWTEFVTWPVTGWQVTGRWRVTGWRWRJZWTWPWQAVG
      WRVHWSXDDWRVTWOWRWRVPVIVJVKVLQVSWAWMXBRVMWFEFDBCVTVNUSVOVQVR $.
  $}

  ${
    $d x y z F $.  $d x y z X $.
    $( A filter base has the finite intersection property.  (Contributed by
       Jeff Hankins, 2-Sep-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    fbasfip $p |- ( F e. ( fBas ` X ) -> -. (/) e. ( fi ` F ) ) $=
      ( vy vz cfbas cfv wcel c0 cfi cv cint wceq cfn wrex wa wss wn wi mtod cvv
      cpw cin elin elpwi anim1i sylbi fbssint 3expb sylan2 0nelfb eleq1 biimpcd
      ad2antrr adantl ss0 nsyl adantrr sseq2 biimprcd ad2antll rexlimddv nrexdv
      wb 0ex elfi mpan mtbird ) ABEFZGZHAIFGZHCJZKZLZCAUAZMUBZNZVIVMCVOVIVKVOGZ
      OZDJZVLPZVMQDAVQVIVKAPZVKMGZOZVTDANZVQVKVNGZWBOWCVKVNMUCWEWAWBVKAUDUEUFVI
      WAWBWDDVKBAUGUHUIVRVSAGZVTOOVMVSHPZVRWFWGQVTVRWFOZVSHLZWGWHWIHAGZVIWJQVQW
      FBAUJUMWFWIWJRVRWIWFWJVSHAUKULUNSVSUOUPUQVTVMWGRVRWFVMWGVTHVLVSURUSUTSVAV
      BHTGVIVJVPVCVDCHATVHVEVFVG $.
  $}

  ${
    $d w x y z G $.  $d x y z F $.  $d w x y z X $.  $d w x y z Y $.
    $( A helpful lemma for showing that certain sets generate filters.
       (Contributed by Jeff Hankins, 3-Sep-2009.)  (Revised by Stefan O'Rear,
       2-Aug-2015.) $)
    fbunfip $p |- ( ( F e. ( fBas ` X ) /\ G e. ( fBas ` Y ) ) ->
                    ( -. (/) e. ( fi ` ( F u. G ) ) <->
                      A. x e. F A. y e. G ( x i^i y ) =/= (/) ) ) $=
      ( vz vw cfv wcel wa c0 wn cv wceq wrex wral wss wi syl cun cfi cin elfiun
      cfbas wne w3o notbid w3a 3ioran df-3an bitr2i syl6bbr nesym ralbii ralnex
      bitri fbasfip anim12i biantrurd syl5rbb ssfii ssralv ralimdv sylan9 ineq1
      neeq1d ineq2 cbvral2v fbssfi r19.29 ss2in sseq2 syl6bi syl5com necon3d ex
      ss0 com13 rexlimivw impancom expimpd syl2an an4s ralrimdvva syl5bi impbid
      imp com12 3bitrd ) CEUEIZJZDFUEIZJZKZLCDUAUBIJZMZLCUBIZJZMZLDUBIZJZMZKZLA
      NZBNZUCZOZBXAPZAWRPZMZKZXGLUFZBXAQZAWRQZXMBDQZACQZWOWQWSXBXJUGZMZXLWOWPXR
      ABLCDWKWMUDUHXSWTXCXKUIXLWSXBXJUJWTXCXKUKULUMXOXKWOXLXOXIMZAWRQXKXNXTAWRX
      NXHMZBXAQXTXMYABXAXGLUNUOXHBXAUPUQUOXIAWRUPUQWOXDXKWLWTWNXCCEURDFURUSUTVA
      WOXOXQWLXOXNACQZWNXQWLCWRRXOYBSCWKVBXNACWRVCTWNXNXPACWNDXARXNXPSDWMVBXMBD
      XAVCTVDVEXQGNZHNZUCZLUFZHDQZGCQZWOXOXMYFYCXFUCZLUFABGHCDXEYCOXGYILXEYCXFV
      FVGXFYDOYIYELXFYDYCVHVGVIWOYHXMABWRXAWLXEWRJZWNXFXAJZYHXMSZWLYJKYCXERZGCP
      ZYDXFRZHDPZYLWNYKKGXECEVJHXFDFVJYHYNYPKXMYHYNYPXMYHYNKYGYMKZGCPYPXMSZYGYM
      GCVKYQYRGCYGYPYMXMYGYPKYFYOKZHDPYMXMSZYFYOHDVKYSYTHDYFYOYTYMYOYFXMYMYOYFX
      MSYMYOKZXGLYELUUAYEXGRZXGLOZYELOZYCXEYDXFVLUUCUUBYELRUUDXGLYEVMYEVRVNVOVP
      VQVSWHVTTWAVTTWBWIWCWDWEWFWGWJ $.
  $}

  ${
    $d f v x F $.  $d f v x X $.
    $( The filter generating class gives a filter for every filter base.
       (Contributed by Jeff Hankins, 3-Sep-2009.)  (Revised by Stefan O'Rear,
       2-Aug-2015.) $)
    fgval $p |- ( F e. ( fBas ` X ) -> ( X filGen F ) =
          { x e. ~P X | ( F i^i ~P x ) =/= (/) } ) $=
      ( vv vf cfbas cfv wcel cvv cv cpw cin c0 wne crab cmpt2 wceq df-fg adantl
      cfg wa pweq adantr wb ineq1 neeq1d rabeqbidv fveq2 elfvex id elfvdm pwexg
      a1i cdm rabexg 3syl ovmpt2dx ) BCFGZHZDECBIDJZFGZEJZAJKZLZMNZAUTKZOZBVCLZ
      MNZACKZOZTURITDEIVAVGPQUSEADRUMUTCQZVBBQZUAZVGVKQUSVNVEVIAVFVJVLVFVJQVMUT
      CUBUCVMVEVIUDVLVMVDVHMVBBVCUEUFSUGSVLVAURQUSUTCFUHSBCFUIUSUJUSCFUNZHVJIHV
      KIHBCFUKCVOULVIAVJIUOUPUQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y F $.  $d y X $.  $d x y $.
    $( A condition for elements of a generated filter.  (Contributed by Jeff
       Hankins, 3-Sep-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    elfg $p |- ( F e. ( fBas ` X ) -> ( A e. ( X filGen F ) <->
          ( A C_ X /\ E. x e. F x C_ A ) ) ) $=
      ( vy cfbas cfv wcel cfg co cv cpw cin c0 wne crab wss wa wb wex wrex wceq
      fgval eleq2d pweq ineq2d neeq1d elrab cdm elfvdm elpw2g syl elin vex elpw
      anbi2i bitri exbii n0 df-rex 3bitr4i a1i anbi12d syl5bb bitrd ) CDFGHZBDC
      IJZHBCEKZLZMZNOZEDLZPZHZBDQZAKZBQZACUAZRZVFVGVMBECDUCUDVNBVLHZCBLZMZNOZRV
      FVSVKWCEBVLVHBUBZVJWBNWDVIWACVHBUEUFUGUHVFVTVOWCVRVFDFUIZHVTVOSCDFUJBDWEU
      KULWCVRSVFVPWBHZATVPCHZVQRZATWCVRWFWHAWFWGVPWAHZRWHVPCWAUMWIVQWGVPBAUNUOU
      PUQURAWBUSVQACUTVAVBVCVDVE $.
  $}

  ${
    $d t x F $.  $d t x X $.
    $( A filter base is a subset of its generated filter.  (Contributed by Jeff
       Hankins, 3-Sep-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    ssfg $p |- ( F e. ( fBas ` X ) -> F C_ ( X filGen F ) ) $=
      ( vt vx cfbas cfv wcel cfg co cv wss wrex wa fbelss ex sseq1 rspcev mpan2
      wi ssid a1i jcad elfg sylibrd ssrdv ) ABEFGZCABAHIZUFCJZAGZUHBKZDJZUHKZDA
      LZMUHUGGUFUIUJUMUFUIUJBAUHNOUIUMSUFUIUHUHKZUMUHTULUNDUHAUKUHUHPQRUAUBDUHA
      BUCUDUE $.
  $}

  ${
    $d t x F $.  $d t x G $.  $d t x X $.
    $( A bigger base generates a bigger filter.  (Contributed by NM,
       5-Sep-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    fgss $p |- ( ( F e. ( fBas ` X ) /\ G e. ( fBas ` X ) /\ F C_ G ) ->
        ( X filGen F ) C_ ( X filGen G ) ) $=
      ( vt vx cfbas cfv wcel wss w3a cfg co cv wrex wa wi ssrexv anim2d wb elfg
      3ad2ant3 3ad2ant1 3ad2ant2 3imtr4d ssrdv ) ACFGZHZBUFHZABIZJZDCAKLZCBKLZU
      JDMZCIZEMUMIZEANZOZUNUOEBNZOZUMUKHZUMULHZUIUGUQUSPUHUIUPURUNUOEABQRUAUGUH
      UTUQSUIEUMACTUBUHUGVAUSSUIEUMBCTUCUDUE $.
  $}

  ${
    $d t u v x y F $.  $d t u v x y G $.  $d t u v x y X $.  $d t u v x y Y $.
    $d t u v x y $.
    $( A condition for a filter to be finer than another involving their filter
       bases.  (Contributed by Jeff Hankins, 3-Sep-2009.)  (Revised by Stefan
       O'Rear, 2-Aug-2015.) $)
    fgss2 $p |- ( ( F e. ( fBas ` X ) /\ G e. ( fBas ` X ) ) ->
        ( ( X filGen F ) C_ ( X filGen G ) <->
          A. x e. F E. y e. G y C_ x ) ) $=
      ( vt vu vv wcel wa cfg co wss cv wrex adantr wi elfg adantl rexlimdv wral
      cfbas cfv ssfg sseld ssel2 simpr syl6bi syl5 exp3a syl5d ralrimdv rexbidv
      weq sseq2 rspcv sstr sseq1 rspcev sylanr2 ancld exp45 syld impancom com23
      a1d imp3a wb 3imtr4d ssrdv ex impbid ) CEUBUCZIZDVMIZJZECKLZEDKLZMZBNZANZ
      MZBDOZACUAZVPVSWCACVPWACIWAVQIZVSWCVPCVQWAVNCVQMVOCEUDPUEVPVSWEWCVSWEJWAV
      RIZVPWCVQVRWAUFVOWFWCQVNVOWFWAEMZWCJWCBWADERWGWCUGUHSUIUJUKULVPWDVSVPWDJZ
      FVQVRWHFNZEMZGNZWIMZGCOZJZWJHNZWIMZHDOZJZWIVQIZWIVRIZWHWJWMWRWHWMWJWRWHWL
      WJWRQZGCVPWKCIZWDWLXAQZVPXBJZWDVTWKMZBDOZXCXBWDXFQVPWCXFAWKCAGUNWBXEBDWAW
      KVTUOUMUPSXDXEXCBDXDVTDIZXEWLXAXDXGXEWLJZJJWJWQXHXDXGVTWIMZWJWQQVTWKWIUQX
      DXGXIJZJWQWJXJWQXDWPXIHVTDWOVTWIURUSSVFUTVAVBTVCVDTVEVGVPWSWNVHZWDVNXKVOG
      WICERPPVPWTWRVHZWDVOXLVNHWIDERSPVIVJVKVL $.
  $}

  ${
    $d t x F $.  $d t x X $.  $d t A $.
    $( A filter generates itself.  (Contributed by Jeff Hankins, 5-Sep-2009.)
       (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    fgfil $p |- ( F e. ( Fil ` X ) -> ( X filGen F ) = F ) $=
      ( vt vx cfil cfv wcel cfg co cv wss wrex wa cfbas wb filfbas syl wi filss
      elfg 3exp2 com34 rexlimdv com23 imp3a sylbid ssrdv ssfg eqssd ) ABEFGZBAH
      IZAUJCUKAUJCJZUKGZULBKZDJZULKZDALZMZULAGZUJABNFGZUMUROABPZDULABTQUJUNUQUS
      UJUQUNUSUJUPUNUSRDAUJUOAGZUNUPUSUJVBUNUPUSUOULABSUAUBUCUDUEUFUGUJUTAUKKVA
      ABUHQUI $.

    $( An element belongs to a filter iff any element below it does.
       (Contributed by Stefan O'Rear, 2-Aug-2015.) $)
    elfilss $p |- ( ( F e. ( Fil ` X ) /\ A C_ X ) ->
        ( A e. F <-> E. t e. F t C_ A ) ) $=
      ( cfil cfv wcel wss wa cv wrex cfg co wb ibar adantl cfbas filfbas adantr
      elfg syl fgfil eleq2d 3bitr2rd ) CDEFGZBDHZIAJBHACKZUFUGIZBDCLMZGZBCGZUFU
      GUHNUEUFUGOPUEUJUHNZUFUECDQFGULCDRABCDTUASUEUJUKNUFUEUICBCDUBUCSUD $.
  $}

  ${
    $( No filter containing a finite element is free.  (Contributed by Jeff
       Hankins, 5-Dec-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    filfinnfr $p |- ( ( F e. ( Fil ` X ) /\ S e. F /\ S e. Fin ) ->
        |^| F =/= (/) ) $=
      ( cfil cfv wcel cfbas cfn cint c0 wne filfbas fbfinnfr syl3an1 ) BCDEFBCG
      EFABFAHFBIJKBCLCABMN $.
  $}

  ${
    $d u v w x y z F $.  $d u v w x y z X $.  $d x y z Y $.
    $( A generated filter is a filter.  (Contributed by Jeff Hankins,
       3-Sep-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    fgcl $p |- ( F e. ( fBas ` X ) -> ( X filGen F ) e. ( Fil ` X ) ) $=
      ( vy vz vu vv vw cfbas wcel cv wss wrex wsbc wa c0 sseq2 rexbidv sbcie wi
      wceq cfv cfg co elfg elfvex wex wne fbasne0 n0 sylib fbelss ex eximdv mpd
      ancld df-rex sylibr cdm wb elfvdm sbcieg syl mpbird 0nelfb 0ex ss0 eleq1d
      biimpac rexlimiva sylbi nsyl w3a sstr expcom reximdv 3ad2ant3 vex 3imtr4g
      weq fbasssin 3expib ss2in sstr2 com12 syl6 exp5c imp31 impancom rexlimdva
      cin rexlimdv imp3a 3ad2ant1 sseq1 cbvrexv bitri anbi12i inex1 isfild ) AB
      HUAIZCJZDJZKZCALZDEFBBAUBUCCXBABUDABHUEWTXDDBMZXABKZCALZWTXAAIZXFNZCUFZXG
      WTXHCUFZXJWTAOUGXKBAUHCAUIUJWTXHXICWTXHXFWTXHXFBAXAUKULUOUMUNXFCAUPUQWTBH
      URZIXEXGUSABHUTXDXGDBXLXBBTXCXFCAXBBXAPQVAVBVCWTOAIZXDDOMZBAVDXNXAOKZCALZ
      XMXDXPDOVEXBOTXCXOCAXBOXAPQRXOXMCAXOXHXMXOXAOAXAVFVGVHVIVJVKWTEJZBKZFJZXQ
      KZVLXAXSKZCALZXAXQKZCALZXDDXSMZXDDXQMZXTWTYBYDSXRXTYAYCCAYAXTYCXAXSXQVMVN
      VOVPXDYBDXSFVQDFVSXCYACAXBXSXAPQRZXDYDDXQEVQZDEVSXCYCCAXBXQXAPQRZVRWTXRXS
      BKZVLXBXQKZDALZGJZXSKZGALZNZXAXQXSWJZKZCALZYFYENXDDYQMWTXRYPYSSYJWTYLYOYS
      WTYKYOYSSZDAWTXBAIZNZYKYTUUBYKNYNYSGAUUBYMAIZYKYNYSSZWTUUAUUCYKUUDSWTUUAU
      UCYKYNYSWTUUAUUCNXAXBYMWJZKZCALZYKYNNZYSSWTUUAUUCUUGCXBYMABVTWAUUHUUGYSUU
      HUUEYQKZUUGYSSXBXQYMXSWBUUIUUFYRCAUUFUUIYRXAUUEYQWCWDVOVBWDWEWFWGWHWKULWI
      WLWMYFYLYEYOYFYDYLYIYCYKCDAXAXBXQWNWOWPYEYBYOYGYAYNCGAXAYMXSWNWOWPWQXDYSD
      YQXQXSYHWRXBYQTXCYRCAXBYQXAPQRVRWS $.

    $( Absorption law for filter generation.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    fgabs $p |- ( ( F e. ( fBas ` Y ) /\ Y C_ X ) ->
        ( X filGen ( Y filGen F ) ) = ( X filGen F ) ) $=
      ( vx vy vz vw cfbas cfv wcel wss wa cvv cfg co cv cpw syl sstrd syl3anc
      wceq wrex cfil simpll fgcl filfbas 3syl fbsspw sspwb sylib simpr fbasweak
      wb simplr elfg adantr ad2antrr ssfg sselda adantrr simplrl simprlr simprr
      filss syl13anc expr rexlimdvaa anassrs expimpd sylbid rexlimdv ssrdv fgss
      wi eqssd ex wn c0 cin wne crab df-fg reldmmpt2 ovprc1 eqtr4d pm2.61d1 ) A
      CHIZJZCBKZLZBMJZBCANOZNOZBANOZUAZWJWKWOWJWKLZWMWNWPDWMWNWPDPZWMJZWQBKZEPZ
      WQKZEWLUBZLZWQWNJZWPWLBHIZJZWRXCUMWPWLWGJZWLBQZKWKXFWPWHWLCUCIJXGWHWIWKUD
      ZACUEWLCUFUGZWPWLCQZXHWPXGWLXKKXJCWLUHRWPWIXKXHKWHWIWKUNCBUIUJZSWJWKUKZWL
      MCBULTZEWQWLBUORWPWSXBXDWPWSLZXAXDEWLXOWTWLJZWTCKZFPZWTKZFAUBZLZXAXDVNZXO
      WHXPYAUMWPWHWSXIUPFWTACUORXOXQXTYBWPWSXQXTYBVNWPWSXQLZLZXSYBFAYDXRAJZXSLZ
      XAXDYDYFXALZLZWNBUCIJZXRWNJZWSXRWQKXDWPYIYCYGWPAXEJZYIWPWHAXHKWKYKXIWPAXK
      XHWPWHAXKKXICAUHRXLSXMAMCBULTZABUERUQYDYFYJXAYDYEYJXSYDAWNXRWPAWNKZYCWPYK
      YMYLABURRUPUSUTUTWPWSXQYGVAYHXRWTWQYDYEXSXAVBYDYFXAVCSXRWQWNBVDVEVFVGVHVI
      VJVKVIVJVLWPYKXFAWLKZWNWMKYLXNWHYNWIWKACURUQAWLBVMTVOVPWKVQWMVRWNBWLNGDMG
      PZHIWQWTQVSVRVTEYOQWANDEGWBWCZWDBANYPWDWEWF $.
  $}

  ${
    $d J x y $.  $d S x y $.  $d X x y $.
    $( The neighborhoods of a non-empty set is a filter.  Example 2 of
       [BourbakiTop1] p.  I.36.  (Contributed by FL, 18-Sep-2007.)  (Revised by
       Mario Carneiro, 23-Aug-2015.) $)
    neifil $p |- ( ( J e. ( TopOn ` X ) /\ S C_ X /\ S =/= (/) ) ->
      ( ( nei ` J ) ` S ) e. ( Fil ` X ) ) $=
      ( vy vx cfv wcel wss c0 cv wi wral wa cuni adantr sseqtrd syl2anc 3adant3
      w3a wceq ctopon wne cnei cpw wn wrex cin cfil toponuni ctop topontop eqid
      simpr neiuni eqtrd eqimss2 syl sspwuni sylibr 0nnei sylan 3adant2 eqeltrd
      tpnei biimpa 3jca elpwi ad2antrr simprl simprr simplr syl22anc rexlimdvaa
      ssnei2 sylan2 ralrimiva innei 3expib 3ad2ant1 ralrimivv isfil2 syl3anbrc
      ) BCUAFGZACHZAIUBZSZABUCFFZCUDZHZIWGGUEZCWGGZSDJZEJZHZDWGUFWMWGGZKZEWHLZW
      MWLUGWGGZDWGLEWGLWGCUHFGWFWIWJWKWCWDWIWEWCWDMZWGNZCHZWIWSCWTTXAWSCBNZWTWC
      CXBTZWDCBUIOZWSBUJGZAXBHZXBWTTWCXEWDCBUKZOZWSACXBWCWDUMXDPZABXBXBULZUNQUO
      WTCUPUQWGCURUSRWCWEWJWDWCXEWEWJXGABUTVAVBWCWDWKWEWSCXBWGXDWSXEXFXBWGGZXHX
      IXEXFXKABXBXJVDVEQVCRVFWCWDWQWEWSWPEWHWMWHGWSWMCHZWPWMCVGWSXLMZWNWODWGXMW
      LWGGZWNMZMZXEXNWNWMXBHWOWSXEXLXOXHVHXMXNWNVIXMXNWNVJXPWMCXBWSXLXOVKWSXCXL
      XOXDVHPABWMWLXBXJVNVLVMVOVPRWFWREDWGWGWCWDWOXNMWRKZWEWCXEXQXGXEWOXNWRABWL
      WMVQVRUQVSVTEDWGCWAWB $.
  $}

  ${
    $d w y z $.  $d x F $.
    $( Recover the base set from a filter.  (Contributed by Stefan O'Rear,
       2-Aug-2015.) $)
    filunibas $p |- ( F e. ( Fil ` X ) -> U. F = X ) $=
      ( cfil cfv wcel cuni wss cpw filsspw sspwuni sylib filtop unissel syl2anc
      wceq ) ABCDEZAFZBGZBAEQBOPABHGRABIABJKABLABMN $.

    $( Two ways to express a filter on an unspecified base.  (Contributed by
       Stefan O'Rear, 2-Aug-2015.) $)
    filunirn $p |- ( F e. U. ran Fil <-> F e. ( Fil ` U. F ) ) $=
      ( vx vy vw vz cfil crn cuni wcel cfv cv cvv wrex wfn wb cpw cin wne cfbas
      c0 wi wral crab rabex df-fil fnmpti fnunirn ax-mp filunibas fveq2d eleq2d
      fvex ibir rexlimivw sylbi fvssunirn sseli impbii ) AFGHZIZAAHZFJZIZUTABKZ
      FJZIZBLMZVCFLNUTVGOCLDKZEKZPQTRVIVHIUAECKZPUBZDVJSJZUCFVKDVLVJSULUDECDUEU
      FBAFLUGUHVFVCBLVFVCVFVBVEAVFVAVDFAVDUIUJUKUMUNUOVBUSAFVAUPUQUR $.
  $}

  ${
    $d x y F $.
    $( A filter gives rise to a connected topology.  (Contributed by Jeff
       Hankins, 6-Dec-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    filcon $p |- ( F e. ( Fil ` X ) -> ( F u. { (/) } ) e. Con ) $=
      ( vx vy cfil cfv wcel cuni c0 cun cin wss wi wral wa wn wo syl wceq cvv
      csn ccon id filunibas fveq2d eleqtrrd ctop ccld cpr cv wal wex nss simpll
      ssel2 adantll elun sylib orcomd ord uniss ad2antlr uniun 0ex unisn uneq2i
      impr un0 3eqtrri syl6sseqr elssuni ad2antrl filss syl13anc exlimdv syl5bi
      elun1 ex uni0b ssun2 snid sselii eleq1 mpbiri sylbir pm2.61d2 alrimiv w3a
      filin 3expa ralrimiva elsni ineq2 in0 syl6eq syl6eqel ralun sylancl ineq1
      rgen 0ss df-ss mpbi ralrimivw wb p0ex unexg mpan2 istopg mpbir2and cldopn
      cdif cfbas filfbas fbncp sylan pm2.21d a1d a1i jaod adantl ssdif0 biimpri
      imp eqss simplbi2 syl2im syl5 orim12d expimpd elin vex elpr 3imtr4g ssrdv
      iscon2 sylanbrc ) ABEFZGZAAHZEFZGZAIUAZJZUBGZYSAYRUUAYSUCYSYTBEABUDUEUFUU
      BUUDUGGZUUDUUDUHFZKZIYTUIZLUUEUUBUUFCUJZUUDLZUUJHZUUDGZMZCUKZUUJDUJZKZUUD
      GZDUUDNZCUUDNZUUBUUNCUUBUUKUUMUUBUUKOZUUJUUCLZUUMUVBPUUPUUJGZUUPUUCGZPZOZ
      DULUVAUUMDUUJUUCUMUVAUVFUUMDUVAUVFUUMUVAUVFOZUULAGZUUMUVGUUBUUPAGZUULYTLU
      UPUULLZUVHUUBUUKUVFUNUVAUVCUVEUVIUVAUVCOZUVDUVIUVKUVIUVDUVKUUPUUDGZUVIUVD
      QUUKUVCUVLUUBUUJUUDUUPUOUPUUPAUUCUQURUSUTVGUVGUULUUDHZYTUUKUULUVMLUUBUVFU
      UJUUDVAVBUVMYTUUCHZJYTIJYTAUUCVCUVNIYTIVDVEVFYTVHVIZVJUVCUVJUVAUVEUUPUUJV
      KVLUUPUULAYTVMVNUULAUUCVQRVRVOVPUVBUULISZUUMUUJVSUVPUUMIUUDGUUCUUDIUUCAVT
      IVDWAWBZUULIUUDWCWDWEWFVRWGUUBUUSCANUUSCUUCNUUTUUBUUSCAUUBUUJAGZOZUURDANU
      URDUUCNUUSUVSUURDAUUBUVRUVIUURUUBUVRUVIWHUUQAGUURUUJUUPAYTWIUUQAUUCVQRWJW
      KUURDUUCUVDUUPISZUURUUPIWLUVTUUQIUUDUVTUUQUUJIKIUUPIUUJWMUUJWNWOUVQWPRWTU
      URDAUUCWQWRWKUUSCUUCUUJUUCGZUUJISZUUSUUJIWLZUWBUURDUUDUWBUUQIUUDUWBUUQIUU
      PKZIUUJIUUPWSIUUPLUWDISUUPXAIUUPXBXCWOUVQWPXDRWTUUSCAUUCWQWRUUBUUDTGZUUFU
      UOUUTOXEUUBUUCTGUWEXFAUUCUUATXGXHCDTUUDXIRXJUUBCUUHUUIUUBUUJUUDGZUUJUUGGZ
      OUWBUUJYTSZQZUUJUUHGUUJUUIGUUBUWFUWGUWIUWGYTUUJXLZAGZUWJUUCGZQZUUBUWFOZUW
      IUWGUWJUUDGUWMUUJUUDYTUVOXKUWJAUUCUQURUWNUWKUWBUWLUWHUUBUWFUWKUWBMZUWFUVR
      UWAQUUBUWOUUJAUUCUQUUBUVRUWOUWAUUBUVRUWOUVSUWKUWBUUBAYTXMFGUVRUWKPAYTXNUU
      JYTAYTXOXPXQVRUWAUWOMUUBUWAUWBUWKUWCXRXSXTVPYDUWLUWJISZUWNUWHUWJIWLUWNUUJ
      YTLZUWPYTUUJLZUWHUWFUWQUUBUWFUUJUVMYTUUJUUDVKUVOVJYAUWRUWPYTUUJYBYCUWHUWQ
      UWRUUJYTYEYFYGYHYIYHYJUUJUUDUUGYKUUJIYTCYLYMYNYOUUDYTUVOYPYQR $.
  $}

  ${
    $d r s u v w x y z B $.  $d r s u v w z C $.  $d r s u v w x y z F $.
    $d r s u v w x V $.  $d r s u v w x X $.  $d r s u v w x z Y $.
    fbasrn.c $e |- C = ran ( x e. B |-> ( F " x ) ) $.
    $( Given a filter on a domain, produce a filter on the range.  (Contributed
       by Jeff Hankins, 7-Sep-2009.)  (Revised by Stefan O'Rear,
       6-Aug-2015.) $)
    fbasrn $p |- ( ( B e. ( fBas ` X ) /\ F : X --> Y /\ Y e. V ) ->
        C e. ( fBas ` Y ) ) $=
      ( vu vv wcel wss c0 cv wrex wa wb wceq cvv wn vz vr vs vw cfv w3a cpw wne
      cfbas wf wnel cin wral cima cmpt crn simpl2 imassrn frn syl5ss syl simpl3
      elpw2g eqid fmptd syl5eqss a1i cdm wfun ffun 3ad2ant2 funimaexg ralrimiva
      mpbird dmmptg 3syl fbasne0 3ad2ant1 eqnetrd dm0rn0 necon3bii sylib fbelss
      wi ex 0nelfb eleq1 notbid syl5ibrcom con2d jcad fdm sseq2d biimpar eqeq1d
      sseqin2 biimpd con3d expimpd eqcom imadisj notbii syl6ibr ralrimiv eleq2i
      bitri syld 0ex elrnmpt ax-mp df-nel ralnex 3bitr4i sylibr cbvmptv anbi12i
      imaeq2 reeanv bitr4i fbasssin 3expb 3ad2antl1 adantrr eqeq2d rspcev mpan2
      vex ad2antrl funimaex syl5bb ad2antrr ad2antll inss1 inss2 ssini ad2antlr
      imass2 ineq12 syl5sseqr sstrd syl2anc adantlrl rexlimddv rexlimdvv syl5bi
      sseq1 exp32 ralrimivv 3jca isfbas2 3ad2ant3 mpbir2and ) BFUIUEKZFGDUJZGEK
      ZUFZCGUIUEKZCGUGZLZCMUHZMCUKZUANZUBNZUCNZULZLZUACOZUCCUMUBCUMZUFZUUPCABDA
      NZUNZUOZUPZUURHUUPBUURUVLUJUVMUURLUUPABUVKUURUVLUUPUVJBKZPZUVKUURKZUVKGLZ
      UVOUUNUVQUUMUUNUUOUVNUQUUNUVKDUPGDUVJURFGDUSUTVAUVOUUOUVPUVQQUUMUUNUUOUVN
      VBUVKGEVCVAVNUVLVDZVEBUURUVLUSVAVFUUPUUTUVAUVHUUPCUVMMCUVMRUUPHVGUUPUVLVH
      ZMUHUVMMUHUUPUVSBMUUPDVIZUVKSKZABUMUVSBRUUNUUMUVTUUOFGDVJVKZUVTUWAABDUVJB
      VLVMABUVKSVOVPUUMUUNBMUHUUOFBVQVRVSUVSMUVMMUVLVTWAWBVSUUPMUVKRZTZABUMZUVA
      UUPUWDABUUPUVNUVJFLZUVJMRZTZPZUWDUUPUVNUWFUWHUUMUUNUVNUWFWDUUOUUMUVNUWFFB
      UVJWCWEVRUUMUUNUVNUWHWDUUOUUMUWGUVNUUMUVNTUWGMBKZTFBWFUWGUVNUWJUVJMBWGWHW
      IWJVRWKUUPUWIDVHZUVJULZMRZTZUWDUUPUWFUWHUWNUUPUWFPZUWMUWGUWOUWMUWGUWOUWLU
      VJMUWOUVJUWKLZUWLUVJRUUPUWPUWFUUPUWKFUVJUUNUUMUWKFRUUOFGDWLVKWMWNUVJUWKWP
      WBWOWQWRWSUWCUWMUWCUVKMRUWMMUVKWTDUVJXAXFXBXCXGXDMCKZTUWCABOZTUVAUWEUWQUW
      RUWQMUVMKZUWRCUVMMHXEMSKUWSUWRQXHABUVKMUVLSUVRXIXJXFXBMCXKUWCABXLXMXNUUPU
      VGUBUCCCUVCCKZUVDCKZPZUVCDINZUNZRZUVDDJNZUNZRZPZJBOIBOZUUPUVGUXBUXEIBOZUX
      HJBOZPUXJUWTUXKUXAUXLUWTUVCUVMKZUXKCUVMUVCHXEUVCSKUXMUXKQUBYGIBUXDUVCUVLS
      AIBUVKUXDUVJUXCDXQXOXIXJXFUXAUVDUVMKZUXLCUVMUVDHXEUVDSKUXNUXLQUCYGJBUXGUV
      DUVLSAJBUVKUXGUVJUXFDXQXOXIXJXFXPUXEUXHIJBBXRXSUUPUXIUVGIJBBUUPUXCBKZUXFB
      KZPZUXIUVGUUPUXQUXIPPUDNZUXCUXFULZLZUVGUDBUUPUXQUXTUDBOZUXIUUMUUNUXQUYAUU
      OUUMUXOUXPUYAUDUXCUXFBFXTYAYBYCUUPUXIUXRBKZUXTPZUVGUXQUUPUXIPZUYCPZDUXRUN
      ZCKZUYFUVELZUVGUYEUYGUYFUVKRZABOZUYBUYJUYDUXTUYBUYFUYFRZUYJUYFVDUYIUYKAUX
      RBUVJUXRRUVKUYFUYFUVJUXRDXQYDYEYFYHUUPUYGUYJQUXIUYCUYGUYFUVMKZUUPUYJCUVMU
      YFHXEUUPUVTUYFSKUYLUYJQUWBDUXRUDYGYIABUVKUYFUVLSUVRXIVPYJYKVNUYEUYFDUXSUN
      ZUVEUXTUYFUYMLUYDUYBUXRUXSDYQYLUYEUXDUXGULZUYMUVEUYMUXDUXGUXSUXCLUYMUXDLU
      XCUXFYMUXSUXCDYQXJUXSUXFLUYMUXGLUXCUXFYNUXSUXFDYQXJYOUXIUVEUYNRUUPUYCUVCU
      XDUVDUXGYRYPYSYTUVFUYHUAUYFCUVBUYFUVEUUFYEUUAUUBUUCUUGUUDUUEUUHUUIUUOUUMU
      UQUUSUVIPQUUNUBUCUAEGCUUJUUKUUL $.
  $}

  ${
    $d f g h x y F $.  $d f g h x y X $.
    $( The union of a nonempty set of filters with a common base and closed
       under pairwise union is a filter.  (Contributed by Mario Carneiro,
       28-Nov-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    filuni $p |- ( ( F C_ ( Fil ` X ) /\ F =/= (/) /\ A. f e. F A. g e. F
              ( f u. g ) e. F ) -> U. F e. ( Fil ` X ) ) $=
      ( vx vy vh c0 cv wcel wel wrex eluni2 wi wa ex syl wsbc sbcel1v bitri cfv
      cfil wss wne cun wral w3a cuni filelss rexlimdva 3ad2ant1 syl5bi pm4.71rd
      ssel2 cvv fvprc necon1ai 3adant3 filtop a1d ralimdva r19.2z sylan9 3impia
      ssn0 sylibr wn 0nelfil ralrimiva notbii ralnex bitr4i simp13 r19.29 simp1
      simpl syl2an simprrr simpl2 simpl3 syl13anc expr reximdva syl3an1 3imtr4g
      filss syld cin simp11 elun1 elun2 anim12i wceq eleq2 anbi12d rspcev an12s
      sylan2 ad2antlr syl9r impr ancom2s rexlimiva 3expib syl2im syland anbi12i
      imp filin isfild ) CDUBUAZUCZCHUDZAIZBIZUEZCJZBCUFZACUFZUGZEIZCUHZJZEFEDY
      BXTYCYADUCZYCEAKZACLZXTYDAYACMZXLXMYFYDNXSXLYEYDACXLXNCJZOZXNXKJZYEYDNCXK
      XNUNZYJYEYDYAXNDUIPQUJUKULUMXLXMDUOJZXSXLXMOXKHUDYLCXKVEYLXKHDUBUPUQQURXT
      DYBJZYCEDRXTDXNJZACLZYMXLXMXSYOXLXSYNACUFZXMYOXLXRYNACYIYNXRYIYJYNYKXNDUS
      QUTVAXMYPYOYNACVBPVCVDADCMVFEDYBSVFXTHXNJZVGZACUFZYCEHRZVGZXLXMYSXSXLYRAC
      YIYJYRYKXNDVHQVIUKUUAYQACLZVGYSYTUUBYTHYBJUUBEHYBSAHCMTVJYQACVKVLVFXTFIZD
      UCZYAUUCUCZUGZYFFAKZACLZYCEYARZYCEUUCRZUUFYFXRYEOZACLZUUHUUFXSYFUULNXLXMX
      SUUDUUEVMXSYFUULXRYEACVNPQXTXLUUDUUEUULUUHNXLXMXSVOXLUUDUUEUGZUUKUUGACUUM
      YHUUKUUGUUMYHUUKOZOYJYEUUDUUEUUGUUMXLYHYJUUNXLUUDUUEVOYHUUKVPYKVQUUMYHXRY
      EVRXLUUDUUEUUNVSXLUUDUUEUUNVTYAUUCXNDWFWAWBWCWDWGUUIYCYFEYAYBSZYGTUUJUUCY
      BJUUHEUUCYBSAUUCCMTZWEXTUUDYDUGZUUHEBKZBCLZOUUCYAWHZGIZJZGCLZUUJUUIOYCEUU
      TRZUUQUUHXRUUGOZACLZUUSUVCUUQXSUUHUVFNXLXMXSUUDYDVMXSUUHUVFXRUUGACVNPQUUQ
      XLUVFUUSOFGKZEGKZOZGCLZUVCXLXMXSUUDYDWIUVFUUSUVJUVEUUSUVJNZACYHUUGXRUVKYH
      UUGXRUVKXRUUSXQUUROZBCLZYHUUGOZUVJXRUUSUVMXQUURBCVNPUVNUVLUVJBCUUGUVLUVJN
      YHXOCJUUGUVLUVJXQUUGUURUVJUUGUUROXQUUCXPJZYAXPJZOZUVJUUGUVOUURUVPUUCXNXOW
      JYAXOXNWKWLUVIUVQGXPCUVAXPWMUVGUVOUVHUVPUVAXPUUCWNUVAXPYAWNWOWPWRWQPWSUJW
      TXAXBXCXHXLUVIUVBGCXLUVACJOUVAXKJZUVIUVBNCXKUVAUNUVRUVGUVHUVBUUCYAUVADXIX
      DQWCXEXFUUJUUHUUIUUSUUPUUIYCUUSUUOBYACMTXGUVDUUTYBJUVCEUUTYBSGUUTCMTWEXJ
      $.
  $}

  ${
    $d u v x y z A $.  $d u v x y z L $.  $d u v x y z Y $.
    $( Conditions for the trace of a filter ` L ` to be a filter.  (Contributed
       by FL, 2-Sep-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    trfil1 $p |- ( ( L e. ( Fil ` Y ) /\ A C_ Y ) -> A = U. ( L |`t A ) ) $=
      ( cfil cfv wcel wss wa crest co cuni cin wceq simpr dfss1 sylib cvv simpl
      id filtop ssexg syl2anr elrestr syl3anc eqeltrrd elssuni syl cpw restsspw
      adantr sspwuni mpbi a1i eqssd ) BCDEZFZACGZHZABAIJZKZURAUSFAUTGURCALZAUSU
      RUQVAAMUPUQNACOPURUPAQFZCBFZVAUSFUPUQRUQUQVCVBUPUQSBCTZACBUAUBUPVCUQVDUJC
      ABUOQUCUDUEAUSUFUGUTAGZURUSAUHGVEABUIUSAUKULUMUN $.

    $( Conditions for the trace of a filter ` L ` to be a filter.  (Contributed
       by FL, 2-Sep-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    trfil2 $p |- ( ( L e. ( Fil ` Y ) /\ A C_ Y ) ->
      ( ( L |`t A ) e. ( Fil ` A ) <-> A. v e. L ( v i^i A ) =/= (/) ) ) $=
      ( vy vx vu vz wcel wss wa c0 cv cin wral wrex wb wceq cvv adantr cfil cfv
      crest co wn wne wi cpw simpr dfss1 sylib simpl id syl2anr elrestr syl3anc
      filtop ssexg eqeltrrd elpwi vex inex1 elrest syldan sseq1d rexxfr2d indir
      a1i cun simplr df-ss uneq2d simprr ssequn1 syl5eq simplll simpllr syl2anc
      eqtrd simprl filelss sstrd unssd ssun1 syl13anc rexlimdvaa sylbid ex syl5
      filss simpll filin 3expb adantlr ralrimivva ineq12 inindir syl6eqr eleq1d
      ralrimiv adantll ralxfr2d mpbird w3a isfil2 3anass mpbiran 3anbi1i 3bitri
      restsspw anass ancom syl12anc ralbii dfrex2 syl6bb con2bid syl5bb bitr4d
      baib nesym ) CDUAUBZIZBDJZKZCBUCUDZBUAUBIZLYFIZUEZAMBNZLUFZACOZYEBYFIZEMZ
      FMZJZEYFPZYOYFIZUGZFBUHZOZYOYNNZYFIZEYFOZFYFOZYGYIQYEDBNZBYFYEYDUUFBRYCYD
      UIBDUJUKYEYCBSIZDCIZUUFYFIYCYDULYDYDUUHUUGYCYDUMCDUQZBDCURUNZYCUUHYDUUITD
      BCYBSUOUPUSYEYSFYTYOYTIYOBJZYEYSYOBUTYEUUKYSYEUUKKZYQGMZBNZYOJZGCPYRUULYP
      UUOEGUUNYFCSUUNSIZUULUUMCIZKUUMBGVAVBZVHYEYNYFIYNUUNRZGCPQZUUKYCYDUUGUUTU
      UJGYNBCYBSVCVDZTUULUUSKYNUUNYOUULUUSUIVEVFUULUUOYRGCUULUUQUUOKZKZUUMYOVIZ
      BNZYOYFUVCUVEUUNYOBNZVIZYOUUMYOBVGUVCUVGUUNYOVIZYOUVCUVFYOUUNUVCUUKUVFYOR
      YEUUKUVBVJZYOBVKUKVLUVCUUOUVHYORUULUUQUUOVMUUNYOVNUKVSVOUVCYCUUGUVDCIZUVE
      YFIYCYDUUKUVBVPZUVCYCYDUUGUVKYCYDUUKUVBVQZUUJVRUVCYCUUQUVDDJUUMUVDJZUVJUV
      KUULUUQUUOVTZUVCUUMYODUVCYCUUQUUMDJUVKUVNUUMCDWAVRUVCYOBDUVIUVLWBWCUVMUVC
      UUMYOWDVHUUMUVDCDWJWEUVDBCYBSUOUPUSWFWGWHWIWTYEUUEHMZUUMNZBNZYFIZGCOZHCOY
      EUVRHGCCYEUVOCIZUUQKZKYCUUGUVPCIZUVRYCYDUWAWKYEUUGUWAUUJTYCUWAUWBYDYCUVTU
      UQUWBUVOUUMCDWLWMWNUVPBCYBSUOUPWOYEUUDUVSFHUVOBNZYFCSUWCSIYEUVTKUVOBHVAVB
      VHYCYDUUGYRYOUWCRZHCPQUUJHYOBCYBSVCVDYEUWDKZUUCUVREGUUNYFCSUUPUWEUUQKUURV
      HYEUUTUWDUVATUWEUUSKUUBUVQYFUWDUUSUUBUVQRYEUWDUUSKUUBUWCUUNNUVQYOUWCYNUUN
      WPUVOUUMBWQWRXAWSXBXBXCYGYMUUAUUEKZKZYIYGYIYMKZUWFKZYIUWGKUWGYIKYGYFYTJZY
      IYMXDZUUAUUEXDUWHUUAUUEXDUWIFEYFBXEUWKUWHUUAUUEUWKUWJUWHBCXJUWJYIYMXFXGXH
      UWHUUAUUEXFXIYIYMUWFXKYIUWGXLXIXTXMYLLYJRZUEZACOZYEYIYKUWMACYJLYAXNYEYHUW
      NYEYHUWLACPZUWNUEYCYDUUGYHUWOQUUJALBCYBSVCVDUWLACXOXPXQXRXS $.

    $( Conditions for the trace of a filter ` L ` to be a filter.  (Contributed
       by Stefan O'Rear, 2-Aug-2015.) $)
    trfil3 $p |- ( ( L e. ( Fil ` Y ) /\ A C_ Y ) ->
      ( ( L |`t A ) e. ( Fil ` A ) <-> -. ( Y \ A ) e. L ) ) $=
      ( vv cfil cfv wcel wss wa crest co cv cin c0 wne wral wn wrex wb syl5bb
      cdif trfil2 dfral2 nne filelss reldisj syl rexbidva adantr difssd elfilss
      wceq sylan2 bitr4d notbid bitrd ) BCEFGZACHZIZBAJKAEFGDLZAMZNOZDBPZCAUAZB
      GZQZDABCUBVCVBQZDBRZQUSVFVBDBUCUSVHVEUSVHUTVDHZDBRZVEUQVHVJSURUQVGVIDBVGV
      ANULZUQUTBGIZVIVANUDVLUTCHVKVISUTBCUEUTACUFUGTUHUIURUQVDCHVEVJSURCAUJDVDB
      CUKUMUNUOTUP $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y V $.  $d x y X $.
    $( If ` A ` is a member of the filter, then the filter truncated to ` A `
       is a subset of the original filter.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    trfilss $p |- ( ( F e. ( Fil ` X ) /\ A e. F ) -> ( F |`t A ) C_ F ) $=
      ( vx cfil cfv wcel wa crest co cv cin cmpt crn restval wf wss filin 3expa
      an32s eqid fmptd frn syl eqsstrd ) BCEFZGZABGZHZBAIJDBDKZALZMZNZBDABUFBOU
      IBBULPUMBQUIDBUKBULUGUJBGZUHUKBGZUGUNUHUOUJABCRSTULUAUBBBULUCUDUE $.

    $( If ` A ` is a member of the filter, then truncating ` F ` to ` A ` and
       regenerating the behavior outside ` A ` using ` filGen ` recovers the
       original filter.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    fgtr $p |- ( ( F e. ( Fil ` X ) /\ A e. F ) ->
      ( X filGen ( F |`t A ) ) = F ) $=
      ( vx vy cfil cfv wcel wa co cfg cfbas wss cpw filfbas filelss syl syl3anc
      wb adantr crest wn fbncp sylan trfil3 syldan mpbird restsspw sspwb syl5ss
      cdif sylib filtop fbasweak trfilss fgss wceq fgfil sseqtrd cv wrex wi cin
      ex elrestr 3expa inss1 sseq1 rspcev sylancl jcad elfg sylibrd ssrdv eqssd
      ) BCFGZHZABHZIZCBAUAJZKJZBVSWACBKJZBVSVTCLGZHZBWCHZVTBMWAWBMVSVTALGHZVTCN
      ZMCBHZWDVSVTAFGHZWFVSWICAUKBHUBZVQWEVRWJBCOZACBCUCUDVQVRACMZWIWJSABCPZABC
      UEUFUGVTAOQVSVTANZWGABUHVSWLWNWGMWMACUIULUJVQWHVRBCUMTVTBACUNRZVQWEVRWKTA
      BCUOVTBCUPRVQWBBUQVRBCURTUSVSDBWAVSDUTZBHZWPCMZEUTZWPMZEVTVAZIZWPWAHZVSWQ
      WRXAVQWQWRVBVRVQWQWRWPBCPVDTVSWQXAVSWQIWPAVCZVTHZXDWPMZXAVQVRWQXEWPABVPBV
      EVFWPAVGWTXFEXDVTWSXDWPVHVIVJVDVKVSWDXCXBSWOEWPVTCVLQVMVNVO $.

    $( The trace operation and the ` filGen ` operation are inverses to one
       another in some sense, with ` filGen ` growing the base set and ` |``t `
       shrinking it.  See ~ fgtr for the converse cancellation law.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    trfg $p |- ( ( F e. ( Fil ` A ) /\ A C_ X /\ X e. V ) ->
      ( ( X filGen F ) |`t A ) = F ) $=
      ( vx vy cfil cfv wcel wss co cv wceq cfbas cpw 3ad2ant1 sylib syl3anc syl
      wa w3a cfg crest cin crn filfbas filsspw simp2 sspwb sstrd simp3 fbasweak
      cmpt fgcl filtop restval syl2anc wf wrex wb simplbda simpll1 simprl inss2
      elfg a1i simprr filelss 3ad2antl1 ad2ant2r ssind filss syl13anc rexlimddv
      eqid fmptd frn eqsstrd df-ss adantr ssfg sselda elrestr eqeltrrd ex ssrdv
      eqssd ) BAGHIZADJZDCIZUAZDBUBKZAUCKZBWKWMEWLELZAUDZUMZUEZBWKWLDGHZIZABIZW
      MWQMWKBDNHIZWSWKBANHIZBDOZJWJXAWHWIXBWJBAUFPWKBAOZXCWHWIBXDJWJBAUGPWKWIXD
      XCJWHWIWJUHADUIQUJWHWIWJUKBCADULRZBDUNSZWHWIWTWJBAUOPZEAWLWRBUPUQWKWLBWPU
      RWQBJWKEWLWOBWPWKWNWLIZTZFLZWNJZWOBIZFBWKXHWNDJZXKFBUSZWKXAXHXMXNTUTXEFWN
      BDVESVAXIXJBIZXKTZTZWHXOWOAJZXJWOJXLWHWIWJXHXPVBXIXOXKVCXRXQWNAVDVFXQXJWN
      AXIXOXKVGWKXOXJAJZXHXKWHWIXOXSWJXJBAVHVIVJVKXJWOBAVLVMVNWPVOVPWLBWPVQSVRW
      KEBWMWKWNBIZWNWMIWKXTTZWOWNWMYAWNAJZWOWNMWHWIXTYBWJWNBAVHVIWNAVSQYAWSWTXH
      WOWMIWKWSXTXFVTWKWTXTXGVTWKBWLWNWKXABWLJXEBDWASWBWNAWLWRBWCRWDWEWFWG $.
  $}

  ${
    $d v u A $.  $d v u P $.  $d v u J $.  $d v Y $.
    $( The trace, over a set ` A ` , of the filter of the neighborhoods of a
       point ` P ` is a filter iff ` P ` belongs to the closure of ` A ` .
       (This is ~ trfil2 applied to a filter of neighborhoods.)  (Contributed
       by FL, 15-Sep-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    trnei $p |- ( ( J e. ( TopOn ` Y ) /\ A C_ Y /\ P e. Y ) ->
        ( P e. ( ( cls ` J ) ` A ) <->
          ( ( ( nei ` J ) ` { P } ) |`t A ) e. ( Fil ` A ) ) ) $=
      ( vv ctopon cfv wcel wss w3a ccl cv cin c0 wne csn cfil 3ad2ant1 syl3anc
      wb cnei wral crest ctop cuni topontop simp2 wceq toponuni sseqtrd eleqtrd
      co simp3 eqid neindisj2 simp1 snssd 3ad2ant3 neifil trfil2 syl2anc bitr4d
      snnzg ) CDFGHZADIZBDHZJZBACKGGHZELAMNOEBPZCUAGGZUBZVJAUCULAQGHZVGCUDHZACU
      EZIBVNHVHVKTVDVEVMVFDCUFRVGADVNVDVEVFUGZVDVEDVNUHVFDCUIRZUJVGBDVNVDVEVFUM
      ZVPUKBAECVNVNUNUOSVGVJDQGHZVEVLVKTVGVDVIDIVINOZVRVDVEVFUPVGBDVQUQVFVDVSVE
      BDVCURVICDUSSVOEAVJDUTVAVB $.
  $}

  ${
    $d w x y z A $.  $d w y z V $.  $d w x y z X $.
    $( Relative complements of the finite parts of an infinite set is a
       filter.  When ` A = NN ` the set of the relative complements is called
       Frechet's filter and is used to define the concept of limit of a
       sequence.  (Contributed by FL, 14-Jul-2008.)  (Revised by Stefan O'Rear,
       2-Aug-2015.) $)
    cfinfil $p |- ( ( X e. V /\ A C_ X /\ -. A e. Fin ) ->
        { x e. ~P X | ( A \ x ) e. Fin } e. ( Fil ` X ) ) $=
      ( vy vz vw wcel wss cfn cv cdif wa wceq difeq2 eleq1d vex wsbc c0 sbcie
      wn w3a cpw crab elrab elpw anbi1i bitri a1i cvv elex 3ad2ant1 ssdif0 0fin
      wb eleq1 mpbiri sylbi sbcieg biimpar sylan2 3adant3 0ex dif0 eleq1i con3i
      biimpi 3ad2ant3 wi sscon ssfi expcom syl 3imtr4g cin cun difindi syl5eqel
      unfi anbi12i inex1 isfild ) DCHZBDIZBJHZUAZUBZBEKZLZJHZEFGDBAKZLZJHZADUCZ
      UDZWHWOHZWHDIZWJMZUOWGWPWHWNHZWJMWRWMWJAWHWNWKWHNWLWIJWKWHBOPUEWSWQWJWHDE
      QUFUGUHUIWCWDDUJHWFDCUKULWCWDWJEDRZWFWDWCBDLZJHZWTWDXASNZXBBDUMXCXBSJHUNX
      ASJUPUQURWCWTXBWJXBEDCWHDNWIXAJWHDBOPUSUTVAVBWFWCWJESRZUAWDXDWEXDWEXDBSLZ
      JHZWEWJXFESVCWHSNWIXEJWHSBOPTXEBJBVDVEUHVGVFVHGKZFKZIZWGWJEXGRZWJEXHRZVIX
      HDIZXIBXGLZJHZBXHLZJHZXJXKXIXOXMIZXNXPVIXGXHBVJXNXQXPXMXOVKVLVMWJXNEXGGQW
      HXGNWIXMJWHXGBOPTZWJXPEXHFQZWHXHNWIXOJWHXHBOPTZVNVHWGXLXGDIUBZXPXNMZBXHXG
      VOZLZJHZXKXJMWJEYCRYBYEVIYAYBYDXOXMVPJBXHXGVQXOXMVSVRUIXKXPXJXNXTXRVTWJYE
      EYCXHXGXSWAWHYCNWIYDJWHYCBOPTVNWB $.
  $}

  ${
    $d w x y z X $.  $d w y z V $.
    $( The set of all elements whose complement is dominated by the base set is
       a filter.  (Contributed by Mario Carneiro, 14-Dec-2013.)  (Revised by
       Stefan O'Rear, 2-Aug-2015.) $)
    csdfil $p |- ( ( X e. dom card /\ om ~<_ X ) ->
        { x e. ~P X | ( X \ x ) ~< X } e. ( Fil ` X ) ) $=
      ( vy vz vw wcel wbr wa cv cdif csdm wss wb wceq difeq2 breq1d vex wsbc c0
      sbcie ccrd cdm com cdom cpw crab elrab elpw anbi1i bitri a1i adantr difid
      cvv elex wne adantl 0sdomg mpbird syl5eqbr sbcieg sdomirr 0ex dif0 syl6eq
      infn0 mtbiri w3a wi simp1l difexg sscon 3ad2ant3 ssdomg sylc domsdomtr ex
      syl 3imtr4g cin cun infunsdom difindi breq1i syl6ibr anbi12i inex1 isfild
      3ad2ant1 ) BUAUBZFZUCBUDGZHZBCIZJZBKGZCDEBBAIZJZBKGZABUEZUFZWNXAFZWNBLZWP
      HZMWMXBWNWTFZWPHXDWSWPAWNWTWQWNNWRWOBKWQWNBOPUGXEXCWPWNBCQUHUIUJUKWKBUNFW
      LBWJUOULWMWPCBRZBBJZBKGZWMXGSBKBUMWMSBKGZBSUPZWLXJWKBVFUQWKXIXJMWLBWJURUL
      USUTWKXFXHMWLWPXHCBWJWNBNWOXGBKWNBBOPVAULUSWMWPCSRZBBKGZBVBXKXLMWMWPXLCSV
      CWNSNZWOBBKXMWOBSJBWNSBOBVDVEPTUKVGWMDIZBLZEIZXNLZVHZBXPJZBKGZBXNJZBKGZWP
      CXPRZWPCXNRZXRYAXSUDGZXTYBVIXRXSUNFZYAXSLZYEXRWKYFWKWLXOXQVJBXPWJVKVRXQWM
      YGXOXPXNBVLVMYAXSUNVNVOYEXTYBYAXSBVPVQVRWPXTCXPEQWNXPNWOXSBKWNXPBOPTZWPYB
      CXNDQZWNXNNWOYABKWNXNBOPTZVSWMXOXPBLZVHYBXTHZBXNXPVTZJZBKGZYDYCHWPCYMRWMX
      OYLYOVIYKWMYLYAXSWAZBKGZYOWMYLYQYAXSBWBVQYNYPBKBXNXPWCWDWEWIYDYBYCXTYJYHW
      FWPYOCYMXNXPYIWGWNYMNWOYNBKWNYMBOPTVSWH $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w y z V $.
    $( The supersets of a nonempty set which are also subsets of a given base
       set form a filter.  (Contributed by Jeff Hankins, 12-Nov-2009.)
       (Revised by Stefan O'Rear, 7-Aug-2015.) $)
    supfil $p |- ( ( A e. V /\ B C_ A /\ B =/= (/) ) ->
        { x e. ~P A | B C_ x } e. ( Fil ` A ) ) $=
      ( vy vz vw wcel wss c0 w3a cv wa wb sseq2 vex a1i cvv wsbc sbcie wne crab
      cpw elrab elpw anbi1i bitri elex 3ad2ant1 simp2 sbcieg mpbird wn necon3ai
      syl ss0 3ad2ant3 0ex sylnibr wi sstr expcom 3imtr4g cin ssin biimpi inex1
      syl2anb sylibr isfild ) BDHZCBIZCJUAZKZCELZIZEFGBCALZIZABUCZUBZVOVTHZVOBI
      ZVPMZNVNWAVOVSHZVPMWCVRVPAVOVSVQVOCOUDWDWBVPVOBEPUEUFUGQVKVLBRHZVMBDUHUIZ
      VNVPEBSZVLVKVLVMUJVNWEWGVLNWFVPVLEBRVOBCOUKUOULVNCJIZVPEJSVMVKWHUMVLWHCJC
      UPUNUQVPWHEJURVOJCOTUSGLZFLZIZVNVPEWISZVPEWJSZUTWJBIZWKCWIIZCWJIZWLWMWOWK
      WPCWIWJVAVBVPWOEWIGPVOWICOTZVPWPEWJFPZVOWJCOTZVCUQWMWLMZVPEWJWIVDZSZUTVNW
      NWIBIKWTCXAIZXBWMWPWOXCWLWSWQWPWOMXCCWJWIVEVFVHVPXCEXAWJWIWRVGVOXACOTVIQV
      J $.
  $}

  ${
    $d x y M $.  $d x y Z $.
    $( The set of upper integer sets is a filter base on ` ZZ ` , which
       corresponds to convergence of sequences on ` ZZ ` .  (Contributed by
       Mario Carneiro, 13-Oct-2015.) $)
    zfbas $p |- ran ZZ>= e. ( fBas ` ZZ ) $=
      ( vx vy cuz crn cz cfbas cfv wcel cpw c0 wne cv cin wral uzf ax-mp c1 cvv
      wb wa wss wnel w3a wf frn wfn ffn 1z fnfvelrn mp2an ne0i wceq wrex wn n0i
      uzid syl nrex fvelrnb mtbir nelir uzin2 inex1 pwid inelcm sylancl 3pm3.2i
      vex rgen2a zex isfbas mpbir2an ) CDZEFGHZVMEIZUAZVMJKZJVMUBZVMALZBLZMZIZM
      JKZBVMNAVMNZUCZEVOCUDZVPOEVOCUEPVQVRWDQCGZVMHZVQCEUFZQEHWHWFWIOEVOCUGPZUH
      EQCUIUJVMWGUKPJVMJVMHZVSCGZJULZAEUMZWMAEVSEHVSWLHWMUNVSUPWLVSUOUQURWIWKWN
      SWJAEJCUSPUTVAWCABVMVSVMHVTVMHTWAVMHWAWBHWCVSVTVBWAVSVTAVHVCVDWAVMWBVEVFV
      IVGERHVNVPWETSVJABREVMVKPVL $.

    uzfbas.1 $e |- Z = ( ZZ>= ` M ) $.
    $( The restriction of the set of upper integers to an upper integer set is
       the set of upper integers based at a point above the cutoff.
       (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    uzrest $p |- ( M e. ZZ -> ( ran ZZ>= |`t Z ) = ( ZZ>= " Z ) ) $=
      ( vx vy cz wcel cuz crn cv cin cvv wceq wf wss uzf ax-mp cfv wral a1i cpw
      crest cima cmpt zex pwex frn ssexi fvex eqeltri restval mp2an cle wbr cif
      co wa ineq2i uzin ancoms syl5eq wfn ffn uzssz eqsstri inss2 ifcl uzid syl
      eleqtrrd sseldi fnfvima syl3anc eqeltrd ralrimiva ineq1 eleq1d ralrn eqid
      wb sylibr fmpt sylib syl5eqss uztrn2 ex ssrdv adantl df-ss sseli fnfvelrn
      sylancr elrestr eqeltrrd wfun cdm ffun fdmi sseqtr4i funimass4 eqssd ) AF
      GZHIZBUBUPZHBUCZXBXDDXCDJZBKZUDZIZXEXCLGZBLGZXDXIMXCFUAZFUEUFFXLHNZXCXLOP
      FXLHUGQUHZBAHRZLCAHUIUJZDBXCLLUKULXBXCXEXHNZXIXEOXBXGXEGZDXCSZXQXBEJZHRZB
      KZXEGZEFSZXSXBYCEFXBXTFGZUQZYBXTAUMUNZAXTUOZHRZXEYFYBYAXOKZYIBXOYACURYEXB
      YJYIMXTAUSUTVAZYFHFVBZBFOZYHBGYIXEGYLYFXMYLPFXLHVCQZTYMYFBXOFCAVDVEZTYFYB
      BYHYABVFYFYHYIYBYFYHFGYHYIGYGAXTFVGYHVHVIYKVJVKFBHYHVLVMVNVOYLXSYDVTYNXRY
      CDEFHXFYAMXGYBXEXFYABVPVQVRQWADXCXEXGXHXHVSWBWCXCXEXHUGVIWDXBXFHRZXDGZDBS
      ZXEXDOZXBYQDBXBXFBGZUQZYPBKZYPXDUUAYPBOZUUBYPMYTUUCXBYTEYPBYTXTYPGXTBGAXT
      XFBCWEWFWGWHYPBWIWCUUAXJXKYPXCGZUUBXDGXJUUAXNTXKUUAXPTUUAYLXFFGZUUDYNYTUU
      EXBBFXFYOWJWHFXFHWKWLYPBXCLLWMVMWNVOHWOZBHWPZOYSYRVTXMUUFPFXLHWQQBFUUGYOF
      XLHPWRWSDBXDHWTULWAXA $.

    $( The set of upper integer sets based at a point in a fixed upper integer
       set like ` NN ` is a filter base on ` NN ` , which corresponds to
       convergence of sequences on ` NN ` .  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    uzfbas $p |- ( M e. ZZ -> ( ZZ>= " Z ) e. ( fBas ` Z ) ) $=
      ( cz wcel cuz crn crest co cima cfbas cfv uzrest c0 wn zfbas 0nelfb ax-mp
      imassrn syl6eqss sseld wss wb uzssz eqsstri trfbas2 mp2an sylibr eqeltrrd
      mtoi ) ADEZFGZBHIZFBJZBKLZABCMZUKNUMEZOZUMUOEZUKUQNULEZULDKLEZUTOPDULQRUK
      UMULNUKUMUNULUPFBSTUAUJVABDUBUSURUCPBAFLDCAUDUEBULDUFUGUHUI $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ultrafilters
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c UFil $.
  $c UFL $.

  $( Extend class notation with the ultrafilters-on-a-set function. $)
  cufil $a class UFil $.

  $( Extend class notation with the ultrafilter lemma. $)
  cufl $a class UFL $.

  ${
    $d f g x $.
    $( Define the set of ultrafilters on a set.  An ultrafilter is a filter
       that gives a definite result for every subset.  (Contributed by Jeff
       Hankins, 30-Nov-2009.) $)
    df-ufil $a |- UFil = ( g e. _V |-> { f e. ( Fil ` g ) |
            A. x e. ~P g ( x e. f \/ ( g \ x ) e. f ) } ) $.

    $( Define the class of base sets for which the ultrafilter lemma
       ~ filssufil holds.  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    df-ufl $a |- UFL = { x | A. f e. ( Fil ` x )
      E. g e. ( UFil ` x ) f C_ g } $.
  $}

  ${
    $d x y z F $.  $d x y z X $.
    $( The property of being an ultrafilter.  (Contributed by Jeff Hankins,
       30-Nov-2009.)  (Revised by Mario Carneiro, 29-Jul-2015.) $)
    isufil $p |- ( F e. ( UFil ` X ) <-> ( F e. ( Fil ` X ) /\
          A. x e. ~P X ( x e. F \/ ( X \ x ) e. F ) ) ) $=
      ( vz vy cv wcel cdif wo cpw wral cfil cfv cufil cvv cdm df-ufil wceq wa
      wb adantr eleq2 adantl difeq1 eleq12 sylan orbi12d raleqbidv fveq2 elfvdm
      pweq fvex elmptrab2 ) AFZDFZGZEFZUNHZUOGZIZAUQJZKUNBGZCUNHZBGZIZACJZKEDUQ
      LMCLMNOLPCBADEQUQCRZUOBRZSZUTVEAVAVFVGVAVFRVHUQCUKUAVIUPVBUSVDVHUPVBTVGUO
      BUNUBUCVGURVCRVHUSVDTUQCUNUDURVCUOBUEUFUGUHUQCLUIUQLULBCLUJUM $.
  $}

  ${
    $d x F $.  $d x X $.
    $( An ultrafilter is a filter.  (Contributed by Jeff Hankins, 1-Dec-2009.)
       (Revised by Mario Carneiro, 29-Jul-2015.) $)
    ufilfil $p |- ( F e. ( UFil ` X ) -> F e. ( Fil ` X ) ) $=
      ( vx cufil cfv wcel cfil cv cdif wo cpw wral isufil simplbi ) ABDEFABGEFC
      HZAFBOIAFJCBKLCABMN $.
  $}

  ${
    $d f x y F $.  $d x S $.  $d f x y X $.  $d x G $.  $d x Y $.
    $( For any subset of the base set of an ultrafilter, either the set is in
       the ultrafilter or the complement is.  (Contributed by Jeff Hankins,
       1-Dec-2009.)  (Revised by Mario Carneiro, 29-Jul-2015.) $)
    ufilss $p |- ( ( F e. ( UFil ` X ) /\ S C_ X ) ->
        ( S e. F \/ ( X \ S ) e. F ) ) $=
      ( vx cufil cfv wcel wss cdif wo cpw cdm wb elfvdm elpw2g syl cv wral cfil
      wi isufil simprbi wceq eleq1 difeq2 eleq1d orbi12d rspccv sylbird imp ) B
      CEFGZACHZABGZCAIZBGZJZUKULACKZGZUPUKCELZGURULMBCENACUSOPUKDQZBGZCUTIZBGZJ
      ZDUQRZURUPTUKBCSFGVEDBCUAUBVDUPDAUQUTAUCZVAUMVCUOUTABUDVFVBUNBUTACUEUFUGU
      HPUIUJ $.

    $( The complement is in an ultrafilter iff the set is not.  (Contributed by
       Mario Carneiro, 11-Dec-2013.)  (Revised by Mario Carneiro,
       29-Jul-2015.) $)
    ufilb $p |- ( ( F e. ( UFil ` X ) /\ S C_ X ) ->
                  ( -. S e. F <-> ( X \ S ) e. F ) ) $=
      ( cufil cfv wcel wss wa wn cdif ufilss ord wi cfbas ufilfil filfbas fbncp
      cfil ex con2d 3syl adantr impbid ) BCDEFZACGZHZABFZIZCAJBFZUFUGUIABCKLUDU
      IUHMZUEUDBCREFBCNEFZUJBCOBCPUKUGUIUKUGUIIACBCQSTUAUBUC $.

    $( Any filter finer than an ultrafilter is actually equal to it.
       (Contributed by Jeff Hankins, 1-Dec-2009.)  (Revised by Mario Carneiro,
       29-Jul-2015.) $)
    ufilmax $p |- ( ( F e. ( UFil ` X ) /\ G e. ( Fil ` X ) /\ F C_ G ) ->
        F = G ) $=
      ( vx cufil cfv wcel cfil wss w3a simp3 cv wi filelss ex 3ad2ant2 wa wn wb
      cdif ufilb 3ad2antl1 simpl3 sseld cfbas filfbas fbncp con2d adantr sylbid
      syl syld con4d com23 mpdd ssrdv eqssd ) ACEFGZBCHFGZABIZJZABURUSUTKVADBAV
      ADLZBGZVBCIZVBAGZUSURVCVDMUTUSVCVDVBBCNOPVAVDVCVEVAVDVCVEMVAVDQZVEVCVFVER
      ZCVBTZAGZVCRZURUSVDVGVISUTVBACUAUBVFVIVHBGZVJVFABVHURUSUTVDUCUDVAVKVJMZVD
      USURVLUTUSVCVKUSBCUEFGZVCVKRZMBCUFVMVCVNVBCBCUGOUKUHPUIULUJUMOUNUOUPUQ $.

    $( The maximal property of an ultrafilter.  (Contributed by Jeff Hankins,
       30-Nov-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    isufil2 $p |- ( F e. ( UFil ` X ) <-> ( F e. ( Fil ` X ) /\
          A. f e. ( Fil ` X ) ( F C_ f -> F = f ) ) ) $=
      ( vx vy cfv wcel cv wss wceq wi wral wa wn cin c0 wne cvv syl ad2antrr wo
      cufil cfil ufilfil ufilmax ralrimiva jca cdif cpw simpl elpwi csn cun cfi
      3expia cfg simpll snex unexg sylancl ssfii cfbas filsspw vex elpw biimpri
      ad2antlr snssd unssd ssun2 snnz mp2an a1i simpr ineq2 neeq1d ralsn ralbii
      co ssn0 sylibr wb filfbas simplr inss2 filtop adantr ineq1 rspcva sylancr
      sylan snfbas syl3anc fbunfip syl2anc mpbird fsubbas mpbir3and ssfg unssad
      w3a sstrd fgcl sseq2 eqeq2 imbi12d rspcv 3syl mpid snid sselii syl5ibrcom
      sseldd eleq2 syld impancom an32s con3d rexnal filelss reldisj difss filss
      wrex nne 3exp2 imp sylbid syl5bi rexlimdva syl5bir sylan2 isufil sylanbrc
      mpii orrd impbii ) BCUBFGZBCUCFZGZBAHZIZBUUAJZKZAYSLZMZYRYTUUEBCUDYRUUDAY
      SYRUUAYSGUUBUUCBUUACUEUOUFUGUUFYTDHZBGZCUUGUHZBGZUAZDCUIZLYRYTUUEUJUUFUUK
      DUULUUGUULGZUUFUUGCIZUUKUUGCUKUUFUUNMZUUHUUJUUOUUHNEHZUUGOZPQZEBLZNZUUJUU
      OUUSUUHYTUUNUUEUUSUUHKYTUUNMZUUSUUEUUHUVAUUSMZUUEBCBUUGULZUMZUNFZUPVSZJZU
      UHUVBUUEBUVFIZUVGUVBBUVCUVFUVBUVDUVEUVFUVBUVDRGZUVDUVEIUVBYTUVCRGUVIYTUUN
      UUSUQUUGURBUVCYSRUSUTUVDRVASUVBUVECVBFZGZUVEUVFIUVBUVKUVDUULIZUVDPQZPUVEG
      NZUVBBUVCUULYTBUULIUUNUUSBCVCTUVBUUGUULUUNUUMYTUUSUUMUUNUUGCDVDZVEVFVGVHV
      IUVMUVBUVCUVDIUVCPQUVMUVCBVJZUUGUVOVKUVCUVDVTVLVMUVBUVNUUPUUAOZPQZAUVCLZE
      BLZUVBUUSUVTUVAUUSVNUVSUUREBUVRUURAUUGUVOUUAUUGJUVQUUQPUUAUUGUUPVOVPVQVRW
      AUVBBUVJGZUVCUVJGZUVNUVTWBYTUWAUUNUUSBCWCTUVBUUNUUGPQZCBGZUWBYTUUNUUSWDUV
      BCUUGOZUUGIUWEPQZUWCCUUGWEUVAUWDUUSUWFYTUWDUUNBCWFZWGUURUWFECBUUPCJUUQUWE
      PUUPCUUGWHVPWIWKUWEUUGVTWJYTUWDUUNUUSUWGTZUUGCBWLWMEABUVCCCWNWOWPUVBUWDUV
      KUVLUVMUVNXAWBUWHUVDBCWQSWRZUVECWSSXBZWTUVBUVKUVFYSGUUEUVHUVGKZKUWIUVECXC
      UUDUWKAUVFYSUUAUVFJUUBUVHUUCUVGUUAUVFBXDUUAUVFBXEXFXGXHXIUVBUUHUVGUUGUVFG
      UVBUVDUVFUUGUWJUUGUVDGUVBUVCUVDUUGUVPUUGUVOXJXKVMXMBUVFUUGXNXLXOXPXQXRYTU
      UTUUJKUUEUUNUUTUURNZEBYDYTUUJUUREBXSYTUWLUUJEBUWLUUQPJZYTUUPBGZMZUUJUUQPY
      EUWOUWMUUPUUIIZUUJUWOUUPCIUWMUWPWBUUPBCXTUUPUUGCYASYTUWNUWPUUJKZYTUWNUUIC
      IZUWQCUUGYBYTUWNUWRUWPUUJUUPUUIBCYCYFYOYGYHYIYJYKTXOYPYLUFDBCYMYNYQ $.

    $( An ultrafilter is a prime filter.  (Contributed by Jeff Hankins,
       1-Jan-2010.)  (Revised by Mario Carneiro, 2-Aug-2015.) $)
    ufprim $p |- ( ( F e. ( UFil ` X ) /\ A C_ X /\ B C_ X ) ->
        ( ( A e. F \/ B e. F ) <-> ( A u. B ) e. F ) ) $=
      ( cfv wcel wss w3a cun wa 3ad2ant1 adantr simpr a1i filss syl13anc ex cin
      cdif indifcom cufil wo cfil ufilfil unss biimpi 3adant1 ssun1 ssun2 wn wb
      ufilb 3adant3 difun2 uncom difeq1i eqtr3i ineq2i 3eqtr4i syl3an1 syl5eqel
      jaod filin simp13 inss1 3expia sylbid orrd impbid ) CDUAEFZADGZBDGZHZACFZ
      BCFZUBZABIZCFZVMVNVRVOVMVNVRVMVNJZCDUCEFZVNVQDGZAVQGZVRVMVTVNVJVKVTVLCDUD
      KZLVMVNMVMWAVNVKVLWAVJVKVLJWAABDUEUFUGZLWBVSABUHNAVQCDOPQVMVOVRVMVOJZVTVO
      WABVQGZVRVMVTVOWCLVMVOMVMWAVOWDLWFWEBAUINBVQCDOPQVBVMVRVPVMVRJZVNVOWGVNUJ
      ZDASZCFZVOVMWHWJUKZVRVJVKWKVLACDULUMLVMVRWJVOVMVRWJHZVTBWIRZCFVLWMBGZVOVM
      VRVTWJWCKWLWMVQWIRZCDBASZRDVQASZRWMWOWPWQDBAIZASWPWQBAUNWRVQABAUOUPUQURBD
      ATVQDATUSVMVTVRWJWOCFWCVQWICDVCUTVAVJVKVLVRWJVDWNWLBWIVENWMBCDOPVFVGVHQVI
      $.
  $}

  ${
    $d x A $.  $d x L $.  $d x Y $.
    $( Conditions for the trace of an ultrafilter ` L ` to be an ultrafilter.
       (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    trufil $p |- ( ( L e. ( UFil ` Y ) /\ A C_ Y ) ->
      ( ( L |`t A ) e. ( UFil ` A ) <-> A e. L ) ) $=
      ( vx cufil cfv wcel wss wa cdif cfil ufilfil wo simpll simplr cin elrestr
      cvv adantr wceq crest co wn wb trfil3 sylan syl5ib cpw wral biimprd elpwi
      cv simpr sstrd ufilss syl2anc wi cdm id elfvdm ssexg syl2anr 3expia df-ss
      syldan sylib eleq1d sylibd indif1 difeq1d syl5eq syl3anc eqeltrrd orim12d
      dfss1 simprr expr mpd sylan2 ralrimiva jctird isufil syl6ibr impbid ufilb
      con1bid bitrd ) BCEFZGZACHZIZBAUAUBZAEFGZCAJBGZUCZABGZWKWMWOWMWLAKFGZWKWO
      WLALWIBCKFGWJWQWOUDBCLABCUEUFZUGWKWOWQDULZWLGZAWSJZWLGZMZDAUHZUIZIWMWKWOW
      QXEWKWQWOWRUJWKXCDXDWSXDGWKWSAHZXCWSAUKWKXFIZWSBGZCWSJZBGZMZXCXGWIWSCHXKW
      IWJXFNXGWSACWKXFUMZWIWJXFOUNWSBCUOUPXGXHWTXJXBXGXHWSAPZWLGZWTWKXHXNUQZXFW
      IWJARGZXOWJWJCEURZGXPWIWJUSBCEUTACXQVAVBZWIXPXHXNWSABWHRQVCVESXGXMWSWLXGX
      FXMWSTXLWSAVDVFVGVHWKXFXJXBWKXFXJIZIZXIAPZXAWLXTYACAPZWSJXACAWSVIXTYBAWSX
      TWJYBATWIWJXSOACVOVFVJVKXTWIXPXJYAWLGWIWJXSNWKXPXSXRSWKXFXJVPXIABWHRQVLVM
      VQVNVRVSVTWADWLAWBWCWDWKWPWNABCWEWFWG $.
  $}

  ${
    $d f g h x y F $.  $d f g h x y X $.
    $( A filter is contained in some ultrafilter.  This version of ~ filssufil
       contains the choice as a hypothesis (in the assumption that ` ~P ~P X `
       is well-orderable).  (Contributed by Mario Carneiro, 24-May-2015.)
       (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    filssufilg $p |- ( ( F e. ( Fil ` X ) /\ ~P ~P X e. dom card ) ->
        E. f e. ( UFil ` X ) F C_ f ) $=
      ( vh vg vx cfv wcel cpw wa cv wss wral wrex c0 wne wi sseq2 elrab syl cdm
      cfil ccrd wpss crab cufil crpss wor w3a cuni wal simpr rabss filsspw elpw
      wn vex sylibr a1d mprgbir ssnum sylancl ssid jctr adantr cun simpr1 ssrab
      ne0i sylib simpld simpr2 simpr3 sorpssun ralrimivva filuni syl3anc wex n0
      ssel2 simprd ssuni sylancom ex exlimdv syl5bi sylc alrimiv zornn0g ralrab
      sylanbrc weq simpll sstr2 imim1d df-pss simplbi2 necon1bd a2i ralimdv imp
      syl6 adantll isufil2 simplr jca syl2anb reximi2 ) BCUBGZHZCIZIZUCUAZHZJZA
      KZDKZUDZUPZDBEKZLZEXIUEZMZAYBNZBXPLZACUFGZNXOYBXMHZYBOPZFKZYBLZYIOPZYIUGU
      HZUIZYIUJZYBHZQZFUKZYDXOXNYBXLLZYGXJXNULYRYAXTXLHZQEXIYAEXIXLUMXTXIHZYSYA
      YTXTXKLYSXTCUNXTXKEUQUOURUSUTXLYBVAVBXJYHXNXJBYBHZYHXJXJBBLZJUUAXJUUBBVCV
      DYAUUBEBXIXTBBRSURYBBVITVEXJYQXNXJYPFXJYMYOXJYMJZYNXIHZBYNLZYOUUCYIXILZYK
      XTXQVFYIHZDYIMEYIMZUUDUUCUUFYAEYIMZUUCYJUUFUUIJXJYJYKYLVGZYAEXIYIVHVJVKXJ
      YJYKYLVLZUUCYLUUHXJYJYKYLVMYLUUGEDYIYIYIXTXQVNVOTEDYICVPVQUUCYJYKUUEUUJUU
      KYKXQYIHZDVRYJUUEDYIVSYJUULUUEDYJUULUUEYJUULBXQLZUUEYJUULJZXQXIHZUUMUUNXQ
      YBHUUOUUMJYIYBXQVTYAUUMEXQXIXTXQBRZSVJWABXQYIWBWCWDWEWFWGYAUUEEYNXIXTYNBR
      SWKWDWHVEADFYBWIVQYCYEAYBYFXPYBHXPXIHZYEJZUUMXSQZDXIMZXPYFHZYEJYCYAYEEXPX
      IXTXPBRSYAUUMXSDEXIUUPWJUURUUTJZUVAYEUVBUUQXPXQLZADWLZQZDXIMZUVAUUQYEUUTW
      MYEUUTUVFUUQYEUUTUVFYEUUSUVEDXIYEUUSUVCXSQUVEYEUVCUUMXSBXPXQWNWOUVCXSUVDU
      VCXRXPXQXRUVCXPXQPXPXQWPWQWRWSXBWTXAXCDXPCXDWKUUQYEUUTXEXFXGXHT $.

    $( A filter is contained in some ultrafilter.  (Requires the Axiom of
       Choice, via ~ numth3 .)  (Contributed by Jeff Hankins, 2-Dec-2009.)
       (Revised by Stefan O'Rear, 29-Jul-2015.) $)
    filssufil $p |- ( F e. ( Fil ` X ) -> E. f e. ( UFil ` X ) F C_ f ) $=
      ( cfil cfv wcel cpw ccrd cdm cv cufil wrex filtop pwexg numth3 filssufilg
      wss cvv 4syl mpdan ) BCDEFZCGZGZHIFZBAJQACKELUACBFUBRFUCRFUDBCMCBNUBRNUCR
      OSABCPT $.
  $}

  ${
    $d f g F $.  $d f g u x X $.  $d f g u Y $.
    $( Define the (strong) ultrafilter lemma, parameterized over base sets.  A
       set ` X ` satisfies the ultrafilter lemma if every filter on ` X ` is a
       subset of some ultrafilter.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    isufl $p |- ( X e. V -> ( X e. UFL <->
      A. f e. ( Fil ` X ) E. g e. ( UFil ` X ) f C_ g ) ) $=
      ( vx cv wss cufil wrex cfil wral cufl wceq fveq2 rexeqdv raleqbidv df-ufl
      cfv elab2g ) AFBFGZBEFZHRZIZAUAJRZKTBDHRZIZADJRZKEDLCUADMZUCUFAUDUGUADJNU
      HTBUBUEUADHNOPEABQS $.

    $( Property of a set that satifies the ultrafilter lemma.  (Contributed by
       Mario Carneiro, 26-Aug-2015.) $)
    ufli $p |- ( ( X e. UFL /\ F e. ( Fil ` X ) ) ->
        E. f e. ( UFil ` X ) F C_ f ) $=
      ( vg cufl wcel cv wss cufil cfv wrex cfil wral isufl wceq rexbidv rspccva
      ibi sseq1 sylan ) CEFZDGZAGZHZACIJZKZDCLJZMZBUGFBUCHZAUEKZUAUHDAECNRUFUJD
      BUGUBBOUDUIAUEUBBUCSPQT $.

    $( Consequence of ~ filssufilg : a set whose double powerset is
       well-orderable satifies the ultrafilter lemma.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    numufl $p |- ( ~P ~P X e. dom card -> X e. UFL ) $=
      ( vf vg cpw ccrd cdm wcel cufl cv wss cufil cfv wrex cfil wral filssufilg
      ancoms cvv pwexb sylibr ralrimiva wb elex isufl syl mpbird ) ADZDZEFZGZAH
      GZBIZCIJCAKLMZBANLZOZUJUMBUNULUNGUJUMCULAPQUAUJARGZUKUOUBUJUGRGZUPUJUHRGU
      QUHUIUCUGSTASTBCRAUDUEUF $.

    $( A finite set satifies the ultrafilter lemma.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    fiufl $p |- ( X e. Fin -> X e. UFL ) $=
      ( cfn wcel cpw cufl pwfi ccrd cdm finnum numufl syl sylbi ) ABCADZBCZAECZ
      AFNMDZBCZOMFQPGHCOPIAJKLL $.

    $( The axiom of choice implies the ultrafilter lemma.  (Contributed by
       Mario Carneiro, 26-Aug-2015.) $)
    acufl $p |- ( CHOICE -> UFL = _V ) $=
      ( vx wac cufl cvv wcel cpw ccrd cdm vex pwex wceq dfac10 biimpi syl5eleqr
      cv numufl syl a1i 2thd eqrdv ) BACDBAOZCEZUADEZBUAFZFZGHZEUBBUEDUFUDUAAIZ
      JJBUFDKLMNUAPQUCBUGRST $.

    $( If ` Y ` is a subset of ` X ` and filters extend to ultrafilters in
       ` X ` , then they still do in ` Y ` .  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    ssufl $p |- ( ( X e. UFL /\ Y C_ X ) -> Y e. UFL ) $=
      ( vf vg vu cufl wcel wss wa cv cufil cfv wrex co cfbas cpw syl2anc adantr
      cfil syl wral cfg simpll filfbas adantl simplr sspwb sylib sstrd fbasweak
      filsspw syl3anc fgcl ufli crest ssfg simprr filtop ad2antlr sseldd simprl
      wb trufil mpbird restid2 ssrest eqsstr3d sseq2 rspcev rexlimddv ralrimiva
      wceq cvv ssexg ancoms isufl ) AFGZBAHZIZBFGZCJZDJZHZDBKLZMZCBSLZUAZVSWECW
      FVSWAWFGZIZAWAUBNZEJZHZWEEAKLZWIVQWJASLGZWLEWMMVQVRWHUCZWIWAAOLGZWNWIWABO
      LGZWAAPZHVQWPWHWQVSWABUDUEWIWABPZWRWHWAWSHZVSWABUKUEZWIVRWSWRHVQVRWHUFZBA
      UGUHUIWOWAFBAUJULZWAAUMTEWJAUNQWIWKWMGZWLIZIZWKBUONZWDGZWAXGHZWEXFXHBWKGZ
      XFWAWKBXFWAWJWKWIWAWJHZXEWIWPXKXCWAAUPTRWIXDWLUQUIZWHBWAGZVSXEWABURUSZUTX
      FXDVRXHXJVBWIXDWLVAZWIVRXEXBRBWKAVCQVDXFWAWABUONZXGXFXMWTXPWAVLXNWIWTXEXA
      RBWAWAVEQXFXDWAWKHXPXGHXOXLBWAWKWMVFQVGWCXIDXGWDWBXGWAVHVIQVJVKVSBVMGZVTW
      GVBVRVQXQBAFVNVOCDVMBVPTVD $.
  $}

  ${
    $d f g x F $.  $d f g x X $.
    $( If the ultrafilter containing a given filter is unique, the filter is an
       ultrafilter.  (Contributed by Jeff Hankins, 3-Dec-2009.)  (Revised by
       Mario Carneiro, 2-Oct-2015.) $)
    ufileu $p |- ( F e. ( Fil ` X ) ->
        ( F e. ( UFil ` X ) <-> E! f e. ( UFil ` X ) F C_ f ) ) $=
      ( vg cfv wcel cv wss wceq wi wral wa ex wb syl wn c0 wne ad2antrr cvv csn
      cfil cufil wreu ufilfil ufilmax 3expa eqcomd sylan2 ralrimiva sseq2 eqreu
      ssid mp3an2 mpdan wrex reu6 ibibr pm5.74ri bitr3d rspcva adantll ad2antlr
      vx filelss cdif cun cfi cfg co cfbas cpw difss filtop difexg elpwg mpbiri
      filsspw snssd unssd ssun1 filn0 ssn0 sylancr ad2ant2rl df-ss sylib sseq1d
      filss 3exp2 com23 imp3a adantr sylbid con3d expr impr ineq2 neeq1d ralsng
      cin imp inssdif0 necon3bbii syl6bbr mpbird filfbas difssd ssdif0 simplbi2
      eqss notbid biimpcd sylan9 adantl syl5bir necon2ad snfbas syl3anc fbunfip
      eleq1 mpd syl2anc w3a fsubbas mpbir3and fgcl filssufil r19.29 simpll snex
      bi1 unexg sylancl ssfii ssfg sstrd unssad sstr2 sseldd a2i rexlimdvw syl5
      imim1d syl56 mpan2d an32s snidg elun2 simprl ufilb con4d mpdd ssrdv eqssd
      adantlr simpllr simplr eqeltrd rexlimdva syl5bi impbid2 ) BCUBEZFZBCUCEZF
      ZBAGZHZAUVEUDZUVFUVHUVGBIZJZAUVEKZUVIUVFUVKAUVEUVGUVEFUVFUVGUVCFZUVKUVGCU
      EUVFUVMLZUVHUVJUVNUVHLBUVGUVFUVMUVHBUVGIBUVGCUFUGUHMUIUJUVFBBHZUVLUVIBUMU
      VHUVOAUVEBUVGBBUKULUNUOUVIUVHUVGDGZIZNZAUVEKZDUVEUPUVDUVFUVHADUVEUQUVDUVS
      UVFDUVEUVDUVPUVEFZLZUVSUVFUWAUVSLZBUVPUVEUWBBUVPUVTUVSBUVPHZUVDUVRUWCAUVP
      UVEUVQUVHUVRUWCUVQUVHUVRUVQUVHURUSUVGUVPBUKUTVAVBUWBVDUVPBUWBVDGZUVPFZUWD
      CHZUWDBFZUVTUWEUWFJZUVDUVSUVTUVPUVCFZUWHUVPCUEUWIUWEUWFUWDUVPCVEMOVCUWBUW
      FUWEUWGUWBUWFUWEUWGJUWBUWFLUWGUWEUWBUWFUWGPZUWEPZUWBUWFUWJLZLZUWKCUWDVFZU
      VPFZUWMCBUWNUAZVGZVHEZVIVJZUVPUWNUWAUWLUVSUWSUVPHZUWAUWLLZUVSUWTUXAUVSUWS
      UVGHZAUVEUPZUWTUXAUWSUVCFZUXCUXAUWRCVKEZFZUXDUXAUXFUWQCVLZHZUWQQRZQUWRFPZ
      UXABUWPUXGUVDBUXGHUVTUWLBCVRSUXAUWNUXGUXAUWNUXGFZUWNCHZCUWDVMUXAUWNTFZUXK
      UXLNUXACBFZUXMUVDUXNUVTUWLBCVNSZCUWDBVOOZUWNCTVPOVQVSVTUXABUWQHBQRZUXIBUW
      PWAUVDUXQUVTUWLBCWBSBUWQWCWDUXAUXJUVGUVPXAZQRZDUWPKZABKZUXAUXTABUXAUVGBFZ
      LUXTUVGCXAZUWDHZPZUXAUYBUYEUWAUWFUWJUYBUYEJUWAUWFLUYBUWJUYEUWAUWFUYBUWJUY
      EJUWAUWFUYBLZLZUYDUWGUYGUYDUVGUWDHZUWGUYGUYCUVGUWDUYGUVGCHZUYCUVGIUVDUYBU
      YIUVTUWFUVGBCVEWEUVGCWFWGWHUWAUYFUYHUWGJZUVDUYFUYJJUVTUVDUWFUYBUYJUVDUYBU
      WFUYJUVDUYBUWFUYHUWGUVGUWDBCWIWJWKWLWMXBWNWOWPWKWQXBUXAUXTUYENZUYBUXAUXMU
      YKUXPUXMUXTUVGUWNXAZQRZUYEUXSUYMDUWNTUVPUWNIUXRUYLQUVPUWNUVGWRWSWTUYDUYLQ
      UVGCUWDXCXDXEOWMXFUJUXABUXEFZUWPUXEFZUXJUYANUVDUYNUVTUWLBCXGSUXAUXLUWNQRZ
      UXNUYOUXACUWDXHUXAUXNUYPUXOUXAUXNUWNQUWNQICUWDHZUXAUXNPZCUWDXIUWLUYQUYRJU
      WAUWFUYQUWDCIZUWJUYRUYSUWFUYQUWDCXKXJUYSUWJUYRUYSUWGUXNUWDCBYAXLXMXNXOXPX
      QYBUXOUWNCBXRXSADBUWPCCXTYCXFUXAUXNUXFUXHUXIUXJYDNUXOUWQBCYEOYFZUWRCYGOAU
      WSCYHOUVSUXCLUVRUXBLZAUVEUPUXAUWTUVRUXBAUVEYIUXAVUAUWTAUVEUXAUVRUXBUWTUVR
      UVHUVQJUXAUXBUVQJUXBUWTJUVHUVQYLUXAUXBUVHUVQUXABUWSHUXBUVHJUXABUWPUWSUXAU
      WQUWRUWSUXAUWQTFZUWQUWRHUXAUVDUWPTFVUBUVDUVTUWLYJUWNYKBUWPUVCTYMYNUWQTYOO
      UXAUXFUWRUWSHUYTUWRCYPOYQZYRBUWSUVGYSOUUDUXBUVQUWTUVQUXBUWTUVGUVPUWSUKXMU
      UAUUEWLUUBUUCUUFXBUUGUWAUWLUWNUWSFUVSUXAUWQUWSUWNVUCUXAUWNUWPFZUWNUWQFUXA
      UXMVUDUXPUWNTUUHOUWNUWPBUUIOYTUUPYTUWMUVTUWFUWKUWONUVDUVTUVSUWLUUQUWBUWFU
      WJUUJUWDUVPCUUKYCXFWPUULMWKUUMUUNUUOUVDUVTUVSUURUUSMUUTUVAUVB $.
  $}

  ${
    $d f x y z F $.  $d f x y z X $.
    $( A filter is equal to the intersection of the ultrafilters containing
       it.  (Contributed by Jeff Hankins, 1-Jan-2010.)  (Revised by Stefan
       O'Rear, 2-Aug-2015.) $)
    filufint $p |- ( F e. ( Fil ` X ) ->
        |^| { f e. ( UFil ` X ) | F C_ f } = F ) $=
      ( vy vz cfv wcel cv wss wi wn wa w3a c0 wne 3ad2ant1 cvv wb syl wceq cfil
      vx cufil crab cint wral vex elintrab wrex cdif csn cun cfi cfg co filsspw
      cfbas cpw difss filtop difexg elpwg mpbiri snssd unssd ssun1 ssn0 sylancr
      filn0 cin elsni filelss 3adant3 reldisj dfss4 biimpi 3ad2ant3 bitrd filss
      sseq2d 3exp2 3imp sylbid 3exp com24 3imp1 ineq2 neeq1d syl5ibrcom expimpd
      necon3bd sylan2i ralrimivv filfbas a1i 3ad2ant2 difeq2 dif0 syl6eq eqtr3d
      eqeltrd 3expia ex snfbas syl3anc fbunfip syl2anc mpbird fsubbas mpbir3and
      com23 fgcl filssufil snex unexg mpan2 ssfii unssad sstrd ad2antrr ufilfil
      ssfg simpr 0nelfil disjdif simprr unssbd adantr simprl snidg sseldd filin
      ad2antlr syl5eqelr expr mtod jca exp31 reximdvai syl5 mpd con3d a1d ancld
      impcom reximdva syl5com pm2.61d rexanali syl6ib con4d ssrdv ssintub eqssd
      syl5bi ) BCUAFZGZBAHZIZACUCFZUDUEZBUUQUBUVABUBHZUVAGUUSUVBUURGZJAUUTUFZUU
      QUVBBGZUUSAUVBUUTUBUGUHUUQUVEUVDUUQUVEKZUUSUVCKZLZAUUTUIZUVDKUUQUVFUVIUUQ
      UVFLUVBCIZUVIUUQUVFUVJUVIUUQUVFUVJMZCBCUVBUJZUKZULZUMFZUNUOZUUPGZUVIUVKUV
      OCUQFZGZUVQUVKUVSUVNCURZIZUVNNOZNUVOGKZUVKBUVMUVTUUQUVFBUVTIUVJBCUPPUVKUV
      LUVTUVKUVLUVTGZUVLCIZCUVBUSZUVKUVLQGZUWDUWERUUQUVFUWGUVJUUQCBGZUWGBCUTZCU
      VBBVASZPUVLCQVBSVCVDVEUUQUVFUWBUVJUUQBUVNIBNOUWBBUVMVFBCVIBUVNVGVHPUVKUWC
      DHZEHZVJZNOZEUVMUFDBUFZUVKUWNDEBUVMUWLUVMGUVKUWKBGZUWLUVLTZUWNUWLUVLVKUVK
      UWPUWQUWNUVKUWPLUWNUWQUWKUVLVJZNOZUUQUVFUVJUWPUWSUUQUWPUVJUVFUWSUUQUWPUVJ
      UVFUWSJUUQUWPUVJMZUVEUWRNUWTUWRNTZUWKUVBIZUVEUWTUXAUWKCUVLUJZIZUXBUWTUWKC
      IZUXAUXDRUUQUWPUXEUVJUWKBCVLVMUWKUVLCVNSUVJUUQUXDUXBRUWPUVJUXCUVBUWKUVJUX
      CUVBTZUVBCVOVPZVTVQVRUUQUWPUVJUXBUVEJUUQUWPUVJUXBUVEUWKUVBBCVSWAWBWCWKWDW
      EWFUWQUWMUWRNUWLUVLUWKWGWHWIWJWLWMUVKBUVRGZUVMUVRGZUWCUWORUUQUVFUXHUVJBCW
      NPUVKUWEUVLNOZUWHUXIUWEUVKUWFWOUUQUVFUVJUXJUUQUVJUVFUXJUUQUVJUVFUXJJUUQUV
      JLUVEUVLNUUQUVJUVLNTZUVEUUQUVJUXKMZUVBCBUXLUXCUVBCUVJUUQUXFUXKUXGWPUXKUUQ
      UXCCTUVJUXKUXCCNUJCUVLNCWQCWRWSVQWTUUQUVJUWHUXKUWIPXAXBWKXCXKWBUUQUVFUWHU
      VJUWIPUVLCBXDXEDEBUVMCCXFXGXHUUQUVFUVSUWAUWBUWCMRZUVJUUQUWHUXMUWIUVNBCXIS
      PXJZUVOCXLSUVQUVPUURIZAUUTUIUVKUVIAUVPCXMUVKUXOUVHAUUTUVKUURUUTGZUXOUVHUV
      KUXPLZUXOLZUUSUVGUXRBUVPUURUVKBUVPIUXPUXOUVKBUVOUVPUVKBUVMUVOUUQUVFUVNUVO
      IZUVJUUQUVNQGZUXSUUQUVMQGUXTUVLXNBUVMUUPQXOXPUVNQXQSZPXRUVKUVSUVOUVPIZUXN
      UVOCYBZSXSXTUXQUXOYCXSUXRUVCNUURGZUXPUYDKZUVKUXOUXPUURUUPGZUYEUURCYAZUURC
      YDSYMUXQUXOUVCUYDUXQUXOUVCLZLZNUVBUVLVJZUURUVBCYEUYIUYFUVCUVLUURGUYJUURGU
      XPUYFUVKUYHUYGYMUXQUXOUVCYFUYIUVMUURUVLUYIUVMUVPUURUXQUVMUVPIUYHUXQUVMUVO
      UVPUVKUVMUVOIZUXPUUQUVFUYKUVJUUQBUVMUVOUYAYGPYHUXQUVSUYBUVKUVSUXPUXNYHUYC
      SXSYHUXQUXOUVCYIXSUVKUVLUVMGZUXPUYHUUQUVFUYLUVJUUQUWGUYLUWJUVLQYJSPXTYKUV
      BUVLUURCYLXEYNYOYPYQYRYSYTUUAXBUUQUVJKZUVIJUVFUUQUUSAUUTUIUYMUVIABCXMUYMU
      USUVHAUUTUYMUXPLZUUSUVGUYNUVGUUSUXPUYMUVGUXPUVCUVJUXPUYFUVCUVJJUYGUYFUVCU
      VJUVBUURCVLXCSUUBUUEUUCUUDUUFUUGYHUUHXCUUSUVCAUUTUUIUUJUUKUUOUULBUVAIUUQA
      BUUTUUMWOUUN $.
  $}

  ${
    $d x y A $.  $d x y X $.  $d x y V $.
    $( Lemma for ~ fixufil and ~ uffixfr .  (Contributed by Mario Carneiro,
       12-Dec-2013.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    uffix $p |- ( ( X e. V /\ A e. X ) -> ( { { A } } e. ( fBas ` X ) /\
          { x e. ~P X | A e. x } = ( X filGen { { A } } ) ) ) $=
      ( vy wcel wa csn cfbas cfv cv cpw crab cfg wss snssi adantl wb a1i syl co
      wceq wne snnzg simpl snfbas syl3anc wrex vex elpw snex snid sseq1 sylancr
      c0 rspcev cint wi intss1 sstr2 snidg intsn syl6eleqr ssel syl5com sylan9r
      rexlimdva impbid2 anbi12d eleq2 elrab elfg 3bitr4d eqrdv jca ) DCFZBDFZGZ
      BHZHZDIJFZBAKZFZADLZMZDVTNUAZUBVRVSDOZVSUOUCZVPWAVQWGVPBDPQVQWHVPBDUDQVPV
      QUEVSDCUFUGZVREWEWFVREKZWDFZBWJFZGZWJDOZWBWJOZAVTUHZGZWJWEFZWJWFFZVRWKWNW
      LWPWKWNRVRWJDEUIUJSVRWLWPWLVSVTFVSWJOZWPVSBUKZULBWJPWOWTAVSVTWBVSWJUMUPUN
      VRWOWLAVTWBVTFZWOVTUQZWJOZVRWLXBXCWBOWOXDURWBVTUSXCWBWJUTTVRBXCFXDWLVRBVS
      XCVQBVSFVPBDVAQVSXAVBVCXCWJBVDVEVFVGVHVIWRWMRVRWCWLAWJWDWBWJBVJVKSVRWAWSW
      QRWIAWJVTDVLTVMVNVO $.

    $( The condition describing a fixed ultrafilter always produces an
       ultrafilter.  (Contributed by Jeff Hankins, 9-Dec-2009.)  (Revised by
       Mario Carneiro, 12-Dec-2013.)  (Revised by Stefan O'Rear,
       29-Jul-2015.) $)
    fixufil $p |- ( ( X e. V /\ A e. X ) ->
        { x e. ~P X | A e. x } e. ( UFil ` X ) ) $=
      ( vy wcel wa cv cpw crab cfv wo wral csn wceq cun wss sylib eleq2 elrab
      cfil cdif cufil cfg co cfbas uffix simprd simpld syl eqeltrd undif2 elpwi
      fgcl ssequn1 syl5req eleq2d biimpac elun adantll ibar adantl difss elpw2g
      wb mpbiri ad2antrr biantrurd orbi12d mpbid ralrimiva ralbii sylibr isufil
      orbi12i sylanbrc ) DCFZBDFZGZBAHZFZADIZJZDUAKZFEHZWCFZDWEUBZWCFZLZEWBMZWC
      DUCKFVSWCDBNNZUDUEZWDVSWKDUFKFZWCWLOZABCDUGZUHVSWMWLWDFVSWMWNWOUIWKDUNUJU
      KVSWEWBFZBWEFZGZWGWBFZBWGFZGZLZEWBMWJVSXBEWBVSWPGZWQWTLZXBVRWPXDVQVRWPGBW
      EWGPZFZXDWPVRXFWPDXEBWPXEWEDPZDWEDULWPWEDQXGDOWEDUMWEDUORUPUQURBWEWGUSRUT
      XCWQWRWTXAWPWQWRVEVSWPWQVAVBXCWSWTVQWSVRWPVQWSWGDQDWEVCWGDCVDVFVGVHVIVJVK
      WIXBEWBWFWRWHXAWAWQAWEWBVTWEBSTWAWTAWGWBVTWGBSTVOVLVMEWCDVNVP $.
  $}

  ${
    $d x A $.  $d x y F $.  $d x y X $.
    $( An ultrafilter is either fixed or free.  A fixed ultrafilter is called
       principal (generated by a single element ` A ` ), and a free ultrafilter
       is called nonprincipal (having empty intersection).  Note that examples
       of free ultrafilters cannot be defined in ZFC without some form of
       global choice.  (Contributed by Jeff Hankins, 4-Dec-2009.)  (Revised by
       Stefan O'Rear, 2-Aug-2015.) $)
    uffixfr $p |- ( F e. ( UFil ` X ) -> ( A e. |^| F <->
          F = { x e. ~P X | A e. x } ) ) $=
      ( cufil cfv wcel cint cv wceq wa wss csn syl adantr elintg adantl simprbi
      3syl eleq2 cpw crab cfil simpl cfg co cfbas ufilfil filtop cuni wne filn0
      intssuni filunibas sseqtrd sselda syl2anc simprd simpld fgcl eqeltrd wral
      c0 uffix filsspw ibi ssrab sylanbrc ufilmax syl3anc eqimss wb sylan elrab
      biimpac mpbird impbida ) CDEFGZBCHZGZCBAIZGZADUAZUBZJZVRVTKZVRWDDUCFZGCWD
      LZWEVRVTUDWFWDDBMMZUEUFZWGWFWIDUGFGZWDWJJZWFDCGZBDGZWKWLKVRWMVTVRCWGGZWMC
      DUHZCDUINZOVRVSDBVRVSCUJZDVRWOCVCUKVSWRLWPCDULCUMSVRWOWRDJWPCDUNNUOUPABCD
      VDUQZURWFWKWJWGGWFWKWLWSUSWIDUTNVAWFCWCLZWBACVBZWHWFWOWTVRWOVTWPOCDVENVTX
      AVRVTXAABCVSPVFQWBAWCCVGZVHCWDDVIVJVRWEKZVTXAXCWHXAWEWHVRCWDVKQWHWTXAXBRN
      XCDWDGZWNVTXAVLVRWMWEXDWQWEWMXDCWDDTVOVMXDDWCGWNWBWNADWCWADBTVNRABCDPSVPV
      Q $.

    $( A classification of fixed ultrafilters.  (Contributed by Mario Carneiro,
       24-May-2015.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    uffix2 $p |- ( F e. ( UFil ` X ) -> ( |^| F =/= (/) <->
          E. x e. X F = { y e. ~P X | x e. y } ) ) $=
      ( cufil cfv wcel cv cint wex cpw crab wceq wa c0 wne wrex cuni cfil wss
      ufilfil filn0 intssuni 3syl filunibas syl sseqtrd pm4.71rd uffixfr anbi2d
      sseld bitrd exbidv n0 df-rex 3bitr4g ) CDEFGZAHZCIZGZAJURDGZCURBHGBDKLMZN
      ZAJUSOPVBADQUQUTVCAUQUTVAUTNVCUQUTVAUQUSDURUQUSCRZDUQCDSFGZCOPUSVDTCDUAZC
      DUBCUCUDUQVEVDDMVFCDUEUFUGUKUHUQUTVBVABURCDUIUJULUMAUSUNVBADUOUP $.
  $}

  ${
    $d x A $.  $d x y F $.  $d x y X $.
    $( The singleton of the generator of a fixed ultrafilter is in the filter.
       (Contributed by Mario Carneiro, 24-May-2015.)  (Revised by Stefan
       O'Rear, 2-Aug-2015.) $)
    uffixsn $p |- ( ( F e. ( UFil ` X ) /\ A e. |^| F ) -> { A } e. F ) $=
      ( vx cufil cfv wcel cint wa csn cv cpw crab wss cuni cfil c0 ufilfil wceq
      wne filn0 intssuni 3syl filunibas syl sselda snssd snex elpw sylibr snidg
      sseqtrd adantl eleq2 elrab sylanbrc uffixfr biimpa eleqtrrd ) BCEFGZABHZG
      ZIZAJZADKZGZDCLZMZBVCVDVGGZAVDGZVDVHGVCVDCNVIVCACUTVACAUTVABOZCUTBCPFGZBQ
      TVAVKNBCRZBCUABUBUCUTVLVKCSVMBCUDUEULUFUGVDCAUHUIUJVBVJUTAVAUKUMVFVJDVDVG
      VEVDAUNUOUPUTVBBVHSDABCUQURUS $.

    $( An ultrafilter is generated by at most one element (because free
       ultrafilters have no generators and fixed ultrafilters have exactly
       one).  (Contributed by Mario Carneiro, 24-May-2015.)  (Revised by Stefan
       O'Rear, 2-Aug-2015.) $)
    ufildom1 $p |- ( F e. ( UFil ` X ) -> |^| F ~<_ 1o ) $=
      ( vx cufil cfv wcel cint c1o cdom wbr c0 breq1 wne wa cen cv wex csn con0
      syl wceq wss uffixsn intss1 simpr snssd eqssd ex eximdv en1 3imtr4g endom
      n0 imp 1on 0domg mp1i pm2.61ne ) ABDEFZAGZHIJZKHIJZUTKUTKHILUSUTKMZNUTHOJ
      ZVAUSVCVDUSCPZUTFZCQUTVERZUAZCQVCVDUSVFVHCUSVFVHUSVFNZUTVGVIVGAFUTVGUBVEA
      BUCVGAUDTVIVEUTUSVFUEUFUGUHUICUTUMCUTUJUKUNUTHULTHSFVBUSUOHSUPUQUR $.

    $( An ultrafilter containing a finite element is fixed.  (Contributed by
       Jeff Hankins, 5-Dec-2009.)  (Revised by Stefan O'Rear, 2-Aug-2015.) $)
    uffinfix $p |- ( ( F e. ( UFil ` X ) /\ S e. F /\ S e. Fin ) ->
        E. x e. X F = { y e. ~P X | x e. y } ) $=
      ( cufil cfv wcel cfn w3a cint c0 wne wel cpw crab wceq wrex cfil ufilfil
      filfinnfr syl3an1 wb uffix2 3ad2ant1 mpbid ) DEFGHZCDHZCIHZJDKLMZDABNBEOP
      QAERZUGDESGHUHUIUJDETCDEUAUBUGUHUJUKUCUIABDEUDUEUF $.

    $( An ultrafilter is free iff it contains the Fr&eacute;chet filter
       ~ cfinfil as a subset.  (Contributed by NM, 14-Jul-2008.)  (Revised by
       Stefan O'Rear, 2-Aug-2015.) $)
    cfinufil $p |- ( F e. ( UFil ` X ) -> ( |^| F = (/) <->
          { x e. ~P X | ( X \ x ) e. Fin } C_ F ) ) $=
      ( vy cfv wcel c0 wceq cv cdif cfn wi wss wa wn wb ufilb adantr com23 syl
      cufil cint cpw wral crab elpwi wne cfil ufilfil filfinnfr 3exp imp sylbid
      necon4bd ex sylan2 ralrimdva csn uffixsn filelss syl2anc dfss4 sylib snfi
      syl6eqel difss filtop elpw2g 3syl mpbiri difeq2 eleq1d eleq1 imbi12d mpid
      rspcv syldan pm2.24d sylbird impancom pm2.01d eq0rdv impbid rabss syl6bbr
      syld ) BCUAEFZBUBZGHZCAIZJZKFZWJBFZLZACUCZUDZWLAWOUEBMWGWIWPWGWIWNAWOWJWO
      FWGWJCMZWIWNLWJCUFWGWQNZWLWIWMWRWLWIWMLWRWLNZWMWHGWSWMOZWKBFZWHGUGZWRWTXA
      PWLWJBCQRWRWLXAXBLZWRBCUHEFZWLXCLWGXDWQBCUIZRXDXAWLXBXDXAWLXBWKBCUJUKSTUL
      UMUNUOSUPUQWGWPWIWGWPNZDWHXFDIZWHFZWGXHWPXHOZWGXHNZWPCXGURZJZBFZXIXJWPCXL
      JZKFZXMXJXNXKKXJXKCMZXNXKHXJXDXKBFZXPWGXDXHXERZXGBCUSZXKBCUTVAZXKCVBVCXGV
      DVEXJXLWOFZWPXOXMLZLXJYAXLCMZCXKVFXJXDCBFYAYCPXRBCVGXLCBVHVIVJWNYBAXLWOWJ
      XLHZWLXOWMXMYDWKXNKWJXLCVKVLWJXLBVMVNVPTVOXJXMXQOZXIWGXHXPYEXMPXTXKBCQVQX
      JXQXIXSVRVSWFVTWAWBUOWCWLAWOBWDWE $.
  $}

  ${
    $d f x y A $.  $d f y B $.  $d f x y X $.
    $( An infinite subset is contained in a free ultrafilter.  (Contributed by
       Jeff Hankins, 6-Dec-2009.)  (Revised by Mario Carneiro, 4-Dec-2013.) $)
    ufinffr $p |- ( ( X e. B /\ A C_ X /\ om ~<_ A ) ->
        E. f e. ( UFil ` X ) ( A e. f /\ |^| f = (/) ) ) $=
      ( vx vy wcel wss com cv cdif cfn cfv wrex cint c0 wceq wa wn mtoi wbr w3a
      cdom cpw crab cufil cfil ominf domfi expcom cfinfil syl3an3 filssufil syl
      elpw2g biimpar 3adant3 0fin a1i difeq2 difid syl6eq eleq1d elrab sylanbrc
      ssel syl5com intss neldifsn elinti simp2 ssdifssd wb 3ad2ant1 mpbird snfi
      csn wi eldif notbii iman bitr4i anbi2i bitri sylbi ssriv ssfi mp2an nsyl3
      pm3.35 eq0rdv sseq2d syl5ib ss0 syl6 jcad reximdv mpd ) DBGZADHZIAUCUAZUB
      ZAEJZKZLGZEDUDZUEZCJZHZCDUFMZNZAXHGZXHOZPQZRZCXJNXBXGDUGMGZXKXAWSWTALGZSX
      PXAXQILGZUHXQXAXRAIUIUJTEABDUKULCXGDUMUNXBXIXOCXJXBXIXLXNXBAXGGZXIXLXBAXF
      GZPLGZXSWSWTXTXAWSXTWTADBUOUPUQYAXBURUSXEYAEAXFXCAQZXDPLYBXDAAKPXCAAUTAVA
      VBVCVDVEXGXHAVFVGXBXIXMPHZXNXIXMXGOZHXBYCXGXHVHXBYDPXMXBFYDFJZYDGZAYEVQZK
      ZXGGZXBYFYIYEYHGYEAVIYEXGYHVJTXBYHXFGZAYHKZLGZYIXBYJYHDHZXBADYGWSWTXAVKVL
      WSWTYJYMVMXAYHDBUOVNVOYLXBYGLGYKYGHYLYEVPEYKYGXCYKGZXCAGZYOXCYGGZVRZRZYPY
      NYOXCYHGZSZRYRXCAYHVSYTYQYOYTYOYPSRZSYQYSUUAXCAYGVSVTYOYPWAWBWCWDYOYPWJWE
      WFYGYKWGWHUSXEYLEYHXFXCYHQXDYKLXCYHAUTVCVDVEWIWKWLWMXMWNWOWPWQWR $.
  $}

  ${
    $d f x A $.  $d f x y X $.
    $( Any infinite set has an ultrafilter on it whose elements are of the same
       cardinality as the set.  Any such ultrafilter is necessarily free.
       (Contributed by Jeff Hankins, 7-Dec-2009.)  (Revised by Stefan O'Rear,
       3-Aug-2015.) $)
    ufilen $p |- ( om ~<_ X -> E. f e. ( UFil ` X ) A. x e. f x ~~ X ) $=
      ( vy com cdom wbr cv cdif csdm wss cufil cfv wrex wcel cvv syl wa sylan
      wn cpw crab cen wral cfil ccrd cdm reldom brrelex2i numth3 csdfil mpancom
      filssufil elfvex ad2antlr ufilfil filelss adantll ssdomg wi cfbas filfbas
      sylc adantl fbncp w3a difss elpw2g mpbiri 3ad2ant1 wceq simp2 dfss4 sylib
      simp3 eqbrtrd difeq2 breq1d elrab sylanbrc ssel syl5com impancom syl21anc
      3expa con3d bren2 simplbi2 sylsyld ralrimdva reximdva mpd ) ECFGZCDHZIZCJ
      GZDCUAZUBZBHZKZBCLMZNZAHZCUCGZAWSUDZBXANWMWRCUEMZOZXBCUFUGOZWMXGWMCPOZXHE
      CFUHUICPUJQDCUKULBWRCUMQWMWTXEBXAWMWSXAOZRZWTXDAWSXKXCWSOZRZXCCFGZWTXCCJG
      ZTZXDXMXIXCCKZXNXJXIWMXLWSCLUNUOZXJXLXQWMXJWSXFOZXLXQWSCUPZXCWSCUQSURZXCC
      PUSVCXMXIXQCXCIZWSOZTZWTXPUTXRYAXKWSCVAMOZXLYDXJYEWMXJXSYEXTWSCVBQVDXCCWS
      CVESXIXQRZWTYDXPYFWTRXOYCYFXOWTYCXIXQXOWTYCUTXIXQXOVFZYBWROZWTYCYGYBWQOZC
      YBIZCJGZYHXIXQYIXOXIYIYBCKCXCVGYBCPVHVIVJYGYJXCCJYGXQYJXCVKXIXQXOVLXCCVMV
      NXIXQXOVOVPWPYKDYBWQWNYBVKWOYJCJWNYBCVQVRVSVTWRWSYBWAWBWEWCWFWCWDXDXNXPXC
      CWGWHWIWJWKWL $.
  $}

  ${
    $d x F $.  $d x J $.  $d x X $.
    ufildr.1 $e |- J = ( F u. { (/) } ) $.
    $( An ultrafilter gives rise to a connected door topology.  (Contributed by
       Jeff Hankins, 6-Dec-2009.)  (Revised by Stefan O'Rear, 3-Aug-2015.) $)
    ufildr $p |- ( F e. ( UFil ` X ) -> ( J u. ( Clsd ` J ) ) = ~P X ) $=
      ( vx cufil cfv wcel ccld cun wo cuni c0 syl5ibr cdif sseld ctop wb adantr
      wss cpw cv elssuni csn unieqi uniun 0ex unisn uneq2i un0 3eqtri cfil wceq
      eqtr2i ufilfil filunibas syl syl5reqr sseq2d eqid cldss jaod ufilss ssun1
      wa sseqtr4i a1i ccon filcon contop syl5eqel biimpa iscld2 syl2anc difeq1d
      3syl eleq1d bitr4d sylibrd orim12d mpd impbid elun vex elpw 3bitr4g eqrdv
      ex ) ACFGHZEBBIGZJZCUAZWIEUBZBHZWMWJHZKZWMCTZWMWKHWMWLHWIWPWQWIWNWQWOWNWQ
      WIWMBLZTZWMBUCWICWRWMWIWRALZCWRAMUDZJZLZWTBXBDUEXCWTXALZJWTMJWTAXAUFXDMWT
      MUGUHUIWTUJUKUNWIACULGHZWTCUMACUOZACUPUQURZUSZNWOWQWIWSWMBWRWRUTZVAXHNVBW
      IWQWPWIWQVEZWMAHZCWMOZAHZKWPWMACVCXJXKWNXMWOXJABWMABTXJAXBBAXAVDDVFVGZPXJ
      XMXLBHZWOXJABXLXNPXJWOWRWMOZBHZXOXJBQHZWSWOXQRWIXRWQWIBXBQDWIXEXBVHHXBQHX
      FACVIXBVJVPVKSWIWQWSXHVLWMBWRXIVMVNWIXOXQRWQWIXLXPBWICWRWMXGVOVQSVRVSVTWA
      WHWBWMBWJWCWMCEWDWEWFWG $.
  $}

  ${
    $d x y z F $.  $d x y z X $.
    fin1aufil.1 $e |- F = ( ~P X \ Fin ) $.
    $( There are no definable free ultrafilters in ZFC. However, there are free
       ultrafilters in some choice-denying constructions.  Here we show that
       given an amorphous set (a.k.a. a Ia-finite I-infinite set) ` X ` , the
       set of infinite subsets of ` X ` is a free ultrafilter on ` X ` .
       (Contributed by Mario Carneiro, 20-May-2015.) $)
    fin1aufil $p |- ( X e. ( Fin1a \ Fin ) ->
        ( F e. ( UFil ` X ) /\ |^| F = (/) ) ) $=
      ( vx vy cfin1a cfn cdif wcel c0 wceq wo wn wss wa wsbc eleq1 notbid sbcie
      wb vz cufil cfv cint cfil cv cpw wral eleq2i eldif vex elpw anbi1i 3bitri
      a1i elex eldifn sbcieg mpbird 0fin 0ex con2bii mpbi w3a ssfi expcom con3d
      3ad2ant3 3imtr4g cin eldifi fin1ai sylan 3adant3 cun inundif incom simprl
      wi syl5eqel simprr simpl3 ssdifd syl2anc unfi syl5eqelr orim2d ex anbi12i
      expr ioran bitr4i inex1 isfild adantr ssun2 undif2 sseqtr4i sylancl ianor
      mpid nsyl sylib elpwi adantl difss elpw2g mpbiri syl5bb orbi12d ralrimiva
      baib syl isufil sylanbrc csn snfi eleq2s mt2 uffixsn mtoi eq0rdv jca ) BF
      GHZIZABUBUCIZAUDZJKYEABUEUCIDUFZAIZBYHHZAIZLZDBUGZUHYFYEYHGIZMZDEUABAYIYH
      BNZYOOZTYEYIYHYMGHZIYHYMIZYOOYQAYRYHCUIYHYMGUJYSYPYOYHBDUKULUMUNZUOBYDUPY
      EYODBPBGIZMZBFGUQZYOUUBDBYDYHBKYNUUAYHBGQRURUSYODJPZMZYEJGIZUUEUTUUDUUFYO
      UUFMDJVAYHJKYNUUFYHJGQRSVBVCUOYEEUFZBNZUAUFZUUGNZVDZUUIGIZMZUUGGIZMZYODUU
      IPZYODUUGPZUUKUUNUULUUJYEUUNUULVSUUHUUNUUJUULUUGUUIVEVFVHVGYOUUMDUUIUAUKY
      HUUIKYNUULYHUUIGQRSZYOUUODUUGEUKZYHUUGKYNUUNYHUUGGQRSZVIYEUUHUUIBNZVDZUUN
      UULLZMZUUGUUIVJZGIZMZUUQUUPOZYODUVEPUVBUVFUVCUVBUVFUUNBUUGHZGIZLZUVCYEUUH
      UVKUVAYEBFIUUHUVKBFGVKBUUGVLVMVNUVBUVFUVKUVCVSUVBUVFOUVJUULUUNUVBUVFUVJUU
      LUVBUVFUVJOZOZUUIUUIUUGVJZUUIUUGHZVOZGUUIUUGVPUVMUVNGIUVOGIZUVPGIUVMUVNUV
      EGUUIUUGVQUVBUVFUVJVRVTUVMUVJUVOUVINUVQUVBUVFUVJWAUVMUUIBUUGYEUUHUVAUVLWB
      WCUVIUVOVEWDUVNUVOWEWDWFWJWGWHXAVGUVHUUOUUMOUVDUUQUUOUUPUUMUUTUURWIUUNUUL
      WKWLYOUVGDUVEUUGUUIUUSWMYHUVEKYNUVFYHUVEGQRSVIWNYEYLDYMYEYSOZYLYOYJGIZMZL
      ZUVRYNUVSOZMUWAUVRUUAUWBYEUUBYSUUCWOUWBYHYJVOZGIBUWCNUUAYHYJWEBYHBVOUWCBY
      HWPYHBWQWRUWCBVEWSXBYNUVSWTXCUVRYIYOYKUVTUVRYPYIYOTYSYPYEYHBXDXEYIYPYOYTX
      LXMYKYJYRIZUVRUVTAYRYJCUIUVRYJYMIZUWDUVTTUVRUWEYJBNZBYHXFYEUWEUWFTYSYJBYD
      XGWOXHUWDUWEUVTYJYMGUJXLXMXIXJUSXKDABXNXOZYEDYGYEYHYGIZYHXPZAIZUWJUWIGIZY
      HXQUWKMUWIYRAUWIYMGUQCXRXSYEUWHUWJYEYFUWHUWJUWGYHABXTVMWHYAYBYC $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filter limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c FilMap $.
  $c fLimf $.

  $c fLim $.
  $c fClus $.
  $c fClusf $.

  $( Extend class definition to include the neighborhood filter mapping
     function. $)
  cfm $a class FilMap $.

  $( Extend class notation with a function returning the limit of a filter. $)
  cflim $a class fLim $.

  $( Extend class definition to include the function for filter-based function
     limits. $)
  cflf $a class fLimf $.

  $( Extend class definition to include the cluster point function on
     filters. $)
  cfcls $a class fClus $.

  $( Extend class definition to include the function for cluster points of a
     function. $)
  cfcf $a class fClusf $.

  ${
    $d f g j t x y $.
    $( Define a function that takes a filter to a neighborhood filter of the
       range.  (Since we now allow filter bases to have support smaller than
       the base set, the function has to come first to ensure that curryings
       are sets.)  (Contributed by Jeff Hankins, 5-Sep-2009.)  (Revised by
       Stefan O'Rear, 20-Jul-2015.) $)
    df-fm $a |- FilMap = ( x e. _V , f e. _V |-> ( y e. ( fBas ` dom f ) |->
         ( x filGen ran ( t e. y |-> ( f " t ) ) ) ) ) $.

    $( Define a function (indexed by a topology ` j ` ) whose value is the
       limits of a filter ` f ` .  (Contributed by Jeff Hankins,
       4-Sep-2009.) $)
    df-flim $a |- fLim = ( j e. Top , f e. U. ran Fil |->
     { x e. U. j | ( ( ( nei ` j ) ` { x } ) C_ f /\ f C_ ~P U. j ) } ) $.

    $( Define a function that gives the limits of a function ` f ` in the
       filter sense.  (Contributed by Jeff Hankins, 14-Oct-2009.) $)
    df-flf $a |- fLimf = ( x e. Top , y e. U. ran Fil |->
        ( f e. ( U. x ^m U. y ) |-> ( x fLim ( ( U. x FilMap f ) ` y ) ) ) ) $.

    $( Define a function that takes a filter in a topology to its set of
       cluster points.  (Contributed by Jeff Hankins, 10-Nov-2009.) $)
    df-fcls $a |- fClus = ( j e. Top , f e. U. ran Fil |->
      if ( U. j = U. f , |^|_ x e. f ( ( cls ` j ) ` x ) , (/) ) ) $.

    $( Define a function that gives the cluster points of a function.
       (Contributed by Jeff Hankins, 24-Nov-2009.) $)
    df-fcf $a |- fClusf = ( j e. Top , f e. U. ran Fil |->
      ( g e. ( U. j ^m U. f ) |-> ( j fClus ( ( U. j FilMap g ) ` f ) ) ) ) $.
  $}

  ${
    $d b f x y B $.  $d b f x y F $.  $d b f x y X $.  $d b f x y Y $.
    $d f x y A $.
    $( Introduce a function that takes a function from a filtered domain to a
       set and produces a filter which consists of supersets of images of
       filter elements.  The functions which are dealt with by this function
       are similar to nets in topology.  For example, suppose we have a
       sequence filtered by the filter generated by its tails under the usual
       natural number ordering.  Then the elements of this filter are precisely
       the supersets of tails of this sequence.  Under this definition, it is
       not too difficult to see that the limit of a function in the filter
       sense captures the notion of convergence of a sequence.  As a result,
       the notion of a filter generalizes many ideas associated with sequences,
       and this function is one way to make that relationship precise in
       Metamath.  (Contributed by Jeff Hankins, 5-Sep-2009.)  (Revised by
       Stefan O'Rear, 6-Aug-2015.) $)
    fmval $p |- ( ( X e. A /\ B e. ( fBas ` Y ) /\ F : Y --> X ) ->
        ( ( X FilMap F ) ` B ) = ( X filGen ran ( y e. B |-> ( F " y ) ) ) ) $=
      ( vb vx vf wcel cfbas cfv cfm co cv cmpt crn cfg cvv wceq wf w3a cima cdm
      cmpt2 df-fm a1i wa dmeq fveq2d adantl imaeq1 mpteq2dv oveqan12d mpteq12dv
      rneqd fdm mpteq1d 3ad2ant3 sylan9eqr 3ad2ant1 simp3 elfvdm 3ad2ant2 simp1
      elex fex2 syl3anc fvex mptex ovmpt2d fveq1d mpteq1 oveq2d eqid ovex fvmpt
      id eqtrd ) EBJZCFKLZJZFEDUAZUBZCEDMNZLCGWAEAGOZDAOZUCZPZQZRNZPZLZEACWHPZQ
      ZRNZWDCWEWLWDHIEDSSGIOZUDZKLZHOZAWFWQWGUCZPZQZRNZPZWLMSMHISSXEUETWDHGAIUF
      UGWTETZWQDTZUHZWDXEGDUDZKLZWKPZWLXHGWSXDXJWKXGWSXJTXFXGWRXIKWQDUIUJUKXFXG
      WTEXCWJRXFVRXGXBWIXGAWFXAWHWQDWGULUMUPUNUOWCVTXKWLTWBWCGXJWAWKWCXIFKFEDUQ
      UJURUSUTVTWBESJWCEBVFVAWDWCFKUDZJZVTDSJVTWBWCVBWBVTXMWCCFKVCVDVTWBWCVEFED
      XLBVGVHWLSJWDGWAWKFKVIVJUGVKVLWBVTWMWPTWCGCWKWPWAWLWFCTZWJWOERXNWIWNAWFCW
      HVMUPVNWLVOEWORVPVQVDVS $.

    $( A mapping filter is a filter.  (Contributed by Jeff Hankins,
       18-Sep-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    fmfil $p |- ( ( X e. A /\ B e. ( fBas ` Y ) /\ F : Y --> X ) ->
        ( ( X FilMap F ) ` B ) e. ( Fil ` X ) ) $=
      ( vy wcel cfbas cfv wf w3a cfm co cv cima cmpt crn cfg cfil fmval eqeltrd
      eqid fbasrn 3comr fgcl syl ) DAGZBEHIGZEDCJZKZBDCLMIDFBCFNOPQZRMZDSIZFABC
      DETUJUKDHIGZULUMGUHUIUGUNFBUKCAEDUKUBUCUDUKDUEUFUA $.

    $d b f x y A $.  $d b f x y B $.  $d b f x y F $.  $d b f x y X $.
    $d b f x y Y $.
    $( Pushing-forward via a function induces a mapping on filters.
       (Contributed by Stefan O'Rear, 8-Aug-2015.) $)
    fmf $p |- ( ( X e. A /\ Y e. B /\ F : Y --> X ) ->
        ( X FilMap F ) : ( fBas ` Y ) --> ( Fil ` X ) ) $=
      ( vb vy vx vf wcel cfm co cfbas cfv cv cmpt cfg cvv wceq wa w3a cfil wral
      wf wfn cima crn ovex eqid fnmpti cdm cmpt2 df-fm a1i dmeq adantl 3ad2ant3
      fdm sylan9eqr fveq2d id imaeq1 mpteq2dv oveqan12d mpteq12dv elex 3ad2ant1
      rneqd fex2 3com13 mptex ovmpt2d fneq1d mpbiri simpl1 simpr simpl3 syl3anc
      fvex fmfil ralrimiva ffnfv sylanbrc ) DAJZEBJZEDCUDZUAZDCKLZEMNZUEZFOZWHN
      DUBNZJZFWIUCWIWLWHUDWGWJFWIDGWKCGOZUFZPZUGZQLZPZWIUEFWIWRWSDWQQUHWSUIUJWG
      WIWHWSWGHIDCRRFIOZUKZMNZHOZGWKWTWNUFZPZUGZQLZPZWSKRKHIRRXHULSWGHFGIUMUNWG
      XCDSZWTCSZTZTZFXBXGWIWRXLXAEMXKWGXACUKZEXJXAXMSXIWTCUOUPWFWDXMESWEEDCURUQ
      USUTXKXGWRSWGXIXJXCDXFWQQXIVAXJXEWPXJGWKXDWOWTCWNVBVCVHVDUPVEWDWEDRJWFDAV
      FVGWFWEWDCRJEDCBAVIVJWSRJWGFWIWREMVSVKUNVLVMVNWGWMFWIWGWKWIJZTWDXNWFWMWDW
      EWFXNVOWGXNVPWDWEWFXNVQAWKCDEVTVRWAFWIWLWHWBWC $.
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d y F $.  $d y X $.  $d y Y $.  $d y Z $.
    $( A finer filter produces a finer image filter.  (Contributed by Jeff
       Hankins, 16-Nov-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    fmss $p |- ( ( ( X e. A /\ B e. ( fBas ` Y ) /\ C e. ( fBas ` Y ) ) /\
          ( F : Y --> X /\ B C_ C ) ) ->
        ( ( X FilMap F ) ` B ) C_ ( ( X FilMap F ) ` C ) ) $=
      ( vy wcel cfbas cfv wss wa cmpt crn cfg co eqid fbasrn syl3anc wceq wf cv
      w3a cima simpl2 simprl simpl1 simpl3 cres resmpt ad2antll resss syl6eqssr
      cfm rnss syl fgss fmval 3sstr4d ) EAHZBFIJZHZCVAHZUCZFEDUAZBCKZLZLZEGBDGU
      BUDZMZNZOPZEGCVIMZNZOPZBEDUNPZJZCVPJZVHVKEIJZHZVNVSHZVKVNKZVLVOKVHVBVEUTV
      TUTVBVCVGUEZVDVEVFUFZUTVBVCVGUGZGBVKDAFEVKQRSVHVCVEUTWAUTVBVCVGUHZWDWEGCV
      NDAFEVNQRSVHVJVMKWBVHVJVMBUIZVMVFWGVJTVDVEGCBVIUJUKVMBULUMVJVMUOUPVKVNEUQ
      SVHUTVBVEVQVLTWEWCWDGABDEFURSVHUTVCVEVRVOTWEWFWDGACDEFURSUS $.
  $}

  ${
    $d s t x y z B $.  $d s t x y C $.  $d s t x y F $.  $d s t x y X $.
    $d x y A $.  $d s x y L $.  $d s t x y Y $.
    $( An element of a mapping filter.  (Contributed by Jeff Hankins,
       8-Sep-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    elfm $p |- ( ( X e. C /\ B e. ( fBas ` Y ) /\ F : Y --> X ) ->
        ( A e. ( ( X FilMap F ) ` B ) <->
          ( A C_ X /\ E. x e. B ( F " x ) C_ A ) ) ) $=
      ( vt vy wcel cfbas cfv co cv cima wss wrex wa eqid wceq wf w3a cmpt fmval
      cfm crn cfg eleq2d wb fbasrn 3comr syl simpr imaeq2 eqeq2d rspcev sylancl
      elfg cvv simpl1 imassrn frn 3ad2ant3 adantr syl5ss elrnmpt mpbird cbvmptv
      ssexd ibi adantl sseq1d rexxfrd anbi2d 3bitrd ) FDJZCGKLJZGFEUAZUBZBCFEUE
      MLZJBFHCEHNZOZUCZUFZUGMZJZBFPZINZBPZIWDQZRZWGEANZOZBPZACQZRVSVTWEBHDCEFGU
      DUHVSWDFKLJZWFWKUIVQVRVPWPHCWDEDGFWDSUJUKIBWDFURULVSWJWOWGVSWIWNIAWMWDCVS
      WLCJZRZWMWDJZWMWBTZHCQZWRWQWMWMTZXAVSWQUMWMSWTXBHWLCWAWLTWBWMWMWAWLEUNZUO
      UPUQWRWMUSJWSXAUIWRWMFDVPVQVRWQUTWRWMEUFZFEWLVAVSXDFPZWQVRVPXEVQGFEVBVCVD
      VEVIHCWBWMWCUSWCSVFULVGWHWDJZWHWMTZACQZVSXFXHACWMWHWCWDHACWBWMXCVHVFVJVKV
      SXGRWHWMBVSXGUMVLVMVNVO $.

    elfm2.l $e |- L = ( Y filGen B ) $.
    $( An element of a mapping filter.  (Contributed by Jeff Hankins,
       26-Sep-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    elfm2 $p |- ( ( X e. C /\ B e. ( fBas ` Y ) /\ F : Y --> X ) ->
        ( A e. ( ( X FilMap F ) ` B ) <->
          ( A C_ X /\ E. x e. L ( F " x ) C_ A ) ) ) $=
      ( vy wcel cfbas cfv co wss cv cima wrex wa wi w3a cfm elfm ssfg syl6sseqr
      wf cfg sselda adantrr 3ad2antl2 simprr imaeq2 sseq1d rspcev rexlimdvaa wb
      weq syl2anc eleq2i elfg syl5bb 3ad2ant2 sstr2 com12 ad2antll syl5 reximdv
      imass2 expr com23 expimpd sylbid rexlimdv impbid anbi2d bitrd ) GDKZCHLMK
      ZHGEUFZUAZBCGEUBNMKBGOZEJPZQZBOZJCRZSWAEAPZQZBOZAFRZSJBCDEGHUCVTWEWIWAVTW
      EWIVTWDWIJCVTWBCKZWDSZSWBFKZWDWIVRVQWKWLVSVRWJWLWDVRCFWBVRCHCUGNZFCHUDIUE
      UHUIUJVTWJWDUKWHWDAWBFAJUQWGWCBWFWBEULUMUNURUOVTWHWEAFVTWFFKZWFHOZWBWFOZJ
      CRZSZWHWETZVRVQWNWRUPVSWNWFWMKVRWRFWMWFIUSJWFCHUTVAVBVTWOWQWSVTWOSWHWQWEV
      TWOWHWQWETVTWOWHSSZWPWDJCWPWCWGOZWTWDWBWFEVHWHXAWDTVTWOXAWHWDWCWGBVCVDVEV
      FVGVIVJVKVLVMVNVOVP $.

    $( The image filter of a filter base is the same as the image filter of its
       generated filter.  (Contributed by Jeff Hankins, 18-Nov-2009.)  (Revised
       by Stefan O'Rear, 6-Aug-2015.) $)
    fmfg $p |- ( ( X e. C /\ B e. ( fBas ` Y ) /\ F : Y --> X ) ->
        ( ( X FilMap F ) ` B ) = ( ( X FilMap F ) ` L ) ) $=
      ( vx vs wcel cfbas cfv wf w3a cfm co cv wss cima wrex elfm2 cfil cfg fgcl
      wa wb syl5eqel filfbas syl elfm syl3an2 bitr4d eqrdv ) EBJZAFKLZJZFECMZNZ
      HAECOPZLZDUSLZURHQZUTJVBERCIQSVBRIDTUEZVBVAJZIVBABCDEFGUAUPUNDUOJZUQVDVCU
      FUPDFUBLZJVEUPDFAUCPVFGAFUDUGDFUHUIIVBDBCEFUJUKULUM $.

    $( An alternate formulation of elementhood in a mapping filter that
       requires ` F ` to be onto.  (Contributed by Jeff Hankins, 1-Oct-2009.)
       (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    elfm3 $p |- ( ( B e. ( fBas ` Y ) /\ F : Y -onto-> X ) ->
        ( A e. ( ( X FilMap F ) ` B ) <-> E. x e. L A = ( F " x ) ) ) $=
      ( vy vz cfbas cfv wcel cvv cv cima wceq wb wa wss wfo cfm co foima adantl
      wrex cdm fofun elfvdm funimaexg syl2anr eqeltrrd w3a wf fof elfm2 syl3an3
      wfun ccnv cfil cfg fgcl syl5eqel 3ad2ant2 ad2antrr cnvimass wfn fofn fndm
      simprl syl5sseq 3ad2ant3 eleq2i elfg adantr syl5bb simprbda sseq2 biimpar
      syl sylan 3ad2antl3 adantlr syldan funimass3 syl2anc biimpd impr syl13anc
      filss foimacnv eqcomd imaeq2 eqeq2d rspcev rexlimdvaa expimpd crn imassrn
      simprr forn eqsstrd eqimss2 sseq1d sylan2 jca impbid bitrd 3coml mpd3an3
      ) CGKLMZGFDUAZFNMZBCFDUBUCLMZBDAOZPZQZAEUFZRZXKXLSDGPZFNXLXTFQXKGFDUDUEXL
      DURZGKUGZMXTNMXKGFDUHZCGKUIDGYBUJUKULXMXKXLXSXMXKXLUMZXNBFTZDIOZPZBTZIEUF
      ZSZXRXLXMXKGFDUNXNYJRGFDUOIBCNDEFGHUPUQYDYJXRYDYEYIXRYDYESZYHXRIEYKYFEMZY
      HSZSZDUSBPZEMZBDYOPZQZXRYNEGUTLZMZYLYOGTZYFYOTZYPYDYTYEYMXKXMYTXLXKEGCVAU
      CZYSHCGVBVCVDVEYKYLYHVJYDUUAYEYMXLXMUUAXKXLDUGZYOGDBVFXLDGVGUUDGQZGFDVHGD
      VIVTZVKVLVEYKYLYHUUBYKYLSZYHUUBUUGYAYFUUDTZYHUUBRYDYAYEYLXLXMYAXKYCVLVEYK
      YLYFGTZUUHYKYLUUIJOYFTJCUFZYLYFUUCMZYKUUIUUJSZEUUCYFHVMYDUUKUULRZYEXKXMUU
      MXLJYFCGVNVDVOVPVQYDUUIUUHYEXLXMUUIUUHXKXLUUEUUIUUHUUFUUEUUHUUIUUDGYFVRVS
      WAWBWCWDYFBDWEWFWGWHYFYOEGWJWIYKYRYMXLXMYEYRXKXLYESYQBGFBDWKWLWBVOXQYRAYO
      EXOYOQXPYQBXOYODWMWNWOWFWPWQYDXQYJAEYDXOEMZXQSZSZYEYIUUPBXPFYDUUNXQWTUUPD
      WRZXPFDXOWSYDUUQFQZUUOXLXMUURXKGFDXAVLVOVKXBUUOYIYDXQUUNXPBTZYIXPBXCYHUUS
      IXOEYFXOQYGXPBYFXODWMXDWOXEUEXFWPXGXHXIXJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x L $.  $d x S $.  $d x X $.  $d x Y $.
    imaelfm.l $e |- L = ( Y filGen B ) $.
    $( An image of a filter element is in the image filter.  (Contributed by
       Jeff Hankins, 5-Oct-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    imaelfm $p |- ( ( ( X e. A /\ B e. ( fBas ` Y ) /\ F : Y --> X ) /\
          S e. L ) -> ( F " S ) e. ( ( X FilMap F ) ` B ) ) $=
      ( vx wcel cfbas cfv wf w3a wa cima cfm co wss cv crn imassrn frn 3ad2ant3
      wrex syl5ss ssid wceq imaeq2 sseq1d rspcev mpan2 anim12i wb adantr mpbird
      elfm2 ) FAJZBGKLJZGFDMZNZCEJZODCPZBFDQRLJZVCFSZDITZPZVCSZIEUEZOZVAVEVBVIU
      TURVEUSUTVCDUAFDCUBGFDUCUFUDVBVCVCSZVIVCUGVHVKICEVFCUHVGVCVCVFCDUIUJUKULU
      MVAVDVJUNVBIVCBADEFGHUQUOUP $.
  $}

  ${
    $d b r s t u v x y z A $.  $d b r s t u v x y z F $.
    $d b r s t u v x y z L $.  $d b r s t u v x y z L $.
    $d b r s t u v x y z X $.  $d b r s t u v x y z Y $.
    $( Lemma for ~ rnelfm .  (Contributed by Jeff Hankins, 14-Nov-2009.) $)
    rnelfmlem $p |- ( ( ( Y e. A /\ L e. ( Fil ` X ) /\ F : Y --> X ) /\
          ran F e. L ) -> ran ( x e. L |-> ( `' F " x ) ) e. ( fBas ` Y ) ) $=
      ( vr vs vy vu vv wcel wa cv c0 wrex syl wb wceq cvv vt vz cfil cfv wf w3a
      crn ccnv cima cmpt cpw wss wne wnel cin wral simpl3 cdm cnvimass syl5sseq
      cfbas fdm simpl1 elpw2g mpbird adantr eqid filtop 3ad2ant2 fimacnv eqcomd
      fmptd 3ad2ant3 imaeq2 eqeq2d rspcev syl2anc elrnmpt 3ad2ant1 ne0i 0nelfil
      frn wn 0ex ax-mp wal wfn fvelrnb ad2antrr eleq1 biimparc ad2ant2l adantll
      wi wfun ffun ad3antrrr eleq2d biimpar 3ad2antl3 adantlr ad2ant2r fvimacnv
      ffn mpbid n0i eqcom sylnib rexlimdvaa con2d expr com23 impr alrimiv imnan
      sylbid elin xchbinxr albii eq0 3bitr2i sylib simpll2 simprl filin syl3anc
      simplr eqeltrd syl5bi mtod df-nel sylibr vex cbvrexv bitri anbi12i reeanv
      weq bitr4i 3expb eqidd 3adantl1 simpll1 simprrl simprrr ineq12d funcnvcnv
      ssexd imain 3syl eqtr4d eqimss2 sseq1 exp32 rexlimdvv ralrimivv mpbir2and
      3jca isfbas2 ) FBLZDEUCUDLZFECUEZUFZCUGZDLZMZADCUHZANZUIZUJZUGZFVAUDLZUVK
      FUKZULZUVKOUMZOUVKUNZUANZGNZHNZUOZULZUAUVKPZHUVKUPGUVKUPZUFZUVFDUVMUVJUEU
      VNUVFADUVIUVMUVJUVFUVIUVMLZUVHDLZUVFUWEUVIFULZUVFUVBUWGUUTUVAUVBUVEUQUVBC
      URZUVIFCUVHUSFECVBZUTQUVFUUTUWEUWGRUUTUVAUVBUVEVCZUVIFBVDQVEVFUVJVGZVLDUV
      MUVJWBQUVFUVOUVPUWCUVFFUVKLZUVOUVFUWLFUVISZADPZUVFEDLZFUVGEUIZSZUWNUVCUWO
      UVEUVAUUTUWOUVBDEVHVIVFUVCUWQUVEUVBUUTUWQUVAUVBUWPFFECVJVKVMVFUWMUWQAEDUV
      HESUVIUWPFUVHEUVGVNVOVPVQUVCUWLUWNRZUVEUUTUVAUWRUVBADUVIFUVJBUWKVRVSVFVEU
      VKFVTQUVFOUVKLZWCUVPUVFUWSODLZUVCUWTWCZUVEUVAUUTUXAUVBDEWAVIVFUWSOUVISZAD
      PZUVFUWTOTLUWSUXCRWDADUVIOUVJTUWKVRWEUVFUXBUWTADUVFUWFUXBMZMZOUVHUVDUOZDU
      XEINZUVHLZUXGUVDLZWCZWNZIWFZOUXFSZUXEUXKIUVFUWFUXBUXKUVFUWFMUXHUXBUXJUVFU
      WFUXHUXBUXJWNUVFUWFUXHMZMZUXIUXBUXOUXIUBNZCUDZUXGSZUBFPZUXBWCZUVCUXIUXSRZ
      UVEUXNUVBUUTUYAUVAUVBCFWGUYAFECXDUBFUXGCWHQVMWIUXOUXRUXTUBFUXOUXPFLZUXRMZ
      MZUXPUVILZUXTUYDUXQUVHLZUYEUXNUYCUYFUVFUXHUXRUYFUWFUYBUXRUYFUXHUXQUXGUVHW
      JWKWLWMUYDCWOZUXPUWHLZUYFUYERUVCUYGUVEUXNUYCUVBUUTUYGUVAFECWPZVMWQUVFUYBU
      YHUXNUXRUVCUYBUYHUVEUVBUUTUYBUYHUVAUVBUYHUYBUVBUWHFUXPUWIWRWSWTXAXBUXPUVH
      CXCVQXEUYEUVIOSUXBUVIUXPXFUVIOXGXHQXIXPXJXKXLXMXNUXLUXGUXFLZWCZIWFUXFOSUX
      MUXKUYKIUXKUXHUXIMUYJUXHUXIXOUXGUVHUVDXQXRXSIUXFXTUXFOXGYAYBUXEUVAUWFUVEU
      XFDLUUTUVAUVBUVEUXDYCUVFUWFUXBYDUVCUVEUXDYGUVHUVDDEYEYFYHXIYIYJOUVKYKYLUV
      FUWBGHUVKUVKUVRUVKLZUVSUVKLZMZUVRUVGJNZUIZSZUVSUVGKNZUIZSZMZKDPJDPZUVFUWB
      UYNUYQJDPZUYTKDPZMVUBUYLVUCUYMVUDUYLUVRUVISZADPZVUCUVRTLUYLVUFRGYMADUVIUV
      RUVJTUWKVRWEVUEUYQAJDAJYRUVIUYPUVRUVHUYOUVGVNVOYNYOUYMUVSUVISZADPZVUDUVST
      LUYMVUHRHYMADUVIUVSUVJTUWKVRWEVUGUYTAKDAKYRUVIUYSUVSUVHUYRUVGVNVOYNYOYPUY
      QUYTJKDDYQYSUVFVUAUWBJKDDUVFUYODLZUYRDLZMZVUAUWBUVFVUKVUAMZMZUVGUYOUYRUOZ
      UIZUVKLZVUOUVTULZUWBVUMVUPVUOUVISZADPZUVCVUKVUSUVEVUAUVAUVBVUKVUSUUTUVAUV
      BMVUKMZVUNDLZVUOVUOSZVUSUVAVUKVVAUVBUVAVUIVUJVVAUYOUYRDEYEYTXAVUTVUOUUAVU
      RVVBAVUNDUVHVUNSUVIVUOVUOUVHVUNUVGVNVOVPVQUUBXBVUMVUOTLVUPVUSRVUMVUOFBUUT
      UVAUVBUVEVULUUCUVCVUOFULZUVEVULUVBUUTVVCUVAUVBUWHVUOFCVUNUSUWIUTVMWIUUHAD
      UVIVUOUVJTUWKVRQVEVUMUVTVUOSVUQVUMUVTUYPUYSUOZVUOVUMUVRUYPUVSUYSUVFVUKUYQ
      UYTUUDUVFVUKUYQUYTUUEUUFUVCVUOVVDSZUVEVULUVBUUTVVEUVAUVBUYGUVGUHWOVVEUYIC
      UUGUYOUYRUVGUUIUUJVMWIUUKVUOUVTUULQUWAVUQUAVUOUVKUVQVUOUVTUUMVPVQUUNUUOYI
      UUPUURUVFUUTUVLUVNUWDMRUWJGHUABFUVKUUSQUUQ $.

    $( A condition for a filter to be an image filter for a given function.
       (Contributed by Jeff Hankins, 14-Nov-2009.)  (Revised by Stefan O'Rear,
       8-Aug-2015.) $)
    rnelfm $p |- ( ( Y e. A /\ L e. ( Fil ` X ) /\ F : Y --> X ) ->
        ( L e. ran ( X FilMap F ) <-> ran F e. L ) ) $=
      ( vx vs wcel cfv cv wceq wrex wb syl wi wa cima ex wss adantr vb vt vz vy
      cfil wf w3a cfm crn cfbas wfn filtop 3ad2ant2 simp1 simp3 fmf syl3anc ffn
      co fvelrnb wfo dffn4 sylib foima ad2antlr simpll simpr simplr fgcl adantl
      cfg eqid imaelfm syl31anc eqeltrrd eleq2 syl5ibcom sylan 3adant1 rexlimdv
      sylbid ccnv cmpt simpl2 filelss eqidd imaeq2 eqeq2d rspcev syl2anc simpl1
      cvv cdm cnvimass fdm syl5sseq 3ad2ant3 ssexd elrnmpt mpbird ssid ad2antrr
      wfun ffun funimass3 sylancl mpbiri sseq1d vex ax-mp cin ad3antrrr imassrn
      jcad jctir ssin elin eleq2d biimpar fvimacnv funfvima2 sylc eleq1 imbi12d
      biimpa rexlimdva com23 imp3a syl5bi ssrdv eqssd filin imp31 eqeltrd exp32
      3exp eleq1d imbi2d syl5ibrcom impbid imp44 simprr simprlr filss rnelfmlem
      syl13anc exp44 simpl3 elfm bitr4d eqrdv fnfvelrn ) EAHZCDUEIZHZEDBUFZUGZC
      DBUHUSZUIZHZBUIZCHZUUQUUTUAJZUURIZCKZUAEUJIZLZUVBUUQUURUVFUKZUUTUVGMUUQUV
      FUUNUURUFZUVHUUQDCHZUUMUUPUVIUUOUUMUVJUUPCDULZUMZUUMUUOUUPUNUUMUUOUUPUOCA
      BDEUPUQUVFUUNUURURNZUAUVFCUURUTNUUQUVEUVBUAUVFUUOUUPUVCUVFHZUVEUVBOZOZUUM
      UUOUVJUUPUVPUVKUVJUUPPZUVNUVOUVQUVNPZUVAUVDHUVEUVBUVRBEQZUVAUVDUUPUVSUVAK
      ZUVJUVNUUPEUVABVAZUVTUUPBEUKZUWAEDBURZEBVBVCEUVABVDNVEUVRUVJUVNUUPEEUVCVK
      USZHZUVSUVDHUVJUUPUVNVFUVQUVNVGUVJUUPUVNVHUVNUWEUVQUVNUWDEUEIHUWEUVCEVIUW
      DEULNVJCUVCEBUWDDEUWDVLVMVNVOUVDCUVAVPVQRVRVSVTWAUUQUVBUUTUUQUVBPZCFCBWBZ
      FJZQZWCZUIZUURIZUUSUWFUBCUWLUWFUBJZCHZUWMDSZBGJZQZUWMSZGUWKLZPZUWMUWLHZUW
      FUWNUWTUWFUWNUWOUWSUWFUUOUWNUWOOUUMUUOUUPUVBWDZUUOUWNUWOUWMCDWERNUWFUWNUW
      SUWFUWNPZUWGUWMQZUWKHZBUXDQZUWMSZUWSUXCUXEUXDUWIKZFCLZUXCUWNUXDUXDKZUXIUW
      FUWNVGUXCUXDWFUXHUXJFUWMCUWHUWMKUWIUXDUXDUWHUWMUWGWGWHWIWJUWFUXEUXIMZUWNU
      WFUXDWLHUXKUWFUXDEAUUMUUOUUPUVBWKUUQUXDESZUVBUUPUUMUXLUUOUUPBWMZUXDEBUWMW
      NZEDBWOZWPWQTWRFCUWIUXDUWJWLUWJVLZWSNTWTUXCUXGUXDUXDSZUXDXAUXCBXCZUXDUXMS
      UXGUXQMUUQUXRUVBUWNUUPUUMUXRUUOEDBXDWQZXBUXNUXDUWMBXEXFXGUWRUXGGUXDUWKUWP
      UXDKUWQUXFUWMUWPUXDBWGXHWIWJRXNUWFUWOUWSUWNUWFUWSUWOUWNUWFUWRUWOUWNOGUWKU
      WFUWPUWKHZUWRUWOUWNUWFUXTUWRPZUWOPZPUUOUWQCHZUWOUWRUWNUWFUUOUYBUXBTUWFUXT
      UWRUWOUYCUXTUWPUWIKZFCLZUWFUWRUWOUYCOZOZUWPWLHUXTUYEMGXIFCUWIUWPUWJWLUXPW
      SXJUWFUYDUYGFCUWFUWHCHZPZUYGUYDBUWIQZUWMSZUWOUYJCHZOZOUYIUYKUWOUYLUYIUYKU
      WOPZPZUYJUWHUVAXKZCUYOUYJUYPUYOUYJUWHSZUYJUVASZPUYJUYPSUYOUYQUYRUYOUYQUWI
      UWISZUWIXAUYOUXRUWIUXMSZUYQUYSMUUQUXRUVBUYHUYNUXSXLZBUWHWNZUWIUWHBXEXFXGB
      UWIXMXOUYJUWHUVAXPVCUYOUCUYPUYJUCJZUYPHVUCUWHHZVUCUVAHZPUYOVUCUYJHZVUCUWH
      UVAXQUYOVUDVUEVUFUYOVUEVUDVUFUYOVUEUDJZBIZVUCKZUDELZVUDVUFOZUUQVUEVUJMZUV
      BUYHUYNUUPUUMVULUUOUUPUWBVULUWCUDEVUCBUTNWQXLUYOVUIVUKUDEUYOVUGEHZPZVUHUW
      HHZVUHUYJHZOVUIVUKVUNVUOVUPVUNVUOPZUXRUYTPVUGUWIHZVUPVUQUXRUYTUYOUXRVUMVU
      OVUAXBVUBXOVUNVUOVURVUNUXRVUGUXMHZVUOVURMUYIUXRUYNVUMUUQUXRUVBUYHUXSXBXBU
      YOVUSVUMUYOUXMEVUGUUQUXMEKZUVBUYHUYNUUPUUMVUTUUOUXOWQXLXRXSVUGUWHBXTWJYEU
      WIVUGBYAYBRVUIVUOVUDVUPVUFVUHVUCUWHYCVUHVUCUYJYCYDVQYFWAYGYHYIYJYKUYIUYPC
      HZUYNUUQUVBUYHVVAUUOUUMUVBUYHVVAOOUUPUUOUYHUVBVVAUUOUYHUVBVVAUWHUVACDYLYP
      YGUMYMTYNYOUYDUWRUYKUYFUYMUYDUWQUYJUWMUWPUWIBWGZXHUYDUYCUYLUWOUYDUWQUYJCV
      VBYQYRYDYSYFYIUUAUWFUYAUWOUUBUWFUXTUWRUWOUUCUWQUWMCDUUDUUFUUGVTYGYHYTUWFU
      VJUWKUVFHZUUPUXAUWTMUUQUVJUVBUVLTFABCDEUUEZUUMUUOUUPUVBUUHGUWMUWKCBDEUUIU
      QUUJUUKUWFUVHVVCUWLUUSHUUQUVHUVBUVMTVVDUVFUWKUURUULWJYNRYT $.
  $}

  ${
    $d f s t w x y z B $.  $d f s t w x y z F $.  $d f s t w x y z L $.
    $d s t w x y z ph $.  $d f s t w x y z X $.  $d f s t w x z Y $.
    $d s t x Z $.
    fmfnfm.b $e |- ( ph -> B e. ( fBas ` Y ) ) $.
    fmfnfm.l $e |- ( ph -> L e. ( Fil ` X ) ) $.
    fmfnfm.f $e |- ( ph -> F : Y --> X ) $.
    fmfnfm.fm $e |- ( ph -> ( ( X FilMap F ) ` B ) C_ L ) $.
    $( Lemma for ~ fmfnfm .  (Contributed by Jeff Hankins, 18-Nov-2009.)
       (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fmfnfmlem1 $p |- ( ph -> ( s e. ( fi ` B ) ->
                       ( ( F " s ) C_ t -> ( t C_ X -> t e. L ) ) ) ) $=
      ( vw cv cfv wcel cima wss wi wa cfi cfbas fbssfi sylan imass2 sstr2 com12
      wrex syl reximdv syl5com cfm co wf cfil filtop elfm syl3anc sseld sylbird
      wb exp3acom23 adantr syld ex ) AHNZCUAOPZDVFQZBNZRZVIFRZVIEPZSZSAVGTZVJDM
      NZQZVIRZMCUHZVMVNVOVFRZMCUHZVJVRACGUBOPZVGVTIMVFCGUCUDVJVSVQMCVSVJVQVSVPV
      HRVJVQSVOVFDUEVPVHVIUFUIUGUJUKAVRVMSVGAVKVRVLAVKVRTZVICFDULUMOZPZVLAFEPZW
      AGFDUNWDWBVAAEFUOOPWEJEFUPUIIKMVICEDFGUQURAWCEVILUSUTVBVCVDVE $.

    $( Lemma for ~ fmfnfm .  (Contributed by Jeff Hankins, 19-Nov-2009.)
       (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fmfnfmlem2 $p |- ( ph -> ( E. x e. L s = ( `' F " x ) ->
                       ( ( F " s ) C_ t -> ( t C_ X -> t e. L ) ) ) ) $=
      ( cv wss wcel wi wa cfv ad2antrr vy vz ccnv cima wceq cfil crn cin simplr
      cfm co wf wfo wfn ffn dffn4 sylib foima 3syl cfbas cfg filtop syl imaelfm
      fgcl eqid syl31anc eqeltrrd sseldd filin syl3anc simprr elin wrex fvelrnb
      wb wfun cdm ffun fdm eleqtrrd fvimacnv syl2anc cnvimass funfvima2 sylancl
      ssel ad2antrl sylbid eleq1 imbi12d syl5ibcom rexlimdv com23 imp3a adantrr
      syld syl5bi ssrdv filss syl13anc exp32 imaeq2 sseq1d syl5ibrcom rexlimdva
      expr imbi1d ) AINZEUCBNZUDZUEZEXIUDZCNZOZXNGOZXNFPZQZQZBFAXJFPZRZXSXLEXKU
      DZXNOZXRQYAYCXPXQYAYCXPRZRZFGUFSPZXJEUGZUHZFPZXPYHXNOXQAYFXTYDKTZYEYFXTYG
      FPZYIYJAXTYDUIAYKXTYDADGEUJUKSZFYGMAEHUDZYGYLAHGEULZHYGEUMZYMYGUELYNEHUNZ
      YOHGEUOZHEUPUQHYGEURUSAGFPZDHUTSPZYNHHDVAUKZPZYMYLPAYFYRKFGVBVCJLAYSYTHUF
      SPUUAJDHVEYTHVBUSFDHEYTGHYTVFVDVGVHVITXJYGFGVJVKYAYCXPVLYEUAYHXNUANZYHPUU
      BXJPZUUBYGPZRZYEUUBXNPZUUBXJYGVMYAYCUUEUUFQXPYAYCRZUUCUUDUUFUUGUUDUUCUUFU
      UGUUDUBNZESZUUBUEZUBHVNZUUCUUFQZAUUDUUKVPZXTYCAYNYPUUMLYQUBHUUBEVOUSTUUGU
      UJUULUBHYAYCUUHHPZUUJUULQYAYCUUNRZRZUUIXJPZUUIXNPZQUUJUULUUPUUQUUHXKPZUUR
      UUPEVQZUUHEVRZPUUQUUSVPAUUTXTUUOAYNUUTLHGEVSVCTZUUPUUHHUVAYAYCUUNVLAUVAHU
      EZXTUUOAYNUVCLHGEVTVCTWAUUHXJEWBWCUUPUUSUUIYBPZUURUUPUUTXKUVAOUUSUVDQUVBE
      XJWDXKUUHEWEWFYCUVDUURQYAUUNYBXNUUIWGWHWQWIUUJUUQUUCUURUUFUUIUUBXJWJUUIUU
      BXNWJWKWLXGWMWIWNWOWPWRWSYHXNFGWTXAXBXLXOYCXRXLXMYBXNXIXKEXCXDXHXEXF $.

    $( Lemma for ~ fmfnfm .  (Contributed by Jeff Hankins, 19-Nov-2009.)
       (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fmfnfmlem3 $p |- ( ph -> ( fi ` ran ( x e. L |-> ( `' F " x ) ) ) =
                                    ran ( x e. L |-> ( `' F " x ) ) ) $=
      ( vs vt vy vz wcel wceq wa wrex cvv cin ccnv cima cmpt crn wral cfi filin
      cv cfv cfil 3expb sylan wf wfun ffun funcnvcnv imain eqcomd adantr imaeq2
      eqeq2d rspcev syl2anc ineq12 eqeq1d rexbidv syl5ibrcom rexlimdvva cbvrexv
      4syl anbi12i wb eqid elrnmpt ax-mp reeanv 3bitr4i inex1 3imtr4g ralrimivv
      vex mptexg rnexg inficl mpbid ) ALUIZMUIZUAZBEDUBZBUIZUCZUDZUEZPZMWNUFLWN
      UFZWNUGUJWNQZAWOLMWNWNAWGWJNUIZUCZQZWHWJOUIZUCZQZRZOESNESZWIWLQZBESZWGWNP
      ZWHWNPZRZWOAXDXGNOEEAWREPZXAEPZRZRZXGXDWSXBUAZWLQZBESZXNWRXAUAZEPZXOWJXRU
      CZQZXQAEFUKUJZPZXMXSIYCXKXLXSWRXAEFUHULUMAYAXMAGFDUNDUOWJUBUOZYAJGFDUPDUQ
      YDXTXOWRXAWJURUSVKUTXPYABXREWKXRQWLXTXOWKXRWJVAVBVCVDXDXFXPBEXDWIXOWLWGWS
      WHXBVEVFVGVHVIWGWLQZBESZWHWLQZBESZRWTNESZXCOESZRXJXEYFYIYHYJYEWTBNEWKWRQW
      LWSWGWKWRWJVAVBVJYGXCBOEWKXAQWLXBWHWKXAWJVAVBVJVLXHYFXIYHWGTPXHYFVMLWBZBE
      WLWGWMTWMVNZVOVPWHTPXIYHVMMWBBEWLWHWMTYLVOVPVLWTXCNOEEVQVRWITPWOXGVMWGWHY
      KVSBEWLWIWMTYLVOVPVTWAAYCWMTPWNTPWPWQVMIBEWLYBWCWMTWDLMWNTWEVKWF $.

    $( Lemma for ~ fmfnfm .  (Contributed by Jeff Hankins, 19-Nov-2009.)
       (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fmfnfmlem4 $p |- ( ph -> ( t e. L <-> ( t C_ X /\
      E. s e. ( fi ` ( B u. ran ( x e. L |-> ( `' F " x ) ) ) )
              ( F " s ) C_ t ) ) ) $=
      ( wcel wss wa wi syl cvv adantr vz vw cima ccnv cmpt crn cun cfi cfv wrex
      vy cv cfil filelss ex cfbas mptexg rnexg unexg syl2anc unssbd wceq imaeq2
      ssfii eqid eqeq2d rspcev mpan2 adantl wb cdm elfvdm cnvimass fdm syl5sseq
      wf elrnmpt mpbird sseldd wfun ffun ssid funimass2 sylancl sseq1d jcad cin
      ssexd w3o elfiun fmfnfmlem1 fmfnfmlem3 eleq2d vex ax-mp fmfnfmlem2 syl5bi
      sylbid syl6bb fbssfi sylan ad3antrrr cfm w3a cfg filtop 3jca ssfg imaelfm
      co sselda adantrr jca filin 3expa simprr wel fvelima simplrr simprl ssel2
      elin syl2an ad2antrr fbelss sseqtr4d fvimacnv biimpd impr ad2ant2rl inss2
      sylanbrc sstri funfvima2 sylc eleq1 rexlimdva imp3a imbi1d syl5ibrcom imp
      anassrs expr imbi12d syl5ibcom syld adantrl ssrdv sstrd filss exp32 ineq2
      syl13anc imaeq2d rexlimdvaa syldan rexlimdvva 3jaod rexlimdv com23 impbid
      ) ACULZFNZUVBGOZEIULZUCZUVBOZIDBFEUDZBULZUCZUEZUFZUGZUHUIZUJZPAUVCUVDUVOA
      FGUMUIZNZUVCUVDQKUVQUVCUVDUVBFGUNUORAUVCUVOAUVCPZUVHUVBUCZUVNNEUVSUCZUVBO
      ZUVOUVRUVLUVNUVSAUVLUVNOZUVCAUVMSNZUWBADHUPUIZNZUVLSNZUWCJAUVQUWFKUVQUVKS
      NUWFBFUVJUVPUQUVKSURRRZDUVLUWDSUSUTUWCDUVLUVNUVMSVDVARTUVRUVSUVLNZUVSUVJV
      BZBFUJZUVCUWJAUVCUVSUVSVBZUWJUVSVEUWIUWKBUVBFUVIUVBVBUVJUVSUVSUVIUVBUVHVC
      VFVGVHVIUVRUVSSNZUWHUWJVJAUWLUVCAUVSHUPVKZAUWEHUWMNJDHUPVLRAEVKZUVSHEUVBV
      MAHGEVPZUWNHVBZLHGEVNRZVOWHTBFUVJUVSUVKSUVKVEZVQRVRVSAUWAUVCAUWOUWALUWOEV
      TZUVSUVSOUWAHGEWAZUVSWBUVSUVBEWCWDRTUVGUWAIUVSUVNUVEUVSVBUVFUVTUVBUVEUVSE
      VCWEVGUTUOWFAUVDUVOUVCAUVOUVDUVCAUVGUVDUVCQZIUVNAUVEUVNNZUVEDUHUIZNZUVEUV
      LUHUIZNZUVEUAULZUBULZWGZVBZUBUXEUJUAUXCUJZWIZUVGUXAQZAUWEUWFUXBUXLVJJUWGU
      AUBUVEDUVLUWDSWJUTAUXDUXMUXFUXKACDEFGHIJKLMWKAUXFUVEUVLNZUXMAUXEUVLUVEABD
      EFGHJKLMWLZWMUXNUVEUVJVBBFUJZAUXMUVESNUXNUXPVJIWNBFUVJUVEUVKSUWRVQWOABCDE
      FGHIJKLMWPWQWRAUXJUXMUAUBUXCUXEAUXGUXCNZUXHUXENZPPUXMUXJEUXIUCZUVBOZUXAQZ
      AUXQUXRUYAAUXQPUXRUXHUVJVBZBFUJZUYAAUXRUYCVJUXQAUXRUXHUVLNZUYCAUXEUVLUXHU
      XOWMUXHSNUYDUYCVJUBWNBFUVJUXHUVKSUWRVQWOWSTAUXQUVEUXGOZIDUJZUYCUYAQZAUWEU
      XQUYFJIUXGDHWTXAAUYFUYGAUYEUYGIDAUVEDNZUYEPZPZUYBUYABFUYJUVIFNZPZUYAUYBEU
      XGUVJWGZUCZUVBOZUXAQUYLUYOUVDUVCUYLUYOUVDPZPZUVQUVFUVIWGZFNZUVDUYRUVBOUVC
      AUVQUYIUYKUYPKXBUYLUYSUYPUYJUVQUVFFNZPUYKUYSUYJUVQUYTAUVQUYIKTAUYHUYTUYEA
      UYHPZDGEXCXJUIZFUVFAVUBFOUYHMTVUAGFNZUWEUWOXDZUVEHDXEXJZNUVFVUBNAVUDUYHAV
      UCUWEUWOAUVQVUCKFGXFRJLXGTADVUEUVEAUWEDVUEOJDHXHRXKFDUVEEVUEGHVUEVEXIUTVS
      XLXMUVQUYTUYKUYSUVFUVIFGXNXOXATUYLUYOUVDXPUYQUYRUYNUVBUYQUBUYRUYNUYLUVDUX
      HUYRNZUXHUYNNZQUYOVUFUXHUVFNZUBBXQZPUYLUVDPZVUGUXHUVFUVIYBVUJVUHVUIVUGVUJ
      VUHUKULZEUIZUXHVBZUKUVEUJZVUIVUGQZAVUHVUNQZUYIUYKUVDAUWSVUPAUWOUWSLUWTRZU
      WSVUHVUNUKUXHUVEEXRUORXBVUJVUMVUOUKUVEVUJUKIXQZPVULUVINZVULUYNNZQVUMVUOVU
      JVURVUSVUTUYLUVDVURVUSPZVUTUYLUVDVVAPZPZUWSVUKUYMNZVUTAUWSUYIUYKVVBVUQXBV
      VCUKUAXQZVUKUVJNZVVDUYLUYEVURVVEVVBAUYHUYEUYKXSUVDVURVUSXTUVEUXGVUKYAYCUY
      JVVAVVFUYKUVDUYJVURVUSVVFUYJVURPZVUSVVFVVGUWSVUKUWNNVUSVVFVJAUWSUYIVURVUQ
      YDUYJUVEUWNVUKAUYHUVEUWNOUYEVUAUVEHUWNAUWEUYHUVEHOJHDUVEYEXAAUWPUYHUWQTYF
      XLXKVUKUVIEYGUTYHYIYJVUKUXGUVJYBYLUWSUYMUWNOVVDVUTQUYMUVJUWNUXGUVJYKEUVIV
      MYMUYMVUKEYNVHYOUUBUUCVUMVUSVUIVUTVUGVULUXHUVIYPVULUXHUYNYPUUDUUEYQUUFYRW
      QUUGUUHUYLUYOUVDXTUUIUYRUVBFGUUJUUMUUKUYBUXTUYOUXAUYBUXSUYNUVBUYBUXIUYMEU
      XHUVJUXGUULUUNWEYSYTYQUUOUUAUUPWRYIUXJUVGUXTUXAUXJUVFUXSUVBUVEUXIEVCWEYSY
      TUUQUURWRUUSUUTYRUVA $.

    $( A filter finer than an image filter is an image filter of the same
       function.  (Contributed by Jeff Hankins, 13-Nov-2009.)  (Revised by
       Stefan O'Rear, 8-Aug-2015.) $)
    fmfnfm $p |- ( ph -> E. f e. ( Fil ` Y ) ( B C_ f /\
            L = ( ( X FilMap F ) ` f ) ) ) $=
      ( vx vt cfv wcel wss wceq wa c0 syl vs vy ccnv cv cima crn cun cfi cfg co
      cmpt cfil cfm wrex cfbas cpw wne wn fbsspw cdm elfvdm wfo wfn dffn4 sylib
      wf foima 3syl filtop fgcl eqid imaelfm syl31anc eqeltrrd sseldd rnelfmlem
      ffn unssd ssun1 fbasne0 ssn0 sylancr cin cvv wb vex elrnmpt ax-mp 0nelfil
      wral ad2antrr adantr w3a 3jca ssfg sselda syl2anc filin 3expa sylan eleq1
      jca syl5ibcom mtod wex neq0 elin wi wfun ffun fvelima ex ad3antrrr fbelss
      sseqtr4d fvimacnv inelcm adantl sylbid imbi1d rexlimdva syld imp3a syl5bi
      fdm exlimdv mpd ineq2 neeq1d syl5ibrcom expimpd ralrimivv fbunfip fsubbas
      mpbird mpbir3and unexg ssfii unssad syl3anc sstrd fmfnfmlem4 bitr4d eqrdv
      elfm fmfg eqtrd sseq2 fveq2 eqeq2d anbi12d rspcev syl12anc ) AGBLEDUCLUDZ
      UEZUKZUFZUGZUHNZUIUJZGULNZOZBUUTPZEUUTFDUMUJZNZQZBCUDZPZEUVGUVDNZQZRZCUVA
      UNAUUSGUONZOZUVBAUVMUURGUPZPZUURSUQZSUUSOURZABUUQUVNABUVLOZBUVNPHGBUSTAUU
      QUVLOZUUQUVNPAGUOUTZOZEFULNOZGFDVFZDUFZEOUVSAUVRUWAHBGUOVAZTIJABUVDNZEUWD
      KADGUEZUWDUWFAUWCGUWDDVBZUWGUWDQJUWCDGVCUWHGFDVQGDVDVEGUWDDVGVHAFEOZUVRUW
      CGGBUIUJZOZUWGUWFOAUWBUWIIEFVITZHJAUVRUWJUVAOUWKHBGVJUWJGVIVHEBGDUWJFGUWJ
      VKZVLVMVNVOLUVTDEFGVPVMZGUUQUSTVRABUURPBSUQZUVPBUUQVSAUVRUWOHGBVTTBUURWAW
      BAUVQUAUDZMUDZWCZSUQZMUUQWJUABWJZAUWSUAMBUUQAUWPBOZUWQUUQOZUWSUXBUWQUUOQZ
      LEUNZAUXARZUWSUWQWDOUXBUXDWEMWFLEUUOUWQUUPWDUUPVKWGWHUXEUXCUWSLEUXEUUNEOZ
      RZUWSUXCUWPUUOWCZSUQZUXGDUWPUEZUUNWCZSQZURZUXIUXGUXLSEOZAUXNURZUXAUXFAUWB
      UXOIEFWITWKUXGUXKEOZUXLUXNUXEUWBUXJEOZRUXFUXPUXEUWBUXQAUWBUXAIWLUXEUWFEUX
      JAUWFEPUXAKWLUXEUWIUVRUWCWMZUWPUWJOUXJUWFOAUXRUXAAUWIUVRUWCUWLHJWNWLABUWJ
      UWPAUVRBUWJPHBGWOTWPEBUWPDUWJFGUWMVLWQVOXBUWBUXQUXFUXPUXJUUNEFWRWSWTUXKSE
      XAXCXDUXMUWQUXKOZMXEUXGUXIMUXKXFUXGUXSUXIMUXSUWQUXJOZUWQUUNOZRUXGUXIUWQUX
      JUUNXGUXGUXTUYAUXIUXGUXTUBUDZDNZUWQQZUBUWPUNZUYAUXIXHZAUXTUYEXHZUXAUXFAUW
      CDXIZUYGJGFDXJZUYHUXTUYEUBUWQUWPDXKXLVHWKUXGUYDUYFUBUWPUXGUYBUWPOZRZUYCUU
      NOZUXIXHUYDUYFUYKUYLUYBUUOOZUXIUYKUYHUYBDUTZOUYLUYMWEAUYHUXAUXFUYJAUWCUYH
      JUYITXMUXGUWPUYNUYBUXEUWPUYNPUXFUXEUWPGUYNAUVRUXAUWPGPHGBUWPXNWTAUYNGQZUX
      AAUWCUYOJGFDYETWLXOWLWPUYBUUNDXPWQUYJUYMUXIXHUXGUYJUYMUXIUYBUWPUUOXQXLXRX
      SUYDUYLUYAUXIUYCUWQUUNXAXTXCYAYBYCYDYFYDYGUXCUWRUXHSUWQUUOUWPYHYIYJYAYDYK
      YLAUVRUVSUVQUWTWEHUWNUAMBUUQGGYMWQYOAUVRUWAUVMUVOUVPUVQWMWEHUWEUURUVTGYNV
      HYPZUUSGVJTABUUSUUTABUUQUUSAUURWDOZUURUUSPAUVRUVSUYQHUWNBUUQUVLUVLYQWQUUR
      WDYRTYSAUVMUUSUUTPUYPUUSGWOTUUAAEUUSUVDNZUVEAMEUYRAUWQEOUWQFPUXJUWQPUAUUS
      UNRZUWQUYROZALMBDEFGUAHIJKUUBAUWIUVMUWCUYTUYSWEUWLUYPJUAUWQUUSEDFGUUEYTUU
      CUUDAUWIUVMUWCUYRUVEQUWLUYPJUUSEDUUTFGUUTVKUUFYTUUGUVKUVCUVFRCUUTUVAUVGUU
      TQZUVHUVCUVJUVFUVGUUTBUUHVUAUVIUVEEUVGUUTUVDUUIUUJUUKUULUUM $.
  $}

  ${
    $d f g A $.  $d f g F $.  $d f g L $.  $d f g X $.  $d f g Y $.
    $( An image filter of an ultrafilter is an ultrafilter.  (Contributed by
       Jeff Hankins, 11-Dec-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fmufil $p |- ( ( X e. A /\ L e. ( UFil ` Y ) /\ F : Y --> X ) ->
        ( ( X FilMap F ) ` L ) e. ( UFil ` X ) ) $=
      ( vf vg wcel cufil cfv wf w3a cfm co cfil cv wss wceq wa simprl cfbas syl
      wi wral ufilfil filfbas fmfil syl3an2 simpl2 simpl3 simprr fmfnfm simprrl
      3syl adantr ufilmax syl3anc fveq2d simprrr eqtr4d rexlimddv expr sylanbrc
      ralrimiva isufil2 ) DAHZCEIJHZEDBKZLZCDBMNZJZDOJZHZVKFPZQZVKVNRZUCZFVLUDV
      KDIJHVGVFCEUAJHZVHVMVGCEOJZHZVRCEUEZCEUFZUBACBDEUGUHVIVQFVLVIVNVLHZVOVPVI
      WCVOSZSZCGPZQZVNWFVJJZRZSZVPGVSWECGBVNDEWEVGVTVRVFVGVHWDUIZWAWBUNVIWCVOTV
      FVGVHWDUJVIWCVOUKULWEWFVSHZWJSZSZVKWHVNWNCWFVJWNVGWLWGCWFRWEVGWMWKUOWEWLW
      JTWEWLWGWIUMCWFEUPUQURWEWLWGWIUSUTVAVBVDFVKDVEVC $.
  $}

  ${
    $d s t u B $.  $d s t u F $.  $d s t u G $.  $d s t u V $.  $d s t u x X $.
    $d s t u W $.  $d f g s t u x y Y $.  $d s t u Z $.
    $( The filter map applied to the identity.  (Contributed by Jeff Hankins,
       8-Nov-2009.)  (Revised by Mario Carneiro, 27-Aug-2015.) $)
    fmid $p |- ( F e. ( Fil ` X ) -> ( ( X FilMap ( _I |` X ) ) ` F ) = F ) $=
      ( vt vs cfil cfv wcel cid cres cfm co cv cima wceq cfg wrex cfbas syl6bbr
      wfo wb filfbas wf1o f1oi f1ofo ax-mp eqid elfm3 sylancl fgfil rexeqdv wss
      wa filelss resiima syl eqeq2d equcom rexbidva risset 3bitrd eqrdv ) ABEFG
      ZCABHBIZJKFZAVBCLZVDGZVEVCDLZMZNZDBAOKZPZVIDAPZVEAGZVBABQFGBBVCSZVFVKTABU
      ABBVCUBVNBUCBBVCUDUEDVEAVCVJBBVJUFUGUHVBVIDVJAABUIUJVBVLVGVENZDAPVMVBVIVO
      DAVBVGAGULZVIVEVGNVOVPVHVGVEVPVGBUKVHVGNVGABUMBVGUNUOUPDCUQRURDVEAUSRUTVA
      $.

    $( Composition of image filters.  (Contributed by Mario Carneiro,
       27-Aug-2015.) $)
    fmco $p |- ( ( ( X e. V /\ Y e. W /\ B e. ( fBas ` Z ) ) /\
        ( F : Y --> X /\ G : Z --> Y ) ) ->
      ( ( X FilMap ( F o. G ) ) ` B ) =
      ( ( X FilMap F ) ` ( ( Y FilMap G ) ` B ) ) ) $=
      ( vu vt wcel cfv wf wa co wss cima wi syl syl3anc cfbas w3a ccom cfm wrex
      vs cv cfg simpl3 ssfg sseld simpl2 simprr eqid imaelfm ex syld imp imaeq2
      wceq imaco syl6eqr sseq1d rspcev rexlimdva wb imass2 syl5eqss sstr2 com12
      elfm reximdv adantl syl6bi rexlimdv impbid anbi2d simpl1 fco cfil filfbas
      fmfil simprl 3bitr4d eqrdv ) FDKZGEKZAHUALKZUBZGFBMZHGCMZNZNZUFAFBCUCZUDO
      LZAGCUDOLZFBUDOLZWMUFUGZFPZWNIUGZQZWRPZIAUEZNZWSBJUGZQZWRPZJWPUEZNZWRWOKZ
      WRWQKZWMXCXHWSWMXCXHWMXBXHIAWMWTAKZNCWTQZWPKZXBXHRWMXLXNWMXLWTHAUHOZKZXNW
      MAXOWTWMWHAXOPWFWGWHWLUIZAHUJSUKWMWGWHWKXPXNRWFWGWHWLULZXQWIWJWKUMZWGWHWK
      UBXPXNEAWTCXOGHXOUNUOUPTUQURXNXBXHXGXBJXMWPXEXMUTZXFXAWRXTXFBXMQZXAXEXMBU
      SBCWTVAZVBVCVDUPSVEWMXGXCJWPWMXEWPKZXEGPZXMXEPZIAUEZNZXGXCRZWMWGWHWKYCYGV
      FXRXQXSIXEAECGHVKTYFYHYDXGYFXCXGYEXBIAYEXGXBYEXAXFPXGXBRYEXAYAXFYBXMXEBVG
      VHXAXFWRVISVJVLVJVMVNVOVPVQWMWFWHHFWNMZXJXDVFWFWGWHWLVRZXQWLYIWIHGFBCVSVM
      IWRADWNFHVKTWMWFWPGUALKZWJXKXIVFYJWMWPGVTLKZYKWMWGWHWKYLXRXQXSEACGHWBTWPG
      WASWIWJWKWCJWRWPDBFGVKTWDWE $.

    $( The ultrafilter lemma property is a cardinal invariant, so since it
       transfers to subsets it also transfers over set dominance.  (Contributed
       by Mario Carneiro, 26-Aug-2015.) $)
    ufldom $p |- ( ( X e. UFL /\ Y ~<_ X ) -> Y e. UFL ) $=
      ( vx vf vg vu vy cufl wcel cv wss wa cfv cfm filfbas cvv wceq adantr syl
      co cdom wbr cen wex domeng wf1o bren biimpi ssufl wi cufil wrex cfil wral
      simplr cfbas wf adantl f1of ad2antrr fmfil syl3anc ufli syl2anc cdm f1odm
      ccnv vex dmex syl6eqelr simprl f1ocnv ad3antrrr fmufil ccom cid f1ococnv1
      cres oveq2d fveq1d fmco syl32anc fmid 3eqtr3d ufilfil 3syl eqsstr3d sseq2
      simprr fmss rspcev rexlimddv ralrimiva wb isufl mpbird exlimiv imp syl2an
      ex an12s exlimdv sylbid ) AHIZBAUAUBZBHIZXDXEBCJZUCUBZXGAKZLZCUDXFCBAHUEX
      DXJXFCXDXJXFXHXDXIXFXHBXGDJZUFZDUDZXGHIZXFXDXILXHXMBXGDUGUHAXGUIXMXNXFXLX
      NXFUJDXLXNXFXLXNLZXFEJZFJZKZFBUKMZULZEBUMMZUNZXOXTEYAXOXPYAIZLZXPXGXKNTMZ
      GJZKZXTGXGUKMZYDXNYEXGUMMZIZYGGYHULXLXNYCUOZYDXNXPBUPMIZBXGXKUQZYJYKYCYLX
      OXPBOURZXLYMXNYCBXGXKUSZUTHXPXKXGBVAVBZGYEXGVCVDYDYFYHIZYGLZLZYFBXKVGZNTZ
      MZXSIZXPUUBKZXTYSBPIZYQXGBYTUQZUUCXOUUEYCYRXOBXKVEZPXLUUGBQXNBXGXKVFRXKDV
      HVIVJZUTZYDYQYGVKZYSXGBYTUFZUUFXLUUKXNYCYRBXGXKVLVMXGBYTUSSZPYTYFBXGVNVBY
      SXPYEUUAMZUUBYSXPBYTXKVOZNTZMZXPBVPBVRZNTZMZUUMXPYSXPUUOUURYSUUNUUQBNXLUU
      NUUQQXNYCYRBXGXKVQVMVSVTYSUUEXNYLUUFYMUUPUUMQUUIYDXNYRYKRYDYLYRYNRUULXLYM
      XNYCYRYOVMXPYTXKPHBXGBWAWBYSYCUUSXPQXOYCYRUOXPBWCSWDYSUUEYEXGUPMZIZYFUUTI
      ZUUFYGUUMUUBKUUIYSYJUVAYDYJYRYPRYEXGOSYSYQYFYIIUVBUUJYFXGWEYFXGOWFUULYDYQ
      YGWIPYEYFYTBXGWJWBWGXRUUDFUUBXSXQUUBXPWHWKVDWLWMXOUUEXFYBWNUUHEFPBWOSWPWT
      WQWRWSXAWTXBXCWR $.
  $}

  ${
    $d x A $.  $d f j x F $.  $d f j x J $.  $d f j x X $.
    flimval.1 $e |- X = U. J $.
    $( The set of limit points of a filter.  (Contributed by Jeff Hankins,
       4-Sep-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    flimval $p |- ( ( J e. Top /\ F e. U. ran Fil ) ->
      ( J fLim F ) = { x e. X |
        ( ( ( nei ` J ) ` { x } ) C_ F /\ F C_ ~P X ) } ) $=
      ( vj vf ctop wcel cuni cv cnei cfv wss cpw wa crab cvv cflim wceq crn csn
      cfil co topopn adantr rabexg syl simpl unieqd syl6eqr fveq2d fveq1d simpr
      sseq12d pweqd anbi12d rabeqbidv df-flim ovmpt2ga mpd3an3 ) CHIZBUCUAJZIZA
      KUBZCLMZMZBNZBDOZNZPZADQZRIZCBSUDVLTVBVDPDCIZVMVBVNVDCDEUEUFVKADCUGUHFGCB
      HVCVEFKZLMZMZGKZNZVRVOJZOZNZPZAVTQVLSRVOCTZVRBTZPZWCVKAVTDWFVTCJDWFVOCWDW
      EUIZUJEUKZWFVSVHWBVJWFVQVGVRBWFVEVPVFWFVOCLWGULUMWDWEUNZUOWFVRBWAVIWIWFVT
      DWHUPUOUQURAGFUSUTVA $.

    $( The predicate "is a limit point of a filter."  (Contributed by Mario
       Carneiro, 9-Apr-2015.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    elflim2 $p |- ( A e. ( J fLim F ) <->
      ( ( J e. Top /\ F e. U. ran Fil /\ F C_ ~P X ) /\
        ( A e. X /\ ( ( nei ` J ) ` { A } ) C_ F ) ) ) $=
      ( vj vf vx ctop wcel cuni wa cpw wss csn cnei cfv cflim cv crab crn anass
      cfil w3a df-3an anbi1i df-flim elmpt2cl flimval eleq2d wceq fveq2d sseq1d
      co sneq anbi1d ancom syl6bb elrab an12 bitri biadan2 3bitr4ri ) CIJZBUCUA
      KZJZLZBDMNZLZADJZAOZCPQZQZBNZLZLVGVHVOLZLVDVFVHUDZVOLACBRUNZJZVGVHVOUBVQV
      IVOVDVFVHUEUFVSVGVPFGIVEHSZOZFSZPQQGSZNWCWBKZMNLHWDTCBRAHGFUGUHVGVSAWAVLQ
      ZBNZVHLZHDTZJZVPVGVRWHAHBCDEUIUJWIVJVHVNLZLVPWGWJHADVTAUKZWGVNVHLWJWKWFVN
      VHWKWEVMBWKWAVKVLVTAUOULUMUPVNVHUQURUSVJVHVNUTVAURVBVC $.
  $}

  $( Reverse closure for the limit point predicate.  (Contributed by Mario
     Carneiro, 9-Apr-2015.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
  flimtop $p |- ( A e. ( J fLim F ) -> J e. Top ) $=
    ( cflim co wcel ctop cfil crn cuni cpw wss w3a csn cnei cfv wa eqid elflim2
    simplbi simp1d ) ACBDEFZCGFZBHIJFZBCJZKLZUBUCUDUFMAUEFANCOPPBLQABCUEUERSTUA
    $.

  $( A filter contains the neighborhood filter as a subfilter.  (Contributed by
     Mario Carneiro, 9-Apr-2015.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
  flimneiss $p |- ( A e. ( J fLim F ) -> ( ( nei ` J ) ` { A } ) C_ F ) $=
    ( cflim co wcel cuni csn cnei cfv wss ctop cfil crn cpw w3a wa eqid elflim2
    simprbi simprd ) ACBDEFZACGZFZAHCIJJBKZUBCLFBMNGFBUCOKPUDUEQABCUCUCRSTUA $.

  $( A filter contains all of the neighborhoods of its limit points.
     (Contributed by Jeff Hankins, 4-Sep-2009.)  (Revised by Mario Carneiro,
     9-Apr-2015.) $)
  flimnei $p |- ( ( A e. ( J fLim F ) /\ N e. ( ( nei ` J ) ` { A } ) ) ->
    N e. F ) $=
    ( cflim co wcel csn cnei cfv flimneiss sselda ) ACBEFGAHCIJJBDABCKL $.

  ${
    flimuni.1 $e |- X = U. J $.
    $( A limit point of a filter belongs to its base set.  (Contributed by Jeff
       Hankins, 4-Sep-2009.)  (Revised by Mario Carneiro, 9-Apr-2015.) $)
    flimelbas $p |- ( A e. ( J fLim F ) -> A e. X ) $=
      ( cflim co wcel csn cnei cfv wss ctop cfil crn cuni cpw w3a wa elflim2
      simprbi simpld ) ACBFGHZADHZAICJKKBLZUCCMHBNOPHBDQLRUDUESABCDETUAUB $.

    $( Reverse closure for the limit point predicate.  (Contributed by Mario
       Carneiro, 9-Apr-2015.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    flimfil $p |- ( A e. ( J fLim F ) -> F e. ( Fil ` X ) ) $=
      ( cflim co wcel cuni cfil cfv crn ctop cpw wss w3a csn cnei sylib syl wa
      elflim2 simplbi simp2d filunirn simp3d sspwuni flimneiss topopn flimelbas
      flimtop opnneip syl3anc sseldd elssuni eqssd fveq2d eleqtrd ) ACBFGHZBBIZ
      JKZDJKUSBJLIHZBVAHUSCMHZVBBDNOZUSVCVBVDPADHZAQCRKKZBOUAABCDEUBUCZUDBUESUS
      UTDJUSUTDUSVDUTDOUSVCVBVDVGUFBDUGSUSDBHDUTOUSVFBDABCUHUSVCDCHZVEDVFHABCUK
      ZUSVCVHVICDEUITABCDEUJACDULUMUNDBUOTUPUQUR $.
  $}

  $( Reverse closure for the limit point predicate.  (Contributed by Mario
     Carneiro, 26-Aug-2015.) $)
  flimtopon $p |- ( A e. ( J fLim F ) ->
      ( J e. ( TopOn ` X ) <-> F e. ( Fil ` X ) ) ) $=
    ( cflim co wcel ctopon cfv cuni wceq cfil ctop wb flimtop istopon baib eqid
    syl filunibas flimfil fveq2 eleq2d syl5ibrcom eqeq1d syl5ibcom impbid bitrd
    ) ACBEFGZCDHIGZDCJZKZBDLIZGZUICMGZUJULNABCOUJUOULDCPQSUIULUNUIUNULBUKLIZGZA
    BCUKUKRUAZULUMUPBDUKLUBUCUDUIBJZUKKZUNULUIUQUTURBUKTSUNUSDUKBDTUEUFUGUH $.

  $( The predicate "is a limit point of a filter."  (Contributed by Jeff
     Hankins, 4-Sep-2009.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
  elflim $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) ) ->
                 ( A e. ( J fLim F ) <->
                   ( A e. X /\ ( ( nei ` J ) ` { A } ) C_ F ) ) ) $=
    ( ctopon cfv wcel cfil wa cflim co cuni csn cnei wss ctop crn adantr adantl
    cpw wb topontop fvssunirn sseli filsspw wceq toponuni pweqd sseqtrd elflim2
    w3a eqid baib syl3anc eleq2d anbi1d bitr4d ) CDEFGZBDHFZGZIZACBJKGZACLZGZAM
    CNFFBOZIZADGZVEIVACPGZBHQLZGZBVCTZOZVBVFUAURVHUTDCUBRUTVJURUSVIBHDUCUDSVABD
    TZVKUTBVMOURBDUESVADVCURDVCUFUTDCUGRZUHUIVBVHVJVLUKVFABCVCVCULUJUMUNVAVGVDV
    EVADVCAVNUOUPUQ $.

  ${
    $d x y A $.  $d x y F $.  $d x G $.  $d x y J $.  $d x K $.  $d x y X $.
    $( A limit point of a filter is a limit point of a finer filter.
       (Contributed by Jeff Hankins, 5-Sep-2009.)  (Revised by Stefan O'Rear,
       8-Aug-2015.) $)
    flimss2 $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) /\ G C_ F ) ->
        ( J fLim G ) C_ ( J fLim F ) ) $=
      ( vx ctopon cfv wcel cfil wss w3a cflim co cv csn cnei cuni eqid adantl
      wa flimelbas wceq simpl1 toponuni syl eleqtrrd flimneiss simpl3 wb simpl2
      sstrd elflim syl2anc mpbir2and ex ssrdv ) CDFGHZADIGHZBAJZKZECBLMZCALMZUT
      ENZVAHZVCVBHZUTVDTZVEVCDHZVCOCPGGZAJZVFVCCQZDVDVCVJHUTVCBCVJVJRUASVFUQDVJ
      UBUQURUSVDUCZDCUDUEUFVFVHBAVDVHBJUTVCBCUGSUQURUSVDUHUKVFUQURVEVGVITUIVKUQ
      URUSVDUJVCACDULUMUNUOUP $.

    $( A limit point of a filter is a limit point in a coarser topology.
       (Contributed by Mario Carneiro, 9-Apr-2015.)  (Revised by Stefan O'Rear,
       8-Aug-2015.) $)
    flimss1 $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) /\ J C_ K ) ->
      ( K fLim F ) C_ ( J fLim F ) ) $=
      ( vx cfv wcel cfil wss cflim co wa cnei cuni eqid adantl filunibas eqtr3d
      wceq syl ctopon w3a csn flimelbas simpl2 flimfil eleqtrrd simpl1 topontop
      cv ctop flimtop toponuni simpl3 topssnei syl31anc flimneiss sstrd syl2anc
      wb elflim mpbir2and ex ssrdv ) BDUAFGZADHFGZBCIZUBZECAJKZBAJKZVHEUJZVIGZV
      KVJGZVHVLLZVMVKDGZVKUCZBMFFZAIZVNVKCNZDVLVKVSGVHVKACVSVSOZUDPVNANZDVSVNVF
      WADSVEVFVGVLUEZADQTVNAVSHFGZWAVSSVLWCVHVKACVSVTUFPAVSQTRZUGVNVQVPCMFFZAVN
      BUKGZCUKGZBNZVSSVGVQWEIVNVEWFVEVFVGVLUHZDBUITVLWGVHVKACULPVNDWHVSVNVEDWHS
      WIDBUMTWDRVEVFVGVLUNVPBCWHVSWHOVTUOUPVLWEAIVHVKACUQPURVNVEVFVMVOVRLUTWIWB
      VKABDVAUSVBVCVD $.

    $( A point is a limit point of its neighborhood filter.  (Contributed by
       Jeff Hankins, 7-Sep-2009.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    neiflim $p |- ( ( J e. ( TopOn ` X ) /\ A e. X ) ->
      A e. ( J fLim ( ( nei ` J ) ` { A } ) ) ) $=
      ( ctopon cfv wcel wa csn cnei cflim co wss ssid jctr adantl cfil wb simpl
      c0 wne snssi snnzg neifil syl3anc elflim syldan mpbird ) BCDEFZACFZGZABAH
      ZBIEEZJKFZUIULULLZGZUIUOUHUIUNULMNOUHUIULCPEFZUMUOQUJUHUKCLZUKSTZUPUHUIRU
      IUQUHACUAOUIURUHACUBOUKBCUCUDAULBCUEUFUG $.

    $( The condition for being a limit point of a filter still holds if one
       only considers open neighborhoods.  (Contributed by Jeff Hankins,
       4-Sep-2009.)  (Proof shortened by Mario Carneiro, 9-Apr-2015.) $)
    flimopn $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) ) ->
    ( A e. ( J fLim F ) <-> ( A e. X /\ A. x e. J ( A e. x -> x e. F ) ) ) ) $=
      ( vy cfv wcel wa wss cv wi wral sylan eleq1 rspcv syl ralrimdva ad3antrrr
      wb ctopon cfil cflim csn cnei elflim dfss3 ctop topontop ad2antrr opnneip
      co 3expb expr com23 cnt simpr cuni wceq toponuni eleqtrd snssd eqid neii1
      simplr neiint syl3anc mpbid snssg ad2antlr mpbird syl2anc imbi12d simpllr
      ntropn eleq2 mpid ntrss2 sseqtr4d filss 3exp2 com24 syl3c impbid pm5.32da
      syld syl5bb bitrd ) DEUAGHZCEUBGHZIZBDCUCULHBEHZBUDZDUEGGZCJZIWLBAKZHZWPC
      HZLZADMZIBCDEUFWKWLWOWTWOFKZCHZFWNMZWKWLIZWTFWNCUGXDXCWTXDXCWSADXDWPDHZIW
      QXCWRXDXEWQXCWRLZXDXEWQIZIWPWNHZXFXDDUHHZXGXHWIXIWJWLEDUIZUJZXIXEWQXHBDWP
      UKUMNXBWRFWPWNXAWPCOPQUNUORXDWTXBFWNXDXAWNHZIZWTXADUPGGZCHZXBXMWTBXNHZXOX
      MXPWMXNJZXMXLXQXDXLUQXMXIWMDURZJXAXRJZXLXQTWIXIWJWLXLXJSZXMBXRXMBEXRWKWLX
      LVEWIEXRUSWJWLXLEDUTSZVAVBXDXIXLXSXKWMDXAXRXRVCZVDNZWMDXAXRYBVFVGVHWLXPXQ
      TWKXLBXNEVIVJVKXMXNDHZWTXPXOLZLXMXIXSYDXTYCXADXRYBVOVLWSYEAXNDWPXNUSWQXPW
      RXOWPXNBVPWPXNCOVMPQVQXMWJXNXAJZXAEJZXOXBLWIWJWLXLVNXMXIXSYFXTYCXADXRYBVR
      VLXMXAXREYCYAVSWJXOYGYFXBWJXOYGYFXBXNXACEVTWAWBWCWFRWDWGWEWH $.
  $}

  ${
    $d n x y A $.  $d n x y B $.  $d n x y J $.  $d n x y X $.  $d n x y Y $.
    $d x y F $.
    fbflim.3 $e |- F = ( X filGen B ) $.
    $( A condition for a filter to converge to a point involving one of its
       bases.  (Contributed by Jeff Hankins, 4-Sep-2009.)  (Revised by Stefan
       O'Rear, 6-Aug-2015.) $)
    fbflim $p |- ( ( J e. ( TopOn ` X ) /\ B e. ( fBas ` X ) ) ->
      ( A e. ( J fLim F ) <->
          ( A e. X /\ A. x e. J ( A e. x -> E. y e. B y C_ x ) ) ) ) $=
      ( ctopon cfv wcel cfbas wa cflim co cv wi wral wss wb cfg syl5eqel sylan2
      wrex cfil fgcl flimopn eleq2i elfg ad3antlr syl5bb simpll sylan biantrurd
      toponss bitr4d imbi2d ralbidva pm5.32da bitrd ) FGIJKZDGLJKZMZCFENOKZCGKZ
      CAPZKZVFEKZQZAFRZMZVEVGBPVFSBDUDZQZAFRZMVBVAEGUEJZKVDVKTVBEGDUAOZVOHDGUFU
      BACEFGUGUCVCVEVJVNVCVEMZVIVMAFVQVFFKZMZVHVLVGVSVHVFGSZVLMZVLVHVFVPKZVSWAE
      VPVFHUHVBWBWATVAVEVRBVFDGUIUJUKVSVTVLVQVAVRVTVAVBVEULVFFGUOUMUNUPUQURUSUT
      $.

    $( A condition for a filter base ` B ` to converge to a point ` A ` .  Use
       neighborhoods instead of open neighborhoods.  Compare ~ fbflim .
       (Contributed by FL, 4-Jul-2011.)  (Revised by Stefan O'Rear,
       6-Aug-2015.) $)
    fbflim2 $p |- ( ( J e. ( TopOn ` X ) /\ B e. ( fBas ` X ) ) ->
        ( A e. ( J fLim F ) <-> ( A e. X /\
            A. n e. ( ( nei ` J ) ` { A } ) E. x e. B x C_ n ) ) ) $=
      ( vy cfv wcel wa cv wss wrex wi wral ad2antrr simpr syl ctopon cfbas cnei
      cflim co csn fbflim cuni ctop topontop wceq toponuni eleqtrd eqid syl2anc
      isneip syl6bi r19.29 pm3.45 imp sstr2 com12 reximdv impcom rexlimivw syl9
      wb ralrimdv adantr simprl simprr opnneip syl3anc sseq2 rexbidv rspcv expr
      ex com23 ralrimdva impbid pm5.32da bitrd ) FGUAJKZCGUBJKZLZBFEUDUEKBGKZBI
      MZKZAMZWHNZACOZPZIFQZLWGWJDMZNZACOZDBUFFUCJJZQZLIABCEFGHUGWFWGWNWSWFWGLZW
      NWSWTWNWQDWRWTWOWRKZWIWHWONZLZIFOZWNWQWTXAWOFUHZNZXDLZXDWTFUIKZBXEKXAXGVG
      WDXHWEWGGFUJRZWTBGXEWFWGSWDGXEUKWEWGGFULRUMBIFWOXEXEUNUPUOXFXDSUQWNXDWQWN
      XDLWMXCLZIFOWQWMXCIFURXJWQIFXJWLXBLZWQWMXCXKWIWLXBUSUTXBWLWQXBWKWPACWKXBW
      PWJWHWOVAVBVCVDTVETVRVFVHWTWSWMIFWTWHFKZLWIWSWLWTXLWIWSWLPZWTXLWILZLZWHWR
      KZXMXOXHXLWIXPWTXHXNXIVIWTXLWIVJWTXLWIVKBFWHVLVMWQWLDWHWRWOWHUKWPWKACWOWH
      WJVNVOVPTVQVSVTWAWBWC $.
  $}

  ${
    $d u v x y F $.  $d f u v w x y z J $.  $d x y S $.  $d f u v w x z X $.
    $( The convergent points of a filter are a subset of the closure of any of
       the filter sets.  (Contributed by Mario Carneiro, 9-Apr-2015.)  (Revised
       by Stefan O'Rear, 9-Aug-2015.) $)
    flimclsi $p |- ( S e. F -> ( J fLim F ) C_ ( ( cls ` J ) ` S ) ) $=
      ( vx vy wcel cflim co ccl cfv cv wa cin wne csn cnei wral syl3anc adantl
      c0 cuni cfil eqid flimfil ad2antlr flimnei adantll filinn0 ralrimiva ctop
      simpll wss wb flimtop filelss ancoms sylan2 flimelbas neindisj2 mpbird ex
      ssrdv ) ABFZDCBGHZACIJJZVCDKZVDFZVFVEFZVCVGLZVHEKZAMTNZEVFOCPJJZQZVIVKEVL
      VIVJVLFZLBCUAZUBJFZVJBFZVCVKVGVPVCVNVFBCVOVOUCZUDZUEVGVNVQVCVFBCVJUFUGVCV
      GVNUKVJABVOUHRUIVICUJFZAVOULZVFVOFZVHVMUMVGVTVCVFBCUNSVGVCVPWAVSVPVCWAABV
      OUOUPUQVGWBVCVFBCVOVRURSVFAECVOVRUSRUTVAVB $.

    $( If ` A ` and ` B ` are both limits of the same filter, then all
       neighborhoods of ` A ` and ` B ` intersect.  (Contributed by Mario
       Carneiro, 21-Sep-2015.) $)
    hausflimlem $p |- ( ( ( A e. ( J fLim F ) /\ B e. ( J fLim F ) ) /\
     ( U e. J /\ V e. J ) /\ ( A e. U /\ B e. V ) ) -> ( U i^i V ) =/= (/) ) $=
      ( cflim co wcel w3a cuni cfil cfv syl csn opnneip syl3anc flimnei syl2anc
      wa cin c0 wne simp1l eqid flimfil cnei simp2l simp3l simp1r simp2r simp3r
      ctop flimtop filinn0 ) AEDGHZIZBUPIZTZCEIZFEIZTZACIZBFIZTZJZDEKZLMIZCDIZF
      DIZCFUAUBUCVFUQVHUQURVBVEUDZADEVGVGUEUFNVFUQCAOEUGMZMIZVIVKVFEUMIZUTVCVMV
      FUQVNVKADEUNNZUSUTVAVEUHUSVBVCVDUIAECPQADECRSVFURFBOVLMIZVJUQURVBVEUJVFVN
      VAVDVPVOUSUTVAVEUKUSVBVCVDULBEFPQBDEFRSCFDVGUOQ $.

    $( One direction of ~ hausflim .  A filter in a Hausdorf space has at most
       one limit.  (Contributed by FL, 14-Nov-2010.)  (Revised by Mario
       Carneiro, 21-Sep-2015.) $)
    hausflimi $p |- ( J e. Haus -> E* x x e. ( J fLim F ) ) $=
      ( vy vu vv cha wcel cv cflim co wa wceq wi wal wne c0 wrex flimelbas syl
      wmo cin w3a cuni simpl simprll eqid simprlr simprr syl13anc df-3an simprl
      hausnei hausflimlem 3expa sylanl1 a1d necon4d expimpd rexlimdvva mpd expr
      syl5bi necon1bd pm2.18d ex alrimivv eleq1 mo4 sylibr ) CGHZAIZCBJKZHZDIZV
      MHZLZVLVOMZNZDOAOVNAUAVKVSADVKVQVRVKVQLZVRVTVRVLVOVKVQVLVOPZVRVKVQWALZLZV
      LEIZHZVOFIZHZWDWFUBZQMZUCZFCRECRZVRWCVKVLCUDZHZVOWLHZWAWKVKWBUEWCVNWMVKVN
      VPWAUFVLBCWLWLUGZSTWCVPWNVKVNVPWAUHVOBCWLWOSTVKVQWAUIVLVOFECWLWOUMUJWCWJV
      REFCCWJWEWGLZWILWCWDCHWFCHLZLZVRWEWGWIUKWRWPWIVRWRWPLZVLVOWHQWSWHQPZWAWCV
      QWQWPWTVKVQWAULVQWQWPWTVLVOWDBCWFUNUOUPUQURUSVCUTVAVBVDVEVFVGVNVPADVLVOVM
      VHVIVJ $.

    flimcf.1 $e |- X = U. J $.
    $( A condition for a topology to be Hausdorff in terms of filters.  A
       topology is Hausdorff iff every filter has at most one limit point.
       (Contributed by Jeff Hankins, 5-Sep-2009.)  (Revised by Stefan O'Rear,
       6-Aug-2015.) $)
    hausflim $p |- ( J e. Haus <-> ( J e. Top /\
      A. f e. ( Fil ` X ) E* x x e. ( J fLim f ) ) ) $=
      ( vz vu vv wcel cv cfv wral wa wne c0 wn wb wss syl adantr cha ctop cflim
      vw co wmo cfil haustop hausflimi ralrimivw jca cin wceq csn cnei wrex cun
      cfi cfbas ctopon simpl toptopon sylib simprll snssd snnzg syl3anc filfbas
      neifil simprlr fbunfip syl2anc cpw w3a neisspw unssd a1d ssun1 filn0 ssn0
      wi sylancr idd 3jcad topopn fsubbas cfg fgcl adantl simplrr cvv fvex unex
      ssfii ax-mp ssfg syl5ss elflim mpbir2and unssbd eleq1 moi 3com23 syl22anc
      3expia necon3ad mpd oveq2 eleq2d mobidv notbid rspcev sylbird syld ralbii
      ex df-ne ralnex bitri rexnal 3imtr3g con4d an32s expr ralrimivva hausnei2
      imp mpbird impbii ) CUAIZCUBIZAJZCBJZUCUEZIZAUFZBDUGKZLZMZYJYKYRCUHYJYPBY
      QAYMCUIUJUKYSYJFJZUDJZNZGJHJULZOUMZHUUAUNZCUOKZKZUPZGYTUNZUUFKZUPZWAZUDDL
      FDLZYSUULFUDDDYSYTDIZUUADIZMZUUBUUKYKUUPUUBMZYRUUKYKUUQMZYRUUKUURUUKYRUUR
      UUCONZHUUGLZGUUJLZYPPZBYQUPZUUKPZYRPUURUVAOUUJUUGUQZURKZIPZUVCUURUUJDUSKZ
      IZUUGUVHIZUVGUVAQUURUUJYQIZUVIUURCDUTKIZUUIDRUUIONZUVKUURYKUVLYKUUQVACDEV
      BZVCZUURYTDYKUUNUUOUUBVDZVEUURUUNUVMUVPYTDVFSUUICDVIVGZUUJDVHSUURUUGYQIZU
      VJUURUVLUUEDRUUEONZUVRUVOUURUUADYKUUNUUOUUBVJZVEUURUUOUVSUVTUUADVFSUUECDV
      IVGUUGDVHSGHUUJUUGDDVKVLUURUVGUVEDVMZRZUVEONZUVGVNZUVCUURUVGUWBUWCUVGUURU
      WBUVGYKUWBUUQYKUUJUUGUWAUUICDEVOUUECDEVOVPTVQUURUWCUVGUURUUJUVERUUJONZUWC
      UUJUUGVRZUURUVKUWEUVQUUJDVSSUUJUVEVTWBVQUURUVGWCWDUURUWDUVFUVHIZUVCUURDCI
      ZUWGUWDQYKUWHUUQCDEWETUVECDWFSUURUWGUVCUURUWGMZDUVFWGUEZYQIZYLCUWJUCUEZIZ
      AUFZPZUVCUWGUWKUURUVFDWHWIZUWIUUBUWOYKUUPUUBUWGWJUWIUWNYTUUAUWIUUNUUOYTUW
      LIZUUAUWLIZUWNYTUUAUMZWAUURUUNUWGUVPTZUURUUOUWGUVTTZUWIUWQUUNUUJUWJRZUWTU
      WIUUJUVEUWJUWFUWIUVEUVFUWJUVEWKIUVEUVFRUUJUUGUUIUUFWLUUEUUFWLWMUVEWKWNWOU
      WGUVFUWJRUURUVFDWPWIWQZWQUWIUVLUWKUWQUUNUXBMQUURUVLUWGUVOTZUWPYTUWJCDWRVL
      WSUWIUWRUUOUUGUWJRZUXAUWIUUJUUGUWJUXCWTUWIUVLUWKUWRUUOUXEMQUXDUWPUUAUWJCD
      WRVLWSUUPUWQUWRMZUWNUWSUUPUWNUXFUWSUWMUWQUWRAYTUUADDYLYTUWLXAYLUUAUWLXAXB
      XCXEXDXFXGUVBUWOBUWJYQYMUWJUMZYPUWNUXGYOUWMAUXGYNUWLYLYMUWJCUCXHXIXJXKXLV
      LXPXMXNXMUVAUUHPZGUUJLUVDUUTUXHGUUJUUTUUDPZHUUGLUXHUUSUXIHUUGUUCOXQXOUUDH
      UUGXRXSXOUUHGUUJXRXSYPBYQXTYAYBYGYCYDYEYSUVLYJUUMQYSYKUVLYKYRVAUVNVCFUDHG
      CDYFSYHYI $.
  $}

  ${
    $d x y z F $.  $d f x y z J $.  $d f x y K $.  $d f x y z X $.
    $d x y z Y $.
    $( Fineness is properly characterized by the property that every limit
       point of a filter in the finer topology is a limit point in the coarser
       topology.  (Contributed by Jeff Hankins, 28-Sep-2009.)  (Revised by
       Mario Carneiro, 23-Aug-2015.) $)
    flimcf $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` X ) ) -> ( J C_ K <->
      A. f e. ( Fil ` X ) ( K fLim f ) C_ ( J fLim f ) ) ) $=
      ( vx vy cfv wcel wa cv cflim co wral simplll simprl simplr syl3anc sseldd
      wss syl ctopon cfil flimss1 simprr expr ralrimiva csn cnei c0 wne simpllr
      ssrdv toponss syl2anc snssd snnzg neifil wceq oveq2 sseq12d rspcv neiflim
      sylc flimneiss ctop topontop opnneip anassrs wb opnnei mpbird ex impbida
      3syl ) BDUAGZHZCVOHZIZBCSZCAJZKLZBVTKLZSZADUBGZMZVRVSIZWCAWDWFVTWDHZIEWAW
      BWFWGEJZWAHZWHWBHWFWGWIIZIZWAWBWHWKVPWGVSWCVPVQVSWJNWFWGWIOVRVSWJPVTBCDUC
      QWFWGWIUDRUEULUFVRWEIZEBCWLWHBHZWHCHZWLWMIZWNWHFJZUGZCUHGGZHZFWHMZWOWSFWH
      WLWMWPWHHZWSWLWMXAIZIZWQBUHGGZWRWHXCWPBWRKLZHXDWRSXCCWRKLZXEWPXCWRWDHZWEX
      FXESZXCVQWQDSWQUIUJZXGVPVQWEXBUKZXCWPDXCWHDWPXCVPWMWHDSVPVQWEXBNZWLWMXAOZ
      WHBDUMUNWLWMXAUDZRZUOXCWPDHZXIXNWPDUPTWQCDUQQVRWEXBPWCXHAWRWDVTWRURWAXFWB
      XEVTWRCKUSVTWRBKUSUTVAVCXCVQXOWPXFHXJXNWPCDVBUNRWPWRBVDTXCBVEHZWMXAWHXDHX
      CVPXPXKDBVFTXLXMWPBWHVGQRVHUFWOVQCVEHWNWTVIVPVQWEWMUKDCVFFWHCVJVNVKVLULVM
      $.

    $( The set of limit points in a restricted topological space.  (Contributed
       by Mario Carneiro, 15-Oct-2015.) $)
    flimrest $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) /\ Y e. F ) ->
        ( ( J |`t Y ) fLim ( F |`t Y ) ) = ( ( J fLim F ) i^i Y ) ) $=
      ( vx vy vz ctopon cfv wcel cfil crest co cv wa wi wral wb wss syl2anc w3a
      cflim cin simp1 filelss 3adant1 resttopon wn cfbas filfbas 3ad2ant2 simp3
      cdif fbncp simp2 trfil3 mpbird flimopn simpll2 simpll3 3expia sseld inss1
      elrestr trfilss simpl1 toponss sylan filss 3exp2 com24 syld impbid imbi2d
      a1i syl3c ralbidva simpl2 sselda baibd syl21anc cvv vex inex1 wceq simpl3
      wrex elrest eleq2 elin adantl sylan9bbr imbi12d ralxfr2d 3bitr4d pm5.32da
      rbaib eleq1 bitr4d ancom bitr4i syl6bb eqrdv ) BCHIZJZACKIZJZDAJZUAZEBDLM
      ZADLMZUBMZBAUBMZDUCZXIENZXLJZXODJZXOXMJZOZXOXNJZXIXPXQXOFNZJZYAXKJZPZFXJQ
      ZOZXSXIXJDHIJZXKDKIJZXPYFRXIXEDCSZYGXEXGXHUDXGXHYIXEDACUEUFZDBCUGTXIYHCDU
      MAJUHZXIACUIIJZXHYKXGXEYLXHACUJUKXEXGXHULDCACUNTXIXGYIYHYKRXEXGXHUOYJDACU
      PTUQFXOXKXJDURTXIXQXRYEXIXQOZXOGNZJZYNAJZPZGBQZYOYNDUCZXKJZPZGBQXRYEYMYQU
      UAGBYMYNBJZOZYPYTYOUUCYPYTUUCXGXHYPYTPXEXGXHXQUUBUSZXEXGXHXQUUBUTZXGXHYPY
      TYNDAXFAVDVATUUCYTYSAJZYPUUCXKAYSUUCXGXHXKASUUDUUEDACVETVBUUCXGYSYNSZYNCS
      ZUUFYPPUUDUUGUUCYNDVCVOYMXEUUBUUHXEXGXHXQVFZYNBCVGVHXGUUFUUHUUGYPXGUUFUUH
      UUGYPYSYNACVIVJVKVPVLVMVNVQYMXEXGXOCJZXRYRRUUIXEXGXHXQVRXIDCXOYJVSXEXGOXR
      UUJYRGXOABCURVTWAYMYDUUAFGYSXJBWBYSWBJUUCYNDGWCWDVOYMXEXHYAXJJYAYSWEZGBWG
      RUUIXEXGXHXQWFGYADBXDAWHTYMUUKOYBYOYCYTUUKYBXOYSJZYMYOYAYSXOWIXQUULYORXIU
      ULYOXQXOYNDWJWQWKWLUUKYCYTRYMYAYSXKWRWKWMWNWOWPWSXSXRXQOXTXQXRWTXOXMDWJXA
      XBXC $.
  $}

  ${
    $d x y A $.  $d x y J $.  $d x y S $.  $d x y X $.
    flimcls.2 $e |- F = ( X filGen ( fi `
      ( ( ( nei ` J ) ` { A } ) u. { S } ) ) ) $.
    $( Lemma for ~ flimcls .  (Contributed by Mario Carneiro, 9-Apr-2015.)
       (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    flimclslem $p |- ( ( J e. ( TopOn ` X ) /\ S C_ X /\
      A e. ( ( cls ` J ) ` S ) ) ->
        ( F e. ( Fil ` X ) /\ S e. F /\ A e. ( J fLim F ) ) ) $=
      ( vx vy cfv wcel wss w3a c0 wne 3ad2ant1 syl wb cvv wa syl2anc ctopon ccl
      cfil cflim csn cnei cun cfi cfg cfbas cpw cuni ctop topontop eqid neisspw
      co wn toponuni pweqd sseqtr4d toponmax elpw2g biimpar 3adant3 snssd unssd
      wceq ssun2 simp2 ssexd snnzg ssn0 sylancr cv cin wral wi sseqtrd neindisj
      simp3 expr syl21anc imp elsni ineq2d neeq1d syl5ibrcom ralrimiv ralrimiva
      clsss3 sseldd eleqtrrd 3ad2ant3 neifil syl3anc filfbas ne0i cls0 neeqtrrd
      simp1 fveq2 necon3i snfbas fbunfip mpbird fsubbas mpbir3and fgcl syl5eqel
      fvex snex unex ssfii ax-mp syl6sseqr syl5ss snssg mpbiri unssad mpbir2and
      ssfg elflim 3jca ) DEUAIJZBEKZABDUBIZIZJZLZCEUCIZJZBCJADCUDUQJZYJCEAUEZDU
      FIZIZBUEZUGZUHIZUIUQZYKFYJYSEUJIZJZYTYKJYJUUBYREUKZKZYRMNZMYSJURZYJYPYQUU
      CYJYPDULZUKZUUCYJDUMJZYPUUHKYEYFUUIYIEDUNOZYNDUUGUUGUOZUPPYJEUUGYEYFEUUGV
      HYIEDUSOZUTVAYJBUUCYEYFBUUCJZYIYEUUMYFYEEDJZUUMYFQEDVBZBEDVCPVDVEVFVGYJYQ
      YRKZYQMNZUUEYQYPVIZYJBRJZUUQYJBEDYEYFUUNYIUUOOZYEYFYIVJZVKZBRVLPYQYRVMVNY
      JUUFGVOZHVOZVPZMNZHYQVQZGYPVQZYJUVGGYPYJUVCYPJZSZUVFHYQUVJUVFUVDYQJZUVCBV
      PZMNZYJUVIUVMYJUUIBUUGKZYIUVIUVMVRUUJYJBEUUGUVAUULVSZYEYFYIWAZUUIUVNSYIUV
      IUVMABDUVCUUGUUKVTWBWCWDUVKUVEUVLMUVKUVDBUVCUVDBWEWFWGWHWIWJYJYPUUAJZYQUU
      AJZUUFUVHQYJYPYKJZUVQYJYEYNEKYNMNZUVSYEYFYIXAZYJAEYJAUUGEYJYHUUGAYJUUIUVN
      YHUUGKUUJUVOBDUUGUUKWKTUVPWLUULWMZVFYIYEUVTYFAYHVLWNYNDEWOWPYPEWQPYJYFBMN
      ZUUNUVRUVAYJYHMYGIZNUWCYJYHMUWDYIYEYHMNYFYHAWRWNYJUUIUWDMVHUUJDWSPWTBMYHU
      WDBMYGXBXCPUUTBEDXDWPGHYPYQEEXETXFYJUUNUUBUUDUUEUUFLQUUTYRDEXGPXHZYSEXIPX
      JZYJYRCBYJYRYSCYRRJYRYSKYPYQYNYOXKBXLXMYRRXNXOYJYSYTCYJUUBYSYTKUWEYSEYBPF
      XPXQZYJBYRJZUUPUURYJUUSUWHUUPQUVBBYRRXRPXSWLYJYMAEJZYPCKZUWBYJYPYQCUWGXTY
      JYEYLYMUWIUWJSQUWAUWFACDEYCTYAYD $.
  $}

  ${
    $d f A $.  $d f J $.  $d f S $.  $d f X $.
    $( Closure in terms of filter convergence.  (Contributed by Jeff Hankins,
       28-Nov-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    flimcls $p |- ( ( J e. ( TopOn ` X ) /\ S C_ X ) ->
      ( A e. ( ( cls ` J ) ` S ) <->
        E. f e. ( Fil ` X ) ( S e. f /\ A e. ( J fLim f ) ) ) ) $=
      ( ctopon cfv wcel wss wa ccl cv cflim co cfil wrex w3a csn cnei cun sylib
      cfi cfg eqid flimclslem 3anass wceq eleq2 oveq2 eleq2d anbi12d rspcev syl
      3expia flimclsi sselda rexlimivw impbid1 ) DEFGHZBEIZJABDKGGZHZBCLZHZADVC
      MNZHZJZCEOGZPZUSUTVBVIUSUTVBQZEARDSGGBRTUBGUCNZVHHZBVKHZADVKMNZHZJZJZVIVJ
      VLVMVOQVQABVKDEVKUDUEVLVMVOUFUAVGVPCVKVHVCVKUGZVDVMVFVOVCVKBUHVRVEVNAVCVK
      DMUIUJUKULUMUNVGVBCVHVDVEVAABVCDUOUPUQUR $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y J $.
    $( If ` A ` is a limit point of the filter ` F ` , then all the points
       which specialize ` A ` (in the specialization preorder) are also limit
       points.  Thus, the set of limit points is a union of closed sets
       (although this is only nontrivial for non-T1 spaces).  (Contributed by
       Mario Carneiro, 20-Sep-2015.) $)
    flimsncls $p |- ( A e. ( J fLim F ) ->
      ( ( cls ` J ) ` { A } ) C_ ( J fLim F ) ) $=
      ( vx vy cflim co wcel csn ccl cfv cv wa cuni wi wral wss syl2anc adantr
      c0 ctop flimtop eqid flimelbas snssd clsss3 sselda cnei simpll syl simprl
      w3a simpr cin wne clsndisj disjsn necon2abii sylibr sylan opnneip syl3anc
      3jca flimnei expr ralrimiva ctopon cfil wb toptopon sylib flimfil flimopn
      mpbir2and ex ssrdv ) ACBFGZHZDAIZCJKKZVQVRDLZVTHZWAVQHZVRWBMZWCWACNZHZWAE
      LZHZWGBHZOZECPZVRVTWEWAVRCUAHZVSWEQZVTWEQABCUBZVRAWEABCWEWEUCZUDUEZVSCWEW
      OUFRUGWDWJECWDWGCHZWHWIWDWQWHMZMZVRWGVSCUHKKHZWIVRWBWRUIZWSWLWQAWGHZWTWSV
      RWLXAWNUJWDWQWHUKWDWLWMWBULZWRXBWDWLWMWBVRWLWBWNSZVRWMWBWPSVRWBUMVCXCWRMW
      GVSUNZTUOXBWAVSWGCWEWOUPXBXETWGAUQURUSUTACWGVAVBABCWGVDRVEVFWDCWEVGKHZBWE
      VHKHZWCWFWKMVIWDWLXFXDCWEWOVJVKVRXGWBABCWEWOVLSEWABCWEVMRVNVOVP $.
  $}

  ${
    $d a j k l x y A $.  $d a j k l x y J $.  $d j k l x y z A $.
    $d j k l x y z X $.  $d z J $.
    hauspwpwf1.x $e |- X = U. J $.
    ${
      hauspwpwf1.f $e |- F = ( x e. ( ( cls ` J ) ` A ) |->
            { a | E. j e. J ( x e. j /\ a = ( j i^i A ) ) } ) $.
      $( Lemma for ~ hauspwpwdom .  Points in the closure of a set in a
         Hausdorff space are characterized by the open neighborhoods they
         extend into the generating set.  (Contributed by Mario Carneiro,
         28-Jul-2015.) $)
      hauspwpwf1 $p |- ( ( J e. Haus /\ A C_ X ) ->
          F : ( ( cls ` J ) ` A ) -1-1-> ~P ~P A ) $=
        ( vy vk vl vz wcel wa wel cv cin wceq wrex cha wss ccl cfv cpw cab cmpt
        wf1 inss2 vex inex1 elpw mpbir eleq1 mpbiri adantl rexlimivw abssi ctop
        cvv wb haustop topopn syl ssexg sylan2 ancoms pwexg elpw2g 3syl a1d weq
        wne c0 w3a simplll clsss3 sylan ad2antrr simplrl sseldd simplrr hausnei
        simpr syl13anc simprll simprr1 eqidd elequ2 ineq1 eqeq2d anbi12d rspcev
        wn syl12anc eqeq1 anbi2d rexbidv elab sylibr wi ad3antrrr simplr simprr
        ad2antlr simprl inopn syl3anc simpr2 elin sylanbrc clsndisj syl32anc n0
        wex sylib anbi1i bitri biimpri ad2antll simpll simpr3 minel inss1 sseli
        adantll nsyl syl2anc nelneq2 sylnib expr syl5bi exlimdv mpd anassrs nan
        eqcom nrexdv sylnibr ex nelne1 rexlimdvva necon4d anbi1d abbidv impbid1
        dom2lem f1eq1 ax-mp ) EUANZBFUBZOZBEUCUDUDZBUEZUEZAUUMACPZGQZCQZBRZSZOZ
        CETZGUFZUGZUHZUUMUUODUHZUULAJUUMUUOUVCJCPZUUTOZCETZGUFZUULUVCUUONZAQZUU
        MNZUULUVKUVCUUNUBZUVBGUUNUVAUUQUUNNZCEUUTUVOUUPUUTUVOUUSUUNNZUVPUUSBUBU
        URBUIUUSBUURBCUJUKULUMUUQUUSUUNUNUOUPUQURUULBUTNZUUNUTNUVKUVNVAUUKUUJUV
        QUUJUUKFENZUVQUUJEUSNZUVREVBZEFHVCVDBFEVEVFVGBUTVHUVCUUNUTVIVJUOVKUULUV
        MJQZUUMNZOZUVCUVJSZAJVLZVAUULUWCOZUWDUWEUWFUVLUWAUVCUVJUWFUVLUWAVMZUVCU
        VJVMZUWFUWGOZAKPZJLPZKQZLQZRVNSZVOZLETKETZUWHUWIUUJUVLFNUWAFNUWGUWPUUJU
        UKUWCUWGVPUWIUUMFUVLUULUUMFUBZUWCUWGUUJUVSUUKUWQUVTBEFHVQVRVSZUULUVMUWB
        UWGVTWAUWIUUMFUWAUWRUULUVMUWBUWGWBWAUWFUWGWDUVLUWALKEFHWCWEUWIUWOUWHKLE
        EUWIUWLENZUWMENZOZUWOUWHUWIUXAUWOOZOZUWLBRZUVCNZUXDUVJNZWNUWHUXCUUPUXDU
        USSZOZCETZUXEUXCUWSUWJUXDUXDSZUXIUWIUWSUWTUWOWFUWJUWKUWNUXAUWIWGUXCUXDW
        HUXHUWJUXJOCUWLECKVLZUUPUWJUXGUXJCKAWIUXKUUSUXDUXDUURUWLBWJWKWLWMWOUVBU
        XIGUXDUWLBKUJUKZUUQUXDSZUVAUXHCEUXMUUTUXGUUPUUQUXDUUSWPZWQWRWSWTUXCUVGU
        XGOZCETZUXFUXCUXOCEUXCUURENZOZUXOWNXAUXRUVGOUXGWNZXAUXCUXQUVGUXSUXCUXQU
        VGOZOZMQZUWMUURRZBRZNZMXOZUXSUYAUYDVNVMZUYFUYAUVSUUKUWBUYCENZUWAUYCNZUY
        GUWFUVSUWGUXBUXTUUJUVSUUKUWCUVTVSXBZUWFUUKUWGUXBUXTUUJUUKUWCXCXBUWFUWBU
        WGUXBUXTUULUVMUWBXDXBUYAUVSUWTUXQUYHUYJUXBUWTUWIUXTUWSUWTUWOXCXEUXCUXQU
        VGXFUWMUUREXGXHUYAUWKUVGUYIUXBUWKUWIUXTUXAUWJUWKUWNXIXEUXCUXQUVGXDUWAUW
        MUURXJXKUWABUYCEFHXLXMMUYDXNXPUYAUYEUXSMUYEMLPZMCPZOZUYBBNZOZUYAUXSUYEU
        YBUYCNZUYNOUYOUYBUYCBXJUYPUYMUYNUYBUWMUURXJXQXRUXCUXTUYOUXSUXCUXTUYOOZO
        ZUUSUXDSZUXGUYRUYBUUSNZUYBUXDNZWNZUYSWNUYOUYTUXCUXTUYLUYNUYTUYKUYTUYLUY
        NOUYBUURBXJXSYFXTUYRUYKUWNVUBUYOUYKUXCUXTUYKUYLUYNYAXTUXBUWNUWIUYQUXAUW
        JUWKUWNYBXEUYKUWNOMKPVUAUYBUWMUWLYCUXDUWLUYBUWLBYDYEYGYHUYBUUSUXDYIYHUU
        SUXDYQYJYKYLYMYNYOUXRUVGUXGYPUMYRUVIUXPGUXDUXLUXMUVHUXOCEUXMUUTUXGUVGUX
        NWQWRWSYSUXDUVCUVJUUAYHYKUUBYNYTUUCUWEUVBUVIGUWEUVAUVHCEUWEUUPUVGUUTUVL
        UWAUURUNUUDWRUUEUUFYTUUGDUVDSUVFUVEVAIUUMUUODUVDUUHUUIWT $.
    $}

    $( If ` X ` is a Hausdorff space, then the cardinality of the closure of a
       set ` A ` is bounded by the double powerset of ` A ` .  In particular, a
       Hausdorff space with a dense subset ` A ` has cardinality at most
       ` ~P ~P A ` , and a separable Hausdorff space has cardinality at most
       ` ~P ~P NN ` .  (Contributed by Mario Carneiro, 9-Apr-2015.)  (Revised
       by Mario Carneiro, 28-Jul-2015.) $)
    hauspwpwdom $p |- ( ( J e. Haus /\ A C_ X ) ->
        ( ( cls ` J ) ` A ) ~<_ ~P ~P A ) $=
      ( vx vy vz cha wcel wss wa ccl cfv cvv cpw cv cin wceq wrex pwexg cab wf1
      cmpt cdom wbr fvex ctop haustop topopn adantr simpr ssexd 3syl hauspwpwf1
      a1i syl eqid f1dom2g syl3anc ) BHIZACJZKZABLMZMZNIZAOZOZNIZVDVGEVDEPFPZIG
      PVIAQRKFBSGUAUCZUBVDVGUDUEVEVBAVCUFUOVBANIVFNIVHVBACBUTCBIZVAUTBUGIVKBUHB
      CDUIUPUJUTVAUKULANTVFNTUMEAFVJBCGDVJUQUNVDVGVJNNURUS $.
  $}

  ${
    $d f x y J $.  $d f F $.  $d f x y X $.  $d f x y Y $.  $d f x y L $.
    $( Given a topology and a filtered set, return the convergence function on
       the functions from the filtered set to the base set of the topological
       space.  (Contributed by Jeff Hankins, 14-Oct-2009.)  (Revised by Mario
       Carneiro, 15-Dec-2013.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    flffval $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) ) -> ( J fLimf L )
        = ( f e. ( X ^m Y ) |-> ( J fLim ( ( X FilMap f ) ` L ) ) ) ) $=
      ( vx vy cfv wcel cfil wa cflf co cuni cmap cv cfm cflim cmpt wceq fveq12d
      ctopon ctop crn fvssunirn sseli unieq oveqan12d simpl adantr oveq1d simpr
      topontop oveq12d mpteq12dv df-flf mptex ovmpt2a syl2an toponuni filunibas
      ovex eqcomd fveq1d oveq2d eqtrd ) BDUBHIZCEJHZIZKZBCLMZABNZCNZOMZBCVLAPZQ
      MZHZRMZSZADEOMZBCDVOQMZHZRMZSVGBUCICJUDNZIVKVSTVIDBUMVHWDCJEUEUFFGBCUCWDA
      FPZNZGPZNZOMZWEWGWFVOQMZHZRMZSVSLWEBTZWGCTZKZAWIWLVNVRWMWNWFVLWHVMOWEBUGZ
      WGCUGUHWOWEBWKVQRWMWNUIWOWGCWJVPWOWFVLVOQWMWFVLTWNWPUJUKWMWNULUAUNUOFGAUP
      AVNVRVLVMOVBUQURUSVJAVNVRVTWCVGVIVLDVMEOVGDVLDBUTVCZCEVAUHVJVQWBBRVJCVPWA
      VJVLDVOQVGVLDTVIWQUJUKVDVEUOVF $.

    $( Given a function from a filtered set to a topological space, define the
       set of limit points of the function.  (Contributed by Jeff Hankins,
       8-Nov-2009.)  (Revised by Stefan O'Rear, 6-Aug-2015.) $)
    flfval $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( ( J fLimf L ) ` F ) = ( J fLim ( ( X FilMap F ) ` L ) ) ) $=
      ( vf ctopon cfv wcel cfil wf cflf co cfm cflim wceq wa cmap wb fveq1d cv
      toponmax filtop elmapg syl2an biimpar cmpt flffval oveq2 oveq2d eqid ovex
      fvmpt sylan9eq syldan 3impa ) BDGHIZCEJHIZEDAKZABCLMZHZBCDANMZHZOMZPZUQUR
      QZUSADERMZIZVEVFVHUSUQDBIECIVHUSSURDBUBCEUCDEABCUDUEUFVFVHVAAFVGBCDFUAZNM
      ZHZOMZUGZHVDVFAUTVMFBCDEUHTFAVLVDVGVMVIAPZVKVCBOVNCVJVBVIADNUITUJVMUKBVCO
      ULUMUNUOUP $.
  $}

  ${
    $d n s F $.  $d n A $.  $d n s J $.  $d n s L $.  $d n s X $.  $d n s Y $.
    $( The property of being a limit point of a function in terms of
       neighborhoods.  (Contributed by Jeff Hankins, 9-Nov-2009.)  (Revised by
       Stefan O'Rear, 6-Aug-2015.) $)
    flfnei $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( A e. ( ( J fLimf L ) ` F ) <-> ( A e. X /\
            A. n e. ( ( nei ` J ) ` { A } ) E. s e. L ( F " s ) C_ n ) ) ) $=
      ( ctopon cfv wcel cfil co wss wa cv wral wb 3ad2ant1 syl3anc w3a cflf cfm
      wf cflim csn cnei cima wrex flfval eleq2d simp1 toponmax filfbas 3ad2ant2
      cfbas simp3 fmfil elflim syl2anc dfss3 cuni ctop topontop eqid neii1 wceq
      sylan toponuni adantr sseqtr4d baibd syldan ralbidva syl5bb anbi2d 3bitrd
      elfm ) DFIJKZEGLJKZGFCUDZUAZACDEUBMJZKADEFCUCMJZUEMZKZAFKZAUFZDUGJJZWDNZO
      ZWGCHPUHBPZNHEUIZBWIQZOWBWCWEACDEFGUJUKWBVSWDFLJKZWFWKRVSVTWAULWBFDKZEGUP
      JKZWAWOVSVTWPWAFDUMSZVTVSWQWAEGUNUOZVSVTWAUQZDECFGURTAWDDFUSUTWBWJWNWGWJW
      LWDKZBWIQWBWNBWIWDVAWBXAWMBWIWBWLWIKZWLFNZXAWMRWBXBOWLDVBZFWBDVCKZXBWLXDN
      VSVTXEWAFDVDSWHDWLXDXDVEVFVHWBFXDVGZXBVSVTXFWAFDVISVJVKWBXAXCWMWBWPWQWAXA
      XCWMORWRWSWTHWLEDCFGVRTVLVMVNVOVPVQ $.
  $}

  ${
    $d n s F $.  $d n A $.  $d n s J $.  $d n s L $.  $d n s N $.  $d n s X $.
    $d n s Y $.
    flfneii.x $e |- X = U. J $.
    $( A neighborhood of a limit point of a function contains the image of a
       filter element.  (Contributed by Jeff Hankins, 11-Nov-2009.)  (Revised
       by Stefan O'Rear, 6-Aug-2015.) $)
    flfneii $p |- ( ( ( J e. Top /\ L e. ( Fil ` Y ) /\ F : Y --> X ) /\
          A e. ( ( J fLimf L ) ` F ) /\ N e. ( ( nei ` J ) ` { A } ) ) ->
        E. s e. L ( F " s ) C_ N ) $=
      ( vn ctop wcel cfil cfv wf w3a cflf cv wss wrex csn cnei cima wral ctopon
      co wa wb toptopon flfnei syl3an1b simplbda 3adant3 wi sseq2 rexbidv rspcv
      wceq 3ad2ant3 mpd ) CKLZDGMNLZGFBOZPZABCDQUFNLZEAUACUBNNZLZPBHRUCZJRZSZHD
      TZJVFUDZVHESZHDTZVDVEVLVGVDVEAFLZVLVACFUENLVBVCVEVOVLUGUHCFIUIAJBCDFGHUJU
      KULUMVGVDVLVNUNVEVKVNJEVFVIEURVJVMHDVIEVHUOUPUQUSUT $.
  $}

  ${
    $d o A $.  $d o s F $.  $d o s J $.  $d o s L $.  $d o s X $.  $d o s Y $.
    $( The property of being a limit point of a function.  (Contributed by Jeff
       Hankins, 8-Nov-2009.)  (Revised by Stefan O'Rear, 7-Aug-2015.) $)
    isflf $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( A e. ( ( J fLimf L ) ` F ) <-> ( A e. X /\
            A. o e. J ( A e. o -> E. s e. L ( F " s ) C_ o ) ) ) ) $=
      ( ctopon cfv wcel cfil co cv wi wral wa wss wb syl3anc w3a cflf cfm cflim
      wf cima wrex flfval eleq2d simp1 cfbas toponmax 3ad2ant1 filfbas 3ad2ant2
      simp3 fmfil flimopn syl2anc elfm adantr toponss biantrurd bitr4d ralbidva
      sylan imbi2d anbi2d 3bitrd ) DFIJKZEGLJKZGFCUEZUAZACDEUBMJZKADEFCUCMJZUDM
      ZKZAFKZABNZKZVSVOKZOZBDPZQZVRVTCHNUFVSRHEUGZOZBDPZQVMVNVPACDEFGUHUIVMVJVO
      FLJKZVQWDSVJVKVLUJZVMFDKZEGUKJKZVLWHVJVKWJVLFDULUMZVKVJWKVLEGUNUOZVJVKVLU
      PZDECFGUQTBAVODFURUSVMWCWGVRVMWBWFBDVMVSDKZQZWAWEVTWPWAVSFRZWEQZWEVMWAWRS
      ZWOVMWJWKVLWSWLWMWNHVSEDCFGUTTVAWPWQWEVMVJWOWQWIVSDFVBVFVCVDVGVEVHVI $.

    $( A limit point of a function is in the topological space.  (Contributed
       by Jeff Hankins, 10-Nov-2009.)  (Revised by Stefan O'Rear,
       7-Aug-2015.) $)
    flfelbas $p |- ( ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\
       F : Y --> X ) /\ A e. ( ( J fLimf L ) ` F ) ) -> A e. X ) $=
      ( vo vs ctopon cfv wcel cfil wf w3a cflf co cv cima wss wrex wi simprbda
      wral isflf ) CEIJKDFLJKFEBMNABCDOPJKAEKAGQZKBHQRUESHDTUAGCUCAGBCDEFHUDUB
      $.
  $}

  ${
    $d o s t A $.  $d o s t B $.  $d o s t F $.  $d o s t J $.  $d o s t L $.
    $d o s t X $.  $d o s t Y $.
    flffbas.l $e |- L = ( Y filGen B ) $.
    $( Limit points of a function can be defined using filter bases.
       (Contributed by Jeff Hankins, 9-Nov-2009.)  (Revised by Mario Carneiro,
       26-Aug-2015.) $)
    flffbas $p |- ( ( J e. ( TopOn ` X ) /\ B e. ( fBas ` Y ) /\ F : Y --> X )
      -> ( A e. ( ( J fLimf L ) ` F ) <-> ( A e. X /\
            A. o e. J ( A e. o -> E. s e. B ( F " s ) C_ o ) ) ) ) $=
      ( vt cfv wcel co cv cima wss wrex wi wa ctopon cfbas wf cflf wral cfil wb
      w3a cfg fgcl syl5eqel isflf syl3an2 eleq2i elfg 3ad2ant2 imass2 sstr2 syl
      com12 adantl reximdv ex com23 adantld sylbid adantr syl5bi ssfg syl6sseqr
      rexlimdv sselda 3ad2antl2 ad2ant2r simprr imaeq2 sseq1d rspcev rexlimdvaa
      weq syl2anc impbid imbi2d ralbidv pm5.32da bitrd ) EGUALMZBHUBLMZHGDUCZUH
      ZADEFUDNLMZAGMZACOZMZDKOZPZWMQZKFRZSZCEUEZTZWLWNDIOZPZWMQZIBRZSZCEUEZTWHW
      GFHUFLZMWIWKXAUGWHFHBUINZXHJBHUJUKACDEFGHKULUMWJWLWTXGWJWLTZWSXFCEXJWRXEW
      NXJWRXEXJWQXEKFWOFMWOXIMZXJWQXESZFXIWOJUNWJXKXLSWLWJXKWOHQZXBWOQZIBRZTZXL
      WHWGXKXPUGWIIWOBHUOUPWJXOXLXMWJWQXOXEWJWQXOXESWJWQTXNXDIBWQXNXDSWJXNWQXDX
      NXCWPQWQXDSXBWODUQXCWPWMURUSUTVAVBVCVDVEVFVGVHVKXJXDWRIBXJXBBMZXDTTXBFMZX
      DWRWJXQXRWLXDWHWGXQXRWIWHBFXBWHBXIFBHVIJVJVLVMVNXJXQXDVOWQXDKXBFKIVTWPXCW
      MWOXBDVPVQVRWAVSWBWCWDWEWF $.
  $}

  ${
    $d o s u A $.  $d o u B $.  $d o s u F $.  $d s u J $.  $d o s u L $.
    $d s u X $.  $d s u Y $.
    flftg.l $e |- J = ( topGen ` B ) $.
    $( Limit points of a function can be defined using topological bases.
       (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    flftg $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X )
      -> ( A e. ( ( J fLimf L ) ` F ) <-> ( A e. X /\
            A. o e. B ( A e. o -> E. s e. L ( F " s ) C_ o ) ) ) ) $=
      ( vu cfv wcel cv wss wrex wi wral wa ctop ctopon cfil wf w3a cflf co cima
      isflf ctg raleqi ctb simpl1 topontop syl syl5eqelr tgclb sylibr bastg weq
      eleq2 sseq2 rexbidv imbi12d cbvralv ssralv syl5bi 3syl r19.29 simpl simpr
      tg2 sstr2 syl5com reximdv embantd impcom rexlimivw syl5 expdimp ralrimiva
      ex impbid1 syl5bb pm5.32da bitrd ) EGUALMZFHUBLMZHGDUCZUDZADEFUEUFLMAGMZA
      KNZMZDINUGZWKOZIFPZQZKERZSWJACNZMZWMWROZIFPZQZCBRZSAKDEFGHIUHWIWJWQXCWQWP
      KBUILZRZWIWJSZXCWPKEXDJUJXFXEXCXFBUKMZBXDOZXEXCQXFXDTMXGXFXDETJXFWFETMWFW
      GWHWJULGEUMUNUOBUPUQBUKURXEXBCXDRXHXCWPXBKCXDKCUSZWLWSWOXAWKWRAUTXIWNWTIF
      WKWRWMVAVBVCVDXBCBXDVEVFVGXCWPKXDXCWKXDMZWLWOXJWLSWSWRWKOZSZCBPZXCWOCWKBA
      VKXCXMWOXCXMSXBXLSZCBPWOXBXLCBVHXNWOCBXLXBWOXLWSXAWOWSXKVIXLWTWNIFXLXKWTW
      NWSXKVJWMWRWKVLVMVNVOVPVQUNWAVRVSVTWBWCWDWE $.
  $}

  ${
    $d o s x F $.  $d o s x J $.  $d o s x L $.  $d o s x X $.  $d o s x Y $.
    $d o A $.
    hausflf.x $e |- X = U. J $.
    $( If a function has its values in a Hausdorff space, then it has at most
       one limit value.  (Contributed by FL, 14-Nov-2010.)  (Revised by Stefan
       O'Rear, 6-Aug-2015.) $)
    hausflf $p |- ( ( J e. Haus /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        E* x x e. ( ( J fLimf L ) ` F ) ) $=
      ( cha wcel cfil cfv wf w3a cv cflf co wmo cfm cflim hausflimi ctopon wceq
      3ad2ant1 ctop haustop toptopon sylib flfval syl3an1 eleq2d mobidv mpbird
      ) CHIZDFJKIZFEBLZMZANZBCDOPKZIZAQUQCDEBRPKZSPZIZAQZUMUNVCUOAUTCTUCUPUSVBA
      UPURVAUQUMCEUAKIZUNUOURVAUBUMCUDIVDCUECEGUFUGBCDEFUHUIUJUKUL $.

    $( If a convergent function has its values in a Hausdorff space, then it
       has a unique limit.  (Contributed by FL, 14-Nov-2010.)  (Revised by
       Stefan O'Rear, 6-Aug-2015.) $)
    hausflf2 $p |- ( ( ( J e. Haus /\ L e. ( Fil ` Y ) /\ F : Y --> X ) /\
        ( ( J fLimf L ) ` F ) =/= (/) ) -> ( ( J fLimf L ) ` F ) ~~ 1o ) $=
      ( vx cflf co cfv c0 wne cv wcel wex wmo c1o cen wbr biimpi cha cfil wf n0
      w3a hausflf wa weu euen1b eu5 bitr2i syl2anr ) ABCHIJZKLZGMUMNZGOZUOGPZUM
      QRSZBUANCEUBJNEDAUCUEUNUPGUMUDTGABCDEFUFUPUQUGZURURUOGUHUSGUMUIUOGUJUKTUL
      $.
  $}

  ${
    $d f u v x y z A $.  $d u x y z L $.  $d f u v x z X $.  $d f u v x z Y $.
    $d f u v x y z F $.  $d f u v x y z J $.  $d f u v x y z K $.
    $( Forward direction of ~ cnpflf .  (Contributed by Mario Carneiro,
       9-Apr-2015.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    cnpflfi $p |- ( ( A e. ( J fLim L ) /\ F e. ( ( J CnP K ) ` A ) ) ->
      ( F ` A ) e. ( ( K fLimf L ) ` F ) ) $=
      ( vx vy co wcel cfv wa cuni cv wrex wi wral eqid adantl adantr syl3anc wf
      cflim ccnp cflf cima wss flimelbas ffvelrnd simplr simprl simprr cnpimaex
      cnpf anass simpl ctopon wb flimtop toptopon sylib flimfil flimopn syl2anc
      cfil ctop mpbid simprd r19.21bi expimpd anim1d syl5bir reximdv2 ralrimiva
      mpd expr cnptop2 isflf mpbir2and ) ACEUBHIZBACDUCHJIZKZABJZBDEUDHJIZWBDLZ
      IZWBFMZIZBGMZUEWFUFZGENZOZFDPZWACLZWDABVTWMWDBUAZVSABCDWMWDWMQZWDQZUMRZVS
      AWMIZVTAECWMWOUGSUHWAWKFDWAWFDIZWGWJWAWSWGKZKZAWHIZWIKZGCNZWJXAVTWSWGXDVS
      VTWTUIWAWSWGUJWAWSWGUKGWFABCDULTXAXCWIGCEWHCIZXCKXEXBKZWIKXAWHEIZWIKXEXBW
      IUNXAXFXGWIXAXEXBXGXAXBXGOZGCWAXHGCPZWTWAWRXIWAVSWRXIKZVSVTUOWACWMUPJIZEW
      MVDJIZVSXJUQWACVEIZXKVSXMVTAECURSCWMWOUSUTVSXLVTAECWMWOVASZGAECWMVBVCVFVG
      SVHVIVJVKVLVNVOVMWADWDUPJIZXLWNWCWEWLKUQWADVEIZXOVTXPVSABCDVPRDWDWPUSUTXN
      WQWBFBDEWDWMGVQTVR $.

    ${
      cnpflf2.3 $e |- L = ( ( nei ` J ) ` { A } ) $.
      $( ` F ` is continous at point ` A ` iff a limit of ` F ` when ` x `
         tends to ` A ` is ` ( F `` A ) ` .  Proposition 9 of [BourbakiTop1]
         p.  TG I.50.  (Contributed by FL, 29-May-2011.)  (Revised by Mario
         Carneiro, 9-Apr-2015.) $)
      cnpflf2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ A e. X ) ->
        ( F e. ( ( J CnP K ) ` A ) <-> ( F : X --> Y /\
          ( F ` A ) e. ( ( K fLimf L ) ` F ) ) ) ) $=
        ( vu vz vv cfv wcel co wa cflim syl2anc cv wss wrex ctopon ccnp wf cflf
        w3a cnpf2 3expa 3adantl3 simpl1 simpl3 csn cnei neiflim syl6eleqr simpr
        oveq2i cnpflfi jca cima wi wral cuni ctop wb topontop syl wceq toponuni
        eleqtrd eleq2i eqid isneip syl5bb imass2 sstr2 com12 syl5 anim2d adantl
        reximdv syl6bi rexlimdv imim2d ralimdv jctild adantld cfil simpl2 snssd
        c0 wne snnzg neifil syl3anc syl5eqel isflf iscnp adantr 3imtr4d impbida
        impr ) CFUALMZDGUALMZAFMZUEZBACDUBNLMZFGBUCZABLZBDEUDNLMZOXEXFOZXGXIXBX
        CXFXGXDXBXCXFXGABCDFGUFUGUHXJACEPNZMZXFXIXJXBXDXLXBXCXDXFUIXBXCXDXFUJXB
        XDOACAUKZCULLLZPNXKACFUMEXNCPHUPUNQXEXFUOABCDEUQQURXEXGXIXFXEXGOZXHGMZX
        HIRZMZBJRZUSZXQSZJETZUTZIDVAZOZXGXRAKRZMZBYFUSZXQSZOZKCTZUTZIDVAZOZXIXF
        XOYDYNXPXOYDYMXGXOYCYLIDXOYBYKXRXOYAYKJEXOXSEMZXSCVBZSZYGYFXSSZOZKCTZOZ
        YAYKUTZXOCVCMZAYPMZYOUUAVDXOXBUUCXBXCXDXGUIZFCVEVFXOAFYPXBXCXDXGUJZXOXB
        FYPVGUUEFCVHVFVIYOXSXNMUUCUUDOUUAEXNXSHVJAKCXSYPYPVKVLVMQYTUUBYQYAYTYKY
        AYSYJKCYAYRYIYGYRYHXTSZYAYIYFXSBVNUUGYAYIYHXTXQVOVPVQVRVTVPVSWAWBWCWDXE
        XGUOZWEWFXOXCEFWGLZMXGXIYEVDXBXCXDXGWHXOEXNUUIHXOXBXMFSXMWJWKZXNUUIMUUE
        XOAFUUFWIXOXDUUJUUFAFWLVFXMCFWMWNWOUUHXHIBDEGFJWPWNXEXFYNVDXGKIABCDFGWQ
        WRWSXAWT $.
    $}

    $( Continuity of a function at a point in terms of filter limits.
       (Contributed by Jeff Hankins, 7-Sep-2009.)  (Revised by Stefan O'Rear,
       7-Aug-2015.) $)
    cnpflf $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ A e. X ) ->
        ( F e. ( ( J CnP K ) ` A ) <-> ( F : X --> Y /\
            A. f e. ( Fil ` X ) ( A e. ( J fLim f ) ->
                ( F ` A ) e. ( ( K fLimf f ) ` F ) ) ) ) ) $=
      ( ctopon cfv wcel w3a ccnp co cflim cflf wi wa syl oveq2 eleq2d cfil wral
      wf cv cnpf2 3expa 3adantl3 cnpflfi expcom ralrimivw adantl jca csn simpl1
      ex cnei simpl3 neiflim syl2anc wss c0 wne snssd snnzg neifil syl3anc wceq
      fveq1d imbi12d rspcv mpid imdistanda eqid cnpflf2 sylibrd impbid ) DFHIJZ
      EGHIJZAFJZKZCADELMIJZFGCUCZADBUDZNMZJZACIZCEWCOMZIZJZPZBFUAIZUBZQZVTWAWMV
      TWAQWBWLVQVRWAWBVSVQVRWAWBACDEFGUEUFUGWAWLVTWAWJBWKWEWAWIACDEWCUHUIUJUKUL
      UOVTWMWBWFCEAUMZDUPIIZOMZIZJZQWAVTWBWLWRVTWBQZWLADWONMZJZWRWSVQVSXAVQVRVS
      WBUNZVQVRVSWBUQZADFURUSWSWOWKJZWLXAWRPZPWSVQWNFUTWNVAVBZXDXBWSAFXCVCWSVSX
      FXCAFVDRWNDFVEVFWJXEBWOWKWCWOVGZWEXAWIWRXGWDWTAWCWODNSTXGWHWQWFXGCWGWPWCW
      OEOSVHTVIVJRVKVLACDEWOFGWOVMVNVOVP $.

    $( A function is continuous iff it respects filter limits.  (Contributed by
       Jeff Hankins, 6-Sep-2009.)  (Revised by Stefan O'Rear, 7-Aug-2015.) $)
    cnflf $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. f e. ( Fil ` X )
        A. x e. ( J fLim f ) ( F ` x ) e. ( ( K fLimf f ) ` F ) ) ) ) $=
      ( ctopon cfv wcel wa ccn co wf cv ccnp wral wi bitr4d syl6bb cflf cfil wb
      cflim cncnp cnpflf 3expa adantlr simplr biantrurd ralbidva cuni flimelbas
      eqid wceq toponuni ad2antrr eleq2d syl5ibr pm4.71rd imbi1d impexp ralbidv
      ralbidv2 ralcom pm5.32da bitrd ) DFHIJZEGHIJZKZCDELMJFGCNZCAOZDEPMIJZAFQZ
      KVKVLCICEBOZUAMIJZADVOUDMZQZBFUBIZQZKACDEFGUEVJVKVNVTVJVKKZVNVLVQJZVPRZBV
      SQZAFQZVTWAVMWDAFWAVLFJZKZVMVKWDKZWDVJWFVMWHUCZVKVHVIWFWIVLBCDEFGUFUGUHWG
      VKWDVJVKWFUIUJSUKWAVTWCAFQZBVSQWEWAVRWJBVSWAVPWCAVQFWAWCWFWBKZVPRWFWCRWAW
      BWKVPWAWBWFWBWFWAVLDULZJVLVODWLWLUNUMWAFWLVLVHFWLUOVIVKFDUPUQURUSUTVAWFWB
      VPVBTVDVCWCBAVSFVETSVFVG $.

    $( A function is continuous iff it respects filter limits.  (Contributed by
       Mario Carneiro, 9-Apr-2015.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    cnflf2 $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) )
      -> ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. f e. ( Fil ` X )
        ( F " ( J fLim f ) ) C_ ( ( K fLimf f ) ` F ) ) ) ) $=
      ( vx ctopon cfv wcel wa ccn co wf cv cflf wral wss adantl wceq cflim cfil
      cima cnflf wfun wb ffun cuni eqid flimelbas ssriv toponuni ad2antrr eqtrd
      cdm fdm syl5sseqr funimass4 syl2anc ralbidv pm5.32da bitr4d ) CEHIJZDFHIJ
      ZKZBCDLMJEFBNZGOZBIBDAOZPMIZJGCVHUAMZQZAEUBIZQZKVFBVJUCVIRZAVLQZKGABCDEFU
      DVEVFVOVMVEVFKZVNVKAVLVPBUEZVJBUOZRVNVKUFVFVQVEEFBUGSVPCUHZVJVRGVJVSVGVHC
      VSVSUIUJUKVPVREVSVFVRETVEEFBUPSVCEVSTVDVFECULUMUNUQGVJVIBURUSUTVAVB $.
  $}

  $( A continuous function preserves filter limits.  (Contributed by Mario
     Carneiro, 18-Sep-2015.) $)
  flfcnp $p |- ( ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\
     F : Y --> X ) /\
       ( A e. ( ( J fLimf L ) ` F ) /\ G e. ( ( J CnP K ) ` A ) ) ) ->
    ( G ` A ) e. ( ( K fLimf L ) ` ( G o. F ) ) ) $=
    ( ctopon cfv wcel wf cflf co cfm cflim wceq flfval syl syl3anc cfil ccnp wa
    w3a ccom simprl adantr eleqtrd simprr cnpflfi syl2anc cuni cnptop2 ad2antll
    cfbas ctop eqid toptopon sylib toponmax simpl1 simpl2 cnpf2 simpl3 syl32anc
    filfbas fmco oveq2d fco fmfil 3eqtr4d eleqtrrd ) DGIJKZFHUAJKZHGBLZUDZABDFM
    NJZKZCADEUBNJKZUCZUCZACJZCEFGBONJZMNJZCBUEZEFMNJZWAADWCPNZKVSWBWDKWAAVQWGVP
    VRVSUFVPVQWGQVTBDFGHRUGUHVPVRVSUIZACDEWCUJUKWAEFEULZWEONJZPNZEWCWICONJZPNZW
    FWDWAWJWLEPWAWIEKZGDKZFHUOJKZGWICLZVOWJWLQWAEWIIJKZWNWAEUPKZWRVSWSVPVRACDEU
    MUNEWIWIUQURUSZWIEUTSWAVMWOVMVNVOVTVAZGDUTSZWAVNWPVMVNVOVTVBZFHVFSZWAVMWRVS
    WQXAWTWHACDEGWIVCTZVMVNVOVTVDZFCBEDWIGHVGVEVHWAWRVNHWIWELZWFWKQWTXCWAWQVOXG
    XEXFHGWICBVIUKWEEFWIHRTWAWRWCGUAJKZWQWDWMQWTWAWOWPVOXHXBXDXFDFBGHVJTXECEWCW
    IGRTVKVL $.

  ${
    $d j k x y F $.  $d j k x y J $.  $d j k x y P $.  $d j k x y X $.
    $d x y L $.  $d j k x M $.  $d j k x y Z $.
    lmflf.1 $e |- Z = ( ZZ>= ` M ) $.
    lmflf.2 $e |- L = ( Z filGen ( ZZ>= " Z ) ) $.
    $( The topological limit relation on functions can be written in terms of
       the filter limit along the filter generated by the upper integer sets.
       (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    lmflf $p |- ( ( J e. ( TopOn ` X ) /\ M e. ZZ /\ F : Z --> X ) ->
      ( F ( ~~>t ` J ) P <-> P e. ( ( J fLimf L ) ` F ) ) ) $=
      ( vx vk vj vy cfv wcel cz cv cuz wa wss ctopon w3a wral wrex cima clm wbr
      wf wi cflf co wfn wb cpw uzf ffn ax-mp uzssz eqsstri imaeq2 sseq1d rexima
      wceq mp2an wfun cdm simpl3 ffun syl uzss eleq2s adantl sseqtr4d funimass4
      fdm syl6eq syl2anc rexbidva syl5rbb imbi2d anbi2d simp1 simp2 simp3 eqidd
      ralbidv lmbrf cfbas uzfbas flffbas syl3an2 3bitr4d ) CFUANOZEPOZGFBUHZUBZ
      AFOZAJQZOZKQZBNZWROKLQZRNZUCZLGUDZUIZJCUCZSWQWSBMQZUEZWRTZMRGUEZUDZUIZJCU
      CZSZBACUFNUGABCDUJUKNOZWPXGXNWQWPXFXMJCWPXEXLWSXLBXCUEZWRTZLGUDZWPXERPULZ
      GPTXLXSUMPPUNZRUHXTUOPYARUPUQGERNZPHEURUSXJXRMLPGRXHXCVCXIXQWRXHXCBUTVAVB
      VDWPXRXDLGWPXBGOZSZBVEZXCBVFZTXRXDUMYDWOYEWMWNWOYCVGZGFBVHVIYDXCYBYFYCXCY
      BTZWPYHXBYBGEXBVJHVKVLYDYFGYBYDWOYFGVCYGGFBVOVIHVPVMKXCWRBVNVQVRVSVTWFWAW
      PJXAALKBCEFGWMWNWOWBHWMWNWOWCWMWNWOWDWPWTGOSXAWEWGWNWMXKGWHNOWOXPXOUMEGHW
      IAXKJBCDFGMIWJWKWL $.
  $}

  ${
    $d h u v z H $.  $d f g h n u v ph $.  $d h u v x z R $.  $d h u v x z S $.
    $d f g h n u v F $.  $d f g h n u v G $.  $d f h u v x z J $.
    $d g h u v x z K $.  $d f g h u v z L $.  $d f g h n u v Z $.
    $d f h n u x X $.  $d g h n v x Y $.
    txflf.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    txflf.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    txflf.l $e |- ( ph -> L e. ( Fil ` Z ) ) $.
    txflf.f $e |- ( ph -> F : Z --> X ) $.
    txflf.g $e |- ( ph -> G : Z --> Y ) $.
    txflf.h $e |- H = ( n e. Z |-> <. ( F ` n ) , ( G ` n ) >. ) $.
    $( Two sequences converge in a filter iff the sequence of their ordered
       pairs converges.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    txflf $p |- ( ph -> ( <. R , S >. e. ( ( ( J tX K ) fLimf L ) ` H ) <->
      ( R e. ( ( J fLimf L ) ` F ) /\ S e. ( ( K fLimf L ) ` G ) ) ) ) $=
      ( wcel vz vh vu vv vf vg vx cop cxp cv cima wss wrex wi cmpt2 crn wral wa
      ctx co cflf cfv cvv vex xpex rgen2w eqid wceq eleq2 sseq2 rexbidv imbi12d
      wb ralrnmpt2 ax-mp crab opelxp ancom bitri a1i r19.40 raleq cbvrexv sylib
      anbi12i reeanv cfil filin 3expb sylan inss1 ssralv anim12i anbi12d rspcev
      cin syl2an ex rexlimdvva syl5bir impbid2 cmpt cres df-ima filelss reseq1i
      inss2 resmpt syl5eq syl rneqd sseq1d ralbii fmpt wfn opex syl6bb rexbidva
      wf wfun cdm adantr ffun sseqtr4d funimass4 syl2anc 3bitr4d ralbidv ralrab
      fdm c0 wne ctopon toponmax rabn0 sylibr bitrd ffvelrnda syl3anc isflf an4
      fnmpti df-f mpbiran r19.26 3bitr3i impexp r19.21v bitr3i syl6bbr r19.28zv
      anim12dan r19.27zv sylan9bbr syl5bb pm5.32da anbi1i 3bitr4g oveq1d fveq1d
      ctg txval eleq2d txtopon eqeltrrd opelxpi fmptd flftg ) ABCUHZKLUIZTZUVIU
      AUJZTZGUBUJZUKZUVLULZUBJUMZUNZUAUCUDHIUCUJZUDUJZUIZUOZUPZUQZURZBKTZBUVSTZ
      EUEUJZUKUVSULZUEJUMZUNUCHUQZURZCLTZCUVTTZFUFUJZUKUVTULZUFJUMZUNUDIUQZURZU
      RZUVIGHIUSUTZJVAUTZVBZTZBEHJVAUTVBTZCFIJVAUTVBTZURAUWFUWMURZUWDURUXGUWKUW
      RURZURUWEUWTAUXGUWDUXHUWDUVIUWATZUVOUWAULZUBJUMZUNZUDIUQZUCHUQZAUXGURZUXH
      UWAVCTZUDIUQUCHUQUWDUXNVMUXPUCUDHIUVSUVTUCVDUDVDVEVFUVRUXLUCUDUAHIUWAUWBV
      CUWBVGUVLUWAVHZUVMUXIUVQUXKUVLUWAUVIVIUXQUVPUXJUBJUVLUWAUVOVJVKVLVNVOUXOU
      XNUWJUCBUGUJZTZUGHVPZUQZUWQUDCUXRTZUGIVPZUQZURZUXHUXOUXNUWJUWQURZUDUYCUQZ
      UCUXTUQZUYEAUXNUYHVMUXGAUXNUWGUYGUNZUCHUQUYHAUXMUYIUCHAUXMUWNUWGUYFUNZUNZ
      UDIUQZUYIAUXLUYKUDIAUXLUWNUWGURZUYFUNUYKAUXIUYMUXKUYFUXIUYMVMAUXIUWGUWNUR
      UYMBCUVSUVTVQUWGUWNVRVSVTADUJZEVBZUVSTZDUVNUQZUYNFVBZUVTTZDUVNUQZURZUBJUM
      ZUYPDUWHUQZUEJUMZUYSDUWOUQZUFJUMZURZUXKUYFAVUBVUGVUBUYQUBJUMZUYTUBJUMZURV
      UGUYQUYTUBJWAVUHVUDVUIVUFUYQVUCUBUEJUYPDUVNUWHWBWCUYTVUEUBUFJUYSDUVNUWOWB
      WCWEWDVUGVUCVUEURZUFJUMUEJUMAVUBVUCVUEUEUFJJWFAVUJVUBUEUFJJAUWHJTZUWOJTZU
      RZURZVUJVUBVUNUWHUWOWPZJTZUYPDVUOUQZUYSDVUOUQZURZVUBVUJAJMWGVBTZVUMVUPPVU
      TVUKVULVUPUWHUWOJMWHWIWJVUCVUQVUEVURVUOUWHULVUCVUQUNUWHUWOWKUYPDVUOUWHWLV
      OVUOUWOULVUEVURUNUWHUWOXGUYSDVUOUWOWLVOWMVUAVUSUBVUOJUVNVUOVHUYQVUQUYTVUR
      UYPDUVNVUOWBUYSDUVNVUOWBWNWOWQWRWSWTXAAUXJVUAUBJAUVNJTZURZUXJDUVNUYOUYRUH
      ZXBZUPZUWAULZVUAVVBUVOVVEUWAVVBUVOGUVNXCZUPVVEGUVNXDVVBVVGVVDVVBUVNMULZVV
      GVVDVHAVUTVVAVVHPUVNJMXEWJVVHVVGDMVVCXBZUVNXCVVDGVVIUVNSXFDMUVNVVCXHXIXJX
      KXIXLVVCUWATZDUVNUQZUYPUYSURZDUVNUQVVFVUAVVJVVLDUVNUYOUYRUVSUVTVQXMVVKUVN
      UWAVVDXSZVVFDUVNUWAVVCVVDVVDVGZXNVVMVVDUVNXOVVFDUVNVVCVVDUYOUYRXPVVNUUBUV
      NUWAVVDUUCUUDVSUYPUYSDUVNUUEUUFXQXRAUWJVUDUWQVUFAUWIVUCUEJAVUKURZEXTZUWHE
      YAZULUWIVUCVMVVOMKEXSZVVPAVVRVUKQYBZMKEYCXJVVOUWHMVVQAVUTVUKUWHMULPUWHJMX
      EWJVVOVVRVVQMVHVVSMKEYJXJYDDUWHUVSEYEYFXRAUWPVUEUFJAVULURZFXTZUWOFYAZULUW
      PVUEVMVVTMLFXSZVWAAVWCVULRYBZMLFYCXJVVTUWOMVWBAVUTVULUWOMULPUWOJMXEWJVVTV
      WCVWBMVHVWDMLFYJXJYDDUWOUVTFYEYFXRWNYGVLUWNUWGUYFUUGXQYHUYLUYJUDUYCUQUYIU
      YBUWNUYJUDUGIUXRUVTCVIZYIUWGUYFUDUYCUUHUUIXQYHUXSUWGUYGUCUGHUXRUVSBVIZYIU
      UJYBUXOUXTYKYLZUYCYKYLZURUYHUYEVMAUWFVWGUWMVWHAKHTZUWFVWGAHKYMVBZTZVWINKH
      YNXJVWIUWFURUXSUGHUMVWGUXSUWFUGKHUXRKBVIWOUXSUGHYOYPWJALITZUWMVWHAILYMVBZ
      TZVWLOLIYNXJVWLUWMURUYBUGIUMVWHUYBUWMUGLIUXRLCVIWOUYBUGIYOYPWJUULVWHUYHUW
      JUYDURZUCUXTUQVWGUYEVWHUYGVWOUCUXTUWJUWQUDUYCUUKYHUWJUYDUCUXTUUMUUNXJYQUY
      AUWKUYDUWRUXSUWGUWJUCUGHVWFYIUYBUWNUWQUDUGIVWEYIWEXQUUOUUPUVKUXGUWDBCKLVQ
      UUQUWFUWKUWMUWRUUAUURAUXDUVIGUWCUVAVBZJVAUTZVBZTZUWEAUXCVWRUVIAGUXBVWQAUX
      AVWPJVAAVWKVWNUXAVWPVHNOUCUDUWCHIVWJVWMUWCVGUVBYFZUUSUUTUVCAVWPUVJYMVBZTV
      UTMUVJGXSVWSUWEVMAUXAVWPVXAVWTAVWKVWNUXAVXATNOHIKLUVDYFUVEPADMVVCUVJGAUYN
      MTURUYOKTUYRLTVVCUVJTAMKUYNEQYRAMLUYNFRYRUYOUYRKLUVFYFSUVGUVIUWCUAGVWPJUV
      JMUBVWPVGUVHYSYQAUXEUWLUXFUWSAVWKVUTVVRUXEUWLVMNPQBUCEHJKMUEYTYSAVWNVUTVW
      CUXFUWSVMOPRCUDFIJLMUFYTYSWNYG $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d x y O $.  $d x y ph $.  $d x y z Z $.
    $d x y X $.  $d x y Y $.
    flfcnp2.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    flfcnp2.k $e |- ( ph -> K e. ( TopOn ` Y ) ) $.
    flfcnp2.l $e |- ( ph -> L e. ( Fil ` Z ) ) $.
    flfcnp2.a $e |- ( ( ph /\ x e. Z ) -> A e. X ) $.
    flfcnp2.b $e |- ( ( ph /\ x e. Z ) -> B e. Y ) $.
    flfcnp2.r $e |- ( ph -> R e. ( ( J fLimf L ) ` ( x e. Z |-> A ) ) ) $.
    flfcnp2.s $e |- ( ph -> S e. ( ( K fLimf L ) ` ( x e. Z |-> B ) ) ) $.
    flfcnp2.o $e |- ( ph -> O e. ( ( ( J tX K ) CnP N ) ` <. R , S >. ) ) $.
    $( The image of a convergent sequence under a continuous map is convergent
       to the image of the original point.  Binary operation version.
       (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    flfcnp2 $p |- ( ph ->
      ( R O S ) e. ( ( N fLimf L ) ` ( x e. Z |-> ( A O B ) ) ) ) $=
      ( vy co cop cfv cmpt cflf df-ov ccom ctx ctopon wcel cfil wf ccnp txtopon
      cxp syl2anc cv wa opelxpi eqid fmptd nfcv nffvmpt1 nfop wceq fveq2 cbvmpt
      opeq12d txflf mpbir2and simpr fvmpt2 fveq2d eleqtrd flfcnp syl32anc eqidd
      mpteq2dva cuni ctop cnptop2 toptopon sylib syl3anc feqmptd syl6eqr fmptco
      syl cnpf2 syl5eqel ) AEFKUDEFUEZKUFZBNCDKUDZUGZJIUHUDZUFZEFKUIAWOKBNCDUEZ
      UGZUJZWRUFZWSAGHUKUDZLMURZULUFUMZINUNUFUMNXEXAUOWNXAXDIUHUDZUFZUMKWNXDJUP
      UDUFUMZWOXCUMAGLULUFUMHMULUFUMXFOPGHLMUQUSZQABNWTXEXAABUTZNUMZVAZCLUMZDMU
      MZWTXEUMRSCDLMVBUSZXAVCVDAWNBNXKBNCUGZUFZXKBNDUGZUFZUEZUGZXGUFZXHAWNYCUME
      XQGIUHUDUFUMFXSHIUHUDUFUMTUAAEFUCXQXSYBGHILMNOPQABNCLXQRXQVCZVDABNDMXSSXS
      VCZVDBUCNYAUCUTZXQUFZYFXSUFZUEUCYAVEBYGYHBNCYFVFBNDYFVFVGXKYFVHXRYGXTYHXK
      YFXQVIXKYFXSVIVKVJVLVMAYBXAXGABNYAWTXMXRCXTDXMXLXNXRCVHAXLVNZRBNCLXQYDVOU
      SXMXLXOXTDVHYISBNDMXSYEVOUSVKWAVPVQUBWNXAKXDJIXENVRVSAXBWQWRABUCNXEWTYFKU
      FZWPXAKXPAXAVTAUCXEJWBZKAXFJYKULUFUMZXIXEYKKUOXJAJWCUMZYLAXIYMUBWNKXDJWDW
      KJYKYKVCWEWFUBWNKXDJXEYKWLWGWHYFWTVHYJWTKUFWPYFWTKVICDKUIWIWJVPVQWM $.
  $}

  ${
    $d f j x $.  $d o s A $.  $d f j o s t F $.  $d f j o s X $.  $d f j s Y $.
    $d f j o s t J $.
    fclsval.x $e |- X = U. J $.
    $( The set of all cluster points of a filter.  (Contributed by Jeff
       Hankins, 10-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclsval $p |- ( ( J e. Top /\ F e. ( Fil ` Y ) ) -> ( J fClus F ) =
          if ( X = Y , |^|_ t e. F ( ( cls ` J ) ` t ) , (/) ) ) $=
      ( vj vf wcel cfil cfv wa cuni wceq cv ccl ciin c0 cvv adantl cfcls co cif
      ctop crn simpl fvssunirn sseli wne wral filn0 fvex rgenw sylancl 0ex ifcl
      iinexg unieq syl6eqr eqeqan12d iineq1 simpll fveq2d fveq1d iineq2dv eqtrd
      eqidd ifbieq12d df-fcls ovmpt2ga syl3anc wb filunibas eqeq2d ifbid ) CUDI
      ZBEJKZIZLZCBUAUBZDBMZNZABAOZCPKZKZQZRUCZDENZWFRUCVSVPBJUEMZIZWGSIZVTWGNVP
      VRUFVRWJVPVQWIBJEUGUHTVSWFSIZRSIWKVSBRUIZWESIZABUJWLVRWMVPBEUKTWNABWCWDUL
      UMABWESUQUNUOWBWFRSUPUNGHCBUDWIGOZMZHOZMZNZAWQWCWOPKZKZQZRUCWGUASWOCNZWQB
      NZLZWSWBXBRWFRXCXDWPDWRWAXCWPCMDWOCURFUSWQBURUTXEXBABXAQZWFXDXBXFNXCAWQBX
      AVATXEABXAWEXEWCBIZLZWCWTWDXHWOCPXCXDXGVBVCVDVEVFXERVGVHAHGVIVJVKVSWBWHWF
      RVRWBWHVLVPVRWAEDBEVMVNTVOVF $.

    $( A cluster point of a filter.  (Contributed by Jeff Hankins,
       10-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    isfcls $p |- ( A e. ( J fClus F ) <-> ( J e. Top /\ F e. ( Fil ` X ) /\
          A. s e. F A e. ( ( cls ` J ) ` s ) ) ) $=
      ( vj vf vx wcel cfil cuni wa wceq cv cfv eleq2d c0 wi a1i ctop wral cfcls
      crn ccl co anass fvssunirn sseli filunibas eqcomd filunirn fveq2 biimparc
      w3a jca sylanb impbii anbi2i anbi1i 3bitr4i ciin df-fcls elmpt2cl fclsval
      df-3an cif sylan2b n0i iffalse nsyl2 pm4.71rd iftrue adantl cvv elex wrex
      wne filn0 sylbi ad2antlr r19.2z ex syl rexlimivw wb eliin pm5.21ndd bitrd
      syl6 pm5.32da 3bitrd biadan2 3bitr4ri ) CUAJZBKUDLZJZMZDBLZNZMZAEOCUEPPZJ
      ZEBUBZMZWRWTXDMZMWOBDKPZJZXDUOZACBUCUFZJZWRWTXDUGWOXHMZXDMWOWQWTMZMZXDMXI
      XEXLXNXDXHXMWOXHXMXHWQWTXGWPBKDUHUIXHWSDBDUJUKUPWQBWSKPZJZWTXHBULZWTXHXPW
      TXGXOBDWSKUMQUNUQURUSUTWOXHXDVFXAXNXDWOWQWTUGUTVAXKWRXFGHUAWPGOZLHOZLNIXS
      IOXRUEPPVBRVGCBUCAIHGVCVDWRXKAWTEBXBVBZRVGZJZWTYBMXFWRXJYAAWQWOXPXJYANXQE
      BCDWSFVEVHQWRYBWTYBWTSWRYBYARNWTYAAVIWTXTRVJVKTVLWRWTYBXDXAYBAXTJZXDXAYAX
      TAWTYAXTNWRWTXTRVMVNQXAAVOJZYCXDYCYDSXAAXTVPTXAXDXCEBVQZYDXABRVRZXDYESWQY
      FWOWTWQXPYFXQBWSVSVTWAYFXDYEXCEBWBWCWDXCYDEBAXBVPWEWJYDYCXDWFSXAEABXBVOWG
      TWHWIWKWLWMWN $.

    $( Reverse closure for the cluster point predicate.  (Contributed by Mario
       Carneiro, 11-Apr-2015.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclsfil $p |- ( A e. ( J fClus F ) -> F e. ( Fil ` X ) ) $=
      ( vs cfcls co wcel ctop cfil cfv cv ccl wral isfcls simp2bi ) ACBGHICJIBD
      KLIAFMCNLLIFBOABCDFEPQ $.
  $}

  ${
    $d n o s A $.  $d n o s x F $.  $d n o s x J $.  $d o s x U $.  $d s x S $.
    $d o s x X $.  $d o s Y $.
    $( Reverse closure for the cluster point predicate.  (Contributed by Mario
       Carneiro, 11-Apr-2015.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclstop $p |- ( A e. ( J fClus F ) -> J e. Top ) $=
      ( vs cfcls co wcel ctop cuni cfil cfv cv ccl wral eqid isfcls simp1bi ) A
      CBEFGCHGBCIZJKGADLCMKKGDBNABCRDROPQ $.

    $( Reverse closure for the cluster point predicate.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    fclstopon $p |- ( A e. ( J fClus F ) ->
        ( J e. ( TopOn ` X ) <-> F e. ( Fil ` X ) ) ) $=
      ( cfcls wcel ctopon cfv cuni wceq cfil ctop fclstop istopon baib syl eqid
      co wb filunibas fclsfil fveq2 eleq2d syl5ibrcom eqeq1d syl5ibcom impbid
      bitrd ) ACBERFZCDGHFZDCIZJZBDKHZFZUICLFZUJULSABCMUJUOULDCNOPUIULUNUIUNULB
      UKKHZFZABCUKUKQUAZULUMUPBDUKKUBUCUDUIBIZUKJZUNULUIUQUTURBUKTPUNUSDUKBDTUE
      UFUGUH $.

    $( A cluster point of a filter.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    isfcls2 $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) ) ->
      ( A e. ( J fClus F ) <-> A. s e. F A e. ( ( cls ` J ) ` s ) ) ) $=
      ( ctopon cfv wcel cfil wa ctop cuni cfcls co cv ccl wral topontop adantr
      wb toponuni fveq2d eleq2d biimpa eqid isfcls df-3an bitri baib syl2anc
      w3a ) CDFGHZBDIGZHZJCKHZBCLZIGZHZACBMNHZAEOCPGGHEBQZTULUOUNDCRSULUNURULUM
      UQBULDUPIDCUAUBUCUDUSUOURJZUTUSUOURUTUKVAUTJABCUPEUPUEUFUOURUTUGUHUIUJ $.

    $( Write the cluster point condition in terms of open sets.  (Contributed
       by Jeff Hankins, 10-Nov-2009.)  (Revised by Mario Carneiro,
       26-Aug-2015.) $)
    fclsopn $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) ) ->
      ( A e. ( J fClus F ) <-> ( A e. X /\
        A. o e. J ( A e. o -> A. s e. F ( o i^i s ) =/= (/) ) ) ) ) $=
      ( ctopon cfv wcel cfil wa cfcls cv wral c0 wne wi wss ad2antrr ad3antrrr
      co ccl cin isfcls2 wrex filn0 adantl r19.2z ex cuni ctop topontop filelss
      syl adantll wceq toponuni sseqtrd clsss3 syl2anc sseqtr4d sseld rexlimdva
      eqid syld pm4.71rd wb adantlr simplr eleqtrd elcls syl3anc ralcom r19.21v
      ralbidva ralbii bitri syl6bb pm5.32da 3bitrd ) DEGHIZCEJHIZKZADCLUAIAFMZD
      UBHHZIZFCNZAEIZWGKWHABMZIZWIWDUCOPZFCNQZBDNZKACDEFUDWCWGWHWCWGWFFCUEZWHWC
      COPZWGWNQWBWOWACEUFUGWOWGWNWFFCUHUIUNWCWFWHFCWCWDCIZKZWEEAWQWEDUJZEWQDUKI
      ZWDWRRZWEWRRWAWSWBWPEDULZSWQWDEWRWBWPWDERWAWDCEUMUOWAEWRUPZWBWPEDUQZSZURZ
      WDDWRWRVDZUSUTXDVAVBVCVEVFWCWHWGWMWCWHKZWGWJWKQZBDNZFCNZWMXGWFXIFCXGWPKZW
      SWTAWRIWFXIVGWAWSWBWHWPXATWCWPWTWHXEVHXKAEWRWCWHWPVIWAXBWBWHWPXCTVJBAWDDW
      RXFVKVLVOXJXHFCNZBDNWMXHFBCDVMXLWLBDWJWKFCVNVPVQVRVSVT $.

    $( An open neighborhood of a cluster point of a filter intersects any
       element of that filter.  (Contributed by Mario Carneiro, 11-Apr-2015.)
       (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclsopni $p |- ( ( A e. ( J fClus F ) /\ ( U e. J /\ A e. U /\ S e. F ) )
      -> ( U i^i S ) =/= (/) ) $=
      ( vs vo cfcls co wcel cin c0 wne cv wral wi cfv wceq neeq1d rspccv ctopon
      cuni wa cfil wb fclsfil fclstopon mpbird fclsopn syl2anc ibi simprd eleq2
      eqid ineq1 ralbidv imbi12d syl ineq2 syl8 3imp2 ) AEDHIJZCEJZACJZBDJZCBKZ
      LMZVBVCVDCFNZKZLMZFDOZVEVGPVBAGNZJZVLVHKZLMZFDOZPZGEOZVCVDVKPZPVBAEUBZJZV
      RVBWAVRUCZVBEVTUAQJZDVTUDQJZVBWBUEVBWCWDADEVTVTUNUFZADEVTUGUHWEAGDEVTFUIU
      JUKULVQVSGCEVLCRZVMVDVPVKVLCAUMWFVOVJFDWFVNVILVLCVHUOSUPUQTURVJVGFBDVHBRV
      IVFLVHBCUSSTUTVA $.

    fclselbas.1 $e |- X = U. J $.
    $( A cluster point is in the base set.  (Contributed by Jeff Hankins,
       11-Nov-2009.)  (Revised by Mario Carneiro, 26-Aug-2015.) $)
    fclselbas $p |- ( A e. ( J fClus F ) -> A e. X ) $=
      ( vo vs cfcls co wcel cv cin c0 wne wral wi wa ctopon cfv cfil wb fclsfil
      fclstopon mpbird fclsopn syl2anc ibi simpld ) ACBHIJZADJZAFKZJUKGKLMNGBOP
      FCOZUIUJULQZUICDRSJZBDTSJZUIUMUAUIUNUOABCDEUBZABCDUCUDUPAFBCDGUEUFUGUH $.
  $}

  $( A neighborhood of a cluster point of a filter intersects any element of
     that filter.  (Contributed by Jeff Hankins, 11-Nov-2009.)  (Revised by
     Stefan O'Rear, 8-Aug-2015.) $)
  fclsneii $p |- ( ( A e. ( J fClus F ) /\ N e. ( ( nei ` J ) ` { A } ) /\
    S e. F ) -> ( N i^i S ) =/= (/) ) $=
    ( cfcls co wcel csn cnei cfv w3a cnt cin wss c0 wne syl syl2anc wb fclsopni
    ctop cuni simp1 simp2 eqid neii1 ntrss2 ssrin ntropn fclselbas snssd neiint
    fclstop syl3anc mpbid snssg mpbird simp3 syl13anc ssn0 ) ADCFGHZEAIZDJKKHZB
    CHZLZEDMKKZBNZEBNZOZVHPQZVIPQVFVGEOZVJVFDUBHZEDUCZOZVLVFVBVMVBVDVEUDZACDUNR
    ZVFVMVDVOVQVBVDVEUEZVCDEVNVNUFZUGSZEDVNVSUHSVGEBUIRVFVBVGDHZAVGHZVEVKVPVFVM
    VOWAVQVTEDVNVSUJSVFWBVCVGOZVFVDWCVRVFVMVCVNOVOVDWCTVQVFAVNVFVBAVNHZVPACDVNV
    SUKRZULVTVCDEVNVSUMUOUPVFWDWBWCTWEAVGVNUQRURVBVDVEUSABVGCDUAUTVHVIVAS $.

  ${
    $d n o s A $.  $d n o s x F $.  $d n o s x J $.  $d s x S $.  $d o s x X $.
    $d x U $.
    $( The set of cluster points is a subset of the closure of any filter
       element.  (Contributed by Mario Carneiro, 11-Apr-2015.)  (Revised by
       Stefan O'Rear, 8-Aug-2015.) $)
    fclssscls $p |- ( S e. F -> ( J fClus F ) C_ ( ( cls ` J ) ` S ) ) $=
      ( vx vs wcel cfcls co ccl cv wral ctop cuni cfil eqid isfcls simp3bi wceq
      cfv fveq2 eleq2d rspcv syl5 ssrdv ) ABFZDCBGHZACISZSZDJZUFFZUIEJZUGSZFZEB
      KZUEUIUHFZUJCLFBCMZNSFUNUIBCUPEUPOPQUMUOEABUKARULUHUIUKAUGTUAUBUCUD $.

    $( Cluster points in terms of neighborhoods.  (Contributed by Jeff Hankins,
       11-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclsnei $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) ) ->
      ( A e. ( J fClus F ) <-> ( A e. X /\
        A. n e. ( ( nei ` J ) ` { A } ) A. s e. F ( n i^i s ) =/= (/) ) ) ) $=
      ( vo ctopon cfv wcel cfil wa cfcls cv cin c0 wne wral wceq wi co csn cnei
      cuni eqid fclselbas toponuni adantr syl5ibr fclsneii 3expb ralrimivva a1i
      eleq2d jcad topontop ad3antrrr simprl simprr opnneip syl3anc ineq1 neeq1d
      ctop ralbidv rspcv expr com23 ralrimdva imdistanda fclsopn sylibrd impbid
      syl ) DEHIJZCEKIJZLZADCMUAJZAEJZBNZFNZOZPQZFCRZBAUBDUCIIZRZLZVQVRVSWFVRVS
      VQADUDZJACDWHWHUEUFVQEWHAVOEWHSVPEDUGUHUNUIVRWFTVQVRWCBFWECVRVTWEJWACJWCA
      WACDVTUJUKULUMUOVQWGVSAGNZJZWIWAOZPQZFCRZTZGDRZLVRVQVSWFWOVQVSLZWFWNGDWPW
      IDJZLWJWFWMWPWQWJWFWMTZWPWQWJLZLZWIWEJZWRWTDVDJZWQWJXAVOXBVPVSWSEDUPUQWPW
      QWJURWPWQWJUSADWIUTVAWDWMBWIWEVTWISZWCWLFCXCWBWKPVTWIWAVBVCVEVFVNVGVHVIVJ
      AGCDEFVKVLVM $.

    $( The filter of supersets of ` X \ U ` does not cluster at any point of
       the open set ` U ` .  (Contributed by Mario Carneiro, 11-Apr-2015.)
       (Revised by Mario Carneiro, 26-Aug-2015.) $)
    supnfcls $p |- ( ( J e. ( TopOn ` X ) /\ U e. J /\ A e. U ) ->
      -. A e. ( J fClus { x e. ~P X | ( X \ U ) C_ x } ) ) $=
      ( ctopon cfv wcel w3a cdif cin c0 wceq cv wss cpw crab cfcls co wn wne wa
      disjdif simpr simpl2 simpl3 difss simpl1 toponmax elpw2g 3syl mpbiri ssid
      wb a1i sseq2 elrab sylanbrc fclsopni syl13anc ex necon2bd mpi ) DEFGHZCDH
      ZBCHZIZCECJZKZLMBDVHANZOZAEPZQZRSHZTCEUCVGVNVILVGVNVILUAZVGVNUBZVNVEVFVHV
      MHZVOVGVNUDVDVEVFVNUEVDVEVFVNUFVPVHVLHZVHVHOZVQVPVRVHEOZECUGVPVDEDHVRVTUN
      VDVEVFVNUHEDUIVHEDUJUKULVSVPVHUMUOVKVSAVHVLVJVHVHUPUQURBVHCVMDUSUTVAVBVC
      $.
  $}

  ${
    $d o t A $.  $d o s t B $.  $d o t F $.  $d o t J $.  $d o t X $.
    fclsbas.f $e |- F = ( X filGen B ) $.
    $( Cluster points in terms of filter bases.  (Contributed by Jeff Hankins,
       13-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclsbas $p |- ( ( J e. ( TopOn ` X ) /\ B e. ( fBas ` X ) ) ->
      ( A e. ( J fClus F ) <-> ( A e. X /\
        A. o e. J ( A e. o -> A. s e. B ( o i^i s ) =/= (/) ) ) ) ) $=
      ( vt cfv wcel wa co cv c0 wral wi wb wss syl cfbas cfcls cin wne cfil cfg
      ctopon fgcl adantl syl5eqel fclsopn syldan ssfg ad3antlr syl6sseqr ssralv
      weq ineq2 neeq1d cbvralv syl6ib wrex eleq2i syl5bb simplbda r19.29r sslin
      elfg ssn0 sylan rexlimivw ex ralrimdva anassrs pm5.74da ralbidva pm5.32da
      impbid bitrd ) EFUGJKZBFUAJKZLZAEDUBMKZAFKZACNZKZWEINZUCZOUDZIDPZQZCEPZLZ
      WDWFWEGNZUCZOUDZGBPZQZCEPZLVTWADFUEJZKWCWMRWBDFBUFMZWTHWAXAWTKVTBFUHUIUJA
      CDEFIUKULWBWDWLWSWBWDLZWKWRCEXBWEEKZLWFWJWQXBXCWFWJWQRXBXCWFLZLZWJWQXEWJW
      IIBPZWQXEBDSWJXFQXEBXADWABXASVTWDXDBFUMUNHUOWIIBDUPTWIWPIGBIGUQWHWOOWGWNW
      EURUSUTVAXEWQWIIDXEWGDKZLWNWGSZGBVBZWQWIQXEXGWGFSZXIXGWGXAKZXEXJXILZDXAWG
      HVCWAXKXLRVTWDXDGWGBFVHUNVDVEXIWQWIXIWQLXHWPLZGBVBWIXHWPGBVFXMWIGBXHWOWHS
      WPWIWNWGWEVGWOWHVIVJVKTVLTVMVRVNVOVPVQVS $.
  $}

  ${
    $d o s t u x y z F $.  $d s x G $.  $d o s t u x y z J $.  $d o s x K $.
    $d o s t u x y z X $.  $d s t u x y z Y $.
    $( A finer topology has fewer cluster points.  (Contributed by Jeff
       Hankins, 11-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclsss1 $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) /\ J C_ K ) ->
        ( K fClus F ) C_ ( J fClus F ) ) $=
      ( vx vo vs ctopon cfv wcel cfil cfcls co cv wi wa wral wb fclsopn syl2anc
      wss w3a cin c0 simpl3 ssralv anim2d simpl2 fclstopon adantl mpbird simpl1
      wne syl 3imtr4d ex pm2.43d ssrdv ) BDHIZJZADKIJZBCUAZUBZECALMZBALMZVCENZV
      DJZVFVEJZVCVGVGVHOVCVGPZVFDJZVFFNZJVKGNUCUDUMGAQOZFCQZPZVJVLFBQZPZVGVHVIV
      BVNVPOUTVAVBVGUEVBVMVOVJVLFBCUFUGUNVICUSJZVAVGVNRVIVQVAUTVAVBVGUHZVGVQVAR
      VCVFACDUIUJUKVRVFFACDGSTVIUTVAVHVPRUTVAVBVGULVRVFFABDGSTUOUPUQUR $.

    $( A finer filter has fewer cluster points.  (Contributed by Jeff Hankins,
       11-Nov-2009.)  (Revised by Mario Carneiro, 26-Aug-2015.) $)
    fclsss2 $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) /\ F C_ G ) ->
        ( J fClus G ) C_ ( J fClus F ) ) $=
      ( vx vs ctopon cfv wcel cfil wss w3a cfcls co cv wi wral isfcls2 syl2anc
      wb wa ccl simpl3 ssralv syl simpl1 fclstopon adantl mpbid 3imtr4d pm2.43d
      simpl2 ex ssrdv ) CDGHIZADJHZIZABKZLZECBMNZCAMNZUSEOZUTIZVBVAIZUSVCVCVDPU
      SVCUAZVBFOCUBHHIZFBQZVFFAQZVCVDVEURVGVHPUOUQURVCUCVFFABUDUEVEUOBUPIZVCVGT
      UOUQURVCUFZVEUOVIVJVCUOVITUSVBBCDUGUHUIVBBCDFRSVEUOUQVDVHTVJUOUQURVCULVBA
      CDFRSUJUMUKUN $.

    $( The set of cluster points in a restricted topological space.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    fclsrest $p |- ( ( J e. ( TopOn ` X ) /\ F e. ( Fil ` X ) /\ Y e. F ) ->
        ( ( J |`t Y ) fClus ( F |`t Y ) ) = ( ( J fClus F ) i^i Y ) ) $=
      ( vy vz vu vs vt cfv wcel co cin cv wa c0 wne wral wb wceq vx ctopon cfil
      w3a crest cfcls wi wss simp1 filelss 3adant1 resttopon syl2anc cdif cfbas
      wn filfbas 3ad2ant2 simp3 fbncp simp2 trfil3 mpbird fclsopn syl5eq neeq1d
      in32 ineq2 rspccv inss1 ssrin ax-mp ssn0 mpan syl6 ralrimiv simpr syl3anc
      ad3antrrr filin inass syl6eqr rspcv syl ralrimdva impbid2 imbi2d ralbidva
      cvv vex inex1 a1i wrex elrest 3adant2 adantr eleq2 rbaib adantl sylan9bbr
      elin ralxfr2d ineq1 inindir ralbidv sylan9bb imbi12d sselda baibd 3bitr4d
      syl21anc pm5.32da bitrd ancom bitri syl6bbr eqrdv ) BCUBJZKZACUCJZKZDAKZU
      DZUABDUELZADUELZUFLZBAUFLZDMZYCUANZYFKZYIDKZYIYGKZOZYIYHKZYCYJYKYIENZKZYO
      FNZMZPQZFYERZUGZEYDRZOZYMYCYDDUBJKZYEDUCJKZYJUUCSYCXSDCUHZUUDXSYAYBUIZYAY
      BUUFXSDACUJUKZDBCULUMYCUUECDUNAKUPZYCACUOJKZYBUUIYAXSUUJYBACUQURXSYAYBUSZ
      DCACUTUMYCYAUUFUUEUUISXSYAYBVAZUUHDACVBUMVCYIEYEYDDFVDUMYCYKUUBYLYCYKOZYI
      GNZKZUUNHNZMDMZPQZHARZUGZGBRUUOUUNINZMZPQZIARZUGZGBRZUUBYLUUMUUTUVEGBUUMU
      UNBKZOZUUSUVDUUOUVHUUSUVDUUSUVCIAUUSUVAAKUUNDMZUVAMZPQZUVCUURUVKHUVAAUUPU
      VATZUUQUVJPUVLUUQUVIUUPMUVJUUNUUPDVGUUPUVAUVIVHVEVFVIUVJUVBUHZUVKUVCUVIUU
      NUHUVMUUNDVJUVIUUNUVAVKVLUVJUVBVMVNVOVPUVHUVDUURHAUVHUUPAKZOZUUPDMZAKZUVD
      UURUGUVOYAUVNYBUVQYCYAYKUVGUVNUULVSUVHUVNVQYCYBYKUVGUVNUUKVSUUPDACVTVRUVC
      UURIUVPAUVAUVPTZUVBUUQPUVRUVBUUNUVPMUUQUVAUVPUUNVHUUNUUPDWAWBVFWCWDWEWFWG
      WHUUMUUAUUTEGUVIYDBWIUVIWIKUVHUUNDGWJWKWLYCYOYDKYOUVITZGBWMSZYKXSYBUVTYAG
      YODBXRAWNWOWPUUMUVSOYPUUOYTUUSUVSYPYIUVIKZUUMUUOYOUVIYIWQYKUWAUUOSYCUWAUU
      OYKYIUUNDXAWRWSWTUUMYTYOUVPMZPQZHARUVSUUSUUMYSUWCFHUVPYEAWIUVPWIKUUMUVNOU
      UPDHWJWKWLYCYQYEKYQUVPTZHAWMSZYKYAYBUWEXSHYQDAXTAWNUKWPUUMUWDOYRUWBPUWDYR
      UWBTUUMYQUVPYOVHWSVFXBUVSUWCUURHAUVSUWBUUQPUVSUWBUVIUVPMUUQYOUVIUVPXCUUNU
      UPDXDWBVFXEXFXGXBUUMXSYAYICKZYLUVFSYCXSYKUUGWPYCYAYKUULWPYCDCYIUUHXHXSYAO
      YLUWFUVFYIGABCIVDXIXKXJXLXMYNYLYKOYMYIYGDXAYLYKXNXOXPXQ $.
  $}

  ${
    $d f n u x y J $.  $d f n u x y K $.  $d f n u x y X $.  $d f n u x y Y $.
    $( Characterization of fineness of topologies in terms of cluster points.
       (Contributed by Jeff Hankins, 12-Nov-2009.)  (Revised by Stefan O'Rear,
       8-Aug-2015.) $)
    fclscf $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` X ) ) ->
      ( J C_ K <-> A. f e. ( Fil ` X ) ( K fClus f ) C_ ( J fClus f ) ) ) $=
      ( vy vu vn wcel wa wss cv cfcls co wral wrex wi wceq wne c0 wn ctopon cfv
      vx cfil simpll simplr wb fclstopon ad2antll simprl fclsss1 syl3anc simprr
      mpbid sseldd expr ssrdv ralrimivw simpllr ssid eleq2 sseq1 anbi12d rspcev
      toponmax mpanr2 3syl sseq2 anbi2d rexbidv imbi12d syl5ibrcom cin cdif cpw
      crab simplll simprrr supnfcls syl difssd toponss syl2anc simprrl pssdifn0
      ex supfil fclsopn biantrurd bitr4d oveq2 sseq12d rspcv sylc sseld sylbird
      rexanali rexnal elrab simprbi sslin necon1bd inssdif0 syl6ibr sylan df-ss
      mtod ssn0 sylib sseq1d biimpd syl9r syl5 rexlimdv syl5bir anim2d reximdva
      mpd anassrs exp32 pm2.61dne ralrimiv ctop topontop eltop2 mpbird impbida
      ) BDUAUBZHZCYHHZIZBCJZCAKZLMZBYMLMZJZADUDUBZNZYKYLIZYPAYQYSUCYNYOYKYLUCKZ
      YNHZYTYOHYKYLUUAIZIZYNYOYTUUCYIYMYQHZYLYPYIYJUUBUEUUCYJUUDYIYJUUBUFUUAYJU
      UDUGYKYLYTYMCDUHUIUNYKYLUUAUJYMBCDUKULYKYLUUAUMUOUPUQURYKYRIZUCBCUUEYTBHZ
      YTCHZUUEUUFIZUUGEKZFKZHZUUJYTJZIZFCOZEYTNZUUHUUNEYTUUHUUIYTHZUUNPZYTDUUHU
      UQYTDQZUUIDHZUUKUUJDJZIZFCOZPZUUHYJDCHZUVCYIYJYRUUFUSZDCVEUVDUUSUVBUVDUUS
      DDJZUVBDUTUVAUUSUVFIFDCUUJDQUUKUUSUUTUVFUUJDUUIVAUUJDDVBVCVDVFWFVGUURUUPU
      USUUNUVBYTDUUIVAUURUUMUVAFCUURUULUUTUUKYTDUUJVHVIVJVKVLUUHYTDRZUUPUUNUUEU
      UFUVGUUPIZUUNUUEUUFUVHIZIZUUKUUJGKZVMZSRZGDYTVNZUUIJZEDVOZVPZNZPFCNZTZUUN
      UVJUVSUUIBUVQLMZHZUVJYIUUFUUPUWBTYIYJYRUVIVQZUUEUUFUVHUJZUUEUUFUVGUUPVRZE
      UUIYTBDVSULUVJUVSUUICUVQLMZHZUWBUVJUWGUUSUVSIZUVSUVJYJUVQYQHZUWGUWHUGYIYJ
      YRUVIUSZUVJDBHZUVNDJUVNSRZUWIUVJYIUWKUWCDBVEVTUVJDYTWAUVJYTDJZUVGUWLUVJYI
      UUFUWMUWCUWDYTBDWBWCZUUEUUFUVGUUPWDYTDWEWCEDUVNBWGULZUUIFUVQCDGWHWCUVJUUS
      UVSUVJYTDUUIUWNUWEUOWIWJUVJUWFUWAUUIUVJUWIYRUWFUWAJZUWOYKYRUVIUFYPUWPAUVQ
      YQYMUVQQYNUWFYOUWAYMUVQCLWKYMUVQBLWKWLWMWNWOWPXGUVTUUKUVRTZIZFCOUVJUUNUUK
      UVRFCWQUVJUWRUUMFCUVJUUJCHZIZUWQUULUUKUWQUVMTZGUVQOUWTUULUVMGUVQWRUWTUXAU
      ULGUVQUVKUVQHZUUJUVNVMZUVLJZUWTUXAUULPUXBUVNUVKJZUXDUXBUVKUVPHUXEUVOUXEEU
      VKUVPUUIUVKUVNVHWSWTUVNUVKUUJXAVTUXDUXAUUJDVMZYTJZUWTUULUXDUXAUXCSQUXGUXD
      UVMUXCSUXDUXCSRUVMUXCUVLXHWFXBUUJDYTXCXDUWTUXGUULUWTUXFUUJYTUWTUUTUXFUUJQ
      UVJYJUWSUUTUWJUUJCDWBXEUUJDXFXIXJXKXLXMXNXOXPXQXOXRXSXTYAYBUUHYJCYCHUUGUU
      OUGUVEDCYDEFYTCYEVGYFWFUQYG $.
  $}

  ${
    $d a x F $.  $d a x J $.
    $( A limit point is a cluster point.  (Contributed by Jeff Hankins,
       12-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    flimfcls $p |- ( J fLim F ) C_ ( J fClus F ) $=
      ( va vx cflim cfcls wcel ctop cuni cfil cfv ccl wral flimtop eqid flimfil
      co cv flimclsi sseld com12 ralrimiv isfcls syl3anbrc ssriv ) CBAEQZBAFQZC
      RZUFGZBHGABIZJKGUHDRZBLKKZGZDAMUHUGGUHABNUHABUJUJOZPUIUMDAUKAGZUIUMUOUFUL
      UHUKABSTUAUBUHABUJDUNUCUDUE $.
  $}

  ${
    $d g o x y z A $.  $d g o x y z F $.  $d g o x y z J $.  $d g o x y z X $.
    $d g o x y z Y $.
    $( A filter clusters at a point iff a finer filter converges to it.
       (Contributed by Jeff Hankins, 12-Nov-2009.)  (Revised by Mario Carneiro,
       26-Aug-2015.) $)
    fclsfnflim $p |- ( F e. ( Fil ` X ) -> ( A e. ( J fClus F ) <->
          E. g e. ( Fil ` X ) ( F C_ g /\ A e. ( J fLim g ) ) ) ) $=
      ( vx vy cfv wcel co cv wss cflim wa c0 wne adantr syl wb cvv cfil csn cun
      cfcls wrex cnei cfi cfg cfbas wn filsspw cuni ctop fclstop adantl neisspw
      cpw eqid filunibas wceq fclsfil sylan9req pweqd sseqtr4d unssd ssun1 ssn0
      filn0 sylancr cin wral incom fclsneii syl5eqner 3com23 adantll ralrimivva
      w3a 3expb filfbas ctopon istopon sylanbrc fclselbas eleqtrrd snssd neifil
      snnzg syl3anc fbunfip syl2anc mpbird filtop fsubbas mpbir3and unexg mpan2
      fgcl fvex ssfii unssad sstrd unssbd elflim mpbir2and sseq2 eleq2d anbi12d
      ssfg oveq2 rspcev syl12anc simprl simprrr flimtopon simpl simprrl fclsss2
      ex flimfcls sseldi sseldd rexlimdvaa impbid ) CEUAHZIZADCUDJZIZCBKZLZADYI
      MJZIZNZBYEUEZYFYHYNYFYHNZECAUBZDUFHZHZUCZUGHZUHJZYEIZCUUALZADUUAMJZIZYNYO
      YTEUIHZIZUUBYOUUGYSEUQZLZYSOPZOYTIUJZYOCYRUUHYFCUUHLYHCEUKQYOYRDULZUQZUUH
      YODUMIZYRUUMLYHUUNYFACDUNUOZYPDUULUULURZUPRYOEUULYFYHECULZUULCEUSYHCUULUA
      HIUUQUULUTACDUULUUPVACUULUSRVBZVCVDVEYFUUJYHYFCYSLCOPUUJCYRVFCEVHCYSVGVIQ
      YOUUKFKZGKZVJZOPZGYRVKFCVKZYOUVBFGCYRYHUUSCIZUUTYRIZNUVBYFYHUVDUVEUVBYHUV
      EUVDUVBYHUVEUVDVRUVAUUTUUSVJOUUTUUSVLAUUSCDUUTVMVNVOVSVPVQYOCUUFIZYRUUFIZ
      UUKUVCSYFUVFYHCEVTQYOYRYEIZUVGYODEWAHIZYPELYPOPZUVHYOUUNEUULUTUVIUUOUURED
      WBWCZYOAEYOAUULEYHAUULIYFACDUULUUPWDUOUURWEZWFYHUVJYFAYGWHUOYPDEWGWIYREVT
      RFGCYREEWJWKWLYFUUGUUIUUJUUKVRSZYHYFECIUVMCEWMYSCEWNRQWOZYTEWRRZYOCYTUUAY
      OCYRYTYFYSYTLZYHYFYSTIZUVPYFYRTIUVQYPYQWSCYRYETWPWQYSTWTRQZXAYOUUGYTUUALU
      VNYTEXIRZXBYOUUEAEIZYRUUALZUVLYOYRYTUUAYOCYRYTUVRXCUVSXBYOUVIUUBUUEUVTUWA
      NSUVKUVOAUUADEXDWKXEYMUUCUUENBUUAYEYIUUAUTZYJUUCYLUUEYIUUACXFUWBYKUUDAYIU
      UADMXJXGXHXKXLXSYFYMYHBYEYFYIYEIZYMNZNZDYIUDJZYGAUWEUVIYFYJUWFYGLUWEUVIUW
      CYFUWCYMXMUWEYLUVIUWCSYFUWCYJYLXNZAYIDEXORWLYFUWDXPYFUWCYJYLXQCYIDEXRWIUW
      EYKUWFAYIDXTUWGYAYBYCYD $.

    flimfnfcls.x $e |- X = U. J $.
    $( A filter converges to a point iff every finer filter clusters there.
       Along with ~ fclsfnflim , this theorem illustrates the duality between
       convergence and clustering.  (Contributed by Jeff Hankins,
       12-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    flimfnfcls $p |- ( F e. ( Fil ` X ) -> ( A e. ( J fLim F ) <->
          A. g e. ( Fil ` X ) ( F C_ g -> A e. ( J fClus g ) ) ) ) $=
      ( vx wcel co cv wss cfcls wi wa wceq syl c0 wne cvv syl2anc vo vy vz cfil
      cfv cflim wral flimfcls ctopon ctop flimtop toptopon sylib ad2antrr simpr
      simplr flimss2 syl3anc simpll sseldd sseldi ralrimiva sseq2 oveq2 imbi12d
      ex eleq2d rspcv ssid id mpi fclstop fclselbas jca syl6 wn cin disjdif cpw
      cdif crab cun cfi cfg simplrl topopn pwexg 3syl unexg ssfii cfbas filsspw
      rabexg ssrab2 a1i unssd ssun2 difss wb elpw2g elrab sylanbrc ne0i simprbi
      mpbiri ad2antll sslin simprrr adantr inssdif0 simplll simprl df-ss sseq1d
      filelss elssuni syl6sseqr ad2antrl filss syl13anc sylbid syl5bir necon3bd
      cuni mpd ssn0 ralrimivva filfbas filtop eleq1 syl5ibrcom pssdifn0 fbunfip
      supfil mpbird w3a fsubbas mpbir3and ssfg com23 sstrd unssad fgcl fclsopni
      mpid simprrl syld necon2bd anassrs expr con4d simprr jctild simpl flimopn
      ralrimdva sylibrd mpdd impbid2 ) CEUDUEZHZADCUFIZHZCBJZKZADUVDLIZHZMZBUUT
      UGZUVCUVHBUUTUVCUVDUUTHZNZUVEUVGUVKUVENZDUVDUFIZUVFAUVDDUHUVLUVBUVMAUVLDE
      UIUEHZUVJUVEUVBUVMKUVCUVNUVJUVEUVCDUJHZUVNACDUKDEFULZUMUNUVCUVJUVEUPUVKUV
      EUOUVDCDEUQURUVCUVJUVEUSUTVAVFVBUVAUVIUVOAEHZNZUVCUVAUVICCKZADCLIZHZMZUVR
      UVHUWBBCUUTUVDCOZUVEUVSUVGUWAUVDCCVCUWCUVFUVTAUVDCDLVDVGVEVHUWBUWAUVRUWBU
      VSUWACVIUWBVJVKUWAUVOUVQACDVLACDEFVMVNPVOUVAUVRUVIUVCUVAUVRUVIUVCMUVAUVRN
      ZUVIUVQAUAJZHZUWECHZMZUADUGZNZUVCUWDUVIUWIUVQUWDUVIUWHUADUWDUWEDHZNZUWFUV
      IUWGUWLUWFUVIUWGMUWLUWFNUWGUVIUWLUWFUWGVPZUVIVPZUWDUWKUWFUWMNZUWNUWDUWKUW
      ONZNZUWEEUWEVTZVQZQOUWNUWEEVRUWQUVIUWSQUWQUVIADECUWRGJZKZGEVSZWAZWBZWCUEZ
      WDIZLIZHZUWSQRZUWQUVICUXFKZUXHUWQCUXCUXFUWQUXDUXEUXFUWQUXDSHZUXDUXEKUWQUV
      AUXCSHZUXKUVAUVRUWPUSZUWQEDHZUXBSHUXLUWQUVOUXNUVAUVOUVQUWPWEDEFWFPZEDWGUX
      AGUXBSWMWHCUXCUUTSWITUXDSWJPUWQUXEEWKUEZHZUXEUXFKUWQUXQUXDUXBKZUXDQRZQUXE
      HVPZUVAUXRUVRUWPUVACUXCUXBCEWLUXCUXBKUVAUXAGUXBWNWOWPUNUWQUWRUXDHUXSUWQUX
      CUXDUWRUXCCWQUWQUWRUXBHZUWRUWRKZUWRUXCHUWQUYAUWREKZEUWEWRZUWQUXNUYAUYCWSU
      XOUWREDWTPXEUYBUWQUWRVIWOUXAUYBGUWRUXBUWTUWRUWRVCXAXBVAZUXDUWRXCPUWQUXTUB
      JZUCJZVQZQRZUCUXCUGUBCUGZUWQUYIUBUCCUXCUWQUYFCHZUYGUXCHZNZNZUYFUWRVQZUYHK
      ZUYOQRZUYIUYNUWRUYGKZUYPUYLUYRUWQUYKUYLUYGUXBHUYRUXAUYRGUYGUXBUWTUYGUWRVC
      XAXDXFUWRUYGUYFXGPUYNUWMUYQUWQUWMUYMUWDUWKUWFUWMXHZXIUYNUWGUYOQUYOQOUYFEV
      QZUWEKZUYNUWGUYFEUWEXJUYNVUAUYFUWEKZUWGUYNUYTUYFUWEUYNUYFEKZUYTUYFOUYNUVA
      UYKVUCUVAUVRUWPUYMXKUWQUYKUYLXLUYFCEXOTUYFEXMUMXNUYNVUBUWGUYNVUBNUVAUYKUW
      EEKZVUBUWGUWQUVAUYMVUBUXMUNUWQUYKUYLVUBWEUWQVUDUYMVUBUWKVUDUWDUWOUWKUWEDY
      DEUWEDXPFXQXRZUNUYNVUBUOUYFUWECEXSXTVFYAYBYCYEUYOUYHYFTYGUWQCUXPHZUXCUXPH
      ZUXTUYJWSUWQUVAVUFUXMCEYHPUWQUXCUUTHZVUGUWQUXNUYCUWRQRZVUHUXOUYCUWQUYDWOU
      WQVUDUWEERZVUIVUEUWQUWMVUJUYSUWQUWGUWEEUWQUWGUWEEOECHZUWQUVAVUKUXMCEYIPZU
      WEECYJYKYCYEUWEEYLTGEUWRDYNURUXCEYHPUBUCCUXCEEYMTYOUWQVUKUXQUXRUXSUXTYPWS
      VULUXDCEYQPYRZUXEEYSPUUAZUUBUWQUXFUUTHZUVIUXJUXHMZMUWQUXQVUOVUMUXEEUUCPUV
      HVUPBUXFUUTUVDUXFOZUVEUXJUVGUXHUVDUXFCVCVUQUVFUXGAUVDUXFDLVDVGVEVHPUUEUWQ
      UXHUXIUWQUXHNUXHUWKUWFUWRUXFHZUXIUWQUXHUOUWDUWKUWOUXHWEUWQUWFUXHUWDUWKUWF
      UWMUUFXIUWQVURUXHUWQUXDUXFUWRVUNUYEUTXIAUWRUWEUXFDUUDXTVFUUGUUHVKUUIUUJUU
      KVFYTUUPUVAUVOUVQUULUUMUWDUVNUVAUVCUWJWSUWDUVOUVNUVAUVOUVQXLUVPUMUVAUVRUU
      NUAACDEUUOTUUQVFYTUURUUS $.

    $( Forward direction of ~ fclscmp .  Every filter clusters in a compact
       space.  (Contributed by Mario Carneiro, 11-Apr-2015.)  (Revised by
       Stefan O'Rear, 8-Aug-2015.) $)
    fclscmpi $p |- ( ( J e. Comp /\ F e. ( Fil ` X ) ) ->
        ( J fClus F ) =/= (/) ) $=
      ( vx wcel cfv wa c0 wceq eqid syl6eq wss cfi wn adantr syl syl2anc fmptd
      wf ccmp cfil cfcls co cv ccl cmpt crn cint ciin cmptop cif fclsval iftrue
      ctop ax-mp sylan fvex dfiin3 ccld wne simpl filelss adantll clscld clsss3
      frn simpr sscls filss syl13anc fiss filfi sseqtrd 0nelfil ssneldd syl3anc
      cmpfii eqnetrd ) BUAFZACUBGZFZHZBAUCUDZEAEUEZBUFGZGZUGZUHZUIZIWCWDEAWGUJZ
      WJVTBUOFZWBWDWKJBUKZWLWBHWDCCJZWKIULZWKEABCCDUMWNWOWKJCKWNWKIUNUPLUQEAWGW
      EWFURUSLWCVTWIBUTGZMZIWINGZFOWJIVAVTWBVBZWCAWPWHTWQWCEAWGWPWHWCWEAFZHZWLW
      ECMZWGWPFXAVTWLWCVTWTWSPWMQZWBWTXBVTWEACVCVDZWEBCDVERWHKZSAWPWHVGQWCWRAIW
      CWRANGZAWCWBWIAMZWRXFMVTWBVHZWCAAWHTXGWCEAWGAWHXAWBWTWGCMZWEWGMZWGAFWCWBW
      TXHPWCWTVHXAWLXBXIXCXDWEBCDVFRXAWLXBXJXCXDWEBCDVIRWEWGACVJVKXESAAWHVGQWIA
      WAVLRWCWBXFAJXHACVMQVNWCWBIAFOXHACVOQVPBWIVRVQVS $.
  $}

  ${
    $d n o x A $.  $d f g j n o s x y J $.  $d f g j n o s x L $.  $d n s N $.
    $d f g n o s x F $.  $d f g j n o s x y X $.  $d f g j n o s x Y $.
    $d s S $.
    $( A space is compact iff every filter clusters.  (Contributed by Jeff
       Hankins, 20-Nov-2009.)  (Revised by Stefan O'Rear, 8-Aug-2015.) $)
    fclscmp $p |- ( J e. ( TopOn ` X ) -> ( J e. Comp <->
          A. f e. ( Fil ` X ) ( J fClus f ) =/= (/) ) ) $=
      ( vx vy cfv wcel cv cfcls co c0 wne cfil wral wi wa wss wceq cvv syl ccmp
      ctopon cuni eqid fclscmpi ralrimiva toponuni fveq2d raleqdv cfi cint ccld
      syl5ibr wn cpw elpwi vn0 inteqd int0 syl6eq neeq1d mpbiri a1d cfg ccl vex
      simpr ssfii ax-mp cfbas simplrl cldss2 ad2antrr pweqd syl5sseqr sstrd w3a
      simplrr wb toponmax fsubbas mpbir3and ssfg syl5ss sselda fclssscls cldcls
      sseqtrd ssint sylibr fgcl oveq2 rspcv 3syl ee12an pm2.61dane sylan2 com23
      ssn0 expr ralrimdva ctop topontop cmpfi sylibrd impbid ) BCUBFGZBUAGZBAHZ
      IJZKLZACMFZNZXHXMXGXKABUCZMFZNXHXKAXOXIBXNXNUDZUEUFXGXKAXLXOXGCXNMCBUGZUH
      UIUMXGXMKDHZUJFZGUNZXRUKZKLZOZDBULFZUOZNZXHXGXMYCDYEXGXRYEGZPXTXMYBYGXGXR
      YDQZXTXMYBOZOXRYDUPXGYHXTYIXGYHXTPZPZYIXRKYKXRKRZPZYBXMYMYBSKLUQYMYASKYMY
      AKUKSYMXRKYKYLVGURUSUTVAVBVCYKXRKLZPZBCXSVDJZIJZYAQZXMYQKLZYBYOYQEHZQZEXR
      NYRYOUUAEXRYOYTXRGPZYQYTBVEFFZYTUUBYTYPGYQUUCQYOXRYPYTYOXRXSYPXRSGXRXSQDV
      FXRSVHVIYOXSCVJFGZXSYPQYOUUDXRCUOZQZYNXTYOXRYDUUEXGYHXTYNVKZYOXNUOYDUUEBX
      NXPVLYOCXNXGCXNRYJYNXQVMVNVOVPYKYNVGXGYHXTYNVRYOCBGZUUDUUFYNXTVQVSXGUUHYJ
      YNCBVTVMXRBCWATWBZXSCWCTWDWEYTYPBWFTUUBYTYDGUUCYTRYOXRYDYTUUGWEYTBWGTWHUF
      EYQXRWIWJYOUUDYPXLGXMYSOUUIXSCWKXKYSAYPXLXIYPRXJYQKXIYPBIWLVAWMWNYQYAWSWO
      WPWTWQWRXAXGBXBGXHYFVSCBXCDBXDTXEXF $.

    $( The cluster points of an ultrafilter are its limit points.  (Contributed
       by Jeff Hankins, 11-Dec-2009.)  (Revised by Mario Carneiro,
       26-Aug-2015.) $)
    uffclsflim $p |- ( F e. ( UFil ` X ) -> ( J fClus F ) = ( J fLim F ) ) $=
      ( vx vf cufil cfv wcel cfcls co cflim cv wss cfil wrex ufilfil fclsfnflim
      wa wb syl biimpa simprrr simpll simprl simprrl ufilmax eleqtrrd rexlimddv
      wceq syl3anc oveq2d ex ssrdv flimfcls a1i eqssd ) ACFGHZBAIJZBAKJZUQDURUS
      UQDLZURHZUTUSHZUQVARZAELZMZUTBVDKJZHZRZVBECNGZUQVAVHEVIOZUQAVIHVAVJSACPUT
      EABCQTUAVCVDVIHZVHRZRZUTVFUSVCVKVEVGUBVMAVDBKVMUQVKVEAVDUIUQVAVLUCVCVKVHU
      DVCVKVEVGUEAVDCUFUJUKUGUHULUMUSURMUQABUNUOUP $.

    $( A space is compact iff every ultrafilter converges.  (Contributed by
       Jeff Hankins, 11-Dec-2009.)  (Proof shortened by Mario Carneiro,
       12-Apr-2015.)  (Revised by Mario Carneiro, 26-Aug-2015.) $)
    ufilcmp $p |- ( ( X e. UFL /\ J e. ( TopOn ` X ) ) -> ( J e. Comp <->
        A. f e. ( UFil ` X ) ( J fLim f ) =/= (/) ) ) $=
      ( vg cufl wcel cfv wa cv cfcls co c0 wne cufil wral cfil adantl wss wrex
      wb ctopon ccmp cflim cuni ufilfil eqid fclscmpi sylan2 ralrimiva toponuni
      fveq2d raleqdv syl5ibr ufli adantlr r19.29 simpllr simplr fclsss2 syl3anc
      wi simprr ssn0 ex syl expr com23 imp3a rexlimdva mpan2d ralrimdva fclscmp
      syl5 sylibrd impbid uffclsflim neeq1d ralbiia syl6bb ) CEFZBCUAGFZHZBUBFZ
      BAIZJKZLMZACNGZOZBWDUCKZLMZAWGOWBWCWHWCWHWBWFABUDZNGZOZWCWFAWLWDWLFWCWDWK
      PGFWFWDWKUEWDBWKWKUFUGUHUIWAWHWMTVTWAWFAWGWLWACWKNCBUJUKULQUMWBWHBDIZJKZL
      MZDCPGZOZWCWBWHWPDWQWBWNWQFZHZWHWNWDRZAWGSZWPVTWSXBWAAWNCUNUOWHXBHWFXAHZA
      WGSWTWPWFXAAWGUPWTXCWPAWGWTWDWGFZHZWFXAWPXEXAWFWPWTXDXAWFWPVAZWTXDXAHZHZW
      EWORZXFXHWAWSXAXIVTWAWSXGUQWBWSXGURWTXDXAVBWNWDBCUSUTXIWFWPWEWOVCVDVEVFVG
      VHVIVMVJVKWAWCWRTVTDBCVLQVNVOWFWJAWGXDWEWILWDBCVPVQVRVS $.

    $( The set of cluster points of a function.  (Contributed by Jeff Hankins,
       24-Nov-2009.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    fcfval $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( ( J fClusf L ) ` F ) = ( J fClus ( ( X FilMap F ) ` L ) ) ) $=
      ( vg vj vf cfv wcel cfil cv cfm co cfcls cmap cvv wceq wa cuni ctopon w3a
      wf cfcf cmpt ctop crn cmpt2 df-fcf simprl unieqd toponuni ad2antrr eqtr4d
      a1i unieq ad2antll filunibas ad2antlr eqtrd oveq12d oveq1d simprr fveq12d
      mpteq12dv topontop adantr fvssunirn sseli adantl ovex mptex ovmpt2d simpr
      3adant3 oveq2d fveq1d wb toponmax filtop elmapg syl2an biimp3ar fvmptd )
      BDUAIJZCEKIZJZEDAUCZUBZFABCDFLZMNZIZONZBCDAMNZIZONZDEPNZBCUDNZQWEWGWRFWQW
      MUEZRWHWEWGSZGHBCUFKUGTZFGLZTZHLZTZPNZXBXDXCWJMNZIZONZUEZWSUDQUDGHUFXAXJU
      HRWTHFGUIUOWTXBBRZXDCRZSZSZFXFXIWQWMXNXCDXEEPXNXCBTZDXNXBBWTXKXLUJZUKWEDX
      ORWGXMDBULUMUNZXNXECTZEXLXEXRRWTXKXDCUPUQWGXRERWEXMCEURUSUTVAXNXBBXHWLOXP
      XNXDCXGWKXNXCDWJMXQVBWTXKXLVCVDVAVEWEBUFJWGDBVFVGWGCXAJWEWFXACKEVHVIVJWSQ
      JWTFWQWMDEPVKVLUOVMVOWIWJARZSZWLWOBOXTCWKWNXTWJADMWIXSVNVPVQVPWEWGAWQJZWH
      WEDBJECJYAWHVRWGDBVSCEVTDEABCWAWBWCWPQJWIBWOOVKUOWD $.

    $( The property of being a cluster point of a function.  (Contributed by
       Jeff Hankins, 24-Nov-2009.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    isfcf $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( A e. ( ( J fClusf L ) ` F ) <-> ( A e. X /\
        A. o e. J ( A e. o -> A. s e. L ( o i^i ( F " s ) ) =/= (/) ) ) ) ) $=
      ( vx cfv wcel cfil co cv c0 wral wi wa syl wss ctopon wf w3a cfcf cfm cin
      cfcls wne cima fcfval eleq2d wb simp1 cfbas toponmax filfbas fmfil syl3an
      id fclsopn syl2anc simpll1 simpll2 simpll3 wceq simpl2 fgfil biimpar eqid
      cfg imaelfm syl31anc ineq2 neeq1d rspcv ralrimdva adantr simplbda r19.29r
      wrex elfm sslin ssn0 sylan rexlimivw impbid imbi2d ralbidva anbi2d 3bitrd
      ex ) DFUAJKZEGLJKZGFCUBZUCZACDEUDMJZKADEFCUEMJZUGMZKZAFKZABNZKZXAINZUFZOU
      HZIWQPZQZBDPZRZWTXBXACHNZUIZUFZOUHZHEPZQZBDPZRWOWPWRACDEFGUJUKWOWLWQFLJKZ
      WSXIULWLWMWNUMWLFDKZWMEGUNJKZWNWNXQFDUOZEGUPZWNUSZDECFGUQURABWQDFIUTVAWOX
      HXPWTWOXGXOBDWOXADKZRZXFXNXBYDXFXNYDXFXMHEYDXJEKZRZXKWQKZXFXMQYFXRXSWNXJG
      EVJMZKZYGYFWLXRWLWMWNYCYEVBXTSYFWMXSWLWMWNYCYEVCYASWLWMWNYCYEVDYDYIYEYDYH
      EXJYDWMYHEVEWLWMWNYCVFEGVGSUKVHDEXJCYHFGYHVIVKVLXEXMIXKWQXCXKVEXDXLOXCXKX
      AVMVNVOSVPYDXNXEIWQYDXCWQKZRXKXCTZHEVTZXNXEQYDYJXCFTZYLWOYJYMYLRULZYCWLXR
      WMXSWNWNYNXTYAYBHXCEDCFGWAURVQVRYLXNXEYLXNRYKXMRZHEVTXEYKXMHEVSYOXEHEYKXL
      XDTXMXEXKXCXAWBXLXDWCWDWESWKSVPWFWGWHWIWJ $.

    $( The property of being a cluster point of a function in terms of
       neighborhoods.  (Contributed by Jeff Hankins, 26-Nov-2009.)  (Revised by
       Stefan O'Rear, 9-Aug-2015.) $)
    fcfnei $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
      ( A e. ( ( J fClusf L ) ` F ) <-> ( A e. X /\ A. n e.
        ( ( nei ` J ) ` { A } ) A. s e. L ( n i^i ( F " s ) ) =/= (/) ) ) ) $=
      ( vo cfv wcel cv cin c0 wne wral wi wa wss syl ctopon cfil wf w3a cfcf co
      cima csn cnei isfcf ctop cuni simpll1 topontop simpr neii1 syl2anc ntrss2
      cnt eqid wb simplr wceq toponuni eleqtrd snssd neiint syl3anc mpbid snssg
      mpbird ntropn eleq2 ineq1 neeq1d ralbidv imbi12d rspcv mpid ssrin ssn0 ex
      ralimdv sylsyld ralrimdva simpl1 opnneip 3expb sylan expr impbid pm5.32da
      com23 bitrd ) DFUAJKZEGUBJKZGFCUCZUDZACDEUEUFJKAFKZAILZKZWTCHLUGZMZNOZHEP
      ZQZIDPZRWSBLZXBMZNOZHEPZBAUHZDUIJJZPZRAICDEFGHUJWRWSXGXNWRWSRZXGXNXOXGXKB
      XMXOXHXMKZRZXHDUSJJZXHSZXGXRXBMZNOZHEPZXKXQDUKKZXHDULZSZXSXQWOYCWOWPWQWSX
      PUMZFDUNZTZXQYCXPYEYHXOXPUOZXLDXHYDYDUTZUPUQZXHDYDYJURUQXQXGAXRKZYBXQYLXL
      XRSZXQXPYMYIXQYCXLYDSYEXPYMVAYHXQAYDXQAFYDWRWSXPVBZXQWOFYDVCYFFDVDTVEVFYK
      XLDXHYDYJVGVHVIXQWSYLYMVAYNAXRFVJTVKXQXRDKZXGYLYBQZQXQYCYEYOYHYKXHDYDYJVL
      UQXFYPIXRDWTXRVCZXAYLXEYBWTXRAVMYQXDYAHEYQXCXTNWTXRXBVNVOVPVQVRTVSXSYAXJH
      EXSXTXISZYAXJQXRXHXBVTYRYAXJXTXIWAWBTWCWDWEXOXNXFIDXOWTDKZRXAXNXEXOYSXAXN
      XEQZXOYSXARZRWTXMKZYTXOYCUUAUUBXOWOYCWOWPWQWSWFYGTYCYSXAUUBADWTWGWHWIXKXE
      BWTXMXHWTVCZXJXDHEUUCXIXCNXHWTXBVNVOVPVRTWJWMWEWKWLWN $.

    $( A cluster point of a function is in the base set of the topology.
       (Contributed by Jeff Hankins, 26-Nov-2009.)  (Revised by Stefan O'Rear,
       9-Aug-2015.) $)
    fcfelbas $p |- ( ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\
        F : Y --> X ) /\ A e. ( ( J fClusf L ) ` F ) ) -> A e. X ) $=
      ( ctopon cfv wcel cfil wf w3a cfcf co wa cuni cfm cfcls fcfval eleq2d imp
      eqid fclselbas syl6bi wceq simpl1 toponuni syl eleqtrrd ) CEGHIZDFJHIZFEB
      KZLZABCDMNHZIZOZACPZEUMUOAUQIZUMUOACDEBQNHZRNZIURUMUNUTABCDEFSTAUSCUQUQUB
      UCUDUAUPUJEUQUEUJUKULUOUFECUGUHUI $.

    $( A neighborhood of a cluster point of a function contains a function
       value from every tail.  (Contributed by Jeff Hankins, 27-Nov-2009.)
       (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    fcfneii $p |- ( ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\
       F : Y --> X ) /\
    ( A e. ( ( J fClusf L ) ` F ) /\ N e. ( ( nei ` J ) ` { A } ) /\ S e. L ) )
      -> ( N i^i ( F " S ) ) =/= (/) ) $=
      ( vn vs cfv wcel cima cin c0 wne cv wral wi wceq ctopon cfil w3a cfcf csn
      wf co cnei wa fcfnei ineq1 neeq1d imaeq2 ineq2d rspc2v com3r adantl 3imp2
      ex syl6bi ) DGUAKLEHUBKLHGCUFUCZACDEUDUGKLZFAUEDUHKKZLZBELZFCBMZNZOPZVAVB
      AGLZIQZCJQZMZNZOPZJERIVCRZUIVDVEVHSSZAICDEGHJUJVOVPVIVDVEVOVHVDVEVOVHSVNV
      HFVLNZOPIJFBVCEVJFTVMVQOVJFVLUKULVKBTZVQVGOVRVLVFFVKBCUMUNULUOUSUPUQUTUR
      $.

    $( A limit point of a function is a cluster point of the function.
       (Contributed by Jeff Hankins, 28-Nov-2009.)  (Revised by Stefan O'Rear,
       9-Aug-2015.) $)
    flfssfcf $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( Fil ` Y ) /\ F : Y --> X )
      -> ( ( J fLimf L ) ` F ) C_ ( ( J fClusf L ) ` F ) ) $=
      ( ctopon cfv wcel cfil wf w3a cfm cflim cfcls cflf cfcf wss flimfcls a1i
      co flfval fcfval 3sstr4d ) BDFGHCEIGHEDAJKZBCDALTGZMTZBUENTZABCOTGABCPTGU
      FUGQUDUEBRSABCDEUAABCDEUBUC $.

    $( If the domain filter is an ultrafilter, the cluster points of the
       function are the limit points.  (Contributed by Jeff Hankins,
       12-Dec-2009.)  (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    uffcfflf $p |- ( ( J e. ( TopOn ` X ) /\ L e. ( UFil ` Y ) /\ F : Y --> X )
      -> ( ( J fClusf L ) ` F ) = ( ( J fLimf L ) ` F ) ) $=
      ( ctopon cfv wcel cufil wf w3a cfm co cfcls cflim cfcf cflf wceq toponmax
      syl3an2 fmufil syl3an1 uffclsflim syl cfil ufilfil fcfval flfval 3eqtr4d
      ) BDFGHZCEIGHZEDAJZKZBCDALMGZNMZBUNOMZABCPMGZABCQMGZUMUNDIGHZUOUPRUJDBHUK
      ULUSDBSBACDEUAUBUNBDUCUDUKUJCEUEGHZULUQUORCEUFZABCDEUGTUKUJUTULURUPRVAABC
      DEUHTUI $.
  $}

  ${
    $d f g h A $.  $d f g h x F $.  $d f g h x J $.  $d f g h x K $.  $d f L $.
    $d f g h x X $.  $d f g h x Y $.
    $( Lemma for ~ cnpfcf .  If a function is continuous at a point, it
       respects clustering there.  (Contributed by Jeff Hankins, 20-Nov-2009.)
       (Revised by Stefan O'Rear, 9-Aug-2015.) $)
    cnpfcfi $p |- ( ( K e. Top /\ A e. ( J fClus L ) /\
      F e. ( ( J CnP K ) ` A ) ) -> ( F ` A ) e. ( ( K fClusf L ) ` F ) ) $=
      ( vf wcel cfcls co cfv wss cfcf cuni cfil eqid syl adantr syl3anc filfbas
      wa ctop ccnp w3a cv cflim wrex simp2 wb fclsfil 3ad2ant2 fclsfnflim mpbid
      cflf ctopon simpl1 toptopon sylib simprl cnpf 3ad2ant3 flfssfcf cfm cfbas
      wf topopn fmfil ad2antrl simprrl fmss syl32anc fclsss2 wceq 3sstr4d sstrd
      fcfval simprrr simpl3 cnpflfi syl2anc sseldd rexlimddv ) DUAGZACEHIGZBACD
      UBIJGZUCZEFUDZKZACWFUEIGZTZABJZBDELIJZGFCMZNJZWEWCWIFWMUFZWBWCWDUGWEEWMGZ
      WCWNUHWCWBWOWDAECWLWLOZUIUJZAFECWLUKPULWEWFWMGZWITZTZBDWFUMIJZWKWJWTXABDW
      FLIJZWKWTDDMZUNJGZWRWLXCBVDZXAXBKWTWBXDWBWCWDWSUOZDXCXCOZUPUQZWEWRWIURZWE
      XEWSWDWBXEWCABCDWLXCWPXGUSUTQZBDWFXCWLVARWTDWFXCBVBIZJZHIZDEXKJZHIZXBWKWT
      XDXNXCNJGZXNXLKZXMXOKXHWTXCDGZEWLVCJZGZXEXPWTWBXRXFDXCXGVEPZWTWOXTWEWOWSW
      QQZEWLSPZXJDEBXCWLVFRWTXRXTWFXSGZXEWGXQYAYCWRYDWEWIWFWLSVGXJWEWRWGWHVHDEW
      FBXCWLVIVJXNXLDXCVKRWTXDWRXEXBXMVLXHXIXJBDWFXCWLVORWTXDWOXEWKXOVLXHYBXJBD
      EXCWLVORVMVNWTWHWDWJXAGWEWRWGWHVPWBWCWDWSVQABCDWFVRVSVTWA $.

    $( A function ` F ` is continuous at point ` A ` iff ` F ` respects cluster
       points there.  (Contributed by Jeff Hankins, 14-Nov-2009.)  (Revised by
       Stefan O'Rear, 9-Aug-2015.) $)
    cnpfcf $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ A e. X ) ->
        ( F e. ( ( J CnP K ) ` A ) <-> ( F : X --> Y /\
            A. f e. ( Fil ` X ) ( A e. ( J fClus f ) ->
              ( F ` A ) e. ( ( K fClusf f ) ` F ) ) ) ) ) $=
      ( vg vh cfv wcel co cfcls wi cfil wral wa wceq syl ad2antrr ctopon w3a wf
      ccnp cv cfcf cnpf2 3adantl3 ctop topontop cnpfcfi 3com23 3expia ralrimivw
      3expa sylan 3ad2antl2 jca ex cflim cflf cfm wss wrex cfbas simplrl simprl
      filfbas simpllr simprr fmfnfm r19.29 simpll1 simprrl sseldd sseldi simplr
      flimfcls flimss2 syl3anc simpll2 fcfval simprrr oveq2d eqtr4d eleq2d expr
      biimpd embantd com23 imp3a rexlimdva syl5 mpan2d ralrimdva toponmax fmfil
      cuni wb toponuni fveq2d eleqtrd flimfnfcls flfval raleqdv 3bitr4d sylibrd
      eqid imdistanda cnpflf impbid ) DFUAJKZEGUAJKZAFKZUBZCADEUDLJKZFGCUCZADBU
      EZMLZKZACJZCEXRUFLJZKZNZBFOJZPZQZXOXPYGXOXPQXQYFXLXMXPXQXNXLXMXPXQACDEFGU
      GUOUHXMXLXPYFXNXMXPQYDBYEXMEUIKZXPYDGEUJYHXPXTYCYHXTXPYCACDEXRUKULUMUPUNU
      QURUSXOYGXQADHUEZUTLZKZYACEYIVALJZKZNZHYEPZQXPXOXQYFYOXOXQQZYFYNHYEYPYIYE
      KZQYKYFYMYPYQYKYFYMNYPYQYKQZQZYFYIGCVBLZJZIUEZVCZYAEUUBMLZKZNZIGOJZPZYMYS
      YFUUFIUUGYSUUBUUGKZQUUCYFUUEYSUUIUUCYFUUENYSUUIUUCQZQZYFYIXRVCZUUBXRYTJZR
      ZQZBYEVDZUUEUUKYIBCUUBGFUUKYQYIFVEJKZYPYQYKUUJVFYIFVHZSYSUUIUUCVGXOXQYRUU
      JVIYSUUIUUCVJVKYFUUPQYDUUOQZBYEVDUUKUUEYDUUOBYEVLUUKUUSUUEBYEUUKXRYEKZQZY
      DUUOUUEUVAUUOYDUUEUUKUUTUUOYDUUENUUKUUTUUOQZQZXTYCUUEUVCDXRUTLZXSAXRDVRUV
      CYJUVDAUVCXLUUTUULYJUVDVCYSXLUUJUVBXLXMXNXQYRVMTUUKUUTUUOVGZUUKUUTUULUUNV
      NXRYIDFVSVTYSYKUUJUVBYPYQYKVJTVOVPUVCYCUUEUVCYBUUDYAUVCYBEUUMMLZUUDUVCXMU
      UTXQYBUVFRYSXMUUJUVBXLXMXNXQYRWAZTUVEYSXQUUJUVBXOXQYRVQZTCEXRGFWBVTUVCUUB
      UUMEMUUKUUTUULUUNWCWDWEWFWHWIWGWJWKWLWMWNWGWJWOYSYAEUUAUTLZKZUUFIEWRZOJZP
      ZYMUUHYSUUAUVLKUVJUVMWSYSUUAUUGUVLYSGEKZUUQXQUUAUUGKYSXMUVNUVGGEWPSYSYQUU
      QYPYQYKVGZUURSUVHEYICGFWQVTYSGUVKOYSXMGUVKRUVGGEWTSXAZXBYAIUUAEUVKUVKXHXC
      SYSYLUVIYAYSXMYQXQYLUVIRUVGUVOUVHCEYIGFXDVTWFYSUUFIUUGUVLUVPXEXFXGWGWJWOX
      IAHCDEFGXJXGXK $.

    $( Continuity of a function in terms of cluster points of a function.
       (Contributed by Jeff Hankins, 28-Nov-2009.)  (Revised by Stefan O'Rear,
       9-Aug-2015.) $)
    cnfcf $p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) ) ->
      ( F e. ( J Cn K ) <-> ( F : X --> Y /\ A. f e. ( Fil ` X )
        A. x e. ( J fClus f ) ( F ` x ) e. ( ( K fClusf f ) ` F ) ) ) ) $=
      ( ctopon cfv wcel wa ccn co wf cv ccnp wral cfcf wi bitrd cfcls wb cnpfcf
      cfil cncnp 3expa adantlr simplr biantrurd bitr4d cuni eqid fclselbas wceq
      ralbidva toponuni ad2antrr eleq2d syl5ibr pm4.71rd imbi1d impexp ralbidv2
      syl6bb ralbidv ralcom syl6rbbr pm5.32da ) DFHIJZEGHIJZKZCDELMJFGCNZCAOZDE
      PMIJZAFQZKVLVMCICEBOZRMIJZADVPUAMZQZBFUDIZQZKACDEFGUEVKVLVOWAVKVLKZVOVMVR
      JZVQSZBVTQZAFQZWAWBVNWEAFWBVMFJZKZVNVLWEKZWEVKWGVNWIUBZVLVIVJWGWJVMBCDEFG
      UCUFUGWHVLWEVKVLWGUHUIUJUOWBWAWDAFQZBVTQWFWBVSWKBVTWBVQWDAVRFWBWDWGWCKZVQ
      SWGWDSWBWCWLVQWBWCWGWCWGWBVMDUKZJVMVPDWMWMULUMWBFWMVMVIFWMUNVJVLFDUPUQURU
      SUTVAWGWCVQVBVDVCVEWDABFVTVFVGTVHT $.
  $}

  ${
    $d x y z B $.  $d f x y z J $.  $d f x y z ph $.  $d f x y z X $.
    $d x y z F $.
    alexsub.1 $e |- ( ph -> X e. UFL ) $.
    alexsub.2 $e |- ( ph -> X = U. B ) $.
    alexsub.3 $e |- ( ph -> J = ( topGen ` ( fi ` B ) ) ) $.
    alexsub.4 $e |- ( ( ph /\ ( x C_ B /\ X = U. x ) ) ->
       E. y e. ( ~P x i^i Fin ) X = U. y ) $.
    ${
      alexsub.5 $e |- ( ph -> F e. ( UFil ` X ) ) $.
      alexsub.6 $e |- ( ph -> ( J fLim F ) = (/) ) $.
      $( Lemma for ~ alexsub .  (Contributed by Mario Carneiro,
         26-Aug-2015.) $)
      alexsublem $p |- -. ph $=
        ( vz wceq wss wa c0 wcel syl cv cuni cdif cpw cfn cin wrex cflim co wel
        wi wral eldif cfi cfv ctg eleq2d anbi1d biimpa adantlr tg2 cfil ufilfil
        wn cufil ad3antrrr cint csn wb cvv elfvexd eqeltrrd uniexb sylibr elfi2
        adantr wne ad2antrr simplrr intss1 adantl simplr sseldd eldifsn simplbi
        ad2antlr ad2antrl elfpw sselda anasss anim1i syl2anc ex mt3d expr ssrdv
        simprbi elfir syl13anc filfi eleqtrd eleq2 imbi12d syl5ibrcom rexlimdva
        elunii eleq1 sylbid imp32 adantrrr elssuni fibas tgtopon ax-mp syl6eqel
        ctopon ctb fiuni eqtrd fveq2d eleqtrrd toponuni simprrr filss rexlimddv
        sseqtr4d ralrimiva imdistanda syl5bi flimopn sylibrd difexg unieq mpdan
        ralrimivw syl6eqr eqnetrd necon3bii sylib ciun sseq0 ssdif0 difss eqssd
        unissi syl5sseqr jctil eqeq2d anbi12d anbi2d pweq ineq1d rexeqdv vtoclg
        sseq1 mpcom uni0 syl6eq neeq2d ciin crn difssd riinn0 sylan cab dfiin2g
        cmpt eqid rnmpt inteqi wf eldifbd difss2d ufilb mpbid fmptd frn cdm fdm
        simpr dm0rn0 abrexfi syl5eqel filintn0 iundif2 iuneq2dv syl5eqr neeqtrd
        disj3 dfss4 uniiun filtop fileln0 pm2.61ne neneqd nrexdv pm2.65i ) AGCU
        AZUBZOZCDEUCZUDZUEUFZUGZAUXADPZGUXAUBZOZQZUXDAUXGUXEAGUXFAGUXFUCZROZGUX
        FPAUXIFEUHUIZPUXKROUXJABUXIUXKABUAZUXISZUXLGSZBCUJZUWRESZUKZCFULZQZUXLU
        XKSZUXMUXNUXLUXFSZVDZQZAUXSUXLGUXFUMAUXNUYBUXRAUXNUYBUXRAUYCQZUXQCFUYDU
        WRFSZUXOUXPUYDUYEUXOQZQZBNUJZNUAZUWRPZQZUXPNDUNUOZUYGUWRUYLUPUOZSZUXOQZ
        UYKNUYLUGAUYFUYOUYCAUYFUYOAUYEUYNUXOAFUYMUWRJUQURUSUTNUWRUYLUXLVATUYGUY
        IUYLSZUYKQZQEGVBUOZSZUYIESZUWRGPZUYJUXPAUYSUYCUYFUYQAEGVEUOSZUYSLEGVCTZ
        VFUYDUYQUYTUYFUYDUYPUYHUYTUYJUYDUYPUYHUYTUYDUYPUYIUWRVGZOZCDUDUEUFZRVHU
        CZUGZUYHUYTUKZAUYPVUHVIZUYCADVJSZVUJADUBZVJSVUKAGVULVJIAEVEGLVKZVLDVMVN
        ZCUYIDVJVOTVPUYDVUEVUICVUGUYDUWRVUGSZQVUIVUEUXLVUDSZVUDESZUKUYDVUOVUPVU
        QUYDVUOVUPQZQZVUDEUNUOZEVUSUYSUWREPUWRRVQZUWRUESZVUDVUTSAUYSUYCVURVUCVR
        ZVUSNUWREUYDVURNCUJZUYTUYDVURVVDQZQZUYTUYAAUXNUYBVVEVSVVFUYTVDZUYAVVFVV
        GQZUYHUYIUXASZUYAVVEUYHUYDVVGVVEVUDUYIUXLVVDVUDUYIPVURUYIUWRVTWAVUOVUPV
        VDWBWCWFVVHUYIDSZVVGQVVIVVFVVJVVGUYDVURVVDVVJVUSUWRDUYIVUSUWRVUFSZUWRDP
        ZVUOVVKUYDVUPVUOVVKVVAUWRVUFRWDZWEWGZVVKVVLVVBUWRDWHZWETWIWJWKUYIDEUMVN
        UXLUYIUXAXFWLWMWNWOWPVUOVVAUYDVUPVUOVVKVVAVVMWQWGVUSVVKVVBVVNVVKVVLVVBV
        VOWQTUWREUYRWRWSVUSUYSVUTEOVVCEGWTTXAWOVUEUYHVUPUYTVUQUYIVUDUXLXBUYIVUD
        EXGXCXDXEXHXIXJUTUYGVUAUYQUYGUWRFUBZGUYEUWRVVPPUYDUXOUWRFXKWGAGVVPOZUYC
        UYFAFGXPUOZSZVVQAFUYLUBZXPUOZVVRAFUYMVWAJUYLXQSUYMVWASDXLUYLXMXNXOAGVVT
        XPAGVULVVTIAVUKVULVVTOVUNDVJXRTXSXTYAZGFYBTVRYFVPUYGUYPUYHUYJYCUYIUWREG
        YDWSYEWOYGWOYHYIAVVSUYSUXTUXSVIVWBVUCCUXLEFGYJWLYKWPMUXIUXKUUAWLGUXFUUB
        VNAVULUXFGUXADDEUUCZUUEIUUFUUDVWCUUGUXAVJSZAUXHQZUXDAVWDUXHAVUKVWDVUNDE
        VJYLTVPAUXLDPZGUXLUBZOZQZQZUWTCUXLUDZUEUFZUGZUKVWEUXDUKBUXAVJUXLUXAOZVW
        JVWEVWMUXDVWNVWIUXHAVWNVWFUXEVWHUXGUXLUXADUUOVWNVWGUXFGUXLUXAYMUUHUUIUU
        JVWNUWTCVWLUXCVWNVWKUXBUEUXLUXAUUKUULUUMXCKUUNUUPYNAUWTCUXCAUWRUXCSZQZG
        UWSVWPGUWSVQGRVQZUWRRUWRROZUWSRGVWRUWSRUBRUWRRYMUUQUURUUSVWPVVAQZGGNUWR
        GUYIUCZUUTZUCZUWSVWSGVXAUFZRVQGVXBVQVWSVXCNUWRVWTUVGZUVAZVGZRVWSVXCVXAV
        XFVWPVWTGPZNUWRULVVAVXCVXAOVWPVXGNUWRVWPGUYIUVBYONGVWTUWRUVCUVDVWSVXAUX
        LVWTONUWRUGBUVEZVGZVXFVWSVWTVJSZNUWRULVXAVXIOVWSVXJNUWRVWSGVJSZVXJAVXKV
        WOVVAVUMVRGUYIVJYLTYONBUWRVWTVJUVFTVXEVXHNBUWRVWTVXDVXDUVHZUVIZUVJYPXSV
        WSUYSVXEEPZVXERVQZVXEUESZVXFRVQAUYSVWOVVAVUCVRVWSUWREVXDUVKZVXNVWSNUWRV
        WTEVXDVWSVVDQZVVGVWTESZVXRUYIDEVWSUWRUXAUYIVWOUWRUXAPZAVVAVWOVXTVVBUWRU
        XAWHZWEWFZWIUVLVXRVUBUYIGPZVVGVXSVIAVUBVWOVVAVVDLVFVXRUYIVULGVXRVVJUYIV
        ULPVWSUWRDUYIVWSUWRDEVYBUVMWIUYIDXKTAGVULOVWOVVAVVDIVFYFZUYIEGUVNWLUVOV
        XLUVPZUWREVXDUVQTVWSVXDUVRZRVQVXOVWSVYFUWRRVWSVXQVYFUWROVYEUWREVXDUVSTV
        WPVVAUVTYQVYFRVXERVXDUWAYRYSVWSVVBVXPVWOVVBAVVAVWOVXTVVBVYAWQWFVVBVXEVX
        HUEVXMNBUWRVWTUWBUWCTVXEEGUWDWSYQVXCRGVXBGVXAUWIYRYSVWSVXBNUWRGVWTUCZYT
        ZUWSNUWRGVWTUWEVWSVYHNUWRUYIYTUWSVWSNUWRVYGUYIVXRVYCVYGUYIOVYDUYIGUWJYS
        UWFNUWRUWKYPUWGUWHVWPUYSVWQAUYSVWOVUCVPUYSGESVWQEGUWLGEGUWMYNTUWNUWOUWP
        UWQ $.
    $}

    $( The Alexander Subbase Theorem:  If ` B ` is a subbase for the topology
       ` J ` , and any cover taken from ` B ` has a finite subcover, then the
       generated topology is compact.  This proof uses the ultrafilter lemma;
       see ~ alexsubALT for a proof using Zorn's lemma.  (Contributed by Jeff
       Hankins, 24-Jan-2010.)  (Revised by Mario Carneiro, 26-Aug-2015.) $)
    alexsub $p |- ( ph -> J e. Comp ) $=
      ( vf wcel cv c0 cfv wa wceq adantr cuni cvv ccmp cflim co cufil wral cufl
      wne cfi ctg wss cpw cfn cin wrex adantlr simprl simprr alexsublem pm2.21i
      wn expr pm2.01d neneqad ralrimiva ctopon ctb fibas tgtopon ax-mp syl6eqel
      wb syl eqeltrrd uniexb sylibr fiuni eqtrd fveq2d eleqtrrd ufilcmp syl2anc
      elex mpbird ) AEUALZEKMZUBUCZNUGZKFUDOZUEZAWGKWHAWEWHLZPZWFNWKWFNQZAWJWLW
      LUTZAWJWLPZPZWMWOBCDWEEFAFUFLZWNGRAFDSZQWNHRAEDUHOZUIOZQWNIRABMZDUJFWTSQP
      FCMSQCWTUKULUMUNWNJUOAWJWLUPAWJWLUQURUSVAVBVCVDAWPEFVEOZLWDWIVKGAEWRSZVEO
      ZXAAEWSXCIWRVFLWSXCLDVGWRVHVIVJAFXBVEAFWQXBHADTLZWQXBQAWQTLXDAFWQTHAWPFTL
      GFUFWBVLVMDVNVODTVPVLVQVRVSKEFVTWAWC $.
  $}

  ${
    $d w x y z B $.  $d w x y z X $.
    $( Biconditional form of the Alexander Subbase Theorem ~ alexsub .
       (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    alexsubb $p |- ( ( X e. UFL /\ X = U. B ) ->
        ( ( topGen ` ( fi ` B ) ) e. Comp <-> A. x e. ~P B ( X = U. x ->
          E. y e. ( ~P x i^i Fin ) X = U. y ) ) ) $=
      ( vz vw wcel cuni wceq wa cv cpw cfn wrex wi wral cvv syl ctb wss cfi cfv
      cufl ctg ccmp cin ctop eqid iscmp simprbi simpr elex adantr uniexb sylibr
      fiuni fibas unitg mp1i 3eqtr4d eqeq1d rexbidv imbi12d ralbidv ssfii bastg
      eqeltrrd ax-mp syl6ss sspwb sylib ssralv sylbird syl5 simpll simplr eqidd
      elpw unieq eqeq2d pweq ineq1d rexeqdv rspccv adantl syl5bir imp32 cbvrexv
      vex alexsub ex impbid ) DUCGZDCHZIZJZCUAUBZUDUBZUEGZDAKZHZIZDBKZHZIZBWTLZ
      MUFZNZOZACLZPZWSWRHZXAIZXLXDIZBXGNZOZAWRLZPZWPXKWSWRUGGXRABWRXLXLUHUIUJWP
      XRXIAXQPZXKWPXIXPAXQWPXBXMXHXOWPDXLXAWPWNWQHZDXLWPCQGZWNXTIWPWNQGYAWPDWNQ
      WMWOUKZWMDQGWODUCULUMVGCUNUOZCQUPRYBWQSGZXLXTIWPCUQZWQSURUSUTZVAWPXEXNBXG
      WPDXLXDYFVAVBVCVDWPXJXQTZXSXKOWPCWRTYGWPCWQWRWPYACWQTYCCQVERYDWQWRTYEWQSV
      FVHVICWRVJVKXIAXJXQVLRVMVNWPXKWSWPXKJZEFCWRDWMWOXKVOWMWOXKVPYHWRVQYHEKZCT
      ZDYIHZIZJJXEBYILZMUFZNZDFKZHZIZFYNNYHYJYLYOYJYIXJGZYHYLYOOZYICEWIVRXKYSYT
      OWPXIYTAYIXJWTYIIZXBYLXHYOUUAXAYKDWTYIVSVTUUAXEBXGYNUUAXFYMMWTYIWAWBWCVCW
      DWEWFWGXEYRBFYNXCYPIXDYQDXCYPVSVTWHVKWJWKWL $.
  $}

  ${
    $d a b c d f j k m n s t u v w x y z J $.
    $d a b c d f j k m n s t u v w x y z X $.
    alexsubALT.1 $e |- X = U. J $.
    $( Lemma for ~ alexsubALT .  A compact space has a subbase such that every
       cover taken from it has a finite subcover.  (Contributed by Jeff
       Hankins, 27-Jan-2010.) $)
    alexsubALTlem1 $p |- ( J e. Comp -> E. x ( J = ( topGen ` ( fi ` x ) )
       /\ A. c e. ~P x ( X = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) ) ) $=
      ( ccmp wcel cfi cfv ctg wceq cv cuni cpw cfn cin wral wa fveq2d wrex ctop
      wi wex cmptop fitop tgtop eqtr2d syl wss elpw cmpcov 3exp syl5bi ralrimiv
      vex fveq2 eqeq2d pweq raleqdv anbi12d spcegv mp2and ) BGHZBBIJZKJZLZCDMZN
      LZCEMNLEVHOPQUAZUCZDBOZRZBAMZIJZKJZLZVKDVNOZRZSZAUDVDBUBHZVGBUEWAVFBKJBWA
      VEBKBUFTBUGUHUIVDVKDVLVHVLHVHBUJZVDVKVHBDUPUKVDWBVIVJVHBCEFULUMUNUOVTVGVM
      SABGVNBLZVQVGVSVMWCVPVFBWCVOVEKVNBIUQTURWCVKDVRVLVNBUSUTVAVBVC $.

    $( Lemma for ~ alexsubALT .  Every subset of a base which has no finite
       subcover is a subset of a maximal such collection.  (Contributed by Jeff
       Hankins, 27-Jan-2010.) $)
    alexsubALTlem2 $p |- ( ( ( J = ( topGen ` ( fi ` x ) )
      /\ A. c e. ~P x ( X = U. c
        -> E. d e. ( ~P c i^i Fin ) X = U. d ) /\ a e. ~P ( fi ` x ) )
          /\ A. b e. ( ~P a i^i Fin ) -. X = U. b )
            -> E. u e. ( { z e. ~P ( fi ` x ) | ( a C_ z
                /\ A. b e. ( ~P z i^i Fin ) -. X = U. b ) } u. { (/) } )
              A. v e. ( { z e. ~P ( fi ` x ) | ( a C_ z
                  /\ A. b e. ( ~P z i^i Fin ) -. X = U. b ) } u. { (/) } )
                -. u C. v ) $=
      ( vw cv wceq cfn wi wcel wa wss c0 cfi cfv ctg cuni cpw cin wrex wral w3a
      vy vn wn crab csn cun crpss wor wal wpss ssel elun weq sseq2 pweq raleqdv
      wo ineq1d anbi12d elrab elsn orbi12i bitri elpwi adantr sseq1 mpbiri jaoi
      0ss sylbi syl6 ralrimiv unissb sylibr ad2antlr vex uniex uni0b notbii wne
      elpw disjssun biimpcd necon3bd n0 elin anbi2i simprrl simpl ssuni syl2anc
      wex exlimiv ad2antrl syl5bi imp elfpw unieq uni0 necon3bi simplrr simprlr
      syl6eq simprr finsschain syl22anc expr 0fin mpbir2an eqeq2d notbid rspccv
      0elpw mpi syl5bir exp3a com23 ad2antll a1i ss0 syl6bi biimprcd a1dd syl9r
      com34 jaod sylan9r sylan ad2ant2lr sylib ex adantrl rexlimdv syld cbvralv
      imp3a jca32 orcom elsnc df-or bitr2i 3bitr4i alrimiv fvex pwex rabex p0ex
      unex zorn syl ) EAMZUAUBZUCUBNFIMZUDNFJMUDNJUVBUEOUFUGPIUUTUEUHGMZUVAUEZQ
      UIZFHMZUDZNZULZHUVCUEZOUFZUHZRZUJMZUVCBMZSZUVIHUVOUEZOUFZUHZRZBUVDUMZTUNZ
      UOZSZUVNUPUQZRZUVNUDZUWCQZPZUJURDMCMUSULCUWCUHDUWCUGUVMUWIUJUVMUWFUWHUVMU
      WFRZUWGTNZULZUWGUVDQZUVCUWGSZUVIHUWGUEZOUFZUHZRZRZPZUWHUWJUWLUWSUWJUWLRZU
      WMUWNUWQUXAUWGUVASZUWMUWFUXBUVMUWLUWDUXBUWEUWDLMZUVASZLUVNUHUXBUWDUXDLUVN
      UWDUXCUVNQZUXCUWCQZUXDUVNUWCUXCUTZUXFUXCUVDQZUVCUXCSZUVIHUXCUEZOUFZUHZRZR
      ZUXCTNZVFZUXDUXFUXCUWAQZUXCUWBQZVFUXPUXCUWAUWBVAUXQUXNUXRUXOUVTUXMBUXCUVD
      BLVBZUVPUXIUVSUXLUVOUXCUVCVCUXSUVIHUVRUXKUXSUVQUXJOUVOUXCVDVGVEVHVIZLTVJV
      KVLZUXNUXDUXOUXHUXDUXMUXCUVAVMVNUXOUXDTUVASUVAVRUXCTUVAVOVPVQVSVTWALUVNUV
      AWBWCVNWDUWGUVAUVNUJWEWFZWJWCUWJUWLUWNUWLUVNUWBSZULZUWJUWNUWKUYCUVNWGWHUW
      DUYDUWNPUVMUWEUWDUYDUVNUWAUFZTWIZUWNUWDUYCUYETUYETNUWDUYCUVNUWAUWBWKWLWMU
      YFUXCUYEQZLXAUWNLUYEWNUYGUWNLUYGUXEUXNRZUWNUYGUXEUXQRUYHUXCUVNUWAWOUXQUXN
      UXEUXTWPVLUYHUXIUXEUWNUXEUXHUXIUXLWQUXEUXNWRUVCUXCUVNWSWTVSXBVSVTXCXDXEUX
      AFUKMZUDZNZULZUKUWPUHUWQUXAUYLUKUWPUYIUWPQUYIUWGSZUYIOQZRUXAUYLUYIUWGXFUX
      AUYMUYNUYLUXAUYNUYMUYLUWJUWLUYNUYMUYLPUWJUWLUYNRZRZUYMUYIUXCSZLUVNUGZUYLU
      WJUYOUYMUYRUWJUYOUYMRZRUVNTWIZUWEUYNUYMUYRUYOUYTUWJUYMUWLUYTUYNUWKUVNTUVN
      TNUWGTUDZTUVNTXGXHXLXIVNXCUVMUWDUWEUYSXJUWJUWLUYNUYMXKUWJUYOUYMXMLUVNUYIX
      NXOXPUYPUYQUYLLUVNUWJUYNUXEUYQUYLPZPZUWLUWJUYNVUCUVLUWDUYNVUCPZUVEUWEUVLF
      VUANZULZUWDVUDUVLTUVKQZVUFVUGTUVJQTOQUVCYBXQTUVJOWOXRUVIVUFHTUVKUVFTNZUVH
      VUEVUHUVGVUAFUVFTXGXSXTYAYCVUFUWDRUXEUYNVUBUWDUXEUXFVUFUYNVUBPZUXGUXFUXPV
      UFVUIUYAVUFUXNVUIUXOUXNVUIPVUFUXLVUIUXHUXIUXLUYQUYNUYLUYQUYIUXJQZUXLUYNUY
      LPZUYIUXCUKWEWJUXLVUJUYNUYLVUJUYNRUYIUXKQUXLUYLUYIUXJOWOUVIUYLHUYIUXKHUKV
      BZUVHUYKVULUVGUYJFUVFUYIXGXSXTYAYDYEYDYFYGYHVUFUXOUYQUYNUYLUXOUYQUYITNZVU
      FVUKUXOUYQUYITSVUMUXCTUYIVCUYIYIYJVUFVUMUYLUYNVUMUYLVUFVUMUYKVUEVUMUYJVUA
      FUYITXGXSXTYKYLYMYNYOXDYPYFYQYRXEUUAUUBUUCXPYFUUEXDWAUYLUVIUKHUWPUKHVBZUY
      KUVHVUNUYJUVGFUYIUVFXGXSXTUUDYSUUFYTUWGUWBQZUWGUWAQZVFZVUPVUOVFUWTUWHVUOV
      UPUUGVUQUWKUWSVFUWTVUOUWKVUPUWSUWGTUYBUUHUVTUWRBUWGUVDUVOUWGNZUVPUWNUVSUW
      QUVOUWGUVCVCVURUVIHUVRUWPVURUVQUWOOUVOUWGVDVGVEVHVIVKUWKUWSUUIUUJUWGUWAUW
      BVAUUKYSYTUULDCUJUWCUWAUWBUVTBUVDUVAUUTUAUUMUUNUUOUUPUUQUURUUS $.

    $( Lemma for ~ alexsubALT .  If a point is covered by a collection taken
       from the base with no finite subcover, a set from the subbase can be
       added that covers the point so that the resulting collection has no
       finite subcover.  (Contributed by Jeff Hankins, 28-Jan-2010.)  (Revised
       by Mario Carneiro, 14-Dec-2013.) $)
    alexsubALTlem3 $p |- ( ( ( ( ( J = ( topGen ` ( fi ` x ) ) /\
          A. c e. ~P x ( X = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) /\
              a e. ~P ( fi ` x ) ) /\
            ( u e. ~P ( fi ` x ) /\ ( a C_ u /\
              A. b e. ( ~P u i^i Fin ) -. X = U. b ) ) ) /\ w e. u ) /\
          ( ( t e. ( ~P x i^i Fin ) /\ w = |^| t ) /\
            ( y e. w /\ -. y e. U. ( x i^i u ) ) ) ) ->
      E. s e. t A. n e. ( ~P ( u u. { s } ) i^i Fin ) -. X = U. n ) $=
      ( wceq cfn wi wcel wss wa vm vf vv cfi cfv ctg cuni cpw cin wrex wral w3a
      vz cv wn wel cint csn cun dfrex2 ralbii ralnex bitr2i wex cdif elin elpwi
      adantr uncom syl6sseq ssundif sylib diffi adantl jca sylbi ad2antll elpw2
      wf vex anbi1i simprrr eldif simplbi2 wo elun orcom df-or ssriv uniss mp1i
      bitr4i uniun unisn uneq2i eqtri eqsstrd difss sseli ad3antrrr elssuni syl
      sseldd ctb unieq 3ad2ant1 cvv syl6eqr sseqtrd unssd uneq1d eqeq2d syl2anc
      eqssd rspcev inss2 ex ad2antrl ralrimiva sylibr adantlr wal alinexa rspcv
      eleq2 eluni notbid syl9r syl5bi imp31 ad2antrr anim2i eximi eliun orbi12i
      weq elsn bitri syl6 exp32 unissi sseq2 mpbiri inss1 elpwid ad2antlr fibas
      simprl unitg fiuni 3eqtr4rd expr exp3a rexlimdv ac6sfi ciun ffvelrn iunss
      ralimdva simplrr snssd sseldi iunfi syl2an ad2ant2lr sylancl imbi2i albii
      snfi unfi fveq2 unieqd uneq12d biimpd orbi1i imbi1i eleq1 ralbidv imbi12d
      id 3bitri spv eleq2d alrimdv imim1d a1dd syld com14 com23 ralrimdv elint2
      syl6ibr wb sylibrd orrd orc equid equequ1 anbi12d spcev mpan2 jaoi anbi2i
      olc exbii adantll ad2ant2l ssrdv nfra1 nfv rsp eqimss2 sstr expcom syl2im
      ssun3 rexlimd ax-mp syl6req sseq1 syl5ibrcom jaod ralrimiv unissb exlimdv
      3syld syl6ib con4d com24 imp45 ) GAUNZUDUEZUFUEZOZHLUNZUGOHMUNUGOMUYOUHPU
      IUJQLUYKUHZUKZJUNZUYLUHZRZULZDUNZUYSRZUYRVUBSZHKUNZUGZOZUOKVUBUHZPUIZUKZT
      TTCDUPZEUNZUYPPUIZRZCUNZVULUQZOZTZBCUPBUNZUYKVUBUIUGRUOTZTZHFUNZUGZOZUOFV
      UBIUNZURZUSZUHZPUIZUKZIVULUJZVUAVUCVUDVUJVUKVVAVVKQQZVUAVUCVUDVUJVVLQVUAV
      UCVUDTZTZVVAVUKVUJVVKVVNVVAVUKVUJVVKQVVNVVAVUKTZTZVVKVUJVVPVVKUOZVUGKVUIU
      JZVUJUOVVQVVDFVVIUJZIVULUKZVVPVVRVVTVVJUOZIVULUKVVQVVSVWAIVULVVDFVVIUTVAV
      VJIVULVBVCVVPVVTHUAUNZUGZVVEUSZOZUAVUIUJZIVULUKZVULVUIUBUNZVSZHVVEVWHUEZU
      GZVVEUSZOZIVULUKZTZUBVDZVVRVVPVVSVWFIVULVVPIEUPZTZVVDVWFFVVIVWRVVBVVIRZVV
      DVWFVVPVWQVWSVVDTZVWFVVPVWQVWTTZTZVVBVVFVEZVUIRZHVXCUGZVVEUSZOZVWFVXBVXCV
      UBSZVXCPRZTZVXDVWTVXJVVPVWQVWSVXJVVDVWSVVBVVHRZVVBPRZTZVXJVVBVVHPVFVXMVXH
      VXIVXMVVBVVFVUBUSZSVXHVXMVVBVVGVXNVXKVVBVVGSVXLVVBVVGVGVHVUBVVFVIVJVVBVVF
      VUBVKVLVXLVXIVXKVVBVVFVMVNVOVPVHVQVXDVXCVUHRZVXITVXJVXCVUHPVFVXOVXHVXIVXC
      VUBDVTZVRWAVCVLVXBHVXFVXBHVVCVXFVVPVWQVWSVVDWBVXBVVCVXCVVFUSZUGZVXFVVBVXQ
      SVVCVXRSVXBAVVBVXQAFUPZUYKVVFRZUOZUYKVXCRZQZUYKVXQRZVYBVXSVYAUYKVVBVVFWCW
      DVYDVXTVYBWEZVYCVYDVYBVXTWEVYEUYKVXCVVFWFVXTVYBWGWLVXTVYBWHVCVLWIVVBVXQWJ
      WKVXRVXEVVFUGZUSVXFVXCVVFWMVYFVVEVXEVVEIVTWNWOWPVJWQVXBVXEVVEHVWTVXEHSZVV
      PVWQVVDVYGVWSVVDVYGVXEVVCSVXCVVBVVBVVFWRUUAHVVCVXEUUBUUCVNVQVXBVVEUYKUGZH
      VXBIAUPVVEVYHSVXBVULUYKVVEVVOVULUYKSZVVNVXAVUNVYIVUQVUTVUKVUNVULUYKVUMUYP
      VULUYPPUUDWSUUEWTUUFVVPVWQVWTUUHXCVVEUYKXAXBVXBVYHGUGZHVXBUYMUGZUYLUGZVYJ
      VYHUYLXDRZVYKVYLOZVXBUYKUUGZUYLXDUUIZWKVUAVYJVYKOZVVMVVOVXAUYNUYQVYQUYTGU
      YMXEZXFWTUYKXGRVYHVYLOVXBAVTUYKXGUUJWKUUKNXHXIXJXNVWEVXGUAVXCVUIVWBVXCOZV
      WDVXFHVYSVWCVXEVVEVWBVXCXEXKXLXOXMUULUUMUUNUUSVVAVWGVWPQZVVNVUKVURVYTVUTV
      URVULPRZVYTVUNWUAVUQVUMPVULUYPPXPWSVHZWUAVWGVWPVWEVWMIUAVULVUIUBVWBVWJOZV
      WDVWLHWUCVWCVWKVVEVWBVWJXEXKXLUUOXQXBVHXRVVPVWOVVRUBVVPVWOVVRVVPVWOTZIVUL
      VWJUUPZVUOURZUSZVUIRZHWUGUGZOZVVRWUDWUGVUBSZWUGPRZTZWUHWUDWUKWULWUDWUEWUF
      VUBVWIWUEVUBSZVVPVWNVWIVWJVUBSZIVULUKWUNVWIWUOIVULVWIVWQTZVWJVUIRZWUOVULV
      UIVVEVWHUUQZWUQVWJVUHRZVWJPRZTWUOVWJVUHPVFWUSWUOWUTVWJVUBVGVHVPXBXSIVULVW
      JVUBUURXTXRWUDVUOVUBVVNVVAVUKVWOUUTZUVAXJWUDWUEPRZWUFPRWULVVOVWIWVBVVNVWN
      VVAVWIWVBVUKVURVWIWVBVUTVURWUAWUTIVULUKWVBVWIWUBVWIWUTIVULWUPVUIPVWJVUHPX
      PWURUVBXSIVULVWJUVCUVDYAYAUVEVUOUVIWUEWUFUVJUVFVOWUHWUGVUHRZWULTWUMWUGVUH
      PVFWVCWUKWULWUGVUBVXPVRWAVCVLWUDHWUIWUDUCHWUIVVOVWNUCUNZHRZWVDWUIRZQZVVNV
      WIVVAVWNWVGVUKVURVWNWVGVUTVUQVWNWVGVUNVUQVWNTZWVEUCBUPZVUSVWJRZIVULUJZTZB
      VDZUCCUPZWEZWVFWVHWVEWVOWVHWVETZWVMWVNWVMUOZWVIWVJUOZIVULUKZQZBYBZWVPWVNW
      WAWVIWVKUOZQZBYBWVQWVTWWCBWVSWWBWVIWVJIVULVBUVGUVHWVIWVKBYCVCWVPWWAWVDVUP
      RZWVNWVPWWAUCUMUPZUMVULUKWWDWVPWWAWWEUMVULWVPUMEUPZWWAWWEVUQVWNWVEWWFWWAW
      WEQZQWWFVWNWVEVUQWWGWWFVWNHUMUNZVWHUEZUGZWWHUSZOZWVEVUQWWGQZQVWMWWLIWWHVU
      LIUMYPZVWLWWKHWWNVWKWWJVVEWWHWWNVWJWWIVVEWWHVWHUVKZUVLWWNUVTUVMXLYDWWLWVE
      WVDWWKRZWWFWWMWWLWVEWWPHWWKWVDYEUVNWWFWWPWWGVUQWWPWVNVUOWWIRZUOZQZCYBZWWE
      QZWWFWWGWWPWVDWWJRZWWEWEWVNWWQTCVDZWWEWEZWXAWVDWWJWWHWFWXBWXCWWECWVDWWIYF
      UVOWXDWXCUOZWWEQWXAWXCWWEWHWWTWXEWWEWVNWWQCYCUVPWLUWAWWFWWAWWTWWEWWFWWAWW
      SCWWAWVNVUOVWJRZUOZIVULUKZWWFWWRWVTWVNWXHQBCBCYPZWVIWVNWVSWXHVUSVUOWVDYEZ
      WXIWVRWXGIVULWXIWVJWXFVUSVUOVWJUVQYGUVRUVSUWBWXGWWRIWWHVULWWNWXFWWQWWNVWJ
      WWIVUOWWOUWCYGYDYHUWDUWEYIUWFYHUWGUWHYJUWIUWJUMWVDVULUCVTUWKUWLVUQWVNWWDU
      WMVWNWVEVUOVUPWVDYEYKUWNYIUWOXQWVOWVIWVKWXIWEZTZBVDZWVFWVMWXMWVNWVLWXLBWV
      KWXKWVIWVKWXIUWPYLYMWVNWVIWXITZBVDZWXMWVNCCYPZWXOCUWQWXNWVNWXPTBVUOCVTWXI
      WVIWVNWXIWXPWXJBCCUWRUWSUWTUXAWXNWXLBWXIWXKWVIWXIWVKUXDYLYMXBUXBWVFWVIVUS
      WUGRZTZBVDWXMBWVDWUGYFWXRWXLBWXQWXKWVIWXQVUSWUERZVUSWUFRZWEWXKVUSWUEWUFWF
      WXSWVKWXTWXIIVUSVULVWJYNBVUOYQYOYRUXCUXEVCVLYSUXFYAYAUXGUXHWUDWVDHSZUCWUG
      UKWUIHSWUDWYAUCWUGWVDWUGRZWVDVWJRZIVULUJZUCCYPZWEZWUDWYAWYBWVDWUERZWVDWUF
      RZWEWYFWVDWUEWUFWFWYGWYDWYHWYEIWVDVULVWJYNUCVUOYQYOYRWUDWYDWYAWYEVWNWYDWY
      AQVVPVWIVWNWYCWYAIVULVWMIVULUXIWYAIUXJVWNVWQVWMWYCWYAQVWMIVULUXKVWMVWLHSZ
      WYCWVDVWLSZWYAVWLHUXLWYCWVDVWKSWYJWVDVWJXAWVDVWKVVEUXPXBWYJWYIWYAWVDVWLHU
      XMUXNUXOYSUXQVQWUDWYAWYEVUOHSWUDVUOVYLHWUDVUOUYLRVUOVYLSWUDVUBUYLVUOVVNVU
      BUYLSZVVOVWOVUCWYKVUAVUDVUBUYLVGXRYKWVAXCVUOUYLXAXBVUAVYLHOZVVMVVOVWOUYNU
      YQWYLUYTUYNVYLVYJHUYNVYJVYKVYLVYRVYMVYNVYOVYPUXRUXSNXHXFWTXIWVDVUOHUXTUYA
      UYBYIUYCUCWUGHUYDXTXNVUGWUJKWUGVUIVUEWUGOVUFWUIHVUEWUGXEXLXOXMXQUYEUYFYIV
      UGKVUIUTUYGUYHYTUYIYTUYJYJ $.

    $( Lemma for ~ alexsubALT .  If any cover taken from a subbase has a finite
       subcover, any cover taken from the corresponding base has a finite
       subcover.  (Contributed by Jeff Hankins, 28-Jan-2010.)  (Revised by
       Mario Carneiro, 14-Dec-2013.) $)
    alexsubALTlem4 $p |- ( J = ( topGen ` ( fi ` x ) ) ->
      ( A. c e. ~P x ( X = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) ->
        A. a e. ~P ( fi ` x ) ( X = U. a ->
          E. b e. ( ~P a i^i Fin ) X = U. b ) ) ) $=
      ( vu vv cv wceq cuni cfn wi wcel wn wa wss c0 vz vy vw vt cfi cfv ctg cpw
      vn vs cin wrex wral w3a ralnex wpss crab csn alexsubALTlem2 wo elun sseq2
      cun weq pweq ineq1d raleqdv anbi12d elrab elsn orbi12i bitri unissd sseq1
      simprrl syl5ibrcom inss1 vex elpw2 mpbir unieq eqeq2d rexeqdv imbi12d mpi
      rspccv inss2 sstr mpan2 anim1i 3imtr4i reximi2 syl6 cbvrexv syl6ib dfrex2
      elfpw con2d a1d 3ad2ant2 adantr imp3a wb unissi cvv fiuni ax-mp ctb fibas
      impr unitg eqtr4i syl6reqr syl6eqr syl wex nss ad2antrl ad4antlr ad2antrr
      wel ad2antlr simprl sseldd sseldi sylibr ssun1 notbid adantll adantl elin
      wne ex syl5bir exp3a con3d eqimss2 psseq2 rexlimdv syl5bi eqcom eqss baib
      3ad2ant1 syl5bb mtbid sstr2 con3rr3 df-rex bitr4i eluni2 cint elpwi sseld
      syl5sseq elfi mp2an alexsubALTlem3 ssfii sseli elpwid snssd unssd cbvralv
      fvex syl6ss biimpi ad2antll jca32 elun1 snid elun2 intss1 impcom adantrrr
      adantlr simprlr elunii sylc com23 exp32 imp55 eleq1 elequ1 spcev necon3bi
      expr sylancr jctil df-pss rspcev syl2anc rexlimddv mpdd simpll3 biantrurd
      exp45 3syld simplr bitr3d sylanbrc rspcv 0elpw mpbir2an syl6eqel necon2ad
      0fin syl5 psseq1 0pss syl6bb sylibrd nsyld jaod mpd con4d 3exp ralrimdv
      id ) BAKZUEUFZUGUFZLZCFKZMZLZCGKZMZLZGUYDUHZNUKZULZOZFUXTUHZUMZCDKZMZLZCE
      KZMZLZEUYPUHZNUKZULZOZDUYAUHZUYCUYOUYPVUFPZVUEUYCUYOVUGUNZVUDUYRVUDQVUAQZ
      EVUCUMZVUHUYRQZVUAEVUCUOVUHVUJVUKVUHVUJRZIKZJKZUPZQZJUYPUAKZSZVUIEVUQUHZN
      UKZUMZRZUAVUFUQZTURZVCZUMZIVVEULVUKAUAJIBCDEFGHUSVULVVFVUKIVVEVUMVVEPZVUM
      VUFPZUYPVUMSZVUIEVUMUHZNUKZUMZRZRZVUMTLZUTZVULVVFVUKOZVVGVUMVVCPZVUMVVDPZ
      UTVVPVUMVVCVVDVAVVRVVNVVSVVOVVBVVMUAVUMVUFUAIVDZVURVVIVVAVVLVUQVUMUYPVBVV
      TVUIEVUTVVKVVTVUSVVJNVUQVUMVEVFVGVHVIITVJVKVLVULVVNVVQVVOVUHVVNVVQOVUJVUH
      VVNVVQVVFVUOJVVEULZQVUHVVNRZVUKVUOJVVEUOVWBUYRVWAVWBUYRCVUMMZSZVWCUXTVUMU
      KZMZSZQZVWAVWBVWDUYRUYQVWCSVWBUYPVUMVUHVVHVVIVVLVOVMCUYQVWCVNVPVWBCVWFSZQ
      VWDVWHOVWBCVWFLZVWIVUHVVHVVMVWJQZVUHVVHRVVIVVLVWKVUHVVIVVLVWKOZOZVVHUYOUY
      CVWMVUGUYOVWLVVIUYOVWJVVLUYOVWJVUAEVVKULZVVLQUYOVWJUYIGVVKULZVWNUYOVWJUYI
      GVWEUHZNUKZULZVWOUYOVWEUYNPZVWJVWROZVWSVWEUXTSUXTVUMVQZVWEUXTAVRZVSVTUYMV
      WTFVWEUYNUYDVWELZUYFVWJUYLVWRVXCUYEVWFCUYDVWEWAWBVXCUYIGUYKVWQVXCUYJVWPNU
      YDVWEVEVFWCWDWFWEUYIUYIGVWQVVKUYGVWQPZUYGVVKPZUYIUYGVWESZUYGNPZRUYGVUMSZV
      XGRVXDVXEVXFVXHVXGVXFVWEVUMSVXHUXTVUMWGUYGVWEVUMWHWIWJUYGVWEWQUYGVUMWQWKW
      JWLWMUYIVUAGEVVKGEVDUYHUYTCUYGUYSWAWBWNWOVUAEVVKWPWOWRWSWTXAXBXJVWBVWFCSZ
      VWJVWIXCVWBUXTMZVWFCVWEUXTVXAXDVUHVXJCLZVVNUYCUYOVXKVUGUYCVXJBMZCUYCVXLUY
      BMZVXJBUYBWAVXJUYAMZVXMUXTXEPZVXJVXNLVXBUXTXEXFXGUYAXHPVXMVXNLUXTXIUYAXHX
      KXGXLXMHXNUUDXAUUOVWJVWFCLZVXIVWICVWFUUAVXPVXIVWIVWFCUUBUUCUUEXOUUFVWDVWG
      VWICVWCVWFUUGUUHXOVWHUBKZVWFPZQZUBVWCULZVWBVWAVWHVXQVWCPZVXSRUBXPVXTUBVWC
      VWFXQVXSUBVWCUUIUUJVWBVXSVWAUBVWCVYAUBUCYAZUCVUMULVWBVXSVWAOZUCVXQVUMUUKV
      WBVYBVYCUCVUMVWBUCIYAZUCKZUDKZUULZLZUDUYNNUKZULZVYBVYCOZVWBVYDVYEUYAPZVYJ
      VVHVYDVYLOVUHVVMVVHVUMUYAVYEVUMUYAUUMZUUNXRVYEXEPVXOVYLVYJXCUCVRVXBUDVYEU
      XTXEXEUUPUUQWOVWBVYDVYJVYKOVWBVYDRZVYHVYKUDVYIVYNVYFVYIPZVYHVYKVYNVYOVYHR
      ZVYBVXSVWAVYNVYPVYBVXSRZRZRZCUIKZMZLZQZUIVUMUJKZURZVCZUHZNUKZUMZVWAUJVYFA
      UBUCIUDUIBCUJDEFGHUURVYSUJUDYAZWUIRZRZWUFVVEPZVUMWUFUPZVWAWULWUFVVCPZWUMW
      ULWUFVUFPZUYPWUFSZVUIEWUHUMZRZRWUOWULWUPWUQWURWULWUFUYASWUPWULVUMWUEUYAVV
      NVUMUYASZVUHVYDVYRWUKVVHWUTVVMVYMXAXSWULWUDUYAWULUXTUYAWUDVXOUXTUYASVXBUX
      TXEUUSXGWULVYFUXTWUDVYRVYFUXTSZVYNWUKVYOWVAVYHVYQVYOVYFUXTVYIUYNVYFUYNNVQ
      UUTUVAZXTYBVYSWUJWUIYCYDYEUVBUVCWUFUYAUXTUEUVEVSYFWULUYPVUMWUFVVNVVIVUHVY
      DVYRWUKVVHVVIVVLYCXSVUMWUEYGZUVFWUIWURVYSWUJWUIWURWUCVUIUIEWUHUIEVDZWUBVU
      AWVDWUAUYTCVYTUYSWAWBYHUVDUVGUVHUVIVVBWUSUAWUFVUFVUQWUFLZVURWUQVVAWURVUQW
      UFUYPVBWVEVUIEVUTWUHWVEVUSWUGNVUQWUFVEVFVGVHVIYFWUFVVCVVDUVJXOWULVUMWUFSZ
      VUMWUFYLZRWUNWULWVGWVFWULWUFVUMSZQZWVGWULVUNWUFPZJIYAZQZRZJXPZWVIWULWUDWU
      FPZUJIYAZQZWVNWUDWUEPWVOWUDUJVRZUVKWUDWUEVUMUVLXGVYNVYPVYBVXSWUKWVQVYNVYP
      VYBVXSWUKWVQOOVYNVYPVYBRZRWUKVXSWVQVYNWVSWUKVXSWVQOVYNWVSWUKRZRZWVPVXRWWA
      UBUJYAZUJAYAZWVPVXROWWAVYEWUDVXQVYDWVTVYEWUDSZVWBVYDWVSWUJWWDWUIWVSWUJRWW
      DVYDVYPWUJWWDVYBVYHWUJWWDVYOWUJVYHWWDWUJWWDVYHVYGWUDSWUDVYFUVMVYEVYGWUDVN
      VPUVNYIUVPYJUVOYIVYNVYPVYBWUKUVQYDWWAVYFUXTWUDWVSWVAVYNWUKVYOWVAVYHVYBWVB
      XTXRVYNWVSWUJWUIVOYDWWBWWCWVPVXRWWCWVPRWUDVWEPZWWBVXRWUDUXTVUMYKWWBWWEVXR
      VXQWUDVWEUVRYMYNYOUVSYPUWGUVTUWAUWBWVMWVOWVQRJWUDWVRJUJVDZWVJWVOWVLWVQVUN
      WUDWUFUWCWWFWVKWVPJUJIUWDYHVHUWEUWHJWUFVUMXQYFWVHVUMWUFWUFVUMYQUWFXOWVCUW
      IVUMWUFUWJYFVUOWUNJWUFVVEVUNWUFVUMYRUWKUWLUWMUWQYOYSYMUWNYSYTYSYTUWRYPYTY
      MXAVULVVOVVQVULVVORZVVFVUMUYPUPZUYRWWGUYPVVEPVVFWWHQZOWWGVVCVVEUYPVVCVVDY
      GWWGVUGVUJUYPVVCPUYCUYOVUGVUJVVOUWOVUHVUJVVOUWSVVBVUJUAUYPVUFUADVDZVVAVVB
      VUJWWJVURVVAUYPVUQYQUWPWWJVUIEVUTVUCWWJVUSVUBNVUQUYPVEVFVGUWTVIUXAYEVUPWW
      IJUYPVVEJDVDVUOWWHVUNUYPVUMYRYHUXBXOWWGUYRUYPTYLZWWHVUJUYRWWKOVUHVVOVUJUY
      RUYPTUYPTLZUYPVUCPVUJVUKWWLUYPTVUCWWLUXSTVUCPTVUBPTNPUYPUXCUXGTVUBNYKUXDU
      XEVUIVUKEUYPVUCEDVDZVUAUYRWWMUYTUYQCUYSUYPWAWBYHWFUXHUXFYBWWGWWHTUYPUPZWW
      KVVOWWHWWNXCVULVUMTUYPUXIYJUYPUXJUXKUXLUXMYMUXNYTYSUXOYMYNUXPUXQUXR $.

    $( The Alexander Subbase Theorem: a space is compact iff it has a subbase
       such that any cover taken from the subbase has a finite subcover.
       (Contributed by Jeff Hankins, 24-Jan-2010.)  (Revised by Mario Carneiro,
       11-Feb-2015.) $)
    alexsubALT $p |- ( J e. Comp <-> E. x ( J = ( topGen ` ( fi ` x ) ) /\ A. c
        e.
    ~P x ( X = U. c -> E. d e. ( ~P c i^i Fin ) X = U. d ) ) ) $=
      ( vb vy vz vt vw wcel cv wceq cuni cfn wrex wi wa wss va ccmp cfi cfv ctg
      cpw cin wral wex alexsubALTlem1 alexsubALTlem4 ctop vex elpw w3a crab wel
      vf wb eleq2 3ad2ant3 eluni ssel tg2 ex syl6bi sylan9r 3impia sseq2 rspcev
      anim2d reximdv 3expia exlimdv syl5bi 3adant3 sylbid elunii expcom biimprd
      syld com23 imp3a syl9r rexlimdva rexlimdvw impbid elunirab syl6bbr ssrab2
      eqrdv elpw2 mpbir unieq eqeq2d ineq1d rexeqdv imbi12d rspcv ax-mp syl5com
      fvex pweq elfpw wf sseq1 rexbidv simprbi syl6 ralrimiv ac6sfi syl5 adantl
      elrab crn simprll frn syl cdom wbr simplr wfo dffn4 sylib adantr ad2antrl
      wfn ffn fodomfi syl2anc jca elin anbi1i bitr2i simprr ciun uniiun simprlr
      domfi ss2iun syl5eqss fniunfv sseqtrd eqsstrd sstrd uniss syl6sseqr eqssd
      3syl simpll2 exp32 rexlimdv 3exp com34 syl7bi ralrimdv fibas eleq1 mpbiri
      ctb tgcl jctild iscmp syl6ibr imp exlimiv impbii ) BUBLZBAMZUCUDZUEUDZNZC
      DMZOZNZCEMZOZNZEUVMUFZPUGZQZRZDUVIUFUHZSZAUIABCDEFUJUWDUVHAUVLUWCUVHUVLUW
      CCUAMZOZNZCGMZOZNZGUWEUFZPUGZQZRZUAUVJUFZUHZUVHABCUAGDEFUKUVLUWPBULLZUWBD
      BUFZUHZSUVHUVLUWPUWSUWQUVLUWPUWBDUWRUVMUWRLUVMBTZUVLUWPUWBUVMBDUMZUNUVLUW
      TUWPUWBUVLUWTUVOUWPUWAUVLUWTUVOUWPUWARUVLUWTUVOUOZUWPUWJGHMZIMZTZIUVMQZHU
      VJUPZUFZPUGZQZUWAUXBCUXGOZNZUWPUXJUXBJCUXKUXBJMZCLZJHUQZUXFSZHUVJQZUXMUXK
      LUXBUXNUXQUXBUXNUXMUVNLZUXQUVOUVLUXNUXRUSUWTCUVNUXMUTVAZUVLUWTUXRUXQRUVOU
      XRJKUQZKDUQZSZKUIUVLUWTSZUXQKUXMUVMVBUYCUYBUXQKUYCUXTUYAUXQUYCUYAUXTUXQUV
      LUWTUYAUXTUXQRUVLUWTUYAUOZUXTUXOUXCKMZTZSZHUVJQZUXQUVLUWTUYAUXTUYHRZUWTUY
      AUYEBLZUVLUYIUVMBUYEVCUVLUYJUYEUVKLZUYIBUVKUYEUTUYKUXTUYHHUYEUVJUXMVDVEVF
      VGVHUYDUYGUXPHUVJUYDUYFUXFUXOUYAUVLUYFUXFRUWTUYAUYFUXFUXEUYFIUYEUVMUXDUYE
      UXCVIVJVEVAVKVLWAVMWBWCVNVOVPVQUXBUXPUXNHUVJUXBUXOUXFUXNUXBUXFUXOUXNUXBUX
      EUXOUXNRIUVMUXEUXOJIUQZUXBIDUQZSUXNUXCUXDUXMVCUYMUYLUXRUXBUXNUYLUYMUXRUXM
      UXDUVMVRVSUXBUXNUXRUXSVTVGWDWEWBWCWFWGUXFHUXMUVJWHWIWKUXGUWOLZUWPUXLUXJRZ
      RUYNUXGUVJTUXFHUVJWJUXGUVJUVIUCXBWLWMUWNUYOUAUXGUWOUWEUXGNZUWGUXLUWMUXJUY
      PUWFUXKCUWEUXGWNWOUYPUWJGUWLUXIUYPUWKUXHPUWEUXGXCWPWQWRWSWTXAUXBUWJUWAGUX
      IUWHUXILUWHUXGTZUWHPLZSUXBUWJUWARZUWHUXGXDUXBUYQUYRUYSUXBUYRUYQUYSUXBUYRU
      YQUYSRUXBUYRSZUYQUWHUVMURMZXEZUXMUXMVUAUDZTZJUWHUHZSZURUIZUYSUYRUYQVUGRUX
      BUYQUXMUXDTZIUVMQZJUWHUHZUYRVUGUYQVUIJUWHUYQJGUQUXMUXGLZVUIUWHUXGUXMVCVUK
      UXMUVJLVUIUXFVUIHUXMUVJUXCUXMNUXEVUHIUVMUXCUXMUXDXFXGXNXHXIXJUYRVUJVUGVUH
      VUDJIUWHUVMURUXDVUCUXMVIXKVEXLXMUYTVUFUYSURUYTVUFUWJUWAUYTVUFUWJSZSZVUAXO
      ZUVTLZCVUNOZNZUWAVUMVUNUVMTZVUNPLZSZVUOVUMVURVUSVUMVUBVURUYTVUBVUEUWJXPZU
      WHUVMVUAXQXRZVUMUYRVUNUWHXSXTZVUSUXBUYRVULYAZVUMUYRUWHVUNVUAYBZVVCVVDVUFV
      VEUYTUWJVUBVVEVUEVUBVUAUWHYGZVVEUWHUVMVUAYHZUWHVUAYCYDYEYFUWHVUNVUAYIYJUW
      HVUNYSYJYKVUOVUNUVSLZVUSSVUTVUNUVSPYLVVHVURVUSVUNUVMUXAWLYMYNYDVUMCVUPVUM
      CUWIVUPUYTVUFUWJYOVUMUWIJUWHVUCYPZVUPVUMUWIJUWHUXMYPZVVIJUWHYQVUMVUEVVJVV
      ITUYTVUBVUEUWJYRJUWHUXMVUCYTXRUUAVUMVUBVVFVVIVUPNVVAVVGJUWHVUAUUBUUIUUCUU
      DVUMVUNBTZVUPCTVUMVUNUVMBVVBUVLUWTUVOUYRVULUUJUUEVVKVUPBOCVUNBUUFFUUGXRUU
      HUVRVUQEVUNUVTUVPVUNNUVQVUPCUVPVUNWNWOVJYJUUKVNWAVEWBWCVOUULWAUUMUUNWBUUO
      UUPUVLUWQUVKULLZUVJUUTLVVLUVIUUQUVJUVAWTBUVKULUURUUSUVBDEBCFUVCUVDWAUVEUV
      FUVG $.
  $}

  ${
    $d f g k m n t u v w x y z A $.  $d f g t u v x y K $.  $d k n u v y z S $.
    $d f g k m n t u v x y ph $.  $d k t u v x z U $.  $d g k n u w x y z V $.
    $d f g k m n t u v w x y z F $.  $d f g k m n t u v w x y z X $.
    ptcmp.1 $e |- S = ( k e. A , u e. ( F ` k ) |->
      ( `' ( w e. X |-> ( w ` k ) ) " u ) ) $.
    ptcmp.2 $e |- X = X_ n e. A U. ( F ` n ) $.
    ptcmp.3 $e |- ( ph -> A e. V ) $.
    ptcmp.4 $e |- ( ph -> F : A --> Comp ) $.
    ptcmp.5 $e |- ( ph -> X e. ( UFL i^i dom card ) ) $.
    $( Lemma for ~ ptcmp .  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    ptcmplem1 $p |- ( ph -> ( X = U. ( ran S u. { X } ) /\
      ( Xt_ ` F ) = ( topGen ` ( fi ` ( ran S u. { X } ) ) ) ) ) $=
      ( wceq cfv cv wcel cvv vg vy vz vx crn csn cun cuni cpt cfi ctg wral cdif
      wfn cfn wrex w3a cixp wa wex cab ccmp wf ffn eqid ptval syl2anc cmpt ccnv
      syl cima cmpt2 ctop wss cmptop ssriv fss sylancl uncom rneqi uneq2i eqtri
      ptbasfi fveq2i syl6eqr fveq2d eqtrd unieqd fibas unitg ax-mp syl6eq ptuni
      ctb syl5eq cpw cufl ccrd cdm cin pwexg ciun crab mptpreima ssrab2 eqsstri
      cxp wb adantr elpw2g mpbiri ralrimivva fmpt2x sylib frn ssexd unexg fiuni
      snex 3eqtr4d jca ) AJEUEZJUFZUGZUHZPHUIQZYDUJQZUKQZPAYFUHZYGUHZJYEAYIYHUH
      ZYJAYFYHAYFUARZDUNUBRZYLQZYMHQZSUBDULYNYOUHPUBDUCRUMULUCUOUPUQUDRZUBDYNUR
      PUSUAUTUDVAZUKQZYHADISZHDUNZYFYRPMADVBHVCZYTNDVBHVDVJUDUBUCDYQUAHIYQVEZVF
      VGAYQYGUKAYQYCFCDFRZHQZBJUUCBRQZVHZVICRZVKZVLZUEZUGZUJQZYGAYSDVMHVCZYQUUL
      PMAUUAVBVMVNUUMNUDVBVMYPVOVPDVBVMHVQVRZUDUBUCBCDYQUAFGHIJUUBLWCVGYDUUKUJY
      DYCYBUGUUKYBYCVSYBUUJYCEUUIKVTWAWBWDWEWFWGZWHYGWNSYKYJPYDWIYGWNWJWKWLAJGD
      GRHQUHURZYILAYSUUMUUPYIPMUUNGDHYFIYFVEWMVGWOAYDTSZYEYJPAYBTSYCTSUUQAYBJWP
      ZTAJWQWRWSWTZSZUURTSOJUUSXAVJAFDUUCUFUUDXGXBZUUREVCZYBUURVNAUUHUURSZCUUDU
      LFDULUVBAUVCFCDUUDAUUCDSUUGUUDSUSZUSZUVCUUHJVNZUUHUUEUUGSZBJXCJBJUUEUUGUU
      FUUFVEXDUVGBJXEXFUVEUUTUVCUVFXHAUUTUVDOXIUUHJUUSXJVJXKXLFCDUUDUUHUUREKXMX
      NUVAUUREXOVJXPJXSYBYCTTXQVRYDTXRVJXTUUOYA $.

    ${
      ptcmplem2.5 $e |- ( ph -> U C_ ran S ) $.
      ptcmplem2.6 $e |- ( ph -> X = U. U ) $.
      ptcmplem2.7 $e |- ( ph -> -. E. z e. ( ~P U i^i Fin ) X = U. z ) $.
      $( Lemma for ~ ptcmp .  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
      ptcmplem2 $p |- ( ph -> U_ k e. { n e. A | -. U. ( F ` n ) ~~ 1o }
          U. ( F ` k ) e. dom card ) $=
        ( vf vg vx vm cv wcel cfv cuni c1o cen wbr wn crab ciun ccrd cdm c0 wne
        wex wceq cpw cfn cin wrex wss 0ss 0fin elfpw mpbir2an unieq uni0 syl6eq
        eqeq2d rspcev mpan necon3bi syl n0 sylib wa cixp cxp cwdom cres wfo weq
        cmpt fveq2 unieqd cbvixpv eqtri inss2 sseldi adantr syl5eqelr syl5eqner
        cufl ssrab2 eqid resixpfo sylancr fonum syl2anc cdif crn wfn cvv difexg
        wral mp1i dmexg uniexg 3syl ralrimivw fnmpt dffn4 ssdif0 simpr syl6eleq
        vex csn elixp simprbi r19.21bi snssd eqssd ensn1 syl6eqbr ex cif simplr
        fvex iftrue syl5ibrcom ad2antrr iffalse wb cab ifex rgenw syl5bir con3d
        neq0 syl6ib eldifi eleq12d eleq1d pm2.61d ralrimiva ad3antrrr mptelixpg
        mpbird sylan2 unisn eleq1 pm4.71rd equequ1 ifbieq2d fvmpt neeq1d adantl
        necon1ai eldifsni ad2antlr neeq12d impbid2 bitrd pm5.32da bitr4d abbidv
        syl6eleqr df-sn df-rab 3eqtr4g ixpfn fndmdif eqtr4d syl5eqr difeq1 syld
        dmeqd exlimdv expimpd breq1d notbid elrab ax-mp ssrdv ssnum xpnum uniex
        elrnmpt 3imtr4g rabexg iunexg sylancl resixp ixpiunwdom syl3anc numwdom
        ne0i exlimddv ) AUAUEZLUFZHIUEZJUGZUHZUIUJUKZULZIEUMZHUEZJUGZUHZUNZUOUP
        ZUFZUAALUQURZUXDUAUSALBUEZUHZUTZBGVAVBVCZVDZULUXQTUYBLUQUQUYAUFZLUQUTZU
        YBUYCUQGVEUQVBUFGVFVGUQGVHVIUXTUYDBUQUYAUXRUQUTZUXSUQLUYEUXSUQUHUQUXRUQ
        VJVKVLVMVNVOVPVQZUALVRVSAUXDVTZHUXJUXMWAZUXJWBZUXOUFZUXNUYIWCUKZUXPUYGU
        YHUXOUFZUXJUXOUFZUYJUYGHEUXMWAZUXOUFUYNUYHUBUYNUBUEZUXJWDWGZWEZUYLUYGUY
        NLUXOLIEUXGWAZUYNNIHEUXGUXMIHWFZUXFUXLUXEUXKJWHWIZWJWKZALUXOUFZUXDAWQUX
        OVCUXOLWQUXOWLQWMWNZWOUYGUXJEVEZUYNUQURUYQUXIIEWRZUYGUYNLUQVUAAUXQUXDUY
        FWNWPHEUXJUXMUBUYPUYPWSWTXAUYNUYHUYPXBXCUYGUBLUYOUXCXDZUPZUHZWGZXEZUXOU
        FZUXJVUJVEUYMUYGVUBLVUJVUIWEZVUKVUCUYGVUILXFZVULUYGVUHXGUFZUBLXIVUMUYGV
        UNUBLUYGVUFXGUFZVUGXGUFVUNUYOXGUFVUOUYGUBXTUYOUXCXGXHXJVUFXGXKVUGXGXLXM
        XNUBLVUHVUIXGVUIWSZXOVQLVUIXPVSLVUJVUIXBXCUYGHUXJVUJUYGUXKEUFZUXMUIUJUK
        ZULZVTUXKVUHUTZUBLVDZUXKUXJUFUXKVUJUFZUYGVUQVUSVVAUYGVUQVTZVUSUCUEZUXMU
        XKUXCUGZYAZXDZUFZUCUSZVVAVVCVUSVVGUQUTZULVVIVVCVVJVURVVJUXMVVFVEZVVCVUR
        UXMVVFXQVVCVVKVURVVCVVKVTZUXMVVFUIUJVVLUXMVVFVVCVVKXRVVCVVFUXMVEVVKVVCV
        VEUXMUYGVVEUXMUFZHEUYGUXCUYNUFZVVMHEXIZUYGUXCLUYNAUXDXRZVUAXSZVVNUXCEXF
        ZVVOHEUXMUXCUAXTZYBYCVQYDYEWNYFVVEUXKUXCYLYGYHYIUUAUUBUCVVGUUCUUDVVCVVH
        VVAUCVVCVVHVVAVVCVVHVTZIEUYSVVDUXEUXCUGZYJZWGZLUFZUXKVWCUXCXDZUPZUHZUTZ
        VVAVVHVVCVVDUXMUFZVWDVVDUXMVVFUUEVVCVWIVTZVWCUYRLVWJVWCUYRUFZVWBUXGUFZI
        EXIZVWJVWLIEVWJUXEEUFZVTZUYSVWLVWOVWLUYSVWIVVCVWIVWNYKUYSVWBVVDUXGUXMUY
        SVVDVWAYMUYTUUFYNVWOVWLUYSULZVWAUXGUFZVWJVWQIEUYGVWQIEXIZVUQVWIUYGUXCUY
        RUFZVWRUYGUXCLUYRVVPNXSZVWSVVRVWRIEUXGUXCVVSYBYCVQYOYDVWPVWBVWAUXGUYSVV
        DVWAYPUUGYNUUHUUIVWJEKUFZVWKVWMYQAVXAUXDVUQVWIOUUJIEVWBUXGKUUKVQUULNUVK
        UUMVVTUXKUXKYAZUHVWGUXKHXTZUUNVVTVXBVWFVVTVXBUDUEZVWCUGZVXDUXCUGZURZUDE
        UMZVWFVVTUDHWFZUDYRVXDEUFZVXGVTZUDYRVXBVXHVVTVXIVXKUDVVTVXIVXJVXIVTVXKV
        VTVXIVXJVVTVXJVXIVUQUYGVUQVVHYKVXDUXKEUUOYNUUPVVTVXJVXGVXIVVTVXJVTZVXGV
        XIVVDVXFYJZVXFURZVXIVXJVXGVXNYQVVTVXJVXEVXMVXFIVXDVWBVXMEVWCIUDWFUYSVXI
        VWAVXFVVDIUDHUUQUXEVXDUXCWHUURVWCWSZVXIVVDVXFUCXTZVXDUXCYLYSUUSUUTUVAVX
        LVXNVXIVXIVXMVXFVXIVVDVXFYPUVBVXLVXNVXIVVDVVEURZVVHVXQVVCVXJVVDUXMVVEUV
        CUVDVXIVXMVVDVXFVVEVXIVVDVXFYMVXDUXKUXCWHUVEYNUVFUVGUVHUVIUVJUDUXKUVLVX
        GUDEUVMUVNVVTVWCEXFZVVRVWFVXHUTVWBXGUFZIEXIVXRVVTVXSIEUYSVVDVWAVXPUXEUX
        CYLYSYTIEVWBVWCXGVXOXOXJUYGVVRVUQVVHUYGVWSVVRVWTIEUXGUXCUVOVQYOUDEVWCUX
        CUVPXCUVQWIUVRVUTVWHUBVWCLUYOVWCUTZVUHVWGUXKVXTVUGVWFVXTVUFVWEUYOVWCUXC
        UVSUWAWIVMVNXCYIUWBUVTUWCUXIVUSIUXKEUYSUXHVURUYSUXGUXMUIUJUYTUWDUWEUWFU
        XKXGUFVVBVVAYQVXCUBLVUHUXKVUIXGVUPUWLUWGUWMUWHVUJUXJUWIXCUYHUXJUWJXCUYG
        UXJXGUFZUXNXGUFZUYHUQURZUYKUYGVXAVYAAVXAUXDOWNUXIIEKUWNVQZUYGVYAUXMXGUF
        ZHUXJXIVYBVYDVYEHUXJUXLUXKJYLUWKYTHUXJUXMXGXGUWOUWPUYGUXCUXJWDZUYHUFZVY
        CUYGVUDVVNVYGVUEVVQHEUXJUXMUXCUWQXAUYHVYFUXAVQHUXJUXMXGXGUWRUWSUYIUXNUW
        TXCUXB $.

      ptcmplem3.8 $e |- K =
        { u e. ( F ` k ) | ( `' ( w e. X |-> ( w ` k ) ) " u ) e. U } $.
      $( Lemma for ~ ptcmp .  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
      ptcmplem3 $p |- ( ph -> E. f ( f Fn A /\
          A. k e. A ( f ` k ) e. ( U. ( F ` k ) \ U. K ) ) ) $=
        ( vg vy vt vx vm cv cfv cuni c1o cen wbr wn crab cvv cdif wcel wral wfn
        wex ciun ccrd cdm wrex rabexg syl wss ptcmplem2 eldifi 3ad2ant3 rabssdv
        wf ralrimivw ss2iun ssnum syl2anc elrabi wceq cpw cfn cin adantr ssdif0
        wa c0 ccmp ffvelrnda cmpt ccnv cima ssrab2 eqsstri a1i simpr uniss mp1i
        eqssd eqid cmpcov syl3anc crn simplbi ad2antrl sselda weq imaeq2 eleq1d
        elfpw elrab2 simprbi fmptd frn cab rnmpt abrexfi syl5eqel sylanbrc cixp
        simp-4r syl6eleq vex elixp fveq2 unieqd simplrr eleqtrd sylib sylibr ex
        fveq1 ralrimiva cif fvex uniex ifex wi breq1d exlimddv eleq12d rspcv wb
        sylc eluni2 mptpreima baib ad2antlr rexbidva mpbird eliun ssrdv dfiun2g
        unieqi syl6eqr sseqtrd unissd ad3antrrr sseqtr4d unieq eqeq2d rexlimddv
        rspcev syl5bir mtod neq0 sylan2 eleq1 ac6num mptexg rgenw notbid ralrab
        rexv fnmpt iftrue ad2antll adantrr adantl en1b eqeltrrd adantlr eqeltrd
        csn elsni a1d expr pm2.27 iffalse sylibrd pm2.61d1 ralimdva syl5bi impr
        fneq1 ifbieq12d fvmpt sylan9eq ralbidva anbi12d spcegv 3impib ) AJUIZKU
        JZUKZULUMUNZUOZJEUPZUQUDUIZVNZIUIZUXIUJZUXKKUJZUKZLUKZURZUSZIUXHUTZWFZH
        UIZEVAZUXKUXTUJZUXPUSZIEUTZWFZHVBZUDAUXHUQUSZIUXHUEUIZUXPUSZUEUQUPZVCZV
        DVEZUSZUYIUEUQVFZIUXHUTUXSUDVBAEMUSZUYGQUXGJEMVGVHAIUXHUXNVCZUYLUSUYKUY
        PVIZUYMABCDEFGIJKMNOPQRSTUAUBVJAUYJUXNVIZIUXHUTUYQAUYRIUXHAUYIUEUQUXNUY
        IAUYHUXNUSZUYHUQUSUYHUXNUXOVKZVLVMVOIUXHUYJUXNVPVHUYPUYKVQVRAUYNIUXHUXK
        UXHUSAUXKEUSZUYNUXGJUXKEVSAVUAWFZUYIUEVBZUYNVUBUXPWGVTZUOVUCVUBVUDNBUIZ
        UKZVTZBGWAWBWCZVFZAVUIUOVUAUBWDVUDUXNUXOVIZVUBVUIUXNUXOWEVUBVUJVUIVUBVU
        JWFZUXNUFUIZUKZVTZVUIUFLWAWBWCZVUKUXMWHUSZLUXMVIZUXNUXOVTVUNUFVUOVFVUBV
        UPVUJAEWHUXKKRWIWDVUQVUKLCNUXKCUIZUJZWJZWKZDUIZWLZGUSZDUXMUPUXMUCVVDDUX
        MWMWNZWOVUKUXNUXOVUBVUJWPVUQUXOUXNVIVUKVVELUXMWQWRWSLUXMUXNUFUXNWTXAXBV
        UKVULVUOUSZVUNWFZWFZUGVULVVAUGUIZWLZWJZXCZVUHUSZNVVLUKZVTZVUIVVHVVLGVIZ
        VVLWBUSZVVMVVHVULGVVKVNVVPVVHUGVULVVJGVVKVVHVVIVULUSZWFVVILUSZVVJGUSZVV
        HVULLVVIVVFVULLVIZVUKVUNVVFVWAVULWBUSZVULLXJZXDXEXFVVSVVIUXMUSVVTVVDVVT
        DVVIUXMLDUGXGVVCVVJGVVBVVIVVAXHXIUCXKXLVHZVVKWTZXMVULGVVKXNVHZVVHVWBVVQ
        VVFVWBVUKVUNVVFVWAVWBVWCXLXEVWBVVLUXTVVJVTUGVULVFHXOZWBUGHVULVVJVVKVWEX
        PZUGHVULVVJXQXRVHVVLGXJXSVVHNVVNVVHNUGVULVVJVCZVVNVVHHNVWIVVHUXTNUSZUXT
        VWIUSZVVHVWJWFZUXTVVJUSZUGVULVFZVWKVWLVWNUYBVVIUSZUGVULVFZVWLUYBVUMUSVW
        PVWLUYBUXNVUMVWLVUAUXCUXTUJZUXEUSZJEUTZUYBUXNUSZAVUAVUJVVGVWJYAVWLUXTJE
        UXEXTZUSZVWSVWLUXTNVXAVVHVWJWPPYBVXBUYAVWSJEUXEUXTHYCYDXLVHVWRVWTJUXKEJ
        IXGZVWQUYBUXEUXNUXCUXKUXTYEVXCUXDUXMUXCUXKKYEYFZUUAUUBUUDVUKVVFVUNVWJYG
        YHUGUYBVULUUEYIVWLVWMVWOUGVULVWJVWMVWOUUCVVHVVRVWMVWJVWOVUSVVIUSVWOCUXT
        NVVJCHXGVUSUYBVVIUXKVURUXTYLXICNVUSVVIVUTVUTWTUUFXKUUGUUHUUIUUJUGUXTVUL
        VVJUUKYJYKUULVVHVWIVWGUKZVVNVVHVVTUGVULUTVWIVXEVTVVHVVTUGVULVWDYMUGHVUL
        VVJGUUMVHVVLVWGVWHUUNUUOUUPVVHVVNGUKZNVVHVVLGVWFUUQANVXFVTVUAVUJVVGUAUU
        RUUSWSVUGVVOBVVLVUHVUEVVLVTVUFVVNNVUEVVLUUTUVAUVCVRUVBYKUVDUVEUEUXPUVFY
        IZUYIUEUVNYJUVGYMUYIUXQIUEUXHUQUDUQUYHUXLUXPUVHUVIXBAUXSWFZUHEUHUIZKUJZ
        UKZULUMUNZVXKUKZVXIUXIUJZYNZWJZUQUSZVXPEVAZUXNULUMUNZUXNUKZUXLYNZUXPUSZ
        IEUTZUYFVXHUYOVXQAUYOUXSQWDUHEVXOMUVJVHVXOUQUSZUHEUTVXRVXHVYDUHEVXLVXMV
        XNVXKVXJVXIKYOYPYPVXIUXIYOYQUVKUHEVXOVXPUQVXPWTZUVOWRAUXJUXRVYCUXRVXSUO
        ZUXQYRZIEUTAUXJWFZVYCUXGVYFUXQIJEVXCUXFVXSVXCUXEUXNULUMVXDYSUVLUVMVYHVY
        GVYBIEVYHVUAWFVXSVYGVYBYRZVYHVUAVXSVYIVYHVUAVXSWFZWFZVYBVYGVYKVYAVXTUXP
        VXSVYAVXTVTVYHVUAVXSVXTUXLUVPUVQAVYJVXTUXPUSZUXJAVYJWFZUYIVYLUEAVUAVUCV
        XSVXGUVRVYMUYIWFZUYHVXTUXPVYNUYHVXTUWDZUSUYHVXTVTVYNUYHUXNVYOUYIUYSVYMU
        YTUVSVYNVXSUXNVYOVTAVUAVXSUYIYGUXNUVTYIYHUYHVXTUWEVHVYMUYIWPUWAYTUWBUWC
        UWFUWGVYFVYGUXQVYBVYFUXQUWHVYFVYAUXLUXPVXSVXTUXLUWIXIUWJUWKUWLUWMUWNVXQ
        VXRVYCUYFUYEVXRVYCWFHVXPUQUXTVXPVTZUYAVXRUYDVYCEUXTVXPUWOVYPUYCVYBIEVYP
        VUAWFUYBVYAUXPVYPVUAUYBUXKVXPUJVYAUXKUXTVXPYLUHUXKVXOVYAEVXPUHIXGZVXLVX
        SVXMVXNVXTUXLVYQVXKUXNULUMVYQVXJUXMVXIUXKKYEYFZYSVYQVXKUXNVYRYFVXIUXKUX
        IYEUWPVYEVXSVXTUXLUXNUXMUXKKYOYPYPUXKUXIYOYQUWQUWRXIUWSUWTUXAUXBXBYT $.

      $( Lemma for ~ ptcmp .  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
      ptcmplem4 $p |- -. ph $=
        ( vf vv cv wfn cfv cuni cdif wcel wral wex ptcmplem3 wrex simprl eldifi
        cixp ralimi wceq fveq2 unieqd eleq12d cbvralv sylibr ad2antll vex elixp
        wa sylanbrc syl6eleqr adantr eleqtrd eluni2 sylib cmpt ccnv cima simprr
        wi simplrr fveq1 eleq1d eqid mptpreima elrab2 simprbi syl crab eqeltrrd
        simplrl rabid elunii syl2anc rexlimdvaa expr ralimdva ex com23 impr imp
        cab crn wss sselda adantrr rnmpt2 syl6eleq abid rexim sylc rexlimddv wn
        eldifn ralnex pm2.65da nexdv pm2.65i ) AUCUEZEUFZHUEZXRUGZXTJUGZUHZKUHZ
        UIUJZHEUKZVHZUCULABCDEFGUCHIJKLMNOPQRSTUAUBUMAYGUCAYGYAYDUJZHEUNZAYGVHZ
        XRUDUEZUJZYIUDGYJXRGUHZUJYLUDGUNYJXRMYMYJXRIEIUEZJUGZUHZUQZMYJXSYNXRUGZ
        YPUJZIEUKZXRYQUJAXSYFUOYFYTAXSYFYAYCUJZHEUKYTYEUUAHEYAYCYDUPURYSUUAIHEY
        NXTUSZYRYAYPYCYNXTXRUTUUBYOYBYNXTJUTVAVBVCVDVEIEYPXRUCVFVGVIOVJAMYMUSYG
        TVKVLUDXRGVMVNYJYKGUJZYLVHZVHZYKCMXTCUEZUGZVOZVPDUEZVQZUSZDYBUNZYHVSZHE
        UKZUULHEUNZYIYJUUDUUNAXSYFUUDUUNVSAXSVHZUUDYFUUNUUPUUDYFUUNVSUUPUUDVHZY
        EUUMHEUUQXTEUJZYEUUMUUQUURYEVHZVHZUUKYHDYBUUTUUIYBUJZUUKVHZVHZYAUUIUJZU
        UIKUJYHUVCXRUUJUJZUVDUVCXRYKUUJUUTYLUVBUUPUUCYLUUSVTVKUUTUVAUUKVRZVLUVE
        XRMUJUVDUUGUUIUJUVDCXRMUUJUUFXRUSUUGYAUUIXTUUFXRWAWBCMUUGUUIUUHUUHWCWDW
        EWFWGUVCUUIUUJGUJZDYBWHZKUVCUVAUVGUUIUVHUJUUTUVAUUKUOUVCYKUUJGUVFUUTUUC
        UVBUUPUUCYLUUSWJVKWIUVGDYBWKVIUBVJYAUUIKWLWMWNWOWPWQWRWSWTUUEYKUUOUDXAZ
        UJUUOUUEYKFXBZUVIYJUUCYKUVJUJYLYJGUVJYKAGUVJXCYGSVKXDXEHDUDEYBUUJFNXFXG
        UUOUDXHVNUULYHHEXIXJXKYJYHXLZHEUKZYIXLYFUVLAXSYEUVKHEYAYCYDXMURVEYHHEXN
        VNXOXPXQ $.
    $}

    $d z ph $.
    $( Lemma for ~ ptcmp .  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    ptcmplem5 $p |- ( ph -> ( Xt_ ` F ) e. Comp ) $=
      ( vz cfv wceq wa wcel crn csn cun cpt cufl ccrd cdm cin inss1 sseldi cuni
      vy cfi ctg ptcmplem1 simpld simprd cv wss cpw cfn wrex wi elpwi cmpt ccnv
      wn cima crab ad2antrr ccmp wf simplrl simplrr simpr imaeq2 eleq1d cbvrabv
      ptcmplem4 iman mpbir expr sylan2 adantlr elpw cdif eldif elpwunsn sylanbr
      vex sylbir adantll snssi adantl snfi a1i elfpw unisng eqcomd unieq eqeq2d
      sylanbrc rspcev syl2anc a1d syldan pm2.61dan impr alexsub ) AULPEUAZJUBZU
      CZHUDQZJAUEUFUGZUHZUEJUEXNUIOUJAJXLUKRZXMXLUMQUNQRZABCDEFGHIJKLMNOUOZUPAX
      PXQXRUQAULURZXLUSZJXSUKRZJPURZUKZRZPXSUTVAUHZVBZAXTSZXSXJUTZTZYAYFVCZAYIY
      JXTYIAXSXJUSZYJXSXJVDAYKYAYFAYKYASZSZYFVCYMYFVGZSZVGYOPBCDEXSFGHBJFURZBUR
      QVEVFZYBVHZXSTZPYPHQZVIIJKLADITYLYNMVJADVKHVLYLYNNVJAJXOTYLYNOVJAYKYAYNVM
      AYKYAYNVNYMYNVOYSYQCURZVHZXSTPCYTYBUUARYRUUBXSYBUUAYQVPVQVRVSYMYFVTWAWBWC
      WDYGYIVGZJXSTZYJXTUUCUUDAXTXSXLUTZTZUUCUUDXSXLULWJWEUUFUUCSXSUUEYHWFTUUDX
      SUUEYHWGXSXJJWHWKWIWLYGUUDSZYFYAUUGXKYETZJXKUKZRZYFUUGXKXSUSZXKVATZUUHUUD
      UUKYGJXSWMWNUULUUGJWOWPXKXSWQXBUUDUUJYGUUDUUIJJXSWRWSWNYDUUJPXKYEYBXKRYCU
      UIJYBXKWTXAXCXDXEXFXGXHXI $.
  $}

  ${
    $d a b k m n u w x A $.  $d a b k m n u w x F $.  $d k m n u w V $.
    $d k m u X $.
    ptcmpg.1 $e |- J = ( Xt_ ` F ) $.
    ptcmpg.2 $e |- X = U. J $.
    $( Tychonoff's theorem:  The product of compact spaces is compact.  The
       choice principles needed are encoded in the last hypothesis: the base
       set of the product must be well-orderable and satisfy the ultrafilter
       lemma.  Both these assumptions are satisfied if ` ~P ~P X ` is
       well-orderable, so if we assume the Axiom of Choice we can eliminate
       them (see ~ ptcmp ).  (Contributed by Mario Carneiro, 27-Aug-2015.) $)
    ptcmpg $p |- ( ( A e. V /\ F : A --> Comp /\ X e. ( UFL i^i dom card ) ) ->
        J e. Comp ) $=
      ( vw vu va vb vn vk vm ccmp cfv cv cuni nfcv ctop wcel wf cdm cin w3a cpt
      cufl ccrd cixp cmpt ccnv cmpt2 fveq2 weq mpteq2dv cnveqd imaeq1d sylan9eq
      cima imaeq2 cbvmpt2x unieqd cbvixpv simp1 simp2 wceq wss cmptop ssriv fss
      sylancl ptuni syl2anc syl6eqr simp3 eqeltrd ptcmplem5 syl5eqel ) ADUAZAOB
      UBZEUGUHUCUDZUAZUEZCBUFPOFWCHIAJKAJQZBPZHLALQZBPZRZUIZWDHQZPZUJZUKZKQZUSZ
      ULMNBDWIJKMIAWEWOMQZBPZHWIWPWJPZUJZUKZIQZUSZMWESJWQSMWOSIWOSJXBSKXBSWDWPB
      UMJMUNZKIUNWOWTWNUSXBXCWMWTWNXCWLWSXCHWIWKWRWDWPWJUMUOUPUQWNXAWTUTURVALNA
      WHNQZBPZRLNUNWGXEWFXDBUMVBVCVSVTWBVDZVSVTWBVEZWCWIEWAWCWICRZEWCVSATBUBZWI
      XHVFXFWCVTOTVGXIXGMOTWPVHVIAOTBVJVKLABCDFVLVMGVNVSVTWBVOVPVQVR $.
  $}

  $( Tychonoff's theorem:  The product of compact spaces is compact.  The proof
     uses the Axiom of Choice.  (Contributed by Mario Carneiro,
     26-Aug-2015.) $)
  ptcmp $p |- ( ( A e. V /\ F : A --> Comp ) -> ( Xt_ ` F ) e. Comp ) $=
    ( wcel ccmp cpt cfv cuni cufl ccrd cdm cin cvv fvex uniex wac wceq eleqtrri
    wf eqid axac3 acufl ax-mp cardeqv elin mpbir2an ptcmpg mp3an3 ) ACDAEBSBFGZ
    HZIJKZLDZUIEDULUJIDUJUKDUJMIUIBFNOZPIMQUAUBUCRUJMUKUMUDRUJIUKUEUFABUICUJUIT
    UJTUGUH $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Extension by continuity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CnExt $.

  $( Extend class notation with the continuous extension operation. $)
  ccnext $a class CnExt $.

  ${
    $d j k f x $.
    $( Define the continuous extension of a given function.  (Contributed by
       Thierry Arnoux, 1-Dec-2017.) $)
    df-cnext $a |- CnExt = ( j e. Top , k e. Top |->
      ( f e. ( U. k ^pm U. j ) |-> U_ x e. ( ( cls ` j ) ` dom f ) ( { x } X.
      ( ( k fLimf ( ( ( nei ` j ) ` { x } ) |`t dom f ) ) ` f ) ) ) ) $.
  $}

  ${
    $d f j k x J $.  $d f j k x K $.
    $( The function applying continuous extension to a given function ` f ` .
       (Contributed by Thierry Arnoux, 1-Dec-2017.) $)
    cnextval $p |- ( ( J e. Top /\ K e. Top ) -> ( J CnExt K )
      = ( f e. ( U. K ^pm U. J ) |-> U_ x e. ( ( cls ` J ) ` dom f ) ( { x } X.
      ( ( K fLimf ( ( ( nei ` J ) ` { x } ) |`t dom f ) ) ` f ) ) ) ) $=
      ( vj vk ctop cv cuni cpm co ccl cfv cnei crest cflf cxp ciun cmpt fveq1d
      cdm ccnext wceq unieq oveq2d fveq2 oveq1d xpeq2d iuneq12d mpteq12dv oveq1
      csn iuneq2d df-cnext ovex mptex ovmpt2 ) EFCDGGBFHZIZEHZIZJKZABHZUAZUTLMZ
      MZAHULZVCURVGUTNMZMZVDOKZPKZMZQZRZSBDIZCIZJKZAVDCLMZMZVGVCDVGCNMZMZVDOKZP
      KZMZQZRZSUBBUSVPJKZAVSVGVCURWBPKZMZQZRZSUTCUCZBVBVNWGWKWLVAVPUSJUTCUDUEWL
      AVFVSVMWJWLVDVEVRUTCLUFTWLVLWIVGWLVCVKWHWLVJWBURPWLVIWAVDOWLVGVHVTUTCNUFT
      UGUETUHUIUJURDUCZBWGWKVQWFWMUSVOVPJURDUDUGWMAVSWJWEWMWIWDVGWMVCWHWCURDWBP
      UKTUHUMUJABEFUNBVQWFVOVPJUOUPUQ $.

    $d f x A $.  $d f x B $.  $d f x F $.  $d f x X $.
    cnextfval.1 $e |- X = U. J $.
    cnextfval.2 $e |- B = U. K $.
    $( The continuous extension of a given function ` F ` .  (Contributed by
       Thierry Arnoux, 1-Dec-2017.) $)
    cnextfval $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( F : A --> B /\ A C_ X ) )
      -> ( ( J CnExt K ) ` F ) = U_ x e. ( ( cls ` J ) ` A ) ( { x } X.
      ( ( K fLimf ( ( ( nei ` J ) ` { x } ) |`t A ) ) ` F ) ) ) $=
      ( vf ctop wcel wa wf cfv crest co cflf cvv wceq wss cdm ccl csn cnei ciun
      cv cxp cuni cpm ccnext cmpt cnextval adantr simpr dmeqd simplrl fdm eqtrd
      syl fveq2d oveq2d fveq12d xpeq2d iuneq12d uniexg ad2antlr ad2antrr feq23i
      eqid biimpi ad2antrl sseq2i ad2antll elpm2r syl22anc fvex snex xpex iunex
      a1i fvmptd ) EKLZFKLZMZBCDNZBGUAZMZMZJDAJUGZUBZEUCOZOZAUGZUDZWJFWOEUEOOZW
      KPQZRQZOZUHZUFZABWLOZWODFWPBPQZRQZOZUHZUFZFUIZEUIZUJQZEFUKQZSWEXKJXJXAULT
      WHAJEFUMUNWIWJDTZMZAWMXBWTXFXMWKBWLXMWKDUBZBXMWJDWIXLUOZUPXMWFXNBTWEWFWGX
      LUQBCDURUTUSZVAXMWSXEWOXMWJDWRXDXMWQXCFRXMWKBWPPXPVBVBXOVCVDVEWIXHSLZXISL
      ZBXHDNZBXIUAZDXJLWDXQWCWHFKVFVGWCXRWDWHEKVFVHWFXSWEWGWFXSBCBXHDBVJIVIVKVL
      WGXTWEWFWGXTGXIBHVMVKVNXHXIBDSSVOVPXGSLWIAXBXFBWLVQWOXEWNVRDXDVQVSVTWAWB
      $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.  $d x J $.  $d x K $.
    cnextfrel.1 $e |- C = U. J $.
    cnextfrel.2 $e |- B = U. K $.
    $( In the general case, a continuous extension is a relation.  (Contributed
       by Thierry Arnoux, 20-Dec-2017.) $)
    cnextrel $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( F : A --> B /\ A C_ C ) )
      -> Rel ( ( J CnExt K ) ` F ) ) $=
      ( vx ctop wcel wa wf wss ccnext co cfv wrel ccl cv csn cnei cflf cxp ciun
      crest wral relxp rgenw reliun mpbir cnextfval releqd mpbiri ) EJKFJKLABDM
      ACNLLZDEFOPQZRIAESQQZITUAZDFUREUBQQAUFPUCPQZUDZUEZRZVBUTRZIUQUGVCIUQURUSU
      HUIIUQUTUJUKUOUPVAIABDEFCGHULUMUN $.

    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y F $.  $d y J $.  $d y K $.
    $( If the target space is Hausdorff, a continuous extension is a function
       (Contributed by Thierry Arnoux, 20-Dec-2017.) $)
    cnextfun $p |- ( ( ( J e. Top /\ K e. Haus ) /\ ( F : A --> B /\ A C_ C ) )
      -> Fun ( ( J CnExt K ) ` F ) ) $=
      ( vx vy ctop wcel wa wss co cfv cv wmo wal sylanl2 cha wf ccnext wrel wbr
      wfun haustop cnextrel ccl cnei crest cflf wi cfil simpllr ctopon toptopon
      csn biimpi ad3antrrr simplrr sylibr clsss3 syl2anc simpr sseldd w3a trnei
      biimpa syl31anc simplrl hausflf syl3anc ex alrimiv moanimv albii cop ciun
      cxp df-br a1i wceq cnextfval eleq2d opeliunxp 3bitrd mobidv albidv mpbird
      wb dffun6 sylanbrc ) EKLZFUALZMZABDUBZACNZMZMZDEFUCOPZUDZIQZJQZXAUEZJRZIS
      ZXAUFWOWNFKLZWSXBFUGZABCDEFGHUHTWTXGXCAEUIPPZLZXDDFXCURZEUJPPAUKOZULOPZLZ
      MZJRZISZWTXKXOJRZUMZISXRWTXTIWTXKXSWTXKMZWOXMAUNPLZWQXSWNWOWSXKUOYAECUPPL
      ZWRXCCLZXKYBWNYCWOWSXKWNYCECGUQZUSUTZWPWQWRXKVAZYAXJCXCYAWNWRXJCNYAYCWNYF
      YEVBYGAECGVCVDWTXKVEZVFYHYCWRYDVGXKYBAXCECVHVIVJWPWQWRXKVKJDFXMBAHVLVMVNV
      OXQXTIXKXOJVPVQVBWTXFXQIWTXEXPJWTXEXCXDVRZXALZYIIXJXLXNVTVSZLZXPXEYJWKWTX
      CXDXAWAWBWTXAYKYIWOWNXHWSXAYKWCXIIABDEFCGHWDTWEYLXPWKWTIXJXNXDWFWBWGWHWIW
      JIJXAWLWM $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x C $.  $d x y F $.  $d x y J $.  $d x y K $.
    $d x y X $.  $d x y ph $.
    cnextf.1 $e |- C = U. J $.
    cnextf.2 $e |- B = U. K $.
    cnextf.3 $e |- ( ph -> J e. Top ) $.
    cnextf.4 $e |- ( ph -> K e. Haus ) $.
    cnextf.5 $e |- ( ph -> F : A --> B ) $.
    cnextf.a $e |- ( ph -> A C_ C ) $.
    cnextf.6 $e |- ( ph -> ( ( cls ` J ) ` A ) = C ) $.
    cnextf.7 $e |- ( ( ph /\ x e. C ) ->
             ( ( K fLimf ( ( ( nei ` J ) ` { x } ) |`t A ) ) ` F ) =/= (/) ) $.
    $( The value of the continuous extension of a given function ` F ` at a
       point ` X ` .  (Contributed by Thierry Arnoux, 21-Dec-2017.) $)
    cnextfvval $p |- ( ( ph /\ X e. C ) -> ( ( ( J CnExt K ) ` F ) ` X ) =
      U. ( ( K fLimf ( ( ( nei ` J ) ` { X } ) |`t A ) ) ` F ) ) $=
      ( wcel cfv adantr wa ccnext co wfun csn cnei crest cflf cuni wbr wceq cha
      ctop wf wss cnextfun syl22anc cop ccl cv cxp ciun biimpar fvex uniex snid
      eleq2d c1o cen wi sneq fveq2d oveq1d oveq2d fveq1d breq1d imbi2d cfil wne
      c0 ctopon toptopon sylib simpr w3a trnei biimpa syl31anc hausflf2 vtoclga
      expcom impcom en1b syl5eleqr nfcv nfiu1 nfel2 nfv nfbi opeq1 eleq1d eleq1
      wb anbi12d bibi12d opeliunxp vtoclgf adantl mpbir2and df-br syl cnextfval
      haustop syl5bb mpbird funbrfv sylc ) AIERZUAZFGHUBUCSZUDZIFHIUEZGUFSZSZCU
      GUCZUHUCZSZUIZXTUJZIXTSYHUKXSGUMRZHULRZCDFUNZCEUOZYAAYJXRLTZAYKXRMTAYLXRN
      TZAYMXROTZCDEFGHJKUPUQXSYIIYHURZBCGUSSSZBUTZUEZFHYTYCSZCUGUCZUHUCZSZVAZVB
      ZRZXSUUGIYRRZYHYGRZAUUHXRAYREIPVGVCXSYHYHUEZYGYHYGFYFVDVEVFXSYGVHVIUJZYGU
      UJUKXRAUUKAUUDVHVIUJZVJAUUKVJBIEYSIUKZUULUUKAUUMUUDYGVHVIUUMFUUCYFUUMUUBY
      EHUHUUMUUAYDCUGUUMYTYBYCYSIVKVLVMVNVOZVPVQAYSERZUULAUUOUAZYKUUBCVRSRZYLUU
      DVTVSUULAYKUUOMTUUPGEWASRZYMUUOYSYRRZUUQUUPYJUURAYJUUOLTGEJWBWCAYMUUOOTAU
      UOWDAUUSUUOAYREYSPVGVCUURYMUUOWEUUSUUQCYSGEWFWGWHAYLUUONTQFHUUBDCKWIWHWKW
      JWLYGWMWCWNXRUUGUUHUUIUAZXCZAYSYHURZUUFRZUUSYHUUDRZUAZXCUVABIEBIWOUUGUUTB
      BYQUUFBYRUUEWPWQUUTBWRWSUUMUVCUUGUVEUUTUUMUVBYQUUFYSIYHWTXAUUMUUSUUHUVDUU
      IYSIYRXBUUMUUDYGYHUUNVGXDXEBYRUUDYHXFXGXHXIYIYQXTRXSUUGIYHXTXJXSXTUUFYQXS
      YJHUMRZYLYMXTUUFUKYNAUVFXRAYKUVFMHXMXKTYOYPBCDFGHEJKXLUQVGXNXOIYHXTXPXQ
      $.

    $( Extension by continuity.  The extension by continuity is a function.
       (Contributed by Thierry Arnoux, 25-Dec-2017.) $)
    cnextf $p |- ( ph -> ( ( J CnExt K ) ` F ) : C --> B ) $=
      ( vy cfv wss wcel ccnext wfn crn wfun cdm wceq ctop cha cnextfun syl22anc
      co wf cv cop wex cab wa ccl csn cnei crest simpl eleq2d biimpar c0 wne n0
      cflf sylib ciun haustop cnextfval opeliunxp syl6bb exbidv 19.42v syl12anc
      cxp syl simprbda adantr mpbid impbida dfdm3 syl6reqr df-fn sylanbrc rneqd
      wb abbi2dv rniun wral vex snnz rnxp ax-mp biimpa ctopon cfil toptopon w3a
      simpr trnei syl31anc flfelbas ex syl3anc syldan syl5eqss ralrimiva sylibr
      ssrdv iunss eqsstrd df-f ) AFGHUAUKRZEUBZXPUCZDSEDXPULAXPUDZXPUEZEUFXQAGU
      GTZHUHTZCDFULZCESZXSKLMNCDEFGHIJUIUJAEBUMZQUMZUNZXPTZQUOZBUPXTAYIBEAYEETZ
      YIAYJUQZAYECGURRRZTZYFFHYEUSZGUTRRCVAUKZVHUKRZTZQUOZYIAYJVBAYMYJAYLEYEOVC
      ZVDZYKYPVEVFYRPQYPVGVIAYIYMYRUQZAYIYMYQUQZQUOUUAAYHUUBQAYHYGBYLYNYPVRZVJZ
      TUUBAXPUUDYGAYAHUGTZYCYDXPUUDUFKAYBUUELHVKVSZMNBCDFGHEIJVLUJZVCBYLYPYFVMV
      NVOYMYQQVPVNZVDVQAYIUQYMYJAYIYMYRUUHVTAYMYJWIYIYSWAWBWCWJBQXPWDWEXPEWFWGA
      XRUUDUCZDAXPUUDUUGWHAUUIBYLUUCUCZVJZDBYLUUCWKAUUJDSZBYLWLUUKDSAUULBYLAYMU
      QUUJYPDYNVEVFUUJYPUFYEBWMWNYNYPWOWPAYMYJYPDSZAYMYJYSWQYKHDWRRTZYOCWSRTZYC
      UUMAUUNYJAUUEUUNUUFHDJWTVIWAYKGEWRRTZYDYJYMUUOAUUPYJAYAUUPKGEIWTVIWAAYDYJ
      NWAAYJXBYTUUPYDYJXAYMUUOCYEGEXCWQXDAYCYJMWAUUNUUOYCXAZQYPDUUQYQYFDTYFFHYO
      DCXEXFXLXGXHXIXJBYLUUJDXMXKXIXNEDXPXOWG $.

    $d b d u v x y z A $.  $d b u v w x y B $.  $d b c d u v w x y C $.
    $d b c d u v w x y z F $.  $d b c d u v w x y z J $.
    $d b c d u v w x y z K $.  $d x y X $.  $d b c d u v w x y z ph $.
    cnextcn.8 $e |- ( ph -> K e. Reg ) $.
    $( Extension by continuity.  Theorem 1 of [BourbakiTop1] p.  I.57.  Given a
       topology ` J ` on ` C ` , a subset ` A ` dense in ` C ` , this states a
       condition for ` F ` from ` A ` to a regular space ` K ` to be extensible
       by continuity (Contributed by Thierry Arnoux, 1-Jan-2018.) $)
    cnextcn $p |- ( ph -> ( ( J CnExt K ) ` F ) e. ( J Cn K ) ) $=
      ( cfv wcel wa vv vw vz vd vu vb vy vc ccnext co ccn cv cima wss cnei wrex
      csn wral simpll cin ccl w3a simpr3 ctop ad2antrr simpr2 neii2 syl2anc vex
      wi snss biimpri anim1i anim2i 3anass anbi1i anbi2i 3bitri opnneip syl3an1
      ex anass adantr cha syl clsss syl3anc sstr sylan anim2d reximdv2 syl21anc
      wf imp crest simpr simplr wceq cvv fvex a1i ctopon toptopon sylib reximdv
      wb fveq2d cflf cuni wne weq eleq1 anbi2d sneq oveq1d oveq2d fveq1d neeq1d
      c0 imbi12d chvarv cnextfvval uniex c1o cen wbr eleq2d biimpar trnei mpbid
      hausflf2 syl31anc en1b eqeltrd neii1 mpd r19.29a sylc sseldd ralrimiva
      imdistanri jca sylbir syl6 haustop crn imassrn syl5ss ssrin imass2 adantl
      frn an32s syld 3anassrs simp-4l elfvexd ssexd elrest biimpa imaeq2 sseq1d
      biimpcd syl5 syl12anc simplll snid cfil syl5eleqr flfnei simprd ad3antrrr
      r19.21bi 3an1rs adantllr creg simprl regsep expcom ad2antll reximi 3expib
      anim1d syl5bir eltopss 3expa elrestr cfm cflim flfval cfg uniexg syl5eqel
      cfbas filfbas fgfil eleqtrrd eqid imaelfm flimclsi eqsstrd sylibr adantlr
      eqsstr3d expl wfun cdm ffun fdm sseqtr4d funimass4 biimprd reximdva cnnei
      cnextf mpbird ) AFGHUIUJRZGHUKUJSZUXQUAULZUMUBULZUNZUABULZUQZGUORZRZUPZUB
      UYBUXQRZUQZHUORRZURZBEURZAUYJBEAUYBESZTZUYFUBUYIUYMUXTUYISZTZAUCULZUXQRZU
      XTSZUCUXSURZUAUYEUPZUYFAUYLUYNUSUYOUXSGSZFUXSCUTZUMZHVARZRZUXTUNZTZUAUYEU
      PZUYTUYOFUDULZCUTZUMZVUDRZUXTUNZVUHUDUYEUYMUYNVUIUYESZVUMVUHUYMUYNVUNVUMV
      BZTZAVUMUYCUXSUNZUXSVUIUNZTZUAGUPZVUHAUYLVUOUSUYMUYNVUNVUMVCVUPGVDSZVUNVU
      TAVVAUYLVUOKVEUYMUYNVUNVUMVFUYCUAGVUIVGVHAVUMTZVUTVUHVVBVUSVUGUAGUYEVVBVU
      AVUSTZUXSUYESZVUAVURTZTZVVDVUGTAVVCVVFVJVUMAVVCAVUAUYBUXSSZVURTZTZTZVVFAV
      VCVVJVVCVVIAVUSVVHVUAVUQVVGVURVVGVUQUYBUXSBVIVKVLVMVNVNWAVVJAVUAVVGVBZVUR
      TZVVFVVLAVUAVVGTZTZVURTAVVMVURTZTVVJVVKVVNVURAVUAVVGVOVPAVVMVURWBVVOVVIAV
      UAVVGVURWBVQVRVVLVVDVVEVVKVVDVURAVVAVUAVVGVVDKUYBGUXSVSVTWCVURVVKVUAVURVV
      KVUAVURAVUAVVGVFWAUUAUUBUUCUUDWCVVBVVEVUGVVDVVBVURVUFVUAVVBVURVUFAVURVUMV
      UFAVURTZVUEVULUNZVUMVUFVVPHVDSZVUKDUNZVUCVUKUNZVVQAVVRVURAHWDSZVVRLHUUEWE
      ZWCAVVSVURAVUKFUUFZDFVUJUUGACDFWMZVWCDUNMCDFUULWEUUHWCVURVVTAVURVUBVUJUNV
      VTUXSVUICUUIVUBVUJFUUJWEUUKVUKVUCHDJWFWGVUEVULUXTWHWIUUMWAWJWJUUNWKWNWLUU
      OUYOFUEULZUMZVUDRZUXTUNZVUMUDUYEUPZUEUYECWOUJZUYOVWEVWJSZTZVWHTVWHAVWKVWI
      VWLVWHWPAUYLUYNVWKVWHUUPUYOVWKVWHWQVWHAVWKTZVWIVWMVWEVUJWRZUDUYEUPZVWHVWI
      AVWKVWOAUYEWSSZCWSSZVWKVWOXFVWPAUYCUYDWTXAACEWSAGXBEAVVAGEXBRSZKGEIXCXDZU
      UQNUURZUDVWECUYEWSWSUUSVHUUTVWHVWNVUMUDUYEVWNVWHVUMVWNVWGVULUXTVWNVWFVUKV
      UDVWEVUJFUVAXGUVBUVCXEUVDWNUVEUYOUFULZVUDRZUXTUNZVWHUEVWJUPZUFUYIUYOVXAUY
      ISZTVXCTZVWFVXAUNZUEVWJUPZVXDVXFUYMVXEVXHUYMUYNVXEVXCUVFUYOVXEVXCWQUYMVXH
      UFUYIUYMUYGDSZVXHUFUYIURZUYMUYGFHVWJXHUJZRZSZVXIVXJTZUYMUYGVXLXIZVXLAUGCD
      EFGHUYBIJKLMNOUYMVXLXSXJZVJZAUGULZESZTZFHVXRUQZUYDRZCWOUJZXHUJZRZXSXJZVJB
      UGBUGXKZUYMVXTVXPVYFVYGUYLVXSAUYBVXREXLXMVYGVXLVYEXSVYGFVXKVYDVYGVWJVYCHX
      HVYGUYEVYBCWOVYGUYCVYAUYDUYBVXRXNXGXOXPXQXRXTPYAYBUYMVXOVXOUQZVXLVXOVXLFV
      XKWTYCUVGUYMVXLYDYEYFZVXLVYHWRUYMVWAVWJCUVHRZSZVWDVXPVYIAVWAUYLLWCUYMUYBC
      GVARRZSZVYKAVYMUYLAVYLEUYBOYGYHUYMVWRCEUNZUYLVYMVYKXFAVWRUYLVWSWCAVYNUYLN
      WCAUYLWPCUYBGEYIWGYJZAVWDUYLMWCZPFHVWJDCJYKYLVXLYMXDUVIYNUYMHDXBRSZVYKVWD
      VXMVXNXFAVYQUYLAVVRVYQVWBHDJXCXDZWCVYOVYPUYGUFFHVWJDCUEUVJWGYJUVKUVMVHUYM
      VXEVXCVXHVXDVJZUYNUYMVXETZVXCTZVVRVXADUNZVXCVYSAVVRUYLVXEVXCVWBUVLZWUAVVR
      VXEWUBWUCUYMVXEVXCWQUYHHVXADJYOVHVYTVXCWPVVRWUBVXCVBZVXGVWHUEVWJWUDVXGVWH
      VVRWUBVXGVXCVWHVVRWUBVXGVBVWGVXBUNVXCVWHVXAVWFHDJWFVWGVXBUXTWHWIUVNWAXEWG
      UVOYPUYOVVRUYGVXASZVXCTZUFHUPZVXCUFUYIUPAVVRUYLUYNVWBVEZUYOUYGUHULZSZWUIU
      XTUNZTZWUGUHHUYOWUIHSZTZWULTZWUEVXBWUIUNZTZUFHUPZWUGWUOHUVPSZWUMWUJWURUYO
      WUSWUMWULAWUSUYLUYNQVEVEUYOWUMWULWQWUNWUJWUKUVQUFUYGWUIHUVRWGWUKWURWUGVJW
      UNWUJWUKWUQWUFUFHWUKWUPVXCWUEWUPWUKVXCVXBWUIUXTWHUVSWJXEUVTYPUYOVVRUYNWUL
      UHHUPZWUHUYMUYNWPVVRUYNTUYHWUIUNZWUKTZUHHUPWUTUYHUHHUXTVGWVBWULUHHWULWVBW
      UJWVAWUKUYGWUIUYBUXQWTVKVPVLUWAWEVHYQVVRWUFVXCUFHUYIVXAHSZWUFTWVCWUETZVXC
      TVVRVXEVXCTWVCWUEVXCWBVVRWVDVXEVXCVVRWVCWUEVXEUYGHVXAVSUWBUWCUWDWKYRYQYQY
      QAVUHUYTVJUYLUYNAVUGUYSUAUYEAVUAVUFUYSAVUATZVUFTZUYRUCUXSWVFUYPUXSSZTVUEU
      XTUYQWVEVUFWVGWQWVEWVGUYQVUESZVUFWVEWVGTZAUYPESZVUBUYPUQZUYDRZCWOUJZSZWVH
      AVUAWVGUSWVIUXSEUYPWVIVVAVUAUXSEUNZAVVAVUAWVGKVEAVUAWVGWQUXSGEIUWEVHWVEWV
      GWPYSWVIWVLWSSZVWQUXSWVLSZWVNWVPWVIWVKUYDWTXAAVWQVUAWVGVWTVEAVUAWVGWVQAVV
      AVUAWVGWVQKUYPGUXSVSVTUWFUXSCWVLWSWSUWGWGAWVJTZWVNTZUYQFHWVMXHUJZRZXIZVUE
      WVRUYQWWBWRWVNABCDEFGHUYPIJKLMNOPYBWCWVSWWBUQZVUEUNWWBVUESWVSWWCWWAVUEWVR
      WWAWWCWRZWVNWVRWWAYDYEYFZWWDWVRVWAWVMVYJSZVWDWWAXSXJZWWEAVWAWVJLWCWVRUYPV
      YLSZWWFAWWHWVJAVYLEUYPOYGYHWVRVWRVYNWVJWWHWWFXFAVWRWVJVWSWCAVYNWVJNWCAWVJ
      WPCUYPGEYIWGYJZAVWDWVJMWCZVXQWVRWWGVJBUCBUCXKZUYMWVRVXPWWGWWKUYLWVJAUYBUY
      PEXLXMWWKVXLWWAXSWWKFVXKWVTWWKVWJWVMHXHWWKUYEWVLCWOWWKUYCWVKUYDUYBUYPXNXG
      XOXPXQXRXTPYAFHWVMDCJYKYLWWAYMXDWCWVSWWAHWVMDFUWHUJRZUWIUJZVUEWVRWWAWWMWR
      ZWVNWVRVYQWWFVWDWWNAVYQWVJVYRWCWWIWWJFHWVMDCUWJWGWCWVSVUCWWLSZWWMVUEUNWVS
      DWSSWVMCUWNRSZVWDVUBCWVMUWKUJZSWWOWVSDHXIZWSJAWWRWSSZWVJWVNAVWAWWSLHWDUWL
      WEVEUWMWVSWWFWWPWVRWWFWVNWWIWCWVMCUWOWEAVWDWVJWVNMVEWVSVUBWVMWWQWVRWVNWPW
      VRWWQWVMWRZWVNWVRWWFWWTWWIWVMCUWPWEWCUWQWSWVMVUBFWWQDCWWQUWRUWSYLVUCWWLHU
      WTWEUXAUXDWWBVUEWWAFWVTWTYCVKUXBYNWLUXCYSYTUXEXEVEYPAUYSUYAUAUYEAVVDTZUYA
      UYSWXAUXQUXFZUXSUXQUXGZUNUYAUYSXFAWXBVVDAEDUXQWMZWXBABCDEFGHIJKLMNOPUXOZE
      DUXQUXHWEWCWXAUXSEWXCAVVAVVDWVOKUYCGUXSEIYOWIAWXCEWRZVVDAWXDWXFWXEEDUXQUX
      IWEWCUXJUCUXSUXTUXQUXKVHUXLUXMYRYTYTAVVAVVRWXDUXRUYKXFKVWBWXEUBUAUXQGHEDB
      IJUXNWGUXP $.

    ${
      $d a v w y A $.  $d a v y J $.
      cnextfres.1 $e |- ( ph -> F e. ( ( J |`t A ) Cn K ) ) $.
      $( ` F ` and its extension by continuity agree on the domain of ` F ` .
         (Contributed by Thierry Arnoux, 17-Jan-2018.) $)
      cnextfres $p |- ( ph -> ( ( ( J CnExt K ) ` F ) |` A ) = F ) $=
        ( cfv wcel vy vv vw ccnext co wfn wss wf cnextf ffn syl fnssres syl2anc
        cres cv wa csn cnei crest cflf cuni wceq fvres adantl sselda cnextfvval
        syldan c1o cen wbr cima wrex wral ffvelrnda ctop restuni adantr eleqtrd
        simpr ccn cvv ccl fvex syl6eqelr ssexd resttop haustop feq2d mpbid eqid
        wb cha cnnei syl3anc r19.21bi snssi neitr rexeqdv ralrimiva ctopon cfil
        toptopon biimpi 3syl eleqtrrd sylib trnei flfnei mpbir2and c0 wne eleq1
        anbi2d sneq fveq2d oveq1d oveq2d fveq1d neeq1d chvarv hausflf2 syl31anc
        wi imbi12d en1eqsn unieqd unisn syl6eq 3eqtrd eqfnfvd ) AUACFGHUDUESZCU
        NZFAYKEUFZCEUGZYLCUFAEDYKUHYMABCDEFGHIJKLMNOPUIEDYKUJUKNECYKULUMACDFUHZ
        FCUFMCDFUJUKAUAUOZCTZUPZYPYLSZYPYKSZFHYPUQZGURSZSZCUSUEZUTUEZSZVAZYPFSZ
        YQYSYTVBAYPCYKVCVDAYQYPETZYTUUGVBACEYPNVEZABCDEFGHYPIJKLMNOPVFVGYRUUGUU
        HUQZVAUUHYRUUFUUKYRUUHUUFTZUUFVHVIVJZUUFUUKVBYRUULUUHDTZFUBUOVKUCUOZUGZ
        UBUUDVLZUCUUKHURSSZVMZACDYPFMVNYRUUQUCUURYRUUOUURTZUPUUPUBUUAGCUSUEZURS
        SZVLZUUQYRUVCUCUURAYQYPUVAVAZTUVCUCUURVMZYRYPCUVDAYQVSACUVDVBZYQAGVOTZY
        NUVFKNCGEIVPUMZVQVRAUVEUAUVDAFUVAHVTUETZUVEUAUVDVMZRAUVAVOTZHVOTZUVDDFU
        HZUVIUVJWKAUVGCWATUVKKACEWAAECGWBSZSZWAOCUVNWCWDNWECGWAWFUMAHWLTZUVLLHW
        GZUKAYOUVMMACUVDDFUVHWHWIUCUBFUVAHUVDDUAUVDWJJWMWNWIWOVGWOYRUVCUUQWKUUT
        YRUUPUBUVBUUDYRUVGYNUUACUGZUVBUUDVBAUVGYQKVQAYNYQNVQZYQUVRAYPCWPVDCUUAG
        EIWQWNWRVQWIWSYRHDWTSTZUUDCXASTZYOUULUUNUUSUPWKYRUVPUVLUVTAUVPYQLVQZUVQ
        UVLUVTHDJXBXCXDYRYPUVOTZUWAYRYPEUVOUUJAUVOEVBYQOVQXEYRGEWTSTZYNUUIUWCUW
        AWKAUWDYQAUVGUWDKGEIXBXFVQUVSUUJCYPGEXGWNWIZAYOYQMVQZUUHUCFHUUDDCUBXHWN
        XIYRUVPUWAYOUUFXJXKZUUMUWBUWEUWFAYQUUIUWGUUJABUOZETZUPZFHUWHUQZUUBSZCUS
        UEZUTUEZSZXJXKZYCAUUIUPZUWGYCBUAUWHYPVBZUWJUWQUWPUWGUWRUWIUUIAUWHYPEXLX
        MUWRUWOUUFXJUWRFUWNUUEUWRUWMUUDHUTUWRUWLUUCCUSUWRUWKUUAUUBUWHYPXNXOXPXQ
        XRXSYDPXTVGFHUUDDCJYAYBUUHUUFYEUMYFUUHYPFWCYGYHYIYJ $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Topological groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c TopMnd $.
  $c TopGrp $.

  $( Extend class notation with the class of all topological monoids. $)
  ctmd $a class TopMnd $.

  $( Extend class notation with the class of all topological groups. $)
  ctgp $a class TopGrp $.

  ${
    $d f j $.
    $( Define the class of all topological monoids.  A topological monoid is a
       monoid whose operation is continuous.  (Contributed by Mario Carneiro,
       19-Sep-2015.) $)
    df-tmd $a |- TopMnd = { f e. ( Mnd i^i TopSp ) |
     [. ( TopOpen ` f ) / j ]. ( +f ` f ) e. ( ( j tX j ) Cn j ) } $.

    $( Define the class of all topological groups.  A topological group is a
       group whose operation and inverse function are continuous.  (Contributed
       by FL, 18-Apr-2010.) $)
    df-tgp $a |- TopGrp = { f e. ( Grp i^i TopMnd ) |
     [. ( TopOpen ` f ) / j ]. ( invg ` f ) e. ( j Cn j ) } $.
  $}

  ${
    $d f j F $.  $d f j G $.  $d f j J $.
    istmd.1 $e |- F = ( +f ` G ) $.
    istmd.2 $e |- J = ( TopOpen ` G ) $.
    $( The predicate "is a topological monoid".  (Contributed by Mario
       Carneiro, 19-Sep-2015.) $)
    istmd $p |- ( G e. TopMnd <-> ( G e. Mnd /\ G e. TopSp /\
      F e. ( ( J tX J ) Cn J ) ) ) $=
      ( vf vj cmnd ctps wcel ctx co ccn wa ctmd cv cplusf cfv ctopn wceq anbi1i
      cin w3a elin wsbc cvv a1i simpl fveq2d syl6eqr id fveq2 sylan9eqr oveq12d
      fvex eleq12d sbcied df-tmd elrab2 df-3an 3bitr4i ) BHIUBZJZACCKLZCMLZJZNB
      HJZBIJZNZVFNBOJVGVHVFUCVCVIVFBHIUDUAFPZQRZGPZVLKLZVLMLZJZGVJSRZUEVFFBVBOV
      JBTZVOVFGVPUFVPUFJVQVJSUOUGVQVLVPTZNZVKAVNVEVSVKBQRAVSVJBQVQVRUHUIDUJVSVM
      VDVLCMVSVLCVLCKVRVQVLVPCVRUKVQVPBSRCVJBSULEUJUMZVTUNVTUNUPUQFGURUSVGVHVFU
      TVA $.
  $}

  $( A topological monoid is a monoid.  (Contributed by Mario Carneiro,
     19-Sep-2015.) $)
  tmdmnd $p |- ( G e. TopMnd -> G e. Mnd ) $=
    ( ctmd wcel cmnd ctps cplusf cfv ctopn ctx co ccn eqid istmd simp1bi ) ABCA
    DCAECAFGZAHGZPIJPKJCOAPOLPLMN $.

  $( A topological monoid is a topological space.  (Contributed by Mario
     Carneiro, 19-Sep-2015.) $)
  tmdtps $p |- ( G e. TopMnd -> G e. TopSp ) $=
    ( ctmd wcel cmnd ctps cplusf cfv ctopn ctx co ccn eqid istmd simp2bi ) ABCA
    DCAECAFGZAHGZPIJPKJCOAPOLPLMN $.

  ${
    $d f j G $.  $d f j I $.  $d f j J $.
    istgp.1 $e |- J = ( TopOpen ` G ) $.
    istgp.2 $e |- I = ( invg ` G ) $.
    $( The predicate "is a topological group".  Definition of [BourbakiTop1]
       p.  III.1 (Contributed by FL, 18-Apr-2010.)  (Revised by Mario Carneiro,
       13-Aug-2015.) $)
    istgp $p |- ( G e. TopGrp <->
      ( G e. Grp /\ G e. TopMnd /\ I e. ( J Cn J ) ) ) $=
      ( vf vj cgrp ctmd wcel ccn co wa ctgp cv cminusg cfv ctopn wceq cvv simpl
      cin w3a elin anbi1i wsbc fvex a1i fveq2d syl6eqr id fveq2 oveq12d eleq12d
      sylan9eqr sbcied df-tgp elrab2 df-3an 3bitr4i ) AHIUBZJZBCCKLZJZMAHJZAIJZ
      MZVDMANJVEVFVDUCVBVGVDAHIUDUEFOZPQZGOZVJKLZJZGVHRQZUFVDFAVANVHASZVLVDGVMT
      VMTJVNVHRUGUHVNVJVMSZMZVIBVKVCVPVIAPQBVPVHAPVNVOUAUIEUJVPVJCVJCKVOVNVJVMC
      VOUKVNVMARQCVHARULDUJUOZVQUMUNUPFGUQURVEVFVDUSUT $.
  $}

  $( A topological group is a group.  (Contributed by FL, 18-Apr-2010.)
     (Revised by Mario Carneiro, 13-Aug-2015.) $)
  tgpgrp $p |- ( G e. TopGrp -> G e. Grp ) $=
    ( ctgp wcel cgrp ctmd cminusg cfv ctopn ccn co eqid istgp simp1bi ) ABCADCA
    ECAFGZAHGZOIJCANOOKNKLM $.

  $( A topological group is a topological monoid.  (Contributed by Mario
     Carneiro, 19-Sep-2015.) $)
  tgptmd $p |- ( G e. TopGrp -> G e. TopMnd ) $=
    ( ctgp wcel cgrp ctmd cminusg cfv ctopn ccn co eqid istgp simp2bi ) ABCADCA
    ECAFGZAHGZOIJCANOOKNKLM $.

  $( A topological group is a topological space.  (Contributed by FL,
     21-Jun-2010.)  (Revised by Mario Carneiro, 13-Aug-2015.) $)
  tgptps $p |- ( G e. TopGrp -> G e. TopSp ) $=
    ( ctgp wcel ctmd ctps tgptmd tmdtps syl ) ABCADCAECAFAGH $.

  ${
    tgpcn.j $e |- J = ( TopOpen ` G ) $.
    ${
      tgptopon.x $e |- X = ( Base ` G ) $.
      $( The topology of a topological monoid.  (Contributed by Mario Carneiro,
         27-Jun-2014.)  (Revised by Mario Carneiro, 13-Aug-2015.) $)
      tmdtopon $p |- ( G e. TopMnd -> J e. ( TopOn ` X ) ) $=
        ( ctmd wcel ctps ctopon cfv tmdtps istps sylib ) AFGAHGBCIJGAKCBAEDLM
        $.

      $( The topology of a topological group.  (Contributed by Mario Carneiro,
         27-Jun-2014.)  (Revised by Mario Carneiro, 13-Aug-2015.) $)
      tgptopon $p |- ( G e. TopGrp -> J e. ( TopOn ` X ) ) $=
        ( ctgp wcel ctps ctopon cfv tgptps istps sylib ) AFGAHGBCIJGAKCBAEDLM
        $.
    $}

    ${
      tgpcn.1 $e |- F = ( +f ` G ) $.
      $( In a topological monoid, the operation ` F ` representing the
         functionalization of the operator slot ` +g ` is continuous.
         (Contributed by Mario Carneiro, 19-Sep-2015.) $)
      tmdcn $p |- ( G e. TopMnd -> F e. ( ( J tX J ) Cn J ) ) $=
        ( ctmd wcel cmnd ctps ctx co ccn istmd simp3bi ) BFGBHGBIGACCJKCLKGABCE
        DMN $.

      $( In a topological group, the operation ` F ` representing the
         functionalization of the operator slot ` +g ` is continuous.
         (Contributed by FL, 21-Jun-2010.)  (Revised by Mario Carneiro,
         13-Aug-2015.) $)
      tgpcn $p |- ( G e. TopGrp -> F e. ( ( J tX J ) Cn J ) ) $=
        ( ctgp wcel ctmd ctx co ccn tgptmd tmdcn syl ) BFGBHGACCIJCKJGBLABCDEMN
        $.
    $}

    ${
      tgpinv.5 $e |- I = ( invg ` G ) $.
      $( In a topological group, the inverse function is continuous.
         (Contributed by FL, 21-Jun-2010.)  (Revised by FL, 27-Jun-2014.) $)
      tgpinv $p |- ( G e. TopGrp -> I e. ( J Cn J ) ) $=
        ( ctgp wcel cgrp ctmd ccn co istgp simp3bi ) AFGAHGAIGBCCJKGABCDELM $.

      $( The inverse function in a topological group is a homeomorphism from
         the group to itself.  (Contributed by Mario Carneiro, 14-Aug-2015.) $)
      grpinvhmeo $p |- ( G e. TopGrp -> I e. ( J Homeo J ) ) $=
        ( ctgp wcel ccn co ccnv chmeo tgpinv cgrp wceq tgpgrp cbs cfv grpinvcnv
        eqid syl eqeltrd ishmeo sylanbrc ) AFGZBCCHIZGBJZUEGBCCKIGABCDELZUDUFBU
        EUDAMGUFBNAOAPQZABUHSERTUGUABCCUBUC $.
    $}

    $d x y G $.  $d x y J $.  $d x K $.  $d x y ph $.  $d x y X $.  $d x y Y $.
    cnmpt1plusg.p $e |- .+ = ( +g ` G ) $.
    cnmpt1plusg.g $e |- ( ph -> G e. TopMnd ) $.
    cnmpt1plusg.k $e |- ( ph -> K e. ( TopOn ` X ) ) $.
    ${
      cnmpt1plusg.a $e |- ( ph -> ( x e. X |-> A ) e. ( K Cn J ) ) $.
      cnmpt1plusg.b $e |- ( ph -> ( x e. X |-> B ) e. ( K Cn J ) ) $.
      $( Continuity of the group sum; analogue of ~ cnmpt12f which cannot be
         used directly because ` +g ` is not a function.  (Contributed by Mario
         Carneiro, 23-Aug-2015.) $)
      cnmpt1plusg $p |- ( ph -> ( x e. X |-> ( A .+ B ) ) e. ( K Cn J ) ) $=
        ( cfv co cmpt wcel eqid cplusf ccn cv wa cbs wceq wf wral ctmd tmdtopon
        ctopon syl cnf2 syl3anc fmpt sylibr r19.21bi plusfval syl2anc mpteq2dva
        ctx tmdcn cnmpt12f eqeltrrd ) ABICDFUAPZQZRBICDEQZRHGUBQZABIVFVGABUCISU
        DCFUEPZSZDVISZVFVGUFAVJBIAIVIBICRZUGZVJBIUHAHIUKPSZGVIUKPSZVLVHSVMMAFUI
        SZVOLFGVIJVITZUJULZNVLHGIVIUMUNBIVICVLVLTUOUPUQAVKBIAIVIBIDRZUGZVKBIUHA
        VNVOVSVHSVTMVROVSHGIVIUMUNBIVIDVSVSTUOUPUQVIEVEFCDVQKVETZURUSUTABCDVEHG
        GGIMNOAVPVEGGVAQGUBQSLVEFGJWAVBULVCVD $.
    $}

    cnmpt2plusg.l $e |- ( ph -> L e. ( TopOn ` Y ) ) $.
    cnmpt2plusg.a $e |- ( ph -> ( x e. X , y e. Y |-> A ) e.
                                ( ( K tX L ) Cn J ) ) $.
    cnmpt2plusg.b $e |- ( ph -> ( x e. X , y e. Y |-> B ) e.
                                ( ( K tX L ) Cn J ) ) $.
    $( Continuity of the group sum; analogue of ~ cnmpt22f which cannot be used
       directly because ` +g ` is not a function.  (Contributed by Mario
       Carneiro, 23-Aug-2015.) $)
    cnmpt2plusg $p |- ( ph ->
        ( x e. X , y e. Y |-> ( A .+ B ) ) e. ( ( K tX L ) Cn J ) ) $=
      ( wcel cplusf cfv co cmpt2 ctx ccn cv w3a cbs wceq wa wral cxp wf txtopon
      ctopon syl2anc ctmd eqid tmdtopon syl syl3anc fmpt2 sylibr r19.21bi 3impa
      cnf2 plusfval mpt2eq3dva tmdcn cnmpt22f eqeltrrd ) ABCKLDEGUAUBZUCZUDBCKL
      DEFUCZUDIJUEUCZHUFUCZABCKLVNVOABUGKTZCUGLTZUHDGUIUBZTZEVTTZVNVOUJAVRVSWAA
      VRUKZWACLAWACLULZBKAKLUMZVTBCKLDUDZUNZWDBKULAVPWEUPUBTZHVTUPUBTZWFVQTWGAI
      KUPUBTJLUPUBTWHPQIJKLUOUQZAGURTZWIOGHVTMVTUSZUTVAZRWFVPHWEVTVGVBBCKLDVTWF
      WFUSVCVDVEVEVFAVRVSWBWCWBCLAWBCLULZBKAWEVTBCKLEUDZUNZWNBKULAWHWIWOVQTWPWJ
      WMSWOVPHWEVTVGVBBCKLEVTWOWOUSVCVDVEVEVFVTFVMGDEWLNVMUSZVHUQVIABCDEVMIJHHH
      KLPQRSAWKVMHHUEUCHUFUCTOVMGHMWQVJVAVKVL $.
  $}

  ${
    $d u v x y z G $.  $d u v J $.  $d u v x y z U $.  $d u v X $.  $d u v Y $.
    $d z B $.
    tmdcn2.1 $e |- B = ( Base ` G ) $.
    tmdcn2.2 $e |- J = ( TopOpen ` G ) $.
    tmdcn2.3 $e |- .+ = ( +g ` G ) $.
    $( Write out the definition of continuity of ` +g ` explicitly.
       (Contributed by Mario Carneiro, 20-Sep-2015.) $)
    tmdcn2 $p |- ( ( ( G e. TopMnd /\ U e. J ) /\
      ( X e. B /\ Y e. B /\ ( X .+ Y ) e. U ) ) -> E. u e. J E. v e. J
        ( X e. u /\ Y e. v /\ A. x e. u A. y e. v ( x .+ y ) e. U ) ) $=
      ( vz wcel co cv cfv wral ctmd wa w3a cxp cplusf ccnv cima wss wrex ctopon
      tmdtopon ad2antrr ctx ccn cop cuni ccnp eqid tmdcn simpr1 opelxpi syl2anc
      simpr2 txtopon toponuni syl eleqtrd cncnpi simplr plusfval simpr3 eqeltrd
      wceq txcnpi dfss3 eleq1 wfn wb plusffn elpreima ax-mp syl6bb ralxp opelxp
      bitri df-ov syl5eqr sylbi eleq1d biimpa ralimi 3anim3i reximi ) HUAPZGIPZ
      UBZJEPZKEPZJKFQZGPZUCZUBZJDRZPZKCRZPZXCXEUDZHUESZUFGUGZUHZUCZCIUIZDIUIXDX
      FARZBRZFQZGPZBXETZAXCTZUCZCIUIZDIUIXBCDJKGXHIIIEEWNIEUJSPZWOXAHIEMLUKULZY
      BXBXHIIUMQZIUNQPZJKUOZYCUPZPXHYEYCIUQQSPWNYDWOXAXHHIMXHURZUSULXBYEEEUDZYF
      XBWQWRYEYHPWPWQWRWTUTZWPWQWRWTVCZJKEEVAVBXBYCYHUJSPZYHYFVMXBYAYAYKYBYBIIE
      EVDVBYHYCVEVFVGYEXHYCIYFYFURVHVBWNWOXAVIYIYJXBJKXHQZWSGXBWQWRYLWSVMYIYJEF
      XHHJKLNYGVJVBWPWQWRWTVKVLVNXLXTDIXKXSCIXJXRXDXFXJXMXNUOZYHPZYMXHSZGPZUBZB
      XETZAXCTZXRXJORZXIPZOXGTYSOXGXIVOUUAYQOABXCXEYTYMVMUUAYMXIPZYQYTYMXIVPXHY
      HVQUUBYQVREXHHLYGVSYHYMGXHVTWAWBWCWEYRXQAXCYQXPBXEYNYPXPYNYOXOGYNXMEPXNEP
      UBZYOXOVMXMXNEEWDUUCYOXMXNXHQXOXMXNXHWFEFXHHXMXNLNYGVJWGWHWIWJWKWKWHWLWMW
      MVF $.
  $}

  ${
    $d x y G $.  $d x y J $.  $d x y .- $.
    tgpsubcn.2 $e |- J = ( TopOpen ` G ) $.
    tgpsubcn.3 $e |- .- = ( -g ` G ) $.
    $( In a topological group, the "subtraction" (or "division") is
       continuous.  Axiom GT' of [BourbakiTop1] p.  III.1 (Contributed by FL,
       21-Jun-2010.)  (Revised by Mario Carneiro, 19-Mar-2015.) $)
    tgpsubcn $p |- ( G e. TopGrp -> .- e. ( ( J tX J ) Cn J ) ) $=
      ( vx vy ctgp wcel cbs cfv cv cminusg cplusg cmpt2 ctx ccn eqid grpsubfval
      co tgptmd tgptopon cnmpt1st cnmpt2nd tgpinv cnmpt21f cnmpt2plusg syl5eqel
      ) AHIZCFGAJKZUJFLZGLZAMKZKZANKZTOBBPTBQTFGUJUOAUMCUJRZUORZUMRZESUIFGUKUNU
      OABBBUJUJDUQAUAABUJDUPUBZUSUIFGBBUJUJUSUSUCUIFGULUMBBBBUJUJUSUSUIFGBBUJUJ
      USUSUDAUMBDURUEUFUGUH $.

    $( A group with a topology is a topological group iff the subtraction
       operation is continuous.  (Contributed by Mario Carneiro,
       2-Sep-2015.) $)
    istgp2 $p |- ( G e. TopGrp <->
      ( G e. Grp /\ G e. TopSp /\ .- e. ( ( J tX J ) Cn J ) ) ) $=
      ( vx vy wcel co ccn w3a 3ad2ant1 simp2 cv cmpt2 eqid simp3 cmpt syl3anbrc
      cfv ctgp cgrp ctps ctx tgpgrp tgptps tgpsubcn 3jca ctmd simp1 cmnd cplusf
      cminusg grpmnd cplusg grpsubinv mpt2eq3dva plusffval syl6eqr ctopon istps
      cbs sylib cnmpt1st cnmpt2nd c0g grpinvf feqmptd wceq grpinvval2 mpteq2dva
      wf sylan eqtrd grpidcl cnmptc cnmptid cnmpt12f cnmpt21f cnmpt22f eqeltrrd
      eqeltrd istmd istgp impbii ) AUAHZAUBHZAUCHZCBBUDIBJIZHZKZWFWGWHWJAUEAUFA
      BCDEUGUHWKWGAUIHZAUMTZBBJIZHWFWGWHWJUJZWKAUKHZWHAULTZWIHWLWGWHWPWJAUNLWGW
      HWJMZWKFGAVBTZWSFNZGNZWMTZCIZOZWQWIWKXDFGWSWSWTXAAUOTZIZOWQWKFGWSWSXCXFWK
      WTWSHZXAWSHZKWSXEACWMWTXAWSPZXEPZEWMPZWKXGWGXHWOLWKXGXHMWKXGXHQUPUQFGWSXE
      WQAXIXJWQPZURUSWKFGWTXBCBBBBBWSWSWKWHBWSUTTHWRWSBAXIDVAVCZXMWKFGBBWSWSXMX
      MVDWKFGXAWMBBBBWSWSXMXMWKFGBBWSWSXMXMVEWKWMFWSAVFTZWTCIZRZWNWKWMFWSWTWMTZ
      RXPWKFWSWSWMWGWHWSWSWMVLWJWSAWMXIXKVGLVHWKFWSXQXOWKWGXGXQXOVIWOWSACWMWTXN
      XIEXKXNPZVJVMVKVNWKFXNWTCBBBBWSXMWKFXNBBWSWSXMXMWGWHXNWSHWJWSAXNXIXRVOLVP
      WKFBWSXMVQWGWHWJQZVRWBZVSXSVTWAWQABXLDWCSXTAWMBDXKWDSWE $.
  $}

  ${
    $d k n x y B $.  $d k n x y G $.  $d k n x y J $.  $d k n x y .x. $.
    $d n x N $.
    tgpmulg.j $e |- J = ( TopOpen ` G ) $.
    tgpmulg.t $e |- .x. = ( .g ` G ) $.
    ${
      tgpmulg.b $e |- B = ( Base ` G ) $.
      $( In a topological monoid, the n-times group multiple function is
         continuous.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
      tmdmulg $p |- ( ( G e. TopMnd /\ N e. NN0 ) ->
         ( x e. B |-> ( N .x. x ) ) e. ( J Cn J ) ) $=
        ( vy wcel cv co cmpt wi cfv wceq oveq1 eleq1d imbi2d vn vk cn0 ctmd ccn
        c0g c1 caddc cc0 eqid mulg0 sylan9eq mpteq2dva mpteq2dv tmdtopon tmdmnd
        cmnd mndidcl syl cnmptc wa cplusg oveq2 cbvmptv mulgnn0p1 syl3an1 3expa
        adantlr syl5eq simpll ctopon simpr syl5eqelr cnmptid cnmpt1plusg expcom
        eqeltrd ex a2d nn0ind impcom ) FUCKDUDKZABFALZCMZNZEEUEMZKZWBABUALZWCCM
        ZNZWFKZOWBABDUFPZNZWFKZOWBABUBLZWCCMZNZWFKZOWBABWOUGUHMZWCCMZNZWFKZOWBW
        GOUAUBFWHUIQZWKWNWBXCWJWMWFXCABWIWLXCWCBKWIUIWCCMWLWHUIWCCRBCDWCWLIWLUJ
        ZHUKULUMSTWHWOQZWKWRWBXEWJWQWFXEABWIWPWHWOWCCRUNSTWHWSQZWKXBWBXFWJXAWFX
        FABWIWTWHWSWCCRUNSTWHFQZWKWGWBXGWJWEWFXGABWIWDWHFWCCRUNSTWBAWLEEBBDEBGI
        UOZXHWBDUQKZWLBKDUPZBDWLIXDURUSUTWOUCKZWBWRXBWBXKWRXBOWBXKVAZWRXBXLWRVA
        ZXAJBWOJLZCMZXNDVBPZMZNZWFXMXAJBWSXNCMZNXRAJBWTXSWCXNWSCVCVDXMJBXSXQXLX
        NBKZXSXQQZWRWBXKXTYAWBXIXKXTYAXJBXPCDWOXNIHXPUJZVEVFVGVHUMVIXMJXOXNXPDE
        EBGYBWBXKWRVJZXMWBEBVKPKYCXHUSZXMJBXONWQWFAJBWPXOWCXNWOCVCVDXLWRVLVMXMJ
        EBYDVNVOVQVRVPVSVTWA $.

      $( In a topological group, the n-times group multiple function is
         continuous.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
      tgpmulg $p |- ( ( G e. TopGrp /\ N e. ZZ ) ->
         ( x e. B |-> ( N .x. x ) ) e. ( J Cn J ) ) $=
        ( ctgp wcel cz wa cn0 co cmpt cneg tmdmulg cfv ad2antrr cv cr cn tgptmd
        ccn ctmd sylan adantlr cminusg simpllr zcnd negnegd wceq eqid mulgnegnn
        oveq1d adantll eqtr3d mpteq2dva ctopon tgptopon adantr cnmpt11f eqeltrd
        nnnn0 syl2an tgpinv adantrl wo simpr elznn0nn sylib mpjaodan ) DJKZFLKZ
        MZFNKZABFAUAZCOZPZEEUEOZKZFUBKZFQZUCKZMZVNVQWBVOVNDUFKZVQWBDUDZABCDEFGH
        IRUGUHVPWEWBWCVPWEMZVTABWDVRCOZDUISZSZPWAWIABVSWLWIVRBKZMZWDQZVRCOZVSWL
        WNWOFVRCWNFWNFVNVOWEWMUJUKULUPWEWMWPWLUMVPBCDWKWDVRIHWKUNZUOUQURUSWIAWJ
        WKEEEBVNEBUTSKVOWEDEBGIVATVPWGWDNKABWJPWAKWEVNWGVOWHVBWDVEABCDEWDGHIRVF
        VNWKWAKVOWEDWKEGWQVGTVCVDVHVPVOVQWFVIVNVOVJFVKVLVM $.
    $}

    $( In a topological monoid, the group multiple function is jointly
       continuous (although this is not saying much as one of the factors is
       discrete).  Use ~ zdis to write the left topology as a subset of the
       complexes.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    tgpmulg2 $p |- ( G e. TopGrp -> .x. e. ( ( ~P ZZ tX J ) Cn J ) ) $=
      ( vn vx ctgp wcel cvv cbs cfv zex a1i eqid tgptopon ctopon ctop topontop
      cz syl cxp wfn mulgfn cv tgpmulg txdis1cn ) BHIZFGACCJTBKLZTJIUHMNBCUIDUI
      OZPZUHCUIQLICRIUKUICSUAATUIUBUCUHUIABUJEUDNGUIABCFUEDEUJUFUG $.
  $}

  ${
    $d f g k t u w x y z A $.  $d f g t u w x y z J $.  $d f g k t u x y z X $.
    $d f g k t u w x y z B $.  $d f g k t u w x y z G $.  $d f g t u x U $.
    $d g x ph $.
    tmdgsum.j $e |- J = ( TopOpen ` G ) $.
    tmdgsum.b $e |- B = ( Base ` G ) $.
    $( In a topological monoid, the group sum operation is a continuous
       function from the function space to the base topology.  This theorem is
       not true when ` A ` is infinite, because in this case for any basic open
       set of the domain one of the factors will be the whole space, so by
       varying the value of the functions to sum at this index, one can achieve
       any desired sum.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    tmdgsum $p |- ( ( G e. CMnd /\ G e. TopMnd /\ A e. Fin ) ->
      ( x e. ( B ^m A ) |-> ( G gsum x ) ) e. ( ( J ^ko ~P A ) Cn J ) ) $=
      ( vw wcel cfn cmap co cgsu cmpt cpt cfv ccn c0 wceq syl vy vz vk ccmn w3a
      ctmd cv csn cxp cpw cxko wa wi cun oveq2 mpteq1d 0xp syl6eq fveq2d oveq1d
      xpeq1 eleq12d imbi2d c0g wfn wf elmapi ffn fn0 sylib oveq2d eqid mpteq2ia
      cvv ctopon tmdtopon adantl fveq2i eqcomi pttoponconst sylancr cmnd tmdmnd
      gsum0 0ex mndidcl cnmptc syl5eqel cres cplusg cbvmptv simpl1l simp2l snfi
      wn unfi sylancl adantr fisuppfi cin simpl2r disjsn sylibr eqidd gsumsplit
      cdif mpteq2dva syl5eq simp1r syl2anc cuni toponuni ctop wss topontop 3syl
      ssun1 xpssres ax-mp ptrescn syl3anc eqeltrd simp3 cnmpt11 feqmptd reseq1d
      fconst6g a1i ssun2 resmpt cmnmnd vex snid elun2 mp1i ffvelrnd fveq2 eqtrd
      gsumsn ptpjcn fvconst2g cnmpt1plusg 3expia expcom findcard2s com12 3impia
      eleqtrd a2d xkopt sylan 3adant1 eleqtrrd ) DUDIZDUFIZBJIZUEZACBKLZDAUGZML
      ZNZBEUHZUIZOPZEQLZEBUJUKLZEQLUUNUUOUUPUVAUVEIZUUPUUNUUOULZUVGUVHACHUGZKLZ
      UUTNZUVIUVBUIZOPZEQLZIZUMUVHACRKLZUUTNZROPZEQLZIZUMUVHACUAUGZKLZUUTNZUWAU
      VBUIZOPZEQLZIZUMUVHACUWAUBUGZUHZUNZKLZUUTNZUWJUVBUIZOPZEQLZIZUMUVHUVGUMHU
      AUBBUVIRSZUVOUVTUVHUWQUVKUVQUVNUVSUWQAUVJUVPUUTUVIRCKUOUPUWQUVMUVREQUWQUV
      LROUWQUVLRUVBUIZRUVIRUVBVAUVBUQZURUSUTVBVCUVIUWASZUVOUWGUVHUWTUVKUWCUVNUW
      FUWTAUVJUWBUUTUVIUWACKUOUPUWTUVMUWEEQUWTUVLUWDOUVIUWAUVBVAUSUTVBVCUVIUWJS
      ZUVOUWPUVHUXAUVKUWLUVNUWOUXAAUVJUWKUUTUVIUWJCKUOUPUXAUVMUWNEQUXAUVLUWMOUV
      IUWJUVBVAUSUTVBVCUVIBSZUVOUVGUVHUXBUVKUVAUVNUVEUXBAUVJUURUUTUVIBCKUOUPUXB
      UVMUVDEQUXBUVLUVCOUVIBUVBVAUSUTVBVCUVHUVQAUVPDVDPZNUVSAUVPUUTUXCUUSUVPIZU
      UTDRMLUXCUXDUUSRDMUXDUUSRVEZUUSRSUXDRCUUSVFUXEUUSCRVGRCUUSVHTUUSVIVJVKDUX
      CUXCVLZWDURVMUVHAUXCUVREUVPCUVHRVNIECVOPIZUVRUVPVOPIWEUUOUXGUUNDECFGVPZVQ
      ZREUVRVNCUWROPUVRUWRROUWSVRVSVTWAUXIUVHDWBIZUXCCIUUOUXJUUNDWCVQCDUXCGUXFW
      FTWGWHUWAJIZUWHUWAIWOZULZUVHUWGUWPUVHUXMUWGUWPUMUVHUXMUWGUWPUVHUXMUWGUEZU
      WLHUWKDUVIUWAWIZMLZDUVIUWIWIZMLZDWJPZLZNZUWOUXNUWLHUWKDUVIMLZNUYAAHUWKUUT
      UYBUUSUVIDMUOWKUXNHUWKUYBUXTUXNUVIUWKIZULZUWJCUWAUWIUXSUVIDJUXCGUXFUXSVLZ
      UUNUUOUXMUWGUYCWLZUXNUWJJIZUYCUXNUXKUWIJIUYGUVHUXKUXLUWGWMZUWHWNUWAUWIWPW
      QZWRZUYCUWJCUVIVFUXNUVICUWJVGVQZUYDUWJCVNUXCUHXFUVIUYJUYKWSUYDUXLUWAUWIWT
      RSUXKUXLUVHUWGUYCXAUWAUWHXBXCUYDUWJXDXEXGXHUXNHUXPUXRUXSDEUWNUWKFUYEUUNUU
      OUXMUWGXIZUXNUYGUXGUWNUWKVOPIZUYIUXNUUOUXGUYLUXHTZUWJEUWNJCUWNVLZVTXJZUXN
      HAUXOUUTUXPUWNUWEEUWKUWBUYPUXNHUWKUXONHUWNXKZUXONZUWNUWEQLZUXNHUWKUYQUXOU
      XNUYMUWKUYQSUYPUWKUWNXLTZUPUXNUYGUWJXMUWMVFZUWAUWJXNZUYRUYSIUYIUXNEXMIZVU
      AUXNUUOUXGVUCUYLUXHCEXOZXPZUWJEXMYGTZVUBUXNUWAUWIXQZYHHUWJUWAUWMUWNUWEJUY
      QUYQVLZUYOUWDUWMUWAWIZOVUIUWDVUBVUIUWDSVUGUWJUVBUWAXRXSVSVRXTYAYBUXNUXKUX
      GUWEUWBVOPIUYHUYNUWAEUWEJCUWEVLVTXJUVHUXMUWGYCUUSUXODMUOYDUXNHUWKUXRNHUWK
      UWHUVIPZNZUWOUXNHUWKUXRVUJUYDUXRDUCUWIUCUGZUVIPZNZMLZVUJUYDUXQVUNDMUYDUXQ
      UCUWJVUMNZUWIWIZVUNUYDUVIVUPUWIUYDUCUWJCUVIUYKYEYFUWIUWJXNVUQVUNSUWIUWAYI
      UCUWJUWIVUMYJXSURVKUYDUXJUWHVNIZVUJCIVUOVUJSUYDUUNUXJUYFDYKTVURUYDUBYLZYH
      UYDUWJCUWHUVIUYKUWHUWIIZUWHUWJIZUYDUWHVUSYMZUWHUWIUWAYNZYOYPVUMCVUJUCDUWH
      VNGVULUWHUVIYQYSYAYRXGUXNVUKUWNUWHUWMPZQLZUWOUXNVUKHUYQVUJNZVVEUXNHUWKUYQ
      VUJUYTUPUXNUYGVUAVVAVVFVVEIUYIVUFVUTVVAUXNVVBVVCYOZHUWJUWMUWHUWNJUYQVUHUY
      OYTYAYBUXNVVDEUWNQUXNVUCVVAVVDESVUEVVGUWJEUWHXMUUAXJVKUUHYBUUBYBUUCUUDUUI
      UUEUUFUUGUUQUVFUVDEQUUOUUPUVFUVDSZUUNUUOVUCUUPVVHUUOUXGVUCUXHVUDTBEJUUJUU
      KUULUTUUM $.

    tmdgsum2.t $e |- .x. = ( .g ` G ) $.
    tmdgsum2.1 $e |- ( ph -> G e. CMnd ) $.
    tmdgsum2.2 $e |- ( ph -> G e. TopMnd ) $.
    tmdgsum2.a $e |- ( ph -> A e. Fin ) $.
    tmdgsum2.u $e |- ( ph -> U e. J ) $.
    tmdgsum2.x $e |- ( ph -> X e. B ) $.
    tmdgsum2.3 $e |- ( ph -> ( ( # ` A ) .x. X ) e. U ) $.
    $( For any neighborhood ` U ` of ` n X ` , there is a neighborhood ` u ` of
       ` X ` such that any sum of ` n ` elements in ` u ` sums to an element of
       ` U ` .  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    tmdgsum2 $p |- ( ph ->
      E. u e. J ( X e. u /\ A. f e. ( u ^m A ) ( G gsum f ) e. U ) ) $=
      ( wcel vg vy vz vx vt vk wfn cfv csn cxp wral cuni wceq cdif cfn wrex w3a
      cv cixp wa wex cgsu co cmap crab wss cab ctg cpw cxko cmpt ccnv cima eqid
      mptpreima ccn ccmn ctmd tmdgsum syl3anc syl2anc syl5eqelr cpt ctop ctopon
      cnima tmdtopon topontop 3syl xkopt fnconstg ptval eleqtrd wf fconst6g syl
      eqtrd cvv wb cbs fvex eqeltri elmapg sylancr mpbird fconstmpt oveq2i cmnd
      chash cmnmnd gsumconst syl5eq oveq2 eleq1d elrab sylanbrc tg2 eleq2 sseq1
      eqeltrd anbi12d rexab2 sylib wi crn cint toponuni ad2antrr ineq1d simplrl
      cin simplrr fvconst2g eleq2d ralbidva mpbid ffnfv frn wfo exlimdv rintopn
      dffn4 fofi simprl mptelixpg ralrn elrint inex1 ixpconstg sylancl fnfvelrn
      inss2 intss1 syl5ss ralrimiva ss2ixp eqsstr3d ssrab simprbi ad2antll sylc
      ssralv oveq1 raleqdv rspcev syl12anc ex 3adantr3 syl5ibrcom expimpd imp3a
      imbi1d mpd ) AUAURZCUGZUBURZUVNUHZUVPCIUIUJZUHZTZUBCUKZUVQUVSULUMUBCUCURZ
      UNUKUCUOUPZUQZUDURZUBCUVQUSZUMZUTZUAVAZCJUIUJZUWETZUWEHGURZVBVCZFTZGDCVDV
      CZVEZVFZUTZUTZUDVAZJBURZTZUWNGUXACVDVCZUKZUTZBIUPZAUWJUEURZTZUXGUWPVFZUTZ
      UEUWIUDVGZUPZUWTAUWPUXKVHUHZTUWJUWPTZUXLAUWPICVIVJVCZUXMAUWPGUWOUWMVKZVLF
      VMZUXOGUWOUWMFUXPUXPVNVOAUXPUXOIVPVCTZFITUXQUXOTAHVQTZHVRTZCUOTZUXRNOPGCD
      HIKLVSVTQFUXPUXOIWFWAWBAUXOUVRWCUHZUXMAIWDTZUYAUXOUYBUMAUXTIDWEUHZTZUYCOH
      IDKLWGZDIWHWIZPCIUOWJWAAUYAUVRCUGZUYBUXMUMPAUXTUYEUYHOUYFCIUYDWKWIUDUBUCC
      UXKUAUVRUOUXKVNWLWAWQWMAUWJUWOTZHUWJVBVCZFTZUXNAUYICDUWJWNZAJDTZUYLRCJDWO
      WPADWRTUYAUYIUYLWSDHWTUHWRLHWTXAXBZPDCUWJWRUOXCXDXEAUYJCXIUHJEVCZFAUYJHUF
      CJVKZVBVCZUYOUWJUYPHVBUFCJXFXGAHXHTZUYAUYMUYQUYOUMAUXSUYRNHXJWPPRCDEUFHJL
      MXKVTXLSXTUWNUYKGUWJUWOUWLUWJUMUWMUYJFUWLUWJHVBXMXNXOXPUEUWPUXKUWJXQWAUWI
      UXJUWRUEUDUXGUWEUMUXHUWKUXIUWQUXGUWEUWJXRUXGUWEUWPXSYAYBYCAUWSUXFUDAUWIUW
      RUXFAUWHUWRUXFYDZUAAUWDUWGUYSAUWDUTUYSUWGUWJUWFTZUWFUWPVFZUTZUXFYDZAUVOUW
      AVUCUWCAUVOUWAUTZUTZVUBUXFVUEVUBUTZDUVNYEZYFZYKZITJVUITZUWNGVUICVDVCZUKZU
      XFVUFVUIIULZVUHYKZIVUFDVUMVUHADVUMUMZVUDVUBAUXTUYEVUOOUYFDIYGWIYHYIVUFUYC
      VUGIVFZVUGUOTZVUNITAUYCVUDVUBUYGYHZVUFCIUVNWNZVUPVUFUVOUVQITZUBCUKZVUSAUV
      OUWAVUBYJZVUFUWAVVAAUVOUWAVUBYLVUFUYCUWAVVAWSVURUYCUVTVUTUBCUYCUVPCTZUTUV
      SIUVQCIUVPWDYMYNYOWPYPUBCIUVNYQXPCIUVNYRWPVUFUYACVUGUVNYSZVUQAUYAVUDVUBPY
      HZVUFUVOVVDVVBCUVNUUBYCCVUGUVNUUCWAVUGIVUMVUMVNUUAVTXTVUFUYMJUWBTZUCVUGUK
      ZVUJAUYMVUDVUBRYHVUFVVGJUVQTZUBCUKZVUFUBCJVKZUWFTZVVIVUFVVJUWJUWFUBCJXFVU
      EUYTVUAUUDWBVUFUYAVVKVVIWSVVEUBCJUVQUOUUEWPYPVUFUVOVVGVVIWSVVBVVFVVHUCUBC
      UVNUWBUVQJXRUUFWPXEUCDVUGJUUGXPVUFVUKUWFVFUWNGUWFUKZVULVUFVUKUBCVUIUSZUWF
      VUFUYAVUIWRTVVMVUKUMVVEDVUHUYNUUHUBCVUIUOWRUUIUUJVUFUVOVUIUVQVFZUBCUKVVMU
      WFVFVVBUVOVVNUBCUVOVVCUTZVUIVUHUVQDVUHUULVVOUVQVUGTVUHUVQVFCUVPUVNUUKUVQV
      UGUUMWPUUNUUOUBCVUIUVQUUPWIUUQVUAVVLVUEUYTVUAUWFUWOVFVVLUWNGUWOUWFUURUUSU
      UTUWNGVUKUWFUVBUVAUXEVUJVULUTBVUIIUXAVUIUMZUXBVUJUXDVULUXAVUIJXRVVPUWNGUX
      CVUKUXAVUICVDUVCUVDYAUVEUVFUVGUVHUWGUWRVUBUXFUWGUWKUYTUWQVUAUWEUWFUWJXRUW
      EUWFUWPXSYAUVLUVIUVJYTUVKYTUVM $.
  $}

  ${
    $d x y G $.  $d x y O $.
    oppgtmd.1 $e |- O = ( oppG ` G ) $.
    $( The opposite of a topological monoid is a topological monoid.
       (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    oppgtmd $p |- ( G e. TopMnd -> O e. TopMnd ) $=
      ( vx vy ctmd wcel cmnd ctps cbs cfv cv cplusg co cmpt2 ctopn ctx ccn eqid
      tmdmnd oppgmnd syl ctopon tmdtopon oppgbas oppgtopn istps sylibr cnmpt2nd
      id cnmpt1st cnmpt2plusg cplusf plusffval oppgplus mpt2eq123i eqtr2i istmd
      syl3anbrc ) AFGZBHGZBIGZDEAJKZVCELZDLZAMKZNZOZAPKZVIQNVIRNGBFGUTAHGVAATAB
      CUAUBUTVIVCUCKGVBAVIVCVISZVCSZUDZVCVIBVCABCVKUEZAVIBCVJUFZUGUHUTDEVDVEVFA
      VIVIVIVCVCVJVFSZUTUJVLVLUTDEVIVIVCVCVLVLUIUTDEVIVIVCVCVLVLUKULVHBVIBUMKZD
      EVCVCVEVDBMKZNZOVHDEVCVQVPBVMVQSZVPSUNDEVCVCVRVCVCVGVKVKVFVQABVEVDVOCVSUO
      UPUQVNURUS $.

    $( The opposite of a topological group is a topological group.
       (Contributed by Mario Carneiro, 17-Sep-2015.) $)
    oppgtgp $p |- ( G e. TopGrp -> O e. TopGrp ) $=
      ( ctgp wcel cgrp ctmd cminusg cfv ctopn ccn co tgpgrp oppggrp syl oppgtmd
      tgptmd wceq eqid oppginv tgpinv eqeltrrd oppgtopn istgp syl3anbrc ) ADEZB
      FEZBGEZBHIZAJIZUJKLZEBDEUFAFEZUGAMZABCNOUFAGEUHAQABCPOUFAHIZUIUKUFULUNUIR
      UMAUNBCUNSZTOAUNUJUJSZUOUAUBBUIUJAUJBCUPUCUISUDUE $.
  $}

  ${
    distgp.1 $e |- B = ( Base ` G ) $.
    distgp.2 $e |- J = ( TopOpen ` G ) $.
    $( Any group equipped with the discrete topology is a topological group.
       (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    distgp $p |- ( ( G e. Grp /\ J = ~P B ) -> G e. TopGrp ) $=
      ( cgrp wcel cpw wceq wa ctps csg cfv ctx co ccn ctgp cvv cbs sylibr simpl
      ctopon simpr fvex eqeltri distopon ax-mp syl6eqel istps cmap eqid grpsubf
      cxp wf adantr elmap oveq12d txdis mp2an syl6eq oveq1d cndis sylancr eqtrd
      xpex eleqtrrd istgp2 syl3anbrc ) BFGZCAHZIZJZVIBKGZBLMZCCNOZCPOZGBQGVIVKU
      AVLCAUBMZGZVMVLCVJVQVIVKUCZARGZVJVQGABSMRDBSUDUEZARUFUGUHZACBDEUITVLVNAAA
      UMZUJOZVPVLWCAVNUNZVNWDGVIWEVKABVNDVNUKZULUOAWCVNWAAAWAWAVEZUPTVLVPWCHZCP
      OZWDVLVOWHCPVLVOVJVJNOZWHVLCVJCVJNVSVSUQVTVTWJWHIWAWAAARRURUSUTVAVLWCRGVR
      WIWDIWGWBWCCRAVBVCVDVFBCVNEWFVGVH $.

    $( Any group equipped with the indiscrete topology is a topological group.
       (Contributed by Mario Carneiro, 14-Aug-2015.) $)
    indistgp $p |- ( ( G e. Grp /\ J = { (/) , B } ) -> G e. TopGrp ) $=
      ( cgrp wcel c0 cpr wceq wa ctps csg cfv co ccn ctopon cvv cbs sylibr ctgp
      ctx simpl simpr fvex eqeltri indistopon ax-mp syl6eqel istps cmap wf eqid
      grpsubf adantr xpex elmap oveq2d txtopon syl2anc cnindis sylancl eleqtrrd
      cxp eqtrd istgp2 syl3anbrc ) BFGZCHAIZJZKZVHBLGZBMNZCCUBOZCPOZGBUAGVHVJUC
      VKCAQNZGZVLVKCVIVPVHVJUDZARGZVIVPGABSNRDBSUEUFZARUGUHUIZACBDEUJTVKVMAAAVD
      ZUKOZVOVKWBAVMULZVMWCGVHWDVJABVMDVMUMZUNUOAWBVMVTAAVTVTUPUQTVKVOVNVIPOZWC
      VKCVIVNPVRURVKVNWBQNGZVSWFWCJVKVQVQWGWAWACCAAUSUTVTAVNRWBVAVBVEVCBCVMEWEV
      FVG $.
  $}

  ${
    $d f t u v x y A $.  $d f t u v x y G $.  $d f t u x y V $.
    symgtgp.g $e |- G = ( SymGrp ` A ) $.
    $( The symmetric group is a topological group.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    symgtgp $p |- ( A e. V -> G e. TopGrp ) $=
      ( vx vy vu wcel cfv ccn co eqid wss wf wb syl2anc wceq cmpt wa ad2antrr
      vf vt vv cgrp ctmd cminusg ctopn ctgp symggrp cmnd ctps cplusg ctx grpmnd
      syl cbs ctopon cpw csn cxp cpt crest symgtopn distopon pttoponconst mpdan
      cmap cv wf1o elsymgbas f1of elmapg anidms sylbid ssrdv resttopon eqeltrrd
      syl5ibr istps sylibr cxko ccom cmpt2 symgplusg ctop distop xkotopon cndis
      sseqtr4d ccmp cnlly clly disllycmp llynlly xkococn syl3anc syl5eqel xkopt
      cnmpt2res mpancom oveq1d eqtrd oveq12d eleqtrd crn cplusf wfn vex fnmpt2i
      coex plusfeq ax-mp eqcomi 3syl cnrest2 mpbid oveq2d syl3anbrc ccnv biimpa
      frn wral f1ocnv cima wi adantr weq fvex ad2antlr crab cvv fvconst2g fveq1
      simplr eqeq1d sylanbrc ralrimiva syl6sseqr mpbir2and feqmptd id ffvelrnda
      grpplusf istmd fconst6g ccnp an32s fmptd wrex cnveq fveq1d mptiniseg cuni
      fvmpt eleq1d toponuni mpteq1 simpll ffvelrnd ptpjcn eqeltrd snelpwi cnima
      cnmpt1res syl5eqelr simpllr f1ocnvfv2 elrab ssrab2 a1i ad3antrrr f1ocnvfv
      simplrr eleq1 syl5ibrcom syld ralrab ssrab mptpreima cdm funmpt funimass3
      wfun dmmpti sylancr mpbird eleq2 imaeq2 sseq1d rspcev syl12anc expr simpr
      anbi12d iscnp cncnp sylan eleqtrrd ptcn grpinvf symginv mpteq2dva 3eltr4d
      adantl istgp ) ACHZBUDHZBUEHZBUFIZBUGIZUXJJKZHBUHHABCDUIZUXFBUJHZBUKHZBUL
      IZUXJUXJUMKZUXJJKZHUXHUXFUXGUXMUXLBUNUOUXFUXJBUPIZUQIZHZUXNUXFAAURZUSUTZV
      AIZUXRVBKZUXJUXSUXRBCADUXRLZVCZUXFUYCAAVGKZUQIHZUXRUYGMZUYDUXSHUXFUYAAUQI
      HZUYHACVDZAUYAUYCCAUYCLZVEVFZUXFEUXRUYGUXFEVHZUXRHZAAUYNVIZUYNUYGHZAUXRUY
      NBCDUYEVJZUYPUYQUXFAAUYNNZAAUYNVKUXFUYQUYSOAAUYNCCVLVMVRVNVOZUXRUYCUYGVPP
      VQZUXRUXJBUYEUXJLZVSVTUXFUXOUXPUYAUYAWAKZUXRVBKZJKZUXQUXFUXOUXPVUCJKZHZUX
      OVUEHZUXFUXOVUDVUDUMKZVUCJKZVUFUXFUXOEFUXRUXRUYNFVHZWBZWCVUJAUXRUXOEFBDUY
      EUXOLZWDZUXFEFVULVUCVUDVUCVUCVUDUXRUYAUYAJKZUXRVUOVUDLZUXFUYAWEHZVUQVUCVU
      OUQIHZACWFZVUSUYAUYAVUCVUCLWGPZUXFUXRUYGVUOUYTUXFUYJVUOUYGQUYKAUYACAWHVFW
      IZVUPVUTVVAUXFVUQUYAWJWKHZVUQEFVUOVUOVULWCZVUCVUCUMKVUCJKHVUSUXFUYAWJWLHV
      VBCAWMWJUYAWNUOVUSUYAUYAUYAEFVVCVVCLWOWPWSWQUXFVUIUXPVUCJUXFVUDUXJVUDUXJU
      MUXFVUDUYDUXJUXFVUCUYCUXRVBVUQUXFVUCUYCQVUSAUYACWRWTZXAUYFXBZVVEXCXAXDUXF
      VURUXOXEUXRMZUXRVUOMZVUGVUHOVUTUXFUXGUXRUXRUTZUXRUXONVVFUXLUXRUXOBUYEBXFI
      ZUXOUXOVVHXGVVIUXOQEFUXRUXRVULUXOVUNUYNVUKEXHFXHZXJXIUXRUXOVVIBUYEVUMVVIL
      XKXLXMZUUCVVHUXRUXOYAXNVVAUXRUXOUXPVUCVUOXOWPXPUXFVUDUXJUXPJVVEXQXDUXOBUX
      JVVKVUBUUDXRUXFUXIUXJVUDJKZUXKUXFUXIUXJVUCJKZHZUXIVVLHZUXFEUXRFAVUKUYNXSZ
      IZRZRZUXJUYCJKUXIVVMUXFEVVQFUYBAUXJUYCCUXRUYLVUAUXFUUAUXFVUQAWEUYBNZVUSAU
      YAWEUUEUOZUXFVUKAHZSZEUXRVVQRZUXJUYAJKZUXJVUKUYBIZJKVWCVWDVWEHZUXRAVWDNZV
      WDUAVHZUXJUYAUUFKIHZUAUXRYBZVWCEUXRVVQAVWDUXFUYOVWBVVQAHUXFUYOSZAAVUKVVPV
      WLUYPAAVVPVIAAVVPNUXFUYOUYPUYRXTAAUYNYCAAVVPVKXNZUUBUUGVWDLZUUHZVWCVWJUAU
      XRVWCVWIUXRHZSZVWJVWHVWIVWDIZUBVHZHZVWIUCVHZHZVWDVXAYDZVWSMZSZUCUXJUUIZYE
      ZUBUYAYBZVWCVWHVWPVWOYFVWQVXGUBUYAVWQVWSUYAHZSZVWTVUKVWIXSZIZVWSHZVXFVXJV
      WRVXLVWSVWPVWRVXLQVWCVXIEVWIVVQVXLUXRVWDEUAYGVUKVVPVXKUYNVWIUUJUUKVWNVUKV
      XKYHUUNYIUUOVWQVXIVXMVXFVWQVXIVXMSZSZVXLGVHZIZVUKQZGUXRYJZUXJHZVWIVXSHZVW
      DVXSYDZVWSMZVXFVWQVXTVXNVWQVXSGUXRVXQRZXSVUKUSZYDZUXJVUKYKHVYFVXSQVVJGUXR
      VXQVUKVYDYKVYDLUULXLVWQVYDVWEHVYEUYAHZVYFUXJHVWQVYDUYDUYAJKZVWEVWQGVXQUYC
      UYDUYAUYGUXRUYDLUXFUYHVWBVWPUYMTZUXFUYIVWBVWPUYTTVWQGUYGVXQRZGUYCUUMZVXQR
      ZUYCUYAJKZVWQUYHUYGVYKQVYJVYLQVYIUYGUYCUUPGUYGVYKVXQUUQXNVWQVYLUYCVXLUYBI
      ZJKZVYMVWQUXFVVTVXLAHZVYLVYOHUXFVWBVWPUURUXFVVTVWBVWPVWATVWQAAVUKVXKVWQAA
      VWIVIZAAVXKVIAAVXKNVWCVWPVYQUXFVWPVYQOVWBAUXRVWIBCDUYEVJYFXTZAAVWIYCAAVXK
      VKXNUXFVWBVWPYNUUSZGAUYBVXLUYCCVYKVYKLUYLUUTWPVWQVYNUYAUYCJVWQVUQVYPVYNUY
      AQUXFVUQVWBVWPVUSTVYSAUYAVXLWEYLPXQXDUVAUVDUXFVYHVWEQVWBVWPUXFUYDUXJUYAJU
      YFXATXDVWBVYGUXFVWPVUKAUVBYIVYEVYDUXJUYAUVCPUVEYFVXOVWPVXLVWIIZVUKQZVYAVW
      CVWPVXNYNVXOVYQVWBWUAVWQVYQVXNVYRYFUXFVWBVWPVXNUVFAAVUKVWIUVGPVXRWUAGVWIU
      XRGUAYGVXQVYTVUKVXLVXPVWIYMYOUVHYPVXOVYCVXSVWDXSVWSYDZMZVXOVXSVVQVWSHZEUX
      RYJZWUBVXOVXSUXRMZWUDEVXSYBZVXSWUEMWUFVXOVXRGUXRUVIUVJZVXOVXLUYNIZVUKQZWU
      DYEZEUXRYBWUGVXOWUKEUXRVXOUYOSZWUJVVQVXLQZWUDWULUYPVYPWUJWUMYEVXOUYOUYPUX
      FUYOUYPOVWBVWPVXNUYRUVKXTVWQVYPVXNUYOVYSTAAVXLVUKUYNUVLPWULWUDWUMVXMVWQVX
      IVXMUYOUVMVVQVXLVWSUVNUVOUVPYQVXRWUJWUDEGUXRGEYGVXQWUIVUKVXLVXPUYNYMYOUVQ
      VTWUDEUXRVXSUVRYPEUXRVVQVWSVWDVWNUVSYRVXOVWDUWCVXSVWDUVTZMVYCWUCOEUXRVVQU
      WAVXOVXSUXRWUNWUHEUXRVVQVWDVUKVVPYHVWNUWDYRVXSVWSVWDUWBUWEUWFVXEVYAVYCSUC
      VXSUXJVXAVXSQZVXBVYAVXDVYCVXAVXSVWIUWGWUOVXCVYBVWSVXAVXSVWDUWHUWIUWNUWJUW
      KUWLVNYQVWQUXTUYJVWPVWJVWHVXHSOUXFUXTVWBVWPVUATUXFUYJVWBVWPUYKTVWCVWPUWMU
      CUBVWIVWDUXJUYAUXRAUWOWPYSYQUXFVWGVWHVWKSOZVWBUXFUXTUYJWUPVUAUYKUAVWDUXJU
      YAUXRAUWPPYFYSVWCVWFUYAUXJJUXFVUQVWBVWFUYAQVUSAUYAVUKWEYLUWQXQUWRUWSUXFUX
      IEUXRUYNUXIIZRVVSUXFEUXRUXRUXIUXFUXGUXRUXRUXINZUXLUXRBUXIUYEUXILZUWTZUOYT
      UXFEUXRWUQVVRVWLWUQVVPVVRUYOWUQVVPQUXFAUXRUYNBUXIDUYEWUSUXAUXDVWLFAAVVPVW
      MYTXBUXBXBUXFVUCUYCUXJJVVDXQUXCUXFVURUXIXEUXRMZVVGVVNVVOOVUTUXFUXGWURWVAU
      XLWUTUXRUXRUXIYAXNVVAUXRUXIUXJVUCVUOXOWPXPUXFVUDUXJUXJJVVEXQXDBUXIUXJVUBW
      USUXEXR $.
  $}

  ${
    $d g x A $.  $d g x G $.  $d x J $.  $d g x .+ $.  $d g x X $.
    tgplacthmeo.1 $e |- F = ( x e. X |-> ( A .+ x ) ) $.
    tgplacthmeo.2 $e |- X = ( Base ` G ) $.
    tgplacthmeo.3 $e |- .+ = ( +g ` G ) $.
    tgplacthmeo.4 $e |- J = ( TopOpen ` G ) $.
    $( The left group action of element ` A ` in a topological monoid ` G ` is
       a continuous function.  (Contributed by FL, 18-Mar-2008.)  (Revised by
       Mario Carneiro, 14-Aug-2015.) $)
    tmdlactcn $p |- ( ( G e. TopMnd /\ A e. X ) -> F e. ( J Cn J ) ) $=
      ( ctmd wcel wa cv co cmpt ccn simpl ctopon tmdtopon adantr cnmptc cnmptid
      cfv simpr cnmpt1plusg syl5eqel ) ELMZBGMZNZDAGBAOZCPQFFRPHUKABULCEFFGKJUI
      UJSUIFGTUEMUJEFGKIUAUBZUKABFFGGUMUMUIUJUFUCUKAFGUMUDUGUH $.

    $( The left group action of element ` A ` in a topological group ` G ` is a
       homeomorphism from the group to itself.  (Contributed by Mario Carneiro,
       14-Aug-2015.) $)
    tgplacthmeo $p |- ( ( G e. TopGrp /\ A e. X ) -> F e. ( J Homeo J ) ) $=
      ( vg wcel wa co sylan cfv cmpt wceq eqid ctgp ccnv chmeo tgptmd tmdlactcn
      ccn ctmd cminusg cv wf1o cgrp tgpgrp grplactcnv simprd grplactfval adantl
      syl6eqr cnveqd grpinvcl syl 3eqtr3d syldan eqeltrd ishmeo sylanbrc ) EUAM
      ZBGMZNZDFFUFOZMZDUBZVIMDFFUCOMVFEUGMZVGVJEUDZABCDEFGHIJKUEPVHVKAGBEUHQZQZ
      AUIZCORZVIVHBLGAGLUIVPCORRZQZUBZVOVRQZVKVQVHGGVSUJZVTWASZVFEUKMZVGWBWCNEU
      LZBCLVREVNGAVRTZIJVNTZUMPUNVHVSDVHVSAGBVPCORZDVGVSWHSVFBCLVREGAWFIUOUPHUQ
      URVHVOGMZWAVQSVFWDVGWIWEGEVNBIWGUSPZVOCLVREGAWFIUOUTVAVFVGWIVQVIMZWJVFVLW
      IWKVMAVOCVQEFGVQTIJKUEPVBVCDFFVDVE $.
  $}

  ${
    $d x y G $.  $d x y H $.  $d x y S $.
    subgtgp.h $e |- H = ( G |`s S ) $.
    $( A submonoid of a topological monoid is a topological monoid.
       (Contributed by Mario Carneiro, 6-Oct-2015.) $)
    submtmd $p |- ( ( G e. TopMnd /\ S e. ( SubMnd ` G ) ) -> H e. TopMnd ) $=
      ( vx vy ctmd wcel cfv ctps cplusf co ctx ccn adantl cplusg cmpt2 eqid wss
      cv csubmnd wa ctopn crest submmnd cress tmdtps resstps sylan syl5eqel cbs
      cmnd wceq submbas ressplusg oveqd mpt2eq123dv plusffval syl6reqr tmdtopon
      ctopon adantr submss tmdcn syl5eqelr cnmpt2res eqeltrd crn wb wf mndplusf
      cxp frn 3syl sseqtr4d cnrest2 syl3anc mpbid resstopn istmd syl3anbrc ) BG
      HZABUAIZHZUBZCULHZCJHCKIZBUCIZAUDLZWIMLZWINLHZCGHWDWFWBACBDUEOZWECBAUFLZJ
      DWBBJHWDWMJHBUGABWCUHUIUJWEWGWJWHNLZHZWKWEWGEFAAETZFTZBPIZLZQZWNWEWTEFCUK
      IZXAWPWQCPIZLZQWGWEEFAAWSXAXAXCWDAXAUMWBACBDUNOZXDWEWRXBWPWQWDWRXBUMWBAWR
      BCWCDWRRZUOOUPUQEFXAXBWGCXARZXBRWGRZURUSWEEFWSWHWIWHWHWIABUKIZAXHWIRZWBWH
      XHVAIHZWDBWHXHWHRZXHRZUTVBZWDAXHSZWBXHABXLVCOZXIXMXOWBEFXHXHWSQZWHWHMLWHN
      LZHWDWBXPBKIZXQEFXHWRXRBXLXEXRRZURXRBWHXKXSVDVEVBVFVGWEXJWGVHZASXNWOWKVIX
      MWEXTXAAWEWFXAXAVLZXAWGVJXTXASWLXAWGCXFXGVKYAXAWGVMVNXDVOXOAWGWJWHXHVPVQV
      RWGCWIXGACWHBDXKVSVTWA $.

    $( A subgroup of a topological group is a topological group.  (Contributed
       by Mario Carneiro, 17-Sep-2015.) $)
    subgtgp $p |- ( ( G e. TopGrp /\ S e. ( SubGrp ` G ) ) -> H e. TopGrp ) $=
      ( ctgp wcel cfv cgrp ctmd cminusg ccn adantl cmpt cbs eqid syl adantr wss
      vx co csubg wa ctopn crest subggrp csubmnd tgptmd subgsubm submtmd syl2an
      cv wceq subgbas mpteq1d subginv adantll mpteq2dva grpinvf 3eqtr4rd ctopon
      feqmptd tgptopon subgss tgpgrp tgpinv eqeltrrd cnmpt1res eqeltrd sseqtr4d
      wf crn wb frn cnrest2 syl3anc mpbid resstopn istgp syl3anbrc ) BEFZABUAGF
      ZUBZCHFZCIFZCJGZBUCGZAUDTZWGKTFZCEFWAWCVTABCDUELZVTBIFABUFGFWDWABUGABUHAB
      CDUIUJWBWEWGWFKTZFZWHWBWESASUKZBJGZGZMZWJWBSAWLWEGZMSCNGZWPMWOWEWBSAWQWPW
      AAWQULVTABCDUMLZUNWBSAWNWPWAWLAFWNWPULVTABCWMWEWLDWMOZWEOZUOUPUQWBSWQWQWE
      WBWCWQWQWEVJZWIWQCWEWQOWTURPZVAUSWBSWNWFWGWFBNGZAWGOVTWFXCUTGFZWABWFXCWFO
      ZXCOZVBQZWAAXCRZVTXCABXFVCLZWBWMSXCWNMWFWFKTZWBSXCXCWMWBBHFZXCXCWMVJVTXKW
      ABVDQXCBWMXFWSURPVAVTWMXJFWABWMWFXEWSVEQVFVGVHWBXDWEVKZARXHWKWHVLXGWBXLWQ
      AWBXAXLWQRXBWQWQWEVMPWRVIXIAWEWGWFXCVNVOVPCWEWGACWFBDXEVQWTVRVS $.
  $}

  ${
    $d u x y A $.  $d u x y z G $.  $d u x y z J $.  $d u x y z S $.
    $d x y z R $.  $d x y z X $.
    subgntr.h $e |- J = ( TopOpen ` G ) $.
    $( A subgroup of a topological group with nonempty interior is open.
       Alternatively, dual to ~ clssubg , the interior of a subgroup is either
       a subgroup, or empty.  (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    subgntr $p |- ( ( G e. TopGrp /\ S e. ( SubGrp ` G ) /\
      A e. ( ( int ` J ) ` S ) ) -> S e. J ) $=
      ( vx vu vy wcel cfv cv wss wa co wceq eqid adantr syl syl2anc sseldd ctgp
      csubg cnt w3a wrex wral csg cplusg cmpt crn cbs cima cres df-ima tgptopon
      ctopon 3ad2ant1 ctop cuni topontop simpl2 subgss toponuni sseqtrd toponss
      ntropn resmpt rneqd syl5eq chmeo simpl1 ntrss2 simpl3 syl3anc tgplacthmeo
      simpr subgsubcl hmeoima eqeltrrd cgrp tgpgrp 3ad2ant2 sselda grpnpcan cvv
      ovex oveq2 elrnmpt1s sylancl wf subgcl fmptd eleq2 sseq1 anbi12d syl12anc
      frn rspcev ralrimiva wb eltop2 mpbird ) CUAIZBCUBJIZABDUCJJZIZUDZBDIZFKZG
      KZIZXJBLZMZGDUEZFBUFZXGXNFBXGXIBIZMZHXEXIACUGJZNZHKZCUHJZNZUIZUJZDIXIYDIZ
      YDBLZXNXQHCUKJZYBUIZXEULZYDDXQYIYHXEUMZUJYDYHXEUNXQYJYCXQXEYGLZYJYCOXQDYG
      UPJIZXEDIZYKXGYLXPXCXDYLXFCDYGEYGPZUOUQZQZXQDURIZBDUSZLZYMXGYQXPXGYLYQYOY
      GDUTRZQZXQBYGYRXQXDBYGLZXCXDXFXPVAZYGBCYNVBZRZXQYLYGYROYPYGDVCRVDZBDYRYRP
      ZVFSZXEDYGVESZHYGXEYBVGRVHVIXQYHDDVJNIZYMYIDIXQXCXSYGIUUJXCXDXFXPVKZXQBYG
      XSUUEXQXDXPABIXSBIZUUCXGXPVPXQXEBAXQYQYSXEBLUUAUUFBDYRUUGVLSZXCXDXFXPVMZT
      BCXRXIAXRPZVQVNZTHXSYAYHCDYGYHPYNYAPZEVOSUUHXEYHDDVRSVSXQXSAYANZXIYDXQCVT
      IZXIYGIAYGIUURXIOXQXCUUSUUKCWARXGBYGXIXDXCUUBXFUUDWBWCXQXEYGAUUIUUNTYGYAC
      XRXIAYNUUQUUOWDVNXQXFUURWEIUURYDIUUNXSAYAWFHXEYBUURAYCWEYCPZXTAXSYAWGWHWI
      VSXQXEBYCWJYFXQHXEYBBYCXQXTXEIZMXDUULXTBIYBBIXQXDUVAUUCQXQUULUVAUUPQXQXEB
      XTUUMWCYABCXSXTUUQWKVNUUTWLXEBYCWQRXMYEYFMGYDDXJYDOXKYEXLYFXJYDXIWMXJYDBW
      NWOWRWPWSXGYQXHXOWTYTFGBDXARXB $.

    $( An open subgroup of a topological group is also closed.  (Contributed by
       Mario Carneiro, 17-Sep-2015.) $)
    opnsubg $p |- ( ( G e. TopGrp /\ S e. ( SubGrp ` G ) /\ S e. J ) ->
      S e. ( Clsd ` J ) ) $=
      ( vx vu vy wcel cfv wss cdif eqid wceq syl cv wa adantr syl2anc eqeltrrd
      co ctgp csubg ccld cuni subgss 3ad2ant2 ctopon tgptopon 3ad2ant1 toponuni
      w3a cbs sseqtrd difeq1d wrex wral cplusg cmpt crn cima cres df-ima resmpt
      rneqd syl5eq chmeo simpl1 eldifi adantl tgplacthmeo simpl3 hmeoima tgpgrp
      c0g cgrp grprid cvv simpl2 subg0cl ovex oveq2 elrnmpt1s sylancl wf sselda
      grpcl syl3anc wn eldifn ad2antlr csg subgsubcl 3com23 3expia sylan eleq1d
      grppncan sylibd mtod eldifd fmptd frn eleq2 sseq1 anbi12d rspcev syl12anc
      wi ralrimiva ctop wb topontop eltop2 mpbird iscld mpbir2and ) BUAHZABUBIH
      ZACHZUKZACUCIHZACUDZJZYBAKZCHZXTABULIZYBXRXQAYFJZXSYFABYFLZUEUFZXTCYFUGIH
      ZYFYBMXQXRYJXSBCYFDYHUHUIZYFCUJNZUMXTYFAKZYDCXTYFYBAYLUNXTYMCHZEOZFOZHZYP
      YMJZPZFCUOZEYMUPZXTYTEYMXTYOYMHZPZGAYOGOZBUQIZTZURZUSZCHYOUUHHZUUHYMJZYTU
      UCGYFUUFURZAUTZUUHCUUCUULUUKAVAZUSUUHUUKAVBUUCUUMUUGUUCYGUUMUUGMXTYGUUBYI
      QZGYFAUUFVCNVDVEUUCUUKCCVFTHZXSUULCHUUCXQYOYFHZUUOXQXRXSUUBVGZUUBUUPXTYOY
      FAVHVIZGYOUUEUUKBCYFUUKLYHUUELZDVJRXQXRXSUUBVKAUUKCCVLRSUUCYOBVNIZUUETZYO
      UUHUUCBVOHZUUPUVAYOMUUCXQUVBUUQBVMNZUURYFUUEBYOUUTYHUUSUUTLZVPRUUCUUTAHZU
      VAVQHUVAUUHHUUCXRUVEXQXRXSUUBVRZABUUTUVDVSNYOUUTUUEVTGAUUFUVAUUTUUGVQUUGL
      ZUUDUUTYOUUEWAWBWCSUUCAYMUUGWDUUJUUCGAUUFYMUUGUUCUUDAHZPZUUFYFAUVIUVBUUPU
      UDYFHZUUFYFHUUCUVBUVHUVCQZUUCUUPUVHUURQZUUCAYFUUDUUNWEZYFUUEBYOUUDYHUUSWF
      WGUVIUUFAHZYOAHZUUBUVOWHXTUVHYOYFAWIWJUVIUVNUUFUUDBWKIZTZAHZUVOUUCXRUVHUV
      NUVRXHUVFXRUVHUVNUVRXRUVNUVHUVRABUVPUUFUUDUVPLZWLWMWNWOUVIUVQYOAUVIUVBUUP
      UVJUVQYOMUVKUVLUVMYFUUEBUVPYOUUDYHUUSUVSWQWGWPWRWSWTUVGXAAYMUUGXBNYSUUIUU
      JPFUUHCYPUUHMYQUUIYRUUJYPUUHYOXCYPUUHYMXDXEXFXGXIXTCXJHZYNUUAXKXTYJUVTYKY
      FCXLNZEFYMCXMNXNSXTUVTYAYCYEPXKUWAACYBYBLXONXP $.

    $( The closure of a subgroup in a topological group is a subgroup.
       (Contributed by Mario Carneiro, 17-Sep-2015.) $)
    clssubg $p |- ( ( G e. TopGrp /\ S e. ( SubGrp ` G ) ) ->
      ( ( cls ` J ) ` S ) e. ( SubGrp ` G ) ) $=
      ( vx vy vz wcel cfv wa wss cv co wral eqid adantr syl adantl wceq syl2anc
      ctgp csubg ccl cbs c0 wne csg cuni ctop ctopon tgptopon topontop toponuni
      subgss sseqtrd clsss3 sseqtr4d sscls c0g subg0cl ne0i ssn0 cop df-ov ccnv
      cxp cima opelxpi ctx syl22anc txtopon cdm cnvimass wf cgrp tgpgrp grpsubf
      txcls fdm syl5sseq subgsubcl 3expb ralrimivva fveq2 syl6eqr eleq1d sylibr
      ralxp wfun wb ffun xpss12 funimass5 mpbird clsss syl3anc tgpsubcn cncls2i
      ccn sstrd eqsstr3d sselda sylan2 wfn ad2antrr ffn elpreima mpbid syl5eqel
      4syl simprd w3a issubg4 mpbir3and ) BUAHZABUBIZHZJZACUCIIZXPHZXSBUDIZKZXS
      UEUFZELZFLZBUGIZMZXSHZFXSNEXSNZXRXSCUHZYAXRCUIHZAYJKZXSYJKXRCYAUJIHZYKXOY
      MXQBCYADYAOZUKPZYACULQZXRAYAYJXQAYAKZXOYAABYNUNRZXRYMYAYJSYOYACUMQZUOZACY
      JYJOZUPTYSUQXRAXSKZAUEUFZYCXRYKYLUUBYPYTACYJUUAURTXRBUSIZAHZUUCXQUUEXOABU
      UDUUDOUTRAUUDVAQAXSVBTXRYHEFXSXSXRYDXSHYEXSHJZJZYGYDYEVCZYFIZXSYDYEYFVDZU
      UGUUHYAYAVFZHZUUIXSHZUUGUUHYFVEZXSVGZHZUULUUMJZUUFXRUUHXSXSVFZHUUPYDYEXSX
      SVHXRUURUUOUUHXRUURAAVFZCCVIMZUCIZIZUUOXRYMYMYQYQUVBUURSYOYOYRYRAACCYAYAV
      RVJXRUVBUUNAVGZUVAIZUUOXRUUTUIHZUVCUUTUHZKUUSUVCKZUVBUVDKXRUUTUUKUJIHZUVE
      XRYMYMUVHYOYOCCYAYAVKTZUUKUUTULQXRUVCUUKUVFXRYFVLZUVCUUKYFAVMXRUUKYAYFVNZ
      UVJUUKSXRBVOHZUVKXOUVLXQBVPZPZYABYFYNYFOZVQZQZUUKYAYFVSQZVTXRUVHUUKUVFSUV
      IUUKUUTUMQUOXRUVGGLZYFIZAHZGUUSNZXQUWBXOXQYGAHZFANEANUWBXQUWCEFAAXQYDAHYE
      AHUWCABYFYDYEUVOWAWBWCUWAUWCGEFAAUVSUUHSZUVTYGAUWDUVTUUIYGUVSUUHYFWDUUJWE
      WFWHWGRXRYFWIZUUSUVJKUVGUWBWJXRUVKUWEUVQUUKYAYFWKQXRUUSUUKUVJXRYQYQUUSUUK
      KYRYRAYAAYAWLTUVRUQGUUSAYFWMTWNUVCUUSUUTUVFUVFOWOWPXRYFUUTCWSMHZYLUVDUUOK
      XOUWFXQBCYFDUVOWQPYTAYFUUTCYJUUAWRTWTXAXBXCUUGUVLUVKYFUUKXDUUPUUQWJXOUVLX
      QUUFUVMXEUVPUUKYAYFXFUUKUUHXSYFXGXJXHXKXIWCXRUVLXTYBYCYIXLWJUVNEFYAXSBYFY
      NUVOXMQXN $.

    $( The closure of a normal subgroup is a normal subgroup.  (Contributed by
       Mario Carneiro, 17-Sep-2015.) $)
    clsnsg $p |- ( ( G e. TopGrp /\ S e. ( NrmSGrp ` G ) ) ->
      ( ( cls ` J ) ` S ) e. ( NrmSGrp ` G ) ) $=
      ( vx vy wcel cfv wa cv co wral cmpt wf crn wss wceq eqid ad2antrr syl ccl
      ctgp cnsg csubg cplusg csg cbs nsgsubg clssubg sylan2 cima cres cuni ctop
      df-ima ctopon tgptopon topontop ad2antlr subgss toponuni sseqtrd sseqtr4d
      clsss3 syl2anc resmpt rneqd syl5eq ctmd tgptmd cnmptc cnmptid cnmpt1plusg
      ccn simpr ctx tgpsubcn cnmpt12f cnclsi nsgconj 3expa adantlll frn eqsstrd
      fmptd clsss syl3anc sstrd eqsstr3d wfn ovex fnmpti df-f mpbiran ralrimiva
      sylibr fmpt isnsg3 sylanbrc ) BUBGZABUCHZGZIZACUAHZHZBUDHZGZEJZFJZBUEHZKZ
      XHBUFHZKZXEGFXELZEBUGHZLXEXAGXBWTAXFGZXGABUHZABCDUIUJXCXNEXOXCXHXOGZIZXEX
      EFXEXMMZNZXNXSXTOZXEPZYAXSYBFXOXMMZXEUKZXEXSYEYDXEULZOYBYDXEUOXSYFXTXSXEX
      OPYFXTQXSXECUMZXOXSCUNGZAYGPZXEYGPXSCXOUPHGZYHWTYJXBXRBCXODXORZUQSZXOCURT
      ZXSAXOYGXSXPAXOPZXBXPWTXRXQUSXOABYKUTTZXSYJXOYGQYLXOCVATZVBZACYGYGRZVDVEY
      PVCFXOXEXMVFTVGVHXSYEYDAUKZXDHZXEXSYDCCVNKGYIYEYTPXSFXKXHXLCCCCXOYLXSFXHX
      IXJBCCXODXJRZWTBVIGXBXRBVJSYLXSFXHCCXOXOYLYLXCXRVOVKZXSFCXOYLVLVMUUBWTXLC
      CVPKCVNKGXBXRBCXLDXLRZVQSVRYQAYDCCYGYRVSVEXSYHYIYSAPYTXEPYMYQXSYSFAXMMZOZ
      AXSYSYDAULZOUUEYDAUOXSUUFUUDXSYNUUFUUDQYOFXOAXMVFTVGVHXSAAUUDNUUEAPXSFAXM
      AUUDXBXRXIAGZXMAGZWTXBXRUUGUUHXHXIXJABXLXOYKUUAUUCVTWAWBUUDRWEAAUUDWCTWDA
      YSCYGYRWFWGWHWIYAXTXEWJYCFXEXMXTXKXHXLWKXTRZWLXEXEXTWMWNWPFXEXEXMXTUUIWQW
      PWOEFXJXEBXLXOYKUUAUUCWRWS $.

    cldsubg.1 $e |- R = ( G ~QG S ) $.
    cldsubg.2 $e |- X = ( Base ` G ) $.
    $( A subgroup of finite index is closed iff it is open.  (Contributed by
       Mario Carneiro, 20-Sep-2015.) $)
    cldsubg $p |- ( ( G e. TopGrp /\ S e. ( SubGrp ` G ) /\ ( X /. R ) e. Fin )
      -> ( S e. ( Clsd ` J ) <-> S e. J ) ) $=
      ( vx vy vz wcel cfv wa cuni cdif wceq syl wss cvv ctgp csubg cqs cfn ccld
      w3a csn ctopon simpl1 tgptopon toponuni simpl2 unisng uneq2d uniun undif1
      difeq1d cun c0g cec eqid eqgid cqg co ovex eqeltri tgpgrp grpidcl ecelqsg
      sylancr eqeltrrd snssd ssequn2 sylib syl5eq unieqd wer eqger uniqs2 eqtrd
      cgrp a1i syl5eqr eqtr3d cin c0 wb difss unissi syl5sseq cpw cv wne adantr
      wn df-ne simpr qsdisj ord disj2 syl6ib syl5bi expimpd eldifsn vex 3imtr4g
      elpw ssrdv sspwuni sylibr uneqdifeq mpbid ctop topontop simpl3 diffi wrex
      syl2anc elqs cplusg cmpt cima simpll2 subgrcl subgss eqglact simplr chmeo
      syl3anc tgplacthmeo sseqtrd hmeocld eqeltrd syl5ibrcom rexlimdva ssdifssd
      sylan eleq1 unicld cldopn ex wi opnsubg 3expia 3adant3 impbid ) CUALZBCUB
      MZLZEAUCZUDLZUFZBDUEMZLZBDLZUULUUNUUOUULUUNNZDOZUUJBUGZPZOZPZBDUUPEUUTPZU
      VABUUPEUUQUUTUUPDEUHMLZEUUQQUUPUUGUVCUUGUUIUUKUUNUIZCDEFHUJRZEDUKRZUQUUPU
      UTBURZEQZUVBBQZUUPUUTUUROZURZUVGEUUPUVJBUUTUUPUUIUVJBQUUGUUIUUKUUNULZBUUH
      UMRUNUUPUVKUUSUURURZOZEUUSUURUOUUPUVNUUJOZEUUPUVMUUJUUPUVMUUJUURURZUUJUUJ
      UURUPUUPUURUUJSUVPUUJQUUPBUUJUUPCUSMZAUTZBUUJUUPUUIUVRBQUVLACEBUVQHGUVQVA
      ZVBRUUPATLZUVQELZUVRUUJLACBVCVDTGCBVCVEVFZUUPCWALZUWAUUPUUGUWCUVDCVGRECUV
      QHUVSVHREUVQATVIVJVKZVLUURUUJVMVNVOVPUUPEATUUPUUIEAVQZUVLACEBHGVRRZUVTUUP
      UWBWBVSZVTWCWDUUPUUTESUUTBWEWFQZUVHUVIWGUUPUVOUUTEUUSUUJUUJUURWHWIUWGWJUU
      PUUTTBPZSZUWHUUPUUSUWIWKZSUWJUUPIUUSUWKUUPIWLZUUJLZUWLBWMZNUWLUWISZUWLUUS
      LUWLUWKLUUPUWMUWNUWOUWNUWLBQZWOZUUPUWMNZUWOUWLBWPUWRUWQUWLBWEWFQZUWOUWRUW
      PUWSUWREUWLBAEUUPUWEUWMUWFWNUUPUWMWQUUPBUUJLUWMUWDWNWRWSUWLBWTXAXBXCUWLUU
      JBXDUWLUWIIXEZXGXFXHUUSUWIXIVNUUTBWTXJUUTBEXKXRXLWDUUPUUTUUMLZUVADLUUPDXM
      LZUUSUDLZUUSUUMSUXAUUPUVCUXBUVEEDXNRUUPUUKUXCUUGUUIUUKUUNXOUUJUURXPRUUPUU
      JUUMUURUUPIUUJUUMUWMUWLJWLZAUTZQZJEXQUUPUWLUUMLZJEUWLAUWTXSUUPUXFUXGJEUUP
      UXDELZNZUXGUXFUXEUUMLUXIUXEKEUXDKWLCXTMZVDYAZBYBZUUMUXIUWCBESZUXHUXEUXLQU
      XIUUIUWCUUGUUIUUKUUNUXHYCBCYDRUUPUXMUXHUUPUUIUXMUVLEBCHYERZWNUUPUXHWQKUXD
      UXJACEBHGUXJVAZYFYIUXIUUNUXLUUMLZUULUUNUXHYGUXIUXKDDYHVDLZBUUQSZUUNUXPWGU
      UPUUGUXHUXQUVDKUXDUXJUXKCDEUXKVAHUXOFYJYQUUPUXRUXHUUPBEUUQUXNUVFYKWNBUXKD
      DUUQUUQVAZYLXRXLYMUWLUXEUUMYRYNYOXBXHYPUUSDUUQUXSYSYIUUTDUUQUXSYTRVKUUAUU
      GUUIUUOUUNUUBUUKUUGUUIUUOUUNBCDFUUCUUDUUEUUF $.
  $}

  ${
    $d y z .~ $.  $d x z .0. $.  $d g x y z A $.  $d w x y z J $.  $d y z S $.
    $d g w x y z G $.  $d g w x y z X $.
    tgpconcomp.x $e |- X = ( Base ` G ) $.
    tgpconcomp.z $e |- .0. = ( 0g ` G ) $.
    tgpconcomp.j $e |- J = ( TopOpen ` G ) $.
    tgpconcomp.s $e |- S =
      U. { x e. ~P X | ( .0. e. x /\ ( J |`t x ) e. Con ) } $.
    ${
      tgpconcompeqg.r $e |- .~ = ( G ~QG S ) $.
      $( The connected component containing ` A ` is the left coset of the
         identity component containing ` A ` .  (Contributed by Mario Carneiro,
         17-Sep-2015.) $)
      tgpconcompeqg $p |- ( ( G e. TopGrp /\ A e. X ) ->
        [ A ] .~ = U. { x e. ~P X | ( A e. x /\ ( J |`t x ) e. Con ) } ) $=
        ( vz wcel crest co wss wceq adantr vy vg ctgp wa cec ccon cpw crab cuni
        wbr cab dfec2 adantl cminusg cfv cplusg w3a ssrab2 sspwuni mpbi eqsstri
        cv a1i eqid eqgval syldan simp2 syl6bi abssdv eqsstrd simpr cgrp tgpgrp
        wb grplinv sylan ctopon grpidcl syl concompid syl2anc eqeltrd mpbir3and
        tgptopon elecg mpbird cmpt cima eqglact mp3an2 oveq2d chmeo tgplacthmeo
        hmeocn toponuni syl5sseq concompcon conima concompss syl3anc wral elpwi
        wi ccnv mptpreima grprid simprrl oveq2 eleq1d elrab2 sylanbrc hmeocnvcn
        ccn simprl sseqtrd simprrr wfun cdm grplactcnv simpld grplactfval mpbid
        wf1o f1oeq1 f1ocnv 3syl f1odm sseqtr4d funimass3 imacnvcnv syl6eqr expr
        f1ofun sylan2 ralrimiva eleq2 anbi12d ralrab sylibr unissb eqssd ) EUCO
        ZBGOZUDZBCUEZBAVBZOZFUUFPQZUFOZUDZAGUGZUHZUIZUUDUUEGRBUUEOZFUUEPQZUFOUU
        EUUMRUUDUUEBNVBZCUJZNUKZGUUCUUEUURSUUBNBCGULUMUUDUUQNGUUDUUQUUCUUPGOZBE
        UNUOZUOZUUPEUPUOZQDOZUQZUUSUUBUUCDGRZUUQUVDVNUVEUUDDHUUFOUUIUDZAUUKUHZU
        IZGLUVGUUKRUVHGRUVFAUUKURUVGGUSUTVAZVCZBUUPUVBCDEUUTUCGIUUTVDZUVBVDZMVE
        VFUUCUUSUVCVGVHVIVJUUDUUNBBCUJZUUDUVMUUCUUCUVABUVBQZDOZUUBUUCVKZUVPUUDU
        VNHDUUBEVLOZUUCUVNHSEVMZGUVBEUUTBHIUVLJUVKVOVPUUDFGVQUOOZHGOZHDOUUBUVSU
        UCEFGKIWDTZUUDUVQUVTUUBUVQUUCUVRTGEHIJVRVSZAHDFGLVTWAWBUUBUUCUVEUVMUUCU
        UCUVOUQVNUVJBBUVBCDEUUTUCGIUVKUVLMVEVFWCUUDUUCUUCUUNUVMVNUVPUVPBBCGGWEW
        AWFUUDUUOFNGBUUPUVBQZWGZDWHZPQUFUUDUUEUWEFPUUBUVQUUCUUEUWESZUVRUVQUVEUU
        CUWFUVINBUVBCEGDIMUVLWIWJVPZWKUUDDUWDFFFUIZUWHVDZUUDUWDFFWLQOZUWDFFXMQZ
        ONBUVBUWDEFGUWDVDZIUVLKWMZUWDFFWNVSUUDGDUWHUVIUUDUVSGUWHSZUWAGFWOVSZWPU
        UDUVSUVTFDPQUFOUWAUWBAHDFGLWQWAWRWBABUUMUUEFGUUMVDWSWTUUDUAVBZUUERZUAUU
        LXAZUUMUUERUUDBUWPOZFUWPPQZUFOZUDZUWQXCZUAUUKXAUWRUUDUXCUAUUKUWPUUKOUUD
        UWPGRZUXCUWPGXBUUDUXDUXBUWQUUDUXDUXBUDZUDZUWPUWDXDZXDDWHZUUEUXFUXGUWPWH
        ZDRZUWPUXHRZUXFUXIGRZHUXIOZFUXIPQUFOUXJUXLUXFUXIUWCUWPOZNGUHGNGUWCUWPUW
        DUWLXEZUXNNGURVAVCUXFUVTBHUVBQZUWPOZUXMUUDUVTUXEUWBTUXFUXPBUWPUUDUXPBSZ
        UXEUUBUVQUUCUXRUVRGUVBEBHIUVLJXFVPTUUDUXDUWSUXAXGWBUXNUXQNHGUXIUUPHSUWC
        UXPUWPUUPHBUVBXHXIUXOXJXKUXFUWPUXGFFUWHUWIUUDUXGUWKOZUXEUUDUWJUXSUWMUWD
        FFXLVSTUXFUWPGUWHUUDUXDUXBXNZUUDUWNUXEUWOTXOUUDUXDUWSUXAXPWRAHDUXIFGLWS
        WTUXFUXGXQZUWPUXGXRZRUXJUXKVNUXFGGUWDYCZGGUXGYCZUYAUUDUYCUXEUUDGGBUBGNG
        UBVBUUPUVBQWGWGZUOZYCZUYCUUDUYGUYFXDUVAUYEUOSZUUBUVQUUCUYGUYHUDUVRBUVBU
        BUYEEUUTGNUYEVDZIUVLUVKXSVPXTUUDUYFUWDSZUYGUYCVNUUCUYJUUBBUVBUBUYEEGNUY
        IIYAUMGGUYFUWDYDVSYBTZGGUWDYEZGGUXGYMYFUXFUWPGUYBUXTUXFUYCUYDUYBGSUYKUY
        LGGUXGYGYFYHUWPDUXGYIWAYBUXFUUEUWEUXHUUDUWFUXEUWGTUWDDYJYKYHYLYNYOUUJUX
        BUWQUAAUUKUUFUWPSZUUGUWSUUIUXAUUFUWPBYPUYMUUHUWTUFUUFUWPFPXHXIYQYRYSUAU
        ULUUEYTYSUUA $.
    $}

    $( The identity component, the connected component containing the identity
       element, is a closed ( ~ concompcld ) normal subgroup.  (Contributed by
       Mario Carneiro, 17-Sep-2015.) $)
    tgpconcomp $p |- ( G e. TopGrp -> S e. ( NrmSGrp ` G ) ) $=
      ( vy vz wcel cfv co wss syl wceq adantr eqid vw ctgp csubg cv cplusg wral
      wi cnsg c0 wne csg crest ccon wa cpw crab cuni ssrab2 sspwuni eqsstri a1i
      mpbi ctopon tgptopon cgrp tgpgrp grpidcl concompid syl2anc ne0i cmpt cima
      wf crn cres df-ima resmpt ax-mp rneqi eqtri imassrn sselda simpr grpsubcl
      syl3anc fmptd frn syl5ss grpsubid ovex oveq2 elrnmpt1s eqeltrrd syl6eleqr
      cvv sylancl chmeo cminusg ccom grpsubval sylan mpteq2dva grpinvcl grpinvf
      feqmptd fmptco eqtr4d grpinvhmeo tgplacthmeo syldan hmeoco eqeltrd hmeocn
      eqidd toponuni syl5sseq concompcon conima concompss syl5eqssr fnmpti df-f
      ccn wfn mpbiran sylibr fmpt ralrimiva w3a wb issubg4 mpbir3and oveq1d cqg
      wbr eqgval cec tgpconcompeqg elec mpbid oppginv fveq1d grpinvinv oppgplus
      coppg simprll eqtr3d syl6eq simprlr simprr oppgtgp oppgid oppgtopn eleq2d
      oppgbas vex fvex 3bitr3g simp3d expr ralrimivva isnsg2 sylanbrc ) CUBMZBC
      UCNMZKUDZLUDZCUENZOZBMZUVGUVFUVHOZBMZUGZLEUFKEUFBCUHNMUVDUVEBEPZBUIUJZUVF
      UVGCUKNZOZBMLBUFZKBUFZUVNUVDBFAUDZMDUVTULOUMMZUNZAEUOZUPZUQZEJUWDUWCPUWEE
      PUWBAUWCURUWDEUSVBUTZVAZUVDFBMZUVOUVDDEVCNMZFEMZUWHCDEIGVDZUVDCVEMZUWJCVF
      ZECFGHVGQZAFBDEJVHVIBFVJQUVDUVRKBUVDUVFBMZUNZBBLBUVQVKZVMZUVRUWPUWQVNZBPZ
      UWRUWPUWSLEUVQVKZBVLZBUXBUXABVOZVNUWSUXABVPUXCUWQUVNUXCUWQRUWFLEBUVQVQVRV
      SVTZUWPUXBEPFUXBMDUXBULOUMMUXBBPUWPUXBUXAVNZEUXABWAUWPEEUXAVMUXEEPUWPLEUV
      QEUXAUWPUVGEMZUNUWLUVFEMZUXFUVQEMUWPUWLUXFUVDUWLUWOUWMSZSUWPUXGUXFUVDBEUV
      FUWGWBZSUWPUXFWCECUVPUVFUVGGUVPTZWDWEUXATWFEEUXAWGQWHUWPFUWSUXBUWPUVFUVFU
      VPOZFUWSUWPUWLUXGUXKFRUXHUXIECUVPUVFFGHUXJWIVIUWPUWOUXKWOMUXKUWSMUVDUWOWC
      UVFUVFUVPWJLBUVQUXKUVFUWQWOUWQTZUVGUVFUVFUVPWKWLWPWMUXDWNUWPBUXADDDUQZUXM
      TUWPUXADDWQOZMUXADDYCOMUWPUXAUAEUVFUAUDZUVHOZVKZCWRNZWSZUXNUWPUXALEUVFUVG
      UXRNZUVHOZVKUXSUWPLEUVQUYAUWPUXGUXFUVQUYARUXIEUVHCUXRUVPUVFUVGGUVHTZUXRTZ
      UXJWTXAXBUWPLUAEEUXTUXPUYAUXRUXQUWPUWLUXFUXTEMUXHECUXRUVGGUYCXCXAUWPLEEUX
      RUVDEEUXRVMZUWOUVDUWLUYDUWMECUXRGUYCXDQSXEUWPUXQXNUXOUXTUVFUVHWKXFXGUWPUX
      RUXNMZUXQUXNMZUXSUXNMUVDUYEUWOCUXRDIUYCXHSUVDUWOUXGUYFUXIUAUVFUVHUXQCDEUX
      QTGUYBIXIXJUXRUXQDDDXKVIXLUXADDXMQUWPEBUXMUWFUVDEUXMRZUWOUVDUWIUYGUWKEDXO
      QSXPUVDDBULOUMMZUWOUVDUWIUWJUYHUWKUWNAFBDEJXQVISXRAFBUXBDEJXSWEXTUWRUWQBY
      DUWTLBUVQUWQUVFUVGUVPWJUXLYABBUWQYBYEYFLBBUVQUWQUXLYGYFYHUVDUWLUVEUVNUVOU
      VSYIYJUWMKLEBCUVPGUXJYKQYLUVDUVMKLEEUVDUXGUXFUNZUVJUVLUVDUYIUVJUNZUNZUVFU
      XRNZCUUENZWRNZNZUVGUYMUENZOZUVKBUYKUYQUVFUVGUYPOUVKUYKUYOUVFUVGUYPUYKUYLU
      XRNZUYOUVFUYKUYLUXRUYNUYKUWLUXRUYNRUVDUWLUYJUWMSZCUXRUYMUYMTZUYCUUAQUUBUY
      KUWLUXGUYRUVFRUYSUVDUXGUXFUVJUUFZECUXRUVFGUYCUUCVIZUUGYMUVHUYPCUYMUVFUVGU
      YBUYTUYPTZUUDUUHUYKUYLEMZUXFUYQBMZUYKUYLUVGUYMBYNOZYOZVUDUXFVUEYIZUYKUYLU
      VGCBYNOZYOZVUGUYKVUJVUDUXFUYRUVGUVHOZBMZUYKUWLUXGVUDUYSVUAECUXRUVFGUYCXCV
      IZUVDUXGUXFUVJUUIUYKVUKUVIBUYKUYRUVFUVGUVHVUBYMUVDUYIUVJUUJXLUYKUWLUVNVUJ
      VUDUXFVULYIYJUYSUWFUYLUVGUVHVUIBCUXRVEEGUYCUYBVUITZYPWPYLUYKUVGUYLVUIYQZM
      UVGUYLVUFYQZMVUJVUGUYKVUOVUPUVGUYKVUOUYLUVTMUWAUNAUWCUPUQZVUPUVDUYJVUDVUO
      VUQRVUMAUYLVUIBCDEFGHIJVUNYRXJUYKUYMUBMZVUDVUPVUQRUVDVURUYJCUYMUYTUUKSZVU
      MAUYLVUFBUYMDEFECUYMUYTGUUOZCUYMFUYTHUULCDUYMUYTIUUMJVUFTZYRVIXGUUNUVGUYL
      VUILUUPZUVFUXRUUQZYSUVGUYLVUFVVBVVCYSUURYTUYKVURUVNVUGVUHYJVUSUWFUYLUVGUY
      PVUFBUYMUYNUBEVUTUYNTVUCVVAYPWPYTUUSWMUUTUVAKLUVHBCEGUYBUVBUVC $.

    $( The identity component is a subset of any open subgroup.  (Contributed
       by Mario Carneiro, 17-Sep-2015.) $)
    tgpconcompss $p |- ( ( G e. TopGrp /\ T e. ( SubGrp ` G ) /\ T e. J ) ->
      S C_ T ) $=
      ( ctgp wcel csubg cfv w3a ctopon ccld cin wss tgptopon simp3 opnsubg elin
      3ad2ant1 sylanbrc subg0cl 3ad2ant2 concompclo syl3anc ) DLMZCDNOMZCEMZPZE
      FQOMZCEEROZSMZGCMZBCTUKULUOUMDEFJHUAUEUNUMCUPMUQUKULUMUBCDEJUCCEUPUDUFULU
      KURUMCDGIUGUHAGBCEFKUIUJ $.
  $}

  ${
    $d u v w x y z A $.  $d u v w x y z F $.  $d u v w x y z G $.
    $d u v w x y z H $.  $d u w x y z J $.  $d u v w x y z X $.
    $d u w x y z K $.
    ghmcnp.x $e |- X = ( Base ` G ) $.
    ghmcnp.j $e |- J = ( TopOpen ` G ) $.
    ghmcnp.k $e |- K = ( TopOpen ` H ) $.
    $( A group homomorphism on topological groups is continuous everywhere if
       it is continuous at any point.  (Contributed by Mario Carneiro,
       21-Oct-2015.) $)
    ghmcnp $p |- ( ( G e. TopMnd /\ H e. TopMnd /\ F e. ( G GrpHom H ) ) ->
      ( F e. ( ( J CnP K ) ` A ) <-> ( A e. X /\ F e. ( J Cn K ) ) ) ) $=
      ( vw wcel co cfv wa eqid adantr syl syl3anc wceq vx vy vu vz vv ctmd cghm
      w3a ccnp cuni ccn wi cnprcl a1i cbs wf cv ctopon tmdtopon 3ad2ant1 simpl2
      wral simpr cima wss wrex csg cplusg crab cmpt ccnv mptpreima cgrp simpll3
      cnpf2 ghmgrp1 simprl adantl toponuni eleqtrrd grpsubcl ffvelrnd tmdlactcn
      syl2anc simprrl cnima syl5eqelr ghmsub oveq1d ghmgrp2 eqtrd simprrr oveq2
      grpnpcan eqeltrd eleq1d elrab sylanbrc cnpimaex ssrab simprbi wfn toponss
      wb ffn sylan ralima syl5ib simpl1 ad2antrr fveq2 oveq2d rspccv ghmlin c0g
      grpcl cminusg grprinv eqtr3d grpass syl13anc grplid 3eqtr3d fveq2d sylibd
      grpinvsub adantlr ralrimiva ralrab2 sylibr wfun cdm ffun ssrab2 syl5sseqr
      fdm funimass4 mpbird expr mpbir2and imaeq2 sseq1d anbi12d rspcev syl12anc
      eleq2 sylan2d rexlimdva anassrs iscnp cncnp ex jcad cncnpi ancoms impbid1
      mpd eleq2d anbi1d bitr4d ) CUFLZDUFLZBCDUGMLZUHZBAEFUIMZNLZAEUJZLZBEFUKML
      ZOZAGLZUVIOUVDUVFUVJUVDUVFUVHUVIUVFUVHULUVDABEFUVGUVGPZUMZUNUVDUVFUVIUVDU
      VFOZUVIGDUONZBUPZBUAUQZUVENLZUAGVBZUVNEGURNLZFUVOURNLZUVFUVPUVDUVTUVFUVAU
      VBUVTUVCCEGIHUSUTZQZUVNUVBUWAUVAUVBUVCUVFVAZDFUVOJUVOPZUSRZUVDUVFVCZABEFG
      UVOVOSZUVNUVRUAGUVNUVQGLZOZUVRUVPUVQBNZUBUQZLZUVQUCUQZLZBUWNVDZUWLVEZOZUC
      EVFZULZUBFVBZUVNUVPUWIUWHQUWJUWTUBFUWJUWLFLZUWMUWSUVNUWIUXBUWMOZUWSUVNUWI
      UXCOZOZAUDUQZLZBUXFVDZUVQACVGNZMZBNZKUQZDVHNZMZUWLLZKUVOVIZVEZOZUDEVFZUWS
      UXEUVFUXPFLABNZUXPLZUXSUVNUVFUXDUWGQUXEUXPKUVOUXNVJZVKUWLVDZFKUVOUXNUWLUY
      BUYBPZVLUXEUYBFFUKMLZUXBUYCFLUXEUVBUXKUVOLUYEUVNUVBUXDUWDQUXEGUVOUXJBUVNU
      VPUXDUWHQZUXECVMLZUWIUVKUXJGLZUXEUVCUYGUVAUVBUVCUVFUXDVNZCDBVPZRZUVNUWIUX
      CVQZUVNUVKUXDUVNAUVGGUVFUVHUVDUVMVRUVNUVTGUVGTZUWCGEVSZRVTQZGCUXIUVQAHUXI
      PZWASZWBKUXKUXMUYBDFUVOUYDUWEUXMPZJWCWDUVNUWIUXBUWMWEUWLUYBFFWFWDWGUXEUXT
      UVOLZUXKUXTUXMMZUWLLZUYAUXEGUVOABUYFUYOWBZUXEUYTUWKUWLUXEUYTUWKUXTDVGNZMZ
      UXTUXMMZUWKUXEUXKVUDUXTUXMUXEUVCUWIUVKUXKVUDTUYIUYLUYOGCDUVQBUXIVUCAHUYPV
      UCPZWHSWIUXEDVMLZUWKUVOLUYSVUEUWKTUXEUVCVUGUYICDBWJRUXEGUVOUVQBUYFUYLWBVU
      BUVOUXMDVUCUWKUXTUWEUYRVUFWNSWKUVNUWIUXBUWMWLWOUXOVUAKUXTUVOUXLUXTTUXNUYT
      UWLUXLUXTUXKUXMWMWPWQWRUDUXPABEFWSSUXEUXRUWSUDEUXEUXFELZOZUXQUXKUEUQZBNZU
      XMMZUWLLZUEUXFVBZUXGUWSUXQUXOKUXHVBZVUIVUNUXQUXHUVOVEVUOUXOKUVOUXHWTXAVUI
      BGXBZUXFGVEZVUOVUNXDVUIUVPVUPUXEUVPVUHUYFQGUVOBXERUXEUVTVUHVUQUVNUVTUXDUW
      CQUXFEGXCXFUXOVUMKUEGUXFBUXLVUKTUXNVULUWLUXLVUKUXKUXMWMWPXGWDXHUXEVUHUXGV
      UNOZUWSUXEVUHVUROZOZAUVQUXIMZUXLCVHNZMZUXFLZKGVIZELUVQVVELZBVVEVDZUWLVEZU
      WSVUTVVEKGVVCVJZVKUXFVDZEKGVVCUXFVVIVVIPZVLVUTVVIEEUKMLZVUHVVJELVUTUVAVVA
      GLZVVLUVNUVAUXDVUSUVAUVBUVCUVFXIXJVUTUYGUVKUWIVVMUXEUYGVUSUYKQZUXEUVKVUSU
      YOQZUXEUWIVUSUYLQZGCUXIAUVQHUYPWAZSKVVAVVBVVICEGVVKHVVBPZIWCWDUXEVUHVURVQ
      UXFVVIEEWFWDWGVUTUWIVVAUVQVVBMZUXFLZVVFVVPVUTVVSAUXFVUTUYGUVKUWIVVSATVVNV
      VOVVPGVVBCUXIAUVQHVVRUYPWNSUXEVUHUXGVUNWEWOVVDVVTKUVQGUXLUVQTVVCVVSUXFUXL
      UVQVVAVVBWMWPWQWRVUTVVHVUKUWLLZUEVVEVBZVUTVVDUXLBNZUWLLZULZKGVBVWBVUTVWEK
      GVUTUXLGLZOZVVDUXKVVCBNZUXMMZUWLLZVWDVUTVVDVWJULZVWFVUTVUNVWKUXEVUHUXGVUN
      WLVUMVWJUEVVCUXFVUJVVCTZVULVWIUWLVWLVUKVWHUXKUXMVUJVVCBXKXLWPXMRQVWGVWIVW
      CUWLUXEVWFVWIVWCTVUSUXEVWFOZUXJVVCVVBMZBNZVWIVWCVWMUVCUYHVVCGLZVWOVWITUXE
      UVCVWFUYIQZUXEUYHVWFUYQQZVWMUYGVVMVWFVWPVWMUVCUYGVWQUYJRZVWMUYGUVKUWIVVMV
      WSUXEUVKVWFUYOQZUXEUWIVWFUYLQZVVQSZUXEVWFVCZGVVBCVVAUXLHVVRXPSVVBUXMCDUXJ
      BVVCGHVVRUYRXNSVWMVWNUXLBVWMUXJVVAVVBMZUXLVVBMZCXONZUXLVVBMZVWNUXLVWMVXDV
      XFUXLVVBVWMUXJUXJCXQNZNZVVBMZVXDVXFVWMVXIVVAUXJVVBVWMUYGUWIUVKVXIVVATVWSV
      XAVWTGCUXIVXHUVQAHUYPVXHPZYFSXLVWMUYGUYHVXJVXFTVWSVWRGVVBCVXHUXJVXFHVVRVX
      FPZVXKXRWDXSWIVWMUYGUYHVVMVWFVXEVWNTVWSVWRVXBVXCGVVBCUXJVVAUXLHVVRXTYAVWM
      UYGVWFVXGUXLTVWSVXCGVVBCUXLVXFHVVRVXLYBWDYCYDXSYGWPYEYHVVDVWAVWDUEKGVUJUX
      LTVUKVWCUWLVUJUXLBXKWPYIYJVUTBYKZVVEBYLZVEVVHVWBXDVUTUVPVXMUXEUVPVUSUYFQZ
      GUVOBYMRVUTGVVEVXNVVDKGYNVUTUVPVXNGTVXOGUVOBYPRYOUEVVEUWLBYQWDYRUWRVVFVVH
      OUCVVEEUWNVVETZUWOVVFUWQVVHUWNVVEUVQUUFVXPUWPVVGUWLUWNVVEBUUAUUBUUCUUDUUE
      YSUUGUUHUUQUUIYSYHUWJUVTUWAUWIUVRUVPUXAOXDUVNUVTUWIUWCQUVNUWAUWIUWFQUVNUW
      IVCUCUBUVQBEFGUVOUUJSYTYHUVNUVTUWAUVIUVPUVSOXDUWCUWFUABEFGUVOUUKWDYTUULUU
      MUVIUVHUVFABEFUVGUVLUUNUUOUUPUVDUVKUVHUVIUVDGUVGAUVDUVTUYMUWBUYNRUURUUSUU
      T $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x J $.  $d x .~ $.  $d x y X $.  $d x y .0. $.
    $d x S $.
    snclseqg.x $e |- X = ( Base ` G ) $.
    snclseqg.j $e |- J = ( TopOpen ` G ) $.
    snclseqg.z $e |- .0. = ( 0g ` G ) $.
    snclseqg.r $e |- .~ = ( G ~QG S ) $.
    snclseqg.s $e |- S = ( ( cls ` J ) ` { .0. } ) $.
    $( The coset of the closure of the identity is the closure of a point.
       (Contributed by Mario Carneiro, 22-Sep-2015.) $)
    snclseqg $p |- ( ( G e. TopGrp /\ A e. X ) ->
      [ A ] .~ = ( ( cls ` J ) ` { A } ) ) $=
      ( vx vy wcel cfv wss wceq syl eqid ctgp wa cec cv cplusg co cmpt csn cima
      ccl imaeq2i cgrp tgpgrp adantr cuni ctop ctopon tgptopon topontop grpidcl
      snssd toponuni sseqtrd clsss3 syl2anc sseqtr4d syl5eqss simpr tgplacthmeo
      eqglact syl3anc chmeo hmeocls 3eqtr4a crn cres df-ima resmpt rneqd syl5eq
      wrex cab c0g cvv fvex oveq2 eqeq2d rexsn grprid sylan syl5bb abbidv rnmpt
      eqeltri df-sn 3eqtr4g eqtrd fveq2d ) DUAOZAFOZUBZABUCZMFAMUDZDUEPZUFZUGZG
      UHZUIZEUJPZPZAUHZXIPXAXFCUIZXFXGXIPZUIZXBXJCXMXFLUKXADULOZCFQWTXBXLRWSXOW
      TDUMZUNZXACXMFLXAXMEUOZFXAEUPOZXGXRQZXMXRQXAEFUQPOZXSWSYAWTDEFIHURUNZFEUS
      SXAXGFXRXAGFXAXOGFOXQFDGHJUTSVAZXAYAFXRRYBFEVBSZVCZXGEXRXRTZVDVEYDVFVGWSW
      TVHMAXDBDFCHKXDTZVJVKXAXFEEVLUFOXTXJXNRMAXDXFDEFXFTHYGIVIYEXGXFEEXRYFVMVE
      VNXAXHXKXIXAXHMXGXEUGZVOZXKXAXHXFXGVPZVOYIXFXGVQXAYJYHXAXGFQYJYHRYCMFXGXE
      VRSVSVTXANUDZXERZMXGWAZNWBYKARZNWBYIXKXAYMYNNYMYKAGXDUFZRZXAYNYLYPMGGDWCP
      WDJDWCWEWNXCGRXEYOYKXCGAXDWFWGWHXAYOAYKWSXOWTYOARXPFXDDAGHYGJWIWJWGWKWLMN
      XGXEYHYHTWMNAWOWPWQWRWQ $.
  $}

  ${
    $d x y G $.  $d x y .0. $.
    tgphaus.1 $e |- .0. = ( 0g ` G ) $.
    tgphaus.j $e |- J = ( TopOpen ` G ) $.
    $( A topological group is Hausdorff iff the identity subgroup is closed.
       (Contributed by Mario Carneiro, 18-Sep-2015.) $)
    tgphaus $p |- ( G e. TopGrp ->
      ( J e. Haus <-> { .0. } e. ( Clsd ` J ) ) ) $=
      ( vx vy wcel ccld cfv wi eqid syl wceq cid cres co cv wa wb ctgp cha cuni
      csn cbs cgrp tgpgrp grpidcl ctopon tgptopon toponuni eleqtrd sncld expcom
      ctx csg ccnv cima ccn tgpsubcn cnclima ex wbr copab wrel cxp wss cnvimass
      cdm wf grpsubf fdm syl5sseq relxp relss ee10 dfrel4v cop wfn ffn elpreima
      sylib opelxp anbi1i grpsubeq0 3expb sylan df-ov eleq1i ovex bitr3i equcom
      elsnc 3bitr4g pm5.32da syl5bb bitrd df-br eleq1 biimparc pm4.71i opabbidv
      an32 bitr4i opabresid syl6eq reseq2d 3eqtrd eleq1d ctop topontop hausdiag
      sylibd baib sylibrd impbid ) AUAHZBUBHZCUDZBIJHZXQCBUCZHZXRXTKXQCAUEJZYAX
      QAUFHZCYCHAUGZYCACYCLZDUHMXQBYCUIJHZYCYANABYCEYFUJZYCBUKMZULXRYBXTCBYAYAL
      ZUMUNMXQXTOYAPZBBUOQZIJZHZXRXQXTAUPJZUQXSURZYMHZYNXQYOYLBUSQHZXTYQKABYOEY
      OLZUTYRXTYQXSYOYLBVAVBMXQYPYKYMXQYPFRZGRZYPVCZFGVDZOYCPZYKXQYPVEZYPUUCNXQ
      YPYCYCVFZVGUUFVEUUEXQYOVIZYPUUFYOXSVHXQUUFYCYOVJZUUGUUFNXQYDUUHYEYCAYOYFY
      SVKMZUUFYCYOVLMVMYCYCVNYPUUFVOVPFGYPVQWBXQUUCYTYCHZUUAYTNZSZFGVDUUDXQUUBU
      ULFGXQYTUUAVRZYPHZUUJUUAYCHZSZUUKSZUUBUULXQUUNUUMUUFHZUUMYOJZXSHZSZUUQXQY
      OUUFVSZUUNUVATXQUUHUVBUUIUUFYCYOVTMUUFUUMXSYOWAMUVAUUPUUTSXQUUQUURUUPUUTY
      TUUAYCYCWCWDXQUUPUUTUUKXQUUPSYTUUAYOQZCNZYTUUANZUUTUUKXQYDUUPUVDUVETZYEYD
      UUJUUOUVFYCAYOYTUUACYFDYSWEWFWGUUTUVCXSHUVDUVCUUSXSYTUUAYOWHWIUVCCYTUUAYO
      WJWMWKGFWLWNWOWPWQYTUUAYPWRUULUULUUOSUUQUULUUOUUKUUOUUJUUAYTYCWSWTXAUUJUU
      OUUKXCXDWNXBFGYCXEXFXQYCYAOYIXGXHXIXMXQBXJHZXRYNTXQYGUVGYHYCBXKMXRUVGYNBY
      AYJXLXNMXOXP $.
  $}

  ${
    tgpt1.j $e |- J = ( TopOpen ` G ) $.
    $( Hausdorff and T1 are equivalent for topological groups.  (Contributed by
       Mario Carneiro, 18-Sep-2015.) $)
    tgpt1 $p |- ( G e. TopGrp -> ( J e. Haus <-> J e. Fre ) ) $=
      ( ctgp wcel cha ct1 haust1 c0g cfv csn ccld cuni wi cbs cgrp eqid grpidcl
      tgpgrp syl wceq tgptopon toponuni eleqtrd t1sncld tgphaus sylibrd impbid2
      ctopon expcom ) ADEZBFEZBGEZBHUKUMAIJZKBLJEZULUKUNBMZEZUMUONUKUNAOJZUPUKA
      PEUNUREASURAUNURQZUNQZRTUKBURUIJEURUPUAABURCUSUBURBUCTUDUMUQUOUNBUPUPQUEU
      JTABUNUTCUFUGUH $.

    $d a w x y z G $.  $d a w x y z J $.
    $( Hausdorff and T0 are equivalent for topological groups.  (Contributed by
       Mario Carneiro, 18-Sep-2015.) $)
    tgpt0 $p |- ( G e. TopGrp -> ( J e. Haus <-> J e. Kol2 ) ) $=
      ( vx vz vy vw va wcel cv wral weq wi cfv wa eleq2 co wceq ad3antrrr eqid
      ctgp cha ct1 ct0 tgpt1 t1t0 wb cbs imbi12d rspccva adantll csg cplusg c0g
      cgrp tgpgrp simpllr simprd grpsubid syl2anc oveq1d simpld eqtrd cmpt ccnv
      grplid cima ccn ctmd tgptmd ctopon tgptopon cnmptid ctx tgpsubcn cnmpt12f
      cnmptc cnmpt1plusg simprl cnima simplr grpnpcan syl3anc eqeltrd mptpreima
      simprr oveq2 eleq1d elrab2 sylanbrc rspcv syl3c simprbi syl eqeltrrd expr
      impbid ralrimiva ex imim1d anassrs ralimdva ist0-2 ist1-2 3imtr4d impbid2
      bitrd ) AUAIZBUBIBUCIZBUDIZABCUEXHXIXJBUFXHDJZEJZIZFJZXLIZUGZEBKZDFLZMZFA
      UHNZKZDXTKZXKGJZIZXNYCIZMZGBKZXRMZFXTKZDXTKZXJXIXHYAYIDXTXHXKXTIZOXSYHFXT
      XHYKXNXTIZXSYHMXHYKYLOZOZYGXQXRYNYGXQYNYGOZXPEBYOXLBIZOXMXOYGYPXMXOMZYNYF
      YQGXLBGELYDXMYEXOYCXLXKPYCXLXNPUIUJUKYOYPXOXMYOYPXOOZOZXNXNAULNZQZXKAUMNZ
      QZXKXLYSUUCAUNNZXKUUBQZXKYSUUAUUDXKUUBYSAUOIZYLUUAUUDRXHUUFYMYGYRAUPSZYSY
      KYLXHYMYGYRUQZURZXTAYTXNUUDXTTZUUDTZYTTZUSUTVAYSUUFYKUUEXKRUUGYSYKYLUUHVB
      ZXTUUBAXKUUDUUJUUBTZUUKVFUTVCYSXNHXTXNHJZYTQZXKUUBQZVDZVEXLVGZIZUUCXLIZYS
      UUSBIZYGXKUUSIZUUTYSUURBBVHQIYPUVBYSHUUPXKUUBABBXTCUUNXHAVIIYMYGYRAVJSXHB
      XTVKNIZYMYGYRABXTCUUJVLZSZYSHXNUUOYTBBBBXTUVFYSHXNBBXTXTUVFUVFUUIVQYSHBXT
      UVFVMXHYTBBVNQBVHQIYMYGYRABYTCUULVOSVPYSHXKBBXTXTUVFUVFUUMVQVRYOYPXOVSXLU
      URBBVTUTYNYGYRWAYSYKXNXKYTQZXKUUBQZXLIZUVCUUMYSUVHXNXLYSUUFYLYKUVHXNRUUGU
      UIUUMXTUUBAYTXNXKUUJUUNUULWBWCYOYPXOWFWDUUQXLIZUVIHXKXTUUSHDLZUUQUVHXLUVK
      UUPUVGXKUUBUUOXKXNYTWGVAWHHXTUUQXLUURUURTWEZWIWJYFUVCUUTMGUUSBYCUUSRYDUVC
      YEUUTYCUUSXKPYCUUSXNPUIWKWLUUTYLUVAUVJUVAHXNXTUUSHFLZUUQUUCXLUVMUUPUUAXKU
      UBUUOXNXNYTWGVAWHUVLWIWMWNWOWPWQWRWSWTXAXBXBXHUVDXJYBUGUVEDFEBXTXCWNXHUVD
      XIYJUGUVEDFGBXTXDWNXEXFXG $.
  $}

  ${
    $d b t $.  $d a b c d p q r s u w x y z G $.  $d a c d p q t u w x y z J $.
    $d a p q r s u w y z F $.  $d a u x y z S $.  $d a b c d p q u w x y z X $.
    $d a b c d p q r s u w x y z H $.  $d a b c d p q r s u w x y z K $.
    $d c d p q t .- $.  $d a b c d p q r s u w x y z Y $.
    divstgp.h $e |- H = ( G /s ( G ~QG Y ) ) $.
    ${
      divstgpopn.x $e |- X = ( Base ` G ) $.
      divstgpopn.j $e |- J = ( TopOpen ` G ) $.
      divstgpopn.k $e |- K = ( TopOpen ` H ) $.
      divstgpopn.f $e |- F = ( x e. X |-> [ x ] ( G ~QG Y ) ) $.
      $( A quotient map in a topological group is an open map.  (Contributed by
         Mario Carneiro, 18-Sep-2015.) $)
      divstgpopn $p |- ( ( G e. TopGrp /\ Y e. ( NrmSGrp ` G ) /\ S e. J ) ->
        ( F " S ) e. K ) $=
        ( va wcel cfv co wceq syl2anc vy vu vz ctgp cnsg w3a cima cqtop cqg cqs
        wss ccnv crn imassrn wfo cvv cqus a1i cbs ovex divslem forn syl5sseq cv
        simp1 syl wrex wral cec cmpt eceq1 cbvmptv eqtri mptpreima rabeq2i wfun
        wa funmpt2 fvelima mpan cminusg cplusg wbr ctopon tgptopon simp3 adantr
        toponss sselda ecexg ax-mp fvmpt eqeq1d eqcom syl6bb csubg wer 3ad2ant2
        nsgsubg ad2antrr eqid eqger simplr erth subgss eqgval 3bitr2d ccn chmeo
        wb coppg oppgplus mpteq2i oppgtgp oppgtopn tgplacthmeo syl5eqelr hmeocn
        oppgbas ad3antrrr cnima c0g cgrp tgpgrp oveq1d grpinvcl grpass syl13anc
        grprinv grplid 3eqtr3d eqeltrd oveq1 eleq1d elrab2 sylanbrc crab wfn wi
        fnmpti fnfvima 3expia sylancr simpr grpcl syl3anc fvmpt3i grplinv erthi
        mpbir3and eqtr4d sylibd ss2rabdv 3sstr4g eleq2 anbi12d rspcev 3ad2antr3
        syl12anc ex sylbid rexlimdva syl5 expimpd syl5bi ralrimiv ctop topontop
        sseq1 eltop2 3syl mpbird elqtop3 mpbir2and divsval imastopn eleqtrrd )
        DUDPZIDUEQPZBFPZUFZCBUGZFCUHRZGUWAUWBUWCPZUWBHDIUIRZUJZUKZCULUWBUGZFPZU
        WACUMZUWBUWFCBUNUWAHUWFCUOZUWJUWFSUWAAUWEDECHUPUDEDUWEUQRSUWAJURZHDUSQS
        UWAKURZNUWEUPPZUWADIUIUTZURZUVRUVSUVTVEZVAZHUWFCVBVFVCUWAUWIUAVDZUBVDZP
        ZUWTUWHUKZVQZUBFVGZUAUWHVHZUWAUXDUAUWHUWSUWHPUWSHPZUWSUWEVIZUWBPZVQUWAU
        XDUXHUAUWHHUAHUXGUWBCCAHAVDZUWEVIZVJZUAHUXGVJNAUAHUXJUXGUXIUWSUWEVKVLVM
        VNVOUWAUXFUXHUXDUXHUCVDZCQZUXGSZUCBVGZUWAUXFVQZUXDCVPUXHUXOAHUXJCNVRUCU
        XGBCVSVTUXPUXNUXDUCBUXPUXLBPZVQZUXNUXFUXLHPZUWSDWAQZQZUXLDWBQZRZIPZUFZU
        XDUXRUXNUXGUXLUWEVIZSZUWSUXLUWEWCZUYEUXRUXNUYFUXGSUYGUXRUXMUYFUXGUXRUXS
        UXMUYFSUXPBHUXLUWABHUKZUXFUWAFHWDQPZUVTUYIUWAUVRUYJUWQDFHLKWEVFZUVRUVSU
        VTWFZBFHWHTWGZWIZAUXLUXJUYFHCUXIUXLUWEVKNUWNUYFUPPUWOUXLUPUWEWJWKWLVFWM
        UYFUXGWNWOUXRUWSUXLUWEHUXRIDWPQPZHUWEWQZUWAUYOUXFUXQUVSUVRUYOUVTIDWSWRW
        TZUWEDHIKUWEXAZXBVFZUWAUXFUXQXCZXDUXRUVRIHUKZUYHUYEXJUWAUVRUXFUXQUWQWTZ
        UXRUYOVUAUYQHIDKXEVFZUWSUXLUYBUWEIDUXTUDHKUXTXAZUYBXAZUYRXFTXGUXRUYEUXD
        UXRUXFUYDUXDUXSUXRUYDVQZOHOVDZUYCUYBRZVJZULBUGZFPZUWSVUJPZVUJUWHUKZUXDV
        UFVUIFFXHRPZUVTVUKVUFVUIFFXIRZPVUNVUFVUIOHUYCVUGDXKQZWBQZRZVJZVUOOHVURV
        UHUYBVUQDVUPUYCVUGVUEVUPXAZVUQXAZXLXMVUFVUPUDPZUYCHPZVUSVUOPVUFUVRVVBUX
        RUVRUYDVUBWGZDVUPVUTXNVFUXRIHUYCVUCWIZOUYCVUQVUSVUPFHVUSXAHDVUPVUTKXSVV
        ADFVUPVUTLXOXPTXQVUIFFXRVFUWAUVTUXFUXQUYDUYLXTBVUIFFYATVUFUXFUWSUYCUYBR
        ZBPZVULUXRUXFUYDUYTWGZVUFVVFUXLBVUFUWSUYAUYBRZUXLUYBRZDYBQZUXLUYBRZVVFU
        XLVUFVVIVVKUXLUYBVUFDYCPZUXFVVIVVKSVUFUVRVVMVVDDYDVFZVVHHUYBDUXTUWSVVKK
        VUEVVKXAZVUDYITYEVUFVVMUXFUYAHPZUXSVVJVVFSVVNVVHVUFVVMUXFVVPVVNVVHHDUXT
        UWSKVUDYFTUXRUXSUYDUYNWGZHUYBDUWSUYAUXLKVUEYGYHVUFVVMUXSVVLUXLSVVNVVQHU
        YBDUXLVVKKVUEVVOYJTYKUXPUXQUYDXCYLVUHBPZVVGOUWSHVUJVUGUWSSVUHVVFBVUGUWS
        UYCUYBYMYNOHVUHBVUIVUIXAVNZYOYPVUFVVROHYQVUGUWEVIZUWBPZOHYQVUJUWHVUFVVR
        VWAOHVUFVUGHPZVQZVVRVUHCQZUWBPZVWAVWCCHYRZUYIVVRVWEYSAHUXJCUWNUXJUPPUWO
        UXIUPUWEWJWKZNYTUXPUYIUXQUYDVWBUYMXTVWFUYIVVRVWEHBCVUHUUAUUBUUCVWCVWDVV
        TUWBVWCVWDVUHUWEVIZVVTVWCVUHHPZVWDVWHSVWCVVMVWBVVCVWIVUFVVMVWBVVNWGZVUF
        VWBUUDZVUFVVCVWBVVEWGZHUYBDVUGUYCKVUEUUEUUFZAVUHUXJVWHHCUXIVUHUWEVKNVWG
        UUGVFVWCVUGVUHUWEHUXRUYPUYDVWBUYSWTVWCVUGVUHUWEWCZVWBVWIVUGUXTQZVUHUYBR
        ZIPZVWKVWMVWCVWPUYCIVWCVWOVUGUYBRZUYCUYBRZVVKUYCUYBRZVWPUYCVWCVWRVVKUYC
        UYBVWCVVMVWBVWRVVKSVWJVWKHUYBDUXTVUGVVKKVUEVVOVUDUUHTYEVWCVVMVWOHPZVWBV
        VCVWSVWPSVWJVWCVVMVWBVXAVWJVWKHDUXTVUGKVUDYFTVWKVWLHUYBDVWOVUGUYCKVUEYG
        YHVWCVVMVVCVWTUYCSVWJVWLHUYBDUYCVVKKVUEVVOYJTYKUXRUYDVWBXCYLVWCVVMVUAVW
        NVWBVWIVWQUFXJVWJUXRVUAUYDVWBVUCWTVUGVUHUYBUWEIDUXTYCHKVUDVUEUYRXFTUUJU
        UIUUKYNUULUUMVVSOHVVTUWBCCUXKOHVVTVJNAOHUXJVVTUXIVUGUWEVKVLVMVNUUNUXCVU
        LVUMVQUBVUJFUWTVUJSUXAVULUXBVUMUWTVUJUWSUUOUWTVUJUWHUVIUUPUUQUUSUURUUTU
        VAUVBUVCUVDUVEUVFUWAUYJFUVGPUWIUXEXJUYKHFUVHUAUBUWHFUVJUVKUVLUWAUYJUWKU
        WDUWGUWIVQXJUYKUWRUWBCFHUWFUVMTUVNUWAUWFDECFGHUDUWAAUWEDECHUPUDUWLUWMNU
        WPUWQUVOUWMUWRUWQLMUVPUVQ $.

      divstgplem.m $e |- .- =
        ( z e. X , w e. X |-> [ ( z ( -g ` G ) w ) ] ( G ~QG Y ) ) $.
      $( Lemma for ~ divstgp .  (Contributed by Mario Carneiro,
         18-Sep-2015.) $)
      divstgplem $p |- ( ( G e. TopGrp /\ Y e. ( NrmSGrp ` G ) ) ->
        H e. TopGrp ) $=
        ( wcel wa wceq vu vr vs vy va vb vc vd vt vp vq ctgp cnsg cfv cgrp ctps
        csg ctx ccn divsgrp adantl cbs ctopon cqg cqs cqtop cvv cqus ovex simpl
        co a1i adantr syl2anc eqeltrd eqid sylibr cxp wf ccnv cima wral grpsubf
        cv syl wss wrex wrel cop cec vex elqs eleq2d syl5bbr anbi12d opelxp wfn
        wi wb ad2antrr elpreima 3syl df-ov divssub syl3anc syl5eqr eleq1d cmpt2
        ffn sylib eqeltrrd ecexg ax-mp eceq1 oveq12 ovmpt2a eleq1 syl6bb anbi1d
        weq 2rexbidv divstgpopn fvmpt3i toponss fnfvima mp3an1 sselda anim12dan
        eltx opelxpi opeq12 divseccl mpbir2and ralbidv ralima mpbird rexlimdvva
        mpan sseq1d sylbid divsval divslem imastopn wfo tgptopon divsbas fveq2d
        qtoptopon eleqtrd istps cab cdm cnvimass fdm syl5sseq relxp relss sseld
        ee10 reeanv 3bitr4g simpllr simprl simprr simpr tgpgrp fnov cmpt fnmpti
        tgpsubcn qtopid sylancl oveq2d eleqtrrd syl5eqelr syl5eqel simplr cnima
        cnmpt21 mpbid fnmpt2i anbi1i pm5.32i 3bitri rspccv syl5bir mpand simpld
        simp-4l simprll simprlr simprrl simprd syl2an eqtr4d 3eqtr3g ralrimivva
        3expb simprrr sylan2 opeq1 opeq2 sylan9bb dfss3 ralxp bitri xpeq1 xpeq2
        simprbi rspc2ev syl112anc expr adantld imbi12d syl5ibrcom sylbird com23
        syld opex elab mpdd relssdv ssabral ralrimiva txtopon istgp2 syl3anbrc
        iscn ) EULRZKEUMUNRZSZFUORZFUPRZFUQUNZHHURVKZHUSVKRZFULRUYJUYLUYIKEFLUT
        VAZUYKHFVBUNZVCUNZRZUYMUYKHJEKVDVKZVEZVCUNZUYSUYKHGDVFVKZVUCUYKVUBEFDGH
        JULUYKAVUAEFDJVGULFEVUAVHVKTUYKLVLZJEVBUNTUYKMVLZPVUAVGRZUYKEKVDVIZVLZU
        YIUYJVJZUUAVUFUYKAVUAEFDJVGULVUEVUFPVUIVUJUUBZVUJNOUUCZUYKGJVCUNZRZJVUB
        DUUDVUDVUCRUYIVUNUYJEGJNMUUEZVMZVUKDGJVUBUUHVNVOUYKVUBUYRVCUYKVUAEFJVGU
        LVUEVUFVUIVUJUUFZUUGUUIZUYRHFUYRVPZOUUJVQUYKUYPUYRUYRVRZUYRUYNVSZUYNVTU
        AWDZWAZUYORZUAHWBZUYKUYLVVAUYQUYRFUYNVUSUYNVPZWCZWEZUYKVVDUAHUYKVVBHRZS
        ZVVDCWDZUBWDZUCWDZVRZRZVVNVVCWFZSZUCHWGUBHWGZCVVCWBZVVJVVCVVRCUUKZWFVVS
        VVJAUDVVCVVTVVJVVCVUTWFVUTWHVVCWHVVJUYNUULZVVCVUTUYNVVBUUMUYKVWAVUTTZVV
        IUYKVVAVWBVVHVUTUYRUYNUUNWEVMUUOZUYRUYRUUPVVCVUTUUQUUSVVJAWDZUDWDZWIZVV
        CRZVWFVUTRZVWFVVTRZVVJVVCVUTVWFVWCUURVVJVWHVWGVWIVVJVWHVWDUEWDZVUAWJZTZ
        VWEUFWDZVUAWJZTZSZUFJWGUEJWGZVWGVWIWRZVVJVWLUEJWGZVWOUFJWGZSVWDUYRRZVWE
        UYRRZSVWQVWHVVJVWSVXAVWTVXBVWSVWDVUBRVVJVXAUEJVWDVUAAWKWLVVJVUBUYRVWDUY
        KVUBUYRTVVIVUQVMZWMWNVWTVWEVUBRVVJVXBUFJVWEVUAUDWKWLVVJVUBUYRVWEVXCWMWN
        WOVWLVWOUEUFJJUUTVWDVWEUYRUYRWPUVAVVJVWPVWRUEUFJJVVJVWJJRZVWMJRZSZSZVWR
        VWPVWKVWNWIZVVCRZVXHVVNRZVVPSZUCHWGUBHWGZWRVXGVXIVXHVUTRZVXHUYNUNZVVBRZ
        SZVXLVXGVVAUYNVUTWQZVXIVXPWSVXGUYLVVAUYKUYLVVIVXFUYQWTVVGWEZVUTUYRUYNXI
        ZVUTVXHVVBUYNXAXBVXGVXOVXLVXMVXGVXOVWJVWMEUQUNZVKZVUAWJZVVBRZVXLVXGVXNV
        YBVVBVXGVXNVWKVWNUYNVKZVYBVWKVWNUYNXCVXGUYJVXDVXEVYDVYBTUYIUYJVVIVXFUVB
        ZVVJVXDVXEUVCZVVJVXDVXEUVDZKEFVXTUYNJVWJVWMLMVXTVPZVVFXDXEXFXGVXGVYCVWJ
        UGWDZRZVWMUHWDZRZSZVYIVYKVRZIVTVVBWAZWFZSZUHGWGUGGWGZVXLVXGVXFVYCVYRVVJ
        VXFUVEVXGUIWDZVYNRZVYPSZUHGWGUGGWGZUIVYOWBZVXFVYCSZVYRWRVXGVYOGGURVKZRZ
        WUCVXGIWUEHUSVKZRZVVIWUFUYKWUHVVIVXFUYKIBCJJBWDZVVKVXTVKZVUAWJZXHWUGQUY
        KBCAWUJVWDVUAWJZWUKGGGHJJJVUPVUPUYKVXTBCJJWUJXHZWUEGUSVKZUYKVXTJJVRZWQZ
        VXTWUMTUYKEUORZWUOJVXTVSWUPUYIWUQUYJEUVFVMJEVXTMVYHWCWUOJVXTXIXBBCJJVXT
        UVGXJUYIVXTWUNRUYJEGVXTNVYHUVJVMXKVUPUYKAJWULUVHDGHUSVKZPUYKDGVUDUSVKZW
        URUYKVUNDJWQZDWUSRVUPAJWULDVUGWULVGRVUHVWDVGVUAXLXMZPUVIZDGJUVKUVLUYKHV
        UDGUSVULUVMUVNUVOVWDWUJVUAXNUVSUVPWTUYKVVIVXFUVQVVBIWUEHUVRVNVXGVUNVUNW
        UFWUCWSUYKVUNVVIVXFVUPWTZWVCUGUHVYOGGVUMVUMUIYIVNUVTWUDVWJVWMWIZVYORZWU
        CVYRWVEWVDWUORZWVDIUNZVVBRZSZVXFWVHSWUDIWUOWQZWVEWVIWSBCJJWUKIQVUGWUKVG
        RVUHWUJVGVUAXLXMUWAZWUOWVDVVBIXAXMWVFVXFWVHVWJVWMJJWPUWBVXFWVHVYCVXFWVG
        VYBVVBVXFWVGVWJVWMIVKVYBVWJVWMIXCBCVWJVWMJJWUKVYBIBUEXTCUFXTSWUJVYATWUK
        VYBTWUIVWJVVKVWMVXTXOWUJVYAVUAXNWEQVUGVYBVGRVUHVYAVGVUAXLXMXPXFXGUWCUWD
        WUBVYRUIWVDVYOVYSWVDTZWUAVYQUGUHGGWVLVYTVYMVYPWVLVYTWVDVYNRVYMVYSWVDVYN
        XQVWJVWMVYIVYKWPXRXSYAUWEUWFWEUWGVXGVYQVXLUGUHGGVXGVYIGRZVYKGRZSZVYQVXL
        VXGWVOVYQSZSZDVYIWAZHRZDVYKWAZHRZVXHWVRWVTVRZRZWWBVVCWFZVXLWVQUYIUYJWVM
        WVSUYIUYJVVIVXFWVPUWIZVXGUYJWVPVYEVMZVXGWVMWVNVYQUWJZAVYIDEFGHJKLMNOPYB
        XEWVQUYIUYJWVNWWAWWEWWFVXGWVMWVNVYQUWKZAVYKDEFGHJKLMNOPYBXEWVQVWKWVRRVW
        NWVTRWWCWVQVWJDUNZVWKWVRWVQVXDWWIVWKTVXGVXDWVPVYFVMAVWJWULVWKJDVWDVWJVU
        AXNPWVAYCWEWVQVYIJWFZVYJWWIWVRRZWVQVUNWVMWWJWVQUYIVUNWWEVUOWEZWWGVYIGJY
        DVNZWVQVYJVYLVXGWVOVYMVYPUWLZUWHWUTWWJVYJWWKWVBJVYIDVWJYEYFVNXKWVQVWMDU
        NZVWNWVTWVQVXEWWOVWNTVXGVXEWVPVYGVMAVWMWULVWNJDVWDVWMVUAXNPWVAYCWEWVQVY
        KJWFZVYLWWOWVTRZWVQVUNWVNWWPWWLWWHVYKGJYDVNZWVQVYJVYLWWNUWMWUTWWPVYLWWQ
        WVBJVYKDVWMYEYFVNXKVWKVWNWVRWVTYJVNWVQWUIVVKWIZVVCRZCWVTWBZBWVRWBZWWDWV
        QWXBUJWDZDUNZUKWDZDUNZWIZVVCRZUKVYKWBZUJVYIWBZWVQWXHUJUKVYIVYKWVQWXCVYI
        RZWXEVYKRZSZSZWXGWXCVUAWJZWXEVUAWJZWIZVVCWXNWXCJRZWXEJRZSZWXGWXQTZWVQWX
        KWXRWXLWXSWVQVYIJWXCWWMYGWVQVYKJWXEWWRYGYHZWXRWXDWXOTWXFWXPTWYAWXSAWXCW
        ULWXOJDVWDWXCVUAXNPWVAYCAWXEWULWXPJDVWDWXEVUAXNPWVAYCWXDWXFWXOWXPYKUWNW
        EWXNWXQVVCRZWXQVUTRZWXQUYNUNZVVBRZWXNWXOUYRRZWXPUYRRZSZWYDWXNUYJWXTWYIW
        VQUYJWXMWWFVMZWYBUYJWXRWYGWXSWYHUYRKEFJWXCLMVUSYLUYRKEFJWXELMVUSYLYHVNW
        XOWXPUYRUYRYJWEWXNWYEWXCWXEWIZIUNZVVBWXNWXOWXPUYNVKZWXCWXEIVKZWYEWYLWXN
        WYMWXCWXEVXTVKZVUAWJZWYNWXNUYJWXTWYMWYPTZWYJWYBUYJWXRWXSWYQKEFVXTUYNJWX
        CWXELMVYHVVFXDUWRVNWXNWXTWYNWYPTWYBBCWXCWXEJJWUKWYPIBUJXTCUKXTSWUJWYOTW
        UKWYPTWUIWXCVVKWXEVXTXOWUJWYOVUAXNWEQVUGWYPVGRVUHWYOVGVUAXLXMXPWEUWOWXO
        WXPUYNXCWXCWXEIXCUWPWXNWYKVYORZWYLVVBRZWXMWVQWYKVYNRWYRWXCWXEVYIVYKYJWV
        QVYNVYOWYKVXGWVOVYMVYPUWSYGUWTWYRWYKWUORZWYSWVJWYRWYTWYSSWSWVKWUOWYKVVB
        IXAXMUXIWEVOWXNVXQWYCWYDWYFSWSVXGVXQWVPWXMVXGVVAVXQVXRVXSWEWTVUTWXQVVBU
        YNXAWEYMVOUWQWVQWWJWWPWXBWXJWSWWMWWRWWJWXBWXDVVKWIZVVCRZCWVTWBZUJVYIWBZ
        WWPWXJWUTWWJWXBXUDWSWVBWXAXUCBUJJVYIDWUIWXDTZWWTXUBCWVTXUEWWSXUAVVCWUIW
        XDVVKUXAXGYNYOYRWWPXUCWXIUJVYIWUTWWPXUCWXIWSWVBXUBWXHCUKJVYKDVVKWXFTXUA
        WXGVVCVVKWXFWXDUXBXGYOYRYNUXCVNYPWWDVWEVVCRZUDWWBWBWXBUDWWBVVCUXDXUFWWT
        UDBCWVRWVTVWEWWSVVCXQUXEUXFVQVXKWWCWWDSVXHWVRVVMVRZRZXUGVVCWFZSUBUCWVRW
        VTHHVVLWVRTZVXJXUHVVPXUIXUJVVNXUGVXHVVLWVRVVMUXGZWMXUJVVNXUGVVCXUKYSWOV
        VMWVTTZXUHWWCXUIWWDXULXUGWWBVXHVVMWVTWVRUXHZWMXULXUGWWBVVCXUMYSWOUXJUXK
        UXLYQUXRYTUXMYTVWPVWGVXIVWIVXLVWPVWFVXHVVCVWDVWEVWKVWNYKZXGVWPVWIVXHVVT
        RVXLVWPVWFVXHVVTXUNXGVVRVXLCVXHVWKVWNUXSVVKVXHTZVVQVXKUBUCHHXUOVVOVXJVV
        PVVKVXHVVNXQXSYAUXTXRUXNUXOYQUXPUXQUYAUYBVVRCVVCUYCXJUYKVVDVVSWSZVVIUYK
        UYTUYTXUPVURVURUBUCVVCHHUYSUYSCYIVNVMYPUYDUYKUYOVUTVCUNRZUYTUYPVVAVVESW
        SUYKUYTUYTXUQVURVURHHUYRUYRUYEVNVURUAUYNUYOHVUTUYRUYHVNYMFHUYNOVVFUYFUY
        G $.
    $}

    $( The quotient of a topological group is a topological group.
       (Contributed by Mario Carneiro, 17-Sep-2015.) $)
    divstgp $p |- ( ( G e. TopGrp /\ Y e. ( NrmSGrp ` G ) ) -> H e. TopGrp ) $=
      ( vx vz vw cbs cfv cv cqg co cec cmpt ctopn csg cmpt2 eqid divstgplem ) E
      FGEAHIZEJACKLZMNZABAOIZBOIZFGTTFJGJAPILUAMQZTCDTRUCRUDRUBRUERS $.

    divstgphaus.j $e |- J = ( TopOpen ` G ) $.
    divstgphaus.k $e |- K = ( TopOpen ` H ) $.
    $( The quotient of a topological group by a closed normal subgroup is a
       Hausdorff topological group.  In particular, the quotient by the closure
       of the identity is a Hausdorff group, isomorphic to both the Kolmogorov
       quotient and the Hausdorff quotient operations on topological spaces
       (because T0 and Hausdorff coincide for topological groups).
       (Contributed by Mario Carneiro, 22-Sep-2015.) $)
    divstgphaus $p |- ( ( G e. TopGrp /\ Y e. ( NrmSGrp ` G ) /\
        Y e. ( Clsd ` J ) ) -> K e. Haus ) $=
      ( vx ctgp wcel cfv ccld c0g co wss wceq eqid syl wb cnsg w3a cha csn cmpt
      cbs cv cqg cec cqtop cqs ccnv cima divs0 3ad2ant2 tgpgrp 3ad2ant1 grpidcl
      cgrp ovex ecelqsi eqeltrrd snssd mptpreima cin csubg nsgsubg eqgid subgss
      crab eqsstrd dfss1 sylib wbr wer eqger erth adantr eqeq1d bitrd fvex elec
      wa vex elsnc2 eqcom bitri 3bitr4g rabbi2dva 3eqtr3d syl5eq eqeltrd ctopon
      simp3 wfo tgptopon cvv cqus eqidd simp1 divslem qtopcld syl2anc mpbir2and
      a1i divsval imastopn fveq2d eleqtrrd divstgp 3adant3 tgphaus mpbird ) AJK
      ZEAUALKZECMLZKZUBZDUCKZBNLZUDZDMLZKZXRYACIAUFLZIUGZAEUHOZUIZUEZUJOZMLZYBX
      RYAYJKZYAYDYFUKZPZYHULYAUMZXPKZXRXTYLXRANLZYFUIZXTYLXOXNYQXTQZXQEABYPFYPR
      ZUNUOZXRYPYDKZYQYLKXRAUSKZUUAXNXOUUBXQAUPUQYDAYPYDRZYSURSZYDYPYFAEUHUTZVA
      SVBVCXRYNEXPXRYNYGYAKZIYDVJZEIYDYGYAYHYHRZVDXRYDYQVEZYQUUGEXRYQYDPUUIYQQX
      RYQEYDXREAVFLKZYQEQXOXNUUJXQEAVGUOZYFAYDEYPUUCYFRZYSVHSZXRUUJEYDPUUKYDEAU
      UCVISVKYQYDVLVMXRUUFIYDYQXRYEYDKZWCZYPYEYFVNZXTYGQZYEYQKUUFUUOUUPYQYGQZUU
      QXRUUPUURTUUNXRYPYEYFYDXRUUJYDYFVOUUKYFAYDEUUCUULVPSUUDVQVRUUOYQXTYGXRYRU
      UNYTVRVSVTYEYPYFIWDANWAWBUUFYGXTQUUQYGXTBNWAWEYGXTWFWGWHWIUUMWJWKXNXOXQWN
      WLXRCYDWMLKZYDYLYHWOYKYMYOWCTXNXOUUSXQACYDGUUCWPUQXRIYFABYHYDWQJBAYFWROQX
      RFXEZXRYDWSZUUHYFWQKXRUUEXEZXNXOXQWTZXAZYAYHCYDYLXBXCXDXRDYIMXRYLABYHCDYD
      JXRIYFABYHYDWQJUUTUVAUUHUVBUVCXFUVAUVDUVCGHXGXHXIXRBJKZXSYCTXNXOUVEXQABEF
      XJXKBDXTXTRHXLSXM $.
  $}

  ${
    $d f g k x z I $.  $d f g k x z ph $.  $d f g k x z R $.  $d f g k x z Y $.
    $d k S $.  $d k V $.  $d k x z W $.
    prdstmdd.y $e |- Y = ( S Xs_ R ) $.
    prdstmdd.i $e |- ( ph -> I e. W ) $.
    prdstmdd.s $e |- ( ph -> S e. V ) $.
    prdstmdd.r $e |- ( ph -> R : I --> TopMnd ) $.
    $( The product of a family of topological monoids is a topological monoid.
       (Contributed by Mario Carneiro, 22-Sep-2015.) $)
    prdstmdd $p |- ( ph -> Y e. TopMnd ) $=
      ( vx vf vg wcel ctps cfv ctopn co ctmd vz vk cplusf ctx ccn wf wss tmdmnd
      cmnd ssriv fss sylancl prdsmndd tmdtps prdstps ccom cpt cbs cxp c1st c2nd
      cv cplusg cmpt cmpt2 w3a eqid 3ad2ant1 wfn ffn syl simp2 simp3 mpt2eq3dva
      prdsplusgval plusffval cop wceq vex op1std fveq1d op2ndd oveq12d mpteq2dv
      mpt2mpt 3eqtr4g ctopon istps sylib txtopon syl2anc ctop cres wral cvv ssv
      topnfn fnssres mp2an fvres tpstop eqeltrd rgen mpbir2an sylancr ffvelrnda
      ffnfv fco2 adantr cnmpt1st cuni prdstopn eqeltrrd toponuni mpteq1d ptpjcn
      wa simpr syl3anc eqcomd fvco3 sylan eleqtrd fveq1 cnmpt21 cnmpt2nd oveq2d
      cnmpt2plusg eleqtrrd syl5eqel ptcn istmd syl3anbrc ) AGUIOGPOZGUCQZGRQZYP
      UDSZYPUESZOGTOABCDEFGHIJADTBUFZTUIUGDUIBUFKLTUILVBZUHUJDTUIBUKULUMABCDEFG
      HJIAYSTPUGDPBUFZKLTPYTUNUJDTPBUKULZUOZAYOYQRBUPZUQQZUESZYRAYOUAGURQZUUGUS
      ZUBDUBVBZUAVBZUTQZQZUUIUUJVAQZQZUUIBQZVCQZSZVDZVDZUUFAMNUUGUUGMVBZNVBZGVC
      QZSZVEMNUUGUUGUBDUUIUUTQZUUIUVAQZUUPSZVDZVEYOUUSAMNUUGUUGUVCUVGAUUTUUGOZU
      VAUUGOZVFUBUUGUVBBCUUTUVADEFGHUUGVGZAUVHCEOUVIJVHAUVHDFOZUVIIVHAUVHBDVIZU
      VIAYSUVLKDTBVJVKZVHAUVHUVIVLAUVHUVIVMUVBVGZVOVNMNUUGUVBYOGUVJUVNYOVGZVPMN
      UAUUGUUGUURUVGUUJUUTUVAVQVRZUBDUUQUVFUVPUULUVDUUNUVEUUPUVPUUIUUKUUTUUTUVA
      UUJMVSZNVSZVTWAUVPUUIUUMUVAUUTUVAUUJUVQUVRWBWAWCZWDWEWFAUAUUQUBUUDDYQUUEF
      UUHUUEVGZAYPUUGWGQZOZUWBYQUUHWGQOAYNUWBUUCUUGYPGUVJYPVGZWHWIZUWDYPYPUUGUU
      GWJWKIAPWLRPWMZUFZUUADWLUUDUFZUWFUWEPVIZYTUWEQZWLOZLPWNRWOVIPWOUGUWHWQPWP
      WOPRWRWSUWJLPYTPOUWIYTRQZWLYTPRWTUWKYTUWKVGXAXBXCLPWLUWEXGXDUUBDPWLRBXHXE
      ZAUUIDOZXQZUAUUHUUQVDMNUUGUUGUVFVEZYQUUIUUDQZUESZMNUAUUGUUGUUQUVFUVSWEUWN
      UWOYQUUORQZUESUWQUWNMNUVDUVEUUPUUOUWRYPYPUUGUUGUWRVGUUPVGADTUUIBKXFAUWBUW
      MUWDXIZUWSUWNMNLUUTUUIYTQZUVDYPYPYPUWRUUGUUGUUGUWSUWSUWNMNYPYPUUGUUGUWSUW
      SXJUWSUWNLUUGUWTVDZUUEUWPUESZYPUWRUESUWNUXALUUEXKZUWTVDZUXBUWNLUUGUXCUWTU
      WNUUEUWAOUUGUXCVRUWNYPUUEUWAAYPUUEVRUWMABCDYPEFGHJIUVMUWCXLZXIZUWSXMUUGUU
      EXNVKXOUWNUVKUWGUWMUXDUXBOAUVKUWMIXIAUWGUWMUWLXIAUWMXRLDUUDUUIUUEFUXCUXCV
      GUVTXPXSXBUWNUUEYPUWPUWRUEUWNYPUUEUXFXTAYSUWMUWPUWRVRKDTUUIRBYAYBZWCYCZUU
      IYTUUTYDYEUWNMNLUVAUWTUVEYPYPYPUWRUUGUUGUUGUWSUWSUWNMNYPYPUUGUUGUWSUWSYFU
      WSUXHUUIYTUVAYDYEYHUWNUWPUWRYQUEUXGYGYIYJYKXBAYPUUEYQUEUXEYGYIYOGYPUVOUWC
      YLYM $.
  $}

  ${
    $d x y I $.  $d x y ph $.  $d x y R $.  $d y S $.  $d x y W $.  $d x y Y $.
    prdstgpd.y $e |- Y = ( S Xs_ R ) $.
    prdstgpd.i $e |- ( ph -> I e. W ) $.
    prdstgpd.s $e |- ( ph -> S e. V ) $.
    prdstgpd.r $e |- ( ph -> R : I --> TopGrp ) $.
    $( The product of a family of topological groups is a topological group.
       (Contributed by Mario Carneiro, 22-Sep-2015.) $)
    prdstgpd $p |- ( ph -> Y e. TopGrp ) $=
      ( vx vy wcel cfv ctopn ccn ctgp eqid adantr cgrp cminusg co wf wss tgpgrp
      ctmd ssriv fss sylancl prdsgrpd tgptmd prdstmdd ccom cpt cbs cmpt grpinvf
      cv syl feqmptd wa simpr prdsinvgd mpteq2dva ctopon tmdtopon wfn ctop wral
      eqtrd cvv topnfn ffn dffn2 sylib fnfco sylancr wceq fvco3 sylan ffvelrnda
      tgptopon topontop 3syl eqeltrd ralrimiva ffnfv sylanbrc prdstopn toponuni
      cuni eqcomd mpteq1 ptpjcn syl3anc oveq12d tgpinv cnmpt11f oveq2d eleqtrrd
      eleqtrd ptcn istgp syl3anbrc ) AGUANZGUGNZGUBOZGPOZXIQUCZNGRNABCDEFGHIJAD
      RBUDZRUAUEDUABUDZKLRUALUSZUFUHDRUABUIUJZUKZABCDEFGHIJAXKRUGUEDUGBUDKLRUGX
      MULUHDRUGBUIUJUMZAXHXIPBUNZUOOZQUCZXJAXHLGUPOZMDMUSZXMOZYABOZUBOZOZUQZUQZ
      XSAXHLXTXMXHOZUQYGALXTXTXHAXFXTXTXHUDXOXTGXHXTSZXHSZURUTVAALXTYHYFAXMXTNZ
      VBMXTBCDXHEFXMGHADFNZYKITACENYKJTAXLYKXNTYIYJAYKVCVDVEVKALYEMXQDXIXRFXTXR
      SZAXGXIXTVFOZNZXPGXIXTXISZYIVGUTZIAXQDVHZYAXQOZVINZMDVJDVIXQUDZAPVLVHDVLB
      UDZYRVMABDVHZUUBAXKUUCKDRBVNUTZDBVOVPVLDPBVQVRAYTMDAYADNZVBZYSYCPOZVIAXKU
      UEYSUUGVSKDRYAPBVTWAZUUFYCRNZUUGYCUPOZVFONUUGVINADRYABKWBZYCUUGUUJUUGSZUU
      JSWCUUJUUGWDWEWFWGMDVIXQWHWIZUUFLXTYEUQXIUUGQUCZXIYSQUCUUFLYBYDXIUUGUUGXT
      AYOUUEYQTZUUFLXTYBUQZXRYSQUCZUUNUUFUUPLXRWLZYBUQZUUQUUFXRYNNXTUURVSUUPUUS
      VSUUFXRXIYNUUFXIXRAXIXRVSUUEABCDXIEFGHJIUUDYPWJZTWMZUUOWFXTXRWKLXTUURYBWN
      WEUUFYLUUAUUEUUSUUQNAYLUUEITAUUAUUEUUMTAUUEVCLDXQYAXRFUURUURSYMWOWPWFUUFX
      RXIYSUUGQUVAUUHWQXBUUFUUIYDUUGUUGQUCNUUKYCYDUUGUULYDSWRUTWSUUFYSUUGXIQUUH
      WTXAXCWFAXIXRXIQUUTWTXAGXHXIYPYJXDXE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Infinite group sum on topological groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c tsums $.

  $( Extend class notation to include infinite group sums in a topological
     group. $)
  ctsu $a class tsums $.

  ${
    $d f s w y z $.
    $( Define the set of limit points of an infinite group sum for the
       topological group ` G ` .  If ` G ` is Hausdorff, then there will be at
       most one element in this set and ` U. ( W tsums F ) ` selects this
       unique element if it exists. ` ( W tsums F ) ~~ 1o ` is a way to say
       that the sum exists and is unique.  Note that unlike ` sum_ `
       ( ~ df-sum ) and ` gsum ` ( ~ df-gsum ), this does not return the sum
       itself, but rather the set of all such sums, which is usually either
       empty or a singleton.  (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    df-tsms $a |- tsums = ( w e. _V , f e. _V |->
      [_ ( ~P dom f i^i Fin ) / s ]_ ( ( ( TopOpen ` w ) fLimf ( s filGen
          ran ( z e. s |-> { y e. s | z C_ y } ) ) ) `
        ( y e. s |-> ( w gsum ( f |` y ) ) ) ) ) $.
  $}

  ${
    $d a u v z A $.  $d a b u v F $.  $d a b u v y z S $.
    tsmsfbas.s $e |- S = ( ~P A i^i Fin ) $.
    tsmsfbas.f $e |- F = ( z e. S |-> { y e. S | z C_ y } ) $.
    tsmsfbas.l $e |- L = ran F $.
    tsmsfbas.a $e |- ( ph -> A e. W ) $.
    $( The collection of all sets of the form
       ` F ( z ) = { y e. S | z C_ y } ` , which can be read as the set of all
       finite subsets of ` A ` which contain ` z ` as a subset, for each finite
       subset ` z ` of ` A ` , form a filter base.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    tsmsfbas $p |- ( ph -> L e. ( fBas ` S ) ) $=
      ( va vv wcel cvv wss c0 wral syl vb vu cfbas cfv elex crn cpw wne wnel cv
      cin wf crab wa ssrab2 wb pwexg inex1g syl5eqel adantr elpw2g mpbiri fmptd
      w3a cfn frn wceq wrex 0ss 0fin elfpw mpbir2an eleqtrri rgenw rabid2 sseq1
      ralbidv syl5bb rspcev mp2an elrnmpt ne0i wn simpr ssid sseq2 rabn0 sylibr
      sylancl necomd neneqd nrexdv 0ex ax-mp sylnibr df-nel cun simplbi anim12i
      eleq2s unss sylib simprbi syl2an sylanbrc adantl syl6eleqr rabbidv eqeq2d
      unfi eqidd syl2anc rabexg cmpt weq cbvmptv eqtri mpbird inelcm ralrimivva
      pwidg ralrimivw ineq1 inrab a1i syl6eq pweqd ineq2d neeq1d ralrnmpt ineq2
      rabbiia 3jca isfbas mpbir2and 3syl ) ADHODPOZGEUCUDZOLDHUEYQGFUFZYRKYQYSY
      ROZYSEUGZQZYSRUHZRYSUIZYSMUJZUAUJZUKZUGZUKZRUHZUAYSSZMYSSZVDZYQEUUAFULUUB
      YQCECUJZBUJZQZBEUMZUUAFYQUUNEOZUNZUUQUUAOZUUQEQZUUPBEUOUUSEPOZUUTUVAUPYQU
      VBUURYQEDUGZVEUKZPIYQUVCPOUVDPODPUQUVCVEPURTUSZUTUUQEPVATVBJVCEUUAFVFTYQU
      UCUUDUULYQEYSOZUUCYQUVFEUUQVGZCEVHZREORUUOQZBESZUVHRUVDERUVDORDQRVEODVIVJ
      RDVKVLIVMUVIBEUUOVIVNUVGUVJCREUVGUUPBESUUNRVGZUVJUUPBEVOUVKUUPUVIBEUUNRUU
      OVPVQVRVSVTYQUVBUVFUVHUPUVECEUUQEFPJWATVBYSEWBTYQRYSOZWCUUDYQRUUQVGZCEVHZ
      UVLYQUVMCEUUSRUUQUUSUUQRUUSUUPBEVHZUUQRUHUUSUURUUNUUNQZUVOYQUURWDUUNWEUUP
      UVPBUUNEUUOUUNUUNWFVSWIUUPBEWGWHWJWKWLRPOUVLUVNUPWMCEUUQRFPJWAWNWORYSWPWH
      YQUULYSUUENUJZUUOQZBEUMZUKZUGZUKZRUHZNESZMYSSZYQUWEYSUBUJZUVQWQZUUOQZBEUM
      ZUGZUKZRUHZNESZUBESZYQUWLUBNEEYQUWFEOZUVQEOZUNZUNZUWIYSOZUWIUWJOZUWLUWRUW
      SUWIUUEUUOQZBEUMZVGZMEVHZUWRUWGEOUWIUWIVGZUXDUWRUWGUVDEUWQUWGUVDOZYQUWQUW
      GDQZUWGVEOZUXFUWQUWFDQZUVQDQZUNUXGUWOUXIUWPUXJUXIUWFUVDEUWFUVDOZUXIUWFVEO
      ZUWFDVKZWRIWTUXJUVQUVDEUVQUVDOZUXJUVQVEOZUVQDVKZWRIWTWSUWFUVQDXAXBUWOUXLU
      XOUXHUWPUXLUWFUVDEUXKUXIUXLUXMXCIWTUXOUVQUVDEUXNUXJUXOUXPXCIWTUWFUVQXJXDU
      WGDVKXEXFIXGUWRUWIXKUXCUXEMUWGEUUEUWGVGZUXBUWIUWIUXQUXAUWHBEUUEUWGUUOVPXH
      XIVSXLUWRUWIPOZUWSUXDUPUWRUVBUXRYQUVBUWQUVEUTUWHBEPXMTZMEUXBUWIFPFCEUUQXN
      ZMEUXBXNJCMEUUQUXBCMXOUUPUXABEUUNUUEUUOVPXHXPXQWATXRUWRUXRUWTUXSUWIPYATUW
      IYSUWJXSXLXTYQUWFUUOQZBEUMZPOZUBESUWEUWNUPYQUYCUBEYQUVBUYCUVEUYABEPXMTYBU
      WDUWMUBMEUYBFPFUXTUBEUYBXNJCUBEUUQUYBCUBXOUUPUYABEUUNUWFUUOVPXHXPXQUUEUYB
      VGZUWCUWLNEUYDUWBUWKRUYDUWAUWJYSUYDUVTUWIUYDUVTUYBUVSUKZUWIUUEUYBUVSYCUYE
      UYAUVRUNZBEUMUWIUYAUVRBEYDUYFUWHBEUYFUWHUPUUOEOUWFUVQUUOXAYEYLXQYFYGYHYIV
      QYJTXRYQUUKUWDMYSYQUVSPOZNESUUKUWDUPYQUYGNEYQUVBUYGUVEUVRBEPXMTYBUUJUWCNU
      AEUVSFPFUXTNEUVSXNJCNEUUQUVSCNXOUUPUVRBEUUNUVQUUOVPXHXPXQUUFUVSVGZUUIUWBR
      UYHUUHUWAYSUYHUUGUVTUUFUVSUUEYKYGYHYIYJTVQXRYMYQUVBYTUUBUUMUNUPUVEMUAPEYS
      YNTYOUSYP $.
  $}

  ${
    $d f s w y z F $.  $d f s w y z G $.  $d f s w y z ph $.  $d f s w y S $.
    $d f s w J $.  $d f s w L $.
    tsmslem1.b $e |- B = ( Base ` G ) $.
    tsmslem1.s $e |- S = ( ~P A i^i Fin ) $.
    tsmslem1.1 $e |- ( ph -> G e. CMnd ) $.
    tsmslem1.a $e |- ( ph -> A e. W ) $.
    tsmslem1.f $e |- ( ph -> F : A --> B ) $.
    $( The finite partial sums of a function ` F ` are defined in a commutative
       monoid.  (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    tsmslem1 $p |- ( ( ph /\ X e. S ) -> ( G gsum ( F |` X ) ) e. B ) $=
      ( wcel wa cres adantr wf cfn syl c0g cfv eqid ccmn simpr wss cpw syl6eleq
      cin elfpw simplbi fssres syl2anc cvv csn cdif simprbi fisuppfi gsumcl ) A
      HDNZOZHCEHPZFDFUAUBZIVCUCAFUDNUTKQAUTUEZVABCERZHBUFZHCVBRAVEUTMQVAHBUGSUI
      ZNZVFVAHDVGVDJUHZVHVFHSNZHBUJZUKTBCHEULUMZVAHCUNVCUOUPVBVAVHVJVIVHVFVJVKU
      QTVLURUS $.
  $}

  ${
    $d f s w y z F $.  $d f s w y z G $.  $d f s w y z ph $.  $d f s w y S $.
    $d f s w J $.  $d f s w L $.
    tsmsval.b $e |- B = ( Base ` G ) $.
    tsmsval.j $e |- J = ( TopOpen ` G ) $.
    tsmsval.s $e |- S = ( ~P A i^i Fin ) $.
    tsmsval.l $e |- L = ran ( z e. S |-> { y e. S | z C_ y } ) $.
    tsmsval.g $e |- ( ph -> G e. V ) $.
    ${
      tsmsval2.f $e |- ( ph -> F e. W ) $.
      tsmsval2.a $e |- ( ph -> dom F = A ) $.
      $( Definition of the topological group sum(s) of a collection ` F ( x ) `
         of values in the group with index set ` A ` .  (Contributed by Mario
         Carneiro, 2-Sep-2015.) $)
      tsmsval2 $p |- ( ph -> ( G tsums F ) = ( ( J fLimf ( S filGen L ) ) `
          ( y e. S |-> ( G gsum ( F |` y ) ) ) ) ) $=
        ( cvv vw vf vs cv cdm cpw cfn cin cres cgsu cmpt ctopn cfv wss crab crn
        co cfg cflf csb ctsu cmpt2 wceq df-tsms a1i wa wcel vex dmex pwex inex1
        simplrl fveq2d syl6eqr simprr dmeqd adantr eqtrd pweqd ineq1d sylan9eqr
        id rabeq syl mpteq12dv oveq12d simplrr reseq1d fveq12d csbied elex fvex
        rneqd ovmpt2d ) AUAUBHGTTUCUBUDZUEZUFZUGUHZBUCUDZUAUDZWOBUDZUIZUJUQZUKZ
        WTULUMZWSCWSCUDXAUNZBWSUOZUKZUPZURUQZUSUQZUMZUTZBFHGXAUIZUJUQZUKZIFJURU
        QZUSUQZUMZVATVAUAUBTTXMVBVCABCUAUBUCVDVEAWTHVCZWOGVCZVFZVFZUCWRXLXSTWRT
        VGYCWQUGWPWOUBVHVIVJVKVEYCWSWRVCZVFZXDXPXKXRYEXEIXJXQUSYEXEHULUMIYEWTHU
        LAXTYAYDVLZVMNVNYEWSFXIJURYDYCWSWRFYDWBYCWRDUFZUGUHFYCWQYGUGYCWPDYCWPGU
        EZDYCWOGAXTYAVOVPAYHDVCYBSVQVRVSVTOVNWAZYEXICFXFBFUOZUKZUPJYEXHYKYECWSX
        GFYJYIYEWSFVCXGYJVCYIXFBWSFWCWDWEWMPVNWFWFYEBWSXCFXOYIYEWTHXBXNUJYFYEWO
        GXAAXTYAYDWGWHWFWEWIWJAHKVGHTVGQHKWKWDAGLVGGTVGRGLWKWDXSTVGAXPXRWLVEWN
        $.
    $}

    tsmsval.a $e |- ( ph -> A e. W ) $.
    tsmsval.f $e |- ( ph -> F : A --> B ) $.
    $( Definition of the topological group sum(s) of a collection ` F ( x ) `
       of values in the group with index set ` A ` .  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    tsmsval $p |- ( ph -> ( G tsums F ) = ( ( J fLimf ( S filGen L ) ) `
        ( y e. S |-> ( G gsum ( F |` y ) ) ) ) ) $=
      ( cvv wf wcel cbs cfv fvex eqeltri a1i fex2 syl3anc cdm wceq fdm tsmsval2
      syl ) ABCDEFGHIJKTMNOPQADEGUAZDLUBETUBZGTUBSRUPAEHUCUDTMHUCUEUFUGDEGLTUHU
      IAUOGUJDUKSDEGULUNUM $.
  $}

  ${
    $d y z F $.  $d y z G $.  $d y z H $.  $d y z ph $.
    tsmspropd.f $e |- ( ph -> F e. V ) $.
    tsmspropd.g $e |- ( ph -> G e. W ) $.
    tsmspropd.h $e |- ( ph -> H e. X ) $.
    tsmspropd.b $e |- ( ph -> ( Base ` G ) = ( Base ` H ) ) $.
    tsmspropd.p $e |- ( ph -> ( +g ` G ) = ( +g ` H ) ) $.
    tsmspropd.j $e |- ( ph -> ( TopOpen ` G ) = ( TopOpen ` H ) ) $.
    $( The group sum depends only on the base set, additive operation, and
       topology components.  Note that for entirely unrestricted functions,
       there can be dependency on out-of-domain values of the operation, so
       this is somewhat weaker than ~ mndpropd etc.  (Contributed by Mario
       Carneiro, 18-Sep-2015.) $)
    tsmspropd $p |- ( ph -> ( G tsums F ) = ( H tsums F ) ) $=
      ( vy vz co cmpt cfv cflf eqid cdm cpw cfn cin cv cres cgsu ctopn wss crab
      crn cfg ctsu oveq1d cvv wcel resexg syl gsumpropd mpteq2dv eqidd tsmsval2
      fveq12d cbs 3eqtr4d ) ANBUAZUBUCUDZCBNUEZUFZUGPZQZCUHRZVGOVGOUEVHUINVGUJQ
      UKZULPZSPZRNVGDVIUGPZQZDUHRZVNSPZRCBUMPDBUMPAVKVQVOVSAVLVRVNSMUNANVGVJVPA
      VICDUOFGABEUPVIUOUPHBVHEUQURIJKLUSUTVCANOVFCVDRZVGBCVLVMFEVTTVLTVGTZVMTZI
      HAVFVAZVBANOVFDVDRZVGBDVRVMGEWDTVRTWAWBJHWCVBVE $.
  $}

  ${
    $d u w y B $.  $d u w C $.  $d u w y z F $.  $d u w y z G $.  $d u w z J $.
    $d z A $.  $d u y z ph $.  $d u w y z S $.  $d u y z U $.
    eltsms.b $e |- B = ( Base ` G ) $.
    eltsms.j $e |- J = ( TopOpen ` G ) $.
    eltsms.s $e |- S = ( ~P A i^i Fin ) $.
    eltsms.1 $e |- ( ph -> G e. CMnd ) $.
    eltsms.2 $e |- ( ph -> G e. TopSp ) $.
    eltsms.a $e |- ( ph -> A e. V ) $.
    eltsms.f $e |- ( ph -> F : A --> B ) $.
    $( The property of being a sum of the sequence ` F ` in the topological
       commutative monoid ` G ` .  (Contributed by Mario Carneiro,
       2-Sep-2015.) $)
    eltsms $p |- ( ph -> ( C e. ( G tsums F ) <-> ( C e. B /\ A. u e. J
       ( C e. u -> E. z e. S A. y e. S
         ( z C_ y -> ( G gsum ( F |` y ) ) e. u ) ) ) ) ) $=
      ( wcel vw ctsu co cres cgsu cmpt wss crab crn cfg cflf cfv cima wrex wral
      cv wi wa ccmn eqid tsmsval eleq2d ctopon cfbas wf wb istps sylib tsmsfbas
      ctps tsmslem1 fmptd flffbas syl3anc cvv cpw cfn cin pwexg inex1g syl5eqel
      3syl adantr rabexg ralrimivw wceq imaeq2 sseq1d rexrnmpt ccnv wfun funmpt
      syl cdm ssrab2 ovex dmmpti funimass3 mp2an mptpreima sseq2i ss2rab 3bitri
      sseqtr4i rexbii syl6bb imbi2d ralbidva anbi2d 3bitrd ) AGJIUBUCZTGBHJIBUP
      ZUDZUEUCZUFZKHCHCUPXLUGZBHUHZUFZUIZUJUCZUKUCULZTZGFTZGDUPZTZXOUAUPZUMZYDU
      GZUAXSUNZUQZDKUOZURZYCYEXPXNYDTZUQBHUOZCHUNZUQZDKUOZURAXKYAGABCEFHIJKXSUS
      LMNOXSUTZPRSVAVBAKFVCULTZXSHVDULTHFXOVEYBYLVFAJVJTYSQFKJMNVGVHABCEHXRXSLO
      XRUTZYRRVIABHXNFXOAEFHIJLXLMOPRSVKXOUTZVLGXSDXOKXTFHUAXTUTVMVNAYKYQYCAYJY
      PDKAYDKTZURZYIYOYEUUCYIXOXQUMZYDUGZCHUNZYOUUCXQVOTZCHUOYIUUFVFUUCUUGCHUUC
      HVOTZUUGAUUHUUBAHEVPZVQVRZVOOAELTUUIVOTUUJVOTRELVSUUIVQVOVTWBWAWCXPBHVOWD
      WMWEYHUUECUAHXQXRVOYTYFXQWFYGUUDYDYFXQXOWGWHWIWMUUEYNCHUUEXQXOWJYDUMZUGZX
      QYMBHUHZUGYNXOWKXQXOWNZUGUUEUULVFBHXNWLXQHUUNXPBHWOBHXNXOJXMUEWPUUAWQXDXQ
      YDXOWRWSUUKUUMXQBHXNYDXOUUAWTXAXPYMBHXBXCXEXFXGXHXIXJ $.

    tsmsi.3 $e |- ( ph -> C e. ( G tsums F ) ) $.
    tsmsi.4 $e |- ( ph -> U e. J ) $.
    tsmsi.5 $e |- ( ph -> C e. U ) $.
    $( The property of being a sum of the sequence ` F ` in the topological
       commutative monoid ` G ` .  (Contributed by Mario Carneiro,
       2-Sep-2015.) $)
    tsmsi $p |- ( ph -> E. z e. S A. y e. S
         ( z C_ y -> ( G gsum ( F |` y ) ) e. U ) ) $=
      ( vu wcel cv wss cres cgsu co wi wral wrex ctsu eltsms mpbid simprd eleq2
      wa wceq imbi2d rexralbidv imbi12d rspcv syl3c ) AHKUDFUCUEZUDZCUEBUEZUFZJ
      IVGUGUHUIZVEUDZUJZBGUKCGULZUJZUCKUKZFHUDZVHVIHUDZUJZBGUKCGULZUAAFEUDZVNAF
      JIUMUIUDVSVNURTABCUCDEFGIJKLMNOPQRSUNUOUPUBVMVOVRUJUCHKVEHUSZVFVOVLVRVEHF
      UQVTVKVQCBGGVTVJVPVHVEHVIUQUTVAVBVCVD $.
  $}

  ${
    $d w x y z A $.  $d w x y B $.  $d w x y z F $.  $d w x y z G $.  $d x X $.
    $d x z J $.  $d w x y z ph $.
    tsmscl.b $e |- B = ( Base ` G ) $.
    tsmscl.1 $e |- ( ph -> G e. CMnd ) $.
    tsmscl.2 $e |- ( ph -> G e. TopSp ) $.
    tsmscl.a $e |- ( ph -> A e. V ) $.
    tsmscl.f $e |- ( ph -> F : A --> B ) $.
    $( A sum in a topological group is an element of the group.  (Contributed
       by Mario Carneiro, 2-Sep-2015.) $)
    tsmscl $p |- ( ph -> ( G tsums F ) C_ B ) $=
      ( vx vw vz vy co cv wcel wi wral ctsu wss cres cgsu cpw cfn cin ctopn cfv
      wrex wa eqid eltsms simpl syl6bi ssrdv ) ALEDUAPZCALQZUQRURCRZURMQZRNQOQZ
      UBEDVAUCUDPUTRSOBUEUFUGZTNVBUJSMEUHUIZTZUKUSAONMBCURVBDEVCFGVCULVBULHIJKU
      MUSVDUNUOUP $.

    haustsms.j $e |- J = ( TopOpen ` G ) $.
    haustsms.h $e |- ( ph -> J e. Haus ) $.
    $( A Hausdorff group has at most one limit point for a given sum.
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    haustsms $p |- ( ph -> E* x x e. ( G tsums F ) ) $=
      ( vz vy co wcel eqid ctsu wmo cpw cfn cin cres cgsu cmpt wss crab crn cfg
      cv cflf cfv cha cfil cuni wf cfbas tsmsfbas fgcl syl tsmslem1 wceq tpsuni
      wa ctps adantr eleqtrd fmptd hausflf syl3anc tsmsval eleq2d mobidv mpbird
      ccmn ) ABUMZFEUARZSZBUBVSPCUCUDUEZFEPUMZUFUGRZUHZGWBQWBQUMWCUIPWBUJUHZUKZ
      ULRZUNRUOZSZBUBZAGUPSWHWBUQUOSZWBGURZWEUSWKOAWGWBUTUOSWLAPQCWBWFWGHWBTZWF
      TWGTZLVAWGWBVBVCAPWBWDWMWEAWCWBSZVGWDDWMACDWBEFHWCIWNJLMVDADWMVEZWPAFVHSW
      QKDGFINVFVCVIVJWETVKBWEGWHWMWBWMTVLVMAWAWJBAVTWIVSAPQCDWBEFGWGVRHINWNWOJL
      MVNVOVPVQ $.

    $( A Hausdorff group has at most one limit point for a given sum.
       (Contributed by Mario Carneiro, 13-Sep-2015.) $)
    haustsms2 $p |- ( ph ->
        ( X e. ( G tsums F ) -> ( G tsums F ) = { X } ) ) $=
      ( vx ctsu wcel wceq wa co csn cv wmo wi simpr haustsms eleq1 moi2 ancom2s
      adantr expr syl21anc elsn syl6ibr ssrdv wss snssi adantl eqssd ex ) AHEDQ
      UAZRZVBHUBZSAVCTZVBVDVEPVBVDVEPUCZVBRZVFHSZVFVDRVEVCVGPUDZVCVGVHUEAVCUFZA
      VIVCAPBCDEFGIJKLMNOUGUKVJVCVITZVCVGVHVKVGVCVHVGVCPHVBVFHVBUHUIUJULUMPHUNU
      OUPVCVDVBUQAHVBURUSUTVA $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y F $.  $d x y G $.  $d x y ph $.
    tsmscls.b $e |- B = ( Base ` G ) $.
    tsmscls.j $e |- J = ( TopOpen ` G ) $.
    tsmscls.1 $e |- ( ph -> G e. CMnd ) $.
    tsmscls.2 $e |- ( ph -> G e. TopSp ) $.
    tsmscls.a $e |- ( ph -> A e. V ) $.
    tsmscls.f $e |- ( ph -> F : A --> B ) $.
    tsmscls.x $e |- ( ph -> X e. ( G tsums F ) ) $.
    $( One half of ~ tgptsmscls , true in any commutative monoid topological
       space.  (Contributed by Mario Carneiro, 21-Sep-2015.) $)
    tsmscls $p |- ( ph -> ( ( cls ` J ) ` { X } ) C_ ( G tsums F ) ) $=
      ( vx vy cfv co wcel csn ccl cpw cfn cin cv wss crab cmpt crn cfg cres cfm
      cgsu cflim ctsu cflf ctps eqid tsmsval ctopon cfil wceq istps sylib cfbas
      wf tsmsfbas fgcl syl tsmslem1 fmptd flfval syl3anc eqtrd eleqtrd sseqtr4d
      flimsncls ) AHUAFUBRRZFBUCUDUEZPVTPUFQUFZUGQVTUHUIZUJZUKSZCQVTEDWAULUNSZU
      IZUMSRZUOSZEDUPSZAHWHTVSWHUGAHWIWHOAWIWFFWDUQSRZWHAQPBCVTDEFWCURGIJVTUSZW
      CUSZLMNUTAFCVARTZWDVTVBRTZVTCWFVGWJWHVCAEURTWMLCFEIJVDVEAWCVTVFRTWNAQPBVT
      WBWCGWKWBUSWLMVHWCVTVIVJAQVTWECWFABCVTDEGWAIWKKMNVKWFUSVLWFFWDCVTVMVNVOZV
      PHWGFVRVJWOVQ $.
  $}

  ${
    $d y z .0. $.  $d u y z A $.  $d u z B $.  $d u x y z F $.  $d u x y z G $.
    $d u x y z J $.  $d u x y z ph $.
    tsmsid.b $e |- B = ( Base ` G ) $.
    tsmsid.z $e |- .0. = ( 0g ` G ) $.
    tsmsid.1 $e |- ( ph -> G e. CMnd ) $.
    tsmsid.2 $e |- ( ph -> G e. TopSp ) $.
    tsmsid.a $e |- ( ph -> A e. V ) $.
    tsmsid.f $e |- ( ph -> F : A --> B ) $.
    tsmsid.w $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) e. Fin ) $.
    ${
      tsmsgsum.j $e |- J = ( TopOpen ` G ) $.
      $( The convergent points of a finite topological group sum are the
         closure of the finite group sum operation.  (Contributed by Mario
         Carneiro, 19-Sep-2015.) $)
      tsmsgsum $p |- ( ph ->
          ( G tsums F ) = ( ( cls ` J ) ` { ( G gsum F ) } ) ) $=
        ( vz wcel wa ad2antrr vx vu vy ctsu co cgsu csn ccl cfv cv wss cres cpw
        wi cfn cin wral wrex cuni wne ctopon wceq ctps istps sylib toponuni syl
        c0 eleq2d ccnv cvv cdif cima cun elfpw simplbi adantl cnvimass syl5sseq
        cdm wf fdm unssd simprbi unfi syl2anc sylanbrc wb ssun1 syl5sseqr pm5.5
        id reseq2 oveq2d eleq1d bitrd rspcv ccmn ssun2 gsumres sylibd rexlimdva
        a1i adantr simprr simplrr eqeltrd ralrimiva sseq1 imbi1d ralbidv rspcev
        impbid disjsn necon2abii syl6bb imbi2d ralbidva anbi12d eltsms topontop
        expr eqid ctop gsumcl snssd sseqtrd elcls2 3bitr4d eqrdv ) AUAEDUDUEZED
        UFUEZUGZFUHUIUIZAUAUJZCRZYOUBUJZRZUCUJZQUJZUKZEDYTULZUFUEZYQRZUNZQBUMUO
        UPZUQZUCUUFURZUNZUBFUQZSYOFUSZRZYRYQYMUPZVHUTZUNZUBFUQZSZYOYKRYOYNRZAYP
        UULUUJUUPACUUKYOAFCVAUIRZCUUKVBAEVCRUUSLCFEIPVDVEZCFVFVGZVIAUUIUUOUBFAY
        QFRZSZUUHUUNYRUVCUUHYLYQRZUUNUVCUUHUVDUVCUUGUVDUCUUFUVCYSUUFRZSZUUGEDYS
        DVJVKHUGVLZVMZVNZULZUFUEZYQRZUVDUVFUVIUUFRZUUGUVLUNUVFUVIBUKUVIUORZUVMU
        VFYSUVHBUVEYSBUKZUVCUVEUVOYSUORZYSBVOZVPVQAUVHBUKZUVBUVEADVTZUVHBDUVGVR
        ABCDWAZUVSBVBNBCDWBVGVSZTWCUVFUVPUVHUORZUVNUVEUVPUVCUVEUVOUVPUVQWDVQAUW
        BUVBUVEOTZYSUVHWEWFUVIBVOWGUUEUVLQUVIUUFYTUVIVBZUUEUUDUVLUWDUUAUUEUUDWH
        UWDUVIYSYTYSUVHWIUWDWLWJUUAUUDWKVGUWDUUCUVKYQUWDUUBUVJEUFYTUVIDWMWNWOWP
        WQVGUVFUVKYLYQUVFBCDEGUVIHIJAEWRRZUVBUVEKTABGRZUVBUVEMTAUVTUVBUVENTUVHU
        VIUKUVFUVHYSWSXCUWCWTWOXAXBAUVBUVDUUHAUVBUVDSZSZUVHUUFRZUVHYTUKZUUDUNZQ
        UUFUQZUUHAUWIUWGAUVRUWBUWIUWAOUVHBVOWGXDUWHUWKQUUFUWHYTUUFRZUWJUUDUWHUW
        MUWJSZSZUUCYLYQUWOBCDEGYTHIJAUWEUWGUWNKTAUWFUWGUWNMTAUVTUWGUWNNTUWHUWMU
        WJXEAUWBUWGUWNOTWTAUVBUVDUWNXFXGYBXHUUGUWLUCUVHUUFYSUVHVBZUUEUWKQUUFUWP
        UUAUWJUUDYSUVHYTXIXJXKXLWFYBXMUVDUUMVHYQYLXNXOXPXQXRXSAQUCUBBCYOUUFDEFG
        IPUUFYCKLMNXTAFYDRZYMUUKUKUURUUQWHAUUSUWQUUTCFYAVGAYMCUUKAYLCABCDEGHIJK
        MNOYEYFUVAYGUBYOYMFUUKUUKYCYHWFYIYJ $.
    $}

    $( If a sum is finite, the usual sum is always a limit point of the
       topological sum (although it may not be the only limit point).
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    tsmsid $p |- ( ph -> ( G gsum F ) e. ( G tsums F ) ) $=
      ( cgsu co cfv wss wcel eqid csn ctopn ccl ctsu ctop cuni ctps istps sylib
      ctopon topontop syl gsumcl snssd wceq toponuni sseqtrd sscls syl2anc ovex
      snss sylibr tsmsgsum eleqtrrd ) AEDOPZVEUAZEUBQZUCQQZEDUDPAVFVHRZVEVHSAVG
      UESZVFVGUFZRVIAVGCUJQSZVJAEUGSVLKCVGEHVGTZUHUIZCVGUKULAVFCVKAVECABCDEFGHI
      JLMNUMUNAVLCVKUOVNCVGUPULUQVFVGVKVKTURUSVEVHEDOUTVAVBABCDEVGFGHIJKLMNVMVC
      VD $.

    haustsmsid.j $e |- J = ( TopOpen ` G ) $.
    haustsmsid.h $e |- ( ph -> J e. Haus ) $.
    $( In a Hausdorff group a finite sum sums to exactly the usual number with
       no extraneous limit points.  By setting the topology to the discrete
       topology (which is Hausdorff), this theorem can be used to turn any
       ` tsums ` theorem into a ` gsum ` theorem, so that the infinite group
       sum operation can be viewed as a generalization of the finite group
       sum.  (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    haustsmsid $p |- ( ph -> ( G tsums F ) = { ( G gsum F ) } ) $=
      ( cgsu co ctsu wcel csn wceq tsmsid haustsms2 mpd ) AEDRSZEDTSZUAUHUGUBUC
      ABCDEGHIJKLMNOUDABCDEFGUGIKLMNPQUEUF $.
  $}

  ${
    $d x A $.  $d x G $.  $d x ph $.  $d x V $.  $d x .0. $.
    tsms0.z $e |- .0. = ( 0g ` G ) $.
    tsms0.1 $e |- ( ph -> G e. CMnd ) $.
    tsms0.2 $e |- ( ph -> G e. TopSp ) $.
    tsms0.a $e |- ( ph -> A e. V ) $.
    $( The sum of zero is zero.  (Contributed by Mario Carneiro,
       18-Sep-2015.) $)
    tsms0 $p |- ( ph -> .0. e. ( G tsums ( x e. A |-> .0. ) ) ) $=
      ( cmpt cgsu co ctsu wcel syl eqid c0 cfn cdif cmnd wceq ccmn cmnmnd gsumz
      syl2anc cbs cfv cv mndidcl adantr fmptd ccnv cvv csn cima 0fin wa suppss2
      wss eqidd ssfi sylancr tsmsid eqeltrrd ) ADBCFKZLMZFDVFNMADUAOZCEOVGFUBAD
      UCOVHHDUDPZJCBDEFGUEUFACDUGUHZVFDEFVJQZGHIJABCFVJVFAFVJOZBUIZCOAVHVLVIVJD
      FVKGUJPUKVFQULARSOVFUMUNFUOTUPZRUTVNSOUQACFBRFAVMCRTOURFVAUSRVNVBVCVDVE
      $.
  $}

  ${
    $d u v x y z F $.  $d u v x y z G $.  $d u v x y z H $.  $d u v x y z ph $.
    $d u v y z A $.  $d u v x y z S $.
    tsmssubm.a $e |- ( ph -> A e. V ) $.
    tsmssubm.1 $e |- ( ph -> G e. CMnd ) $.
    tsmssubm.2 $e |- ( ph -> G e. TopSp ) $.
    tsmssubm.s $e |- ( ph -> S e. ( SubMnd ` G ) ) $.
    tsmssubm.f $e |- ( ph -> F : A --> S ) $.
    tsmssubm.h $e |- H = ( G |`s S ) $.
    $( Evaluate an infinite group sum in a submonoid.  (Contributed by Mario
       Carneiro, 18-Sep-2015.) $)
    tsmssubm $p |- ( ph -> ( H tsums F ) = ( ( G tsums F ) i^i S ) ) $=
      ( vz vy vu co wcel wa wb vx vv ctsu cin cv wss cres cgsu wi cpw wral wrex
      cfn ctopn cfv cbs csubmnd wceq submbas syl eleq2d anbi1d elin ancom bitri
      eqid submss sselda wf fss syl2anc eltsms baibd syldan cvv vex inex1 crest
      a1i resstopn eleq2i fvex elrest sylancr adantr syl5bbr eleq2 rbaib adantl
      sylan9bbr c0g ccmn cmnd submmnd subcmn ad2antrr elfpw simprbi fssres feq3
      simplbi mpbid cdif fisuppfi gsumcl eleqtrrd gsumsubm eleq1d bitr4d imbi2d
      csn an32s ralbidva rexbidv imbi12d ralxfr2d pm5.32da syl5bb cress resstps
      ctps syl5eqel 3bitr4rd eqrdv ) AUAFDUCQZEDUCQZCUDZAUAUEZCRZYHUBUEZRZNUEOU
      EZUFZFDYLUGZUHQZYJRZUIZOBUJUMUDZUKZNYRULZUIZUBFUNUOZUKZSZYHFUPUOZRZUUCSYH
      YGRZYHYERAYIUUFUUCACUUEYHACEUQUOZRZCUUEURZKCFEMUSUTZVAVBUUGYIYHYFRZSZAUUD
      UUGUULYISUUMYHYFCVCUULYIVDVEAYIUULUUCAYISZUULYHPUEZRZYMEYNUHQZUUORZUIZOYR
      UKZNYRULZUIZPEUNUOZUKZUUCAYIYHEUPUOZRZUULUVDTACUVEYHAUUICUVEUFZKUVECEUVEV
      FZVGUTZVHAUULUVFUVDAONPBUVEYHYRDEUVCGUVHUVCVFZYRVFZIJHABCDVIZUVGBUVEDVILU
      VIBCUVEDVJVKVLVMVNUUNUUAUVBUBPUUOCUDZUUBUVCVOUVMVORUUNUUOUVCRSUUOCPVPVQVS
      YJUUBRYJUVCCVRQZRZUUNYJUVMURZPUVCULZUVNUUBYJCFUVCEMUVJVTWAAUVOUVQTZYIAUVC
      VORUUIUVREUNWBKPYJCUVCVOUUHWCWDWEWFUUNUVPSZYKUUPYTUVAUVPYKYHUVMRZUUNUUPYJ
      UVMYHWGYIUVTUUPTAUVTUUPYIYHUUOCVCWHWIWJUVSYSUUTNYRUVSYQUUSOYRUVSYLYRRZSYP
      UURYMUUNUWAUVPYPUURTUVPYPYOUVMRZUUNUWASZUURYJUVMYOWGUWCUWBYOUUORZUURUWCYO
      CRZUWBUWDTUWCYOUUECUWCYLUUEYNFUMFWKUOZUUEVFZUWFVFAFWLRZYIUWAAEWLRFWMRZUWH
      IAUUIUWIKCFEMWNUTCEFMWOVKZWPUWAYLUMRZUUNUWAYLBUFZUWKYLBWQZWRWIZUWCYLCYNVI
      ZYLUUEYNVIZUWCUVLUWLUWOAUVLYIUWALWPUWAUWLUUNUWAUWLUWKUWMXAWIBCYLDWSVKZUWC
      UUJUWOUWPTAUUJYIUWAUUKWPZCUUEYLYNWTUTXBUWCYLCVOUWFXKXCYNUWNUWQXDXEUWRXFUW
      BUWDUWEYOUUOCVCWHUTUWCUUQYOUUOUWCYLCYNEFUMUWNAUUIYIUWAKWPUWQMXGXHXIWJXLXJ
      XMXNXOXPXIXQXRAONUBBUUEYHYRDFUUBGUWGUUBVFUVKUWJAFECXSQZYAMAEYARUUIUWSYARJ
      KCEUUHXTVKYBHAUVLBUUEDVIZLAUUJUVLUWTTUUKCUUEBDWTUTXBVLYCYD $.
  $}

  ${
    $d a b u y z A $.  $d b u z B $.  $d a b u x y z F $.  $d a b u x y z ph $.
    $d a b u x y z G $.  $d a b u x y z W $.
    tsmsres.b $e |- B = ( Base ` G ) $.
    tsmsres.z $e |- .0. = ( 0g ` G ) $.
    tsmsres.1 $e |- ( ph -> G e. CMnd ) $.
    tsmsres.2 $e |- ( ph -> G e. TopSp ) $.
    tsmsres.a $e |- ( ph -> A e. V ) $.
    tsmsres.f $e |- ( ph -> F : A --> B ) $.
    tsmsres.s $e |- ( ph -> ( `' F " ( _V \ { .0. } ) ) C_ W ) $.
    $( Extend an infinite group sum by padding outside with zeroes.
       (Contributed by Mario Carneiro, 18-Sep-2015.) $)
    tsmsres $p |- ( ph -> ( G tsums ( F |` W ) ) = ( G tsums F ) ) $=
      ( cres wcel wss cgsu cfn vx vu va vb vy vz ctsu co cv cin wral wrex ctopn
      wi cpw cfv inss1 sspwb mpbi ssrin ax-mp simpr sseldi elfpw simplbi adantl
      wa syl simprbi ssfi sylancl sylanbrc wceq sseq2 ssin syl6bbr reseq2 inss2
      resabs1 syl6eq oveq2d eleq1d rspcv ad2antlr syl6ss biantrud resres oveq2i
      imbi12d ccmn ad2antrr fssres syl2anc ccnv cvv csn cdif resss cnvss imass1
      cima mp2b syl5ss fisuppfi gsumres syl5reqr sylibrd ralrimdva sseq1 imbi1d
      wf ralbidv rspcev ee12an rexlimdva cun unssd syl2an wb ssun1 id syl5sseqr
      pm5.5 bitrd adantrr indir df-ss sylib uneq2d simprr ssequn1 eqtrd reseq2d
      unfi syl5eq eqtr4d eqtr3d biimpd eqid eltsms expr com23 impbid imbi2d wfn
      syld anbi2d inex1g fnresdm 3syl reseq1d syl5eqr feq1d mpbid 3bitr4d eqrdv
      ffn ) AUAEDGPZUGUHZEDUGUHZAUAUIZCQZUVAUBUIZQZUCUIZUDUIZRZEUURUVFPZSUHZUVC
      QZUNZUDBGUJZUOZTUJZUKZUCUVNULZUNZUBEUMUPZUKZVGUVBUVDUEUIZUFUIZRZEDUWAPZSU
      HZUVCQZUNZUFBUOZTUJZUKZUEUWHULZUNZUBUVRUKZVGUVAUUSQUVAUUTQAUVSUWLUVBAUVQU
      WKUBUVRAUVPUWJUVDAUVPUWJAUVOUWJUCUVNAUVEUVNQZVGZUVEUWHQUVOUVEUWARZUWEUNZU
      FUWHUKZUWJUWNUVNUWHUVEUVMUWGRZUVNUWHRUVLBRZUWRBGUQZUVLBURUSUVMUWGTUTVAAUW
      MVBVCUWNUVOUWPUFUWHUWNUWAUWHQZVGZUVOUWOUVEGRZVGZEDUWAGUJZPZSUHZUVCQZUNZUW
      PUXBUXEUVNQZUVOUXIUNUXBUXEUVLRZUXETQZUXJUXBUWABRZUXKUXAUXMUWNUXAUXMUWATQZ
      UWABVDZVEVFZUWABGUTVHUXBUXNUXEUWARUXLUXAUXNUWNUXAUXMUXNUXOVIVFZUWAGUQUWAU
      XEVJVKUXEUVLVDVLUVKUXIUDUXEUVNUVFUXEVMZUVGUXDUVJUXHUXRUVGUVEUXERUXDUVFUXE
      UVEVNUVEUWAGVOVPUXRUVIUXGUVCUXRUVHUXFESUXRUVHUURUXEPZUXFUVFUXEUURVQUXEGRU
      XSUXFVMUWAGVRDUXEGVSVAVTWAWBWIWCVHUXBUWOUXDUWEUXHUXBUXCUWOUXBUVEUVLGUWMUV
      EUVLRZAUXAUWMUXTUVETQUVEUVLVDVEWDBGVRZWEWFUXBUWDUXGUVCUXBUXGEUWCGPZSUHUWD
      UYBUXFESDUWAGWGWHUXBUWACUWCETGHIJAEWJQZUWMUXAKWKUXQUXBBCDXKZUXMUWACUWCXKA
      UYDUWMUXANWKUXPBCUWADWLWMZUXBUWCWNZWOHWPWQZXAZDWNZUYGXAZGUWCDRUYFUYIRUYHU
      YJRDUWAWRUWCDWSUYFUYIUYGWTXBAUYJGRZUWMUXAOWKXCUXBUWACUYGUWCUXQUYEXDXEXFWB
      WIXGXHUWIUWQUEUVEUWHUVTUVEVMZUWFUWPUFUWHUYLUWBUWOUWEUVTUVEUWAXIXJXLXMXNXO
      AUWIUVPUEUWHAUVTUWHQZVGZUVTGUJZUVNQZUWIUYOUVFRZUVJUNZUDUVNUKZUVPUYNUYOUVL
      RZUYOTQZUYPUYNUVTBRZUYTUYMVUBAUYMVUBUVTTQZUVTBVDZVEZVFUVTBGUTVHUYNVUCUYOU
      VTRVUAUYMVUCAUYMVUBVUCVUDVIVFZUVTGUQUVTUYOVJVKUYOUVLVDVLUYNUWIUYRUDUVNUYN
      UVFUVNQZVGZUWIEDUVTUVFXPZPZSUHZUVCQZUYRVUHVUIUWHQZUWIVULUNVUHVUIBRZVUITQZ
      VUMVUHUVTUVFBUYMVUBAVUGVUEWDVUHUVFUVLBVUGUVFUVLRZUYNVUGVUPUVFTQZUVFUVLVDZ
      VEVFZUWTWEXQZUYNVUCVUQVUOVUGVUFVUGVUPVUQVURVIUVTUVFYNXRZVUIBVDVLUWFVULUFV
      UIUWHUWAVUIVMZUWFUWEVULVVBUWBUWFUWEXSVVBVUIUVTUWAUVTUVFXTVVBYAYBUWBUWEYCV
      HVVBUWDVUKUVCVVBUWCVUJESUWAVUIDVQWAWBYDWCVHVUHUYQVULUVJUYNVUGUYQVULUVJUNU
      YNVUGUYQVGZVGZVULUVJVVDVUKUVIUVCVVDEVUJGPZSUHVUKUVIVVDVUICVUJETGHIJAUYCUY
      MVVCKWKUYNVUGVUOUYQVVAYEZVVDUYDVUNVUICVUJXKAUYDUYMVVCNWKUYNVUGVUNUYQVUTYE
      BCVUIDWLWMZVVDVUJWNZUYGXAZUYJGVUJDRVVHUYIRVVIUYJRDVUIWRVUJDWSVVHUYIUYGWTX
      BAUYKUYMVVCOWKXCVVDVUICUYGVUJVVFVVGXDXEVVDVVEUVHESVVDVVEDUVFPZUVHVVDVVEDV
      UIGUJZPVVJDVUIGWGVVDVVKUVFDVVDVVKUYOUVFGUJZXPZUVFUVTUVFGYFVVDVVMUYOUVFXPZ
      UVFVVDVVLUVFUYOVVDUVFGRZVVLUVFVMUYNVUGVVOUYQVUHUVFUVLGVUSUYAWEYEZUVFGYGYH
      YIVVDUYQVVNUVFVMUYNVUGUYQYJUYOUVFYKYHYLYOYMYOVVDVVOUVHVVJVMVVPDUVFGVSVHYP
      WAYQWBYRUUAUUBUUFXHUVOUYSUCUYOUVNUVEUYOVMZUVKUYRUDUVNVVQUVGUYQUVJUVEUYOUV
      FXIXJXLXMXNXOUUCUUDXLUUGAUDUCUBUVLCUVAUVNUUREUVRWOIUVRYSZUVNYSKLABFQUVLWO
      QMBGFUUHVHAUVLCDUVLPZXKZUVLCUURXKAUYDUWSVVTNUWTBCUVLDWLVKAUVLCVVSUURAVVSD
      BPZGPUURDBGWGAVWADGAUYDDBUUEVWADVMNBCDUUQBDUUIUUJUUKUULUUMUUNYTAUFUEUBBCU
      VAUWHDEUVRFIVVRUWHYSKLMNYTUUOUUP $.
  $}

  ${
    $d a b u y z A $.  $d b u z B $.  $d a b u x y z F $.  $d a b u x y z ph $.
    $d a b u y z C $.  $d a b u x y z G $.  $d a b u x y z H $.
    tsmsf1o.b $e |- B = ( Base ` G ) $.
    tsmsf1o.1 $e |- ( ph -> G e. CMnd ) $.
    tsmsf1o.2 $e |- ( ph -> G e. TopSp ) $.
    tsmsf1o.a $e |- ( ph -> A e. V ) $.
    tsmsf1o.f $e |- ( ph -> F : A --> B ) $.
    tsmsf1o.s $e |- ( ph -> H : C -1-1-onto-> A ) $.
    $( Re-index an infinite group sum using a bijection.  (Contributed by Mario
       Carneiro, 18-Sep-2015.) $)
    tsmsf1o $p |- ( ph -> ( G tsums F ) = ( G tsums ( F o. H ) ) ) $=
      ( vz va vb wcel wss wral vx vu vy ctsu co ccom cres cgsu cpw cfn cin wrex
      cv wi ctopn cfv wa cima cmpt crn wb wf wf1o f1opwfi f1of eqid fmpt sylibr
      syl wceq sseq1 imbi1d ralbidv rexrnmpt wfo f1ofo forn 3syl rexeqdv imaeq2
      cbvmptv sseq2 reseq2 oveq2d eleq1d imbi12d ralrnmpt raleqdv bitr3d adantr
      wf1 f1of1 ad2antrr elfpw simplbi ad2antlr adantl f1imass syl12anc simprbi
      c0g ccmn f1ores syl2anc fofi imassrn syl5sseq fssres cvv csn cdif gsumf1o
      fisuppfi df-ima eqimss2i cores ax-mp resco eqtr4i oveq2i ralbidva 3bitr3d
      syl6eq rexbidva imbi2d anbi2d eltsms f1dmex fco 3bitr4d eqrdv ) AUAFEUDUE
      ZFEGUFZUDUEZAUAUMZCRZYOUBUMZRZUCUMZOUMZSZFEYTUGZUHUEZYQRZUNZOBUIUJUKZTZUC
      UUFULZUNZUBFUOUPZTZUQYPYRPUMZQUMZSZFYMUUMUGZUHUEZYQRZUNZQDUIUJUKZTZPUUSUL
      ZUNZUBUUJTZUQYOYLRYOYNRAUUKUVCYPAUUIUVBUBUUJAUUHUVAYRAUUGUCPUUSGUULURZUSZ
      UTZULZUVDYTSZUUDUNZOUUFTZPUUSULZUUHUVAAUVDUUFRPUUSTZUVGUVKVAAUUSUUFUVEVBZ
      UVLAUUSUUFUVEVCZUVMADBGVCZUVNNDBGPVDVIZUUSUUFUVEVEVIZPUUSUUFUVDUVEUVEVFZV
      GVHUUGUVJPUCUUSUVDUVEUUFUVRYSUVDVJZUUEUVIOUUFUVSUUAUVHUUDYSUVDYTVKVLVMVNV
      IAUUGUCUVFUUFAUVNUUSUUFUVEVOUVFUUFVJUVPUUSUUFUVEVPUUSUUFUVEVQVRZVSAUVJUUT
      PUUSAUULUUSRZUQZUVDGUUMURZSZFEUWCUGZUHUEZYQRZUNZQUUSTZUVJUUTAUWIUVJVAUWAA
      UVIOUVFTZUWIUVJAUWCUUFRQUUSTZUWJUWIVAAUVMUWKUVQQUUSUUFUWCUVEPQUUSUVDUWCUU
      LUUMGVTWAZVGVHUVIUWHQOUUSUWCUVEUUFUWLYTUWCVJZUVHUWDUUDUWGYTUWCUVDWBUWMUUC
      UWFYQUWMUUBUWEFUHYTUWCEWCWDWEWFWGVIAUVIOUVFUUFUVTWHWIWJUWBUWHUURQUUSUWBUU
      MUUSRZUQZUWDUUNUWGUUQUWODBGWKZUULDSZUUMDSZUWDUUNVAAUWPUWAUWNAUVOUWPNDBGWL
      VIZWMZUWAUWQAUWNUWAUWQUULUJRUULDWNWOWPUWNUWRUWBUWNUWRUUMUJRZUUMDWNZWOWQZD
      BUULUUMGWRWSUWOUWFUUPYQUWOUWFFUWEGUUMUGZUFZUHUEUUPUWOUWCCUUMUWEFUXDUJFXAU
      PZIUXFVFAFXBRUWAUWNJWMUWOUXAUUMUWCUXDVOZUWCUJRUWNUXAUWBUWNUWRUXAUXBWTWQUW
      OUUMUWCUXDVCZUXGUWOUWPUWRUXHUWTUXCDBUUMGXCXDZUUMUWCUXDVPVIUUMUWCUXDXEXDZU
      WOBCEVBZUWCBSUWCCUWEVBAUXKUWAUWNMWMUWOGUTZUWCBGUUMXFUWOUVODBGVOUXLBVJAUVO
      UWAUWNNWMDBGVPDBGVQVRXGBCUWCEXHXDZUWOUWCCXIUXFXJXKUWEUXJUXMXMUXIXLUXEUUOF
      UHUXEEUXDUFZUUOUXDUTZUWCSUXEUXNVJUWCUXOGUUMXNXOEUXDUWCXPXQEGUUMXRXSXTYCWE
      WFYAWIYDYBYEVMYFAOUCUBBCYOUUFEFUUJHIUUJVFZUUFVFJKLMYGAQPUBDCYOUUSYMFUUJXI
      IUXPUUSVFJKAUWPBHRDXIRUWSLDBHGYHXDAUXKDBGVBZDCYMVBMAUVOUXQNDBGVEVIDBCEGYI
      XDYGYJYK $.
  $}

  ${
    $d y z A $.  $d w y z C $.  $d w y z F $.  $d w y z G $.  $d y z ph $.
    $d w z B $.  $d y z H $.
    tsmsmhm.b $e |- B = ( Base ` G ) $.
    tsmsmhm.j $e |- J = ( TopOpen ` G ) $.
    tsmsmhm.k $e |- K = ( TopOpen ` H ) $.
    tsmsmhm.1 $e |- ( ph -> G e. CMnd ) $.
    tsmsmhm.2 $e |- ( ph -> G e. TopSp ) $.
    tsmsmhm.3 $e |- ( ph -> H e. CMnd ) $.
    tsmsmhm.4 $e |- ( ph -> H e. TopSp ) $.
    tsmsmhm.5 $e |- ( ph -> C e. ( G MndHom H ) ) $.
    tsmsmhm.6 $e |- ( ph -> C e. ( J Cn K ) ) $.
    tsmsmhm.a $e |- ( ph -> A e. V ) $.
    tsmsmhm.f $e |- ( ph -> F : A --> B ) $.
    tsmsmhm.x $e |- ( ph -> X e. ( G tsums F ) ) $.
    $( Apply a continuous group homomorphism to an infinite group sum.
       (Contributed by Mario Carneiro, 18-Sep-2015.) $)
    tsmsmhm $p |- ( ph -> ( C ` X ) e. ( H tsums ( C o. F ) ) ) $=
      ( vz vy vw cfv cpw cfn cin cres cgsu cmpt ccom wss crab crn cfg cflf ctsu
      cv co ctopon wcel cfil ccnp ctps istps sylib cfbas eqid tsmsfbas fgcl syl
      wf tsmslem1 fmptd tsmsval eleqtrd cuni tsmscl sseldd wceq toponuni cncnpi
      ccn syl2anc flfcnp syl32anc cbs ccmn cnf2 syl3anc fco eqidd feqmptd fveq2
      fmptco wa resco oveq2i c0g adantr cmnd cmnmnd simprbi adantl cmhm simplbi
      elfpw fssres syl2an cvv csn cdif fisuppfi gsummhm syl5eq mpteq2dva eqtr4d
      fveq2d eleqtrrd ) AKDUGZDUDBUHUIUJZFEUDVAZUKZULVBZUMZUNZIYDUEYDUEVAYEUOUD
      YDUPUMZUQZURVBZUSVBZUGZGDEUNZUTVBZAHCVCUGVDZYLYDVEUGVDZYDCYHVOKYHHYLUSVBU
      GZVDDKHIVFVBUGVDZYCYNVDAFVGVDYQPCHFLMVHVIZAYKYDVJUGVDYRAUDUEBYDYJYKJYDVKZ
      YJVKYKVKZUAVLYKYDVMVNAUDYDYGCYHABCYDEFJYELUUBOUAUBVPZYHVKVQAKFEUTVBZYSUCA
      UDUEBCYDEFHYKVGJLMUUBUUCPUAUBVRVSADHIWFVBVDZKHVTZVDYTTAKCUUGAUUECKABCEFJL
      OPUAUBWAUCWBAYQCUUGWCUUACHWDVNVSKDHIUUGUUGVKWEWGKYHDHIYLCYDWHWIAYPUDYDGYO
      YEUKZULVBZUMZYMUGYNAUDUEBGWJUGZYDYOGIYKWKJUUKVKZNUUBUUCQUAACUUKDVOZBCEVOZ
      BUUKYOVOAYQIUUKVCUGVDZUUFUUMUUAAGVGVDUUORUUKIGUULNVHVITDHICUUKWLWMZUBBCUU
      KDEWNWGVRAYIUUJYMAYIUDYDYGDUGZUMUUJAUDUFYDCYGUFVAZDUGUUQYHDUUDAYHWOAUFCUU
      KDUUPWPUURYGDWQWRAUDYDUUIUUQAYEYDVDZWSZUUIGDYFUNZULVBUUQUUHUVAGULDEYEWTXA
      UUTYECYFFGDUIFXBUGZLUVBVKAFWKVDUUSOXCUUTGWKVDZGXDVDAUVCUUSQXCGXEVNUUSYEUI
      VDZAUUSYEBUOZUVDYEBXJZXFXGZADFGXHVBVDUUSSXCAUUNUVEYECYFVOUUSUBUUSUVEUVDUV
      FXIBCYEEXKXLZUUTYECXMUVBXNXOYFUVGUVHXPXQXRXSXTYAXTYB $.
  $}

  ${
    $d y z A $.  $d x y z B $.  $d x y z F $.  $d x y z .+ $.  $d x y z ph $.
    $d y z G $.  $d y z H $.
    tsmsadd.b $e |- B = ( Base ` G ) $.
    tsmsadd.p $e |- .+ = ( +g ` G ) $.
    tsmsadd.1 $e |- ( ph -> G e. CMnd ) $.
    tsmsadd.2 $e |- ( ph -> G e. TopMnd ) $.
    tsmsadd.a $e |- ( ph -> A e. V ) $.
    tsmsadd.f $e |- ( ph -> F : A --> B ) $.
    tsmsadd.h $e |- ( ph -> H : A --> B ) $.
    tsmsadd.x $e |- ( ph -> X e. ( G tsums F ) ) $.
    tsmsadd.y $e |- ( ph -> Y e. ( G tsums H ) ) $.
    $( The sum of two infinite group sums.  (Contributed by Mario Carneiro,
       19-Sep-2015.) $)
    tsmsadd $p |- ( ph -> ( X .+ Y ) e. ( G tsums ( F oF .+ H ) ) ) $=
      ( wcel vz vy vx co cpw cfn cin cv cres cgsu cplusf cfv cmpt ctopn wss crn
      crab cfg cflf cof ctsu wceq ctmd ctps tmdtps tsmscl eqid plusfval syl2anc
      syl sseldd ctopon istps sylib cfil tsmsfbas fgcl tsmslem1 tsmsval eleqtrd
      cfbas ccmn ctx ccn cop cuni ccnp tmdcn cxp opelxpi txtopon cncnpi flfcnp2
      toponuni eqeltrrd cmnd wa cmnmnd mndcl 3expb sylan inidm off adantr elfpw
      c0g simprbi adantl wf simplbi fssres syl2an cvv csn cdif fisuppfi gsumadd
      cbs fvex eqeltri a1i syl3anc offres oveq2d 3eqtr4d mpteq2dva fveq2d eqtrd
      fex2 eleqtrrd ) AIJDUDZUABUEUFUGZFEUAUHZUIZUJUDZFGYMUIZUJUDZFUKULZUDZUMZF
      UNULZYLUBYLUBUHZYMUOUAYLUQUMZUPZURUDZUSUDZULZFEGDUTZUDZVAUDZAIJYRUDZYKUUG
      AICTZJCTZUUKYKVBAFEVAUDZCIABCEFHKMAFVCTZFVDTZNFVEVJZOPVFRVKZAFGVAUDZCJABC
      GFHKMUUQOQVFSVKZCDYRFIJKLYRVGZVHVIAUAYOYQIJUUAUUAUUEUUAYRCCYLAUUPUUACVLUL
      TZUUQCUUAFKUUAVGZVMVNZUVDAUUDYLWAULTUUEYLVOULTAUAUBBYLUUCUUDHYLVGZUUCVGUU
      DVGZOVPUUDYLVQVJABCYLEFHYMKUVEMOPVRZABCYLGFHYMKUVEMOQVRZAIUUNUAYLYOUMUUFU
      LRAUAUBBCYLEFUUAUUDWBHKUVCUVEUVFMOPVSVTAJUUSUAYLYQUMUUFULSAUAUBBCYLGFUUAU
      UDWBHKUVCUVEUVFMOQVSVTAYRUUAUUAWCUDZUUAWDUDTZIJWEZUVIWFZTYRUVKUVIUUAWGUDU
      LTAUUOUVJNYRFUUAUVCUVAWHVJAUVKCCWIZUVLAUULUUMUVKUVMTUURUUTIJCCWJVIAUVIUVM
      VLULTZUVMUVLVBAUVBUVBUVNUVDUVDUUAUUACCWKVIUVMUVIWNVJVTUVKYRUVIUUAUVLUVLVG
      WLVIWMWOAUUJUAYLFUUIYMUIZUJUDZUMZUUFULUUGAUAUBBCYLUUIFUUAUUDWBHKUVCUVEUVF
      MOAUCUBBBBDCCCEGHHAFWPTZUCUHZCTZUUBCTZWQUVSUUBDUDCTZAFWBTZUVRMFWRVJUVRUVT
      UWAUWBCDFUVSUUBKLWSWTXAPQOOBXBXCVSAUVQYTUUFAUAYLUVPYSAYMYLTZWQZFYNYPUUHUD
      ZUJUDYOYQDUDZUVPYSUWEYMCDYNFYPUFFXFULZKUWHVGLAUWCUWDMXDUWDYMUFTZAUWDYMBUO
      ZUWIYMBXEZXGXHZABCEXIZUWJYMCYNXIUWDPUWDUWJUWIUWKXJZBCYMEXKXLZABCGXIZUWJYM
      CYPXIUWDQUWNBCYMGXKXLZUWEYMCXMUWHXNXOZYNUWLUWOXPUWEYMCUWRYPUWLUWQXPXQUWEU
      VOUWFFUJAUVOUWFVBZUWDAEXMTZGXMTZUWSAUWMBHTZCXMTZUWTPOUXCACFXRULXMKFXRXSXT
      YAZBCEHXMYIYBAUWPUXBUXCUXAQOUXDBCGHXMYIYBYMDEGXMXMYCVIXDYDUWEYOCTYQCTYSUW
      GVBUVGUVHCDYRFYOYQKLUVAVHVIYEYFYGYHYJ $.
  $}

  ${
    tsmsinv.b $e |- B = ( Base ` G ) $.
    tsmsinv.p $e |- I = ( invg ` G ) $.
    tsmsinv.1 $e |- ( ph -> G e. CMnd ) $.
    tsmsinv.2 $e |- ( ph -> G e. TopGrp ) $.
    tsmsinv.a $e |- ( ph -> A e. V ) $.
    tsmsinv.f $e |- ( ph -> F : A --> B ) $.
    tsmsinv.x $e |- ( ph -> X e. ( G tsums F ) ) $.
    $( Inverse of an infinite group sum.  (Contributed by Mario Carneiro,
       20-Sep-2015.) $)
    tsmsinv $p |- ( ph -> ( I ` X ) e. ( G tsums ( I o. F ) ) ) $=
      ( ctopn cfv wcel syl co eqid ctgp ctps tgptps cghm cmhm cabel cgrp tgpgrp
      ccmn isabl sylanbrc invghm sylib ghmmhm ccn tgpinv tsmsmhm ) ABCFDEEEPQZU
      SGHIUSUAZUTKAEUBRZEUCRLEUDSZKVBAFEEUETRZFEEUFTRAEUGRZVCAEUHRZEUJRVDAVAVEL
      EUISKEUKULCEFIJUMUNEEFUOSAVAFUSUSUPTRLEFUSUTJUQSMNOUR $.
  $}

  ${
    $d k A $.  $d k x B $.  $d k F $.  $d k x G $.  $d k x H $.  $d k ph $.
    $d k .- $.
    tsmssub.b $e |- B = ( Base ` G ) $.
    tsmssub.p $e |- .- = ( -g ` G ) $.
    tsmssub.1 $e |- ( ph -> G e. CMnd ) $.
    tsmssub.2 $e |- ( ph -> G e. TopGrp ) $.
    tsmssub.a $e |- ( ph -> A e. V ) $.
    tsmssub.f $e |- ( ph -> F : A --> B ) $.
    tsmssub.h $e |- ( ph -> H : A --> B ) $.
    tsmssub.x $e |- ( ph -> X e. ( G tsums F ) ) $.
    tsmssub.y $e |- ( ph -> Y e. ( G tsums H ) ) $.
    $( The difference of two infinite group sums.  (Contributed by Mario
       Carneiro, 20-Sep-2015.) $)
    tsmssub $p |- ( ph -> ( X .- Y ) e. ( G tsums ( F oF .- H ) ) ) $=
      ( co vk vx cminusg cfv cplusg ccom cof ctsu eqid ctgp wcel ctmd tgptmd wf
      syl cgrp tgpgrp grpinvf 3syl fco syl2anc tsmsinv tsmsadd wceq ctps tgptps
      tsmscl sseldd grpsubval cmpt ffvelrnda mpteq2dva feqmptd offval2 cvv fvex
      cv wa a1i fveq2 fmptco 3eqtr4d oveq2d 3eltr4d ) AIJEUCUDZUDZEUEUDZTZEDWEF
      UFZWGUGTZUHTIJGTZEDFGUGTZUHTABCWGDEWIHIWFKWGUIZMAEUJUKZEULUKNEUMUOOPACCWE
      UNZBCFUNBCWIUNAWNEUPUKWONEUQCEWEKWEUIZURUSZQBCCWEFUTVARABCFEWEHJKWPMNOQSV
      BVCAICUKJCUKWKWHVDAEDUHTCIABCDEHKMAWNEVEUKNEVFUOZOPVGRVHAEFUHTCJABCFEHKMW
      ROQVGSVHCWGEWEGIJKWMWPLVIVAAWLWJEUHAUABUAVQZDUDZWSFUDZGTZVJUABWTXAWEUDZWG
      TZVJWLWJAUABXBXDAWSBUKVRZWTCUKXACUKXBXDVDABCWSDPVKZABCWSFQVKZCWGEWEGWTXAK
      WMWPLVIVAVLAUABWTXAGDFHCCOXFXGAUABCDPVMZAUABCFQVMZVNAUABWTXCWGDWIHCVOOXFX
      CVOUKXEXAWEVPVSXHAUAUBBCXAUBVQZWEUDXCFWEXGXIAUBCCWEWQVMXJXAWEVTWAVNWBWCWD
      $.
  $}

  ${
    $d k A $.  $d k B $.  $d k x F $.  $d k x G $.  $d x J $.  $d k x ph $.
    $d k V $.  $d x X $.
    tgptsmscls.b $e |- B = ( Base ` G ) $.
    tgptsmscls.j $e |- J = ( TopOpen ` G ) $.
    tgptsmscls.1 $e |- ( ph -> G e. CMnd ) $.
    tgptsmscls.2 $e |- ( ph -> G e. TopGrp ) $.
    tgptsmscls.a $e |- ( ph -> A e. V ) $.
    tgptsmscls.f $e |- ( ph -> F : A --> B ) $.
    ${
      tgptsmscls.x $e |- ( ph -> X e. ( G tsums F ) ) $.
      $( A sum in a topological group is uniquely determined up to a coset of
         ` cls ( { 0 } ) ` , which is a normal subgroup by ~ clsnsg , ~ 0nsg .
         (Contributed by Mario Carneiro, 22-Sep-2015.) $)
      tgptsmscls $p |- ( ph -> ( G tsums F ) = ( ( cls ` J ) ` { X } ) ) $=
        ( vk co cfv wcel adantr vx ctsu csn ccl cv wa c0g cqg cec wbr csubg wer
        ctgp cgrp tgpgrp syl eqid 0subg clssubg syl2anc eqger csg tgptps tsmscl
        ctps sselda sseldd ccmn wf simpr tsmssub cmpt ffvelrnda feqmptd offval2
        cof cgsu wceq grpsubid mpteq2dva eqtrd oveq2d grpidcl fmptd c0 cfn ccnv
        cvv cdif cima wss 0fin eqidd suppss2 ssfi sylancr tsmsgsum cmnmnd gsumz
        cmnd sneqd fveq2d 3eqtrd eleqtrd cabel w3a isabl sylanbrc subgss eqgabl
        wb mpbir3and ersym wrel releqg relelec ax-mp sylibr snclseqg ex tsmscls
        ssrdv eqssd ) AEDUBQZHUCFUDRZRZAUAYDYFAUAUEZYDSZYGYFSAYHUFZYGHEEUGRZUCZ
        YERZUHQZUIZYFYIHYGYMUJZYGYNSZYIYGHYMCYIYLEUKRZSZCYMULYIEUMSZYKYQSZYRAYS
        YHLTZYIEUNSZYTYIYSUUBUUAEUOUPZEYJYJUQZURUPYKEFJUSUTZYMECYLIYMUQZVAUPYIY
        GHYMUJZYGCSZHCSZHYGEVBRZQZYLSZAYDCYGABCDEGIKAYSEVESZLEVCZUPZMNVDZVFAUUI
        YHAYDCHUUPOVGTZYIUUKEDDUUJVPQZUBQZYLYIBCDEDUUJGHYGIUUJUQZAEVHSZYHKTZUUA
        ABGSZYHMTZABCDVIYHNTZUVEAHYDSYHOTAYHVJVKYIUUSEPBYJVLZUBQEUVFVQQZUCZYERY
        LYIUURUVFEUBYIUURPBPUEZDRZUVJUUJQZVLUVFYIPBUVJUVJUUJDDGCCUVDYIBCUVIDUVE
        VMZUVLYIPBCDUVEVNZUVMVOYIPBUVKYJYIUVIBSZUFUUBUVJCSUVKYJVRYIUUBUVNUUCTUV
        LCEUUJUVJYJIUUDUUTVSUTVTWAWBYIBCUVFEFGYJIUUDUVBYIYSUUMUUAUUNUPUVDYIPBYJ
        CUVFYIYJCSZUVNYIUUBUVOUUCCEYJIUUDWCUPTUVFUQWDYIWEWFSUVFWGWHYKWIWJZWEWKU
        VPWFSWLYIBYJPWEYJYIUVIBWEWISUFYJWMWNWEUVPWOWPJWQYIUVHYKYEYIUVGYJYIEWTSZ
        UVCUVGYJVRYIUVAUVQUVBEWRUPUVDBPEGYJUUDWSUTXAXBXCXDYIEXESZYLCWKZUUGUUHUU
        IUULXFXKYIUUBUVAUVRUUCUVBEXGXHYIYRUVSUUECYLEIXIUPYGHYMYLEUUJCIUUTUUFXJU
        TXLXMYMXNYPYOXKYMYLEUUFXOYGHYMXPXQXRYIYSUUIYNYFVRUUAUUQHYMYLEFCYJIJUUDU
        UFYLUQXSUTXDXTYBABCDEFGHIJKUUOMNOYAYC $.
    $}

    $( The set of limit points to an infinite sum in a topological group is
       closed.  (Contributed by Mario Carneiro, 22-Sep-2015.) $)
    tgptsmscld $p |- ( ph -> ( G tsums F ) e. ( Clsd ` J ) ) $=
      ( vx cfv wcel c0 wceq syl adantr ctsu co ccld ctop ctgp tgptopon topontop
      ctopon 0cld eleq1 syl5ibrcom wne cv wex n0 wa csn ccl wf simpr tgptsmscls
      ccmn cuni ctps tgptps tsmscl toponuni sseqtrd sselda snssd clscld syl2anc
      wss eqid eqeltrd ex exlimdv syl5bi pm2.61dne ) AEDUAUBZFUCOZPZVTQAWBVTQRQ
      WAPZAFUDPZWCAFCUHOPZWDAEUEPZWEKEFCIHUFSZCFUGSZFUISVTQWAUJUKVTQULNUMZVTPZN
      UNAWBNVTUOAWJWBNAWJWBAWJUPZVTWIUQZFUROOZWAWKBCDEFGWIHIAEVBPWJJTAWFWJKTABG
      PWJLTABCDUSWJMTAWJUTVAWKWDWLFVCZVMWMWAPAWDWJWHTWKWIWNAVTWNWIAVTCWNABCDEGH
      JAWFEVDPKEVESLMVFAWECWNRWGCFVGSVHVIVJWLFWNWNVNVKVLVOVPVQVRVS $.
  $}

  ${
    $d k .+ $.  $d k A $.  $d k B $.  $d k C $.  $d k D $.  $d k ph $.
    $d k F $.  $d k G $.
    tsmssplit.b $e |- B = ( Base ` G ) $.
    tsmssplit.p $e |- .+ = ( +g ` G ) $.
    tsmssplit.1 $e |- ( ph -> G e. CMnd ) $.
    tsmssplit.2 $e |- ( ph -> G e. TopMnd ) $.
    tsmssplit.a $e |- ( ph -> A e. V ) $.
    tsmssplit.f $e |- ( ph -> F : A --> B ) $.
    tsmssplit.x $e |- ( ph -> X e. ( G tsums ( F |` C ) ) ) $.
    tsmssplit.y $e |- ( ph -> Y e. ( G tsums ( F |` D ) ) ) $.
    tsmssplit.i $e |- ( ph -> ( C i^i D ) = (/) ) $.
    tsmssplit.u $e |- ( ph -> A = ( C u. D ) ) $.
    $( Split a topological group sum into two parts.  (Contributed by Mario
       Carneiro, 19-Sep-2015.) $)
    tsmssplit $p |- ( ph -> ( X .+ Y ) e. ( G tsums F ) ) $=
      ( vk co cv wcel cfv c0g cif cmpt cof ctsu ffvelrnda cmnd ccmn cmnmnd eqid
      syl mndidcl adantr ifcl syl2anc fmptd cres feqmptd reseq1d wss wceq ssun1
      wa cun syl5sseqr iftrue mpteq2ia resmpt 3eqtr4a eqtr4d oveq2d ctmd tmdtps
      ctps wn eldifn adantl iffalse suppss2 tsmsres eqtrd eleqtrd ssun2 tsmsadd
      cdif wi cin noel eleq2 mtbiri elin sylnib imnan sylibr imp oveq12d mndrid
      c0 sylan syldan con2d mndlid eleq2d elun syl6bb biimpa mpjaodan mpteq2dva
      wo eqidd offval2 eleqtrrd ) AJKFUCHUBBUBUDZDUEZXSGUFZHUGUFZUHZUIZUBBXSEUE
      ZYAYBUHZUIZFUJUCZUKUCHGUKUCABCFYDHYGIJKLMNOPAUBBYCCYDAXSBUEZVIZYACUEZYBCU
      EZYCCUEABCXSGQULZAYLYIAHUMUEZYLAHUNUEYNNHUOUQZCHYBLYBUPZURUQUSZXTYAYBCUTV
      AZYDUPVBZAUBBYFCYGYJYKYLYFCUEYMYQYEYAYBCUTVAZYGUPVBZAJHGDVCZUKUCZHYDUKUCZ
      RAUUCHYDDVCZUKUCUUDAUUBUUEHUKAUUBUBBYAUIZDVCZUUEAGUUFDAUBBCGQVDZVEADBVFZU
      UEUUGVGADEVJZDBDEVHUAVKUUIUBDYCUIUBDYAUIUUEUUGUBDYCYAXTYAYBVLZVMUBBDYCVNU
      BBDYAVNVOUQVPVQABCYDHIDYBLYPNAHVRUEHVTUEOHVSUQZPYSABYCUBDYBAXSBDWKUEZVIXT
      WAZYCYBVGZUUMUUNAXSBDWBWCXTYAYBWDZUQWEWFWGWHAKHGEVCZUKUCZHYGUKUCZSAUURHYG
      EVCZUKUCUUSAUUQUUTHUKAUUQUUFEVCZUUTAGUUFEUUHVEAEBVFZUUTUVAVGAUUJEBEDWIUAV
      KUVBUBEYFUIUBEYAUIUUTUVAUBEYFYAYEYAYBVLZVMUBBEYFVNUBBEYAVNVOUQVPVQABCYGHI
      EYBLYPNUULPUUAABYFUBEYBAXSBEWKUEZVIYEWAZYFYBVGZUVDUVEAXSBEWBWCYEYAYBWDZUQ
      WEWFWGWHWJAGYHHUKAGUBBYCYFFUCZUIZYHAGUUFUVIUUHAUBBUVHYAYJXTUVHYAVGYEYJXTV
      IZUVHYAYBFUCZYAUVJYCYAYFYBFXTYCYAVGYJUUKWCUVJUVEUVFYJXTUVEYJXTYEVIZWAXTUV
      EWLYJXSDEWMZUEZUVLAUVNWAZYIAUVMXDVGZUVOTUVPUVNXSXDUEXSWNUVMXDXSWOWPUQUSXS
      DEWQWRXTYEWSWTZXAUVGUQXBYJUVKYAVGZXTAYIYKUVRYMAYNYKUVRYOCFHYAYBLMYPXCXEXF
      USWGYJYEVIZUVHYBYAFUCZYAUVSYCYBYFYAFUVSUUNUUOYJYEUUNYJXTYEUVQXGXAUUPUQYEY
      FYAVGYJUVCWCXBYJUVTYAVGZYEAYIYKUWAYMAYNYKUWAYOCFHYAYBLMYPXHXEXFUSWGAYIXTY
      EXOZAYIXSUUJUEUWBABUUJXSUAXIXSDEXJXKXLXMXNVPAUBBYCYFFYDYGICCPYRYTAYDXPAYG
      XPXQVPVQXR $.
  $}

  ${
    $d g k w y z .0. $.  $d a b c d f g h j k n s t u v w x y z G $.  $d y J $.
    $d b g h k s u v w y z B $.  $d f g j k n x y z D $.  $d f g j n x y z L $.
    $d a b g h j k n s t u v y z A $.  $d c d f g j k n w x y z K $.  $d c S $.
    $d a b d f g h j k n s t u v x y z H $.  $d c d g w x y z N $.  $d c d U $.
    $d d f g j n x y z .- $.  $d b f g h j k n s t u v y z C $.  $d c d g T $.
    $d c d g y .+ $.  $d b c d f g h j k n s t u v w x y z F $.
    $d a b f g h j k n s t u v w y z ph $.
    tsmsxp.b $e |- B = ( Base ` G ) $.
    tsmsxp.g $e |- ( ph -> G e. CMnd ) $.
    tsmsxp.2 $e |- ( ph -> G e. TopGrp ) $.
    tsmsxp.a $e |- ( ph -> A e. V ) $.
    tsmsxp.c $e |- ( ph -> C e. W ) $.
    tsmsxp.f $e |- ( ph -> F : ( A X. C ) --> B ) $.
    tsmsxp.h $e |- ( ph -> H : A --> B ) $.
    tsmsxp.1 $e |- ( ( ph /\ j e. A ) ->
      ( H ` j ) e. ( G tsums ( k e. C |-> ( j F k ) ) ) ) $.
    ${
      tsmsxp.j $e |- J = ( TopOpen ` G ) $.
      tsmsxp.z $e |- .0. = ( 0g ` G ) $.
      tsmsxp.p $e |- .+ = ( +g ` G ) $.
      tsmsxp.m $e |- .- = ( -g ` G ) $.
      tsmsxp.l $e |- ( ph -> L e. J ) $.
      tsmsxp.3 $e |- ( ph -> .0. e. L ) $.
      tsmsxp.k $e |- ( ph -> K e. ( ~P A i^i Fin ) ) $.
      ${
        tsmsxp.ks $e |- ( ph -> dom D C_ K ) $.
        tsmsxp.d $e |- ( ph -> D e. ( ~P ( A X. C ) i^i Fin ) ) $.
        $( Lemma for ~ tsmsxp .  (Contributed by Mario Carneiro,
           21-Sep-2015.) $)
        tsmsxplem1 $p |- ( ph -> E. n e. ( ~P C i^i Fin ) ( ran D C_ n /\
      A. x e. K ( ( H ` x ) .- ( G gsum ( F |` ( { x } X. n ) ) ) ) e. L ) ) $=
          ( vf vz vg vy cpw cfn cin cv wf cfv wss co cmpt cres cgsu crn wcel wi
          wral wa csn cxp wrex wex elfpw simprbi syl simplbi sselda eqid adantr
          ccmn ctps ctgp tgptps fovrn syl3an1 3expa cima df-ima ctopon tgptopon
          fmptd wceq toponss syl2anc resmpt rneqd syl5eq cminusg ccom ffvelrnda
          chmeo grpsubval sylan mpteq2dva tgpgrp grpinvcl grpinvf feqmptd eqidd
          cgrp oveq2 fmptco eqeltrd eqeltrrd syldan ralbidv adantl syl6ss sylib
          cvv ovex sylanbrc a1i adantlr oveq2d eleq1d ad2antrr fisuppfi reseq2d
          3syl weq eqtr4d grpinvhmeo hmeoco hmeoima grpsubid1 elrnmpt1s sylancl
          tgplacthmeo tsmsi ralrimiva sseq1 imbi1d ac6sfi cun frn inss1 sspwuni
          cuni rnss rnxpss unssd wfo wfn ffn dffn4 fofi inss2 rnfi unfi adantrr
          unifi ssun2 wb fvssunirn ssun1 sstri syl5sseqr pm5.5 bitrd rspcv cmnd
          id reseq2 cmnmnd simplr jca cdif gsumcl elsn ovres oveq1 eqtrd gsumsn
          sylanbr syl3anc snfi snssd xpss12 fssres xpfi sylancr gsumxp 3eqtr4rd
          elrnmpti cabel isabl ad3antrrr ablnncan simpr rexlimdva syl5bi sylbid
          syl5ibrcom syld an32s ralimdva impr fveq2 sneq xpeq1d oveq12d cbvralv
          sseq2 xpeq2 anbi12d rspcev syl12anc exlimddv ) AOEVBZVCVDZURVEZVFZHVE
          ZUYKVGZUSVEZVHZLIEUYMIVEZKVIZVJZUYOVKZVLVIZUTPUYMMVGZUTVEZQVIZVJZVMZV
          NZVOZUSUYJVPZHOVPZVQZFVMZJVEZVHZBVEZMVGZLKVUOVRZVUMVSZVKZVLVIZQVIZPVN
          ZBOVPZVQZJUYJVTZURAOVCVNZVAVEZUYOVHZVUGVOZUSUYJVPZVAUYJVTZHOVPVUKURWA
          AOCVBVCVDVNZVVFUOVVLOCVHZVVFOCWBZWCWDZAVVKHOAUYMOVNZUYMCVNZVVKAOCUYMA
          VVLVVMUOVVLVVMVVFVVNWEWDWFZAVVQVQZUSVAEDVUBUYJVUFUYSLNSUAUIUYJWGALWIV
          NZVVQUBWHALWJVNZVVQALWKVNZVWAUCLWLWDWHAESVNVVQUEWHVVSIEUYRDUYSAVVQUYQ
          EVNZUYRDVNZACEVSZDKVFZVVQVWCVWDUFUYMUYQDCEKWMZWNWOUYSWGWTUHVVSUTDVUDV
          JZPWPZVUFNVVSVWIVWHPVKZVMVUFVWHPWQVVSVWJVUEVVSPDVHZVWJVUEXAAVWKVVQAND
          WRVGVNZPNVNZVWKAVWBVWLUCLNDUIUAWSWDUMPNDXBXCZWHUTDPVUDXDWDXEXFVVSVWHN
          NXJVIZVNVWMVWINVNVVSVWHVADVUBVVGGVIZVJZLXGVGZXHZVWOVVSVWHUTDVUBVUCVWR
          VGZGVIZVJVWSVVSUTDVUDVXAVVSVUBDVNZVUCDVNZVUDVXAXAACDUYMMUGXIZDGLVWRQV
          UBVUCUAUKVWRWGZULXKXLXMVVSUTVADDVWTVWPVXAVWRVWQVVSLXSVNZVXCVWTDVNAVXF
          VVQAVWBVXFUCLXNWDZWHZDLVWRVUCUAVXEXOXLVVSUTDDVWRVVSVXFDDVWRVFVXHDLVWR
          UAVXEXPWDXQVVSVWQXRVVGVWTVUBGXTYAUUAVVSVWRVWOVNZVWQVWOVNZVWSVWOVNVVSV
          WBVXIAVWBVVQUCWHZLVWRNUIVXEUUBWDVVSVWBVXBVXJVXKVXDVAVUBGVWQLNDVWQWGUA
          UKUIUUHXCVWRVWQNNNUUCXCYBAVWMVVQUMWHPVWHNNUUDXCYCVVSVUBTQVIZVUBVUFVVS
          VXFVXBVXLVUBXAVXHVXDDLQVUBTUAUJULUUEXCVVSTPVNZVXLYIVNVXLVUFVNAVXMVVQU
          NWHVUBTQYJUTPVUDVXLTVUEYIVUEWGZVUCTVUBQXTUUFUUGYCUUIYDUUJVVJVUIHVAOUY
          JURVVGUYNXAZVVIVUHUSUYJVXOVVHUYPVUGVVGUYNUYOUUKUULYEUUMXCAVUKVQZUYKVM
          ZUURZVULUUNZUYJVNZVULVXSVHZVUPLKVUQVXSVSZVKZVLVIZQVIZPVNZBOVPZVVEAUYL
          VXTVUJAUYLVQZVXSEVHZVXSVCVNZVXTVYHVXRVULEVYHVXQUYIVHVXREVHVYHVXQUYJUY
          IUYLVXQUYJVHAOUYJUYKUUOYFZUYIVCUUPYGVXQEUUQYHAVULEVHUYLAVULVWEVMZEAFV
          WEVBVCVDVNZFVWEVHZVULVYLVHUQVYMVYNFVCVNZFVWEWBZWEFVWEUUSYSCEUUTYGWHUV
          AZVYHVXRVCVNZVULVCVNZVYJVYHVXQVCVNZVXQVCVHVYRVYHVVFOVXQUYKUVBZVYTAVVF
          UYLVVOWHVYHUYKOUVCZWUAUYLWUBAOUYJUYKUVDYFOUYKUVEYHOVXQUYKUVFXCVYHVXQU
          YJVCVYKUYIVCUVGYGVXQUVKXCAVYSUYLAVYMVYOVYSUQVYMVYNVYOVYPWCFUVHYSWHVXR
          VULUVIXCZVXSEWBYKZUVJVYAVXPVULVXRUVLYLVXPVUBLKUYMVRZVXSVSZVKZVLVIZQVI
          ZPVNZHOVPZVYGAUYLVUJWUKVYHVUIWUJHOAVVPUYLVUIWUJVOAVVPVQZUYLVQZVUILUYS
          VXSVKZVLVIZVUFVNZWUJWUMVXTVUIWUPVOAUYLVXTVVPWUDYMVUHWUPUSVXSUYJUYOVXS
          XAZVUHVUGWUPWUQUYPVUHVUGUVMWUQVXSUYNUYOUYNVXRVXSUYKUYMUVNVXRVULUVOUVP
          WUQUWBUVQUYPVUGUVRWDWUQVUAWUOVUFWUQUYTWUNLVLUYOVXSUYSUWCYNYOUVSUVTWDW
          UMWUPWUHVUFVNZWUJWUMWUOWUHVUFWUMLVAWUELIVXSVVGUYQWUGVIZVJZVLVIZVJVLVI
          ZLIVXSUYRVJZVLVIZWUHWUOWUMLUWAVNZVVPWVDDVNWVBWVDXAWUMVVTWVEAVVTVVPUYL
          UBYPZLUWDWDAVVPUYLUWEWUMVXSDWVCLVCTUAUJWVFAUYLVYJVVPWUCYMZWUMIVXSUYRD
          WVCWUMUYQVXSVNZVWCVWDWUMVXSEUYQAUYLVYIVVPVYQYMZWFWULVWCVWDUYLWULVWFVV
          QVQVWCVWDWULVWFVVQAVWFVVPUFWHVVRUWFVWFVVQVWCVWDVWGWOXLYMYDWVCWGWTZWUM
          VXSDYITVRUWGZWVCWVGWVJYQUWHWVADWVDVALUYMOUAVAHYTZWUTWVCLVLWVLIVXSWUSU
          YRWVLWVHVQWUSVVGUYQKVIZUYRWVLVVGWUEVNWVHWUSWVMXAVAUYMUWIVVGUYQWUEVXSK
          UWJUWNWVLWVMUYRXAWVHVVGUYMUYQKUWKWHUWLXMYNUWMUWOWUMWUEDVXSVAIWUGLVCVC
          TUAUJWVFWUEVCVNZWUMUYMUWPZYLWVGWUMVWFWUFVWEVHZWUFDWUGVFAVWFVVPUYLUFYP
          WUMWUECVHVYIWVPWUMUYMCWULVVQUYLVVRWHUWQWVIWUECVXSEUWRXCVWEDWUFKUWSXCZ
          WUMWUFDWVKWUGWUMWVNVYJWUFVCVNWVOWVGWUEVXSUWTUXAWVQYQUXBWUMWUNWVCLVLWU
          MVYIWUNWVCXAWVIIEVXSUYRXDWDYNUXCYOWURWUHVUDXAZUTPVTWUMWUJUTPVUDWUHVUE
          VXNVUBVUCQYJUXDWUMWVRWUJUTPWUMVUCPVNZVQZWUJWVRVUBVUDQVIZPVNWVTWWAVUCP
          WVTDLQVUBVUCUAULALUXEVNZVVPUYLWVSAVXFVVTWWBVXGUBLUXFYKUXGWULVXBUYLWVS
          AVVPVVQVXBVVRVXDYDYPWUMPDVUCAVWKVVPUYLVWNYPWFUXHWUMWVSUXIYBWVRWUIWWAP
          WUHVUDVUBQXTYOUXMUXJUXKUXLUXNUXOUXPUXQWUJVYFHBOHBYTZWUIVYEPWWCVUBVUPW
          UHVYDQUYMVUOMUXRWWCWUGVYCLVLWWCWUFVYBKWWCWUEVUQVXSUYMVUOUXSUXTYRYNUYA
          YOUYBYHVVDVYAVYGVQJVXSUYJVUMVXSXAZVUNVYAVVCVYGVUMVXSVULUYCWWDVVBVYFBO
          WWDVVAVYEPWWDVUTVYDVUPQWWDVUSVYCLVLWWDVURVYBKVUMVXSVUQUYDYRYNYNYOYEUY
          EUYFUYGUYH $.
      $}

      tsmsxp.4 $e |- ( ph -> A. c e. S A. d e. T ( c .+ d ) e. U ) $.
      tsmsxp.n $e |- ( ph -> N e. ( ~P C i^i Fin ) ) $.
      tsmsxp.s $e |- ( ph -> D C_ ( K X. N ) ) $.
      tsmsxp.x $e |- ( ph -> A. x e. K
        ( ( H ` x ) .- ( G gsum ( F |` ( { x } X. N ) ) ) ) e. L ) $.
      tsmsxp.5 $e |- ( ph -> ( G gsum ( F |` ( K X. N ) ) ) e. S ) $.
      tsmsxp.6 $e |- ( ph -> A. g e. ( L ^m K ) ( G gsum g ) e. T ) $.
      $( Lemma for ~ tsmsxp .  (Contributed by Mario Carneiro, 21-Sep-2015.) $)
      tsmsxplem2 $p |- ( ph -> ( G gsum ( H |` K ) ) e. U ) $=
        ( vy vz vw cxp cres cgsu co cabel wcel wceq cgrp ccmn ctgp tgpgrp isabl
        syl sylanbrc cfn cpw cin wss simprbi xpfi syl2anc simplbi xpss12 fssres
        elfpw cvv csn cdif fisuppfi gsumcl ablpncan3 syl12anc wral cfv cmpt cof
        wf cv adantr snfi sylancr sselda snssd eqid fmptd gsumsub fvex a1i ovex
        wa feqresmpt eqidd offval2 oveq2d cmnd cmnmnd simpr fovrnd elsn sylanbr
        weq ovres oveq1 eqtrd mpteq2dva gsumsn gsumxp eleq1d oveq2 eqeltrrd wb
        syl3anc adantll 3eqtr4d eqtr4d 3eqtr3d cmap sneq xpeq1d reseq2d oveq12d
        fveq2 rspccva sylan elmapg mpbird rspcv sylc rspc2va syl21anc ) AONRUAV
        KZVLZVMVNZOPRVLZVMVNZUVCTVNZGVNZUVEJAOVOVPZUVCDVPUVEDVPUVGUVEVQAOVRVPZO
        VSVPZUVHAOVTVPUVIUIOWAWCUHOWBWDZAUVADUVBOWEUDUGUPUHARWEVPZUAWEVPZUVAWEV
        PARCWFWEWGVPZUVLVAUVNRCWHZUVLRCWOZWIWCZAUAEWFWEWGVPZUVMVCUVRUAEWHZUVMUA
        EWOZWIWCZRUAWJWKZACEVKZDNXGZUVAUWCWHZUVADUVBXGULAUVOUVSUWEAUVNUVOVAUVNU
        VOUVLUVPWLWCZAUVRUVSVCUVRUVSUVMUVTWLWCZRCUAEWMWKUWCDUVANWNWKZAUVADWPUDW
        QWRZUVBUWBUWHWSZWTARDUVDOWEUDUGUPUHUVQACDPXGUVORDUVDXGUMUWFCDRPWNWKZARD
        UWIUVDUVQUWKWSZWTDGOTUVCUVEUGUQURXAXBAUVCHVPUVFIVPUEXHZUFXHZGVNZJVPZUFI
        XCUEHXCUVGJVPZVFAOVHRVHXHZPXDZONUWRWQZUAVKZVLZVMVNZTVNZXEZVMVNZUVFIAOUV
        DVHRUXCXEZTXFVNZVMVNUVEOUXGVMVNZTVNUXFUVFARDUVDOUXGTWEUDUGUPURUVKUVQUWK
        AVHRUXCDUXGAUWRRVPZXTZUXADUXBOWEUDUGUPAUVJUXJUHXIZUXKUWTWEVPZUVMUXAWEVP
        UWRXJZAUVMUXJUWAXIZUWTUAWJXKZUXKUWDUXAUWCWHZUXADUXBXGAUWDUXJULXIZUXKUWT
        CWHUVSUXQUXKUWRCARCUWRUWFXLZXMAUVSUXJUWGXIZUWTCUAEWMWKUWCDUXANWNWKZUXKU
        XADUWIUXBUXPUYAWSZWTUXGXNXOZUWLARDUWIUXGUVQUYCWSXPAUXHUXEOVMAVHRUWSUXCT
        UVDUXGWEWPWPUVQUWSWPVPUXKUWRPXQXRUXCWPVPUXKOUXBVMXSXRAVHCDRPUMUWFYAAUXG
        YBYCYDAUXIUVCUVETAUXIOVHROVIUAUWRVIXHZUVBVNZXEZVMVNZXEZVMVNUVCAUXGUYHOV
        MAVHRUXCUYGUXKOVJUWTOVIUAVJXHZUYDUXBVNZXEZVMVNZXEVMVNZOVIUAUWRUYDNVNZXE
        ZVMVNZUXCUYGUXKOYEVPZUXJUYPDVPUYMUYPVQUXKUVJUYQUXLOYFWCAUXJYGUXKUADUYOO
        WEUDUGUPUXLUXOUXKVIUAUYNDUYOUXKUYDUAVPZXTUWRUYDDCENUXKUWDUYRUXRXIUXKUWR
        CVPUYRUXSXIUXKUAEUYDUXTXLYHUYOXNXOZUXKUADUWIUYOUXOUYSWSWTUYLDUYPVJOUWRR
        UGVJVHYKZUYKUYOOVMUYTVIUAUYJUYNUYTUYRXTUYJUYIUYDNVNZUYNUYTUYIUWTVPUYRUY
        JVUAVQVJUWRYIUYIUYDUWTUANYLYJUYTVUAUYNVQUYRUYIUWRUYDNYMXIYNYOYDYPUUBUXK
        UWTDUAVJVIUXBOWEWEUDUGUPUXLUXMUXKUXNXRUXOUYAUYBYQUXKUYFUYOOVMUXKVIUAUYE
        UYNUXJUYRUYEUYNVQAUWRUYDRUANYLUUCYOYDUUDYOYDARDUAVHVIUVBOWEWEUDUGUPUHUV
        QUWAUWHUWJYQUUEYDUUFAUXESRUUGVNZVPZOKXHZVMVNZIVPZKVUBXCUXFIVPZAVUCRSUXE
        XGZAVHRUXDSUXEABXHZPXDZONVUIWQZUAVKZVLZVMVNZTVNZSVPZBRXCUXJUXDSVPZVEVUP
        VUQBUWRRBVHYKZVUOUXDSVURVUJUWSVUNUXCTVUIUWRPUULVURVUMUXBOVMVURVULUXANVU
        RVUKUWTUAVUIUWRUUHUUIUUJYDUUKYRUUMUUNUXEXNXOASQVPUVLVUCVUHUUAUSUVQSRUXE
        QWEUUOWKUUPVGVUFVUGKUXEVUBVUDUXEVQVUEUXFIVUDUXEOVMYSYRUUQUURYTVBUWPUWQU
        VCUWNGVNZJVPUEUFUVCUVFHIUWMUVCVQUWOVUSJUWMUVCUWNGYMYRUWNUVFVQVUSUVGJUWN
        UVFUVCGYSYRUUSUUTYT $.
    $}

    $d x ph $.
    $( Write a sum over a two-dimensional region as a double sum.  This
       infinite group sum version of ~ gsumxp is also known as Fubini's
       theorem.  The converse is not necessarily true without additional
       assumptions.  See ~ tsmsxplem1 for the main proof; this part mostly sets
       up the local assumptions.  (Contributed by Mario Carneiro,
       21-Sep-2015.) $)
    tsmsxp $p |- ( ph -> ( G tsums F ) C_ ( G tsums H ) ) $=
      ( wcel vx vv vy vz vu va vb vt vc vd vs vg vn vh ctsu co cv wss cres cgsu
      wi cxp cpw cfn cin wral wrex ctopn cfv wa w3a c0g cplusg ctmd ctgp tgptmd
      syl 3ad2ant1 simp2 ctopon eqid tmdtopon toponss syl2anc simp3 sseldd cmnd
      tmdmnd mndidcl mndrid eqeltrd tmdcn2 syl23anc r19.29 simp31 elfpw simplbi
      wceq cdm ad2antrl dmss dmxpss simprbi dmfi sylanbrc cmap cmg ccmn simpl11
      syl6ss simprrl simpl2r chash cn0 hashcl mulgnn0z simpl32 tmdgsum2 crn csn
      csg wf sylan simp3rl simp2rl simp2rr simp2ll 3adant3 3adant3r wrel xpss12
      simprd eleq1d rexlimddv anassrs 3expia rexlimdva com23 cvv eltsms simp111
      cmpt simp3l tsmsxplem1 simp3ll simp133 simp3rr relxp relss ee10 relssdmrn
      simpld sylan9ss syl12anc xpfi anim12i syl2anb sylibr simp2lr sseq2 reseq2
      an4s oveq2d imbi12d rspcv syl3c simp3lr oveq2 sylib tsmsxplem2 3exp exp4a
      cbvralv 3imp1 3expa expr ralrimiva sseq1 imbi1d ralbidv rspcev rexlimdvaa
      embantd imp3a syl5 mpan2d ralrimdva anim2d tgptps xpexg 3imtr4d ssrdv
      ctps ) AUAHGUOUPZHIUOUPZAUAUQZCTZUWPUBUQZTZUCUQZUDUQZURZHGUXAUSZUTUPZUWRT
      ZVAZUDBDVBZVCVDVEZVFZUCUXHVGZVAZUBHVHVIZVFZVJUWQUWPUEUQZTZUFUQZUGUQZURZHI
      UXQUSUTUPUXNTZVAZUGBVCVDVEZVFZUFUYAVGZVAZUEUXLVFZVJUWPUWNTUWPUWOTAUXMUYEU
      WQAUXMUYDUEUXLAUXNUXLTZVJUXOUXMUYCAUYFUXOUXMUYCVAAUYFUXOVKZUXMUWSHVLVIZUH
      UQZTZUIUQUJUQHVMVIZUPUXNTUJUYIVFUIUWRVFZVKZUHUXLVGZUBUXLVGZUYCUYGHVNTZUYF
      UWQUYHCTZUWPUYHUYKUPZUXNTUYOAUYFUYPUXOAHVOTZUYPNHVPVQZVRZAUYFUXOVSZUYGUXN
      CUWPUYGUXLCVTVITZUYFUXNCURUYGUYPVUCVUAHUXLCUXLWAZLWBVQVUBUXNUXLCWCWDAUYFU
      XOWEZWFZUYGHWGTZUYQUYGUYPVUGVUAHWHZVQZCHUYHLUYHWAZWIZVQUYGUYRUWPUXNUYGVUG
      UWQUYRUWPWRVUIVUFCUYKHUWPUYHLUYKWAZVUJWJWDVUEWKUIUJUHUBCUYKUXNHUXLUWPUYHL
      VUDVULWLWMUXMUYOVJUXKUYNVJZUBUXLVGUYGUYCUXKUYNUBUXLWNUYGVUMUYCUBUXLUYGUWR
      UXLTZVJZUXKUYNUYCVUOUYNUXKUYCVUOUYMUXKUYCVAZUHUXLUYGVUNUYIUXLTZUYMVUPVAUY
      GVUNVUQVJZUYMVUPUYGVURUYMVKZUWSUXJUYCUYGVURUWSUYJUYLWOVUSUXIUYCUCUXHVUSUW
      TUXHTZUXIVJZVJZUWTWSZUYATZVVCUXQURZUXSVAZUGUYAVFZUYCVVBVVCBURVVCVDTZVVDVV
      BVVCUXGWSZBVVBUWTUXGURZVVCVVIURVUTVVJVUSUXIVUTVVJUWTVDTZUWTUXGWPZWQZWTUWT
      UXGXAVQBDXBXJVVBVVKVVHVUTVVKVUSUXIVUTVVJVVKVVLXCWTUWTXDVQVVCBWPXEVVBVVFUG
      UYAVVBUXQUYATZVVEUXSVUSVVAVVNVVEVJZUXSVUSVVAVVOVJZVJZUYHUKUQZTZHULUQZUTUP
      ZUYITZULVVRUXQXFUPZVFZVJZUXSUKUXLVVQUKUXQCHXGVIZUYIULHUXLUYHVUDLVWFWAZVVQ
      AHXHTZAUYFUXOVURUYMVVPXIZMVQZVVQAUYPVWIUYTVQZVVQVVNUXQVDTZVUSVVAVVNVVEXKV
      VNUXQBURZVWLUXQBWPZXCVQZVUNVUQUYGUYMVVPXLVVQVUGUYQVVQUYPVUGVWKVUHVQZVUKVQ
      VVQUXQXMVIZUYHVWFUPZUYHUYIVVQVUGVWQXNTZVWRUYHWRVWPVVQVWLVWSVWOUXQXOVQCVWF
      HVWQUYHLVWGVUJXPWDUWSUYJUYLUYGVURVVPXQWKXRVUSVVPVVRUXLTZVWEVJZUXSVUSVVPVX
      AVKZUWTXSZUMUQZURZUWPIVIHGUWPXTVXDVBUSUTUPHYAVIZUPVVRTUAUXQVFZVJZUXSUMDVC
      VDVEZVXBUABCDUWTUYKEFUMGHIUXLUXQVVRVXFJKUYHLVXBAVWHAUYFUXOVURUYMVVPVXAUUA
      ZMVQVXBAUYSVXJNVQZVXBABJTZVXJOVQZVXBADKTZVXJPVQZVXBAUXGCGYBZVXJQVQZVXBABC
      IYBZVXJRVQZVXBAEUQZBTZVXTIVIHFDVXTFUQGUPUUBUOUPTZVXJSYCVUDVUJVULVXFWAZVUS
      VVPVWTVWEUUCVVSVWDVWTVUSVVPYDZVVNVVEVVAVUSVXAYEVVNVVEVVAVUSVXAYFVUTUXIVVO
      VUSVXAYGUUDVUSVVPVXAVXDVXITZVXHVJZUXSVUSVVPVXAVYFUXSVUSVVPVXAVYFVJZUXSVUS
      VVPVYGVKZUABCDUWTUYKUWRUYIUXNUNEFGHIUXLUXQVVRVXFVXDJKUYHUIUJLVUSVVPVWHVYG
      VWJYHVUSVVPVXAUYSVYFVXKYIVUSVVPVXAVXLVYFVXMYIVUSVVPVXAVXNVYFVXOYIVUSVVPVX
      AVXPVYFVXQYIVUSVVPVXAVXRVYFVXSYIVYHAVYAVYBVUSVVPAVYGVWIYHSYCVUDVUJVULVYCV
      WTVWEVYFVUSVVPUUEVUSVVPVXAVVSVYFVYDYIVVNVVEVVAVUSVYGYEZUWSUYJUYLUYGVURVVP
      VYGUUFVYEVXHVXAVUSVVPYDZVYHVUTVVEVXEUWTUXQVXDVBZURZVUTUXIVVOVUSVYGYGVVNVV
      EVVAVUSVYGYFVYHVXEVXGVYEVXHVXAVUSVVPUUGZUULVUTVVEVXEVJUWTVVCVXCVBZVYKVUTU
      WTYJZUWTVYNURVUTVVJUXGYJVYOVVMBDUUHUWTUXGUUIUUJUWTUUKVQVVCUXQVXCVXDYKUUMU
      UNZVYHVXEVXGVYMYLVYHVYKUXHTZUXIVYLHGVYKUSZUTUPZUWRTZVYHVVNVYEVYQVYIVYJVVN
      VYEVJVYKUXGURZVYKVDTZVJZVYQVVNVWMVWLVJVXDDURZVXDVDTZVJWUCVYEVWNVXDDWPVWMW
      UDVWLWUEWUCVWMWUDVJWUAVWLWUEVJWUBUXQBVXDDYKUXQVXDUUOUUPUVBUUQVYKUXGWPUURW
      DVUTUXIVVOVUSVYGUUSVYPUXFVYLVYTVAUDVYKUXHUXAVYKWRZUXBVYLUXEVYTUXAVYKUWTUU
      TWUFUXDVYSUWRWUFUXCVYRHUTUXAVYKGUVAUVCYMUVDUVEUVFVYHVWDHUNUQZUTUPZUYITZUN
      VWCVFVYHVVSVWDVWTVWEVYFVUSVVPUVGYLVWBWUIULUNVWCVVTWUGWRVWAWUHUYIVVTWUGHUT
      UVHYMUVMUVIUVJUVKUVLUVNYNUVOYNYOUVPUVQUYBVVGUFVVCUYAUXPVVCWRZUXTVVFUGUYAW
      UJUXRVVEUXSUXPVVCUXQUVRUVSUVTUWAWDUWBUWCYPYOYQYRUWDYQUWEUWFYPYRUWGUWHAUDU
      CUBUXGCUWPUXHGHUXLYSLVUDUXHWAMAUYSHUWMTNHUWIVQZAVXLVXNUXGYSTOPBDJKUWJWDQY
      TAUGUFUEBCUWPUYAIHUXLJLVUDUYAWAMWUKORYTUWKUWL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Topological rings, fields, vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c TopRing $. $( Topological ring $)
  $c TopDRing $. $( Topological division ring $)
  $c TopMod $. $( Topological module $)
  $c TopVec $. $( Topologcal vector space $)

  $( The class of all topological division rings. $)
  ctrg $a class TopRing $.

  $( The class of all topological division rings. $)
  ctdrg $a class TopDRing $.

  $( The class of all topological modules. $)
  ctlm $a class TopMod $.

  $( The class of all topological vector spaces. $)
  ctvc $a class TopVec $.

  $( Define a topological ring, which is a ring such that the addition is a
     topological group operation and the multiplication is continuous.
     (Contributed by Mario Carneiro, 5-Oct-2015.) $)
  df-trg $a |- TopRing = { r e. ( TopGrp i^i Ring ) |
    ( mulGrp ` r ) e. TopMnd } $.

  $( Define a topological division ring (which differs from a topological field
     only in being potentially noncommutative), which is a division ring and
     topological ring such that the unit group of the division ring (which is
     the set of nonzero elements) is a topological group.  (Contributed by
     Mario Carneiro, 5-Oct-2015.) $)
  df-tdrg $a |- TopDRing = { r e. ( TopRing i^i DivRing ) |
    ( ( mulGrp ` r ) |`s ( Unit ` r ) ) e. TopGrp } $.

  $( Define a topological left module, which is just what its name suggests:
     instead of a group over a ring with a scalar product connecting them, it
     is a topological group over a topological ring with a continuous scalar
     product.  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
  df-tlm $a |- TopMod = { w e. ( TopMnd i^i LMod ) |
    ( ( Scalar ` w ) e. TopRing /\
      ( .sf ` w ) e. ( ( ( TopOpen ` ( Scalar ` w ) ) tX
                         ( TopOpen ` w ) ) Cn ( TopOpen ` w ) ) ) } $.

  $( Define a topological left vector space, which is a topological module over
     a topological division ring.  (Contributed by Mario Carneiro,
     5-Oct-2015.) $)
  df-tvc $a |- TopVec = { w e. TopMod | ( Scalar ` w ) e. TopDRing } $.

  ${
    $d r M $.  $d r R $.  $d r U $.
    istrg.1 $e |- M = ( mulGrp ` R ) $.
    $( Express the predicate " ` R ` is a topological ring".  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    istrg $p |- ( R e. TopRing <->
      ( R e. TopGrp /\ R e. Ring /\ M e. TopMnd ) ) $=
      ( vr ctgp crg cin wcel ctmd wa ctrg w3a elin anbi1i cmgp cfv wceq syl6eqr
      cv fveq2 eleq1d df-trg elrab2 df-3an 3bitr4i ) AEFGZHZBIHZJAEHZAFHZJZUHJA
      KHUIUJUHLUGUKUHAEFMNDSZOPZIHUHDAUFKULAQZUMBIUNUMAOPBULAOTCRUADUBUCUIUJUHU
      DUE $.

    $( The multiplicative monoid of a topological ring is a topological
       monoid.  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    trgtmd $p |- ( R e. TopRing -> M e. TopMnd ) $=
      ( ctrg wcel ctgp crg ctmd istrg simp3bi ) ADEAFEAGEBHEABCIJ $.

    istdrg.1 $e |- U = ( Unit ` R ) $.
    $( Express the predicate " ` R ` is a topological ring".  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    istdrg $p |- ( R e. TopDRing <->
      ( R e. TopRing /\ R e. DivRing /\ ( M |`s U ) e. TopGrp ) ) $=
      ( vr ctrg cdr cin wcel cress co ctgp wa ctdrg cmgp cfv cui fveq2 syl6eqr
      w3a elin anbi1i cv wceq oveq12d eleq1d df-tdrg elrab2 df-3an 3bitr4i ) AG
      HIZJZCBKLZMJZNAGJZAHJZNZUONAOJUPUQUOUAUMURUOAGHUBUCFUDZPQZUSRQZKLZMJUOFAU
      LOUSAUEZVBUNMVCUTCVABKVCUTAPQCUSAPSDTVCVAARQBUSARSETUFUGFUHUIUPUQUOUJUK
      $.

    $( The unit group of a topological division ring is a topological group.
       (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    tdrgunit $p |- ( R e. TopDRing -> ( M |`s U ) e. TopGrp ) $=
      ( ctdrg wcel ctrg cdr cress co ctgp istdrg simp3bi ) AFGAHGAIGCBJKLGABCDE
      MN $.
  $}

  $( A topological ring is a topological group.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  trgtgp $p |- ( R e. TopRing -> R e. TopGrp ) $=
    ( ctrg wcel ctgp crg cmgp cfv ctmd eqid istrg simp1bi ) ABCADCAECAFGZHCALLI
    JK $.

  $( A topological ring is a topological monoid.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  trgtmd2 $p |- ( R e. TopRing -> R e. TopMnd ) $=
    ( ctrg wcel ctgp ctmd trgtgp tgptmd syl ) ABCADCAECAFAGH $.

  $( A topological ring is a topological space.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  trgtps $p |- ( R e. TopRing -> R e. TopSp ) $=
    ( ctrg wcel ctgp ctps trgtgp tgptps syl ) ABCADCAECAFAGH $.

  $( A topological ring is a ring.  (Contributed by Mario Carneiro,
     5-Oct-2015.) $)
  trgrng $p |- ( R e. TopRing -> R e. Ring ) $=
    ( ctrg wcel ctgp crg cmgp cfv ctmd eqid istrg simp2bi ) ABCADCAECAFGZHCALLI
    JK $.

  $( A topological ring is a group.  (Contributed by Mario Carneiro,
     5-Oct-2015.) $)
  trggrp $p |- ( R e. TopRing -> R e. Grp ) $=
    ( ctrg wcel crg cgrp trgrng rnggrp syl ) ABCADCAECAFAGH $.

  $( A topological division ring is a topological ring.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tdrgtrg $p |- ( R e. TopDRing -> R e. TopRing ) $=
    ( ctdrg wcel ctrg cdr cmgp cfv cui cress co ctgp eqid istdrg simp1bi ) ABCA
    DCAECAFGZAHGZIJKCAPOOLPLMN $.

  $( A topological division ring is a division ring.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tdrgdrng $p |- ( R e. TopDRing -> R e. DivRing ) $=
    ( ctdrg wcel ctrg cdr cmgp cfv cui cress co ctgp eqid istdrg simp2bi ) ABCA
    DCAECAFGZAHGZIJKCAPOOLPLMN $.

  $( A topological division ring is a ring.  (Contributed by Mario Carneiro,
     5-Oct-2015.) $)
  tdrgrng $p |- ( R e. TopDRing -> R e. Ring ) $=
    ( ctdrg wcel ctrg crg tdrgtrg trgrng syl ) ABCADCAECAFAGH $.

  $( A topological division ring is a topological monoid.  (Contributed by
     Mario Carneiro, 5-Oct-2015.) $)
  tdrgtmd $p |- ( R e. TopDRing -> R e. TopMnd ) $=
    ( ctdrg wcel ctrg ctmd tdrgtrg trgtmd2 syl ) ABCADCAECAFAGH $.

  $( A topological division ring is a topological space.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tdrgtps $p |- ( R e. TopDRing -> R e. TopSp ) $=
    ( ctdrg wcel ctrg ctps tdrgtrg trgtps syl ) ABCADCAECAFAGH $.

  ${
    istdrg2.m $e |- M = ( mulGrp ` R ) $.
    istdrg2.b $e |- B = ( Base ` R ) $.
    istdrg2.z $e |- .0. = ( 0g ` R ) $.
    $( A topological-ring division ring is a topological division ring iff the
       group of nonzero elements is a topological group.  (Contributed by Mario
       Carneiro, 5-Oct-2015.) $)
    istdrg2 $p |- ( R e. TopDRing <-> ( R e. TopRing /\ R e. DivRing /\
      ( M |`s ( B \ { .0. } ) ) e. TopGrp ) ) $=
      ( ctdrg wcel ctrg cdr cui cfv cress co ctgp w3a csn wa df-3an cdif istdrg
      eqid wceq crg isdrng simprbi adantl oveq2d eleq1d pm5.32i 3bitr4i bitri )
      BHIBJIZBKIZCBLMZNOZPIZQZUNUOCADRUAZNOZPIZQZBUPCEUPUCZUBUNUOSZURSVEVBSUSVC
      VEURVBVEUQVAPVEUPUTCNUOUPUTUDZUNUOBUEIVFABUPDFVDGUFUGUHUIUJUKUNUOURTUNUOV
      BTULUM $.
  $}

  ${
    mulrcn.j $e |- J = ( TopOpen ` R ) $.
    ${
      mulrcn.t $e |- T = ( +f ` ( mulGrp ` R ) ) $.
      $( The functionalization of the ring multiplication operation is a
         continuous function in a topological ring.  (Contributed by Mario
         Carneiro, 5-Oct-2015.) $)
      mulrcn $p |- ( R e. TopRing -> T e. ( ( J tX J ) Cn J ) ) $=
        ( ctrg wcel cmgp cfv ctmd ctx co ccn eqid trgtmd mgptopn tmdcn syl ) AF
        GAHIZJGBCCKLCMLGASSNZOBSCACSTDPEQR $.
    $}

    ${
      invrcn.i $e |- I = ( invr ` R ) $.
      invrcn.u $e |- U = ( Unit ` R ) $.
      $( The multiplicative inverse function is a continuous function from the
         unit group (that is, the nonzero numbers) to itself.  (Contributed by
         Mario Carneiro, 5-Oct-2015.) $)
      invrcn2 $p |- ( R e. TopDRing -> I e. ( ( J |`t U ) Cn ( J |`t U ) ) ) $=
        ( ctdrg wcel cmgp cfv cress co ctgp crest ccn tdrgunit mgptopn resstopn
        eqid invrfval tgpinv syl ) AHIAJKZBLMZNICDBOMZUFPMIABUDUDTZGQUECUFBUEDU
        DUETZADUDUGERSABUECGUHFUAUBUC $.

      $( The multiplicative inverse function is a continuous function from the
         unit group (that is, the nonzero numbers) to the field.  (Contributed
         by Mario Carneiro, 5-Oct-2015.) $)
      invrcn $p |- ( R e. TopDRing -> I e. ( ( J |`t U ) Cn J ) ) $=
        ( ctdrg wcel crest co ccn ctps ctop wss tdrgtps tpstop cnrest2r invrcn2
        3syl sseldd ) AHIZDBJKZUCLKZUCDLKZCUBAMIDNIUDUEOAPDAEQBUCDRTABCDEFGSUA
        $.
    $}

    $d x y J $.  $d x K $.  $d x y ph $.  $d x y R $.  $d x y X $.  $d x y Y $.
    cnmpt1mulr.t $e |- .x. = ( .r ` R ) $.
    cnmpt1mulr.r $e |- ( ph -> R e. TopRing ) $.
    cnmpt1mulr.k $e |- ( ph -> K e. ( TopOn ` X ) ) $.
    ${
      cnmpt1mulr.a $e |- ( ph -> ( x e. X |-> A ) e. ( K Cn J ) ) $.
      cnmpt1mulr.b $e |- ( ph -> ( x e. X |-> B ) e. ( K Cn J ) ) $.
      $( Continuity of ring multiplication; analogue of ~ cnmpt12f which cannot
         be used directly because ` .r ` is not a function.  (Contributed by
         Mario Carneiro, 5-Oct-2015.) $)
      cnmpt1mulr $p |- ( ph -> ( x e. X |-> ( A .x. B ) ) e. ( K Cn J ) ) $=
        ( cmgp cfv eqid mgptopn wcel mgpplusg ctrg ctmd trgtmd syl cnmpt1plusg
        ) ABCDFEPQZGHIEGUGUGRZJSEFUGUHKUAAEUBTUGUCTLEUGUHUDUEMNOUF $.
    $}

    cnmpt2mulr.l $e |- ( ph -> L e. ( TopOn ` Y ) ) $.
    cnmpt2mulr.a $e |- ( ph -> ( x e. X , y e. Y |-> A ) e.
                                ( ( K tX L ) Cn J ) ) $.
    cnmpt2mulr.b $e |- ( ph -> ( x e. X , y e. Y |-> B ) e.
                                ( ( K tX L ) Cn J ) ) $.
    $( Continuity of ring multiplication; analogue of ~ cnmpt22f which cannot
       be used directly because ` .r ` is not a function.  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    cnmpt2mulr $p |- ( ph ->
        ( x e. X , y e. Y |-> ( A .x. B ) ) e. ( ( K tX L ) Cn J ) ) $=
      ( wcel cmgp cfv eqid mgptopn mgpplusg ctrg ctmd trgtmd syl cnmpt2plusg )
      ABCDEGFUAUBZHIJKLFHUKUKUCZMUDFGUKULNUEAFUFTUKUGTOFUKULUHUIPQRSUJ $.
  $}

  ${
    $d x y J $.  $d x y R $.  $d x y U $.
    dvrcn.j $e |- J = ( TopOpen ` R ) $.
    dvrcn.d $e |- ./ = ( /r ` R ) $.
    dvrcn.u $e |- U = ( Unit ` R ) $.
    $( The division function is continuous in a topological field.
       (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    dvrcn $p |- ( R e. TopDRing -> ./ e. ( ( J tX ( J |`t U ) ) Cn J ) ) $=
      ( vx vy ctdrg wcel cbs cfv cv cinvr cmulr co cmpt2 eqid ctopon crest ctps
      ctx ccn dvrfval tdrgtrg tdrgtps istps sylib wss unitss resttopon cnmpt1st
      sylancl cnmpt2nd invrcn cnmpt21f cnmpt2mulr syl5eqel ) BJKZAHIBLMZCHNZINZ
      BOMZMZBPMZQRDDCUAQZUCQDUDQHIVAABVFCVDVASZVFSZGVDSZFUEUTHIVBVEBVFDDVGVACEV
      IBUFUTBUBKDVATMKZBUGVADBVHEUHUIZUTVKCVAUJVGCTMKVLVABCVHGUKCDVAULUNZUTHIDV
      GVACVLVMUMUTHIVCVDDVGVGDVACVLVMUTHIDVGVACVLVMUOBCVDDEVJGUPUQURUS $.
  $}

  ${
    $d w F $.  $d w J $.  $d w K $.  $d w .x. $.  $d w W $.
    istlm.s $e |- .x. = ( .sf ` W ) $.
    istlm.j $e |- J = ( TopOpen ` W ) $.
    istlm.f $e |- F = ( Scalar ` W ) $.
    istlm.k $e |- K = ( TopOpen ` F ) $.
    $( The predicate " ` W ` is a topological left module".  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    istlm $p |- ( W e. TopMod <-> ( ( W e. TopMnd /\ W e. LMod /\
      F e. TopRing ) /\ .x. e. ( ( K tX J ) Cn J ) ) ) $=
      ( vw ctmd clmod wcel ctrg wa ctx co cfv ctopn syl6eqr cin ccn ctlm df-3an
      w3a anass elin anbi1i bitr4i csca cscaf wceq fveq2 eleq1d oveq12d eleq12d
      cv fveq2d anbi12d df-tlm elrab2 3bitr4ri ) EKLUAZMZBNMZOZADCPQZCUBQZMZOVD
      VEVIOZOEKMZELMZVEUEZVIOEUCMVDVEVIUFVMVFVIVMVKVLOZVEOVFVKVLVEUDVDVNVEEKLUG
      UHUIUHJUQZUJRZNMZVOUKRZVPSRZVOSRZPQZVTUBQZMZOVJJEVCUCVOEULZVQVEWCVIWDVPBN
      WDVPEUJRBVOEUJUMHTZUNWDVRAWBVHWDVREUKRAVOEUKUMFTWDWAVGVTCUBWDVSDVTCPWDVSB
      SRDWDVPBSWEURITWDVTESRCVOESUMGTZUOWFUOUPUSJUTVAVB $.

    $( The scalar multiplication is continuous in a topological module.
       (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    vscacn $p |- ( W e. TopMod -> .x. e. ( ( K tX J ) Cn J ) ) $=
      ( ctlm wcel ctmd clmod ctrg w3a ctx co ccn istlm simprbi ) EJKELKEMKBNKOA
      DCPQCRQKABCDEFGHIST $.
  $}

  $( A topological module is a topological monoid.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tlmtmd $p |- ( W e. TopMod -> W e. TopMnd ) $=
    ( ctlm wcel ctmd clmod csca cfv ctrg w3a cscaf ctopn ctx eqid istlm simplbi
    co ccn simp1d ) ABCZADCZAECZAFGZHCZSTUAUCIAJGZUBKGZAKGZLPUFQPCUDUBUFUEAUDMU
    FMUBMUEMNOR $.

  $( A topological module is a topological space.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tlmtps $p |- ( W e. TopMod -> W e. TopSp ) $=
    ( ctlm wcel ctmd ctps tlmtmd tmdtps syl ) ABCADCAECAFAGH $.

  $( A topological module is a left module.  (Contributed by Mario Carneiro,
     5-Oct-2015.) $)
  tlmlmod $p |- ( W e. TopMod -> W e. LMod ) $=
    ( ctlm wcel ctmd clmod csca cfv ctrg w3a cscaf ctopn ctx eqid istlm simplbi
    co ccn simp2d ) ABCZADCZAECZAFGZHCZSTUAUCIAJGZUBKGZAKGZLPUFQPCUDUBUFUEAUDMU
    FMUBMUEMNOR $.

  ${
    $d x y F $.  $d x y J $.  $d x y K $.  $d x L $.  $d x y ph $.  $d x y W $.
    $d x y X $.  $d x y Y $.
    tlmtrg.f $e |- F = ( Scalar ` W ) $.
    $( The scalar ring of a topological module is a topological ring.
       (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    tlmtrg $p |- ( W e. TopMod -> F e. TopRing ) $=
      ( ctlm wcel ctmd clmod ctrg w3a cscaf cfv ctopn ctx co eqid istlm simplbi
      ccn simp3d ) BDEZBFEZBGEZAHEZTUAUBUCIBJKZALKZBLKZMNUFRNEUDAUFUEBUDOUFOCUE
      OPQS $.

    $( The scalar ring of a topological module is a topological space.
       (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    tlmscatps $p |- ( W e. TopMod -> F e. TopSp ) $=
      ( ctlm wcel ctrg ctps tlmtrg trgtps syl ) BDEAFEAGEABCHAIJ $.

    $( A topological vector space is a topological module over a topological
       division ring.  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    istvc $p |- ( W e. TopVec <-> ( W e. TopMod /\ F e. TopDRing ) ) $=
      ( vx cv csca ctdrg wcel ctlm ctvc wceq fveq2 syl6eqr eleq1d df-tvc elrab2
      cfv ) DEZFQZGHAGHDBIJRBKZSAGTSBFQARBFLCMNDOP $.

    $( The scalar field of a topological vector space is a topological division
       ring.  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    tvctdrg $p |- ( W e. TopVec -> F e. TopDRing ) $=
      ( ctvc wcel ctlm ctdrg istvc simprbi ) BDEBFEAGEABCHI $.

    cnmpt1vsca.t $e |- .x. = ( .s ` W ) $.
    cnmpt1vsca.j $e |- J = ( TopOpen ` W ) $.
    cnmpt1vsca.k $e |- K = ( TopOpen ` F ) $.
    cnmpt1vsca.w $e |- ( ph -> W e. TopMod ) $.
    cnmpt1vsca.l $e |- ( ph -> L e. ( TopOn ` X ) ) $.
    ${
      cnmpt1vsca.a $e |- ( ph -> ( x e. X |-> A ) e. ( L Cn K ) ) $.
      cnmpt1vsca.b $e |- ( ph -> ( x e. X |-> B ) e. ( L Cn J ) ) $.
      $( Continuity of scalar multiplication; analogue of ~ cnmpt12f which
         cannot be used directly because ` .s ` is not a function.
         (Contributed by Mario Carneiro, 5-Oct-2015.) $)
      cnmpt1vsca $p |- ( ph -> ( x e. X |-> ( A .x. B ) ) e. ( L Cn J ) ) $=
        ( wcel cscaf cfv co cmpt ccn cv wa cbs wceq wf wral ctps ctlm tlmscatps
        ctopon syl eqid istps sylib cnf2 syl3anc sylibr r19.21bi tlmtps scafval
        fmpt syl2anc mpteq2dva ctx vscacn cnmpt12f eqeltrrd ) ABKCDJUAUBZUCZUDB
        KCDEUCZUDIGUEUCZABKVNVOABUFKTUGCFUHUBZTZDJUHUBZTZVNVOUIAVRBKAKVQBKCUDZU
        JZVRBKUKAIKUOUBTZHVQUOUBTZWAIHUEUCTWBQAFULTZWDAJUMTZWEPFJLUNUPVQHFVQUQZ
        OURUSRWAIHKVQUTVABKVQCWAWAUQVFVBVCAVTBKAKVSBKDUDZUJZVTBKUKAWCGVSUOUBTZW
        HVPTWIQAJULTZWJAWFWKPJVDUPVSGJVSUQZNURUSSWHIGKVSUTVABKVSDWHWHUQVFVBVCVS
        VMEFVQJCDWLLWGVMUQZMVEVGVHABCDVMIHGGKQRSAWFVMHGVIUCGUEUCTPVMFGHJWMNLOVJ
        UPVKVL $.
    $}

    cnmpt2vsca.m $e |- ( ph -> M e. ( TopOn ` Y ) ) $.
    cnmpt2vsca.a $e |- ( ph -> ( x e. X , y e. Y |-> A ) e.
                               ( ( L tX M ) Cn K ) ) $.
    cnmpt2vsca.b $e |- ( ph -> ( x e. X , y e. Y |-> B ) e.
                               ( ( L tX M ) Cn J ) ) $.
    $( Continuity of scalar multiplication; analogue of ~ cnmpt22f which cannot
       be used directly because ` .s ` is not a function.  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    cnmpt2vsca $p |- ( ph ->
        ( x e. X , y e. Y |-> ( A .x. B ) ) e. ( ( L tX M ) Cn J ) ) $=
      ( cscaf cfv co cmpt2 ctx ccn cv wcel wceq wa cbs wral cxp txtopon syl2anc
      ctopon ctps ctlm tlmscatps syl eqid istps sylib cnf2 syl3anc fmpt2 sylibr
      wf r19.21bi tlmtps scafval 3impa mpt2eq3dva vscacn cnmpt22f eqeltrrd ) AB
      CMNDELUDUEZUFZUGBCMNDEFUFZUGJKUHUFZHUIUFZABCMNWAWBABUJMUKZCUJNUKZWAWBULZA
      WEUMZWFUMDGUNUEZUKZELUNUEZUKZWGWHWJCNAWJCNUOZBMAMNUPZWIBCMNDUGZVKZWMBMUOA
      WCWNUSUEUKZIWIUSUEUKZWOWCIUIUFUKWPAJMUSUEUKKNUSUEUKWQTUAJKMNUQURZAGUTUKZW
      RALVAUKZWTSGLOVBVCWIIGWIVDZRVEVFUBWOWCIWNWIVGVHBCMNDWIWOWOVDVIVJVLVLWHWLC
      NAWLCNUOZBMAWNWKBCMNEUGZVKZXCBMUOAWQHWKUSUEUKZXDWDUKXEWSALUTUKZXFAXAXGSLV
      MVCWKHLWKVDZQVEVFUCXDWCHWNWKVGVHBCMNEWKXDXDVDVIVJVLVLWKVTFGWILDEXHOXBVTVD
      ZPVNURVOVPABCDEVTJKIHHMNTUAUBUCAXAVTIHUHUFHUIUFUKSVTGHILXIQORVQVCVRVS $.
  $}

  ${
    $d x W $.
    $( A topological vector space is a topological group.  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    tlmtgp $p |- ( W e. TopMod -> W e. TopGrp ) $=
      ( vx ctlm wcel cgrp ctmd cminusg cfv ctopn ccn co ctgp syl cmpt eqid ctps
      cbs ctopon istps sylib clmod tlmlmod lmodgrp tlmtmd csca cv cvsca grpinvf
      cur wf feqmptd wceq lmodvneg1 sylan mpteq2dva eqtr4d tlmtps tlmscatps crg
      lmodrng rnggrp rngidcl grpinvcl syl2anc cnmptc cnmptid cnmpt1vsca eqeltrd
      id istgp syl3anbrc ) ACDZAEDZAFDAGHZAIHZVOJKZDALDVLAUADZVMAUBZAUCMZAUDVLV
      NBAQHZAUEHZUIHZWAGHZHZBUFZAUGHZKZNZVPVLVNBVTWEVNHZNWHVLBVTVTVNVLVMVTVTVNU
      JVSVTAVNVTOZVNOZUHMUKVLBVTWGWIVLVQWEVTDWGWIULVRWFWBWAWCVNVTAWEWJWKWAOZWFO
      ZWBOZWCOZUMUNUOUPVLBWDWEWFWAVOWAIHZVOAVTWLWMVOOZWPOZVLVIVLAPDVOVTRHDAUQVT
      VOAWJWQSTZVLBWDVOWPVTWAQHZWSVLWAPDWPWTRHDWAAWLURWTWPWAWTOZWRSTVLWAEDZWBWT
      DZWDWTDVLWAUSDZXBVLVQXDVRWAAWLUTMZWAVAMVLXDXCXEWTWAWBXAWNVBMWTWAWCWBXAWOV
      CVDVEVLBVOVTWSVFVGVHAVNVOWQWKVJVK $.
  $}

  $( A topological vector space is a topological module.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tvctlm $p |- ( W e. TopVec -> W e. TopMod ) $=
    ( ctvc wcel ctlm csca cfv ctdrg eqid istvc simplbi ) ABCADCAEFZGCKAKHIJ $.

  $( A topological vector space is a left module.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tvclmod $p |- ( W e. TopVec -> W e. LMod ) $=
    ( ctvc wcel ctlm clmod tvctlm tlmlmod syl ) ABCADCAECAFAGH $.

  $( A topological vector space is a vector space.  (Contributed by Mario
     Carneiro, 5-Oct-2015.) $)
  tvclvec $p |- ( W e. TopVec -> W e. LVec ) $=
    ( ctvc wcel clmod csca cfv clvec tvclmod ctdrg eqid tvctdrg tdrgdrng islvec
    cdr syl sylanbrc ) ABCZADCAEFZNCZAGCAHQRICSRARJZKRLORATMP $.


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
              Uniform Stuctures and Spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Uniform structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c UnifOn $. $( The class function of uniform structures over a base set. $)

  $( Extend class notation with the class function of uniform structures. $)
  cust $a class UnifOn $.

  ${
    $d x u v w $.
    $( Definition of a uniform structure.  Definition 1 of [BourbakiTop1] p.
       II.1.  A uniform structure is used to give a generalization of the idea
       of Cauchy's sequence.  This defintion is analogous to ` TopOn ` .
       Elements of an uniform structure are called entourages.  (Contributed by
       FL, 29-May-2014.)  (Revised by Thierry Arnoux, 15-Nov-2017.) $)
    df-ust $a |- UnifOn = ( x e. _V |-> { u | ( u C_ ~P ( x X. x )
       /\ ( x X. x ) e. u /\ A. v e. u (
          A. w e. ~P ( x X. x ) ( v C_ w -> w e. u )
               /\ A. w e. u ( v i^i w ) e. u
               /\ ( ( _I |` x ) C_ v
                    /\ `' v e. u
                    /\ E. w e. u ( w o. w ) C_ v ) ) ) } ) $.
  $}

  ${
    $d u v w x $.
    $( The defined uniform structure as a function.  (Contributed by Thierry
       Arnoux, 15-Nov-2017.) $)
    ustfn $p |- UnifOn Fn _V $=
      ( vx vu vv vw cvv cv cxp cpw wss wcel wral cin cid cres ccnv w3a cab pwex
      wi vex ccom wrex cust elpw abbii abid2 xpex eqeltri eqeltrri simp1 ss2abi
      ssexi df-ust fnmpti ) AEBFZAFZUPGZHZIZUQUOJZCFZDFZIVBUOJSDURKVAVBLUOJDUOK
      MUPNVAIVAOUOJVBVBUAVAIDUOUBPPCUOKZPZBQZUCVEUSBQZUOURHZJZBQZVFEVHUSBUOURBT
      UDUEVIVGEBVGUFURUQUPUPATZVJUGRRUHUIVDUSBUSUTVCUJUKULADCBUMUN $.
  $}

  ${
    $d u v w x X $.
    $( The class of all uniform structures for a base ` X ` .  (Contributed by
       Thierry Arnoux, 15-Nov-2017.) $)
    ustval $p |- ( X e. _V -> ( UnifOn ` X ) = { u | ( u C_ ~P ( X X. X ) /\
        ( X X. X ) e. u /\ A. v e. u (
          A. w e. ~P ( X X. X ) ( v C_ w -> w e. u )
               /\ A. w e. u ( v i^i w ) e. u
               /\ ( ( _I |` X ) C_ v
                    /\ `' v e. u
                    /\ E. w e. u ( w o. w ) C_ v ) ) ) } ) $=
      ( vx cvv wcel cv cxp cpw wss wral cid cres w3a cab cust wceq id pwexg cin
      ccnv ccom wrex cmpt df-ust a1i xpeq12d pweqd sseq2d eleq1d raleqdv reseq2
      wi sseq1d 3anbi1d 3anbi13d ralbidv 3anbi123d abbidv adantl simp1 sseqtr4i
      ss2abi df-pw xpexg anidms 3syl ssexg sylancr fvmptd ) DFGZEDCHZEHZVNIZJZK
      ZVOVMGZBHZAHZKVTVMGUNZAVPLZVSVTUAVMGAVMLZMVNNZVSKZVSUBVMGZVTVTUCVSKAVMUDZ
      OZOZBVMLZOZCPZVMDDIZJZKZWMVMGZWAAWNLZWCMDNZVSKZWFWGOZOZBVMLZOZCPZFQFQEFWL
      UERVLEABCUFUGVNDRZWLXDRVLXEWKXCCXEVQWOVRWPWJXBXEVPWNVMXEVOWMXEVNDVNDXESZX
      FUHZUIZUJXEVOWMVMXGUKXEWIXABVMXEWBWQWHWTWCXEWAAVPWNXHULXEWEWSWFWGXEWDWRVS
      VNDMUMUOUPUQURUSUTVAVLSVLXDWNJZKXIFGZXDFGXDWOCPXIXCWOCWOWPXBVBVDCWNVEVCVL
      WMFGZWNFGXJVLXKDDFFVFVGWMFTWNFTVHXDXIFVIVJVK $.
  $}

  ${
    $d u v w U $.  $d u v w X $.
    $( The predicate " ` U ` is a uniform structure with base ` X ` ."
       (Contributed by Thierry Arnoux, 15-Nov-2017.) $)
    isust $p |- ( X e. _V -> ( U e. ( UnifOn ` X ) <-> ( U C_ ~P ( X X. X ) /\
      ( X X. X ) e. U /\ A. v e. U (
          A. w e. ~P ( X X. X ) ( v C_ w -> w e. U )
               /\ A. w e. U ( v i^i w ) e. U
               /\ ( ( _I |` X ) C_ v
                    /\ `' v e. U
                    /\ E. w e. U ( w o. w ) C_ v ) ) ) ) ) $=
      ( vu cvv wcel cust cfv cv cxp wss wi wral wrex eleq2 raleqbi1dv 3anbi123d
      w3a syl cpw cin cid cres ccnv ccom ustval eleq2d wb simp1 wa xpexg anidms
      pwexg adantr simpr ssexd ex syl5 wceq sseq1 imbi2d ralbidv rexeq 3anbi23d
      cab elab3g bitrd ) DFGZCDHIZGCEJZDDKZUAZLZVLVKGZBJZAJZLZVQVKGZMZAVMNZVPVQ
      UBZVKGZAVKNZUCDUDVPLZVPUEZVKGZVQVQUFVPLZAVKOZSZSZBVKNZSZEVFZGZCVMLZVLCGZV
      RVQCGZMZAVMNZWBCGZACNZWEWFCGZWHACOZSZSZBCNZSZVIVJWNCABEDUGUHVIXHCFGZMWOXH
      UIXHWPVIXIWPWQXGUJVIWPXIVIWPUKCVMFVIVMFGZWPVIVLFGZXJVIXKDDFFULUMVLFUNTUOV
      IWPUPUQURUSWMXHECFVKCUTZVNWPVOWQWLXGVKCVMVAVKCVLPWKXFBVKCXLWAWTWDXBWJXEXL
      VTWSAVMXLVSWRVRVKCVQPVBVCWCXAAVKCVKCWBPQXLWGXCWIXDWEVKCWFPWHAVKCVDVERQRVG
      TVH $.

    $d v w V $.
    $( Entourages are subsets of the cross product of the base set.
       (Contributed by Thierry Arnoux, 19-Nov-2017.) $)
    ustssxp $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U ) -> V C_ ( X X. X ) ) $=
      ( vv vw cust cfv wcel wa cxp cpw wss cv wi wral cin cid cres ccnv w3a cvv
      ccom wrex wb elfvex isust syl ibi simp1d sselda elpwid ) ACFGHZBAHIBCCJZU
      LAUMKZBULAUNLZUMAHZDMZEMZLURAHNEUNOUQURPAHEAOQCRUQLUQSAHURURUBUQLEAUCTTDA
      OZULUOUPUSTZULCUAHULUTUDACFUEEDACUFUGUHUIUJUK $.

    $d w W $.
    $( A uniform structure is upward closed.  Condition F_I of [BourbakiTop1]
       p.  I.36.  (Contributed by Thierry Arnoux, 19-Nov-2017.) $)
    ustssel $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U /\ W C_ ( X X. X ) )
      -> ( V C_ W -> W e. U ) ) $=
      ( vv vw cust cfv wcel wss w3a cv wi wral simp1 cvv wb syl syl2anc wceq
      cxp cpw cin cid cres ccnv ccom wrex isust mpbid simp3d ralimi simp2 simp3
      elfvexd xpexg ssexd elpwg mpbird sseq1 imbi1d sseq2 eleq1 imbi12d rspc2v
      mpd ) ADGHIZBAIZCDDUAZJZKZELZFLZJZVMAIZMZFVIUBZNZEANZBCJZCAIZMZVKVRVLVMUC
      AIFANZUDDUEVLJVLUFAIVMVMUGVLJFAUHKZKZEANZVSVKAVQJZVIAIZWFVKVGWGWHWFKZVGVH
      VJOZVKDPIZVGWIQVKAGDWJUOZFEADUIRUJUKWEVREAVRWCWDOULRVKVHCVQIZVSWBMVGVHVJU
      MVKWMVJVGVHVJUNZVKCPIWMVJQVKCVIPVKWKWKVIPIWLWLDDPPUPSWNUQCVIPURRUSVPWBBVM
      JZVOMEFBCAVQVLBTVNWOVOVLBVMUTVAVMCTWOVTVOWAVMCBVBVMCAVCVDVESVF $.

    $( The full set is always an entourage.  Condition F_IIb of [BourbakiTop1]
       p.  I.36.  (Contributed by Thierry Arnoux, 19-Nov-2017.) $)
    ustbasel $p |- ( U e. ( UnifOn ` X ) -> ( X X. X ) e. U ) $=
      ( vv vw cust cfv wcel cxp cpw wss cv wral cin cid cres ccnv ccom wrex w3a
      wi cvv wb elfvex isust syl ibi simp2d ) ABEFGZABBHZIZJZUIAGZCKZDKZJUNAGTD
      UJLUMUNMAGDALNBOUMJUMPAGUNUNQUMJDARSSCALZUHUKULUOSZUHBUAGUHUPUBABEUCDCABU
      DUEUFUG $.

    $( A uniform structure is closed under finite intersection.  Condition F_II
       of [BourbakiTop1] p.  I.36.  (Contributed by Thierry Arnoux,
       30-Nov-2017.) $)
    ustincl $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U /\ W e. U )
      -> ( V i^i W ) e. U ) $=
      ( vw vv cust wcel cin cv wral wss ccnv wrex w3a wceq ralbidv eleq1d sseq2
      wi cfv wa cxp cpw cid cres ccom cvv wb elfvex isust syl ibi simp3d imbi1d
      sseq1 ineq1 cnveq rexbidv 3anbi123d rspcv mpan9 simp2d ineq2 3impa ) ADGU
      AHZBAHZCAHZBCIZAHZVFVGUBZBEJZIZAHZEAKZVHVJVKBVLLZVLAHZTZEDDUCZUDZKZVOUEDU
      FZBLZBMZAHZVLVLUGZBLZEANZOZVFFJZVLLZVQTZEVTKZWJVLIZAHZEAKZWBWJLZWJMZAHZWF
      WJLZEANZOZOZFAKZVGWAVOWIOZVFAVTLZVSAHZXDVFXFXGXDOZVFDUHHVFXHUIADGUJEFADUK
      ULUMUNXCXEFBAWJBPZWMWAWPVOXBWIXIWLVREVTXIWKVPVQWJBVLUPUOQXIWOVNEAXIWNVMAW
      JBVLUQRQXIWQWCWSWEXAWHWJBWBSXIWRWDAWJBURRXIWTWGEAWJBWFSUSUTUTVAVBVCVNVJEC
      AVLCPVMVIAVLCBVDRVAVBVE $.

    $( The diagonal set is included in any entourage, i.e. any point is ` V `
       -close to itself.  Condition U_I of [BourbakiTop1] p.  II.1.
       (Contributed by Thierry Arnoux, 2-Dec-2017.) $)
    ustdiag $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U ) -> ( _I |` X ) C_ V ) $=
      ( vw vv cust wcel wss ccnv cv wrex wi cin w3a simp3d ralbidv eleq1d sseq2
      wral 3anbi123d cfv wa cid cres ccom cxp cpw cvv elfvex isust syl ibi wceq
      wb sseq1 imbi1d ineq1 cnveq rexbidv rspcv mpan9 simp1d ) ACFUAGZBAGZUBZUC
      CUDZBHZBIZAGZDJZVJUEZBHZDAKZVEBVJHZVJAGZLZDCCUFZUGZSZBVJMZAGZDASZVGVIVMNZ
      VCEJZVJHZVOLZDVRSZWDVJMZAGZDASZVFWDHZWDIZAGZVKWDHZDAKZNZNZEASZVDVSWBWCNZV
      CAVRHZVQAGZWRVCWTXAWRNZVCCUHGVCXBUNACFUIDEACUJUKULOWQWSEBAWDBUMZWGVSWJWBW
      PWCXCWFVPDVRXCWEVNVOWDBVJUOUPPXCWIWADAXCWHVTAWDBVJUQQPXCWKVGWMVIWOVMWDBVF
      RXCWLVHAWDBURQXCWNVLDAWDBVKRUSTTUTVAOVB $.

    $( If ` V ` is an entourage, so is its inverse.  Condition U_II of
       [BourbakiTop1] p.  II.1.  (Contributed by Thierry Arnoux,
       2-Dec-2017.) $)
    ustinvel $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U ) -> `' V e. U ) $=
      ( vw vv cust wcel wss ccnv cv wrex wi cin w3a simp3d ralbidv eleq1d sseq2
      wral 3anbi123d cfv wa cid cres ccom cxp cpw cvv elfvex isust syl ibi wceq
      wb sseq1 imbi1d ineq1 cnveq rexbidv rspcv mpan9 simp2d ) ACFUAGZBAGZUBZUC
      CUDZBHZBIZAGZDJZVJUEZBHZDAKZVEBVJHZVJAGZLZDCCUFZUGZSZBVJMZAGZDASZVGVIVMNZ
      VCEJZVJHZVOLZDVRSZWDVJMZAGZDASZVFWDHZWDIZAGZVKWDHZDAKZNZNZEASZVDVSWBWCNZV
      CAVRHZVQAGZWRVCWTXAWRNZVCCUHGVCXBUNACFUIDEACUJUKULOWQWSEBAWDBUMZWGVSWJWBW
      PWCXCWFVPDVRXCWEVNVOWDBVJUOUPPXCWIWADAXCWHVTAWDBVJUQQPXCWKVGWMVIWOVMWDBVF
      RXCWLVHAWDBURQXCWNVLDAWDBVKRUSTTUTVAOVB $.

    $( For each entourage ` V ` there is an entourage ` w ` that is "not more
       than half as large".  Condition U_III of [BourbakiTop1] p.  II.1.
       (Contributed by Thierry Arnoux, 2-Dec-2017.) $)
    ustexhalf $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U )
      -> E. w e. U ( w o. w ) C_ V ) $=
      ( vv cust wcel wss ccnv wrex wral cin w3a simp3d ralbidv eleq1d 3anbi123d
      cv wi sseq2 cfv wa cid cres ccom cxp cpw cvv wb elfvex isust syl ibi wceq
      sseq1 imbi1d ineq1 cnveq rexbidv rspcv mpan9 ) BDFUAGZCBGZUBZUCDUDZCHZCIZ
      BGZARZVIUEZCHZABJZVDCVIHZVIBGZSZADDUFZUGZKZCVILZBGZABKZVFVHVLMZVBERZVIHZV
      NSZAVQKZWCVILZBGZABKZVEWCHZWCIZBGZVJWCHZABJZMZMZEBKZVCVRWAWBMZVBBVQHZVPBG
      ZWQVBWSWTWQMZVBDUHGVBXAUIBDFUJAEBDUKULUMNWPWRECBWCCUNZWFVRWIWAWOWBXBWEVOA
      VQXBWDVMVNWCCVIUOUPOXBWHVTABXBWGVSBWCCVIUQPOXBWJVFWLVHWNVLWCCVETXBWKVGBWC
      CURPXBWMVKABWCCVJTUSQQUTVANN $.

    $( The elements of uniform structures, called entourages, are relations.
       (Contributed by Thierry Arnoux, 15-Nov-2017.) $)
    ustrel $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U ) -> Rel V ) $=
      ( cust cfv wcel wa cvv cxp wss wrel ustssxp xpss syl6ss df-rel sylibr ) A
      CDEFBAFGZBHHIZJBKQBCCIRABCLCCMNBOP $.

    $( A uniform structure on a non-empty base is a filter.  Remark 3 of
       [BourbakiTop1] p.  II.2.  (Contributed by Thierry Arnoux,
       15-Nov-2017.) $)
    ustfilxp $p |- ( ( X =/= (/) /\ U e. ( UnifOn ` X ) )
      -> U e. ( Fil ` ( X X. X ) ) ) $=
      ( vw vv c0 wne cfv wcel cpw cin wral wss w3a cvv syl simp1d ne0i r19.21bi
      wa wb cust cxp cfbas cv wi cfil wnel cid cres ccnv ccom wrex elfvex isust
      ibi adantl simp2d simp3d cop vex opelresi ax-mp biimpri rgen r19.2z mpan2
      ad2antrr rexlimivw ssn0 syl2anc nelrdva df-nel sylibr inex2 pwid a1i elin
      wn sylanbrc ralrimiva xpexg isfbas mpbir2and wex elpw2 anbi2i bitri exbii
      3jca n0 an32s expimpd exlimdv syl5bi isfil ) BEFZABUAGHZSZABBUBZUCGHZACUD
      ZIZJZEFZXAAHZUEZCWSIZKAWSUFGHWRWTAXGLZAEFZEAUGZADUDZXAJZIZJZEFZCAKZDAKZMZ
      WRXHWSAHZXKXALZXEUEZCXGKZXLAHZCAKZUHBUIZXKLZXKUJAHZXAXAUKXKLCAULZMZMZDAKZ
      WQXHXSYKMZWPWQYLWQBNHZWQYLTABUAUMZCDABUNOUOUPZPWRXIXJXQWRXSXIWRXHXSYKYOUQ
      AWSQOWREAHVRXJWRDAEWRXKAHZSZYFYEEFZXKEFYQYFYGYHYQYBYDYIWRYJDAWRXHXSYKYOUR
      RZURPYQXAXAUSZYEHZCBULZYRWPUUBWQYPWPUUACBKUUBUUACBUUAXABHZXANHUUAUUCTCUTZ
      XABNVAVBVCVDUUACBVEVFVGUUAYRCBYEYTQVHOYEXKVIVJVKEAVLVMWRXPDAYQXOCAYQXESZX
      LXNHZXOUUEYCXLXMHZUUFYQYCCAYQYBYDYIYSUQRUUGUUEXLXAXKUUDVNVOVPXLAXMVQVSXNX
      LQOVTVTWIWQWTXHXRSTZWPWQWSNHZUUHWQYMYMUUIYNYNBBNNWAVJDCNWSAWBOUPWCWRXFCXG
      XDYPXTSZDWDZWRXAXGHZSZXEXDXKXCHZDWDUUKDXCWJUUNUUJDUUNYPXKXBHZSUUJXKAXBVQU
      UOXTYPXKXAUUDWEWFWGWHWGUUMUUJXEDUUMYPXTXEWRYPUULYAYQYACXGYQYBYDYIYSPRWKWL
      WMWNVTCAWSWOVS $.
  $}

  ${
    $d v w U $.  $d v w X $.
    $( A uniform structure cannot be empty.  (Contributed by Thierry Arnoux,
       16-Nov-2017.) $)
    ustne0 $p |- ( U e. ( UnifOn ` X ) -> U =/= (/) ) $=
      ( cust cfv wcel cxp c0 wne ustbasel ne0i syl ) ABCDEBBFZAEAGHABIALJK $.
  $}

  $( In an uniform structure, any entourage ` V ` is a subset of its
     composition with itself.  (Contributed by Thierry Arnoux, 5-Jan-2018.) $)
  ustssco $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U ) -> V C_ ( V o. V ) ) $=
    ( cust cfv wcel wa cid cres cun ccom ssun1 coires1 wrel cdm wss wceq ustrel
    cxp ustssxp dmss syl dmxpid syl6sseq syl2anc syl5eq uneq1d syl5sseqr coundi
    relssres syl6sseqr ustdiag ssequn1 sylib coeq2d sseqtrd ) ACDEFBAFGZBBHCIZB
    JZKZBBKZUQBBURKZVAJZUTUQBVAJBVCBVALUQVBBVAUQVBBCIZBBCMUQBNBOZCPVDBQABCRUQVE
    CCSZOZCUQBVFPVEVGPABCTBVFUAUBCUCUDBCUJUEUFUGUHBURBUIUKUQUSBBUQURBPUSBQABCUL
    URBUMUNUOUP $.

  ${
    $d w x U $.  $d w x V $.  $d x X $.
    $( In an uniform structure, for any entourage ` V ` , there exists a
       smaller symmetrical entourage.  (Contributed by Thierry Arnoux,
       4-Jan-2018.) $)
    ustexsym $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U )
      -> E. w e. U ( `' w = w /\ w C_ V ) ) $=
      ( vx cust cfv wcel wa ccom wss ccnv wceq wrex cin simplll simplr ustinvel
      cv syl2anc ustincl syl3anc ustrel dfrel2 sylib ineq1d cnvin incom 3eqtr4g
      wrel inss2 ustssco simpr sstrd syl5ss cnveq eqeq12d sseq1 rspcev syl12anc
      id anbi12d ustexhalf r19.29a ) BDFGHZCBHZIZESZVHJZCKZASZLZVKMZVKCKZIZABNZ
      EBVGVHBHZIZVJIZVHLZVHOZBHZWALZWAMZWACKZVPVSVEVTBHZVQWBVEVFVQVJPZVSVEVQWFW
      GVGVQVJQZBVHDRTWHBVTVHDUAUBVSVEVQWDWGWHVEVQIZVTLZVTOVHVTOWCWAWIWJVHVTWIVH
      UJWJVHMBVHDUCVHUDUEUFVTVHUGVTVHUHUITVSWAVHCVTVHUKVSVHVICVSVEVQVHVIKWGWHBV
      HDULTVRVJUMUNUOVOWDWEIAWABVKWAMZVMWDVNWEWKVLWCVKWAVKWAUPWKVAUQVKWACURVBUS
      UTEBCDVCVD $.
  $}

  ${
    $d v w U $.  $d v w V $.  $d v w X $.
    $( In an uniform structure, for any entourage ` V ` , there exists a
       symmetrical entourage smaller than half ` V ` .  (Contributed by Thierry
       Arnoux, 16-Jan-2018.) $)
    ustex2sym $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U )
      -> E. w e. U ( `' w = w /\ ( w o. w ) C_ V ) ) $=
      ( vv cust cfv wcel wa cv ccom wss ccnv wceq wrex simplll ustexsym syl2anc
      simplr sstrd simprl coss1 coss2 ad2antll simpllr jca reximdva mpd r19.29a
      ex ustexhalf ) BDFGHZCBHZIZEJZUOKZCLZAJZMURNZURURKZCLZIZABOZEBUNUOBHZIZUQ
      IZUSURUOLZIZABOZVCVFULVDVIULUMVDUQPUNVDUQSABUODQRVFVHVBABVFURBHZIZVHVBVKV
      HIZUSVAVKUSVGUAVLUTUPCVGUTUPLVKUSVGUTUOURKUPURUOURUBURUOUOUCTUDVEUQVJVHUE
      TUFUJUGUHEBCDUKUI $.
  $}

  ${
    $d v w U $.  $d v w V $.  $d v w X $.
    $( In an uniform structure, for any entourage ` V ` , there exists a
       symmetrical entourage smaller than a third of ` V ` .  (Contributed by
       Thierry Arnoux, 16-Jan-2018.) $)
    ustex3sym $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U )
      -> E. w e. U ( `' w = w /\ ( w o. ( w o. w ) ) C_ V ) ) $=
      ( vv cust cfv wcel wa cv ccom wss ccnv wceq wrex simplll simplr ustex2sym
      syl2anc sstrd simprl simp-5l ustssco simprr coss2 adantl sstr syl simpllr
      coss1 jca ex reximdva mpd ustexhalf r19.29a ) BDFGHZCBHZIZEJZUTKZCLZAJZMV
      CNZVCVCVCKZKZCLZIZABOZEBUSUTBHZIZVBIZVDVEUTLZIZABOZVIVLUQVJVOUQURVJVBPUSV
      JVBQABUTDRSVLVNVHABVLVCBHZIZVNVHVQVNIZVDVGVQVDVMUAVRVFVACVRVCVELZVMVFVALV
      RUQVPVSUQURVJVBVPVNUBVLVPVNQBVCDUCSVQVDVMUDVSVMIZVFVCUTKZVAVMVFWALVSVEUTV
      CUEUFVTVCUTLWAVALVCVEUTUGVCUTUTUJUHTSVKVBVPVNUITUKULUMUNEBCDUOUP $.
  $}

  ${
    $d v w U $.  $d a b v V $.  $d a b v w X $.
    $( Any element of the base set is "near" itself, i.e. entourages are
       reflexive.  (Contributed by Thierry Arnoux, 16-Nov-2017.) $)
    ustref $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U /\ A e. X ) -> A V A ) $=
      ( cust cfv wcel w3a cid cres wbr wa wceq resieq mpbiri anidms 3ad2ant3 wi
      eqid ustdiag ssbrd 3adant3 mpd ) BDEFGZCBGZADGZHAAIDJZKZAACKZUFUDUHUEUFUH
      UFUFLUHAAMASDAANOPQUDUEUHUIRUFUDUELUGCAABCDTUAUBUC $.
  $}

  ${
    $d u v w $.
    $( The unique uniform structure of the empty set is the empty set.  Remark
       3 of [BourbakiTop1] p.  II.2.  (Contributed by Thierry Arnoux,
       15-Nov-2017.) $)
    ust0 $p |- ( UnifOn ` (/) ) = { { (/) } } $=
      ( vu vv vw c0 cv wcel wceq wss wi wral cin wrex w3a 0ex ax-mp sseq2 ralsn
      eqeltri mpbir eleq1d cust cfv csn cxp cpw cid cres ccnv ccom cvv wb isust
      simp1bi 0xp pweqi pw0 eqtri syl6sseq ustbasel syl5eqelr snssd elsn sylibr
      eqssd ssriv eqimss2i snid a1i raleqi eleq1 imbi12d bitri inidm ineq2 res0
      eqimssi cnv0 co02 coeq12d sseq1d rexsn 3pm3.2i sseq1 imbi1d ralbidv ineq1
      id cnveq rexbidv 3anbi123d mpbir3an snssi eqssi ) DUAUBZDUCZUCZAWNWPAEZWN
      FZWQWOGWQWPFWRWQWOWRWQDDUDZUEZWOWRWQWTHZWSWQFZBEZCEZHZXDWQFICWTJXCXDKZWQF
      CWQJUFDUGZXCHZXCUHZWQFXDXDUIZXCHZCWQLMMBWQJZDUJFZWRXAXBXLMUKNCBWQDULOUMWT
      DUEWOWSDDUNZUOUPUQZURWRDWQWRDWSWQXNWQDUSUTVAVDAWOVBVCVEWOWNFZWPWNHXPWOWTH
      ZWSWOFZXEXDWOFZIZCWTJZXFWOFZCWOJZXHXIWOFZXKCWOLZMZMZBWOJZWTWOXOVFWSDWOXND
      NVGZRYHDXDHZXSIZCWTJZDXDKZWOFZCWOJZXGDHZDUHZWOFZXJDHZCWOLZMZYLDDHZDWOFZIZ
      UUCUUBYIVHYLYKCWOJUUDYKCWTWOXOVIYKUUDCDNXDDGZYJUUBXSUUCXDDDPXDDWOVJVKQVLS
      YODDKZWOFZUUFDWODVMYIRYNUUGCDNUUEYMUUFWOXDDDVNTQSYPYRYTXGDUFVOVPYQDWOVQYI
      RYTDDUIZDHZUUHDDVRVPYSUUICDNUUEXJUUHDUUEXDDXDDUUEWGZUUJVSVTWASWBYGYLYOUUA
      MBDNXCDGZYAYLYCYOYFUUAUUKXTYKCWTUUKXEYJXSXCDXDWCWDWEUUKYBYNCWOUUKXFYMWOXC
      DXDWFTWEUUKXHYPYDYRYEYTXCDXGPUUKXIYQWOXCDWHTUUKXKYSCWOXCDXJPWIWJWJQWKXMXP
      XQXRYHMUKNCBWODULOWKWOWNWLOWM $.
  $}

  ${
    $d u v w x $.
    $( The empty set is not an uniform structure.  (Contributed by Thierry
       Arnoux, 3-Dec-2017.) $)
    ustn0 $p |- -. (/) e. U. ran UnifOn $=
      ( vx vu vv vw c0 cust wcel cv cab cpw wss wral wrex w3a cvv wceq vex pwex
      mtbir ss2abi crn cuni cfv wex cxp noel 0ex elab wi cin cid cres ccnv ccom
      eleq2 elpw abbii abid2 xpex eqeltri simp1 ssexi df-ust fvmpt2 mp2an simp2
      eqeltrri eqsstri sseli mto nex cdm wfun wb funmpt2 elunirn ax-mp wfn fndm
      ustfn rexeqi rexv 3bitri ) EFUAUBGZEAHZFUCZGZAUDZWGAWGEWEWEUEZBHZGZBIZGZW
      MWIEGZWIUFWKWNBEUGWJEWIUOUHSWFWLEWFWJWIJZKZWKCHZDHZKWRWJGUIDWOLWQWRUJWJGD
      WJLUKWEULWQKWQUMWJGWRWRUNWQKDWJMNNCWJLZNZBIZWLWEOGXAOGWFXAPAQZXAWPBIZWJWO
      JZGZBIZXCOXEWPBWJWOBQUPUQXFXDOBXDURWOWIWEWEXBXBUSRRUTVGWTWPBWPWKWSVATVBAO
      XAOFADCBVCZVDVEWTWKBWPWKWSVFTVHVIVJVKWDWGAFVLZMZWGAOMWHFVMWDXIVNAOXAFXGVO
      AEFVPVQWGAXHOFOVRXHOPVTOFVSVQWAWGAWBWCS $.
  $}

  ${
    ustund.1 $e |- ( ph -> ( A X. A ) C_ V ) $.
    ustund.2 $e |- ( ph -> ( B X. B ) C_ V ) $.
    ustund.3 $e |- ( ph -> ( A i^i B ) =/= (/) ) $.
    $( If two intersecting sets ` A ` and ` B ` are both small in ` V ` , their
       union is small in ` ( V ^ 2 ) ` .  Proposition 1 of [BourbakiTop1] p.
       II.12.  This proposition actually does not require any axiom of the
       defintion of unifom structures.  (Contributed by Thierry Arnoux,
       17-Nov-2017.) $)
    ustund $p |- ( ph -> ( ( A u. B ) X. ( A u. B ) ) C_ ( V o. V ) ) $=
      ( cun cxp cin ccom syl xpindi inss1 syl5ss syl5eqss inss2 unssd xpindir
      wss c0 wne wceq xpco xpundir coss2 xpundi coss1 sstrd eqsstr3d ) ABCHZUKI
      ZBCJZUKIZUKUMIZKZDDKZAUMUAUBUPULUCGUKUMUKUDLAUPUNDKZUQAUODTUPURTAUOBUMIZC
      UMIZHDBCUMUEAUSUTDAUSBBIZBCIZJZDBBCMAVCVADVAVBNEOPAUTCBIZCCIZJZDCBCMAVFVE
      DVDVEQFOPRPUODUNUFLAUNDTURUQTAUNUMBIZUMCIZHDUMBCUGAVGVHDAVGVAVDJZDBCBSAVI
      VADVAVDNEOPAVHVBVEJZDBCCSAVJVEDVBVEQFOPRPUNDDUHLUIUJ $.
  $}

  $( Any point ` A ` is near enough to itself.  (Contributed by Thierry Arnoux,
     18-Nov-2017.) $)
  ustelimasn $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U /\ A e. X )
    -> A e. ( V " { A } ) ) $=
    ( cust cfv wcel w3a cop csn cima cid cres wss ustdiag 3adant3 opelresi ibir
    simp3 3ad2ant3 sseldd wb elimasng anidms biimpar syl2anc ) BDEFGZCBGZADGZHZ
    UIAAIZCGZACAJKGZUGUHUISUJLDMZCUKUGUHUNCNUIBCDOPUIUGUKUNGZUHUIUOADDQRTUAUIUM
    ULUIUMULUBCAADDUCUDUEUF $.

  $( For a point ` A ` in ` X ` , ` ( V " { A } ) ` is small enough in
     ` ( V o. ``' V ) ` .  This proposition actually does not require any axiom
     of the defintion of unifom structures.  (Contributed by Thierry Arnoux,
     18-Nov-2017.) $)
  ustneism $p |- ( ( V C_ ( X X. X ) /\ A e. X )
    -> ( ( V " { A } ) X. ( V " { A } ) ) C_ ( V o. `' V ) ) $=
    ( cxp wss wcel wa csn cima ccom ccnv c0 wne wceq snnzg adantl xpco eqsstr3i
    syl mp1i cnvxp ressn cnveqi resss cnvss ax-mp coss2 coss1 sstrd eqsstr3d
    cres ) BCCDEZACFZGZBAHZIZUPDZUOUPDZUPUODZJZBBKZJZUNUOLMZUTUQNUMVCULACOPUPUO
    UPQSUNUTURVAJZVBUSVAEUTVDEUNUSURKZVAUOUPUAVEBUOUKZKZVAVFURBAUBZUCVFBEVGVAEB
    UOUDZVFBUEUFRRUSVAURUGTURBEVDVBEUNURVFBVHVIRURBVAUHTUIUJ $.

  ${
    $d u v w x $.  $d x U $.  $d x X $.
    $( First direction for ~ ustbas .  (Contributed by Thierry Arnoux,
       16-Nov-2017.) $)
    elrnust $p |- ( U e. ( UnifOn ` X ) -> U e. U. ran UnifOn ) $=
      ( vx cust cfv wcel cv cdm wrex crn cuni elfvdm wceq eleq2d rspcev mpancom
      fveq2 cvv wfn wfun wb ustfn fnfun elunirn mp2b sylibr ) ABDEZFZACGZDEZFZC
      DHZIZADJKFZBULFUHUMABDLUKUHCBULUIBMUJUGAUIBDQNOPDRSDTUNUMUAUBRDUCCADUDUEU
      F $.
  $}

  ${
    $d v w U $.  $d v w X $.
    $( Second direction for ~ ustbas .  (Contributed by Thierry Arnoux,
       16-Nov-2017.) $)
    ustbas2 $p |- ( U e. ( UnifOn ` X ) -> X = dom U. U ) $=
      ( vv vw cust cfv wcel cxp cdm cuni dmxpid wss ustbasel elssuni syl cpw cv
      wi wral w3a cin cid cres ccnv ccom wrex cvv wb elfvex isust simp1d unissd
      ibi unipw syl6sseq eqssd dmeqd syl5eqr ) ABEFGZBBBHZIAJZIBKUSUTVAUSUTVAUS
      UTAGZUTVALABMUTANOUSVAUTPZJUTUSAVCUSAVCLZVBCQZDQZLVFAGRDVCSVEVFUAAGDASUBB
      UCVELVEUDAGVFVFUEVELDAUFTTCASZUSVDVBVGTZUSBUGGUSVHUHABEUIDCABUJOUMUKULUTU
      NUOUPUQUR $.
  $}

  ${
    $d u U $.  $d u X $.
    $( The set union of a uniform structure is the cross product of its base.
       (Contributed by Thierry Arnoux, 5-Dec-2017.) $)
    ustuni $p |- ( U e. ( UnifOn ` X ) -> U. U = ( X X. X ) ) $=
      ( vu cust cfv wcel cxp cpw wss cuni wceq ustbasel cv wral ralrimiva pwssb
      ustssxp sylibr elpwuni biimpa syl2anc ) ABDEFZBBGZAFZAUCHIZAJUCKZABLUBCMZ
      UCIZCANUEUBUHCAAUGBQOCAUCPRUDUEUFAUCSTUA $.
  $}

  ${
    $d x U $.  $d x X $.
    ustbas.1 $e |- X = dom U. U $.
    $( Recover the base of an uniform structure ` U ` . ` U. ran UnifOn ` is to
       ` UnifOn ` what ` Top ` is to ` TopOn ` .  (Contributed by Thierry
       Arnoux, 16-Nov-2017.) $)
    ustbas $p |- ( U e. U. ran UnifOn <-> U e. ( UnifOn ` X ) ) $=
      ( vx cust crn cuni wcel cfv cv cdm wrex cvv wfun ustfn fnfun elunirn mp2b
      wfn wb ustbas2 syl6eqr fveq2d eleq2d ibi rexlimivw sylbi elrnust impbii )
      AEFGHZABEIZHZUJADJZEIZHZDEKZLZULEMSENUJUQTOMEPDAEQRUOULDUPUOULUOUNUKAUOUM
      BEUOUMAGKBAUMUACUBUCUDUEUFUGABUHUI $.
  $}

  $( Lemma for ~ ustuqtop (Contributed by Thierry Arnoux, 5-Dec-2017.) $)
  ustimasn $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U /\ P e. X )
    -> ( V " { P } ) C_ X ) $=
    ( cust cfv wcel w3a csn crn imassrn cxp wss ustssxp 3adant3 rnxpid syl6sseq
    cima rnss syl syl5ss ) BDEFGZCBGZADGZHZCAIZRCJZDCUFKUECDDLZMZUGDMUBUCUIUDBC
    DNOUIUGUHJDCUHSDPQTUA $.

  ${
    $d u v w x y A $.  $d u v w x y U $.  $d u v w x X $.
    $( The trace of a uniform structure ` U ` on a subset ` A ` is a uniform
       structure on ` A ` .  Definition 3 of [BourbakiTop1] p.  II.9.
       (Contributed by Thierry Arnoux, 2-Dec-2017.) $)
    trust $p |- ( ( U e. ( UnifOn ` X ) /\ A C_ X )
      -> ( U |`t ( A X. A ) ) e. ( UnifOn ` A ) ) $=
      ( vv vw vu vx wcel wss wa cin cid ccom wrex w3a wceq cvv syl2anc syl21anc
      cv vy cust cfv cxp crest co cpw wi wral cres ccnv restsspw a1i inxp dfss1
      biimpi xpeq12d syl5eq adantl simpl elfvex adantr ustbasel elrestr syl3anc
      simpr ssexd xpexg eqeltrrd ad5antr cun simplr simp-4r elpwid xpss12 sstrd
      ustssxp unssd ssun2 ustssel mpi df-ss sylib uneq1d simpllr ssequn2 eqtr2d
      indir syl6eqr ineq1 eqeq2d rspcev elrest biimpar simp1 simp3 biimpa 3expa
      eqsstr3d 3adant3 ad2antrr r19.29a ralrimiva ustincl simprl simprr ineq12d
      ex inindir reeanv sylanbrc r19.29_2a simp-4l ustdiag cdm inss1 resss mpbi
      sstri iss wbr ssel2 equid resieq mpbiri breq2 dminxp sylibr reseq2d ssrin
      syl5req eqsstrd sseqtr4d ad3antrrr ustinvel coss1 coss2 ax-mp mpbird 3jca
      cnveqd cnvin cnvxp ineq2i eqtri syl6eq sstr inss2 xpidtr ssind id coeq12d
      mpan sseq1d ustexhalf adantlr sseq2d rexbidv wb isust syl ) BCUBUCZHZACIZ
      JZBAAUDZUEUFZAUBUCHZUVGUVFUGZIZUVFUVGHZDTZETZIZUVMUVGHZUHZEUVIUIZUVLUVMKZ
      UVGHZEUVGUIZLAUJZUVLIZUVLUKZUVGHZUVMUVMMZUVLIZEUVGNZOZOZDUVGUIZOZUVEUVJUV
      KUWJUVJUVEUVFBULUMUVECCUDZUVFKZUVFUVGUVDUWMUVFPUVCUVDUWMCAKZUWNUDUVFCCAAU
      NUVDUWNAUWNAUVDUWNAPACUOUPZUWOUQURUSUVEUVCUVFQHZUWLBHZUWMUVGHUVCUVDUTZUVE
      AQHZUWSUWPUVEACQUVCCQHUVDBCUBVAVBUVCUVDVFZVGZUXAAAQQVHRZUVCUWQUVDBCVCVBUW
      LUVFBUVBQVDVEVIUVEUWIDUVGUVEUVLUVGHZJZUVQUVTUWHUXDUVPEUVIUXDUVMUVIHZJZUVN
      UVOUXFUVNJZUVLFTZUVFKZPZUVOFBUXGUXHBHZJZUXJJZUVCUWPUVMGTZUVFKZPZGBNZUVOUV
      EUVCUXCUXEUVNUXKUXJUWRVJZUVEUWPUXCUXEUVNUXKUXJUXBVJUXMUVMUXHVKZBHZUVMUXSU
      VFKZPZUXQUXMUVCUXKUXSUWLIZUXTUXRUXGUXKUXJVLZUXMUVMUXHUWLUXMUVMUVFUWLUXMUV
      MUVFUXDUXEUVNUXKUXJVMVNZUXMUVDUVDUVFUWLIUVEUVDUXCUXEUVNUXKUXJUWTVJZUYFACA
      CVORVPUXMUVCUXKUXHUWLIUXRUYDBUXHCVQRVRUVCUXKUYCOUXHUXSIUXTUXHUVMVSBUXHUXS
      CVTWAVEUXMUVMUVMUVFKZUXIVKZUYAUXMUYHUVMUXIVKZUVMUXMUYGUVMUXIUXMUVMUVFIUYG
      UVMPUYEUVMUVFWBWCWDUXMUXIUVMIUYIUVMPUXMUXIUVLUVMUXLUXJVFUXFUVNUXKUXJWEWSU
      XIUVMWFWCWGUVMUXHUVFWHWIUXPUYBGUXSBUXNUXSPUXOUYAUVMUXNUXSUVFWJWKWLRUVCUWP
      JZUVOUXQGUVMUVFBUVBQWMZWNSUXDUXJFBNZUXEUVNUVCUVDUXCUYLUVCUVDUXCOUVCUWPUXC
      UYLUVCUVDUXCWOUVCUVDUWPUXCUXBWTUVCUVDUXCWPUYJUXCUYLFUVLUVFBUVBQWMWQSWRZXA
      XBXHXCUXDUVSEUVGUXDUVOJZUXJUXPJZUVSFGBBUYNUXKJZUXNBHZJZUYOJZUVCUWPUVRUATZ
      UVFKZPZUABNZUVSUVEUVCUXCUVOUXKUYQUYOUWRVJZUVEUWPUXCUVOUXKUYQUYOUXBVJUYSUX
      HUXNKZBHZUVRVUEUVFKZPZVUCUYSUVCUXKUYQVUFVUDUYNUXKUYQUYOWEUYPUYQUYOVLBUXHU
      XNCXDVEUYSUVRUXIUXOKVUGUYSUVLUXIUVMUXOUYRUXJUXPXEUYRUXJUXPXFXGUXHUXNUVFXI
      WIVUBVUHUAVUEBUYTVUEPVUAVUGUVRUYTVUEUVFWJWKWLRUYJUVSVUCUAUVRUVFBUVBQWMWNS
      UYNUYLUXQUYOGBNFBNUXDUYLUVOUYMVBUYNUVCUWPUVOUXQUVEUVCUXCUVOUWRXAUVEUWPUXC
      UVOUXBXAUXDUVOVFUYJUVOUXQUYKWQSUXJUXPFGBBXJXKXLXCUXDUWBUWDUWGUXDUXJUWBFBU
      XDUXKJZUXJJZUWAUXIUVLVUJLCUJZUXHIZUVDUWAUXIIVUJUVCUXKVULUVCUVDUXCUXKUXJXM
      ZUXDUXKUXJVLZBUXHCXNRUVCUVDUXCUXKUXJVMZVULUVDJUWAVUKUVFKZUXIUVDUWAVUPPVUL
      UVDVUPLVUPXOZUJZUWAVUPLIVUPVURPVUPVUKLVUKUVFXPLCXQXSVUPXTXRUVDVUQALUVDUXH
      UVLVUKYAZDANZFAUIVUQAPUVDVUTFAUVDUXHAHZJZVVAUXHUXHVUKYAZVUTUVDVVAVFVVBUXH
      CHZVVDVVCACUXHYBZVVEVVDVVDJVVCUXHUXHPFYCCUXHUXHYDYERVUSVVCDUXHAUVLUXHUXHV
      UKYFWLRXCFDAAVUKYGYHYIYKUSVULVUPUXIIUVDVUKUXHUVFYJVBYLRVUIUXJVFZYMUYMXBUX
      DUXJUWDFBVUJUVCUWPUWCUXOPZGBNZUWDVUMUVEUWPUXCUXKUXJUXBYNVUJUXHUKZBHZUWCVV
      IUVFKZPZVVHVUJUVCUXKVVJVUMVUNBUXHCYORVUJUWCUXIUKZVVKVUJUVLUXIVVFUUAVVMVVI
      UVFUKZKVVKUXHUVFUUBVVNUVFVVIAAUUCUUDUUEUUFVVGVVLGVVIBUXNVVIPUXOVVKUWCUXNV
      VIUVFWJWKWLRUYJUWDVVHGUWCUVFBUVBQWMWNSUYMXBUXDUXJUWGFBVUJUWGUWEUXIIZEUVGN
      ZVUJUVCUVDUXKVVPVUMVUOVUNUVEUXKJZUXNUXNMZUXHIZVVPGBVVQUYQJZVVSJZUXOUVGHZU
      XOUXOMZUXIIZVVPVWAUVCUWPUYQVWBUVCUVDUXKUYQVVSXMUVEUWPUXKUYQVVSUXBYNVVQUYQ
      VVSVLUXNUVFBUVBQVDVEVWAVWCUXHUVFVVSVWCUXHIZVVTVWCVVRIZVVSVWEUXOUXNIZVWFUX
      NUVFXPVWGVWCUXNUXOMVVRUXOUXNUXOYPUXOUXNUXNYQVPYRVWCVVRUXHUUGUUMUSVWCUVFIV
      WAVWCUVFUVFMZUVFUXOUVFIZVWCVWHIUXNUVFUUHVWIVWCUVFUXOMVWHUXOUVFUXOYPUXOUVF
      UVFYQVPYRAUUIXSUMUUJVVOVWDEUXOUVGUXPUWEVWCUXIUXPUVMUXOUVMUXOUXPUUKZVWJUUL
      UUNWLRUVCUXKVVSGBNUVDGBUXHCUUOUUPXBSVUJUWFVVOEUVGVUJUVLUXIUWEVVFUUQUURYSU
      YMXBYTYTXCYTUVEUWSUVHUWKUUSUXAEDUVGAUUTUVAYS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The topology induced by an uniform structure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c unifTop $. $( The function producing the topology induced. $)

  $( Extend class notation with the function inducing a topology from a uniform
     structure. $)
  cutop $a class unifTop $.

  ${
    $d a u v x $.
    $( Definition of a topology induced by a uniform structure.  Definition 3
       of [BourbakiTop1] p.  II.4.  (Contributed by Thierry Arnoux,
       17-Nov-2017.) $)
    df-utop $a |- unifTop = ( u e. U. ran UnifOn |-> { a e. ~P dom U. u |
      A. x e. a E. v e. u ( v " { x } ) C_ a } ) $.
  $}

  ${
    $d a u v x U $.  $d a u x X $.
    $( The topology induced by a uniform structure ` U ` .  (Contributed by
       Thierry Arnoux, 30-Nov-2017.) $)
    utopval $p |- ( U e. ( UnifOn ` X ) -> ( unifTop ` U ) = { a e. ~P X |
      A. x e. a E. v e. U ( v " { x } ) C_ a } ) $=
      ( vu cust cfv wcel cv csn wrex wral cuni cdm cpw crab cutop cvv wceq cima
      wss crn cmpt df-utop a1i simpr unieqd dmeqd ustbas2 adantr eqtr4d rexeqdv
      wa pweqd ralbidv rabeqbidv elrnust elfvex pwexg rabexg 3syl fvmptd ) CDGH
      IZFCBJAJKUAEJZUBZBFJZLZAVEMZEVGNZOZPZQZVFBCLZAVEMZEDPZQZGUCNZRSRFVRVMUDTV
      DABFEUEUFVDVGCTZUNZVIVOEVLVPVTVKDVTVKCNZOZDVTVJWAVTVGCVDVSUGZUHUIVDDWBTVS
      CDUJUKULUOVTVHVNAVEVTVFBVGCWCUMUPUQCDURVDDSIVPSIVQSICDGUSDSUTVOEVPSVAVBVC
      $.
  $}

  ${
    $d a v x A $.  $d a v x U $.  $d a x X $.
    $( Open sets in the topology induced by an uniform structure ` U ` on ` X `
       (Contributed by Thierry Arnoux, 30-Nov-2017.) $)
    elutop $p |- ( U e. ( UnifOn ` X ) -> ( A e. ( unifTop ` U ) <->
      ( A C_ X /\ A. x e. A E. v e. U ( v " { x } ) C_ A ) ) ) $=
      ( va cust cfv wcel cutop cpw cv csn wss wrex wral wa cvv wi a1i cima crab
      utopval eleq2d wceq sseq2 raleqbi1dv elrab syl6bb elex elfvex simpr ssexd
      rexbidv adantr ex wb elpwg pm5.21ndd anbi1d bitrd ) DEGHIZCDJHZIZCEKZIZBL
      ALMUAZCNZBDOZACPZQZCENZVJQVBVDCVGFLZNZBDOZAVMPZFVEUBZIVKVBVCVQCABDEFUCUDV
      PVJFCVEVOVIAVMCVMCUEVNVHBDVMCVGUFUNUGUHUIVBVFVLVJVBCRIZVFVLVFVRSVBCVEUJTV
      BVLVRVBVLQCERVBERIVLDEGUKUOVBVLULUMUPVRVFVLUQSVBCERURTUSUTVA $.
  $}

  ${
    $d a p u v w x y U $.  $d a p u v x y X $.
    $( The topology induced by a uniform structure ` U ` is a topology.
       (Contributed by Thierry Arnoux, 30-Nov-2017.) $)
    utoptop $p |- ( U e. ( UnifOn ` X ) -> ( unifTop ` U ) e. Top ) $=
      ( vx vy vv vp va vw vu wcel cv wss wral wa cima wrex adantr elutop simprd
      simpr cust cfv cutop cuni wi wal cin ctop csn cpw utopval ssrab2 syl6eqss
      crab sstrd sspwuni simp-4l simp-4r simplr sseldd biimpa r19.21bi syl21anc
      sylib r19.41v ssuni reximi sylbir syl2anc eluni2 biimpi r19.29a ralrimiva
      adantl wb mpbir2and ex alrimiv simpld adantrr ssinss1 syl simpr31 simpr32
      simpl ustincl syl3anc inss1 imass1 ax-mp simpr33 syl5ss inss2 wceq imaeq1
      ssind sseq1d rspcev 3anassrs simpll simplrl elin simplrr reeanv r19.29_2a
      w3a sylanbrc ralrimivva cvv fvex istopg ) ABUAUBJZCKZAUCUBZLZXMUDZXNJZUEZ
      CUFZXMDKZUGZXNJZDXNMCXNMZXNUHJZXLXRCXLXOXQXLXONZXQXPBLZEKZFKZUIZOZXPLZEAP
      ZFXPMZYEXMBUJZLYFYEXMXNYNXLXOTXLXNYNLXOXLXNYJGKZLEAPFYOMZGYNUNYNFEABGUKYP
      GYNULUMQUOXMBUPVDYEYLFXPYEYHXPJZNZYHXTJZYLDXMYRXTXMJZNZYSNZYJXTLZEAPZYTYL
      UUBXLXTXNJZYSUUDXLXOYQYTYSUQUUBXMXNXTXLXOYQYTYSURYRYTYSUSZUTUUAYSTXLUUENZ
      UUDFXTUUGXTBLZUUDFXTMZXLUUEUUHUUINFEXTABRVASVBZVCUUFUUDYTNUUCYTNZEAPYLUUC
      YTEAVEUUKYKEAYJXTXMVFVGVHVIYQYSDXMPZYEYQUULDYHXMVJVKVNVLVMXLXQYFYMNVOXOFE
      XPABRQVPVQVRXLYBCDXNXNXLXMXNJZUUENZNZYBYABLZHKZYIOZYALZHAPZFYAMZUUOXMBLZU
      UPXLUUMUVBUUEXLUUMNZUVBIKZYIOZXMLZIAPZFXMMZXLUUMUVBUVHNFIXMABRVAZVSVTXMXT
      BWAWBUUOUUTFYAUUOYHYAJZNZUVFUUCNZUUTIEAAUVKUVDAJZYGAJZUVLUUTXLUUNUVJUVMUV
      NUVLXFZUUTXLUUNUVJUVOXFZNZUVDYGUGZAJZUVRYIOZYALZUUTUVQXLUVMUVNUVSXLUVPWEU
      VMUVNUVLUUNUVJXLWCUVMUVNUVLUUNUVJXLWDAUVDYGBWFWGUVQUVTXMXTUVQUVTUVEXMUVRU
      VDLUVTUVELUVDYGWHUVRUVDYIWIWJUVQUVFUUCUVMUVNUVLUUNUVJXLWKZVSWLUVQUVTYJXTU
      VRYGLUVTYJLUVDYGWMUVRYGYIWIWJUVQUVFUUCUWBSWLWPUUSUWAHUVRAUUQUVRWNUURUVTYA
      UUQUVRYIWOWQWRVIWSWSUVKUVGUUDUVLEAPIAPUVKXLUUMYHXMJZUVGXLUUNUVJWTZXLUUMUU
      EUVJXAUVKUWCYSUVKUVJUWCYSNUUOUVJTYHXMXTXBVDZVSUVCUVGFXMUVCUVBUVHUVISVBVCU
      VKXLUUEYSUUDUWDXLUUMUUEUVJXCUVKUWCYSUWESUUJVCUVFUUCIEAAXDXGXEVMXLYBUUPUVA
      NVOUUNFHYAABRQVPXHXNXIJYDXSYCNVOAUCXJCDXIXNXKWJXG $.

    $( The base of the topology induced by a uniform structure ` U ` .
       (Contributed by Thierry Arnoux, 5-Dec-2017.) $)
    utopbas $p |- ( U e. ( UnifOn ` X ) -> X = U. ( unifTop ` U ) ) $=
      ( vv vx va cust cfv wcel cutop cuni cpw wss wceq cv csn cima wrex crn syl
      wral crab utopval ssrab2 syl6eqss wb ssid a1i wa cxp ustssxp imassrn rnss
      rnxpid syl6sseq syl5ss ralrimiva c0 wne wi ustne0 r19.2zb sylib ralrimivw
      mpd elutop mpbir2and elpwuni mpbid eqcomd ) ABFGHZAIGZJZBVJVKBKZLZVLBMZVJ
      VKCNZDNOZPZENZLCAQDVSTZEVMUAVMDCABEUBVTEVMUCUDVJBVKHZVNVOUEVJWABBLZVRBLZC
      AQZDBTWBVJBUFUGVJWDDBVJWCCATZWDVJWCCAVJVPAHUHVPBBUIZLZWCAVPBUJWGVRVPRZBVP
      VQUKWGWHWFRBVPWFULBUMUNUOSUPVJAUQURWEWDUSABUTWCCAVAVBVDVCDCBABVEVFVKBVGSV
      HVI $.
  $}

  $( Topology induced by a uniform structure ` U ` with its base set.
     (Contributed by Thierry Arnoux, 5-Jan-2018.) $)
  utoptopon $p |- ( U e. ( UnifOn ` X )
         -> ( unifTop ` U ) e. ( TopOn ` X ) ) $=
    ( cust wcel cutop ctop cuni wceq ctopon utoptop utopbas istopon sylanbrc
    cfv ) ABCNDAENZFDBOGHOBINDABJABKBOLM $.

  ${
    $d a b u v x A $.  $d a b u v x U $.  $d a b u x X $.
    $( Restriction of a topology induced by an uniform structure (Contributed
       by Thierry Arnoux, 12-Dec-2017.) $)
    restutop $p |- ( ( U e. ( UnifOn ` X ) /\ A C_ X ) ->
      ( ( unifTop ` U ) |`t A ) C_ ( unifTop ` ( U |`t ( A X. A ) ) ) ) $=
      ( vv vx va vu cust cfv wcel wss wa cutop cv cima wrex cin cvv syl2anc crn
      vb crest co cxp csn wral simpl wceq wb fvex a1i elfvex adantr simpr ssexd
      elrest biimpa inss2 sseq1 mpbiri rexlimivw simp-5l ad2antrr ad6antr xpexg
      syl simplr elrestr syl3anc inss1 imass1 ax-mp sstr mpan rnin sstri rnxpid
      imassrn sseqtri ssind adantl simpllr sseqtr4d imaeq1 sseq1d rspcev sseldi
      eleqtrd elutop simplbda r19.21bi syl21anc r19.29a ralrimiva trust biimpar
      syl12anc ex ssrdv ) BCHIZJZACKZLZUABMIZAUBUCZBAAUDZUBUCZMIZXCUANZXEJZXIXH
      JZXCXJLZXCXIAKZDNZENZUEZOZXIKZDXGPZEXIUFZXKXCXJUGXLXIFNZAQZUHZFXDPZXMXCXJ
      YDXCXDRJZARJZXJYDUIYEXCBMUJUKXCACRXACRJXBBCHULUMXAXBUNUOZFXIAXDRRUPSUQZYC
      XMFXDYCXMYBAKYAAURXIYBAUSUTVAVFXLXSEXIXLXOXIJZLZYCXSFXDYJYAXDJZLZYCLZGNZX
      POZYAKZXSGBYMYNBJZLZYPLZYNXFQZXGJZYTXPOZXIKZXSYSXAXFRJZYQUUAYMXAYQYPXAXBX
      JYIYKYCVBZVCYSYFYFUUDXCYFXJYIYKYCYQYPYGVDZUUFAARRVESYMYQYPVGYNXFBWTRVHVIY
      SUUBYBXIYPUUBYBKYRYPUUBYAAUUBYOKZYPUUBYAKYTYNKUUGYNXFVJYTYNXPVKVLUUBYOYAV
      MVNUUBAKYPUUBXFTZAUUBYNTZUUHQZUUHUUBYTTUUJYTXPVRYNXFVOVPUUIUUHURVPAVQVSUK
      VTWAYLYCYQYPWBWCXRUUCDYTXGXNYTUHXQUUBXIXNYTXPWDWEWFSYMXAYKXOYAJYPGBPZUUEY
      JYKYCVGYMYBYAXOYAAVJYMXOXIYBXLYIYKYCWBYLYCUNWHWGXAYKLUUKEYAXAYKYACKUUKEYA
      UFEGYABCWIWJWKWLWMXLYDYIYHUMWMWNXCXKXMXTLZXCXGAHIJXKUULUIABCWOEDXIXGAWIVF
      WPWQWRWS $.
  $}

  ${
    $d a b t u w x A $.  $d a b t u v w x U $.  $d b t u w x X $.
    $( The restriction of the topology induced by an uniform structure to an
       open set.  (Contributed by Thierry Arnoux, 16-Dec-2017.) $)
    restutopopn $p |- ( ( U e. ( UnifOn ` X ) /\ A e. ( unifTop ` U ) )
      -> ( ( unifTop ` U ) |`t A ) = ( unifTop ` ( U |`t ( A X. A ) ) ) ) $=
      ( vt vx va vv vu vw cfv wcel wa wss cv cima wrex cin wceq wb cvv vb cutop
      cust crest co cxp wral elutop simprbda restutop syldan trust adantr sstrd
      csn simp-9l simplr simp-4r ustincl syl3anc inimass adantl simpllr imaeq1d
      syl ssrin ad5antr simp-5r sseldd ad2antrr vex inimasn ax-mp c0 wne disjsn
      bicomi necon1abii xpima2 sylbir ineq2d syl5eq incom syl6eq eqtrd sseqtr4d
      syl5ss imaeq1 sseq1d rspcev syl2anc simp-4l simplbda r19.29a xpexg anidms
      r19.21bi elrest sylan2 biimpa ralrimiva mpbir2and df-ss sylib eqcomd fvex
      wn ineq1 eqeq2d mpan ad2antlr mpbird ex ssrdv eqssd ) BCUCJZKZABUBJZKZLZX
      RAUDUEZBAAUFZUDUEZUBJZXQXSACMZYAYDMXQXSYEDNZENZUOZOZAMZDBPZEAUGZEDABCUHZU
      IZABCUJUKXTUAYDYAXTUANZYDKZYOYAKZXTYPLZYQYOFNZAQZRZFXRPZYRYOXRKZYOYOAQZRZ
      UUBYRUUCYOCMZGNZYHOZYOMZGBPZEYOUGZYRYOACXTYPYOAMZHNZYHOZYOMZHYCPZEYOUGZXT
      YCAUCJKZYPUULUUQLSXQXSYEUURYNABCULUKEHYOYCAUHVEZUIZXTYEYPYNUMUNYRUUJEYOYR
      YGYOKZLZUUOUUJHYCUVBUUMYCKZLZUUOLZUUMINZYBQZRZUUJIBUVEUVFBKZLZUVHLZYJUUJD
      BUVKYFBKZLZYJLZYFUVFQZBKZUVOYHOZYOMZUUJUVNXQUVLUVIUVPXQXSYPUVAUVCUUOUVIUV
      HUVLYJUPUVKUVLYJUQUVEUVIUVHUVLYJURBYFUVFCUSUTUVNUVQYIUVFYHOZQZYOYFUVFYHVA
      UVNUVTUUNYOUVNUVTAUVSQZUUNYJUVTUWAMUVMYIAUVSVFVBUVNUUNUVGYHOZUWAUVNUUMUVG
      YHUVJUVHUVLYJVCVDUVNYGAKZUWBUWARUVKUWCUVLYJUVKYOAYGYRUULUVAUVCUUOUVIUVHUU
      TVGYRUVAUVCUUOUVIUVHVHVIZVJUWCUWBUVSAQZUWAUWCUWBUVSYBYHOZQZUWEYGTKUWBUWGR
      EVKUVFYBYGTVLVMUWCUWFAUVSUWCAYHQZVNVOUWFARUWCUWHVNUWHVNRUWCXGAYGVPVQVRAAY
      HVSVTWAWBUVSAWCWDVEWEWFUVDUUOUVIUVHUVLYJVHUNWGUUIUVRGUVOBUUGUVORUUHUVQYOU
      UGUVOYHWHWIWJWKUVKXTUWCYKUVEXTUVIUVHXTYPUVAUVCUUOWLZVJUWDXTYKEAXQXSYEYLYM
      WMWQWKWNUVEXTUVCUVHIBPZUWIUVBUVCUUOUQXTUVCUWJXSXQYBTKZUVCUWJSXSUWKAAXRXRW
      OWPIUUMYBBXPTWRWSWTWKWNYRUUPEYOXTYPUULUUQUUSWMWQWNXAXQUUCUUFUUKLSXSYPEGYO
      BCUHVJXBYRUUDYOYRUULUUDYORUUTYOAXCXDXEUUAUUEFYOXRYSYORYTUUDYOYSYOAXHXIWJW
      KXSYQUUBSZXQYPXRTKXSUWLBUBXFFYOAXRTXRWRXJXKXLXMXNXO $.
  $}

  ${
    $d w A $.  $d q v w P $.  $d p q v w U $.  $d p q v X $.
    utopustuq.1 $e |- N = ( p e. X |-> ran ( v e. U |-> ( v " { p } ) ) ) $.
    $( Lemma for ~ ustuqtop (Contributed by Thierry Arnoux, 11-Jan-2018.) $)
    ustuqtoplem $p |- ( ( ( U e. ( UnifOn ` X ) /\ P e. X ) /\ A e. V ) ->
      ( A e. ( N ` P ) <-> E. w e. U A = ( w " { P } ) ) ) $=
      ( vq wcel wa cv csn cima cmpt crn wceq cvv cust cfv simpl sneqd mpteq2dva
      wrex imaeq2d rneqd cbvmptv eqtri a1i w3a simpr2 3anassrs simpr mptexg syl
      rnexg adantr fvmptd eleq2d imaeq1 elrnmpt sylan9bb ) EHUAUBZLZDHLZMZCDFUB
      ZLCBEBNZDOZPZQZRZLCGLCANZVKPZSAEUFVHVIVNCVHKDBEVJKNZOZPZQZRZVNHFTFKHWAQZS
      VHFIHBEVJINZOZPZQZRZQWBJIKHWGWAWCVQSZWFVTWHBEWEVSWHVJELZMZWDVRVJWJWCVQWHW
      IUCUDUGUEUHUIUJUKVHVQDSZMZVTVMWLBEVSVLVFVGWKWIVSVLSVFVGWKWIULMZVRVKVJWMVQ
      DVFVGWKWIUMUDUGUNUEUHVFVGUOVFVNTLZVGVFVMTLWNBEVLVEUPVMTURUQUSUTVAAEVPCVMG
      BAEVLVPVJVOVKVBUIVCVD $.

    $d a b c j p q r u w N $.  $d a b j p q r u v w x U $.
    $d a b c j p q r u v w X $.
    $( Lemma for ~ ustuqtop (Contributed by Thierry Arnoux, 11-Jan-2018.) $)
    ustuqtop0 $p |- ( U e. ( UnifOn ` X ) -> N : X --> ~P ~P X ) $=
      ( cust cfv wcel cv csn cima cmpt crn cpw wa wss cvv wb elpwg ustimasn vex
      wral 3expa an32s imaexg mp2b sylibr ralrimiva eqid rnmptss syl rnexg 3syl
      mptexg adantr mpbird fmptd ) BDGHZIZEDABAJZEJZKZLZMZNZDOZOZCUTVBDIZPZVFVH
      IZVFVGQZVJVDVGIZABUCVLVJVMABVJVABIZPVDDQZVMUTVNVIVOUTVNVIVOVBBVADUAUDUEVA
      RIVDRIVMVOSAUBVAVCRUFVDDRTUGUHUIABVDVGVEVEUJUKULUTVKVLSZVIUTVERIVFRIVPABV
      DUSUOVERUMVFVGRTUNUPUQFUR $.

    $( Lemma for ~ ustuqtop , similar to ~ ssnei2 (Contributed by Thierry
       Arnoux, 11-Jan-2018.) $)
    ustuqtop1 $p |- ( ( ( ( U e. ( UnifOn ` X ) /\ p e. X )
      /\ a C_ b /\ b C_ X ) /\ a e. ( N ` p ) ) -> b e. ( N ` p ) ) $=
      ( vu vw wcel cv wa wss w3a cima wceq cun 3anassrs cvv cfv csn cxp simpl1l
      cust wrex simplr ustssxp syl2anc simpl1r snssd simpl3 unssd ssun1 ustssel
      xpss12 a1i imp syl31anc simpl2 ssequn1 biimpi id cin c0 wne inidm eqnetri
      vex snnz xpima2 eqcomd uneq12d imaundir syl6eqr sylan9req sylancom imaeq1
      mp1i eqeq2d rspcev wb ustuqtoplem mpan2 biimpa 3ad2antl1 r19.29a 3ad2ant1
      adantr mpbird ) BDUEUAKZELZDKZMZFLZGLZNZWPDNZOZWOWLCUAZKZMZWPWTKZWPILZWLU
      BZPZQZIBUFZXBWOJLZXEPZQZXHJBXBXIBKZMZXKMZXIXEWPUCZRZBKZWPXPXEPZQZXHXNWKXL
      XPDDUCZNZXIXPNZXQWSXAXLXKWKWKWMWQWRXAXLXKOZUDSZXBXLXKUGZXNXIXOXTXNWKXLXIX
      TNYDYEBXIDUHUIXNXEDNWRXOXTNXNWLDWSXAXLXKWMWKWMWQWRYCUJSUKWSXAXLXKWRWNWQWR
      YCULSXEDWPDUPUIUMYBXNXIXOUNUQWKXLYAOYBXQBXIXPDUOURUSXMXKWQXSWSXAXLXKWQWNW
      QWRYCUTSWQXKWPWOWPRZXRWQYFWPQWOWPVAVBXKYFXJXOXEPZRXRXKWOXJWPYGXKVCXKYGWPX
      EXEVDZVEVFYGWPQXKYHXEVEXEVGWLEVIVJVHXEWPXEVKVSVLVMXIXOXEVNVOVPVQXGXSIXPBX
      DXPQXFXRWPXDXPXEVRVTWAUIWNWQXAXKJBUFZWRWNXAYIWNWOTKXAYIWBFVIJAWOWLBCTDEHW
      CWDWEWFWGWSXCXHWBZXAWNWQYJWRWNWPTKYJGVIIAWPWLBCTDEHWCWDWHWIWJ $.

    $( Lemma for ~ ustuqtop (Contributed by Thierry Arnoux, 11-Jan-2018.) $)
    ustuqtop2 $p |- ( ( U e. ( UnifOn ` X ) /\ p e. X )
      -> ( fi ` ( N ` p ) ) C_ ( N ` p ) ) $=
      ( va vb vw vu vx cfv wcel cv wa wceq cin cima cvv wb cust cfi wss simp-6l
      wral csn wrex simp-7l simp-4r simplr ustincl syl3anc simpllr ineq12 ax-mp
      vex inimasn syl6eqr sylancom imaeq1 eqeq2d rspcev inex1 ustuqtoplem mpan2
      syl2anc biimpar simp-4l biimpa r19.29a adantr ralrimiva fvex inficl sylib
      eqimss syl ) BDUALMZENZDMZOZVSCLZUBLZWBPZWCWBUCWAGNZHNZQZWBMZHWBUEZGWBUEZ
      WDWAWIGWBWAWEWBMZOZWHHWBWLWFWBMZOZWEINZVSUFZRZPZWHIBWNWOBMZOZWROZWFJNZWPR
      ZPZWHJBXAXBBMZOZXDOZWAWGKNZWPRZPZKBUGZWHWAWKWMWSWRXEXDUDXGWOXBQZBMZWGXLWP
      RZPZXKXGVRWSXEXMVRVTWKWMWSWRXEXDUHWNWSWRXEXDUIXAXEXDUJBWOXBDUKULXFXDWRXOW
      TWRXEXDUMWRXDOWGWQXCQZXNWEWQWFXCUNVSSMXNXPPEUPWOXBVSSUQUOURUSXJXOKXLBXHXL
      PXIXNWGXHXLWPUTVAVBVFWAWHXKWAWGSMWHXKTWEWFGUPZVCKAWGVSBCSDEFVDVEVGVFXAWAW
      MXDJBUGZWAWKWMWSWRVHWLWMWSWRUMWAWMXRWAWFSMWMXRTHUPJAWFVSBCSDEFVDVEVIVFVJW
      LWRIBUGZWMWAWKXSWAWESMWKXSTXQIAWEVSBCSDEFVDVEVIVKVJVLVLWBSMWJWDTVSCVMGHWB
      SVNUOVOWCWBVPVQ $.

    $( Lemma for ~ ustuqtop , similar to ~ elnei (Contributed by Thierry
       Arnoux, 11-Jan-2018.) $)
    ustuqtop3 $p |- ( ( ( U e. ( UnifOn ` X ) /\ p e. X ) /\ a e. ( N ` p ) )
      -> p e. a ) $=
      ( vw cust cfv wcel cv wa csn cima wceq cid wss ad4antlr cvv fnresi fnsnfv
      cres wfn mpan simp-4l simplr ustdiag syl2anc imass1 syl eqsstrd fvex snss
      sylibr fvresi eqcomd simpr 3eltr4d wrex wb vex ustuqtoplem biimpa r19.29a
      mpan2 ) BDIJKZELZDKZMZFLZVHCJKZMZVKHLZVHNZOZPZVHVKKHBVMVNBKZMZVQMZVHQDUCZ
      JZVPVHVKVTWBNZVPRWBVPKVTWCWAVOOZVPVIWCWDPZVGVLVRVQWADUDVIWEDUADVHWAUBUESV
      TWAVNRZWDVPRVTVGVRWFVGVIVLVRVQUFVMVRVQUGBVNDUHUIWAVNVOUJUKULWBVPVHWAUMUNU
      OVIVHWBPVGVLVRVQVIWBVHDVHUPUQSVSVQURUSVJVLVQHBUTZVJVKTKVLWGVAFVBHAVKVHBCT
      DEGVCVFVDVE $.

    $( Lemma for ~ ustuqtop (Contributed by Thierry Arnoux, 11-Jan-2018.) $)
    ustuqtop4 $p |- ( ( ( U e. ( UnifOn ` X ) /\ p e. X ) /\ a e. ( N ` p ) )
      -> E. b e. ( N ` p ) A. q e. b a e. ( N ` q ) ) $=
      ( vw wcel cv wa wceq wrex wss cvv wb syl2anc syl vu vr cust cfv cima wral
      csn ccom simplr eqid imaeq1 eqeq2d rspcev mpan2 adantl imaexg ustuqtoplem
      simplll sylan2 mpbird w3a simp-5l simpld simp-4r ustimasn syl3anc jca wbr
      sselda wrel simp-6l ustrel elrelimasn mpbid simpr wex vex biimpri 19.23bi
      brco simpllr ssbrd mpd simp-5r ex ssrdv adantr eqidd mpdan syl21anc sseq2
      3jca wi sseq1 3anbi23d anbi1d eleq1 imbi12d 3anbi2d anbi12d imbi1d anbi2d
      3anbi1d eleq2d ustuqtop1 chvarv vtoclg impcom ralrimiva ustexhalf adantlr
      fveq2 raleq r19.29a rexralbidv adantllr biimpa ) BDUCUDKZFLZDKZMZGLZXSCUD
      ZKZMYBJLZXSUGZUEZNZYBELZCUDZKZEHLZUFHYCOZJBYAYEBKZYHYMYDYAYNMZYHMYMYGYJKZ
      EYLUFZHYCOZYOYRYHYOUALZYSUHZYEPZYRUABYOYSBKZMZUUAMZYSYFUEZYCKZYPEUUEUFZYR
      UUDYAUUBUUFYAYNUUBUUAURZYOUUBUUAUIZYAUUBMUUFUUEYGNZJBOZUUBUUKYAUUBUUEUUEN
      ZUUKUUEUJUUJUULJYSBYEYSNZYGUUEUUEYEYSYFUKULUMUNUOUUBYAUUEQKUUFUUKRYSYFBUP
      JAUUEXSBCQDFIUQUSUTSUUDYPEUUEUUDYIUUEKZMZXRYIDKZMZYSYIUGZUEZYGPZYGDPZVAZU
      USYJKZMZUUBYNYPUUOUVBUVCUUOUUQUUTUVAUUOXRUUPXRXTYNUUBUUAUUNVBZUUDUUEDYIUU
      DXRUUBXTUUEDPUUDXRXTUUHVCUUIXRXTYNUUBUUAVDZXSBYSDVEVFVIZVGUUOUBUUSYGUUOUB
      LZUUSKZUVHYGKZUUOUVIMZUVJXSUVHYEVHZUVKXSUVHYTVHZUVLUVKXSYIYSVHZYIUVHYSVHZ
      UVMUVKUUNUVNUUDUUNUVIUIUVKYSVJZUUNUVNRUVKXRUUBUVPXRXTYNUUBUUAUUNUVIVKZYOU
      UBUUAUUNUVIVDBYSDVLSZXSYIYSVMTVNUVKUVIUVOUUOUVIVOUVKUVPUVIUVORUVRYIUVHYSV
      MTVNUVNUVOMZUVMEUVMUVSEVPEXSUVHYSYSFVQUBVQVTVRVSSUVKYTYEXSUVHUUCUUAUUNUVI
      WAWBWCUVKYEVJZUVJUVLRUVKXRYNUVTUVQYAYNUUBUUAUUNUVIWDBYEDVLSXSUVHYEVMTUTWE
      WFUUOXRYNXTUVAUVEYAYNUUBUUAUUNVDZUUDXTUUNUVFWGXSBYEDVEVFWLUUOXRUUPUUBUVCU
      VEUVGYOUUBUUAUUNWAZUUQUUBMUVCUUSYEUURUEZNZJBOZUUBUWEUUQUUBUUSUUSNZUWEUUBU
      USWHUWDUWFJYSBUUMUWCUUSUUSYEYSUURUKULUMWIUOUUBUUQUUSQKZUVCUWERYSUURBUPZJA
      UUSYIBCQDFIUQUSUTWJVGUWBUWAYNUVDUUBMZYPYNYGQKUWIYPWMZYEYFBUPUUQUUSYLPZYLD
      PZVAZUVCMZUUBMZYLYJKZWMUWJHYGQYLYGNZUWOUWIUWPYPUWQUWNUVDUUBUWQUWMUVBUVCUW
      QUWKUUTUWLUVAUUQYLYGUUSWKYLYGDWNWOWPWPYLYGYJWQWRUUBUWNUWPUUBUWGUWNUWPWMZU
      WHUUQYBYLPZUWLVAZYKMZUWPWMZUWRGUUSQYBUUSNZUXAUWNUWPUXCUWTUWMYKUVCUXCUWSUW
      KUUQUWLYBUUSYLWNWSYBUUSYJWQWTXAYAUWSUWLVAZYDMZYLYCKZWMUXBFEXSYINZUXEUXAUX
      FUWPUXGUXDUWTYDYKUXGYAUUQUWSUWLUXGXTUUPXRXSYIDWQXBXCUXGYCYJYBXSYICXLZXDWT
      UXGYCYJYLUXHXDWRABCDFGHIXEXFXGTXHXGTXHWJXIYQUUGHUUEYCYPEYLUUEXMUMSXRYNUUA
      UABOXTUABYEDXJXKXNWGYHYMYRRYOYHYKYPHEYCYLYBYGYJWQXOUOUTXPYAYDYHJBOZYAYBQK
      YDUXIRGVQJAYBXSBCQDFIUQUNXQXN $.

    $( Lemma for ~ ustuqtop (Contributed by Thierry Arnoux, 11-Jan-2018.) $)
    ustuqtop5 $p |- ( ( U e. ( UnifOn ` X ) /\ p e. X ) -> X e. ( N ` p ) ) $=
      ( vw cust cfv wcel cv wa csn cima wceq wrex adantr cin c0 cvv cxp wne wss
      ustbasel snssi sylib incom syl6req snnzg eqnetrd adantl xpima2 syl eqcomd
      dfss imaeq1 eqeq2d rspcev syl2anc wb elfvex ustuqtoplem mpdan mpbird ) BD
      HIJZEKZDJZLZDVFCIJZDGKZVFMZNZOZGBPZVHDDUAZBJZDVOVKNZOZVNVEVPVGBDUDQVHVQDV
      HDVKRZSUBZVQDOVGVTVEVGVSVKSVGVKVKDRZVSVGVKDUCVKWAOVFDUEVKDUOUFVKDUGUHVFDU
      IUJUKDDVKULUMUNVMVRGVOBVJVOOVLVQDVJVOVKUPUQURUSVHDTJZVIVNUTVEWBVGBDHVAQGA
      DVFBCTDEFVBVCVD $.

    $d x N $.  $d x X $.
    $( For a given uniform structure ` U ` on a set ` X ` , there is a unique
       topology ` j ` such that the set ` ran ( v e. U |-> ( v " { p } ) ) ` is
       the filter of the neighbourhoods of ` p ` for that topology.
       Proposition 1 of [BourbakiTop1] p.  II.3.  (Contributed by Thierry
       Arnoux, 11-Jan-2018.) $)
    ustuqtop $p |- ( U e. ( UnifOn ` X ) -> E! j e. ( TopOn ` X )
      A. p e. X ( N ` p ) = ( ( nei ` j ) ` { p } ) ) $=
      ( vc vr vx va vb cfv wcel cv cmpt wceq wreu wral cpw cust csn cnei ctopon
      fveq2 eleq2d cbvralv eleq1 raleqbi1dv syl5bbr cbvrabv ustuqtop0 ustuqtop1
      crab ustuqtop2 ustuqtop3 ustuqtop4 ustuqtop5 neiptopreu feqmptd eqeq1d wb
      cvv fvex rgenw mpteqb ax-mp syl6bb reubidv mpbid ) BEUAMNZDFEFOZUBCOUCMMZ
      PZQZCEUDMZRVLDMZVMQFESZCVPRVKCHOZIOZDMZNZIVSSZHETZUNDEJFKLWCKOZVQNZFWESZH
      KWDWCVSVQNZFVSSVSWEQWGWHWBFIVSVLVTQVQWAVSVLVTDUEUFUGWHWFFVSWEVSWEVQUHUIUJ
      UKABDEFGULZABDEFKLGUMABDEFGUOABDEFKGUPABDEJFKLGUQABDEFGURUSVKVOVRCVPVKVOF
      EVQPZVNQZVRVKDWJVNVKFEWDTDWIUTVAVQVCNZFESWKVRVBWLFEVLDVDVEFEVQVMVCVFVGVHV
      IVJ $.
  $}

  ${
    utoptop.1 $e |- J = ( unifTop ` U ) $.

    ${
      $d a p K $.  $d a b p q N $.  $d p v P $.  $d a b j p q u v w U $.
      $d a b j p q v w X $.
      utopsnneip.1 $e |- K = { a e. ~P X | A. p e. a a e. ( N ` p ) } $.
      utopsnneip.2 $e |- N = ( p e. X |-> ran ( v e. U |-> ( v " { p } ) ) ) $.
      $( The neighborhoods of a point ` P ` for the topology induced by an
         uniform space ` U ` .  (Contributed by Thierry Arnoux,
         11-Jan-2018.) $)
      utopsnneiplem $p |- ( ( U e. ( UnifOn ` X ) /\ P e. X ) ->
        ( ( nei ` J ) ` { P } ) = ran ( v e. U |-> ( v " { P } ) ) ) $=
        ( vw vb cfv wcel wa wceq simpr cvv vu vq cust csn cnei cv cima cmpt crn
        wral cpw crab wss wrex cutop utopval syl5eq simpll elpwid sselda mptexg
        wb rnexg syl adantr fvmpt2 syl2anc eleq2d vex eqid elrnmpt ax-mp syl6bb
        nfre1 nfan simplr eqimss2 adantl imaeq1 sseq1d rspcev r19.29af ad2antrr
        nfv weq ad3antrrr eqeq2d mpan2 imaexg ustuqtoplem mpbird syl21anc sseq1
        jca w3a wi 3anbi2d eleq1 anbi12d imbi1d ustuqtop1 vtoclg syl31anc mpbid
        mp2b adantllr impbida ralbidva rabbidva eqtr4d syl6eqr fveq2d ustuqtop0
        bitrd ustuqtop2 ustuqtop3 ustuqtop4 ustuqtop5 neiptopnei sneqd fvex a1i
        fveq1d fvmptd nfmpt1 nfel1 simpr2 imaeq2d 3anassrs mpteq2da rneqd simpl
        nfrn 3eqtr2d ) CGUCOZPZBGPZQZBUDZDUEOZOZYSEUEOZOZBFOZACAUFZYSUGZUHZUIZY
        PUUAUUCRYQYPYSYTUUBYPDEUEYPDIUFZHUFZFOZPZHUUIUJZIGUKZULZEYPDMUFZUUJUDZU
        GZUUIUMZMCUNZHUUIUJZIUUNULZUUOYPDCUOOUVBJHMCGIUPUQYPUUMUVAIUUNYPUUIUUNP
        ZQZUULUUTHUUIUVDUUJUUIPZQZUULUUIUUEUUQUGZRZACUNZUUTUVFYPUUJGPZUULUVIVBZ
        YPUVCUVEURZUVDUUIGUUJUVDUUIGYPUVCSUSZUTZYPUVJQZUULUUIACUVGUHZUIZPZUVIUV
        OUUKUVQUUIUVOUVJUVQTPZUUKUVQRYPUVJSYPUVSUVJYPUVPTPUVSACUVGYOVAUVPTVCVDV
        EHGUVQTFLVFVGVHUUITPUVRUVIVBIVIACUVGUUIUVPTUVPVJVKVLVMZVGUVFUVIUUTUVFUV
        IQZUVHUUTACUVFUVIAUVFAWDUVHACVNVOUWAUUECPZQZUVHQUWBUVGUUIUMZUUTUWAUWBUV
        HVPUVHUWDUWCUVGUUIVQVRUUSUWDMUUECMAWEUURUVGUUIUUPUUEUUQVSVTWAVGUVFUVISW
        BUVFUUTQUUSUVIMCUVFUUTMUVFMWDUUSMCVNVOUVFUUPCPZUUSUVIUUTUVFUWEQZUUSQZUU
        LUVIUWGUVOUUSUUIGUMZUURUUKPZUULUWGYPUVJUVFYPUWEUUSUVLWCZUVFUVJUWEUUSUVN
        WCZWNZUWFUUSSUVDUWHUVEUWEUUSUVMWFUWGYPUVJUWEUWIUWJUWKUVFUWEUUSVPUVOUWEQ
        UWIUURUAUFZUUQUGZRZUACUNZUWEUWPUVOUWEUURUURRZUWPUURVJUWOUWQUAUUPCUAMWEU
        WNUURUURUWMUUPUUQVSWGWAWHVRUVOUWIUWPVBZUWEUVOUURTPZUWRUUPTPZUWSMVIZUUPU
        UQTWIZVLUAAUURUUJCFTGHLWJWHVEWKWLUWTUWSUVOUUSUWHWOZUWIQZUULWPZUXAUXBUVO
        NUFZUUIUMZUWHWOZUXFUUKPZQZUULWPUXENUURTUXFUURRZUXJUXDUULUXKUXHUXCUXIUWI
        UXKUXGUUSUVOUWHUXFUURUUIWMWQUXFUURUUKWRWSWTACFGHNILXAXBXEXCUWGUVOUVKUWL
        UVTVDXDXFUVFUUTSWBXGXNXHXIXJKXKXLYCVEYRHBUUQUUBOZUUCGFTYPFHGUXLUHRYQYPE
        FGUBHINKACFGHLXMACFGHINLXAACFGHLXOACFGHILXPACFGUBHINLXQACFGHLXRXSVEYRUU
        JBRZQZUUQYSUUBUXNUUJBYRUXMSXTXLYPYQSZUUCTPYRYSUUBYAYBYDYRYQUUHTPZUUDUUH
        RUXOYPUXPYQYPUUGTPUXPACUUFYOVAUUGTVCVDVEYQUXPQZHBUVQUUHGFTFHGUVQUHRUXQL
        YBUXQUXMQZUVPUUGUXRACUVGUUFUXQUXMAYQUXPAYQAWDAUUHTAUUGACUUFYEYMYFVOUXMA
        WDVOYQUXPUXMUWBUVGUUFRYQUXPUXMUWBWOQZUUQYSUUEUXSUUJBYQUXPUXMUWBYGXTYHYI
        YJYKYQUXPYLYQUXPSYDVGYN $.
    $}

    $d p v P $.  $d a b p q r v U $.  $d a b p q r v X $.
    $( The neighborhoods of a point ` P ` for the topology induced by an
       uniform space ` U ` .  (Contributed by Thierry Arnoux, 13-Jan-2018.) $)
    utopsnneip $p |- ( ( U e. ( UnifOn ` X ) /\ P e. X ) ->
       ( ( nei ` J ) ` { P } ) = ran ( v e. U |-> ( v " { P } ) ) ) $=
      ( vb vr vq vp va cv csn cima cmpt crn cfv wcel wral weq crab fveq2 eleq2d
      cpw cbvralv eleq1 raleqbi1dv syl5bb cbvrabv simpl sneqd imaeq2d mpteq2dva
      wa rneqd cbvmptv utopsnneiplem ) ABCDGLZHLZIEACALZILZMZNZOZPZOZQZRZHURSZG
      EUDZUAVFEJKFVIKLZJLZVFQZRZJVKSZGKVJVIURVMRZJURSGKTVOVHVPHJURHJTVGVMURUSVL
      VFUBUCUEVPVNJURVKURVKVMUFUGUHUIIJEVEACUTVLMZNZOZPIJTZVDVSVTACVCVRVTUTCRZU
      NZVBVQUTWBVAVLVTWAUJUKULUMUOUPUQ $.

    $d v P $.  $d v U $.  $d v V $.
    $( Images of singletons by entourages ` V ` are neighborhoods of those
       singletons.  (Contributed by Thierry Arnoux, 13-Jan-2018.) $)
    utopsnnei $p |- ( ( U e. ( UnifOn ` X ) /\ V e. U /\ P e. X )
        -> ( V " { P } ) e. ( ( nei ` J ) ` { P } ) ) $=
      ( vv cust cfv wcel w3a csn cima cnei cv wceq wrex eqid 3ad2ant2 cvv mpan2
      imaeq1 eqeq2d rspcev cmpt crn utopsnneip 3adant2 eleq2d wb imaexg elrnmpt
      syl bitrd mpbird ) BEHIJZDBJZAEJZKZDALZMZUTCNIIZJZVAGOZUTMZPZGBQZUQUPVGUR
      UQVAVAPZVGVARVFVHGDBVDDPVEVAVAVDDUTUBUCUDUASUSVCVAGBVEUEZUFZJZVGUSVBVJVAU
      PURVBVJPUQGABCEFUGUHUIUQUPVKVGUJZURUQVATJVLDUTBUKGBVEVAVITVIRULUMSUNUO $.


    $d a r v z J $.  $d a r v z M $.  $d z U $.  $d a r v z V $.  $d z X $.
    $( For any symmetrical entourage ` V ` and any relation ` M ` , build a
       neighborhood of ` M ` .  First part of proposition 2 of [BourbakiTop1]
       p.  II.4.  (Contributed by Thierry Arnoux, 14-Jan-2018.) $)
    utop2nei $p |- ( ( U e. ( UnifOn ` X ) /\ ( V e. U /\ `' V = V )
        /\ M C_ ( X X. X ) )
      -> ( V o. ( M o. V ) ) e. ( ( nei ` ( J tX J ) ) ` M ) ) $=
      ( vr cfv wcel wceq wa cxp wss ccom c0 syl2anc adantr syl cvv wbr cust w3a
      vz ccnv ctx co cnei ctop cutop utoptop syl5eqel txtop 3ad2ant1 0nei coeq1
      co01 syl6eq coeq2d co02 adantl simpr fveq2d 3eltr4d wne cv wral c1st cima
      csn c2nd cuni cop simpl1 simpl2l simp3 xp1st utopsnnei syl3anc xp2nd eqid
      sselda neitx syl22anc fvex xpsn fveq2i wrel xpss sstr mpan2 df-rel sylibr
      syl6eleq 1st2nd sylancom sneqd eleqtrrd a1i simpll2 simprd simpll1 simpld
      relxp ustrel elrelimasn biimpa brcnv breq syl5bbr biimpar simplr 1st2ndbr
      simpll3 sylan 3pm3.2i brcogw syl21anc df-br sylib eqeltrd ex ssrdv simp2l
      mpan simp1 ustssxp coss1 coss2 xpcoid syl6sseq sstrd utopbas unieqi txuni
      syl6eqr xpeq12d eqtrd sseqtrd ssnei2 ralrimiva wb neips mpbird pm2.61dane
      ) AEUAHIZDAIZDUDZDJZKZCEELZMZUBZDCDNZNZCBBUEUFZUGHZHZIZCOUULCOJZKZOOUUPHZ
      UUNUUQUUTUUOUHIZOUVAIUULUVBUUSUUEUUIUVBUUKUUEBUHIZUVCUVBUUEBAUIHZUHFAEUJU
      KZUVEBBULPUMZQUUOUNRUUSUUNOJUULUUSUUNDONOUUSUUMODUUSUUMODNOCODUODUPUQURDU
      SUQUTUUTCOUUPUULUUSVAVBVCUULCOVDZKZUURUUNGVEZVIZUUPHZIZGCVFZUULUVMUVGUULU
      VLGCUULUVICIZKZUVBDUVIVGHZVIZVHZDUVIVJHZVIZVHZLZUVKIUWBUUNMUUNUUOVKZMZUVL
      UULUVBUVNUVFQUVOUWBUVPUVSVLZVIZUUPHZUVKUVOUWBUVQUVTLZUUPHZUWGUVOUVCUVCUVR
      UVQBUGHZHIZUWAUVTUWJHIZUWBUWIIUVOUUEUVCUUEUUIUUKUVNVMZUVERZUWNUVOUUEUUFUV
      PEIZUWKUWMUUFUUHUUEUUKUVNVNZUVOUVIUUJIZUWOUULCUUJUVIUUEUUIUUKVOZWAZUVIEEV
      PRUVPABDEFVQVRUVOUUEUUFUVSEIZUWLUWMUWPUVOUWQUWTUWSUVIEEVSRUVSABDEFVQVRUVR
      UWAUVQUVTBBBVKZUXAUXAVTZUXBWBWCUWHUWFUUPUVPUVSUVIVGWDZUVIVJWDZWEWFWMUVOUV
      JUWFUUPUVOUVIUWEUULUVNCWGZUVIUWEJUVOUUKUXEUULUUKUVNUWRQUUKCSSLZMZUXEUUKUU
      JUXFMUXGEEWHCUUJUXFWIWJCWKWLZRUVICWNWOWPVBWQUVOUCUWBUUNUVOUCVEZUWBIZUXIUU
      NIUVOUXJKZUXIUXIVGHZUXIVJHZVLZUUNUVOUXJUWBWGZUXIUXNJUXOUXKUVRUWAXCWRUXIUW
      BWNWOUXKUXLUXMUUNTZUXNUUNIUXKUXLUVPDTZUVPUVSCTZUVSUXMDTZUXPUXKUUHUVPUXLDT
      ZUXQUXKUUFUUHUUEUUIUUKUVNUXJWSZWTUXKDWGZUXLUVRIZUXTUXKUUEUUFUYBUUEUUIUUKU
      VNUXJXAUXKUUFUUHUYAXBADEXDPZUXJUYCUVOUXIUVRUWAVPUTUYBUYCUXTUVPUXLDXEXFPUU
      HUXQUXTUXQUVPUXLUUGTUUHUXTUVPUXLDUXCUXIVGWDZXGUVPUXLUUGDXHXIXJPUXKUUKUVNU
      XRUUEUUIUUKUVNUXJXMUULUVNUXJXKUUKUXEUVNUXRUXHUVICXLXNPUXKUYBUXMUWAIZUXSUY
      DUXJUYFUVOUXIUVRUWAVSUTUYBUYFUXSUVSUXMDXEXFPUXQUXRKZUXLUVSUUMTZUXSUXPUXLS
      IZUVSSIZUVPSIZUBUYGUYHUYIUYJUYKUYEUXDUXCXOUXLUVSCDSSUVPSXPYDUYIUXMSIZUYJU
      BUYHUXSKUXPUYIUYLUYJUYEUXIVJWDUXDXOUXLUXMDUUMSSUVSSXPYDXNXQUXLUXMUUNXRXSX
      TYAYBUULUWDUVNUULUUNUUJUWCUULUUNUUJUUMNZUUJUULDUUJMZUUNUYMMUULUUEUUFUYNUU
      EUUIUUKYEUUEUUFUUHUUKYCADEYFPZDUUJUUMYGRUULUUMUUJMZUYMUUJMUULUUMUUJDNZUUJ
      UULUUKUUMUYQMUWRCUUJDYGRUULUYNUYQUUJMUYOUYNUYQUUJUUJNZUUJDUUJUUJYHEYIZYJR
      YKUYPUYMUYRUUJUUMUUJUUJYHUYSYJRYKUUEUUIUUJUWCJUUKUUEUUJUXAUXALZUWCUUEEUXA
      EUXAUUEEUVDVKUXAAEYLBUVDFYMYOZVUAYPUUEUVCUVCUYTUWCJUVEUVEBBUXAUXAUXBUXBYN
      PYQUMZYRQUVJUUOUUNUWBUWCUWCVTZYSWCYTQUVHUVBCUWCMZUVGUURUVMUUAUULUVBUVGUVF
      QUULVUDUVGUULCUUJUWCUWRVUBYRQUULUVGVACUUOUUNUWCGVUCUUBVRUUCUUD $.

    ${
      $( Relation between a topological closure and a symmetric entourage in an
         uniform space.  Second part of proposition 2 of [BourbakiTop1] p.
         II.4.  (Contributed by Thierry Arnoux, 17-Jan-2018.) $)
      utop3cls $p |- ( ( ( U e. ( UnifOn ` X ) /\ M C_ ( X X. X ) ) /\
          ( V e. U /\ `' V = V ) )
          -> ( ( cls ` ( J tX J ) ) ` M ) C_ ( V o. ( M o. V ) ) ) $=
        ( vr cfv wcel cxp wss wa wceq c1st c2nd syl2anc syl wbr csn cvv vz cust
        ccnv ctx co ccl ccom cv cop wrel relxp cuni ctop cutop utoptop syl5eqel
        txtop ad3antrrr simpllr ctopon utoptopon toponuni xpeq12d txuni sseqtrd
        eqid eqtrd clsss3 sseqtr4d simpr sseldd 1st2nd sylancr cima cin simp-4l
        wral simpr1l 3anassrs ustrel elin sylib simpld xp1st elrelimasn simp-4r
        biimpa xpss syl6ss df-rel sylibr simprd 1st2ndbr xp2nd wb simpr1r brcnv
        fvex syl5rbbr mpbird wi w3a brcogw ex mp3an sylan syl21anc ralrimiva c0
        breq wne cnei simplll simplrl 3ad2ant1 utopsnnei syl3an3 neitx syl22anc
        1st2nd2 xpsn syl6eqr fveq2d 3ad2ant3 eleqtrrd syl3anc neindisj r19.3rzv
        sneqd df-br eqeltrd ssrdv ) AEUBHIZCEEJZKZLZDAIZDUCZDMZLZLZUACBBUDUEZUF
        HHZDCDUGZUGZUUAUAUHZUUCIZUUFUUEIUUAUUGLZUUFUUFNHZUUFOHZUIZUUEUUHYNUJUUF
        YNIZUUFUUKMEEUKUUHUUCYNUUFUUHUUCUUBULZYNUUHUUBUMIZCUUMKZUUCUUMKYMUUNYOY
        TUUGYMBUMIZUUPUUNYMBAUNHZUMFAEUOUPZUURBBUQPURZUUHCYNUUMYMYOYTUUGUSYMYNU
        UMMYOYTUUGYMYNBULZUUTJZUUMYMEUUTEUUTYMBEUTHZIEUUTMYMBUUQUVBFAEVAUPEBVBQ
        ZUVCVCYMUUPUUPUVAUUMMUURUURBBUUTUUTUUTVFZUVDVDPVGURZVEZCUUBUUMUUMVFZVHP
        UVEVIUUAUUGVJZVKZUUFYNVLVMUUHUUIUUJUUERZUUKUUEIUUHUVJUVJGDUUISZVNZDUUJS
        ZVNZJZCVOZVQZUUHUVJGUVPUUHGUHZUVPIZLZUUIUVRNHZDRZUWAUVROHZCRZUWCUUJDRZU
        VJUVTDUJZUWAUVLIZUWBUVTYMYQUWFYMYOYTUUGUVSVPYPYTUUGUVSYQYQYSUUGUVSYPVRV
        SADEVTPZUVTUVRUVOIZUWGUVTUWIUVRCIZUVTUVSUWIUWJLUUHUVSVJUVRUVOCWAWBZWCZU
        VRUVLUVNWDQUWFUWGUWBUUIUWADWEWGPUVTCUJZUWJUWDUVTCTTJZKUWMUVTCYNUWNYMYOY
        TUUGUVSWFEEWHWICWJWKUVTUWIUWJUWKWLUVRCWMPUVTUWEUUJUWCDRZUVTUWFUWCUVNIZU
        WOUWHUVTUWIUWPUWLUVRUVLUVNWNQUWFUWPUWOUUJUWCDWEWGPUVTYSUWEUWOWOYPYTUUGU
        VSYSYQYSUUGUVSYPWPVSUWOUWCUUJYRRYSUWEUWCUUJDUVROWRZUUFOWRZWQUWCUUJYRDXJ
        WSQWTUWBUWDLZUUIUWCUUDRZUWEUVJUUITIZUWCTIZUWATIZUWSUWTXAUUFNWRZUWQUVRNW
        RUXAUXBUXCXBUWSUWTUUIUWCCDTTUWATXCXDXEUXAUUJTIZUXBUWTUWELZUVJXAUXDUWRUW
        QUXAUXEUXBXBUXFUVJUUIUUJDUUDTTUWCTXCXDXEXFXGXHUUHUVPXIXKZUVJUVQWOUUHUUN
        UUOUUGUVOUUFSZUUBXLHZHZIZUXGUUSUVFUVHUUHYMYQUULUXKYMYOYTUUGXMYPYQYSUUGX
        NUVIYMYQUULXBZUVOUVKUVMJZUXIHZUXJUXLUUPUUPUVLUVKBXLHZHIZUVNUVMUXOHIZUVO
        UXNIYMYQUUPUULUURXOZUXRUULYMYQUUIEIUXPUUFEEWDUUIABDEFXPXQUULYMYQUUJEIUX
        QUUFEEWNUUJABDEFXPXQUVLUVNUVKUVMBBUUTUUTUVDUVDXRXSUULYMUXJUXNMYQUULUXHU
        XMUXIUULUXHUUKSUXMUULUUFUUKUUFEEXTYIUUIUUJUXDUWRYAYBYCYDYEYFUUFCUUBUVOU
        UMUVGYGXSUVJGUVPYHQWTUUIUUJUUEYJWBYKXDYL $.
    $}

$(
    @{
      utop2cls.1 @e |- S = { w e. U | `' w = w } @.
      @( Topological closure of a relation in an uniform space.  Proposition 2
         of [BourbakiTop1] p.  II.4. @)
      utop2cls @p |- ( ( U e. ( UnifOn ` X ) /\ ( V e. U /\ `' V = V )
          /\ M C_ ( X X. X ) )
        -> ( ( cls ` J ) ` M ) = |^|_ v e. S ( v o. ( M o. v ) ) ) @=
        ? @.
    @}

    @( For any symmetrical entourage ` V ` and any subset ` A ` , build a
       neighborhood of ` A ` .  Corollary 1 of [BourbakiTop1] p.  II.5. @)
    utopnei @p |- ( ( U e. ( UnifOn ` X ) /\ ( V e. U /\ `' V = V )
        /\ A C_ X ) -> ( V " A ) e. ( ( nei ` J ) ` A ) ) @=
      ? @.

    @( Topological closure in an uniform space.  Corollary 1 of [BourbakiTop1]
       p.  II.5. @)
    utopcls @p |- ( ( U e. ( UnifOn ` X ) /\ A C_ X )
        -> ( ( cls ` J ) ` A ) = |^|_ v e. U ( v " A ) ) @=
      ? @.

    @( Condition for the topology induced by an uniform structure to be
       Hausdorff. @)
    utophaus @p |- ( U e. ( UnifOn ` X ) -> ( J e. Haus <->
      |^| U = ( _I |` X ) ) ) @=
      ? @.
$)
  $}

  ${
    $d a b v w x J $.  $d a b v w x y U $.  $d a b v w x y X $.
    utopreg.1 $e |- J = ( unifTop ` U ) $.
    $( All Hausdorff uniform spaces are regular.  Proposition 3 of
       [BourbakiTop1] p.  II.5.  (Contributed by Thierry Arnoux,
       16-Jan-2018.) $)
    utopreg $p |- ( ( U e. ( UnifOn ` X ) /\ J e. Haus ) -> J e. Reg ) $=
      ( vx vb va vv vw cfv wcel wa cv wss wrex wceq ad2antrr syl simplr syl2anc
      cust cha ctop wral creg cutop utoptop adantr syl5eqel cima ccnv ccom cnei
      ccl csn simp-4l simpr cuni ad3antrrr simpllr eqid eltopss utopbas syl6eqr
      unieqi sseqtr4d sseldd utopsnnei syl3anc neii2 simprl snss sylibr simplll
      vex ad6antr ustimasn sseqtrd simprr clsss ctx cxp ustssxp xpeq12d simp-5r
      co imasncls syl22anc utop3cls sstrd imass1 jca reximdva simp-5l ustex3sym
      ex mpd r19.29a cmpt opnneip utopsnneip eleqtrd wb elrnmpt mpbid ralrimiva
      crn isreg sylanbrc ) ACUAJKZBUBKZLZBUCKZEMZFMZKZXOBUNJZJZGMZNZLZFBOZEXSUD
      ZGBUDBUEKXLBAUFJZUCDXJYDUCKXKACUGUHUIZXLYCGBXLXSBKZLZYBEXSYGXNXSKZLZXSHMZ
      XNUOZUJZPZYBHAYIYJAKZLZYMLZIMZUKYQPZYQYQYQULULZYJNZLZYBIAYPYQAKZLZUUALZYK
      XONZXOYQYKUJZNZLZFBOZYBUUDXMUUFYKBUMJJZKZUUIUUDYIXMYIYNYMUUBUUAUPZXLXMYFY
      HYEQZRZUUDYIUUBUUKUULYPUUBUUASZYIUUBLZXJUUBXNCKZUUKXJXKYFYHUUBUPZYIUUBUQU
      UPXSCXNUUPXSBURZCUUPXMYFXSUUSNZXLXMYFYHUUBYEUSXLYFYHUUBUTXSBUUSUUSVAZVBZT
      UUPXJCUUSPZUURXJCYDURUUSACVCBYDDVEVDZRVFYGYHUUBSVGXNABYQCDVHVITYKFBUUFVJT
      UUDUUHYAFBUUDXOBKZLZUUHYAUVFUUHLZXPXTUVGUUEXPUVFUUEUUGVKXNXOEVOVLVMUVGXRY
      LXSUVGXRUUFXQJZYLUVGXMUUFUUSNUUGXRUVHNUUDXMUVEUUHUUNQUVGUUFCUUSUVGXJUUBUU
      QUUFCNUUDXJUVEUUHUUDYIXJUULXJXKYFYHVNZRZQZUUDUUBUVEUUHUUOQYIUUQYNYMUUBUUA
      UVEUUHYIXSCXNYIXSUUSCYIXMYFUUTUUMXLYFYHSZUVBTZYIXJUVCUVIUVDRVFYGYHUQZVGZV
      PXNAYQCVQVIUVGXJUVCUVKUVDRVRUVFUUEUUGVSUUFXOBUUSUVAVTVIUUDUVHYLNUVEUUHUUD
      UVHYQBBWAWFUNJJZYKUJZYLUUDXMXMYQUUSUUSWBZNXNUUSKUVHUVQNUUNUUNUUDYQCCWBZUV
      RUUDXJUUBYQUVSNZUVJUUOAYQCWCTZUUDCUUSCUUSUUDXJUVCUVJUVDRZUWBWDVRUUDXSUUSX
      NUUDYIUUTUULUVMRYGYHYNYMUUBUUAWEVGXNYQBBUUSUUSUVAUVAWGWHUUDUVPYJNUVQYLNUU
      DUVPYSYJUUDXJUVTUUBYRUVPYSNUVJUWAUUOUUCYRYTVKABYQYQCDWIWHUUCYRYTVSWJUVPYJ
      YKWKRWJQWJYOYMUUBUUAUVEUUHWEVFWLWPWMWQYPXJYNUUAIAOXJXKYFYHYNYMWNYIYNYMSIA
      YJCWOTWRYIXSHAYLWSZXGZKZYMHAOZYIXSUUJUWDYIXMYFYHXSUUJKUUMUVLUVNXNBXSWTVIY
      IXJUUQUUJUWDPUVIUVOHXNABCDXATXBYIYFUWEUWFXCUVLHAYLXSUWCBUWCVAXDRXEWRXFXFG
      EFBXHXI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Uniform Spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c UnifSt $. $( Uniform Structure extractor function $)
  $c UnifSp $. $( The class of uniform spaces. $)
  $c toUnifSp $. $( The function building a uniform space $)

  $( Extend class notation with the Uniform Structure extractor function. $)
  cuss $a class UnifSt $.

  $( Extend class notation with the class of uniform spaces. $)
  cusp $a class UnifSp $.

  $( Extend class notation with the function mapping a uniform structure to a
     uniform space. $)
  ctus $a class toUnifSp $.

  $( Define the uniform structure extractor function.  Similarly with ~ df-topn
     this differs from ~ df-unif when a structure has been restricted using
     ~ df-ress ; in this case the ` UnifSet ` component will still have a
     uniform set over the larger set, and this function fixes this by
     restricting the uniform set as well.  (Contributed by Thierry Arnoux,
     1-Dec-2017.) $)
  df-uss $a |- UnifSt = ( f e. _V |->
    ( ( UnifSet ` f ) |`t ( ( Base ` f ) X. ( Base ` f ) ) ) ) $.

  $( Definition of a uniform space, i.e. a base set with an uniform structure
     and its induced topology.  Derived from definition 3 of [BourbakiTop1] p.
     II.4.  (Contributed by Thierry Arnoux, 17-Nov-2017.) $)
  df-usp $a |- UnifSp = { f | (
       ( UnifSt ` f ) e. ( UnifOn ` ( Base ` f ) )
    /\ ( TopOpen ` f ) = ( unifTop ` ( UnifSt ` f ) ) ) } $.

  $( Define the function mapping a uniform structure to a uniform space.
     (Contributed by Thierry Arnoux, 17-Nov-2017.) $)
  df-tus $a |- toUnifSp = ( u e. U. ran UnifOn |->
      ( { <. ( Base ` ndx ) , dom U. u >. , <. ( UnifSet ` ndx ) , u >. }
        sSet <. ( TopSet ` ndx ) , ( unifTop ` u ) >. ) ) $.

  ${
    $d w W $.
    ussval.1 $e |- B = ( Base ` W ) $.
    ussval.2 $e |- U = ( UnifSet ` W ) $.
    $( The uniform structure on uniform space ` W ` .  This proof uses a trick
       with ~ fvprc to avoid requiring ` W ` to be a set.  (Contributed by
       Thierry Arnoux, 3-Dec-2017.) $)
    ussval $p |- ( U |`t ( B X. B ) ) = ( UnifSt ` W ) $=
      ( vw cvv wcel cxp crest co cuss cfv wceq cunif cbs cv fveq2 c0 fvprc ovex
      xpeq12d oveq12d df-uss fvmpt xpeq12i oveq12i syl6reqr 0rest syl5eq oveq1d
      wn 3eqtr4a pm2.61i ) CGHZBAAIZJKZCLMZNUOURCOMZCPMZUTIZJKZUQFCFQZOMZVCPMZV
      EIZJKVBGLVCCNZVDUSVFVAJVCCORVGVEUTVEUTVCCPRZVHUBUCFUDUSVAJUAUEBUSUPVAJEAU
      TAUTDDUFUGUHUOULZSUPJKSUQURUPUIVIBSUPJVIBUSSECOTUJUKCLTUMUN $.

    $( In case the base of the ` UnifSt ` element of the uniform space is the
       base of its element structure, then ` UnifSt ` does not restrict it
       further.  (Contributed by Thierry Arnoux, 4-Dec-2017.) $)
    ussid $p |- ( ( B X. B ) = U. U -> U = ( UnifSt ` W ) ) $=
      ( cxp cuni wceq crest co cuss cfv oveq2 cvv wcel id cbs fvex eqeltri xpex
      syl6eqelr uniexb sylibr eqid restid syl eqtr2d ussval syl6eq ) AAFZBGZHZB
      BUJIJZCKLULUMBUKIJZBUJUKBIMULBNOZUNBHULUKNOUOULUKUJNULPAAACQLNDCQRSZUPTUA
      BUBUCBNUKUKUDUEUFUGABCDEUHUI $.
  $}

  ${
    $d a u v x $.  $d a x w B $.  $d w J $.  $d a w U $.  $d w W $.
    isusp.1 $e |- B = ( Base ` W ) $.
    isusp.2 $e |- U = ( UnifSt ` W ) $.
    isusp.3 $e |- J = ( TopOpen ` W ) $.
    $( The predicate ` W ` is a uniform space.  (Contributed by Thierry Arnoux,
       4-Dec-2017.) $)
    isusp $p |- ( W e. UnifSp
      <-> ( U e. ( UnifOn ` B ) /\ J = ( unifTop ` U ) ) ) $=
      ( vw cusp wcel cvv cust cfv cutop wceq c0 cbs fveq2d cuss ctopn wa wn csn
      elex wne 0nep0 fvprc syl5eq ust0 syl6eq eleq2d fvex eqeltri syl6bb eqeq1d
      elsnc bitrd necon3bbid mpbiri con4i fveq2 syl6eqr eleq12d eqeq12d anbi12d
      adantr cv df-usp elab2g pm5.21nii ) DIJDKJZBALMZJZCBNMZOZUAZDIUDVMVKVOVKV
      MVKUBZVMUBPPUCZUEUFVQVMPVRVQVMBVROZPVROVQVMBVRUCZJVSVQVLVTBVQVLPLMVTVQAPL
      VQADQMZPEDQUGUHRUIUJUKBVRBDSMZKFDSULUMUPUNVQBPVRVQBWBPFDSUGUHUOUQURUSUTVF
      HVGZSMZWCQMZLMZJZWCTMZWDNMZOZUAVPHDIKWCDOZWGVMWJVOWKWDBWFVLWKWDWBBWCDSVAF
      VBZWKWEALWKWEWAAWCDQVAEVBRVCWKWHCWIVNWKWHDTMCWCDTVAGVBWKWDBNWLRVDVEHVHVIV
      J $.
  $}

  ${
    ressunif.1 $e |- H = ( G |`s A ) $.
    ressunif.2 $e |- U = ( UnifSet ` G ) $.
    $( ` UnifSet ` is unaffected by restriction.  (Contributed by Thierry
       Arnoux, 7-Dec-2017.) $)
    ressunif $p |- ( A e. V -> U = ( UnifSet ` H ) ) $=
      ( cunif c1 c3 cdc df-unif 1nn0 3nn decnncl 1nn 3nn0 1lt10 declti resslem
      ) ABDHIJKECFGLIJMNOIJIPQMRST $.
  $}

  $( Value of the uniform structure of a restricted space.  (Contributed by
     Thierry Arnoux, 12-Dec-2017.) $)
  ressuss $p |- ( A e. V ->
    ( UnifSt ` ( W |`s A ) ) = ( ( UnifSt ` W ) |`t ( A X. A ) ) ) $=
    ( wcel cuss cfv cxp crest cunif cbs cin cress eqid ussval cvv wceq fvex a1i
    co syl5eqr oveq1i xpex xpexg anidms restco syl3anc inxp incom syl5eq oveq2d
    ressbas xpeq12d ressunif oveq1d 3eqtrd eqtr2d ) ABDZCEFZAAGZHSZCIFZCJFZVBGZ
    USKZHSZCALSZEFZUQUTVAVCHSZUSHSZVEVHURUSHVBVACVBMZVAMZNUAUQVAODZVCODZUSODZVI
    VEPVLUQCIQRVMUQVBVBCJQZVOUBRUQVNAABBUCUDVCUSVAOOOUEUFTUQVEVAVFJFZVPGZHSVFIF
    ZVQHSZVGUQVDVQVAHUQVDVBAKZVTGVQVBVBAAUGUQVTVPVTVPUQVTAVBKVPAVBUHAVBVFBCVFMZ
    VJUKTZWBULUIUJUQVAVRVQHAVACVFBWAVKUMUNVSVGPUQVPVRVFVPMVRMNRUOUP $.

  ${
    ressust.x $e |- X = ( Base ` W ) $.
    ressust.t $e |- T = ( UnifSt ` ( W |`s A ) ) $.
    $( The uniform structure of a restricted space.  (Contributed by Thierry
       Arnoux, 22-Jan-2018.) $)
    ressust $p |- ( ( W e. UnifSp /\ A C_ X ) -> T e. ( UnifOn ` A ) ) $=
      ( cusp wcel wss wa cuss cfv cxp crest co cust cvv wceq cbs eqid fvex ssex
      cress eqeltri adantl ressuss syl5eq ctopn cutop isusp simplbi trust sylan
      syl eqeltrd ) CGHZADIZJZBCKLZAAMNOZAPLZURBCAUCOKLZUTFURAQHZVBUTRUQVCUPADD
      CSLQECSUAUDUBUEAQCUFUNUGUPUSDPLHZUQUTVAHUPVDCUHLZUSUILRDUSVECEUSTVETUJUKA
      USDULUMUO $.
  $}

  ${
    ressusp.1 $e |- B = ( Base ` W ) $.
    ressusp.2 $e |- J = ( TopOpen ` W ) $.
    $( The restriction of a uniform topological space to an open set is a
       uniform space.  (Contributed by Thierry Arnoux, 16-Dec-2017.) $)
    ressusp $p |- ( ( W e. UnifSp /\ W e. TopSp /\ A e. J )
      -> ( W |`s A ) e. UnifSp ) $=
      ( cusp wcel co cuss cust crest cutop wceq eqid isusp sylib syl2anc fveq2d
      cfv ctps w3a cress cbs cxp ressuss 3ad2ant3 wss simp1 simpld ctopon simp2
      istps simp3 toponss trust eqeltrd ressbas2 syl eleqtrd simprd restutopopn
      wa oveq1d 3eqtr4d resstopn sylanbrc ) DGHZDUAHZACHZUBZDAUCIZJTZVLUDTZKTZH
      CALIZVMMTZNVLGHVKVMAKTZVOVKVMDJTZAAUELIZVRVJVHVMVTNVIACDUFUGZVKVSBKTHZABU
      HZVTVRHVKWBCVSMTZNZVKVHWBWEVCVHVIVJUIBVSCDEVSOFPQZUJZVKCBUKTHZVJWCVKVIWHV
      HVIVJULBCDEFUMQVHVIVJUNZACBUORZAVSBUPRUQVKAVNKVKWCAVNNWJABVLDVLOZEURUSSUT
      VKWDALIZVTMTZVPVQVKWBAWDHWLWMNWGVKACWDWIVKWBWEWFVAZUTAVSBVBRVKCWDALWNVDVK
      VMVTMWASVEVNVMVPVLVNOVMOAVLCDWKFVFPVG $.
  $}

  ${
    $d u U $.  $d u X $.
    $( The value of the uniform space mapping function.  (Contributed by
       Thierry Arnoux, 5-Dec-2017.) $)
    tusval $p |- ( U e. ( UnifOn ` X ) -> ( toUnifSp ` U ) =
      ( { <. ( Base ` ndx ) , dom U. U >. , <. ( UnifSet ` ndx ) , U >. }
        sSet <. ( TopSet ` ndx ) , ( unifTop ` U ) >. ) ) $=
      ( vu cust cfv wcel cnx cbs cuni cdm cop cpr cutop csts co ctus cvv opeq2d
      wceq a1i cv cunif cts crn cmpt df-tus simpr unieqd preq12d fveq2d oveq12d
      wa dmeqd elrnust ovex fvmptd ) ABDEFZCAGHEZCUAZIZJZKZGUBEZUSKZLZGUCEZUSME
      ZKZNOZURAIZJZKZVCAKZLZVFAMEZKZNOZDUDIZPQPCVRVIUESUQCUFTUQUSASZULZVEVNVHVP
      NVTVBVLVDVMVTVAVKURVTUTVJVTUSAUQVSUGZUHUMRVTUSAVCWARUIVTVGVOVFVTUSAMWAUJR
      UKABUNVQQFUQVNVPNUOTUP $.

    tuslem.k $e |- K = ( toUnifSp ` U ) $.
    $( Lemma for ~ tusbas , ~ tusunif , and ~ tustopn .  (Contributed by
       Thierry Arnoux, 5-Dec-2017.) $)
    tuslem $p |- ( U e. ( UnifOn ` X ) -> ( X = ( Base ` K ) /\
        U = ( UnifSet ` K ) /\ ( unifTop ` U ) = ( TopOpen ` K ) ) ) $=
      ( cfv wcel cbs wceq cunif cnx cuni cop cts co wne c1 c9 cvv c3 eqid cutop
      cust ctopn cdm cpr csts baseid 1re ltneii basendx tsetndx neeq12i setsnid
      1lt9 mpbir ustbas2 uniexg dmexg cdc df-unif 1nn 3nn0 1lt10 declti decnncl
      1nn0 3nn 2strbas 3syl eqtrd ctus tusval syl5eq fveq2d 3eqtr4a unifid 9nn0
      9re 9lt10 gtneii unifndx 2strop prex tsetid setsid mp2an syl6reqr utopbas
      fvex crest unieqd 3eqtr3rd oveq2d restid ax-mp topnval 3eqtr3g 3jca ) ACU
      BEZFZCBGEZHABIEZHAUAEZBUCEZHWTJGEZAKZUDZLZJIEZALZUEZGEZXKJMEZXCLUFNZGECXA
      XCXMGXKUGXEXMOPQOPQUHUNUIXEPXMQUJUKULUOUMWTCXGXLACUPWTXFRFXGRFXGXLHAWSUQX
      FRURXGAIXKPSUSZRXKTZUTPSPVAVBVFVCVDZPSVFVGVEZVHVIVJWTBXNGWTBAVKEXNDACVLVM
      ZVNVOZWTXKIEXNIEAXBXCXMIXKVPXIXMOXOQOQXOVRPSQVAVBVQVSVDVTXIXOXMQWAUKULUOU
      MXGAIXKXOWSXPUTXQXRWBWTBXNIXSVNVOWTXCBMEZXDWTYAXNMEZXCWTBXNMXSVNXKRFXCRFX
      CYBHXHXJWCAUAWIRXCMRXKWDWEWFWGZWTYAYAKZWJNZYAXAWJNYAXDWTYDXAYAWJWTCXCKXAY
      DACWHXTWTXCYAYCWKWLWMYARFYEYAHBMWIYARYDYDTWNWOXAYABXATYATWPWQVJWR $.

    $( The base set of a constructed uniform space.  (Contributed by Thierry
       Arnoux, 5-Dec-2017.) $)
    tusbas $p |- ( U e. ( UnifOn ` X ) -> X = ( Base ` K ) ) $=
      ( cust cfv wcel cbs wceq cunif cutop ctopn tuslem simp1d ) ACEFGCBHFIABJF
      IAKFBLFIABCDMN $.

    $( The uniform structure of a constructed uniform space.  (Contributed by
       Thierry Arnoux, 5-Dec-2017.) $)
    tusunif $p |- ( U e. ( UnifOn ` X ) -> U = ( UnifSet ` K ) ) $=
      ( cust cfv wcel cbs wceq cunif cutop ctopn tuslem simp2d ) ACEFGCBHFIABJF
      IAKFBLFIABCDMN $.

    $( The uniform structure of a constructed uniform space.  (Contributed by
       Thierry Arnoux, 15-Dec-2017.) $)
    tususs $p |- ( U e. ( UnifOn ` X ) -> U = ( UnifSt ` K ) ) $=
      ( cust cfv wcel cunif cuss tusunif cbs cxp cuni wceq ustuni unieqd tusbas
      xpeq12d 3eqtr3rd eqid ussid syl eqtrd ) ACEFGZABHFZBIFZABCDJZUDBKFZUHLZUE
      MZNUEUFNUDAMCCLUJUIACOUDAUEUGPUDCUHCUHABCDQZUKRSUHUEBUHTUETUAUBUC $.

    ${
      tustopn.j $e |- J = ( unifTop ` U ) $.
      $( The topology induced by a constructed uniform space.  (Contributed by
         Thierry Arnoux, 5-Dec-2017.) $)
      tustopn $p |- ( U e. ( UnifOn ` X ) -> J = ( TopOpen ` K ) ) $=
        ( cust cfv wcel cutop ctopn cbs wceq cunif tuslem simp3d syl5eq ) ADGHI
        ZBAJHZCKHZFRDCLHMACNHMSTMACDEOPQ $.
    $}

    $( A constructed uniform space is an uniform space.  (Contributed by
       Thierry Arnoux, 5-Dec-2017.) $)
    tususp $p |- ( U e. ( UnifOn ` X ) -> K e. UnifSp ) $=
      ( cust cfv wcel cuss cbs ctopn cutop wceq id tususs tusbas fveq2d 3eltr3d
      cusp cunif eqid tusunif tuslem simp3d eqtr3d 3eqtr3d isusp sylanbrc ) ACE
      FZGZBHFZBIFZEFZGBJFZUJKFZLBRGUIAUHUJULUIMABCDNZUICUKEABCDOPQUIAKFZBSFZKFU
      MUNUIAUQKABCDUAZPUICUKLAUQLUPUMLABCDUBUCUIUQUJKUIAUQUJURUOUDPUEUKUJUMBUKT
      UJTUMTUFUG $.

    $( A constructed uniform space is a topological space.  (Contributed by
       Thierry Arnoux, 25-Jan-2018.) $)
    tustps $p |- ( U e. ( UnifOn ` X ) -> K e. TopSp ) $=
      ( cust cfv wcel ctopn cbs ctopon ctps cutop utoptopon eqid tustopn tusbas
      fveq2d 3eltr3d istps sylibr ) ACEFGZBHFZBIFZJFZGBKGUAALFZCJFUBUDACMAUEBCD
      UENOUACUCJABCDPQRUCUBBUCNUBNST $.
  $}

  ${
    uspreg.1 $e |- J = ( TopOpen ` W ) $.
    $( If a uniform space is Hausdorff, it is regular.  Proposition 3 of
       [BourbakiTop1] p.  II.5.  (Contributed by Thierry Arnoux,
       4-Jan-2018.) $)
    uspreg $p |- ( ( W e. UnifSp /\ J e. Haus ) -> J e. Reg ) $=
      ( cusp wcel cha wa cuss cfv cutop creg wceq cbs cust isusp simprbi adantr
      eqid simplbi simpr eqeltrrd utopreg syl2anc eqeltrd ) BDEZAFEZGZABHIZJIZK
      UEAUILZUFUEUHBMIZNIEZUJUKUHABUKRUHRCOZPQZUGULUIFEUIKEUEULUFUEULUJUMSQUGAU
      IFUNUEUFTUAUHUIUKUIRUBUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Uniform continuity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c uCn $.

  $( Extend class notation with the uniform continuity operation. $)
  cucn $a class uCn $.

  ${
    $d u v f s r x y $.
    $( Define a function on two uniform structures which value is the set of
       uniformly continuous functions from the first uniform structure to the
       second.  A function ` f ` is uniformly continuous if, roughly speaking,
       it is possible to guarantee that ` ( f `` x ) ` and ` ( f `` y ) ` be as
       close to each other as we please by requiring only that ` x ` and ` y `
       are sufficiently close to each other; unlike ordinary continuity, the
       maximum distance between ` ( f `` x ) ` and ` ( f `` y ) ` cannot depend
       on ` x ` and ` y ` themselves.  This formulation is the definition 1 of
       [BourbakiTop1] p.  II.6.  (Contributed by Thierry Arnoux,
       16-Nov-2017.) $)
    df-ucn $a |- uCn = ( u e. U. ran UnifOn , v e. U. ran UnifOn |->
       { f e. ( dom U. v ^m dom U. u ) | A. s e. v E. r e. u
            A. x e. dom U. u A. y e. dom U. u
            ( x r y -> ( f ` x ) s ( f ` y ) ) } ) $.
  $}

  ${
    $d f r s u v x y U $.  $d f r s u v x V $.  $d f r s x y X $.
    $d f r s x Y $.
    $( The set of all uniformly continuous function from uniform space ` U ` to
       uniform space ` V ` .  (Contributed by Thierry Arnoux, 16-Nov-2017.) $)
    ucnval $p |- ( ( U e. ( UnifOn ` X ) /\ V e. ( UnifOn ` Y ) )
      -> ( U uCn V ) = { f e. ( Y ^m X ) | A. s e. V E. r e. U
            A. x e. X A. y e. X ( x r y -> ( f ` x ) s ( f ` y ) ) } ) $=
      ( vu vv cfv wcel co cv cuni cdm wral cmap wceq cust wa cucn wbr wrex crab
      wi crn cvv elrnust adantr adantl ovex rabex a1i simpr dmeqd simpl oveq12d
      raleqdv raleqbidv rexeqbidv rabeqbidv ovmpt2ga syl3anc ustbas2 oveqan12rd
      unieqd df-ucn rexbidv ralbidv eqtr4d ) CFUALMZEGUALMZUBZCEUCNZAOZBOZIOUDV
      QDOZLVRVSLHOUDUGZBCPZQZRZAWBRZICUEZHERZDEPZQZWBSNZUFZVTBFRZAFRZICUEZHERZD
      GFSNZUFVOCUAUHPZMZEWPMZWJUIMZVPWJTVMWQVNCFUJUKVNWRVMEGUJULWSVOWFDWIWHWBSU
      MUNUOJKCEWPWPVTBJOZPZQZRZAXBRZIWTUEZHKOZRZDXFPZQZXBSNZUFWJUCUIWTCTZXFETZU
      BZXGWFDXJWIXMXIWHXBWBSXMXHWGXMXFEXKXLUPZVHUQXMXAWAXMWTCXKXLURZVHUQZUSXMXE
      WEHXFEXNXMXDWDIWTCXOXMXCWCAXBWBXPXMVTBXBWBXPUTVAVBVAVCABKJDHIVIVDVEVOWNWF
      DWOWIVNVMGWHFWBSEGVFCFVFZVGVOWMWEHEVOWLWDICVOWKWCAFWBVMFWBTVNXQUKZVOVTBFW
      BXRUTVAVJVKVCVL $.
  $}

  ${
    $d f r s x y F $.  $d f r s x y U $.  $d f r s x V $.  $d f r s x y X $.
    $d f r s x Y $.
    $( The predicate " ` F ` is a uniformly continuous function from uniform
       space ` U ` to uniform space ` V ` ."  (Contributed by Thierry Arnoux,
       16-Nov-2017.) $)
    isucn $p |- ( ( U e. ( UnifOn ` X ) /\ V e. ( UnifOn ` Y ) )
      -> ( F e. ( U uCn V ) <-> ( F : X --> Y /\ A. s e. V E. r e. U
          A. x e. X A. y e. X ( x r y -> ( F ` x ) s ( F ` y ) ) ) ) ) $=
      ( vf cust cfv wcel wa co cv wbr wi wral cvv cucn cmap wrex wf crab ucnval
      eleq2d fveq1 breq12d imbi2d ralbidv rexralbidv elrab syl6bb elfvex elmapg
      wceq wb syl2anr anbi1d bitrd ) CFKLMZEGKLMZNZDCEUAOZMZDGFUBOZMZAPZBPZIPQZ
      VIDLZVJDLZHPZQZRZBFSZAFSICUCZHESZNZFGDUDZVSNVDVFDVKVIJPZLZVJWBLZVNQZRZBFS
      ZAFSICUCZHESZJVGUEZMVTVDVEWJDABCJEFGHIUFUGWIVSJDVGWBDUQZWHVRHEWKWGVQIACFW
      KWFVPBFWKWEVOVKWKWCVLWDVMVNVIWBDUHVJWBDUHUIUJUKULUKUMUNVDVHWAVSVCGTMFTMVH
      WAURVBEGKUOCFKUOGFDTTUPUSUTVA $.
  $}

  ${
    $d r s u v x y F $.  $d r u x y R $.  $d s u v x y S $.
    $d r s u v x y U $.  $d s u v x V $.  $d r s u v x y X $.
    $d s u v x y Y $.  $d r s u v x y ph $.
    isucn2.u $e |- U = ( ( X X. X ) filGen R ) $.
    isucn2.v $e |- V = ( ( Y X. Y ) filGen S ) $.
    isucn2.1 $e |- ( ph -> U e. ( UnifOn ` X ) ) $.
    isucn2.2 $e |- ( ph -> V e. ( UnifOn ` Y ) ) $.
    isucn2.3 $e |- ( ph -> R e. ( fBas ` ( X X. X ) ) ) $.
    isucn2.4 $e |- ( ph -> S e. ( fBas ` ( Y X. Y ) ) ) $.
    $( The predicate " ` F ` is a uniformly continuous function from uniform
       space ` U ` to uniform space ` V ` ." , expressed with filter bases for
       the entourages.  (Contributed by Thierry Arnoux, 26-Jan-2018.) $)
    isucn2 $p |- ( ph -> ( F e. ( U uCn V ) <-> ( F : X --> Y
      /\ A. s e. S E. r e. R A. x e. X A. y e. X
                                  ( x r y -> ( F ` x ) s ( F ` y ) ) ) ) ) $=
      ( wi wa vu vv cucn co wcel wf cv wbr cfv wral wrex cust isucn syl2anc wss
      wb cxp cfg cfbas ssfg syl syl6sseqr adantr sselda simplr wceq breq imbi2d
      ralbidv rexralbidv rspcv imp simpr syl6eleq biimpa simprd syldan id ssbrd
      elfg imim1 adantl ralrimivw ralim ralimi 3syl reximdva r19.37av rexlimdva
      mpd ad3antrrr ralrimiva ssrexv imbi1d 2ralbidv cbvrexv syl6ib ralimdv nfv
      ex nfan simp-4r rsp simp-4l imim2d reximdv syl21anc r19.29af syld impbida
      nfra1 pm5.32da bitrd ) AGFHUCUDUEZIJGUFZBUGZCUGZUAUGZUHZXPGUIZXQGUIZUBUGZ
      UHZSZCIUJZBIUJZUAFUKZUBHUJZTZXOXPXQLUGZUHZXTYAKUGZUHZSZCIUJZBIUJZLDUKZKEU
      JZTAFIULUIUEHJULUIUEXNYIUPOPBCFGHIJUBUAUMUNAXOYHYRAXOTZYHYRYSYHTZYQKEYTYL
      EUEZTZXSYMSZCIUJZBIUJZUAFUKZYQUUBYLHUEZYHUUFYTEHYLYSEHUOZYHAUUHXOAEJJUQZE
      URUDZHAEUUIUSUIUEZEUUJUOREUUIUTVANVBVCVCVDYSYHUUAVEUUGYHUUFYGUUFUBYLHYBYL
      VFZYEUUDUABFIUULYDUUCCIUULYCYMXSXTYAYBYLVGVHVIVJVKVLUNAUUFYQSXOYHUUAAUUEY
      QUAFAXRFUEZTZUUEYPSZLDUKZUUEYQSUUNYJXRUOZLDUKZUUPAUUMXRIIUQZDURUDZUEZUURU
      UNXRFUUTAUUMVMMVNAUVATXRUUSUOZUURAUVAUVBUURTZADUUSUSUIUEZUVAUVCUPQLXRDUUS
      VTVAVOVPVQAUURUUPSUUMAUUQUUOLDAYJDUETZUUQUUOUVEUUQTZUUCYNSZCIUJZBIUJUUDYO
      SZBIUJUUOUVFUVHBIUVFUVGCIUUQUVGUVEUUQYKXSSUVGUUQYJXRXPXQUUQVRVSYKXSYMWAVA
      WBWCWCUVHUVIBIUUCYNCIWDWEUUDYOBIWDWFWTWGVCWJUUEYPLDWHVAWIWKWJWLYSYRYHYSYR
      UUFKEUJZYHAYRUVJSXOAYQUUFKEADFUOZYQUUFSADUUTFAUVDDUUTUOQDUUSUTVAMVBUVKYQY
      PLFUKUUFYPLDFWMYPUUELUAFYJXRVFZYNUUCBCIIUVLYKXSYMXPXQYJXRVGWNWOWPWQVAWRVC
      YSUVJYHYSUVJTZYGUBHUVMYBHUEZTZYLYBUOZYGKEUVMUVNKYSUVJKYSKWSUUFKEXKXAUVNKW
      SXAUVOUUATZUVPTZUUFYGUVRUVJUUAUUFYSUVJUVNUUAUVPXBUVOUUAUVPVEZUVJUUAUUFUUF
      KEXCVLUNUVRYSUUAUVPUUFYGSYSUVJUVNUUAUVPXDUVSUVQUVPVMYSUUATZUVPTZUUEYFUAFU
      WAUUDYEBIUWAUUCYDCIUWAYMYCXSUVPYMYCSUVTUVPYLYBXTYAUVPVRVSWBXEWRWRXFXGWJUV
      OUUKYBUUJUEZUVPKEUKZAUUKXOUVJUVNRWKUVOYBHUUJUVMUVNVMNVNUUKUWBTYBUUIUOZUWC
      UUKUWBUWDUWCTKYBEUUIVTVOVPUNXHWLWTXIVLXJXLXM $.
  $}

  ${
    $d p x y F $.  $d p x y X $.
    ucnprima.1 $e |- ( ph -> U e. ( UnifOn ` X ) ) $.
    ucnprima.2 $e |- ( ph -> V e. ( UnifOn ` Y ) ) $.
    ucnprima.3 $e |- ( ph -> F e. ( U uCn V ) ) $.
    ucnprima.4 $e |- ( ph -> W e. V ) $.
    ucnprima.5 $e |- G = ( x e. X , y e. X |-> <. ( F ` x ) , ( F ` y ) >. ) $.
    $( Reformulate the ` G ` function as a mapping with one variable.
       (Contributed by Thierry Arnoux, 19-Nov-2017.) $)
    ucnimalem $p |- G = ( p e. ( X X. X )
                       |-> <. ( F ` ( 1st ` p ) ) , ( F ` ( 2nd ` p ) ) >. ) $=
      ( cv cfv cop vex cmpt2 cxp c1st c2nd op1std fveq2d op2ndd opeq12d mpt2mpt
      cmpt wceq eqtr4i ) FBCIIBQZERZCQZERZSZUAKIIUBKQZUCRZERZURUDRZERZSZUJPBCKI
      IVCUQURUMUOSUKZUTUNVBUPVDUSUMEUMUOURBTZCTZUEUFVDVAUOEUMUOURVEVFUGUFUHUIUL
      $.

    $d p r w x y F $.  $d p x y G $.  $d p r w x y U $.  $d r w x V $.
    $d p r w x y W $.  $d p r w x y X $.  $d r w x Y $.  $d p r x y ph $.
    $( An equivalent statement of the definition of uniformly continuous
       function.  (Contributed by Thierry Arnoux, 19-Nov-2017.) $)
    ucnima $p |- ( ph -> E. r e. U ( G " r ) C_ W ) $=
      ( cfv wcel wa wrex vp vw cv wral cima wss wi wbr wf cucn co cust wb isucn
      syl2anc mpbid simprd wceq breq imbi2d ralbidv rexralbidv sylc cxp simplll
      rspcv simplr jca ustssxp sylan sselda adantlr simpr cop elxp2 sylib df-br
      eleq1d syl6bbr c1st c2nd cvv opex ucnimalem fvmpt2 sylancl 1st2nd2 eqtr3d
      syl vex simpld fveq2d opeq12d eqtr4d imbi12d exbiri reximdv mpd r19.29d2r
      opth pm3.35 rexlimivw imp syl21anc ralrimiva ex reximdva wfun cdm mpt2fun
      dmmpt2 syl6sseqr funimass4 sylancr biimprd r19.29r reximi ) AUAUCZFQZHRZU
      AKUCZUDZYBFYAUEHUFZUGZSZKDTZYCKDTAYBKDTZYDKDUDYFABUCZCUCZYAUHZYHEQZYIEQZH
      UHZUGZCIUDZBIUDZKDTZYGAHGRYJYKYLUBUCZUHZUGZCIUDZBIUDKDTZUBGUDZYQOAIJEUIZU
      UCAEDGUJUKRZUUDUUCSZNADIULQRZGJULQRUUEUUFUMLMBCDEGIJUBKUNUOUPUQUUBYQUBHGY
      RHURZUUAYOKBDIUUHYTYNCIUUHYSYMYJYKYLYRHUSUTVAVBVFVCAYPYBKDAYADRZSZYPYBUUJ
      YPSZXTUAYAUUKXRYARZSZAYPSZXRIIVDZRZUULXTUUMAYPAUUIYPUULVEUUJYPUULVGVHUUJU
      ULUUPYPUUJYAUUOXRAUUGUUIYAUUOUFLDYAIVIVJZVKVLUUKUULVMUUNUUPSZUULXTUURYNYN
      UULXTUGZUGZSZCITZBITUUSUURYNUUTBCIIAYPUUPVGAUUPUUTCITZBITZYPAUUPSZXRYHYIV
      NZURZCITZBITZUVDUVEUUPUVIAUUPVMBCXRIIVOVPUVEUVHUVCBIUVEUVGUUTCIUVEUVGUUSY
      NUVEUVGSZUULYJXTYMUVJUULUVFYARZYJAUVGUULUVKUMUUPAUVGSXRUVFYAAUVGVMVRVLYHY
      IYAVQVSUVJXTYKYLVNZHRYMUVJXSUVLHUVJXSXRVTQZEQZXRWAQZEQZVNZUVLUVJUUPUVQWBR
      XSUVQURAUUPUVGVGZUVNUVPWCUAUUOUVQWBFABCDEFGHIJUALMNOPWDWEWFUVJYKUVNYLUVPU
      VJYHUVMEUVJYHUVMURZYIUVOURZUVJUVFUVMUVOVNZURUVSUVTSUVJXRUVFUWAUVEUVGVMUVJ
      UUPXRUWAURUVRXRIIWGWIWHYHYIUVMUVOBWJCWJWTVPZWKWLUVJYIUVOEUVJUVSUVTUWBUQWL
      WMWNVRYKYLHVQVSWOWPWQWQWRVLWSUVBUUSBIUVAUUSCIYNUUSXAXBXBWIXCXDXEXFXGWRAYD
      KDUUJYCYBUUJFXHYAFXIZUFYCYBUMBCIIUVLFPXJUUJYAUUOUWCUUQBCIIUVLFPYKYLWCXKXL
      UAYAHFXMXNXOXEYBYDKDXPUOYEYCKDYBYCXAXQWI $.

    $d r G $.
    $( The preimage by a uniformly continuous function ` F ` of an entourage
       ` W ` of ` Y ` is an entourage of ` X ` .  Note of the definition 1 of
       [BourbakiTop1] p.  II.6.  (Contributed by Thierry Arnoux,
       19-Nov-2017.) $)
    ucnprima $p |- ( ph -> ( `' G " W ) e. U ) $=
      ( vr cv wss wcel cfv ccnv cima wrex ucnima wa wfun cdm wb cop mpt2fun cxp
      cust ustssxp sylan opex dmmpt2 syl6sseqr funimass3 sylancr rexbidva mpbid
      wi adantr simpr cnvimass sseqtri a1i ustssel syl3anc rexlimdva mpd ) APQZ
      FUAHUBZRZPDUCZVMDSZAFVLUBHRZPDUCVOABCDEFGHIJPKLMNOUDAVQVNPDAVLDSZUEZFUFVL
      FUGZRVQVNUHBCIIBQETZCQETZUIZFOUJVSVLIIUKZVTADIULTSZVRVLWDRKDVLIUMUNBCIIWC
      FOWAWBUOUPZUQVLHFURUSUTVAAVNVPPDVSWEVRVMWDRZVNVPVBAWEVRKVCAVRVDWGVSVMVTWD
      FHVEWFVFVGDVLVMIVHVIVJVK $.
  $}

  ${
    $d r s x y U $.  $d r s x y X $.
    $( The identity is uniformly continuous from a uniform structure to
       itself.  Example 1 of [BourbakiTop1] p.  II.6.  (Contributed by Thierry
       Arnoux, 16-Nov-2017.) $)
    iducn $p |- ( U e. ( UnifOn ` X ) -> ( _I |` X ) e. ( U uCn U ) ) $=
      ( vx vy vr vs cust cfv wcel cid cres cucn co wf cv wbr wi wral wa fvresi
      wrex wf1o f1oi f1of mp1i simpr breqan12d biimprd adantl ralrimivva imbi1d
      weq breq 2ralbidv rspcev syl2anc ralrimiva wb isucn anidms mpbir2and ) AB
      GHIZJBKZAALMIZBBVCNZCOZDOZEOZPZVFVCHZVGVCHZFOZPZQZDBRCBRZEAUAZFARZBBVCUBV
      EVBBUCBBVCUDUEVBVPFAVBVLAIZSZVRVFVGVLPZVMQZDBRCBRZVPVBVRUFVSWACDBBVFBIZVG
      BIZSZWAVSWEVMVTWCWDVJVFVKVGVLBVFTBVGTUGUHUIUJVOWBEVLAEFULZVNWACDBBWFVIVTV
      MVFVGVHVLUMUKUNUOUPUQVBVDVEVQSURCDAVCABBFEUSUTVA $.
  $}

  ${
    $d r s x y A $.  $d r s v w x y U $.  $d r s x y V $.  $d r s v w x y X $.
    $d r s x Y $.  $d r s x y ph $.
    cstucnd.1 $e |- ( ph -> U e. ( UnifOn ` X ) ) $.
    cstucnd.2 $e |- ( ph -> V e. ( UnifOn ` Y ) ) $.
    cstucnd.3 $e |- ( ph -> A e. Y ) $.
    $( A constant function is uniformly continuous.  Deduction form.  Example 1
       of [BourbakiTop1] p.  II.6.  (Contributed by Thierry Arnoux,
       16-Nov-2017.) $)
    cstucnd $p |- ( ph -> ( X X. { A } ) e. ( U uCn V ) ) $=
      ( vx vy vr vs wcel cv wbr cfv wral wa syl2anc csn cxp cucn co wf fconst6g
      wi wrex syl c0 cust adantr ustne0 ad3antrrr simpllr ustref syl3anc simprl
      wne wceq fvconst2g simprr 3brtr4d ralrimivva reximdva0 mpdan ralrimiva wb
      a1d isucn mpbir2and ) AEBUAUBZCDUCUDNZEFVLUEZJOZKOZLOZPZVOVLQZVPVLQZMOZPZ
      UGZKERJERZLCUHZMDRZABFNZVNIEBFUFUIAWEMDAWADNZSZCUJUSZWEWICEUKQNZWJAWKWHGU
      LCEUMUIWIWDLCWIVQCNZSZWCJKEEWMVOENZVPENZSZSZWBVRWQBBVSVTWAWQDFUKQNZWHWGBB
      WAPAWRWHWLWPHUNAWHWLWPUOAWGWHWLWPIUNZBDWAFUPUQWQWGWNVSBUTWSWMWNWOUREBVOFV
      ATWQWGWOVTBUTWSWMWNWOVBEBVPFVATVCVIVDVEVFVGAWKWRVMVNWFSVHGHJKCVLDEFMLVJTV
      K $.
  $}

  ${
    $d a r s x y z F $.  $d a J $.  $d a r s x z K $.  $d a r s x y z R $.
    $d a r s x y z S $.  $d a r s x y z ph $.
    ucncn.j $e |- J = ( TopOpen ` R ) $.
    ucncn.k $e |- K = ( TopOpen ` S ) $.
    ucncn.1 $e |- ( ph -> R e. UnifSp ) $.
    ucncn.2 $e |- ( ph -> S e. UnifSp ) $.
    ucncn.3 $e |- ( ph -> R e. TopSp ) $.
    ucncn.4 $e |- ( ph -> S e. TopSp ) $.
    ucncn.5 $e |- ( ph -> F e. ( ( UnifSt ` R ) uCn ( UnifSt ` S ) ) ) $.
    $( Uniform continuity implies continuity.  Deduction form.  Proposition 1
       of [BourbakiTop1] p.  II.6.  (Contributed by Thierry Arnoux,
       30-Nov-2017.) $)
    ucncn $p |- ( ph -> F e. ( J Cn K ) ) $=
      ( vz wcel cfv wral wa syl adantr va vx vr vs vy ccn co cbs wf ccnv cv wbr
      cima wi cuss wrex cucn cust wb cusp cutop wceq eqid isusp simplbi syl2anc
      isucn mpbid simpld wss csn cdm cnvimass fdm syl5sseq simplll simpr simplr
      ad2antrr sseldd simprd r19.21bi r19.12 syl21anc ad3antrrr ustrel ustimasn
      wrel ad5antr syl3anc simpllr elrelimasn biimpar adantlr wfn elpreima 3syl
      ffn ad7antr mpbir2and ex ralrimiva r19.26 pm3.33 ralimi sylbir w3a biimpa
      simpl2l simpl2r simpl3 breq2 eleq1 imbi12d rspcv sylc mpd ssrdv syl121anc
      reximdva simprbi eleqtrd elutop sneq imaeq2d sseq1d rexbidv r19.29a bitrd
      eleq2d ctopon ctps istps sylib iscn ) ADEFUFUGOZBUHPZCUHPZDUIZDUJUAUKZUMZ
      EOZUAFQZAYSUBUKZNUKZUCUKZULZUUDDPZUUEDPZUDUKZULZUNZNYQQZUBYQQUCBUOPZUPZUD
      CUOPZQZADUUNUUPUQUGOZYSUUQRZMAUUNYQURPOZUUPYRURPOZUURUUSUSABUTOZUUTIUVBUU
      TEUUNVAPZVBZYQUUNEBYQVCZUUNVCGVDZVESZACUTOZUVAJUVHUVAFUUPVAPZVBZYRUUPFCYR
      VCZUUPVCHVDZVESZUBNUUNDUUPYQYRUDUCVGVFVHZVIZAUUBUAFAYTFOZRZUUBUUAYQVJZUUF
      UUDVKUMZUUAVJZUCUUNUPZUBUUAQZUVQDVLZUUAYQDYTVMAUWCYQVBZUVPAYSUWDUVOYQYRDV
      NSTVOZUVQUWAUBUUAUVQUUDUUAOZRZUUJUUHVKZUMZYTVJZUWAUDUUPUWGUUJUUPOZRZUWJRZ
      UUMUCUUNUPZUWAUWLUWNUWJUWLAUWKUUDYQOZUWNAUVPUWFUWKVPZUWGUWKVQUWLUUAYQUUDU
      VQUVRUWFUWKUWEVSUVQUWFUWKVRVTZAUWKRZUWNUBYQUWRUUOUWNUBYQQAUUOUDUUPAYSUUQU
      VNWAWBUUMUCUBUUNYQWCSWBWDTUWMUUMUVTUCUUNUWMUUFUUNOZRZUUMUVTUWTUUMRZAUUFWH
      ZUVSYQVJZUUGUUEUUAOZUNZNYQQZUVTUWLAUWJUWSUUMUWPWEZUWTUXBUUMUWTUUTUWSUXBAU
      UTUVPUWFUWKUWJUWSUVGWIUWMUWSVQUUNUUFYQWFVFTUXAUUTUWSUWOUXCUXAAUUTUXGUVGSU
      WMUWSUUMVRUWLUWOUWJUWSUUMUWQWEUUDUUNUUFYQWGWJUXAUUMUUKUXDUNZNYQQZUXFUWTUU
      MVQUWTUXIUUMUWTUXHNYQUWTUUEYQOZRZUUKUXDUXKUUKRUXDUXJUUIYTOZUWTUXJUUKVRUWT
      UUKUXLUXJUWTUUKRUWIYTUUIUWLUWJUWSUUKWKUWTUUIUWIOZUUKUWTUUJWHZUXMUUKUSUWTU
      VAUWKUXNAUVAUVPUWFUWKUWJUWSUVMWIUWGUWKUWJUWSWKUUPUUJYRWFVFUUHUUIUUJWLSWMV
      TWNAUXDUXJUXLRUSZUVPUWFUWKUWJUWSUXJUUKAYSDYQWOZUXOUVOYQYRDWRZYQUUEYTDWPWQ
      WSWTXAXBTUUMUXIRUULUXHRZNYQQUXFUULUXHNYQXCUXRUXENYQUUGUUKUXDXDXEXFVFAUXBU
      XCRZUXFXGZUEUVSUUAUXTUEUKZUVSOZUYAUUAOZUXTUYBRZUUDUYAUUFULZUYCUYDUXBUYBUY
      EUXBUXCAUXFUYBXIUXTUYBVQZUXBUYBUYEUUDUYAUUFWLXHVFUYDUYAYQOUXFUYEUYCUNZUYD
      UVSYQUYAUXBUXCAUXFUYBXJUYFVTAUXSUXFUYBXKUXEUYGNUYAYQUUEUYAVBUUGUYEUXDUYCU
      UEUYAUUDUUFXLUUEUYAUUAXMXNXOXPXQXAXRXSXAXTXQUWGUUHYTOZUUJUYAVKZUMZYTVJZUD
      UUPUPZUEYTQZUWJUDUUPUPZUWGUWOUYHUVQUWFUWOUYHRZAUWFUYOUSZUVPAYSUXPUYPUVOUX
      QYQUUDYTDWPWQTXHWAUVQUYMUWFUVQYTYRVJZUYMUVQYTUVIOZUYQUYMRZUVQYTFUVIAUVPVQ
      AUVJUVPAUVHUVJJUVHUVAUVJUVLYASTYBAUYRUYSUSZUVPAUVAUYTUVMUEUDYTUUPYRYCSTVH
      WATUYLUYNUEUUHYTUYAUUHVBZUYKUWJUDUUPVUAUYJUWIYTVUAUYIUWHUUJUYAUUHYDYEYFYG
      XOXPYHXBUVQUUBUUAUVCOZUVRUWBRZUVQEUVCUUAAUVDUVPAUVBUVDIUVBUUTUVDUVFYASTYJ
      AVUBVUCUSZUVPAUUTVUDUVGUBUCUUAUUNYQYCSTYIWTXBAEYQYKPOZFYRYKPOZYPYSUUCRUSA
      BYLOVUEKYQEBUVEGYMYNACYLOVUFLYRFCUVKHYMYNUADEFYQYRYOVFWT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Cauchy filters in uniform spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CauFilU $.

  $( Extend class notation with the set of Cauchy filter bases. $)
  ccfilu $a class CauFilU $.

  ${
    $d u f v a $.
    $( Define the set of Cauchy filter bases on a uniform space.  A Cauchy
       filter base is a filter base on the set such that for every entourage
       ` v ` , there is an element ` a ` of the filter "small enough in
       ` v ` " i.e. such that every pair ` { x , y } ` of points in ` a ` is
       related by ` v ` ".  Definition 2 of [BourbakiTop1] p.  II.13.
       (Contributed by Thierry Arnoux, 16-Nov-2017.) $)
    df-cfilu $a |- CauFilU = ( u e. U. ran UnifOn |->
        { f e. ( fBas ` dom U. u ) | A. v e. u E. a e. f ( a X. a ) C_ v } ) $.
  $}

  ${
    $d a f u v $.  $d a f v F $.  $d f u v U $.
    $( The predicate " ` F ` is a Cauchy filter base on uniform space ` U ` ."
       (Contributed by Thierry Arnoux, 18-Nov-2017.) $)
    iscfilu $p |- ( U e. ( UnifOn ` X ) -> ( F e. ( CauFilU ` U ) <->
      ( F e. ( fBas ` X ) /\ A. v e. U E. a e. F ( a X. a ) C_ v ) ) ) $=
      ( vf vu cust cfv wcel ccfilu cuni cdm cfbas cv wrex wral wa crab wceq cxp
      wss crn elrnust unieq dmeqd raleq rabeqbidv df-cfilu fvex rabex fvmpt syl
      fveq2d eleq2d rexeq ralbidv elrab syl6bb ustbas2 anbi1d bitr4d ) BDHIJZCB
      KIZJZCBLZMZNIZJZEOZVJUAAOUBZECPZABQZRZCDNIZJZVMRVCVECVKEFOZPZABQZFVHSZJVN
      VCVDVTCVCBHUCLZJVDVTTBDUDGBVRAGOZQZFWBLZMZNIZSVTWAKWBBTZWCVSFWFVHWGWEVGNW
      GWDVFWBBUEUFUNVRAWBBUGUHAGFEUIVSFVHVGNUJUKULUMUOVSVMFCVHVQCTVRVLABVKEVQCU
      PUQURUSVCVPVIVMVCVOVHCVCDVGNBDUTUNUOVAVB $.
  $}

  ${
    $d a v F $.  $d v U $.
    $( A Cauchy filter base is a filter base.  (Contributed by Thierry Arnoux,
       19-Nov-2017.) $)
    cfilufbas $p |- ( ( U e. ( UnifOn ` X ) /\ F e. ( CauFilU ` U ) )
      -> F e. ( fBas ` X ) ) $=
      ( va vv cust cfv wcel ccfilu cfbas cv cxp wss wrex wral iscfilu simprbda
      ) ACFGHBAIGHBCJGHDKZRLEKMDBNEAOEABCDPQ $.
  $}

  ${
    $d a v F $.  $d a v V $.  $d v U $.
    $( For a Cauchy filter base and any entourage ` V ` , there is an element
       of the filter small in ` V ` .  (Contributed by Thierry Arnoux,
       19-Nov-2017.) $)
    cfiluexsm $p |- ( ( U e. ( UnifOn ` X ) /\ F e. ( CauFilU ` U ) /\ V e. U )
      -> E. a e. F ( a X. a ) C_ V ) $=
      ( vv cust cfv wcel ccfilu w3a cv cxp wss wrex wral cfbas iscfilu simplbda
      3adant3 wi wceq sseq2 rexbidv rspcv 3ad2ant3 mpd ) ADGHIZBAJHIZCAIZKELZUK
      MZFLZNZEBOZFAPZULCNZEBOZUHUIUPUJUHUIBDQHIUPFABDERSTUJUHUPURUAUIUOURFCAUMC
      UBUNUQEBUMCULUCUDUEUFUG $.
  $}

  ${
    $d p x y A $.  $d p x y F $.  $d p x y X $.
    $( Lemma for ~ fmucnd .  (Contributed by Thierry Arnoux, 19-Nov-2017.) $)
    fmucndlem $p |- ( ( F Fn X /\ A C_ X ) ->
      ( ( x e. X , y e. X |-> <. ( F ` x ) , ( F ` y ) >. ) " ( A X. A ) )
        = ( ( F " A ) X. ( F " A ) ) ) $=
      ( vp wss wa cv cfv cop cmpt2 cxp cima wceq cvv wcel fvex adantl wrex cres
      wfn df-ima simpr resmpt2 sylancom rneqd syl5eq wtru c1st c2nd cmpt op1std
      crn vex fveq2d op2ndd opeq12d mpt2mpt eqcomi rneqi a1i fliftrel trud xpss
      sseli fvelimab anbi12d eqid opex elrnmpt2 eqcom opth2 bitri reeanv 3bitri
      wb 2rexbii syl6rbbr opelxp syl6bbr adantr 1st2nd2 eleq1d 3bitr4d eqrdav
      eqtrd ) DEUBZCEGZHZABEEAIZDJZBIZDJZKZLZCCMZNZABCCWOLZUNZDCNZXAMZWJWRWPWQU
      AZUNWTWPWQUCWJXCWSWHWIWIXCWSOWHWIUDABEECCWOUEUFUGUHWJFWTXBPPMZFIZWTQZXEXD
      QZWJWTXDXEWTXDGUIFXEUJJZDJZXEUKJZDJZPPWTWQWSFWQXIXKKZULZXMWSABFCCXLWOXEWK
      WMKOZXIWLXKWNXNXHWKDWKWMXEAUOZBUOZUMUPXNXJWMDWKWMXEXOXPUQUPURUSUTVAXIPQUI
      XEWQQHZXHDRVBXKPQXQXJDRVBVCVDVFSXEXBQZXGWJXBXDXEXAXAVEVFSWJXGHZXHXJKZWTQZ
      XTXBQZXFXRWJYAYBVQXGWJYAXHXAQZXJXAQZHZYBWJYEWLXHOZACTZWNXJOZBCTZHZYAWJYCY
      GYDYIAECXHDVGBECXJDVGVHYAXTWOOZBCTACTYFYHHZBCTACTYJABCCWOXTWSWSVIWLWNVJVK
      YKYLABCCYKWOXTOYLXTWOVLWLWNXHXJXEUJRXEUKRVMVNVRYFYHABCCVOVPVSXHXJXAXAVTWA
      WBXSXEXTWTXGXEXTOWJXEPPWCSZWDXSXEXTXBYMWDWEWFWG $.
  $}

  ${
    $d a c C $.  $d a c C $.  $d a b v D $.  $d a b c r s t v x y F $.
    $d r s t v x y U $.  $d a r s t v x y V $.  $d a r s t v x y X $.
    $d a r s v x Y $.  $d a s t v x y ph $.
    fmucnd.1 $e |- ( ph -> U e. ( UnifOn ` X ) ) $.
    fmucnd.2 $e |- ( ph -> V e. ( UnifOn ` Y ) ) $.
    fmucnd.3 $e |- ( ph -> F e. ( U uCn V ) ) $.
    fmucnd.4 $e |- ( ph -> C e. ( CauFilU ` U ) ) $.
    fmucnd.5 $e |- D = ran ( a e. C |-> ( F " a ) ) $.
    $( The image of a Cauchy filter base by an uniformly continuous function is
       a Cauchy filter base.  Deduction form.  Proposition 3 of [BourbakiTop1]
       p.  II.13.  (Contributed by Thierry Arnoux, 18-Nov-2017.) $)
    fmucnd $p   |- ( ph -> D e. ( CauFilU ` V ) ) $=
      ( vx vy vc cfv wcel cv vb vv vr vs vt ccfilu cfbas cxp wss wrex wral cust
      wf cvv cfilufbas syl2anc cucn co wa wbr wi isucn simprbda syl21anc fbasrn
      elfvexd syl3anc cop ccnv cima cmpt crn wceq simplr eqid weq imaeq2 eqeq2d
      cmpt2 rspcev sylancl wb imaexg elrnmpt 3syl ad3antrrr cbvmptv rneqi eqtri
      mpbird syl6eleqr wfn ffn simplll fbelss sylan fmucndlem mpt2fun funimass2
      syl wfun mpan adantl eqsstr3d id xpeq12d sseq1d adantr simpr simpl fveq2d
      opeq12d cbvmpt2 ucnprima cfiluexsm r19.29a ralrimiva iscfilu mpbir2and
      nfcv ) ACFUFRSZCHUGRSZUATZYCUHZUBTZUIZUACUJZUBFUKZABGUGRSZGHEUMZHUNSYBADG
      ULRSZBDUFRSZYIJMDBGUOUPZAYKFHULRSZEDFUQURZSZYJJKLYKYNUSYPYJOTZPTZUCTUTYQE
      RZYRERZYEUTVAPGUKOGUKUCDUJUBFUKOPDEFGHUBUCVBVCVDZAFULHKVFIBCEUNGHNVEVGAYG
      UBFAYEFSZUSZITZUUDUHZOPGGYSYTVHZVSZVIYEVJZUIZYGIBUUCUUDBSZUSZUUIUSZEUUDVJ
      ZCSUUMUUMUHZYEUIZYGUULUUMQBEQTZVJZVKZVLZCUULUUMUUSSZUUMUUQVMZQBUJZUULUUJU
      UMUUMVMZUVBUUCUUJUUIVNZUUMVOUVAUVCQUUDBQIVPUUQUUMUUMUUPUUDEVQVRVTWAAUUTUV
      BWBZUUBUUJUUIAYPUUMUNSUVELEUUDYOWCQBUUQUUMUURUNUURVOWDWEWFWJCIBUUMVKZVLUU
      SNUVFUURIQBUUMUUQUUDUUPEVQWGWHWIWKUULUUNUUGUUEVJZYEUULEGWLZUUDGUIZUVGUUNV
      MAUVHUUBUUJUUIAYJUVHUUAGHEWMWTWFUULAUUJUVIAUUBUUJUUIWNUVDAYIUUJUVIYMGBUUD
      WOWPUPOPUUDEGWQUPUUIUVGYEUIZUUKUUGXAUUIUVJOPGGUUFUUGUUGVOWRUUEYEUUGWSXBXC
      XDYFUUOUAUUMCYCUUMVMZYDUUNYEUVKYCUUMYCUUMUVKXEZUVLXFXGVTUPUUCYKYLUUHDSUUI
      IBUJAYKUUBJXHZAYLUUBMXHUUCUDUEDEUUGFYEGHUVMAYNUUBKXHAYPUUBLXHAUUBXIOPUDUE
      GGUUFUDTZERZUETZERZVHZUDUUFXTUEUUFXTOUVRXTPUVRXTOUDVPZPUEVPZUSZYSUVOYTUVQ
      UWAYQUVNEUVSUVTXJXKUWAYRUVPEUVSUVTXIXKXLXMXNDBUUHGIXOVGXPXQAYNYAYBYHUSWBK
      UBFCHUAXRWTXS $.
  $}

  ${
    $d a b c v F $.  $d a b v X $.  $d b v U $.
    $( The filter generated by a Cauchy filter base is still a Cauchy filter
       base.  (Contributed by Thierry Arnoux, 24-Jan-2018.) $)
    cfilufg $p |- ( ( U e. ( UnifOn ` X ) /\ F e. ( CauFilU ` U ) )
      -> ( X filGen F ) e. ( CauFilU ` U ) ) $=
      ( va vv vb cust cfv wcel ccfilu wa cfg co cfbas cxp wss wrex wral iscfilu
      cv cfil cfilufbas fgcl filfbas 3syl ad3antrrr ssfg syl simplr weq xpeq12d
      sseldd id sseq1d rspcev sylancom simplbda r19.21bi ralrimiva wb mpbir2and
      r19.29a adantr ) ACGHIZBAJHZIZKZCBLMZVEIZVHCNHZIZDTZVLOZETZPZDVHQZEARZVGB
      VJIZVHCUAHIVKABCUBZBCUCVHCUDUEVGVPEAVGVNAIZKZFTZWBOZVNPZVPFBWAWBBIZKZWDWB
      VHIVPWFWDKZBVHWBWGVRBVHPVGVRVTWEWDVSUFBCUGUHWAWEWDUIULVOWDDWBVHDFUJZVMWCV
      NWHVLWBVLWBWHUMZWIUKUNUOUPVGWDFBQZEAVDVFVRWJEAREABCFSUQURVBUSVDVIVKVQKUTV
      FEAVHCDSVCVA $.
  $}

  ${
    $d a b v w A $.  $d a b v w F $.  $d a v w U $.  $d a v w X $.
    $( Condition for the trace of a Cauchy filter base to be a Cauchy filter
       base for the restricted uniform structure.  (Contributed by Thierry
       Arnoux, 24-Jan-2018.) $)
    trcfilu $p |- ( ( U e. ( UnifOn ` X ) /\
      ( F e. ( CauFilU ` U ) /\ -. (/) e. ( F |`t A ) ) /\ A C_ X )
      -> ( F |`t A ) e. ( CauFilU ` ( U |`t ( A X. A ) ) ) ) $=
      ( vb vw va vv cust cfv wcel ccfilu wa wss cxp cv wrex syl2anc cin cvv w3a
      c0 crest co wn cfbas wral simp1 simp2l iscfilu biimpa simpld simp3 simp2r
      trfbas2 biimpar syl21anc wceq ad5antr adantr elfvexd ssexd ad4antr simplr
      elrestr syl3anc inxp simpr ssrin syl simpllr sseqtr4d syl5eqssr id sseq1d
      xpeq12d rspcev simprd r19.21bi 3ad2antr2 3anassrs r19.29a xpexg ralrimiva
      elrest wb trust mpbir2and ) BDIJZKZCBLJZKZUBCAUCUDZKUEZMZADNZUAZWMBAAOZUC
      UDZLJKZWMAUFJKZEPZXBOZFPZNZEWMQZFWSUGZWQCDUFJKZWPWNXAWQXHGPZXIOZHPZNZGCQZ
      HBUGZWQWJWLXHXNMZWJWOWPUHZWJWLWNWPUIZWJWLXOHBCDGUJUKRZULWJWOWPUMZWJWLWNWP
      UNXHWPMXAWNACDUOUPUQWQXFFWSWQXDWSKZMZXDXKWRSZURZXFHBYAXKBKZMZYCMZXLXFGCYF
      XICKZMZXLMZXIASZWMKZYJYJOZXDNZXFYIWLATKZYGYKWQWLXTYDYCYGXLXQUSYAYNYDYCYGX
      LYAADTYABIDWQWJXTXPUTZVAWQWPXTXSUTVBZVCYFYGXLVDXIACWKTVEVFYIYLXJWRSZXDXIX
      IAAVGYIYQYBXDYIXLYQYBNYHXLVHXJXKWRVIVJYEYCYGXLVKVLVMXEYMEYJWMXBYJURZXCYLX
      DYRXBYJXBYJYRVNZYSVPVOVQRWQXTYDYCXMWQXTYDXMYCWQXMHBWQXHXNXRVRVSVTWAWBYAWJ
      WRTKZXTYCHBQZYOYAYNYNYTYPYPAATTWCRWQXTVHWJYTMXTUUAHXDWRBWITWEUKUQWBWDWQWS
      AIJKZWTXAXGMWFWQWJWPUUBXPXSABDWGRFWSWMAEUJVJWH $.
  $}

  ${
    $d a u v A $.  $d a u v F $.  $d u v U $.  $d v X $.
    $( A Cauchy filter base is also a Cauchy filter base on any coarser uniform
       structure.  (Contributed by Thierry Arnoux, 24-Jan-2018.) $)
    cfiluweak $p |- ( ( U e. ( UnifOn ` X ) /\ A C_ X
      /\ F e. ( CauFilU ` ( U |`t ( A X. A ) ) ) ) -> F e. ( CauFilU ` U ) ) $=
      ( va vv vu cust cfv wcel wss cxp ccfilu cfbas cv wrex cvv syl2anc adantr
      wa crest co w3a wral cpw trust 3adant3 simp3 iscfilu biimpa simpld fbsspw
      syl simp2 sspwb sylib sstrd simp1 elfvexd syl3anc cin ssexd xpexg elrestr
      fbasweak simpr simprd wceq sseq2 rspcva inss1 sstr mpan2 reximi ralrimiva
      rexbidv wb 3ad2ant1 mpbir2and ) BDHIZJZADKZCBAALZUAUBZMIJZUCZCBMIJZCDNIJZ
      EOZWILZFOZKZECPZFBUDZWFCANIJZCDUEZKDQJZWHWFWOWJGOZKZECPZGWDUDZWFWDAHIJZWE
      WOXATZWAWBXBWEABDUFUGWAWBWEUHXBWEXCGWDCAEUIUJRZUKZWFCAUEZWPWFWOCXFKXEACUL
      UMWFWBXFWPKWAWBWEUNZADUOUPUQWFBHDWAWBWEURZUSZCQADVEUTWFWMFBWFWKBJZTZWJWKW
      CVAZKZECPZWMXKXLWDJZXAXNXKWAWCQJZXJXOWFWAXJXHSXKAQJZXQXPXKADQWFWQXJXISWFW
      BXJXGSVBZXRAAQQVCRWFXJVFWKWCBVTQVDUTWFXAXJWFWOXAXDVGSWTXNGXLWDWRXLVHWSXME
      CWRXLWJVIVPVJRXMWLECXMXLWKKWLWKWCVKWJXLWKVLVMVNUMVOWAWBWGWHWNTVQWEFBCDEUI
      VRVS $.
  $}

  ${
    $d a v w J $.  $d a u v w P $.  $d u v w U $.  $d u v w X $.  $d v w W $.
    neipcfilu.x $e |- X = ( Base ` W ) $.
    neipcfilu.j $e |- J = ( TopOpen ` W ) $.
    neipcfilu.u $e |- U = ( UnifSt ` W ) $.
    $( In an uniform space, a neighboring filter is a Cauchy filter base.
       (Contributed by Thierry Arnoux, 24-Jan-2018.) $)
    neipcfilu $p |- ( ( W e. UnifSp /\ W e. TopSp /\ P e. X )
      -> ( ( nei ` J ) ` { P } ) e. ( CauFilU ` U ) ) $=
      ( va vv vw vu wcel w3a cfv wss wrex wa wceq syl2anc cusp ctps cnei ccfilu
      csn cfbas cv cxp wral cfil ctopon wne simp2 istps sylib simp3 snssd snnzg
      syl neifil syl3anc filfbas cima cutop cmpt crn imaeq1 eqeq2d rspcev mpan2
      c0 eqid cvv wb vex imaexg elrnmpt mp2b sylibr ad2antlr cust isusp simplbi
      3ad2ant1 utopsnneip eleq2d ad3antrrr mpbird simpl1 3anassrs fveq2d fveq1d
      simprbi eleqtrrd simpr id xpeq12d sseq1d adantr ccom ccnv simplr ustexsym
      simpll1 ad2antrr ustssxp simpll2 ustneism simprl coeq2d coss1 coss2 sstrd
      ad2antll simpllr eqsstrd reximdva mpd ustexhalf 3adant2 r19.29a ralrimiva
      ex iscfilu mpbir2and ) DUAMZDUBMZAEMZNZAUEZCUCOZOZBUDOMZYLEUFOMZIUGZYOUHZ
      JUGZPZIYLQZJBUIZYIYLEUJOMZYNYICEUKOMZYJEPYJVKULZUUAYIYGUUBYFYGYHUMECDFGUN
      UOYIAEYFYGYHUPZUQYIYHUUCUUDAEURUSYJCEUTVAYLEVBUSYIYSJBYIYQBMZRZKUGZYJVCZU
      UHUHZYQPZYSKBUUFUUGBMZRZUUJRZUUHYLMUUJYSUUMUUHYJBVDOZUCOZOZYLUUMUUHUUPMZU
      UHJBYQYJVCZVEZVFZMZUUKUVAUUFUUJUUKUUHUURSZJBQZUVAUUKUUHUUHSZUVCUUHVLUVBUV
      DJUUGBYQUUGSUURUUHUUHYQUUGYJVGVHVIVJUUGVMMUUHVMMUVAUVCVNKVOUUGYJVMVPJBUUR
      UUHUUSVMUUSVLVQVRVSVTYIUUQUVAVNUUEUUKUUJYIUUPUUTUUHYIBEWAOMZYHUUPUUTSYFYG
      UVEYHYFUVECUUNSZEBCDFHGWBZWCWDZUUDJABUUNEUUNVLWETWFWGWHUUMYJYKUUOUUMCUUNU
      CUUMYFUVFYIUUEUUKUUJYFYFYGYHUUEUUKUUJNWIWJYFUVEUVFUVGWMUSWKWLWNUULUUJWOYR
      UUJIUUHYLYOUUHSZYPUUIYQUVIYOUUHYOUUHUVIWPZUVJWQWRVITUUFUVEYHUUEUUJKBQZYIU
      VEUUEUVHWSYIYHUUEUUDWSYIUUEWOUVEYHUUENZLUGZUVMWTZYQPZUVKLBUVLUVMBMZRZUVOR
      ZUUGXAZUUGSZUUGUVMPZRZKBQZUVKUVRUVEUVPUWCUVEYHUUEUVPUVOXDZUVLUVPUVOXBKBUV
      MEXCTUVRUWBUUJKBUVRUUKRZUWBUUJUWEUWBRZUUIUUGUVSWTZYQUWFUUGEEUHPZYHUUIUWGP
      UWFUVEUUKUWHUVRUVEUUKUWBUWDXEUVRUUKUWBXBBUUGEXFTUVQUVOUUKUWBYHUVEYHUUEUVP
      UVOUUKUWBNXGWJAUUGEXHTUWFUWGUUGUUGWTZYQUWFUVSUUGUUGUWEUVTUWAXIXJUWFUWIUVN
      YQUWAUWIUVNPUWEUVTUWAUWIUVMUUGWTUVNUUGUVMUUGXKUUGUVMUVMXLXMXNUVQUVOUUKUWB
      XOXMXPXMYCXQXRUVEUUEUVOLBQYHLBYQEXSXTYAVAYAYBYIUVEYMYNYTRVNUVHJBYLEIYDUSY
      E $.
  $}

  $(
    cvgfcfilu.j @e |- J = ( TopOpen ` W ) @.
    cvgfcfilu.u @e |- U = ( UnifSt ` W ) @.
    @( In an uniform space, all convergent filters are Cauchy filters bases.
       Proposition 2 of [BourbakiTop1] p.  II.13. (Contributed by Thierry
       Arnoux, 18-Nov-2017.) @)
    cvgfcfilu @p |- ( ( W e. UnifSp /\ W e. TopSp /\ A e. ( J fLim F ) )
      -> F e. ( CauFilU ` U ) ) @=
      ? @.
  $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Complete uniform spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CUnifSp $.

  $( Extend class notation with the class of all complete uniform spaces. $)
  ccusp $a class CUnifSp $.

  ${
    $d c w $.
    $( Define the class of all complete uniform spaces.  Definition 3 of
       [BourbakiTop1] p.  II.15.  (Contributed by Thierry Arnoux,
       1-Dec-2017.) $)
    df-cusp $a |- CUnifSp = { w e. UnifSp | A. c e. ( Fil ` ( Base ` w ) )
      ( c e. ( CauFilU ` ( UnifSt ` w ) )
        -> ( ( TopOpen ` w ) fLim c ) =/= (/) ) } $.
  $}

  ${
    $d c w W $.
    $( The predicate " ` W ` is a complete uniform space."  (Contributed by
       Thierry Arnoux, 3-Dec-2017.) $)
    iscusp $p |- ( W e. CUnifSp <-> ( W e. UnifSp /\
      A. c e. ( Fil ` ( Base ` W ) ) ( c e. ( CauFilU ` ( UnifSt ` W ) )
        -> ( ( TopOpen ` W ) fLim c ) =/= (/) ) ) ) $=
      ( vw cv cuss cfv ccfilu wcel ctopn cflim co c0 wne wi cbs cfil wral fveq2
      cusp fveq2d ccusp eleq2d oveq1d neeq1d imbi12d raleqbidv df-cusp elrab2
      wceq ) BDZCDZEFZGFZHZUKIFZUJJKZLMZNZBUKOFZPFZQUJAEFZGFZHZAIFZUJJKZLMZNZBA
      OFZPFZQCASUAUKAUIZURVGBUTVIVJUSVHPUKAORTVJUNVCUQVFVJUMVBUJVJULVAGUKAERTUB
      VJUPVELVJUOVDUJJUKAIRUCUDUEUFCBUGUH $.

    $( A complete uniform space is an uniform space.  (Contributed by Thierry
       Arnoux, 3-Dec-2017.) $)
    cuspusp $p |- ( W e. CUnifSp -> W e. UnifSp ) $=
      ( vc ccusp wcel cusp cv cuss cfv ccfilu ctopn cflim co c0 wne wi cbs cfil
      wral iscusp simplbi ) ACDAEDBFZAGHIHDAJHUAKLMNOBAPHQHRABST $.

    $d c B $.  $d c C $.  $d c J $.
    cuspcvg.1 $e |- B = ( Base ` W ) $.
    cuspcvg.2 $e |- J = ( TopOpen ` W ) $.
    $( In a complete uniform space, any Cauchy filter ` C ` has a limit.
       (Contributed by Thierry Arnoux, 3-Dec-2017.) $)
    cuspcvg $p |- ( ( W e. CUnifSp /\ C e. ( CauFilU ` ( UnifSt ` W ) )
      /\ C e. ( Fil ` B ) ) -> ( J fLim C ) =/= (/) ) $=
      ( vc ccusp wcel cfil cfv cuss ccfilu cflim co c0 wne wa wi wceq cbs ctopn
      cv wral simpr fveq2i syl6eleq cusp iscusp simprbi adantr eleq1 eqcomi a1i
      id oveq12d neeq1d imbi12d rspcva syl2anc 3impia 3com23 ) DHIZBAJKZIZBDLKM
      KZIZCBNOZPQZVCVEVGVIVCVERZBDUAKZJKZIGUCZVFIZDUBKZVMNOZPQZSZGVLUDZVGVISZVJ
      BVDVLVCVEUEAVKJEUFUGVCVSVEVCDUHIVSDGUIUJUKVRVTGBVLVMBTZVNVGVQVIVMBVFULWAV
      PVHPWAVOCVMBNVOCTWACVOFUMUNWAUOUPUQURUSUTVAVB $.
  $}

  ${
    $d c W $.
    iscusp2.1 $e |- B = ( Base ` W ) $.
    iscusp2.2 $e |- U = ( UnifSt ` W ) $.
    iscusp2.3 $e |- J = ( TopOpen ` W ) $.
    $( The predicate " ` W ` is a complete uniform space."  (Contributed by
       Thierry Arnoux, 15-Dec-2017.) $)
    iscusp2 $p |- ( W e. CUnifSp <-> ( W e. UnifSp /\ A. c e. ( Fil ` B )
      ( c e. ( CauFilU ` U ) -> ( J fLim c ) =/= (/) ) ) ) $=
      ( wcel cfv ccfilu cflim co c0 wne wi cfil wral wa fveq2i ccusp cusp ctopn
      cv cuss cbs iscusp eleq2i oveq1i neeq1i imbi12i raleqbii anbi2i bitr4i )
      DUAIDUBIZEUDZDUEJZKJZIZDUCJZUPLMZNOZPZEDUFJZQJZRZSUOUPBKJZIZCUPLMZNOZPZEA
      QJZRZSDEUGVMVFUOVKVCEVLVEAVDQFTVHUSVJVBVGURUPBUQKGTUHVIVANCUTUPLHUIUJUKUL
      UMUN $.
  $}

  ${
    $d x A $.  $d x F $.  $d x J $.  $d x K $.  $d x ph $.
    cnextucn.x $e |- X = ( Base ` V ) $.
    cnextucn.y $e |- Y = ( Base ` W ) $.
    cnextucn.j $e |- J = ( TopOpen ` V ) $.
    cnextucn.k $e |- K = ( TopOpen ` W ) $.
    cnextucn.u $e |- U = ( UnifSt ` W ) $.
    cnextucn.v $e |- ( ph -> V e. TopSp ) $.
    cnextucn.t $e |- ( ph -> W e. TopSp ) $.
    cnextucn.w $e |- ( ph -> W e. CUnifSp ) $.
    cnextucn.h $e |- ( ph -> K e. Haus ) $.
    cnextucn.a $e |- ( ph -> A C_ X ) $.
    cnextucn.f $e |- ( ph -> F : A --> Y ) $.
    cnextucn.c $e |- ( ph -> ( ( cls ` J ) ` A ) = X ) $.
    cnextucn.l $e |- ( ( ph /\ x e. X ) ->
        ( ( Y FilMap F ) ` ( ( ( nei ` J ) ` { x } ) |`t A ) )
      e. ( CauFilU ` U ) ) $.
    $( Extension by continuity.  Proposition 11 of [BourbakiTop1] p.  II.20.
       Given a topology ` J ` on ` X ` , a subset ` A ` dense in ` X ` , this
       states a condition for ` F ` from ` A ` to a space ` Y ` Hausdorff and
       complete to be extensible by continuity (Contributed by Thierry Arnoux,
       4-Dec-2017.) $)
    cnextucn $p |- ( ph -> ( ( J CnExt K ) ` F ) e. ( J Cn K ) ) $=
      ( cuni eqid ctps wcel ctop tpstop syl wf wceq wb tpsuni mpbid sseqtrd ccl
      feq3 cfv eqtrd cv wa csn cnei crest co cflf cfm cflim c0 cfil istps sylib
      ctopon adantr eleq2d biimpar eleqtrrd toptopon fveq2 mpbird trnei syl3anc
      wss flfval ccusp cuss ccfilu wne syldan fveq2i syl6eleq cvv cfbas eqeltri
      cbs fvex a1i filfbas cuspcvg eqnetrd cusp cha creg cuspusp uspreg syl2anc
      fmfil cnextcn ) ABCGUEZFUEZEFGXLUFZXKUFAHUGUHZFUIUHZQFHNUJUKZTACKEULZCXKE
      ULZUBAKXKUMZXQXRUNAIUGUHZXSRKGIMOUOUKKXKCEUSUKUPACJXLUAAXNJXLUMZQJFHLNUOU
      KZUQACFURUTUTZJXLUCYBVAABVBZXLUHZVCZEGYDVDFVEUTUTCVFVGZVHVGUTZGYGKEVIVGUT
      ZVJVGZVKYFGKVOUTUHZYGCVLUTUHZXQYHYJUMAYKYEAXTYKRKGIMOVMVNVPYFYDYCUHZYLYFY
      DJYCAYDJUHZYEAJXLYDYBVQVRZAYCJUMYEUCVPVSYFFJVOUTZUHZCJWEZYNYMYLUNAYQYEAYQ
      FXLVOUTZUHZAXOYTXPFXLXMVTVNAYAYQYTUNYBYAYPYSFJXLVOWAVQUKWBVPAYRYEUAVPYOCY
      DFJWCWDUPZAXQYEUBVPZEGYGKCWFWDYFIWGUHZYIIWHUTZWIUTZUHYIKVLUTUHZYJVKWJAUUC
      YESVPYFYIDWIUTZUUEAYEYNYIUUGUHYOUDWKDUUDWIPWLWMYFKWNUHZYGCWOUTUHZXQUUFUUH
      YFKIWQUTWNMIWQWRWPWSYFYLUUIUUAYGCWTUKUUBWNYGEKCXIWDKYIGIMOXAWDXBAIXCUHZGX
      DUHGXEUHAUUCUUJSIXFUKTGIOXGXHXJ $.
  $}

  ${
    $d a b v w x y z A $.  $d a b v w x y z F $.  $d a b x J $.  $d x K $.
    $d v w y z T $.  $d b v w y U $.  $d b X $.  $d a b v w y Y $.
    $d b x ph $.
    ucnextcn.x $e |- X = ( Base ` V ) $.
    ucnextcn.y $e |- Y = ( Base ` W ) $.
    ucnextcn.j $e |- J = ( TopOpen ` V ) $.
    ucnextcn.k $e |- K = ( TopOpen ` W ) $.
    ucnextcn.s $e |- S = ( UnifSt ` V ) $.
    ucnextcn.t $e |- T = ( UnifSt ` ( V |`s A ) ) $.
    ucnextcn.u $e |- U = ( UnifSt ` W ) $.
    ucnextcn.v $e |- ( ph -> V e. TopSp ) $.
    ucnextcn.r $e |- ( ph -> V e. UnifSp ) $.
    ucnextcn.w $e |- ( ph -> W e. TopSp ) $.
    ucnextcn.z $e |- ( ph -> W e. CUnifSp ) $.
    ucnextcn.h $e |- ( ph -> K e. Haus ) $.
    ucnextcn.a $e |- ( ph -> A C_ X ) $.
    ucnextcn.f $e |- ( ph -> F e. ( T uCn U ) ) $.
    ucnextcn.c $e |- ( ph -> ( ( cls ` J ) ` A ) = X ) $.
    $( Extension by continuity.  Theorem 2 of [BourbakiTop1] p.  II.20.  Given
       an uniform space on a set ` X ` , a subset ` A ` dense in ` X ` , and a
       function ` F ` uniformly continuous from ` A ` to ` Y ` , that function
       can be extended by continuity to the whole ` X ` , and its extension is
       uniformly continuous.  (Contributed by Thierry Arnoux, 25-Jan-2018.) $)
    ucnextcn $p |- ( ph -> ( ( J CnExt K ) ` F ) e. ( J Cn K ) ) $=
      ( vx vy vz vv vw va vb wf cv wbr cfv wi wral wrex cucn co wcel wa cust wb
      cusp wss ressust syl2anc cutop ccusp cuspusp syl isusp sylib simpld isucn
      wceq mpbid csn cnei crest cfm cima cmpt crn cfg ccfilu cvv adantr elfvexd
      cfbas cfil ccl simpr eleqtrrd ctopon ctps istps trnei syl3anc filfbas cxp
      fmval c0 wn neipcfilu 0nelfb trcfilu syl121anc cress cuss ressuss 3eqtr4g
      oveq1i fveq2d imaeq2 cbvmptv rneqi fmucnd cfilufg eqeltrd cnextucn ) AUHB
      EFGHIJKLMNOPSTUBUCUDUEABLFUOZUIUPZUJUPZUKUPUQYGFURYHFURULUPUQUSUJBUTUIBUT
      UKDVAULEUTZAFDEVBVCVDZYFYIVEZUFADBVFURVDZELVFURVDZYJYKVGAIVHVDZBKVIZYLUAU
      EBDIKMRVJVKZAYMHEVLURVTZAJVHVDZYMYQVEAJVMVDYRUCJVNVOLEHJNSPVPVQVRZUIUJDFE
      BLULUKVSVKWAVRZUGAUHUPZKVDZVEZUUAWBGWCURURZBWDVCZLFWEVCURZLUMUUEFUMUPZWFZ
      WGZWHZWIVCZEWJURZUUCLWKVDUUEBWNURVDZYFUUFUUKVTUUCEVFLAYMUUBYSWLZWMUUCUUEB
      WOURVDZUUMUUCUUABGWPURURZVDZUUOUUCUUAKUUPAUUBWQZAUUPKVTUUBUGWLWRUUCGKWSUR
      VDZYOUUBUUQUUOVGAUUSUUBAIWTVDZUUSTKGIMOXAVQWLAYOUUBUEWLZUURBUUAGKXBXCWAUU
      EBXDVOZAYFUUBYTWLUMWKUUEFLBXFXCUUCYMUUJUULVDUUKUULVDUUNUUCUUEUUJDFEBLUNAY
      LUUBYPWLZUUNAYJUUBUFWLUUCUUECBBXEZWDVCZWJURZDWJURZUUCCKVFURVDZUUDCWJURVDZ
      XGUUEVDXHZYOUUEUVFVDAUVHUUBAUVHGCVLURVTZAYNUVHUVKVEUAKCGIMQOVPVQVRWLUUCYN
      UUTUUBUVIAYNUUBUAWLAUUTUUBTWLUURUUACGIKMOQXIXCUUCUUMUVJUVBBUUEXJVOUVABCUU
      DKXKXLUUCBWKVDZUVGUVFVTUUCDVFBUVCWMUVLDUVEWJUVLIBXMVCXNURIXNURZUVDWDVCDUV
      EBWKIXORCUVMUVDWDQXQXPXRVOWRUUIUNUUEFUNUPZWFZWGUMUNUUEUUHUVOUUGUVNFXSXTYA
      YBEUUJLYCVKYDYE $.

$(
    @( Extension by continuity. Theorem 2 of [BourbakiTop1] p.  II.20. The
       extension obtained by ~ ucnextcn is uniformly continuous. (Contributed
       by Thierry Arnoux, 25-Jan-20178) @)
    ucnextucn @p |- ( ph -> ( ( J CnExt K ) ` F ) e. ( S uCn U ) ) @=
      ? @.
$)
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Metric spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Pseudometric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d d u x y z X $.  $d d x y z D $.
    $( Express the predicate " ` D ` is a pseudometric."  (Contributed by
       Thierry Arnoux, 7-Feb-2018.) $)
    ispsmet $p |- ( X e. V -> ( D e. ( PsMet ` X ) <->
      ( D : ( X X. X ) --> RR* /\ A. x e. X ( ( x D x ) = 0 /\ A. y e. X
        A. z e. X ( x D y ) <_ ( ( z D x ) +e ( z D y ) ) ) ) ) ) $=
      ( vd vu wcel cxr cmap co cv cc0 wceq cxad wral wa cvv oveq cpsmet cfv cxp
      cle wbr wf crab elex id oveq2d raleq raleqbi1dv anbi2d rabeqbidv df-psmet
      xpeq12d ovex rabex eleq2d eqeq1d oveq12d breq12d 2ralbidv anbi12d ralbidv
      fvmpt syl elrab syl6bb wb xrex xpexg anidms elmapg sylancr anbi1d bitrd )
      FEIZDFUAUBZIZDJFFUCZKLZIZAMZWDDLZNOZWDBMZDLZCMZWDDLZWIWGDLZPLZUDUEZCFQBFQ
      ZRZAFQZRZWAJDUFZWPRVRVTDWDWDGMZLZNOZWDWGWSLZWIWDWSLZWIWGWSLZPLZUDUEZCFQZB
      FQZRZAFQZGWBUGZIWQVRVSXKDVRFSIVSXKOFEUHHFXAXFCHMZQZBXLQZRZAXLQZGJXLXLUCZK
      LZUGXKSUAXLFOZXPXJGXRWBXSXQWAJKXSXLFXLFXSUIZXTUPUJXOXIAXLFXSXNXHXAXMXGBXL
      FXFCXLFUKULUMULUNHABCGUOXJGWBJWAKUQURVFVGUSXJWPGDWBWSDOZXIWOAFYAXAWFXHWNY
      AWTWENWDWDWSDTUTYAXFWMBCFFYAXBWHXEWLUDWDWGWSDTYAXCWJXDWKPWIWDWSDTWIWGWSDT
      VAVBVCVDVEVHVIVRWCWRWPVRJSIWASIZWCWRVJVKVRYBFFEEVLVMJWADSSVNVOVPVQ $.
  $}

  ${
    $d x y z D $.  $d x y z X $.
    $( Recover the base set from a pseudometric.  (Contributed by Thierry
       Arnoux, 7-Feb-2018.) $)
    psmetdmdm $p |- ( D e. ( PsMet ` X ) -> X = dom dom D ) $=
      ( vx vy vz cpsmet cfv wcel cdm cxp cxr wf wceq cv co cc0 cxad wral wa cvv
      cle wbr elfvex ispsmet biimpa mpancom simpld fdm dmeqd syl dmxpid syl6req
      ) ABFGHZAIZIZBBJZIZBUMUPKALZUOUQMUMURCNZUSAOPMUSDNZAOENZUSAOVAUTAOQOUAUBE
      BRDBRSCBRZBTHZUMURVBSZABFUCVCUMVDCDEATBUDUEUFUGURUNUPUPKAUHUIUJBUKUL $.
  $}

  ${
    $d a b c D $.  $d a b c X $.
    $( The distance function of a pseudometric as a function.  (Contributed by
       Thierry Arnoux, 7-Feb-2018.) $)
    psmetf $p |- ( D e. ( PsMet ` X ) -> D : ( X X. X ) --> RR* ) $=
      ( va vb vc cpsmet cfv wcel cxp cxr wf cv co cc0 wceq cxad cle wral wa cvv
      wbr wb elfvex ispsmet syl ibi simpld ) ABFGHZBBIJAKZCLZUJAMNOUJDLZAMELZUJ
      AMULUKAMPMQUAEBRDBRSCBRZUHUIUMSZUHBTHUHUNUBABFUCCDEATBUDUEUFUG $.

    $( Closure of the distance function of a pseudometric space.  (Contributed
       by Thierry Arnoux, 7-Feb-2018.) $)
    psmetcl $p |- ( ( D e. ( PsMet ` X ) /\ A e. X /\ B e. X ) ->
        ( A D B ) e. RR* ) $=
      ( cpsmet cfv wcel cxp cxr wf co psmetf fovrn syl3an1 ) CDEFGDDHICJADGBDGA
      BCKIGCDLABIDDCMN $.

    $d a A $.
    $( The distance function of a pseudometric space is zero if its arguments
       are equal.  (Contributed by Thierry Arnoux, 7-Feb-2018.) $)
    psmet0 $p |- ( ( D e. ( PsMet ` X ) /\ A e. X ) -> ( A D A ) = 0 ) $=
      ( va vb vc cpsmet cfv wcel cv co cc0 wceq wral wa cxad cle wbr cxp cvv wf
      cxr wb elfvex ispsmet syl ibi simprd r19.21bi simpld ralrimiva id oveq12d
      eqeq1d rspcv mpan9 ) BCGHIZDJZURBKZLMZDCNACIAABKZLMZUQUTDCUQURCIOUTUREJZB
      KFJZURBKVDVCBKPKQRFCNECNZUQUTVEOZDCUQCCSUBBUAZVFDCNZUQVGVHOZUQCTIUQVIUCBC
      GUDDEFBTCUEUFUGUHUIUJUKUTVBDACURAMZUSVALVJURAURABVJULZVKUMUNUOUP $.

    $d b c A $.  $d b c B $.  $d c C $.
    $( Triangle inequality for the distance function of a pseudometric.
       (Contributed by Thierry Arnoux, 11-Feb-2018.) $)
    psmettri2 $p |- ( ( D e. ( PsMet ` X ) /\ ( C e. X /\ A e. X /\ B e. X ) )
      -> ( A D B ) <_ ( ( C D A ) +e ( C D B ) ) ) $=
      ( va vb vc wcel cv co cxad cle wbr wral w3a wa wceq r19.21bi oveq1 cpsmet
      cfv 3anass cc0 cxp cxr wf cvv wb elfvex ispsmet syl simprd anasss sylan2b
      ibi ralrimivvva wi 3anrot oveq2 oveq1d breq12d oveq2d breq2d rspc3v sylbi
      oveq12d mpan9 ) DEUAUBIZFJZGJZDKZHJZVJDKZVMVKDKZLKZMNZHEOZGEOZFEOZCEIZAEI
      ZBEIZPZABDKZCADKZCBDKZLKZMNZVIVQFGHEEEVJEIZVKEIZVMEIZPVIWJWKWLQZQVQWJWKWL
      UCVIWJWMVQVIWJQZWKWLVQWNWKQVQHEWNVRGEWNVJVJDKUDRZVSVIWOVSQZFEVIEEUEUFDUGZ
      WPFEOZVIWQWRQZVIEUHIVIWSUIDEUAUJFGHDUHEUKULUPUMSUMSSUNUNUOUQWDWBWCWAPVTWI
      URWAWBWCUSVQWIAVKDKZVMADKZVOLKZMNWEXAVMBDKZLKZMNFGHABCEEEVJARZVLWTVPXBMVJ
      AVKDTXEVNXAVOLVJAVMDUTVAVBVKBRZWTWEXBXDMVKBADUTXFVOXCXALVKBVMDUTVCVBVMCRZ
      XDWHWEMXGXAWFXCWGLVMCADTVMCBDTVGVDVEVFVH $.

    $( The distance function of a pseudometric is symmetrical.  (Contributed by
       Thierry Arnoux, 7-Feb-2018.) $)
    psmetsym $p |- ( ( D e. ( PsMet ` X ) /\ A e. X /\ B e. X )
      -> ( A D B ) = ( B D A ) ) $=
      ( wcel w3a wceq cle wbr cxad psmettri2 syl13anc cc0 psmet0 oveq2d psmetcl
      co cxr xaddid1 syl cpsmet simp1 simp3 simp2 3adant2 eqtrd breqtrd 3adant3
      cfv 3com23 wa wb xrletri3 syl2anc mpbir2and ) CDUAUIEZADEZBDEZFZABCQZBACQ
      ZGZUTVAHIZVAUTHIZUSUTVABBCQZJQZVAHUSUPURUQURUTVFHIUPUQURUBZUPUQURUCZUPUQU
      RUDZVHABBCDKLUSVFVAMJQZVAUSVEMVAJUPURVEMGUQBCDNUEOUPURUQVJVAGZUPURUQFVARE
      ZVKBACDPZVASTUJUFUGUSVAUTAACQZJQZUTHUSUPUQURUQVAVOHIVGVIVHVIBAACDKLUSVOUT
      MJQZUTUSVNMUTJUPUQVNMGURACDNUHOUSUTREZVPUTGABCDPZUTSTUFUGUSVQVLVBVCVDUKUL
      VRUPURUQVLVMUJUTVAUMUNUO $.

    $( Triangle inequality for the distance function of a pseudometric space.
       (Contributed by Thierry Arnoux, 11-Feb-2018.) $)
    psmettri $p |- ( ( D e. ( PsMet ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) +e ( C D B ) ) ) $=
      ( cpsmet cfv wcel w3a wa co cxad cle simpl simpr3 simpr1 simpr2 psmettri2
      wbr syl13anc wceq psmetsym syl3anc oveq1d breqtrd ) DEFGHZAEHZBEHZCEHZIZJ
      ZABDKZCADKZCBDKZLKZACDKZUNLKMUKUFUIUGUHULUOMSUFUJNZUFUGUHUIOZUFUGUHUIPZUF
      UGUHUIQABCDERTUKUMUPUNLUKUFUIUGUMUPUAUQURUSCADEUBUCUDUE $.

    $( The distance function of a pseudometric space is nonnegative.
       (Contributed by Thierry Arnoux, 7-Feb-2018.) $)
    psmetge0 $p |- ( ( D e. ( PsMet ` X ) /\ A e. X /\ B e. X ) ->
      0 <_ ( A D B ) ) $=
      ( cpsmet cfv wcel w3a cc0 co cle wbr cxmu cxad simp1 simp2 wceq cxr a1i
      c2 simp3 psmettri2 syl13anc psmet0 3adant2 cr 2re xmul01 syl6reqr psmetcl
      rexr mp2b x2times syl 3brtr4d crp wb 0xr 2rp xlemul2 syl3anc mpbird ) CDE
      FGZADGZBDGZHZIABCJZKLZTIMJZTVGMJZKLZVFBBCJZVGVGNJZVIVJKVFVCVDVEVEVLVMKLVC
      VDVEOVCVDVEPVCVDVEUAZVNBBACDUBUCVFVLIVIVCVEVLIQVDBCDUDUETUFGTRGVIIQUGTUKT
      UHULUIVFVGRGZVJVMQABCDUJZVGUMUNUOVFIRGZVOTUPGZVHVKUQVQVFURSVPVRVFUSSIVGTU
      TVAVB $.

    $( The distance function of a pseudometric space is a function into the
       nonnegative extended real numbers.  (Contributed by Thierry Arnoux,
       24-Feb-2018.) $)
    psmetxrge0 $p |- ( D e. ( PsMet ` X )
       -> D : ( X X. X ) --> ( 0 [,] +oo ) ) $=
      ( va cpsmet cfv wcel cxp wfn crn cc0 cpnf co wf cxr wa cle adantl syl2anc
      wbr wceq cicc wss psmetf ffn syl wral ffvelrnda c1st c2nd simpl cop elxp6
      cv simprbi psmetge0 3expb 1st2nd2 fveq2d df-ov syl6eqr jca elxrge0 sylibr
      breqtrrd ralrimiva fnfvrnss df-f sylanbrc ) ABDEFZABBGZHZAIJKUALZUBZVJVLA
      MVIVJNAMVKABUCZVJNAUDUEZVIVKCUMZAEZVLFZCVJUFVMVOVIVRCVJVIVPVJFZOZVQNFZJVQ
      PSZOVRVTWAWBVIVJNVPAVNUGVTJVPUHEZVPUIEZALZVQPVTVIWCBFZWDBFZOZJWEPSZVIVSUJ
      VSWHVIVSVPWCWDUKZTWHVPBBULUNQVIWFWGWIWCWDABUOUPRVSVQWETVIVSVQWJAEWEVSVPWJ
      AVPBBUQURWCWDAUSUTQVDVAVQVBVCVECVJVLAVFRVJVLAVGVH $.

    $d a b c R $.
    $( Restriction of a pseudometric.  (Contributed by Thierry Arnoux,
       11-Feb-2018.) $)
    psmetres2 $p |- ( ( D e. ( PsMet ` X ) /\ R C_ X ) ->
                   ( D |` ( R X. R ) ) e. ( PsMet ` R ) ) $=
      ( va vb vc cpsmet wcel wa cxr cv co wceq cxad adantr simpr syl2anc ovresd
      cc0 cvv cfv wss cxp cres wf cle psmetf xpss12 fssres simpll sselda psmet0
      wbr wral ad2antrr psmettri2 syl13anc oveq12d 3brtr4d ralrimiva jca elfvex
      eqtrd wb ssexg ispsmet syl mpbird ) ACGUAHZBCUBZIZABBUCZUDZBGUAHZVLJVMUEZ
      DKZVPVMLZSMZVPEKZVMLZFKZVPVMLZWAVSVMLZNLZUFUMZFBUNZEBUNZIZDBUNZIZVKVOWIVK
      CCUCZJAUEZVLWKUBZVOVIWLVJACUGOVKVJVJWMVIVJPZWNBCBCUHQWKJVLAUIQVKWHDBVKVPB
      HZIZVRWGWPVQVPVPALZSWPVPVPABVKWOPZWRRWPVIVPCHZWQSMVIVJWOUJZVKBCVPWNUKZVPA
      CULQVCWPWFEBWPVSBHZIZWEFBXCWABHZIZVPVSALZWAVPALZWAVSALZNLZVTWDUFXEVIWACHW
      SVSCHZXFXIUFUMXCVIXDWPVIXBWTOOXCBCWAVKVJWOXBWNUOUKXCWSXDWPWSXBXAOOXCXJXDW
      PBCVSVKVJWOWNOUKOVPVSWAACUPUQXCVTXFMXDXCVPVSABWPWOXBWROZWPXBPZROXEWBXGWCX
      HNXEWAVPABXCXDPZXCWOXDXKORXEWAVSABXMXCXBXDXLORURUSUTUTVAUTVAVKBTHZVNWJVDV
      KVJCTHZXNWNVIXOVJACGVBOBCTVEQDEFVMTBVFVGVH $.

    $( Real closure of an extended metric value that is upper bounded by a
       real.  (Contributed by Thierry Arnoux, 11-Mar-2018.) $)
    psmetlecl $p |- ( ( D e. ( PsMet ` X ) /\ ( A e. X /\ B e. X ) /\
      ( C e. RR /\ ( A D B ) <_ C ) ) -> ( A D B ) e. RR ) $=
      ( cpsmet cfv wcel wa cr cle wbr w3a cxr cc0 psmetcl 3expb 3adant3 simp3l
      co psmetge0 simp3r xrrege0 syl22anc ) DEFGHZAEHZBEHZIZCJHZABDTZCKLZIZMUJN
      HZUIOUJKLZUKUJJHUEUHUMULUEUFUGUMABDEPQRUEUHUIUKSUEUHUNULUEUFUGUNABDEUAQRU
      EUHUIUKUBUJCUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Basic metric space properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c *MetSp $.
  $c MetSp $.
  $c toMetSp $.

  $( Extend class notation with the class of all extended metric spaces. $)
  cxme $a class *MetSp $.

  $( Extend class notation with the class of all metric spaces. $)
  cmt $a class MetSp $.

  $( Extend class notation with the function mapping a metric to a metric
     space. $)
  ctmt $a class toMetSp $.

  $( Define the (proper) class of all extended metric spaces.  (Contributed by
     Mario Carneiro, 2-Sep-2015.) $)
  df-xms $a |- *MetSp = { f e. TopSp | ( TopOpen ` f ) =
    ( MetOpen ` ( ( dist ` f ) |` ( ( Base ` f ) X. ( Base ` f ) ) ) ) } $.

  $( Define the (proper) class of all metric spaces.  (Contributed by NM,
     27-Aug-2006.) $)
  df-ms $a |- MetSp = { f e. *MetSp | ( ( dist ` f ) |`
    ( ( Base ` f ) X. ( Base ` f ) ) ) e. ( Met ` ( Base ` f ) ) } $.

  $( Define the function mapping a metric to a metric space.  (Contributed by
     Mario Carneiro, 2-Sep-2015.) $)
  df-tms $a |- toMetSp = ( d e. U. ran *Met |->
      ( { <. ( Base ` ndx ) , dom dom d >. , <. ( dist ` ndx ) , d >. }
        sSet <. ( TopSet ` ndx ) , ( MetOpen ` d ) >. ) ) $.

  ${
    $d d x y z D $.  $d d t x y z X $.
    $( Express the predicate " ` D ` is a metric."  (Contributed by NM,
       25-Aug-2006.)  (Revised by Mario Carneiro, 14-Aug-2015.) $)
    ismet $p |- ( X e. A -> ( D e. ( Met ` X ) <-> ( D : ( X X. X ) --> RR /\
                 A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                 A. z e. X ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) ) ) ) $=
      ( vd vt wcel cr cmap co cv cc0 wceq wb caddc wral wa cvv cme cfv cxp crab
      cle wf elex xpeq12 anidms oveq2d raleq anbi2d raleqbi1dv rabeqbidv df-met
      wbr ovex rabex fvmpt eleq2d eqeq1d bibi1d oveq12d breq12d ralbidv anbi12d
      syl oveq 2ralbidv elrab syl6bb reex xpexg elmapg sylancr anbi1d bitrd ) F
      DIZEFUAUBZIZEJFFUCZKLZIZAMZBMZELZNOZWDWEOZPZWFCMZWDELZWJWEELZQLZUEUPZCFRZ
      SZBFRAFRZSZWAJEUFZWQSVRVTEWDWEGMZLZNOZWHPZXAWJWDWTLZWJWEWTLZQLZUEUPZCFRZS
      ZBFRZAFRZGWBUDZIWRVRVSXLEVRFTIVSXLOFDUGHFXCXGCHMZRZSZBXMRZAXMRZGJXMXMUCZK
      LZUDXLTUAXMFOZXQXKGXSWBXTXRWAJKXTXRWAOXMFXMFUHUIUJXPXJAXMFXOXIBXMFXTXNXHX
      CXGCXMFUKULUMUMUNHABCGUOXKGWBJWAKUQURUSVGUTXKWQGEWBWTEOZXIWPABFFYAXCWIXHW
      OYAXBWGWHYAXAWFNWDWEWTEVHZVAVBYAXGWNCFYAXAWFXFWMUEYBYAXDWKXEWLQWJWDWTEVHW
      JWEWTEVHVCVDVEVFVIVJVKVRWCWSWQVRJTIWATIZWCWSPVLVRYCFFDDVMUIJWAETTVNVOVPVQ
      $.

    $( Express the predicate " ` D ` is an extended metric."  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    isxmet $p |- ( X e. A -> ( D e. ( *Met ` X ) <->
               ( D : ( X X. X ) --> RR* /\
                 A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                 A. z e. X ( x D y ) <_ ( ( z D x ) +e ( z D y ) ) ) ) ) ) $=
      ( vd vt wcel cxr cmap co cv cc0 wceq wb cxad wral wa cvv cxmt cfv cxp cle
      wbr wf crab elex xpeq12 anidms oveq2d anbi2d raleqbi1dv rabeqbidv df-xmet
      raleq ovex rabex fvmpt eleq2d oveq eqeq1d oveq12d breq12d ralbidv anbi12d
      syl bibi1d 2ralbidv elrab syl6bb xrex xpexg elmapg sylancr anbi1d bitrd )
      FDIZEFUAUBZIZEJFFUCZKLZIZAMZBMZELZNOZWDWEOZPZWFCMZWDELZWJWEELZQLZUDUEZCFR
      ZSZBFRAFRZSZWAJEUFZWQSVRVTEWDWEGMZLZNOZWHPZXAWJWDWTLZWJWEWTLZQLZUDUEZCFRZ
      SZBFRZAFRZGWBUGZIWRVRVSXLEVRFTIVSXLOFDUHHFXCXGCHMZRZSZBXMRZAXMRZGJXMXMUCZ
      KLZUGXLTUAXMFOZXQXKGXSWBXTXRWAJKXTXRWAOXMFXMFUIUJUKXPXJAXMFXOXIBXMFXTXNXH
      XCXGCXMFUPULUMUMUNHABCGUOXKGWBJWAKUQURUSVGUTXKWQGEWBWTEOZXIWPABFFYAXCWIXH
      WOYAXBWGWHYAXAWFNWDWEWTEVAZVBVHYAXGWNCFYAXAWFXFWMUDYBYAXDWKXEWLQWJWDWTEVA
      WJWEWTEVAVCVDVEVFVIVJVKVRWCWSWQVRJTIWATIZWCWSPVLVRYCFFDDVMUJJWAETTVNVOVPV
      Q $.
  $}

  ${
    $d x y z D $.  $d x y z X $.
    ismeti.0 $e |- X e. _V $.
    ismeti.1 $e |- D : ( X X. X ) --> RR $.
    ismeti.2 $e |- ( ( x e. X /\ y e. X ) -> ( ( x D y ) = 0 <-> x = y ) ) $.
    ismeti.3 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                  ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) $.
    $( Properties that determine a metric.  (Contributed by NM, 17-Nov-2006.)
       (Revised by Mario Carneiro, 14-Aug-2015.) $)
    ismeti $p |- D e. ( Met ` X ) $=
      ( cme cfv wcel cxp cv co wceq wb wral wa cvv cr cc0 caddc 3expa ralrimiva
      wf cle wbr jca rgen2a ismet ax-mp mpbir2an ) DEJKLZEEMUADUFZANZBNZDOZUBPU
      PUQPQZURCNZUPDOUTUQDOUCOUGUHZCERZSZBERAERZGVCABEUPELZUQELZSZUSVBHVGVACEVE
      VFUTELVAIUDUEUIUJETLUNUOVDSQFABCTDEUKULUM $.
  $}

  ${
    $d x y z D $.  $d x y z ph $.  $d x y z X $.
    isxmetd.0 $e |- ( ph -> X e. _V ) $.
    isxmetd.1 $e |- ( ph -> D : ( X X. X ) --> RR* ) $.
    ${
      isxmetd.2 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
        ( ( x D y ) = 0 <-> x = y ) ) $.
      isxmetd.3 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) ) ->
                    ( x D y ) <_ ( ( z D x ) +e ( z D y ) ) ) $.
      $( Properties that determine an extended metric.  (Contributed by Mario
         Carneiro, 20-Aug-2015.) $)
      isxmetd $p |- ( ph -> D e. ( *Met ` X ) ) $=
        ( cxmt cfv wcel cv co wceq wb wral wa cvv cxp cxr wf cc0 cxad cle 3exp2
        wbr wi imp32 ralrimiv jca ralrimivva isxmet syl mpbir2and ) AEFKLMZFFUA
        UBEUCZBNZCNZEOZUDPUSUTPQZVADNZUSEOVCUTEOUEOUFUHZDFRZSZCFRBFRZHAVFBCFFAU
        SFMZUTFMZSSZVBVEIVJVDDFAVHVIVCFMZVDUIAVHVIVKVDJUGUJUKULUMAFTMUQURVGSQGB
        CDTEFUNUOUP $.
    $}

    ${
      isxmet2d.2 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) -> 0 <_ ( x D y ) ) $.
      isxmet2d.3 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
        ( ( x D y ) <_ 0 <-> x = y ) ) $.
      isxmet2d.4 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) /\
        ( ( z D x ) e. RR /\ ( z D y ) e. RR ) ) ->
          ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) $.
      $( It is safe to only require the triangle inequality when the values are
         real (so that we can use the standard addition over the reals), but in
         this case the nonnegativity constraint cannot be deduced and must be
         provided separately.  (Counterexample:
         ` D ( x , y ) = if ( x = y , 0 , -oo ) ` satisfies all hypotheses
         except nonnegativity.)  (Contributed by Mario Carneiro,
         20-Aug-2015.) $)
      isxmet2d $p |- ( ph -> D e. ( *Met ` X ) ) $=
        ( wcel wa co cc0 wceq cle wbr cxr cpnf cv fovrnda 0xr xrletri3 biantrud
        wb sylancl 3bitr2d w3a cr cmnf w3o cxad cicc cxp wf wfn ffn syl elxrge0
        wral sylanbrc ralrimivva ffnov adantr simpr3 simpr1 fovrnd simplbi elxr
        sylib simpr2 caddc 3expa rexadd adantl breqtrrd 3adantr3 pnfge ad2antrr
        anassrs oveq2 wne renemnf xaddpnf1 syl2an sylan9eqr wi simprbi ge0nemnf
        wn syl2anc a1d necon4bd imp 3jaodan mpdan oveq1 xaddpnf2 isxmetd ) ABCD
        EFGHABUAZFLZCUAZFLZMMZXAXCENZOPZXFOQRZOXFQRZMZXHXAXCPXEXFSLZOSLXGXJUFAX
        AXCSFFEHUBZUCXFOUDUGXEXIXHIUEJUHAXBXDDUAZFLZUIZMZXMXAENZUJLZXQTPZXQUKPZ
        ULZXFXQXMXCENZUMNZQRZXPXQSLZYAXPXQOTUNNZLZYEXPXMXAYFFFEAFFUOZYFEUPZXOAE
        YHUQZXFYFLZCFVABFVAYIAYHSEUPYJHYHSEURUSAYKBCFFXEXKXIYKXLIXFUTVBVCBCFFYF
        EVDVBVEZAXBXDXNVFZAXBXDXNVGVHZYGYEOXQQRZXQUTZVIUSZXQVJVKXPXRYDXSXTXPXRM
        ZYBUJLZYBTPZYBUKPZULZYDYRYBSLZUUBXPUUCXRXPYBYFLZUUCXPXMXCYFFFEYLYMAXBXD
        XNVLVHZUUDUUCOYBQRZYBUTZVIUSZVEYBVJVKYRYSYDYTUUAXPXRYSYDXPXRYSMZMXFXQYB
        VMNZYCQAXOUUIXFUUJQRKVNUUIYCUUJPXPXQYBVOVPVQWAYRYTMXFTYCQXPXFTQRZXRYTXP
        XKUUKAXBXDXKXNXLVRXFVSUSZVTYTYRYCXQTUMNZTYBTXQUMWBXPYEXQUKWCZUUMTPXRYQX
        QWDXQWEWFWGVQYRUUAYDXPUUAYDWHXRXPYDYBUKXPYBUKWCZYDWKZXPUUCUUFUUOUUHXPUU
        DUUFUUEUUDUUCUUFUUGWIUSYBWJWLZWMWNVEWOWPWQXPXSMXFTYCQXPUUKXSUULVEXSXPYC
        TYBUMNZTXQTYBUMWRXPUUCUUOUURTPUUHUUQYBWSWLWGVQXPXTYDXPYDXQUKXPUUNUUPXPY
        EYOUUNYQXPYGYOYNYGYEYOYPWIUSXQWJWLWMWNWOWPWQWT $.
    $}
  $}

  ${
    $d x y z A $.  $d y z B $.  $d d w x y z D $.  $d x y z R $.  $d x y z X $.
    $d z C $.
    $( Lemma for ~ metf and others.  (Contributed by NM, 30-Aug-2006.)
       (Revised by Mario Carneiro, 14-Aug-2015.) $)
    metflem $p |- ( D e. ( Met ` X ) -> ( D : ( X X. X ) --> RR /\
                  A. x e. X A. y e. X ( ( ( x D y ) = 0 <-> x = y ) /\
                  A. z e. X ( x D y ) <_ ( ( z D x ) + ( z D y ) ) ) ) ) $=
      ( cme cfv wcel cxp cr wf cv co cc0 wceq wb caddc cle wral wa elfvdm ismet
      wbr cdm syl ibi ) DEFGHZEEIJDKALZBLZDMZNOUHUIOPUJCLZUHDMUKUIDMQMRUCCESTBE
      SAESTZUGEFUDZHUGULPDEFUAABCUMDEUBUEUF $.

    $( Mapping of the distance function of an extended metric.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    xmetf $p |- ( D e. ( *Met ` X ) -> D : ( X X. X ) --> RR* ) $=
      ( vx vy vz cxmt cfv wcel cxp cxr wf cv co cc0 wceq wb cxad cle wral wa
      wbr cdm elfvdm isxmet syl ibi simpld ) ABFGHZBBIJAKZCLZDLZAMZNOUJUKOPULEL
      ZUJAMUMUKAMQMRUAEBSTDBSCBSZUHUIUNTZUHBFUBZHUHUOPABFUCCDEUPABUDUEUFUG $.

    $( Mapping of the distance function of a metric space.  (Contributed by NM,
       30-Aug-2006.) $)
    metf $p |- ( D e. ( Met ` X ) -> D : ( X X. X ) --> RR ) $=
      ( vx vy vz cme cfv wcel cxp cr wf cv co cc0 wceq wb caddc cle wbr wral wa
      metflem simpld ) ABFGHBBIJAKCLZDLZAMZNOUDUEOPUFELZUDAMUGUEAMQMRSEBTUADBTC
      BTCDEABUBUC $.

    $( Closure of the distance function of a metric space.  Part of Property M1
       of [Kreyszig] p. 3.  (Contributed by NM, 30-Aug-2006.) $)
    xmetcl $p |- ( ( D e. ( *Met ` X ) /\ A e. X /\ B e. X ) ->
        ( A D B ) e. RR* ) $=
      ( cxmt cfv wcel cxp cxr wf co xmetf fovrn syl3an1 ) CDEFGDDHICJADGBDGABCK
      IGCDLABIDDCMN $.

    $( Closure of the distance function of a metric space.  Part of Property M1
       of [Kreyszig] p. 3.  (Contributed by NM, 30-Aug-2006.) $)
    metcl $p |- ( ( D e. ( Met ` X ) /\ A e. X /\ B e. X ) ->
        ( A D B ) e. RR ) $=
      ( cme cfv wcel cxp cr wf co metf fovrn syl3an1 ) CDEFGDDHICJADGBDGABCKIGC
      DLABIDDCMN $.

    $( An extended metric is a metric exactly when it takes real values for all
       values of the arguments.  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    ismet2 $p |- ( D e. ( Met ` X ) <->
        ( D e. ( *Met ` X ) /\ D : ( X X. X ) --> RR ) ) $=
      ( vx vy vz cme cfv wcel cvv cxmt cr wf wa elfvex cv co wceq cle wral cxr
      cxp adantr cc0 caddc wbr cxad simpllr simpr simplrl fovrnd simplrr rexadd
      syl2anc breq2d ralbidva anbi2d 2ralbidva wss ressxr fss sylancl biantrurd
      wb bitr3d pm5.32da ancom syl6bb ismet isxmet anbi1d 3bitr4d pm5.21nii ) A
      BFGHZBIHZABJGHZBBUAZKALZMZABFNVOVNVQABJNUBVNVQCOZDOZAPZUCQVSVTQVCZWAEOZVS
      APZWCVTAPZUDPZRUEZEBSZMZDBSCBSZMZVPTALZWBWAWDWEUFPZRUEZEBSZMZDBSCBSZMZVQM
      ZVMVRVNWKVQWRMWSVNVQWJWRVNVQMZWQWJWRWTWPWICDBBWTVSBHZVTBHZMZMZWOWHWBXDWNW
      GEBXDWCBHZMZWMWFWARXFWDKHWEKHWMWFQXFWCVSKBBAVNVQXCXEUGZXDXEUHZWTXAXBXEUIU
      JXFWCVTKBBAXGXHWTXAXBXEUKUJWDWEULUMUNUOUPUQWTWLWQWTVQKTURWLVNVQUHUSVPKTAU
      TVAVBVDVEVQWRVFVGCDEIABVHVNVOWRVQCDEIABVIVJVKVL $.

    $( A metric is an extended metric.  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    metxmet $p |- ( D e. ( Met ` X ) -> D e. ( *Met ` X ) ) $=
      ( cme cfv wcel cxmt cxp cr wf ismet2 simplbi ) ABCDEABFDEBBGHAIABJK $.

    $( Recover the base set from an extended metric.  (Contributed by Mario
       Carneiro, 23-Aug-2015.) $)
    xmetdmdm $p |- ( D e. ( *Met ` X ) -> X = dom dom D ) $=
      ( cxmt cfv wcel cdm cxp cxr wf wceq xmetf fdm syl dmeqd dmxpid syl6req )
      ABCDEZAFZFBBGZFBQRSQSHAIRSJABKSHALMNBOP $.

    $( Recover the base set from a metric.  (Contributed by Mario Carneiro,
       23-Aug-2015.) $)
    metdmdm $p |- ( D e. ( Met ` X ) -> X = dom dom D ) $=
      ( cme cfv wcel cxmt cdm wceq metxmet xmetdmdm syl ) ABCDEABFDEBAGGHABIABJ
      K $.

    $( Two ways to express an extended metric on an unspecified base.
       (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    xmetunirn $p |- ( D e. U. ran *Met <-> D e. ( *Met ` dom dom D ) ) $=
      ( vx vy vz vd vw cxmt crn cuni wcel cdm cfv cv cvv wb wceq wral cxr cmap
      co wrex wfn cc0 cxad cle wbr wa cxp crab ovex rabex df-xmet fnunirn ax-mp
      fnmpti id xmetdmdm fveq2d eleqtrd rexlimivw sylbi fvssunirn sseli impbii
      ) AGHIZJZAAKKZGLZJZVFABMZGLZJZBNUAZVIGNUBVFVMOBNCMZDMZEMZTZUCPVNVOPOVQFMZ
      VNVPTVRVOVPTUDTUEUFFVJQUGDVJQCVJQZERVJVJUHZSTZUIGVSEWARVTSUJUKBCDFEULUOBA
      GNUMUNVLVIBNVLAVKVHVLUPVLVJVGGAVJUQURUSUTVAVHVEAGVGVBVCVD $.

    $( The value of an extended metric is zero iff its arguments are equal.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmeteq0 $p |- ( ( D e. ( *Met ` X ) /\ A e. X /\ B e. X )
                 -> ( ( A D B ) = 0 <-> A = B ) ) $=
      ( vx vy vz cxmt wcel co cc0 wceq wb cv wral wa syl ralimi eqeq1d bibi12d
      cfv cxad cle wbr cxp cxr wf cdm elfvdm isxmet ibi simpl oveq1 eqeq1 oveq2
      simprd eqeq2 rspc2v syl5com 3impib ) CDHUAIZADIZBDIZABCJZKLZABLZMZVAENZFN
      ZCJZKLZVHVILZMZFDOZEDOZVBVCPVGVAVMVJGNZVHCJVPVICJUBJUCUDGDOZPZFDOZEDOZVOV
      ADDUEUFCUGZVTVAWAVTPZVADHUHZIVAWBMCDHUIEFGWCCDUJQUKUPVSVNEDVRVMFDVMVQULRR
      QVMVGAVICJZKLZAVILZMEFABDDVHALZVKWEVLWFWGVJWDKVHAVICUMSVHAVIUNTVIBLZWEVEW
      FVFWHWDVDKVIBACUOSVIBAUQTURUSUT $.

    $( The value of a metric is zero iff its arguments are equal.  Property M2
       of [Kreyszig] p. 4.  (Contributed by NM, 30-Aug-2006.) $)
    meteq0 $p |- ( ( D e. ( Met ` X ) /\ A e. X /\ B e. X )
                 -> ( ( A D B ) = 0 <-> A = B ) ) $=
      ( cme cfv wcel cxmt co cc0 wceq wb metxmet xmeteq0 syl3an1 ) CDEFGCDHFGAD
      GBDGABCIJKABKLCDMABCDNO $.

    $( Triangle inequality for the distance function of an extended metric.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmettri2 $p |- ( ( D e. ( *Met ` X ) /\ ( C e. X /\ A e. X /\ B e. X ) )
                 -> ( A D B ) <_ ( ( C D A ) +e ( C D B ) ) ) $=
      ( vx vy vz wcel w3a cxmt co cxad cle wbr cv wral wceq oveq1 oveq2 cfv cc0
      wi wb wa cxp cxr wf cdm elfvdm isxmet syl ibi simprd simpr ralimi breq12d
      oveq1d oveq2d oveq12d breq2d rspc3v syl5 3comr impcom ) CEIZAEIZBEIZJDEKU
      AIZABDLZCADLZCBDLZMLZNOZVGVHVFVIVNUCVIFPZGPZDLZHPZVODLZVRVPDLZMLZNOZHEQZG
      EQZFEQZVGVHVFJVNVIVQUBRVOVPRUDZWCUEZGEQZFEQZWEVIEEUFUGDUHZWIVIWJWIUEZVIEK
      UIZIVIWKUDDEKUJFGHWLDEUKULUMUNWHWDFEWGWCGEWFWCUOUPUPULWBVNAVPDLZVRADLZVTM
      LZNOVJWNVRBDLZMLZNOFGHABCEEEVOARZVQWMWAWONVOAVPDSWRVSWNVTMVOAVRDTURUQVPBR
      ZWMVJWOWQNVPBADTWSVTWPWNMVPBVRDTUSUQVRCRZWQVMVJNWTWNVKWPVLMVRCADSVRCBDSUT
      VAVBVCVDVE $.

    $( Triangle inequality for the distance function of a metric space.
       (Contributed by NM, 30-Aug-2006.)  (Revised by Mario Carneiro,
       20-Aug-2015.) $)
    mettri2 $p |- ( ( D e. ( Met ` X ) /\ ( C e. X /\ A e. X /\ B e. X ) )
                 -> ( A D B ) <_ ( ( C D A ) + ( C D B ) ) ) $=
      ( cme cfv wcel w3a wa co cxad caddc cle cxmt wbr metxmet xmettri2 metcl
      cr sylan wceq 3adant3r3 3adant3r2 rexadd syl2anc breqtrd ) DEFGHZCEHZAEHZ
      BEHZIZJZABDKZCADKZCBDKZLKZUOUPMKZNUHDEOGHULUNUQNPDEQABCDERUAUMUOTHZUPTHZU
      QURUBUHUIUJUSUKCADESUCUHUIUKUTUJCBDESUDUOUPUEUFUG $.

    $( The distance function of a metric space is zero if its arguments are
       equal.  Definition 14-1.1(a) of [Gleason] p. 223.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xmet0 $p |- ( ( D e. ( *Met ` X ) /\ A e. X ) -> ( A D A ) = 0 ) $=
      ( cxmt cfv wcel wa co cc0 wceq eqid wb xmeteq0 3anidm23 mpbiri ) BCDEFZAC
      FZGAABHIJZAAJZAKPQRSLAABCMNO $.

    $( The distance function of a metric space is zero if its arguments are
       equal.  Definition 14-1.1(a) of [Gleason] p. 223.  (Contributed by NM,
       30-Aug-2006.) $)
    met0 $p |- ( ( D e. ( Met ` X ) /\ A e. X ) -> ( A D A ) = 0 ) $=
      ( cme cfv wcel cxmt co cc0 wceq metxmet xmet0 sylan ) BCDEFBCGEFACFAABHIJ
      BCKABCLM $.

    $( The distance function of a metric space is nonnegative.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    xmetge0 $p |- ( ( D e. ( *Met ` X ) /\ A e. X /\ B e. X ) ->
                  0 <_ ( A D B ) ) $=
      ( cxmt cfv wcel w3a cc0 co cle wbr c2 cxmu cxad simp1 simp2 wceq cxr a1i
      simp3 xmettri2 syl13anc xmet0 3adant2 cr rexr xmul01 mp2b syl6reqr xmetcl
      2re x2times syl 3brtr4d crp wb 0xr 2rp xlemul2 syl3anc mpbird ) CDEFGZADG
      ZBDGZHZIABCJZKLZMINJZMVGNJZKLZVFBBCJZVGVGOJZVIVJKVFVCVDVEVEVLVMKLVCVDVEPV
      CVDVEQVCVDVEUAZVNBBACDUBUCVFVLIVIVCVEVLIRVDBCDUDUEMUFGMSGVIIRULMUGMUHUIUJ
      VFVGSGZVJVMRABCDUKZVGUMUNUOVFISGZVOMUPGZVHVKUQVQVFURTVPVRVFUSTIVGMUTVAVB
      $.

    $( The distance function of a metric space is nonnegative.  (Contributed by
       NM, 27-Aug-2006.)  (Revised by Mario Carneiro, 14-Aug-2015.) $)
    metge0 $p |- ( ( D e. ( Met ` X ) /\ A e. X /\ B e. X ) ->
                  0 <_ ( A D B ) ) $=
      ( cme cfv wcel cxmt cc0 co cle wbr metxmet xmetge0 syl3an1 ) CDEFGCDHFGAD
      GBDGIABCJKLCDMABCDNO $.

    $( Real closure of an extended metric value that is upper bounded by a
       real.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmetlecl $p |- ( ( D e. ( *Met ` X ) /\ ( A e. X /\ B e. X ) /\
      ( C e. RR /\ ( A D B ) <_ C ) ) -> ( A D B ) e. RR ) $=
      ( cxmt cfv wcel wa cr co cle wbr w3a cxr cc0 xmetcl 3expb 3adant3 simp3l
      xmetge0 simp3r xrrege0 syl22anc ) DEFGHZAEHZBEHZIZCJHZABDKZCLMZIZNUJOHZUI
      PUJLMZUKUJJHUEUHUMULUEUFUGUMABDEQRSUEUHUIUKTUEUHUNULUEUFUGUNABDEUARSUEUHU
      IUKUBUJCUCUD $.

    $( The distance function of an extended metric space is symmetric.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmetsym $p |- ( ( D e. ( *Met ` X ) /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( B D A ) ) $=
      ( wcel w3a co wceq cle wbr cxad xmettri2 syl13anc cc0 xmet0 oveq2d xmetcl
      cxr xaddid1 syl cxmt cfv simp1 simp3 simp2 3adant2 3com23 breqtrd 3adant3
      eqtrd wa wb xrletri3 syl2anc mpbir2and ) CDUAUBEZADEZBDEZFZABCGZBACGZHZUT
      VAIJZVAUTIJZUSUTVABBCGZKGZVAIUSUPURUQURUTVFIJUPUQURUCZUPUQURUDZUPUQURUEZV
      HABBCDLMUSVFVANKGZVAUSVENVAKUPURVENHUQBCDOUFPUPURUQVJVAHZUPURUQFVAREZVKBA
      CDQZVASTUGUJUHUSVAUTAACGZKGZUTIUSUPUQURUQVAVOIJVGVIVHVIBAACDLMUSVOUTNKGZU
      TUSVNNUTKUPUQVNNHURACDOUIPUSUTREZVPUTHABCDQZUTSTUJUHUSVQVLVBVCVDUKULVRUPU
      RUQVLVMUGUTVAUMUNUO $.

    $( An extended metric is a pseudometric.  (Contributed by Thierry Arnoux,
       7-Feb-2018.) $)
    xmetpsmet $p |- ( D e. ( *Met ` X ) -> D e. ( PsMet ` X ) ) $=
      ( vx vy vz cxmt cfv wcel cpsmet cxp cxr wf cv co wa w3a ralrimiva jca cvv
      wral cc0 wceq cxad cle wbr xmetf 3anrot xmettri2 sylan2br 3anassrs elfvex
      xmet0 wb ispsmet syl mpbird ) ABFGHZABIGHZBBJKALZCMZUTANUAUBZUTDMZANEMZUT
      ANVCVBANUCNUDUEZEBTZDBTZOZCBTZOZUQUSVHABUFUQVGCBUQUTBHZOZVAVFUTABULVKVEDB
      VKVBBHZOVDEBUQVJVLVCBHZVDVJVLVMPUQVMVJVLPVDVMVJVLUGUTVBVCABUHUIUJQQRQRUQB
      SHURVIUMABFUKCDEASBUNUOUP $.

    $( The distance function of an extended metric space is symmetric.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmettpos $p |- ( D e. ( *Met ` X ) -> tpos D = D ) $=
      ( vx vy cxmt cfv wcel ctpos wceq cv wral xmetsym 3expb ralrimivva cxp cxr
      co wf wfn wb xmetf ffn tpossym 3syl mpbird ) ABEFGZAHAIZCJZDJZAQUIUHAQIZD
      BKCBKZUFUJCDBBUFUHBGUIBGUJUHUIABLMNUFBBOZPARAULSUGUKTABUAULPAUBCDBAUCUDUE
      $.

    $( The distance function of a metric space is symmetric.  Definition
       14-1.1(c) of [Gleason] p. 223.  (Contributed by NM, 27-Aug-2006.)
       (Revised by Mario Carneiro, 20-Aug-2015.) $)
    metsym $p |- ( ( D e. ( Met ` X ) /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( B D A ) ) $=
      ( cme cfv wcel cxmt co wceq metxmet xmetsym syl3an1 ) CDEFGCDHFGADGBDGABC
      IBACIJCDKABCDLM $.

    $( Triangle inequality for the distance function of a metric space.
       Definition 14-1.1(d) of [Gleason] p. 223.  (Contributed by Mario
       Carneiro, 20-Aug-2015.) $)
    xmettri $p |- ( ( D e. ( *Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) +e ( C D B ) ) ) $=
      ( cxmt cfv wcel w3a wa cxad cle wbr simpl simpr3 simpr1 xmettri2 syl13anc
      co simpr2 wceq xmetsym syl3anc oveq1d breqtrd ) DEFGHZAEHZBEHZCEHZIZJZABD
      SZCADSZCBDSZKSZACDSZUNKSLUKUFUIUGUHULUOLMUFUJNZUFUGUHUIOZUFUGUHUIPZUFUGUH
      UITABCDEQRUKUMUPUNKUKUFUIUGUMUPUAUQURUSCADEUBUCUDUE $.

    $( Triangle inequality for the distance function of a metric space.
       Definition 14-1.1(d) of [Gleason] p. 223.  (Contributed by NM,
       27-Aug-2006.) $)
    mettri $p |- ( ( D e. ( Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) + ( C D B ) ) ) $=
      ( cme cfv wcel w3a wa co caddc cle wbr mettri2 expcom 3coml impcom wceq
      wi metsym 3adant3r2 oveq1d breqtrrd ) DEFGHZAEHZBEHZCEHZIZJZABDKZCADKZCBD
      KZLKZACDKZUMLKMUIUEUKUNMNZUHUFUGUEUPTUEUHUFUGIUPABCDEOPQRUJUOULUMLUEUFUHU
      OULSUGACDEUAUBUCUD $.

    $( Triangle inequality for the distance function of an extended metric.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmettri3 $p |- ( ( D e. ( *Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) )
                 -> ( A D B ) <_ ( ( A D C ) +e ( B D C ) ) ) $=
      ( cxmt cfv wcel w3a wa co cxad cle xmettri wceq 3adant3r1 oveq2d breqtrrd
      xmetsym ) DEFGHZAEHZBEHZCEHZIJZABDKACDKZCBDKZLKUEBCDKZLKMABCDENUDUGUFUELT
      UBUCUGUFOUABCDESPQR $.

    $( Triangle inequality for the distance function of a metric space.
       (Contributed by NM, 13-Mar-2007.) $)
    mettri3 $p |- ( ( D e. ( Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) + ( B D C ) ) ) $=
      ( cme cfv wcel w3a wa co cle mettri wceq metsym 3adant3r1 oveq2d breqtrrd
      caddc ) DEFGHZAEHZBEHZCEHZIJZABDKACDKZCBDKZSKUEBCDKZSKLABCDEMUDUGUFUESTUB
      UCUGUFNUABCDEOPQR $.

    $( One half of the reverse triangle inequality for the distance function of
       an extended metric.  (Contributed by Mario Carneiro, 4-Sep-2015.) $)
    xmetrtri $p |- ( ( D e. ( *Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                    ( ( A D C ) +e -e ( B D C ) ) <_ ( A D B ) ) $=
      ( cxmt cfv wcel w3a co cxad cle wbr cxr cc0 3adant3r2 3adant3r1 3adant3r3
      xmetcl xmetge0 wa cxne 3ancomb xmettri sylan2b cmnf wb ge0nemnf xlesubadd
      wne syl2anc syl33anc mpbird ) DEFGHZAEHZBEHZCEHZIZUAZACDJZBCDJZUBKJABDJZL
      MZUTVBVAKJLMZURUNUOUQUPIVDUOUPUQUCACBDEUDUEUSUTNHZVANHZVBNHZOUTLMZVAUFUJZ
      OVBLMZVCVDUGUNUOUQVEUPACDESPUNUPUQVFUOBCDESQZUNUOUPVGUQABDESRUNUOUQVHUPAC
      DETPUSVFOVALMZVIVKUNUPUQVLUOBCDETQVAUHUKUNUOUPVJUQABDETRUTVAVBUIULUM $.

    ${
      xmetrtri2.1 $e |- K = ( dist ` RR*s ) $.
      $( The reverse triangle inequality for the distance function of an
         extended metric.  In order to express the "extended absolute value
         function", we use the distance function ~ xrsdsval defined on the
         extended real structure.  (Contributed by Mario Carneiro,
         4-Sep-2015.) $)
      xmetrtri2 $p |- ( ( D e. ( *Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) )
         -> ( ( A D C ) K ( B D C ) ) <_ ( A D B ) ) $=
        ( wcel w3a co cle wbr cxne cxad cxr wceq xmetcl syl2anc xmetrtri breq1
        cxmt cfv 3adant3r2 3adant3r1 xrsdsval 3ancoma sylan2b xmetsym 3adant3r3
        wa cif breqtrrd ifboth eqbrtrd ) DFUAUBHZAFHZBFHZCFHZIZUJZACDJZBCDJZEJZ
        VAVBKLZVBVAMNJZVAVBMNJZUKZABDJZKUTVAOHZVBOHZVCVGPUOUPURVIUQACDFQUCUOUQU
        RVJUPBCDFQUDVAVBEGUERUTVEVHKLZVFVHKLZVGVHKLZUTVEBADJZVHKUSUOUQUPURIVEVN
        KLUPUQURUFBACDFSUGUOUPUQVHVNPURABDFUHUIULABCDFSVDVKVLVMVEVFVEVGVHKTVFVG
        VHKTUMRUN $.
    $}

    $( Reverse triangle inequality for the distance function of a metric
       space.  (Contributed by Mario Carneiro, 5-May-2014.) $)
    metrtri $p |- ( ( D e. ( Met ` X ) /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                    ( abs ` ( ( A D C ) - ( B D C ) ) ) <_ ( A D B ) ) $=
      ( cme cfv wcel w3a wa co cxrs cds cmin cabs cle cr wceq metcl 3adant3r2
      3adant3r1 eqid xrsdsreval syl2anc cxmt metxmet xmetrtri2 sylan eqbrtrrd
      wbr ) DEFGHZAEHZBEHZCEHZIZJZACDKZBCDKZLMGZKZUQURNKOGZABDKZPUPUQQHZURQHZUT
      VARUKULUNVCUMACDESTUKUMUNVDULBCDESUAUQURUSUSUBZUCUDUKDEUEGHUOUTVBPUJDEUFA
      BCDUSEVEUGUHUI $.

    $( The distance function of an extended metric space is positive for
       unequal points.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    xmetgt0 $p |- ( ( D e. ( *Met ` X ) /\ A e. X /\ B e. X ) ->
                ( A =/= B <-> 0 < ( A D B ) ) ) $=
      ( cxmt cfv wcel w3a cc0 co clt wbr cle wceq wn wa cxr wb 0xr sylancl
      xmetge0 biantrud xmetcl xrletri3 xrlenlt xmeteq0 3bitr3d necon1abid
      bitr4d ) CDEFGADGBDGHZIABCJZKLZABUJUKIMLZUKINZULOZABNUJUMUMIUKMLZPZUNUJUP
      UMABCDUAUBUJUKQGZIQGZUNUQRABCDUCZSUKIUDTUIUJURUSUMUORUTSUKIUETABCDUFUGUH
      $.

    $( The distance function of a metric space is positive for unequal points.
       Definition 14-1.1(b) of [Gleason] p. 223 and its converse.  (Contributed
       by NM, 27-Aug-2006.) $)
    metgt0 $p |- ( ( D e. ( Met ` X ) /\ A e. X /\ B e. X ) ->
                ( A =/= B <-> 0 < ( A D B ) ) ) $=
      ( cme cfv wcel cxmt wne cc0 co clt wbr wb metxmet xmetgt0 syl3an1 ) CDEFG
      CDHFGADGBDGABIJABCKLMNCDOABCDPQ $.

    $( A metric space is nonempty iff its base set is nonempty.  (Contributed
       by NM, 4-Oct-2007.)  (Revised by Mario Carneiro, 14-Aug-2015.) $)
    metn0 $p |- ( D e. ( Met ` X ) -> ( D =/= (/) <-> X =/= (/) ) ) $=
      ( cme cfv wcel c0 wceq cxp cdm cr wf wrel wb metf frel reldm0 3syl eqeq1d
      fdm syl bitrd wo xpeq0 oridm bitri syl6bb necon3bid ) ABCDEZAFBFUHAFGZBBH
      ZFGZBFGZUHUIAIZFGZUKUHUJJAKZALUIUNMABNZUJJAOAPQUHUMUJFUHUOUMUJGUPUJJASTRU
      AUKULULUBULBBUCULUDUEUFUG $.

    $( Restriction of an extended metric.  (Contributed by Mario Carneiro,
       20-Aug-2015.) $)
    xmetres2 $p |- ( ( D e. ( *Met ` X ) /\ R C_ X ) ->
                   ( D |` ( R X. R ) ) e. ( *Met ` R ) ) $=
      ( vx vy vz cxmt wcel wss wa cxp adantr cxr cv co cc0 wceq sseldd 3adantr3
      cxad cfv cres cdm elfvdm simpr ssexd wf xmetf xpss12 syl2anc fssres ovres
      adantl eqeq1d wb simpll simplr simprl simprr xmeteq0 syl3anc bitrd simpr3
      w3a cle xmettri2 syl13anc simpr1 ovresd simpr2 oveq12d 3brtr4d isxmetd
      wbr ) ACGUAHZBCIZJZDEFABBKZUBZBVQBCGUCZVOCVTHVPACGUDLVOVPUEZUFVQCCKZMAUGZ
      VRWBIZVRMVSUGVOWCVPACUHLVQVPVPWDWAWABCBCUIUJWBMVRAUKUJVQDNZBHZENZBHZJZJZW
      EWGVSOZPQWEWGAOZPQZWEWGQZWJWKWLPWIWKWLQZVQWEWGBBAULUMZUNWJVOWECHZWGCHZWMW
      NUOVOVPWIUPWJBCWEVOVPWIUQZVQWFWHURRZWJBCWGWSVQWFWHUSRZWEWGACUTVAVBVQWFWHF
      NZBHZVDZJZWLXBWEAOZXBWGAOZTOZWKXBWEVSOZXBWGVSOZTOVEXEVOXBCHWQWRWLXHVEVNVO
      VPXDUPXEBCXBVOVPXDUQVQWFWHXCVCZRVQWFWHWQXCWTSVQWFWHWRXCXASWEWGXBACVFVGVQW
      FWHWOXCWPSXEXIXFXJXGTXEXBWEABXKVQWFWHXCVHVIXEXBWGABXKVQWFWHXCVJVIVKVLVM
      $.

    $( Lemma for ~ metres .  (Contributed by Mario Carneiro, 24-Aug-2015.) $)
    metreslem $p |- ( dom D = ( X X. X ) ->
        ( D |` ( R X. R ) ) = ( D |` ( ( X i^i R ) X. ( X i^i R ) ) ) ) $=
      ( cdm cxp wceq cres cin resdmres ineq2 dmres incom eqtr3i 3eqtr4g reseq2d
      inxp syl5eqr ) ADZCCEZFZABBEZGZAUBDZGACBHZUDEZGAUAITUCUEATUARHUASHZUCUERS
      UAJAUAKSUAHUEUFCCBBPSUALMNOQ $.

    $( Lemma for ~ metres .  (Contributed by FL, 12-Oct-2006.)  (Proof
       shortened by Mario Carneiro, 14-Aug-2015.) $)
    metres2 $p |- ( ( D e. ( Met ` X ) /\ R C_ X ) ->
                   ( D |` ( R X. R ) ) e. ( Met ` R ) ) $=
      ( cme cfv wcel wss wa cxp cres cxmt cr metxmet xmetres2 sylan metf adantr
      wf simpr syl2anc xpss12 fssres ismet2 sylanbrc ) ACDEFZBCGZHZABBIZJZBKEFZ
      UHLUIRZUIBDEFUEACKEFUFUJACMABCNOUGCCIZLARZUHULGZUKUEUMUFACPQUGUFUFUNUEUFS
      ZUOBCBCUATULLUHAUBTUIBUCUD $.
  $}

  $( A restriction of an extended metric is an extended metric.  (Contributed
     by Mario Carneiro, 24-Aug-2015.) $)
  xmetres $p |- ( D e. ( *Met ` X ) ->
      ( D |` ( R X. R ) ) e. ( *Met ` ( X i^i R ) ) ) $=
    ( cxmt cfv wcel cxp cres cin cxr wf cdm wceq xmetf fdm metreslem 3syl inss1
    wss xmetres2 mpan2 eqeltrd ) ACDEFZABBGHZACBIZUEGHZUEDEZUCCCGZJAKALUHMUDUFM
    ACNUHJAOABCPQUCUECSUFUGFCBRAUECTUAUB $.

  $( A restriction of a metric is a metric.  (Contributed by NM, 26-Aug-2007.)
     (Revised by Mario Carneiro, 14-Aug-2015.) $)
  metres $p |- ( D e. ( Met ` X ) ->
      ( D |` ( R X. R ) ) e. ( Met ` ( X i^i R ) ) ) $=
    ( cme cfv wcel cxp cres cin cr cdm wceq metf fdm metreslem 3syl wss metres2
    wf inss1 mpan2 eqeltrd ) ACDEFZABBGHZACBIZUEGHZUEDEZUCCCGZJASAKUHLUDUFLACMU
    HJANABCOPUCUECQUFUGFCBTAUECRUAUB $.

  ${
    $d x y z $.
    $( The empty metric.  (Contributed by NM, 30-Aug-2006.)  (Revised by Mario
       Carneiro, 14-Aug-2015.) $)
    0met $p |- (/) e. ( Met ` (/) ) $=
      ( vx vy vz c0 0ex cxp cr wf f0 xp0 feq2i mpbir cv wcel co wceq wb pm2.21i
      cc0 noel adantr caddc cle wbr 3ad2ant1 ismeti ) ABCDDEDDFZGDHDGDHGIUGDGDD
      JKLAMZDNZUHBMZDOZSPUHUJPQZUJDNZUIULUHTZRUAUIUMUKCMZUHDOUOUJDOUBOUCUDZUODN
      UIUPUNRUEUF $.
  $}

  ${
    $d f g h y B $.  $d f g h y z D $.  $d z E $.  $d f g x y z I $.  $d z V $.
    $d f g h x y ph $.  $d f g y z R $.  $d f g y S $.  $d f g y Y $.
    prdsdsf.y $e |- Y = ( S Xs_ ( x e. I |-> R ) ) $.
    prdsdsf.b $e |- B = ( Base ` Y ) $.
    prdsdsf.v $e |- V = ( Base ` R ) $.
    prdsdsf.e $e |- E = ( ( dist ` R ) |` ( V X. V ) ) $.
    prdsdsf.d $e |- D = ( dist ` Y ) $.
    prdsdsf.s $e |- ( ph -> S e. W ) $.
    prdsdsf.i $e |- ( ph -> I e. X ) $.
    prdsdsf.r $e |- ( ( ph /\ x e. I ) -> R e. Z ) $.
    prdsdsf.m $e |- ( ( ph /\ x e. I ) -> E e. ( *Met ` V ) ) $.
    $( The product metric is a function into the nonnegative extended reals.
       In general this means that it is not a metric but rather an *extended*
       metric (even when all the factors are metrics), but it will be a metric
       when restricted to regions where it does not take infinite values.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    prdsdsf $p |- ( ph -> D : ( B X. B ) --> ( 0 [,] +oo ) ) $=
      ( vf vg vy cxp cc0 cpnf cicc co wf cfv cmpt cds crn csn cun cxr clt cmpt2
      cv csup wcel wral wa cle wbr wss csb cres cvv wceq simpr ralrimiva adantr
      elex syl nfcsb1v nfel1 csbeq1a eleq1d rspc mpan9 eqid fvmpts fveq2d oveqd
      syl2anc simprl prdsbascl nfel2 fveq2 eleq12d simprr ovresd cxmt nfcv nffv
      eqtr4d nfxp nfres nfel xpeq12d reseq12d syl5eq xmetcl syl3anc eqeltrd frn
      fmptd 0xr a1i snssd unssd supxrcl ssun2 c0ex snss supxrub sylancl elxrge0
      mpbir sylanbrc ralrimivva fmpt2 sylib mptexg dmmptg prdsds feq1d mpbird
      cdm ) ACCUFZUGUHUIUJZDUKYMYNUCUDCCUEHUEVAZUCVAZULZYOUDVAZULZYOBHEUMZULZUN
      ULZUJZUMZUOZUGUPZUQZURUSVBZUTZUKZAUUHYNVCZUDCVDUCCVDUUJAUUKUCUDCCAYPCVCZY
      RCVCZVEZVEZUUHURVCZUGUUHVFVGZUUKUUOUUGURVHZUUPUUOUUEUUFURUUOHURUUDUKUUEUR
      VHUUOUEHUUCURUUDUUOYOHVCZVEZUUCYQYSBYOEVIZUNULZBYOIVIZUVCUFZVJZUJZURUUTUU
      CYQYSUVBUJUVFUUTUUBUVBYQYSUUTUUAUVAUNUUTUUSUVAVKVCZUUAUVAVLUUOUUSVMUUOEVK
      VCZBHVDZUUSUVGAUVIUUNAUVHBHABVAZHVCVEEMVCZUVHUAEMVPVQVNVOZUVHUVGBYOHBUVAV
      KBYOEVRZVSUVJYOVLZEUVAVKBYOEVTZWAWBWCBYOEHYTVKYTWDWEWHWFWGUUTYQYSUVBUVCUU
      OUVJYPULZIVCZBHVDUUSYQUVCVCZUUOBCEFYPHIJKVKLNOAFJVCUUNSVOZAHKVCZUUNTVOZUV
      LPAUULUUMWIWJUVQUVRBYOHBYQUVCBYOIVRZWKUVNUVPYQIUVCUVJYOYPWLBYOIVTZWMWBWCZ
      UUOUVJYRULZIVCZBHVDUUSYSUVCVCZUUOBCEFYRHIJKVKLNOUVSUWAUVLPAUULUUMWNWJUWFU
      WGBYOHBYSUVCUWBWKUVNUWEYSIUVCUVJYOYRWLUWCWMWBWCZWOWSUUTUVEUVCWPULZVCZUVRU
      WGUVFURVCUUOGIWPULZVCZBHVDZUUSUWJAUWMUUNAUWLBHUBVNVOUWLUWJBYOHBUVEUWIBUVB
      UVDBUVAUNBUNWQUVMWRBUVCUVCUWBUWBWTXABUVCWPBWPWQUWBWRXBUVNGUVEUWKUWIUVNGEU
      NULZIIUFZVJUVEQUVNUWNUVBUWOUVDUVNEUVAUNUVOWFUVNIUVCIUVCUWCUWCXCXDXEUVNIUV
      CWPUWCWFWMWBWCUWDUWHYQYSUVEUVCXFXGXHUUDWDXJHURUUDXIVQUUOUGURUGURVCUUOXKXL
      XMXNZUUGXOVQUUOUURUGUUGVCZUUQUWPUWQUUFUUGVHUUFUUEXPUGUUGXQXRYBUUGUGXSXTUU
      HYAYCYDUCUDCCUUHYNUUIUUIWDYEYFAYMYNDUUIAUECDLYTFUCUDHJVKNSAUVTYTVKVCTBHEK
      YGVQOAUVKBHVDYTYLHVLAUVKBHUAVNBHEMYHVQRYIYJYK $.

    ${
      $d x B $.  $d x D $.
      $( The product metric is an extended metric.  (Contributed by Mario
         Carneiro, 20-Aug-2015.) $)
      prdsxmetlem $p |- ( ph -> D e. ( *Met ` B ) ) $=
        ( vf vg vh vz cvv wcel cbs cfv fvex eqeltri a1i cxp cc0 cpnf cicc co wf
        cxr wss prdsdsf iccssxr fss sylancl cle wbr fovrnda elxrge0 simprbi syl
        cv wa cmpt crn csn cun clt csup wral adantr ralrimiva simprl prdsdsval3
        wceq simprr breq1d cxmt adantlr prdsbascl r19.21bi xmetcl syl3anc fmptd
        eqid frn 0xr snssd unssd supxrleub 0le0 c0ex breq1 ralsn mpbir mpbiran2
        wb ralunb ovex rgenw ralrnmpt ax-mp bitri xmetge0 biantrud xrletri3 wfn
        xmeteq0 prdsbasfn syl2anc cr caddc 3adantr3 3adant3 3ad2ant1 ssun1 wrex
        w3a cab elabrex adantl rnmpt syl6eleqr sseldi supxrub breqtrrd syl22anc
        xrrege0 mpbird fovrnd ralbidva fnmpt eqfnfv bitr4d syl5bb 3bitrd simp23
        3ad2antl1 simp3l simp21 simp3r simp22 readdcld xmettri2 syl13anc rexadd
        3bitr2d breqtrd readdcl 3ad2ant3 le2addd letrd addge0d sylanbrc eqbrtrd
        cxad sylibr rexrd isxmet2d ) AUCUDUEDCCUGUHACLUIUJUGOLUIUKULUMACCUNZUOU
        PUQURZDUSZUVKUTVAUVJUTDUSABCDEFGHIJKLMNOPQRSTUAUBVBZUOUPVCUVJUVKUTDVDVE
        AUCVLZCUHZUDVLZCUHZVMZVMZUVNUVPDURZUVKUHZUOUVTVFVGZAUVNUVPUVKCCDUVMVHUW
        AUVTUTUHUWBUVTVIVJVKUVSUVTUOVFVGBHBVLZUVNUJZUWCUVPUJZGURZVNZVOZUOVPZVQZ
        UTVRVSZUOVFVGZUFVLZUOVFVGZUFUWJVTZUVNUVPWEZUVSUVTUWKUOVFUVSBCDEFGUVNUVP
        HIJKMLNOAFJUHZUVRSWAZAHKUHZUVRTWAZAEMUHZBHVTZUVRAUXABHUAWBZWAZAUVOUVQWC
        ZAUVOUVQWFZPQRWDZWGUVSUWJUTVAZUOUTUHZUWLUWOXGUVSUWHUWIUTUVSHUTUWGUSUWHU
        TVAUVSBHUWFUTUWGUVSUWCHUHZVMZGIWHUJUHZUWDIUHZUWEIUHZUWFUTUHZAUXJUXLUVRU
        BWIZUVSUXMBHUVSBCEFUVNHIJKMLNOUWRUWTUXDPUXEWJZWKZUVSUXNBHUVSBCEFUVPHIJK
        MLNOUWRUWTUXDPUXFWJZWKZUWDUWEGIWLZWMZUWGWOZWNHUTUWGWPVKUVSUOUTUXIUVSWQU
        MWRWSZWQUFUWJUOWTVEUWOUWFUOVFVGZBHVTZUVSUWPUWOUWNUFUWHVTZUYFUWOUYGUWNUF
        UWIVTZUYHUOUOVFVGZXAUWNUYIUFUOXBUWMUOUOVFXCXDXEUWNUFUWHUWIXHXFUWFUGUHZB
        HVTUYGUYFXGUYJBHUWDUWEGXIXJUWNUYEBUFHUWFUWGUGUYCUWMUWFUOVFXCXKXLXMUVSUY
        FUWDUWEWEZBHVTZUWPUVSUYEUYKBHUXKUYEUYEUOUWFVFVGZVMZUWFUOWEZUYKUXKUYMUYE
        UXKUXLUXMUXNUYMUXPUXRUXTUWDUWEGIXNZWMXOUXKUXOUXIUYOUYNXGUYBWQUWFUOXPVEU
        XKUXLUXMUXNUYOUYKXGUXPUXRUXTUWDUWEGIXRWMUUQUUAUVSUVNHXQUVPHXQUWPUYLXGUV
        SCBHEVNZFUVNHJKLNOUWRUWTAUYQHXQZUVRAUXBUYRUXCBHEUYQMUYQWOUUBVKWAZUXEXSU
        VSCUYQFUVPHJKLNOUWRUWTUYSUXFXSBHUVNUVPUUCXTUUDUUEUUFAUVOUVQUEVLZCUHZYHZ
        UYTUVNDURZYAUHZUYTUVPDURZYAUHZVMZYHZUVTUWKVUCVUEYBURZVFAVUBUVTUWKWEZVUG
        AUVOUVQVUJVUAUXGYCYDVUHUWKVUIVFVGZUWMVUIVFVGZUFUWJVTZVUHVULUFUWHVTZVULU
        FUWIVTZVUMVUHVUNUWFVUIVFVGZBHVTZVUHVUPBHVUHUXJVMZUWFUWCUYTUJZUWDGURZVUS
        UWEGURZYBURZVUIVURUXOVVBYAUHUYMUWFVVBVFVGUWFYAUHVURUXLUXMUXNUXOAVUBUXJU
        XLVUGUBUUHZVUHUXMBHAVUBUXMBHVTZVUGAUVOUVQVVDVUAUXQYCYDWKZVUHUXNBHAVUBUX
        NBHVTZVUGAUVOUVQVVFVUAUXSYCYDWKZUYAWMZVURVUTVVAVURVUTUTUHZVUDUOVUTVFVGZ
        VUTVUCVFVGVUTYAUHZVURUXLVUSIUHZUXMVVIVVCVUHVVLBHVUHBCEFUYTHIJKMLNOAVUBU
        WQVUGSYEZAVUBUWSVUGTYEZAVUBUXBVUGUXCYEZPAUVOUVQVUAVUGUUGZWJWKZVVEVUSUWD
        GIWLWMZVUHVUDUXJAVUBVUDVUFUUIZWAZVURUXLVVLUXMVVJVVCVVQVVEVUSUWDGIXNWMVU
        RVUTBHVUTVNZVOZUWIVQZUTVRVSZVUCVFVURVWCUTVAZVUTVWCUHVUTVWDVFVGVUHVWEUXJ
        VUHVWBUWIUTVUHHUTVWAUSVWBUTVAVUHBHVUTUTVWAVVRVWAWOZWNHUTVWAWPVKVUHUOUTU
        XIVUHWQUMWRZWSWAVURVWBVWCVUTVWBUWIYFVURVUTUWMVUTWEBHYGUFYIZVWBUXJVUTVWH
        UHVUHBUFHVUTVUSUWDGXIYJYKBUFHVUTVWAVWFYLYMYNVWCVUTYOXTVUHVUCVWDWEUXJVUH
        BCDEFGUYTUVNHIJKMLNOVVMVVNVVOVVPAUVOUVQVUAVUGUUJZPQRWDWAYPZVUTVUCYRYQZV
        URVVAUTUHZVUFUOVVAVFVGZVVAVUEVFVGVVAYAUHZVURUXLVVLUXNVWLVVCVVQVVGVUSUWE
        GIWLWMZVUHVUFUXJAVUBVUDVUFUUKZWAZVURUXLVVLUXNVWMVVCVVQVVGVUSUWEGIXNWMVU
        RVVABHVVAVNZVOZUWIVQZUTVRVSZVUEVFVURVWTUTVAZVVAVWTUHVVAVXAVFVGVUHVXBUXJ
        VUHVWSUWIUTVUHHUTVWRUSVWSUTVAVUHBHVVAUTVWRVWOVWRWOZWNHUTVWRWPVKVWGWSWAV
        URVWSVWTVVAVWSUWIYFVURVVAUWMVVAWEBHYGUFYIZVWSUXJVVAVXDUHVUHBUFHVVAVUSUW
        EGXIYJYKBUFHVVAVWRVXCYLYMYNVWTVVAYOXTVUHVUEVXAWEUXJVUHBCDEFGUYTUVPHIJKM
        LNOVVMVVNVVOVVPAUVOUVQVUAVUGUULZPQRWDWAYPZVVAVUEYRYQZUUMZVURUXLUXMUXNUY
        MVVCVVEVVGUYPWMVURUWFVUTVVAUVFURZVVBVFVURUXLVVLUXMUXNUWFVXIVFVGVVCVVQVV
        EVVGUWDUWEVUSGIUUNUUOVURVVKVWNVXIVVBWEVWKVXGVUTVVAUUPXTUURZUWFVVBYRYQVX
        HVUHVUIYAUHZUXJVUGAVXKVUBVUCVUEUUSUUTZWAVXJVURVUTVVAVUCVUEVWKVXGVVTVWQV
        WJVXFUVAUVBWBVUHUXOBHVTVUNVUQXGVUHUXOBHVVHWBVULVUPBUFHUWFUWGUTUYCUWMUWF
        VUIVFXCXKVKYSVUHUOVUIVFVGZVUOVUHVUCVUEVVSVWPVUHVUCUVKUHZUOVUCVFVGZVUHUY
        TUVNUVKCCDAVUBUVLVUGUVMYEZVVPVWIYTVXNVUCUTUHVXOVUCVIVJVKVUHVUEUVKUHZUOV
        UEVFVGZVUHUYTUVPUVKCCDVXPVVPVXEYTVXQVUEUTUHVXRVUEVIVJVKUVCVULVXMUFUOXBU
        WMUOVUIVFXCXDUVGVULUFUWHUWIXHUVDVUHUXHVUIUTUHVUKVUMXGAVUBUXHVUGAUVOUVQU
        XHVUAUYDYCYDVUHVUIVXLUVHUFUWJVUIWTXTYSUVEUVI $.
    $}

    $( The product metric is an extended metric.  Eliminate disjoint variable
       conditions from ~ prdsxmetlem .  (Contributed by Mario Carneiro,
       26-Sep-2015.) $)
    prdsxmet $p |- ( ph -> D e. ( *Met ` B ) ) $=
      ( vy cv csb cds cfv cbs cxp cres cvv cmpt cprds co nfcsb1v csbeq1a cbvmpt
      nfcv oveq2i eqtri eqid wcel wral elex syl ralrimiva nfel1 weq eleq1d rspc
      wa mpan9 cxmt nffv nfxp nfres nfel fveq2d syl5eq xpeq12d reseq12d eleq12d
      prdsxmetlem ) AUCCDBUCUDZEUEZFWEUFUGZWEUHUGZWGUIZUJZHWGJKLUKLFBHEULZUMUNF
      UCHWEULZUMUNNWJWKFUMBUCHEWEUCEURBWDEUOZBWDEUPZUQUSUTOWGVAWIVARSTAEUKVBZBH
      VCWDHVBZWEUKVBZAWNBHABUDHVBVKEMVBWNUAEMVDVEVFWNWPBWDHBWEUKWLVGBUCVHZEWEUK
      WMVIVJVLAGIVMUGZVBZBHVCWOWIWGVMUGZVBZAWSBHUBVFWSXABWDHBWIWTBWFWHBWEUFBUFU
      RWLVNBWGWGBWEUHBUHURWLVNZXBVOVPBWGVMBVMURXBVNVQWQGWIWRWTWQGEUFUGZIIUIZUJW
      IQWQXCWFXDWHWQEWEUFWMVRWQIWGIWGWQIEUHUGWGPWQEWEUHWMVRVSZXEVTWAVSWQIWGVMXE
      VRWBVJVLWC $.
  $}

  ${
    $d f g B $.  $d f g D $.  $d x I $.  $d f g x ph $.
    prdsmet.y $e |- Y = ( S Xs_ ( x e. I |-> R ) ) $.
    prdsmet.b $e |- B = ( Base ` Y ) $.
    prdsmet.v $e |- V = ( Base ` R ) $.
    prdsmet.e $e |- E = ( ( dist ` R ) |` ( V X. V ) ) $.
    prdsmet.d $e |- D = ( dist ` Y ) $.
    prdsmet.s $e |- ( ph -> S e. W ) $.
    prdsmet.i $e |- ( ph -> I e. Fin ) $.
    prdsmet.r $e |- ( ( ph /\ x e. I ) -> R e. Z ) $.
    prdsmet.m $e |- ( ( ph /\ x e. I ) -> E e. ( Met ` V ) ) $.
    $( The product metric is a metric when the index set is finite.
       (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    prdsmet $p |- ( ph -> D e. ( Met ` B ) ) $=
      ( vf vg cxmt cfv wcel cxp cr wf cme cfn cv wa metxmet syl prdsxmet wfn co
      wral cc0 cpnf cicc prdsdsf ffn cmpt crn csn cun cxr csup adantr ralrimiva
      clt simprl simprr prdsdsval3 wss prdsbascl r19.26 wi metcl 3expib syl5bir
      ralimdva mp2and eqid fmpt sylib frn 0re a1i snssd unssd wor c0 wne xrltso
      mptfi rnfi 3syl snfi unfi sylancl ssun2 c0ex snss ne0i mp1i ressxr syl6ss
      mpbir fisupcl syl13anc sseldd eqeltrd ralrimivva ffnov sylanbrc ismet2 )
      ADCUDUEUFCCUGZUHDUIZDCUJUEUFABCDEFGHIJUKKLMNOPQRSTABULZHUFUMZGIUJUEUFZGIU
      DUEUFUAGIUNUOZUPADXTUQZUBULZUCULZDURZUHUFZUCCUSUBCUSYAAXTUTVAVBURZDUIYFAB
      CDEFGHIJUKKLMNOPQRSTYEVCXTYKDVDUOAYJUBUCCCAYGCUFZYHCUFZUMZUMZYIBHYBYGUEZY
      BYHUEZGURZVEZVFZUTVGZVHZVIVMVJZUHYOBCDEFGYGYHHIJUKLKMNAFJUFYNRVKZAHUKUFZY
      NSVKZAELUFZBHUSYNAUUGBHTVLVKZAYLYMVNZAYLYMVOZOPQVPYOUUBUHUUCYOYTUUAUHYOHU
      HYSUIZYTUHVQYOYRUHUFZBHUSZUUKYOYPIUFZBHUSZYQIUFZBHUSZUUMYOBCEFYGHIJUKLKMN
      UUDUUFUUHOUUIVRYOBCEFYHHIJUKLKMNUUDUUFUUHOUUJVRUUOUUQUMUUNUUPUMZBHUSZYOUU
      MUUNUUPBHVSAUUSUUMVTYNAUURUULBHYCYDUURUULVTUAYDUUNUUPUULYPYQGIWAWBUOWDVKW
      CWEBHUHYRYSYSWFWGWHHUHYSWIUOYOUTUHUTUHUFYOWJWKWLWMZYOVIVMWNZUUBUKUFZUUBWO
      WPZUUBVIVQUUCUUBUFUVAYOWQWKYOYTUKUFZUUAUKUFUVBYOUUEYSUKUFUVDUUFBHYRWRYSWS
      WTUTXAYTUUAXBXCUTUUBUFZUVCYOUVEUUAUUBVQUUAYTXDUTUUBXEXFXKUUBUTXGXHYOUUBUH
      VIUUTXIXJVIUUBVMXLXMXNXOXPUBUCCCUHDXQXRDCXSXR $.
  $}

  ${
    $d f g B $.  $d f g D $.  $d f g E $.  $d x I $.  $d f g x ph $.
    ressprdsds.y $e |- ( ph -> Y = ( S Xs_ ( x e. I |-> R ) ) ) $.
    ressprdsds.h $e |- ( ph -> H = ( T Xs_ ( x e. I |-> ( R |`s A ) ) ) ) $.
    ressprdsds.b $e |- B = ( Base ` H ) $.
    ressprdsds.d $e |- D = ( dist ` Y ) $.
    ressprdsds.e $e |- E = ( dist ` H ) $.
    ressprdsds.s $e |- ( ph -> S e. U ) $.
    ressprdsds.t $e |- ( ph -> T e. V ) $.
    ressprdsds.i $e |- ( ph -> I e. W ) $.
    ressprdsds.r $e |- ( ( ph /\ x e. I ) -> R e. X ) $.
    ressprdsds.a $e |- ( ( ph /\ x e. I ) -> A e. Z ) $.
    $( Restriction of a product metric.  (Contributed by Mario Carneiro,
       16-Sep-2015.) $)
    ressprdsds $p |- ( ph -> E = ( D |` ( B X. B ) ) ) $=
      ( vf vg cxp cres wceq cv co wral wcel wa ovres adantl cprds cds cfv cress
      cmpt crn cc0 csn cun cxr clt csup ressds syl oveqd mpteq2dva adantr rneqd
      eqid uneq1d supeq1d cbs ralrimiva wss cixp ressbasss a1i ss2ixp cvv rgenw
      ovex prdsbas3 3sstr4d fveq2d syl5eq sseqtrd simprl sseldd eleqtrd 3eqtr4d
      simprr prdsdsval2 proplem3 eqtr2d ralrimivva wfn wb mptexg dmmpti xpeq12d
      cdm prdsdsfn fneq12d mpbird dmmptg xpss12 syl2anc fnssres eqfnov2 ) AJEDD
      UJZUKZULZUHUMZUIUMZJUNZYBYCXTUNZULZUIDUOUHDUOZAYFUHUIDDAYBDUPZYCDUPZUQZUQ
      ZYEYBYCEUNZYDYJYEYLULAYBYCDDEURUSYKYBYCGBLFVDZUTUNZVAVBZUNZYBYCHBLFCVCUNZ
      VDZUTUNZVAVBZUNZYLYDYKBLBUMZYBVBZUUBYCVBZFVAVBZUNZVDZVEZVFVGZVHZVIVJVKBLU
      UCUUDYQVAVBZUNZVDZVEZUUIVHZVIVJVKYPUUAYKVIUUJUUOVJYKUUHUUNUUIYKUUGUUMAUUG
      UUMULYJABLUUFUULAUUBLUPUQZUUEUUKUUCUUDUUPCQUPUUEUUKULUGCUUEFYQQYQVRZUUEVR
      ZVLVMVNVOVPVQVSVTYKBYNWAVBZYOFGUUEYBYCLINOYNYNVRZUUSVRZAGIUPYJUCVPALNUPZY
      JUEVPZAFOUPZBLUOZYJAUVDBLUFWBZVPYKDUUSYBYKDPWAVBZUUSADUVGWCZYJAYSWAVBZUUS
      DUVGABLYQWAVBZWDZBLFWAVBZWDZUVIUUSAUVJUVLWCZBLUOUVKUVMWCAUVNBLUVNUUPCUVLY
      QFUUQUVLVRZWEWFWBBLUVJUVLWGVMABUVIYQHLUVJMNWHYSYSVRZUVIVRZUDUEYQWHUPZBLUO
      ZAUVRBLFCVCWJZWIZWFUVJVRWKABUUSFGLUVLINOYNUUTUVAUCUEUVFUVOWKWLADKWAVBUVIT
      AKYSWASWMWNZAPYNWARWMZWLZVPAUVGUUSULYJUWCVPWOZAYHYIWPZWQYKDUUSYCUWEAYHYIW
      TZWQUURYOVRZXAYKBUVIYTYQHUUKYBYCLMNWHYSUVPUVQAHMUPYJUDVPUVCUVSYKUWAWFYKYB
      DUVIUWFADUVIULYJUWBVPZWRYKYCDUVIUWGUWIWRUUKVRYTVRZXAWSAYJUHUIEYOAEPVAVBYO
      UAAPYNVARWMWNZXBAYJUHUIJYTAJKVAVBYTUBAKYSVASWMWNZXBWSXCXDAJXSXEZXTXSXEZYA
      YGXFAUWMYTUVIUVIUJZXEAUVIYTYSYRHLMWHUVPUDAUVBYRWHUPUEBLYQNXGVMUVQYRXJLULA
      BLYQYRUVTYRVRXHWFUWJXKAXSUWOJYTUWLADUVIDUVIUWBUWBXIXLXMAEUVGUVGUJZXEZXSUW
      PWCZUWNAUWQYOUUSUUSUJZXEAUUSYOYNYMGLIWHUUTUCAUVBYMWHUPUEBLFNXGVMUVAAUVEYM
      XJLULUVFBLFOXNVMUWHXKAUWPUWSEYOUWKAUVGUUSUVGUUSUWCUWCXIXLXMAUVHUVHUWRUWDU
      WDDUVGDUVGXOXPUWPXSEXQXPUHUIDDJXTXRXPXM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x I $.  $d x ph $.  $d x R $.
    resspwsds.y $e |- ( ph -> Y = ( R ^s I ) ) $.
    resspwsds.h $e |- ( ph -> H = ( ( R |`s A ) ^s I ) ) $.
    resspwsds.b $e |- B = ( Base ` H ) $.
    resspwsds.d $e |- D = ( dist ` Y ) $.
    resspwsds.e $e |- E = ( dist ` H ) $.
    resspwsds.i $e |- ( ph -> I e. V ) $.
    resspwsds.r $e |- ( ph -> R e. W ) $.
    resspwsds.a $e |- ( ph -> A e. X ) $.
    $( Restriction of a product metric.  (Contributed by Mario Carneiro,
       16-Sep-2015.) $)
    resspwsds $p |- ( ph -> E = ( D |` ( B X. B ) ) ) $=
      ( vx csca cfv cress co cvv cpws cmpt cprds csn cxp wcel wceq eqid syl2anc
      pwsval fconstmpt oveq2i syl6eq ovex sylancr fvex a1i cv adantr ressprdsds
      eqtrd ) AUABCDEEUBUCZEBUDUEZUBUCZUFFGHUFIJLKALEHUGUEZVHUAHEUHZUIUEZMAVKVH
      HEUJUKZUIUEZVMAEJULZHIULZVKVOUMSREVHHJIVKVKUNVHUNUPUOVNVLVHUIUAHEUQURUSVG
      AGVIHUGUEZVJUAHVIUHZUIUEZNAVRVJHVIUJUKZUIUEZVTAVIUFULVQVRWBUMEBUDUTRVIVJH
      UFIVRVRUNVJUNUPVAWAVSVJUIUAHVIUQURUSVGOPQVHUFULAEUBVBVCVJUFULAVIUBVBVCRAV
      PUAVDHULZSVEABKULWCTVEVF $.
  $}

  ${
    $d g h i n F $.  $d f g h i j m n p x ph $.  $d p T $.  $d f g h i j n V $.
    $d f g i j m n p x E $.  $d g h i n R $.  $d g j m x S $.  $d j m x W $.
    $d g h i j m n p x X $.  $d g h i j n p Y $.
    imasdsf1o.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasdsf1o.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasdsf1o.f $e |- ( ph -> F : V -1-1-onto-> B ) $.
    imasdsf1o.r $e |- ( ph -> R e. Z ) $.
    imasdsf1o.e $e |- E = ( ( dist ` R ) |` ( V X. V ) ) $.
    imasdsf1o.d $e |- D = ( dist ` U ) $.
    imasdsf1o.m $e |- ( ph -> E e. ( *Met ` V ) ) $.
    imasdsf1o.x $e |- ( ph -> X e. V ) $.
    imasdsf1o.y $e |- ( ph -> Y e. V ) $.
    ${
      imasdsf1o.w $e |- W = ( RR*s |`s ( RR* \ { -oo } ) ) $.
      imasdsf1o.s $e |- S = { h e. ( ( V X. V ) ^m ( 1 ... n ) ) |
      ( ( F ` ( 1st ` ( h ` 1 ) ) ) = ( F ` X ) /\
        ( F ` ( 2nd ` ( h ` n ) ) ) = ( F ` Y ) /\ A. i e. ( 1 ... ( n - 1 ) )
        ( F ` ( 2nd ` ( h ` i ) ) ) = ( F ` ( 1st ` ( h ` ( i + 1 ) ) ) ) ) }
          $.
      imasdsf1o.t $e |- T = U_ n e. NN
        ran ( g e. S |-> ( RR*s gsum ( E o. g ) ) ) $.
      $( Lemma for ~ imasdsf1o .  (Contributed by Mario Carneiro,
         21-Aug-2015.) $)
      imasdsf1olem $p |- ( ph -> ( ( F ` X ) D ( F ` Y ) ) = ( X E Y ) ) $=
        ( vx vf vj vp vm cfv co cxr csup cn cxrs cv ccom cgsu cmpt wf1o eqid wf
        syl f1of ffvelrnd syl6eqr wceq cle wbr wss wcel wral wa cmnf csn c1 cfz
        cxad cvv cfn cc0 xrsbas xrsadd a1i cxp w3a wne syl2anc eldifsn sylanbrc
        xmetcl ad2antrr cmap c1st c2nd caddc cmin mp1i adantl ax-mp 1nn cop 1ex
        wrex wb mpbird fveq2d syl3anc df-ov syl6eq oveq2d eqtrd eqeq1d syl12anc
        fveq1 weq oveq2 c0 fveq2 syl5bb cres xp2nd f1fveq mpbid reseq2d breq12d
        wi eleq1 imbi12d imbi2d cuz resmpt breqtrrd adantr clt ccnv crn cds wfo
        ciun f1ofo imasdsval2 supeq1i cdif xrsex fzfid difss wfn cxmt xmetf ffn
        3syl xmetge0 ge0nemnf 3expb sylan ralrimivva crab ssrab2 eqsstri sselda
        ffnov elmapi fco 0re rexr renemnf xaddid2 xaddid1 jca gsumress ressbas2
        cr cbs xrs10 ccmn xrs1cmn fisuppfi gsumcl eqeltrd eldifad frn ralrimiva
        fmptd iunss syl5eqss opex f1osn opelxpi snssd fss sylancr elfvexd xpexg
        sylibr snex elmapg sylancl op1stg op2ndg fconst6g fcoconst coeq2i sneqi
        snfi xpsn eqcomi xpeq2i feq1d fconstmpt cmnd cmnmnd eqidd gsumsn eqtr2d
        3eqtr3g fvsn anbi12d coeq2 eqeq2d rspcev elrnmpt rexeqi eqeq12d ralbidv
        ovex 3anbi123d rexrab bitri cz fzsn df-3an ral0 oveq1 1m1e0 fz10 mpbiri
        biantrud anbi2d bitr3d anbi1d rexeqbidv eliun syl6eleqr infmxrlb eleq2i
        1z raleqdv vex elrab2 simprbi simp2d wf1 f1of1 simplr elfz1end syl6eleq
        sylib eluzfz1 xrleid fcompt reseq1d 1st2nd2 simp1d xp1st opeq1d 3eqtr4d
        nnuz syl5eq a1d simprl simprr peano2fzr expr cun fzsuc elfzuz3 ad2antll
        imim1d eqsstr3d unssad fssres xleadd1a ex xmettri syl13anc nnz ad2antrl
        fzss2 elfzuzb simp3d rspcv sylc eqtr4d xaddcld xrletr mpand syld cplusg
        eluzp1m1 xrex ssexi ressplusg fzelp1 sylan2 wn fzp1disj disjsn gsumunsn
        cin reseq12d oveq1d breq2d sylibrd a2d nnind mpcom mpd eqbrtrrd fnresdm
        expcom breq2 syl5ibrcom rexlimdva ralrimiv infmxrgelb infmxrcl xrletri3
        syl5bi mpbir2and ) APMUPZQMUPZCUQZFURUUAUUBZUSZPQLUQZAVYSKUTHEVALHVBZVC
        ZVDUQZVEZUUCZUUFZURVYTUSWUAABCDELGHIJKDUUDUPZMNVYQVYRRSTANBMVFZNBMUUEUA
        NBMUUGVIUBWUIVGUDANBPMAWUJNBMVHUANBMVJVIZUFVKANBQMWUKUGVKUIUCUUHURFWUHV
        YTUJUUIVLAWUAWUBVMZWUAWUBVNVOZWUBWUAVNVOZAFURVPZWUBFVQWUMAFWUHURUJAWUGU
        RVPZKUTVRWUHURVPAWUPKUTAKVBZUTVQZVSZEURWUFVHWUPWUSHEWUEURWUFWUSWUCEVQZV
        SZWUEURVTWAZWVAWUEOWUDVDUQZURWVBUUJZWVAUKWBWUQWCUQZURWDWVDWUDVAOWEWFWGW
        HWIUHVAWEVQZWVAUUKWJWVAWBWUQUULZWVDURVPZWVAURWVBUUMZWJWVANNWKZWVDLVHZWV
        EWVJWUCVHZWVEWVDWUDVHZAWVKWURWUTALWVJUUNZULVBZWUCLUQZWVDVQZHNVRULNVRWVK
        ALNUUOUPVQZWVJURLVHZWVNUELNUUPZWVJURLUUQUURZAWVQULHNNAWVRWVONVQZWUCNVQZ
        VSWVQUEWVRWWBWWCWVQWVRWWBWWCWLZWVPURVQZWVPVTWMZWVQWVOWUCLNWQZWWDWWEWGWV
        PVNVOWWFWWGWVOWUCLNUUSWVPUUTWNWVPURVTWOWPUVAUVBUVCULHNNWVDLUVHWPWRZWVAW
        UCWVJWVEWSUQZVQZWVLWUSEWWIWUCEWWIVPWUSEWBIVBZUPZWTUPZMUPZVYQVMZWUQWWKUP
        ZXAUPZMUPZVYRVMZJVBZWWKUPZXAUPZMUPZWWTWBXBUQZWWKUPZWTUPZMUPZVMZJWBWUQWB
        XCUQZWCUQZVRZWLZIWWIUVDZWWIUIWXLIWWIUVEUVFWJUVGWUCWVJWVEUVIVIZWVEWVJWVD
        LWUCUVJWNZWGUVSVQZWGWVDVQZWVAUVKWXPWGURVQWGVTWMWXQWGUVLWGUVMWGURVTWOWPZ
        XDUKVBZURVQZWGWXSWDUQWXSVMZWXSWGWDUQWXSVMZVSZWVAWXTWYAWYBWXSUVNWXSUVOUV
        PZXEUVQZWVAWVEWVDWUDOWFWGWVHWVDOUVTUPVMWVIWVDUROVAUHWHUVRXFZOUHUWAZOUWB
        VQZWVAOUHUWCZWJWVGWXOWVAWVEWVDWEWGWAUUJZWUDWVGWXOUWDUWEUWFUWGWUFVGZUWJE
        URWUFUWHVIUWIKUTWUGURUWKUXAUWLZAWUBWUHFAWUBWUGVQZKUTXJZWUBWUHVQAWBUTVQZ
        WBWUCUPZWTUPZMUPZVYQVMZWYPXAUPZMUPZVYRVMZVSZWUBWUEVMZVSZHWVJWBWAZWSUQZX
        JZWYNXGAWBPQXHZXHWAZXUGVQZXUIWTUPZMUPZVYQVMZXUIXAUPZMUPZVYRVMZVSZWUBVAL
        XUJVCZVDUQZVMZXUHAXUKXUFWVJXUJVHZAXUFXUIWAZXUJVHZXVCWVJVPXVBXUFXVCXUJVF
        XVDWBXUIXIPQUWMZUWNXUFXVCXUJVJXFAXUIWVJAPNVQZQNVQZXUIWVJVQZUFUGPQNNUWOW
        NZUWPXUFXVCWVJXUJUWQUWRAWVJWEVQZXUFWEVQXUKXVBXKANWEVQZXVKXVJALUUONUEUWS
        ZXVLNNWEWEUWTWNWBUXBWVJXUFXUJWEWEUXCUXDXLAXUNXUQAXULPMAXVFXVGXULPVMUFUG
        PQNNUXEWNXMAXUOQMAXVFXVGXUOQVMUFUGPQNNUXFWNXMUVPAXUTOUMXUFWUBVEZVDUQZWU
        BAXUTOXUSVDUQXVNAUKXUFURWDWVDXUSVAOWEWFWGWHWIUHWVFAUUKWJXUFWFVQAWBUXKWJ
        WVHAWVIWJAXUFWVDXUSVHXUFWVDXUFWUBWAZWKZVHZAWUBWVDVQZXVQAWUBURVQZWUBVTWM
        ZXVRAWVRXVFXVGXVSUEUFUGPQLNWQXNZAXVSWGWUBVNVOZXVTXWAAWVRXVFXVGXWBUEUFUG
        PQLNUUSXNWUBUUTWNWUBURVTWOWPZXUFWUBWVDUXGVIAXUFWVDXUSXVPALXUFXVCWKZVCZX
        UFXUILUPZWAZWKZXUSXVPAWVNXVHXWEXWHVMWWAXVILXUFWVJXUIUXHWNXWDXUJLWBXUIXI
        XVEUXLUXIXWGXVOXUFXWFWUBWUBXWFPQLXOUXMUXJUXNUYBZUXOXLWXPWXQAUVKWXRXDWXT
        WYCAWYDXEUVQAXUSXVMOVDAXUSXVPXVMXWIUMXUFWUBUXPXPXQXRAOUXQVQZWYOXVRXVNWU
        BVMWYHXWJAWYIOUXRXDZWYOAXGWJXWCWUBWVDWUBUMOWBUTWYFUMVBZWBVMZWUBUXSUXTXN
        UYAXUEXURXVAVSHXUJXUGWUCXUJVMZXUCXURXUDXVAXWNWYSXUNXUBXUQXWNWYRXUMVYQXW
        NWYQXULMXWNWYPXUIWTXWNWYPWBXUJUPXUIWBWUCXUJYAWBXUIXIXVEUYCXPZXMXMXSXWNX
        UAXUPVYRXWNWYTXUOMXWNWYPXUIXAXWOXMXMXSUYDXWNWUEXUTWUBXWNWUDXUSVAVDWUCXU
        JLUYEXQUYFUYDUYGXTWYMXUHKWBUTWYMXUDHEXJZWUQWBVMZXUHWUBWEVQWYMXWPXKPQLUY
        LHEWUEWUBWUFWEWYKUYHXFXWPWYSWUQWUCUPZXAUPZMUPZVYRVMZWWTWUCUPZXAUPZMUPZW
        XDWUCUPZWTUPZMUPZVMZJWXJVRZWLZXUDVSZHWWIXJZXWQXUHXWPXUDHWXMXJXXLXUDHEWX
        MUIUYIWXLXXJXUDHIWWIIHYBZWWOWYSWWSXXAWXKXXIXXMWWNWYRVYQXXMWWMWYQMXXMWWL
        WYPWTWBWWKWUCYAXMXMXSXXMWWRXWTVYRXXMWWQXWSMXXMWWPXWRXAWUQWWKWUCYAXMXMXS
        XXMWXHXXHJWXJXXMWXCXXDWXGXXGXXMWXBXXCMXXMWXAXXBXAWWTWWKWUCYAXMXMXXMWXFX
        XFMXXMWXEXXEWTWXDWWKWUCYAXMXMUYJUYKUYMZUYNUYOXWQXXKXUEHWWIXUGXWQWVEXUFW
        VJWSXWQWVEWBWBWCUQZXUFWUQWBWBWCYCWBUYPVQXXOXUFVMVUMWBUYQXFZXPXQXWQXXJXU
        CXUDXXJWYSXXAVSZXXIVSZXWQXUCWYSXXAXXIUYRXWQXXQXXRXUCXWQXXIXXQXWQXXIXXHJ
        YDVRXXHJUYSXWQXXHJWXJYDXWQWXJWBWGWCUQYDXWQWXIWGWBWCXWQWXIWBWBXCUQWGWUQW
        BWBXCUYTVUAXPXQVUBXPVUNVUCVUDXWQXXAXUBWYSXWQXWTXUAVYRXWQXWSWYTMXWQXWRWY
        PXAWUQWBWUCYEXMXMXSVUEVUFYFVUGVUHYFYFUYGUWRKWUBUTWUGVUIUXAUJVUJFWUBVUKW
        NAWUNWUBUNVBZVNVOZUNFVRZAXXTUNFXXSFVQZXXSWUGVQZKUTXJZAXXTXYBXXSWUHVQXYD
        FWUHXXSUJVULKXXSUTWUGVUIUYOAXYCXXTKUTXYCXXSWUEVMZHEXJZWUSXXTXXSWEVQXYCX
        YFXKUNVUOHEWUEXXSWUFWEWYKUYHXFWUSXYEXXTHEWVAXXTXYEWUBWUEVNVOWVAWUBOWUDW
        VEYGZVDUQZWUEVNWVAPXWSLUQZWUBXYHVNWVAXWSQPLWVAXXAXWSQVMZWVAWYSXXAXXIWUT
        XXJWUSWUTWWJXXJWXLXXJIWUCWWIEXXNUIVUPVUQXEZVURWVANBMVUSZXWSNVQZXVGXXAXY
        JXKWVAWUJXYLAWUJWURWUTUAWRNBMVUTVIZWVAXWRWVJVQXYMWVAWVEWVJWUQWUCWXNWVAW
        URWUQWVEVQZAWURWUTVVAZWUQVVBVVDZVKXWRNNYHVIAXVGWURWUTUGWRNBXWSQMYIXTYJX
        QWVAXYOXYIXYHVNVOZXYQWURWVAXYOXYRYMZXYPWVAUOVBZWVEVQZPXYTWUCUPZXAUPZLUQ
        ZOWUDWBXYTWCUQZYGZVDUQZVNVOZYMZYMWVAWBWVEVQZPWYTLUQZOWUDXUFYGZVDUQZVNVO
        ZYMZYMWVAWXSWVEVQZPWXSWUCUPZXAUPZLUQZOWUDWBWXSWCUQZYGZVDUQZVNVOZYMZYMWV
        AWXSWBXBUQZWVEVQZPYVEWUCUPZXAUPZLUQZOWUDWBYVEWCUQZYGZVDUQZVNVOZYMZYMWVA
        XYSYMUOUKWUQXYTWBVMZYUIYUOWVAYVOYUAYUJYUHYUNXYTWBWVEYNYVOYUDYUKYUGYUMVN
        YVOYUCWYTPLYVOYUBWYPXAXYTWBWUCYEXMXQYVOYUFYULOVDYVOYUEXUFWUDYVOYUEXXOXU
        FXYTWBWBWCYCXXPXPYKXQYLYOYPUOUKYBZYUIYVDWVAYVPYUAYUPYUHYVCXYTWXSWVEYNYV
        PYUDYUSYUGYVBVNYVPYUCYURPLYVPYUBYUQXAXYTWXSWUCYEXMXQYVPYUFYVAOVDYVPYUEY
        UTWUDXYTWXSWBWCYCYKXQYLYOYPXYTYVEVMZYUIYVNWVAYVQYUAYVFYUHYVMXYTYVEWVEYN
        YVQYUDYVIYUGYVLVNYVQYUCYVHPLYVQYUBYVGXAXYTYVEWUCYEXMXQYVQYUFYVKOVDYVQYU
        EYVJWUDXYTYVEWBWCYCYKXQYLYOYPUOKYBZYUIXYSWVAYVRYUAXYOYUHXYRXYTWUQWVEYNY
        VRYUDXYIYUGXYHVNYVRYUCXWSPLYVRYUBXWRXAXYTWUQWUCYEXMXQYVRYUFXYGOVDYVRYUE
        WVEWUDXYTWUQWBWCYCYKXQYLYOYPWVAYUNYUJWVAYUKYUKYUMVNWVAYUKURVQZYUKYUKVNV
        OWVAWVRXVFWYTNVQZYVSAWVRWURWUTUEWRZAXVFWURWUTUFWRZWVAWYPWVJVQZYVTWVAWVE
        WVJWBWUCWXNWVAWUQWBYQUPZVQYUJWVAWUQUTYWDXYPVVNVVCWBWUQVVEVIZVKZWYPNNYHV
        IPWYTLNWQXNYUKVVFVIWVAOUMXUFXWLWUCUPZLUPZVEZVDUQZWYPLUPZYUMYUKWVAXWJWYO
        YWKWVDVQYWJYWKVMAXWJWURWUTXWKWRWYOWVAXGWJWVAWVJWVDWYPLWWHYWFVKYWHWVDYWK
        UMOWBUTWYFXWMYWGWYPLXWLWBWUCYEXMUXTXNWVAYULYWIOVDWVAYULUMWVEYWHVEZXUFYG
        ZYWIWVAWUDYWLXUFWVAWVSWVLWUDYWLVMZWVAWVRWVSYWAWVTVIWXNUMLWUCWVEWVJURVVG
        WNZVVHWVAXUFWVEVPYWMYWIVMWVAWBWVEYWEUWPUMWVEXUFYWHYRVIXRXQWVAYUKPWYTXHZ
        LUPYWKPWYTLXOWVAYWPWYPLWVAWYPWYQWYTXHZYWPWVAYWCWYPYWQVMYWFWYPNNVVIVIWVA
        WYQPWYTWVAWYSWYQPVMZWVAWYSXXAXXIXYKVVJWVAXYLWYQNVQZXVFWYSYWRXKXYNWVAYWC
        YWSYWFWYPNNVVKVIYWBNBWYQPMYIXTYJVVLUYAXMVVOVVMYSVVPWXSUTVQZWVAYVDYVNWVA
        YWTYVDYVNYMWVAYWTVSZYVDYVFYVCYMYVNYXAYVFYUPYVCWVAYWTYVFYUPWVAYWTYVFVSZV
        SZWXSYWDVQZYVFYUPYXCWXSUTYWDWVAYWTYVFVVQVVNVVCZWVAYWTYVFVVRZWXSWBWUQVVS
        WNZVVTVWEYXAYVFYVCYVMWVAYWTYVFYVCYVMYMYXCYVCYVIYVBYVGLUPZWDUQZVNVOZYVMY
        XCYVCYUSYXHWDUQZYXIVNVOZYXJYXCYUSURVQZYVBURVQZYXHURVQZYVCYXLYMYXCWVRXVF
        YURNVQZYXMWVAWVRYXBYWAYTZWVAXVFYXBYWBYTZYXCYUQWVJVQYXPYXCWVEWVJWXSWUCWV
        AWVLYXBWXNYTZYXGVKYUQNNYHVIZPYURLNWQXNZYXCYVBURWVBYXCYUTWVDYVAOWFWGWYFW
        YGWYHYXCWYIWJZYXCWBWXSUULZYXCWVMYUTWVEVPZYUTWVDYVAVHWVAWVMYXBWXOYTYXCYU
        TYVEWAZWVEYXCYUTYYEVWAZYVJWVEYXCYXDYVJYYFVMYXEWBWXSVWBVIZYXCWUQYVEYQUPV
        QZYVJWVEVPYVFYYHWVAYWTYVEWBWUQVWCVWDZYVEWBWUQVWOVIZVWFZVWGZWVEWVDYUTWUD
        VWHWNZYXCYUTWVDWYJYVAYYCYYMUWDUWEUWGZYXCWVJURYVGLYXCWVRWVSYXQWVTVIYXCWV
        EWVJYVEWUCYXSYXFVKZVKZYXMYXNYXOWLYVCYXLYUSYVBYXHVWIVWJXNYXCYVIYXKVNVOZY
        XLYXJYXCYVIYUSYURYVHLUQZWDUQZYXKVNYXCWVRXVFYVHNVQZYXPYVIYYSVNVOYXQYXRYX
        CYVGWVJVQZYYTYYOYVGNNYHVIZYXTPYVHYURLNVWKVWLYXCYXHYYRYUSWDYXCYXHYURYVHX
        HZLUPYYRYXCYVGUUUCLYXCYVGYVGWTUPZYVHXHZUUUCYXCUUUAYVGUUUEVMYYOYVGNNVVIV
        IYXCYURUUUDYVHYXCYURMUPZUUUDMUPZVMZYURUUUDVMZYXCWXSWXJVQZXXIUUUHYXCYXDW
        XIWXSYQUPVQZUUUJYXEYXCWXSUYPVQZYYHUUUKYWTUUULWVAYVFWXSVWMVWNYYIWXSWUQVX
        FWNWXSWBWXIVWPWPWVAXXIYXBWVAWYSXXAXXIXYKVWQYTXXHUUUHJWXSWXJJUKYBZXXDUUU
        FXXGUUUGUUUMXXCYURMUUUMXXBYUQXAWWTWXSWUCYEXMXMUUUMXXFUUUDMUUUMXXEYVGWTU
        UUMWXDYVEWUCWWTWXSWBXBUYTXMXMXMUYJVWRVWSYXCXYLYXPUUUDNVQZUUUHUUUIXKWVAX
        YLYXBXYNYTYXTYXCUUUAUUUNYYOYVGNNVVKVINBYURUUUDMYIXTYJVVLVWTXMYURYVHLXOV
        LXQYSYXCYVIURVQZYXKURVQYXIURVQYYQYXLVSYXJYMYXCWVRXVFYYTUUUOYXQYXRUUUBPY
        VHLNWQXNYXCYUSYXHYYAYYPVXAYXCYVBYXHYYNYYPVXAYVIYXKYXIVXBXNVXCVXDYXCYVLY
        XIYVIVNYXCOUMYYFYWHVEZVDUQOUMYUTYWHVEZVDUQZYXHWDUQYVLYXIYXCYUTWVDWDUMOY
        VEWVEYWHYXHWYFWVDWEVQWDOVXEUPVMWVDURVXGWVIVXHWVDWDVAOWEUHWIVXIXFYYBYYCY
        XCXWLYUTVQZVSWVJWVDYWGLWVAWVKYXBUUUSWWHWRUUUSYXCXWLYVJVQZYWGWVJVQXWLWBW
        XSVXJYXCUUUTVSWVEWVJXWLWUCWVAWVLYXBUUUTWXNWRYXCYVJWVEXWLYYJUVGVKVXKVKYX
        FYXCYUTYYEVXPYDVMZYVEYUTVQVXLUUVAYXCWBWXSVXMWJYUTYVEVXNVVDYXCWVJWVDYVGL
        WVAWVKYXBWWHYTYYOVKXWLYVEVMYWGYVGLXWLYVEWUCYEXMVXOYXCYVKUUUPOVDYXCYVKYW
        LYYFYGZUUUPYXCWUDYWLYVJYYFWVAYWNYXBYWOYTZYYGVXQYXCYYFWVEVPUUVBUUUPVMYYK
        UMWVEYYFYWHYRVIXRXQYXCYVBUUURYXHWDYXCYVAUUUQOVDYXCYVAYWLYUTYGZUUUQYXCWU
        DYWLYUTUUVCVVHYXCYYDUUVDUUUQVMYYLUMWVEYUTYWHYRVIXRXQVXRVVMVXSVXTVVTVYAV
        XDVYGVYAVYBVYCVYDVYEWVAWUEWVCXYHWYEWVAXYGWUDOVDWVAWVMWUDWVEUUNXYGWUDVMW
        XOWVEWVDWUDUUQWVEWUDVYFUURXQVWTYSXXSWUEWUBVNVYHVYIVYJVYOVYJVYOVYKAWUOXV
        SWUNXYAXKWYLXWAUNFWUBVYLWNXLAWUAURVQZXVSWULWUMWUNVSXKAWUOUUVEWYLFVYMVIX
        WAWUAWUBVYNWNVYPXR $.
    $}

    $( The distance function is transferred across an image structure under a
       bijection.  (Contributed by Mario Carneiro, 20-Aug-2015.) $)
    imasdsf1o $p |- ( ph -> ( ( F ` X ) D ( F ` Y ) ) = ( X E Y ) ) $=
      ( vh vn vi vg c1 cfv c1st wceq c2nd caddc cmin cfz wral w3a cxp cmap crab
      cv co cn cxrs ccom cgsu cmpt crn ciun cxr cmnf csn cdif eqid imasdsf1olem
      cress ) ABCDUEUAURZUFUGUFGUFIGUFUHUBURZVNUFUIUFGUFJGUFUHUCURZVNUFUIUFGUFV
      PUEUJUSVNUFUGUFGUFUHUCUEVOUEUKUSULUSUMUNUAHHUOUEVOULUSUPUSUQZUBUTUDVQVAFU
      DURVBVCUSVDVEVFZEUDUAUCUBFGHVAVGVHVIVJVMUSZIJKLMNOPQRSTVSVKVQVKVRVKVL $.
  $}

  ${
    $d a b x y z B $.  $d a b c x y z D $.  $d a b c x y z F $.  $d a b c ph $.
    $d a b c x y z V $.
    imasf1oxmet.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasf1oxmet.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasf1oxmet.f $e |- ( ph -> F : V -1-1-onto-> B ) $.
    imasf1oxmet.r $e |- ( ph -> R e. Z ) $.
    imasf1oxmet.e $e |- E = ( ( dist ` R ) |` ( V X. V ) ) $.
    imasf1oxmet.d $e |- D = ( dist ` U ) $.
    ${
      imasf1oxmet.m $e |- ( ph -> E e. ( *Met ` V ) ) $.
      $( The image of an extended metric is an extended metric.  (Contributed
         by Mario Carneiro, 20-Aug-2015.) $)
      imasf1oxmet $p |- ( ph -> D e. ( *Met ` B ) ) $=
        ( vy co wceq wral vx vz va vb vc cxmt cfv wcel cxp cxr wf cv cc0 wb cle
        cxad wbr wa wfn cds wf1o wfo f1ofo syl imasdsfn cimas adantr cbs simprl
        eqid simprr imasdsf1o xmetcl 3expb sylan eqeltrd ralrimivva f1ofn oveq2
        crn eleq1d ralrn forn raleqdv bitr3d ralbidv mpbid oveq1 ffnov sylanbrc
        xmeteq0 syl3anc eqeq1d wf1 f1of1 f1fveq 3bitr4d simpr xmettri2 syl13anc
        oveq12d 3brtr4d ralrimiva breq2d jca eqeq2 bibi12d oveq2d breq12d eqeq1
        anbi12d oveq1d cvv elfvexd fornex sylc isxmet mpbir2and ) ACBUFUGUHZBBU
        IZUJCUKZUAULZQULZCRZUMSZYBYCSZUNZYDUBULZYBCRZYHYCCRZUPRZUOUQZUBBTZURZQB
        TZUABTZACXTUSYDUJUHZQBTZUABTZYAABCDEDUTUGZGHIJKAHBGVAZHBGVBZLHBGVCVDZMY
        TVJOVEAUCULZGUGZYCCRZUJUHZQBTZUCHTZYSAUUEUDULZGUGZCRZUJUHZUDHTZUCHTUUIA
        UUMUCUDHHAUUDHUHZUUJHUHZURZURZUULUUDUUJFRZUJUURBCDEFGHUUDUUJIAEGDVFRSZU
        UQJVGZAHDVHUGSZUUQKVGZAUUAUUQLVGZADIUHZUUQMVGZNOAFHUFUGUHZUUQPVGZAUUOUU
        PVIZAUUOUUPVKZVLZAUVGUUQUUSUJUHZPUVGUUOUUPUVLUUDUUJFHVMVNVOVPVQAUUNUUHU
        CHAUUGQGVTZTZUUNUUHAGHUSZUVNUUNUNAUUAUVOLHBGVRVDZUUGUUMQUDHGYCUUKSZUUFU
        ULUJYCUUKUUECVSZWAWBVDAUUGQUVMBAUUBUVMBSUUCHBGWCVDZWDWEWFWGAYRUAUVMTZUU
        IYSAUVOUVTUUIUNUVPYRUUHUAUCHGYBUUESZYQUUGQBUWAYDUUFUJYBUUEYCCWHZWAWFWBV
        DAYRUAUVMBUVSWDWEWGUAQBBUJCWIWJAUUFUMSZUUEYCSZUNZUUFYHUUECRZYJUPRZUOUQZ
        UBBTZURZQBTZUCHTZYPAUULUMSZUUEUUKSZUNZUULUWFYHUUKCRZUPRZUOUQZUBBTZURZUD
        HTZUCHTUWLAUWTUCUDHHUURUWOUWSUURUUSUMSZUUDUUJSZUWMUWNUURUVGUUOUUPUXBUXC
        UNUVHUVIUVJUUDUUJFHWKWLUURUULUUSUMUVKWMAHBGWNZUUQUWNUXCUNAUUAUXDLHBGWOV
        DHBUUDUUJGWPVOWQUURUULUEULZGUGZUUECRZUXFUUKCRZUPRZUOUQZUEHTZUWSUURUXJUE
        HUURUXEHUHZURZUUSUXEUUDFRZUXEUUJFRZUPRZUULUXIUOUXMUVGUXLUUOUUPUUSUXPUOU
        QUURUVGUXLUVHVGZUURUXLWRZUURUUOUXLUVIVGZUURUUPUXLUVJVGZUUDUUJUXEFHWSWTU
        URUULUUSSUXLUVKVGUXMUXGUXNUXHUXOUPUXMBCDEFGHUXEUUDIUURUUTUXLUVAVGZUURUV
        BUXLUVCVGZUURUUAUXLUVDVGZUURUVEUXLUVFVGZNOUXQUXRUXSVLUXMBCDEFGHUXEUUJIU
        YAUYBUYCUYDNOUXQUXRUXTVLXAXBXCAUXKUWSUNUUQAUWRUBUVMTZUXKUWSAUVOUYEUXKUN
        UVPUWRUXJUBUEHGYHUXFSZUWQUXIUULUOUYFUWFUXGUWPUXHUPYHUXFUUECWHYHUXFUUKCW
        HXAXDWBVDAUWRUBUVMBUVSWDWEVGWGXEVQAUXAUWKUCHAUWJQUVMTZUXAUWKAUVOUYGUXAU
        NUVPUWJUWTQUDHGUVQUWEUWOUWIUWSUVQUWCUWMUWDUWNUVQUUFUULUMUVRWMYCUUKUUEXF
        XGUVQUWHUWRUBBUVQUUFUULUWGUWQUOUVRUVQYJUWPUWFUPYCUUKYHCVSXHXIWFXKWBVDAU
        WJQUVMBUVSWDWEWFWGAYOUAUVMTZUWLYPAUVOUYHUWLUNUVPYOUWKUAUCHGUWAYNUWJQBUW
        AYGUWEYMUWIUWAYEUWCYFUWDUWAYDUUFUMUWBWMYBUUEYCXJXGUWAYLUWHUBBUWAYDUUFYK
        UWGUOUWBUWAYIUWFYJUPYBUUEYHCVSXLXIWFXKWFWBVDAYOUAUVMBUVSWDWEWGABXMUHZXS
        YAYPURUNAHXMUHUUBUYIAFUFHPXNUUCHBXMGXOXPUAQUBXMCBXQVDXR $.
    $}

    imasf1omet.m $e |- ( ph -> E e. ( Met ` V ) ) $.
    $( The image of a metric is a metric.  (Contributed by Mario Carneiro,
       21-Aug-2015.) $)
    imasf1omet $p |- ( ph -> D e. ( Met ` B ) ) $=
      ( vy cfv wcel cr vx va vb cxmt cxp wf cme metxmet syl imasf1oxmet cv wral
      wfn co cds wf1o wfo f1ofo eqid imasdsfn wa cimas adantr cbs simprl simprr
      wceq imasdsf1o metcl 3expb sylan eqeltrd ralrimivva wb f1ofn oveq2 eleq1d
      crn ralrn forn raleqdv bitr3d ralbidv mpbid oveq1 ffnov sylanbrc ismet2 )
      ACBUDRSBBUEZTCUFZCBUGRSABCDEFGHIJKLMNOAFHUGRSZFHUDRSZPFHUHUIZUJACWIUMUAUK
      ZQUKZCUNZTSZQBULZUABULZWJABCDEDUORZGHIJKAHBGUPZHBGUQZLHBGURUIZMWTUSOUTAUB
      UKZGRZWOCUNZTSZQBULZUBHULZWSAXEUCUKZGRZCUNZTSZUCHULZUBHULXIAXMUBUCHHAXDHS
      ZXJHSZVAZVAZXLXDXJFUNZTXRBCDEFGHXDXJIAEGDVBUNVGXQJVCAHDVDRVGXQKVCAXAXQLVC
      ADISXQMVCNOAWLXQWMVCAXOXPVEAXOXPVFVHAWKXQXSTSZPWKXOXPXTXDXJFHVIVJVKVLVMAX
      NXHUBHAXGQGVRZULZXNXHAGHUMZYBXNVNAXAYCLHBGVOUIZXGXMQUCHGWOXKVGXFXLTWOXKXE
      CVPVQVSUIAXGQYABAXBYABVGXCHBGVTUIZWAWBWCWDAWRUAYAULZXIWSAYCYFXIVNYDWRXHUA
      UBHGWNXEVGZWQXGQBYGWPXFTWNXEWOCWEVQWCVSUIAWRUAYABYEWAWBWDUAQBBTCWFWGCBWHW
      G $.
  $}

  ${
    $d k x y A $.  $d x M $.  $d x N $.  $d k x ph $.  $d k x R $.  $d k x S $.
    $d k x y B $.  $d k x y C $.  $d k x y D $.  $d x y X $.  $d x y Y $.
    $d x W $.
    xpsds.t $e |- T = ( R Xs. S ) $.
    xpsds.x $e |- X = ( Base ` R ) $.
    xpsds.y $e |- Y = ( Base ` S ) $.
    xpsds.1 $e |- ( ph -> R e. V ) $.
    xpsds.2 $e |- ( ph -> S e. W ) $.
    xpsds.p $e |- P = ( dist ` T ) $.
    $( Closure of the metric in a binary structure product.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    xpsdsfn $p |- ( ph -> P Fn ( ( X X. Y ) X. ( X X. Y ) ) ) $=
      ( vx vy csn co eqid cxp csca cfv ccda ccnv cprds cds cmpt2 crn cvv xpsval
      cv xpslem wf1o wfo xpsff1o2 a1i f1ocnv f1ofo 3syl wcel ovex imasdsfn ) AH
      IUAZBCUBUCZCRDRUDSUEZUFSZEVGUGUCZPQHIPULRQULRUDSUEUHZUEZVIUIZUJAPQCDEVGVI
      VEFGHIJKLMNVITZVETZVGTZUKAPQCDEVGVIVEFGHIJKLMNVLVMVNUMAVDVKVIUNZVKVDVJUNV
      KVDVJUOVOAPQHIVIVLUPUQVDVKVIURVKVDVJUSUTVGUJVAAVEVFUFVBUQVHTOVC $.

    $( Closure of the metric in a binary structure product.  (Contributed by
       Mario Carneiro, 20-Aug-2015.) $)
    xpsdsfn2 $p |- ( ph -> P Fn ( ( Base ` T ) X. ( Base ` T ) ) ) $=
      ( cxp wfn cbs cfv xpsdsfn xpsbas xpeq12d fneq2d mpbid ) ABHIPZUEPZQBERSZU
      GPZQABCDEFGHIJKLMNOTAUFUHBAUEUGUEUGACDEFGHIJKLMNUAZUIUBUCUD $.

    xpsds.m $e |- M = ( ( dist ` R ) |` ( X X. X ) ) $.
    xpsds.n $e |- N = ( ( dist ` S ) |` ( Y X. Y ) ) $.
    ${
      xpsds.3 $e |- ( ph -> M e. ( *Met ` X ) ) $.
      xpsds.4 $e |- ( ph -> N e. ( *Met ` Y ) ) $.
      $( Lemma for ~ xpsxmet .  (Contributed by Mario Carneiro,
         21-Aug-2015.) $)
      xpsxmetlem $p |- ( ph ->
        ( dist ` ( ( Scalar ` R ) Xs_ `' ( { R } +c { S } ) ) ) e.
        ( *Met ` ran ( x e. X , y e. Y |-> `' ( { x } +c { y } ) ) ) ) $=
        ( vk csca cfv c2o cv csn ccda co ccnv cmpt cprds cds cbs cxmt cmpt2 crn
        cxp cres cvv con0 eqid wcel fvex a1i 2on wa c0 wceq c1o cpr elpri df2o3
        eleq2s adantr fveq2 xpsc0 syl sylan9eqr fveq2d syl6eqr xpeq12d reseq12d
        wo 3eltr4d xpsc1 jaodan sylan2 prdsxmet wfn xpscfn syl2anc dffn5 oveq2d
        sylib xpslem eqtrd ) AEUEUFZUDUGUDUHZEUIFUIUJUKULZUFZUMZUNUKZUOUFZXEUPU
        FZUQUFWTXBUNUKZUOUFBCLMBUHUICUHUIUJUKULURZUSZUQUFAUDXGXFXCWTXCUOUFZXCUP
        UFZXLUTZVAZUGXLVBVCXEVBXEVDXGVDXLVDXNVDXFVDWTVBVEAEUEVFVGUGVCVEAVHVGXCV
        BVEAXAUGVEZVIXAXBVFVGXOAXAVJVKZXAVLVKZWFZXNXLUQUFZVEZXRXAVJVLVMUGXAVJVL
        VNVOVPAXPXTXQAXPVIZHLUQUFZXNXSAHYBVEXPUBVQYAXNEUOUFZLLUTZVAHYAXKYCXMYDY
        AXCEUOXPAXCVJXBUFZEXAVJXBVRAEJVEZYEEVKQEFJVSVTWAZWBYAXLLXLLYAXLEUPUFLYA
        XCEUPYGWBOWCZYHWDWETWCYAXLLUQYHWBWGAXQVIZIMUQUFZXNXSAIYJVEXQUCVQYIXNFUO
        UFZMMUTZVAIYIXKYKXMYLYIXCFUOXQAXCVLXBUFZFXAVLXBVRAFKVEZYMFVKREFKWHVTWAZ
        WBYIXLMXLMYIXLFUPUFMYIXCFUPYOWBPWCZYPWDWEUAWCYIXLMUQYPWBWGWIWJWKAXHXEUO
        AXBXDWTUNAXBUGWLZXBXDVKAYFYNYQQREFJKWMWNUDUGXBWOWQWPZWBAXJXGUQAXJXHUPUF
        XGABCEFGXHXIWTJKLMNOPQRXIVDWTVDXHVDWRAXHXEUPYRWBWSWBWG $.

      $( A product metric of extended metrics is an extended metric.
         (Contributed by Mario Carneiro, 21-Aug-2015.) $)
      xpsxmet $p |- ( ph -> P e. ( *Met ` ( X X. Y ) ) ) $=
        ( vx vy cxp csca cfv csn ccda co ccnv cprds cds cmpt2 crn cres cvv eqid
        cv xpsval xpslem wf1o xpsff1o2 f1ocnv mp1i wcel ovex a1i wss xpsxmetlem
        cxmt ssid xmetres2 sylancl imasf1oxmet ) AJKUDZBCUEUFZCUGDUGUHUIUJZUKUI
        ZEVRULUFZUBUCJKUBURUGUCURUGUHUIUJUMZUNZWAUDUOZVTUJZWAUPAUBUCCDEVRVTVPHI
        JKLMNOPVTUQZVPUQZVRUQZUSAUBUCCDEVRVTVPHIJKLMNOPWDWEWFUTVOWAVTVAWAVOWCVA
        AUBUCJKVTWDVBVOWAVTVCVDVRUPVEAVPVQUKVFVGWBUQQAVSWAVJUFZVEWAWAVHWBWGVEAU
        BUCBCDEFGHIJKLMNOPQRSTUAVIWAVKVSWAWAVLVMVN $.

      xpsds.a $e |- ( ph -> A e. X ) $.
      xpsds.b $e |- ( ph -> B e. Y ) $.
      xpsds.c $e |- ( ph -> C e. X ) $.
      xpsds.d $e |- ( ph -> D e. Y ) $.
      $( Value of the metric in a binary structure product.  (Contributed by
         Mario Carneiro, 20-Aug-2015.) $)
      xpsdsval $p |- ( ph -> ( <. A , B >. P <. C , D >. ) =
        sup ( { ( A M C ) , ( B N D ) } , RR* , < ) ) $=
        ( vx vy vk csn ccda co ccnv cv cmpt2 cfv csca cprds cds cop cpr cxr clt
        csup crn cxp cres cvv eqid xpsval xpslem wf1o xpsff1o2 f1ocnv mp1i wcel
        ovex a1i cxmt wss xpsxmetlem ssid xmetres2 sylancl wceq xpsfval syl2anc
        df-ov syl5eqr opelxpi f1of ax-mp ffvelrni syl eqeltrrd imasdsf1o ovresd
        wf eqtrd wi f1ocnvfv sylancr mpd oveq12d c2o cmpt cc0 cun cbs con0 fvex
        2on wfn xpscfn eleqtrd prdsdsval wrex wo c0 c1o df2o3 rexeqi 0ex fveq2d
        fveq2 eqeq2d xpsc0 oveqi syl5eq eqtr4d xpsc1 cle wbr 0xr xmetcl syl3anc
        oveq123d 1on elexi rexpr bitri orbi12d syl5bb wb vex elrnmpt elpr eqrdv
        3bitr4g uneq1d uncom syl6eq supeq1d snssd prssi wor supsn mp2an supxrcl
        xrltso xmetge0 prid1 supxrub xrletrd syl5eqbr supxrun 3eqtrd 3eqtr3d )
        ABUMCUMUNUOUPZUJUKNOUJUQZUMUKUQUMUNUOUPURZUPZUSZDUMEUMUNUOUPZUVOUSZFUOZ
        UVLUVQGUTUSZGUMHUMUNUOUPZVAUOZVBUSZUOZBCVCZDEVCZFUOBDJUOZCEKUOZVDZVEVFV
        GZAUVSUVLUVQUWCUVNVHZUWKVIVJZUOUWDANOVIZFUWBIUWLUVOUWKUVLUVQVKAUJUKGHIU
        WBUVNUVTLMNOPQRSTUVNVLZUVTVLZUWBVLZVMAUJUKGHIUWBUVNUVTLMNOPQRSTUWNUWOUW
        PVNZUWMUWKUVNVOZUWKUWMUVOVOAUJUKNOUVNUWNVPZUWMUWKUVNVQVRUWBVKVSAUVTUWAV
        AVTWAUWLVLUAAUWCUWKWBUSZVSUWKUWKWCUWLUWTVSAUJUKFGHIJKLMNOPQRSTUAUBUCUDU
        EWDUWKWEUWCUWKUWKWFWGAUWEUVNUSZUVLUWKAUXABCUVNUOZUVLBCUVNWKABNVSZCOVSZU
        XBUVLWHUFUGUJUKNOUVNBCUWNWIWJWLZAUWEUWMVSZUXAUWKVSAUXCUXDUXFUFUGBCNOWMW
        JZUWMUWKUWEUVNUWRUWMUWKUVNXAUWSUWMUWKUVNWNWOZWPWQWRZAUWFUVNUSZUVQUWKAUX
        JDEUVNUOZUVQDEUVNWKADNVSZEOVSZUXKUVQWHUHUIUJUKNOUVNDEUWNWIWJWLZAUWFUWMV
        SZUXJUWKVSAUXLUXMUXOUHUIDENOWMWJZUWMUWKUWFUVNUXHWPWQWRZWSAUVLUVQUWCUWKU
        XIUXQWTXBAUVPUWEUVRUWFFAUXAUVLWHZUVPUWEWHZUXEAUWRUXFUXRUXSXCUWSUXGUWMUW
        KUWEUVLUVNXDXEXFAUXJUVQWHZUVRUWFWHZUXNAUWRUXOUXTUYAXCUWSUXPUWMUWKUWFUVQ
        UVNXDXEXFXGAUWDULXHULUQZUVLUSZUYBUVQUSZUYBUWAUSZVBUSZUOZXIZVHZXJUMZXKZV
        EVFVGUYJUWIXKZVEVFVGZUWJAULUWBXLUSZUWCUWAUVTUVLUVQXHVKXMUWBUWPUYNVLUVTV
        KVSAGUTXNWAXHXMVSAXOWAAGLVSZHMVSZUWAXHXPSTGHLMXQWJAUVLUWKUYNUXIUWQXRAUV
        QUWKUYNUXQUWQXRUWCVLXSAVEUYKUYLVFAUYKUWIUYJXKUYLAUYIUWIUYJAUJUYIUWIAUVM
        UYGWHZULXHXTZUVMUWGWHZUVMUWHWHZYAZUVMUYIVSZUVMUWIVSUYRUVMYBUVLUSZYBUVQU
        SZYBUWAUSZVBUSZUOZWHZUVMYCUVLUSZYCUVQUSZYCUWAUSZVBUSZUOZWHZYAZAVUAUYRUY
        QULYBYCVDZXTVUOUYQULXHVUPYDYEUYQVUHVUNULYBYCYFYCXMUUAUUBUYBYBWHZUYGVUGU
        VMVUQUYCVUCUYDVUDUYFVUFVUQUYEVUEVBUYBYBUWAYHYGUYBYBUVLYHUYBYBUVQYHYTYIU
        YBYCWHZUYGVUMUVMVURUYCVUIUYDVUJUYFVULVURUYEVUKVBUYBYCUWAYHYGUYBYCUVLYHU
        YBYCUVQYHYTYIUUCUUDAVUHUYSVUNUYTAVUGUWGUVMAVUGBDGVBUSZUOZUWGAVUCBVUDDVU
        FVUSAVUEGVBAUYOVUEGWHSGHLYJWQYGAUXCVUCBWHUFBCNYJWQAUXLVUDDWHUHDENYJWQYT
        AUWGBDVUSNNVIVJZUOVUTJVVABDUBYKABDVUSNUFUHWTYLYMYIAVUMUWHUVMAVUMCEHVBUS
        ZUOZUWHAVUICVUJEVULVVBAVUKHVBAUYPVUKHWHTGHMYNWQYGAUXDVUICWHUGBCOYNWQAUX
        MVUJEWHUIDEOYNWQYTAUWHCEVVBOOVIVJZUOVVCKVVDCEUCYKACEVVBOUGUIWTYLYMYIUUE
        UUFUVMVKVSVUBUYRUUGUJUUHZULXHUYGUVMUYHVKUYHVLUUIWOUVMUWGUWHVVEUUJUULUUK
        UUMUWIUYJUUNUUOUUPAUYJVEWCUWIVEWCZUYJVEVFVGZUWJYOYPUYMUWJWHAXJVEXJVEVSZ
        AYQWAZUUQAUWGVEVSZUWHVEVSZVVFAJNWBUSVSZUXCUXLVVJUDUFUHBDJNYRYSZAKOWBUSV
        SUXDUXMVVKUEUGUICEKOYRYSUWGUWHVEUURWJZAVVGXJUWJYOVEVFUUSVVHVVGXJWHUVCYQ
        VEXJVFUUTUVAAXJUWGUWJVVIVVMAVVFUWJVEVSVVNUWIUVBWQAVVLUXCUXLXJUWGYOYPUDU
        FUHBDJNUVDYSAVVFUWGUWIVSUWGUWJYOYPVVNUWGUWHBDJVTUVEUWIUWGUVFWGUVGUVHUYJ
        UWIUVIYSUVJUVK $.
    $}

    ${
      xpsmet.3 $e |- ( ph -> M e. ( Met ` X ) ) $.
      xpsmet.4 $e |- ( ph -> N e. ( Met ` Y ) ) $.
      $( The direct product of two metric spaces.  Definition 14-1.5 of
         [Gleason] p. 225.  (Contributed by NM, 20-Jun-2007.)  (Revised by
         Mario Carneiro, 20-Aug-2015.) $)
      xpsmet $p |- ( ph -> P e. ( Met ` ( X X. Y ) ) ) $=
        ( vx vy vk cxp csca cfv csn ccda co ccnv cprds cds cv crn cres cvv eqid
        cmpt2 xpsval xpslem wf1o xpsff1o2 f1ocnv mp1i wcel ovex a1i cme wss c2o
        cmpt cbs fvex com cfn 2onn nnfi wa c0 wceq wo elpri df2o3 eleq2s adantr
        c1o cpr fveq2 xpsc0 syl sylan9eqr fveq2d syl6eqr xpeq12d reseq12d xpsc1
        3eltr4d jaodan sylan2 prdsmet wfn xpscfn syl2anc dffn5 sylib eqtrd ssid
        oveq2d metres2 sylancl imasf1omet ) AJKUEZBCUFUGZCUHDUHUIUJUKZULUJZEXPU
        MUGZUBUCJKUBUNUHUCUNUHUIUJUKUSZUOZXSUEUPZXRUKZXSUQAUBUCCDEXPXRXNHIJKLMN
        OPXRURZXNURZXPURZUTAUBUCCDEXPXRXNHIJKLMNOPYBYCYDVAZXMXSXRVBXSXMYAVBAUBU
        CJKXRYBVCXMXSXRVDVEXPUQVFAXNXOULVGVHXTURQAXQXSVIUGZVFXSXSVJXTYFVFAXNUDV
        KUDUNZXOUGZVLZULUJZUMUGZYJVMUGZVIUGXQYFAUDYLYKYHXNYHUMUGZYHVMUGZYNUEZUP
        ZVKYNUQYJUQYJURYLURYNURYPURYKURXNUQVFACUFVNVHVKVOVFVKVPVFAVQVKVRVEYHUQV
        FAYGVKVFZVSYGXOVNVHYQAYGVTWAZYGWGWAZWBZYPYNVIUGZVFZYTYGVTWGWHVKYGVTWGWC
        WDWEAYRUUBYSAYRVSZFJVIUGZYPUUAAFUUDVFYRTWFUUCYPCUMUGZJJUEZUPFUUCYMUUEYO
        UUFUUCYHCUMYRAYHVTXOUGZCYGVTXOWIACHVFZUUGCWAOCDHWJWKWLZWMUUCYNJYNJUUCYN
        CVMUGJUUCYHCVMUUIWMMWNZUUJWOWPRWNUUCYNJVIUUJWMWRAYSVSZGKVIUGZYPUUAAGUUL
        VFYSUAWFUUKYPDUMUGZKKUEZUPGUUKYMUUMYOUUNUUKYHDUMYSAYHWGXOUGZDYGWGXOWIAD
        IVFZUUODWAPCDIWQWKWLZWMUUKYNKYNKUUKYNDVMUGKUUKYHDVMUUQWMNWNZUURWOWPSWNU
        UKYNKVIUURWMWRWSWTXAAXPYJUMAXOYIXNULAXOVKXBZXOYIWAAUUHUUPUUSOPCDHIXCXDU
        DVKXOXEXFXIZWMAXSYLVIAXSXPVMUGYLYEAXPYJVMUUTWMXGWMWRXSXHXQXSXSXJXKXL $.
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Metric space balls
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d d r x y D $.  $d d r x y X $.
    $( The value of the ball function.  (Contributed by NM, 30-Aug-2006.)
       (Revised by Mario Carneiro, 11-Nov-2013.)  (Revised by Thierry Arnoux,
       11-Feb-2018.) $)
    blfvalps $p |- ( D e. ( PsMet ` X ) -> ( ball ` D ) =
      ( x e. X , r e. RR* |-> { y e. X | ( x D y ) < r } ) ) $=
      ( vd cpsmet wcel cv cdm cxr co clt wbr crab cmpt2 cvv cbl wceq wa cfv a1i
      cmpt df-bl dmeq dmeqd psmetdmdm eqcomd sylan9eqr eqidd simpr oveqd breq1d
      rabeqbidv mpt2eq123dv elex cxp cpw wf wral ssrab2 wb elfvdm adantr elpw2g
      wss syl ralrimivva eqid fmpt2 sylib xrex xpexg sylancl pwexg fex2 syl3anc
      mpbiri fvmptd ) CDGUAZHZFCAEFIZJZJZKAIZBIZWBLZEIZMNZBWDOZPZAEDKWEWFCLZWHM
      NZBDOZPZQRQRFQWKUCSWAABEFUDUBWAWBCSZTZAEWDKWJDKWNWPWAWDCJZJZDWPWCWRWBCUEU
      FWADWSCDUGUHUIZWQKUJWQWIWMBWDDWTWQWGWLWHMWQWBCWEWFWAWPUKULUMUNUOCVTUPWADK
      UQZDURZWOUSZXAQHZXBQHZWOQHWAWNXBHZEKUTADUTXCWAXFAEDKWAWEDHWHKHTZTZXFWNDVF
      ZWMBDVAXHDGJZHZXFXIVBWAXKXGCDGVCZVDWNDXJVEVGVRVHAEDKWNXBWOWOVIVJVKWAXKKQH
      XDXLVLDKXJQVMVNWAXKXEXLDXJVOVGXAXBWOQQVPVQVS $.

    $( The value of the ball function.  (Contributed by NM, 30-Aug-2006.)
       (Revised by Mario Carneiro, 11-Nov-2013.)  (Proof shortened by Thierry
       Arnoux, 11-Feb-2018.) $)
    blfval $p |- ( D e. ( *Met ` X ) -> ( ball ` D ) =
      ( x e. X , r e. RR* |-> { y e. X | ( x D y ) < r } ) ) $=
      ( cxmt cfv wcel cpsmet cbl cxr cv co clt wbr crab wceq xmetpsmet blfvalps
      cmpt2 syl ) CDFGHCDIGHCJGAEDKALBLCMELNOBDPTQCDRABCDESUA $.
  $}

  ${
    $d x A $.  $d r x y z B $.  $d r x y P $.  $d x ph $.  $d x Q $.  $d x S $.
    $d r x y z D $.  $d r x y R $.  $d r x y z X $.
    $( The ball around a point ` P ` is the set of all points whose distance
       from ` P ` is less than the ball's radius ` R ` .  (Contributed by NM,
       31-Aug-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.)  (Revised by
       Thierry Arnoux, 11-Mar-2018.) $)
    blvalps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X /\ R e. RR* ) ->
                  ( P ( ball ` D ) R ) = { x e. X | ( P D x ) < R } ) $=
      ( vy vr cpsmet cfv wcel cxr cv co clt wbr crab cvv wceq 3ad2ant1 wa cmpt2
      w3a cbl blfvalps simprl oveq1d simprr breq12d rabbidv simp2 elfvdm rabexg
      simp3 cdm syl ovmpt2d ) BEHIJZCEJZDKJZUBZFGCDEKFLZALZBMZGLZNOZAEPZCVBBMZD
      NOZAEPZBUCIZQUQURVJFGEKVFUARUSFABEGUDSUTVACRZVDDRZTTZVEVHAEVMVCVGVDDNVMVA
      CVBBUTVKVLUEUFUTVKVLUGUHUIUQURUSUJUQURUSUMUTEHUNZJZVIQJUQURVOUSBEHUKSVHAE
      VNULUOUP $.

    $( The ball around a point ` P ` is the set of all points whose distance
       from ` P ` is less than the ball's radius ` R ` .  (Contributed by NM,
       31-Aug-2006.)  (Revised by Mario Carneiro, 11-Nov-2013.) $)
    blval $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
                  ( P ( ball ` D ) R ) = { x e. X | ( P D x ) < R } ) $=
      ( vy vr cxmt cfv wcel cxr cv co clt wbr crab cvv wceq 3ad2ant1 wa w3a cbl
      cmpt2 blfval simprl oveq1d simprr breq12d rabbidv simp2 cdm elfvdm rabexg
      simp3 syl ovmpt2d ) BEHIJZCEJZDKJZUAZFGCDEKFLZALZBMZGLZNOZAEPZCVBBMZDNOZA
      EPZBUBIZQUQURVJFGEKVFUCRUSFABEGUDSUTVACRZVDDRZTTZVEVHAEVMVCVGVDDNVMVACVBB
      UTVKVLUEUFUTVKVLUGUHUIUQURUSUJUQURUSUNUTEHUKZJZVIQJUQURVOUSBEHULSVHAEVNUM
      UOUP $.

    $( Membership in a ball.  (Contributed by NM, 2-Sep-2006.)  (Revised by
       Mario Carneiro, 11-Nov-2013.)  (Revised by Thierry Arnoux,
       11-Mar-2018.) $)
    elblps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X /\ R e. RR* ) ->
             ( A e. ( P ( ball ` D ) R ) <-> ( A e. X /\ ( P D A ) < R ) ) ) $=
      ( vx cpsmet cfv wcel cxr w3a cbl co cv clt wbr crab wa blvalps eleq2d
      wceq oveq2 breq1d elrab syl6bb ) BEGHICEIDJIKZACDBLHMZIACFNZBMZDOPZFEQZIA
      EICABMZDOPZRUFUGUKAFBCDESTUJUMFAEUHAUAUIULDOUHACBUBUCUDUE $.

    $( Membership in a ball.  (Contributed by NM, 2-Sep-2006.)  (Revised by
       Mario Carneiro, 11-Nov-2013.) $)
    elbl $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
             ( A e. ( P ( ball ` D ) R ) <-> ( A e. X /\ ( P D A ) < R ) ) ) $=
      ( vx cxmt cfv wcel cxr w3a cbl co cv clt wbr crab wa blval eleq2d breq1d
      wceq oveq2 elrab syl6bb ) BEGHICEIDJIKZACDBLHMZIACFNZBMZDOPZFEQZIAEICABMZ
      DOPZRUFUGUKAFBCDESTUJUMFAEUHAUBUIULDOUHACBUCUAUDUE $.

    $( Membership in a ball.  (Contributed by NM, 9-Mar-2007.)  (Revised by
       Thierry Arnoux, 11-Mar-2018.) $)
    elbl2ps $p |- ( ( ( D e. ( PsMet ` X ) /\ R e. RR* ) /\ ( P e. X /\
      A e. X ) ) -> ( A e. ( P ( ball ` D ) R ) <-> ( P D A ) < R ) ) $=
      ( cpsmet cfv wcel cxr wa cbl co clt wbr elblps 3expa an32s adantrr simprr
      wb biantrurd bitr4d ) BEFGHZDIHZJZCEHZAEHZJJZACDBKGLHZUGCABLDMNZJZUJUEUFU
      IUKTZUGUCUFUDULUCUFUDULABCDEOPQRUHUGUJUEUFUGSUAUB $.

    $( Membership in a ball.  (Contributed by NM, 9-Mar-2007.) $)
    elbl2 $p |- ( ( ( D e. ( *Met ` X ) /\ R e. RR* ) /\ ( P e. X /\
      A e. X ) ) -> ( A e. ( P ( ball ` D ) R ) <-> ( P D A ) < R ) ) $=
      ( cxmt cfv wcel cxr wa cbl co clt wbr wb elbl 3expa an32s adantrr simprr
      biantrurd bitr4d ) BEFGHZDIHZJZCEHZAEHZJJZACDBKGLHZUGCABLDMNZJZUJUEUFUIUK
      OZUGUCUFUDULUCUFUDULABCDEPQRSUHUGUJUEUFUGTUAUB $.

    $( Membership in a ball, with reversed distance function arguments.
       (Contributed by NM, 10-Nov-2007.) $)
    elbl3ps $p |- ( ( ( D e. ( PsMet ` X ) /\ R e. RR* ) /\ ( P e. X /\
      A e. X ) ) -> ( A e. ( P ( ball ` D ) R ) <-> ( A D P ) < R ) ) $=
      ( cpsmet cfv wcel cxr wa cbl clt wbr elbl2ps wceq psmetsym adantlr breq1d
      co 3expb bitrd ) BEFGHZDIHZJCEHZAEHZJZJZACDBKGSHCABSZDLMACBSZDLMABCDENUGU
      HUIDLUBUFUHUIOZUCUBUDUEUJCABEPTQRUA $.

    $( Membership in a ball, with reversed distance function arguments.
       (Contributed by NM, 10-Nov-2007.) $)
    elbl3 $p |- ( ( ( D e. ( *Met ` X ) /\ R e. RR* ) /\ ( P e. X /\
      A e. X ) ) -> ( A e. ( P ( ball ` D ) R ) <-> ( A D P ) < R ) ) $=
      ( cxmt cfv wcel cxr wa cbl co clt elbl2 wceq xmetsym 3expb adantlr breq1d
      wbr bitrd ) BEFGHZDIHZJCEHZAEHZJZJZACDBKGLHCABLZDMTACBLZDMTABCDENUGUHUIDM
      UBUFUHUIOZUCUBUDUEUJCABEPQRSUA $.

    $( Commute the arguments to the ball function.  (Contributed by Mario
       Carneiro, 22-Jan-2014.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    blcomps $p |- ( ( ( D e. ( PsMet ` X ) /\ R e. RR* )
        /\ ( P e. X /\ A e. X ) )
      -> ( A e. ( P ( ball ` D ) R ) <-> P e. ( A ( ball ` D ) R ) ) ) $=
      ( cpsmet cfv wcel cxr wa cbl co clt wbr elbl2ps wb elbl3ps ancom2s bitr4d
      ) BEFGHDIHJZCEHZAEHZJJACDBKGZLHCABLDMNZCADUCLHZABCDEOTUBUAUEUDPCBADEQRS
      $.

    $( Commute the arguments to the ball function.  (Contributed by Mario
       Carneiro, 22-Jan-2014.) $)
    blcom $p |- ( ( ( D e. ( *Met ` X ) /\ R e. RR* ) /\ ( P e. X /\ A e. X ) )
      -> ( A e. ( P ( ball ` D ) R ) <-> P e. ( A ( ball ` D ) R ) ) ) $=
      ( cxmt cfv wcel cxr wa cbl co clt wbr elbl2 wb elbl3 ancom2s bitr4d ) BEF
      GHDIHJZCEHZAEHZJJACDBKGZLHCABLDMNZCADUCLHZABCDEOTUBUAUEUDPCBADEQRS $.

    $( The infinity ball in an extended metric is the set of all points that
       are a finite distance from the center.  (Contributed by Mario Carneiro,
       23-Aug-2015.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    xblpnfps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X ) ->
        ( A e. ( P ( ball ` D ) +oo ) <-> ( A e. X /\ ( P D A ) e. RR ) ) ) $=
      ( cpsmet cfv wcel wa cpnf cbl co clt wbr cr cxr wb pnfxr elblps cmnf syl
      w3a wne cc0 cle psmetcl psmetge0 ge0nemnf syl2anc wceq ngtmnft necon2abid
      mp3an3 wn mpbird biantrurd xrrebnd bitr4d 3expa pm5.32da bitrd ) BDEFGZCD
      GZHZACIBJFKGZADGZCABKZILMZHZVEVFNGZHVAVBIOGVDVHPQABCIDRULVCVEVGVIVAVBVEVG
      VIPVAVBVEUAZVGSVFLMZVGHZVIVJVKVGVJVKVFSUBZVJVFOGZUCVFUDMVMCABDUEZCABDUFVF
      UGUHVJVKVFSVJVNVFSUIVKUMPVOVFUJTUKUNUOVJVNVIVLPVOVFUPTUQURUSUT $.

    $( The infinity ball in an extended metric is the set of all points that
       are a finite distance from the center.  (Contributed by Mario Carneiro,
       23-Aug-2015.) $)
    xblpnf $p |- ( ( D e. ( *Met ` X ) /\ P e. X ) ->
        ( A e. ( P ( ball ` D ) +oo ) <-> ( A e. X /\ ( P D A ) e. RR ) ) ) $=
      ( cxmt cfv wcel wa cpnf cbl co clt wbr cr cxr wb pnfxr elbl cmnf syl wceq
      mp3an3 w3a wne cc0 cle xmetcl xmetge0 ge0nemnf syl2anc ngtmnft necon2abid
      wn mpbird biantrurd xrrebnd bitr4d 3expa pm5.32da bitrd ) BDEFGZCDGZHZACI
      BJFKGZADGZCABKZILMZHZVEVFNGZHVAVBIOGVDVHPQABCIDRUBVCVEVGVIVAVBVEVGVIPVAVB
      VEUCZVGSVFLMZVGHZVIVJVKVGVJVKVFSUDZVJVFOGZUEVFUFMVMCABDUGZCABDUHVFUIUJVJV
      KVFSVJVNVFSUAVKUMPVOVFUKTULUNUOVJVNVIVLPVOVFUPTUQURUSUT $.

    $( The infinity ball in a standard metric is just the whole space.
       (Contributed by Mario Carneiro, 23-Aug-2015.) $)
    blpnf $p |- ( ( D e. ( Met ` X ) /\ P e. X ) ->
       ( P ( ball ` D ) +oo ) = X ) $=
      ( vx cme cfv wcel wa cpnf cbl co cv cr cxmt wb metxmet xblpnf sylan metcl
      3expia pm4.71d bitr4d eqrdv ) ACEFGZBCGZHZDBIAJFKZCUFDLZUGGZUHCGZBUHAKMGZ
      HZUJUDACNFGUEUIULOACPUHABCQRUFUJUKUDUEUJUKBUHACSTUAUBUC $.

    $( Two balls are disjoint if the center-to-center distance is more than the
       sum of the radii.  (Contributed by Mario Carneiro, 30-Dec-2013.) $)
    bldisj $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X /\ Q e. X ) /\
      ( R e. RR* /\ S e. RR* /\ ( R +e S ) <_ ( P D Q ) ) )
        -> ( ( P ( ball ` D ) R ) i^i ( Q ( ball ` D ) S ) ) = (/) ) $=
      ( vx cfv wcel w3a cxr cxad co wbr wa clt wb xmetcl adantr syl3anc cle cbl
      cxmt cv wn simpr3 simpr1 simpr2 xaddcld xrlenlt syl2anc mpbid elin simpl1
      simpl2 elbl simpl3 anbi12d anandi syl6bbr simpr xlt2add syl22anc xmettri3
      cin wi syl13anc xrlelttr mpand syld expimpd sylbid syl5bi mtod eq0rdv ) A
      FUCHIZBFIZCFIZJZDKIZEKIZDELMZBCAMZUANZJZOZGBDAUBHZMZCEWGMZVEZWFGUDZWJIZWC
      WBPNZWFWDWMUEZVSVTWAWDUFWFWBKIZWCKIZWDWNQWFDEVSVTWAWDUGZVSVTWAWDUHZUIZVSW
      PWEBCAFRSZWBWCUJUKULWLWKWHIZWKWIIZOZWFWMWKWHWIUMWFXCWKFIZBWKAMZDPNZCWKAMZ
      EPNZOZOZWMWFXCXDXFOZXDXHOZOXJWFXAXKXBXLWFVPVQVTXAXKQVPVQVRWEUNZVPVQVRWEUO
      ZWQWKABDFUPTWFVPVRWAXBXLQXMVPVQVRWEUQZWRWKACEFUPTURXDXFXHUSUTWFXDXIWMWFXD
      OZXIXEXGLMZWBPNZWMXPXEKIZXGKIZVTWAXIXRVFXPVPVQXDXSWFVPXDXMSZWFVQXDXNSZWFX
      DVAZBWKAFRTZXPVPVRXDXTYAWFVRXDXOSZYCCWKAFRTZWFVTXDWQSWFWAXDWRSXEXGDEVBVCX
      PWCXQUANZXRWMXPVPVQVRXDYGYAYBYEYCBCWKAFVDVGXPWPXQKIWOYGXROWMVFWFWPXDWTSXP
      XEXGYDYFUIWFWOXDWSSWCXQWBVHTVIVJVKVLVMVNVO $.

    $( A nonempty ball implies that the radius is positive.  (Contributed by
       NM, 11-Mar-2007.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
    blgt0 $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) /\
                A e. ( P ( ball ` D ) R ) ) -> 0 < R ) $=
      ( cxmt cfv wcel cxr w3a cbl co wa cc0 0xr a1i simpl1 simpl2 wbr syl3anc
      clt elbl simprbda xmetcl simpl3 cle xmetge0 simplbda xrlelttrd ) BEFGHZCE
      HZDIHZJZACDBKGLHZMZNCABLZDNIHUOOPUOUJUKAEHZUPIHUJUKULUNQZUJUKULUNRZUMUNUQ
      UPDUASZABCDEUBZUCZCABEUDTUJUKULUNUEUOUJUKUQNUPUFSURUSVBCABEUGTUMUNUQUTVAU
      HUI $.

    $( Two balls are disjoint if they don't overlap.  (Contributed by NM,
       11-Mar-2007.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
    bl2in $p |- ( ( ( D e. ( Met ` X ) /\ P e. X /\ Q e. X ) /\
                ( R e. RR /\ R <_ ( ( P D Q ) / 2 ) ) ) ->
                ( ( P ( ball ` D ) R ) i^i ( Q ( ball ` D ) R ) ) = (/) ) $=
      ( cme cfv wcel w3a cr co c2 cdiv cle wbr wa cxmt cxr cxad wceq cbl cin c0
      simpl1 metxmet syl simpl2 simpl3 rexr ad2antrl cmul simprl rexadd syl2anc
      caddc recnd 2timesd eqtr4d wb id cc0 clt 2re 2pos pm3.2i lemuldiv2 mp3an3
      metcl syl2anr biimprd impr eqbrtrd bldisj syl33anc ) AEFGHZBEHZCEHZIZDJHZ
      DBCAKZLMKNOZPZPZAEQGHZVPVQDRHZWEDDSKZVTNOBDAUAGZKCDWGKUBUCTWCVOWDVOVPVQWB
      UDAEUEUFVOVPVQWBUGVOVPVQWBUHVSWEVRWADUIUJZWHWCWFLDUKKZVTNWCWFDDUOKZWIWCVS
      VSWFWJTVRVSWAULZWKDDUMUNWCDWCDWKUPUQURVRVSWAWIVTNOZVRVSPWLWAVSVSVTJHZWLWA
      USZVRVSUTBCAEVHVSWMLJHZVALVBOZPWNWOWPVCVDVEDVTLVFVGVIVJVKVLABCDDEVMVN $.

    ${
      xblss2ps.1 $e |- ( ph -> D e. ( PsMet ` X ) ) $.
      xblss2ps.2 $e |- ( ph -> P e. X ) $.
      xblss2ps.3 $e |- ( ph -> Q e. X ) $.
      xblss2ps.4 $e |- ( ph -> R e. RR* ) $.
      xblss2ps.5 $e |- ( ph -> S e. RR* ) $.
      xblss2ps.6 $e |- ( ph -> ( P D Q ) e. RR ) $.
      xblss2ps.7 $e |- ( ph -> ( P D Q ) <_ ( S +e -e R ) ) $.
      $( One ball is contained in another if the center-to-center distance is
         less than the difference of the radii.  In this version of ~ blss2 for
         extended metrics, we have to assume the balls are a finite distance
         apart, or else ` P ` will not even be in the infinity ball around
         ` Q ` .  (Contributed by Mario Carneiro, 23-Aug-2015.)  (Revised by
         Thierry Arnoux, 11-Mar-2018.) $)
      xblss2ps $p |- ( ph -> ( P ( ball ` D ) R ) C_ ( Q ( ball ` D ) S ) ) $=
        ( co wcel wbr cxr cpnf adantr vx cbl cfv cv wa cpsmet wb elblps syl3anc
        simprbda cr wceq cxad psmetcl rexrd xaddcld ad2antrr psmettri2 syl13anc
        clt cle simplbda xltadd2 mpbid xrlelttrd cxne xnegcld xleadd1a syl31anc
        xnpcan sylan breqtrd xrltletrd caddc simpll simplr simpr oveq2d eleqtrd
        syl xblpnfps syl2anc biimpa simprd readdcld pnfxr a1i rexadd ltpnf cmnf
        wne cc0 0xr psmetge0 xrletrd ge0nemnf wi xaddmnf1 xnegeq xnegpnf syl6eq
        ex eqeq1d sylibrd necon1d mpd breqtrrd xrltle sylancr jca xrnemnf sylib
        wo mpjaodan mpbir2and ssrdv ) AUACEBUBUCZOZDFXQOZAUAUDZXRPZXTXSPZAYAUEZ
        YBXTGPZDXTBOZFUTQZAYAYDCXTBOZEUTQZABGUFUCPZCGPZERPZYAYDYHUEUGHIKXTBCEGU
        HUIZUJZYCEUKPZYFESULZYCYNUEZYECDBOZEUMOZFYCYERPZYNYCYIDGPZYDYSAYIYAHTZA
        YTYAJTZYMDXTBGUNUIZTYCYRRPYNYCYQEYCYQAYQUKPZYAMTZUOZAYKYAKTZUPZTAFRPZYA
        YNLUQYCYEYRUTQYNYCYEYQYGUMOZYRUUCYCYQYGUUFYCYIYJYDYGRPZUUAAYJYAITZYMCXT
        BGUNUIZUPUUHYCYIYJYTYDYEUUJVAQZUUAUULUUBYMDXTCBGURZUSYCYHUUJYRUTQZAYAYD
        YHYLVBZYCUUKYKUUDYHUUPUGUUMUUGUUEYGEYQVCUIVDVETYPYRFEVFZUMOZEUMOZFVAYCY
        RUUTVAQZYNYCYQRPUUSRPZYKYQUUSVAQZUVAUUFYCFUURAUUIYALTZYCEUUGVGUPZUUGAUV
        CYANTZYQUUSEVHVITYCUUIYNUUTFULUVDFEVJVKVLVMYCYOUEZYESFUTUVGYEYQYGVNOZSY
        CYSYOUUCTUVGUVHUVGYQYGUVGAUUDAYAYOVOZMVTZUVGAXTCSXQOZPZYGUKPZUVIUVGXTXR
        UVKAYAYOVPUVGESCXQYCYOVQZVRVSAUVLUEYDUVMAUVLYDUVMUEZAYIYJUVLUVOUGHIXTBC
        GWAWBWCWDWBZWEZUOSRPUVGWFWGUVGYEUUJUVHVAUVGYIYJYTYDUUNUVGAYIUVIHVTUVGAY
        JUVIIVTUVGAYTUVIJVTYCYDYOYMTUUOUSUVGUUDUVMUUJUVHULUVJUVPYQYGWHWBVLUVGUV
        HUKPUVHSUTQUVQUVHWIVTVEUVGUUSWJWKZFSULYCUVRYOYCUVBWLUUSVAQUVRUVEYCWLYQU
        USWLRPZYCWMWGZUUFUVEYCYIYJYTWLYQVAQUUAUULUUBCDBGWNUIUVFWOUUSWPWBTUVGFSU
        USWJUVGFSWKZFWJUMOZWJULZUUSWJULUVGUUIUWAUWCWQAUUIYAYOLUQUUIUWAUWCFWRXBV
        TUVGUUSUWBWJUVGUURWJFUMUVGUURSVFZWJUVGYOUURUWDULUVNESWSVTWTXAVRXCXDXEXF
        XGYCYKEWJWKZUEYNYOXMYCYKUWEUUGYCYKWLEVAQZUWEUUGYCWLEUTQZUWFYCWLYGEUVTUU
        MUUGYCYIYJYDWLYGVAQUUAUULYMCXTBGWNUIUUQVEYCUVSYKUWGUWFWQWMUUGWLEXHXIXFE
        WPWBXJEXKXLXNYCYIYTUUIYBYDYFUEUGUUAUUBUVDXTBDFGUHUIXOXBXP $.
    $}

    ${
      xblss2.1 $e |- ( ph -> D e. ( *Met ` X ) ) $.
      xblss2.2 $e |- ( ph -> P e. X ) $.
      xblss2.3 $e |- ( ph -> Q e. X ) $.
      xblss2.4 $e |- ( ph -> R e. RR* ) $.
      xblss2.5 $e |- ( ph -> S e. RR* ) $.
      xblss2.6 $e |- ( ph -> ( P D Q ) e. RR ) $.
      xblss2.7 $e |- ( ph -> ( P D Q ) <_ ( S +e -e R ) ) $.
      $( One ball is contained in another if the center-to-center distance is
         less than the difference of the radii.  In this version of ~ blss2 for
         extended metrics, we have to assume the balls are a finite distance
         apart, or else ` P ` will not even be in the infinity ball around
         ` Q ` .  (Contributed by Mario Carneiro, 23-Aug-2015.) $)
      xblss2 $p |- ( ph -> ( P ( ball ` D ) R ) C_ ( Q ( ball ` D ) S ) ) $=
        ( co wcel wbr adantr cc0 cmnf vx cbl cfv cv wa clt cxmt wb elbl syl3anc
        cxr simprbda cr cpnf wceq cxad rexrd xaddcld ad2antrr xmettri2 syl13anc
        xmetcl cle simplbda xltadd2 mpbid cxne xnegcld xleadd1a syl31anc xnpcan
        xrlelttrd breqtrd xrltletrd wne 0xr xmetge0 xrletrd ge0nemnf syl2anc wi
        sylan a1i xaddmnf1 ex simpr xnegeq xnegpnf syl6eq oveq2d eqeq1d sylibrd
        syl necon1d oveq12d pnfaddmnf biantrud xrletri3 sylancl xmeteq0 3bitr2d
        mpd oveq1d eqtr4d 3brtr3d wo xrltle sylancr jca xrnemnf sylib mpbir2and
        mpjaodan ssrdv ) AUACEBUBUCZOZDFXOOZAUAUDZXPPZXRXQPZAXSUEZXTXRGPZDXRBOZ
        FUFQZAXSYBCXRBOZEUFQZABGUGUCPZCGPZEUKPZXSYBYFUEUHHIKXRBCEGUIUJZULZYAEUM
        PZYDEUNUOZYAYLUEZYCCDBOZEUPOZFYAYCUKPZYLYAYGDGPZYBYQAYGXSHRZAYRXSJRZYKD
        XRBGVBUJZRYAYPUKPYLYAYOEYAYOAYOUMPZXSMRZUQZAYIXSKRZURZRAFUKPZXSYLLUSYAY
        CYPUFQYLYAYCYOYEUPOZYPUUAYAYOYEUUDYAYGYHYBYEUKPZYSAYHXSIRZYKCXRBGVBUJZU
        RUUFYAYGYHYRYBYCUUHVCQYSUUJYTYKDXRCBGUTVAYAYFUUHYPUFQZAXSYBYFYJVDZYAUUI
        YIUUBYFUULUHUUKUUEUUCYEEYOVEUJVFVLRYNYPFEVGZUPOZEUPOZFVCYAYPUUPVCQZYLYA
        YOUKPZUUOUKPZYIYOUUOVCQZUUQUUDYAFUUNAUUGXSLRZYAEUUEVHURZUUEAUUTXSNRZYOU
        UOEVIVJRYAUUGYLUUPFUOUVAFEVKWBVMVNYAYMUEZYEEYCFUFYAYFYMUUMRUVDCDXRBUVDY
        OSVCQZCDUOZUVDYOUUOSVCAUUTXSYMNUSUVDUUOUNTUPOSUVDFUNUUNTUPUVDUUOTVOZFUN
        UOYAUVGYMYAUUSSUUOVCQUVGUVBYASYOUUOSUKPZYAVPWCZUUDUVBYAYGYHYRSYOVCQZYSU
        UJYTCDBGVQUJZUVCVRUUOVSVTRUVDFUNUUOTUVDFUNVOZFTUPOZTUOZUUOTUOUVDUUGUVLU
        VNWAAUUGXSYMLUSUUGUVLUVNFWDWEWMUVDUUOUVMTUVDUUNTFUPUVDUUNUNVGZTUVDYMUUN
        UVOUOYAYMWFZEUNWGWMWHWIZWJWKWLWNXBZUVQWOWPWIVMYAUVEUVFUHYMYAUVEUVEUVJUE
        ZYOSUOZUVFYAUVJUVEUVKWQYAUURUVHUVTUVSUHUUDVPYOSWRWSYAYGYHYRUVTUVFUHYSUU
        JYTCDBGWTUJXARVFXCUVDEUNFUVPUVRXDXEYAYIETVOZUEYLYMXFYAYIUWAUUEYAYISEVCQ
        ZUWAUUEYASEUFQZUWBYASYEEUVIUUKUUEYAYGYHYBSYEVCQYSUUJYKCXRBGVQUJUUMVLYAU
        VHYIUWCUWBWAVPUUESEXGXHXBEVSVTXIEXJXKXMYAYGYRUUGXTYBYDUEUHYSYTUVAXRBDFG
        UIUJXLWEXN $.
    $}

    $( One ball is contained in another if the center-to-center distance is
       less than the difference of the radii.  (Contributed by Mario Carneiro,
       15-Jan-2014.)  (Revised by Mario Carneiro, 23-Aug-2015.)  (Revised by
       Thierry Arnoux, 11-Mar-2018.) $)
    blss2ps $p |- ( ( ( D e. ( PsMet ` X ) /\ P e. X /\ Q e. X ) /\
                ( R e. RR /\ S e. RR /\ ( P D Q ) <_ ( S - R ) ) ) ->
                ( P ( ball ` D ) R ) C_ ( Q ( ball ` D ) S ) ) $=
      ( cpsmet cfv wcel w3a cr co cmin cle wbr wa simpl1 simpl2 simpl3 rexrd
      simpr1 simpr2 resubcld simpr3 psmetlecl syl122anc cxne cxad wceq breqtrrd
      rexsub syl2anc xblss2ps ) AFGHIZBFIZCFIZJZDKIZEKIZBCALZEDMLZNOZJZPZABCDEF
      UNUOUPVCQZUNUOUPVCRZUNUOUPVCSZVDDUQURUSVBUAZTVDEUQURUSVBUBZTVDUNUOUPVAKIV
      BUTKIVEVFVGVDEDVIVHUCUQURUSVBUDZBCVAAFUEUFVDUTVAEDUGUHLZNVJVDUSURVKVAUIVI
      VHEDUKULUJUM $.

    $( One ball is contained in another if the center-to-center distance is
       less than the difference of the radii.  (Contributed by Mario Carneiro,
       15-Jan-2014.)  (Revised by Mario Carneiro, 23-Aug-2015.) $)
    blss2 $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X /\ Q e. X ) /\
                ( R e. RR /\ S e. RR /\ ( P D Q ) <_ ( S - R ) ) ) ->
                ( P ( ball ` D ) R ) C_ ( Q ( ball ` D ) S ) ) $=
      ( cxmt cfv wcel w3a cr co cmin cle wbr wa simpl1 simpl2 simpl3 rexrd cxne
      simpr1 simpr2 resubcld simpr3 xmetlecl syl122anc cxad wceq rexsub syl2anc
      breqtrrd xblss2 ) AFGHIZBFIZCFIZJZDKIZEKIZBCALZEDMLZNOZJZPZABCDEFUNUOUPVC
      QZUNUOUPVCRZUNUOUPVCSZVDDUQURUSVBUBZTVDEUQURUSVBUCZTVDUNUOUPVAKIVBUTKIVEV
      FVGVDEDVIVHUDUQURUSVBUEZBCVAAFUFUGVDUTVAEDUAUHLZNVJVDUSURVKVAUIVIVHEDUJUK
      ULUM $.
  $}

  ${
    $d X s $.  $d M s $.  $d R s $.  $d Y s $.  $d Z s $.
    $( A ball of radius ` R / 2 ` is contained in a ball of radius ` R `
       centered at any point inside the smaller ball.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       14-Jan-2014.) $)
    blhalf $p |- ( ( ( M e. ( *Met ` X ) /\ Y e. X ) /\ ( R e. RR /\
                    Z e. ( Y ( ball ` M ) ( R / 2 ) ) ) ) ->
              ( Y ( ball ` M ) ( R / 2 ) ) C_ ( Z ( ball ` M ) R ) ) $=
      ( cxmt cfv wcel wa cr c2 cdiv co cbl cmin cle wbr cxr syl3anc recnd rexrd
      wss simpll simplr clt simprr wb simprl rehalfcld elbl mpbid simpld simprd
      wi xmetcl xrltle syl2anc mpd caddc pncand 2halvesd oveq1d eqtr3d syl33anc
      breqtrd blss2 ) BCFGHZDCHZIZAJHZEDAKLMZBNGZMZHZIZIZVGVHECHZVKJHVJDEBMZAVK
      OMZPQVMEAVLMUBVGVHVOUCZVGVHVOUDZVPVQVRVKUEQZVPVNVQWBIZVIVJVNUFVPVGVHVKRHZ
      VNWCUGVTWAVPVKVPAVIVJVNUHZUIZUAZEBDVKCUJSUKZULZWFWEVPVRVKVSPVPWBVRVKPQZVP
      VQWBWHUMVPVRRHZWDWBWJUNVPVGVHVQWKVTWAWIDEBCUOSWGVRVKUPUQURVPVKVKUSMZVKOMV
      KVSVPVKVKVPVKWFTZWMUTVPWLAVKOVPAVPAWETVAVBVCVEBDEVKACVFVD $.
  $}

  ${
    $d r x y A $.  $d r x y z B $.  $d x y z C $.  $d r x y z D $.  $d r x R $.
    $d r x y z P $.  $d x S $.  $d r x y z X $.
    $( Mapping of a ball.  (Contributed by NM, 7-May-2007.)  (Revised by Mario
       Carneiro, 23-Aug-2015.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    blfps $p |- ( D e. ( PsMet ` X ) -> ( ball ` D ) : ( X X. RR* ) --> ~P X )
      $=
      ( vx vr vy cpsmet cfv wcel cxr cxp cpw cbl wf cv clt wbr crab cmpt2 wral
      co wa wss ssrab2 cdm wb elfvdm elpw2g syl mpbiri a1d ralrimivv eqid fmpt2
      sylib blfvalps feq1d mpbird ) ABFGHZBIJZBKZALGZMUSUTCDBICNZENATDNZOPZEBQZ
      RZMZURVEUTHZDISCBSVGURVHCDBIURVHVBBHVCIHUAURVHVEBUBZVDEBUCURBFUDZHVHVIUEA
      BFUFVEBVJUGUHUIUJUKCDBIVEUTVFVFULUMUNURUSUTVAVFCEABDUOUPUQ $.

    $( Mapping of a ball.  (Contributed by NM, 7-May-2007.)  (Revised by Mario
       Carneiro, 23-Aug-2015.) $)
    blf $p |- ( D e. ( *Met ` X ) -> ( ball ` D ) : ( X X. RR* ) --> ~P X ) $=
      ( vx vr vy cxmt cfv wcel cxr cxp cpw cbl wf cv co clt wbr crab cmpt2 wral
      wa wss ssrab2 cdm elfvdm elpw2g syl mpbiri a1d ralrimivv eqid fmpt2 sylib
      wb blfval feq1d mpbird ) ABFGHZBIJZBKZALGZMUSUTCDBICNZENAODNZPQZEBRZSZMZU
      RVEUTHZDITCBTVGURVHCDBIURVHVBBHVCIHUAURVHVEBUBZVDEBUCURBFUDZHVHVIUNABFUEV
      EBVJUFUGUHUIUJCDBIVEUTVFVFUKULUMURUSUTVAVFCEABDUOUPUQ $.

    $( Membership in the range of the ball function.  Note that
       ` ran ( ball `` D ) ` is the collection of all balls for metric ` D ` .
       (Contributed by NM, 31-Aug-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    blrnps $p |- ( D e. ( PsMet ` X ) -> ( A e. ran ( ball ` D ) <->
         E. x e. X E. r e. RR* A = ( x ( ball ` D ) r ) ) ) $=
      ( cpsmet cfv wcel cxr cxp cpw cbl wf wfn crn cv co wceq wrex wb blfps ffn
      ovelrn 3syl ) CDFGHDIJZDKZCLGZMUGUENBUGOHBAPEPUGQREISADSTCDUAUEUFUGUBAEDI
      BUGUCUD $.

    $( Membership in the range of the ball function.  Note that
       ` ran ( ball `` D ) ` is the collection of all balls for metric ` D ` .
       (Contributed by NM, 31-Aug-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    blrn $p |- ( D e. ( *Met ` X ) -> ( A e. ran ( ball ` D ) <->
         E. x e. X E. r e. RR* A = ( x ( ball ` D ) r ) ) ) $=
      ( cxmt cfv wcel cxr cxp cpw cbl wf wfn crn cv co wceq wrex wb ovelrn 3syl
      blf ffn ) CDFGHDIJZDKZCLGZMUGUENBUGOHBAPEPUGQREISADSTCDUCUEUFUGUDAEDIBUGU
      AUB $.

    $( A ball contains its center.  (Contributed by NM, 2-Sep-2006.)  (Revised
       by Mario Carneiro, 12-Nov-2013.)  (Revised by Thierry Arnoux,
       11-Mar-2018.) $)
    xblcntrps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X /\ ( R e. RR* /\ 0 < R ) )
              -> P e. ( P ( ball ` D ) R ) ) $=
      ( cpsmet cfv wcel cxr cc0 clt wbr wa w3a cbl co simp2 wceq psmet0 3adant3
      simp3r eqbrtrd wb elblps 3adant3r mpbir2and ) ADEFGZBDGZCHGZICJKZLZMZBBCA
      NFOGZUGBBAOZCJKZUFUGUJPUKUMICJUFUGUMIQUJBADRSUFUGUHUITUAUFUGUHULUGUNLUBUI
      BABCDUCUDUE $.

    $( A ball contains its center.  (Contributed by NM, 2-Sep-2006.)  (Revised
       by Mario Carneiro, 12-Nov-2013.) $)
    xblcntr $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ ( R e. RR* /\ 0 < R ) ) ->
                 P e. ( P ( ball ` D ) R ) ) $=
      ( cxmt cfv wcel cxr cc0 clt wbr wa w3a co simp2 wceq xmet0 3adant3 simp3r
      cbl eqbrtrd wb elbl 3adant3r mpbir2and ) ADEFGZBDGZCHGZICJKZLZMZBBCATFNGZ
      UGBBANZCJKZUFUGUJOUKUMICJUFUGUMIPUJBADQRUFUGUHUISUAUFUGUHULUGUNLUBUIBABCD
      UCUDUE $.

    $( A ball contains its center.  (Contributed by NM, 2-Sep-2006.)  (Revised
       by Mario Carneiro, 12-Nov-2013.)  (Revised by Thierry Arnoux,
       11-Mar-2018.) $)
    blcntrps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X /\ R e. RR+ ) ->
                 P e. ( P ( ball ` D ) R ) ) $=
      ( crp wcel cpsmet cfv cxr cc0 clt wbr wa cbl rpxr rpgt0 xblcntrps syl3an3
      co jca ) CEFZADGHFBDFCIFZJCKLZMBBCANHSFUAUBUCCOCPTABCDQR $.

    $( A ball contains its center.  (Contributed by NM, 2-Sep-2006.)  (Revised
       by Mario Carneiro, 12-Nov-2013.) $)
    blcntr $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR+ ) ->
                 P e. ( P ( ball ` D ) R ) ) $=
      ( crp wcel cxmt cfv cxr cc0 clt wbr wa cbl rpxr rpgt0 jca xblcntr syl3an3
      co ) CEFZADGHFBDFCIFZJCKLZMBBCANHTFUAUBUCCOCPQABCDRS $.

    $( A ball is nonempty iff the radius is positive.  (Contributed by Mario
       Carneiro, 23-Aug-2015.) $)
    xbln0 $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
                 ( ( P ( ball ` D ) R ) =/= (/) <-> 0 < R ) ) $=
      ( vx cxmt cfv wcel cxr w3a cbl co c0 cc0 clt wbr wa 3expa 3adantl3 wi wne
      cv wex n0 elbl cle xmetge0 0xr a1i xmetcl simpl3 xrlelttr syl3anc expimpd
      mpand sylbid exlimdv syl5bi xblcntr ne0i syl expr 3impa impbid ) ADFGHZBD
      HZCIHZJZBCAKGLZMUAZNCOPZVJEUBZVIHZEUCVHVKEVIUDVHVMVKEVHVMVLDHZBVLALZCOPZQ
      VKVLABCDUEVHVNVPVKVHVNQZNVOUFPZVPVKVEVFVNVRVGVEVFVNVRBVLADUGRSVQNIHZVOIHZ
      VGVRVPQVKTVSVQUHUIVEVFVNVTVGVEVFVNVTBVLADUJRSVEVFVGVNUKNVOCULUMUOUNUPUQUR
      VEVFVGVKVJTVEVFQVGVKVJVEVFVGVKQZVJVEVFWAJBVIHVJABCDUSVIBUTVARVBVCVD $.

    $( A ball is not empty.  (Contributed by NM, 6-Oct-2007.)  (Revised by
       Mario Carneiro, 12-Nov-2013.) $)
    bln0 $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR+ ) ->
                 ( P ( ball ` D ) R ) =/= (/) ) $=
      ( cxmt cfv wcel crp w3a cbl co c0 wne blcntr ne0i syl ) ADEFGBDGCHGIBBCAJ
      FKZGQLMABCDNQBOP $.

    $( A ball belongs to the set of balls of a metric space.  (Contributed by
       NM, 2-Sep-2006.)  (Revised by Mario Carneiro, 12-Nov-2013.)  (Revised by
       Thierry Arnoux, 11-Mar-2018.) $)
    blelrnps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X /\ R e. RR* ) ->
                    ( P ( ball ` D ) R ) e. ran ( ball ` D ) ) $=
      ( cpsmet cfv wcel cbl cxr cxp wfn co crn cpw blfps ffn syl fnovrn syl3an1
      wf ) ADEFGZAHFZDIJZKZBDGCIGBCUBLUBMGUAUCDNZUBTUDADOUCUEUBPQDIBCUBRS $.

    $( A ball belongs to the set of balls of a metric space.  (Contributed by
       NM, 2-Sep-2006.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    blelrn $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
                    ( P ( ball ` D ) R ) e. ran ( ball ` D ) ) $=
      ( cxmt cfv wcel cbl cxr cxp wfn co crn cpw wf blf ffn syl fnovrn syl3an1
      ) ADEFGZAHFZDIJZKZBDGCIGBCUBLUBMGUAUCDNZUBOUDADPUCUEUBQRDIBCUBST $.

    $( A ball is a subset of the base set of a metric space.  (Contributed by
       NM, 31-Aug-2006.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    blssm $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
                  ( P ( ball ` D ) R ) C_ X ) $=
      ( cxmt cfv wcel cxr w3a cbl co cxp cpw wf blf fovrn syl3an1 elpwid ) ADEF
      GZBDGZCHGZIBCAJFZKZDSDHLDMZUBNTUAUCUDGADOBCUDDHUBPQR $.

    $( The union of the set of balls of a metric space is its base set.
       (Contributed by NM, 12-Sep-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    unirnblps $p |- ( D e. ( PsMet ` X ) -> U. ran ( ball ` D ) = X ) $=
      ( vx cpsmet cfv wcel cbl crn cuni cpw wss cxr cxp wf blfps frn syl c1 1rp
      mp3an3 sspwuni sylib cv wa co blcntrps rpxr ax-mp blelrnps elunii syl2anc
      crp ex ssrdv eqssd ) ABDEFZAGEZHZIZBUPURBJZKZUSBKUPBLMZUTUQNVAABOVBUTUQPQ
      URBUAUBUPCBUSUPCUCZBFZVCUSFZUPVDUDVCVCRUQUEZFZVFURFZVEUPVDRULFZVGSAVCRBUF
      TUPVDRLFZVHVIVJSRUGUHAVCRBUITVCVFURUJUKUMUNUO $.

    $( The union of the set of balls of a metric space is its base set.
       (Contributed by NM, 12-Sep-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    unirnbl $p |- ( D e. ( *Met ` X ) -> U. ran ( ball ` D ) = X ) $=
      ( vx cxmt cfv wcel cbl crn cuni cpw wss cxr cxp wf blf frn syl 1rp mp3an3
      c1 sspwuni sylib cv wa co crp blcntr ax-mp blelrn elunii syl2anc ex ssrdv
      rpxr eqssd ) ABDEFZAGEZHZIZBUPURBJZKZUSBKUPBLMZUTUQNVAABOVBUTUQPQURBUAUBU
      PCBUSUPCUCZBFZVCUSFZUPVDUDVCVCTUQUEZFZVFURFZVEUPVDTUFFZVGRAVCTBUGSUPVDTLF
      ZVHVIVJRTUNUHAVCTBUISVCVFURUJUKULUMUO $.

    $( The intersection of two balls with the same center is the smaller of
       them.  (Contributed by NM, 1-Sep-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    blin $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X ) /\ ( R e. RR* /\
      S e. RR* ) ) -> ( ( P ( ball ` D ) R ) i^i ( P ( ball ` D ) S ) ) =
                        ( P ( ball ` D ) if ( R <_ S , R , S ) ) ) $=
      ( vx cxmt cfv wcel wa cxr cbl co cin cle wbr clt wb 3expa elbl cif xmetcl
      cv adantlr simplrl simplrr xrltmin syl3anc sylan2 adantrr adantrl anbi12d
      pm5.32da ifcl elin anandi 3bitr4g 3bitr4rd eqrdv ) AEGHIZBEIZJZCKIZDKIZJZ
      JZFBCALHZMZBDVGMZNZBCDOPZCDUAZVGMZVFFUCZEIZBVNAMZVLQPZJZVOVPCQPZVPDQPZJZJ
      ZVNVMIZVNVJIZVFVOVQWAVFVOJVPKIZVCVDVQWARVBVOWEVEUTVAVOWEBVNAEUBSUDVBVCVDV
      OUEVBVCVDVOUFVPCDUGUHUMVEVBVLKIZWCVRRZVKCDKUNUTVAWFWGVNABVLETSUIVFVNVHIZV
      NVIIZJVOVSJZVOVTJZJWDWBVFWHWJWIWKVBVCWHWJRZVDUTVAVCWLVNABCETSUJVBVDWIWKRZ
      VCUTVAVDWMVNABDETSUKULVNVHVIUOVOVSVTUPUQURUS $.

    $( The size of a ball increases monotonically with its radius.
       (Contributed by NM, 20-Sep-2007.)  (Revised by Mario Carneiro,
       24-Aug-2015.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    ssblps $p |- ( ( ( D e. ( PsMet ` X ) /\ P e. X ) /\
                   ( R e. RR* /\ S e. RR* ) /\ R <_ S ) ->
               ( P ( ball ` D ) R ) C_ ( P ( ball ` D ) S ) ) $=
      ( cpsmet cfv wcel wa cxr cle wbr w3a simp1l simp1r simp2l simp2r co cc0
      cr wceq psmet0 3ad2ant1 0re syl6eqel cxne simp3 wb xsubge0 syl2anc mpbird
      cxad eqbrtrd xblss2ps ) AEFGHZBEHZIZCJHZDJHZIZCDKLZMZABBCDEUOUPUTVANUOUPU
      TVAOZVCUQURUSVAPZUQURUSVAQZVBBBARZSTUQUTVFSUAVABAEUBUCZUDUEVBVFSDCUFULRZK
      VGVBSVHKLZVAUQUTVAUGVBUSURVIVAUHVEVDDCUIUJUKUMUN $.

    $( The size of a ball increases monotonically with its radius.
       (Contributed by NM, 20-Sep-2007.)  (Revised by Mario Carneiro,
       24-Aug-2015.) $)
    ssbl $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X ) /\
                   ( R e. RR* /\ S e. RR* ) /\ R <_ S ) ->
               ( P ( ball ` D ) R ) C_ ( P ( ball ` D ) S ) ) $=
      ( cxmt cfv wcel wa cxr cle wbr w3a simp1l simp1r simp2l simp2r co cc0 cr
      wceq xmet0 3ad2ant1 0re syl6eqel cxne cxad xsubge0 syl2anc mpbird eqbrtrd
      simp3 wb xblss2 ) AEFGHZBEHZIZCJHZDJHZIZCDKLZMZABBCDEUOUPUTVANUOUPUTVAOZV
      CUQURUSVAPZUQURUSVAQZVBBBARZSTUQUTVFSUAVABAEUBUCZUDUEVBVFSDCUFUGRZKVGVBSV
      HKLZVAUQUTVAULVBUSURVIVAUMVEVDDCUHUIUJUKUN $.

    $( Any point ` P ` in a ball ` B ` can be centered in another ball that is
       a subset of ` B ` .  (Contributed by NM, 31-Aug-2006.)  (Revised by
       Mario Carneiro, 24-Aug-2015.)  (Revised by Thierry Arnoux,
       11-Mar-2018.) $)
    blssps $p |- ( ( D e. ( PsMet ` X ) /\ B e. ran ( ball ` D ) /\ P e. B ) ->
                E. x e. RR+ ( P ( ball ` D ) x ) C_ B ) $=
      ( vy vr vz wcel co wss crp wrex cxr wi clt wbr wa syl2anc cle cfv cbl crn
      cpsmet cv blrnps w3a elblps cq simpl1 simpl2 simpr psmetcl syl3anc simpl3
      wceq qbtwnxr 3expia cr qre cmin simpll1 simplr simpll2 simprrl eqbrtrd wb
      psmetsym simprl rexr ad2antrl xrltle mpd psmetlecl syl122anc difrp xrleid
      mpbid resubcld syl recnd nncand breqtrrd blss2ps syl33anc simpll3 simprrr
      ssblps syl221anc sstrd sseq1d rspcev expr sylan2 rexlimdva expimpd sylbid
      oveq2 syld eleq2 sseq2 rexbidv imbi12d syl5ibrcom 3expib rexlimdvv 3imp )
      CEUDUAIZBCUBUAZUCIZDBIZDAUEZXIJZBKZALMZXHXJBFUEZGUEZXIJZUPZGNMFEMXKXOOZFB
      CEGUFXHXSXTFGENXHXPEIZXQNIZXSXTOXHYAYBUGZXTXSDXRIZXMXRKZALMZOYCYDDEIZXPDC
      JZXQPQZRYFDCXPXQEUHYCYGYIYFYCYGRZYIYHHUEZPQZYKXQPQZRZHUIMZYFYJYHNIZYBYIYO
      OYJXHYAYGYPXHYAYBYGUJXHYAYBYGUKYCYGULXPDCEUMUNXHYAYBYGUOYPYBYIYOHYHXQUQUR
      SYJYNYFHUIYKUIIYJYKUSIZYNYFOYKUTYJYQYNYFYJYQYNRZRZYKDXPCJZVAJZLIZDUUAXIJZ
      XRKZYFYSYTYKPQZUUBYSYTYHYKPYSXHYGYAYTYHUPXHYAYBYGYRVBZYCYGYRVCZXHYAYBYGYR
      VDZDXPCEVHUNYJYQYLYMVEVFZYSYTUSIZYQUUEUUBVGYSXHYGYAYQYTYKTQZUUJUUFUUGUUHY
      JYQYNVIZYSUUEUUKUUIYSYTNIZYKNIZUUEUUKOYSXHYGYAUUMUUFUUGUUHDXPCEUMUNZYQUUN
      YJYNYKVJVKZYTYKVLSVMDXPYKCEVNVOZUULYTYKVPSVRYSUUCXPYKXIJZXRYSXHYGYAUUAUSI
      YQYTYKUUAVAJZTQUUCUURKUUFUUGUUHYSYKYTUULUUQVSUULYSYTYTUUSTYSUUMYTYTTQUUOY
      TVQVTYSYKYTYSYKUULWAYSYTUUQWAWBWCCDXPUUAYKEWDWEYSXHYAUUNYBYKXQTQZUURXRKUU
      FUUHUUPXHYAYBYGYRWFZYSYMUUTYJYQYLYMWGYSUUNYBYMUUTOUUPUVAYKXQVLSVMCXPYKXQE
      WHWIWJYEUUDAUUALXLUUAUPXMUUCXRXLUUADXIWRWKWLSWMWNWOWSWPWQXSXKYDXOYFBXRDWT
      XSXNYEALBXRXMXAXBXCXDXEXFWQXG $.

    $( Any point ` P ` in a ball ` B ` can be centered in another ball that is
       a subset of ` B ` .  (Contributed by NM, 31-Aug-2006.)  (Revised by
       Mario Carneiro, 24-Aug-2015.) $)
    blss $p |- ( ( D e. ( *Met ` X ) /\ B e. ran ( ball ` D ) /\ P e. B ) ->
                E. x e. RR+ ( P ( ball ` D ) x ) C_ B ) $=
      ( vy vr vz wcel co wss crp wrex cxr wi clt wbr wa syl2anc cle cfv cbl crn
      cxmt cv wceq blrn w3a elbl cq simpl1 simpl2 xmetcl syl3anc simpl3 qbtwnxr
      simpr 3expia cr qre simpll1 simplr simpll2 xmetsym simprrl eqbrtrd simprl
      cmin wb rexr ad2antrl xrltle mpd xmetlecl syl122anc difrp resubcld xrleid
      mpbid recnd nncand breqtrrd blss2 syl33anc simpll3 simprrr ssbl syl221anc
      sstrd oveq2 sseq1d rspcev expr sylan2 rexlimdva syld expimpd sylbid eleq2
      syl sseq2 rexbidv imbi12d syl5ibrcom 3expib rexlimdvv 3imp ) CEUDUAIZBCUB
      UAZUCIZDBIZDAUEZXIJZBKZALMZXHXJBFUEZGUEZXIJZUFZGNMFEMXKXOOZFBCEGUGXHXSXTF
      GENXHXPEIZXQNIZXSXTOXHYAYBUHZXTXSDXRIZXMXRKZALMZOYCYDDEIZXPDCJZXQPQZRYFDC
      XPXQEUIYCYGYIYFYCYGRZYIYHHUEZPQZYKXQPQZRZHUJMZYFYJYHNIZYBYIYOOYJXHYAYGYPX
      HYAYBYGUKXHYAYBYGULYCYGUQXPDCEUMUNXHYAYBYGUOYPYBYIYOHYHXQUPURSYJYNYFHUJYK
      UJIYJYKUSIZYNYFOYKUTYJYQYNYFYJYQYNRZRZYKDXPCJZVHJZLIZDUUAXIJZXRKZYFYSYTYK
      PQZUUBYSYTYHYKPYSXHYGYAYTYHUFXHYAYBYGYRVAZYCYGYRVBZXHYAYBYGYRVCZDXPCEVDUN
      YJYQYLYMVEVFZYSYTUSIZYQUUEUUBVIYSXHYGYAYQYTYKTQZUUJUUFUUGUUHYJYQYNVGZYSUU
      EUUKUUIYSYTNIZYKNIZUUEUUKOYSXHYGYAUUMUUFUUGUUHDXPCEUMUNZYQUUNYJYNYKVJVKZY
      TYKVLSVMDXPYKCEVNVOZUULYTYKVPSVSYSUUCXPYKXIJZXRYSXHYGYAUUAUSIYQYTYKUUAVHJ
      ZTQUUCUURKUUFUUGUUHYSYKYTUULUUQVQUULYSYTYTUUSTYSUUMYTYTTQUUOYTVRWTYSYKYTY
      SYKUULVTYSYTUUQVTWAWBCDXPUUAYKEWCWDYSXHYAUUNYBYKXQTQZUURXRKUUFUUHUUPXHYAY
      BYGYRWEZYSYMUUTYJYQYLYMWFYSUUNYBYMUUTOUUPUVAYKXQVLSVMCXPYKXQEWGWHWIYEUUDA
      UUALXLUUAUFXMUUCXRXLUUADXIWJWKWLSWMWNWOWPWQWRXSXKYDXOYFBXRDWSXSXNYEALBXRX
      MXAXBXCXDXEXFWRXG $.

    $( Two ways to express the existence of a ball subset.  (Contributed by NM,
       5-May-2007.)  (Revised by Mario Carneiro, 12-Nov-2013.)  (Revised by
       Thierry Arnoux, 11-Mar-2018.) $)
    blssexps $p |- ( ( D e. ( PsMet ` X ) /\ P e. X ) ->
                   ( E. x e. ran ( ball ` D ) ( P e. x /\ x C_ A ) <->
                     E. r e. RR+ ( P ( ball ` D ) r ) C_ A ) ) $=
      ( cpsmet cfv wcel wa cv wss cbl crn wrex co crp wi w3a syl3anc sstr 3expa
      blssps expcom reximdv syl5com expimpd adantlr rexlimdva cxr simpll simplr
      rpxr ad2antrl blelrnps simprl blcntrps simprr wceq eleq2 anbi12d syl12anc
      sseq1 rspcev rexlimdvaa impbid ) CEGHIZDEIZJZDAKZIZVJBLZJZACMHZNZOZDFKZVN
      PZBLZFQOZVIVMVTAVOVGVJVOIZVMVTRVHVGWAJVKVLVTVGWAVKVLVTRVGWAVKSVRVJLZFQOVL
      VTFVJCDEUCVLWBVSFQWBVLVSVRVJBUAUDUEUFUBUGUHUIVIVSVPFQVIVQQIZVSJZJZVRVOIZD
      VRIZVSVPWEVGVHVQUJIZWFVGVHWDUKZVGVHWDULZWCWHVIVSVQUMUNCDVQEUOTWEVGVHWCWGW
      IWJVIWCVSUPCDVQEUQTVIWCVSURVMWGVSJAVRVOVJVRUSVKWGVLVSVJVRDUTVJVRBVCVAVDVB
      VEVF $.

    $( Two ways to express the existence of a ball subset.  (Contributed by NM,
       5-May-2007.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    blssex $p |- ( ( D e. ( *Met ` X ) /\ P e. X ) ->
                   ( E. x e. ran ( ball ` D ) ( P e. x /\ x C_ A ) <->
                     E. r e. RR+ ( P ( ball ` D ) r ) C_ A ) ) $=
      ( cxmt cfv wcel wa cv wss cbl crn wrex co crp wi w3a syl3anc blss reximdv
      expcom syl5com 3expa expimpd adantlr rexlimdva cxr simpll simplr ad2antrl
      sstr rpxr blelrn simprl blcntr simprr eleq2 sseq1 anbi12d rspcev syl12anc
      wceq rexlimdvaa impbid ) CEGHIZDEIZJZDAKZIZVJBLZJZACMHZNZOZDFKZVNPZBLZFQO
      ZVIVMVTAVOVGVJVOIZVMVTRVHVGWAJVKVLVTVGWAVKVLVTRVGWAVKSVRVJLZFQOVLVTFVJCDE
      UAVLWBVSFQWBVLVSVRVJBUMUCUBUDUEUFUGUHVIVSVPFQVIVQQIZVSJZJZVRVOIZDVRIZVSVP
      WEVGVHVQUIIZWFVGVHWDUJZVGVHWDUKZWCWHVIVSVQUNULCDVQEUOTWEVGVHWCWGWIWJVIWCV
      SUPCDVQEUQTVIWCVSURVMWGVSJAVRVOVJVRVDVKWGVLVSVJVRDUSVJVRBUTVAVBVCVEVF $.

    $( A nested ball exists whose radius is less than any desired amount.
       (Contributed by NM, 20-Sep-2007.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    ssblex $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X ) /\
                     ( R e. RR+ /\ S e. RR+ ) ) ->
     E. x e. RR+ ( x < R /\ ( P ( ball ` D ) x ) C_ ( P ( ball ` D ) S ) ) ) $=
      ( cfv wcel wa crp co cle wbr clt wss syl2anc rpred cr cxr rpxrd cxmt cdiv
      c2 cif cbl cv wrex simprl rphalfcld simprr ifcl cc0 rpgt0d wb halfpos syl
      min1 mpbid lelttrd simpl min2 syl121anc breq1 oveq2 sseq1d anbi12d rspcev
      ssbl wceq syl12anc ) BFUAGHCFHIZDJHZEJHZIZIZDUCUBKZELMZVPEUDZJHZVRDNMZCVR
      BUEGZKZCEWAKZOZAUFZDNMZCWEWAKZWCOZIZAJUGVOVPJHVMVSVODVKVLVMUHZUIZVKVLVMUJ
      ZVQVPEJUKPZVOVRVPDVOVRWMQVOVPWKQZVODWJQZVOVPRHZERHZVRVPLMWNVOEWLQZVPEUQPV
      OULDNMZVPDNMZVODWJUMVODRHWSWTUNWODUOUPURUSVOVKVRSHESHVRELMZWDVKVNUTVOVRWM
      TVOEWLTVOWPWQXAWNWRVPEVAPBCVREFVHVBWIVTWDIAVRJWEVRVIZWFVTWHWDWEVRDNVCXBWG
      WBWCWEVRCWAVDVEVFVGVJ $.

    $( Given any two balls and a point in their intersection, there is a ball
       contained in the intersection with the given center point.  (Contributed
       by Mario Carneiro, 12-Nov-2013.) $)
    blin2 $p |- ( ( ( D e. ( *Met ` X ) /\ P e. ( B i^i C ) ) /\
                  ( B e. ran ( ball ` D ) /\ C e. ran ( ball ` D ) ) ) ->
                    E. x e. RR+ ( P ( ball ` D ) x ) C_ ( B i^i C ) ) $=
      ( vy vz cfv wcel cin wa cv co wss crp wrex blss syl3anc cxr simpll simprl
      cxmt cbl crn simplr elin sylib simpld simprr simprd reeanv ss2in cle wceq
      wbr cif inss1 cpw cxp blf frn 3syl sseldd elpwid syl5ss rpxr anim12i blin
      wf jca syl2an sseq1d wi ifcl oveq2 rspcev ex syl adantl sylbid rexlimdvva
      syl5 syl5bir mp2and ) DFUCIJZEBCKZJZLZBDUDIZUEZJZCWKJZLZLZEGMZWJNZBOZGPQZ
      EHMZWJNZCOZHPQZEAMZWJNZWGOZAPQZWOWFWLEBJZWSWFWHWNUAZWIWLWMUBZWOXHECJZWOWH
      XHXKLWFWHWNUFZEBCUGUHZUIGBDEFRSWOWFWMXKXCXIWIWLWMUJWOXHXKXMUKHCDEFRSWSXCL
      WRXBLZHPQGPQWOXGWRXBGHPPULWOXNXGGHPPXNWQXAKZWGOZWOWPPJZWTPJZLZLZXGWQBXACU
      MXTXPEWPWTUNUPZWPWTUQZWJNZWGOZXGXTXOYCWGWOWFEFJZLWPTJZWTTJZLXOYCUOXSWOWFY
      EXIWOWGFEWOWGBFBCURWOBFWOWKFUSZBWOWFFTUTZYHWJVJWKYHOXIDFVAYIYHWJVBVCXJVDV
      EVFXLVDVKXQYFXRYGWPVGWTVGVHDEWPWTFVIVLVMXSYDXGVNZWOXSYBPJZYJYAWPWTPVOYKYD
      XGXFYDAYBPXDYBUOXEYCWGXDYBEWJVPVMVQVRVSVTWAWCWBWDWE $.
  $}

  ${
    $d x C $.  $d b r x y z D $.  $d x P $.  $d x R $.  $d b r x y z X $.
    $d x Y $.
    $( The balls of a metric space form a basis for a topology.  (Contributed
       by NM, 12-Sep-2006.)  (Revised by Mario Carneiro, 15-Jan-2014.) $)
    blbas $p |- ( D e. ( *Met ` X ) -> ran ( ball ` D ) e. TopBases ) $=
      ( vz vb vx vy vr cxmt cfv wcel wel cv cin wss wa cbl wrex wral wb cvv crn
      ctb crp blin2 simpll cuni inss1 sseli elunii sylan ad2ant2lr wceq unirnbl
      ad2antrr eleqtrd blssex syl2anc mpbird ralrimdva ralrimivv fvex isbasis2g
      co ex rnex ax-mp sylibr ) ABHIJZCDKDLELZFLZMZNODAPIZUAZQZCVKRZFVMREVMRZVM
      UBJZVHVOEFVMVMVHVIVMJZVJVMJZOZVNCVKVHCLZVKJZOZVTVNWCVTOZVNWAGLVLVCVKNGUCQ
      ZGVIVJAWABUDWDVHWABJVNWESVHWBVTUEWDWAVMUFZBWBVRWAWFJZVHVSWBCEKVRWGVKVIWAV
      IVJUGUHWAVIVMUIUJUKVHWFBULWBVTABUMUNUODVKAWABGUPUQURVDUSUTVMTJVQVPSVLAPVA
      VEEFCDVMTVBVFVG $.

    blres.2 $e |- C = ( D |` ( Y X. Y ) ) $.
    $( A ball in a restricted metric space.  (Contributed by Mario Carneiro,
       5-Jan-2014.) $)
    blres $p |- ( ( D e. ( *Met ` X ) /\ P e. ( X i^i Y ) /\ R e. RR* ) ->
                  ( P ( ball ` C ) R ) = ( ( P ( ball ` D ) R ) i^i Y ) ) $=
      ( vx cxmt cfv wcel cin cbl co clt wbr wa wb sseli elin cxr w3a wceq inss2
      cv cxp cres oveqi ovres syl5eq sylan breq1d pm5.32da 3ad2ant2 ancom bitri
      anbi2d anbi1i anass 3bitr4g xmetres syl5eqel syl3an1 inss1 syl3an2 anbi1d
      elbl syl5bb 3bitr4d eqrdv ) BEIJKZCEFLZKZDUAKZUBZHCDAMJNZCDBMJNZFLZVOHUEZ
      VLKZCVSANZDOPZQZVSEKZCVSBNZDOPZQZVSFKZQZVSVPKZVSVRKZVOWHWDWBQZQZWHWGQZWCW
      IVMVKWMWNRVNVMWHWLWGVMWHQZWBWFWDWOWAWEDOVMCFKZWHWAWEUCVLFCEFUDSWPWHQWACVS
      BFFUFUGZNWEAWQCVSGUHCVSFFBUIUJUKULUQUMUNWCWHWDQZWBQWMVTWRWBVTWDWHQWRVSEFT
      WDWHUOUPURWHWDWBUSUPWGWHUOUTVKAVLIJZKVMVNWJWCRVKAWQWSGBFEVAVBVSACDVLVGVCW
      KVSVQKZWHQVOWIVSVQFTVOWTWGWHVMVKCEKVNWTWGRVLECEFVDSVSBCDEVGVEVFVHVIVJ $.
  $}

  ${
    $d x y z D $.  $d x P $.  $d x y z .~ $.  $d x y z X $.
    xmeter.1 $e |- .~ = ( `' D " RR ) $.
    $( Value of the "finitely separated" relation.  (Contributed by Mario
       Carneiro, 24-Aug-2015.) $)
    xmeterval $p |- ( D e. ( *Met ` X ) ->
        ( A .~ B <-> ( A e. X /\ B e. X /\ ( A D B ) e. RR ) ) ) $=
      ( cxmt cfv wcel cop ccnv cr cima cxp wa wbr co w3a cxr bitri wf wfn xmetf
      ffn elpreima 3syl breqi df-br df-3an opelxp bicomi eleq1i anbi12i 3bitr4g
      wb df-ov ) CEGHIZABJZCKLMZIZUREENZIZURCHZLIZOZABDPZAEIZBEIZABCQZLIZRZUQVA
      SCUACVAUBUTVEUOCEUCVASCUDVAURLCUEUFVFABUSPUTABDUSFUGABUSUHTVKVGVHOZVJOVEV
      GVHVJUIVLVBVJVDVBVLABEEUJUKVIVCLABCUPULUMTUN $.

    $( The "finitely separated" relation is an equivalence relation.
       (Contributed by Mario Carneiro, 24-Aug-2015.) $)
    xmeter $p |- ( D e. ( *Met ` X ) -> .~ Er X ) $=
      ( vx vy vz wcel wrel cr cxr wceq cv wbr wa w3a xmeterval biimpa adantrr
      co cxmt cfv cxp wss cdm ccnv cima cnvimass eqsstri xmetf fdm syl syl5sseq
      wf relxp relss simp2d simp1d simpl xmetsym syl3anc simp3d eqeltrrd adantr
      ee10 wb mpbir3and adantrl cxad cle rexadd readdcl eqeltrd syl2anc xmettri
      caddc syl13anc xmetlecl syl122anc xmet0 syl6eqel ex pm4.71rd df-3an anidm
      cc0 0re anbi2ci bitri syl6bbr bitr4d iserd ) ACUAUBHZEFGCBWMBCCUCZUDWNIBI
      WMAUEZBWNBAUFJUGWODAJUHUIWMWNKAUNWOWNLACUJWNKAUKULUMCCUOBWNUPVEWMEMZFMZBN
      ZOZWQWPBNZWQCHZWPCHZWQWPATZJHZWSXBXAWPWQATZJHZWMWRXBXAXFPWPWQABCDQRZUQZWS
      XBXAXFXGURZWSXEXCJWSWMXBXAXEXCLWMWRUSXIXHWPWQACUTVAWSXBXAXFXGVBZVCWMWTXAX
      BXDPVFWRWQWPABCDQVDVGWMWRWQGMZBNZOZOZWPXKBNZXBXKCHZWPXKATZJHZWMWRXBXLXISZ
      XNXAXPWQXKATZJHZWMXLXAXPYAPZWRWMXLYBWQXKABCDQRVHZUQZXNWMXBXPXEXTVITZJHZXQ
      YEVJNZXRWMXMUSZXSYDXNXFYAYFWMWRXFXLXJSXNXAXPYAYCVBXFYAOYEXEXTVPTJXEXTVKXE
      XTVLVMVNXNWMXBXPXAYGYHXSYDWMWRXAXLXHSWPXKWQACVOVQWPXKYEACVRVSWMXOXBXPXRPV
      FXMWPXKABCDQVDVGWMXBXBXBWPWPATZJHZPZWPWPBNWMXBYJXBOZYKWMXBYJWMXBYJWMXBOYI
      WFJWPACVTWGWAWBWCYKXBXBOZYJOYLXBXBYJWDYMXBYJXBWEWHWIWJWPWPABCDQWKWL $.

    $( The equivalence classes under the finite separation equivalence relation
       are infinity balls.  Thus, by ~ erdisj , infinity balls are either
       identical or disjoint, quite unlike the usual situation with Euclidean
       balls which admit many kinds of overlap.  (Contributed by Mario
       Carneiro, 24-Aug-2015.) $)
    xmetec $p |- ( ( D e. ( *Met ` X ) /\ P e. X ) ->
        [ P ] .~ = ( P ( ball ` D ) +oo ) ) $=
      ( vx cxmt cfv wcel wa cec cpnf cbl co cv wbr cr w3a xmeterval cvv baib wb
      3anass sylan9bb vex a1i elecg sylan xblpnf 3bitr4d eqrdv ) ADGHIZBDIZJZFB
      CKZBLAMHNZUNBFOZCPZUQDIZBUQANQIZJZUQUOIZUQUPIULURUMUSUTRZUMVABUQACDESVCUM
      VAUMUSUTUCUAUDULUQTIZUMVBURUBVDULFUEUFUQBCTDUGUHUQABDUIUJUK $.

    $( A ball centered at ` P ` is contained in the set of points finitely
       separated from ` P ` .  This is just an application of ~ ssbl to the
       infinity ball.  (Contributed by Mario Carneiro, 24-Aug-2015.) $)
    blssec $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ S e. RR* ) ->
        ( P ( ball ` D ) S ) C_ [ P ] .~ ) $=
      ( cxmt cfv wcel cxr w3a cbl co cpnf cec wss wa cle wbr pnfge adantl pnfxr
      wi ssbl 3expia mpanr2 mpd 3impa wceq xmetec 3adant3 sseqtr4d ) AEGHIZBEIZ
      DJIZKBDALHZMZBNUPMZBCOZUMUNUOUQURPZUMUNQZUOQDNRSZUTUOVBVADTUAVAUONJIZVBUT
      UCUBVAUOVCQVBUTABDNEUDUEUFUGUHUMUNUSURUIUOABCEFUJUKUL $.
  $}

  $( The infinity ball in an extended metric acts like an ultrametric ball in
     that every point in the ball is also its center.  (Contributed by Mario
     Carneiro, 21-Aug-2015.) $)
  blpnfctr $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\
      A e. ( P ( ball ` D ) +oo ) ) ->
    ( P ( ball ` D ) +oo ) = ( A ( ball ` D ) +oo ) ) $=
    ( cxmt cfv wcel cpnf cbl co w3a ccnv cima cec wer eqid xmeter wceq xmetec
    cr 3ad2ant1 wbr simp3 3adant3 eleqtrrd elecg ancoms 3adant1 mpbid erthi cxr
    wb wa wss pnfxr blssm mp3an3 sselda adantlr syldan 3impa 3eqtr3d ) BDEFGZCD
    GZACHBIFZJZGZKZCBLTMZNZAVINZVFAHVEJZVHCAVIDVCVDDVIOVGBVIDVIPZQUAVHAVJGZCAVI
    UBZVHAVFVJVCVDVGUCVCVDVJVFRVGBCVIDVMSUDZUEVDVGVNVOULZVCVGVDVQACVIVFDUFUGUHU
    IUJVPVCVDVGVKVLRZVCVDUMZVGADGZVRVSVFDAVCVDHUKGVFDUNUOBCHDUPUQURVCVTVRVDBAVI
    DVMSUSUTVAVB $.

  ${
    $d x y B $.  $d x y D $.  $d x y P $.  $d x y R $.  $d x y X $.
    xmetresbl.1 $e |- B = ( P ( ball ` D ) R ) $.
    $( An extended metric restricted to any ball (in particular the infinity
       ball) is a proper metric.  Together with ~ xmetec , this shows that any
       extended metric space can be "factored" into the disjoint union of
       proper metric spaces, with points in the same region measured by that
       region's metric, and points in different regions being distance ` +oo `
       from each other.  (Contributed by Mario Carneiro, 23-Aug-2015.) $)
    xmetresbl $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
        ( D |` ( B X. B ) ) e. ( Met ` B ) ) $=
      ( vx vy cxmt cfv wcel cxr cr wf co syl2anc syl wbr wb mpbid w3a cxp simp1
      cres cme wss cbl blssm syl5eqss xmetres2 wfn wral xmetf xpss12 fssres ffn
      cv wa wceq ovres adantl ccnv cima wer simpl1 xmeter blssec sselda adantrr
      cec simpl2 elecg adantrl ertr3d xmeterval simp3d eqeltrd ralrimivva ffnov
      eqid sylanbrc ismet2 ) BEIJKZCEKZDLKZUAZBAAUBZUDZAIJKZWGMWHNZWHAUEJKWFWCA
      EUFZWIWCWDWEUCZWFACDBUGJOZEFBCDEUHUIZBAEUJPWFWHWGUKZGUQZHUQZWHOZMKZHAULGA
      ULWJWFWGLWHNZWOWFEEUBZLBNZWGXAUFZWTWFWCXBWLBEUMQWFWKWKXCWNWNAEAEUNPXALWGB
      UOPWGLWHUPQWFWSGHAAWFWPAKZWQAKZURZURZWRWPWQBOZMXFWRXHUSWFWPWQAABUTVAXGWPE
      KZWQEKZXHMKZXGWPWQBVBMVCZRZXIXJXKUAZXGWPCWQXLEXGWCEXLVDWCWDWEXFVEZBXLEXLV
      TZVFQXGWPCXLVJZKZCWPXLRZWFXDXRXEWFAXQWPWFAWMXQFBCXLDEXPVGUIZVHVIZXGXRWDXR
      XSSYAWCWDWEXFVKZWPCXLXQEVLPTXGWQXQKZCWQXLRZWFXEYCXDWFAXQWQXTVHVMZXGYCWDYC
      YDSYEYBWQCXLXQEVLPTVNXGWCXMXNSXOWPWQBXLEXPVOQTVPVQVRGHAAMWHVSWAWHAWBWA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Open sets of a metric space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d d x y z D $.  $d x y z X $.
    mopnval.1 $e |- J = ( MetOpen ` D ) $.
    $( An open set is a subset of a metric space which includes a ball around
       each of its points.  Definition 1.3-2 of [Kreyszig] p. 18.  The object
       ` ( MetOpen `` D ) ` is the family of all open sets in the metric space
       determined by the metric ` D ` .  By ~ mopntop , the open sets of a
       metric space form a topology ` J ` , whose base set is ` U. J ` by
       ~ mopnuni .  (Contributed by NM, 1-Sep-2006.)  (Revised by Mario
       Carneiro, 12-Nov-2013.) $)
    mopnval $p |- ( D e. ( *Met ` X ) -> J = ( topGen ` ran ( ball ` D ) ) ) $=
      ( vd cxmt cfv wcel crn cuni cbl wceq fvssunirn sseli cmopn cv fveq2 rneqd
      ctg fveq2d df-mopn fvex fvmpt syl5eq syl ) ACFGZHAFIJZHZBAKGZIZSGZLUFUGAF
      CMNUHBAOGUKDEAEPZKGZIZSGUKUGOULALZUNUJSUOUMUIULAKQRTEUAUJSUBUCUDUE $.

    $( The set of open sets of a metric space ` X ` is a topology on ` X ` .
       Remark in [Kreyszig] p. 19.  This theorem connects the two concepts and
       makes available the theorems for topologies for use with metric spaces.
       (Contributed by Mario Carneiro, 24-Aug-2015.) $)
    mopntopon $p |- ( D e. ( *Met ` X ) -> J e. ( TopOn ` X ) ) $=
      ( cxmt cfv wcel cbl crn ctg ctopon mopnval cuni ctb blbas tgtopon unirnbl
      syl fveq2d eleqtrd eqeltrd ) ACEFGZBAHFIZJFZCKFZABCDLUBUDUCMZKFZUEUBUCNGU
      DUGGACOUCPRUBUFCKACQSTUA $.

    $( The set of open sets of a metric space is a topology.  (Contributed by
       NM, 28-Aug-2006.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    mopntop $p |- ( D e. ( *Met ` X ) -> J e. Top ) $=
      ( cxmt cfv wcel ctopon ctop mopntopon topontop syl ) ACEFGBCHFGBIGABCDJCB
      KL $.

    $( The union of all open sets in a metric space is its underlying set.
       (Contributed by NM, 4-Sep-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    mopnuni $p |- ( D e. ( *Met ` X ) -> X = U. J ) $=
      ( cxmt cfv wcel ctopon cuni wceq mopntopon toponuni syl ) ACEFGBCHFGCBIJA
      BCDKCBLM $.

    $( The defining property of an open set of a metric space.  (Contributed by
       NM, 1-Sep-2006.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    elmopn $p |- ( D e. ( *Met ` X ) -> ( A e. J <->
   ( A C_ X /\ A. x e. A E. y e. ran ( ball ` D ) ( x e. y /\ y C_ A ) ) ) ) $=
      ( cxmt cfv wcel cbl crn ctg cuni wss cv wa wrex wral ctb mopnval wb blbas
      eleq2d eltg2 syl unirnbl sseq2d anbi1d 3bitrd ) DFHIJZCEJCDKILZMIZJZCULNZ
      OZAPBPZJUQCOQBULRACSZQZCFOZURQUKEUMCDEFGUAUDUKULTJUNUSUBDFUCABCULTUEUFUKU
      PUTURUKUOFCDFUGUHUIUJ $.

    $( The family of open sets of a metric space is a collection of subsets of
       the base set.  (Contributed by NM, 3-Sep-2006.)  (Revised by Mario
       Carneiro, 12-Nov-2013.) $)
    mopnfss $p |- ( D e. ( *Met ` X ) -> J C_ ~P X ) $=
      ( cxmt cfv wcel cuni cpw pwuni mopnuni pweqd syl5sseqr ) ACEFGZBHZIBCIBJN
      COABCDKLM $.

    $( The base set of a metric space is open.  Part of Theorem T1 of
       [Kreyszig] p. 19.  (Contributed by NM, 4-Sep-2006.)  (Revised by Mario
       Carneiro, 12-Nov-2013.) $)
    mopnm $p |- ( D e. ( *Met ` X ) -> X e. J ) $=
      ( cxmt cfv wcel ctopon mopntopon toponmax syl ) ACEFGBCHFGCBGABCDICBJK $.

    $( A defining property of an open set of a metric space.  (Contributed by
       NM, 5-May-2007.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    elmopn2 $p |- ( D e. ( *Met ` X ) -> ( A e. J <-> ( A C_ X /\
           A. x e. A E. y e. RR+ ( x ( ball ` D ) y ) C_ A ) ) ) $=
      ( vz cxmt cfv wcel wss cv wa cbl crn wrex wral co crp elmopn ssel2 blssex
      wb sylan2 anassrs ralbidva pm5.32da bitrd ) DFIJKZCEKCFLZAMZHMZKUMCLNHDOJ
      ZPQZACRZNUKULBMUNSCLBTQZACRZNAHCDEFGUAUJUKUPURUJUKNUOUQACUJUKULCKZUOUQUDZ
      UKUSNUJULFKUTCFULUBHCDULFBUCUEUFUGUHUI $.

    $( An open set of a metric space is a subspace of its base set.
       (Contributed by NM, 3-Sep-2006.) $)
    mopnss $p |- ( ( D e. ( *Met ` X ) /\ A e. J ) -> A C_ X ) $=
      ( cxmt cfv wcel ctopon wss mopntopon toponss sylan ) BDFGHCDIGHACHADJBCDE
      KACDLM $.
  $}

  ${
    $d d w x y z $.  $d f x D $.  $d f x J $.  $d f K $.  $d f x X $.
    isms.j $e |- J = ( TopOpen ` K ) $.
    isms.x $e |- X = ( Base ` K ) $.
    isms.d $e |- D = ( ( dist ` K ) |` ( X X. X ) ) $.
    $( Express the predicate " ` <. X , D >. ` is an extended metric space"
       with underlying set ` X ` and distance function ` D ` .  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    isxms $p |- ( K e. *MetSp <-> ( K e. TopSp /\ J = ( MetOpen ` D ) ) ) $=
      ( vf cv ctopn cfv cds cbs cxp cres cmopn wceq ctps fveq2 syl6eqr reseq12d
      cxme xpeq12d fveq2d eqeq12d df-xms elrab2 ) HIZJKZUHLKZUHMKZUKNZOZPKZQBAP
      KZQHCRUBUHCQZUIBUNUOUPUICJKBUHCJSETUPUMAPUPUMCLKZDDNZOAUPUJUQULURUHCLSUPU
      KDUKDUPUKCMKDUHCMSFTZUSUCUAGTUDUEHUFUG $.

    $( Express the predicate " ` <. X , D >. ` is an extended metric space"
       with underlying set ` X ` and distance function ` D ` .  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    isxms2 $p |- ( K e. *MetSp <->
        ( D e. ( *Met ` X ) /\ J = ( MetOpen ` D ) ) ) $=
      ( vx wcel cmopn cfv wceq wa cxmt ctopon cdm crn cuni adantl syl cxme ctps
      isxms istps cv cbl df-mopn dmmptss toponmax simpl elfvdm sseldi xmetunirn
      eleqtrd sylib eqid mopntopon eqeltrd toponuni eqtr4d fveq2d eleq1 syl5ibr
      ctg ex impbid syl5bb pm5.32ri bitri ) CUAICUBIZBAJKZLZMADNKZIZVLMABCDEFGU
      CVLVJVNVJBDOKZIZVLVNDBCFEUDVLVPVNVLVPVNVLVPMZAAPPZNKZVMVQANQRZIAVSIZVQJPZ
      VTAHVTHUEUFKQVDKJHUGUHVQDVKIAWBIVQDBVKVPDBIVLDBUISVLVPUJZUNDAJUKTULAUMUOZ
      VQVRDNVQVRBRZDVQBVROKZIVRWELVQBVKWFWCVQWAVKWFIWDAVKVRVKUPZUQTURVRBUSTVPDW
      ELVLDBUSSUTVAUNVEVNVPVLVKVOIAVKDWGUQBVKVOVBVCVFVGVHVI $.

    $( Express the predicate " ` <. X , D >. ` is a metric space" with
       underlying set ` X ` and distance function ` D ` .  (Contributed by NM,
       27-Aug-2006.)  (Revised by Mario Carneiro, 24-Aug-2015.) $)
    isms $p |- ( K e. MetSp <-> ( K e. *MetSp /\ D e. ( Met ` X ) ) ) $=
      ( vf cv cds cfv cbs cxp cres cme wcel cxme cmt fveq2 syl6eqr wceq xpeq12d
      reseq12d fveq2d eleq12d df-ms elrab2 ) HIZJKZUHLKZUJMZNZUJOKZPADOKZPHCQRU
      HCUAZULAUMUNUOULCJKZDDMZNAUOUIUPUKUQUHCJSUOUJDUJDUOUJCLKDUHCLSFTZURUBUCGT
      UOUJDOURUDUEHUFUG $.

    $( Express the predicate " ` <. X , D >. ` is a metric space" with
       underlying set ` X ` and distance function ` D ` .  (Contributed by NM,
       27-Aug-2006.)  (Revised by Mario Carneiro, 24-Aug-2015.) $)
    isms2 $p |- ( K e. MetSp <->
        ( D e. ( Met ` X ) /\ J = ( MetOpen ` D ) ) ) $=
      ( cxme wcel cme cfv wa cxmt cmopn wceq cmt isxms2 anbi1i isms metxmet
      pm4.71ri an32 bitri 3bitr4i ) CHIZADJKIZLADMKIZBANKOZLZUFLZCPIUFUHLZUEUIU
      FABCDEFGQRABCDEFGSUKUGUFLZUHLUJUFULUHUFUGADTUARUGUFUHUBUCUD $.

    $( The topology component of a metric space coincides with the topology
       generated by the metric component.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    xmstopn $p |- ( K e. *MetSp -> J = ( MetOpen ` D ) ) $=
      ( cxme wcel ctps cmopn cfv wceq isxms simprbi ) CHICJIBAKLMABCDEFGNO $.

    $( The topology component of a metric space coincides with the topology
       generated by the metric component.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    mstopn $p |- ( K e. MetSp -> J = ( MetOpen ` D ) ) $=
      ( cmt wcel cme cfv cmopn wceq isms2 simprbi ) CHIADJKIBALKMABCDEFGNO $.
  $}

  $( A metric space is a topological space.  (Contributed by Mario Carneiro,
     26-Aug-2015.) $)
  xmstps $p |- ( M e. *MetSp -> M e. TopSp ) $=
    ( cxme wcel ctps ctopn cfv cds cbs cxp cres cmopn wceq eqid isxms simplbi )
    ABCADCAEFZAGFAHFZQIJZKFLRPAQPMQMRMNO $.

  $( A metric space is a topological space.  (Contributed by Mario Carneiro,
     26-Aug-2015.) $)
  msxms $p |- ( M e. MetSp -> M e. *MetSp ) $=
    ( cmt wcel cxme cds cfv cbs cxp cres cme ctopn eqid isms simplbi ) ABCADCAE
    FAGFZOHIZOJFCPAKFZAOQLOLPLMN $.

  $( A metric space is a topological space.  (Contributed by Mario Carneiro,
     26-Aug-2015.) $)
  mstps $p |- ( M e. MetSp -> M e. TopSp ) $=
    ( cmt wcel cxme ctps msxms xmstps syl ) ABCADCAECAFAGH $.

  ${
    msf.x $e |- X = ( Base ` M ) $.
    msf.d $e |- D = ( ( dist ` M ) |` ( X X. X ) ) $.
    $( The distance function, suitably truncated, is a metric on ` X ` .
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    xmsxmet $p |- ( M e. *MetSp -> D e. ( *Met ` X ) ) $=
      ( cxme wcel cxmt cfv ctopn cmopn wceq eqid isxms2 simplbi ) BFGACHIGBJIZA
      KILAPBCPMDENO $.

    $( The distance function, suitably truncated, is a metric on ` X ` .
       (Contributed by Mario Carneiro, 12-Nov-2013.) $)
    msmet $p |- ( M e. MetSp -> D e. ( Met ` X ) ) $=
      ( cmt wcel cme cfv ctopn cmopn wceq eqid isms2 simplbi ) BFGACHIGBJIZAKIL
      APBCPMDENO $.

    $( Mapping of the distance function of a metric space.  (Contributed by NM,
       30-Aug-2006.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    msf $p |- ( M e. MetSp -> D : ( X X. X ) --> RR ) $=
      ( cmt wcel cme cfv cxp cr wf msmet metf syl ) BFGACHIGCCJKALABCDEMACNO $.
  $}

  ${
    mscl.x $e |- X = ( Base ` M ) $.
    mscl.d $e |- D = ( dist ` M ) $.
    $( The distance function, suitably truncated, is a metric on ` X ` .
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    xmsxmet2 $p |- ( M e. *MetSp -> ( D |` ( X X. X ) ) e. ( *Met ` X ) ) $=
      ( cxp cres cds cfv reseq1i xmsxmet ) ACCFZGBCDABHILEJK $.

    $( The distance function, suitably truncated, is a metric on ` X ` .
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    msmet2 $p |- ( M e. MetSp -> ( D |` ( X X. X ) ) e. ( Met ` X ) ) $=
      ( cxp cres cds cfv reseq1i msmet ) ACCFZGBCDABHILEJK $.

    $( Closure of the distance function of a metric space.  (Contributed by NM,
       30-Aug-2006.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    mscl $p |- ( ( M e. MetSp /\ A e. X /\ B e. X ) -> ( A D B ) e. RR ) $=
      ( cmt wcel w3a cxp cres co cr wceq ovres 3adant1 cme cfv msmet2 eqeltrrd
      metcl syl3an1 ) DHIZAEIZBEIZJABCEEKLZMZABCMZNUEUFUHUIOUDABEECPQUDUGERSIUE
      UFUHNICDEFGTABUGEUBUCUA $.

    $( Closure of the distance function of an extended metric space.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    xmscl $p |- ( ( M e. *MetSp /\ A e. X /\ B e. X ) -> ( A D B ) e. RR* ) $=
      ( cxme wcel w3a cxp cres co cxr wceq ovres 3adant1 cxmt cfv xmsxmet2
      xmetcl syl3an1 eqeltrrd ) DHIZAEIZBEIZJABCEEKLZMZABCMZNUEUFUHUIOUDABEECPQ
      UDUGERSIUEUFUHNICDEFGTABUGEUAUBUC $.

    $( The distance function in an extended metric space is nonnegative.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    xmsge0 $p |- ( ( M e. *MetSp /\ A e. X /\ B e. X ) ->
                   0 <_ ( A D B ) ) $=
      ( cxme wcel w3a cc0 cxp cres co cle cxmt cfv wbr xmsxmet2 xmetge0 syl3an1
      wceq ovres 3adant1 breqtrd ) DHIZAEIZBEIZJKABCEELMZNZABCNZOUFUIEPQIUGUHKU
      JORCDEFGSABUIETUAUGUHUJUKUBUFABEECUCUDUE $.

    $( The distance function in an extended metric space is symmetric.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    xmseq0 $p |- ( ( M e. *MetSp /\ A e. X /\ B e. X ) ->
                   ( ( A D B ) = 0 <-> A = B ) ) $=
      ( cxme wcel w3a cxp cres co cc0 wceq ovres 3adant1 eqeq1d cxmt cfv bitr3d
      wb xmsxmet2 xmeteq0 syl3an1 ) DHIZAEIZBEIZJZABCEEKLZMZNOZABCMZNOABOZUIUKU
      MNUGUHUKUMOUFABEECPQRUFUJESTIUGUHULUNUBCDEFGUCABUJEUDUEUA $.

    $( The distance function in an extended metric space is symmetric.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    xmssym $p |- ( ( M e. *MetSp /\ A e. X /\ B e. X ) ->
                   ( A D B ) = ( B D A ) ) $=
      ( cxme wcel w3a cxp cres co cxmt cfv wceq xmsxmet2 xmetsym syl3an1 ovresd
      simp2 simp3 3eqtr3d ) DHIZAEIZBEIZJZABCEEKLZMZBAUHMZABCMBACMUDUHENOIUEUFU
      IUJPCDEFGQABUHERSUGABCEUDUEUFUAZUDUEUFUBZTUGBACEULUKTUC $.

    $( Triangle inequality for the distance function of an extended metric.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    xmstri2 $p |- ( ( M e. *MetSp /\ ( C e. X /\ A e. X /\ B e. X ) )
                 -> ( A D B ) <_ ( ( C D A ) +e ( C D B ) ) ) $=
      ( cxme wcel w3a wa cxp cres co cxad cle cxmt cfv ovresd xmsxmet2 xmettri2
      wbr sylan simpr2 simpr3 simpr1 oveq12d 3brtr3d ) EIJZCFJZAFJZBFJZKZLZABDF
      FMNZOZCAUPOZCBUPOZPOZABDOCADOZCBDOZPOQUJUPFRSJUNUQUTQUCDEFGHUAABCUPFUBUDU
      OABDFUJUKULUMUEZUJUKULUMUFZTUOURVAUSVBPUOCADFUJUKULUMUGZVCTUOCBDFVEVDTUHU
      I $.

    $( Triangle inequality for the distance function of a metric space.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    mstri2 $p |- ( ( M e. MetSp /\ ( C e. X /\ A e. X /\ B e. X ) )
                 -> ( A D B ) <_ ( ( C D A ) + ( C D B ) ) ) $=
      ( cmt wcel w3a wa cxp cres co caddc cle cme cfv ovresd wbr msmet2 mettri2
      sylan simpr2 simpr3 simpr1 oveq12d 3brtr3d ) EIJZCFJZAFJZBFJZKZLZABDFFMNZ
      OZCAUPOZCBUPOZPOZABDOCADOZCBDOZPOQUJUPFRSJUNUQUTQUADEFGHUBABCUPFUCUDUOABD
      FUJUKULUMUEZUJUKULUMUFZTUOURVAUSVBPUOCADFUJUKULUMUGZVCTUOCBDFVEVDTUHUI $.

    $( Triangle inequality for the distance function of a metric space.
       Definition 14-1.1(d) of [Gleason] p. 223.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    xmstri $p |- ( ( M e. *MetSp /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) +e ( C D B ) ) ) $=
      ( cxme wcel w3a wa cxp cres co cxad cle cxmt cfv ovresd wbr xmettri sylan
      xmsxmet2 simpr1 simpr2 simpr3 oveq12d 3brtr3d ) EIJZAFJZBFJZCFJZKZLZABDFF
      MNZOZACUPOZCBUPOZPOZABDOACDOZCBDOZPOQUJUPFRSJUNUQUTQUADEFGHUDABCUPFUBUCUO
      ABDFUJUKULUMUEZUJUKULUMUFZTUOURVAUSVBPUOACDFVCUJUKULUMUGZTUOCBDFVEVDTUHUI
      $.

    $( Triangle inequality for the distance function of a metric space.
       Definition 14-1.1(d) of [Gleason] p. 223.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    mstri $p |- ( ( M e. MetSp /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) + ( C D B ) ) ) $=
      ( cmt wcel w3a wa cxp cres co caddc cle cme cfv ovresd wbr msmet2 oveq12d
      mettri sylan simpr1 simpr2 simpr3 3brtr3d ) EIJZAFJZBFJZCFJZKZLZABDFFMNZO
      ZACUPOZCBUPOZPOZABDOACDOZCBDOZPOQUJUPFRSJUNUQUTQUADEFGHUBABCUPFUDUEUOABDF
      UJUKULUMUFZUJUKULUMUGZTUOURVAUSVBPUOACDFVCUJUKULUMUHZTUOCBDFVEVDTUCUI $.

    $( Triangle inequality for the distance function of an extended metric.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    xmstri3 $p |- ( ( M e. *MetSp /\ ( A e. X /\ B e. X /\ C e. X ) )
                 -> ( A D B ) <_ ( ( A D C ) +e ( B D C ) ) ) $=
      ( cxme wcel w3a wa cxp cres co cxad cle cxmt cfv ovresd xmsxmet2 xmettri3
      wbr sylan simpr1 simpr2 simpr3 oveq12d 3brtr3d ) EIJZAFJZBFJZCFJZKZLZABDF
      FMNZOZACUPOZBCUPOZPOZABDOACDOZBCDOZPOQUJUPFRSJUNUQUTQUCDEFGHUAABCUPFUBUDU
      OABDFUJUKULUMUEZUJUKULUMUFZTUOURVAUSVBPUOACDFVCUJUKULUMUGZTUOBCDFVDVETUHU
      I $.

    $( Triangle inequality for the distance function of a metric space.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    mstri3 $p |- ( ( M e. MetSp /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( A D B ) <_ ( ( A D C ) + ( B D C ) ) ) $=
      ( cmt wcel w3a wa cxp cres co caddc cle cme cfv ovresd wbr msmet2 mettri3
      sylan simpr1 simpr2 simpr3 oveq12d 3brtr3d ) EIJZAFJZBFJZCFJZKZLZABDFFMNZ
      OZACUPOZBCUPOZPOZABDOACDOZBCDOZPOQUJUPFRSJUNUQUTQUADEFGHUBABCUPFUCUDUOABD
      FUJUKULUMUEZUJUKULUMUFZTUOURVAUSVBPUOACDFVCUJUKULUMUGZTUOBCDFVDVETUHUI $.

    $( Reverse triangle inequality for the distance function of a metric
       space.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    msrtri $p |- ( ( M e. MetSp /\ ( A e. X /\ B e. X /\ C e. X ) )
              -> ( abs ` ( ( A D C ) - ( B D C ) ) ) <_ ( A D B ) ) $=
      ( cmt wcel w3a wa cxp cres co cmin cabs cfv cle ovresd cme msmet2 metrtri
      wbr sylan simpr1 simpr3 simpr2 oveq12d fveq2d 3brtr3d ) EIJZAFJZBFJZCFJZK
      ZLZACDFFMNZOZBCUROZPOZQRZABUROZACDOZBCDOZPOZQRABDOSULURFUARJUPVBVCSUDDEFG
      HUBABCURFUCUEUQVAVFQUQUSVDUTVEPUQACDFULUMUNUOUFZULUMUNUOUGZTUQBCDFULUMUNU
      OUHZVHTUIUJUQABDFVGVITUK $.

  $}

  ${
    xmspropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    xmspropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    xmspropd.3 $e |- ( ph ->
      ( ( dist ` K ) |` ( B X. B ) ) = ( ( dist ` L ) |` ( B X. B ) ) ) $.
    xmspropd.4 $e |- ( ph -> ( TopOpen ` K ) = ( TopOpen ` L ) ) $.
    $( Property deduction for an extended metric space.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    xmspropd $p |- ( ph -> ( K e. *MetSp <-> L e. *MetSp ) ) $=
      ( ctps wcel ctopn cfv cds cbs cxp cres cmopn wceq eqtr3d eqid wa tpspropd
      cxme xpeq12d reseq2d fveq2d eqeq12d anbi12d isxms 3bitr4g ) ACIJZCKLZCMLZ
      CNLZUNOZPZQLZRZUADIJZDKLZDMLZDNLZVBOZPZQLZRZUACUCJDUCJAUKUSURVFACDABUNVBE
      FSHUBAULUTUQVEHAUPVDQAVABBOZPZUPVDAUMVGPVHUPGAVGUOUMABUNBUNEEUDUESAVGVCVA
      ABVBBVBFFUDUESUFUGUHUPULCUNULTUNTUPTUIVDUTDVBUTTVBTVDTUIUJ $.

    $( Property deduction for a metric space.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    mspropd $p |- ( ph -> ( K e. MetSp <-> L e. MetSp ) ) $=
      ( cxme wcel cds cfv cbs cxp cres cme wa cmt eqtr3d eqid fveq2d ctopn isms
      xmspropd xpeq12d reseq2d eleq12d anbi12d 3bitr4g ) ACIJZCKLZCMLZULNZOZULP
      LZJZQDIJZDKLZDMLZUSNZOZUSPLZJZQCRJDRJAUJUQUPVCABCDEFGHUDAUNVAUOVBAURBBNZO
      ZUNVAAUKVDOVEUNGAVDUMUKABULBULEEUEUFSAVDUTURABUSBUSFFUEUFSAULUSPABULUSEFS
      UAUGUHUNCUBLZCULVFTULTUNTUCVADUBLZDUSVGTUSTVATUCUI $.
  $}

  ${
    setsms.x $e |- ( ph -> X = ( Base ` M ) ) $.
    setsms.d $e |- ( ph -> D = ( ( dist ` M ) |` ( X X. X ) ) ) $.
    setsms.k $e |- ( ph -> K =
      ( M sSet <. ( TopSet ` ndx ) , ( MetOpen ` D ) >. ) ) $.
    $( The base set of a constructed metric space.  (Contributed by Mario
       Carneiro, 28-Aug-2015.) $)
    setsmsbas $p |- ( ph -> X = ( Base ` K ) ) $=
      ( cbs cfv cnx cts cmopn cop csts co baseid wne c1 c9 1lt9 basendx tsetndx
      1re ltneii neeq12i mpbir setsnid fveq2d 3eqtr4a ) ADIJDKLJZBMJZNOPZIJECIJ
      ULUKIDQKIJZUKRSTRSTUDUAUEUNSUKTUBUCUFUGUHFACUMIHUIUJ $.

    $( The distance function of a constructed metric space.  (Contributed by
       Mario Carneiro, 28-Aug-2015.) $)
    setsmsds $p |- ( ph -> ( dist ` M ) = ( dist ` K ) ) $=
      ( cds cfv cnx cts cmopn cop csts co wne c1 c2 c9 fveq2d dsid cdc 9re 2nn0
      1nn 9nn0 9lt10 declti gtneii dsndx tsetndx neeq12i mpbir setsnid syl6reqr
      ) ACIJDKLJZBMJZNOPZIJDIJACUSIHUAURUQIDUBKIJZUQQRSUCZTQTVAUDRSTUFUEUGUHUIU
      JUTVAUQTUKULUMUNUOUP $.

    setsms.m $e |- ( ph -> M e. V ) $.
    $( The topology of a constructed metric space.  (Contributed by Mario
       Carneiro, 28-Aug-2015.) $)
    setsmstset $p |- ( ph -> ( MetOpen ` D ) = ( TopSet ` K ) ) $=
      ( cmopn cfv cnx cts cop csts co wcel cvv wceq tsetid setsid fveq2d eqtr4d
      fvex sylancl ) ABKLZDMNLUGOPQZNLZCNLADERUGSRUGUITJBKUEEUGNSDUAUBUFACUHNIU
      CUD $.

    $d d w x y z D $.  $d x M $.  $d x V $.  $d x X $.
    $( The topology of a constructed metric space.  (Contributed by Mario
       Carneiro, 28-Aug-2015.) $)
    setsmstopn $p |- ( ph -> ( MetOpen ` D ) = ( TopOpen ` K ) ) $=
      ( vx cmopn cfv cpw wss wceq cdm wcel eqid syl cts setsmstset cbs cxmt crn
      ctopn cuni cv cbl ctg df-mopn dmmptss sseli simpr xmetunirn sylib mopnuni
      cxp cds cin cres dmeqd dmres syl6eq inss1 syl6eqss dmxpid syl6sseq adantr
      wa dmss eqsstr3d sspwuni sylibr ex syl5 wn ndmfv pm2.61d1 setsmsbas pweqd
      c0 0ss 3sstr3d topnid eqtrd ) ABLMZCUAMZCUFMZABCDEFGHIJUBZAWHCUCMZNZOWHWI
      PAWGFNZWHWLABLQZRZWGWMOZWOBUDUEUGZRZAWPWNWQBKWQKUHUIMUEUJMLKUKULUMAWRWPAW
      RVJZWGUGZFOWPWSWTBQZQZFWSBXBUDMRZXBWTPWSWRXCAWRUNBUOUPBWGXBWGSUQTAXBFOWRA
      XBFFURZQZFAXAXDOXBXEOAXAXDDUSMZQZUTZXDAXAXFXDVAZQXHABXIHVBXFXDVCVDXDXGVEV
      FXAXDVKTFVGVHVIVLWGFVMVNVOVPWOVQWGWBWMBLVRWMWCVFVSWJAFWKABCDFGHIVTWAWDWKW
      HCWKSWHSWETWF $.

    $( The constructed metric space is a metric space iff the provided distance
       function is a metric.  (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    setsxms $p |- ( ph -> ( K e. *MetSp <-> D e. ( *Met ` X ) ) ) $=
      ( cxme wcel cds cfv cxp cres cxmt cmopn fveq2d eqid ctopn wceq setsmstopn
      cbs setsmsds setsmsbas xpeq12d reseq12d eqtrd eqtr3d isxms2 rbaib eleq12d
      wb syl bitr4d ) ACKLZCMNZCUDNZUSOZPZUSQNZLZBFQNZLACUANZVARNZUBZUQVCUNABRN
      VEVFABCDEFGHIJUCABVARABDMNZFFOZPVAHAVHURVIUTABCDFGHIUEAFUSFUSABCDFGHIUFZV
      JUGUHUIZSUJUQVCVGVAVECUSVETUSTVATUKULUOABVAVDVBVKAFUSQVJSUMUP $.

    $( The constructed metric space is a metric space iff the provided distance
       function is a metric.  (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    setsms $p |- ( ph -> ( K e. MetSp <-> D e. ( Met ` X ) ) ) $=
      ( cxme wcel cds cfv cbs cxp cres cme wa eqid cmt setsxms setsmsds xpeq12d
      cxmt setsmsbas reseq12d eqtr2d fveq2d eqcomd eleq12d anbi12d isms metxmet
      ctopn pm4.71ri 3bitr4g ) ACKLZCMNZCONZUTPZQZUTRNZLZSBFUENLZBFRNZLZSCUALVG
      AURVEVDVGABCDEFGHIJUBAVBBVCVFABDMNZFFPZQVBHAVHUSVIVAABCDFGHIUCAFUTFUTABCD
      FGHIUFZVJUDUGUHAVFVCAFUTRVJUIUJUKULVBCUONZCUTVKTUTTVBTUMVGVEBFUNUPUQ $.
  $}

  ${
    $d d D $.  $d d M $.  $d d X $.
    tmsval.m $e |- M =
      { <. ( Base ` ndx ) , X >. , <. ( dist ` ndx ) , D >. } $.
    tmsval.k $e |- K = ( toMetSp ` D ) $.
    $( For any metric there is an associated metric space.  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    tmsval $p |- ( D e. ( *Met ` X ) ->
      K = ( M sSet <. ( TopSet ` ndx ) , ( MetOpen ` D ) >. ) ) $=
      ( vd cxmt cfv wcel ctmt cnx cmopn cop csts co cdm cpr wceq opeq2d cts cbs
      cv cds crn cuni cvv cmpt df-tms a1i wa dmeq dmeqd cxp cxr wf xmetf dmxpid
      fdm syl6eq sylan9eqr simpr preq12d syl6eqr fveq2d oveq12d fvssunirn sseli
      syl ovex fvmptd syl5eq ) ADHIZJZBAKICLUAIZAMIZNZOPZFVNGALUBIZGUCZQZQZNZLU
      DIZVTNZRZVOVTMIZNZOPZVRHUEUFZKUGKGWJWIUHSVNGUIUJVNVTASZUKZWFCWHVQOWLWFVSD
      NZWDANZRCWLWCWMWEWNWLWBDVSWKVNWBAQZQZDWKWAWOVTAULUMVNWPDDUNZQDVNWOWQVNWQU
      OAUPWOWQSADUQWQUOAUSVIUMDURUTVATWLVTAWDVNWKVBZTVCEVDWLWGVPVOWLVTAMWRVETVF
      VMWJAHDVGVHVRUGJVNCVQOVJUJVKVL $.

    $( Lemma for ~ tmsbas , ~ tmsds , and ~ tmstopn .  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    tmslem $p |- ( D e. ( *Met ` X ) -> ( X = ( Base ` K ) /\
        D = ( dist ` K ) /\ ( MetOpen ` D ) = ( TopOpen ` K ) ) ) $=
      ( cxmt cfv wcel cbs wceq cds c1 c2 df-ds 1nn0 cres cxr cvv cnx cdm elfvdm
      cmopn ctopn cdc 1nn 1lt10 declti 2nn decnncl 2strbas syl cxp wf wfn xmetf
      2nn0 ffn fnresdm 3syl 2strop reseq1d eqtr3d tmsval setsmsbas setsmsds cop
      eqtrd cpr prex eqeltri a1i setsmstopn 3jca ) ADGHZIZDBJHKABLHZKAUCHBUDHKV
      PABCDVPDGUAZIDCJHKADGUBDALCMNUEZVREOMNMUFUQPUGUHZMNPUIUJZUKULZVPADDUMZQZA
      CLHZWCQVPWCRAUNAWCUOWDAKADUPWCRAURWCAUSUTVPAWEWCDALCVSVOEOVTWAVAZVBVCZABC
      DEFVDZVEVPAWEVQWFVPABCDWBWGWHVFVHVPABCSDWBWGWHCSIVPCTJHDVGZTLHAVGZVISEWIW
      JVJVKVLVMVN $.
  $}

  ${
    tmsbas.k $e |- K = ( toMetSp ` D ) $.
    $( The base set of a constructed metric space.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    tmsbas $p |- ( D e. ( *Met ` X ) -> X = ( Base ` K ) ) $=
      ( cxmt cfv wcel cbs wceq cds cmopn ctopn cnx cop cpr eqid tmslem simp1d )
      ACEFGCBHFIABJFIAKFBLFIABMHFCNMJFANOZCSPDQR $.

    $( The metric of a constructed metric space.  (Contributed by Mario
       Carneiro, 2-Sep-2015.) $)
    tmsds $p |- ( D e. ( *Met ` X ) -> D = ( dist ` K ) ) $=
      ( cxmt cfv wcel cbs wceq cds cmopn ctopn cnx cop cpr eqid tmslem simp2d )
      ACEFGCBHFIABJFIAKFBLFIABMHFCNMJFANOZCSPDQR $.

    ${
      tmstopn.j $e |- J = ( MetOpen ` D ) $.
      $( The topology of a constructed metric.  (Contributed by Mario Carneiro,
         2-Sep-2015.) $)
      tmstopn $p |- ( D e. ( *Met ` X ) -> J = ( TopOpen ` K ) ) $=
        ( cxmt cfv wcel cmopn ctopn cbs wceq cds cnx cop cpr eqid tmslem simp3d
        syl5eq ) ADGHIZBAJHZCKHZFUBDCLHMACNHMUCUDMACOLHDPONHAPQZDUERESTUA $.
    $}

    $( The constructed metric space is an extended metric space.  (Contributed
       by Mario Carneiro, 2-Sep-2015.) $)
    tmsxms $p |- ( D e. ( *Met ` X ) -> K e. *MetSp ) $=
      ( cxmt cfv wcel cds cbs cxp cres ctopn cmopn wceq cxme wss tmsds cxr eqid
      fveq2d tmsbas eleq12d ibi ssid xmetres2 sylancl wf wfn xmetf fnresdm 4syl
      ffn eqtr4d tmstopn eqtr2d isxms2 sylanbrc ) ACEFZGZBHFZBIFZVAJZKZVAEFZGZB
      LFZVCMFZNBOGUSUTVDGZVAVAPVEUSVHUSAUTURVDABCDQZUSCVAEABCDUATUBUCZVAUDUTVAV
      AUEUFUSVGAMFZVFUSVCAMUSVCUTAUSVHVBRUTUGUTVBUHVCUTNVJUTVAUIVBRUTULVBUTUJUK
      VIUMTAVKBCDVKSUNUOVCVFBVAVFSVASVCSUPUQ $.

    $( The constructed metric space is a metric space given a metric.
       (Contributed by Mario Carneiro, 2-Sep-2015.) $)
    tmsms $p |- ( D e. ( Met ` X ) -> K e. MetSp ) $=
      ( cme cfv wcel cxme cds cbs cxp cres cmt cxmt metxmet tmsxms syl wss wceq
      eqid tmsds tmsbas fveq2d eleq12d ssid metres2 sylancl ctopn isms sylanbrc
      ibi ) ACEFZGZBHGZBIFZBJFZUPKLZUPEFZGZBMGUMACNFGZUNACOZABCDPQUMUOURGZUPUPR
      USUMVBUMAUOULURUMUTAUOSVAABCDUAQUMCUPEUMUTCUPSVAABCDUBQUCUDUKUPUEUOUPUPUF
      UGUQBUHFZBUPVCTUPTUQTUIUJ $.
  $}

  ${
    $d x D $.  $d x E $.  $d r x y z F $.  $d x P $.  $d r x y ph $.  $d x S $.
    $d r y z B $.  $d r x y R $.  $d r x y z U $.  $d r x y z V $.
    imasf1obl.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasf1obl.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasf1obl.f $e |- ( ph -> F : V -1-1-onto-> B ) $.
    ${
      imasf1obl.r $e |- ( ph -> R e. Z ) $.
      imasf1obl.e $e |- E = ( ( dist ` R ) |` ( V X. V ) ) $.
      imasf1obl.d $e |- D = ( dist ` U ) $.
      imasf1obl.m $e |- ( ph -> E e. ( *Met ` V ) ) $.
      imasf1obl.x $e |- ( ph -> P e. V ) $.
      imasf1obl.s $e |- ( ph -> S e. RR* ) $.
      $( The image of a metric space ball.  (Contributed by Mario Carneiro,
         28-Aug-2015.) $)
      imasf1obl $p |- ( ph ->
          ( ( F ` P ) ( ball ` D ) S ) = ( F " ( P ( ball ` E ) S ) ) ) $=
        ( vx cfv cbl co ccnv cima cv wcel clt wbr wa wf1o wceq f1ocnvfv2 oveq2d
        sylan cimas adantr cbs cxmt wf f1ocnv ffvelrnda imasdsf1o eqtr3d breq1d
        syl f1of wb elbl2 syl22anc bitr4d pm5.32da imasf1oxmet ffvelrnd syl3anc
        cxr elbl wfn f1ofn elpreima 3syl 3bitr4d eqrdv imacnvcnv syl6eq ) ADIUB
        ZFCUCUBUDZIUEZUEDFHUCUBUDZUFZIWJUFAUAWHWKAUAUGZBUHZWGWLCUDZFUIUJZUKZWMW
        LWIUBZWJUHZUKZWLWHUHZWLWKUHZAWMWOWRAWMUKZWODWQHUDZFUIUJZWRXBWNXCFUIXBWG
        WQIUBZCUDWNXCXBXEWLWGCAJBIULZWMXEWLUMNJBWLIUNUPUOXBBCEGHIJDWQKAGIEUQUDU
        MWMLURAJEUSUBUMWMMURAXFWMNURAEKUHWMOURPQAHJUTUBUHZWMRURZADJUHZWMSURZABJ
        WLWIABJWIULZBJWIVAAXFXKNJBIVBVGZBJWIVHVGVCZVDVEVFXBXGFVQUHZXIWQJUHWRXDV
        IXHAXNWMTURXJXMWQHDFJVJVKVLVMACBUTUBUHWGBUHXNWTWPVIABCEGHIJKLMNOPQRVNAJ
        BDIAXFJBIVANJBIVHVGSVOTWLCWGFBVRVPAXKWIBVSXAWSVIXLBJWIVTBWLWJWIWAWBWCWD
        IWJWEWF $.
    $}

    ${
      imasf1oxms.r $e |- ( ph -> R e. *MetSp ) $.
      $( The image of a metric space is a metric space.  (Contributed by Mario
         Carneiro, 28-Aug-2015.) $)
      imasf1oxms $p |- ( ph -> U e. *MetSp ) $=
        ( vy vr cfv wcel wceq eqid syl co cxr wrex vx vz cds cbs cxp cres ctopn
        cxmt cmopn cxme xmsxmet xpeq12d reseq2d fveq2d 3eltr4d imasf1oxmet wf1o
        wss f1ofo imasbas eleqtrd ssid xmetres2 sylancl imastopn xmstopn eqtr4d
        wfo cqtop oveq1d cbl crn ctg cuni blbas wb unirnbl f1oeq2 mpbird tgqtop
        ctb 3syl syl2anc mopnval wf wfn xmetf ffn fnresdm cv ccnv cima ad2antrr
        wa wf1 f1of1 cdm cnvimass f1odm syl5sseq simprl simprr syl3anc syl12anc
        blssm f1imaeq simplr foimacnv imasf1obl eqcomd eqeq12d bitr3d 2rexbidva
        cimas adantr f1ofn oveq1 eqeq2d rexbidv rexrn forn rexeqdv 3bitr2d blrn
        3bitr4d pm5.32da elqtop2 cpw blf frn sseld elpwi pm4.71rd eqrdv 3eqtr4d
        syl6 3eqtrd isxms2 sylanbrc ) ADUCMZDUDMZUUAUEZUFZUUAUHMZNZDUGMZUUCUIMZ
        ODUJNAYTUUDNZUUAUUAURUUEAYTBUHMZUUDABYTCDCUCMZFFUEZUFZEFUJGHIJUULPZYTPZ
        AUUJCUDMZUUOUEZUFZUUOUHMZUULFUHMZACUJNZUUQUURNJUUQCUUOUUOPZUUQPZUKQAUUK
        UUPUUJAFUUOFUUOHHULUMZAFUUOUHHUNUOZUPZABUUAUHABCDEFUJGHAFBEUQZFBEVHZIFB
        EUSZQZJUTUNVAZUUAVBYTUUAUUAVCVDAUUFCUGMZEVIRUULUIMZEVIRZUUGABCDEUVKUUFF
        UJGHUVIJUVKPZUUFPZVEAUVKUVLEVIAUVKUUQUIMZUVLAUUTUVKUVPOJUUQUVKCUUOUVNUV
        AUVBVFQAUULUUQUIUVCUNVGVJAUULVKMZVLZVMMZEVIRZUVREVIRZVMMZUVMUUGAUVRWANZ
        UVRVNZBEUQZUVTUWBOAUULUUSNZUWCUVDUULFVOQZAUWEUVFIAUWFUWDFOUWEUVFVPUVDUU
        LFVQUWDFBEVRWBVSZEUVRUWDBUWDPZVTWCAUVLUVSEVIAUWFUVLUVSOUVDUULUVLFUVLPWD
        QVJAYTUIMZYTVKMZVLZVMMZUUGUWBAYTUUINZUWJUWMOUVEYTUWJBUWJPWDQAUUCYTUIAUU
        BSYTWEZYTUUBWFUUCYTOAUUHUWOUVJYTUUAWGQUUBSYTWHUUBYTWIWBUNAUWAUWLVMAUAUW
        AUWLAUAWJZBURZEWKUWPWLZUVRNZWNZUWQUWPUWLNZWNUWPUWANZUXAAUWQUWSUXAAUWQWN
        ZUWRKWJZLWJZUVQRZOZLSTKFTZUWPUBWJZUXEUWKRZOZLSTZUBBTZUWSUXAUXCUXHUWPUXD
        EMZUXEUWKRZOZLSTZKFTZUXLUBEVLZTZUXMUXCUXGUXPKLFSUXCUXDFNZUXESNZWNZWNZEU
        WRWLZEUXFWLZOZUXGUXPUYDFBEWOZUWRFURUXFFURZUYGUXGVPUYDUVFUYHAUVFUWQUYCIW
        MZFBEWPQUYDEWQZUWRFEUWPWRUYDUVFUYKFOUYJFBEWSQWTUYDUWFUYAUYBUYIAUWFUWQUY
        CUVDWMZUXCUYAUYBXAZUXCUYAUYBXBZUULUXDUXEFXEXCFBUWRUXFEXFXDUYDUYEUWPUYFU
        XOUYDUVGUWQUYEUWPOUYDUVFUVGUYJUVHQAUWQUYCXGFBUWPEXHWCUYDUXOUYFUYDBYTUXD
        CUXEDUULEFUJADECXNROUWQUYCGWMAFUUOOUWQUYCHWMUYJAUUTUWQUYCJWMUUMUUNUYLUY
        MUYNXIXJXKXLXMUXCUVFEFWFUXTUXRVPAUVFUWQIXOZFBEXPUXLUXQUBKFEUXIUXNOZUXKU
        XPLSUYPUXJUXOUWPUXIUXNUXEUWKXQXRXSXTWBUXCUXLUBUXSBUXCUVFUVGUXSBOUYOUVHF
        BEYAWBYBYCUXCUWFUWSUXHVPAUWFUWQUVDXOKUWRUULFLYDQUXCUWNUXAUXMVPAUWNUWQUV
        EXOUBUWPYTBLYDQYEYFAUWCUWDBEVHZUXBUWTVPUWGAUWEUYQUWHUWDBEUSQUWPEUVRWAUW
        DBUWIYGWCAUXAUWQAUXAUWPBYHZNUWQAUWLUYRUWPAUWNBSUEZUYRUWKWEUWLUYRURUVEYT
        BYIUYSUYRUWKYJWBYKUWPBYLYPYMYEYNUNYOYOYQUUCUUFDUUAUVOUUAPUUCPYRYS $.
    $}

    imasf1oms.r $e |- ( ph -> R e. MetSp ) $.
    $( The image of a metric space is a metric space.  (Contributed by Mario
       Carneiro, 28-Aug-2015.) $)
    imasf1oms $p |- ( ph -> U e. MetSp ) $=
      ( cxme wcel cds cfv cxp cres cme cmt syl eqid cbs msxms wss msmet xpeq12d
      imasf1oxms reseq2d 3eltr4d imasf1omet wf1o wfo f1ofo imasbas eleqtrd ssid
      fveq2d metres2 sylancl ctopn isms sylanbrc ) ADKLDMNZDUANZVCOPZVCQNZLZDRL
      ABCDEFGHIACRLZCKLJCUBSUFAVBVELVCVCUCVFAVBBQNVEABVBCDCMNZFFOZPZEFRGHIJVJTV
      BTAVHCUANZVKOZPZVKQNZVJFQNAVGVMVNLJVMCVKVKTVMTUDSAVIVLVHAFVKFVKHHUEUGAFVK
      QHUPUHUIABVCQABCDEFRGHAFBEUJFBEUKIFBEULSJUMUPUNVCUOVBVCVCUQURVDDUSNZDVCVO
      TVCTVDTUTVA $.
  $}

  ${
    $d f x z A $.  $d x y B $.  $d f x z D $.  $d f x y z I $.  $d f x y z P $.
    $d f y z E $.  $d f x y ph $.  $d y z R $.  $d y S $.  $d y W $.  $d y Y $.
    prdsbl.y $e |- Y = ( S Xs_ ( x e. I |-> R ) ) $.
    prdsbl.b $e |- B = ( Base ` Y ) $.
    prdsbl.v $e |- V = ( Base ` R ) $.
    prdsbl.e $e |- E = ( ( dist ` R ) |` ( V X. V ) ) $.
    prdsbl.d $e |- D = ( dist ` Y ) $.
    prdsbl.s $e |- ( ph -> S e. W ) $.
    prdsbl.i $e |- ( ph -> I e. Fin ) $.
    prdsbl.r $e |- ( ( ph /\ x e. I ) -> R e. Z ) $.
    prdsbl.m $e |- ( ( ph /\ x e. I ) -> E e. ( *Met ` V ) ) $.
    prdsbl.p $e |- ( ph -> P e. B ) $.
    prdsbl.a $e |- ( ph -> A e. RR* ) $.
    prdsbl.g $e |- ( ph -> 0 < A ) $.
    $( A ball in the product metric for finite index set is the Cartesian
       product of balls in all coordinates.  For infinite index set this is no
       longer true; instead the correct statement is that a *closed ball* is
       the product of closed balls in each coordinate (where closed ball means
       a set of the form in ~ blcld ) - for a counterexample the point ` p ` in
       ` RR ^ NN ` whose ` n ` -th coordinate is ` 1 - 1 / n ` is in
       ` X_ n e. NN ball ( 0 , 1 ) ` but is not in the ` 1 ` -ball of the
       product (since ` d ( 0 , p ) = 1 ` ).

       The last assumption, ` 0 < A ` , is needed only in the case
       ` I = (/) ` , when the right side evaluates to ` { (/) } ` and the left
       evaluates to ` (/) ` if ` A <_ 0 ` and ` { (/) } ` if ` 0 < A ` .
       (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    prdsbl $p |- ( ph ->
      ( P ( ball ` D ) A ) = X_ x e. I ( ( P ` x ) ( ball ` E ) A ) ) $=
      ( vf vz vy cbl cfv co cv cixp wcel clt wbr wa wral wfn ralrimiva prdsbas3
      wb cfn eleq2d biimpa ixpfn vex elixp baib 3syl cxmt cxr adantlr prdsbascl
      ad2antrr adantr r19.21bi simpr elbl2 syl22anc ralbidva crn xmetcl syl3anc
      cmpt eqid breq1 ralrnmpt syl cc0 csn c0ex ralsn sylibr cun ralunb wi csup
      prdsdsval3 wor c0 wne wss xrltso a1i wceq wrex cab rnmpt abrexfi syl5eqel
      snfi unfi sylancl ssun2 snss mpbir ne0i mp1i wf fmptd frn 0xr snssd unssd
      fisupcl syl13anc eqeltrd rspcv syl5bir mpan2d sylbird ovex elabrex adantl
      cle ssun1 syl6eleqr sseldi supxrub syl2anc breqtrrd prdsxmet mpand impbid
      xrlelttr ralrimdva 3bitrrd pm5.32da elbl ss2ixp sseqtr4d pm4.71rd 3bitr4d
      blssm sseld eqrdv ) AUGFCEUJUKULZBJBUMZFUKZCIUJUKULZUNZAUGUMZDUOZFUVDEULZ
      CUPUQZURZUVEUVDUVCUOZURUVDUUSUOZUVIAUVEUVGUVIAUVEURZUVIUUTUVDUKZUVBUOZBJU
      SZUVAUVLIULZCUPUQZBJUSZUVGUVKUVDBJKUNZUOZUVDJUTZUVIUVNVCAUVEUVSADUVRUVDAB
      DGHJKLVDNMOPTUAAGNUOZBJUBVAZQVBZVEVFBJKUVDVGUVIUVTUVNBJUVBUVDUGVHVIVJVKUV
      KUVMUVPBJUVKUUTJUOZURZIKVLUKUOZCVMUOZUVAKUOZUVLKUOZUVMUVPVCAUWDUWFUVEUCVN
      ZAUWGUVEUWDUEVPZUVKUWHBJAUWHBJUSUVEABDGHFJKLVDNMOPTUAUWBQUDVOZVQVRZUVKUWI
      BJUVKBDGHUVDJKLVDNMOPAHLUOUVETVQZAJVDUOZUVEUAVQZAUWABJUSUVEUWBVQZQAUVEVSZ
      VOVRZUVLIUVACKVTWAWBUVKUVQUVGUVKUVQUHUMZCUPUQZUHBJUVOWFZWCZUSZUVGUVKUVOVM
      UOZBJUSUXDUVQVCUVKUXEBJUWEUWFUWHUWIUXEUWJUWMUWSUVAUVLIKWDWEZVAUXAUVPBUHJU
      VOUXBVMUXBWGZUWTUVOCUPWHWIWJUVKUXDUXAUHWKWLZUSZUVGUVKWKCUPUQZUXIAUXJUVEUF
      VQUXAUXJUHWKWMUWTWKCUPWHWNWOUXDUXIURUXAUHUXCUXHWPZUSZUVKUVGUXAUHUXCUXHWQU
      VKUVFUXKUOUXLUVGWRUVKUVFUXKVMUPWSZUXKUVKBDEGHIFUVDJKLVDNMOPUWNUWPUWQAFDUO
      ZUVEUDVQUWRQRSWTZUVKVMUPXAZUXKVDUOZUXKXBXCZUXKVMXDZUXMUXKUOUXPUVKXEXFUVKU
      XCVDUOZUXHVDUOUXQUVKUWOUXTUWPUWOUXCUIUMUVOXGBJXHUIXIZVDBUIJUVOUXBUXGXJZBU
      IJUVOXKXLWJWKXMUXCUXHXNXOWKUXKUOZUXRUVKUYCUXHUXKXDUXHUXCXPWKUXKWMXQXRUXKW
      KXSXTUVKUXCUXHVMUVKJVMUXBYAUXCVMXDUVKBJUVOVMUXBUXFUXGYBJVMUXBYCWJUVKWKVMW
      KVMUOUVKYDXFYEYFZVMUXKUPYGYHYIUXAUVGUHUVFUXKUWTUVFCUPWHYJWJYKYLYMUVKUVGUV
      PBJUWEUVOUVFYQUQZUVGUVPUWEUVOUXMUVFYQUWEUXSUVOUXKUOUVOUXMYQUQUVKUXSUWDUYD
      VQUWEUXCUXKUVOUXCUXHYRUWEUVOUYAUXCUWDUVOUYAUOUVKBUIJUVOUVAUVLIYNYOYPUYBYS
      YTUXKUVOUUAUUBUVKUVFUXMXGUWDUXOVQUUCUWEUXEUVFVMUOZUWGUYEUVGURUVPWRUXFUWEE
      DVLUKUOZUXNUVEUYFAUYGUVEUWDABDEGHIJKLVDMNOPQRSTUAUBUCUUDZVPAUXNUVEUWDUDVP
      UVKUVEUWDUWRVQFUVDEDWDWEUWKUVOUVFCUUGWEUUEUUHUUFUUIUUJAUYGUXNUWGUVJUVHVCU
      YHUDUEUVDEFCDUUKWEAUVIUVEAUVCDUVDAUVCUVRDAUVBKXDZBJUSUVCUVRXDAUYIBJAUWDUR
      UWFUWHUWGUYIUCAUWHBJUWLVRAUWGUWDUEVQIUVACKUUPWEVABJUVBKUULWJUWCUUMUUQUUNU
      UOUUR $.
  $}

  ${
    $d x y A $.  $d r w x y z D $.  $d r x y J $.  $d x y z R $.  $d w x y S $.
    $d r y N $.  $d r w x y z P $.  $d z T $.  $d r w x y z X $.
    mopni.1 $e |- J = ( MetOpen ` D ) $.
    $( An open set of a metric space includes a ball around each of its
       points.  (Contributed by NM, 3-Sep-2006.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    mopni $p |- ( ( D e. ( *Met ` X ) /\ A e. J /\ P e. A ) ->
                 E. x e. ran ( ball ` D ) ( P e. x /\ x C_ A ) ) $=
      ( vy cxmt cfv wcel cv wss wa cbl crn wrex wral wi elmopn simplbda rexbidv
      wceq eleq1 anbi1d rspccv syl 3impia ) CFIJKZBEKZDBKZDALZKZULBMZNZACOJPZQZ
      UIUJNHLZULKZUNNZAUPQZHBRZUKUQSUIUJBFMVBHABCEFGTUAVAUQHDBURDUCZUTUOAUPVCUS
      UMUNURDULUDUEUBUFUGUH $.

    $( An open set of a metric space includes a ball around each of its
       points.  (Contributed by NM, 2-May-2007.)  (Revised by Mario Carneiro,
       12-Nov-2013.) $)
    mopni2 $p |- ( ( D e. ( *Met ` X ) /\ A e. J /\ P e. A ) ->
                 E. x e. RR+ ( P ( ball ` D ) x ) C_ A ) $=
      ( vy cxmt cfv wcel w3a cv wss wa cbl crn wrex co crp mopnss sselda blssex
      mopni wb adantlr syldan 3impa mpbid ) CFIJKZBEKZDBKZLDHMZKUMBNOHCPJZQRZDA
      MUNSBNATRZHBCDEFGUDUJUKULUOUPUEZUJUKOZULDFKZUQURBFDBCEFGUAUBUJUSUQUKHBCDF
      AUCUFUGUHUI $.

    $( An open set of a metric space includes an arbitrarily small ball around
       each of its points.  (Contributed by NM, 20-Sep-2007.)  (Revised by
       Mario Carneiro, 12-Nov-2013.) $)
    mopni3 $p |- ( ( ( D e. ( *Met ` X ) /\ A e. J /\ P e. A ) /\ R e. RR+ ) ->
        E. x e. RR+ ( x < R /\ ( P ( ball ` D ) x ) C_ A ) ) $=
      ( vy cxmt cfv wcel w3a crp wa cv cbl co wss wrex clt mopni2 adantr mopnss
      wbr simp1 sselda 3impa ssblex sylan anassrs expcom anim2d reximdv syl5com
      jca sstr rexlimdva mpd ) CGJKLZBFLZDBLZMZENLZOZDIPZCQKZRZBSZINTZAPZEUAUEZ
      DVKVGRZBSZOZANTZVCVJVDIBCDFGHUBUCVEVIVPINVEVFNLZOVLVMVHSZOZANTZVIVPVCVDVQ
      VTVCUTDGLZOVDVQOVTVCUTWAUTVAVBUFUTVAVBWAUTVAOBGDBCFGHUDUGUHUPACDEVFGUIUJU
      KVIVSVOANVIVRVNVLVRVIVNVMVHBUQULUMUNUOURUS $.

    $( The balls of a metric space are open sets.  (Contributed by NM,
       12-Sep-2006.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    blssopn $p |- ( D e. ( *Met ` X ) -> ran ( ball ` D ) C_ J ) $=
      ( cxmt cfv wcel cbl crn ctg ctb wss blbas bastg syl mopnval sseqtr4d ) AC
      EFGZAHFIZSJFZBRSKGSTLACMSKNOABCDPQ $.

    $( The union of a collection of open sets of a metric space is open.
       Theorem T2 of [Kreyszig] p. 19.  (Contributed by NM, 4-Sep-2006.)
       (Revised by Mario Carneiro, 23-Dec-2013.) $)
    unimopn $p |- ( ( D e. ( *Met ` X ) /\ A C_ J ) ->
                 U. A e. J ) $=
      ( cxmt cfv wcel ctop wss cuni mopntop uniopn sylan ) BDFGHCIHACJAKCHBCDEL
      ACMN $.

    $( The intersection of two open sets of a metric space is open.
       (Contributed by NM, 4-Sep-2006.)  (Revised by Mario Carneiro,
       23-Dec-2013.) $)
    mopnin $p |- ( ( D e. ( *Met ` X ) /\ A e. J /\ B e. J ) ->
               ( A i^i B ) e. J ) $=
      ( cxmt cfv wcel ctop cin mopntop inopn syl3an1 ) CEGHIDJIADIBDIABKDICDEFL
      ABDMN $.

    $( The empty set is an open set of a metric space.  Part of Theorem T1 of
       [Kreyszig] p. 19.  (Contributed by NM, 4-Sep-2006.) $)
    mopn0 $p |- ( D e. ( *Met ` X ) -> (/) e. J ) $=
      ( cxmt cfv wcel ctop c0 mopntop 0opn syl ) ACEFGBHGIBGABCDJBKL $.

    $( A ball of a metric space is an open set.  (Contributed by NM,
       12-Sep-2006.) $)
    rnblopn $p |- ( ( D e. ( *Met ` X ) /\ B e. ran ( ball ` D ) ) ->
        B e. J ) $=
      ( cxmt cfv wcel cbl crn blssopn sselda ) BDFGHBIGJCABCDEKL $.

    $( A ball of a metric space is an open set.  (Contributed by NM,
       9-Mar-2007.)  (Revised by Mario Carneiro, 12-Nov-2013.) $)
    blopn $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
                    ( P ( ball ` D ) R ) e. J ) $=
      ( cxmt cfv wcel cxr w3a cbl crn co wss blssopn 3ad2ant1 blelrn sseldd ) A
      EGHIZBEIZCJIZKALHZMZDBCUCNTUAUDDOUBADEFPQABCERS $.

    $( The neighborhoods around a point ` P ` of a metric space are those
       subsets containing a ball around ` P ` .  Definition of neighborhood in
       [Kreyszig] p. 19.  (Contributed by NM, 8-Nov-2007.)  (Revised by Mario
       Carneiro, 23-Dec-2013.) $)
    neibl $p |- ( ( D e. ( *Met ` X ) /\ P e. X ) ->
      ( N e. ( ( nei ` J ) ` { P } ) <-> ( N C_ X /\ E. r e. RR+
        ( P ( ball ` D ) r ) C_ N ) ) ) $=
      ( vy cfv wcel wa wss cv wrex crp wb adantr syl2anc wi w3a cxmt csn cbl co
      cnei cuni mopntop mopnuni eleq2d biimpa isneip sseq2d anbi1d mopni2 sstr2
      ctop eqid com12 reximdv syl5com 3exp imp4a ad2antrr rexlimdv rpxr syl3an3
      blopn blcntr wceq eleq2 sseq1 anbi12d rspcev expr 3expia pm5.32da 3bitr2d
      cxr impbid ) AEUAIJZBEJZKZDBUBCUEIIJZDCUFZLZBHMZJZWFDLZKZHCNZKZDELZWJKWLB
      FMZAUCIUDZDLZFONZKWBCUPJZBWDJZWCWKPVTWQWAACEGUGQVTWAWRVTEWDBACEGUHZUIUJBH
      CDWDWDUQUKRWBWLWEWJVTWLWEPWAVTEWDDWSULQUMWBWLWJWPWBWLKZWJWPWTWIWPHCVTWFCJ
      ZWIWPSSWAWLVTXAWGWHWPVTXAWGWHWPSVTXAWGTWNWFLZFONWHWPFWFABCEGUNWHXBWOFOXBW
      HWOWNWFDUOURUSUTVAVBVCVDWBWPWJSWLWBWOWJFOVTWAWMOJZWOWJSZVTWAXCTWNCJZBWNJZ
      XDXCVTWAWMVRJXEWMVEABWMCEGVGVFABWMEVHXEXFWOWJWIXFWOKHWNCWFWNVIWGXFWHWOWFW
      NBVJWFWNDVKVLVMVNRVOVDQVSVPVQ $.

    $( A ball around a point is a neighborhood of the point.  (Contributed by
       NM, 8-Nov-2007.)  (Revised by Mario Carneiro, 24-Aug-2015.) $)
    blnei $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR+ ) ->
              ( P ( ball ` D ) R ) e. ( ( nei ` J ) ` { P } ) ) $=
      ( cxmt cfv wcel crp w3a ctop cbl co csn cnei mopntop 3ad2ant1 cxr rpxr
      blopn syl3an3 blcntr opnneip syl3anc ) AEGHIZBEIZCJIZKDLIZBCAMHNZDIZBUJIU
      JBODPHHIUFUGUIUHADEFQRUHUFUGCSIUKCTABCDEFUAUBABCEUCBDUJUDUE $.

    $( Every ball around a limit point ` P ` of a subset ` S ` includes a
       member of ` S ` (even if ` P e/ S ` ).  (Contributed by NM,
       9-Nov-2007.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    lpbl $p |- ( ( ( D e. ( *Met ` X ) /\ S C_ X /\
        P e. ( ( limPt ` J ) ` S ) ) /\ R e. RR+ ) ->
      E. x e. S x e. ( P ( ball ` D ) R ) ) $=
      ( cfv wcel wss wa cin c0 wne syl wceq syl2anc syl3anc wex clp w3a crp cbl
      cxmt co cdif cv wrex cnei wral simpl1 cuni mopntop simpl2 mopnuni sseqtrd
      csn ctop eqid simpl3 sseldd eleqtrrd simpr blnei islp2 mpbid ineq1 neeq1d
      lpss wb rspcva elin eldifi anim2i ancomd sylbi eximi n0 df-rex 3imtr4i )
      BGUEIJZEGKZCEFUAIIZJZUBZDUCJZLZCDBUDIUFZECURZUGZMZNOZAUHZWIJZAEUIZWHWIWJF
      UJIIZJZWNWKMZNOZAWQUKZWMWHWBCGJWGWRWBWCWEWGULZWHCFUMZGWHWDXCCWHFUSJZEXCKZ
      WDXCKWHWBXDXBBFGHUNPZWHEGXCWBWCWEWGUOWHWBGXCQXBBFGHUPPZUQZEFXCXCUTZVJRWBW
      CWEWGVAZVBZXGVCWFWGVDBCDFGHVESWHWEXAXJWHXDXECXCJWEXAVKXFXHXKCEAFXCXIVFSVG
      WTWMAWIWQWNWIQWSWLNWNWIWKVHVIVLRWNWLJZATWNEJZWOLZATWMWPXLXNAXLWOWNWKJZLZX
      NWNWIWKVMXPWOXMXOXMWOWNEWJVNVOVPVQVRAWLVSWOAEVTWAP $.

    blcld.3 $e |- S = { z e. X | ( P D z ) <_ R } $.
    $( A smaller closed ball is contained in a larger open ball.  (Contributed
       by Mario Carneiro, 10-Jan-2014.) $)
    blsscls2 $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X ) /\
                       ( R e. RR* /\ T e. RR* /\ R < T ) ) ->
                     S C_ ( P ( ball ` D ) T ) ) $=
      ( cxmt cfv wcel wa cxr clt wbr w3a co wi cv cle crab cbl wral wss simplr3
      xmetcl 3expa adantlr simplr1 simplr2 xrlelttr exp3acom23 syl3anc wb simp2
      mpd elbl2 an4s sylanr1 anassrs sylibrd ralrimiva rabss sylibr syl5eqss )
      BHKLMZCHMZNZDOMZFOMZDFPQZRZNZECAUAZBSZDUBQZAHUCZCFBUDLSZJVOVRVPVTMZTZAHUE
      VSVTUFVOWBAHVOVPHMZNZVRVQFPQZWAWDVMVRWETZVKVLVMVJWCUGWDVQOMZVKVLVMWFTVJWC
      WGVNVHVIWCWGCVPBHUHUIUJVKVLVMVJWCUKVKVLVMVJWCULWGVKVLRVRVMWEVQDFUMUNUOURV
      JVNWCWAWEUPZVNVJVLWCWHVKVLVMUQVHVLVIWCWHVPBCFHUSUTVAVBVCVDVRAHVTVEVFVG $.

    $( A "closed ball" in a metric space is actually closed.  (Contributed by
       Mario Carneiro, 31-Dec-2013.)  (Revised by Mario Carneiro,
       24-Aug-2015.) $)
    blcld $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
        S e. ( Clsd ` J ) ) $=
      ( vy wcel wceq wss wa wbr co cle wb syl2anc adantr vw vx cxmt cfv cxr w3a
      ccld cuni cdif mopnuni 3ad2ant1 difeq1d cv cbl crn wrex difssd clt simpl3
      wral cq simpl1 simpl2 eldifi adantl xmetcl syl3anc wn eldif breq1d elrab2
      oveq2 simplbi2 con3and sylbi xrltnle mpbird qbtwnxr cr qre cxne cxad rexr
      ad2antrl xnegcld xaddcld blelrn cc0 simprrr xposdif xblcntr syl112anc cin
      wi mpbid c0 incom xaddcom simprl xnpcan eqtrd xrleid syl eqbrtrd syl33anc
      bldisj syl5eq blssm reldisj simprrl blsscls2 syl23anc sstrd eleq2 anbi12d
      sscond sseq1 rspcev syl12anc expr sylan2 rexlimdva mpd ralrimiva eqeltrrd
      elmopn mpbir2and ctop mopntop crab ssrab2 eqsstri syl5sseq eqid iscld2 )
      BGUCUDKZCGKZDUEKZUFZEFUGUDKZFUHZEUIZFKZYSGEUIZUUBFYSGUUAEYPYQGUUALYRBFGHU
      JUKZULYSUUDFKZUUDGMZJUMZUAUMZKZUUIUUDMZNZUABUNUDZUOZUPZJUUDUTZYSGEUQYSUUO
      JUUDYSUUHUUDKZNZDUBUMZUROZUUSCUUHBPZUROZNZUBVAUPZUUOUURYRUVAUEKZDUVAUROZU
      VDYPYQYRUUQUSZUURYPYQUUHGKZUVEYPYQYRUUQVBZYPYQYRUUQVCZUUQUVHYSUUHGEVDVEZC
      UUHBGVFVGZUURUVFUVADQOZVHZUUQUVNYSUUQUVHUUHEKZVHNUVNUUHGEVIUVHUVMUVOUVOUV
      HUVMCAUMZBPZDQOZUVMAUUHGEUVPUUHLUVQUVADQUVPUUHCBVLVJIVKVMVNVOVEUURYRUVEUV
      FUVNRUVGUVLDUVAVPSVQUBDUVAVRVGUURUVCUUOUBVAUUSVAKUURUUSVSKZUVCUUOWNUUSVTU
      URUVSUVCUUOUURUVSUVCNZNZUUHUVAUUSWAZWBPZUUMPZUUNKZUUHUWDKZUWDUUDMZUUOUWAY
      PUVHUWCUEKZUWEUURYPUVTUVITZUURUVHUVTUVKTZUWAUVAUWBUURUVEUVTUVLTZUWAUUSUVS
      UUSUEKZUURUVCUUSWCWDZWEWFZBUUHUWCGWGVGUWAYPUVHUWHWHUWCUROZUWFUWIUWJUWNUWA
      UVBUWOUURUVSUUTUVBWIUWAUWLUVEUVBUWORUWMUWKUUSUVAWJSWOBUUHUWCGWKWLUWAUWDGC
      UUSUUMPZUIZUUDUWAUWDUWPWMZWPLZUWDUWQMZUWAUWRUWPUWDWMZWPUWDUWPWQUWAYPYQUVH
      UWLUWHUUSUWCWBPZUVAQOUXAWPLUWIUURYQUVTUVJTZUWJUWMUWNUWAUXBUVAUVAQUWAUXBUW
      CUUSWBPZUVAUWAUWLUWHUXBUXDLUWMUWNUUSUWCWRSUWAUVEUVSUXDUVALUWKUURUVSUVCWSU
      VAUUSWTSXAUWAUVEUVAUVAQOUWKUVAXBXCXDBCUUHUUSUWCGXFXEXGUWAUWDGMZUWSUWTRUWA
      YPUVHUWHUXEUWIUWJUWNBUUHUWCGXHVGUWDUWPGXIXCWOUWAEUWPGUWAYPYQYRUWLUUTEUWPM
      UWIUXCUURYRUVTUVGTUWMUURUVSUUTUVBXJABCDEUUSFGHIXKXLXPXMUULUWFUWGNUAUWDUUN
      UUIUWDLUUJUWFUUKUWGUUIUWDUUHXNUUIUWDUUDXQXOXRXSXTYAYBYCYDYPYQUUFUUGUUPNRY
      RJUAUUDBFGHYFUKYGYEYSFYHKZEUUAMYTUUCRYPYQUXFYRBFGHYIUKYSGEUUAEUVRAGYJGIUV
      RAGYKYLUUEYMEFUUAUUAYNYOSVQ $.

    $( The closure of an open ball in a metric space is contained in the
       corresponding closed ball.  (The converse is not, in general, true; for
       example, with the discrete metric, the closed ball of radius 1 is the
       whole space, but the open ball of radius 1 is just a point, whose
       closure is also a point.)  (Contributed by Mario Carneiro,
       31-Dec-2013.) $)
    blcls $p |- ( ( D e. ( *Met ` X ) /\ P e. X /\ R e. RR* ) ->
                  ( ( cls ` J ) ` ( P ( ball ` D ) R ) ) C_ S ) $=
      ( cxmt cfv wcel cxr w3a ccld co wss wbr wa syl2anc cbl ccl blcld cle crab
      cv wral blssm clt elbl xmetcl 3expa 3adantl3 simpl3 xrltle expimpd sylbid
      wi ralrimiv ssrab sylanbrc syl6sseqr cuni eqid clsss2 ) BGJKLZCGLZDMLZNZE
      FOKLCDBUAKPZEQVJFUBKKEQABCDEFGHIUCVIVJCAUFZBPZDUDRZAGUEZEVIVJGQVMAVJUGVJV
      NQBCDGUHVIVMAVJVIVKVJLVKGLZVLDUIRZSVMVKBCDGUJVIVOVPVMVIVOSVLMLZVHVPVMURVF
      VGVOVQVHVFVGVOVQCVKBGUKULUMVFVGVHVOUNVLDUOTUPUQUSVMAGVJUTVAIVBEVJFFVCZVRV
      DVET $.
  $}

  ${
    $d x D $.  $d x P $.  $d x R $.  $d x S $.  $d x X $.
    blsscls.2 $e |- J = ( MetOpen ` D ) $.
    $( If two concentric balls have different radii, the closure of the smaller
       one is contained in the larger one.  (Contributed by Mario Carneiro,
       5-Jan-2014.) $)
    blsscls $p |- ( ( ( D e. ( *Met ` X ) /\ P e. X ) /\
                    ( R e. RR* /\ S e. RR* /\ R < S ) ) ->
            ( ( cls ` J ) ` ( P ( ball ` D ) R ) ) C_ ( P ( ball ` D ) S ) ) $=
      ( vx cxmt cfv wcel wa cxr clt wbr w3a cbl co ccl cv crab eqid blcls 3expa
      cle wss 3ad2antr1 blsscls2 sstrd ) AFIJKZBFKZLZCMKZDMKZCDNOZPLBCAQJZRESJJ
      ZBHTARCUEOHFUAZBDUPRULUNUMUQURUFZUOUJUKUMUSHABCUREFGURUBZUCUDUGHABCURDEFG
      UTUHUI $.
  $}

  ${
    $d r s x y z C $.  $d r s x y J $.  $d r s x y K $.  $d s y R $.  $d y S $.
    $d r s x y z D $.  $d r x y ph $.  $d r s x y z X $.  $d a b x C $.
    $d a b x D $.  $d a b x J $.  $d a b x K $.  $d a b x X $.
    metequiv.3 $e |- J = ( MetOpen ` C ) $.
    metequiv.4 $e |- K = ( MetOpen ` D ) $.
    $( Two ways of saying that metric ` D ` generates a finer topology than
       metric ` C ` .  (Contributed by Mario Carneiro, 12-Nov-2013.)  (Revised
       by Mario Carneiro, 24-Aug-2015.) $)
    metss $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` X ) ) ->
          ( J C_ K <-> A. x e. X A. r e. RR+ E. s e. RR+
                ( x ( ball ` D ) s ) C_ ( x ( ball ` C ) r ) ) ) $=
      ( vy cfv wcel wa wss cv wrex wral crp wceq vz cxmt cbl crn ctg wi cuni co
      mopnval adantr adantl sseq12d ctb wb blbas unirnbl eqtr4d syl2anc raleqdv
      tgss2 blssex adantll imbi2d ralbidv w3a blelrn syl3an3 blcntr eleq2 sseq2
      rpxr rexbidv imbi12d rspcv com23 sylc 3expa adantllr ralrimdva blss 3expb
      cxr adantlr r19.29 sstr expcom reximdv impcom rexlimivw ex syl5com impbid
      syl expr bitrd ralbidva 3bitrd ) BFUBLZMZCWRMZNZDEOBUCLZUDZUELZCUCLZUDZUE
      LZOZAPZKPZMZXIUAPZMXLXJONUAXFQZUFZKXCRZAXCUGZRZXIGPXEUHZXIHPZXBUHZOZGSQZH
      SRZAFRZXADXDEXGWSDXDTWTBDFIUIUJWTEXGTWSCEFJUIUKULXAXCUMMZXPXFUGZTXHXQUNWS
      YEWTBFUOUJXAXPFYFWSXPFTWTBFUPUJZWTYFFTWSCFUPUKUQAKUAXCXFUMUTURXAXQXOAFRYD
      XAXOAXPFYGUSXAXOYCAFXAXIFMZNZXOXKXRXJOZGSQZUFZKXCRZYCYIXNYLKXCYIXMYKXKWTY
      HXMYKUNWSUAXJCXIFGVAVBVCVDYIYMYCYIYMYBHSWSYHXSSMZYMYBUFZWTWSYHYNYOWSYHYNV
      EXTXCMZXIXTMZYOYNWSYHXSWBMYPXSVKBXIXSFVFVGBXIXSFVHYPYMYQYBYLYQYBUFKXTXCXJ
      XTTZXKYQYKYBXJXTXIVIYRYJYAGSXJXTXRVJVLVMVNVOVPVQVRVSYIYCYLKXCYIXJXCMZNXKY
      CYKYIYSXKYCYKUFYIYSXKNZNXTXJOZHSQZYCYKXAYTUUBYHWSYTUUBWTWSYSXKUUBHXJBXIFV
      TWAWCWCYCUUBYKYCUUBNYBUUANZHSQYKYBUUAHSWDUUCYKHSUUAYBYKUUAYAYJGSYAUUAYJXR
      XTXJWEWFWGWHWIWMWJWKWNVOVSWLWOWPWOWQ $.

    $( Two ways of saying that two metrics generate the same topology.  Two
       metrics satisfying the right-hand side are said to be (topologically)
       equivalent.  (Contributed by Jeffrey Hankins, 21-Jun-2009.)  (Revised by
       Mario Carneiro, 12-Nov-2013.) $)
    metequiv $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` X ) ) ->
      ( J = K <-> A. x e. X
          ( A. r e. RR+ E. s e. RR+
                ( x ( ball ` D ) s ) C_ ( x ( ball ` C ) r ) /\
            A. a e. RR+ E. b e. RR+
                ( x ( ball ` C ) b ) C_ ( x ( ball ` D ) a ) ) ) ) $=
      ( cfv wcel wa wss cv co crp wral cxmt cbl wrex wceq metss wb anbi12d eqss
      ancoms r19.26 3bitr4g ) BFUAMZNZCULNZOZDEPZEDPZOAQZGQCUBMZRURHQBUBMZRPGSU
      CHSTZAFTZURJQUTRURIQUSRPJSUCISTZAFTZODEUDVAVCOAFTUOUPVBUQVDABCDEFGHKLUEUN
      UMUQVDUFACBEDFJILKUEUIUGDEUHVAVCAFUJUK $.

    $( If there is a sequence of radii approaching zero for which the balls of
       both metrics coincide, then the generated topologies are equivalent.
       (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    metequiv2 $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` X ) ) ->
      ( A. x e. X A. r e. RR+ E. s e. RR+ ( s <_ r /\
        ( x ( ball ` C ) s ) = ( x ( ball ` D ) s ) ) -> J = K ) ) $=
      ( cfv wcel wa cv cbl co crp wrex wral wss cxmt cle wbr wi simprrr simplll
      wceq simplr simprlr rpxrd simprll simprrl ssbl syl221anc eqsstr3d simpllr
      cxr eqsstrd jca expr reximdva r19.40 syl6 ralimdva r19.26 syl6ib metequiv
      anassrs sylibrd ) BFUAKZLZCVJLZMZGNZHNZUBUCZANZVNBOKZPZVQVNCOKZPZUGZMZGQR
      ZHQSZAFSWAVQVOVRPZTZGQRZHQSVSVQVOVTPZTZGQRZHQSMZAFSDEUGVMWEWLAFVMVQFLZMZW
      EWHWKMZHQSWLWNWDWOHQWNVOQLZMZWDWGWJMZGQRWOWQWCWRGQWNWPVNQLZWCWRUDWNWPWSMZ
      WCWRWNWTWCMZMZWGWJXBWAVSWFWNWTVPWBUEZXBVKWMVNUQLZVOUQLZVPVSWFTVKVLWMXAUFV
      MWMXAUHZXBVNWNWPWSWCUIUJZXBVOWNWPWSWCUKUJZWNWTVPWBULZBVQVNVOFUMUNUOXBVSWA
      WIXCXBVLWMXDXEVPWAWITVKVLWMXAUPXFXGXHXICVQVNVOFUMUNURUSUTVHVAWGWJGQVBVCVD
      WHWKHQVEVFVDABCDEFGHHGIJVGVI $.

    metss2.1 $e |- ( ph -> C e. ( Met ` X ) ) $.
    metss2.2 $e |- ( ph -> D e. ( Met ` X ) ) $.
    metss2.3 $e |- ( ph -> R e. RR+ ) $.
    metss2.4 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x C y ) <_ ( R x. ( x D y ) ) ) $.
    $( Lemma for ~ metss2 .  (Contributed by Mario Carneiro, 14-Sep-2015.) $)
    metss2lem $p |- ( ( ph /\ ( x e. X /\ S e. RR+ ) ) ->
      ( x ( ball ` D ) ( S / R ) ) C_ ( x ( ball ` C ) S ) ) $=
      ( wcel wa co syl3anc cv crp cdiv clt wbr crab cbl cfv cmul cme cr simplrl
      ad2antrr simpr metcl simplrr rpred ltmuldiv2d cle anassrs adantlrr lelttr
      wi remulcld mpand sylbird ss2rabdv cxmt cxr metxmet adantr simprl rpdivcl
      wceq syl syl2anr rpxrd blval rpxr ad2antll 3sstr4d ) ABUAZJQZGUBQZRZRZWBC
      UAZESZGFUCSZUDUEZCJUFZWBWGDSZGUDUEZCJUFZWBWIEUGUHSZWBGDUGUHSZWFWJWMCJWFWG
      JQZRZWJFWHUISZGUDUEZWMWRWHGFWREJUJUHZQZWCWQWHUKQAXBWEWQNUMAWCWDWQULZWFWQU
      NZWBWGEJUOTZWRGAWCWDWQUPUQZAFUBQZWEWQOUMZURWRWLWSUSUEZWTWMAWCWQXIWDAWCWQX
      IPUTVAWRWLUKQZWSUKQGUKQXIWTRWMVCWRDXAQZWCWQXJAXKWEWQMUMXCXDWBWGDJUOTWRFWH
      WRFXHUQXEVDXFWLWSGVBTVEVFVGWFEJVHUHZQZWCWIVIQWOWKVNAXMWEAXBXMNEJVJVOVKAWC
      WDVLZWFWIWEWDXGWIUBQAWCWDUNOGFVMVPVQCEWBWIJVRTWFDXLQZWCGVIQZWPWNVNAXOWEAX
      KXOMDJVJVOVKXNWDXPAWCGVSVTCDWBGJVRTWA $.

    $( If the metric ` D ` is "strongly finer" than ` C ` (meaning that there
       is a positive real constant ` R ` such that
       ` C ( x , y ) <_ R x. D ( x , y ) ` ), then ` D ` generates a finer
       topology.  (Using this theorem twice in each direction states that if
       two metrics are strongly equivalent, then they generate the same
       topology.)  (Contributed by Mario Carneiro, 14-Sep-2015.) $)
    metss2 $p |- ( ph -> J C_ K ) $=
      ( vs vr cfv crp wcel wss cv cbl co wrex wral cdiv simpr rpdivcl metss2lem
      wa syl2anr wceq oveq2 sseq1d rspcev syl2anc ralrimivva wb cme metxmet syl
      cxmt metss mpbird ) AGHUAZBUBZPUBZEUCRZUDZVGQUBZDUCRUDZUAZPSUEZQSUFBIUFZA
      VNBQISAVGITZVKSTZUKZUKVKFUGUDZSTZVGVSVIUDZVLUAZVNVRVQFSTVTAVPVQUHNVKFUIUL
      ABCDEFVKGHIJKLMNOUJVMWBPVSSVHVSUMVJWAVLVHVSVGVIUNUOUPUQURADIVCRZTZEWCTZVF
      VOUSADIUTRZTWDLDIVAVBAEWFTWEMEIVAVBBDEGHIPQJKVDUQVE $.
  $}

  ${
    $d a b c x y D $.  $d a b c x y F $.  $d a b c x y ph $.  $d a b c X $.
    comet.1 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    comet.2 $e |- ( ph -> F : ( 0 [,] +oo ) --> RR* ) $.
    comet.3 $e |- ( ( ph /\ x e. ( 0 [,] +oo ) ) ->
      ( ( F ` x ) = 0 <-> x = 0 ) ) $.
    comet.4 $e |- ( ( ph /\ ( x e. ( 0 [,] +oo ) /\ y e. ( 0 [,] +oo ) ) ) ->
      ( x <_ y -> ( F ` x ) <_ ( F ` y ) ) ) $.
    comet.5 $e |- ( ( ph /\ ( x e. ( 0 [,] +oo ) /\ y e. ( 0 [,] +oo ) ) ) ->
      ( F ` ( x +e y ) ) <_ ( ( F ` x ) +e ( F ` y ) ) ) $.
    $( The composition of an extended metric with a monotonic subadditive
       function is an extended metric.  (Contributed by Mario Carneiro,
       21-Mar-2015.) $)
    comet $p |- ( ph -> ( F o. D ) e. ( *Met ` X ) ) $=
      ( cc0 co cxr wcel cfv cle wbr wceq cxad va vb ccom cxmt elfvexd cpnf cicc
      vc wf cxp wfn cv wral xmetf syl ffn wa w3a xmetge0 elxrge0 sylanbrc 3expb
      xmetcl sylan ralrimivva ffnov fco syl2anc cop opelxpi fvco3 syl2an fveq2i
      df-ov 3eqtr4g eqeq1d wb ralrimiva adantr fveq2 eqeq1 bibi12d sylc xmeteq0
      rspcv 3bitrd 3adantr3 ffvelrnd simpr3 simpr1 fovrnd simpr2 xaddcld 3anrot
      ge0xaddcl xmettri2 sylan2br wi breq1 breq1d imbi12d breq2 breq2d syl21anc
      rspc2va oveq1 fveq2d oveq1d breq12d oveq2 xrletrd oveq12d 3brtr4d isxmetd
      mpd oveq2d ) AUAUBUHEDUCZFADUDFGUEALUFUGMZNEUIZFFUJZXRDUIZXTNXQUIHADXTUKZ
      UAULZUBULZDMZXROZUBFUMUAFUMYAAXTNDUIZYBADFUDPOZYGGDFUNUOZXTNDUPUOAYFUAUBF
      FAYHYCFOZYDFOZUQZYFGYHYJYKYFYHYJYKURYENOLYEQRYFYCYDDFVCYCYDDFUSYEUTVAVBVD
      ZVEUAUBFFXRDVFVAZXTXRNEDVGVHAYLUQZYCYDXQMZLSYEEPZLSZYELSZYCYDSZYOYPYQLYOY
      CYDVIZXQPZUUADPZEPZYPYQAYGUUAXTOUUBUUDSYLYIYCYDFFVJXTNUUAEDVKVLYCYDXQVNYE
      UUCEYCYDDVNVMVOZVPYOYFBULZEPZLSZUUFLSZVQZBXRUMZYRYSVQZYMAUUKYLAUUJBXRIVRV
      SUUJUULBYEXRUUFYESZUUHYRUUIYSUUMUUGYQLUUFYEEVTZVPUUFYELWAWBWEWCAYHYLYSYTV
      QZGYHYJYKUUOYCYDDFWDVBVDWFAYJYKUHULZFOZURZUQZYQUUPYCDMZEPZUUPYDDMZEPZTMZY
      PUUPYCXQMZUUPYDXQMZTMQUUSYQUUTUVBTMZEPZUVDUUSXRNYEEAXSUURHVSZAYJYKYFUUQYM
      WGZWHUUSXRNUVGEUVIUUSUUTXROZUVBXROZUVGXROZUUSUUPYCXRFFDAYAUURYNVSZAYJYKUU
      QWIZAYJYKUUQWJZWKZUUSUUPYDXRFFDUVNUVOAYJYKUUQWLZWKZUUTUVBWOVHZWHUUSUVAUVC
      UUSXRNUUTEUVIUVQWHUUSXRNUVBEUVIUVSWHWMUUSYEUVGQRZYQUVHQRZAYHUURUWAGUURYHU
      UQYJYKURUWAUUQYJYKWNYCYDUUPDFWPWQVDUUSYFUVMUUFCULZQRZUUGUWCEPZQRZWRZCXRUM
      BXRUMZUWAUWBWRZUVJUVTAUWHUURAUWGBCXRXRJVEVSUWGUWIYEUWCQRZYQUWEQRZWRBCYEUV
      GXRXRUUMUWDUWJUWFUWKUUFYEUWCQWSUUMUUGYQUWEQUUNWTXAUWCUVGSZUWJUWAUWKUWBUWC
      UVGYEQXBUWLUWEUVHYQQUWCUVGEVTXCXAXEXDXOUUSUVKUVLUUFUWCTMZEPZUUGUWETMZQRZC
      XRUMBXRUMZUVHUVDQRZUVQUVSAUWQUURAUWPBCXRXRKVEVSUWPUWRUUTUWCTMZEPZUVAUWETM
      ZQRBCUUTUVBXRXRUUFUUTSZUWNUWTUWOUXAQUXBUWMUWSEUUFUUTUWCTXFXGUXBUUGUVAUWET
      UUFUUTEVTXHXIUWCUVBSZUWTUVHUXAUVDQUXCUWSUVGEUWCUVBUUTTXJXGUXCUWEUVCUVATUW
      CUVBEVTXPXIXEXDXKAYJYKYPYQSUUQUUEWGUUSUVEUVAUVFUVCTUUSUUPYCVIZXQPZUXDDPZE
      PZUVEUVAUUSYGUXDXTOZUXEUXGSAYGUURYIVSZUUSUUQYJUXHUVOUVPUUPYCFFVJVHXTNUXDE
      DVKVHUUPYCXQVNUUTUXFEUUPYCDVNVMVOUUSUUPYDVIZXQPZUXJDPZEPZUVFUVCUUSYGUXJXT
      OZUXKUXMSUXIUUSUUQYKUXNUVOUVRUUPYDFFVJVHXTNUXJEDVKVHUUPYDXQVNUVBUXLEUUPYD
      DVNVMVOXLXMXN $.
  $}

  ${
    $d x y A $.  $d a b r s x y z C $.  $d r s z D $.  $d r s z J $.  $d z S $.
    $d x y B $.  $d x y z P $.  $d a b r s x y z R $.  $d a b r s x y z X $.
    stdbdmet.1 $e |- D = ( x e. X , y e. X |->
      if ( ( x C y ) <_ R , ( x C y ) , R ) ) $.
    $( Value of the standard bounded metric.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    stdbdmetval $p |- ( ( R e. V /\ A e. X /\ B e. X ) ->
      ( A D B ) = if ( ( A C B ) <_ R , ( A C B ) , R ) ) $=
      ( wcel co cle wbr cif wceq cvv ovex ifexg cv mpan oveq12 breq1d ifbieq12d
      wa eqidd ovmpt2ga syl3an3 3comr ) CIKZDIKZGHKZCDFLCDELZGMNZUMGOZPZULUJUKU
      OQKZUPUMQKULUQCDERUNUMGQHSUAABCDIIATZBTZELZGMNZUTGOUOFQURCPUSDPUEZVAUNUTG
      UMGVBUTUMGMURCUSDEUBZUCVCVBGUFUDJUGUHUI $.

    $( The standard bounded metric is an extended metric given an extended
       metric and a positive extended real cutoff.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    stdbdxmet $p |- ( ( C e. ( *Met ` X ) /\ R e. RR* /\ 0 < R ) ->
        D e. ( *Met ` X ) ) $=
      ( vz wcel cxr cc0 wbr co cv cle wa wceq cvv syl2anc cxad cxmt cfv clt w3a
      va vb cpnf cicc cif cmpt ccom cmpt2 simp1 xmetcl xmetge0 elxrge0 sylanbrc
      3expb sylan cxp wfn wf xmetf 3ad2ant1 ffn syl sylib eqidd breq1 ifbieq12d
      fnov id fmpt2co syl6eqr simplbi simp2 ifcl syl2anr eqid fmptd vex sylancr
      ifexg fvmptg eqeq1d wb eqeq1 bibi1d biidd wn simp3 neneqd ad2antrr wi 0xr
      gt0ne0d xrltle adantr syl5ibrcom con3and 2falsed ifbothda ad2antrl xrmin1
      bitrd ad2antll xrletr syl3anc mpand xrmin2 jctird xrlemin sylibrd adantrr
      mpd simpr breq12d xaddcld xaddid2 simprbi xleadd1a syl31anc xrletrd oveq2
      a1i eqbrtrrd breq2d ifboth xaddid1 breq2 xleadd2a oveq1 ge0xaddcl oveq12d
      ovex 3brtr4d comet eqeltrrd ) CFUAUBZIZEJIZKEUCLZUDZHKUGUHMZHNZEOLZUUEEUI
      ZUJZCUKZDYSUUCUUIABFFANZBNZCMZEOLZUULEUIZULDUUCABHFFUUDUULUUGUUNCUUHUUCYT
      UUJFIZUUKFIZPUULUUDIZYTUUAUUBUMZYTUUOUUPUUQYTUUOUUPUDUULJIKUULOLUUQUUJUUK
      CFUNUUJUUKCFUOUULUPUQURUSUUCCFFUTZVAZCABFFUULULQUUCUUSJCVBZUUTYTUUAUVAUUB
      CFVCVDUUSJCVEVFABFFCVKVGUUCUUHVHUUEUULQZUUFUUMUUEEUULEUUEUULEOVIUVBVLUVBE
      VHVJVMGVNUUCUEUFCUUHFUURUUCHUUDUUGJUUHUUEUUDIZUUEJIZUUAUUGJIUUCUVCUVDKUUE
      OLUUEUPVOYTUUAUUBVPZUUFUUEEJVQVRUUHVSZVTUUCUENZUUDIZPZUVGUUHUBZKQUVGEOLZU
      VGEUIZKQZUVGKQZUVIUVJUVLKUVHUVHUVLRIZUVJUVLQZUUCUVHVLUUCUVGRIUUAUVOUEWAUV
      EUVKUVGERJWCWBHUVGUUGUVLUUDRUUHUUEUVGQZUUFUVKUUEEUVGEUUEUVGEOVIUVQVLUVQEV
      HVJUVFWDVRZWEUVKUVNUVNWFEKQZUVNWFUVMUVNWFUVIUVGEUVGUVLQZUVNUVMUVNUVGUVLKW
      GWHEUVLQZUVSUVMUVNEUVLKWGWHUVIUVKPUVNWIUVIUVKWJZPUVSUVNUUCUVSWJUVHUWBUUCE
      KUUCEYTUUAUUBWKZWPWLWMUVIUVNUVKUVIUVKUVNKEOLZUUCUWDUVHUUCUUBUWDUWCUUCKJIZ
      UUAUUBUWDWNWOUVEKEWQWBXOZWRUVGKEOVIWSWTXAXBXEUUCUVHUFNZUUDIZPZPZUVGUWGOLZ
      UVLUWGEOLZUWGEUIZOLZUVJUWGUUHUBZOLUWJUWKUVLUWGOLZUVLEOLZPZUWNUWJUWKUWPUWQ
      UWJUVLUVGOLZUWKUWPUWJUVGJIZUUAUWSUVHUWTUUCUWHUVHUWTKUVGOLZUVGUPZVOXCZUUCU
      UAUWIUVEWRZUVGEXDSUWJUVLJIZUWTUWGJIZUWSUWKPUWPWNUWJUWTUUAUXEUXCUXDUVKUVGE
      JVQSZUXCUWHUXFUUCUVHUWHUXFKUWGOLZUWGUPZVOXFZUVLUVGUWGXGXHXIUWJUWTUUAUWQUX
      CUXDUVGEXJSXKUWJUXEUXFUUAUWNUWRWFUXGUXJUXDUVLUWGEXLXHXMUWJUVJUVLUWOUWMOUU
      CUVHUVPUWHUVRXNZUWIUWHUWMRIZUWOUWMQUUCUVHUWHXPUUCUWGRIUUAUXLUFWAUVEUWLUWG
      ERJWCWBHUWGUUGUWMUUDRUUHUUEUWGQZUUFUWLUUEEUWGEUUEUWGEOVIUXMVLUXMEVHVJUVFW
      DVRZXQXMUWJUVGUWGTMZEOLZUXOEUIZUVLUWMTMZUXOUUHUBZUVJUWOTMOUWJUXQUVGUWMTMZ
      OLZUXQEUWMTMZOLZUXQUXROLZUWJUXQUXOOLZUXQUVGETMZOLZUYAUWJUXOJIZUUAUYEUWJUV
      GUWGUXCUXJXRZUXDUXOEXDSUWJUXQEUYFUWJUYHUUAUXQJIUYIUXDUXPUXOEJVQSZUXDUWJUV
      GEUXCUXDXRUWJUYHUUAUXQEOLUYIUXDUXOEXJSZUWJKETMZEUYFOUWJUUAUYLEQUXDEXSVFUW
      JUWEUWTUUAUXAUYLUYFOLUWEUWJWOYEZUXCUXDUVHUXAUUCUWHUVHUWTUXAUXBXTXCKUVGEYA
      YBYFYCUWLUYEUYGUYAUWGEUWGUWMQUXOUXTUXQOUWGUWMUVGTYDYGEUWMQUYFUXTUXQOEUWMU
      VGTYDYGYHSUWJUXQEUYBUYJUXDUWJEUWMUXDUWJUXFUUAUWMJIZUXJUXDUWLUWGEJVQSZXRUY
      KUWJEKTMZEUYBOUWJUUAUYPEQUXDEYIVFUWJUWEUYNUUAKUWMOLZUYPUYBOLUYMUYOUXDUWJU
      XHUWDUYQUWHUXHUUCUVHUWHUXFUXHUXIXTXFUUCUWDUWIUWFWRUWLUXHUWDUYQUWGEUWGUWMK
      OYJEUWMKOYJYHSKUWMEYKYBYFYCUVKUYAUYCUYDUVGEUVTUXTUXRUXQOUVGUVLUWMTYLYGUWA
      UYBUXRUXQOEUVLUWMTYLYGYHSUWIUXOUUDIUXQRIZUXSUXQQUUCUVGUWGYMUUCUXORIUUAUYR
      UVGUWGTYOUVEUXPUXOERJWCWBHUXOUUGUXQUUDRUUHUUEUXOQZUUFUXPUUEEUXOEUUEUXOEOV
      IUYSVLUYSEVHVJUVFWDVRUWJUVJUVLUWOUWMTUXKUXNYNYPYQYR $.

    $( The standard bounded metric is a proper metric given an extended metric
       and a positive real cutoff.  (Contributed by Mario Carneiro,
       26-Aug-2015.) $)
    stdbdmet $p |- ( ( C e. ( *Met ` X ) /\ R e. RR+ ) -> D e. ( Met ` X ) ) $=
      ( cfv wcel wa cr cxr cc0 wbr 3expb cv cle wral ad2antlr syl2anc cxmt rpxr
      crp cxp wf cme clt rpgt0 jca stdbdxmet sylan2 co xmetcl adantlr ifcl rpre
      xmetge0 rpge0 breq2 ifboth xrmin2 xrrege0 syl22anc ralrimivva fmpt2 sylib
      cif ismet2 sylanbrc ) CFUAHZIZEUCIZJZDVJIZFFUDKDUEZDFUFHIVLVKELIZMEUGNZJV
      NVLVPVQEUBZEUHUIVKVPVQVNABCDEFGUJOUKVMAPZBPZCULZEQNZWAEVGZKIZBFRAFRVOVMWD
      ABFFVMVSFIZVTFIZJZJZWCLIZEKIZMWCQNZWCEQNZWDWHWALIZVPWIVKWGWMVLVKWEWFWMVSV
      TCFUMOUNZVLVPVKWGVRSZWBWAELUOTVLWJVKWGEUPSWHMWAQNZMEQNZWKVKWGWPVLVKWEWFWP
      VSVTCFUQOUNVLWQVKWGEURSWBWPWQWKWAEWAWCMQUSEWCMQUSUTTWHWMVPWLWNWOWAEVATWCE
      VBVCVDABFFWCKDGVEVFDFVHVI $.

    $( The standard bounded metric corresponding to ` C ` generates the same
       balls as ` C ` for radii less than ` R ` .  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    stdbdbl $p |- ( ( ( C e. ( *Met ` X ) /\ R e. RR* /\ 0 < R ) /\
      ( P e. X /\ S e. RR* /\ S <_ R ) ) ->
        ( P ( ball ` D ) S ) = ( P ( ball ` C ) S ) ) $=
      ( vz cfv wcel cxr clt wbr cle wa co adantr syl3anc cxmt cc0 w3a crab wceq
      cv cbl cif simpll2 simpr1 simpr stdbdmetval breq1d wn simplr3 biantrud wb
      simpr2 simpl1 xmetcl xrlemin bitr4d xrltnle syl2anc ifcl 3bitr4d rabbidva
      notbid stdbdxmet blval 3eqtr4d ) CHUAKZLZFMLZUBFNOZUCZEHLZGMLZGFPOZUCZQZE
      JUFZDRZGNOZJHUDZEWBCRZGNOZJHUDZEGDUGKRZEGCUGKRZWAWDWGJHWAWBHLZQZWDWFFPOZW
      FFUHZGNOZWGWLWCWNGNWLVNVQWKWCWNUEVMVNVOVTWKUIZWAVQWKVPVQVRVSUJZSZWAWKUKZA
      BEWBCDFMHIULTUMWLGWFPOZUNZGWNPOZUNZWGWOWLWTXBWLWTWTVSQZXBWLVSWTVQVRVSVPWK
      UOUPWLVRWFMLZVNXBXDUQWAVRWKVPVQVRVSURZSZWLVMVQWKXEWAVMWKVMVNVOVTUSZSWRWSE
      WBCHUTTZWPGWFFVATVBVHWLXEVRWGXAUQXIXGWFGVCVDWLWNMLZVRWOXCUQWLXEVNXJXIWPWM
      WFFMVEVDXGWNGVCVDVFVBVGWADVLLZVQVRWIWEUEVPXKVTABCDFHIVISWQXFJDEGHVJTWAVMV
      QVRWJWHUEXHWQXFJCEGHVJTVK $.

    stdbdmopn.2 $e |- J = ( MetOpen ` C ) $.
    $( The standard bounded metric corresponding to ` C ` generates the same
       topology as ` C ` .  (Contributed by Mario Carneiro, 26-Aug-2015.) $)
    stdbdmopn $p |- ( ( C e. ( *Met ` X ) /\ R e. RR* /\ 0 < R ) ->
        J = ( MetOpen ` D ) ) $=
      ( vs vr wcel cxr cc0 clt wbr cle wceq crp syl2anc vz cfv w3a cv cbl co wa
      cxmt wrex wral cmopn cr rpxr ad2antll simpl2 ifcl rpre rpgt0 simpl3 breq2
      cif ifboth wi 0xr xrltle sylancr mpd xrmin1 xrrege0 syl22anc elrpd simprl
      xrmin2 3jca stdbdbl syldan eqcomd breq1 eqeq12d anbi12d rspcev ralrimivva
      oveq2 syl12anc simp1 stdbdxmet eqid metequiv2 ) CGUHUBZLZEMLZNEOPZUCZJUDZ
      KUDZQPZUAUDZWNCUEUBZUFZWQWNDUEUBZUFZRZUGZJSUIZKSUJUAGUJZFDUKUBZRZWMXDUAKG
      SWMWQGLZWOSLZUGZUGZWOEQPZWOEVAZSLXMWOQPZWQXMWRUFZWQXMWTUFZRZXDXKXMXKXMMLZ
      WOULLZNXMQPZXNXMULLXKWOMLZWKXRXIYAWMXHWOUMUNZWJWKWLXJUOZXLWOEMUPTZXIXSWMX
      HWOUQUNXKNXMOPZXTXKNWOOPZWLYEXIYFWMXHWOURUNWJWKWLXJUSXLYFWLYEWOEWOXMNOUTE
      XMNOUTVBTZXKNMLXRYEXTVCVDYDNXMVEVFVGXKYAWKXNYBYCWOEVHTZXMWOVIVJYGVKYHXKXP
      XOWMXJXHXRXMEQPZUCXPXORXKXHXRYIWMXHXIVLYDXKYAWKYIYBYCWOEVMTVNABCDWQEXMGHV
      OVPVQXCXNXQUGJXMSWNXMRZWPXNXBXQWNXMWOQVRYJWSXOXAXPWNXMWQWRWCWNXMWQWTWCVSV
      TWAWDWBWMWJDWILXEXGVCWJWKWLWEABCDEGHWFUACDFXFGJKIXFWGWHTVG $.
  $}

  ${
    $d d x y D $.  $d d J $.  $d d x y X $.
    mopnex.1 $e |- J = ( MetOpen ` D ) $.
    $( The topology generated by an extended metric can also be generated by a
       true metric.  Thus, "metrizable topologies" can equivalently be defined
       in terms of metrics or extended metrics.  (Contributed by Mario
       Carneiro, 26-Aug-2015.) $)
    mopnex $p |- ( D e. ( *Met ` X ) ->
      E. d e. ( Met ` X ) J = ( MetOpen ` d ) ) $=
      ( vx vy cxmt cfv wcel cv co c1 cle wbr cif cmpt2 cmopn wceq 1rp wrex eqid
      cme crp stdbdmet mpan2 cxr cc0 clt rpxr ax-mp 0lt1 stdbdmopn fveq2 eqeq2d
      mp3an23 rspcev syl2anc ) ACHIJZFGCCFKGKALZMNOUTMPQZCUCIZJZBVARIZSZBDKZRIZ
      SZDVBUAUSMUDJZVCTFGAVAMCVAUBZUEUFUSMUGJZUHMUIOVEVIVKTMUJUKULFGAVAMBCVJEUM
      UPVHVEDVAVBVFVASVGVDBVFVARUNUOUQUR $.
  $}

  ${
    $d d n r t u w x y z D $.  $d d m n r t u w x y z J $.
    $d n r t u w x y z A $.  $d d n r t u w x y z X $.
    methaus.1 $e |- J = ( MetOpen ` D ) $.
    $( The topology generated by a metric space is Hausdorff.  (Contributed by
       Mario Carneiro, 21-Mar-2015.)  (Revised by Mario Carneiro,
       26-Aug-2015.) $)
    methaus $p |- ( D e. ( *Met ` X ) -> J e. Haus ) $=
      ( vd vx vy vm vn cfv wcel cv wceq wrex cha cin c0 w3a co syl3anc cxmt cme
      cmopn mopnex wne wi wral wa c2 cdiv cbl metxmet ad2antrr simplrl cr metcl
      cxr 3expb adantr cc0 clt wbr wb metgt0 biimpa elrpd rphalfcld rpxrd blopn
      eqid simplrr crp blcntr cxad cle caddc rpred syl2anc recnd 2halvesd eqtrd
      rexadd leidd eqbrtrd bldisj syl33anc eleq2 ineq1 eqeq1d 3anbi13d 3anbi23d
      ineq2 rspc2ev syl113anc ex ralrimivva ctopon mopntopon ishaus2 3syl eleq1
      mpbird syl5ibrcom rexlimiv syl ) ACUAJZKBELZUCJZMZECUBJZNBOKZABCEDUDXIXKE
      XJXGXJKZXKXIXHOKZXLXMFLZGLZUEZXNHLZKZXOILZKZXQXSPZQMZRZIXHNHXHNZUFZGCUGFC
      UGZXLYEFGCCXLXNCKZXOCKZUHZUHZXPYDYJXPUHZXNXNXOXGSZUIUJSZXGUKJZSZXHKZXOYMY
      NSZXHKZXNYOKZXOYQKZYOYQPZQMZYDYKXGXFKZYGYMUQKZYPXLUUCYIXPXGCULZUMZXLYGYHX
      PUNZYKYMYKYLYKYLYJYLUOKZXPXLYGYHUUHXNXOXGCUPURUSZYJXPUTYLVAVBZXLYGYHXPUUJ
      VCXNXOXGCVDURVEVFVGZVHZXGXNYMXHCXHVJZVITYKUUCYHUUDYRUUFXLYGYHXPVKZUULXGXO
      YMXHCUUMVITYKUUCYGYMVLKZYSUUFUUGUUKXGXNYMCVMTYKUUCYHUUOYTUUFUUNUUKXGXOYMC
      VMTYKUUCYGYHUUDUUDYMYMVNSZYLVOVBUUBUUFUUGUUNUULUULYKUUPYLYLVOYKUUPYMYMVPS
      ZYLYKYMUOKZUURUUPUUQMYKYMUUKVQZUUSYMYMWBVRYKYLYKYLUUIVSVTWAYKYLUUIWCWDXGX
      NXOYMYMCWEWFYCYSYTUUBRYSXTYOXSPZQMZRHIYOYQXHXHXQYOMZXRYSYBUVAXTXQYOXNWGUV
      BYAUUTQXQYOXSWHWIWJXSYQMZXTYTUVAUUBYSXSYQXOWGUVCUUTUUAQXSYQYOWLWIWKWMWNWO
      WPXLUUCXHCWQJKXMYFVCUUEXGXHCUUMWRFGIHXHCWSWTXBBXHOXAXCXDXE $.

    $( The topology generated by a metric space is first-countable.
       (Contributed by Mario Carneiro, 21-Mar-2015.) $)
    met1stc $p |- ( D e. ( *Met ` X ) -> J e. 1stc ) $=
      ( vy vx vz vw vn vr wcel cv com wbr wss wa wrex cn co crp cxmt cfv wel wi
      ctop cdom wral cpw cuni c1stc mopntop mopnuni eleq2d biimpar c1 cdiv cmpt
      cbl crn wf cxr simpll simplr nnrp rpreccld rpxrd blopn syl3anc eqid fmptd
      adantl frn syl nnex mptex rnex elpw sylibr cen ccrd cdm wfo omelon nnenom
      con0 ensymi isnumi mp2an wfn ovex fnmpti mpbi fodomnum mp2 domentr simprl
      dffn4 a1i simprr mopni2 clt cr elrp nnrecl sylbi ad2antrl simp-4l simp-4r
      cc0 nnrpd blcntr simplrl nnrecre rpred ltled ssbl syl221anc simplrr sstrd
      cle jca expr reximdva mpd rexlimddv cvv wceq wb vex oveq2 cbvmptv elrnmpt
      oveq2d mp1i eleq2 sseq1 anbi12d rexxfr2d mpbird ralrimiva imbi2d syl12anc
      breq1 rexeq ralbidv rspcev syldan is1stc2 sylanbrc ) ACUAUBKZBUEKELZMUFNZ
      FGUCZFHUCZHLZGLZOZPZHUUKQZUDZGBUGZPZEBUHZQZFBUIZUGBUJKABCDUKUUJUVDFUVEUUJ
      FLZUVEKZUVFCKZUVDUUJUVHUVGUUJCUVEUVFABCDULUMUNUUJUVHPZIRUVFUOILZUPSZAURUB
      ZSZUQZUSZUVCKZUVOMUFNZUUMUURHUVOQZUDZGBUGZUVDUVIUVOBOZUVPUVIRBUVNUTUWAUVI
      IRUVMBUVNUVIUVJRKZPZUUJUVHUVKVAKUVMBKUUJUVHUWBVBUUJUVHUWBVCUWCUVKUWCUVJUW
      BUVJTKUVIUVJVDVKVEVFAUVFUVKBCDVGVHUVNVIZVJRBUVNVLVMUVOBUVNIRUVMVNVOVPVQVR
      UVQUVIUVORUFNZRMVSNUVQRVTWAKZRUVOUVNWBZUWEMWEKMRVSNUWFWCRMWDWFMRWGWHUVNRW
      IUWGIRUVMUVNUVFUVKUVLWJUWDWKRUVNWQWLRUVOUVNWMWNWDUVORMWOWHWRUVIUVSGBUVIUU
      PBKZUUMUVRUVIUWHUUMPZPZUVRUVFUVFUOUUKUPSZUVLSZKZUWLUUPOZPZERQZUWJUVFJLZUV
      LSZUUPOZUWPJTUWJUUJUWHUUMUWSJTQUUJUVHUWIVBUVIUWHUUMWPUVIUWHUUMWSJUUPAUVFB
      CDWTVHUWJUWQTKZUWSPZPZUWKUWQXANZERQZUWPUWTUXDUWJUWSUWTUWQXBKXIUWQXANPUXDU
      WQXCUWQEXDXEXFUXBUXCUWOERUXBUUKRKZUXCUWOUXBUXEUXCPZPZUWMUWNUXGUUJUVHUWKTK
      UWMUUJUVHUWIUXAUXFXGZUUJUVHUWIUXAUXFXHZUXGUUKUXGUUKUXBUXEUXCWPXJVEZAUVFUW
      KCXKVHUXGUWLUWRUUPUXGUUJUVHUWKVAKUWQVAKUWKUWQXTNUWLUWROUXHUXIUXGUWKUXJVFU
      XGUWQUWJUWTUWSUXFXLZVFUXGUWKUWQUXEUWKXBKUXBUXCUUKXMXFUXGUWQUXKXNUXBUXEUXC
      WSXOAUVFUWKUWQCXPXQUWJUWTUWSUXFXRXSYAYBYCYDYEUWJUURUWOHEUWLUVORYFUWLYFKUW
      JUXEPUVFUWKUVLWJWRUUOYFKUUOUVOKUUOUWLYGZERQYHUWJHYIERUWLUUOUVNYFIERUVMUWL
      UVJUUKYGUVKUWKUVFUVLUVJUUKUOUPYJYMYKYLYNUXLUURUWOYHUWJUXLUUNUWMUUQUWNUUOU
      WLUVFYOUUOUWLUUPYPYQVKYRYSYBYTUVBUVQUVTPEUVOUVCUUKUVOYGZUULUVQUVAUVTUUKUV
      OMUFUUCUXMUUTUVSGBUXMUUSUVRUUMUURHUUKUVOUUDUUAUUEYQUUFUUBUUGYTFEGHBUVEUVE
      VIUUHUUI $.

    $( A separable metric space (a metric space with a countable dense subset)
       is second-countable.  (Contributed by Mario Carneiro, 13-Apr-2015.) $)
    met2ndci $p |- ( ( D e. ( *Met ` X ) /\ ( A C_ X /\ A ~<_ om /\
      ( ( cls ` J ) ` A ) = X ) ) -> J e. 2ndc ) $=
      ( vx vy vz wcel wss com wbr wceq wa cn cv co wrex adantr syl3anc vw vu vr
      vn vt cxmt cfv cdom ccl w3a c1 cdiv cbl cmpt2 crn c2ndc ctop wral mopntop
      ctg cxp wf simpll simplr1 simprr sseldd simprl nnrpd rpreccld rpxrd blopn
      cxr ralrimivva eqid fmpt2 sylib frn syl crp mopni2 clt rphalfcld cc0 elrp
      c2 cr nnrecl sylbi cin c0 wne wex cuni ad2antrr mopnuni ad3antrrr sseqtrd
      simpr1 simplrr simplrl elunii syl2anc eleqtrrd simpr3 simprrl clsndisj n0
      blcntr syl32anc inss2 simpr sseldi eqidd oveq2 oveq2d eqeq2d rspc2ev ovex
      oveq1 eqeq1 2rexbidv rnmpt2 elab2 sylibr inss1 blcom syl22anc cle simprll
      wb mpbid simprrr wi rpre ltle syl2an mpd sstrd rexlimddv cen rpred blhalf
      ssbl simprlr eleq2 sseq1 anbi12d rspcev syl12anc exlimddv anassrs basgen2
      syl221anc ctb eqeltrd tgclb ccrd cdm wfo con0 omelon simpr2 xpdom2 nnenom
      nnex omex enref xpen mp2an xpomen domentr sylancl ondomen sylancr wfn ffn
      entri dffn4 fodomnum sylc domtr 2ndci eqeltrrd ) BDUFUGIZADJZAKUHLZACUIUG
      UGZDMZUJZNZFGOAGPZUKFPZULQZBUMUGZQZUNZUOZUTUGZCUPUWJCUQIZUWQCJZHPZUAPZIZU
      XBUBPZJZNZUAUWQRZHUXDURUBCURUWRCMUWDUWSUWIBCDEUSSZUWJOAVAZCUWPVBZUWTUWJUW
      OCIZGAURFOURUXJUWJUXKFGOAUWJUWLOIZUWKAIZNZNZUWDUWKDIUWMVLIUXKUWDUWIUXNVCU
      XOADUWKUWEUWFUWHUWDUXNVDUWJUXLUXMVEVFUXOUWMUXOUWLUXOUWLUWJUXLUXMVGVHVIVJB
      UWKUWMCDEVKTVMFGOAUWOCUWPUWPVNZVOVPZUXICUWPVQVRUWJUXGUBHCUXDUWJUXDCIZUXAU
      XDIZNZNZUXAUCPZUWNQZUXDJZUXGUCVSUYAUWDUXRUXSUYDUCVSRUWDUWIUXTVCZUWJUXRUXS
      VGUWJUXRUXSVEUCUXDBUXACDEVTTUYAUYBVSIZUYDNZNZUKUDPZULQZUYBWEULQZWALZUXGUD
      OUYHUYKVSIZUYLUDORZUYHUYBUYAUYFUYDVGWBUYMUYKWFIZWCUYKWALNUYNUYKWDUYKUDWGW
      HVRUYAUYGUYIOIZUYLNZUXGUYAUYGUYQNZNZUEPZUXAUYJUWNQZAWIZIZUXGUEUYSVUBWJWKZ
      VUCUEWLUYSUWSACWMZJUXAUWGIVUACIZUXAVUAIZVUDUWJUWSUXTUYRUXHWNUYSADVUEUWJUW
      EUXTUYRUWDUWEUWFUWHWRWNZUWDDVUEMUWIUXTUYRBCDEWOWPZWQUYSUXADUWGUYSUXAVUEDU
      YSUXSUXRUXAVUEIUWJUXRUXSUYRWSUWJUXRUXSUYRWTUXAUXDCXAXBVUIXCZUWJUWHUXTUYRU
      WDUWEUWFUWHXDWNXCUYSUWDUXADIZUYJVLIZVUFUYAUWDUYRUYESZVUJUYSUYJUYSUYIUYSUY
      IUYAUYGUYPUYLXEZVHVIZVJZBUXAUYJCDEVKTUYSUWDVUKUYJVSIZVUGVUMVUJVUOBUXAUYJD
      XHTUXAAVUACVUEVUEVNXFXIUEVUBXGVPUYSVUCNZUYTUYJUWNQZUWQIZUXAVUSIZVUSUXDJZU
      XGVURVUSUWOMZGARFORZVUTVURUYPUYTAIVUSVUSMZVVDUYSUYPVUCVUNSVURVUBAUYTVUAAX
      JUYSVUCXKZXLZVURVUSXMVVCVVEVUSUWKUYJUWNQZMFGUYIUYTOAUWLUYIMZUWOVVHVUSVVIU
      WMUYJUWKUWNUWLUYIUKULXNXOXPUWKUYTMVVHVUSVUSUWKUYTUYJUWNXSXPXQTUXAUWOMZGAR
      FORVVDHVUSUWQUYTUYJUWNXRUXAVUSMVVJVVCFGOAUXAVUSUWOXTYAFGHOAUWOUWPUXPYBYCY
      DVURUYTVUAIZVVAVURVUBVUAUYTVUAAYEVVFXLVURUWDVULVUKUYTDIZVVKVVAYJUYSUWDVUC
      VUMSZUYSVULVUCVUPSZUYSVUKVUCVUJSVURADUYTUYSUWEVUCVUHSVVGVFZUYTBUXAUYJDYFY
      GYKZVURVUSUYTUYKUWNQZUXDVURUWDVVLVULUYKVLIUYJUYKYHLZVUSVVQJVVMVVOVVNVURUY
      KVURUYBUYSUYFVUCUYAUYFUYDUYQYIZSZWBVJUYSVVRVUCUYSUYLVVRUYAUYGUYPUYLYLUYSV
      UQUYMUYLVVRYMZVUOUYSUYBVVSWBVUQUYJWFIUYOVWAUYMUYJYNUYKYNUYJUYKYOYPXBYQSBU
      YTUYJUYKDUUCUUMZVURVVQUYCUXDVURUWDVVLUYBWFIUXAVVQIVVQUYCJVVMVVOVURUYBVVTU
      UAVURVUSVVQUXAVWBVVPVFUYBBDUYTUXAUUBYGUYSUYDVUCUYAUYFUYDUYQUUDSYRYRUXFVVA
      VVBNUAVUSUWQUXBVUSMUXCVVAUXEVVBUXBVUSUXAUUEUXBVUSUXDUUFUUGUUHUUIUUJUUKYSY
      SVMUBHUAUWQCUULTZUWJUWQUUNIZUWQKUHLZUWRUPIUWJUWRUQIVWDUWJUWRCUQVWCUXHUUOU
      WQUUPYDUWJUWQUXIUHLZUXIKUHLZVWEUWJUXIUUQUURIZUXIUWQUWPUUSZVWFUWJKUUTIVWGV
      WHUVAUWJUXIOKVAZUHLZVWJKYTLVWGUWJUWFVWKUWDUWEUWFUWHUVBAKOUVEUVCVRVWJKKVAZ
      KOKYTLKKYTLVWJVWLYTLUVDKUVFUVGOKKKUVHUVIUVJUVQUXIVWJKUVKUVLZKUXIUVMUVNUWJ
      UWPUXIUVOZVWIUWJUXJVWNUXQUXICUWPUVPVRUXIUWPUVRVPUXIUWQUWPUVSUVTVWMUWQUXIK
      UWAXBUWQUWBXBUWC $.

    $( A metric space is second-countable iff it is separable (has a countable
       dense subset).  (Contributed by Mario Carneiro, 13-Apr-2015.) $)
    met2ndc $p |- ( D e. ( *Met ` X ) -> ( J e. 2ndc <->
      E. x e. ~P X ( x ~<_ om /\ ( ( cls ` J ) ` x ) = X ) ) ) $=
      ( cxmt cfv wcel c2ndc cv com cdom wbr ccl wceq wa cpw wrex cuni eqid syl5
      2ndcsep mopnuni pweqd eqeq2d anbi2d rexeqbidv wss wi elpwi met2ndci 3exp2
      syl5ibr imp4a rexlimdv impbid ) BDFGHZCIHZAJZKLMZUSCNGGZDOZPZADQZRZURVEUQ
      UTVACSZOZPZAVFQZRACVFVFTUBUQVCVHAVDVIUQDVFBCDEUCZUDUQVBVGUTUQDVFVAVJUEUFU
      GUMUQVCURAVDUSVDHUSDUHZUQVCURUIUSDUJUQVKUTVBURUQVKUTVBURUSBCDEUKULUNUAUOU
      P $.
  $}

  ${
    $d r u x y z C $.  $d r y D $.  $d r u x y z J $.  $d r u x y z X $.
    $d r u x y z Y $.  $d x K $.
    metrest.1 $e |- D = ( C |` ( Y X. Y ) ) $.
    metrest.3 $e |- J = ( MetOpen ` C ) $.
    metrest.4 $e |- K = ( MetOpen ` D ) $.
    $( Two alternate formulations of a subspace topology of a metric space
       topology.  (Contributed by Jeff Hankins, 19-Aug-2009.)  (Proof shortened
       by Mario Carneiro, 5-Jan-2014.) $)
    metrest $p |- ( ( C e. ( *Met ` X ) /\ Y C_ X ) -> ( J |`t Y ) = K ) $=
      ( vu vy vr vz wcel wss wa cin wrex crp wi vx cxmt cfv crest wceq cbl wral
      co cv inss1 elmopn2 simplbda adantlr ssralv mpsyl ssrin reximi ralimi syl
      inss2 jctil sseq1 sseq2 rexbidv raleqbi1dv syl5ibrcom rexlimdva cuni ctop
      anbi12d cab mopntop ad2antrr wel ssel2 cxr rpxr blopn eleq1a 3expa sylan2
      anassrs adantrd adantrr abssdv uniopn oveq1 ineq1d sseq1d rspccv ad2antll
      w3a syl2anc ssel blcntr a1d reximdva ex sylan9r mpdd eleq2d rspcev sylcom
      ancld simprl sseld jcad elin sylan2br rexlimivw imp impbid1 eluniab ancom
      expr anass r19.41v rexbii bitr2i 3bitri exbii ineq1 eleq2 ceqsexv rexcom4
      wex ovex bitr3i anbi1i syl6bb eqrdv eqeq2d impbid wb simpr sylanbrc blres
      rexbidva ralbidva cvv pm5.32da bitr4d adantr id mopnm syl2anr elrest cres
      ssexg cxp xmetres2 syl5eqel 3bitr4d ) AEUBUCNZFEOZPZUACFUDUHZDUUPUAUIZJUI
      ZFQZUEZJCRZUURFOZKUIZLUIZBUFUCUHZUUROZLSRZKUURUGZPZUURUUQNZUURDNZUUPUVBUV
      CUVDUVEAUFUCZUHZFQZUUROZLSRZKUURUGZPZUVJUUPUVBUVSUUPUVAUVSJCUUPUUSCNZPZUV
      SUVAUUTFOZUVOUUTOZLSRZKUUTUGZPUWAUWEUWBUWAUVNUUSOZLSRZKUUTUGZUWEUUTUUSOUW
      AUWGKUUSUGZUWHUUSFUJUUNUVTUWIUUOUUNUVTUUSEOUWIKLUUSACEHUKULUMUWGKUUTUUSUN
      UOUWGUWDKUUTUWFUWCLSUVNUUSFUPUQURUSUUSFUTVAUVAUVCUWBUVRUWEUURUUTFVBUVQUWD
      KUURUUTUVAUVPUWCLSUURUUTUVOVCVDVEVJVFVGUUPUVSUVBUUPUVSPZMUIZUVNUEZLSRZKUU
      RRZUWKFQZUUROZPZMVKZVHZCNZUURUWSFQZUEZUVBUWJCVINZUWRCOUWTUUNUXCUUOUVSACEH
      VLZVMUWJUWQMCUUPUVCUWQUWKCNZTUVRUUPUVCPZUWNUXEUWPUXFUWMUXEKUURUUPUVCKUAVN
      ZUWMUXETZUVCUXGPZUUPUVDFNZUXHUURFUVDVOZUUNUUOUXJUXHUUOUXJPZUUNUVDENZUXHFE
      UVDVOZUUNUXMPZUWLUXELSUVESNZUXOUVEVPNZUWLUXETZUVEVQZUUNUXMUXQUXRUUNUXMUXQ
      WLUVNCNUXRAUVDUVECEHVRUVNCUWKVSUSVTWAVGWAWBWAWBVGWCWDWEUWRCWFWMUWJJUURUXA
      UWJJUAVNZUVPUUSUVNNZPZLSRZKUURRZUUSFNZPZUUSUXANZUWJUXTUYFUWJUXTUYDUYEUWJU
      XTUUSUVEUVMUHZFQZUUROZUUSUYHNZPZLSRZUYDUWJUXTUYJLSRZUYMUVRUXTUYNTUUPUVCUV
      QUYNKUUSUURUVDUUSUEZUVPUYJLSUYOUVOUYIUURUYOUVNUYHFUVDUUSUVEUVMWGZWHWIZVDW
      JWKUUPUVCUXTUYNUYMTZTUVRUVCUXTUYEUUPUYRUURFUUSWNUUOUYEUUSENZUUNUYRFEUUSWN
      UUNUYSUYRUUNUYSPUYJUYLLSUUNUYSUXPUYJUYLTUUNUYSUXPWLZUYJUYKUYTUYKUYJAUUSUV
      EEWOWPXDVTWQWRWSWSWDWTUXTUYMUYDUYCUYMKUUSUURUYOUYBUYLLSUYOUVPUYJUYAUYKUYQ
      UYOUVNUYHUUSUYPXAVJVDXBWRXCUWJUURFUUSUUPUVCUVRXEXFXGUYDUYEUXTUYCUYEUXTTZK
      UURUYBVUALSUVPUYAUYEUXTUYAUYEPUVPUUSUVONUXTUUSUVNFXHUVOUURUUSVOXIXOXJXJXK
      XLUYGUUSUWSNZUYEPUYFUUSUWSFXHVUBUYDUYEVUBJMVNZUWQPZMYFUWLUWPVUCPZPZLSRZKU
      URRZMYFZUYDUWQMUUSXMVUDVUHMVUDUWQVUCPUWNVUEPZVUHVUCUWQXNUWNUWPVUCXPVUHUWM
      VUEPZKUURRVUJVUGVUKKUURUWLVUELSXQXRUWMVUEKUURXQXSXTYAUYDVUGMYFZKUURRVUIUY
      CVULKUURUYCVUFMYFZLSRVULVUMUYBLSVUEUYBMUVNUVDUVEUVMYGUWLUWPUVPVUCUYAUWLUW
      OUVOUURUWKUVNFYBWIUWKUVNUUSYCVJYDXRVUFLMSYEYHXRVUGKMUURYEXSXTYIXSYJYKUVAU
      XBJUWSCUUSUWSUEUUTUXAUURUUSUWSFYBYLXBWMWRYMUUPUVCUVIUVRUXFUVHUVQKUURUUPUV
      CUXGUVHUVQYNZUXIUUPUXJVUNUXKUUNUUOUXJVUNUXLUUNUVDEFQNZVUNUXLUXMUXJVUOUXNU
      UOUXJYOUVDEFXHYPUUNVUOPZUVGUVPLSUXPVUPUXQUVGUVPYNZUXSUUNVUOUXQVUQUUNVUOUX
      QWLUVFUVOUURBAUVDUVEEFGYQWIVTWAYRWAWBWAWBYSUUAUUBUUPUXCFYTNZUVKUVBYNUUNUX
      CUUOUXDUUCUUOUUOECNVURUUNUUOUUDACEHUUEFECUUIUUFJUURFCVIYTUUGWMUUPBFUBUCZN
      UVLUVJYNUUPBAFFUUJUUHVUSGAFEUUKUULKLUURBDFIUKUSUUMYK $.
  $}

  ${
    $( The restriction of a metric space is a metric space.  (Contributed by
       Mario Carneiro, 24-Aug-2015.) $)
    ressxms $p |- ( ( K e. *MetSp /\ A e. V ) -> ( K |`s A ) e. *MetSp ) $=
      ( cxme wcel co cds cfv cbs cxp cres cxmt crest cmopn wceq cin eqid adantr
      syl syl5eq wa cress ctopn xmsxmet xmetres resres inxp eqtri ressds adantl
      reseq2i ressbas xpeq12d reseq12d fveq2d 3eltr3d xmstopn oveq1d wss xpss12
      incom inss1 mp2an resabs1 ax-mp eqtr4i metrest sylancl cuni xmstps tpsuni
      eqtrd ctps ineq2d oveq2d ctopon istps sylib restin sylan 3eqtr3d resstopn
      eqtr4d isxms2 sylanbrc ) BDEZACEZUAZBAUBFZGHZWIIHZWKJZKZWKLHZEBUCHZAMFZWM
      NHZOWIDEWHBGHZBIHZWSJZKZAAJZKZWSAPZLHZWMWNWHXAWSLHEZXCXEEWFXFWGXABWSWSQZX
      AQZUDRZXAAWSUESWHXCWRXDXDJZKZWMXCWRWTXBPZKXKWRWTXBUFXLXJWRWSWSAAUGUKUHZWH
      WRWJXJWLWGWRWJOWFAWRBWICWIQZWRQUIUJWHXDWKXDWKWHXDAWSPZWKWSAVAZWGXOWKOWFAW
      SWICBXNXGULUJTZXQUMUNTZWHXDWKLXQUOUPWHWOXDMFZXCNHZWPWQWHXSXANHZXDMFZXTWHW
      OYAXDMWFWOYAOWGXAWOBWSWOQZXGXHUQRURWHXFXDWSUSZYBXTOXIWSAVBZXAXCYAXTWSXDXC
      XKXAXJKZXMXJWTUSZYFXKOYDYDYGYEYEXDWSXDWSUTVCWRXJWTVDVEVFYAQXTQVGVHVLWHXSW
      OAWOVIZPZMFZWPWHXDYIWOMWHXDXOYIXPWHWSYHAWFWSYHOZWGWFBVMEZYKBVJZWSWOBXGYCV
      KSRVNTVOWFWOWSVPHZEZWGWPYJOWFYLYOYMWSWOBXGYCVQVRAWOYNCYHYHQVSVTWCWHXCWMNX
      RUOWAWMWPWIWKAWIWOBXNYCWBWKQWMQWDWE $.

    $( The restriction of a metric space is a metric space.  (Contributed by
       Mario Carneiro, 24-Aug-2015.) $)
    ressms $p |- ( ( K e. MetSp /\ A e. V ) -> ( K |`s A ) e. MetSp ) $=
      ( cmt wcel wa cress co cxme cds cfv cbs cxp cres cme cin eqid wceq adantl
      syl5eq msxms ressxms sylan msmet adantr metres resres inxp reseq2i ressds
      syl eqtri incom ressbas xpeq12d reseq12d fveq2d ctopn crest resstopn isms
      3eltr3d sylanbrc ) BDEZACEZFZBAGHZIEZVGJKZVGLKZVJMZNZVJOKZEVGDEVDBIEVEVHB
      UAABCUBUCVFBJKZBLKZVOMZNZAAMZNZVOAPZOKZVLVMVFVQVOOKEZVSWAEVDWBVEVQBVOVOQZ
      VQQUDUEVQAVOUFUKVFVSVNVTVTMZNZVLVSVNVPVRPZNWEVNVPVRUGWFWDVNVOVOAAUHUIULVF
      VNVIWDVKVEVNVIRVDAVNBVGCVGQZVNQUJSVFVTVJVTVJVFVTAVOPZVJVOAUMVEWHVJRVDAVOV
      GCBWGWCUNSTZWIUOUPTVFVTVJOWIUQVBVLBURKZAUSHVGVJAVGWJBWGWJQUTVJQVLQVAVC $.
  $}

  ${
    $d g k p r w y B $.  $d g k m p r u w x y D $.  $d g k m n p r u w x z I $.
    $d m n u C $.  $d g n r w E $.  $d g k x S $.  $d g k x W $.  $d g k x Y $.
    $d p r u w K $.  $d g k p r u w x ph $.  $d g k m n p r u w x z R $.
    $d r V $.
    prdsxms.y $e |- Y = ( S Xs_ R ) $.
    ${
      prdsxms.s $e |- ( ph -> S e. W ) $.
      prdsxms.i $e |- ( ph -> I e. Fin ) $.
      prdsxms.d $e |- D = ( dist ` Y ) $.
      prdsxms.b $e |- B = ( Base ` Y ) $.
      ${
        prdsms.r $e |- ( ph -> R : I --> MetSp ) $.
        $( Lemma for ~ prdsms .  The distance function of a product structure
           is an extended metric.  (Contributed by Mario Carneiro,
           28-Aug-2015.) $)
        prdsmslem1 $p |- ( ph -> D e. ( Met ` B ) ) $=
          ( vk cfv cds cbs cme eqid cv cmpt cprds co cxp cres ffvelrnda wcel wa
          cmt msmet syl prdsmet feqmptd oveq2d syl5eq fveq2d 3eltr4d ) AEOFOUAZ
          DPZUBZUCUDZQPZVBRPZSPCBSPAOVDVCUTEUTQPUTRPZVEUEUFZFVEGVBUJVBTVDTVETZV
          FTZVCTJKAFUJUSDNUGZAUSFUHUIUTUJUHVFVESPUHVIVFUTVEVGVHUKULUMACHQPVCLAH
          VBQAHEDUCUDVBIADVAEUCAOFUJDNUNUOUPZUQUPABVDSABHRPVDMAHVBRVJUQUPUQUR
          $.
      $}

      prdsxms.r $e |- ( ph -> R : I --> *MetSp ) $.
      $( Lemma for ~ prdsms .  The distance function of a product structure is
         an extended metric.  (Contributed by Mario Carneiro, 28-Aug-2015.) $)
      prdsxmslem1 $p |- ( ph -> D e. ( *Met ` B ) ) $=
        ( vk cfv cds cbs cxmt eqid cv cmpt cprds co cxp cres cfn cxme ffvelrnda
        wcel wa xmsxmet syl prdsxmet feqmptd oveq2d syl5eq fveq2d 3eltr4d ) AEO
        FOUAZDPZUBZUCUDZQPZVCRPZSPCBSPAOVEVDVAEVAQPVARPZVFUEUFZFVFGUGVCUHVCTVET
        VFTZVGTZVDTJKAFUHUTDNUIZAUTFUJUKVAUHUJVGVFSPUJVJVGVAVFVHVIULUMUNACHQPVD
        LAHVCQAHEDUCUDVCIADVBEUCAOFUHDNUOUPUQZURUQABVESABHRPVEMAHVCRVKURUQURUS
        $.

      prdsxms.j $e |- J = ( TopOpen ` Y ) $.
      prdsxms.v $e |- V = ( Base ` ( R ` k ) ) $.
      prdsxms.e $e |- E = ( ( dist ` ( R ` k ) ) |` ( V X. V ) ) $.
      prdsxms.k $e |- K = ( TopOpen ` ( R ` k ) ) $.
      prdsxms.c $e |- C = { x | E. g ( ( g Fn I /\
          A. k e. I ( g ` k ) e. ( ( TopOpen o. R ) ` k ) /\ E. z e. Fin
          A. k e. ( I \ z ) ( g ` k ) = U. ( ( TopOpen o. R ) ` k ) ) /\
        x = X_ k e. I ( g ` k ) ) } $.
      $( Lemma for ~ prdsxms .  The topology generated by the supremum metric
         is the same as the product topology, when the index set is finite.
         (Contributed by Mario Carneiro, 28-Aug-2015.) $)
      prdsxmslem2 $p |- ( ph -> J = ( MetOpen ` D ) ) $=
        ( vp vr vn vm vu vw vy ctopn cfv cbl crn c0 csn cdif ctg cmopn cfn wcel
        wfn wceq cvv wf topnfn cxme syl sylib sylancr syl2anc cv wral cuni wrex
        wss w3a cixp wa wex wi wne co cxr cxmt wb adantr simprl syl3anc cds cbs
        cres cmpt 3ad2ant1 ovex ffvelrnda cprds ralrimiva feqmptd oveq2d syl5eq
        cxp fveq2d eleqtrd blopn fveq2 syl6eqr sylan eqtrd fveq1 eleq1d anbi12d
        eqid weq ixpeq2dva syl121anc sylbid syl6eq raleqdv rspcev syl6sseqr cfi
        syl5bi ccnv cima xmstps eqeltrd ctopon eqeltrrd ad2antrr cnveqd imaeq1d
        ctop ctps crp ccom cpt ffn dffn2 fnfco cab wal eldifsn prdsxmslem1 blrn
        ptval cc0 clt wbr simprr xbln0 mptexg rgenw fnmpt mp1i simp2l prdsbascl
        xmsxmet r19.21bi simp2r xpeq12d reseq12d eqidd oveq123d xmstopn 3eltr4d
        fvmpt adantl fvco3 cbvmptv oveq2i prdsbl ralbidv sylan9eq eqeq2d spcegv
        oveqd simp3 fneq1 3impib 3expia simpr neeq1d ral0 difeq2 difid biantrud
        sylancl df-3an syl6rbbr eqeq1 bi2anan9 3imtr4d rexlimdvva imp3a alrimiv
        exbidv ex ssab sylibr cmpt2 cun ssv fnssres mp2an fvres tpstop mpbir2an
        rgen ffnfv fco2 ptbasfi mopntop prdsbas2 istps toponuni syl5eqr cbvixpv
        unieqd mopntopon toponmax snssd mpteq1d mptpreima elrab2 simprrr mopni2
        ciun ad3antrrr simprrl rpxr ad2antrl blcntr blssm simplrr simplll rpgt0
        crab eleq2d biimpa vex elixp simprbi simp-4r sseldd ssrabdv eleq2 sseq1
        sylc syl12anc rexlimddv expr ralrimiv eltop2 mpteq2dv raleqbidv cbvralv
        rsp mpbird fmpt2x frn unssd fiss eqsstrd mopnval tgdif0 sseqtrd 2basgen
        fitop eqtr4d prdstopn 3eqtr4d ) AUPGUUAZUUBUQZFURUQZUSZUTVAVBZVCUQZMFVD
        UQZAVVSEVCUQZVWCALVEVFZVVRLVGZVVSVWEVHTAUPVIVGZLVIGVJZVWGVKAGLVGZVWIALV
        LGVJZVWJUCLVLGUUCVMZLGUUDVNVILUPGUUEVOBJCLEIVVRVEUHUUKVPAVWBEWAEVWCWAVW
        CVWEVHAVWBIVQZLVGZJVQZVWMUQZVWOVVRUQZVFZJLVRZVWPVWQVSZVHZJLCVQZVBZVRZCV
        EVTZWBZBVQZJLVWPWCZVHZWDZIWEZBUUFZEAVXGVWBVFZVXKWFZBUUGVWBVXLWAAVXNBVXM
        VXGVWAVFZVXGUTWGZWDAVXKVXGVWAUTUUHAVXOVXPVXKAVXOVXGUIVQZUJVQZVVTWHZVHZU
        JWIVTUIDVTZVXPVXKWFZAFDWJUQVFZVXOVYAWKADFGHLPQRSTUAUBUCUUIZUIVXGFDUJUUJ
        VMAVXTVYBUIUJDWIAVXQDVFZVXRWIVFZWDZWDZVXTVYBVYHVXTWDZVXSUTWGZVWNVWSWDZV
        XSVXHVHZWDZIWEZVXPVXKVYHVYJVYNWFVXTVYHVYJUULVXRUUMUUNZVYNVYHVYCVYEVYFVY
        JVYOWKAVYCVYGVYDWLAVYEVYFWMAVYEVYFUUOFVXQVXRDUUPWNAVYGVYOVYNAVYGVYOWBZU
        KLUKVQZVXQUQZVXRVYQGUQZWOUQZVYSWPUQZWUAXGZWQZURUQZWHZWRZVIVFZWUFLVGZVWO
        WUFUQZVWQVFZJLVRZVXSJLVWOVXQUQZVXRKURUQZWHZWCZVHZVYNVYPVWFWUGAVYGVWFVYO
        TWSZUKLWUEVEUUQVMWUEVIVFZUKLVRWUHVYPWURUKLVYRVXRWUDWTUURUKLWUEWUFVIWUFX
        RZUUSUUTVYPWUJJLVYPVWOLVFZWDZWUNKVDUQZWUIVWQWVAKOWJUQVFZWULOVFZVYFWUNWV
        BVFWVAVWOGUQZVLVFZWVCVYPLVLVWOGAVYGVWKVYOUCWSZXAZKWVEOUEUFUVCZVMZVYPWVD
        JLVYPJHJLWVEWRZXBWHZWPUQZWVEHVXQLOPVEVLWVLWVLXRWVMXRAVYGHPVFVYOSWSZWUQV
        YPWVFJLWVHXCUEVYPVXQDWVMAVYEVYFVYOUVAZVYPDQWPUQZWVMUBVYPQWVLWPVYPQHGXBW
        HZWVLRVYPGWVKHXBVYPJLVLGWVGXDXEXFXHXFXIUVBUVDVYPVYFWUTAVYEVYFVYOUVEZWLK
        WULVXRWVBOWVBXRZXJWNWUTWUIWUNVHVYPUKVWOWUEWUNLWUFUKJXSZVYRWULVXRVXRWUDW
        UMWVTWUCKURWVTWUCWVEWOUQZOOXGZWQKWVTVYTWWAWUBWWBWVTVYSWVEWOVYQVWOGXKZXH
        WVTWUAOWUAOWVTWUAWVEWPUQZOWVTVYSWVEWPWWCXHUEXLZWWEUVFUVGUFXLXHVYQVWOVXQ
        XKWVTVXRUVHUVIWUSWULVXRWUMWTUVLZUVMWVAVWQNWVBVYPVWKWUTVWQNVHZWVGVWKWUTW
        DVWQWVEUPUQNLVLVWOUPGUVNUGXLZXMWVAWVFNWVBVHZWVHKNWVEOUGUEUFUVJZVMXNUVKX
        CVYPVXSVXQVXRHUKLVYSWRZXBWHZWOUQZURUQZWHWUOVYPVVTWWNVXQVXRVYPFWWMURVYPF
        QWOUQWWMUAVYPQWWLWOVYPQWVQWWLRVYPGWWKHXBVYPUKLVLGWVGXDXEXFZXHXFXHUWBVYP
        JVXRWWLWPUQZWWMVXQWVEHKLOPWWLVLWWKWVKHXBUKJLVYSWVEWWCUVOUVPWWPXRUEUFWWM
        XRWVNWUQWVHWVJVYPVXQDWWPWVOVYPDWVPWWPUBVYPQWWLWPWWOXHXFXIWVRAVYGVYOUWCU
        VQXNZWUGWUHWUKWDZWUPVYNVYMWWRWUPWDIWUFVIVWMWUFVHZVYKWWRVYLWUPWWSVWNWUHV
        WSWUKLVWMWUFUWDWWSVWRWUJJLWWSVWPWUIVWQVWOVWMWUFXOZXPUVRXQWWSVXHWUOVXSWW
        SJLVWPWUNWWSWUTVWPWUIWUNWWTWWFUVSXTUVTXQUWAUWEYAUWFYBWLVYIVXGVXSUTVYHVX
        TUWGUWHVYIVXJVYMIVYHVXFVYKVXTVXIVYLVYHVYKVYKVXEWDVXFVYHVXEVYKAVXEVYGAVW
        FVXAJUTVRZVXETVXAJUWIVXDWXACLVEVXBLVHZVXAJVXCUTWXBVXCLLVBUTVXBLLUWJLUWK
        YCYDYEUWMWLUWLVWNVWSVXEUWNUWOVXGVXSVXHUWPUWQUXBUWRUXCUWSYBUWTYHUXAVXKBV
        WBUXDUXEUHYFAEVWDYGUQZVWCAEUKLVYQVVRUQZVSZWCZVAZULUMLULVQZVVRUQZUNWXFWX
        HUNVQZUQZWRZYIZUMVQZYJZUXFZUSZUXGZYGUQZWXCAVWFLYRVVRVJZEWXSVHTAVLYRUPVL
        WQZVJZVWKWXTWYBWYAVLVGZVXGWYAUQZYRVFZBVLVRVWHVLVIWAWYCVKVLUXHVIVLUPUXIU
        XJWYEBVLVXGVLVFZWYDVXGUPUQZYRVXGVLUPUXKWYFVXGYSVFWYGYRVFVXGYKWYGVXGWYGX
        RUXLVMYLUXNBVLYRWYAUXOUXMUCLVLYRUPGUXPVOBJCUNUMLEIULUKVVRVEWXFUHWXFXRUX
        QVPAVWDYRVFZWXRVWDWAWXSWXCWAAVYCWYHVYDFVWDDVWDXRZUXRVMZAWXGWXQVWDAWXFVW
        DADWXFVWDADJLVWTWCZWXFADJLWWDWCWYKAJDGHLPVEQRUBSTVWLUXSAJLWWDVWTAWUTWDZ
        WWDOVWTUEWYLVWQOYMUQZVFOVWTVHWYLVWQNWYMAVWKWUTWWGUCWWHXMZWYLWVEYSVFZNWY
        MVFWYLWVFWYOALVLVWOGUCXAZWVEYKVMONWVEUEUGUXTVNYLOVWQUYAVMUYBXTXNJUKLVWT
        WXEJUKXSVWQWXDVWOVYQVVRXKUYDUYCYCZAVWDDYMUQVFZDVWDVFAVYCWYRVYDFVWDDWYIU
        YEVMDVWDUYFVMYNUYGAULLWXHVAWXIXGUYMZVWDWXPVJZWXQVWDWAAWXOVWDVFZUMWXIVRZ
        ULLVRZWYTAUNWXFVWOWXJUQZWRZYIZWXNYJZVWDVFZUMVWQVRZJLVRXUCAXUIJLWYLXUIXU
        HUMNVRWYLXUHUMNWYLWXNNVFZWDZUNDXUDWRZYIZWXNYJZXUGVWDXUKXUMXUFWXNXUKXULX
        UEAXULXUEVHWUTXUJAUNDWXFXUDWYQUYHYOYPYQXUKXUNVWDVFZVXQUOVQZVFZXUPXUNWAZ
        WDZUOVWDVTZUIXUNVRZXUKXUTUIXUNVXQXUNVFVYEWULWXNVFZWDZXUKXUTXUDWXNVFZXVB
        UNVXQDXUNUNUIXSXUDWULWXNVWOWXJVXQXOXPUNDXUDWXNXULXULXRUYIZUYJWYLXUJXVCX
        UTWYLXUJXVCWDZWDZWUNWXNWAZXUTUJYTXVGWVCWXNWVBVFXVBXVHUJYTVTWYLWVCXVFWYL
        WVFWVCWYPWVIVMWLXVGWXNNWVBWYLXUJXVCWMWYLWWIXVFWYLWVFWWIWYPWWJVMWLXIWYLX
        UJVYEXVBUYKUJWXNKWULWVBOWVSUYLWNXVGVXRYTVFZXVHWDZWDZVXSVWDVFZVXQVXSVFZV
        XSXUNWAZXUTXVKVYCVYEVYFXVLAVYCWUTXVFXVJVYDUYNZXVGVYEXVJWYLXUJVYEXVBUYOW
        LZXVIVYFXVGXVHVXRUYPUYQZFVXQVXRVWDDWYIXJWNXVKVYCVYEXVIXVMXVOXVPXVGXVIXV
        HWMFVXQVXRDUYRWNXVKVXSXVDUNDVUCXUNXVKXVDUNDVXSXVKVYCVYEVYFVXSDWAXVOXVPX
        VQFVXQVXRDUYSWNXVKWXJVXSVFZWDZWUNWXNXUDXVGXVIXVHXVRUYTXVSXUDWUNVFZJLVRZ
        WUTXVTXVSWXJWUOVFZXWAXVKXVRXWBXVKVXSWUOWXJXVKAVYEVYFVYOWUPAWUTXVFXVJVUA
        XVPXVQXVIVYOXVGXVHVXRVUBUYQWWQYAVUDVUEXWBWXJLVGXWAJLWUNWXJUNVUFVUGVUHVM
        AWUTXVFXVJXVRVUIXVTJLVVCVUNVUJVUKXVEYFXUSXVMXVNWDUOVXSVWDXUPVXSVHXUQXVM
        XURXVNXUPVXSVXQVULXUPVXSXUNVUMXQYEVUOVUPVUQYHVURXUKWYHXUOXVAWKAWYHWUTXU
        JWYJYOUIUOXUNVWDVUSVMVVDYNXCWYLXUHUMVWQNWYNYDVVDXCXUIXUBJULLJULXSZXUHXU
        AUMVWQWXIVWOWXHVVRXKXWCXUGWXOVWDXWCXUFWXMWXNXWCXUEWXLXWCUNWXFXUDWXKVWOW
        XHWXJXKVUTYPYQXPVVAVVBVNULUMLWXIWXOVWDWXPWXPXRVVEVNWYSVWDWXPVVFVMVVGWXR
        VWDYRVVHVPVVIAWXCVWDVWCAWYHWXCVWDVHWYJVWDVVNVMAVWDVWAVCUQZVWCAVYCVWDXWD
        VHVYDFVWDDWYIVVJVMVWAVVKXLZXNVVLVWBEVVMVPVVOAGHLMPVEQRSTVWLUDVVPXWEVVQ
        $.
    $}

    $( The indexed product structure is an extended metric space when the index
       set is finite.  (Although the extended metric is still valid when the
       index set is infinite, it no longer agrees with the product topology,
       which is not metrizable in any case.)  (Contributed by Mario Carneiro,
       28-Aug-2015.) $)
    prdsxms $p |- ( ( S e. W /\ I e. Fin /\ R : I --> *MetSp ) ->
      Y e. *MetSp ) $=
      ( vx vz vg vk wcel cfn cxme wf cfv ctopn cmopn wceq eqid cv w3a cres cxmt
      cds cbs cxp simp1 simp2 simp3 prdsxmslem1 ssid xmetres2 sylancl ccom wral
      wss wfn cuni cdif wrex cixp wa wex cab prdsxmslem2 cxr xmetf fnresdm 4syl
      ffn fveq2d eqtr4d isxms2 sylanbrc ) BDKZCLKZCMANZUAZEUDOZEUEOZVTUFZUBZVTU
      COZKZEPOZWBQOZREMKVRVSWCKZVTVTUPWDVRVTVSABCDEFVOVPVQUGZVOVPVQUHZVSSZVTSZV
      OVPVQUIZUJZVTUKVSVTVTULUMVRWEVSQOWFVRGHVTITZCUQJTZWNOZWOPAUNOZKJCUOWPWQUR
      RJCHTUSUOHLUTUAGTJCWPVARVBIVCGVDZVSABIJWOAOZUDOWSUEOZWTUFUBZCWEWSPOZWTDEF
      WHWIWJWKWLWESZWTSXASXBSWRSVEVRWBVSQVRWGWAVFVSNVSWAUQWBVSRWMVSVTVGWAVFVSVJ
      WAVSVHVIVKVLWBWEEVTXCWKWBSVMVN $.

    $( The indexed product structure is a metric space when the index set is
       finite.  (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    prdsms $p |- ( ( S e. W /\ I e. Fin /\ R : I --> MetSp ) ->
      Y e. MetSp ) $=
      ( vx wcel cfn cmt wf w3a cxme cds cfv cbs cxp cres wss eqid cme msxms fss
      cv ssriv mpan2 prdsxms syl3an3 simp1 simp2 simp3 prdsmslem1 metres2 ctopn
      ssid sylancl isms sylanbrc ) BDHZCIHZCJAKZLZEMHZENOZEPOZVEQRZVEUAOZHZEJHV
      AUSUTCMAKZVCVAJMSVIGJMGUDUBUECJMAUCUFABCDEFUGUHVBVDVGHVEVESVHVBVEVDABCDEF
      USUTVAUIUSUTVAUJVDTVETZUSUTVAUKULVEUOVDVEVEUMUPVFEUNOZEVEVKTVJVFTUQUR $.
  $}

  ${
    pwsms.y $e |- Y = ( R ^s I ) $.
    $( The product of a finite family of metric spaces is a metric space.
       (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    pwsxms $p |- ( ( R e. *MetSp /\ I e. Fin ) -> Y e. *MetSp ) $=
      ( cxme wcel cfn wa csca cfv csn cxp cprds co eqid pwsval cvv wf fvex a1i
      simpr fconst6g adantr prdsxms syl3anc eqeltrd ) AEFZBGFZHZCAIJZBAKLZMNZEA
      UJBEGCDUJOPUIUJQFZUHBEUKRZULEFUMUIAISTUGUHUAUGUNUHBAEUBUCUKUJBQULULOUDUEU
      F $.

    $( The product of a finite family of metric spaces is a metric space.
       (Contributed by Mario Carneiro, 28-Aug-2015.) $)
    pwsms $p |- ( ( R e. MetSp /\ I e. Fin ) -> Y e. MetSp ) $=
      ( cmt wcel cfn wa csca cfv csn cxp cprds co eqid pwsval cvv wf fvex a1i
      simpr fconst6g adantr prdsms syl3anc eqeltrd ) AEFZBGFZHZCAIJZBAKLZMNZEAU
      JBEGCDUJOPUIUJQFZUHBEUKRZULEFUMUIAISTUGUHUAUGUNUHBAEUBUCUKUJBQULULOUDUEUF
      $.
  $}

  ${
    $d x y R $.  $d x y S $.
    xpsms.t $e |- T = ( R Xs. S ) $.
    $( A binary product of metric spaces is a metric space.  (Contributed by
       Mario Carneiro, 28-Aug-2015.) $)
    xpsxms $p |- ( ( R e. *MetSp /\ S e. *MetSp ) -> T e. *MetSp ) $=
      ( vx vy cxme wcel cbs cfv csca csn ccda co ccnv cv eqid wf1o mp1i c2o cxp
      wa cprds cmpt2 crn simpl simpr xpsval xpslem xpsff1o2 f1ocnv cvv cfn fvex
      wf a1i com 2onn nnfi xpscf biimpri prdsxms syl3anc imasf1oxms ) AGHZBGHZU
      BZAIJZBIJZUAZAKJZALBLMNOZUCNZCEFVHVIEPLFPLMNOUDZOZVNUEZVGEFABCVMVNVKGGVHV
      IDVHQZVIQZVEVFUFZVEVFUGZVNQZVKQZVMQZUHVGEFABCVMVNVKGGVHVIDVQVRVSVTWAWBWCU
      IVJVPVNRVPVJVORVGEFVHVIVNWAUJVJVPVNUKSVGVKULHZTUMHZTGVLUOZVMGHWDVGAKUNUPT
      UQHWEVGURTUSSWFVGGABUTVAVLVKTULVMWCVBVCVD $.

    $( A binary product of metric spaces is a metric space.  (Contributed by
       Mario Carneiro, 28-Aug-2015.) $)
    xpsms $p |- ( ( R e. MetSp /\ S e. MetSp ) -> T e. MetSp ) $=
      ( vx vy cmt wcel cbs cfv csca csn ccda co ccnv cv eqid wf1o mp1i c2o fvex
      cxp cprds cmpt2 crn simpl simpr xpsval xpslem xpsff1o2 f1ocnv cvv cfn a1i
      wa wf com 2onn nnfi xpscf biimpri prdsms syl3anc imasf1oms ) AGHZBGHZUOZA
      IJZBIJZUBZAKJZALBLMNOZUCNZCEFVHVIEPLFPLMNOUDZOZVNUEZVGEFABCVMVNVKGGVHVIDV
      HQZVIQZVEVFUFZVEVFUGZVNQZVKQZVMQZUHVGEFABCVMVNVKGGVHVIDVQVRVSVTWAWBWCUIVJ
      VPVNRVPVJVORVGEFVHVIVNWAUJVJVPVNUKSVGVKULHZTUMHZTGVLUPZVMGHWDVGAKUAUNTUQH
      WEVGURTUSSWFVGGABUTVAVLVKTULVMWCVBVCVD $.
  $}

  ${
    tmsxps.p $e |- P = ( dist ` ( ( toMetSp ` M ) Xs. ( toMetSp ` N ) ) ) $.
    tmsxps.1 $e |- ( ph -> M e. ( *Met ` X ) ) $.
    tmsxps.2 $e |- ( ph -> N e. ( *Met ` Y ) ) $.
    $( Express the product of two metrics as another metric.  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    tmsxps $p |- ( ph -> P e. ( *Met ` ( X X. Y ) ) ) $=
      ( ctmt cfv cbs cxmt cxp wceq cxme eqid wcel tmsxms syl cxps cres xpsdsfn2
      wfn fnresdm xpsxms syl2anc xmsxmet2 eqeltrrd tmsbas xpeq12d xpsbas fveq2d
      co eqtrd eleqtrrd ) ABCJKZDJKZUAUNZLKZMKZEFNZMKABUTUTNZUBZBVAABVCUDVDBOAB
      UQURUSPPUQLKZURLKZUSQZVEQZVFQZACEMKRZUQPRZHCUQEUQQZSTZADFMKRZURPRZIDURFUR
      QZSTZGUCVCBUETAUSPRZVDVARAVKVOVRVMVQUQURUSVGUFUGBUSUTUTQGUHTUIAVBUTMAVBVE
      VFNUTAEVEFVFAVJEVEOHCUQEVLUJTAVNFVFOIDURFVPUJTUKAUQURUSPPVEVFVGVHVIVMVQUL
      UOUMUP $.

    ${
      tmsxpsmopn.j $e |- J = ( MetOpen ` M ) $.
      tmsxpsmopn.k $e |- K = ( MetOpen ` N ) $.
      tmsxpsmopn.l $e |- L = ( MetOpen ` P ) $.
      $( Express the product of two metrics as another metric.  (Contributed by
         Mario Carneiro, 2-Sep-2015.) $)
      tmsxpsmopn $p |- ( ph -> L = ( J tX K ) ) $=
        ( cfv wcel wceq eqid syl ctmt cxps co ctopn ctx ctps cxme tmsxms xmstps
        cxmt xpstopn syl2anc cmopn cbs cxp cres xpsxms reseq1i xmstopn xpsdsfn2
        cds wfn fnresdm fveq2d eqtr2d syl5eq tmstopn oveq12d 3eqtr4d ) AFUAPZGU
        APZUBUCZUDPZVJUDPZVKUDPZUEUCZECDUEUCAVJUFQZVKUFQZVMVPRAVJUGQZVQAFHUJPQZ
        VSKFVJHVJSZUHTZVJUITAVKUGQZVRAGIUJPQZWCLGVKIVKSZUHTZVKUITVJVKVLVNVOVMVL
        SZVNSVOSVMSZUKULAEBUMPZVMOAVMBVLUNPZWJUOZUPZUMPZWIAVLUGQZVMWMRAVSWCWNWB
        WFVJVKVLWGUQULWLVMVLWJWHWJSBVLVAPWKJURUSTAWLBUMABWKVBWLBRABVJVKVLUGUGVJ
        UNPZVKUNPZWGWOSWPSWBWFJUTWKBVCTVDVEVFACVNDVOUEAVTCVNRKFCVJHWAMVGTAWDDVO
        RLGDVKIWENVGTVHVI $.
    $}

    tmsxpsval.a $e |- ( ph -> A e. X ) $.
    tmsxpsval.b $e |- ( ph -> B e. Y ) $.
    tmsxpsval.c $e |- ( ph -> C e. X ) $.
    tmsxpsval.d $e |- ( ph -> D e. Y ) $.
    $( Value of the product of two metrics.  (Contributed by Mario Carneiro,
       2-Sep-2015.) $)
    tmsxpsval $p |- ( ph -> ( <. A , B >. P <. C , D >. ) =
        sup ( { ( A M C ) , ( B N D ) } , RR* , < ) ) $=
      ( co cfv wcel cop ctmt cds cbs cxp cres cpr cxr clt csup cxps cxme tmsxms
      eqid cxmt syl wss wceq tmsds tmsbas 3eltr3d ssid xmetres2 sylancl eleqtrd
      fveq2d xpsdsval ovresd oveqd eqtr4d preq12d supeq1d eqtrd ) ABCUADEUAFRBD
      GUBSZUCSZVNUDSZVPUEUFZRZCEHUBSZUCSZVSUDSZWAUEUFZRZUGZUHUIUJBDGRZCEHRZUGZU
      HUIUJABCDEFVNVSVNVSUKRZVQWBULULVPWAWHUNVPUNWAUNAGIUOSZTZVNULTLGVNIVNUNZUM
      UPAHJUOSZTZVSULTMHVSJVSUNZUMUPKVQUNWBUNAVOVPUOSZTVPVPUQVQWOTAGWIVOWOLAWJG
      VOURLGVNIWKUSUPZAIVPUOAWJIVPURLGVNIWKUTUPZVFVAVPVBVOVPVPVCVDAVTWAUOSZTWAW
      AUQWBWRTAHWLVTWRMAWMHVTURMHVSJWNUSUPZAJWAUOAWMJWAURMHVSJWNUTUPZVFVAWAVBVT
      WAWAVCVDABIVPNWQVEZACJWAOWTVEZADIVPPWQVEZAEJWAQWTVEZVGAUHWDWGUIAVRWEWCWFA
      VRBDVORWEABDVOVPXAXCVHAGVOBDWPVIVJAWCCEVTRWFACEVTWAXBXDVHAHVTCEWSVIVJVKVL
      VM $.

    $( Value of the product of two metrics.  (Contributed by Mario Carneiro,
       2-Sep-2015.) $)
    tmsxpsval2 $p |- ( ph -> ( <. A , B >. P <. C , D >. ) =
        if ( ( A M C ) <_ ( B N D ) , ( B N D ) , ( A M C ) ) ) $=
      ( cxr clt wcel cop co cpr csup wbr cif cle tmsxpsval wor wceq xrltso cxmt
      a1i cfv xmetcl syl3anc suppr wn xrltnle syl2anc ifbid ifnot syl6eq 3eqtrd
      wb ) ABCUADEUAFUBBDGUBZCEHUBZUCRSUDZVGVFSUEZVFVGUFZVFVGUGUEZVGVFUFZABCDEF
      GHIJKLMNOPQUHARSUIZVFRTZVGRTZVHVJUJVMAUKUMAGIULUNTBITDITVNLNPBDGIUOUPZAHJ
      ULUNTCJTEJTVOMOQCEHJUOUPZRVFVGSUQUPAVJVKURZVFVGUFVLAVIVRVFVGAVOVNVIVRVEVQ
      VPVGVFUSUTVAVKVFVGVBVCVD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Continuity in metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z F $.  $d t u v w x y z J $.  $d t u v w x y z K $.
    $d t u v w x y z X $.  $d t u v w x y z Y $.  $d t u v w x y z Z $.
    $d u v w x y z A $.  $d u v w x y z C $.  $d u v w x y z D $.
    $d u v w x z B $.  $d u v w x y z E $.  $d u v w x y z P $.
    $d t w x y z L $.
    metcn.2 $e |- J = ( MetOpen ` C ) $.
    metcn.4 $e |- K = ( MetOpen ` D ) $.
    $( Two ways to express that ` F ` is continuous at ` P ` for metric
       spaces.  Proposition 14-4.2 of [Gleason] p. 240.  (Contributed by NM,
       17-May-2007.)  (Revised by Mario Carneiro, 28-Aug-2015.) $)
    metcnp3 $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) /\ P e. X ) ->
      ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\
        A. y e. RR+ E. z e. RR+ ( F " ( P ( ball ` C ) z ) )
        C_ ( ( F ` P ) ( ball ` D ) y ) ) ) ) $=
      ( vv cfv wcel wss wa wrex wi crp vu cxmt w3a ccnp co wf cima cbl crn wral
      cv ctopon mopntopon 3ad2ant1 ctg wceq mopnval 3ad2ant2 simp3 tgcnp simplr
      simpll2 simpll3 ffvelrnd simpr blcntr syl3anc cxr rpxr adantl eleq2 sseq2
      blelrn anbi2d rexbidv imbi12d rspcv syl mpid simpl1 simplrr mopni2 imass2
      ad2antrr sstr2 com12 reximdv syl5com expimpd expr rexlimdv syld ralrimdva
      simpl2 blss 3expib r19.29r ad3antrrr ad2antrl simprl sstr ad2ant2l ancoms
      blopn imaeq2 sseq1d anbi12d rspcev syl12anc rexlimdva syl5 exp3a ralrimdv
      com23 exp4a impbid pm5.32da bitrd ) CIUBNOZDJUBNOZEIOZUCZFEGHUDUENOIJFUFZ
      EFNZUAUKZOZEMUKZOZFYGUGZYEPZQZMGRZSZUADUHNZUIZUJZQYCFEBUKZCUHNUEZUGZYDAUK
      ZYNUEZPZBTRZATUJZQYBMUAYOEFGHIJXSXTGIULNOYACGIKUMUNXTXSHYOUONUPYADHJLUQUR
      XTXSHJULNOYADHJLUMURXSXTYAUSUTYBYCYPUUDYBYCQZYPUUDUUEYPUUCATUUEYTTOZQZYPY
      HYIUUAPZQZMGRZUUCUUGYPYDUUAOZUUJUUGXTYDJOZUUFUUKXSXTYAYCUUFVBZUUGIJEFYBYC
      UUFVAXSXTYAYCUUFVCZVDZUUEUUFVEDYDYTJVFVGUUGUUAYOOZYPUUKUUJSZSUUGXTUULYTVH
      OZUUPUUMUUOUUFUURUUEYTVIVJDYDYTJVMVGYMUUQUAUUAYOYEUUAUPZYFUUKYLUUJYEUUAYD
      VKUUSYKUUIMGUUSYJUUHYHYEUUAYIVLVNVOVPVQVRVSUUGUUIUUCMGUUEUUFYGGOZUUIUUCSU
      UEUUFUUTQZQZYHUUHUUCUVBYHQZYRYGPZBTRZUUHUUCUVCXSUUTYHUVEUUEXSUVAYHXSXTYAY
      CVTZWDUUEUUFUUTYHWAUVBYHVEBYGCEGIKWBVGUUHUVDUUBBTUVDUUHUUBUVDYSYIPUUHUUBS
      YRYGFWCYSYIUUAWEVRWFWGWHWIWJWKWLWMUUEUUDYMUAYOUUEUUDYEYOOZYFYLUUEUVGYFQZU
      UDYLUUEUVHUUAYEPZATRZUUDYLSUUEXTUVHUVJSXSXTYAYCWNXTUVGYFUVJAYEDYDJWOWPVRU
      UEUVJUUDYLUVJUUDQUVIUUCQZATRUUEYLUVIUUCATWQUUEUVKYLATUUGUVIUUCYLUUGUVIQZU
      UBYLBTUVLYQTOZUUBYLUVLUVMUUBQZQZYRGOZEYROZYSYEPZYLUVOXSYAYQVHOZUVPUUEXSUU
      FUVIUVNUVFWRZUUGYAUVIUVNUUNWDZUVMUVSUVLUUBYQVIWSCEYQGIKXDVGUVOXSYAUVMUVQU
      VTUWAUVLUVMUUBWTCEYQIVFVGUVNUVLUVRUUBUVIUVRUVMUUGYSUUAYEXAXBXCYKUVQUVRQMY
      RGYGYRUPZYHUVQYJUVRYGYREVKUWBYIYSYEYGYRFXEXFXGXHXIWJXJWIXJXKXLWLXNXOXMXPX
      QXR $.

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous at point ` P ` .  (Contributed by NM, 11-May-2007.)  (Revised
       by Mario Carneiro, 28-Aug-2015.) $)
    metcnp $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) /\ P e. X ) ->
                ( F e. ( ( J CnP K ) ` P ) <->
          ( F : X --> Y /\ A. y e. RR+ E. z e. RR+
      A. w e. X ( ( P C w ) < z -> ( ( F ` P ) D ( F ` w ) ) < y ) ) ) ) $=
      ( cfv wcel co crp wral wa wi cxmt w3a ccnp wf cv cbl cima wss clt metcnp3
      wrex wbr wfun cdm ffun ad2antlr cxr simpll1 simpll3 rpxr ad2antll syl3anc
      wb wceq fdm sseqtr4d funimass4 syl2anc elbl imbi1d impexp simpl2 ad2antrr
      blssm simplrl rpxrd simpllr adantr ffvelrnd simplr ffvelrnda elbl2 imbi2d
      syl22anc pm5.74da syl5bb ralbidv2 anassrs rexbidva ralbidva pm5.32da
      bitrd ) DJUANOZEKUANOZFJOZUBZGFHIUCPNOJKGUDZGFBUEZDUFNPZUGFGNZAUEZEUFNPZU
      HZBQUKZAQRZSWQFCUEZDPWRUIULZWTXFGNZEPXAUIULZTZCJRZBQUKZAQRZSABDEFGHIJKLMU
      JWPWQXEXMWPWQSZXDXLAQXNXAQOZSXCXKBQXNXOWRQOZXCXKVCXNXOXPSZSZXCXHXBOZCWSRZ
      XKXRGUMZWSGUNZUHXCXTVCWQYAWPXQJKGUOUPXRWSJYBXRWMWOWRUQOZWSJUHWMWNWOWQXQUR
      ZWMWNWOWQXQUSZXPYCXNXOWRUTVAZDFWRJVNVBWQYBJVDWPXQJKGVEUPVFCWSXBGVGVHXRXSX
      JCWSJXRXFWSOZXSTXFJOZXGSZXSTZYHXJTZXRYGYIXSXRWMWOYCYGYIVCYDYEYFXFDFWRJVIV
      BVJYJYHXGXSTZTXRYKYHXGXSVKXRYHYLXJXRYHSZXSXIXGYMWNXAUQOWTKOXHKOXSXIVCXNWN
      XQYHWMWNWOWQVLVMYMXAXNXOXPYHVOVPYMJKFGWPWQXQYHVQXRWOYHYEVRVSXRJKXFGWPWQXQ
      VTWAXHEWTXAKWBWDWCWEWFWLWGWLWHWIWJWKWL $.

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous at point ` P ` .  The distance arguments are swapped compared
       to ~ metcnp (and Munkres' ~ metcn ) for compatibility with ~ df-lm .
       Definition 1.3-3 of [Kreyszig] p. 20.  (Contributed by NM, 4-Jun-2007.)
       (Revised by Mario Carneiro, 13-Nov-2013.) $)
    metcnp2 $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) /\ P e. X ) ->
                ( F e. ( ( J CnP K ) ` P ) <->
          ( F : X --> Y /\ A. y e. RR+ E. z e. RR+
      A. w e. X ( ( w C P ) < z -> ( ( F ` w ) D ( F ` P ) ) < y ) ) ) ) $=
      ( cfv wcel co clt wbr crp wa cxmt w3a ccnp wf cv wi wral wrex metcnp wceq
      wb simpl1 ad2antrr simpl3 xmetsym syl3anc breq1d simpllr ffvelrnd imbi12d
      simpr simpl2 ralbidva anassrs rexbidva pm5.32da bitrd ) DJUANOZEKUANOZFJO
      ZUBZGFHIUCPNOJKGUDZFCUEZDPZBUEZQRZFGNZVMGNZEPZAUEZQRZUFZCJUGZBSUHZASUGZTV
      LVMFDPZVOQRZVRVQEPZVTQRZUFZCJUGZBSUHZASUGZTABCDEFGHIJKLMUIVKVLWEWMVKVLTZW
      DWLASWNVTSOZTWCWKBSWNWOVOSOZWCWKUKWNWOWPTZTZWBWJCJWRVMJOZTZVPWGWAWIWTVNWF
      VOQWTVHVJWSVNWFUJWNVHWQWSVHVIVJVLULUMWNVJWQWSVHVIVJVLUNUMZWRWSVAZFVMDJUOU
      PUQWTVSWHVTQWTVIVQKOVRKOVSWHUJWNVIWQWSVHVIVJVLVBUMWTJKFGVKVLWQWSURZXAUSWT
      JKVMGXCXBUSVQVREKUOUPUQUTVCVDVEVCVFVG $.

    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous.  Theorem 10.1 of [Munkres] p. 127.  The second biconditional
       argument says that for every positive "epsilon" ` y ` there is a
       positive "delta" ` z ` such that a distance less than delta in ` C `
       maps to a distance less than epsilon in ` D ` .  (Contributed by NM,
       15-May-2007.)  (Revised by Mario Carneiro, 28-Aug-2015.) $)
    metcn $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) ) ->
                ( F e. ( J Cn K ) <-> ( F : X --> Y /\
                A. x e. X A. y e. RR+ E. z e. RR+
      A. w e. X ( ( x C w ) < z -> ( ( F ` x ) D ( F ` w ) ) < y ) ) ) ) $=
      ( cxmt cfv wcel wa co cv wral ccn wf ccnp clt wbr wi crp ctopon mopntopon
      wrex cncnp syl2an metcnp 3expa adantlr simplr biantrurd ralbidva pm5.32da
      wb bitr4d bitrd ) EJNOPZFKNOPZQZGHIUARPZJKGUBZGASZHIUCROPZAJTZQZVGVHDSZER
      CSUDUEVHGOVLGOFRBSUDUEUFDJTCUGUJBUGTZAJTZQVCHJUHOPIKUHOPVFVKUTVDEHJLUIFIK
      MUIAGHIJKUKULVEVGVJVNVEVGQZVIVMAJVOVHJPZQZVIVGVMQZVMVEVPVIVRUTZVGVCVDVPVS
      BCDEFVHGHIJKLMUMUNUOVQVGVMVEVGVPUPUQVAURUSVB $.

    $( Epsilon-delta property of a continuous metric space function, with
       function arguments as in ~ metcnp .  (Contributed by NM, 17-Dec-2007.)
       (Revised by Mario Carneiro, 13-Nov-2013.) $)
    metcnpi $p |- ( ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) ) /\
        ( F e. ( ( J CnP K ) ` P ) /\ A e. RR+ ) ) -> E. x e. RR+
      A. y e. X ( ( P C y ) < x -> ( ( F ` P ) D ( F ` y ) ) < A ) ) $=
      ( vz cfv wcel wa co crp clt cxmt ccnp cv wbr wi wral wrex wf simpr simpll
      wb simplr cuni eqid cnprcl adantl mopnuni ad2antrr eleqtrrd syl3anc mpbid
      wceq metcnp simprd breq2 imbi2d rexralbidv rspccv syl impr ) DJUAOPZEKUAO
      PZQZGFHIUBROPZCSPZFBUCZDRAUCTUDZFGOVPGOERZCTUDZUEZBJUFASUGZVMVNQZVQVRNUCZ
      TUDZUEZBJUFASUGZNSUFZVOWAUEWBJKGUHZWGWBVNWHWGQZVMVNUIWBVKVLFJPVNWIUKVKVLV
      NUJVKVLVNULWBFHUMZJVNFWJPVMFGHIWJWJUNUOUPVKJWJVBVLVNDHJLUQURUSNABDEFGHIJK
      LMVCUTVAVDWFWANCSWCCVBZWEVTABSJWKWDVSVQWCCVRTVEVFVGVHVIVJ $.

    $( TODO - delete this if not used $)
    $( Epsilon-delta property of a continuous metric space function, with
       swapped distance function arguments as in ~ metcnp2 .  (Contributed by
       NM, 16-Dec-2007.)  (Revised by Mario Carneiro, 13-Nov-2013.) $)
    metcnpi2 $p |- ( ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) )
        /\ ( F e. ( ( J CnP K ) ` P ) /\ A e. RR+ ) ) -> E. x e. RR+
      A. y e. X ( ( y C P ) < x -> ( ( F ` y ) D ( F ` P ) ) < A ) ) $=
      ( vz cfv wcel wa co crp clt cxmt ccnp cv wbr wi wral wrex wf simpr simpll
      wb simplr cuni eqid cnprcl wceq mopnuni ad2antrr eleqtrrd metcnp2 syl3anc
      adantl mpbid simprd breq2 imbi2d rexralbidv rspccv syl impr ) DJUAOPZEKUA
      OPZQZGFHIUBROPZCSPZBUCZFDRAUCTUDZVPGOFGOERZCTUDZUEZBJUFASUGZVMVNQZVQVRNUC
      ZTUDZUEZBJUFASUGZNSUFZVOWAUEWBJKGUHZWGWBVNWHWGQZVMVNUIWBVKVLFJPVNWIUKVKVL
      VNUJVKVLVNULWBFHUMZJVNFWJPVMFGHIWJWJUNUOVBVKJWJUPVLVNDHJLUQURUSNABDEFGHIJ
      KLMUTVAVCVDWFWANCSWCCUPZWEVTABSJWKWDVSVQWCCVRTVEVFVGVHVIVJ $.

    $( TODO - delete this if not used $)
    $( Epsilon-delta property of a metric space function continuous at ` P ` .
       A variation of ~ metcnpi2 with non-strict ordering.  (Contributed by NM,
       16-Dec-2007.)  (Revised by Mario Carneiro, 13-Nov-2013.) $)
    metcnpi3 $p |- ( ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) )
        /\ ( F e. ( ( J CnP K ) ` P ) /\ A e. RR+ ) ) -> E. x e. RR+
      A. y e. X ( ( y C P ) <_ x -> ( ( F ` y ) D ( F ` P ) ) <_ A ) ) $=
      ( cfv wcel wa crp wbr wi cxr vz cxmt ccnp co cv clt wral wrex metcnpi2 c2
      cle cdiv rphalfcl ad2antrl simplll simprr cuni simplrl cnprcl syl mopnuni
      eqid wceq eleqtrrd xmetcl syl3anc rpxrd rpxr rphalflt xrlelttr exp3acom23
      w3a imp syl31anc simpllr ctopon wf mopntopon cnpf2 simplrr xrltle syl2anc
      ffvelrnd imim12d anassrs ralimdva breq2 imbi1d ralbidv rspcev rexlimddv
      impr ) DJUBNOZEKUBNOZPZGFHIUCUDNOZCQOZPZPZBUEZFDUDZUAUEZUFRZWTGNZFGNZEUDZ
      CUFRZSZBJUGZXAAUEZUKRZXFCUKRZSZBJUGZAQUHZUAQUABCDEFGHIJKLMUIWSXBQOZXIPPXB
      UJULUDZQOZXAXQUKRZXLSZBJUGZXOXPXRWSXIXBUMZUNWSXPXIYAWSXPPXHXTBJWSXPWTJOZX
      HXTSWSXPYCPZPZXSXCXGXLYEXATOZXQTOZXBTOZXQXBUFRZXSXCSZYEWMYCFJOYFWMWNWRYDU
      OZWSXPYCUPZYEFHUQZJYEWPFYMOWOWPWQYDURZFGHIYMYMVBUSUTYEWMJYMVCYKDHJLVAUTVD
      ZWTFDJVEVFYEXQXPXRWSYCYBUNVGXPYHWSYCXBVHUNXPYIWSYCXBVIUNYFYGYHVLZYIYJYPXS
      YIXCXAXQXBVJVKVMVNYEXFTOZCTOXGXLSYEWNXDKOXEKOYQWMWNWRYDVOZYEJKWTGYEHJVPNO
      ZIKVPNOZWPJKGVQYEWMYSYKDHJLVRUTYEWNYTYREIKMVRUTYNFGHIJKVSVFZYLWCYEJKFGUUA
      YOWCXDXEEKVEVFYECWOWPWQYDVTVGXFCWAWBWDWEWFWLXNYAAXQQXJXQVCZXMXTBJUUBXKXSX
      LXJXQXAUKWGWHWIWJWBWK $.

    txmetcnp.4 $e |- L = ( MetOpen ` E ) $.
    $( Continuity of a binary operation on metric spaces.  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    txmetcnp $p |- ( ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) /\
      E e. ( *Met ` Z ) ) /\ ( A e. X /\ B e. Y ) ) ->
        ( F e. ( ( ( J tX K ) CnP L ) ` <. A , B >. ) <->
          ( F : ( X X. Y ) --> Z /\ A. z e. RR+ E. w e. RR+
      A. u e. X A. v e. Y ( ( ( A C u ) < w /\ ( B D v ) < w ) ->
        ( ( A F B ) E ( u F v ) ) < z ) ) ) ) $=
      ( wcel vx cxmt cfv w3a wa cop ctmt cxps co cds cmopn cxp wf cv clt wbr wi
      ccnp wral crp wrex ctx wb eqid simpl1 simpl2 tmsxps simpl3 opelxpi adantl
      metcnp syl3anc tmsxpsmopn oveq1d fveq1d eleq2d oveq2 breq1d df-ov syl6eqr
      oveq1i fveq2 oveq2d syl5eqr imbi12d ralxp cle cif ad2antrr simpllr simpld
      wceq simprd simprrl simprrr tmsxpsval2 xmetcl rpxr ad2antrl xrmaxlt bitrd
      cxr imbi1d anassrs 2ralbidva syl5bb rexbidva ralbidv pm5.32da 3bitr3d ) G
      NUBUCTZHOUBUCTZIPUBUCTZUDZENTZFOTZUEZUEZJEFUFZGUGUCHUGUCUHUIUJUCZUKUCZMUR
      UIZUCZTZNOULZPJUMZXSUAUNZXTUIZBUNZUOUPZXSJUCZYGJUCZIUIZAUNZUOUPZUQZUAYEUS
      ZBUTVAZAUTUSZUEZJXSKLVBUIZMURUIZUCZTYFEDUNZGUIZYIUOUPFCUNZHUIZYIUOUPUEZEF
      JUIZUUDUUFJUIZIUIZYNUOUPZUQZCOUSDNUSZBUTVAZAUTUSZUEXRXTYEUBUCTXMXSYETZYDY
      TVCXRXTGHNOXTVDZXKXLXMXQVEZXKXLXMXQVFZVGXKXLXMXQVHXQUUQXNEFNOVIVJABUAXTIX
      SJYAMYEPYAVDZSVKVLXRYCUUCJXRXSYBUUBXRYAUUAMURXRXTKLYAGHNOUURUUSUUTQRUVAVM
      VNVOVPXRYFYSUUPXRYFUEZYRUUOAUTUVBYQUUNBUTYQXSUUDUUFUFZXTUIZYIUOUPZUULUQZC
      OUSDNUSUVBYIUTTZUEZUUNYPUVFUADCNOYGUVCWLZYJUVEYOUULUVIYHUVDYIUOYGUVCXSXTV
      QVRUVIYMUUKYNUOUVIYMUUIYLIUIUUKUUIYKYLIEFJVSWAUVIYLUUJUUIIUVIYLUVCJUCUUJY
      GUVCJWBUUDUUFJVSVTWCWDVRWEWFUVHUVFUUMDCNOUVBUVGUUDNTZUUFOTZUEZUVFUUMVCUVB
      UVGUVLUEZUEZUVEUUHUULUVNUVEUUEUUGWGUPUUGUUEWHZYIUOUPZUUHUVNUVDUVOYIUOUVNE
      FUUDUUFXTGHNOUURXRXKYFUVMUUSWIZXRXLYFUVMUUTWIZUVNXOXPXNXQYFUVMWJZWKZUVNXO
      XPUVSWMZUVBUVGUVJUVKWNZUVBUVGUVJUVKWOZWPVRUVNUUEXBTZUUGXBTZYIXBTZUVPUUHVC
      UVNXKXOUVJUWDUVQUVTUWBEUUDGNWQVLUVNXLXPUVKUWEUVRUWAUWCFUUFHOWQVLUVGUWFUVB
      UVLYIWRWSUUEUUGYIWTVLXAXCXDXEXFXGXHXIXJ $.

    $( Continuity of a binary operation on metric spaces.  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    txmetcn $p |- ( ( C e. ( *Met ` X ) /\ D e. ( *Met ` Y ) /\
      E e. ( *Met ` Z ) ) -> ( F e. ( ( J tX K ) Cn L ) <->
        ( F : ( X X. Y ) --> Z /\ A. x e. X A. y e. Y A. z e. RR+ E. w e. RR+
      A. u e. X A. v e. Y ( ( ( x C u ) < w /\ ( y D v ) < w ) ->
        ( ( x F y ) E ( u F v ) ) < z ) ) ) ) $=
      ( wcel vt cxmt cfv w3a ctx co ccn cxp wf cv ccnp wral wa clt wbr crp wrex
      wi ctopon wb mopntopon txtopon syl2an 3adant3 3ad2ant3 cncnp syl2anc wceq
      cop fveq2 eleq2d ralxp txmetcnp adantlr simplr biantrurd bitr4d 2ralbidva
      syl5bb pm5.32da bitrd ) GNUBUCTZHOUBUCTZIPUBUCTZUDZJKLUEUFZMUGUFTZNOUHZPJ
      UIZJUAUJZWFMUKUFZUCZTZUAWHULZUMZWIAUJZFUJZGUFDUJZUNUOBUJZEUJZHUFWRUNUOUMW
      PWSJUFWQWTJUFIUFCUJUNUOUREOULFNULDUPUQCUPULZBOULANULZUMWEWFWHUSUCTZMPUSUC
      TZWGWOUTWBWCXCWDWBKNUSUCTLOUSUCTXCWCGKNQVAHLORVAKLNOVBVCVDWDWBXDWCIMPSVAV
      EUAJWFMWHPVFVGWEWIWNXBWNJWPWSVIZWKUCZTZBOULANULWEWIUMZXBWMXGUAABNOWJXEVHW
      LXFJWJXEWKVJVKVLXHXGXAABNOXHWPNTWSOTUMZUMZXGWIXAUMZXAWEXIXGXKUTWICDEFWPWS
      GHIJKLMNOPQRSVMVNXJWIXAWEWIXIVOVPVQVRVSVTWA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The uniform structure generated by a metric
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d d w x y z $.  $d a d x D $.  $d a d x X $.
    $( Value of the uniform structure generated by metric ` D ` .  (Contributed
       by Thierry Arnoux, 1-Dec-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metuvalOLD $p |- ( D e. ( *Met ` X ) -> ( metUnifOLD ` D ) = ( ( X X. X )
      filGen ran ( a e. RR+ |-> ( `' D " ( 0 [,) a ) ) ) ) ) $=
      ( vd vx vy vz vw cxmt wcel cv cdm cxp crp co cmpt crn cfg cvv wceq cfv wa
      ccnv cc0 cico cima cuni cmetuOLD df-metuOLD a1i simpr dmeqd adantr eqtr4d
      xmetdmdm xpeq12d simplr cnveqd imaeq1d mpteq2dva rneqd oveq12d wrex fveq2
      elfvdm eleq2d rspcev mpancom wfun cxad cle wbr wral cxr cmap crab df-xmet
      wb funmpt2 elunirn ax-mp sylibr ovex fvmptd ) ABIUAZJZDADKZLZLZWIMZCNWGUC
      ZUDCKZUEOZUFZPZQZROZBBMZCNAUCZWMUFZPZQZROZIQUGZUHSUHDXDWQPTWFCDUIUJWFWGAT
      ZUBZWJWRWPXBRXFWIBWIBXFWIALZLZBXFWHXGXFWGAWFXEUKULULWFBXHTXEABUOUMUNZXIUP
      XFWOXAXFCNWNWTXFWLNJZUBZWKWSWMXKWGAWFXEXJUQURUSUTVAVBWFAEKZIUAZJZEILZVCZA
      XDJZBXOJWFXPABIVEXNWFEBXOXLBTXMWEAXLBIVDVFVGVHIVIXQXPVRESFKZGKZWGOZUDTXRX
      STVRXTHKZXRWGOYAXSWGOVJOVKVLHXLVMUBGXLVMFXLVMDVNXLXLMVOOVPIEFGHDVQVSEAIVT
      WAWBXCSJWFWRXBRWCUJWD $.
  $}

  ${
    $d d u v w x y z $.  $d a d x D $.  $d a d x X $.
    $( Value of the uniform structure generated by metric ` D ` .  (Contributed
       by Thierry Arnoux, 1-Dec-2017.)  (Revised by Thierry Arnoux,
       11-Feb-2018.) $)
    metuval $p |- ( D e. ( PsMet ` X ) -> ( metUnif ` D ) = ( ( X X. X )
      filGen ran ( a e. RR+ |-> ( `' D " ( 0 [,) a ) ) ) ) ) $=
      ( vd vx vy vz vu vw vv cpsmet wcel cv cdm cxp crp co cmpt cfg wceq cfv wa
      ccnv cc0 cico cima crn cmetu cvv df-metu a1i simpr dmeqd psmetdmdm adantr
      eqtr4d xpeq12d simplr cnveqd imaeq1d mpteq2dva rneqd oveq12d elfvdm fveq2
      cuni wrex eleq2d rspcev mpancom wfun cxad cle wbr wral cmap crab df-psmet
      wb cxr funmpt2 elunirn ax-mp sylibr ovex fvmptd ) ABKUAZLZDADMZNZNZWKOZCP
      WIUCZUDCMZUEQZUFZRZUGZSQZBBOZCPAUCZWOUFZRZUGZSQZKUGVFZUHUIUHDXFWSRTWHCDUJ
      UKWHWIATZUBZWLWTWRXDSXHWKBWKBXHWKANZNZBXHWJXIXHWIAWHXGULUMUMWHBXJTXGABUNU
      OUPZXKUQXHWQXCXHCPWPXBXHWNPLZUBZWMXAWOXMWIAWHXGXLURUSUTVAVBVCWHAEMZKUAZLZ
      EKNZVGZAXFLZBXQLWHXRABKVDXPWHEBXQXNBTXOWGAXNBKVEVHVIVJKVKXSXRVSFUIGMZXTHM
      ZQUDTXTIMZYAQJMZXTYAQYCYBYAQVLQVMVNJFMZVOIYDVOUBGYDVOHVTYDYDOVPQVQKFGIJHV
      RWAEAKWBWCWDXEUILWHWTXDSWEUKWF $.
  $}

  ${
    $d a B $.  $d a D $.  $d a X $.
    metust.1 $e |- F = ran ( a e. RR+ |-> ( `' D " ( 0 [,) a ) ) ) $.
    $( Define a filter base ` F ` generated by a metric ` D ` .  (Contributed
       by Thierry Arnoux, 22-Nov-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metustelOLD $p |- ( D e. ( *Met ` X )
      -> ( B e. F <-> E. a e. RR+ B = ( `' D " ( 0 [,) a ) ) ) ) $=
      ( wcel crp ccnv cc0 cv cico co cima cmpt crn cxmt cvv wi a1i wceq wrex wb
      cfv eleq2i elex cnvexg imaexg eleq1a 3syl rexlimdvw eqid pm5.21ndd syl5bb
      elrnmpt ) ACGAEHBIZJEKLMZNZOZPZGZBDQUDZGZAURUAZEHUBZCUTAFUEVCARGZVAVEVAVF
      SVCAUTUFTVCVDVFEHVCUPRGURRGVDVFSBVBUGUPUQRUHURRAUIUJUKVFVAVEUCSVCEHURAUSR
      USULUOTUMUN $.

    $( Define a filter base ` F ` generated by a metric ` D ` .  (Contributed
       by Thierry Arnoux, 22-Nov-2017.)  (Revised by Thierry Arnoux,
       11-Feb-2018.) $)
    metustel $p |- ( D e. ( PsMet ` X )
      -> ( B e. F <-> E. a e. RR+ B = ( `' D " ( 0 [,) a ) ) ) ) $=
      ( wcel crp ccnv cc0 cv cico co cima cmpt crn cpsmet cvv wi a1i cfv eleq2i
      wceq wrex elex cnvexg imaexg eleq1a 3syl rexlimdvw eqid elrnmpt pm5.21ndd
      wb syl5bb ) ACGAEHBIZJEKLMZNZOZPZGZBDQUAZGZAURUCZEHUDZCUTAFUBVCARGZVAVEVA
      VFSVCAUTUETVCVDVFEHVCUPRGURRGVDVFSBVBUFUPUQRUGURRAUHUIUJVFVAVEUNSVCEHURAU
      SRUSUKULTUMUO $.

    $d a b A $.  $d a b B $.  $d a b D $.  $d a b F $.  $d a b X $.
    $( Range of the elements of the filter base generated by the metric
       ` D ` .  (Contributed by Thierry Arnoux, 28-Nov-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    metustssOLD $p |- ( ( D e. ( *Met ` X ) /\ A e. F ) -> A C_ ( X X. X ) ) $=
      ( cxmt cfv wcel wa cxp cpw crp ccnv cc0 wss cxr syl ad2antrr cvv cico crn
      cv co cima cmpt wral cdm cnvimass wf wceq xmetf syl5sseq wb cnvexg imaexg
      fdm elpwg 3syl mpbird ralrimiva eqid rnmptss syl5eqss simpr sseldd elpwid
      ) BDGHZIZACIZJZADDKZVKCVLLZAVKCEMBNZOEUCZUAUDZUEZUFZUBZVMFVKVQVMIZEMUGVSV
      MPVKVTEMVKVOMIZJVTVQVLPZVIWBVJWAVIBUHZVQVLBVPUIVIVLQBUJWCVLUKBDULVLQBUQRU
      MSVIVTWBUNZVJWAVIVNTIVQTIWDBVHUOVNVPTUPVQVLTURUSSUTVAEMVQVMVRVRVBVCRVDVIV
      JVEVFVG $.

    $( Range of the elements of the filter base generated by the metric
       ` D ` .  (Contributed by Thierry Arnoux, 28-Nov-2017.)  (Revised by
       Thierry Arnoux, 11-Feb-2018.) $)
    metustss $p |- ( ( D e. ( PsMet ` X ) /\ A e. F ) -> A C_ ( X X. X ) ) $=
      ( cpsmet cfv wcel wa cxp cpw crp ccnv cc0 wss cxr syl ad2antrr cvv cv crn
      cico co cima cmpt wral cdm cnvimass wf wceq psmetf fdm syl5sseq wb cnvexg
      imaexg elpwg 3syl mpbird ralrimiva rnmptss syl5eqss simpr sseldd elpwid
      eqid ) BDGHZIZACIZJZADDKZVKCVLLZAVKCEMBNZOEUAZUCUDZUEZUFZUBZVMFVKVQVMIZEM
      UGVSVMPVKVTEMVKVOMIZJVTVQVLPZVIWBVJWAVIBUHZVQVLBVPUIVIVLQBUJWCVLUKBDULVLQ
      BUMRUNSVIVTWBUOZVJWAVIVNTIVQTIWDBVHUPVNVPTUQVQVLTURUSSUTVAEMVQVMVRVRVGVBR
      VCVIVJVDVEVF $.

    $( Elements of the filter base generated by the metric ` D ` are
       relations.  (Contributed by Thierry Arnoux, 28-Nov-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    metustrelOLD $p |- ( ( D e. ( *Met ` X ) /\ A e. F ) -> Rel A ) $=
      ( cxmt cfv wcel wa cvv cxp wss wrel metustssOLD xpss syl6ss df-rel sylibr
      ) BDGHIACIJZAKKLZMANTADDLUAABCDEFODDPQARS $.

    $( Elements of the filter base generated by the metric ` D ` are
       relations.  (Contributed by Thierry Arnoux, 28-Nov-2017.)  (Revised by
       Thierry Arnoux, 11-Feb-2018.) $)
    metustrel $p |- ( ( D e. ( PsMet ` X ) /\ A e. F ) -> Rel A ) $=
      ( cpsmet cfv wcel wa cvv cxp wss wrel metustss xpss syl6ss df-rel sylibr
      ) BDGHIACIJZAKKLZMANTADDLUAABCDEFODDPQARS $.

    $( Any two elements of the filter base generated by the metric ` D ` can be
       compared, like for RR+ (i.e. it's totally ordered).  (Contributed by
       Thierry Arnoux, 22-Nov-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metusttoOLD $p |- ( ( D e. ( *Met ` X ) /\ A e. F /\ B e. F )
      -> ( A C_ B \/ B C_ A ) ) $=
      ( vb wcel cc0 cico wceq wa wss crp rpred cle wbr a1i wrex cxmt cfv w3a cv
      ccnv co cima wo simplr simpll simplll cxr simpl rexrd 0le0 simpr icossico
      cr 0xr syl22anc imass2 sylancom simplrr simplrl 3sstr4d olcd simpllr orcd
      syl lecasei adantlll metustelOLD biimpa 3adant3 crn oveq2 imaeq2d cbvmptv
      cmpt rneqi eqtri 3adant2 reeanv sylanbrc r19.29_2a ) CEUAUBIZADIZBDIZUCZA
      CUEZJFUDZKUFZUGZLZBWJJHUDZKUFZUGZLZMZABNZBANZUHZFHOOWKOIZWOOIZWSXBWIXCXDM
      ZWSMZXBWOWKXFWOXCXDWSUIPXFWKXCXDWSUJPXFWOWKQRZMZXAWTXHWQWMBAXFXGWKURIZWQW
      MNZXHWKXCXDWSXGUKPXIXGMZWPWLNZXJXKJULIZWKULIJJQRZXGXLXMXKUSSXKWKXIXGUMUNX
      NXKUOSXIXGUPJWKJWOUQUTWPWLWJVAVIVBXEWNWRXGVCXEWNWRXGVDVEVFXFWKWOQRZMZWTXA
      XPWMWQABXFXOWOURIZWMWQNZXPWOXCXDWSXOVGPXQXOMZWLWPNZXRXSXMWOULIXNXOXTXMXSU
      SSXSWOXQXOUMUNXNXSUOSXQXOUPJWOJWKUQUTWLWPWJVAVIVBXEWNWRXOVDXEWNWRXOVCVEVH
      VJVKWIWNFOTZWRHOTZWSHOTFOTWFWGYAWHWFWGYAACDEFGVLVMVNWFWHYBWGWFWHYBBCDEHDF
      OWMVSZVOHOWQVSZVOGYCYDFHOWMWQWKWOLWLWPWJWKWOJKVPVQVRVTWAVLVMWBWNWRFHOOWCW
      DWE $.

    $( Any two elements of the filter base generated by the metric ` D ` can be
       compared, like for RR+ (i.e. it's totally ordered).  (Contributed by
       Thierry Arnoux, 22-Nov-2017.)  (Revised by Thierry Arnoux,
       11-Feb-2018.) $)
    metustto $p |- ( ( D e. ( PsMet ` X ) /\ A e. F /\ B e. F )
      -> ( A C_ B \/ B C_ A ) ) $=
      ( vb wcel cc0 cico wceq wa wss crp rpred cle wbr a1i wrex cpsmet cfv ccnv
      w3a cv co cima wo simpll simplr cr simpllr cxr 0xr simpl rexrd 0le0 simpr
      icossico syl22anc imass2 sylancom simplrl simplrr 3sstr4d simplll lecasei
      syl orcd olcd adantlll metustel biimpa 3adant3 cmpt oveq2 imaeq2d cbvmptv
      crn rneqi eqtri 3adant2 reeanv sylanbrc r19.29_2a ) CEUAUBIZADIZBDIZUDZAC
      UCZJFUEZKUFZUGZLZBWJJHUEZKUFZUGZLZMZABNZBANZUHZFHOOWKOIZWOOIZWSXBWIXCXDMZ
      WSMZXBWKWOXFWKXCXDWSUIPXFWOXCXDWSUJPXFWKWOQRZMZWTXAXHWMWQABXFXGWOUKIZWMWQ
      NZXHWOXCXDWSXGULPXIXGMZWLWPNZXJXKJUMIZWOUMIJJQRZXGXLXMXKUNSXKWOXIXGUOUPXN
      XKUQSXIXGURJWOJWKUSUTWLWPWJVAVHVBXEWNWRXGVCXEWNWRXGVDVEVIXFWOWKQRZMZXAWTX
      PWQWMBAXFXOWKUKIZWQWMNZXPWKXCXDWSXOVFPXQXOMZWPWLNZXRXSXMWKUMIXNXOXTXMXSUN
      SXSWKXQXOUOUPXNXSUQSXQXOURJWKJWOUSUTWPWLWJVAVHVBXEWNWRXOVDXEWNWRXOVCVEVJV
      GVKWIWNFOTZWRHOTZWSHOTFOTWFWGYAWHWFWGYAACDEFGVLVMVNWFWHYBWGWFWHYBBCDEHDFO
      WMVOZVSHOWQVOZVSGYCYDFHOWMWQWKWOLWLWPWJWKWOJKVPVQVRVTWAVLVMWBWNWRFHOOWCWD
      WE $.

    $d a b p q A $.  $d a p q x D $.  $d b p q x y z F $.  $d p q x y z X $.
    $( The identity diagonal is included in all elements of the filter base
       generated by the metric ` D ` .  (Contributed by Thierry Arnoux,
       22-Nov-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metustidOLD $p |- ( ( D e. ( *Met ` X ) /\ A e. F ) -> ( _I |` X ) C_ A )
      $=
      ( vp vq cfv wcel wa cid cv cc0 wceq crp wbr syl syl2anc cxr cxmt cres a1i
      wrel relres cop ccnv cico cima vex brres df-br ideq anbi1i 3bitr3i biimpi
      ad2antlr simpld df-ov opeq2 fveq2d syl5eq simplll simprd xmet0 eqtr3d clt
      co 0xr rpxr rpgt0 lbico1 syl3anc adantl eqeltrd wfun cdm wb wf xmetf ffun
      cxp ad3antrrr eqeltrrd opelxpi eleqtrrd fvimacnv mpbid adantr wrex simplr
      fdm simpr metustelOLD ad2antrr r19.29a ex relssdv ) BDUAIJZACJZKZGHLDUBZA
      XBUDXALDUEUCXAGMZHMZUFZXBJZXEAJZXAXFKZABUGNEMZUHVHZUIZOZXGEPXHXIPJZKZXLKX
      EXKAXNXEXKJZXLXNXEBIZXJJZXOXNXPNXJXNXCXCBVHZXPNXNXCXDOZXRXPOXNXSXCDJZXFXS
      XTKZXAXMXFYAXCXDXBQXCXDLQZXTKXFYAXCXDLDHUJZUKXCXDXBULYBXSXTXCXDYCUMUNUOUP
      UQZURZXSXRXCXCUFZBIXPXCXCBUSXSYFXEBXCXDXCUTVAVBRXNWSXTXRNOWSWTXFXMVCXNXSX
      TYDVDZXCBDVESVFXMNXJJZXHXMNTJZXITJNXIVGQYHYIXMVIUCXIVJXIVKNXIVLVMVNVOXNBV
      PZXEBVQZJXQXOVRWSYJWTXFXMWSDDWBZTBVSZYJBDVTZYLTBWARWCXNXEYLYKXNXTXDDJXEYL
      JYGXNXCXDDYEYGWDXCXDDDWESWSYKYLOZWTXFXMWSYMYOYNYLTBWLRWCWFXEXJBWGSWHWIXNX
      LWMWFXHWTXLEPWJZWSWTXFWKWSWTYPVRWTXFABCDEFWNWOWHWPWQWR $.

    $( The identity diagonal is included in all elements of the filter base
       generated by the metric ` D ` .  (Contributed by Thierry Arnoux,
       22-Nov-2017.)  (Revised by Thierry Arnoux, 11-Feb-2018.) $)
    metustid $p |- ( ( D e. ( PsMet ` X ) /\ A e. F ) -> ( _I |` X ) C_ A ) $=
      ( vp vq cfv wcel wa cid cv cc0 wceq crp wbr syl syl2anc cxr cpsmet relres
      cres wrel a1i cop ccnv cico co cima vex brres df-br anbi1i 3bitr3i biimpi
      ideq ad2antlr simpld df-ov fveq2d syl5eq simplll simprd psmet0 eqtr3d clt
      opeq2 0xr rpxr rpgt0 lbico1 syl3anc adantl eqeltrd wfun cdm wb cxp psmetf
      wf ffun ad3antrrr eqeltrrd opelxpi fdm eleqtrrd fvimacnv mpbid simpr wrex
      adantr simplr metustel ad2antrr r19.29a ex relssdv ) BDUAIJZACJZKZGHLDUCZ
      AXBUDXALDUBUEXAGMZHMZUFZXBJZXEAJZXAXFKZABUGNEMZUHUIZUJZOZXGEPXHXIPJZKZXLK
      XEXKAXNXEXKJZXLXNXEBIZXJJZXOXNXPNXJXNXCXCBUIZXPNXNXCXDOZXRXPOXNXSXCDJZXFX
      SXTKZXAXMXFYAXCXDXBQXCXDLQZXTKXFYAXCXDLDHUKZULXCXDXBUMYBXSXTXCXDYCUQUNUOU
      PURZUSZXSXRXCXCUFZBIXPXCXCBUTXSYFXEBXCXDXCVHVAVBRXNWSXTXRNOWSWTXFXMVCXNXS
      XTYDVDZXCBDVESVFXMNXJJZXHXMNTJZXITJNXIVGQYHYIXMVIUEXIVJXIVKNXIVLVMVNVOXNB
      VPZXEBVQZJXQXOVRWSYJWTXFXMWSDDVSZTBWAZYJBDVTZYLTBWBRWCXNXEYLYKXNXTXDDJXEY
      LJYGXNXCXDDYEYGWDXCXDDDWESWSYKYLOZWTXFXMWSYMYOYNYLTBWFRWCWGXEXJBWHSWIWLXN
      XLWJWGXHWTXLEPWKZWSWTXFWMWSWTYPVRWTXFABCDEFWNWOWIWPWQWR $.

    $( Elements of the filter base generated by the metric ` D ` are
       symmetric.  (Contributed by Thierry Arnoux, 28-Nov-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    metustsymOLD $p |- ( ( D e. ( *Met ` X ) /\ A e. F ) -> `' A = A ) $=
      ( vp vq cfv wcel wa ccnv wss syl cv wb co wceq crp cxr cxp cnvss syl6sseq
      cxmt metustssOLD cnvxp wbr cop cico cima simp-4l simpr1r 3anassrs simpr1l
      cc0 xmetsym syl3anc df-ov 3eqtr3g eleq1d wfun cdm xmetf ffun 3syl simpllr
      ancomd opelxpi fdm eleqtrrd fvimacnv syl2anc 3bitr3d simpr eleq2d 3bitr4d
      wf wrex cmpt crn eqid elrnmpt ibi eleq2s ad2antlr r19.29a df-br vex bitri
      opelcnv 3bitr4g 3impb eqbrrdva ) BDUDIJZACJZKZGHALZADDWPADDUAZMZWQWRMABCD
      EFUEZWSWQWRLWRAWRUBDDUFUCNWTWPGOZDJZHOZDJZXAXCWQUGZXAXCAUGZPWPXBXDKZKZXCX
      AUHZAJZXAXCUHZAJZXEXFXHABLUOEOZUIQZUJZRZXJXLPESXHXMSJZKZXPKZXIXOJZXKXOJZX
      JXLXSXIBIZXNJZXKBIZXNJZXTYAXSYBYDXNXSXCXABQZXAXCBQZYBYDXSWNXDXBYFYGRWNWOX
      GXQXPUKZWPXGXQXPXDXBXDXQXPWPULUMWPXGXQXPXBXBXDXQXPWPUNUMXCXABDUPUQXCXABUR
      XAXCBURUSUTXSBVAZXIBVBZJYCXTPXSWNWRTBVQZYIYHBDVCZWRTBVDVEZXSXIWRYJXSXDXBK
      XIWRJXSXBXDWPXGXQXPVFZVGXCXADDVHNXSWNYKYJWRRYHYLWRTBVIVEZVJXIXNBVKVLXSYIX
      KYJJYEYAPYMXSXKWRYJXSXGXKWRJYNXAXCDDVHNYOVJXKXNBVKVLVMXSAXOXIXRXPVNZVOXSA
      XOXKYPVOVPWOXPESVRZWNXGYQAESXOVSZVTZCAYSJYQESXOAYRYSYRWAWBWCFWDWEWFXEXKWQ
      JXJXAXCWQWGXAXCAGWHHWHWJWIXAXCAWGWKWLWM $.

    $( Elements of the filter base generated by the metric ` D ` are
       symmetric.  (Contributed by Thierry Arnoux, 28-Nov-2017.)  (Revised by
       Thierry Arnoux, 11-Feb-2018.) $)
    metustsym $p |- ( ( D e. ( PsMet ` X ) /\ A e. F ) -> `' A = A ) $=
      ( vp vq cfv wcel wa ccnv wss syl cv wb co wceq crp cxr cxp metustss cnvss
      cpsmet cnvxp syl6sseq wbr cop cico cima simp-4l simpr1r 3anassrs psmetsym
      cc0 simpr1l syl3anc df-ov 3eqtr3g eleq1d wfun wf psmetf ffun 3syl simpllr
      cdm ancomd opelxpi eleqtrrd fvimacnv syl2anc 3bitr3d simpr eleq2d 3bitr4d
      fdm wrex simplr cmpt crn eqid elrnmpt ibi r19.29a df-br vex opelcnv bitri
      eleq2s 3bitr4g ex 3impib eqbrrdva ) BDUDIJZACJZKZGHALZADDWQADDUAZMZWRWSMA
      BCDEFUBZWTWRWSLWSAWSUCDDUEUFNXAWQGOZDJZHOZDJZXBXDWRUGZXBXDAUGZPZWQXCXEKZX
      HWQXIKZXDXBUHZAJZXBXDUHZAJZXFXGXJABLUOEOZUIQZUJZRZXLXNPESXJXOSJZKZXRKZXKX
      QJZXMXQJZXLXNYAXKBIZXPJZXMBIZXPJZYBYCYAYDYFXPYAXDXBBQZXBXDBQZYDYFYAWOXEXC
      YHYIRWOWPXIXSXRUKZWQXIXSXRXEXCXEXSXRWQULUMWQXIXSXRXCXCXEXSXRWQUPUMXDXBBDU
      NUQXDXBBURXBXDBURUSUTYABVAZXKBVGZJYEYBPYAWOWSTBVBZYKYJBDVCZWSTBVDVEZYAXKW
      SYLYAXEXCKXKWSJYAXCXEWQXIXSXRVFZVHXDXBDDVINYAWOYLWSRZYJWOYMYQYNWSTBVQNNZV
      JXKXPBVKVLYAYKXMYLJYGYCPYOYAXMWSYLYAXIXMWSJYPXBXDDDVINYRVJXMXPBVKVLVMYAAX
      QXKXTXRVNZVOYAAXQXMYSVOVPXJWPXRESVRZWOWPXIVSYTAESXQVTZWAZCAUUBJYTESXQAUUA
      UUBUUAWBWCWDFWJNWEXFXMWRJXLXBXDWRWFXBXDAGWGHWGWHWIXBXDAWFWKWLWMWN $.

    $d a p q r v A $.  $d a r u v w D $.  $d r u v w F $.  $d r u v w X $.
    $( For any element ` A ` of the filter base generated by the metric ` D ` ,
       the half element (corresponding to half the distance) is also in this
       base.  (Contributed by Thierry Arnoux, 28-Nov-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    metustexhalfOLD $p |- ( ( ( X =/= (/) /\ D e. ( *Met ` X ) ) /\ A e. F )
      -> E. v e. F ( v o. v ) C_ A ) $=
      ( vb vr wcel wa cc0 co wceq wss crp cxr syl wbr syl21anc vp vq c0 wne cfv
      cxmt ccnv cv cico cima ccom wrex c2 cdiv simp-4r simplr rphalfcld imaeq2d
      eqidd oveq2 eqeq2d rspcev syl2anc cbvmptv rneqi eqtri metustelOLD biimpar
      cmpt crn wrel relco a1i cop cxp cdm cossxp cnvimass wf xmetf fdm syl5sseq
      dmss rnss xpss12 adantl dmxp rnxp xpeq12d adantr sseqtrd syl5ss ad3antrrr
      sselda opelxp sylib simpll simprl simprr w3a simplll simp1d simp2d simp3d
      jca 3jca wfun simpld ffun sylanbrc eleqtrrd cle clt simprd rpxrd ffvelrnd
      0xr xmetge0 syl3anc df-ov syl6breq cxad syl5eqel caddc cr rpred rehalfcld
      0re rexrd df-br fvimacnv elico2 biimpa rexadd readdcld sylibr wex r19.29a
      vex ex eqeltrd xmettri syl13anc lt2halvesd eqbrtrd xrlelttrd elico1 breqd
      syl5eqbrr syl23anc syl22anc mpbird simpr brco brelrn sseldd adantrr ancrd
      wi eximdv 3ad2ant1 mpd df-rex syl31anc mpdan relssdv id coeq12d sseq1d wb
      ) EUCUDZCEUFUEJZKZBDJZKZBCUGZLFUHZUIMZUJZNZAUHZUWAUKZBOZADULZFPUVOUVQPJZK
      ZUVTKZUVPLUVQUMUNMZUIMZUJZDJZUWJUWJUKZBOZUWDUWGUVLUWJUVPLHUHZUIMZUJZNZHPU
      LZUWKUVKUVLUVNUWEUVTUOZUWGUWHPJUWJUWJNZUWRUWGUVQUVOUWEUVTUPZUQUWGUWJUSUWQ
      UWTHUWHPUWNUWHNZUWPUWJUWJUXBUWOUWIUVPUWNUWHLUIUTURVAVBVCUVLUWKUWRUWJCDEHD
      FPUVSVIZVJHPUWPVIZVJGUXCUXDFHPUVSUWPUVQUWNNUVRUWOUVPUVQUWNLUIUTURVDVEVFVG
      VHVCUWGUAUBUWLBUWLVKUWGUWJUWJVLVMUWGUAUHZUBUHZVNZUWLJZUXGBJZUWGUXHKZUXEEJ
      ZUXFEJZKZUXIUXJUXGEEVOZJZUXMUWGUWLUXNUXGUVMUWLUXNOUVNUWEUVTUVMUWLUWJVPZUW
      JVJZVOZUXNUWJUWJVQUVMUXRUXNVPZUXNVJZVOZUXNUVLUXRUYAOZUVKUVLUWJUXNOZUYBUVL
      CVPZUWJUXNCUWIVRUVLUXNQCVSZUYDUXNNZCEVTZUXNQCWARZWBZUYCUXPUXSOUXQUXTOZUYB
      UWJUXNWCUWJUXNWDZUXPUXSUXQUXTWEVCRWFUVKUYAUXNNUVLUVKUXSEUXTEEEWGEEWHZWIWJ
      WKWLWMWNUXEUXFEEWOZWPUXJUXMKUWGUXKUXLUXHUXIUWGUXHUXMWQUXJUXKUXLWRUXJUXKUX
      LWSUWGUXHUXMUPUWGUXKUXLWTZUXHKZUXEUXFBSZUXIUYOUXEIUHZUWJSZUYQUXFUWJSZKZUY
      PIEUYOUYQEJZKZUYTKZUYPUXEUXFUVSSZVUCUVLUWEKZUXKUXLWTZVUAUYRUYSVUDVUCVUEUX
      KUXLVUCUVLUWEVUCUWGUVLVUCUWGUXKUXLUYNUXHVUAUYTXAZXBZUWSRVUCUWGUWEVUHUXARX
      EVUCUWGUXKUXLVUGXCVUCUWGUXKUXLVUGXDXFUYOVUAUYTUPVUBUYRUYSWRVUBUYRUYSWSVUF
      VUAKZUYTKZCXGZUXGUYDJZUXGCUEZUVRJZVUDVUJUVLVUKVUJUVLUWEVUJVUEUXKUXLVUFVUA
      UYTWQZXBZXHZUVLUYEVUKUYGUXNQCXIRRZVUJUXGUXNUYDVUJUXKUXLUXOVUJVUEUXKUXLVUO
      XCZVUJVUEUXKUXLVUOXDZUYMXJZVUJUVLUYFVUQUYHRZXKVUJLQJZUVQQJZVUMQJZLVUMXLSZ
      VUMUVQXMSZVUNVVCVUJXQVMVUJUVQVUJUVLUWEVUPXNZXOZVUJUXNQUXGCVUJUVLUYEVUQUYG
      RVVAXPZVUJLUXEUXFCMZVUMXLVUJUVLUXKUXLLVVKXLSVUQVUSVUTUXEUXFCEXRXSUXEUXFCX
      TZYAVUJVUMVVKUVQXMVVLVUJVVKUXEUYQCMZUYQUXFCMZYBMZUVQVUJVVKVUMQVVLVVJYCVUJ
      VVOVUJVVOVVMVVNYDMZYEVUJVVMYEJZVVNYEJZVVOVVPNVUJLYEJZUWHQJZVVMUWIJZVVQVVS
      VUJYHVMZVUJUWHVUJUVQVUJUVQVVHYFZYGYIZVUJVVMUXEUYQVNZCUEZUWIUXEUYQCXTVUJVU
      KVWEUYDJZVWEUWJJZVWFUWIJZVURVUJVWEUXNUYDVUJUXKVUAVWEUXNJVUSVUFVUAUYTUPZUX
      EUYQEEWOXJVVBXKVUJUYRVWHVUIUYRUYSWRUXEUYQUWJYJWPVUKVWGKVWIVWHVWEUWICYKVHT
      YCZVVSVVTKZVWAKZVVQLVVMXLSZVVMUWHXMSZVWLVWAVVQVWNVWOWTLUWHVVMYLYMZXBTZVUJ
      VVSVVTVVNUWIJZVVRVWBVWDVUJVVNUYQUXFVNZCUEZUWIUYQUXFCXTVUJVUKVWSUYDJZVWSUW
      JJZVWTUWIJZVURVUJVWSUXNUYDVUJVUAUXLVWSUXNJVWJVUTUYQUXFEEWOXJVVBXKVUJUYSVX
      BVUIUYRUYSWSUYQUXFUWJYJWPVUKVXAKVXCVXBVWSUWICYKVHTYCZVWLVWRKZVVRLVVNXLSZV
      VNUWHXMSZVWLVWRVVRVXFVXGWTLUWHVVNYLYMZXBTZVVMVVNYNVCZVUJVVMVVNVWQVXIYOUUA
      YIVVIVUJUVLUXKUXLVUAVVKVVOXLSVUQVUSVUTVWJUXEUXFUYQCEUUBUUCVUJVVOVVPUVQXMV
      XJVUJVVMVVNUVQVWQVXIVWCVUJVVSVVTVWAVWOVWBVWDVWKVWMVVQVWNVWOVWPXDTVUJVVSVV
      TVWRVXGVWBVWDVXDVXEVVRVXFVXGVXHXDTUUDUUEUUFUUIVVCVVDKVUNVVEVVFVVGWTLUVQVU
      MUUGVHUUJVUKVULKZVUNKUXGUVSJZVUDVXKVUNVXLUXGUVRCYKYMUXEUXFUVSYJYPTUUKVUCB
      UVSUXEUXFVUCUWFUVTVUHXNUUHUULUYOVUAUYTKZIYQZUYTIEULUYOUYTIYQZVXNUYOUXEUXF
      UWLSZVXOUYOUXHVXPUYNUXHUUMUXEUXFUWLYJYPIUXEUXFUWJUWJUAYSZUBYSUUNWPUYNVXOV
      XNUUSZUXHUWGUXKVXRUXLUVMVXRUVNUWEUVTUVMUYTVXMIUVMUYTVUAUVMUYTVUAUVMUYRVUA
      UYSUVMUYRKUXQEUYQUVMUXQEOUYRUVMUXQUXTEUVMUYCUYJUVLUYCUVKUYIWFUYKRUVKUXTEN
      UVLUYLWJWKWJUYRUYQUXQJUVMUXEUYQUWJVXQIYSUUOWFUUPUUQYTUURUUTWMUVAWJUVBUYTI
      EUVCYPYRUXEUXFBYJWPUVDUVEYTUVFUWCUWMAUWJDUWAUWJNZUWBUWLBVXSUWAUWJUWAUWJVX
      SUVGZVXTUVHUVIVBVCUVMUVNUVTFPULZUVLUVNVYAUVJUVKBCDEFGVGWFYMYR $.

    $( For any element ` A ` of the filter base generated by the metric ` D ` ,
       the half element (corresponding to half the distance) is also in this
       base.  (Contributed by Thierry Arnoux, 28-Nov-2017.)  (Revised by
       Thierry Arnoux, 11-Feb-2018.) $)
    metustexhalf $p |- ( ( ( X =/= (/) /\ D e. ( PsMet ` X ) ) /\ A e. F )
      -> E. v e. F ( v o. v ) C_ A ) $=
      ( vb vr wcel wa cc0 co wceq wss crp cxr syl wbr syl21anc vp vq wne cpsmet
      c0 cfv ccnv cv cico cima ccom wrex c2 cdiv simp-4r simplr rphalfcld eqidd
      oveq2 imaeq2d eqeq2d rspcev syl2anc cmpt crn cbvmptv rneqi eqtri metustel
      biimpar wrel relco a1i cop cxp cdm cossxp cnvimass wf psmetf fdm syl5sseq
      dmss rnss xpss12 adantl dmxp rnxp xpeq12d adantr sseqtrd syl5ss ad3antrrr
      sselda opelxp sylib simpll simprl simprr w3a simplll simp1d simp2d simp3d
      jca 3jca wfun simpld ffun sylanbrc eleqtrrd cle clt simprd rpxrd ffvelrnd
      0xr psmetge0 syl3anc df-ov syl6breq syl5eqel caddc cr 0re rpred rehalfcld
      cxad rexrd df-br fvimacnv elico2 biimpa rexadd readdcld sylibr wex vex ex
      r19.29a eqeltrd psmettri syl13anc lt2halvesd xrlelttrd syl5eqbrr syl23anc
      eqbrtrd elico1 syl22anc breqd mpbird simpr wi brelrn sseldd adantrr ancrd
      brco eximdv 3ad2ant1 mpd df-rex syl31anc mpdan relssdv id coeq12d sseq1d
      wb ) EUEUCZCEUDUFJZKZBDJZKZBCUGZLFUHZUIMZUJZNZAUHZUWAUKZBOZADULZFPUVOUVQP
      JZKZUVTKZUVPLUVQUMUNMZUIMZUJZDJZUWJUWJUKZBOZUWDUWGUVLUWJUVPLHUHZUIMZUJZNZ
      HPULZUWKUVKUVLUVNUWEUVTUOZUWGUWHPJUWJUWJNZUWRUWGUVQUVOUWEUVTUPZUQUWGUWJUR
      UWQUWTHUWHPUWNUWHNZUWPUWJUWJUXBUWOUWIUVPUWNUWHLUIUSUTVAVBVCUVLUWKUWRUWJCD
      EHDFPUVSVDZVEHPUWPVDZVEGUXCUXDFHPUVSUWPUVQUWNNUVRUWOUVPUVQUWNLUIUSUTVFVGV
      HVIVJVCUWGUAUBUWLBUWLVKUWGUWJUWJVLVMUWGUAUHZUBUHZVNZUWLJZUXGBJZUWGUXHKZUX
      EEJZUXFEJZKZUXIUXJUXGEEVOZJZUXMUWGUWLUXNUXGUVMUWLUXNOUVNUWEUVTUVMUWLUWJVP
      ZUWJVEZVOZUXNUWJUWJVQUVMUXRUXNVPZUXNVEZVOZUXNUVLUXRUYAOZUVKUVLUWJUXNOZUYB
      UVLCVPZUWJUXNCUWIVRUVLUXNQCVSZUYDUXNNZCEVTZUXNQCWARZWBZUYCUXPUXSOUXQUXTOZ
      UYBUWJUXNWCUWJUXNWDZUXPUXSUXQUXTWEVCRWFUVKUYAUXNNUVLUVKUXSEUXTEEEWGEEWHZW
      IWJWKWLWMWNUXEUXFEEWOZWPUXJUXMKUWGUXKUXLUXHUXIUWGUXHUXMWQUXJUXKUXLWRUXJUX
      KUXLWSUWGUXHUXMUPUWGUXKUXLWTZUXHKZUXEUXFBSZUXIUYOUXEIUHZUWJSZUYQUXFUWJSZK
      ZUYPIEUYOUYQEJZKZUYTKZUYPUXEUXFUVSSZVUCUVLUWEKZUXKUXLWTZVUAUYRUYSVUDVUCVU
      EUXKUXLVUCUVLUWEVUCUWGUVLVUCUWGUXKUXLUYNUXHVUAUYTXAZXBZUWSRVUCUWGUWEVUHUX
      ARXEVUCUWGUXKUXLVUGXCVUCUWGUXKUXLVUGXDXFUYOVUAUYTUPVUBUYRUYSWRVUBUYRUYSWS
      VUFVUAKZUYTKZCXGZUXGUYDJZUXGCUFZUVRJZVUDVUJUVLVUKVUJUVLUWEVUJVUEUXKUXLVUF
      VUAUYTWQZXBZXHZUVLUYEVUKUYGUXNQCXIRRZVUJUXGUXNUYDVUJUXKUXLUXOVUJVUEUXKUXL
      VUOXCZVUJVUEUXKUXLVUOXDZUYMXJZVUJUVLUYFVUQUYHRZXKVUJLQJZUVQQJZVUMQJZLVUMX
      LSZVUMUVQXMSZVUNVVCVUJXQVMVUJUVQVUJUVLUWEVUPXNZXOZVUJUXNQUXGCVUJUVLUYEVUQ
      UYGRVVAXPZVUJLUXEUXFCMZVUMXLVUJUVLUXKUXLLVVKXLSVUQVUSVUTUXEUXFCEXRXSUXEUX
      FCXTZYAVUJVUMVVKUVQXMVVLVUJVVKUXEUYQCMZUYQUXFCMZYHMZUVQVUJVVKVUMQVVLVVJYB
      VUJVVOVUJVVOVVMVVNYCMZYDVUJVVMYDJZVVNYDJZVVOVVPNVUJLYDJZUWHQJZVVMUWIJZVVQ
      VVSVUJYEVMZVUJUWHVUJUVQVUJUVQVVHYFZYGYIZVUJVVMUXEUYQVNZCUFZUWIUXEUYQCXTVU
      JVUKVWEUYDJZVWEUWJJZVWFUWIJZVURVUJVWEUXNUYDVUJUXKVUAVWEUXNJVUSVUFVUAUYTUP
      ZUXEUYQEEWOXJVVBXKVUJUYRVWHVUIUYRUYSWRUXEUYQUWJYJWPVUKVWGKVWIVWHVWEUWICYK
      VJTYBZVVSVVTKZVWAKZVVQLVVMXLSZVVMUWHXMSZVWLVWAVVQVWNVWOWTLUWHVVMYLYMZXBTZ
      VUJVVSVVTVVNUWIJZVVRVWBVWDVUJVVNUYQUXFVNZCUFZUWIUYQUXFCXTVUJVUKVWSUYDJZVW
      SUWJJZVWTUWIJZVURVUJVWSUXNUYDVUJVUAUXLVWSUXNJVWJVUTUYQUXFEEWOXJVVBXKVUJUY
      SVXBVUIUYRUYSWSUYQUXFUWJYJWPVUKVXAKVXCVXBVWSUWICYKVJTYBZVWLVWRKZVVRLVVNXL
      SZVVNUWHXMSZVWLVWRVVRVXFVXGWTLUWHVVNYLYMZXBTZVVMVVNYNVCZVUJVVMVVNVWQVXIYO
      UUAYIVVIVUJUVLUXKUXLVUAVVKVVOXLSVUQVUSVUTVWJUXEUXFUYQCEUUBUUCVUJVVOVVPUVQ
      XMVXJVUJVVMVVNUVQVWQVXIVWCVUJVVSVVTVWAVWOVWBVWDVWKVWMVVQVWNVWOVWPXDTVUJVV
      SVVTVWRVXGVWBVWDVXDVXEVVRVXFVXGVXHXDTUUDUUHUUEUUFVVCVVDKVUNVVEVVFVVGWTLUV
      QVUMUUIVJUUGVUKVULKZVUNKUXGUVSJZVUDVXKVUNVXLUXGUVRCYKYMUXEUXFUVSYJYPTUUJV
      UCBUVSUXEUXFVUCUWFUVTVUHXNUUKUULUYOVUAUYTKZIYQZUYTIEULUYOUYTIYQZVXNUYOUXE
      UXFUWLSZVXOUYOUXHVXPUYNUXHUUMUXEUXFUWLYJYPIUXEUXFUWJUWJUAYRZUBYRUUSWPUYNV
      XOVXNUUNZUXHUWGUXKVXRUXLUVMVXRUVNUWEUVTUVMUYTVXMIUVMUYTVUAUVMUYTVUAUVMUYR
      VUAUYSUVMUYRKUXQEUYQUVMUXQEOUYRUVMUXQUXTEUVMUYCUYJUVLUYCUVKUYIWFUYKRUVKUX
      TENUVLUYLWJWKWJUYRUYQUXQJUVMUXEUYQUWJVXQIYRUUOWFUUPUUQYSUURUUTWMUVAWJUVBU
      YTIEUVCYPYTUXEUXFBYJWPUVDUVEYSUVFUWCUWMAUWJDUWAUWJNZUWBUWLBVXSUWAUWJUWAUW
      JVXSUVGZVXTUVHUVIVBVCUVMUVNUVTFPULZUVLUVNVYAUVJUVKBCDEFGVIWFYMYT $.

    $d a y D $.
    $( The filter base generated by a metric ` D ` .  (Contributed by Thierry
       Arnoux, 26-Nov-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metustfbasOLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) )
      -> F e. ( fBas ` ( X X. X ) ) ) $=
      ( vz vx vy vp c0 wne wcel wa wss cv wceq syl adantl c1 cvv cxmt cfv cfbas
      cxp cpw wnel cin wrex wral w3a ccnv cc0 cico co crp metustelOLD simpr cdm
      cima cnvimass cxr wf xmetf fdm adantr syl5sseq eqsstrd rexlimdvw ralrimiv
      ex sylbid pwssb sylibr wex cnvexg imaexg elisset 1rp oveq2 imaeq2d eqeq2d
      3syl rspcev mpan eximi exbidv mpbird n0 wn cid metustidOLD adantll biimpi
      cres opelresi ibir ne0i exlimiv ssn0 syl2anc nelrdva df-nel df-ss simplrl
      cop eqeltrd dfss1 simplrr wo simplr simprl simprr metusttoOLD syl3anc vex
      mpjaodan inex1 pwid a1i elpwid sseq1 ralrimivva 3jca elfvex xpexg isfbas2
      wb mpbir2and ) CJKZACUAUBZLZMZBCCUDZUCUBLZBYMUENZBJKZJBUFZFOZGOZHOZUGZNZF
      BUHZHBUIGBUIZUJZYKYOYIYKYSYMNZGBUIYOYKUUFGBYKYSBLZYSAUKZULDOZUMUNZUSZPZDU
      OUHZUUFYSABCDEUPZYKUULUUFDUOYKUULUUFYKUULMZYSUUKYMYKUULUQUUOAURZUUKYMAUUJ
      UTYKUUPYMPZUULYKYMVAAVBUUQACVCYMVAAVDQVEVFVGVJVHVKVIGBYMVLVMRYLYPYQUUDYLU
      UGGVNZYPYKUURYIYKUURUUMGVNZYKYSUUHULSUMUNZUSZPZGVNZUUSYKUUHTLUVATLUVCAYJV
      OUUHUUTTVPGUVATVQWBUVBUUMGSUOLUVBUUMVRUULUVBDSUOUUISPZUUKUVAYSUVDUUJUUTUU
      HUUISULUMVSVTWAWCWDWEQYKUUGUUMGUUNWFWGRGBWHVMYLJBLWIYQYLGBJYLUUGMWJCWNZYS
      NZUVEJKZYSJKYKUUGUVFYIYSABCDEWKWLYLUVGUUGYLIOZCLZIVNZUVGYIUVJYKYIUVJICWHW
      MVEUVIUVGIUVIUVHUVHXEZUVELZUVGUVIUVLUVHCCWOWPUVEUVKWQQWRQVEUVEYSWSWTXAJBX
      BVMYLUUCGHBBYLUUGYTBLZMZMZUUABLZUUAUUANZUUCUVOYSYTNZUVPYTYSNZUVOUVRMUUAYS
      BUVRUUAYSPZUVOUVRUVTYSYTXCWMRYLUUGUVMUVRXDXFUVOUVSMUUAYTBUVSUUAYTPZUVOUVS
      UWAYTYSXGWMRYLUUGUVMUVSXHXFUVOYKUUGUVMUVRUVSXIYIYKUVNXJYLUUGUVMXKYLUUGUVM
      XLYSYTABCDEXMXNXPUVOUUAUUAUUAUUAUELUVOUUAYSYTGXOXQXRXSXTUUBUVQFUUABYRUUAU
      UAYAWCWTYBYCYLYMTLZYNYOUUEMYGYLCTLZUWCUWBYKUWCYIACUAYDRZUWDCCTTYEWTGHFTYM
      BYFQYH $.

    $( The filter base generated by a metric ` D ` .  (Contributed by Thierry
       Arnoux, 26-Nov-2017.)  (Revised by Thierry Arnoux, 11-Feb-2018.) $)
    metustfbas $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) )
      -> F e. ( fBas ` ( X X. X ) ) ) $=
      ( vz vx vy vp c0 wne wcel wa wss cv wceq crp adantl cvv c1 cpsmet cfv cxp
      cfbas cpw wnel cin wrex wral w3a ccnv cc0 cico co cima metustel simpr cdm
      cnvimass cxr wf psmetf fdm syl adantr syl5sseq eqsstrd rexlimdvw ralrimiv
      ex sylbid pwssb sylibr wex cnvexg imaexg elisset 1rp oveq2 imaeq2d eqeq2d
      rspcev mpan eximi 4syl exbidv mpbird cid cres metustid adantll biimpi cop
      n0 opelresi ibir ne0i exlimiv ssn0 syl2anc nelrdva df-nel simplrl eqeltrd
      wn df-ss dfss1 simplrr simplr simprl simprr metustto syl3anc mpjaodan vex
      wo inex1 pwid a1i elpwid sseq1 ralrimivva 3jca wb xpexg isfbas2 mpbir2and
      elfvex ) CJKZACUAUBZLZMZBCCUCZUDUBLZBYMUENZBJKZJBUFZFOZGOZHOZUGZNZFBUHZHB
      UIGBUIZUJZYKYOYIYKYSYMNZGBUIYOYKUUFGBYKYSBLZYSAUKZULDOZUMUNZUOZPZDQUHZUUF
      YSABCDEUPZYKUULUUFDQYKUULUUFYKUULMZYSUUKYMYKUULUQUUOAURZUUKYMAUUJUSYKUUPY
      MPZUULYKYMUTAVAUUQACVBYMUTAVCVDVEVFVGVJVHVKVIGBYMVLVMRYLYPYQUUDYLUUGGVNZY
      PYKUURYIYKUURUUMGVNZYKUUHSLUUHULTUMUNZUOZSLYSUVAPZGVNUUSAYJVOUUHUUTSVPGUV
      ASVQUVBUUMGTQLUVBUUMVRUULUVBDTQUUITPZUUKUVAYSUVCUUJUUTUUHUUITULUMVSVTWAWB
      WCWDWEYKUUGUUMGUUNWFWGRGBWNVMYLJBLXEYQYLGBJYLUUGMWHCWIZYSNZUVDJKZYSJKYKUU
      GUVEYIYSABCDEWJWKYLUVFUUGYLIOZCLZIVNZUVFYIUVIYKYIUVIICWNWLVEUVHUVFIUVHUVG
      UVGWMZUVDLZUVFUVHUVKUVGCCWOWPUVDUVJWQVDWRVDVEUVDYSWSWTXAJBXBVMYLUUCGHBBYL
      UUGYTBLZMZMZUUABLZUUAUUANZUUCUVNYSYTNZUVOYTYSNZUVNUVQMUUAYSBUVQUUAYSPZUVN
      UVQUVSYSYTXFWLRYLUUGUVLUVQXCXDUVNUVRMUUAYTBUVRUUAYTPZUVNUVRUVTYTYSXGWLRYL
      UUGUVLUVRXHXDUVNYKUUGUVLUVQUVRXPYIYKUVMXIYLUUGUVLXJYLUUGUVLXKYSYTABCDEXLX
      MXNUVNUUAUUAUUAUUAUELUVNUUAYSYTGXOXQXRXSXTUUBUVPFUUABYRUUAUUAYAWBWTYBYCYL
      YMSLZYNYOUUEMYDYLCSLZUWBUWAYKUWBYIACUAYHRZUWCCCSSYEWTGHFSYMBYFVDYG $.

    $( The uniform structure generated by a metric ` D ` (Contributed by
       Thierry Arnoux, 26-Nov-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metustOLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) )
      -> ( ( X X. X ) filGen F ) e. ( UnifOn ` X ) ) $=
      ( vv vw vu cfv wcel wa wss cv wral ccnv wrex w3a syl simplr ad2antrr cxmt
      c0 wne cxp cfg co cust cpw wi cin cres ccom cfbas cfil metustfbasOLD fgcl
      cid filsspw 3syl filtop ad3antrrr simpllr elpwid simpr syl13anc ralrimiva
      filss ex filin syl3anc metustidOLD syl2anc sstrd elfg biimpa simprd sylan
      r19.29a adantr ssfg sseldd simpld cnvss syl6sseq wceq metustsymOLD adantl
      cnvxp eqsstr3d simp-4l metustexhalfOLD syl21anc sstr reximi sylbir ssrexv
      r19.41v sylc 3jca cvv wb elfvex isust mpbir3and ) CUBUCZACUAIJZKZCCUDZBUE
      UFZCUGIJZXIXHUHZLZXHXIJZFMZGMZLZXOXIJZUIZGXKNZXNXOUJXIJZGXINZUQCUKZXNLZXN
      OZXIJZXOXOULZXNLZGXIPZQZQZFXINZXGBXHUMIJZXIXHUNIJZXLABCDEUOZBXHUPZXIXHURU
      SXGYLYMXMYNYOXIXHUTUSXGYJFXIXGXNXIJZKZXSYAYIYQXRGXKYQXOXKJZKZXPXQYSXPKZYM
      YPXOXHLXPXQXGYMYPYRXPXGYLYMYNYORZVAXGYPYRXPVBYTXOXHYQYRXPSVCYSXPVDXNXOXIX
      HVGVEVHVFYQXTGXIYQXQKYMYPXQXTXGYMYPXQUUATXGYPXQSYQXQVDXNXOXIXHVIVJVFYQYCY
      EYHYQHMZXNLZYCHBYQUUBBJZKZUUCKZYBUUBXNUUFXFUUDYBUUBLYQXFUUDUUCXEXFYPSTZYQ
      UUDUUCSZUUBABCDEVKVLUUEUUCVDZVMXGYLYPUUCHBPZYNYLYPKZXNXHLZUUJYLYPUULUUJKH
      XNBXHVNVOZVPVQZVRYQUUCYEHBUUFYMUUBXIJYDXHLZUUBYDLYEXGYMYPUUDUUCUUAVAUUFBX
      IUUBYQBXILZUUDUUCYQYLUUPXGYLYPYNVSBXHVTRZTUUHWAUUFUULUUOYQUULUUDUUCXGYLYP
      UULYNUUKUULUUJUUMWBVQTUULYDXHOXHXNXHWCCCWHWDRUUFUUBUUBOZYDUUFXFUUDUURUUBW
      EUUGUUHUUBABCDEWFVLUUCUURYDLUUEUUBXNWCWGWIUUBYDXIXHVGVEUUNVRYQUUPYGGBPZYH
      UUQYQUUCUUSHBUUFYFUUBLZGBPZUUCUUSUUFXEXFUUDUVAXEXFYPUUDUUCWJUUGUUHGUUBABC
      DEWKWLUUIUVAUUCKUUTUUCKZGBPUUSUUTUUCGBWQUVBYGGBYFUUBXNWMWNWOVLUUNVRYGGBXI
      WPWRWSWSVFXGCWTJZXJXLXMYKQXAXFUVCXEACUAXBWGGFXICXCRXD $.

    $( The uniform structure generated by a metric ` D ` (Contributed by
       Thierry Arnoux, 26-Nov-2017.)  (Revised by Thierry Arnoux,
       11-Feb-2018.) $)
    metust $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) )
      -> ( ( X X. X ) filGen F ) e. ( UnifOn ` X ) ) $=
      ( vv vw vu cfv wcel wa wss cv wral ccnv wrex w3a syl simplr ad2antrr cust
      c0 wne cpsmet cxp cfg co cpw cin cid cres ccom cfbas cfil metustfbas fgcl
      wi filsspw filtop ad3antrrr simpllr elpwid simpr filss syl13anc ralrimiva
      3syl filin syl3anc metustid syl2anc sstrd elfg biimpa simprd sylan adantr
      r19.29a ssfg sseldd simpld cnvss cnvxp syl6sseq metustsym adantl eqsstr3d
      wceq simp-4l metustexhalf syl21anc r19.41v sstr reximi sylbir ssrexv sylc
      ex 3jca cvv wb elfvex isust mpbir3and ) CUBUCZACUDIJZKZCCUEZBUFUGZCUAIJZX
      IXHUHZLZXHXIJZFMZGMZLZXOXIJZUQZGXKNZXNXOUIXIJZGXINZUJCUKZXNLZXNOZXIJZXOXO
      ULZXNLZGXIPZQZQZFXINZXGBXHUMIJZXIXHUNIJZXLABCDEUOZBXHUPZXIXHURVGXGYLYMXMY
      NYOXIXHUSVGXGYJFXIXGXNXIJZKZXSYAYIYQXRGXKYQXOXKJZKZXPXQYSXPKZYMYPXOXHLXPX
      QXGYMYPYRXPXGYLYMYNYORZUTXGYPYRXPVAYTXOXHYQYRXPSVBYSXPVCXNXOXIXHVDVEWRVFY
      QXTGXIYQXQKYMYPXQXTXGYMYPXQUUATXGYPXQSYQXQVCXNXOXIXHVHVIVFYQYCYEYHYQHMZXN
      LZYCHBYQUUBBJZKZUUCKZYBUUBXNUUFXFUUDYBUUBLYQXFUUDUUCXEXFYPSTZYQUUDUUCSZUU
      BABCDEVJVKUUEUUCVCZVLXGYLYPUUCHBPZYNYLYPKZXNXHLZUUJYLYPUULUUJKHXNBXHVMVNZ
      VOVPZVRYQUUCYEHBUUFYMUUBXIJYDXHLZUUBYDLYEXGYMYPUUDUUCUUAUTUUFBXIUUBYQBXIL
      ZUUDUUCYQYLUUPXGYLYPYNVQBXHVSRZTUUHVTUUFUULUUOYQUULUUDUUCXGYLYPUULYNUUKUU
      LUUJUUMWAVPTUULYDXHOXHXNXHWBCCWCWDRUUFUUBUUBOZYDUUFXFUUDUURUUBWHUUGUUHUUB
      ABCDEWEVKUUCUURYDLUUEUUBXNWBWFWGUUBYDXIXHVDVEUUNVRYQUUPYGGBPZYHUUQYQUUCUU
      SHBUUFYFUUBLZGBPZUUCUUSUUFXEXFUUDUVAXEXFYPUUDUUCWIUUGUUHGUUBABCDEWJWKUUIU
      VAUUCKUUTUUCKZGBPUUSUUTUUCGBWLUVBYGGBYFUUBXNWMWNWOVKUUNVRYGGBXIWPWQWSWSVF
      XGCWTJZXJXLXMYKQXAXFUVCXEACUDXBWFGFXICXCRXD $.

    $d a b p q r v A $.  $d a b B $.  $d a v w x y C $.
    $d a b p q r u v w x y D $.  $d a b p q r u v x y z F $.
    $d a b p q r u v w x y z X $.
    $( Given a metric ` D ` and a uniform structure generated by that metric,
       Cauchy filter bases on that uniform structure are exactly the filter
       bases which contain balls of any pre-chosen size.  See ~ iscfil .
       (Contributed by Thierry Arnoux, 29-Nov-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cfilucfilOLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) -> (
      C e. ( CauFilU ` ( ( X X. X ) filGen F ) ) <-> ( C e. ( fBas ` X )
        /\ A. x e. RR+ E. y e. C ( D " ( y X. y ) ) C_ ( 0 [,) x ) ) ) ) $=
      ( vw cfv wcel wa co cv cc0 wss wrex crp wceq syl2anc vv c0 wne cxp ccfilu
      cxmt cfg cfbas cima cico wral cust metustOLD cfilufbas sylan wfun ccnv wf
      cxr simpllr ffun 3syl ad2antrr simplr metustfbasOLD cdm cnvimass syl5sseq
      xmetf fdm c2 cdiv simpr rphalfcld eqidd imaeq2d eqeq2d rspcev metustelOLD
      oveq2 biimpar cle wbr 0xr a1i rpxr 0le0 rehalfcld rphalflt ltled icossico
      rpre syl22anc imass2 elfg syl12anc cfiluexsm syl3anc funimass2 ex reximdv
      sseq1 sylc ralrimiva jca simprl simp-4r simprd sseq2d rexbidv rspccv nfcv
      nfre1 nfral nfan ad4antr fbelss sylancom simp-6r sseqtr4d ralrimi r19.29r
      nfv xpss12 cin dfss1 biimpi adantl dminss syl6eqssr adantr reximi r19.41v
      sstrd syl sstr sylbir simp-5r biimpa r19.29a wb iscfilu mpbir2and impbida
      ) FUBUCZDFUFJKZLZCFFUDZEUGMZUEJKZCFUHJKZDBNZUULUDZUIZOANZUJMZPZBCQZARUKZL
      ZUUGUUJLZUUKUUSUUGUUIFULJKZUUJUUKDEFGHUMZUUICFUNUOUVAUURARUVAUUORKZLZDUPZ
      UUMDUQZUUPUIZPZBCQZUURUVEUUFUUHUSDURZUVFUUEUUFUUJUVDUTZDFVIZUUHUSDVAVBUVE
      UVBUUJUVHUUIKZUVJUUGUVBUUJUVDUVCVCUUGUUJUVDVDUVEEUUHUHJKZUVHUUHPZINZUVHPZ
      IEQZUVNUUGUVOUUJUVDDEFGHVEZVCUVEDVFZUVHUUHDUUPVGUVEUUFUVKUWAUUHSZUVLUVMUU
      HUSDVJZVBVHUVEUVGOUUOVKVLMZUJMZUIZEKZUWFUVHPZUVSUVEUUFUWFUVGOGNZUJMZUIZSZ
      GRQZUWGUVLUVEUWDRKUWFUWFSZUWMUVEUUOUVAUVDVMZVNUVEUWFVOUWLUWNGUWDRUWIUWDSZ
      UWKUWFUWFUWPUWJUWEUVGUWIUWDOUJVTVPVQVRTUUFUWGUWMUWFDEFGHVSWATUVEUVDUWEUUP
      PZUWHUWOUVDOUSKZUUOUSKOOWBWCZUWDUUOWBWCUWQUWRUVDWDWEUUOWFUWSUVDWGWEUVDUWD
      UUOUVDUUOUUOWLZWHUWTUUOWIWJOUUOOUWDWKWMUWEUUPUVGWNVBUVRUWHIUWFEUVQUWFUVHX
      BVRTUVOUVNUVPUVSLIUVHEUUHWOWAWPUUICUVHFBWQWRUVFUVIUUQBCUVFUVIUUQUUMUUPDWS
      WTXAXCXDXEUUGUUTLZUUJUUKUUMUANZPZBCQZUAUUIUKZUUGUUKUUSXFZUXAUXDUAUUIUXAUX
      BUUIKZLZUWKUXBPZUXDGRUXHUWIRKZLZUXIUUMUWKPZBCQZUXDUXKUXILZUUNUWJPZBCQZUUM
      UWAPZBCUKZUXMUXNUUSUXJUXPUXNUUKUUSUUGUUTUXGUXJUXIXGXHUXHUXJUXIVDUURUXPAUW
      IRUUOUWISZUUQUXOBCUXSUUPUWJUUNUUOUWIOUJVTXIXJXKXCUXNUXQBCUXKUXIBUXHUXJBUX
      AUXGBUUGUUTBUUGBYCUUKUUSBUUKBYCUURBARBRXLUUQBCXMXNXOXOUXGBYCXOUXJBYCXOUXI
      BYCXOUXNUULCKZUXQUXNUXTLZUUMUUHUWAUYAUULFPZUYBUUMUUHPUXNUXTUUKUYBUXAUUKUX
      GUXJUXIUXTUXFXPFCUULXQXRZUYCUULFUULFYDTUYAUUFUVKUWBUUEUUFUUTUXGUXJUXIUXTX
      SUVMUWCVBXTWTYAUXPUXRLUXOUXQLZBCQUXMUXOUXQBCYBUYDUXLBCUYDUUMUVGUUNUIZUWKU
      YDUUMUWAUUMYEZUYEUXQUYFUUMSZUXOUXQUYGUUMUWAYFYGYHUUMDYIYJUXOUYEUWKPUXQUUN
      UWJUVGWNYKYNYLYOTUXMUXILUXLUXILZBCQUXDUXLUXIBCYMUYHUXCBCUUMUWKUXBYPYLYQXR
      UXHUVQUXBPZUXIGRQZIEUXHUVQEKZLZUYIUVQUWKSZGRQZUYJUYLUYILUUFUYKUYNUUEUUFUU
      TUXGUYKUYIYRUXHUYKUYIVDUUFUYKUYNUVQDEFGHVSYSTUYNUYILUYMUYILZGRQUYJUYMUYIG
      RYMUYOUXIGRUYMUYIUXIUVQUWKUXBXBYSYLYQXRUXHUXBUUHPZUYIIEQZUXAUXGUVOUYPUYQL
      ZUUGUVOUUTUXGUVTVCUVOUXGUYRIUXBEUUHWOYSXRXHYTYTXDUXAUVBUUJUUKUXELUUAUUGUV
      BUUTUVCYKUAUUICFBUUBYOUUCUUD $.

    $( Given a metric ` D ` and a uniform structure generated by that metric,
       Cauchy filter bases on that uniform structure are exactly the filter
       bases which contain balls of any pre-chosen size.  See ~ iscfil .
       (Contributed by Thierry Arnoux, 29-Nov-2017.)  (Revised by Thierry
       Arnoux, 11-Feb-2018.) $)
    cfilucfil $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) ) -> (
      C e. ( CauFilU ` ( ( X X. X ) filGen F ) ) <-> ( C e. ( fBas ` X )
        /\ A. x e. RR+ E. y e. C ( D " ( y X. y ) ) C_ ( 0 [,) x ) ) ) ) $=
      ( vw cfv wcel wa co cv cc0 wss wrex crp wceq syl2anc vv c0 wne cpsmet cxp
      cfg ccfilu cfbas cima cico wral cust metust cfilufbas sylan wfun ccnv cxr
      simpllr psmetf ffun 3syl ad2antrr simplr metustfbas cdm cnvimass syl5sseq
      wf fdm c2 cdiv simpr rphalfcld eqidd oveq2 imaeq2d eqeq2d rspcev metustel
      biimpar cle wbr rpxr 0le0 rpre rehalfcld rphalflt ltled icossico syl22anc
      0xr a1i imass2 sseq1 elfg syl12anc cfiluexsm syl3anc funimass2 ex reximdv
      sylc ralrimiva jca simprl simp-4r simprd sseq2d rexbidv rspccv nfcv nfre1
      nfv nfral ad4antr fbelss sylancom xpss12 simp-6r sseqtr4d ralrimi r19.29r
      nfan cin dfss1 biimpi adantl dminss syl6eqssr adantr sstrd reximi r19.41v
      syl sstr sylbir simp-5r biimpa r19.29a wb iscfilu mpbir2and impbida ) FUB
      UCZDFUDJKZLZCFFUEZEUFMZUGJKZCFUHJKZDBNZUULUEZUIZOANZUJMZPZBCQZARUKZLZUUGU
      UJLZUUKUUSUUGUUIFULJKZUUJUUKDEFGHUMZUUICFUNUOUVAUURARUVAUUORKZLZDUPZUUMDU
      QZUUPUIZPZBCQZUURUVEUUFUUHURDVIZUVFUUEUUFUUJUVDUSZDFUTZUUHURDVAVBUVEUVBUU
      JUVHUUIKZUVJUUGUVBUUJUVDUVCVCUUGUUJUVDVDUVEEUUHUHJKZUVHUUHPZINZUVHPZIEQZU
      VNUUGUVOUUJUVDDEFGHVEZVCUVEDVFZUVHUUHDUUPVGUVEUUFUVKUWAUUHSZUVLUVMUUHURDV
      JZVBVHUVEUVGOUUOVKVLMZUJMZUIZEKZUWFUVHPZUVSUVEUUFUWFUVGOGNZUJMZUIZSZGRQZU
      WGUVLUVEUWDRKUWFUWFSZUWMUVEUUOUVAUVDVMZVNUVEUWFVOUWLUWNGUWDRUWIUWDSZUWKUW
      FUWFUWPUWJUWEUVGUWIUWDOUJVPVQVRVSTUUFUWGUWMUWFDEFGHVTWATUVEUVDUWEUUPPZUWH
      UWOUVDOURKZUUOURKOOWBWCZUWDUUOWBWCUWQUWRUVDWLWMUUOWDUWSUVDWEWMUVDUWDUUOUV
      DUUOUUOWFZWGUWTUUOWHWIOUUOOUWDWJWKUWEUUPUVGWNVBUVRUWHIUWFEUVQUWFUVHWOVSTU
      VOUVNUVPUVSLIUVHEUUHWPWAWQUUICUVHFBWRWSUVFUVIUUQBCUVFUVIUUQUUMUUPDWTXAXBX
      CXDXEUUGUUTLZUUJUUKUUMUANZPZBCQZUAUUIUKZUUGUUKUUSXFZUXAUXDUAUUIUXAUXBUUIK
      ZLZUWKUXBPZUXDGRUXHUWIRKZLZUXIUUMUWKPZBCQZUXDUXKUXILZUUNUWJPZBCQZUUMUWAPZ
      BCUKZUXMUXNUUSUXJUXPUXNUUKUUSUUGUUTUXGUXJUXIXGXHUXHUXJUXIVDUURUXPAUWIRUUO
      UWISZUUQUXOBCUXSUUPUWJUUNUUOUWIOUJVPXIXJXKXCUXNUXQBCUXKUXIBUXHUXJBUXAUXGB
      UUGUUTBUUGBXNUUKUUSBUUKBXNUURBARBRXLUUQBCXMXOYDYDUXGBXNYDUXJBXNYDUXIBXNYD
      UXNUULCKZUXQUXNUXTLZUUMUUHUWAUYAUULFPZUYBUUMUUHPUXNUXTUUKUYBUXAUUKUXGUXJU
      XIUXTUXFXPFCUULXQXRZUYCUULFUULFXSTUYAUUFUVKUWBUUEUUFUUTUXGUXJUXIUXTXTUVMU
      WCVBYAXAYBUXPUXRLUXOUXQLZBCQUXMUXOUXQBCYCUYDUXLBCUYDUUMUVGUUNUIZUWKUYDUUM
      UWAUUMYEZUYEUXQUYFUUMSZUXOUXQUYGUUMUWAYFYGYHUUMDYIYJUXOUYEUWKPUXQUUNUWJUV
      GWNYKYLYMYOTUXMUXILUXLUXILZBCQUXDUXLUXIBCYNUYHUXCBCUUMUWKUXBYPYMYQXRUXHUV
      QUXBPZUXIGRQZIEUXHUVQEKZLZUYIUVQUWKSZGRQZUYJUYLUYILUUFUYKUYNUUEUUFUUTUXGU
      YKUYIYRUXHUYKUYIVDUUFUYKUYNUVQDEFGHVTYSTUYNUYILUYMUYILZGRQUYJUYMUYIGRYNUY
      OUXIGRUYMUYIUXIUVQUWKUXBWOYSYMYQXRUXHUXBUUHPZUYIIEQZUXAUXGUVOUYPUYQLZUUGU
      VOUUTUXGUVTVCUVOUXGUYRIUXBEUUHWPYSXRXHYTYTXDUXAUVBUUJUUKUXELUUAUUGUVBUUTU
      VCYKUAUUICFBUUBYOUUCUUD $.
  $}

  ${
    $d a b D $.  $d a b X $.
    $( The uniform structure generated by metric ` D ` is a uniform structure.
       (Contributed by Thierry Arnoux, 1-Dec-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    metuustOLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) )
      -> ( metUnifOLD ` D ) e. ( UnifOn ` X ) ) $=
      ( va vb c0 wne cxmt cfv wcel wa cmetuOLD cxp crp cc0 cv cico co cima cmpt
      wceq ccnv crn cfg metuvalOLD adantl oveq2 imaeq2d cbvmptv rneqi metustOLD
      cust eqeltrd ) BEFZABGHIZJAKHZBBLCMAUAZNCOZPQZRZSZUBZUCQZBUKHUNUOVBTUMABC
      UDUEAVABDUTDMUPNDOZPQZRZSCDMUSVEUQVCTURVDUPUQVCNPUFUGUHUIUJUL $.

    $( The uniform structure generated by metric ` D ` is a uniform structure.
       (Contributed by Thierry Arnoux, 1-Dec-2017.)  (Revised by Thierry
       Arnoux, 11-Feb-2018.) $)
    metuust $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) )
      -> ( metUnif ` D ) e. ( UnifOn ` X ) ) $=
      ( va vb c0 wne cpsmet cfv wcel wa cmetu cxp crp cv cico co cima cmpt wceq
      cc0 ccnv crn cfg cust metuval adantl oveq2 imaeq2d cbvmptv metust eqeltrd
      rneqi ) BEFZABGHIZJAKHZBBLCMAUAZTCNZOPZQZRZUBZUCPZBUDHUNUOVBSUMABCUEUFAVA
      BDUTDMUPTDNZOPZQZRCDMUSVEUQVCSURVDUPUQVCTOUGUHUIULUJUK $.
  $}

  ${
    $d b x y C $.  $d a b x y D $.  $d a b x y X $.
    $( Given a metric ` D ` and a uniform structure generated by that metric,
       Cauchy filter bases on that uniform structure are exactly the filter
       bases which contain balls of any pre-chosen size.  See ~ iscfil .
       (Contributed by Thierry Arnoux, 1-Dec-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cfilucfil2OLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) -> (
      C e. ( CauFilU ` ( metUnifOLD ` D ) ) <-> ( C e. ( fBas ` X )
        /\ A. x e. RR+ E. y e. C ( D " ( y X. y ) ) C_ ( 0 [,) x ) ) ) ) $=
      ( va vb cfv wcel wa ccfilu cxp crp cc0 cv cico co cima cmpt wceq wne cxmt
      cmetuOLD ccnv crn cfg cfbas wss wrex wral metuvalOLD adantl fveq2d eleq2d
      c0 oveq2 imaeq2d cbvmptv rneqi cfilucfilOLD bitrd ) EUOUAZDEUBHIZJZCDUCHZ
      KHZICEELFMDUDZNFOZPQZRZSZUEZUFQZKHZICEUGHIDBOZVOLRNAOPQUHBCUIAMUJJVDVFVNC
      VDVEVMKVCVEVMTVBDEFUKULUMUNABCDVLEGVKGMVGNGOZPQZRZSFGMVJVRVHVPTVIVQVGVHVP
      NPUPUQURUSUTVA $.

    $( Given a metric ` D ` and a uniform structure generated by that metric,
       Cauchy filter bases on that uniform structure are exactly the filter
       bases which contain balls of any pre-chosen size.  See ~ iscfil .
       (Contributed by Thierry Arnoux, 1-Dec-2017.)  (Revised by Thierry
       Arnoux, 11-Feb-2018.) $)
    cfilucfil2 $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) ) -> (
      C e. ( CauFilU ` ( metUnif ` D ) ) <-> ( C e. ( fBas ` X )
        /\ A. x e. RR+ E. y e. C ( D " ( y X. y ) ) C_ ( 0 [,) x ) ) ) ) $=
      ( va vb cfv wcel wa ccfilu cxp crp cc0 cv cico co cima cmpt wceq c0 cmetu
      wne cpsmet ccnv crn cfg cfbas wss wrex metuval adantl fveq2d eleq2d oveq2
      wral imaeq2d cbvmptv rneqi cfilucfil bitrd ) EUAUCZDEUDHIZJZCDUBHZKHZICEE
      LFMDUEZNFOZPQZRZSZUFZUGQZKHZICEUHHIDBOZVOLRNAOPQUIBCUJAMUPJVDVFVNCVDVEVMK
      VCVEVMTVBDEFUKULUMUNABCDVLEGVKGMVGNGOZPQZRZSFGMVJVRVHVPTVIVQVGVHVPNPUOUQU
      RUSUTVA $.
  $}

  ${
    $d x D $.  $d x P $.  $d x R $.  $d x X $.
    $( The ball around a point ` P ` , alternative definition.  (Contributed by
       Thierry Arnoux, 7-Dec-2017.)  (Revised by Thierry Arnoux,
       11-Mar-2018.) $)
    blval2 $p |- ( ( D e. ( PsMet ` X ) /\ P e. X /\ R e. RR+ )
      -> ( P ( ball ` D ) R ) = ( ( `' D " ( 0 [,) R ) ) " { P } ) ) $=
      ( vx cfv wcel w3a co wbr cc0 cima cxr wa wb 3ad2ant2 ex syl3anc bitrd cvv
      cpsmet crp cbl cv clt crab ccnv cico csn wceq rpxr blvalps syl3an3 nfrab1
      nfv nfcv cop cxp wfn psmetf ffn elpreima 3syl 3ad2ant1 opelxp baib biimpd
      wf adantrd simprl simpl2 syl df-ov eleq1i cle simpl3 rpxrd elico1 sylancr
      0xr simpl1 psmetcl psmetge0 jca biantrurd df-3an syl6rbbr syl5bbr anbi12d
      simpr pm5.21ndd vex elimasng mpan2 rabid a1i 3bitr4d eqrd eqtr4d ) ADUAFG
      ZBDGZCUBGZHZBCAUCFIZBEUDZAIZCUEJZEDUFZAUGKCUHIZLZBUILZXBWTXACMGZXDXHUJCUK
      EABCDULUMXCEXKXHXCEUOEXKUPXGEDUNXCBXEUQZXJGZXEDGZXGNZXEXKGZXEXHGZXCXNXMDD
      URZGZXMAFZXIGZNZXPWTXAXNYCOZXBWTXSMAVHAXSUSYDADUTXSMAVAXSXMXIAVBVCVDXCXOY
      CXPXCXTXOYBXCXTXOXAWTXTXOOZXBXTXAXOBXEDDVEVFZPVGVIXCXPXOXCXOXGVJQXCXOYCXP
      OXCXONZXTXOYBXGYGXAYEWTXAXBXOVKZYFVLYBXFXIGZYGXGXFYAXIBXEAVMVNYGYIXFMGZKX
      FVOJZXGHZXGYGKMGXLYIYLOVTYGCWTXAXBXOVPVQKCXFVRVSYGXGYJYKNZXGNYLYGYMXGYGYJ
      YKYGWTXAXOYJWTXAXBXOWAZYHXCXOWJZBXEADWBRYGWTXAXOYKYNYHYOBXEADWCRWDWEYJYKX
      GWFWGSWHWIQWKSXAWTXQXNOZXBXAXETGYPEWLXJBXEDTWMWNPXRXPOXCXGEDWOWPWQWRWS $.
  $}

  $( Membership in a ball, alternative definition.  (Contributed by Thierry
     Arnoux, 26-Jan-2018.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
  elbl4 $p |- ( ( ( D e. ( PsMet ` X ) /\ R e. RR+ ) /\ ( A e. X /\ B e. X ) )
    -> ( B e. ( A ( ball ` D ) R ) <-> B ( `' D " ( 0 [,) R ) ) A ) ) $=
    ( cpsmet cfv wcel crp wa cbl co ccnv cc0 cico cima csn wbr cxr wb w3a df-br
    rpxr blcomps sylanl2 simpll simprr simplr blval2 eleq2d syl3anc cop syl6bbr
    elimasng ancoms adantl 3bitrd ) CEFGHZDIHZJZAEHZBEHZJZJZBADCKGZLHZABDVELZHZ
    ACMNDOLPZBQPZHZBAVIRZUSURDSHVCVFVHTDUCBCADEUDUEVDURVBUSVHVKTURUSVCUFUTVAVBU
    GURUSVCUHURVBUSUAVGVJACBDEUIUJUKVCVKVLTZUTVBVAVMVBVAJVKBAULVIHVLVIBAEEUNBAV
    IUBUMUOUPUQ $.

  ${
    $d a e w D $.  $d a e X $.  $d w V $.
    $( Elementhood in the uniform structure generated by a metric ` D `
       (Contributed by Thierry Arnoux, 8-Dec-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    metuelOLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) ->
      ( V e. ( metUnifOLD ` D ) <-> ( V C_ ( X X. X )
        /\ E. w e. ran ( a e. RR+ |-> ( `' D " ( 0 [,) a ) ) ) w C_ V ) ) ) $=
      ( ve c0 wne cfv wcel wa crp cc0 cv cico co cima cmpt wss wceq cxp crn cfg
      cxmt cmetuOLD ccnv wrex metuvalOLD adantl eleq2d cfbas wb imaeq2d cbvmptv
      oveq2 rneqi metustfbasOLD elfg syl bitrd ) DGHZBDUDIJZKZCBUEIZJCDDUAZELBU
      FZMENZOPZQZRZUBZUCPZJZCVESANCSAVKUGKZVCVDVLCVBVDVLTVABDEUHUIUJVCVKVEUKIJV
      MVNULBVKDFVJFLVFMFNZOPZQZREFLVIVQVGVOTVHVPVFVGVOMOUOUMUNUPUQACVKVEURUSUT
      $.

    $( Elementhood in the uniform structure generated by a metric ` D `
       (Contributed by Thierry Arnoux, 8-Dec-2017.)  (Revised by Thierry
       Arnoux, 11-Feb-2018.) $)
    metuel $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) ) ->
      ( V e. ( metUnif ` D ) <-> ( V C_ ( X X. X )
        /\ E. w e. ran ( a e. RR+ |-> ( `' D " ( 0 [,) a ) ) ) w C_ V ) ) ) $=
      ( ve c0 wne cfv wcel wa crp cc0 cv cico co cima cmpt wss wceq cpsmet ccnv
      cmetu cxp crn cfg wrex metuval adantl eleq2d cfbas wb oveq2 imaeq2d rneqi
      cbvmptv metustfbas elfg syl bitrd ) DGHZBDUAIJZKZCBUCIZJCDDUDZELBUBZMENZO
      PZQZRZUEZUFPZJZCVESANCSAVKUGKZVCVDVLCVBVDVLTVABDEUHUIUJVCVKVEUKIJVMVNULBV
      KDFVJFLVFMFNZOPZQZREFLVIVQVGVOTVHVPVFVGVOMOUMUNUPUOUQACVKVEURUSUT $.
  $}


  ${
    $d a d w x y D $.  $d d w x y V $.  $d a d x y X $.
    metuel2.u $e |- U = ( metUnif ` D ) $.
    $( Elementhood in the uniform structure generated by a metric ` D `
       (Contributed by Thierry Arnoux, 24-Jan-2018.)  (Revised by Thierry
       Arnoux, 11-Feb-2018.) $)
    metuel2 $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) ) ->
      ( V e. U <-> ( V C_ ( X X. X )
        /\ E. d e. RR+ A. x e. X A. y e. X ( ( x D y ) < d -> x V y ) ) ) ) $=
      ( vw va wcel wa wss cv crp cc0 wrex wb cvv cxr c0 wne cpsmet cfv cxp ccnv
      cmetu cico co cima cmpt crn clt wbr wral eleq2i a1i metuel wceq wex oveq2
      wi vex imaeq2d cbvmptv elrnmpt ax-mp anbi1i r19.41v bitr4i df-rex rexcom4
      exbii 3bitr4i cnvexg imaexg sseq1 ceqsexgv rexbidv adantr syl5bb cnvimass
      syl cop cdm wf simpll psmetf fdm 3syl syl5sseq ssrel2 simplr simpr opelxp
      sylanbrc biantrurd cle w3a simp-4l psmetcl syl3anc 3anass syl6bbr simpllr
      psmetge0 0xr rpxrd elico1 syl2anc 3bitr4d eleq1i syl6bb wfn elpreima 4syl
      df-ov ffn anasss imbi12d 2ralbidva bitr4d rexbidva pm5.32da adantl 3bitrd
      df-br bitrd ) FUAUBZCFUCUDZKZLZEDKZECUGUDZKZEFFUEZMZINZEMZIJOCUFZPJNZUHUI
      ZUJZUKZULZQZLZYQANZBNZCUIZGNZUMUNZUUHUUIEUNZVBZBFUOAFUOZGOQZLZYMYORYLDYNE
      HUPUQICEFJURYKUUGUUQRYIYKYQUUFUUPYKYQLZUUFYTPUUKUHUIZUJZEMZGOQZUUPUUFYRUU
      TUSZYSLZIUTZGOQZUURUVBYRUUEKZYSLZIUTUVDGOQZIUTUUFUVFUVHUVIIUVHUVCGOQZYSLU
      VIUVGUVJYSYRSKUVGUVJRIVCGOUUTYRUUDSJGOUUCUUTUUAUUKUSUUBUUSYTUUAUUKPUHVAVD
      VEVFVGVHUVCYSGOVIVJVMYSIUUEVKUVDGIOVLVNYKUVFUVBRYQYKUVEUVAGOYKUUTSKZUVEUV
      ARYKYTSKUVKCYJVOYTUUSSVPWCYSUVAIUUTSYRUUTEVQVRWCVSVTWAUURUVAUUOGOUURUUKOK
      ZLZUVAUUHUUIWDZUUTKZUVNEKZVBZBFUOAFUOZUUOUVMUUTYPMUVAUVRRUVMCWEZUUTYPCUUS
      WBUVMYKYPTCWFZUVSYPUSYKYQUVLWGCFWHZYPTCWIWJWKABFFUUTEWLWCUVMUUNUVQABFFUVM
      UUHFKZUUIFKZLLZUULUVOUUMUVPUVMUWBUWCUULUVORUVMUWBLZUWCLZUVNCUDZUUSKZUVNYP
      KZUWHLZUULUVOUWFUWIUWHUWFUWBUWCUWIUVMUWBUWCWMZUWEUWCWNZUUHUUIFFWOWPWQUWFU
      ULUUJUUSKZUWHUWFPUUJWRUNZUULLZUUJTKZUWNUULWSZUULUWMUWFUWOUWPUWOLUWQUWFUWP
      UWOUWFYKUWBUWCUWPYKYQUVLUWBUWCWTZUWKUWLUUHUUICFXAXBWQUWPUWNUULXCXDUWFYKUW
      BUWCUULUWORUWRUWKUWLYKUWBUWCWSUWNUULUUHUUICFXFWQXBUWFPTKZUUKTKUWMUWQRUWSU
      WFXGUQUWFUUKUURUVLUWBUWCXEXHPUUKUUJXIXJXKUUJUWGUUSUUHUUICXQXLXMUWFYKUVTCY
      PXNUVOUWJRUWRUWAYPTCXRYPUVNUUSCXOXPXKXSUUMUVPRUWDUUHUUIEYGUQXTYAYBYCYHYDY
      EYF $.
  $}

  ${
    $d a r w D $.  $d a r w P $.  $d a r w V $.  $d a r w X $.
    $( The "section" image of an entourage at a point ` P ` always contains a
       ball (centered on this point).  (Contributed by Thierry Arnoux,
       8-Dec-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metustblOLD $p |- ( ( D e. ( *Met ` X ) /\ V e. ( metUnifOLD ` D ) /\ P e.
      X ) -> E. a e. ran ( ball ` D ) ( P e. a /\ a C_ ( V " { P } ) ) ) $=
      ( vr vw cfv wcel w3a cv cima wss wa crn wrex co crp wceq wb cxmt cmetuOLD
      csn cbl ccnv cc0 cico simp1 simp3 cmpt simpr cvv vex elrnmpt ax-mp biimpi
      eqid ad2antlr sseq1 biimpcd reximdv imp syl2anc c0 wne ne0i syl simp2 cxp
      metuelOLD simplbda syl21anc r19.29a imass1 reximi cpsmet xmetpsmet blval2
      syl3an1 sseq1d 3expa rexbidva syl5ibr blssex 3adant2 mpbird ) ADUAHIZCAUB
      HIZBDIZJZBEKZIWKCBUCZLZMNEAUDHZOPZBFKZWNQZWMMZFRPZWJWGWIAUEUFWPUGQLZCMZFR
      PZWSWGWHWIUHZWGWHWIUIZWJGKZCMZXBGFRWTUJZOZWJXEXHIZNZXFNXFXEWTSZFRPZXBXJXF
      UKXIXLWJXFXIXLXEULIXIXLTGUMFRWTXEXGULXGUQUNUOUPURXFXLXBXFXKXAFRXKXFXAXEWT
      CUSUTVAVBVCWJDVDVEZWGWHXFGXHPZWJWIXMXDDBVFVGXCWGWHWIVHXMWGNWHCDDVIMXNGACD
      FVJVKVLVMWGWINZXBWSXBWSXOWTWLLZWMMZFRPXAXQFRWTCWLVNVOXOWRXQFRWGWIWPRIZWRX
      QTWGWIXRJWQXPWMWGADVPHIWIXRWQXPSADVQABWPDVRVSVTWAWBWCVBVLWGWIWOWSTWHEWMAB
      DFWDWEWF $.

    $( The "section" image of an entourage at a point ` P ` always contains a
       ball (centered on this point).  (Contributed by Thierry Arnoux,
       8-Dec-2017.) $)
    metustbl $p |- ( ( D e. ( PsMet ` X ) /\ V e. ( metUnif ` D ) /\ P e. X )
      -> E. a e. ran ( ball ` D ) ( P e. a /\ a C_ ( V " { P } ) ) ) $=
      ( vr vw cfv wcel w3a cv cima wss wa crn wrex co crp cvv wb cpsmet csn cbl
      cmetu ccnv cc0 cico simp1 simp3 cmpt wceq simpr eqid elrnmpt ax-mp biimpi
      vex ad2antlr sseq1 biimpcd reximdv imp syl2anc c0 wne ne0i syl cxp metuel
      simp2 simplbda syl21anc r19.29a imass1 reximi blval2 sseq1d 3expa syl5ibr
      rexbidva blssexps 3adant2 mpbird ) ADUAHIZCAUDHIZBDIZJZBEKZIWHCBUBZLZMNEA
      UCHZOPZBFKZWKQZWJMZFRPZWGWDWFAUEUFWMUGQLZCMZFRPZWPWDWEWFUHZWDWEWFUIZWGGKZ
      CMZWSGFRWQUJZOZWGXBXEIZNZXCNXCXBWQUKZFRPZWSXGXCULXFXIWGXCXFXIXBSIXFXITGUQ
      FRWQXBXDSXDUMUNUOUPURXCXIWSXCXHWRFRXHXCWRXBWQCUSUTVAVBVCWGDVDVEZWDWEXCGXE
      PZWGWFXJXADBVFVGWTWDWEWFVJXJWDNWECDDVHMXKGACDFVIVKVLVMWDWFNZWSWPWSWPXLWQW
      ILZWJMZFRPWRXNFRWQCWIVNVOXLWOXNFRWDWFWMRIZWOXNTWDWFXOJWNXMWJABWMDVPVQVRVT
      VSVBVLWDWFWLWPTWEEWJABDFWAWBWC $.
  $}

  ${
    $d a b d e v w x D $.  $d a b d e v x X $.
    $( The topology induced by a uniform structure generated by a metric ` D `
       is that metric's open sets.  (Contributed by Thierry Arnoux,
       6-Dec-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metutopOLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) ->
      ( unifTop ` ( metUnifOLD ` D ) ) = ( MetOpen ` D ) ) $=
      ( va vx vb vv vd ve cfv wcel wa cv wss wrex cima wceq syl wb cvv crp cxmt
      c0 wne cmetuOLD cutop cmopn cbl crn cuni wral cpw crab metuustOLD utopval
      csn cust eleq2d rabid syl6bb biimpa simpld elpwid ad2antlr sseqtr4d simpr
      unirnbl simp-5r simplr ad3antrrr simpllr sseldd metustblOLD expcom anim2d
      syl3anc sstr reximdv sylc r19.21bi r19.29a ralrimiva jca ctg eqid mopnval
      simprd adantl fvex rnex eltg2 ax-mp adantr mpbird sseqtrd elpwg ccnv cico
      co cmpt sselda blssex syl2anc mpbid cpsmet xmetpsmet blval2 syl3an1 3expa
      cc0 sseq1d rexbidva syl21anc cnvexg imaexg ralrimivw imaeq1 rexrnmpt 3syl
      cxp cfg cfbas oveq2 imaeq2d cbvmptv rneqi metustfbasOLD metuvalOLD ssrexv
      wi ssfg ad2antrr mpd biimpar syldan impbida eqrdv ) BUBUCZABUAIZJZKZCAUDI
      ZUEIZAUFIZYTCLZUUBJZUUDUUCJZYTUUEKZUUFUUDAUGIZUHZUIZMZDLZELZJZUUMUUDMZKZE
      UUINZDUUDUJZKZUUGUUKUURUUGUUDBUUJUUGUUDBUUGUUDBUKZJZFLZUULUOZOZUUDMZFUUAN
      ZDUUDUJZYTUUEUVAUVGKZYTUUEUUDUVGCUUTULZJUVHYTUUBUVIUUDYTUUABUPIJUUBUVIPAB
      UMDFUUABCUNQUQUVGCUUTURUSZUTZVAVBZYSUUJBPZYQUUEABVFZVCVDUUGUUQDUUDUUGUULU
      UDJZKZUVEUUQFUUAUVPUVBUUAJZKZUVEKZUVEUUNUUMUVDMZKZEUUINZUUQUVRUVEVEUVSYSU
      VQUULBJZUWBYQYSUUEUVOUVQUVEVGUVPUVQUVEVHUVSUUDBUULUUGUUDBMZUVOUVQUVEUVLVI
      UUGUVOUVQUVEVJVKAUULUVBBEVLVOUVEUWAUUPEUUIUVEUVTUUOUUNUVTUVEUUOUUMUVDUUDV
      PVMVNVQVRUUGUVFDUUDUUGUVAUVGUVKWFVSVTWAWBYTUUFUUSRUUEYTUUFUUDUUIWCIZJZUUS
      YTUUCUWEUUDYSUUCUWEPYQAUUCBUUCWDWEWGUQUUISJUWFUUSRUUHAUGWHWIDEUUDUUISWJWK
      USZWLWMYTUUFUVHUUEYTUUFKZUVAUVGUWHUVAUWDUWHUUDUUJBUWHUUKUURYTUUFUUSUWGUTZ
      VAYSUVMYQUUFUVNVCWNZUUFUVAUWDRYTUUDBUUCWOWGWMUWHUVFDUUDUWHUVOKZUVEFGTAWPZ
      XIGLZWQWRZOZWSZUHZNZUVFUWKUWRUWOUVCOZUUDMZGTNZUWKYSUWCUULUWMUUHWRZUUDMZGT
      NZUXAYQYSUUFUVOVJZUWHUUDBUULUWJWTZUWKUUQUXDUWHUUQDUUDUWHUUKUURUWIWFVSUWKY
      SUWCUUQUXDRUXEUXFEUUDAUULBGXAXBXCYSUWCKZUXDUXAUXGUXCUWTGTUXGUWMTJZKUXBUWS
      UUDYSUWCUXHUXBUWSPZYSABXDIJUWCUXHUXIABXEAUULUWMBXFXGXHXJXKUTXLUWKYSUWOSJZ
      GTUJUWRUXARUXEYSUXJGTYSUWLSJUXJAYRXMUWLUWNSXNQXOUVEUWTGFTUWOUWPSUWPWDUVBU
      WOPUVDUWSUUDUVBUWOUVCXPXJXQXRWMYTUWRUVFYIZUUFUVOYTUWQUUAMUXKYTUWQBBXSZUWQ
      XTWRZUUAYTUWQUXLYAIJUWQUXMMAUWQBHUWPHTUWLXIHLZWQWRZOZWSGHTUWOUXPUWMUXNPUW
      NUXOUWLUWMUXNXIWQYBYCYDYEYFUWQUXLYJQYSUUAUXMPYQABGYGWGVDUVEFUWQUUAYHQYKYL
      WAWBYTUUEUVHUVJYMYNYOYP $.

    $( The topology induced by a uniform structure generated by a metric ` D `
       is generated by that metric's open balls.  (Contributed by Thierry
       Arnoux, 6-Dec-2017.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    psmetutop $p |- ( ( X =/= (/) /\ D e. ( PsMet ` X ) ) ->
      ( unifTop ` ( metUnif ` D ) ) = ( topGen ` ran ( ball ` D ) ) ) $=
      ( va vx vb vv vd ve cfv wcel wa cv wss wrex cima wceq syl wb cvv crp cuni
      wne cpsmet cmetu cutop cbl crn ctg wral cpw csn crab cust metuust utopval
      c0 eleq2d syl6bb biimpa simpld elpwid unirnblps ad2antlr sseqtr4d simp-5r
      rabid simplr ad3antrrr simpllr sseldd metustbl syl3anc sstr expcom anim2d
      simpr reximdv sylc simprd r19.21bi r19.29a ralrimiva jca fvex eltg2 ax-mp
      rnex a1i mpbird sseqtrd elpwg adantl ccnv cc0 cico co cmpt sselda syl2anc
      blssexps mpbid blval2 3expa sseq1d rexbidva syl21anc cnvexg imaexg imaeq1
      ralrimivw eqid rexrnmpt 3syl wi cxp cfg cfbas oveq2 imaeq2d cbvmptv rneqi
      metustfbas ssfg metuval ssrexv ad2antrr mpd biimpar syldan impbida eqrdv
      ) BUPUBZABUCIZJZKZCAUDIZUEIZAUFIZUGZUHIZYOCLZYQJZUUAYTJZYOUUBKZUUCUUAYSUA
      ZMZDLZELZJZUUHUUAMZKZEYSNZDUUAUIZKZUUDUUFUUMUUDUUABUUEUUDUUABUUDUUABUJZJZ
      FLZUUGUKZOZUUAMZFYPNZDUUAUIZYOUUBUUPUVBKZYOUUBUUAUVBCUUOULZJUVCYOYQUVDUUA
      YOYPBUMIJYQUVDPABUNDFYPBCUOQUQUVBCUUOVFURZUSZUTVAZYNUUEBPZYLUUBABVBZVCVDU
      UDUULDUUAUUDUUGUUAJZKZUUTUULFYPUVKUUQYPJZKZUUTKZUUTUUIUUHUUSMZKZEYSNZUULU
      VMUUTVPUVNYNUVLUUGBJZUVQYLYNUUBUVJUVLUUTVEUVKUVLUUTVGUVNUUABUUGUUDUUABMZU
      VJUVLUUTUVGVHUUDUVJUVLUUTVIVJAUUGUUQBEVKVLUUTUVPUUKEYSUUTUVOUUJUUIUVOUUTU
      UJUUHUUSUUAVMVNVOVQVRUUDUVADUUAUUDUUPUVBUVFVSVTWAWBWCUUCUUNRZUUDYSSJUVTYR
      AUFWDWGDEUUAYSSWEWFZWHWIYOUUCUVCUUBYOUUCKZUUPUVBUWBUUPUVSUWBUUAUUEBUWBUUF
      UUMYOUUCUUNUVTYOUWAWHUSZUTYNUVHYLUUCUVIVCWJZUUCUUPUVSRYOUUABYTWKWLWIUWBUV
      ADUUAUWBUVJKZUUTFGTAWMZWNGLZWOWPZOZWQZUGZNZUVAUWEUWLUWIUUROZUUAMZGTNZUWEY
      NUVRUUGUWGYRWPZUUAMZGTNZUWOYLYNUUCUVJVIZUWBUUABUUGUWDWRZUWEUULUWRUWBUULDU
      UAUWBUUFUUMUWCVSVTUWEYNUVRUULUWRRUWSUWTEUUAAUUGBGWTWSXAYNUVRKZUWRUWOUXAUW
      QUWNGTUXAUWGTJZKUWPUWMUUAYNUVRUXBUWPUWMPAUUGUWGBXBXCXDXEUSXFUWEYNUWISJZGT
      UIUWLUWORUWSYNUXCGTYNUWFSJUXCAYMXGUWFUWHSXHQXJUUTUWNGFTUWIUWJSUWJXKUUQUWI
      PUUSUWMUUAUUQUWIUURXIXDXLXMWIYOUWLUVAXNZUUCUVJYOUWKYPMUXDYOUWKBBXOZUWKXPW
      PZYPYOUWKUXEXQIJUWKUXFMAUWKBHUWJHTUWFWNHLZWOWPZOZWQGHTUWIUXIUWGUXGPUWHUXH
      UWFUWGUXGWNWOXRXSXTYAYBUWKUXEYCQYNYPUXFPYLABGYDWLVDUUTFUWKYPYEQYFYGWBWCYO
      UUBUVCUVEYHYIYJYK $.

    $( The topology induced by a uniform structure generated by an extended
       metric ` D ` is that metric's open sets.  (Contributed by Thierry
       Arnoux, 11-Mar-2018.) $)
    xmetutop $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) ->
      ( unifTop ` ( metUnif ` D ) ) = ( MetOpen ` D ) ) $=
      ( c0 wne cxmt cfv wcel wa cmetu cutop cbl crn cmopn cpsmet wceq xmetpsmet
      ctg psmetutop sylan2 eqid mopnval adantl eqtr4d ) BCDZABEFGZHAIFJFZAKFLQF
      ZAMFZUEUDABNFGUFUGOABPABRSUEUHUGOUDAUHBUHTUAUBUC $.
  $}

  ${
    xmsusp.x $e |- X = ( Base ` F ) $.
    xmsusp.d $e |- D = ( ( dist ` F ) |` ( X X. X ) ) $.
    xmsusp.u $e |- U = ( UnifSt ` F ) $.
    $( If the uniform set of a metric space is the uniform structure generated
       by its metric, then it is a uniform space.  (Contributed by Thierry
       Arnoux, 14-Dec-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    xmsuspOLD $p |- ( ( X =/= (/) /\ F e. *MetSp /\ U = ( metUnifOLD ` D ) )
      -> F e. UnifSp ) $=
      ( wne cxme wcel cmetuOLD cfv wceq w3a cust ctopn cutop 3ad2ant2 syl2anc
      c0 cusp simp3 cxmt simp1 xmsxmet metuustOLD eqeltrd cmopn metutopOLD eqid
      fveq2d xmstopn 3eqtr4rd isusp sylanbrc ) DTHZCIJZBAKLZMZNZBDOLZJCPLZBQLZM
      CUAJUTBURVAUPUQUSUBZUTUPADUCLJZURVAJUPUQUSUDZUQUPVEUSACDEFUERZADUFSUGUTUR
      QLZAUHLZVCVBUTUPVEVHVIMVFVGADUISUTBURQVDUKUQUPVBVIMUSAVBCDVBUJZEFULRUMDBV
      BCEGVJUNUO $.

    $( If the uniform set of a metric space is the uniform structure generated
       by its metric, then it is a uniform space.  (Contributed by Thierry
       Arnoux, 14-Dec-2017.) $)
    xmsusp $p |- ( ( X =/= (/) /\ F e. *MetSp /\ U = ( metUnif ` D ) )
      -> F e. UnifSp ) $=
      ( c0 wne cxme wcel cmetu cfv wceq w3a cust ctopn cutop 3ad2ant2 syl2anc
      cusp simp3 simp1 xmsxmet cpsmet xmetpsmet metuust sylan2 eqeltrd xmetutop
      cxmt cmopn fveq2d eqid xmstopn 3eqtr4rd isusp sylanbrc ) DHIZCJKZBALMZNZO
      ZBDPMZKCQMZBRMZNCUAKVCBVAVDUSUTVBUBZVCUSADUKMKZVAVDKZUSUTVBUCZUTUSVHVBACD
      EFUDSZVHUSADUEMKVIADUFADUGUHTUIVCVARMZAULMZVFVEVCUSVHVLVMNVJVKADUJTVCBVAR
      VGUMUTUSVEVMNVBAVECDVEUNZEFUOSUPDBVECEGVNUQUR $.
  $}

  ${
    $d a b u v w A $.  $d a b u v w D $.  $d a b u v w X $.
    $( The uniform structure generated by the restriction of a metric is its
       trace.  (Contributed by Thierry Arnoux, 18-Dec-2017.) $)
    restmetu $p |- ( ( A =/= (/) /\ D e. ( PsMet ` X ) /\ A C_ X ) ->
      ( ( metUnif ` D ) |`t ( A X. A ) ) = ( metUnif ` ( D |` ( A X. A ) ) )
      ) $=
      ( va vv vb vw c0 cfv wcel wss crp cv cin wceq syl2anc cvv wrex wa wb cres
      vu wne cpsmet w3a cxp ccnv cc0 cico co cima cmpt crn cfg crab cmetu crest
      cpw cfbas simp1 psmetres2 3adant1 oveq2 imaeq2d cbvmptv rneqi syl metuval
      metustfbas fgval fvex elfvexd xpexg restval sylancr inss2 mpbiri vex elpw
      sseq1 sylibr rexlimivw adantl nfre1 nfan nfmpt1 nfrn nfcri nfcv nfin nfne
      nfv simplr ineq1 cxr wfun simp2 psmetf ffun respreima 4syl ad6antr eqtr4d
      rspe inex1 eqid elrnmpt ax-mp simpllr ssinss1 a1i pweq eleq2d syl6bb ssin
      wf syl6bbr ad5antlr mpbir2and inelcm r19.29af2 ssn0 ancoms 3adant2 metuel
      sylib simplbda adantr r19.29a adantllr simpr cdif cun elpwid unssd eqeq2d
      rspcev eqsstr3d 3bitri wex r19.29af jca simprl simpl3 xpss12 sstrd difssd
      eqidd ad4antr cnvexg imaexg mpbird cdm cnvimass fdm syl5sseq 0ss syl6eqss
      ssdif0 ssundif difcom difdif2 sseq1i anbi1i ancom exbii n0 df-rex 3bitr4i
      elin biimpi ad2antll r19.29_2a indir incom eqtr3i uneq2i un0 3eqtri df-ss
      disjdif syl5req impbida ineq2d neeq1d elrab 3bitr4g eqrdv eqtrd 3eqtr4rd
      ) AHUCZBCUDIZJZACKZUEZAAUFZDLBUWPUAZUGZUHDMZUIUJZUKZULZUMZUNUJZUXCEMZURZN
      ZHUCZEUWPURZUOZUWQUPIZBUPIZUWPUQUJZUWOUXCUWPUSIJZUXDUXJOUWOUWKUWQAUDIJZUX
      NUWKUWMUWNUTUWMUWNUXOUWKBACVAVBZUWQUXCAFUXBFLUWRUHFMZUIUJZUKZULDFLUXAUXSU
      WSUXQOZUWTUXRUWRUWSUXQUHUIVCZVDVEZVFVIPEUXCUWPVJVGUWOUXOUXKUXDOUXPUWQADVH
      VGUWOUXMEUXLUXEUWPNZULZUMZUXJUWOUXLQJUWPQJZUXMUYEOBUPVKUWOAQJZUYGUYFUWOUW
      QUDAUXPVLZUYHAAQQVMPEUWPUXLQQVNVOUWOUBUYEUXJUWOUBMZUYCOZEUXLRZUYIUXIJZUXC
      UYIURZNZHUCZSZUYIUYEJZUYIUXJJUWOUYKUYPUWOUYKSZUYLUYOUYKUYLUWOUYJUYLEUXLUY
      JUYIUWPKZUYLUYJUYSUYCUWPKUXEUWPVPUYIUYCUWPVTVQUYIUWPUBVRZVSWAWBWCUYRUYJUY
      OEUXLUWOUYKEUWOEWLUYJEUXLWDWEUWOUXEUXLJZUYJUYOUYKUWOVUASZUYJSZGMZUXEKZUYO
      GDLBUGZUWTUKZULZUMZVUCVUDVUIJZSZVUESZVUDVUGOZUYODLVUKVUEDVUCVUJDVUCDWLDGV
      UIDVUHDLVUGWFWGWHWEVUEDWLWEDUYNHDUXCUYMDUXBDLUXAWFWGDUYMWIWJDHWIWKVULUWSL
      JZSZVUMSZVUDUWPNZUXCJZVUQUYMJZUYOVUPVUQUXAOZDLRZVURVUPVUNVUTVVAVULVUNVUMW
      MVUPVUQVUGUWPNZUXAVUMVUQVVBOVUOVUDVUGUWPWNWCUWOUXAVVBOZVUAUYJVUJVUEVUNVUM
      UWOUWMCCUFZWOBXPZBWPZVVCUWKUWMUWNWQZBCWRZVVDWOBWSZUWTUWPBWTXAXBXCVUTDLXDP
      VUQQJVURVVATVUDUWPGVRZXEZDLUXAVUQUXBQUXBXFXGXHWAVUPVUSVUQUXEKZVUQUWPKZVUP
      VUEVVLVUKVUEVUNVUMXIVUDUWPUXEXJVGVVMVUPVUDUWPVPXKUYJVUSVVLVVMSZTVUBVUJVUE
      VUNVUMUYJVUSVUQUYCKZVVNUYJVUSVUQUYCURZJVVOUYJUYMVVPVUQUYIUYCXLXMVUQUYCVVK
      VSXNVUQUXEUWPXOXQXRXSVUQUXCUYMXTPVULVUJVUMDLRZVUCVUJVUEWMVUDQJVUJVVQTVVJD
      LVUGVUDVUHQVUHXFZXGXHYFYAVUBVUEGVUIRZUYJUWOVUAUXEVVDKZVVSUWOCHUCZUWMVUAVV
      TVVSSTUWKUWNVWAUWMUWNUWKVWAACYBYCYDZVVGGBUXECDYEPYGYHYIYJUWOUYKYKUUAUUBUW
      OUYPSZUYIVVDUWPYLZYMZUXLJZUYIVWEUWPNZOZUYKVWCVWFVWEVVDKZVUDVWEKZGVUIRZVWC
      UYIVWDVVDVWCUYIUWPVVDVWCUYIUWPUWOUYLUYOUUCYNZVWCUWNUWNUWPVVDKUWKUWMUWNUYP
      UUDZVWMACACUUEPUUFVWCVVDUWPUUGYOVWCUXEUXSOZVWKEFUYMLVWCUXEUYMJZSZUXQLJZSZ
      VWNSZVUFUXRUKZVUIJZVWTVWEKZVWKVWSVXAVWTVUGOZDLRZVWSVWQVWTVWTOZVXDVWPVWQVW
      NWMVWSVWTUUHVXCVXEDUXQLUXTVUGVWTVWTUXTUWTUXRVUFUYAVDYPYQPVWSUWMVUFQJVWTQJ
      VXAVXDTUWOUWMUYPVWOVWQVWNVVGUUIZBUWLUUJVUFUXRQUUKDLVUGVWTVUHQVVRXGXAUULVW
      SVWTVVDYLZVWTUWPNZYMZUYIKZVXBVWSVXGVXHUYIVWSVXGHUYIVWSVWTVVDKZVXGHOVWSUWM
      VXKVXFUWMBUUMZVWTVVDBUXRUUNUWMVVEVXLVVDOVVHVVDWOBUUOVGUUPVGVWTVVDUUSYFUYI
      UUQUURVWSVXHUXSUYIVWSUWMVVEVVFUXSVXHOVXFVVHVVIUXRUWPBWTXAVWSUXSUXEUYIVWRV
      WNYKVWSUXEUYIVWCVWOVWQVWNXIYNYRYRYOVXBVWTUYIYLVWDKVWTVWDYLZUYIKVXJVWTUYIV
      WDUUTVWTUYIVWDUVAVXMVXIUYIVWTVVDUWPUVBUVCYSWAVWJVXBGVWTVUIVUDVWTVWEVTYQPU
      YOVWNFLRZEUYMRZUWOUYLUYOVXOUXEUYNJZEYTVWOVXNSZEYTUYOVXOVXPVXQEVXPUXEUXCJZ
      VWOSVXNVWOSVXQUXEUXCUYMUVJVXRVXNVWOUXEQJVXRVXNTEVRFLUXSUXEUXBQUYBXGXHUVDV
      XNVWOUVEYSUVFEUYNUVGVXNEUYMUVHUVIUVKUVLUVMVWCVWAUWMVWFVWIVWKSTUWOVWAUYPVW
      BYHUWOUWMUYPVVGYHGBVWECDYEPXSVWCVWGUYIUWPNZUYIVWGVXSVWDUWPNZYMVXSHYMVXSUY
      IVWDUWPUVNVXTHVXSUWPVWDNVXTHUWPVWDUVOUWPVVDUWAUVPUVQVXSUVRUVSVWCUYSVXSUYI
      OVWLUYIUWPUVTYFUWBUYJVWHEVWEUXLUXEVWEOUYCVWGUYIUXEVWEUWPWNYPYQPUWCUYIQJUY
      QUYKTUYTEUXLUYCUYIUYDQUYDXFXGXHUXHUYOEUYIUXIUXEUYIOZUXGUYNHVYAUXFUYMUXCUX
      EUYIXLUWDUWEUWFUWGUWHUWIUWJ $.
  $}

  ${
    $d a c d e u v x y C $.  $d b c d f u v x y D $.  $d c d u v x y F $.
    $d u v x y U $.  $d u v x V $.  $d a c d e u v x y X $.
    $d b c d f u v x y Y $.  $d c d u v x y ph $.
    metucnOLD.u $e |- U = ( metUnifOLD ` C ) $.
    metucnOLD.v $e |- V = ( metUnifOLD ` D ) $.
    metucnOLD.x $e |- ( ph -> X =/= (/) ) $.
    metucnOLD.y $e |- ( ph -> Y =/= (/) ) $.
    metucnOLD.c $e |- ( ph -> C e. ( *Met ` X ) ) $.
    metucnOLD.d $e |- ( ph -> D e. ( *Met ` Y ) ) $.
    $( Uniform continuity in metric spaces.  Compare the order of the
       quantifiers with ~ metcn .  (Contributed by Thierry Arnoux,
       26-Jan-2018.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    metucnOLD $p |- ( ph -> ( F e. ( U uCn V ) <-> ( F : X --> Y
      /\ A. d e. RR+ E. c e. RR+ A. x e. X A. y e. X
      ( ( x C y ) < c -> ( ( F ` x ) D ( F ` y ) ) < d ) ) ) ) $=
      ( wcel crp vu vv va vb ve vf cucn co wf cv wbr cfv wi wral ccnv cico cima
      cc0 cmpt crn wrex wa clt cxp cfg cmetuOLD cxmt wceq metuvalOLD syl syl5eq
      oveq12d eleq2d eqid c0 cust oveq2 imaeq2d cbvmptv rneqi metustOLD syl2anc
      wne cfbas metustfbasOLD isucn2 bitrd wb eqeq2d rspcev mpan2 adantl adantr
      metustelOLD mpbird biimpa simpr breqd ralbidv rexralbidv ralxfrd 2ralbidv
      imbi2d imbi1d rexxfrd cpsmet ad4antr xmetpsmet simplr simprr simprl elbl4
      cbl rpxr elbl3ps sylanl2 bitr3d syl22anc simpllr simp-4r ffvelrnd imbi12d
      cxr 2ralbidva rexbidva ralbidva pm5.32da ) AGFHUGUHZSZIJGUIZBUJZCUJZUAUJZ
      UKZYKGULZYLGULZUBUJZUKZUMZCIUNZBIUNUAUCTDUOZURUCUJZUPUHZUQZUSZUTZVAZUBUDT
      EUOZURUDUJZUPUHZUQZUSZUTZUNZVBZYJYKYLDUHKUJZVCUKZYOYPEUHLUJZVCUKZUMZCIUNB
      IUNZKTVAZLTUNZVBAYIGIIVDZUUFVEUHZJJVDZUUMVEUHZUGUHZSUUOAYHUVHGAFUVEHUVGUG
      AFDVFULZUVEMADIVGULSZUVIUVEVHQDIUCVIVJVKAHEVFULZUVGNAEJVGULSZUVKUVGVHREJU
      DVIVJVKVLVMABCUUFUUMUVEGUVGIJUBUAUVEVNUVGVNAIVOWCZUVJUVEIVPULSOQDUUFIKUUE
      KTUUAURUUPUPUHZUQZUSUCKTUUDUVOUUBUUPVHUUCUVNUUAUUBUUPURUPVQVRVSVTZWAWBAJV
      OWCZUVLUVGJVPULSPREUUMJLUULLTUUHURUURUPUHZUQZUSUDLTUUKUVSUUIUURVHUUJUVRUU
      HUUIUURURUPVQVRVSVTZWAWBAUVMUVJUUFUVDWDULSOQDUUFIUEUUEUETUUAURUEUJZUPUHZU
      QZUSUCUETUUDUWCUUBUWAVHUUCUWBUUAUUBUWAURUPVQVRVSVTZWEWBAUVQUVLUUMUVFWDULS
      PREUUMJUFUULUFTUUHURUFUJZUPUHZUQZUSUDUFTUUKUWGUUIUWEVHUUJUWFUUHUUIUWEURUP
      VQVRVSVTZWEWBWFWGAYJUUNUVCAYJVBZUUNYKYLUVOUKZYOYPUVSUKZUMZCIUNBIUNZKTVAZL
      TUNZUVCAUUNUWOWHYJAUUNYNUWKUMZCIUNZBIUNZUAUUFVAZLTUNUWOAUUGUWSUBLUVSUUMTA
      UURTSZVBUVSUUMSZUVSUWGVHZUFTVAZUWTUXCAUWTUVSUVSVHZUXCUVSVNUXBUXDUFUURTUWE
      UURVHZUWGUVSUVSUXEUWFUVRUUHUWEUURURUPVQVRWIWJWKWLAUXAUXCWHZUWTAUVLUXFRUVS
      EUUMJUFUWHWNVJWMWOAYQUUMSZYQUVSVHZLTVAZAUVLUXGUXIWHRYQEUUMJLUVTWNVJWPAUXH
      VBZYTUWQUABUUFIUXJYSUWPCIUXJYRUWKYNUXJYQUVSYOYPAUXHWQWRXCWSWTXAAUWSUWNLTA
      UWRUWMUAKUVOUUFTAUUPTSZVBUVOUUFSZUVOUWCVHZUETVAZUXKUXNAUXKUVOUVOVHZUXNUVO
      VNUXMUXOUEUUPTUWAUUPVHZUWCUVOUVOUXPUWBUVNUUAUWAUUPURUPVQVRWIWJWKWLAUXLUXN
      WHZUXKAUVJUXQQUVODUUFIUEUWDWNVJWMWOAYMUUFSZYMUVOVHZKTVAZAUVJUXRUXTWHQYMDU
      UFIKUVPWNVJWPAUXSVBZUWPUWLBCIIUYAYNUWJUWKUYAYMUVOYKYLAUXSWQWRXDXBXEWSWGWM
      UWIUWNUVBLTUWIUWTVBZUWMUVAKTUYBUXKVBZUWLUUTBCIIUYCYKISZYLISZVBZVBZUWJUUQU
      WKUUSUYGDIXFULSZUXKUYEUYDUWJUUQWHUYGUVJUYHAUVJYJUWTUXKUYFQXGDIXHVJUYBUXKU
      YFXIUYCUYDUYEXJZUYCUYDUYEXKZUYHUXKVBUYEUYDVBZVBYKYLUUPDXMULUHSZUWJUUQYLYK
      DUUPIXLUXKUYHUUPYCSUYKUYLUUQWHUUPXNYKDYLUUPIXOXPXQXRUYGEJXFULSZUWTYPJSZYO
      JSZUWKUUSWHUYGUVLUYMAUVLYJUWTUXKUYFRXGEJXHVJUWIUWTUXKUYFXSUYGIJYLGAYJUWTU
      XKUYFXTZUYIYAUYGIJYKGUYPUYJYAUYMUWTVBUYNUYOVBZVBYOYPUUREXMULUHSZUWKUUSYPY
      OEUURJXLUWTUYMUURYCSUYQUYRUUSWHUURXNYOEYPUURJXOXPXQXRYBYDYEYFWGYGWG $.
  $}

  ${
    $d a c d e u v x y C $.  $d b c d f u v x y D $.  $d c d u v x y F $.
    $d u v x y U $.  $d u v x V $.  $d a c d e u v x y X $.
    $d b c d f u v x y Y $.  $d c d u v x y ph $.
    metucn.u $e |- U = ( metUnif ` C ) $.
    metucn.v $e |- V = ( metUnif ` D ) $.
    metucn.x $e |- ( ph -> X =/= (/) ) $.
    metucn.y $e |- ( ph -> Y =/= (/) ) $.
    metucn.c $e |- ( ph -> C e. ( PsMet ` X ) ) $.
    metucn.d $e |- ( ph -> D e. ( PsMet ` Y ) ) $.
    $( Uniform continuity in metric spaces.  Compare the order of the
       quantifiers with ~ metcn .  (Contributed by Thierry Arnoux,
       26-Jan-2018.)  (Revised by Thierry Arnoux, 11-Feb-2018.) $)
    metucn $p |- ( ph -> ( F e. ( U uCn V ) <-> ( F : X --> Y
      /\ A. d e. RR+ E. c e. RR+ A. x e. X A. y e. X
      ( ( x C y ) < c -> ( ( F ` x ) D ( F ` y ) ) < d ) ) ) ) $=
      ( wcel crp vu vv va vb ve vf cucn co wf cv wbr cfv wi wral ccnv cico cima
      cc0 cmpt crn wrex wa clt cxp cfg cmetu cpsmet wceq metuval syl5eq oveq12d
      syl eleq2d eqid wne cust oveq2 imaeq2d cbvmptv rneqi metust syl2anc cfbas
      c0 metustfbas isucn2 bitrd wb eqeq2d rspcev adantl metustel adantr mpbird
      mpan2 biimpa simpr breqd imbi2d ralbidv rexralbidv ralxfrd imbi1d rexxfrd
      2ralbidv ad4antr simplr simprr simprl cbl cxr rpxr elbl3ps sylanl2 bitr3d
      syl22anc simpllr simp-4r ffvelrnd 2ralbidva rexbidva ralbidva pm5.32da
      elbl4 imbi12d ) AGFHUGUHZSZIJGUIZBUJZCUJZUAUJZUKZYIGULZYJGULZUBUJZUKZUMZC
      IUNZBIUNUAUCTDUOZURUCUJZUPUHZUQZUSZUTZVAZUBUDTEUOZURUDUJZUPUHZUQZUSZUTZUN
      ZVBZYHYIYJDUHKUJZVCUKZYMYNEUHLUJZVCUKZUMZCIUNBIUNZKTVAZLTUNZVBAYGGIIVDZUU
      DVEUHZJJVDZUUKVEUHZUGUHZSUUMAYFUVFGAFUVCHUVEUGAFDVFULZUVCMADIVGULSZUVGUVC
      VHQDIUCVIVLVJAHEVFULZUVENAEJVGULSZUVIUVEVHREJUDVIVLVJVKVMABCUUDUUKUVCGUVE
      IJUBUAUVCVNUVEVNAIWDVOZUVHUVCIVPULSOQDUUDIKUUCKTYSURUUNUPUHZUQZUSUCKTUUBU
      VMYTUUNVHUUAUVLYSYTUUNURUPVQVRVSVTZWAWBAJWDVOZUVJUVEJVPULSPREUUKJLUUJLTUU
      FURUUPUPUHZUQZUSUDLTUUIUVQUUGUUPVHUUHUVPUUFUUGUUPURUPVQVRVSVTZWAWBAUVKUVH
      UUDUVBWCULSOQDUUDIUEUUCUETYSURUEUJZUPUHZUQZUSUCUETUUBUWAYTUVSVHUUAUVTYSYT
      UVSURUPVQVRVSVTZWEWBAUVOUVJUUKUVDWCULSPREUUKJUFUUJUFTUUFURUFUJZUPUHZUQZUS
      UDUFTUUIUWEUUGUWCVHUUHUWDUUFUUGUWCURUPVQVRVSVTZWEWBWFWGAYHUULUVAAYHVBZUUL
      YIYJUVMUKZYMYNUVQUKZUMZCIUNBIUNZKTVAZLTUNZUVAAUULUWMWHYHAUULYLUWIUMZCIUNZ
      BIUNZUAUUDVAZLTUNUWMAUUEUWQUBLUVQUUKTAUUPTSZVBUVQUUKSZUVQUWEVHZUFTVAZUWRU
      XAAUWRUVQUVQVHZUXAUVQVNUWTUXBUFUUPTUWCUUPVHZUWEUVQUVQUXCUWDUVPUUFUWCUUPUR
      UPVQVRWIWJWOWKAUWSUXAWHZUWRAUVJUXDRUVQEUUKJUFUWFWLVLWMWNAYOUUKSZYOUVQVHZL
      TVAZAUVJUXEUXGWHRYOEUUKJLUVRWLVLWPAUXFVBZYRUWOUABUUDIUXHYQUWNCIUXHYPUWIYL
      UXHYOUVQYMYNAUXFWQWRWSWTXAXBAUWQUWLLTAUWPUWKUAKUVMUUDTAUUNTSZVBUVMUUDSZUV
      MUWAVHZUETVAZUXIUXLAUXIUVMUVMVHZUXLUVMVNUXKUXMUEUUNTUVSUUNVHZUWAUVMUVMUXN
      UVTUVLYSUVSUUNURUPVQVRWIWJWOWKAUXJUXLWHZUXIAUVHUXOQUVMDUUDIUEUWBWLVLWMWNA
      YKUUDSZYKUVMVHZKTVAZAUVHUXPUXRWHQYKDUUDIKUVNWLVLWPAUXQVBZUWNUWJBCIIUXSYLU
      WHUWIUXSYKUVMYIYJAUXQWQWRXCXEXDWTWGWMUWGUWLUUTLTUWGUWRVBZUWKUUSKTUXTUXIVB
      ZUWJUURBCIIUYAYIISZYJISZVBZVBZUWHUUOUWIUUQUYEUVHUXIUYCUYBUWHUUOWHAUVHYHUW
      RUXIUYDQXFUXTUXIUYDXGUYAUYBUYCXHZUYAUYBUYCXIZUVHUXIVBUYCUYBVBZVBYIYJUUNDX
      JULUHSZUWHUUOYJYIDUUNIYDUXIUVHUUNXKSUYHUYIUUOWHUUNXLYIDYJUUNIXMXNXOXPUYEU
      VJUWRYNJSZYMJSZUWIUUQWHAUVJYHUWRUXIUYDRXFUWGUWRUXIUYDXQUYEIJYJGAYHUWRUXIU
      YDXRZUYFXSUYEIJYIGUYLUYGXSUVJUWRVBUYJUYKVBZVBYMYNUUPEXJULUHSZUWIUUQYNYMEU
      UPJYDUWRUVJUUPXKSUYMUYNUUQWHUUPXLYMEYNUUPJXMXNXOXPYEXTYAYBWGYCWG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Examples of metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d u v w D $.  $d u v w V $.  $d u v w x y X $.
    dscmet.1 $e |- D = ( x e. X , y e. X |-> if ( x = y , 0 , 1 ) ) $.
    $( The discrete metric on any set ` X ` .  Definition 1.1-8 of [Kreyszig]
       p. 8.  (Contributed by FL, 12-Oct-2006.) $)
    dscmet $p |- ( X e. V -> D e. ( Met ` X ) ) $=
      ( vw vv vu wcel cv cc0 wceq weq cle wbr wa c1 ifbid cn0 cme cfv cxp cr wf
      co wb caddc wral cif 0re 1re keepel rgen2w mpbi equequ1 equequ2 0nn0 1nn0
      fmpt2 elexi ovmpt2 eqeq1d wn iffalse wne ax-1ne0 a1i eqnetrd neneqd con4i
      iftrue impbii syl6bb cn wo nn0addcli elnn0 breq1 0le1 leidi keephyp nnge1
      nn0rei letri sylancr nn0ge0i add20i mp2an bibi12d chvarv syl2anb syl6eqbr
      eqtr2 syl sylbi breqtrrd jaoi mp1i adantl ovmpt2a adantrr adantrl oveq12d
      id eqeq12 3brtr4d expcom ralrimiv jca rgen2a pm3.2i ismet mpbiri ) EDJCEU
      AUBJEEUCUDCUEZGKZHKZCUFZLMZGHNZUGZXRIKZXPCUFZYBXQCUFZUHUFZOPZIEUIZQZHEUIG
      EUIZQXOYIABNZLRUJZUDJZBEUIAEUIXOYLABEEYJLRUDUKULUMUNABEEYKUDCFUTUOYHGHEXP
      EJZXQEJZQZYAYGYOXSXTLRUJZLMZXTYOXRYPLABXPXQEEYKYPCGBNZLRUJAGNYJYRLRAGBUPS
      BHNZYRXTLRBHGUQSFYPTXTLRTURUSUMZVAVBZVCYQXTXTYQXTVDZYPLUUBYPRLXTLRVERLVFU
      UBVGVHVIVJVKXTLRVLZVMZVNYOYFIEYBEJZYOYFUUEYOQZYPIGNZLRUJZIHNZLRUJZUHUFZXR
      YEOUUKVOJZUUKLMZVPZYPUUKOPZUUFUUKTJUUNUUHUUJUUGLRTURUSUMZUUILRTURUSUMZVQZ
      UUKVRUOUULUUOUUMUULYPROPZRUUKOPUUOXTLROPRROPUUSLRLYPROVSRYPROVSVTRULWAWBU
      UKWCYPRUUKYPYTWDULUUKUURWDWEWFUUMYPLUUKOUUMUUHLMZUUJLMZQZYPLOPLUUHOPLUUJO
      PUUMUVBUGUUHUUPWGUUJUUQWGUUHUUJUUHUUPWDUUJUUQWDWHWIUVBYPLLOUVBXTYQUUTUUGU
      UIXTUVAUVAUUIUGZUUTUUGUGHGHGNZUVAUUTUUIUUGUVDUUJUUHLUVDUUIUUGLRHGIUQZSVCU
      VEWJYQXTUGUVCGIGINZYQUVAXTUUIUVFYPUUJLUVFXTUUILRGIHUPZSVCUVGWJUUDWKZWKUVH
      YBXPXQWNWLUUCWOLUKWAWMWPUUMXEWQWRWSYOXRYPMUUEUUAWTUUFYCUUHYDUUJUHUUEYMYCU
      UHMYNABYBXPEEYKUUHCAINZBGNQYJUUGLRAKZYBBKZXPXFSFUUHTUUPVAXAXBUUEYNYDUUJMY
      MABYBXQEEYKUUJCUVIYSQYJUUILRUVJYBUVKXQXFSFUUJTUUQVAXAXCXDXGXHXIXJXKXLGHID
      CEXMXN $.

    $( The discrete metric generates the discrete topology.  In particular, the
       discrete topology is metrizable.  (Contributed by Mario Carneiro,
       29-Jan-2014.) $)
    dscopn $p |- ( X e. V -> ( MetOpen ` D ) = ~P X ) $=
      ( vu vv vw wcel cfv cv wss wa wb c1 wceq clt wbr cc0 cmopn wrex wral cxmt
      cpw cbl crn cme dscmet metxmet syl elmopn simpll ssel2 adantll jca csn co
      eqid eleq1a wi simpl a1i cif eqeq12 ifbid cr 0re 1re keepel elexi ovmpt2a
      elsn breq1d ltnri iffalse mtbiri con4i iftrue 0lt1 syl6eqbr impbii equcom
      wn bitri syl6rbb simpr biantrurd bitrd pm5.21ndd adantl cxr crp 1rp ax-mp
      rpxr elbl mp3an3 sylan bitr4d syl5bb eqrdv blelrn eqeltrd snssi vex jctil
      ex snid eleq2 sseq1 anbi12d rspcev syl2an sylancom ralrimiva pm4.71d elpw
      syl6bbr ) EDJZGCUAKZEUEZXTGLZYAJZYCEMZYCYBJXTYDYEHLZILZJZYGYCMZNZICUFKZUG
      ZUBZHYCUCZNZYEXTCEUDKJZYDYOOXTCEUHKJYPABCDEFUICEUJUKZHIYCCYAEYAUSULUKXTYE
      YNXTYEYNXTYENZYMHYCYRYFYCJZXTYFEJZNZYMYRYSNXTYTXTYEYSUMYEYSYTXTYCEYFUNUOU
      PUUAYFUQZYLJYFUUBJZUUBYCMZNZYMYSUUAUUBYFPYKURZYLUUAIUUBUUFYGUUBJYGYFQZUUA
      YGUUFJZIYFVMUUAUUGYGEJZYFYGCURZPRSZNZUUHYTUUGUULOZXTYTUUIUUGUULYFEYGUTUUL
      UUIVAYTUUIUUKVBVCYTUUIUUMYTUUINZUUGUUKUULUUNUUKYFYGQZTPVDZPRSZUUGUUNUUJUU
      PPRABYFYGEEALZBLZQZTPVDUUPCUURYFQUUSYGQNUUTUUOTPUURYFUUSYGVEVFFUUPVGUUOTP
      VGVHVIVJVKVLVNUUQUUOUUGUUQUUOUUOUUQUUOWDZUUQPPRSPVIVOUVAUUPPPRUUOTPVPVNVQ
      VRUUOUUPTPRUUOTPVSVTWAWBHIWCWEWFUUNUUIUUKYTUUIWGWHWIXHWJWKXTYPYTUUHUULOZY
      QYPYTPWLJZUVBPWMJUVCWNPWPWOZYGCYFPEWQWRWSWTXAXBXTYPYTUUFYLJZYQYPYTUVCUVEU
      VDCYFPEXCWRWSXDYSUUDUUCYFYCXEYFHXFXIXGYJUUEIUUBYLYGUUBQYHUUCYIUUDYGUUBYFX
      JYGUUBYCXKXLXMXNXOXPXHXQWTYCEGXFXRXSXB $.
  $}

  ${
    $d a b c x y .- $.  $d x y .0. $.  $d a b c x y F $.  $d a b c x y ph $.
    $d a b c x y X $.
    nrmmetd.x $e |- X = ( Base ` G ) $.
    nrmmetd.m $e |- .- = ( -g ` G ) $.
    nrmmetd.z $e |- .0. = ( 0g ` G ) $.
    nrmmetd.g $e |- ( ph -> G e. Grp ) $.
    nrmmetd.f $e |- ( ph -> F : X --> RR ) $.
    nrmmetd.1 $e |- ( ( ph /\ x e. X ) -> ( ( F ` x ) = 0 <-> x = .0. ) ) $.
    nrmmetd.2 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( F ` ( x .- y ) ) <_ ( ( F ` x ) + ( F ` y ) ) ) $.
    $( Show that a group norm generates a metric.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    nrmmetd $p |- ( ph -> ( F o. .- ) e. ( Met ` X ) ) $=
      ( co wceq cle cfv wcel va vb vc cxp cr ccom wf cv cc0 wb caddc wbr wa cme
      wral cgrp grpsubf syl fco syl2anc cop opelxpi fvco3 syl2an fveq2i 3eqtr4g
      df-ov eqeq1d grpsubcl 3expb sylan ralrimiva fveq2 eqeq1 bibi12d grpsubeq0
      rspccva syldan 3bitrd adantrr ffvelrnd simprll syl3anc simprlr grpnnncan2
      adantr simprr readdcld syl13anc fveq2d oveq1 oveq1d breq12d oveq2 rspc2va
      ralrimivva oveq2d syl21anc eqbrtrrd anbi2d imbi12d grpidcl simprl cminusg
      eleq1 eqid grpinvval2 grpinvsub eqtr3d pm5.501 bicom syl6bb recnd addid2d
      wi bitr3d 3brtr3d chvarv adantrlr anbi1d adantrll le2addd oveq12d 3brtr4d
      eqtrd letrd expr ralrimiv jca cvv cbs fvex eqeltri ismet ax-mp sylanbrc )
      AGGUDZUEDFUFZUGZUAUHZUBUHZYRPZUIQZYTUUAQZUJZUUBUCUHZYTYRPZUUFUUAYRPZUKPZR
      ULZUCGUOZUMZUBGUOUAGUOZYRGUNSTZAGUEDUGZYQGFUGZYSMAEUPTZUUPLGEFIJUQURZYQGU
      EDFUSUTAUULUAUBGGAYTGTZUUAGTZUMZUMZUUEUUKUVBUUCYTUUAFPZDSZUIQZUVCHQZUUDUV
      BUUBUVDUIUVBYTUUAVAZYRSZUVGFSZDSZUUBUVDAUUPUVGYQTUVHUVJQUVAUURYTUUAGGVBYQ
      GUVGDFVCVDYTUUAYRVGUVCUVIDYTUUAFVGVEVFZVHAUVAUVCGTZUVEUVFUJZAUUQUVAUVLLUU
      QUUSUUTUVLGEFYTUUAIJVIVJVKZABUHZDSZUIQZUVOHQZUJZBGUOZUVLUVMAUVSBGNVLZUVSU
      VMBUVCGUVOUVCQZUVQUVEUVRUVFUWBUVPUVDUIUVOUVCDVMVHUVOUVCHVNVOVQVKVRAUUQUVA
      UVFUUDUJZLUUQUUSUUTUWCGEFYTUUAHIKJVPVJVKVSUVBUUJUCGAUVAUUFGTZUUJAUVAUWDUM
      ZUMZUVDUUFYTFPZDSZUUFUUAFPZDSZUKPZUUBUUIRUWFUVDYTUUFFPZDSZUUAUUFFPZDSZUKP
      ZUWKUWFGUEUVCDAUUOUWEMWFZAUVAUVLUWDUVNVTWAUWFUWMUWOUWFGUEUWLDUWQUWFUUQUUS
      UWDUWLGTZAUUQUWELWFZAUUSUUTUWDWBZAUVAUWDWGZGEFYTUUFIJVIWCZWAZUWFGUEUWNDUW
      QUWFUUQUUTUWDUWNGTZUWSAUUSUUTUWDWDZUXAGEFUUAUUFIJVIWCZWAZWHUWFUWHUWJUWFGU
      EUWGDUWQUWFUUQUWDUUSUWGGTUWSUXAUWTGEFUUFYTIJVIWCWAZUWFGUEUWIDUWQUWFUUQUWD
      UUTUWIGTUWSUXAUXEGEFUUFUUAIJVIWCWAZWHUWFUWLUWNFPZDSZUVDUWPRUWFUXJUVCDUWFU
      UQUUSUUTUWDUXJUVCQUWSUWTUXEUXAGEFYTUUAUUFIJWEWIWJUWFUWRUXDUVOCUHZFPZDSZUV
      PUXLDSZUKPZRULZCGUOBGUOZUXKUWPRULZUXBUXFAUXRUWEAUXQBCGGOWPZWFUXQUXSUWLUXL
      FPZDSZUWMUXOUKPZRULBCUWLUWNGGUVOUWLQZUXNUYBUXPUYCRUYDUXMUYADUVOUWLUXLFWKW
      JUYDUVPUWMUXOUKUVOUWLDVMWLWMUXLUWNQZUYBUXKUYCUWPRUYEUYAUXJDUXLUWNUWLFWNWJ
      UYEUXOUWOUWMUKUXLUWNDVMWQWMWOWRWSUWFUWMUWOUWHUWJUXCUXGUXHUXIAUUSUWDUWMUWH
      RULZUUTUVBUVDUUAYTFPZDSZRULZXOAUUSUWDUMZUMZUYFXOZUBUCUUAUUFQZUVBUYKUYIUYF
      UYMUVAUYJAUYMUUTUWDUUSUUAUUFGXEWTWTUYMUVDUWMUYHUWHRUYMUVCUWLDUUAUUFYTFWNW
      JUYMUYGUWGDUUAUUFYTFWKWJWMXAUVBHUYGFPZDSZHDSZUYHUKPZUVDUYHRUVBHGTZUYGGTZU
      XRUYOUYQRULZUVBUUQUYRAUUQUVALWFZGEHIKXBZURUVBUUQUUTUUSUYSVUAAUUSUUTWGZAUU
      SUUTXCZGEFUUAYTIJVIWCZAUXRUVAUXTWFUXQUYTHUXLFPZDSZUYPUXOUKPZRULBCHUYGGGUV
      RUXNVUGUXPVUHRUVRUXMVUFDUVOHUXLFWKWJUVRUVPUYPUXOUKUVOHDVMZWLWMUXLUYGQZVUG
      UYOVUHUYQRVUJVUFUYNDUXLUYGHFWNWJVUJUXOUYHUYPUKUXLUYGDVMWQWMWOWRUVBUYNUVCD
      UVBUYGEXDSZSZUYNUVCUVBUUQUYSVULUYNQVUAVUEGEFVUKUYGHIJVUKXFZKXGUTUVBUUQUUT
      UUSVULUVCQVUAVUCVUDGEFVUKUUAYTIJVUMXHWCXIWJUVBUYQUIUYHUKPUYHUVBUYPUIUYHUK
      AUYPUIQZUVAAUVTUYRVUNUWAAUUQUYRLVUBURUVSVUNBHGUVRUVQUVSVUNUVRUVQUVRUVQUJU
      VSUVRUVQXJUVRUVQXKXLUVRUVPUYPUIVUIVHXPVQUTWFWLUVBUYHUVBUYHUVBGUEUYGDAUUOU
      VAMWFVUEWAXMXNYEXQXRZXSAUUTUWDUWOUWJRULZUUSUYLAUUTUWDUMZUMZVUPXOUAUBUUDUY
      KVURUYFVUPUUDUYJVUQAUUDUUSUUTUWDYTUUAGXEXTWTUUDUWMUWOUWHUWJRUUDUWLUWNDYTU
      UAUUFFWKWJUUDUWGUWIDYTUUAUUFFWNWJWMXAVUOXRYAYBYFAUVAUUBUVDQUWDUVKVTUWFUUG
      UWHUUHUWJUKUWFUUFYTVAZYRSZVUSFSZDSZUUGUWHUWFUUPVUSYQTZVUTVVBQAUUPUWEUURWF
      ZUWFUWDUUSVVCUXAUWTUUFYTGGVBUTYQGVUSDFVCUTUUFYTYRVGUWGVVADUUFYTFVGVEVFUWF
      UUFUUAVAZYRSZVVEFSZDSZUUHUWJUWFUUPVVEYQTZVVFVVHQVVDUWFUWDUUTVVIUXAUXEUUFU
      UAGGVBUTYQGVVEDFVCUTUUFUUAYRVGUWIVVGDUUFUUAFVGVEVFYCYDYGYHYIWPGYJTUUNYSUU
      MUMUJGEYKSYJIEYKYLYMUAUBUCYJYRGYNYOYP $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y .- $.  $d x y R $.  $d x y X $.
    abvmet.x $e |- X = ( Base ` R ) $.
    abvmet.a $e |- A = ( AbsVal ` R ) $.
    abvmet.m $e |- .- = ( -g ` R ) $.
    $( An absolute value ` F ` generates a metric defined by
       ` d ( x , y ) = F ( x - y ) ` , analogously to ~ cnmet .  (In fact, the
       ring structure is not needed at all; the group properties ~ abveq0 and
       ~ abvtri , ~ abvneg are sufficient.)  (Contributed by Mario Carneiro,
       9-Sep-2014.)  (Revised by Mario Carneiro, 2-Oct-2015.) $)
    abvmet $p |- ( F e. A -> ( F o. .- ) e. ( Met ` X ) ) $=
      ( vx vy wcel c0g cfv eqid crg cgrp abvrcl rnggrp cv co syl abvf caddc cle
      abveq0 wbr abvsubtri 3expb nrmmetd ) CAKZIJCBDEBLMZFHUKNZUJBOKBPKABCGQBRU
      AAEBCGFUBAEBCISZUKGFULUEUJUMEKJSZEKUMUNDTCMUMCMUNCMUCTUDUFAEBCDUMUNGFHUGU
      HUI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Normed algebraic structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c norm $. $( Norm of a normed ring $)
  $c NrmGrp $. $( Normed group $)
  $c toNrmGrp $. $( norm + group = normed group $)
  $c NrmRing $. $( Normed ring $)
  $c NrmMod $. $( Normed module $)
  $c NrmVec $. $( Normed vector space $)

  $( Norm of a normed ring. $)
  cnm $a class norm $.

  $( The class of all normed groups. $)
  cngp $a class NrmGrp $.

  $( Make a normed group from a norm and a group. $)
  ctng $a class toNrmGrp $.

  $( Normed ring. $)
  cnrg $a class NrmRing $.

  $( Normed module. $)
  cnlm $a class NrmMod $.

  $( Normed vector space. $)
  cnvc $a class NrmVec $.

  ${
    $d f g w x y $.
    $( Define the norm on a group or ring (when it makes sense) in terms of the
       distance to zero.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    df-nm $a |- norm = ( w e. _V |-> ( x e. ( Base ` w ) |->
      ( x ( dist ` w ) ( 0g ` w ) ) ) ) $.

    $( Define a normed group, which is a group with a
       right-translation-invariant metric.  This is not a standard notion, but
       is helpful as the most general context in which a metric-like norm makes
       sense.  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    df-ngp $a |- NrmGrp = { g e. ( Grp i^i MetSp ) |
      ( ( norm ` g ) o. ( -g ` g ) ) C_ ( dist ` g ) } $.

    $( Define a function that fills in the topology and metric components of a
       structure given a group and a norm on it.  (Contributed by Mario
       Carneiro, 2-Oct-2015.) $)
    df-tng $a |- toNrmGrp = ( g e. _V , f e. _V |-> ( ( g
      sSet <. ( dist ` ndx ) , ( f o. ( -g ` g ) ) >. )
      sSet <. ( TopSet ` ndx ) , ( MetOpen ` ( f o. ( -g ` g ) ) ) >. ) ) $.

    $( A normed ring is a ring with an induced topology and metric such that
       the metric is translation-invariant and the norm (distance from 0) is an
       absolute value on the ring.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    df-nrg $a |- NrmRing = { w e. NrmGrp | ( norm ` w ) e. ( AbsVal ` w ) } $.

    $( A normed (left) module is a module which is also a normed group over a
       normed ring, such that the norm distributes over scalar multiplication.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    df-nlm $a |- NrmMod = { w e. ( NrmGrp i^i LMod )
      | [. ( Scalar ` w ) / f ].
      ( f e. NrmRing /\ A. x e. ( Base ` f ) A. y e. ( Base ` w )
        ( ( norm ` w ) ` ( x ( .s ` w ) y ) ) =
        ( ( ( norm ` f ) ` x ) x. ( ( norm ` w ) ` y ) ) ) } $.

    $( A normed vector space is a normed module which is also a vector space.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    df-nvc $a |- NrmVec = ( NrmMod i^i LVec ) $.
  $}

  ${
    $d x A $.  $d w x D $.  $d w x W $.  $d w x X $.  $d w x .0. $.
    nmfval.n $e |- N = ( norm ` W ) $.
    nmfval.x $e |- X = ( Base ` W ) $.
    nmfval.z $e |- .0. = ( 0g ` W ) $.
    nmfval.d $e |- D = ( dist ` W ) $.
    $( The value of the norm function.  (Contributed by Mario Carneiro,
       2-Oct-2015.) $)
    nmfval $p |- N = ( x e. X |-> ( x D .0. ) ) $=
      ( vw cnm cfv cmpt cvv wcel cbs cds syl6eqr c0 cv c0g fveq2 eqidd oveq123d
      co wceq mpteq12dv df-nm crn csn cun wf eqid cop df-ov fvrn0 eqeltri fmpti
      a1i fvex rnex p0ex unex fex2 mp3an fvmpt fvprc mpt0 syl5eq mpteq1d eqtr4d
      wn pm2.61i eqtri ) CDLMZAEAUAZFBUFZNZGDOPZVPVSUGKDAKUAZQMZVQWAUBMZWARMZUF
      ZNVSOLWADUGZAWBWEEVRWFWBDQMZEWADQUCHSWFVQVQWCFWDBWFWDDRMZBWADRUCJSWFVQUDW
      FWCDUBMFWADUBUCISUEUHAKUIEBUJZTUKZULZVSUMEOPWKOPVSOPAEWKVRVSVSUNVRWKPVQEP
      VRVQFUOZBMWKVQFBUPBWLUQURUTUSEWGOHDQVAURWIWJBBWHOJDRVAURVBVCVDEWKVSOOVEVF
      VGVTVMZVPATVRNZVSWMVPTWNDLVHAVRVISWMAETVRWMEWGTHDQVHVJVKVLVNVO $.

    $( The value of the norm function.  (Contributed by Mario Carneiro,
       2-Oct-2015.) $)
    nmval $p |- ( A e. X -> ( N ` A ) = ( A D .0. ) ) $=
      ( vx cv co oveq1 nmfval ovex fvmpt ) KAKLZFBMAFBMECRAFBNKBCDEFGHIJOAFBPQ
      $.

    nmfval.e $e |- E = ( D |` ( X X. X ) ) $.
    $( The value of the norm function using a restricted metric.  (Contributed
       by Mario Carneiro, 2-Oct-2015.) $)
    nmfval2 $p |- ( W e. Grp -> N = ( x e. X |-> ( x E .0. ) ) ) $=
      ( cgrp wcel cv co cmpt nmfval wa cxp cres wceq id grpidcl syl2anr syl5req
      oveqi ovres mpteq2dva syl5eq ) EMNZDAFAOZGBPZQAFULGCPZQABDEFGHIJKRUKAFUMU
      NUKULFNZSUNULGBFFTUAZPZUMCUPULGLUGUOUOGFNUQUMUBUKUOUCFEGIJUDULGFFBUHUEUFU
      IUJ $.

    $( The value of the norm function using a restricted metric.  (Contributed
       by Mario Carneiro, 2-Oct-2015.) $)
    nmval2 $p |- ( ( W e. Grp /\ A e. X ) -> ( N ` A ) = ( A E .0. ) ) $=
      ( cgrp wcel wa cfv co wceq nmval adantl cxp cres oveqi id grpidcl syl2anr
      ovres syl5req eqtrd ) EMNZAFNZOZADPZAGBQZAGCQZUKUMUNRUJABDEFGHIJKSTULUOAG
      BFFUAUBZQZUNCUPAGLUCUKUKGFNUQUNRUJUKUDFEGIJUEAGFFBUGUFUHUI $.
  $}

  ${
    $d x D $.  $d x E $.  $d x W $.  $d x X $.
    nmf2.n $e |- N = ( norm ` W ) $.
    nmf2.x $e |- X = ( Base ` W ) $.
    nmf2.d $e |- D = ( dist ` W ) $.
    nmf2.e $e |- E = ( D |` ( X X. X ) ) $.
    $( The norm is a function from the base set into the reals.  (Contributed
       by Mario Carneiro, 2-Oct-2015.) $)
    nmf2 $p |- ( ( W e. Grp /\ E e. ( Met ` X ) ) -> N : X --> RR ) $=
      ( vx cgrp wcel cme cfv wa cr wf cv c0g eqid co cmpt grpidcl metcl syl3an1
      3comr 3expa fmptd wceq nmfval2 adantr feq1d mpbird ) DKLZBEMNLZOZEPCQEPJE
      JRZDSNZBUAZUBZQUPJEUSPUTUNUOUQELZUSPLZUNURELZUOVAVBEDURGURTZUCUOVAVCVBUQU
      RBEUDUFUEUGUTTUHUPEPCUTUNCUTUIUOJABCDEURFGVDHIUJUKULUM $.
  $}

  ${
    $d x y K $.  $d x y L $.  $d x y ph $.
    nmpropd.1 $e |- ( ph -> ( Base ` K ) = ( Base ` L ) ) $.
    nmpropd.2 $e |- ( ph -> ( +g ` K ) = ( +g ` L ) ) $.
    nmpropd.3 $e |- ( ph -> ( dist ` K ) = ( dist ` L ) ) $.
    $( Weak property deduction for a norm.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    nmpropd $p |- ( ph -> ( norm ` K ) = ( norm ` L ) ) $=
      ( vx vy cbs cfv cv c0g cds co cmpt cnm eqidd wcel cplusg eqid wa proplem3
      grpidpropd oveq123d mpteq12dv nmfval 3eqtr4g ) AGBIJZGKZBLJZBMJZNZOGCIJZU
      ICLJZCMJZNZOBPJZCPJZAGUHULUMUPDAUIUIUJUNUKUOFAUIQAGHUHBCAUHQDAUIUHRHKUHRU
      AGHBSJCSJEUBUCUDUEGUKUQBUHUJUQTUHTUJTUKTUFGUOURCUMUNURTUMTUNTUOTUFUG $.
  $}

  ${
    $d x y B $.  $d a x y K $.  $d a x y L $.  $d a x y ph $.
    nmpropd2.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    nmpropd2.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    nmpropd2.3 $e |- ( ph -> K e. Grp ) $.
    nmpropd2.4 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    nmpropd2.5 $e |- ( ph ->
      ( ( dist ` K ) |` ( B X. B ) ) = ( ( dist ` L ) |` ( B X. B ) ) ) $.
    $( Strong property deduction for a norm.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    nmpropd2 $p |- ( ph -> ( norm ` K ) = ( norm ` L ) ) $=
      ( va cbs cfv c0g cds cxp cres eqtr3d eqid cv co cnm xpeq12d reseq2d eqidd
      cmpt grpidpropd oveq123d mpteq12dv cgrp wcel nmfval2 syl grppropd 3eqtr4d
      wceq mpbid ) ALEMNZLUAZEONZEPNZUSUSQZRZUBZUGZLFMNZUTFONZFPNZVGVGQZRZUBZUG
      ZEUCNZFUCNZALUSVEVGVLADUSVGGHSAUTUTVAVHVDVKAVIDDQZRZVDVKAVBVPRVQVDKAVPVCV
      BADUSDUSGGUDUESAVPVJVIADVGDVGHHUDUESAUTUFABCDEFGHJUHUIUJAEUKULZVNVFUQILVB
      VDVNEUSVAVNTUSTVATVBTVDTUMUNAFUKULZVOVMUQAVRVSIABCDEFGHJUOURLVIVKVOFVGVHV
      OTVGTVHTVITVKTUMUNUP $.
  $}

  ${
    $d g x y D $.  $d g x y G $.  $d g x y .- $.  $d g x y N $.  $d x y X $.
    isngp.n $e |- N = ( norm ` G ) $.
    isngp.z $e |- .- = ( -g ` G ) $.
    isngp.d $e |- D = ( dist ` G ) $.
    $( The property of being a normed group.  (Contributed by Mario Carneiro,
       2-Oct-2015.) $)
    isngp $p |- ( G e. NrmGrp <->
      ( G e. Grp /\ G e. MetSp /\ ( N o. .- ) C_ D ) ) $=
      ( vg cgrp cmt wcel ccom wss wa cnm cfv csg cds fveq2 syl6eqr cin cngp w3a
      elin anbi1i cv wceq coeq12d sseq12d df-ngp elrab2 df-3an 3bitr4i ) BIJUAZ
      KZDCLZAMZNBIKZBJKZNZUQNBUBKURUSUQUCUOUTUQBIJUDUEHUFZOPZVAQPZLZVARPZMUQHBU
      NUBVABUGZVDUPVEAVFVBDVCCVFVBBOPDVABOSETVFVCBQPCVABQSFTUHVFVEBRPAVABRSGTUI
      HUJUKURUSUQULUM $.

    isngp2.x $e |- X = ( Base ` G ) $.
    ${
      isngp2.e $e |- E = ( D |` ( X X. X ) ) $.
      $( The property of being a normed group.  (Contributed by Mario Carneiro,
         2-Oct-2015.) $)
      isngp2 $p |- ( G e. NrmGrp <->
        ( G e. Grp /\ G e. MetSp /\ ( N o. .- ) = E ) ) $=
        ( wcel wss wceq wa cres cr wf syl cvv cngp cgrp cmt w3a isngp cxp resss
        ccom eqsstri sseq1 mpbiri cdm cme cfv reseq1i eqtri msmet sylan2 adantr
        cds nmf2 grpsubf ad2antrr fco syl2anc fdm reseq2d wfun msf ad2antlr cin
        simpr ssv fss sylancl fssxp ssind df-res syl6sseqr funssres wfn fnresdm
        ffun ffn 3syl 3eqtr3d ex impbid2 pm5.32i df-3an 3bitr4i bitr4i ) CUALCU
        BLZCUCLZEDUHZAMZUDZWMWNWOBNZUDZACDEGHIUEWMWNOZWROWTWPOZWSWQWTWRWPWTWRWP
        WRWPBAMBAFFUFZPZAKAXBUGUIWOBAUJUKWTWPWRXABWOULZPZBXBPZWOBXAXDXBBXAXBQWO
        RZXDXBNXAFQERZXBFDRZXGWTXHWPWNWMBFUMUNLXHBCFJBXCCUTUNZXBPKAXJXBIUOUPZUQ
        ABECFGJIKVAURUSWMXIWNWPFCDJHVBVCXBFQEDVDVEZXBQWOVFSVGXABVHZWOBMXEWONXAX
        BQBRZXMWNXNWMWPBCFJXKVIVJZXBQBWCSXAWOAXBTUFZVKZBXAWOAXPWTWPVLXAXBTWORZW
        OXPMXAXGQTMXRXLQVMXBQTWOVNVOXBTWOVPSVQBXCXQKAXBVRUPVSBWOVTVEXAXNBXBWAXF
        BNXOXBQBWDXBBWBWEWFWGWHWIWMWNWRWJWMWNWPWJWKWL $.
    $}

    $( The property of being a normed group.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    isngp3 $p |- ( G e. NrmGrp <-> ( G e. Grp /\ G e. MetSp /\
      A. x e. X A. y e. X ( x D y ) = ( N ` ( x .- y ) ) ) ) $=
      ( wcel wceq w3a co cfv wral wa cr wf cngp cgrp cmt ccom cxp cres eqid wfn
      cv isngp2 wb cme msmet2 nmf2 sylan2 grpsubf adantr fco syl2anc ffn adantl
      syl metf 3syl eqfnov2 cop opelxpi fvco3 syl2an df-ov fveq2i 3eqtr4g ovres
      eqeq12d eqcom syl6bb 2ralbidva bitrd pm5.32i df-3an 3bitr4i bitri ) DUALD
      UBLZDUCLZFEUDZCGGUEZUFZMZNZWCWDAUIZBUIZCOZWJWKEOZFPZMZBGQAGQZNZCWGDEFGHIJ
      KWGUGZUJWCWDRZWHRWSWPRWIWQWSWHWPWSWHWJWKWEOZWJWKWGOZMZBGQAGQZWPWSWEWFUHZW
      GWFUHZWHXCUKWSWFSWETZXDWSGSFTZWFGETZXFWDWCWGGULPLZXGCDGKJUMZCWGFDGHKJWRUN
      UOWCXHWDGDEKIUPUQZWFGSFEURUSWFSWEUTVBWSXIWFSWGTXEWDXIWCXJVAWGGVCWFSWGUTVD
      ABGGWEWGVEUSWSXBWOABGGWSWJGLWKGLRZRZXBWNWLMWOXMWTWNXAWLXMWJWKVFZWEPZXNEPZ
      FPZWTWNWSXHXNWFLXOXQMXLXKWJWKGGVGWFGXNFEVHVIWJWKWEVJWMXPFWJWKEVJVKVLXLXAW
      LMWSWJWKGGCVMVAVNWNWLVOVPVQVRVSWCWDWHVTWCWDWPVTWAWB $.
  $}

  $( A normed group is a group.  (Contributed by Mario Carneiro,
     2-Oct-2015.) $)
  ngpgrp $p |- ( G e. NrmGrp -> G e. Grp ) $=
    ( cngp wcel cgrp cmt cnm cfv csg ccom cds wss eqid isngp simp1bi ) ABCADCAE
    CAFGZAHGZIAJGZKQAPOOLPLQLMN $.

  $( A normed group is a metric space.  (Contributed by Mario Carneiro,
     2-Oct-2015.) $)
  ngpms $p |- ( G e. NrmGrp -> G e. MetSp ) $=
    ( cngp wcel cgrp cmt cnm cfv csg ccom cds wss eqid isngp simp2bi ) ABCADCAE
    CAFGZAHGZIAJGZKQAPOOLPLQLMN $.

  $( A normed group is a metric space.  (Contributed by Mario Carneiro,
     2-Oct-2015.) $)
  ngpxms $p |- ( G e. NrmGrp -> G e. *MetSp ) $=
    ( cngp wcel cmt cxme ngpms msxms syl ) ABCADCAECAFAGH $.

  $( A normed group is a topological space.  (Contributed by Mario Carneiro,
     5-Oct-2015.) $)
  ngptps $p |- ( G e. NrmGrp -> G e. TopSp ) $=
    ( cngp wcel cmt ctps ngpms mstps syl ) ABCADCAECAFAGH $.

  ${
    ngpds.n $e |- N = ( norm ` G ) $.
    ngpds.x $e |- X = ( Base ` G ) $.
    ngpds.m $e |- .- = ( -g ` G ) $.
    ngpds.d $e |- D = ( dist ` G ) $.
    $( Value of the distance function in terms of the norm of a normed group.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ngpds $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
      ( A D B ) = ( N ` ( A .- B ) ) ) $=
      ( cngp wcel w3a co cfv wceq 3ad2ant1 3adant1 df-ov ccom cxp cres cgrp cmt
      eqid isngp2 simp3bi oveqd cop wf ngpgrp grpsubf syl opelxpi fvco3 syl2anc
      fveq2i 3eqtr4g ovres 3eqtr3rd ) DLMZAGMZBGMZNZABFEUAZOZABCGGUBZUCZOZABEOZ
      FPZABCOZVEVFVIABVBVCVFVIQZVDVBDUDMZDUEMVNCVIDEFGHJKIVIUFUGUHRUIVEABUJZVFP
      ZVPEPZFPZVGVLVEVHGEUKZVPVHMZVQVSQVBVCVTVDVBVOVTDULGDEIJUMUNRVCVDWAVBABGGU
      OSVHGVPFEUPUQABVFTVKVRFABETURUSVCVDVJVMQVBABGGCUTSVA $.

    $( Value of the distance function in terms of the norm of a normed group.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ngpdsr $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
      ( A D B ) = ( N ` ( B .- A ) ) ) $=
      ( cngp wcel w3a co cfv cxme wceq ngpxms xmssym syl3an1 ngpds 3com23 eqtrd
      ) DLMZAGMZBGMZNABCOZBACOZBAEOFPZUEDQMUFUGUHUIRDSABCDGIKTUAUEUGUFUIUJRBACD
      EFGHIJKUBUCUD $.
  $}

  ${
    ngpds2.x $e |- X = ( Base ` G ) $.
    ngpds2.z $e |- .0. = ( 0g ` G ) $.
    ngpds2.m $e |- .- = ( -g ` G ) $.
    ngpds2.d $e |- D = ( dist ` G ) $.
    $( Write the distance between two points in terms of distance from zero.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ngpds2 $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
      ( A D B ) = ( ( A .- B ) D .0. ) ) $=
      ( cngp wcel w3a co cnm cfv eqid ngpds wceq cgrp ngpgrp grpsubcl nmval syl
      syl3an1 eqtrd ) DLMZAFMZBFMZNZABCOABEOZDPQZQZULGCOZABCDEUMFUMRZHJKSUKULFM
      ZUNUOTUHDUAMUIUJUQDUBFDEABHJUCUFULCUMDFGUPHIKUDUEUG $.

    $( Write the distance between two points in terms of distance from zero.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ngpds2r $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
      ( A D B ) = ( ( B .- A ) D .0. ) ) $=
      ( cngp wcel w3a co cxme wceq ngpxms xmssym syl3an1 ngpds2 3com23 eqtrd )
      DLMZAFMZBFMZNABCOZBACOZBAEOGCOZUDDPMUEUFUGUHQDRABCDFHKSTUDUFUEUHUIQBACDEF
      GHIJKUAUBUC $.

    $( Write the distance between two points in terms of distance from zero.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ngpds3 $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
      ( A D B ) = ( .0. D ( A .- B ) ) ) $=
      ( cngp wcel w3a co ngpds2 cxme wceq ngpxms 3ad2ant1 cgrp grpsubcl syl3an1
      ngpgrp grpidcl syl xmssym syl3anc eqtrd ) DLMZAFMZBFMZNZABCOABEOZGCOZGUNC
      OZABCDEFGHIJKPUMDQMZUNFMZGFMZUOUPRUJUKUQULDSTUJDUAMZUKULURDUDZFDEABHJUBUC
      UMUTUSUJUKUTULVATFDGHIUEUFUNGCDFHKUGUHUI $.

    $( Write the distance between two points in terms of distance from zero.
       (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    ngpds3r $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
      ( A D B ) = ( .0. D ( B .- A ) ) ) $=
      ( cngp wcel w3a co cxme wceq ngpxms xmssym syl3an1 ngpds3 3com23 eqtrd )
      DLMZAFMZBFMZNABCOZBACOZGBAEOCOZUDDPMUEUFUGUHQDRABCDFHKSTUDUFUEUHUIQBACDEF
      GHIJKUAUBUC $.
  $}

  ${
    ngprcan.x $e |- X = ( Base ` G ) $.
    ngprcan.p $e |- .+ = ( +g ` G ) $.
    ngprcan.d $e |- D = ( dist ` G ) $.
    $( Cancel right addition inside a distance calculation.  (Contributed by
       Mario Carneiro, 2-Oct-2015.) $)
    ngprcan $p |- ( ( G e. NrmGrp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A .+ C ) D ( B .+ C ) ) = ( A D B ) ) $=
      ( cngp wcel w3a co cfv wceq eqid grpcl syl3anc ngpds wa ngpgrp grppnpcan2
      csg cnm cgrp sylan fveq2d simpl adantr simpr1 simpr3 simpr2 3eqtr4d ) FKL
      ZAGLZBGLZCGLZMZUAZACENZBCENZFUDOZNZFUEOZOZABVCNZVEOZVAVBDNZABDNZUTVDVGVEU
      OFUFLZUSVDVGPFUBZGEFVCABCHIVCQZUCUGUHUTUOVAGLZVBGLZVIVFPUOUSUIZUTVKUPURVN
      UOVKUSVLUJZUOUPUQURUKZUOUPUQURULZGEFACHIRSUTVKUQURVOVQUOUPUQURUMZVSGEFBCH
      IRSVAVBDFVCVEGVEQZHVMJTSUTUOUPUQVJVHPVPVRVTABDFVCVEGWAHVMJTSUN $.

    $( Cancel left addition inside a distance calculation.  (Contributed by
       Mario Carneiro, 2-Oct-2015.) $)
    ngplcan $p |- ( ( ( G e. NrmGrp /\ G e. Abel ) /\
        ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( C .+ A ) D ( C .+ B ) ) = ( A D B ) ) $=
      ( cngp wcel cabel wa w3a co wceq simplr ablcom syl3anc oveq12d ngprcan
      simpr3 simpr1 simpr2 adantlr eqtrd ) FKLZFMLZNZAGLZBGLZCGLZOZNZCAEPZCBEPZ
      DPACEPZBCEPZDPZABDPZUOUPURUQUSDUOUIUMUKUPURQUHUIUNRZUJUKULUMUCZUJUKULUMUD
      GEFCAHISTUOUIUMULUQUSQVBVCUJUKULUMUEGEFCBHISTUAUHUNUTVAQUIABCDEFGHIJUBUFU
      G $.

    $d x y z D $.  $d x y z G $.  $d z .+ $.  $d x y z X $.
    $( Express the property of being a normed group purely in terms of
       right-translation invariance of the metric instead of using the
       definition of norm (which itself uses the metric).  (Contributed by
       Mario Carneiro, 29-Oct-2015.) $)
    isngp4 $p |- ( G e. NrmGrp <-> ( G e. Grp /\ G e. MetSp /\
   A. x e. X A. y e. X A. z e. X ( ( x .+ z ) D ( y .+ z ) ) = ( x D y ) ) ) $=
      ( wcel cv co wceq wral cfv wa wi eqid ad2ant2rl cngp cmt w3a ngpgrp ngpms
      cgrp ngprcan ralrimivvva csg cnm simp1 simp2 cminusg grpinvcl eqcom oveq2
      3jca oveq12d eqeq2d syl5bb rspcv syl c0g grpsubval adantl eqcomd grpsubcl
      grprinv 3expb adantlr nmval eqtr4d sylibd anassrs 3impia isngp3 syl3anbrc
      ralimdva impbii ) FUAKZFUFKZFUBKZALZCLZEMZBLZWDEMZDMZWCWFDMZNZCGOZBGOZAGO
      ZUCZVTWAWBWMFUDFUEVTWJABCGGGWCWFWDDEFGHIJUGUHUQWNWAWBWIWCWFFUIPZMZFUJPZPZ
      NZBGOZAGOZVTWAWBWMUKWAWBWMULWAWBWMXAWAWBQZWLWTAGXBWCGKZQWKWSBGXBXCWFGKZWK
      WSRXBXCXDQZQZWKWIWCWFFUMPZPZEMZWFXHEMZDMZNZWSXFXHGKZWKXLRWAXDXMWBXCGFXGWF
      HXGSZUNTWJXLCXHGWJWIWHNWDXHNZXLWHWIUOXOWHXKWIXOWEXIWGXJDWDXHWCEUPWDXHWFEU
      PURUSUTVAVBXFXKWRWIXFXKWPFVCPZDMZWRXFXIWPXJXPDXFWPXIXEWPXINXBGEFXGWOWCWFH
      IXNWOSZVDVEVFWAXDXJXPNWBXCGEFXGWFXPHIXPSZXNVHTURXFWPGKZWRXQNWAXEXTWBWAXCX
      DXTGFWOWCWFHXRVGVIVJWPDWQFGXPWQSZHXSJVKVBVLUSVMVNVRVRVOABDFWOWQGYAXRJHVPV
      QVS $.
  $}

  ${
    ngpinvds.x $e |- X = ( Base ` G ) $.
    ngpinvds.i $e |- I = ( invg ` G ) $.
    ngpinvds.d $e |- D = ( dist ` G ) $.
    $( Two elements are the same distance apart as their inverses.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    ngpinvds $p |- ( ( ( G e. NrmGrp /\ G e. Abel ) /\ ( A e. X /\ B e. X ) )
      -> ( ( I ` A ) D ( I ` B ) ) = ( A D B ) ) $=
      ( cngp wcel cabel wa cfv co eqid wceq grpinvcl syl2anc syl3anc csg simplr
      cnm simprr simprl ablsub2inv fveq2d simpll cgrp ngpgrp syl ngpdsr 3eqtr4d
      ngpds ) DJKZDLKZMZAFKZBFKZMZMZBENZAENZDUANZOZDUCNZNZABVDOZVFNZVCVBCOZABCO
      ZVAVEVHVFVAFDVDEBAGVDPZHUOUPUTUBUQURUSUDZUQURUSUEZUFUGVAUOVCFKZVBFKZVJVGQ
      UOUPUTUHZVADUIKZURVOVAUOVRVQDUJUKZVNFDEAGHRSVAVRUSVPVSVMFDEBGHRSVCVBCDVDV
      FFVFPZGVLIULTVAUOURUSVKVIQVQVNVMABCDVDVFFVTGVLIUNTUM $.
  $}

  ${
    ngpsubcan.x $e |- X = ( Base ` G ) $.
    ngpsubcan.m $e |- .- = ( -g ` G ) $.
    ngpsubcan.d $e |- D = ( dist ` G ) $.
    $( Cancel right subtraction inside a distance calculation.  (Contributed by
       Mario Carneiro, 4-Oct-2015.) $)
    ngpsubcan $p |- ( ( G e. NrmGrp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A .- C ) D ( B .- C ) ) = ( A D B ) ) $=
      ( cngp wcel w3a wa co cfv wceq eqid grpsubval syl2anc cplusg simpr1 simpl
      cminusg simpr3 simpr2 oveq12d cgrp ngpgrp grpinvcl ngprcan syl13anc eqtrd
      adantr ) EKLZAGLZBGLZCGLZMZNZACFOZBCFOZDOACEUDPZPZEUAPZOZBVDVEOZDOZABDOZU
      TVAVFVBVGDUTUPURVAVFQUOUPUQURUBZUOUPUQURUEZGVEEVCFACHVERZVCRZISTUTUQURVBV
      GQUOUPUQURUFZVKGVEEVCFBCHVLVMISTUGUTUOUPUQVDGLZVHVIQUOUSUCVJVNUTEUHLZURVO
      UOVPUSEUIUNVKGEVCCHVMUJTABVDDVEEGHVLJUKULUM $.
  $}

  ${
    nmf.x $e |- X = ( Base ` G ) $.
    nmf.n $e |- N = ( norm ` G ) $.
    $( The norm on a normed group is a function into the reals.  (Contributed
       by Mario Carneiro, 4-Oct-2015.) $)
    nmf $p |- ( G e. NrmGrp -> N : X --> RR ) $=
      ( cngp wcel cgrp cds cfv cxp cres cme cr wf ngpgrp cmt ngpms eqid msmet
      syl nmf2 syl2anc ) AFGZAHGAIJZCCKLZCMJGZCNBOAPUDAQGUGARUFACDUFSZTUAUEUFBA
      CEDUESUHUBUC $.

    $( The norm of a normed group is closed in the reals.  (Contributed by
       Mario Carneiro, 4-Oct-2015.) $)
    nmcl $p |- ( ( G e. NrmGrp /\ A e. X ) -> ( N ` A ) e. RR ) $=
      ( cngp wcel cr nmf ffvelrnda ) BGHDIACBCDEFJK $.

    $( The norm of a normed group is nonnegative.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    nmge0 $p |- ( ( G e. NrmGrp /\ A e. X ) -> 0 <_ ( N ` A ) ) $=
      ( cngp wcel wa cc0 c0g cfv cds co cle wbr cgrp ngpgrp eqid grpidcl adantr
      syl cxme ngpxms xmsge0 syl3an1 mpd3an3 wceq nmval adantl breqtrrd ) BGHZA
      DHZIJABKLZBMLZNZACLZOULUMUNDHZJUPOPZULURUMULBQHURBRDBUNEUNSZTUBUAULBUCHUM
      URUSBUDAUNUOBDEUOSZUEUFUGUMUQUPUHULAUOCBDUNFEUTVAUIUJUK $.

    ${
      nmeq0.z $e |- .0. = ( 0g ` G ) $.
      $( The identity is the only element of the group with zero norm.
         (Contributed by Mario Carneiro, 4-Oct-2015.) $)
      nmeq0 $p |- ( ( G e. NrmGrp /\ A e. X ) ->
                     ( ( N ` A ) = 0 <-> A = .0. ) ) $=
        ( cngp wcel wa cfv cc0 wceq cds co eqid nmval adantl eqeq1d cgrp ngpgrp
        wb adantr grpidcl syl cxme ngpxms xmseq0 syl3an1 mpd3an3 bitrd ) BIJZAD
        JZKZACLZMNAEBOLZPZMNZAENZUOUPURMUNUPURNUMAUQCBDEGFHUQQZRSTUMUNEDJZUSUTU
        CZUOBUAJZVBUMVDUNBUBUDDBEFHUEUFUMBUGJUNVBVCBUHAEUQBDFVAUIUJUKUL $.

      $( The norm of a nonzero element is nonzero.  (Contributed by Mario
         Carneiro, 4-Oct-2015.) $)
      nmne0 $p |- ( ( G e. NrmGrp /\ A e. X /\ A =/= .0. ) ->
                     ( N ` A ) =/= 0 ) $=
        ( cngp wcel cfv cc0 wne wa nmeq0 necon3bid biimp3ar ) BIJZADJZACKZLMAEM
        RSNTLAEABCDEFGHOPQ $.

      $( The norm of a nonzero element is a positive real.  (Contributed by
         Mario Carneiro, 4-Oct-2015.) $)
      nmrpcl $p |- ( ( G e. NrmGrp /\ A e. X /\ A =/= .0. ) ->
                      ( N ` A ) e. RR+ ) $=
        ( cngp wcel wne w3a cfv cr nmcl 3adant3 cc0 cle wbr nmge0 nmne0 ne0gt0d
        elrpd ) BIJZADJZAEKZLZACMZUDUEUHNJUFABCDFGOPZUGUHUIUDUEQUHRSUFABCDFGTPA
        BCDEFGHUAUBUC $.
    $}

    ${
      nminv.i $e |- I = ( invg ` G ) $.
      $( The norm of a negated element is the same as the norm of the original
         element.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
      nminv $p |- ( ( G e. NrmGrp /\ A e. X ) ->
                     ( N ` ( I ` A ) ) = ( N ` A ) ) $=
        ( cngp wcel wa c0g cfv cds co csg wceq cgrp ngpgrp eqid grpidcl mpd3an3
        adantr syl ngpdsr nmval adantl grpinvval2 sylan fveq2d 3eqtr4rd ) BIJZA
        EJZKZABLMZBNMZOZUOABPMZOZDMZADMZACMZDMULUMUOEJZUQUTQUNBRJZVCULVDUMBSZUC
        EBUOFUOTZUAUDAUOUPBURDEGFURTZUPTZUEUBUMVAUQQULAUPDBEUOGFVFVHUFUGUNVBUSD
        ULVDUMVBUSQVEEBURCAUOFVGHVFUHUIUJUK $.
    $}

    ${
      nmmtri.m $e |- .- = ( -g ` G ) $.
      $( The triangle inequality for the norm of a subtraction.  (Contributed
         by Mario Carneiro, 4-Oct-2015.) $)
      nmmtri $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
                        ( N ` ( A .- B ) ) <_ ( ( N ` A ) + ( N ` B ) ) ) $=
        ( cngp wcel w3a cfv co caddc cle eqid 3ad2ant1 wceq nmval cds ngpds c0g
        cmt wbr ngpms simp2 simp3 ngpgrp grpidcl syl syl13anc 3ad2ant2 3ad2ant3
        cgrp mstri3 oveq12d breqtrrd eqbrtrrd ) CJKZAFKZBFKZLZABCUAMZNZABDNEMAE
        MZBEMZONZPABVDCDEFHGIVDQZUBVCVEACUCMZVDNZBVJVDNZONZVHPVCCUDKZVAVBVJFKZV
        EVMPUEUTVAVNVBCUFRUTVAVBUGUTVAVBUHUTVAVOVBUTCUOKVOCUIFCVJGVJQZUJUKRABVJ
        VDCFGVIUPULVCVFVKVGVLOVAUTVFVKSVBAVDECFVJHGVPVITUMVBUTVGVLSVABVDECFVJHG
        VPVITUNUQURUS $.

      $( The norm of the difference between two elements.  (Contributed by
         Mario Carneiro, 4-Oct-2015.) $)
      nmsub $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
                        ( N ` ( A .- B ) ) = ( N ` ( B .- A ) ) ) $=
        ( cngp wcel w3a co cminusg cfv cgrp wceq simp1 ngpgrp syl3anc syl simp3
        simp2 eqid grpinvsub fveq2d grpsubcl nminv syl2anc eqtr3d ) CJKZAFKZBFK
        ZLZBADMZCNOZOZEOZABDMZEOUOEOZUNUQUSEUNCPKZUMULUQUSQUNUKVAUKULUMRZCSUAZU
        KULUMUBZUKULUMUCZFCDUPBAGIUPUDZUETUFUNUKUOFKZURUTQVBUNVAUMULVGVCVDVEFCD
        BAGIUGTUOCUPEFGHVFUHUIUJ $.

      $( Reverse triangle inequality for the norm of a subtraction.
         (Contributed by Mario Carneiro, 4-Oct-2015.) $)
      nmrtri $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
        ( abs ` ( ( N ` A ) - ( N ` B ) ) ) <_ ( N ` ( A .- B ) ) ) $=
        ( cngp wcel cfv co cmin cabs cle 3ad2ant1 eqid wceq nmval w3a c0g ngpms
        cds cmt wbr simp2 cgrp ngpgrp grpidcl msrtri syl13anc 3ad2ant2 3ad2ant3
        simp3 syl oveq12d fveq2d ngpds eqcomd 3brtr4d ) CJKZAFKZBFKZUAZACUBLZCU
        DLZMZBVFVGMZNMZOLZABVGMZAELZBELZNMZOLABDMELZPVECUEKZVCVDVFFKZVKVLPUFVBV
        CVQVDCUCQVBVCVDUGVBVCVDUOVECUHKZVRVBVCVSVDCUIQFCVFGVFRZUJUPABVFVGCFGVGR
        ZUKULVEVOVJOVEVMVHVNVINVCVBVMVHSVDAVGECFVFHGVTWATUMVDVBVNVISVCBVGECFVFH
        GVTWATUNUQURVEVLVPABVGCDEFHGIWAUSUTVA $.

      $( Inequality for the difference of norms.  (Contributed by Mario
         Carneiro, 6-Oct-2015.) $)
      nm2dif $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
        ( ( N ` A ) - ( N ` B ) ) <_ ( N ` ( A .- B ) ) ) $=
        ( cngp wcel w3a cfv cmin co cabs cr nmcl 3adant3 3adant2 resubcld recnd
        abscld simp1 cgrp ngpgrp grpsubcl syl3an1 syl2anc leabsd nmrtri letrd )
        CJKZAFKZBFKZLZAEMZBEMZNOZUSPMABDOZEMZUPUQURUMUNUQQKUOACEFGHRSUMUOURQKUN
        BCEFGHRTUAZUPUSUPUSVBUBUCUPUMUTFKZVAQKUMUNUOUDUMCUEKUNUOVCCUFFCDABGIUGU
        HUTCEFGHRUIUPUSVBUJABCDEFGHIUKUL $.
    $}

    ${
      nmtri.p $e |- .+ = ( +g ` G ) $.
      $( The triangle inequality for the norm of a sum.  (Contributed by Mario
         Carneiro, 4-Oct-2015.) $)
      nmtri $p |- ( ( G e. NrmGrp /\ A e. X /\ B e. X ) ->
                     ( N ` ( A .+ B ) ) <_ ( ( N ` A ) + ( N ` B ) ) ) $=
        ( cngp wcel w3a cminusg cfv csg co caddc cle wbr eqid cgrp ngpgrp simp3
        3ad2ant1 grpinvcl syl2anc nmmtri syld3an3 grpsubinv fveq2d wceq 3adant2
        simp2 nminv oveq2d 3brtr3d ) DJKZAFKZBFKZLZABDMNZNZDONZPZENZAENZVBENZQP
        ZABCPZENVFBENZQPRUQURUSVBFKZVEVHRSUTDUAKZUSVKUQURVLUSDUBUDZUQURUSUCZFDV
        ABGVATZUEUFAVBDVCEFGHVCTZUGUHUTVDVIEUTFCDVCVAABGIVPVOVMUQURUSUMVNUIUJUT
        VGVJVFQUQUSVGVJUKURBDVAEFGHVOUNULUOUP $.
    $}
  $}

  ${
    nm0.n $e |- N = ( norm ` G ) $.
    nm0.z $e |- .0. = ( 0g ` G ) $.
    $( Norm of the identity element.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    nm0 $p |- ( G e. NrmGrp -> ( N ` .0. ) = 0 ) $=
      ( cngp wcel cfv cc0 wceq eqid cbs wb cgrp ngpgrp grpidcl syl nmeq0 mpbiri
      mpdan ) AFGZCBHIJZCCJZCKUACALHZGZUBUCMUAANGUEAOUDACUDKZEPQCABUDCUFDERTS
      $.
  $}

  ${
    $d x y A $.  $d x y G $.  $d x y H $.
    subgngp.h $e |- H = ( G |`s A ) $.
    ${
      subgnm.n $e |- N = ( norm ` G ) $.
      subgnm.m $e |- M = ( norm ` H ) $.
      $( The norm in a subgroup.  (Contributed by Mario Carneiro,
         4-Oct-2015.) $)
      subgnm $p |- ( A e. ( SubGrp ` G ) -> M = ( N |` A ) ) $=
        ( vx csubg cfv wcel cbs c0g cds co cmpt cres eqid nmfval cv wceq subgss
        wss resmpt subgbas ressds eqidd subg0 oveq123d mpteq12dv eqtr2d reseq1i
        syl 3eqtr4g ) ABJKZLZICMKZIUAZCNKZCOKZPZQZIBMKZUSBNKZBOKZPZQZARZDEARUQV
        IIAVGQZVCUQAVDUDVIVJUBVDABVDSZUCIVDAVGUEUNUQIAVGURVBABCFUFUQUSUSVEUTVFV
        AAVFBCUPFVFSZUGUQUSUHABCVEFVESZUIUJUKULIVADCURUTHURSUTSVASTEVHAIVFEBVDV
        EGVKVMVLTUMUO $.

      $( A substructure assigns the same values to the norms of elements of a
         subgroup.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
      subgnm2 $p |- ( ( A e. ( SubGrp ` G ) /\ X e. A ) ->
        ( M ` X ) = ( N ` X ) ) $=
        ( csubg cfv wcel cres subgnm fveq1d fvres sylan9eq ) ABJKLZFALFDKFEAMZK
        FEKRFDSABCDEGHINOFAEPQ $.
    $}

    $( A normed group restricted to a subgroup is a normed group.  (Contributed
       by Mario Carneiro, 4-Oct-2015.) $)
    subgngp $p |- ( ( G e. NrmGrp /\ A e. ( SubGrp ` G ) ) -> H e. NrmGrp ) $=
      ( vx vy cngp wcel cfv wa cmt cv cds csg cnm wceq ad2antlr eleqtrrd eqid
      co csubg cgrp cbs subggrp adantl cress ngpms ressms sylan syl5eqel simplr
      wral simprl subgbas simprr subgsub syl3anc fveq2d ressds oveqd simpll wss
      subgss sseldd ngpds grpsubcl subgnm2 syl2anc 3eqtr4d ralrimivva syl3anbrc
      eqtr3d 3expb isngp3 ) BGHZABUAIZHZJZCUBHZCKHELZFLZCMIZTZVTWACNIZTZCOIZIZP
      ZFCUCIZULEWIULCGHVQVSVOABCDUDUEZVRCBAUFTZKDVOBKHVQWKKHBUGABVPUHUIUJVRWHEF
      WIWIVRVTWIHZWAWIHZJZJZVTWABNIZTZBOIZIZWEWRIZWCWGWOWQWEWRWOVQVTAHWAAHWQWEP
      VOVQWNUKZWOVTWIAVRWLWMUMVQAWIPVOWNABCDUNQZRZWOWAWIAVRWLWMUOXBRZABCWPWDVTW
      AWPSZDWDSZUPUQURWOVTWABMIZTZWCWSWOXGWBVTWAVQXGWBPVOWNAXGBCVPDXGSZUSQUTWOV
      OVTBUCIZHWAXJHXHWSPVOVQWNVAWOAXJVTVQAXJVBVOWNXJABXJSZVCQZXCVDWOAXJWAXLXDV
      DVTWAXGBWPWRXJWRSZXKXEXIVEUQVLWOVQWEAHWGWTPXAWOWEWIAVRVSWNWEWIHZWJVSWLWMX
      NWICWDVTWAWISZXFVFVMUIXBRABCWFWRWEDXMWFSZVGVHVIVJEFWBCWDWFWIXPXFWBSXOVNVK
      $.
  $}

  ${
    $d r u v x y z G $.
    $( A normed abelian group is a topological group (with the topology induced
       by the metric induced by the norm).  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    ngptgp $p |- ( ( G e. NrmGrp /\ G e. Abel ) -> G e. TopGrp ) $=
      ( vx vu vr vy vv wcel wa cfv co syl cv clt wbr wral crp eqid syl3anc wceq
      cr vz cngp cabel cgrp ctps csg ctopn ctx ccn ctgp ngpgrp adantr cmt ngpms
      mstps cds cbs cres cmopn wf wi wrex grpsubf c2 cdiv rphalfcl adantl caddc
      cxp simplll simpllr simpld simprl mscl simprd rpre ad2antlr lt2halves cle
      simprr grpsubcl mstri syl13anc ngpsubcan cminusg cplusg grpsubval syl2anc
      oveq12d grpinvcl ngplcan ngpinvds syl12anc 3eqtrd breqtrd readdcld lelttr
      mpand syld ovresd breq1d anbi12d 3imtr4d ralrimivva breq2 imbi1d 2ralbidv
      rspcev ralrimiva cxmt wb cxme msxms xmsxmet 3syl txmetcn mpbir2and mstopn
      eleqtrrd istgp2 syl3anbrc ) AUBGZAUCGZHZAUDGZAUEGZAUFIZAUGIZYHUHJZYHUIJZG
      AUJGYBYEYCAUKULZYDAUMGZYFYBYLYCAUNULZAUOKYDYGAUPIZAUQIZYOVIZURZUSIZYRUHJZ
      YRUIJZYJYDYGYTGZYPYOYGUTZBLZCLZYQJZDLZMNZELZFLZYQJZUUFMNZHZUUCUUHYGJZUUDU
      UIYGJZYQJZUALZMNZVAZFYOOCYOOZDPVBZUAPOZEYOOBYOOZYDYEUUBYKYOAYGYOQZYGQZVCK
      YDUVABEYOYOYDUUCYOGZUUHYOGZHZHZUUTUAPUVHUUPPGZHZUUPVDVEJZPGZUUEUVKMNZUUJU
      VKMNZHZUUQVAZFYOOCYOOZUUTUVIUVLUVHUUPVFVGUVJUVPCFYOYOUVJUUDYOGZUUIYOGZHZH
      ZUUCUUDYNJZUVKMNZUUHUUIYNJZUVKMNZHZUUMUUNYNJZUUPMNZUVOUUQUWAUWFUWBUWDVHJZ
      UUPMNZUWHUWAUWBTGZUWDTGZUUPTGZUWFUWJVAUWAYLUVEUVRUWKUWAYDYLYDUVGUVIUVTVJZ
      YMKZUWAUVEUVFYDUVGUVIUVTVKZVLZUVJUVRUVSVMZUUCUUDYNAYOUVCYNQZVNRZUWAYLUVFU
      VSUWLUWOUWAUVEUVFUWPVOZUVJUVRUVSVTZUUHUUIYNAYOUVCUWSVNRZUVIUWMUVHUVTUUPVP
      VQZUWBUWDUUPVRRUWAUWGUWIVSNZUWJUWHUWAUWGUUMUUDUUHYGJZYNJZUXFUUNYNJZVHJZUW
      IVSUWAYLUUMYOGZUUNYOGZUXFYOGZUWGUXIVSNUWOUWAYEUVEUVFUXJUWAYDYEUWNYKKZUWQU
      XAYOAYGUUCUUHUVCUVDWARZUWAYEUVRUVSUXKUXMUWRUXBYOAYGUUDUUIUVCUVDWARZUWAYEU
      VRUVFUXLUXMUWRUXAYOAYGUUDUUHUVCUVDWARUUMUUNUXFYNAYOUVCUWSWBWCUWAUXGUWBUXH
      UWDVHUWAYBUVEUVRUVFUXGUWBSUWAYBYCUWNVLUWQUWRUXAUUCUUDUUHYNAYGYOUVCUVDUWSW
      DWCUWAUXHUUDUUHAWEIZIZAWFIZJZUUDUUIUXPIZUXRJZYNJZUXQUXTYNJZUWDUWAUXFUXSUU
      NUYAYNUWAUVRUVFUXFUXSSUWRUXAYOUXRAUXPYGUUDUUHUVCUXRQZUXPQZUVDWGWHUVTUUNUY
      ASUVJYOUXRAUXPYGUUDUUIUVCUYDUYEUVDWGVGWIUWAYDUXQYOGZUXTYOGZUVRUYBUYCSUWNU
      WAYEUVFUYFUXMUXAYOAUXPUUHUVCUYEWJWHUWAYEUVSUYGUXMUXBYOAUXPUUIUVCUYEWJWHUW
      RUXQUXTUUDYNUXRAYOUVCUYDUWSWKWCUWAYDUVFUVSUYCUWDSUWNUXAUXBUUHUUIYNAUXPYOU
      VCUYEUWSWLWMWNWIWOUWAUWGTGZUWITGUWMUXEUWJHUWHVAUWAYLUXJUXKUYHUWOUXNUXOUUM
      UUNYNAYOUVCUWSVNRUWAUWBUWDUWTUXCWPUXDUWGUWIUUPWQRWRWSUWAUVMUWCUVNUWEUWAUU
      EUWBUVKMUWAUUCUUDYNYOUWQUWRWTXAUWAUUJUWDUVKMUWAUUHUUIYNYOUXAUXBWTXAXBUWAU
      UOUWGUUPMUWAUUMUUNYNYOUXNUXOWTXAXCXDUUSUVQDUVKPUUFUVKSZUURUVPCFYOYOUYIUUL
      UVOUUQUYIUUGUVMUUKUVNUUFUVKUUEMXEUUFUVKUUJMXEXBXFXGXHWHXIXDYDYQYOXJIGZUYJ
      UYJUUAUUBUVBHXKYDYLAXLGUYJYMAXMYQAYOUVCYQQZXNXOZUYLUYLBEUADFCYQYQYQYGYRYR
      YRYOYOYOYRQZUYMUYMXPRXQYDYIYSYHYRUIYDYHYRYHYRUHYDYLYHYRSYMYQYHAYOYHQZUVCU
      YKXRKZUYOWIUYOWIXSAYHYGUYNUVDXTYA $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y L $.  $d x y ph $.
    ngppropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    ngppropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    ngppropd.3 $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
      ( x ( +g ` K ) y ) = ( x ( +g ` L ) y ) ) $.
    ngppropd.4 $e |- ( ph ->
      ( ( dist ` K ) |` ( B X. B ) ) = ( ( dist ` L ) |` ( B X. B ) ) ) $.
    ngppropd.5 $e |- ( ph -> ( TopOpen ` K ) = ( TopOpen ` L ) ) $.
    $( Property deduction for a normed group.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    ngppropd $p |- ( ph -> ( K e. NrmGrp <-> L e. NrmGrp ) ) $=
      ( cgrp wcel cfv cxp cres wceq wa adantr eqid cmt cnm csg ccom cds cbs w3a
      cngp wb mspropd simpr cv co adantlr nmpropd2 grpsubpropd2 coeq12d xpeq12d
      cplusg reseq2d 3eqtr3d eqeq12d anbi12d anbi1d bitrd 3anass 3bitr4g isngp2
      pm5.32da grppropd ) AELMZEUAMZEUBNZEUCNZUDZEUENZEUFNZVQOZPZQZUGZFLMZFUAMZ
      FUBNZFUCNZUDZFUENZFUFNZWHOZPZQZUGZEUHMFUHMAVKVLVTRZRZWBWCWKRZRZWAWLAWNVKW
      ORWPAVKWMWOAVKRZVLWCVTWKAVLWCUIVKADEFGHJKUJSWQVOWFVSWJWQVMWDVNWEWQBCDEFAD
      VQQVKGSZADWHQVKHSZAVKUKZABULZDMCULZDMRXAXBEUSNUMXAXBFUSNUMQVKIUNZAVPDDOZP
      ZWGXDPZQVKJSUOWQBCDEFWRWSWTXCUPUQAVSWJQVKAXEXFVSWJJAXDVRVPADVQDVQGGURUTAX
      DWIWGADWHDWHHHURUTVASVBVCVIAVKWBWOABCDEFGHIVJVDVEVKVLVTVFWBWCWKVFVGVPVSEV
      NVMVQVMTVNTVPTVQTVSTVHWGWJFWEWDWHWDTWETWGTWHTWJTVHVG $.
  $}

  ${
    $d f g D $.  $d f g G $.  $d f g J $.  $d f g N $.
    $( The function ` toNrmGrp ` is a two-argument function.  (Contributed by
       Mario Carneiro, 8-Oct-2015.) $)
    reldmtng $p |- Rel dom toNrmGrp $=
      ( vg vf cvv cv cnx cds cfv csg ccom cop csts co cts ctng df-tng reldmmpt2
      cmopn ) ABCCADZEFGBDRHGIZJKLEMGSQGJKLNBAOP $.

    tngval.t $e |- T = ( G toNrmGrp N ) $.
    tngval.m $e |- .- = ( -g ` G ) $.
    tngval.d $e |- D = ( N o. .- ) $.
    tngval.j $e |- J = ( MetOpen ` D ) $.
    $( Value of the function which augments a given structure ` G ` with a norm
       ` N ` .  (Contributed by Mario Carneiro, 2-Oct-2015.) $)
    tngval $p |- ( ( G e. V /\ N e. W ) -> T =
   ( ( G sSet <. ( dist ` ndx ) , D >. ) sSet <. ( TopSet ` ndx ) , J >. ) ) $=
      ( vg vf wcel co cfv cop csts cvv wa ctng cnx cds cts wceq elex ccom cmopn
      csg simpl simpr fveq2d syl6eqr coeq12d opeq2d oveq12d df-tng ovex ovmpt2a
      cv syl2an syl5eq ) CGOZFHOZUABCFUBPZCUCUDQZARZSPZUCUEQZDRZSPZIVDCTOFTOVFV
      LUFVECGUGFHUGMNCFTTMVAZVGNVAZVMUJQZUHZRZSPZVJVPUIQZRZSPVLUBVMCUFZVNFUFZUA
      ZVRVIVTVKSWCVMCVQVHSWAWBUKZWCVPAVGWCVPFEUHAWCVNFVOEWAWBULWCVOCUJQEWCVMCUJ
      WDUMJUNUOKUNZUPUQWCVSDVJWCVSAUIQDWCVPAUIWEUMLUNUPUQNMURVIVKSUSUTVBVC $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y T $.  $d x y V $.
    tngbas.t $e |- T = ( G toNrmGrp N ) $.
    ${
      tnglem.2 $e |- E = Slot K $.
      tnglem.3 $e |- K e. NN $.
      tnglem.4 $e |- K < 9 $.
      $( Lemma for ~ tngbas and similar theorems.  (Contributed by Mario
         Carneiro, 2-Oct-2015.) $)
      tnglem $p |- ( N e. V -> ( E ` G ) = ( E ` T ) ) $=
        ( cfv wceq cnx co eqid c1 c2 c9 clt c0 cvv wcel wa cds csg ccom cop cts
        csts cmopn tngval fveq2d ndxid cdc ndxarg nnrei eqeltri wbr eqbrtri 1nn
        cr 2nn0 9nn0 9lt10 declti 1nn0 deccl nn0rei lttri mp2an ltneii neeqtrri
        dsndx setsnid tsetndx eqtri syl6reqr wn str0 fvprc adantr ctng reldmtng
        9re ovprc1 syl5eq 3eqtr4a pm2.61ian ) CUAUBZEFUBZCBKZABKZLWIWJUCZWLCMUD
        KZECUEKZUFZUGUINZMUHKZWPUJKZUGUINZBKZWKWMAWTBWPACWSWOEUAFGWOOWPOWSOUKUL
        WKWQBKXAWPWNBCBDHIUMZMBKZPQUNZWNXCXDXCDVABDHIUOZDIUPUQZXCRSURRXDSURXCXD
        SURXCDRSXEJUSZPQRUTVBVCVDVEXCRXDXFWDXDPQVFVBVGVHVIVJVKVMVLVNWSWRBWQXBXC
        RWRXCRXFXGVKVOVLVNVPVQWIVRZWJUCZTTBKWKWLBDHVSXHWKTLWJCBVTWAXIATBXIACEWB
        NZTGXHXJTLWJCEWBWCWEWAWFULWGWH $.
    $}

    ${
      tngbas.2 $e |- B = ( Base ` G ) $.
      $( The base set of a structure augmented with a norm.  (Contributed by
         Mario Carneiro, 2-Oct-2015.) $)
      tngbas $p |- ( N e. V -> B = ( Base ` T ) ) $=
        ( wcel cbs cfv c1 df-base 1nn 1lt9 tnglem syl5eq ) DEHACIJBIJGBICKDEFLM
        NOP $.
    $}

    ${
      tngplusg.2 $e |- .+ = ( +g ` G ) $.
      $( The group addition of a structure augmented with a norm.  (Contributed
         by Mario Carneiro, 2-Oct-2015.) $)
      tngplusg $p |- ( N e. V -> .+ = ( +g ` T ) ) $=
        ( wcel cplusg cfv c2 df-plusg 2nn 2lt9 tnglem syl5eq ) DEHACIJBIJGBICKD
        EFLMNOP $.
    $}

    ${
      tng0.2 $e |- .0. = ( 0g ` G ) $.
      $( The group identity of a structure augmented with a norm.  (Contributed
         by Mario Carneiro, 4-Oct-2015.) $)
      tng0 $p |- ( N e. V -> .0. = ( 0g ` T ) ) $=
        ( vx vy wcel c0g cfv cbs eqidd eqid tngbas cv wa cplusg tngplusg syl5eq
        proplem3 grpidpropd ) CDJZEBKLAKLGUDHIBMLZBAUDUENUEABCDFUEOPUDHQUEJIQUE
        JRHIBSLZASLUFABCDFUFOTUBUCUA $.
    $}

    ${
      tngmulr.2 $e |- .x. = ( .r ` G ) $.
      $( The ring multiplication of a structure augmented with a norm.
         (Contributed by Mario Carneiro, 2-Oct-2015.) $)
      tngmulr $p |- ( N e. V -> .x. = ( .r ` T ) ) $=
        ( wcel cmulr cfv c3 df-mulr 3nn 3lt9 tnglem syl5eq ) DEHBCIJAIJGAICKDEF
        LMNOP $.
    $}

    ${
      tngsca.2 $e |- F = ( Scalar ` G ) $.
      $( The scalar ring of a structure augmented with a norm.  (Contributed by
         Mario Carneiro, 2-Oct-2015.) $)
      tngsca $p |- ( N e. V -> F = ( Scalar ` T ) ) $=
        ( wcel csca cfv c5 df-sca 5nn 5lt9 tnglem syl5eq ) DEHBCIJAIJGAICKDEFLM
        NOP $.
    $}

    ${
      tngvsca.2 $e |- .x. = ( .s ` G ) $.
      $( The scalar multiplication of a structure augmented with a norm.
         (Contributed by Mario Carneiro, 2-Oct-2015.) $)
      tngvsca $p |- ( N e. V -> .x. = ( .s ` T ) ) $=
        ( wcel cvsca cfv c6 df-vsca 6nn 6lt9 tnglem syl5eq ) DEHBCIJAIJGAICKDEF
        LMNOP $.
    $}

    ${
      tngip.2 $e |- ., = ( .i ` G ) $.
      $( The inner product operation of a structure augmented with a norm.
         (Contributed by Mario Carneiro, 2-Oct-2015.) $)
      tngip $p |- ( N e. V -> ., = ( .i ` T ) ) $=
        ( wcel cip cfv c8 df-ip 8nn 8lt9 tnglem syl5eq ) DEHCBIJAIJGAIBKDEFLMNO
        P $.
    $}

    ${
      tngds.2 $e |- .- = ( -g ` G ) $.
      $( The metric function of a structure augmented with a norm.
         (Contributed by Mario Carneiro, 3-Oct-2015.) $)
      tngds $p |- ( N e. V -> ( N o. .- ) = ( dist ` T ) ) $=
        ( cvv wcel ccom cds cfv wceq cnx cop csts co c9 csg c0 wa cts cmopn wne
        dsid c1 cdc 9re 1nn 2nn0 9nn0 9lt10 declti gtneii dsndx tsetndx neeq12i
        mpbir setsnid fvex eqeltri coexg mpan2 setsid sylan2 eqid tngval fveq2d
        c2 3eqtr4a wn co02 df-ds str0 eqtri fvprc syl5eq coeq2d reldmtng ovprc1
        ctng adantr pm2.61ian ) BHIZDEIZDCJZAKLZMZWDWEUAZBNKLZWFOPQZKLZWKNUBLZW
        FUCLZOPQZKLWFWGWNWMKWKUEWJWMUDUFVIUGZRUDRWPUHUFVIRUIUJUKULUMUNWJWPWMRUO
        UPUQURUSWEWDWFHIZWFWLMWECHIWQCBSLZHGBSUTVADCEHVBVCHWFKHBUEVDVEWIAWOKWFA
        BWNCDHEFGWFVFWNVFVGVHVJWDVKZWHWEWSDTJZTKLZWFWGWTTXADVLKWPVMVNVOWSCTDWSC
        WRTGBSVPVQVRWSATKWSABDWAQTFBDWAVSVTVQVHVJWBWC $.
    $}

    tngtset.2 $e |- D = ( dist ` T ) $.
    tngtset.3 $e |- J = ( MetOpen ` D ) $.
    $( The topology generated by a normed structure.  (Contributed by Mario
       Carneiro, 3-Oct-2015.) $)
    tngtset $p |- ( ( G e. V /\ N e. W ) -> J = ( TopSet ` T ) ) $=
      ( wcel cfv cmopn cnx cds cop csts cts cvv eqid wa csg ccom wceq ovex fvex
      co tsetid setsid mp2an tngds syl6reqr adantl fveq2d syl5eq tngval 3eqtr4a
      ) CFKZEGKZUAZECUBLZUCZMLZCNOLVBPZQUGZNRLVCPQUGZRLZDBRLVESKVCSKVCVGUDCVDQU
      EVBMUFSVCRSVEUHUIUJUTDAMLVCJUTAVBMUSAVBUDURUSVBBOLABCVAEGHVATZUKIULUMUNUO
      UTBVFRVBBCVCVAEFGHVHVBTVCTUPUNUQ $.

    $( The topology generated by a normed structure.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    tngtopn $p |- ( ( G e. V /\ N e. W ) -> J = ( TopOpen ` T ) ) $=
      ( vx vy wcel cfv wss wceq cmopn cdm eqid syl wa cts ctopn tngtset cbs cpw
      cxmt crn cuni cv cbl ctg df-mopn dmmptss sseli cxp csg ccom tngds syl6eqr
      adantl dmeqd dmcoss cminusg cplusg co grpsubfval dmmpt2 sseqtri syl6eqssr
      cds ovex adantr dmss dmxpid syl6sseq simpr xmetunirn sylib mopnuni tngbas
      ad2antlr 3sstr3d sspwuni sylibr ex syl5 wn c0 ndmfv 0ss syl6eqss pm2.61d1
      syl5eqss eqsstr3d topnid eqtrd ) CFMZEGMZUAZDBUBNZBUCNZABCDEFGHIJUDZWTXAB
      UENZUFZOXAXBPWTXADXEXCWTDAQNZXEJWTAQRZMZXFXEOZXHAUGUHUIZMZWTXIXGXJAKXJKUJ
      ZUKNUHULNQKUMUNUOWTXKXIWTXKUAZXFUIZXDOXIXMARZRZCUENZXNXDXMXPXQXQUPZRZXQXM
      XOXROZXPXSOWTXTXKWTXOECUQNZURZRZXRWTYBAWSYBAPWRWSYBBVKNABCYAEGHYASZUSIUTV
      AVBYCYARXREYAVCKLXQXQXLLUJCVDNZNZCVENZVFYAKLXQYGCYEYAXQSZYGSYESYDVGXLYFYG
      VLVHVIVJVMXOXRVNTXQVOVPXMAXPUGNMZXPXNPXMXKYIWTXKVQAVRVSAXFXPXFSVTTWSXQXDP
      WRXKXQBCEGHYHWAWBWCXFXDWDWEWFWGXHWHXFWIXEAQWJXEWKWLWMWNWOXDXABXDSXASWPTWQ
      $.
  $}

  ${
    $d x A $.  $d x G $.  $d x N $.  $d x T $.  $d x X $.
    tngnm.t $e |- T = ( G toNrmGrp N ) $.
    tngnm.x $e |- X = ( Base ` G ) $.
    tngnm.a $e |- A e. _V $.
    $( The topology generated by a normed structure.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    tngnm $p |- ( ( G e. Grp /\ N : X --> A ) -> N = ( norm ` T ) ) $=
      ( vx wcel wf wa cfv cmpt co wceq eqid cbs cvv syl cgrp c0g csg ccom simpr
      cnm feqmptd cop cxp grpsubf ad2antrr grpidcl opelxpi syl2anc fvco3 fveq2i
      df-ov 3eqtr4g grpsubid1 adantlr fveq2d eqtr2d mpteq2dva fvex eqeltri fex2
      cv cds mp3an23 adantl tngbas tngds tng0 oveq123d mpteq12dv nmfval syl6eqr
      eqidd 3eqtrd ) CUAJZEADKZLZDIEIVGZDMZNIEWCCUBMZDCUCMZUDZOZNZBUFMZWBIEADVT
      WAUEUGWBIEWDWHWBWCEJZLZWHWCWEWFOZDMZWDWLWCWEUHZWGMZWOWFMZDMZWHWNWLEEUIZEW
      FKZWOWSJZWPWRPVTWTWAWKECWFGWFQZUJUKWLWKWEEJZXAWBWKUEVTXCWAWKECWEGWEQZULUK
      WCWEEEUMUNWSEWODWFUOUNWCWEWGUQWMWQDWCWEWFUQUPURWLWMWCDVTWKWMWCPWAECWFWCWE
      GXDXBUSUTVAVBVCWBWIIBRMZWCBUBMZBVHMZOZNWJWBIEWHXEXHWBDSJZEXEPWAXIVTWAESJA
      SJXIECRMSGCRVDVEHEADSSVFVIVJZEBCDSFGVKTWBWCWCWEXFWGXGWBXIWGXGPXJBCWFDSFXB
      VLTWBWCVRWBXIWEXFPXJBCDSWEFXDVMTVNVOIXGWJBXEXFWJQXEQXFQXGQVPVQVS $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y T $.  $d x y X $.
    tngngp2.t $e |- T = ( G toNrmGrp N ) $.
    tngngp2.x $e |- X = ( Base ` G ) $.
    tngngp2.d $e |- D = ( dist ` T ) $.
    $( A norm turns a group into a normed group iff the generated metric is in
       fact a metric.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    tngngp2 $p |- ( N : X --> RR ->
      ( T e. NrmGrp <-> ( G e. Grp /\ D e. ( Met ` X ) ) ) ) $=
      ( vx vy cr wf wcel cme cfv wa cvv wceq eqid syl cngp cgrp ngpgrp cbs fvex
      wb eqeltri reex fex2 mp3an23 a1i tngbas cplusg tngplusg proplem3 grppropd
      cv syl5ibr imp cxp cres cmt adantl msmet2 wfn csg ccom grpsubf fco syldan
      ngpms cds adantr tngds syl6reqr feq1d mpbird fnresdm 3syl xpeq12d reseq2d
      ffn eqtr3d fveq2d 3eltr4d jca cnm wss biimpa adantrr ctopn simprr eleqtrd
      cmopn metf eqeltrd simprl tngtopn syl2anc reseq1i isms2 simpl grpsubpropd
      eqtr2d sylanbrc tngnm coeq12d eqimss isngp syl3anbrc impbida ) EKDLZBUAMZ
      CUBMZAENOZMZPZXLXMPZXNXPXLXMXNXMXNXLBUBMZBUCXLDQMZXNXSUFXLEQMKQMXTECUDOZQ
      GCUDUEUGUHEKDQQUIUJZXTIJECBEYARXTGUKZEBCDQFGULZXTIUQEMJUQEMPIJCUMOZBUMOYE
      BCDQFYESUNZUOUPTZURUSZXRABUDOZYIUTZVAZYINOZAXOXRBVBMZYKYLMZXMYMXLBVKVCABY
      IYISZHVDTXRAEEUTZVAZAYKXRYPKALZAYPVEYQARXRYRYPKDCVFOZVGZLZXLXMYPEYSLZUUAX
      RXNUUBYHECYSGYSSZVHTYPEKDYSVIVJXRYPKAYTXRYTBVLOZAXRXTYTUUDRZXLXTXMYBVMZBC
      YSDQFUUCVNZTHVOVPVQYPKAWBYPAVRVSXRYPYJAXREYIEYIXRXTEYIRZUUFYDTZUUIVTWAWCX
      REYINUUIWDWEWFXLXQPZXSYMBWGOZBVFOZVGZUUDWHZXMXLXNXSXPXLXNXSYGWIWJUUJYNBWK
      OZYKWNOZRYMUUJYKAYLUUJYJKALZAYJVEYKARUUJAYLMUUQUUJAXOYLXLXNXPWLUUJEYINUUJ
      XTUUHXLXTXQYBVMZYDTWDWMZAYIWOTYJKAWBYJAVRVSZUUSWPUUJUUPAWNOZUUOUUJYKAWNUU
      TWDUUJXNXTUVAUUORXLXNXPWQZUURABCUVADUBQFHUVASWRWSXDYKUUOBYIUUOSYOAUUDYJHW
      TXAXEUUJUUMUUDRUUNUUJYTUUMUUDUUJDUUKYSUULUUJXNXLDUUKRUVBXLXQXBKBCDEFGUHXF
      WSUUJXTYSUULRUURXTCBXTEYAYIYCYDWCYFXCTXGUUJXTUUEUURUUGTWCUUMUUDXHTUUDBUUL
      UUKUUKSUULSUUDSXIXJXK $.
  $}

  ${
    $d a b x y .- $.  $d a b x y N $.  $d a b x y T $.  $d a b x y X $.
    $d a b G $.  $d x y ph $.  $d a b x y .0. $.
    tngngp.t $e |- T = ( G toNrmGrp N ) $.
    tngngp.x $e |- X = ( Base ` G ) $.
    tngngp.m $e |- .- = ( -g ` G ) $.
    tngngp.z $e |- .0. = ( 0g ` G ) $.
    ${
      tngngpd.1 $e |- ( ph -> G e. Grp ) $.
      tngngpd.2 $e |- ( ph -> N : X --> RR ) $.
      tngngpd.3 $e |- ( ( ph /\ x e. X ) -> ( ( N ` x ) = 0 <-> x = .0. ) ) $.
      tngngpd.4 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
        ( N ` ( x .- y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) $.
      $( Derive the axioms for a normed group from the axioms for a metric
         space.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
      tngngpd $p |- ( ph -> T e. NrmGrp ) $=
        ( wcel cfv cvv cngp cgrp cds cme ccom cr wf wceq fvex eqeltri reex fex2
        cbs mp3an23 tngds 3syl nrmmetd eqeltrrd wa eqid tngngp2 syl mpbir2and
        wb ) ADUARZEUBRZDUCSZHUDSZRZNAGFUEZVGVHAHUFGUGZGTRZVJVGUHOVKHTRUFTRVLHE
        UMSTKEUMUIUJUKHUFGTTULUNDEFGTJLUOUPABCGEFHIKLMNOPQUQURAVKVEVFVIUSVDOVGD
        EGHJKVGUTVAVBVC $.
    $}

    $( Derive the axioms for a normed group from the axioms for a metric
       space.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    tngngp $p |- ( N : X --> RR -> ( T e. NrmGrp <-> ( G e. Grp /\ A. x e. X
        ( ( ( N ` x ) = 0 <-> x = .0. ) /\
          A. y e. X ( N ` ( x .- y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) ) $=
      ( wcel cfv wceq co caddc cle wa cvv va vb cr wf cngp cgrp cv cc0 wbr wral
      wb cds cme eqid tngngp2 simprbda cnm c0g cbs simpr fvex eqeltri reex fex2
      simplr mp3an23 ad2antrr tngbas eleqtrd nmeq0 syl2anc adantr simpll fveq1d
      syl tngnm eqeq1d tng0 eqeq2d 3bitr4d simpllr eleq2d biimpa nmmtri syl3anc
      csg syl5eqr cplusg tngplusg grpsubpropd fveq12d oveq12d 3brtr4d ralrimiva
      syl5eq oveqd jca simprl simpl ralimi ad2antll fveq2 eqeq1 bibi12d rspccva
      sylan oveq1 fveq2d oveq1d breq12d oveq2d rspc2va ancoms tngngpd impbida
      oveq2 ) GUCFUDZCUEMZDUFMZAUGZFNZUHOZXTHOZUKZXTBUGZEPZFNZYAYEFNZQPZRUIZBGU
      JZSZAGUJZSZXQXRSZXSYMXQXRXSCULNZGUMNMYPCDFGIJYPUNUOUPZYOYLAGYOXTGMZSZYDYK
      YSXTCUQNZNZUHOZXTCURNZOZYBYCYSXRXTCUSNZMZUUBUUDUKXQXRYRVEYSXTGUUEYOYRUTYS
      FTMZGUUEOXQUUGXRYRXQGTMUCTMUUGGDUSNZTJDUSVAVBVCGUCFTTVDVFVGZGCDFTIJVHVOZV
      IZXTCYTUUEUUCUUEUNZYTUNZUUCUNVJVKYSYAUUAUHYSXTFYTYSXSXQFYTOYOXSYRYQVLXQXR
      YRVMUCCDFGIJVCVPVKZVNZVQYSHUUCXTYSUUGHUUCOUUICDFTHILVRVOVSVTYSYJBGYSYEGMZ
      SZXTYECWFNZPZYTNZUUAYEYTNZQPZYGYIRUUQXRUUFYEUUEMZUUTUVBRUIXQXRYRUUPWAYSUU
      FUUPUUKVLYSUUPUVCYSGUUEYEUUJWBWCXTYECUURYTUUEUULUUMUURUNWDWEYSYGUUTOUUPYS
      YFUUSFYTUUNYSEUURXTYEYSEDWFNUURKYSDCYSUUHGUUEJUUJWGYSUUGDWHNZCWHNOUUIUVDC
      DFTIUVDUNWIVOWJWOWPWKVLYSYIUVBOUUPYSYAUUAYHUVAQUUOYSYEFYTUUNVNWLVLWMWNWQW
      NWQXQYNSZUAUBCDEFGHIJKLXQXSYMWRXQYNWSUVEYDAGUJZUAUGZGMZUVGFNZUHOZUVGHOZUK
      ZYMUVFXQXSYLYDAGYDYKWSWTXAYDUVLAUVGGXTUVGOZYBUVJYCUVKUVMYAUVIUHXTUVGFXBZV
      QXTUVGHXCXDXEXFUVEYKAGUJZUVHUBUGZGMSZUVGUVPEPZFNZUVIUVPFNZQPZRUIZYMUVOXQX
      SYLYKAGYDYKUTWTXAUVQUVOUWBYJUWBUVGYEEPZFNZUVIYHQPZRUIABUVGUVPGGUVMYGUWDYI
      UWERUVMYFUWCFXTUVGYEEXGXHUVMYAUVIYHQUVNXIXJYEUVPOZUWDUVSUWEUWARUWFUWCUVRF
      YEUVPUVGEXPXHUWFYHUVTUVIQYEUVPFXBXKXJXLXMXFXNXO $.
  $}

  ${
    $d r A $.  $d r N $.  $d r R $.
    isnrg.1 $e |- N = ( norm ` R ) $.
    isnrg.2 $e |- A = ( AbsVal ` R ) $.
    $( A normed ring is a ring with a norm that makes it into a normed group,
       and such that the norm is an absolute value on the ring.  (Contributed
       by Mario Carneiro, 4-Oct-2015.) $)
    isnrg $p |- ( R e. NrmRing <-> ( R e. NrmGrp /\ N e. A ) ) $=
      ( vr cnm cfv cabv wcel cngp cnrg wceq fveq2 syl6eqr eleq12d df-nrg elrab2
      cv ) FSZGHZTIHZJCAJFBKLTBMZUACUBAUCUABGHCTBGNDOUCUBBIHATBINEOPFQR $.

    $( The norm of a normed ring is an absolute value.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    nrgabv $p |- ( R e. NrmRing -> N e. A ) $=
      ( cnrg wcel cngp isnrg simprbi ) BFGBHGCAGABCDEIJ $.
  $}

  $( A normed ring is a normed group.  (Contributed by Mario Carneiro,
     4-Oct-2015.) $)
  nrgngp $p |- ( R e. NrmRing -> R e. NrmGrp ) $=
    ( cnrg wcel cngp cnm cfv cabv eqid isnrg simplbi ) ABCADCAEFZAGFZCLAKKHLHIJ
    $.

  $( A normed ring is a ring.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
  nrgrng $p |- ( R e. NrmRing -> R e. Ring ) $=
    ( cnrg wcel cnm cfv cabv crg eqid nrgabv abvrcl syl ) ABCADEZAFEZCAGCMALLHM
    HZIMALNJK $.

  ${
    nmmul.x $e |- X = ( Base ` R ) $.
    nmmul.n $e |- N = ( norm ` R ) $.
    nmmul.t $e |- .x. = ( .r ` R ) $.
    $( The norm of a product in a normed ring.  (Contributed by Mario Carneiro,
       5-Oct-2015.) $)
    nmmul $p |- ( ( R e. NrmRing /\ A e. X /\ B e. X ) ->
      ( N ` ( A .x. B ) ) = ( ( N ` A ) x. ( N ` B ) ) ) $=
      ( cnrg wcel cabv cfv co cmul wceq eqid nrgabv abvmul syl3an1 ) CJKECLMZKA
      FKBFKABDNEMAEMBEMONPUACEHUAQZRUAFCDEABUBGIST $.

    nrgdsdi.d $e |- D = ( dist ` R ) $.
    $( Distribute a distance calculation.  (Contributed by Mario Carneiro,
       5-Oct-2015.) $)
    nrgdsdi $p |- ( ( R e. NrmRing /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( N ` A ) x. ( B D C ) ) = ( ( A .x. B ) D ( A .x. C ) ) ) $=
      ( wcel cfv co cmul wceq adantr syl3anc ngpds cnrg w3a wa csg simpl simpr1
      cgrp crg nrgrng rnggrp simpr2 simpr3 eqid grpsubcl rngsubdi fveq2d eqtr3d
      syl nmmul cngp nrgngp oveq2d rngcl 3eqtr4d ) EUAMZAHMZBHMZCHMZUBZUCZAGNZB
      CEUDNZOZGNZPOZABFOZACFOZVLOZGNZVKBCDOZPOVPVQDOZVJAVMFOZGNZVOVSVJVEVFVMHMZ
      WCVOQVEVIUEVEVFVGVHUFZVJEUGMZVGVHWDVJEUHMZWFVEWGVIEUIRZEUJURVEVFVGVHUKZVE
      VFVGVHULZHEVLBCIVLUMZUNSAVMEFGHIJKUSSVJWBVRGVJHEFVLABCIKWKWHWEWIWJUOUPUQV
      JVTVNVKPVJEUTMZVGVHVTVNQVEWLVIEVARZWIWJBCDEVLGHJIWKLTSVBVJWLVPHMZVQHMZWAV
      SQWMVJWGVFVGWNWHWEWIHEFABIKVCSVJWGVFVHWOWHWEWJHEFACIKVCSVPVQDEVLGHJIWKLTS
      VD $.

    $( Distribute a distance calculation.  (Contributed by Mario Carneiro,
       5-Oct-2015.) $)
    nrgdsdir $p |- ( ( R e. NrmRing /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A D B ) x. ( N ` C ) ) = ( ( A .x. C ) D ( B .x. C ) ) ) $=
      ( wcel cfv co cmul wceq adantr syl3anc ngpds cnrg w3a wa csg simpl nrgrng
      cgrp crg rnggrp simpr1 simpr2 eqid grpsubcl simpr3 nmmul rngsubdir fveq2d
      syl eqtr3d cngp nrgngp oveq1d rngcl 3eqtr4d ) EUAMZAHMZBHMZCHMZUBZUCZABEU
      DNZOZGNZCGNZPOZACFOZBCFOZVKOZGNZABDOZVNPOVPVQDOZVJVLCFOZGNZVOVSVJVEVLHMZV
      HWCVOQVEVIUEVJEUGMZVFVGWDVJEUHMZWEVEWFVIEUFRZEUIURVEVFVGVHUJZVEVFVGVHUKZH
      EVKABIVKULZUMSVEVFVGVHUNZVLCEFGHIJKUOSVJWBVRGVJHEFVKABCIKWJWGWHWIWKUPUQUS
      VJVTVMVNPVJEUTMZVFVGVTVMQVEWLVIEVARZWHWIABDEVKGHJIWJLTSVBVJWLVPHMZVQHMZWA
      VSQWMVJWFVFVHWNWGWHWKHEFACIKVCSVJWFVGVHWOWGWIWKHEFBCIKVCSVPVQDEVKGHJIWJLT
      SVD $.
  $}

  ${
    nm1.n $e |- N = ( norm ` R ) $.
    nm1.u $e |- .1. = ( 1r ` R ) $.
    $( The norm of one in a nonzero normed ring.  (Contributed by Mario
       Carneiro, 5-Oct-2015.) $)
    nm1 $p |- ( ( R e. NrmRing /\ R e. NzRing ) -> ( N ` .1. ) = 1 ) $=
      ( cnrg wcel cabv cfv c0g wne c1 wceq cnzr eqid nrgabv nzrnz abv1z syl2an
      ) AFGCAHIZGBAJIZKBCILMANGTACDTOZPABUAEUAOZQTABCUAUBEUCRS $.
  $}

  ${
    nminvr.n $e |- N = ( norm ` R ) $.
    nminvr.u $e |- U = ( Unit ` R ) $.
    $( The norm of a unit is nonzero in a nonzero normed ring.  (Contributed by
       Mario Carneiro, 5-Oct-2015.) $)
    unitnmn0 $p |- ( ( R e. NrmRing /\ R e. NzRing /\ A e. U ) ->
      ( N ` A ) =/= 0 ) $=
      ( cnrg wcel cnzr w3a cngp cbs cfv c0g wne cc0 nrgngp 3ad2ant1 eqid unitcl
      3ad2ant3 nzrunit 3adant1 nmne0 syl3anc ) BGHZBIHZACHZJBKHZABLMZHZABNMZOZA
      DMPOUFUGUIUHBQRUHUFUKUGUJBCAUJSZFTUAUGUHUMUFABCULFULSZUBUCABDUJULUNEUOUDU
      E $.

    nminvr.i $e |- I = ( invr ` R ) $.
    $( The norm of an inverse in a nonzero normed ring.  (Contributed by Mario
       Carneiro, 5-Oct-2015.) $)
    nminvr $p |- ( ( R e. NrmRing /\ R e. NzRing /\ A e. U ) ->
      ( N ` ( I ` A ) ) = ( 1 / ( N ` A ) ) ) $=
      ( cnrg wcel cnzr c1 cfv co wceq eqid syl2anc cr nmcl recnd w3a cdiv cmulr
      cur crg nzrrng 3ad2ant2 simp3 unitrinv fveq2d cbs simp1 3ad2ant3 rnginvcl
      cmul unitcl nmmul syl3anc nm1 3adant3 3eqtr3d cc ax-1cn a1i cngp 3ad2ant1
      nrgngp unitnmn0 divmuld mpbird eqcomd ) BIJZBKJZACJZUAZLAEMZUBNZADMZEMZVO
      VQVSOVPVSUONZLOVOAVRBUCMZNZEMZBUDMZEMZVTLVOWBWDEVOBUEJZVNWBWDOVMVLWFVNBUF
      UGZVLVMVNUHZBWACWDDAGHWAPZWDPZUIQUJVOVLABUKMZJZVRWKJZWCVTOVLVMVNULVNVLWLV
      MWKBCAWKPZGUPUMZVOWFVNWMWGWHWKBCDAGHWNUNQZAVRBWAEWKWNFWIUQURVLVMWELOVNBWD
      EFWJUSUTVAVOLVPVSLVBJVOVCVDVOVPVOBVEJZWLVPRJVLVMWQVNBVGVFZWOABEWKWNFSQTVO
      VSVOWQWMVSRJWRWPVRBEWKWNFSQTABCEFGVHVIVJVK $.

  $}

  ${
    nmdvr.x $e |- X = ( Base ` R ) $.
    nmdvr.n $e |- N = ( norm ` R ) $.
    nmdvr.u $e |- U = ( Unit ` R ) $.
    nmdvr.d $e |- ./ = ( /r ` R ) $.
    $( The norm of a division in a nonzero normed ring.  (Contributed by Mario
       Carneiro, 5-Oct-2015.) $)
    nmdvr $p |- ( ( ( R e. NrmRing /\ R e. NzRing ) /\ ( A e. X /\ B e. U ) )
      -> ( N ` ( A ./ B ) ) = ( ( N ` A ) / ( N ` B ) ) ) $=
      ( wcel wa cfv co cdiv cmul wceq ad2antrr syl2anc cnrg cnzr cinvr cmulr c1
      simpll simprl crg nrgrng simprr eqid rnginvcl nmmul syl3anc simplr nminvr
      oveq2d eqtrd dvrval adantl fveq2d cngp cr nrgngp nmcl recnd unitss sseldi
      cc0 wne unitnmn0 3expa adantrl divrecd 3eqtr4d ) DUALZDUBLZMZAGLZBELZMZMZ
      ABDUCNZNZDUDNZOZFNZAFNZUEBFNZPOZQOZABCOZFNWHWIPOWBWGWHWDFNZQOZWKWBVPVSWDG
      LZWGWNRVPVQWAUFZVRVSVTUGZWBDUHLZVTWOVPWRVQWADUISVRVSVTUJZGDEWCBJWCUKZHULT
      AWDDWEFGHIWEUKZUMUNWBWMWJWHQWBVPVQVTWMWJRWPVPVQWAUOWSBDEWCFIJWTUPUNUQURWB
      WLWFFWAWLWFRVRGCDWEEWCABHXAJWTKUSUTVAWBWHWIWBWHWBDVBLZVSWHVCLVPXBVQWADVDS
      ZWQADFGHIVETVFWBWIWBXBBGLWIVCLXCWBEGBGDEHJVGWSVHBDFGHIVETVFVRVTWIVIVJZVSV
      PVQVTXDBDEFIJVKVLVMVNVO $.
  $}

  $( A nonzero normed ring is a domain.  (Contributed by Mario Carneiro,
     4-Oct-2015.) $)
  nrgdomn $p |- ( R e. NrmRing -> ( R e. Domn <-> R e. NzRing ) ) $=
    ( cnrg wcel cdomn cnzr domnnzr wa cabv cfv c0 wne simpr cnm eqid nrgabv syl
    ne0i adantr abvn0b sylanbrc ex impbid2 ) ABCZADCZAECZAFUCUEUDUCUEGUEAHIZJKZ
    UDUCUELUCUGUEUCAMIZUFCUGUFAUHUHNUFNZOUFUHQPRUFAUISTUAUB $.

  ${
    $( A normed ring is a topological group.  (Contributed by Mario Carneiro,
       5-Oct-2015.) $)
    nrgtgp $p |- ( R e. NrmRing -> R e. TopGrp ) $=
      ( cnrg wcel cngp cabel ctgp nrgngp crg nrgrng rngabl syl ngptgp syl2anc )
      ABCZADCAECZAFCAGNAHCOAIAJKALM $.
  $}

  ${
    subrgnrg.h $e |- H = ( G |`s A ) $.
    $( A normed ring restricted to a subring is a normed ring.  (Contributed by
       Mario Carneiro, 4-Oct-2015.) $)
    subrgnrg $p |- ( ( G e. NrmRing /\ A e. ( SubRing ` G ) ) ->
      H e. NrmRing ) $=
      ( cnrg wcel csubrg cfv wa cngp cabv csubg nrgngp subrgsubg subgngp syl2an
      cnm cres wceq eqid adantl subgnm syl nrgabv abvres sylan eqeltrd sylanbrc
      isnrg ) BEFZABGHFZIZCJFZCQHZCKHZFCEFUJBJFABLHFZUMUKBMABNZABCDOPULUNBQHZAR
      ZUOULUPUNUSSUKUPUJUQUAABCUNURDURTZUNTZUBUCUJURBKHZFUKUSUOFVBBURUTVBTZUDVB
      UOABCURVCDUOTZUEUFUGUOCUNVAVDUIUH $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y R $.  $d x y T $.
    tngnrg.t $e |- T = ( R toNrmGrp F ) $.
    tngnrg.a $e |- A = ( AbsVal ` R ) $.
    $( Given any absolute value over a ring, augmenting the ring with the
       absolute value produces a normed ring.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    tngnrg $p |- ( F e. A -> T e. NrmRing ) $=
      ( vx vy wcel cngp cfv cabv syl eqid cr wa cv cplusg proplem3 cmulr abvrcl
      cnm cnrg cgrp cds cbs cme crg rnggrp csg ccom tngds abvmet eqeltrrd wf wb
      abvf tngngp2 mpbir2and wceq tngnm syl2anc eqidd tngplusg tngmulr abvpropd
      reex tngbas syl5eq eleq12d ibi isnrg sylanbrc ) DAIZCJIZCUBKZCLKZIZCUCIVN
      VOBUDIZCUEKZBUFKZUGKZIZVNBUHIVSABDFUABUIMZVNDBUJKZUKVTWBCBWEDAEWENZULABDW
      EWAWANZFWFUMUNVNWAODUOZVOVSWCPUPAWABDFWGUQZVTCBDWAEWGVTNURMUSVNVRVNDVPAVQ
      VNVSWHDVPUTWDWIOCBDWAEWGVGVAVBVNABLKVQFVNGHWABCVNWAVCWACBDAEWGVHVNGQWAIHQ
      WAIPZGHBRKZCRKWKCBDAEWKNVDSVNWJGHBTKZCTKCWLBDAEWLNVESVFVIVJVKVQCVPVPNVQNV
      LVM $.
  $}

  ${
    $d f w x y A $.  $d f w F $.  $d f w x y N $.  $d f w x y V $.  $d x y X $.
    $d f w x K $.  $d f w x y W $.  $d f w x y .x. $.  $d y Y $.
    isnlm.v $e |- V = ( Base ` W ) $.
    isnlm.n $e |- N = ( norm ` W ) $.
    isnlm.s $e |- .x. = ( .s ` W ) $.
    isnlm.f $e |- F = ( Scalar ` W ) $.
    isnlm.k $e |- K = ( Base ` F ) $.
    isnlm.a $e |- A = ( norm ` F ) $.
    $( A normed (left) module is a module which is also a normed group over a
       normed ring, such that the norm distributes over scalar multiplication.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    isnlm $p |- ( W e. NrmMod <->
      ( ( W e. NrmGrp /\ W e. LMod /\ F e. NrmRing ) /\
    A. x e. K A. y e. V ( N ` ( x .x. y ) ) = ( ( A ` x ) x. ( N ` y ) ) ) ) $=
      ( wcel wa cfv cnm cbs vf vw cngp clmod cin cnrg cv co cmul wceq wral cnlm
      w3a anass df-3an elin anbi1i bitr4i cvsca csca wsbc cvv fvex a1i id fveq2
      syl6eqr sylan9eqr eleq1d fveq2d fveq12d oveq12d eqeq12d raleqbidv anbi12d
      simpl oveqd fveq1d sbcied df-nlm elrab2 3bitr4ri ) IUCUDUEZPZEUFPZQZAUGZB
      UGZDUHZGRZWGCRZWHGRZUIUHZUJZBHUKZAFUKZQWDWEWPQZQIUCPZIUDPZWEUMZWPQIULPWDW
      EWPUNWTWFWPWTWRWSQZWEQWFWRWSWEUOWDXAWEIUCUDUPUQURUQUAUGZUFPZWGWHUBUGZUSRZ
      UHZXDSRZRZWGXBSRZRZWHXGRZUIUHZUJZBXDTRZUKZAXBTRZUKZQZUAXDUTRZVAWQUBIWCULX
      DIUJZXRWQUAXSVBXSVBPXTXDUTVCVDXTXBXSUJZQZXCWEXQWPYBXBEUFYAXTXBXSEYAVEXTXS
      IUTREXDIUTVFMVGVHZVIYBXOWOAXPFYBXPETRFYBXBETYCVJNVGYBXMWNBXNHYBXNITRHYBXD
      ITXTYAVPZVJJVGYBXHWJXLWMYBXFWIXGGYBXGISRGYBXDISYDVJKVGZYBXEDWGWHYBXEIUSRD
      YBXDIUSYDVJLVGVQVKYBXJWKXKWLUIYBWGXICYBXIESRCYBXBESYCVJOVGVRYBWHXGGYEVRVL
      VMVNVNVOVSABUBUAVTWAWB $.

    $( Defining property of a normed module.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    nmvs $p |- ( ( W e. NrmMod /\ X e. K /\ Y e. V ) ->
      ( N ` ( X .x. Y ) ) = ( ( A ` X ) x. ( N ` Y ) ) ) $=
      ( wcel co cfv cmul wceq vx vy cnlm cv wral wa cngp clmod cnrg w3a simprbi
      isnlm oveq1 fveq2d fveq2 oveq1d eqeq12d oveq2d rspc2v syl5com 3impib
      oveq2 ) GUCPZHDPZIFPZHIBQZERZHARZIERZSQZTZVCUAUDZUBUDZBQZERZVLARZVMERZSQZ
      TZUBFUEUADUEZVDVEUFVKVCGUGPGUHPCUIPUJVTUAUBABCDEFGJKLMNOULUKVSVKHVMBQZERZ
      VHVQSQZTUAUBHIDFVLHTZVOWBVRWCWDVNWAEVLHVMBUMUNWDVPVHVQSVLHAUOUPUQVMITZWBV
      GWCVJWEWAVFEVMIHBVBUNWEVQVIVHSVMIEUOURUQUSUTVA $.
  $}

  ${
    $d x y F $.  $d x y W $.
    $( A normed module is a normed group.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    nlmngp $p |- ( W e. NrmMod -> W e. NrmGrp ) $=
      ( vx vy cnlm wcel cngp clmod csca cfv cnrg w3a cv cvsca cnm cmul wceq cbs
      co wral eqid isnlm simplbi simp1d ) ADEZAFEZAGEZAHIZJEZUDUEUFUHKBLZCLZAMI
      ZRANIZIUIUGNIZIUJULIORPCAQIZSBUGQIZSBCUMUKUGUOULUNAUNTULTUKTUGTUOTUMTUAUB
      UC $.

    $( A normed module is a left module.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    nlmlmod $p |- ( W e. NrmMod -> W e. LMod ) $=
      ( vx vy cnlm wcel cngp clmod csca cfv cnrg w3a cv cvsca cnm cmul wceq cbs
      co wral eqid isnlm simplbi simp2d ) ADEZAFEZAGEZAHIZJEZUDUEUFUHKBLZCLZAMI
      ZRANIZIUIUGNIZIUJULIORPCAQIZSBUGQIZSBCUMUKUGUOULUNAUNTULTUKTUGTUOTUMTUAUB
      UC $.

    nlmnrg.1 $e |- F = ( Scalar ` W ) $.
    $( The scalar component of a left module is a normed ring.  (Contributed by
       Mario Carneiro, 4-Oct-2015.) $)
    nlmnrg $p |- ( W e. NrmMod -> F e. NrmRing ) $=
      ( vx vy cnlm wcel cngp clmod cnrg w3a cv cvsca cfv cnm cmul cbs wral eqid
      co wceq isnlm simplbi simp3d ) BFGZBHGZBIGZAJGZUEUFUGUHKDLZELZBMNZTBONZNU
      IAONZNUJULNPTUAEBQNZRDAQNZRDEUMUKAUOULUNBUNSULSUKSCUOSUMSUBUCUD $.

    $( The scalar component of a left module is a normed group.  (Contributed
       by Mario Carneiro, 4-Oct-2015.) $)
    nlmngp2 $p |- ( W e. NrmMod -> F e. NrmGrp ) $=
      ( cnlm wcel cnrg cngp nlmnrg nrgngp syl ) BDEAFEAGEABCHAIJ $.
  $}

  ${
    nlmdsdi.v $e |- V = ( Base ` W ) $.
    nlmdsdi.s $e |- .x. = ( .s ` W ) $.
    nlmdsdi.f $e |- F = ( Scalar ` W ) $.
    nlmdsdi.k $e |- K = ( Base ` F ) $.
    nlmdsdi.d $e |- D = ( dist ` W ) $.
    ${
      nlmdsdi.a $e |- A = ( norm ` F ) $.
      $( Distribute a distance calculation.  (Contributed by Mario Carneiro,
         6-Oct-2015.) $)
      nlmdsdi $p |- ( ( W e. NrmMod /\ ( X e. K /\ Y e. V /\ Z e. V ) ) ->
        ( ( A ` X ) x. ( Y D Z ) ) = ( ( X .x. Y ) D ( X .x. Z ) ) ) $=
        ( wcel cfv co syl3anc cnlm w3a csg cnm cmul wceq simpl simpr1 cgrp cngp
        nlmngp adantr ngpgrp syl simpr2 simpr3 eqid grpsubcl nmvs clmod nlmlmod
        wa lmodsubdi fveq2d eqtr3d ngpds oveq2d lmodvscl 3eqtr4d ) GUAQZHEQZIFQ
        ZJFQZUBZVBZHARZIJGUCRZSZGUDRZRZUESZHICSZHJCSZVQSZVSRZVPIJBSZUESWBWCBSZV
        OHVRCSZVSRZWAWEVOVJVKVRFQZWIWAUFVJVNUGVJVKVLVMUHZVOGUIQZVLVMWJVOGUJQZWL
        VJWMVNGUKULZGUMUNVJVKVLVMUOZVJVKVLVMUPZFGVQIJKVQUQZURTACDEVSFGHVRKVSUQZ
        LMNPUSTVOWHWDVSVOHCDEVQFGIJKLMNWQVJGUTQZVNGVAULZWKWOWPVCVDVEVOWFVTVPUEV
        OWMVLVMWFVTUFWNWOWPIJBGVQVSFWRKWQOVFTVGVOWMWBFQZWCFQZWGWEUFWNVOWSVKVLXA
        WTWKWOHCDEFGIKMLNVHTVOWSVKVMXBWTWKWPHCDEFGJKMLNVHTWBWCBGVQVSFWRKWQOVFTV
        I $.
    $}

    nlmdsdir.n $e |- N = ( norm ` W ) $.
    nlmdsdir.e $e |- E = ( dist ` F ) $.
    $( Distribute a distance calculation.  (Contributed by Mario Carneiro,
       6-Oct-2015.) $)
    nlmdsdir $p |- ( ( W e. NrmMod /\ ( X e. K /\ Y e. K /\ Z e. V ) ) ->
      ( ( X E Y ) x. ( N ` Z ) ) = ( ( X .x. Z ) D ( Y .x. Z ) ) ) $=
      ( wcel co cnlm w3a wa csg cfv cnm cmul wceq simpl cgrp cngp adantr ngpgrp
      nlmngp2 syl simpr1 simpr2 eqid grpsubcl syl3anc simpr3 nmvs clmod nlmlmod
      lmodsubdir fveq2d eqtr3d ngpds oveq1d nlmngp lmodvscl 3eqtr4d ) HUASZIESZ
      JESZKGSZUBZUCZIJDUDUEZTZDUFUEZUEZKFUEZUGTZIKBTZJKBTZHUDUEZTZFUEZIJCTZWCUG
      TWEWFATZVRVTKBTZFUEZWDWIVRVMVTESZVPWMWDUHVMVQUIVRDUJSZVNVOWNVRDUKSZWOVMWP
      VQDHNUNULZDUMUOVMVNVOVPUPZVMVNVOVPUQZEDVSIJOVSURZUSUTVMVNVOVPVAZWABDEFGHV
      TKLQMNOWAURZVBUTVRWLWHFVRIJVSBDEWGGHKLMNOWGURZWTVMHVCSZVQHVDULZWRWSXAVEVF
      VGVRWJWBWCUGVRWPVNVOWJWBUHWQWRWSIJCDVSWAEXBOWTRVHUTVIVRHUKSZWEGSZWFGSZWKW
      IUHVMXFVQHVJULVRXDVNVPXGXEWRXAIBDEGHKLNMOVKUTVRXDVOVPXHXEWSXAJBDEGHKLNMOV
      KUTWEWFAHWGFGQLXCPVHUTVL $.
  $}

  ${
    nlmmul0or.v $e |- V = ( Base ` W ) $.
    nlmmul0or.s $e |- .x. = ( .s ` W ) $.
    nlmmul0or.z $e |- .0. = ( 0g ` W ) $.
    nlmmul0or.f $e |- F = ( Scalar ` W ) $.
    nlmmul0or.k $e |- K = ( Base ` F ) $.
    nlmmul0or.o $e |- O = ( 0g ` F ) $.
    $( If a scalar product is zero, one of its factors must be zero.
       (Contributed by NM, 6-Dec-2007.)  (Revised by Mario Carneiro,
       4-Oct-2015.) $)
    nlmmul0or $p |- ( ( W e. NrmMod /\ A e. K /\ B e. V ) ->
                    ( ( A .x. B ) = .0. <-> ( A = O \/ B = .0. ) ) ) $=
      ( wcel cfv cc0 wceq syl2anc cnlm w3a cnm cmul co wo cngp nlmngp2 3ad2ant1
      cr simp2 eqid nmcl recnd nlmngp simp3 mul0ord nmvs clmod nlmlmod lmodvscl
      eqeq1d wb syl3an1 nmeq0 bitr3d orbi12d 3bitr3d ) HUAPZAEPZBGPZUBZADUCQZQZ
      BHUCQZQZUDUEZRSZVNRSZVPRSZUFABCUEZISZAFSZBISZUFVLVNVPVLVNVLDUGPZVJVNUJPVI
      VJWEVKDHMUHUIZVIVJVKUKZADVMENVMULZUMTUNVLVPVLHUGPZVKVPUJPVIVJWIVKHUOUIZVI
      VJVKUPZBHVOGJVOULZUMTUNUQVLWAVOQZRSZVRWBVLWMVQRVMCDEVOGHABJWLKMNWHURVBVLW
      IWAGPZWNWBVCWJVIHUSPVJVKWOHUTACDEGHBJMKNVAVDWAHVOGIJWLLVETVFVLVSWCVTWDVLW
      EVJVSWCVCWFWGADVMEFNWHOVETVLWIVKVTWDVCWJWKBHVOGIJWLLVETVGVH $.
  $}

  ${
    $d x y A $.  $d x y S $.  $d x y W $.
    sranlm.a $e |- A = ( ( subringAlg ` W ) ` S ) $.
    $( The subring algebra over a normed ring is a normed left module.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    sranlm $p |- ( ( W e. NrmRing /\ S e. ( SubRing ` W ) ) ->
      A e. NrmMod ) $=
      ( vx vy cnrg wcel cfv wa cngp cnm cmul wceq cbs adantr eqid adantl eqtr3d
      co csubrg clmod csca w3a cv cvsca wral cnlm nrgngp eqidd csra a1i subrgss
      wss srabase sraaddg proplem3 cds cxp srads reseq1d sratopn ngppropd mpbid
      cplusg sralmod cress srasca subrgnrg eqeltrrd 3jca nrgabv ad2antrr simprl
      cmulr subrgbas fveq2d eqtrd eleqtrrd sseldd simprr abvmul syl3anc nmpropd
      cabv sravsca fveq12d subrgsubg ad2antlr subgnm2 syl2anc fveq1d ralrimivva
      csubg oveq12d isnlm sylanbrc ) CGHZBCUAIHZJZAKHZAUBHZAUCIZGHZUDEUEZFUEZAU
      FIZTZALIZIZXEXCLIZIZXFXIIZMTZNZFAOIZUGEXCOIZUGAUHHWTXAXBXDWTCKHZXAWRXRWSC
      UIPWTEFCOIZCAWTXSUJWTABCABCUKIINWTDULZWSBXSUNZWRBXSCXSQZUMRZUOZWTXEXSHZXF
      XSHZJEFCVEIAVEIWTABCXTYCUPZUQWTCURIAURIXSXSUSWTABCXTYCUTZVAWTABCXTYCVBVCV
      DWSXBWRABCDVFRWTCBVGTZXCGWTABCXTYCVHZBCYIYIQZVIVJVKWTXOEFXQXPWTXEXQHZXFXP
      HZJZJZXECLIZIZXFYPIZMTZXJXNYOXEXFCVOIZTZYPIZYSXJYOYPCWEIZHZYEYFUUBYSNWRUU
      DWSYNUUCCYPYPQZUUCQZVLVMYOBXSXEWTYAYNYCPYOXEXQBWTYLYMVNWTBXQNYNWTBYIOIZXQ
      WSBUUGNWRBCYIYKVPRWTYIXCOYJVQVRPVSZVTYOXFXPXSWTYLYMWAWTXSXPNYNYDPVSUUCXSC
      YTYPXEXFUUFYBYTQWBWCYOUUAXHYPXIWTYPXINYNWTCAYDYGYHWDPZWTYNEFYTXGWTABCXTYC
      WFUQWGSYOYQXLYRXMMYOXEYILIZIZYQXLYOBCWNIHZXEBHUUKYQNWSUULWRYNBCWHWIUUHBCY
      IUUJYPXEYKUUEUUJQWJWKYOXEUUJXKYOYIXCLWTYIXCNYNYJPVQWLSYOXFYPXIUUIWLWOSWME
      FXKXGXCXQXIXPAXPQXIQXGQXCQXQQXKQWPWQ $.
  $}

  ${
    $d r B $.  $d r D $.  $d r E $.  $d x y ph $.  $d r x y T $.  $d r x y U $.
    $d r s w x y z F $.  $d r y K $.  $d r R $.  $d r V $.  $d r s w x y z W $.
    $d r s w x y z .x. $.  $d r X $.
    nlmvscn.f $e |- F = ( Scalar ` W ) $.
    ${
      nlmvscn.v $e |- V = ( Base ` W ) $.
      nlmvscn.k $e |- K = ( Base ` F ) $.
      nlmvscn.d $e |- D = ( dist ` W ) $.
      nlmvscn.e $e |- E = ( dist ` F ) $.
      nlmvscn.n $e |- N = ( norm ` W ) $.
      nlmvscn.a $e |- A = ( norm ` F ) $.
      nlmvscn.s $e |- .x. = ( .s ` W ) $.
      nlmvscn.t $e |- T = ( ( R / 2 ) / ( ( A ` B ) + 1 ) ) $.
      nlmvscn.u $e |- U = ( ( R / 2 ) / ( ( N ` X ) + T ) ) $.
      nlmvscn.w $e |- ( ph -> W e. NrmMod ) $.
      nlmvscn.r $e |- ( ph -> R e. RR+ ) $.
      nlmvscn.b $e |- ( ph -> B e. K ) $.
      nlmvscn.x $e |- ( ph -> X e. V ) $.
      ${
        nlmvscn.c $e |- ( ph -> C e. K ) $.
        nlmvscn.y $e |- ( ph -> Y e. V ) $.
        nlmvscn.1 $e |- ( ph -> ( B E C ) < U ) $.
        nlmvscn.2 $e |- ( ph -> ( X D Y ) < T ) $.
        $( Lemma for ~ nlmvscn .  Compare this proof with the similar
           elementary proof ~ mulcn2 for continuity of multiplication on
           ` CC ` .  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
        nlmvscnlem2 $p |- ( ph -> ( ( B .x. X ) D ( C .x. Y ) ) < R ) $=
          ( co caddc cmt wcel cngp cnlm nlmngp syl ngpms clmod nlmlmod lmodvscl
          cr syl3anc mscl readdcld rpred cle wbr mstri syl13anc c1 cmul c2 cdiv
          cfv nlmngp2 nmcl syl2anc cc0 ge0p1rpd remulcld rehalfcld wceq nlmdsdi
          nmge0 cxme msxms xmsge0 lep1d lemul1ad eqbrtrrd clt ltmuldiv2d mpbird
          syl6breq lelttrd crp rphalfcld rpdivcld syl5eqel nlmdsdir cmin nm2dif
          resubcld csg ngpdsr breqtrrd ltled letrd lesubadd2d mpbid lemul2ad wb
          eqid 0re a1i ltaddrpd ltmuldiv syl112anc lt2halvesd ) ACPHUPZDQHUPZEU
          PZYGCQHUPZEUPZYJYHEUPZUQUPZFAOURUSZYGNUSZYHNUSZYIVHUSAOUTUSZYNAOVAUSZ
          YQUHOVBVCZOVDVCZAOVEUSZCLUSZPNUSZYOAYRUUAUHOVFVCZUJUKCHKLNOPSRUETVGVI
          ZAUUADLUSZQNUSZYPUUDULUMDHKLNOQSRUETVGVIZYGYHEONSUAVJVIAYKYLAYNYOYJNU
          SZYKVHUSYTUUEAUUAUUBUUGUUIUUDUJUMCHKLNOQSRUETVGVIZYGYJEONSUAVJVIZAYNU
          UIYPYLVHUSYTUUJUUHYJYHEONSUAVJVIZVKAFUIVLZAYNYOYPUUIYIYMVMVNYTUUEUUHU
          UJYGYHYJEONSUAVOVPAYKYLFUUKUULUUMAYKCBWAZVQUQUPZPQEUPZVRUPZFVSVTUPZUU
          KAUUOUUPAUUOAUUNAKUTUSZUUBUUNVHUSAYRUUSUHKORWBVCZUJCKBLTUDWCWDZAUUSUU
          BWEUUNVMVNUUTUJCKBLTUDWKWDWFZVLZAYNUUCUUGUUPVHUSYTUKUMPQEONSUAVJVIZWG
          AFUUMWHZAUUNUUPVRUPZYKUUQVMAYRUUBUUCUUGUVFYKWIUHUJUKUMBEHKLNOCPQSUERT
          UAUDWJVPAUUNUUOUUPUVAUVCUVDAOWLUSZUUCUUGWEUUPVMVNAYNUVGYTOWMVCUKUMPQE
          ONSUAWNVIAUUNUVAWOWPWQAUUQUURWRVNUUPUURUUOVTUPZWRVNAUUPGUVHWRUOUFXAAU
          UPUURUUOUVDUVEUVBWSWTXBAYLCDJUPZPMWAZGUQUPZVRUPZUURUULAUVIUVKAKURUSZU
          UBUUFUVIVHUSZAUUSUVMUUTKVDVCZUJULCDJKLTUBVJVIZAUVJGAYQUUCUVJVHUSYSUKP
          OMNSUCWCWDZAGAGUVHXCUFAUURUUOAFUIXDUVBXEXFZVLZVKZWGUVEAUVIQMWAZVRUPZY
          LUVLVMAYRUUBUUFUUGUWBYLWIUHUJULUMEHJKLMNOCDQSUERTUAUCUBXGVPAUWAUVKUVI
          AYQUUGUWAVHUSYSUMQOMNSUCWCWDZUVTUVPAKWLUSZUUBUUFWEUVIVMVNAUVMUWDUVOKW
          MVCUJULCDJKLTUBWNVIAUWAUVJXHUPZGVMVNUWAUVKVMVNAUWEUUPGAUWAUVJUWCUVQXJ
          UVDUVSAUWEQPOXKWAZUPMWAZUUPVMAYQUUGUUCUWEUWGVMVNYSUMUKQPOUWFMNSUCUWFX
          TZXIVIAYQUUCUUGUUPUWGWIYSUKUMPQEOUWFMNUCSUWHUAXLVIXMAUUPGUVDUVSUOXNXO
          AUWAUVJGUWCUVQUVSXPXQXRWQAUVLUURWRVNZUVIUURUVKVTUPZWRVNZAUVIIUWJWRUNU
          GXAAUVNUURVHUSUVKVHUSWEUVKWRVNUWIUWKXSUVPUVEUVTAWEUVJUVKWEVHUSAYAYBUV
          QUVTAYQUUCWEUVJVMVNYSUKPOMNSUCWKWDAUVJGUVQUVRYCXBUVIUURUVKYDYEWTXBYFX
          B $.
      $}

      $( Lemma for ~ nlmvscn .  (Contributed by Mario Carneiro, 5-Oct-2015.) $)
      nlmvscnlem1 $p |- ( ph ->
        E. r e. RR+ A. x e. K A. y e. V ( ( ( B E x ) < r /\ ( X D y ) < r ) ->
          ( ( B .x. X ) D ( x .x. y ) ) < R ) ) $=
        ( cle wbr cif crp wcel cv co clt wa wi wral wrex c2 cfv caddc rphalfcld
        cdiv c1 cngp cr cnlm nlmngp2 syl syl2anc cc0 ge0p1rpd rpdivcld syl5eqel
        nmcl nmge0 nlmngp rpred readdcld 0re ltaddrpd lelttrd elrpd ifcl adantr
        a1i simprll simprlr cmt ngpms mscl syl3anc simprrl min2 ltletrd simprrr
        min1 nlmvscnlem2 expr ralrimivva breq2 anbi12d imbi1d 2ralbidv rspcev
        wceq ) AHJUMUNZHJUOZUPUQZEBURZKUSZXNUTUNZQCURZFUSZXNUTUNZVAZEQIUSXPXSIU
        SFUSGUTUNZVBZCOVCBMVCZXQRURZUTUNZXTYFUTUNZVAZYCVBZCOVCBMVCZRUPVDAHUPUQJ
        UPUQXOAHGVEVIUSZEDVFZVJVGUSZVIUSUPUGAYLYNAGUJVHZAYMALVKUQZEMUQZYMVLUQAP
        VMUQZYPUILPSVNVOZUKELDMUAUEWAVPAYPYQVQYMUMUNYSUKELDMUAUEWBVPVRVSVTZAJYL
        QNVFZHVGUSZVIUSUPUHAYLUUBYOAUUBAUUAHAPVKUQZQOUQZUUAVLUQAYRUUCUIPWCVOZUL
        QPNOTUDWAVPZAHYTWDZWEZAVQUUAUUBVQVLUQAWFWLUUFUUHAUUCUUDVQUUAUMUNUUEULQP
        NOTUDWBVPAUUAHUUFYTWGWHWIVSVTZXMHJUPWJVPZAYDBCMOAXPMUQZXSOUQZVAZYBYCAUU
        MYBVAZVAZDEXPFGHIJKLMNOPQXSSTUAUBUCUDUEUFUGUHAYRUUNUIWKAGUPUQUUNUJWKAYQ
        UUNUKWKZAUUDUUNULWKZAUUKUULYBWMZAUUKUULYBWNZUUOXQXNJUUOLWOUQZYQUUKXQVLU
        QUUOYPUUTAYPUUNYSWKLWPVOUUPUUREXPKLMUAUCWQWRUUOXNAXOUUNUUJWKWDZAJVLUQZU
        UNAJUUIWDWKZAUUMXRYAWSUUOHVLUQZUVBXNJUMUNAUVDUUNUUGWKZUVCHJWTVPXAUUOXTX
        NHUUOPWOUQZUUDUULXTVLUQAUVFUUNAUUCUVFUUEPWPVOWKUUQUUSQXSFPOTUBWQWRUVAUV
        EAUUMXRYAXBUUOUVDUVBXNHUMUNUVEUVCHJXCVPXAXDXEXFYKYERXNUPYFXNXLZYJYDBCMO
        UVGYIYBYCUVGYGXRYHYAYFXNXQUTXGYFXNXTUTXGXHXIXJXKVP $.
    $}

    nlmvscn.sf $e |- .x. = ( .sf ` W ) $.
    nlmvscn.j $e |- J = ( TopOpen ` W ) $.
    nlmvscn.kf $e |- K = ( TopOpen ` F ) $.
    $( The scalar multiplication of a normed module is continuous.  Lemma for
       ~ nrgtrg and ~ nlmtlm .  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    nlmvscn $p |- ( W e. NrmMod -> .x. e. ( ( K tX J ) Cn J ) ) $=
      ( vz vs vw wcel cfv co clt wa wral crp eqid vx vy cnlm cds cbs cres cmopn
      vr cxp ctx ccn wf cv wbr wi wrex clmod nlmlmod lmodscaf syl cvsca c2 cdiv
      c1 caddc simpll simpr simplrl simplrr nlmvscnlem1 ralrimiva simprl ovresd
      cnm breq1d simprr anbi12d wceq scafval ad2antlr oveq12d ad2antrr lmodvscl
      adantl syl3anc eqtrd imbi12d 2ralbidva rexbidv ralbidv ralrimivva cxmt wb
      mpbird cmt cxme cngp nlmngp2 ngpms msxms xmsxmet nlmngp txmetcn mpbir2and
      3syl mstopn eleqtrrd ) EUCMZABUDNZBUENZXJUIUFZUGNZEUDNZEUENZXNUIUFZUGNZUJ
      OZXPUKOZDCUJOZCUKOXHAXRMZXJXNUIXNAULZUAUMZJUMZXKOZKUMZPUNZUBUMZLUMZXOOZYE
      PUNZQZYBYGAOZYCYHAOZXOOZUHUMZPUNZUOZLXNRJXJRZKSUPZUHSRZUBXNRUAXJRZXHEUQMZ
      YAEURZXNABXJEXNTZFXJTZGUSUTXHYTUAUBXJXNXHYBXJMZYGXNMZQZQZYTYBYCXIOZYEPUNZ
      YGYHXMOZYEPUNZQZYBYGEVANZOZYCYHUUOOZXMOZYOPUNZUOZLXNRJXJRZKSUPZUHSRUUIUVB
      UHSUUIYOSMZQJLBVNNZYBXMYOYOVBVCOZYBUVDNVDVEOVCOZUUOUVEYGEVNNZNUVFVEOVCOZX
      IBXJUVGXNEYGKFUUDUUEXMTXITUVGTUVDTUUOTZUVFTUVHTXHUUHUVCVFUUIUVCVGXHUUFUUG
      UVCVHXHUUFUUGUVCVIVJVKUUIYSUVBUHSUUIYRUVAKSUUIYQUUTJLXJXNUUIYCXJMZYHXNMZQ
      ZQZYKUUNYPUUSUVMYFUUKYJUUMUVMYDUUJYEPUVMYBYCXIXJXHUUFUUGUVLVHZUUIUVJUVKVL
      ZVMVOUVMYIUULYEPUVMYGYHXMXNXHUUFUUGUVLVIZUUIUVJUVKVPZVMVOVQUVMYNUURYOPUVM
      YNUUPUUQXOOUURUVMYLUUPYMUUQXOUUHYLUUPVRXHUVLXNAUUOBXJEYBYGUUDFUUEGUVIVSVT
      UVLYMUUQVRUUIXNAUUOBXJEYCYHUUDFUUEGUVIVSWDWAUVMUUPUUQXMXNUVMUUBUUFUUGUUPX
      NMXHUUBUUHUVLUUCWBZUVNUVPYBUUOBXJXNEYGUUDFUVIUUEWCWEUVMUUBUVJUVKUUQXNMUVR
      UVOUVQYCUUOBXJXNEYHUUDFUVIUUEWCWEVMWFVOWGWHWIWJWNWKXHXKXJWLNMZXOXNWLNMZUV
      TXTYAUUAQWMXHBWOMZBWPMUVSXHBWQMUWABEFWRBWSUTZBWTXKBXJUUEXKTZXAXEXHEWOMZEW
      PMUVTXHEWQMUWDEXBEWSUTZEWTXOEXNUUDXOTZXAXEZUWGUAUBUHKLJXKXOXOAXLXPXPXJXNX
      NXLTXPTZUWHXCWEXDXHXSXQCXPUKXHDXLCXPUJXHUWADXLVRUWBXKDBXJIUUEUWCXFUTXHUWD
      CXPVRUWEXOCEXNHUUDUWFXFUTZWAUWIWAXG $.
  $}

  $( The ring module over a normed ring is a normed module.  (Contributed by
     Mario Carneiro, 4-Oct-2015.) $)
  rlmnlm $p |- ( R e. NrmRing -> ( ringLMod ` R ) e. NrmMod ) $=
    ( cnrg wcel cbs cfv csubrg crglmod cnlm crg nrgrng subrgid syl rlmval mpdan
    eqid sranlm ) ABCZADEZAFECZAGEZHCQAICSAJRAROKLTRAAMPN $.

  $( A normed ring is a topological ring.  (Contributed by Mario Carneiro,
     4-Oct-2015.) $)
  nrgtrg $p |- ( R e. NrmRing -> R e. TopRing ) $=
    ( cnrg wcel ctgp crg cmgp cfv ctps ctopn co eqid syl istps wceq wtru strfvi
    cbs a1i cts syl3anbrc ctmd ctrg nrgtgp nrgrng cmnd cplusf ctx rngmgp ctopon
    ccn tgptps sylib mgpbas mgptopn sylibr crglmod cnlm rlmsca2 rlmscaf rlmtopn
    rlmnlm cid c1 df-base c9 df-tset topnpropd trud nlmvscn istmd istrg ) ABCZA
    DCZAECZAFGZUACZAUBCAUCZAUDZVLVOUECZVOHCZVOUFGZAIGZWBUGJWBUJJCZVPVLVNVSVRAVO
    VOKZUHLVLWBAQGZUIGCZVTVLAHCZWFVLVMWGVQAUKLWEWBAWEKZWBKZMULWEWBVOWEAVOWDWHUM
    AWBVOWDWIUNZMUOVLAUPGZUQCWCAVAWAAVBGZWBWBWKAURAUSAUTWBWLIGNOAWLWEWLQGNOAQVC
    WEVDWHPRASGZWLSGNOASVEWMVFWMKPRVGVHVILWAVOWBWAKWJVJTAVOWDVKT $.

  ${
    $d r s x y I $.  $d y ph $.  $d r s x y R $.  $d x y T $.  $d r s x y U $.
    $d x A $.  $d x B $.  $d x D $.
    nrginvrcn.x $e |- X = ( Base ` R ) $.
    nrginvrcn.u $e |- U = ( Unit ` R ) $.
    nrginvrcn.i $e |- I = ( invr ` R ) $.
    ${
      nrginvrcn.n $e |- N = ( norm ` R ) $.
      nrginvrcn.d $e |- D = ( dist ` R ) $.
      nrginvrcn.r $e |- ( ph -> R e. NrmRing ) $.
      nrginvrcn.z $e |- ( ph -> R e. NzRing ) $.
      nrginvrcn.a $e |- ( ph -> A e. U ) $.
      nrginvrcn.b $e |- ( ph -> B e. RR+ ) $.
      nrginvrcn.t $e |- T = ( if ( 1 <_ ( ( N ` A ) x. B ) ,
        1 , ( ( N ` A ) x. B ) ) x. ( ( N ` A ) / 2 ) ) $.
      $( Lemma for ~ nrginvrcn .  Compare this proof with ~ reccn2 , the
         elementary proof of continuity of division.  (Contributed by Mario
         Carneiro, 6-Oct-2015.) $)
      nrginvrcnlem $p |- ( ph -> E. x e. RR+ A. y e. U
        ( ( A D y ) < x -> ( ( I ` A ) D ( I ` y ) ) < B ) ) $=
        ( crp wcel cv co clt wbr cfv wi wral wrex c1 cmul cle cif cdiv 1rp cngp
        c0g wne cnrg nrgngp syl unitss sseldi cnzr eqid nzrunit syl2anc syl3anc
        c2 nmrpcl rpmulcld ifcl sylancr rphalfcld syl5eqel wa csg wceq cmulr cr
        cur adantr unitcl nmcl recnd simprl ngpgrp crg nrgrng rnginvcl grpsubcl
        mul32d nmmul rngsubdi unitrinv oveq1d eqtrd fveq2d eqtr3d rngidcl rngcl
        rngsubdir rnglidm rngass syl13anc unitlinv oveq2d rngridm oveq12d rpred
        cgrp 3eqtrd rpne0d divmuld mpbird ngpdsr ngpds 3eqtr4rd remulcld simprr
        eqeltrd min2 lemul1d mpbid syl5eqbr caddc 2halvesd cmin resubcld nm2dif
        1re breqtrrd min1 a1i mulid2d lelttrd eqbrtrd ltsubadd2d ltmul2dd lttrd
        breqtrd ltletrd ltadd1d ltdivmuld ralrimiva breq2 imbi1d ralbidv rspcev
        expr ) AHUCUDZDCUEZFUFZHUGUHZDJUIZUUOJUIZFUFZEUGUHZUJZCIUKZUUPBUEZUGUHZ
        UVAUJZCIUKZBUCULAHUMDKUIZEUNUFZUOUHZUMUVIUPZUVHVLUQUFZUNUFZUCUBAUVKUVLA
        UMUCUDUVIUCUDZUVKUCUDZURAUVHEAGUSUDZDLUDZDGUTUIZVAZUVHUCUDZAGVBUDZUVPRG
        VCVDZAILDLGIMNVEZTVFAGVGUDZDIUDZUVSSTDGIUVRNUVRVHZVIVJDGKLUVRMPUWFVMVKZ
        UAVNZUVJUMUVIUCVOVPZAUVHUWGVQVNVRZAUVBCIAUUOIUDZUUQUVAAUWKUUQVSZVSZUUTU
        UPUVHUUOKUIZUNUFZUQUFZEUGUWMUUODGVTUIZUFZKUIZUWOUQUFZUURUUSUWQUFZKUIZUW
        PUUTUWMUWTUXBWAUWOUXBUNUFZUWSWAUWMUXCUVHUXBUNUFZUWNUNUFGWDUIZDUUSGWBUIZ
        UFZUWQUFZKUIZUWNUNUFZUWSUWMUVHUWNUXBUWMUVHUWMUVPUVQUVHWCUDAUVPUWLUWBWEZ
        UWMUWEUVQAUWEUWLTWEZLGIDMNWFVDZDGKLMPWGVJZWHZUWMUWNUWMUVPUUOLUDZUWNWCUD
        UXKUWMILUUOUWCAUWKUUQWIZVFZUUOGKLMPWGVJZWHZUWMUXBUWMUVPUXALUDZUXBWCUDUX
        KUWMGXNUDZUURLUDZUUSLUDZUYAUWMUVPUYBUXKGWJVDZUWMGWKUDZUWEUYCAUYFUWLAUWA
        UYFRGWLVDWEZUXLLGIJDNOMWMVJZUWMUYFUWKUYDUYGUXQLGIJUUONOMWMVJZLGUWQUURUU
        SMUWQVHZWNVKZUXAGKLMPWGVJWHZWOUWMUXDUXIUWNUNUWMDUXAUXFUFZKUIZUXDUXIUWMU
        WAUVQUYAUYNUXDWAAUWAUWLRWEZUXMUYKDUXAGUXFKLMPUXFVHZWPVKUWMUYMUXHKUWMUYM
        DUURUXFUFZUXGUWQUFUXHUWMLGUXFUWQDUURUUSMUYPUYJUYGUXMUYHUYIWQUWMUYQUXEUX
        GUWQUWMUYFUWEUYQUXEWAUYGUXLGUXFIUXEJDNOUYPUXEVHZWRVJWSWTXAXBWSUWMUXHUUO
        UXFUFZKUIZUXJUWSUWMUWAUXHLUDZUXPUYTUXJWAUYOUWMUYBUXELUDZUXGLUDZVUAUYEUW
        MUYFVUBUYGLGUXEMUYRXCVDZUWMUYFUVQUYDVUCUYGUXMUYILGUXFDUUSMUYPXDVKZLGUWQ
        UXEUXGMUYJWNVKUXRUXHUUOGUXFKLMPUYPWPVKUWMUYSUWRKUWMUYSUXEUUOUXFUFZUXGUU
        OUXFUFZUWQUFUWRUWMLGUXFUWQUXEUXGUUOMUYPUYJUYGVUDVUEUXRXEUWMVUFUUOVUGDUW
        QUWMUYFUXPVUFUUOWAUYGUXRLGUXFUXEUUOMUYPUYRXFVJUWMVUGDUUSUUOUXFUFZUXFUFZ
        DUXEUXFUFZDUWMUYFUVQUYDUXPVUGVUIWAUYGUXMUYIUXRLGUXFDUUSUUOMUYPXGXHUWMVU
        HUXEDUXFUWMUYFUWKVUHUXEWAUYGUXQGUXFIUXEJUUONOUYPUYRXIVJXJUWMUYFUVQVUJDW
        AUYGUXMLGUXFUXEDMUYPUYRXKVJXOXLWTXAXBXOUWMUWSUWOUXBUWMUWSUWMUVPUWRLUDZU
        WSWCUDUXKUWMUYBUXPUVQVUKUYEUXRUXMLGUWQUUODMUYJWNVKUWRGKLMPWGVJZWHUWMUWO
        UWMUWOUWMUVHUWNAUVTUWLUWGWEZUWMUVPUXPUUOUVRVAZUWNUCUDUXKUXRUWMUWDUWKVUN
        AUWDUWLSWEUXQUUOGIUVRNUWFVIVJUUOGKLUVRMPUWFVMVKVNZXMZWHUYLUWMUWOVUOXPXQ
        XRUWMUUPUWSUWOUQUWMUVPUVQUXPUUPUWSWAUXKUXMUXRDUUOFGUWQKLPMUYJQXSVKZWSUW
        MUVPUYCUYDUUTUXBWAUXKUYHUYIUURUUSFGUWQKLPMUYJQXTVKYAUWMUWPEUGUHUUPUWOEU
        NUFZUGUHUWMUUPHVURUWMUUPUWSWCVUQVULYDZUWMHAUUNUWLUWJWEXMZUWMUWOEVUPUWME
        AEUCUDUWLUAWEXMZYBZAUWKUUQYCZUWMHUVIUVLUNUFZVURVUTUWMVVDUWMUVIUVLAUVNUW
        LUWHWEZUWMUVHVUMVQZVNXMVVBUWMHUVMVVDUOUBUWMUVKUVIUOUHZUVMVVDUOUHUWMUMWC
        UDZUVIWCUDZVVGYNUWMUVIVVEXMZUMUVIYEVPUWMUVKUVIUVLUWMUVKAUVOUWLUWIWEXMZV
        VJVVFYFYGYHUWMVVDUVIUWNUNUFVURUGUWMUVLUWNUVIUWMUVLVVFXMZUXSVVEUWMUVLUWN
        UGUHUVLUVLYIUFZUWNUVLYIUFZUGUHUWMVVMUVHVVNUGUWMUVHUXOYJUWMUVHUWNYKUFZUV
        LUGUHUVHVVNUGUHUWMVVOUUPUVLUWMUVHUWNUXNUXSYLVUSVVLUWMVVODUUOUWQUFKUIZUU
        PUOUWMUVPUVQUXPVVOVVPUOUHUXKUXMUXRDUUOGUWQKLMPUYJYMVKUWMUVPUVQUXPUUPVVP
        WAUXKUXMUXRDUUOFGUWQKLPMUYJQXTVKYOUWMUUPHUVLVUSVUTVVLVVCUWMHUMUVLUNUFZU
        VLUOUWMHUVMVVQUOUBUWMUVKUMUOUHZUVMVVQUOUHUWMVVHVVIVVRYNVVJUMUVIYPVPUWMU
        VKUMUVLVVKVVHUWMYNYQVVFYFYGYHUWMUVLUWMUVLVVLWHYRUUDUUEYSUWMUVHUWNUVLUXN
        UXSVVLUUAYGYTUWMUVLUWNUVLVVLUXSVVLUUFXRUUBUWMUVHUWNEUXOUXTUWMEVVAWHWOYO
        YSUUCUWMUUPEUWOVUSVVAVUOUUGXRYTUUMUUHUVGUVCBHUCUVDHWAZUVFUVBCIVVSUVEUUQ
        UVAUVDHUUPUGUUIUUJUUKUULVJ $.
    $}

    nrginvrcn.j $e |- J = ( TopOpen ` R ) $.
    $( The ring inverse function is continuous in a normed ring.  (Note that
       this is true even in rings which are not division rings.)  (Contributed
       by Mario Carneiro, 6-Oct-2015.) $)
    nrginvrcn $p |- ( R e. NrmRing -> I e. ( ( J |`t U ) Cn ( J |`t U ) ) ) $=
      ( vy vs wcel cfv co clt wbr crp eqid wa wceq vx vr cnrg cds cxp cmopn ccn
      cres crest wf cv wi wral wrex crg cmgp cress cgrp nrgrng unitgrp invrfval
      unitgrpbas grpinvf 3syl cur c0g c0 wne c1 1rp ne0i ax-mp ad2antrr simplrl
      unitss sseldi simpr rng1eq0 syl3anc cc0 cxme cngp cmt nrgngp ngpms adantr
      wb msxms ffvelrnda xmseq0 mpbiri simplrr rpgt0d eqbrtrd oveq1d syl5ibrcom
      fveq2 breq1d syld imp a1d ralrimiva ralrimivw r19.2z sylancr cnm cmul cle
      an32s cif cdiv simpll isnzr sylanbrc nrginvrcnlem pm2.61dane ovresd simpl
      cnzr ffvelrn syl2an imbi12d ralbidva rexbidv mpbird ralrimivva wss xpss12
      c2 cxmt resabs1 xmsxmet 4syl xmetres2 sylancl syl5eqelr syl2anc mpbir2and
      mp2an metcn mstopn eqcomi metrest eqtrd oveq12d eleqtrrd ) AUCLZCAUDMZBBU
      EZUHZUFMZUUKUGNZDBUINZUUMUGNUUGCUULLZBBCUJZUAUKZJUKZUUJNZKUKZOPZUUPCMZUUQ
      CMZUUJNZUBUKZOPZULZJBUMZKQUNZUBQUMUABUMZUUGAUOLZAUPMBUQNZURLUUOAUSZABUVKG
      UVKRZUTBUVKCABUVKGUVMVBABUVKCGUVMHVAVCVDZUUGUVHUAUBBQUUGUUPBLZUVDQLZSZSZU
      VHUUPUUQUUHNZUUSOPZUVAUVBUUHNZUVDOPZULZJBUMZKQUNZUVRUWEAVEMZAVFMZUVRUWFUW
      GTZSZQVGVHZUWDKQUMUWEVIQLUWJVJQVIVKVLUWIUWDKQUWIUWCJBUWIUUQBLZSUWBUVTUVRU
      WKUWHUWBUVRUWKSZUWHUWBUWLUWHUUPUUQTZUWBUWLUVJUUPELUUQELUWHUWMULUUGUVJUVQU
      WKUVLVMUWLBEUUPEABFGVOZUUGUVOUVPUWKVNZVPUWLBEUUQUWNUVRUWKVQZVPEAUWFUUPUUQ
      UWGFUWFRZUWGRZVRVSUWLUWBUWMUVBUVBUUHNZUVDOPUWLUWSVTUVDOUWLUWSVTTZUVBUVBTZ
      UVBRUWLAWALZUVBELZUXCUWTUXAWGUUGUXBUVQUWKUUGAWBLZAWCLZUXBAWDZAWEZAWHZVDVM
      UWLBEUVBUWNUVRBBUUQCUUGUUOUVQUVNWFWIZVPZUXJUVBUVBUUHAEFUUHRZWJVSWKUWLUVDU
      UGUVOUVPUWKWLWMWNUWMUWAUWSUVDOUWMUVAUVBUVBUUHUUPUUQCWQWOWRWPWSWTXIXAXBXCU
      WDKQXDXEUVRUWFUWGVHZSZKJUUPUVDUUHAVIUUPAXFMZMZUVDXGNZXHPVIUXPXJUXOYIXKNXG
      NZBCUXNEFGHUXNRUXKUUGUVQUXLXLUXMUVJUXLAXSLUUGUVJUVQUXLUVLVMUVRUXLVQAUWFUW
      GUWQUWRXMXNUUGUVOUVPUXLVNUUGUVOUVPUXLWLUXQRXOXPUVRUVGUWDKQUVRUVFUWCJBUWLU
      UTUVTUVEUWBUWLUURUVSUUSOUWLUUPUUQUUHBUWOUWPXQWRUWLUVCUWAUVDOUWLUVAUVBUUHB
      UVRUVABLZUWKUUGUUOUVOUXRUVQUVNUVOUVPXRBBUUPCXTYAWFUXIXQWRYBYCYDYEYFUUGUUJ
      BYJMZLZUXTUUNUUOUVISWGUUGUUJUUHEEUEZUHZUUIUHZUXSUUIUYAYGZUYCUUJTBEYGZUYEU
      YDUWNUWNBEBEYHYSUUHUUIUYAYKVLZUUGUYBEYJMLZUYEUYCUXSLUUGUXDUXEUXBUYGUXFUXG
      UXHUYBAEFUYBRZYLYMZUWNUYBBEYNYOYPZUYJUAUBKJUUJUUJCUUKUUKBBUUKRZUYKYTYQYRU
      UGUUMUUKUUMUUKUGUUGUUMUYBUFMZBUINZUUKUUGDUYLBUIUUGUXDUXEDUYLTUXFUXGUYBDAE
      IFUYHUUAVDWOUUGUYGUYEUYMUUKTUYIUWNUYBUUJUYLUUKEBUYCUUJUYFUUBUYLRUYKUUCYOU
      UDZUYNUUEUUF $.
  $}

  $( A normed division ring is a topological division ring.  (Contributed by
     Mario Carneiro, 6-Oct-2015.) $)
  nrgtdrg $p |- ( ( R e. NrmRing /\ R e. DivRing ) -> R e. TopDRing ) $=
    ( cnrg wcel cdr wa ctrg cmgp cfv cui cress co ctgp ctdrg nrgtrg adantr ctmd
    simpr eqid syl syl3anbrc cgrp cinvr ctopn ccn nrgrng unitgrp csubmnd trgtmd
    crg unitsubm submtmd syl2anc cbs nrginvrcn mgptopn resstopn invrfval istdrg
    crest istgp ) ABCZADCZEZAFCZVBAGHZAIHZJKZLCZAMCVAVDVBANOZVAVBQVCVGUACZVGPCZ
    AUBHZAUCHZVFUSKZVNUDKCZVHVCAUICZVJVAVPVBAUEOZAVFVGVFRZVGRZUFSVCVEPCZVFVEUGH
    CZVKVCVDVTVIAVEVERZUHSVCVPWAVQAVFVEVRWBUJSVFVEVGVSUKULVAVOVBAVFVLVMAUMHZWCR
    VRVLRZVMRZUNOVGVLVNVFVGVMVEVSAVMVEWBWEUOUPAVFVGVLVRVSWDUQUTTAVFVEWBVRURT $.

  $( A normed module is a topological module.  (Contributed by Mario Carneiro,
     6-Oct-2015.) $)
  nlmtlm $p |- ( W e. NrmMod -> W e. TopMod ) $=
    ( cnlm wcel ctmd clmod csca cfv ctrg w3a cscaf ctopn ctx ccn ctlm ctgp cngp
    co cabel syl eqid nlmngp nlmlmod lmodabl ngptgp syl2anc tgptmd cnrg nlmvscn
    nlmnrg nrgtrg 3jca istlm sylanbrc ) ABCZADCZAECZAFGZHCZIAJGZUQKGZAKGZLQVAMQ
    CANCUNUOUPURUNAOCZUOUNAPCARCZVBAUAUNUPVCAUBZAUCSAUDUEAUFSVDUNUQUGCURUQAUQTZ
    UIUQUJSUKUSUQVAUTAVEUSTZVATZUTTZUHUSUQVAUTAVFVGVEVHULUM $.

  $( A normed vector space is just a normed module which is algebraically a
     vector space.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
  isnvc $p |- ( W e. NrmVec <-> ( W e. NrmMod /\ W e. LVec ) ) $=
    ( cnlm clvec cnvc df-nvc elin2 ) ABCDEF $.

  $( A normed vector space is a normed module.  (Contributed by Mario Carneiro,
     4-Oct-2015.) $)
  nvcnlm $p |- ( W e. NrmVec -> W e. NrmMod ) $=
    ( cnvc wcel cnlm clvec isnvc simplbi ) ABCADCAECAFG $.

  $( A normed vector space is a left vector space.  (Contributed by Mario
     Carneiro, 4-Oct-2015.) $)
  nvclvec $p |- ( W e. NrmVec -> W e. LVec ) $=
    ( cnvc wcel cnlm clvec isnvc simprbi ) ABCADCAECAFG $.

  $( A normed vector space is a left module.  (Contributed by Mario Carneiro,
     4-Oct-2015.) $)
  nvclmod $p |- ( W e. NrmVec -> W e. LMod ) $=
    ( cnvc wcel cnlm clmod nvcnlm nlmlmod syl ) ABCADCAECAFAGH $.

  ${
    isnvc2.1 $e |- F = ( Scalar ` W ) $.
    $( A normed vector space is just a normed module whose scalar ring is a
       division ring.  (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    isnvc2 $p |- ( W e. NrmVec <-> ( W e. NrmMod /\ F e. DivRing ) ) $=
      ( cnvc wcel cnlm clvec wa cdr isnvc clmod nlmlmod islvec baib syl pm5.32i
      wb bitri ) BDEBFEZBGEZHSAIEZHBJSTUASBKEZTUAQBLTUBUAABCMNOPR $.
  $}

  $( A normed vector space is a topological vector space.  (Contributed by
     Mario Carneiro, 4-Oct-2015.) $)
  nvctvc $p |- ( W e. NrmVec -> W e. TopVec ) $=
    ( cnvc wcel ctlm csca cfv ctdrg ctvc cnlm nvcnlm nlmtlm syl cnrg cdr nlmnrg
    eqid clvec nvclvec lvecdrng nrgtdrg syl2anc istvc sylanbrc ) ABCZADCZAEFZGC
    ZAHCUDAICZUEAJZAKLUDUFMCZUFNCZUGUDUHUJUIUFAUFPZOLUDAQCUKARUFAULSLUFTUAUFAUL
    UBUC $.

  ${
    $d x y S $.  $d x y U $.  $d x y W $.  $d x y X $.
    lssnlm.x $e |- X = ( W |`s U ) $.
    lssnlm.s $e |- S = ( LSubSp ` W ) $.
    $( A subspace of a normed module is a normed module.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    lssnlm $p |- ( ( W e. NrmMod /\ U e. S ) -> X e. NrmMod ) $=
      ( vx vy wcel wa cfv cnrg co cnm cmul wceq cbs adantr syl2anc eqid cnlm cv
      cngp clmod csca w3a cvsca wral csubg nlmngp nlmlmod lsssubg sylan subgngp
      lsslmod resssca adantl nlmnrg eqeltrrd 3jca simpll simprl fveq2d eleqtrrd
      wss subgss syl simprr subgbas sseldd nmvs syl3anc ressvsca oveqd ad2antrr
      simplr lssvscl syl22anc subgnm2 eqtr3d eqcomd oveq12d ralrimivva sylanbrc
      fveq1d 3eqtr4d isnlm ) CUAIZBAIZJZDUCIZDUDIZDUEKZLIZUFGUBZHUBZDUGKZMZDNKZ
      KZWOWMNKZKZWPWSKZOMZPZHDQKZUHGWMQKZUHDUAIWJWKWLWNWJCUCIZBCUIKIZWKWHXHWICU
      JRWHCUDIZWIXICUKZABCFULUMZBCDEUNSWHXJWIWLXKABCDEFUOUMWJCUEKZWMLWIXMWMPZWH
      BXMCDAEXMTZUPUQZWHXMLIWIXMCXOURRUSUTWJXEGHXGXFWJWOXGIZWPXFIZJZJZWOWPCUGKZ
      MZCNKZKZWOXMNKZKZWPYCKZOMZWTXDXTWHWOXMQKZIZWPCQKZIYDYHPWHWIXSVAXTWOXGYIWJ
      XQXRVBXTXMWMQWJXNXSXPRZVCVDZXTBYKWPXTXIBYKVEWJXIXSXLRZYKBCYKTZVFVGXTWPXFB
      WJXQXRVHXTXIBXFPYNBCDEVIVGVDZVJYEYAXMYIYCYKCWOWPYOYCTZYATZXOYITZYETVKVLXT
      YBWSKZWTYDXTYBWRWSXTYAWQWOWPXTWIYAWQPWHWIXSVPZBYACDAEYRVMVGVNVCXTXIYBBIZY
      TYDPYNXTXJWIYJWPBIZUUBWHXJWIXSXKVOUUAYMYPYIAYABXMCWOWPXOYRYSFVQVRBCDWSYCY
      BEYQWSTZVSSVTXTXBYFXCYGOXTWOXAYEXTWMXMNXTXMWMYLWAVCWEXTXIUUCXCYGPYNYPBCDW
      SYCWPEYQUUDVSSWBWFWCGHXAWQWMXGWSXFDXFTUUDWQTWMTXGTXATWGWD $.

    $( A subspace of a normed vector space is a normed vector space.
       (Contributed by Mario Carneiro, 4-Oct-2015.) $)
    lssnvc $p |- ( ( W e. NrmVec /\ U e. S ) -> X e. NrmVec ) $=
      ( cnvc wcel wa cnlm csca cfv nvcnlm lssnlm sylan wceq eqid resssca adantl
      cdr clvec nvclvec lvecdrng syl adantr eqeltrrd isnvc2 sylanbrc ) CGHZBAHZ
      IZDJHZDKLZTHDGHUICJHUJULCMABCDEFNOUKCKLZUMTUJUNUMPUIBUNCDAEUNQZRSUIUNTHZU
      JUICUAHUPCUBUNCUOUCUDUEUFUMDUMQUGUH $.
  $}

  $( The ring module over a normed division ring is a normed vector space.
     (Contributed by Mario Carneiro, 4-Oct-2015.) $)
  rlmnvc $p |- ( ( R e. NrmRing /\ R e. DivRing ) ->
    ( ringLMod ` R ) e. NrmVec ) $=
    ( cnrg wcel crglmod cfv cnlm clvec cnvc cdr rlmnlm rlmlvec wa isnvc biimpri
    syl2an ) ABCADEZFCZPGCZPHCZAICAJAKSQRLPMNO $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Normed space homomorphisms (bounded linear operators)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c normOp $. $( Operator norm $)
  $c NGHom $. $( Normed group homomorphism $)
  $c NMHom $. $( Normed module homomorphism $)

  $( The operator norm function. $)
  cnmo $a class normOp $.

  $( The class of normed group homomorphisms. $)
  cnghm $a class NGHom $.

  $( The class of normed module homomorphisms. $)
  cnmhm $a class NMHom $.

  ${
    $d f r s t x L $.  $d f r s t x M $.  $d f r s t x S $.  $d f r s t x T $.
    $d r s x A $.  $d f r s x F $.  $d x ph $.  $d f r s t x V $.  $d r x X $.
    $d r s t x N $.
    $( Define the norm of an operator between two normed groups (usually vector
       spaces).  This definition produces an operator norm function for each
       pair of groups ` <. s , t >. ` .  Equivalent to the definition of linear
       operator norm in [AkhiezerGlazman] p. 39.  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    df-nmo $a |- normOp = ( s e. NrmGrp , t e. NrmGrp |->
    ( f e. ( s GrpHom t ) |-> sup ( { r e. ( 0 [,) +oo ) | A. x e. ( Base ` s )
        ( ( norm ` t ) ` ( f ` x ) ) <_ ( r x. ( ( norm ` s ) ` x ) ) } ,
      RR* , `' < ) ) ) $.

    $( Define the set of normed group homomorphisms between two normed groups.
       A normed group homomorphism is a group homomorphism which additionally
       bounds the increase of norm by a fixed real operator.  In vector spaces
       these are also known as bounded linear operators.  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    df-nghm $a |- NGHom = ( s e. NrmGrp , t e. NrmGrp |->
      ( `' ( s normOp t ) " RR ) ) $.

    $( Define a normed module homomorphism, also known as a bounded linear
       operator.  This is a module homomorphism (a linear function) such that
       the operator norm is finite, or equivalently there is a constant ` c `
       such that (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    df-nmhm $a |- NMHom = ( s e. NrmMod , t e. NrmMod |->
      ( ( s LMHom t ) i^i ( s NGHom t ) ) ) $.

    $( The function producing operator norm functions is a function on normed
       groups.  (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    nmoffn $p |- normOp Fn ( NrmGrp X. NrmGrp ) $=
      ( vs vt vf vx vr cngp cghm cfv cnm cmul cle wbr cbs cc0 cpnf cxr cvv wcel
      cv co wral cico crab clt ccnv csup cmpt cnmo df-nmo wf wss ssrab2 icossxr
      eqid sstri infmxrcl mp1i fmpti ovex xrex fex2 mp3an fnmpt2i ) ABFFCASZBSZ
      GTZDSZCSZHVEIHHESVGVDIHHJTKLDVDMHUAZENOUBTZUCZPUDUEUFZUGZUHDBCAEUIVFPVMUJ
      VFQRPQRVMQRCVFPVLVMVMUNVKPUKVLPRVHVFRVKVJPVIEVJULNOUMUOVKUPUQURVDVEGUSUTV
      FPVMQQVAVBVC $.

    $( Lemma for normed group homomorphisms.  (Contributed by Mario Carneiro,
       18-Oct-2015.) $)
    reldmnghm $p |- Rel dom NGHom $=
      ( vs vt cngp cv cnmo co ccnv cr cima cnghm df-nghm reldmmpt2 ) ABCCADBDEF
      GHIJBAKL $.

    $( Lemma for module homomorphisms.  (Contributed by Mario Carneiro,
       18-Oct-2015.) $)
    reldmnmhm $p |- Rel dom NMHom $=
      ( vs vt cnlm cv clmhm co cnghm cin cnmhm df-nmhm reldmmpt2 ) ABCCADZBDZEF
      LMGFHIBAJK $.

    nmofval.1 $e |- N = ( S normOp T ) $.
    ${
      nmofval.2 $e |- V = ( Base ` S ) $.
      nmofval.3 $e |- L = ( norm ` S ) $.
      nmofval.4 $e |- M = ( norm ` T ) $.
      $( Value of the operator norm.  (Contributed by Mario Carneiro,
         18-Oct-2015.) $)
      nmofval $p |- ( ( S e. NrmGrp /\ T e. NrmGrp ) ->
        N = ( f e. ( S GrpHom T ) |-> sup ( { r e. ( 0 [,) +oo ) | A. x e. V
          ( M ` ( f ` x ) ) <_ ( r x. ( L ` x ) ) } , RR* , `' < ) ) ) $=
        ( wcel co cv cfv cxr cnm cvv vs vt cngp cnmo cghm cmul cle wbr wral cc0
        wa cpnf cico crab clt ccnv csup cmpt cbs wceq oveq12 simpl fveq2d simpr
        syl6eqr fveq1d oveq2d breq12d raleqbidv rabbidv mpteq12dv df-nmo wf wss
        supeq1d eqid ssrab2 icossxr sstri infmxrcl mp1i fmpti ovex xrex ovmpt2a
        fex2 mp3an syl5eq ) BUCNCUCNUKGBCUDODBCUEOZAPZDPZQZFQZIPZWJEQZUFOZUGUHZ
        AHUIZIUJULUMOZUNZRUOUPZUQZURZJUAUBBCUCUCDUAPZUBPZUEOZWLXESQZQZWNWJXDSQZ
        QZUFOZUGUHZAXDUSQZUIZIWSUNZRXAUQZURXCUDXDBUTZXECUTZUKZDXFXPWIXBXDBXECUE
        VAXSRXOWTXAXSXNWRIWSXSXLWQAXMHXSXMBUSQHXSXDBUSXQXRVBZVCKVEXSXHWMXKWPUGX
        SWLXGFXSXGCSQFXSXECSXQXRVDVCMVEVFXSXJWOWNUFXSWJXIEXSXIBSQEXSXDBSXTVCLVE
        VFVGVHVIVJVOVKAUBDUAIVLWIRXCVMWITNRTNXCTNDWIRXBXCXCVPWTRVNXBRNWKWINWTWS
        RWRIWSVQUJULVRVSWTVTWAWBBCUEWCWDWIRXCTTWFWGWEWH $.

      $( Value of the operator norm.  (Contributed by Mario Carneiro,
         18-Oct-2015.) $)
      nmoval $p |- ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) ->
        ( N ` F ) = sup ( { r e. ( 0 [,) +oo ) | A. x e. V
          ( M ` ( F ` x ) ) <_ ( r x. ( L ` x ) ) } , RR* , `' < ) ) $=
        ( vf wcel co cfv cv cle cxr cngp cghm cmul wbr wral cpnf cico crab ccnv
        cc0 clt csup wceq wa nmofval fveq1d fveq1 fveq2d breq1d ralbidv rabbidv
        cmpt supeq1d eqid wor xrltso cnvso mpbi supex fvmpt sylan9eq 3impa ) BU
        AOZCUAOZDBCUBPZOZDGQZARZDQZFQZIRVREQUCPZSUDZAHUEZIUJUFUGPZUHZTUKUIZULZU
        MVMVNUNZVPVQDNVOVRNRZQZFQZWASUDZAHUEZIWDUHZTWFULZVBZQWGWHDGWPABCNEFGHIJ
        KLMUOUPNDWOWGVOWPWIDUMZTWNWEWFWQWMWCIWDWQWLWBAHWQWKVTWASWQWJVSFVRWIDUQU
        RUSUTVAVCWPVDTWEWFTUKVETWFVEVFTUKVGVHVIVJVKVL $.

      $( Property of the operator norm.  (Contributed by Mario Carneiro,
         18-Oct-2015.) $)
      nmogelb $p |- ( ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) )
        /\ A e. RR* ) -> ( A <_ ( N ` F ) <-> A. r e. ( 0 [,) +oo )
         ( A. x e. V ( M ` ( F ` x ) ) <_ ( r x. ( L ` x ) ) -> A <_ r ) ) ) $=
        ( vs wcel cfv cle wbr cxr cngp cghm co w3a cmul wral cc0 cpnf cico crab
        cv clt ccnv csup wi nmoval breq2d wss wb ssrab2 icossxr infmxrgelb mpan
        sstri breq2 ralrab2 syl6bb sylan9bb ) CUAPDUAPECDUBUCPUDZBEHQZRSBAUKZEQ
        GQJUKZVKFQUEUCRSAIUFZJUGUHUIUCZUJZTULUMUNZRSZBTPZVMBVLRSZUOJVNUFZVIVJVP
        BRACDEFGHIJKLMNUPUQVRVQBOUKZRSZOVOUFZVTVOTURVRVQWCUSVOVNTVMJVNUTUGUHVAV
        DOVOBVBVCVMWBVSOJVNWAVLBRVEVFVGVH $.

      $( Any upper bound on the values of a linear operator translates to an
         upper bound on the operator norm.  (Contributed by Mario Carneiro,
         18-Oct-2015.) $)
      nmolb $p |- ( ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) /\
           A e. RR /\ 0 <_ A ) -> ( A. x e. V
         ( M ` ( F ` x ) ) <_ ( A x. ( L ` x ) ) -> ( N ` F ) <_ A ) ) $=
        ( vr wcel co cle wbr cfv cxr cngp cghm w3a cr cv cmul wral wi cpnf cico
        cc0 elrege0 crab clt ccnv csup nmoval wss ssrab2 icossxr sstri infmxrcl
        wa mp1i eqeltrd xrleid wb nmogelb mpdan mpbid wceq oveq1 breq2d ralbidv
        syl breq2 imbi12d rspccv syl5bir 3impib ) CUAODUAOECDUBPOUCZBUDOZUKBQRZ
        AUEZESGSZBWDFSZUFPZQRZAIUGZEHSZBQRZUHZWBWCVCBUKUIUJPZOZWAWLBULWAWENUEZW
        FUFPZQRZAIUGZWJWOQRZUHZNWMUGZWNWLUHWAWJWJQRZXAWAWJTOZXBWAWJWRNWMUMZTUNU
        OUPZTACDEFGHINJKLMUQXDTURXETOWAXDWMTWRNWMUSUKUIUTVAXDVBVDVEZWJVFVOWAXCX
        BXAVGXFAWJCDEFGHINJKLMVHVIVJWTWLNBWMWOBVKZWRWIWSWKXGWQWHAIXGWPWGWEQWOBW
        FUFVLVMVNWOBWJQVPVQVRVOVSVT $.

      nmolb2d.z $e |- .0. = ( 0g ` S ) $.
      nmolb2d.1 $e |- ( ph -> S e. NrmGrp ) $.
      nmolb2d.2 $e |- ( ph -> T e. NrmGrp ) $.
      nmolb2d.3 $e |- ( ph -> F e. ( S GrpHom T ) ) $.
      nmolb2d.4 $e |- ( ph -> A e. RR ) $.
      nmolb2d.5 $e |- ( ph -> 0 <_ A ) $.
      nmolb2d.6 $e |- ( ( ph /\ ( x e. V /\ x =/= .0. ) ) ->
        ( M ` ( F ` x ) ) <_ ( A x. ( L ` x ) ) ) $.
      $( Any upper bound on the values of a linear operator at nonzero vectors
         translates to an upper bound on the operator norm.  (Contributed by
         Mario Carneiro, 18-Oct-2015.) $)
      nmolb2d $p |- ( ph -> ( N ` F ) <_ A ) $=
        ( cv cfv cmul co cle wbr wral wcel wceq fveq2 fveq2d oveq2d breq12d wne
        wa anassrs cc0 0le0 recnd mul01d syl5breqr c0g cghm eqid ghmid syl cngp
        nm0 eqtrd 3brtr4d adantr pm2.61ne ralrimiva cr wi nmolb syl311anc mpd )
        ABUCZFUDZHUDZCWAGUDZUEUFZUGUHZBJUIZFIUDCUGUHZAWFBJAWAJUJZUQWFKFUDZHUDZC
        KGUDZUEUFZUGUHZWAKWAKUKZWCWKWEWMUGWOWBWJHWAKFULUMWOWDWLCUEWAKGULUNUOAWI
        WAKUPWFUBURAWNWIAUSCUSUEUFZWKWMUGAUSUSWPUGUTACACTVAVBVCAWKEVDUDZHUDZUSA
        WJWQHAFDEVEUFUJZWJWQUKSDEFKWQPWQVFZVGVHUMAEVIUJZWRUSUKREHWQOWTVJVHVKAWL
        USCUEADVIUJZWLUSUKQDGKNPVJVHUNVLVMVNVOAXBXAWSCVPUJUSCUGUHWGWHVQQRSTUABC
        DEFGHIJLMNOVRVSVT $.
    $}

    $( The operator norm is a function into the extended reals.  (Contributed
       by Mario Carneiro, 18-Oct-2015.) $)
    nmof $p |- ( ( S e. NrmGrp /\ T e. NrmGrp ) ->
                 N : ( S GrpHom T ) --> RR* ) $=
      ( vf vx vr cngp wcel wa cghm co cxr wf cv cfv cnm cc0 cpnf eqid cmul wral
      cle wbr cbs cico crab clt ccnv csup cmpt wss ssrab2 icossxr infmxrcl mp1i
      sstri fmptd nmofval feq1d mpbird ) AHIBHIJZABKLZMCNVCMEVCFOZEOZPBQPZPGOVD
      AQPZPUALUCUDFAUEPZUBZGRSUFLZUGZMUHUIUJZUKZNVBEVCVLMVMVKMULVLMIVBVEVCIJVKV
      JMVIGVJUMRSUNUQVKUOUPVMTURVBVCMCVMFABEVGVFCVHGDVHTVGTVFTUSUTVA $.

    $( The operator norm of an operator is an extended real.  (Contributed by
       Mario Carneiro, 18-Oct-2015.) $)
    nmocl $p |- ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) ->
                  ( N ` F ) e. RR* ) $=
      ( cngp wcel cghm co cfv cxr wa nmof ffvelrnda 3impa ) AFGZBFGZCABHIZGCDJK
      GPQLRKCDABDEMNO $.

    $( The operator norm of an operator is nonnegative.  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    nmoge0 $p |- ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) ->
                   0 <_ ( N ` F ) ) $=
      ( vx vr cngp wcel cghm co w3a cc0 cfv cle wbr cv cnm wral eqid cmul wi wa
      cbs cpnf cr elrege0 simprbi adantl a1d ralrimiva cxr wb 0xr nmogelb mpan2
      cico mpbird ) AHIBHICABJKILZMCDNOPZFQZCNBRNZNGQZVAARNZNUAKOPFAUDNZSZMVCOP
      ZUBZGMUEUQKZSZUSVHGVIUSVCVIIZUCVGVFVKVGUSVKVCUFIVGVCUGUHUIUJUKUSMULIUTVJU
      MUNFMABCVDVBDVEGEVETVDTVBTUOUPUR $.

    $( A normed group homomorphism is a group homomorphism with bounded norm.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    nghmfval $p |- ( S NGHom T ) = ( `' N " RR ) $=
      ( vs vt cngp wcel wa cnghm co ccnv cr cima wceq cv cnmo cnveqd cvv c0 cxp
      oveq12 syl6eqr imaeq1d df-nghm ovex eqeltri cnvex imaexg ax-mp ovmpt2a wn
      mpt2ndm0 wfn cdm nmoffn fndm ndmov syl5eq cnv0 syl6eq 0ima eqtr4d pm2.61i
      ) AGHBGHIZABJKZCLZMNZOEFABGGEPZFPZQKZLZMNZVHJVIAOVJBOIZVLVGMVNVKCVNVKABQK
      ZCVIAVJBQUBDUCRUDFEUEZVGSHVHSHCCVOSDABQUFUGUHVGMSUIUJUKVEULZVFTVHEFVMJABG
      GVPUMVQVHTMNTVQVGTMVQVGTLTVQCTVQCVOTDABGQQGGUAZUNQUOVROUPVRQUQUJURUSRUTVA
      UDMVBVAVCVD $.

    $( A normed group homomorphism is a group homomorphism with bounded norm.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    isnghm $p |- ( F e. ( S NGHom T ) <-> ( ( S e. NrmGrp /\ T e. NrmGrp ) /\
      ( F e. ( S GrpHom T ) /\ ( N ` F ) e. RR ) ) ) $=
      ( cnghm co wcel ccnv cr cima cngp wa cghm c0 wceq cnmo wfn syl6eq cxr cfv
      nghmfval eleq2i n0i wn cxp cdm nmoffn fndm ax-mp ndmov syl5eq cnveqd cnv0
      imaeq1d 0ima nsyl2 wf wb nmof ffn elpreima 3syl biadan2 bitri ) CABFGZHCD
      IZJKZHZALHBLHMZCABNGZHCDUAJHMZMVFVHCABDEUBUCVIVJVLVIVHOPVJVHCUDVJUEZVHOJK
      OVMVGOJVMVGOIOVMDOVMDABQGOEABLQQLLUFZRQUGVNPUHVNQUIUJUKULUMUNSUOJUPSUQVJV
      KTDURDVKRVIVLUSABDEUTVKTDVAVKCJDVBVCVDVE $.

    $( A normed group homomorphism is a group homomorphism with bounded norm.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    isnghm2 $p |- ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) ->
      ( F e. ( S NGHom T ) <-> ( N ` F ) e. RR ) ) $=
      ( cngp wcel cghm co cnghm cfv cr wb wa isnghm baib baibd 3impa ) AFGZBFGZ
      CABHIGZCABJIGZCDKLGZMSTNZUBUAUCUBUDUAUCNABCDEOPQR $.

    $( A normed group homomorphism is a group homomorphism with bounded norm.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    isnghm3 $p |- ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) ->
     ( F e. ( S NGHom T ) <-> ( N ` F ) < +oo ) ) $=
      ( cngp wcel cghm co w3a cnghm cfv cpnf clt wbr isnghm2 cxr cmnf syl2anc
      cr wb nmocl cc0 cle nmoge0 ge0gtmnf xrrebnd baibd bitrd ) AFGBFGCABHIGJZC
      ABKIGCDLZTGZUKMNOZABCDEPUJUKQGZRUKNOZULUMUAABCDEUBZUJUNUCUKUDOUOUPABCDEUE
      UKUFSUNULUOUMUKUGUHSUI $.

    $( A bounded group homomorphism is a normed group homomorphism.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    bddnghm $p |- ( ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) /\
      ( A e. RR /\ ( N ` F ) <_ A ) ) -> F e. ( S NGHom T ) ) $=
      ( cngp wcel cghm co w3a cr cfv cle wbr wa cnghm cxr cc0 nmocl jca xrrege0
      nmoge0 an4s sylan wb isnghm2 adantr mpbird ) BGHCGHDBCIJHKZALHZDEMZANOZPZ
      PDBCQJHZULLHZUJULRHZSULNOZPUNUPUJUQURBCDEFTBCDEFUCUAUQUKURUMUPULAUBUDUEUJ
      UOUPUFUNBCDEFUGUHUI $.

    $( A normed group homomorphism has a real operator norm.  (Contributed by
       Mario Carneiro, 18-Oct-2015.) $)
    nghmcl $p |- ( F e. ( S NGHom T ) -> ( N ` F ) e. RR ) $=
      ( cnghm co wcel cghm cfv cr cngp wa isnghm simprbi simprd ) CABFGHZCABIGH
      ZCDJKHZQALHBLHMRSMABCDENOP $.

    nmoi.2 $e |- V = ( Base ` S ) $.
    nmoi.3 $e |- L = ( norm ` S ) $.
    nmoi.4 $e |- M = ( norm ` T ) $.
    $( The operator norm achieves the minimum of the set of upper bounds, if
       the operator is bounded.  (Contributed by Mario Carneiro,
       18-Oct-2015.) $)
    nmoi $p |- ( ( F e. ( S NGHom T ) /\ X e. V ) ->
      ( M ` ( F ` X ) ) <_ ( ( N ` F ) x. ( L ` X ) ) ) $=
      ( co wcel wa cfv cle wbr cc0 adantr vx cnghm cmul c0g fveq2 fveq2d oveq2d
      vr wceq breq12d wne cdiv cv wral wi cpnf cico rspcv ad3antlr clt cngp cbs
      cr wb cghm isnghm simplbi simprd wf simprbi simpld eqid ghmf syl sylancom
      ffvelrn nmcl syl2anc elrege0 adantl crp simpr nmrpcl 3expa sylan rpregt0d
      jca ledivmul2 syl3anc sylibrd ralrimiva rerpdivcld rexrd nmogelb syl31anc
      cxr mpbird ledivmul2d mpbid ghmid nm0 eqtrd 0re syl6eqel nmoge0 syl5breqr
      0le0 mulge0d eqbrtrd pm2.61ne ) CABUBMNZHGNZOZHCPZEPZCFPZHDPZUCMZQRZAUDPZ
      CPZEPZXPXTDPZUCMZQRHXTHXTUIZXOYBXRYDQYEXNYAEHXTCUEUFYEXQYCXPUCHXTDUEUGUJX
      MHXTUKZOZXOXQULMZXPQRZXSYGYIUAUMZCPZEPZUHUMZYJDPZUCMZQRZUAGUNZYHYMQRZUOZU
      HSUPUQMZUNZYGYSUHYTYGYMYTNZOZYQXOYMXQUCMZQRZYRXLYQUUEUOXKYFUUBYPUUEUAHGYJ
      HUIZYLXOYOUUDQUUFYKXNEYJHCUEUFUUFYNXQYMUCYJHDUEUGUJURUSUUCXOVCNZYMVCNZXQV
      CNSXQUTROZYRUUEVDYGUUGUUBXMUUGYFXMBVANZXNBVBPZNZUUGXMAVANZUUJXKUUMUUJOZXL
      XKUUNCABVEMNZXPVCNZOZABCFIVFZVGTZVHZXKXLGUUKCVIZUULXMUUOUVAXMUUOUUPXKUUQX
      LXKUUNUUQUURVJTZVKZABCGUUKJUUKVLZVMVNGUUKHCVPVOXNBEUUKUVDLVQVRTZTUUBUUHYG
      UUBUUHSYMQRYMVSVGVTYGUUIUUBYGXQXMUUMXLOYFXQWANZXMUUMXLXMUUMUUJUUSVKZXKXLW
      BWGUUMXLYFUVFHADGXTJKXTVLZWCWDWEZWFTXOYMXQWHWIWJWKYGUUMUUJUUOYHWPNYIUUAVD
      XMUUMYFUVGTXMUUJYFUUTTXMUUOYFUVCTYGYHYGXOXQUVEUVIWLWMUAYHABCDEFGUHIJKLWNW
      OWQYGXOXPXQUVEXMUUPYFXMUUOUUPUVBVHZTUVIWRWSXMYBSYDQXMYBBUDPZEPZSXMYAUVKEX
      MUUOYAUVKUIUVCABCXTUVKUVHUVKVLZWTVNUFXMUUJUVLSUIUUTBEUVKLUVMXAVNXBXMXPYCU
      VJXMYCSVCXMUUMYCSUIUVGADXTKUVHXAVNZXCXDXMUUMUUJUUOSXPQRUVGUUTUVCABCFIXEWI
      XMSSYCQXGUVNXFXHXIXJ $.

    $( The operator norm is a bound on the size of an operator, even when it is
       infinite (using extended real multiplication).  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    nmoix $p |- ( ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) /\
      X e. V ) -> ( M ` ( F ` X ) ) <_ ( ( N ` F ) *e ( L ` X ) ) ) $=
      ( wcel co cfv cle wbr cpnf wceq cc0 cngp cghm w3a wa cr cxmu cmul isnghm2
      cnghm biimpar nmoi sylan an32s nmcl 3ad2antl1 rexmul syl2anr breqtrrd c0g
      id fveq2d oveq2d breq12d wne cxr cbs simpl2 eqid ghmf ffvelrnda 3ad2antl3
      fveq2 syl2anc adantr rexrd pnfge syl crp simp1 nmrpcl 3expa sylanl1 rpgt0
      clt rpxr xmulpnf2 simpl3 ghmid nm0 eqtrd simpl1 pnfxr xmul01 ax-mp syl6eq
      0le0 mpbiri pm2.61ne simpr oveq1d wo cmnf nmocl nmoge0 ge0nemnf jca sylib
      xrnemnf mpjaodan ) AUAMZBUAMZCABUBNMZUCZHGMZUDZCFOZUEMZHCOZEOZXPHDOZUFNZP
      QXPRSZXOXQUDXSXPXTUGNZYAPXMXQXNXSYCPQZXMXQUDCABUINMZXNYDXMYEXQABCFIUHUJAB
      CDEFGHIJKLUKULUMXQXQXTUEMZYAYCSXOXQUTXJXKXNYFXLHADGJKUNUOXPXTUPUQURXOYBUD
      ZXSRXTUFNZYAPXOXSYHPQZYBXOYIAUSOZCOZEOZRYJDOZUFNZPQZHYJHYJSZXSYLYHYNPYPXR
      YKEHYJCVLVAYPXTYMRUFHYJDVLVBVCXOHYJVDZUDZXSRYHPYRXSVEMXSRPQYRXSXOXSUEMZYQ
      XOXKXRBVFOZMZYSXJXKXLXNVGZXLXJXNUUAXKXLGYTHCABCGYTJYTVHZVIVJVKXRBEYTUUCLU
      NVMVNVOXSVPVQYRXTVRMZYHRSZXMXJXNYQUUDXJXKXLVSXJXNYQUUDHADGYJJKYJVHZVTWAWB
      UUDXTVEMTXTWDQUUEXTWEXTWCXTWFVMVQURXOYOTTPQWPXOYLTYNTPXOYLBUSOZEOZTXOYKUU
      GEXOXLYKUUGSXJXKXLXNWGABCYJUUGUUFUUGVHZWHVQVAXOXKUUHTSUUBBEUUGLUUIWIVQWJX
      OYNRTUFNZTXOYMTRUFXOXJYMTSXJXKXLXNWKADYJKUUFWIVQVBRVEMUUJTSWLRWMWNWOVCWQW
      RVNYGXPRXTUFXOYBWSWTURXMXQYBXAZXNXMXPVEMZXPXBVDZUDUUKXMUULUUMABCFIXCZXMUU
      LTXPPQUUMUUNABCFIXDXPXEVMXFXPXHXGVNXI $.

    nmoleub.z $e |- .0. = ( 0g ` S ) $.
    $( The operator norm is a bound on the growth of a vector under the action
       of the operator.  (Contributed by Mario Carneiro, 19-Oct-2015.) $)
    nmoi2 $p |- ( ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) /\
        ( X e. V /\ X =/= .0. ) ) ->
      ( ( M ` ( F ` X ) ) / ( L ` X ) ) <_ ( N ` F ) ) $=
      ( wcel co cfv c1 cxmu cxr cngp cghm w3a wne wa cdiv cle cc0 wbr cr simpl2
      cbs wf simpl3 eqid ghmf syl simprl ffvelrnd nmcl syl2anc rexrd adantr crp
      nmocl nmrpcl 3expb 3ad2antl1 rpxrd xmulcld rpreccld rpge0d nmoix xlemul1a
      adantrr syl31anc cmul wceq rpred rexmul recnd rpcnd rpne0d divrecd eqtr4d
      jca xmulass syl3anc recidd eqtrd oveq2d xmulid1 3eqtrd 3brtr3d ) AUAOZBUA
      OZCABUBPOZUCZHGOZHIUDZUEZUEZHCQZEQZRHDQZUFPZSPZCFQZXESPZXFSPZXDXEUFPZXHUG
      XBXDTOXITOXFTOZUHXFUGUIZUEXDXIUGUIZXGXJUGUIXBXDXBWPXCBULQZOXDUJOZWOWPWQXA
      UKXBGXOHCXBWQGXOCUMWOWPWQXAUNABCGXOKXOUOZUPUQWRWSWTURUSXCBEXOXQMUTVAZVBXB
      XHXEWRXHTOZXAABCFJVEVCZXBXEWOWPXAXEVDOZWQWOWSWTYAHADGIKLNVFVGVHZVIZVJXBXL
      XMXBXFXBXEYBVKZVIZXBXFYDVLWFWRWSXNWTABCDEFGHJKLMVMVOXDXIXFVNVPXBXGXDXFVQP
      ZXKXBXPXFUJOZXGYFVRXRXBXFYDVSZXDXFVTVAXBXDXEXBXDXRWAXBXEYBWBZXBXEYBWCZWDW
      EXBXJXHXEXFSPZSPZXHRSPZXHXBXSXETOXLXJYLVRXTYCYEXHXEXFWGWHXBYKRXHSXBYKXEXF
      VQPZRXBXEUJOYGYKYNVRXBXEYBVSYHXEXFVTVAXBXEYIYJWIWJWKXBXSYMXHVRXTXHWLUQWMW
      N $.

    nmoleub.1 $e |- ( ph -> S e. NrmGrp ) $.
    nmoleub.2 $e |- ( ph -> T e. NrmGrp ) $.
    nmoleub.3 $e |- ( ph -> F e. ( S GrpHom T ) ) $.
    nmoleub.4 $e |- ( ph -> A e. RR* ) $.
    nmoleub.5 $e |- ( ph -> 0 <_ A ) $.
    $( The operator norm, defined as an infimum of upper bounds, can also be
       defined as a supremum of norms of ` F ( x ) ` away from zero.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    nmoleub $p |- ( ph -> ( ( N ` F ) <_ A <->
      A. x e. V ( x =/= .0. -> ( ( M ` ( F ` x ) ) / ( L ` x ) ) <_ A ) ) ) $=
      ( cfv cle wbr cv wne cdiv co wi wral wa wcel cngp cbs cr ad2antrr wf cghm
      eqid ghmf syl simprl ffvelrn syl2anc adantr nmrpcl 3expb sylan rerpdivcld
      nmcl crp rexrd cxr nmocl syl3anc 3jca nmoi2 simplr xrletrd expr ralrimiva
      w3a cpnf wceq cmul cc0 simpllr recnd mul01d syl5breqr c0g fveq2 sylan9eqr
      0le0 ghmid fveq2d ad3antrrr nm0 eqtrd oveq2d 3brtr4d a1d simpr ledivmul2d
      3expa sylanl1 biimpd embantd pm2.61dane ralimdva nmolb syl311anc syld imp
      an32s pnfge breqtrrd wo cmnf ge0nemnf jca xrnemnf sylib mpjaodan impbida
      ) AFIUBZCUCUDZBUEZKUFZYHFUBZHUBZYHGUBZUGUHZCUCUDZUIZBJUJZAYGUKZYOBJYQYHJU
      LZYIYNYQYRYIUKZUKZYMYFCYTYMYTYKYLYTEUMULZYJEUNUBZULZYKUOULZAUUAYGYSRUPYTJ
      UUBFUQZYRUUCAUUEYGYSAFDEURUHULZUUESDEFJUUBMUUBUSZUTVAZUPYQYRYIVBJUUBYHFVC
      ZVDYJEHUUBUUGOVJZVDYQDUMULZYSYLVKULZAUUKYGQVEUUKYRYIUULYHDGJKMNPVFZVGVHVI
      VLAYFVMULZYGYSAUUKUUAUUFUUNQRSDEFILVNVOZUPACVMULZYGYSTUPYQUUKUUAUUFWBZYSY
      MYFUCUDAUUQYGAUUKUUAUUFQRSVPVEDEFGHIJYHKLMNOPVQVHAYGYSVRVSVTWAAYPUKZCUOUL
      ZYGCWCWDZAUUSYPYGAUUSUKZYPYGUVAYPYKCYLWEUHZUCUDZBJUJZYGUVAYOUVCBJUVAYRUKZ
      YOUVCUIYHKUVEYHKWDZUKZUVCYOUVGWFCWFWEUHZYKUVBUCUVGWFWFUVHUCWNUVGCUVGCAUUS
      YRUVFWGWHWIWJUVGYKEWKUBZHUBZWFUVGYJUVIHUVFUVEYJKFUBZUVIYHKFWLUVEUUFUVKUVI
      WDAUUFUUSYRSUPDEFKUVIPUVIUSZWOVAWMWPUVGUUAUVJWFWDAUUAUUSYRUVFRWQEHUVIOUVL
      WRVAWSUVGYLWFCWEUVFUVEYLKGUBZWFYHKGWLUVEUUKUVMWFWDAUUKUUSYRQUPDGKNPWRVAWM
      WTXAXBUVEYIUKZYIYNUVCUVEYIXCUVNYNUVCUVNYKCYLUVEUUDYIUVEUUAUUCUUDAUUAUUSYR
      RUPUVAUUEYRUUCAUUEUUSUUHVEUUIVHUUJVDVEAUUSYRYIWGUVAUUKYRYIUULAUUKUUSQVEZU
      UKYRYIUULUUMXEXFXDXGXHXIXJUVAUUKUUAUUFUUSWFCUCUDZUVDYGUIUVOAUUAUUSRVEAUUF
      UUSSVEAUUSXCAUVPUUSUAVEBCDEFGHIJLMNOXKXLXMXNXOUURUUTUKZYFWCCUCUVQUUNYFWCU
      CUDAUUNYPUUTUUOUPYFXPVAUURUUTXCXQAUUSUUTXRZYPAUUPCXSUFZUKUVRAUUPUVSTAUUPU
      VPUVSTUACXTVDYACYBYCVEYDYE $.
  $}

  $( Reverse closure for a normed group homomorphism.  (Contributed by Mario
     Carneiro, 18-Oct-2015.) $)
  nghmrcl1 $p |- ( F e. ( S NGHom T ) -> S e. NrmGrp ) $=
    ( cnghm co wcel cngp wa cghm cnmo cfv cr eqid isnghm simplbi simpld ) CABDE
    FZAGFZBGFZQRSHCABIEFCABJEZKLFHABCTTMNOP $.

  $( Reverse closure for a normed group homomorphism.  (Contributed by Mario
     Carneiro, 18-Oct-2015.) $)
  nghmrcl2 $p |- ( F e. ( S NGHom T ) -> T e. NrmGrp ) $=
    ( cnghm co wcel cngp wa cghm cnmo cfv cr eqid isnghm simplbi simprd ) CABDE
    FZAGFZBGFZQRSHCABIEFCABJEZKLFHABCTTMNOP $.

  $( A normed group homomorphism is a group homomorphism.  (Contributed by
     Mario Carneiro, 18-Oct-2015.) $)
  nghmghm $p |- ( F e. ( S NGHom T ) -> F e. ( S GrpHom T ) ) $=
    ( cnghm co wcel cghm cnmo cfv cr cngp wa eqid isnghm simprbi simpld ) CABDE
    FZCABGEFZCABHEZIJFZQAKFBKFLRTLABCSSMNOP $.

  ${
    $d x F $.  $d x N $.  $d x S $.  $d x T $.  $d x V $.  $d x .0. $.
    nmo0.1 $e |- N = ( S normOp T ) $.
    nmo0.2 $e |- V = ( Base ` S ) $.
    nmo0.3 $e |- .0. = ( 0g ` T ) $.
    $( The operator norm of the zero operator.  (Contributed by Mario Carneiro,
       20-Oct-2015.) $)
    nmo0 $p |- ( ( S e. NrmGrp /\ T e. NrmGrp ) ->
                  ( N ` ( V X. { .0. } ) ) = 0 ) $=
      ( vx cngp wcel wa cfv cc0 wceq cle wbr cnm c0g eqid simpl simpr cgrp cghm
      csn cxp co ngpgrp 0ghm syl2an cr 0re a1i 0le0 cv wne cvv eqeltri fvconst2
      cmul fvex ad2antrl fveq2d nm0 ad2antlr eqtrd nmcl ad2ant2r mul02d eqbrtrd
      recnd syl5breqr nmolb2d nmoge0 mpd3an3 cxr wb nmocl 0xr sylancl mpbir2and
      xrletri3 ) AJKZBJKZLZDEUEUFZCMZNOZWGNPQZNWGPQZWEINABWFARMZBRMZCDASMZFGWKT
      ZWLTZWMTWCWDUAWCWDUBWCAUCKBUCKWFABUDUGKZWDAUHBUHDABEHGUIUJZNUKKWEULUMNNPQ
      WEUNUMWEIUOZDKZWRWMUPZLZLZWRWFMZWLMZNNWRWKMZUTUGZPXBXDEWLMZNXBXCEWLWSXCEO
      WEWTDEWREBSMUQHBSVAURUSVBVCWDXGNOWCXABWLEWOHVDVEVFXBNNXFPUNXBXEXBXEWCWSXE
      UKKWDWTWRAWKDGWNVGVHVKVIVLVJVMWCWDWPWJWQABWFCFVNVOWEWGVPKZNVPKWHWIWJLVQWC
      WDWPXHWQABWFCFVRVOVSWGNWBVTWA $.

    $( The operator norm is zero only for the zero operator.  (Contributed by
       Mario Carneiro, 20-Oct-2015.) $)
    nmoeq0 $p |- ( ( S e. NrmGrp /\ T e. NrmGrp /\ F e. ( S GrpHom T ) ) ->
                   ( ( N ` F ) = 0 <-> F = ( V X. { .0. } ) ) ) $=
      ( vx wcel co cfv cc0 wceq wa cle wbr cmul cr cngp cghm w3a csn cxp cv cnm
      cmpt cnghm id 0re syl6eqel isnghm2 biimpar sylan2 eqid nmoi simplr oveq1d
      sylan simpl1 nmcl recnd mul02d eqtrd breqtrd cbs simpll2 simpl3 ffvelrnda
      wf ghmf syl nmge0 syl2anc wb letri3 sylancl mpbir2and nmeq0 mpbid feqmptd
      mpteq2dva fconstmpt a1i 3eqtr4d ex 3adant3 fveq2 eqeq1d syl5ibrcom impbid
      nmo0 ) AUAKZBUAKZCABUBLKZUCZCDMZNOZCEFUDUEZOZWQWSXAWQWSPZJEJUFZCMZUHJEFUH
      ZCWTXBJEXDFXBXCEKZPZXDBUGMZMZNOZXDFOZXGXJXINQRZNXIQRZXGXIWRXCAUGMZMZSLZNQ
      XBCABUILKZXFXIXPQRWSWQWRTKZXQWSWRNTWSUJUKULWQXQXRABCDGUMUNUOABCXNXHDEXCGH
      XNUPZXHUPZUQUTXGXPNXOSLNXGWRNXOSWQWSXFURUSXGXOXGXOXBWNXFXOTKWNWOWPWSVAXCA
      XNEHXSVBUTVCVDVEVFXGWOXDBVGMZKZXMWNWOWPWSXFVHZXBEYAXCCXBWPEYACVKWNWOWPWSV
      IABCEYAHYAUPZVLVMZVJZXDBXHYAYDXTVNVOXGXITKZNTKXJXLXMPVPXGWOYBYGYCYFXDBXHY
      AYDXTVBVOUKXINVQVRVSXGWOYBXJXKVPYCYFXDBXHYAFYDXTIVTVOWAWCXBJEYACYEWBWTXEO
      XBJEFWDWEWFWGWQWSXAWTDMZNOZWNWOYIWPABDEFGHIWMWHXAWRYHNCWTDWIWJWKWL $.
  $}

  ${
    $d x F $.  $d x G $.  $d x L $.  $d x M $.  $d x N $.  $d x S $.  $d x T $.
    $d x U $.
    nmoco.1 $e |- N = ( S normOp U ) $.
    nmoco.2 $e |- L = ( T normOp U ) $.
    nmoco.3 $e |- M = ( S normOp T ) $.
    $( An upper bound on the operator norm of a composition.  (Contributed by
       Mario Carneiro, 20-Oct-2015.) $)
    nmoco $p |- ( ( F e. ( T NGHom U ) /\ G e. ( S NGHom T ) ) ->
                  ( N ` ( F o. G ) ) <_ ( ( L ` F ) x. ( M ` G ) ) ) $=
      ( co wcel wa cfv cmul eqid cr cle wbr vx cnghm ccom cnm cbs cngp nghmrcl1
      c0g adantl nghmrcl2 adantr nghmghm ghmco syl2an nghmcl remulcl cc0 nmoge0
      cghm syl3anc jca mulge0 cv wne ad2antrr ghmf syl ad2antlr simprl ffvelrnd
      wf nmcl syl2anc remulcld sylan ad2ant2lr nmoi lemul2a syl31anc letrd wceq
      simpll fvco3 fveq2d recnd mulassd 3brtr4d nmolb2d ) DBCUBLMZEABUBLMZNZUAD
      FOZEGOZPLZACDEUCZAUDOZCUDOZHAUEOZAUHOZIWRQZWPQZWQQZWSQWJAUFMZWIABEUGZUIWI
      CUFMZWJBCDUJZUKWIDBCUSLMZEABUSLMZWOACUSLMWJBCDULZABEULZABCDEUMUNWIWLRMZWM
      RMZWNRMWJBCDFJUOZABEGKUOZWLWMUPUNWIXKUQWLSTZNZXLUQWMSTZNUQWNSTWJWIXKXOXMW
      IBUFMZXEXGXOBCDUGZXFXIBCDFJURUTVAZWJXLXQXNWJXCXRXHXQXDABEUJXJABEGKURUTVAW
      LWMVBUNWKUAVCZWRMZYAWSVDZNZNZYAEOZDOZWQOZWLWMYAWPOZPLZPLZYAWOOZWQOWNYIPLS
      YEYHWLYFBUDOZOZPLZYKYEXEYGCUEOZMYHRMWIXEWJYDXFVEYEBUEOZYPYFDYEXGYQYPDVKWI
      XGWJYDXIVEBCDYQYPYQQZYPQZVFVGYEWRYQYAEYEXHWRYQEVKZWJXHWIYDXJVHABEWRYQWTYR
      VFVGZWKYBYCVIZVJZVJYGCWQYPYSXBVLVMYEWLYNWIXKWJYDXMVEZYEXRYFYQMZYNRMZWIXRW
      JYDXSVEUUCYFBYMYQYRYMQZVLVMZVNYEWLYJUUDYEWMYIWJXLWIYDXNVHZWJYBYIRMZWIYCWJ
      XCYBUUJXDYAAWPWRWTXAVLVOVPZVNZVNYEWIUUEYHYOSTWIWJYDWBUUCBCDYMWQFYQYFJYRUU
      GXBVQVMYEUUFYJRMXPYNYJSTZYOYKSTUUHUULWIXPWJYDXTVEWJYBUUMWIYCABEWPYMGWRYAK
      WTXAUUGVQVPYNYJWLVRVSVTYEYLYGWQYEYTYBYLYGWAUUAUUBWRYQYADEWCVMWDYEWLWMYIYE
      WLUUDWEYEWMUUIWEYEYIUUKWEWFWGWH $.
  $}

  $( The composition of normed group homomorphisms is a normed group
     homomorphism.  (Contributed by Mario Carneiro, 20-Oct-2015.) $)
  nghmco $p |- ( ( F e. ( T NGHom U ) /\ G e. ( S NGHom T ) ) ->
                 ( F o. G ) e. ( S NGHom U ) ) $=
    ( cnghm co wcel wa cngp ccom cghm cnmo cfv cmul nghmghm syl2an eqid nghmcl
    cr cle nghmrcl1 adantl nghmrcl2 adantr ghmco remulcl nmoco bddnghm syl32anc
    wbr ) DBCFGHZEABFGHZIAJHZCJHZDEKZACLGHZDBCMGZNZEABMGZNZOGZTHZUPACMGZNVBUAUK
    UPACFGHUMUNULABEUBUCULUOUMBCDUDUEULDBCLGHEABLGHUQUMBCDPABEPABCDEUFQULUSTHVA
    THVCUMBCDURURRZSABEUTUTRZSUSVAUGQABCDEURUTVDVDRZVEVFUHVBACUPVDVGUIUJ $.

  ${
    $d x F $.  $d x G $.  $d x N $.  $d x .+ $.  $d x S $.  $d x T $.
    nmotri.1 $e |- N = ( S normOp T ) $.
    nmotri.p $e |- .+ = ( +g ` T ) $.
    $( Triangle inequality for the operator norm.  (Contributed by Mario
       Carneiro, 20-Oct-2015.) $)
    nmotri $p |- ( ( T e. Abel /\ F e. ( S NGHom T ) /\ G e. ( S NGHom T ) ) ->
                   ( N ` ( F oF .+ G ) ) <_ ( ( N ` F ) + ( N ` G ) ) ) $=
      ( wcel co cfv eqid 3ad2ant2 cr cle wbr syl3anc adantr syl syl2anc w3a cof
      vx cabel cnghm caddc cnm cbs cngp nghmrcl1 nghmrcl2 cghm nghmghm ghmplusg
      c0g id syl3an nghmcl 3ad2ant3 readdcld cc0 nmoge0 addge0d cv wa cmul cgrp
      wne ngpgrp wf ghmf simprl ffvelrnd grpcl nmcl simpl syl2an remulcld nmtri
      simpl2 nmoi simpl3 le2addd letrd wfn cvv wceq fvex fnfvof syl22anc fveq2d
      ffn a1i recnd adddird 3brtr4d nmolb2d ) CUDIZDBCUEJZIZEWSIZUAZUCDFKZEFKZU
      FJZBCDEAUBJZBUGKZCUGKZFBUHKZBUOKZGXILZXGLZXHLZXJLWTWRBUIIZXABCDUJMZWTWRCU
      IIZXABCDUKMZWRWRWTDBCULJZIZXAEXRIZXFXRIWRUPBCDUMZBCEUMZADEBCHUNUQXBXCXDWT
      WRXCNIZXABCDFGURMZXAWRXDNIZWTBCEFGURUSZUTXBXCXDYDYFXBXNXPXSVAXCOPXOXQWTWR
      XSXAYAMZBCDFGVBQXBXNXPXTVAXDOPXOXQXAWRXTWTYBUSZBCEFGVBQVCXBUCVDZXIIZYIXJV
      HZVEZVEZYIDKZYIEKZAJZXHKZXCYIXGKZVFJZXDYRVFJZUFJZYIXFKZXHKXEYRVFJOYMYQYNX
      HKZYOXHKZUFJZUUAYMXPYPCUHKZIZYQNIXBXPYLXQRZYMCVGIZYNUUFIZYOUUFIZUUGYMXPUU
      IUUHCVISYMXIUUFYIDYMXSXIUUFDVJZXBXSYLYGRBCDXIUUFXKUUFLZVKSZXBYJYKVLZVMZYM
      XIUUFYIEYMXTXIUUFEVJZXBXTYLYHRBCEXIUUFXKUUMVKSZUUOVMZUUFACYNYOUUMHVNQYPCX
      HUUFUUMXMVOTYMUUCUUDYMXPUUJUUCNIUUHUUPYNCXHUUFUUMXMVOTZYMXPUUKUUDNIUUHUUS
      YOCXHUUFUUMXMVOTZUTYMYSYTYMXCYRXBYCYLYDRZXBXNYJYRNIYLXOYJYKVPYIBXGXIXKXLV
      OVQZVRZYMXDYRXBYEYLYFRZUVCVRZUTYMXPUUJUUKYQUUEOPUUHUUPUUSYNYOACXHUUFUUMXM
      HVSQYMUUCUUDYSYTUUTUVAUVDUVFYMWTYJUUCYSOPWRWTXAYLVTUUOBCDXGXHFXIYIGXKXLXM
      WATYMXAYJUUDYTOPWRWTXAYLWBUUOBCEXGXHFXIYIGXKXLXMWATWCWDYMUUBYPXHYMDXIWEZE
      XIWEZXIWFIZYJUUBYPWGYMUULUVGUUNXIUUFDWLSYMUUQUVHUURXIUUFEWLSUVIYMBUHWHWMU
      UOXIADEWFYIWIWJWKYMXCXDYRYMXCUVBWNYMXDUVEWNYMYRUVCWNWOWPWQ $.
  $}

  ${
    nghmplusg.p $e |- .+ = ( +g ` T ) $.
    $( The sum of two bounded linear operators is bounded linear.  (Contributed
       by Mario Carneiro, 20-Oct-2015.) $)
    nghmplusg $p |- ( ( T e. Abel /\ F e. ( S NGHom T ) /\ G e. ( S NGHom T ) )
                      -> ( F oF .+ G ) e. ( S NGHom T ) ) $=
      ( cabel wcel cnghm co w3a cngp cof cghm cnmo cfv 3ad2ant2 nghmghm nghmcl
      cr caddc cle wbr nghmrcl1 nghmrcl2 ghmplusg syl3an eqid 3ad2ant3 readdcld
      id nmotri bddnghm syl32anc ) CGHZDBCIJZHZEUPHZKZBLHZCLHZDEAMJZBCNJZHZDBCO
      JZPZEVEPZUAJZTHVBVEPVHUBUCVBUPHUQUOUTURBCDUDQUQUOVAURBCDUEQUOUOUQDVCHUREV
      CHVDUOUKBCDRBCERADEBCFUFUGUSVFVGUQUOVFTHURBCDVEVEUHZSQURUOVGTHUQBCEVEVISU
      IUJABCDEVEVIFULVHBCVBVEVIUMUN $.
  $}

  ${
    0nghm.2 $e |- V = ( Base ` S ) $.
    0nghm.3 $e |- .0. = ( 0g ` T ) $.
    $( The zero operator is a normed group homomorphism.  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    0nghm $p |- ( ( S e. NrmGrp /\ T e. NrmGrp ) ->
                  ( V X. { .0. } ) e. ( S NGHom T ) ) $=
      ( cngp wcel wa csn cxp cnghm co cnmo cfv cr cc0 eqid cgrp ngpgrp nmo0 0re
      syl6eqel cghm wb 0ghm syl2an isnghm2 mpd3an3 mpbird ) AGHZBGHZIZCDJKZABLM
      HZUNABNMZOZPHZUMUQQPABUPCDUPRZEFUAUBUCUKULUNABUDMHZUOURUEUKASHBSHUTULATBT
      CABDFEUFUGABUNUPUSUHUIUJ $.
  $}

  ${
    $d x N $.  $d x S $.  $d x V $.  $d x .0. $.
    nmoid.1 $e |- N = ( S normOp S ) $.
    nmoid.2 $e |- V = ( Base ` S ) $.
    nmoid.3 $e |- .0. = ( 0g ` S ) $.
    $( The operator norm of the identity function on a nontrivial group.
       (Contributed by Mario Carneiro, 20-Oct-2015.) $)
    nmoid $p |- ( ( S e. NrmGrp /\ { .0. } C. V ) ->
      ( N ` ( _I |` V ) ) = 1 ) $=
      ( vx wcel wa cfv c1 wceq cle wbr co adantr cr 1re a1i cngp wpss cres eqid
      csn cid cnm simpl cgrp cghm ngpgrp syl cc0 0le1 cv wne cmul nmcl ad2ant2r
      idghm leidd fvresi ad2antrl fveq2d recnd mulid2d 3brtr4d wn pssnel adantl
      nmolb2d wex elsn biimpri necon3bi eqtr4d cnghm cxr syl3anc nmoge0 xrrege0
      nmocl syl22anc wb isnghm2 mpbird simprl nmoi syl2anc eqbrtrd nmrpcl 3expb
      crp adantlr lemul1d sylanr2 exlimddv rexri xrletri3 sylancl mpbir2and ) A
      UAIZDUEZCUBZJZUFCUCZBKZLMZXGLNOZLXGNOZXEHLAAXFAUGKZXKBCDEFXKUDZXLGXBXDUHZ
      XMXEAUIIZXFAAUJPIZXBXNXDAUKQCAFUTULZLRIZXESTZUMLNOXEUNTXEHUOZCIZXSDUPZJZJ
      ZXSXKKZYDXSXFKZXKKZLYDUQPZNYCYDXBXTYDRIXDYAXSAXKCFXLURUSZVAYCYEXSXKXTYEXS
      MXEYACXSVBVCVDZYCYDYCYDYHVEVFZVGVKZXEXTXSXCIZVHZJZXJHXDYNHVLXBHXCCVIVJYMX
      EXTYAXJYLXSDYLXSDMHDVMVNVOYCXJYGXGYDUQPZNOYCYGYFYONYCYGYDYFYJYIVPYCXFAAVQ
      PIZXTYFYONOXEYPYBXEYPXGRIZXEXGVRIZXQUMXGNOZXIYQXEXBXBXOYRXMXMXPAAXFBEWBVS
      ZXRXEXBXBXOYSXMXMXPAAXFBEVTVSYKXGLWAWCZXEXBXBXOYPYQWDXMXMXPAAXFBEWEVSWFQX
      EXTYAWGAAXFXKXKBCXSEFXLXLWHWIWJYCLXGYDXQYCSTXEYQYBUUAQXBYBYDWMIZXDXBXTYAU
      UBXSAXKCDFXLGWKWLWNWOWFWPWQXEYRLVRIXHXIXJJWDYTLSWRXGLWSWTXA $.
  $}

  ${
    $d x S $.  $d x V $.
    idnghm.2 $e |- V = ( Base ` S ) $.
    $( The identity operator is a normed group homomorphism.  (Contributed by
       Mario Carneiro, 18-Oct-2015.) $)
    idnghm $p |- ( S e. NrmGrp -> ( _I |` V ) e. ( S NGHom S ) ) $=
      ( vx cngp wcel cid cres cnghm co cnmo cfv wceq eqid syl6eqel cc0 cmpt syl
      cr wa c0g csn wpss c1 nmoid 1re cv eleq2 biimpar elsni mpteq2dva mptresid
      cxp eqcomi fconstmpt 3eqtr4g fveq2d nmo0 anidms sylan9eqr 0re wss wo cgrp
      ngpgrp grpidcl snssd sspss sylib mpjaodan cghm wb id idghm isnghm2 mpbird
      mpd3an23 ) AEFZGBHZAAIJFZVSAAKJZLZSFZVRAUALZUBZBUCZWCWEBMZVRWFTWBUDSAWABW
      DWANZCWDNZUEUFOVRWGTWBPSWGVRWBBWEUMZWALZPWGVSWJWAWGDBDUGZQZDBWDQVSWJWGDBW
      LWDWGWLBFZTWLWEFZWLWDMWGWOWNWEBWLUHUIWLWDUJRUKWMVSDBULUNDBWDUOUPUQVRWKPMA
      AWABWDWHCWIURUSUTVAOVRWEBVBWFWGVCVRWDBVRAVDFZWDBFAVEZBAWDCWIVFRVGWEBVHVIV
      JVRVRVSAAVKJFZVTWCVLVRVMVRWPWRWQBACVNRAAVSWAWHVOVQVP $.
  $}

  ${
    nmods.n $e |- N = ( S normOp T ) $.
    nmods.v $e |- V = ( Base ` S ) $.
    nmods.c $e |- C = ( dist ` S ) $.
    nmods.d $e |- D = ( dist ` T ) $.
    $( Upper bound for the distance between the values of a bounded linear
       operator.  (Contributed by Mario Carneiro, 22-Oct-2015.) $)
    nmods $p |- ( ( F e. ( S NGHom T ) /\ A e. V /\ B e. V ) ->
      ( ( F ` A ) D ( F ` B ) ) <_ ( ( N ` F ) x. ( A C B ) ) ) $=
      ( co wcel cfv cmul eqid syl3an1 wceq cnghm w3a csg cnm cle wbr simp1 cgrp
      cngp nghmrcl1 ngpgrp syl grpsubcl nmoi syl2anc cbs nghmrcl2 3ad2ant1 cghm
      wf nghmghm simp2 ffvelrnd simp3 ngpds syl3anc ghmsub fveq2d eqtr4d oveq2d
      ghmf 3brtr4d ) GEFUANOZAIOZBIOZUBZABEUCPZNZGPZFUDPZPZGHPZVREUDPZPZQNZAGPZ
      BGPZDNZWBABCNZQNUEVPVMVRIOZWAWEUEUFVMVNVOUGVMEUHOZVNVOWJVMEUIOZWKEFGUJZEU
      KULIEVQABKVQRZUMSEFGWCVTHIVRJKWCRZVTRZUNUOVPWHWFWGFUCPZNZVTPZWAVPFUIOZWFF
      UPPZOWGXAOWHWSTVMVNWTVOEFGUQURVPIXAAGVPGEFUSNOZIXAGUTVMVNXBVOEFGVAZUREFGI
      XAKXARZVKULZVMVNVOVBVCVPIXABGXEVMVNVOVDVCWFWGDFWQVTXAWPXDWQRZMVEVFVPVSWRV
      TVMXBVNVOVSWRTXCIEFAGVQWQBKWNXFVGSVHVIVPWIWDWBQVMWLVNVOWIWDTWMABCEVQWCIWO
      KWNLVESVJVL $.
  $}

  ${
    $d r s x y F $.  $d r s x y S $.  $d r s x y T $.
    nghmcn.j $e |- J = ( TopOpen ` S ) $.
    nghmcn.k $e |- K = ( TopOpen ` T ) $.
    $( A normed group homomorphism is a continuous function.  (Contributed by
       Mario Carneiro, 20-Oct-2015.) $)
    nghmcn $p |- ( F e. ( S NGHom T ) -> F e. ( J Cn K ) ) $=
      ( vy co wcel cfv clt wbr crp eqid syl wa syl3anc cr ad2antrr vx vs vr cds
      cnghm cbs cxp cres cmopn ccn wf cv wi wral wrex cghm nghmghm ghmf cnmo c1
      caddc cdiv simprr nghmcl cc0 cle nghmrcl1 nghmrcl2 nmoge0 ge0p1rpd adantr
      cngp rpdivcld cmul cmt ngpms simplrl simpr mscl rpred ltmuldiv2d ffvelrnd
      remulcld nmods 3expa adantlrr cxme msxms xmsge0 lep1d letrd mpand sylbird
      lemul1ad lelttr ovresd breq1d 3imtr4d ralrimiva wceq breq2 imbi1d ralbidv
      rspcev syl2anc ralrimivva cxmt wb xmsxmet metcn mpbir2and mstopn eleqtrrd
      3syl oveq12d ) CABUEIJZCAUDKZAUFKZXRUGUHZUIKZBUDKZBUFKZYBUGUHZUIKZUJIZDEU
      JIXPCYEJZXRYBCUKZUAULZHULZXSIZUBULZLMZYHCKZYICKZYCIZUCULZLMZUMZHXRUNZUBNU
      OZUCNUNUAXRUNZXPCABUPIJZYGABCUQZABCXRYBXROZYBOZURPZXPYTUAUCXRNXPYHXRJZYPN
      JZQZQZYPCABUSIZKZUTVAIZVBIZNJYJUUNLMZYQUMZHXRUNZYTUUJYPUUMXPUUGUUHVCZXPUU
      MNJZUUIXPUULABCUUKUUKOZVDZXPAVLJZBVLJZUUBVEUULVFMABCVGZABCVHZUUCABCUUKUUT
      VIRVJZVKVMUUJUUPHXRUUJYIXRJZQZYHYIXQIZUUNLMZYMYNYAIZYPLMZUUOYQUVHUVJUUMUV
      IVNIZYPLMZUVLUVHUVIYPUUMUVHAVOJZUUGUVGUVISJXPUVOUUIUVGXPUVBUVOUVDAVPPZTZX
      PUUGUUHUVGVQZUUJUVGVRZYHYIXQAXRUUDXQOZVSRZUVHYPUUJUUHUVGUURVKVTZXPUUSUUIU
      VGUVFTZWAUVHUVKUVMVFMZUVNUVLUVHUVKUULUVIVNIZUVMUVHBVOJZYMYBJYNYBJUVKSJZXP
      UWFUUIUVGXPUVCUWFUVEBVPPZTUVHXRYBYHCXPYGUUIUVGUUFTZUVRWBZUVHXRYBYICUWIUVS
      WBZYMYNYABYBUUEYAOZVSRZUVHUULUVIXPUULSJUUIUVGUVATZUWAWCUVHUUMUVIUVHUUMUWC
      VTZUWAWCZXPUUGUVGUVKUWEVFMZUUHXPUUGUVGUWQYHYIXQYAABCUUKXRUUTUUDUVTUWLWDWE
      WFUVHUULUUMUVIUWNUWOUWAUVHAWGJZUUGUVGVEUVIVFMUVHUVOUWRUVQAWHZPUVRUVSYHYIX
      QAXRUUDUVTWIRUVHUULUWNWJWNWKUVHUWGUVMSJYPSJUWDUVNQUVLUMUWMUWPUWBUVKUVMYPW
      ORWLWMUVHYJUVIUUNLUVHYHYIXQXRUVRUVSWPWQUVHYOUVKYPLUVHYMYNYAYBUWJUWKWPWQWR
      WSYSUUQUBUUNNYKUUNWTZYRUUPHXRUWTYLUUOYQYKUUNYJLXAXBXCXDXEXFXPXSXRXGKJZYCY
      BXGKJZYFYGUUAQXHXPUVOUWRUXAUVPUWSXSAXRUUDXSOZXIXNXPUWFBWGJUXBUWHBWHYCBYBU
      UEYCOZXIXNUAUCUBHXSYCCXTYDXRYBXTOYDOXJXEXKXPDXTEYDUJXPUVODXTWTUVPXSDAXRFU
      UDUXCXLPXPUWFEYDWTUWHYCEBYBGUUEUXDXLPXOXM $.
  $}

  ${
    $d s t S $.  $d s t T $.
    $( A normed module homomorphism is a left module homomorphism which is also
       a normed group homomorphism.  (Contributed by Mario Carneiro,
       18-Oct-2015.) $)
    isnmhm $p |- ( F e. ( S NMHom T ) <-> ( ( S e. NrmMod /\ T e. NrmMod ) /\
      ( F e. ( S LMHom T ) /\ F e. ( S NGHom T ) ) ) ) $=
      ( vs vt cnmhm co wcel cnlm wa clmhm cnghm cv df-nmhm elmpt2cl wceq oveq12
      cin ineq12d ovex inex1 ovmpt2a eleq2d elin syl6bb biadan2 ) CABFGZHZAIHBI
      HJZCABKGZHCABLGZHJZDEIIDMZEMZKGZUMUNLGZRZABFCEDNZOUIUHCUJUKRZHULUIUGUSCDE
      ABIIUQUSFUMAPUNBPJUOUJUPUKUMAUNBKQUMAUNBLQSURUJUKABKTUAUBUCCUJUKUDUEUF $.

    $( Reverse closure for a normed module homomorphism.  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    nmhmrcl1 $p |- ( F e. ( S NMHom T ) -> S e. NrmMod ) $=
      ( cnmhm co wcel cnlm wa clmhm cnghm isnmhm simplbi simpld ) CABDEFZAGFZBG
      FZNOPHCABIEFCABJEFHABCKLM $.

    $( Reverse closure for a normed module homomorphism.  (Contributed by Mario
       Carneiro, 18-Oct-2015.) $)
    nmhmrcl2 $p |- ( F e. ( S NMHom T ) -> T e. NrmMod ) $=
      ( cnmhm co wcel cnlm wa clmhm cnghm isnmhm simplbi simprd ) CABDEFZAGFZBG
      FZNOPHCABIEFCABJEFHABCKLM $.

    $( A normed module homomorphism is a left module homomorphism (a linear
       operator).  (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    nmhmlmhm $p |- ( F e. ( S NMHom T ) -> F e. ( S LMHom T ) ) $=
      ( cnmhm co wcel clmhm cnghm cnlm wa isnmhm simprbi simpld ) CABDEFZCABGEF
      ZCABHEFZNAIFBIFJOPJABCKLM $.

    $( A normed module homomorphism is a normed group homomorphism.
       (Contributed by Mario Carneiro, 18-Oct-2015.) $)
    nmhmnghm $p |- ( F e. ( S NMHom T ) -> F e. ( S NGHom T ) ) $=
      ( cnmhm co wcel clmhm cnghm cnlm wa isnmhm simprbi simprd ) CABDEFZCABGEF
      ZCABHEFZNAIFBIFJOPJABCKLM $.

    $( A normed module homomorphism is a group homomorphism.  (Contributed by
       Mario Carneiro, 18-Oct-2015.) $)
    nmhmghm $p |- ( F e. ( S NMHom T ) -> F e. ( S GrpHom T ) ) $=
      ( cnmhm co wcel cnghm cghm nmhmnghm nghmghm syl ) CABDEFCABGEFCABHEFABCIA
      BCJK $.

    isnmhm2.1 $e |- N = ( S normOp T ) $.
    $( A normed module homomorphism is a left module homomorphism with bounded
       norm (a bounded linear operator).  (Contributed by Mario Carneiro,
       18-Oct-2015.) $)
    isnmhm2 $p |- ( ( S e. NrmMod /\ T e. NrmMod /\ F e. ( S LMHom T ) ) ->
      ( F e. ( S NMHom T ) <-> ( N ` F ) e. RR ) ) $=
      ( cnlm wcel clmhm co cnmhm cfv cr wb cnghm isnmhm baib baibd cngp nlmngp
      wa cghm lmghm isnghm syl2an sylan2 bitrd 3impa ) AFGZBFGZCABHIGZCABJIGZCD
      KLGZMUHUITZUJTUKCABNIGZULUMUKUJUNUKUMUJUNTABCOPQUJUMCABUAIGZUNULMABCUBUMU
      NUOULUHARGZBRGZUNUOULTZMUIASBSUNUPUQTURABCDEUCPUDQUEUFUG $.

    $( A normed module homomorphism has a real operator norm.  (Contributed by
       Mario Carneiro, 18-Oct-2015.) $)
    nmhmcl $p |- ( F e. ( S NMHom T ) -> ( N ` F ) e. RR ) $=
      ( cnmhm co wcel cnghm cfv cr nmhmnghm nghmcl syl ) CABFGHCABIGHCDJKHABCLA
      BCDEMN $.
  $}

  ${
    0nmhm.1 $e |- V = ( Base ` S ) $.
    $( The identity operator is a bounded linear operator.  (Contributed by
       Mario Carneiro, 20-Oct-2015.) $)
    idnmhm $p |- ( S e. NrmMod -> ( _I |` V ) e. ( S NMHom S ) ) $=
      ( cnlm wcel wa cid cres clmhm co cnghm cnmhm jca clmod nlmlmod idlmhm syl
      id cngp nlmngp idnghm isnmhm sylanbrc ) ADEZUDUDFGBHZAAIJEZUEAAKJEZFUEAAL
      JEUDUDUDUDRZUHMUDUFUGUDANEUFAOBACPQUDASEUGATABCUAQMAAUEUBUC $.

    0nmhm.2 $e |- .0. = ( 0g ` T ) $.
    0nmhm.f $e |- F = ( Scalar ` S ) $.
    0nmhm.g $e |- G = ( Scalar ` T ) $.
    $( The zero operator is a bounded linear operator.  (Contributed by Mario
       Carneiro, 20-Oct-2015.) $)
    0nmhm $p |- ( ( S e. NrmMod /\ T e. NrmMod /\ F = G ) ->
                  ( V X. { .0. } ) e. ( S NMHom T ) ) $=
      ( cnlm wcel wceq co clmod nlmlmod cngp nlmngp 3adant3 wa w3a csn cnmhm id
      cxp clmhm cnghm 0lmhm syl3an 0nghm syl2an wb isnmhm baib mpbir2and ) AKLZ
      BKLZCDMZUAEFUBUEZABUCNLZUSABUFNLZUSABUGNLZUPAOLUQBOLURURVAAPBPURUDECDABFH
      GIJUHUIUPUQVBURUPAQLBQLVBUQARBRABEFGHUJUKSUPUQUTVAVBTZULURUTUPUQTVCABUSUM
      UNSUO $.
  $}

  $( The composition of bounded linear operators is a bounded linear operator.
     (Contributed by Mario Carneiro, 20-Oct-2015.) $)
  nmhmco $p |- ( ( F e. ( T NMHom U ) /\ G e. ( S NMHom T ) ) ->
                 ( F o. G ) e. ( S NMHom U ) ) $=
    ( cnmhm co wcel cnlm clmhm cnghm nmhmrcl2 nmhmrcl1 anim12ci nmhmlmhm lmhmco
    wa ccom syl2an nmhmnghm nghmco jca isnmhm sylanbrc ) DBCFGHZEABFGHZQZAIHZCI
    HZQDERZACJGHZUJACKGHZQUJACFGHUEUIUFUHBCDLABEMNUGUKULUEDBCJGHEABJGHUKUFBCDOA
    BEODEABCPSUEDBCKGHEABKGHULUFBCDTABETABCDEUASUBACUJUCUD $.

  ${
    nmhmplusg.p $e |- .+ = ( +g ` T ) $.
    $( The sum of two bounded linear operators is bounded linear.  (Contributed
       by Mario Carneiro, 20-Oct-2015.) $)
    nmhmplusg $p |- ( ( F e. ( S NMHom T ) /\ G e. ( S NMHom T ) ) ->
                      ( F oF .+ G ) e. ( S NMHom T ) ) $=
      ( cnmhm co wcel wa cnlm cof clmhm cnghm nmhmrcl1 nmhmrcl2 nmhmlmhm adantl
      anim12i nmhmnghm lmhmplusg syl2an cabel clmod nlmlmod lmodabl 3syl adantr
      nghmplusg syl3anc jca isnmhm sylanbrc ) DBCGHZIZEUNIZJZBKIZCKIZJDEALHZBCM
      HZIZUTBCNHZIZJUTUNIUOURUPUSBCDOBCEPZSUQVBVDUODVAIEVAIVBUPBCDQBCEQADEBCFUA
      UBUQCUCIZDVCIZEVCIZVDUPVFUOUPUSCUDIVFVECUECUFUGRUOVGUPBCDTUHUPVHUOBCETRAB
      CDEFUIUJUKBCUTULUM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Topology on the reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z S $.
    qtopbas.1 $e |- S C_ RR* $.
    $( The set of open intervals with endpoints in a subset forms a basis for a
       topology.  (Contributed by Mario Carneiro, 17-Jun-2014.) $)
    qtopbaslem $p |- ( (,) " ( S X. S ) ) e. TopBases $=
      ( vx vy vz vw vv vu vt cioo wcel cv cin wral wa cxr wceq sseli cfv mp2an
      cxp cima cvv ctb crn iooex rnex imassrn ssexi co cle wbr cif iooin syl2an
      anim12i ifcl ancoms cop df-ov opelxpi wfun cdm wss wi cr cpw wf ioof ffun
      ax-mp xpss12 fdmi sseqtr4i funfvima2 syl syl5eqel an4s eqeltrd ralrimivva
      rgen2a wfn wb ffn ineq1 eleq1d ralbidv ralima fveq2 syl6eqr ineq1d ineq2d
      ineq2 ralxp bitri syl6bb mpbir fiinbas ) JAAUAZUBZUCKCLZDLZMZWTKZDWTNZCWT
      NZWTUDKWTJUEJUFUGJWSUHUIXFELZFLZJUJZGLZHLZJUJZMZWTKZHANGANZFANEANZXOEFAXG
      AKZXHAKZOZXNGHAAXSXJAKZXKAKZOZOXMXGXJUKULZXJXGUMZXHXKUKULZXHXKUMZJUJZWTXS
      XGPKZXHPKZOXJPKZXKPKZOXMYGQYBXQYHXRYIAPXGBRAPXHBRUPXTYJYAYKAPXJBRAPXKBRUP
      XGXHXJXKUNUOXQXTXRYAYGWTKZXQXTOYDAKZYFAKZYLXRYAOXTXQYMYCXJXGAUQURYEXHXKAU
      QYMYNOZYGYDYFUSZJSZWTYDYFJUTYOYPWSKZYQWTKZYDYFAAVAJVBZWSJVCZVDYRYSVEPPUAZ
      VFVGZJVHZYTVIUUBUUCJVJVKWSUUBUUAAPVDZUUEWSUUBVDZBBAPAPVLTZUUBUUCJVIVMVNWS
      YPJVOTVPVQUOVRVSVTWAXFILZJSZXBMZWTKZDWTNZIWSNZXPJUUBWBZUUFXFUUMWCUUDUUNVI
      UUBUUCJWDVKZUUGXEUULCIUUBWSJXAUUIQZXDUUKDWTUUPXCUUJWTXAUUIXBWEWFWGWHTUULX
      OIEFAAUUHXGXHUSZQZUULXIXBMZWTKZDWTNZXOUURUUKUUTDWTUURUUJUUSWTUURUUIXIXBUU
      RUUIUUQJSXIUUHUUQJWIXGXHJUTWJWKWFWGUVAXIUUIMZWTKZIWSNZXOUUNUUFUVAUVDWCUUO
      UUGUUTUVCDIUUBWSJXBUUIQUUSUVBWTXBUUIXIWMWFWHTUVCXNIGHAAUUHXJXKUSZQZUVBXMW
      TUVFUUIXLXIUVFUUIUVEJSXLUUHUVEJWIXJXKJUTWJWLWFWNWOWPWNWOWQCDWTUCWRT $.
  $}

  $( The set of open intervals with rational endpoints forms a basis for a
     topology.  (Contributed by NM, 8-Mar-2007.) $)
  qtopbas $p |- ( (,) " ( QQ X. QQ ) ) e. TopBases $=
    ( cq cr cxr qssre ressxr sstri qtopbaslem ) AABCDEFG $.

  $( A basis for the standard topology on the reals.  (Contributed by NM,
     6-Feb-2007.)  (Proof shortened by Mario Carneiro, 17-Jun-2014.) $)
  retopbas $p |- ran (,) e. TopBases $=
    ( cioo cxr cxp cima crn ctb cdm cr cpw ioof fdmi imaeq2i imadmrn qtopbaslem
    eqtr3i ssid eqeltrri ) ABBCZDZAEZFAAGZDSTUARARHIAJKLAMOBBPNQ $.

  $( The standard topology on the reals.  (Contributed by FL, 4-Jun-2007.) $)
  retop $p |- ( topGen ` ran (,) ) e. Top $=
    ( cioo crn ctb wcel ctg cfv ctop retopbas tgcl ax-mp ) ABZCDKEFGDHKIJ $.

  $( The underlying set of the standard topology on the reals is the reals.
     (Contributed by FL, 4-Jun-2007.) $)
  uniretop $p |- RR = U. ( topGen ` ran (,) ) $=
    ( cioo crn cuni ctg cfv unirnioo ctb wcel wceq retopbas unitg ax-mp eqtr4i
    cr ) NABZCZODECZFOGHQPIJOGKLM $.

  $( The standard topology on the reals is a topology on the reals.
     (Contributed by Mario Carneiro, 28-Aug-2015.) $)
  retopon $p |- ( topGen ` ran (,) ) e. ( TopOn ` RR ) $=
    ( cioo crn ctg cfv ctop wcel cr ctopon retop uniretop toptopon mpbi ) ABCDZ
    EFMGHDFIMGJKL $.

  $( The standard topological space on the reals.  (Contributed by NM,
     10-Feb-2007.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  retpsOLD $p |- <. RR , ( topGen ` ran (,) ) >. e. TopSpOLD $=
    ( cr cioo crn ctg cfv cop ctpsOLD wcel ctop cuni uniretop istpsOLD mpbir2an
    wceq retop ) ABCDEZFGHPIHAPJNOKAPLM $.

  ${
    retps.k $e |- K = { <. ( Base ` ndx ) , RR >. ,
                      <. ( TopSet ` ndx ) , ( topGen ` ran (,) ) >. } $.
    $( The standard topological space on the reals.  (Contributed by NM,
       19-Oct-2012.) $)
    retps $p |- K e. TopSp $=
      ( cr cioo crn ctg cfv uniretop retop eltpsi ) CDEFGABHIJ $.
  $}

  $( Open intervals are open sets of the standard topology on the reals .
     (Contributed by FL, 18-Jun-2007.) $)
  iooretop $p |- ( A (,) B ) e. ( topGen ` ran (,) ) $=
    ( cioo crn ctg cfv co ctb wcel wss retopbas bastg ax-mp ioorebas sselii ) C
    DZPEFZABCGPHIPQJKPHLMABNO $.

  $( Closed intervals are closed sets of the standard topology on ` RR ` .
     (Contributed by FL, 14-Sep-2007.) $)
  icccld $p |- ( ( A e. RR /\ B e. RR ) -> ( A [,] B ) e.
        ( Clsd ` ( topGen ` ran (,) ) ) ) $=
    ( cr wcel wa cicc co cioo crn ctg cfv ccld cdif cmnf cpnf cun difreicc ctop
    retop iooretop unopn syl6eqel wss wb iccssre uniretop iscld2 sylancr mpbird
    mp3an ) ACDBCDEZABFGZHIJKZLKDZCULMZUMDZUKUONAHGZBOHGZPZUMABQUMRDZUQUMDURUMD
    USUMDSNATBOTUQURUMUAUJUBUKUTULCUCUNUPUDSABUEULUMCUFUGUHUI $.

  ${
    $d v w x y z A $.
    $( Right-unbounded closed intervals are closed sets of the standard
       topology on ` RR ` .  (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    icopnfcld $p |- ( A e. RR -> ( A [,) +oo ) e.
          ( Clsd ` ( topGen ` ran (,) ) ) ) $=
      ( vx vy vz vw cr wcel cpnf cico co cmnf cioo cdif cfv cxr clt wbr a1i cle
      wceq crn ctg ccld cun mnfxr rexr pnfxr mnflt df-ioo df-ico xrlenlt xrlttr
      ltpnf cv xrltletr ixxun syl32anc ioomax syl6eq wss cin c0 ioossre ixxdisj
      syl3anc uneqdifeq sylancr mpbid ctop retop iooretop uniretop opncld mp2an
      wb syl6eqelr ) AFGZAHIJZFKALJZMZLUAUBNZUCNZVQVSVRUDZFTZVTVRTZVQWCKHLJZFVQ
      KOGZAOGZHOGZKAPQAHPQWCWFTWGVQUERZAUFZWIVQUGRZAUHAUMBCDEKAHILPPSPLPPBCDUIZ
      BCDUJZAEUNZUKZWMWOAHULKAWOUOUPUQURUSVQVSFUTVSVRVAVBTZWDWEVOKAVCVQWGWHWIWQ
      WJWKWLBCDEKAHIPPSPLWMWNWPVDVEVSVRFVFVGVHWAVIGVSWAGVTWBGVJKAVKVSWAFVLVMVNV
      P $.

    $( Left-unbounded closed intervals are closed sets of the standard topology
       on ` RR ` .  (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    iocmnfcld $p |- ( A e. RR -> ( -oo (,] A ) e.
          ( Clsd ` ( topGen ` ran (,) ) ) ) $=
      ( vx vy vz vw cr wcel cmnf cioc co cioo cfv cpnf wceq cxr clt wbr a1i cle
      mnfxr crn ctg ccld cdif cun rexr pnfxr mnflt ltpnf df-ioc df-ioo xrlelttr
      cv xrltnle xrlttr ixxun syl32anc ioomax syl6eq wss cin c0 wb iocssre mpan
      ixxdisj syl3anc uneqdifeq syl2anc mpbid iooretop syl6eqel uniretop iscld2
      ctop retop sylancr mpbird ) AFGZHAIJZKUAUBLZUCLGZFVTUDZWAGZVSWCAMKJZWAVSV
      TWEUEZFNZWCWENZVSWFHMKJZFVSHOGZAOGZMOGZHAPQAMPQWFWINWJVSTRZAUFZWLVSUGRZAU
      HAUIBCDEHAMKKPSPPIPPBCDUJZBCDUKZAEUMZUNZWQWRAMULHAWRUOUPUQURUSVSVTFUTZVTW
      EVAVBNZWGWHVCWJVSWTTHAVDVEZVSWJWKWLXAWMWNWOBCDEHAMKPSPPIWPWQWSVFVGVTWEFVH
      VIVJAMVKVLVSWAVOGWTWBWDVCVPXBVTWAFVMVNVQVR $.

    $( ` QQ ` is dense in the standard topology on ` RR ` .  (Contributed by
       NM, 1-Mar-2007.) $)
    qdensere $p |- ( ( cls ` ( topGen ` ran (,) ) ) ` QQ ) = RR $=
      ( vx vy vz vw cq cioo cfv cr wcel wss qssre uniretop cv c0 cxr clt wbr wa
      wrex a1i crn ctg ccl ctop retop clsss3 mp2an cin wne wi wral wceq cxp cpw
      co wf wfn ioof ffn ovelrn mp2b w3a elioo3g simplbi simp1d simp2d eliooord
      simp3d simpld simprd xrlttrd qbtwnxr syl3anc ad2antrr ad2antlr rexrd 3jca
      wb qre simpr sylanbrc simplr inelcm syl2anc ex rexlimdva mpd eleq2 neeq1d
      ineq1 3imtr4d rexlimivw sylbi rgen eqidd ctb retopbas elcls3 mpbiri ssriv
      cuni id eqssi ) EFUAZUBGZUCGGZHXEUDIEHJZXFHJUEKEXEHLUFUGAHXFAMZHIZXHXFIXH
      BMZIZXJEUHZNUIZUJZBXDUKXNBXDXJXDIZXJCMZDMZFUOZULZDOSZCOSZXNOOUMZHUNZFUPFY
      BUQXOYAVRURYBYCFUSCDOOXJFUTVAXTXNCOXSXNDOXSXHXRIZXREUHZNUIZXKXMYDYFUJXSYD
      XPXJPQXJXQPQRZBESZYFYDXPOIZXQOIZXPXQPQYHYDYIYJXHOIZYDYIYJYKVBXPXHPQZXHXQP
      QZRXPXQXHVCVDZVEZYDYIYJYKYNVFZYDXPXHXQYOYDYIYJYKYNVHYPYDYLYMXHXPXQVGZVIYD
      YLYMYQVJVKBXPXQVLVMYDYGYFBEYDXJEIZRZYGYFYSYGRZXJXRIZYRYFYTYIYJXJOIZVBYGUU
      AYTYIYJUUBYDYIYRYGYOVNYDYJYRYGYPVNYTXJYRXJHIYDYGXJVSVOVPVQYSYGVTXPXQXJVCW
      AYDYRYGWBXJXREWCWDWEWFWGTXJXRXHWHXSXLYENXJXREWJWIWKWLWLWMWNXIBXDXHEXEHXIX
      EWOHXEXAULXILTXDWPIXIWQTXGXIKTXIXBWRWSWTXC $.
  $}

  ${
    cnmetdval.1 $e |- D = ( abs o. - ) $.
    $( Value of the distance function of the metric space of complex numbers.
       (Contributed by NM, 9-Dec-2006.)  (Revised by Mario Carneiro,
       27-Dec-2014.) $)
    cnmetdval $p |- ( ( A e. CC /\ B e. CC ) ->
                  ( A D B ) = ( abs ` ( A - B ) ) ) $=
      ( cc wcel wa cop cabs cmin ccom cfv co cxp wceq subf opelxpi fvco3 df-ov
      wf sylancr fveq1i eqtri fveq2i 3eqtr4g ) AEFBEFGZABHZIJKZLZUGJLZILZABCMZA
      BJMZILUFEENZEJTUGUNFUIUKOPABEEQUNEUGIJRUAULUGCLUIABCSUGCUHDUBUCUMUJIABJSU
      DUE $.
  $}

  ${
    $d x y z $.
    $( The absolute value metric determines a metric space on the complex
       numbers.  This theorem provides a link between complex numbers and
       metrics spaces, making metric space theorems available for use with
       complex numbers.  (Contributed by FL, 9-Oct-2006.) $)
    cnmet $p |- ( abs o. - ) e. ( Met ` CC ) $=
      ( vx vy vz cabs cmin cc cr wf cv wcel wa cfv cc0 wceq cnmetdval w3a caddc
      co cle 3adant2 ccom cnex cxp absf subf fco mp2an subcl eqid eqcomd eqeq1d
      abs00ad subeq0 3bitr3d abs3dif abssub oveq1d breqtrd 3adant3 3coml ismeti
      oveq12d 3brtr4d ) ABCDEUAZFUBFGDHFFUCZFEHVEGVDHUDUEVEFGDEUFUGAIZFJZBIZFJZ
      KZVFVHERZDLZMNVKMNVFVHVDRZMNVFVHNVJVKVFVHUHULVJVLVMMVJVMVLVFVHVDVDUIZOZUJ
      UKVFVHUMUNVGVICIZFJZPZVLVPVFERDLZVPVHERDLZQRZVMVPVFVDRZVPVHVDRZQRZSVRVLVF
      VPERDLZVTQRZWASVFVHVPUOVGVQWFWANVIVGVQKWEVSVTQVFVPUPUQTURVGVIVMVLNVQVOUSV
      QVGVIWDWANVQVGVIPWBVSWCVTQVQVGWBVSNVIVPVFVDVNOUSVQVIWCVTNVGVPVHVDVNOTVBUT
      VCVA $.

    $( The absolute value metric is an extended metric.  (Contributed by Mario
       Carneiro, 28-Aug-2015.) $)
    cnxmet $p |- ( abs o. - ) e. ( *Met ` CC ) $=
      ( cabs cmin ccom cc cme cfv wcel cxmt cnmet metxmet ax-mp ) ABCZDEFGLDHFG
      ILDJK $.
  $}

  ${
    $d x D $.  $d x R $.
    cnblcld.1 $e |- D = ( abs o. - ) $.
    $( Two ways to write the open ball centered at zero.  (Contributed by Mario
       Carneiro, 8-Sep-2015.) $)
    cnbl0 $p |- ( R e. RR* ->
      ( `' abs " ( 0 [,) R ) ) = ( 0 ( ball ` D ) R ) ) $=
      ( vx wcel cabs cc0 co cfv cc wa clt wbr cr adantl wb wceq cmin 0cn eqtrd
      cxr ccnv cico cima cbl cle w3a abscl absge0 jca biantrurd df-3an syl6rbbr
      cv 0re simpl elico2 sylancr cnmetdval abssub subid1 fveq2d breq1d 3bitr4d
      mpan pm5.32da wfn wf absf ffn elpreima mp1i cxmt ccom cnxmet eqeltri elbl
      ax-mp mp3an12 eqrdv ) BUAEZDFUBGBUCHZUDZGBAUEIHZWADUNZJEZWEFIZWBEZKZWFGWE
      AHZBLMZKZWEWCEZWEWDEZWAWFWHWKWAWFKZWGNEZGWGUFMZWGBLMZUGZWRWHWKWOWRWPWQKZW
      RKWSWOWTWRWFWTWAWFWPWQWEUHWEUIUJOUKWPWQWRULUMWOGNEWAWHWSPUOWAWFUPGBWGUQUR
      WOWJWGBLWFWJWGQWAWFWJWEGRHZFIZWGGJEZWFWJXBQSXCWFKWJGWERHFIXBGWEACUSGWEUTT
      VEWFXAWEFWEVAVBTOVCVDVFFJVGZWMWIPWAJNFVHXDVIJNFVJVRJWEWBFVKVLAJVMIZEXCWAW
      NWLPAFRVNXECVOVPSWEAGBJVQVSVDVT $.

    $( Two ways to write the closed ball centered at zero.  (Contributed by
       Mario Carneiro, 8-Sep-2015.) $)
    cnblcld $p |- ( R e. RR* ->
      ( `' abs " ( 0 [,] R ) ) = { x e. CC | ( 0 D x ) <_ R } ) $=
      ( cxr wcel cabs cc0 co cc cle wbr wa cfv cr wb adantl wceq cmin eqtrd cab
      ccnv cicc cima cv crab wf wfn absf ffn elpreima mp2b w3a abscl absge0 jca
      rexrd biantrurd df-3an syl6rbbr 0xr simpl elicc1 sylancr cnmetdval abssub
      mpan subid1 fveq2d breq1d 3bitr4d pm5.32da syl5bb abbi2dv df-rab syl6eqr
      0cn ) CEFZGUBHCUCIZUDZAUEZJFZHWABIZCKLZMZAUAWDAJUFVRWEAVTWAVTFZWBWAGNZVSF
      ZMZVRWEJOGUGGJUHWFWIPUIJOGUJJWAVSGUKULVRWBWHWDVRWBMZWGEFZHWGKLZWGCKLZUMZW
      MWHWDWJWMWKWLMZWMMWNWJWOWMWBWOVRWBWKWLWBWGWAUNUQWAUOUPQURWKWLWMUSUTWJHEFV
      RWHWNPVAVRWBVBHCWGVCVDWJWCWGCKWBWCWGRVRWBWCWAHSIZGNZWGHJFZWBWCWQRVQWRWBMW
      CHWASIGNWQHWABDVEHWAVFTVGWBWPWAGWAVHVITQVJVKVLVMVNWDAJVOVP $.
  $}

  $( The complex number field is a metric space.  (Contributed by Mario
     Carneiro, 28-Aug-2015.) $)
  cnfldms $p |- CCfld e. MetSp $=
    ( ccnfld cmt wcel cabs cmin ccom cc cme cmopn wceq cnmet eqid cxmt cnfldbas
    cfv ctopon mp2b cres cr wf cnxmet mopntopon cnfldtset topontopn cxp cds wfn
    ctopn absf subf fco mp2an ffn fnresdm cnfldds reseq1i eqtr3i isms2 mpbir2an
    ) ABCDEFZGHOCUTIOZVAJKVALZUTVAAGUTGMOCVAGPOCVAAUHOJUAUTVAGVBUBGVAANUCUDQNUT
    GGUEZRZUTAUFOZVCRVCSUTTZUTVCUGVDUTJGSDTVCGETVFUIUJVCGSDEUKULVCSUTUMVCUTUNQU
    TVEVCUOUPUQURUS $.

  $( The complex number field is a topological space.  (Contributed by Mario
     Carneiro, 28-Aug-2015.) $)
  cnfldxms $p |- CCfld e. *MetSp $=
    ( ccnfld cmt wcel cxme cnfldms msxms ax-mp ) ABCADCEAFG $.

  $( The complex number field is a topological space.  (Contributed by Mario
     Carneiro, 28-Aug-2015.) $)
  cnfldtps $p |- CCfld e. TopSp $=
    ( ccnfld cmt wcel ctps cnfldms mstps ax-mp ) ABCADCEAFG $.

  ${
    $( The norm of the field of complex numbers.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    cnfldnm $p |- abs = ( norm ` CCfld ) $=
      ( vx cc cv cc0 cabs cmin ccom cmpt cfv ccnfld cnm wcel wceq 0cn cnmetdval
      co eqid mpan2 wtru cr subid1 fveq2d eqtrd mpteq2ia cnfldbas cnfld0 nmfval
      cnfldds wf absf a1i feqmptd trud 3eqtr4ri ) ABACZDEFGZPZHABUOEIZHZJKIZEAB
      UQURUOBLZUQUODFPZEIZURVADBLUQVCMNUODUPUPQORVAVBUOEUOUAUBUCUDAUPUTJBDUTQUE
      UFUHUGEUSMSABTEBTEUISUJUKULUMUN $.

    $( The complex numbers form a normed group.  (Contributed by Mario
       Carneiro, 4-Oct-2015.) $)
    cnngp $p |- CCfld e. NrmGrp $=
      ( ccnfld cngp wcel cgrp cmt cabs cmin ccom wss cnrng rnggrp ax-mp cnfldms
      crg ssid cnfldnm cnfldsub cnfldds isngp mpbir3an ) ABCADCZAECFGHZUBIANCUA
      JAKLMUBOUBAGFPQRST $.

    $( The complex numbers form a normed ring.  (Contributed by Mario Carneiro,
       4-Oct-2015.) $)
    cnnrg $p |- CCfld e. NrmRing $=
      ( ccnfld cnrg wcel cngp cabs cabv cfv cnngp absabv cnfldnm isnrg mpbir2an
      eqid ) ABCADCEAFGZCHINAEJNMKL $.

    cnfldtopn.1 $e |- J = ( TopOpen ` CCfld ) $.
    $( The topology of the complex numbers.  (Contributed by Mario Carneiro,
       28-Aug-2015.) $)
    cnfldtopn $p |- J = ( MetOpen ` ( abs o. - ) ) $=
      ( ccnfld ctopn cfv cabs cmin ccom cmopn cxmt wcel ctopon wceq cnxmet eqid
      cc mopntopon cnfldbas cnfldtset topontopn mp2b eqtr4i ) ACDEZFGHZIEZBUDPJ
      EKUEPLEKUEUCMNUDUEPUEOQPUECRSTUAUB $.

    $( The topology of the complex numbers is a topology.  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    cnfldtopon $p |- J e. ( TopOn ` CC ) $=
      ( ccnfld ctps wcel cc ctopon cfv cnfldtps cnfldbas istps mpbi ) CDEAFGHEI
      FACJBKL $.

    $( The topology of the complex numbers is a topology.  (Contributed by
       Mario Carneiro, 2-Sep-2015.) $)
    cnfldtop $p |- J e. Top $=
      ( cc cnfldtopon topontopi ) CAABDE $.

    $( The topology of the complex numbers is Hausdorff.  (Contributed by Mario
       Carneiro, 8-Sep-2015.) $)
    cnfldhaus $p |- J e. Haus $=
      ( cabs cmin ccom cc cxmt cfv wcel cha cnxmet cnfldtopn methaus ax-mp ) CD
      EZFGHIAJIKOAFABLMN $.
  $}

  ${
    $d r x y z D $.  $d x A $.  $d x B $.
    remet.1 $e |- D = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    $( Value of the distance function of the metric space of real numbers.
       (Contributed by NM, 16-May-2007.) $)
    remetdval $p |- ( ( A e. RR /\ B e. RR ) ->
                  ( A D B ) = ( abs ` ( A - B ) ) ) $=
      ( cr wcel wa co cop cabs cmin ccom cxp cres cfv df-ov fveq1i wceq cc recn
      eqtri opelxpi fvres syl eqid cnmetdval syl2an syl5eqr eqtrd syl5eq ) AEFZ
      BEFZGZABCHZABIZJKLZEEMZNZOZABKHJOZUNUOCOUSABCPUOCURDQUAUMUSUOUPOZUTUMUOUQ
      FUSVARABEEUBUOUQUPUCUDUMVAABUPHZUTABUPPUKASFBSFVBUTRULATBTABUPUPUEUFUGUHU
      IUJ $.

    $( The absolute value metric determines a metric space on the reals.
       (Contributed by NM, 10-Feb-2007.) $)
    remet $p |- D e. ( Met ` RR ) $=
      ( cabs cmin ccom cr cxp cres cme cfv cc wss cnmet ax-resscn metres2 mp2an
      wcel eqeltri ) ACDEZFFGHZFIJZBSKIJQFKLTUAQMNSFKOPR $.

    $( The absolute value metric is an extended metric.  (Contributed by Mario
       Carneiro, 28-Aug-2015.) $)
    rexmet $p |- D e. ( *Met ` RR ) $=
      ( cr cme cfv wcel cxmt remet metxmet ax-mp ) ACDEFACGEFABHACIJ $.

    $( A ball in terms of an open interval of reals.  (Contributed by NM,
       18-May-2007.)  (Revised by Mario Carneiro, 13-Nov-2013.) $)
    bl2ioo $p |- ( ( A e. RR /\ B e. RR ) ->
                   ( A ( ball ` D ) B ) = ( ( A - B ) (,) ( A + B ) ) ) $=
      ( vx cr wcel wa cfv co cmin clt wbr cabs wb cc recn syl2an cxr rexr caddc
      cbl cioo cv w3a remetdval wceq abssub eqtrd breq1d adantlr absdiflt 3expb
      ancoms bitrd pm5.32da 3anass syl6bbr rexmet mp3an1 sylan2 resubcl readdcl
      cxmt elbl elioo2 syl2anc 3bitr4d eqrdv ) AFGZBFGZHZEABCUBIJZABKJZABUAJZUC
      JZVLEUDZFGZAVQCJZBLMZHZVRVNVQLMZVQVOLMZUEZVQVMGZVQVPGZVLWAVRWBWCHZHWDVLVR
      VTWGVLVRHVTVQAKJNIZBLMZWGVJVRVTWIOVKVJVRHZVSWHBLWJVSAVQKJNIZWHAVQCDUFVJAP
      GVQPGWKWHUGVRAQVQQAVQUHRUIUJUKVRVLWIWGOZVRVJVKWLVQABULUMUNUOUPVRWBWCUQURV
      KVJBSGZWEWAOZBTCFVDIGVJWMWNCDUSVQCABFVEUTVAVLVNFGZVOFGZWFWDOZABVBABVCWOVN
      SGVOSGWQWPVNTVOTVNVOVQVFRVGVHVI $.

    $( An open interval of reals in terms of a ball.  (Contributed by NM,
       18-May-2007.)  (Revised by Mario Carneiro, 28-Aug-2015.) $)
    ioo2bl $p |- ( ( A e. RR /\ B e. RR ) -> ( A (,) B ) =
     ( ( ( A + B ) / 2 ) ( ball ` D ) ( ( B - A ) / 2 ) ) ) $=
      ( cr wcel wa caddc co c2 cdiv cmin cioo wceq ancoms rehalfcld recn oveq1d
      cc syl2anr cbl cfv readdcl resubcl bl2ioo addcom halfaddsub simprd simpld
      syl2anc oveq12d 3eqtr3rd ) AEFZBEFZGZBAHIZJKIZBALIZJKIZCUAUBZIZUQUSLIZUQU
      SHIZMIZABHIZJKIZUSUTIABMIUOUQEFUSEFVAVDNUOUPUNUMUPEFBAUCOPUOURUNUMUREFBAU
      DOPUQUSCDUEUJUOUQVFUSUTUOUPVEJKUNBSFZASFZUPVENUMBQZAQZBAUFTRRUOVBAVCBMUOV
      CBNZVBANZUNVGVHVKVLGUMVIVJBAUGTZUHUOVKVLVMUIUKUL $.

    $( An open interval of reals in terms of a ball.  (Contributed by Mario
       Carneiro, 14-Nov-2013.) $)
    ioo2blex $p |- ( ( A e. RR /\ B e. RR ) ->
                     ( A (,) B ) e. ran ( ball ` D ) ) $=
      ( cr wcel wa cioo co caddc cdiv cmin cbl cfv crn ioo2bl readdcl rehalfcld
      c2 cxr resubcl ancoms rexrd cxmt rexmet blelrn mp3an1 syl2anc eqeltrd ) A
      EFZBEFZGZABHIABJIZSKIZBALIZSKIZCMNZIZUQOZABCDPULUNEFZUPTFZURUSFZULUMABQRU
      LUPULUOUKUJUOEFBAUAUBRUCCEUDNFUTVAVBCDUECUNUPEUFUGUHUI $.

    $( The balls of the standard real metric space are included in the open
       real intervals.  (Contributed by NM, 8-May-2007.)  (Revised by Mario
       Carneiro, 13-Nov-2013.) $)
    blssioo $p |- ran ( ball ` D ) C_ ran (,) $=
      ( vz vy vr cfv crn cioo cv wcel co wceq cxr cr ax-mp wa cpnf cmnf c0 cc0
      cbl wrex cxmt rexmet blrn w3o elxr cmin caddc bl2ioo resubcl readdcl rexr
      wb cxp wfn cpw wf ioof ffn fnovrn mp3an1 syl2an syl2anc eqeltrd oveq2 cme
      remet blpnf sylan9eqr ioomax ioorebas eqeltrri syl6eqel clt wbr wn nltmnf
      mpan 0xr mnfxr xbln0 mp3an13 necon1bbid mpbii iooid 3jaodan sylan2b eleq1
      wne syl5ibrcom rexlimivv sylbi ssriv ) CAUAFZGZHGZCIZWPJZWRDIZEIZWOKZLZEM
      UBDNUBZWRWQJZANUCFJZWSXDUNABUDZDWRANEUEOXCXEDENMWTNJZXAMJZPXEXCXBWQJZXIXH
      XANJZXAQLZXARLZUFXJXAUGXHXKXJXLXMXHXKPZXBWTXAUHKZWTXAUIKZHKZWQWTXAABUJXNX
      ONJZXPNJZXQWQJZWTXAUKWTXAULXRXOMJZXPMJZXTXSXOUMXPUMHMMUOZUPZYAYBXTYCNUQZH
      URYDUSYCYEHUTOMMXOXPHVAVBVCVDVEXHXLPXBNWQXLXHXBWTQWOKZNXAQWTWOVFANVGFJXHY
      FNLABVHAWTNVIVSVJRQHKNWQVKRQVLVMVNXHXMPXBSWQXMXHXBWTRWOKZSXARWTWOVFXHTRVO
      VPZVQZYGSLTMJYIVTTVROXHYHYGSXFXHRMJYGSWJYHUNXGWAAWTRNWBWCWDWEVJTTHKSWQTWF
      TTVLVMVNWGWHWRXBWQWIWKWLWMWN $.

    ${
      $d a b v x y z $.  $d a b x y z D $.  $d v J $.
      tgioo.2 $e |- J = ( MetOpen ` D ) $.
      $( The topology generated by open intervals of reals is the same as the
         open sets of the standard metric space on the reals.  (Contributed by
         NM, 7-May-2007.)  (Revised by Mario Carneiro, 13-Nov-2013.) $)
      tgioo $p |- ( topGen ` ran (,) ) = J $=
        ( vz cioo cr wcel wceq wss cv co wrex wa c1 cxr syl2anc syl wbr cmnf vv
        vx vy va vb cbl cfv crn ctg cxmt rexmet mopnval ax-mp blssioo wral cuni
        crp elssuni unirnioo syl6sseqr cin ctb retopbas simpl sselda cmin caddc
        a1i 1re bl2ioo mpan2 peano2rem rexrd peano2re cxp wfn cpw wf ffn fnovrn
        ioof mp3an1 eqeltrd 1rp blcntr mp3an13 elin sylanbrc basis2 syl22anc wb
        simpr ovelrn wi eleq2 sseq1 anbi12d cle cif inss2 adantl elioore adantr
        sstr sseqtrd dfss sylib eliooxr jca iooin eqtrd clt mnfxr simpld simprd
        ifcl mnflt xrmax2 xrltletrd eleqtrd c0 ne0i ioon0 syl5ib mpcom syl32anc
        xrre2 mnfle xrlelttrd xrmin2 xrre ioo2blex inss1 rspcev syl12anc blssex
        wne sylancr mpbid syl6bi rexlimivv imp sylanb rexlimiva ralrimiva ssriv
        elmopn2 sseqtri 2basgen mp2an eqtr2i ) BAUFUGZUHZUIUGZFUHZUIUGZAGUJUGHZ
        BUUNIACUKZABGDULUMZUUMUUOJUUOUUNJUUNUUPIACUNUUOBUUNUAUUOBUAKZUUOHZUUTGJ
        ZUBKZUCKUULLUUTJUCUQMZUBUUTUOZUUTBHZUVAUUTUUOUPGUUTUUOURUSUTZUVAUVDUBUU
        TUVAUVCUUTHZNZUVCEKZHZUVJUUTUVCOUULLZVAZJZNZEUUOMZUVDUVIUUOVBHZUVAUVLUU
        OHZUVCUVMHZUVPUVQUVIVCVHUVAUVHVDUVIUVCGHZUVRUVAUUTGUVCUVGVEZUVTUVLUVCOV
        FLZUVCOVGLZFLZUUOUVTOGHUVLUWDIZVIUVCOACVJVKZUVTUWBPHZUWCPHZUWDUUOHZUVTU
        WBUVCVLZVMZUVTUWCUVCVNZVMZFPPVOZVPZUWGUWHUWIUWNGVQZFVRUWOWAUWNUWPFVSUMZ
        PPUWBUWCFVTWBQWCRUVIUVHUVCUVLHZUVSUVAUVHWLUVIUVTUWRUWAUUQUVTOUQHUWRUURW
        DAUVCOGWEWFRUVCUUTUVLWGWHEUVCUUOUUTUVLWIWJUVOUVDEUUOUVJUUOHZUVJUDKZUEKZ
        FLZIZUEPMUDPMZUVOUVDUWOUWSUXDWKUWQUDUEPPUVJFWMUMUXDUVOUVDUXCUVOUVDWNZUD
        UEPPUXCUXEWNUWTPHZUXAPHZNZUXCUVOUVCUXBHZUXBUVMJZNZUVDUXCUVKUXIUVNUXJUVJ
        UXBUVCWOZUVJUXBUVMWPWQUXKUVKUVJUUTJZNZEUUMMZUVDUXKUXBUUMHUXIUXBUUTJZUXO
        UXKUXBUWTUWBWRSZUWBUWTWSZUXAUWCWRSZUXAUWCWSZFLZUUMUXKUXBUXBUWDVAZUYAUXK
        UXBUWDJUXBUYBIUXKUXBUVLUWDUXJUXBUVLJZUXIUXJUVMUVLJUYCUUTUVLWTUXBUVMUVLX
        DVKXAUXKUVTUWEUXIUVTUXJUVCUWTUXAXBZXCZUWFRXEUXBUWDXFXGUXIUYBUYAIZUXJUXI
        UXHUWGUWHNZUYFUVCUWTUXAXHZUXIUVTUYGUYDUVTUWGUWHUWKUWMXIRUWTUXAUWBUWCXJQ
        XCXKZUXKUXRGHZUXTGHZUYAUUMHUXKTPHZUXRPHZUXTPHZTUXRXLSUXRUXTXLSZUYJUYLUX
        KXMVHZUXKUWGUXFUYMUXKUVTUWGUYEUWKRZUXKUXFUXGUXIUXHUXJUYHXCZXNZUXQUWBUWT
        PXPQZUXKUXGUWHUYNUXKUXFUXGUYRXOZUXKUWCUXKUVTUWCGHZUYEUWLRZVMZUXSUXAUWCP
        XPQZUXKTUWBUXRUYPUYQUYTUXKUWBGHZTUWBXLSUXIVUFUXJUXIUVTVUFUYDUWJRXCUWBXQ
        RUXKUXFUWGUWBUXRWRSUYSUYQUWTUWBXRQXSUXKUVCUYAHZUYOUXKUVCUXBUYAUXIUXJVDZ
        UYIXTUYMUYNNZVUGUYOUVCUXRUXTXHVUGUYAYAYQVUIUYOUYAUVCYBUXRUXTYCYDYERZTUX
        RUXTYGYFUXKUYNVUBTUXTXLSUXTUWCWRSZUYKVUEVUCUXKTUXRUXTUYPUYTVUEUXKUYMTUX
        RWRSUYTUXRYHRVUJYIUXKUXGUWHVUKVUAVUDUXAUWCYJQUXTUWCYKWJUXRUXTACYLQWCVUH
        UXJUXPUXIUXJUVMUUTJUXPUUTUVLYMUXBUVMUUTXDVKXAUXNUXIUXPNEUXBUUMUXCUVKUXI
        UXMUXPUXLUVJUXBUUTWPWQYNYOUXKUUQUVTUXOUVDWKUURUYEEUUTAUVCGUCYPYRYSYTVHU
        UAUUBUUCUUDRUUEUUQUVFUVBUVENWKUURUBUCUUTABGDUUGUMWHUUFUUSUUHUUMUUOUUIUU
        JUUK $.

      $( ` QQ ` is dense in ` RR ` .  (Contributed by NM, 24-Aug-2007.) $)
      qdensere2 $p |- ( ( cls ` J ) ` QQ ) = RR $=
        ( cq cioo crn ctg cfv ccl cr tgioo fveq2i fveq1i qdensere eqtr3i ) EFGH
        IZJIZIEBJIZIKERSQBJABCDLMNOP $.
    $}
  $}

  ${
    blcvx.s $e |- S = ( P ( ball ` ( abs o. - ) ) R ) $.
    $( An open ball in the complex numbers is a convex set.  (Contributed by
       Mario Carneiro, 12-Feb-2015.)  (Revised by Mario Carneiro,
       8-Sep-2015.) $)
    blcvx $p |- ( ( ( P e. CC /\ R e. RR* ) /\
        ( A e. S /\ B e. S /\ T e. ( 0 [,] 1 ) ) ) ->
      ( ( T x. A ) + ( ( 1 - T ) x. B ) ) e. S ) $=
      ( cc wcel wa cc0 c1 co cmul cmin cabs clt wbr cr adantr cxr cicc w3a ccom
      caddc cbl cfv cle simpr3 0re 1re elicc2i sylib simp1d recnd syl6eleq cxmt
      simpr1 cnxmet a1i simpll simplr elbl syl3anc mpbid simpld resubcl sylancr
      wb mulcld simpr2 addcld wceq eqid cnmetdval syl2anc subdid oveq12d ax-1cn
      addsub4d pncan3 sylancl oveq1d adddird mulid2 3eqtr3d 3eqtr2d fveq2d cpnf
      ad2antrr eqtr4d subcld abscld readdcld simpr abstrid oveq1 mul02d abs00bd
      sylan9eqr oveq2 subid1i syl6eq mulid2d addid2d simprd eqbrtrd adantlr wne
      absmuld simp2d absidd eqtrd eqbrtrrd leltned biimpar syl112anc abssubge0d
      ltmul2 simp3d subge0 mpbird jca wi ltle sylan mpd lemul2a remulcl ltleadd
      syl31anc syl22anc mp2and breqtrd pm2.61dane lelttrd ltpnf syl breqtrrd
      0xr wo rexrd absge0d xrlelttrd xrltle ge0nemnf xrnemnf mpjaodan mpbir2and
      cmnf syl6eleqr ) CHIZDUAIZJZAEIZBEIZFKLUBMIZUCZJZFANMZLFOMZBNMZUEMZCDPOUD
      ZUFUGMZEUUSUVCUVEIZUVCHIZCUVCUVDMZDQRZUUSUUTUVBUUSFAUUSFUUSFSIZKFUHRZFLUH
      RZUUSUUQUVJUVKUVLUCUUNUUOUUPUUQUIKLFUJUKULUMZUNZUOZUUSAHIZCAUVDMZDQRZUUSA
      UVEIZUVPUVRJZUUSAEUVEUUNUUOUUPUUQURGUPUUSUVDHUQUGIZUULUUMUVSUVTVIUWAUUSUS
      UTZUULUUMUURVAZUULUUMUURVBZAUVDCDHVCVDVEZVFZVJZUUSUVABUUSUVAUUSLSIZUVJUVA
      SIZUKUVNLFVGVHZUOZUUSBHIZCBUVDMZDQRZUUSBUVEIZUWLUWNJZUUSBEUVEUUNUUOUUPUUQ
      VKGUPUUSUWAUULUUMUWOUWPVIUWBUWCUWDBUVDCDHVCVDVEZVFZVJZVLZUUSUVHFCAOMZNMZU
      VACBOMZNMZUEMZPUGZDQUUSUVHCUVCOMZPUGZUXFUUSUULUVGUVHUXHVMUWCUWTCUVCUVDUVD
      VNZVOVPUUSUXEUXGPUUSUXEFCNMZUUTOMZUVACNMZUVBOMZUEMUXJUXLUEMZUVCOMUXGUUSUX
      BUXKUXDUXMUEUUSFCAUVOUWCUWFVQUUSUVACBUWKUWCUWRVQVRUUSUXJUXLUUTUVBUUSFCUVO
      UWCVJUUSUVACUWKUWCVJUWGUWSVTUUSUXNCUVCOUUSFUVAUEMZCNMLCNMZUXNCUUSUXOLCNUU
      SFHIZLHIUXOLVMUVOVSFLWAWBZWCUUSFUVACUVOUWKUWCWDUULUXPCVMUUMUURCWEWJWFWCWG
      WHWKUUSDSIZUXFDQRDWIVMZUUSUXSJZUXFUXBPUGZUXDPUGZUEMZDUUSUXFSIZUXSUUSUXEUU
      SUXBUXDUUSFUXAUVOUUSCAUWCUWFWLZVJZUUSUVAUXCUWKUUSCBUWCUWRWLZVJZVLWMZTUUSU
      YDSIUXSUUSUYBUYCUUSUXBUYGWMZUUSUXDUYIWMZWNTUUSUXSWOZUUSUXFUYDUHRUXSUUSUXB
      UXDUYGUYIWPTUYAUYDDQRZFKUUSFKVMZUYNUXSUUSUYOJZUYDKUXCPUGZUEMZDQUYPUYBKUYC
      UYQUEUYPUXBUYOUUSUXBKUXANMKFKUXANWQUUSUXAUYFWRWTWSUYPUXDUXCPUYOUUSUXDLUXC
      NMUXCUYOUVALUXCNUYOUVALKOMLFKLOXALVSXBXCWCUUSUXCUYHXDWTWHVRUUSUYRDQRUYOUU
      SUYRUWMDQUUSUYRUYQUWMUUSUYQUUSUYQUUSUXCUYHWMZUOXEUUSUULUWLUWMUYQVMUWCUWRC
      BUVDUXIVOVPZWKUUSUWLUWNUWQXFZXGTXGXHUYAFKXIZJZUYDFDNMZUVADNMZUEMZDQVUCUYB
      VUDQRZUYCVUEUHRZUYDVUFQRZVUCUYBFUXAPUGZNMZVUDQUUSUYBVUKVMUXSVUBUUSUYBFPUG
      ZVUJNMVUKUUSFUXAUVOUYFXJUUSVULFVUJNUUSFUVNUUSUVJUVKUVLUVMXKZXLWCXMWJVUCVU
      JDQRZVUKVUDQRZUUSVUNUXSVUBUUSUVQVUJDQUUSUULUVPUVQVUJVMUWCUWFCAUVDUXIVOVPU
      USUVPUVRUWEXFXNZWJVUCVUJSIZUXSUVJKFQRZVUNVUOVIUUSVUQUXSVUBUUSUXAUYFWMZWJU
      USUXSVUBVBUUSUVJUXSVUBUVNWJUUSVUBVURUXSUUSVURVUBUUSKFKSIUUSUJUTUVNVUMXOXP
      XHVUJDFXSXQVEXGUYAVUHVUBUYAUYCUVAUYQNMZVUEUHUUSUYCVUTVMUXSUUSUYCUVAPUGZUY
      QNMVUTUUSUVAUXCUWKUYHXJUUSVVAUVAUYQNUUSFLUVNUWHUUSUKUTUUSUVJUVKUVLUVMXTZX
      RWCXMTUYAUYQSIZUXSUWIKUVAUHRZJZUYQDUHRZVUTVUEUHRUUSVVCUXSUYSTUYMUUSVVEUXS
      UUSUWIVVDUWJUUSVVDUVLVVBUUSUWHUVJVVDUVLVIUKUVNLFYAVHYBYCTUYAUYQDQRZVVFUUS
      VVGUXSUUSUWMUYQDQUYTVUAXNTUUSVVCUXSVVGVVFYDUYSUYQDYEYFYGUYQDUVAYHYKXGTUYA
      VUGVUHJVUIYDZVUBUYAUYBSIZUYCSIZVUDSIZVUESIZVVHUUSVVIUXSUYKTUUSVVJUXSUYLTU
      USUVJUXSVVKUVNFDYIYFUUSUWIUXSVVLUWJUVADYIYFUYBUYCVUDVUEYJYLTYMUYAVUFDVMVU
      BUYAUXODNMZLDNMZVUFDUUSVVMVVNVMUXSUUSUXOLDNUXRWCTUYAFUVADUUSUXQUXSUVOTUUS
      UVAHIUXSUWKTUYADUYMUOZWDUYADVVOXDWFTYNYOYPUUSUXTJZUXFWIDQVVPUYEUXFWIQRUUS
      UYEUXTUYJTUXFYQYRUUSUXTWOYSUUSUUMDUUJXIZJUXSUXTUUAUUSUUMVVQUWDUUSUUMKDUHR
      ZVVQUWDUUSKDQRZVVRUUSKVUJDKUAIZUUSYTUTUUSVUJVUSUUBUWDUUSUXAUYFUUCVUPUUDUU
      SVVTUUMVVSVVRYDYTUWDKDUUEVHYGDUUFVPYCDUUGUMUUHXGUUSUWAUULUUMUVFUVGUVIJVIU
      WBUWCUWDUVCUVDCDHVCVDUUIGUUK $.
  $}

  ${
    $d u v w x y z $.
    $( The standard topology on the reals is Hausdorff.  (Contributed by NM,
       8-Mar-2007.) $)
    rehaus $p |- ( topGen ` ran (,) ) e. Haus $=
      ( cabs cmin ccom cr cxp cres cxmt cfv wcel cioo crn ctg eqid rexmet cmopn
      cha tgioo methaus ax-mp ) ABCDDEFZDGHIJKLHZPITTMZNTUADTTOHZUBUCMQRS $.

    tgqioo.1 $e |- Q = ( topGen ` ( (,) " ( QQ X. QQ ) ) ) $.
    $( The topology generated by open intervals of reals with rational
       endpoints is the same as the open sets of the standard metric space on
       the reals.  In particular, this proves that the standard topology on the
       reals is second-countable.  (Contributed by Mario Carneiro,
       17-Jun-2014.) $)
    tgqioo $p |- ( topGen ` ran (,) ) = Q $=
      ( vx vy vz vw vu vv cioo cq wss cxr cv wcel ax-mp wa wrex clt wbr syl2anc
      cxp cima ctg cfv crn wceq imassrn wf wfn co wral cr cpw ffn simpll elioo1
      w3a biimpa simp1d simp2d qbtwnxr syl3anc simplr simp3d reeanv cop opelxpi
      ioof df-ov 3ad2ant2 wfun cdm wi ffun qssre ressxr sstri xpss12 mp2an fdmi
      sseqtr4i funfvima2 syl syl5eqel 3ad2ant1 simp3lr simp3rl wb simp2l sseldi
      simp2r mpbir3and cle simp3ll xrltle mpd iooss1 simp3rr iooss2 sstrd eleq2
      sseq1 anbi12d rspcev syl12anc 3exp rexlimdvv syl5bir mp2and ralrimiva ctb
      qtopbas eltg2b sylibr rgen2a ffnov mpbir2an frn 2basgen eqtr2i ) AIJJUAZU
      BZUCUDZIUEZUCUDZBYBYDKYDYCKZYCYEUFIYAUGLLUAZYCIUHZYFYHIYGUIZCMZDMZIUJZYCN
      ZDLUKCLUKYGULUMZIUHZYIVHYGYNIUNOYMCDLYJLNZYKLNZPZEMZFMZNZYTYLKZPZFYBQZEYL
      UKZYMYRUUDEYLYRYSYLNZPZYJGMZRSZUUHYSRSZPZGJQZYSHMZRSZUUMYKRSZPZHJQZUUDUUG
      YPYSLNZYJYSRSZUULYPYQUUFUOZUUGUURUUSYSYKRSZYRUUFUURUUSUVAUQYJYKYSUPURZUSZ
      UUGUURUUSUVAUVBUTGYJYSVAVBUUGUURYQUVAUUQUVCYPYQUUFVCZUUGUURUUSUVAUVBVDHYS
      YKVAVBUULUUQPUUKUUPPZHJQGJQUUGUUDUUKUUPGHJJVEUUGUVEUUDGHJJUUGUUHJNZUUMJNZ
      PZUVEUUDUUGUVHUVEUQZUUHUUMIUJZYBNYSUVJNZUVJYLKZUUDUVIUVJUUHUUMVFZIUDZYBUU
      HUUMIVIUVIUVMYANZUVNYBNZUVHUUGUVOUVEUUHUUMJJVGVJIVKZYAIVLZKUVOUVPVMYOUVQV
      HYGYNIVNOYAYGUVRJLKZUVSYAYGKJULLVOVPVQZUVTJLJLVRVSYGYNIVHVTWAYAUVMIWBVSWC
      WDUVIUVKUURUUJUUNUUGUVHUURUVEUVCWEUUIUUJUUPUUGUVHWFUUNUUOUUKUUGUVHWGUVIUU
      HLNZUUMLNZUVKUURUUJUUNUQWHUVIJLUUHUVTUUGUVFUVGUVEWIWJZUVIJLUUMUVTUUGUVFUV
      GUVEWKWJZUUHUUMYSUPTWLUVIUVJYJUUMIUJZYLUVIYPYJUUHWMSZUVJUWEKUUGUVHYPUVEUU
      TWEZUVIUUIUWFUUIUUJUUPUUGUVHWNUVIYPUWAUUIUWFVMUWGUWCYJUUHWOTWPYJUUHUUMWQT
      UVIYQUUMYKWMSZUWEYLKUUGUVHYQUVEUVDWEZUVIUUOUWHUUNUUOUUKUUGUVHWRUVIUWBYQUU
      OUWHVMUWDUWIUUMYKWOTWPYJUUMYKWSTWTUUCUVKUVLPFUVJYBYTUVJUFUUAUVKUUBUVLYTUV
      JYSXAYTUVJYLXBXCXDXEXFXGXHXIXJYBXKNYMUUEWHXLEFYLYBXKXMOXNXOCDLLYCIXPXQYGY
      CIXROYBYDXSVSXT $.
  $}

  $( The standard topology on the reals is second-countable.  (Contributed by
     Mario Carneiro, 21-Mar-2015.) $)
  re2ndc $p |- ( topGen ` ran (,) ) e. 2ndc $=
    ( cioo ctg cfv cq cxp c2ndc wcel com cdom wbr cen cdm cn qnnen mp2an nnenom
    entri wss cxr cr crn cima eqid tgqioo ctb qtopbas ccrd cres wfo con0 omelon
    xpen xpnnen entr2i isnumi wfun wf ioof ffun ax-mp qssre ressxr sstri xpss12
    cpw fdmi sseqtr4i fores fodomnum mp2 domentr 2ndci eqeltri ) AUABCADDEZUBZB
    CZFVPVPUCUDVOUEGVOHIJZVPFGUFVOVNIJZVNHKJVQVNUGLGZVNVOAVNUHZUIZVRHUJGHVNKJVS
    UKVNMHVNMMEZMDMKJZWCVNWBKJNNDMDMULOUMQZPUNHVNUOOAUPZVNALZRWASSEZTVEZAUQWEUR
    WGWHAUSUTVNWGWFDSRZWIVNWGRDTSVAVBVCZWJDSDSVDOWGWHAURVFVGVNAVHOVNVOVTVIVJVNM
    HWDPQVOVNHVKOVOVLOVM $.

  ${
    resubmet.1 $e |- R = ( topGen ` ran (,) ) $.
    resubmet.2 $e |- J = ( MetOpen ` ( ( abs o. - ) |` ( A X. A ) ) ) $.
    $( The subspace topology induced by a subset of the reals.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 13-Aug-2014.) $)
    resubmet $p |- ( A C_ RR -> J = ( R |`t A ) ) $=
      ( cr wss cabs cmin ccom cxp cres cmopn cfv crest wceq xpss12 anidms eqid
      co resabs1 syl fveq2d syl6reqr cxmt wcel cioo crn ctg tgioo eqtri metrest
      rexmet mpan eqtr4d ) AFGZCHIJZFFKZLZAAKZLZMNZBAOTZUPVBUQUTLZMNCUPVAVDMUPU
      TURGZVAVDPUPVEAFAFQRUQUTURUAUBUCEUDUSFUENUFUPVCVBPUSUSSZUMUSVABVBFAVASBUG
      UHUINUSMNZDUSVGVFVGSUJUKVBSULUNUO $.
  $}

  ${
    tgioo2.1 $e |- J = ( TopOpen ` CCfld ) $.
    $( The standard topology on the reals is a subspace of the complex metric
       topology.  (Contributed by Mario Carneiro, 13-Aug-2014.) $)
    tgioo2 $p |- ( topGen ` ran (,) ) = ( J |`t RR ) $=
      ( cabs cmin ccom cr cxp cres crest co eqid cxmt cfv wcel wss cmopn cnxmet
      cc wceq ax-resscn cnfldtopn metrest mp2an tgioo ) CDEZFFGHZAFIJZUFKZUERLM
      NFROUGUFPMZSQTUEUFAUIRFUHABUAUIKUBUCUD $.

    rerest.2 $e |- R = ( topGen ` ran (,) ) $.
    $( The subspace topology induced by a subset of the reals.  (Contributed by
       Mario Carneiro, 13-Aug-2014.) $)
    rerest $p |- ( A C_ RR -> ( J |`t A ) = ( R |`t A ) ) $=
      ( cr wss crest co cioo crn ctg cfv tgioo2 eqtri oveq1i ctop wcel cvv wceq
      cnfldtop reex restabs mp3an13 syl5req ) AFGZBAHICFHIZAHIZCAHIZBUGAHBJKLMU
      GECDNOPCQRUFFSRUHUITCDUAUBAFCQSUCUDUE $.
  $}

  ${
    tgioo3.1 $e |- J = ( TopOpen ` ( CCfld |`s RR ) ) $.
    $( The standard topology on the reals is a subspace of the complex metric
       topology.  (Contributed by Mario Carneiro, 13-Aug-2014.) $)
    tgioo3 $p |- ( topGen ` ran (,) ) = J $=
      ( ccnfld ctopn cfv cr crest co cress cioo crn ctg resstopn tgioo2 3eqtr4i
      eqid ) CDEZFGHCFIHZDEJKLEAFRQCRPQPZMQSNBO $.
  $}

  ${
    $d a b c u v x y $.
    xrtgioo.1 $e |- J = ( ( ordTop ` <_ ) |`t RR ) $.
    $( The topology on the extended reals coincides with the standard topology
       on the reals, when restricted to ` RR ` .  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    xrtgioo $p |- ( topGen ` ran (,) ) = J $=
      ( vx vy vv cioo cfv cr co wcel wss cxr wceq wa wb cpnf cmnf cvv clt wbr
      vu va vb vc crn ctg cle cordt crest cv ctop letop cxp wf wfn wral cpw ffn
      ioof ax-mp iooordt rgen2w ffnov mpbir2an mp2an tgtop sseqtri sseli ctopon
      frn tgss retopon toponss mpan reordt restopn2 sylanbrc cioc cmpt cico cun
      ssriv eqid leordtval oveq1i ctb eqeltrri tgclb mpbir reex tgrest retopbas
      eqtr4i cin wrex elrest elun vex elrnmpt w3a simpl pnfxr a1i adantl df-ioc
      rexr elixx3g baib syl3anc pnfge syl biantrud ltpnf 3bitr2d pm5.32da ancom
      wo bitri 3anass 3bitr4g elioo2 mpan2 bitr4d eqrdv ioorebas syl6eqel ineq1
      elin eleq1d syl5ibrcom sylbi mnfxr df-ico mnfle biantrurd mnflt jaoi cuni
      rexlimiv elssuni unirnioo syl6sseqr df-ss sylib id eqeltrd eleq1 eqsstri
      eqssi ) FUEZUFGZUGUHGZHUIIZAUUKUUMCUUKUUMCUJZUUKJZUUNUULJZUUNHKZUUNUUMJZU
      UKUULUUNUUKUULUFGZUULUULUKJZUUJUULKZUUKUUSKULLLUMZUULFUNZUVAUVCFUVBUOZUUN
      DUJZFIUULJZDLUPCLUPUVBHUQZFUNUVDUSUVBUVGFURUTUVFCDLLUUNUVEVAVBCDLLUULFVCV
      DUVBUULFVJUTUUJUULUKVKVEUUTUUSUULMULUULVFUTVGVHUUKHVIGJUUOUUQVLUUNUUKHVMV
      NUUTHUULJUURUUPUUQNOULVOHUUNUULVPVEVQWBUUMCLUUNPVRIZVSZUEZCLQUUNVTIZVSZUE
      ZWAZUUJWAZHUIIZUFGZUUKUUMUVOUFGZHUIIZUVQUULUVRHUICUVJUVMUUJUVJWCUVMWCUUJW
      CWDZWEUVOWFJZHRJZUVQUVSMUWAUVRUKJUULUVRUKUVTULWGUVOWHWIZWJHUVOWFRWKVEWMUU
      JWFJUVPUUJKUVQUUKKWLUAUVPUUJUAUJZUVPJZUWDEUJZHWNZMZEUVOWOZUWDUUJJZUWAUWBU
      WEUWIOUWCWJEUWDHUVOWFRWPVEUWHUWJEUVOUWFUVOJZUWJUWHUWGUUJJZUWKUWFUVNJZUWFU
      UJJZXQUWLUWFUVNUUJWQUWMUWLUWNUWMUWFUVJJZUWFUVMJZXQUWLUWFUVJUVMWQUWOUWLUWP
      UWOUWFUVHMZCLWOZUWLUWFRJZUWOUWROEWRZCLUVHUWFUVIRUVIWCWSUTUWQUWLCLUUNLJZUW
      LUWQUVHHWNZUUJJUXAUXBUUNPFIZUUJUXADUXBUXCUXAUVEUXBJZUVEHJZUUNUVESTZUVEPST
      ZWTZUVEUXCJZUXAUXEUVEUVHJZNZUXEUXFUXGNZNUXDUXHUXAUXEUXJUXLUXAUXENZUXJUXFU
      VEPUGTZNZUXFUXLUXMUXAPLJZUVELJZUXJUXOOUXAUXEXAZUXPUXMXBXCUXEUXQUXAUVEXFXD
      ZUXJUXAUXPUXQWTUXOUBUCUDUUNPUVESUGVRUBUCUDXEXGXHXIUXMUXNUXFUXMUXQUXNUXSUV
      EXJXKXLUXMUXGUXFUXEUXGUXAUVEXMXDXLXNXOUXDUXJUXENUXKUVEUVHHYHUXJUXEXPXRUXE
      UXFUXGXSXTUXAUXPUXIUXHOXBUUNPUVEYAYBYCYDUUNPYEYFUWQUWGUXBUUJUWFUVHHYGYIYJ
      YSYKUWPUWFUVKMZCLWOZUWLUWSUWPUYAOUWTCLUVKUWFUVLRUVLWCWSUTUXTUWLCLUXAUWLUX
      TUVKHWNZUUJJUXAUYBQUUNFIZUUJUXADUYBUYCUXAUVEUYBJZUXEQUVESTZUVEUUNSTZWTZUV
      EUYCJZUXAUXEUVEUVKJZNZUXEUYEUYFNZNUYDUYGUXAUXEUYIUYKUXMUYIQUVEUGTZUYFNZUY
      FUYKUXMQLJZUXAUXQUYIUYMOUYNUXMYLXCUXRUXSUYIUYNUXAUXQWTUYMUBUCUDQUUNUVEUGS
      VTUBUCUDYMXGXHXIUXMUYLUYFUXMUXQUYLUXSUVEYNXKYOUXMUYEUYFUXEUYEUXAUVEYPXDYO
      XNXOUYDUYIUXENUYJUVEUVKHYHUYIUXEXPXRUXEUYEUYFXSXTUYNUXAUYHUYGOYLQUUNUVEYA
      VNYCYDQUUNYEYFUXTUWGUYBUUJUWFUVKHYGYIYJYSYKYQYKUWNUWGUWFUUJUWNUWFHKUWGUWF
      MUWNUWFUUJYRHUWFUUJYTUUAUUBUWFHUUCUUDUWNUUEUUFYQYKUWDUWGUUJUUGYJYSYKWBUVP
      UUJWFVKVEUUHUUIBWM $.
  $}

  ${
    xrrest.1 $e |- X = ( ordTop ` <_ ) $.
    xrrest.2 $e |- R = ( topGen ` ran (,) ) $.
    $( The subspace topology induced by a subset of the reals.  (Contributed by
       Mario Carneiro, 9-Sep-2015.) $)
    xrrest $p |- ( A C_ RR -> ( X |`t A ) = ( R |`t A ) ) $=
      ( cr wss crest cioo crn ctg cfv cle cordt oveq1i xrtgioo eqtri cvv wcel
      co wceq fvex eqeltri reex restabs mp3an13 syl5req ) AFGZBAHTCFHTZAHTZCAHT
      ZBUIAHBIJKLUIEUICMNLZFHDOPQOCRSUHFRSUJUKUACULRDMNUBUCUDAFCRRUEUFUG $.
  $}

  ${
    xrrest2.1 $e |- J = ( TopOpen ` CCfld ) $.
    xrrest2.2 $e |- X = ( ordTop ` <_ ) $.
    $( The subspace topology induced by a subset of the reals.  (Contributed by
       Mario Carneiro, 9-Sep-2015.) $)
    xrrest2 $p |- ( A C_ RR -> ( J |`t A ) = ( X |`t A ) ) $=
      ( cr wss crest co cioo crn ctg cfv eqid rerest xrrest eqtr4d ) AFGBAHIJKL
      MZAHICAHIARBDRNZOARCESPQ $.
  $}

  ${
    $d r x y z D $.  $d x J $.  $d x P $.  $d x R $.
    xrsxmet.1 $e |- D = ( dist ` RR*s ) $.
    $( The metric on the extended reals is a proper extended metric.
       (Contributed by Mario Carneiro, 4-Sep-2015.) $)
    xrsxmet $p |- D e. ( *Met ` RR* ) $=
      ( vx vy cxr wcel wtru cle wbr cxad co wa cc0 wb cr recnd syl adantr caddc
      wceq vz cxmt cfv cvv xrex a1i cxp wf cv cxne cif id xnegcl xaddcl syl2anr
      wral sylan2 ifcl syl2anc rgen2a xrsds fmpt2 mpbi breq2 xsubge0 biimpar wn
      ancoms xrletri orcanai syldan ifbothda xrsdsval breqtrrd biantrud eqeltrd
      adantl weq 0xr xrletri3 sylancl simpr wne 0re syl6eqel xrsdsreclb adantlr
      simplr 3expa mpbid simpld simprd cmin rexsub eqeq1d biimpa xneg11 xnegneg
      xnegdi oveq2d simpl xaddcom 3eqtrd xneg0 bitr3d biidd eqeq1 bibi1d ifboth
      eqeq12d ad2antrr eqtr3d subeq0d pm2.61dane ex anidms xrleid iftrue xnegid
      oveq1 syl5ibrcom impbid 3bitr2d w3a simplrr oveq1d simpll1 oveq12 vtoclga
      leidd eqtrd simplrl simpll2 eqeq2 oveq12d 3brtr4d cabs syl3anc xrsdsreval
      wo addid2d eqtr2d 3brtr3d eqeltrrd oveq2 eqtr4d clt xrleloe neneqd syl6bb
      biorf orcom xrltnle con2bid iffalse 3eqtr4d addid1d simpll3 simprl simprr
      abs3difd abssubd pm2.61da2ne 3adant1 isxmet2d trud ) AEUBUCFGCDUAAEEUDFGU
      EUFEEUGEAUHZGCUIZDUIZHIZUVIUVHUJZJKZUVHUVIUJZJKZUKZEFZDEUPCEUPUVGUVPCDEUV
      HEFZUVIEFZLZUVLEFZUVNEFZUVPUVRUVRUVKEFZUVTUVQUVRULUVHUMZUVIUVKUNUOZUVRUVQ
      UVMEFZUWAUVIUMZUVHUVMUNUQUVJUVLUVNEURUSZUTCDEEUVOEACDABVAVBVCUFUVSMUVHUVI
      AKZHIZGUVSMUVOUWHHUVJMUVLHIZMUVNHIZMUVOHIUVSUVLUVNUVLUVOMHVDUVNUVOMHVDUVS
      UWJUVJUVRUVQUWJUVJNUVIUVHVEVHVFUVSUVJVGZUVIUVHHIZUWKUVSUVJUWMUVHUVIVIVJUV
      SUWKUWMUVHUVIVEVFVKVLUVHUVIABVMZVNZVQUVSUWHMHIZCDVRZNGUVSUWPUWPUWILZUWHMT
      ZUWQUVSUWIUWPUWOVOUVSUWHEFMEFZUWSUWRNUVSUWHUVOEUWNUWGVPVSUWHMVTWAUVSUWSUW
      QUVSUWSUWQUVSUWSLZUWQUVHUVIUXAUWQWBUXAUVHUVIWCZLZUVHUVIUXCUVHUXCUVHOFZUVI
      OFZUXCUWHOFZUXDUXELZUXCUWHMOUVSUWSUXBWHWDWEUVSUXBUXFUXGNZUWSUVQUVRUXBUXHU
      VHUVIABWFWIWGWJZWKPUXCUVIUXCUXDUXEUXIWLPUXCUVNUVHUVIWMKZMUXCUXGUVNUXJTUXI
      UVHUVIWNQUXCUVOMTZUVNMTZUXAUXKUXBUVSUWSUXKUVSUWHUVOMUWNWOWPRUXCUVLMTZUXLN
      ZUXLUXLNZUXKUXLNZUVSUXNUWSUXBUVSUVLUJZMUJZTZUXMUXLUVSUVTUWTUXSUXMNUWDVSUV
      LMWQWAUVSUXQUVNUXRMUVSUXQUVMUVKUJZJKZUVMUVHJKZUVNUVSUVRUWBUXQUYATUVQUVRWB
      UVQUWBUVRUWCRUVIUVKWSUSUVSUXTUVHUVMJUVQUXTUVHTUVRUVHWRRWTUVSUWEUVQUYBUVNT
      UVRUWEUVQUWFVQUVQUVRXAUVMUVHXBUSXCUXRMTUVSXDUFXJXEXKUXCUXLXFUVJUXNUXOUXPU
      VLUVNUVLUVOTUXMUXKUXLUVLUVOMXGXHUVNUVOTUXLUXKUXLUVNUVOMXGXHXIUSWJXLXMXNXO
      UVSUWSUWQUVIUVIAKZMTZUVRUYDUVQUVRUYCUVIUVIHIZUVIUVMJKZUYFUKZUYFMUVRUYCUYG
      TUVIUVIABVMXPUVRUYEUYGUYFTUVIXQUYEUYFUYFXRQUVIXSXCZVQUWQUWHUYCMUVHUVIUVIA
      XTZWOYAYBYCVQUVQUVRUAUIZEFZYDZUYJUVHAKZOFZUYJUVIAKZOFZLZUWHUYMUYOSKZHIZGU
      YLUYQLZUYSUYJUVHUYJUVIUYTUACVRZLZUYOUYOUWHUYRHVUBUYOUYLUYNUYPVUAYEZYJVUBU
      YJUVHUVIAUYTVUAWBZYFVUBUYRMUYOSKUYOVUBUYMMUYOSVUBUYMUVHUVHAKZMVUBUYJUVHUV
      HAVUDYFVUBUVQVUEMTZUVQUVRUYKUYQVUAYGUYDVUFDUVHEDCVRZUYCVUEMVUGUYCVUETUVIU
      VHUVIUVHAYHXPWOUYHYIQYKYFVUBUYOVUBUYOVUCPUUAUUBUUCUYTUADVRZLZUVIUVHAKZVUJ
      UWHUYRHVUIVUJVUIUYMVUJOVUIUYJUVIUVHAUYTVUHWBZYFZUYLUYNUYPVUHYLUUDZYJVUIUV
      QUVRUWHVUJTZUVQUVRUYKUYQVUHYGUVQUVRUYKUYQVUHYMZUVSVUNUVHUVIUWQVUNUVSUWQUW
      HUYCVUJUYIUVHUVIUVIAUUEUUFVQUVSUXBLZUVOUWMUVNUVLUKZUWHVUJUWMUVOUVNTZUVOUV
      LTZUVOVUQTVUPUVNUVLUVNVUQUVOYNUVLVUQUVOYNVUPUWMLUWLVURVUPUWMUWLVUPUVJUWMV
      UPUVJUVHUVIUUGIZUWQYTZVUTUWMVGZUVSUVJVVANUXBUVHUVIUUHRVUPUWQVGZVUTVVANVUP
      UVHUVIUVSUXBWBUUIVVCVUTUWQVUTYTVVAUWQVUTUUKUWQVUTUULUUJQUVSVUTVVBNUXBUVHU
      VIUUMRYCZUUNWPUVJUVLUVNUUOQVUPVVBLUVJVUSVUPUVJVVBVVDVFUVJUVLUVNXRQVLUVSUW
      HUVOTUXBUWNRUVSVUJVUQTZUXBUVRUVQVVEUVIUVHABVMVHRUUPXNUSVUIUYRVUJMSKVUJVUI
      UYMVUJUYOMSVULVUIUYOUYCMVUIUYJUVIUVIAVUKYFVUIUVRUYDVUOUYHQYKYOVUIVUJVUIVU
      JVUMPUUQYKYPUYTUYJUVHWCZUYJUVIWCZLZLZUXJYQUCZUVHUYJWMKYQUCZUYJUVIWMKYQUCZ
      SKUWHUYRHVVIUVHUVIUYJVVIUVHVVIUYJOFZUXDVVIUYNVVMUXDLZUYLUYNUYPVVHYLVVIUYK
      UVQVVFUYNVVNNUVQUVRUYKUYQVVHUURZUVQUVRUYKUYQVVHYGUYTVVFVVGUUSUYJUVHABWFYR
      WJZWLZPZVVIUVIVVIVVMUXEVVIUYPVVMUXELZUYLUYNUYPVVHYEVVIUYKUVRVVGUYPVVSNVVO
      UVQUVRUYKUYQVVHYMUYTVVFVVGUUTUYJUVIABWFYRWJZWLZPVVIUYJVVIVVMUXDVVPWKPZUVA
      VVIUXDUXEUWHVVJTVVQVWAUVHUVIABYSUSVVIUYMVVKUYOVVLSVVIUYMUYJUVHWMKYQUCZVVK
      VVIVVNUYMVWCTVVPUYJUVHABYSQVVIUYJUVHVWBVVRUVBYKVVIVVSUYOVVLTVVTUYJUVIABYS
      QYOYPUVCUVDUVEUVF $.

    $( The metric on the extended reals coincides with the usual metric on the
       reals.  (Contributed by Mario Carneiro, 4-Sep-2015.) $)
    xrsdsre $p |- ( D |` ( RR X. RR ) ) = ( ( abs o. - ) |` ( RR X. RR ) ) $=
      ( vx vy cr cxp cres cabs cmin wceq cv co wral wcel cfv wfn cxr wss mp2an
      cc ccom wa xrsdsreval ovres eqid remetdval 3eqtr4d rgen2a wb cxmt xrsxmet
      wf xmetf ffn mp2b ressxr xpss12 fnssres cme cnmet ax-resscn eqfnov2 mpbir
      metf ) AEEFZGZHIUAZVEGZJZCKZDKZVFLZVJVKVHLZJZDEMCEMZVNCDEVJENVKENUBVJVKAL
      VJVKILHOVLVMVJVKABUCVJVKEEAUDVJVKVHVHUEUFUGUHVFVEPZVHVEPZVIVOUIAQQFZPZVEV
      RRZVPAQUJONVRQAULVSABUKAQUMVRQAUNUOEQRZWAVTUPUPEQEQUQSVRVEAURSVGTTFZPZVEW
      BRZVQVGTUSONWBEVGULWCUTVGTVDWBEVGUNUOETRZWEWDVAVAETETUQSWBVEVGURSCDEEVFVH
      VBSVC $.

    $( Any ball of the metric of the extended reals centered on an element of
       ` RR ` is entirely contained in ` RR ` .  (Contributed by Mario
       Carneiro, 4-Sep-2015.) $)
    xrsblre $p |- ( ( P e. RR /\ R e. RR* ) -> ( P ( ball ` D ) R ) C_ RR ) $=
      ( vx cr wcel cxr wa cbl cfv co ccnv cima cec wss rexr cvv wb simpr blssec
      cxmt xrsxmet eqid mp3an1 sylan cv wbr simpl elecg sylancr xmeterval ax-mp
      vex w3a simplll eqeltrrd simplr3 simplr1 simplr2 xrsdsreclb syl3anc mpbid
      wceq wne simprd pm2.61dane ex syl5bi sylbid ssrdv sstrd ) BFGZCHGZIZBCAJK
      LZBAMFNZOZFVMBHGZVNVPVRPZBQAHUBKGZVSVNVTADUCZABVQCHVQUDZUAUEUFVOEVRFVOEUG
      ZVRGZBWDVQUHZWDFGZVOWDRGVMWEWFSEUNVMVNUIWDBVQRFUJUKWFVSWDHGZBWDALFGZUOZVO
      WGWAWFWJSWBBWDAVQHWCULUMVOWJWGVOWJIZWGBWDWKBWDVDZIBWDFWKWLTVMVNWJWLUPUQWK
      BWDVEZIZVMWGWNWIVMWGIZVSWHWIVOWMURWNVSWHWMWIWOSVSWHWIVOWMUSVSWHWIVOWMUTWK
      WMTBWDADVAVBVCVFVGVHVIVJVKVL $.

    xrsmopn.1 $e |- J = ( MetOpen ` D ) $.
    $( The metric on the extended reals generates a topology, but this does not
       match the order topology on ` RR* ` ; for example ` { +oo } ` is open in
       the metric topology, but not the order topology.  However, the metric
       topology is finer than the order topology, meaning that all open
       intervals are open in the metric topology.  (Contributed by Mario
       Carneiro, 4-Sep-2015.) $)
    xrsmopn $p |- ( ordTop ` <_ ) C_ J $=
      ( vx vy vr vz cfv wcel cxr wss co crp wa cr a1i syl3anc wceq c1 cle cordt
      cbl wrex wral cuni elssuni letopuni syl6sseqr wel cabs cmin ccom cxp cres
      cv cin cxmt crest eqid rexmet ctop cvv reex elrestr mp3an12 ad2antrr elin
      letop biimpri adantll cioo crn cmopn xrtgioo eqtr3i mopni2 xrsxmet simplr
      ctg tgioo ressxr dfss1 mpbi syl6eleqr adantl xrsdsre eqcomi blres xrsblre
      rpxr sylan2 df-ss sylib eqtrd sseq1d inss1 sstr mpan2 syl6bi reximdva mpd
      wn 1rp clt wbr sselda adantr mp1i elbl w3a simp2 wne cc0 3ad2ant1 simpl3l
      wb xmetcl 1re xmetge0 simpl3r ax-mp xrltle sylancl xrrege0 syl22anc simpr
      wi xrsdsreclb mpbid simpld necon1bd simp1r elequ1 syl5ibcom 3expia sylbid
      ex syld ssrdv oveq2 rspcev sylancr pm2.61dan ralrimiva elmopn2 sylanbrc
      ssriv ) EUAUBIZBEUPZUUIJZUUJKLZFUPZGUPZAUCIZMZUUJLZGNUDZFUUJUEZUUJBJZUUKU
      UJUUIUFKUUJUUIUGUHUIZUUKUURFUUJUUKFEUJZOZUUMPJZUURUVCUVDOZUUMUUNUKULUMPPU
      NZUOZUCIMZUUJPUQZLZGNUDZUURUVEUVGPURIJZUVIUUIPUSMZJZUUMUVIJZUVKUVLUVEUVGU
      VGUTZVAQUUKUVNUVBUVDUUIVBJPVCJUUKUVNVIVDUUJPUUIVBVCVEVFVGUVBUVDUVOUUKUVOU
      VBUVDOUUMUUJPVHVJVKGUVIUVGUUMUVMPVLVMVTIUVMUVGVNIZUVMUVMUTVOUVGUVQUVPUVQU
      TWAVPVQRUVEUVJUUQGNUVEUUNNJZOZUVJUUPUVILZUUQUVSUVHUUPUVIUVSUVHUUPPUQZUUPU
      VSAKURIJZUUMKPUQZJUUNKJZUVHUWASUWBUVSACVRZQUVSUUMPUWCUVCUVDUVRVSPKLUWCPSW
      BPKWCWDWEUVRUWDUVEUUNWKZWFUVGAUUMUUNKPAUVFUOUVGACWGWHWIRUVSUUPPLZUWAUUPSU
      VDUVRUWGUVCUVRUVDUWDUWGUWFAUUMUUNCWJWLVKUUPPWMWNWOWPUVTUVIUUJLUUQUUJPWQUU
      PUVIUUJWRWSWTXAXBUVCUVDXCZOZTNJZUUMTUUOMZUUJLZUURXDUWIHUWKUUJUWIHUPZUWKJZ
      UWMKJZUUMUWMAMZTXEXFZOZHEUJZUWIUWBUUMKJZTKJZUWNUWRXQUWBUWIUWEQUVCUWTUWHUU
      KUUJKUUMUVAXGZXHUWJUXAUWIXDTWKZXIUWMAUUMTKXJRUVCUWHUWRUWSUVCUWHUWRXKZUWHU
      WSUVCUWHUWRXLUXDUWHUUMUWMSZUWSUXDUVDUUMUWMUXDUUMUWMXMZUVDUXDUXFOZUVDUWMPJ
      ZUXGUWPPJZUVDUXHOZUXGUWPKJZTPJZXNUWPUAXFZUWPTUAXFZUXIUXGUWBUWTUWOUXKUWBUX
      GUWEQZUXDUWTUXFUVCUWHUWTUWRUXBXOXHZUWOUWQUVCUWHUXFXPZUUMUWMAKXRRZUXLUXGXS
      QUXGUWBUWTUWOUXMUXOUXPUXQUUMUWMAKXTRUXGUWQUXNUWOUWQUVCUWHUXFYAUXGUXKUXAUW
      QUXNYHUXRUWJUXAXDUXCYBUWPTYCYDXBUWPTYEYFUXGUWTUWOUXFUXIUXJXQUXPUXQUXDUXFY
      GUUMUWMACYIRYJYKYRYLUXDUVBUXEUWSUUKUVBUWHUWRYMFHEYNYOYSXBYPYQYTUUQUWLGTNU
      UNTSUUPUWKUUJUUNTUUMUUOUUAWPUUBUUCUUDUUEUWBUUTUULUUSOXQUWEFGUUJABKDUUFYBU
      UGUUH $.
  $}

  ${
    $d x y J $.
    zcld.1 $e |- J = ( topGen ` ran (,) ) $.
    $( The integers are a closed set in the topology on ` RR ` .  (Contributed
       by Mario Carneiro, 17-Feb-2015.) $)
    zcld $p |- ZZ e. ( Clsd ` J ) $=
      ( vx vy cz cfv wcel cr cv c1 caddc co cioo wa clt wbr wne syl syl2anc cxr
      ccld cdif ciun wrex eliun elioore adantl wn eliooord btwnnz sylan2 eldifd
      3expb rexlimiva cfl eldifi flcld flle eldifn nelne2 necomd zred mpbir2and
      cle ltlend flltp1 w3a wb rexrd peano2re elioo2 mpbir3and id oveq1 oveq12d
      wceq eleq2d rspcev impbii bitri eqriv ctop crn ctg retop eqeltri iooretop
      wral eleqtrri rgenw iunopn mp2an eqeltrri wss cuni uniretop unieqi eqtr4i
      zssre iscld2 mpbir ) EAUAFGZHEUBZAGZCECIZXEJKLZMLZUCZXCADXHXCDIZXHGXIXGGZ
      CEUDZXIXCGZCXIEXGUEXKXLXJXLCEXEEGZXJNXIHEXJXIHGZXMXIXEXFUFUGXJXMXEXIOPZXI
      XFOPZNXIEGUHZXIXEXFUIXMXOXPXQXEXIUJUMUKULUNXLXIUOFZEGZXIXRXRJKLZMLZGZXKXL
      XIXIHEUPZUQZXLYBXNXRXIOPZXIXTOPZYCXLYEXRXIVDPZXIXRQXLXNYGYCXIURRXLXRXIXLX
      SXQXRXIQYDXIHEUSXRXIEUTSVAXLXRXIXLXRYDVBZYCVEVCXLXNYFYCXIVFRXLXRTGXTTGYBX
      NYEYFVGVHXLXRYHVIXLXTXLXRHGXTHGYHXRVJRVIXRXTXIVKSVLXJYBCXREXEXRVPZXGYAXIY
      IXEXRXFXTMYIVMXEXRJKVNVOVQVRSVSVTWAAWBGZXGAGZCEWHXHAGAMWCWDFZWBBWEWFZYKCE
      XGYLAXEXFWGBWIWJCEXGAWKWLWMYJEHWNXBXDVHYMWSEAHHYLWOAWOWPAYLBWQWRWTWLXA $.
  $}

  ${
    $d n r u x y z J $.  $d n r u v S $.
    recld2.1 $e |- J = ( TopOpen ` CCfld ) $.
    $( The real numbers are a closed set in the topology on ` CC ` .
       (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    recld2 $p |- RR e. ( Clsd ` J ) $=
      ( vx vy cr cfv wcel cc wss cabs cmin co crp cim wn cc0 wceq wb wbr wa cbl
      ccld cdif ccom wrex difss eldifi imcld recnd wne eldifn reim0b necon3bbid
      wral syl mpbid absrpcld clt cxmt cxr cnxmet a1i abscld rexrd elbl syl3anc
      cv simprl wi adantr simpr imsubd reim0 adantl oveq2d 3eqtrd fveq2d subcld
      cle subid1d absimle eqbrtrrd lenltd cnmetdval syl2anc breq1d mtbird con2d
      eqid ex impr eldifd sylbid ssrdv oveq2 sseq1d rspcev rgen cnfldtopn ax-mp
      elmopn2 mpbir2an ctop cnfldtop ax-resscn cuni mopnuni iscld2 mp2an mpbir
      ) EAUBFGZHEUCZAGZXMXLHIZCVGZDVGZJKUDZUAFZLZXLIZDMUEZCXLUNZHEUFYACXLXOXLGZ
      XONFZJFZMGXOYEXRLZXLIZYAYCYDYCYDYCXOXOHEUGZUHUIZYCXOEGZOYDPUJXOHEUKYCYJYD
      PYCXOHGZYJYDPQRYHXOULUOUMUPUQYCDYFXLYCXPYFGZXPHGZXOXPXQLZYEURSZTZXPXLGZYC
      XQHUSFGZYKYEUTGYLYPRYRYCVAVBYHYCYEYCYDYIVCVDXPXQXOYEHVEVFYCYPYQYCYPTXPHEY
      CYMYOVHYCYMYOXPEGZOZYCYOYTVIYMYCYSYOYCYSYOOYCYSTZYOXOXPKLZJFZYEURSZUUAYEU
      UCVSSUUDOUUAUUBNFZJFZYEUUCVSUUAUUEYDJUUAUUEYDXPNFZKLYDPKLYDUUAXOXPYCYKYSY
      HVJZUUAXPYCYSVKUIZVLUUAUUGPYDKYSUUGPQYCXPVMVNVOUUAYDYCYDHGYSYIVJZVTVPVQUU
      AUUBHGUUFUUCVSSUUAXOXPUUHUUIVRZUUBWAUOWBUUAYEUUCUUAYDUUJVCUUAUUBUUKVCWCUP
      UUAYNUUCYEURUUAYKYMYNUUCQUUHUUIXOXPXQXQWIWDWEWFWGWJWHVJWKWLWJWMWNXTYGDYEM
      XPYEQXSYFXLXPYEXOXRWOWPWQWEWRYRXMXNYBTRVACDXLXQAHABWSZXAWTXBAXCGEHIXKXMRA
      BXDXEEAHYRHAXFQVAXQAHUULXGWTXHXIXJ $.

    $( The integers are a closed set in the topology on ` CC ` .  (Contributed
       by Mario Carneiro, 17-Feb-2015.) $)
    zcld2 $p |- ZZ e. ( Clsd ` J ) $=
      ( cr ccld cfv wcel cz crest co recld2 cioo crn ctg tgioo2 eqcomi restcldr
      zcld mp2an ) CADEZFGACHIZDEFGSFABJTKLMETABNOQCGAPR $.

    $( The integers are a discrete set in the topology on ` CC ` .
       (Contributed by Mario Carneiro, 19-Sep-2015.) $)
    zdis $p |- ( J |`t ZZ ) = ~P ZZ $=
      ( vx vy vz cz co cv wcel wa c1 cfv cc zcnd cnxmet ctop cvv clt wceq wb ex
      crest cpw restsspw wss wrex wral cabs cmin ccom cbl cin elpwi sselda cxmt
      cxr crp 1rp ax-mp cnfldtopn blopn mp3an13 cnfldtop elrestr mp3an12 blcntr
      rpxr zex 3syl syl elin sylanbrc adantr inss2 simpr sseldi zsubcld wbr cc0
      eqid cnmetdval syl2anc inss1 elbl2 mpanl12 eqbrtrrd cn0 nn0abscl nn0lt10b
      mpbid abs00d subeq0d simplr eqeltrrd ssrdv eleq2 anbi12d rspcev ralrimiva
      sseq1 syl12anc resttop mp2an eltop2 sylibr ssriv eqssi ) AFUBGZFUCZFAUDCX
      IXHCHZXIIZDHZEHZIZXMXJUEZJZEXHUFZDXJUGZXJXHIZXKXQDXJXKXLXJIZJZXLKUHUIUJZU
      KLGZFULZXHIZXLYDIZYDXJUEZXQYAXLMIZYCAIZYEYAXLXKXJFXLXJFUMUNZNZYBMUOLIZYHK
      UPIZYIOKUQIZYMURKVGUSZYBXLKAMABUTVAVBAPIZFQIZYIYEABVCZVHYCFAPQVDVEVIYAXLY
      CIZXLFIZYFYAYHYSYKYLYHYNYSOURYBXLKMVFVBVJYJXLYCFVKVLYAEYDXJYAXMYDIZXMXJIY
      AUUAJZXLXMXJUUBXLXMYAYHUUAYKVMZUUBXMUUBYDFXMYCFVNYAUUAVOZVPZNZUUBXLXMUIGZ
      UUBUUGUUBXLXMYAYTUUAYJVMUUEVQZNUUBUUGUHLZKRVRZUUIVSSZUUBXLXMYBGZUUIKRUUBY
      HXMMIZUULUUISUUCUUFXLXMYBYBVTWAWBUUBXMYCIZUULKRVRZUUBYDYCXMYCFWCUUDVPUUBY
      HUUMUUNUUOTZUUCUUFYLYMYHUUMJUUPOYOXMYBXLKMWDWEWBWJWFUUBUUGFIUUIWGIUUJUUKT
      UUHUUGWHUUIWIVIWJWKWLXKXTUUAWMWNUAWOXPYFYGJEYDXHXMYDSXNYFXOYGXMYDXLWPXMYD
      XJWTWQWRXAWSXHPIZXSXRTYPYQUUQYRVHFAQXBXCDEXJXHXDUSXEXFXG $.

    $( Every subset of the integers are closed in the topology on ` CC ` .
       (Contributed by Mario Carneiro, 6-Jul-2017.) $)
    sszcld $p |- ( A C_ ZZ -> A e. ( Clsd ` J ) ) $=
      ( cz wss ccld cfv wcel crest co zcld2 id cpw difss zex elpw2 mpbir ctopon
      cdif cc zdis eleqtrri a1i ctop wa wb cnfldtopon zsscn resttopon topontopi
      mp2an toponunii iscld ax-mp sylanbrc restcldr sylancr ) ADEZDBFGZHABDIJZF
      GHZAUSHBCKURURDASZUTHZVAURLVCURVBDMZUTVBVDHVBDEDANVBDOPQBCUAUBUCUTUDHVAUR
      VCUEUFDUTBTRGHDTEUTDRGHBCUGUHDBTUIUKZUJAUTDDUTVEULUMUNUODABUPUQ $.

    ${
      reperflem.2 $e |- ( ( u e. S /\ v e. RR ) -> ( u + v ) e. S ) $.
      reperflem.3 $e |- S C_ CC $.
      $( A subset of the real numbers that is closed under addition with real
         numbers is perfect.  (Contributed by Mario Carneiro, 26-Dec-2016.) $)
      reperflem $p |- ( J |`t S ) e. Perf $=
        ( vn vr co wcel cfv wss cv wne cc cabs crp wb cr crest clp csn cdif cin
        cperf c0 cnei wral cmin ccom cbl wrex cxmt cnxmet sseli cnfldtopn neibl
        wa sylancr c2 cdiv caddc clt wceq ralrimiva rpre rehalfcld oveq2 eleq1d
        wbr rspccva syl2an sseldi adantr eqid cnmetdval syl2anc simpr rphalfcld
        rpcnd pncan2d fveq2d rpred rpge0d absidd 3eqtrd rphalflt adantl eqbrtrd
        cxr a1i rpxr elbl3 syl22anc mpbird cc0 rpne0d eqnetrd subne0ad sylanbrc
        eldifsn inelcm ssrin ssn0 syl syl5com rexlimdva adantld sylbid ralrimiv
        wi ex ctop cnfldtop cnfldtopon islp2 mp3an12 ssriv restperf mp2an mpbir
        toponunii ) DCUAJZUFKZCCDUBLLZMZBCYFBNZCKZYHYFKZHNZCYHUCZUDZUEZUGOZHYLD
        UHLLZUIZYIYOHYPYIYKYPKZYKPMZYHINZQUJUKZULLJZYKMZIRUMZUSZYOYIUUAPUNLKZYH
        PKZYRUUESUOCPYHGUPZUUAYHDYKPIDEUQURUTYIUUDYOYSYIUUCYOIRYIYTRKZUSZUUBYMU
        EZUGOZUUCYOUUJYHYTVAVBJZVCJZUUBKZUUNYMKZUULUUJUUOUUNYHUUAJZYTVDVKZUUJUU
        QUUMYTVDUUJUUQUUNYHUJJZQLZUUMQLUUMUUJUUNPKZUUGUUQUUTVEUUJCPUUNGYIYHANZV
        CJZCKZATUIUUMTKUUNCKZUUIYIUVDATFVFUUIYTYTVGVHUVDUVEAUUMTUVBUUMVEUVCUUNC
        UVBUUMYHVCVIVJVLVMZVNZYIUUGUUIUUHVOZUUNYHUUAUUAVPVQVRUUJUUSUUMQUUJYHUUM
        UVHUUJUUMUUJYTYIUUIVSVTZWAWBZWCUUJUUMUUJUUMUVIWDUUJUUMUVIWEWFWGUUIUUMYT
        VDVKYIYTWHWIWJUUJUUFYTWKKZUUGUVAUUOUURSUUFUUJUOWLUUIUVKYIYTWMWIUVHUVGUU
        NUUAYHYTPWNWOWPUUJUVEUUNYHOUUPUVFUUJUUNYHUVGUVHUUJUUSUUMWQUVJUUJUUMUVIW
        RWSWTUUNCYHXBXAUUNUUBYMXCVRUUCUUKYNMZUULYOXLUUBYKYMXDUVLUULYOUUKYNXEXMX
        FXGXHXIXJXKYIUUGYJYQSZUUHDXNKZCPMZUUGUVMDEXOZGYHCHDPPDDEXPYCZXQXRXFWPXS
        UVNUVOYEYGSUVPGDYDPCUVQYDVPXTYAYB $.
    $}

    $( The real numbers are a perfect subset of the complex numbers.
       (Contributed by Mario Carneiro, 26-Dec-2016.) $)
    reperf $p |- ( J |`t RR ) e. Perf $=
      ( vy vx cr cv readdcl ax-resscn reperflem ) CDEABDFCFGHI $.

    $( The complex numbers are a perfect space.  (Contributed by Mario
       Carneiro, 26-Dec-2016.) $)
    cnperf $p |- J e. Perf $=
      ( vy vx cc crest co cperf ctopon cfv wcel wceq cnfldtopon toponunii ax-mp
      restid cv cr caddc recn addcl sylan2 ssid reperflem eqeltrri ) AEFGZAHAEI
      JZKUFALABMZAUGEEAUHNPOCDEABCQZRKDQZEKUIEKUJUISGEKUITUJUIUAUBEUCUDUE $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The interior of a closed interval in the standard topology on ` RR ` is
       the corresponding open interval.  (Contributed by Mario Carneiro,
       1-Sep-2014.) $)
    iccntr $p |- ( ( A e. RR /\ B e. RR ) ->
      ( ( int ` ( topGen ` ran (,) ) ) ` ( A [,] B ) ) = ( A (,) B ) ) $=
      ( vx cr wcel wa co cfv wss clt wbr c0 wceq cxr cle w3a wn ad2antrr adantl
      crp cicc cioo crn ctg cnt cpr cun wb rexr icc0 syl2an biimpar fveq2d ctop
      retop ntr0 ax-mp eqsstri syl6eqss iccssre uniretop ntrss2 sylancr anim12i
      adantr uncom prunioo syl5eq 3expa sylan sseqtr4d simpr simpl ltlecasei cv
      0ss cin wral cabs cmin ccom cres wrex ntropn cxmt eqid rexmet cmopn tgioo
      cxp cbl mopni2 mp3an1 rphalfcl ltsubrpd rpred resubcld ltnled mpbid caddc
      cdiv rpre rphalflt ltsub2dd readdcld ltaddrp sylancom lttrd rexrd syl2anc
      c2 elioo2 mpbir3and bl2ioo eleqtrrd ssel syl5com sseld elicc2 simp2 3syld
      syl6bi mtod nrexdv pm2.65da ltaddrpd ltsubrp ltadd2dd simp3 notbid ralprg
      wi eleq1 mpbir2and disjr sylibr disjssun syl iooretop ioossicc mpanr12
      ssntr eqssd ) ADEZBDEZFZABUAGZUBUCUDHZUEHZHZABUBGZUUFUUJABUFZUUKUGZIZUUJU
      UKIZUUFUUNBAUUFBAJKZFZUUJLUUIHZUUMUUQUUGLUUIUUFUUGLMZUUPUUDANEZBNEZUUSUUP
      UHUUEAUIZBUIZABUJUKULUMUURLUUMUUHUNEZUURLMUOUUHUPUQUUMVPURUSUUFABOKZFUUJU
      UGUUMUUFUUJUUGIZUVEUUFUVDUUGDIZUVFUOABUTZUUGUUHDVAVBVCZVEUUFUUTUVAFUVEUUM
      UUGMZUUDUUTUUEUVAUVBUVCVDUUTUVAUVEUVJUUTUVAUVEPUUMUUKUULUGUUGUULUUKVFABVG
      VHVIVJVKUUDUUEVLZUUDUUEVMZVNUUFUUJUULVQLMZUUNUUOUHUUFCVOZUUJEZQZCUULVRZUV
      MUUFUVQAUUJEZQZBUUJEZQZUUFUVRAUVNVSVTWADDWJWBZWKHZGZUUJIZCTWCZUUFUUJUUHEZ
      UVRUWFUUFUVDUVGUWGUOUVHUUGUUHDVAWDVCZUWBDWEHEZUWGUVRUWFUWBUWBWFZWGZCUUJUW
      BAUUHDUWBUWBWHHZUWJUWLWFWIZWLWMVJUUFUVRFZUWECTUWNUVNTEZFZUWEAAUVNXKXAGZVT
      GZOKZUWPUWRAJKUWSQUWPAUWQUUFUUDUVRUWOUVLRZUWOUWQTEZUWNUVNWNZSZWOZUWPUWRAU
      WPAUWQUWTUWPUWQUXCWPZWQZUWTWRWSUWPUWEUWRUUJEZUWRUUGEZUWSUWPUWRUWDEUWEUXGU
      WPUWRAUVNVTGZAUVNWTGZUBGZUWDUWPUWRUXKEZUWRDEZUXIUWRJKZUWRUXJJKZUXFUWPUWQU
      VNAUXEUWOUVNDEZUWNUVNXBZSZUWTUWOUWQUVNJKZUWNUVNXCZSXDUWPUWRAUXJUXFUWTUWPA
      UVNUWTUXRXEZUXDUWNUWOUUDAUXJJKUWTAUVNXFXGXHUWPUXINEUXJNEUXLUXMUXNUXOPUHUW
      PUXIUWPAUVNUWTUXRWQXIUWPUXJUYAXIUXIUXJUWRXLXJXMUWPUUDUXPUWDUXKMUWTUXRAUVN
      UWBUWJXNXJXOUWDUUJUWRXPXQUWPUUJUUGUWRUUFUVFUVRUWOUVIRXRUUFUXHUWSYLUVRUWOU
      UFUXHUXMUWSUWRBOKZPUWSABUWRXSUXMUWSUYBXTYBRYAYCYDYEUUFUVTBUVNUWCGZUUJIZCT
      WCZUUFUWGUVTUYEUWHUWIUWGUVTUYEUWKCUUJUWBBUUHDUWMWLWMVJUUFUVTFZUYDCTUYFUWO
      FZUYDBUWQWTGZBOKZUYGBUYHJKUYIQUYGBUWQUUFUUEUVTUWOUVKRZUWOUXAUYFUXBSZYFZUY
      GBUYHUYJUYGBUWQUYJUYGUWQUYKWPZXEZWRWSUYGUYDUYHUUJEZUYHUUGEZUYIUYGUYHUYCEU
      YDUYOUYGUYHBUVNVTGZBUVNWTGZUBGZUYCUYGUYHUYSEZUYHDEZUYQUYHJKZUYHUYRJKZUYNU
      YGUYQBUYHUYGBUVNUYJUWOUXPUYFUXQSZWQZUYJUYNUYFUWOUUEUYQBJKUYJBUVNYGXGUYLXH
      UYGUWQUVNBUYMVUDUYJUWOUXSUYFUXTSYHUYGUYQNEUYRNEUYTVUAVUBVUCPUHUYGUYQVUEXI
      UYGUYRUYGBUVNUYJVUDXEXIUYQUYRUYHXLXJXMUYGUUEUXPUYCUYSMUYJVUDBUVNUWBUWJXNX
      JXOUYCUUJUYHXPXQUYGUUJUUGUYHUUFUVFUVTUWOUVIRXRUUFUYPUYIYLUVTUWOUUFUYPVUAA
      UYHOKZUYIPUYIABUYHXSVUAVUFUYIYIYBRYAYCYDYEUVPUVSUWACABDDUVNAMUVOUVRUVNAUU
      JYMYJUVNBMUVOUVTUVNBUUJYMYJYKYNCUUJUULYOYPUUJUULUUKYQYRWSUUFUVDUVGUUKUUJI
      ZUOUVHUVDUVGFUUKUUHEUUKUUGIVUGABYSABYTUUGUUHUUKDVAUUBUUAVCUUC $.
  $}

  ${
    $d n t u v w x y z B $.  $d t v w C $.  $d t u v w y ph $.  $d t v w y R $.
    $d t u v w x y z A $.  $d w x D $.  $d t v w G $.  $d x z T $.  $d t y V $.
    $d u w z J $.  $d n u v w y S $.  $d t u v w x y z U $.
    icccmp.1 $e |- J = ( topGen ` ran (,) ) $.
    icccmp.2 $e |- T = ( J |`t ( A [,] B ) ) $.
    ${
      icccmp.3 $e |- D = ( ( abs o. - ) |` ( RR X. RR ) ) $.
      icccmp.4 $e |- S = { x e. ( A [,] B ) | E. z e. ( ~P U i^i Fin )
                           ( A [,] x ) C_ U. z } $.
      icccmp.5 $e |- ( ph -> A e. RR ) $.
      icccmp.6 $e |- ( ph -> B e. RR ) $.
      icccmp.7 $e |- ( ph -> A <_ B ) $.
      icccmp.8 $e |- ( ph -> U C_ J ) $.
      icccmp.9 $e |- ( ph -> ( A [,] B ) C_ U. U ) $.
      $( Lemma for ~ icccmp .  (Contributed by Mario Carneiro, 18-Jun-2014.) $)
      icccmplem1 $p |- ( ph -> ( A e. S /\ A. y e. S y <_ B ) ) $=
        ( vu wcel cv cle wbr wral cicc co cuni wss cpw cfn cin cxr rexrd lbicc2
        wrex syl3anc sseldd eluni2 sylib wa csn snssi ad2antrl snex elpw sylibr
        snfi a1i elin sylanbrc wceq adantr iccid syl ad2antll eqsstrd unieq vex
        unisn syl6eq sseq2d rspcev syl2anc rexlimddv sseq1d rexbidv elrab2 crab
        oveq2 ssrab2 eqsstri sseli cr w3a elicc2 biimpa simp3d sylan2 ralrimiva
        wb jca ) AEHUBZCUCZFUDUEZCHUFAEEFUGUHZUBZEEUGUHZDUCZUIZUJZDJUKZULUMZUQZ
        XDAEUNUBZFUNUBEFUDUEXHAEPUOZAFQUOREFUPURZAEUAUCZUBZXOUAJAEJUIZUBXTUAJUQ
        AXGYAETXRUSUAEJUTVAAXSJUBZXTVBZVBZXSVCZXNUBZXIXSUJZXOYDYEXMUBZYEULUBZYF
        YDYEJUJZYHYBYJAXTXSJVDVEYEJXSVFVGVHYIYDXSVIVJYEXMULVKVLYDXIEVCZXSYDXPXI
        YKVMAXPYCXQVNEVOVPXTYKXSUJAYBEXSVDVQVRXLYGDYEXNXJYEVMZXKXSXIYLXKYEUIXSX
        JYEVSXSUAVTWAWBWCWDWEWFEBUCZUGUHZXKUJZDXNUQZXOBEXGHYMEVMZYOXLDXNYQYNXIX
        KYMEEUGWKWGWHOWIVLAXFCHXEHUBAXEXGUBZXFHXGXEHYPBXGWJXGOYPBXGWLWMWNAYRVBX
        EWOUBZEXEUDUEZXFAYRYSYTXFWPZAEWOUBFWOUBYRUUAXBPQEFXEWQWEWRWSWTXAXC $.

      ${
        icccmp.10 $e |- ( ph -> V e. U ) $.
        icccmp.11 $e |- ( ph -> C e. RR+ ) $.
        icccmp.12 $e |- ( ph -> ( G ( ball ` D ) C ) C_ V ) $.
        icccmp.13 $e |- G = sup ( S , RR , < ) $.
        icccmp.14 $e |- R =
          if ( ( G + ( C / 2 ) ) <_ B , ( G + ( C / 2 ) ) , B ) $.
        $( Lemma for ~ icccmp .  (Contributed by Mario Carneiro,
           13-Jun-2014.) $)
        icccmplem2 $p |- ( ph -> B e. S ) $=
          ( vy vn vv vw vt c2 cdiv co caddc cle wbr wn wceq clt cr csup wss wne
          c0 cv wral wrex wcel cicc cuni cpw cfn ssrab2 eqsstri iccssre syl2anc
          cin crab syl5ss icccmplem1 simpld ne0i syl simprd breq2 rspcev suprcl
          ralbidv syl3anc syl5eqel rphalfcld ltaddrpd rpred readdcld ltnled cif
          mpbid ifcl suprub syl31anc syl6breqr ltled letrd ifboth min2 syl5eqbr
          w3a wb elicc2 mpbir3and cmin ltsubrpd syl6breq resubcld wa weq sseq1d
          oveq2 rexbidv elrab2 unieq sseq2d cbvrexv cun sylanbrc adantrr simprr
          elin sseldd adantr expr lelttrd cxr rexr syl5eq rexlimdv syl5bi sylib
          suprlub wi csn simpr1 elpwid simpll snssd unssd snex unex elpw sylibr
          vex snfi sylancl simplr2 ssun1 syl6ss biimpa simp1d simp2d simplr cbl
          unfi cfv cioo simplr3 simp3d min1 crp rphalflt ltadd2dd elioo2 syl2an
          lttrd bl2ioo eleqtrrd elun2 wo lelttric mpjaod ex ssrdv unisng uneq2d
          uniun sseqtr4d 3exp2 expimpd mpd syl6bb eqtri iftrue breq1d syl5ibcom
          cbvrabv mtod iffalse eqeltrrd ) AHEIALFUNUOUPZUQUPZEURUSZUTZHEVAAUXCU
          XBLURUSZALUXBVBUSUXEUTALUXAALIVCVBVDZVCUGAIVCVEZIVGVFZUIVHZUJVHZURUSZ
          UIIVIZUJVCVJZUXFVCVKAIDEVLUPZVCIDBVHZVLUPZCVHZVMZVEZCKVNZVOVTZVJZBUXN
          WAZUXNRUYBBUXNVPVQADVCVKZEVCVKZUXNVCVEZSTDEVRVSZWBZADIVKZUXHAUYIUXIEU
          RUSZUIIVIZABUICDEGIJKMOPQRSTUAUBUCWCZWDZIDWEWFZAUYEUYKUXMTAUYIUYKUYLW
          GUXLUYKUJEVCUXJEVAUXKUYJUIIUXJEUXIURWHWKWIVSZUJUIIWJWLWMZAFUEWNZWOZAL
          UXBUYPALUXAUYPAUXAUYQWPZWQZWRWTAHLURUSUXCUXEAHUXFLURAUXGUXHUXMHIVKZHU
          XFURUSUYHUYNUYOAHUXNVKZDHVLUPZUXIVMZVEZUIUYAVJZVUAAVUBHVCVKZDHURUSZHE
          URUSZAHUXCUXBEWSZVCUHAUXBVCVKZUYEVUJVCVKUYTTUXCUXBEVCXAVSWMZADVUJHURA
          DUXBURUSZDEURUSZDVUJURUSZADLUXBSUYPUYTADUXFLURAUXGUXHUXMUYIDUXFURUSUY
          HUYNUYOUYMUJUIIDXBXCUGXDALUXBUYPUYTUYRXEXFUAUXCVUMVUNVUOUXBEUXBVUJDUR
          WHEVUJDURWHXGVSUHXDAHVUJEURUHAVUKUYEVUJEURUSUYTTUXBEXHVSXIAUYDUYEVUBV
          UGVUHVUIXJXKSTDEHXLVSXMALFXNUPZUKVHZVBUSZUKIVJZVUFAVUPUXFVBUSZVUSAVUP
          LUXFVBALFUYPUEXOUGXPAUXGUXHUXMVUPVCVKZVUTVUSXKUYHUYNUYOALFUYPAFUEWPZX
          QZUJUIUKIVUPUUBXCWTAVURVUFUKIVUQIVKVUQUXNVKZDVUQVLUPZUXRVEZCUYAVJZXRA
          VURVUFUUCZUYBVVGBVUQUXNIBUKXSZUXSVVFCUYAVVIUXPVVEUXRUXOVUQDVLYAXTYBZR
          YCAVVDVVGVVHVVGVVEULVHZVMZVEZULUYAVJAVVDXRZVVHVVFVVMCULUYACULXSUXRVVL
          VVEUXQVVKYDYEYFVVNVVMVVHULUYAVVNVVKUYAVKZVVMVURVUFVVNVVOVVMVURXJZXRZV
          VKNUUDZYGZUYAVKZVUCVVSVMZVEZVUFVVQVVSUXTVKZVVSVOVKZVVTVVQVVSKVEVWCVVQ
          VVKVVRKVVQVVKKVVQVVKUXTVKZVVKVOVKZVVQVVOVWEVWFXRVVNVVOVVMVURUUEVVKUXT
          VOYKUUAZWDUUFVVQNKVVQANKVKZAVVDVVPUUGZUDWFZUUHUUIVVSKVVKVVRULUUNNUUJU
          UKUULUUMVVQVWFVVRVOVKVWDVVQVWEVWFVWGWGNUUOVVKVVRUVEUUPVVSUXTVOYKYHVVQ
          VUCVVLNYGZVWAVVQUMVUCVWKVVQUMVHZVUCVKZVWLVWKVKZVVQVWMXRZVWLVUQURUSZVW
          NVUQVWLVBUSZVVQVWMVWPVWNVVQVWMVWPXRZXRZVVEVWKVWLVWSVVEVVLVWKVVOVVMVUR
          VVNVWRUUQVVLNUURUUSVWSVWLVVEVKZVWLVCVKZDVWLURUSZVWPVVQVWMVXAVWPVWOVXA
          VXBVWLHURUSZVVQVWMVXAVXBVXCXJZVVQUYDVUGVWMVXDXKVVQAUYDVWISWFZVVQAVUGV
          WIVULWFDHVWLXLVSUUTZUVAZYIVVQVWMVXBVWPVWOVXAVXBVXCVXFUVBYIVVQVWMVWPYJ
          VVQVWTVXAVXBVWPXJXKZVWRVVQUYDVUQVCVKZVXHVXEVVQUXNVCVUQVVQAUYFVWIUYGWF
          AVVDVVPUVCYLZDVUQVWLXLVSYMXMYLYNVVQVWMVWQVWNVVQVWMVWQXRZXRZVWLNVKVWNV
          XLLFGUVDUVFUPZNVWLVXLAVXMNVEVVQAVXKVWIYMZUFWFVXLVWLVUPLFUQUPZUVGUPZVX
          MVXLVWLVXPVKZVXAVUPVWLVBUSZVWLVXOVBUSZVVQVWMVXAVWQVXGYIZVXLVUPVUQVWLV
          XLAVVAVXNVVCWFZVVQVXIVXKVXJYMVXTVVOVVMVURVVNVXKUVHVVQVWMVWQYJUVPVXLVW
          LHVXOVXTVXLAVUGVXNVULWFVXLAVXOVCVKZVXNALFUYPVVBWQZWFZVVQVWMVXCVWQVWOV
          XAVXBVXCVXFUVIYIVXLAHVXOVBUSVXNAHUXBVXOVULUYTVYCAHVUJUXBURUHAVUKUYEVU
          JUXBURUSUYTTUXBEUVJVSXIAUXAFLUYSVVBUYPAFUVKVKZUXAFVBUSUEFUVLWFUVMYOWF
          YOVXLVVAVYBVXQVXAVXRVXSXJXKZVYAVYDVVAVUPYPVKVXOYPVKVYFVYBVUPYQVXOYQVU
          PVXOVWLUVNUVOVSXMVXLLVCVKZFVCVKVXMVXPVAVXLAVYGVXNUYPWFVXLFVXLAVYEVXNU
          EWFWPLFGQUVQVSUVRYLVWLNVVLUVSWFYNVWOVXAVXIVWPVWQUVTVXGVVQVXIVWMVXJYMV
          WLVUQUWAVSUWBUWCUWDVVQVWAVVLVVRVMZYGVWKVVKVVRUWGVVQVYHNVVLVVQVWHVYHNV
          AVWJNKUWEWFUWFYRUWHVUEVWBUIVVSUYAUXIVVSVAVUDVWAVUCUXIVVSYDYEWIVSUWIYS
          YTUWJYTYSUWKVVEVUDVEZUIUYAVJZVUFUKHUXNIVUQHVAZVYIVUEUIUYAVYKVVEVUCVUD
          VUQHDVLYAXTYBIUYCVYJUKUXNWARUYBVYJBUKUXNVVIUYBVVGVYJVVJVVFVYICUIUYACU
          IXSUXRVUDVVEUXQUXIYDYEYFUWLUWQUWMYCYHZUJUIIHXBXCUGXDUXCHUXBLURUXCHVUJ
          UXBUHUXCUXBEUWNYRUWOUWPUWRUXDHVUJEUHUXCUXBEUWSYRWFVYLUWT $.
      $}

      $( Lemma for ~ icccmp .  (Contributed by Mario Carneiro, 13-Jun-2014.) $)
      icccmplem3 $p |- ( ph -> B e. S ) $=
        ( wcel vu vy vv vw cr clt csup cv wrex cuni cicc co cle wbr wss c0 wral
        wne cpw cfn cin ssrab2 eqsstri iccssre syl2anc syl5ss icccmplem1 simpld
        crab ne0i syl simprd wceq ralbidv rspcev suprcl syl3anc suprub syl31anc
        breq2 wb suprleub mpbird w3a elicc2 mpbir3and sseldd eluni2 cbl cfv crp
        sylib wa sselda cxmt rexmet cioo crn ctg cmopn eqid tgioo mopni2 mp3an1
        wi eqtri ex cdiv caddc cif ad2antrr simplr simprl icccmplem2 rexlimdvaa
        c2 simprr syld rexlimdva mpd ) AGUEUFUGZUAUHZTZUAIUIZEGTZAYAIUJZTYDADEU
        KULZYFYASAYAYGTZYAUETZDYAUMUNZYAEUMUNZAGUEUOZGUPURZUBUHZUCUHZUMUNZUBGUQ
        ZUCUEUIZYIAGYGUEGDBUHUKULCUHUJUOCIUSUTVAUIZBYGVIYGNYSBYGVBVCADUETZEUETZ
        YGUEUOOPDEVDVEVFZADGTZYMAUUCYNEUMUNZUBGUQZABUBCDEFGHIJKLMNOPQRSVGZVHZGD
        VJVKZAUUAUUEYRPAUUCUUEUUFVLZYQUUEUCEUEYOEVMYPUUDUBGYOEYNUMVTVNVOVEZUCUB
        GVPVQAYLYMYRUUCYJUUBUUHUUJUUGUCUBGDVRVSAYKUUEUUIAYLYMYRUUAYKUUEWAUUBUUH
        UUJPUCUBUBGEWBVSWCAYTUUAYHYIYJYKWDWAOPDEYAWEVEWFWGUAYAIWHWLAYCYEUAIAYBI
        TZWMZYCYAUDUHZFWIWJULYBUOZUDWKUIZYEUULYBJTZYCUUOXEAIJYBRWNUUPYCUUOFUEWO
        WJTUUPYCUUOFMWPUDYBFYAJUEJWQWRWSWJFWTWJZKFUUQMUUQXAXBXFXCXDXGVKUULUUNYE
        UDWKUULUUMWKTZUUNWMZWMBCDEUUMFYAUUMXPXHULXIULZEUMUNUUTEXJZGHIYAJYBKLMNA
        YTUUKUUSOXKAUUAUUKUUSPXKADEUMUNUUKUUSQXKAIJUOUUKUUSRXKAYGYFUOUUKUUSSXKA
        UUKUUSXLUULUURUUNXMUULUURUUNXQYAXAUVAXAXNXOXRXSXT $.
    $}

    $( A closed interval in ` RR ` is compact.  (Contributed by Mario Carneiro,
       13-Jun-2014.) $)
    icccmp $p |- ( ( A e. RR /\ B e. RR ) -> T e. Comp ) $=
      ( vu vz vx cr wcel wa cicc co crest ccmp cv cuni wss c0 cle wbr wrex wral
      clt cpw cfn cin wi crab cabs cmin ccom cxp cres eqid simplll simplr elpwi
      simpllr ad2antrl simprr icccmplem3 oveq2 sseq1d rexbidv elrab simprbi syl
      wceq expr ralrimiva ctop wb cioo crn ctg cfv retop eqeltri iccssre adantr
      uniretop unieqi eqtr4i cmpsub sylancr mpbird csn rexr icc0 syl2an biimpar
      cxr oveq2d rest0 ax-mp syl6eq 0cmp syl6eqel lelttric mpjaodan syl5eqel )
      AJKZBJKZLZCDABMNZONZPFXFABUAUBZXHPKZBAUEUBZXFXILZXJXGGQZRSZXGHQRZSZHXMUFU
      GUHZUCZUIZGDUFZUDZXLXSGXTXLXMXTKZXNXRXLYBXNLZLZBAIQZMNZXOSZHXQUCZIXGUJZKZ
      XRYDIHABUKULUMJJUNUOZYICXMDEFYKUPYIUPXDXEXIYCUQXDXEXIYCUTXFXIYCURYBXMDSXL
      XNXMDUSVAXLYBXNVBVCYJBXGKXRYHXRIBXGYEBVJZYGXPHXQYLYFXGXOYEBAMVDVEVFVGVHVI
      VKVLXLDVMKZXGJSZXJYAVNDVOVPVQVRZVMEVSVTZXFYNXIABWAWBXGDJGHJYORDRWCDYOEWDW
      EWFWGWHXFXKLZXHTWIZPYQXHDTONZYRYQXGTDOXFXGTVJZXKXDAWNKBWNKYTXKVNXEAWJBWJA
      BWKWLWMWOYMYSYRVJYPDWPWQWRWSWTABXAXBXC $.
  $}

  ${
    $d z A $.  $d z X $.  $d z Y $.
    $( Lemma for ~ reconn .  Connectedness in the reals-easy direction.
       (Contributed by Jeff Hankins, 13-Jul-2009.)  (Proof shortened by Mario
       Carneiro, 9-Sep-2015.) $)
    reconnlem1 $p |- ( ( ( A C_ RR /\ ( ( topGen ` ran (,) ) |`t A ) e. Con )
      /\ ( X e. A /\ Y e. A ) ) -> ( X [,] Y ) C_ A ) $=
      ( cr wss cioo co wcel wa c0 wceq cmnf cpnf a1i cin clt wbr syl wb cun crn
      vz ctg cfv crest ccon cicc cdif cv simplr ctopon retopon simplll iooretop
      wn wne simplrl sseldd mnflt eldifn adantl eleq1 syl5ibcom mtod cle wo w3a
      eldifi simplrr elicc2 syl2anc mpbid simp2d simp1d leloed mt3d mnfxr rexrd
      ord elioo2 sylancr mpbir3and inelcm syl5ibrcom simp3d ltpnf pnfxr sylancl
      cxr inss1 jctil jctir leidd ioodisj syl21anc sseq0 ioojoin syl32anc unass
      csn un12 eqtri ioomax 3eqtr3g sseqtr4d disjsn sylibr disjssun nconsubb ex
      mt2d eq0rdv ssdif0 ) ADEZFUAUCUDZAUEGUFHZIZBAHZCAHZIZIZBCUGGZAUHZJKYBAEYA
      UBYCYAUBUIZYCHZXPXNXPXTUJYAYEXPUOYAYEIZALYDFGZXOYDMFGZDXODUKUDHYFULNXNXPX
      TYEUMZYGXOHYFLYDUNNYHXOHYFYDMUNNYFBYGHZXRYGAOJUPYFYJBDHZLBPQZBYDPQZYFADBY
      IXQXRXSYEUQZURZYFYKYLYOBUSRYFYMBYDKZYFYPYDAHZYEYQUOZYAYDYBAUTVAZYFXRYPYQY
      NBYDAVBVCVDYFYMYPYFBYDVEQZYMYPVFYFYDDHZYTYDCVEQZYFYDYBHZUUAYTUUBVGZYEUUCY
      AYDYBAVHVAYFYKCDHZUUCUUDSYOYFADCYIXQXRXSYEVIZURZBCYDVJVKVLZVMYFBYDYOYFUUA
      YTUUBUUHVNZVOVLVSVPYFLWIHZYDWIHZYJYKYLYMVGSVQYFYDUUIVRZLYDBVTWAWBYNBYGAWC
      VKYFCYHHZXSYHAOJUPYFUUMUUEYDCPQZCMPQZUUGYFUUNYDCKZYFUUPYQYSYFYQUUPXSUUFYD
      CAVBWDVDYFUUNUUPYFUUBUUNUUPVFYFUUAYTUUBUUHWEYFYDCUUIUUGVOVLVSVPYFUUEUUOUU
      GCWFRYFUUKMWIHZUUMUUEUUNUUOVGSUULWGYDMCVTWHWBUUFCYHAWCVKYFYGYHOZAOZUUREUU
      RJKZUUSJKUURAWJYFUUJUUKIUUKUUQIYDYDVEQUUTYFUUKUUJUULVQWKYFUUKUUQUULWGWLYF
      YDUUIWMLYDYDMWNWOUUSUURWPWAYFAYDWTZYGYHTZTZEZAUVBEZYFADUVCYIYFYGUVATYHTZL
      MFGZUVCDYFUUJUUKUUQLYDPQZYDMPQZUVFUVGKUUJYFVQNUULUUQYFWGNYFUUAUVHUUIYDUSR
      YFUUAUVIUUIYDWFRLYDMWQWRUVFYGUVAYHTTUVCYGUVAYHWSYGUVAYHXAXBXCXDXEYFAUVAOJ
      KZUVDUVESYFYRUVJYSAYDXFXGAUVAUVBXHRVLXIXJXKXLYBAXMXG $.
  $}

  ${
    $d x y A $.  $d w x y z B $.  $d r w y z C $.  $d r w ph $.  $d r w z U $.
    $d r w S $.  $d r w V $.
    reconnlem2.1 $e |- ( ph -> A C_ RR ) $.
    reconnlem2.2 $e |- ( ph -> U e. ( topGen ` ran (,) ) ) $.
    reconnlem2.3 $e |- ( ph -> V e. ( topGen ` ran (,) ) ) $.
    reconnlem2.4 $e |- ( ph -> A. x e. A A. y e. A ( x [,] y ) C_ A ) $.
    reconnlem2.5 $e |- ( ph -> B e. ( U i^i A ) ) $.
    reconnlem2.6 $e |- ( ph -> C e. ( V i^i A ) ) $.
    reconnlem2.7 $e |- ( ph -> ( U i^i V ) C_ ( RR \ A ) ) $.
    reconnlem2.8 $e |- ( ph -> B <_ C ) $.
    reconnlem2.9 $e |- S = sup ( ( U i^i ( B [,] C ) ) , RR , < ) $.
    $( Lemma for ~ reconn .  (Contributed by Jeff Hankins, 17-Aug-2009.)
       (Proof shortened by Mario Carneiro, 9-Sep-2015.) $)
    reconnlem2 $p |- ( ph -> -. A C_ ( U u. V ) ) $=
      ( wcel cr vr vw vz cun wss wo wn cv cabs cmin ccom cxp cres cbl cmnf cioo
      cfv co cin crp wrex wa c2 cdiv caddc cle wbr clt cicc csup wne wral inss2
      c0 sseldi wceq oveq1 sseq1d oveq2 rspc2va syl21anc sstrd syl5ss inss1 cxr
      sseldd rexrd lbicc2 syl3anc elin sylanbrc syl sseli w3a wb elicc2 syl2anc
      ne0i simp3 syl6bi syl5 ralrimiv breq2 ralbidv rspcev suprcl syl2an adantr
      rpred ltnled mpbid ad2antrr simpr syl31anc syl6breqr ltled mpbir3and eqid
      suprub recnd adantl rpre mpbird ssel mtod nrexdv suprleub syl5eqbr elndif
      syl5com syl5bir syld elioo2 ex wi mopni2 mp3an1 ad3antrrr adantrr rexr
      syl5eqel rphalfcl ltaddrp readdcl letrd eliooord simprd remetdval pncan2d
      mtand fveq2d absidd 3eqtrd rphalflt eqbrtrd cxmt rexmet a1i rpxr syl22anc
      rpge0 elbl3 mnflt leloed ord cdif sseld mpan2d eleq1 syl5ibrcom con4d imp
      mnfxr sylancr ancld crn ctg ctop retop iooretop inopn mp3an13 cmopn tgioo
      notbid ltsubrp sylan resubcl bl2ioo sselda simprl simplr simpllr readdcld
      3syl simprr ltaddrpd lelttrd expr lenltd ralrimiva sylbid ioran sylnibr
      elun ) ADHIUDZUEZGUXFSZAGHSZGISZUFZUXHAUXIUGZUXJUGUXKUGAUXIGUAUHZUIUJUKTT
      ULUMZUNUQURZHUOFUPURZUSZUEZUAUTVAZAUXRUAUTAUXMUTSZVBZUXRGUXMVCVDURZVEURZU
      XQSZUYAUYDUYCGVFVGZUYAGUYCVHVGZUYEUGAGTSZUYBUTSZUYFUXTAGHEFVIURZUSZTVHVJZ
      TRAUYJTUEZUYJVNVKZUBUHZUCUHZVFVGZUBUYJVLZUCTVAZUYKTSAUYJUYITHUYIVMZAUYIDT
      AEDSFDSZBUHZCUHZVIURZDUEZCDVLBDVLUYIDUEZAHDUSZDEHDVMNVOZAIDUSZDFIDVMOVOZM
      VUDVUEEVUBVIURZDUEBCEFDDVUAEVPVUCVUJDVUAEVUBVIVQVRVUBFVPVUJUYIDVUBFEVIVSV
      RVTWAZJWBWCZAEUYJSZUYMAEHSEUYISZVUMAVUFHEHDWDNVOAEWESFWESZEFVFVGVUNAEADTE
      JVUGWFZWGAFADTFJVUIWFZWGZQEFWHWIEHUYIWJWKZUYJEWRWLZAFTSZUYNFVFVGZUBUYJVLZ
      UYRVUQAVVBUBUYJUYNUYJSZUYNUYISZAVVBUYJUYIUYNUYSWMAVVEUYNTSZEUYNVFVGZVVBWN
      ZVVBAETSZVVAVVEVVHWOVUPVUQEFUYNWPWQVVFVVGVVBWSWTXAXBZUYQVVCUCFTUYOFVPUYPV
      VBUBUYJUYOFUYNVFXCXDXEWQZUCUBUYJXFWIUUAZUXMUUBZGUYBUUCXGZUYAGUYCAUYGUXTVV
      LXHZAUYGUYBTSZUYCTSZUXTVVLUXTUYBVVMXIZGUYBUUDXGZXJXKUYAUYDVBZUYCUYKGVFVVT
      UYLUYMUYRUYCUYJSZUYCUYKVFVGAUYLUXTUYDVULXLAUYMUXTUYDVUTXLAUYRUXTUYDVVKXLV
      VTUYCHSUYCUYISZVWAVVTUXQHUYCHUXPWDUYAUYDXMZVOVVTVWBVVQEUYCVFVGZUYCFVFVGZU
      YAVVQUYDVVSXHZVVTEGUYCAVVIUXTUYDVUPXLZAUYGUXTUYDVVLXLZVWFAEGVFVGZUXTUYDAE
      UYKGVFAUYLUYMUYRVUMEUYKVFVGVULVUTVVKVUSUCUBUYJEXSXNRXOZXLVVTGUYCVWHVWFUYA
      UYFUYDVVNXHXPUUEVVTUYCFVWFAVVAUXTUYDVUQXLZVVTUYCUXPSZUYCFVHVGZVVTUXQUXPUY
      CHUXPVMVWCVOVWLUOUYCVHVGVWMUYCUOFUUFUUGWLXPVVTVVIVVAVWBVVQVWDVWEWNWOVWGVW
      KEFUYCWPWQXQUYCHUYIWJWKUCUBUYJUYCXSXNRXOUUJUYAUYCUXOSZUXRUYDUYAVWNUYCGUXN
      URZUXMVHVGZUYAVWOUYBUXMVHUYAVWOUYCGUJURZUIUQZUYBUIUQZUYBUYAVVQUYGVWOVWRVP
      VVSVVOUYCGUXNUXNXRZUUHWQUYAVWQUYBUIUYAGUYBUYAGVVOXTUYAUYBUXTVVPAVVRYAXTUU
      IUUKUYAUYHVWSUYBVPUXTUYHAVVMYAUYHUYBUYBYBUYBUVAUULWLUUMUXTUYBUXMVHVGAUXMU
      UNYAUUOUYAUXNTUUPUQSZUXMWESZUYGVVQVWNVWPWOVXAUYAUXNVWTUUQZUURUXTVXBAUXMUU
      SYAVVOVVSUYCUXNGUXMTUVBUUTYCUXOUXQUYCYDYJYEYFAUXIUXIGUXPSZVBZUXSAUXIVXDAU
      XIVXDAUXIVBZVXDUYGUOGVHVGZGFVHVGZAUYGUXIVVLXHZVXFUYGVXGVXIGUVCWLAUXIVXHAV
      XHUXIAVXHUGGFVPZUXLAVXHVXJAGFVFVGZVXHVXJUFAGUYKFVFRAUYKFVFVGZVVCVVJAUYLUY
      MUYRVVAVXLVVCWOVULVUTVVKVUQUCUBUBUYJFYGXNYCYHZAGFVVLVUQUVDXKUVEAUXLVXJFHS
      ZUGAVXNFTDUVFZSZAUYTVXPUGVUIFDTYIWLAVXNFISZVXPAVUHIFIDWDOVOVXNVXQVBFHIUSZ
      SAVXPFHIWJAVXRVXOFPUVGYKUVHYEVXJUXIVXNGFHUVIUWEUVJYLUVKUVLAVXDUYGVXGVXHWN
      WOZUXIAUOWESVUOVXSUVMVURUOFGYMUVNXHXQYNUVOVXEGUXQSZAUXSGHUXPWJAHUPUVPUVQU
      QZSZUXQVYASZVXTUXSYOKVYAUVRSVYBUXPVYASVYCUVSUOFUVTHUXPVYAUWAUWBVYCVXTUXSV
      XAVYCVXTUXSVXCUAUXQUXNGVYATUXNUXNUWCUQZVWTVYDXRUWDZYPYQYNUWOYKYLYEAUXJUXO
      IUEZUAUTVAZAVYFUAUTUYAVYFGGUXMUJURZVFVGZUYAVYHGVHVGZVYIUGAUYGUXTVYJVVLGUX
      MUWFUWGUYAVYHGAUYGUXMTSZVYHTSZUXTVVLUXMYBZGUXMUWHXGZVVOXJXKUYAVYFVYHGUXMV
      EURZUPURZIUEZVYIUYAUXOVYPIAUYGVYKUXOVYPVPUXTVVLVYMGUXMUXNVWTUWIXGVRUYAVYQ
      VYIUYAVYQVBZGUYKVYHVFRVYRUYKVYHVFVGZUYNVYHVFVGZUBUYJVLZVYRVYTUBUYJVYRVVDV
      BZVYTVYHUYNVHVGZUGWUBWUCUYNVXOSZWUBUYNDSWUDUGVYRUYJDUYNVYRUYJUYIDUYSAVUEU
      XTVYQVUKXLWCUWJUYNDTYIWLVYRVVDWUCWUDVYRVVDWUCVBZVBZVXRVXOUYNAVXRVXOUEUXTV
      YQWUEPYRWUFUYNHSUYNISUYNVXRSWUFUYJHUYNHUYIWDVYRVVDWUCUWKZVOWUFVYPIUYNUYAV
      YQWUEUWLWUFUYNVYPSZVVFWUCUYNVYOVHVGZVYRVVDVVFWUCWUBUYJTUYNAUYLUXTVYQVVDVU
      LYRZVYRVVDXMWFZYSZVYRVVDWUCUWPWUFUYNGVYOWULUYAUYGVYQWUEVVOXLZWUFGUXMWUMWU
      FUXMAUXTVYQWUEUWMZXIUWNZWUFUYNUYKGVFWUFUYLUYMUYRVVDUYNUYKVFVGVYRVVDUYLWUC
      WUJYSAUYMUXTVYQWUEVUTYRAUYRUXTVYQWUEVVKYRWUGUCUBUYJUYNXSXNRXOWUFGUXMWUMWU
      NUWQUWRWUFVYLVYOTSZWUHVVFWUCWUIWNWOZUYAVYLVYQWUEVYNXLWUOVYLVYHWESVYOWESWU
      QWUPVYHYTVYOYTVYHVYOUYNYMXGWQXQWFUYNHIWJWKWFUWSYEWUBUYNVYHWUKUYAVYLVYQVVD
      VYNXLUWTYCUXAVYRUYLUYMUYRVYLVYSWUAWOAUYLUXTVYQVULXLAUYMUXTVYQVUTXLAUYRUXT
      VYQVVKXLUYAVYLVYQVYNXHUCUBUBUYJVYHYGXNYCYHYNUXBYEYFAIVYASZUXJVYGYOLWURUXJ
      VYGVXAWURUXJVYGVXCUAIUXNGVYATVYEYPYQYNWLYEUXIUXJUXCWKGHIUXEUXDAGDSUXGUXHA
      UYIDGVUKAGUYISZUYGVWIVXKVVLVWJVXMAVVIVVAWUSUYGVWIVXKWNWOVUPVUQEFGWPWQXQWF
      DUXFGYDYJYE $.
  $}

  ${
    $d b c u v x y A $.
    $( A subset of the reals is connected iff it has the interval property.
       (Contributed by Jeff Hankins, 15-Jul-2009.)  (Proof shortened by Mario
       Carneiro, 9-Sep-2015.) $)
    reconn $p |- ( A C_ RR -> ( ( ( topGen ` ran (,) ) |`t A ) e. Con <->
      A. x e. A A. y e. A ( x [,] y ) C_ A ) ) $=
      ( vu vv vb vc cr wss co wcel cv cicc wral cin wex adantr ad2antrr simplrr
      wa cioo crn ctg cfv crest ccon reconnlem1 ralrimivva ex c0 wne w3a cun wn
      cdif wi anbi12i eeanv simplll inss2 simprll sseldi sseldd simprlr cle wbr
      n0 csup simplrl simpllr simpr eqid reconnlem2 incom syl5eqss uncom sseq2i
      clt sylnib lecasei exp32 exlimdvv syl5bi exp3a 3impd ralrimdvva ctopon wb
      syl5bir retopon connsub mpan sylibrd impbid ) CHIZUAUBUCUDZCUEJUFKZALZBLZ
      MJCIZBCNACNZWOWQXAWOWQTWTABCCCWRWSUGUHUIWOXADLZCOZUJUKZELZCOZUJUKZXBXEOZH
      CUOZIZULCXBXEUMZIZUNZUPZEWPNDWPNZWQWOXAXNDEWPWPWOXBWPKZXEWPKZTZTZXAXNXSXA
      TZXDXGXJXMXTXDXGXJXMUPZXDXGTFLZXCKZFPZGLZXFKZGPZTZXTYAXDYDXGYGFXCVGGXFVGU
      QYHYCYFTZGPFPXTYAYCYFFGURXTYIYAFGXTYIXJXMXTYIXJTZTZXMYBYEYKCHYBWOXRXAYJUS
      ZYKXCCYBXBCUTXTYCYFXJVAZVBVCYKCHYEYLYKXFCYEXECUTXTYCYFXJVDZVBVCYKYBYEVEVF
      ZTABCYBYEXBYBYEMJOHVRVHZXBXEYKWOYOYLQXTXPYJYOWOXPXQXAVIZRXTXQYJYOWOXPXQXA
      SZRXSXAYJYOVJYKYCYOYMQYKYFYOYNQXTYIXJYOSYKYOVKYPVLVMYKYEYBVEVFZTZCXEXBUMZ
      IXLYTABCYEYBXEYEYBMJOHVRVHZXEXBYKWOYSYLQXTXQYJYSYRRXTXPYJYSYQRXSXAYJYSVJY
      KYFYSYNQYKYCYSYMQYTXEXBOXHXIXEXBVNXTYIXJYSSVOYKYSVKUUBVLVMUUAXKCXEXBVPVQV
      SVTWAWBWIWCWDWEUIWFWPHWGUDKWOWQXOWHWJDECWPHWKWLWMWN $.
  $}

  ${
    $d x y $.
    $( Corollary of ~ reconn .  The set of real numbers is connected.
       (Contributed by Jeff Hankins, 17-Aug-2009.) $)
    retopcon $p |- ( topGen ` ran (,) ) e. Con $=
      ( vx vy cioo crn ctg cfv cr crest co ccon ctop wcel retop uniretop restid
      wceq ax-mp cv wss wral cicc iccssre rgen2a wb ssid reconn mpbir eqeltrri
      ) CDEFZGHIZUIJUIKLUJUIPMUIKGNOQUJJLZARZBRZUAIGSZBGTAGTZUNABGULUMUBUCGGSUK
      UOUDGUEABGUFQUGUH $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( A closed interval is connected.  (Contributed by Jeff Hankins,
       17-Aug-2009.) $)
    iccconn $p |- ( ( A e. RR /\ B e. RR ) ->
      ( ( topGen ` ran (,) ) |`t ( A [,] B ) ) e. Con ) $=
      ( vx vy cr wcel wa cioo crn ctg cfv cicc co crest ccon cv wss wral iccss2
      rgen2a wb iccssre reconn syl mpbiri ) AEFBEFGZHIJKABLMZNMOFZCPZDPZLMUGQZD
      UGRCUGRZUKCDUGABUIUJSTUFUGEQUHULUAABUBCDUGUCUDUE $.

    $( Every nonempty open set is uncountable.  (Contributed by Mario Carneiro,
       26-Jul-2014.)  (Revised by Mario Carneiro, 20-Feb-2015.) $)
    opnreen $p |- ( ( A e. ( topGen ` ran (,) ) /\ A =/= (/) ) ->
                    A ~~ ~P NN ) $=
      ( vx vy cioo cfv wcel wa cdom wbr cen cr cvv wss cmin co crp caddc sylan2
      clt syl2anc crn ctg c0 wne cn reex cuni elssuni uniretop syl6sseqr ssdomg
      cpw mpsyl rpnnen domentr sylancl adantr cv wex n0 cabs ccom cxp cres wrex
      cmopn eqid tgioo eleq2i cxmt rexmet mopni2 mp3an1 sylanb sselda cdiv cicc
      cbl c2 cc0 c1 c3 cexp cmpt rpnnen2 rphalfcl rpred resubcl readdcl ltsubrp
      cif simpl ltaddrp lttrd iccen syl3anc sylancr ovex cxr rexrd recnd adantl
      subsub4d 2halvesd oveq2d eqtrd eqbrtrrd addassd breqtrd iccssioo syl22anc
      rpre domtr wceq bl2ioo breqtrrd sylan simplll simpr sylc ex rexlimdva mpd
      exlimdv syl5bi imp sbth ) ADUAUBEZFZAUCUDZGAUEULZHIZYKAHIZAYKJIYIYLYJYIAK
      HIZKYKJIYLKLFYIAKMYNUFYIAYHUGKAYHUHUIUJZAKLUKUMUNAKYKUOUPUQYIYJYMYJBURZAF
      ZBUSYIYMBAUTYIYQYMBYIYQYMYIYQGZYPCURZVANVBKKVCVDZVREOZAMZCPVEZYMYIAYTVFEZ
      FZYQUUCYHUUDAYTUUDYTVGZUUDVGZVHVIYTKVJEFUUEYQUUCYTUUFVKCAYTYPUUDKUUGVLVMV
      NYRUUBYMCPYRYSPFZGZUUBYMUUIUUBGZYKUUAHIZUUAAHIZYMUUIUUKUUBYRYPKFZUUHUUKYI
      AKYPYOVOUUMUUHGZYKYPYSNOZYPYSQOZDOZUUAHUUNYKYPYSVSVPOZNOZYPUURQOZVQOZHIZU
      VAUUQHIZYKUUQHIUUNYKVTWAVQOZHIUVDUVAJIZUVBBCBYKCUEYSYPFWAWBVPOYSWCOVTWKWD
      WDZUVFVGWEUUNUUSKFZUUTKFZUUSUUTSIUVEUUHUUMUURKFZUVGUUHUURYSWFZWGZYPUURWHR
      ZUUHUUMUVIUVHUVKYPUURWIRZUUNUUSYPUUTUVLUUMUUHWLZUVMUUHUUMUURPFZUUSYPSIUVJ
      YPUURWJRUUHUUMUVOYPUUTSIUVJYPUURWMRWNUUSUUTWOWPYKUVDUVAUOWQUUQLFUUNUVAUUQ
      MZUVCUUOUUPDWRUUNUUOWSFUUPWSFUUOUUSSIUUTUUPSIUVPUUNUUOUUHUUMYSKFZUUOKFYSX
      LZYPYSWHRWTUUNUUPUUHUUMUVQUUPKFUVRYPYSWIRWTUUNUUSUURNOZUUOUUSSUUNUVSYPUUR
      UURQOZNOUUOUUNYPUURUURUUNYPUVNXAZUUNUURUUHUVIUUMUVKXBXAZUWBXCUUNUVTYSYPNU
      UNYSUUNYSUUHUVQUUMUVRXBXAXDZXEXFUUNUVGUVOUVSUUSSIUVLUUHUVOUUMUVJXBZUUSUUR
      WJTXGUUNUUTUUTUURQOZUUPSUUNUVHUVOUUTUWESIUVMUWDUUTUURWMTUUNUWEYPUVTQOUUPU
      UNYPUURUURUWAUWBUWBXHUUNUVTYSYPQUWCXEXFXIUUOUUPUUSUUTXJXKUVAUUQLUKUMYKUVA
      UUQXMTUUHUUMUVQUUAUUQXNUVRYPYSYTUUFXORXPXQUQUUJYIUUBUULYIYQUUHUUBXRUUIUUB
      XSUUAAYHUKXTYKUUAAXMTYAYBYCYAYDYEYFAYKYGT $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( A countable subset of the reals has empty interior.  (Contributed by
       Mario Carneiro, 26-Jul-2014.) $)
    rectbntr0 $p |- ( ( A C_ RR /\ A ~<_ NN ) ->
      ( ( int ` ( topGen ` ran (,) ) ) ` A ) = (/) ) $=
      ( cr wss cn cdom wbr wa cpw wn cioo crn ctg cfv cnt c0 cen retop uniretop
      wcel cvv wceq csdm nnex canth2 domnsym mt2 wne ctop simpl sylancr opnreen
      wi ntropn syl reex ssex ntrss2 mpan ssdomg sylc domtr sylan ensym endomtr
      ex expcom syl2im syld necon1bd mpi ) ABCZADEFZGZDHZDEFZIAJKLMZNMMZOUAVODV
      NUBFDUCUDVNDUEUFVMVOVQOVMVQOUGZVQVNPFZVOVMVQVPSZVRVSULVMVPUHSZVKVTQVKVLUI
      AVPBRUMUJVTVRVSVQUKVEUNVMVQDEFZVSVNVQPFZVOVKVQAEFZVLWBVKATSVQACZWDABUOUPW
      AVKWEQAVPBRUQURVQATUSUTVQADVAVBVQVNVCWCWBVOVNVQDVDVFVGVHVIVJ $.
  $}

  ${
    $d s A $.  $d s ph $.
    xrge0gsumle.g $e |- G = ( RR*s |`s ( 0 [,] +oo ) ) $.
    xrge0gsumle.a $e |- ( ph -> A e. V ) $.
    xrge0gsumle.f $e |- ( ph -> F : A --> ( 0 [,] +oo ) ) $.
    xrge0gsumle.b $e |- ( ph -> B e. ( ~P A i^i Fin ) ) $.
    xrge0gsumle.c $e |- ( ph -> C C_ B ) $.
    $( A finite sum in the nonnegative extended reals is monotonic in the
       support.  (Contributed by Mario Carneiro, 13-Sep-2015.) $)
    xrge0gsumle $p |- ( ph ->
      ( G gsum ( F |` C ) ) <_ ( G gsum ( F |` B ) ) ) $=
      ( cgsu co cc0 cxr wcel wss wceq c0 vs vx cres cxad cle wbr cpw cfn cin cv
      cdif cmpt crn wf wa cpnf cicc iccssxr cbs cxrs xrsbas ressbas2 ax-mp cmnf
      cfv csn cress csubmnd c0g eqid xrge0subm cvv xrex difexg wne ge0nemnf jca
      simpl elxrge0 eldifsn 3imtr4i ssriv ressabs mp2an eqtr4i xrs10 subm0 ccmn
      xrge0cmn eqeltri a1i simprbi adantl simplbi fssres syl2an fisuppfi gsumcl
      elfpw sseldi fmptd frn syl cc 0ss 0fin mpbir2an reseq2 res0 syl6eq oveq2d
      0cn gsum0 elrnmpt1s sseldd diffi ssdifssd syl2anc sstrd xleadd2a syl31anc
      ssfi xaddid1 cplusg xrsadd ressplusg disjdif undif2 ssequn1 sylib syl5req
      ovex cun gsumsplit resabs1 difss mp1i oveq12d eqtr2d 3brtr3d ) AFEDUCZMNZ
      OUDNZUUBFECDUKZUCZMNZUDNZUUBFECUCZMNZUEAOPQUUFPQZUUBPQZOUUFUEUFZUUCUUGUEU
      FAUABUGUHUIZFEUAUJZUCZMNZULZUMZPOAUUMPUUQUNUURPRAUAUUMUUPPUUQAUUNUUMQZUOZ
      OUPUQNZPUUPOUPURZUUTUUNUVAUUOFUHOUVAPRUVAFUSVESUVBUVAPFUTHVAVBVCZUVAUTPVD
      VFZUKZVGNZVHVEQOFVIVESUVFUVFVJZVKUVAFUVFOFUTUVAVGNZUVFUVAVGNZHUVEVLQZUVAU
      VERUVIUVHSPVLQUVJVMPUVDVLVNVCUBUVAUVEUBUJZPQZOUVKUEUFZUOZUVLUVKVDVOZUOUVK
      UVAQUVKUVEQUVNUVLUVOUVLUVMVRUVKVPVQUVKVSUVKPVDVTWAWBUVEUVAUTVLWCWDWEUVFUV
      GWFWGVCZFWHQZUUTFUVHWHHWIWJZWKUUSUUNUHQZAUUSUUNBRZUVSUUNBWSZWLWMZABUVAEUN
      ZUVTUUNUVAUUOUNUUSJUUSUVTUVSUWAWNBUVAUUNEWOWPZUUTUUNUVAVLOVFUKZUUOUWBUWDW
      QWRWTUUQVJZXAUUMPUUQXBXCOUURQZATUUMQZOXDQUWGUWHTBRTUHQBXEXFTBWSXGXLUAUUMU
      UPOTUUQXDUWFUUNTSZUUPFTMNOUWIUUOTFMUWIUUOETUCTUUNTEXHEXIXJXKFOUVPXMXJXNWD
      WKXOAUVAPUUFUVBAUUDUVAUUEFUHOUVCUVPUVQAUVRWKZACUHQZUUDUHQACUUMQZUWKKUWLCB
      RZUWKCBWSZWLXCZCDXPXCZAUWCUUDBRUUDUVAUUEUNJACBDAUWLUWMKUWLUWMUWKUWNWNXCZX
      QBUVAUUDEWOXRZAUUDUVAUWEUUEUWPUWRWQWRZWTAUVAPUUBUVBADUVAUUAFUHOUVCUVPUWJA
      UWKDCRZDUHQUWOLCDYBXRZAUWCDBRDUVAUUAUNJADCBLUWQXSBUVADEWOXRZADUVAUWEUUAUX
      AUXBWQWRWTZAUUFUVAQZUULUWSUXDUUJUULUUFVSWLXCOUUFUUBXTYAAUUKUUCUUBSUXCUUBY
      CXCAUUIFUUHDUCZMNZFUUHUUDUCZMNZUDNUUGACUVADUUDUDUUHFUUMOUVCUVPUVAVLQUDFYD
      VESOUPUQYLUVAUDUTFVLHYEYFVCUWJKAUWCUWMCUVAUUHUNJUWQBUVACEWOXRZACUVAUWEUUH
      UWOUXIWQDUUDUITSADCYGWKADUUDYMDCYMZCDCYHAUWTUXJCSLDCYIYJYKYNAUXFUUBUXHUUF
      UDAUXEUUAFMAUWTUXEUUASLEDCYOXCXKAUXGUUEFMUUDCRUXGUUESACDYPEUUDCYOYQXKYRYS
      YT $.
  $}

  ${
    $d r s u v w y z A $.  $d r s u v w y z F $.  $d r s u v w y z ph $.
    $d r s u v w y z G $.  $d r u v w y z S $.
    xrge0tsms.g $e |- G = ( RR*s |`s ( 0 [,] +oo ) ) $.
    xrge0tsms.a $e |- ( ph -> A e. V ) $.
    xrge0tsms.f $e |- ( ph -> F : A --> ( 0 [,] +oo ) ) $.
    xrge0tsms.s $e |- S = sup (
      ran ( s e. ( ~P A i^i Fin ) |-> ( G gsum ( F |` s ) ) ) , RR* , < ) $.
    $( Any finite or infinite sum in the nonnegative extended reals is uniquely
       convergent to the supremum of all finite sums.  (Contributed by Mario
       Carneiro, 13-Sep-2015.) $)
    xrge0tsms $p |- ( ph -> ( G tsums F ) = { S } ) $=
      ( vz co wcel cc0 cxr wbr clt wa cvv vu vy vx vv vr vw ctsu wceq cpnf cicc
      csn cv wss cres cgsu wi cpw cfn cin wral wrex cle cordt cfv cmpt crn csup
      crest cxrs ax-mp cmnf cdif cress eqid wne ge0nemnf jca elxrge0 mp2an ccmn
      wf eqeltri a1i elfpw simprbi simplbi fssres fisuppfi gsumcl sseldi syl c0
      cc reseq2 syl6eq oveq2d elrnmpt1s supxrub sylancl syl6breqr sylanbrc ctop
      wb letop ovex inss1 cr cioo simplrl simplrr elin syl2anc simprrl syl6breq
      simpr ad3antrrr mpbid weq sylib simprrr simprlr xrge0gsumle xrltletrd w3a
      adantr sstrd mpbir3and sseldd expr ralrimiva reximdva syl5ibrcom ad2antrl
      mpd eleq2 syl5bi simprr ad2antrr ctps cha iccssxr xrsbas ressbas2 csubmnd
      cbs c0g xrge0subm difexg simpl eldifsn 3imtr4i ssriv ressabs eqtr4i xrs10
      xrex subm0 xrge0cmn adantl syl2an fmptd frn supxrcl syl5eqel 0ss mpbir2an
      0fin 0cn res0 gsum0 elrest ctg reex elrestr mp3an12 xrtgioo syl6eleqr tg2
      sseli cxp wfn ioof ffn ovelrn mp2b eliooord simpld simprll supxrlub rgenw
      cbvmptv breq2 rexrnmpt syl6ss simp-4l ssfi simprd xrlelttrd anassrs sseq1
      elioo1 anbi12d imbi1d rexlimdvva rexlimdv eqeltrrd pnfnei simplr breqtrrd
      cioc ltpnf rexr simp-5l simprl pnfge elioc1 rexlimddv wo xrnemnf mpjaodan
      pnfxr syl5 rexralbidv imbi12d rexlimdva ralrimiv xrstset resstset topnval
      imbi2d xrstps resstps eltsms mpbir2and ctsr letsr ordthaus mp1i haustsms2
      cts resthaus ) ACEDUGMZNZVUBCUKUHAVUCCOUIUJMZNZCUAULZNZLULZUBULZUMZEDVUIU
      NZUOMZVUFNZUPZUBBUQURUSZUTLVUOVAZUPZUAVBVCVDZVUDVHMZUTACPNZOCVBQZVUEACGVU
      OEDGULZUNZUOMZVEZVFZPRVGZPKAVVFPUMZVVGPNAVUOPVVEWAVVHAGVUOVVDPVVEAVVBVUON
      ZSZVUDPVVDOUIUUAZVVJVVBVUDVVCEUROVUDPUMVUDEUUEVDUHVVKVUDPEVIHUUBUUCVJZVUD
      VIPVKUKZVLZVMMZUUDVDNOEUUFVDUHVVOVVOVNZUUGVUDEVVOOEVIVUDVMMZVVOVUDVMMZHVV
      NTNZVUDVVNUMVVRVVQUHPTNVVSUUPPVVMTUUHVJUCVUDVVNUCULZPNZOVVTVBQZSZVWAVVTVK
      VOZSVVTVUDNVVTVVNNVWCVWAVWDVWAVWBUUIVVTVPVQVVTVRVVTPVKUUJUUKUULVVNVUDVITU
      UMVSUUNVVOVVPUUOUUQVJZEVTNZVVJEVVQVTHUURWBZWCVVIVVBURNZAVVIVVBBUMZVWHVVBB
      WDZWEUUSZABVUDDWAZVWIVVBVUDVVCWAVVIJVVIVWIVWHVWJWFBVUDVVBDWGUUTZVVJVVBVUD
      TOUKVLZVVCVWKVWMWHWIWJVVEVNZUVAVUOPVVEUVBWKZVVFUVCWKUVDZAOVVGCVBAVVHOVVFN
      ZOVVGVBQVWPWLVUONZOWMNVWRVWSWLBUMWLURNBUVEUVGWLBWDUVFUVHGVUOVVDOWLVVEWMVW
      OVVBWLUHZVVDEWLUOMOVWTVVCWLEUOVWTVVCDWLUNWLVVBWLDWNDUVIWOWPEOVWEUVJWOWQVS
      VVFOWRWSKWTZCVRXAAVUQUAVUSVUFVUSNZVUFUDULZVUDUSZUHZUDVURVAZAVUQVURXBNZVUD
      TNZVXBVXFXCXDOUIUJXEZUDVUFVUDVURXBTUVKVSAVXEVUQUDVURAVXCVURNZSZVUQVXECVXD
      NZVUJVULVXDNZUPZUBVUOUTZLVUOVAZUPVXLCVXCNZVXKVXPVXDVXCCVXCVUDXFUVSAVXJVXQ
      VXPAVXJVXQSZSZCXGNZVXPCUIUHZVXSVXTSZVUGVUFVXCXGUSZUMZSZUAXHVFZVAZVXPVYBVY
      CVYFUVLVDZNCVYCNZVYGVYBVYCVURXGVHMZVYHVYBVXJVYCVYJNZAVXJVXQVXTXIVXGXGTNVX
      JVYKXDUVMVXCXGVURXBTUVNUVOWKVYJVYJVNUVPUVQVYBVXQVXTVYIAVXJVXQVXTXJVXSVXTX
      OCVXCXGXKXAUAVYCVYFCUVRXLVYBVYEVXPUAVYFVUFVYFNZVUFUEULZUFULZXHMZUHZUFPVAU
      EPVAZVYBVYEVXPUPZPPUVTZXGUQZXHWAXHVYSUWAVYLVYQXCUWBVYSVYTXHUWCUEUFPPVUFXH
      UWDUWEVYBVYPVYRUEUFPPVYBVYMPNZVYNPNZSZSVYRVYPCVYONZVYOVYCUMZSZVXPUPVYBWUC
      WUFVXPVYBWUCWUFSZSZVYMEDVUHUNZUOMZRQZLVUOVAZVXPWUHVYMVYNRQZUFVVFVAZWULWUH
      VYMVVGRQZWUNWUHVYMCVVGRWUHVYMCRQZCVYNRQZWUHWUDWUPWUQSVYBWUCWUDWUEXMCVYMVY
      NUWFWKZUWGKXNWUHVVHWUAWUOWUNXCZAVVHVXRVXTWUGVWPXPVYBWUAWUBWUFUWHZUFVVFVYM
      UWIZXLXQWUJTNZLVUOUTWUNWULXCWVBLVUOEWUIUOXEUWJWUMWUKLUFVUOWUJVVETGLVUOVVD
      WUJGLXRVVCWUIEUOVVBVUHDWNWPUWKVYNWUJVYMRUWLUWMVJZXSWUHWUKVXOLVUOWUHVUHVUO
      NZWUKVXOWUHWVDWUKSZSZVXNUBVUOWVFVUIVUONZVUJVXMWUHWVEWVGVUJSZVXMWUHWVEWVHS
      ZSZVULVXCNZVULVUDNZVXMWVJVYOVXCVULWVJVYOVYCVXCWUHWUEWVIVYBWUCWUDWUEXTYEVX
      CXGXFUWNWVJVULVYONZVULPNZVYMVULRQZVULVYNRQZWVJVUDPVULVVKWVJVUIVUDVUKEUROV
      VLVWEVWFWVJVWGWCZWVJWVGVUIURNZWUHWVEWVGVUJXMZWVGVUIBUMZWVRVUIBWDZWEZWKZWV
      JVWLWVTVUIVUDVUKWAZWVJAVWLAVXRVXTWUGWVIUWOZJWKZWVJWVGWVTWVSWVGWVTWVRWWAWF
      ZWKZBVUDVUIDWGZXLZWVJVUIVUDVWNVUKWWCWWJWHWIZWJZWVJVYMWUJVULWUHWUAWVIWUTYE
      ZWVJVUDPWUJVVKWVJVUHVUDWUIEUROVVLVWEWVQWVJWVRVUJVUHURNZWWCWUHWVEWVGVUJXTZ
      VUIVUHUWPZXLZWVJVWLVUHBUMZVUHVUDWUIWAZWWFWVJVUHVUIBWWOWWHYFBVUDVUHDWGZXLZ
      WVJVUHVUDVWNWUIWWQWXAWHWIWJWWLWUHWVDWUKWVHYAWVJBVUIVUHDEFHWVJABFNZWWEIWKW
      WFWVSWWOYBYCWVJVULCVYNWWLWVJAVUTWWEVWQWKWUHWUBWVIVYBWUAWUBWUFYAYEZWVJVULV
      VGCVBWVJVVHVULVVFNZVULVVGVBQWVJAVVHWWEVWPWKWVJWVGVULTNWXDWVSEVUKUOXEGVUOV
      VDVULVUIVVETVWOGUBXRVVCVUKEUOVVBVUIDWNWPWQWSVVFVULWRXLKWTWUHWUQWVIWUHWUPW
      UQWURUWQYEUWRWVJWUAWUBWVMWVNWVOWVPYDXCWWMWXCVYMVYNVULUXAXLYGYHWWKVULVXCVU
      DXKZXAUWSYIYJYIYKYNYIVYPVYEWUFVXPVYPVUGWUDVYDWUEVUFVYOCYOVUFVYOVYCUWTUXBU
      XCYLUXDYPUXEYNVXSVYASZVYMUIUXJMZVXCUMZVXPUEXGWXFVXJUIVXCNWXHUEXGVAAVXJVXQ
      VYAXIWXFCUIVXCVXSVYAXOAVXJVXQVYAXJUXFUEVXCUXGXLWXFVYMXGNZWXHSZSZWULVXPWXK
      WUNWULWXKWUOWUNWXKVYMCVVGRWXKVYMUICRWXIVYMUIRQWXFWXHVYMUXKYMVXSVYAWXJUXHU
      XIKXNWXKVVHWUAWUSAVVHVXRVYAWXJVWPXPWXIWUAWXFWXHVYMUXLYMZWVAXLXQWVCXSWXKWU
      KVXOLVUOWXKWVDWUKVXOWXKWVESZVXNUBVUOWXMWVGVUJVXMWXMWVHSZWVKWVLVXMWXNWXGVX
      CVULWXKWXHWVEWVHWXFWXIWXHYQYRWXNVULWXGNZWVNWVOVULUIVBQZWXNVUDPVULVVKWXNVU
      IVUDVUKEUROVVLVWEVWFWXNVWGWCZWVGWVRWXMVUJWWBYMZWXNVWLWVTWWDWXNAVWLAVXRVYA
      WXJWVEWVHUXMZJWKZWVGWVTWXMVUJWWGYMZWWIXLZWXNVUIVUDVWNVUKWXRWYBWHWIZWJZWXN
      VYMWUJVULWXKWUAWVEWVHWXLYRZWXNVUDPWUJVVKWXNVUHVUDWUIEUROVVLVWEWXQWXNWVRVU
      JWWNWXRWXMWVGVUJYQZWWPXLZWXNVWLWWRWWSWXTWXNVUHVUIBWYFWYAYFWWTXLZWXNVUHVUD
      VWNWUIWYGWYHWHWIWJWYDWXKWVDWUKWVHXJWXNBVUIVUHDEFHWXNAWXBWXSIWKWXTWXMWVGVU
      JUXNWYFYBYCWXNWVNWXPWYDVULUXOWKWXNWUAUIPNWXOWVNWVOWXPYDXCWYEUYAVYMUIVULUX
      PWSYGYHWYCWXEXAYIYJYIYKYNUXQVXSVUTCVKVOZSZVXTVYAUXRAWYJVXRAVUTWYIVWQAVUTV
      VAWYIVWQVXACVPXLVQYECUXSXSUXTYIUYBVXEVUGVXLVUPVXPVUFVXDCYOVXEVUNVXNLUBVUO
      VUOVXEVUMVXMVUJVUFVXDVULYOUYJUYCUYDYLUYEYPUYFAUBLUABVUDCVUODEVUSFVVLVUDVU
      REVVLVXHVUREUYTVDUHVXIVUDVIEVURTHUYGUYHVJUYIZVUOVNVWFAVWGWCZEYSNAEVVQYSHV
      IYSNVXHVVQYSNUYKVXIVUDVITUYLVSWBWCZIJUYMUYNABVUDDEVUSFCVVLWYLWYMIJWYKAVUR
      YTNZVXHVUSYTNVBUYONWYNAUYPVBUYQUYRVXIVUDVURTVUAWSUYSYN $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x V $.
    xrge0tsms2.g $e |- G = ( RR*s |`s ( 0 [,] +oo ) ) $.
    $( Any finite or infinite sum in the nonnegative extended reals is
       convergent.  This is a rather unique property of the set
       ` [ 0 , +oo ] ` ; a similar theorem is not true for ` RR* ` or ` RR ` or
       ` [ 0 , +oo ) ` .  It is true for ` NN0 u. { +oo } ` , however, or more
       generally any additive submonoid of ` [ 0 , +oo ) ` with ` +oo `
       adjoined.  (Contributed by Mario Carneiro, 13-Sep-2015.) $)
    xrge0tsms2 $p |- ( ( A e. V /\ F : A --> ( 0 [,] +oo ) ) ->
        ( G tsums F ) ~~ 1o ) $=
      ( vx wcel cc0 cpnf cicc co wf wa ctsu cpw cfn cin cv cxr clt cres crn csn
      cgsu cmpt csup c1o simpl simpr eqid xrge0tsms xrltso supex ensn1 syl6eqbr
      cen ) ADGZAHIJKBLZMZCBNKFAOPQCBFRUAUDKUEUBZSTUFZUCUGUPUSAVABCDFEUQURUHUQU
      RUIVAUJUKVASUTTULUMUNUO $.
  $}

  ${
    $d r s w x y z C $.  $d r s w x y z D $.  $d r s w x y z J $.
    $d r s x y K $.  $d r s w x y z X $.
    xmetdcn2.1 $e |- J = ( MetOpen ` D ) $.
    ${
      xmetdcn2.2 $e |- C = ( dist ` RR*s ) $.
      xmetdcn2.3 $e |- K = ( MetOpen ` C ) $.
      ${
        metdcn.d $e |- ( ph -> D e. ( *Met ` X ) ) $.
        metdcn.a $e |- ( ph -> A e. X ) $.
        metdcn.b $e |- ( ph -> B e. X ) $.
        metdcn.r $e |- ( ph -> R e. RR+ ) $.
        metdcn.y $e |- ( ph -> Y e. X ) $.
        metdcn.z $e |- ( ph -> Z e. X ) $.
        metdcn.4 $e |- ( ph -> ( A D Y ) < ( R / 2 ) ) $.
        metdcn.5 $e |- ( ph -> ( B D Z ) < ( R / 2 ) ) $.
        $( The metric function of a metric space is always continuous in the
           topology generated by it.  (Contributed by Mario Carneiro,
           5-May-2014.)  (Revised by Mario Carneiro, 4-Sep-2015.) $)
        metdcnlem $p |- ( ph -> ( ( A D B ) C ( Y D Z ) ) < R ) $=
          ( co caddc cxr cxmt cfv wcel cr cle wbr xrsxmet a1i xmetcl syl3anc c2
          cdiv rphalfcld rpred clt rpxrd xmetrtri2 syl13anc xrlelttrd wi xrltle
          syl2anc xmetlecl syl122anc wceq xmetsym oveq12d eqbrtrd readdcld cxad
          mpd xmettri rexadd breqtrd lt2halvesd lelttrd ) ABCEUCZJKEUCZDUCZWBJC
          EUCZDUCZWEWCDUCZUDUCZFADUEUFUGUHZWBUEUHZWCUEUHZWHUIUHWDWHUJUKWDUIUHWI
          ADMULUMZAEIUFUGUHZBIUHZCIUHZWJOPQBCEIUNUOZAWMJIUHZKIUHZWKOSTJKEIUNUOZ
          AWFWGAWIWJWEUEUHZFUPUQUCZUIUHZWFXAUJUKZWFUIUHZWLWPAWMWQWOWTOSQJCEIUNU
          OZAXAAFRURZUSZAWFXAUTUKZXCAWFBJEUCZXAAWIWJWTWFUEUHZWLWPXEWBWEDUEUNUOZ
          AWMWNWQXIUEUHOPSBJEIUNUOAXAXFVAZAWMWNWQWOWFXIUJUKOPSQBJCEDIMVBVCUAVDZ
          AXJXAUEUHZXHXCVEXKXLWFXAVFVGVPWBWEXADUEVHVIZAWIWTWKXBWGXAUJUKZWGUIUHZ
          WLXEWSXGAWGXAUTUKZXPAWGCKEUCZXAAWIWTWKWGUEUHZWLXEWSWEWCDUEUNUOZAWMWOW
          RXSUEUHOQTCKEIUNUOXLAWGCJEUCZKJEUCZDUCZXSUJAWEYBWCYCDAWMWQWOWEYBVJOSQ
          JCEIVKUOAWMWQWRWCYCVJOSTJKEIVKUOVLAWMWOWRWQYDXSUJUKOQTSCKJEDIMVBVCVMU
          BVDZAXTXNXRXPVEYAXLWGXAVFVGVPWEWCXADUEVHVIZVNZAWDWFWGVOUCZWHUJAWIWJWK
          WTWDYHUJUKWLWPWSXEWBWCWEDUEVQVCAXDXQYHWHVJXOYFWFWGVRVGVSZWBWCWHDUEVHV
          IYGAFRUSZYIAWFWGFXOYFYJXMYEVTWA $.
      $}

      $( The metric function of an extended metric space is always continuous
         in the topology generated by it.  In this variation of ~ xmetdcn we
         use the metric topology instead of the order topology on ` RR* ` ,
         which makes the theorem a bit stronger.  Since ` +oo ` is an isolated
         point in the metric topology, this is saying that for any points
         ` A , B ` which are an infinite distance apart, there is a product
         neighborhood around ` <. A , B >. ` such that ` d ( a , b ) = +oo `
         for any ` a ` near ` A ` and ` b ` near ` B ` , i.e. the distance
         function is locally constant ` +oo ` .  (Contributed by Mario
         Carneiro, 5-May-2014.)  (Revised by Mario Carneiro, 4-Sep-2015.) $)
      xmetdcn2 $p |- ( D e. ( *Met ` X ) -> D e. ( ( J tX J ) Cn K ) ) $=
        ( vx vz vs vw wcel co cv clt wbr wa wral crp vy vr cxmt cfv ctx ccn cxp
        cxr wf wrex xmetf cdiv rphalfcl adantl simp-4l simplrl ad2antrr simplrr
        wi c2 simpllr simprl simprr metdcnlem ex ralrimivva wceq anbi12d imbi1d
        breq2 2ralbidv rspcev syl2anc ralrimiva wb xrsxmet a1i txmetcn mpd3an23
        id mpbir2and ) BEUCUDMZBCCUENDUFNMZEEUGUHBUIZIOZJOZBNZKOZPQZUAOZLOZBNZW
        HPQZRZWEWJBNWFWKBNANUBOZPQZUSZLESJESZKTUJZUBTSZUAESIESZBEUKWBWTIUAEEWBW
        EEMZWJEMZRZRZWSUBTXEWOTMZRZWOUTULNZTMZWGXHPQZWLXHPQZRZWPUSZLESJESZWSXFX
        IXEWOUMUNXGXMJLEEXGWFEMZWKEMZRZRZXLWPXRXLRWEWJABWOCDEWFWKFGHWBXDXFXQXLU
        OXGXBXQXLWBXBXCXFUPUQXGXCXQXLWBXBXCXFURUQXEXFXQXLVAXGXOXPXLUPXGXOXPXLUR
        XRXJXKVBXRXJXKVCVDVEVFWRXNKXHTWHXHVGZWQXMJLEEXSWNXLWPXSWIXJWMXKWHXHWGPV
        JWHXHWLPVJVHVIVKVLVMVNVFWBWBAUHUCUDMZWCWDXARVOWBVTXTWBAGVPVQIUAUBKLJBBA
        BCCDEEUHFFHVRVSWA $.
    $}

    ${
      xmetdcn.2 $e |- K = ( ordTop ` <_ ) $.
      $( The metric function of an extended metric space is always continuous
         in the topology generated by it.  (Contributed by Mario Carneiro,
         4-Sep-2015.) $)
      xmetdcn $p |- ( D e. ( *Met ` X ) -> D e. ( ( J tX J ) Cn K ) ) $=
        ( cxmt cfv wcel ctx co cxrs cds cmopn ccn cxr ctopon wss cle eqid cordt
        letopon eqeltri xrsmopn eqsstri cuni xrsxmet ax-mp cnss2 mp2an xmetdcn2
        wceq mopnuni sseldi ) ADGHIBBJKZLMHZNHZOKZUOCOKZACPQHZICUQRURUSRCSUAHZU
        TFUBUCCVAUQFUPUQUPTZUQTZUDUEUOUQCPUPPGHIPUQUFULUPVBUGUPUQPVCUMUHUIUJUPA
        BUQDEVBVCUKUN $.
    $}

    ${
      metdcn2.2 $e |- K = ( topGen ` ran (,) ) $.
      $( The metric function of a metric space is always continuous in the
         topology generated by it.  (Contributed by Mario Carneiro,
         5-May-2014.)  (Revised by Mario Carneiro, 4-Sep-2015.) $)
      metdcn2 $p |- ( D e. ( Met ` X ) -> D e. ( ( J tX J ) Cn K ) ) $=
        ( cme cfv wcel ctx co cle cr ccn eqid syl cxr crn wss a1i cordt metxmet
        crest cxmt xmetdcn ctopon wb letopon cxp wf metf ressxr cnrest2 syl3anc
        frn mpbid cioo ctg xrtgioo eqtri oveq2i syl6eleqr ) ADGHIZABBJKZLUAHZMU
        CKZNKZVDCNKVCAVDVENKIZAVGIZVCADUDHIVHADUBABVEDEVEOUEPVCVEQUFHIZARMSZMQS
        ZVHVIUGVJVCUHTVCDDUIZMAUJVKADUKVMMAUOPVLVCULTMAVDVEQUMUNUPCVFVDNCUQRURH
        VFFVFVFOUSUTVAVB $.
    $}

    metdcn.2 $e |- K = ( TopOpen ` CCfld ) $.
    $( The metric function of a metric space is always continuous in the
       topology generated by it.  (Contributed by Mario Carneiro, 5-May-2014.)
       (Revised by Mario Carneiro, 4-Sep-2015.) $)
    metdcn $p |- ( D e. ( Met ` X ) -> D e. ( ( J tX J ) Cn K ) ) $=
      ( cme cfv wcel ctx co cioo crn ctg ccn cr crest tgioo2 oveq2i ctop sseldi
      wss cnfldtop cnrest2r ax-mp eqsstri eqid metdcn2 ) ADGHIBBJKZLMNHZOKZUICO
      KZAUKUICPQKZOKZULUJUMUIOCFRSCTIUNULUBCFUCPUICUDUEUFABUJDEUJUGUHUA $.
  $}

  ${
    msdcn.x $e |- X = ( Base ` M ) $.
    msdcn.d $e |- D = ( dist ` M ) $.
    msdcn.j $e |- J = ( TopOpen ` M ) $.
    msdcn.2 $e |- K = ( topGen ` ran (,) ) $.
    $( The metric function of a metric space is always continuous in the
       topology generated by it.  (Contributed by Mario Carneiro, 5-May-2014.)
       (Revised by Mario Carneiro, 5-Oct-2015.) $)
    msdcn $p |- ( M e. MetSp -> ( D |` ( X X. X ) ) e. ( ( J tX J ) Cn K ) ) $=
      ( cmt wcel cxp cres cmopn cfv ctx co ccn cme msmet2 metdcn2 mstopn oveq1d
      eqid syl cds reseq1i oveq12d eleqtrrd ) DJKZAEELZMZULNOZUMPQZCRQZBBPQZCRQ
      UJULESOKULUOKADEFGTULUMCEUMUDIUAUEUJUPUNCRUJBUMBUMPULBDEHFADUFOUKGUGUBZUQ
      UHUCUI $.
  $}

  ${
    $d x y D $.  $d x y G $.  $d x y J $.  $d x K $.  $d x y ph $.  $d x y R $.
    $d x y X $.  $d x y Y $.
    cnmpt1ds.d $e |- D = ( dist ` G ) $.
    cnmpt1ds.j $e |- J = ( TopOpen ` G ) $.
    cnmpt1ds.r $e |- R = ( topGen ` ran (,) ) $.
    cnmpt1ds.g $e |- ( ph -> G e. MetSp ) $.
    cnmpt1ds.k $e |- ( ph -> K e. ( TopOn ` X ) ) $.
    ${
      cnmpt1ds.a $e |- ( ph -> ( x e. X |-> A ) e. ( K Cn J ) ) $.
      cnmpt1ds.b $e |- ( ph -> ( x e. X |-> B ) e. ( K Cn J ) ) $.
      $( Continuity of the metric function; analogue of ~ cnmpt12f which cannot
         be used directly because ` D ` is not necessarily a function.
         (Contributed by Mario Carneiro, 5-Oct-2015.) $)
      cnmpt1ds $p |- ( ph -> ( x e. X |-> ( A D B ) ) e. ( K Cn R ) ) $=
        ( co cmpt wcel cbs cfv cxp cres ccn cv wa wf wral ctopon ctps cmt mstps
        syl eqid istps sylib cnf2 syl3anc fmpt sylibr r19.21bi ovresd mpteq2dva
        ctx msdcn cnmpt12f eqeltrrd ) ABJCDEGUAUBZVIUCUDZRZSBJCDERZSIFUERABJVKV
        LABUFJTUGCDEVIACVITZBJAJVIBJCSZUHZVMBJUIAIJUJUBTZHVIUJUBTZVNIHUERZTVOOA
        GUKTZVQAGULTZVSNGUMUNVIHGVIUOZLUPUQZPVNIHJVIURUSBJVICVNVNUOUTVAVBADVITZ
        BJAJVIBJDSZUHZWCBJUIAVPVQWDVRTWEOWBQWDIHJVIURUSBJVIDWDWDUOUTVAVBVCVDABC
        DVJIHHFJOPQAVTVJHHVERFUERTNEHFGVIWAKLMVFUNVGVH $.
    $}

    cnmpt2ds.l $e |- ( ph -> L e. ( TopOn ` Y ) ) $.
    cnmpt2ds.a $e |- ( ph -> ( x e. X , y e. Y |-> A ) e.
                             ( ( K tX L ) Cn J ) ) $.
    cnmpt2ds.b $e |- ( ph -> ( x e. X , y e. Y |-> B ) e.
                             ( ( K tX L ) Cn J ) ) $.
    $( Continuity of the metric function; analogue of ~ cnmpt22f which cannot
       be used directly because ` D ` is not necessarily a function.
       (Contributed by Mario Carneiro, 5-Oct-2015.) $)
    cnmpt2ds $p |- ( ph ->
        ( x e. X , y e. Y |-> ( A D B ) ) e. ( ( K tX L ) Cn R ) ) $=
      ( cbs cfv cxp cres co cmpt2 ctx ccn wcel wceq wral ctopon txtopon syl2anc
      cv wa wf ctps cmt mstps syl eqid istps sylib cnf2 syl3anc sylibr r19.21bi
      fmpt2 ovresd 3impa mpt2eq3dva msdcn cnmpt22f eqeltrrd ) ABCLMDEFHUBUCZVQU
      DUEZUFZUGBCLMDEFUFZUGJKUHUFZGUIUFABCLMVSVTABUPLUJZCUPMUJZVSVTUKAWBUQZWCUQ
      DEFVQWDDVQUJZCMAWECMULZBLALMUDZVQBCLMDUGZURZWFBLULAWAWGUMUCUJZIVQUMUCUJZW
      HWAIUIUFZUJWIAJLUMUCUJKMUMUCUJWJRSJKLMUNUOZAHUSUJZWKAHUTUJZWNQHVAVBVQIHVQ
      VCZOVDVEZTWHWAIWGVQVFVGBCLMDVQWHWHVCVJVHVIVIWDEVQUJZCMAWRCMULZBLAWGVQBCLM
      EUGZURZWSBLULAWJWKWTWLUJXAWMWQUAWTWAIWGVQVFVGBCLMEVQWTWTVCVJVHVIVIVKVLVMA
      BCDEVRJKIIGLMRSTUAAWOVRIIUHUFGUIUFUJQFIGHVQWPNOPVNVBVOVP $.
  $}

  ${
    $d x G $.  $d x J $.  $d x K $.
    nmcn.n $e |- N = ( norm ` G ) $.
    nmcn.j $e |- J = ( TopOpen ` G ) $.
    nmcn.k $e |- K = ( topGen ` ran (,) ) $.
    $( The norm of a normed group is a continuous function.  (Contributed by
       Mario Carneiro, 4-Oct-2015.) $)
    nmcn $p |- ( G e. NrmGrp -> N e. ( J Cn K ) ) $=
      ( vx cngp wcel cbs cfv cv c0g cds co cmpt ccn eqid nmfval ngpms ctps cgrp
      ctopon ngptps istps sylib cnmptid ngpgrp grpidcl cnmptc cnmpt1ds syl5eqel
      syl ) AIJZDHAKLZHMZANLZAOLZPQBCRPHUSDAUPUREUPSZURSZUSSZTUOHUQURUSCABBUPVB
      FGAUAUOAUBJBUPUDLJAUEUPBAUTFUFUGZUOHBUPVCUHUOHURBBUPUPVCVCUOAUCJURUPJAUIU
      PAURUTVAUJUNUKULUM $.
  $}

  ${
    abscn.3 $e |- J = ( TopOpen ` CCfld ) $.
    abscn.4 $e |- K = ( topGen ` ran (,) ) $.
    $( The absolute value function on complex numbers is continuous.
       (Contributed by NM, 22-Aug-2007.)  (Proof shortened by Mario Carneiro,
       10-Jan-2014.) $)
    abscn $p |- abs e. ( J Cn K ) $=
      ( ccnfld cngp wcel cabs ccn co cnngp cnfldnm nmcn ax-mp ) EFGHABIJGKEABHL
      CDMN $.
  $}

  ${
    $d r w x y z A $.  $d r s t w x y z D $.  $d r s t w y z J $.  $d s t ph $.
    $d x y B $.  $d r s w z C $.  $d s t G $.  $d w z R $.  $d s t w x y z T $.
    $d r s w z K $.  $d r s t w x y z S $.  $d s w U $.  $d r s t w x y z X $.
    $d r s t w z F $.  $d w z V $.
    metdscn.f $e |- F = ( x e. X |->
      sup ( ran ( y e. S |-> ( x D y ) ) , RR* , `' < ) ) $.
    $( Value of the "distance to a set" function.  (Contributed by Mario
       Carneiro, 14-Feb-2015.)  (Revised by Mario Carneiro, 4-Sep-2015.) $)
    metdsval $p |- ( A e. X -> ( F ` A ) =
      sup ( ran ( y e. S |-> ( A D y ) ) , RR* , `' < ) ) $=
      ( cv co cmpt crn cxr clt ccnv csup wceq oveq1 mpteq2dv wor supeq1d xrltso
      rneqd cnvso mpbi supex fvmpt ) ACBEAIZBIZDJZKZLZMNOZPBECUIDJZKZLZMUMPGFUH
      CQZMULUPUMUQUKUOUQBEUJUNUHCUIDRSUCUAHMUPUMMNTMUMTUBMNUDUEUFUG $.

    $( The distance from a point to a set is a nonnegative extended real
       number.  (Contributed by Mario Carneiro, 14-Feb-2015.)  (Revised by
       Mario Carneiro, 4-Sep-2015.) $)
    metdsf $p |- ( ( D e. ( *Met ` X ) /\ S C_ X ) ->
       F : X --> ( 0 [,] +oo ) ) $=
      ( vz wcel wss wa cv co cxr cc0 cle wbr simplr syl3anc wral cxmt cmpt ccnv
      cfv crn clt csup cpnf cicc wf simplll sselda xmetcl eqid frn syl infmxrcl
      fmptd xmetge0 ralrimiva cvv wb ovex rgenw breq2 ralrnmpt ax-mp sylibr 0xr
      infmxrgelb sylancl mpbird elxrge0 sylanbrc ) CFUAUDIZDFJZKZAFBDALZBLZCMZU
      BZUEZNUFUCUGZOUHUIMZEVQVRFIZKZWCNIZOWCPQZWCWDIWFWBNJZWGWFDNWAUJWIWFBDVTNW
      AWFVSDIZKZVOWEVSFIZVTNIVOVPWEWJUKZVQWEWJRZWFDFVSVOVPWERULZVRVSCFUMSWAUNZU
      RDNWAUOUPZWBUQUPWFWHOHLZPQZHWBTZWFOVTPQZBDTZWTWFXABDWKVOWEWLXAWMWNWOVRVSC
      FUSSUTVTVAIZBDTWTXBVBXCBDVRVSCVCVDWSXABHDVTWAVAWPWRVTOPVEVFVGVHWFWIONIWHW
      TVBWQVIHWBOVJVKVLWCVMVNGUR $.

    $( The distance from the point ` A ` to the set ` S ` is greater than ` R `
       iff the ` R ` -ball around ` A ` misses ` S ` .  (Contributed by Mario
       Carneiro, 4-Sep-2015.) $)
    metdsge $p |- ( ( ( D e. ( *Met ` X ) /\ S C_ X /\ A e. X ) /\ R e. RR* )
      -> ( R <_ ( F ` A ) <-> ( S i^i ( A ( ball ` D ) R ) ) = (/) ) ) $=
      ( vz vw cfv wcel cxr cle wbr cv co wral wb cxmt wss w3a cmpt crn clt ccnv
      csup cbl cin wceq simpl3 metdsval syl breq2d simpll1 adantr simpl2 sselda
      wa c0 wf xmetcl syl3anc oveq2 cbvmptv fmptd frn simpr infmxrgelb wn elbl2
      syl2anc syl22anc xrltnle bitrd con2bid ralbidva ovex rgenw breq2 ralrnmpt
      cvv ax-mp disj 3bitr4g 3bitrd ) DHUALMZFHUBZCHMZUCZENMZUTZECGLZOPEBFCBQZD
      RZUDZUEZNUFUGUHZOPZEJQZOPZJWRSZFCEDUILRZUJVAUKZWMWNWSEOWMWJWNWSUKWHWIWJWL
      ULZABCDFGHIUMUNUOWMWRNUBZWLWTXCTWMFNWQVBXGWMKFCKQZDRZNWQWMXHFMZUTZWHWJXHH
      MZXINMZWHWIWJWLXJUPZWMWJXJXFUQZWMFHXHWHWIWJWLURUSZCXHDHVCVDZBKFWPXIWOXHCD
      VEVFZVGFNWQVHUNWKWLVIZJWREVJVMWMEXIOPZKFSZXHXDMZVKZKFSXCXEWMXTYCKFXKYBXTX
      KYBXIEUFPZXTVKZXKWHWLWJXLYBYDTXNWMWLXJXSUQZXOXPXHDCEHVLVNXKXMWLYDYETXQYFX
      IEVOVMVPVQVRXIWCMZKFSXCYATYGKFCXHDVSVTXBXTKJFXIWQWCXRXAXIEOWAWBWDKFXDWEWF
      WG $.

    $( If a point is in a set, its distance to the set is zero.  (Contributed
       by Mario Carneiro, 14-Feb-2015.)  (Revised by Mario Carneiro,
       4-Sep-2015.) $)
    metds0 $p |- ( ( D e. ( *Met ` X ) /\ S C_ X /\ A e. S ) ->
        ( F ` A ) = 0 ) $=
      ( cfv wcel cc0 wbr wceq co c0 cle cxr syl wb adantr cxmt wss w3a clt cpnf
      wn cbl cin cicc wf metdsf 3adant3 3adant1 ffvelrnd elxrge0 simplbi xrleid
      ssel2 simp1 simp2 metdsge syl31anc mpbid wa simpl3 simpr syl112anc inelcm
      wne xblcntr syl2anc ex necon2bd mpd wo simprbi 0xr xrleloe sylancr eqcomd
      ord ) DGUAIJZEGUBZCEJZUCZKCFIZWEKWFUDLZUFZKWFMZWEECWFDUGINZUHZOMZWHWEWFWF
      PLZWLWEWFQJZWMWEWFKUEUINZJZWNWEGWOCFWBWCGWOFUJWDABDEFGHUKULWCWDCGJZWBEGCU
      RUMZUNZWPWNKWFPLZWFUOZUPRZWFUQRWEWBWCWQWNWMWLSWBWCWDUSZWBWCWDUTWRXBABCDWF
      EFGHVAVBVCWEWGWKOWEWGWKOVIZWEWGVDZWDCWJJZXDWBWCWDWGVEXEWBWQWNWGXFWEWBWGXC
      TWEWQWGWRTWEWNWGXBTWEWGVFDCWFGVJVGCEWJVHVKVLVMVNWEWGWIWEWTWGWIVOZWEWPWTWS
      WPWNWTXAVPRWEKQJWNWTXGSVQXBKWFVRVSVCWAVNVT $.

    $( A generalization of the triangle inequality to the point-set distance
       function.  Under the usual notation where the same symbol ` d ` denotes
       the point-point and point-set distance functions, this theorem would be
       written ` d ( a , S ) <_ d ( a , b ) + d ( b , S ) ` .  (Contributed by
       Mario Carneiro, 4-Sep-2015.) $)
    metdstri $p |- ( ( ( D e. ( *Met ` X ) /\ S C_ X ) /\
      ( A e. X /\ B e. X ) ) -> ( F ` A ) <_ ( ( A D B ) +e ( F ` B ) ) ) $=
      ( wcel wa co cle wbr c0 wceq cpnf syl2anc adantr syl cxmt cfv wss cbl cin
      cxad cxne cmin simprr simprl rexsub oveq2d resubcld leidd xmetsym syl3anc
      cr simpll eqcomd recnd nncand 3brtr4d blss2 syl33anc eqsstrd expr cxr cc0
      cicc metdsf ffvelrnd elxrge0 simplbi xmetcl xnegcld xaddcld adantrr pnfxr
      wf a1i pnfge ssbl syl221anc xblpnf mpbir2and blpnfctr eqtr2d sseqtrd cmnf
      wb wne wo simprbi ge0nemnf jca xrnemnf sylib mpjaod clt wn pnfnlt xposdif
      xbln0 breq1 sylan9bb necon1bbid mpbid 0ss syl6eqss xmetge0 mpjaodan sslin
      bitr4d xrleid simplr metdsge syl31anc mpbird xlesubadd xaddcom breqtrd
      sseq0 ) EHUAUBJZFHUCZKZCHJZDHJZKZKZCGUBZDGUBZCDELZUFLZYLYKUFLZMYIYJYLUGZU
      FLZYKMNZYJYMMNZYIYQFDYPEUDUBZLZUEZOPZYIUUAFCYJYSLZUEZUCZUUDOPZUUBYIYTUUCU
      CZUUEYIYLUQJZUUGYLQPZYIUUHKZYJUQJZUUGYJQPZYIUUHUUKUUGYIUUHUUKKZKZYTDYJYLU
      HLZYSLZUUCUUNYPUUODYSUUNUUKUUHYPUUOPYIUUHUUKUIZYIUUHUUKUJZYJYLUKRULUUNYCY
      GYFUUOUQJUUKDCELZYJUUOUHLZMNUUPUUCUCYIYCUUMYCYDYHURZSYIYGUUMYEYFYGUIZSYIY
      FUUMYEYFYGUJZSUUNYJYLUUQUURUMUUQUUNYLYLUUSUUTMUUNYLUURUNUUNYLUUSYIYLUUSPZ
      UUMYIYCYFYGUVDUVAUVCUVBCDEHUOUPSUSUUNYJYLUUNYJUUQUTUUNYLUURUTVAVBEDCUUOYJ
      HVCVDVEVFYIUUHUULUUGYIUUHUULKZKZYTDQYSLZUUCUVFYCYGYPVGJZQVGJZYPQMNZYTUVGU
      CYIYCUVEUVASZYIYGUVEUVBSZYIUUHUVHUULUUJYJYOYIYJVGJZUUHYIYJVHQVILZJZUVMYIH
      UVNCGYEHUVNGVSYHABEFGHIVJSZUVCVKZUVOUVMVHYJMNZYJVLZVMTZSUUJYLYIYLVGJZUUHY
      IYCYFYGUWAUVAUVCUVBCDEHVNUPZSVOVPVQZUVIUVFVRVTUVFUVHUVJUWCYPWATEDYPQHWBWC
      UVFUUCCQYSLZUVGUVFYJQCYSYIUUHUULUIULUVFYCYFDUWDJZUWDUVGPUVKYIYFUVEUVCSZUV
      FUWEYGUUHUVLYIUUHUULUJUVFYCYFUWEYGUUHKWJUVKUWFDECHWDRWEDECHWFUPWGWHVFUUJU
      VMYJWIWKZKZUUKUULWLYIUWHUUHYIUVMUWGUVTYIUVMUVRUWGUVTYIUVOUVRUVQUVOUVMUVRU
      VSWMTZYJWNRWOSYJWPWQWRYIUUIKZYTOUUCUWJQYJWSNZWTZYTOPYIUWLUUIYIUVMUWLUVTYJ
      XATSUWJUWKYTOYIYTOWKZYLYJWSNZUUIUWKYIUWMVHYPWSNZUWNYIYCYGUVHUWMUWOWJUVAUV
      BYIYJYOUVTYIYLUWBVOVPZEDYPHXCUPYIUWAUVMUWNUWOWJUWBUVTYLYJXBRXMYLQYJWSXDXE
      XFXGUUCXHXIYIUWAYLWIWKZKUUHUUIWLYIUWAUWQUWBYIUWAVHYLMNZUWQUWBYIYCYFYGUWRU
      VAUVCUVBCDEHXJUPYLWNRZWOYLWPWQXKYTUUCFXLTYIYJYJMNZUUFYIUVMUWTUVTYJXNTYIYC
      YDYFUVMUWTUUFWJUVAYCYDYHXOZUVCUVTABCEYJFGHIXPXQXGUUAUUDYBRYIYCYDYGUVHYQUU
      BWJUVAUXAUVBUWPABDEYPFGHIXPXQXRYIUVMUWAYKVGJZUVRUWQVHYKMNZYQYRWJUVTUWBYIY
      KUVNJZUXBYIHUVNDGUVPUVBVKZUXDUXBUXCYKVLZVMTZUWIUWSYIUXDUXCUXEUXDUXBUXCUXF
      WMTYJYLYKXSVDXGYIUXBUWAYMYNPUXGUWBYKYLXTRYA $.

    $( The distance from a point to a set is bounded by the distance to any
       member of the set.  (Contributed by Mario Carneiro, 5-Sep-2015.) $)
    metdsle $p |- ( ( ( D e. ( *Met ` X ) /\ S C_ X ) /\
      ( A e. S /\ B e. X ) ) -> ( F ` B ) <_ ( A D B ) ) $=
      ( cxmt cfv wcel wa co cxad cle adantrr cc0 wceq syl3anc wss simprr sselda
      wbr simpr jca metdstri syldan simpll xmetsym metds0 3expa oveq12d xaddid1
      cxr xmetcl syl eqtrd breqtrd ) EHJKLZFHUAZMZCFLZDHLZMZMZDGKZDCENZCGKZONZC
      DENZPVBVEVDCHLZMVGVJPUDVFVDVLVBVCVDUBZVBVCVLVDVBFHCUTVAUEUCQZUFABDCEFGHIU
      GUHVFVJVKRONZVKVFVHVKVIROVFUTVDVLVHVKSUTVAVEUIZVMVNDCEHUJTVBVCVIRSZVDUTVA
      VCVQABCEFGHIUKULQUMVFVKUOLZVOVKSVFUTVLVDVRVPVNVMCDEHUPTVKUNUQURUS $.

    $( The distance from a point to a nonempty set in a proper metric space is
       a real number.  (Contributed by Mario Carneiro, 5-Sep-2015.) $)
    metdsre $p |- ( ( D e. ( Met ` X ) /\ S C_ X /\ S =/= (/) ) ->
       F : X --> RR ) $=
      ( vz vw cfv wcel cr wf cv wa cc0 co adantr syl cle cme wss c0 wne wex wfn
      n0 wral cpnf cicc cxmt metxmet metdsf ffn cxr wbr simprr ffvelrnd elxrge0
      sylan simplbi simpll simpr sselda adantrr syl3anc simprbi metdsle sylanl1
      metcl xrrege0 syl22anc anassrs ralrimiva ffnfv sylanbrc ex exlimdv syl5bi
      3impia ) CFUAJKZDFUBZDUCUDZFLEMZWCHNZDKZHUEWAWBOZWDHDUGWGWFWDHWGWFWDWGWFO
      ZEFUFZINZEJZLKZIFUHWDWHFPUIUJQZEMZWIWGWNWFWACFUKJKZWBWNCFULZABCDEFGUMUTZR
      FWMEUNSWHWLIFWGWFWJFKZWLWGWFWROZOZWKUOKZWEWJCQZLKZPWKTUPZWKXBTUPZWLWTWKWM
      KZXAWTFWMWJEWGWNWSWQRWGWFWRUQZURZXFXAXDWKUSZVASWTWAWEFKZWRXCWAWBWSVBWGWFX
      JWRWGDFWEWAWBVCVDVEXGWEWJCFVJVFWTXFXDXHXFXAXDXIVGSWAWOWBWSXEWPABWEWJCDEFG
      VHVIWKXBVKVLVMVNIFLEVOVPVQVRVSVT $.

    metdscn.j $e |- J = ( MetOpen ` D ) $.
    $( The distance from a point to a set is zero iff the point is in the
       closure set.  (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    metdseq0 $p |- ( ( D e. ( *Met ` X ) /\ S C_ X /\ A e. X ) ->
      ( ( F ` A ) = 0 <-> A e. ( ( cls ` J ) ` S ) ) ) $=
      ( cfv wcel cc0 wceq wa cin c0 syl cle wbr vz vr cxmt wss w3a ccl wne wral
      cv wi cbl co crp wrex simpll1 simprl simprr mopni2 syl3anc ssrin wn rpgt0
      clt cr wb 0re rpre ltnle sylancr mpbid ad2antrl simpllr breq2d cxr adantr
      simpl2 ad2antrr simpl3 rpxr metdsge bitr3d incom eqeq1i syl6bb necon3bbid
      syl31anc ssn0 syl2anc rexlimddv expr ralrimiva ctop cuni ctopon mopntopon
      3ad2ant1 topontop toponuni sseqtrd eleqtrd eqid elcls cpnf cicc ffvelrnda
      mpbird metdsf 3impa elxrge0 simplbi xrleid syl5eq simpll2 simpll3 xblcntr
      mpdan simplr blopn simpr syl112anc clsndisj syl32anc necon2bd mpd simprbi
      ex wo 0xr xrleloe ord eqcomd impbida ) DHUCKLZEHUDZCHLZUEZCFKZMNZCEGUFKKL
      ZYPYROZYSCUAUIZLZUUAEPZQUGZUJZUAGUHZYTUUEUAGYTUUAGLZUUBUUDYTUUGUUBOZOZCUB
      UIZDUKKZULZUUAUDZUUDUBUMUUIYMUUGUUBUUMUBUMUNYMYNYOYRUUHUOZYTUUGUUBUPYTUUG
      UUBUQUBUUADCGHJURUSUUIUUJUMLZUUMOZOZUULEPZUUCUDZUURQUGZUUDUUQUUMUUSUUIUUO
      UUMUQUULUUAEUTRUUQUUJMSTZVAZUUTUUOUVBUUIUUMUUOMUUJVCTZUVBUUJVBUUOMVDLUUJV
      DLUVCUVBVEVFUUJVGMUUJVHVIVJVKUUQUVAUURQUUQUVAEUULPZQNZUURQNUUQUUJYQSTZUVA
      UVEUUQYQMUUJSYPYRUUHUUPVLVMUUQYMYNYOUUJVNLZUVFUVEVEUUIYMUUPUUNVOYTYNUUHUU
      PYMYNYOYRVPZVQYTYOUUHUUPYMYNYOYRVRZVQUUOUVGUUIUUMUUJVSVKABCDUUJEFHIVTWFWA
      UVDUURQEUULWBWCWDWEVJUURUUCWGWHWIWJWKYTGWLLZEGWMZUDZCUVKLYSUUFVEYTGHWNKLZ
      UVJYPUVMYRYMYNUVMYODGHJWOWPZVOZHGWQZRYTEHUVKUVHYTUVMHUVKNZUVOHGWRZRZWSYTC
      HUVKUVIUVSWTUACEGUVKUVKXAZXBUSXFYPYSOZMYQUWAMYQVCTZVAZMYQNZUWACYQUUKULZEP
      ZQNZUWCYPUWGYSYPUWFEUWEPZQUWEEWBYPYQYQSTZUWHQNZYPYQVNLZUWIYPYQMXCXDULZLZU
      WKYMYNYOUWMYMYNOHUWLCFABDEFHIXGXEXHZUWMUWKMYQSTZYQXIZXJRZYQXKRYPUWKUWIUWJ
      VEUWQABCDYQEFHIVTXPVJXLVOUWAUWBUWFQUWAUWBUWFQUGZUWAUWBOZUVJUVLYSUWEGLZCUW
      ELZUWRUWSUVMUVJYPUVMYSUWBUVNVQZUVPRUWSEHUVKYMYNYOYSUWBXMUWSUVMUVQUXBUVRRW
      SYPYSUWBXQUWSYMYOUWKUWTYMYNYOYSUWBUOZYMYNYOYSUWBXNZYPUWKYSUWBUWQVQZDCYQGH
      JXRUSUWSYMYOUWKUWBUXAUXCUXDUXEUWAUWBXSDCYQHXOXTCEUWEGUVKUVTYAYBYFYCYDUWAU
      WBUWDYPUWBUWDYGZYSYPUWOUXFYPUWMUWOUWNUWMUWKUWOUWPYERYPMVNLUWKUWOUXFVEYHUW
      QMYQYIVIVJVOYJYDYKYL $.

    ${
      metdscn.c $e |- C = ( dist ` RR*s ) $.
      metdscn.k $e |- K = ( MetOpen ` C ) $.
      ${
        metdscnlem.1 $e |- ( ph -> D e. ( *Met ` X ) ) $.
        metdscnlem.2 $e |- ( ph -> S C_ X ) $.
        metdscnlem.3 $e |- ( ph -> A e. X ) $.
        metdscnlem.4 $e |- ( ph -> B e. X ) $.
        metdscnlem.5 $e |- ( ph -> R e. RR+ ) $.
        metdscnlem.6 $e |- ( ph -> ( A D B ) < R ) $.
        $( Lemma for ~ metdscn .  (Contributed by Mario Carneiro,
           4-Sep-2015.) $)
        metdscnlem $p |- ( ph -> ( ( F ` A ) +e -e ( F ` B ) ) < R ) $=
          ( cfv cxne cxad co cc0 cpnf cicc wcel cxr cxmt wss wf metdsf ffvelrnd
          syl2anc cle wbr elxrge0 simplbi xnegcld xaddcld xmetcl rpxrd metdstri
          syl syl3anc syl22anc cmnf simprbi ge0nemnf xmetge0 xlesubadd syl33anc
          wne wb mpbird xrlelttrd ) ADJUDZEJUDZUEZUFUGZDEGUGZHAWAWCAWAUHUIUJUGZ
          UKZWAULUKZAMWFDJAGMUMUDUKZIMUNZMWFJUORSBCGIJMNUPURZTUQZWGWHUHWAUSUTZW
          AVAZVBVHZAWBAWBWFUKZWBULUKZAMWFEJWKUAUQZWPWQUHWBUSUTZWBVAZVBVHZVCVDAW
          IDMUKZEMUKZWEULUKZRTUADEGMVEVIZAHUBVFAWDWEUSUTZWAWEWBUFUGUSUTZAWIWJXB
          XCXGRSTUABCDEGIJMNVGVJAWHWQXDWMWBVKVQZUHWEUSUTZXFXGVRWOXAXEAWGWMWLWGW
          HWMWNVLVHAWQWSXHXAAWPWSWRWPWQWSWTVLVHWBVMURAWIXBXCXIRTUADEGMVNVIWAWBW
          EVOVPVSUCVT $.
      $}

      $( The function ` F ` which gives the distance from a point to a set is a
         continuous function into the metric topology of the extended reals.
         (Contributed by Mario Carneiro, 14-Feb-2015.)  (Revised by Mario
         Carneiro, 4-Sep-2015.) $)
      metdscn $p |- ( ( D e. ( *Met ` X ) /\ S C_ X ) ->
          F e. ( J Cn K ) ) $=
        ( vw wcel wa co cxr clt wbr vz vs vr cxmt cfv wss ccn wf cv wi wral crp
        wrex cc0 cpnf cicc metdsf iccssxr fss sylancl simprr cle cxne cxad wceq
        ad2antrr simplrl simprl syl2anc simplll simpllr simplrr xmetsym syl3anc
        ffvelrnd xrsdsval eqbrtrd metdscnlem breq1 ifboth expr ralrimiva imbi1d
        cif breq2 ralbidv rspcev ralrimivva wb simpl xrsxmet metcn mpbir2and )
        DIUDUEOZEIUFZPZFGHUGQOZIRFUHZUAUIZNUIZDQZUBUIZSTZWSFUEZWTFUEZCQZUCUIZST
        ZUJZNIUKZUBULUMZUCULUKUAIUKZWPIUNUOUPQZFUHXMRUFWRABDEFIJUQUNUOURIXMRFUS
        UTZWPXKUAUCIULWPWSIOZXGULOZPZPZXPXAXGSTZXHUJZNIUKZXKWPXOXPVAXRXTNIXRWTI
        OZXSXHXRYBXSPZPZXFXDXEVBTZXEXDVCVDQZXDXEVCVDQZWDZXGSYDXDROXEROXFYHVEYDI
        RWSFWPWRXQYCXNVFZWPXOXPYCVGZVOYDIRWTFYIXRYBXSVHZVOXDXECLVPVIYDYFXGSTZYG
        XGSTZYHXGSTZYDABWTWSCDXGEFGHIJKLMWNWOXQYCVJZWNWOXQYCVKZYKYJWPXOXPYCVLZY
        DWTWSDQZXAXGSYDWNYBXOYRXAVEYOYKYJWTWSDIVMVNXRYBXSVAZVQVRYDABWSWTCDXGEFG
        HIJKLMYOYPYJYKYQYSVRYEYLYMYNYFYGYFYHXGSVSYGYHXGSVSVTVIVQWAWBXJYAUBXGULX
        BXGVEZXIXTNIYTXCXSXHXBXGXASWEWCWFWGVIWHWPWNCRUDUEOWQWRXLPWIWNWOWJCLWKUA
        UCUBNDCFGHIRKMWLUTWM $.
    $}

    ${
      metdscn2.k $e |- K = ( TopOpen ` CCfld ) $.
      $( The function ` F ` which gives the distance from a point to a nonempty
         set in a metric space is a continuous function into the topology of
         the complexes.  (Contributed by Mario Carneiro, 5-Sep-2015.) $)
      metdscn2 $p |- ( ( D e. ( Met ` X ) /\ S C_ X /\ S =/= (/) ) ->
          F e. ( J Cn K ) ) $=
        ( cfv wcel wss cmopn cr co ccn eqid cxr cme wne w3a cxrs cds crest cioo
        c0 crn ctg cxp cres xrsdsre cxmt wceq xrsxmet ressxr mp2an tgioo tgioo2
        metrest eqtr3i oveq2i ctop cnfldtop ax-mp eqsstri metxmet metdscn sylan
        cnrest2r 3adant3 wf wb metdsre frn mopntopon cnrest2 mp3an13 3syl mpbid
        ctopon sseldi ) CHUALMZDHNZDUHUBZUCZFUDUELZOLZPUFQZRQZFGRQZEWKFGPUFQZRQ
        ZWLWJWMFRUGUIUJLWJWMWHPPUKULZWJWHWHSZUMWHTUNLMZPTNZWJWOOLZUOWHWPUPZUQWH
        WOWIWSTPWOSWISZWSSVAURUSGKUTVBVCGVDMWNWLNGKVEPFGVKVFVGWGEFWIRQMZEWKMZWD
        WEXBWFWDCHUNLMWEXBCHVHABWHCDEFWIHIJWPXAVIVJVLWGHPEVMEUIPNZXBXCVNZABCDEH
        IVOHPEVPWITWBLMZXDWRXEWQXFWTWHWITXAVQVFUQPEFWITVRVSVTWAWC $.
    $}

    metnrmlem.1 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    metnrmlem.2 $e |- ( ph -> S e. ( Clsd ` J ) ) $.
    metnrmlem.3 $e |- ( ph -> T e. ( Clsd ` J ) ) $.
    metnrmlem.4 $e |- ( ph -> ( S i^i T ) = (/) ) $.
    $( Lemma for ~ metnrm .  (Contributed by Mario Carneiro, 14-Jan-2014.)
       (Revised by Mario Carneiro, 4-Sep-2015.) $)
    metnrmlem1a $p |- ( ( ph /\ A e. T ) ->
      ( 0 < ( F ` A ) /\ if ( 1 <_ ( F ` A ) , 1 , ( F ` A ) ) e. RR+ ) ) $=
      ( wcel cc0 wbr c1 wa cfv clt cle cif crp wceq cin c0 wn adantr wne inelcm
      wi expcom adantl necon2bd mpd ccl eqcom cxmt wss cuni ccld eqid cldss syl
      mopnuni sseqtr4d simpr sseldd metdseq0 syl3anc syl5bb cldcls eleq2d bitrd
      wb mtbird wo cpnf cicc co metdsf syl2anc ffvelrnd cxr elxrge0 simprbi 0xr
      wf simplbi xrleloe sylancr mpbid ord mt3d 1re rexri ifcl a1i breq2 ifboth
      cr 0lt1 xrltle xrmin1 xrrege0 syl22anc elrpd jca ) ADGQZUAZRDHUBZUCSZTXNU
      DSZTXNUEZUFQXMXORXNUGZXMXRDFQZXMFGUHZUIUGZXSUJAYAXLPUKXMXSXTUIXLXSXTUIULZ
      UNAXSXLYBDFGUMUOUPUQURXMXRDFIUSUBUBZQZXSXRXNRUGZXMYDRXNUTXMEJVAUBQZFJVBZD
      JQYEYDVRAYFXLMUKZXMFIVCZJXMFIVDUBZQZFYIVBAYKXLNUKZFIYIYIVEZVFVGXMYFJYIUGY
      HEIJLVHVGZVIZXMGJDXMGYIJXMGYJQZGYIVBAYPXLOUKGIYIYMVFVGYNVIAXLVJVKZBCDEFHI
      JKLVLVMVNXMYCFDXMYKYCFUGYLFIVOVGVPVQVSXMXOXRXMRXNUDSZXOXRVTZXMXNRWAWBWCZQ
      ZYRXMJYTDHXMYFYGJYTHWKYHYOBCEFHJKWDWEYQWFZUUAXNWGQZYRXNWHZWIVGXMRWGQZUUCY
      RYSVRWJXMUUAUUCUUBUUAUUCYRUUDWLVGZRXNWMWNWOWPWQZXMXQXMXQWGQZTXDQZRXQUDSZX
      QTUDSZXQXDQXMTWGQZUUCUUHTWRWSZUUFXPTXNWGWTWNZUUIXMWRXAXMRXQUCSZUUJXMRTUCS
      ZXOUUOXEUUGXPUUPXOUUOTXNTXQRUCXBXNXQRUCXBXCWNZXMUUEUUHUUOUUJUNWJUUNRXQXFW
      NURXMUULUUCUUKUUMUUFTXNXGWNXQTXHXIUUQXJXK $.

    $( Lemma for ~ metnrm .  (Contributed by Mario Carneiro, 14-Jan-2014.)
       (Revised by Mario Carneiro, 4-Sep-2015.) $)
    metnrmlem1 $p |- ( ( ph /\ ( A e. S /\ B e. T ) ) ->
                       if ( 1 <_ ( F ` B ) , 1 , ( F ` B ) ) <_ ( A D B ) ) $=
      ( wcel c1 cle wa cfv wbr cif co cxr 1re rexri cc0 cpnf cicc wss wf adantr
      cxmt cuni ccld eqid cldss syl wceq mopnuni sseqtr4d metdsf syl2anc simprr
      sseldd ffvelrnd elxrge0 simplbi ifcl sylancr simprl xmetcl syl3anc xrmin2
      metdstri syl22anc xmetsym metds0 oveq12d xaddid1 eqtrd breqtrd xrletrd
      cxad ) ADGRZEHRZUAZUAZSEIUBZTUCZSWKUDZWKDEFUEZWJSUFRZWKUFRZWMUFRSUGUHZWJW
      KUIUJUKUEZRZWPWJKWREIWJFKUOUBRZGKULZKWRIUMAWTWINUNZWJGJUPZKWJGJUQUBZRZGXC
      ULAXEWIOUNGJXCXCURZUSUTWJWTKXCVAXBFJKMVBUTZVCZBCFGIKLVDVEWJHKEWJHXCKWJHXD
      RZHXCULAXIWIPUNHJXCXFUSUTXGVCAWGWHVFVGZVHWSWPUIWKTUCWKVIVJUTZWLSWKUFVKVLX
      KWJWTDKRZEKRZWNUFRZXBWJGKDXHAWGWHVMZVGZXJDEFKVNVOZWJWOWPWMWKTUCWQXKSWKVPV
      LWJWKEDFUEZDIUBZWFUEZWNTWJWTXAXMXLWKXTTUCXBXHXJXPBCEDFGIKLVQVRWJXTWNUIWFU
      EZWNWJXRWNXSUIWFWJWTXMXLXRWNVAXBXJXPEDFKVSVOWJWTXAWGXSUIVAXBXHXOBCDFGIKLV
      TVOWAWJXNYAWNVAXQWNWBUTWCWDWE $.

    metnrmlem.u $e |- U = U_ t e. T ( t ( ball ` D )
      ( if ( 1 <_ ( F ` t ) , 1 , ( F ` t ) ) / 2 ) ) $.
    $( Lemma for ~ metnrm .  (Contributed by Mario Carneiro, 14-Jan-2014.)
       (Revised by Mario Carneiro, 5-Sep-2015.) $)
    metnrmlem2 $p |- ( ph -> ( U e. J /\ T C_ U ) ) $=
      ( wcel wss cv c1 cfv cle wbr cif cdiv cbl ciun ctop wral cxmt mopntop syl
      c2 co wa cxr adantr cuni ccld eqid cldss wceq mopnuni sseqtr4d sselda cc0
      clt crp metnrmlem1a simprd rphalfcld rpxrd blopn syl3anc ralrimiva iunopn
      syl2anc syl5eqel csn blcntr snssd ss2iun iunid eqcomi 3sstr4g jca ) AHJSG
      HTAHDGDUAZUBWIIUCZUDUEUBWJUFZUOUGUPZEUHUCUPZUIZJRAJUJSZWMJSZDGUKWNJSAEKUL
      UCSZWONEJKMUMUNAWPDGAWIGSZUQZWQWIKSZWLURSWPAWQWRNUSZAGKWIAGJUTZKAGJVAUCSG
      XBTPGJXBXBVBVCUNAWQKXBVDNEJKMVEUNVFVGZWSWLWSWKWSVHWJVIUEWKVJSABCWIEFGIJKL
      MNOPQVKVLVMZVNEWIWLJKMVOVPVQDGWMJVRVSVTADGWIWAZUIZWNGHAXEWMTZDGUKXFWNTAXG
      DGWSWIWMWSWQWTWLVJSWIWMSXAXCXDEWIWLKWBVPWCVQDGXEWMWDUNXFGDGWEWFRWGWH $.

    metnrmlem.g $e |- G = ( x e. X |->
      sup ( ran ( y e. T |-> ( x D y ) ) , RR* , `' < ) ) $.
    metnrmlem.v $e |- V = U_ s e. S ( s ( ball ` D )
      ( if ( 1 <_ ( G ` s ) , 1 , ( G ` s ) ) / 2 ) ) $.
    $( Lemma for ~ metnrm .  (Contributed by Mario Carneiro, 14-Jan-2014.)
       (Revised by Mario Carneiro, 5-Sep-2015.) $)
    metnrmlem3 $p |- ( ph -> E. z e. J E. w e. J
                       ( S C_ z /\ T C_ w /\ ( z i^i w ) = (/) ) ) $=
      ( wcel wss cin c0 wceq w3a wrex incom syl5eq metnrmlem2 simpld simprd cfv
      cv c1 cle wbr cif c2 cdiv co cbl ciun ineq1i iunin1 eqtr4i wral wa ineq2i
      iunin2 cxmt cxr cxad adantr cuni ccld eqid cldss mopnuni sseqtr4d adantrr
      syl sselda adantrl crp cc0 clt metnrmlem1a rphalfcld rpxrd caddc cr rpred
      rehalfcld rexadd syl2anc recnd 2cn a1i wne 2ne0 divdird eqtr4d metnrmlem1
      cc cxmu ancom2s xmetsym syl3anc breqtrd wi xmetcl xle2add syl22anc mp2and
      readdcld divcan2d 2re rexmul sylancr 3eqtr4d x2times 3brtr4d wb rexrd 2rp
      cmul xlemul2 mpbird eqbrtrd ralrimiva iunss sylibr sseq2 eqeq1d ss0 ineq1
      bldisj syl33anc eqimss anassrs syl5eqss 3anbi13d ineq2 3anbi23d syl113anc
      rspc2ev ) ANMUFZJMUFZHNUGZIJUGZNJUHZUIUJZHDUSZUGZIEUSZUGZUUSUVAUHZUIUJZUK
      ZEMULDMULAUUMUUOABCPGIHNLMOUDRSUATAIHUHHIUHUIIHUMUBUNZUEUOZUPAUUNUUPABCFG
      HIJKMOQRSTUAUBUCUOZUPAUUMUUOUVGUQAUUNUUPUVHUQAUUQPHPUSZUTUVILURZVAVBUTUVJ
      VCZVDVEVFZGVGURZVFZJUHZVHZUIUUQPHUVNVHZJUHUVPNUVQJUEVIPHJUVNVJVKAUVPUIUGZ
      UVPUIUJAUVOUIUGZPHVLUVRAUVSPHAUVIHUFZVMZUVOFIUVNFUSZUTUWBKURZVAVBUTUWCVCZ
      VDVEVFZUVMVFZUHZVHZUIUVOUVNFIUWFVHZUHUWHJUWIUVNUCVNFIUVNUWFVOVKUWAUWGUIUG
      ZFIVLUWHUIUGUWAUWJFIAUVTUWBIUFZUWJAUVTUWKVMZVMZUWGUIUJZUWJUWMGOVPURUFZUVI
      OUFZUWBOUFZUVLVQUFUWEVQUFUVLUWEVRVFZUVIUWBGVFZVAVBUWNAUWOUWLSVSZAUVTUWPUW
      KAHOUVIAHMVTZOAHMWAURZUFHUXAUGTHMUXAUXAWBZWCWGAUWOOUXAUJSGMORWDWGZWEWHWFZ
      AUWKUWQUVTAIOUWBAIUXAOAIUXBUFIUXAUGUAIMUXAUXCWCWGUXDWEWHWIZUWMUVLUWMUVKAU
      VTUVKWJUFZUWKUWAWKUVJWLVBUXGABCUVIGIHLMOUDRSUATUVFWMUQWFZWNWOUWMUWEUWMUWD
      UWMWKUWCWLVBZUWDWJUFZAUWKUXIUXJVMUVTABCUWBGHIKMOQRSTUAUBWMWIUQZWNWOUWMUWR
      UVKUWDWPVFZVDVEVFZUWSVAUWMUWRUVLUWEWPVFZUXMUWMUVLWQUFUWEWQUFUWRUXNUJUWMUV
      KUWMUVKUXHWRZWSUWMUWDUWMUWDUXKWRZWSUVLUWEWTXAUWMUVKUWDVDUWMUVKUXOXBUWMUWD
      UXPXBVDXJUFUWMXCXDZVDWKXEUWMXFXDZXGXHUWMUXMUWSVAVBZVDUXMXKVFZVDUWSXKVFZVA
      VBZUWMUVKUWDVRVFZUWSUWSVRVFZUXTUYAVAUWMUVKUWSVAVBZUWDUWSVAVBZUYCUYDVAVBZU
      WMUVKUWBUVIGVFZUWSVAAUWKUVTUVKUYHVAVBABCUWBUVIGIHLMOUDRSUATUVFXIXLUWMUWOU
      WQUWPUYHUWSUJUWTUXFUXEUWBUVIGOXMXNXOABCUVIUWBGHIKMOQRSTUAUBXIUWMUVKVQUFUW
      DVQUFUWSVQUFZUYIUYEUYFVMUYGXPUWMUVKUXHWOUWMUWDUXKWOUWMUWOUWPUWQUYIUWTUXEU
      XFUVIUWBGOXQXNZUYJUVKUWDUWSUWSXRXSXTUWMVDUXMYLVFZUXLUXTUYCUWMUXLVDUWMUXLU
      WMUVKUWDUXOUXPYAZXBUXQUXRYBUWMVDWQUFUXMWQUFUXTUYKUJYCUWMUXLUYLWSZVDUXMYDY
      EUWMUVKWQUFUWDWQUFUYCUXLUJUXOUXPUVKUWDWTXAYFUWMUYIUYAUYDUJUYJUWSYGWGYHUWM
      UXMVQUFUYIVDWJUFZUXSUYBYIUWMUXMUYMYJUYJUYNUWMYKXDUXMUWSVDYMXNYNYOGUVIUWBU
      VLUWEOUUCUUDUWGUIUUEWGUUFYPFIUWGUIYQYRUUGYPPHUVOUIYQYRUVPUUAWGUNUVEUUOUUP
      UURUKUUOUVBNUVAUHZUIUJZUKDENJMMUUSNUJZUUTUUOUVDUYPUVBUUSNHYSUYQUVCUYOUIUU
      SNUVAUUBYTUUHUVAJUJZUVBUUPUYPUURUUOUVAJIYSUYRUYOUUQUIUVAJNUUIYTUUJUULUUK
      $.
  $}

  ${
    $d s t u v w x y z D $.  $d s t v w x y z J $.  $d s t u v w x y z X $.
    metnrm.j $e |- J = ( MetOpen ` D ) $.
    $( A metric space is normal.  (Contributed by Jeff Hankins, 31-Aug-2013.)
       (Revised by Mario Carneiro, 5-Sep-2015.) $)
    metnrm $p |- ( D e. ( *Met ` X ) -> J e. Nrm ) $=
      ( vx vy vz vw vu vv vs vt cfv wcel cv cin c1 co cmpt eqid cxmt c0 wss w3a
      ctop wceq wrex wi ccld wral cnrm mopntop wa crn cxr clt ccnv csup cle wbr
      cif cdiv cbl ciun simp1 simp2l simp2r metnrmlem3 3expia ralrimivva isnrm3
      c2 simp3 sylanbrc ) ACUAMNZBUENEOZFOZPUBUFZVPGOZUCVQHOZUCVSVTPUBUFUDHBUGG
      BUGZUHZFBUIMZUJEWCUJBUKNABCDULVOWBEFWCWCVOVPWCNZVQWCNZUMZVRWAVOWFVRUDIJGH
      KAVPVQKVQKOZQWGICJVPIOJOARZSUNUOUPUQZURSZMZUSUTQWKVAVLVBRAVCMZRVDZWJICJVQ
      WHSUNUOWIURSZBLVPLOZQWOWNMZUSUTQWPVAVLVBRWLRVDZCLWJTDVOWFVRVEVOWDWEVRVFVO
      WDWEVRVGVOWFVRVMWMTWNTWQTVHVIVJGHBEFVKVN $.

    $( A metric space is regular.  (Contributed by Mario Carneiro,
       29-Dec-2016.) $)
    metreg $p |- ( D e. ( *Met ` X ) -> J e. Reg ) $=
      ( cxmt cfv wcel cnrm ct1 creg metnrm cha methaus haust1 nrmreg syl2anc
      syl ) ACEFGZBHGBIGZBJGABCDKRBLGSABCDMBNQBOP $.
  $}

  ${
    $d a b c u v w x y z J $.  $d u w x y z K $.  $d a b c u v x y z .+ $.
    addcn.j $e |- J = ( TopOpen ` CCfld ) $.
    ${
      addcn.2 $e |- .+ : ( CC X. CC ) --> CC $.
      addcn.3 $e |- ( ( a e. RR+ /\ b e. CC /\ c e. CC ) ->
      E. y e. RR+ E. z e. RR+ A. u e. CC A. v e. CC
        ( ( ( abs ` ( u - b ) ) < y /\ ( abs ` ( v - c ) ) < z ) ->
          ( abs ` ( ( u .+ v ) - ( b .+ c ) ) ) < a ) ) $.
      $( Lemma for ~ addcn , ~ subcn , and ~ mulcn .  (Contributed by Mario
         Carneiro, 5-May-2014.)  (Proof shortened by Mario Carneiro,
         2-Sep-2015.) $)
      addcnlem $p |- .+ e. ( ( J tX J ) Cn J ) $=
        ( co wcel cc clt wbr wa wral crp vx ctx ccn cxp wf cv cabs cmin ccom wi
        wrex w3a cfv 3coml cle ifcl adantl wceq simpll1 simprl cnmetdval abssub
        cif eqid eqtrd syl2anc breq1d cr wb subcld abscld simplrl rpred simplrr
        ltmin syl3anc bitrd simpl syl6bi simpll2 simprr anim12d biimprd imim12d
        simpr anassrs ralimdva anbi12d imbi1d 2ralbidv rspcev ee12an rexlimdvva
        fovcl breq2 mpd rgen3 cxmt cnxmet cnfldtopn txmetcn mp3an mpbir2an ) EF
        FUBMFUCMNZOOUDOEUEZHUFZDUFZUGUHUIZMZUAUFZPQZIUFZCUFZXHMZXJPQZRZXFXLEMZX
        GXMEMZXHMZGUFZPQZUJZCOSDOSZUATUKZGTSIOSHOSZKYDHIGOOTXFONZXLONZXTTNZULZX
        GXFUHMZUGUMZAUFZPQZXMXLUHMZUGUMZBUFZPQZRZXRXQUHMUGUMZXTPQZUJZCOSZDOSZBT
        UKATUKZYDYHYFYGUUDLUNYIUUCYDABTTYIYLTNZYPTNZRZRZYLYPUOQZYLYPVCZTNZUUCXI
        UUJPQZXNUUJPQZRZYAUJZCOSZDOSZYDUUGUUKYIUUIYLYPTUPUQUUHUUBUUPDOUUHXGONZR
        UUAUUOCOUUHUURXMONZUUAUUOUJUUHUURUUSRZRZUUNYRYTYAUVAUULYMUUMYQUVAUULYMY
        KYPPQZRZYMUVAUULYKUUJPQZUVCUVAXIYKUUJPUVAYFUURXIYKURYFYGYHUUGUUTUSZUUHU
        URUUSUTZYFUURRXIXFXGUHMUGUMYKXFXGXHXHVDZVAXFXGVBVEVFVGUVAYKVHNYLVHNZYPV
        HNZUVDUVCVIUVAYJUVAXGXFUVFUVEVJVKUVAYLYIUUEUUFUUTVLVMZUVAYPYIUUEUUFUUTV
        NVMZYKYLYPVOVPVQYMUVBVRVSUVAUUMYOYLPQZYQRZYQUVAUUMYOUUJPQZUVMUVAXNYOUUJ
        PUVAYGUUSXNYOURYFYGYHUUGUUTVTZUUHUURUUSWAZYGUUSRXNXLXMUHMUGUMYOXLXMXHUV
        GVAXLXMVBVEVFVGUVAYOVHNUVHUVIUVNUVMVIUVAYNUVAXMXLUVPUVOVJVKUVJUVKYOYLYP
        VOVPVQUVLYQWEVSWBUVAYAYTUVAXSYSXTPUVAXQONZXRONZXSYSURUVAYFYGUVQUVEUVOXF
        XLOOOEKWNVFUUTUVRUUHXGXMOOOEKWNUQUVQUVRRXSXQXRUHMUGUMYSXQXRXHUVGVAXQXRV
        BVEVFVGWCWDWFWGWGYCUUQUAUUJTXJUUJURZYBUUODCOOUVSXPUUNYAUVSXKUULXOUUMXJU
        UJXIPWOXJUUJXNPWOWHWIWJWKWLWMWPWQXHOWRUMNZUVTUVTXDXEYERVIWSWSWSHIGUACDX
        HXHXHEFFFOOOFJWTZUWAUWAXAXBXC $.
    $}

    $( Complex number addition is a continuous function.  Part of Proposition
       14-4.16 of [Gleason] p. 243.  (Contributed by NM, 30-Jul-2007.)  (Proof
       shortened by Mario Carneiro, 5-May-2014.) $)
    addcn $p |- + e. ( ( J tX J ) Cn J ) $=
      ( vy vz vv vu va vb vc caddc ax-addf cv addcn2 addcnlem ) CDEFJAGHIBKCDEF
      GLHLILMN $.

    $( Complex number subtraction is a continuous function.  Part of
       Proposition 14-4.16 of [Gleason] p. 243.  (Contributed by NM,
       4-Aug-2007.)  (Proof shortened by Mario Carneiro, 5-May-2014.) $)
    subcn $p |- - e. ( ( J tX J ) Cn J ) $=
      ( vy vz vv vu va vb vc cmin subf cv subcn2 addcnlem ) CDEFJAGHIBKCDEFGLHL
      ILMN $.

    $( Complex number multiplication is a continuous function.  Part of
       Proposition 14-4.16 of [Gleason] p. 243.  (Contributed by NM,
       30-Jul-2007.)  (Proof shortened by Mario Carneiro, 5-May-2014.) $)
    mulcn $p |- x. e. ( ( J tX J ) Cn J ) $=
      ( vy vz vv vu va vb vc cmul ax-mulf cv mulcn2 addcnlem ) CDEFJAGHIBKCDEFG
      LHLILMN $.

    divcn.k $e |- K = ( J |`t ( CC \ { 0 } ) ) $.
    $( Complex number division is a continuous function, when the second
       argument is nonzero.  (Contributed by Mario Carneiro, 12-Aug-2014.) $)
    divcn $p |- / e. ( ( J tX K ) Cn J ) $=
      ( vx vy vz vw vu cdiv cc cc0 c1 co cmul wcel wa wtru cfv cabs csn cdif cv
      cmpt2 ctx ccn wceq crio df-div wne eldifsn w3a divval divrec eqtr3d 3expb
      sylan2b mpt2eq3ia eqtri ctopon cnfldtopon a1i crest wss resttopon sylancl
      difss syl5eqel cnmpt1st cnmpt2nd cmpt cmin ccom cxp cres clt wbr wral crp
      wf wi wrex eqid reccl sylbi fmpti cle c2 reccn2 wb ovres eldifi cnmetdval
      cif abssub eqtrd syl2an breq1d oveq2 ovex fvmpt oveqan12d imbi12d rexbidv
      ralbidva adantr mpbird rgen2 cxmt cnxmet xmetres2 mp2an cnfldtopn metrest
      cmopn metcn mpbir2an cnmpt21 mulcn cnmpt22f trud eqeltri ) JEFKKLUAZUBZEU
      CZMFUCZJNZONZUDZABUENAUFNZJEFKYDYFGUCZONYEUGGKUHZUDYIEFGUIEFKYDYLYHYFYDPY
      EKPZYFKPZYFLUJZQYLYHUGZYFKLUKYMYNYOYPYMYNYOULYEYFJNYLYHGYEYFUMYEYFUNUOUPU
      QURUSYIYJPREFYEYGOABAAAKYDAKUTSPZRACVAVBZRBAYDVCNZYDUTSZDRYQYDKVDZYSYTPYR
      KYCVGZYDAKVEVFVHZREFABKYDYRUUCVIREFGYFMYKJNZYGABBAKYDYDYRUUCREFABKYDYRUUC
      VJUUCGYDUUDVKZBAUFNPZRUUFYDKUUEVTZYEHUCZTVLVMZYDYDVNVOZNZIUCZVPVQZYEUUESZ
      UUHUUESZUUINZYFVPVQZWAZHYDVRZIVSWBZFVSVREYDVRZGYDKUUDUUEUUEWCZYKYDPYKKPYK
      LUJQUUDKPYKKLUKYKWDWEWFUUTEFYDVSYEYDPZYFVSPZQUUTUUHYEVLNTSZUULVPVQZMUUHJN
      ZMYEJNZVLNTSZYFVPVQZWAZHYDVRZIVSWBZIHYEYFMYETSZYFONZWGVQMUVOWNUVNWHJNONZU
      VPWCWIUVCUUTUVMWJUVDUVCUUSUVLIVSUVCUURUVKHYDUVCUUHYDPZQZUUMUVFUUQUVJUVRUU
      KUVEUULVPUVRUUKYEUUHUUINZUVEYEUUHYDYDUUIWKUVCYMUUHKPZUVSUVEUGUVQYEKYCWLUU
      HKYCWLYMUVTQUVSYEUUHVLNTSUVEYEUUHUUIUUIWCZWMYEUUHWOWPWQWPWRUVRUUPUVIYFVPU
      VRUUPUVHUVGUUINZUVIUVCUVQUUNUVHUUOUVGUUIGYEUUDUVHYDUUEYKYEMJWSUVBMYEJWTXA
      GUUHUUDUVGYDUUEYKUUHMJWSUVBMUUHJWTXAXBUVCUVHKPZUVGKPZUWBUVIUGUVQUVCYMYELU
      JQUWCYEKLUKYEWDWEUVQUVTUUHLUJQUWDUUHKLUKUUHWDWEUWCUWDQUWBUVHUVGVLNTSUVIUV
      HUVGUUIUWAWMUVHUVGWOWPWQWPWRXCXEXDXFXGXHUUJYDXISPZUUIKXISPZUUFUUGUVAQWJUW
      FUUAUWEXJUUBUUIYDKXKXLXJEFIHUUJUUIUUEBAYDKBYSUUJXOSZDUWFUUAYSUWGUGXJUUBUU
      IUUJAUWGKYDUUJWCACXMZUWGWCXNXLUSUWHXPXLXQVBYKYFMJWSXROAAUENAUFNPRACXSVBXT
      YAYB $.
  $}

  $( The complex numbers form a topological group under addition, with the
     standard topology induced by the absolute value metric.  (Contributed by
     Mario Carneiro, 2-Sep-2015.) $)
  cnfldtgp $p |- CCfld e. TopGrp $=
    ( ccnfld ctgp wcel cgrp ctps ctopn cfv ctx co ccn crg cnrng rnggrp cnfldtps
    cmin ax-mp eqid subcn cnfldsub istgp2 mpbir3an ) ABCADCZAECOAFGZUCHIUCJICAK
    CUBLAMPNUCUCQZRAUCOUDSTUA $.

  ${
    $d k u v w x y z A $.  $d k v w x y z J $.  $d k z L $.  $d k w x y z ph $.
    $d k v w x y z K $.  $d k u v w x y z X $.  $d k u v w x y z Y $.
    $d u v w z B $.
    fsumcn.3 $e |- K = ( TopOpen ` CCfld ) $.
    fsumcn.4 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    fsumcn.5 $e |- ( ph -> A e. Fin ) $.
    ${
      $d y B $.
      fsumcn.6 $e |- ( ( ph /\ k e. A ) -> ( x e. X |-> B ) e. ( J Cn K ) ) $.
      $( A finite sum of functions to complex numbers from a common topological
         space is continuous.  The class expression for ` B ` normally contains
         free variables ` k ` and ` x ` to index it.  (Contributed by NM,
         8-Aug-2007.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
      fsumcn $p |- ( ph -> ( x e. X |-> sum_ k e. A B ) e. ( J Cn K ) ) $=
        ( vw wss cmpt wcel wi cc wa caddc vy vz csu ccn co ssid cfn cv csn wceq
        c0 cun sseq1 sumeq1 mpteq2dv eleq1d imbi12d imbi2d weq cc0 sum0 mpteq2i
        ctopon cfv cnfldtopon a1i 0cn cnmptc syl5eqel wn ssun1 sstr mpan imim1i
        a1d csb simplr disjsn sylibr eqidd ad2antrr simprl ssfi syl2anc simplll
        cin sselda simplrr wral adantr cnf2 syl3anc eqid fmpt rsp syl fsumsplit
        wf imp syl21anc simpr unssbd vex snss adantrr impancom ralrimiv nfcsb1v
        ad2ant2rl nfel1 csbeq1a rspc sylc sumsns oveq2d eqtrd anassrs mpteq2dva
        nfcv nfsum nfcsb nfov sumeq2sdv csbeq2dv cbvmpt syl6eq simprr syl5eqelr
        oveq12d ralrimiva nfmpt addcn cnmpt12f eqeltrd exp32 syl5 expcom adantl
        ctx a2d findcard2s mpcom mpi ) ACCNZBHCDEUCZOZFGUDUEZPZCUFCUGPZAUUDUUHQ
        ZKAMUHZCNZBHUUKDEUCZOZUUGPZQZQAUKCNZBHUKDEUCZOZUUGPZQZQAUAUHZCNZBHUVBDE
        UCZOZUUGPZQZQAUVBUBUHZUIZULZCNZBHUVJDEUCZOZUUGPZQZQAUUJQMUAUBCUUKUKUJZU
        UPUVAAUVPUULUUQUUOUUTUUKUKCUMUVPUUNUUSUUGUVPBHUUMUURUUKUKDEUNUOUPUQURMU
        AUSZUUPUVGAUVQUULUVCUUOUVFUUKUVBCUMUVQUUNUVEUUGUVQBHUUMUVDUUKUVBDEUNUOU
        PUQURUUKUVJUJZUUPUVOAUVRUULUVKUUOUVNUUKUVJCUMUVRUUNUVMUUGUVRBHUUMUVLUUK
        UVJDEUNUOUPUQURUUKCUJZUUPUUJAUVSUULUUDUUOUUHUUKCCUMUVSUUNUUFUUGUVSBHUUM
        UUEUUKCDEUNUOUPUQURAUUTUUQAUUSBHUTOUUGBHUURUTDEVAVBABUTFGHRJGRVCVDPZAGI
        VEZVFUTRPAVGVFVHVIVOUVBUGPZUVHUVBPVJZSAUVGUVOUWCAUVGUVOQZQUWBAUWCUWDUVG
        UVKUVFQAUWCSZUVOUVKUVCUVFUVBUVJNUVKUVCUVBUVIVKUVBUVJCVLVMVNUWEUVKUVFUVN
        UWEUVKUVFUVNUWEUVKUVFSZSZUVMMHUVBBUUKDVPZEUCZEUVHUWHVPZTUEZOZUUGUWGUVMB
        HUVDEUVHDVPZTUEZOZUWLUWEUVKUVMUWOUJUVFUWEUVKSZBHUVLUWNUWEUVKBUHHPZUVLUW
        NUJUWEUVKUWQSZSZUVLUVDUVIDEUCZTUEUWNUWSUVBUVIDUVJEUWSUWCUVBUVIWFUKUJAUW
        CUWRVQUVBUVHVRVSUWSUVJVTUWSUUIUVKUVJUGPAUUIUWCUWRKWAUWEUVKUWQWBZCUVJWCW
        DUWSEUHZUVJPZSAUXBCPZUWQDRPZAUWCUWRUXCWEUWSUVJCUXBUXAWGUWEUVKUWQUXCWHAU
        XDSZUWQUXEUXFUXEBHWIZUWQUXEQUXFHRBHDOZWRZUXGUXFFHVCVDPZUVTUXHUUGPZUXIAU
        XJUXDJWJUVTUXFUWAVFLUXHFGHRWKWLBHRDUXHUXHWMWNVSUXEBHWOWPZWSWTWQUWSUWTUW
        MUVDTUWSUVHCPZUWMRPZUWTUWMUJUWEUVKUXMUWQUWPUVICNUXMUWPUVBUVICUWEUVKXAXB
        UVHCUBXCXDVSZXEZUWSUXMUXEECWIZUXNUXPAUWQUXQUWCUVKAUWQSUXEECAUXDUWQUXEUX
        LXFXGXIUXEUXNEUVHCEUWMREUVHDXHZXJEUBUSZDUWMREUVHDXKZUPXLXMDEUVHCXNWDXOX
        PXQXRXEBMHUWNUWKMUWNXSBUWIUWJTBUVBUWHEBUVBXSBUUKDXHZXTZBTXSBEUVHUWHBUVH
        XSUYAYAZYBBMUSZUVDUWIUWMUWJTUYDUVBDUWHEBUUKDXKZYCZUYDEUVHDUWHUYEYDZYIYE
        YFUWGMUWIUWJTFGGGHAUXJUWCUWFJWAUWGMHUWIOUVEUUGBMHUVDUWIMUVDXSUYBUYFYEUW
        EUVKUVFYGYHUWGMHUWJOBHUWMOZUUGBMHUWMUWJMUWMXSUYCUYGYEUWGUXMUXKECWIZUYHU
        UGPZUWEUVKUXMUVFUXOXEAUYIUWCUWFAUXKECLYJWAUXKUYJEUVHCEUYHUUGEBHUWMEHXSU
        XRYKXJUXSUXHUYHUUGUXSBHDUWMUXTUOUPXLXMYHTGGYSUEGUDUEPUWGGIYLVFYMYNYOYTY
        PYQYRYTUUAUUBUUC $.
    $}

    fsum2cn.7 $e |- ( ph -> L e. ( TopOn ` Y ) ) $.
    fsum2cn.8 $e |- ( ( ph /\ k e. A ) ->
                     ( x e. X , y e. Y |-> B ) e. ( ( J tX L ) Cn K ) ) $.
    $( Version of ~ fsumcn for two-argument mappings.  (Contributed by Mario
       Carneiro, 6-May-2014.) $)
    fsum2cn $p |- ( ph -> ( x e. X , y e. Y |-> sum_ k e. A B ) e.
                          ( ( J tX L ) Cn K ) ) $=
      ( vz vu vv nfcv csu cmpt2 cxp cv c2nd cfv c1st csb cmpt ctx nfcsb1v nfcsb
      co ccn nfsum weq wa csbeq1a sylan9eq sumeq2sdv cbvmpt2 cop op2ndd csbeq1d
      wceq vex op1std csbeq2dv eqtrd mpt2mpt eqtr4i ctopon wcel txtopon syl2anc
      syl5eqelr fsumcn syl5eqel ) ABCJKDEFUAZUBZQJKUCZDCQUDZUEUFZBWBUGUFZEUHZUH
      ZFUAZUIZGIUJUMZHUNUMZVTRSJKDCSUDZBRUDZEUHZUHZFUAZUBWHBCRSJKVSWORVSTSVSTBD
      WNFBDTBCWKWMBWKTBWLEUKULZUOCDWNFCDTCWKWMUKZUOBRUPZCSUPZUQDEWNFWRWSEWMWNBW
      LEURCWKWMURUSZUTVARSQJKWGWOWBWLWKVBVEZDWFWNFXAWFCWKWEUHWNXACWCWKWEWLWKWBR
      VFZSVFZVCVDXACWKWEWMXABWDWLEWLWKWBXBXCVGVDVHVIZUTVJVKAQDWFFWIHWALAGJVLUFV
      MIKVLUFVMWIWAVLUFVMMOGIJKVNVONAFUDDVMUQQWAWFUIZBCJKEUBZWJXFRSJKWNUBXEBCRS
      JKEWNRETSETWPWQWTVARSQJKWFWNXDVJVKPVPVQVR $.
  $}

  ${
    $d x A $.  $d k n x J $.  $d n x N $.
    expcn.j $e |- J = ( TopOpen ` CCfld ) $.
    $( The power function on complex numbers, for fixed exponent ` N ` , is
       continuous.  (Contributed by Mario Carneiro, 5-May-2014.)  (Revised by
       Mario Carneiro, 23-Aug-2014.) $)
    expcn $p |- ( N e. NN0 -> ( x e. CC |-> ( x ^ N ) ) e. ( J Cn J ) ) $=
      ( vn cc cv cexp co cmpt wcel cc0 wceq oveq2 mpteq2dv eleq1d wtru a1i cmul
      c1 vk ccn caddc exp0 mpteq2ia ctopon cfv cnfldtopon ax-1cn cnmptc eqeltri
      trud cn0 wa oveq1 cbvmptv id simpl expp1 mpteq2dva syl5eq simpr syl5eqelr
      syl2anr cnmptid ctx mulcn cnmpt12f eqeltrd ex nn0ind ) AFAGZEGZHIZJZBBUBI
      ZKAFVLLHIZJZVPKAFVLUAGZHIZJZVPKZAFVLVSTUCIZHIZJZVPKZAFVLCHIZJZVPKEUACVMLM
      ZVOVRVPWIAFVNVQVMLVLHNOPVMVSMZVOWAVPWJAFVNVTVMVSVLHNOPVMWCMZVOWEVPWKAFVNW
      DVMWCVLHNOPVMCMZVOWHVPWLAFVNWGVMCVLHNOPVRAFTJZVPAFVQTVLUDUEWMVPKQATBBFFBF
      UFUGKZQBDUHZRZWPTFKQUIRUJULUKVSUMKZWBWFWQWBUNZWEEFVMVSHIZVMSIZJZVPWRWEEFV
      MWCHIZJXAAEFWDXBVLVMWCHUOUPWREFXBWTVMFKZXCWQXBWTMWRXCUQWQWBURVMVSUSVDUTVA
      WREWSVMSBBBBFWNWRWORZWREFWSJWAVPAEFVTWSVLVMVSHUOUPWQWBVBVCWREBFXDVESBBVFI
      BUBIKWRBDVGRVHVIVJVK $.

    $( Division by a nonzero constant is a continuous operation.  (Contributed
       by Mario Carneiro, 5-May-2014.) $)
    divccn $p |- ( ( A e. CC /\ A =/= 0 ) ->
                   ( x e. CC |-> ( x / A ) ) e. ( J Cn J ) ) $=
      ( cc wcel cc0 wne wa cv cdiv co cmpt c1 cmul ccn wceq divrec 3expb a1i
      ancoms mpteq2dva ctopon cfv cnfldtopon cnmptid reccl cnmptc mulcn eqeltrd
      ctx cnmpt12f ) BEFZBGHZIZAEAJZBKLZMAEUPNBKLZOLZMCCPLUOAEUQUSUPEFZUOUQUSQZ
      UTUMUNVAUPBRSUAUBUOAUPUROCCCCECEUCUDFUOCDUETZUOACEVBUFUOAURCCEEVBVBBUGUHO
      CCUKLCPLFUOCDUITULUJ $.
  $}

  ${
    $d x J $.
    sqcn.j $e |- J = ( TopOpen ` CCfld ) $.
    $( The square function on complex numbers is continuous.  (Contributed by
       NM, 13-Jun-2007.)  (Proof shortened by Mario Carneiro, 5-May-2014.) $)
    sqcn $p |- ( x e. CC |-> ( x ^ 2 ) ) e. ( J Cn J ) $=
      ( c2 cn0 wcel cc cv cexp co cmpt ccn 2nn0 expcn ax-mp ) DEFAGAHDIJKBBLJFM
      ABDCNO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Topological definitions using the reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c II $.
  $c -cn-> $.

  $( Extend class notation with the unit interval. $)
  cii $a class II $.

  $( Extend class notation to include the operation which returns a class of
     continuous complex functions. $)
  ccncf $a class -cn-> $.

  $( Define the unit interval with the Euclidean topology.  (Contributed by
     Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 3-Sep-2015.) $)
  df-ii $a |- II = ( MetOpen ` ( ( abs o. - )
                          |` ( ( 0 [,] 1 ) X. ( 0 [,] 1 ) ) ) ) $.

  ${
    $d a b d e f x y $.
    $( Define the operation whose value is a class of continuous complex
       functions.  (Contributed by Paul Chapman, 11-Oct-2007.) $)
    df-cncf $a |- -cn-> = ( a e. ~P CC , b e. ~P CC |->
      { f e. ( b ^m a ) | A. x e. a A. e e. RR+ E. d e. RR+ A. y e. a
  ( ( abs ` ( x - y ) ) < d -> ( abs ` ( ( f ` x ) - ( f ` y ) ) ) < e ) } ) $.
  $}

  $( The unit interval is a topological space.  (Contributed by Mario Carneiro,
     3-Sep-2015.) $)
  iitopon $p |- II e. ( TopOn ` ( 0 [,] 1 ) ) $=
    ( cabs cmin ccom cc0 c1 cicc co cxp cres cxmt cfv wcel cii ctopon cc cnxmet
    wss cr unitssre ax-resscn sstri xmetres2 mp2an df-ii mopntopon ax-mp ) ABCZ
    DEFGZUHHIZUHJKLZMUHNKLUGOJKLUHOQUJPUHROSTUAUGUHOUBUCUIMUHUDUEUF $.

  $( The unit interval is a topological space.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  iitop $p |- II e. Top $=
    ( cc0 c1 cicc co cii iitopon topontopi ) ABCDEFG $.

  $( The base set of the unit interval.  (Contributed by Jeff Madsen,
     2-Sep-2009.)  (Revised by Mario Carneiro, 15-Jan-2014.) $)
  iiuni $p |- ( 0 [,] 1 ) = U. II $=
    ( cc0 c1 cicc co cii iitopon toponunii ) ABCDEFG $.

  $( Alternate definition of the unit interval.  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  dfii2 $p |- II = ( ( topGen ` ran (,) ) |`t ( 0 [,] 1 ) ) $=
    ( cc0 c1 cicc co cr wss cii cioo crn ctg cfv crest wceq unitssre eqid df-ii
    resubmet ax-mp ) ABCDZEFGHIJKZSLDMNSTGTOPQR $.

  ${
    dfii3.1 $e |- J = ( TopOpen ` CCfld ) $.
    $( Alternate definition of the unit interval.  (Contributed by Jeff Madsen,
       11-Jun-2010.)  (Revised by Mario Carneiro, 3-Sep-2015.) $)
    dfii3 $p |- II = ( J |`t ( 0 [,] 1 ) ) $=
      ( cc0 c1 cicc co crest cii cabs cmin ccom cc cxmt cfv wcel wceq cnxmet cr
      wss unitssre ax-resscn sstri cxp cres eqid cnfldtopn df-ii metrest eqcomi
      mp2an ) ACDEFZGFZHIJKZLMNOUKLSULHPQUKRLTUAUBUMUMUKUKUCUDZAHLUKUNUEABUFUGU
      HUJUI $.
  $}

  ${
    dfii4.1 $e |- I = ( CCfld |`s ( 0 [,] 1 ) ) $.
    $( Alternate definition of the unit interval.  (Contributed by Mario
       Carneiro, 3-Sep-2015.) $)
    dfii4 $p |- II = ( TopOpen ` I ) $=
      ( cii ccnfld ctopn cfv cc0 c1 cicc co crest eqid dfii3 resstopn eqtri ) C
      DEFZGHIJZKJAEFPPLZMQAPDBRNO $.
  $}

  $( The unit interval expressed as an order topology.  (Contributed by Mario
     Carneiro, 9-Sep-2015.) $)
  dfii5 $p |- II = ( ordTop ` ( <_ i^i ( ( 0 [,] 1 ) X. ( 0 [,] 1 ) ) ) ) $=
    ( cii cioo crn ctg cfv cc0 c1 cicc co crest cle cordt cxp cin dfii2 cr wceq
    wss unitssre eqid xrrest ax-mp ordtresticc 3eqtr2i ) ABCDEZFGHIZJIZKLEZUFJI
    ZKUFUFMNLEOUFPRUIUGQSUFUEUHUHTUETUAUBFGUCUD $.

  $( The unit interval is compact.  (Contributed by Jeff Madsen, 2-Sep-2009.)
     (Revised by Mario Carneiro, 13-Jun-2014.) $)
  iicmp $p |- II e. Comp $=
    ( cc0 cr wcel c1 cii ccmp 0re 1re cioo crn ctg cfv eqid dfii2 icccmp mp2an
    ) ABCDBCEFCGHADEIJKLZQMNOP $.

  $( The unit interval is connected.  (Contributed by Mario Carneiro,
     11-Feb-2015.) $)
  iicon $p |- II e. Con $=
    ( cii cioo crn ctg cfv cc0 c1 cicc co crest ccon dfii2 wcel 0re 1re iccconn
    cr mp2an eqeltri ) ABCDEFGHIJIZKLFQMGQMTKMNOFGPRS $.

  ${
    $d a b f w x y z A $.  $d w x y z C $.  $d f w x y z F $.  $d w y z R $.
    $d a b f w x y z B $.
    $( The value of the continuous complex function operation is the set of
       continuous functions from ` A ` to ` B ` .  (Contributed by Paul
       Chapman, 11-Oct-2007.)  (Revised by Mario Carneiro, 9-Nov-2013.) $)
    cncfval $p |- ( ( A C_ CC /\ B C_ CC ) ->
      ( A -cn-> B ) = { f e. ( B ^m A ) | A. x e. A A. y e. RR+
        E. z e. RR+ A. w e. A ( ( abs ` ( x - w ) ) < z ->
        ( abs ` ( ( f ` x ) - ( f ` w ) ) ) < y ) } ) $=
      ( va vb cc wss wcel co cv cfv wral crp cmap crab wceq cpw ccncf cmin cabs
      clt wbr wi wrex cnex elpw2 oveq2 raleq rexbidv raleqbi1dv rabeqbidv oveq1
      ralbidv rabeq syl df-cncf ovex rabex ovmpt2 syl2anbr ) EJKEJUAZLFVELEFUBM
      ANZDNZUCMUDOCNUEUFVFGNZOVGVHOUCMUDOBNUEUFUGZDEPZCQUHZBQPZAEPZGFERMZSZTFJK
      EJUIUJFJUIUJHIEFVEVEVIDHNZPZCQUHZBQPZAVPPZGINZVPRMZSVOUBVMGWAERMZSZVPETZV
      TVMGWBWCVPEWARUKVSVLAVPEWEVRVKBQWEVQVJCQVIDVPEULUMUQUNUOWAFTWCVNTWDVOTWAF
      ERUPVMGWCVNURUSADBGHICUTVMGVNFERVAVBVCVD $.

    $( Membership in the set of continuous complex functions from ` A ` to
       ` B ` .  (Contributed by Paul Chapman, 11-Oct-2007.)  (Revised by Mario
       Carneiro, 9-Nov-2013.) $)
    elcncf $p |- ( ( A C_ CC /\ B C_ CC ) ->
     ( F e. ( A -cn-> B ) <-> ( F : A --> B /\ A. x e. A A. y e. RR+
     E. z e. RR+ A. w e. A ( ( abs ` ( x - w ) ) < z ->
     ( abs ` ( ( F ` x ) - ( F ` w ) ) ) < y ) ) ) ) $=
      ( vf cc wa co wcel cv cmin cabs cfv clt wral crp cvv wss cmap wbr wi wrex
      ccncf wf crab cncfval eleq2d wceq oveq12d fveq2d breq1d imbi2d rexralbidv
      fveq1 2ralbidv elrab syl6bb wb cnex ssex elmapg syl2anr anbi1d bitrd ) EI
      UAZFIUAZJZGEFUFKZLZGFEUBKZLZAMZDMZNKOPCMQUCZVOGPZVPGPZNKZOPZBMZQUCZUDZDER
      CSUEZBSRAERZJZEFGUGZWFJVJVLGVQVOHMZPZVPWIPZNKZOPZWBQUCZUDZDERCSUEZBSRAERZ
      HVMUHZLWGVJVKWRGABCDEFHUIUJWQWFHGVMWIGUKZWPWEABESWSWOWDCDSEWSWNWCVQWSWMWA
      WBQWSWLVTOWSWJVRWKVSNVOWIGUQVPWIGUQULUMUNUOUPURUSUTVJVNWHWFVIFTLETLVNWHVA
      VHFIVBVCEIVBVCFEGTTVDVEVFVG $.

    $( Version of ~ elcncf with arguments commuted.  (Contributed by Mario
       Carneiro, 28-Apr-2014.) $)
    elcncf2 $p |- ( ( A C_ CC /\ B C_ CC ) ->
     ( F e. ( A -cn-> B ) <-> ( F : A --> B /\ A. x e. A A. y e. RR+
     E. z e. RR+ A. w e. A ( ( abs ` ( w - x ) ) < z ->
     ( abs ` ( ( F ` w ) - ( F ` x ) ) ) < y ) ) ) ) $=
      ( cc wa co wcel cv cmin cabs cfv clt wbr wral crp sseldd ccncf wf wi wrex
      wss elcncf wb simplll simprl simprr abssubd breq1d simpllr simplr imbi12d
      ffvelrnd anassrs ralbidva rexbidv ralbidv pm5.32da bitrd ) EHUEZFHUEZIZGE
      FUAJKEFGUBZALZDLZMJNOZCLZPQZVGGOZVHGOZMJNOZBLZPQZUCZDERZCSUDZBSRZAERZIVFV
      HVGMJNOZVJPQZVMVLMJNOZVOPQZUCZDERZCSUDZBSRZAERZIABCDEFGUFVEVFWAWJVEVFIZVT
      WIAEWKVGEKZIZVSWHBSWMVRWGCSWMVQWFDEWKWLVHEKZVQWFUGWKWLWNIZIZVKWCVPWEWPVIW
      BVJPWPVGVHWPEHVGVCVDVFWOUHZWKWLWNUIZTWPEHVHWQWKWLWNUJZTUKULWPVNWDVOPWPVLV
      MWPFHVLVCVDVFWOUMZWPEFVGGVEVFWOUNZWRUPTWPFHVMWTWPEFVHGXAWSUPTUKULUOUQURUS
      UTURVAVB $.

    $( Reverse closure of the continuous function predicate.  (Contributed by
       Mario Carneiro, 25-Aug-2014.) $)
    cncfrss $p |- ( F e. ( A -cn-> B ) -> A C_ CC ) $=
      ( va vb vx vw vz vf vy ccncf co cc cv cmin cabs cfv clt wbr wral wcel cpw
      wi crp wrex cmap crab df-cncf elmpt2cl1 elpwid ) CABKLUAAMDEMUBZUKFNZGNZO
      LPQHNRSULINZQUMUNQOLPQJNRSUCGDNZTHUDUEJUDTFUOTIENUOUFLUGABKCFGJIDEHUHUIUJ
      $.

    $( Reverse closure of the continuous function predicate.  (Contributed by
       Mario Carneiro, 25-Aug-2014.) $)
    cncfrss2 $p |- ( F e. ( A -cn-> B ) -> B C_ CC ) $=
      ( va vb vx vw vz vf vy ccncf co cc cv cmin cabs cfv clt wbr wral wcel cpw
      wi crp wrex cmap crab df-cncf elmpt2cl2 elpwid ) CABKLUABMDEMUBZUKFNZGNZO
      LPQHNRSULINZQUMUNQOLPQJNRSUCGDNZTHUDUEJUDTFUOTIENUOUFLUGABKCFGJIDEHUHUIUJ
      $.

    $( A continuous complex function's domain and codomain.  (Contributed by
       Paul Chapman, 17-Jan-2008.)  (Revised by Mario Carneiro,
       25-Aug-2014.) $)
    cncff $p |- ( F e. ( A -cn-> B ) -> F : A --> B ) $=
      ( vx vw vz vy ccncf co wcel cv cmin cabs cfv clt wbr wral crp cc wss wrex
      wf wi wa wb cncfrss cncfrss2 elcncf syl2anc ibi simpld ) CABHIJZABCUBZDKZ
      EKZLIMNFKOPUNCNUOCNLIMNGKOPUCEAQFRUAGRQDAQZULUMUPUDZULASTBSTULUQUEABCUFAB
      CUGDGFEABCUHUIUJUK $.

    $( Defining property of a continuous function.  (Contributed by Mario
       Carneiro, 30-Apr-2014.)  (Revised by Mario Carneiro, 25-Aug-2014.) $)
    cncfi $p |- ( ( F e. ( A -cn-> B ) /\ C e. A /\ R e. RR+ ) ->
                  E. z e. RR+ A. w e. A ( ( abs ` ( w - C ) ) < z ->
                    ( abs ` ( ( F ` w ) - ( F ` C ) ) ) < R ) ) $=
      ( vx vy co wcel crp cv cmin cabs cfv clt wbr wi wral ccncf wrex wa wf wss
      cc wb cncfrss cncfrss2 elcncf2 syl2anc ibi simprd wceq oveq2 fveq2d fveq2
      breq1d oveq2d imbi12d rexralbidv breq2 imbi2d rspc2v mpan9 3impb ) GCDUAJ
      KZECKZFLKZBMZENJZOPZAMZQRZVJGPZEGPZNJZOPZFQRZSZBCTALUBZVGVJHMZNJZOPZVMQRZ
      VOWBGPZNJZOPZIMZQRZSZBCTALUBZILTHCTZVHVIUCWAVGCDGUDZWMVGWNWMUCZVGCUFUEDUF
      UEVGWOUGCDGUHCDGUIHIABCDGUJUKULUMWLWAVNVRWIQRZSZBCTALUBHIEFCLWBEUNZWKWQAB
      LCWRWEVNWJWPWRWDVLVMQWRWCVKOWBEVJNUOUPURWRWHVRWIQWRWGVQOWRWFVPVONWBEGUQUS
      UPURUTVAWIFUNZWQVTABLCWSWPVSVNWIFVRQVBVCVAVDVEVF $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z F $.  $d w x y ph $.
    $d w z Z $.
    elcncf1d.1 $e |- ( ph -> F : A --> B ) $.
    elcncf1d.2 $e |- ( ph -> ( ( x e. A /\ y e. RR+ ) -> Z e. RR+ ) ) $.
    elcncf1d.3 $e |- ( ph -> ( ( ( x e. A /\ w e. A ) /\ y e. RR+ ) ->
                       ( ( abs ` ( x - w ) ) < Z ->
                         ( abs ` ( ( F ` x ) - ( F ` w ) ) ) < y ) ) ) $.
    $( Membership in the set of continuous complex functions from ` A ` to
       ` B ` .  (Contributed by Paul Chapman, 26-Nov-2007.) $)
    elcncf1di $p |- ( ph ->
                   ( ( A C_ CC /\ B C_ CC ) -> F e. ( A -cn-> B ) ) ) $=
      ( vz co wcel wa cv cfv clt wral crp ccncf cc wss wf cmin cabs wbr wi wrex
      imp an32 anbi2i anass bitr4i sylbir ralrimiva breq2 imbi1d ralbidv rspcev
      wceq syl2anc ralrimivva jca elcncf syl5ibrcom ) AGEFUAMNEUBUCFUBUCOEFGUDZ
      BPZDPZUEMUFQZLPZRUGZVHGQVIGQUEMUFQCPZRUGZUHZDESZLTUIZCTSBESZOAVGVRIAVQBCE
      TAVHENZVMTNZOZOZHTNZVJHRUGZVNUHZDESZVQAWAWCJUJWBWEDEWBVIENZOZAVSWGOVTOZOZ
      WEWJAWAWGOZOWHWIWKAVSWGVTUKULAWAWGUMUNAWIWEKUJUOUPVPWFLHTVKHVAZVOWEDEWLVL
      WDVNVKHVJRUQURUSUTVBVCVDBCLDEFGVEVF $.
  $}

  ${
    $d w x y A $.  $d w x y B $.  $d w x y F $.  $d w Z $.
    elcncf1i.1 $e |- F : A --> B $.
    elcncf1i.2 $e |- ( ( x e. A /\ y e. RR+ ) -> Z e. RR+ ) $.
    elcncf1i.3 $e |- ( ( ( x e. A /\ w e. A ) /\ y e. RR+ ) ->
                       ( ( abs ` ( x - w ) ) < Z ->
                         ( abs ` ( ( F ` x ) - ( F ` w ) ) ) < y ) ) $.
    $( Membership in the set of continuous complex functions from ` A ` to
       ` B ` .  (Contributed by Paul Chapman, 26-Nov-2007.) $)
    elcncf1ii $p |- ( ( A C_ CC /\ B C_ CC ) -> F e. ( A -cn-> B ) ) $=
      ( cc wss wa co wcel wi wtru a1i cv cfv wf crp cmin cabs clt wbr elcncf1di
      ccncf trud ) DKLEKLMFDEUHNOPQABCDEFGDEFUAQHRASZDOZBSZUBOZMGUBOPQIRUKCSZDO
      MUMMUJUNUCNUDTGUEUFUJFTUNFTUCNUDTULUEUFPPQJRUGUI $.
  $}

  ${
    $d f w x y z A $.  $d f w x y z B $.  $d f w x y z C $.  $d w x y z F $.
    $( A continuous complex function restricted to a subset is continuous.
       (Contributed by Paul Chapman, 18-Oct-2007.)  (Revised by Mario Carneiro,
       25-Aug-2014.) $)
    rescncf $p |- ( C C_ A ->
            ( F e. ( A -cn-> B ) -> ( F |` C ) e. ( C -cn-> B ) ) ) $=
      ( vx vw vz vy wss co wcel wa cv cmin cabs cfv clt wral crp cc cres wf wbr
      ccncf wi wrex simpr wb cncfrss adantl cncfrss2 elcncf syl2anc mpbid simpl
      simpld fssres simprd ssralv fvres oveqan12d fveq2d breq1d imbi2d ralimdva
      biimprd sylan9 reximdv ralimdv syld sylc sstrd mpbir2and ex ) CAIZDABUDJK
      ZDCUAZCBUDJKZVOVPLZVRCBVQUBZEMZFMZNJOPGMQUCZWAVQPZWBVQPZNJZOPZHMZQUCZUEZF
      CRZGSUFZHSRZECRZVSABDUBZVOVTVSWOWCWADPZWBDPZNJZOPZWHQUCZUEZFARZGSUFZHSRZE
      ARZVSVPWOXELZVOVPUGVSATIZBTIZVPXFUHVPXGVOABDUIUJZVPXHVOABDUKUJZEHGFABDULU
      MUNZUPVOVPUOZABCDUQUMVSVOXEWNXLVSWOXEXKURVOXEXDECRWNXDECAUSVOXDWMECVOWACK
      ZLZXCWLHSXNXBWKGSVOXBXAFCRXMWKXAFCAUSXMXAWJFCXMWBCKZLZWJXAXPWIWTWCXPWGWSW
      HQXPWFWROXMXOWDWPWEWQNWACDUTWBCDUTVAVBVCVDVFVEVGVHVIVEVJVKVSCTIXHVRVTWNLU
      HVSCATXLXIVLXJEHGFCBVQULUMVMVN $.

    $( Change the codomain of a continuous complex function.  (Contributed by
       Paul Chapman, 18-Oct-2007.)  (Revised by Mario Carneiro, 1-May-2015.) $)
    cncffvrn $p |- ( ( C C_ CC /\ F e. ( A -cn-> B ) ) ->
      ( F e. ( A -cn-> C ) <-> F : A --> C ) ) $=
      ( vw vx vz vy cc wss ccncf co wcel wa cv cmin cabs cfv wral crp wf clt wi
      wbr wrex wb cncfrss simpl elcncf2 syl2anc cncfi 3expb ralrimivva biantrud
      adantl bitr4d ) CIJZDABKLMZNZDACKLMZACDUAZEOZFOZPLQRGOUBUDVBDRVCDRPLQRHOZ
      UBUDUCEASGTUEZHTSFASZNZVAUSAIJZUQUTVGUFURVHUQABDUGUOUQURUHFHGEACDUIUJUSVF
      VAURVFUQURVEFHATURVCAMVDTMVEGEABVCVDDUKULUMUOUNUP $.

    $( The set of continuous functions is expanded when the range is expanded.
       (Contributed by Mario Carneiro, 30-Aug-2014.) $)
    cncfss $p |- ( ( B C_ C /\ C C_ CC ) -> ( A -cn-> B ) C_ ( A -cn-> C ) ) $=
      ( vf wss cc wa ccncf co cv wf cncff adantl simpll fss syl2anc wb cncffvrn
      wcel adantll mpbird ex ssrdv ) BCEZCFEZGZDABHIZACHIZUFDJZUGSZUIUHSZUFUJGZ
      UKACUIKZULABUIKZUDUMUJUNUFABUILMUDUEUJNABCUIOPUEUJUKUMQUDABCUIRTUAUBUC $.
  $}

  ${
    $d y z B $.  $d k x y z D $.  $d k x y z F $.  $d k x y z G $.  $d k y Z $.
    $d k y z A $.  $d k x y z ph $.
    climcncf.1 $e |- Z = ( ZZ>= ` M ) $.
    climcncf.2 $e |- ( ph -> M e. ZZ ) $.
    climcncf.4 $e |- ( ph -> F e. ( A -cn-> B ) ) $.
    climcncf.5 $e |- ( ph -> G : Z --> A ) $.
    climcncf.6 $e |- ( ph -> G ~~> D ) $.
    climcncf.7 $e |- ( ph -> D e. A ) $.
    $( Image of a limit under a continuous map.  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    climcncf $p |- ( ph -> ( F o. G ) ~~> ( F ` D ) ) $=
      ( vy vz cvv cv wcel cfv vx vk ccom cc ccncf co wf cncff syl ffvelrnda wss
      cncfrss2 sselda syldan cuz fvex eqeltri fex sylancl syl2anc crp cmin cabs
      coexg clt wbr wi wral wrex cncfi 3expia imp wceq fvco3 sylan climcn1 ) AU
      AOPDBUBEFEFUCZGQHIJNAPRZBSVRETZCSVSUDSABCVREAEBCUEUFZSZBCEUGKBCEUHUIUJACU
      DVSAWACUDUKKBCEULUIUMUNMAWAFQSZVQQSKAHBFUGZHQSWBLHGUOTQIGUOUPUQHBQFURUSEF
      VTQVDUTAUARZVASZVRDVBUFVCTORVEVFVSDETVBUFVCTWDVEVFVGPBVHOVAVIZAWADBSZWEWF
      VGKNWAWGWEWFOPBCDWDEVJVKUTVLAHBUBRZFLUJAWCWHHSWHVQTWHFTETVMLHBWHEFVNVOVP
      $.
  $}

  ${
    $d w x y z $.
    $( Absolute value is continuous.  (Contributed by Paul Chapman,
       21-Oct-2007.)  (Revised by Mario Carneiro, 28-Apr-2014.) $)
    abscncf $p |- abs e. ( CC -cn-> RR ) $=
      ( vw vx vz vy cabs cc cr ccncf co wcel wf cv cmin cfv clt wbr wi wral crp
      wss wrex absf abscn2 rgen2 wa wb ssid ax-resscn elcncf2 mp2an mpbir2an )
      EFGHIJZFGEKZALZBLZMIENCLOPUNENUOENMIENDLOPQAFRCSUAZDSRBFRZUBUPBDFSDCAUOUC
      UDFFTGFTULUMUQUEUFFUGUHBDCAFGEUIUJUK $.

    $( Real part is continuous.  (Contributed by Paul Chapman, 21-Oct-2007.)
       (Revised by Mario Carneiro, 28-Apr-2014.) $)
    recncf $p |- Re e. ( CC -cn-> RR ) $=
      ( vw vx vz vy cre cc cr ccncf co wcel wf cv cmin cabs cfv clt wbr crp wss
      wral wi wrex ref recn2 rgen2 wa wb ssid ax-resscn elcncf2 mp2an mpbir2an
      ) EFGHIJZFGEKZALZBLZMINOCLPQUOEOUPEOMINODLPQUAAFTCRUBZDRTBFTZUCUQBDFRDCAU
      PUDUEFFSGFSUMUNURUFUGFUHUIBDCAFGEUJUKUL $.

    $( Imaginary part is continuous.  (Contributed by Paul Chapman,
       21-Oct-2007.)  (Revised by Mario Carneiro, 28-Apr-2014.) $)
    imcncf $p |- Im e. ( CC -cn-> RR ) $=
      ( vw vx vz vy cim cc cr ccncf co wcel wf cv cmin cabs cfv clt wbr crp wss
      wral wi wrex imf imcn2 rgen2 wa wb ssid ax-resscn elcncf2 mp2an mpbir2an
      ) EFGHIJZFGEKZALZBLZMINOCLPQUOEOUPEOMINODLPQUAAFTCRUBZDRTBFTZUCUQBDFRDCAU
      PUDUEFFSGFSUMUNURUFUGFUHUIBDCAFGEUJUKUL $.

    $( Complex conjugate is continuous.  (Contributed by Paul Chapman,
       21-Oct-2007.)  (Revised by Mario Carneiro, 28-Apr-2014.) $)
    cjcncf $p |- * e. ( CC -cn-> CC ) $=
      ( vw vx vz vy ccj cc ccncf co wcel wf cmin cabs cfv clt wbr wral crp wrex
      cv wi cjf cjcn2 rgen2 wss wa wb ssid elcncf2 mp2an mpbir2an ) EFFGHIZFFEJ
      ZASZBSZKHLMCSNOUMEMUNEMKHLMDSNOTAFPCQRZDQPBFPZUAUOBDFQDCAUNUBUCFFUDZUQUKU
      LUPUEUFFUGZURBDCAFFEUHUIUJ $.
  $}

  ${
    $d t u v w x y z A $.  $d t u w y z F $.
    mulc1cncf.1 $e |- F = ( x e. CC |-> ( A x. x ) ) $.
    $( Multiplication by a constant is continuous.  (Contributed by Paul
       Chapman, 28-Nov-2007.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
    mulc1cncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      ( vu vw cc wcel cv cmin co cabs cfv clt wbr wi wral crp cmul wa vy simprr
      vz vv vt wf wrex ccncf mulcl fmptd simpl simprl mulcn2 syl3anc wceq oveq1
      fveq2d breq1d anbi1d oveq1d imbi12d ralbidv rspcv ad2antrr wb cc0 abs00bd
      subid simprll rpgt0d eqbrtrd biantrurd oveq2 ovex simplrl oveq12d anassrs
      fvmpt syl ralbidva sylibrd reximdva rexlimdva mpd ralrimivva ssid elcncf2
      wss mp2an sylanbrc ) BGHZGGCUFZEIZUAIZJKLMFIZNOZWMCMZWNCMZJKZLMZUCIZNOZPZ
      EGQZFRUGZUCRQUAGQZCGGUHKHZWKAGBAIZSKZGCBXHUIDUJWKXEUAUCGRWKWNGHZXARHZTZTZ
      UDIZBJKZLMZUEIZNOZWPTZXNWMSKZBWNSKZJKZLMZXANOZPZEGQZUDGQZFRUGZUERUGZXEXMX
      KWKXJYIWKXJXKUBWKXLUKWKXJXKULUEFEUDXABWNUMUNXMYHXEUERXMXQRHZTYGXDFRXMYJWO
      RHZYGXDPXMYJYKTZTZYGBBJKZLMZXQNOZWPTZBWMSKZYAJKZLMZXANOZPZEGQZXDWKYGUUCPX
      LYLYFUUCUDBGXNBUOZYEUUBEGUUDXSYQYDUUAUUDXRYPWPUUDXPYOXQNUUDXOYNLXNBBJUPUQ
      URUSUUDYCYTXANUUDYBYSLUUDXTYRYAJXNBWMSUPUTUQURVAVBVCVDYMXCUUBEGXMYLWMGHZX
      CUUBVEXMYLUUETZTZWPYQXBUUAUUGYPWPUUGYOVFXQNUUGYNWKYNVFUOXLUUFBVHVDVGUUGXQ
      XMYJYKUUEVIVJVKVLUUGWTYTXANUUGWSYSLUUGWQYRWRYAJUUGUUEWQYRUOXMYLUUEUBAWMXI
      YRGCXHWMBSVMDBWMSVNVRVSUUGXJWRYAUOWKXJXKUUFVOAWNXIYAGCXHWNBSVMDBWNSVNVRVS
      VPUQURVAVQVTWAVQWBWCWDWEGGWHZUUHXGWLXFTVEGWFZUUIUAUCFEGGCWGWIWJ $.
  $}

  ${
    $d A x $.
    divccncf.1 $e |- F = ( x e. CC |-> ( x / A ) ) $.
    $( Division by a constant is continuous.  (Contributed by Paul Chapman,
       28-Nov-2007.) $)
    divccncf $p |- ( ( A e. CC /\ A =/= 0 ) -> F e. ( CC -cn-> CC ) ) $=
      ( cc wcel cc0 wne wa c1 cdiv co cmul cmpt ccncf wceq divrec2 3expb ancoms
      cv mpteq2dva syl5eq reccl eqid mulc1cncf syl eqeltrd ) BEFZBGHZIZCAEJBKLZ
      ATZMLZNZEEOLZUJCAEULBKLZNUNDUJAEUPUMULEFZUJUPUMPZUQUHUIURULBQRSUAUBUJUKEF
      UNUOFBUCAUKUNUNUDUEUFUG $.
  $}

  ${
    $d u w x y z A $.  $d u v w z B $.  $d u v w x y z C $.  $d u w x y z ph $.
    $d u v w x y z F $.  $d u v w x y z G $.
    cncfco.4 $e |- ( ph -> F e. ( A -cn-> B ) ) $.
    cncfco.5 $e |- ( ph -> G e. ( B -cn-> C ) ) $.
    $( The composition of two continuous maps on complex numbers is also
       continuous.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by
       Mario Carneiro, 25-Aug-2014.) $)
    cncfco $p |- ( ph -> ( G o. F ) e. ( A -cn-> C ) ) $=
      ( vw vz co wcel cv cmin cabs cfv clt wi crp wa vx vy vv vu ccom ccncf wbr
      wf wral cncff syl fco syl2anc adantr simprl ffvelrnd simprr cncfi syl3anc
      ad2antrr simplrl simpr ad3antrrr oveq1 fveq2d breq1d fveq2 oveq1d imbi12d
      wrex rspcv fvco3 oveq12d imbi2d sylibrd imp an32s imim2d anassrs ralimdva
      wceq reximdva ex mpid rexlimdva mpd ralrimivva cc wss wb cncfrss cncfrss2
      elcncf2 mpbir2and ) AFEUEZBDUFKLZBDWOUHZIMZUAMZNKOPJMZQUGZWRWOPZWSWOPZNKZ
      OPZUBMZQUGZRZIBUIZJSVJZUBSUIUABUIZACDFUHZBCEUHZWQAFCDUFKLZXLHCDFUJUKAEBCU
      FKLZXMGBCEUJUKZBCDFEULUMAXJUAUBBSAWSBLZXFSLZTZTZUCMZWSEPZNKZOPZUDMZQUGZYA
      FPZYBFPZNKZOPZXFQUGZRZUCCUIZUDSVJZXJXTXNYBCLXRYNAXNXSHUNXTBCWSEAXMXSXPUNA
      XQXRUOUPAXQXRUQUDUCCDYBXFFURUSXTYMXJUDSXTYESLZTZYMXAWREPZYBNKZOPZYEQUGZRZ
      IBUIZJSVJZXJYPXOXQYOUUCAXOXSYOGUTAXQXRYOVAZXTYOVBJIBCWSYEEURUSYPYMUUCXJRY
      PYMTZUUBXIJSUUEWTSLZTUUAXHIBUUEUUFWRBLZUUAXHRUUEUUFUUGTZTYTXGXAYPUUHYMYTX
      GRZYPUUHTZYMUUIUUJYMYTYQFPZYHNKZOPZXFQUGZRZUUIUUJYQCLYMUUORUUJBCWREAXMXSY
      OUUHXPVCZYPUUFUUGUQZUPYLUUOUCYQCYAYQWAZYFYTYKUUNUURYDYSYEQUURYCYROYAYQYBN
      VDVEVFUURYJUUMXFQUURYIUULOUURYGUUKYHNYAYQFVGVHVEVFVIVKUKUUJXGUUNYTUUJXEUU
      MXFQUUJXDUULOUUJXBUUKXCYHNUUJXMUUGXBUUKWAUUPUUQBCWRFEVLUMUUJXMXQXCYHWAUUP
      YPXQUUHUUDUNBCWSFEVLUMVMVEVFVNVOVPVQVRVSVTWBWCWDWEWFWGABWHWIZDWHWIZWPWQXK
      TWJAXOUUSGBCEWKUKAXNUUTHCDFWLUKUAUBJIBDWOWMUMWN $.
  $}

  ${
    $d f w x y z A $.  $d f w x y z B $.  $d f w x y z J $.  $d f w x y z K $.
    $d w x y z C $.  $d w x y z D $.
    cncfmet.1 $e |- C = ( ( abs o. - ) |` ( A X. A ) ) $.
    cncfmet.2 $e |- D = ( ( abs o. - ) |` ( B X. B ) ) $.
    cncfmet.3 $e |- J = ( MetOpen ` C ) $.
    cncfmet.4 $e |- K = ( MetOpen ` D ) $.
    $( Relate complex function continuity to metric space continuity.
       (Contributed by Paul Chapman, 26-Nov-2007.)  (Revised by Mario Carneiro,
       7-Sep-2015.) $)
    cncfmet $p |- ( ( A C_ CC /\ B C_ CC ) -> ( A -cn-> B ) = ( J Cn K ) ) $=
      ( vx vw vz vy cc wa co clt cfv wcel vf wss ccncf ccn cv wbr wral crp wrex
      wf wi cmin cabs wb wceq simplll simprl simprr ccom cxp oveqi ovres syl5eq
      cres ad2ant2l ssel2 eqid cnmetdval syl2an eqtrd syl22anc breq1d ad2ant2lr
      ffvelrn syl2anc simpllr imbi12d anassrs ralbidva rexbidv ralbidv pm5.32da
      sseldd cxmt cnxmet xmetres2 mpan syl5eqel metcn elcncf 3bitr4rd eqrdv ) A
      OUBZBOUBZPZUAABUCQZEFUDQZWOABUAUEZUJZKUEZLUEZCQZMUEZRUFZWTWRSZXAWRSZDQZNU
      EZRUFZUKZLAUGZMUHUIZNUHUGZKAUGZPZWSWTXAULQUMSZXCRUFZXEXFULQUMSZXHRUFZUKZL
      AUGZMUHUIZNUHUGZKAUGZPWRWQTZWRWPTWOWSXNYDWOWSPZXMYCKAYFWTATZPZXLYBNUHYHXK
      YAMUHYHXJXTLAYFYGXAATZXJXTUNYFYGYIPZPZXDXQXIXSYKXBXPXCRYKWMYGWMYIXBXPUOWM
      WNWSYJUPZYFYGYIUQYLYFYGYIURWMYGPZWMYIPZPXBWTXAUMULUSZQZXPYGYIXBYPUOWMWMYJ
      XBWTXAYOAAUTVDZQYPCYQWTXAGVAWTXAAAYOVBVCVEYMWTOTXAOTYPXPUOYNAOWTVFAOXAVFW
      TXAYOYOVGZVHVIVJVKVLYKXGXRXHRYKXGXEXFYOQZXRYKXEBTZXFBTZXGYSUOWSYGYTWOYIAB
      WTWRVNVMZWSYIUUAWOYGABXAWRVNVEZYTUUAPXGXEXFYOBBUTVDZQYSDUUDXEXFHVAXEXFBBY
      OVBVCVOYKXEOTXFOTYSXRUOYKBOXEWMWNWSYJVPZUUBWCYKBOXFUUEUUCWCXEXFYOYRVHVOVJ
      VLVQVRVSVTWAVSWBWMCAWDSZTDBWDSZTYEXOUNWNWMCYQUUFGYOOWDSTZWMYQUUFTWEYOAOWF
      WGWHWNDUUDUUGHUUHWNUUDUUGTWEYOBOWFWGWHKNMLCDWREFABIJWIVIKNMLABWRWJWKWL $.
  $}

  ${
    $d A f w x y z $.  $d B f w x y z $.  $d C w x y z $.  $d D w x y z $.
    $d J f w x y z $.  $d K f w x y $.
    cncfcn.2 $e |- J = ( TopOpen ` CCfld ) $.
    cncfcn.3 $e |- K = ( J |`t A ) $.
    cncfcn.4 $e |- L = ( J |`t B ) $.
    $( Relate complex function continuity to topological continuity.
       (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    cncfcn $p |- ( ( A C_ CC /\ B C_ CC ) -> ( A -cn-> B ) = ( K Cn L ) ) $=
      ( cc wss co cxp cres cmopn cfv ccn eqid crest wceq cnxmet ccncf cabs cmin
      wa ccom cncfmet cxmt simpl cnfldtopn metrest sylancr syl5eq simpr oveq12d
      wcel eqtr4d ) AIJZBIJZUDZABUAKUBUCUEZAALMZNOZUTBBLMZNOZPKDEPKABVAVCVBVDVA
      QZVCQZVBQZVDQZUFUSDVBEVDPUSDCARKZVBGUSUTIUGOUOZUQVIVBSTUQURUHUTVACVBIAVEC
      FUIZVGUJUKULUSECBRKZVDHUSVJURVLVDSTUQURUMUTVCCVDIBVFVKVHUJUKULUNUP $.
  $}

  ${
    cncfcn1.1 $e |- J = ( TopOpen ` CCfld ) $.
    $( Relate complex function continuity to topological continuity.
       (Contributed by Paul Chapman, 28-Nov-2007.)  (Revised by Mario Carneiro,
       7-Sep-2015.) $)
    cncfcn1 $p |- ( CC -cn-> CC ) = ( J Cn J ) $=
      ( cc wss ccncf co wceq ssid crest ctop wcel cnfldtop cnfldtopon toponunii
      ccn restid ax-mp eqcomi cncfcn mp2an ) CCDZUACCEFAAOFGCHZUBCCAAABACIFZAAJ
      KUCAGABLAJCCAABMNPQRZUDST $.
  $}

  ${
    $d x A $.  $d x S $.  $d x T $.
    $( A constant function is a continuous function on ` CC ` .  (Contributed
       by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       7-Sep-2015.) $)
    cncfmptc $p |- ( ( A e. T /\ S C_ CC /\ T C_ CC ) ->
      ( x e. S |-> A ) e. ( S -cn-> T ) ) $=
      ( wcel cc wss w3a cmpt ccnfld ctopn cfv crest co ccn ccncf eqid resttopon
      ctopon sylancr cnfldtopon simp2 simp3 cnmptc wceq cncfcn 3adant1 eleqtrrd
      simp1 ) BDEZCFGZDFGZHZACBIJKLZCMNZUNDMNZONZCDPNZUMABUOUPCDUMUNFSLEZUKUOCS
      LEUNUNQZUAZUJUKULUBCUNFRTUMUSULUPDSLEVAUJUKULUCDUNFRTUJUKULUIUDUKULURUQUE
      UJCDUNUOUPUTUOQUPQUFUGUH $.

    $( The identity function is a continuous function on ` CC ` .  (Contributed
       by Jeff Madsen, 11-Jun-2010.)  (Revised by Mario Carneiro,
       17-May-2016.) $)
    cncfmptid $p |- ( ( S C_ T /\ T C_ CC ) ->
      ( x e. S |-> x ) e. ( S -cn-> T ) ) $=
      ( wss cc wa ccncf co cv cmpt cncfss ccnfld ctopn cfv ccn ctopon wcel eqid
      crest cnfldtopon resttopon sylancr cnmptid cncfcn syl2anc eleqtrrd sseldd
      sstr wceq ) BCDCEDFZBBGHZBCGHABAIJZBBCKUJULLMNZBSHZUNOHZUKUJAUNBUJUMEPNQB
      EDZUNBPNQUMUMRZTBCEUHZBUMEUAUBUCUJUPUPUKUOUIURURBBUMUNUNUQUNRZUSUDUEUFUG
      $.
  $}

  ${
    $d y A $.  $d x y F $.  $d x ph $.  $d x X $.
    cncfmpt1f.1 $e |- ( ph -> F e. ( CC -cn-> CC ) ) $.
    cncfmpt1f.2 $e |- ( ph -> ( x e. X |-> A ) e. ( X -cn-> CC ) ) $.
    $( Composition of continuous functions. ` -cn-> ` analog of ~ cnmpt11f .
       (Contributed by Mario Carneiro, 3-Sep-2014.) $)
    cncfmpt1f $p |- ( ph -> ( x e. X |-> ( F ` A ) ) e. ( X -cn-> CC ) ) $=
      ( vy cmpt ccom cfv cc ccncf co cv wf wcel wral cncff syl eqid fmpt sylibr
      eqidd feqmptd fveq2 fmptcof cncfco eqeltrrd ) ADBECIZJBECDKZIELMNZABHELCH
      OZDKUKUJDAELUJPZCLQBERAUJULQUNGELUJSTBELCUJUJUAUBUCAUJUDAHLLDADLLMNQLLDPF
      LLDSTUEUMCDUFUGAELLUJDGFUHUI $.
  $}

  ${
    $d x F $.  $d x J $.  $d x ph $.  $d x X $.
    cncfmpt2f.1 $e |- J = ( TopOpen ` CCfld ) $.
    cncfmpt2f.2 $e |- ( ph -> F e. ( ( J tX J ) Cn J ) ) $.
    cncfmpt2f.3 $e |- ( ph -> ( x e. X |-> A ) e. ( X -cn-> CC ) ) $.
    cncfmpt2f.4 $e |- ( ph -> ( x e. X |-> B ) e. ( X -cn-> CC ) ) $.
    $( Composition of continuous functions. ` -cn-> ` analog of ~ cnmpt12f .
       (Contributed by Mario Carneiro, 3-Sep-2014.) $)
    cncfmpt2f $p |- ( ph -> ( x e. X |-> ( A F B ) ) e. ( X -cn-> CC ) ) $=
      ( co cmpt crest cc ctopon cfv wcel wss wceq ccn ccncf cncfrss syl sylancr
      cnfldtopon resttopon ssid eqid restid ax-mp eqcomi cncfcn sylancl eleqtrd
      toponunii cnmpt12f eleqtrrd ) ABGCDELMFGNLZFUALZGOUBLZABCDEUSFFFGAFOPQZRZ
      GOSZUSGPQRFHUFZABGCMZVARVDJGOVFUCUDZGFOUGUEAVFVAUTJAVDOOSVAUTTVGOUHGOFUSF
      HUSUIFONLZFVCVHFTVEFVBOOFVEUPUJUKULUMUNZUOABGDMVAUTKVIUOIUQVIUR $.
  $}

  ${
    $d x F $.  $d x J $.  $d x ph $.  $d x S $.  $d x X $.
    cncfmpt2ss.1 $e |- J = ( TopOpen ` CCfld ) $.
    cncfmpt2ss.2 $e |- F e. ( ( J tX J ) Cn J ) $.
    cncfmpt2ss.3 $e |- ( ph -> ( x e. X |-> A ) e. ( X -cn-> S ) ) $.
    cncfmpt2ss.4 $e |- ( ph -> ( x e. X |-> B ) e. ( X -cn-> S ) ) $.
    cncfmpt2ss.5 $e |- S C_ CC $.
    cncfmpt2ss.6 $e |- ( ( A e. S /\ B e. S ) -> ( A F B ) e. S ) $.
    $( Composition of continuous functions in a subset.  (Contributed by Mario
       Carneiro, 17-May-2016.) $)
    cncfmpt2ss $p |- ( ph -> ( x e. X |-> ( A F B ) ) e. ( X -cn-> S ) ) $=
      ( co cmpt wcel wf eqid cc ccncf cv wa wral cncff syl fmpt sylibr r19.21bi
      syl2anc fmptd wss ctx ccn a1i ssid cncfss mp2an sseldi cncfmpt2f cncffvrn
      wb sylancr mpbird ) ABHCDFOZPZHEUAOZQZHEVFRZABHVEEVFABUBHQUCCEQZDEQZVEEQA
      VJBHAHEBHCPZRZVJBHUDAVLVGQVMKHEVLUEUFBHECVLVLSUGUHUIAVKBHAHEBHDPZRZVKBHUD
      AVNVGQVOLHEVNUEUFBHEDVNVNSUGUHUINUJVFSUKAETULZVFHTUAOZQVHVIVBMABCDFGHIFGG
      UMOGUNOQAJUOAVGVQVLVPTTULVGVQULMTUPHETUQURZKUSAVGVQVNVRLUSUTHTEVFVAVCVD
      $.
  $}

  ${
    $d A u v w x y $.  $d F u v w $.
    addccncf.1 $e |- F = ( x e. CC |-> ( x + A ) ) $.
    $( Adding a constant is a continuous function.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       12-Sep-2015.) $)
    addccncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      ( cc wcel cv caddc cmpt ccncf ccnfld ctopn cfv eqid ctx ccn addcn a1i wss
      co ssid cncfmptid mp2an cncfmptc mp3an23 cncfmpt2f syl5eqel ) BEFZCAEAGZB
      HTIEEJTZDUHAUIBHKLMZEUKNZHUKUKOTUKPTFUHUKULQRAEUIIUJFZUHEESZUNUMEUAZUOAEE
      UBUCRUHUNUNAEBIUJFUOUOABEEUDUEUFUG $.
  $}

  ${
    $d A x $.
    cdivcncf.1 $e |- F = ( x e. ( CC \ { 0 } ) |-> ( A / x ) ) $.
    $( Division with a constant numerator is continuous.  (Contributed by Mario
       Carneiro, 28-Dec-2016.) $)
    cdivcncf $p |- ( A e. CC -> F e. ( ( CC \ { 0 } ) -cn-> CC ) ) $=
      ( cc wcel cc0 csn cdif cv cdiv co cfv crest ccn ctopon wss eqid a1i wceq
      cmpt ccnfld ctopn ccncf cnfldtopon difss resttopon sylancl cnmptc cnmptid
      id divcn cnmpt12f ssid toponunii restid ax-mp eqcomi cncfcn mp2an 3eltr4g
      ctx ) BEFZAEGHZIZBAJZKLUAUBUCMZVENLZVGOLZCVEEUDLZVCABVFKVHVGVHVGVEVCVGEPM
      ZFZVEEQZVHVEPMFVLVCVGVGRZUEZSZEVDUFZVEVGEUGUHZVCABVHVGVEEVRVPVCUKUIVCAVHV
      EVRUJKVGVHVBLVGOLFVCVGVHVNVHRZULSUMDVMEEQVJVITVQEUNVEEVGVHVGVNVSVGENLZVGV
      LVTVGTVOVGVKEEVGVOUOUPUQURUSUTVA $.
  $}

  ${
    $d x A $.
    negcncf.1 $e |- F = ( x e. A |-> -u x ) $.
    $( The negative function is continuous.  (Contributed by Mario Carneiro,
       30-Dec-2016.) $)
    negcncf $p |- ( A C_ CC -> F e. ( A -cn-> CC ) ) $=
      ( cc c1 cneg cv cmul co cmpt ccncf wcel wa ssel2 mulm1d mpteq2dva syl6eqr
      wss ccnfld ctopn cfv eqid ctx ccn mulcn a1i neg1cn ssid mp3an13 cncfmptid
      cncfmptc mpan2 cncfmpt2f eqeltrrd ) BESZABFGZAHZIJZKZCBELJZUPUTABURGZKCUP
      ABUSVBUPURBMNURBEUROPQDRUPAUQURITUAUBZBVCUCZIVCVCUDJVCUEJMUPVCVDUFUGUQEMU
      PEESZABUQKVAMUHEUIZAUQBEULUJUPVEABURKVAMVFABEUKUMUNUO $.
  $}

  ${
    $d x y F $.  $d x A $.
    negfcncf.1 $e |- G = ( x e. A |-> -u ( F ` x ) ) $.
    $( The negative of a continuous complex function is continuous.
       (Contributed by Paul Chapman, 21-Jan-2008.)  (Revised by Mario Carneiro,
       25-Aug-2014.) $)
    negfcncf $p |- ( F e. ( A -cn-> CC ) -> G e. ( A -cn-> CC ) ) $=
      ( vy cc ccncf co wcel cv cneg cmpt ccom cfv cncff ffvelrnda feqmptd eqidd
      negeq fmptco syl6eqr id wss ssid eqid negcncf mp1i cncfco eqeltrrd ) CBGH
      IZJZFGFKZLZMZCNZDUKULUPABAKZCOZLZMDULAFBGURUNUSCUOULBGUQCBGCPZQULABGCUTRU
      LUOSUMURTUAEUBULBGGCUOULUCGGUDUOGGHIJULGUEFGUOUOUFUGUHUIUJ $.
  $}

  $( Absolute value is continuous.  Alternate proof of ~ abscncf .
     (Contributed by NM, 6-Jun-2008.)  (Revised by Mario Carneiro,
     10-Sep-2015.)  (Proof modification is discouraged.) $)
  abscncfALT $p |- abs e. ( CC -cn-> RR ) $=
    ( cabs ccnfld ctopn cfv cioo crn ctg ccn co cc cr ccncf eqid abscn wss wceq
    ssid ax-resscn crest ctopon cnfldtopon toponunii restid ax-mp eqcomi tgioo2
    wcel cncfcn mp2an eleqtrri ) ABCDZEFGDZHIZJKLIZUKULUKMZULMNJJOKJOUNUMPJQRJK
    UKUKULUOUKJSIZUKUKJTDZUGUPUKPUKUOUAZUKUQJJUKURUBUCUDUEUKUOUFUHUIUJ $.

  ${
    $d z F $.  $d z J $.  $d x y z K $.
    cncfcnvcn.j $e |- J = ( TopOpen ` CCfld ) $.
    cncfcnvcn.k $e |- K = ( J |`t X ) $.
    $( Rewrite ~ cmphaushmeo for functions on the complexes.  (Contributed by
       Mario Carneiro, 19-Feb-2015.) $)
    cncfcnvcn $p |- ( ( K e. Comp /\ F e. ( X -cn-> Y ) ) ->
      ( F : X -1-1-onto-> Y <-> `' F e. ( Y -cn-> X ) ) ) $=
      ( wcel ccncf co crest ccn wf1o wb cc wceq eqid syl cuni sylancr ccmp ccnv
      wa chmeo simpr cncfrss adantl cncfrss2 cncfcn syl2anc eleqtrd ishmeo baib
      wss ctop cnfldtop cnfldtopon toponunii restuni unieqi f1oeq2 f1oeq3 simpl
      syl6eqr cha cvv cnfldhaus cnex ssex resthaus cmphaushmeo syl3anc 3bitr4d
      eleq2d ) CUAHZADEIJZHZUCZACBEKJZUDJHZAUBZVSCLJZHZDEAMZWAEDIJZHVRACVSLJZHZ
      VTWCNVRAVPWFVOVQUEVRDOUNZEOUNZVPWFPVQWHVODEAUFUGZVQWIVODEAUHUGZDEBCVSFGVS
      QZUIUJUKZVTWGWCACVSULUMRVRDVSSZAMZCSZWNAMZWDVTVRDWPPWOWQNVRDBDKJZSZWPVRBU
      OHZWHDWSPBFUPZWJDBOOBBFUQURZUSTCWRGUTVDDWPWNAVARVREWNPZWDWONVRWTWIXCXAWKE
      BOXBUSTEWNDAVBRVRVOVSVEHZWGVTWQNVOVQVCVRBVEHEVFHZXDBFVGVRWIXEWKEOVHVIREBV
      FVJTWMACVSWPWNWPQWNQVKVLVMVRWEWBWAVRWIWHWEWBPWKWJEDBVSCFWLGUIUJVNVM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    cnmptre.1 $e |- R = ( TopOpen ` CCfld ) $.
    cnmptre.2 $e |- J = ( ( topGen ` ran (,) ) |`t A ) $.
    cnmptre.3 $e |- K = ( ( topGen ` ran (,) ) |`t B ) $.
    cnmptre.4 $e |- ( ph -> A C_ RR ) $.
    cnmptre.5 $e |- ( ph -> B C_ RR ) $.
    cnmptre.6 $e |- ( ( ph /\ x e. A ) -> F e. B ) $.
    cnmptre.7 $e |- ( ph -> ( x e. CC |-> F ) e. ( R Cn R ) ) $.
    $( Lemma for ~ iirevcn and related functions.  (Contributed by Mario
       Carneiro, 6-Jun-2014.) $)
    cnmptre $p |- ( ph -> ( x e. A |-> F ) e. ( J Cn K ) ) $=
      ( crest co ccn cc cr cmpt wcel ctopon cfv cnfldtopon a1i ax-resscn syl6ss
      eqid cnmpt1res cioo crn ctg wss wceq rerest syl syl6eqr oveq1d eleqtrd wb
      wf fmptd frn cnrest2 syl3anc mpbid oveq2d ) ABCFUAZGEDPQZRQZGHRQAVIGERQZU
      BZVIVKUBZAVIECPQZERQVLABFEVOESCVOUIESUCUDUBZAEIUEUFZACTSLUGUHOUJAVOGERAVO
      UKULUMUDZCPQZGACTUNVOVSUOLCVREIVRUIZUPUQJURUSUTAVPVIULDUNZDSUNVMVNVAVQACD
      VIVBWAABCFDVINVIUIVCCDVIVDUQADTSMUGUHDVIGESVEVFVGAVJHGRAVJVRDPQZHADTUNVJW
      BUOMDVREIVTUPUQKURVHUT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y K $.  $d x y ph $.
    $d x y X $.
    cnmpt2pc.r $e |- R = ( topGen ` ran (,) ) $.
    cnmpt2pc.m $e |- M = ( R |`t ( A [,] B ) ) $.
    cnmpt2pc.n $e |- N = ( R |`t ( B [,] C ) ) $.
    cnmpt2pc.o $e |- O = ( R |`t ( A [,] C ) ) $.
    cnmpt2pc.a $e |- ( ph -> A e. RR ) $.
    cnmpt2pc.c $e |- ( ph -> C e. RR ) $.
    cnmpt2pc.b $e |- ( ph -> B e. ( A [,] C ) ) $.
    cnmpt2pc.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    cnmpt2pc.q $e |- ( ( ph /\ ( x = B /\ y e. X ) ) -> D = E ) $.
    cnmpt2pc.d $e |- ( ph -> ( x e. ( A [,] B ) , y e. X |-> D )
                               e. ( ( M tX J ) Cn K ) ) $.
    cnmpt2pc.e $e |- ( ph -> ( x e. ( B [,] C ) , y e. X |-> E )
                               e. ( ( N tX J ) Cn K ) ) $.
    $( Piecewise definition of a continuous function on a real interval.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       5-Jun-2014.) $)
    cnmpt2pc $p |- ( ph -> ( x e. ( A [,] C ) , y e. X |->
                            if ( x <_ B , D , E ) ) e. ( ( O tX J ) Cn K ) ) $=
      ( cicc co cxp cle wbr cif cmpt2 ctx cuni eqid ccld cfv wcel crest iccssre
      cv wss syl2anc cioo crn ctg sseldd icccld fveq2i syl6eleqr cun ssun1 wceq
      cr iccsplit syl5sseqr uniretop unieqi eqtr4i restcldi ctopon toponuni syl
      syl3anc topontop topcld eqeltrd txcld ssun2 xpeq1d xpundir syl6eq retopon
      ctop 3syl eqeltri resttopon sylancr syl5eqel txtopon eqtr3d wf wral sstrd
      ccn cntop2 toptopon w3a wa elicc2 biimpa simp3d 3adant3 iftrue mpt2eq3dva
      sylib wb cnf2 fmpt2 sylibr simp2d biantrud simp1d adantr cres resmpt2 cvv
      sylancl ovex txrest syl22anc restabs oveq1i 3eqtr4g eqtrd oveq12d 3eltr4d
      a1i oveq1d letri3d bitr4d ancom2s ifeq1d ifid expr 3adant2 sylbid iffalse
      pm2.61d1 ralun raleqdv mpbird feq2d mpbid ssid retop resttop mp2an oveq2d
      wi restid paste ) ADEUGUHZOUIZEFUGUHZOUIZBCDFUGUHZOBVBZEUJUKZGIULZUMZNJUN
      UHZKUVMUOZKUOZUVNUPUVOUPZAUVDNUQURZUSOJUQURZUSZUVEUVMUQURZUSAUVDHUVHUTUHZ
      UQURZUVQAUVHVOVCZUVDHUQURZUSUVDUVHVCZUVDUWBUSADVOUSZFVOUSZUWCTUADFVAVDZAU
      VDVEVFVGURZUQURZUWDAUWFEVOUSZUVDUWJUSTAUVHVOEUWHUBVHZDEVIVDHUWIUQPVJZVKAU
      VDUVFVLZUVDUVHUVDUVFVMAUWFUWGEUVHUSUVHUWNVNTUAUBDFEVPWEZVQZUVHUVDHVOVOUWI
      UOHUOVRHUWIPVSVTZWAWENUWAUQSVJZVKAOJUOZUVRAJOWBURZUSZOUWSVNUCOJWCWDZAUXAJ
      WOUSUWSUVRUSUCOJWFJUWSUWSUPZWGWPWHZUVDONJWIVDAUVFUVQUSUVSUVGUVTUSAUVFUWBU
      VQAUWCUVFUWDUSUVFUVHVCZUVFUWBUSUWHAUVFUWJUWDAUWKUWGUVFUWJUSUWLUAEFVIVDUWM
      VKAUWNUVFUVHUVFUVDWJUWOVQZUVHUVFHVOUWQWAWEUWRVKUXDUVFONJWIVDAUVHOUIZUVEUV
      GVLZUVNAUXGUWNOUIUXHAUVHUWNOUWOWKUVDUVFOWLWMAUVMUXGWBURUSZUXGUVNVNANUVHWB
      URZUSUXAUXIANUWAUXJSAHVOWBURZUSZUWCUWAUXJUSHUWIUXKPWNWQZUWHUVHHVOWRWSWTUC
      NJUVHOXAVDUXGUVMWCWDZXBAUXGUVOUVLXCZUVNUVOUVLXCAUVKUVOUSCOXDZBUVHXDZUXOAU
      XQUXPBUWNXDZAUXPBUVDXDZUXPBUVFXDZUXRAUVEUVOBCUVDOUVKUMZXCZUXSALJUNUHZUVEW
      BURUSZKUVOWBURUSZUYAUYCKXFUHZUSUYBALUVDWBURZUSUXAUYDALHUVDUTUHZUYGQAUXLUV
      DVOVCUYHUYGUSUXMAUVDUVHVOUWPUWHXEUVDHVOWRWSWTUCLJUVDOXAVDAKWOUSZUYEABCUVD
      OGUMZUYFUSUYIUEUYJUYCKXGWDKUVOUVPXHXQZAUYAUYJUYFABCUVDOUVKGAUVIUVDUSZCVBO
      USZXIUVJUVKGVNAUYLUVJUYMAUYLXJUVIVOUSZDUVIUJUKZUVJAUYLUYNUYOUVJXIZAUWFUWK
      UYLUYPXRTUWLDEUVIXKVDXLXMXNUVJGIXOWDXPUEWHZUYAUYCKUVEUVOXSWEBCUVDOUVKUVOU
      YAUYAUPXTYAAUVGUVOBCUVFOUVKUMZXCZUXTAMJUNUHZUVGWBURUSZUYEUYRUYTKXFUHZUSUY
      SAMUVFWBURZUSUXAVUAAMHUVFUTUHZVUCRAUXLUVFVOVCVUDVUCUSUXMAUVFUVHVOUXFUWHXE
      UVFHVOWRWSWTUCMJUVFOXAVDUYKAUYRBCUVFOIUMVUBABCUVFOUVKIAUVIUVFUSZUYMXIZUVJ
      UVKIVNZVUFUVJUVIEVNZVUGAVUEUVJVUHXRUYMAVUEXJZUVJUVJEUVIUJUKZXJVUHVUIVUJUV
      JVUIUYNVUJUVIFUJUKZAVUEUYNVUJVUKXIZAUWKUWGVUEVULXRUWLUAEFUVIXKVDXLZYBYCVU
      IUVIEVUIUYNVUJVUKVUMYDAUWKVUEUWLYEUUAUUBXNAUYMVUHVUGUVAVUEAUYMVUHVUGAUYMV
      UHXJXJZUVKUVJIIULIVUNUVJGIIAVUHUYMGIVNUDUUCUUDUVJIUUEWMUUFUUGUUHUVJGIUUIU
      UJXPUFWHZUYRUYTKUVGUVOXSWEBCUVFOUVKUVOUYRUYRUPXTYAUXPBUVDUVFUUKVDAUXPBUVH
      UWNUWOUULUUMBCUVHOUVKUVOUVLUVLUPXTXQAUXGUVNUVOUVLUXNUUNUUOAUYAUYFUVLUVEYF
      ZUVMUVEUTUHZKXFUHUYQAUWEOOVCZVUPUYAVNUWPOUUPZBCUVHOUVDOUVKYGYIAVUQUYCKXFA
      VUQNUVDUTUHZJOUTUHZUNUHZUYCANWOUSZUXAUVDYHUSZUVSVUQVVBVNVVCANUWAWOSHWOUSZ
      UVHYHUSZUWAWOUSHUWIWOPUUQWQZDFUGYJZUVHHYHUURUUSWQYSZUCVVDADEUGYJYSUXDUVDO
      NJWOUWTYHUVRYKYLAVUTLVVAJUNAUWAUVDUTUHZUYHVUTLAVVEUWEVVFVVJUYHVNVVEAVVGYS
      ZUWPVVFAVVHYSZUVDUVHHWOYHYMWENUWAUVDUTSYNQYOAVVAJUWSUTUHZJAOUWSJUTUXBUUTA
      UXAVVMJVNUCJUWTUWSUXCUVBWDYPZYQYPYTYRAUYRVUBUVLUVGYFZUVMUVGUTUHZKXFUHVUOA
      UXEVURVVOUYRVNUXFVUSBCUVHOUVFOUVKYGYIAVVPUYTKXFAVVPNUVFUTUHZVVAUNUHZUYTAV
      VCUXAUVFYHUSZUVSVVPVVRVNVVIUCVVSAEFUGYJYSUXDUVFONJWOUWTYHUVRYKYLAVVQMVVAJ
      UNAUWAUVFUTUHZVUDVVQMAVVEUXEVVFVVTVUDVNVVKUXFVVLUVFUVHHWOYHYMWENUWAUVFUTS
      YNRYOVVNYQYPYTYRUVC $.
  $}

  $( Reverse the unit interval.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
  iirev $p |- ( X e. ( 0 [,] 1 ) -> ( 1 - X ) e. ( 0 [,] 1 ) ) $=
    ( cr wcel cc0 cle wbr c1 w3a cmin co cicc 1re resubcl mpan 3ad2ant1 sylancr
    simp3 wb 0re elicc2i simp1 subge0 mpbird simp2 subge02 mpbid 3jca 3imtr4i )
    ABCZDAEFZAGEFZHZGAIJZBCZDUMEFZUMGEFZHADGKJZCUMUQCULUNUOUPUIUJUNUKGBCZUIUNLG
    AMNOULUOUKUIUJUKQULURUIUOUKRLUIUJUKUAZGAUBPUCULUJUPUIUJUKUDULURUIUJUPRLUSGA
    UEPUFUGDGASLTDGUMSLTUH $.

  ${
    $d x y $.
    $( The reversion function is a continuous map of the unit interval.
       (Contributed by Mario Carneiro, 6-Jun-2014.) $)
    iirevcn $p |- ( x e. ( 0 [,] 1 ) |-> ( 1 - x ) ) e. ( II Cn II ) $=
      ( cc0 c1 cicc co cv cmin cmpt cii ccn wcel wtru ccnfld ctopn cfv dfii2 cr
      eqid a1i cc unitssre iirev adantl ctopon cnfldtopon ax-1cn cnmptc cnmptid
      wss ctx subcn cnmpt12f cnmptre trud ) ABCDEZCAFZGEZHIIJEKLAUOUOMNOZUQIIUR
      RZPPUOQUILUASZUTUPUOKUQUOKLUPUBUCLACUPGURURURURTURTUDOKLURUSUESZLACURURTT
      VAVACTKLUFSUGLAURTVAUHGURURUJEURJEKLURUSUKSULUMUN $.
  $}

  $( Map the first half of ` II ` into ` II ` .  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  iihalf1 $p |- ( X e. ( 0 [,] ( 1 / 2 ) ) -> ( 2 x. X ) e. ( 0 [,] 1 ) ) $=
    ( cr wcel cc0 cle wbr c1 c2 cdiv w3a cmul cicc 2re remulcl 0re 2pos elicc2i
    co wa 1re mpan 3ad2ant1 ltleii mulge0 mpanl12 3adant3 clt wb pm3.2i mp3an23
    lemuldiv2 biimpar 3adant2 3jca 2ne0 rereccli 3imtr4i ) ABCZDAEFZAGHIRZEFZJZ
    HAKRZBCZDVCEFZVCGEFZJADUTLRCVCDGLRCVBVDVEVFURUSVDVAHBCZURVDMHANUAUBURUSVEVA
    VGDHEFURUSSVEMDHOMPUCHAUDUEUFURVAVFUSURVFVAURGBCVGDHUGFZSVFVAUHTVGVHMPUIAGH
    UKUJULUMUNDUTAOHMUOUPQDGVCOTQUQ $.

  ${
    $d x y $.
    iihalf1cn.1 $e |- J = ( ( topGen ` ran (,) ) |`t ( 0 [,] ( 1 / 2 ) ) ) $.
    $( The first half function is a continuous map.  (Contributed by Mario
       Carneiro, 6-Jun-2014.) $)
    iihalf1cn $p |- ( x e. ( 0 [,] ( 1 / 2 ) ) |-> ( 2 x. x ) )
                      e. ( J Cn II ) $=
      ( cc0 c1 c2 cdiv co cicc cv cmul cii ccn wcel wtru cfv cr wss a1i cc cmpt
      ccnfld ctopn eqid dfii2 0re 1re rehalfcli iccssre unitssre iihalf1 adantl
      mp2an ctopon cnfldtopon 2cn cnmptc cnmptid mulcn cnmpt12f cnmptre trud
      ctx ) ADEFGHZIHZFAJZKHZUABLMHNOAVEDEIHZUBUCPZVGBLVIUDZCUEVEQRZODQNVDQNVKU
      FEUGUHDVDUIUMSVHQROUJSVFVENVGVHNOVFUKULOAFVFKVIVIVIVITVITUNPNOVIVJUOSZOAF
      VIVITTVLVLFTNOUPSUQOAVITVLURKVIVIVCHVIMHNOVIVJUSSUTVAVB $.
  $}

  $( Map the second half of ` II ` into ` II ` .  (Contributed by Jeff Madsen,
     2-Sep-2009.) $)
  iihalf2 $p |- ( X e. ( ( 1 / 2 ) [,] 1 ) ->
                                      ( ( 2 x. X ) - 1 ) e. ( 0 [,] 1 ) ) $=
    ( cr wcel c1 c2 cdiv cle wbr w3a cmul cmin cc0 cicc 2re 1re sylancl mp3an23
    co wb elicc2i remulcl mpan resubcl 3ad2ant1 subge0 clt 2pos pm3.2i ledivmul
    wa mp3an13 bitr4d biimpar 3adant3 caddc wceq ax-1cn 2timesi breq2d lesubadd
    a1i lemul2 syl 3bitr4d biimpa 3adant2 3jca 2ne0 rereccli 0re 3imtr4i ) ABCZ
    DEFRZAGHZADGHZIZEAJRZDKRZBCZLVRGHZVRDGHZIAVMDMRCVRLDMRCVPVSVTWAVLVNVSVOVLVQ
    BCZDBCZVSEBCZVLWBNEAUAUBZOVQDUCPUDVLVNVTVOVLVTVNVLVTDVQGHZVNVLWBWCVTWFSWEOV
    QDUEPWCVLWDLEUFHZUJZVNWFSOWDWGNUGUHZDAEUIUKULUMUNVLVOWAVNVLVOWAVLVQEDJRZGHZ
    VQDDUORZGHZVOWAVLWJWLVQGWJWLUPVLDUQURVAUSVLWCWHVOWKSOWIADEVBQVLWBWAWMSZWEWB
    WCWCWNOOVQDDUTQVCVDVEVFVGVMDAENVHVIOTLDVRVJOTVK $.

  ${
    $d x y $.
    iihalf2cn.1 $e |- J = ( ( topGen ` ran (,) ) |`t ( ( 1 / 2 ) [,] 1 ) ) $.
    $( The second half function is a continuous map.  (Contributed by Mario
       Carneiro, 6-Jun-2014.) $)
    iihalf2cn $p |- ( x e. ( ( 1 / 2 ) [,] 1 ) |-> ( ( 2 x. x ) - 1 ) )
                      e. ( J Cn II ) $=
      ( c1 c2 co cicc cmul cmin cii ccn wcel wtru cfv cr wss 1re a1i cc cnmptc
      cdiv cv cmpt cc0 ccnfld ctopn eqid dfii2 rehalfcli iccssre mp2an unitssre
      iihalf2 adantl ctopon cnfldtopon 2cn cnmptid mulcn cnmpt12f recnd cnmptre
      ctx subcn trud ) ADEUAFZDGFZEAUBZHFZDIFZUCBJKFLMAVGUDDGFZUEUFNZVJBJVLUGZC
      UHVGOPZMVFOLDOLZVNDQUIQVFDUJUKRVKOPMULRVHVGLVJVKLMVHUMUNMAVIDIVLVLVLVLSVL
      SUONLMVLVMUPRZMAEVHHVLVLVLVLSVPMAEVLVLSSVPVPESLMUQRTMAVLSVPURHVLVLVCFVLKF
      ZLMVLVMUSRUTMADVLVLSSVPVPMDVOMQRVATIVQLMVLVMVDRUTVBVE $.
  $}

  $( Divide the unit interval into two pieces.  (Contributed by Mario Carneiro,
     7-Jun-2014.) $)
  elii1 $p |- ( X e. ( 0 [,] ( 1 / 2 ) ) <->
                ( X e. ( 0 [,] 1 ) /\ X <_ ( 1 / 2 ) ) ) $=
    ( cc0 c1 c2 cdiv co cicc cle wbr wa cr 0re 1re elicc2i a1i w3a df-3an bitri
    wcel anbi1i rehalfcli simp1bi simp3bi halflt1 ltleii letrd pm4.71ri 3bitr4i
    ancom an32 ) ABCDEFZGFSZACHIZULJZABCGFSZAUKHIZJZULUMULAUKCULAKSZBAHIZUPBUKA
    LCMUAZNZUBUKKSULUTOCKSULMOULURUSUPVAUCUKCHIULUKCUTMUDUEOUFUGUNULUMJZUQUMULU
    IURUSJZUPJZUMJVCUMJZUPJVBUQVCUPUMUJULVDUMULURUSUPPVDVAURUSUPQRTUOVEUPUOURUS
    UMPVEBCALMNURUSUMQRTUHRR $.

  $( Divide the unit interval into two pieces.  (Contributed by Mario Carneiro,
     7-Jun-2014.) $)
  elii2 $p |- ( ( X e. ( 0 [,] 1 ) /\ -. X <_ ( 1 / 2 ) ) ->
                X e. ( ( 1 / 2 ) [,] 1 ) ) $=
    ( cc0 c1 cicc co wcel c2 cle wbr wn wa cr 0re 1re elicc2i simp1bi adantr wo
    cdiv rehalfcli letric sylancl orcanai simp3bi syl3anbrc ) ABCDEFZACGSEZHIZJ
    ZKALFZUGAHIZACHIZAUGCDEFUFUJUIUFUJBAHIZULBCAMNOZPZQUFUHUKUFUJUGLFUHUKRUOCNT
    ZAUGUAUBUCUFULUIUFUJUMULUNUDQUGCAUPNOUE $.

  $( The unit interval is closed under multiplication.  (Contributed by Jeff
     Madsen, 2-Sep-2009.) $)
  iimulcl $p |- ( ( A e. ( 0 [,] 1 ) /\ B e. ( 0 [,] 1 ) )
                                  -> ( A x. B ) e. ( 0 [,] 1 ) ) $=
    ( cr wcel cc0 cle wbr c1 wa cmul co cicc remulcl 3ad2antr1 3ad2antl1 mulge0
    w3a 1re 0re elicc2i 3adantr3 3adantl3 wi lemul12a mpanr2 mpanl2 an4s 3impia
    an6 sylbi 1t1e1 syl6breq 3jca anbi12i 3imtr4i ) ACDZEAFGZAHFGZQZBCDZEBFGZBH
    FGZQZIZABJKZCDZEVEFGZVEHFGZQAEHLKZDZBVIDZIVEVIDVDVFVGVHUPUQVCVFURUPVAUTVFVB
    ABMNOUPUQVCVGURUPUQIZUTVAVGVBABPUAUBVDVEHHJKZHFVDUPUTIZUQVAIZURVBIZQVEVMFGZ
    UPUQURUTVAVBUIVNVOVPVQUPUQUTVAVPVQUCZVLHCDZUTVAIZVRRVLVSIVTVSVRRAHBHUDUEUFU
    GUHUJUKULUMVJUSVKVCEHASRTEHBSRTUNEHVESRTUO $.

  ${
    $d x y $.
    $( Multiplication is a continuous function on the unit interval.
       (Contributed by Mario Carneiro, 8-Jun-2014.) $)
    iimulcn $p |- ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |-> ( x x. y ) )
                  e. ( ( II tX II ) Cn II ) $=
      ( co cv cmul cmpt2 cii ctx cfv ccn wcel wtru cc eqid a1i wss cxp wf ax-mp
      mpbi cc0 c1 ccnfld ctopn crest dfii3 ctopon cnfldtopon unitssre ax-resscn
      cicc cr sstri wfn wceq ax-mulf ffn fnov mulcn eqeltrri cnmpt2res trud crn
      wb wral iimulcl rgen2a fmpt2 frn sylbi cnrest2 mp3an oveq2i eleqtrri ) AB
      UAUBUKCZVOADZBDZECZFZGGHCZUCUDIZVOUECZJCZVTGJCVSVTWAJCKZVSWCKZWDLABVRWAGW
      AWAGVOMVOMWAWANZUFZWAMUGIKZLWAWFUHZOZVOMPZLVOULMUIUJUMZOZWGWJWMABMMVRFZWA
      WAHCWAJCZKLEWNWOEMMQZUNZEWNUOWPMERWQUPWPMEUQSABMMEURTWAWFUSUTOVAVBWHVSVCV
      OPZWKWDWEVDWIVRVOKZBVOVEAVOVEZWRWSABVOVPVQVFVGWTVOVOQZVOVSRWRABVOVOVRVOVS
      VSNVHXAVOVSVIVJSWLVOVSVTWAMVKVLTGWBVTJWGVMVN $.
  $}

  ${
    $d J v $.  $d A v $.  $d B v $.  $d C v $.
    icoopnst.1 $e |- J = ( MetOpen ` ( ( abs o. - ) |`
                                    ( ( A [,] B ) X. ( A [,] B ) ) ) ) $.
    $( A half-open interval starting at ` A ` is open in the closed interval
       from ` A ` to ` B ` .  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Revised by Mario Carneiro, 15-Dec-2013.) $)
    icoopnst $p |- ( ( A e. RR /\ B e. RR ) ->
                                ( C e. ( A (,] B ) -> ( A [,) C ) e. J ) ) $=
      ( vv cr wcel wa co wceq cle wbr clt w3a wi a1i adantr ex wb cioc cico crn
      cioo ctg cfv cicc crest cv cin wrex c1 cmin iooretop simp1 ltm1 peano2rem
      ltletr 3expb mpancom mpand 3adantr3 ad2antrr simp3 3jcad simp2 cxr elioc2
      impr rexr sylan biimpa ltle 3adant2 syld 3expa an31s imp ancom2s 3adantr2
      an4s anasss adantll syldan simpl1 simpr2 simpl3 impbid1 simpll simp1d syl
      jcad 3jca elico2 syl2anc elioo2 elicc2 anbi12d syl5bb 3bitr4d eqrdv ineq1
      elin eqeq2d rspcev sylancr ctop cvv retop elrest mp2an sylibr wss iccssre
      ovex eqid resubmet eleqtrrd ) AGHZBGHZIZCABUAJHZACUBJZDHYAYBIZYCUDUCUEUFZ
      ABUGJZUHJZDYDYCFUIZYFUJZKZFYEUKZYCYGHZYDAULUMJZCUDJZYEHYCYNYFUJZKZYKYMCUN
      YDFYCYOYDYHGHZAYHLMZYHCNMZOZYQYMYHNMZYSOZYQYRYHBLMZOZIZYHYCHZYHYOHZYDYTUU
      EYDYTUUBUUDYDYTYQUUAYSYTYQPYDYQYRYSUOQZXSYTUUAPXTYBXSYTUUAXSYQYRUUAYSXSYQ
      YRUUAXSYQIZYMANMZYRUUAXSUUJYQAUPRYMGHZUUIUUJYRIUUAPZXSUUKYQAUQZRUUKXSYQUU
      LYMAYHURUSUTVAVIVBSVCYTYSPYDYQYRYSVDQVEYDYTYQYRUUCUUHYTYRPYDYQYRYSVFQYAYB
      CGHZACNMZCBLMZOZYTUUCPZYAYBUUQXSAVGHXTYBUUQTAVJABCVHVKVLZXTUUQUURXSXTUUNU
      UPUURUUOXTUUNUUPUURXTUUNIZUUPIZYTUUCUVAYQYSUUCYRUUTYQUUPYSUUCUUTYQIZYSUUP
      UUCUVBYSUUPIZUUCYQUUNXTUVCUUCPZYQUUNXTUVDYQUUNXTOUVCYHBNMZUUCYHCBURYQXTUV
      EUUCPUUNYHBVMVNVOVPVQVRVSWAVTSWBVTWCWDVEWLUUEYQYRYSYQUUAYSUUDWEUUBYQYRUUC
      WFYQUUAYSUUDWGWMWHYDXSCVGHZUUFYTTXSXTYBWIYDUUNUVFYDUUNUUOUUPUUSWJCVJWKZAC
      YHWNWOUUGYHYNHZYHYFHZIYDUUEYHYNYFXCYDUVHUUBUVIUUDYDYMVGHZUVFUVHUUBTXSUVJX
      TYBXSUUKUVJUUMYMVJWKVCUVGYMCYHWPWOYAUVIUUDTYBABYHWQRWRWSWTXAYJYPFYNYEYHYN
      KYIYOYCYHYNYFXBXDXEXFYEXGHYFXHHYLYKTXIABUGXOFYCYFYEXGXHXJXKXLYDYFGXMZDYGK
      YAUVKYBABXNRYFYEDYEXPEXQWKXRS $.
  $}

  ${
    $d J v $.  $d A v $.  $d B v $.  $d C v $.
    iocopnst.1 $e |- J = ( MetOpen ` ( ( abs o. - ) |`
                                    ( ( A [,] B ) X. ( A [,] B ) ) ) ) $.
    $( A half-open interval ending at ` B ` is open in the closed interval from
       ` A ` to ` B ` .  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by
       Mario Carneiro, 15-Dec-2013.) $)
    iocopnst $p |- ( ( A e. RR /\ B e. RR ) ->
                                ( C e. ( A [,) B ) -> ( C (,] B ) e. J ) ) $=
      ( vv cr wcel wa co wceq clt wbr cle w3a wi a1i adantr ex wb cico cioc crn
      cioo ctg cfv cicc crest cv cin wrex c1 caddc iooretop simp1 ltp1 peano2re
      simp2 lelttr 3expa ancom1s ancomsd mpdan mpand impr 3adantr2 ad2antlr cxr
      3jcad rexr elico2 sylan2 biimpa ltle 3adant2 syld imp an4s anasss adantlr
      3adantr3 syldan simp3 jcad simpl1 simpl2 simpr3 impbid1 simp1d syl simplr
      3jca elioc2 syl2anc elin elioo2 elicc2 anbi12d syl5bb 3bitr4d eqrdv ineq1
      eqeq2d rspcev sylancr ctop cvv retop ovex elrest mp2an sylibr wss iccssre
      eqid resubmet eleqtrrd ) AGHZBGHZIZCABUAJHZCBUBJZDHXTYAIZYBUDUCUEUFZABUGJ
      ZUHJZDYCYBFUIZYEUJZKZFYDUKZYBYFHZYCCBULUMJZUDJZYDHYBYMYEUJZKZYJCYLUNYCFYB
      YNYCYGGHZCYGLMZYGBNMZOZYPYQYGYLLMZOZYPAYGNMZYROZIZYGYBHZYGYNHZYCYSUUDYCYS
      UUAUUCYCYSYPYQYTYSYPPYCYPYQYRUOQZYSYQPYCYPYQYRURQXSYSYTPXRYAXSYSYTXSYPYRY
      TYQXSYPYRYTXSYPIZBYLLMZYRYTXSUUIYPBUPRUUHYLGHZUUIYRIYTPXSUUJYPBUQZRUUHUUJ
      IYRUUIYTYPXSUUJYRUUIIYTPZYPXSUUJUULYGBYLUSUTVAVBVCVDVEVFSVGVIYCYSYPUUBYRU
      UGXTYACGHZACNMZCBLMZOZYSUUBPZXTYAUUPXSXRBVHHYAUUPTBVJABCVKVLVMZXRUUPUUQXS
      XRUUMUUNUUQUUOXRUUMUUNUUQXRUUMIZUUNIZYSUUBUUTYPYQUUBYRUUSYPUUNYQUUBUUSYPI
      UUNYQIZUUBXRUUMYPUVAUUBPXRUUMYPOUVAAYGLMZUUBACYGUSXRYPUVBUUBPUUMAYGVNVOVP
      UTVQVRWASVSWAVTWBYSYRPYCYPYQYRWCQVIWDUUDYPYQYRYPYQYTUUCWEYPYQYTUUCWFUUAYP
      UUBYRWGWLWHYCCVHHZXSUUEYSTYCUUMUVCYCUUMUUNUUOUURWICVJWJZXRXSYAWKCBYGWMWNU
      UFYGYMHZYGYEHZIYCUUDYGYMYEWOYCUVEUUAUVFUUCYCUVCYLVHHZUVEUUATUVDXSUVGXRYAX
      SUUJUVGUUKYLVJWJVGCYLYGWPWNXTUVFUUCTYAABYGWQRWRWSWTXAYIYOFYMYDYGYMKYHYNYB
      YGYMYEXBXCXDXEYDXFHYEXGHYKYJTXHABUGXIFYBYEYDXFXGXJXKXLYCYEGXMZDYFKXTUVHYA
      ABXNRYEYDDYDXOEXPWJXQS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d v w y z F $.  $d w z G $.  $d v w x y z J $.
    ${
      icchmeo.j $e |- J = ( TopOpen ` CCfld ) $.
      icchmeo.f $e |- F = ( x e. ( 0 [,] 1 ) |->
        ( ( x x. B ) + ( ( 1 - x ) x. A ) ) ) $.
      $( The natural bijection from ` [ 0 , 1 ] ` to an arbitrary nontrivial
         closed interval ` [ A , B ] ` is a homeomorphism.  (Contributed by
         Mario Carneiro, 8-Sep-2015.) $)
      icchmeo $p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
        F e. ( II Homeo ( J |`t ( A [,] B ) ) ) ) $=
        ( vy cr wcel cii co ccn c1 cmul cmin cmpt a1i wss cc clt wbr cicc crest
        w3a ccnv chmeo cc0 cv caddc ctopon cfv iitopon oveq2i cnfldtop cnrest2r
        dfii3 ctop ax-mp eqsstri sseldi cnfldtopon simp2 recnd cnmptc ctx mulcn
        cnmptid cnmpt12f ax-1cn subcn simp1 addcn syl5eqel wb wf1o wf cdiv wceq
        crn iccf1o simpld f1of iccssre 3adant3 ax-resscn syl6ss cnrest2 syl3anc
        frn 3syl mpbid simprd resttopon sylancr wne difrp biimp3a rpne0d divccn
        crp rpcnd syl2anc oveq1 cnmpt11 eqeltrd cdm dfdm4 eqimss2i syl syl5sseq
        f1odm unitssre syl6eleqr ishmeo sylanbrc ) BIJZCIJZBCUAUBZUEZDKEBCUCLZU
        DLZMLJZDUFZYBKMLZJDKYBUGLJXTDKEMLZJZYCXTDAUHNUCLZAUIZCOLZNYIPLZBOLZUJLQ
        YFGXTAYJYLUJKEEEYHKYHUKULJXTUMRZXTAYICOKEEEYHYMXTKKMLZYFAYHYIQYNKEYHUDL
        ZMLZYFKYOKMEFUQZUNEURJZYPYFSEFUOZYHKEUPUSUTXTAKYHYMVHVAZXTACKEYHTYMETUK
        ULJZXTEFVBZRZXTCXQXRXSVCVDVEOEEVFLEMLZJXTEFVGRZVIXTAYKBOKEEEYHYMXTANYIP
        KEEEYHYMXTANKEYHTYMUUCNTJXTVJRVEYTPUUDJXTEFVKRZVIXTABKEYHTYMUUCXTBXQXRX
        SVLVDZVEUUEVIUJUUDJXTEFVMRVIVNXTUUADVTYASZYATSZYGYCVOUUCXTYHYADVPZYHYAD
        VQUUHXTUUJYDHYAHUIZBPLZCBPLZVRLZQZVSZAHBCDGWAZWBZYHYADWCYHYADWJWKXTYAIT
        XQXRYAISXSBCWDWEWFWGZYADKETWHWIWLXTYDYBYOMLZYEXTYDYBEMLZJZYDUUTJZXTYDUU
        OUVAXTUUJUUPUUQWMXTHAUULYIUUMVRLZUUNYBEEYATXTUUAUUIYBYAUKULJUUBUUSYAETW
        NWOZXTHUUKBPYBEEEYAUVEXTYBYBMLZUVAHYAUUKQYRUVFUVASYSYAYBEUPUSXTHYBYAUVE
        VHVAXTHBYBEYATUVEUUCUUGVEUUFVIUUCXTUUMTJUUMUHWPATUVDQEEMLJXTUUMXQXRXSUU
        MXAJBCWQWRZXBXTUUMUVGWSAUUMEFWTXCYIUULUUMVRXDXEXFXTUUAYDVTZYHSYHTSUVBUV
        CVOUUCXTDXGZUVHYHUVIUVHDXHXIXTUUJUVIYHVSUURYHYADXLXJXKXTYHITYHISXTXMRWF
        WGYHYDYBETWHWIWLKYOYBMYQUNXNDKYBXOXP $.
    $}

    ${
      icopnfhmeo.f $e |- F = ( x e. ( 0 [,) 1 ) |-> ( x / ( 1 - x ) ) ) $.
      $( Define a bijection from ` [ 0 , 1 ) ` to ` [ 0 , +oo ) ` .
         (Contributed by Mario Carneiro, 9-Sep-2015.) $)
      icopnfcnv $p |- ( F : ( 0 [,) 1 ) -1-1-onto-> ( 0 [,) +oo ) /\
        `' F = ( y e. ( 0 [,) +oo ) |-> ( y / ( 1 + y ) ) ) ) $=
        ( cc0 c1 co caddc wceq wtru cmin wcel cr cle wbr clt wb 1re adantl cmul
        cico cpnf wf1o ccnv cv cdiv cmpt cxr w3a 0re rexri elico2 mp2an simp1bi
        simp3bi difrp sylancl mpbid rerpdivcld simp2bi divge0d elrege0 sylanbrc
        wa crp simplbi readdcl sylancr a1i simprbi ltp1d cc ax-1cn recnd addcom
        breqtrrd lelttrd elrpd divge0 syl22anc ltdivmul syl112anc mpbird adantr
        mulid1d syl3anbrc mulcld subadd2d subdird mulid2d oveq1d eqtrd 3bitr4rd
        eqeq1d adddid eqcom 3bitr4g rpne0d divmul3d rpcnd divmul2d 3bitr4d trud
        f1ocnv2d ) EFUAGZEUBUAGZCUCCUDBXFBUEZFXGHGZUFGZUGIVDJABXEXFAUEZFXJKGZUF
        GZXICDXJXELZXLXFLZJXMXLMLEXLNOXNXMXJXKXMXJMLZEXJNOZXJFPOZEMLZFUHLZXMXOX
        PXQUIQUJFRUKZEFXJULUMZUNZXMXQXKVELZXMXOXPXQYAUOXMXOFMLZXQYCQYBRXJFUPUQU
        RZUSXMXJXKYBYEXMXOXPXQYAUTVAXLVBVCSXGXFLZXIXELZJYFXIMLZEXINOZXIFPOZYGYF
        XGXHYFXGMLZEXGNOZXGVBZVFZYFXHYFYDYKXHMLZRYNFXGVGVHZYFEXGXHXRYFUJVIYNYPY
        FYKYLYMVJZYFXGXGFHGZXHPYFXGYNVKYFFVLLZXGVLLZXHYRIVMYFXGYNVNZFXGVOVHVPZV
        QZVRZUSYFYKYLYOEXHPOZYIYNYQYPUUCXGXHVSVTYFYJXGXHFTGZPOZYFXGXHUUFPUUBYFX
        HYFXHYPVNZWEVPYFYKYDYOUUEYJUUGQYNYDYFRVIYPUUCXGFXHWAWBWCXRXSYGYHYIYJUIQ
        UJXTEFXIULUMWFSXMYFVDZXJXIIZXGXLIZQJUUIXIXJIZXLXGIZUUJUUKUUIXGXJXHTGZIZ
        XJXKXGTGZIZUULUUMUUIUUNXGIZUUPXJIZUUOUUQUUIXGXJXGTGZKGZXJIXJUUTHGZXGIUU
        SUURUUIXGUUTXJYFYTXMUUASZUUIXJXGUUIXJXMXOYFYBWDVNZUVCWGUVDWHUUIUUPUVAXJ
        UUIUUPFXGTGZUUTKGUVAUUIFXJXGYSUUIVMVIZUVDUVCWIUUIUVEXGUUTKUUIXGUVCWJWKW
        LWNUUIUUNUVBXGUUIUUNXJFTGZUUTHGUVBUUIXJFXGUVDUVFUVCWOUUIUVGXJUUTHUUIXJU
        VDWEWKWLWNWMXGUUNWPXJUUPWPWQUUIXGXJXHUVCUVDYFXHVLLXMUUHSUUIXHYFXHVELXMU
        UDSWRWSUUIXJXGXKUVDUVCUUIXKXMYCYFYEWDZWTUUIXKUVHWRXAXBXJXIWPXGXLWPWQSXD
        XC $.

      icopnfhmeo.j $e |- J = ( TopOpen ` CCfld ) $.
      $( The defined bijection from ` [ 0 , 1 ) ` to ` [ 0 , +oo ) ` is an
         order isomorphism and a homeomorphism.  (Contributed by Mario
         Carneiro, 9-Sep-2015.) $)
      icopnfhmeo $p |- ( F Isom < , < ( ( 0 [,) 1 ) , ( 0 [,) +oo ) ) /\
        F e. ( ( J |`t ( 0 [,) 1 ) ) Homeo ( J |`t ( 0 [,) +oo ) ) ) ) $=
        ( vy cc0 c1 co clt wcel wbr wb cdiv wceq cmin cmul cr cle mp2an vz cico
        vw cpnf wiso crest chmeo wf1o cfv wral ccnv caddc cmpt icopnfcnv simpli
        cv wa cxr w3a 0re 1re rexri elico2 simp1bi ssriv sseli adantr crp difrp
        simp3bi sylancl mpbid rpregt0d adantl lt2mul2div syl22anc ltsub1d recnd
        remulcld ax-1cn a1i subdid mulid1d oveq1d eqtrd mulcomd oveq12d breq12d
        cc bitr4d id oveq2 ovex fvmpt breqan12d 3bitr4d rgen2a df-isom mpbir2an
        cxp cin cordt cvv ctsr letsr elexi inex1 wss icossxr leiso mpbi isores1
        isores2 cdm cps tsrps ax-mp ledm psssdm eqcomi ordthmeo mp3an iccssico2
        eqid xrrest2 ordtrestixx eqtri elrege0 simplbi oveq12i eleqtrri pm3.2i
        ) GHUBIZGUDUBIZJJBUEZBCYMUFIZCYNUFIZUGIZKYOYMYNBUHZUAUPZUCUPZJLZYTBUIZU
        UABUIZJLZMZUCYMUJUAYMUJYSBUKFYNFUPZHUUGULINIUMOAFBDUNUOUUFUAUCYMYTYMKZU
        UAYMKZUQZYTHUUAPIZQIZUUAHYTPIZQIZJLZYTUUMNIZUUAUUKNIZJLZUUBUUEUUJYTRKZU
        UKRKGUUKJLUQZUUARKZUUMRKGUUMJLUQUUOUURMUUHUUSUUIYMRYTAYMRAUPZYMKZUVBRKZ
        GUVBSLZUVBHJLZGRKZHURKZUVCUVDUVEUVFUSMUTHVAVBZGHUVBVCTVDVEZVFZVGZUUIUUT
        UUHUUIUUKUUIUUAHJLZUUKVHKZUUIUVAGUUASLZUVMUVGUVHUUIUVAUVOUVMUSMUTUVIGHU
        UAVCTVJUUIUVAHRKZUVMUVNMYMRUUAUVJVFZVAUUAHVIVKVLVMVNUUIUVAUUHUVQVNZUUJU
        UMUUHUUMVHKZUUIUUHYTHJLZUVSUUHUUSGYTSLZUVTUVGUVHUUHUUSUWAUVTUSMUTUVIGHY
        TVCTVJUUHUUSUVPUVTUVSMUVKVAYTHVIVKVLVGVMYTUUKUUAUUMVOVPUUJUUBYTYTUUAQIZ
        PIZUUAUWBPIZJLUUOUUJYTUUAUWBUVLUVRUUJYTUUAUVLUVRVSVQUUJUULUWCUUNUWDJUUJ
        UULYTHQIZUWBPIUWCUUJYTHUUAUUJYTUVLVRZHWIKUUJVTWAZUUJUUAUVRVRZWBUUJUWEYT
        UWBPUUJYTUWFWCWDWEUUJUUNUUAHQIZUUAYTQIZPIUWDUUJUUAHYTUWHUWGUWFWBUUJUWIU
        UAUWJUWBPUUJUUAUWHWCUUJUUAYTUWHUWFWFWGWEWHWJUUHUUIUUCUUPUUDUUQJAYTUVBHU
        VBPIZNIZUUPYMBUVBYTOZUVBYTUWKUUMNUWMWKUVBYTHPWLWGDYTUUMNWMWNAUUAUWLUUQY
        MBUVBUUAOZUVBUUAUWKUUKNUWNWKUVBUUAHPWLWGDUUAUUKNWMWNWOWPWQUAUCYMYNJJBWR
        WSZBSYMYMWTZXAZXBUIZSYNYNWTZXAZXBUIZUGIZYRUWQXCKUWTXCKYMYNUWQUWTBUEZBUX
        BKSUWPSXDXEXFZXGSUWSUXDXGYMYNUWQSBUEZUXCYMYNSSBUEZUXEYOUXFUWOYMURXHZYNU
        RXHZYOUXFMGHXIZGUDXIZYMYNBXJTXKYMYNSSBXLXKYMYNUWQSBXMXKUWQUWTBXCXCYMYNU
        WQXNZYMSXOKZUXGUXKYMOSXDKUXLXESXPXQZUXIYMSURXRXSTXTUWTXNZYNUXLUXHUXNYNO
        UXMUXJYNSURXRXSTXTYAYBYPUWRYQUXAUGYPSXBUIZYMUFIZUWRYMRXHYPUXPOUVJYMCUXO
        EUXOYDZYEXQAFYMUXIGHUVBUUGYCYFYGYQUXOYNUFIZUXAYNRXHYQUXROFYNRUUGYNKUUGR
        KGUUGSLUUGYHYIVEYNCUXOEUXQYEXQAFYNUXJGUDUVBUUGYCYFYGYJYKYL $.
    $}

    ${
      iccpnfhmeo.f $e |- F = ( x e. ( 0 [,] 1 ) |->
        if ( x = 1 , +oo , ( x / ( 1 - x ) ) ) ) $.
      $( Define a bijection from ` [ 0 , 1 ] ` to ` [ 0 , +oo ] ` .
         (Contributed by Mario Carneiro, 9-Sep-2015.) $)
      iccpnfcnv $p |- ( F : ( 0 [,] 1 ) -1-1-onto-> ( 0 [,] +oo ) /\ `' F =
        ( y e. ( 0 [,] +oo ) |-> if ( y = +oo , 1 , ( y / ( 1 + y ) ) ) ) ) $=
        ( cc0 c1 co cpnf wceq cdiv wa wtru wcel wbr 0xr wn adantl wb eqeq2 cr
        cicc wf1o ccnv cv caddc cif cmpt cxr cle pnfxr pnfge ax-mp ubicc2 mp3an
        cmin a1i cico csn cun ssun1 snunico sseqtri wo wi 1re rexri 0le1 eleq2i
        elun bitr3i pm2.53 sylbi elsni syl6 con1d wral wf eqid icopnfcnv simpli
        imp f1of fmpt mpbir syl sseldi ifclda 1elunit f1ocnv mp2b simpri bibi1d
        rspec iftrue eqeq2d syl5ibrcom wnel pnfnre neleq1 mpbiri df-nel iffalse
        simpr syl5ibcom wss 0re icossre mp2an eqeltrd ex ad2antrr syl5bi impbid
        syld bibi2d wne clt w3a elico2 sylib simp1d simp3d gtned adantll neneqd
        eqeq1 notbid simplr 2falsed cfv f1ocnvfvb mp3an1 cvv simpl ovex sylancl
        fvmpt2 eqeq1d eqcom ifbothda 3bitr3rd 3bitr4g syl2an an4s anass1rs trud
        f1ocnv2d ) EFUAGZEHUAGZCUBCUCBUUIBUDZHIZFUUJFUUJUEGZJGZUFZUGIKLABUUHUUI
        AUDZFIZHUUOFUUOUOGZJGZUFZUUNCDUUOUUHMZUUSUUIMLUUTUUPHUURUUIHUUIMZUUTUUP
        KEUHMZHUHMZEHUINZUVAOUJUVBUVDOEUKULZEHUMUNUPUUTUUPPZKZEHUQGZUUIUURUVHUV
        HHURZUSZUUIUVHUVIUTUVBUVCUVDUVJUUIIOUJUVEEHVAUNZVBUVGUUOEFUQGZMZUURUVHM
        ZUUTUVFUVMUUTUVMUUPUUTUVMPZUUOFURZMZUUPUUTUVMUVQVCZUVOUVQVDUUTUUOUVLUVP
        USZMUVRUVSUUHUUOUVBFUHMZEFUINUVSUUHIOFVEVFZVGEFVAUNZVHUUOUVLUVPVIVJUVMU
        VQVKVLUUOFVMVNVOWAZUVNAUVLUVNAUVLVPUVLUVHAUVLUURUGZVQZUVLUVHUWDUBZUWEUW
        FUWDUCZBUVHUUMUGIZABUWDUWDVRZVSZVTZUVLUVHUWDWBULAUVLUVHUURUWDUWIWCWDWMW
        EZWFWGQUUJUUIMZUUNUUHMLUWMUUKFUUMUUHFUUHMUWMUUKKWHUPUWMUUKPZKZUVLUUHUUM
        UVLUVSUUHUVLUVPUTUWBVBUWOUUJUVHMZUUMUVLMZUWMUWNUWPUWMUWPUUKUWMUWPPZUUJU
        VIMZUUKUWMUWPUWSVCZUWRUWSVDUWMUUJUVJMUWTUVJUUIUUJUVKVHUUJUVHUVIVIVJUWPU
        WSVKVLUUJHVMVNVOWAZUWQBUVHUWQBUVHVPUVHUVLUWGVQZUWFUVHUVLUWGUBUXBUWKUVLU
        VHUWDWIUVHUVLUWGWBWJBUVHUVLUUMUWGUWFUWHUWJWKZWCWDWMWEZWFWGQUUTUWMKZUUOU
        UNIZUUJUUSIZRZLUUKUUPUXGRUUOUUMIZUXGRZUXHUXEFUUMFUUNIUUPUXFUXGFUUNUUOSW
        LUUMUUNIUXIUXFUXGUUMUUNUUOSWLUXEUUKKZUUPUXGUXKUXGUUPUUKUXEUUKXCUUPUUSHU
        UJUUPHUURWNWOWPUXKUXGUUSTWQZUUPUXKUUJTWQZUXGUXLUXKUXMHTWQZWRUUKUXMUXNRU
        XEUUJHTWSQWTUUJUUSTWSXDUXLUUSTMZPUXKUUPUUSTXAUXKUUPUXOUUTUVFUXOVDUWMUUK
        UUTUVFUXOUVGUUSUURTUVFUUSUURIUUTUUPHUURXBQUVGUVHTUURETMZUVCUVHTXEXFUJEH
        XGXHUWLWFXIXJXKVOXLXNXMUUPUXIUUKRUXIUUJUURIZRZUXJUXEUWNKZHUURHUUSIUUKUX
        GUXIHUUSUUJSXOUURUUSIUXQUXGUXIUURUUSUUJSXOUXSUUPKUXIUUKUXSUUPUXIPZUXSUX
        TUUPFUUMIZPUXSFUUMUWMUWNFUUMXPUUTUWOUUMFUWOUUMTMZEUUMUINZUUMFXQNZUWOUWQ
        UYBUYCUYDXRZUXDUXPUVTUWQUYERXFUWAEFUUMXSXHXTZYAUWOUYBUYCUYDUYFYBYCYDYEU
        UPUXIUYAUUOFUUMYFYGWPWAUXEUWNUUPYHYIUXEUVFUWNUXRUUTUVFUWMUWNUXRUVGUVMUW
        PUXRUWOUWCUXAUVMUWPKZUUMUUOIZUURUUJIZUXIUXQUYGUUOUWDYJZUUJIZUUJUWGYJZUU
        OIZUYIUYHUWFUVMUWPUYKUYMRUWKUVLUVHUUOUUJUWDYKYLUYGUYJUURUUJUYGUVMUURYMM
        UYJUURIUVMUWPYNUUOUUQJYOAUVLUURYMUWDUWIYQYPYRUYGUYLUUMUUOUYGUWPUUMYMMUY
        LUUMIUVMUWPXCUUJUULJYOBUVHUUMYMUWGUXCYQYPYRUUAUUOUUMYSUUJUURYSUUBUUCUUD
        UUEYTYTQUUGUUF $.

      iccpnfhmeo.k $e |- K = ( ( ordTop ` <_ ) |`t ( 0 [,] +oo ) ) $.
      $( The defined bijection from ` [ 0 , 1 ] ` to ` [ 0 , +oo ] ` is an
         order isomorphism and a homeomorphism.  (Contributed by Mario
         Carneiro, 8-Sep-2015.) $)
      iccpnfhmeo $p |- ( F Isom < , < ( ( 0 [,] 1 ) , ( 0 [,] +oo ) ) /\
        F e. ( II Homeo K ) ) $=
        ( cc0 c1 co cpnf clt wiso wcel wbr cfv cxr wceq cdiv cmin cr cle vz cii
        vw vy cicc chmeo wor wpo wfo cv wral wss iccssxr xrltso soss sopo ax-mp
        mp2 wf1o ccnv caddc cif cmpt iccpnfcnv simpli f1ofo w3a wne 0re elicc2i
        wi 1re simp1bi 3ad2ant1 3ad2ant2 a1i simp3 simp3bi ltletrd gtned necomd
        wa ifnefalse syl breq2 resubcl sylancr cc ax-1cn recnd subeq0 necon3bid
        wb mpbird redivcld ltpnf adantr wn simpl3 ccnfld ctopn crest icopnfhmeo
        cico eqid csn cun simp1 0xr rexri mp3an syl6eleqr elun sylib elsni syl6
        wo ord oveq2 oveq12d ovex fvmpt eqeq1 ifbieq2d elexi ifex cxp cin cordt
        id cvv ctsr letsr inex1 mp2an mpbi cdm ledm psssdm eqcomi 0le1 necon1ad
        snunico mpd simp2 con1d isorel syl12anc 3brtr3d ifbothda eqbrtrd 3expia
        mpbid pnfxr breqan12d sylibrd rgen2a soisoi mp4an leiso isores1 isores2
        imp cps tsrps ordthmeo dfii5 ordtresticc eqtri oveq12i eleqtrri pm3.2i
        ) FGUEHZFIUEHZJJBKZBUBCUFHZLUVMJUGZUVNJUHZUVMUVNBUIZUAUJZUCUJZJMZUVTBNZ
        UWABNZJMZVKZUCUVMUKUAUVMUKUVOUVMOULZOJUGZUVQFGUMZUNUVMOJUOURUVNJUGZUVRU
        VNOULZUWHUWJFIUMZUNUVNOJUOURUVNJUPUQUVMUVNBUSZUVSUWMBUTUDUVNUDUJZIPGUWN
        GUWNVAHQHVBVCPAUDBDVDVEUVMUVNBVFUQUWFUAUCUVMUVTUVMLZUWAUVMLZWBUWBUVTGPZ
        IUVTGUVTRHZQHZVBZUWAGPZIUWAGUWARHZQHZVBZJMZUWEUWOUWPUWBUXEUWOUWPUWBVGZU
        WTUWSUXDJUXFUVTGVHZUWTUWSPUXFGUVTUXFUVTGUWOUWPUVTSLZUWBUWOUXHFUVTTMUVTG
        TMFGUVTVIVLVJVMVNZUXFUVTUWAGUXIUWPUWOUWASLZUWBUWPUXJFUWATMZUWAGTMZFGUWA
        VIVLVJZVMVOGSLZUXFVLVPUWOUWPUWBVQUWPUWOUXLUWBUWPUXJUXKUXLUXMVRVOVSVTZWA
        ZUVTGIUWSWCWDUXAUWSIJMZUWSUXCJMUWSUXDJMUXFIUXCIUXDUWSJWEUXCUXDUWSJWEUXF
        UXQUXAUXFUWSSLUXQUXFUVTUWRUXIUXFUXNUXHUWRSLVLUXIGUVTWFWGUXFUWRFVHZGUVTV
        HZUXOUXFGWHLZUVTWHLZUXRUXSWMWIUXFUVTUXIWJUXTUYAWBUWRFGUVTGUVTWKWLWGWNWO
        UWSWPWDWQUXFUXAWRZWBZUVTAFGXDHZAUJZGUYERHZQHZVCZNZUWAUYHNZUWSUXCJUYCUWB
        UYIUYJJMZUWOUWPUWBUYBWSUYCUYDFIXDHZJJUYHKZUVTUYDLZUWAUYDLZUWBUYKWMUYMUY
        CUYMUYHWTXANZUYDXBHUYPUYLXBHUFHLAUYHUYPUYHXEZUYPXEXCVEVPUXFUYNUYBUXFUXG
        UYNUXPUXFUYNUVTGUXFUYNWRUVTGXFZLZUWQUXFUYNUYSUXFUVTUYDUYRXGZLUYNUYSXQUX
        FUVTUVMUYTUWOUWPUWBXHFOLGOLFGTMUYTUVMPXIGVLXJUUAFGUUCXKZXLUVTUYDUYRXMXN
        XRUVTGXOXPUUBUUDWQZUXFUYBUYOUXFUYOUXAUXFUYOWRUWAUYRLZUXAUXFUYOVUCUXFUWA
        UYTLUYOVUCXQUXFUWAUVMUYTUWOUWPUWBUUEVUAXLUWAUYDUYRXMXNXRUWAGXOXPUUFUVCZ
        UYDUYLUVTUWAJJUYHUUGUUHUUMUYCUYNUYIUWSPVUBAUVTUYGUWSUYDUYHUYEUVTPZUYEUV
        TUYFUWRQVUEYJUYEUVTGRXSXTZUYQUVTUWRQYAZYBWDUYCUYOUYJUXCPVUDAUWAUYGUXCUY
        DUYHUYEUWAPZUYEUWAUYFUXBQVUHYJUYEUWAGRXSXTZUYQUWAUXBQYAZYBWDUUIUUJUUKUU
        LUWOUWPUWCUWTUWDUXDJAUVTUYEGPZIUYGVBZUWTUVMBVUEVUKUWQUYGUWSIUYEUVTGYCVU
        FYDDUWQIUWSIOUUNYEZVUGYFYBAUWAVULUXDUVMBVUHVUKUXAUYGUXCIUYEUWAGYCVUIYDD
        UXAIUXCVUMVUJYFYBUUOUUPUUQUAUCUVMUVNJJBUURUUSZBTUVMUVMYGZYHZYINZTUVNUVN
        YGZYHZYINZUFHZUVPVUPYKLVUSYKLUVMUVNVUPVUSBKZBVVALTVUOTYLYMYEZYNTVURVVCY
        NUVMUVNVUPTBKZVVBUVMUVNTTBKZVVDUVOVVEVUNUWGUWKUVOVVEWMUWIUWLUVMUVNBUUTY
        OYPUVMUVNTTBUVAYPUVMUVNVUPTBUVBYPVUPVUSBYKYKUVMUVNVUPYQZUVMTUVDLZUWGVVF
        UVMPTYLLVVGYMTUVEUQZUWIUVMTOYRYSYOYTVUSYQZUVNVVGUWKVVIUVNPVVHUWLUVNTOYR
        YSYOYTUVFXKUBVUQCVUTUFUVGCTYINUVNXBHVUTEFIUVHUVIUVJUVKUVL $.
    $}

    ${
      xrhmeo.f $e |- F = ( x e. ( 0 [,] 1 ) |->
        if ( x = 1 , +oo , ( x / ( 1 - x ) ) ) ) $.
      xrhmeo.g $e |- G = ( y e. ( -u 1 [,] 1 ) |->
        if ( 0 <_ y , ( F ` y ) , -e ( F ` -u y ) ) ) $.
      xrhmeo.j $e |- J = ( TopOpen ` CCfld ) $.
      xrhmeo.k $e |- K = ( ordTop ` <_ ) $.
      $( The bijection from ` [ -u 1 , 1 ] ` to the extended reals is an order
         isomorphism and a homeomorphism.  (Contributed by Mario Carneiro,
         9-Sep-2015.) $)
      xrhmeo $p |- ( G Isom < , < ( ( -u 1 [,] 1 ) , RR* ) /\
        G e. ( ( J |`t ( -u 1 [,] 1 ) ) Homeo ( ordTop ` <_ ) ) ) $=
        ( c1 cxr clt cle wcel wbr wceq cc0 wa syl vz vw vv cneg cicc wiso crest
        co cordt cfv chmeo wor cv wi wral wss iccssxr xrltso ax-mp wf cxne cpnf
        cif cr 1re elicc2i adantr simpr 0re syl3anbrc wf1o cdiv simpli ffvelrni
        f1of sseldi wn sylancr le0neg1d mpbid simp2bi xnegcld wrex mpbi elxrge0
        wo wb mp4an f1ocnvfv2 breq2 fveq2 eqeq2d anbi12d rspcev syl12anc iftrue
        biimpar reximi 0xr mpan mp2an mp3an12 ax-1cn notbid 0elunit wne ax-1ne0
        cmin syl6eq eqtrd fvmpt mtbird pm3.2i sylancl fveq2d xnegeq negeq breq1
        eqid simpl1 eleq1 imbi12d ex vtoclga sylc isorel syl2anc eleq1d simpll2
        a1i simpll1 ifbothda ifbieq12d fvex xnegex ifex cvv ctsr letsr ledm wpo
        wfo soss mp2 sopo crn renegcli simp1bi simp3bi ccnv caddc cmpt renegcld
        iccpnfcnv letric orcanai lenegcon1 ifclda fmpti frn cab ssabral le0neg2
        0le1 1le1 f1ocnv mp2b sylbir biimpri eqcomd xnegcl xrletri ord xle0neg1
        iccss sylibd imp sylanbrc iccssre iccneg negnegi oveq2i syl6eleq biimpa
        xle0neg2 neeq2 mpbiri necomd ifnefalse oveq2 subid1i oveq12d div0i c0ex
        id breq12d cii iccpnfhmeo leisorel mtbid unitssre recnd negnegd xnegneg
        eqtr2d iffalse pm2.61dan rnmpt sseqtr4i eqssi dffo2 mpbir2an w3a simpl3
        mprgbir simpl2 ltled letrd breqtrrd lt0neg1d syl5eqbrr xlt0neg2 simprbi
        ltnle mpbird xrltletrd ltnegd xltneg 3expia breqan12d rgen2a soisoi cxp
        simpll3 sylibrd cin elexi inex1 ssid leiso isores1 cdm cps tsrps psssdm
        eqcomi ordthmeo mp3an xrrest2 ordtresticc eqtri oveq1i eleqtrri ) KUDZK
        UEUHZLMMDUFZDEVUOUGUHZNUIUJZUKUHZOVUOMULZLMUUAZVUOLDUUBZUAUMZUBUMZMPZVV
        CDUJZVVDDUJZMPZUNZUBVUOUOUAVUOUOVUPVUOLUPZLMULZVUTVUNKUQZURVUOLMUUCUUDV
        VKVVAURLMUUEUSVVBVUOLDUTZDUUFZLQBVUOLRBUMZNPZVVOCUJZVVOUDZCUJZVAZVCZDHV
        VOVUOOZVVPVVQVVTLVWBVVPSZRVBUEUHZLVVQRVBUQZVWCVVORKUEUHZOZVVQVWDOVWCVVO
        VDOZVVPVVOKNPZVWGVWBVWHVVPVWBVWHVUNVVONPZVWIVUNKVVOKVEUUGZVEVFZUUHZVGVW
        BVVPVHVWBVWIVVPVWBVWHVWJVWIVWLUUIVGRKVVOVIVEVFVJZVWFVWDVVOCVWFVWDCVKZVW
        FVWDCUTVWOCUUJZUCVWDUCUMZVBQKVWQKVWQUUKUHVLUHVCUULQAUCCGUUNVMZVWFVWDCVO
        USZVNTVPVWBVVPVQZSZVVSVXAVWDLVVSVWEVXAVVRVWFOZVVSVWDOVXAVVRVDORVVRNPZVV
        RKNPZVXBVXAVVOVWBVWHVWTVWMVGZUUMVXAVVORNPZVXCVWBVVPVXFVWBRVDOZVWHVVPVXF
        WFVIVWMRVVOUUOVRUUPVXAVVOVXEVSVTVXAVWJVXDVWBVWJVWTVWBVWHVWJVWIVWLWAVGVX
        AKVDOZVWHVWJVXDWGVEVXEKVVOUUQVRVTRKVVRVIVEVFVJZVWFVWDVVRCVWSVNTVPWBUURU
        USZVVNLVVMVVNLUPVXJVUOLDUUTUSLVVCVWAQZBVUOWCZUAUVAZVVNLVXMUPVXLUALVXLUA
        LUVBVVCLOZRVVCNPZVXLVXNVXOSZVVPVVCVVQQZSZBVUOWCZVXLVXPVVCVWPUJZVUOORVXT
        NPZVVCVXTCUJZQZVXSVXPVWFVUOVXTVUNVDOZVXHVUNRNPZKKNPVWFVUOUPVWKVERKNPZVY
        EUVDVXHVYFVYEWGVEKUVCUSWDUVEVUNKRKUVOWHZVXPVVCVWDOZVXTVWFOZVVCWEZVWDVWF
        VVCVWPVWOVWDVWFVWPVKVWDVWFVWPUTVWRVWFVWDCUVFVWDVWFVWPVOUVGZVNUVHZVPVXPV
        YIVYAVYLVYIVXTVDOVYAVXTKNPRKVXTVIVEVFWATVXPVYBVVCVXPVWOVYHVYBVVCQVWRVYH
        VXPVYJUVIVWFVWDVVCCWIVRUVJVXRVYAVYCSBVXTVUOVVOVXTQZVVPVYAVXQVYCVVOVXTRN
        WJVYMVVQVYBVVCVVOVXTCWKWLWMWNWOVXRVXKBVUOVVPVXKVXQVVPVWAVVQVVCVVPVVQVVT
        WPWLWQWRTVXNVXOVQZSZVWTVVCVVTQZSZBVUOWCZVXLVYOVVCVAZVWPUJZUDZVUOORWUANP
        ZVQZVVCWUAUDZCUJZVAZQZVYRVYOWUAVUNVUNUDZUEUHZVUOVYOVYTVUOOZWUAWUIOZVYOV
        WFVUOVYTVYGVYOVYSVWDOZVYTVWFOZVYOVYSLOZRVYSNPZWULVXNWUNVYNVVCUVKVGVXNVY
        NWUOVXNVYNVVCRNPZWUOVXNVXOWUPRLOZVXNVXOWUPWFWSRVVCUVLWTUVMVVCUVNUVPUVQV
        YSWEUVRZVWDVWFVYSVWPVYKVNTZVPZVYOVYTVDOZWUJWUKWGZVYOVUOVDVYTVYDVXHVUOVD
        UPZVWKVEVUNKUVSXAZWUTVPZVYDVXHWVAWVBVWKVEVUNKVYTUVTXBTVTWUHKVUNUEKXCUWA
        UWBUWCVYOVYTRNPZWUBVYOWVFVYTCUJZRCUJZNPZVYOWVIVYSRNPZVXNVYNWVJVQVXNVXOW
        VJVVCUWEXDUWDVYOWVGVYSWVHRNVYOVWOWULWVGVYSQVWRWURVWFVWDVYSCWIVRZWVHRQZV
        YORVWFOZWVLXEARAUMZKQVBWVNKWVNXHUHZVLUHZVCZRVWFCWVNRQZWVQWVPRWVRWVNKXFW
        VQWVPQWVRKWVNWVRKWVNXFKRXFXGWVNRKUWFUWGUWHWVNKVBWVPUWITWVRWVPRKVLUHRWVR
        WVNRWVOKVLWVRUWOWVRWVOKRXHUHKWVNRKXHUWJKXCUWKXIUWLKXCXGUWMXIXJGUWNXKUSZ
        YJUWPXLVYOWUMWVMWVFWVIWGZWUSXEVWFVWDMMCUFZVWFLUPZVWDLUPZSWUMWVMSWVTWWAC
        UWQVURVWDUGUHZUKUHOACWWDGWWDXSUWRVMZWWBWWCRKUQVWEXMVWFVWDVYTRCUWSXBXNXL
        VYOVYTWVEVSUWTVYOWUFVYSVAZVVCVYOWUEVYSQWUFWWFQVYOWUEWVGVYSVYOWUDVYTCVYO
        VYTVYOVYTVYOVWFVDVYTUXAWUSVPUXBUXCXOWVKXJWUEVYSXPTVXNWWFVVCQVYNVVCUXDVG
        UXEVYQWUCWUGSBWUAVUOVVOWUAQZVWTWUCVYPWUGWWGVVPWUBVVOWUARNWJXDWWGVVTWUFV
        VCWWGVVSWUEQVVTWUFQWWGVVRWUDCVVOWUAXQXOVVSWUEXPTWLWMWNWOVYQVXKBVUOVWTVX
        KVYPVWTVWAVVTVVCVVPVVQVVTUXFWLWQWRTUXGUXOBUAVUOVWADHUXHUXIUXJVUOLDUXKUX
        LVVIUAUBVUOVVCVUOOZVVDVUOOZSVVEVXOVVCCUJZVVCUDZCUJZVAZVCZRVVDNPZVVDCUJZ
        VVDUDZCUJZVAZVCZMPZVVHWWHWWIVVEWXAVXOWWJWWTMPWWMWWTMPZWXAWWHWWIVVEUXMZW
        WJWWMWWJWWNWWTMXRWWMWWNWWTMXRWXCVXOSZWWJWWPWWTMWXDVVEWWJWWPMPZWWHWWIVVE
        VXOUXNZWXDVVCVWFOZVVDVWFOZVVEWXEWGZWXDWWHVXOWXGWWHWWIVVEVXOXTZWXCVXOVHZ
        VVPVWGUNZVXOWXGUNBVVCVUOVVOVVCQZVVPVXOVWGWXGVVOVVCRNWJZVVOVVCVWFYAYBVWB
        VVPVWGVWNYCZYDYEWXDWWIWWOWXHWWHWWIVVEVXOUXPZWXDRVVCVVDVXGWXDVIYJWXDVUOV
        DVVCWVDWXJVPZWXDVUOVDVVDWVDWXPVPZWXKWXDVVCVVDWXQWXRWXFUXQUXRZWXLWWOWXHU
        NBVVDVUOVVOVVDQZVVPWWOVWGWXHVVOVVDRNWJZVVOVVDVWFYAYBWXOYDZYEWWAWXGWXHSW
        XIWWEVWFVWDVVCVVDMMCYFWTYGVTWXDWWOWWTWWPQWXSWWOWWPWWSWPTUXSWWOWWMWWPMPW
        WMWWSMPZWXBWXCVYNSZWWPWWSWWPWWTWWMMWJWWSWWTWWMMWJWYDWWOSZWWMRWWPWYEWWLW
        YEVWDLWWLVWEWYEWWKVWFOZWWLVWDOZWYDWYFWWOWYDWWHVYNWYFWWHWWIVVEVYNXTWXCVY
        NVHZVWTVXBUNZVYNWYFUNBVVCVUOWXMVWTVYNVXBWYFWXMVVPVXOWXNXDWXMVVRWWKVWFVV
        OVVCXQZYHYBVWBVWTVXBVXIYCZYDYEZVGZVWFVWDWWKCVWSVNZTVPZWBWUQWYEWSYJWYEVW
        DLWWPVWEWYEWXHWWPVWDOZWYEWWIWWOWXHWWHWWIVVEVYNWWOYIWYDWWOVHWYBYEVWFVWDV
        VDCVWSVNTZVPWYERWWLMPZWWMRMPZWYERWVHWWLMWVSWYERWWKMPZWVHWWLMPZWYEVVCRMP
        ZWYTWYEXUBVYNWYDVYNWWOWYHVGWYEVVCVDOVXGXUBVYNWGWYEVUOVDVVCWVDWWHWWIVVEV
        YNWWOYKVPZVIVVCRUYDXNUYEWYEVVCXUCUXTVTWYEWVMWYFWYTXUAWGZXEWYMWWAWVMWYFS
        XUDWWEVWFVWDRWWKMMCYFWTVRVTUYAWYEWWLLOZWYRWYSWGWYOWWLUYBTVTWYEWYPRWWPNP
        ZWYQWYPWWPLOXUFWWPWEUYCTUYFWYDWWOVQZSZWWRWWLMPZWYCXUHWWQWWKMPZXUIXUHVVE
        XUJWWHWWIVVEVYNXUGUYNXUHVVCVVDXUHVUOVDVVCWVDWWHWWIVVEVYNXUGYKVPXUHVUOVD
        VVDWVDWWHWWIVVEVYNXUGYIZVPUYGVTXUHWWQVWFOZWYFXUJXUIWGZXUHWWIXUGXULXUKWY
        DXUGVHWYIXUGXULUNBVVDVUOWXTVWTXUGVXBXULWXTVVPWWOWYAXDWXTVVRWWQVWFVVOVVD
        XQZYHYBWYKYDYEZWYDWYFXUGWYLVGZWWAXULWYFSXUMWWEVWFVWDWWQWWKMMCYFWTYGVTXU
        HWWRLOXUEXUIWYCWGXUHVWDLWWRVWEXUHXULWWRVWDOXUOVWFVWDWWQCVWSVNTVPXUHVWDL
        WWLVWEXUHWYFWYGXUPWYNTVPWWRWWLUYHYGVTYLYLUYIWWHWWIVVFWWNVVGWWTMBVVCVWAW
        WNVUODWXMVVPVXOVVQVVTWWJWWMWXNVVOVVCCWKWXMVVSWWLQVVTWWMQWXMVVRWWKCWYJXO
        VVSWWLXPTYMHVXOWWJWWMVVCCYNWWLYOYPXKBVVDVWAWWTVUODWXTVVPWWOVVQVVTWWPWWS
        WYAVVOVVDCWKWXTVVSWWRQVVTWWSQWXTVVRWWQCXUNXOVVSWWRXPTYMHWWOWWPWWSVVDCYN
        WWRYOYPXKUYJUYOUYKUAUBVUOLMMDUYLWHZDNVUOVUOUYMZUYPZUIUJZVURUKUHZVUSXUSY
        QONYROZVUOLXUSNDUFZDXVAONXURNYRYSUYQUYRYSVUOLNNDUFZXVCVUPXVDXUQVVJLLUPV
        UPXVDWGVVLLUYSVUOLDUYTXAWDVUOLNNDVUAWDXUSNDYQYRVUOLXUSVUBZVUONVUCOZVVJX
        VEVUOQXVBXVFYSNVUDUSVVLVUONLYTVUEXAVUFYTVUGVUHVUQXUTVURUKVUQVURVUOUGUHZ
        XUTWVCVUQXVGQWVDVUOEVURIVURXSVUIUSVUNKVUJVUKVULVUMXM $.
    $}
  $}

  ${
    $d x y $.
    $( The extended reals are homeomorphic to the interval ` [ 0 , 1 ] ` .
       (Contributed by Mario Carneiro, 9-Sep-2015.) $)
    xrhmph $p |- II ~= ( ordTop ` <_ ) $=
      ( vx vy cii cfv c1 cneg cicc co chmph wbr cle cc0 cv cmul cmpt wcel ax-mp
      clt 1re eqid ccnfld ctopn crest cordt cmin caddc cr renegcli 0lt1 lt0neg2
      chmeo wb mpbi 0re lttri mp2an icchmeo mp3an hmphi wceq cpnf cdiv cif cxne
      cxr wiso xrhmeo simpri hmphtr ) CUAUBDZEFZEGHZUCHZIJZVMKUDDZIJZCVOIJALEGH
      ZAMZENHEVRUEHZVKNHUFHOZCVMUKHPZVNVKUGPEUGPZVKERJZWAESUHZSVKLRJZLERJZWCWFW
      EUIWBWFWEULSEUJQUMUIVKLEWDUNSUOUPAVKEVTVJVJTZVTTUQURVTCVMUSQBVLLBMZKJWHAV
      QVREUTVAVRVSVBHVCOZDWHFWIDVDVCOZVMVOUKHPZVPVLVERRWJVFWKABWIWJVJVOWITWJTWG
      VOTVGVHWJVMVOUSQCVMVOVIUP $.
  $}

  $( The topology of the extended reals is compact.  Since the topology of the
     extended reals extends the topology of the reals (by ~ xrtgioo ), this
     means that ` RR* ` is a compactification of ` RR ` .  (Contributed by
     Mario Carneiro, 9-Sep-2015.) $)
  xrcmp $p |- ( ordTop ` <_ ) e. Comp $=
    ( cii cle cordt cfv chmph wbr ccmp wcel xrhmph iicmp cmphmph mp2 ) ABCDZEFA
    GHMGHIJAMKL $.

  $( The topology of the extended reals is connected.  (Contributed by Mario
     Carneiro, 9-Sep-2015.) $)
  xrcon $p |- ( ordTop ` <_ ) e. Con $=
    ( cii cle cordt cfv chmph wbr ccon wcel xrhmph iicon conhmph mp2 ) ABCDZEFA
    GHMGHIJAMKL $.

  ${
    $( A linear combination of two reals lies in the interval between them.
       Equivalently, a closed interval is a convex set.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    icccvx $p |- ( ( A e. RR /\ B e. RR ) ->
              ( ( C e. ( A [,] B ) /\ D e. ( A [,] B ) /\ T e. ( 0 [,] 1 ) ) ->
                      ( ( ( 1 - T ) x. C ) + ( T x. D ) ) e. ( A [,] B ) ) ) $=
      ( cr wcel wa cicc co c1 w3a cmul caddc wceq 3adantr3 adantl jca oveq1d cc
      cc0 cmin clt wbr w3o iccssre sselda adantrr adantrl lttri4d iccss2 adantr
      wss simpr3 wi lincmb01cmp ex 3expa an32s sylan oveq2 unitssre sseli recnd
      imp sseldd ad2antll ax-1cn npcan mpan subcl adddir mulid2 3eqtr3d syl2anc
      ancri 3adantr1 sylan9eqr simplr2 eqeltrd ancom2s iirev recn mulcl syl2anr
      sseldi adantll adantlr addcomd 3adantl3 nncan eqcomd eqtrd sylan2 3jaodan
      syl mpdan ) AFGBFGHZCABIJZGZDWSGZEUAKIJZGZLZKEUBJZCMJZEDMJZNJZWSGZWRXDHZC
      DUCUDZCDOZDCUCUDZUEZXIWRWTXAXNXCWRWTXAHZHZCDWRWTCFGZXAWRWSFCABUFZUGUHZWRX
      ADFGZWTWRWSFDXRUGZUIZUJPXJXKXIXLXMXJXKHCDIJZWSXHXJYCWSUMZXKWRWTXAYDXCXOYD
      WRABCDUKQPULXJXQXTHZXCHXKXHYCGZXJYEXCWRWTXAYEXCXPXQXTXSYBRPWRWTXAXCUNZRYE
      XKXCYFYEXKHXCYFXQXTXKXCYFUOXQXTXKLXCYFCDEUPUQURVEUSUTVFXJXLHXHDWSXLXJXHXE
      DMJZXGNJZDXLXFYHXGNCDXEMVASWRXAXCYIDOZWTWRXAXCHHETGZDTGZYJXCYKWRXAXCEXBFE
      VBVCVDZVGWRXAYLXCWRXAHDYAVDUHYKYLHZXEENJZDMJZKDMJZYIDYNYOKDMYKYOKOZYLKTGZ
      YKYRVHKEVIVJULSYKXETGZYKHYLYPYIOZYKYTYSYKYTVHKEVKVJVPYTYKYLUUAXEEDVLURUTY
      LYQDOYKDVMQVNVOVQVRWTXAXCWRXLVSVTXJXMHDCIJZWSXHXJUUBWSUMZXMWRWTXAUUCXCWRX
      AWTUUCXAWTHUUCWRABDCUKQWAPULXJXTXQHZXCHZXMXHUUBGZXJUUDXCWRWTXAUUDXCXPXTXQ
      YBXSRPYGRUUDXMXCUUFUUDXMHXCUUFXTXQXMXCUUFUOXTXQXMLZXCUUFUUGXCHZXHKXEUBJZD
      MJZXFNJZUUBUUHXHXGXFNJZUUKXTXQXCXHUULOXMUUEXFXGXQXCXFTGZXTXCYTCTGUUMXQXCX
      EXCXBFXEVBEWBZWFVDCWCXECWDWEWGXTXCXGTGZXQXCYKYLUUOXTYMDWCEDWDWEWHWIWJXCUU
      LUUKOZUUGXCYKUUPYMYKXGUUJXFNYKEUUIDMYKUUIEYSYKUUIEOVHKEWKVJWLSSWPQWMXCUUG
      XEXBGUUKUUBGUUNDCXEUPWNVTUQURVEUSUTVFWOWQUQ $.
  $}

  ${
    $d A u v x y z $.  $d B u v x y z $.  $d C u v x y z $.
    $d K u v w x y z $.  $d R w z $.  $d S w z $.  $d F u v $.  $d G u v $.
    $d u v w x y z $.
    oprpiece1.1 $e |- A e. RR $.
    oprpiece1.2 $e |- B e. RR $.
    oprpiece1.3 $e |- A <_ B $.
    oprpiece1.4 $e |- R e. _V $.
    oprpiece1.5 $e |- S e. _V $.
    oprpiece1.6 $e |- K e. ( A [,] B ) $.
    oprpiece1.7 $e |- F =
      ( x e. ( A [,] B ) , y e. C |-> if ( x <_ K , R , S ) ) $.
    ${
      oprpiece1.8 $e |- G = ( x e. ( A [,] K ) , y e. C |-> R ) $.
      $( Restriction to the first part of a piecewise defined function.
         (Contributed by Jeff Madsen, 11-Jun-2010.)  (Proof shortened by Mario
         Carneiro, 3-Sep-2015.) $)
      oprpiece1res1 $p |- ( F |` ( ( A [,] K ) X. C ) ) = G $=
        ( cle wcel cicc co cv wbr cif cmpt2 cxp cres wss cxr rexri lbicc2 mp3an
        wceq iccss2 mp2an ssid resmpt2 reseq1i w3a elicc1 simp1bi ax-mp iccleub
        wb mp3an12 iftrue syl adantr mpt2eq3ia eqtr4i 3eqtr4i ) ABCDUAUBZEAUCZJ
        SUDZFGUEZUFZCJUAUBZEUGZUHZABVREVPUFZHVSUHIVRVMUIZEEUIVTWAUNCVMTZJVMTZWB
        CUJTZDUJTZCDSUDWCCKUKZDLUKZMCDULUMPCDCJUOUPEUQABVMEVREVPURUPHVQVSQUSIAB
        VREFUFWARABVREVPFVNVRTZVPFUNZBUCETWIVOWJWEJUJTZWIVOWGWDWKPWDWKCJSUDZJDS
        UDZWEWFWDWKWLWMUTVEWGWHCDJVAUPVBVCCJVNVDVFVOFGVGVHVIVJVKVL $.
    $}

    ${
      $d P w x $.  $d Q w x $.
      oprpiece1.9 $e |- ( x = K -> R = P ) $.
      oprpiece1.10 $e |- ( x = K -> S = Q ) $.
      oprpiece1.11 $e |- ( y e. C -> P = Q ) $.
      oprpiece1.12 $e |- G = ( x e. ( K [,] B ) , y e. C |-> S ) $.
      $( Restriction to the second part of a piecewise defined function.
         (Contributed by Jeff Madsen, 11-Jun-2010.)  (Proof shortened by Mario
         Carneiro, 3-Sep-2015.) $)
      oprpiece1res2 $p |- ( F |` ( ( K [,] B ) X. C ) ) = G $=
        ( cicc co cv cle wbr cif cmpt2 cxp cres wss wceq cxr rexri ubicc2 mp3an
        wcel mp2an ssid resmpt2 reseq1i wa eqeq1 ad2antlr simpr elicc2i simp1bi
        iccss2 cr ax-mp simp2bi ad2antrr wb letri3 sylancl mpbir2and 3eqtr4d wn
        syl eqidd ifbothda mpt2eq3ia eqtr4i 3eqtr4i ) ABCDUDUEZEAUFZLUGUHZHIUIZ
        UJZLDUDUEZEUKZULZABWLEWJUJZJWMULKWLWGUMZEEUMWNWOUNLWGUSZDWGUSZWPRCUOUSD
        UOUSCDUGUHWRCMUPDNUPOCDUQURCDLDVJUTEVAABWGEWLEWJVBUTJWKWMSVCKABWLEIUJWO
        UCABWLEWJIWIHIUNIIUNWJIUNWHWLUSZBUFEUSZVDZHIHWJIVEIWJIVEXAWIVDZFGHIWTFG
        UNWSWIUBVFXBWHLUNZHFUNXBXCWILWHUGUHZXAWIVGWSXDWTWIWSWHVKUSZXDWHDUGUHZLD
        WHWQLVKUSZRWQXGCLUGUHLDUGUHCDLMNVHVIVLZNVHZVMVNXBXEXGXCWIXDVDVOWSXEWTWI
        WSXEXDXFXIVIVNXHWHLVPVQVRZTWAXBXCIGUNXJUAWAVSXAWIVTVDIWBWCWDWEWF $.
    $}
  $}

  ${
    $d z F $.  $d z J $.  $d x y z K $.
    cnrehmeo.1 $e |- F = ( x e. RR , y e. RR |-> ( x + ( _i x. y ) ) ) $.
    cnrehmeo.2 $e |- J = ( topGen ` ran (,) ) $.
    cnrehmeo.3 $e |- K = ( TopOpen ` CCfld ) $.
    $( The canonical bijection from ` ( RR X. RR ) ` to ` CC ` described in
       ~ cnref1o is in fact a homeomorphism of the usual topologies on these
       sets.  (It is also an isometry, if ` ( RR X. RR ) ` is metrized with the
       l<SUP>2</SUP> norm.)  (Contributed by Mario Carneiro, 25-Aug-2014.) $)
    cnrehmeo $p |- F e. ( ( J tX J ) Homeo K ) $=
      ( vz co wcel wtru ccn cr ci cfv a1i cc cre cim ctx chmeo ccnv caddc cmpt2
      cmul ctopon cioo crn ctg retopon eqeltri crest ctop wss cnfldtop cnrest2r
      cv cnmpt1st tgioo2 eqtri oveq2i syl6eleq sseldd cnfldtopon ax-icn cnmpt2c
      mp1i cnmpt2nd mulcn cnmpt22f addcn syl5eqel cop cmpt cnrecnv wf ref ccncf
      feqmptd recncf wceq ssid ax-resscn toponunii restid eqcomi cncfcn eleqtri
      ax-mp mp2an syl6eqelr imf imcncf cnmpt1t ishmeo sylanbrc trud ) CDDUAJZEU
      BJKZLCWSEMJZKCUCZEWSMJZKWTLCABNNAURZOBURZUFJZUDJUEXAFLABXDXFUDDDEEENNDNUG
      PZKLDUHUIUJPZXGGUKULQZXILWSENUMJZMJZXAABNNXDUEZEUNKXKXAUOLEHUPNWSEUQVHZLX
      LWSDMJZXKLABDDNNXIXIUSDXJWSMDXHXJGEHUTVAZVBZVCVDLABOXEUFDDEEENNXIXILABODD
      ENNRXIXIERUGPZKZLEHVEZQZORKLVFQVGLXKXAABNNXEUEZXMLYAXNXKLABDDNNXIXIVIXPVC
      VDUFEEUAJEMJZKLEHVJQVKUDYBKLEHVLQVKVMLXBIRIURZSPZYCTPZVNVOXCABICFVPLIYDYE
      EDDRXTLIRYDVOSEDMJZLIRNSRNSVQLVRQVTSRNVSJZYFWARRUONRUOYGYFWBRWCWDRNEEDHER
      UMJZEXRYHEWBXSEXQRREXSWEWFWJWGXOWHWKZWIWLLIRYEVOTYFLIRNTRNTVQLWMQVTTYGYFW
      NYIWIWLWOVMCWSEWPWQWR $.
  $}

  ${
    $d f r s u x y z D $.  $d u z F $.  $d u z R $.  $d f r s u x y z T $.
    $d r u x y z J $.  $d f r s u x y z X $.
    cnheibor.2 $e |- J = ( TopOpen ` CCfld ) $.
    cnheibor.3 $e |- T = ( J |`t X ) $.
    ${
      cnheibor.4 $e |- F = ( x e. RR , y e. RR |-> ( x + ( _i x. y ) ) ) $.
      cnheibor.5 $e |- Y = ( F " ( ( -u R [,] R ) X. ( -u R [,] R ) ) ) $.
      $( Lemma for ~ cnheibor .  (Contributed by Mario Carneiro,
         14-Sep-2014.) $)
      cnheiborlem $p |- ( ( X e. ( Clsd ` J ) /\ ( R e. RR /\
        A. z e. X ( abs ` z ) <_ R ) ) -> T e. Comp ) $=
        ( cfv wcel cr cle co ccmp cc vu ccld cv cabs wbr wral wa crest ctop wss
        cvv wceq cnfldtop a1i cneg cicc cxp cima ccnv wf1o wfn wb cnref1o f1ofn
        elpreima mp2b c1st c2nd cop 1st2nd2 ad2antrl xp1st cnfldtopon toponunii
        recnd abscld cldss adantr simprr sseldd simplrl cre cim f1ocnvfv1 fveq2
        simprl sylancr opeq12d cnrecnv opex fvmpt syl eqtr3d fveq2d fvex syl6eq
        op1st absrele eqbrtrd simplrr breq1d rspcv sylc letrd absled simpld w3a
        mpbid simprd renegcl elicc2 syl2anc xp2nd op2nd absimle opelxpi eqeltrd
        mpbir3and ex syl5bi ssrdv wfun crn wi f1ofun ax-mp f1ofo forn syl6sseqr
        wfo funimass1 mpd ctx eqid syl3anc syl6eqr ccn mpancom retop eqeltrrd
        cioo chmeo cnrehmeo imaexg eqeltri restabs oveq2i ishmeo simpli iccssre
        ctg mpbi rerest oveq12d ovex txrest mp4an icccmp txcmp syl5eqel imassrn
        imacmp eqsstri wf f1of frn sstri simpl restcldi cmpcld ) HGUBNOZDPOZCUC
        ZUDNZDQUEZCHUFZUGZUGZGIUHRZHUHRZESUVRUVTGHUHRZEUVRGUIOZHIUJZIUKOZUVTUWA
        ULUWBUVRGJUMUNUVRHFDUOZDUPRZUWFUQZURZIUVRFUSZHURZUWGUJZHUWHUJZUVRUAUWJU
        WGUAUCZUWJOZUWMPPUQZOZUWMFNZHOZUGZUVRUWMUWGOZUWOTFUTZFUWOVAUWNUWSVBABFL
        VCZUWOTFVDUWOUWMHFVEVFUVRUWSUWTUVRUWSUGZUWMUWMVGNZUWMVHNZVIZUWGUWPUWMUX
        FULUVRUWRUWMPPVJVKUXCUXDUWFOZUXEUWFOZUXFUWGOUXCUXGUXDPOZUWEUXDQUEZUXDDQ
        UEZUWPUXIUVRUWRUWMPPVLVKZUXCUXJUXKUXCUXDUDNZDQUEUXJUXKUGUXCUXMUWQUDNZDU
        XCUXDUXCUXDUXLVOVPUXCUWQUXCHTUWQUVRHTUJZUWSUVKUXOUVQHGTTGGJVMVNZVQVRZVR
        UVRUWPUWRVSZVTZVPZUVKUVLUVPUWSWAZUXCUXMUWQWBNZUDNZUXNQUXCUXDUYBUDUXCUXD
        UYBUWQWCNZVIZVGNUYBUXCUWMUYEVGUXCUWQUWINZUWMUYEUXCUXAUWPUYFUWMULUXBUVRU
        WPUWRWFUWOTUWMFWDWGUXCUWQTOZUYFUYEULUXSCUWQUVMWBNZUVMWCNZVIUYETUWIUVMUW
        QULZUYHUYBUYIUYDUVMUWQWBWEUVMUWQWCWEWHABCFLWIUYBUYDWJWKWLWMZWNUYBUYDUWQ
        WBWOZUWQWCWOZWQWPWNUXCUYGUYCUXNQUEUXSUWQWRWLWSUXCUWRUVPUXNDQUEZUXRUVKUV
        LUVPUWSWTUVOUYNCUWQHUYJUVNUXNDQUVMUWQUDWEXAXBXCZXDUXCUXDDUXLUYAXEXHZXFU
        XCUXJUXKUYPXIUXCUWEPOZUVLUXGUXIUXJUXKXGVBUXCUVLUYQUYADXJZWLZUYAUWEDUXDX
        KXLXRUXCUXHUXEPOZUWEUXEQUEZUXEDQUEZUWPUYTUVRUWRUWMPPXMVKZUXCVUAVUBUXCUX
        EUDNZDQUEVUAVUBUGUXCVUDUXNDUXCUXEUXCUXEVUCVOVPUXTUYAUXCVUDUYDUDNZUXNQUX
        CUXEUYDUDUXCUXEUYEVHNUYDUXCUWMUYEVHUYKWNUYBUYDUYLUYMXNWPWNUXCUYGVUEUXNQ
        UEUXSUWQXOWLWSUYOXDUXCUXEDVUCUYAXEXHZXFUXCVUAVUBVUFXIUXCUYQUVLUXHUYTVUA
        VUBXGVBUYSUYAUWEDUXEXKXLXRUXDUXEUWFUWFXPXLXQXSXTYAUVRFYBZHFYCZUJUWKUWLY
        DUXAVUGUXBUWOTFYEYFUVRHTVUHUXQUXAUWOTFYJVUHTULUXBUWOTFYGUWOTFYHVFYIHUWG
        FYKWGYLMYIZUWDUVRIUWHUKMFUUAYCUUKNZVUJYMRZGUUBRZOZUWHUKOABFVUJGLVUJYNZJ
        UUCZFUWGVULUUDYFUUEUNHIGUIUKUUFYOKYPUVRUVSSOZHUVSUBNOZUVTSOUVLVUPUVKUVP
        UVLUVSGUWHUHRZSIUWHGUHMUUGUVLFVUKGYQROZVUKUWGUHRZSOVURSOVUSUWIGVUKYQROZ
        VUMVUSVVAUGVUOFVUKGUUHUULUUIUVLGUWFUHRZVVBYMRZVUTSUVLVVCVUJUWFUHRZVVDYM
        RZVUTUVLVVBVVDVVBVVDYMUVLUWFPUJZVVBVVDULUYQUVLVVFUYRUWEDUUJYRUWFVUJGJVU
        NUUMWLZVVGUUNVUJUIOZVVHUWFUKOZVVIVUTVVEULYSYSUWEDUPUUOZVVJUWFUWFVUJVUJU
        IUIUKUKUUPUUQYPUVLVVBSOZVVKVVCSOUVLVVBVVDSVVGUYQUVLVVDSOUYRUWEDVVDVUJVU
        NVVDYNUURYRXQZVVLVVBVVBUUSXLYTUWGFVUKGUVBWGUUTVKUVRITUJZUVKUWCVUQVVMUVR
        IVUHTIUWHVUHMFUWGUVAUVCUXAUWOTFUVDVUHTUJUXBUWOTFUVEUWOTFUVFVFUVGUNUVKUV
        QUVHVUIIHGTUXPUVIYOHUVSUVJXLYT $.
    $}

    $( Heine-Borel theorem for complex numbers.  A subset of ` CC ` is compact
       iff it is closed and bounded.  (Contributed by Mario Carneiro,
       14-Sep-2014.) $)
    cnheibor $p |- ( X C_ CC -> ( T e. Comp <-> ( X e. ( Clsd ` J ) /\
      E. r e. RR A. x e. X ( abs ` x ) <_ r ) ) ) $=
      ( vu vz cc wcel cfv cv cr wrex wa co wceq crp cc0 vs vf vy ccmp ccld cabs
      wss cle wbr wral cha crest cnfldhaus a1i simpl simpr syl5eqelr cnfldtopon
      toponunii hauscmp syl3anc cuni cmin ccom cbl cin wex cpw cfn wel cnfldtop
      wf ctop restuni sylancr unieqi syl6eqr eleq2d biimpar c1 caddc cnex ssexg
      cvv sylancl adantr cxmt cxr cnxmet sselda abscld peano2re rexrd cnfldtopn
      0cn blopn elrestr syl6eleqr eqid cnmetdval mpan cneg df-neg fveq2i absneg
      syl clt syl5eqr eqtrd ltp1d eqbrtrd elbl mpbir2and elin sylanbrc ge0p1rpd
      absge0d oveq2 ineq1d eqeq2d rspcev eleq2 eqeq1 rexbidv syl12anc ralrimiva
      anbi12d syl2anc simpllr sseldi rpred ad2antrl simprr simprl ad2antrr sylc
      wb rspcv rexlimdvaa mpd cmpcovf ffvelrn fimaxre3 ad4antr elssuni sseqtr4d
      syldan inss2 eluni2 syl6bb simp-6l sstrd sseldd simplrl ffvelrnd inss1 id
      fveq2 oveq2d eqeq12d eleqtrd rpxrd simprd eqbrtrrd simplrr breq1d ltletrd
      mpbid ltled sylbid ralrimiv expr reximdva ex exlimdv expimpd rexlimdva ci
      jca cmul cmpt2 cicc cxp cima cnheiborlem imp adantl impbida ) DJUGZBUDKZD
      CUELKZAMZUFLZEMZUHUIZADUJZENOZPZUWIUWJPZUWKUWQUWSCUKKZUWICDULQZUDKUWKUWTU
      WSCFUMUNUWIUWJUOZUWSUXABUDGUWIUWJUPZUQDCJJCCFURUSZUTVAUWSBVBZUAMZVBZRZUXF
      SUBMZVLZHMZTUXKUXILZUFVCVDZVELZQZDVFZRZHUXFUJZPZUBVGZPZUABVHZVIVFZOZUWQUW
      SUWJAHVJZUXKTUWNUXNQZDVFZRZESOZPZHBOZAUXEUJUYDUXCUWSUYKAUXEUWSUWLUXEKZUWL
      DKZUYKUWSUYMUYLUWSDUXEUWLUWSDUXAVBZUXEUWSCVMKZUWIDUYNRCFVKZUXBDCJUXDVNVOB
      UXAGVPVQZVRVSUWSUYMPZTUWMVTWAQZUXNQZDVFZBKUWLVUAKZVUAUYGRZESOZUYKUYRVUAUX
      ABUYRUYODWDKZUYTCKZVUAUXAKUYOUYRUYPUNUWSVUEUYMUWSUWIJWDKVUEUXBWBDJWDWCWEW
      FUYRUXMJWGLKZTJKZUYSWHKZVUFVUGUYRWIUNZVUHUYRWOUNZUYRUYSUYRUWMNKUYSNKUYRUW
      LUWSDJUWLUXBWJZWKZUWMWLXFWMZUXMTUYSCJCFWNWPVAUYTDCVMWDWQVAGWRUYRUWLUYTKZU
      YMVUBUYRVUOUWLJKZTUWLUXMQZUYSXGUIZVULUYRVUQUWMUYSXGUYRVUPVUQUWMRZVULVUPVU
      QTUWLVCQZUFLZUWMVUHVUPVUQVVARWOTUWLUXMUXMWSWTXAVUPVVAUWLXBZUFLUWMVVBVUTUF
      UWLXCXDUWLXEXHXIZXFUYRUWMVUMXJXKUYRVUGVUHVUIVUOVUPVURPYQVUJVUKVUNUWLUXMTU
      YSJXLVAXMUWSUYMUPUWLUYTDXNXOUYRUYSSKVUAVUARZVUDUYRUWMVUMUYRUWLVULXQXPVUAW
      SVUCVVDEUYSSUWNUYSRZUYGVUAVUAVVEUYFUYTDUWNUYSTUXNXRXSXTYAWEUYJVUBVUDPHVUA
      BUXKVUARZUYEVUBUYIVUDUXKVUAUWLYBVVFUYHVUCESUXKVUAUYGYCYDYGYAYEUUGYFUYHUXQ
      AHESUBBUXEUAUXEWSUWNUXLRZUYGUXPUXKVVGUYFUXODUWNUXLTUXNXRXSXTUUAYHUWSUYAUW
      QUAUYCUWSUXFUYCKZPZUXHUXTUWQVVIUXHPZUXSUWQUBVVJUXSUWQVVJUXSPZUXLUWNUHUIZH
      UXFUJZENOZUWQVVKUXFVIKUXLNKZHUXFUJZVVNVVKUYCVIUXFUYBVIUUHUWSVVHUXHUXSYIYJ
      UXJVVPVVJUXRUXJVVOHUXFUXJHUAVJPUXLUXFSUXKUXIUUBYKYFYLEHUXFUXLUUCYHVVKVVMU
      WPENVVKUWNNKZVVMUWPVVKVVQVVMPZPZUWOADVVSUYMAIVJZIUXFOZUWOVVSUYMUWLUXGKVWA
      VVSDUXGUWLVVSDUXEUXGUWSDUXERVVHUXHUXSVVRUYQUUDVVIUXHUXSVVRYIXIZVRIUWLUXFU
      UIUUJVVSVVTUWOIUXFVVSIUAVJZVVTPZPZUWMUWNVWEUWLVWEIMZJUWLVWEVWFDJVWEVWFUXG
      DVWCVWFUXGUGVVSVVTVWFUXFUUEYLVVSDUXGRVWDVWBWFUUFUWIUWJVVHUXHUXSVVRVWDUUKU
      ULVVSVWCVVTYMZUUMZWKZVVKVVQVVMVWDUUNZVWEUWMVWFUXILZUWNVWIVWEVWKVWEUXFSVWF
      UXIVVKUXJVVRVWDVVJUXJUXRYNYOVVSVWCVVTYNZUUOZYKVWJVWEVUQUWMVWKXGVWEVUPVUSV
      WHVVCXFVWEVUPVUQVWKXGUIZVWEUWLTVWKUXNQZKZVUPVWNPZVWEVWODVFZVWOUWLVWODUUPV
      WEUWLVWFVWRVWGVWEVWCUXRVWFVWRRZVWLVVKUXRVVRVWDVVJUXJUXRYMYOUXQVWSHVWFUXFU
      XKVWFRZUXKVWFUXPVWRVWTUUQVWTUXOVWODVWTUXLVWKTUXNUXKVWFUXIUURZUUSXSUUTYRYP
      UVAYJVWEVUGVUHVWKWHKVWPVWQYQVUGVWEWIUNVUHVWEWOUNVWEVWKVWMUVBUWLUXMTVWKJXL
      VAUVHUVCUVDVWEVWCVVMVWKUWNUHUIZVWLVVKVVQVVMVWDUVEVVLVXBHVWFUXFVWTUXLVWKUW
      NUHVXAUVFYRYPUVGUVIYSUVJUVKUVLUVMYTUVNUVOUVPUVQYTUVSUWRUWJUWIUWKUWQUWJUWK
      UWPUWJENUCIAUWNBUCINNUCMUVRVWFUVTQWAQUWAZCDVXCUWNXBUWNUWBQZVXDUWCUWDZFGVX
      CWSVXEWSUWEYSUWFUWGUWH $.
  $}

  ${
    $d r s u w x y z J $.
    cnllycmp.1 $e |- J = ( TopOpen ` CCfld ) $.
    $( The topology on the complexes is locally compact.  (Contributed by Mario
       Carneiro, 2-Mar-2015.) $)
    cnllycmp $p |- J e. N-Locally Comp $=
      ( vu vy vx vz ccmp wcel cv co cfv wral wa cabs wss cc syl3anc wbr cle cr
      vr vs vw cnlly ctop csn cnei cpw cin wrex cnfldtop cmin ccom cbl crp cxmt
      crest cnxmet cnfldtopn mopni2 mp3an1 c2 cdiv ccl a1i cxr elssuni ad2antrr
      cuni cnfldtopon toponunii syl6sseqr simplr sseldd rphalfcl ad2antrl rpxrd
      blopn blcntr opnneip blssm sscls syl2anc clt rpxr rphalflt blsscls simprr
      syl23anc sstrd ssnei2 syl22anc vex elpw2 sylibr elin sylanbrc ccld clscld
      caddc abscld rpred readdcld crab blcls wi adantr abs2difd resubcld subcld
      eqid simpr letr mpand abssubd wceq sylan eqtr4d breq1d lesubadd2d 3imtr3d
      cnmetdval ralrimiva oveq2 ralrab ssralv breq2 ralbidv rspcev cnheibor syl
      sylc wb mpbir2and eleq1d rexlimddv rgen2 isnlly mpbir2an ) AGUDHAUEHZACIZ
      UQJZGHZCDIZUFZAUGKKZEIZUHZUIZUJZDUUGLEALABUKZUUJEDAUUGUUGAHZUUDUUGHZMZUUD
      UAIZNULUMZUNKZJZUUGOZUUJUAUOUUPPUPKHZUULUUMUUSUAUOUJURUAUUGUUPUUDAPABUSZU
      TVAUUNUUOUOHZUUSMZMZUUDUUOVBVCJZUUQJZAVDKKZUUIHZAUVGUQJZGHZUUJUVDUVGUUFHZ
      UVGUUHHZUVHUVDYTUVFUUFHZUVFUVGOZUVGPOZUVKYTUVDUUKVEZUVDYTUVFAHZUUDUVFHZUV
      MUVPUVDUUTUUDPHZUVEVFHZUVQUUTUVDURVEZUVDUUGPUUDUVDUUGAVIZPUULUUGUWBOUUMUV
      CUUGAVGVHPAABVJVKZVLZUULUUMUVCVMVNZUVDUVEUVBUVEUOHZUUNUUSUUOVOVPZVQZUUPUU
      DUVEAPUVAVRQUVDUUTUVSUWFUVRUWAUWEUWGUUPUUDUVEPVSQUUDAUVFVTQUVDYTUVFPOZUVN
      UVPUVDUUTUVSUVTUWIUWAUWEUWHUUPUUDUVEPWAQZUVFAPUWCWBWCUVDUVGUUGPUVDUVGUURU
      UGUVDUUTUVSUVTUUOVFHZUVEUUOWDRZUVGUUROUWAUWEUWHUVBUWKUUNUUSUUOWEVPUVBUWLU
      UNUUSUUOWFVPUUPUUDUVEUUOAPUVAWGWIUUNUVBUUSWHWJZUWDWJZUUEAUVGUVFPUWCWKWLUV
      DUVGUUGOUVLUWMUVGUUGEWMWNWOUVGUUFUUHWPWQUVDUVJUVGAWRKHZFIZNKZUBIZSRZFUVGL
      ZUBTUJZUVDYTUWIUWOUVPUWJUVFAPUWCWSWCUVDUUDNKZUVEWTJZTHUWQUXCSRZFUVGLZUXAU
      VDUXBUVEUVDUUDUWEXAZUVDUVEUWGXBZXCUVDUVGUUDUCIZUUPJZUVESRZUCPXDZOZUXDFUXK
      LZUXEUVDUUTUVSUVTUXLUWAUWEUWHUCUUPUUDUVEUXKAPUVAUXKXKXEQUVDUUDUWPUUPJZUVE
      SRZUXDXFZFPLUXMUVDUXPFPUVDUWPPHZMZUWPUUDULJZNKZUVESRZUWQUXBULJZUVESRZUXOU
      XDUXRUYBUXTSRZUYAUYCUXRUWPUUDUVDUXQXLZUVDUVSUXQUWEXGZXHUXRUYBTHUXTTHUVETH
      ZUYDUYAMUYCXFUXRUWQUXBUXRUWPUYEXAZUVDUXBTHUXQUXFXGZXIUXRUXSUXRUWPUUDUYEUY
      FXJXAUVDUYGUXQUXGXGZUYBUXTUVEXMQXNUXRUXTUXNUVESUXRUXTUUDUWPULJNKZUXNUXRUW
      PUUDUYEUYFXOUVDUVSUXQUXNUYKXPUWEUUDUWPUUPUUPXKYBXQXRXSUXRUWQUXBUVEUYHUYIU
      YJXTYAYCUXJUXOUXDFUCPUXHUWPXPUXIUXNUVESUXHUWPUUDUUPYDXSYEWOUXDFUVGUXKYFYL
      UWTUXEUBUXCTUWRUXCXPUWSUXDFUVGUWRUXCUWQSYGYHYIWCUVDUVOUVJUWOUXAMYMUWNFUVI
      AUVGUBBUVIXKYJYKYNUUCUVJCUVGUUIUUAUVGXPUUBUVIGUUAUVGAUQYDYOYIWCYPYQEDCGAY
      RYS $.
  $}

  $( The topology on the reals is locally compact.  (Contributed by Mario
     Carneiro, 2-Mar-2015.) $)
  rellycmp $p |- ( topGen ` ran (,) ) e. N-Locally Comp $=
    ( cioo crn ctg cfv ccnfld ctopn cr crest co ccmp cnlly eqid tgioo2 cnllycmp
    wcel ccld recld2 cldllycmp mp2an eqeltri ) ABCDEFDZGHIZJKZUAUALZMUAUCOGUAPD
    OUBUCOUAUDNUAUDQGUARST $.

  ${
    $d u v x y z F $.  $d u v y z K $.  $d u v w x y z ph $.  $d v x y z X $.
    $d x y z J $.
    bndth.1 $e |- X = U. J $.
    bndth.2 $e |- K = ( topGen ` ran (,) ) $.
    bndth.3 $e |- ( ph -> J e. Comp ) $.
    bndth.4 $e |- ( ph -> F e. ( J Cn K ) ) $.
    $( The Boundedness Theorem.  A continuous function from a compact
       topological space to the reals is bounded (above).  (Boundedness below
       is obtained by applying this theorem to ` -u F ` .)  (Contributed by
       Mario Carneiro, 12-Aug-2014.) $)
    bndth $p |- ( ph -> E. x e. RR A. y e. X ( F ` y ) <_ x ) $=
      ( vw wss cr cioo cmnf wcel clt cxr wa vv vu vz crn cuni cfv cle wral wrex
      cv wbr csn cxp cpw cfn cin wf ccn co ctg ctopon retopon eqeltri toponunii
      cima cnf syl frn wi imassrn ctb retopbas bastg ax-mp sseqtr4i sstri retop
      ctop elexi elpw2 mpbir crest ccmp rncmp syl2anc cmpsub sylancr mpbid wceq
      wb unieq unissi unirnioo c1 caddc id ltp1 ressxr peano2re sseldi elioomnf
      mpbir2and df-ov mnfxr snid opelxpi wfun ioof ffun snssi xpss12 mp2an fdmi
      cop cdm funfvima2 syl5eqel elunii ssriv eqssi syl6eq sseq2d pweq mpd csup
      ineq1d simpr adantrr elpwid sseli adantr adantl idd xrltle eleq1d wfn ffn
      c0 wn sseldd rexeqdv imbi12d rspcv mpsyl elin sylib simprd simpld xrltnle
      wne mnflt elsni breq2d mtbird ioo0 syl2an necon3abid mpbird ixxub syl3anc
      df-ioo eqeltrd rgen2 fveq2 syl6eqr supeq1d supeq1 ralima fimaxre3 simplrr
      ssralv ee10 sselda eluni2 r19.29r sspwuni 3ad2ant1 simp2r simp3l r19.21bi
      ralxp adantrl 3adant3 simp2l syl6ss supxrub simp3r letrd 3expia rexlimdva
      w3a anassrs adantlrr syl5 expdimp sylan2b syldan ralrimdva ad2antrr breq1
      ralrn sylibd reximdva rexlimddv ) ADUDZUAUJZUEZMZCUJDUFZBUJZUGUKZCGUHZBNU
      IZUAOPULZNUMZVEZUNZUOUPZAUXENMZUXHUAUXRUIZAGNDUQZUXSADEFURUSQZUYAKDEFGNHN
      FFOUDZUTUFZNVAUFIVBVCVDZVFVGZGNDVHVGZUXPFUNZQZAUXEUBUJZUEZMZUXHUAUYJUNZUO
      UPZUIZVIZUBUYHUHZUXSUXTVIZUYIUXPFMUXPUYCFOUXOVJZUYCUYDFUYCVKQUYCUYDMVLUYC
      VKVMVNIVOVPUXPFFVRFUYDVRIVQVCZVSVTWAAFUXEWBUSWCQZUYQAEWCQUYBVUAJKDEFWDWEA
      FVRQUXSVUAUYQWJUYTUYGUXEFNUBUAUYEWFWGWHUYPUYRUBUXPUYHUYJUXPWIZUYLUXSUYOUX
      TVUBUYKNUXEVUBUYKUXPUEZNUYJUXPWKVUCNVUCUYCUENUXPUYCUYSWLWMVOZBNVUCUXJNQZU
      XJPUXJWNWOUSZOUSZQZVUGUXPQUXJVUCQVUEVUHVUEUXJVUFRUKZVUEWPUXJWQVUEVUFSQVUH
      VUEVUITWJVUENSVUFWRUXJWSZWTVUFUXJXAVGXBVUEVUGPVUFXNZOUFZUXPPVUFOXCVUEVUKU
      XOQZVULUXPQZVUEPUXNQVUFNQVUMPPSXDVSXEVUJPVUFUXNNXFWGOXGZUXOOXOZMVUMVUNVIS
      SUMZNUNZOUQZVUOXHVUQVUROXIVNUXOVUQVUPUXNSMZNSMUXOVUQMZPSQZVUTXDPSXJVNZWRU
      XNSNSXKXLZVUQVUROXHXMVOUXOVUKOXPXLVGXQUXJVUGUXPXRWEXSXTYAYBVUBUXHUAUYNUXR
      VUBUYMUXQUOUYJUXPYCYFUUAUUBUUCUUDYDAUXFUXRQZUXHTZTZLUJZSRYEZUXJUGUKZLUXFU
      HZBNUIZUXMVVGUXFUOQZVVINQZLUXFUHZVVLVVGUXFUXQQZVVMAVVEVVPVVMTZUXHAVVETZVV
      EVVQAVVEYGUXFUXQUOUUEUUFZYHUUGAVVEVVOUXHVVRUXFUXPMZVVNLUXPUHZVVOVVRUXFUXP
      VVRVVPVVMVVSUUHYIZVWAUCUJZOUFZSRYEZNQZUCUXOUHZVWGUYJVVHOUSZSRYEZNQZLNUHUB
      UXNUHVWJUBLUXNNUYJUXNQZVVHNQZTZVWIVVHNVWMUYJSQZVVHSQZVWHYRUUJZVWIVVHWIVWK
      VWNVWLUXNSUYJVVCYJZYKVWLVWOVWKNSVVHWRYJZYLVWMVWPVVHUYJUGUKZYSVWMVWSVVHPUG
      UKZVWLVWTYSZVWKVWLPVVHRUKZVXAVVHUUKVWLVVBVWOVXBVXAWJXDVWRPVVHUUIWGWHYLVWM
      UYJPVVHUGVWKUYJPWIVWLUYJPUULYKUUMUUNVWMVWSVWHYRVWKVWNVWOVWHYRWIVWSWJVWLVW
      QVWRUYJVVHUUOUUPUUQUURCUCUABUYJVVHRROCUCUAUVAUXJSQZVWOTUXJVVHRUKYMUXJVVHY
      NVWNVXCTUYJUXJRUKYMUYJUXJYNUUSUUTVWKVWLYGUVBUVCVWFVWJUCUBLUXNNVWCUYJVVHXN
      ZWIZVWEVWINVXESVWDVWHRVXEVWDVXDOUFVWHVWCVXDOUVDUYJVVHOXCUVEUVFYOUWAWAOVUQ
      YPZVVAVWAVWGWJVUSVXFXHVUQVUROYQVNVVDVVNVWFLUCVUQUXOOVVHVWDWIVVIVWENSVVHVW
      DRUVGYOUVHXLWAVVNLUXFUXPUVKUVLZYHBLUXFVVIUVIWEVVGVVKUXLBNVVGVUETZVVKVWCUX
      JUGUKZUCUXEUHZUXLVXHVVKVXIUCUXEVXHVWCUXEQVWCUXGQZVVKVXIVIZVXHUXEUXGVWCAVV
      EUXHVUEUVJUVMVXKVXHVWCVVHQZLUXFUIZVXLLVWCUXFUVNVXHVXNVVKVXIVXNVVKTVXMVVJT
      ZLUXFUIZVXHVXIVXMVVJLUXFUVOAVVEVUEVXPVXIVIUXHVVRVUETVXOVXILUXFVVRVUEVVHUX
      FQZVXOVXIVIVVRVUEVXQTZVXOVXIVVRVXRVXOUWKZVWCVVIUXJVXSVVHNVWCVXSVVHNVXSUXP
      VURVVHUXPVURMVUCNMVUDUXPNUVPWAVXSUXFUXPVVHVVRVXRVVTVXOVWBUVQVVRVUEVXQVXOU
      VRYTWTYIZVVRVXRVXMVVJUVSZYTVVRVXRVVNVXOVVRVXQVVNVUEVVRVVNLUXFVXGUVTUWBUWC
      VVRVUEVXQVXOUWDVXSVVHSMVXMVWCVVIUGUKVXSVVHNSVXTWRUWEVYAVVHVWCUWFWEVVRVXRV
      XMVVJUWGUWHUWIUWLUWJUWMUWNUWOUWPUWQUWRVXHDGYPZVXJUXLWJAVYBVVFVUEAUYAVYBUY
      FGNDYQVGUWSVXIUXKUCCGDVWCUXIUXJUGUWTUXAVGUXBUXCYDUXD $.

    evth.5 $e |- ( ph -> X =/= (/) ) $.
    $( The Extreme Value Theorem.  A continuous function from a nonempty
       compact topological space to the reals attains its maximum at some point
       in the domain.  (Contributed by Mario Carneiro, 12-Aug-2014.) $)
    evth $p |- ( ph -> E. x e. X A. y e. X ( F ` y ) <_ ( F ` x ) ) $=
      ( vz cle wbr cr c1 co wcel cc cv cfv wral wrex crn clt csup csn cdif cmin
      wn wf cdiv cmpt ccmp adantr ccnfld ctopn crest ccn cc0 ctop ctopon cmptop
      syl toptopon sylib eqid cnfldtopon a1i ax-1cn cnmptc wss wne w3a cioo ctg
      cuni uniretop unieqi eqtr4i cnf frn cdm wceq fdm eqnetrd dm0rn0 necon3bii
      wa c0 bndth wfn ffn breq1 ralrn rexbidv mpbird 3jca suprcl recnd cnfldtop
      feqmptd cnrest2r ax-mp tgioo2 eqtri oveq2i syl6eleq sseldi eqeltrrd subcn
      ctx cnmpt12f ad2antrr ffvelrn eldifsn simpld resubcld simprd necomd fmptd
      wb cnrest2 syl3anc mpbid rereccld sylancl sylancr gt0ne0d recgt0d syl2anc
      1re wi oveq2d adantrr ralimdva sylibrd mtod baib adantll subne0d sylanbrc
      difssd divcn ax-resscn syl6eleqr cif simpr ifcl 0re 0lt1 ltletrd ltsubrpd
      max1 elrpd ltnled simprl max2 ad2ant2l fnfvelrn sylan ad2ant2rl mpbir2and
      suprub ltlend letr mpan2d fveq2 ovex fvmpt breq1d ad2antll lerec syl22anc
      posdifd lesub recrecd 3bitr3d 3imtr4d anassrs suprleub pm2.65da ralrimiva
      breq2d bitrd nrexdv breq2 ralbidv syl5ibrcom necon3bd ffnfv dfrex2 sylibr
      ffvelrnda ) ACUAZDUBZBUAZDUBZNOZCGUCZUKZBGUCZUKUXABGUDAUXCGPDUEZPUFUGZUHU
      IZDULZAUXGUWPMGQUXEMUAZDUBZUJRZUMRZUNZUBZUWRNOZCGUCZBPUDAUXGWJZBCUXLEFGHI
      AEUOSZUXGJUPZUXPUXLEUQURUBZPUSRZUTRZEFUTRZUXPUXLEUXSUTRZSZUXLUYASZUXPMQUX
      JUMEUXSUXSTVAUHZUIZUSRZUXSGUXPEVBSZEGVCUBSUXPUXQUYIUXREVDVEEGHVFVGZUXPMQE
      UXSGTUYJUXSTVCUBSZUXPUXSUXSVHZVIVJZQTSUXPVKVJVLUXPMGUXJUNZUYCSZUYNEUYHUTR
      SZUXPMUXEUXIUJEUXSUXSUXSGUYJUXPMUXEEUXSGTUYJUYMAUXETSUXGAUXEAUXDPVMZUXDWK
      VNZUXHUWRNOZMUXDUCZBPUDZVOZUXEPSZAUYQUYRVUAAGPDULZUYQADUYBSVUDKDEFGPHPVPU
      EVQUBZVRFVRVSFVUEIVTWAWBVEZGPDWCVEADWDZWKVNUYRAVUGGWKAVUDVUGGWEVUFGPDWFVE
      LWGVUGWKUXDWKDWHWIVGAVUAUWQUWRNOZCGUCZBPUDABCDEFGHIJKWLAUYTVUIBPADGWMZUYT
      VUIYCAVUDVUJVUFGPDWNVEZUYSVUHMCGDUXHUWQUWRNWOWPVEWQWRWSZBMUXDWTVEZXAUPVLA
      MGUXIUNZUYCSUXGADVUNUYCAMGPDVUFXCAUYAUYCDUXSVBSUYAUYCVMUXSUYLXBPEUXSXDXEA
      DUYBUYAKFUXTEUTFVUEUXTIUXSUYLXFXGXHZXIXJXKUPUJUXSUXSXMRUXSUTRSUXPUXSUYLXL
      VJXNUXPUYKUYNUEUYGVMZUYGTVMUYOUYPYCUYMUXPGUYGUYNULVUPUXPMGUXJUYGUYNUXPUXH
      GSZWJZUXJTSUXJVAVNUXJUYGSVURUXJVURUXEUXIAVUCUXGVUQVUMXOZVURUXIPSZUXIUXEVN
      ZVURUXIUXFSZVUTVVAWJUXGVUQVVBAGUXFUXHDXPUUAUXIPUXEXQVGZXRZXSZXAVURUXEUXIV
      URUXEVUSXAVURUXIVVDXAVURUXIUXEVURVUTVVAVVCXTYAUUBZUXJTVAXQUUCUYNVHYBGUYGU
      YNWCVEUXPTUYFUUDUYGUYNEUXSTYDYEYFUMUXSUYHXMRUXSUTRSUXPUXSUYHUYLUYHVHUUEVJ
      XNUXPUYKUXLUEPVMZPTVMZUYDUYEYCUYMUXPGPUXLULVVGUXPMGUXKPUXLVURUXJVVEVVFYGU
      XLVHZYBGPUXLWCVEVVHUXPUUFVJPUXLEUXSTYDYEYFVUOUUGWLUXPUXOBPUXPUWRPSZWJZUXO
      UXEUXEQQUWRNOZUWRQUUHZUMRZUJRZNOZVVKVVOUXEUFOVVPUKVVKUXEVVNAVUCUXGVVJVUMX
      OZVVKVVNVVKVVMVVKVVJQPSZVVMPSZUXPVVJUUIZYMVVLUWRQPUUJZYHZVVKVVMVVKVAQVVMV
      APSVVKUUKVJVVRVVKYMVJVWBVAQUFOVVKUULVJVVKVVRVVJQVVMNOYMVVTQUWRUUOYIUUMZYJ
      ZYGZVVKVVMVWBVWCYKUUPUUNVVKVVOUXEVVKUXEVVNVVQVWEXSZVVQUUQYFVVKUXOUWQVVONO
      ZCGUCZVVPVVKUXNVWGCGUXPVVJUWPGSZUXNVWGYNUXPVVJVWIWJZWJZQUXEUWQUJRZUMRZUWR
      NOZVWMVVMNOZUXNVWGVWKVWNUWRVVMNOZVWOVWKVVRVVJVWPYMUXPVVJVWIUURZQUWRUUSYIV
      WKVWMPSVVJVVSVWNVWPWJVWOYNVWKVWLVWKUXEUWQAVUCUXGVWJVUMXOZVWKUWQPSZUWQUXEV
      NZVWKUWQUXFSZVWSVWTWJUXGVWIVXAAVVJGUXFUWPDXPUUTUWQPUXEXQVGZXRZXSZVWKVWLVW
      KUWQUXEUFOZVAVWLUFOZVWKVXEUWQUXENOZUXEUWQVNAVWIVXGUXGVVJAVWIWJVUBUWQUXDSZ
      VXGAVUBVWIVULUPAVUJVWIVXHVUKGUWPDUVAUVBBMUXDUWQUVEYLZUVCVWKUWQUXEVWKVWSVW
      TVXBXTYAVWKUWQUXEVXCVWRUVFUVDVWKUWQUXEVXCVWRUVPYFZYJYGVWQVWKVVJVVRVVSVWQY
      MVWAYHZVWMUWRVVMUVGYEUVHVWIUXNVWNYCUXPVVJVWIUXMVWMUWRNMUWPUXKVWMGUXLUXHUW
      PWEZUXJVWLQUMVXLUXIUWQUXEUJUXHUWPDUVIYOYOVVIQVWLUMUVJUVKUVLUVMVWKVVNVWLNO
      ZVWMQVVNUMRZNOZVWGVWOVWKVVNPSZVAVVNUFOVWLPSVXFVXMVXOYCUXPVVJVXPVWIVWEYPZV
      WKVVMVXKUXPVVJVAVVMUFOVWIVWCYPYKVXDVXJVVNVWLUVNUVOVWKVXPVUCVWSVXMVWGYCVXQ
      VWRVXCVVNUXEUWQUVQYEVWKVXNVVMVWMNVWKVVMVWKVVMVXKXAUXPVVJVVMVAVNVWIVWDYPUV
      RUWEUVSUVTUWAYQVVKVVPUXHVVONOZMUXDUCZVWHVVKVUBVVOPSVVPVXSYCAVUBUXGVVJVULX
      OVWFBMMUXDVVOUWBYLVVKVUJVXSVWHYCAVUJUXGVVJVUKXOVXRVWGMCGDUXHUWQVVONWOWPVE
      UWFYRYSUWGUWCAUXCUWSUXFSZBGUCZUXGAUXBVXTBGAUWRGSZWJZUXBUWSUXEVNZVXTAUXBVY
      DYNVYBAUXAUWSUXEAUXAUWSUXEWEZVXGCGUCAVXGCGVXIUWDVYEUWTVXGCGUWSUXEUWQNUWHU
      WIUWJUWKUPVYCUWSPSZVXTVYDYCAGPUWRDVUFUWOVXTVYFVYDUWSPUXEXQYTVEYRYQAVUJUXG
      VYAYCVUKUXGVUJVYABGUXFDUWLYTVEYRYSUXABGUWMUWN $.

    $( The Extreme Value Theorem, minimum version.  A continuous function from
       a nonempty compact topological space to the reals attains its minimum at
       some point in the domain.  (Contributed by Mario Carneiro,
       12-Aug-2014.) $)
    evth2 $p |- ( ph -> E. x e. X A. y e. X ( F ` x ) <_ ( F ` y ) ) $=
      ( vz cfv co cr wcel ccn a1i cc cv cneg cmpt cle wbr wral wrex cmin ctopon
      cc0 ctop ccmp cmptop syl toptopon sylib cioo crn ctg cuni uniretop unieqi
      eqtr4i cnf feqmptd eqeltrrd retopon eqeltri ccnfld ctopn crest cnfldtopon
      wf eqid 0cn cnmptc tgioo2 eqtri wss ax-resscn cnmptid cnmpt1res ctx subcn
      cnmpt12f df-neg renegcl syl5eqelr adantl fmptd frn cnrest2 syl3anc oveq2i
      wb mpbid syl6eleqr wceq negeq syl5eqr cnmpt11 wa fveq2 negeqd negex fvmpt
      ad2antlr breq12d ffvelrnda adantr adantlr lenegd bitr4d ralbidva rexbidva
      evth ) ACUAZMGMUAZDNZUBZUCZNZBUAZYANZUDUEZCGUFZBGUGYCDNZXQDNZUDUEZCGUFZBG
      UGABCYAEFGHIJAMCXSUJXQUHOZXTEFFGPAEUKQZEGUINQAEULQYLJEUMUNEGHUOUPADMGXSUC
      EFROZAMGPDADYMQGPDVMKDEFGPHPUQURUSNZUTFUTVAFYNIVBVCVDUNZVEKVFFPUINZQAFYNY
      PIVGVHSZACPYKUCZFVIVJNZPVKOZROZFFROAYRFYSROQZYRUUAQZACUJXQUHFYSYSYSPYQACU
      JFYSPTYQYSTUINQZAYSYSVNZVLSZUJTQAVOSVPACXQYSFYSTPFYNYTIYSUUEVQVRZUUFPTVSZ
      AVTSZACYSTUUFWAWBUHYSYSWCOYSROQAYSUUEWDSWEAUUDYRURPVSZUUHUUBUUCWOUUFAPPYR
      VMUUJACPYKPYRXQPQZYKPQAUUKYKXQUBZPXQWFZXQWGWHWIYRVNWJPPYRWKUNUUIPYRFYSTWL
      WMWPFYTFRUUGWNWQXQXSWRYKUULXTUUMXQXSWSWTXALXPAYFYJBGAYCGQZXBZYEYICGUUOXQG
      QZXBZYEYHUBZYGUBZUDUEYIUUQYBUURYDUUSUDUUPYBUURWRUUOMXQXTUURGYAXRXQWRXSYHX
      RXQDXCXDYAVNZYHXEXFWIUUNYDUUSWRAUUPMYCXTUUSGYAXRYCWRXSYGXRYCDXCXDUUTYGXEX
      FXGXHUUQYGYHUUOYGPQUUPAGPYCDYOXIXJAUUPYHPQUUNAGPXQDYOXIXKXLXMXNXOWP $.
  $}

  ${
    $d d k m r u w x y z D $.  $d d k w x y z J $.  $d d k m r u w x y z U $.
    $d r w x F $.  $d d k m r w x y z ph $.  $d d k m r u w x y z X $.
    $d x K $.
    lebnum.j $e |- J = ( MetOpen ` D ) $.
    lebnum.d $e |- ( ph -> D e. ( Met ` X ) ) $.
    lebnum.c $e |- ( ph -> J e. Comp ) $.
    lebnum.s $e |- ( ph -> U C_ J ) $.
    lebnum.u $e |- ( ph -> X = U. U ) $.
    ${
      lebnumlem1.u $e |- ( ph -> U e. Fin ) $.
      lebnumlem1.n $e |- ( ph -> -. X e. U ) $.
      lebnumlem1.f $e |- F = ( y e. X |-> sum_ k e. U
        sup ( ran ( z e. ( X \ k ) |-> ( y D z ) ) , RR* , `' < ) ) $.
      $( Lemma for ~ lebnum .  The function ` F ` measures the sum of all of
         the distances to escape the sets of the cover.  Since by assumption it
         is a cover, there is at least one set which covers a given point, and
         since it is open, the point is a positive distance from the edge of
         the set.  Thus, the sum is a strictly positive number.  (Contributed
         by Mario Carneiro, 14-Feb-2015.) $)
      lebnumlem1 $p |- ( ph -> F : X --> RR+ ) $=
        ( wcel cr cc0 vm vw cv cdif co cmpt crn cxr clt ccnv csup csu wa adantr
        crp cfn wral wf cme cfv wss wne ad2antrr difssd cuni sselda elssuni syl
        c0 wceq metxmet mopnuni sseqtr4d wi wn eleq1 notbid syl5ibrcom necon2ad
        cxmt imp pssdifn0 syl2anc eqid metdsre syl3anc fmpt sylibr rsp fsumrecl
        simplr sylc wbr wrex eleq2d biimpa eluni2 sylib 0re a1i metdsval simprl
        sseldd 3syl mpd ffvelrnd eqeltrrd cle cpnf metdsf elxrge0 simprd elndif
        cicc ad2antll ccld difeq1d ctop mopntop opncld eqeltrd cldcls neleqtrrd
        ccl wb metdseq0 necon3abid mpbird ne0gt0d breqtrd adantlr mpteq1d rneqd
        difeq2 supeq1d fsumge1 ltletrd rexlimddv elrpd fmptd ) ABIECIFUCZUDZBUC
        ZCUCZDUEZUFZUGZUHUIUJZUKZFULZUOGAUUCIRZUMZUUJUULEUUIFAEUPRZUUKOUNUULUUA
        ERZUMZUUISRZBIUQZUUKUUPUUOISBIUUIUFZURZUUQUUODIUSUTRZUUBIVAZUUBVIVBZUUS
        AUUTUUKUUNKVCUUOIUUAVDZUUOUUAIVAUUAIVBZUVBUUOUUAHVEZIUUOUUAHRUUAUVEVAUU
        LEHUUAAEHVAZUUKMUNVFUUAHVGVHAIUVEVJZUUKUUNADIVTUTRZUVGAUUTUVHKDIVKZVHZD
        HIJVLZVHVCVMUULUUNUVDAUUNUVDVNUUKAUUNUUAIAUUNVOUUAIVJZIERZVOZPUVLUUNUVM
        UUAIEVPVQVRVSUNWAUUAIWBWCBCDUUBUURIUURWDZWEWFBISUUIUURUVOWGWHAUUKUUNWKZ
        UUPBIWIWLZWJZUULUUCUAUCZRZTUUJUIWMUAEUULUUCEVEZRZUVTUAEWNAUUKUWBAIUWAUU
        CNWOWPUAUUCEWQWRUULUVSERZUVTUMZUMZTCIUVSUDZUUEUFZUGZUHUUHUKZUUJTSRUWEWS
        WTUWEUUCUBICUWFUBUCUUDDUEUFUGUHUUHUKUFZUTZUWISUWEUUKUWKUWIVJAUUKUWDWKZU
        BCUUCDUWFUWJIUWJWDZXAVHZUWEISUUCUWJUWEUUTUWFIVAZUWFVIVBZISUWJURAUUTUUKU
        WDKVCZUWEIUVSVDZUWEUVSIVAUVSIVBZUWPUWEUVSUVEIUWEUVSHRZUVSUVEVAUWEEHUVSA
        UVFUUKUWDMVCUULUWCUVTXBZXCZUVSHVGVHUWEUUTUVHUVGUWQUVIUVKXDZVMUWEUWCUWSU
        XAAUWCUWSVNUUKUWDAUWCUVSIAUWCVOUVSIVJZUVNPUXDUWCUVMUVSIEVPVQVRVSVCXEUVS
        IWBWCUBCDUWFUWJIUWMWEWFUWLXFZXGUULUUJSRUWDUVRUNUWETUWKUWIUIUWEUWKUXEUWE
        UWKUHRZTUWKXHWMZUWEUWKTXIXNUEZRUXFUXGUMUWEIUXHUUCUWJUWEUVHUWOIUXHUWJURA
        UVHUUKUWDUVJVCZUWRUBCDUWFUWJIUWMXJWCUWLXFUWKXKWRXLUWEUWKTVBUUCUWFHYDUTU
        TZRZVOUWEUXJUWFUUCUVTUUCUWFRVOUULUWCUUCUVSIXMXOUWEUWFHXPUTZRUXJUWFVJUWE
        UWFUVEUVSUDZUXLUWEIUVEUVSUXCXQUWEHXRRZUWTUXMUXLRUWEUVHUXNUXIDHIJXSVHUXB
        UVSHUVEUVEWDXTWCYAUWFHYBVHYCUWEUXKUWKTUWEUVHUWOUUKUWKTVJUXKYEUXIUWRUWLU
        BCUUCDUWFUWJHIUWMJYFWFYGYHYIUWNYJUWEEUUIUWIFUVSAUUMUUKUWDOVCUULUUNUUPUW
        DUVQYKUULUUNTUUIXHWMZUWDUUOUUIUHRZUXOUUOUUIUXHRZUXPUXOUMUUOUXQBIUQZUUKU
        XQUUOIUXHUURURZUXRUUOUVHUVAUXSAUVHUUKUUNUVJVCUVCBCDUUBUURIUVOXJWCBIUXHU
        UIUURUVOWGWHUVPUXQBIWIWLUUIXKWRXLYKUUAUVSVJZUHUUGUWHUUHUXTUUFUWGUXTCUUB
        UWFUUEUUAUVSIYNYLYMYOUXAYPYQYRYSQYT $.

      lebnumlem2.k $e |- K = ( topGen ` ran (,) ) $.
      $( Lemma for ~ lebnum .  As a finite sum of point-to-set distance
         functions, which are continuous by ~ metdscn , the function ` F ` is
         also continuous.  (Contributed by Mario Carneiro, 14-Feb-2015.) $)
      lebnumlem2 $p |- ( ph -> F e. ( J Cn K ) ) $=
        ( wcel ccnfld ctopn cfv cr crest co ccn cdif cmpt crn cxr clt ccnv csup
        cv csu eqid cxmt ctopon cme metxmet syl mopntopon wss wne adantr difssd
        wa c0 sselda toponss syl2anc wn wceq eleq1 syl5ibrcom necon2ad pssdifn0
        notbid imp metdscn2 syl3anc fsumcn syl5eqel cc wb cnfldtopon a1i crp wf
        lebnumlem1 frn rpssre syl6ss ax-resscn cnrest2 mpbid cioo tgioo2 oveq2i
        ctg eqtri syl6eleqr ) AGHUAUBUCZUDUEUFZUGUFZHIUGUFAGHXDUGUFZTZGXFTZAGBJ
        ECJFUOZUHZBUOCUODUFUIUJUKULUMUNZFUPUIXGRABEXLFHXDJXDUQZADJURUCTZHJUSUCT
        ZADJUTUCTZXNLDJVAVBZDHJKVCZVBPAXJETZVHZXPXKJVDXKVIVEZBJXLUIZXGTAXPXSLVF
        XTJXJVGXTXJJVDZXJJVEZYAXTXOXJHTYCXTXNXOAXNXSXQVFXRVBAEHXJNVJXJHJVKVLAXS
        YDAXSXJJAXSVMXJJVNZJETZVMQYEXSYFXJJEVOVSVPVQVTXJJVRVLBCDXKYBHXDJYBUQKXM
        WAWBWCWDAXDWEUSUCTZGUJZUDVDUDWEVDZXHXIWFYGAXDXMWGWHAYHWIUDAJWIGWJYHWIVD
        ABCDEFGHJKLMNOPQRWKJWIGWLVBWMWNYIAWOWHUDGHXDWEWPWBWQIXEHUGIWRUJXAUCXESX
        DXMWSXBWTXC $.

      $( Lemma for ~ lebnum .  By the previous lemmas, ` F ` is continuous and
         positive on a compact set, so it has a positive minimum ` r ` .  Then
         setting ` d = r / # ( U ) ` , since for each ` u e. U ` we have
         ` ball ( x , d ) C_ u ` iff ` d <_ d ( x , X \ u ) ` , if
         ` -. ball ( x , d ) C_ u ` for all ` u ` then summing over ` u `
         yields ` sum_ u e. U d ( x , X \ u ) = F ( x ) < sum_ u e. U d = r ` ,
         in contradiction to the assumption that ` r ` is the minimum of
         ` F ` .  (Contributed by Mario Carneiro, 14-Feb-2015.)  (Revised by
         Mario Carneiro, 5-Sep-2015.) $)
      lebnumlem3 $p |- ( ph ->
        E. d e. RR+ A. x e. X E. u e. U ( x ( ball ` D ) d ) C_ u ) $=
        ( vr vw cv cbl cfv co wss wrex wral crp c0 wceq wa wne c1 wcel 1rp ne0i
        ax-mp ral0 simpr raleqdv mpbiri ralrimivw r19.2z sylancr cle wbr crn wf
        lebnumlem1 adantr frn syl cuni eqid ccmp ccn lebnumlem2 metxmet mopnuni
        cme cxmt 3syl neeq1d biimpa evth2 raleq rexeqbi1dv mpbird wfn ffn breq1
        wb ralbidv rexrn ssrexv sylc chash cdiv cn ad2antrr eqnetrrd unieq uni0
        simplr syl6eq necon3i cfn hashnncl rpdivcld wn ralnex clt cdif cmpt cxr
        nnrpd ccnv csup cr simprl metdsval difssd elssuni adantl sseqtr4d eleq1
        csu wi notbid syl2anc syl3anc ffvelrnd rpred weq ltnled rpcnd ad3antrrr
        syl5ibrcom necon2ad imp pssdifn0 metdsre simprr sseq2 rspccva sylan cin
        eqeltrrd rpxrd metdsge syl31anc difin0ss syl5com sylbid eqbrtrrd fsumlt
        blssm mtod oveq1 mpteq2dv rneqd supeq1d sumeq2sdv sumex fvmpt fsumconst
        cmul cc nncnd nnne0d divcan2d 3brtr4d mpbid expr syl5bir con4d ralimdva
        eqtr2d oveq2 sseq1d rexbidv rspcev ee12an rexlimdva mpd pm2.61dane ) AB
        UEZMUEZFUFUGZUHZEUEZUIZEGUJZBLUKZMULUJZLUMALUMUNZUOZULUMUPZUWRMULUKUWSU
        QULURUXBUSULUQUTVAUXAUWRMULUXAUWRUWQBUMUKUWQBVBUXAUWQBLUMAUWTVCVDVEVFUW
        RMULVGVHALUMUPZUOZUCUEZUWKIUGZVIVJZBLUKZUCULUJZUWSUXDIVKZULUIZUXHUCUXJU
        JZUXIUXDLULIVLZUXKAUXMUXCACDFGHIJLNOPQRSTUAVMVNZLULIVOVPUXDUXLUDUEIUGZU
        XFVIVJZBLUKZUDLUJZUXDUXRUXPBJVQZUKZUDUXSUJZUXDUDBIJKUXSUXSVRUBAJVSURUXC
        PVNAIJKVTUHURUXCACDFGHIJKLNOPQRSTUAUBWAVNAUXCUXSUMUPALUXSUMAFLWDUGURZFL
        WEUGURZLUXSUNZOFLWBZFJLNWCWFZWGWHWIUXDUYDUXRUYAWPAUYDUXCUYFVNUXQUXTUDLU
        XSUXPBLUXSWJWKVPWLUXDUXMILWMUXLUXRWPUXNLULIWNUXHUXQUCUDLIUXEUXOUNUXGUXP
        BLUXEUXOUXFVIWOWQWRWFWLUXHUCUXJULWSWTUXDUXHUWSUCULUXDUXEULURZUOZUXEGXAU
        GZXBUHZULURZUXHUWKUYJUWMUHZUWOUIZEGUJZBLUKZUWSUYHUXEUYIUXDUYGVCUYHUYIUY
        HUYIXCURZGUMUPZUYHGVQZUMUPUYQUYHLUYRUMALUYRUNZUXCUYGRXDZAUXCUYGXHXEGUMU
        YRUMGUMUNUYRUMVQUMGUMXFXGXIXJVPZUYHGXKURZUYPUYQWPAVUBUXCUYGSXDZGXLVPWLZ
        XTXMZUYHUXGUYNBLUYHUWKLURZUOZUYNUXGUYNXNUYMXNZEGUKZVUGUXGXNZUYMEGXOUYHV
        UFVUIVUJUYHVUFVUIUOZUOZUXFUXEXPVJVUJVULGDLHUEZXQZUWKDUEZFUHZXRZVKZXSXPY
        AZYBZHYKZGUYJHYKZUXFUXEXPVULGVUTUYJHUYHVUBVUKVUCVNZUYHUYQVUKVUAVNVULVUM
        GURZUOZUWKCLDVUNCUEZVUOFUHZXRZVKZXSVUSYBZXRZUGZVUTYCVVEVUFVVLVUTUNVULVU
        FVVDUYHVUFVUIYDZVNZCDUWKFVUNVVKLVVKVRZYEVPZVVELYCUWKVVKVVEUYBVUNLUIZVUN
        UMUPZLYCVVKVLUYHUYBVUKVVDAUYBUXCUYGOXDXDZVVELVUMYFZVVEVUMLUIVUMLUPZVVRV
        VEVUMUYRLVVDVUMUYRUIVULVUMGYGYHUYHUYSVUKVVDUYTXDYIVULVVDVWAAVVDVWAYLUXC
        UYGVUKAVVDVUMLAVVDXNVUMLUNZLGURZXNTVWBVVDVWCVUMLGYJYMUUBUUCUUAUUDVUMLUU
        EYNCDFVUNVVKLVVOUUFYOVVNYPZUULVVEUYJUYHUYKVUKVVDVUEXDZYQZVVEVVLVUTUYJXP
        VVPVVEVVLUYJXPVJUYJVVLVIVJZXNVVEVWGUYLVUMUIZVULVUIVVDVWHXNZUYHVUFVUIUUG
        VUHVWIEVUMGEHYRUYMVWHUWOVUMUYLUUHYMUUIUUJVVEVWGVUNUYLUUKUMUNZVWHVVEUYCV
        VQVUFUYJXSURZVWGVWJWPVVEUYBUYCVVSUYEVPZVVTVVNVVEUYJVWEUUMZCDUWKFUYJVUNV
        VKLVVOUUNUUOVVEUYLLUIZVWJVWHVVEUYCVUFVWKVWNVWLVVNVWMFUWKUYJLUVAYOLVUMUY
        LUUPUUQUURUVBVVEVVLUYJVWDVWFYSWLUUSUUTVULVUFUXFVVAUNVVMCUWKGVVJHYKVVALI
        CBYRZGVVJVUTHVWOXSVVIVURVUSVWOVVHVUQVWODVUNVVGVUPVVFUWKVUOFUVCUVDUVEUVF
        UVGUAGVUTHUVHUVIVPVULVVBUYIUYJUVKUHZUXEVULVUBUYJUVLURVVBVWPUNVVCVULUYJU
        YHUYKVUKVUEVNYTGUYJHUVJYNVULUXEUYIVULUXEUXDUYGVUKXHZYTVULUYIUYHUYPVUKVU
        DVNZUVMVULUYIVWRUVNUVOUWBUVPVULUXFUXEVULUXFVULLULUWKIUXDUXMUYGVUKUXNXDV
        VMYPYQVULUXEVWQYQYSUVQUVRUVSUVTUWAUWRUYOMUYJULUWLUYJUNZUWQUYNBLVWSUWPUY
        MEGVWSUWNUYLUWOUWLUYJUWKUWMUWCUWDUWEWQUWFUWGUWHUWIUWJ $.
    $}

    $( The Lebesgue number lemma, or Lebesgue covering lemma.  If ` X ` is a
       compact metric space and ` U ` is an open cover of ` X ` , then there
       exists a positive real number ` d ` such that every ball of size ` d `
       (and every subset of a ball of size ` d ` , including every subset of
       diameter less than ` d ` ) is a subset of some member of the cover.
       (Contributed by Mario Carneiro, 14-Feb-2015.)  (Proof shortened by Mario
       Carneiro, 5-Sep-2015.) $)
    lebnum $p |- ( ph ->
      E. d e. RR+ A. x e. X E. u e. U ( x ( ball ` D ) d ) C_ u ) $=
      ( cv wss wrex crp cfn wcel c1 vw vy vz vk cuni wceq cbl cfv wral cpw ccmp
      co cin cxmt cme metxmet syl mopnuni eqtr3d eqid cmpcov syl3anc 1rp simprl
      inss1 sseldi elpwid ad2antrr simplr sseldd cxr ad3antrrr simpr rpxr blssm
      wa sseq2 rspcev syl2anc ralrimiva oveq2 sseq1d rexbidv ralbidv sylancr wn
      mp1i cdif cmpt crn clt ccnv csup csu ctg adantr sstrd simplrr eqtrd inss2
      cioo lebnumlem3 wi ssrexv ralimdv reximdv mpd pm2.61dan rexlimddv ) AFUEZ
      UANZUEZUFZBNZHNZDUGUHZULZCNZOZCEPZBGUIZHQPZUAEUJZRUMZAFUKSZEFOZXJEUEZUFXM
      UAYDPKLAGXJYGADGUNUHSZGXJUFZADGUOUHSZYHJDGUPUQZDFGIURUQZMUSEFXJUAXJUTVAVB
      AXKYDSZXMVPZVPZGXKSZYBYOYPVPZTQSZXNTXPULZXROZCEPZBGUIZYBVCYQUUABGYQXNGSZV
      PZGESYSGOZUUAUUDXKEGYOXKEOZYPUUCYOXKEYOYDYCXKYCRVEAYMXMVDZVFVGZVHYOYPUUCV
      IVJUUDYHUUCTVKSZUUEAYHYNYPUUCYKVLYQUUCVMYRUUIUUDVCTVNWGDXNTGVOVBYTUUECGEX
      RGYSVQVRVSVTYAUUBHTQXOTUFZXTUUABGUUJXSYTCEUUJXQYSXRXOTXNXPWAWBWCWDVRWEYOY
      PWFZVPZXSCXKPZBGUIZHQPYBUULBUBUCCDXKUDUBGXKUCGUDNWHUBNUCNDULWIWJVKWKWLWMU
      DWNWIZFXAWJWOUHZGHIAYJYNUUKJVHAYEYNUUKKVHUULXKEFYOUUFUUKUUHWPZAYFYNUUKLVH
      WQUULGXJXLAYIYNUUKYLVHAYMXMUUKWRWSYOXKRSUUKYOYDRXKYCRWTUUGVFWPYOUUKVMUUOU
      TUUPUTXBUULUUNYAHQUULUUMXTBGUULUUFUUMXTXCUUQXSCXKEXDUQXEXFXGXHXI $.
  $}

  ${
    $d d r u x y z D $.  $d r u x ph $.  $d d r u x U $.  $d d r u x y z X $.
    xlebnum.j $e |- J = ( MetOpen ` D ) $.
    xlebnum.d $e |- ( ph -> D e. ( *Met ` X ) ) $.
    xlebnum.c $e |- ( ph -> J e. Comp ) $.
    xlebnum.s $e |- ( ph -> U C_ J ) $.
    xlebnum.u $e |- ( ph -> X = U. U ) $.
    $( Generalize ~ lebnum to extended metrics.  (Contributed by Mario
       Carneiro, 5-Sep-2015.) $)
    xlebnum $p |- ( ph ->
      E. d e. RR+ A. x e. X E. u e. U ( x ( ball ` D ) d ) C_ u ) $=
      ( vy vz cv co c1 crp wcel vr cle wbr cif cmpt2 cbl cfv wss wrex wral eqid
      cmopn cxmt cme 1rp stdbdmet sylancl ccmp cxr cc0 wceq rpxr mp1i stdbdmopn
      clt 0lt1 syl3anc eqeltrrd sseqtrd lebnum wa simpr ifcl wi ad2antrr adantr
      a1i syl cr rpre ad2antlr 1re min2 stdbdbl syl33anc metxmet min1 syl221anc
      ssbl eqsstr3d sstr2 reximdv ralimdva sseq1d rexbidv ralbidv rspcev ee12an
      oveq2 rexlimdva mpd ) ABPZUAPZNOGGNPOPDQZRUBUCXDRUDUEZUFUGZQZCPZUHZCEUIZB
      GUJZUASUIXBHPZDUFUGZQZXHUHZCEUIZBGUJZHSUIZABCXEEXEULUGZGUAXSUKADGUMUGZTZR
      STZXEGUNUGTZJUONODXERGXEUKZUPUQZAFXSURAYARUSTZUTRVEUCZFXSVAJYBYFAUORVBZVC
      YGAVFVQNODXERFGYDIVDVGZKVHAEFXSLYIVIMVJAXKXRUASAXCSTZVKZXCRUBUCZXCRUDZSTZ
      XKXBYMXMQZXHUHZCEUIZBGUJZXRYKYJYBYNAYJVLUOYLXCRSVMUQZYKXJYQBGYKXBGTZVKZXI
      YPCEUUAYOXGUHXIYPVNUUAYOXBYMXFQZXGUUAYAYFYGYTYMUSTZYMRUBUCZUUBYOVAAYAYJYT
      JVOYBYFUUAUOYHVCYGUUAVFVQYKYTVLZUUAYNUUCYKYNYTYSVPYMVBVRZUUAXCVSTZRVSTZUU
      DYJUUGAYTXCVTWAZWBXCRWCUQNODXEXBRYMGYDWDWEUUAXEXTTZYTUUCXCUSTZYMXCUBUCZUU
      BXGUHUUAYCUUJAYCYJYTYEVOXEGWFVRUUEUUFYJUUKAYTXCVBWAUUAUUGUUHUULUUIWBXCRWG
      UQXEXBYMXCGWIWHWJYOXGXHWKVRWLWMXQYRHYMSXLYMVAZXPYQBGUUMXOYPCEUUMXNYOXHXLY
      MXBXMWSWNWOWPWQWRWTXA $.
  $}

  ${
    $d k n r u x U $.
    $( Specialize the Lebesgue number lemma ~ lebnum to the unit interval.
       (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    lebnumii $p |- ( ( U C_ II /\ ( 0 [,] 1 ) = U. U ) -> E. n e. NN
    A. k e. ( 1 ... n ) E. u e. U ( ( ( k - 1 ) / n ) [,] ( k / n ) ) C_ u ) $=
      ( wss cc0 c1 co wceq cv cmin cfv wrex cdiv wcel cc cr cle wbr clt vx cicc
      vr cii cuni wa cabs ccom cxp cres cbl crp cfz cn df-ii cme cnmet unitssre
      wral ax-resscn sstri metres2 mp2an a1i iicmp simpl simpr lebnum cfl caddc
      cn0 rpreccl adantl rpred rpge0d flge0nn0 syl2anc nn0p1nn syl elfznn nnrpd
      ccmp adantr rpdivcld cmul elfzle2 nnred recnd mulid1d breqtrrd 1re nngt0d
      wi wb ledivmul syl112anc mpbird 0re elicc2i syl3anbrc oveq1 rexbidv rspcv
      sseq1d cioo cin cxr simplr resubcld rexrd readdcld nn0red nndivred nnne0d
      nnm1nn0 ax-1cn nncan sylancl oveq1d eqtr3d rprecred flltp1 rpgt0 ad2antlr
      ltdiv23 syl122anc mpbid eqbrtrd ltsub23d ltaddrpd iccssioo nn0ge0d divge0
      divsubdird syl22anc iccss ssind cxmt eqid oveq2 dfss1 mpbi syl6eleqr rpxr
      rexmet xpss12 resabs1 ax-mp eqcomi syl3anc bl2ioo ineq1d sseqtr4d reximdv
      blres eqtrd sstr2 ralrimdva oveq12d raleqbidv rspcev ee12an rexlimdva mpd
      syld ) BUDEZFGUBHZBUEIZUFZUAJZUCJZUGKUHZUVGUVGUIZUJZUKLZHZAJZEZABMZUAUVGU
      SZUCULMCJZGKHZDJZNHZUWAUWCNHZUBHZUVQEZABMZCGUWCUMHZUSZDUNMZUVIUAAUVNBUDUV
      GUCUOUVNUVGUPLOZUVIUVLPUPLOUVGPEUWLUQUVGQPURUTVAUVLUVGPVBVCVDUDWBOUVIVEVD
      UVFUVHVFUVFUVHVGVHUVIUVTUWKUCULUVIUVKULOZUFZGUVKNHZVILZGVJHZUNOZUVTUWBUWQ
      NHZUWAUWQNHZUBHZUVQEZABMZCGUWQUMHZUSZUWKUWNUWPVKOZUWRUWNUWOQOZFUWORSUXFUW
      NUWOUWMUWOULOUVIUVKVLVMZVNUWNUWOUXHVOUWOVPVQUWPVRVSZUWNUVTUXCCUXDUWNUWAUX
      DOZUFZUVTUWTUVKUVOHZUVQEZABMZUXCUXKUWTUVGOZUVTUXNWMUXKUWTQOZFUWTRSUWTGRSZ
      UXOUXKUWTUXKUWAUWQUXKUWAUXJUWAUNOZUWNUWAUWQVTVMZWAUXKUWQUWNUWRUXJUXIWCZWA
      WDZVNZUXKUWTUYAVOUXKUXQUWAUWQGWEHZRSZUXKUWAUWQUYCRUXJUWAUWQRSUWNUWAGUWQWF
      VMUXKUWQUXKUWQUXKUWQUXTWGZWHZWIWJUXKUWAQOGQOZUWQQOZFUWQTSZUXQUYDWNUXKUWAU
      XSWGZUYGUXKWKVDZUYEUXKUWQUXTWLZUWAGUWQWOWPWQZFGUWTWRWKWSWTZUVSUXNUAUWTUVG
      UVJUWTIZUVRUXMABUYOUVPUXLUVQUVJUWTUVKUVOXAXDXBXCVSUXKUXMUXBABUXKUXAUXLEUX
      MUXBWMUXKUXAUWTUVKKHZUWTUVKVJHZXEHZUVGXFZUXLUXKUXAUYRUVGUXKUYPXGOUYQXGOUY
      PUWSTSUWTUYQTSUXAUYREUXKUYPUXKUWTUVKUYBUXKUVKUVIUWMUXJXHZVNZXIXJUXKUYQUXK
      UWTUVKUYBVUAXKXJUXKUWTUWSUVKUYBUXKUWBUWQUXKUWBUXKUXRUWBVKOUXSUWAXOVSZXLZU
      XTXMVUAUXKUWTUWSKHZGUWQNHZUVKTUXKUWAUWBKHZUWQNHVUDVUEUXKUWAUWBUWQUXKUWAUY
      JWHZUXKUWBVUCWHUYFUXKUWQUXTXNYNUXKVUFGUWQNUXKUWAPOGPOVUFGIVUGXPUWAGXQXRXS
      XTUXKUWOUWQTSZVUEUVKTSZUXKUXGVUHUXKUVKUYTYAUWOYBVSUXKUYGUVKQOZFUVKTSZUYHU
      YIVUHVUIWNUYKVUAUWMVUKUVIUXJUVKYCYDUYEUYLGUVKUWQYEYFYGYHYIUXKUWTUVKUYBUYT
      YJUYPUYQUWSUWTYKYOUXKFQOZUYGFUWSRSZUXQUXAUVGEVULUXKWRVDUYKUXKUWBQOFUWBRSU
      YHUYIVUMVUCUXKUWBVUBYLUYEUYLUWBUWQYMYOUYMFGUWSUWTYPYOYQUXKUXLUWTUVKUVLQQU
      IZUJZUKLHZUVGXFZUYSUXKVUOQYRLOZUWTQUVGXFZOUVKXGOZUXLVUQIVURUXKVUOVUOYSZUU
      EVDUXKUWTUVGVUSUYNUVGQEZVUSUVGIURUVGQUUAUUBUUCUWMVUTUVIUXJUVKUUDYDUVNVUOU
      WTUVKQUVGVUOUVMUJZUVNUVMVUNEZVVCUVNIVVBVVBVVDURURUVGQUVGQUUFVCUVLUVMVUNUU
      GUUHUUIUUOUUJUXKVUPUYRUVGUXKUXPVUJVUPUYRIUYBVUAUWTUVKVUOVVAUUKVQUULUUPUUM
      UXAUXLUVQUUQVSUUNUVEUURUWJUXEDUWQUNUWCUWQIZUWHUXCCUWIUXDUWCUWQGUMYTVVEUWG
      UXBABVVEUWFUXAUVQVVEUWDUWSUWEUWTUBUWCUWQUWBNYTUWCUWQUWANYTUUSXDXBUUTUVAUV
      BUVCUVD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Path homotopy
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Htpy $.
  $c PHtpy $.
  $c ~=ph $.

  $( Extend class notation with the class of homotopies between two continuous
     functions. $)
  chtpy $a class Htpy $.

  $( Extend class notation with the class of path homotopies between two
     continuous functions. $)
  cphtpy $a class PHtpy $.

  $( Extend class notation with the path homotopy relation. $)
  cphtpc $a class ~=ph $.

  ${
    $d f g h k s x y $.
    $( Define the function which takes topological spaces ` X , Y ` and two
       continuous functions ` F , G : X --> Y ` and returns the class of
       homotopies from ` F ` to ` G ` .  (Contributed by Mario Carneiro,
       22-Feb-2015.) $)
    df-htpy $a |- Htpy = ( x e. Top , y e. Top |->
        ( f e. ( x Cn y ) , g e. ( x Cn y ) |->
            { h e. ( ( x tX II ) Cn y ) | A. s e. U. x
              ( ( s h 0 ) = ( f ` s ) /\ ( s h 1 ) = ( g ` s ) ) } ) ) $.

    $( Define the class of path homotopies between two paths
       ` F , G : II --> X ` ; these are homotopies (in the sense of ~ df-htpy )
       which also preserve both endpoints of the paths throughout the
       homotopy.  Definition of [Hatcher] p. 25.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    df-phtpy $a |- PHtpy = ( x e. Top |->
        ( f e. ( II Cn x ) , g e. ( II Cn x ) |->
            { h e. ( f ( II Htpy x ) g ) | A. s e. ( 0 [,] 1 )
              ( ( 0 h s ) = ( f ` 0 ) /\ ( 1 h s ) = ( f ` 1 ) ) } ) ) $.
  $}

  ${
    $d s A $.  $d f g h s t F $.  $d f g h s t G $.  $d h s x y H $.  $d t M $.
    $d f g h j k s t x y z J $.  $d f g h j k s t x y z ph $.
    $d f g h j k x y K $.  $d f g h j k s t x y z X $.
    ishtpy.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    ishtpy.3 $e |- ( ph -> F e. ( J Cn K ) ) $.
    ishtpy.4 $e |- ( ph -> G e. ( J Cn K ) ) $.
    $( Membership in the class of homotopies between two continuous functions.
       (Contributed by Mario Carneiro, 22-Feb-2015.)  (Revised by Mario
       Carneiro, 5-Sep-2015.) $)
    ishtpy $p |- ( ph -> ( H e. ( F ( J Htpy K ) G ) <->
                    ( H e. ( ( J tX II ) Cn K ) /\ A. s e. X
                    ( ( s H 0 ) = ( F ` s ) /\ ( s H 1 ) = ( G ` s ) ) ) ) ) $=
      ( vh vf vg co wcel wceq wa ccn cvv vj vk chtpy cv cc0 cfv c1 wral cii ctx
      crab ctop cuni cmpt2 df-htpy simprl simprr oveq12d oveq1d unieqd toponuni
      a1i ctopon syl adantr eqtr4d raleqdv rabeqbidv mpt2eq123dv cntop2 cxp cpw
      topontop wf ssrab2 ovex elpw2 mpbir rgen2w eqid fmpt2 mpbi xpex pwex fex2
      wss mp3an ovmpt2d fveq1 eqeq2d bi2anan9 adantl ralbidv rabbidv rabex oveq
      wb eleq2d eqeq1d anbi12d elrab syl6bb ) ADBCEFUCOZOZPDHUDZUELUDZOZXEBUFZQ
      ZXEUGXFOZXECUFZQZRZHGUHZLEUIUJOZFSOZUKZPDXPPXEUEDOZXHQZXEUGDOZXKQZRZHGUHZ
      RAXDXQDAMNBCEFSOZYDXGXEMUDZUFZQZXJXENUDZUFZQZRZHGUHZLXPUKZXQXCTAUAUBEFULU
      LMNUAUDZUBUDZSOZYPYKHYNUMZUHZLYNUIUJOZYOSOZUKZUNZMNYDYDYMUNZUCTUCUAUBULUL
      UUBUNQAUAUBMNLHUOVBAYNEQZYOFQZRZRZMNYPYPUUAYDYDYMUUGYNEYOFSAUUDUUEUPZAUUD
      UUEUQZURZUUJUUGYRYLLYTXPUUGYSXOYOFSUUGYNEUIUJUUHUSUUIURUUGYKHYQGUUGYQEUMZ
      GUUGYNEUUHUTAGUUKQZUUFAEGVCUFPZUULIGEVAVDVEVFVGVHVIAUUMEULPIGEVMVDABYDPFU
      LPJBEFVJVDUUCTPZAYDYDVKZXPVLZUUCVNZUUOTPUUPTPUUNYMUUPPZNYDUHMYDUHUUQUURMN
      YDYDUURYMXPWFYLLXPVOYMXPXOFSVPZVQVRVSMNYDYDYMUUPUUCUUCVTWAWBYDYDEFSVPZUUT
      WCXPUUSWDUUOUUPUUCTTWEWGVBWHAYEBQZYHCQZRZRZYLXNLXPUVDYKXMHGUVCYKXMWQAUVAY
      GXIUVBYJXLUVAYFXHXGXEYEBWIWJUVBYIXKXJXEYHCWIWJWKWLWMWNJKXQTPAXNLXPUUSWOVB
      WHWRXNYCLDXPXFDQZXMYBHGUVEXIXSXLYAUVEXGXRXHXEUEXFDWPWSUVEXJXTXKXEUGXFDWPW
      SWTWMXAXB $.

    $( A homotopy is a continuous function.  (Contributed by Mario Carneiro,
       22-Feb-2015.) $)
    htpycn $p |- ( ph -> ( F ( J Htpy K ) G ) C_ ( ( J tX II ) Cn K ) ) $=
      ( vh vs chtpy co cii ctx cv wcel cfv wceq wa ccn cc0 c1 wral ishtpy simpl
      syl6bi ssrdv ) AJBCDELMMZDNOMEUAMZAJPZUIQUKUJQZKPZUBUKMUMBRSUMUCUKMUMCRST
      KFUDZTULABCUKDEFKGHIUEULUNUFUGUH $.

    ${
      htpyi.1 $e |- ( ph -> H e. ( F ( J Htpy K ) G ) ) $.
      $( A homotopy evaluated at its endpoints.  (Contributed by Mario
         Carneiro, 22-Feb-2015.) $)
      htpyi $p |- ( ( ph /\ A e. X ) ->
        ( ( A H 0 ) = ( F ` A ) /\ ( A H 1 ) = ( G ` A ) ) ) $=
        ( vs cc0 co cfv wceq c1 wa wcel cv wral cii ctx ccn chtpy ishtpy simprd
        mpbid oveq1 fveq2 eqeq12d anbi12d rspccva sylan ) AMUAZNEOZUPCPZQZUPREO
        ZUPDPZQZSZMHUBZBHTBNEOZBCPZQZBREOZBDPZQZSZAEFUCUDOGUEOTZVDAECDFGUFOOTVL
        VDSLACDEFGHMIJKUGUIUHVCVKMBHUPBQZUSVGVBVJVMUQVEURVFUPBNEUJUPBCUKULVMUTV
        HVAVIUPBREUJUPBDUKULUMUNUO $.
    $}

    ${
      ishtpyd.1 $e |- ( ph -> H e. ( ( J tX II ) Cn K ) ) $.
      ishtpyd.2 $e |- ( ( ph /\ s e. X ) -> ( s H 0 ) = ( F ` s ) ) $.
      ishtpyd.3 $e |- ( ( ph /\ s e. X ) -> ( s H 1 ) = ( G ` s ) ) $.
      $( Deduction for membership in the class of homotopies.  (Contributed by
         Mario Carneiro, 22-Feb-2015.) $)
      ishtpyd $p |- ( ph -> H e. ( F ( J Htpy K ) G ) ) $=
        ( chtpy co wcel cfv wceq wa cii ctx ccn cv cc0 c1 wral ralrimiva ishtpy
        jca mpbir2and ) ADBCEFOPPQDEUAUBPFUCPQHUDZUEDPULBRSZULUFDPULCRSZTZHGUGL
        AUOHGAULGQTUMUNMNUJUHABCDEFGHIJKUIUK $.
    $}

    htpycom.6 $e |- M = ( x e. X , y e. ( 0 [,] 1 ) |->
                           ( x H ( 1 - y ) ) ) $.
    htpycom.7 $e |- ( ph -> H e. ( F ( J Htpy K ) G ) ) $.
    $( Given a homotopy from ` F ` to ` G ` , produce a homotopy from ` G ` to
       ` F ` .  (Contributed by Mario Carneiro, 23-Feb-2015.) $)
    htpycom $p |- ( ph -> M e. ( G ( J Htpy K ) F ) ) $=
      ( cc0 c1 co cmin cii vt vz cicc cmpt2 ctx ccn ctopon cfv wcel iitopon a1i
      cnmpt1st cnmpt2nd cmpt iirevcn oveq2 cnmpt21 chtpy htpycn sseldd cnmpt22f
      cv syl5eqel wa wceq simpr 0elunit oveq1 ax-1cn subid1i syl6eq oveq2d ovex
      ovmpt2 sylancl htpyi simprd eqtrd 1elunit 1m1e0 simpld ishtpyd ) AEDIGHJU
      AKMLAIBCJPQUCRZBVBZQCVBZSRZFRZUDGTUERHUFRZNABCWDWFFGTGTHJWCKTWCUGUHUIAUJU
      KZABCGTJWCKWIULABCUBWEQUBVBZSRZWFGTTTJWCWCKWIABCGTJWCKWIUMWIUBWCWKUNTTUFR
      UIAUBUOUKWJWEQSUPUQADEGHURRRWHFADEGHJKLMUSOUTVAVCAUAVBZJUIZVDZWLPIRZWLQFR
      ZWLEUHZWNWMPWCUIWOWPVEAWMVFZVGBCWLPJWCWGWPIWLWFFRZWDWLWFFVHZWEPVEZWFQWLFX
      AWFQPSRQWEPQSUPQVIVJVKVLNWLQFVMVNVOWNWLPFRZWLDUHZVEZWPWQVEZAWLDEFGHJKLMOV
      PZVQVRWNWLQIRZXBXCWNWMQWCUIXGXBVEWRVSBCWLQJWCWGXBIWSWTWEQVEZWFPWLFXHWFQQS
      RPWEQQSUPVTVKVLNWLPFVMVNVOWNXDXEXFWAVRWB $.
  $}

  ${
    $d s x y F $.  $d s x y J $.  $d x y K $.  $d s x y ph $.  $d s x y X $.
    $d s G $.
    htpyid.1 $e |- G = ( x e. X , y e. ( 0 [,] 1 ) |-> ( F ` x ) ) $.
    htpyid.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    htpyid.4 $e |- ( ph -> F e. ( J Cn K ) ) $.
    $( A homotopy from a function to itself.  (Contributed by Mario Carneiro,
       23-Feb-2015.) $)
    htpyid $p |- ( ph -> G e. ( F ( J Htpy K ) F ) ) $=
      ( vs cc0 c1 co cv cfv cii wcel wceq cicc cmpt2 ctx ccn ctopon iitopon a1i
      cnmpt1st cnmpt21f syl5eqel simpr 0elunit fveq2 eqidd fvex sylancl 1elunit
      wa ovmpt2 ishtpyd ) ADDEFGHLJKKAEBCHMNUAOZBPZDQZUBFRUCOGUDOIABCVBDFRFGHVA
      JRVAUEQSAUFUGZABCFRHVAJVDUHKUIUJALPZHSZURZVFMVASVEMEOVEDQZTAVFUKZULBCVEMH
      VAVCVHEVHVBVEDUMZCPZMTVHUNIVEDUOZUSUPVGVFNVASVENEOVHTVIUQBCVENHVAVCVHEVHV
      JVKNTVHUNIVLUSUPUT $.
  $}

  ${
    $d s F $.  $d s G $.  $d x y H $.  $d x y K $.  $d x y L $.  $d s x y ph $.
    $d s x y J $.  $d s N $.  $d s x y P $.  $d s x y X $.
    htpyco1.n $e |- N = ( x e. X , y e. ( 0 [,] 1 ) |-> ( ( P ` x ) H y ) ) $.
    htpyco1.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    htpyco1.p $e |- ( ph -> P e. ( J Cn K ) ) $.
    htpyco1.f $e |- ( ph -> F e. ( K Cn L ) ) $.
    htpyco1.g $e |- ( ph -> G e. ( K Cn L ) ) $.
    htpyco1.h $e |- ( ph -> H e. ( F ( K Htpy L ) G ) ) $.
    $( Compose a homotopy with a continuous map.  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    htpyco1 $p |- ( ph -> N e. ( ( F o. P ) ( J Htpy L ) ( G o. P ) ) ) $=
      ( co wcel vs ccom ccn cnco syl2anc cc0 c1 cv cfv cmpt2 cii ctopon iitopon
      cicc ctx a1i cnmpt1st cnmpt21f cnmpt2nd chtpy cuni ctop syl eqid toptopon
      cntop2 sylib htpycn sseldd cnmpt22f syl5eqel wa wceq wf syl3anc ffvelrnda
      cnf2 htpyi syldan simpld simpr 0elunit fveq2 id oveqan12d ovmpt2a sylancl
      ovex fvco3 sylan 3eqtr4d simprd 1elunit ishtpyd ) AEDUBZFDUBZKHJLUANADHIU
      CSTZEIJUCSZTWOHJUCSZTOPDEHIJUDUEAWQFWRTWPWSTOQDFHIJUDUEAKBCLUFUGUNSZBUHZD
      UIZCUHZGSZUJHUKUOSJUCSMABCXBXCGHUKIUKJLWTNUKWTULUITAUMUPZABCXADHUKHILWTNX
      EABCHUKLWTNXEUQOURABCHUKLWTNXEUSAEFIJUTSSIUKUOSJUCSGAEFIJIVAZAIVBTZIXFULU
      ITZAWQXGODHIVFVCIXFXFVDVEVGZPQVHRVIVJVKAUAUHZLTZVLZXJDUIZUFGSZXMEUIZXJUFK
      SZXJWOUIZXLXNXOVMZXMUGGSZXMFUIZVMZAXKXMXFTXRYAVLALXFXJDAHLULUITXHWQLXFDVN
      ZNXIODHILXFVQVOZVPAXMEFGIJXFXIPQRVRVSZVTXLXKUFWTTXPXNVMAXKWAZWBBCXJUFLWTX
      DXNKXAXJVMZXCUFVMZXBXMXCUFGXAXJDWCZYGWDWEMXMUFGWHWFWGAYBXKXQXOVMYCLXFXJED
      WIWJWKXLXSXTXJUGKSZXJWPUIZXLXRYAYDWLXLXKUGWTTYIXSVMYEWMBCXJUGLWTXDXSKYFXC
      UGVMZXBXMXCUGGYHYKWDWEMXMUGGWHWFWGAYBXKYJXTVMYCLXFXJFDWIWJWKWN $.
  $}

  ${
    $d s F $.  $d s G $.  $d s H $.  $d s J $.  $d s P $.  $d s ph $.
    htpyco2.f $e |- ( ph -> F e. ( J Cn K ) ) $.
    htpyco2.g $e |- ( ph -> G e. ( J Cn K ) ) $.
    htpyco2.p $e |- ( ph -> P e. ( K Cn L ) ) $.
    htpyco2.h $e |- ( ph -> H e. ( F ( J Htpy K ) G ) ) $.
    $( Compose a homotopy with a continuous map.  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    htpyco2 $p |- ( ph ->
      ( P o. H ) e. ( ( P o. F ) ( J Htpy L ) ( P o. G ) ) ) $=
      ( wcel ctopon cfv ccn co cc0 wceq c1 ccom cuni ctop cntop1 syl eqid sylib
      vs toptopon syl2anc cii ctx chtpy htpycn sseldd cv wa htpyi simpld fveq2d
      cnco cop cicc cxp simpr 0elunit opelxpi sylancl wf iitopon txtopon cntop2
      cnf2 syl3anc fvco3 sylan syldan fveq2i 3eqtr4g cnf 3eqtr4d simprd 1elunit
      df-ov ishtpyd ) ABCUAZBDUAZBEUAZFHFUBZUHAFUCMZFWINOMZACFGPQZMZWJICFGUDUEF
      WIWIUFZUIUGZAWMBGHPQMZWFFHPQZMIKCBFGHVAUJADWLMZWPWGWQMJKDBFGHVAUJAEFUKULQ
      ZGPQZMZWPWHWSHPQMACDFGUMQQWTEACDFGWIWOIJUNLUOZKEBWSGHVAUJAUHUPZWIMZUQZXCR
      EQZBOZXCCOZBOZXCRWHQZXCWFOZXEXFXHBXEXFXHSZXCTEQZXCDOZSZAXCCDEFGWIWOIJLURZ
      USUTXEXCRVBZWHOZXQEOZBOZXJXGAXDXQWIRTVCQZVDZMZXRXTSZXEXDRYAMYCAXDVEZVFXCR
      WIYAVGVHAYBGUBZEVIZYCYDAWSYBNOMZGYFNOMZXAYGAWKUKYANOMYHWOVJFUKWIYAVKVHAGU
      CMZYIAWMYJICFGVLUEGYFYFUFZUIUGXBEWSGYBYFVMVNZYBYFXQBEVOVPVQXCRWHWDXFXSBXC
      REWDVRVSAWIYFCVIZXDXKXISAWMYMICFGWIYFWNYKVTUEWIYFXCBCVOVPWAXEXMBOZXNBOZXC
      TWHQZXCWGOZXEXMXNBXEXLXOXPWBUTXEXCTVBZWHOZYREOZBOZYPYNAXDYRYBMZYSUUASZXEX
      DTYAMUUBYEWCXCTWIYAVGVHAYGUUBUUCYLYBYFYRBEVOVPVQXCTWHWDXMYTBXCTEWDVRVSAWI
      YFDVIZXDYQYOSAWRUUDJDFGWIYFWNYKVTUEWIYFXCBDVOVPWAWE $.
  $}

  ${
    $d s x y z J $.  $d x y K $.  $d s x y L $.  $d s x y M $.  $d s x y z X $.
    $d s F $.  $d s H $.  $d s N $.  $d s x y z ph $.
    htpycc.1 $e |- N = ( x e. X , y e. ( 0 [,] 1 ) |->
   if ( y <_ ( 1 / 2 ) , ( x L ( 2 x. y ) ) , ( x M ( ( 2 x. y ) - 1 ) ) ) ) $.
    htpycc.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    htpycc.4 $e |- ( ph -> F e. ( J Cn K ) ) $.
    htpycc.5 $e |- ( ph -> G e. ( J Cn K ) ) $.
    htpycc.6 $e |- ( ph -> H e. ( J Cn K ) ) $.
    htpycc.7 $e |- ( ph -> L e. ( F ( J Htpy K ) G ) ) $.
    htpycc.8 $e |- ( ph -> M e. ( G ( J Htpy K ) H ) ) $.
    $( Concatenate two homotopies.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Revised by Mario Carneiro, 23-Feb-2015.) $)
    htpycc $p |- ( ph -> N e. ( F ( J Htpy K ) H ) ) $=
      ( c1 vs vz cc0 cicc co cv c2 cdiv cle wbr cmul cmin cif cmpt2 cii ctx ccn
      ctopon cfv wcel iitopon a1i cioo crn ctg crest dfii2 cr 0re 1re rehalfcli
      eqid halfgt0 ltleii halflt1 elicc2i mpbir3an wceq wa simprd simpld eqtr4d
      htpyi ralrimiva weq oveq1 eqeq12d rspccva sylan adantrl simprl oveq2d 2cn
      wral 2ne0 recidi syl6eq 1m1e0 3eqtr4d wss retopon iccssre mp2an resttopon
      oveq1d cnmpt2nd cnmpt1st cmpt iihalf1cn oveq2 cnmpt21 chtpy htpycn sseldd
      cnmpt22f iihalf2cn cnmpt2pc cnmptcom syl5eqel 0elunit syl6eqbr iftrue syl
      simpr simpl mul01i oveq12d eqtrd ovex ovmpt2a sylancl 1elunit wn clt mpbi
      ltnlei breq1d mtbiri iffalse mulid1i 2m1e1 ishtpyd ) ADFKGHLUANOQAKBCLUCT
      UDUEZCUFZTUGUHUEZUIUJZBUFZUGUUDUKUEZIUEZUUGUUHTULUEZJUEZUMZUNGUOUPUEHUQUE
      ZMACBUULUOGHUUCLUOUUCURUSUTAVAVBNACBUCUUETUUIVCVDVEUSZUUKGHUUNUCUUEUDUEZV
      FUEZUUNUUETUDUEZVFUEZUOLUUNVLUUPVLZUURVLZVGUCVHUTZAVIVBTVHUTZAVJVBUUEUUCU
      TZAUVCUUEVHUTZUCUUEUIUJUUETUIUJTVJVKZUCUUEVIUVEVMVNZUUETUVEVJVOVNUCTUUEVI
      VJVPVQVBNAUUDUUEVRZUUGLUTZVSVSZUUGTIUEZUUGUCJUEZUUIUUKAUVHUVJUVKVRZUVGAUA
      UFZTIUEZUVMUCJUEZVRZUALWNUVHUVLAUVPUALAUVMLUTZVSZUVNUVMEUSZUVOUVRUVMUCIUE
      ZUVMDUSZVRZUVNUVSVRZAUVMDEIGHLNOPRWCZVTUVRUVOUVSVRZUVMTJUEZUVMFUSZVRZAUVM
      EFJGHLNPQSWCZWAWBWDUVPUVLUAUUGLUABWEUVNUVJUVOUVKUVMUUGTIWFUVMUUGUCJWFWGWH
      WIWJUVIUUHTUUGIUVIUUHUGUUEUKUETUVIUUDUUEUGUKAUVGUVHWKWLUGWMWOWPWQZWLUVIUU
      JUCUUGJUVIUUJTTULUEUCUVIUUHTTULUWJXEWRWQWLWSACBUUGUUHIUUPGGUOHUUOLUUPUUOU
      RUSUTZAUUNVHURUSUTZUUOVHWTZUWKXAUVAUVDUWMVIUVEUCUUEXBXCUUOUUNVHXDXCVBZNAC
      BUUPGUUOLUWNNXFACBUBUUDUGUBUFZUKUEZUUHUUPGUUPUOUUOLUUOUWNNACBUUPGUUOLUWNN
      XGUWNUBUUOUWPXHUUPUOUQUEUTAUBUUPUUSXIVBUWOUUDUGUKXJZXKADEGHXLUEZUEUUMIADE
      GHLNOPXMRXNXOACBUUGUUJJUURGGUOHUUQLUURUUQURUSUTZAUWLUUQVHWTZUWSXAUVDUVBUW
      TUVEVJUUETXBXCUUQUUNVHXDXCVBZNACBUURGUUQLUXANXFACBUBUUDUWPTULUEZUUJUURGUU
      RUOUUQLUUQUXANACBUURGUUQLUXANXGUXAUBUUQUXBXHUURUOUQUEUTAUBUURUUTXPVBUBCWE
      UWPUUHTULUWQXEXKAEFUWRUEUUMJAEFGHLNPQXMSXNXOXQXRXSUVRUVMUCKUEZUVTUWAUVRUV
      QUCUUCUTUXCUVTVRAUVQYDZXTBCUVMUCLUUCUULUVTKBUAWEZUUDUCVRZVSZUULUUIUVTUXGU
      UFUULUUIVRUXGUUDUCUUEUIUXEUXFYDZUVFYAUUFUUIUUKYBYCUXGUUGUVMUUHUCIUXEUXFYE
      UXGUUHUGUCUKUEUCUXGUUDUCUGUKUXHWLUGWMYFWQYGYHMUVMUCIYIYJYKUVRUWBUWCUWDWAY
      HUVRUVMTKUEZUWFUWGUVRUVQTUUCUTUXIUWFVRUXDYLBCUVMTLUUCUULUWFKUXEUUDTVRZVSZ
      UULUUKUWFUXKUUFYMUULUUKVRUXKUUFTUUEUIUJZUUETYNUJUXLYMVOUUETUVEVJYPYOUXKUU
      DTUUEUIUXEUXJYDZYQYRUUFUUIUUKYSYCUXKUUGUVMUUJTJUXEUXJYEUXKUUJUGTULUETUXKU
      UHUGTULUXKUUHUGTUKUEUGUXKUUDTUGUKUXMWLUGWMYTWQXEUUAWQYGYHMUVMTJYIYJYKUVRU
      WEUWHUWIVTYHUUB $.
  $}

  ${
    $d s A $.  $d f g h s t F $.  $d f g h s t G $.  $d h s x y H $.  $d t K $.
    $d f g h j s t x y J $.  $d f g h s t x y ph $.
    isphtpy.2 $e |- ( ph -> F e. ( II Cn J ) ) $.
    isphtpy.3 $e |- ( ph -> G e. ( II Cn J ) ) $.
    $( Membership in the class of path homotopies between two continuous
       functions.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 23-Feb-2015.) $)
    isphtpy $p |- ( ph -> ( H e. ( F ( PHtpy ` J ) G ) <->
                    ( H e. ( F ( II Htpy J ) G ) /\ A. s e. ( 0 [,] 1 )
                    ( ( 0 H s ) = ( F ` 0 ) /\ ( 1 H s ) = ( F ` 1 ) ) ) ) ) $=
      ( vh vf vg cfv co wcel cc0 cv wceq c1 wa cii vj cphtpy cicc wral crab ccn
      chtpy cvv ctop cmpt2 cntop2 oveq2 oveqd rabeq mpt2eq123dv df-phtpy mpt2ex
      syl ovex fvmpt 3syl oveq12 fveq1d eqeq2d anbi12d ralbidv rabeqbidv adantl
      simpl rabex a1i ovmpt2d eleq2d oveq eqeq1d elrab syl6bb ) ADBCEUBLZMZNDOF
      PZIPZMZOBLZQZRVTWAMZRBLZQZSZFORUCMZUDZIBCTEUGMZMZUEZNDWLNOVTDMZWCQZRVTDMZ
      WFQZSZFWIUDZSAVSWMDAJKBCTEUFMZWTWBOJPZLZQZWERXALZQZSZFWIUDZIXAKPZWKMZUEZW
      MVRUHABWTNEUINVRJKWTWTXJUJZQGBTEUKUAEJKTUAPZUFMZXMXGIXAXHTXLUGMZMZUEZUJXK
      UIUBXLEQZJKXMXMXPWTWTXJXLETUFULZXRXQXOXIQXPXJQXQXNWKXAXHXLETUGULUMXGIXOXI
      UNURUOUAJKIFUPJKWTWTXJTEUFUSZXSUQUTVAXABQZXHCQZSZXJWMQAYBXGWJIXIWLXABXHCW
      KVBYBXFWHFWIYBXCWDXEWGYBXBWCWBYBOXABXTYAVIZVCVDYBXDWFWEYBRXABYCVCVDVEVFVG
      VHGHWMUHNAWJIWLBCWKUSVJVKVLVMWJWSIDWLWADQZWHWRFWIYDWDWOWGWQYDWBWNWCOVTWAD
      VNVOYDWEWPWFRVTWADVNVOVEVFVPVQ $.

    $( A path homotopy is a homotopy.  (Contributed by Mario Carneiro,
       2-Sep-2009.)  (Revised by Mario Carneiro, 23-Feb-2015.) $)
    phtpyhtpy $p |- ( ph -> ( F ( PHtpy ` J ) G ) C_ ( F ( II Htpy J ) G ) ) $=
      ( vh vs cphtpy cfv co cii chtpy cv wcel cc0 wceq c1 wa cicc isphtpy simpl
      wral syl6bi ssrdv ) AGBCDIJKZBCLDMKKZAGNZUFOUHUGOZPHNZUHKPBJQRUJUHKRBJQSH
      PRTKUCZSUIABCUHDHEFUAUIUKUBUDUE $.

    $( A path homotopy is a continuous function.  (Contributed by Mario
       Carneiro, 23-Feb-2015.) $)
    phtpycn $p |- ( ph -> ( F ( PHtpy ` J ) G ) C_ ( ( II tX II ) Cn J ) ) $=
      ( cphtpy cfv co cii chtpy ctx ccn phtpyhtpy cc0 cicc ctopon wcel iitopon
      c1 a1i htpycn sstrd ) ABCDGHIBCJDKIIJJLIDMIABCDEFNABCJDOTPIZJUDQHRASUAEFU
      BUC $.

    ${
      phtpyi.1 $e |- ( ph -> H e. ( F ( PHtpy ` J ) G ) ) $.
      $( Membership in the class of path homotopies between two continuous
         functions.  (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      phtpyi $p |- ( ( ph /\ A e. ( 0 [,] 1 ) ) ->
        ( ( 0 H A ) = ( F ` 0 ) /\ ( 1 H A ) = ( F ` 1 ) ) ) $=
        ( vs cc0 cv co cfv wceq c1 wa wcel oveq2 eqeq1d cicc wral chtpy isphtpy
        cii cphtpy mpbid simprd anbi12d rspccva sylan ) AKJLZEMZKCNZOZPULEMZPCN
        ZOZQZJKPUAMZUBZBUTRKBEMZUNOZPBEMZUQOZQZAECDUEFUCMMRZVAAECDFUFNMRVGVAQIA
        CDEFJGHUDUGUHUSVFJBUTULBOZUOVCURVEVHUMVBUNULBKESTVHUPVDUQULBPESTUIUJUK
        $.

      $d J f g $.  $d F f g $.  $d G f g $.
      $( Two path-homotopic paths have the same start and end point.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      phtpy01 $p |- ( ph ->
        ( ( F ` 0 ) = ( G ` 0 ) /\ ( F ` 1 ) = ( G ` 1 ) ) ) $=
        ( cc0 cfv wceq c1 co wcel wa 1elunit mpan2 cii htpyi simprd cicc phtpyi
        simpld 0elunit ctopon iitopon a1i cphtpy chtpy phtpyhtpy sseldd eqtr3d
        jca ) AIBJZICJZKLBJZLCJZKAILDMZUNUOAURUNKZLLDMZUPKZALILUAMZNZUSVAOPALBC
        DEFGHUBQZUCAIIDMUNKZURUOKZAIVBNVEVFOUDAIBCDREVBRVBUEJNAUFUGZFGABCEUHJMB
        CREUIMMDABCEFGUJHUKZSQTULAUTUPUQAUSVAVDTALIDMUPKZUTUQKZAVCVIVJOPALBCDRE
        VBVGFGVHSQTULUM $.
    $}

    ${
      isphtpyd.1 $e |- ( ph -> H e. ( F ( II Htpy J ) G ) ) $.
      isphtpyd.2 $e |- ( ( ph /\ s e. ( 0 [,] 1 ) ) ->
        ( 0 H s ) = ( F ` 0 ) ) $.
      isphtpyd.3 $e |- ( ( ph /\ s e. ( 0 [,] 1 ) ) ->
        ( 1 H s ) = ( F ` 1 ) ) $.
      $( Deduction for membership in the class of path homotopies.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      isphtpyd $p |- ( ph -> H e. ( F ( PHtpy ` J ) G ) ) $=
        ( cphtpy cfv co wcel cii cc0 wceq c1 wa chtpy cv cicc ralrimiva isphtpy
        wral jca mpbir2and ) ADBCELMNODBCPEUANNOQFUBZDNQBMRZSUIDNSBMRZTZFQSUCNZ
        UFIAULFUMAUIUMOTUJUKJKUGUDABCDEFGHUEUH $.
    $}

    ${
      isphtpy2d.1 $e |- ( ph -> H e. ( ( II tX II ) Cn J ) ) $.
      isphtpy2d.2 $e |- ( ( ph /\ s e. ( 0 [,] 1 ) ) ->
        ( s H 0 ) = ( F ` s ) ) $.
      isphtpy2d.3 $e |- ( ( ph /\ s e. ( 0 [,] 1 ) ) ->
        ( s H 1 ) = ( G ` s ) ) $.
      isphtpy2d.4 $e |- ( ( ph /\ s e. ( 0 [,] 1 ) ) ->
        ( 0 H s ) = ( F ` 0 ) ) $.
      isphtpy2d.5 $e |- ( ( ph /\ s e. ( 0 [,] 1 ) ) ->
        ( 1 H s ) = ( F ` 1 ) ) $.
      $( Deduction for membership in the class of path homotopies.
         (Contributed by Mario Carneiro, 23-Feb-2015.) $)
      isphtpy2d $p |- ( ph -> H e. ( F ( PHtpy ` J ) G ) ) $=
        ( cii cc0 c1 cicc co ctopon cfv wcel iitopon a1i ishtpyd isphtpyd ) ABC
        DEFGHABCDNEOPQRZFNUFSTUAAUBUCGHIJKUDLMUE $.
    $}

    phtpycom.6 $e |- K = ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |->
                           ( x H ( 1 - y ) ) ) $.
    phtpycom.7 $e |- ( ph -> H e. ( F ( PHtpy ` J ) G ) ) $.
    $( Given a homotopy from ` F ` to ` G ` , produce a homotopy from ` G ` to
       ` F ` .  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 23-Feb-2015.) $)
    phtpycom $p |- ( ph -> K e. ( G ( PHtpy ` J ) F ) ) $=
      ( cii cc0 c1 co cfv wcel cv wceq cicc ctopon iitopon a1i cphtpy phtpyhtpy
      vt chtpy sseldd htpycom cmin 0elunit simpr oveq1 oveq2 oveq2d ovex ovmpt2
      sylancr iirev phtpyi sylan2 simpld phtpy01 adantr 3eqtrd 1elunit isphtpyd
      wa simprd ) AEDHGUGJIABCDEFMGHNOUAPZMVKUBQRAUCUDIJKADEGUEQPDEMGUHPPFADEGI
      JUFLUIUJAUGSZVKRZVIZNVLHPZNOVLUKPZFPZNDQZNEQZVNNVKRVMVOVQTULAVMUMZBCNVLVK
      VKBSZOCSZUKPZFPZVQHNWCFPWANWCFUNWBVLTZWCVPNFWBVLOUKUOZUPKNVPFUQURUSVNVQVR
      TZOVPFPZODQZTZVMAVPVKRWGWJVIVLUTAVPDEFGIJLVAVBZVCVNVRVSTZWIOEQZTZAWLWNVIV
      MADEFGIJLVDVEZVCVFVNOVLHPZWHWIWMVNOVKRVMWPWHTVGVTBCOVLVKVKWDWHHOWCFPWAOWC
      FUNWEWCVPOFWFUPKOVPFUQURUSVNWGWJWKVJVNWLWNWOVJVFVH $.
  $}

  ${
    $d s x y F $.  $d s G $.  $d s x y J $.  $d s x y ph $.
    phtpyid.1 $e |- G = ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |->
                          ( F ` x ) ) $.
    phtpyid.3 $e |- ( ph -> F e. ( II Cn J ) ) $.
    $( A homotopy from a path to itself.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 23-Feb-2015.) $)
    phtpyid $p |- ( ph -> G e. ( F ( PHtpy ` J ) F ) ) $=
      ( vs cii cc0 c1 co cfv wcel cv wceq fveq2 eqidd fvex cicc iitopon 0elunit
      ctopon a1i htpyid ovmpt2 mpan adantl 1elunit isphtpyd ) ADDEFIHHABCDEJFKL
      UAMZGJULUDNOAUBUEHUFIPZULOZKUMEMKDNZQZAKULOUNUPUCBCKUMULULBPZDNZUOEUOUQKD
      RCPUMQZUOSGKDTUGUHUIUNLUMEMLDNZQZALULOUNVAUJBCLUMULULURUTEUTUQLDRUSUTSGLD
      TUGUHUIUK $.
  $}

  ${
    $d s F $.  $d s G $.  $d s H $.  $d s K $.  $d s P $.  $d s ph $.
    phtpyco2.f $e |- ( ph -> F e. ( II Cn J ) ) $.
    phtpyco2.g $e |- ( ph -> G e. ( II Cn J ) ) $.
    phtpyco2.p $e |- ( ph -> P e. ( J Cn K ) ) $.
    phtpyco2.h $e |- ( ph -> H e. ( F ( PHtpy ` J ) G ) ) $.
    $( Compose a path homotopy with a continuous map.  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    phtpyco2 $p |- ( ph ->
      ( P o. H ) e. ( ( P o. F ) ( PHtpy ` K ) ( P o. G ) ) ) $=
      ( cii ccn co wcel cfv cc0 c1 wceq fvco3 vs ccom cnco syl2anc cphtpy chtpy
      phtpyhtpy sseldd htpyco2 cv wa phtpyi simpld fveq2d cop cxp 0elunit simpr
      cicc opelxpi sylancr cuni wf ctx ctopon iitopon txtopon mp2an ctop cntop2
      a1i eqid toptopon sylib phtpycn syl3anc sylan syldan df-ov fveq2i 3eqtr4g
      syl cnf2 iiuni cnf adantr sylancl 3eqtr4d simprd 1elunit isphtpyd ) ABCUB
      ZBDUBZBEUBZGUAACLFMNZOZBFGMNOZWLLGMNZOHJCBLFGUCUDADWOOWQWMWROIJDBLFGUCUDA
      BCDELFGHIJACDFUEPNZCDLFUFNNEACDFHIUGKUHUIAUAUJZQRUSNZOZUKZQWTENZBPZQCPZBP
      ZQWTWNNZQWLPZXCXDXFBXCXDXFSZRWTENZRCPZSZAWTCDEFHIKULZUMUNXCQWTUOZWNPZXOEP
      ZBPZXHXEAXBXOXAXAUPZOZXPXRSZXCQXAOZXBXTUQAXBURZQWTXAXAUTVAAXSFVBZEVCZXTYA
      ALLVDNZXSVEPOZFYDVEPOZEYFFMNZOYEYGALXAVEPOZYJYGVFVFLLXAXAVGVHVKAFVIOZYHAW
      PYKHCLFVJWBFYDYDVLZVMVNAWSYIEACDFHIVOKUHEYFFXSYDWCVPZXSYDXOBETVQVRQWTWNVS
      XDXQBQWTEVSVTWAXCXAYDCVCZYBXIXGSAYNXBAWPYNHCLFXAYDWDYLWEWBWFZUQXAYDQBCTWG
      WHXCXKBPZXLBPZRWTWNNZRWLPZXCXKXLBXCXJXMXNWIUNXCRWTUOZWNPZYTEPZBPZYRYPAXBY
      TXSOZUUAUUCSZXCRXAOZXBUUDWJYCRWTXAXAUTVAAYEUUDUUEYMXSYDYTBETVQVRRWTWNVSXK
      UUBBRWTEVSVTWAXCYNUUFYSYQSYOWJXAYDRBCTWGWHWK $.
  $}

  ${
    $d s F $.  $d s H $.  $d s x y J $.  $d x y K $.  $d s M $.  $d s x y ph $.
    $d x y L $.
    phtpycc.1 $e |- M = ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |->
                          if ( y <_ ( 1 / 2 ) ,
                    ( x K ( 2 x. y ) ) , ( x L ( ( 2 x. y ) - 1 ) ) ) ) $.
    phtpycc.3 $e |- ( ph -> F e. ( II Cn J ) ) $.
    phtpycc.4 $e |- ( ph -> G e. ( II Cn J ) ) $.
    phtpycc.5 $e |- ( ph -> H e. ( II Cn J ) ) $.
    phtpycc.6 $e |- ( ph -> K e. ( F ( PHtpy ` J ) G ) ) $.
    phtpycc.7 $e |- ( ph -> L e. ( G ( PHtpy ` J ) H ) ) $.
    $( Concatenate two path homotopies.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 7-Jun-2014.) $)
    phtpycc $p |- ( ph -> M e. ( F ( PHtpy ` J ) H ) ) $=
      ( cc0 c1 co wceq vs cii cicc ctopon cfv wcel iitopon a1i cphtpy phtpyhtpy
      chtpy sseldd htpycc cv wa cdiv cle wbr cmul cmin cif 0elunit simpr breq1d
      c2 simpl oveq2d oveq12d oveq1d ifbieq12d ovex ifex ovmpt2a sylancr simpll
      eqeq1 elii1 iihalf1 sylbir adantll phtpyi syl2anc simpld wn elii2 iihalf2
      syl phtpy01 ad2antrr eqtr4d ifbothda eqtrd 1elunit simprd isphtpyd ) ADFJ
      GUALNABCDEFUBGHIJQRUCSZKUBWPUDUEUFAUGUHLMNADEGUIUEZSDEUBGUKSZSHADEGLMUJOU
      LAEFWQSEFWRSIAEFGMNUJPULUMAUAUNZWPUFZUOZQWSJSZWSRVEUPSZUQURZQVEWSUSSZHSZQ
      XERUTSZISZVAZQDUEZXAQWPUFWTXBXITVBAWTVCZBCQWSWPWPCUNZXCUQURZBUNZVEXLUSSZH
      SZXNXORUTSZISZVAZXIJXNQTZXLWSTZUOZXMXDXPXRXFXHYBXLWSXCUQXTYAVCZVDYBXNQXOX
      EHXTYAVFZYBXLWSVEUSYCVGZVHYBXNQXQXGIYDYBXOXERUTYEVIVHVJKXDXFXHQXEHVKQXGIV
      KVLVMVNXDXFXJTZXHXJTXIXJTXAXFXHXFXIXJVPXHXIXJVPXAXDUOZYFRXEHSZRDUEZTZYGAX
      EWPUFZYFYJUOAWTXDVOWTXDYKAWTXDUOWSQXCUCSUFYKWSVQWSVRVSVTAXEDEHGLMOWAWBZWC
      XAXDWDZUOZXHQEUEZXJYNXHYOTZRXGISZREUEZTZYNAXGWPUFZYPYSUOAWTYMVOWTYMYTAWTY
      MUOWSXCRUCSUFYTWSWEWSWFWGVTAXGEFIGMNPWAWBZWCYNXJYOTZYIYRTZAUUBUUCUOWTYMAD
      EHGLMOWHWIZWCWJWKWLXARWSJSZXDYHYQVAZYIXARWPUFWTUUEUUFTWMXKBCRWSWPWPXSUUFJ
      XNRTZYAUOZXMXDXPXRYHYQUUHXLWSXCUQUUGYAVCZVDUUHXNRXOXEHUUGYAVFZUUHXLWSVEUS
      UUIVGZVHUUHXNRXQXGIUUJUUHXOXERUTUUKVIVHVJKXDYHYQRXEHVKRXGIVKVLVMVNXDYJYQY
      ITUUFYITXAYHYQYHUUFYIVPYQUUFYIVPYGYFYJYLWNYNYQYRYIYNYPYSUUAWNYNUUBUUCUUDW
      NWJWKWLWO $.
  $}

  ${
    $d x f g J $.
    $( Define the function which takes a topology and returns the path homotopy
       relation on that topology.  Definition of [Hatcher] p. 25.  (Contributed
       by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       7-Jun-2014.) $)
    df-phtpc $a |- ~=ph = ( x e. Top |-> { <. f , g >. |
        ( { f , g } C_ ( II Cn x ) /\ ( f ( PHtpy ` x ) g ) =/= (/) ) } ) $.

    $( The path homotopy relation is a relation.  (Contributed by Mario
       Carneiro, 7-Jun-2014.)  (Revised by Mario Carneiro, 7-Aug-2014.) $)
    phtpcrel $p |- Rel ( ~=ph ` J ) $=
      ( vf vg vx cv cpr cii ccn co wss cphtpy cfv c0 wne ctop cphtpc relmptopab
      wa df-phtpc ) BEZCEZFGDEZHIJTUAUBKLIMNRDBCOAPDBCSQ $.
  $}

  ${
    $d f g F $.  $d f g G $.  $d f g j J $.
    $( The relation "is path homotopic to".  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 5-Sep-2015.) $)
    isphtpc $p |- ( F ( ~=ph ` J ) G <->
      ( F e. ( II Cn J ) /\ G e. ( II Cn J ) /\
        ( F ( PHtpy ` J ) G ) =/= (/) ) ) $=
      ( vj vf vg cphtpc cfv wbr ctop wcel cii ccn co cphtpy c0 wne cv wa wceq
      w3a cop df-br cdm cpr copab df-phtpc dmmptss elfvdm sseldi sylbi 3ad2ant1
      wss cntop2 oveq2 sseq2d vex prss syl6bbr fveq2 oveqd anbi12d opabbidv cxp
      neeq1d ovex xpex opabssxp ssexi fvmpt oveq12 brab2ga df-3an bitr4i syl6bb
      breqd eqid pm5.21nii ) ABCGHZIZCJKZALCMNZKZBWBKZABCOHZNZPQZUAZVTABUBZVSKZ
      WAABVSUCWJGUDJCDJERZFRZUEZLDRZMNZUMZWKWLWNOHZNZPQZSZEFUFZGDEFUGZUHWICGUIU
      JUKWCWDWAWGALCUNULWAVTABWKWBKWLWBKSZWKWLWENZPQZSZEFUFZIZWHWAVSXGABDCXAXGJ
      GWNCTZWTXFEFXIWPXCWSXEXIWPWMWBUMXCXIWOWBWMWNCLMUOUPWKWLWBEUQFUQURUSXIWRXD
      PXIWQWEWKWLWNCOUTVAVEVBVCXBXGWBWBVDWBWBLCMVFZXJVGXEEFWBWBVHVIVJVPXHWCWDSW
      GSWHXEWGEFABWBWBXGWKATWLBTSXDWFPWKAWLBWEVKVEXGVQVLWCWDWGVMVNVOVR $.
  $}

  ${
    $d f g u v x y z J $.
    $( Path homotopy is an equivalence relation.  Proposition 1.2 of [Hatcher]
       p. 26.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
       Carneiro, 6-Jul-2015.) $)
    phtpcer $p |- ( ~=ph ` J ) Er ( II Cn J ) $=
      ( vy vz vf vu vv vg co wtru cv wbr wcel c0 wne isphtpc sylib wa c1 adantr
      wex vx cii ccn cphtpc cfv wer phtpcrel a1i cphtpy simp2bi simp1bi simp3bi
      wrel n0 cc0 cicc cmin cmpt2 eqid simpr phtpycom ne0i syl syl3anbrc adantl
      exlimddv w3a simp2d simp3d eeanv sylanbrc cdiv cle cmul cif simp1d simprl
      c2 simprr phtpycc ex exlimdvv wb id phtpyid ancli pm4.71ri df-3an 3ancomb
      mpd 3bitr2i bitr4i iserd trud ) UBAUCHZAUDUEZUFIUABCWOWPWPUMIAUGUHUAJZBJZ
      WPKZWRWQWPKZIWSWRWOLZWQWOLZWRWQAUIUEZHZMNZWTWSXBXAWQWRXCHZMNZWQWRAOZUJZWS
      XBXAXGXHUKZWSDJZXFLZXEDWSXGXLDTZWSXBXAXGXHULZDXFUNZPWSXLQZEFUORUPHZXQEJZR
      FJZUQHXKHURZXDLXEXPEFWQWRXKAXTWSXBXLXJSWSXAXLXISXTUSWSXLUTVAXDXTVBVCVFWRW
      QAOVDVEWSWRCJZWPKZQZWQYAWPKZIYCXBYAWOLZWQYAXCHZMNZYDWSXBYBXJSZYCXAYEWRYAX
      CHZMNZYCYBXAYEYJVGWSYBUTWRYAAOPZVHZYCXLGJZYILZQZGTDTZYGYCXMYNGTZYPYCXGXMW
      SXGYBXNSXOPYCYJYQYCXAYEYJYKVIGYIUNPXLYNDGVJVKYCYOYGDGYCYOYGYCYOQZEFXQXQXS
      RVRVLHVMKXRVRXSVNHZXKHXRYSRUQHYMHVOURZYFLYGYREFWQWRYAAXKYMYTYTUSYCXBYOYHS
      YCXAYOYCXAYEYJYKVPSYCYEYOYLSYCXLYNVQYCXLYNVSVTYFYTVBVCWAWBWJWQYAAOVDVEXBW
      QWQWPKZWCIXBXBXBWQWQXCHZMNZVGZUUAXBXBUUCQZXBQXBUUCXBVGUUDXBUUEXBUUCXBBCXQ
      XQWRWQUEURZUUBLUUCXBBCWQUUFAUUFUSXBWDWEUUBUUFVBVCWFWGXBUUCXBWHXBUUCXBWIWK
      WQWQAOWLUHWMWN $.
  $}

  ${
    $d h F $.  $d h G $.  $d h J $.  $d h V $.
    $( Path homotopic paths have the same endpoints.  (Contributed by Mario
       Carneiro, 24-Feb-2015.) $)
    phtpc01 $p |- ( F ( ~=ph ` J ) G ->
      ( ( F ` 0 ) = ( G ` 0 ) /\ ( F ` 1 ) = ( G ` 1 ) ) ) $=
      ( vh cphtpc cfv wbr cii ccn co wcel cphtpy c0 wne w3a cc0 wceq c1 isphtpc
      wa cv wex n0 simpll simplr simpr phtpy01 ex exlimdv syl5bi 3impia sylbi )
      ABCEFGAHCIJZKZBUMKZABCLFJZMNZOPAFPBFQRAFRBFQTZABCSUNUOUQURUQDUAZUPKZDUBUN
      UOTZURDUPUCVAUTURDVAUTURVAUTTABUSCUNUOUTUDUNUOUTUEVAUTUFUGUHUIUJUKUL $.
  $}

  ${
    $d s x y F $.  $d s x y G $.  $d s H $.  $d s x y J $.  $d s x y z ph $.
    reparpht.2 $e |- ( ph -> F e. ( II Cn J ) ) $.
    reparpht.3 $e |- ( ph -> G e. ( II Cn II ) ) $.
    reparpht.4 $e |- ( ph -> ( G ` 0 ) = 0 ) $.
    reparpht.5 $e |- ( ph -> ( G ` 1 ) = 1 ) $.
    ${
      reparphti.6 $e |- H = ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |->
                    ( F ` ( ( ( 1 - y ) x. ( G ` x ) ) + ( y x. x ) ) ) ) $.
      $( Lemma for ~ reparpht .  (Contributed by NM, 15-Jun-2010.)  (Revised by
         Mario Carneiro, 7-Jun-2014.) $)
      reparphti $p |- ( ph -> H e. ( ( F o. G ) ( PHtpy ` J ) F ) ) $=
        ( cii co wcel cc0 c1 cfv cmul caddc vs vz ccom ccn cnco syl2anc cicc cv
        cmin cmpt2 ctx ctopon iitopon a1i ccnfld ctopn crest ctop eqid cnfldtop
        cnrest2r mp1i cnmpt2nd cmpt iirevcn oveq2 cnmpt21 dfii3 oveq2i syl6eleq
        wss sseldd cnmpt1st cnmpt21f mulcn cnmpt22f addcn cc crn cnfldtopon cxp
        wb wf wral wa iiuni cnf syl ffvelrnda adantrr simprl simprr w3a 0re 1re
        cr icccvx mp2an syl3anc ralrimivva fmpt2 sylib unitssre ax-resscn sstri
        frn cnrest2 mpbid syl6eleqr syl5eqel sseldi mulid2d sseli adantl mul02d
        wi oveq12d addid1d eqtrd fveq2d simpr 0elunit weq oveq2d ax-1cn subid1i
        syl6eq simpl ovmpt2a sylancl fvco3 sylan 3eqtr4d 1elunit adantr sylancr
        wceq fvex mul01d mulid1d 1m1e0 addid2d subcl 00id npcan isphtpy2d ) ADE
        UCZDFGUAAEMMUDNZOZDMGUDNZOUUGUUJOIHEDMMGUEUFHAFBCPQUGNZUUKQCUHZUINZBUHZ
        ERZSNZUULUUNSNZTNZDRZUJMMUKNZGUDNLABCUURDMMMGUUKUUKMUUKULROAUMUNZUVAABC
        UUKUUKUURUJZUUTUOUPRZUUKUQNZUDNZUUTMUDNZAUVBUUTUVCUDNZOZUVBUVEOZABCUUPU
        UQTMMUVCUVCUVCUUKUUKUVAUVAABCUUMUUOSMMUVCUVCUVCUUKUUKUVAUVAAUVEUVGBCUUK
        UUKUUMUJZUVCUROUVEUVGVKAUVCUVCUSZUTUUKUUTUVCVAVBZAUVJUVFUVEABCUBUULQUBU
        HZUINZUUMMMMMUUKUUKUUKUVAUVAABCMMUUKUUKUVAUVAVCZUVAUBUUKUVNVDUUHOAUBVEU
        NUVMUULQUIVFVGMUVDUUTUDUVCUVKVHVIZVJVLAUVEUVGBCUUKUUKUUOUJZUVLAUVQUVFUV
        EABCUUNEMMMMUUKUUKUVAUVAABCMMUUKUUKUVAUVAVMZIVNUVPVJVLSUVCUVCUKNUVCUDNZ
        OAUVCUVKVOUNZVPABCUULUUNSMMUVCUVCUVCUUKUUKUVAUVAAUVEUVGBCUUKUUKUULUJZUV
        LAUWAUVFUVEUVOUVPVJVLAUVEUVGBCUUKUUKUUNUJZUVLAUWBUVFUVEUVRUVPVJVLUVTVPT
        UVSOAUVCUVKVQUNVPAUVCVRULROZUVBVSUUKVKZUUKVRVKZUVHUVIWBUWCAUVCUVKVTUNAU
        UKUUKWAZUUKUVBWCZUWDAUURUUKOZCUUKWDBUUKWDUWGAUWHBCUUKUUKAUUNUUKOZUULUUK
        OZWEWEUUOUUKOZUWIUWJUWHAUWIUWKUWJAUUKUUKUUNEAUUIUUKUUKEWCZIEMMUUKUUKWFW
        FWGWHZWIWJAUWIUWJWKAUWIUWJWLPWPOQWPOUWKUWIUWJWMUWHXPWNWOPQUUOUUNUULWQWR
        WSWTBCUUKUUKUURUUKUVBUVBUSXAXBUWFUUKUVBXFWHUWEAUUKWPVRXCXDXEZUNUUKUVBUU
        TUVCVRXGWSXHUVPXIHVNXJAUAUHZUUKOZWEZQUWOERZSNZPUWOSNZTNZDRZUWRDRZUWOPFN
        ZUWOUUGRZUWQUXAUWRDUWQUXAUWRPTNUWRUWQUWSUWRUWTPTUWQUWRUWQUUKVRUWRUWNAUU
        KUUKUWOEUWMWIXKZXLUWQUWOUWPUWOVROZAUUKVRUWOUWNXMXNZXOXQUWQUWRUXFXRXSXTU
        WQUWPPUUKOZUXDUXBYQAUWPYAZYBBCUWOPUUKUUKUUSUXBFBUAYCZUULPYQZWEZUURUXADU
        XMUUPUWSUUQUWTTUXMUUMQUUOUWRSUXMUUMQPUINQUXMUULPQUIUXKUXLYAZYDQYEYFYGUX
        MUUNUWOEUXKUXLYHZXTXQUXMUULPUUNUWOSUXNUXOXQXQXTLUXADYRYIYJAUWLUWPUXEUXC
        YQUWMUUKUUKUWODEYKYLYMUWQUWOQFNZPUWRSNZQUWOSNZTNZDRZUWODRUWQUWPQUUKOZUX
        PUXTYQUXJYNBCUWOQUUKUUKUUSUXTFUXKUULQYQZWEZUURUXSDUYCUUPUXQUUQUXRTUYCUU
        MPUUOUWRSUYCUUMQQUINPUYCUULQQUIUXKUYBYAZYDUUAYGUYCUUNUWOEUXKUYBYHZXTXQU
        YCUULQUUNUWOSUYDUYEXQXQXTLUXSDYRYIYJUWQUXSUWODUWQUXSPUWOTNUWOUWQUXQPUXR
        UWOTUWQUWRUXFXOUWQUWOUXHXLXQUWQUWOUXHUUBXSXTXSUWQQUWOUINZPERZSNZUWOPSNZ
        TNZDRZPDRZPUWOFNZPUUGRZUWQUYJPDUWQUYJPPTNPUWQUYHPUYIPTUWQUYHUYFPSNPUWQU
        YGPUYFSAUYGPYQUWPJYOYDUWQUYFUWQQVROZUXGUYFVROYEUXHQUWOUUCYPZYSXSUWQUWOU
        XHYSXQUUDYGXTUWQUXIUWPUYMUYKYQYBUXJBCPUWOUUKUUKUUSUYKFUUNPYQZCUAYCZWEZU
        URUYJDUYSUUPUYHUUQUYITUYSUUMUYFUUOUYGSUYSUULUWOQUIUYQUYRYAZYDUYSUUNPEUY
        QUYRYHZXTXQUYSUULUWOUUNPSUYTVUAXQXQXTLUYJDYRYIYPAUYNUYLYQUWPAUYNUYGDRZU
        YLAUWLUXIUYNVUBYQUWMYBUUKUUKPDEYKYJAUYGPDJXTXSYOYMUWQUYFQERZSNZUWOQSNZT
        NZDRZQDRZQUWOFNZQUUGRZUWQVUFQDUWQVUFUYFUWOTNZQUWQVUDUYFVUEUWOTUWQVUDUYF
        QSNUYFUWQVUCQUYFSAVUCQYQUWPKYOYDUWQUYFUYPYTXSUWQUWOUXHYTXQUWQUYOUXGVUKQ
        YQYEUXHQUWOUUEYPXSXTUWQUYAUWPVUIVUGYQYNUXJBCQUWOUUKUUKUUSVUGFUUNQYQZUYR
        WEZUURVUFDVUMUUPVUDUUQVUETVUMUUMUYFUUOVUCSVUMUULUWOQUIVULUYRYAZYDVUMUUN
        QEVULUYRYHZXTXQVUMUULUWOUUNQSVUNVUOXQXQXTLVUFDYRYIYPAVUJVUHYQUWPAVUJVUC
        DRZVUHAUWLUYAVUJVUPYQUWMYNUUKUUKQDEYKYJAVUCQDKXTXSYOYMUUF $.
    $}

    $( Reparametrization lemma.  The reparametrization of a path by any
       continuous map ` G : II --> II ` with ` G ( 0 ) = 0 ` and
       ` G ( 1 ) = 1 ` is path-homotopic to the original path.  (Contributed by
       Jeff Madsen, 15-Jun-2010.)  (Revised by Mario Carneiro, 23-Feb-2015.) $)
    reparpht $p |- ( ph -> ( F o. G ) ( ~=ph ` J ) F ) $=
      ( vx vy ccom cii ccn co wcel cphtpy cfv c1 cv cmul c0 wne cphtpc wbr cnco
      syl2anc cc0 cicc cmin caddc cmpt2 eqid reparphti ne0i isphtpc syl3anbrc
      syl ) ABCKZLDMNZOZBUSOZURBDPQNZUAUBZURBDUCQUDACLLMNOVAUTFECBLLDUEUFEAIJUG
      RUHNZVDRJSZUINISZCQTNVEVFTNUJNBQUKZVBOVCAIJBCVGDEFGHVGULUMVBVGUNUQURBDUOU
      P $.
  $}

  ${
    $d f F $.  $d f G $.  $d f J $.  $d f K $.  $d f P $.  $d f ph $.
    phtpcco2.f $e |- ( ph -> F ( ~=ph ` J ) G ) $.
    phtpcco2.p $e |- ( ph -> P e. ( J Cn K ) ) $.
    $( Compose a path homotopy with a continuous map.  (Contributed by Mario
       Carneiro, 6-Jul-2015.) $)
    phtpcco2 $p |- ( ph -> ( P o. F ) ( ~=ph ` K ) ( P o. G ) ) $=
      ( vf ccom cii ccn co wcel cphtpy cfv c0 wne cphtpc adantr wbr w3a isphtpc
      sylib simp1d cnco syl2anc simp2d cv wex simp3d n0 simpr phtpyco2 ne0i syl
      wa exlimddv syl3anbrc ) ABCJZKFLMZNZBDJZVANZUTVCFOPMZQRZUTVCFSPUAACKELMZN
      ZBEFLMNZVBAVHDVGNZCDEOPMZQRZACDESPUAVHVJVLUBGCDEUCUDZUEZHCBKEFUFUGAVJVIVD
      AVHVJVLVMUHZHDBKEFUFUGAIUIZVKNZVFIAVLVQIUJAVHVJVLVMUKIVKULUDAVQUQZBVPJZVE
      NVFVRBCDVPEFAVHVQVNTAVJVQVOTAVIVQHTAVQUMUNVEVSUOUPURUTVCFUCUS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The fundamental group
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c *p $.
  $c Om1 $.
  $c OmN $.
  $c pi1 $.
  $c piN $.

  $( Extend class notation with the concatenation operation for paths in a
     topological space. $)
  cpco $a class *p $.

  $( Extend class notation with the loop space. $)
  comi $a class Om1 $.

  $( Extend class notation with the higher loop spaces. $)
  comn $a class OmN $.

  $( Extend class notation with the fundamental group. $)
  cpi1 $a class pi1 $.

  $( Extend class notation with the higher homotopy groups. $)
  cpin $a class piN $.

  ${
    $d b f g h j m n p t x y $.
    $( Define the concatenation of two paths in a topological space ` J ` .
       For simplicity of definition, we define it on all paths, not just those
       whose endpoints line up.  Definition of [Hatcher] p. 26.  Hatcher
       denotes path concatenation with a square dot; other authors, such as
       Munkres, use a star.  (Contributed by Jeff Madsen, 15-Jun-2010.) $)
    df-pco $a |- *p = ( j e. Top |-> ( f e. ( II Cn j ) , g e. ( II Cn j ) |->
               ( x e. ( 0 [,] 1 ) |-> if ( x <_ ( 1 / 2 ) ,
                 ( f ` ( 2 x. x ) ) , ( g ` ( ( 2 x. x ) - 1 ) ) ) ) ) ) $.

    $( Define the loop space of a topological space, with a magma structure on
       it given by concatenation of loops.  This structure is not a group, but
       the operation is compatible with homotopy, which allows the homotopy
       groups to be defined based on this operation.  (Contributed by Mario
       Carneiro, 10-Jul-2015.) $)
    df-om1 $a |- Om1 = ( j e. Top , y e. U. j |-> { <. ( Base ` ndx ) ,
           { f e. ( II Cn j ) | ( ( f ` 0 ) = y /\ ( f ` 1 ) = y ) } >. ,
        <. ( +g ` ndx ) , ( *p ` j ) >. ,
        <. ( TopSet ` ndx ) , ( j ^ko II ) >. } ) $.

    $( Define the n-th iterated loop space of a topological space.  Unlike
       ` Om1 ` this is actually a _pointed_ topological space, which is to say
       a tuple of a topological space (a member of ` TopSp ` , not ` Top ` )
       and a point in the space.  Higher loop spaces select the constant loop
       at the point from the lower loop space for the distinguished point.
       (Contributed by Mario Carneiro, 10-Jul-2015.) $)
    df-omn $a |- OmN = ( j e. Top , y e. U. j |->
      seq 0 ( ( ( x e. _V , p e. _V |->
        <. ( ( TopOpen ` ( 1st ` x ) ) Om1 ( 2nd ` x ) ) ,
           ( ( 0 [,] 1 ) X. { ( 2nd ` x ) } ) >. ) o. 1st ) ,
          <. { <. ( Base ` ndx ) , U. j >. ,
               <. ( TopSet ` ndx ) , j >. } , y >. ) ) $.

    $( Define the fundamental group, whose operation is given by concatenation
       of homotopy classes of loops.  Definition of [Hatcher] p. 26.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    df-pi1 $a |- pi1 = ( j e. Top , y e. U. j |->
       ( ( j Om1 y ) /s ( ~=ph ` j ) ) ) $.

    $( Define the n-th homotopy group, which is formed by taking the ` n ` -th
       loop space and forming the quotient under the relation of path homotopy
       equivalence in the base space of the ` n ` -th loop space, which is the
       ` n - 1 ` -th loop space.  For ` n = 0 ` , since this is not
       well-defined we replace this relation with the path-connectedness
       relation, so that the ` 0 ` -th homotopy group is the set of path
       components of ` X ` .  (Since the ` 0 ` -th loop space does not have a
       group operation, neither does the ` 0 ` -th homotopy group, but the rest
       are genuine groups.)  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    df-pin $a |- piN = ( j e. Top , p e. U. j |->
      ( n e. NN0 |-> ( ( 1st ` ( ( j OmN p ) ` n ) ) /s if ( n = 0 ,
    { <. x , y >. | E. f e. ( II Cn j ) ( ( f ` 0 ) = x /\ ( f ` 1 ) = y ) } ,
      ( ~=ph ` ( TopOpen ` ( 1st ` ( ( j OmN p ) ` ( n - 1 ) ) ) ) ) ) ) ) ) $.
  $}

  ${
    $d f g x y z F $.  $d f g x y z G $.  $d x K $.  $d x y z ph $.  $d x X $.
    $d x y H $.  $d f g j x y z J $.
    $( The value of the path concatenation function on a topological space.
       (Contributed by Jeff Madsen, 15-Jun-2010.)  (Revised by Mario Carneiro,
       7-Jun-2014.) $)
    pcofval $p |- ( *p ` J ) = ( f e. ( II Cn J ) ,
                    g e. ( II Cn J ) |->
               ( x e. ( 0 [,] 1 ) |-> if ( x <_ ( 1 / 2 ) ,
                 ( f ` ( 2 x. x ) ) , ( g ` ( ( 2 x. x ) - 1 ) ) ) ) ) $=
      ( vj ctop wcel cpco cfv cii ccn co c1 cv c2 cmpt2 wceq wn c0 con3i df-pco
      cc0 cicc cdiv cle wbr cmul cmin cmpt oveq2 eqidd mpt2eq123dv mpt2ex fvmpt
      cif ovex cdm dmmptss sseli ndmfv syl cntop2 eq0rdv mpt2eq12 syl2anc mpt20
      syl6eq eqtr4d pm2.61i ) DFGZDHIZBCJDKLZVLAUBMUCLANZMOUDLUEUFOVMUGLZBNZIVN
      MUHLCNIUOUIZPZQEDBCJENZKLZVSVPPZVQFHVRDQZBCVSVSVPVLVLVPVRDJKUJZWBWAVPUKUL
      ABCEUAZBCVLVLVPJDKUPZWDUMUNVJRZVKSVQWEDHUQZGZRVKSQWGVJWFFDEFVTHWCURUSTDHU
      TVAWEVQBCSSVPPZSWEVLSQZWIVQWHQWEBVLVOVLGVJVOJDVBTVCZWJBCVLVLSSVPVDVEBCSVP
      VFVGVHVI $.

    pcoval.2 $e |- ( ph -> F e. ( II Cn J ) ) $.
    pcoval.3 $e |- ( ph -> G e. ( II Cn J ) ) $.
    $( The concatenation of two paths.  (Contributed by Jeff Madsen,
       15-Jun-2010.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    pcoval $p |- ( ph -> ( F ( *p ` J ) G ) =
                ( x e. ( 0 [,] 1 ) |-> if ( x <_ ( 1 / 2 ) ,
                  ( F ` ( 2 x. x ) ) , ( G ` ( ( 2 x. x ) - 1 ) ) ) ) ) $=
      ( vf vg co wcel cfv cc0 c1 cicc cv c2 cif cmpt wceq cii ccn cpco cdiv cle
      wbr cmul cmin wa fveq1 adantr ifeq12d mpteq2dv pcofval ovex mptex ovmpt2a
      adantl syl2anc ) ACUAEUBJZKDUTKCDEUCLZJBMNOJZBPZNQUDJUEUFZQVCUGJZCLZVENUH
      JZDLZRZSZTFGHICDUTUTBVBVDVEHPZLZVGIPZLZRZSVJVAVKCTZVMDTZUIZBVBVOVIVRVDVLV
      FVNVHVPVLVFTVQVEVKCUJUKVQVNVHTVPVGVMDUJURULUMBHIEUNBVBVIMNOUOUPUQUS $.

    $( Evaluate the concatenation of two paths.  (Contributed by Mario
       Carneiro, 7-Jun-2014.) $)
    pcovalg $p |- ( ( ph /\ X e. ( 0 [,] 1 ) ) ->
                  ( ( F ( *p ` J ) G ) ` X ) = if ( X <_ ( 1 / 2 ) ,
                  ( F ` ( 2 x. X ) ) , ( G ` ( ( 2 x. X ) - 1 ) ) ) ) $=
      ( vx cc0 c1 co cfv c2 cle wbr cmul cmin cif fveq2d fvex cicc wcel cpco cv
      cdiv cmpt pcoval fveq1d wceq breq1 oveq2 oveq1d ifbieq12d eqid ifex fvmpt
      sylan9eq ) AEIJUAKZUBEBCDUCLKZLEHURHUDZJMUEKZNOZMUTPKZBLZVCJQKZCLZRZUFZLE
      VANOZMEPKZBLZVJJQKZCLZRZAEUSVHAHBCDFGUGUHHEVGVNURVHUTEUIZVBVIVDVFVKVMUTEV
      ANUJVOVCVJBUTEMPUKZSVOVEVLCVOVCVJJQVPULSUMVHUNVIVKVMVJBTVLCTUOUPUQ $.

    $( Evaluate the concatenation of two paths on the first half.  (Contributed
       by Jeff Madsen, 15-Jun-2010.)  (Revised by Mario Carneiro,
       7-Jun-2014.) $)
    pcoval1 $p |- ( ( ph /\ X e. ( 0 [,] ( 1 / 2 ) ) ) ->
                  ( ( F ( *p ` J ) G ) ` X ) = ( F ` ( 2 x. X ) ) ) $=
      ( cc0 c1 c2 cdiv co cicc wcel cfv cle wbr wceq cr 1re wa cpco cif wss 0re
      cmul cmin rehalfcli halflt1 ltleii iccss mp4an sseli pcovalg sylan2 elii1
      0le0 simprbi iftrue syl adantl eqtrd ) AEHIJKLZMLZNZUAEBCDUBOLOZEVCPQZJEU
      FLZBOZVHIUGLCOZUCZVIVEAEHIMLZNZVFVKRVDVLEHSNISNHHPQVCIPQVDVLUDUETUQVCIITU
      HTUIUJHIHVCUKULUMABCDEFGUNUOVEVKVIRZAVEVGVNVEVMVGEUPURVGVIVJUSUTVAVB $.

    $( The starting point of a path concatenation.  (Contributed by Jeff
       Madsen, 15-Jun-2010.) $)
    pco0 $p |- ( ph -> ( ( F ( *p ` J ) G ) ` 0 ) = ( F ` 0 ) ) $=
      ( cc0 cpco cfv co c2 cmul c1 cdiv cicc wcel wceq cle wbr 0re cr rehalfcli
      0le0 1re halfgt0 ltleii elicc2i mpbir3an pcoval1 2cn mul01i fveq2i syl6eq
      mpan2 ) AGBCDHIJIZKGLJZBIZGBIAGGMKNJZOJPZUOUQQUSGUAPGGRSGURRSTUCGURTMUDUB
      ZUEUFGURGTUTUGUHABCDGEFUIUNUPGBKUJUKULUM $.

    $( The ending point of a path concatenation.  (Contributed by Jeff Madsen,
       15-Jun-2010.) $)
    pco1 $p |- ( ph -> ( ( F ( *p ` J ) G ) ` 1 ) = ( G ` 1 ) ) $=
      ( vx c1 cpco cfv co c2 cle wbr cmul cmin wceq wn 1re syl6eq cc0 cicc cdiv
      cv cif cmpt pcoval fveq1d wcel 1elunit clt halflt1 rehalfcli ltnlei breq1
      mpbi mtbiri iffalse syl oveq2 mulid1i oveq1d 2m1e1 fveq2d eqtrd eqid fvex
      2cn fvmpt ax-mp ) AHBCDIJKZJHGUAHUBKZGUDZHLUCKZMNZLVMOKZBJZVPHPKZCJZUEZUF
      ZJZHCJZAHVKWAAGBCDEFUGUHHVLUIWBWCQUJGHVTWCVLWAVMHQZVTVSWCWDVORVTVSQWDVOHV
      NMNZVNHUKNWERULVNHHSUMSUNUPVMHVNMUOUQVOVQVSURUSWDVRHCWDVRLHPKHWDVPLHPWDVP
      LHOKLVMHLOUTLVHVATVBVCTVDVEWAVFHCVGVIVJT $.

    pcoval2.4 $e |- ( ph -> ( F ` 1 ) = ( G ` 0 ) ) $.
    $( Evaluate the concatenation of two paths on the second half.
       (Contributed by Jeff Madsen, 15-Jun-2010.)  (Proof shortened by Mario
       Carneiro, 7-Jun-2014.) $)
    pcoval2 $p |- ( ( ph /\ X e. ( ( 1 / 2 ) [,] 1 ) ) ->
                  ( ( F ( *p ` J ) G ) ` X ) = ( G ` ( ( 2 x. X ) - 1 ) ) ) $=
      ( c1 c2 co wcel wa cfv cle wbr cmul cc0 wceq cr cdiv cicc cif wss 0re 1re
      cpco cmin rehalfcli halfgt0 ltleii 1le1 iccss mp4an pcovalg sylan2 adantr
      sseli simprr elicc2i simp2bi ad2antrl wb simp1bi letri3 sylancl mpbir2and
      oveq2d 2ne0 recidi syl6eq fveq2d oveq1d 1m1e0 3eqtr4d ifeq1d ifid iffalse
      2cn expr pm2.61d1 eqtrd ) AEIJUAKZIUBKZLZMZEBCDUGNKNZEWCOPZJEQKZBNZWIIUHK
      ZCNZUCZWLWEAERIUBKZLWGWMSWDWNERTLITLRWCOPIIOPWDWNUDUEUFRWCUEIUFUIZUJUKULR
      IWCIUMUNURABCDEFGUOUPWFWHWMWLSZAWEWHWPAWEWHMZMZWMWHWLWLUCWLWRWHWJWLWLWRIB
      NZRCNZWJWLAWSWTSWQHUQWRWIIBWRWIJWCQKIWREWCJQWREWCSZWHWCEOPZAWEWHUSWEXBAWH
      WEETLZXBEIOPZWCIEWOUFUTZVAVBWRXCWCTLXAWHXBMVCWEXCAWHWEXCXBXDXEVDVBWOEWCVE
      VFVGVHJVSVIVJVKZVLWRWKRCWRWKIIUHKRWRWIIIUHXFVMVNVKVLVOVPWHWLVQVKVTWHWJWLV
      RWAWB $.

    $( The concatenation of two paths is a path.  (Contributed by Jeff Madsen,
       19-Jun-2010.)  (Proof shortened by Mario Carneiro, 7-Jun-2014.) $)
    pcocn $p |- ( ph -> ( F ( *p ` J ) G ) e. ( II Cn J ) ) $=
      ( vx vy vz cfv co cc0 c1 c2 cmul cii wcel a1i cr cpco cicc cv cle wbr cif
      cdiv cmin cmpt ccn pcoval ctopon iitopon cnmptid 0elunit cnmptc crn crest
      cioo ctg eqid dfii2 0re rehalfcli halfgt0 ltleii halflt1 elicc2i mpbir3an
      1re wceq wa adantr simprl oveq2d 2ne0 recidi syl6eq fveq2d oveq1d 3eqtr4d
      2cn 1m1e0 wss retopon iccssre mp2an resttopon cnmpt1st iihalf1cn cnmpt21f
      oveq2 cnmpt21 iihalf2cn cnmpt2pc breq1 ifbieq12d cnmpt12 eqeltrd ) ABCDUA
      KLHMNUBLZHUCZNOUGLZUDUEZOXAPLZBKZXDNUHLZCKZUFZUIQDUJLAHBCDEFUKAHIJXAMIUCZ
      XBUDUEZOXIPLZBKZXKNUHLZCKZUFZXHQQQDWTWTWTQWTULKRAUMSZAHQWTXPUNAHMQQWTWTXP
      XPMWTRAUOSUPXPXPAIJMXBNXLUSUQUTKZXNQDXQMXBUBLZURLZXQXBNUBLZURLZQWTXQVAXSV
      AZYAVAZVBMTRZAVCSNTRZAVJSXBWTRZAYFXBTRZMXBUDUEXBNUDUENVJVDZMXBVCYHVEVFXBN
      YHVJVGVFMNXBVCVJVHVISXPAXIXBVKZJUCZWTRZVLZVLZNBKZMCKZXLXNAYNYOVKYLGVMYMXK
      NBYMXKOXBPLNYMXIXBOPAYIYKVNVOOWBVPVQVRZVSYMXMMCYMXMNNUHLMYMXKNNUHYPVTWCVR
      VSWAAIJXKBXSQQDXRWTXSXRULKRZAXQTULKRZXRTWDZYQWEYDYGYSVCYHMXBWFWGXRXQTWHWG
      SZXPAIJHXIXDXKXSQXSQXRWTXRYTXPAIJXSQXRWTYTXPWIYTHXRXDUIXSQUJLRAHXSYBWJSXA
      XIOPWLZWMEWKAIJXMCYAQQDXTWTYAXTULKRZAYRXTTWDZUUBWEYGYEUUCYHVJXBNWFWGXTXQT
      WHWGSZXPAIJHXIXFXMYAQYAQXTWTXTUUDXPAIJYAQXTWTUUDXPWIUUDHXTXFUIYAQUJLRAHYA
      YCWNSXAXIVKXDXKNUHUUAVTWMFWKWOXIXAVKZXOXHVKYJMVKUUEXJXCXLXNXEXGXIXAXBUDWP
      UUEXKXDBXIXAOPWLZVSUUEXMXFCUUEXKXDNUHUUFVTVSWQVMWRWS $.

    copco.6 $e |- ( ph -> H e. ( J Cn K ) ) $.
    $( The composition of a concatenation of paths with a continuous function.
       (Contributed by Mario Carneiro, 9-Jul-2015.) $)
    copco $p |- ( ph ->
      ( H o. ( F ( *p ` J ) G ) ) = ( ( H o. F ) ( *p ` K ) ( H o. G ) ) ) $=
      ( vx c1 co cfv cif wcel wf cii cnf syl vy cc0 cicc cdiv cle wbr cmul ccom
      cv c2 cmin cmpt cpco wceq cuni ccn iiuni eqid elii1 iihalf1 sylbir syl2an
      wa fvco3 anassrs ifeq1da wn elii2 iihalf2 ifeq2da eqtrd mpteq2dva syl2anc
      cnco pcoval wral pcocn eqeltrrd fmpt sylibr feqmptd fveq2 syl6eq 3eqtr4rd
      fvif fmptcof ) AKUBLUCMZKUIZLUJUDMZUEUFZUJWHUGMZDBUHZNZWKLUKMZDCUHZNZOZUL
      KWGWJWKBNZDNZWNCNZDNZOZULWLWOFUMNMDBCEUMNMZUHAKWGWQXBAWHWGPZVCZWQWJWSWPOX
      BXEWJWMWSWPAXDWJWMWSUNZAWGEUOZBQZWKWGPZXFXDWJVCZABREUPMZPZXHGBREWGXGUQXGU
      RZSTXJWHUBWIUCMPXIWHUSWHUTVAWGXGWKDBVDVBVEVFXEWJWPXAWSAXDWJVGZWPXAUNZAWGX
      GCQZWNWGPZXOXDXNVCZACXKPZXPHCREWGXGUQXMSTXRWHWILUCMPXQWHVHWHVITWGXGWNDCVD
      VBVEVJVKVLAKWLWOFAXLDEFUPMPZWLRFUPMZPGJBDREFVNVMAXSXTWOYAPHJCDREFVNVMVOAK
      UAWGXGWJWRWTOZUAUIZDNZXBXCDAWGXGKWGYBULZQZYBXGPKWGVPAYEXKPYFAXCYEXKAKBCEG
      HVOZABCEGHIVQVRYEREWGXGUQXMSTKWGXGYBYEYEURVSVTYGAUAXGFUOZDAXTXGYHDQJDEFXG
      YHXMYHURSTWAYCYBUNYDYBDNXBYCYBDWBWJWRWTDWEWCWFWD $.
  $}

  ${
    $d m n s t x y F $.  $d s t x y M $.  $d s t x y N $.  $d m n s x y z ph $.
    $d m n s t x y G $.  $d m n s t x y H $.  $d m n s t x y J $.  $d s P $.
    $d m n s t x y K $.
    pcohtpy.4 $e |- ( ph -> ( F ` 1 ) = ( G ` 0 ) ) $.
    pcohtpy.5 $e |- ( ph -> F ( ~=ph ` J ) H ) $.
    pcohtpy.6 $e |- ( ph -> G ( ~=ph ` J ) K ) $.
    ${
      pcohtpylem.7 $e |- P = ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |->
                               if ( x <_ ( 1 / 2 ) ,
                         ( ( 2 x. x ) M y ) , ( ( ( 2 x. x ) - 1 ) N y ) ) ) $.
      pcohtpylem.8 $e |- ( ph -> M e. ( F ( PHtpy ` J ) H ) ) $.
      pcohtpylem.9 $e |- ( ph -> N e. ( G ( PHtpy ` J ) K ) ) $.
      $( Lemma for ~ pcohtpy .  (Contributed by Jeff Madsen, 15-Jun-2010.)
         (Revised by Mario Carneiro, 24-Feb-2015.) $)
      pcohtpylem $p |- ( ph ->
        P e. ( ( F ( *p ` J ) G ) ( PHtpy ` J ) ( H ( *p ` J ) K ) ) ) $=
        ( co c1 wceq vs cpco cfv cii ccn wcel cphtpy wne cphtpc wbr w3a isphtpc
        vz c0 sylib simp1d pcocn simp2d cc0 phtpy01 simprd simpld 3eqtr3d cv c2
        cicc cdiv cle cmul cmin cif cmpt2 ctx cioo crn ctg crest eqid dfii2 0re
        cr a1i rehalfcli halfgt0 ltleii halflt1 elicc2i mpbir3an ctopon iitopon
        1re adantr phtpyi adantrl 3eqtr4d simprl oveq2d 2cn 2ne0 syl6eq retopon
        wa oveq1d wss iccssre mp2an resttopon cnmpt1st cnmpt21 cnmpt2nd phtpycn
        cmpt sseldd cnmpt22f weq simpll adantll phtpyhtpy syl2anc iftrue adantl
        htpyi wn iffalse pm2.61dan simpr 0elunit simpl breq1d oveq12d ifbieq12d
        syl ovex ifex ovmpt2a sylancl pcovalg 1elunit eqtrd sylancr 1m1e0 oveq2
        recidi iihalf1cn iihalf2cn cnmpt2pc syl5eqel elii1 iihalf1 sylbir chtpy
        elii2 iihalf2 syl6eqbr mul01i pco0 clt ltnlei mpbi mtbiri mulid1i 2m1e1
        pco1 isphtpy2d ) AEFHUBUCZRZGIUVERZDHUAAEFHAEUDHUERZUFZGUVHUFZEGHUGUCZR
        ZUNUHZAEGHUIUCZUJUVIUVJUVMUKMEGHULUOZUPZAFUVHUFZIUVHUFZFIUVKRZUNUHZAFIU
        VNUJUVQUVRUVTUKNFIHULUOZUPZLUQAGIHAUVIUVJUVMUVOURZAUVQUVRUVTUWAURZASEUC
        ZUSFUCZSGUCZUSIUCZLAUSEUCZUSGUCTUWEUWGTAEGJHUVPUWCPUTVAAUWFUWHTSFUCZSIU
        CTAFIKHUWBUWDQUTVBVCUQADBCUSSVFRZUWKBVDZSVEVGRZVHUJZVEUWLVIRZCVDZJRZUWO
        SVJRZUWPKRZVKZVLUDUDVMRHUERZOABCUSUWMSUWQVNVOVPUCZUWSUDHUXBUSUWMVFRZVQR
        ZUXBUWMSVFRZVQRZUDUWKUXBVRUXDVRZUXFVRZVSUSWAUFZAVTWBSWAUFZAWKWBUWMUWKUF
        ZAUXKUWMWAUFZUSUWMVHUJUWMSVHUJSWKWCZUSUWMVTUXMWDWEZUWMSUXMWKWFWEUSSUWMV
        TWKWGWHWBUDUWKWIUCUFAWJWBZAUWLUWMTZUWPUWKUFZXBZXBZSUWPJRZUSUWPKRZUWQUWS
        UXSUWEUWFUXTUYAAUWEUWFTUXRLWLAUXQUXTUWETZUXPAUXQXBZUSUWPJRUWITUYBAUWPEG
        JHUVPUWCPWMVAWNAUXQUYAUWFTZUXPUYCUYDSUWPKRUWJTAUWPFIKHUWBUWDQWMVBWNWOUX
        SUWOSUWPJUXSUWOVEUWMVIRSUXSUWLUWMVEVIAUXPUXQWPWQVEWRWSUUCWTZXCUXSUWRUSU
        WPKUXSUWRSSVJRUSUXSUWOSSVJUYEXCUUAWTXCWOABCUWOUWPJUXDUDUDUDHUXCUWKUXDUX
        CWIUCUFZAUXBWAWIUCUFZUXCWAXDZUYFXAUXIUXLUYHVTUXMUSUWMXEXFUXCUXBWAXGXFWB
        ZUXOABCUMUWLVEUMVDZVIRZUWOUXDUDUXDUDUXCUWKUXCUYIUXOABCUXDUDUXCUWKUYIUXO
        XHUYIUMUXCUYKXLUXDUDUERUFAUMUXDUXGUUDWBUYJUWLVEVIUUBZXIABCUXDUDUXCUWKUY
        IUXOXJAUVLUXAJAEGHUVPUWCXKPXMXNABCUWRUWPKUXFUDUDUDHUXEUWKUXFUXEWIUCUFZA
        UYGUXEWAXDZUYMXAUXLUXJUYNUXMWKUWMSXEXFUXEUXBWAXGXFWBZUXOABCUMUWLUYKSVJR
        ZUWRUXFUDUXFUDUXEUWKUXEUYOUXOABCUXFUDUXEUWKUYOUXOXHUYOUMUXEUYPXLUXFUDUE
        RUFAUMUXFUXHUUEWBUMBXOUYKUWOSVJUYLXCXIABCUXFUDUXEUWKUYOUXOXJAUVSUXAKAFI
        HUWBUWDXKQXMXNUUFUUGAUAVDZUWKUFZXBZUYQUWMVHUJZVEUYQVIRZUSJRZVUASVJRZUSK
        RZVKZUYTVUAEUCZVUCFUCZVKZUYQUSDRZUYQUVFUCUYSUYTVUEVUHTUYSUYTXBZVUBVUFVU
        EVUHVUJVUBVUFTZVUASJRZVUAGUCZTZVUJAVUAUWKUFZVUKVUNXBAUYRUYTXPUYRUYTVUOA
        UYRUYTXBUYQUXCUFVUOUYQUUHUYQUUIUUJXQAVUAEGJUDHUWKUXOUVPUWCAUVLEGUDHUUKR
        ZRJAEGHUVPUWCXRPXMYBXSZVBUYTVUEVUBTUYSUYTVUBVUDXTYAUYTVUHVUFTUYSUYTVUFV
        UGXTYAWOUYSUYTYCZXBZVUDVUGVUEVUHVUSVUDVUGTZVUCSKRZVUCIUCZTZVUSAVUCUWKUF
        ZVUTVVCXBAUYRVURXPVUSUYQUXEUFZVVDUYRVURVVEAUYQUULXQUYQUUMYLAVUCFIKUDHUW
        KUXOUWBUWDAUVSFIVUPRKAFIHUWBUWDXRQXMYBXSZVBVURVUEVUDTUYSUYTVUBVUDYDYAVU
        RVUHVUGTUYSUYTVUFVUGYDYAWOYEUYSUYRUSUWKUFZVUIVUETAUYRYFZYGBCUYQUSUWKUWK
        UWTVUEDBUAXOZUWPUSTZXBZUWNUYTUWQUWSVUBVUDVVKUWLUYQUWMVHVVIVVJYHZYIVVKUW
        OVUAUWPUSJVVKUWLUYQVEVIVVLWQZVVIVVJYFZYJVVKUWRVUCUWPUSKVVKUWOVUASVJVVMX
        CVVNYJYKOUYTVUBVUDVUAUSJYMVUCUSKYMYNYOYPAEFHUYQUVPUWBYQWOUYSUYTVULVVAVK
        ZUYTVUMVVBVKZUYQSDRZUYQUVGUCUYSUYTVVOVVPTVUJVULVUMVVOVVPVUJVUKVUNVUQVAU
        YTVVOVULTUYSUYTVULVVAXTYAUYTVVPVUMTUYSUYTVUMVVBXTYAWOVUSVVAVVBVVOVVPVUS
        VUTVVCVVFVAVURVVOVVATUYSUYTVULVVAYDYAVURVVPVVBTUYSUYTVUMVVBYDYAWOYEUYSU
        YRSUWKUFZVVQVVOTVVHYRBCUYQSUWKUWKUWTVVODVVIUWPSTZXBZUWNUYTUWQUWSVULVVAV
        VTUWLUYQUWMVHVVIVVSYHZYIVVTUWOVUAUWPSJVVTUWLUYQVEVIVWAWQZVVIVVSYFZYJVVT
        UWRVUCUWPSKVVTUWOVUASVJVWBXCVWCYJYKOUYTVULVVAVUASJYMVUCSKYMYNYOYPAGIHUY
        QUWCUWDYQWOUYSUSUYQJRZUWIUSUYQDRZUSUVFUCZUYSVWDUWITSUYQJRUWETAUYQEGJHUV
        PUWCPWMVBUYSVVGUYRVWEVWDTYGVVHBCUSUYQUWKUWKUWTVWDDUWLUSTZCUAXOZXBZUWTUW
        QVWDVWIUWNUWTUWQTVWIUWLUSUWMVHVWGVWHYHZUXNUUNUWNUWQUWSXTYLVWIUWOUSUWPUY
        QJVWIUWOVEUSVIRUSVWIUWLUSVEVIVWJWQVEWRUUOWTVWGVWHYFYJYSOUSUYQJYMYOYTAVW
        FUWITUYRAEFHUVPUWBUUPWLWOUYSSUYQKRZUWJSUYQDRZSUVFUCZUYSUSUYQKRUWFTVWKUW
        JTAUYQFIKHUWBUWDQWMVAUYSVVRUYRVWLVWKTYRVVHBCSUYQUWKUWKUWTVWKDUWLSTZVWHX
        BZUWTUWSVWKVWOUWNYCUWTUWSTVWOUWNSUWMVHUJZUWMSUUQUJVWPYCWFUWMSUXMWKUURUU
        SVWOUWLSUWMVHVWNVWHYHZYIUUTUWNUWQUWSYDYLVWOUWRSUWPUYQKVWOUWRVESVJRSVWOU
        WOVESVJVWOUWOVESVIRVEVWOUWLSVEVIVWQWQVEWRUVAWTXCUVBWTVWNVWHYFYJYSOSUYQK
        YMYOYTAVWMUWJTUYRAEFHUVPUWBUVCWLWOUVD $.
    $}

    $( Homotopy invariance of path concatenation.  (Contributed by Jeff Madsen,
       15-Jun-2010.)  (Revised by Mario Carneiro, 24-Feb-2015.) $)
    pcohtpy $p |- ( ph ->
                    ( F ( *p ` J ) G ) ( ~=ph ` J ) ( H ( *p ` J ) K ) ) $=
      ( vm vn cfv co wcel wbr sylib c1 cc0 wceq wa vx vy cpco cii ccn cphtpy c0
      wne cphtpc w3a isphtpc simp1d simp2d phtpc01 syl simprd simpld 3eqtr3d cv
      pcocn wex simp3d n0 eeanv sylanbrc cicc c2 cdiv cle cmul cif cmpt2 adantr
      cmin eqid simprl simprr pcohtpylem ne0i ex exlimdvv mpd syl3anbrc ) ABCEU
      CLZMZUDEUEMZNDFWDMZWFNWEWGEUFLZMZUGUHZWEWGEUILZOABCEABWFNZDWFNZBDWHMZUGUH
      ZABDWKOZWLWMWOUJHBDEUKPZULACWFNZFWFNZCFWHMZUGUHZACFWKOZWRWSXAUJICFEUKPZUL
      GUTADFEAWLWMWOWQUMAWRWSXAXCUMAQBLZRCLZQDLZRFLZGARBLRDLSZXDXFSZAWPXHXITHBD
      EUNUOUPAXEXGSZQCLQFLSZAXBXJXKTICFEUNUOUQURUTAJUSZWNNZKUSZWTNZTZKVAJVAZWJA
      XMJVAZXOKVAZXQAWOXRAWLWMWOWQVBJWNVCPAXAXSAWRWSXAXCVBKWTVCPXMXOJKVDVEAXPWJ
      JKAXPWJAXPTZUAUBRQVFMZYAUAUSZQVGVHMVIOVGYBVJMZUBUSZXLMYCQVNMYDXNMVKVLZWIN
      WJXTUAUBYEBCDEFXLXNAXDXESXPGVMAWPXPHVMAXBXPIVMYEVOAXMXOVPAXMXOVQVRWIYEVSU
      OVTWAWBWEWGEUKWC $.
  $}

  ${
    $d x y z F $.  $d x y z J $.  $d x P $.  $d x y z Y $.
    pcopt.1 $e |- P = ( ( 0 [,] 1 ) X. { Y } ) $.
    $( A constant function is a path from ` Y ` to itself.  (Contributed by
       Mario Carneiro, 12-Feb-2015.)  (Revised by Mario Carneiro,
       19-Mar-2015.) $)
    pcoptcl $p |- ( ( J e. ( TopOn ` X ) /\ Y e. X ) ->
      ( P e. ( II Cn J ) /\ ( P ` 0 ) = Y /\ ( P ` 1 ) = Y ) ) $=
      ( ctopon cfv wcel wa cii ccn co cc0 wceq c1 cicc fveq1i fvconst2g sylancl
      syl5eq csn iitopon cnconst2 mp3an1 syl5eqel simpr 0elunit 1elunit 3jca
      cxp ) BCFGHZDCHZIZAJBKLZHMAGZDNOAGZDNUMAMOPLZDUAUJZUNEJUQFGHUKULURUNHUBDJ
      BUQCUCUDUEUMUOMURGZDMAUREQUMULMUQHUSDNUKULUFZUGUQDMCRSTUMUPOURGZDOAUREQUM
      ULOUQHVADNUTUHUQDOCRSTUI $.

    $( Concatenation with a point does not affect homotopy class.  (Contributed
       by Jeff Madsen, 19-Jun-2010.)  (Revised by Mario Carneiro,
       20-Dec-2013.) $)
    pcopt $p |- ( ( F e. ( II Cn J ) /\ ( F ` 0 ) = Y )
                                -> ( P ( *p ` J ) F ) ( ~=ph ` J ) F ) $=
      ( vx vy cii co wcel cc0 cfv wceq c1 c2 cle cmul cmin a1i cr ccn cpco cicc
      vz wa cv cdiv wbr cif cmpt ccom cphtpc csn cxp fveq1i cuni simpr wf iiuni
      eqid cnf adantr 0elunit ffvelrn sylancl eqeltrrd iihalf1 sylbir fvconst2g
      elii1 syl2an syl5eq simplr eqtr4d ifeq1d expr wn iffalse mpteq2dva ctopon
      pm2.61d1 w3a ctop cntop2 sylib pcoptcl syl2anc simp1d simpl pcoval adantl
      toptopon elii2 iihalf2 syl eqeltrd iftrue syl6eqel pm2.61d2 feqmptd fveq2
      ex fvif syl6eq fmptco 3eqtr4d iitopon cnmptid cnmptc cioo crn crest dfii2
      ctg 0re 1re rehalfcli halfgt0 ltleii halflt1 elicc2i mpbir3an simprl 2ne0
      oveq2d 2cn recidi 1m1e0 syl6req wss retopon iccssre mp2an resttopon oveq2
      oveq1d weq breq1 fvmpt mp1i cnmpt2c cnmpt1st cnmpt21 cnmpt2pc ifbieq2d id
      iihalf2cn cnmpt12 syl6eqbr c0ex 1elunit ltnlei mtbiri mulid1i 2m1e1 eqtrd
      clt mpbi 1ex reparpht eqbrtrd ) BHCUAIZJZKBLZDMZUEZABCUBLIZBFKNUCIZFUFZNO
      UGIZPUHZKOUVIQIZNRIZUIZUJZUKZBCULLUVFFUVHUVKUVLALZUVMBLZUIZUJFUVHUVKUVDUV
      RUIZUJUVGUVPUVFFUVHUVSUVTUVFUVIUVHJZUEUVKUVSUVTMZUVFUWAUVKUWBUVFUWAUVKUEZ
      UEZUVKUVQUVDUVRUWDUVQDUVDUWDUVQUVLUVHDUMUNZLZDUVLAUWEEUOUVFDCUPZJZUVLUVHJ
      ZUWFDMUWCUVFUVDDUWGUVCUVEUQUVFUVHUWGBURZKUVHJZUVDUWGJUVCUWJUVEBHCUVHUWGUS
      UWGUTZVAVBZVCUVHUWGKBVDVEVFZUWCUVIKUVJUCIZJUWIUVIVJUVIVGVHUVHDUVLUWGVIVKV
      LUVCUVEUWCVMVNVOVPUVKVQZUVSUVRUVTUVKUVQUVRVRUVKUVDUVRVRVNWAVSUVFFABCUVFAU
      VBJZKALDMZNALDMZUVFCUWGVTLJZUWHUWQUWRUWSWBUVFCWCJZUWTUVCUXAUVEBHCWDVBCUWG
      UWLWLWEUWNACUWGDEWFWGWHUVCUVEWIZWJUVFFGUVHUVHUVNGUFZBLZUVTUVOBUWAUVNUVHJZ
      UVFUWAUVKUXEUWAUWPUXEUWAUWPUEZUVNUVMUVHUWPUVNUVMMZUWAUVKKUVMVRZWKUXFUVIUV
      JNUCIZJUVMUVHJUVIWMUVIWNWOWPXBUVKUVNKUVHUVKKUVMWQZVCWRWSWKUVOUVOMUVFUVOUT
      ZSUVFGUVHUWGBUWMWTUXCUVNMUXDUVNBLUVTUXCUVNBXAUVKKUVMBXCXDXEXFUVFBUVOCUXBU
      VFFGUDUVIKUXCUVJPUHZKOUXCQIZNRIZUIZUVNHHHHUVHUVHUVHHUVHVTLJUVFXGSZUVFFHUV
      HUXPXHUVFFKHHUVHUVHUXPUXPUWKUVFVCSZXIUXPUXPUVFGUDKUVJNKXJXKXNLZUXNHHUXRUW
      OXLIZUXRUXIXLIZHUVHUXRUTUXSUTUXTUTZXMKTJZUVFXOSNTJZUVFXPSUVJUVHJZUVFUYDUV
      JTJZKUVJPUHUVJNPUHNXPXQZKUVJXOUYFXRXSZUVJNUYFXPXTXSKNUVJXOXPYAYBSUXPUVFUX
      CUVJMZUDUFZUVHJZUEUEZUXNNNRIKUYKUXMNNRUYKUXMOUVJQINUYKUXCUVJOQUVFUYHUYJYC
      YEOYFYDYGXDYPYHYIUVFGUDKUXSHHUWOUVHUVHUXSUWOVTLJZUVFUXRTVTLJZUWOTYJZUYLYK
      UYBUYEUYNXOUYFKUVJYLYMUWOUXRTYNYMSUXPUXPUXQUUAUVFGUDFUXCUVMUXNUXTHUXTHUXI
      UVHUXIUXTUXIVTLJZUVFUYMUXITYJZUYOYKUYEUYCUYPUYFXPUVJNYLYMUXIUXRTYNYMSZUXP
      UVFGUDUXTHUXIUVHUYQUXPUUBUYQFUXIUVMUJUXTHUAIJUVFFUXTUYAUUGSFGYQUVLUXMNRUV
      IUXCOQYOYPUUCUUDGFYQZUXOUVNMUYIKMUYRUXLUVKUXNUVMKUXCUVIUVJPYRUYRUXMUVLNRU
      XCUVIOQYOYPUUEVBUUHUWKKUVOLKMUVFVCFKUVNKUVHUVOUVIKMZUVKUVNKMUYSUVIKUVJPUY
      SUUFUYGUUIUXJWOUXKUUJYSYTNUVHJNUVOLNMUVFUUKFNUVNNUVHUVOUVINMZUVNUVMNUYTUW
      PUXGUYTUVKNUVJPUHZUVJNUUQUHVUAVQXTUVJNUYFXPUULUURUVINUVJPYRUUMUXHWOUYTUVM
      ONRINUYTUVLONRUYTUVLONQIOUVINOQYOOYFUUNXDYPUUOXDUUPUXKUUSYSYTUUTUVA $.

    $( Concatenation with a point does not affect homotopy class.  (Contributed
       by Mario Carneiro, 12-Feb-2015.) $)
    pcopt2 $p |- ( ( F e. ( II Cn J ) /\ ( F ` 1 ) = Y )
                  -> ( F ( *p ` J ) P ) ( ~=ph ` J ) F ) $=
      ( vx vy cii co wcel c1 cfv wceq wa cc0 c2 cle cmul a1i cr vz cpco cicc cv
      ccn cdiv wbr cif cmpt ccom cphtpc cmin wn csn cxp fveq1i cuni simpr iiuni
      wf eqid cnf adantr 1elunit ffvelrn sylancl eqeltrrd iihalf2 syl fvconst2g
      elii2 syl2an syl5eq simplr eqtr4d anassrs mpteq2dva simpl ctopon w3a ctop
      ifeq2da cntop2 toptopon sylib pcoptcl syl2anc simp1d pcoval iftrue adantl
      elii1 iihalf1 sylbir eqeltrd iffalse syl6eqel pm2.61d1 eqidd feqmptd fvif
      fveq2 syl6eq fmptco 3eqtr4d iitopon cnmptid 0elunit cnmptc cioo crn crest
      ex ctg dfii2 0re rehalfcli halfgt0 ltleii halflt1 elicc2i mpbir3an simprl
      1re oveq2d 2cn 2ne0 recidi wss retopon mp2an resttopon cnmpt1st iihalf1cn
      iccssre oveq2 cnmpt21 breq1 fvmpt mp1i cnmpt2c cnmpt2pc ifbieq12d cnmpt12
      id syl6eqbr mul01i eqtrd c0ex clt ltnlei mpbi mtbiri 1ex reparpht eqbrtrd
      ) BHCUEIZJZKBLZDMZNZBACUBLIZBFOKUCIZFUDZKPUFIZQUGZPUVDRIZKUHZUIZUJZBCUKLU
      VAFUVCUVFUVGBLZUVGKULIZALZUHZUIFUVCUVFUVKUUSUHZUIUVBUVJUVAFUVCUVNUVOUVAUV
      DUVCJZNUVFUVMUUSUVKUVAUVPUVFUMZUVMUUSMUVAUVPUVQNZNZUVMDUUSUVSUVMUVLUVCDUN
      UOZLZDUVLAUVTEUPUVADCUQZJZUVLUVCJZUWADMUVRUVAUUSDUWBUURUUTURUVAUVCUWBBUTZ
      KUVCJZUUSUWBJUURUWEUUTBHCUVCUWBUSUWBVAZVBVCZVDUVCUWBKBVEVFVGZUVRUVDUVEKUC
      IZJUWDUVDVKUVDVHVIUVCDUVLUWBVJVLVMUURUUTUVRVNVOVPWBVQUVAFBACUURUUTVRZUVAA
      UUQJZOALDMZKALDMZUVACUWBVSLJZUWCUWLUWMUWNVTUVACWAJZUWOUURUWPUUTBHCWCVCCUW
      BUWGWDWEUWIACUWBDEWFWGWHWIUVAFGUVCUVCUVHGUDZBLZUVOUVIBUVPUVHUVCJZUVAUVPUV
      FUWSUVPUVFUWSUVPUVFNZUVHUVGUVCUVFUVHUVGMZUVPUVFUVGKWJZWKUWTUVDOUVEUCIZJUV
      GUVCJUVDWLUVDWMWNWOXMUVQUVHKUVCUVFUVGKWPZVDWQWRWKUVAUVIWSUVAGUVCUWBBUWHWT
      UWQUVHMUWRUVHBLUVOUWQUVHBXBUVFUVGKBXAXCXDXEUVABUVICUWKUVAFGUAUVDOUWQUVEQU
      GZPUWQRIZKUHZUVHHHHHUVCUVCUVCHUVCVSLJUVAXFSZUVAFHUVCUXHXGUVAFOHHUVCUVCUXH
      UXHOUVCJZUVAXHSXIUXHUXHUVAGUAOUVEKUXFXJXKXNLZKHHUXJUXCXLIZUXJUWJXLIZHUVCU
      XJVAUXKVAZUXLVAXOOTJZUVAXPSKTJZUVAYDSUVEUVCJZUVAUXPUVETJZOUVEQUGUVEKQUGKY
      DXQZOUVEXPUXRXRXSZUVEKUXRYDXTXSOKUVEXPYDYAYBSUXHUVAUWQUVEMZUAUDZUVCJZNNZU
      XFPUVERIKUYCUWQUVEPRUVAUXTUYBYCYEPYFYGYHXCUVAGUAFUWQUVGUXFUXKHUXKHUXCUVCU
      XCUXKUXCVSLJZUVAUXJTVSLJZUXCTYIZUYDYJUXNUXQUYFXPUXROUVEYOYKUXCUXJTYLYKSZU
      XHUVAGUAUXKHUXCUVCUYGUXHYMUYGFUXCUVGUIUXKHUEIJUVAFUXKUXMYNSUVDUWQPRYPYQUV
      AGUAKUXLHHUWJUVCUVCUXLUWJVSLJZUVAUYEUWJTYIZUYHYJUXQUXOUYIUXRYDUVEKYOYKUWJ
      UXJTYLYKSUXHUXHUWFUVAVDSUUAUUBUWQUVDMZUXGUVHMUYAOMUYJUXEUVFUXFKUVGKUWQUVD
      UVEQYRUWQUVDPRYPUYJKWSUUCVCUUDUXIOUVILOMUVAXHFOUVHOUVCUVIUVDOMZUVHUVGOUYK
      UVFUXAUYKUVDOUVEQUYKUUEUXSUUFUXBVIUYKUVGPORIOUVDOPRYPPYFUUGXCUUHUVIVAZUUI
      YSYTUWFKUVILKMUVAVDFKUVHKUVCUVIUVDKMZUVQUVHKMUYMUVFKUVEQUGZUVEKUUJUGUYNUM
      XTUVEKUXRYDUUKUULUVDKUVEQYRUUMUXDVIUYLUUNYSYTUUOUUP $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y J $.  $d x y z ph $.
    pcoass.2 $e |- ( ph -> F e. ( II Cn J ) ) $.
    pcoass.3 $e |- ( ph -> G e. ( II Cn J ) ) $.
    pcoass.4 $e |- ( ph -> H e. ( II Cn J ) ) $.
    pcoass.5 $e |- ( ph -> ( F ` 1 ) = ( G ` 0 ) ) $.
    pcoass.6 $e |- ( ph -> ( G ` 1 ) = ( H ` 0 ) ) $.
    pcoass.7 $e |- P = ( x e. ( 0 [,] 1 ) |-> if ( x <_ ( 1 / 2 ) ,
                    if ( x <_ ( 1 / 4 ) , ( 2 x. x ) , ( x + ( 1 / 4 ) ) ) ,
                      ( ( x / 2 ) + ( 1 / 2 ) ) ) ) $.
    $( Order of concatenation does not affect homotopy class.  (Contributed by
       Jeff Madsen, 19-Jun-2010.)  (Proof shortened by Mario Carneiro,
       8-Jun-2014.) $)
    pcoass $p |- ( ph -> ( ( F ( *p ` J ) G ) ( *p ` J ) H ) ( ~=ph ` J )
                    ( F ( *p ` J ) ( G ( *p ` J ) H ) ) ) $=
      ( co cc0 c1 c2 wcel wceq a1i vy vz cfv cicc cv cdiv cle wbr c4 cmul caddc
      cif cmpt wa iftrue fveq2d adantl cc 2cn cr 0re 1re elicc2i simp1bi adantr
      cmin recnd sylancr simp2bi ax-mp syl3anbrc 2rp recni oveq2i eqtri 2halves
      2ne0 iccdili eqeltrd pcocn pcoval1 eqtr4d sylan2 anassrs eqtrd wn sylancl
      syl clt 2re 4pos mpbi ltleii ax-1cn pcoval2 syl2anc syl6eq oveq1d iffalse
      4re 3eqtrd 3eqtr4d pm2.61dan halflt1 mpbir3an 1elunit iccss2 mp2an oveq2d
      wss eqid cii ccn ctopon cnmptid cnmptc crest simprl ltnlei mtbiri retopon
      wf dfii2 cxr mp3an iccssre resttopon cnmpt1st ctop oveq2 cnmpt21 cnmpt12f
      cvv sseldi cnmptre oveq1 cnmpt2pc breq1 ifbieq12d iiuni cpco cphtpc simpr
      ccom mulcom cn 4nn nnrecre mul02i 2timesi wne recdiv2 mp4an 2t2e4 oveq12i
      rehalfcli eqtr3i mulcomli adantlr simplll ad2antlr letric orcanai readdcl
      simplr leadd1dd syl5eqbrr simp3bi 2lt4 2pos ltrecii le2addd syl6breq pco0
      adddid syl5eqr pnpcan2d divcan1i subidi 1mhlfehlf iccshftli subdid recidi
      remulcl elii2 halfgt0 sseli div0i icccntri addid2i iccshftri 3syl divdird
      wo peano2cn divcan2d eqtr3d pncan mpteq2dva wral iitopon 0elunit cioo crn
      ctg addcomi breq1d recgt0ii 3eqtr4a rexri lbicc2 sstri retop ovex restabs
      0xr eqcomi iihalf1cn cnmpt1res ccnfld ctopn unitssre cnfldtopon ctx addcn
      divccn equcoms eqcomd cnmpt12 syl5eqel cnf fmpt sylibr cuni feqmptd fveq2
      fmptcof pcoval 3eqtr4rd syl6eqbr mul01i c0ex fvmpt 1ex reparpht eqbrtrd
      id ) ADEGUUAUCZNZFVUHNZDEFVUHNZVUHNZCUUDZVULGUUBUCABOPUDNZBUEZPQUFNZUGUHZ
      VUOPUIUFNZUGUHZQVUOUJNZVUOVURUKNZULZVUOQUFNZVUPUKNZULZVULUCZUMBVUNVUQVUTV
      UIUCZVUTPVFNFUCZULZUMVUMVUJABVUNVVFVVIAVUOVUNRZUNZVUQVVFVVISVVKVUQUNZVVBV
      ULUCZVVGVVFVVIVVLVUSVVMVVGSZVVKVUSVVNVUQVVKVUSUNVVMVUTVULUCZVVGVUSVVMVVOS
      VVKVUSVVBVUTVULVUSVUTVVAUOZUPUQAVVJVUSVVOVVGSZVVJVUSUNZAVUTOVUPUDNZRZVVQV
      VRVUTVUOQUJNZVVSVVRQURRZVUOURRZVUTVWASZUSVVRVUOVVJVUOUTRZVUSVVJVWEOVUOUGU
      HZVUOPUGUHZOPVUOVAVBVCZVDZVEZVGQVUOUUEZVHVVRVUOOVURUDNZRZVWAVVSRVVRVWEVWF
      VUSVWMVWJVVJVWFVUSVVJVWEVWFVWGVWHVIVEVVJVUSUUCOVURVUOVAUIUUFRVURUTRZUUGUI
      UUHVJZVCVKOVUROVUPQVUOVAVWOVLQUSUUIQVURVUPUSVURVWOVMZQVURUJNZVURVURUKNZVU
      PVURVWPUUJZVUPQUFNZVWTUKNZVWRVUPVWTVURVWTVURUKVWTPQQUJNZUFNZVURVWBQOUUKZV
      WBVXDVWTVXCSUSVQUSVQQQUULUUMVXBUIPUFUUNVNVOZVXEUUOVUPURRZVXAVUPSVUPPVBUUP
      ZVMZVUPVPVJUUQZVOZUURZVRWHVSAVVTUNVVOQVUTUJNZDUCVVGADVUKGVUTHAEFGIJLVTZWA
      ADEGVUTHIWAWBWCWDWEUUSVVLVUSWFZUNZVVAVULUCZVXLPVFNZEUCZVVMVVGVXOVXPQVVAUJ
      NZPVFNZVUKUCZVUTVUPVFNZVUKUCZVXRVXOAVVAVUPPUDNZRZVXPVYASAVVJVUQVXNUUTZVXO
      VUOVURVUPUDNZRZVYEVXOVWEVURVUOUGUHZVUQVYHVVLVWEVXNVVJVWEAVUQVWIUVAZVEZVVL
      VUSVYIVVLVWEVWNVUSVYIUWNVYJVWOVUOVURUVBWGUVCVVKVUQVXNUVEVURVUPVUOVWOVXGVC
      ZVKZVYHVVAUTRZVUPVVAUGUHVVAPUGUHVYEVYHVWEVWNVYNVYHVWEVYIVUQVYLVDZVWOVUOVU
      RUVDWGVYHVUPVWRVVAUGVXIVYHVURVUOVURVWNVYHVWOTZVYOVYPVYHVWEVYIVUQVYLVIUVFU
      VGVYHVVAVUPVUPUKNZPUGVYHVUOVURVUPVUPVYOVYPVUPUTRZVYHVXGTZVYSVYHVWEVYIVUQV
      YLUVHVURVUPUGUHZVYHVURVUPVWOVXGQUIWIUHVURVUPWIUHZUVIQUIWJWTUVJWKUVKWLZWMZ
      TUVLPURRZVYQPSWNPVPVJZUVMVUPPVVAVXGVBVCVKZWHADVUKGVVAHVXMAPDUCOEUCOVUKUCK
      AEFGIJUVNWBZWOWPVXOVXTVYBVUKVXOVXTVUTVUPUKNZVYQVFNZVYBVXOVXTVXSVYQVFNWUIV
      YQPVXSVFWUEVNVXOVXSWUHVYQVFVXOVXSVUTVWQUKNWUHVXOQVUOVURVWBVXOUSTZVXOVUOVY
      KVGZVURURRVXOVWPTUVOVWQVUPVUTUKVXJVNWQWRUVPVXOVUTVUPVUPVXOVUTVXOQUTRVWEVU
      TUTRWJVYKQVUOUWDVHVGZVXFVXOVXHTZWUMUVQWEUPVXOVYCQVYBUJNZEUCZVXRVXOAVYBVVS
      RZVYCWUOSVYFVXOVUTVYDRZWUPVXOVUTVWAVYDVXOVWBVWCVWDUSWUKVWKVHVXOVYHVWAVYDR
      VYMVURVUPVUPPQVUOVWOVXGVLVXKPQWNUSVQUVRVRWHVSZVUPPOVUPVUPVUTVXGVBVXGVUPVX
      HUVSUVTUWAWHAEFGVYBIJWAWPVXOWUNVXQEVXOWUNVXLQVUPUJNZVFNVXQVXOQVUTVUPWUJWU
      LWUMUWBWUSPVXLVFQUSVQUWCVNWQUPWEXAVXNVVMVXPSVVLVXNVVBVVAVULVUSVUTVVAWSUPU
      QVXOAWUQVVGVXRSVYFWURADEGVUTHIKWOWPXBXCVUQVVFVVMSVVKVUQVVEVVBVULVUQVVBVVD
      UOZUPUQVUQVVIVVGSVVKVUQVVGVVHUOUQXBVVKVUQWFZUNVVDVULUCZVVHVVFVVIAVVJWVAWV
      BVVHSZVVJWVAUNAVUOVYDRZWVCVUOUWEAWVDUNWVBQVVDUJNZPVFNZVUKUCZVUOVUKUCZVVHW
      VDAVVDVYDRZWVBWVGSWVDVVJVVCVVSRWVIVYDVUNVUOVUPVUNRZPVUNRZVYDVUNXJWVJVYROV
      UPUGUHZVUPPUGUHVXGOVUPVAVXGUWFWMZVUPPVXGVBXDWMOPVUPVAVBVCXEZXFOPVUPPXGXHZ
      UWGOPOVUPQVUOVAVBVLQUSVQUWHVUPXKUWIOVUPVUPPVUPVVCVAVXGVXGVUPVXHUWJWUEUWKU
      WLZADVUKGVVDHVXMWUGWOWCWVDWVGWVHSAWVDWVFVUOVUKWVDWVFVUOPUKNZPVFNZVUOWVDWV
      EWVQPVFWVDQWVQQUFNZUJNWVEWVQWVDWVSVVDQUJWVDVUOPQWVDVUOWVDVWEVUPVUOUGUHVWG
      VUPPVUOVXGVBVCVDVGZWUDWVDWNTVWBWVDUSTZVXDWVDVQTZUWMXIWVDWVQQWVDVWCWVQURRW
      VTVUOUWOWHWWAWWBUWPUWQWRWVDVWCWUDWVRVUOSWVTWNVUOPUWRWGWEUPUQAEFGVUOIJLWOX
      AWCWDWVAVVFWVBSVVKWVAVVEVVDVULVUQVVBVVDWSZUPUQWVAVVIVVHSVVKVUQVVGVVHWSUQX
      BXCUWSABUAVUNVUNVVEUAUEZVULUCVVFCVULAVUNVUNCYBZVVEVUNRBVUNUWTACXLXLXMNZRW
      WEACBVUNVVEUMZWWFMABUAUBVUOOWWDVUPUGUHZWWDVURUGUHZQWWDUJNZWWDVURUKNZULZWW
      DQUFNZVUPUKNZULZVVEXLXLXLXLVUNVUNVUNXLVUNXNUCRAUXATZABXLVUNWWPXOABOXLXLVU
      NVUNWWPWWPOVUNRZAUXBTZXPWWPWWPAUAUBOVUPPWWLUXCUXDUXEUCZWWNXLXLWWSVVSXQNZW
      WSVYDXQNZXLVUNWWSXKZWWTXKZWXAXKZYCOUTRZAVATZPUTRZAVBTWVJAWVNTWWPAWWDVUPSZ
      UBUEZVUNRZUNUNZWWKVURVUPUKNZWWLWWNWXKWWKVUPVURUKNWXLWXKWWDVUPVURUKAWXHWXJ
      XRZWRVUPVURVXHVWPUXFWQWXKWWIWFWWLWWKSWXKWWIVUPVURUGUHZWUAWXNWFWUBVURVUPVW
      OVXGXSWLWXKWWDVUPVURUGWXMUXGXTWWIWWJWWKWSWHWXKWWMVURVUPUKWXKWWMVWTVURWXKW
      WDVUPQUFWXMWRVXEWQWRXBAUAUBOVURVUPWWJWWSWWKXLXLWWSVWLXQNZWWSVYGXQNZWWTVUN
      WXBWXOXKWXPXKZWXCWXFVYRAVXGTVURVVSRZAWXRVWNOVURUGUHVYTVWOOVURVAVWOUIWTWKU
      XHWMZWUCOVUPVURVAVXGVCXEZTWWPAWWDVURSZWXJUNUNZVWQVWRWWJWWKVWSWYBWWDVURQUJ
      AWYAWXJXRZXIWYBWWDVURVURUKWYCWRUXIAUAUBBWWDVUTWWJWXOXLWXOXLVWLVUNVWLWXOVW
      LXNUCRZAWWSUTXNUCRZVWLUTXJWYDYAVWLVVSUTOVVSRZWXRVWLVVSXJZOYDRVUPYDRWVLWYF
      UXPVUPVXGUXJWVMOVUPUXKYEWXTOVUPOVURXGXHZWXEVYRVVSUTXJZVAVXGOVUPYFXHZUXLVW
      LWWSUTYGXHTZWWPAUAUBWXOXLVWLVUNWYKWWPYHWYKABVUTWWTWXOXLVVSVWLWWTVWLXQNZWX
      OWWSYIRWYGVVSYMRWYLWXOSUXMWYHOVUPUDUXNVWLVVSWWSYIYMUXOYEUXQWWTVVSXNUCRZAW
      YEWYIWYMYAWYJVVSWWSUTYGXHTWYGAWYHTBVVSVUTUMWWTXLXMNRABWWTWXCUXRTUXSVUOWWD
      QUJYJZYKAUAUBBWWDVVAWWKWXPXLWXPXLVYGVUNVYGWXPVYGXNUCRZAWYEVYGUTXJZWYOYAVW
      NVYRWYPVWOVXGVURVUPYFXHZVYGWWSUTYGXHTZWWPAUAUBWXPXLVYGVUNWYRWWPYHWYRABVYG
      VUNUXTUYAUCZVVAWXPXLWYSXKZWXQYCWYPAWYQTVUNUTXJAUYBTZVYHVVAVUNRAVYHVYDVUNV
      VAWVOWUFYNUQABVUOVURUKWYSWYSWYSWYSURWYSURXNUCRAWYSWYTUYCTZABWYSURXUBXOABV
      URWYSWYSURURXUBXUBAVURVWNAVWOTVGXPUKWYSWYSUYDNWYSXMNRAWYSWYTUYETZYLYOVUOW
      WDVURUKYPZYKYQAUAUBBWWDVVDWWNWXAXLWXAXLVYDVUNVYDWXAVYDXNUCRZAWYEVYDUTXJZX
      UEYAVYRWXGXUFVXGVBVUPPYFXHZVYDWWSUTYGXHTZWWPAUAUBWXAXLVYDVUNXUHWWPYHXUHAB
      VYDVUNWYSVVDWXAXLWYTWXDYCXUFAXUGTXUAWVDVVDVUNRAWVDVYDVUNVVDWVOWVPYNUQABVV
      CVUPUKWYSWYSWYSWYSURXUBBURVVCUMWYSWYSXMNRZAVWBVXDXUIUSVQBQWYSWYTUYFXHTABV
      UPWYSWYSURURXUBXUBVXFAVXHTXPXUCYLYOVUOWWDSZVVCWWMVUPUKVUOWWDQUFYPWRZYKYQW
      WDVUOSZWXIOSZUNVVEWWOXULVVEWWOSZXUMXUNBUAXUJVUQWWHVVBVVDWWLWWNVUOWWDVUPUG
      YRXUJVUSWWIVUTVVAWWJWWKVUOWWDVURUGYRWYNXUDYSXUKYSUYGVEUYHUYIUYJZCXLXLVUNV
      UNYTYTUYKWHBVUNVUNVVECMUYLUYMCWWGSAMTAUAVUNGUYNZVULAVULXLGXMNRVUNXUPVULYB
      ADVUKGHVXMWUGVTZVULXLGVUNXUPYTXUPXKUYKWHUYOWWDVVEVULUYPUYQABVUIFGADEGHIKV
      TJUYRUYSAVULCGXUQXUOAWWQOCUCOSWWRBOVVEOVUNCVUOOSZVVEVVBVUTOXURVUQVVEVVBSX
      URVUOOVUPUGXURVUGZWVMUYTWUTWHXURVUSVVBVUTSXURVUOOVURUGXUSWXSUYTVVPWHXURVU
      TQOUJNOVUOOQUJYJQUSVUAWQXAMVUBVUCWHAWVKPCUCPSWVKAXFTBPVVEPVUNCVUOPSZVVEVV
      DPXUTWVAVVEVVDSXUTVUQPVUPUGUHZVUPPWIUHXVAWFXDVUPPVXGVBXSWLVUOPVUPUGYRXTWW
      CWHXUTVVDVYQPXUTVVCVUPVUPUKVUOPQUFYPWRWUEWQWEMVUDVUCWHVUEVUF $.
  $}

  ${
    $d s t x y F $.  $d s t y G $.  $d y H $.  $d s t x y J $.  $d s t x y P $.
    pcorev.1 $e |- G = ( x e. ( 0 [,] 1 ) |-> ( F ` ( 1 - x ) ) ) $.
    $( Closure for a reversed path.  (Contributed by Mario Carneiro,
       12-Feb-2015.) $)
    pcorevcl $p |- ( F e. ( II Cn J ) ->
    ( G e. ( II Cn J ) /\ ( G ` 0 ) = ( F ` 1 ) /\ ( G ` 1 ) = ( F ` 0 ) ) ) $=
      ( cii ccn co wcel cc0 cfv c1 wceq cmin cmpt a1i oveq2 syl6eq fveq2d fvex
      cicc cv ctopon iitopon iirevcn id cnmpt11f syl5eqel 0elunit subid1i fvmpt
      ax-1cn mp1i 1elunit 1m1e0 3jca ) BFDGHZIZCUQIJCKLBKZMZLCKJBKZMZURCAJLUAHZ
      LAUBZNHZBKZOUQEURAVEBFFDVCFVCUCKIURUDPAVCVEOFFGHIURAUEPURUFUGUHJVCIUTURUI
      AJVFUSVCCVDJMZVELBVGVELJNHLVDJLNQLULUJRSELBTUKUMLVCIVBURUNALVFVAVCCVDLMZV
      EJBVHVELLNHJVDLLNQUORSEJBTUKUMUP $.

    pcorev.2 $e |- P = ( ( 0 [,] 1 ) X. { ( F ` 1 ) } ) $.
    ${
      pcorevlem.3 $e |- H = ( s e. ( 0 [,] 1 ) , t e. ( 0 [,] 1 ) |->
                           ( F ` if ( s <_ ( 1 / 2 ) ,
              ( 1 - ( ( 1 - t ) x. ( 2 x. s ) ) ) ,
              ( 1 - ( ( 1 - t ) x. ( 1 - ( ( 2 x. s ) - 1 ) ) ) ) ) ) ) $.
      $( Lemma for ~ pcorev .  Prove continuity of the homotopy function.
         (Contributed by Jeff Madsen, 11-Jun-2010.)  (Proof shortened by Mario
         Carneiro, 8-Jun-2014.) $)
      pcorevlem $p |- ( F e. ( II Cn J ) ->
        ( H e. ( ( G ( *p ` J ) F ) ( PHtpy ` J ) P ) /\
          ( G ( *p ` J ) F ) ( ~=ph ` J ) P ) ) $=
        ( cii co wcel cfv cc0 c1 cmin wceq cmul ccn cpco cphtpy cphtpc wbr cicc
        vy cv cmpt ctopon iitopon iirevcn cnmpt11f syl5eqel 1elunit oveq2 1m1e0
        a1i id syl6eq fveq2d fvex fvmpt mp1i cuni w3a ctop cntop2 eqid toptopon
        pcocn sylib wf iiuni cnf ffvelrn sylancl pcoptcl syl2anc simp1d c2 cdiv
        cle cif cmpt2 ctx cioo crn ctg crest dfii2 cr 0re 1re rehalfcli halfgt0
        ltleii halflt1 elicc2i wa oveq2d 2cn oveq1d ax-1cn eqtr4d retopon mp2an
        wss iccssre resttopon cnmpt2nd cnmpt21 oveq12 cnmpt22 weq simpr 0elunit
        cnmpt1st simpl breq1d oveq12d ifbieq12d ovmpt2a iftrue unitssre mulid2d
        adantl sseli recnd syl eqtrd anassrs wn iffalse cc subcl sylancr mul02d
        mpan sylan9eqr mpbir3an simprl 2ne0 subid1i iihalf1cn iimulcn iihalf2cn
        recidi cnmpt2pc cnmpt21f elii1 pcoval1 iihalf1 sylan2br pcoval2 iihalf2
        elii2 nncan eqtr2d sylan2 pm2.61dan mulcl ifeq12d ifid csn cxp fvconst2
        fveq1i syl5eq 3eqtr4d syl6eqbr mul01i mul01d pco0 ax-mp clt ltnlei mpbi
        syl6req mtbiri mulid1i 2m1e1 pco1 eqcomd isphtpy2d c0 isphtpc syl3anbrc
        wne ne0i jca ) DLGUAMZNZFEDGUBOMZCGUCOMZNZUWNCGUDOUEZUWMUWNCFGUGUWMEDGU
        WMEAPQUFMZQAUHZRMZDOZUIUWLIUWMAUWTDLLGUWRLUWRUJONUWMUKURZAUWRUWTUILLUAM
        NUWMAULURZUWMUSZUMUNZUXDQUWRNZQEOPDOZSUWMUOAQUXAUXGUWREUWSQSZUWTPDUXHUW
        TQQRMZPUWSQQRUPUQUTVAIPDVBVCVDZVKZUWMCUWLNZPCOQDOZSZQCOUXMSZUWMGGVEZUJO
        NZUXMUXPNZUXLUXNUXOVFUWMGVGNUXQDLGVHGUXPUXPVIZVJVLUWMUWRUXPDVMUXFUXRDLG
        UWRUXPVNUXSVOUOUWRUXPQDVPVQCGUXPUXMJVRVSVTZUWMFHBUWRUWRHUHZQWAWBMZWCUEZ
        QQBUHZRMZWAUYATMZTMZRMZQUYEQUYFQRMZRMZTMZRMZWDZDOZWELLWFMZGUAMKUWMHBUYM
        DLLLGUWRUWRUXBUXBUWMHBPUYBQUYHWGWHWIOZUYLLLUYPPUYBUFMZWJMZUYPUYBQUFMZWJ
        MZLUWRUYPVIUYRVIZUYTVIZWKPWLNZUWMWMURQWLNZUWMWNURUYBUWRNZUWMVUEUYBWLNZP
        UYBWCUEUYBQWCUEQWNWOZPUYBWMVUGWPWQZUYBQVUGWNWRWQPQUYBWMWNWSUUAURUXBUWMU
        YAUYBSZUYDUWRNZWTWTZUYGUYKQRVUKUYFUYJUYETVUKUYFQUYJVUKUYFWAUYBTMQVUKUYA
        UYBWATUWMVUIVUJUUBXAWAXBUUCUUHUTZVUKUYJQPRMZQVUKUYIPQRVUKUYIUXIPVUKUYFQ
        QRVULXCUQUTXAQXDUUDZUTXEXAXAUWMHBAUYGUWTUYHUYRLLLUYQUWRUWRUYRUYQUJONZUW
        MUYPWLUJONZUYQWLXHZVUOXFVUCVUFVUQWMVUGPUYBXIXGUYQUYPWLXJXGURZUXBUWMHBAU
        GUYEUYFUWSUGUHZTMZUYGUYRLLLLUWRUYQUWRUWRVURUXBUWMHBAUYDUWTUYEUYRLLLUYQU
        WRUWRVURUXBUWMHBUYRLUYQUWRVURUXBXKUXBUXCUWSUYDQRUPZXLUWMHBAUYAWAUWSTMZU
        YFUYRLUYRLUYQUWRUYQVURUXBUWMHBUYRLUYQUWRVURUXBXRVURAUYQVVBUIUYRLUAMNUWM
        AUYRVUAUUEURUWSUYAWATUPZXLUXBUXBAUGUWRUWRVUTWEUYOLUAMNUWMAUGUUFURZUWSUY
        EVUSUYFTXMXNUXBUXCUWSUYGQRUPXLUWMHBAUYKUWTUYLUYTLLLUYSUWRUWRUYTUYSUJONZ
        UWMVUPUYSWLXHZVVEXFVUFVUDVVFVUGWNUYBQXIXGUYSUYPWLXJXGURZUXBUWMHBAUGUYEU
        YJVUTUYKUYTLLLLUWRUYSUWRUWRVVGUXBUWMHBAUYDUWTUYEUYTLLLUYSUWRUWRVVGUXBUW
        MHBUYTLUYSUWRVVGUXBXKUXBUXCVVAXLUWMHBAUYIUWTUYJUYTLLLUYSUWRUWRVVGUXBUWM
        HBAUYAVVBQRMZUYIUYTLUYTLUYSUWRUYSVVGUXBUWMHBUYTLUYSUWRVVGUXBXRVVGAUYSVV
        HUIUYTLUAMNUWMAUYTVUBUUGURAHXOVVBUYFQRVVCXCXLUXBUXCUWSUYIQRUPXLUXBUXBVV
        DUWSUYEVUSUYJTXMXNUXBUXCUWSUYKQRUPXLUUIUXDUUJUNUWMVUSUWRNZWTZVUSPFMZVUS
        UYBWCUEZQQWAVUSTMZTMZRMZQQQVVMQRMZRMZTMZRMZWDZDOZVUSUWNOZVVJVVIPUWRNZVV
        KVWASUWMVVIXPZXQHBVUSPUWRUWRUYNVWAFHUGXOZUYDPSZWTZUYMVVTDVWGUYCVVLUYHUY
        LVVOVVSVWGUYAVUSUYBWCVWEVWFXSZXTVWGUYGVVNQRVWGUYEQUYFVVMTVWGUYEVUMQVWGU
        YDPQRVWEVWFXPXAVUNUTZVWGUYAVUSWATVWHXAZYAXAVWGUYKVVRQRVWGUYEQUYJVVQTVWI
        VWGUYIVVPQRVWGUYFVVMQRVWJXCXAYAXAYBVAKVVTDVBYCVQVVJVVLVWAVWBSVVJVVLWTZV
        WAVVODOZVWBVWKVVTVVODVVLVVTVVOSVVJVVLVVOVVSYDYGVAUWMVVIVVLVWBVWLSZVVIVV
        LWTUWMVUSUYQNZVWMVUSUUKUWMVWNWTZVWBVVMEOZVWLUWMEDGVUSUXEUXDUULVWOVVMUWR
        NZVWPVWLSVWNVWQUWMVUSUUMYGVWQVWPQVVMRMZDOZVWLAVVMUXAVWSUWREUWSVVMSUWTVW
        RDUWSVVMQRUPVAIVWRDVBVCVWQVVOVWRDVWQVVNVVMQRVWQVVMVWQVVMUWRWLVVMYEYHYIY
        FXAVAXEYJYKUUNYLXEVVJVVLYMZWTZVWAVVSDOZVWBVXAVVTVVSDVWTVVTVVSSVVJVVLVVO
        VVSYNYGVAUWMVVIVWTVWBVXBSZVVIVWTWTUWMVUSUYSNZVXCVUSUUQUWMVXDWTZVWBVVPDO
        VXBUWMEDGVUSUXEUXDUXJUUOVXEVVPVVSDVXEVVPUWRNZVVPVVSSVXDVXFUWMVUSUUPYGVX
        FVVSQVVQRMZVVPVXFVVRVVQQRVXFVVQVXFQYONZVVPYONZVVQYONZXDVXFVVPUWRWLVVPYE
        YHYIZQVVPYPZYQYFXAVXFVXHVXIVXGVVPSXDVXKQVVPUURYQUUSYJVAYKUUTYLXEUVAYKVV
        JVVLQPVVMTMZRMZQPVVQTMZRMZWDZDOZUXMVUSQFMZVUSCOZVVJVXQQDVVJVXQVVLQQWDQV
        VJVVLVXNQVXPQVVJVXNVUMQVVJVXMPQRVVJVVMVVIVVMYONZUWMVVIWAYONVUSYONZVYAXB
        VVIVUSUWRWLVUSYEYHYIZWAVUSUVBYQYGZYRXAVUNUTVVJVXPVUMQVVJVXOPQRVVJVVQVVJ
        VXHVXIVXJXDVVJVYAVXHVXIVYDXDVVMQYPVQVXLYQYRXAVUNUTUVCVVLQUVDUTVAVVJVVIU
        XFVXSVXRSVWDUOHBVUSQUWRUWRUYNVXRFVWEUYDQSZWTZUYMVXQDVYFUYCVVLUYHUYLVXNV
        XPVYFUYAVUSUYBWCVWEVYEXSZXTVYFUYGVXMQRVYFUYEPUYFVVMTVYFUYEUXIPVYFUYDQQR
        VWEVYEXPXAUQUTZVYFUYAVUSWATVYGXAZYAXAVYFUYKVXOQRVYFUYEPUYJVVQTVYHVYFUYI
        VVPQRVYFUYFVVMQRVYIXCXAYAXAYBVAKVXQDVBYCVQVVJVXTVUSUWRUXMUVEUVFZOZUXMVU
        SCVYJJUVHVVIVYKUXMSUWMUWRUXMVUSQDVBZUVGYGUVIUVJVVIUWMPVUSFMZUXMPUWNOZVV
        IVYMQQVUSRMZPTMZRMZDOZUXMVWCVVIVYMVYRSXQHBPVUSUWRUWRUYNVYRFUYAPSZBUGXOZ
        WTZUYMVYQDWUAUYMUYHVYQWUAUYCUYMUYHSWUAUYAPUYBWCVYSVYTXSZVUHUVKUYCUYHUYL
        YDYJWUAUYGVYPQRWUAUYEVYOUYFPTWUAUYDVUSQRVYSVYTXPXAWUAUYFWAPTMPWUAUYAPWA
        TWUBXAWAXBUVLUTYAXAYKVAKVYQDVBZYCYSVVIVYQQDVVIVYQVUMQVVIVYPPQRVVIVYOVVI
        VXHVYBVYOYONXDVYCQVUSYPYQUVMXAVUNUTVAZYKUWMVYNPEOZUXMUWMEDGUXEUXDUVNVWC
        WUEUXMSXQAPUXAUXMUWREUWSPSZUWTQDWUFUWTVUMQUWSPQRUPVUNUTVAIVYLVCUVOUVSYT
        VVIUWMQVUSFMZUXMQUWNOZVVIWUGVYRUXMUXFVVIWUGVYRSUOHBQVUSUWRUWRUYNVYRFUYA
        QSZVYTWTZUYMVYQDWUJUYMUYLVYQWUJUYCYMUYMUYLSWUJUYCQUYBWCUEZUYBQUVPUEWUKY
        MWRUYBQVUGWNUVQUVRWUJUYAQUYBWCWUIVYTXSZXTUVTUYCUYHUYLYNYJWUJUYKVYPQRWUJ
        UYEVYOUYJPTWUJUYDVUSQRWUIVYTXPXAWUJUYJUXIPWUJUYIQQRWUJUYIWAQRMQWUJUYFWA
        QRWUJUYFWAQTMWAWUJUYAQWATWULXAWAXBUWAUTXCUWBUTXAUQUTYAXAYKVAKWUCYCYSWUD
        YKUWMWUHUXMUWMEDGUXEUXDUWCUWDYTUWEZUWMUWNUWLNUXLUWOUWFUWIZUWQUXKUXTUWMU
        WPWUNWUMUWOFUWJYJUWNCGUWGUWHUWK $.
    $}

    $( Concatenation with the reverse path.  (Contributed by Jeff Madsen,
       19-Jun-2010.)  (Revised by Mario Carneiro, 20-Dec-2013.) $)
    pcorev $p |- ( F e. ( II Cn J ) -> ( G ( *p ` J ) F ) ( ~=ph ` J ) P ) $=
      ( vs vt cii ccn co wcel c1 cv c2 wbr cmin cmul cfv cc0 cicc cle cif cmpt2
      cdiv cpco cphtpy cphtpc eqid pcorevlem simprd ) CJEKLMHIUANUBLZUMHOZNPUFL
      UCQNNIORLZPUNSLZSLRLNUONUPNRLRLSLRLUDCTUEZDCEUGTLZBEUHTLMURBEUITQAIBCDUQE
      HFGUQUJUKUL $.
  $}

  ${
    $d x y F $.  $d y G $.  $d x y J $.
    pcorev2.1 $e |- G = ( x e. ( 0 [,] 1 ) |-> ( F ` ( 1 - x ) ) ) $.
    pcorev2.2 $e |- P = ( ( 0 [,] 1 ) X. { ( F ` 0 ) } ) $.
    $( Concatenation with the reverse path.  (Contributed by Mario Carneiro,
       12-Feb-2015.) $)
    pcorev2 $p |- ( F e. ( II Cn J ) -> ( F ( *p ` J ) G ) ( ~=ph ` J ) P ) $=
      ( vy cii co wcel cc0 c1 cv cmin cfv cmpt csn wceq eqid ccn cxp cphtpc wbr
      cicc cpco pcorevcl simp1d pcorev syl iiuni cnf feqmptd iirev oveq2 fveq2d
      cuni fvmpt cc ax-1cn cr unitssre sseli recnd nncan sylancr eqtrd mpteq2ia
      fvex syl6reqr oveq1d simp3d sneqd xpeq2d syl6eqr 3brtr3d ) CIEUAJZKZHLMUE
      JZMHNZOJZDPZQZDEUFPZJZVSMDPZRZUBZCDWDJBEUCPZVRDVQKZWEWHWIUDVRWJLDPMCPSZWF
      LCPZSZACDEFUGZUHHWHDWCEWCTWHTUIUJVRWCCDWDVRCHVSVTCPZQWCVRHVSEUQZCCIEVSWPU
      KWPTULUMHVSWBWOVTVSKZWBMWAOJZCPZWOWQWAVSKWBWSSVTUNAWAMANZOJZCPWSVSDWTWASX
      AWRCWTWAMOUOUPFWRCVIURUJWQWRVTCWQMUSKVTUSKWRVTSUTWQVTVSVAVTVBVCVDMVTVEVFU
      PVGVHVJVKVRWHVSWLRZUBBVRWGXBVSVRWFWLVRWJWKWMWNVLVMVNGVOVP $.
  $}

  ${
    $d y F $.  $d x y G $.  $d y H $.  $d x y J $.  $d y P $.  $d y ph $.
    pcophtb.h $e |- H = ( x e. ( 0 [,] 1 ) |-> ( G ` ( 1 - x ) ) ) $.
    pcophtb.p $e |- P = ( ( 0 [,] 1 ) X. { ( F ` 0 ) } ) $.
    pcophtb.f $e |- ( ph -> F e. ( II Cn J ) ) $.
    pcophtb.g $e |- ( ph -> G e. ( II Cn J ) ) $.
    pcophtb.0 $e |- ( ph -> ( F ` 0 ) = ( G ` 0 ) ) $.
    pcophtb.1 $e |- ( ph -> ( F ` 1 ) = ( G ` 1 ) ) $.
    $( The path homotopy equivalence relation on two paths ` F , G ` with the
       same start and end point can be written in terms of the loop ` F - G `
       formed by concatenating ` F ` with the inverse of ` G ` .  Thus, all the
       homotopy information in ` ~=ph `` J ` is available if we restrict our
       attention to closed loops, as in the definition of the fundamental
       group.  (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    pcophtb $p |- ( ph ->
      ( ( F ( *p ` J ) H ) ( ~=ph ` J ) P <-> F ( ~=ph ` J ) G ) ) $=
      ( cfv co wbr cc0 c1 wceq adantr vy cpco cphtpc wa cii ccn wer phtpcer a1i
      cicc csn cxp wcel w3a pcorevcl syl simp2d eqtr4d simp1d pco0 erref pcorev
      eqid pcohtpy pcopt2 syl2anc ertrd cv c2 cdiv cle c4 cmul caddc cif simp3d
      cmpt pcoass eqtrd simpr ertr3d eqcomd pcopt pcorev2 sneqd xpeq2d breqtrrd
      pco1 syl5eq impbida ) ADFGUBNZOZCGUCNZPZDEWMPZAWNUDZDDFEWKOZWKOZEWMUEGUFO
      ZWSWMUGZWPGUHZUIZWPWRDQRUJOZRENZUKULZWKOZDWMWSXBWPDWQDGXEARDNZQWQNZSWNAXG
      QFNZXHAXGXDXIMAFWSUMZXIXDSZRFNZQENZSZAEWSUMZXJXKXNUNKBEFGHUOUPZUQURZAFEGA
      XJXKXNXPUSZKUTURTWPDWMWSXBADWSUMZWNJTZVAAWQXEWMPZWNAXOYAKBXEEFGHXEVCZVBUP
      TVDWPXSXGXDSZXFDWMPXTAYCWNMTXEDGXDYBVEVFVGWPWRCEWKOZEWMWSXBWPWRWLEWKOYDWM
      WSXBWPUAUAXCUAVHZRVIVJOZVKPYERVLVJOZVKPVIYEVMOYEYGVNOVOYEVIVJOYFVNOVOVQZD
      FEGXTAXJWNXRTAXOWNKTZAXGXISZWNXQTAXNWNAXJXKXNXPVPZTYHVCVRWPWLECGEARWLNZXM
      SWNAYLXLXMADFGJXRWHYKVSTAWNVTWPEWMWSXBYIVAVDWAWPXOXMQDNZSYDEWMPYIWPYMXMAY
      MXMSWNLTWBCEGYMIWCVFVGWAAWOUDZWLEFWKOZCWMWSWTYNXAUIZYNDFEGFAYJWOXQTAWOVTY
      NFWMWSYPAXJWOXRTVAVDAYOCWMPWOAYOXCXMUKZULZCWMAXOYOYRWMPKBYREFGHYRVCWDUPAC
      XCYMUKZULYRIAYSYQXCAYMXMLWEWFWIWGTVGWJ $.
  $}

  ${
    $d b j y B $.  $d b f j y J $.  $d b f j y ph $.  $d b f j y Y $.
    $d b j y K $.  $d b j y .+ $.
    om1val.o $e |- O = ( J Om1 Y ) $.
    om1val.b $e |- ( ph -> B =
      { f e. ( II Cn J ) | ( ( f ` 0 ) = Y /\ ( f ` 1 ) = Y ) } ) $.
    om1val.p $e |- ( ph -> .+ = ( *p ` J ) ) $.
    om1val.k $e |- ( ph -> K = ( J ^ko II ) ) $.
    om1val.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    om1val.y $e |- ( ph -> Y e. X ) $.
    $( The definition of the loop space.  (Contributed by Mario Carneiro,
       10-Jul-2015.) $)
    om1val $p |- ( ph -> O = { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( TopSet ` ndx ) , K >. } ) $=
      ( co cfv cop wceq cii vj vy comi cnx cbs cplusg cts ctp ctop cv cc0 c1 wa
      cuni ccn crab cpco cxko cvv cmpt2 df-om1 a1i simprl oveq2d simprr anbi12d
      eqeq2d rabeqbidv adantr eqtr4d opeq2d fveq2d oveq1d tpeq123d unieq adantl
      ctopon wcel toponuni syl topontop tpex ovmpt2dx syl5eq ) AGEIUCPUDUEQZBRZ
      UDUFQZCRZUDUGQZFRZUHZJAUAUBEIUIUAUJZUNZWEUKDUJZQZUBUJZSZULWNQZWPSZUMZDTWL
      UOPZUPZRZWGWLUQQZRZWIWLTURPZRZUHZWKUCHUSUCUAUBUIWMXHUTSAUBDUAVAVBAWLESZWP
      ISZUMZUMZXCWFXEWHXGWJXLXBBWEXLXBWOISZWRISZUMZDTEUOPZUPZBXLWTXODXAXPXLWLET
      UOAXIXJVCZVDXLWQXMWSXNXLWPIWOAXIXJVEZVGXLWPIWRXSVGVFVHABXQSXKKVIVJVKXLXDC
      WGXLXDEUQQZCXLWLEUQXRVLACXTSXKLVIVJVKXLXFFWIXLXFETURPZFXLWLETURXRVMAFYASX
      KMVIVJVKVNAXIUMWMEUNZHXIWMYBSAWLEVOVPAHYBSZXIAEHVQQVRZYCNHEVSVTVIVJAYDEUI
      VRNHEWAVTOWKUSVRAWFWHWJWBVBWCWD $.
  $}

  ${
    $d f F $.  $d f J $.  $d f ph $.  $d f X $.  $d f Y $.
    om1bas.o $e |- O = ( J Om1 Y ) $.
    om1bas.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    om1bas.y $e |- ( ph -> Y e. X ) $.
    ${
      om1bas.b $e |- ( ph -> B = ( Base ` O ) ) $.
      $( The base set of the loop space.  (Contributed by Mario Carneiro,
         10-Jul-2015.) $)
      om1bas $p |- ( ph -> B =
          { f e. ( II Cn J ) | ( ( f ` 0 ) = Y /\ ( f ` 1 ) = Y ) } ) $=
        ( cnx cbs cfv wceq cii ccn co cop eqidd cc0 cv c1 crab cplusg cpco cxko
        wa cts ctp om1val fveq2d eqtrd cvv wcel ovex rabex eqid topgrpbas ax-mp
        syl6eqr ) ABLMNUACUBZNGOUCVBNGOUHZCPDQRZUDZSLUENDUFNZSLUINDPUGRZSUJZMNZ
        VEABEMNVIKAEVHMAVEVFCDVGEFGHAVETAVFTAVGTIJUKULUMVEUNUOVEVIOVCCVDPDQUPUQ
        VEVFVGVHUNVHURUSUTVA $.

      $( Elementhood in the base set of the loop space.  (Contributed by Mario
         Carneiro, 10-Jul-2015.) $)
      om1elbas $p |- ( ph -> ( F e. B <->
          ( F e. ( II Cn J ) /\ ( F ` 0 ) = Y /\ ( F ` 1 ) = Y ) ) ) $=
        ( vf wcel cc0 cfv wceq c1 wa fveq1 eqeq1d cv cii ccn co crab w3a om1bas
        eleq2d anbi12d elrab 3anass bitr4i syl6bb ) ACBMCNLUAZOZGPZQUNOZGPZRZLU
        BDUCUDZUEZMZCUTMZNCOZGPZQCOZGPZUFZABVACABLDEFGHIJKUGUHVBVCVEVGRZRVHUSVI
        LCUTUNCPZUPVEURVGVJUOVDGNUNCSTVJUQVFGQUNCSTUIUJVCVEVGUKULUM $.

      om1addcl.h $e |- ( ph -> H e. B ) $.
      om1addcl.k $e |- ( ph -> K e. B ) $.
      $( Closure of the group operation of the loop space.  (Contributed by
         Jeff Madsen, 11-Jun-2010.)  (Revised by Mario Carneiro,
         5-Sep-2015.) $)
      om1addcl $p |- ( ph -> ( H ( *p ` J ) K ) e. B ) $=
        ( cfv wcel cc0 wceq c1 om1elbas cpco co cii ccn w3a mpbid simp1d simp3d
        simp2d eqtr4d pcocn pco0 eqtrd pco1 mpbir3and ) ACEDUAOUBZBPUPUCDUDUBZP
        QUPOZHRSUPOZHRACEDACUQPZQCOZHRZSCOZHRZACBPUTVBVDUEMABCDFGHIJKLTUFZUGZAE
        UQPZQEOZHRZSEOZHRZAEBPVGVIVKUENABEDFGHIJKLTUFZUGZAVCHVHAUTVBVDVEUHAVGVI
        VKVLUIUJUKAURVAHACEDVFVMULAUTVBVDVEUIUMAUSVJHACEDVFVMUNAVGVIVKVLUHUMABU
        PDFGHIJKLTUO $.
    $}

    $( The group operation (which isn't much more than a magma) of the loop
       space.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    om1plusg $p |- ( ph -> ( *p ` J ) = ( +g ` O ) ) $=
      ( vf cplusg cfv cnx cbs cop cpco cts cii cxko eqidd cvv ctp om1bas om1val
      co fveq2d wcel wceq fvex eqid topgrpplusg ax-mp syl6reqr ) ACJKLMKCMKZNLJ
      KBOKZNLPKBQRUDZNUAZJKZUNACUPJAUMUNIBUOCDEFAUMIBCDEFGHAUMSUBAUNSAUOSGHUCUE
      UNTUFUNUQUGBOUHUMUNUOUPTUPUIUJUKUL $.

    $( The topology of the loop space.  (Contributed by Mario Carneiro,
       10-Jul-2015.) $)
    om1tset $p |- ( ph -> ( J ^ko II ) = ( TopSet ` O ) ) $=
      ( vf cts cfv cnx cbs cop cplusg cpco cii cxko eqidd cvv ctp om1bas om1val
      co fveq2d wcel wceq ovex eqid topgrptset ax-mp syl6reqr ) ACJKLMKCMKZNLOK
      BPKZNLJKBQRUDZNUAZJKZUOACUPJAUMUNIBUOCDEFAUMIBCDEFGHAUMSUBAUNSAUOSGHUCUEU
      OTUFUOUQUGBQRUHUMUNUOUPTUPUIUJUKUL $.

    om1opn.k $e |- K = ( TopOpen ` O ) $.
    om1opn.b $e |- ( ph -> B = ( Base ` O ) ) $.
    $( The topology of the loop space.  (Contributed by Mario Carneiro,
       10-Jul-2015.) $)
    om1opn $p |- ( ph -> K = ( ( J ^ko II ) |`t B ) ) $=
      ( cii cxko co crest cts cfv cbs eqid om1tset oveq12d ctopn topnval eqtr4i
      syl6reqr ) ACMNOZBPOEQRZESRZPOZDAUGUHBUIPACEFGHIJUALUBDEUCRUJKUIUHEUITUHT
      UDUEUF $.
  $}

  ${
    $d j x y J $.  $d x y K $.  $d j y O $.  $d j x y ph $.  $d j y Y $.
    pi1val.g $e |- G = ( J pi1 Y ) $.
    pi1val.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    pi1val.2 $e |- ( ph -> Y e. X ) $.
    ${
      pi1val.o $e |- O = ( J Om1 Y ) $.
      $( The definition of the fundamental group.  (Contributed by Mario
         Carneiro, 11-Feb-2015.)  (Revised by Mario Carneiro, 10-Jul-2015.) $)
      pi1val $p |- ( ph -> G = ( O /s ( ~=ph ` J ) ) ) $=
        ( vj vy cpi1 co cphtpc cfv cqus ctop comi wceq cv cuni cvv cmpt2 df-pi1
        a1i wa simprl simprr oveq12d syl6eqr fveq2d adantl ctopon wcel toponuni
        unieq syl adantr eqtr4d topontop ovex ovmpt2dx syl5eq ) ABCFMNDCOPZQNZG
        AKLCFRKUAZUBZVGLUAZSNZVGOPZQNZVFMEUCMKLRVHVLUDTALKUEUFAVGCTZVIFTZUGUGZV
        JDVKVEQVOVJCFSNDVOVGCVIFSAVMVNUHZAVMVNUIUJJUKVOVGCOVPULUJAVMUGVHCUBZEVM
        VHVQTAVGCUQUMAEVQTZVMACEUNPUOZVRHECUPURUSUTAVSCRUOHECVAURIVFUCUOADVEQVB
        UFVCVD $.

      pi1bas.b $e |- ( ph -> B = ( Base ` G ) ) $.
      pi1bas.k $e |- ( ph -> K = ( Base ` O ) ) $.
      $( The base set of the fundamental group of a topological space at a
         given base point.  (Contributed by Jeff Madsen, 11-Jun-2010.)
         (Revised by Mario Carneiro, 10-Jul-2015.) $)
      pi1bas $p |- ( ph -> B = ( K /. ( ~=ph ` J ) ) ) $=
        ( cbs cfv cphtpc cqs cvv wcel pi1val eqidd fvex comi co eqeltri divsbas
        a1i ovex wceq qseq1 syl 3eqtr4rd ) AFOPZDQPZRZCOPEUORZBAUOFCUNSSACDFGHI
        JKLUAAUNUBUOSTADQUCUHFSTAFDHUDUESLDHUDUIUFUHUGAEUNUJUQUPUJNEUNUOUKULMUM
        $.

      $( Lemma for ~ pi1buni .  (Contributed by Mario Carneiro,
         10-Jul-2015.) $)
      pi1blem $p |- ( ph ->
          ( ( ( ~=ph ` J ) " K ) C_ K /\ K C_ ( II Cn J ) ) ) $=
        ( vx vy cfv wcel wa wceq cphtpc cima wss cii ccn co cv wbr wrex vex cc0
        elima c1 cphtpy c0 wne w3a simpr isphtpc sylib adantrl phtpc01 ad2antll
        simp2d simpld om1elbas biimpa adantrr eqtr3d simprd simp3d wb mpbir3and
        adantr rexlimdvaa syl5bi ssrdv simp1 syl6bi jca ) ADUAQZEUBZEUCEUDDUEUF
        ZUCAOWBEOUGZWBRPUGZWDWAUHZPEUIAWDERZPWDWAEOUJULAWFWGPEAWEERZWFSZSZWGWDW
        CRZUKWDQZHTZUMWDQZHTZWJWEWCRZWKWEWDDUNQUFUOUPZAWFWPWKWQUQZWHAWFSWFWRAWF
        URWEWDDUSUTVAVDWJUKWEQZWLHWJWSWLTZUMWEQZWNTZWFWTXBSAWHWEWDDVBVCZVEWJWPW
        SHTZXAHTZAWHWPXDXEUQZWFAWHXFAEWEDFGHLJKNVFVGVHZVDVIWJXAWNHWJWTXBXCVJWJW
        PXDXEXGVKVIAWGWKWMWOUQZVLWIAEWDDFGHLJKNVFZVNVMVOVPVQAOEWCAWGXHWKXIWKWMW
        OVRVSVQVT $.

      $( Another way to write the loop space base in terms of the base of the
         fundamental group.  (Contributed by Mario Carneiro, 10-Jul-2015.) $)
      pi1buni $p |- ( ph -> U. B = K ) $=
        ( cuni cphtpc cqs wss eqtrd cvv cfv cxp cin pi1bas cima wceq cii ccn co
        pi1blem simpld qsinxp syl unieqd wer phtpcer a1i simprd wcel fvex inex1
        erinxp uniqs2 ) ABOEDPUAZEEUBZUCZQZOEABVGABEVDQZVGABCDEFGHIJKLMNUDAVDEU
        EERZVHVGUFAVIEUGDUHUIZRZABCDEFGHIJKLMNUJZUKEVDULUMSUNAEVFTAVJEVDVJVDUOA
        DUPUQAVIVKVLURVBVFTUSAVDVEDPUTVAUQVCS $.
    $}

    pi1bas2.b $e |- ( ph -> B = ( Base ` G ) ) $.
    $( The base set of the fundamental group, written self-referentially.
       (Contributed by Mario Carneiro, 10-Jul-2015.) $)
    pi1bas2 $p |- ( ph -> B = ( U. B /. ( ~=ph ` J ) ) ) $=
      ( cuni comi co eqid cbs cfv eqidd pi1buni pi1bas ) ABCDBKDFLMZEFGHITNZJAB
      CDTOPZTEFGHIUAJAUBQRS $.

    $( Elementhood in the base set of the loop space.  (Contributed by Mario
       Carneiro, 10-Jul-2015.) $)
    pi1eluni $p |- ( ph -> ( F e. U. B <->
        ( F e. ( II Cn J ) /\ ( F ` 0 ) = Y /\ ( F ` 1 ) = Y ) ) ) $=
      ( cuni comi co eqid cbs cfv eqidd pi1buni om1elbas ) ABLCEEGMNZFGUAOZIJAB
      DEUAPQZUAFGHIJUBKAUCRST $.

    pi1bas3.r $e |- R = ( ( ~=ph ` J ) i^i ( U. B X. U. B ) ) $.
    $( The base set of the fundamental group.  (Contributed by Mario Carneiro,
       10-Jul-2015.) $)
    pi1bas3 $p |- ( ph -> B = ( U. B /. R ) ) $=
      ( cuni cphtpc cfv cxp cqs wss wceq co cin pi1bas2 cima cii ccn comi eqidd
      eqid cbs pi1buni pi1blem simpld qsinxp syl eqtrd qseq2 ax-mp syl6eqr ) AB
      BMZENOZUSUSPUAZQZUSCQZABUSUTQZVBABDEFGHIJKUBAUTUSUCUSRZVDVBSAVEUSUDEUETRA
      BDEUSEGUFTZFGHIJVFUHZKABDEVFUIOZVFFGHIJVGKAVHUGUJUKULUSUTUMUNUOCVASVCVBSL
      CVAUSUPUQUR $.

    pi1cpbl.o $e |- O = ( J Om1 Y ) $.
    pi1cpbl.a $e |- .+ = ( +g ` O ) $.
    $( The group operation, loop concatenation, is compatible with homotopy
       equivalence.  (Contributed by Mario Carneiro, 10-Jul-2015.) $)
    pi1cpbl $p |- ( ph ->
      ( ( M R N /\ P R Q ) -> ( M .+ P ) R ( N .+ Q ) ) ) $=
      ( wbr wa co cpco cfv cuni wcel cphtpc ctopon adantr cbs eqidd pi1buni w3a
      simprl cxp cin breqi brinxp2 bitri sylib simp1d simprr om1addcl simp2d c1
      wceq cc0 cii ccn pi1eluni simp3d eqtr4d pcohtpy syl3anbrc cplusg om1plusg
      mpbid syl6eqr oveqd 3brtr3d ex ) AIJFUAZCEFUAZUBZICDUCZJEDUCZFUAAWEUBZICH
      UDUEZUCZJEWIUCZWFWGFWHWJBUFZUGZWKWLUGZWJWKHUHUEZUAZWJWKFUAZWHWLIHCKLMSAHL
      UIUEUGWEOUJZAMLUGWEPUJZWHBGHKUKUEZKLMNWRWSSABGUKUEVGWEQUJZWHWTULUMZWHIWLU
      GZJWLUGZIJWOUAZWHWCXCXDXEUNZAWCWDUOWCIJWOWLWLUPUQZUAXFIJFXGRURIJWLWLWOUSU
      TVAZVBZWHCWLUGZEWLUGZCEWOUAZWHWDXJXKXLUNZAWCWDVCWDCEXGUAXMCEFXGRURCEWLWLW
      OUSUTVAZVBZVDWHWLJHEKLMSWRWSXBWHXCXDXEXHVEWHXJXKXLXNVEVDWHICJHEWHVFIUEZMV
      HCUEZWHIVIHVJUCZUGZVHIUEMVGZXPMVGZWHXCXSXTYAUNXIWHBIGHLMNWRWSXAVKVRVLWHCX
      RUGZXQMVGZVFCUEMVGZWHXJYBYCYDUNXOWHBCGHLMNWRWSXAVKVRVEVMWHXCXDXEXHVLWHXJX
      KXLXNVLVNWQWJWKXGUAWMWNWPUNWJWKFXGRURWJWKWLWLWOUSUTVOWHWIDICWHWIKVPUEDWHH
      KLMSWRWSVQTVSZVTWHWIDJEYEVTWAWB $.
  $}

  ${
    $d a b c d .+ $.  $d f F $.  $d f G $.  $d c d M $.  $d c d N $.  $d f X $.
    $d a b c d f B $.  $d a b c d f J $.  $d a b c d f ph $.  $d c d f Y $.
    elpi1.g $e |- G = ( J pi1 Y ) $.
    elpi1.b $e |- B = ( Base ` G ) $.
    elpi1.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    elpi1.2 $e |- ( ph -> Y e. X ) $.
    $( The elements of the fundamental group.  (Contributed by Jeff Madsen,
       19-Jun-2010.)  (Revised by Mario Carneiro, 10-Jul-2015.) $)
    elpi1 $p |- ( ph -> ( F e. B <->
                  E. f e. ( II Cn J ) ( ( ( f ` 0 ) = Y /\ ( f ` 1 ) = Y )
                                  /\ F = [ f ] ( ~=ph ` J ) ) ) ) $=
      ( wcel cphtpc cfv wceq wa wrex cvv syl6bb cuni cqs cc0 cv cec cii ccn cbs
      c1 co a1i pi1bas2 eleq2d elex id ecexg ax-mp syl6eqel rexlimivw pm5.21nii
      fvex elqsg w3a pi1eluni 3anass anbi1d anass rexbidv2 syl5bb bitrd ) ADBMD
      BUAZFNOZUBZMZUCCUDZOHPZUIVOOHPZQZDVOVLUEZPZQZCUFFUGUJZRZABVMDABEFGHIKLBEU
      HOPAJUKZULUMVNVTCVKRZAWCVNDSMZWEDVMUNVTWFCVKVTDVSSVTUOVLSMVSSMFNVAVOSVLUP
      UQURUSCVKDVLSVBUTAVTWACVKWBAVOVKMZVTQVOWBMZVRQZVTQWHWAQAWGWIVTAWGWHVPVQVC
      WIABVOEFGHIKLWDVDWHVPVQVETVFWHVRVTVGTVHVIVJ $.

    ${
      elpi1i.3 $e |- ( ph -> F e. ( II Cn J ) ) $.
      elpi1i.4 $e |- ( ph -> ( F ` 0 ) = Y ) $.
      elpi1i.5 $e |- ( ph -> ( F ` 1 ) = Y ) $.
      $( The elements of the fundamental group.  (Contributed by Jeff Madsen,
         19-Jun-2010.)  (Revised by Mario Carneiro, 10-Jul-2015.) $)
      elpi1i $p |- ( ph -> [ F ] ( ~=ph ` J ) e. B ) $=
        ( vf cfv cc0 wceq c1 wa cphtpc cec wcel cv cii ccn co wrex eceq1 eqcomd
        biantrud fveq1 eqeq1d anbi12d bitr3d rspcev syl12anc elpi1 mpbird ) ACE
        UAPZUBZBUCQOUDZPZGRZSVBPZGRZTZVAVBUTUBZRZTZOUEEUFUGZUHZACVKUCQCPZGRZSCP
        ZGRZVLLMNVJVNVPTZOCVKVBCRZVGVJVQVRVIVGVRVHVAVBCUTUIUJUKVRVDVNVFVPVRVCVM
        GQVBCULUMVRVEVOGSVBCULUMUNUOUPUQABOVADEFGHIJKURUS $.
    $}

    pi1addf.p $e |- .+ = ( +g ` G ) $.
    $( The group operation of ` pi1 ` is a binary operation.  (Contributed by
       Jeff Madsen, 11-Jun-2010.)  (Revised by Mario Carneiro, 10-Jul-2015.) $)
    pi1addf $p |- ( ph -> .+ : ( B X. B ) --> B ) $=
      ( cxp cfv co cvv cqus wcel a1i cv vd vc va vb wf cuni cphtpc cin cqs comi
      cplusg cbs eqidd fvex ovex cima wss cii eqid pi1blem simpld divsin pi1val
      ccn wceq pi1buni xpeq12d ineq2d oveq2d 3eqtr4d wer phtpcer simprd eqsstrd
      erinxp pi1cpbl cpco ctopon adantr om1plusg oveqd simprl om1addcl eqeltrrd
      wa simprr divsaddf pi1bas3 feq2d mpbird wb feq3 syl ) ABBMZBCUEZWNBUFZEUG
      NZWPWPMZUHZUIZCUEZAXAWTWTMZWTCUEAWSEGUJOZCXCUKNZDWPPUAUBUCUDAXCWQQOZXCWQX
      CULNZXFMZUHZQODXCWSQOAWQXCXEXFPPAXEUMAXFUMZWQPRAEUGUNSXCPRAEGUJUOSZAWQXFU
      PXFUQZXFUREVDOZUQZABDEXFXCFGHJKXCUSZBDULNVEAISZXIUTZVAVBADEXCFGHJKXNVCAWS
      XHXCQAWRXGWQAWPXFWPXFABDEXFXCFGHJKXNXOXIVFZXQVGVHVIVJXQAXLWPWQXLWQVKAEVLS
      AWPXFXLXQAXKXMXPVMVNVOXJABUDTXDUATZWSDEUCTUBTZXCFGHJKXOWSUSZXNXDUSZVPAXSW
      PRZXRWPRZWEZWEZXSXREVQNZOXSXRXDOWPYEYFXDXSXRYEEXCFGXNAEFVRNRYDJVSZAGFRYDK
      VSZVTWAYEWPXSEXRXCFGXNYGYHAWPXFVEYDXQVSAYBYCWBAYBYCWFWCWDYALWGAWNXBWTCABW
      TBWTABWSDEFGHJKXOXTWHZYIVGWIWJABWTVEWOXAWKYIBWTWNCWLWMWJ $.

    pi1addval.3 $e |- ( ph -> M e. U. B ) $.
    pi1addval.4 $e |- ( ph -> N e. U. B ) $.
    $( The concatenation of two path-homotopy classes in the fundamental
       group.  (Contributed by Jeff Madsen, 11-Jun-2010.)  (Revised by Mario
       Carneiro, 10-Jul-2015.) $)
    pi1addval $p |- ( ph -> ( [ M ] ( ~=ph ` J ) .+ [ N ] ( ~=ph ` J ) ) =
        [ ( M ( *p ` J ) N ) ] ( ~=ph ` J ) ) $=
      ( cec co wcel wceq vd vc va cphtpc cfv cuni cxp cin comi cplusg cpco cqus
      vb cvv cbs eqidd fvex a1i ovex cima wss cii ccn eqid simpld divsin pi1val
      pi1blem pi1buni xpeq12d ineq2d oveq2d 3eqtr4d wer phtpcer eqsstrd pi1cpbl
      simprd erinxp cv wa om1plusg adantr oveqd ctopon simprl om1addcl eqeltrrd
      simprr divsaddval mpd3an23 imaeq2d 3sstr4d ecinxp syl2anc eceq1 syl eqtrd
      oveq12d ) AFEUDUEZBUFZXAUGZUHZQZGXCQZCRZFGEIUIRZUJUEZRZXCQZFWTQZGWTQZCRFG
      EUKUEZRZWTQZAFXASZGXASZXFXJTOPAXCXGCXHDXAFGUNUAUBUCUMAXGWTULRZXGWTXGUOUEZ
      XSUGZUHZULRDXGXCULRAWTXGXRXSUNUNAXRUPAXSUPZWTUNSAEUDUQURXGUNSAEIUIUSURZAW
      TXSUTZXSVAZXSVBEVCRZVAZABDEXSXGHIJLMXGVDZBDUOUETAKURZYBVHZVEZVFADEXGHIJLM
      YHVGAXCYAXGULAXBXTWTAXAXSXAXSABDEXSXGHIJLMYHYIYBVIZYLVJVKVLVMYLAYFXAWTYFW
      TVNAEVOURAXAXSYFYLAYEYGYJVRVPVSYCABUMVTXHUAVTZXCDEUCVTUBVTZXGHIJLMYIXCVDY
      HXHVDZVQAYNXASZYMXASZWAZWAZYNYMXMRYNYMXHRXAYSXMXHYNYMAXMXHTYRAEXGHIYHLMWB
      ZWCWDYSXAYNEYMXGHIYHAEHWEUESYRLWCAIHSYRMWCAXAXSTYRYLWCAYPYQWFAYPYQWIWGWHY
      ONWJWKAXKXDXLXECAWTXAUTZXAVAZXPXKXDTAYDXSUUAXAYKAXAXSWTYLWLYLWMZOXAFWTWNW
      OAUUBXQXLXETUUCPXAGWTWNWOWSAXOXNXCQZXJAUUBXNXASXOUUDTUUCAXAFEGXGHIYHLMYLO
      PWGXAXNWTWNWOAXNXITUUDXJTAXMXHFGYTWDXNXIXCWPWQWRVM $.
  $}

  ${
    $d a b c d u x y z B $.  $d a b c d u x y z J $.  $d a b c d u x y z ph $.
    $d a b c d x y z G $.  $d a b c d x y Y $.  $d a b c d x .0. $.
    pi1fval.g $e |- G = ( J pi1 Y ) $.
    pi1fval.b $e |- B = ( Base ` G ) $.
    pi1fval.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    pi1fval.4 $e |- ( ph -> Y e. X ) $.
    pi1grplem.z $e |- .0. = ( ( 0 [,] 1 ) X. { Y } ) $.
    $( Lemma for ~ pi1grp .  (Contributed by Jeff Madsen, 11-Jun-2010.)
       (Revised by Mario Carneiro, 10-Aug-2015.) $)
    pi1grplem $p |- ( ph ->
        ( G e. Grp /\ [ .0. ] ( ~=ph ` J ) = ( 0g ` G ) ) ) $=
      ( wcel cfv wceq co c1 cv wbr w3a vx vy vz va vd vc vb cgrp cphtpc cec c0g
      vu wa cuni cxp cin cpco comi cc0 cicc cmin cmpt cvv eqid pi1val cbs eqidd
      a1i pi1buni fvex ovex cima wss cii ccn pi1blem simpld divsin om1plusg wer
      phtpcer simprd erinxp cplusg pi1cpbl oveqd breq12d sylibrd 3ad2ant1 simp2
      ctopon simp3 om1addcl adantr 3adant3r3 simpr3 simpr1 simpr2 cdiv cle cmul
      c2 caddc cif pi1eluni biimpa 3ad2antr1 simp1d simp3d simp2d eqtr4d pcoass
      c4 mpbid brinxp2 syl3anbrc pcoptcl mpbird simpr sselda pcopt pcorevcl syl
      syl2anc eqtrd wb mpbir3and pcorev sneqd xpeq2d syl6reqr breqtrrd divsgrp2
      csn ecinxp eqeq1d anbi2d ) ACUHMZGDUINZUJZCUKNZOZUMYRGYSBUNZUUCUOUPZUJZUU
      AOZUMAUAUBUCDUQNZUUDDFURPZCUDUSQUTPZQUDRZVAPUARZNVBZUUCVCGUEUFUDUGAYSUUHC
      UUCVCVCACDUUHEFHJKUUHVDZVEABCDUUHVFNZUUHEFHJKUUMBCVFNOZAIVHZAUUNVGVIZYSVC
      MADUIVJVHUUHVCMADFURVKVHZAYSUUCVLUUCVMZUUCVNDVOPZVMZABCDUUCUUHEFHJKUUMUUP
      UUQVPZVQZVRUUQADUUHEFUUMJKVSZAUUTUUCYSUUTYSVTADWAVHAUUSUVAUVBWBZWCUURAUUJ
      UFRZUUDSUGRZUERZUUDSUMUUJUVGUUHWDNZPZUVFUVHUVIPZUUDSUUJUVGUUGPZUVFUVHUUGP
      ZUUDSABUVGUVIUVHUUDCDUUJUVFUUHEFHJKUUPUUDVDUUMUVIVDWEAUVLUVJUVMUVKUUDAUUG
      UVIUUJUVGUVDWFAUUGUVIUVFUVHUVDWFWGWHAUUKUUCMZUBRZUUCMZTUUCUUKDUVOUUHEFUUM
      AUVNDEWKNMZUVPJWIAUVNFEMZUVPKWIAUVNUUCUUNOZUVPUUQWIAUVNUVPWJAUVNUVPWLWMZA
      UVNUVPUCRZUUCMZTZUMZUUKUVOUUGPZUWAUUGPZUUCMUUKUVOUWAUUGPZUUGPZUUCMUWFUWHY
      SSUWFUWHUUDSUWDUUCUWEDUWAUUHEFUUMAUVQUWCJWNZAUVRUWCKWNZAUVSUWCUUQWNZAUVNU
      VPUWEUUCMUWBUVTWOAUVNUVPUWBWPZWMUWDUUCUUKDUWGUUHEFUUMUWIUWJUWKAUVNUVPUWBW
      QUWDUUCUVODUWAUUHEFUUMUWIUWJUWKAUVNUVPUWBWRZUWLWMWMUWDULULUUIULRZQXBWSPZW
      TSUWNQXMWSPZWTSXBUWNXAPUWNUWPXCPXDUWNXBWSPUWOXCPXDVBZUUKUVOUWADUWDUUKUUTM
      ZUSUUKNZFOZQUUKNZFOZAUVPUVNUWRUWTUXBTZUWBAUVNUXCABUUKCDEFHJKUUPXEXFZXGZXH
      UWDUVOUUTMZUSUVONZFOZQUVONZFOZUWDUVPUXFUXHUXJTUWMUWDBUVOCDEFHUWIUWJUUOUWD
      IVHZXEXNZXHUWDUWAUUTMZUSUWANZFOZQUWANFOZUWDUWBUXMUXOUXPTUWLUWDBUWACDEFHUW
      IUWJUXKXEXNZXHUWDUXAFUXGUWDUWRUWTUXBUXEXIUWDUXFUXHUXJUXLXJXKUWDUXIFUXNUWD
      UXFUXHUXJUXLXIUWDUXMUXOUXPUXQXJXKUWQVDXLUWFUWHUUCUUCYSXOXPAGUUCMZGUUTMUSG
      NFOQGNFOTZAUVQUVRUXSJKGDEFLXQYDABGCDEFHJKUUPXEXRZAUVNUMZGUUKUUGPZUUCMUVNU
      YBUUKYSSZUYBUUKUUDSUYAUUCGDUUKUUHEFUUMAUVQUVNJWNZAUVRUVNKWNZAUVSUVNUUQWNZ
      AUXRUVNUXTWNZAUVNXSZWMUYHUYAUWRUWTUYCAUUCUUTUUKUVEXTZUYAUWRUWTUXBUXDXJZGU
      UKDFLYAYDUYBUUKUUCUUCYSXOXPUYAUULUUCMZUULUUTMZUSUULNZFOZQUULNZFOZUYAUYLUY
      MUXAOZUYOUWSOZUYAUWRUYLUYQUYRTUYIUDUUKUULDUULVDZYBYCZXHUYAUYMUXAFUYAUYLUY
      QUYRUYTXJUYAUWRUWTUXBUXDXIZYEUYAUYOUWSFUYAUYLUYQUYRUYTXIUYJYEAUYKUYLUYNUY
      PTYFUVNABUULCDEFHJKUUPXEWNYGZUYAUULUUKUUGPZUUCMUXRVUCGYSSVUCGUUDSUYAUUCUU
      LDUUKUUHEFUUMUYDUYEUYFVUBUYHWMUYGUYAVUCUUIUXAYNZUOZGYSUYAUWRVUCVUEYSSUYIU
      DVUEUUKUULDUYSVUEVDYHYCUYAVUEUUIFYNZUOGUYAVUDVUFUUIUYAUXAFVUAYIYJLYKYLVUC
      GUUCUUCYSXOXPYMAUUBUUFYRAYTUUEUUAAUUSUXRYTUUEOUVCUXTUUCGYSYOYDYPYQXR $.
  $}

  ${
    $d t x F $.  $d x G $.  $d t I $.  $d t x J $.  $d x ph $.  $d t x Y $.
    $d t X $.
    pi1grp.2 $e |- G = ( J pi1 Y ) $.
    $( The fundamental group is a group.  Proposition 1.3 of [Hatcher] p. 26.
       (Contributed by Jeff Madsen, 19-Jun-2010.)  (Proof shortened by Mario
       Carneiro, 8-Jun-2014.)  (Revised by Mario Carneiro, 10-Aug-2015.) $)
    pi1grp $p |- ( ( J e. ( TopOn ` X ) /\ Y e. X ) -> G e. Grp ) $=
      ( ctopon cfv wcel wa cgrp cc0 c1 cicc co csn cxp cphtpc cec c0g eqid wceq
      cbs simpl simpr pi1grplem simpld ) BCFGHZDCHZIZAJHKLMNDOPZBQGRASGUAUIAUBG
      ZABCDUJEUKTUGUHUCUGUHUDUJTUEUF $.

    ${
      pi1id.3 $e |- .0. = ( ( 0 [,] 1 ) X. { Y } ) $.
      $( The identity element of the fundamental group.  (Contributed by Mario
         Carneiro, 12-Feb-2015.)  (Revised by Mario Carneiro, 10-Aug-2015.) $)
      pi1id $p |- ( ( J e. ( TopOn ` X ) /\ Y e. X ) ->
        [ .0. ] ( ~=ph ` J ) = ( 0g ` G ) ) $=
        ( ctopon cfv wcel wa cgrp cphtpc cec c0g wceq cbs eqid simpl simpr
        pi1grplem simprd ) BCHIJZDCJZKZALJEBMINAOIPUEAQIZABCDEFUFRUCUDSUCUDTGUA
        UB $.
    $}

    pi1inv.n $e |- N = ( invg ` G ) $.
    pi1inv.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    pi1inv.y $e |- ( ph -> Y e. X ) $.
    pi1inv.f $e |- ( ph -> F e. ( II Cn J ) ) $.
    pi1inv.0 $e |- ( ph -> ( F ` 0 ) = Y ) $.
    pi1inv.1 $e |- ( ph -> ( F ` 1 ) = Y ) $.
    pi1inv.i $e |- I = ( x e. ( 0 [,] 1 ) |-> ( F ` ( 1 - x ) ) ) $.
    $( An inverse in the fundamental group.  (Contributed by Mario Carneiro,
       12-Feb-2015.)  (Revised by Mario Carneiro, 10-Aug-2015.) $)
    pi1inv $p |- ( ph -> ( N ` [ F ] ( ~=ph ` J ) ) = [ I ] ( ~=ph ` J ) ) $=
      ( cfv wceq wcel cphtpc cec cplusg c0g cpco cc0 cicc csn cxp cbs eqid cuni
      co cii ccn w3a pcorevcl syl simp1d simp2d eqtrd simp3d pi1eluni mpbir3and
      a1i pi1addval wer phtpcer wbr pcorev sneqd xpeq2d breqtrd erthi pi1grplem
      c1 cgrp simprd 3eqtrd wb simpld elpi1i grpinvid2 syl3anc mpbird ) ACFUARZ
      UBZGREWFUBZSZWHWGDUCRZUMZDUDRZSZAWKECFUERUMZWFUBUFVPUGUMZIUHZUIZWFUBZWLAD
      UJRZWJDFECHIJWSUKZLMWJUKZAEWSULZTEUNFUOUMZTZUFERZISVPERZISAXDXEVPCRZSZXFU
      FCRZSZACXCTZXDXHXJUPNBCEFQUQURZUSZAXEXGIAXDXHXJXLUTPVAZAXFXIIAXDXHXJXLVBO
      VAZAWSEDFHIJLMWSWSSAWTVEZVCVDACXBTXKXIISXGISNOPAWSCDFHIJLMXPVCVDVFAWNWQWF
      XCXCWFVGAFVHVEAWNWOXGUHZUIZWQWFAXKWNXRWFVINBXRCEFQXRUKVJURAXQWPWOAXGIPVKV
      LVMVNADVQTZWRWLSZAWSDFHIWQJWTLMWQUKVOZVRVSAXSWGWSTWHWSTWIWMVTAXSXTYAWAAWS
      CDFHIJWTLMNOPWBAWSEDFHIJWTLMXMXNXOWBWSWJDGWGWHWLWTXAWLUKKWCWDWE $.
  $}

  ${
    $d f g h s u w x y z B $.  $d g h s u w x y z F $.  $d g h s u w x y z I $.
    $d g s x A $.  $d f h w y z G $.  $d f s z H $.  $d f g h s u w x y z ph $.
    $d f g h s u w x y z J $.  $d f g h s w x y z P $.  $d f g h s w x y z Q $.
    pi1xfr.p $e |- P = ( J pi1 ( F ` 0 ) ) $.
    pi1xfr.q $e |- Q = ( J pi1 ( F ` 1 ) ) $.
    pi1xfr.b $e |- B = ( Base ` P ) $.
    pi1xfr.g $e |- G = ran ( g e. U. B |-> <. [ g ] ( ~=ph ` J ) ,
      [ ( I ( *p ` J ) ( g ( *p ` J ) F ) ) ] ( ~=ph ` J ) >. ) $.
    pi1xfr.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    pi1xfr.f $e |- ( ph -> F e. ( II Cn J ) ) $.
    ${
      pi1xfrval.i $e |- ( ph -> I e. ( II Cn J ) ) $.
      pi1xfrval.1 $e |- ( ph -> ( F ` 1 ) = ( I ` 0 ) ) $.
      pi1xfrval.2 $e |- ( ph -> ( I ` 1 ) = ( F ` 0 ) ) $.
      $( Functionality of the loop transfer function on the equivalence class
         of a path.  (Contributed by Mario Carneiro, 23-Dec-2016.) $)
      pi1xfrf $p |- ( ph -> G : B --> ( Base ` Q ) ) $=
        ( cfv vh vs cbs wf cuni cv cphtpc cec cmpt crn wfun cpco co wcel wa cc0
        ctopon adantr cicc cii ccn iitopon cnf2 syl3anc 0elunit ffvelrn sylancl
        c1 a1i wceq w3a pi1eluni biimpa simp1d simp2d simp3d eqid 1elunit pcocn
        elpi1i pco0 3eqtr4rd eqtr4d pco1 eqtrd eceq1 oveq1 oveq2d syl 3ad2antr1
        wer phtpcer erref wbr simpr3 erth mpbird pcohtpy erthi fliftfund fliftf
        mpbid cqs pi1bas2 wrex cab df-qs rnmpt eqtr4i syl6eq feq2d ) ABDUCTZGUD
        EBUEZEUFZIUGTZUHZUIZUJZXLGUDZAGUKXSAEUAXPHXNFIULTZUMZXTUMZXOUHZUAUFZXOU
        HZHYDFXTUMZXTUMZXOUHZBXLGXMNAXNXMUNZUOZBXNCIJUPFTZKMAIJUQTUNZYIOURZAYKJ
        UNZYIAUPVHUSUMZJFUDZUPYOUNYNAUTYOUQTUNZYLFUTIVAUMZUNZYPYQAVBVIOPFUTIYOJ
        VCVDZVEYOJUPFVFVGZURYJXNYRUNZUPXNTZYKVJZVHXNTYKVJZAYIUUBUUDUUEVKABXNCIJ
        YKKOUUABCUCTVJAMVIZVLVMZVNZYJUUBUUDUUEUUGVOZYJUUBUUDUUEUUGVPZVTZYJXLYBD
        IJVHFTZLXLVQYMAUULJUNZYIAYPVHYOUNUUMYTVRYOJVHFVFVGURYJHYAIAHYRUNZYIQURZ
        YJXNFIUUHAYSYIPURZUUJVSZYJUUCYKUPYATZVHHTZUUIYJXNFIUUHUUPWAAUUSYKVJZYIS
        URWBVSYJUPYBTUPHTZUULYJHYAIUUOUUQWAAUULUVAVJYIRURWCYJVHYBTVHYATUULYJHYA
        IUUOUUQWDYJXNFIUUHUUPWDWEVTZXNYDXOWFXNYDVJZYBYGVJYCYHVJUVCYAYFHXTXNYDFX
        TWGWHYBYGXOWFWIAYIYDXMUNZXPYEVJZVKZUOZYBYGXOYRYRXOWKUVGIWLVIZUVGHYAHIYF
        UVGUUCYKUURUUSAUVDYIUUDUVEUUIWJUVGXNFIAUVDYIUUBUVEUUHWJZAYSUVFPURZWAAUU
        TUVFSURWBUVGHXOYRUVHAUUNUVFQURWMUVGXNFYDIFAUVDYIUUEUVEUUJWJUVGXNYDXOWNU
        VEAYIUVDUVEWOUVGXNYDXOYRUVHUVIWPWQUVGFXOYRUVHUVJWMWRWRWSWTAEXPYCBXLGXMN
        UUKUVBXAXBABXRXLGABXMXOXCZXRABCIJYKKOUUAUUFXDUVKUBUFXPVJEXMXEUBXFXREUBX
        MXOXGEUBXMXPXQXQVQXHXIXJXKWQ $.

      pi1xfrval.a $e |- ( ph -> A e. U. B ) $.
      $( The value of the loop transfer function on the equivalence class of a
         path.  (Contributed by Mario Carneiro, 12-Feb-2015.)  (Revised by
         Mario Carneiro, 23-Dec-2016.) $)
      pi1xfrval $p |- ( ph -> ( G ` [ A ] ( ~=ph ` J ) ) =
        [ ( I ( *p ` J ) ( A ( *p ` J ) F ) ) ] ( ~=ph ` J ) ) $=
        ( cuni wcel cphtpc cfv cec cpco co wceq cv cvv wa fvex ecexg mp1i eceq1
        oveq1 oveq2d syl cbs wf wfun pi1xfrf ffun fliftval mpdan ) ABCUBZUCBJUD
        UEZUFZHUEIBGJUGUEZUHZVJUHZVHUFZUIUAAFFUJZVHUFZIVNGVJUHZVJUHZVHUFZVIVMUK
        UKHVGBOVHUKUCZVOUKUCAVNVGUCULZJUDUMZVNUKVHUNUOVSVRUKUCVTWAVQUKVHUNUOVNB
        VHUPVNBUIZVQVLUIVRVMUIWBVPVKIVJVNBGVJUQURVQVLVHUPUSACEUTUEZHVAHVBACDEFG
        HIJKLMNOPQRSTVCCWCHVDUSVEVF $.
    $}

    pi1xfr.i $e |- I = ( x e. ( 0 [,] 1 ) |-> ( F ` ( 1 - x ) ) ) $.
    $( Given a path ` F ` and its inverse ` I ` between two basepoints, there
       is an induced group homomorphism on the fundamental groups.
       (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    pi1xfr $p |- ( ph -> G e. ( P GrpHom Q ) ) $=
      ( cfv co vy vz vf vh vu cgrp wcel wa cbs cplusg wceq wral cghm ctopon cc0
      wf cv c1 cicc cii ccn iitopon cnf2 syl3anc 0elunit ffvelrn sylancl pi1grp
      a1i syl2anc 1elunit jca w3a pcorevcl syl simp1d simp2d eqcomd simp3d cuni
      pi1xfrf cphtpc cqs pi1bas2 eleq2d biimpa eqid oveq1 fveq2d oveq1d eqeq12d
      cec fveq2 ralbidv adantlr oveq2d cpco wer phtpcer pi1eluni 3adant3 adantr
      oveq2 wb biimp3a pco0 eqtrd eqtr4d pcocn 3ad2ant1 3eqtr4rd erref cdiv cle
      c2 wbr c4 cmul caddc cif cmpt pcoass csn pco1 pcorev2 pcohtpy pcopt ertrd
      ertr3d ertr4d erthi mpbir3and pi1xfrval eqidd pi1addval 3eqtr4d ralrimiva
      cxp ectocld syldan simp2 simp3 simpr oveq12d 3expa isghm sylanbrc ) ADUFU
      GZEUFUGZUHCEUISZHUPZUAUQZUBUQZDUJSZTZHSZUULHSZUUMHSZEUJSZTZUKZUBCULZUACUL
      ZUHHDEUMTUGAUUHUUIAJKUNSUGZUOGSZKUGZUUHPAUOURUSTZKGUPZUOUVGUGUVFAUTUVGUNS
      UGZUVDGUTJVATZUGZUVHUVIAVBVIPQGUTJUVGKVCVDZVEUVGKUOGVFVGZDJKUVELVHVJAUVDU
      RGSZKUGZUUIPAUVHURUVGUGUVOUVLVKUVGKURGVFVGZEJKUVNMVHVJVLAUUKUVCACDEFGHIJK
      LMNOPQAIUVJUGZUOISZUVNUKZURISZUVEUKZAUVKUVQUVSUWAVMQBGIJRVNVOZVPZAUVRUVNA
      UVQUVSUWAUWBVQZVRZAUVQUVSUWAUWBVSZWAAUVBUACAUULCUGZUULCVTZJWBSZWCZUGZUVBA
      UWGUWKACUWJUULACDJKUVELPUVMCDUISUKANVIZWDZWEWFUCUQZUWIWLZUUMUUNTZHSZUWOHS
      ZUURUUSTZUKZUBCULUVBAUCUULUWHUWIUWJUWJWGZUWOUULUKZUWTUVAUBCUXBUWQUUPUWSUU
      TUXBUWPUUOHUWOUULUUMUUNWHWIUXBUWRUUQUURUUSUWOUULHWMWJWKWNAUWNUWHUGZUHZUWT
      UBCUXDUUMCUGZUUMUWJUGZUWTAUXEUXFUXCAUXEUXFACUWJUUMUWMWEWFWOUWOUDUQZUWIWLZ
      UUNTZHSZUWRUXHHSZUUSTZUKZUWTUXDUDUUMUWHUWIUWJUXAUXHUUMUKZUXJUWQUXLUWSUXNU
      XIUWPHUXHUUMUWOUUNXCWIUXNUXKUURUWRUUSUXHUUMHWMWPWKAUXCUXGUWHUGZUXMAUXCUXO
      VMZUWNUXGJWQSZTZUWIWLZHSZIUWNGUXQTZUXQTZUWIWLZIUXGGUXQTZUXQTZUWIWLZUUSTZU
      XJUXLUXPIUXRGUXQTZUXQTZUWIWLUYBUYEUXQTZUWIWLUXTUYGUXPUYIUYJUWIUVJUVJUWIWR
      UXPJWSVIZUXPUYIIUYAUYEUXQTZUXQTUYJUWIUVJUYKUXPIUYHIJUYLUXPUOUXRSZUVEUOUYH
      SUVTUXPUYMUOUWNSZUVEUXPUWNUXGJAUXCUWNUVJUGZUXOUXDUYOUYNUVEUKZURUWNSZUVEUK
      ZAUXCUYOUYPUYRVMACUWNDJKUVELPUVMUWLWTWFZVPZXAZUXPUXGUVJUGZUOUXGSZUVEUKZUR
      UXGSZUVEUKZAUXCUXOVUBVUDVUFVMZAUXOVUGXDUXCACUXGDJKUVELPUVMUWLWTXBXEZVPZXF
      AUXCUYPUXOUXDUYOUYPUYRUYSVQZXAXGZUXPUXRGJUXPUWNUXGJVUAVUIUXPUYQUVEVUCAUXC
      UYRUXOUXDUYOUYPUYRUYSVSZXAZUXPVUBVUDVUFVUHVQZXHZXIZAUXCUVKUXOQXJZXFAUXCUW
      AUXOUWFXJZXKUXPIUWIUVJUYKAUXCUVQUXOUWCXJZXLUXPUYHUWNUYDUXQTZUYLUWIUVJUYKU
      XPUEUEUVGUEUQZURXOXMTZXNXPVVAURXQXMTZXNXPXOVVAXRTVVAVVCXSTXTVVAXOXMTVVBXS
      TXTYAZUWNUXGGJVUAVUIVUQVUOUXPVUBVUDVUFVUHVSZVVDWGZYBUXPVUTUWNGUYEUXQTZUXQ
      TUYLUWIUVJUYKUXPUWNUYDUWNJVVGUXPUYQVUCUOUYDSZVUOUXPUXGGJVUIVUQXFZXHUXPUWN
      UWIUVJUYKVUAXLUXPUYDGIUXQTZUYDUXQTZVVGUWIUVJUYKUXPVVKUVGUVEYCYRZUYDUXQTZU
      YDUWIUVJUYKUXPVVJUYDVVLJUYDUXPURVVJSUVTVVHUXPGIJVUQVUSYDUXPVUCUVEVVHUVTVU
      NVVIVURXKZXGUXPUVKVVJVVLUWIXPVUQBVVLGIJRVVLWGZYEVOUXPUYDUWIUVJUYKUXPUXGGJ
      VUIVUQVVEXIZXLYFUXPUYDUVJUGVVHUVEUKVVMUYDUWIXPVVPUXPVVHVUCUVEVVIVUNXGVVLU
      YDJUVEVVOYGVJYHUXPUEVVDGIUYDJVUQVUSVVPUXPUVRUVNAUXCUVSUXOUWDXJZVRZVVNVVFY
      BYIYFUXPUEVVDUWNGUYEJVUAVUQUXPIUYDJVUSVVPVVNXIZVUMUXPUOUYESZUVNUXPVVTUVRU
      VNUXPIUYDJVUSVVPXFVVQXGZVRVVFYBYJYHYFUXPUEVVDIUYAUYEJVUSAUXCUYAUVJUGUXOUX
      DUWNGJUYTAUVKUXCQXBZVULXIZXAVVSAUXCUVTUOUYASZUKUXOUXDUYNUVEVWDUVTVUJUXDUW
      NGJUYTVWBXFAUWAUXCUWFXBZXKZXAUXPURUYASZUVNVVTUXPUWNGJVUAVUQYDVWAXHVVFYBYJ
      YKUXPUXRCDEFGHIJKLMNOAUXCUVDUXOPXJZVUQVUSVVRVURUXPUXRUWHUGZUXRUVJUGZUYMUV
      EUKZURUXRSZUVEUKZVUPVUKUXPVWLVUEUVEUXPUWNUXGJVUAVUIYDVVEXGAUXCVWIVWJVWKVW
      MVMXDUXOACUXRDJKUVELPUVMUWLWTXJYLYMUXPUUJUUSEJUYBUYEKUVNMUUJWGZVWHAUXCUVO
      UXOUVPXJZUUSWGZUXPUYBUUJVTZUGUYBUVJUGZUOUYBSZUVNUKZURUYBSZUVNUKZAUXCVWRUX
      OUXDIUYAJAUVQUXCUWCXBZVWCVWFXIXAAUXCVWTUXOUXDVWSUVRUVNUXDIUYAJVXCVWCXFAUV
      SUXCUWDXBXGXAAUXCVXBUXOUXDVXAVWGUVNUXDIUYAJVXCVWCYDUXDUWNGJUYTVWBYDXGXAUX
      PUUJUYBEJKUVNMVWHVWOUXPUUJYNZWTYLUXPUYEVWQUGUYEUVJUGVVTUVNUKURUYESZUVNUKV
      VSVWAUXPVXEURUYDSUVNUXPIUYDJVUSVVPYDUXPUXGGJVUIVUQYDXGUXPUUJUYEEJKUVNMVWH
      VWOVXDWTYLYOYPUXPUXIUXSHUXPCUUNDJUWNUXGKUVELNVWHAUXCUVFUXOUVMXJUUNWGZAUXC
      UXOUUAAUXCUXOUUBZYOWIUXPUWRUYCUXKUYFUUSAUXCUWRUYCUKUXOUXDUWNCDEFGHIJKLMNO
      AUVDUXCPXBVWBVXCAUVNUVRUKUXCUWEXBVWEAUXCUUCYMXAUXPUXGCDEFGHIJKLMNOVWHVUQV
      USVVRVURVXGYMUUDYPUUEYSYTYQYSYTYQVLUBUAUUNUUSDEHCUUJNVWNVXFVWPUUFUUG $.

    ${
      pi1xfrcnv.h $e |- H = ran ( h e. U. ( Base ` Q ) |-> <. [ h ]
    ( ~=ph ` J ) , [ ( F ( *p ` J ) ( h ( *p ` J ) I ) ) ] ( ~=ph ` J ) >. ) $.
      $( Given a path ` F ` between two basepoints, there is an induced group
         homomorphism on the fundamental groups.  (Contributed by Mario
         Carneiro, 12-Feb-2015.)  (Proof shortened by Mario Carneiro,
         23-Dec-2016.) $)
      pi1xfrcnvlem $p |- ( ph -> `' G C_ H ) $=
        ( ccnv cbs cfv cuni cv cphtpc cec cpco co cop cmpt ccom crn cvv wcel wa
        fvex ecexg mp1i fliftcnv cii ccn cc0 c1 wceq w3a pcorevcl simp1d adantr
        syl cicc wf ctopon iitopon a1i syl3anc 0elunit ffvelrn sylancl pi1eluni
        cnf2 biimpa simp3d pcocn simp2d eqtr4d pco0 eqtrd pco1 wb 1elunit eqidd
        mpbir3and eceq1 oveq1 oveq2d opeq12d fmptco wer phtpcer eqtr2d csn eqid
        erref cxp wbr pcopt2 syl2anc c2 cdiv cle c4 caddc eqcomd pcoass pcorev2
        cmul cif pcohtpy ertr2d ertr3d ertr4d pcopt ertrd erthi mpteq2dva rneqd
        opeq2d rncoss sseqtr4i syl6eqss ) AIUBZGEUCUDZUEZGUFZLUGUDZUHZHYPKLUIUD
        ZUJZYSUJZYQUHZUKZULZFCUEZKFUFZHYSUJZYSUJZULZUMZUNZJAYMFUUEUUHYQUHZUUFYQ
        UHZUKZULZUNUUKAFUUMUULUOUOIUUEQYQUOUPZUUMUOUPAUUFUUEUPZUQZLUGURZUUFUOYQ
        USUTUUPUULUOUPUURUUSUUHUOYQUSUTVAAUUJUUOAUUJFUUEUULHUUHKYSUJZYSUJZYQUHZ
        UKZULUUOAFGUUEYOUUHUUCUVCUUIUUDUURUUHYOUPZUUHVBLVCUJZUPZVDUUHUDZVEHUDZV
        FZVEUUHUDZUVHVFZUURKUUGLAKUVEUPZUUQAUVLVDKUDZUVHVFZVEKUDZVDHUDZVFZAHUVE
        UPZUVLUVNUVQVGSBHKLTVHVKZVIVJZUURUUFHLUURUUFUVEUPZVDUUFUDZUVPVFZVEUUFUD
        ZUVPVFZAUUQUWAUWCUWEVGACUUFDLMUVPNRAVDVEVLUJZMHVMZVDUWFUPUVPMUPAVBUWFVN
        UDUPZLMVNUDUPUVRUWGUWHAVOVPRSHVBLUWFMWBVQZVRUWFMVDHVSVTCDUCUDVFAPVPWAWC
        ZVIZAUVRUUQSVJZUURUWAUWCUWEUWJWDZWEZUURUVOUWBVDUUGUDUURUVOUVPUWBAUVQUUQ
        AUVLUVNUVQUVSWDVJUURUWAUWCUWEUWJWFZWGZUURUUFHLUWKUWLWHWGZWEUURUVGUVMUVH
        UURKUUGLUVTUWNWHAUVNUUQAUVLUVNUVQUVSWFVJZWIUURUVJVEUUGUDZUVHUURKUUGLUVT
        UWNWJUURUUFHLUWKUWLWJZWIAUVDUVFUVIUVKVGWKUUQAYNUUHELMUVHORAUWGVEUWFUPUV
        HMUPUWIWLUWFMVEHVSVTAYNWMWAVJWNAUUIWMAUUDWMYPUUHVFZYRUULUUBUVBYPUUHYQWO
        UXAUUAUVAVFUUBUVBVFUXAYTUUTHYSYPUUHKYSWPWQUUAUVAYQWOVKWRWSAFUUEUVCUUNUU
        RUVBUUMUULUURUVAUUFYQUVEUVEYQWTUURLXAVPZUURUVAHKUUFYSUJZYSUJZUUFYQUVEUX
        BUURHUXCHLUUTUURVDUXCUDUVMUVHUURKUUFLUVTUWKWHUWRXBUURHYQUVEUXBUWLXEUURU
        XCKUUGKYSUJZYSUJUUTYQUVEUXBUURKUUFKLUXEUWPUURKYQUVEUXBUVTXEUURUUFUUFUWF
        UVPXCXFZYSUJZUXEYQUVEUXBUURUWAUWEUXGUUFYQXGUWKUWMUXFUUFLUVPUXFXDZXHXIUU
        RUXEUUFHKYSUJZYSUJUXGYQUVEUXBUURBBUWFBUFZVEXJXKUJZXLXGUXJVEXMXKUJZXLXGX
        JUXJXRUJUXJUXLXNUJXSUXJXJXKUJUXKXNUJXSULZUUFHKLUWKUWLUVTUWMUURUVMUVHUWR
        XOZUXMXDZXPUURUUFUXIUUFLUXFUURUWDUVPVDUXIUDUWMUURHKLUWLUVTWHWGUURUUFYQU
        VEUXBUWKXEZUURUVRUXIUXFYQXGUWLBUXFHKLTUXHXQVKZXTYAYBXTUURBUXMKUUGKLUVTU
        WNUVTUWQUURUWSUVHUVMUWTUWRWGUXOXPYCXTUURUXDUXIUUFYSUJZUUFYQUVEUXBUURBUX
        MHKUUFLUWLUVTUWKUXNUWPUXOXPUURUXRUXFUUFYSUJZUUFYQUVEUXBUURUXIUUFUXFLUUF
        UURVEUXIUDUVOUWBUURHKLUWLUVTWJUWPWIUXQUXPXTUURUWAUWCUXSUUFYQXGUWKUWOUXF
        UUFLUVPUXHYDXIYEYBYBYFYIYGWIYHWGUUKUUDUNJUUDUUIYJUAYKYL $.

      $( Given a path ` F ` between two basepoints, there is an induced group
         homomorphism on the fundamental groups.  (Contributed by Mario
         Carneiro, 12-Feb-2015.)  (Proof shortened by Mario Carneiro,
         23-Dec-2016.) $)
      pi1xfrcnv $p |- ( ph -> ( `' G = H /\ `' G e. ( Q GrpHom P ) ) ) $=
        ( vz vy ccnv wceq cghm co wcel pi1xfrcnvlem wrel cvv cxp wss cphtpc cfv
        cv cec cpco cuni wa fvex ecexg mp1i fliftrel df-rel sylibr dfrel2 sylib
        cbs cc0 cicc cmin cmpt cop crn cpi1 0elunit oveq2 ax-1cn subid1i syl6eq
        fveq2d fvmpt ax-mp oveq2i eqtr4i 1elunit 1m1e0 fveq2i eqid cii pcorevcl
        c1 ccn w3a syl simp1d cbvmptv ctopon iitopon cnf2 syl3anc feqmptd iirev
        wf a1i cc cr unitssre sseli recnd nncan sylancr mpteq2ia syl6eqr oveq1d
        eqtrd eceq1 opeq2d mpteq2dv rneqd syl5eq cnveqd unieqd oveq2d mpteq12dv
        3sstr4d cnvss eqsstr3d eqssd pi1xfr eqeltrd jca ) AIUDZJUEYNEDUFUGZUHAY
        NJABCDEFGHIJKLMNOPQRSTUAUIAJJUDZUDZYNAJUJZYQJUEAJUKUKULUMYRAGGUPZLUNUOZ
        UQZHYSKLURUOZUGZUUBUGZYTUQZUKUKJEVIUOZUSZUAYTUKUHZUUAUKUHAYSUUGUHUTZLUN
        VAZYSUKYTVBVCUUHUUEUKUHUUIUUJUUDUKYTVBVCVDJVEVFJVGVHAYPIUMYQYNUMAGUUGUU
        AUBVJWMVKUGZWMUBUPZVLUGZKUOZVMZUUCUUBUGZYTUQZVNZVMZVOZUDFDVIUOZUSZFUPZY
        TUQZKUVCUUOUUBUGZUUBUGZYTUQZVNZVMZVOZYPIAUCUUFEDGFKUUTUVJUUOLMELWMHUOZV
        PUGLVJKUOZVPUGOUVLUVKLVPVJUUKUHUVLUVKUEZVQBVJWMBUPZVLUGZHUOZUVKUUKKUVNV
        JUEZUVOWMHUVQUVOWMVJVLUGWMUVNVJWMVLVRWMVSVTWAWBTWMHVAWCWDWEWFZDLVJHUOZV
        PUGLWMKUOZVPUGNUVTUVSLVPWMUUKUHUVTUVSUEZWGBWMUVPUVSUUKKUVNWMUEZUVPWMWMV
        LUGZHUOUVSUWBUVOUWCHUVNWMWMVLVRWBUWCVJHWHWIWATVJHVAWCWDWEWFZUUFWJZUUTWJ
        ZRAKWKLWNUGZUHZUVMUWAAHUWGUHZUWHUVMUWAWOSBHKLTWLWPWQZUBUCUUKUUNWMUCUPZV
        LUGZKUOUULUWKUEUUMUWLKUULUWKWMVLVRWBWRZUVJWJUIAJUUTAJGUUGUUAUUEVNZVMZVO
        UUTUAAUWOUUSAGUUGUWNUURAUUEUUQUUAAUUDUUPUEUUEUUQUEAHUUOUUCUUBAHUBUUKUUL
        HUOZVMUUOAUBUUKMHAWKUUKWSUOUHZLMWSUOUHUWIUUKMHXEUWQAWTXFRSHWKLUUKMXAXBX
        CUBUUKUUNUWPUULUUKUHZUUNWMUUMVLUGZHUOZUWPUWRUUMUUKUHUUNUWTUEUULXDBUUMUV
        PUWTUUKKUVNUUMUEUVOUWSHUVNUUMWMVLVRWBTUWSHVAWCWPUWRUWSUULHUWRWMXGUHUULX
        GUHUWSUULUEVSUWRUULUUKXHUULXIXJXKWMUULXLXMWBXQXNXOZXPUUDUUPYTXRWPXSXTYA
        YBZYCAIFCUSZUVDKUVCHUUBUGZUUBUGZYTUQZVNZVMZVOUVJQAUXHUVIAFUXCUXGUVBUVHA
        CUVACUVAUEAPXFYDAUXFUVGUVDAUXEUVFUEUXFUVGUEAUXDUVEKUUBAHUUOUVCUUBUXAYEY
        EUXEUVFYTXRWPXSYFYAYBYGYPIYHWPYIYJZAYNUUTYOAYNJUUTUXIUXBXQAUCUUFEDGKUUT
        UUOLMUVRUWDUWEUWFRUWJUWMYKYLYM $.
    $}

    $( The mapping ` G ` between fundamental groups is an isomorphism.
       (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    pi1xfrgim $p |- ( ph -> G e. ( P GrpIso Q ) ) $=
      ( vy co cghm wcel ccnv cgim pi1xfr cbs cfv cuni cphtpc cec cpco cmpt wceq
      cv cop crn eqid pi1xfrcnv simprd isgim2 sylanbrc ) AHDEUATUBHUCZEDUATUBZH
      DEUDTUBABCDEFGHIJKLMNOPQRUEAVBSEUFUGUHSUNZJUIUGZUJGVDIJUKUGZTVFTVEUJUOULU
      PZUMVCABCDEFSGHVGIJKLMNOPQRVGUQURUSDEHUTVA $.
  $}

  ${
    $d g s x A $.  $d g h s x F $.  $d f g h s x z J $.  $d f g h s x y z ph $.
    $d f h y z G $.  $d g h s x K $.  $d f g h s x y z P $.  $d g s x T $.
    $d f g h s x y z Q $.  $d f g h s x y z V $.
    pi1co.p $e |- P = ( J pi1 A ) $.
    pi1co.q $e |- Q = ( K pi1 B ) $.
    pi1co.v $e |- V = ( Base ` P ) $.
    pi1co.g $e |- G = ran ( g e. U. V |->
      <. [ g ] ( ~=ph ` J ) , [ ( F o. g ) ] ( ~=ph ` K ) >. ) $.
    pi1co.j $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    pi1co.f $e |- ( ph -> F e. ( J Cn K ) ) $.
    pi1co.a $e |- ( ph -> A e. X ) $.
    pi1co.b $e |- ( ph -> ( F ` A ) = B ) $.
    $( Functionality of the loop transfer function on the equivalence class of
       a path.  (Contributed by Mario Carneiro, 23-Dec-2016.) $)
    pi1cof $p |- ( ph -> G : V --> ( Base ` Q ) ) $=
      ( vh vs cbs cfv wf cuni cv cphtpc cec cmpt crn wfun ccom cvv wcel wa fvex
      ecexg mp1i eqid ctopon ctop ccn co cntop2 syl toptopon sylib cnf2 syl3anc
      adantr ffvelrnd eqeltrrd cii cc0 wceq w3a a1i pi1eluni biimpa simp1d cnco
      c1 syl2anc cicc iitopon 0elunit fvco3 sylancl simp2d fveq2d 3eqtrd simp3d
      1elunit elpi1i eceq1 coeq2 wer phtpcer simpr3 simpr1 wb mpbid erth mpbird
      wbr phtpcco2 erthi fliftfund fliftf cqs pi1bas2 df-qs rnmpt eqtr4i syl6eq
      wrex cab feq2d ) AKEUCUDZHUEFKUFZFUGZIUHUDZUIZUJZUKZXTHUEZAHULYGAFUAYDGYB
      UMZJUHUDZUIZUAUGZYCUIZGYKUMZYIUIZUNXTHYAPYCUNUOYDUNUOAYBYAUOZUPZIUHUQYBUN
      YCURUSZYPXTYHEJJUFZCNXTUTAJYRVAUDUOZYOAJVBUOZYSAGIJVCVDUOZYTRGIJVEVFJYRYR
      UTVGVHZVKACYRUOYOABGUDZCYRTALYRBGAILVAUDUOZYSUUALYRGUEQUUBRGIJLYRVIVJSVLV
      MVKYPYBVNIVCVDZUOZUUAYHVNJVCVDZUOYPUUFVOYBUDZBVPZWCYBUDZBVPZAYOUUFUUIUUKV
      QZAKYBDILBMQSKDUCUDVPAOVRZVSZVTZWAZAUUAYORVKYBGVNIJWBWDYPVOYHUDZUUHGUDZUU
      CCYPVOWCWEVDZLYBUEZVOUUSUOUUQUURVPYPVNUUSVAUDUOZUUDUUFUUTUVAYPWFVRAUUDYOQ
      VKUUPYBVNIUUSLVIVJZWGUUSLVOGYBWHWIYPUUHBGYPUUFUUIUUKUUOWJWKAUUCCVPYOTVKZW
      LYPWCYHUDZUUJGUDZUUCCYPUUTWCUUSUOUVDUVEVPUVBWNUUSLWCGYBWHWIYPUUJBGYPUUFUU
      IUUKUUOWMWKUVCWLWOZYBYKYCWPYBYKVPYHYMVPYJYNVPYBYKGWQYHYMYIWPVFAYOYKYAUOZY
      DYLVPZVQZUPZYHYMYIUUGUUGYIWRUVJJWSVRUVJGYBYKIJUVJYBYKYCXFUVHAYOUVGUVHWTUV
      JYBYKYCUUEUUEYCWRUVJIWSVRUVJUUFUUIUUKUVJYOUULAYOUVGUVHXAAYOUULXBUVIUUNVKX
      CWAXDXEAUUAUVIRVKXGXHXIAFYDYJUNXTHYAPYQUVFXJXCAKYFXTHAKYAYCXKZYFAKDILBMQS
      UUMXLUVKUBUGYDVPFYAXQUBXRYFFUBYAYCXMFUBYAYDYEYEUTXNXOXPXSXE $.

    $( The value of the loop transfer function on the equivalence class of a
       path.  (Contributed by Mario Carneiro, 10-Aug-2015.)  (Proof shortened
       by Mario Carneiro, 23-Dec-2016.) $)
    pi1coval $p |- ( ( ph /\ T e. U. V ) ->
        ( G ` [ T ] ( ~=ph ` J ) ) = [ ( F o. T ) ] ( ~=ph ` K ) ) $=
      ( cv cphtpc cfv cec ccom cvv cuni wcel wa fvex ecexg mp1i eceq1 coeq2 syl
      wceq cbs wf wfun pi1cof ffun fliftval ) AGGUBZJUCUDZUEZHVDUFZKUCUDZUEZFVE
      UEHFUFZVHUEZUGUGILUHZFQVEUGUIVFUGUIAVDVLUIUJZJUCUKVDUGVEULUMVHUGUIVIUGUIV
      MKUCUKVGUGVHULUMVDFVEUNVDFUQVGVJUQVIVKUQVDFHUOVGVJVHUNUPALEURUDZIUSIUTABC
      DEGHIJKLMNOPQRSTUAVALVNIVBUPVC $.

    $( The mapping ` G ` between fundamental groups is a group homomorphism.
       (Contributed by Mario Carneiro, 10-Aug-2015.)  (Revised by Mario
       Carneiro, 23-Dec-2016.) $)
    pi1coghm $p |- ( ph -> G e. ( P GrpHom Q ) ) $=
      ( vy vz vf vh cgrp wcel wa cbs cfv wf cplusg wceq wral cghm ctopon pi1grp
      cv syl2anc cuni ctop ccn cntop2 eqid toptopon sylib cnf2 syl3anc ffvelrnd
      co syl eqeltrrd jca pi1cof cphtpc cqs a1i pi1bas2 eleq2d biimpa cec oveq1
      fveq2d fveq2 oveq1d eqeq12d ralbidv oveq2 oveq2d cpco ccom cii cc0 c1 w3a
      pi1eluni simp1d adantr simp3d simp2d ad2antrr copco eceq1 pcocn pco0 pco1
      eqtr4d eqtrd mpbir3and pi1coval adantlr syldan cnco iitopon 0elunit fvco3
      cicc sylancl 3eqtrd 1elunit eqidd pi1addval 3eqtr4d simpr oveq12d ectocld
      wb simplr ralrimiva raleqdv mpbird isghm sylanbrc ) ADUEUFZEUEUFZUGKEUHUI
      ZHUJZUAUQZUBUQZDUKUIZVIZHUIZYQHUIZYRHUIZEUKUIZVIZULZUBKUMZUAKUMZUGHDEUNVI
      UFAYMYNAILUOUIUFZBLUFZYMQSDILBMUPURAJJUSZUOUIUFZCUUKUFZYNAJUTUFZUULAGIJVA
      VIUFZUUNRGIJVBVJJUUKUUKVCVDVEZABGUIZCUUKTALUUKBGAUUIUULUUOLUUKGUJQUUPRGIJ
      LUUKVFVGSVHVKZEJUUKCNUPURVLAYPUUHABCDEFGHIJKLMNOPQRSTVMAUUGUAKAYQKUFZYQKU
      SZIVNUIZVOZUFZUUGAUUSUVCAKUVBYQAKDILBMQSKDUHUIULZAOVPZVQZVRVSUCUQZUVAVTZY
      RYSVIZHUIZUVHHUIZUUCUUDVIZULZUBKUMZUUGAUCYQUUTUVAUVBUVBVCZUVHYQULZUVMUUFU
      BKUVPUVJUUAUVLUUEUVPUVIYTHUVHYQYRYSWAWBUVPUVKUUBUUCUUDUVHYQHWCWDWEWFAUVGU
      UTUFZUGZUVNUVMUBUVBUMUVRUVMUBUVBUVHUDUQZUVAVTZYSVIZHUIZUVKUVTHUIZUUDVIZUL
      UVMUVRUDYRUUTUVAUVBUVOUVTYRULZUWBUVJUWDUVLUWEUWAUVIHUVTYRUVHYSWGWBUWEUWCU
      UCUVKUUDUVTYRHWCWHWEUVRUVSUUTUFZUGZUVGUVSIWIUIVIZUVAVTZHUIZGUVGWJZJVNUIZV
      TZGUVSWJZUWLVTZUUDVIZUWBUWDUWGGUWHWJZUWLVTZUWKUWNJWIUIVIZUWLVTZUWJUWPUWGU
      WQUWSULUWRUWTULUWGUVGUVSGIJUVRUVGWKIVAVIZUFZUWFUVRUXBWLUVGUIZBULZWMUVGUIZ
      BULZAUVQUXBUXDUXFWNAKUVGDILBMQSUVEWOVSZWPZWQZUWGUVSUXAUFZWLUVSUIZBULZWMUV
      SUIZBULZUVRUWFUXJUXLUXNWNUVRKUVSDILBMAUUIUVQQWQZAUUJUVQSWQUVDUVROVPWOVSZW
      PZUWGUXEBUXKUVRUXFUWFUVRUXBUXDUXFUXGWRZWQUWGUXJUXLUXNUXPWSZXFZAUUOUVQUWFR
      WTZXAUWQUWSUWLXBVJUVRUWFUWHUUTUFZUWJUWRULZUWGUYBUWHUXAUFWLUWHUIZBULWMUWHU
      IZBULUWGUVGUVSIUXIUXQUXTXCUWGUYDUXCBUWGUVGUVSIUXIUXQXDUVRUXDUWFUVRUXBUXDU
      XFUXGWSZWQXGUWGUYEUXMBUWGUVGUVSIUXIUXQXEUWGUXJUXLUXNUXPWRZXGUWGKUWHDILBMA
      UUIUVQUWFQWTZAUUJUVQUWFSWTZUVDUWGOVPWOXHAUYBUYCUVQABCDEUWHFGHIJKLMNOPQRST
      XIXJXKUWGYOUUDEJUWKUWNUUKCNYOVCZAUULUVQUWFUUPWTAUUMUVQUWFUURWTUUDVCZUVRUW
      KYOUSZUFZUWFUVRUYMUWKWKJVAVIZUFZWLUWKUIZCULWMUWKUIZCULUVRUXBUUOUYOUXHAUUO
      UVQRWQUVGGWKIJXLURUVRUYPUXCGUIZUUQCUVRWLWMXPVIZLUVGUJZWLUYSUFZUYPUYRULUVR
      WKUYSUOUIUFZUUIUXBUYTVUBUVRXMVPUXOUXHUVGWKIUYSLVFVGZXNUYSLWLGUVGXOXQUVRUX
      CBGUYFWBAUUQCULZUVQTWQZXRUVRUYQUXEGUIZUUQCUVRUYTWMUYSUFZUYQVUFULVUCXSUYSL
      WMGUVGXOXQUVRUXEBGUXRWBVUEXRUVRYOUWKEJUUKCNAUULUVQUUPWQAUUMUVQUURWQUVRYOX
      TWOXHWQUWGUWNUYLUFZUWNUYNUFZWLUWNUIZCULZWMUWNUIZCULZUWGUXJUUOVUIUXQUYAUVS
      GWKIJXLURUWGVUJUXKGUIZUUQCUWGUYSLUVSUJZVUAVUJVUNULUWGVUBUUIUXJVUOVUBUWGXM
      VPUYHUXQUVSWKIUYSLVFVGZXNUYSLWLGUVSXOXQUWGUXKBGUXSWBAVUDUVQUWFTWTZXRUWGVU
      LUXMGUIZUUQCUWGVUOVUGVULVURULVUPXSUYSLWMGUVSXOXQUWGUXMBGUYGWBVUQXRAVUHVUI
      VUKVUMWNYFUVQUWFAYOUWNEJUUKCNUUPUURAYOXTWOWTXHYAYBUWGUWAUWIHUWGKYSDIUVGUV
      SLBMOUYHUYIYSVCZAUVQUWFYGUVRUWFYCYAWBUWGUVKUWMUWCUWOUUDUVRUVKUWMULUWFABCD
      EUVGFGHIJKLMNOPQRSTXIWQAUWFUWCUWOULUVQABCDEUVSFGHIJKLMNOPQRSTXIXJYDYBYEYH
      UVRUVMUBKUVBAKUVBULUVQUVFWQYIYJYEXKYHVLUBUAYSUUDDEHKYOOUYJVUSUYKYKYL $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                       Complex metric vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Complex left modules
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CMod $. $( Complex module $)

  $( Complex module. $)
  cclm $a class CMod $.

  ${
    $d f k w F $.  $d f k w K $.  $d f k w W $.
    $( Define a complex module, which is just a left module over a subring of
       ` CC ` , which allows us to use conventional addition, multiplication,
       etc. in the left module theorems.  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    df-clm $a |- CMod = { w e. LMod | [. ( Scalar ` w ) / f ].
      [. ( Base ` f ) / k ].
        ( f = ( CCfld |`s k ) /\ k e. ( SubRing ` CCfld ) ) } $.

    isclm.f $e |- F = ( Scalar ` W ) $.
    isclm.k $e |- K = ( Base ` F ) $.
    $( A complex module is a left module over a subring of the complexes.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    isclm $p |- ( W e. CMod <-> ( W e. LMod /\
      F = ( CCfld |`s K ) /\ K e. ( SubRing ` CCfld ) ) ) $=
      ( vf vk vw cclm wcel clmod ccnfld cress wceq cfv wa cv cbs csca cvv co id
      csubrg w3a wsbc fvex fveq2 syl6eqr sylan9eqr adantr fveq2d oveq2d eqeq12d
      a1i eleq1d anbi12d sbcied df-clm elrab2 3anass bitr4i ) CIJCKJZALBMUAZNZB
      LUCOZJZPZPVBVDVFUDFQZLGQZMUAZNZVIVEJZPZGVHROZUEZFHQZSOZUEVGHCKIVPCNZVOVGF
      VQTVQTJVRVPSUFUNVRVHVQNZPZVMVGGVNTVNTJVTVHRUFUNVTVIVNNZPZVKVDVLVFWBVHAVJV
      CVTVHANWAVSVRVHVQAVSUBVRVQCSOAVPCSUGDUHUIZUJWBVIBLMWAVTVIVNBWAUBVTVNAROBV
      TVHARWCUKEUHUIZULUMWBVIBVEWDUOUPUQUQHFGURUSVBVDVFUTVA $.

    $( A complex module is a left module over a subring of the complexes.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmsca $p |- ( W e. CMod -> F = ( CCfld |`s K ) ) $=
      ( cclm wcel clmod ccnfld cress co wceq csubrg cfv isclm simp2bi ) CFGCHGA
      IBJKLBIMNGABCDEOP $.

    $( A complex module is a left module over a subring of the complexes.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmsubrg $p |- ( W e. CMod -> K e. ( SubRing ` CCfld ) ) $=
      ( cclm wcel clmod ccnfld cress co wceq csubrg cfv isclm simp3bi ) CFGCHGA
      IBJKLBIMNGABCDEOP $.
  $}

  $( A complex module is a left module.  (Contributed by Mario Carneiro,
     16-Oct-2015.) $)
  clmlmod $p |- ( W e. CMod -> W e. LMod ) $=
    ( cclm wcel clmod csca cfv ccnfld cbs cress wceq csubrg eqid isclm simp1bi
    co ) ABCADCAEFZGPHFZIOJQGKFCPQAPLQLMN $.

  $( A complex module is an additive group.  (Contributed by Mario Carneiro,
     16-Oct-2015.) $)
  clmgrp $p |- ( W e. CMod -> W e. Grp ) $=
    ( cclm wcel clmod cgrp clmlmod lmodgrp syl ) ABCADCAECAFAGH $.

  $( A complex module is an abelian group.  (Contributed by Mario Carneiro,
     16-Oct-2015.) $)
  clmabl $p |- ( W e. CMod -> W e. Abel ) $=
    ( cclm wcel clmod cabel clmlmod lmodabl syl ) ABCADCAECAFAGH $.

  ${
    clm0.f $e |- F = ( Scalar ` W ) $.
    $( The scalar ring of a complex module is a ring.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmrng $p |- ( W e. CMod -> F e. Ring ) $=
      ( cclm wcel clmod crg clmlmod lmodrng syl ) BDEBFEAGEBHABCIJ $.

    $( The scalar ring of a complex module is a group.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmfgrp $p |- ( W e. CMod -> F e. Grp ) $=
      ( cclm wcel clmod cgrp clmlmod lmodfgrp syl ) BDEBFEAGEBHABCIJ $.

    $( The zero of the scalar ring of a complex module.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clm0 $p |- ( W e. CMod -> 0 = ( 0g ` F ) ) $=
      ( cclm wcel cc0 ccnfld cbs cfv cress c0g csubrg wceq eqid clmsubrg cnfld0
      co subrg0 syl clmsca fveq2d eqtr4d ) BDEZFGAHIZJQZKIZAKIUCUDGLIEFUFMAUDBC
      UDNZOUDGUEFUENPRSUCAUEKAUDBCUGTUAUB $.

    $( The identity of the scalar ring of a complex module.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    clm1 $p |- ( W e. CMod -> 1 = ( 1r ` F ) ) $=
      ( cclm wcel c1 ccnfld cbs cfv cress co cur csubrg wceq eqid cnfld1 subrg1
      clmsubrg syl clmsca fveq2d eqtr4d ) BDEZFGAHIZJKZLIZALIUCUDGMIEFUFNAUDBCU
      DOZRUDGUEFUEOPQSUCAUELAUDBCUGTUAUB $.

    $( The addition of the scalar ring of a complex module.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    clmadd $p |- ( W e. CMod -> + = ( +g ` F ) ) $=
      ( cclm wcel cplusg cfv ccnfld cbs cress caddc eqid clmsca fveq2d cvv wceq
      co fvex cnfldadd ressplusg ax-mp syl6reqr ) BDEZAFGHAIGZJQZFGZKUCAUEFAUDB
      CUDLMNUDOEKUFPAIRUDKHUEOUELSTUAUB $.

    $( The multiplication of the scalar ring of a complex module.  (Contributed
       by Mario Carneiro, 16-Oct-2015.) $)
    clmmul $p |- ( W e. CMod -> x. = ( .r ` F ) ) $=
      ( cclm wcel cmulr cfv ccnfld cbs co cmul eqid clmsca fveq2d cvv wceq fvex
      cress cnfldmul ressmulr ax-mp syl6reqr ) BDEZAFGHAIGZRJZFGZKUCAUEFAUDBCUD
      LMNUDOEKUFPAIQUDHUEKOUELSTUAUB $.

    $( The conjugation of the scalar ring of a complex module.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    clmcj $p |- ( W e. CMod -> * = ( *r ` F ) ) $=
      ( cclm wcel cstv cfv ccnfld cbs cress co ccj eqid clmsca fveq2d wceq fvex
      cvv cnfldcj ressstarv ax-mp syl6reqr ) BDEZAFGHAIGZJKZFGZLUCAUEFAUDBCUDMN
      OUDRELUFPAIQUDHUELRUEMSTUAUB $.

    $( Reverse direction of ~ isclm .  (Contributed by Mario Carneiro,
       30-Oct-2015.) $)
    isclmi $p |- ( ( W e. LMod /\ F = ( CCfld |`s K ) /\
                     K e. ( SubRing ` CCfld ) ) -> W e. CMod ) $=
      ( clmod wcel ccnfld cress co wceq csubrg cfv w3a cbs simp1 simp2 subrgbas
      cclm eqid 3ad2ant3 fveq2d eqtr4d oveq2d eqtrd simp3 eqeltrrd syl3anbrc
      isclm ) CEFZAGBHIZJZBGKLZFZMZUIAGANLZHIZJUOULFCRFUIUKUMOUNAUJUPUIUKUMPZUN
      BUOGHUNBUJNLZUOUMUIBURJUKBGUJUJSQTUNAUJNUQUAUBZUCUDUNBUOULUSUIUKUMUEUFAUO
      CDUOSUHUG $.

    clmsub.k $e |- K = ( Base ` F ) $.
    $( The scalar ring of a complex module contains the integers.  (Contributed
       by Mario Carneiro, 16-Oct-2015.) $)
    clmzss $p |- ( W e. CMod -> ZZ C_ K ) $=
      ( cclm wcel ccnfld csubrg cfv cz wss clmsubrg zsssubrg syl ) CFGBHIJGKBLA
      BCDEMBNO $.

    $( The scalar ring of a complex module is a subset of the complexes.
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmsscn $p |- ( W e. CMod -> K C_ CC ) $=
      ( cclm wcel ccnfld csubrg cfv cc wss clmsubrg cnfldbas subrgss syl ) CFGB
      HIJGBKLABCDEMBKHNOP $.

    $( Subtraction in the scalar ring of a complex module.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    clmsub $p |- ( ( W e. CMod /\ A e. K /\ B e. K ) ->
      ( A - B ) = ( A ( -g ` F ) B ) ) $=
      ( cclm wcel w3a cmin co ccnfld cress csg cfv csubg wceq csubrg eqid oveqd
      clmsubrg subrgsubg cnfldsub subgsub syl3an1 clmsca fveq2d 3ad2ant1 eqtr4d
      syl ) EHIZADIZBDIZJZABKLZABMDNLZOPZLZABCOPZLULDMQPIZUMUNUPUSRULDMSPIVACDE
      FGUBDMUCUKDMUQKURABUDUQTURTUEUFUOUTURABULUMUTURRUNULCUQOCDEFGUGUHUIUAUJ
      $.

    $( Negation in the scalar ring of a complex module.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmneg $p |- ( ( W e. CMod /\ A e. K ) -> -u A = ( ( invg ` F ) ` A ) ) $=
      ( cclm wcel wa cminusg cfv ccnfld cress co cneg wceq clmsca syl eqid cc
      fveq2d adantr fveq1d csubg csubrg clmsubrg subrgsubg subginv sylan sselda
      clmsscn cnfldneg 3eqtr2rd ) DGHZACHZIZABJKZKALCMNZJKZKZALJKZKZAOZUPAUQUSU
      NUQUSPUOUNBURJBCDEFQUAUBUCUNCLUDKHZUOVBUTPUNCLUEKHVDBCDEFUFCLUGRCLURVAUSA
      URSVASUSSUHUIUPATHVBVCPUNCTABCDEFUKUJAULRUM $.

    $( Norm in the scalar ring of a complex module.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmabs $p |- ( ( W e. CMod /\ A e. K ) ->
      ( abs ` A ) = ( ( norm ` F ) ` A ) ) $=
      ( cclm wcel wa cnm cfv ccnfld cress cabs wceq clmsca fveq2d adantr eqid
      co fveq1d csubg csubrg clmsubrg subrgsubg cnfldnm subgnm2 sylan eqtr2d
      syl ) DGHZACHZIZABJKZKALCMTZJKZKZANKZUMAUNUPUKUNUPOULUKBUOJBCDEFPQRUAUKCL
      UBKHZULUQUROUKCLUCKHUSBCDEFUDCLUEUJCLUOUPNAUOSUFUPSUGUHUI $.

    $( Closure of ring addition for a complex module.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmacl $p |- ( ( W e. CMod /\ X e. K /\ Y e. K ) -> ( X + Y ) e. K ) $=
      ( cclm wcel ccnfld csubrg cfv caddc co clmsubrg cnfldadd subrgacl syl3an1
      ) CHIBJKLIDBIEBIDEMNBIABCFGOBMJDEPQR $.

    $( Closure of ring multiplication for a complex module.  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    clmmcl $p |- ( ( W e. CMod /\ X e. K /\ Y e. K ) -> ( X x. Y ) e. K ) $=
      ( cclm wcel ccnfld csubrg cfv cmul co clmsubrg cnfldmul subrgmcl syl3an1
      ) CHIBJKLIDBIEBIDEMNBIABCFGOBJMDEPQR $.

    $( Closure of ring subtraction for a complex module.  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmsubcl $p |- ( ( W e. CMod /\ X e. K /\ Y e. K ) -> ( X - Y ) e. K ) $=
      ( cclm wcel ccnfld csubg cfv cmin csubrg clmsubrg subrgsubg syl subgsubcl
      co cnfldsub syl3an1 ) CHIZBJKLIZDBIEBIDEMSBIUBBJNLIUCABCFGOBJPQBJMDETRUA
      $.
  $}

  $( The domain of a linear operator is a complex module iff the range is.
     (Contributed by Mario Carneiro, 21-Oct-2015.) $)
  lmhmclm $p |- ( F e. ( S LMHom T ) -> ( S e. CMod <-> T e. CMod ) ) $=
    ( clmhm wcel clmod csca cfv ccnfld cbs cress wceq csubrg w3a cclm lmhmlmod1
    co lmhmlmod2 eqid isclm 2thd lmhmsca eqcomd fveq2d oveq2d eqeq12d 3anbi123d
    eleq1d 3bitr4g ) CABDQEZAFEZAGHZIULJHZKQZLZUMIMHZEZNBFEZBGHZIUSJHZKQZLZUTUP
    EZNAOEBOEUJUKURUOVBUQVCUJUKURABCPABCRUAUJULUSUNVAUJUSULABCULUSULSZUSSZUBUCZ
    UJUMUTIKUJULUSJVFUDZUEUFUJUMUTUPVGUHUGULUMAVDUMSTUSUTBVEUTSTUI $.

  ${
    clmvsdir.v $e |- V = ( Base ` W ) $.
    clmvsdir.f $e |- F = ( Scalar ` W ) $.
    clmvsdir.s $e |- .x. = ( .s ` W ) $.
    clmvsdir.k $e |- K = ( Base ` F ) $.
    $( Associative law for scalar product.  ( ~ lmodvsass analog.)
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmvsass $p |- ( ( W e. CMod /\ ( Q e. K /\ R e. K /\ X e. V ) ) ->
                      ( ( Q x. R ) .x. X ) = ( Q .x. ( R .x. X ) ) ) $=
      ( cclm wcel w3a wa cmul co cmulr wceq cfv clmmul adantr oveqd oveq1d eqid
      clmod clmlmod lmodvsass sylan eqtrd ) GMNZAENBENHFNOZPZABQRZHCRABDSUAZRZH
      CRZABHCRCRZUNUOUQHCUNQUPABULQUPTUMDGJUBUCUDUEULGUGNUMURUSTGUHABCUPDEFGHIJ
      KLUPUFUIUJUK $.

    clmvsdir.a $e |- .+ = ( +g ` W ) $.
    $( Distributive law for scalar product.  ( ~ lmodvsdir analog.)
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmvsdir $p |- ( ( W e. CMod /\ ( Q e. K /\ R e. K /\ X e. V ) ) ->
                      ( ( Q + R ) .x. X ) = ( ( Q .x. X ) .+ ( R .x. X ) ) ) $=
      ( cclm wcel w3a caddc co wceq cplusg cfv clmadd oveqd oveq1d adantr clmod
      wa clmlmod eqid lmodvsdir sylan eqtrd ) HOPZBFPCFPIGPQZUHBCRSZIDSZBCEUAUB
      ZSZIDSZBIDSCIDSASZUNUQUTTUOUNUPUSIDUNRURBCEHKUCUDUEUFUNHUGPUOUTVATHUIAURB
      CDEFGHIJNKLMURUJUKULUM $.
  $}

  ${
    clmvs1.v $e |- V = ( Base ` W ) $.
    clmvs1.s $e |- .x. = ( .s ` W ) $.
    $( Scalar product with ring unit.  ( ~ lmodvs1 analog.)  (Contributed by
       Mario Carneiro, 16-Oct-2015.) $)
    clmvs1 $p |- ( ( W e. CMod /\ X e. V ) -> ( 1 .x. X ) = X ) $=
      ( cclm wcel wa c1 co csca cfv cur wceq eqid clm1 adantr oveq1d clmod
      clmlmod lmodvs1 sylan eqtrd ) CGHZDBHZIZJDAKCLMZNMZDAKZDUGJUIDAUEJUIOUFUH
      CUHPZQRSUECTHUFUJDOCUAAUIUHBCDEUKFUIPUBUCUD $.
  $}

  ${
    clm0vs.v $e |- V = ( Base ` W ) $.
    clm0vs.f $e |- F = ( Scalar ` W ) $.
    clm0vs.s $e |- .x. = ( .s ` W ) $.
    clm0vs.z $e |- .0. = ( 0g ` W ) $.
    $( Zero times a vector is the zero vector.  Equation 1a of [Kreyszig]
       p. 51.  ( ~ lmod0vs analog.)  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    clm0vs $p |- ( ( W e. CMod /\ X e. V ) -> ( 0 .x. X ) = .0. ) $=
      ( cclm wcel wa cc0 co c0g cfv wceq clm0 adantr clmod clmlmod eqid lmod0vs
      oveq1d sylan eqtrd ) DKLZECLZMZNEAOBPQZEAOZFUJNUKEAUHNUKRUIBDHSTUEUHDUALU
      IULFRDUBABUKCDEFGHIUKUCJUDUFUG $.
  $}

  ${
    clmvneg1.v $e |- V = ( Base ` W ) $.
    clmvneg1.n $e |- N = ( invg ` W ) $.
    clmvneg1.f $e |- F = ( Scalar ` W ) $.
    clmvneg1.s $e |- .x. = ( .s ` W ) $.
    $( Minus 1 times a vector is the negative of the vector.  Equation 2 of
       [Kreyszig] p. 51.  ( ~ lmodvneg1 analog.)  (Contributed by Mario
       Carneiro, 16-Oct-2015.) $)
    clmvneg1 $p |- ( ( W e. CMod /\ X e. V ) -> ( -u 1 .x. X ) = ( N ` X ) ) $=
      ( cclm wcel wa c1 co cfv wceq cz eqid eqtrd cur cminusg cbs clmzss 1z a1i
      cneg sseldd clmneg mpdan clm1 fveq2d adantr clmod clmlmod lmodvneg1 sylan
      oveq1d ) EKLZFDLZMZNUGZFAOBUAPZBUBPZPZFAOZFCPZVAVBVEFAUSVBVEQUTUSVBNVDPZV
      EUSNBUCPZLVBVHQUSRVINBVIEIVISZUDNRLUSUEUFUHNBVIEIVJUIUJUSNVCVDBEIUKULTUMU
      RUSEUNLUTVFVGQEUOAVCBVDCDEFGHIJVCSVDSUPUQT $.
  $}

  ${
    clmvsneg.b $e |- B = ( Base ` W ) $.
    clmvsneg.f $e |- F = ( Scalar ` W ) $.
    clmvsneg.s $e |- .x. = ( .s ` W ) $.
    clmvsneg.n $e |- N = ( invg ` W ) $.
    clmvsneg.k $e |- K = ( Base ` F ) $.
    clmvsneg.w $e |- ( ph -> W e. CMod ) $.
    clmvsneg.x $e |- ( ph -> X e. B ) $.
    clmvsneg.r $e |- ( ph -> R e. K ) $.
    $( Multiplication of a vector by a negated scalar.  ( ~ lmodvsneg analog.)
       (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmvsneg $p |- ( ph -> ( N ` ( R .x. X ) ) = ( -u R .x. X ) ) $=
      ( co cfv wcel cminusg cneg eqid cclm clmod clmlmod lmodvsneg wceq syl2anc
      syl clmneg oveq1d eqtr4d ) ACIDRGSCEUASZSZIDRCUBZIDRABCDEFUNGHIJKLMNUNUCA
      HUDTZHUETOHUFUJPQUGAUPUOIDAUQCFTUPUOUHOQCEFHKNUKUIULUM $.
  $}

  ${
    $d x y B $.  $d x y V $.  $d x y W $.  $d x y .x. $.  $d x y .xb $.
    $d x A $.
    clmmulg.1 $e |- V = ( Base ` W ) $.
    clmmulg.2 $e |- .xb = ( .g ` W ) $.
    clmmulg.3 $e |- .x. = ( .s ` W ) $.
    $( The group multiple function matches the scalar multiplication function.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    clmmulg $p |- ( ( W e. CMod /\ A e. ZZ /\ B e. V ) ->
      ( A .xb B ) = ( A .x. B ) ) $=
      ( wcel cz co wceq cc0 c1 oveq1 eqeq12d cfv eqid ad2antrr vx vy cclm caddc
      cv cneg wa c0g mulg0 adantl csca clm0vs eqtr4d wi cplusg cmnd cgrp clmgrp
      cn0 grpmnd syl simplr mulgnn0p1 syl3anc cbs simpll wss clmzss nn0z sseldd
      simpr 1z a1i clmvsdir syl13anc clmvs1 adantr oveq2d eqtrd syl5ibr cminusg
      ex cn fveq2 nnz mulgneg clmvsneg eqcomd zindd 3impia 3com23 ) FUCJZBEJZAK
      JZABCLZABDLZMZWLWMWNWQUAUEZBCLZWRBDLZMNBCLZNBDLZMUBUEZBCLZXCBDLZMZXCUFZBC
      LZXGBDLZMZXCOUDLZBCLZXKBDLZMZWQWLWMUGZUAUBAWRNMWSXAWTXBWRNBCPWRNBDPQWRXCM
      WSXDWTXEWRXCBCPWRXCBDPQWRXKMWSXLWTXMWRXKBCPWRXKBDPQWRXGMWSXHWTXIWRXGBCPWR
      XGBDPQWRAMWSWOWTWPWRABCPWRABDPQXOXAFUHRZXBWMXAXPMWLECFBXPGXPSZHUIUJDFUKRZ
      EFBXPGXRSZIXQULUMXOXCUSJZXFXNUNXFXNXOXTUGZXDBFUORZLZXEBYBLZMXDXEBYBPYAXLY
      CXMYDYAFUPJZXTWMXLYCMWLYEWMXTWLFUQJZYEFURZFUTVATXOXTVKWLWMXTVBZEYBCFXCBGH
      YBSZVCVDYAXMXEOBDLZYBLZYDYAWLXCXRVERZJOYLJWMXMYKMWLWMXTVFYAKYLXCWLKYLVGZW
      MXTXRYLFXSYLSZVHZTZXTXCKJZXOXCVIUJVJYAKYLOYPOKJYAVLVMVJYHYBXCODXRYLEFBGXS
      IYNYIVNVOYAYJBXEYBXOYJBMXTDEFBGIVPVQVRVSQVTWBXOXCWCJZXFXJUNXFXJXOYRUGZXDF
      WARZRZXEYTRZMXDXEYTWDYSXHUUAXIUUBYSYFYQWMXHUUAMWLYFWMYRYGTYRYQXOXCWEUJZWL
      WMYRVBZECFYTXCBGHYTSZWFVDYSUUBXIYSEXCDXRYLYTFBGXSIUUEYNWLWMYRVFUUDYSKYLXC
      WLYMWMYRYOTUUCVJWGWHQVTWBWIWJWK $.
  $}

  ${
    clmsubdir.v $e |- V = ( Base ` W ) $.
    clmsubdir.t $e |- .x. = ( .s ` W ) $.
    clmsubdir.f $e |- F = ( Scalar ` W ) $.
    clmsubdir.k $e |- K = ( Base ` F ) $.
    clmsubdir.m $e |- .- = ( -g ` W ) $.
    clmsubdir.w $e |- ( ph -> W e. CMod ) $.
    clmsubdir.a $e |- ( ph -> A e. K ) $.
    clmsubdir.b $e |- ( ph -> B e. K ) $.
    clmsubdir.x $e |- ( ph -> X e. V ) $.
    $( Scalar multiplication distributive law for subtraction.  ( ~ lmodsubdir
       analog.)  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    clmsubdir $p |- ( ph ->
      ( ( A - B ) .x. X ) = ( ( A .x. X ) .- ( B .x. X ) ) ) $=
      ( co cmin csg cfv cclm wcel wceq clmsub syl3anc oveq1d eqid clmod clmlmod
      syl lmodsubdir eqtrd ) ABCUATZJDTBCEUBUCZTZJDTBJDTCJDTGTAUPURJDAIUDUEZBFU
      ECFUEUPURUFPQRBCEFIMNUGUHUIABCUQDEFGHIJKLMNOUQUJAUSIUKUEPIULUMQRSUNUO $.
  $}

  ${
    $d x y z G $.  $d x y z W $.
    zlmclm.w $e |- W = ( ZMod ` G ) $.
    $( The ` ZZ ` -module operation turns an arbitrary abelian group into a
       complex module.  (Contributed by Mario Carneiro, 30-Oct-2015.) $)
    zlmclm $p |- ( G e. Abel <-> W e. CMod ) $=
      ( cabel wcel cclm clmod csca cfv ccnfld cz cress co csubrg zlmlmod biimpi
      wceq eqid zlmsca eqcomd zsubrg a1i isclmi syl3anc clmlmod sylibr impbii )
      ADEZBFEZUHBGEZBHIZJKLMZQKJNIEZUIUHUJABCOZPUHULUKADBULCULRSTUMUHUAUBUKKBUK
      RUCUDUIUJUHBUEUNUFUG $.

    clmzlmvsca.x $e |- X = ( Base ` G ) $.
    $( The scalar product of a complex module matches the scalar product of the
       derived ` ZZ ` -module, which implies, together with ~ zlmbas and
       ~ zlmplusg , that any module over ` ZZ ` is structure-equivalent to the
       canonical ` ZZ ` -module ` ZMod `` G ` .  (Contributed by Mario
       Carneiro, 30-Oct-2015.) $)
    clmzlmvsca $p |- ( ( G e. CMod /\ ( A e. ZZ /\ B e. X ) ) ->
                       ( A ( .s ` G ) B ) = ( A ( .s ` W ) B ) ) $=
      ( cclm wcel cz cvsca cfv co wceq w3a cmg eqid zlmvsca eqcomi clmmulg
      eqcomd 3expb ) CHIZAJIZBEIZABCKLZMZABDKLZMZNUCUDUEOUIUGABUHUFECGCPLZUHUJC
      DFUJQRSUFQTUAUB $.
  $}

  ${
    $d r x y z A $.  $d r x y z F $.  $d r x y z L $.  $d x y N $.  $d y z O $.
    $d r x y z M $.  $d r x y z ph $.  $d y ps $.  $d x y z S $.  $d x y z V $.
    $d r B $.  $d r x y z R $.  $d y T $.
    nmoleub2.n $e |- N = ( S normOp T ) $.
    nmoleub2.v $e |- V = ( Base ` S ) $.
    nmoleub2.l $e |- L = ( norm ` S ) $.
    nmoleub2.m $e |- M = ( norm ` T ) $.
    nmoleub2.g $e |- G = ( Scalar ` S ) $.
    nmoleub2.w $e |- K = ( Base ` G ) $.
    nmoleub2.s $e |- ( ph -> S e. ( NrmMod i^i CMod ) ) $.
    nmoleub2.t $e |- ( ph -> T e. ( NrmMod i^i CMod ) ) $.
    nmoleub2.f $e |- ( ph -> F e. ( S LMHom T ) ) $.
    nmoleub2.a $e |- ( ph -> A e. RR* ) $.
    nmoleub2.r $e |- ( ph -> R e. RR+ ) $.
    ${
      nmoleub2lem.5 $e |- ( ( ph /\
        A. x e. V ( ps -> ( ( M ` ( F ` x ) ) / R ) <_ A ) ) -> 0 <_ A ) $.
      nmoleub2lem.6 $e |- ( ( ( ( ph /\ A. x e. V ( ps -> ( ( M ` ( F ` x ) )
         / R ) <_ A ) ) /\ A e. RR ) /\ ( y e. V /\ y =/= ( 0g ` S ) ) )
      -> ( M ` ( F ` y ) ) <_ ( A x. ( L ` y ) ) ) $.
      nmoleub2lem.7 $e |- ( ( ph /\ x e. V ) -> ( ps -> ( L ` x ) <_ R ) ) $.
      $( Lemma for ~ nmoleub2a and similar theorems.  (Contributed by Mario
         Carneiro, 19-Oct-2015.) $)
      nmoleub2lem $p |- ( ph -> ( ( N ` F ) <_ A <->
          A. x e. V ( ps -> ( ( M ` ( F ` x ) ) / R ) <_ A ) ) ) $=
        ( cfv cle wbr cv cdiv co wi wral wa wcel adantlr cngp cbs cnlm cclm cin
        cr inss1 sseldi nlmngp syl ad2antrr wf clmhm eqid lmhmf simprl ffvelrnd
        nmcl syl2anc crp rerpdivcld rexrd cxr cghm lmghm syl3anc cxmu cmul wceq
        nmocl rpred rexmul recnd rpne0d divcan1d eqtrd rpxrd nmoix syl31anc cc0
        xmulcld nmoge0 simprr xlemul2a xrletrd eqbrtrd wb xlemul1 mpbird simplr
        jca expr syld ralrimiva cpnf c0g simpr adantr nmolb2d breqtrrd cmnf wne
        pnfge wo ge0nemnf xrnemnf sylib mpjaodan impbida ) AINUJZEUKULZBCUMZIUJ
        ZMUJZFUNUOZEUKULZUPZCOUQZAYKURZYQCOYSYLOUSZURBYLLUJZFUKULZYPAYTBUUBUPYK
        UIUTYSYTUUBYPYSYTUUBURZURZYOYJEUUDYOUUDYNFUUDHVAUSZYMHVBUJZUSYNVFUSAUUE
        YKUUCAHVCUSUUEAVCVDVEZVCHVCVDVGZUCVHHVIVJZVKZUUDOUUFYLIAOUUFIVLZYKUUCAI
        GHVMUOUSZUUKUDOUUFGHIQUUFVNZVOVJVKYSYTUUBVPZVQYMHMUUFUUMSVRVSZAFVTUSZYK
        UUCUFVKZWAZWBZAYJWCUSZYKUUCAGVAUSZUUEIGHWDUOUSZUUTAGVCUSUVAAUUGVCGUUHUB
        VHGVIVJZUUIAUULUVBUDGHIWEVJZGHINPWJWFZVKZAEWCUSZYKUUCUEVKUUDYOYJUKULZYO
        FWGUOZYJFWGUOZUKULZUUDUVIYNUVJUKUUDUVIYOFWHUOZYNUUDYOVFUSFVFUSUVIUVLWIU
        URUUDFUUQWKZYOFWLVSUUDYNFUUDYNUUOWMUUDFUVMWMUUDFUUQWNWOWPUUDYNYJUUAWGUO
        ZUVJUUDYNUUOWBUUDYJUUAUVFUUDUUAUUDUVAYTUUAVFUSAUVAYKUUCUVCVKZUUNYLGLOQR
        VRVSWBZXAUUDYJFUVFUUDFUUQWQZXAUUDUVAUUEUVBYTYNUVNUKULUVOUUJAUVBYKUUCUVD
        VKUUNGHILMNOYLPQRSWRWSUUDUUAWCUSFWCUSUUTWTYJUKULZURZUUBUVNUVJUKULUVPUVQ
        AUVSYKUUCAUUTUVRUVEAUVAUUEUVBUVRUVCUUIUVDGHINPXBWFXKVKYSYTUUBXCUUAFYJXD
        WSXEXFUUDYOWCUSUUTUUPUVHUVKXGUUSUVFUUQYOYJFXHWFXIAYKUUCXJXEXLXMXNAYRURZ
        EVFUSZYKEXOWIZUVTUWAURDEGHILMNOGXPUJZPQRSUWCVNAUVAYRUWAUVCVKAUUEYRUWAUU
        IVKAUVBYRUWAUVDVKUVTUWAXQUVTWTEUKULZUWAUGXRUHXSUVTUWBURZYJXOEUKUWEUUTYJ
        XOUKULAUUTYRUWBUVEVKYJYCVJUVTUWBXQXTUVTUVGEYAYBZURUWAUWBYDUVTUVGUWFAUVG
        YRUEXRZUVTUVGUWDUWFUWGUGEYEVSXKEYFYGYHYI $.
    $}

    ${
      nmoleub2a.5 $e |- ( ph -> QQ C_ K ) $.
      ${
        nmoleub2lem3.p $e |- .x. = ( .s ` S ) $.
        nmoleub2lem3.1 $e |- ( ph -> A e. RR ) $.
        nmoleub2lem3.2 $e |- ( ph -> 0 <_ A ) $.
        nmoleub2lem3.3 $e |- ( ph -> B e. V ) $.
        nmoleub2lem3.4 $e |- ( ph -> B =/= ( 0g ` S ) ) $.
        nmoleub2lem3.5 $e |- ( ph -> ( ( r .x. B ) e. V ->
 ( ( L ` ( r .x. B ) ) < R -> ( ( M ` ( F ` ( r .x. B ) ) ) / R ) <_ A ) ) ) $.
        nmoleub2lem3.6 $e |- ( ph ->
          -. ( M ` ( F ` B ) ) <_ ( A x. ( L ` B ) ) ) $.
        $( Lemma for ~ nmoleub2a and similar theorems.  (Contributed by Mario
           Carneiro, 19-Oct-2015.) $)
        nmoleub2lem3 $p |- -. ph $=
          ( cfv cmul co cle wbr cdiv cv clt wa cq wrex wcel rpred remulcld cngp
          cr cbs cnlm cclm cin inss1 sseldi nlmngp clmhm wf eqid lmhmf ffvelrnd
          syl nmcl syl2anc cc0 0re nmge0 mulge0d wn ltnled mpbird lelttrd elrpd
          a1i rerpdivcld c0g wne crp nmrpcl syl3anc wceq recnd w3a mulass mul12
          cc eqtrd ltmul2dd eqbrtrd wb rpregt0d jca lt2mul2div syl22anc qbtwnre
          mpbid simprl cvsca csca ad2antrr sselda adantr lmhmlin fveq2d lmhmsca
          syl6eqr eleqtrrd nmvs fveq1d cabs inss2 clmabs ad2antlr rpge0d divge0
          cnm qre oveq1d wi ltled absidd eqtr3d clmod nlmlmod lmodvscl ltmuldiv
          3eqtrd simprr mp2d eqbrtrrd ledivmul2d lemuldiv pm2.21dd ex rexlimdva
          lenltd mpd pm2.65i ) ACHUOZLUOZBCKUOZUPUQZURUSZABDUPUQZUVAUTUQZOVAZVB
          USZUVGDUVBUTUQZVBUSZVCZOVDVEZUVDAUVFVJVFZUVIVJVFUVFUVIVBUSZUVLAUVEUVA
          ABDUIADUFVGZVHZAUVAAFVIVFZUUTFVKUOZVFZUVAVJVFZAFVLVFZUVQAVLVMVNZVLFVL
          VMVOZUCVPZFVQWCANUVRCHAHEFVRUQVFZNUVRHVSUDNUVREFHQUVRVTZWAWCUKWBZUUTF
          LUVRUWFSWDWEZAWFUVCUVAWFVJVFZAWGWOABUVBUIAEVIVFZCNVFZUVBVJVFZAEVLVFZU
          WJAUWBVLEUWCUBVPZEVQWCZUKCEKNQRWDWEZVHZUWHABUVBUIUWPUJAUWJUWKWFUVBURU
          SUWOUKCEKNQRWHWEWIAUVCUVAVBUSUVDWJUNAUVCUVAUWQUWHWKWLZWMZWNWPZADUVBUV
          OAUWJUWKCEWQUOZWRUVBWSVFUWOUKULCEKNUXAQRUXAVTWTXAZWPAUVEUVBUPUQZDUVAU
          PUQZVBUSZUVNAUXCDUVCUPUQZUXDVBABXGVFZDXGVFZUVBXGVFZUXCUXFXBABUIXCADUV
          OXCAUVBUWPXCUXGUXHUXIXDUXCBDUVBUPUQUPUQUXFBDUVBXEBDUVBXFXHXAAUVCUVADU
          WQUWHUFUWRXIXJAUVEVJVFZUWLWFUVBVBUSVCZDVJVFZUVTWFUVAVBUSZVCZUXEUVNXKU
          VPAUVBUXBXLZUVOAUVTUXMUWHUWSXMZUVEUVBDUVAXNXOXQOUVFUVIXPXAAUVKUVDOVDA
          UVGVDVFZVCZUVKUVDUXRUVKVCZUVHUVDUXRUVHUVJXRZUXSUVGUVFURUSZUVHWJUXSUVG
          UVAUPUQZUVEURUSZUYAUXSUYBDUTUQZBURUSUYCUXSUVGCGUQZHUOZLUOZDUTUQZUYDBU
          RUXSUYGUYBDUTUXSUYGUVGUUTFXSUOZUQZLUOZUVGFXTUOZYQUOZUOZUVAUPUQZUYBUXS
          UYFUYJLUXSUWEUVGJVFZUWKUYFUYJXBAUWEUXQUVKUDYAZUXRUYPUVKAVDJUVGUGYBYCZ
          AUWKUXQUVKUKYAZJEFGUYINHIUVGCTUAQUHUYIVTZYDXAYEUXSUWAUVGUYLVKUOZVFUVS
          UYKUYOXBAUWAUXQUVKUWDYAUXSUVGJVUAUYRUXSVUAIVKUOJUXSUYLIVKUXSUWEUYLIXB
          UYQEFHIUYLTUYLVTZYFWCZYEUAYGYHAUVSUXQUVKUWGYAUYMUYIUYLVUALUVRFUVGUUTU
          WFSUYTVUBVUAVTUYMVTYIXAUXSUYNUVGUVAUPUXSUYNUVGIYQUOZUOZUVGUXSUVGUYMVU
          DUXSUYLIYQVUCYEYJUXSUVGYKUOZVUEUVGUXSEVMVFZUYPVUFVUEXBAVUGUXQUVKAUWBV
          MEVLVMYLUBVPYAUYRUVGIJETUAYMWEUXSUVGUXQUVGVJVFZAUVKUVGYRYNZUXSWFUVGUW
          IUXSWGWOZVUIUXSWFUVFUVGVUJAUVMUXQUVKUWTYAZVUIAWFUVFURUSZUXQUVKAUXJWFU
          VEURUSUVTUXMVULUVPABDUIUVOUJADUFYOWIUWHUWSUVEUVAYPXOYAUXTWMUUAUUBUUCZ
          XHYSUUHYSUXSUYENVFZUYEKUOZDVBUSZUYHBURUSZUXSEUUDVFZUYPUWKVUNUXSUWMVUR
          AUWMUXQUVKUWNYAZEUUEWCUYRUYSUVGGIJNECQTUHUAUUFXAUXSVUOUVGUVBUPUQZDVBU
          XSVUOVUEUVBUPUQZVUTUXSUWMUYPUWKVUOVVAXBVUSUYRUYSVUDGIJKNEUVGCQRUHTUAV
          UDVTYIXAUXSVUEUVGUVBUPVUMYSXHUXSVUTDVBUSZUVJUXRUVHUVJUUIUXSVUHUXLUXKV
          VBUVJXKVUIAUXLUXQUVKUVOYAZAUXKUXQUVKUXOYAUVGDUVBUUGXAWLXJAVUNVUPVUQYT
          YTUXQUVKUMYAUUJUUKUXSUYBBDUXSUVGUVAVUIAUVTUXQUVKUWHYAVHABVJVFUXQUVKUI
          YAZADWSVFUXQUVKUFYAUULXQUXSVUHUXJUXNUYCUYAXKVUIUXSBDVVDVVCVHAUXNUXQUV
          KUXPYAUVGUVEUVAUUMXAXQUXSUVGUVFVUIVUKUUQXQUUNUUOUUPUURUNUUS $.
      $}

      ${
        nmoleub2lem2.6 $e |- ( ( ( L ` x ) e. RR /\ R e. RR ) ->
          ( ( L ` x ) O R -> ( L ` x ) <_ R ) ) $.
        nmoleub2lem2.7 $e |- ( ( ( L ` x ) e. RR /\ R e. RR ) ->
          ( ( L ` x ) < R -> ( L ` x ) O R ) ) $.
        $( Lemma for ~ nmoleub2a and similar theorems.  (Contributed by Mario
           Carneiro, 19-Oct-2015.) $)
        nmoleub2lem2 $p |- ( ph -> ( ( N ` F ) <_ A <->
           A. x e. V ( ( L ` x ) O R -> ( ( M ` ( F ` x ) ) / R ) <_ A ) ) ) $=
          ( vy vz cv cfv wbr cdiv co cle wi wral c0g wceq clmhm wcel cghm lmghm
          cc0 eqid ghmid 3syl fveq2d cnlm cngp cclm cin inss1 sseldi nlmngp nm0
          wa eqtrd adantr oveq1d crp rpcnd rpne0d div0d clt cgrp ngpgrp grpidcl
          syl nmcl sylan rpred syl2anc imim1d ralimdva imp rpgt0d eqbrtrd fveq2
          cr breq1d imbi12d rspcv syl3c eqbrtrrd wne cmul cvsca simp-4l cxr wss
          wn cq simpllr ad3antrrr simplrl simplrr simpr nmoleub2lem3 iman mpbir
          rspccv nmoleub2lem ) ABUKZJULZDMUMZBUICDEFGHIJKLNOPQRSTUAUBUCUDUEAYGY
          EGULZKULZDUNUOZCUPUMZUQZBNURZVRZEUSULZGULZKULZDUNUOZVECUPYNYRVEDUNUOV
          EYNYQVEDUNAYQVEUTYMAYQFUSULZKULZVEAYPYSKAGEFVAUOVBZGEFVCUOVBYPYSUTUCE
          FGVDEFGYOYSYOVFZYSVFZVGVHVIAFVJVBFVKVBYTVEUTAVJVLVMZVJFVJVLVNZUBVOFVP
          FKYSRUUCVQVHVSVTWAYNDYNDADWBVBZYMUEVTZWCYNDUUGWDWEVSYNYONVBZYFDWFUMZY
          KUQZBNURZYOJULZDWFUMZYRCUPUMZAUUHYMAEVKVBZEWGVBUUHAEVJVBZUUOAUUDVJEUU
          EUAVOZEVPZWJZEWHNEYOPUUBWIVHVTAYMUUKAYLUUJBNAYENVBZVRZUUIYGYKUVAYFXAV
          BZDXAVBZUUIYGUQAUUOUUTUVBUUSYEEJNPQWKWLZUVADAUUFUUTUEVTWMZUHWNWOWPWQZ
          YNUULVEDWFAUULVEUTZYMAUUPUUOUVGUUQUUREJYOQUUBVQVHVTYNDUUGWRWSUUJUUMUU
          NUQBYONYEYOUTZUUIUUMYKUUNUVHYFUULDWFYEYOJWTXBUVHYJYRCUPUVHYIYQDUNUVHY
          HYPKYEYOGWTVIWAXBXCXDXEXFZYNCXAVBZVRZUIUKZNVBZUVLYOXGZVRZVRZUVLGULKUL
          CUVLJULXHUOUPUMZUQUVPUVQXMZVRZXMUVSCUVLDEFEXIULZGHIJKLNUJOPQRSTUVSAEU
          UDVBAYMUVJUVOUVRXJZUAWJUVSAFUUDVBUWAUBWJUVSAUUAUWAUCWJUVSACXKVBUWAUDW
          JUVSAUUFUWAUEWJUVSAXNIXLUWAUFWJUVTVFYNUVJUVOUVRXOYNVECUPUMUVJUVOUVRUV
          IXPUVKUVMUVNUVRXQUVKUVMUVNUVRXRUVSUUKUJUKUVLUVTUOZNVBUWBJULZDWFUMZUWB
          GULZKULZDUNUOZCUPUMZUQZUQYNUUKUVJUVOUVRUVFXPUUJUWIBUWBNYEUWBUTZUUIUWD
          YKUWHUWJYFUWCDWFYEUWBJWTXBUWJYJUWGCUPUWJYIUWFDUNUWJYHUWEKYEUWBGWTVIWA
          XBXCYCWJUVPUVRXSXTUVPUVQYAYBUVAUVBUVCYGYFDUPUMUQUVDUVEUGWNYD $.
      $}

      $( The operator norm is the supremum of the value of a linear operator in
         the closed unit ball.  (Contributed by Mario Carneiro,
         19-Oct-2015.) $)
      nmoleub2a $p |- ( ph -> ( ( N ` F ) <_ A <->
          A. x e. V ( ( L ` x ) <_ R -> ( ( M ` ( F ` x ) ) / R ) <_ A ) ) ) $=
        ( cle cv cfv cr wcel wa wbr idd ltle nmoleub2lem2 ) ABCDEFGHIJKLUFMNOPQ
        RSTUAUBUCUDUEBUGJUHZUIUJDUIUJUKUPDUFULUMUPDUNUO $.

      $( The operator norm is the supremum of the value of a linear operator in
         the open unit ball.  (Contributed by Mario Carneiro, 19-Oct-2015.) $)
      nmoleub2b $p |- ( ph -> ( ( N ` F ) <_ A <->
          A. x e. V ( ( L ` x ) < R -> ( ( M ` ( F ` x ) ) / R ) <_ A ) ) ) $=
        ( clt cv cfv ltle cr wcel wa wbr idd nmoleub2lem2 ) ABCDEFGHIJKLUFMNOPQ
        RSTUAUBUCUDUEBUGJUHZDUIUPUJUKDUJUKULUPDUFUMUNUO $.
    $}

    nmoleub3.5 $e |- ( ph -> 0 <_ A ) $.
    nmoleub3.6 $e |- ( ph -> RR C_ K ) $.
    $( The operator norm is the supremum of the value of a linear operator on
       the closed unit sphere.  (Contributed by Mario Carneiro,
       19-Oct-2015.) $)
    nmoleub3 $p |- ( ph -> ( ( N ` F ) <_ A <->
        A. x e. V ( ( L ` x ) = R -> ( ( M ` ( F ` x ) ) / R ) <_ A ) ) ) $=
      ( vy cv cfv wceq cc0 cle wbr cdiv co wi wral adantr wa wcel c0g wne cvsca
      cr cmul csca cnm clmhm ad3antrrr wss crp cngp cnlm cclm cin sseldi nlmngp
      inss1 syl simprl simprr eqid nmrpcl syl3anc rpdivcld rpred sseldd lmhmlin
      fveq2d cbs lmhmsca syl6eqr eleqtrrd lmhmf ffvelrnd nmvs fveq1d cabs inss2
      clmabs syl2anc rpge0d absidd eqtr3d eqtrd oveq1d 3eqtrd rpcnd nmcl rpne0d
      recnd divassd dmdcand clmod nlmlmod lmodvscl divcan1d fveq2 eqeq1d breq1d
      wf simpllr imbi12d rspcv syl3c eqbrtrrd ledivmul2d mpbid leidd syl5ibrcom
      simplr breq1 nmoleub2lem ) ABUHZJUIZDUJZBUGCDEFGHIJKLMNOPQRSTUAUBUCUDAUKC
      ULUMYPYNGUIZKUIZDUNUOZCULUMZUPZBMUQZUEURAUUBUSZCVDUTZUSZUGUHZMUTZUUFEVAUI
      ZVBZUSZUSZUUFGUIZKUIZUUFJUIZUNUOZCULUMUUMCUUNVEUOULUMUUKDUUNUNUOZUUFEVCUI
      ZUOZGUIZKUIZDUNUOZUUOCULUUKUVAUUPUUMVEUOZDUNUOUUPUUMDUNUOVEUOUUOUUKUUTUVB
      DUNUUKUUTUUPUULFVCUIZUOZKUIZUUPFVFUIZVGUIZUIZUUMVEUOZUVBUUKUUSUVDKUUKGEFV
      HUOUTZUUPIUTZUUGUUSUVDUJAUVJUUBUUDUUJUBVIZUUKVDIUUPAVDIVJUUBUUDUUJUFVIUUK
      UUPUUKDUUNADVKUTZUUBUUDUUJUDVIZUUKEVLUTZUUGUUIUUNVKUTUUKEVMUTZUVOAUVPUUBU
      UDUUJAVMVNVOZVMEVMVNVRZTVPVIZEVQVSUUEUUGUUIVTZUUEUUGUUIWAUUFEJMUUHOPUUHWB
      WCWDZWEZWFZWGZUVTIEFUUQUVCMGHUUPUUFRSOUUQWBZUVCWBZWHWDWIUUKFVMUTZUUPUVFWJ
      UIZUTUULFWJUIZUTZUVEUVIUJAUWGUUBUUDUUJAUVQVMFUVRUAVPVIZUUKUUPIUWHUWDUUKUW
      HHWJUIIUUKUVFHWJUUKUVJUVFHUJUVLEFGHUVFRUVFWBZWKVSZWISWLWMUUKMUWIUUFGUUKUV
      JMUWIGYAUVLMUWIEFGOUWIWBZWNVSUVTWOZUVGUVCUVFUWHKUWIFUUPUULUWNQUWFUWLUWHWB
      UVGWBWPWDUUKUVHUUPUUMVEUUKUVHUUPHVGUIZUIZUUPUUKUUPUVGUWPUUKUVFHVGUWMWIWQU
      UKUUPWRUIZUWQUUPUUKEVNUTZUVKUWRUWQUJAUWSUUBUUDUUJAUVQVNEVMVNWSTVPVIUWDUUP
      HIERSWTXAUUKUUPUWCUUKUUPUWBXBXCXDZXEXFXGXFUUKUUPUUMDUUKUUPUWBXHUUKUUMUUKF
      VLUTZUWJUUMVDUTUUKUWGUXAUWKFVQVSUWOUULFKUWIUWNQXIXAZXKZUUKDUVNXHZUUKDUVNX
      JZXLUUKUUMDUUNUXCUXDUUKUUNUWAXHZUXEUUKUUNUWAXJZXMXGUUKUURMUTZUUBUURJUIZDU
      JZUVACULUMZUUKEXNUTZUVKUUGUXHUUKUVPUXLUVSEXOVSUWDUVTUUPUUQHIMEUUFORUWESXP
      WDAUUBUUDUUJYBUUKUXIUWQUUNVEUOZUUPUUNVEUODUUKUVPUVKUUGUXIUXMUJUVSUWDUVTUW
      PUUQHIJMEUUPUUFOPUWERSUWPWBWPWDUUKUWQUUPUUNVEUWTXFUUKDUUNUXDUXFUXGXQXGUUA
      UXJUXKUPBUURMYNUURUJZYPUXJYTUXKUXNYOUXIDYNUURJXRXSUXNYSUVACULUXNYRUUTDUNU
      XNYQUUSKYNUURGXRWIXFXTYCYDYEYFUUKUUMCUUNUXBUUCUUDUUJYKUWAYGYHAYNMUTZUSZYO
      DULUMYPDDULUMUXPDUXPDAUVMUXOUDURWFYIYODDULYLYJYM $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y J $.  $d x y K $.  $d x y S $.
    $d x y T $.
    nmhmcn.j $e |- J = ( TopOpen ` S ) $.
    nmhmcn.k $e |- K = ( TopOpen ` T ) $.
    nmhmcn.g $e |- G = ( Scalar ` S ) $.
    nmhmcn.b $e |- B = ( Base ` G ) $.
    $( A linear operator over a normed complex module is bounded iff it is
       continuous.  (Contributed by Mario Carneiro, 22-Oct-2015.) $)
    nmhmcn $p |- ( ( S e. ( NrmMod i^i CMod ) /\ T e. ( NrmMod i^i CMod )
      /\ QQ C_ B ) ->
      ( F e. ( S NMHom T ) <-> ( F e. ( S LMHom T ) /\ F e. ( J Cn K ) ) ) ) $=
      ( vy cnlm wcel co wa cfv c1 3syl eqid vx cin cq wss w3a cnmhm clmhm cnghm
      cclm ccn wb inss1 sseli isnmhm baib syl2an 3adant3 nghmcn c0g cds cbs cxp
      cv cres cbl ccnv cima crp wrex cxmt cmopn cxme cngp simpll1 sseldi nlmngp
      cmt ngpms msxms xmsxmet simpr cxr simpll2 clmod nlmlmod lmod0vcl 1rp rpxr
      mp1i blopn syl3anc wceq 4syl eleqtrrd cnima syl2anc eleqtrd cghm ad2antlr
      mstopn lmghm ghmid syl a1i blcntr eqeltrd wf wfn lmhmf elpreima mpbir2and
      ffn mopni2 cnmo cdiv cle wbr clt wi wral cgrp simpl1 adantr ngpgrp nmval2
      cnm ad2antrr xmetsym eqtrd breq1d biimpd elbl simpl2 simplr ffvelrnda 1re
      cr adantld sylbid adantl nmcl ltle sylancl lediv1d 3imtr3d ralimdva blval
      imim12d crab sseq1d rabss syl6bb rpreccl simpl3 nmoleub2b 3imtr4d bddnghm
      rpxrd 3jca rpred expr syld rexlimdva mpd ex impbid2 pm5.32da bitrd ) BMUI
      UBZNZCUVINZUCAUDZUEZDBCUFONZDBCUGONZDBCUHONZPZUVODFGUJONZPUVJUVKUVNUVQUKZ
      UVLUVJBMNZCMNZUVSUVKUVIMBMUIULZUMUVIMCUWBUMUVNUVTUWAPUVQBCDUNUOUPUQUVMUVO
      UVPUVRUVMUVOPZUVPUVRBCDFGHIURUWCUVRUVPUWCUVRPZBUSQZUAVCZBUTQZBVAQZUWHVBVD
      ZVEQOZDVFCUSQZRCUTQZCVAQZUWMVBVDZVEQOZVGZUDZUAVHVIZUVPUWDUWIUWHVJQNZUWPUW
      IVKQZNUWEUWPNZUWRUWDBVQNZBVLNUWSUWDUVTBVMNZUXBUWDUVIMBUWBUVJUVKUVLUVOUVRV
      NZVOZBVPZBVRZSBVSUWIBUWHUWHTZUWITZVTSZUWDUWPFUWTUWDUVRUWOGNUWPFNUWCUVRWAU
      WDUWOUWNVKQZGUWDUWNUWMVJQNZUWKUWMNZRWBNZUWOUXKNUWDCVQNZCVLNUXLUWDUWACVMNZ
      UXOUWDUVIMCUWBUVJUVKUVLUVOUVRWCZVOZCVPZCVRZSCVSUWNCUWMUWMTZUWNTZVTSZUWDUW
      ACWDNUXMUXRCWEUWMCUWKUYAUWKTZWFSZRVHNZUXNUWDWGRWHZWIUWNUWKRUXKUWMUXKTWJWK
      UWDUWAUXPUXOGUXKWLUXRUXSUXTUWNGCUWMIUYAUYBWTWMWNUWODFGWOWPUWDUVTUXCUXBFUW
      TWLUXEUXFUXGUWIFBUWHHUXHUXIWTWMWQUWDUXAUWEUWHNZUWEDQZUWONZUWDUVTBWDNUYHUX
      EBWEUWHBUWEUXHUWETZWFSZUWDUYIUWKUWOUWDDBCWRONZUYIUWKWLUVOUYMUVMUVRBCDXAWS
      ZBCDUWEUWKUYKUYDXBXCUWDUXLUXMUYFUWKUWONUYCUYEUYFUWDWGXDUWNUWKRUWMXEWKXFUW
      DUWHUWMDXGZDUWHXHZUXAUYHUYJPUKUVOUYOUVMUVRUWHUWMBCDUXHUYAXIZWSZUWHUWMDXLZ
      UWHUWEUWODXJSXKUAUWPUWIUWEUWTUWHUWTTXMWKUWDUWQUVPUAVHUWDUWFVHNZPZUWQDBCXN
      OZQRUWFXOOZXPXQZUVPVUAUWELVCZUWIOZUWFXRXQZVUEUWPNZXSZLUWHXTZVUEBYFQZQZUWF
      XRXQZVUEDQZCYFQZQZUWFXOOVUCXPXQZXSZLUWHXTUWQVUDVUAVUIVURLUWHVUAVUEUWHNZPZ
      VUMVUGVUHVUQVUTVUMVUGVUTVULVUFUWFXRVUTVULVUEUWEUWIOZVUFVUTBYANZVUSVULVVAW
      LVUTUXCVVBUWDUXCUYTVUSUWCUXCUVRUWCUVTUXCUWCUVIMBUWBUVJUVKUVLUVOYBVOUXFXCY
      CZYGBYDXCVUAVUSWAZVUEUWGUWIVUKBUWHUWEVUKTZUXHUYKUWGTUXIYEWPVUTUWSVUSUYHVV
      AVUFWLUWDUWSUYTVUSUXJYGVVDUWDUYHUYTVUSUYLYGVUEUWEUWIUWHYHWKYIYJYKVUTVUHVU
      SVUNUWONZPZVUQVUTUYOUYPVUHVVGUKUWDUYOUYTVUSUYRYGUYSUWHVUEUWODXJSVUTVVFVUQ
      VUSVUTVVFVUNUWMNZUWKVUNUWNOZRXRXQZPZVUQVUTUXLUXMUXNVVFVVKUKUWDUXLUYTVUSUY
      CYGZUWDUXMUYTVUSUYEYGZUYFUXNVUTWGUYGWIVUNUWNUWKRUWMYLWKVUTVVJVUQVVHVUTVUP
      RXRXQZVUPRXPXQZVVJVUQVUTVUPYQNZRYQNZVVNVVOXSVUTUXPVVHVVPUWDUXPUYTVUSUWCUX
      PUVRUWCUWAUXPUWCUVIMCUWBUVJUVKUVLUVOYMVOUXSXCYCZYGZVUAUWHUWMVUEDVUAUVOUYO
      UWDUVOUYTUVMUVOUVRYNYCZUYQXCYOZVUNCVUOUWMUYAVUOTZUUAWPZYPVUPRUUBUUCVUTVUP
      VVIRXRVUTVUPVUNUWKUWNOZVVIVUTCYANZVVHVUPVWDWLVUTUXPVWEVVSCYDXCVWAVUNUWLUW
      NVUOCUWMUWKVWBUYAUYDUWLTUYBYEWPVUTUXLVVHUXMVWDVVIWLVVLVWAVVMVUNUWKUWNUWMY
      HWKYIYJVUTVUPRUWFVWCVVQVUTYPXDUWDUYTVUSYNUUDUUEYRYSYRYSUUHUUFVUAUWQVUGLUW
      HUUIZUWPUDVUJVUAUWJVWFUWPVUAUWSUYHUWFWBNZUWJVWFWLUWDUWSUYTUXJYCUWDUYHUYTU
      YLYCUYTVWGUWDUWFWHYTLUWIUWEUWFUWHUUGWKUUJVUGLUWHUWPUUKUULVUALVUCUWFBCDEAV
      UKVUOVUBUWHVUBTZUXHVVEVWBJKUWDUVJUYTUXDYCUWDUVKUYTUXQYCVVTVUAVUCUYTVUCVHN
      UWDUWFUUMZYTUURUWDUYTWAUWCUVLUVRUYTUVJUVKUVLUVOUUNYGUUOUUPUWDUXCUXPUYMUEZ
      VUCYQNZVUDUVPXSUYTUWDUXCUXPUYMVVCVVRUYNUUSUYTVUCVWIUUTVWJVWKVUDUVPVUCBCDV
      UBVWHUUQUVAUPUVBUVCUVDUVEUVFUVGUVH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Complex pre-Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CPreHil $. $( Complex pre-Hilbert space $)
  $c toCHil $. $( Add a norm on a Hilbert space $)

  $( Extend class notation with a complex pre-Hilbert space. $)
  ccph $a class CPreHil $.

  $( Function to put a norm on a Hilbert space. $)
  ctch $a class toCHil $.

  ${
    $d f k w F $.  $d f k w K $.  $d f k w N $.  $d f k w V $.  $d f k w x W $.
    $d f k w ., $.
    $( Define a complex pre-Hilbert space.  By restricting the scalar field to
       a quadratically closed subfield of ` CC ` , we have enough structure to
       define a norm, with the associated connection to a metric and topology.
       (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    df-cph $a |- CPreHil = { w e. ( PreHil i^i NrmMod ) |
     [. ( Scalar ` w ) / f ]. [. ( Base ` f ) / k ]. ( f = ( CCfld |`s k ) /\
        ( sqr " ( k i^i ( 0 [,) +oo ) ) ) C_ k /\
   ( norm ` w ) = ( x e. ( Base ` w ) |-> ( sqr ` ( x ( .i ` w ) x ) ) ) ) } $.

    $( Define a function to augment a (pre-)Hilbert space with a norm.  No
       extra parameters are needed, but some conditions must be satisfied to
       ensure that this in fact creates a normed pre-Hilbert space.
       (Contributed by Mario Carneiro, 7-Oct-2015.) $)
    df-tch $a |- toCHil = ( w e. _V |-> ( w toNrmGrp
      ( x e. ( Base ` w ) |-> ( sqr ` ( x ( .i ` w ) x ) ) ) ) ) $.

    iscph.v $e |- V = ( Base ` W ) $.
    iscph.h $e |- ., = ( .i ` W ) $.
    iscph.n $e |- N = ( norm ` W ) $.
    iscph.f $e |- F = ( Scalar ` W ) $.
    iscph.k $e |- K = ( Base ` F ) $.
    $( A complex pre-Hilbert space is a pre-Hilbert space over a quadratically
       closed subfield of the complexes, with a norm defined (Contributed by
       Mario Carneiro, 8-Oct-2015.) $)
    iscph $p |- ( W e. CPreHil <-> ( ( W e. PreHil /\ W e. NrmMod /\
      F = ( CCfld |`s K ) ) /\ ( sqr " ( K i^i ( 0 [,) +oo ) ) ) C_ K /\
      N = ( x e. V |-> ( sqr ` ( x ., x ) ) ) ) ) $=
      ( wcel co wceq wa csqr cfv cbs fveq2d vf vk vw cphl cnlm cin ccnfld cress
      cc0 cpnf cico cima wss cv cmpt w3a ccph elin anbi1i df-3an bitr4i cnm cip
      wsbc csca cvv a1i simplr simpll syl6eqr eqtrd simpr oveq2d eqeq12d ineq1d
      fvex imaeq2d oveqd mpteq12dv 3anbi123d 3anass syl6bb sbcied df-cph elrab2
      sseq12d anass 3bitr4i ) GUDUEUFZMZBUGDUHNZOZPZQDUIUJUKNZUFZULZDUMZEAFAUNZ
      WRCNZQRZUOZOZPZPZGUDMZGUEMZWLUPZXCPGUQMZXGWQXBUPWMXGXCWMXEXFPZWLPXGWJXIWL
      GUDUEURUSXEXFWLUTVAUSXHWJWLXCPZPXDUAUNZUGUBUNZUHNZOZQXLWNUFZULZXLUMZUCUNZ
      VBRZAXRSRZWRWRXRVCRZNZQRZUOZOZUPZUBXKSRZVDZUAXRVERZVDXJUCGWIUQXRGOZYHXJUA
      YIVFYIVFMYJXRVEVPVGYJXKYIOZPZYFXJUBYGVFYGVFMYLXKSVPVGYLXLYGOZPZYFWLWQXBUP
      XJYNXNWLXQWQYEXBYNXKBXMWKYNXKYIBYJYKYMVHYNYIGVERBYNXRGVEYJYKYMVIZTKVJVKZY
      NXLDUGUHYNXLYGDYLYMVLYNYGBSRDYNXKBSYPTLVJVKZVMVNYNXPWPXLDYNXOWOQYNXLDWNYQ
      VOVQYQWFYNXSEYDXAYNXSGVBREYNXRGVBYOTJVJYNAXTYCFWTYNXTGSRFYNXRGSYOTHVJYNYB
      WSQYNYACWRWRYNYAGVCRCYNXRGVCYOTIVJVRTVSVNVTWLWQXBWAWBWCWCAUCUAUBWDWEWJWLX
      CWGVAXGWQXBWAWH $.
  $}

  ${
    $d x W $.
    $( A complex pre-Hilbert space is a pre-Hilbert space.  (Contributed by
       Mario Carneiro, 7-Oct-2015.) $)
    cphphl $p |- ( W e. CPreHil -> W e. PreHil ) $=
      ( vx ccph wcel cphl cnlm csca cfv ccnfld cbs cress wceq w3a csqr cc0 cpnf
      co cico cin eqid cima wss cnm cv cip cmpt iscph simp1bi simp1d ) ACDZAEDZ
      AFDZAGHZIUMJHZKQLZUJUKULUOMNUNOPRQSUAUNUBAUCHZBAJHZBUDZURAUEHZQNHUFLBUMUS
      UNUPUQAUQTUSTUPTUMTUNTUGUHUI $.

    $( A complex pre-Hilbert space is a normed module.  (Contributed by Mario
       Carneiro, 7-Oct-2015.) $)
    cphnlm $p |- ( W e. CPreHil -> W e. NrmMod ) $=
      ( vx ccph wcel cphl cnlm csca cfv ccnfld cbs cress wceq w3a csqr cc0 cpnf
      co cico cin eqid cima wss cnm cv cip cmpt iscph simp1bi simp2d ) ACDZAEDZ
      AFDZAGHZIUMJHZKQLZUJUKULUOMNUNOPRQSUAUNUBAUCHZBAJHZBUDZURAUEHZQNHUFLBUMUS
      UNUPUQAUQTUSTUPTUMTUNTUGUHUI $.
  $}

  $( A complex pre-Hilbert space is a normed group.  (Contributed by Mario
     Carneiro, 13-Oct-2015.) $)
  cphngp $p |- ( W e. CPreHil -> W e. NrmGrp ) $=
    ( ccph wcel cnlm cngp cphnlm nlmngp syl ) ABCADCAECAFAGH $.

  $( A complex pre-Hilbert space is a left module.  (Contributed by Mario
     Carneiro, 7-Oct-2015.) $)
  cphlmod $p |- ( W e. CPreHil -> W e. LMod ) $=
    ( ccph wcel cnlm clmod cphnlm nlmlmod syl ) ABCADCAECAFAGH $.

  $( A complex pre-Hilbert space is a left vector space.  (Contributed by Mario
     Carneiro, 7-Oct-2015.) $)
  cphlvec $p |- ( W e. CPreHil -> W e. LVec ) $=
    ( ccph wcel cphl clvec cphphl phllvec syl ) ABCADCAECAFAGH $.

  $( A complex pre-Hilbert space is a normed vector space.  (Contributed by
     Mario Carneiro, 8-Oct-2015.) $)
  cphnvc $p |- ( W e. CPreHil -> W e. NrmVec ) $=
    ( ccph wcel cnlm clvec cnvc cphnlm cphlvec isnvc sylanbrc ) ABCADCAECAFCAGA
    HAIJ $.

  ${
    cphsubrglem.k $e |- K = ( Base ` F ) $.
    cphsubrglem.1 $e |- ( ph -> F = ( CCfld |`s A ) ) $.
    cphsubrglem.2 $e |- ( ph -> F e. DivRing ) $.
    $( Lemma for ~ cphsubrg .  (Contributed by Mario Carneiro, 9-Oct-2015.) $)
    cphsubrglem $p |- ( ph -> ( F = ( CCfld |`s K ) /\ K = ( A i^i CC ) /\
      K e. ( SubRing ` CCfld ) ) ) $=
      ( ccnfld co wceq cc cfv wcel cbs cvv crg syl eqid cc0 cmul cin csubrg c0g
      cress fveq2d wa cdr drngrng eqeltrrd rng0cl reldmress elbasov 3syl simprd
      cnfldbas ressbas eqtr4d syl5eq oveq2d ressinbas wss cnrng jctil ressbasss
      c1 syl6eqss syl5eqss cur wn wne drngunz cgrp rnggrp mp1i issubg syl3anbrc
      csubg cnfld0 subg0 neeqtrd neneqd c2 cexp wo rngidcl sseldd sqvald oveq1d
      eleqtrd cmulr fvex eqeltri cnfldmul ressmulr ax-mp rnglidm syl2anc 3eqtrd
      wb sq01 mpbid ord mpd jca cnfld1 issubrg sylanbrc 3jca ) ACHDUDIZJDBKUAZJ
      DHUBLMZACHBUDIZXIFAXIHXJUDIZXLADXJHUDADCNLZXJEAXNXLNLZXJACXLNFUEZABOMZXJX
      OJAHOMZXQAXLPMXLUCLZXOMXRXQUFACXLPFACUGMZCPMZGCUHQZUIXOXLXSXORZXSRUJXSXOX
      LUDHBUKXLRZYCULUMUNZBKXLOHYDUOUPQUQURZUSAXQXLXMJYEBKHOUOUTQUQUQZYFAHPMZXI
      PMZUFDKVAZVEDMZUFXKAYIYHACXIPYGYBUIZVBVCAYJYKADXNKEAXNXOKXPBKXLHYDUOVDVFV
      GZACVHLZVEDAYNSJZVIYNVEJZAYNSAYNCUCLZSAXTYNYQVJGCYNYQYQRYNRZVKQAYQXIUCLZS
      ACXIUCYGUEADHVQLMZSYSJAHVLMZYJXIVLMZYTYHUUAAVBHVMVNYMAYIUUBYLXIVMQKDHUOVO
      VPDHXISXIRZVRVSQUQVTWAAYOYPAYNWBWCIZYNJZYOYPWDZAUUDYNYNTIXIVHLZYNTIZYNAYN
      ADKYNYMAYAYNDMYBDCYNEYRWEQZWFZWGAYNUUGYNTACXIVHYGUEWHAYIYNXINLZMUUHYNJYLA
      YNDUUKUUIADXNUUKEACXINYGUEURWIUUKXITUUGYNUUKRDOMTXIWJLJDXNOECNWKWLDHXITOU
      UCWMWNWOUUGRWPWQWRAYNKMUUEUUFWSUUJYNWTQXAXBXCUUIUIXDDKHVEUOXEXFXGXH $.

    $( Lemma for ~ cphreccl .  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    cphreccllem $p |- ( ( ph /\ X e. K /\ X =/= 0 ) -> ( 1 / X ) e. K ) $=
      ( wcel cc0 wne ccnfld cfv cc wceq 3ad2ant1 syl cui c0g eqid cinvr c1 cdiv
      w3a csubrg wss cress cin cphsubrglem simp3d cnfldbas subrgss simp2 sseldd
      co simp3 cnfldinv syl2anc cdif cnfld0 subrg0 simp1d fveq2d eqtr4d neeqtrd
      csn eldifsn sylanbrc cdr isdrng simprbi eqtr3d eleqtrd wb subrgunit mpbid
      crg eqeltrrd ) AEDIZEJKZUDZELUAMZMZUBEUCUOZDWAENIVTWCWDOWADNEWADLUEMIZDNU
      FAVSWEVTACLDUGUOZOZDBNUHOZWEABCDFGHUIZUJPZDNLUKULQAVSVTUMZUNAVSVTUPZEUQUR
      WAELRMZIZVSWCDIZWAEWFRMZIZWNVSWOUDZWAEDCSMZVFUSZWPWAVSEWSKEWTIWKWAEJWSWLW
      AJWFSMZWSWAWEJXAOWJDLWFJWFTZUTVAQWACWFSAVSWGVTAWGWHWEWIVBPZVCVDVEEDWSVGVH
      WACRMZWTWPWACVIIZXDWTOZAVSXEVTHPXECVQIXFDCXDWSFXDTWSTVJVKQWACWFRXCVCVLVMW
      AWEWQWRVNWJDLWFWMWBWPEXBWMTWPTWBTVOQVPUJVR $.
  $}

  ${
    $d x W $.
    cphsca.f $e |- F = ( Scalar ` W ) $.
    cphsca.k $e |- K = ( Base ` F ) $.
    $( A complex pre-Hilbert space is a vector space over a subfield of
       ` CC ` .  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    cphsca $p |- ( W e. CPreHil -> F = ( CCfld |`s K ) ) $=
      ( vx ccph wcel cphl cnlm ccnfld cress co wceq w3a csqr cc0 cpnf cfv eqid
      cico cin cima wss cnm cbs cv cip cmpt iscph simp1bi simp3d ) CGHZCIHZCJHZ
      AKBLMNZUMUNUOUPOPBQRUAMUBUCBUDCUESZFCUFSZFUGZUSCUHSZMPSUINFAUTBUQURCURTUT
      TUQTDEUJUKUL $.

    $( The scalar field of a complex pre-Hilbert space is a subring of
       ` CC ` .  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    cphsubrg $p |- ( W e. CPreHil -> K e. ( SubRing ` CCfld ) ) $=
      ( ccph wcel ccnfld cress co wceq cin csubrg cfv cphsca clvec cdr lvecdrng
      cc cphlvec syl cphsubrglem simp3d ) CFGZAHBIJKBBSLKBHMNGUDBABEABCDEOUDCPG
      AQGCTACDRUAUBUC $.

    $( The scalar field of a complex pre-Hilbert space is closed under
       reciprocal.  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    cphreccl $p |- ( ( W e. CPreHil /\ A e. K /\ A =/= 0 ) ->
      ( 1 / A ) e. K ) $=
      ( ccph wcel cphsca clvec cdr cphlvec lvecdrng syl cphreccllem ) DGHZCBCAF
      BCDEFIPDJHBKHDLBDEMNO $.

    $( The scalar field of a complex pre-Hilbert space is closed under
       reciprocal.  (Contributed by Mario Carneiro, 11-Oct-2015.) $)
    cphdivcl $p |- ( ( W e. CPreHil /\ ( A e. K /\ B e. K /\ B =/= 0 ) ) ->
      ( A / B ) e. K ) $=
      ( ccph wcel cc0 wne w3a wa cdiv co c1 cmul cc ccnfld sseldd csubrg adantr
      cfv wss cphsubrg cnfldbas subrgss simpr1 simpr2 simpr3 cphreccl 3adant3r1
      syl divrecd cnfldmul subrgmcl syl3anc eqeltrd ) EHIZADIZBDIZBJKZLZMZABNOA
      PBNOZQOZDVDABVDDRAVDDSUAUCIZDRUDUSVGVCCDEFGUEUBZDRSUFUGUMZUSUTVAVBUHZTVDD
      RBVIUSUTVAVBUITUSUTVAVBUJUNVDVGUTVEDIZVFDIVHVJUSVAVBVKUTBCDEFGUKULDSQAVEU
      OUPUQUR $.

    $( The scalar field of a complex pre-Hilbert space is closed under
       conjugation.  (Contributed by Mario Carneiro, 11-Oct-2015.) $)
    cphcjcl $p |- ( ( W e. CPreHil /\ A e. K ) -> ( * ` A ) e. K ) $=
      ( ccph wcel wa cstv cfv ccj wceq ccnfld cress co cphsca cvv cbs eqid fvex
      fveq2d eqeltri cnfldcj ressstarv ax-mp syl6eqr adantr fveq1d cphl phlsrng
      csr cphphl syl srngcl sylan eqeltrrd ) DGHZACHZIZABJKZKZALKCUTAVALURVALMU
      SURVANCOPZJKZLURBVCJBCDEFQUBCRHLVDMCBSKRFBSUAUCCNVCLRVCTUDUEUFUGUHUIURBUL
      HZUSVBCHURDUJHVEDUMBDEUKUNCBVAAVATFUOUPUQ $.

    $( The scalar field of a complex pre-Hilbert space is closed under square
       roots of positive reals (i.e. it is quadratically closed relative to
       ` RR ` ).  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    cphsqrcl $p |- ( ( W e. CPreHil /\ ( A e. K /\ A e. RR /\ 0 <_ A ) ) ->
      ( sqr ` A ) e. K ) $=
      ( vx wcel cr cc0 w3a csqr cfv cpnf co cc wss sstri wceq eqid cle wbr ccph
      cico cin cima simp1 wa elrege0 biimpri 3adant1 elin sylanbrc wfn sqrf ffn
      wf ax-mp inss2 cxr 0re pnfxr icossre mp2an ax-resscn fnfvima mp3an12 cphl
      syl cnlm ccnfld cress cnm cbs cv cip cmpt iscph simp2bi sselda sylan2 ) A
      CHZAIHZJAUAUBZKZDUCHZALMZLCJNUDOZUEZUFZHZWGCHWEAWIHZWKWEWBAWHHZWLWBWCWDUG
      WCWDWMWBWMWCWDUHAUIUJUKACWHULUMLPUNZWIPQWLWKPPLUQWNUOPPLUPURWIWHPCWHUSWHI
      PJIHNUTHWHIQVAVBJNVCVDVERRPWILAVFVGVIWFWJCWGWFDVHHDVJHBVKCVLOSKWJCQDVMMZG
      DVNMZGVOZWQDVPMZOLMVQSGBWRCWOWPDWPTWRTWOTEFVRVSVTWA $.

    $( The scalar field of a complex pre-Hilbert space is closed under the
       absolute value operation.  (Contributed by Mario Carneiro,
       11-Oct-2015.) $)
    cphabscl $p |- ( ( W e. CPreHil /\ A e. K ) -> ( abs ` A ) e. K ) $=
      ( ccph wcel wa cabs cfv ccj cmul co csqr cc wceq ccnfld csubrg syl sselda
      wss cphsubrg cnfldbas subrgss absval cr cc0 cle wbr simpl adantr cnfldmul
      cphcjcl subrgmcl syl3anc cjmulrcld cjmulge0d cphsqrcl syl13anc eqeltrd
      simpr ) DGHZACHZIZAJKZAALKZMNZOKZCVEAPHVFVIQVCCPAVCCRSKHZCPUBBCDEFUCZCPRU
      DUETUAZAUFTVEVCVHCHZVHUGHUHVHUIUJVICHVCVDUKVEVJVDVGCHVMVCVJVDVKULVCVDVBAB
      CDEFUNCRMAVGUMUOUPVEAVLUQVEAVLURVHBCDEFUSUTVA $.

    $( The scalar field of a complex pre-Hilbert space is closed under square
       roots of all numbers except possibly the negative reals.  (Contributed
       by Mario Carneiro, 8-Oct-2015.) $)
    cphsqrcl2 $p |- ( ( W e. CPreHil /\ A e. K /\ -. -u A e. RR+ ) ->
      ( sqr ` A ) e. K ) $=
      ( wcel crp wn csqr cfv cc0 wceq wne co cmul cc ccnfld syl2anc sseldd ccph
      cneg w3a wa sqr0 fveq2 id 3eqtr4a adantl simpl2 eqeltrd cabs caddc csubrg
      cdiv wss simpl1 cphsubrg syl cnfldbas subrgss cr cle wbr cphabscl absge0d
      abscld cphsqrcl syl13anc cnfldadd syl3anc simpl3 cmin recnd eqeq1d negcld
      subrgacl subnegd subeq0ad bitr3d sylancom eleq1 syl5ibcom sylbid necon3bd
      absrpcl mpd absne0d cphdivcl cnfldmul subrgmcl c2 cexp wnel eqid sqreulem
      cre ci simp1d simp2d simp3d df-nel sylib eqsqrd eqeltrrd pm2.61dane ) DUA
      GZACGZAUBZHGZIZUCZAJKZCGALXLALMZUDXMACXNXMAMXLXNLJKLXMAUEALJUFXNUGUHUIXGX
      HXKXNUJUKXLALNZUDZAULKZJKZXQAUMOZXSULKZUOOZPOZXMCXPYBAXPCQYBXPCRUNKGZCQUP
      XPXGYCXGXHXKXOUQZBCDEFURUSZCQRUTVAUSZXPYCXRCGZYACGZYBCGYEXPXGXQCGZXQVBGLX
      QVCVDYGYDXPXGXHYIYDXGXHXKXOUJZABCDEFVESZXPAXPCQAYFYJTZVGZXPAYLVFXQBCDEFVH
      VIXPXGXSCGZXTCGZXTLNYHYDXPYCYIXHYNYEYKYJCUMRXQAVJVQVKZXPXGYNYOYDYPXSBCDEF
      VESXPXSXPCQXSYFYPTXPXKXSLNZXGXHXKXOVLXPXJXSLXPXSLMZXQXIMZXJXPXQXIVMOZLMYR
      YSXPYTXSLXPXQAXPXQYMVNZYLVRVOXPXQXIUUAXPAYLVPVSVTXPXQHGZYSXJXLXOAQGZUUBYL
      AWFWAXQXIHWBWCWDWEWGZWHXSXTBCDEFWIVICRPXRYAWJWKVKZTYLXPYBWLWMOAMZLYBWQKVC
      VDZWRYBPOZHWNZXPUUCYQUUFUUGUUIUCYLUUDAYBYBWOWPSZWSXPUUFUUGUUIUUJWTXPUUIUU
      HHGIXPUUFUUGUUIUUJXAUUHHXBXCXDUUEXEXF $.

    $( If the scalar field contains ` _i ` , it is completely closed under
       square roots (i.e. it is quadratically closed).  (Contributed by Mario
       Carneiro, 11-Oct-2015.) $)
    cphsqrcl3 $p |- ( ( W e. CPreHil /\ _i e. K /\ A e. K ) ->
      ( sqr ` A ) e. K ) $=
      ( ccph wcel ci w3a cneg crp csqr cfv wa cmul cc ccnfld syl adantl subrgss
      csubrg wss simpl1 cphsubrg cnfldbas simpl3 sseldd negnegd fveq2d rpre cc0
      co cr cle wbr rpge0 sqrnegd eqtr3d simpl2 cminusg wceq cnfldneg subrgsubg
      csubg eqid subginvcl syl2anc eqeltrrd cphsqrcl syl13anc cnfldmul subrgmcl
      syl3anc eqeltrd ex wn wi cphsqrcl2 3expia 3adant2 pm2.61d ) DGHZICHZACHZJ
      ZAKZLHZAMNZCHZWFWHWJWFWHOZWIIWGMNZPUMZCWKWGKZMNWIWMWKWNAMWKAWKCQAWKCRUBNH
      ZCQUCWKWCWOWCWDWEWHUDZBCDEFUESZCQRUFUASWCWDWEWHUGZUHZUIUJWKWGWHWGUNHZWFWG
      UKTZWHULWGUOUPZWFWGUQTZURUSWKWOWDWLCHZWMCHWQWCWDWEWHUTWKWCWGCHWTXBXDWPWKA
      RVANZNZWGCWKAQHXFWGVBWSAVCSWKCRVENHZWEXFCHWKWOXGWQCRVDSWRCRXEAXEVFVGVHVIX
      AXCWGBCDEFVJVKCRPIWLVLVMVNVOVPWCWEWHVQZWJVRWDWCWEXHWJABCDEFVSVTWAWB $.

    $( The scalar field of a complex pre-Hilbert space contains all rational
       numbers.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    cphqss $p |- ( W e. CPreHil -> QQ C_ K ) $=
      ( ccph wcel ccnfld csubrg cfv cress co cdr cq wss cphsubrg cphsca cphlvec
      clvec lvecdrng syl eqeltrrd qsssubdrg syl2anc ) CFGZBHIJGHBKLZMGNBOABCDEP
      UEAUFMABCDEQUECSGAMGCRACDTUAUBBUCUD $.
  $}

  $( A complex pre-Hilbert space is a complex module.  (Contributed by Mario
     Carneiro, 16-Oct-2015.) $)
  cphclm $p |- ( W e. CPreHil -> W e. CMod ) $=
    ( ccph wcel clmod csca cfv ccnfld cbs cress wceq csubrg cclm cphlmod cphsca
    co eqid cphsubrg isclm syl3anbrc ) ABCADCAEFZGTHFZIOJUAGKFCALCAMTUAATPZUAPZ
    NTUAAUBUCQTUAAUBUCRS $.

  ${
    cphnmvs.v $e |- V = ( Base ` W ) $.
    cphnmvs.n $e |- N = ( norm ` W ) $.
    cphnmvs.s $e |- .x. = ( .s ` W ) $.
    cphnmvs.f $e |- F = ( Scalar ` W ) $.
    cphnmvs.k $e |- K = ( Base ` F ) $.
    $( Norm of a scalar product.  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    cphnmvs $p |- ( ( W e. CPreHil /\ X e. K /\ Y e. V ) ->
      ( N ` ( X .x. Y ) ) = ( ( abs ` X ) x. ( N ` Y ) ) ) $=
      ( ccph wcel w3a co cfv cmul wceq cnm cabs cnlm cphnlm eqid syl3an1 cphclm
      nmvs cclm clmabs sylan 3adant3 oveq1d eqtr4d ) FNOZGCOZHEOZPZGHAQDRZGBUAR
      ZRZHDRZSQZGUBRZVBSQUOFUCOUPUQUSVCTFUDUTABCDEFGHIJKLMUTUEUHUFURVDVAVBSUOUP
      VDVATZUQUOFUIOUPVEFUGGBCFLMUJUKULUMUN $.
  $}

  ${
    $d x A $.  $d x ., $.  $d x K $.  $d x V $.  $d x W $.
    nmsq.v $e |- V = ( Base ` W ) $.
    nmsq.h $e |- ., = ( .i ` W ) $.
    $( An inner product is a member of the complex numbers.  (Contributed by
       Mario Carneiro, 13-Oct-2015.) $)
    cphipcl $p |- ( ( W e. CPreHil /\ A e. V /\ B e. V ) ->
      ( A ., B ) e. CC ) $=
      ( ccph wcel w3a csca cfv cbs cc co wss ccnfld csubrg eqid cphsubrg cphphl
      cnfldbas subrgss syl 3ad2ant1 cphl ipcl syl3an1 sseldd ) EHIZADIZBDIZJEKL
      ZMLZNABCOZUJUKUNNPZULUJUNQRLIUPUMUNEUMSZUNSZTUNNQUBUCUDUEUJEUFIUKULUOUNIE
      UAABUMCUNDEUQGFURUGUHUI $.

    nmsq.n $e |- N = ( norm ` W ) $.
    $( The value of the norm in a complex pre-Hilbert space is the square root
       of the inner product of a vector with itself.  (Contributed by Mario
       Carneiro, 7-Oct-2015.) $)
    cphnmfval $p |- ( W e. CPreHil ->
        N = ( x e. V |-> ( sqr ` ( x ., x ) ) ) ) $=
      ( ccph wcel cphl cnlm csca cfv ccnfld cbs co wceq csqr eqid cress w3a cc0
      cpnf cico cin cima wss cv cmpt iscph simp3bi ) EIJEKJELJEMNZOUMPNZUAQRUBS
      UNUCUDUEQUFUGUNUHCADAUIZUOBQSNUJRAUMBUNCDEFGHUMTUNTUKUL $.

    $( The square of the norm is the norm of an inner product in a normed
       pre-Hilbert space.  (Contributed by Mario Carneiro, 7-Oct-2015.) $)
    cphnm $p |- ( ( W e. CPreHil /\ A e. V ) ->
        ( N ` A ) = ( sqr ` ( A ., A ) ) ) $=
      ( vx ccph wcel cfv cv co csqr cmpt cphnmfval fveq1d wceq oveq12 eqid fvex
      anidms fveq2d fvmpt sylan9eq ) EJKZADKACLAIDIMZUHBNZOLZPZLAABNZOLZUGACUKI
      BCDEFGHQRIAUJUMDUKUHASZUIULOUNUIULSUHAUHABTUCUDUKUAULOUBUEUF $.

    $( The square of the norm is the norm of an inner product in a normed
       pre-Hilbert space.  (Contributed by Mario Carneiro, 7-Oct-2015.) $)
    nmsq $p |- ( ( W e. CPreHil /\ A e. V ) ->
      ( ( N ` A ) ^ 2 ) = ( A ., A ) ) $=
      ( ccph wcel wa cfv c2 cexp co csqr cphnm oveq1d cc cphipcl 3anidm23 eqtrd
      sqsqrd ) EIJZADJZKZACLZMNOAABOZPLZMNOUHUFUGUIMNABCDEFGHQRUFUHUDUEUHSJAABD
      EFGTUAUCUB $.

    cphnmcl.f $e |- F = ( Scalar ` W ) $.
    cphnmcl.k $e |- K = ( Base ` F ) $.
    $( The norm of a vector is a member of the scalar field in a complex
       pre-Hilbert space.  (Contributed by Mario Carneiro, 9-Oct-2015.) $)
    cphnmf $p |- ( W e. CPreHil -> N : V --> K ) $=
      ( vx ccph wcel wf co cfv cr cc0 cle cv csqr cmpt wa wbr simpl cphl cphphl
      adantr simpr ipcl syl3anc c2 cexp nmsq cngp cphngp sylan resqcld eqeltrrd
      nmcl sqge0d breqtrd cphsqrcl syl13anc eqid fmptd cphnmfval feq1d mpbird )
      FMNZECDOECLELUAZVLBPZUBQZUCZOVKLEVNCVOVKVLENZUDZVKVMCNZVMRNSVMTUEVNCNVKVP
      UFVQFUGNZVPVPVRVKVSVPFUHUIVKVPUJZVTVLVLABCEFJHGKUKULVQVLDQZUMUNPZVMRVLBDE
      FGHIUOZVQWAVKFUPNVPWARNFUQVLFDEGIVAURZUSUTVQSWBVMTVQWAWDVBWCVCVMACFJKVDVE
      VOVFVGVKECDVOLBDEFGHIVHVIVJ $.

    $( The norm of a vector is a member of the scalar field in a complex
       pre-Hilbert space.  (Contributed by Mario Carneiro, 9-Oct-2015.) $)
    cphnmcl $p |- ( ( W e. CPreHil /\ A e. V ) -> ( N ` A ) e. K ) $=
      ( ccph wcel cphnmf ffvelrnda ) GMNFDAEBCDEFGHIJKLOP $.
  $}

  ${
    reipcl.v $e |- V = ( Base ` W ) $.
    reipcl.h $e |- ., = ( .i ` W ) $.
    $( An inner product of an element with itself is real.  (Contributed by
       Mario Carneiro, 7-Oct-2015.) $)
    reipcl $p |- ( ( W e. CPreHil /\ A e. V ) -> ( A ., A ) e. RR ) $=
      ( ccph wcel wa cnm cfv c2 cexp co cr eqid nmsq cngp cphngp nmcl eqeltrrd
      sylan resqcld ) DGHZACHZIZADJKZKZLMNAABNOABUGCDEFUGPZQUFUHUDDRHUEUHOHDSAD
      UGCEUITUBUCUA $.

    $( The inner product in a complex pre-Hilbert space is positive definite.
       (Contributed by Mario Carneiro, 7-Oct-2015.) $)
    ipge0 $p |- ( ( W e. CPreHil /\ A e. V ) -> 0 <_ ( A ., A ) ) $=
      ( ccph wcel wa cc0 cnm cfv c2 cexp co cle cngp cr cphngp eqid nmcl sqge0d
      sylan nmsq breqtrd ) DGHZACHZIZJADKLZLZMNOAABOPUHUJUFDQHUGUJRHDSADUICEUIT
      ZUAUCUBABUICDEFUKUDUE $.
  $}

  ${
    cphipcj.h $e |- ., = ( .i ` W ) $.
    cphipcj.v $e |- V = ( Base ` W ) $.
    ${
      $( Conjugate of an inner product in a complex pre-Hilbert space.  Complex
         version of ~ ipcj .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cphipcj $p |- ( ( W e. CPreHil /\ A e. V /\ B e. V ) ->
        ( * ` ( A ., B ) ) = ( B ., A ) ) $=
        ( ccph wcel w3a co ccj cfv csca cstv wceq cclm cphclm eqid clmcj fveq1d
        syl 3ad2ant1 cphl cphphl ipcj syl3an1 eqtrd ) EHIZADIZBDIZJZABCKZLMUMEN
        MZOMZMZBACKZULUMLUOUIUJLUOPZUKUIEQIURERUNEUNSZTUBUCUAUIEUDIUJUKUPUQPEUE
        ABUNCUODEUSFGUOSUFUGUH $.
    $}

    ${
      $( Orthogonality (meaning inner product is 0) is commutative.  Complex
         version of ~ iporthcom .  (Contributed by Mario Carneiro,
         16-Oct-2015.) $)
      cphorthcom $p |- ( ( W e. CPreHil /\ A e. V /\ B e. V ) ->
        ( ( A ., B ) = 0 <-> ( B ., A ) = 0 ) ) $=
        ( ccph wcel w3a co csca cfv c0g wceq cc0 cphl wb eqid eqeq2d cphphl syl
        iporthcom syl3an1 cclm cphclm clm0 3ad2ant1 3bitr4d ) EHIZADIZBDIZJZABC
        KZELMZNMZOZBACKZUPOZUNPOURPOUJEQIUKULUQUSREUAABUOCDEUPUOSZFGUPSUCUDUMPU
        PUNUJUKPUPOZULUJEUEIVAEUFUOEUTUGUBUHZTUMPUPURVBTUI $.

      cphip0l.z $e |- .0. = ( 0g ` W ) $.
      $( Inner product with a zero first argument.  Part of proof of Theorem
         6.44 of [Ponnusamy] p. 361.  Complex version of ~ ip0l .  (Contributed
         by Mario Carneiro, 16-Oct-2015.) $)
      cphip0l $p |- ( ( W e. CPreHil /\ A e. V ) -> ( .0. ., A ) = 0 ) $=
        ( ccph wcel wa co csca cfv c0g cc0 cphl wceq cphphl eqid ip0l cclm clm0
        sylan cphclm syl adantr eqtr4d ) DIJZACJZKEABLZDMNZONZPUIDQJUJUKUMRDSAU
        LBCDEUMULTZFGUMTHUAUDUIPUMRZUJUIDUBJUODUEULDUNUCUFUGUH $.

      $( Inner product with a zero second argument.  Complex version of
         ~ ip0r .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cphip0r $p |- ( ( W e. CPreHil /\ A e. V ) -> ( A ., .0. ) = 0 ) $=
        ( ccph wcel wa co csca cfv c0g cc0 cphl wceq cphphl eqid ip0r cclm clm0
        sylan cphclm syl adantr eqtr4d ) DIJZACJZKAEBLZDMNZONZPUIDQJUJUKUMRDSAU
        LBCDEUMULTZFGUMTHUAUDUIPUMRZUJUIDUBJUODUEULDUNUCUFUGUH $.

      $( The inner product of a vector with itself is zero iff the vector is
         zero.  Part of Definition 3.1-1 of [Kreyszig] p. 129.  Complex version
         of ~ ipeq0 .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cphipeq0 $p |- ( ( W e. CPreHil /\ A e. V ) ->
        ( ( A ., A ) = 0 <-> A = .0. ) ) $=
        ( ccph wcel wa co cc0 wceq csca cfv c0g cclm cphclm eqid clm0 adantr wb
        syl eqeq2d cphl cphphl ipeq0 sylan bitrd ) DIJZACJZKZAABLZMNUNDOPZQPZNZ
        AENZUMMUPUNUKMUPNZULUKDRJUSDSUODUOTZUAUDUBUEUKDUFJULUQURUCDUGAUOBCDEUPU
        TFGUPTHUHUIUJ $.
    $}

    ${
      cphdir.P $e |- .+ = ( +g ` W ) $.
      $( Distributive law for inner product.  Equation I3 of [Ponnusamy]
         p. 362.  Complex version of ~ ipdir .  (Contributed by Mario Carneiro,
         16-Oct-2015.) $)
      cphdir $p |- ( ( W e. CPreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( ( A .+ B ) ., C ) = ( ( A ., C ) + ( B ., C ) ) ) $=
        ( ccph wcel w3a wa co csca cfv caddc wceq eqid cplusg cphl cphphl ipdir
        sylan cclm cphclm clmadd syl adantr oveqd eqtr4d ) GKLZAFLBFLCFLMZNZABD
        OCEOZACEOZBCEOZGPQZUAQZOZUQURROUMGUBLUNUPVASGUCABCDUTUSEFGUSTZHIJUTTUDU
        EUORUTUQURUMRUTSZUNUMGUFLVCGUGUSGVBUHUIUJUKUL $.

      $( Distributive law for inner product.  Complex version of ~ ipdi .
         (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cphdi $p |- ( ( W e. CPreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( A ., ( B .+ C ) ) = ( ( A ., B ) + ( A ., C ) ) ) $=
        ( ccph wcel w3a wa co csca cfv caddc wceq eqid cplusg cphl cphphl sylan
        ipdi cclm cphclm clmadd syl adantr oveqd eqtr4d ) GKLZAFLBFLCFLMZNZABCD
        OEOZABEOZACEOZGPQZUAQZOZUQURROUMGUBLUNUPVASGUCABCDUTUSEFGUSTZHIJUTTUEUD
        UORUTUQURUMRUTSZUNUMGUFLVCGUGUSGVBUHUIUJUKUL $.

      cph2di.1 $e |- ( ph -> W e. CPreHil ) $.
      cph2di.2 $e |- ( ph -> A e. V ) $.
      cph2di.3 $e |- ( ph -> B e. V ) $.
      cph2di.4 $e |- ( ph -> C e. V ) $.
      cph2di.5 $e |- ( ph -> D e. V ) $.
      $( Distributive law for inner product.  Complex version of ~ ip2di .
         (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cph2di $p |- ( ph -> ( ( A .+ B ) ., ( C .+ D ) ) =
        ( ( ( A ., C ) + ( B ., D ) ) + ( ( A ., D ) + ( B ., C ) ) ) ) $=
        ( co caddc wcel csca cfv cplusg eqid ccph cphl cphphl ip2di cclm cphclm
        syl wceq clmadd 3syl oveqd oveq123d eqtr4d ) ABCFRDEFRGRBDGRZCEGRZIUAUB
        ZUCUBZRZBEGRZCDGRZVARZVARURUSSRZVCVDSRZSRABCDEFVAUTGHIUTUDZJKLVAUDAIUET
        ZIUFTMIUGUKNOPQUHAVFVBVGVESVAAVIIUITSVAULMIUJUTIVHUMUNZASVAURUSVJUOASVA
        VCVDVJUOUPUQ $.
    $}

    ${
      cphsubdir.m $e |- .- = ( -g ` W ) $.
      $( Distributive law for inner product subtraction.  Complex version of
         ~ ipsubdir .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cphsubdir $p |- ( ( W e. CPreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( ( A .- B ) ., C ) = ( ( A ., C ) - ( B ., C ) ) ) $=
        ( ccph wcel w3a co cfv wceq eqid adantr ipcl syl3anc csca csg cmin cphl
        wa cphphl ipsubdir sylan cclm cphclm simpr1 simpr3 simpr2 clmsub eqtr4d
        cbs ) GKLZAFLZBFLZCFLZMZUEZABENCDNZACDNZBCDNZGUAOZUBOZNZVDVEUCNZUQGUDLZ
        VAVCVHPGUFZABCVGVFDEFGVFQZHIJVGQUGUHVBGUILZVDVFUPOZLZVEVNLZVIVHPUQVMVAG
        UJRVBVJURUTVOUQVJVAVKRZUQURUSUTUKUQURUSUTULZACVFDVNFGVLHIVNQZSTVBVJUSUT
        VPVQUQURUSUTUMVRBCVFDVNFGVLHIVSSTVDVEVFVNGVLVSUNTUO $.

      $( Distributive law for inner product subtraction.  Complex version of
         ~ ipsubdi .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cphsubdi $p |- ( ( W e. CPreHil /\ ( A e. V /\ B e. V /\ C e. V ) ) ->
        ( A ., ( B .- C ) ) = ( ( A ., B ) - ( A ., C ) ) ) $=
        ( ccph wcel w3a co cfv wceq eqid adantr ipcl syl3anc csca csg cmin cphl
        cphphl ipsubdi sylan cclm cbs cphclm simpr1 simpr2 simpr3 clmsub eqtr4d
        wa ) GKLZAFLZBFLZCFLZMZUPZABCENDNZABDNZACDNZGUAOZUBOZNZVDVEUCNZUQGUDLZV
        AVCVHPGUEZABCVGVFDEFGVFQZHIJVGQUFUGVBGUHLZVDVFUIOZLZVEVNLZVIVHPUQVMVAGU
        JRVBVJURUSVOUQVJVAVKRZUQURUSUTUKZUQURUSUTULABVFDVNFGVLHIVNQZSTVBVJURUTV
        PVQVRUQURUSUTUMACVFDVNFGVLHIVSSTVDVEVFVNGVLVSUNTUO $.

      cph2subdi.1 $e |- ( ph -> W e. CPreHil ) $.
      cph2subdi.2 $e |- ( ph -> A e. V ) $.
      cph2subdi.3 $e |- ( ph -> B e. V ) $.
      cph2subdi.4 $e |- ( ph -> C e. V ) $.
      cph2subdi.5 $e |- ( ph -> D e. V ) $.
      $( Distributive law for inner product subtraction.  Complex version of
         ~ ip2subdi .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
      cph2subdi $p |- ( ph -> ( ( A .- B ) ., ( C .- D ) ) =
        ( ( ( A ., C ) + ( B ., D ) ) - ( ( A ., D ) + ( B ., C ) ) ) ) $=
        ( co wcel syl3anc caddc csca cfv cplusg cmin cclm wceq ccph cphclm eqid
        csg syl clmadd oveqd oveq12d cbs cphphl clmacl clmsub ip2subdi 3eqtr4rd
        cphl ipcl ) ABDFRZCEFRZUARZBEFRZCDFRZUARZIUBUCZUKUCZRZVDVEVJUDUCZRZVGVH
        VMRZVKRVFVIUERZBCGRDEGRFRAVFVNVIVOVKAUAVMVDVEAIUFSZUAVMUGAIUHSZVQMIUIUL
        ZVJIVJUJZUMULZUNAUAVMVGVHWAUNUOAVQVFVJUPUCZSZVIWBSZVPVLUGVSAVQVDWBSZVEW
        BSZWCVSAIVBSZBHSZDHSZWEAVRWGMIUQULZNPBDVJFWBHIVTJKWBUJZVCTAWGCHSZEHSZWF
        WJOQCEVJFWBHIVTJKWKVCTVJWBIVDVEVTWKURTAVQVGWBSZVHWBSZWDVSAWGWHWMWNWJNQB
        EVJFWBHIVTJKWKVCTAWGWLWIWOWJOPCDVJFWBHIVTJKWKVCTVJWBIVGVHVTWKURTVFVIVJW
        BIVTWKUSTABCDEVMVKVJFGHIVTJKLVKUJVMUJWJNOPQUTVA $.
    $}

    cphass.f $e |- F = ( Scalar ` W ) $.
    cphass.k $e |- K = ( Base ` F ) $.
    cphass.s $e |- .x. = ( .s ` W ) $.
    $( Associative law for inner product.  Equation I2 of [Ponnusamy] p. 363.
       See ~ ipass , ~ his5 .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    cphass $p |- ( ( W e. CPreHil /\ ( A e. K /\ B e. V /\ C e. V ) ) ->
      ( ( A .x. B ) ., C ) = ( A x. ( B ., C ) ) ) $=
      ( ccph wcel w3a co cmul wceq wa cmulr cphl cphphl eqid ipass sylan cphclm
      cfv cclm clmmul syl adantr oveqd eqtr4d ) IOPZAGPBHPCHPQZUAZABDRCFRZABCFR
      ZEUBUIZRZAUTSRUPIUCPUQUSVBTIUDABCDVAEFGHILJKMNVAUEUFUGURSVAAUTUPSVATZUQUP
      IUJPVCIUHEILUKULUMUNUO $.

    $( "Associative" law for second argument of inner product (compare
       ~ cphass ).  See ~ ipassr , his52 .  (Contributed by Mario Carneiro,
       16-Oct-2015.) $)
    cphassr $p |- ( ( W e. CPreHil /\ ( A e. K /\ B e. V /\ C e. V ) ) ->
      ( B ., ( A .x. C ) ) = ( ( * ` A ) x. ( B ., C ) ) ) $=
      ( wcel co ccj cfv cmul wceq ccph w3a cstv cmulr cclm cphclm adantr clmmul
      wa syl eqidd clmcj fveq1d oveq123d cc clmsscn simpr1 sseldd cjcld cphipcl
      3adant3r1 mulcomd cphl cphphl 3anrot biimpi eqid ipassr syl2an 3eqtr4rd
      wss ) IUAOZAGOZBHOZCHOZUBZUIZBCFPZAQRZSPVRAEUCRZRZEUDRZPZVSVRSPBACDPFPZVQ
      VRVRVSWASWBVQIUEOZSWBTVLWEVPIUFUGZEILUHUJVQVRUKVQAQVTVQWEQVTTWFEILULUJUMU
      NVQVSVRVQAVQGUOAVQWEGUOVKWFEGILMUPUJVLVMVNVOUQURUSVLVNVOVRUOOVMBCFHIKJUTV
      AVBVLIVCOVNVOVMUBZWDWCTVPIVDVPWGVMVNVOVEVFBCADWBEFVTGHILJKMNWBVGVTVGVHVIV
      J $.

    $( Move scalar multiplication to outside of inner product.  See ~ his35 .
       (Contributed by Mario Carneiro, 17-Oct-2015.) $)
    cph2ass $p |- ( ( W e. CPreHil /\
       ( A e. K /\ B e. K ) /\ ( C e. V /\ D e. V ) ) ->
     ( ( A .x. C ) ., ( B .x. D ) ) = ( ( A x. ( * ` B ) ) x. ( C ., D ) ) ) $=
      ( wcel wa co cmul cc ccph w3a ccj wceq simp1 simp2r simp3l simp3r cphassr
      cfv syl13anc oveq2d simp2l clmod cphlmod 3ad2ant1 lmodvscl syl3anc cphass
      wss cphclm clmsscn syl sseldd cjcld cphipcl 3expb 3adant2 mulassd 3eqtr4d
      cclm ) JUAPZAHPZBHPZQZCIPZDIPZQZUBZACBDERZGRZSRZABUCUJZCDGRZSRZSRACERVTGR
      ZAWCSRWDSRVSWAWEASVSVLVNVPVQWAWEUDVLVOVRUEZVLVMVNVRUFZVLVOVPVQUGZVLVOVPVQ
      UHZBCDEFGHIJKLMNOUIUKULVSVLVMVPVTIPZWFWBUDWGVLVMVNVRUMZWIVSJUNPZVNVQWKVLV
      OWMVRJUOUPWHWJBEFHIJDLMONUQURACVTEFGHIJKLMNOUSUKVSAWCWDVSHTAVSJVKPZHTUTVL
      VOWNVRJVAUPFHJMNVBVCZWLVDVSBVSHTBWOWHVDVEVLVRWDTPZVOVLVPVQWPCDGIJLKVFVGVH
      VIVJ $.
  $}

  ${
    $d x V $.
    tchex.v $e |- V = ( Base ` W ) $.
    $( Lemma for ~ tchbas and similar theorems.  (Contributed by Mario
       Carneiro, 7-Oct-2015.) $)
    tchex $p |- ( x e. V |-> ( sqr ` ( x ., x ) ) ) e. _V $=
      ( csqr crn c0 csn cun cv co cfv cmpt wf cvv wcel eqid cbs cc fvex eqeltri
      fvrn0 a1i fmpti cnex wss sqrf frn ax-mp ssexi p0ex unex fex2 mp3an ) CFGZ
      HIZJZACAKZUSBLZFMZNZOCPQURPQVBPQACURVAVBVBRVAURQUSCQFUTUCUDUECDSMPEDSUAUB
      UPUQUPTUFTTFOUPTUGUHTTFUIUJUKULUMCURVBPPUNUO $.
  $}

  ${
    $d x .- $.  $d w x y z ., $.  $d x y z F $.  $d x y z G $.  $d w x y z V $.
    $d x C $.  $d x y z ph $.  $d w x y z W $.  $d x .x. $.  $d x X $.
    $d x Y $.
    tchval.n $e |- G = ( toCHil ` W ) $.
    ${
      tchval.v $e |- V = ( Base ` W ) $.
      tchval.h $e |- ., = ( .i ` W ) $.
      $( Define a function to augment a pre-Hilbert space with norm.
         (Contributed by Mario Carneiro, 7-Oct-2015.) $)
      tchval $p |- G = ( W toNrmGrp
                          ( x e. V |-> ( sqr ` ( x ., x ) ) ) ) $=
        ( vw ctch cfv cv co csqr cmpt ctng cvv wceq cbs cip wcel id fveq2 oveqd
        syl6eqr fveq2d mpteq12dv oveq12d df-tch ovex fvmpt wn c0 fvprc reldmtng
        ovprc1 eqtr4d pm2.61i eqtri ) BEJKZEADALZVACMZNKZOZPMZFEQUAZUTVERIEILZA
        VGSKZVAVAVGTKZMZNKZOZPMVEQJVGERZVGEVLVDPVMUBVMAVHVKDVCVMVHESKDVGESUCGUE
        VMVJVBNVMVICVAVAVMVIETKCVGETUCHUEUDUFUGUHAIUIEVDPUJUKVFULUTUMVEEJUNEVDP
        UOUPUQURUS $.
    $}

    ${
      tchbas.v $e |- V = ( Base ` W ) $.
      $( The base set of a pre-Hilbert space augmented with norm.  (Contributed
         by Mario Carneiro, 8-Oct-2015.) $)
      tchbas $p |- V = ( Base ` G ) $=
        ( vx cv cip cfv co csqr cmpt cvv wcel cbs wceq tchex eqid tchval tngbas
        ax-mp ) FBFGZUBCHIZJKILZMNBAOIPFUCBCEQBACUDMFAUCBCDEUCRSETUA $.
    $}

    ${
      tchplusg.v $e |- .+ = ( +g ` W ) $.
      $( The addition operation of a pre-Hilbert space augmented with norm.
         (Contributed by Mario Carneiro, 8-Oct-2015.) $)
      tchplusg $p |- .+ = ( +g ` G ) $=
        ( vx cbs cfv cv cip co csqr cmpt cvv wcel cplusg wceq eqid tchex tchval
        tngplusg ax-mp ) FCGHZFIZUDCJHZKLHMZNOABPHQFUEUCCUCRZSABCUFNFBUEUCCDUGU
        ERTEUAUB $.
    $}

    ${
      tchmulr.t $e |- .x. = ( .r ` W ) $.
      $( The ring operation of a pre-Hilbert space augmented with norm.
         (Contributed by Mario Carneiro, 8-Oct-2015.) $)
      tchmulr $p |- .x. = ( .r ` G ) $=
        ( vx cbs cfv cv cip co csqr cmpt cvv wcel cmulr wceq eqid tchex tchval
        tngmulr ax-mp ) FCGHZFIZUDCJHZKLHMZNOABPHQFUEUCCUCRZSBACUFNFBUEUCCDUGUE
        RTEUAUB $.
    $}

    ${
      tchsca.f $e |- F = ( Scalar ` W ) $.
      $( The scalar field of a pre-Hilbert space augmented with norm.
         (Contributed by Mario Carneiro, 8-Oct-2015.) $)
      tchsca $p |- F = ( Scalar ` G ) $=
        ( vx cbs cfv cv cip co csqr cmpt cvv wcel csca wceq eqid tchex tchval
        tngsca ax-mp ) FCGHZFIZUDCJHZKLHMZNOABPHQFUEUCCUCRZSBACUFNFBUEUCCDUGUER
        TEUAUB $.
    $}

    ${
      tchvsca.s $e |- .x. = ( .s ` W ) $.
      $( The scalar multiplication of a pre-Hilbert space augmented with norm.
         (Contributed by Mario Carneiro, 8-Oct-2015.) $)
      tchvsca $p |- .x. = ( .s ` G ) $=
        ( vx cbs cfv cv cip co csqr cmpt cvv wcel cvsca wceq eqid tchex tchval
        tngvsca ax-mp ) FCGHZFIZUDCJHZKLHMZNOABPHQFUEUCCUCRZSBACUFNFBUEUCCDUGUE
        RTEUAUB $.
    $}

    ${
      tchip.s $e |- .x. = ( .i ` W ) $.
      $( The inner product of a pre-Hilbert space augmented with norm.
         (Contributed by Mario Carneiro, 8-Oct-2015.) $)
      tchip $p |- .x. = ( .i ` G ) $=
        ( vx cbs cfv cv co csqr cmpt cvv wcel cip wceq eqid tchex tchval tngip
        ax-mp ) FCGHZFIZUCAJKHLZMNABOHPFAUBCUBQZRBCAUDMFBAUBCDUEESETUA $.
    $}

    ${
      tchtopn.d $e |- D = ( dist ` G ) $.
      tchtopn.j $e |- J = ( TopOpen ` G ) $.
      $( The topology of a pre-Hilbert space augmented with norm.  (Contributed
         by Mario Carneiro, 8-Oct-2015.) $)
      tchtopn $p |- ( W e. V -> J = ( MetOpen ` D ) ) $=
        ( vx wcel cmopn cfv ctopn cbs cv cip co csqr cvv eqid cmpt tchex tchval
        wceq tngtopn mpan2 syl6reqr ) EDJZAKLZBMLZCUHIENLZIOZULEPLZQRLUAZSJUIUJ
        UDIUMUKEUKTZUBABEUIUNDSIBUMUKEFUOUMTUCGUITUEUFHUG $.
    $}

    $( Augmentation of a pre-Hilbert space with a norm does not affect whether
       it is still a pre-Hilbert space because all the orginal components are
       the same.  (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    tchphl $p |- ( W e. PreHil <-> G e. PreHil ) $=
      ( vx vy cphl wcel wtru cbs cfv csca eqidd wceq eqid cv wa cplusg proplem3
      a1i cvsca wb tchbas tchplusg tchsca tchvsca cip tchip phlpropd trud ) BFG
      AFGUAHDEBIJZBKJZIJZUKBAHUJLUJAIJMHAUJBCUJNUBSHDOZUJGEOUJGZPZDEBQJZAQJZUPU
      QMHUPABCUPNUCSRHUKLUKAKJMHUKABCUKNUDSULNHUMULGUNPDEBTJZATJZURUSMHURABCURN
      UESRHUODEBUFJZAUFJZUTVAMHUTABCUTNUGSRUHUI $.

    ${
      tchnmval.n $e |- N = ( norm ` G ) $.
      tchnmval.v $e |- V = ( Base ` W ) $.
      tchnmval.h $e |- ., = ( .i ` W ) $.
      $( The norm of a pre-Hilbert space augmented with norm.  (Contributed by
         Mario Carneiro, 8-Oct-2015.) $)
      tchnmfval $p |- ( W e. Grp ->
        N = ( x e. V |-> ( sqr ` ( x ., x ) ) ) ) $=
        ( cgrp wcel cv co csqr cfv cmpt cnm wf cc crn c0 csn cun wceq fvrn0 a1i
        eqid fmpti cnex wss sqrf frn ax-mp ssexi p0ex unex tngnm mpan2 syl6reqr
        tchval ) FKLZAEAMZVCCNZOPZQZBRPZDVBEOUAZUBUCZUDZVFSVFVGUEAEVJVEVFVFUHVE
        VJLVCELOVDUFUGUIVJBFVFEABCEFGIJVAIVHVIVHTUJTTOSVHTUKULTTOUMUNUOUPUQURUS
        HUT $.

      $( The norm of a pre-Hilbert space augmented with norm.  (Contributed by
         Mario Carneiro, 8-Oct-2015.) $)
      tchnmval $p |- ( ( W e. Grp /\ X e. V ) ->
        ( N ` X ) = ( sqr ` ( X ., X ) ) ) $=
        ( vx cgrp wcel cfv cv co csqr cmpt tchnmfval wceq fveq1d fvmpt sylan9eq
        oveq12 anidms fveq2d eqid fvex ) ELMZFDMFCNFKDKOZUJBPZQNZRZNFFBPZQNZUIF
        CUMKABCDEGHIJSUAKFULUODUMUJFTZUKUNQUPUKUNTUJFUJFBUDUEUFUMUGUNQUHUBUC $.
    $}

    ${
      cphtchnm.n $e |- N = ( norm ` W ) $.
      $( The norm of a norm-augmented complex pre-Hilbert space is the same as
         the original norm on it.  (Contributed by Mario Carneiro,
         11-Oct-2015.) $)
      cphtchnm $p |- ( W e. CPreHil -> N = ( norm ` G ) ) $=
        ( vx ccph wcel cbs cfv cv cip csqr cmpt cnm eqid cphnmfval clmod cgrp
        co wceq cphlmod lmodgrp tchnmfval 3syl eqtr4d ) CGHZBFCIJZFKZUICLJZTMJN
        ZAOJZFUJBUHCUHPZUJPZEQUGCRHCSHULUKUACUBCUCFAUJULUHCDULPUMUNUDUEUF $.
    $}

    tchcph.v $e |- V = ( Base ` W ) $.
    tchcph.f $e |- F = ( Scalar ` W ) $.
    tchcph.1 $e |- ( ph -> W e. PreHil ) $.
    tchcph.2 $e |- ( ph -> F = ( CCfld |`s K ) ) $.
    $( Lemma for ~ tchcph .  (Contributed by Mario Carneiro, 16-Oct-2015.) $)
    tchclm $p |- ( ph -> W e. CMod ) $=
      ( clmod wcel ccnfld cbs cfv cress co wceq syl csubrg cclm cphl phllmod cc
      cin eqid clvec phllvec lvecdrng cphsubrglem simp1d simp3d isclm syl3anbrc
      cdr ) AFLMZBNBOPZQRSZURNUAPMZFUBMAFUCMZUQJFUDTAUSURDUEUFSZUTADBURURUGZKAF
      UHMZBUPMAVAVDJFUITBFIUJTUKZULAUSVBUTVEUMBURFIVCUNUO $.

    tchcph.h $e |- ., = ( .i ` W ) $.
    $( Lemma for ~ tchcph : real closure of an inner product of a vector with
       itself.  (Contributed by Mario Carneiro, 10-Oct-2015.) $)
    tchcphlem3 $p |- ( ( ph /\ X e. V ) -> ( X ., X ) e. RR ) $=
      ( wcel cfv cc adantr eqid ccj wa co cbs cclm wss tchclm clmsscn cphl ipcl
      syl 3anidm23 sylan sseldd cstv wceq clmcj fveq1d simpr ipcj syl3anc eqtrd
      cjrebd ) AHFOZUAZHHDUBZVDBUCPZQVEVDGUDOZVFQUEAVGVCABCEFGIJKLMUFRZBVFGKVFS
      ZUGUJAGUHOZVCVEVFOZLVJVCVKHHBDVFFGKNJVIUIUKULUMVDVETPVEBUNPZPZVEVDVETVLVD
      VGTVLUOVHBGKUPUJUQVDVJVCVCVMVEUOAVJVCLRAVCURZVNHHBDVLFGKNJVLSUSUTVAVB $.

    tchcph.3 $e |- ( ( ph /\ ( x e. K /\ x e. RR /\ 0 <_ x ) ) ->
      ( sqr ` x ) e. K ) $.
    tchcph.4 $e |- ( ( ph /\ x e. V ) -> 0 <_ ( x ., x ) ) $.
    ${
      tchcph.k $e |- K = ( Base ` F ) $.
      ${
        ipcau2.n $e |- N = ( norm ` G ) $.
        ipcau2.c $e |- C = ( ( Y ., X ) / ( Y ., Y ) ) $.
        ipcau2.3 $e |- ( ph -> X e. V ) $.
        ipcau2.4 $e |- ( ph -> Y e. V ) $.
        $( The Cauchy-Schwarz inequality for a complex pre-Hilbert space.
           (Contributed by Mario Carneiro, 11-Oct-2015.) $)
        ipcau2 $p |- ( ph ->
          ( abs ` ( X ., Y ) ) <_ ( ( N ` X ) x. ( N ` Y ) ) ) $=
          ( co cabs cfv csqr cmul cle wbr cexp c0g wceq oveq2 oveq1d breq1d wne
          c2 wa cdiv cc wcel cclm wss tchclm clmsscn cphl syl3anc sseldd adantr
          syl ipcl cr tchcphlem3 mpdan recnd cc0 clm0 eqeq2d eqid ipeq0 syl2anc
          wb bitrd necon3bid biimpar divassd oveq2i syl6eqr cmin ccj cvsca wral
          csg cv clmod phllmod c1 syl5eq cstv ccnfld fveq2d ax-mp fveq1d eqtr3d
          cvv cbs oveq12d divrecd 3eqtrd clmmcl oveq12 anidms breq2d rspcv sylc
          eqeltrd caddc eqidd cmulr ipass syl13anc ipassr2 oveqd eqtrd 3eqtr3rd
          cplusg oveq2d oveq123d clmacl eqeltrrd mpbid eqbrtrd mulge0d resqrcld
          sqsqrd sqrge0d tchnmval fveq2i cjdivd cress eqeltri cnfldcj ressstarv
          fvex ipcj cjcjd cjred cdr clvec phllvec lvecdrng cphreccllem mpd3an23
          lmodvscl ralrimiva ip2subdi cnfldadd ressplusg cnfldmul clmsub abscld
          ressmulr divcan2d absvalsqd resqcld redivcld pnpcan2d breqtrd subge0d
          lmodvsubcl clt ledivmul2 syl112anc ip0r eqtr4d mul02d pm2.61ne sqmuld
          ne0gt0d 3brtr4d remulcld absge0d le2sqd mpbird cgrp lmodgrp breqtrrd
          ) AKLFUFZUGUHZKKFUFZUIUHZLLFUFZUIUHZUJUFZKHUHZLHUHZUJUFUKAUWLUWQUKULU
          WLUTUMUFZUWQUTUMUFZUKULAUWKLKFUFZUJUFZUWMUWOUJUFZUWTUXAUKAUXCUXDUKULZ
          KJUNUHZFUFZUXBUJUFZUXDUKULLUXFLUXFUOZUXCUXHUXDUKUXIUWKUXGUXBUJLUXFKFU
          PUQURALUXFUSZVAZUXCUWOVBUFZUWMUKULZUXEUXKUXLUWKCUJUFZUWMUKUXKUXLUWKUX
          BUWOVBUFZUJUFUXNUXKUWKUXBUWOAUWKVCVDUXJAGVCUWKAJVEVDZGVCVFZADEGIJMNOP
          QVGZDGJOUAVHZVMZAJVIVDZKIVDZLIVDZUWKGVDZPUDUEKLDFGIJORNUAVNVJZVKZVLZA
          UXBVCVDUXJAGVCUXBUXTAUYAUYCUYBUXBGVDZPUEUDLKDFGIJORNUAVNVJZVKZVLZAUWO
          VCVDUXJAUWOAUYCUWOVOVDZUEADEFGIJLMNOPQRVPVQZVRZVLZAUWOVSUSZUXJAUWOVSL
          UXFAUWOVSUOUWODUNUHZUOZUXIAVSUYQUWOAUXPVSUYQUOUXRDJOVTVMZWAAUYAUYCUYR
          UXIWEPUELDFIJUXFUYQORNUYQWBZUXFWBZWCWDWFWGWHZWICUXOUWKUJUCWJWKZUXKVSU
          WMUXNWLUFZUKULUXNUWMUKULUXKVSKCWMUHZLJWNUHZUFZJWPUHZUFZVUIFUFZVUDUKUX
          KVUIIVDZVSBWQZVULFUFZUKULZBIWOZVSVUJUKULZUXKJWRVDZUYBVUGIVDZVUKAVUQUX
          JAUYAVUQPJWSVMZVLZAUYBUXJUDVLZUXKVUQVUEGVDZUYCVURVUTUXKVUEUWKWTUWOVBU
          FZUJUFZGUXKVUEUXBWMUHZUWOWMUHZVBUFZUWKUWOVBUFVVDUXKVUEUXOWMUHVVGCUXOW
          MUCUUAUXKUXBUWOUYKUYOVUBUUBXAUXKVVEUWKVVFUWOVBUXKUWKWMUHZWMUHVVEUWKUX
          KVVHUXBWMAVVHUXBUOUXJAUWKDXBUHZUHZVVHUXBAUWKVVIWMAVVIXCGUUCUFZXBUHZWM
          ADVVKXBQXDGXHVDZWMVVLUOGDXIUHXHUADXIUUGUUDZGXCVVKWMXHVVKWBZUUEUUFXEWK
          ZXFAUYAUYBUYCVVJUXBUOPUDUEKLDFVVIIJORNVVIWBZUUHVJXGZVLXDUXKUWKUYGUUIX
          GUXKUWOAUYLUXJUYMVLZUUJXJUXKUWKUWOUYGUYOVUBXKXLUXKUXPUYDVVCGVDZVVDGVD
          AUXPUXJUXRVLZAUYDUXJUYEVLZUXKUWOGVDZUYPVVTAVWCUXJAUYAUYCUYCVWCPUEUELL
          DFGIJORNUAVNVJVLVUBUXKGDGUWOUAADVVKUOUXJQVLZADUUKVDZUXJAJUULVDZVWEAUY
          AVWFPJUUMVMDJOUUNVMVLUUOUUPZDGJUWKVVCOUAXMVJXSZAUYCUXJUEVLZVUEVUFDGIJ
          LNOVUFWBZUAUUQVJZVUHIJKVUGNVUHWBZUVMVJAVUOUXJAVUNBITUURZVLVUNVUPBVUII
          VULVUIUOZVUMVUJVSUKVWNVUMVUJUOVULVUIVULVUIFXNXOXPXQXRUXKVUJUWMVUGVUGF
          UFZDYIUHZUFZKVUGFUFZVUGKFUFZVWPUFZDWPUHZUFUWMVUEUXBUJUFZXTUFZUXNVXBXT
          UFZVXAUFZVUDUXKKVUGKVUGVWPVXADFVUHIJORNVWLVXAWBVWPWBAUYAUXJPVLZVVAVWK
          VVAVWKUUSUXKVWQVXCVWTVXDVXAUXKUWMUWMVWOVXBVWPXTUXKVWPVVKYIUHZXTUXKDVV
          KYIVWDXDVVMXTVXGUOVVNGXTXCVVKXHVVOUUTUVAXEWKZUXKUWMYAUXKVWOVUELVUGFUF
          ZDYBUHZUFZVXBUXKUYAVVBUYCVURVWOVXKUOVXFVWHVWIVWKVUELVUGVUFVXJDFGIJORN
          UAVWJVXJWBZYCYDUXKVUEVUEVXIUXBVXJUJUXKVXJVVKYBUHZUJUXKDVVKYBVWDXDVVMU
          JVXMUOVVNGXCVVKUJXHVVOUVBUVEXEWKZUXKVUEYAUXKUWOCVXJUFZLCVVIUHZLVUFUFZ
          FUFZUXBVXIUXKUYAUYCUYCCGVDZVXOVXRUOVXFVWIVWIUXKCUXBVVCUJUFZGUXKCUXOVX
          TUCUXKUXBUWOUYKUYOVUBXKXAUXKUXPUYHVVTVXTGVDVWAAUYHUXJUYIVLZVWGDGJUXBV
          VCOUAXMVJXSZLLCVUFVXJDFVVIGIJORNUAVWJVXLVVQYEYDUXKVXOUWOCUJUFZUXBUXKV
          XJUJUWOCVXNYFUXKVYCUWOUXOUJUFUXBCUXOUWOUJUCWJUXKUXBUWOUYKUYOVUBUVFXAY
          GUXKVXQVUGLFUXKVXPVUELVUFUXKCVVIWMAVVIWMUOUXJVVPVLXFUQZYJYHYKYGYKUXKV
          WRUXNVWSVXBVWPXTVXHUXKUWKCVXJUFZKVXQFUFZUXNVWRUXKUYAUYBUYCVXSVYEVYFUO
          VXFVVAVWIVYBKLCVUFVXJDFVVIGIJORNUAVWJVXLVVQYEYDUXKVXJUJUWKCVXNYFUXKVX
          QVUGKFVYDYJYHUXKVWSVUEUXBVXJUFZVXBUXKUYAVVBUYCUYBVWSVYGUOVXFVWHVWIVVA
          VUELKVUFVXJDFGIJORNUAVWJVXLYCYDUXKVXJUJVUEUXBVXNYFYGYKXJUXKVXCVXDWLUF
          ZVXEVUDUXKUXPVXCGVDZVXDGVDZVYHVXEUOVWAUXKUXPUWMGVDZVXBGVDZVYIVWAUXKUY
          AUYBUYBVYKVXFVVAVVAKKDFGIJORNUAVNVJUXKUXPVVBUYHVYLVWAVWHVYADGJVUEUXBO
          UAXMVJZDGJUWMVXBOUAYLVJUXKUXPUXNGVDZVYLVYJVWAUXKUXPUYDVXSVYNVWAVWBVYB
          DGJUWKCOUAXMVJVYMDGJUXNVXBOUAYLVJVXCVXDDGJOUAUVCVJUXKUWMUXNVXBAUWMVCV
          DUXJAUWMAUYBUWMVOVDZUDADEFGIJKMNOPQRVPVQZVRZVLUXKUXNUXKUXLUXNVOVUCUXK
          UXCUWOAUXCVOVDZUXJAUWTUXCVOAUWTUWKVVHUJUFUXCAUWKUYFUVGAVVHUXBUWKUJVVR
          YJYGZAUWLAUWKUYFUVDZUVHYMVLZVVSVUBUVIYMZVRUXKGVCVXBUXKUXPUXQVWAUXSVMV
          YMVKUVJXGXLUVKUXKUWMUXNAVYOUXJVYPVLZWUBUVLYNYOUXKVYRVYOUYLVSUWOUVNULU
          XMUXEWEWUAWUCVVSUXKUWOVVSAVSUWOUKULZUXJAUYCVUOWUDUEVWMVUNWUDBLIVULLUO
          ZVUMUWOVSUKWUEVUMUWOUOVULLVULLFXNXOXPXQXRZVLVUBUWBUXCUWMUWOUVOUVPYNAU
          XHVSUXDUKAUXHVSUXBUJUFVSAUXGVSUXBUJAUXGUYQVSAUYAUYBUXGUYQUOPUDKDFIJUX
          FUYQORNUYTVUAUVQWDUYSUVRUQAUXBUYJUVSYGAUWMUWOVYPUYMAUYBVUOVSUWMUKULZU
          DVWMVUNWUGBKIVULKUOZVUMUWMVSUKWUHVUMUWMUOVULKVULKFXNXOXPXQXRZWUFYPYOU
          VTVYSAUXAUWNUTUMUFZUWPUTUMUFZUJUFUXDAUWNUWPAUWNAUWMVYPWUIYQZVRAUWPAUW
          OUYMWUFYQZVRUWAAWUJUWMWUKUWOUJAUWMVYQYRAUWOUYNYRXJYGUWCAUWLUWQVYTAUWN
          UWPWULWUMUWDAUWKUYFUWEAUWNUWPWULWUMAUWMVYPWUIYSAUWOUYMWUFYSYPUWFUWGAU
          WRUWNUWSUWPUJAJUWHVDZUYBUWRUWNUOAVUQWUNVUSJUWIVMZUDEFHIJKMUBNRYTWDAWU
          NUYCUWSUWPUOWUOUEEFHIJLMUBNRYTWDXJUWJ $.
      $}

      ${
        tchcph.m $e |- .- = ( -g ` W ) $.
        tchcphlem1.3 $e |- ( ph -> X e. V ) $.
        tchcphlem1.4 $e |- ( ph -> Y e. V ) $.
        $( Lemma for ~ tchcph : the triangle inequality.  (Contributed by Mario
           Carneiro, 8-Oct-2015.) $)
        tchcphlem1 $p |- ( ph -> ( sqr ` ( ( X .- Y ) ., ( X .- Y ) ) )
          <_ ( ( sqr ` ( X ., X ) ) + ( sqr ` ( Y ., Y ) ) ) ) $=
          ( co csqr cfv caddc cle wbr c2 cexp cmul cabs wcel cr cgrp cphl clmod
          phllmod lmodgrp 3syl grpsubcl syl3anc tchcphlem3 readdcld cc cclm wss
          mpdan tchclm clmsscn syl ipcl sseldd addcld abscld recnd 2re cc0 wral
          cv ralrimiva wceq oveq12 anidms breq2d sylc resqrcld remulcld remulcl
          rspcv sylancr add32d eqeltrd cmin absidd cplusg clmadd oveq12d clmacl
          csg oveqd clmsub eqid ip2subdi 3eqtr4rd fveq2d eqtr3d eqbrtrd addge0d
          abs2dif2d oveq1d breqtrd abstrid 2timesd ccj abscjd cstv clmcj fveq1d
          ipcj oveq2d breqtrrd cnm cdiv ipcau2 tchnmval syl2anc clt wb a1i 2pos
          eqtrd lemul2 syl112anc mpbid letrd leadd2dd sqsqrd sqrge0d 3brtr4d
          sqrcld binom2 le2sqd mpbird ) AJKGUDZUUFEUDZUEUFZJJEUDZUEUFZKKEUDZUEU
          FZUGUDZUHUIUUHUJUKUDZUUMUJUKUDZUHUIAUUGUUIUJUUJUULULUDZULUDZUGUDZUUKU
          GUDZUUNUUOUHAUUGUUIUUKUGUDZJKEUDZKJEUDZUGUDZUMUFZUGUDZUUSAUUFHUNZUUGU
          OUNAIUPUNZJHUNZKHUNZUVFAIUQUNZIURUNUVGOIUSIUTVAZUBUCHIGJKMUAVBVCZACDE
          FHIUUFLMNOPQVDVIZAUUTUVDAUUIUUKAUVHUUIUOUNUBACDEFHIJLMNOPQVDVIZAUVIUU
          KUOUNUCACDEFHIKLMNOPQVDVIZVEZAUVCAUVAUVBAFVFUVAAIVGUNZFVFVHACDFHILMNO
          PVJZCFINTVKVLZAUVJUVHUVIUVAFUNZOUBUCJKCEFHINQMTVMVCZVNZAFVFUVBUVSAUVJ
          UVIUVHUVBFUNZOUCUBKJCEFHINQMTVMVCZVNZVOZVPZVEAUUSUUTUUQUGUDZUOAUUIUUQ
          UUKAUUIUVNVQZAUUQAUJUOUNZUUPUOUNZUUQUOUNVRAUUJUULAUUIUVNAUVHVSBWAZUWL
          EUDZUHUIZBHVTZVSUUIUHUIZUBAUWNBHSWBZUWNUWPBJHUWLJWCZUWMUUIVSUHUWRUWMU
          UIWCUWLJUWLJEWDWEWFWKWGZWHZAUUKUVOAUVIUWOVSUUKUHUIZUCUWQUWNUXABKHUWLK
          WCZUWMUUKVSUHUXBUWMUUKWCUWLKUWLKEWDWEWFWKWGZWHZWIZUJUUPWJWLZVQAUUKUVO
          VQZWMZAUUTUUQUVPUXFVEWNAUUGUUTUMUFZUVDUGUDZUVEUHAUUGUUTUVCWOUDZUMUFZU
          XJUHAUUGUMUFUUGUXLAUUGUVMAUVFUWOVSUUGUHUIZUVLUWQUWNUXMBUUFHUWLUUFWCZU
          WMUUGVSUHUXNUWMUUGWCUWLUUFUWLUUFEWDWEWFWKWGZWPAUUGUXKUMAUUTUVCCXAUFZU
          DZUUIUUKCWQUFZUDZUVAUVBUXRUDZUXPUDUXKUUGAUUTUXSUVCUXTUXPAUGUXRUUIUUKA
          UVQUGUXRWCUVRCINWRVLZXBAUGUXRUVAUVBUYAXBWSAUVQUUTFUNZUVCFUNZUXKUXQWCU
          VRAUVQUUIFUNZUUKFUNZUYBUVRAUVJUVHUVHUYDOUBUBJJCEFHINQMTVMVCAUVJUVIUVI
          UYEOUCUCKKCEFHINQMTVMVCCFIUUIUUKNTWTVCZAUVQUVTUWCUYCUVRUWAUWDCFIUVAUV
          BNTWTVCUUTUVCCFINTXCVCAJKJKUXRUXPCEGHINQMUAUXPXDUXRXDOUBUCUBUCXEXFXGX
          HAUUTUVCAFVFUUTUVSUYFVNUWFXKXIAUXIUUTUVDUGAUUTUVPAUUIUUKUVNUVOUWSUXCX
          JWPXLXMAUVEUWHUUSUHAUVDUUQUUTUWGUXFUVPAUVDUJUVAUMUFZULUDZUUQUWGAUWJUY
          GUOUNZUYHUOUNVRAUVAUWBVPZUJUYGWJWLUXFAUVDUYGUVBUMUFZUGUDZUYHUHAUVAUVB
          UWBUWEXNAUYHUYGUYGUGUDUYLAUYGAUYGUYJVQXOAUYGUYKUYGUGAUVAXPUFZUMUFUYGU
          YKAUVAUWBXQAUYMUVBUMAUYMUVACXRUFZUFZUVBAUVAXPUYNAUVQXPUYNWCUVRCINXSVL
          XTAUVJUVHUVIUYOUVBWCOUBUCJKCEUYNHINQMUYNXDYAVCYMXGXHYBYMYCAUYGUUPUHUI
          ZUYHUUQUHUIZAUYGJDYDUFZUFZKUYRUFZULUDUUPUHABUVBUUKYEUDZCDEFUYRHIJKLMN
          OPQRSTUYRXDZVUAXDUBUCYFAUYSUUJUYTUULULAUVGUVHUYSUUJWCUVKUBDEUYRHIJLVU
          BMQYGYHAUVGUVIUYTUULWCUVKUCDEUYRHIKLVUBMQYGYHWSXMAUYIUWKUWJVSUJYIUIZU
          YPUYQYJUYJUXEUWJAVRYKVUCAYLYKUYGUUPUJYNYOYPYQYRUXHYCYQAUUGAUUGUVMVQYS
          AUUOUUJUJUKUDZUUQUGUDZUULUJUKUDZUGUDZUUSAUUJVFUNUULVFUNUUOVUGWCAUUIUW
          IUUBAUULUXDVQUUJUULUUCYHAVUEUURVUFUUKUGAVUDUUIUUQUGAUUIUWIYSXLAUUKUXG
          YSWSYMUUAAUUHUUMAUUGUVMUXOWHAUUJUULUWTUXDVEAUUGUVMUXOYTAUUJUULUWTUXDA
          UUIUVNUWSYTAUUKUVOUXCYTXJUUDUUE $.
      $}

      tchcph.s $e |- .x. = ( .s ` W ) $.
      tchcphlem2.3 $e |- ( ph -> X e. K ) $.
      tchcphlem2.4 $e |- ( ph -> Y e. V ) $.
      $( Lemma for ~ tchcph : homogeneity.  (Contributed by Mario Carneiro,
         8-Oct-2015.) $)
      tchcphlem2 $p |- ( ph -> ( sqr ` ( ( X .x. Y ) ., ( X .x. Y ) ) ) =
        ( ( abs ` X ) x. ( sqr ` ( Y ., Y ) ) ) ) $=
        ( ccj cfv cmul co csqr cabs cc cclm wss tchclm clmsscn sseldd cjmulrcld
        wcel syl cjmulge0d cr tchcphlem3 mpdan cc0 cv cle wral ralrimiva oveq12
        wbr wceq anidms breq2d rspcv sylc sqrmuld cstv cmulr cphl clmod phllmod
        lmodvscl syl3anc ipassr syl13anc clmmul oveqd ipass eqtr4d clmcj fveq1d
        eqid oveq123d recnd cjcld mul32d 3eqtr2d fveq2d absval oveq1d 3eqtr4d )
        AJJUDUEZUFUGZKKFUGZUFUGZUHUEXBUHUEZXCUHUEZUFUGJKCUGZXGFUGZUHUEJUIUEZXFU
        FUGAXBXCAJAGUJJAIUKUQZGUJULADEGHILMNOPUMZDGINTUNURUBUOZUPAJXLUSAKHUQZXC
        UTUQUCADEFGHIKLMNOPQVAVBZAXMVCBVDZXOFUGZVEVIZBHVFVCXCVEVIZUCAXQBHSVGXQX
        RBKHXOKVJZXPXCVCVEXSXPXCVJXOKXOKFVHVKVLVMVNVOAXHXDUHAXHXGKFUGZJDVPUEZUE
        ZDVQUEZUGZJXCUFUGZXAUFUGXDAIVRUQZXGHUQZXMJGUQZXHYDVJOAIVSUQZYHXMYGAYFYI
        OIVTURUBUCJCDGHIKMNUATWAWBUCUBXGKJCYCDFYAGHINQMTUAYCWKZYAWKWCWDAYEXTXAY
        BUFYCAXJUFYCVJXKDINWEURZAYEJXCYCUGZXTAUFYCJXCYKWFAYFYHXMXMXTYLVJOUBUCUC
        JKKCYCDFGHINQMTUAYJWGWDWHAJUDYAAXJUDYAVJXKDINWIURWJWLAJXCXAXLAXCXNWMAJX
        LWNWOWPWQAXIXEXFUFAJUJUQXIXEVJXLJWRURWSWT $.
    $}

    $( The standard definition of a norm turns any pre-Hilbert space over a
       quadratically closed subfield of ` CC ` into a complex pre-Hilbert space
       (which allows access to a norm, metric, and topology).  (Contributed by
       Mario Carneiro, 11-Oct-2015.) $)
    tchcph $p |- ( ph -> G e. CPreHil ) $=
      ( wcel cfv wceq cc vy vz cphl cnlm ccnfld cbs cress co w3a csqr cpnf cico
      cc0 cin cima wss cnm cv cmpt ccph tchphl sylib cngp clmod cnrg cvsca cmul
      wral csg c0g tchval eqid phllmod syl lmodgrp cr tchcphlem3 resqrcld fmptd
      cgrp wa oveq12 anidms fveq2d fvex fvmpt3i adantl eqeq1d c2 cexp wb csubrg
      clvec cdr lvecdrng cphsubrglem simp2d inss2 syl6eqss adantr ipcl 3anidm23
      phllvec sylan sseldd sqrcld sqeq0 sqsqrd cclm tchclm eqeq12d bitr3d ipeq0
      clm0 3bitrd caddc cle simp1d wbr 3anass simpr2 recnd jca eleq2d recn elin
      ex rbaib syl5bi adantlr simprl simprr 3expb sylancr 3jca tchnmval syl2anc
      cabs wf sqrf sylan9bb adantrr pm5.32rd syl6bbr syl6bb tchcphlem1 grpsubcl
      3imtr4d imp oveqan12d 3brtr4d tngngpd simp3d subrgnrg tchcphlem2 lmodvscl
      cnnrg eqeltrd fveq1d subrgsubg cnfldnm subgnm2 oveq12d 3eqtr4d ralrimivva
      csubg eqtrd tchbas tchvsca tchsca isnlm sylanbrc elrege0 anbi2i bitri cdm
      ralrimiv wfun ffun ax-mp inss1 syl5ss fdmi syl6sseqr funimass4 cnex tngnm
      mpbird eqcomd tchip iscph syl3anbrc ) ADUCQZDUDQZCUECUFRZUGUHZSZUIUJUWOUM
      UKULUHZUNZUOUWOUPZDUQRZUAGUAURZUXBEUHZUJRZUSZSDUTQAUWMUWNUWQAHUCQZUWMLDHI
      VAVBZADVCQZDVDQZCVEQZUIUXBUBURZHVFRZUHZUXARZUXBCUQRZRZUXKUXARZVGUHZSZUBGV
      HUAUWOVHUWNAUXHUXIUXJAUAUBDHHVIRZBGBURZUYAEUHZUJRZUSZGHVJRZBDEGHIJNVKJUXT
      VLZUYEVLZAHVDQZHVTQZAUXFUYHLHVMVNZHVOVNZABGUYCVPUYDAUYAGQZWAUYBACDEFGHUYA
      IJKLMNVQPVRUYDVLZVSAUXBGQZWAZUXBUYDRZUMSUXDUMSZUXCCVJRZSZUXBUYESZUYOUYPUX
      DUMUYNUYPUXDSABUXBUYCUXDGUYDUYAUXBSZUYBUXCUJVUAUYBUXCSUYAUXBUYAUXBEWBWCWD
      UYMUYBUJWEZWFZWGWHUYOUXDWIWJUHZUMSZUYQUYSUYOUXDTQVUEUYQWKUYOUXCUYOUWOTUXC
      AUWOTUPUYNAUWOFTUNZTAUWQUWOVUFSZUWOUEWLRQZAFCUWOUWOVLZMAHWMQZCWNQAUXFVUJL
      HXCVNCHKWOVNWPZWQZFTWRWSZWTAUXFUYNUXCUWOQZLUXFUYNVUNUXBUXBCEUWOGHKNJVUIXA
      XBXDXEZXFZUXDXGVNUYOVUDUXCUMUYRUYOUXCVUOXHAUMUYRSZUYNAHXIQVUQACDFGHIJKLMX
      JCHKXNVNWTXKXLAUXFUYNUYSUYTWKLUXBCEGHUYEUYRKNJUYRVLUYGXMXDXOAUYNUXKGQZWAZ
      WAZUXBUXKUXTUHZVVAEUHZUJRZUXDUXKUXKEUHZUJRZXPUHZVVAUYDRZUYPUXKUYDRZXPUHZX
      QVUTBCDEUWOUXTGHUXBUXKIJKAUXFVUSLWTAUWQVUSAUWQVUGVUHVUKXRZWTNAUYAUWOQZUYA
      VPQZUMUYAXQXSZUIZUYAUJRZUWOQZVUSAVVNVVPVVNVVKVVLVVMWAZWAZAVVPVVKVVLVVMXTA
      UYAFQZVVLVVMUIZVVOFQZVVOTQZWAZVVRVVPAVVTVWCAVVTWAZVWAVWBOVWDUYAVWDUYAAVVS
      VVLVVMYAYBXFYCYGAVVRVVSVVQWAVVTAVVQVVKVVSAVVQVVKVVSWKZAVVLVWEVVMAVVKUYAVU
      FQZVVLVVSAUWOVUFUYAVULYDVVLUYATQZVWFVVSWKUYAYEVWFVVSVWGUYAFTYFYHVNUUAUUBY
      GUUCVVSVVLVVMXTUUDAVVPVVOVUFQVWCAUWOVUFVVOVULYDVVOFTYFUUEUUHZYIUUIZYJAUYL
      UMUYBXQXSZVUSPYJVUIUYFAUYNVURYKAUYNVURYLUUFVUTVVAGQZVVGVVCSAUYIVUSVWKUYKU
      YIUYNVURVWKGHUXTUXBUXKJUYFUUGYMXDBVVAUYCVVCGUYDUYAVVASZUYBVVBUJVWLUYBVVBS
      UYAVVAUYAVVAEWBWCWDUYMVUBWFVNVUSVVIVVFSAUYNVURUYPUXDVVHVVEXPVUCBUXKUYCVVE
      GUYDUYAUXKSZUYBVVDUJVWMUYBVVDSUYAUXKUYAUXKEWBWCWDUYMVUBWFUUJWGUUKUULAUWMU
      XIUXGDVMVNACUWPVEVVJAUEVEQVUHUWPVEQUUQAUWQVUGVUHVUKUUMZUWOUEUWPUWPVLZUUNY
      NUURYOAUXSUAUBUWOGAUXBUWOQZVURWAZWAZUXMUXMEUHUJRZUXBYRRZVVEVGUHUXNUXRVWRB
      UXLCDEUWOGHUXBUXKIJKAUXFVWQLWTAUWQVWQVVJWTZNAVVNVVPVWQVWIYJAUYLVWJVWQPYJV
      UIUXLVLZAVWPVURYKZAVWPVURYLZUUOVWRUYIUXMGQZUXNVWSSAUYIVWQUYKWTZAUYHVWQVXE
      UYJUYHVWPVURVXEUXBUXLCUWOGHUXKJKVXBVUIUUPYMXDDEUXAGHUXMIUXAVLZJNYPYQVWRUX
      PVWTUXQVVEVGVWRUXPUXBUWPUQRZRZVWTVWRUXBUXOVXHVWRCUWPUQVXAWDUUSVWRUWOUEUVF
      RQZVWPVXIVWTSAVXJVWQAVUHVXJVWNUWOUEUUTVNWTVXCUWOUEUWPVXHYRUXBVWOUVAVXHVLU
      VBYQUVGVWRUYIVURUXQVVESVXFVXDDEUXAGHUXKIVXGJNYPYQUVCUVDUVEUAUBUXOUXLCUWOU
      XAGDDGHIJUVHZVXGUXLDHIVXBUVICDHIKUVJZVUIUXOVLUVKUVLVVJYOAUWTVVPBUWSVHZAVV
      PBUWSUYAUWSQZVVRAVVPVXNVVKUYAUWRQZWAVVRUYAUWOUWRYFVXOVVQVVKUYAUVMUVNUVOVW
      HYIUVQAUJUVRZUWSUJUVPZUPUWTVXMWKTTUJYSVXPYTTTUJUVSUVTAUWSTVXQAUWSUWOTUWOU
      WRUWAVUMUWBTTUJYTUWCUWDBUWSUWOUJUWEYNUWHAUXEUXAAUYIGTUXEYSUXEUXASUYKAUAGU
      XDTUXEVUPUXEVLVSTDHUXEGUADEGHIJNVKJUWFUWGYQUWIUACEUWOUXAGDVXKEDHINUWJVXGV
      XLVUIUWKUWL $.
  $}

  ${
    $d x ., $.  $d x V $.  $d x W $.  $d x X $.  $d x Y $.
    ipcau.v $e |- V = ( Base ` W ) $.
    ipcau.h $e |- ., = ( .i ` W ) $.
    ipcau.n $e |- N = ( norm ` W ) $.
    $( The Cauchy-Schwarz inequality for a complex pre-Hilbert space.
       (Contributed by Mario Carneiro, 11-Oct-2015.) $)
    ipcau $p |- ( ( W e. CPreHil /\ X e. V /\ Y e. V ) ->
      ( abs ` ( X ., Y ) ) <_ ( ( N ` X ) x. ( N ` Y ) ) ) $=
      ( vx wcel w3a co cfv cmul cle eqid syl wceq cc0 ccph cabs ctch cdiv simp1
      cnm csca cbs cphl cphphl ccnfld cress cphsca cv csqr cphsqrcl sylan ipge0
      cr wbr simp2 simp3 ipcau2 cphtchnm fveq1d oveq12d breqtrrd ) DUAKZECKZFCK
      ZLZEFAMUBNEDUCNZUFNZNZFVMNZOMEBNZFBNZOMPVKJFEAMFFAMUDMZDUGNZVLAVSUHNZVMCD
      EFVLQZGVSQZVKVHDUIKVHVIVJUEZDUJRVKVHVSUKVTULMSWCVSVTDWBVTQZUMRHVKVHJUNZVT
      KWEUSKTWEPUTLWEUONVTKWCWEVSVTDWBWDUPUQVKVHWECKTWEWEAMPUTWCWEACDGHURUQWDVM
      QVRQVHVIVJVAVHVIVJVBVCVKVPVNVQVOOVKEBVMVKVHBVMSWCVLBDWAIVDRZVEVKFBVMWFVEV
      FVG $.
  $}

  ${
    nmpar.v $e |- V = ( Base ` W ) $.
    nmpar.p $e |- .+ = ( +g ` W ) $.
    nmpar.m $e |- .- = ( -g ` W ) $.
    nmpar.n $e |- N = ( norm ` W ) $.
    ${
      nmpar.h $e |- ., = ( .i ` W ) $.
      nmpar.f $e |- F = ( Scalar ` W ) $.
      nmpar.k $e |- K = ( Base ` F ) $.
      nmpar.1 $e |- ( ph -> W e. CPreHil ) $.
      nmpar.2 $e |- ( ph -> A e. V ) $.
      nmpar.3 $e |- ( ph -> B e. V ) $.
      $( Lemma for ~ nmpar .  (Contributed by Mario Carneiro, 7-Oct-2015.) $)
      nmparlem $p |- ( ph ->
        ( ( ( N ` ( A .+ B ) ) ^ 2 ) + ( ( N ` ( A .- B ) ) ^ 2 ) ) =
         ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
        ( co caddc cfv c2 cexp cmul cmin cph2di cph2subdi oveq12d cclm wcel wss
        cc ccph cphclm syl clmsscn cphl cphphl ipcl syl3anc clmacl sseldd eqtrd
        ppncand wceq clmod cphlmod lmodvacl nmsq syl2anc oveq2d 2timesd 3eqtr4d
        lmodvsubcl ) ABCDUBZVRFUBZBCHUBZVTFUBZUCUBZBBFUBZCCFUBZUCUBZWEUCUBZVRIU
        DUEUFUBZVTIUDUEUFUBZUCUBUEBIUDUEUFUBZCIUDUEUFUBZUCUBZUGUBZAWBWEBCFUBZCB
        FUBZUCUBZUCUBZWEWOUHUBZUCUBWFAVSWPWAWQUCABCBCDFJKPLMSTUATUAUIABCBCFHJKP
        LNSTUATUAUJUKAWEWOWEAGUOWEAKULUMZGUOUNAKUPUMZWRSKUQURZEGKQRUSURZAWRWCGU
        MZWDGUMZWEGUMWTAKUTUMZBJUMZXEXBAWSXDSKVAURZTTBBEFGJKQPLRVBVCAXDCJUMZXGX
        CXFUAUACCEFGJKQPLRVBVCEGKWCWDQRVDVCVEZAGUOWOXAAWRWMGUMZWNGUMZWOGUMWTAXD
        XEXGXIXFTUABCEFGJKQPLRVBVCAXDXGXEXJXFUATCBEFGJKQPLRVBVCEGKWMWNQRVDVCVEX
        HVGVFAWGVSWHWAUCAWSVRJUMZWGVSVHSAKVIUMZXEXGXKAWSXLSKVJURZTUADJKBCLMVKVC
        VRFIJKLPOVLVMAWSVTJUMZWHWAVHSAXLXEXGXNXMTUAHJKBCLNVQVCVTFIJKLPOVLVMUKAW
        LUEWEUGUBWFAWKWEUEUGAWIWCWJWDUCAWSXEWIWCVHSTBFIJKLPOVLVMAWSXGWJWDVHSUAC
        FIJKLPOVLVMUKVNAWEXHVOVFVP $.
    $}

    $( A complex pre-Hilbert space satisfies the parallelogram law.
       (Contributed by Mario Carneiro, 7-Oct-2015.) $)
    nmpar $p |- ( ( W e. CPreHil /\ A e. V /\ B e. V ) ->
      ( ( ( N ` ( A .+ B ) ) ^ 2 ) + ( ( N ` ( A .- B ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      ( ccph wcel w3a csca cfv cip cbs eqid simp1 simp2 simp3 nmparlem ) GLMZAF
      MZBFMZNABCGOPZGQPZUGRPZDEFGHIJKUHSUGSUISUDUEUFTUDUEUFUAUDUEUFUBUC $.
  $}

  ${
    $d r A $.  $d r B $.  $d r D $.  $d x y ph $.  $d r x y T $.  $d r x y U $.
    $d r ., $.  $d r R $.  $d r y V $.
    ipcn.v $e |- V = ( Base ` W ) $.
    ipcn.h $e |- ., = ( .i ` W ) $.
    ipcn.d $e |- D = ( dist ` W ) $.
    ipcn.n $e |- N = ( norm ` W ) $.
    ipcn.t $e |- T = ( ( R / 2 ) / ( ( N ` A ) + 1 ) ) $.
    ipcn.u $e |- U = ( ( R / 2 ) / ( ( N ` B ) + T ) ) $.
    ipcn.w $e |- ( ph -> W e. CPreHil ) $.
    ipcn.a $e |- ( ph -> A e. V ) $.
    ipcn.b $e |- ( ph -> B e. V ) $.
    ipcn.r $e |- ( ph -> R e. RR+ ) $.
    ${
      ipcn.x $e |- ( ph -> X e. V ) $.
      ipcn.y $e |- ( ph -> Y e. V ) $.
      ipcn.1 $e |- ( ph -> ( A D X ) < U ) $.
      ipcn.2 $e |- ( ph -> ( B D Y ) < T ) $.
      $( The inner product operation of a complex pre-Hilbert space is
         continuous.  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
      ipcnlem2 $p |- ( ph -> ( abs ` ( ( A ., B ) - ( X ., Y ) ) ) < R ) $=
        ( co ccph wcel cc cphipcl syl3anc rpred cmin cabs c1 caddc cmul c2 cdiv
        cfv subcld abscld cngp cr cnlm cphnlm syl nlmngp nmcl syl2anc cc0 nmge0
        cle wbr ge0p1rpd cmt mscl remulcld rehalfcld csg wceq cphsubdi syl13anc
        ngpms eqid fveq2d cgrp ngpgrp grpsubcl ipcau ngpds oveq2d breqtrrd cxme
        eqbrtrrd msxms xmsge0 lep1d lemul1ad syl6breq ltmuldiv2d mpbird lelttrd
        letrd clt crp rphalfcld rpdivcld syl5eqel readdcld oveq1d nm2dif ngpdsr
        cphsubdir resubcld ltled lesubadd2d mpbid lemul2ad wb ltaddrpd ltmuldiv
        0re a1i syl112anc abs3lemd ) ABCHUHZLMHUHZBMHUHZEAKUIUJZBJUJZCJUJZYIUKU
        JTUAUBBCHJKNOULUMZAYLLJUJZMJUJZYJUKUJTUDUELMHJKNOULUMZAYLYMYQYKUKUJTUAU
        EBMHJKNOULUMZAEUCUNZAYIYKUOUHZUPVBZBIVBZUQURUHZCMDUHZUSUHZEUTVAUHZAUUAA
        YIYKYOYSVCVDZAUUDUUEAUUDAUUCAKVEUJZYMUUCVFUJAKVGUJZUUIAYLUUJTKVHVIKVJVI
        ZUABKIJNQVKVLZAUUIYMVMUUCVOVPUUKUABKIJNQVNVLVQZUNZAKVRUJZYNYQUUEVFUJAUU
        IUUOUUKKWFVIZUBUECMDKJNPVSUMZVTZAEYTWAZAUUBUUCUUEUSUHZUUFUUHAUUCUUEUULU
        UQVTUURABCMKWBVBZUHZHUHZUPVBZUUBUUTVOAUVCUUAUPAYLYMYNYQUVCUUAWCTUAUBUEB
        CMHUVAJKONUVAWGZWDWEWHAUVDUUCUVBIVBZUSUHZUUTVOAYLYMUVBJUJZUVDUVGVOVPTUA
        AKWIUJZYNYQUVHAUUIUVIUUKKWJVIZUBUEJKUVACMNUVEWKUMHIJKBUVBNOQWLUMAUUEUVF
        UUCUSAUUIYNYQUUEUVFWCUUKUBUECMDKUVAIJQNUVEPWMUMWNWOWQAUUCUUDUUEUULUUNUU
        QAKWPUJZYNYQVMUUEVOVPAUUOUVKUUPKWRVIZUBUECMDKJNPWSUMAUUCUULWTXAXFAUUFUU
        GXGVPUUEUUGUUDVAUHZXGVPAUUEFUVMXGUGRXBAUUEUUGUUDUUQUUSUUMXCXDXEAYKYJUOU
        HZUPVBZBLDUHZCIVBZFURUHZUSUHZUUGAUVNAYKYJYSYRVCVDZAUVPUVRAUUOYMYPUVPVFU
        JZUUPUAUDBLDKJNPVSUMZAUVQFAUUIYNUVQVFUJUUKUBCKIJNQVKVLZAFAFUVMXHRAUUGUU
        DAEUCXIUUMXJXKZUNZXLZVTZUUSAUVOUVPMIVBZUSUHZUVSUVTAUVPUWHUWBAUUIYQUWHVF
        UJUUKUEMKIJNQVKVLZVTUWGABLUVAUHZMHUHZUPVBZUVOUWIVOAUWLUVNUPAYLYMYPYQUWL
        UVNWCTUAUDUEBLMHUVAJKONUVEXPWEWHAUWMUWKIVBZUWHUSUHZUWIVOAYLUWKJUJZYQUWM
        UWOVOVPTAUVIYMYPUWPUVJUAUDJKUVABLNUVEWKUMUEHIJKUWKMNOQWLUMAUVPUWNUWHUSA
        UUIYMYPUVPUWNWCUUKUAUDBLDKUVAIJQNUVEPWMUMXMWOWQAUWHUVRUVPUWJUWFUWBAUVKY
        MYPVMUVPVOVPUVLUAUDBLDKJNPWSUMAUWHUVQUOUHZFVOVPUWHUVRVOVPAUWQUUEFAUWHUV
        QUWJUWCXQUUQUWEAUWQMCUVAUHIVBZUUEVOAUUIYQYNUWQUWRVOVPUUKUEUBMCKUVAIJNQU
        VEXNUMAUUIYNYQUUEUWRWCUUKUBUECMDKUVAIJQNUVEPXOUMWOAUUEFUUQUWEUGXRXFAUWH
        UVQFUWJUWCUWEXSXTYAXFAUVSUUGXGVPZUVPUUGUVRVAUHZXGVPZAUVPGUWTXGUFSXBAUWA
        UUGVFUJUVRVFUJVMUVRXGVPUWSUXAYBUWBUUSUWFAVMUVQUVRVMVFUJAYEYFUWCUWFAUUIY
        NVMUVQVOVPUUKUBCKIJNQVNVLAUVQFUWCUWDYCXEUVPUUGUVRYDYGXDXEYH $.
    $}

    $( The inner product operation of a complex pre-Hilbert space is
       continuous.  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    ipcnlem1 $p |- ( ph -> E. r e. RR+ A. x e. V A. y e. V
      ( ( ( A D x ) < r /\ ( B D y ) < r ) ->
        ( abs ` ( ( A ., B ) - ( x ., y ) ) ) < R ) ) $=
      ( cle wbr cif crp wcel cv co clt wa cmin cabs cfv wi wral wrex c2 cdiv c1
      caddc rphalfcld cngp cr cnlm ccph cphnlm syl nlmngp nmcl syl2anc ge0p1rpd
      cc0 nmge0 rpdivcld syl5eqel rpred readdcld 0re a1i ltaddrpd lelttrd elrpd
      ifcl adantr simprll simprlr cmt mscl syl3anc simprrl min2 ltletrd simprrr
      ngpms min1 ipcnlem2 expr ralrimivva breq2 anbi12d imbi1d 2ralbidv rspcev
      wceq ) AHIUEUFZHIUGZUHUIZDBUJZFUKZXIULUFZECUJZFUKZXIULUFZUMZDEJUKXKXNJUKU
      NUKUOUPGULUFZUQZCLURBLURZXLNUJZULUFZXOYAULUFZUMZXRUQZCLURBLURZNUHUSAHUHUI
      IUHUIXJAHGUTVAUKZDKUPZVBVCUKZVAUKUHSAYGYIAGUDVDZAYHAMVEUIZDLUIZYHVFUIAMVG
      UIZYKAMVHUIZYMUAMVIVJMVKVJZUBDMKLORVLVMAYKYLVOYHUEUFYOUBDMKLORVPVMVNVQVRZ
      AIYGEKUPZHVCUKZVAUKUHTAYGYRYJAYRAYQHAYKELUIZYQVFUIYOUCEMKLORVLVMZAHYPVSZV
      TZAVOYQYRVOVFUIAWAWBYTUUBAYKYSVOYQUEUFYOUCEMKLORVPVMAYQHYTYPWCWDWEVQVRZXH
      HIUHWFVMZAXSBCLLAXKLUIZXNLUIZUMZXQXRAUUGXQUMZUMZDEFGHIJKLMXKXNOPQRSTAYNUU
      HUAWGAYLUUHUBWGZAYSUUHUCWGZAGUHUIUUHUDWGAUUEUUFXQWHZAUUEUUFXQWIZUUIXLXIIU
      UIMWJUIZYLUUEXLVFUIUUIYKUUNAYKUUHYOWGMWQZVJUUJUULDXKFMLOQWKWLUUIXIAXJUUHU
      UDWGVSZAIVFUIZUUHAIUUCVSWGZAUUGXMXPWMUUIHVFUIZUUQXIIUEUFAUUSUUHUUAWGZUURH
      IWNVMWOUUIXOXIHUUIUUNYSUUFXOVFUIAUUNUUHAYKUUNYOUUOVJWGUUKUUMEXNFMLOQWKWLU
      UPUUTAUUGXMXPWPUUIUUSUUQXIHUEUFUUTUURHIWRVMWOWSWTXAYFXTNXIUHYAXIXGZYEXSBC
      LLUVAYDXQXRUVAYBXMYCXPYAXIXLULXBYAXIXOULXBXCXDXEXFVM $.
  $}

  ${
    $d r s w x y z ., $.  $d r s x y K $.  $d r s w x y z W $.
    ipcn.f $e |- ., = ( .if ` W ) $.
    ipcn.j $e |- J = ( TopOpen ` W ) $.
    ipcn.k $e |- K = ( TopOpen ` CCfld ) $.
    $( The inner product operation of a complex pre-Hilbert space is
       continuous.  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    ipcn $p |- ( W e. CPreHil -> ., e. ( ( J tX J ) Cn K ) ) $=
      ( vz vs vw vr wcel cfv co cc clt wa wral crp eqid vx vy ccph cds cbs cres
      cxp cmopn ctx ccn wf cv wbr cabs cmin ccom wi wrex csca wss cphphl phlipf
      cphl syl cclm cphclm clmsscn fss syl2anc cip c2 cdiv cnm c1 caddc simplrl
      simpll simplrr simpr ipcnlem1 ralrimiva simprl ovresd breq1d anbi12d wceq
      simprr ad2antrr fovrnd ipfval adantl oveq12d fveq2d eqtrd imbi12d rexbidv
      cnmetdval 2ralbidva ralbidv mpbird ralrimivva cxmt wb cxme cmt cngp ngpms
      cphngp msxms xmsxmet cnxmet a1i cnfldtopn txmetcn mpbir2and mstopn oveq1d
      syl3anc eleqtrrd ) DUCLZADUDMZDUEMZYBUGZUFZUHMZYEUINZCUJNZBBUINZCUJNXTAYG
      LZYCOAUKZUAULZHULZYDNZIULZPUMZUBULZJULZYDNZYNPUMZQZYKYPANZYLYQANZUNUOUPZN
      ZKULZPUMZUQZJYBRHYBRZISURZKSRZUBYBRUAYBRZXTYCDUSMZUEMZAUKZUUMOUTZYJXTDVCL
      UUNDVAUULAUUMYBDYBTZEUULTZUUMTZVBVDXTDVELUUODVFUULUUMDUUQUURVGVDYCUUMOAVH
      VIZXTUUJUAUBYBYBXTYKYBLZYPYBLZQZQZUUJYKYLYANZYNPUMZYPYQYANZYNPUMZQZYKYPDV
      JMZNZYLYQUVINZUONZUNMZUUEPUMZUQZJYBRHYBRZISURZKSRUVCUVQKSUVCUUESLZQHJYKYP
      YAUUEUUEVKVLNZYKDVMMZMVNVONVLNZUVSYPUVTMUWAVONVLNZUVIUVTYBDIUUPUVITZYATUV
      TTUWATUWBTXTUVBUVRVQXTUUTUVAUVRVPXTUUTUVAUVRVRUVCUVRVSVTWAUVCUUIUVQKSUVCU
      UHUVPISUVCUUGUVOHJYBYBUVCYLYBLZYQYBLZQZQZYTUVHUUFUVNUWGYOUVEYSUVGUWGYMUVD
      YNPUWGYKYLYAYBXTUUTUVAUWFVPZUVCUWDUWEWBZWCWDUWGYRUVFYNPUWGYPYQYAYBXTUUTUV
      AUWFVRZUVCUWDUWEWGZWCWDWEUWGUUDUVMUUEPUWGUUDUUAUUBUONZUNMZUVMUWGUUAOLUUBO
      LUUDUWMWFUWGYKYPOYBYBAXTYJUVBUWFUUSWHZUWHUWJWIUWGYLYQOYBYBAUWNUWIUWKWIUUA
      UUBUUCUUCTWQVIUWGUWLUVLUNUWGUUAUVJUUBUVKUOUWGUUTUVAUUAUVJWFUWHUWJAUVIYBDY
      KYPUUPUWCEWJVIUWFUUBUVKWFUVCAUVIYBDYLYQUUPUWCEWJWKWLWMWNWDWOWRWPWSWTXAXTY
      DYBXBMLZUWOUUCOXBMLZYIYJUUKQXCXTDXDLZUWOXTDXELZUWQXTDXFLUWRDXHDXGVDZDXIVD
      YDDYBUUPYDTZXJVDZUXAUWPXTXKXLUAUBKIJHYDYDUUCAYEYECYBYBOYETZUXBCGXMXNXRXOX
      TYHYFCUJXTBYEBYEUIXTUWRBYEWFUWSYDBDYBFUUPUWTXPVDZUXCWLXQXS $.
  $}

  ${
    $d x y C $.  $d x y J $.  $d x K $.  $d x y ph $.  $d x y W $.  $d x y X $.
    $d x y Y $.
    cnmpt1ip.j $e |- J = ( TopOpen ` W ) $.
    cnmpt1ip.c $e |- C = ( TopOpen ` CCfld ) $.
    cnmpt1ip.h $e |- ., = ( .i ` W ) $.
    cnmpt1ip.r $e |- ( ph -> W e. CPreHil ) $.
    cnmpt1ip.k $e |- ( ph -> K e. ( TopOn ` X ) ) $.
    ${
      cnmpt1ip.a $e |- ( ph -> ( x e. X |-> A ) e. ( K Cn J ) ) $.
      cnmpt1ip.b $e |- ( ph -> ( x e. X |-> B ) e. ( K Cn J ) ) $.
      $( Continuity of inner product; analogue of ~ cnmpt12f which cannot be
         used directly because ` .i ` is not a function.  (Contributed by Mario
         Carneiro, 13-Oct-2015.) $)
      cnmpt1ip $p |- ( ph -> ( x e. X |-> ( A ., B ) ) e. ( K Cn C ) ) $=
        ( cfv co wcel cipf cmpt ccn cv wa cbs wceq wral ctopon ctps ccph cphngp
        wf cngp ngptps 3syl eqid istps cnf2 syl3anc fmpt sylibr r19.21bi ipfval
        sylib syl2anc mpteq2dva ctx ipcn syl cnmpt12f eqeltrrd ) ABJCDIUARZSZUB
        BJCDFSZUBHEUCSABJVNVOABUDJTUECIUFRZTZDVPTZVNVOUGAVQBJAJVPBJCUBZUMZVQBJU
        HAHJUIRTZGVPUIRTZVSHGUCSZTVTOAIUJTZWBAIUKTZIUNTWDNIULIUOUPVPGIVPUQZKURV
        EZPVSHGJVPUSUTBJVPCVSVSUQVAVBVCAVRBJAJVPBJDUBZUMZVRBJUHAWAWBWHWCTWIOWGQ
        WHHGJVPUSUTBJVPDWHWHUQVAVBVCVMFVPICDWFMVMUQZVDVFVGABCDVMHGGEJOPQAWEVMGG
        VHSEUCSTNVMGEIWJKLVIVJVKVL $.
    $}

    cnmpt2ip.l $e |- ( ph -> L e. ( TopOn ` Y ) ) $.
    cnmpt2ip.a $e |- ( ph -> ( x e. X , y e. Y |-> A ) e.
                                ( ( K tX L ) Cn J ) ) $.
    cnmpt2ip.b $e |- ( ph -> ( x e. X , y e. Y |-> B ) e.
                                ( ( K tX L ) Cn J ) ) $.
    $( Continuity of inner product; analogue of ~ cnmpt22f which cannot be used
       directly because ` .i ` is not a function.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    cnmpt2ip $p |- ( ph ->
        ( x e. X , y e. Y |-> ( A ., B ) ) e. ( ( K tX L ) Cn C ) ) $=
      ( cipf cfv co cmpt2 ctx ccn wcel wceq cbs wral cxp ctopon txtopon syl2anc
      cv wa wf ctps ccph cngp cphngp ngptps 3syl eqid istps sylib syl3anc fmpt2
      cnf2 sylibr r19.21bi ipfval 3impa mpt2eq3dva ipcn syl cnmpt22f eqeltrrd )
      ABCLMDEKUBUCZUDZUEBCLMDEGUDZUEIJUFUDZFUGUDABCLMWAWBABUPLUHZCUPMUHZWAWBUIZ
      AWDUQZWEUQDKUJUCZUHZEWHUHZWFWGWICMAWICMUKZBLALMULZWHBCLMDUEZURZWKBLUKAWCW
      LUMUCUHZHWHUMUCUHZWMWCHUGUDZUHWNAILUMUCUHJMUMUCUHWORSIJLMUNUOZAKUSUHZWPAK
      UTUHZKVAUHWSQKVBKVCVDWHHKWHVEZNVFVGZTWMWCHWLWHVJVHBCLMDWHWMWMVEVIVKVLVLWG
      WJCMAWJCMUKZBLAWLWHBCLMEUEZURZXCBLUKAWOWPXDWQUHXEWRXBUAXDWCHWLWHVJVHBCLME
      WHXDXDVEVIVKVLVLVTGWHKDEXAPVTVEZVMUOVNVOABCDEVTIJHHFLMRSTUAAWTVTHHUFUDFUG
      UDUHQVTHFKXFNOVPVQVRVS $.
  $}

  ${
    $d x y C $.  $d x y J $.  $d x y S $.  $d x y W $.
    csscld.c $e |- C = ( CSubSp ` W ) $.
    csscld.j $e |- J = ( TopOpen ` W ) $.
    $( A "closed subspace" in a complex pre-Hilbert space is actually closed in
       the topology induced by the norm, thus justifying the terminology
       "closed subspace".  (Contributed by Mario Carneiro, 13-Oct-2015.) $)
    csscld $p |- ( ( W e. CPreHil /\ S e. C ) -> S e. ( Clsd ` J ) ) $=
      ( vy vx wcel wa cfv cv co c0g wceq crab cin eqid syl cc ccph cuni cip cbs
      cocv csca ciin ccld cssi adantl wral wss ocvss ocvval mp1i riinrab ctopon
      syl6eqr ctps cnlm cphnlm adantr nlmngp ngptps istps sylib toponuni ineq1d
      cngp 3syl ctop topontop sseli cmpt ccnv csn cima cvv fvex mptiniseg ax-mp
      3eqtrd ccnfld ctopn ccn simpll cnmptid cnmptc cnmpt1ip cha cnfldhaus cclm
      simpr cc0 cphclm clm0 ad2antrr 0cn syl6eqelr cnfldtopon toponunii sylancr
      sncld cnclima syl2anc syl5eqelr sylan2 ralrimiva riincld eqeltrd ) DUAIZB
      AIZJZBCUBZGBDUEKZKZHLZGLZDUCKZMZDUFKZNKZOZHDUDKZPZUGZQZCUHKZXMBXPXOKZYDYF
      QZYGXLBYIOXKABXODXORZEUIUJXMYIYCGXPUKHYDPZYJXPYDULYIYLOXMBXOYDDYDRZYKUMZH
      GXPYAXSXOYDDYBYMXSRZYARZYBRYKUNUOYCGHYDXPUPURXMYDXNYFXMCYDUQKIZYDXNOXMDUS
      IZYQXMDUTIZDVIIYRXKYSXLDVAVBDVCDVDVJYDCDYMFVEVFZYDCVGSVHWBXMCVKIZYEYHIZGX
      PUKYGYHIXMYQUUAYTYDCVLSXMUUBGXPXRXPIXMXRYDIZUUBXPYDXRYNVMXMUUCJZYEHYDXTVN
      ZVOYBVPZVQZYHYBVRIUUGYEOYANVSHYDXTYBUUEVRUUERVTWAUUDUUECWCWDKZWEMIUUFUUHU
      HKIZUUGYHIUUDHXQXRUUHXSCCDYDFUUHRZYOXKXLUUCWFXMYQUUCYTVBZUUDHCYDUUKWGUUDH
      XRCCYDYDUUKUUKXMUUCWMWHWIUUDUUHWJIYBTIUUIUUHUUJWKUUDYBWNTXKWNYBOZXLUUCXKD
      WLIUULDWOYADYPWPSWQWRWSYBUUHTTUUHUUHUUJWTXAXCXBUUFUUECUUHXDXEXFXGXHGXPYEC
      XNXNRXIXEXJ $.
  $}

  ${
    $d x y J $.  $d x y O $.  $d x y S $.  $d x y V $.  $d x y W $.
    clsocv.v $e |- V = ( Base ` W ) $.
    clsocv.o $e |- O = ( ocv ` W ) $.
    clsocv.j $e |- J = ( TopOpen ` W ) $.
    $( The orthogonal complement of the closure of a subset is the same as the
       orthogonal complement of the subset itself.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    clsocv $p |- ( ( W e. CPreHil /\ S C_ V ) ->
      ( O ` ( ( cls ` J ) ` S ) ) = ( O ` S ) ) $=
      ( vy wcel wss cfv syl adantr sylib wceq eqid syl2anc cin cc ccph ccl ctop
      vx wa cuni ctopon ctps cngp cphngp ngptps istps topontop toponuni sseqtrd
      simpr sscls ocv2ss cv cip co csca c0g wral clsss3 sseqtr4d ocvss a1i crab
      sselda ccld cab df-ss ineq1d dfrab3 ineq2i inass eqtr4i 3eqtr4g cmpt ccnv
      clscld csn cima cvv fvex mptiniseg ax-mp ccnfld ccn simpll cnmptc cnmptid
      ctopn cnmpt1ip cha cnfldhaus cc0 cclm cphclm clm0 ad2antrr 0cn cnfldtopon
      syl6eqelr toponunii sncld sylancr syl5eqelr incld eqeltrrd ocvi ralrimiva
      adantl ssrab sylanbrc clsss2 ssrab2 eqssd rabid2 elocv syl3anbrc ex ssrdv
      cnclima ) EUAJZADKZUEZABUBLLZCLZACLZYHAYIKZYJYKKYHBUCJZABUFZKZYLYHBDUGLJZ
      YMYHEUHJZYPYFYQYGYFEUIJYQEUJEUKMNDBEFHULOZDBUMMZYHADYNYFYGUPYHYPDYNPYRDBU
      NMZUOZABYNYNQZUQRZYIACEGURMYHUDYKYJYHUDUSZYKJZUUDYJJZYHUUEUEZYIDKZUUDDJUU
      DIUSZEUTLZVAZEVBLZVCLZPZIYIVDZUUFYHUUHUUEYHYIYNDYHYMYOYIYNKYSUUAABYNUUBVE
      RYTVFNZYHYKDUUDYKDKYHACDEFGVGVHVJZUUGYIUUNIYIVIZPUUOUUGYIUURUUGUURBVKLZJA
      UURKZYIUURKUUGYIUUNIDVIZSZUURUUSUUGYIDSZUUNIVLZSZYIUVDSUVBUURUUGUVCYIUVDU
      UGUUHUVCYIPUUPYIDVMOVNUVBYIDUVDSZSUVEUVAUVFYIUUNIDVOVPYIDUVDVQVRUUNIYIVOV
      SUUGYIUUSJZUVAUUSJUVBUUSJYHUVGUUEYHYMYOUVGYSUUAABYNUUBWBRNUUGUVAIDUUKVTZW
      AUUMWCZWDZUUSUUMWEJUVJUVAPUULVCWFIDUUKUUMUVHWEUVHQWGWHUUGUVHBWIWNLZWJVAJU
      VIUVKVKLJZUVJUUSJUUGIUUDUUIUVKUUJBBEDHUVKQZUUJQZYFYGUUEWKYHYPUUEYRNZUUGIU
      UDBBDDUVOUVOUUQWLUUGIBDUVOWMWOUUGUVKWPJUUMTJUVLUVKUVMWQUUGUUMWRTYFWRUUMPZ
      YGUUEYFEWSJUVPEWTUULEUULQZXAMXBXCXEUUMUVKTTUVKUVKUVMXDXFXGXHUVIUVHBUVKYER
      XIYIUVABXJRXKUUGYLUUNIAVDZUUTYHYLUUEUUCNUUEUVRYHUUEUUNIAUUDUUIAUULUUJCDEU
      UMFUVNUVQUUMQZGXLXMXNUUNIYIAXOXPUURABYNUUBXQRUURYIKUUGUUNIYIXRVHXSUUNIYIX
      TOIUUDYIUULUUJCDEUUMFUVNUVQUVSGYAYBYCYDXS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Neighborhoods and closure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
  @c neiOLD @.
  @c accOLD @.
  @c acc @.
  @c cls @.
  @c int @.

  @( Extend class notation with neighborhood of a metric space point. @)
  cne @a class neiOLD @.

  @( Extend class notation with accumulation points (limit points) of
     a metric space point. @)
  cacOLD @a class accOLD @.

  @( Extend class notation with accumulation points (limit points) of
     a metric space point. @)
  cac @a class acc @.

  @( Extend class notation with closure of a metric space subset. @)
  ccl @a class cls @.

  @( Extend class notation with interior of a metric space subset. @)
  cnt @a class int @.

  @{
    @d u v w x y z @.
    @( Define a function on metric spaces whose value is the relation "subset
       ` x ` is a neighborhood of point ` y ` ." @)
    df-neiOLD @a |- neiOLD =
             { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x C_ ( 1st ` z ) /\ y e. ( 1st ` z ) /\ E. v e. RR
      ( 0 < v /\ ( y ( ball ` z ) v ) C_ x ) ) } ) } @.

    @( Define a function on metric spaces whose value is the relation " ` x `
       is an accumulation point (limit point) of subset ` y ` ." @)
    df-accOLD @a |- accOLD =
                   { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x e. ( 1st ` z ) /\ y C_ ( 1st ` z ) /\ A. v ( ( v C_ ( 1st ` z ) /\
       v ( neiOLD ` z ) x ) -> E. u e. v ( u e. y /\ -. u = x ) ) ) } ) } @.

    @( Define a function on metric spaces whose value is the relation " ` x `
       is an accumulation point (limit point) of subset ` y ` ." @)
    df-acc @a |- acc = { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x e. ( 1st ` z ) /\ y C_ ( 1st ` z ) /\ A. v e. RR ( 0 < v -> E. u e.
      ( x ( ball ` z ) v ) ( u e. y /\ -. u = x ) ) ) } ) } @.

    @( Define a function on metric spaces whose value is the closure function
       on the subsets of the metric space. @)
    df-clsOLD @a |- cls = { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x C_ ( 1st ` z ) /\
      y = ( x u. { v e. ( 1st ` z ) | v ( acc ` z ) x } ) ) } ) } @.

    @( Define a function on metric spaces whose value is the interior function
       on the subsets of the metric space. @)
    df-ntr @a |- int = { <. z , w >. | ( z e. MetSp /\ w = { <. x , y >. |
      ( x C_ ( 1st ` z ) /\ y = U. { v e. ran ( ball ` z ) | v C_ x } ) } @.
  @}

  @{
    @d u v w x y z M @.  @d v w x y z X @.  @d u v w x y z @.
    accfval.1 @e |- X = ( 1st ` M ) @.
    @( The relation "subset ` x ` is a neighborhood of point ` y ` ." @)
    neifvalOLD @p |- ( M e. MetSp ->
                ( neiOLD ` M ) = { <. x , y >. | ( x C_ X /\
           y e. X /\ E. v e. RR ( 0 < v /\ ( y ( ball ` M ) v ) C_ x ) ) } ) @=
      ( vz vw cv c1st cfv wss wcel cc0 clt wbr cblOLD co wa cr wrex w3a
      copab cmt
      cne wceq fveq2 syl6eqr sseq2d eleq2d oveqd sseq1d anbi2d rexbidv
      3anbi123d opabbidv df-neiOLD cpw cxp cvv fvex eqeltri pwex xpex df-3an
      vex elpw 3anbi1i bitr3i opabbii opabssxp eqsstr3i ssexi
      fvopab4 ) GHDAIZ
      GIZJKZLZBIZVQMZNCIZOPZVSWAVPQKZRZVOLZSZCTUAZUBZABUCVOELZVSEMZWBVSWADQKZRZ
      VOLZSZCTUAZUBZABUCZUDUEVPDUFZWHWPABWRVRWIVTWJWGWOWRVQEVOWRVQDJKZEVPDJUGFU
      HZUIWRVQEVSWTUJWRWFWNCTWRWEWMWBWRWDWLVOWRWCWKVSWAVPDQUGUKULUMUNUOUPABGHCU
      QWQEURZEUSZXAEEEWSUTFDJVAVBZVCXCVDWQVOXAMZWJSWOSZABUCXBXEWPABXEXDWJWOUBWP
      XDWJWOVEXDWIWJWOVOEAVFVGVHVIVJWOABXAEVKVLVMVN @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The relation " ` x ` is an accumulation point (limit point) of subset
       ` y ` ." @)
    accfvalOLD @p |- ( M e. MetSp -> ( accOLD ` M ) = { <. x , y >. |
      ( x e. X /\ y C_ X /\ A. v ( ( v C_ X /\
       v ( neiOLD ` M ) x ) -> E. u e. v ( u e. y /\ -. u = x ) ) ) } ) @=
      ( vz vw cv c1st cfv wcel wss cne wbr wa wceq wn wrex wi wal w3a copab
      cmt cacOLD fveq2 syl6eqr eleq2d sseq2d wb breq syl anbi12d imbi1d albidv
      3anbi123d opabbidv df-accOLD cpw cxp cvv fvex eqeltri pwex xpex df-3an
      vex elpw 3anbi2i bitr3i opabbii opabssxp eqsstr3i ssexi
      fvopab4 ) HIEAJZ
      HJZKLZMZBJZVSNZCJZVSNZWCVQVROLZPZQZDJZWAMWHVQRSQDWCTZUAZCUBZUCZABUDVQFMZW
      AFNZWCFNZWCVQEOLZPZQZWIUAZCUBZUCZABUDZUEUFVRERZWLXAABXCVTWMWBWNWKWTXCVSFV
      QXCVSEKLZFVREKUGGUHZUIXCVSFWAXEUJXCWJWSCXCWGWRWIXCWDWOWFWQXCVSFWCXEUJXCWE
      WPRWFWQUKVREOUGWCVQWEWPULUMUNUOUPUQURABHICDUSXBFFUTZVAZFXFFXDVBGEKVCVDZFX
      HVEVFXBWMWAXFMZQWTQZABUDXGXJXAABXJWMXIWTUCXAWMXIWTVGXIWNWMWTWAFBVHVIVJVKV
      LWTABFXFVMVNVOVP @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The relation " ` x ` is an accumulation point (limit point) of subset
       ` y ` ." @)
    accfval @p |- ( M e. MetSp -> ( acc ` M ) = { <. x , y >. |
      ( x e. X /\ y C_ X /\ A. v e. RR ( 0 < v -> E. u e.
      ( x ( ball ` M ) v ) ( u e. y /\ -. u = x ) ) ) } ) @=
      ( vz vw cv c1st cfv wcel wss cc0 clt wbr wceq wn wa cblOLD co wrex wi cr
      wral w3a copab cmt cac fveq2 syl6eqr eleq2d sseq2d wb oveqd rexeq syl
      imbi2d ralbidv 3anbi123d opabbidv df-acc cpw cxp cvv fvex eqeltri pwex
      xpex df-3an vex elpw 3anbi2i bitr3i opabbii opabssxp eqsstr3i ssexi
      fvopab4 ) HIEAJZHJZKLZMZBJZWCNZOCJZPQZDJZWEMWIWARSTZDWAWGWBUALZUBZUCZUDZC
      UEUFZUGZABUHWAFMZWEFNZWHWJDWAWGEUALZUBZUCZUDZCUEUFZUGZABUHZUIUJWBERZWPXDA
      BXFWDWQWFWRWOXCXFWCFWAXFWCEKLZFWBEKUKGULZUMXFWCFWEXHUNXFWNXBCUEXFWMXAWHXF
      WLWTRWMXAUOXFWKWSWAWGWBEUAUKUPWJDWLWTUQURUSUTVAVBABHICDVCXEFFVDZVEZFXIFXG
      VFGEKVGVHZFXKVIVJXEWQWEXIMZTXCTZABUHXJXMXDABXMWQXLXCUGXDWQXLXCVKXLWRWQXCW
      EFBVLVMVNVOVPXCABFXIVQVRVSVT @.
      @( [ ?] @) @( [9-Sep-2006] @)

    @( The closure function on the subsets of the metric space. @)
    clsfvalOLD @p |- ( M e. MetSp -> ( cls ` M ) =  { <. x , y >. | ( x C_ X /\
                     y = ( x u. { v e. X | v ( acc ` M ) x } ) ) } ) @=
      ( vz vw cv c1st cfv wss cac wbr crab cun wceq wa copab cmt ccl fveq2
      syl6eqr sseq2d rabeq syl wb breq rabbidv eqtrd uneq2d eqeq2d anbi12d
      opabbidv df-clsOLD cpw wcel cvv vex elpw anbi1i opabbii fvex eqeltri
      pwex
      opabex2 eqeltrri fvopab4 ) GHDAIZGIZJKZLZBIZVICIZVIVJMKZNZCVKOZPZQZRZAB
      SVIELZVMVIVNVIDMKZNZCEOZPZQZRZABSZTUAVJDQZVTWGABWIVLWAVSWFWIVKEVIWIVKDJKZ
      EVJDJUBFUCZUDWIVRWEVMWIVQWDVIWIVQVPCEOZWDWIVKEQVQWLQWKVPCVKEUEUFWIVPWCCEW
      IVOWBQVPWCUGVJDMUBVNVIVOWBUHUFUIUJUKULUMUNABGHCUOVIEUPZUQZWFRZABSWHURWOWG
      ABWNWAWFVIEAUSUTVAVBABWMWEEEWJURFDJVCVDVEVFVGVH @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The interior function on the subsets of the metric space. @)
    ntrfval @p |- ( M e. MetSp -> ( int ` M ) =  { <. x , y >. | ( x C_ X /\
                     y = U. { v e. ran ( ball ` M ) | v C_ x } ) } ) @=
?@.
  @}

  @{
    @d w x y z M @.  @d w x y z P @.  @d w x y z S @.  @d w x y z X @.
    accbr.1 @e |- X = ( 1st ` M ) @.
    @( A neighborhood of a point ` P ` is any subset ` S ` that contains a ball
       around ` P ` .  Definition of neighborhood in [Kreyszig] p. 19. @)
    neibrOLD @p |- ( ( M e. MetSp /\ S C_ X /\ P e. X ) ->
                    ( S ( neiOLD ` M ) P <->
                E. x e. RR ( 0 < x /\ ( P ( ball ` M ) x ) C_ S ) ) ) @=
     ( vy vz cmt wcel wss w3a cne cfv wbr cv cc0 clt cblOLD co wa cr wrex copab
      wb wceq neifvalOLD breq syl 3ad2ant1 cpw sseq1 sseq2 anbi2d rexbidv
      3anbi13d eleq1 oveq1 sseq1d 3anbi23d eqid brabg cvv c1st fvex eqeltri
   elpw2g ax-mp sylanbrOLD df-3an baibr bitr4d 3adant1 bitrd ) DIJZCEKZBEJZLCBD
      MNZOZCBGPZEKZHPZEJZQAPZROZWBWDDSNZTZVTKZUAZAUBUCZLZGHUDZOZWEBWDWFTZCKZUAZ
      AUBUCZVOVPVSWMUEZVQVOVRWLUFWRGHADEFUGCBVRWLUHUIUJVPVQWMWQUEVOVPVQUAZWMVPV
      QWQLZWQCEUKZJZVQWMWTUEVPWKVPWCWEWGCKZUAZAUBUCZLWTGHCBXAEWLVTCUFZWAVPWJXEW
      CVTCEULXFWIXDAUBXFWHXCWEVTCWGUMUNUOUPWBBUFZWCVQXEWQVPWBBEUQXGXDWPAUBXGXCW
      OWEXGWGWNCWBBWDWFURUSUNUOUTWLVAVBEVCJXBVPUEEDVDNVCFDVDVEVFCEVCVGVHVIWTWSW
      QVPVQWQVJVKVLVMVN @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( ` P ` is an accumulation point (also called limit point) of a subset
       ` S ` iff every ball around ` P ` contains a point in ` S ` distinct
       from ` P ` .  Definition 2.20(b) [Rudin] p. 28. @)
    accbr @p |- ( ( M e. MetSp /\ P e. X /\ S C_ X ) -> ( P ( acc ` M ) S <->
            A. x e. RR ( 0 < x -> E. y e. ( P ( ball ` M ) x )
                ( y e. S /\ -. y = P ) ) ) ) @=
      ( vz vw cmt wcel wss w3a cac cfv wbr cv cc0 clt wceq wn wa cblOLD co wrex
      wi cr wral copab wb accfval breq syl 3ad2ant1 cpw eleq1 oveq1 rexeq
      eqeq2 notbid anbi2d rexbidv bitrd imbi2d ralbidv 3anbi13d sseq1 eleq2
      anbi1d 3anbi23d eqid brabg cvv c1st fvex eqeltri elpw2g ax-mp sylan2brOLD
      df-3an baibr bitr4d 3adant1 ) EJKZCFKZDFLZMCDENOZPZCDHQZFKZIQZFLZRAQZSPZB
      QZWKKZWOWITZUAZUBZBWIWMEUCOZUDZUEZUFZAUGUHZMZHIUIZPZWNWODKZWOCTZUAZUBZBCW
      MWTUDZUEZUFZAUGUHZWDWEWHXGUJZWFWDWGXFTXPHIABEFGUKCDWGXFULUMUNWEWFXGXOUJWD
      WEWFUBZXGWEWFXOMZXOWEDFUOZKZXGXRUJWFXEWEWLWNWPXJUBZBXLUEZUFZAUGUHZMXRHICD
      FXSXFWICTZWJWEXDYDWLWICFUPYEXCYCAUGYEXBYBWNYEXBWSBXLUEZYBYEXAXLTXBYFUJWIC
      WMWTUQWSBXAXLURUMYEWSYABXLYEWRXJWPYEWQXIWICWOUSUTVAVBVCVDVEVFWKDTZWLWFYDX
      OWEWKDFVGYGYCXNAUGYGYBXMWNYGYAXKBXLYGWPXHXJWKDWOVHVIVBVDVEVJXFVKVLFVMKXTW
      FUJFEVNOVMGEVNVOVPDFVMVQVRVSXRXQXOWEWFXOVTWAWBWCVC @.
      @( [ ?] @) @( [9-Sep-2006] @)

    @( ` P ` is an accumulation point (also called limit point) of a subset
       ` S ` iff every neighborhood of ` P ` contains a point in ` S ` distinct
       from ` P ` .  Definition of accumulation point in [Kreyszig] p. 21. @)
    accbrOLD @p |- ( ( M e. MetSp /\ P e. X /\ S C_ X ) -> ( P ( accOLD ` M ) S
                   <-> A. x ( ( x C_ X /\ x ( neiOLD ` M ) P ) -> E. y e. x
                   ( y e. S /\ -. y = P ) ) ) ) @=
      ( vz vw cmt wcel wss w3a cacOLD cfv wbr cv cne wa wceq wn wrex wi wal
      copab wb accfvalOLD
      breq syl 3ad2ant1 cpw eleq1 breq2 anbi2d eqeq2 notbid rexbidv
      imbi12d albidv 3anbi13d sseq1 eleq2 anbi1d imbi2d 3anbi23d eqid brabg
      cvv c1st fvex eqeltri elpw2g ax-mp sylan2brOLD
      df-3an baibr bitr4d 3adant1
      bitrd ) EJKZCFKZDFLZMCDENOZPZCDHQZFKZIQZFLZAQZFLZWIWEEROZPZSZBQZWGKZWNWET
      ZUAZSZBWIUBZUCZAUDZMZHIUEZPZWJWICWKPZSZWNDKZWNCTZUAZSZBWIUBZUCZAUDZVTWAWD
      XDUFZWBVTWCXCTXNHIABEFGUGCDWCXCUHUIUJWAWBXDXMUFVTWAWBSZXDWAWBXMMZXMWADFUK
      ZKZXDXPUFWBXBWAWHXFWOXISZBWIUBZUCZAUDZMXPHICDFXQXCWECTZWFWAXAYBWHWECFULYC
      WTYAAYCWMXFWSXTYCWLXEWJWECWIWKUMUNYCWRXSBWIYCWQXIWOYCWPXHWECWNUOUPUNUQURU
      SUTWGDTZWHWBYBXMWAWGDFVAYDYAXLAYDXTXKXFYDXSXJBWIYDWOXGXIWGDWNVBVCUQVDUSVE
      XCVFVGFVHKXRWBUFFEVIOVHGEVIVJVKDFVHVLVMVNXPXOXMWAWBXMVOVPVQVRVS @.
      @( [ ?] @) @( [8-Sep-2006] @)

    @( The closure of a subset of a metric space consists of the subset and
       the accumulation points of the subset.  Definition of closure of
       [Kreyszig] p. 21. @)
    clsval2 @p |- ( ( M e. MetSp /\ S C_ X ) -> ( ( cls ` M ) ` S ) =
                 ( S u. { x e. X | x ( acc ` M ) S } ) ) @=
      ? @.

    @( The interior of a subset of a metric space is the union of all the balls
       it includes.  From Definition 2.20(e) of [Rudin] p. 28.  Rudin uses
       "neighborhood" for what we call "ball." @)
    ntrval @p |- ( ( M e. MetSp /\ S C_ X ) -> ( ( int ` M ) ` S ) =
                 U. { x e. ran ( ball ` M ) | x C_ S } ) @=
?@.
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Convergence and completeness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CauFil $.
  $c Cau $.
  $c CMet $.

  $( Extend class notation with the set of Cauchy filters. $)
  ccfil $a class CauFil $.

  $( Extend class notation with a function on metric spaces whose value is the
     set of all Cauchy sequences of the space. $)
  cca $a class Cau $.

  $( Extend class notation with class of complete metric spaces. $)
  cms $a class CMet $.

  ${
    $d d f j x y $.
    $( Define the set of Cauchy filters on a metric space.  A Cauchy filter is
       a filter on the set such that for every ` 0 < x ` there is an element of
       the filter whose metric diameter is less than ` x ` .  (Contributed by
       Mario Carneiro, 13-Oct-2015.) $)
    df-cfil $a |- CauFil = ( d e. U. ran *Met |-> { f e. ( Fil ` dom dom d ) |
            A. x e. RR+ E. y e. f ( d " ( y X. y ) ) C_ ( 0 [,) x ) } ) $.

    $( Define a function on metric spaces whose value is the set of Cauchy
       sequences of the space.  (Contributed by NM, 8-Sep-2006.) $)
    df-cau $a |- Cau = ( d e. U. ran *Met |-> { f e. ( dom dom d ^pm CC ) |
       A. x e. RR+ E. j e. ZZ ( f |` ( ZZ>= ` j ) ) :
          ( ZZ>= ` j ) --> ( ( f ` j ) ( ball ` d ) x ) } ) $.

    $( Define the class of complete metrics.  (Contributed by Mario Carneiro,
       1-May-2014.) $)
    df-cmet $a |- CMet = ( x e. _V |-> { d e. ( Met ` x ) |
      A. f e. ( CauFil ` d ) ( ( MetOpen ` d ) fLim f ) =/= (/) } ) $.
  $}

  ${
    $d j k u x y D $.  $d j k u x y F $.  $d j k u x y P $.  $d j k u x y X $.
    $d u x y J $.  $d j M $.  $d j k u x ph $.  $d j k x R $.  $d j k x Z $.
    lmmbr.2 $e |- J = ( MetOpen ` D ) $.
    lmmbr.3 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a metric space.  Definition 1.4-1 of [Kreyszig] p. 25.  The
       condition ` F C_ ( CC X. X ) ` allows us to use objects more general
       than sequences when convenient; see the comment in ~ df-lm .
       (Contributed by NM, 7-Dec-2006.)  (Revised by Mario Carneiro,
       1-May-2014.) $)
    lmmbr $p |- ( ph -> ( F ( ~~>t ` J ) P <->
                  ( F e. ( X ^pm CC ) /\ P e. X /\ A. x e. RR+ E. y e. ran ZZ>=
                    ( F |` y ) : y --> ( P ( ball ` D ) x ) ) ) ) $=
      ( vu cfv wcel cv wrex wi w3a crp syl wa clm wbr cc cpm co cres wf cuz crn
      wral cbl cxmt ctopon mopntopon lmbr wb cxr rpxr blopn syl3an3 blcntr wceq
      eleq2 rexbidv imbi12d rspcva impancom syl2anc 3expa adantlrl ralrimiv wss
      feq3 mopni2 r19.29 expcom reximdv impcom rexlimivw sylan2 adantlr impbida
      fss 3exp2 pm5.32da df-3an 3bitr4g bitrd ) AFEGUALUBFHUCUDUEMZEHMZEKNZMZCN
      ZWKFWMUFZUGZCUHUIZOZPZKGUJZQZWIWJWMEBNZDUKLUEZWNUGZCWPOZBRUJZQZACKEFGHADH
      ULLMZGHUMLMJDGHIUNSUOAXGWTXFUPJXGWIWJTZWSTXHXETWTXFXGXHWSXEXGXHTZWSXEXIWS
      TXDBRXIXARMZWSXDXGWJXJWSXDPZWIXGWJXJXKXGWJXJQXBGMZEXBMZXKXJXGWJXAUQMXLXAU
      RDEXAGHIUSUTDEXAHVAXLWSXMXDWRXMXDPKXBGWKXBVBZWLXMWQXDWKXBEVCXNWOXCCWPWKXB
      WMWNVMVDVEVFVGVHVIVJVGVKXIXETWRKGXGXEWKGMZWRPZXHXEXGXPXEXGXOWLWQXGXOWLQXE
      XBWKVLZBROZWQBWKDEGHIVNXEXRTXDXQTZBROWQXDXQBRVOXSWQBRXQXDWQXQXCWOCWPXCXQW
      OWMXBWKWNWCVPVQVRVSSVTWDVRWAVKWBWEWIWJWSWFWIWJXEWFWGSWH $.

    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a metric space.  Definition 1.4-1 of [Kreyszig] p. 25.  The
       condition ` F C_ ( CC X. X ) ` allows us to use objects more general
       than sequences when convenient; see the comment in ~ df-lm .
       (Contributed by NM, 7-Dec-2006.)  (Revised by Mario Carneiro,
       1-May-2014.) $)
    lmmbr2 $p |- ( ph -> ( F ( ~~>t ` J ) P <->
   ( F e. ( X ^pm CC ) /\ P e. X /\ A. x e. RR+ E. j e. ZZ A. k e. ( ZZ>= ` j )
      ( k e. dom F /\ ( F ` k ) e. X /\ ( ( F ` k ) D P ) < x ) ) ) ) $=
      ( vy cfv cc wcel cuz w3a cz wa wb clm wbr cpm co cv cbl cres crn wrex crp
      wf wral cdm clt lmmbr df-3an cxmt cpw wfn uzf wceq reseq2 id feq12d rexrn
      ffn mp2b wfun cxp wss simp2l cvv elfvdm 3ad2ant1 cnex elpmg sylancl mpbid
      simpld ffvresb syl cxr rpxr syl3an3 xmetsym breq1d 3expa pm5.32da 3adant3
      elbl bitrd 3adant2l anbi2d 3anass syl6bbr ralbidv rexbidv syl5bb ralbidva
      ) AGDHUAMUBGINUCUDOZDIOZLUEZDBUEZCUFMUDZGXBUGZUKZLPUHUIZBUJULZQZWTXAFUEZG
      UMOZXJGMZIOZXLDCUDZXCUNUBZQZFEUEPMZULZERUIZBUJULZQZABLCDGHIJKUOAXIWTXASZX
      TSZYAXIYBXHSZAYCWTXAXHUPACIUQMOZYDYCTKYEYBXHXTYEYBSXGXSBUJYEYBXCUJOZXGXST
      XGXQXDGXQUGZUKZERUIZYEYBYFQZXSRRURZPUKPRUSXGYITUTRYKPVFXFYHLERPXBXQVAZXBX
      QXDXEYGXBXQGVBYLVCVDVEVGYJYHXRERYJYHXKXLXDOZSZFXQULZXRYJGVHZYHYOTYJYPGNIV
      IVJZYJWTYPYQSZYEWTXAYFVKYJIUQUMZOZNVLOWTYRTYEYBYTYFCIUQVMVNVOINGYSVLVPVQV
      RVSFXQXDGVTWAYJYNXPFXQYJYNXKXMXOSZSXPYJYMUUAXKYEXAYFYMUUATWTYEXAYFQYMXMDX
      LCUDZXCUNUBZSZUUAYFYEXAXCWBOYMUUDTXCWCXLCDXCIWJWDYEXAUUDUUATYFYEXASXMUUCX
      OYEXAXMUUCXOTYEXAXMQUUBXNXCUNDXLCIWEWFWGWHWIWKWLWMXKXMXOWNWOWPWKWQWRWGWSW
      HWAWRWTXAXTUPWOWK $.

    lmmbr3.5 $e |- Z = ( ZZ>= ` M ) $.
    lmmbr3.6 $e |- ( ph -> M e. ZZ ) $.
    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a metric space using an abitrary set of upper integers.
       (Contributed by NM, 19-Dec-2006.)  (Revised by Mario Carneiro,
       1-May-2014.) $)
    lmmbr3 $p |- ( ph -> ( F ( ~~>t ` J ) P <->
  ( F e. ( X ^pm CC ) /\ P e. X /\ A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
      ( k e. dom F /\ ( F ` k ) e. X /\ ( ( F ` k ) D P ) < x ) ) ) ) $=
      ( cfv wcel cv w3a wral clm wbr cc cpm co cdm clt cuz cz crp lmmbr2 rexuz3
      wrex wb syl ralbidv 3anbi3d bitr4d ) AGDHUAPUBGJUCUDUEQZDJQZFRZGUFQVAGPZJ
      QVBDCUEBRUGUBSZFERUHPTZEUIUMZBUJTZSUSUTVDEKUMZBUJTZSABCDEFGHJLMUKAVHVFUSU
      TAVGVEBUJAIUIQVGVEUNOVCEFIKNULUOUPUQUR $.

    lmmbrf.7 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    ${
      lmmcvg.8 $e |- ( ph -> F ( ~~>t ` J ) P ) $.
      lmmcvg.9 $e |- ( ph -> R e. RR+ ) $.
      $( Convergence property of a converging sequence.  (Contributed by NM,
         1-Jun-2007.)  (Revised by Mario Carneiro, 1-May-2014.) $)
      lmmcvg $p |- ( ph -> E. j e. Z A. k e. ( ZZ>= ` j )
                     ( A e. X /\ ( A D P ) < R ) ) $=
        ( wcel vx cv cdm cfv co clt wbr w3a cuz wral wrex wa crp cpm clm lmmbr3
        cc mpbid simp3d wceq breq2 3anbi3d rexralbidv sylc uztrn2 3simpc eleq1d
        rspcv oveq1d breq1d anbi12d syl5ib sylan2 anassrs ralimdva reximdva mpd
        wi ) AGUBZHUCTZVSHUDZKTZWADCUEZEUFUGZUHZGFUBZUIUDZUJZFLUKZBKTZBDCUEZEUF
        UGZULZGWGUJZFLUKAEUMTVTWBWCUAUBZUFUGZUHZGWGUJFLUKZUAUMUJZWISAHKUQUNUETZ
        DKTZWSAHDIUOUDUGWTXAWSUHRAUACDFGHIJKLMNOPUPURUSWRWIUAEUMWOEUTZWQWEFGLWG
        XBWPWDVTWBWOEWCUFVAVBVCVHVDAWHWNFLAWFLTZULWEWMGWGAXCVSWGTZWEWMVRZXCXDUL
        AVSLTZXEJVSWFLOVEWEWBWDULAXFULZWMVTWBWDVFXGWBWJWDWLXGWABKQVGXGWCWKEUFXG
        WABDCQVIVJVKVLVMVNVOVPVQ $.
    $}

    lmmbrf.8 $e |- ( ph -> F : Z --> X ) $.
    $( Express the binary relation "sequence ` F ` converges to point
       ` P ` " in a metric space using an abitrary set of upper integers.  This
       version of ~ lmmbr2 presupposes that ` F ` is a function.  (Contributed
       by NM, 20-Jul-2007.)  (Revised by Mario Carneiro, 1-May-2014.) $)
    lmmbrf $p |- ( ph -> ( F ( ~~>t ` J ) P <-> ( P e. X /\
      A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( A D P ) < x ) ) ) $=
      ( wcel wa cv cdm cfv co clt wbr w3a cuz wral wrex crp cc cpm clm cxmt cvv
      wf wss elfvdm cnex jctir cz uzssz zsscn sstri eqsstri jctr elpm2r syl2anc
      syl2an biantrurd uztrn2 adantll oveq1d breq1d adantrl wceq fdm syl eleq2d
      wb biimpar ffvelrnda jca df-3an syl6bbr anassrs ralbidva rexbidva ralbidv
      bitr3d syldan anbi2d lmmbr3 3anass syl6bb 3bitr4rd ) AEKSZGUAZHUBZSZWSHUC
      ZKSZXBEDUDZBUAZUEUFZUGZGFUAZUHUCZUIZFLUJZBUKUIZTZHKULUMUDSZXMTZWRCEDUDZXE
      UEUFZGXIUIZFLUJZBUKUIZTHEIUNUCUFZAXNXMADKUOUCSZLKHUQZXNNRYBKUOUBZSZULUPSZ
      TYCLULURZTXNYCYBYEYFDKUOUSUTVAYCYGLJUHUCZULOYHVBULJVCVDVEVFVGKULLHYDUPVHV
      JVIVKAXTXLWRAXSXKBUKAXRXJFLAXHLSZTZXQXGGXIYJWSXISZWSLSZXQXGWAZYIYKYLAJWSX
      HLOVLVMAYIYLYMAYIYLTTXFXQXGAYLXFXQWAYIAYLTZXDXPXEUEYNXBCEDQVNVOVPAYLXFXGW
      AYIYNXFXAXCTZXFTXGYNYOXFYNXAXCAXAYLAWTLWSAYCWTLVQRLKHVRVSVTWBALKWSHRWCWDV
      KXAXCXFWEWFVPWKWGWLWHWIWJWMAYAXNWRXLUGXOABDEFGHIJKLMNOPWNXNWRXLWOWPWQ $.
  $}

  ${
    $d j k x D $.  $d j k x F $.  $d j k x P $.  $d j k x ph $.  $d j k x X $.
    $d x J $.
    lmnn.2 $e |- J = ( MetOpen ` D ) $.
    lmnn.3 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    lmnn.4 $e |- ( ph -> P e. X ) $.
    lmnn.5 $e |- ( ph -> F : NN --> X ) $.
    lmnn.6 $e |- ( ( ph /\ k e. NN ) -> ( ( F ` k ) D P ) < ( 1 / k ) ) $.
    $( A condition that implies convergence.  (Contributed by NM, 8-Jun-2007.)
       (Revised by Mario Carneiro, 1-May-2014.) $)
    lmnn $p |- ( ph -> F ( ~~>t ` J ) P ) $=
      ( vx cfv wbr wcel clt cn wa c1 vj clm cv cuz wral wrex crp cdiv cfl caddc
      co cn0 cr cc0 cle rpreccl adantl rpge0d flge0nn0 syl2anc nn0p1nn syl cxmt
      rpred cxr ad2antrr wf uztrn2 sylan ffvelrnd xmetcl syl3anc nnrecred rexrd
      nnuz ad2antlr adantlr syldan adantr nnred flltp1 eluzle ltletrd wb simplr
      rpxr rpregt0 rpregt0d ltrec1 syl2an mpbid xrlttrd ralrimiva fveq2 raleqdv
      nnrp wceq rspcev cz 1z a1i eqidd lmmbrf mpbir2and ) AECFUBNOCGPZDUCZENZCB
      UKZMUCZQOZDUAUCZUDNZUEZUARUFZMUGUEJAXNMUGAXIUGPZSZTXIUHUKZUINZTUJUKZRPZXJ
      DXSUDNZUEZXNXPXRULPZXTXPXQUMPZUNXQUOOYCXPXQXOXQUGPAXIUPUQZVDZXPXQYEURXQUS
      UTXRVAVBZXPXJDYAXPXFYAPZSZXHTXFUHUKZXIYIBGVCNPZXGGPXEXHVEPAYKXOYHIVFYIRGX
      FEARGEVGXOYHKVFXPXTYHXFRPZYGTXFXSRVOVHVIZVJAXEXOYHJVFXGCBGVKVLYIYJYIXFYMV
      MVNXOXIVEPAYHXIWFVPXPYHYLXHYJQOZYMAYLYNXOLVQVRYIXQXFQOZYJXIQOZYIXQXSXFXPY
      DYHYFVSZXPXSUMPYHXPXSYGVTVSYIXFYMVTYIYDXQXSQOYQXQWAVBYHXSXFUOOXPXSXFWBUQW
      CYIXOYLYOYPWDZAXOYHWEYMXOXIUMPUNXIQOSXFUMPUNXFQOSYRYLXIWGYLXFXFWPWHXIXFWI
      WJUTWKWLWMXMYBUAXSRXKXSWQXJDXLYAXKXSUDWNWOWRUTWMAMXGBCUADEFTGRHIVOTWSPAWT
      XAAYLSXGXBKXCXD $.
  $}

  ${
    $d s u v w x y z B $.  $d f r s u v w x y z F $.  $d f r s u v w x y z X $.
    $d x y G $.  $d r x y z J $.  $d r s x y z R $.  $d u v w x y z Y $.
    $d d f r s u v w x y z D $.
    $( The set of Cauchy filters on a metric space.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    cfilfval $p |- ( D e. ( *Met ` X ) -> ( CauFil ` D ) = { f e. ( Fil ` X ) |
            A. x e. RR+ E. y e. f ( D " ( y X. y ) ) C_ ( 0 [,) x ) } ) $=
      ( vd cxmt cfv wcel ccfil cv cima wss wrex crp wral cdm cfil crab wceq cxp
      cc0 cico crn cuni fvssunirn sseli dmeq dmeqd fveq2d imaeq1 sseq1d rexbidv
      co ralbidv rabeqbidv df-cfil fvex rabex fvmpt syl xmetdmdm rabeq eqtr4d )
      CEGHZIZCJHZCBKZVHUAZLZUBAKUCUNZMZBDKZNZAOPZDCQZQZRHZSZVODERHZSZVFCGUDUEZI
      VGVSTVEWBCGEUFUGFCFKZVILZVKMZBVMNZAOPZDWCQZQZRHZSVSWBJWCCTZWGVODWJVRWKWIV
      QRWKWHVPWCCUHUIUJWKWFVNAOWKWEVLBVMWKWDVJVKWCCVIUKULUMUOUPABDFUQVODVRVQRUR
      USUTVAVFVTVRTWAVSTVFEVQRCEVBUJVODVTVRVCVAVD $.

    $( The property of being a Cauchy filter.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    iscfil $p |- ( D e. ( *Met ` X ) ->
      ( F e. ( CauFil ` D ) <-> ( F e. ( Fil ` X ) /\ A. x e. RR+ E. y e. F
        ( D " ( y X. y ) ) C_ ( 0 [,) x ) ) ) ) $=
      ( vf cxmt cfv wcel ccfil cv cxp cima cc0 cico co wss wrex crp wral eleq2d
      cfil crab wa cfilfval wceq rexeq ralbidv elrab syl6bb ) CEGHIZDCJHZIDCBKZ
      UMLMNAKOPQZBFKZRZASTZFEUBHZUCZIDURIUNBDRZASTZUDUKULUSDABCFEUEUAUQVAFDURUO
      DUFUPUTASUNBUODUGUHUIUJ $.

    $( The property of being a Cauchy filter.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    iscfil2 $p |- ( D e. ( *Met ` X ) ->
      ( F e. ( CauFil ` D ) <-> ( F e. ( Fil ` X ) /\ A. x e. RR+ E. y e. F
        A. z e. y A. w e. y ( z D w ) < x ) ) ) $=
      ( cfv wcel cv cxp cc0 co wss wrex crp wral wa wbr cxr cxmt cfil cima cico
      ccfil clt iscfil wfun cdm wb wf xmetf ad3antrrr ffun simplr filelss sylan
      syl xpss12 syl2anc wceq fdm sseqtr4d funimassov cle 0xr a1i simpllr rpxrd
      simp-4l sselda adantrr adantrl xmetcl syl3anc xmetge0 elico1 df-3an baibd
      w3a syl6bb syl22anc 2ralbidva bitrd rexbidva ralbidva pm5.32da ) EGUAHIZF
      EUEHIFGUBHIZEBJZWJKZUCLAJZUDMZNZBFOZAPQZRWICJZDJZEMZWLUFSZDWJQCWJQZBFOZAP
      QZRABEFGUGWHWIWPXCWHWIRZWOXBAPXDWLPIZRZWNXABFXFWJFIZRZWNWSWMIZDWJQCWJQZXA
      XHEUHZWKEUIZNWNXJUJXHGGKZTEUKZXKWHXNWIXEXGEGULUMZXMTEUNURXHWKXMXLXHWJGNZX
      PWKXMNXFWIXGXPWHWIXEUOWJFGUPUQZXQWJGWJGUSUTXHXNXLXMVAXOXMTEVBURVCCDWJWJWM
      EVDUTXHXIWTCDWJWJXHWQWJIZWRWJIZRZRZLTIZWLTIZWSTIZLWSVESZXIWTUJYBYAVFVGYAW
      LXDXEXGXTVHVIYAWHWQGIZWRGIZYDWHWIXEXGXTVJZXHXRYFXSXHWJGWQXQVKVLZXHXSYGXRX
      HWJGWRXQVKVMZWQWREGVNVOYAWHYFYGYEYHYIYJWQWREGVPVOYBYCRZXIYDYERZWTYKXIYDYE
      WTVTYLWTRLWLWSVQYDYEWTVRWAVSWBWCWDWEWFWGWD $.

    $( A Cauchy filter is a filter.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    cfilfil $p |- ( ( D e. ( *Met ` X ) /\ F e. ( CauFil ` D ) ) ->
      F e. ( Fil ` X ) ) $=
      ( vy vx cxmt cfv wcel ccfil cfil cv cxp cima cc0 cico wss wrex crp wral
      co iscfil simprbda ) ACFGHBAIGHBCJGHADKZUCLMNEKOTPDBQERSEDABCUAUB $.

    $( Property of a Cauchy filter.  (Contributed by Mario Carneiro,
       13-Oct-2015.) $)
    cfili $p |- ( ( F e. ( CauFil ` D ) /\ R e. RR+ ) ->
      E. x e. F A. y e. x A. z e. x ( y D z ) < R ) $=
      ( vr vd vf ccfil cfv wcel cv co clt wbr wral wrex crp cdm cfil wa cxmt wb
      crn cuni cxp cima cc0 cico wss crab df-cfil elfvdm sseldi xmetunirn sylib
      dmmptss iscfil2 syl ibi simprd wceq breq2 2ralbidv rexbidv rspccva sylan
      ) FDJKLZBMZCMDNZGMZOPZCAMZQBVNQZAFRZGSQZESLVKEOPZCVNQBVNQZAFRZVIFDTTZUAKL
      ZVQVIWBVQUBZVIDWAUCKLZVIWCUDVIDUCUEUFZLWDVIJTWEDHWEHMZVJVJUGUHUIVNUJNUKBI
      MRASQIWFTTUAKULJABIHUMURFDJUNUODUPUQGABCDFWAUSUTVAVBVPVTGESVLEVCZVOVSAFWG
      VMVRBCVNVNVLEVKOVDVEVFVGVH $.

    $( A Cauchy filter contains balls of any pre-chosen size.  (Contributed by
       Mario Carneiro, 15-Oct-2015.) $)
    cfil3i $p |- ( ( D e. ( *Met ` X ) /\ F e. ( CauFil ` D ) /\ R e. RR+ ) ->
      E. x e. X ( x ( ball ` D ) R ) e. F ) $=
      ( vy vs cfv wcel cv co wral wrex wa wi sylan syl wss ad2antrr adantr cxmt
      ccfil crp w3a clt wbr cbl cfili 3adant1 c0 cfilfil 3adant3 fileln0 r19.2z
      wne cfil ex filelss ssrexv dfss3 cxr wb simpl1 simpll3 rpxrd simplr elbl2
      sselda syl22anc ralbidva simpr blssm syl3anc filss 3exp2 sylbird reximdva
      syl5bb syl3c 3syld rexlimdva mpd ) BEUAHIZDBUBHIZCUCIZUDZAJZFJZBKCUEUFZFG
      JZLZAWJLZGDMZWGCBUGHKZDIZAEMZWDWEWMWCGAFBCDUHUIWFWLWPGDWFWJDIZNZWLWKAWJMZ
      WKAEMZWPWRWJUJUOZWLWSOWFDEUPHIZWQXAWCWDXBWEBDEUKULZWJDEUMPXAWLWSWKAWJUNUQ
      QWRWJERZWSWTOWFXBWQXDXCWJDEURPZWKAWJEUSQWRWKWOAEWRWGEIZNZWKWJWNRZWOXHWHWN
      IZFWJLXGWKFWJWNUTXGXIWIFWJXGWHWJIZNWCCVAIZXFWHEIXIWIVBWRWCXFXJWCWDWEWQVCZ
      SXGXKXJXGCWCWDWEWQXFVDVEZTWRXFXJVFXGWJEWHWRXDXFXETVHWHBWGCEVGVIVJVRXGXBWQ
      WNERZXHWOOWFXBWQXFXCSWFWQXFVFXGWCXFXKXNWRWCXFXLTWRXFVKXMBWGCEVLVMXBWQXNXH
      WOWJWNDEVNVOVSVPVQVTWAWB $.

    $( A filter finer than a Cauchy filter is Cauchy.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    cfilss $p |- ( ( ( D e. ( *Met ` X ) /\ F e. ( CauFil ` D ) ) /\
      ( G e. ( Fil ` X ) /\ F C_ G ) ) -> G e. ( CauFil ` D ) ) $=
      ( vy vx cxmt cfv wcel ccfil wa cfil wss cv cxp cima wrex crp wral iscfil
      cc0 cico co simprl simprr simplbda adantr ssrexv ralimdv sylc wb ad2antrr
      mpbir2and ) ADGHIZBAJHZIZKZCDLHZIZBCMZKZKZCUOIZUSAENZVDOPUAFNUBUCMZECQZFR
      SZUQUSUTUDVBUTVEEBQZFRSZVGUQUSUTUEUQVIVAUNUPBURIVIFEABDTUFUGUTVHVFFRVEEBC
      UHUIUJUNVCUSVGKUKUPVAFEACDTULUM $.

    $( The Cauchy filter condition for a filter base.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    fgcfil $p |- ( ( D e. ( *Met ` X ) /\ B e. ( fBas ` X ) ) ->
      ( ( X filGen B ) e. ( CauFil ` D ) <-> A. x e. RR+ E. y e. B
        A. z e. y A. w e. y ( z D w ) < x ) ) $=
      ( vu cfv wcel wa co cv wral wrex crp wss wi wb adantl cfbas cfg ccfil clt
      cxmt cfili adantll elfg ad3antlr ssralv ralimdv syld com12 reximdv syl6bi
      wbr rexlimdv mpd ralrimiva ex cfil ssfg ssrexv fgcl jctild iscfil2 adantr
      syl sylibrd impbid ) FGUEIJZEGUAIJZKZGEUBLZFUCIJZCMDMFLAMZUDUPZDBMZNZCVRN
      ZBEOZAPNZVMVOWBVMVOKZWAAPWCVPPJZKZVQDHMZNZCWFNZHVNOZWAVOWDWIVMHCDFVPVNUFU
      GWEWHWAHVNWEWFVNJZWFGQZVRWFQZBEOZKZWHWARZVLWJWNSVKVOWDBWFEGUHUIWMWOWKWHWM
      WAWHWLVTBEWLWHVTWLWHVSCWFNVTWLWGVSCWFVQDVRWFUJUKVSCVRWFUJULUMUNUMTUOUQURU
      SUTVMWBVNGVAIJZVTBVNOZAPNZKZVOVMWBWRWPVMEVNQZWBWRRVLWTVKEGVBTWTWAWQAPVTBE
      VNVCUKVHVLWPVKEGVDTVEVKVOWSSVLABCDFVNGVFVGVIVJ $.

    $( The Cauchy filter condition for a filter map.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    fmcfil $p |- ( ( D e. ( *Met ` X ) /\ B e. ( fBas ` Y ) /\ F : Y --> X ) ->
      ( ( ( X FilMap F ) ` B ) e. ( CauFil ` D ) <-> A. x e. RR+ E. y e. B
        A. z e. y A. w e. y ( ( F ` z ) D ( F ` w ) ) < x ) ) $=
      ( vu vv vs cxmt cfv wcel co cv clt wral wb cfbas wf w3a cfm cima cmpt crn
      ccfil cfg wbr wrex crp wceq elfvdm fmval syl3an1 eleq1d simp1 simp2 simp3
      cdm 3ad2ant1 eqid fbasrn syl3anc fgcfil syl2anc cvv imassrn wss frn ssexd
      3ad2ant3 syl5ss ralrimivw raleq raleqbi1dv rexrnmpt syl wa wfn simpl3 ffn
      fbelss sylan oveq1 breq1d ralbidv ralima oveq2 bitrd rexbidva 3bitrd ) FH
      MNOZEIUANOZIHGUBZUCZEHGUDPNZFUHNZOHBEGBQZUEZUFZUGZUIPZWSOZJQZKQZFPZAQZRUJ
      ZKLQZSZJXKSZLXCUKZAULSZCQGNZDQGNZFPZXIRUJZDWTSZCWTSZBEUKZAULSWQWRXDWSWNHM
      VAZOZWOWPWRXDUMFHMUNZBYCEGHIUOUPUQWQWNXCHUANOZXEXOTWNWOWPURWQWOWPYDYFWNWO
      WPUSZWNWOWPUTWNWOYDWPYEVBZBEXCGYCIHXCVCVDVEALJKXCFHVFVGWQXNYBAULWQXNXJKXA
      SZJXASZBEUKZYBWQXAVHOZBESXNYKTWQYLBEWQXAHYCYHWQXAGUGZHGWTVIWPWNYMHVJWOIHG
      VKVMVNVLVOXMYJBLEXAXBVHXBVCXLYIJXKXAXJKXKXAVPVQVRVSWQYJYABEWQWTEOZVTZYJXP
      XGFPZXIRUJZKXASZCWTSZYAYOGIWAZWTIVJZYJYSTYOWPYTWNWOWPYNWBIHGWCVSZWQWOYNUU
      AYGIEWTWDWEZYIYRJCIWTGXFXPUMZXJYQKXAUUDXHYPXIRXFXPXGFWFWGWHWIVGYOYRXTCWTY
      OYTUUAYRXTTUUBUUCYQXSKDIWTGXGXQUMYPXRXIRXGXQXPFWJWGWIVGWHWKWLWKWHWM $.

    $( A filter is Cauchy iff it contains a ball of any chosen size.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    iscfil3 $p |- ( D e. ( *Met ` X ) ->
      ( F e. ( CauFil ` D ) <-> ( F e. ( Fil ` X ) /\
        A. r e. RR+ E. x e. X ( x ( ball ` D ) r ) e. F ) ) ) $=
      ( vu vv vs vy cfv wcel cv co wrex crp wral wa simprl syl sseldd cxmt cfil
      ccfil cbl cfilfil cfil3i 3expa ralrimiva jca clt wbr cdiv rphalfcl adantl
      c2 wi wceq oveq2 eleq1d rexbidv rspcv simprr cr wss simp-4l simplrl rpred
      simpllr blhalf syl22anc cxr wb rpxrd blssm syl3anc elbl2 mpbid ralrimivva
      raleq raleqbi1dv syl2anc rexlimdvaa syld ralrimdva impr iscfil2 mpbir2and
      rspcev adantr impbida ) BDUAJKZCBUCJKZCDUBJKZALZELZBUDJZMZCKZADNZEOPZQZWK
      WLQZWMWTBCDUEXBWSEOWKWLWOOKWSABWOCDUFUGUHUIWKXAQWLWMFLZGLZBMHLZUJUKZGILZP
      ZFXGPZICNZHOPZWKWMWTRWKWMWTXKWKWMQZWTXJHOXLXEOKZQZWTWNXEUOULMZWPMZCKZADNZ
      XJXNXOOKZWTXRUPXMXSXLXEUMZUNWSXREXOOWOXOUQZWRXQADYAWQXPCWOXOWNWPURUSUTVAS
      XNXQXJADXNWNDKZXQQZQZXQXFGXPPZFXPPZXJXNYBXQVBYDXFFGXPXPYDXCXPKZXDXPKZQZQZ
      XDXCXEWPMZKZXFYJXPYKXDYJWKYBXEVCKYGXPYKVDWKWMXMYCYIVEZXNYBXQYIVFZYJXEXLXM
      YCYIVHZVGYDYGYHRZXEBDWNXCVIVJYDYGYHVBZTYJWKXEVKKXCDKXDDKYLXFVLYMYJXEYOVMY
      JXPDXCYJWKYBXOVKKXPDVDYMYNYJXOYJXMXSYOXTSVMBWNXODVNVOZYPTYJXPDXDYRYQTXDBX
      CXEDVPVJVQVRXIYFIXPCXHYEFXGXPXFGXGXPVSVTWHWAWBWCWDWEWKWLWMXKQVLXAHIFGBCDW
      FWIWGWJ $.

    cfilfcls.1 $e |- J = ( MetOpen ` D ) $.
    cfilfcls.2 $e |- X = dom dom D $.
    $( Similar to ultrafilters ( ~ uffclsflim ), the cluster points and limit
       points of a Cauchy filter coincide.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    cfilfcls $p |- ( F e. ( CauFil ` D ) -> ( J fClus F ) = ( J fLim F ) ) $=
      ( vx vy vr cfv wcel co cv wa cdm wss crp adantr syl syl3anc vd vf vz wral
      ccfil cfcls cflim wi cuni eqid fclselbas adantl ctopon wceq cxmt crn cima
      cxp cc0 cico wrex cfil crab df-cfil dmmptss elfvdm sseldi xmetunirn sylib
      fveq2i syl6eleqr mopntopon toponuni eleqtrrd mopni2 3expb cfilfil mpancom
      cbl sylan ad2antrr cdiv simpll rphalfcl cfil3i simprr rpxr ad2antlr blssm
      c2 cxr cin wex c0 wne simpllr blopn blcntr fclsopni syl13anc elin simplrl
      n0 cr rpred blhalf syl22anc sselda adantrr simprl wb blcom mpbid sstrd ex
      syl5bi exlimdv filss rexlimddv ad2ant2r toponss ralrimiva flimopn syl2anc
      mpd expr mpbir2and ssrdv flimfcls a1i eqssd ) BAUEJKZCBUFLZCBUGLZYLGYMYNY
      LGMZYMKZYOYNKZYLYPNZYQYODKZYOHMZKZYTBKZUHZHCUDZYRYOCUIZDYPYOUUEKYLYOBCUUE
      UUEUJUKULYRCDUMJKZDUUEUNYRADUOJZKZUUFYLUUHYPYLAAOOZUOJZUUGYLAUOUPUIZKAUUJ
      KYLUEOUUKAUAUUKUAMZYTYTURUQUSYOUTLPHUBMVAGQUDUBUULOOVBJVCUEGHUBUAVDVEBAUE
      VFVGAVHVIDUUIUOFVJVKZRZACDEVLSZDCVMSVNZYRUUCHCYRYTCKZUUAUUBYRUUQUUANZNZYO
      IMZAVSJZLZYTPZUUBIQYRUUHUURUVCIQVAZUUNUUHUUQUUAUVDIYTAYOCDEVOVPVTUUSUUTQK
      ZUVCNZNBDVBJKZUVBBKZYTDPZUVCUUBYRUVGUURUVFYLUVGYPUUHYLUVGUUMABDVQVRRZWAYR
      UVEUVHUURUVCYRUVENZYTUUTWJWBLZWJWBLZUVALZBKZUVHHDUVKUUHYLUVMQKZUVOHDVAYRU
      UHUVEUUNRZYLYPUVEWCUVKUVLQKZUVPUVEUVRYRUUTWDULZUVLWDSHAUVMBDWETUVKYTDKZUV
      ONZNZUVGUVOUVBDPZUVNUVBPZUVHYRUVGUVEUWAUVJWAUVKUVTUVOWFZUWBUUHYSUUTWKKZUW
      CUVKUUHUWAUVQRZYRYSUVEUWAUUPWAZUVEUWFYRUWAUUTWGWHAYOUUTDWITUWBUCMZYOUVLUV
      ALZUVNWLZKZUCWMZUWDUWBUWKWNWOZUWMUWBYPUWJCKZYOUWJKZUVOUWNYLYPUVEUWAWPUWBU
      UHYSUVLWKKZUWOUWGUWHUWBUVRUWQUVKUVRUWAUVSRZUVLWGZSZAYOUVLCDEWQTUWBUUHYSUV
      RUWPUWGUWHUWRAYOUVLDWRTUWEYOUVNUWJBCWSWTUCUWKXCVIUWBUWLUWDUCUWLUWIUWJKZUW
      IUVNKZNZUWBUWDUWIUWJUVNXAUWBUXCUWDUWBUXCNZUVNUWIUVLUVALZUVBUXDUUHUVTUVLXD
      KUXBUVNUXEPUWBUUHUXCUWGRZUVKUVTUVOUXCXBUXDUVLUWBUVRUXCUWRRZXEUWBUXAUXBWFU
      VLADYTUWIXFXGUXDUUHUWIDKZUUTXDKYOUXEKZUXEUVBPUXFUWBUXAUXHUXBUWBUWJDUWIUWB
      UUHYSUWQUWJDPUWGUWHUWTAYOUVLDWITXHXIZUXDUUTYRUVEUWAUXCWPXEUXDUXAUXIUWBUXA
      UXBXJUXDUUHUWQYSUXHUXAUXIXKUXFUXDUVRUWQUXGUWSSUWBYSUXCUWHRUXJUWIAYOUVLDXL
      XGXMUUTADUWIYOXFXGXNXOXPXQYEUVNUVBBDXRWTXSXTUUSUVIUVFYRUUFUURUVIUUOUUFUUQ
      UVIUUAYTCDYAXIVTRUUSUVEUVCWFUVBYTBDXRWTXSYFYBYRUUFUVGYQYSUUDNXKUUOUVJHYOB
      CDYCYDYGXOYHYNYMPYLBCYIYJYK $.
  $}

  ${
    $d d f j k m x D $.  $d f j k m x F $.  $d j k x ph $.  $d d f j k m x X $.
    $d j M $.  $d j k x Z $.
    $( The set of Cauchy sequences on a metric space.  (Contributed by NM,
       8-Sep-2006.)  (Revised by Mario Carneiro, 5-Sep-2015.) $)
    caufval $p |- ( D e. ( *Met ` X ) -> ( Cau ` D ) = { f e. ( X ^pm CC ) |
         A. x e. RR+ E. k e. ZZ ( f |` ( ZZ>= ` k ) ) :
          ( ZZ>= ` k ) --> ( ( f ` k ) ( ball ` D ) x ) } ) $=
      ( vd cxmt cfv wcel cv cbl co wf cz wrex crp cdm cc cpm wceq cuz cres wral
      crab crn cuni cca cvv cmpt df-cau a1i wa dmeq dmeqd cxp cxr xmetf fdm syl
      dmxpid syl6eq sylan9eqr oveq1d wb simpr fveq2d oveqd feq3 rexbidv ralbidv
      rabeqbidv fvssunirn sseli ovex rabex fvmptd ) BEGHZIZFBDJZUAHZVSCJZHZAJZF
      JZKHZLZWAVTUBZMZDNOZAPUCZCWDQZQZRSLZUDZVTWBWCBKHZLZWGMZDNOZAPUCZCERSLZUDZ
      GUEUFZUGUHUGFXBWNUITVRACDFUJUKVRWDBTZULZWJWSCWMWTXDWLERSXCVRWLBQZQZEXCWKX
      EWDBUMUNVRXFEEUOZQEVRXEXGVRXGUPBMXEXGTBEUQXGUPBURUSUNEUTVAVBVCXDWIWRAPXDW
      HWQDNXDWFWPTWHWQVDXDWEWOWBWCXDWDBKVRXCVEVFVGWFWPVTWGVHUSVIVJVKVQXBBGEVLVM
      XAUHIVRWSCWTERSVNVOUKVP $.

    $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` ."
       Part of Definition 1.4-3 of [Kreyszig] p. 28.  The condition
       ` F C_ ( CC X. X ) ` allows us to use objects more general than
       sequences when convenient; see the comment in ~ df-lm .  (Contributed by
       NM, 7-Dec-2006.)  (Revised by Mario Carneiro, 14-Nov-2013.) $)
    iscau $p |- ( D e. ( *Met ` X ) -> ( F e. ( Cau ` D ) <->
        ( F e. ( X ^pm CC ) /\ A. x e. RR+ E. k e. ZZ ( F |` ( ZZ>= ` k ) ) :
          ( ZZ>= ` k ) --> ( ( F ` k ) ( ball ` D ) x ) ) ) ) $=
      ( vf cxmt cfv wcel cca cv cuz cbl co cres wf cz wrex crp wral cc cpm crab
      wa caufval eleq2d reseq1 eqidd fveq1 oveq1d feq123d rexbidv ralbidv elrab
      wceq syl6bb ) BEGHIZDBJHZIDCKZLHZUSFKZHZAKZBMHZNZVAUTOZPZCQRZASTZFEUAUBNZ
      UCZIDVJIUTUSDHZVCVDNZDUTOZPZCQRZASTZUDUQURVKDABFCEUEUFVIVQFDVJVADUOZVHVPA
      SVRVGVOCQVRUTUTVEVMVFVNVADUTUGVRUTUHVRVBVLVCVDUSVADUIUJUKULUMUNUP $.

    $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` ,"
       using an abitrary set of upper integers.  (Contributed by NM,
       19-Dec-2006.)  (Revised by Mario Carneiro, 14-Nov-2013.) $)
    iscau2 $p |- ( D e. ( *Met ` X ) -> ( F e. ( Cau ` D ) <->
        ( F e. ( X ^pm CC ) /\ A. x e. RR+ E. j e. ZZ A. k e. ( ZZ>= ` j )
             ( k e. dom F /\ ( F ` k ) e. X /\
               ( ( F ` k ) D ( F ` j ) ) < x ) ) ) ) $=
      ( cfv wcel cc co cz crp wral wa clt w3a wb syl wi wceq cca cpm cv cuz cbl
      cxmt cres wf wrex cdm wbr iscau wfun cxp wss elfvdm cnex sylancl simprbda
      elpmg ffvresb rexbidv adantr uzid adantl eleq1 fveq2 eleq1d anbi12d rspcv
      cvv c0 wn cxr n0i cpw blf fdm ndmovg ex con1d simpl adantld ad2antrr syld
      syl56 oveq1d breq1d 3anbi123d simp2 syl6 rpxr elbl syl3an3 3expa 3adantl3
      xmetsym pm5.32da 3com23 anbi2d syl6bbr ralbidv pm5.21ndd rexbidva adantlr
      bitrd 3anass 3expia ralbidva ) BFUFGHZEBUAGHEFIUBJHZCUCZUDGZXLEGZAUCZBUEG
      ZJZEXMUGUHZCKUIZALMZNXKDUCZEUJZHZYAEGZFHZYDXNBJZXOOUKZPZDXMMZCKUIZALMZNAB
      CEFULXJXKXTYKXJXKNZXSYJALYLXOLHZNXSYCYDXQHZNZDXMMZCKUIZYJYLXSYQQYMYLXRYPC
      KYLEUMZXRYPQXJXKYREIFUNUOZXJFUFUJZHIVKHXKYRYSNQBFUFUPUQFIEYTVKUTURUSDXMXQ
      EVARVBVCXJYMYQYJQXKXJYMNZYPYICKUUAXLKHZNZXNFHZYPYIUUCYPXLYBHZXNXQHZNZUUDU
      UCXLXMHZYPUUGSUUBUUHUUAXLVDVEZYOUUGDXLXMYAXLTZYCUUEYNUUFYAXLYBVFZUUJYDXNX
      QYAXLEVGZVHVIVJRXJUUGUUDSYMUUBXJUUFUUDUUEUUFXQVLTZVMXJUUDXOVNHZNZUUDXQXNV
      OXJUUOUUMXJXPUJFVNUNZTZUUOVMZUUMSXJUUPFVPZXPUHUUQBFVQUUPUUSXPVRRUUQUURUUM
      XNXOFVNXPVSVTRWAUUDUUNWBWFWCWDWEUUCYIUUEUUDXNXNBJZXOOUKZPZUUDUUCUUHYIUVBS
      UUIYHUVBDXLXMUUJYCUUEYEUUDYGUVAUUKUUJYDXNFUULVHUUJYFUUTXOOUUJYDXNXNBUULWG
      WHWIVJRUUEUUDUVAWJWKUUAUUDYPYIQZSUUBXJYMUUDUVCXJYMUUDPZYOYHDXMUVDYOYCYEYG
      NZNYHUVDYNUVEYCXJUUDYMYNUVEQXJUUDYMPZYNYEXNYDBJZXOOUKZNZUVEYMXJUUDUUNYNUV
      IQXOWLYDBXNXOFWMWNUVFYEUVHYGUVFYENUVGYFXOOXJUUDYEUVGYFTZYMXJUUDYEUVJXNYDB
      FWQWOWPWHWRXFWSWTYCYEYGXGXAXBXHVCXCXDXEXFXIWRXF $.

    iscau3.2 $e |- Z = ( ZZ>= ` M ) $.
    iscau3.3 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    iscau3.4 $e |- ( ph -> M e. ZZ ) $.
    $( Express the Cauchy sequence property in the more conventional
       three-quantifier form.  (Contributed by NM, 19-Dec-2006.)  (Revised by
       Mario Carneiro, 14-Nov-2013.) $)
    iscau3 $p |- ( ph -> ( F e. ( Cau ` D ) <-> ( F e. ( X ^pm CC ) /\
           A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
             ( k e. dom F /\ ( F ` k ) e. X /\ A. m e. ( ZZ>= ` k )
               ( ( F ` k ) D ( F ` m ) ) < x ) ) ) ) $=
      ( cfv wcel co clt wbr wral wa cca cc cpm cdm w3a cuz wrex crp cxmt iscau2
      cv cz wb syl cid adantr ssid simpr eleq1 xmetsym fveq2d cr c2 cdiv cxr wi
      simp1 simp2l simp3l xmetcl syl3anc simp2r simp3r rehalfcld rexrd syl22anc
      cxad xlt2add caddc rexadd syl2anc recnd 2halvesd eqtrd breq2d cle xmettri
      wceq syl13anc xaddcld xrlelttr mpand sylbid syld cvv ax-mp breq1i anbi12i
      3imtr4g cau3lem anbi2i df-3an bitr4i ralbii rexbii 3bitr3g rexuz3 ralbidv
      ovex fvi bitr4d pm5.32da bitrd ) AGCUANOZGIUBUCPOZEUKZGUDOZXPGNZIOZXRDUKZ
      GNZCPZBUKZQRZUEZEXTUFNZSZDULUGZBUHSZTZXOXQXSXRFUKGNZCPZYCQRZFXPUFNZSZUEZE
      YFSZDJUGZBUHSZTACIUINOZXNYJUMLBCDEGIUJUNAXOYIYSAXOTZYIYQDULUGZBUHSZYSUUAX
      QXSTZYBUONZYCQRZTZEYFSZDULUGZBUHSZUUDYLUONZYCQRZFYNSZTZEYFSZDULUGZBUHSZYI
      UUCUUAYTUUJUUQUMAYTXOLUPYTXSYAIOZYKIOZUUDBCDEFGUOULULUQXQXSURXRYAIUSXRYKI
      USYTUURXSUEYAXRCPYBUOYAXRCIUTVAYTUUSUURUEYKYACPYAYKCPZUOYKYACIUTVAYTXSUUS
      TZUURYCVBOZTZUEZYBYCVCVDPZQRZUUTUVEQRZTZYMUUEUVEQRZUUTUONZUVEQRZTUULUVDUV
      HYBUUTVQPZUVEUVEVQPZQRZYMUVDYBVEOZUUTVEOZUVEVEOZUVQUVHUVNVFUVDYTXSUURUVOY
      TUVAUVCVGZYTXSUUSUVCVHZYTUVAUURUVBVIZXRYACIVJVKZUVDYTUURUUSUVPUVRUVTYTXSU
      USUVCVLZYAYKCIVJVKZUVDUVEUVDYCYTUVAUURUVBVMZVNZVOZUWFYBUUTUVEUVEVRVPUVDUV
      NUVLYCQRZYMUVDUVMYCUVLQUVDUVMUVEUVEVSPZYCUVDUVEVBOZUWIUVMUWHWHUWEUWEUVEUV
      EVTWAUVDYCUVDYCUWDWBWCWDWEUVDYLUVLWFRZUWGYMUVDYTXSUUSUURUWJUVRUVSUWBUVTXR
      YKYACIWGWIUVDYLVEOZUVLVEOYCVEOUWJUWGTYMVFUVDYTXSUUSUWKUVRUVSUWBXRYKCIVJVK
      UVDYBUUTUWAUWCWJUVDYCUWDVOYLUVLYCWKVKWLWMWNUVIUVFUVKUVGUUEYBUVEQYBWOOUUEY
      BWHXRYACXIYBWOXJWPZWQUVJUUTUVEQUUTWOOUVJUUTWHYAYKCXIUUTWOXJWPWQWRUUKYLYCQ
      YLWOOUUKYLWHXRYKCXIYLWOXJWPWQZWSWTUNUUIYHBUHUUHYGDULUUGYEEYFUUGUUDYDTYEUU
      FYDUUDUUEYBYCQUWLWQXAXQXSYDXBXCXDXEXDUUPUUBBUHUUOYQDULUUNYPEYFUUNUUDYOTYP
      UUMYOUUDUULYMFYNUWMXDXAXQXSYOXBXCXDXEXDXFUUAYRUUBBUHUUAHULOZYRUUBUMAUWNXO
      MUPYPDEHJKXGUNXHXKXLXM $.

    $d j k x N $.  $d j k m x Z $.
    iscau4.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    iscau4.6 $e |- ( ( ph /\ j e. Z ) -> ( F ` j ) = B ) $.
    $( Express the property " ` F ` is a Cauchy sequence of metric ` D ` ,"
       using an arbitrary set of upper integers.  (Contributed by NM,
       19-Dec-2006.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    iscau4 $p |- ( ph -> ( F e. ( Cau ` D ) <->
            ( F e. ( X ^pm CC ) /\ A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
              ( k e. dom F /\ A e. X /\ ( A D B ) < x ) ) ) ) $=
      ( wcel clt wral wa vm cca cfv cc cpm co cv cdm wbr w3a cuz wrex iscau3 wi
      crp cz simpr syl6eleq eluzelz uzid 3syl wceq fveq2 oveq1d raleqbidv rspcv
      breq1d adantr oveq2d cbvralv ralimi eleq1d syl2im r19.26 ad3antrrr simplr
      syl imp cxmt simprr xmetsym syl3anc biimpd expimpd ralimdv exp3a impancom
      syl5bir mpd syl5bi imdistanda 3imtr4g df-3an ralbii reximdva anim2d uzssz
      sylbid wss eqsstri ssrexv ax-mp anim2i iscau2 syl5ibr impbid simpl uztrn2
      syld wb adantrl adantrr oveq12d 3anbi23d sylan2 anassrs ralbidva rexbidva
      jca ralbidv anbi2d bitrd ) AHEUBUCQZHJUDUEUFQZGUGZHUHQZYEHUCZJQZYGFUGZHUC
      ZEUFZBUGZRUIZUJZGYIUKUCZSZFKULZBUOSZTZYDYFCJQZCDEUFZYLRUIZUJZGYOSZFKULZBU
      OSZTAYCYSAYCYDYFYHYGUAUGZHUCZEUFZYLRUIZUAYEUKUCZSZUJZGYOSZFKULZBUOSZTYSAB
      EFGUAHIJKLMNUMAUUPYRYDAUUOYQBUOAUUNYPFKAYIKQZTZYFYHTZUULTZGYOSZUUSYMTZGYO
      SZUUNYPUURUUSGYOSZUULGYOSZTUVDYMGYOSZTUVAUVCUURUVDUVEUVFUURUVDTZUVEYJUUHE
      UFZYLRUIZUAYOSZUVFUURUVEUVJUNZUVDUURYIYOQZUVKUURYIIUKUCZQYIUPQUVLUURYIKUV
      MAUUQUQLURIYIUSYIUTVAZUULUVJGYIYOYEYIVBZUUJUVIUAUUKYOYEYIUKVCUVOUUIUVHYLR
      UVOYGYJUUHEYEYIHVCZVDVGVEVFVQVHUVJYJYGEUFZYLRUIZGYOSZUVGUVFUVIUVRUAGYOUUG
      YEVBZUVHUVQYLRUVTUUHYGYJEUUGYEHVCVIVGVJUVGYJJQZUVSUVFUNZUURUVDUWAUURUVLUV
      DYHGYOSUWAUVNUUSYHGYOYFYHUQVKYHUWAGYIYOUVOYGYJJUVPVLVFVMVRUURUWAUVDUWBUUR
      UWATZUVDUVSUVFUVDUVSTUUSUVRTZGYOSUWCUVFUUSUVRGYOVNUWCUWDYMGYOUWCUUSUVRYMU
      WCUUSTZUVRYMUWEUVQYKYLRUWEEJVSUCQZUWAYHUVQYKVBAUWFUUQUWAUUSMVOUURUWAUUSVP
      UWCYFYHVTYJYGEJWAWBVGWCWDWEWHWFWGWIWJXIWKUUSUULGYOVNUUSYMGYOVNWLUUMUUTGYO
      YFYHUULWMWNYNUVBGYOYFYHYMWMWNWLWOWEWPWRAUWFYSYCUNMYSYCUWFYDYPFUPULZBUOSZT
      YRUWHYDYQUWGBUOKUPWSYQUWGUNKUVMUPLIWQWTYPFKUPXAXBVKXCBEFGHJXDXEVQXFAYRUUF
      YDAYQUUEBUOAYPUUDFKUURYNUUCGYOAUUQYEYOQZYNUUCXJZUUQUWITZAUUQYEKQZTZUWJUWK
      UUQUWLUUQUWIXGIYEYIKLXHXSAUWMTZYHYTYMUUBYFUWNYGCJAUWLYGCVBUUQOXKZVLUWNYKU
      UAYLRUWNYGCYJDEUWOAUUQYJDVBUWLPXLXMVGXNXOXPXQXRXTYAYB $.

    iscauf.7 $e |- ( ph -> F : Z --> X ) $.
    $( Express the property " ` F ` is a Cauchy sequence of metric
       ` D ` " presupposing ` F ` is a function.  (Contributed by NM,
       24-Jul-2007.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    iscauf $p |- ( ph -> ( F e. ( Cau ` D ) <->
                A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) ( B D A ) < x ) ) $=
      ( wcel cfv wa cv cdm co clt wbr w3a cuz wral wrex crp cc cpm cca cxmt cvv
      wf wss elfvdm syl cnex jctir uzssz zsscn eqsstri elpm2r syl2anc biantrurd
      cz sstri wb adantr adantrr simprl ffvelrnd eqeltrrd uztrn2 sylan2 ffvelrn
      syl2an xmetsym syl3anc breq1d fdm eleq2d biimpar jca df-3an syl6bbr bitrd
      wceq anassrs ralbidva rexbidva ralbidv iscau4 3bitr4rd ) AGUAZHUBZRZCJRZC
      DEUCZBUAZUDUEZUFZGFUAZUGSZUHZFKUIZBUJUHZHJUKULUCRZXITDCEUCZXBUDUEZGXFUHZF
      KUIZBUJUHHEUMSRAXJXIAJUNUBZRZUKUORZTKJHUPZKUKUQZTXJAXPXQAEJUNSRZXPMEJUNUR
      USUTVAAXRXSQKIUGSZUKLYAVHUKIVBVCVIVDVAJUKKHXOUOVEVFVGAXNXHBUJAXMXGFKAXEKR
      ZTXLXDGXFAYBWQXFRZXLXDVJAYBYCTZTZXLXCXDYEXKXAXBUDYEXTDJRWTXKXAWJAXTYDMVKY
      EXEHSZDJAYBYFDWJYCPVLYEKJXEHAXRYDQVKAYBYCVMVNVOYEWQHSZCJYDAWQKRZYGCWJIWQX
      EKLVPZOVQAXRYHYGJRYDQYIKJWQHVRVSVOZDCEJVTWAWBYEXCWSWTTZXCTXDYEYKXCYEWSWTA
      XRYHWSYDQYIXRWSYHXRWRKWQKJHWCWDWEVSYJWFVGWSWTXCWGWHWIWKWLWMWNABCDEFGHIJKL
      MNOPWOWP $.
  $}

  ${
    $d d f j k x y D $.  $d f j k x y F $.  $d d f x J $.  $d f j k x y X $.
    $( A metric with a Cauchy sequence cannot be empty.  (Contributed by NM,
       19-Dec-2006.)  (Revised by Mario Carneiro, 24-Dec-2013.) $)
    caun0 $p |- ( ( D e. ( *Met ` X ) /\ F e. ( Cau ` D ) ) -> X =/= (/) ) $=
      ( vk vj vx cfv wcel cv co wral cz wrex crp c0 wne ne0i r19.2z rexlimivw
      c1 cca wa cdm clt wbr w3a cuz 1rp ax-mp cc cpm iscau2 simplbda sylancr wi
      cxmt uzid ex 3syl 3ad2ant2 syl6 rexlimiv syl ) ACUPGHZBAUAGHZUBZDIZBUCHZV
      GBGZCHZVIEIZBGAJFIUDUEZUFZDVKUGGZKZELMZFNMZCOPZVFNOPZVPFNKZVQTNHVSUHNTQUI
      VDVEBCUJUKJHVTFAEDBCULUMVPFNRUNVPVRFNVOVRELVKLHZVOVMDVNMZVRWAVKVNHVNOPZVO
      WBUOVKUQVNVKQWCVOWBVMDVNRURUSVMVRDVNVJVHVRVLCVIQUTSVAVBSVC $.

    $( Inclusion of a Cauchy sequence, under our definition.  (Contributed by
       NM, 7-Dec-2006.)  (Revised by Mario Carneiro, 24-Dec-2013.) $)
    caufpm $p |- ( ( D e. ( *Met ` X ) /\ F e. ( Cau ` D ) ) ->
        F e. ( X ^pm CC ) ) $=
      ( vy vx cxmt cfv wcel cca cc cpm co cv cuz cbl cres wf cz wrex crp iscau
      wral simprbda ) ACFGHBAIGHBCJKLHDMZNGZUDBGEMAOGLBUEPQDRSETUBEADBCUAUC $.
  $}

  ${
    $d j k m u x D $.  $d j k m u x F $.  $d j k m u x X $.  $d j k m u x Z $.
    $d j k m x M $.
    caucfil.1 $e |- Z = ( ZZ>= ` M ) $.
    caucfil.2 $e |- L = ( ( X FilMap F ) ` ( ZZ>= " Z ) ) $.
    $( A Cauchy sequence predicate can be expressed in terms of the Cauchy
       filter predicate for a suitably chosen filter.  (Contributed by Mario
       Carneiro, 13-Oct-2015.) $)
    caucfil $p |- ( ( D e. ( *Met ` X ) /\ M e. ZZ /\ F : Z --> X ) ->
      ( F e. ( Cau ` D ) <-> L e. ( CauFil ` D ) ) ) $=
      ( vk vm vx vu cfv wcel cz clt cuz wral wa wi vj cxmt wf w3a cv cdm co wbr
      wrex crp cima cca ccfil df-3an adantll wceq simpll3 fdm eleqtrrd ffvelrnd
      uztrn2 syl jca biantrurd wss adantl sseld pm4.71rd imbi1d impexp ralbidv2
      uzss syl6bb bitr3d syl5bb ralbidva r19.26-2 weq eleq1 fveq2 oveq2d breq1d
      imbi12d cbvralv ralbii eleq2d oveq1d cbvral2v ralcom 3bitr3i anbi2i anidm
      3bitr2i simpll1 ad2ant2l adantrr xmetsym syl3anc imbi2d anbi2d wo jaob wb
      eluzelz uztric syl2an pm5.5 syl5bbr bitrd 2ralbidva wfn cpw uzf ffn ax-mp
      rexbidva uzssz eqsstri raleq raleqbi1dv rexima syl6bbr ralbidv cc cpm cvv
      mp2an elfvdm adantr cnex jctir zsscn sstri jctr elpm2r simpl simpr iscau3
      baibd syldan 3impa cfm eleq1i cfbas uzfbas fmcfil syl3an2 3bitr4d ) AEUBM
      NZDONZFEBUCZUDZIUEZBUFZNZUUMBMZENZUUPJUEZBMZAUGZKUEZPUHZJUUMQMZRZUDZIUAUE
      ZQMZRZUAFUIZKUJRZUVBJLUEZRZIUVKRZLQFUKZUIZKUJRZBAULMNZCAUMMZNZUULUVIUVOKU
      JUULUVIUVBJUVGRZIUVGRZUAFUIZUVOUULUVHUWAUAFUULUVFFNZSZUVHUURUVCNZUVBTZJUV
      GRZIUVGRZUWAUWDUVEUWGIUVGUVEUUOUUQSZUVDSZUWDUUMUVGNZSZUWGUUOUUQUVDUNUWLUV
      DUWJUWGUWLUWIUVDUWLUUOUUQUWLUUMFUUNUWCUWKUUMFNUULDUUMUVFFGVAUOZUWLUUKUUNF
      UPUUIUUJUUKUWCUWKUQZFEBURVBUSUWLFEUUMBUWNUWMUTZVCVDUWLUVBUWFJUVCUVGUWLUWF
      UURUVGNZUWESZUVBTUWPUWFTUWLUWEUWQUVBUWLUWEUWPUWLUVCUVGUURUWKUVCUVGVEUWDUV
      FUUMVLVFVGVHVIUWPUWEUVBVJVMVKVNVOVPUWHUWFUUMUURQMZNZUUSUUPAUGZUVAPUHZTZSZ
      JUVGRIUVGRZUWDUWAUXDUWHUXBJUVGRIUVGRZSUWHUWHSUWHUWFUXBIJUVGUVGVQUWHUXEUWH
      UVKUWRNZUUSUVKBMZAUGZUVAPUHZTZLUVGRZJUVGRUXBIUVGRZJUVGRUWHUXEUXKUXLJUVGUX
      JUXBLIUVGLIVRZUXFUWSUXIUXAUVKUUMUWRVSUXMUXHUWTUVAPUXMUXGUUPUUSAUVKUUMBVTW
      AWBWCWDWEUXJUWFUVKUVCNZUUPUXGAUGZUVAPUHZTJLIJUVGUVGJIVRZUXFUXNUXIUXPUXQUW
      RUVCUVKUURUUMQVTWFUXQUXHUXOUVAPUXQUUSUUPUXGAUURUUMBVTWGWBWCLJVRZUXNUWEUXP
      UVBUVKUURUVCVSUXRUXOUUTUVAPUXRUXGUUSUUPAUVKUURBVTWAWBWCWHUXBJIUVGUVGWIWJW
      KUWHWLWMUWDUXCUVBIJUVGUVGUWDUWKUWPSZSZUXCUWFUWSUVBTZSZUVBUXTUXBUYAUWFUXTU
      XAUVBUWSUXTUWTUUTUVAPUXTUUIUUSENUUQUWTUUTUPUUIUUJUUKUWCUXSWNUXTFEUURBUUIU
      UJUUKUWCUXSUQUWCUWPUURFNUULUWKDUURUVFFGVAWOUTUWDUWKUUQUWPUWOWPUUSUUPAEWQW
      RWBWSWTUYBUWEUWSXAZUVBTZUXTUVBUWEUVBUWSXBUXTUYCUYDUVBXCUXSUYCUWDUWKUUMONU
      URONUYCUWPUVFUUMXDUVFUURXDUUMUURXEXFVFUYCUVBXGVBXHXIXJXHXIXPQOXKZFOVEUVOU
      WBXCOOXLZQUCUYEXMOUYFQXNXOFDQMOGDXQXRZUVMUWALUAOFQUVLUVTIUVKUVGUVBJUVKUVG
      XSXTYAYGYBYCUUIUUJUUKUVQUVJXCZUUIUUJSZUUKBEYDYEUGNZUYHUYIEUBUFZNZYDYFNZSU
      UKFYDVEZSUYJUUKUYIUYLUYMUUIUYLUUJAEUBYHYIYJYKUUKUYNFOYDUYGYLYMYNEYDFBUYKY
      FYOXFUYIUVQUYJUVJUYIKAUAIJBDEFGUUIUUJYPUUIUUJYQYRYSYTUUAUVSUVNEBUUBUGMZUV
      RNZUULUVPCUYOUVRHUUCUUJUUIUVNFUUDMNUUKUYPUVPXCDFGUUEKLIJUVNABEFUUFUUGVOUU
      H $.
  $}

  ${
    $d d f D $.  $d f F $.  $d d f J $.  $d d f x X $.
    iscmet.1 $e |- J = ( MetOpen ` D ) $.
    $( The property " ` D ` is a complete metric." meaning all Cauchy filters
       converge to a point in the space.  (Contributed by Mario Carneiro,
       1-May-2014.)  (Revised by Mario Carneiro, 13-Oct-2015.) $)
    iscmet $p |- ( D e. ( CMet ` X ) <-> ( D e. ( Met ` X ) /\
                 A. f e. ( CauFil ` D ) ( J fLim f ) =/= (/) ) ) $=
      ( vd vx cms cfv wcel cvv cme cv cflim co c0 ccfil cmopn wceq fveq2 wne wa
      wral elfvex adantr crab rabeq syl df-cmet fvex rabex fvmpt eleq2d syl6eqr
      oveq1d neeq1d raleqbidv elrab syl6bb pm5.21nii ) ADHIZJZDKJZADLIZJZCBMZNO
      ZPUAZBAQIZUCZUBZADHUDVEVCVJADLUDUEVCVBAFMZRIZVFNOZPUAZBVLQIZUCZFVDUFZJVKV
      CVAVRAGDVQFGMZLIZUFZVRKHVSDSVTVDSWAVRSVSDLTVQFVTVDUGUHGBFUIVQFVDDLUJUKULU
      MVQVJFAVDVLASZVOVHBVPVIVLAQTWBVNVGPWBVMCVFNWBVMARICVLARTEUNUOUPUQURUSUT
      $.

    $( The convergence of a Cauchy filter in a complete metric space.
       (Contributed by Mario Carneiro, 14-Oct-2015.) $)
    cmetcvg $p |- ( ( D e. ( CMet ` X ) /\ F e. ( CauFil ` D ) ) ->
                    ( J fLim F ) =/= (/) ) $=
      ( vf cms cfv wcel cv cflim co c0 wne ccfil wral cme iscmet simprbi wceq
      oveq2 neeq1d rspccva sylan ) ADGHIZCFJZKLZMNZFAOHZPZBUIICBKLZMNZUEADQHIUJ
      AFCDERSUHULFBUIUFBTUGUKMUFBCKUAUBUCUD $.
  $}

  ${
    $d f D $.  $d f X $.
    $( A complete metric space is a metric space.  (Contributed by NM,
       18-Dec-2006.)  (Revised by Mario Carneiro, 29-Jan-2014.) $)
    cmetmet $p |- ( D e. ( CMet ` X ) -> D e. ( Met ` X ) ) $=
      ( vf cms cfv wcel cme cmopn cv cflim co c0 ccfil wral eqid iscmet simplbi
      wne ) ABDEFABGEFAHEZCIJKLRCAMENACSBSOPQ $.

    cmetmeti.1 $e |- D e. ( CMet ` X ) $.
    $( A complete metric space is a metric space.  (Contributed by NM,
       26-Oct-2007.) $)
    cmetmeti $p |- D e. ( Met ` X ) $=
      ( cms cfv wcel cme cmetmet ax-mp ) ABDEFABGEFCABHI $.
  $}

  ${
    $d j k m w x y z D $.  $d j k m w x y z F $.  $d j k m y z G $.  $d x P $.
    $d j k x y z J $.  $d j k m x y z ph $.  $d j k m w x y z X $.
    cmetcau.1 $e |- J = ( MetOpen ` D ) $.
    ${
      cmetcau.3 $e |- ( ph -> D e. ( CMet ` X ) ) $.
      cmetcau.4 $e |- ( ph -> P e. X ) $.
      cmetcau.5 $e |- ( ph -> F e. ( Cau ` D ) ) $.
      cmetcau.6 $e |- G = ( x e. NN |-> if ( x e. dom F , ( F ` x ) , P ) ) $.
      $( Lemma for ~ cmetcau .  (Contributed by Mario Carneiro,
         14-Oct-2015.) $)
      cmetcaulem $p |- ( ph -> F e. dom ( ~~>t ` J ) ) $=
        ( vk vz cn cfv wcel wa wral vy vj vw vm cv cuz cima cfg co cflf wex clm
        cdm c0 wne cfm cflim ctopon cfil wf wceq cxmt cme cms cmetmet mopntopon
        syl metxmet cfbas c1 cz 1z nnuz uzfbas mp1i fgcl cif cc cvv elfvdm cnex
        cpm a1i cca caufpm syl2anc elpm2g simprbda syl21anc adantr ffvelrnda wn
        ad2antrr ifclda fmptd flfval syl3anc eqid fmfg oveq2d eqtr4d ccfil wrex
        wss crp 1rp clt wbr w3a iscau3 simplbda mpdan simp1 ralimi reximi biidd
        rspcv mpsyl eqidd iscau4 wi simprl uztrn2 sylan sylan2 anassrs ralimdva
        idd syldan reximdva ralimdv mpd sselda weq fveq2 elin syl5bir wb lmmbr3
        ex dfss3 nnsscn jctir elpm2r nnz ad2antrl fdm eleq2d biimpar a1d simprr
        3anim123d iftrue adantl fvex syl6eqel eleq1 ifbieq12d eqtrd cin eqeq12d
        fvmptg sylanbrc sylbi vtoclga mpbir2and rexlimdva caucfil mpbid cmetcvg
        expr eqnetrd n0 sylib lmflf lmcl biimpa simp3d r19.26 ad2ant2lr simprr2
        rexanuz2 eqeltrrd oveq1d simprr3 eqbrtrrd 3jca mpand mpbir3and releldmi
        lmrel sylbird exlimdv ) AUAUEZFGPUFPUGZUHUIZUJUIQZRZUAUKZEGULQZUMRZAUWQ
        UNUOUWSAUWQGUWOHFUPUIZQZUQUIZUNAUWQGUWPUXBQZUQUIZUXDAGHURQRZUWPPUSQRZPH
        FUTZUWQUXFVAACHVBQRZUXGACHVCQRZUXJACHVDQRZUXKJCHVEVGCHVHVGZCGHIVFVGZAUW
        OPVIQRZUXHVJVKRZUXOAVLVJPVMVNVOZUWOPVPVGABPBUEZEUMZRZUXREQZDVQZHFAUXRPR
        ZSZUXTUYADHUYDUXSHUXREAUXSHEUTZUYCAHVDUMZRZVRVSRZEHVRWBUIZRZUYEAUXLUYGJ
        CHVDVTVGZUYHAWAWCZAUXJECWDQZRZUYJUXMLCEHWEWFZUYGUYHSUYJUYEUXSVRXDHVREUY
        FVSWGWHWIWJWKADHRUYCUXTWLKWMWNMWOZFGUWPHPWPWQAUXCUXEGUQAUYGUXOUXIUXCUXE
        VAUYKUXQUYPUWOUYFFUWPHPUWPWRZWSWQWTXAAUXLUXCCXBQRZUXDUNUOJAFUYMRZUYRANU
        EZUXSRZNUBUEZUFQZTZUBPXCZUYSVJXERAVUEOXETZVUEXFAVUAUYTEQZHRZVUGUCUEEQCU
        IOUEZXGXHUCUYTUFQTZXIZNVUCTZUBPXCZOXETZVUFAUYNVUNLAUYNUYJVUNAOCUBNUCEVJ
        HPVMUXMUXPAVLWCZXJXKXLVUMVUEOXEVULVUDUBPVUKVUANVUCVUAVUHVUJXMXNXOXNVGZV
        UEVUEOVJXEVUIVJVAVUEXPXQXRAVUDUYSUBPVUDVUCUXSXDZAVUBPRZSZUYSNVUCUXSUUAA
        VURVUQUYSAVURVUQSZSZUYSFUYIRZUYTFUMZRZVUHVUGUDUEZEQZCUIVUIXGXHZXIZNVVEU
        FQZTZUDVUCXCZOXETZAVVBVUTAUYGUYHUXIPVRXDZSVVBUYKUYLAUXIVVMUYPUUBUUCHVRP
        FUYFVSUUDWIWJVVAVUAVUHVVGXIZNVVITZUDVUCXCZOXETZVVLVVAUYNVVQAUYNVUTLWJVV
        AUYNUYJVVQVVAOVUGVVFCUDNEVUBHVUCVUCWRZAUXJVUTUXMWJZVURVUBVKRAVUQVUBUUEU
        UFZVVAUYTVUCRZSZVUGXSVVAVVEVUCRZSZVVFXSXTXKXLVVAVVPVVKOXEVVAVVOVVJUDVUC
        VVAVWCVVEPRZVVOVVJYAVVAVURVWCVWEAVURVUQYBZVJVVEVUBPVMYCYDZVVAVWESVVNVVH
        NVVIVVAVWEUYTVVIRZVVNVVHYAZVWEVWHSVVAUYTPRZVWIVJUYTVVEPVMYCVVAVWJSZVUAV
        VDVUHVUHVVGVVGVWKVVDVUAVVAVVDVWJVVAVVCPUYTAVVCPVAZVUTAUXIVWLUYPPHFUUGVG
        WJUUHUUIUUJVWKVUHYHVWKVVGYHUULYEYFYGYIYJYKYLVVAOVUGVVFCUDNFVUBHVUCVVRVV
        SVVTVWBVWJVUAUYTFQZVUGVAZVVAVURVWAVWJVWFVJUYTVUBPVMYCZYDVVAVUCUXSUYTAVU
        RVUQUUKZYMVWJVUASZVWMVUAVUGDVQZVUGVWJVUAVWRVSRVWMVWRVAVWQVWRVUGVSVUAVWR
        VUGVAVWJVUAVUGDUUMUUNZUYTEUUOUUPBUYTUYBVWRPVSFBNYNZUXTVUAUYADVUGDUXRUYT
        UXSUUQUXRUYTEYOVWTDXSUURMUVBYIVWSUUSZWFVWDVVEPUXSUUTZRZVVEFQZVVFVAZVWDV
        WEVVEUXSRVXCVWGVVAVUCUXSVVEVWPYMVVEPUXSYPUVCVWNVXENVVEVXBNUDYNVWMVXDVUG
        VVFUYTVVEFYOUYTVVEEYOUVAUYTVXBRVWQVWNUYTPUXSYPVXAUVDUVEVGXTUVFUVKYQUVGY
        LAUXJUXPUXIUYSUYRYRUXMVUOUYPCFUXCVJHPVMUXCWRUVHWQUVICUXCGHIUVJWFUVLUAUW
        QUVMUVNAUWRUXAUAAUWRFUWNUWTXHZUXAAUXGUXPUXIVXFUWRYRUXNVUOUYPUWNFGUWPVJH
        PVMUYQUVOWQAVXFUXAAVXFSZEUWNUWTXHZUXAVXGVXHUYJUWNHRZVUAVUHVUGUWNCUIZVUI
        XGXHZXIZNVUCTZUBPXCZOXETZAUYJVXFUYOWJAUXGVXFVXIUXNUWNFGHUVPYDVXGVVDVWMH
        RZVWMUWNCUIZVUIXGXHZXIZNVUCTUBPXCZOXETZVXOVXGVVBVXIVYAAVXFVVBVXIVYAXIAO
        CUWNUBNFGVJHPIUXMVMVUOYSUVQUVRAVYAVXOYAVXFAVUFVYAVXOVUPVUFVYASVUEVXTSZO
        XETAVXOVUEVXTOXEUVSAVYBVXNOXEVYBVUAVXSSZNVUCTZUBPXCAVXNVUAVXSUBNVJPVMUW
        BAVYDVXMUBPVUSVYCVXLNVUCAVURVWAVYCVXLYAZVURVWASAVWJVYEVWOAVWJSZVYCVXLVY
        FVYCSZVUAVUHVXKVYFVUAVXSYBVYGVWMVUGHVWJVUAVWNAVXSVXAUVTZVVDVXPVXRVUAVYF
        UWAUWCVYGVXQVXJVUIXGVYGVWMVUGUWNCVYHUWDVVDVXPVXRVUAVYFUWEUWFUWGYTYEYFYG
        YJYQYKYQUWHWJYLVXGOCUWNUBNEGVJHPIAUXJVXFUXMWJVMUXPVXGVLWCYSUWIEUWNUWTGU
        WKUWJVGYTUWLUWMYL $.
    $}

    $( The convergence of a Cauchy sequence in a complete metric space.
       (Contributed by NM, 19-Dec-2006.)  (Revised by Mario Carneiro,
       14-Oct-2015.) $)
    cmetcau $p |- ( ( D e. ( CMet ` X ) /\ F e. ( Cau ` D ) ) ->
                    F e. dom ( ~~>t ` J ) ) $=
      ( vx vy cms cfv wcel cca wa cv clm cdm c0 wne wex cxmt cme cmetmet syl n0
      metxmet caun0 sylan sylib cn cif cmpt simpll simpr simplr eqid cmetcaulem
      exlimddv ) ADHIJZBAKIJZLZFMZDJZBCNIOJFUSDPQZVAFRUQADSIJZURVBUQADTIJVCADUA
      ADUDUBABDUEUFFDUCUGUSVALGAUTBGUHGMZBOJVDBIUTUIUJZCDEUQURVAUKUSVAULUQURVAU
      MVEUNUOUP $.
  $}

  ${
    $d f g i j k m n r s t u v w x y z D $.  $d j k m r x y z G $.  $d j k R $.
    $d j k m n r u v w x y z F $.  $d x P $.  $d f g i j k m n r s w x y z X $.
    $d f g i j k n r s x y z J $.  $d k n u v y S $.  $d f g i j k n r s y Z $.
    $d f i j k n x M $.  $d f g i j k m n r s x y z ph $.
    iscmet3.1 $e |- Z = ( ZZ>= ` M ) $.
    $( Lemma for ~ iscmet3 .  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    iscmet3lem3 $p |- ( ( M e. ZZ /\ R e. RR+ ) ->
      E. j e. Z A. k e. ( ZZ>= ` j ) ( ( 1 / 2 ) ^ k ) < R ) $=
      ( vn cz wcel crp wa c1 cexp cfv clt wbr wceq cc0 cn0 ax-mp c2 cdiv co cuz
      cv cabs wral wrex cmpt simpl simpr eluzelz eleq2s adantl oveq2 eqid fvmpt
      ovex syl cres cli nn0uz reseq2i wss nn0ssz resmpt eqtr3i cc rphalfcl rpre
      cr 1rp recni a1i cle rpge0 absid mp2an halflt1 eqbrtri expcnv syl5eqbr wb
      cvv 0z zex mptex climres sylancr mpbid climi0 uztrn2 absidd breq1d sylan2
      rpexpcl anassrs ralbidva rexbidva ) DHIZAJIZKZLUAUBUCZCUEZMUCZUFNZAOPZCBU
      EZUDNZUGZBEUHXEAOPZCXIUGZBEUHXBXEABCGHXCGUEZMUCZUIZDEFWTXAUJWTXAUKXBXDEIZ
      KZXDHIZXDXONXEQXPXRXBXRXDDUDNEDXDULFUMUNZGXDXNXEHXOXMXDXCMUOXOUPXCXDMURUQ
      USXBXORUDNZUTZRVAPZXORVAPZXBYAGSXNUIZRVAXOSUTZYAYDSXTXOVBVCSHVDYEYDQVEGHS
      XNVFTVGXBXCGXCVHIXBXCXCJIZXCVKIZLJIYFVLLVITZXCVJTZVMVNXCUFNZLOPXBYJXCLOYG
      RXCVOPZYJXCQYIYFYKYHXCVPTXCVQVRVSVTVNWAWBXBRHIXOWDIZYBYCWCWEYLXBGHXNWFWGV
      NRXORWDWHWIWJWKXBXJXLBEXBXHEIZKXGXKCXIXBYMXDXIIZXGXKWCZYMYNKXBXPYODXDXHEF
      WLXQXFXEAOXQXEJIZXFXEQXQYFXRYPYHXSXCXDWPWIYPXEXEVJXEVPWMUSWNWOWQWRWSWJ $.

    iscmet3.2 $e |- J = ( MetOpen ` D ) $.
    iscmet3.3 $e |- ( ph -> M e. ZZ ) $.
    iscmet3.4 $e |- ( ph -> D e. ( Met ` X ) ) $.
    ${
      iscmet3.6 $e |- ( ph -> F : Z --> X ) $.
      iscmet3.9 $e |- ( ph -> A. k e. ZZ
        A. u e. ( S ` k ) A. v e. ( S ` k ) ( u D v ) < ( ( 1 / 2 ) ^ k ) ) $.
      iscmet3.10 $e |- ( ph -> A. k e. Z
        A. n e. ( M ... k ) ( F ` k ) e. ( S ` n ) ) $.
      $( Lemma for ~ iscmet3 .  (Contributed by Mario Carneiro,
         15-Oct-2015.) $)
      iscmet3lem1 $p |- ( ph -> F e. ( Cau ` D ) ) $=
        ( wcel vj vr cca cfv cv co clt wbr cuz wral wrex crp wa c1 c2 cdiv cexp
        cz iscmet3lem3 sylan r19.2uz syl wi cfz simpl syl6eleq eluzfz2 ad2antrr
        adantl rsp sylc fveq2 eleq2d rspcv simprr elfzuzb sylanbrc uztrn2 oveq2
        wceq eleq1d raleqbidv eluzelz eleq2s ad2antrl oveq1 rspc2va syl21anc cr
        breq1d cme adantr ffvelrn syl2an metcl syl3anc rphalfcl rpexpcl sylancr
        1rp ax-mp rpred rpre ad2antlr lttr mpand anassrs ralrimdva reximdva mpd
        wf ralrimiva cxmt metxmet eqidd iscauf mpbird ) AHDUCUDTFUEZHUDZUAUEZHU
        DZDUFZUBUEZUGUHZUAXRUIUDZUJZFLUKZUBULUJAYGUBULAYCULTZUMZUNUOUPUFZXRUQUF
        ZYCUGUHZFLUKZYGYIYLFXTUIUDUJUALUKZYMAJURTYHYNOYCUAFJLMUSUTYLUAFJLMVAVBY
        IYLYFFLYIXRLTZUMYLYDUAYEYIYOXTYETZYLYDVCYIYOYPUMZUMZYBYKUGUHZYLYDYRXSXR
        EUDZTZYAYTTZCUEZBUEZDUFZYKUGUHZBYTUJCYTUJZYSYRXRJXRVDUFZTZXSGUEZEUDZTZG
        UUHUJZUUAYRXRJUIUDZTZUUIYRXRLUUNYQYOYIYOYPVEZVIZMVFZJXRVGVBYRUUMFLUJZYO
        UUMAUUSYHYQSVHZUUQUUMFLVJVKUULUUAGXRUUHUUJXRVTZUUKYTXSUUJXREVLZVMVNVKYR
        XRJXTVDUFZTZYAUUKTZGUVCUJZUUBYRUUOYPUVDUURYIYOYPVOXRJXTVPVQYRXTLTZUUSUV
        FYQUVGYIJXTXRLMVRZVIUUTUUMUVFFXTLXRXTVTZUULUVEGUUHUVCXRXTJVDVSUVIXSYAUU
        KXRXTHVLWAWBVNVKUVEUUBGXRUVCUVAUUKYTYAUVBVMVNVKYRUUGFURUJZXRURTZUUGAUVJ
        YHYQRVHYOUVKYIYPUVKXRUUNLJXRWCMWDWEZUUGFURVJVKUUFYSXSUUDDUFZYKUGUHCBXSY
        AYTYTUUCXSVTUUEUVMYKUGUUCXSUUDDWFWJUUDYAVTUVMYBYKUGUUDYAXSDVSWJWGWHYRYB
        WITZYKWITYCWITZYSYLUMYDVCYRDKWKUDTZXSKTZYAKTZUVNAUVPYHYQPVHYILKHXKZYOUV
        QYQAUVSYHQWLZUUPLKXRHWMWNYIUVSUVGUVRYQUVTUVHLKXTHWMWNXSYADKWOWPYRYKYRYJ
        ULTZUVKYKULTUNULTUWAWTUNWQXAUVLYJXRWRWSXBYHUVOAYQYCXCXDYBYKYCXEWPXFXGXH
        XIXJXLAUBYAXSDFUAHJKLMAUVPDKXMUDTPDKXNVBOAUVGUMYAXOAYOUMXSXOQXPXQ $.

      iscmet3.7 $e |- ( ph -> G e. ( Fil ` X ) ) $.
      iscmet3.8 $e |- ( ph -> S : ZZ --> G ) $.
      iscmet3.5 $e |- ( ph -> F e. dom ( ~~>t ` J ) ) $.
      $( Lemma for ~ iscmet3 .  (Contributed by Mario Carneiro,
         15-Oct-2015.) $)
      iscmet3lem2 $p |- ( ph -> ( J fLim G ) =/= (/) ) $=
        ( vx vy vr vj cv clm cfv wbr cflim co c0 wne cdm wcel wex eldmg ibi syl
        wa wral ctopon cxmt cme metxmet mopntopon lmcl sylan cbl wss crp adantr
        wi wrex mopni2 3expia cfil ad3antrrr c1 cdiv cexp clt ad2antrr rphalfcl
        c2 cuz adantl iscmet3lem3 syl2anc blcntr syl3anc simplr cxr rpxrd blopn
        cz lmcvg rexanuz2 r19.2uz wf eluzelz eleq2s ad2antrl ffvelrn rpxr blssm
        cle 1rp ax-mp rpexpcl mpan rpred ltle simpll cfz eluzfz2 r19.21bi fveq2
        cr weq eleq2d rspcv sylc simpr ad2antlr rsp wceq oveq1 breq1d ffvelrnda
        syl21anc wb syl22anc syld impr filss syl13anc rexlimdvaa rspc2va syl2an
        oveq2 filelss sselda elbl2 mpbird ex ssrdv ssbl sstr adantrd blcom rpre
        ee12an blhalf expr sylbid adantld sstrd syl5bir mp2and ad2ant2r toponss
        syl5 simprr ralrimiva flimopn mpbir2and ne0i exlimddv ) AHUDUHZJUIUJZUK
        ZJIULUMZUNUOZUDAHUVMUPZUQZUVNUDURZUCUVRUVSUDHUVMUVQUSUTVAAUVNVBZUVLUVOU
        QZUVPUVTUWAUVLLUQZUVLUEUHZUQZUWCIUQZVOZUEJVCZAJLVDUJUQZUVNUWBADLVEUJUQZ
        UWHADLVFUJUQUWIQDLVGVAZDJLOVHVAZUVLHJLVIVJZUVTUWFUEJUVTUWCJUQZVBZUWDUVL
        UFUHZDVKUJZUMZUWCVLZUFVMVPZUWEUVTUWIUWMUWDUWSVOAUWIUVNUWJVNZUWIUWMUWDUW
        SUFUWCDUVLJLOVQVRVJUWNUWRUWEUFVMUWNUWOVMUQZUWRVBZVBILVSUJUQZUWQIUQZUWCL
        VLZUWRUWEAUXCUVNUWMUXBUAVTUVTUXAUXDUWMUWRUVTUXAVBZWAWGWBUMZFUHZWCUMZUWO
        WGWBUMZWDUKZFUGUHWHUJZVCUGMVPZUXHHUJZUVLUXJUWPUMZUQZFUXLVCUGMVPZUXDUXFK
        WRUQZUXJVMUQZUXMAUXRUVNUXAPWEZUXAUXSUVTUWOWFWIZUXJUGFKMNWJWKUXFUVLUXOUG
        FHJKMNUXFUWIUWBUXSUVLUXOUQUVTUWIUXAUWTVNZUVTUWBUXAUWLVNZUYADUVLUXJLWLWM
        UXTAUVNUXAWNUXFUWIUWBUXJWOUQZUXOJUQUYBUYCUXFUXJUYAWPZDUVLUXJJLOWQWMWSUX
        MUXQVBUXKUXPVBZFUXLVCUGMVPZUXFUXDUXKUXPUGFKMNWTUYGUYFFMVPUXFUXDUYFUGFKM
        NXAUXFUYFUXDFMUXFUXHMUQZUYFVBZVBZUXCUXHEUJZIUQZUWQLVLZUYKUWQVLUXDAUXCUV
        NUXAUYIUAVTUYJWRIEXBZUXHWRUQZUYLAUYNUVNUXAUYIUBVTUYHUYOUXFUYFUYOUXHKWHU
        JZMKUXHXCNXDZXEWRIUXHEXFZWKUXFUYMUYIUXFUWIUWBUWOWOUQZUYMUYBUYCUXAUYSUVT
        UWOXGWIDUVLUWOLXHWMVNUYJUYKUXNUXJUWPUMZUWQUXFUYHUYFUYKUYTVLZUXFUYHVBZUX
        KVUAUXPVUBUXKUXIUXJXIUKZVUAVUBUXIYAUQUXJYAUQUXKVUCVOVUBUXIVUBUYOUXIVMUQ
        ZUYHUYOUXFUYQWIUXGVMUQZUYOVUDWAVMUQVUEXJWAWFXKUXGUXHXLXMZVAZXNVUBUXJUXF
        UXSUYHUYAVNXNUXIUXJXOWKVUBUYKUXNUXIUWPUMZVLZVUCVUHUYTVLZVUAUXFAUYHVUIAU
        VNUXAXPAUYHVBZUEUYKVUHVUKUWCUYKUQZUWCVUHUQZVUKVULVBZVUMUXNUWCDUMZUXIWDU
        KZVUNUXNUYKUQZVULCUHZBUHZDUMZUXIWDUKZBUYKVCCUYKVCZVUPVUKVUQVULVUKUXHKUX
        HXQUMZUQZUXNGUHZEUJZUQZGVVCVCZVUQUYHVVDAVVDUXHUYPMKUXHXRNXDWIAVVHFMTXSV
        VGVUQGUXHVVCGFYBVVFUYKUXNVVEUXHEXTYCYDYEVNVUKVULYFVUNVVBFWRVCZUYOVVBAVV
        IUYHVULSWEUYHUYOAVULUYQYGVVBFWRYHYEVVAVUPUXNVUSDUMZUXIWDUKCBUXNUWCUYKUY
        KVURUXNYIVUTVVJUXIWDVURUXNVUSDYJYKBUEYBVVJVUOUXIWDVUSUWCUXNDUUCYKUUAYMV
        UNUWIUXIWOUQZUXNLUQZUWCLUQVUMVUPYNAUWIUYHVULUWJWEUYHVVKAVULUYHUXIUYHUYO
        VUDUYQVUFVAWPYGVUKVVLVULAMLUXHHRYLVNVUKUYKLUWCVUKUXCUYLUYKLVLAUXCUYHUAV
        NAUYNUYOUYLUYHUBUYQUYRUUBUYKILUUDWKUUEUWCDUXNUXILUUFYOUUGUUHUUIVJVUBUWI
        VVLVVKUYDVUCVUJVOUXFUWIUYHUYBVNZUXFMLUXHHAMLHXBUVNUXARWEYLZVUBUXIVUGWPU
        XFUYDUYHUYEVNZUWIVVLVBZVVKUYDVBVUCVUJDUXNUXIUXJLUUJVRYOUYKVUHUYTUUKUUOY
        PUULYQUXFUYHUYFUYTUWQVLZVUBUXPVVQUXKVUBUXPUVLUYTUQZVVQVUBUWIUYDUWBVVLUX
        PVVRYNVVMVVOUXFUWBUYHUYCVNVVNUXNDUVLUXJLUUMYOVUBUWIVVLUWOYAUQZVVRVVQVOV
        VMVVNUXAVVSUVTUYHUWOUUNYGVVPVVSVVRVVQUWODLUXNUVLUUPUUQYMUURUUSYQUUTUYKU
        WQILYRYSYTUVEUVAUVBUVCUWNUXEUXBUVTUWHUWMUXEAUWHUVNUWKVNUWCJLUVDVJVNUWNU
        XAUWRUVFUWQUWCILYRYSYTYPUVGAUWAUWBUWGVBYNZUVNAUWHUXCVVTUWKUAUEUVLIJLUVH
        WKVNUVIUVOUVLUVJVAUVK $.
    $}

    $( The property " ` D ` is a complete metric" expressed in terms of
       functions on ` NN ` (or any other upper integer set).  Thus, we only
       have to look at functions on ` NN ` , and not all possible Cauchy
       filters, to determine completeness.  (The proof uses countable choice.)
       (Contributed by NM, 18-Dec-2006.)  (Revised by Mario Carneiro,
       5-May-2014.) $)
    iscmet3 $p |- ( ph -> ( D e. ( CMet ` X ) <->
            A. f e. ( Cau ` D ) ( f : Z --> X -> f e. dom ( ~~>t ` J ) ) ) ) $=
      ( vu vk vn cfv wcel cv wral wa cz vg vs vv vt vx vi vj cms wf clm cdm cca
      wi cmetcau a1d ralrimiva cme cflim co c0 wne ccfil adantr c1 c2 cdiv cexp
      clt wbr wex wrex crp simpr 1rp rphalfcl ax-mp rpexpcl cfili syl2an vex cn
      mpan com znnen nnenom entri raleq raleqbi1dv axcc4 syl cdom ciin ad2antrr
      cid cfz cen uzenom endom 3syl crab cin dfin5 wss wceq fzn0 biimpri eleq2s
      cuz simprr elfzelz ffvelrn cfil cxmt metxmet simpl cfilfil filelss syldan
      sylan r19.2z syl2anr iinss elfvdm fvi sseqtr4d dfss1 syl5eqr syl2anc fvex
      sylib cvv wb weq fveq2 oveq2 raleqbidv cbvralv ex exlimdv mpd fzfid iinfi
      cfi cfn syl13anc filfi eleqtrd fileln0 eqnetrd rabn0 adantrrr eleq1 eliin
      adantl syl6bb axcc4dom wal df-ral 19.29 sylanb simprrl feq3 mpbid simplrr
      4syl simprd breq2d simprrr eleq2d eleq1d syl5bb simpld iscmet3lem1 simprl
      simplrl mp2d iscmet3lem2 syl5 expdimp an32s expr iscmet sylanbrc impbid2
      ) ABFUHOPZGFCQZUIZUWFDUJOUKPZUMZCBULOZRZUWEUWICUWJUWEUWFUWJPZSUWHUWGBUWFD
      FIUNUOUPAUWKUWEAUWKSZBFUQOPZDUAQZURUSUTVAZUABVBOZRUWEAUWNUWKKVCZUWMUWPUAU
      WQUWMUWOUWQPZSZTUWOUBQZUIZLQUCQBUSZVDVEVFUSZMQZVGUSZVHVIZUCUXEUXAOZRZLUXH
      RZMTRZSZUBVJZUWPUWTUXGUCUDQZRZLUXNRZUDUWOVKZMTRUXMUWTUXQMTUWTUWSUXFVLPZUX
      QUXETPZUWMUWSVMUXDVLPZUXSUXRVDVLPUXTVNVDVOVPUXDUXEVQWBUDLUCBUXFUWOVRVSUPU
      XPUXJUDUWOUBMTUAVTTWAWCWDWEWFUXOUXILUXNUXHUXGUCUXNUXHWGWHWIWJUWTUXLUWPUBU
      WMUWSUXLUWPUWMUWSUXLSZSZGFWNOZUWFUIZUXEUWFOZNQZUXAOZPZNEUXEWOUSZRZMGRZSZC
      VJZUWPUYBGWCWKVIZUEQZNUYIUYGWLZPZUEUYCVKZMGRZUYMUYBETPZGWCWPVIUYNAUYTUWKU
      YAJWMEGHWQGWCWRWSUWMUWSUXBUYSUXKUWMUWSUXBSZSZUYRMGVUBUXEGPZSZUYQUEUYCWTZU
      TVAUYRVUDVUEUYPUTVUDVUEUYCUYPXAZUYPUEUYCUYPXBVUDUYPUYCXCVUFUYPXDVUDUYPFUY
      CVUDUYGFXCZNUYIVKZUYPFXCVUCUYIUTVAZVUGNUYIRVUHVUBVUIUXEEXHOZGVUIUXEVUJPEU
      XEXEXFHXGZVUBVUGNUYIVUBUYFUYIPZUYGUWOPZVUGVUBUXBUYFTPVUMVULUWMUWSUXBXIUYF
      EUXEXJTUWOUYFUXAXKVSZVUBUWOFXLOZPZVUMVUGUWMBFXMOPZUWSVUPVUAAVUQUWKAUWNVUQ
      KBFXNZWJVCUWSUXBXOBUWOFXPZVSZUYGUWOFXQXSXRUPVUGNUYIXTYANUYIUYGFYBWJVUDUWN
      FUQUKZPZUYCFXDZUWMUWNVUAVUCUWRWMBFUQYCZFVVAYDZWSYEUYPUYCYFYJYGVUDVUPUYPUW
      OPUYPUTVAVUBVUPVUCVUTVCZVUDUYPUWOUUCOZUWOVUDVUPVUMNUYIRZVUIUYIUUDPUYPVVGP
      VVFVUBVVHVUCVUBVUMNUYIVUNUPVCVUCVUIVUBVUKUUNVUDEUXEUUANUYIUYGUWOVUOUUBUUE
      VUDVUPVVGUWOXDVVFUWOFUUFWJUUGUYPUWOFUUHYHUUIUYQUEUYCUUJYJUPUUKUYQUYJUEUYC
      CMGFWNYIUYOUYEXDUYQUYEUYPPZUYJUYOUYEUYPUULUYEYKPVVIUYJYLUXEUWFYINUYEUYIUY
      GYKUUMVPUUOUUPYHAUYAUWKUYMUWPUMAUYASZUWKUYMUWPUWKUYMSUWLUWIUMZUYLSZCVJZVV
      JUWPUWKVVKCUUQUYMVVMUWICUWJUURVVKUYLCUUSUUTVVJVVLUWPCVVJVVLUWPVVJVVLSZUCL
      BUXAUFUGUWFUWODEFGHIAUYTUYAVVLJWMZAUWNUYAVVLKWMZVVNUYDUWGVVJVVKUYDUYKUVAV
      VNUWNVVBVVCUYDUWGYLVVPVVDVVEUYCFGUWFUVBUVEUVCZVVNUXKUXCUXDUFQZVGUSZVHVIZU
      CVVRUXAOZRZLVWARZUFTRVVNUXBUXKAUWSUXLVVLUVDZUVFUXJVWCMUFTMUFYMZUXIVWBLUXH
      VWAUXEVVRUXAYNZVWEUXGVVTUCUXHVWAVWFVWEUXFVVSUXCVHUXEVVRUXDVGYOUVGYPYPYQYJ
      ZVVNUYKVVRUWFOZUGQZUXAOZPZUGEVVRWOUSZRZUFGRVVJVVKUYDUYKUVHUYJVWMMUFGUYJUY
      EVWJPZUGUYIRVWEVWMUYHVWNNUGUYINUGYMUYGVWJUYEUYFVWIUXAYNUVIYQVWEVWNVWKUGUY
      IVWLUXEVVREWOYOVWEUYEVWHVWJUXEVVRUWFYNUVJYPUVKYQYJZVVNVUQUWSVUPVVNUWNVUQV
      VPVURWJAUWSUXLVVLUVOVUSYHVVNUXBUXKVWDUVLVVNUWLUWGUWHVVNUCLBUXAUFUGUWFDEFG
      HIVVOVVPVVQVWGVWOUVMVVQVVJVVKUYLUVNUVPUVQYRYSUVRUVSUVTYTUWAYSYTUPBUADFIUW
      BUWCYRUWD $.
  $}

  ${
    $d f D $.  $d f J $.  $d f X $.
    iscmet2.1 $e |- J = ( MetOpen ` D ) $.
    $( A metric ` D ` is complete iff all Cauchy sequences converge to a point
       in the space.  The proof uses countable choice.  Part of Definition
       1.4-3 of [Kreyszig] p. 28.  (Contributed by NM, 7-Sep-2006.)  (Revised
       by Mario Carneiro, 15-Oct-2015.) $)
    iscmet2 $p |- ( D e. ( CMet ` X ) <-> ( D e. ( Met ` X ) /\
                   ( Cau ` D ) C_ dom ( ~~>t ` J ) ) ) $=
      ( vf cms cfv wcel cme cca clm cdm wss wa cmetmet cv cmetcau ex cn c1 wral
      ssrdv jca wf wi ssel2 a1d ralrimiva adantl cz 1z a1i simpl iscmet3 mpbird
      nnuz impbii ) ACFGHZACIGHZAJGZBKGLZMZNZURUSVBACOUREUTVAUREPZUTHZVDVAHZAVD
      BCDQRUBUCVCURSCVDUDZVFUEZEUTUAZVBVIUSVBVHEUTVBVENVFVGUTVAVDUFUGUHUIVCAEBT
      CSUPDTUJHVCUKULUSVBUMUNUOUQ $.
  $}

  ${
    $d s u v x y D $.  $d s u v x y F $.  $d s u v x y X $.  $d s u v x y Y $.
    $( A Cauchy filter on a metric subspace extends to a Cauchy filter in the
       larger space.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    cfilresi $p |- ( ( D e. ( *Met ` X ) /\
         F e. ( CauFil ` ( D |` ( Y X. Y ) ) ) ) ->
       ( X filGen F ) e. ( CauFil ` D ) ) $=
      ( vu vv vx vy cxmt cfv wcel wa co cv clt wral crp sylan wss syl cxp ccfil
      cres cfg wbr wrex cin xmetres cfil iscfil2 simplbda cfilfil filelss inss2
      wceq syl6ss sselda anim12dan ovres 2ralbidva rexbidva ralbidv mpbid cfbas
      breq1d wb cpw cdm filfbas filsspw inss1 sspwb mpbi elfvdm adantr fbasweak
      syl3anc fgcfil syldan mpbird ) ACIJKZBADDUAUCZUBJKZLZCBUDMAUBJKZENZFNZAMZ
      GNZOUEZFHNZPEWKPZHBUFZGQPZWDWFWGWBMZWIOUEZFWKPEWKPZHBUFZGQPZWNWAWBCDUGZIJ
      KZWCWSADCUHZXAWCBWTUIJKZWSGHEFWBBWTUJUKRWDWRWMGQWDWQWLHBWDWKBKZLZWPWJEFWK
      WKXEWFWKKZWGWKKZLLZWOWHWIOXHWFDKZWGDKZLWOWHUOXEXFXIXGXJXEWKDWFXEWKWTDWDXC
      XDWKWTSWAXAWCXCXBWBBWTULRZWKBWTUMRCDUNUPZUQXEWKDWGXLUQURWFWGDDAUSTVEUTVAV
      BVCWAWCBCVDJKZWEWNVFWDBWTVDJKZBCVGZSCIVHZKZXMWDXCXNXKBWTVITWDBWTVGZXOWDXC
      BXRSXKBWTVJTWTCSXRXOSCDVKWTCVLVMUPWAXQWCACIVNVOBXPWTCVPVQGHEFBACVRVSVT $.

    $( Cauchy filter on a metric subspace.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    cfilres $p |- ( ( D e. ( *Met ` X ) /\ F e. ( Fil ` X ) /\ Y e. F ) ->
      ( F e. ( CauFil ` D ) <->
        ( F |`t Y ) e. ( CauFil ` ( D |` ( Y X. Y ) ) ) ) ) $=
      ( vu vv vx vy vs cfv wcel co wa cv clt wral crp syl2anc wb ex ccfil crest
      cxmt cfil w3a cxp cres wbr wrex cdif wn cfbas simp2 filfbas syl simp3 wss
      fbncp filelss 3adant1 trfil3 mpbird cfili adantll cin simpll2 simpll3 jca
      adantr elrestr 3expa sylan wi inss1 ssralv ralimdv syld ax-mp inss2 sseli
      ovres breq1d syl2an ralbidva ralbiia sylibr raleq rspcev syl2im rexlimdva
      raleqbi1dv mpd ralrimiva xmetres2 iscfil2 mpbir2and cfg cfilresi 3ad2ant1
      simp1 wceq fgtr eleq1d sylibd impbid ) ACUCJKZBCUDJZKZDBKZUEZBAUAJZKZBDUB
      LZADDUFUGZUAJKZXJXLXOXJXLMZXOXMDUDJKZENZFNZXNLZGNZOUHZFHNZPZEYCPZHXMUIZGQ
      PZXJXQXLXJXQCDUJBKUKZXJBCULJKZXIYHXJXHYIXFXHXIUMZBCUNUOXFXHXIUPDCBCURRXJX
      HDCUQZXQYHSYJXHXIYKXFDBCUSUTZDBCVARVBVIXPYFGQXPYAQKZMZXRXSALZYAOUHZFINZPZ
      EYQPZIBUIZYFXLYMYTXJIEFAYABVCVDYNYSYFIBYNYQBKZMYQDVEZXMKZYSYBFUUBPZEUUBPZ
      YFYNXHXIMUUAUUCYNXHXIXFXHXIXLYMVFXFXHXIXLYMVGVHXHXIUUAUUCYQDBXGBVJVKVLYSY
      PFUUBPZEUUBPZUUEUUBYQUQZYSUUGVMYQDVNUUHYSUUFEYQPUUGUUHYRUUFEYQYPFUUBYQVOV
      PUUFEUUBYQVOVQVRUUDUUFEUUBXRUUBKZYBYPFUUBUUIXRDKZXSDKZYBYPSXSUUBKUUBDXRYQ
      DVSZVTUUBDXSUULVTUUJUUKMXTYOYAOXRXSDDAWAWBWCWDWEWFUUCUUEYFYEUUEHUUBXMYDUU
      DEYCUUBYBFYCUUBWGWKWHTWIWJWLWMXPXNDUCJKZXOXQYGMSXJUUMXLXJXFYKUUMXFXHXIWTY
      LADCWNRVIGHEFXNXMDWOUOWPTXJXOCXMWQLZXKKZXLXFXHXOUUOVMXIXFXOUUOAXMCDWRTWSX
      JUUNBXKXHXIUUNBXAXFDBCXBUTXCXDXE $.
  $}

  ${
    $d f x y z D $.  $d x y z F $.  $d f x y z X $.  $d f x y z Y $.
    $( Cauchy sequence on a metric subspace.  (Contributed by NM,
       30-Jan-2008.)  (Revised by Mario Carneiro, 30-Dec-2013.) $)
    caussi $p |- ( D e. ( *Met ` X ) ->
                   ( Cau ` ( D |` ( Y X. Y ) ) ) C_ ( Cau ` D ) ) $=
      ( vz vy vx cxmt cfv wcel cxp cv cc co clt wral cz crp wa wss cvv cres cca
      vf cin cpm cdm wbr w3a cuz wrex wfun wi inss1 xpss2 ax-mp sstr anim2i a1i
      mpan2 wb elfvdm inex1g syl cnex elpmg sylancl 3imtr4d adantl simp2 ralimi
      fveq2 eleq1d rspcva syl2an inss2 simpr sseldi sselda simplr ovresd breq1d
      uzid weq biimpd imdistanda sseld anim1d syld syldan anim2d 3anass 3imtr4g
      ralimdv impancom mpd ex reximdva anim12d xmetres iscau2 ssrdv ) ABGHIZUCA
      CCJUAZUBHZAUBHZXBUCKZBCUDZLUEMIZDKZXFUFIZXIXFHZXGIZXKEKZXFHZXCMZFKZNUGZUH
      ZDXMUIHZOZEPUJZFQOZRZXFBLUEMIZXJXKBIZXKXNAMZXPNUGZUHZDXSOZEPUJZFQOZRXFXDI
      ZXFXEIXBXHYDYBYKXBXFUKZXFLXGJZSZRZYMXFLBJZSZRZXHYDYPYSULXBYOYRYMYOYNYQSZY
      RXGBSZYTBCUMZXGBLUNUOXFYNYQUPUSUQURXBXGTIZLTIZXHYPUTXBBGUFZIZUUCABGVAZBCU
      UEVBVCVDXGLXFTTVEVFXBUUFUUDYDYSUTUUGVDBLXFUUETVEVFVGXBYAYJFQXBXTYIEPXBXMP
      IZRZXTYIUUIXTRXNXGIZYIUUIXMXSIZXLDXSOUUJXTUUHUUKXBXMWBVHXRXLDXSXJXLXQVIVJ
      XLUUJDXMXSDEWCXKXNXGXIXMXFVKVLVMVNUUIUUJXTYIUUIUUJRZXRYHDXSUULXJXLXQRZRXJ
      YEYGRZRXRYHUULUUMUUNXJUUIUUJXNCIZUUMUUNULUULXGCXNBCVOZUUIUUJVPVQUUIUUORZU
      UMXLYGRUUNUUQXLXQYGUUQXLRZXQYGUURXOYFXPNUURXKXNACUUQXGCXKXGCSUUQUUPURVRUU
      IUUOXLVSVTWAWDWEUUQXLYEYGUUQXGBXKUUAUUQUUBURWFWGWHWIWJXJXLXQWKXJYEYGWKWLW
      MWNWOWPWQWMWRXBXCXGGHIYLYCUTACBWSFXCEDXFXGWTVCFAEDXFBWTVGXA $.

    $( Cauchy sequence on a metric subspace.  (Contributed by NM,
       29-Jan-2008.)  (Revised by Mario Carneiro, 30-Dec-2013.) $)
    causs $p |- ( ( D e. ( *Met ` X ) /\ F : NN --> Y ) ->
      ( F e. ( Cau ` D ) <-> F e. ( Cau ` ( D |` ( Y X. Y ) ) ) ) ) $=
      ( vy vz vx cxmt cfv wcel cn wa wss cc co cvv wb syl wral c1 crn cres wfun
      cin cca cxp cpm caufpm cdm elfvdm cnex elpmg sylancl biimpa syldan simprd
      wf rnss rnxpss syl6ss adantlr frn ad2antlr ssind ex xmetres inex1g adantr
      wi sylan wfn ffn df-f simplbi2 cv clt wbr cuz crp inss2 a1i sylan2 ancoms
      wrex fss ffvelrn nnuz uztrn2 anassrs ovresd breq1d ralbidva ralbidv cz 1z
      rexbidva eqidd simpr iscauf simpl id syl2anr 3bitr4rd sylan9r pm5.21ndd
      inss1 ) ACHIJZKDBUQZLZBUAZCDUDZMZBAUEIJZBADDUFUBZUEIJZXIXMXLXIXMLXJCDXGXM
      XJCMXHXGXMLZXJNCUFZUAZCXPBXQMZXJXRMXPBUCZXSXGXMBCNUGOJZXTXSLZABCUHXGYAYBX
      GCHUIZJZNPJZYAYBQACHUJZUKCNBYCPULUMUNUOUPBXQURRNCUSUTVAXHXJDMXGXMKDBVBVCV
      DVEXGXOXLVIXHXGXOXLXGXOLZXJNXKUFZUAZXKYGBYHMZXJYIMYGXTYJXGXOBXKNUGOJZXTYJ
      LZXGXNXKHIJZXOYKADCVFZXNBXKUHVJXGYKYLXGXKPJZYEYKYLQXGYDYOYFCDYCVGRUKXKNBP
      PULUMUNUOUPBYHURRNXKUSUTVEVHXHXLKXKBUQZXGXMXOQZXHBKVKZXLYPVIKDBVLYPYRXLKX
      KBVMVNRXGYPYQXGYPLZEVOZBIZFVOZBIZXNOZGVOZVPVQZFYTVRIZSZEKWDZGVSSZUUAUUCAO
      ZUUEVPVQZFUUGSZEKWDZGVSSZXOXMYSXHUUJUUOQYPXGXHXGYPXKDMZXHUUPXGCDVTWAKXKDB
      WEWBWCXHUUIUUNGVSXHUUHUUMEKXHYTKJZLZUUFUULFUUGUURUUBUUGJZLZUUDUUKUUEVPUUT
      UUAUUCADUURUUADJUUSKDYTBWFVHXHUUQUUSUUCDJZUUQUUSLXHUUBKJZUVATUUBYTKWGWHKD
      UUBBWFWBWIWJWKWLWPWMRYSGUUCUUAXNEFBTXKKWGXGYMYPYNVHTWNJYSWOWAZYSUVBLUUCWQ
      ZYSUUQLUUAWQZXGYPWRWSYSGUUCUUAAEFBTCKWGXGYPWTUVCUVDUVEYPYPXKCMZKCBUQXGYPX
      AUVFXGCDXFWAKXKCBWEXBWSXCVEXDXE $.
  $}

  ${
    $d f k r x y C $.  $d f k r s x y D $.  $d f k r x y ph $.  $d k s x y R $.
    $d f k r s x y X $.
    equivcau.1 $e |- ( ph -> C e. ( Met ` X ) ) $.
    equivcau.2 $e |- ( ph -> D e. ( Met ` X ) ) $.
    equivcau.3 $e |- ( ph -> R e. RR+ ) $.
    equivcau.4 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x C y ) <_ ( R x. ( x D y ) ) ) $.
    $( If the metric ` D ` is "strongly finer" than ` C ` (meaning that there
       is a positive real constant ` R ` such that
       ` C ( x , y ) <_ R x. D ( x , y ) ` ), all the ` D ` -Cauchy filters are
       also ` C ` -Cauchy.  (Using this theorem twice in each direction states
       that if two metrics are strongly equivalent, then they have the same
       Cauchy sequences.)  (Contributed by Mario Carneiro, 14-Sep-2015.) $)
    equivcfil $p |- ( ph -> ( CauFil ` D ) C_ ( CauFil ` C ) ) $=
      ( vs vr cfv cv wcel co wrex crp wa vf ccfil cfil wral cdiv simpr ad2antrr
      cbl wi rpdivcld wceq oveq2 eleq1d rexbidv rspcv syl wss simpllr metss2lem
      eqid ancom2s adantlr anassrs cxmt cxr cme ad3antrrr metxmet rpxr ad2antlr
      cmopn blssm syl3anc filss 3exp2 com24 syl3c reximdva ralrimdva imdistanda
      syld wb iscfil3 3syl 3imtr4d ssrdv ) AUAEUBNZDUBNZAUAOZGUCNPZBOZLOZEUHNZQ
      ZWIPZBGRZLSUDZTZWJWKMOZDUHNQZWIPZBGRZMSUDZTZWIWGPZWIWHPZAWJWQXCAWJTZWQXBM
      SXGWSSPZTZWQWKWSFUEQZWMQZWIPZBGRZXBXIXJSPWQXMUIXIWSFXGXHUFAFSPWJXHJUGUJWP
      XMLXJSWLXJUKZWOXLBGXNWNXKWIWLXJWKWMULUMUNUOUPXIXLXABGXIWKGPZTZWJXKWTUQZWT
      GUQZXLXAUIAWJXHXOURXGXHXOXQAXHXOTXQWJAXOXHXQABCDEFWSDVKNZEVKNZGXSUTXTUTHI
      JKUSVAVBVCXPDGVDNZPZXOWSVEPZXRXPDGVFNZPZYBAYEWJXHXOHVGDGVHZUPXIXOUFXHYCXG
      XOWSVIVJDWKWSGVLVMWJXLXRXQXAWJXLXRXQXAXKWTWIGVNVOVPVQVRWAVSVTAEYDPEYAPXEW
      RWBIEGVHBEWIGLWCWDAYEYBXFXDWBHYFBDWIGMWCWDWEWF $.

    $( If the metric ` D ` is "strongly finer" than ` C ` (meaning that there
       is a positive real constant ` R ` such that
       ` C ( x , y ) <_ R x. D ( x , y ) ` ), all the ` D ` -Cauchy sequences
       are also ` C ` -Cauchy.  (Using this theorem twice in each direction
       states that if two metrics are strongly equivalent, then they have the
       same Cauchy sequences.)  (Contributed by Mario Carneiro,
       14-Sep-2015.) $)
    equivcau $p |- ( ph -> ( Cau ` D ) C_ ( Cau ` C ) ) $=
      ( vk vf cv cfv co cz crp wcel wceq vs vr cuz cbl cres wf wrex wral cc cpm
      crab cca wa cdiv wi simpr ad2antrr rpdivcld wb oveq2 feq3 syl rexbidv wss
      rspcv simprr cdm elpmi simpld ad3antlr resss dmss ax-mp uzid ad2antrl fdm
      ad2antll eleqtrrd sseldi ffvelrnd eqid metss2lem expr ralrimiva ad3antrrr
      cmopn simplr oveq1 sseq12d imbi2d fss syl2anc reximdva ralrimdva ss2rabdv
      syl3c syld cme cxmt metxmet caufval 3syl 3sstr4d ) ALNZUCOZXDMNZOZUANZEUD
      OZPZXFXEUEZUFZLQUGZUARUHZMGUIUJPZUKZXEXGUBNZDUDOZPZXKUFZLQUGZUBRUHZMXOUKZ
      EULOZDULOZAXNYBMXOAXFXOSZUMZXNYAUBRYGXQRSZUMZXNXEXGXQFUNPZXIPZXKUFZLQUGZY
      AYIYJRSXNYMUOYIXQFYGYHUPAFRSYFYHJUQURXMYMUAYJRXHYJTZXLYLLQYNXJYKTXLYLUSXH
      YJXGXIUTXJYKXEXKVAVBVCVEVBYIYLXTLQYIXDQSZYLXTYIYOYLUMZUMZYLYKXSVDZXTYIYOY
      LVFYQXGGSYHBNZYJXIPZYSXQXRPZVDZUOZBGUHZYHYRYQXFVGZGXDXFYFUUEGXFUFZAYHYPYF
      UUFUUEUIVDGUIXFVHVIVJYQXKVGZUUEXDXKXFVDUUGUUEVDXFXEVKXKXFVLVMYQXDXEUUGYOX
      DXESYIYLXDVNVOYLUUGXETYIYOXEYKXKVPVQVRVSVTAUUDYFYHYPAUUCBGAYSGSYHUUBABCDE
      FXQDWFOZEWFOZGUUHWAUUIWAHIJKWBWCWDWEYGYHYPWGUUCYHYRUOBXGGYSXGTZUUBYRYHUUJ
      YTYKUUAXSYSXGYJXIWHYSXGXQXRWHWIWJVEWPXEYKXSXKWKWLWCWMWQWNWOAEGWROZSEGWSOZ
      SYDXPTIEGWTUAEMLGXAXBADUUKSDUULSYEYCTHDGWTUBDMLGXAXBXC $.
  $}

  ${
    $d j k x D $.  $d j k J $.  $d j M $.  $d j k ph $.  $d k V $.  $d j k Z $.
    $d j k x F $.  $d j k x P $.  $d j k x Q $.  $d j k x R $.  $d j k x X $.
    lmle.1 $e |- Z = ( ZZ>= ` M ) $.
    lmle.3 $e |- J = ( MetOpen ` D ) $.
    lmle.4 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    lmle.6 $e |- ( ph -> M e. ZZ ) $.
    lmle.7 $e |- ( ph -> F ( ~~>t ` J ) P ) $.
    lmle.8 $e |- ( ph -> Q e. X ) $.
    lmle.9 $e |- ( ph -> R e. RR* ) $.
    lmle.10 $e |- ( ( ph /\ k e. Z ) -> ( Q D ( F ` k ) ) <_ R ) $.
    $( If the distance from each member of a converging sequence to a given
       point is less than or equal to a given amount, so is the convergence
       value.  (Contributed by NM, 23-Dec-2007.)  (Proof shortened by Mario
       Carneiro, 1-May-2014.) $)
    lmle $p |- ( ph -> ( Q D P ) <_ R ) $=
      ( wcel vx vj cv co cle wbr crab cuz cfv cres wf cxmt ctopon mopntopon syl
      clm wrel cdm lmrel releldm sylancr lmff wa eqid adantr cz simprl syl6eleq
      eluzelz wceq fvres adantl simprr ffvelrnda eqeltrrd uztrn2 adantlr syldan
      sylan oveq2 elrab sylanbrc ccld cxr blcld syl3anc lmcld rexlimddv simprbi
      breq1d ) ACDUAUCZBUDZEUEUFZUAJUGZTZDCBUDZEUEUFZAUBUCZUHUIZJGWSUJZUKZWOUBK
      AUBGHIJKLABJULUITZHJUMUITZNBHJMUNUOZOAHUPUIZUQGCXEUFZGXEURTHUSPGCXEUTVAVB
      AWRKTZXAVCZVCZCWNFGHWRJWSWSVDAXCXHXDVEXIWRIUHUIZTWRVFTXIWRKXJAXGXAVGZLVHI
      WRVIUOAXFXHPVEXIFUCZWSTZVCZXLGUIZJTDXOBUDZEUEUFZXOWNTXNXLWTUIZXOJXMXRXOVJ
      XIXLWSGVKVLXIWSJXLWTAXGXAVMVNVOXIXMXLKTZXQXIXGXMXSXKIXLWRKLVPVSAXSXQXHSVQ
      VRWMXQUAXOJWKXOVJWLXPEUEWKXODBVTWJWAWBAWNHWCUITZXHAXBDJTEWDTXTNQRUABDEWNH
      JMWNVDWEWFVEWGWHWOCJTWQWMWQUACJWKCVJWLWPEUEWKCDBVTWJWAWIUO $.
  $}

  ${
    $d j k x D $.  $d j k x F $.  $d j k x M $.  $d j k x P $.  $d j k x V $.
    $d x J $.  $d j k x Z $.
    lmclim.2 $e |- J = ( TopOpen ` CCfld ) $.
    lmclim.3 $e |- Z = ( ZZ>= ` M ) $.
    $( Relate a limit on the metric space of complex numbers to our complex
       number limit notation.  (Contributed by NM, 9-Dec-2006.)  (Revised by
       Mario Carneiro, 1-May-2014.) $)
    lmclim $p |- ( ( M e. ZZ /\ Z C_ dom F ) ->
                ( F ( ~~>t ` J ) P <-> ( F e. ( CC ^pm CC ) /\ F ~~> P ) ) ) $=
      ( vk vx vj wcel wa cc co cv cfv clt wbr wral crp cz cdm wss cpm cabs cmin
      ccom w3a cuz wrex clm cli 3anass uztrn2 simplr sselda biantrurd wceq eqid
      wb cnmetdval ancoms breq1d pm5.32da ad2antlr bitr3d syl5bb sylan2 anassrs
      ralbidva rexbidva ralbidv anbi2d cnfldtopn cnxmet a1i simpl lmmbr3 simpll
      cxmt simpr eqidd clim2 3bitr4d ) DUAKZEBUBZUCZLZBMMUDNZKZAMKZHOZWFKZWLBPZ
      MKZWNAUEUFUGZNZIOZQRZUHZHJOZUIPZSZJEUJZITSZUHZWJWKWOWNAUFNUEPZWRQRZLZHXBS
      ZJEUJZITSZLZLZBACUKPRWJBAULRZLXFWJWKXELZLWHXNWJWKXEUMWHXPXMWJWHWKXEXLWHWK
      LZXDXKITXQXCXJJEXQXAEKZLWTXIHXBXQXRWLXBKZWTXIUTZXRXSLXQWLEKZXTDWLXAEGUNWT
      WMWOWSLZLZXQYALZXIWMWOWSUMYDYBYCXIYDWMYBXQEWFWLWEWGWKUOUPUQWKYBXIUTWHYAWK
      WOWSXHWKWOLWQXGWRQWOWKWQXGURWNAWPWPUSVAVBVCVDVEVFVGVHVIVJVKVLVDVMVGWHIWPA
      JHBCDMECFVNWPMVTPKWHVOVPGWEWGVQVRWHWJXOXMWHWJLZIAWNJHBDWIEGWEWGWJVSWHWJWA
      YEYALWNWBWCVDWD $.

    $( Relate a limit on the metric space of complex numbers to our complex
       number limit notation.  (Contributed by NM, 24-Jul-2007.)  (Revised by
       Mario Carneiro, 1-May-2014.) $)
    lmclimf $p |- ( ( M e. ZZ /\ F : Z --> CC ) ->
                 ( F ( ~~>t ` J ) P <-> F ~~> P ) ) $=
      ( cz wcel cc wf wa clm cfv wbr cpm co wss cvv cnex cli cdm wceq simpr fdm
      eqimss2 3syl lmclim syldan cuz uzssz zsscn eqsstri elpm2r mpanl12 sylancl
      wb sstri biantrurd bitr4d ) DHIZEJBKZLZBACMNOZBJJPQIZBAUAOZLZVFVAVBEBUBZR
      ZVDVGUQVCVBVHEUCVIVAVBUDZEJBUEEVHUFUGABCDEFGUHUIVCVEVFVCVBEJRZVEVJEDUJNZJ
      GVLHJDUKULURUMJSIZVMVBVKLVETTJJEBSSUNUOUPUSUT $.
  $}

  ${
    $d f k m n D $.  $d f k n J $.  $d f k m n P $.  $d f k m n S $.  $d k V $.
    $d f k n ph $.  $d k X $.
    metelcls.2 $e |- J = ( MetOpen ` D ) $.
    metelcls.3 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    metelcls.5 $e |- ( ph -> S C_ X ) $.
    $( A point belongs to the closure of a subset iff there is a sequence in
       the subset converging to it.  Theorem 1.4-6(a) of [Kreyszig] p. 30.
       This proof uses countable choice ~ ax-cc .  The statement can be
       generalized to first-countable spaces, not just metrizable spaces.
       (Contributed by NM, 8-Nov-2007.)  (Proof shortened by Mario Carneiro,
       1-May-2015.) $)
    metelcls $p |- ( ph -> ( P e. ( ( cls ` J ) ` S ) <->
                     E. f ( f : NN --> S /\ f ( ~~>t ` J ) P ) ) ) $=
      ( c1stc wcel cuni wss ccl cfv cn cv wf syl clm wbr wa wex wb cxmt met1stc
      wceq mopnuni sseqtrd eqid 1stcelcls syl2anc ) AFKLZDFMZNCDFOPPLQDERZSUPCF
      UAPUBUCEUDUEABGUFPLZUNIBFGHUGTADGUOJAUQGUOUHIBFGHUITUJCDEFUOUOUKULUM $.
  $}

  ${
    $d f x D $.  $d f x J $.  $d f x S $.  $d f x X $.
    metcld.2 $e |- J = ( MetOpen ` D ) $.
    $( A subset of a metric space is closed iff every convergent sequence on it
       converges to a point in the subset.  Theorem 1.4-6(b) of [Kreyszig]
       p. 30.  (Contributed by NM, 11-Nov-2007.)  (Revised by Mario Carneiro,
       1-May-2014.) $)
    metcld $p |- ( ( D e. ( *Met ` X ) /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
            A. x A. f ( ( f : NN --> S /\ f ( ~~>t ` J ) x ) -> x e. S ) ) ) $=
      ( cxmt cfv wcel wss wa ccld ccl cn cv wf clm wi wal wbr ctop cuni mopntop
      adantr mopnuni sseq2d biimpa eqid iscld4 syl2anc wex simpl simpr metelcls
      wb imbi1d 19.23v syl6rbbr albidv dfss2 syl6bbr bitr4d ) BFHIJZCFKZLZCEMIJ
      ZCENIIZCKZOCDPZQVJAPZERIUALZVKCJZSDTZATZVFEUBJZCEUCZKZVGVIUPVDVPVEBEFGUDU
      EVDVEVRVDFVQCBEFGUFUGUHCEVQVQUIUJUKVFVOVKVHJZVMSZATVIVFVNVTAVFVTVLDULZVMS
      VNVFVSWAVMVFBVKCDEFGVDVEUMVDVEUNUOUQVLVMDURUSUTAVHCVAVBVC $.

    $( A subset of a metric space is closed iff every convergent sequence on it
       converges to a point in the subset.  Theorem 1.4-6(b) of [Kreyszig]
       p. 30.  (Contributed by Mario Carneiro, 1-May-2014.) $)
    metcld2 $p |- ( ( D e. ( *Met ` X ) /\ S C_ X ) -> ( S e. ( Clsd ` J ) <->
                    ( ( ~~>t ` J ) " ( S ^m NN ) ) C_ S ) ) $=
      ( vf vx cxmt cfv wcel wss wa ccld cn cv wf wi wal wex cvv clm wbr cmap co
      cima metcld 19.23v vex elima2 wb cdm id elfvdm ssexg syl2anr nnex sylancl
      elmapg anbi1d exbidv syl5rbb imbi1d syl5bb albidv dfss2 syl6bbr bitrd ) A
      DHIJZBDKZLZBCMIJNBFOZPZVKGOZCUAIZUBZLZVMBJZQFRZGRZVNBNUCUDZUEZBKZGABFCDEU
      FVJVSVMWAJZVQQZGRWBVJVRWDGVRVPFSZVQQVJWDVPVQFUGVJWEWCVQWCVKVTJZVOLZFSVJWE
      FVMVNVTGUHUIVJWGVPFVJWFVLVOVJBTJZNTJWFVLUJVIVIDHUKZJWHVHVIULADHUMBDWIUNUO
      UPBNVKTTURUQUSUTVAVBVCVDGWABVEVFVG $.
  $}

  ${
    $d k r A $.  $d k n r D $.  $d k n r F $.  $d k r ph $.  $d k n r X $.
    $d k J $.  $d k P $.
    caubl.2 $e |- ( ph -> D e. ( *Met ` X ) ) $.
    caubl.3 $e |- ( ph -> F : NN --> ( X X. RR+ ) ) $.
    caubl.4 $e |- ( ph -> A. n e. NN
      ( ( ball ` D ) ` ( F ` ( n + 1 ) ) ) C_ ( ( ball ` D ) ` ( F ` n ) ) ) $.
    ${
      $d n ph $.
      caubl.5 $e |- ( ph -> A. r e. RR+ E. n e. NN ( 2nd ` ( F ` n ) ) < r ) $.
      $( Sufficient condition to ensure a sequence of nested balls is Cauchy.
         (Contributed by Mario Carneiro, 18-Jan-2014.)  (Revised by Mario
         Carneiro, 1-May-2014.) $)
      caubl $p |- ( ph -> ( 1st o. F ) e. ( Cau ` D ) ) $=
        ( cfv wcel co cn crp wa wss wi wceq fveq2d vk c1st ccom cca clt wbr cuz
        cv wral wrex c2nd c1 caddc fveq2 sseq1d imbi2d cz ssid a1ii nnuz uztrn2
        cbl oveq1 sseq12d rspccva syl2an anassrs syl expcom a2d uzind4 ad2ant2r
        sstr2 com12 cop wrel relxp wf ad3antrrr simplrl ffvelrnd 1st2nd sylancr
        cxp df-ov syl6eqr cxmt cxr cle xp1st xp2nd simpllr simplrr cr rpre ltle
        rpxrd syl2anc mpd syl221anc eqsstrd syl5com simprl sylan blcntr syl3anc
        ssbl eleqtrrd ssel syld wb elbl2 syl22anc sylibd mpdd ralrimiv reximdva
        ex expr ralimdva 1z a1i fvco3 1stcof iscauf mpbird ) AUBDUCZBUDKLCUHZDK
        ZUBKZUAUHZDKZUBKZBMFUHZUEUFZUAYHUGKZUIZCNUJZFOUIZAYIUKKZYNUEUFZCNUJZFOU
        IYSJAUUBYRFOAYNOLZPZUUAYQCNUUDYHNLZUUAYQUUDUUEUUAPZPZYOUAYPUUGYKYPLZYLB
        VBKZKZYIUUIKZQZYOAUUEUUHUULRUUCUUAUUHAUUEPZUULUUMYNDKZUUIKZUUKQZRUUMUUK
        UUKQZRUUMUULRZUUMYKULUMMZDKZUUIKZUUKQZRUURFUAYHYKYNYHSZUUPUUQUUMUVCUUOU
        UKUUKUVCUUNYIUUIYNYHDUNTUOUPYNYKSZUUPUULUUMUVDUUOUUJUUKUVDUUNYLUUIYNYKD
        UNTUOUPZYNUUSSZUUPUVBUUMUVFUUOUVAUUKUVFUUNUUTUUIYNUUSDUNTUOUPUVEYHUQLUU
        MUUQUUKURUSUUHUUMUULUVBUUMUUHUULUVBRZUUMUUHPUVAUUJQZUVGAUUEUUHUVHAYHULU
        MMZDKZUUIKZUUKQZCNUIYKNLZUVHUUEUUHPIULYKYHNUTVAZUVLUVHCYKNYHYKSZUVKUVAU
        UKUUJUVOUVJUUTUUIUVOUVIUUSDYHYKULUMVCTTUVOYIYLUUIYHYKDUNTVDVEVFVGUVAUUJ
        UUKVMVHVIVJVKVNVLUUGUUHUULYORUUGUUHPZUULYMYJYNUUIMZLZYOUVPUULUUJUVQQZUV
        RUVPUUKUVQQUULUVSUVPUUKYJYTUUIMZUVQUVPUUKYJYTVOZUUIKUVTUVPYIUWAUUIUVPEO
        WDZVPZYIUWBLZYIUWASEOVQZUVPNUWBYHDANUWBDVRZUUCUUFUUHHVSZUUDUUEUUAUUHVTW
        AZYIUWBWBWCTYJYTUUIWEWFUVPBEWGKLZYJELZYTWHLYNWHLZYTYNWIUFZUVTUVQQAUWIUU
        CUUFUUHGVSZUVPUWDUWJUWHYIEOWJVHZUVPYTUVPUWDYTOLZUWHYIEOWKVHZWQUVPYNAUUC
        UUFUUHWLZWQZUVPUUAUWLUUDUUEUUAUUHWMUVPUWOUUCUUAUWLRZUWPUWQUWOYTWNLYNWNL
        UWSUUCYTWOYNWOYTYNWPVFWRWSBYJYTYNEXGWTXAUUJUUKUVQVMXBUVPYMUUJLUVSUVRUVP
        YMYMYLUKKZUUIMZUUJUVPUWIYMELZUWTOLZYMUXALUWMUVPYLUWBLZUXBUVPNUWBYKDUWGU
        UGUUEUUHUVMUUDUUEUUAXCUVNXDWAZYLEOWJVHZUVPUXDUXCUXEYLEOWKVHBYMUWTEXEXFU
        VPUUJYMUWTVOZUUIKUXAUVPYLUXGUUIUVPUWCUXDYLUXGSUWEUXEYLUWBWBWCTYMUWTUUIW
        EWFXHUUJUVQYMXIXBXJUVPUWIUWKUWJUXBUVRYOXKUWMUWRUWNUXFYMBYJYNEXLXMXNXRXO
        XPXSXQXTWSAFYMYJBCUAYGULENUTGULUQLAYAYBAUWFUVMYKYGKYMSHNUWBYKUBDYCXDAUW
        FUUEYHYGKYJSHNUWBYHUBDYCXDAUWFNEYGVRHNEODYDVHYEYF $.
    $}

    caublcls.6 $e |- J = ( MetOpen ` D ) $.
    $( The convergent point of a sequence of nested balls is in the closures of
       any of the balls (i.e. it is in the intersection of the closures).
       Indeed, it is the only point in the intersection because a metric space
       is Hausdorff, but we don't prove this here.  (Contributed by Mario
       Carneiro, 21-Jan-2014.)  (Revised by Mario Carneiro, 1-May-2014.) $)
    caublcls $p |- ( ( ph /\ ( 1st o. F ) ( ~~>t ` J ) P /\ A e. NN ) ->
                     P e. ( ( cls ` J ) ` ( ( ball ` D ) ` ( F ` A ) ) ) ) $=
      ( cfv cn wcel syl wss wceq fveq2d crp vk vr c1st ccom clm wbr w3a cbl cuz
      eqid cxmt ctopon 3ad2ant1 mopntopon simp3 nnzd simp2 cv wa wi c1 caddc co
      fveq2 sseq1d imbi2d cz ssid a1ii wral uztrn2 oveq1 sseq12d rspccva syl2an
      nnuz anassrs sstr2 expcom a2d uzind4 impcom 3adantl2 adantr cxp wf simpl1
      sylan ffvelrnd xp1st xp2nd blcntr syl3anc fvco3 syl2anc cop 1st2nd2 df-ov
      c2nd syl6eqr 3eltr4d sseldd ffvelrnda 3adant2 rpxrd blssm eqsstrd lmcls
      cxr ) AUCFUDZDGUEMUFZBNOZUGZDBFMZCUHMZMZUAXJGBHBUIMZXQUJXMCHUKMOZGHULMOAX
      KXRXLIUMZCGHLUNPXMBAXKXLUOZUPAXKXLUQXMUAURZXQOZUSZYAFMZXOMZXPYAXJMZAXLYBY
      EXPQZXKYBAXLUSZYGYHUBURZFMZXOMZXPQZUTYHXPXPQZUTYHYGUTZYHYAVAVBVCZFMZXOMZX
      PQZUTYNUBUABYAYIBRZYLYMYHYSYKXPXPYSYJXNXOYIBFVDSVEVFYIYARZYLYGYHYTYKYEXPY
      TYJYDXOYIYAFVDSVEVFZYIYORZYLYRYHUUBYKYQXPUUBYJYPXOYIYOFVDSVEVFUUABVGOYHYM
      XPVHVIYBYHYGYRYHYBYGYRUTZYHYBUSYQYEQZUUCAXLYBUUDAEURZVAVBVCZFMZXOMZUUEFMZ
      XOMZQZENVJYANOZUUDXLYBUSKVAYABNVPVKZUUKUUDEYANUUEYARZUUHYQUUJYEUUNUUGYPXO
      UUNUUFYOFUUEYAVAVBVLSSUUNUUIYDXOUUEYAFVDSVMVNVOVQYQYEXPVRPVSVTWAWBWCYCYDU
      CMZUUOYDWSMZXOVCZYFYEYCXRUUOHOZUUPTOZUUOUUQOXMXRYBXSWDYCYDHTWEZOZUURYCNUU
      TYAFYCANUUTFWFZAXKXLYBWGJPZXMXLYBUULXTUUMWHZWIZYDHTWJPYCUVAUUSUVEYDHTWKPC
      UUOUUPHWLWMYCUVBUULYFUUORUVCUVDNUUTYAUCFWNWOYCYEUUOUUPWPZXOMUUQYCYDUVFXOY
      CUVAYDUVFRUVEYDHTWQPSUUOUUPXOWRWTXAXBXMXPXNUCMZXNWSMZXOVCZHXMXPUVGUVHWPZX
      OMUVIXMXNUVJXOXMXNUUTOZXNUVJRAXLUVKXKANUUTBFJXCXDZXNHTWQPSUVGUVHXOWRWTXMX
      RUVGHOZUVHXIOUVIHQXSXMUVKUVMUVLXNHTWJPXMUVHXMUVKUVHTOUVLXNHTWKPXECUVGUVHH
      XFWMXGXH $.
  $}

  ${
    $d f k n x y C $.  $d f k n x y D $.  $d f k n x y F $.  $d f k n x y P $.
    $d f n x y J $.  $d f k n x ph $.  $d f k n x y X $.  $d f k n x y Y $.
    $d f k n x K $.
    metcnp4.3 $e |- J = ( MetOpen ` C ) $.
    metcnp4.4 $e |- K = ( MetOpen ` D ) $.
    metcnp4.5 $e |- ( ph -> C e. ( *Met ` X ) ) $.
    metcnp4.6 $e |- ( ph -> D e. ( *Met ` Y ) ) $.
    ${
      metcnp4.7 $e |- ( ph -> P e. X ) $.
      $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
         continuous at point ` P ` .  Theorem 14-4.3 of [Gleason] p. 240.
         (Contributed by NM, 17-May-2007.)  (Revised by Mario Carneiro,
         4-May-2014.) $)
      metcnp4 $p |- ( ph -> ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y /\
                      A. f ( ( f : NN --> X /\ f ( ~~>t ` J ) P ) ->
                             ( F o. f ) ( ~~>t ` K ) ( F ` P ) ) ) ) ) $=
        ( cxmt cfv wcel syl ctopon c1stc met1stc mopntopon 1stccnp ) ADEFGHIJAB
        IPQRZGUARMBGIKUBSAUEGITQRMBGIKUCSACJPQRHJTQRNCHJLUCSOUD $.
    $}

    metcn4.7 $e |- ( ph -> F : X --> Y ) $.
    $( Two ways to say a mapping from metric ` C ` to metric ` D ` is
       continuous.  Theorem 10.3 of [Munkres] p. 128.  (Contributed by NM,
       13-Jun-2007.)  (Revised by Mario Carneiro, 4-May-2014.) $)
    metcn4 $p |- ( ph -> ( F e. ( J Cn K ) <-> A. f ( f : NN --> X ->
        A. x ( f ( ~~>t ` J ) x -> ( F o. f ) ( ~~>t ` K ) ( F ` x ) ) ) ) ) $=
      ( cxmt cfv wcel syl ctopon c1stc met1stc mopntopon 1stccn ) ABEFGHIJACIPQ
      RZGUARMCGIKUBSAUEGITQRMCGIKUCSADJPQRHJTQRNDHJLUCSOUD $.
  $}

  ${
    $d f D $.  $d f J $.  $d f X $.
    iscmet3i.2 $e |- J = ( MetOpen ` D ) $.
    iscmet3i.3 $e |- D e. ( Met ` X ) $.
    iscmet3i.4 $e |- ( ( f e. ( Cau ` D ) /\ f : NN --> X ) ->
                      f e. dom ( ~~>t ` J ) ) $.
    $( Properties that determine a complete metric space.  (Contributed by NM,
       15-Apr-2007.)  (Revised by Mario Carneiro, 5-May-2014.) $)
    iscmet3i $p |- D e. ( CMet ` X ) $=
      ( cms cfv wcel cn cv wf clm cdm wi cca wtru c1 a1i wral wb nnuz cz 1z cme
      iscmet3 trud ex mprgbir ) ADHIJZKDBLZMZULCNIOJZPZBAQIZUKUOBUPUAUBRABCSDKU
      CESUDJRUETADUFIJRFTUGUHULUPJUMUNGUIUJ $.
  $}

  ${
    $d x y A $.  $d f j u x y D $.  $d f j u x y J $.  $d f j u x y X $.
    $d x y F $.
    lmcau.1 $e |- J = ( MetOpen ` D ) $.
    $( Every convergent sequence in a metric space is a Cauchy sequence.
       Theorem 1.4-5 of [Kreyszig] p. 28.  (Contributed by NM, 29-Jan-2008.)
       (Proof shortened by Mario Carneiro, 5-May-2014.) $)
    lmcau $p |- ( D e. ( *Met ` X ) -> dom ( ~~>t ` J ) C_ ( Cau ` D ) ) $=
      ( vj vx vu vy cfv wcel cv wb wa co cuz wf cz wrex crp wceq vf clm cdm cca
      cxmt wbr cha wfun methaus lmfun funfvbrb 3syl cc cpm cbl cres wral crn id
      w3a lmmbr biimpa simp1d cdiv rphalfcl simp3d oveq2 feq3 syl rexbidv rspcv
      c2 syl2im impcom cpw wfn uzf ffn reseq2 feq12d rexrn mp2b sylib simprr cr
      wss simplll simp2d ad2antrr rpre ad2antlr uzid ad2antrl ffvelrnd eqeltrrd
      fvres blhalf syl22anc fss syl2anc expr reximdva ralrimiva iscau mpbir2and
      mpd adantr ex sylbid ssrdv ) ACUEIJZUABUBIZUCZAUDIZXKUAKZXMJZXOXOXLIZXLUF
      ZXOXNJZXKBUGJXLUHXPXRLABCDUIBUJXOXLUKULXKXRXSXKXRMZXSXOCUMUNNJZEKZOIZYBXO
      IZFKZAUOIZNZXOYCUPZPZEQRZFSUQZXTYAXQCJZGKZXQHKZYFNZXOYMUPZPZGOURZRZHSUQZX
      KXRYAYLYTUTXKHGAXQXOBCDXKUSVAVBZVCXTYJFSXTYESJZMZYCXQYEVLVDNZYFNZYHPZEQRZ
      YJUUCYMUUEYPPZGYRRZUUGUUBXTUUIUUBUUDSJXTYTUUIYEVEXTYAYLYTUUAVFYSUUIHUUDSY
      NUUDTZYQUUHGYRUUJYOUUETYQUUHLYNUUDXQYFVGYOUUEYMYPVHVIVJVKVMVNQQVOZOPOQVPU
      UIUUGLVQQUUKOVRUUHUUFGEQOYMYCTZYMYCUUEYPYHYMYCXOVSUULUSVTWAWBWCUUCUUFYIEQ
      UUCYBQJZUUFYIUUCUUMUUFMZMZUUFUUEYGWFZYIUUCUUMUUFWDZUUOXKYLYEWEJZYDUUEJUUP
      XKXRUUBUUNWGXTYLUUBUUNXTYAYLYTUUAWHWIUUBUURXTUUNYEWJWKUUOYBYHIZYDUUEUUOYB
      YCJZUUSYDTUUMUUTUUCUUFYBWLWMZYBYCXOWPVIUUOYCUUEYBYHUUQUVAWNWOYEACXQYDWQWR
      YCUUEYGYHWSWTXAXBXFXCXKXSYAYKMLXRFAEXOCXDXGXEXHXIXJ $.

    $( Every convergent filter in a metric space is a Cauchy filter.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    flimcfil $p |- ( ( D e. ( *Met ` X ) /\ A e. ( J fLim F ) ) ->
      F e. ( CauFil ` D ) ) $=
      ( vy vx cfv wcel co wa cfil cv crp adantl wceq adantr eleqtrrd syl3anc wb
      cxmt cflim ccfil cbl wrex wral cuni eqid flimfil mopnuni fveq2d flimelbas
      ad2antlr ad2antrr cnei simplr ctop mopntop simpll rpxr blopn simpr blcntr
      csn cxr opnneip flimnei syl2anc eleq1d rspcev ralrimiva iscfil3 mpbir2and
      oveq1 ) BEUBIJZADCUCKJZLZCBUDIJZCEMIZJZGNZHNZBUEIZKZCJZGEUFZHOUGZVRCDUHZM
      IZVTVQCWJJVPACDWIWIUIZUJPVREWIMVPEWIQZVQBDEFUKZRULSVRWGHOVRWCOJZLZAEJZAWC
      WDKZCJZWGWOAWIEVQAWIJVPWNACDWIWKUMUNVPWLVQWNWMUOSZWOVQWQAVEDUPIIJZWRVPVQW
      NUQWODURJZWQDJZAWQJZWTVPXAVQWNBDEFUSUOWOVPWPWCVFJZXBVPVQWNUTZWSWNXDVRWCVA
      PBAWCDEFVBTWOVPWPWNXCXEWSVRWNVCBAWCEVDTADWQVGTACDWQVHVIWFWRGAEWBAQWEWQCWB
      AWCWDVOVJVKVIVLVPVSWAWHLUAVQGBCEHVMRVN $.
  $}

  ${
    $d f x D $.  $d f x J $.  $d f x X $.  $d f x Y $.
    cmetss.2 $e |- J = ( MetOpen ` D ) $.
    $( A subspace of a complete metric space is complete iff it is closed in
       the parent space.  Theorem 1.4-7 of [Kreyszig] p. 30.  (Contributed by
       NM, 28-Jan-2008.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
    cmetss $p |- ( D e. ( CMet ` X ) ->
      ( ( D |` ( Y X. Y ) ) e. ( CMet ` Y ) <-> Y e. ( Clsd ` J ) ) ) $=
      ( vx vf cfv wcel wa wss cflim co syl adantr cdm wceq syl2anc c0 syl3anc
      cms cxp cres ccld ccl cfil wrex ctopon cxmt cme cmetmet metxmet mopntopon
      cv wb resss dmss metdmdm sseq12 syl2anr mpbiri flimcls simprrr wmo wex wi
      mp2b cha methaus hausflimi 3syl cin wne cmopn crest simprrl flimrest eqid
      simprl metrest oveq1d eqtr3d ccfil flimcfil cfilres mpbid cmetcvg eqnetrd
      simplr n0 elin exbii bitri sylib mopick rexlimdvaa sylbid ssrdv ctop cuni
      mpd mopntop mopnuni sseqtrd iscld4 mpbird wral cldss sseqtr4d metres2 cfg
      adantl ad2antrr eqcomd cfilfil sylan elfvdm oveq12d cfbas filfbas filsspw
      trfg cpw sspwb sstrd fbasweak fgcl filtop sseldd flimclsi cldcls ad2antlr
      ssfg df-ss 3eqtrd simpll cfilresi ralrimiva iscmet sylanbrc impbida ) ACU
      AHIZADDUBZUCZDUAHIZDBUDHIZUUBUUEJZUUFDBUEHHZDKZUUGFUUHDUUGFUNZUUHIZDGUNZI
      ZUUJBUULLMZIZJZGCUFHZUGZUUJDIZUUGBCUHHIZDCKZUUKUURUOUUGACUIHIZUUTUUBUVBUU
      EUUBACUJHIZUVBACUKZACULZNZOZABCEUMZNUUGUVAUUDPZPZAPZPZKZUUDAKUVIUVKKUVMAU
      UCUPUUDAUQUVIUVKUQVGUUEDUVJQZCUVLQZUVAUVMUOUUBUUEUUDDUJHIZUVNUUDDUKUUDDUR
      NUUBUVCUVOUVDACURNDUVJCUVLUSUTVAZUUJDGBCVBRUUGUUPUUSGUUQUUGUULUUQIZUUPJZJ
      ZUUOUUSUUGUVRUUMUUOVCZUVTUUOFVDZUUOUUSJZFVEZUUOUUSVFUVTUVBBVHIUWBUUGUVBUV
      SUVGOZABCEVIFUULBVJVKUVTUUNDVLZSVMZUWDUVTUWFUUDVNHZUULDVOMZLMZSUVTBDVOMZU
      WILMZUWFUWJUVTUUTUVRUUMUWLUWFQUVTUVBUUTUWEUVHNUUGUVRUUPVSZUUGUVRUUMUUOVPZ
      UULBCDVQTUVTUWKUWHUWILUVTUVBUVAUWKUWHQZUWEUUGUVAUVSUVQOAUUDBUWHCDUUDVREUW
      HVRZVTZRWAWBUVTUUEUWIUUDWCHZIZUWJSVMUUBUUEUVSWIUVTUULAWCHZIZUWSUVTUVBUUOU
      XAUWEUWAUUJAUULBCEWDRUVTUVBUVRUUMUXAUWSUOUWEUWMUWNAUULCDWETWFUUDUWIUWHDUW
      PWGRWHUWGUUJUWFIZFVEUWDFUWFWJUXBUWCFUUJUUNDWKWLWMWNUUOUUSFWORXAWPWQWRUUGB
      WSIZDBWTZKZUUFUUIUOUUGUVBUXCUVGABCEXBNUUGDCUXDUVQUUGUVBCUXDQZUVGABCEXCZNX
      DDBUXDUXDVRZXERXFUUBUUFJZUVPUWHUULLMZSVMZGUWRXGUUEUXIUVCUVAUVPUUBUVCUUFUV
      DOZUXIDUXDCUUFUXEUUBDBUXDUXHXHXLUXIUVCUVBUXFUXLUVEUXGVKXIZADCXJRZUXIUXKGU
      WRUXIUULUWRIZJZUXJBCUULXKMZLMZSUXPUXJUWKUXQDVOMZLMZUXRDVLZUXRUXPUWHUWKUUL
      UXSLUXPUWKUWHUXPUVBUVAUWOUUBUVBUUFUXOUVFXMZUXIUVAUXOUXMOZUWQRXNUXPUXSUULU
      XPUULDUFHIZUVACUAPZIZUXSUULQUXIUUDDUIHIZUXOUYDUXIUVPUYGUXNUUDDULNUUDUULDX
      OXPZUYCUUBUYFUUFUXOACUAXQXMZDUULUYECYBTXNXRUXPUUTUXQUUQIZDUXQIZUXTUYAQUXP
      UVBUUTUYBUVHNUXPUULCXSHIZUYJUXPUULDXSHIZUULCYCZKUYFUYLUXPUYDUYMUYHUULDXTN
      UXPUULDYCZUYNUXPUYDUULUYOKUYHUULDYANUXPUVAUYOUYNKUYCDCYDWNYEUYIUULUYEDCYF
      TZUULCYGNUXPUULUXQDUXPUYLUULUXQKUYPUULCYMNUXPUYDUUMUYHUULDYHNYIZUXQBCDVQT
      UXPUXRDKUYAUXRQUXPUXRUUHDUXPUYKUXRUUHKUYQDUXQBYJNUUFUUHDQUUBUXODBYKYLXDUX
      RDYNWNYOUXPUUBUXQUWTIZUXRSVMUUBUUFUXOYPUXIUVBUXOUYRUXIUVCUVBUXLUVENAUULCD
      YQXPAUXQBCEWGRWHYRUUDGUWHDUWPYSYTUUA $.
  $}

  ${
    $d f x y C $.  $d f x y D $.  $d f x y ph $.  $d x y R $.  $d f x y X $.
    $d x y S $.
    equivcmet.1 $e |- ( ph -> C e. ( Met ` X ) ) $.
    equivcmet.2 $e |- ( ph -> D e. ( Met ` X ) ) $.
    equivcmet.3 $e |- ( ph -> R e. RR+ ) $.
    equivcmet.4 $e |- ( ph -> S e. RR+ ) $.
    equivcmet.5 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x C y ) <_ ( R x. ( x D y ) ) ) $.
    equivcmet.6 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x D y ) <_ ( S x. ( x C y ) ) ) $.
    $( If two metrics are strongly equivalent, one is complete iff the other
       is.  Unlike ~ equivcau , ~ metss2 , this theorem does not have a
       one-directional form - it is possible for a metric ` C ` that is
       strongly finer than the complete metric ` D ` to be incomplete and vice
       versa.  Consider ` D = ` the metric on ` RR ` induced by the usual
       homeomorphism from ` ( 0 , 1 ) ` against the usual metric ` C ` on
       ` RR ` and against the discrete metric ` E ` on ` RR ` .  Then both
       ` C ` and ` E ` are complete but ` D ` is not, and ` C ` is strongly
       finer than ` D ` , which is strongly finer than ` E ` .  (Contributed by
       Mario Carneiro, 15-Sep-2015.) $)
    equivcmet $p |- ( ph -> ( C e. ( CMet ` X ) <-> D e. ( CMet ` X ) ) ) $=
      ( vf cfv wcel cmopn cflim c0 cme cv co wne ccfil wral cms equivcfil eqssd
      wa 2thd eqid metss2 oveq1d neeq1d raleqbidv anbi12d iscmet 3bitr4g ) ADHU
      APZQZDRPZOUBZSUCZTUDZODUEPZUFZUJEUTQZERPZVCSUCZTUDZOEUEPZUFZUJDHUGPZQEVNQ
      AVAVHVGVMAVAVHIJUKAVEVKOVFVLAVFVLABCEDGHJILNUHABCDEFHIJKMUHUIAVDVJTAVBVIV
      CSAVBVIABCDEFVBVIHVBULZVIULZIJKMUMABCEDGVIVBHVPVOJILNUMUIUNUOUPUQDOVBHVOU
      REOVIHVPURUS $.
  $}

  ${
    $d f x D $.  $d f x J $.  $d f x ph $.  $d x R $.  $d f x X $.
    relcmpcmet.1 $e |- J = ( MetOpen ` D ) $.
    relcmpcmet.2 $e |- ( ph -> D e. ( Met ` X ) ) $.
    ${
      relcmpcmet.3 $e |- ( ph -> R e. RR+ ) $.
      relcmpcmet.4 $e |- ( ( ph /\ x e. X ) ->
        ( J |`t ( ( cls ` J ) ` ( x ( ball ` D ) R ) ) ) e. Comp ) $.
      $( If ` D ` is a metric space such that all the balls of some fixed size
         are relatively compact, then ` D ` is complete.  (Contributed by Mario
         Carneiro, 15-Oct-2015.) $)
      relcmpcmet $p |- ( ph -> D e. ( CMet ` X ) ) $=
        ( vf cfv wcel co wa syl wss cfil wceq syl2anc cme cv cflim c0 wne ccfil
        wral cms cbl cxmt crp wrex metxmet adantr simpr syl3anc ccl crest cfcls
        cfil3i cin ctopon ad2antrr mopntopon cfilfil sylan simprr cuni topontop
        ctop cxr simprl rpxrd blssm toponuni sseqtrd eqid clsss3 sseqtr4d sscls
        filss syl13anc fclsrest cdm cfilfcls ad2antlr syl5sseq eqsstrd ad2ant2r
        inss1 ccmp cdif wn cfbas filfbas trfil3 mpbird resttopon fveq2d eleqtrd
        fbncp wb fclscmpi ssn0 rexlimddv ralrimiva iscmet sylanbrc ) ACFUALMZEK
        UBZUCNZUDUEZKCUFLZUGCFUHLMHAXLKXMAXJXMMZOZBUBZDCUILNZXJMZXLBFXOCFUJLMZX
        NDUKMZXRBFULAXSXNAXIXSHCFUMPZUNAXNUOAXTXNIUNBCDXJFUTUPXOXPFMZXROZOZEXQE
        UQLLZURNZXJYEURNZUSNZXKQYHUDUEZXLYDYHEXJUSNZYEVAZXKYDEFVBLMZXJFRLMZYEXJ
        MZYHYKSYDXSYLAXSXNYCYAVCZCEFGVDPZXOYMYCAXSXNYMYACXJFVEVFUNZYDYMXRYEFQZX
        QYEQZYNYQXOYBXRVGYDYEEVHZFYDEVJMZXQYTQZYEYTQYDYLUUAYPFEVIPZYDXQFYTYDXSY
        BDVKMZXQFQYOXOYBXRVLAUUDXNYCADIVMVCCXPDFVNUPYDYLFYTSYPFEVOPZVPZXQEYTYTV
        QZVRTUUEVSZYDUUAUUBYSUUCUUFXQEYTUUGVTTXQYEXJFWAWBZXJEFYEWCUPYDYJYKXKYJY
        EWJXNYJXKSAYCCXJECWDWDZGUUJVQWEWFWGWHYDYFWKMZYGYFVHZRLZMYIAYBUUKXNXRJWI
        YDYGYERLZUUMYDYGUUNMZFYEWLXJMWMZYDXJFWNLMZYNUUPYDYMUUQYQXJFWOPUUIYEFXJF
        XATYDYMYRUUOUUPXBYQUUHYEXJFWPTWQYDYEUULRYDYFYEVBLMZYEUULSYDYLYRUURYPUUH
        YEEFWRTYEYFVOPWSWTYGYFUULUULVQXCTYHXKXDTXEXFCKEFGXGXH $.
    $}

    cmpcmet.3 $e |- ( ph -> J e. Comp ) $.
    $( A compact metric space is complete.  One half of ~ heibor .
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    cmpcmet $p |- ( ph -> D e. ( CMet ` X ) ) $=
      ( vx c1 crp wcel 1rp a1i ccmp cfv co adantr wss syl syl2anc cv wa cbl ccl
      ccld crest ctop cuni cxmt cme metxmet mopntop cxr simpr rpxr mp1i syl3anc
      blssm wceq mopnuni sseqtrd eqid clscld cmpcld relcmpcmet ) AHBICDEFIJKZAL
      MAHUAZDKZUBZCNKZVGIBUCOPZCUDOOZCUEOKZCVLUFPNKAVJVHGQVICUGKZVKCUHZRVMVIBDU
      IOKZVNAVPVHABDUJOKVPFBDUKSQZBCDEULSVIVKDVOVIVPVHIUMKZVKDRVQAVHUNVFVRVILIU
      OUPBVGIDURUQVIVPDVOUSVQBCDEUTSVAVKCVOVOVBVCTVLCVDTVE $.
  $}

  ${
    $d x y C $.  $d x y D $.  $d x y X $.
    $( Given a metric ` D ` and a uniform structure generated by that metric,
       Cauchy filter bases on that uniform structure are exactly the Cauchy
       filters for the metric.  (Contributed by Thierry Arnoux,
       15-Dec-2017.) $)
    cfilucfil3OLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) -> (
      ( C e. ( Fil ` X ) /\ C e. ( CauFilU ` ( metUnifOLD ` D ) ) )
      <-> C e. ( CauFil ` D ) ) ) $=
      ( vy vx c0 wne cxmt cfv wcel wa cfil cmetuOLD ccfilu cv cxp cima cc0 cico
      co wss wrex ccfil cfbas cfilucfil2OLD anbi2d filfbas pm4.71i anbi1i anass
      crp wral bitr2i syl6bb wb iscfil adantl bitr4d ) CFGZBCHIJZKZACLIJZABMINI
      JZKZVBBDOZVEPQREOSTUADAUBEUKULZKZABUCIJZVAVDVBACUDIJZVFKZKZVGVAVCVJVBEDAB
      CUEUFVGVBVIKZVFKVKVBVLVFVBVIACUGUHUIVBVIVFUJUMUNUTVHVGUOUSEDBACUPUQUR $.

    $( Given a metric ` D ` and a uniform structure generated by that metric,
       Cauchy filter bases on that uniform structure are exactly the Cauchy
       filters for the metric.  (Contributed by Thierry Arnoux, 15-Dec-2017.)
       (Revised by Thierry Arnoux, 11-Feb-2018.) $)
    cfilucfil3 $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) ) -> (
      ( C e. ( Fil ` X ) /\ C e. ( CauFilU ` ( metUnif ` D ) ) )
      <-> C e. ( CauFil ` D ) ) ) $=
      ( vy vx c0 wne cxmt cfv wcel wa cfil cmetu ccfilu cv cxp cima cc0 cico wb
      wss wrex crp wral ccfil cpsmet xmetpsmet cfbas cfilucfil2 filfbas pm4.71i
      co anbi2d anbi1i anass bitr2i syl6bb sylan2 iscfil adantl bitr4d ) CFGZBC
      HIJZKACLIJZABMINIJZKZVDBDOZVGPQREOSULUADAUBEUCUDZKZABUEIJZVCVBBCUFIJZVFVI
      TBCUGVBVKKZVFVDACUHIJZVHKZKZVIVLVEVNVDEDABCUIUMVIVDVMKZVHKVOVDVPVHVDVMACU
      JUKUNVDVMVHUOUPUQURVCVJVITVBEDBACUSUTVA $.
  $}

  $( Given a metric ` D ` and a uniform structure generated by that metric,
     Cauchy filter bases on that uniform structure are exactly the Cauchy
     filters for the metric.  (Contributed by Thierry Arnoux, 15-Dec-2017.) $)
  cfilucfil4OLD $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) /\ C e. ( Fil ` X ) )
    -> ( C e. ( CauFilU ` ( metUnifOLD ` D ) ) <-> C e. ( CauFil ` D ) ) ) $=
    ( c0 wne cxmt cfv wcel cmetuOLD ccfilu ccfil wb wa wi cfilucfil3OLD cfilfil
    cfil ex adantl pm4.71rd bitrd pm5.32 sylibr 3impia ) CDEZBCFGHZACQGHZABIGJG
    HZABKGHZLZUEUFMZUGUHMZUGUIMZLUGUJNUKULUIUMABCOUKUIUGUFUIUGNUEUFUIUGBACPRSTU
    AUGUHUIUBUCUD $.

  $( Given a metric ` D ` and a uniform structure generated by that metric,
     Cauchy filter bases on that uniform structure are exactly the Cauchy
     filters for the metric.  (Contributed by Thierry Arnoux, 15-Dec-2017.)
     (Revised by Thierry Arnoux, 11-Feb-2018.) $)
  cfilucfil4 $p |- ( ( X =/= (/) /\ D e. ( *Met ` X ) /\ C e. ( Fil ` X ) )
    -> ( C e. ( CauFilU ` ( metUnif ` D ) ) <-> C e. ( CauFil ` D ) ) ) $=
    ( c0 wne cxmt cfv wcel cfil cmetu ccfilu ccfil wb cfilucfil3 cfilfil adantl
    wa wi ex pm4.71rd bitrd pm5.32 sylibr 3impia ) CDEZBCFGHZACIGHZABJGKGHZABLG
    HZMZUEUFQZUGUHQZUGUIQZMUGUJRUKULUIUMABCNUKUIUGUFUIUGRUEUFUIUGBACOSPTUAUGUHU
    IUBUCUD $.

  ${
    $d r x y D $.
    cncmet.1 $e |- D = ( abs o. - ) $.
    $( The set of complex numbers is a complete metric space under the absolute
       value metric.  (Contributed by NM, 20-Dec-2006.)  (Revised by Mario
       Carneiro, 15-Oct-2015.) $)
    cncmet $p |- D e. ( CMet ` CC ) $=
      ( vy vr cc cfv wcel wtru c1 cabs cmin cmopn a1i cv co cle wbr cr wss wa
      vx cms ccnfld ctopn ccom eqid cnfldtopn fveq2i eqtr4i cme eqeltri crp 1rp
      cnmet cbl ccl crest ccmp ccld wral wrex ctop cnfldtop cxmt cxr ax-mp rpxr
      metxmet blssm mp3an13 cnfldtopon toponunii clscld sylancr caddc abscl syl
      peano2re crab df-rab eqcomi blcls ad2antrl adantr resubcld simpl id subcl
      cab syl2anr abscld 1re simprl abs2difd wceq cnmetdval abssub eqtrd simprr
      adantrr eqbrtrrd letrd lesubadd2d mpbid ss2abdv sstrd ssabral sylib breq2
      ex ralbidv rspcev syl2anc wb clsss3 cnheibor mpbir2and adantl relcmpcmet
      trud ) AEUBFGHUAAIUCUDFZEYAJKUEZLFALFYAYAUFZUGAYBLBUHUIZAEUJFZGZHAYBYEBUN
      UKZMIULGZHUMMUANZEGZYAYIIAUOFOZYAUPFFZUQOZURGZHYJYNYLYAUSFGZCNZJFZDNZPQZC
      YLUTZDRVAZYJYAVBGZYKESZYOYAYCVCZAEVDFGZYJIVEGZUUCYFUUEYGAEVHVFZYHUUFUMIVG
      VFZAYIIEVIVJZYKYAEEYAYAYCVKVLZVMVNYJYIJFZIVOOZRGZYQUULPQZCYLUTZUUAYJUUKRG
      ZUUMYIVPZUUKVRVQYJYLUUNCWIZSUUOYJYLYPEGZYIYPAOZIPQZTZCWIZUURUUEYJUUFYLUVC
      SUUGUUHCAYIIUVCYAEYDUVACEVSUVCUVACEVTWAWBVJYJUVBUUNCYJUVBUUNYJUVBTZYQUUKK
      OZIPQUUNUVDUVEYPYIKOZJFZIUVDYQUUKUUSYQRGYJUVAYPVPWCZYJUUPUVBUUQWDZWEUVDUV
      FUVBUUSYJUVFEGYJUUSUVAWFYJWGYPYIWHWJWKIRGUVDWLMZUVDYPYIYJUUSUVAWMYJUVBWFW
      NUVDUUTUVGIPYJUUSUUTUVGWOUVAYJUUSTUUTYIYPKOJFUVGYIYPABWPYIYPWQWRWTYJUUSUV
      AWSXAXBUVDYQUUKIUVHUVIUVJXCXDXJXEXFUUNCYLXGXHYTUUODUULRYRUULWOYSUUNCYLYRU
      ULYQPXIXKXLXMYJYLESZYNYOUUATXNYJUUBUUCUVKUUDUUIYKYAEUUJXOVNCYMYAYLDYCYMUF
      XPVQXQXRXSXT $.
  $}

  $( The real numbers are a complete metric space.  (Contributed by Jeff
     Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro, 12-Sep-2015.) $)
  recmet $p |- ( ( abs o. - ) |` ( RR X. RR ) ) e. ( CMet ` RR ) $=
    ( cabs cmin ccom cxp cres cms cfv wcel ccnfld ctopn ccld eqid recld2 cncmet
    cr cc wb cnfldtopn cmetss ax-mp mpbir ) ABCZOODEOFGHZOIJGZKGHZUDUDLZMUBPFGH
    UCUEQUBUBLNUBUDPOUDUFRSTUA $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Baire's Category Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n r x z A $.  $d k r x z B $.  $d r x C $.  $d g k m n r x y z D $.
    $d g k n r x z F $.  $d g k m n r x y z J $.  $d g k m n r x y z M $.
    $d k m n r x z ph $.  $d x R $.  $d g k m n r x y z X $.
    bcth.2 $e |- J = ( MetOpen ` D ) $.
    ${
      bcthlem.4 $e |- ( ph -> D e. ( CMet ` X ) ) $.
      bcthlem.5 $e |- F = ( k e. NN , z e. ( X X. RR+ ) |->
           { <. x , r >. | ( ( x e. X /\ r e. RR+ ) /\ ( r < ( 1 / k ) /\
             ( ( cls ` J ) ` ( x ( ball ` D ) r ) ) C_
               ( ( ( ball ` D ) ` z ) \ ( M ` k ) ) ) ) } ) $.
      $( Lemma for ~ bcth .  Substitutions for the function ` F ` .
         (Contributed by Mario Carneiro, 9-Jan-2014.) $)
      bcthlem1 $p |- ( ( ph /\ ( A e. NN /\ B e. ( X X. RR+ ) ) ) ->
         ( C e. ( A F B ) <-> ( C e. ( X X. RR+ ) /\ ( 2nd ` C ) < ( 1 / A ) /\
           ( ( cls ` J ) ` ( ( ball ` D ) ` C ) ) C_
             ( ( ( ball ` D ) ` B ) \ ( M ` A ) ) ) ) ) $=
        ( wcel crp wa cfv cn cxp co cv cdiv clt wbr cbl ccl cdif wss copab c2nd
        c1 w3a wceq cvv opabssxp cms cdm elfvdm syl cr reex ssexi xpexg sylancl
        rpssre ssexg sylancr oveq2 breq2d fveq2 difeq2d sseq2d anbi12d opabbidv
        anbi2d difeq1d ovmpt2g syl3an3 3expa ancoms eleq2d sseli simp1 c1st cop
        1st2nd2 eleq1d fvex eleq1 bi2anan9 simpr breq1d oveq12 fveq2d opelopaba
        sseq1d syl6bb opelxp syl6rbb df-ov syl6reqr 3anass syl6bbr pm5.21nii
        bitrd ) ADUAQZELRUBZQZSZSZFDEIUCZQFBUDZLQZMUDZRQZSZXQUNDUEUCZUFUGZXOXQG
        UHTZUCZJUITZTZEYBTZDKTZUJZUKZSZSZBMULZQZFXJQZFUMTZXTUFUGZFYBTZYDTZYHUKZ
        UOZXMXNYLFXLAXNYLUPZXIXKAUUAAXIXKYLUQQZUUAAYLXJUKXJUQQZUUBYJBMLRURZALUS
        UTZQZRUQQUUCAGLUSTQUUFOGLUSVAVBRVCVDVHVELRUUEUQVFVGYLXJUQVIVJHCDEUAXJXS
        XQUNHUDZUEUCZUFUGZYECUDZYBTZUUGKTZUJZUKZSZSZBMULYLIXSYAYEUUKYGUJZUKZSZS
        ZBMULUQUUGDUPZUUPUUTBMUVAUUOUUSXSUVAUUIYAUUNUURUVAUUHXTXQUFUUGDUNUEVKVL
        UVAUUMUUQYEUVAUULYGUUKUUGDKVMVNVOVPVRVQUUJEUPZUUTYKBMUVBUUSYJXSUVBUURYI
        YAUVBUUQYHYEUVBUUKYFYGUUJEYBVMVSVOVRVRVQPVTWAWBWCWDYMYNYTYLXJFUUDWEYNYP
        YSWFYNYMFWGTZLQZYORQZSZYPUVCYOYBUCZYDTZYHUKZSZSZYTYNYMUVCYOWHZYLQUVKYNF
        UVLYLFLRWIZWJYKUVKBMUVCYOFWGWKFUMWKXOUVCUPZXQYOUPZSZXSUVFYJUVJUVNXPUVDU
        VOXRUVEXOUVCLWLXQYORWLWMUVPYAYPYIUVIUVPXQYOXTUFUVNUVOWNWOUVPYEUVHYHUVPY
        CUVGYDXOUVCXQYOYBWPWQWSVPVPWRWTYNUVKYNYPYSSZSYTYNUVFYNUVJUVQYNYNUVLXJQU
        VFYNFUVLXJUVMWJUVCYOLRXAXBYNUVIYSYPYNUVHYRYHYNUVGYQYDYNYQUVLYBTUVGYNFUV
        LYBUVMWQUVCYOYBXCXDWQWSVRVPYNYPYSXEXFXHXGWT $.

      bcthlem.6 $e |- ( ph -> M : NN --> ( Clsd ` J ) ) $.
      ${
        bcthlem.7 $e |- ( ph -> R e. RR+ ) $.
        bcthlem.8 $e |- ( ph -> C e. X ) $.
        bcthlem.9 $e |- ( ph -> g : NN --> ( X X. RR+ ) ) $.
        bcthlem.10 $e |- ( ph -> ( g ` 1 ) = <. C , R >. ) $.
        bcthlem.11 $e |- ( ph -> A. k e. NN
                            ( g ` ( k + 1 ) ) e. ( k F ( g ` k ) ) ) $.
        $( Lemma for ~ bcth .  The balls in the sequence form an inclusion
           chain.  (Contributed by Mario Carneiro, 7-Jan-2014.) $)
        bcthlem2 $p |- ( ph -> A. n e. NN
      ( ( ball ` D ) ` ( g ` ( n + 1 ) ) ) C_ ( ( ball ` D ) ` ( g ` n ) ) ) $=
          ( cv c1 caddc co cfv cbl wss cn wcel wa crp cxp c2nd cdiv clt wbr ccl
          cdif wral wceq oveq1 fveq2d id fveq2 oveq12d eleq12d rspccva sylan wb
          w3a ffvelrnda bcthlem1 expr mpd wi ctop cuni cxmt cme cms cmetmet syl
          mpbid metxmet mopntop adantr cxr xp1st xp2nd rpxrd blssm 3expb syl2an
          c1st jca cop 1st2nd2 df-ov syl6reqr adantl mopnuni 3sstr3d eqid sscls
          syl2anc difss2 sstr2 syl2im a1d ex 3impd ralrimiva ) AIUDZUEUFUGZGUDZ
          UHZEUIUHZUHZXPXRUHZXTUHZUJZIUKAXPUKULZUMZXSMUNUOZULZXSUPUHZUEXPUQUGUR
          USZYAKUTUHUHZYCXPLUHZVAUJZVMZYDYFXSXPYBJUGZULZYNAHUDZUEUFUGZXRUHZYQYQ
          XRUHZJUGZULZHUKVBYEYPUCUUBYPHXPUKYQXPVCZYSXSUUAYOUUCYRXQXRYQXPUEUFVDV
          EUUCYQXPYTYBJUUCVFYQXPXRVGVHVIVJVKYFYBYGULZYPYNVLZAUKYGXPXRUAVNAYEUUD
          UUEABCXPYBXSEHJKLMNOPQVOVPVQWFAYNYDVRYEAYHYJYMYDAYHYJYMYDVRZVRAYHUMZU
          UFYJUUGYAYKUJZYMYKYCUJYDUUGKVSULZYAKVTZUJUUHAUUIYHAEMWAUHULZUUIAEMWBU
          HULZUUKAEMWCUHULUULPEMWDWEEMWGWEZEKMOWHWEWIUUGXSWQUHZYIXTUGZMYAUUJAUU
          KUUNMULZYIWJULZUMUUOMUJZYHUUMYHUUPUUQXSMUNWKYHYIXSMUNWLWMWRUUKUUPUUQU
          UREUUNYIMWNWOWPYHUUOYAVCAYHYAUUNYIWSZXTUHUUOYHXSUUSXTXSMUNWTVEUUNYIXT
          XAXBXCAMUUJVCZYHAUUKUUTUUMEKMOXDWEWIXEYAKUUJUUJXFXGXHYKYCYLXIYAYKYCXJ
          XKXLXMXNWIVQXO $.

        $( Lemma for ~ bcth .  The limit point of the centers in the sequence
           is in the intersection of every ball in the sequence.  (Contributed
           by Mario Carneiro, 7-Jan-2014.) $)
        bcthlem3 $p |- ( ( ph /\ ( 1st o. g ) ( ~~>t ` J ) x /\ A e. NN ) ->
                         x e. ( ( ball ` D ) ` ( g ` A ) ) ) $=
          ( vn c1st cv ccom clm cfv wbr cn wcel w3a c1 caddc co cbl ccl wss crp
          wa cxp c2nd cdiv cdif wral wceq oveq1 fveq2d id fveq2 oveq12d eleq12d
          clt rspccva sylan wb ffvelrnda bcthlem1 expr mpd mpbid simp3d difss2d
          3adant2 peano2nn cms cme cxmt cmetmet metxmet bcthlem2 syl3an3 sseldd
          3syl caublcls ) AUEHUFZUGBUFZKUHUIUJZDUKULZUMDUNUOUPZWQUIZFUQUIZUIKUR
          UIUIZDWQUIZXCUIZWRAWTXDXFUSWSAWTVAZXDXFDLUIZXGXBMUTVBZULZXBVCUIUNDVDU
          PVNUJZXDXFXHVEUSZXGXBDXEJUPZULZXJXKXLUMZAIUFZUNUOUPZWQUIZXPXPWQUIZJUP
          ZULZIUKVFWTXNUCYAXNIDUKXPDVGZXRXBXTXMYBXQXAWQXPDUNUOVHVIYBXPDXSXEJYBV
          JXPDWQVKVLVMVOVPXGXEXIULZXNXOVQZAUKXIDWQUAVRAWTYCYDABCDXEXBFIJKLMNOPQ
          VSVTWAWBWCWDWEWTAWSXAUKULWRXDULDWFAXAFWRUDWQKMAFMWGUIULFMWHUIULFMWIUI
          ULPFMWJFMWKWOUAABCEFGHIUDJKLMNOPQRSTUAUBUCWLOWPWMWN $.

        $( Lemma for ~ bcth .  Given any open ball ` ( C ( ball `` D ) R ) ` as
           starting point (and in particular, a ball in ` int ( U. ran M ) ` ),
           the limit point ` x ` of the centers of the induced sequence of
           balls ` g ` is outside ` U. ran M ` .  Note that a set ` A ` has
           empty interior iff every nonempty open set ` U ` contains points
           outside ` A ` , i.e. ` ( U \ A ) =/= (/) ` .  (Contributed by Mario
           Carneiro, 7-Jan-2014.) $)
        bcthlem4 $p |- ( ph -> ( ( C ( ball ` D ) R ) \ U. ran M ) =/= (/) ) $=
          ( vn vm vy c1st cv ccom clm cfv wbr cbl co crn cuni cdif wne cdm wcel
          c0 wex cms cca cme cxmt cmetmet syl metxmet bcthlem2 c2nd clt cn wrex
          crp wa c1 cdiv cr cc0 elrp nnrecl sylbi adantl caddc peano2nn cxp ccl
          wss w3a wral wceq oveq1 fveq2d id fveq2 oveq12d eleq12d rspccva sylan
          wb ffvelrnda bcthlem1 expr mpbid simp2d adantlr wi simp1d xp2nd rpred
          mpd nnrecre rpre ad2antlr lttr syl3anc breq1d rspcev ee12an rexlimdva
          mpand ralrimiva caubl cmetcau syl2anc wfun fo1st fofun ax-mp cofunexg
          cvv wfo vex mp2an eldm bcthlem3 cop df-ov adantr wn sylib 1nn syl6eqr
          mp3an3 eleqtrd mopntop cxr xp1st rpxrd blssm 1st2nd2 syl6reqr mopnuni
          ctop 3sstr3d sscls simp3d sstrd 3adant2 syl3an3 sseldd eldifbd eluni2
          eqid 3expa wfn ccld wf ffn eleq2 syl5bb notbid ralnex syl6bbr biimpar
          rexrn syldan eldifd ne0i exlimddv ) AUFGUGZUHZBUGZJUIUJZUKZDFEULUJZUM
          ZKUNZUOZUPZUTUQZBAUWBUWDURUSZUWEBVAAELVBUJUSZUWBEVCUJUSUWLOAEUCUWALMA
          ELVDUJUSZELVEUJUSZAUWMUWNOELVFVGELVHVGZTABCDEFGHUCIJKLMNOPQRSTUAUBVIA
          UCUGZUWAUJZVJUJZMUGZVKUKZUCVLVMZMVNAUWTVNUSZVOZVPUDUGZVQUMZUWTVKUKZUD
          VLVMZUXBUXCUXHAUXCUWTVRUSZVSUWTVKUKVOUXHUWTVTUWTUDWAWBWCUXDUXGUXBUDVL
          UXDUXEVLUSZVOZUXEVPWDUMZVLUSZUXGUXLUWAUJZVJUJZUWTVKUKZUXBUXJUXMUXDUXE
          WEZWCUXKUXOUXFVKUKZUXGUXPAUXJUXRUXCAUXJVOZUXNLVNWFZUSZUXRUXNUWFUJZJWG
          UJUJZUXEUWAUJZUWFUJZUXEKUJZUPZWHZUXSUXNUXEUYDIUMZUSZUYAUXRUYHWIZAHUGZ
          VPWDUMZUWAUJZUYLUYLUWAUJZIUMZUSZHVLWJUXJUYJUBUYQUYJHUXEVLUYLUXEWKZUYN
          UXNUYPUYIUYRUYMUXLUWAUYLUXEVPWDWLWMUYRUYLUXEUYOUYDIUYRWNUYLUXEUWAWOWP
          WQWRWSUXSUYDUXTUSZUYJUYKWTZAVLUXTUXEUWATXAAUXJUYSUYTABCUXEUYDUXNEHIJK
          LMNOPXBXCXKXDZXEXFUXKUXOVRUSZUXFVRUSZUXIUXRUXGVOUXPXGAUXJVUBUXCUXSUXO
          UXSUYAUXOVNUSUXSUYAUXRUYHVUAXHZUXNLVNXIVGZXJXFUXJVUCUXDUXEXLWCUXCUXIA
          UXJUWTXMXNUXOUXFUWTXOXPYAUXAUXPUCUXLVLUWQUXLWKZUWSUXOUWTVKVUFUWRUXNVJ
          UWQUXLUWAWOWMXQXRXSXTXKYBYCEUWBJLNYDYEBUWBUWDUFYFZUWAYKUSUWBYKUSYKYKU
          FYLVUGYGYKYKUFYHYIGYMUFUWAYKYJYNYOUUAAUWEVOZUWCUWJUSUWKVUHUWCUWGUWIVU
          HUWCVPUWAUJZUWFUJZUWGAUWEVPVLUSUWCVUJUSUUBABCVPDEFGHIJKLMNOPQRSTUAUBY
          PUUDAVUJUWGWKUWEAVUJDFYQZUWFUJUWGAVUIVUKUWFUAWMDFUWFYRUUCYSUUEAUWEUWC
          UYFUSZYTZUDVLWJZUWCUWIUSZYTZVUHVUMUDVLAUWEUXJVUMAUWEUXJWIZUWCUYEUYFVU
          QUYBUYGUWCAUXJUYBUYGWHUWEUXSUYBUYCUYGUXSJUUNUSZUYBJUOZWHUYBUYCWHAVURU
          XJAUWOVURUWPEJLNUUFVGYSUXSUXNUFUJZUXOUWFUMZLUYBVUSUXSUWOVUTLUSZUXOUUG
          USVVALWHAUWOUXJUWPYSUXSUYAVVBVUDUXNLVNUUHVGUXSUXOVUEUUIEVUTUXOLUUJXPU
          XSUYBVUTUXOYQZUWFUJVVAUXSUXNVVCUWFUXSUYAUXNVVCWKVUDUXNLVNUUKVGWMVUTUX
          OUWFYRUULALVUSWKZUXJAUWOVVDUWPEJLNUUMVGYSUUOUYBJVUSVUSUVDUUPYEUXSUYAU
          XRUYHVUAUUQUURUUSUXJAUWEUXMUWCUYBUSUXQABCUXLDEFGHIJKLMNOPQRSTUAUBYPUU
          TUVAUVBUVEYBAVUPVUNAVUPVULUDVLVMZYTVUNAVUOVVEVUOUWCUEUGZUSZUEUWHVMZAV
          VEUEUWCUWHUVCAKVLUVFZVVHVVEWTAVLJUVGUJZKUVHVVIQVLVVJKUVIVGVVGVULUEUDV
          LKVVFUYFUWCUVJUVPVGUVKUVLVULUDVLUVMUVNUVOUVQUVRUWJUWCUVSVGUVT $.
      $}

      $d g ph $.
      bcthlem5.7 $e |- ( ph -> A. k e. NN
                         ( ( int ` J ) ` ( M ` k ) ) = (/) ) $.
      $( Lemma for ~ bcth .  The proof makes essential use of the Axiom of
         Dependent Choice ~ axdc4uz , which in the form used here accepts a
         "selection" function ` F ` from each element of ` K ` to a nonempty
         subset of ` K ` , and the result function ` g ` maps ` g ( n + 1 ) `
         to an element of ` F ( n , g ( n ) ) ` .  The trick here is thus in
         the choice of ` F ` and ` K ` : we let ` K ` be the set of all tagged
         nonempty open sets (tagged here meaning that we have a point and an
         open set, in an ordered pair), and ` F ( k , <. x , z >. ) ` gives the
         set of all balls of size less than ` 1 / k ` , tagged by their
         centers, whose closures fit within the given open set ` z ` and miss
         ` M ( k ) ` .

         Since ` M ( k ) ` is closed, ` z \ M ( k ) ` is open and also
         nonempty, since ` z ` is nonempty and ` M ( k ) ` has empty interior.
         Then there is some ball contained in it, and hence our function ` F `
         is valid (it never maps to the empty set).  Now starting at a point in
         the interior of ` U. ran M ` , DC gives us the function ` g ` all
         whose elements are constrained by ` F ` acting on the previous value.
         (This is all proven in this lemma.)  Now ` g ` is a sequence of tagged
         open balls, forming an inclusion chain (see ~ bcthlem2 ) and whose
         sizes tend to zero, since they are bounded above by ` 1 / k ` .  Thus,
         the centers of these balls form a Cauchy sequence, and converge to a
         point ` x ` (see ~ bcthlem4 ).  Since the inclusion chain also ensures
         the closure of each ball is in the previous ball, the point ` x ` must
         be in all these balls (see ~ bcthlem3 ) and hence misses each
         ` M ( k ) ` , contradicting the fact that ` x ` is in the interior of
         ` U. ran M ` (which was the starting point).  (Contributed by Mario
         Carneiro, 6-Jan-2014.) $)
      bcthlem5 $p |- ( ph -> ( ( int ` J ) ` U. ran M ) = (/) ) $=
        ( cfv wcel wss crp wa vn vm vg crn cuni cnt cv cbl co wrex cxmt cms cme
        cmetmet metxmet 3syl ctop mopntop syl cpw ccld cn wf eqid cldss2 syl6ss
        frn sspwuni sylib ntropn syl2anc jca mopni2 3expa sylan wn w3a cdif wne
        c0 cxp c1 cop wceq caddc wral cvv csn wex mopnuni topopn eqeltrd rpssre
        cr reex ssexi xpexg sylancl 3ad2ant1 ntrss3 sseqtr4d simp2 sseldd simp3
        opelxpi cdiv clt wbr ccl copab opabssxp wb elpw2g adantr mpbiri rsp imp
        syl2an ssdif0 c1st c2nd 1st2nd2 ad2antll fveq2d syl3anc wi cxr syl21anc
        simpl mpd syl31anc simpr3 rpred simpr1 simpr2 rpxr sstr2 eximdv syl5bi
        id df-ov syl6eqr xp1st xp2nd bln0 eqnetrd ffvelrn cldss rpxrd expr ssn0
        blopn ssntr expcom sylsyld syl5bir necon2d difopn 3adant3 nnrp rpreccld
        n0 simp2l mopni3 simp1 ssdifssd sseld 3impia c2 rphalfcl rphalflt breq1
        elssuni rspcev ad2antlr df-rex simplrl nnrecred expdimp 3anim123i 3coml
        lttr anim1i blsscls anim12d simpllr jctild 3exp2 com35 rexlimdva 3expia
        imp5d ex opabn0 sylibr eldifsn sylanbrc ralrimivva fmpt2 1z nnuz simpl1
        axdc4uz simpl3 oveq12d eleq12d cbvralv bcthlem4 exlimddv ntrss2 syl5com
        oveq1 fveq2 syl6ib necon3ad nrexdv pm2.65da eq0rdv ) AUAHUDZUEZGUFPZPZA
        UAUGZUYBQZUYCUBUGZDUHPZUIZUYBRZUBSUJZADIUKPQZUYBGQZTUYDUYIAUYJUYKADIULP
        QZDIUMPQUYJLDIUNDIUOUPZAGUQQZUXTGUEZRZUYKAUYJUYNUYMDGIKURUSZAUXSUYOUTZR
        UYPAUXSGVAPZUYRAVBUYSHVCZUXSUYSRNVBUYSHVGUSGUYOUYOVDZVEVFUXSUYOVHVIZUXT
        GUYOVUAVJVKVLUYJUYKUYDUYIUBUYBDUYCGIKVMVNVOAUYDTUYHUBSAUYDUYESQZUYHVPZA
        UYDVUCVQZUYGUXTVRZVTVSZVUDVUEVBISWAZUCUGZVCZWBVUIPUYCUYEWCZWDZUYCWBWEUI
        ZVUIPZUYCUYCVUIPZFUIZQZUAVBWFZVQZVUGUCVUEVUHWGQZVUKVUHQZVBVUHWAVUHUTZVT
        WHVRZFVCZVUSUCWIAUYDVUTVUCAIGQSWGQVUTAIUYOGAUYJIUYOWDZUYMDGIKWJUSZAUYNU
        YOGQUYQGUYOVUAWKUSWLSWNWOWMWPISGWGWQWRZWSVUEUYCIQZVUCVVAVUEUYBIUYCAUYDU
        YBIRVUCAUYBUYOIAUYNUYPUYBUYORUYQVUBUXTGUYOVUAWTVKVVFXAWSAUYDVUCXBXCZAUY
        DVUCXDUYCUYEISXEVKAUYDVVDVUCABUGZIQZJUGZSQZTZVVLWBEUGZXFUIZXGXHZVVJVVLU
        YFUIGXIPPZCUGZUYFPZVVOHPZVRZRZTZTZBJXJZVVCQZCVUHWFEVBWFVVDAVWGECVBVUHAV
        VOVBQZVVSVUHQZTZTZVWFVVBQZVWFVTVSZVWGVWKVWLVWFVUHRZVWDBJISXKAVWLVWNXLZV
        WJAVUTVWOVVGVWFVUHWGXMUSXNXOVWKVWEJWIZBWIZVWMVWKVWBVTVSZVWQVWKVWAUYAPZV
        TWDZVWRAVWTEVBWFZVWHVWTVWJOVWHVWIYIZVXAVWHVWTVWTEVBXPXQXRVWKVWBVTVWSVTV
        WBVTWDVVTVWARZVWKVWSVTVSZVVTVWAXSVWKVVTVTVSZVXCVVTVWSRZVXDVWKVVTVVSXTPZ
        VVSYAPZUYFUIZVTVWKVVTVXGVXHWCZUYFPVXIVWKVVSVXJUYFVWIVVSVXJWDAVWHVVSISYB
        YCYDVXGVXHUYFUUAUUBZVWKUYJVXGIQZVXHSQZVXIVTVSAUYJVWJUYMXNZVWIVXLAVWHVVS
        ISUUCYCZVWIVXMAVWHVVSISUUDYCZDVXGVXHIUUEYEUUFVWKUYNVWAUYORZVVTGQZVXCVXF
        YFAUYNVWJUYQXNVWKVWAUYSQZVXQAUYTVWHVXSVWJNVXBVBUYSVVOHUUGXRZVWAGUYOVUAU
        UHUSVWKVVTVXIGVXKVWKUYJVXLVXHYGQVXIGQVXNVXOVWKVXHVXPUUIDVXGVXHGIKUULYEW
        LZUYNVXQTVXRVXCVXFVWAGVVTUYOVUAUUMUUJYHVXFVXEVXDVVTVWSUUKUUNUUOUUPUUQYJ
        VWRVVJVWBQZBWIVWKVWQBVWBUVBVWKVYBVWPBAVWJVYBVWPAVWJVYBVQZUYCVVPXGXHZVVJ
        UYCUYFUIZVWBRZTZUASUJZVWPVYCUYJVWBGQZVYBVVPSQZVYHAVWJUYJVYBUYMWSAVWJVYI
        VYBVWKVXRVXSVYIVYAVXTVVTVWAGUYOVUAUURVKUUSAVWJVYBXDVYCVWHVYJAVWHVWIVYBU
        VCVWHVVOVVOUUTUVAUSUAVWBDVVJVVPGIKUVDYKVYCAVVKVWJVYHVWPYFAVWJVYBUVEAVWJ
        VYBVVKVWKVWBIVVJVWKVVTIVWAVWKVVTUYOIVWKVXRVVTUYORVYAVVTGUVMUSAVVEVWJVVF
        XNXAUVFUVGUVHAVWJVYBXBAVVKTZVWJTZVYGVWPUASVYLUYCSQZTZVYGVWPVYNVYGTZVVLU
        YCXGXHZJSUJZVWPVYMVYQVYLVYGVYMUYCUVIXFUIZSQVYRUYCXGXHZVYQUYCUVJUYCUVKVY
        PVYSJVYRSVVLVYRUYCXGUVLUVNVKUVOVYQVVMVYPTZJWIVYOVWPVYPJSUVPVYOVYTVWEJVY
        LVYMVYGVVMVYPVWEVYLVYMVYPVVMVYGVWEVYLVYMVYPVVMVYGVWEYFVYLVYMVYPVVMVQZTZ
        VYGVWDVVNWUBVYDVVQVYFVWCWUBVVLWNQZUYCWNQZVVPWNQZVYPVYDVVQYFWUBVVLVYLVYM
        VYPVVMYLZYMWUBUYCVYLVYMVYPVVMYNYMWUBVVOVYKVWHVWIWUAUVQUVRVYLVYMVYPVVMYO
        WUCWUDWUEVQVYPVYDVVQVVLUYCVVPUWBUVSYKWUBVVRVYERZVYFVWCYFVYLUYJVVKTZVVLY
        GQZUYCYGQZVYPVQZWUGWUAVYKWUHVWJAUYJVVKUYMUWCXNVVMVYMVYPWUKVVMWUIVYMWUJV
        YPVYPVVLYPUYCYPVYPYTUVTUWADVVJVVLUYCGIKUWDXRVVRVYEVWBYQUSUWEWUBVVKVVMAV
        VKVWJWUAUWFWUFVLUWGUWHUWIUWLYRYSYJUWMUWJYHYJUWKYRYSYJVWEBJUWNUWOVWFVVBV
        TUWPUWQUWRECVBVUHVWFVVCFMUWSVIWSVUHVUKUCUAFWBWGVBUWTUXAUXCYEVUEVUSTZBCU
        YCDUYEUCEFGHIJKWULAUYLAUYDVUCVUSUXBZLUSMWULAUYTWUMNUSAUYDVUCVUSUXDVUEVV
        HVUSVVIXNVUEVUJVULVURYNVUEVUJVULVURYOWULVURVVOWBWEUIZVUIPZVVOVVOVUIPZFU
        IZQZEVBWFVUEVUJVULVURYLVUQWURUAEVBUYCVVOWDZVUNWUOVUPWUQWUSVUMWUNVUIUYCV
        VOWBWEUXLYDWUSUYCVVOVUOWUPFWUSYTUYCVVOVUIUXMUXEUXFUXGVIUXHUXIAUYDVUGVUD
        YFVUCAUYHVUFVTAUYHUYGUXTRZVUFVTWDAUYBUXTRZUYHWUTAUYNUYPWVAUYQVUBUXTGUYO
        VUAUXJVKUYGUYBUXTYQUXKUYGUXTXSUXNUXOWSYJVNUXPUXQUXR $.
    $}

    $( Baire's Category Theorem.  If a nonempty metric space is complete, it is
       nonmeager in itself.  In other words, no open set in the metric space
       can be the countable union of rare closed subsets (where rare means
       having an empty interior), so some subset ` M `` k ` must have a
       nonempty interior.  Theorem 4.7-2 of [Kreyszig] p. 247.  (The
       terminology "meager" and "nonmeager" is used by Kreyszig to replace
       Baire's "of the first category" and "of the second category."  The
       latter terms are going out of favor to avoid confusion with category
       theory.)  See ~ bcthlem5 for an overview of the proof.  (Contributed by
       NM, 28-Oct-2007.)  (Proof shortened by Mario Carneiro, 6-Jan-2014.) $)
    bcth $p |- ( ( D e. ( CMet ` X ) /\ M : NN --> ( Clsd ` J ) /\
                  ( ( int ` J ) ` U. ran M ) =/= (/) ) ->
               E. k e. NN ( ( int ` J ) ` ( M ` k ) ) =/= (/) ) $=
      ( vy vn vm cfv wcel cn c0 cv wceq wa crp co clt wss vg vz vx cms ccld crn
      vr wf cuni cnt wne w3a wral wn wrex cxp cdiv wbr cbl ccl cdif copab cmpt2
      c1 simpll eleq1 bi2anan9 simpr breq1d oveq12 fveq2d sseq1d cbvopabv oveq2
      anbi12d breq2d fveq2 difeq2d sseq2d anbi2d opabbidv syl5eq difeq1d simplr
      cbvmpt2v eqeq1d cbvralv sylib bcthlem5 necon3ad 3impia df-ne rexbii bitri
      ex rexnal sylibr ) AEUDJKZLCUEJDUHZDUFUICUJJZJZMUKZULBNZDJZWTJZMOZBLUMZUN
      ZXEMUKZBLUOZWRWSXBXHWRWSPZXGXAMXKXGXAMOXKXGPZGUAAHBUBLEQUPZUCNZEKZUGNZQKZ
      PZXPVDXCUQRZSURZXNXPAUSJZRZCUTJZJZUBNZYAJZXDVAZTZPZPZUCUGVBZVCCDEIFWRWSXG
      VEBUBHUALXMYKGNZEKZINZQKZPZYNVDHNZUQRZSURZYLYNYARZYCJZUANZYAJZYQDJZVAZTZP
      ZPZGIVBYPYSUUAYFUUDVAZTZPZPZGIVBZXCYQOZYKYPYNXSSURZUUAYGTZPZPZGIVBUUMYJUU
      RUCUGGIXNYLOZXPYNOZPZXRYPYIUUQUUSXOYMUUTXQYOXNYLEVFXPYNQVFVGUVAXTUUOYHUUP
      UVAXPYNXSSUUSUUTVHVIUVAYDUUAYGUVAYBYTYCXNYLXPYNYAVJVKVLVOVOVMUUNUURUULGIU
      UNUUQUUKYPUUNUUOYSUUPUUJUUNXSYRYNSXCYQVDUQVNVPUUNYGUUIUUAUUNXDUUDYFXCYQDV
      QZVRVSVOVTWAWBYEUUBOZUULUUHGIUVCUUKUUGYPUVCUUJUUFYSUVCUUIUUEUUAUVCYFUUCUU
      DYEUUBYAVQWCVSVTVTWAWEWRWSXGWDXLXGUUDWTJZMOZHLUMXKXGVHXFUVEBHLUUNXEUVDMUU
      NXDUUDWTUVBVKWFWGWHWIWOWJWKXJXFUNZBLUOXHXIUVFBLXEMWLWMXFBLWPWNWQ $.

    $( Baire's Category Theorem, version 2:  If countably many closed sets
       cover ` X ` , then one of them has an interior.  (Contributed by Mario
       Carneiro, 10-Jan-2014.) $)
    bcth2 $p |- ( ( ( D e. ( CMet ` X ) /\ X =/= (/) ) /\
                  ( M : NN --> ( Clsd ` J ) /\ U. ran M = X ) ) ->
               E. k e. NN ( ( int ` J ) ` ( M ` k ) ) =/= (/) ) $=
      ( cms cfv wcel c0 wne wa cn ccld wf crn cuni wceq cnt syl wrex simpll cme
      cv simprl ctop ctopon cxmt cmetmet ad2antrr metxmet mopntopon 3syl simprr
      topontop toponmax eqeltrd isopn3i syl2anc eqtrd simplr eqnetrd syl3anc
      bcth ) AEGHIZEJKZLZMCNHDOZDPQZERZLZLZVEVHVICSHZHZJKBUDDHVMHJKBMUAVEVFVKUB
      VGVHVJUEVLVNEJVLVNVIEVLCUFIZVICIVNVIRVLCEUGHIZVOVLAEUCHIZAEUHHIVPVEVQVFVK
      AEUIUJAEUKACEFULUMZECUOTVLVIECVGVHVJUNZVLVPECIVRECUPTUQVICURUSVSUTVEVFVKV
      AVBABCDEFVDVC $.

    $( Baire's Category Theorem, version 3:  The intersection of countably many
       dense open sets is dense.  (Contributed by Mario Carneiro,
       10-Jan-2014.) $)
    bcth3 $p |- ( ( D e. ( CMet ` X ) /\ M : NN --> J /\
                    A. k e. NN ( ( cls ` J ) ` ( M ` k ) ) = X ) ->
                  ( ( cls ` J ) ` |^| ran M ) = X ) $=
      ( vx cfv wcel cn wceq wral wa cdif c0 wi syl wss cvv sylan cms wf ccl crn
      cint cmpt cnt cuni cxmt cme cmetmet metxmet ctop mopntop ad2antrr ffvelrn
      cv elssuni adantll eqid clsval2 syl2anc mopnuni difeq2 difid syl6eq difss
      eqeq12d ntropn sylancl dfss4 sylib cdm elfvdm difexg adantr fveq2 difeq2d
      id fvmptg syl2anr difeq1d eqtrd fveq2d eqtr4d eqeq1d syl5ib ralimdva ccld
      sylbid opncld eqeltrd sylan2 anassrs ralrimiva fmpt wrex wn ralbii ralnex
      wne nne bitr3i bcth 3expia necon1bd syl5bi syldan ciin ciun fnmpt fniunfv
      wfn 3syl iuneq2dv cbviunv syl6eqr eqtr3d iundif2 adantl fniinfv 3eqtrd c1
      ffn biidd fnfvelrn intss1 sstrd expcom vtoclga ax-mp dif0 syl6reqr 3impia
      1nn 3syld ) AEUAHIZJCDUBZBUQZDHZCUCHZHZEKZBJLZDUDZUEZUUAHZEKZYQYRMZUUDYSG
      JEGUQZDHZNZUFZHZCUGHZHZOKZBJLZUUMUDUHZUUOHZOKZUUHYQAEUIHIZYRUUDUURPYQAEUJ
      HIUVBAEUKAEULQZUVBYRMZUUCUUQBJUVDYSJIZMZUUCCUHZUVGYTNZUUOHZNZUVGKZUUQUVFU
      UBUVJEUVGUVFCUMIZYTUVGRZUUBUVJKUVBUVLYRUVEACEFUNZUOZYRUVEUVMUVBYRUVEMYTCI
      UVMJCYSDUPYTCURQUSZYTCUVGUVGUTZVAVBUVBEUVGKZYRUVEACEFVCZUOZVHUVKUVGUVJNZO
      KUVFUUQUVKUWAUVGUVGNOUVJUVGUVGVDUVGVEVFUVFUWAUUPOUVFUWAUVIUUPUVFUVIUVGRZU
      WAUVIKUVFUVICIZUWBUVFUVLUVHUVGRUWCUVOUVGYTVGUVHCUVGUVQVIVJUVICURQUVIUVGVK
      VLUVFUUNUVHUUOUVFUUNEYTNZUVHUVEUVEUWDSIZUUNUWDKUVDUVEVSUVBUWEYRUVBEUIVMZI
      ZUWEAEUIVNZEYTUWFVOQVPGYSUULUWDJSUUMUUJYSKUUKYTEUUJYSDVQVRZUUMUTZVTWAZUVF
      EUVGYTUVTWBWCWDWEWFWGWJWHTYQYRJCWIHZUUMUBZUURUVAPUUIUULUWLIZGJLZUWMYQUVBY
      RUWOUVCUVDUWNGJUVBYRUUJJIZUWNYRUWPMUVBUUKCIZUWNJCUUJDUPUVBUWQMUULUVGUUKNZ
      UWLUVBUULUWRKUWQUVBEUVGUUKUVSWBVPUVBUVLUWQUWRUWLIUVNUUKCUVGUVQWKTWLWMWNWO
      TGJUWLUULUUMUWJWPVLUURUUPOXAZBJWQZWRZYQUWMMZUVAUURUWSWRZBJLUXAUXCUUQBJUUP
      OXBWSUWSBJWTXCUXBUWTUUTOYQUWMUUTOXAUWTABCUUMEFXDXEXFXGXHYQUVBYRUVAUUHPUVC
      UVAUVGUUTNZUVGONZKUVDUUHUUTOUVGVDUVDUXDUUGUXEEUVDUXDUVGUVGUUFNZUUOHZNZUUG
      UVDUUTUXGUVGUVDUUSUXFUUOUVDUUSEGJUUKXIZNZEUUFNUXFUVDUUSGJUULXJZUXJUVDBJUU
      NXJZUUSUXKUVDUULSIZGJLUUMJXMUXLUUSKUVDUXMGJUVBUXMYRUWPUVBUWGUXMUWHEUUKUWF
      VOQUOWOGJUULUUMSUWJXKBJUUMXLXNUVDUXLBJUWDXJUXKUVDBJUUNUWDUWKXOGBJUULUWDUW
      IXPXQXRGJEUUKXSVFUVDUXIUUFEUVDDJXMZUXIUUFKYRUXNUVBJCDYDXTZGJDYAQVRUVDEUVG
      UUFUVBUVRYRUVSVPZWBYBWDVRUVDUVLUUFUVGRZUUGUXHKUVBUVLYRUVNVPYCJIUVDUXQPZYO
      UXRUXRBYCJYSYCKUXRYEUVDUVEUXQUVFUUFYTUVGUVFYTUUEIZUUFYTRUVDUXNUVEUXSUXOJY
      SDYFTYTUUEYGQUVPYHYIYJYKUUFCUVGUVQVAVBWEUVDEUVGUXEUXPUVGYLYMVHWGTYPYN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Banach spaces and complex Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CMetSp $.
  $c Ban $.
  $c CHil $.

  $( Extend class notation with the class of all complete normed groups. $)
  ccms $a class CMetSp $.

  $( Extend class notation with the class of all Banach spaces. $)
  cbn $a class Ban $.

  $( Extend class notation with the class of all complex Hilbert spaces. $)
  chl $a class CHil $.

  ${
    $d b w $.
    $( Define the class of all complete metric spaces.  (Contributed by Mario
       Carneiro, 15-Oct-2015.) $)
    df-cms $a |- CMetSp = { w e. MetSp |
     [. ( Base ` w ) / b ]. ( ( dist ` w ) |` ( b X. b ) ) e. ( CMet ` b ) } $.
  $}

  $( Define the class of all Banach spaces.  A Banach space is a normed vector
     space such that both the vector space and the scalar field are complete
     under their respective norm-induced metrics.  (Contributed by NM,
     5-Dec-2006.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
  df-bn $a |- Ban = { w e. ( NrmVec i^i CMetSp ) |
    ( Scalar ` w ) e. CMetSp } $.

  $( Define the class of all complex Hilbert spaces.  A complex Hilbert space
     is a Banach space which is also an inner product space over the complex
     numbers.  (Contributed by Steve Rodriguez, 28-Apr-2007.) $)
  df-hl $a |- CHil = ( Ban i^i CPreHil ) $.

  ${
    $d w F $.  $d w W $.
    isbn.1 $e |- F = ( Scalar ` W ) $.
    $( A Banach space is a normed vector space with a complete induced metric.
       (Contributed by NM, 5-Dec-2006.)  (Revised by Mario Carneiro,
       15-Oct-2015.) $)
    isbn $p |- ( W e. Ban <->
      ( W e. NrmVec /\ W e. CMetSp /\ F e. CMetSp ) ) $=
      ( vw cnvc ccms cin wcel wa cbn w3a elin anbi1i cv csca wceq fveq2 syl6eqr
      cfv eleq1d df-bn elrab2 df-3an 3bitr4i ) BEFGZHZAFHZIBEHZBFHZIZUGIBJHUHUI
      UGKUFUJUGBEFLMDNZOSZFHUGDBUEJUKBPZULAFUMULBOSAUKBOQCRTDUAUBUHUIUGUCUD $.

    $( The scalar field of a complex Banach space is complete.  (Contributed by
       NM, 8-Sep-2007.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
    bnsca $p |- ( W e. Ban -> F e. CMetSp ) $=
      ( cbn wcel cnvc ccms isbn simp3bi ) BDEBFEBGEAGEABCHI $.
  $}

  $( A Banach space is a normed vector space.  (Contributed by Mario Carneiro,
     15-Oct-2015.) $)
  bnnvc $p |- ( W e. Ban -> W e. NrmVec ) $=
    ( cbn wcel cnvc ccms csca cfv eqid isbn simp1bi ) ABCADCAECAFGZECKAKHIJ $.

  $( A Banach space is a normed module.  (Contributed by Mario Carneiro,
     15-Oct-2015.) $)
  bnnlm $p |- ( W e. Ban -> W e. NrmMod ) $=
    ( cbn wcel cnvc cnlm bnnvc nvcnlm syl ) ABCADCAECAFAGH $.

  $( A Banach space is a normed group.  (Contributed by Mario Carneiro,
     15-Oct-2015.) $)
  bnngp $p |- ( W e. Ban -> W e. NrmGrp ) $=
    ( cbn wcel cnlm cngp bnnlm nlmngp syl ) ABCADCAECAFAGH $.

  $( A Banach space is a left module.  (Contributed by Mario Carneiro,
     15-Oct-2015.) $)
  bnlmod $p |- ( W e. Ban -> W e. LMod ) $=
    ( cbn wcel cnlm clmod bnnlm nlmlmod syl ) ABCADCAECAFAGH $.

  $( A Banach space is a complete metric space.  (Contributed by Mario
     Carneiro, 15-Oct-2015.) $)
  bncms $p |- ( W e. Ban -> W e. CMetSp ) $=
    ( cbn wcel cnvc ccms csca cfv eqid isbn simp2bi ) ABCADCAECAFGZECKAKHIJ $.

  ${
    $d b w D $.  $d b w M $.  $d b w X $.
    iscms.1 $e |- X = ( Base ` M ) $.
    iscms.2 $e |- D = ( ( dist ` M ) |` ( X X. X ) ) $.
    $( A complete metric space is a metric space with a complete metric.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    iscms $p |- ( M e. CMetSp <-> ( M e. MetSp /\ D e. ( CMet ` X ) ) ) $=
      ( vw vb cv cds cfv cxp cres cms wcel cbs wsbc wceq cvv fveq2 syl6eqr ccms
      cmt fvex a1i wa adantr id sylan9eqr xpeq12d reseq12d fveq2d sbcied df-cms
      eleq12d elrab2 ) FHZIJZGHZURKZLZURMJZNZGUPOJZPACMJZNZFBUBUAUPBQZVBVEGVCRV
      CRNVFUPOUCUDVFURVCQZUEZUTAVAVDVHUTBIJZCCKZLAVHUQVIUSVJVFUQVIQVGUPBISUFVHU
      RCURCVGVFURVCCVGUGVFVCBOJCUPBOSDTUHZVKUIUJETVHURCMVKUKUNULFGUMUO $.

    $( The induced metric on a complete normed group is complete.  (Contributed
       by Mario Carneiro, 15-Oct-2015.) $)
    cmscmet $p |- ( M e. CMetSp -> D e. ( CMet ` X ) ) $=
      ( ccms wcel cmt cms cfv iscms simprbi ) BFGBHGACIJGABCDEKL $.

    $( The induced metric on Banach space is complete.  (Contributed by NM,
       8-Sep-2007.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
    bncmet $p |- ( M e. Ban -> D e. ( CMet ` X ) ) $=
      ( cbn wcel ccms cms cfv bncms cmscmet syl ) BFGBHGACIJGBKABCDELM $.
  $}

  $( A complete metric space is a metric space.  (Contributed by Mario
     Carneiro, 15-Oct-2015.) $)
  cmsms $p |- ( G e. CMetSp -> G e. MetSp ) $=
    ( ccms wcel cmt cds cfv cbs cxp cres cms eqid iscms simplbi ) ABCADCAEFAGFZ
    NHIZNJFCOANNKOKLM $.

  ${
    cmspropd.1 $e |- ( ph -> B = ( Base ` K ) ) $.
    cmspropd.2 $e |- ( ph -> B = ( Base ` L ) ) $.
    cmspropd.3 $e |- ( ph ->
      ( ( dist ` K ) |` ( B X. B ) ) = ( ( dist ` L ) |` ( B X. B ) ) ) $.
    cmspropd.4 $e |- ( ph -> ( TopOpen ` K ) = ( TopOpen ` L ) ) $.
    $( Property deduction for a complete metric space.  (Contributed by Mario
       Carneiro, 15-Oct-2015.) $)
    cmspropd $p |- ( ph -> ( K e. CMetSp <-> L e. CMetSp ) ) $=
      ( cmt wcel cds cfv cbs cxp cres cms wa ccms eqtr3d eqid mspropd xpeq12d
      reseq2d fveq2d eleq12d anbi12d iscms 3bitr4g ) ACIJZCKLZCMLZUKNZOZUKPLZJZ
      QDIJZDKLZDMLZURNZOZURPLZJZQCRJDRJAUIUPUOVBABCDEFGHUAAUMUTUNVAAUQBBNZOZUMU
      TAUJVCOVDUMGAVCULUJABUKBUKEEUBUCSAVCUSUQABURBURFFUBUCSAUKURPABUKUREFSUDUE
      UFUMCUKUKTUMTUGUTDURURTUTTUGUH $.
  $}

  ${
    cmsss.h $e |- K = ( M |`s A ) $.
    cmsss.x $e |- X = ( Base ` M ) $.
    cmsss.j $e |- J = ( TopOpen ` M ) $.
    $( The restriction of a complete metric space is complete iff it is
       closed.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    cmsss $p |- ( ( M e. CMetSp /\ A C_ X ) ->
                    ( K e. CMetSp <-> A e. ( Clsd ` J ) ) ) $=
      ( wcel cfv cbs cxp cres cms ccld wceq syl cvv eqid cmt ccms wss cds cmopn
      wa simpr xpss12 sylancom resabs1 fvex eqeltri ssex adantl ressds ressbas2
      xpeq12d reseq12d eqtrd fveq2d eleq12d wb adantr cmetss bitr3d cmsms cress
      cmscmet co ressms syl5eqel syl2an iscms baib mstopn eleq2d 3bitr4d ) DUAI
      ZAEUBZUEZCUCJZCKJZWALZMZWANJZIZADUCJZEELZMZUDJZOJZIZCUAIZABOJZIVSWHAALZMZ
      ANJZIZWEWKVSWOWCWPWDVSWOWFWNMZWCVSWNWGUBZWOWRPVQVRVRWSVQVRUFAEAEUGUHWFWNW
      GUIQVSWFVTWNWBVSARIZWFVTPVRWTVQAEEDKJRGDKUJUKULZUMAWFDCRFWFSUNQVSAWAAWAVR
      AWAPVQAECDFGUOUMZXBUPUQURVSAWANXBUSUTVSWHENJIZWQWKVAVQXCVRWHDEGWHSZVGVBWH
      WIEAWISVCQVDVSCTIZWLWEVAVQDTIZWTXEVRDVEZXAXFWTUECDAVFVHTFADRVIVJVKWLXEWEW
      CCWAWASWCSVLVMQVSWMWJAVSBWIOVSXFBWIPVQXFVRXGVBWHBDEHGXDVNQUSVOVP $.
  $}

  ${
    lssbn.x $e |- X = ( W |`s U ) $.
    lssbn.s $e |- S = ( LSubSp ` W ) $.
    lssbn.j $e |- J = ( TopOpen ` W ) $.
    $( A subspace of a Banach space is a Banach space iff it is closed.
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    lssbn $p |- ( ( W e. Ban /\ U e. S ) ->
                  ( X e. Ban <-> U e. ( Clsd ` J ) ) ) $=
      ( cbn wcel wa ccms ccld cfv cnvc csca wb bnnvc lssnvc eqid resssca adantl
      sylan wceq bnsca adantr eqeltrrd w3a isbn 3anan32 bitri syl2anc cbs bncms
      baib wss lssss cmsss syl2an bitrd ) DIJZBAJZKZEIJZELJZBCMNJZVCEOJZEPNZLJZ
      VDVEQVADOJVBVGDRABDEFGSUCVCDPNZVHLVBVJVHUDVABVJDEAFVJTZUAUBVAVJLJVBVJDVKU
      EUFUGVDVGVIKZVEVDVGVEVIUHVLVEKVHEVHTUIVGVEVIUJUKUOULVADLJBDUMNZUPVEVFQVBD
      UNABVMDVMTZGUQBCEDVMFVNHURUSUT $.
  $}

  ${
    $d c x y D $.  $d c F $.  $d c U $.  $d c x y X $.
    cmetcusp1.x $e |- X = ( Base ` F ) $.
    cmetcusp1.d $e |- D = ( ( dist ` F ) |` ( X X. X ) ) $.
    cmetcusp1.u $e |- U = ( UnifSt ` F ) $.
    $( If the uniform set of a complete metric space is the uniform structure
       generated by its metric, then it is a complete uniform space.
       (Contributed by Thierry Arnoux, 15-Dec-2017.) $)
    cmetcusp1OLD $p |- ( ( X =/= (/) /\ F e. CMetSp /\ U = ( metUnifOLD ` D ) )
      -> F e. CUnifSp ) $=
      ( vc c0 wne wcel cfv wceq ccfilu cflim co wi wral syl 3ad2ant2 ccms ctopn
      cmetuOLD w3a cusp cv cfil ccusp cxme cmt cmsms msxms xmsuspOLD syl3an2 wa
      ccfil simpl3 fveq2d eleq2d cxmt wb simpl1 cms cme cmscmet cmetmet metxmet
      3syl adantr simpr cfilucfil4OLD syl3anc bitrd eqid iscmet simprbi xmstopn
      cmopn oveq1d neeq1d ralbidv mpbird r19.21bi ex ralrimiva iscusp2 sylanbrc
      sylbid ) DIJZCUAKZBAUCLZMZUDZCUEKZHUFZBNLZKZCUBLZWOOPZIJZQZHDUGLZRCUHKWJW
      ICUIKZWLWNWJCUJKXCCUKCULSZABCDEFGUMUNWMXAHXBWMWOXBKZUOZWQWOAUPLZKZWTXFWQW
      OWKNLZKZXHXFWPXIWOXFBWKNWIWJWLXEUQURUSXFWIADUTLKZXEXJXHVAWIWJWLXEVBWMXKXE
      WJWIXKWLWJADVCLKZADVDLKZXKACDEFVEZADVFADVGVHTVIWMXEVJWOADVKVLVMWMXHWTQZXE
      WJWIXOWLWJXHWTWJWTHXGWJWTHXGRAVRLZWOOPZIJZHXGRZWJXLXSXNXLXMXSAHXPDXPVNVOV
      PSWJWTXRHXGWJWSXQIWJWRXPWOOWJXCWRXPMXDAWRCDWRVNZEFVQSVSVTWAWBWCWDTVIWHWED
      BWRCHEGXTWFWG $.

    $( If the uniform set of a complete metric space is the uniform structure
       generated by its metric, then it is a complete uniform space.
       (Contributed by Thierry Arnoux, 15-Dec-2017.) $)
    cmetcusp1 $p |- ( ( X =/= (/) /\ F e. CMetSp /\ U = ( metUnif ` D ) )
      -> F e. CUnifSp ) $=
      ( vc c0 wne wcel cfv wceq ccfilu cflim co wi wral syl 3ad2ant2 ccms cmetu
      w3a cusp cv ctopn cfil ccusp cxme cmt cmsms msxms xmsusp syl3an2 wa ccfil
      simpl3 fveq2d eleq2d cxmt wb simpl1 cms cme cmscmet cmetmet metxmet simpr
      3syl adantr cfilucfil4 syl3anc bitrd iscmet simprbi xmstopn oveq1d neeq1d
      cmopn eqid ralbidv mpbird r19.21bi ex sylbid ralrimiva iscusp2 sylanbrc )
      DIJZCUAKZBAUBLZMZUCZCUDKZHUEZBNLZKZCUFLZWOOPZIJZQZHDUGLZRCUHKWJWICUIKZWLW
      NWJCUJKXCCUKCULSZABCDEFGUMUNWMXAHXBWMWOXBKZUOZWQWOAUPLZKZWTXFWQWOWKNLZKZX
      HXFWPXIWOXFBWKNWIWJWLXEUQURUSXFWIADUTLKZXEXJXHVAWIWJWLXEVBWMXKXEWJWIXKWLW
      JADVCLKZADVDLKZXKACDEFVEZADVFADVGVITVJWMXEVHWOADVKVLVMWMXHWTQZXEWJWIXOWLW
      JXHWTWJWTHXGWJWTHXGRAVSLZWOOPZIJZHXGRZWJXLXSXNXLXMXSAHXPDXPVTVNVOSWJWTXRH
      XGWJWSXQIWJWRXPWOOWJXCWRXPMXDAWRCDWRVTZEFVPSVQVRWAWBWCWDTVJWEWFDBWRCHEGXT
      WGWH $.
  $}

  ${
    $d c x y D $.  $d c x y X $.
    $( The uniform space generated by a complete metric is a complete uniform
       space.  (Contributed by Thierry Arnoux, 5-Dec-2017.) $)
    cmetcuspOLD $p |- ( ( X =/= (/) /\ D e. ( CMet ` X ) )
      -> ( toUnifSp ` ( metUnifOLD ` D ) ) e. CUnifSp ) $=
      ( vc vy vx c0 wne cfv wcel wa cv ccfilu cflim co cfil syl biimpar syl2anc
      eqid wceq cms cmetuOLD ctus cusp cuss ctopn wi cbs wral cxmt cust cmetmet
      ccusp cme metxmet anim2i metuustOLD tususp 3syl cmopn simpll ccfil simprd
      cxp cima cc0 cico wss wrex ad3antlr wb tusbas fveq2d eleq2d adantr tususs
      crp adantlr cfbas cfilucfil2OLD simplbda iscfil syl12anc cutop metutopOLD
      cmetcvg tustopn eqtr3d oveq1d neeq1d ex ralrimiva iscusp sylanbrc ) BFGZA
      BUAHIZJZAUBHZUCHZUDIZCKZWSUEHZLHZIZWSUFHZXAMNZFGZUGZCWSUHHZOHZUIWSUMIWQWO
      ABUJHIZJZWRBUKHIZWTWPXKWOWPABUNHIXKABULABUOPZUPZABUQZWRWSBWSSZURUSWQXHCXJ
      WQXAXJIZJZXDXGXSXDJZWQAUTHZXAMNZFGZXGWQXRXDVAZXTWPXAAVBHIZYCXTWOWPYDVCXTX
      KXABOHZIZADKZYHVDVEVFEKVGNVHDXAVIEVQUIZYEWPXKWOXRXDXNVJXSYGXDWQYGXRWQXMYG
      XRVKWQXLXMXOXPPZXMYFXJXAXMBXIOWRWSBXQVLVMVNPQVOXTWQXAWRLHZIZYIYDWQXDYLXRW
      QYLXDWQYKXCXAWQXMYKXCTYJXMWRXBLWRWSBXQVPVMPVNQVRWQYLXABVSHIZYIWQXLYLYMYIJ
      VKXOEDXAABVTPWARXKYEYGYIJEDAXABWBQWCAXAYABYASWFRWQXGYCWQXFYBFWQXEYAXAMWQW
      RWDHZXEYAWQXMYNXETYJWRYNWSBXQYNSWGPWQXLYNYATXOABWEPWHWIWJQRWKWLWSCWMWN $.

    $( The uniform space generated by a complete metric is a complete uniform
       space.  (Contributed by Thierry Arnoux, 5-Dec-2017.) $)
    cmetcusp $p |- ( ( X =/= (/) /\ D e. ( CMet ` X ) )
      -> ( toUnifSp ` ( metUnif ` D ) ) e. CUnifSp ) $=
      ( vc vy vx c0 wne cfv wcel wa cv ccfilu cflim co 3syl syl biimpar syl2anc
      eqid wceq cms cmetu ctus cusp cuss ctopn wi cbs cfil wral cpsmet cust cme
      ccusp cmetmet metxmet xmetpsmet anim2i metuust tususp cmopn simpll simprd
      cxmt ccfil cxp cima cc0 cico wss crp ad3antlr tusbas fveq2d eleq2d adantr
      wrex wb simpr cunif tusunif cuni ustuni unieqd 3eqtr3rd ussid eqtrd cfbas
      xpeq12d cfilucfil2 biimpa jca iscfil cmetcvg cutop xmetutop eqtr3d oveq1d
      tustopn neeq1d ex ralrimiva iscusp sylibr ) BFGZABUAHIZJZAUBHZUCHZUDIZCKZ
      XIUEHZLHZIZXIUFHZXKMNZFGZUGZCXIUHHZUIHZUJZJXIUNIXGXJYAXGXEABUKHIZJZXHBULH
      IZXJXFYBXEXFABUMHIZABVDHIZYBABUOZABUPZABUQOURZABUSZXHXIBXISZUTOXGXRCXTXGX
      KXTIZJZXNXQYMXNJZXGAVAHZXKMNZFGZXQXGYLXNVBZYNXFXKAVEHIZYQYNXEXFYRVCYNYFXK
      BUIHZIZADKZUUBVFVGVHEKVINVJDXKVQEVKUJZJZYSXFYFXEYLXNXFYEYFYGYHPZVLYNUUAUU
      CYMUUAXNXGUUAYLXGYCYDUUAYLVRYIYJYDYTXTXKYDBXSUIXHXIBYKVMZVNVOOQVPYNXGXKXH
      LHZIZUUCYRYNXGXNUUHYRYMXNVSXGUUHXNXGUUGXMXKXGYCYDUUGXMTYIYJYDXHXLLYDXHXIV
      THZXLXHXIBYKWAZYDXSXSVFZUUIWBZTUUIXLTYDXHWBBBVFUULUUKXHBWCYDXHUUIUUJWDYDB
      XSBXSUUFUUFWIWEXSUUIXIXSSUUISWFPWGVNOVOQRXGUUHJXKBWHHIZUUCXGUUHUUMUUCJZXG
      YCUUHUUNVRYIEDXKABWJPWKVCRWLYFYSUUDEDAXKBWMQRAXKYOBYOSWNRXGXQYQXGXPYPFXGX
      OYOXKMXGXHWOHZXOYOXGYCYDUUOXOTYIYJXHUUOXIBYKUUOSWSOXGXEYFJUUOYOTXFYFXEUUE
      URABWPPWQWRWTQRXAXBWLXICXCXD $.
  $}

  $( The field of complex numbers is a complete metric space.  (Contributed by
     Mario Carneiro, 15-Oct-2015.) $)
  cncms $p |- CCfld e. CMetSp $=
    ( ccnfld ccms wcel cmt cabs cmin ccom cc cms cfv cnfldms eqid cnfldbas cres
    cncmet cxp cds cr wf wfn wceq cme cnmet metf ax-mp ffn fnresdm mp2b cnfldds
    reseq1i eqtr3i iscms mpbir2an ) ABCADCEFGZHIJCKUNUNLOUNAHMUNHHPZNZUNAQJZUON
    UORUNSZUNUOTUPUNUAUNHUBJCURUCUNHUDUEUORUNUFUOUNUGUHUNUQUOUIUJUKULUM $.

  ${
    cnflduss.1 $e |- U = ( UnifSt ` CCfld ) $.
    $( The uniform structure of the complex numbers.  (Contributed by Thierry
       Arnoux, 17-Dec-2017.)  (Revised by Thierry Arnoux, 11-Mar-2018.) $)
    cnflduss $p |- U = ( metUnif ` ( abs o. - ) ) $=
      ( ccnfld cuss cfv cabs cmin ccom cmetu cxp cuni wceq cust wcel wne cpsmet
      cc c0 cc0 ax-mp ne0i cxmt cnxmet xmetpsmet metuust ustuni eqcomi cnfldbas
      0cn mp2an cnfldunif ussid eqtr4i ) ACDEZFGHZIEZBQQJZUPKZLUPUNLURUQUPQMENZ
      URUQLQROZUOQPENZUSSQNUTUIQSUATUOQUBENVAUCUOQUDTUOQUEUJUPQUFTUGQUPCUHUKULT
      UM $.
  $}

  $( The field of complex numbers is a complete uniform space.  (Contributed by
     Thierry Arnoux, 17-Dec-2017.) $)
  cnfldcusp $p |- CCfld e. CUnifSp $=
    ( cc wne ccnfld ccms wcel cuss cfv cabs cmin ccom cmetu wceq ccusp cc0 ne0i
    c0 0cn cres cr wf ax-mp cncms eqid cnflduss cnfldbas cxp cds wfn absf mp2an
    subf fco ffn fnresdm mp2b cnfldds reseq1i eqtr3i cmetcusp1 mp3an ) APBZCDEC
    FGZHIJZKGLCMENAEVAQANOUAUBVBVBUCZUDVCVBCAUEVCAAUFZRZVCCUGGZVERVESVCTZVCVEUH
    VFVCLASHTVEAITVHUIUKVEASHIULUJVESVCUMVEVCUNUOVCVGVEUPUQURVDUSUT $.

  ${
    resscdrg.1 $e |- F = ( CCfld |`s K ) $.
    $( The real numbers are a subset of any complete subfield in the
       complexes.  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    resscdrg $p |- ( ( K e. ( SubRing ` CCfld ) /\
                       F e. DivRing /\ F e. CMetSp ) -> RR C_ K ) $=
      ( ccnfld csubrg cfv wcel cdr ccms w3a cr ctopn ccl wss wceq cioo cnfldbas
      cq cin cc crn ctg ctop eqid cnfldtop ax-resscn qssre cnfldtopon toponunii
      tgioo2 restcls mp3an qdensere eqtr3i dfss1 mpbir ccld simp3 cncms subrgss
      wb 3ad2ant1 cmsss sylancr mpbid cress co eleq1i qsssubdrg sylan2b 3adant3
      clsss2 syl2anc syl5ss ) BDEFGZAHGZAIGZJZKRDLFZMFFZBKVTNVTKSZKORPUAUBFZMFF
      ZWAKVSUCGKTNRKNWCWAOVSVSUDZUEUFUGRVSWBTKTVSVSWDUHUIZVSWDUJUKULUMUNKVTUOUP
      VRBVSUQFGZRBNZVTBNVRVQWFVOVPVQURVRDIGBTNZVQWFVAUSVOVPWHVQBTDQUTVBBVSADTCQ
      WDVCVDVEVOVPWGVQVPVODBVFVGZHGWGAWIHCVHBVIVJVKBRVSTWEVLVMVN $.

    $( The only complete subfields of the complexes are ` RR ` and ` CC ` .
       (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    cncdrg $p |- ( ( K e. ( SubRing ` CCfld ) /\
                     F e. DivRing /\ F e. CMetSp ) -> K e. { RR , CC } ) $=
      ( ccnfld csubrg cfv wcel cdr ccms w3a cr wss cc cpr simp1 cnsubrg syl2anc
      resscdrg ) BDEFGZAHGZAIGZJSKBLBKMNGSTUAOABCRBPQ $.
  $}

  ${
    srabn.a $e |- A = ( ( subringAlg ` W ) ` S ) $.
    srabn.j $e |- J = ( TopOpen ` W ) $.
    $( The subring algebra over a complete normed ring is a Banach space iff
       the subring is a closed division ring.  (Contributed by Mario Carneiro,
       15-Oct-2015.) $)
    srabn $p |- ( ( W e. NrmRing /\ W e. CMetSp /\ S e. ( SubRing ` W ) ) ->
      ( A e. Ban <-> ( S e. ( Clsd ` J ) /\ ( W |`s S ) e. DivRing ) ) ) $=
      ( cnrg wcel ccms csubrg cfv w3a wa cdr wb eqid cds baib syl eleq1d cbn co
      csca cnvc ccld cress simp2 cbs csra wceq a1i wss subrgss 3ad2ant3 srabase
      eqidd cxp srads reseq1d sratopn cmspropd isbn 3anrot 3anass 3bitri srasca
      mpbid cmsss syl2anc bitr3d sranlm 3adant2 isnvc2 bitr4d anbi12d bitrd
      cnlm ) DGHZDIHZBDJKHZLZAUAHZAUCKZIHZAUDHZMZBCUEKHZDBUFUBZNHZMWAAIHZWBWFOW
      AVSWJVRVSVTUGZWADUHKZDAWAWLUPWAABDABDUIKKUJWAEUKZVTVRBWLULZVSBWLDWLPZUMUN
      ZUOWADQKAQKWLWLUQWAABDWMWPURUSWAABDWMWPUTVAVGWBWJWFWBWEWJWDLWJWDWELWJWFMW
      CAWCPZVBWEWJWDVCWJWDWEVDVERSWAWDWGWEWIWAWHIHZWDWGWAWHWCIWAABDWMWPVFZTWAVS
      WNWRWGOWKWPBCWHDWLWHPWOFVHVIVJWAWEWCNHZWIWAAVQHZWEWTOVRVTXAVSABDEVKVLWEXA
      WTWCAWQVMRSWAWHWCNWSTVNVOVP $.
  $}

  $( The ring module over a complete normed division ring is a Banach space.
     (Contributed by Mario Carneiro, 15-Oct-2015.) $)
  rlmbn $p |- ( ( R e. NrmRing /\ R e. DivRing /\ R e. CMetSp ) ->
    ( ringLMod ` R ) e. Ban ) $=
    ( cnrg wcel cdr ccms w3a crglmod cfv cbn ctopn ccld cress co wceq 3syl eqid
    cbs syl eqeltrd 3ad2ant1 cuni ctps cmt simp3 cmsms mstps tpsuni ctop tpstop
    topcld ressid simp2 csubrg wa simp1 crg nrgrng subrgid rlmval srabn syl3anc
    wb mpbir2and ) ABCZADCZAECZFZAGHZICZAQHZAJHZKHZCZAVJLMZDCZVGVJVKUAZVLVGAUBC
    ZVJVPNVGVFAUCCVQVDVEVFUDZAUEAUFOZVJVKAVJPZVKPZUGRVGVQVKUHCVPVLCVSVKAWAUIVKV
    PVPPUJOSVGVNADVDVEVNANVFVJABVTUKTVDVEVFULSVGVDVFVJAUMHCZVIVMVOUNVBVDVEVFUOV
    RVGAUPCZWBVDVEWCVFAUQTVJAVTURRVHVJVKAAUSWAUTVAVC $.

  $( The predicate "is a complex Hilbert space."  A Hilbert space is a Banach
     space which is also an inner product space, i.e. whose norm satisfies the
     parallelogram law.  (Contributed by Steve Rodriguez, 28-Apr-2007.)
     (Revised by Mario Carneiro, 15-Oct-2015.) $)
  ishl $p |- ( W e. CHil <-> ( W e. Ban /\ W e. CPreHil ) ) $=
    ( cbn ccph chl df-hl elin2 ) ABCDEF $.

  $( Every complex Hilbert space is a Banach space.  (Contributed by Steve
     Rodriguez, 28-Apr-2007.) $)
  hlbn $p |- ( W e. CHil -> W e. Ban ) $=
    ( chl wcel cbn ccph ishl simplbi ) ABCADCAECAFG $.

  $( Every complex Hilbert space is a complex pre-Hilbert space.  (Contributed
     by Mario Carneiro, 15-Oct-2015.) $)
  hlcph $p |- ( W e. CHil -> W e. CPreHil ) $=
    ( chl wcel cbn ccph ishl simprbi ) ABCADCAECAFG $.

  $( Every complex Hilbert space is an inner product space (also called a
     pre-Hilbert space).  (Contributed by NM, 28-Apr-2007.)  (Revised by Mario
     Carneiro, 15-Oct-2015.) $)
  hlphl $p |- ( W e. CHil -> W e. PreHil ) $=
    ( chl wcel ccph cphl hlcph cphphl syl ) ABCADCAECAFAGH $.

  $( Every complex Hilbert space is a complete metric space.  (Contributed by
     Mario Carneiro, 17-Oct-2015.) $)
  hlcms $p |- ( W e. CHil -> W e. CMetSp ) $=
    ( chl wcel cbn ccms hlbn bncms syl ) ABCADCAECAFAGH $.

  ${
    hlress.f $e |- F = ( Scalar ` W ) $.
    hlress.k $e |- K = ( Base ` F ) $.
    $( Lemma for ~ hlpr .  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    hlprlem $p |- ( W e. CHil -> ( K e. ( SubRing ` CCfld ) /\
      ( CCfld |`s K ) e. DivRing /\ ( CCfld |`s K ) e. CMetSp ) ) $=
      ( chl wcel ccnfld csubrg cfv cress co cdr ccms ccph cphsubrg syl eqeltrrd
      hlcph wceq cphsca clvec cphlvec lvecdrng 3syl cbn hlbn bnsca 3jca ) CFGZB
      HIJGZHBKLZMGULNGUJCOGZUKCSZABCDEPQUJAULMUJUMAULTUNABCDEUAQZUJUMCUBGAMGUNC
      UCACDUDUERUJAULNUOUJCUFGANGCUGACDUHQRUI $.

    $( The scalar field of a complex Hilbert space contains ` RR ` .
       (Contributed by Mario Carneiro, 8-Oct-2015.) $)
    hlress $p |- ( W e. CHil -> RR C_ K ) $=
      ( chl wcel ccnfld csubrg cfv cress cdr ccms w3a wss hlprlem eqid resscdrg
      co cr syl ) CFGBHIJGHBKSZLGUBMGNTBOABCDEPUBBUBQRUA $.

    $( The scalar field of a complex Hilbert space is either ` RR ` or
       ` CC ` .  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    hlpr $p |- ( W e. CHil -> K e. { RR , CC } ) $=
      ( chl wcel ccnfld csubrg cfv cress co cdr ccms w3a cr cc cpr hlprlem eqid
      cncdrg syl ) CFGBHIJGHBKLZMGUCNGOBPQRGABCDESUCBUCTUAUB $.

    $( A Hilbert space is a complete complex pre-Hilbert space over ` RR ` or
       ` CC ` .  (Contributed by Mario Carneiro, 15-Oct-2015.) $)
    ishl2 $p |- ( W e. CHil <->
      ( W e. CMetSp /\ W e. CPreHil /\ K e. { RR , CC } ) ) $=
      ( wcel wa ccms cr cc w3a syl ccnfld cress co cfv cdr eqid wceq cncms ccph
      chl cbn cpr ishl df-3an 3ancomb cnvc cphnvc isbn 3anass bitri baib cphsca
      wb eleq1d csubrg wi cphsubrg clvec cphlvec lvecdrng cncdrg 3expia syl2anc
      eqeltrrd elpri oveq2 ctopn ccld recld2 wss ax-resscn cnfldbas cmsss mp2an
      wo mpbir syl6eqel ressid ax-mp eqeltri jaoi impbid1 bitrd anbi2d pm5.32ri
      3bitr4ri ) CUBFCUCFZCUAFZGZCHFZWJBIJUDFZKZCUEWLWMWJKWLWMGZWJGWNWKWLWMWJUF
      WLWJWMUGWJWIWOWJWIWLAHFZGZWOWJCUHFZWIWQUOCUIWIWRWQWIWRWLWPKWRWQGACDUJWRWL
      WPUKULUMLWJWPWMWLWJWPMBNOZHFZWMWJAWSHABCDEUNZUPWJWTWMWJBMUQPFZWSQFZWTWMUR
      ABCDEUSWJAWSQXAWJCUTFAQFCVAACDVBLVFXBXCWTWMWSBWSRVCVDVEWMBISZBJSZVQWTBIJV
      GXDWTXEXDWSMINOZHBIMNVHXFHFZIMVIPZVJPFZXHXHRZVKMHFZIJVLXGXIUOTVMIXHXFMJXF
      RVNXJVOVPVRVSXEWSMJNOZHBJMNVHXLMHXKXLMSTJMHVNVTWATWBVSWCLWDWEWFWEWGWHUL
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Minimizing Vector Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j w x y .- $.  $d j r s t u v w x y z A $.  $d r w x y J $.  $d x y P $.
    $d s t u v w x y F $.  $d y K $.  $d j w x y N $.  $d r s t u v w x y ph $.
    $d w x y R $.  $d w x y U $.  $d r w x y X $.  $d j r s t u v w x y z Y $.
    $d r s t u v w x y z D $.  $d r s t u v w x y z S $.  $d r y T $.
    $d y L $.
    minvec.x $e |- X = ( Base ` U ) $.
    minvec.m $e |- .- = ( -g ` U ) $.
    minvec.n $e |- N = ( norm ` U ) $.
    minvec.u $e |- ( ph -> U e. CPreHil ) $.
    minvec.y $e |- ( ph -> Y e. ( LSubSp ` U ) ) $.
    minvec.w $e |- ( ph -> ( U |`s Y ) e. CMetSp ) $.
    minvec.a $e |- ( ph -> A e. X ) $.
    ${
      minvec.j $e |- J = ( TopOpen ` U ) $.
      minvec.r $e |- R = ran ( y e. Y |-> ( N ` ( A .- y ) ) ) $.
      $( Lemma for ~ minvec .  The set of all distances from points of ` Y ` to
         ` A ` are a nonempty set of nonnegative reals.  (Contributed by Mario
         Carneiro, 8-May-2014.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
      minveclem1 $p |- ( ph ->
                         ( R C_ RR /\ R =/= (/) /\ A. w e. R 0 <_ w ) ) $=
        ( cr wss c0 wne cc0 cv cle wbr wral co cfv cmpt crn wf wcel cngp cphngp
        ccph syl adantr clmod cphlmod clss eqid lssss sselda lmodvsubcl syl3anc
        wa nmcl syl2anc fmptd frn syl5eqss lssn0 wceq eqeq1i dm0rn0 fvex dmmpti
        cdm 3bitr2i necon3bii sylibr nmge0 ralrimiva rgenw breq2 ralrnmpt ax-mp
        cvv wb raleqi 3jca ) AEUAUBEUCUDZUECUFZUGUHZCEUIZAEBKDBUFZHUJZIUKZULZUM
        ZUATAKUAXBUNXCUAUBABKXAUAXBAWSKUOZVIZFUPUOZWTJUOZXAUAUOAXFXDAFURUOZXFOF
        UQUSUTZXEFVAUOZDJUOZWSJUOXGAXJXDAXHXJOFVBUSUTAXKXDRUTAKJWSAKFVCUKZUOZKJ
        UBPXLKJFLXLVDZVEUSVFHJFDWSLMVGVHZWTFIJLNVJVKXBVDZVLKUAXBVMUSVNAKUCUDZWO
        AXMXQPXLKFXNVOUSEUCKUCEUCVPXCUCVPXBWAZUCVPKUCVPEXCUCTVQXBVRXRKUCBKXAXBW
        TIVSZXPVTVQWBWCWDAWQCXCUIZWRAUEXAUGUHZBKUIZXTAYABKXEXFXGYAXIXOWTFIJLNWE
        VKWFXAWKUOZBKUIXTYBWLYCBKXSWGWQYABCKXAXBWKXPWPXAUEUGWHWIWJWDWQCEXCTWMWD
        WN $.

      minvec.s $e |- S = sup ( R , RR , `' < ) $.
      $( Lemma for ~ minvec .  The infimum of the distances to ` A ` is a real
         number.  (Contributed by Mario Carneiro, 16-Jun-2014.)  (Revised by
         Mario Carneiro, 15-Oct-2015.) $)
      minveclem4c $p |- ( ph -> S e. RR ) $=
        ( vw cr clt ccnv csup wss c0 wne cv cle wbr wral wrex minveclem1 simp1d
        wcel cc0 simp2d 0re simp3d breq1 ralbidv rspcev sylancr infmrcl syl3anc
        wceq syl5eqel ) AEDUCUDUEUFZUCUAADUCUGZDUHUIZBUJZUBUJZUKULZUBDUMZBUCUNZ
        VJUCUQAVKVLURVNUKULZUBDUMZABUBCDFGHIJKLMNOPQRSTUOZUPAVKVLVSVTUSAURUCUQV
        SVQUTAVKVLVSVTVAVPVSBURUCVMURVHVOVRUBDVMURVNUKVBVCVDVEBUBDVFVGVI $.

      minvec.d $e |- D = ( ( dist ` U ) |` ( X X. X ) ) $.
      ${
        minveclem2.1 $e |- ( ph -> B e. RR ) $.
        minveclem2.2 $e |- ( ph -> 0 <_ B ) $.
        minveclem2.3 $e |- ( ph -> K e. Y ) $.
        minveclem2.4 $e |- ( ph -> L e. Y ) $.
        minveclem2.5 $e |- ( ph -> ( ( A D K ) ^ 2 ) <_ ( ( S ^ 2 ) + B ) ) $.
        minveclem2.6 $e |- ( ph -> ( ( A D L ) ^ 2 ) <_ ( ( S ^ 2 ) + B ) ) $.
        $( Lemma for ~ minvec .  Any two points ` K ` and ` L ` in ` Y ` are
           close to each other if they are close to the infimum of distance to
           ` A ` .  (Contributed by Mario Carneiro, 9-May-2014.)  (Revised by
           Mario Carneiro, 15-Oct-2015.) $)
        minveclem2 $p |- ( ph -> ( ( K D L ) ^ 2 ) <_ ( 4 x. B ) ) $=
          ( vw vx co c2 cexp c4 cmul cle wbr caddc c1 cdiv cplusg cvsca cr wcel
          cfv 4re minveclem4c resqcld remulcl sylancr cme cmt cngp cphngp ngpms
          ccph syl msmet clss wss eqid lssss sseldd metcl syl3anc clmod cphlmod
          readdcld csca cbs cc0 wne cz cclm cphclm clmzss 2ne0 cphreccl lssvacl
          2z a1i syl22anc lmodvsubcl syl2anc clt cv wral wrex 0re rspcev mpbird
          wb wceq fveq2d wa pm3.2i lemul2 mp3an3 mpbid recnd 2re 2pos cc oveq1i
          syl6eq eqtr3d syl5eqr oveq12d oveq1d oveqi ovresd 3eqtr4d ngpds eqtrd
          2cn syl5eq lssvscl nmcl ccnv c0 minveclem1 simp3d simp1d simp2d breq1
          csup ralbidv infmrgelb syl31anc syl6breqr cmpt crn oveq2 sylancl fvex
          eqeq2d elrnmpti sylibr syl6eleqr infmrlb syl5eqbr le2sq2 4pos le2addd
          leadd1dd 2timesd breqtrrd nmpar sqmul cabs cphnmvs ltleii absid mp2an
          sq2 lmodsubdi cmg mulg2 clmmulg lmodvacl clmvs1 recidi clmvsass cabel
          syl13anc lmodabl ablsub4 syl122anc 3eqtr2d cds ngpdsr cres ablnnncan1
          cxp oveq2d 2t2e4 mulassd 3brtr4d letrd 4cn adddid breqtrd leadd2d ) A
          JKEUOZUPUQUOZURDUSUOZUTVAURGUPUQUOZUSUOZUXIVBUOZUXLUXJVBUOZUTVAAUXMUR
          UXKDVBUOZUSUOZUXNUTAUXMURCVCUPVDUOZJKHVEVIZUOZHVFVIZUOZLUOZMVIZUPUQUO
          ZUSUOZUXIVBUOZUXPAUXLUXIAURVGVHZUXKVGVHZUXLVGVHVJAGABCFGHILMNOPQRSTUA
          UBUCUDUEVKZVLZURUXKVMVNZAUXHAENVOVIVHZJNVHZKNVHZUXHVGVHAHVPVHZUYLAHVQ
          VHZUYOAHVTVHZUYPSHVRWAZHVSWAEHNPUFWBWAZAONJAOHWCVIZVHZONWDTUYTONHPUYT
          WEZWFWAZUIWGZAONKVUCUJWGZJKENWHWIVLZWLAUYEUXIAUYGUYDVGVHZUYEVGVHVJAUY
          CAUYPUYBNVHZUYCVGVHZUYRAHWJVHZCNVHZUYANVHVUHAUYQVUJSHWKWAZUBAONUYAVUC
          AVUJVUAUXQHWMVIZWNVIZVHZUXSOVHZUYAOVHZVULTAUYQUPVUNVHZUPWOWPZVUOSAWQV
          UNUPAHWRVHZWQVUNWDAUYQVUTSHWSWAZVUMVUNHVUMWEZVUNWEZWTWAUPWQVHZAXDXEZW
          GZVUSAXAXEUPVUMVUNHVVBVVCXBWIZAVUJVUAJOVHKOVHVUPVULTUIUJUXRUYTOHJKUXR
          WEZVUBXCXFVUNUYTUXTOVUMHUXQUXSVVBUXTWEZVVCVUBUUAXFZWGZLNHCUYAPQXGWIZU
          YBHMNPRUUBXHZVLZURUYDVMVNZVUFWLAUYGUXOVGVHZUXPVGVHVJAUXKDUYJUGWLZURUX
          OVMVNAUXLUYEUXIUYKVVOVUFAUXKUYDUTVAZUXLUYEUTVAZAGVGVHWOGUTVAVUIGUYCUT
          VAVVRUYIAWOFVGXIUUCUUJZGUTAWOVVTUTVAZWOUMXJZUTVAZUMFXKZAFVGWDZFUUDWPZ
          VWDABUMCFHILMNOPQRSTUAUBUCUDUUEZUUFZAVWEVWFUNXJZVWBUTVAZUMFXKZUNVGXLZ
          WOVGVHZVWAVWDXPAVWEVWFVWDVWGUUGZAVWEVWFVWDVWGUUHAVWMVWDVWLXMVWHVWKVWD
          UNWOVGVWIWOXQVWJVWCUMFVWIWOVWBUTUUIUUKXNVNZVWMAXMXEUNUMUMFWOUULUUMXOU
          EUUNVVMAGVVTUYCUTUEAVWEVWLUYCFVHVVTUYCUTVAVWNVWOAUYCBOCBXJZLUOZMVIZUU
          OZUUPZFAUYCVWRXQZBOXLZUYCVWTVHAVUQUYCUYCXQZVXBVVJUYCWEVXAVXCBUYAOVWPU
          YAXQZVWRUYCUYCVXDVWQUYBMVWPUYACLUUQXRUUTXNUURBOVWRUYCVWSVWSWEVWQMUUSU
          VAUVBUDUVCUNUMUYCFUVDWIUVEGUYCUVFXFAUYHVUGVVRVVSXPZUYJVVNUYHVUGUYGWOU
          RXIVAZXSVXEUYGVXFVJUVGXTUXKUYDURYAYBXHYCUVIAUPCJEUOZUPUQUOZCKEUOZUPUQ
          UOZVBUOZUSUOZUPUPUXOUSUOZUSUOZUYFUXPUTAVXKVXMUTVAZVXLVXNUTVAZAVXKUXOU
          XOVBUOVXMUTAVXHVXJUXOUXOAVXGAUYLVUKUYMVXGVGVHUYSUBVUDCJENWHWIVLZAVXIA
          UYLVUKUYNVXIVGVHUYSUBVUECKENWHWIVLZVVQVVQUKULUVHAUXOAUXOVVQYDZUVJUVKA
          VXKVGVHZVXMVGVHZVXOVXPXPZAVXHVXJVXQVXRWLAUPVGVHZVVPVYAYEVVQUPUXOVMVNV
          XTVYAVYCWOUPXIVAZXSVYBVYCVYDYEYFXTVXKVXMUPYAYBXHYCACJLUOZCKLUOZUXRUOZ
          MVIZUPUQUOZVYEVYFLUOZMVIZUPUQUOZVBUOZUPVYEMVIZUPUQUOZVYFMVIZUPUQUOZVB
          UOZUSUOZUYFVXLAUYQVYENVHZVYFNVHZVYMVYSXQSAVUJVUKUYMVYTVULUBVUDLNHCJPQ
          XGWIAVUJVUKUYNWUAVULUBVUELNHCKPQXGWIVYEVYFUXRLMNHPVVHQRUVLWIAUYEVYIUX
          IVYLVBAUPUYCUSUOZUPUQUOZUYEVYIAWUCUPUPUQUOZUYDUSUOZUYEAUPYGVHZUYCYGVH
          WUCWUEXQYSAUYCVVMYDUPUYCUVMVNWUDURUYDUSUVSYHYIAWUBVYHUPUQAUPUYBUXTUOZ
          MVIZWUBVYHAWUHUPUVNVIZUYCUSUOZWUBAUYQVURVUHWUHWUJXQSVVFVVLUXTVUMVUNMN
          HUPUYBPRVVIVVBVVCUVOWIWUIUPUYCUSVYCWOUPUTVAWUIUPXQYEWOUPXMYEYFUVPUPUV
          QUVRYHYIAWUGVYGMAWUGUPCUXTUOZUPUYAUXTUOZLUOCCUXRUOZUXSLUOZVYGAUPUXTVU
          MVUNLNHCUYAPVVIVVBVVCQVULVVFUBVVKUVTAWUMWUKUXSWULLAUPCHUWAVIZUOZWUMWU
          KAVUKWUPWUMXQUBNUXRWUOHCPWUOWEZVVHUWBWAAVUTVVDVUKWUPWUKXQVVAVVEUBUPCW
          UOUXTNHPWUQVVIUWCWIYJAVCUXSUXTUOZUXSWULAVUTUXSNVHZWURUXSXQVVAAVUJUYMU
          YNWUSVULVUDVUEUXRNHJKPVVHUWDWIZUXTNHUXSPVVIUWEXHAWURUPUXQUSUOZUXSUXTU
          OZWULWVAVCUXSUXTUPYSXAUWFYHAVUTVURVUOWUSWVBWULXQVVAVVFVVGWUTUPUXQUXTV
          UMVUNNHUXSPVVBVVIVVCUWGUWIYKYJYLAHUWHVHZVUKVUKUYMUYNWUNVYGXQAVUJWVCVU
          LHUWJWAZUBUBVUDVUENUXRHLKCCJPVVHQUWKUWLUWMXRYJYMYJAUXHVYKUPUQAJKHUWNV
          IZUOZKJLUOZMVIZUXHVYKAUYPUYMUYNWVFWVHXQUYRVUDVUEJKWVEHLMNRPQWVEWEZUWO
          WIAUXHJKWVENNUWRUWPZUOWVFEWVJJKUFYNAJKWVENVUDVUEYOYTAVYJWVGMANHLCJKPQ
          WVDUBVUDVUEUWQXRYPYMYLAVXKVYRUPUSAVXHVYOVXJVYQVBAVXGVYNUPUQAVXGCJWVEU
          OZVYNAVXGCJWVJUOWVKEWVJCJUFYNACJWVENUBVUDYOYTAUYPVUKUYMWVKVYNXQUYRUBV
          UDCJWVEHLMNRPQWVIYQWIYRYMAVXIVYPUPUQAVXICKWVEUOZVYPAVXICKWVJUOWVLEWVJ
          CKUFYNACKWVENUBVUEYOYTAUYPVUKUYNWVLVYPXQUYRUBVUECKWVEHLMNRPQWVIYQWIYR
          YMYLUWSYPAUXPUPUPUSUOZUXOUSUOVXNWVMURUXOUSUWTYHAUPUPUXOWUFAYSXEZWVNVX
          SUXAYKUXBUXCAURUXKDURYGVHAUXDXEAUXKUYJYDADUGYDUXEUXFAUXIUXJUXLVUFAUYG
          DVGVHUXJVGVHVJUGURDVMVNUYKUXGXO $.
      $}

      $( Lemma for ~ minvec . ` D ` is a complete metric when restricted to
         ` Y ` .  (Contributed by Mario Carneiro, 7-May-2014.)  (Revised by
         Mario Carneiro, 15-Oct-2015.) $)
      minveclem3a $p |- ( ph -> ( D |` ( Y X. Y ) ) e. ( CMet ` Y ) ) $=
        ( cress cds cfv cbs cxp cres cms ccms wcel eqid cmscmet syl reseq1i wss
        wceq clss lssss xpss12 syl2anc resabs1 ressds ressbas2 xpeq12d reseq12d
        co eqtrd syl5eq fveq2d 3eltr4d ) AGLUDVHZUEUFZVMUGUFZVOUHZUIZVOUJUFZDLL
        UHZUIZLUJUFAVMUKULVQVRULRVQVMVOVOUMVQUMUNUOAVTGUEUFZKKUHZUIZVSUIZVQDWCV
        SUCUPAWDWAVSUIZVQAVSWBUQZWDWEURALKUQZWGWFALGUSUFZULZWGQWHLKGMWHUMUTUOZW
        JLKLKVAVBWAVSWBVCUOAWAVNVSVPAWIWAVNURQLWAGVMWHVMUMZWAUMVDUOALVOLVOAWGLV
        OURWJLKVMGWKMVEUOZWLVFVGVIVJALVOUJWLVKVL $.

      ${
        minvec.f $e |- F = ran ( r e. RR+ |->
          { y e. Y | ( ( A D y ) ^ 2 ) <_ ( ( S ^ 2 ) + r ) } ) $.
        $( Lemma for ~ minvec .  The set of vectors within a fixed distance of
           the infimum forms a filter base.  (Contributed by Mario Carneiro,
           15-Oct-2015.) $)
        minveclem3b $p |- ( ph -> F e. ( fBas ` Y ) ) $=
          ( vu vv vw vs vt cfbas cfv wcel cpw wss c0 wne wnel cv cin w3a crp co
          wral c2 cexp caddc cle wbr crab cmpt crn wf ssrab2 clss adantr elpw2g
          wa syl mpbiri eqid fmptd frn syl5eqss cdm 1rp wceq fdm syl5eleqr ne0i
          wb c1 dm0rn0 eqeq1i bitr4i necon3bii sylib wn wrex clt cr minveclem4c
          csqr resqcld ltaddrp sylan rpre adantl readdcld recnd sqsqrd breqtrrd
          ccnv csup cc0 minveclem1 simp1d 0re syl3anc infmrgelb syl31anc mpbird
          cvv breq2 ax-mp syl6bb sylibr ad2antrr sselda sylbid elrnmpt rabbidva
          bitri eleq2d vex weq rabbidv cbvmptv rpred simp2d simp3d breq1 rspcev
          ralbidv sylancr infmrcl syl5eqel a1i lelttrd ltled resqrcld syl6breqr
          sqge0d sqrge0d lt2sqd ltnled mpbid breq2i raleqi fvex ralrnmpt syl5bb
          rgenw mtbid rexnal cme cngp ccph cphngp ngpms msmet 3syl lssss metge0
          cmt metcl le2sqd cds cxp cres oveqi ovresd syl5eq ngpds breq2d breq1d
          eqtrd 3bitr3d notbid letrid ord mpd rabn0 necomd neneqd nrexdv eleq2i
          reximdva 0ex sylnibr cmin lesubadd2d mpteq2dva rneqd syl6reqr anbi12d
          df-nel reeanv resubcld simplrl simplrr lemin rabexg elrnmpt1s syl2anc
          cif ifcl eleqtrrd eqeltrrd ineq12 inrab syl6eq eleq1d syl5ibrcom pwid
          inex1 inelcm mpan2 syl6 rexlimdvva syl5bir ralrimivv isfbas mpbir2and
          3jca ) AHMULUMUNZHMUOZUPZHUQURZUQHUSZHUGUTZUHUTZVAZUOZVAUQURZUHHVEUGH
          VEZVBZAHNVCCBUTZDVDZVFVGVDZFVFVGVDZNUTZVHVDZVIVJZBMVKZVLZVMZUYRUFAVCU
          YRVUQVNZVURUYRUPANVCVUPUYRVUQAVUMVCUNZVSZVUPUYRUNZVUPMUPZVUOBMVOVVAMG
          VPUMZUNZVVBVVCWLAVVEVUTSVQZVUPMVVDVRVTWAVUQWBZWCZVCUYRVUQWDVTWEAUYTVU
          AVUGAVUQWFZUQURZUYTAWMVVIUNVVJAWMVCVVIWGAVUSVVIVCWHVVHVCUYRVUQWIVTWJV
          VIWMWKVTVVIUQHUQVVIUQWHVURUQWHHUQWHVUQWNHVURUQUFWOWPWQWRAUQHUNZWSVUAA
          UQVUPWHZNVCWTZVVKAVVLNVCVVAUQVUPVVAVUPUQVVAVUOBMWTZVUPUQURVVAVUNXDUMZ
          CVUIJVDZKUMZVIVJZWSZBMWTZVVNVVAVVRBMVEZWSVVTVVAVVOFVIVJZVWAVVAFVVOXAV
          JZVWBWSVVAVWCVULVVOVFVGVDZXAVJVVAVULVUNVWDXAAVULXBUNZVUTVULVUNXAVJAFA
          BCEFGIJKLMOPQRSTUAUBUCUDXCXEZVULVUMXFXGZVVAVUNVVAVUNVVAVULVUMAVWEVUTV
          WFVQZVUTVUMXBUNZAVUMXHXIZXJZXKXLZXMVVAFVVOVVAFEXBXAXNXOZXBUDVVAEXBUPZ
          EUQURZVUIUIUTZVIVJZUIEVEZBXBWTZVWMXBUNAVWNVUTAVWNVWOXPVWPVIVJZUIEVEZA
          BUICEGIJKLMOPQRSTUAUBUCXQZXRVQZAVWOVUTAVWNVWOVXAVXBUUAVQZAVWSVUTAXPXB
          UNZVXAVWSXSAVWNVWOVXAVXBUUBZVWRVXABXPXBVUIXPWHVWQVWTUIEVUIXPVWPVIUUCU
          UEUUDUUFVQZBUIEUUGXTUUHZVVAVUNVWKVVAXPVUNVXEVVAXSUUIZVWKVVAXPVULVUNVX
          IVWHVWKVVAFVXHUUNVWGUUJUUKZUULZVVAXPVWMFVIVVAXPVWMVIVJZVXAAVXAVUTVXFV
          QVVAVWNVWOVWSVXEVXLVXAWLVXCVXDVXGVXIBUIUIEXPYAYBYCUDUUMVVAVUNVWKVXJUU
          OZUUPYCVVAFVVOVXHVXKUUQUURVWBVVOVWMVIVJZVVAVWAFVWMVVOVIUDUUSVVAVXNVVO
          VWPVIVJZUIEVEZVWAVVAVWNVWOVWSVVOXBUNZVXNVXPWLVXCVXDVXGVXKBUIUIEVVOYAY
          BVXPVXOUIBMVVQVLZVMZVEZVWAVXOUIEVXSUCUUTVVQYDUNZBMVEVXTVWAWLVYABMVVPK
          UVAUVDVXOVVRBUIMVVQVXRYDVXRWBVWPVVQVVOVIYEUVBYFYNYGUVCUVEVVRBMUVFYHVV
          AVVSVUOBMVVAVUIMUNZVSZVVSVUNVUKVIVJZWSVUOVYCVVRVYDVYCVVOVUJVIVJVWDVUK
          VIVJVVRVYDVYCVVOVUJVVAVXQVYBVXKVQVYCDLUVGUMUNZCLUNZVUILUNZVUJXBUNZAVY
          EVUTVYBAGUVHUNZGUVPUNVYEAGUVIUNVYIRGUVJVTZGUVKDGLOUEUVLUVMZYIZAVYFVUT
          VYBUAYIZVVAMLVUIVVAVVEMLUPZVVFVVDMLGOVVDWBUVNZVTYJZCVUIDLUVQZXTZVVAXP
          VVOVIVJVYBVXMVQVYCVYEVYFVYGXPVUJVIVJVYLVYMVYPCVUIDLUVOXTUVRVYCVUJVVQV
          VOVIVYCVUJCVUIGUVSUMZVDZVVQVYCVUJCVUIVYSLLUVTUWAZVDVYTDWUACVUIUEUWBVY
          CCVUIVYSLVYMVYPUWCUWDVYCVYIVYFVYGVYTVVQWHAVYIVUTVYBVYJYIVYMVYPCVUIVYS
          GJKLQOPVYSWBUWEXTUWHUWFVYCVWDVUNVUKVIVVAVWDVUNWHVYBVWLVQUWGUWIUWJVYCV
          YDVUOVYCVUNVUKVVAVUNXBUNVYBVWKVQVYCVUJVYRXEZUWKUWLYKUWSUWMVUOBMUWNYHU
          WOUWPUWQVVKUQVURUNZVVMHVURUQUFUWRUQYDUNWUCVVMWLUWTNVCVUPUQVUQYDVVGYLY
          FYNUXAUQHUXHYHAVUFUGUHHHAVUBHUNZVUCHUNZVSVUBVUKVULUXBVDZUJUTZVIVJZBMV
          KZWHZUJVCWTZVUCWUFUKUTZVIVJZBMVKZWHZUKVCWTZVSZVUFAWUDWUKWUEWUPAWUDVUB
          NVCWUFVUMVIVJZBMVKZVLZVMZUNZWUKAHWVAVUBAWVAVURHAWUTVUQANVCWUSVUPVVAWU
          RVUOBMVYCVUKVULVUMWUBVYCFVVAFXBUNVYBVXHVQXEVVAVWIVYBVWJVQUXCYMUXDUXEU
          FUXFZYOVUBYDUNWVBWUKWLUGYPZUJVCWUIVUBWUTYDNUJVCWUSWUINUJYQWURWUHBMVUM
          WUGWUFVIYEYRYSYLYFYGAWUEVUCWVAUNZWUPAHWVAVUCWVCYOVUCYDUNWVEWUPWLUHYPU
          KVCWUNVUCWUTYDNUKVCWUSWUNNUKYQWURWUMBMVUMWULWUFVIYEYRYSYLYFYGUXGWUQWU
          JWUOVSZUKVCWTUJVCWTAVUFWUJWUOUJUKVCVCUXIAWVFVUFUJUKVCVCAWUGVCUNZWULVC
          UNZVSZVSZWVFVUDHUNZVUFWVJWVKWVFWUHWUMVSZBMVKZHUNWVJWUFWUGWULVIVJZWUGW
          ULUXQZVIVJZBMVKZWVMHWVJWVPWVLBMWVJVYBVSZWUFXBUNWUGXBUNWULXBUNWVPWVLWL
          WVRVUKVULWVRVUJWVRVYEVYFVYGVYHAVYEWVIVYBVYKYIAVYFWVIVYBUAYIWVJMLVUIAV
          YNWVIAVVEVYNSVYOVTVQYJVYQXTXEAVWEWVIVYBVWFYIUXJWVRWUGAWVGWVHVYBUXKYTW
          VRWULAWVGWVHVYBUXLYTWUFWUGWULUXMXTYMWVJWVQWVAHWVJWVOVCUNZWVQYDUNZWVQW
          VAUNWVIWVSAWVNWUGWULVCUXRXIWVJVVEWVTAVVEWVISVQWVPBMVVDUXNVTNVCWUSWVQW
          VOWUTYDWUTWBVUMWVOWHWURWVPBMVUMWVOWUFVIYEYRUXOUXPAHWVAWHWVIWVCVQUXSUX
          TWVFVUDWVMHWVFVUDWUIWUNVAWVMVUBWUIVUCWUNUYAWUHWUMBMUYBUYCUYDUYEWVKVUD
          VUEUNVUFVUDVUBVUCWVDUYGUYFVUDHVUEUYHUYIUYJUYKUYLYKUYMUYPAVVEUYQUYSVUH
          VSWLSUGUHVVDMHUYNVTUYO $.

        $( Lemma for ~ minvec .  The filter formed by taking elements
           successively closer to the infimum is Cauchy.  (Contributed by Mario
           Carneiro, 8-May-2014.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
        minveclem3 $p |- ( ph ->
          ( Y filGen F ) e. ( CauFil ` ( D |` ( Y X. Y ) ) ) ) $=
          ( vu vv vs vw cfg co cxp cres ccfil cfv wcel cv clt wbr wral wrex crp
          wa c2 cexp cdiv c4 caddc cle crab crn cvv cz simpr 2z rpexpcl sylancl
          cmpt rphalfcld cn 4nn nnrp ax-mp rpdivcl clss adantr rabexg eqid wceq
          syl oveq2 breq2d rabbidv elrnmpt1s syl2anc syl6eleqr weq oveq1d elrab
          breq1d anbi12i simprll simprrl ovresd cr ccph cngp cphngp ngpms msmet
          cme cmt 4syl ad2antrr wss lssss sseldd metcl syl3anc rpred cmul cress
          resqcld rpge0d simprlr simprrr minveclem2 rpcnd cc 4cn a1i cc0 nnne0i
          ccms wne divcan2d breqtrd ad2antlr mpbird rphalflt lelttrd rpre rpge0
          metge0 lt2sqd eqbrtrd sylan2b ralrimivva raleq raleqbi1dv rspcev cxmt
          ralrimiva cfbas wb cms minveclem3a cmetmet metxmet minveclem3b fgcfil
          3syl ) AMHUKULDMMUMUNZUOUPUQZUGURZUHURZUVDULZUIURZUSUTZUHUJURZVAZUGUV
          KVAZUJHVBZUIVCVAZAUVNUIVCAUVIVCUQZVDZCBURZDULZVEVFULZFVEVFULZUVIVEVFU
          LZVEVGULZVHVGULZVIULZVJUTZBMVKZHUQUVJUHUWGVAZUGUWGVAZUVNUVQUWGNVCUVTU
          WANURZVIULZVJUTZBMVKZVSZVLZHUVQUWDVCUQZUWGVMUQZUWGUWOUQUVQUWCVCUQZVHV
          CUQZUWPUVQUWBUVQUVPVEVNUQUWBVCUQZAUVPVOVPUVIVEVQVRZVTZVHWAUQUWSWBVHWC
          WDUWCVHWEVRZUVQMGWFUPZUQZUWQAUXEUVPSWGUWFBMUXDWHWKNVCUWMUWGUWDUWNVMUW
          NWIUWJUWDWJZUWLUWFBMUXFUWKUWEUVTVJUWJUWDUWAVIWLWMWNWOWPUFWQUVQUVJUGUH
          UWGUWGUVFUWGUQZUVGUWGUQZVDUVQUVFMUQZCUVFDULZVEVFULZUWEVJUTZVDZUVGMUQZ
          CUVGDULZVEVFULZUWEVJUTZVDZVDZUVJUXGUXMUXHUXRUWFUXLBUVFMBUGWRZUVTUXKUW
          EVJUXTUVSUXJVEVFUVRUVFCDWLWSXAWTUWFUXQBUVGMBUHWRZUVTUXPUWEVJUYAUVSUXO
          VEVFUVRUVGCDWLWSXAWTXBUVQUXSVDZUVHUVFUVGDULZUVIUSUYBUVFUVGDMUVQUXIUXL
          UXRXCZUVQUXMUXNUXQXDZXEUYBUYCUVIUSUTUYCVEVFULZUWBUSUTUYBUYFUWCUWBUYBU
          YCUYBDLXLUPUQZUVFLUQZUVGLUQZUYCXFUQAUYGUVPUXSAGXGUQZGXHUQGXMUQUYGRGXI
          GXJDGLOUEXKXNXOZUYBMLUVFAMLXPZUVPUXSAUXEUYLSUXDMLGOUXDWIXQWKXOZUYDXRZ
          UYBMLUVGUYMUYEXRZUVFUVGDLXSXTZYDUYBUWCUVQUWRUXSUXBWGZYAUYBUWBUVQUWTUX
          SUXAWGZYAUYBUYFVHUWDYBULUWCVJUYBBCUWDDEFGIUVFUVGJKLMOPQAUYJUVPUXSRXOA
          UXEUVPUXSSXOAGMYCULYOUQUVPUXSTXOACLUQUVPUXSUAXOUBUCUDUEUYBUWDUVQUWPUX
          SUXCWGZYAUYBUWDUYSYEUYDUYEUVQUXIUXLUXRYFUVQUXMUXNUXQYGYHUYBUWCVHUYBUW
          CUYQYIVHYJUQUYBYKYLVHYMYPUYBVHWBYNYLYQYRUYBUWTUWCUWBUSUTUYRUWBUUAWKUU
          BUYBUYCUVIUYPUVPUVIXFUQAUXSUVIUUCYSUYBUYGUYHUYIYMUYCVJUTUYKUYNUYOUVFU
          VGDLUUEXTUVPYMUVIVJUTAUXSUVIUUDYSUUFYTUUGUUHUUIUVMUWIUJUWGHUVLUWHUGUV
          KUWGUVJUHUVKUWGUUJUUKUULWPUUNAUVDMUUMUPUQZHMUUOUPUQUVEUVOUUPAUVDMUUQU
          PUQUVDMXLUPUQUYTABCDEFGIJKLMOPQRSTUAUBUCUDUEUURUVDMUUSUVDMUUTUVCABCDE
          FGHIJKLMNOPQRSTUAUBUCUDUEUFUVAUIUJUGUHHUVDMUVBWPYT $.

        minvec.p $e |- P = U. ( J fLim ( X filGen F ) ) $.
        $( Lemma for ~ minvec . ` F ` converges to a point ` P ` in ` Y ` .
           (Contributed by Mario Carneiro, 7-May-2014.)  (Revised by Mario
           Carneiro, 15-Oct-2015.) $)
        minveclem4a $p |- ( ph -> P e. ( ( J fLim ( X filGen F ) ) i^i Y ) ) $=
          ( vx cfg co cflim cuni cin csn ovex uniex snid c0 wceq cxp cres cmopn
          wn cfv cxme wcel ccph cngp cphngp ngpxms 3syl xmstopn syl oveq1d cxmt
          crest xmsxmet clss eqid lssss metrest syl2anc eqtr2d cfil minveclem3b
          wss cvv cfbas fgcl cbs fvex eqeltri trfg syl3anc fgabs eqtr3d oveq12d
          a1i ctopon xmstps istps sylib cpw fbsspw sspwb sstrd fbasweak filfbas
          ctps ssfg sseqtrd filtop sseldd flimrest eqtrd minveclem3a minveclem3
          cms ccfil wne cmetcvg eqnetrrd neneqd wo inss1 c1o cen wbr cv weu wmo
          cha methaus eqeltrd hausflimi wb ssn0 sylancr n0moeu euen1b en1b sssn
          mpbid sylibr syl5sseq ord mpd syl5eleqr syl5eqel ) AEJMIUJUKZULUKZUMZ
          UULNUNZUHAUUMUUMUOZUUNUUMUULJUUKULUPUQURAUUNUSUTZVDUUNUUOUTZAUUNUSADN
          NVAVBZVCVEZNIUJUKZULUKZUUNUSAUVAJNVQUKZUUKNVQUKZULUKZUUNAUUSUVBUUTUVC
          ULAUVBDVCVEZNVQUKZUUSAJUVENVQAHVFVGZJUVEUTAHVHVGHVIVGUVGSHVJHVKVLZDJH
          MUCPUFVMZVNVOADMVPVEVGZNMWGZUVFUUSUTAUVGUVJUVHDHMPUFVRZVNANHVSVEZVGUV
          KTUVMNMHPUVMVTWAVNZDUURUVEUUSMNUURVTUVEVTZUUSVTZWBWCWDAMUUTUJUKZNVQUK
          ZUUTUVCAUUTNWEVEVGZUVKMWHVGZUVRUUTUTAINWIVEZVGZUVSABCDFGHIJKLMNOPQRST
          UAUBUCUDUEUFUGWFZINWJZVNZUVNUVTAMHWKVEWHPHWKWLWMWSZNUUTWHMWNWOAUVQUUK
          NVQAUWBUVKUVQUUKUTUWCUVNIMNWPWCZVOWQWRAJMWTVEVGZUUKMWEVEVGZNUUKVGUVDU
          UNUTAHXJVGZUWHAUVGUWJUVHHXAVNMJHPUCXBXCAIMWIVEZVGZUWIAUWBIMXDZWGUVTUW
          LUWCAINXDZUWMAUWBIUWNWGUWCNIXEVNAUVKUWNUWMWGUVNNMXFXCZXGUWFIWHNMXHWOI
          MWJVNAUUTUUKNAUUTUVQUUKAUUTUWKVGZUUTUVQWGAUUTUWAVGZUUTUWMWGUVTUWPAUWB
          UVSUWQUWCUWDUUTNXIVLZAUUTUWNUWMAUWQUUTUWNWGUWRNUUTXEVNUWOXGUWFUUTWHNM
          XHWOUUTMXKVNUWGXLAUVSNUUTVGUWEUUTNXMVNXNUUKJMNXOWOXPAUURNXSVEVGUUTUUR
          XTVEVGUVAUSYAABCDFGHJKLMNPQRSTUAUBUCUDUEUFXQABCDFGHIJKLMNOPQRSTUAUBUC
          UDUEUFUGXRUURUUTUUSNUVPYBWCYCZYDAUUPUUQAUUNUUOWGUUPUUQYEAUULUUNUUOUUL
          NYFZAUULYGYHYIZUULUUOUTAUIYJUULVGZUIYKZUXAAUXBUIYLZUXCAUVGJYMVGUXDUVH
          UVGJUVEYMUVIUVGUVJUVEYMVGUVLDUVEMUVOYNVNYOUIUUKJYPVLAUULUSYAZUXDUXCYQ
          AUUNUULWGUUNUSYAUXEUWTUWSUUNUULYRYSUIUULYTVNUUDUIUULUUAUUEUULUUBXCUUF
          UUNUUMUUCXCUUGUUHUUIUUJ $.

        $( Lemma for ~ minvec .  The convergent point of the Cauchy sequence
           ` F ` is a member of the base space.  (Contributed by Mario
           Carneiro, 16-Jun-2014.)  (Revised by Mario Carneiro,
           15-Oct-2015.) $)
        minveclem4b $p |- ( ph -> P e. X ) $=
          ( clss cfv wcel wss eqid lssss syl cfg co cflim cin inss2 minveclem4a
          sseldi sseldd ) ANMEANHUIUJZUKNMULTVDNMHPVDUMUNUOAJMIUPUQURUQZNUSNEVE
          NUTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHVAVBVC $.

        minvec.t $e |- T = ( ( ( ( ( A D P ) + S ) / 2 ) ^ 2 ) - ( S ^ 2 ) ) $.
        $( Lemma for ~ minvec .  The convergent point of the Cauchy sequence
           ` F ` attains the minimum distance, and so is closer to ` A ` than
           any other point in ` Y ` .  (Contributed by Mario Carneiro,
           7-May-2014.)  (Revised by Mario Carneiro, 15-Oct-2015.) $)
        minveclem4 $p |- ( ph -> E. x e. Y A. y e. Y
                          ( N ` ( A .- x ) ) <_ ( N ` ( A .- y ) ) ) $=
          ( vw wcel co cfv cv cle wbr wral wrex cfg cflim cin inss2 minveclem4a
          sseldi wa wceq cds cxp cres oveqi minveclem4b ovresd syl5eq cngp ccph
          cphngp syl eqid ngpds syl3anc eqtrd adantr cme ngpms msmet 3syl metcl
          cr cmt minveclem4c clmod cphlmod clss lssss sselda lmodvsubcl syl2anc
          wss nmcl wn clt ltnled caddc c2 cdiv crab ccl cfil cexp cfbas cpw cvv
          minveclem3b cbs fvex a1i crp cmpt crn resqcld cc0 cmul 2timesd breq1d
          recnd 3bitr2d 0re ralbidv rspcev metge0 oveq2 breq2d syl6eleqr sseldd
          wb ad2antrr ccld fveq2d fbsspw sspwb sylib eqeltri fbasweak fgcl ssfg
          sstrd cmin readdcld rehalfcld resubcld 2re 2pos pm3.2i ltmuldiv2 ccnv
          ltadd1d csup c0 wne minveclem1 simp3d simp1d simp2d sylancr infmrgelb
          breq1 syl31anc mpbird syl6breqr addge0d divge0 syl21anc lt2sqd 3bitrd
          posdifd biimpa elrpd syl5eqel rabexg rabbidv elrnmpt1s ssrab2 pncan3d
          oveq2i adantlr le2sqd bitr4d rabbidva eqsstrd filss syl13anc flimclsi
          rabss2 inss1 cmopn cxmt cxr cxme xmsxmet rexrd blcld xmstopn eleqtrrd
          ngpxms cldcls eleqtrd simprbi leadd2d lemuldiv2 mp3an3 biimpar syldan
          elrab sylbird pm2.18d simpr elrnmpt1 sylancl syl5eqbr letrd ralrimiva
          ex infmrlb eqbrtrrd ) AFPUMDFMUNZNUOZDCUPZMUNZNUOZUQURZCPUSZDBUPZMUNZ
          NUOZUYKUQURZCPUSZBPUTALOKVAUNZVBUNZPVCZPFUYTPVDACDEFGHJKLMNOPQRSTUAUB
          UCUDUEUFUGUHUIUJVEZVFAUYLCPAUYIPUMZVGZDFEUNZUYHUYKUQAVUEUYHVHVUCAVUED
          FJVIUOZUNZUYHAVUEDFVUFOOVJVKZUNVUGEVUHDFUHVLADFVUFOUDACDEFGHJKLMNOPQR
          STUAUBUCUDUEUFUGUHUIUJVMZVNVOAJVPUMZDOUMZFOUMZVUGUYHVHAJVQUMZVUJUAJVR
          VSZUDVUIDFVUFJMNOTRSVUFVTWAWBWCWDVUDVUEHUYKAVUEWJUMZVUCAEOWEUOUMZVUKV
          ULVUOAVUJJWKUMVUPVUNJWFEJORUHWGWHZUDVUIDFEOWIWBZWDAHWJUMZVUCACDGHJLMN
          OPRSTUAUBUCUDUEUFUGWLZWDVUDVUJUYJOUMZUYKWJUMAVUJVUCVUNWDVUDJWMUMZVUKU
          YIOUMZVVAAVVBVUCAVUMVVBUAJWNVSWDAVUKVUCUDWDAPOUYIAPJWOUOZUMZPOWTZUBVV
          DPOJRVVDVTWPVSZWQZMOJDUYIRSWRWBUYJJNORTXAWSAVUEHUQURZVUCAVVIAVVIXBHVU
          EXCURZVVIAHVUEVUTVURXDAVVJVVIAVVJVUEVUEHXEUNZXFXGUNZUQURZVVIAVVJVGZFD
          UYIEUNZVVLUQURZCOXHZUMZVVMVVNFVVQLXIUOUOZVVQVVNUYTVVSFVVNVVQUYSUMZUYT
          VVSWTVVNUYSOXJUOUMZVVOXFXKUNZHXFXKUNZIXEUNZUQURZCPXHZUYSUMVVQOWTZVWFV
          VQWTVVTVVNKOXLUOUMZVWAAVWHVVJAKPXLUOUMZKOXMZWTOXNUMZVWHACDEGHJKLMNOPQ
          RSTUAUBUCUDUEUFUGUHUIXOZAKPXMZVWJAVWIKVWMWTVWLPKUUAVSAVVFVWMVWJWTVVGP
          OUUBUUCUUHVWKAOJXPUOXNRJXPXQUUDXRKXNPOUUEWBWDZKOUUFVSVVNKUYSVWFVVNVWH
          KUYSWTVWNKOUUGVSVVNVWFQXSVWBVWCQUPZXEUNZUQURZCPXHZXTZYAZKVVNIXSUMVWFX
          NUMZVWFVWTUMVVNIVVLXFXKUNZVWCUUIUNZXSUKVVNVXCAVXCWJUMVVJAVXBVWCAVVLAV
          VKAVUEHVURVUTUUJZUUKZYBZAHVUTYBZUULWDAVVJYCVXCXCURZAVVJHVVLXCURZVWCVX
          BXCURVXHAVVJHHXEUNZVVKXCURXFHYDUNZVVKXCURZVXIAHVUEHVUTVURVUTUURAVXKVX
          JVVKXCAHAHVUTYGYEYFAVUSVVKWJUMZXFWJUMZYCXFXCURZVGZVXLVXIYQVUTVXDVXPAV
          XNVXOUUMUUNUUOZXRZHVVKXFUUPWBYHAHVVLVUTVXEAYCGWJXCUUQUUSZHUQAYCVXSUQU
          RZYCULUPZUQURZULGUSZAGWJWTZGUUTUVAZVYCACULDGJLMNOPRSTUAUBUCUDUEUFUVBZ
          UVCZAVYDVYEUYNVYAUQURZULGUSZBWJUTZYCWJUMZVXTVYCYQAVYDVYEVYCVYFUVDZAVY
          DVYEVYCVYFUVEAVYKVYCVYJYIVYGVYIVYCBYCWJUYNYCVHVYHVYBULGUYNYCVYAUQUVHY
          JYKUVFZVYKAYIXRBULULGYCUVGUVIUVJUGUVKZAVXMYCVVKUQURVXPYCVVLUQURZVXDAV
          UEHVURVUTAVUPVUKVULYCVUEUQURVUQUDVUIDFEOYLWBVYNUVLVXRVVKXFUVMUVNZUVOA
          VWCVXBVXGVXFUVQUVPUVRUVSUVTVVNVVEVXAAVVEVVJUBWDVWECPVVDUWAVSQXSVWRVWF
          IVWSXNVWSVTVWOIVHZVWQVWECPVYQVWPVWDVWBUQVWOIVWCXEYMYNUWBUWCWSUIYOYPVW
          GVVNVVPCOUWDXRVVNVWFVVPCPXHZVVQVVNVWEVVPCPVVNVUCVGZVWEVWBVXBUQURVVPVY
          SVWDVXBVWBUQVYSVWDVWCVXCXEUNVXBIVXCVWCXEUKUWFVYSVWCVXBVYSVWCAVWCWJUMV
          VJVUCVXGYRYGVYSVXBVYSVVLAVVLWJUMZVVJVUCVXEYRZYBYGUWEVOYNVYSVVOVVLVYSV
          UPVUKVVCVVOWJUMAVUPVVJVUCVUQYRZAVUKVVJVUCUDYRZAVUCVVCVVJVVHUWGZDUYIEO
          WIWBWUAVYSVUPVUKVVCYCVVOUQURWUBWUCWUDDUYIEOYLWBAVYOVVJVUCVYPYRUWHUWIU
          WJVVNVVFVYRVVQWTAVVFVVJVVGWDVVPCPOUWOVSUWKVWFVVQUYSOUWLUWMVVQUYSLUWNV
          SAFUYTUMVVJAVUAUYTFUYTPUWPVUBVFWDYPVVNVVQLYSUOZUMVVSVVQVHVVNVVQEUWQUO
          ZYSUOZWUEVVNEOUWRUOUMZVUKVVLUWSUMVVQWUGUMAWUHVVJAVUJJUWTUMZWUHVUNJUXF
          ZEJORUHUXAWHWDAVUKVVJUDWDVVNVVLAVYTVVJVXEWDUXBCEDVVLVVQWUFOWUFVTVVQVT
          UXCWBVVNLWUFYSALWUFVHZVVJAVUJWUIWUKVUNWUJELJOUERUHUXDWHWDYTUXEVVQLUXG
          VSUXHVVRVULVVMVVPVVMCFOUYIFVHVVOVUEVVLUQUYIFDEYMYFUXOUXIVSAVVIVVMAVVI
          VUEVUEXEUNZVVKUQURXFVUEYDUNZVVKUQURZVVMAVUEHVUEVURVUTVURUXJAWUMWULVVK
          UQAVUEAVUEVURYGYEYFAVUOVXMWUNVVMYQZVURVXDVUOVXMVXPWUOVXQVUEVVKXFUXKUX
          LWSYHUXMUXNUYDUXPUXQWDVUDHVXSUYKUQUGVUDVYDVYJUYKGUMVXSUYKUQURAVYDVUCV
          YLWDAVYJVUCVYMWDVUDUYKCPUYKXTZYAZGVUDVUCUYKXNUMUYKWUQUMAVUCUXRUYJNXQC
          PUYKWUPXNWUPVTUXSUXTUFYOBULUYKGUYEWBUYAUYBUYFUYCUYRUYMBFPUYNFVHZUYQUY
          LCPWURUYPUYHUYKUQWURUYOUYGNUYNFDMYMYTYFYJYKWS $.
      $}

      $( Lemma for ~ minvec .  Discharge the assumptions in ~ minveclem4 .
         (Contributed by Mario Carneiro, 9-May-2014.)  (Revised by Mario
         Carneiro, 15-Oct-2015.) $)
      minveclem5 $p |- ( ph -> E. x e. Y A. y e. Y
                        ( N ` ( A .- x ) ) <_ ( N ` ( A .- y ) ) ) $=
        ( vs vz vr crp cv co c2 cexp caddc cle wbr crab cmpt crn cfg cflim cuni
        cdiv cmin weq oveq2 breq2d rabbidv oveq1d breq1d cbvrabv syl6eq cbvmptv
        rneqi eqid minveclem4 ) ABCDEILUEUHDUFUIZEUJZUKULUJZGUKULUJZUEUIZUMUJZU
        NUOZUFMUPZUQZURZUSUJUTUJVAZFGDWFEUJGUMUJUKVBUJUKULUJVSVCUJZHWEIJKLMUGNO
        PQRSTUAUBUCUDWDUGUHDCUIZEUJZUKULUJZVSUGUIZUMUJZUNUOZCMUPZUQUEUGUHWCWNUE
        UGVDZWCVRWLUNUOZUFMUPWNWOWBWPUFMWOWAWLVRUNVTWKVSUMVEVFVGWPWMUFCMUFCVDZV
        RWJWLUNWQVQWIUKULVPWHDEVEVHVIVJVKVLVMWFVNWGVNVO $.

      $( Lemma for ~ minvec .  Any minimal point is less than ` S ` away from
         ` A ` .  (Contributed by Mario Carneiro, 9-May-2014.)  (Revised by
         Mario Carneiro, 15-Oct-2015.) $)
      minveclem6 $p |- ( ( ph /\ x e. Y ) ->
        ( ( ( A D x ) ^ 2 ) <_ ( ( S ^ 2 ) + 0 ) <->
          A. y e. Y ( N ` ( A .- x ) ) <_ ( N ` ( A .- y ) ) ) ) $=
        ( vw cv wcel wa co cexp cc0 caddc cle wbr cfv wral cds cxp oveqi adantr
        cres clss wss eqid lssss syl sselda ovresd syl5eq cngp wceq ccph cphngp
        c2 ngpds syl3anc eqtrd oveq1d cr clt ccnv csup c0 wne minveclem1 simp1d
        w3a simp2d 0re a1i simp3d breq1 ralbidv rspcev syl2anc infmrcl syl5eqel
        wrex resqcld recnd addid1d breq12d cphlmod lmodvsubcl nmcl wb infmrgelb
        clmod nmge0 syl31anc mpbird syl6breqr le2sqd breq2i syl5bb 3bitr2d cmpt
        crn raleqi cvv fvex rgenw breq2 ralrnmpt ax-mp bitri syl6bb ) ABUFZMUGZ
        UHZDYHEUIZVNUJUIZGVNUJUIZUKULUIZUMUNZDYHJUIZKUOZUEUFZUMUNZUEFUPZYQDCUFJ
        UIZKUOZUMUNZCMUPZYJYOYQVNUJUIZYMUMUNYQGUMUNZYTYJYLUUEYNYMUMYJYKYQVNUJYJ
        YKDYHHUQUOZUIZYQYJYKDYHUUGLLURVAZUIUUHEUUIDYHUDUSYJDYHUUGLADLUGZYITUTZA
        MLYHAMHVBUOZUGMLVCRUULMLHNUULVDVEVFVGZVHVIYJHVJUGZUUJYHLUGZUUHYQVKAUUNY
        IAHVLUGZUUNQHVMVFUTZUUKUUMDYHUUGHJKLPNOUUGVDVOVPVQVRYJYMYJYMYJGYJGFVSVT
        WAWBZVSUCYJFVSVCZFWCWDZYHYRUMUNZUEFUPZBVSWRZUURVSUGYJUUSUUTUKYRUMUNZUEF
        UPZAUUSUUTUVEWGYIACUEDFHIJKLMNOPQRSTUAUBWEUTZWFZYJUUSUUTUVEUVFWHZYJUKVS
        UGZUVEUVCUVIYJWIWJZYJUUSUUTUVEUVFWKZUVBUVEBUKVSYHUKVKUVAUVDUEFYHUKYRUMW
        LWMWNWOZBUEFWPVPWQZWSWTXAXBYJYQGYJUUNYPLUGZYQVSUGZUUQYJHXHUGZUUJUUOUVNA
        UVPYIAUUPUVPQHXCVFUTUUKUUMJLHDYHNOXDVPZYPHKLNPXEWOZUVMYJUUNUVNUKYQUMUNU
        UQUVQYPHKLNPXIWOYJUKUURGUMYJUKUURUMUNZUVEUVKYJUUSUUTUVCUVIUVSUVEXFUVGUV
        HUVLUVJBUEUEFUKXGXJXKUCXLXMUUFYQUURUMUNZYJYTGUURYQUMUCXNYJUUSUUTUVCUVOU
        VTYTXFUVGUVHUVLUVRBUEUEFYQXGXJXOXPYTYSUECMUUBXQZXRZUPZUUDYSUEFUWBUBXSUU
        BXTUGZCMUPUWCUUDXFUWDCMUUAKYAYBYSUUCCUEMUUBUWAXTUWAVDYRUUBYQUMYCYDYEYFY
        G $.

      $( Lemma for ~ minvec .  Since any two minimal points are distance zero
         away from each other, the minimal point is unique.  (Contributed by
         Mario Carneiro, 9-May-2014.)  (Revised by Mario Carneiro,
         15-Oct-2015.) $)
      minveclem7 $p |- ( ph -> E! x e. Y A. y e. Y
                        ( N ` ( A .- x ) ) <_ ( N ` ( A .- y ) ) ) $=
        ( vw cv co cfv cle wbr wral wrex wa wceq wi wreu minveclem5 wcel c2 cc0
        cexp caddc c4 cmul ccph ad2antrr clss cress ccms cr 0re simplrl simplrr
        a1i 0le0 simprl simprr minveclem2 ex minveclem6 adantrr adantrl anbi12d
        wb 4cn mul01i breq2i cme cmt cngp cphngp ngpms 3syl adantr syl wss eqid
        msmet lssss sseldd metcl syl3anc sqge0d biantrud resqcld letri3 sylancl
        recnd sqeq0 meteq0 bitrd 3bitr2d syl5bb 3imtr3d ralrimivva oveq2 fveq2d
        cc breq1d ralbidv reu4 sylanbrc ) ADBUFZJUGZKUHZDCUFJUGKUHZUIUJZCMUKZBM
        ULYHDUEUFZJUGZKUHZYFUIUJZCMUKZUMZYCYIUNZUOZUEMUKBMUKYHBMUPABCDEFGHIJKLM
        NOPQRSTUAUBUCUDUQAYPBUEMMAYCMURZYIMURZUMZUMZDYCEUGUSVAUGGUSVAUGUTVBUGZU
        IUJZDYIEUGUSVAUGUUAUIUJZUMZYCYIEUGZUSVAUGZVCUTVDUGZUIUJZYNYOYTUUDUUHYTU
        UDUMZCDUTEFGHIYCYIJKLMNOPAHVEURZYSUUDQVFAMHVGUHZURZYSUUDRVFAHMVHUGVIURY
        SUUDSVFADLURYSUUDTVFUAUBUCUDUTVJURZUUIVKVNUTUTUIUJUUIVOVNAYQYRUUDVLAYQY
        RUUDVMYTUUBUUCVPYTUUBUUCVQVRVSYTUUBYHUUCYMAYQUUBYHWDYRABCDEFGHIJKLMNOPQ
        RSTUAUBUCUDVTWAAYRUUCYMWDYQAUECDEFGHIJKLMNOPQRSTUAUBUCUDVTWBWCUUHUUFUTU
        IUJZYTYOUUGUTUUFUIVCWEWFWGYTUUNUUNUTUUFUIUJZUMZUUFUTUNZYOYTUUOUUNYTUUEY
        TELWHUHURZYCLURZYILURZUUEVJURYTHWIURZUURAUVAYSAUUJHWJURUVAQHWKHWLWMWNEH
        LNUDWRWOZYTMLYCAMLWPZYSAUULUVCRUUKMLHNUUKWQWSWOWNZAYQYRVPWTZYTMLYIUVDAY
        QYRVQWTZYCYIELXAXBZXCXDYTUUFVJURUUMUUQUUPWDYTUUEUVGXEVKUUFUTXFXGYTUUQUU
        EUTUNZYOYTUUEXRURUUQUVHWDYTUUEUVGXHUUEXIWOYTUURUUSUUTUVHYOWDUVBUVEUVFYC
        YIELXJXBXKXLXMXNXOYHYMBUEMYOYGYLCMYOYEYKYFUIYOYDYJKYCYIDJXPXQXSXTYAYB
        $.
    $}

    $( Minimizing vector theorem, or the Hilbert projection theorem.  There is
       exactly one vector in a complete subspace ` W ` that minimizes the
       distance to an arbitrary vector ` A ` in a parent inner product space.
       Theorem 3.3-1 of [Kreyszig] p. 144, specialized to subspaces instead of
       convex subsets.  (Contributed by NM, 11-Apr-2008.)  (Proof shortened by
       Mario Carneiro, 9-May-2014.)  (Revised by Mario Carneiro,
       15-Oct-2015.) $)
    minvec $p |- ( ph -> E! x e. Y A. y e. Y
                   ( N ` ( A .- x ) ) <_ ( N ` ( A .- y ) ) ) $=
      ( vj cfv cv eqid cds cxp cres co cmpt crn cr ccnv csup ctopn oveq2 fveq2d
      clt weq cbvmptv rneqi minveclem7 ) ABCDEUARHHUBUCZQIDQSZFUDZGRZUEZUFZVCUG
      UMUHUIZEEUJRZFGHIJKLMNOPVETVBCIDCSZFUDZGRZUEQCIVAVHQCUNUTVGGUSVFDFUKULUOU
      PVDTURTUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projection Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z .- $.  $d w z ., $.  $d w x y z A $.  $d x B $.  $d w x y z N $.
    $d x .(+) $.  $d x O $.  $d w x y z ph $.  $d w x y z U $.  $d w x y z V $.
    $d y .+ $.  $d x T $.  $d w x y z W $.
    pjthlem.v $e |- V = ( Base ` W ) $.
    pjthlem.n $e |- N = ( norm ` W ) $.
    pjthlem.p $e |- .+ = ( +g ` W ) $.
    pjthlem.m $e |- .- = ( -g ` W ) $.
    pjthlem.h $e |- ., = ( .i ` W ) $.
    pjthlem.l $e |- L = ( LSubSp ` W ) $.
    pjthlem.1 $e |- ( ph -> W e. CHil ) $.
    pjthlem.2 $e |- ( ph -> U e. L ) $.
    pjthlem.4 $e |- ( ph -> A e. V ) $.
    ${
      pjthlem.5 $e |- ( ph -> B e. U ) $.
      pjthlem.7 $e |- ( ph ->
        A. x e. U ( N ` A ) <_ ( N ` ( A .- x ) ) ) $.
      pjthlem.8 $e |- T = ( ( A ., B ) / ( ( B ., B ) + 1 ) ) $.
      $( Lemma for ~ pjth .  (Contributed by NM, 10-Oct-1999.)  (Revised by
         Mario Carneiro, 17-Oct-2015.) $)
      pjthlem1 $p |- ( ph -> ( A ., B ) = 0 ) $=
        ( co ccph wcel cc chl hlcph syl wss lssss sseldd cphipcl syl3anc abscld
        cabs cfv recnd c2 cexp cc0 wceq cle wbr cneg cr caddc clt cmul renegcld
        resqcld reipcl syl2anc 2re readdcl sylancl 0re a1i peano2re ipge0 ltp1d
        lelttrd ax-1cn addass mp3an23 df-2 oveq2i syl6reqr breqtrrd lttrd cvsca
        c1 cdiv cmin cv wral clmod csca cbs cphlmod cphl hlphl eqid ipcl hlress
        ge0p1rpd rpne0d cphdivcl syl13anc syl5eqel lssvscl syl22anc oveq2 nmge0
        wne nmcl mpbird crp remulcld cphsubdi oveq1d eqeltrd oveq2d ccj mulcomd
        nmsq cjcld absvalsqd fveq2i cjred syl5eq 3eqtr4rd 3eqtrd oveq12d div23d
        eqtrd 3eqtr3d fveq2d breq2d sylc cngp cphngp lmodvscl lmodvsubcl le2sqd
        rspcv mpbid subge0d rpexpcl rerpdivcld negcld pncand cphsubdir subsub4d
        cz 2z subcld adddid cphassr divcld divassd cjdivd sqvald divcan5d rpcnd
        eqtr2d cphipcj cph2ass syl122anc absdivd rpge0d 3eqtr4d negsubd addcomd
        absidd sqdivd pncan2 subdid 3eqtr2d mulneg2d mulneg12 prodge02 le0neg1d
        eqtr3d ge0divd sqge0d wa wb letri3 mpbir2and sqeq0d abs00d ) ACDHUFZAMU
        GUHZCLUHZDLUHZUWPUIUHAMUJUHZUWQTMUKULZUBAGLDAGIUHZGLUMUAIGLMNSUNULUCUOZ
        CDHLMNRUPUQZAUWPUSUTZAUXEAUWPUXDURZVAZAUXEVBVCUFZVDVEZUXHVDVFVGZVDUXHVF
        VGZAUXJVDUXHVHZVFVGZAUXLVIUHDDHUFZVBVJUFZVIUHZVDUXOVKVGVDUXLUXOVLUFZVFV
        GUXMAUXHAUXEUXFVNZVMAUXNVIUHZVBVIUHUXPAUWQUWSUXSUXAUXCDHLMNRVOVPZVQUXNV
        BVRVSZAVDUXNWOVJUFZUXOVDVIUHZAVTWAZAUXSUYBVIUHUXTUXNWBULZUYAAVDUXNUYBUY
        DUXTUYEAUWQUWSVDUXNVFVGUXAUXCDHLMNRWCVPZAUXNUXTWDWEAUYBUYBWOVJUFZUXOVKA
        UYBUYEWDAUYGUXNWOWOVJUFZVJUFZUXOAUXNUIUHZUYGUYIVEZAUXNUXTVAZUYJWOUIUHZU
        YMUYKWFWFUXNWOWOWGWHULVBUYHUXNVJWIWJWKZWLWMAVDUXHUXOVHZVLUFZUXQVFAVDUYP
        VFVGVDUYPUYBVBVCUFZWPUFZVFVGAVDCFDMWNUTZUFZJUFZKUTZVBVCUFZCKUTZVBVCUFZW
        QUFZUYRVFAVDVUFVFVGVUEVUCVFVGZAVUDVUBVFVGZVUGAUYTGUHZVUDCBWRZJUFZKUTZVF
        VGZBGWSVUHAMWTUHZUXBFMXAUTZXBUTZUHZDGUHVUIAUWQVUNUXAMXCULZUAAFUWPUYBWPU
        FZVUPUEAUWQUWPVUPUHZUYBVUPUHUYBVDXRVUSVUPUHUXAAMXDUHZUWRUWSVUTAUWTVVATM
        XEULUBUXCCDVUOHVUPLMVUOXFZRNVUPXFZXGUQAVIVUPUYBAUWTVIVUPUMTVUOVUPMVVBVV
        CXHULUYEUOAUYBAUXNUXTUYFXIZXJZUWPUYBVUOVUPMVVBVVCXKXLXMZUCVUPIUYSGVUOMF
        DVVBUYSXFZVVCSXNXOUDVUMVUHBUYTGVUJUYTVEZVULVUBVUDVFVVHVUKVUAKVUJUYTCJXP
        UUAUUBUUIUUCAVUDVUBAMUUDUHZUWRVUDVIUHAUWQVVIUXAMUUEULZUBCMKLNOXSVPZAVVI
        VUALUHZVUBVIUHVVJAVUNUWRUYTLUHZVVLVURUBAVUNVUQUWSVVMVURVVFUXCFUYSVUOVUP
        LMDNVVBVVGVVCUUFUQZJLMCUYTNQUUGUQZVUAMKLNOXSVPZAVVIUWRVDVUDVFVGVVJUBCMK
        LNOXQVPAVVIVVLVDVUBVFVGVVJVVOVUAMKLNOXQVPUUHUUJAVUCVUEAVUBVVPVNAVUDVVKV
        NUUKXTAUXHUYQWPUFZUXOVLUFZVHZCCHUFZVJUFZVVTWQUFVVSVUFUYRAVVSVVTAVVRAVVR
        AVVQUXOAUXHUYQUXRAUYBYAUHVBUURUHUYQYAUHVVDUUSUYBVBUULVSZUUMZUYAYBVAZUUN
        ZAUWQUWRUWRVVTUIUHUXAUBUBCCHLMNRUPUQZUUOAVUCVWAVUEVVTWQAVUCVVTVVRWQUFZV
        VTVVSVJUFVWAAVUCVUAVUAHUFZCVUAHUFZUYTVUAHUFZWQUFZVWGAUWQVVLVUCVWHVEUXAV
        VOVUAHKLMNROYIVPAUWQUWRVVMVVLVWHVWKVEUXAUBVVNVVOCUYTVUAHJLMRNQUUPXLAVWK
        VVTCUYTHUFZWQUFZVWJWQUFVVTVWLVWJVJUFZWQUFVWGAVWIVWMVWJWQAUWQUWRUWRVVMVW
        IVWMVEUXAUBUBVVNCCUYTHJLMRNQYCXLYDAVVTVWLVWJVWFAUWQUWRVVMVWLUIUHUXAUBVV
        NCUYTHLMNRUPUQAVWJUYTCHUFZUYTUYTHUFZWQUFZUIAUWQVVMUWRVVMVWJVWQVEUXAVVNU
        BVVNUYTCUYTHJLMRNQYCXLZAVWOVWPAUWQVVMUWRVWOUIUHUXAVVNUBUYTCHLMNRUPUQAUW
        QVVMVVMVWPUIUHUXAVVNVVNUYTUYTHLMNRUPUQUUTYEUUQAVWNVVRVVTWQAVVQUYGVLUFVV
        QUYBVLUFZVVQWOVLUFZVJUFVVRVWNAVVQUYBWOAVVQVWCVAZAUYBUYEVAZUYMAWFWAUVAAU
        XOUYGVVQVLUYNYFAVWLVWSVWJVWTVJAVWLUXHUYBWPUFZUXHUYBVLUFZUYQWPUFZVWSAVWL
        FYGUTZUWPVLUFZUWPVXFVLUFZVXCAUWQVUQUWRUWSVWLVXGVEUXAVVFUBUXCFCDUYSVUOHV
        UPLMRNVVBVVCVVGUVBXLAVXFUWPAFAFVUSUIUEAUWPUYBUXDVXBVVEUVCXMZYJUXDYHAUWP
        UWPYGUTZVLUFZUYBWPUFUWPVXJUYBWPUFZVLUFVXCVXHAUWPVXJUYBUXDAUWPUXDYJVXBVV
        EUVDAUXHVXKUYBWPAUWPUXDYKYDAVXFVXLUWPVLAVXFVUSYGUTZVXLFVUSYGUEYLAVXMVXJ
        UYBYGUTZWPUFVXLAUWPUYBUXDVXBVVEUVEAVXNUYBVXJWPAUYBUYEYMYFYSYNYFYOYPAVXE
        UYBUXHVLUFZUYBUYBVLUFZWPUFVXCAVXDVXOUYQVXPWPAUXHUYBAUXHUXRVAZVXBYHAUYBV
        XBUVFYQAUXHUYBUYBVXQVXBVXBVVEVVEUVGUVIAUXHUYBUYQVXQVXBAUYQVWBUVHZAUYQVW
        BXJZYRYPZAVWQVWSVVQUXNVLUFZWQUFZVWJVWTAVWOVWSVWPVYAWQAVWLYGUTZVWLVWOVWS
        AVWLAVWLVWSVIVXTAVVQUYBVWCUYEYBYEYMAUWQUWRVVMVYCVWOVEUXAUBVVNCUYTHLMRNU
        VJUQVXTYTAVWPFVXFVLUFZUXNVLUFZVYAAUWQVUQVUQUWSUWSVWPVYEVEUXAVVFVVFUXCUX
        CFFDDUYSVUOHVUPLMRNVVBVVCVVGUVKUVLAVYDVVQUXNVLAFUSUTZVBVCUFUXEUYBWPUFZV
        BVCUFVYDVVQAVYFVYGVBVCAVYFVUSUSUTZVYGFVUSUSUEYLAVYHUXEUYBUSUTZWPUFVYGAU
        WPUYBUXDVXBVVEUVMAVYIUYBUXEWPAUYBUYEAUYBVVDUVNUVRYFYSYNYDAFVXIYKAUXEUYB
        UXGVXBVVEUVSYTYDYSYQVWRAVVQUYBUXNWQUFZVLUFVWTVYBAVYJWOVVQVLAUYJUYMVYJWO
        VEUYLWFUXNWOUVTVSYFAVVQUYBUXNVXAVXBUYLUWAUWGUVOYQYOYFYPYPAVVTVVRVWFVWDU
        VPAVVTVVSVWFVWEUVQUWBAUWQUWRVUEVVTVEUXAUBCHKLMNROYIVPYQAUYRVVQUYOVLUFVV
        SAUXHUYOUYQVXQAUYOAUXOUYAVMZVAVXRVXSYRAVVQUXOVXAAUXOUYAVAZUWCYSYOWLAUYP
        UYQAUXHUYOUXRVYKYBVWBUWHXTAUXHUIUHUXOUIUHUXQUYPVEVXQVYLUXHUXOUWDVPWLUXL
        UXOUWEXOAUXHUXRUWFXTAUXEUXFUWIAUXHVIUHUYCUXIUXJUXKUWJUWKUXRVTUXHVDUWLVS
        UWMUWNUWO $.
    $}

    pjthlem.j $e |- J = ( TopOpen ` W ) $.
    pjthlem.s $e |- .(+) = ( LSSum ` W ) $.
    pjthlem.o $e |- O = ( ocv ` W ) $.
    pjthlem.3 $e |- ( ph -> U e. ( Clsd ` J ) ) $.
    $( Lemma for ~ pjth .  (Contributed by NM, 10-Oct-1999.)  (Revised by Mario
       Carneiro, 15-May-2014.) $)
    pjthlem2 $p |- ( ph -> A e. ( U .(+) ( O ` U ) ) ) $=
      ( vx vy vz vw cv co cfv cle wbr wral wcel wreu wrex chl ccph syl syl6eleq
      hlcph clss cress ccms ccld wss wb hlcms lssss cmsss syl2anc mpbird minvec
      eqid reurex wa cabel clmod adantr cphlmod lmodabl simprl sseldd ablpncan3
      wceq syl12anc csubg lsssssubg cphl cphphl csca c0g lmodvsubcl syl3anc cc0
      ocvlss c1 caddc cdiv ad2antrr simpr lssvacl syl22anc simplrr oveq2 fveq2d
      breq2d rspcv sylc lmodgrp grpsubsub4 syl13anc breqtrrd ralrimiva pjthlem1
      cgrp sselda cclm cphclm clm0 eqtrd syl3anbrc lsmelvali eqeltrrd rexlimddv
      elocv ) ABUGUKZIULZJUMZBUHUKZIULZJUMZUNUOZUHEUPZBEEKUMZDULZUQUGEAYQUGEURY
      QUGEUSAUGUHBMIJLENQOAMUTUQZMVAUQZTMVDVBZAEHMVEUMUASVCAMEVFULZVGUQZEGVHUMU
      QZUFAMVGUQZELVIZUUDUUEVJAYTUUFTMVKVBAEHUQZUUGUAHELMNSVLZVBEGUUCMLUUCVQNUC
      VMVNVOUBVPYQUGEVRVBAYJEUQZYQVSZVSZYJYKCULZBYSUULMVTUQZYJLUQZBLUQZUUMBWHUU
      LMWAUQZUUNUULUUAUUQAUUAUUKUUBWBZMWCVBZMWDVBUULELYJUULUUHUUGAUUHUUKUAWBZUU
      IVBZAUUJYQWEZWFZAUUPUUKUBWBZLCMIYJBNPQWGWIUULEMWJUMZUQYRUVEUQUUJYKYRUQZUU
      MYSUQUULHUVEEUULUUQHUVEVIUUSHMSWKVBZUUTWFUULHUVEYRUVGUULMWLUQZUUGYRHUQUUL
      UUAUVHUURMWMVBUVAEHKLMNUESWSVNWFUVBUULUUGYKLUQZYKUIUKZFULZMWNUMZWOUMZWHZU
      IEUPUVFUVAUULUUQUUPUUOUVIUUSUVDUVCILMBYJNQWPWQZUULUVNUIEUULUVJEUQZVSZUVKW
      RUVMUVQUJYKUVJCUVKUVJUVJFULWTXAULXBULZEFHIJLMNOPQRSAYTUUKUVPTXCUULUUHUVPU
      UTWBUULUVIUVPUVOWBUULUVPXDUULYLYKUJUKZIULZJUMZUNUOZUJEUPUVPUULUWBUJEUULUV
      SEUQZVSZYLBUVSYJCULZIULZJUMZUWAUNUWDUWEEUQZYQYLUWGUNUOZUWDUUQUUHUWCUUJUWH
      UULUUQUWCUUSWBUULUUHUWCUUTWBUULUWCXDUULUUJUWCUVBWBCHEMUVSYJPSXEXFAUUJYQUW
      CXGYPUWIUHUWEEYMUWEWHZYOUWGYLUNUWJYNUWFJYMUWEBIXHXIXJXKXLUWDUVTUWFJUWDMXS
      UQZUUPUUOUVSLUQUVTUWFWHUULUWKUWCUULUUQUWKUUSMXMVBWBUULUUPUWCUVDWBUULUUOUW
      CUVCWBUULELUVSUVAXTLCMIBYJUVSNPQXNXOXIXPXQWBUVRVQXRUVQMYAUQZWRUVMWHUVQUUA
      UWLUULUUAUVPUURWBMYBVBUVLMUVLVQZYCVBYDXQUIYKEUVLFKLMUVMNRUWMUVMVQUEYIYECD
      EYRMYJYKPUDYFXFYGYH $.
  $}

  ${
    $d x .(+) $.  $d x J $.  $d x L $.  $d x O $.  $d x U $.  $d x V $.
    $d x W $.
    pjth.v $e |- V = ( Base ` W ) $.
    pjth.s $e |- .(+) = ( LSSum ` W ) $.
    pjth.o $e |- O = ( ocv ` W ) $.
    pjth.j $e |- J = ( TopOpen ` W ) $.
    pjth.l $e |- L = ( LSubSp ` W ) $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       uniquely into a member ` x ` of a closed subspace ` H ` and a member
       ` y ` of the complement of the subspace.  Theorem 3.7(i) of [Beran]
       p. 102 (existence part).  (Contributed by NM, 23-Oct-1999.)  (Revised by
       Mario Carneiro, 14-May-2014.) $)
    pjth $p |- ( ( W e. CHil /\ U e. L /\ U e. ( Clsd ` J ) ) ->
      ( U .(+) ( O ` U ) ) = V ) $=
      ( vx chl wcel cfv wss syl lssss eqid ccld w3a co clmod cphl hlphl phllmod
      3ad2ant1 simp2 3ad2ant2 ocvlss syl2anc lsmcl syl3anc cv wa cplusg cip csg
      cnm simpl1 simpl2 simpr simpl3 pjthlem2 ex ssrdv eqssd ) GNOZBDOZBCUAPOZU
      BZBBEPZAUCZFVLVNDOZVNFQVLGUDOZVJVMDOZVOVLGUEOZVPVIVJVRVKGUFUHZGUGRVIVJVKU
      IVLVRBFQZVQVSVJVIVTVKDBFGHLSUJBDEFGHJLUKULADBVMGLIUMUNDVNFGHLSRVLMFVNVLMU
      OZFOZWAVNOVLWBUPWAGUQPZABGURPZCDGUSPZGUTPZEFGHWFTWCTWETWDTLVIVJVKWBVAVIVJ
      VKWBVBVLWBVCKIJVIVJVKWBVDVEVFVGVH $.
  $}

  ${
    pjth2.j $e |- J = ( TopOpen ` W ) $.
    pjth2.l $e |- L = ( LSubSp ` W ) $.
    pjth2.k $e |- K = ( proj ` W ) $.
    $( Projection Theorem with abbreviations:  A topologically closed subspace
       is a projection subspace.  (Contributed by Mario Carneiro,
       17-Oct-2015.) $)
    pjth2 $p |- ( ( W e. CHil /\ U e. L /\ U e. ( Clsd ` J ) ) ->
      U e. dom K ) $=
      ( chl wcel ccld cfv w3a cdm cocv clsm co cbs wceq eqid simp2 pjth cphl wa
      wb hlphl 3ad2ant1 pjdm2 syl mpbir2and ) EIJZADJZABKLJZMZACNJZULAAEOLZLEPL
      ZQERLZSZUKULUMUAUQABDUPUREURTZUQTZUPTZFGUBUNEUCJZUOULUSUDUEUKULVCUMEUFUGU
      QACDUPUREUTGVBVAHUHUIUJ $.
  $}

  ${
    $d x C $.  $d x J $.  $d x L $.  $d x W $.
    cldcss.v $e |- V = ( Base ` W ) $.
    cldcss.j $e |- J = ( TopOpen ` W ) $.
    cldcss.l $e |- L = ( LSubSp ` W ) $.
    cldcss.c $e |- C = ( CSubSp ` W ) $.
    $( Corollary of the Projection Theorem:  A topologically closed subspace is
       algebraically closed in Hilbert space.  (Contributed by Mario Carneiro,
       17-Oct-2015.) $)
    cldcss $p |- ( W e. CHil ->
      ( U e. C <-> ( U e. L /\ U e. ( Clsd ` J ) ) ) ) $=
      ( chl wcel ccld cfv wa cphl hlphl csslss sylan ccph hlcph jca w3a cpj cdm
      csscld wss 3ad2ant1 eqid pjcss syl pjth2 sseldd 3expb impbida ) FKLZBALZB
      DLZBCMNLZOUPUQOURUSUPFPLZUQURFQZABDFJIRSUPFTLUQUSFUAABCFJHUFSUBUPURUSUQUP
      URUSUCZFUDNZUEZABVBUTVDAUGUPURUTUSVAUHAVCFVCUIZJUJUKBCVCDFHIVEULUMUNUO $.

    $( Corollary of the Projection Theorem:  A topologically closed subspace is
       algebraically closed in Hilbert space.  (Contributed by Mario Carneiro,
       17-Oct-2015.) $)
    cldcss2 $p |- ( W e. CHil -> C = ( L i^i ( Clsd ` J ) ) ) $=
      ( vx chl wcel ccld cfv cin cv wa cldcss elin syl6bbr eqrdv ) EKLZJACBMNZO
      ZUBJPZALUECLUEUCLQUEUDLAUEBCDEFGHIRUECUCSTUA $.
  $}

  ${
    $d x W $.
    $( Corollary of the Projection Theorem:  A complex Hilbert space is a
       Hilbert space (in the algebraic sense, meaning that all algebraically
       closed subspaces have a projection decomposition).  (Contributed by
       Mario Carneiro, 17-Oct-2015.) $)
    hlhil $p |- ( W e. CHil -> W e. Hil ) $=
      ( chl wcel cphl cpj cfv cdm ccss wceq chs hlphl wss eqid pjcss clss ctopn
      vx syl ccld cin cbs cldcss2 cv wa pjth2 3expib syl5bi ssrdv eqsstrd eqssd
      elin ishil sylanbrc ) ABCZADCZAEFZGZAHFZIAJCAKZUNUQURUNUOUQURLUSURUPAUPMZ
      URMZNRUNURAOFZAPFZSFZTZUQURVCVBAUAFZAVFMVCMZVBMZVAUBUNQVEUQQUCZVECVIVBCZV
      IVDCZUDUNVIUQCZVIVBVDUKUNVJVKVLVIVCUPVBAVGVHUTUEUFUGUHUIUJURAUPUTVAULUM
      $.
  $}

$(
###############################################################################
                 BASIC REAL AND COMPLEX ANALYSIS
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Continuity
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Intermediate value theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c A $.  $d b c B $.  $d c C $.  $d a b c F $.  $d a b c S $.
    pmltpclem1.1 $e |- ( ph -> A e. S ) $.
    pmltpclem1.2 $e |- ( ph -> B e. S ) $.
    pmltpclem1.3 $e |- ( ph -> C e. S ) $.
    pmltpclem1.4 $e |- ( ph -> A < B ) $.
    pmltpclem1.5 $e |- ( ph -> B < C ) $.
    pmltpclem1.6 $e |- ( ph ->
      ( ( ( F ` A ) < ( F ` B ) /\ ( F ` C ) < ( F ` B ) ) \/
        ( ( F ` B ) < ( F ` A ) /\ ( F ` B ) < ( F ` C ) ) ) ) $.
    $( Lemma for ~ pmltpc .  (Contributed by Mario Carneiro, 1-Jul-2014.) $)
    pmltpclem1 $p |- ( ph ->
      E. a e. S E. b e. S E. c e. S ( a < b /\ b < c /\
        ( ( ( F ` a ) < ( F ` b ) /\ ( F ` c ) < ( F ` b ) ) \/
          ( ( F ` b ) < ( F ` a ) /\ ( F ` b ) < ( F ` c ) ) ) ) ) $=
      ( clt wbr cfv wa wo wcel w3a wrex wceq breq1 breq1d anbi1d breq2d orbi12d
      fveq2 3anbi13d breq2 anbi12d 3anbi123d anbi2d 3anbi23d rspc3ev syl33anc
      cv ) ABEUACEUADEUABCPQZCDPQZBFRZCFRZPQZDFRZVCPQZSZVCVBPQZVCVEPQZSZTZGUSZH
      USZPQZVMIUSZPQZVLFRZVMFRZPQZVOFRZVRPQZSZVRVQPQZVRVTPQZSZTZUBZIEUCHEUCGEUC
      JKLMNOWGUTVAVKUBBVMPQZVPVBVRPQZWASZVRVBPQZWDSZTZUBUTCVOPQZVDVTVCPQZSZVHVC
      VTPQZSZTZUBGHIBCDEEEVLBUDZVNWHWFWMVPVLBVMPUEWTWBWJWEWLWTVSWIWAWTVQVBVRPVL
      BFUJZUFUGWTWCWKWDWTVQVBVRPXAUHUGUIUKVMCUDZWHUTVPWNWMWSVMCBPULVMCVOPUEXBWJ
      WPWLWRXBWIVDWAWOXBVRVCVBPVMCFUJZUHXBVRVCVTPXCUHUMXBWKVHWDWQXBVRVCVBPXCUFX
      BVRVCVTPXCUFUMUIUNVODUDZWNVAWSVKUTVODCPULXDWPVGWRVJXDWOVFVDXDVTVEVCPVODFU
      JZUFUOXDWQVIVHXDVTVEVCPXEUHUOUIUPUQUR $.
  $}

  ${
    $d a b c w x y z A $.  $d a b c w x y z F $.  $d w x y z ph $.  $d b c V $.
    $d a b c U $.  $d a b c W $.  $d b c X $.
    pmltpc.1 $e |- ( ph -> F e. ( RR ^pm RR ) ) $.
    pmltpc.2 $e |- ( ph -> A C_ dom F ) $.
    pmltpc.3 $e |- ( ph -> U e. A ) $.
    pmltpc.4 $e |- ( ph -> V e. A ) $.
    pmltpc.5 $e |- ( ph -> W e. A ) $.
    pmltpc.6 $e |- ( ph -> X e. A ) $.
    pmltpc.7 $e |- ( ph -> U <_ V ) $.
    pmltpc.8 $e |- ( ph -> W <_ X ) $.
    pmltpc.9 $e |- ( ph -> -. ( F ` U ) <_ ( F ` V ) ) $.
    pmltpc.10 $e |- ( ph -> -. ( F ` X ) <_ ( F ` W ) ) $.
    $( Lemma for ~ pmltpc .  (Contributed by Mario Carneiro, 1-Jul-2014.) $)
    pmltpclem2 $p |- ( ph -> E. a e. A E. b e. A E. c e. A ( a < b /\ b < c /\
      ( ( ( F ` a ) < ( F ` b ) /\ ( F ` c ) < ( F ` b ) ) \/
        ( ( F ` b ) < ( F ` a ) /\ ( F ` b ) < ( F ` c ) ) ) ) ) $=
      ( cv clt wbr cfv wa wo w3a wrex wcel ad2antrr simpr wne cdm cr wf wss cpm
      co reex elpm2 sylib simpld sseldd ffvelrnd cle wn ltnled gtned wceq fveq2
      mpbird eqcomd necon3i syl simprd leltned simplr orcd pmltpclem1 ltlecasei
      jca olcd adantr lelttrd lttrd ) AHUAZIUAZUBUCWGJUAZUBUCWFDUDZWGDUDZUBUCWH
      DUDZWJUBUCUEWJWIUBUCWJWKUBUCUEUFUGJBUHIBUHHBUHZFDUDZCDUDZAWMWNUBUCZUEZWLF
      CWPFCUBUCZUEZFCEBDHIJAFBUIZWOWQOUJACBUIZWOWQMUJAEBUIZWOWQNUJWPWQUKACEUBUC
      ZWOWQAXBECULZAWNEDUDZULXCAXDWNADUMZUNEDAXEUNDUOZXEUNUPZADUNUNUQURUIXFXGUE
      KUNUNDUSUSUTVAZVBZABXEELNVCZVDZAXDWNUBUCZWNXDVEUCVFSAXDWNXKAXEUNCDXIABXEC
      LMVCZVDZVGVKZVHECWNXDECVIXDWNECDVJVLVMVNACEAXEUNCAXFXGXHVOZXMVCZAXEUNEXPX
      JVCZQVPVKZUJWRWOXLUEWNWMUBUCZWNXDUBUCZUEWRWOXLAWOWQVQAXLWOWQXOUJWAVRVSWPC
      FVEUCZUEZCFGBDHIJAWTWOYBMUJAWSWOYBOUJAGBUIZWOYBPUJYCCFUBUCFCULZYCWNWMULYE
      YCWMWNAWMUNUIZWOYBAXEUNFDXIABXEFLOVCZVDZUJAWOYBVQZVHFCWNWMFCVIWMWNFCDVJVL
      VMVNYCCFACUNUIZWOYBXQUJAFUNUIZWOYBAXEUNFXPYGVCZUJWPYBUKVPVKAFGUBUCZWOYBAY
      MGFULZAGDUDZWMULYNAWMYOYHAWMYOUBUCZYOWMVEUCVFTAWMYOYHAXEUNGDXIABXEGLPVCZV
      DZVGVKZVHGFYOWMGFDVJVMVNAFGYLAXEUNGXPYQVCZRVPVKZUJYCWOYPUEXTYOWMUBUCZUEYC
      WOYPYIAYPWOYBYSUJWAWBVSAYKWOYLWCAYJWOXQWCVTAWNWMVEUCZUEZWLEGUUDEGUBUCZUEZ
      CEGBDHIJAWTUUCUUEMUJAXAUUCUUENUJAYDUUCUUEPUJAXBUUCUUEXSUJUUDUUEUKUUFXLXDY
      OUBUCZUEYAYOXDUBUCZUEUUFXLUUGAXLUUCUUEXOUJUUDUUGUUEUUDXDWNYOAXDUNUIZUUCXK
      WCAWNUNUIUUCXNWCZAYOUNUIUUCYRWCZAXLUUCXOWCUUDWNWMYOUUJAYFUUCYHWCUUKAUUCUK
      AYPUUCYSWCWDWEZWCWAWBVSUUDGEVEUCZUEZFGEBDHIJAWSUUCUUMOUJAYDUUCUUMPUJAXAUU
      CUUMNUJAYMUUCUUMUUAUJUUNGEUBUCEGULZUUNYOXDULUUOUUNXDYOAUUIUUCUUMXKUJUUDUU
      GUUMUULWCZVHEGYOXDEGVIXDYOEGDVJVLVMVNUUNGEAGUNUIZUUCUUMYTUJAEUNUIZUUCUUMX
      RUJUUDUUMUKVPVKUUNYPUUGUEUUBUUHUEUUNYPUUGAYPUUCUUMYSUJUUPWAVRVSAUURUUCXRW
      CAUUQUUCYTWCVTYHXNVT $.
  $}

  ${
    $d a b c w x y z A $.  $d a b c w x y z F $.
    $( Any function on the reals is either increasing, decreasing, or has a
       triple of points in a vee formation.  (This theorem was created on
       demand by Mario Carneiro for the 6PCM conference in Bialystok,
       1-Jul-2014.)  (Contributed by Mario Carneiro, 1-Jul-2014.) $)
    pmltpc $p |- ( ( F e. ( RR ^pm RR ) /\ A C_ dom F ) ->
      ( A. x e. A A. y e. A ( x <_ y -> ( F ` x ) <_ ( F ` y ) ) \/
        A. x e. A A. y e. A ( x <_ y -> ( F ` y ) <_ ( F ` x ) ) \/
        E. a e. A E. b e. A E. c e. A ( a < b /\ b < c /\
        ( ( ( F ` a ) < ( F ` b ) /\ ( F ` c ) < ( F ` b ) ) \/
          ( ( F ` b ) < ( F ` a ) /\ ( F ` b ) < ( F ` c ) ) ) ) ) ) $=
      ( vz vw wcel wa cv cle wbr cfv wi wral clt wrex wn cr cpm cdm wss w3a w3o
      co wo rexanali rexbii rexnal bitri weq breq1 fveq2 imbi12d breq2 cbvral2v
      breq2d breq1d xchbinx anbi12i reeanv ioran 3bitr4i simplll simpld simpllr
      simprd simplrl simplrr simprll simprrl simprlr simprrr pmltpclem2 syl5bir
      ex rexlimdvva orrd df-3or sylibr ) DUAUAUBUGJZCDUCUDZKZALZBLZMNZWFDOZWGDO
      ZMNZPBCQZACQZWHWJWIMNZPZBCQACQZUHZELZFLZRNWSGLZRNWRDOZWSDOZRNWTDOZXBRNKXB
      XARNXBXCRNKUHUEGCSFCSECSZUHWMWPXDUFWEWQXDWQTZWHWKTZKZBCSZHLZILZMNZXJDOZXI
      DOZMNZTZKZICSZKZHCSACSZWEXDXHACSZXQHCSZKWMTZWPTZKXSXEXTYBYAYCXTWLTZACSYBX
      HYDACWHWKBCUIUJWLACUKULYAXKXNPZICQZTZHCSZYCXQYGHCXKXNICUIUJYHYFHCQWPYFHCU
      KYEWOWFXJMNZXLWIMNZPHIABCCHAUMZXKYIXNYJXIWFXJMUNYKXMWIXLMXIWFDUOUSUPIBUMZ
      YIWHYJWNXJWGWFMUQYLXLWJWIMXJWGDUOUTUPURVAULVBXHXQAHCCVCWMWPVDVEWEXRXDAHCC
      XRXGXPKZICSBCSWEWFCJZXICJZKZKZXDXGXPBICCVCYQYMXDBICCYQWGCJZXJCJZKZKZYMXDU
      UAYMKZCWFDWGXIXJEFGUUBWCWDWEYPYTYMVFZVGUUBWCWDUUCVIUUBYNYOWEYPYTYMVHZVGYQ
      YRYSYMVJUUBYNYOUUDVIYQYRYSYMVKUUAWHXFXPVLUUAXGXKXOVMUUAWHXFXPVNUUAXGXKXOV
      OVPVRVSVQVSVQVTWMWPXDWAWB $.
  $}

  ${
    $d c x y z B $.  $d c x y z D $.  $d c x y z F $.  $d c x y z ph $.
    $d c x y A $.  $d x y z C $.  $d x y z S $.  $d c x y z U $.
    ivth.1 $e |- ( ph -> A e. RR ) $.
    ivth.2 $e |- ( ph -> B e. RR ) $.
    ivth.3 $e |- ( ph -> U e. RR ) $.
    ivth.4 $e |- ( ph -> A < B ) $.
    ivth.5 $e |- ( ph -> ( A [,] B ) C_ D ) $.
    ivth.7 $e |- ( ph -> F e. ( D -cn-> CC ) ) $.
    ivth.8 $e |- ( ( ph /\ x e. ( A [,] B ) ) -> ( F ` x ) e. RR ) $.
    ${
      ivth.9 $e |- ( ph -> ( ( F ` A ) < U /\ U < ( F ` B ) ) ) $.
      ${
        ivth.10 $e |- S = { x e. ( A [,] B ) | ( F ` x ) <_ U } $.
        $( Lemma for ~ ivth .  The set ` S ` of all ` x ` values with
           ` ( F `` x ) ` less than ` U ` is lower bounded by ` A ` and upper
           bounded by ` B ` .  (Contributed by Mario Carneiro, 17-Jun-2014.) $)
        ivthlem1 $p |- ( ph -> ( A e. S /\ A. z e. S z <_ B ) ) $=
          ( wcel wbr cv cle wral cicc co cfv cxr rexrd lbicc2 syl3anc ralrimiva
          ltled cr wceq fveq2 eleq1d rspcv sylc clt simpld breq1d sylanbrc crab
          elrab2 ssrab2 eqsstri sseli iccleub 3expia syl2anc syl5 ralrimiv jca
          wi ) ADGSZCUAZEUBTZCGUCADDEUDUEZSZDIUFZHUBTZVOADUGSZEUGSZDEUBTVSADJUH
          ZAEKUHZADEJKMULDEUIUJZAVTHAVSBUAZIUFZUMSZBVRUCVTUMSZWFAWIBVRPUKWIWJBD
          VRWGDUNZWHVTUMWGDIUOZUPUQURLAVTHUSTHEIUFUSTQUTULWHHUBTZWABDVRGWKWHVTH
          UBWLVARVDVBAVQCGVPGSVPVRSZAVQGVRVPGWMBVRVCVRRWMBVRVEVFVGAWBWCWNVQVNWD
          WEWBWCWNVQDEVPVHVIVJVKVLVM $.

        ivth.11 $e |- C = sup ( S , RR , < ) $.
        $( Lemma for ~ ivth .  Show that the supremum of ` S ` cannot be less
           than ` U ` .  If it was, continuity of ` F ` implies that there are
           points just above the supremum that are also less than ` U ` , a
           contradiction.  (Contributed by Mario Carneiro, 17-Jun-2014.) $)
        ivthlem2 $p |- ( ph -> -. ( F ` C ) < U ) $=
          ( wbr vy vz cfv clt wa cv cmin co cabs wi wral crp wrex wn ccncf wcel
          cc adantr cicc cr cle csup wss c0 wne w3a crab ssrab2 eqsstri iccssre
          syl2anc syl5ss ivthlem1 simpld ne0i syl simprd wceq breq2 rspcev 3jca
          ralbidv suprcl syl5eqel suprub syl6breqr wb suprleub mpbird mpbir3and
          syl5eqbr elicc2 sseldd ralrimiva fveq2 eleq1d rspcv sylc difrp biimpa
          cncfi syl3anc ssralv ad2antrr c2 cdiv caddc cif rphalfcl adantl rpred
          readdcld ifcl cxr rexrd ltled ubicc2 lttr mpan2d imp ltnrd syl5ibrcom
          breq2d notbid necon2ad jctild ltlend sylibrd mpd ltaddrpd ifboth min1
          letrd abssubge0d rpre breq1d recnd syld syl5 rexlimdva rphalflt oveq1
          min2 ltadd2dd lelttrd ltsubadd2d eqbrtrd fveq2d anbi12d r19.29 pm3.45
          syl12anc simprr simprl simplll resubcld absdifltd ltle pncan3d elrab2
          baib ad2antrl 3imtr4d ex 3syl lenltd sylibd adantld mt2d pm2.21d expr
          sylbid com23 imp3a pm2.01da ) AEIUCZHUDTZAUVQUEZUAUFZEUGUHZUIUCZUBUFZ
          UDTZUVSIUCZUVPUGUHUIUCHUVPUGUHZUDTZUJZUAFUKZUBULUMZUVQUNZUVRIFUQUOUHU
          PZEFUPZUWEULUPZUWIAUWKUVQOURAUWLUVQACDUSUHZFENAEUWNUPZEUTUPZCEVATZEDV
          ATZAEGUTUDVBZUTSAGUTVCZGVDVEZUWBBUFZVATZUBGUKZBUTUMZVFZUWSUTUPAUWTUXA
          UXEAGUWNUTGUXBIUCZHVATZBUWNVGUWNRUXHBUWNVHVIACUTUPZDUTUPZUWNUTVCZJKCD
          VJVKZVLACGUPZUXAAUXMUWBDVATZUBGUKZABUBCDFGHIJKLMNOPQRVMZVNZGCVOVPAUXJ
          UXOUXEKAUXMUXOUXPVQZUXDUXOBDUTUXBDVRZUXCUXNUBGUXBDUWBVAVSWBVTVKWAZBUB
          GWCVPWDZACUWSEVAAUXFUXMCUWSVATUXTUXQBUBGCWEVKSWFZAEUWSDVASAUWSDVATZUX
          OUXRAUXFUXJUYCUXOWGUXTKBUBUBGDWHVKWIWKZAUXIUXJUWOUWPUWQUWRVFWGJKCDEWL
          VKWJZWMURAUVQUWMAUVPUTUPZHUTUPZUVQUWMWGAUWOUXGUTUPZBUWNUKZUYFUYEAUYHB
          UWNPWNZUYHUYFBEUWNUXBEVRUXGUVPUTUXBEIWOWPWQWRZLUVPHWSVKWTUBUAFUQEUWEI
          XAXBUVRUWHUWJUBULUVRUWBULUPZUEZUWHUWGUAUWNUKZUWJAUWHUYNUJZUVQUYLAUWNF
          VCUYONUWGUAUWNFXCVPXDUYMUYNUWCEUVSUDTZUEZUAUWNUMZUWJUYMDEUWBXEXFUHZXG
          UHZVATZDUYTXHZUWNUPZVUBEUGUHZUIUCZUWBUDTZEVUBUDTZUYRUYMVUCVUBUTUPZCVU
          BVATZVUBDVATZUYMUXJUYTUTUPZVUHAUXJUVQUYLKXDZUYMEUYSAUWPUVQUYLUYAXDZUY
          MUYSUYLUYSULUPUVRUWBXIXJZXKZXLZVUADUYTUTXMVKZUYMCEVUBAUXIUVQUYLJXDVUM
          VUQAUWQUVQUYLUYBXDUYMEVUBVUMVUQUYMEDUDTZEUYTUDTZVUGUYMUVPDIUCZUDTZVUR
          UVRVVAUYLAUVQVVAAUVQHVUTUDTZVVAACIUCHUDTVVBQVQAUYFUYGVUTUTUPZUVQVVBUE
          VVAUJUYKLADUWNUPZUYIVVCACXNUPDXNUPCDVATVVDACJXOADKXOACDJKMXPCDXQXBUYJ
          UYHVVCBDUWNUXSUXGVUTUTUXBDIWOWPWQWRUVPHVUTXRXBXSXTURAVVAVURUJUVQUYLAV
          VAUWRDEVEZUEVURAVVAVVEUWRAVVADEAVVAUNDEVRZUVPUVPUDTZUNAUVPUYKYAVVFVVA
          VVGVVFVUTUVPUVPUDDEIWOYCYDYBYEUYDYFAEDUYAKYGYHXDYIUYMEUYSVUMVUNYJVUAV
          URVUSVUGDUYTDVUBEUDVSUYTVUBEUDVSYKVKZXPZYMUYMUXJVUKVUJVULVUPDUYTYLVKA
          VUCVUHVUIVUJVFWGZUVQUYLAUXIUXJVVJJKCDVUBWLVKXDWJUYMVUEVUDUWBUDUYMEVUB
          VUMVUQVVIYNUYMVUDUWBUDTVUBEUWBXGUHZUDTUYMVUBUYTVVKVUQVUPUYMEUWBVUMUYL
          UWBUTUPUVRUWBYOXJZXLUYMUXJVUKVUBUYTVATVULVUPDUYTUUCVKUYMUYSUWBEVUOVVL
          VUMUYLUYSUWBUDTUVRUWBUUAXJUUDUUEUYMVUBEUWBVUQVUMVVLUUFWIUUGVVHUYQVUFV
          UGUEUAVUBUWNUVSVUBVRZUWCVUFUYPVUGVVMUWAVUEUWBUDVVMUVTVUDUIUVSVUBEUGUU
          BUUHYPUVSVUBEUDVSUUIVTUULUYNUYRUEUWGUYQUEZUAUWNUMUYMUWJUWGUYQUAUWNUUJ
          UYMVVNUWJUAUWNVVNUWFUYPUEZUYMUVSUWNUPZUEZUWJUWGUYQVVOUWCUWFUYPUUKXTVV
          QUWFUYPUWJVVQUYPUWFUWJUYMVVPUYPUWFUWJUJUYMVVPUYPUEZUEZUWFUWJVVSUWFUYP
          UYMVVPUYPUUMVVSUWFUVPUWEUGUHUWDUDTZUWDUVPUWEXGUHZUDTZUEUYPUNZVVSUWDUV
          PUWEVVSVVPUYIUWDUTUPZUYMVVPUYPUUNZVVSAUYIAUVQUYLVVRUUOZUYJVPUYHVWDBUV
          SUWNUXBUVSVRZUXGUWDUTUXBUVSIWOZWPWQWRZVVSAUYFVWFUYKVPZVVSHUVPVVSAUYGV
          WFLVPZVWJUUPUUQVVSVWBVWCVVTVVSVWBUVSGUPZVWCVVSUWDHUDTZUWDHVATZVWBVWLV
          VSVWDUYGVWMVWNUJVWIVWKUWDHUURVKVVSVWAHUWDUDVVSUVPHVVSUVPVWJYQVVSHVWKY
          QUUSYCVVPVWLVWNWGUYMUYPVWLVVPVWNUXHVWNBUVSUWNGVWGUXGUWDHVAVWHYPRUUTUV
          AUVBUVCVVSVWLUVSEVATZVWCVVSAUXFVWLVWOUJVWFUXTUXFVWLVWOUXFVWLUEUVSUWSE
          VABUBGUVSWESWFUVDUVEVVSUVSEVVSUWNUTUVSVVSAUXKVWFUXLVPVWEWMVVSAUWPVWFU
          YAVPUVFUVGYRUVHUVLUVIUVJUVKUVMUVNYSYTYSXSYRYTYIUVO $.

        $( Lemma for ~ ivth , the intermediate value theorem.  Show that
           ` ( F `` C ) ` cannot be greater than ` U ` , and so establish the
           existence of a root of the function.  (Contributed by Mario
           Carneiro, 30-Apr-2014.)  (Revised by Mario Carneiro,
           17-Jun-2014.) $)
        ivthlem3 $p |- ( ph -> ( C e. ( A (,) B ) /\ ( F ` C ) = U ) ) $=
          ( wbr vz vy cioo co wcel cfv wceq cr clt csup wss c0 wne cv wral wrex
          cle w3a cicc crab ssrab2 eqsstri iccssre syl2anc syl5ss ivthlem1 ne0i
          simpld syl simprd breq2 ralbidv rspcev suprcl syl5eqel wn ivthlem2 wa
          3jca cmin cabs wi cc ccncf adantr suprub syl6breqr wb suprleub mpbird
          crp syl5eqbr elicc2 mpbir3and sseldd ralrimiva fveq2 rspcv sylc difrp
          eleq1d biimpa cncfi syl3anc ssralv ad2antrr ltsubrp sylancom syl6breq
          rpre adantl resubcld suprlub mpbid ad2antrl simplll simprl abssuble0d
          sseli simprr ltsub23d eqbrtrd jca32 ex reximdv2 r19.29 ad2antll recnd
          mpd breq1d sylbid rexlimdva notbid necon2ad jctild ltlend sylibrd cxr
          syl5 rexrd pm3.45 imp absdifltd nncand elrab2 simprbi pm2.21d adantrd
          caddc lenltd expr com23 imp3a mpan2d syld pm2.01da mpbir2and breqtrrd
          lttri3d ltnrd syl5ibcom breq2d syl5ibrcom elioo2 jca ) AECDUCUDUEZEIU
          FZHUGZAUVFEUHUEZCEUITZEDUITZAEGUHUIUJZUHSAGUHUKZGULUMZUAUNZBUNZUQTZUA
          GUOZBUHUPZURZUVLUHUEAUVMUVNUVSAGCDUSUDZUHGUVPIUFZHUQTZBUWAUTUWARUWCBU
          WAVAVBZACUHUEZDUHUEZUWAUHUKZJKCDVCVDZVEACGUEZUVNAUWIUVODUQTZUAGUOZABU
          ACDFGHIJKLMNOPQRVFZVHZGCVGVIAUWFUWKUVSKAUWIUWKUWLVJZUVRUWKBDUHUVPDUGU
          VQUWJUAGUVPDUVOUQVKVLVMVDVSZBUAGVNVIVOZACIUFZUVGUITZUVJAUWQHUVGUIAUWQ
          HUITZHDIUFZUITZQVHAUVHUVGHUITVPHUVGUITZVPZABCDEFGHIJKLMNOPQRSVQAUXBAU
          XBVRZUBUNZEVTUDWAUFZUVOUITZUXEIUFZUVGVTUDWAUFUVGHVTUDZUITZWBZUBFUOZUA
          WKUPZUXCUXDIFWCWDUDUEZEFUEZUXIWKUEZUXMAUXNUXBOWEAUXOUXBAUWAFENAEUWAUE
          ZUVICEUQTZEDUQTZUWPACUVLEUQAUVTUWICUVLUQTUWOUWMBUAGCWFVDSWGZAEUVLDUQS
          AUVLDUQTZUWKUWNAUVTUWFUYAUWKWHUWOKBUAUAGDWIVDWJWLZAUWEUWFUXQUVIUXRUXS
          URWHJKCDEWMVDWNZWOWEAUXBUXPAHUHUEZUVGUHUEZUXBUXPWHLAUXQUWBUHUEZBUWAUO
          ZUYEUYCAUYFBUWAPWPZUYFUYEBEUWAUVPEUGUWBUVGUHUVPEIWQXAWRWSZHUVGWTVDXBU
          AUBFWCEUXIIXCXDUXDUXLUXCUAWKUXDUVOWKUEZVRZUXLUXKUBUWAUOZUXCAUXLUYLWBZ
          UXBUYJAUWAFUKUYMNUXKUBUWAFXEVIXFUYKUYLUXGUXEGUEZVRZUBUWAUPZUXCUYKEUVO
          VTUDZUXEUITZUBGUPZUYPUYKUYQUVLUITZUYSUYKUYQEUVLUIUXDUYJUVIUYQEUITAUVI
          UXBUYJUWPXFZEUVOXGXHSXIUYKUVTUYQUHUEUYTUYSWHAUVTUXBUYJUWOXFUYKEUVOVUA
          UYJUVOUHUEZUXDUVOXJXKZXLBUAUBGUYQXMVDXNUYKUYRUYOUBGUWAUYKUYNUYRVRZUXE
          UWAUEZUYOVRUYKVUDVRZVUEUXGUYNUYNVUEUYKUYRGUWAUXEUWDXSZXOZVUFUXFEUXEVT
          UDUVOUIVUFUXEEVUFUWAUHUXEVUFAUWGAUXBUYJVUDXPZUWHVIVUHWOZVUFAUVIVUIUWP
          VIZVUFUXEUVLEUQVUFUVTUYNUXEUVLUQTVUFAUVTVUIUWOVIUYKUYNUYRXQZBUAGUXEWF
          VDSWGXRVUFEUVOUXEVUKUYKVUBVUDVUCWEVUJUYKUYNUYRXTYAYBVULYCYDYEYIUYLUYP
          VRUXKUYOVRZUBUWAUPUYKUXCUXKUYOUBUWAYFUYKVUMUXCUBUWAVUMUXJUYNVRZUYKVUE
          VRUXCUXKUYOVUNUXGUXJUYNUUAUUBUYKVUNUXCWBVUEUYKUXJUYNUXCUYKUYNUXJUXCUX
          DUYJUYNUXJUXCWBUXDUYJUYNVRZVRZUXJUVGUXIVTUDZUXHUITZUXHUVGUXIUUIUDUITZ
          VRUXCVUPUXHUVGUXIVUPVUEUYGUXHUHUEZUYNVUEUXDUYJVUGYGAUYGUXBVUOUYHXFUYF
          VUTBUXEUWAUVPUXEUGZUWBUXHUHUVPUXEIWQZXAWRWSZAUYEUXBVUOUYIXFZVUPUVGHVV
          DAUYDUXBVUOLXFZXLUUCVUPVURUXCVUSVUPVURHUXHUITZUXCVUPVUQHUXHUIVUPUVGHV
          UPUVGVVDYHVUPHVVEYHUUDYJVUPVVFUXCVUPUXHHUQTZVVFVPUYNVVGUXDUYJUYNVUEVV
          GUWCVVGBUXEUWAGVVAUWBUXHHUQVVBYJRUUEUUFYGVUPUXHHVVCVVEUUJXNUUGYKUUHYK
          UUKUULUUMWEYSYLYSUUNUUOYLYIUUPAUVGHUYILUUSUUQZUURAUWRUXRECUMZVRUVJAUW
          RVVIUXRAUWRECAUVGUVGUITZVPZECUGZUWRVPAUVGUYIUUTZVVLVVJUWRVVLUVGUWQUVG
          UIECIWQYJYMUVAYNUXTYOACEJUWPYPYQYIAUVGUWTUITZUVKAUVGHUWTUIVVHAUWSUXAQ
          VJYBAVVNUXSDEUMZVRUVKAVVNVVOUXSAVVNDEAVVNVPDEUGZVVKVVMVVPVVNVVJVVPUWT
          UVGUVGUIDEIWQUVBYMUVCYNUYBYOAEDUWPKYPYQYIACYRUEDYRUEUVFUVIUVJUVKURWHA
          CJYTADKYTCDEUVDVDWNVVHUVE $.
      $}

      $( The intermediate value theorem, increasing case.  (Contributed by Paul
         Chapman, 22-Jan-2008.)  (Proof shortened by Mario Carneiro,
         30-Apr-2014.) $)
      ivth $p |- ( ph -> E. c e. ( A (,) B ) ( F ` c ) = U ) $=
        ( vy cv cfv wceq cle wbr cicc co crab cr clt csup cioo wcel wrex breq1d
        wa fveq2 cbvrabv eqid ivthlem3 eqeq1d rspcev syl ) AQRZGSZFUAUBZQCDUCUD
        ZUEZUFUGUHZCDUIUDZUJVFGSZFTZUMHRZGSZFTZHVGUKABCDVFEVEFGIJKLMNOPVCBRZGSZ
        FUAUBQBVDVAVMTVBVNFUAVAVMGUNULUOVFUPUQVLVIHVFVGVJVFTVKVHFVJVFGUNURUSUT
        $.
    $}

    ${
      ivth2.9 $e |- ( ph -> ( ( F ` B ) < U /\ U < ( F ` A ) ) ) $.
      $( The intermediate value theorem, decreasing case.  (Contributed by Paul
         Chapman, 22-Jan-2008.)  (Revised by Mario Carneiro, 30-Apr-2014.) $)
      ivth2 $p |- ( ph -> E. c e. ( A (,) B ) ( F ` c ) = U ) $=
        ( cfv wceq wcel clt vy cv cneg cmpt cioo co wrex renegcld cc ccncf eqid
        negfcncf syl cicc wa cr sselda fveq2 negeqd negex fvmpt eqeltrd wbr cxr
        cle rexrd ltled lbicc2 syl3anc sseldd simprd wral ralrimiva eleq1d sylc
        rspcv ltnegd eqbrtrd simpld ubicc2 breqtrrd ivth ioossicc syl5ss eqeq1d
        mpbid jca wf cncff ffvelrnda syldan recnd adantr neg11ad bitrd rexbidva
        ) AHUBZUAEUAUBZGQZUCZUDZQZFUCZRZHCDUEUFZUGWQGQZFRZHXEUGABCDEXCXAHIJAFKU
        HLMAGEUIUJUFZSZXAXHSNUAEGXAXAUKZULUMABUBZCDUNUFZSUOZXKXAQZXKGQZUCZUPXMX
        KESXNXPRAXLEXKMUQUAXKWTXPEXAWRXKRWSXOWRXKGURUSXJXOUTVAUMXMXOOUHVBACXAQZ
        XCTVCXCDXAQZTVCAXQCGQZUCZXCTACESXQXTRAXLECMACVDSZDVDSZCDVEVCZCXLSZACIVF
        ZADJVFZACDIJLVGZCDVHVIZVJUACWTXTEXAWRCRWSXSWRCGURUSXJXSUTVAUMAFXSTVCZXT
        XCTVCADGQZFTVCZYIPVKAFXSKAYDXOUPSZBXLVLZXSUPSZYHAYLBXLOVMZYLYNBCXLXKCRX
        OXSUPXKCGURVNVPVOVQWFVRAXCYJUCZXRTAYKXCYPTVCAYKYIPVSAYJFADXLSZYMYJUPSZA
        YAYBYCYQYEYFYGCDVTVIZYOYLYRBDXLXKDRXOYJUPXKDGURVNVPVOKVQWFADESXRYPRAXLE
        DMYSVJUADWTYPEXAWRDRWSYJWRDGURUSXJYJUTVAUMWAWGWBAXDXGHXEAWQXESZUOZXDXFU
        CZXCRXGUUAXBUUBXCUUAWQESZXBUUBRAXEEWQAXEXLECDWCMWDUQZUAWQWTUUBEXAWRWQRW
        SXFWRWQGURUSXJXFUTVAUMWEUUAXFFAYTUUCXFUISUUDAEUIWQGAXIEUIGWHNEUIGWIUMWJ
        WKAFUISYTAFKWLWMWNWOWPWF $.
    $}

    ${
      ivthle.9 $e |- ( ph -> ( ( F ` A ) <_ U /\ U <_ ( F ` B ) ) ) $.
      $( The intermediate value theorem with weak inequality, increasing case.
         (Contributed by Mario Carneiro, 12-Aug-2014.) $)
      ivthle $p |- ( ph -> E. c e. ( A [,] B ) ( F ` c ) = U ) $=
        ( wceq cr wcel adantr cfv clt wbr cv cicc co wrex wa wss ioossicc ccncf
        cioo adantlr simpr ivth ssrexv mpsyl anassrs cxr cle rexrd ltled ubicc2
        cc syl3anc eqcom fveq2 eqeq2d syl5bb rspcev sylan simprd wral ralrimiva
        wo eleq1d rspcv sylc leloed mpbid mpjaodan lbicc2 eqeq1d simpld ) ACGUA
        ZFUBUCZHUDZGUAZFQZHCDUEUFZUGZWEFQZAWFUHFDGUAZUBUCZWKFWMQZAWFWNWKCDULUFZ
        WJUIAWFWNUHZUHZWIHWPUGWKCDUJWRBCDEFGHACRSWQITADRSWQJTAFRSWQKTACDUBUCWQL
        TAWJEUIWQMTAGEVDUKUFSWQNTABUDZWJSWSGUAZRSZWQOUMAWQUNUOWIHWPWJUPUQURAWOW
        KWFADWJSZWOWKACUSSZDUSSZCDUTUCZXBACIVAZADJVAZACDIJLVBZCDVCVEZWIWOHDWJWI
        FWHQWGDQZWOWHFVFXJWHWMFWGDGVGVHVIVJVKUMAWNWOVOZWFAFWMUTUCZXKAWEFUTUCZXL
        PVLAFWMKAXBXABWJVMZWMRSZXIAXABWJOVNZXAXOBDWJWSDQWTWMRWSDGVGVPVQVRVSVTTW
        AACWJSZWLWKAXCXDXEXQXFXGXHCDWBVEZWIWLHCWJWGCQWHWEFWGCGVGWCVJVKAXMWFWLVO
        AXMXLPWDAWEFAXQXNWERSZXRXPXAXSBCWJWSCQWTWERWSCGVGVPVQVRKVSVTWA $.
    $}

    ivthle2.9 $e |- ( ph -> ( ( F ` B ) <_ U /\ U <_ ( F ` A ) ) ) $.
    $( The intermediate value theorem with weak inequality, decreasing case.
       (Contributed by Mario Carneiro, 12-May-2014.) $)
    ivthle2 $p |- ( ph -> E. c e. ( A [,] B ) ( F ` c ) = U ) $=
      ( wceq cr wcel adantr cfv clt wbr cv cicc co wrex wa cioo wss ioossicc cc
      ccncf adantlr simpr ivth2 ssrexv mpsyl anassrs cxr cle rexrd ltled lbicc2
      syl3anc eqcom fveq2 eqeq2d syl5bb rspcev sylan wo simprd ralrimiva eleq1d
      wral rspcv sylc leloed mpbid mpjaodan ubicc2 eqeq1d simpld ) ADGUAZFUBUCZ
      HUDZGUAZFQZHCDUEUFZUGZWEFQZAWFUHFCGUAZUBUCZWKFWMQZAWFWNWKCDUIUFZWJUJAWFWN
      UHZUHZWIHWPUGWKCDUKWRBCDEFGHACRSWQITADRSWQJTAFRSWQKTACDUBUCWQLTAWJEUJWQMT
      AGEULUMUFSWQNTABUDZWJSWSGUAZRSZWQOUNAWQUOUPWIHWPWJUQURUSAWOWKWFACWJSZWOWK
      ACUTSZDUTSZCDVAUCZXBACIVBZADJVBZACDIJLVCZCDVDVEZWIWOHCWJWIFWHQWGCQZWOWHFV
      FXJWHWMFWGCGVGVHVIVJVKUNAWNWOVLZWFAFWMVAUCZXKAWEFVAUCZXLPVMAFWMKAXBXABWJV
      PZWMRSZXIAXABWJOVNZXAXOBCWJWSCQWTWMRWSCGVGVOVQVRVSVTTWAADWJSZWLWKAXCXDXEX
      QXFXGXHCDWBVEZWIWLHDWJWGDQWHWEFWGDGVGWCVJVKAXMWFWLVLAXMXLPWDAWEFAXQXNWERS
      ZXRXPXAXSBDWJWSDQWTWERWSDGVGVOVQVRKVSVTWA $.
  $}

  ${
    $d x z D $.  $d x y z F $.  $d x y z M $.  $d x y z N $.  $d x y z ph $.
    $d x A $.  $d x B $.
    ivthicc.1 $e |- ( ph -> A e. RR ) $.
    ivthicc.2 $e |- ( ph -> B e. RR ) $.
    ivthicc.3 $e |- ( ph -> M e. ( A [,] B ) ) $.
    ivthicc.4 $e |- ( ph -> N e. ( A [,] B ) ) $.
    ivthicc.5 $e |- ( ph -> ( A [,] B ) C_ D ) $.
    ivthicc.7 $e |- ( ph -> F e. ( D -cn-> CC ) ) $.
    ivthicc.8 $e |- ( ( ph /\ x e. ( A [,] B ) ) -> ( F ` x ) e. RR ) $.
    $( The interval between any two points of a continuous real function is
       contained in the range of the function.  Equivalently, the range of a
       continuous real function is convex.  (Contributed by Mario Carneiro,
       12-Aug-2014.) $)
    ivthicc $p |- ( ph -> ( ( F ` M ) [,] ( F ` N ) ) C_ ran F ) $=
      ( vz wcel wbr cr ad2antrr vy cfv cicc co crn cv wa clt w3o cle w3a elicc2
      wceq syl2anc mpbid simp1d lttri4d adantr wrex simpll wral ralrimiva fveq2
      wb wss eleq1d rspcv sylc iccssre sselda simpr simp2d iccss syl22anc sstrd
      simp3d cc ccncf syldan sylan biimpa 3simpc syl ivthle wi wfn wf cncff ffn
      3syl fnfvelrn eleq1 syl5ibcom rexlimdva csn simplr fveq2d cxr rexrd iccid
      oveq2d eqtr3d eleqtrd elsni sseldd eqeltrd ivthle2 3jaodan mpdan ex ssrdv
      ) AUAGFUBZHFUBZUCUDZFUEZAUAUFZXNQZXPXOQZAXQUGZGHUHRZGHUMZHGUHRZUIZXRAYCXQ
      AGHAGSQZCGUJRZGDUJRZAGCDUCUDZQZYDYEYFUKZKACSQZDSQZYHYIVDIJCDGULUNUOZUPZAH
      SQZCHUJRZHDUJRZAHYGQZYNYOYPUKZLAYJYKYQYRVDIJCDHULUNUOZUPZUQURXSXTXRYAYBXS
      XTUGZAPUFZFUBZXPUMZPGHUCUDZUSXRAXQXTUTZUUABGHEXPFPAYDXQXTYMTAYNXQXTYTTXSX
      PSQZXTAXNSXPAXLSQZXMSQZXNSVEAYHBUFZFUBZSQZBYGVAZUUHKAUULBYGOVBZUULUUHBGYG
      UUJGUMUUKXLSUUJGFVCVFVGVHZAYQUUMUUILUUNUULUUIBHYGUUJHUMUUKXMSUUJHFVCVFVGV
      HZXLXMVIUNVJZURXSXTVKAUUEEVEXQXTAUUEYGEAYJYKYEYPUUEYGVEIJAYDYEYFYLVLAYNYO
      YPYSVPCDGHVMVNZMVOZTAFEVQVRUDQZXQXTNTUUAAUUJUUEQZUULUUFAUVAUUJYGQZUULAUUE
      YGUUJUURVJOVSVTXSXLXPUJRZXPXMUJRZUGZXTXSUUGUVCUVDUKZUVEAXQUVFAUUHUUIXQUVF
      VDUUOUUPXLXMXPULUNWAUUGUVCUVDWBWCZURWDAUUDXRPUUEAUUBUUEQUUBEQZUUDXRWEZAUU
      EEUUBUUSVJAUVHUGUUCXOQZUUDXRAFEWFZUVHUVJAUUTEVQFWGUVKNEVQFWHEVQFWIWJZEUUB
      FWKVTUUCXPXOWLWMZVSWNVHXSYAUGZXPXLXOUVNXPXLWOZQXPXLUMUVNXPXNUVOAXQYAWPUVN
      XLXLUCUDZXNUVOUVNXLXMXLUCUVNGHFXSYAVKWQXAUVNXLWRQZUVPUVOUMAUVQXQYAAXLUUOW
      STXLWTWCXBXCXPXLXDWCAXLXOQZXQYAAUVKGEQUVRUVLAYGEGMKXEEGFWKUNTXFXSYBUGZAUU
      DPHGUCUDZUSXRAXQYBUTZUVSBHGEXPFPAYNXQYBYTTAYDXQYBYMTXSUUGYBUUQURXSYBVKAUV
      TEVEXQYBAUVTYGEAYJYKYOYFUVTYGVEIJAYNYOYPYSVLAYDYEYFYLVPCDHGVMVNZMVOZTAUUT
      XQYBNTUVSAUUJUVTQZUULUWAAUWDUVBUULAUVTYGUUJUWBVJOVSVTXSUVEYBUVGURXGAUUDXR
      PUVTAUUBUVTQUVHUVIAUVTEUUBUWCVJUVMVSWNVHXHXIXJXK $.
  $}

  ${
    $d x y A $.  $d a b w z A $.  $d a b x y B $.  $d w z B $.  $d a b x y F $.
    $d a b x y ph $.  $d w z ph $.  $d w z F $.
    evthicc.1 $e |- ( ph -> A e. RR ) $.
    evthicc.2 $e |- ( ph -> B e. RR ) $.
    evthicc.3 $e |- ( ph -> A <_ B ) $.
    evthicc.4 $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    $( Specialization of the Extreme Value Theorem to a closed interval of
       ` RR ` .  (Contributed by Mario Carneiro, 12-Aug-2014.) $)
    evthicc $p |- ( ph ->
      ( E. x e. ( A [,] B ) A. y e. ( A [,] B ) ( F ` y ) <_ ( F ` x ) /\
        E. z e. ( A [,] B ) A. w e. ( A [,] B ) ( F ` z ) <_ ( F ` w ) ) ) $=
      ( cv cfv co wral wrex eqid cr wcel cle wbr cicc cioo crn ctg crest icccmp
      cuni ccmp syl2anc ccncf ccn cabs cmin ccom cxp cres cmopn cc wceq iccssre
      wss ax-resscn syl6ss tgioo cncfmet sylancl resubmet syl oveq1d eleqtrd c0
      eqtrd ctop retop uniretop restuni sylancr wne cxr lbicc2 syl3anc eqnetrrd
      rexrd ne0i evth raleqdv rexeqbidv mpbird evth2 jca ) ACMHNBMHNUAUBZCFGUCO
      ZPZBWNQZDMHNEMHNUAUBZEWNPZDWNQZAWPWMCUDUEUFNZWNUGOZUIZPZBXBQABCHXAWTXBXBR
      ZWTRZAFSTZGSTZXAUJTIJFGXAWTXEXARUHUKZAHWNSULOZXAWTUMOZLAXIUNUOUPZWNWNUQUR
      ZUSNZWTUMOZXJAWNUTVCSUTVCXIXNVAAWNSUTAXFXGWNSVCZIJFGVBUKZVDVEVDWNSXLXKSSU
      QURZXMWTXLRXQRZXMRZXQXQUSNZXRXTRVFVGVHAXMXAWTUMAXOXMXAVAXPWNWTXMXEXSVIVJV
      KVNVLZAWNXBVMAWTVOTXOWNXBVAVPXPWNWTSVQVRVSZAFWNTZWNVMVTAFWATGWATFGUAUBYCA
      FIWEAGJWEKFGWBWCWNFWFVJWDZWGAWOXCBWNXBYBAWMCWNXBYBWHWIWJAWSWQEXBPZDXBQADE
      HXAWTXBXDXEXHYAYDWKAWRYEDWNXBYBAWQEWNXBYBWHWIWJWL $.

    $( Combine ~ ivthicc with ~ evthicc to exactly describe the image of a
       closed interval.  (Contributed by Mario Carneiro, 19-Feb-2015.) $)
    evthicc2 $p |- ( ph -> E. x e. RR E. y e. RR ran F = ( x [,] y ) ) $=
      ( vz va vb wa wrex cr wcel adantr wss cc cv cfv cle wbr cicc co wral wceq
      crn evthicc reeanv sylibr r19.26 ccncf wf cncff syl simprr simprl wfn ffn
      ffvelrnd wb elicc2 syl2anc 3anass syl6bb ancom ffvelrnda biantrurd syl5bb
      w3a bitr4d ralbidva biimpar ffnfv sylanbrc frn a1i ax-resscn cncfss mp2an
      ssid sseldi ivthicc eqssd rspceov syl3anc ex syl5bir rexlimdvva mpd ) AKU
      AZFUBZLUAZFUBZUCUDZKDEUEUFZUGZMUAZFUBZWNUCUDZKWRUGZNZMWROLWROZFUIZBUAZCUA
      UEUFUHCPOBPOZAWSLWROXCMWRONXEALKMKDEFGHIJUJWSXCLMWRWRUKULAXDXHLMWRWRXDWQX
      BNZKWRUGZAWOWRQZWTWRQZNZNZXHWQXBKWRUMXNXJXHXNXJNZXAPQZWPPQZXFXAWPUEUFZUHX
      HXNXPXJXNWRPWTFXNFWRPUNUFZQZWRPFUOZAXTXMJRZWRPFUPUQZAXKXLURZVBZRXNXQXJXNW
      RPWOFYCAXKXLUSZVBZRXOXFXRXOWRXRFUOZXFXRSXOFWRUTZWNXRQZKWRUGZYHXOYAYIXNYAX
      JYCRWRPFVAUQXNYKXJXNYJXIKWRXNWMWRQZNZYJWNPQZXBWQNZNZXIYMYJYNXBWQVLZYPYMXP
      XQYJYQVCXNXPYLYERXNXQYLYGRXAWPWNVDVEYNXBWQVFVGXIYOYMYPWQXBVHYMYNYOXNWRPWM
      FYCVIVJVKVMVNVOKWRXRFVPVQWRXRFVRUQXNXRXFSXJXNBDEWRFWTWOADPQXMGRAEPQXMHRYD
      YFWRWRSXNWRWCVSXNXSWRTUNUFZFPTSTTSXSYRSVTTWCWRPTWAWBYBWDXNWRPXGFYCVIWERWF
      BCPPXAWPXFUEWGWHWIWJWKWL $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.
    $( A continuous function on a closed interval is bounded.  (Contributed by
       Mario Carneiro, 7-Sep-2014.) $)
    cniccbdd $p |- ( ( A e. RR /\ B e. RR /\ F e. ( ( A [,] B ) -cn-> CC ) ) ->
      E. x e. RR A. y e. ( A [,] B ) ( abs ` ( F ` y ) ) <_ x ) $=
      ( vz cr wcel co cc ccncf cfv cabs cle wbr wral wa cc0 wceq adantr cicc cv
      w3a wrex clt 0re c0 ral0 cxr wb simp1 rexrd simp2 syl2anc biimpar raleqdv
      icc0 mpbiri breq2 ralbidv rspcev sylancr ccom simpr simp3 abscncf evthicc
      a1i cncfco simpld wf cncff syl ffvelrnda fvco3 sylan breq1d biimpd ee12an
      ralbidva rexlimdva imp syldan ltlecasei ) CGHZDGHZECDUAIZJKIHZUCZBUBZELML
      ZAUBZNOZBWGPZAGUDZDCWIDCUEOZQZRGHWKRNOZBWGPZWOUFWQWSWRBUGPWRBUHWQWRBWGUGW
      IWGUGSZWPWICUIHDUIHWTWPUJWICWEWFWHUKZULWIDWEWFWHUMZULCDUQUNUOUPURWNWSARGW
      LRSWMWRBWGWLRWKNUSUTVAVBWICDNOZWJMEVCZLZFUBZXDLZNOZBWGPZFWGUDZWOWIXCQZXJX
      GXENOBWGPFWGUDXKFBFBCDXDWIWEXCXATWIWFXCXBTWIXCVDWIXDWGGKIHZXCWIWGJGEMWEWF
      WHVEZMJGKIHWIVFVHVIZTVGVJWIXJWOWIXIWOFWGWIXFWGHZQZXGGHXIWKXGNOZBWGPZWOWIW
      GGXFXDWIXLWGGXDVKXNWGGXDVLVMVNXPXIXRXPXHXQBWGXPWJWGHZQXEWKXGNXPWGJEVKZXSX
      EWKSWIXTXOWIWHXTXMWGJEVLVMTWGJWJMEVOVPVQVTVRWNXRAXGGWLXGSWMXQBWGWLXGWKNUS
      UTVAVSWAWBWCXBXAWD $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 Integrals
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Lebesgue measure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c vol* $. $( outer Lebesgue measure $)
  $c vol $. $( Lebesgue measure $)

  $( Extend class notation with the outer Lebesgue measure. $)
  covol $a class vol* $.

  $( Extend class notation with the Lebesgue measure. $)
  cvol $a class vol $.

  ${
    $d x y f $.
    $( Define the outer Lebesgue measure for subsets of the reals.  Here ` f `
       is a function from the natural numbers to pairs ` <. a , b >. ` with
       ` a <_ b ` , and the outer volume of the set ` x ` is the infimum over
       all such functions such that the union of the open intervals
       ` ( a , b ) ` covers ` x ` of the sum of ` b - a ` .  (Contributed by
       Mario Carneiro, 16-Mar-2014.) $)
    df-ovol $a |- vol* = ( x e. ~P RR |-> sup ( { y e. RR* |
      E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( x C_ U. ran ( (,) o. f ) /\
          y = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) } ,
        RR* , `' < ) ) $.

    $( Define the Lebesgue measure, which is just the outer measure with a
       peculiar domain of definition.  The property of being
       Lebesgue-measurable can be expressed as ` A e. dom vol ` .  (Contributed
       by Mario Carneiro, 17-Mar-2014.) $)
    df-vol $a |- vol = ( vol* |` { x | A. y e. ( `' vol* " RR )
      ( vol* ` y ) = ( ( vol* ` ( y i^i x ) ) + ( vol* ` ( y \ x ) ) ) } ) $.

  $}

  $( Closure for the interval endpoint function.  (Contributed by Mario
     Carneiro, 16-Mar-2014.) $)
  ovolfcl $p |- ( ( F : NN --> ( <_ i^i ( RR X. RR ) ) /\ N e. NN ) ->
                    ( ( 1st ` ( F ` N ) ) e. RR /\
                      ( 2nd ` ( F ` N ) ) e. RR /\
                      ( 1st ` ( F ` N ) ) <_ ( 2nd ` ( F ` N ) ) ) ) $=
    ( cn cle cr cxp cin wf wcel wa cfv c1st c2nd cop wbr w3a wceq inss2 ffvelrn
    sseldi 1st2nd2 eqeltrrd ancom elin df-br bicomi opelxp anbi12i bitri df-3an
    syl 3bitr4i sylib ) CDEEFZGZAHBCIJZBAKZLKZUQMKZNZUOIZUREIZUSEIZURUSDOZPZUPU
    QUTUOUPUQUNIUQUTQUPUOUNUQDUNRCUOBASZTUQEEUAUKVFUBVDVBVCJZJZVGVDJVAVEVDVGUCV
    AUTDIZUTUNIZJVHUTDUNUDVIVDVJVGVDVIURUSDUEUFURUSEEUGUHUIVBVCVDUJULUM $.

  ${
    $d n z A $.  $d n x y z F $.
    $( Unpack the interval covering property of the outer measure definition.
       (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    ovolfioo $p |- ( ( A C_ RR /\ F : NN --> ( <_ i^i ( RR X. RR ) ) ) ->
                      ( A C_ U. ran ( (,) o. F ) <-> A. z e. A E. n e. NN
                  ( ( 1st ` ( F ` n ) ) < z /\ z < ( 2nd ` ( F ` n ) ) ) ) ) $=
      ( cr wss cn cle cxp wf wa cv cioo cfv clt wbr wb cxr wcel rexr ccom inss2
      cin ciun crn cuni c1st c2nd wrex wral wceq ioof ressxr xpss12 mp2an sstri
      cpw wfn fss mpan2 fco sylancr ffn fniunfv sseq2d adantl dfss3 ssel2 eliun
      co fvco3 cop ffvelrn sseldi 1st2nd2 syl fveq2d df-ov syl6eqr eqtrd eleq2d
      3syl ovolfcl elioo1 syl2an 3anass syl6bb 3adant3 bitrd ad2antrr biantrurd
      w3a adantll bitr4d rexbidva syl5bb sylan an32s ralbidva bitr3d ) BEFZGHEE
      IZUCZDJZKZBCGCLZMDUAZNZUDZFZBXGUEUFZFZXFDNZUGNZALZOPZXOXMUHNZOPZKZCGUIZAB
      UJZXDXJXLQXAXDXIXKBXDGEUQZXGJZXGGURXIXKUKXDRRIZYBMJGYDDJZYCULXDXCYDFYEXCX
      BYDHXBUBZERFZYGXBYDFUMUMERERUNUOUPGXCYDDUSUTGYDYBMDVAVBGYBXGVCCGXGVDWBVEV
      FXJXOXISZABUJXEYAABXIVGXEYHXTABXAXOBSZXDYHXTQZXAYIKXOESZXDYJBEXOVHYHXOXHS
      ZCGUIYKXDKZXTCXOGXHVIYMYLXSCGYMXFGSZKZYLXORSZXSKZXSXDYNYLYQQYKXDYNKZYLXOX
      NXQMVJZSZYQYRXHYSXOYRXHXMMNZYSGXCXFMDVKYRUUAXNXQVLZMNYSYRXMUUBMYRXMXBSXMU
      UBUKYRXCXBXMYFGXCXFDVMVNXMEEVOVPVQXNXQMVRVSVTWAYRXNESZXQESZXNXQHPZWLYTYQQ
      ZDXFWCUUCUUDUUFUUEUUCUUDKYTYPXPXRWLZYQUUCXNRSXQRSYTUUGQUUDXNTXQTXNXQXOWDW
      EYPXPXRWFWGWHVPWIWMYOYPXSYKYPXDYNXOTWJWKWNWOWPWQWRWSWPWT $.

    $( Unpack the interval covering property using closed intervals.
       (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    ovolficc $p |- ( ( A C_ RR /\ F : NN --> ( <_ i^i ( RR X. RR ) ) ) ->
                      ( A C_ U. ran ( [,] o. F ) <-> A. z e. A E. n e. NN
                ( ( 1st ` ( F ` n ) ) <_ z /\ z <_ ( 2nd ` ( F ` n ) ) ) ) ) $=
      ( cr wss cn cle cxp wf wa cv cicc cfv wbr wrex wral wb cxr wcel ccom ciun
      cin crn cuni c1st c2nd cpw wfn wceq inss2 ressxr xpss12 mp2an sstri mpan2
      iccf fss fco sylancr ffn fniunfv sseq2d adantl dfss3 ssel2 eliun co fvco3
      3syl cop ffvelrn sseldi 1st2nd2 syl fveq2d df-ov syl6eqr eqtrd eleq2d w3a
      ovolfcl elicc2 3anass syl6bb 3adant3 bitrd adantll simpll bitr4d rexbidva
      biantrurd syl5bb sylan an32s ralbidva bitr3d ) BEFZGHEEIZUCZDJZKZBCGCLZMD
      UAZNZUBZFZBXDUDUEZFZXCDNZUFNZALZHOZXLXJUGNZHOZKZCGPZABQZXAXGXIRWRXAXFXHBX
      AGSUHZXDJZXDGUIXFXHUJXASSIZXSMJGYADJZXTUQXAWTYAFYBWTWSYAHWSUKZESFZYDWSYAF
      ULULESESUMUNUOGWTYADURUPGYAXSMDUSUTGXSXDVACGXDVBVJVCVDXGXLXFTZABQXBXRABXF
      VEXBYEXQABWRXLBTZXAYEXQRZWRYFKXLETZXAYGBEXLVFYEXLXETZCGPYHXAKZXQCXLGXEVGY
      JYIXPCGYJXCGTZKZYIYHXPKZXPXAYKYIYMRYHXAYKKZYIXLXKXNMVHZTZYMYNXEYOXLYNXEXJ
      MNZYOGWTXCMDVIYNYQXKXNVKZMNYOYNXJYRMYNXJWSTXJYRUJYNWTWSXJYCGWTXCDVLVMXJEE
      VNVOVPXKXNMVQVRVSVTYNXKETZXNETZXKXNHOZWAYPYMRZDXCWBYSYTUUBUUAYSYTKYPYHXMX
      OWAYMXKXNXLWCYHXMXOWDWEWFVOWGWHYLYHXPYHXAYKWIWLWJWKWMWNWOWPWMWQ $.

    $( Any (closed) interval covering is a subset of the reals.  (Contributed
       by Mario Carneiro, 24-Mar-2015.) $)
    ovolficcss $p |- ( F : NN --> ( <_ i^i ( RR X. RR ) ) ->
      U. ran ( [,] o. F ) C_ RR ) $=
      ( vx vy cn cle cr cxp wf cicc crn cpw wss cv cfv wcel wral wceq syl cxr
      wb cin ccom cuni cima rnco2 wa c1st c2nd cop inss2 ffvelrn sseldi 1st2nd2
      co df-ov syl6eqr xp1st xp2nd iccssre syl2anc eqsstrd reex elpw2 ralrimiva
      fveq2d sylibr wfn ffn fveq2 eleq1d ralrn mpbird wfun cdm iccf ffun ressxr
      ax-mp xpss12 mp2an sstri fdmi sseqtr4i funimass4 sylancr syl5eqss sspwuni
      frn syl6ss sylib ) DEFFGZUAZAHZIAUBJZFKZLWNUCFLWMWNIAJZUDZWOIAUEWMWQWOLZB
      MZINZWOOZBWPPZWMXBCMZANZINZWOOZCDPZWMXFCDWMXCDOUFZXEFLXFXHXEXDUGNZXDUHNZI
      UNZFXHXEXIXJUIZINXKXHXDXLIXHXDWKOZXDXLQXHWLWKXDEWKUJZDWLXCAUKULZXDFFUMRVE
      XIXJIUOUPXHXIFOZXJFOZXKFLXHXMXPXOXDFFUQRXHXMXQXOXDFFURRXIXJUSUTVAXEFVBVCV
      FVDWMADVGXBXGTDWLAVHXAXFBCDAWSXDQWTXEWOWSXDIVIVJVKRVLWMIVMZWPIVNZLWRXBTSS
      GZSKZIHXRVOXTYAIVPVRWMWPWLXSDWLAWHWLXTXSWLWKXTXNFSLZYBWKXTLVQVQFSFSVSVTWA
      XTYAIVOWBWCWIBWPWOIWDWEVLWFWNFWGWJ $.
  $}

  ${
    ovolfs.1 $e |- G = ( ( abs o. - ) o. F ) $.
    $( The value of the interval length function.  (Contributed by Mario
       Carneiro, 16-Mar-2014.) $)
    ovolfsval $p |- ( ( F : NN --> ( <_ i^i ( RR X. RR ) ) /\ N e. NN ) ->
                      ( G ` N ) = ( ( 2nd ` ( F ` N ) ) -
                                    ( 1st ` ( F ` N ) ) ) ) $=
      ( cn cle cr cxp cin wcel cfv cabs cmin ccom co wceq syl cc recnd eqtrd wf
      wa c2nd fveq1i fvco3 syl5eq cop inss2 ffvelrn sseldi 1st2nd2 fveq2d df-ov
      c1st syl6eqr wbr ovolfcl simp1d simp2d eqid cnmetdval syl2anc abssuble0
      w3a ) EFGGHZIZAUACEJUBZCBKZCAKZLMNZKZVIUCKZVIUNKZMOZVGVHCVJANZKVKCBVODUDE
      VFCVJAUEUFVGVKVMVLVJOZVNVGVKVMVLUGZVJKVPVGVIVQVJVGVIVEJVIVQPVGVFVEVIFVEUH
      EVFCAUIUJVIGGUKQULVMVLVJUMUOVGVPVMVLMOLKZVNVGVMRJVLRJVPVRPVGVMVGVMGJZVLGJ
      ZVMVLFUPZACUQZURSVGVLVGVSVTWAWBUSSVMVLVJVJUTVAVBVGVSVTWAVDVRVNPWBVMVLVCQT
      TT $.

    $d x y G $.  $d x y F $.
    $( Closure for the interval length function.  (Contributed by Mario
       Carneiro, 16-Mar-2014.) $)
    ovolfsf $p |- ( F : NN --> ( <_ i^i ( RR X. RR ) ) ->
      G : NN --> ( 0 [,) +oo ) ) $=
      ( vx cn cle cr cxp wf cfv cc0 co wcel cabs cmin ccom cc fco wss wbr mp2an
      cin wfn cpnf cico wral absf subf inss2 ax-resscn xpss12 sstri fss sylancr
      cv mpan2 feq1i sylibr ffn syl wa ffvelrnda c2nd w3a ovolfcl subge0 ancoms
      c1st wb biimp3ar ovolfsval breqtrrd elrege0 sylanbrc ralrimiva ffnfv ) EF
      GGHZUBZAIZBEUCZDUOZBJZKUDUELZMZDEUFEWCBIVSEGBIZVTVSEGNOPZAPZIZWEVSQQHZGWF
      IZEWIAIZWHQGNIWIQOIWJUGUHWIQGNORUAVSVRWISWKVRVQWIFVQUIGQSZWLVQWISUJUJGQGQ
      UKUAULEVRWIAUMUPEWIGWFARUNEGBWGCUQURZEGBUSUTVSWDDEVSWAEMVAZWBGMKWBFTWDVSE
      GWABWMVBWNKWAAJZVCJZWOVHJZOLZWBFWNWQGMZWPGMZWQWPFTZVDKWRFTZAWAVEWSWTXBXAW
      TWSXBXAVIWPWQVFVGVJUTABWACVKVLWBVMVNVODEWCBVPVN $.

    ovolfs.2 $e |- S = seq 1 ( + , G ) $.
    $( Closure for the partial sums of the interval length function.
       (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    ovolsf $p |- ( F : NN --> ( <_ i^i ( RR X. RR ) ) ->
      S : NN --> ( 0 [,) +oo ) ) $=
      ( vx vy cn cle cr cxp cin wf cc0 cpnf co caddc c1 wcel cv cico cseq cz 1z
      nnuz a1i ovolfsf ffvelrnda wa ge0addcl adantl seqf feq1i sylibr ) HIJJKLB
      MZHNOUAPZQCRUBZMHUPAMUOFGQUPCRHUERUCSUOUDUFUOHUPFTZCBCDUGUHURUPSGTZUPSUIU
      RUSQPUPSUOURUSUJUKULHUPAUQEUMUN $.
  $}

  ${
    $d f x y A $.  $d f y B $.  $d f F $.  $d x M $.  $d f y S $.
    ovolval.1 $e |- M = { y e. RR* |
      E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( A C_ U. ran ( (,) o. f ) /\
          y = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) } $.
    $( The value of the outer measure.  (Contributed by Mario Carneiro,
       16-Mar-2014.) $)
    ovolval $p |- ( A C_ RR -> ( vol* ` A ) = sup ( M , RR* , `' < ) ) $=
      ( vx cr wss covol cxr clt csup wceq cv ccom crn wa wrex crab wor cpw wcel
      cfv ccnv reex elpw2 cioo cuni caddc cabs cmin c1 cseq cle cxp cin cn cmap
      co sseq1 anbi1d rexbidv rabbidv syl6eqr supeq1d df-ovol xrltso cnvso mpbi
      supex fvmpt sylbir ) BGHBGUAZUBBIUCDJKUDZLZMBGUEUFFBFNZUGCNZOPUHZHZANUIUJ
      UKOVQOULUMPJKLMZQZCUNGGUOUPUQURUSZRZAJSZJVNLVOVMIVPBMZJWDDVNWEWDBVRHZVTQZ
      CWBRZAJSDWEWCWHAJWEWAWGCWBWEVSWFVTVPBVRUTVAVBVCEVDVEFACVFJDVNJKTJVNTVGJKV
      HVIVJVKVL $.

    $( Elementhood in the set ` M ` of approximations to the outer measure.
       (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    elovolm $p |- ( B e. M <->
      E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( A C_ U. ran ( (,) o. f ) /\
          B = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) ) $=
      ( wcel cxr cv ccom crn wss wceq wa cle cr cn co wrex wf cioo cuni cabs c1
      caddc cmin cseq clt csup cxp cin cmap anbi2d rexbidv elrab2 cc0 cpnf cico
      eqeq1 reex xpex inex2 nnex elmap ovolsf sylbi icossxr fss sylancl supxrcl
      eqid frn 3syl eleq1 syl5ibrcom imp adantrl rexlimiva pm4.71ri bitr4i ) CE
      GCHGZBUADIZJKUBLZCUEUCUFJWBJZUDUGZKZHUHUIZMZNZDOPPUJZUKZQULRZSZNWMWCAIZWG
      MZNZDWLSWMACHEWNCMZWPWIDWLWQWOWHWCWNCWGUSUMUNFUOWMWAWIWADWLWBWLGZWHWAWCWR
      WHWAWRWAWHWGHGZWRQHWETZWFHLWSWRQUPUQURRZWETZXAHLWTWRQWKWBTXBWKQWBWJOPPUTU
      TVAVBVCVDWEWBWDWDVKWEVKVEVFUPUQVGQXAHWEVHVIQHWEVLWFVJVMCWGHVNVOVPVQVRVSVT
      $.

    ${
      ovolval.2 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
      $( Sufficient condition for elementhood in the set ` M ` .  (Contributed
         by Mario Carneiro, 16-Mar-2014.) $)
      elovolmr $p |- ( ( F : NN --> ( <_ i^i ( RR X. RR ) ) /\
                A C_ U. ran ( (,) o. F ) ) -> sup ( ran S , RR* , < ) e. M ) $=
        ( cn cle cr cioo ccom crn cuni wss cxr clt caddc c1 cxp wf wa csup cabs
        cin cv cmin cseq wceq cmap co wrex wcel reex xpex inex2 elmap id eqcomd
        coeq2d seqeq3d syl5eq rneqd supeq1d biantrud coeq2 unieqd sseq2d bitr3d
        nnex rspcev sylanbr elovolm sylibr ) IJKKUAZUFZEUBZBLEMZNZOZPZUCBLDUGZM
        ZNZOZPZCNZQRUDZSUEUHMZWCMZTUIZNZQRUDUJZUCZDVQIUKULZUMZWIFUNVREWPUNWBWQV
        QIEVPJKKUOUOUPUQVKURWOWBDEWPWCEUJZWGWOWBWRWNWGWRQWHWMRWRCWLWRCSWJEMZTUI
        WLHWRWSWKSTWREWCWJWRWCEWRUSUTVAVBVCVDVEVFWRWFWABWRWEVTWRWDVSWCELVGVDVHV
        IVJVLVMABWIDFGVNVO $.
    $}

    $( The set ` M ` is composed of nonnegative extended real numbers.
       (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    ovolmge0 $p |- ( B e. M -> 0 <_ B ) $=
      ( wcel ccom crn wss c1 cxr wa cle cr cn co cc0 wbr syl cioo cv cuni caddc
      cabs cmin cseq clt csup wceq cxp cin cmap wrex elovolm wf reex xpex inex2
      nnex elmap cfv cpnf cico eqid 1nn ffvelrn sylancl elrege0 simprbi icossxr
      ovolsf frn syl6ss wfn ffn supxrub syl2anc wi sseldi supxrcl xrletr mp3an1
      fnfvelrn 0xr mp2and sylbi breq2 syl5ibrcom adantld rexlimiv ) CEGBUADUBZH
      IUCJZCUDUEUFHWLHZKUGZIZLUHUIZUJZMZDNOOUKZULZPUMQZUNRCNSZABCDEFUOWSXCDXBWL
      XBGZWRXCWMXDXCWRRWQNSZXDPXAWLUPZXEXAPWLWTNOOUQUQURUSUTVAXFRKWOVBZNSZXGWQN
      SZXEXFXGRVCVDQZGZXHXFPXJWOUPZKPGZXKWOWLWNWNVEWOVEVLZVFPXJKWOVGVHZXKXGOGXH
      XGVIVJTXFWPLJZXGWPGZXIXFWPXJLXFXLWPXJJXNPXJWOVMTRVCVKZVNZXFWOPVOZXMXQXFXL
      XTXNPXJWOVPTVFPKWOWDVHWPXGVQVRXFXGLGZWQLGZXHXIMXEVSZXFXJLXGXRXOVTXFXPYBXS
      WPWATRLGYAYBYCWERXGWQWBWCVRWFWGCWQRNWHWIWJWKWG $.
  $}

  ${
    $d f g m n x y z A $.  $d f m n x z F $.  $d m z G $.  $d x M $.  $d x N $.
    $d f g k m n x y B $.  $d k m n z ph $.  $d f k n x y S $.  $d k y T $.
    $( The volume of a set is an extended real number.  (Contributed by Mario
       Carneiro, 16-Mar-2014.) $)
    ovolcl $p |- ( A C_ RR -> ( vol* ` A ) e. RR* ) $=
      ( vf vy cr wss covol cfv cioo cv ccom crn cuni caddc cabs cmin c1 cxr clt
      cseq csup wceq wa cle cxp cin cn cmap co wrex crab ccnv eqid ovolval wcel
      ssrab2 infmxrcl ax-mp syl6eqel ) ADEAFGAHBIZJKLECIMNOJUSJPSKQRTUAUBBUCDDU
      DUEUFUGUHUIZCQUJZQRUKTZQCABVAVAULUMVAQEVBQUNUTCQUOVAUPUQUR $.

    ${
      ovollb.1 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
      $( The outer volume is a lower bound on the sum of all interval coverings
         of ` A ` .  (Contributed by Mario Carneiro, 15-Jun-2014.) $)
      ovollb $p |- ( ( F : NN --> ( <_ i^i ( RR X. RR ) ) /\
                       A C_ U. ran ( (,) o. F ) ) ->
                     ( vol* ` A ) <_ sup ( ran S , RR* , < ) ) $=
        ( vf vy cn cle cr cxp wf cioo ccom crn cuni wss wa cxr clt csup cin cfv
        covol cv caddc cabs cmin c1 cseq wceq cmap co wrex crab ccnv simpr ioof
        cpw simpl inss2 ressxr xpss12 mp2an fss sylancl fco sylancr frn sspwuni
        sstri syl sylib sstrd eqid ovolval wbr ssrab2 elovolmr infmxrlb eqbrtrd
        wcel ) GHIIJZUAZCKZALCMZNZOZPZQZAUCUBZALEUDZMNOPFUDUEUFUGMWKMUHUINRSTUJ
        QEWCGUKULUMZFRUNZRSUOTZBNRSTZHWIAIPWJWNUJWIAWGIWDWHUPWIWFIURZPZWGIPWIGW
        PWEKZWQWIRRJZWPLKGWSCKZWRUQWIWDWCWSPWTWDWHUSWCWBWSHWBUTIRPZXAWBWSPVAVAI
        RIRVBVCVJGWCWSCVDVEGWSWPLCVFVGGWPWEVHVKWFIVIVLVMFAEWMWMVNZVOVKWIWMRPWOW
        MWAWNWOHVPWLFRVQFABECWMXBDVRWMWOVSVGVT $.
    $}

    ${
      ovolgelb.1 $e |- S = seq 1 ( + , ( ( abs o. - ) o. g ) ) $.
      $( The outer volume is the greatest lower bound on the sum of all
         interval coverings of ` A ` .  (Contributed by Mario Carneiro,
         15-Jun-2014.) $)
      ovolgelb $p |- ( ( A C_ RR /\ ( vol* ` A ) e. RR /\ B e. RR+ ) ->
              E. g e. ( ( <_ i^i ( RR X. RR ) ) ^m NN )
                ( A C_ U. ran ( (,) o. g ) /\
                sup ( ran S , RR* , < ) <_ ( ( vol* ` A ) + B ) ) ) $=
        ( vy vx cr wss wcel cxr clt cle wbr wa cn wrex wi wral wceq cfv crp w3a
        covol cioo cv ccom crn cuni caddc co csup cxp cmap simp2 simp3 ltaddrpd
        wn rpred readdcld ltnled mpbid cabs cmin c1 cseq crab ccnv eqid ovolval
        cin 3ad2ant1 breq2d ssrab2 rexrd infmxrgelb sylancr eqeq1 rneqi supeq1i
        wb eqeq2i syl6bbr anbi2d rexbidv ralrab ralcom r19.23v ralbii ancomsimp
        impexp bitri cc0 cpnf cico wf reex xpex inex2 nnex elmap ovolsf frn syl
        sylbi icossxr syl6ss supxrcl breq2 imbi2d syl5bb ralbiia 3bitr3i bitr4d
        ceqsralv syl6rbb mtbid rexanali sylibr xrltnle sylbird syl2anr reximdva
        xrltle anim2d mpd ) AHIZAUDUAZHJZBUBJZUCZAUEDUFZUGUHUIIZYHBUJUKZCUHZKLU
        LZMNZURZOZDMHHUMZVKZPUNUKZQZYMYPYNMNZOZDUUBQYKYMYQRZDUUBSZURUUCYKYNYHMN
        ZUUGYKYHYNLNUUHURYKYHBYGYIYJUOZYGYIYJUPZUQYKYHYNUUIYKYHBUUIYKBUUJUSUTZV
        AVBYKUUHYNYMFUFZUJVCVDUGYLUGZVEVFZUHZKLULZTZOZDUUBQZFKVGZKLVHULZMNZUUGY
        KYHUVAYNMYGYIYHUVATYJFADUUTUUTVIVJVLVMYKUVBYNGUFZMNZGUUTSZUUGYKUUTKIYNK
        JZUVBUVEWAUUSFKVNYKYNUUKVOZGUUTYNVPVQUVEYMUVCYPTZOZDUUBQZUVDRZGKSZUUGUU
        SUVJUVDGFKUULUVCTZUURUVIDUUBUVMUUQUVHYMUVMUUQUVCUUPTUVHUULUVCUUPVRYPUUP
        UVCKYOUUOLCUUNEVSVTWBWCWDWEWFUVIUVDRZDUUBSZGKSUVNGKSZDUUBSUVLUUGUVNGDKU
        UBWGUVOUVKGKUVIUVDDUUBWHWIUVPUUFDUUBUVPUVHYMUVDRZRZGKSZYLUUBJZUUFUVNUVR
        GKUVNUVHYMOUVDRUVRYMUVHUVDWJUVHYMUVDWKWLWIUVTYPKJZUVSUUFWAUVTYOKIUWAUVT
        YOWMWNWOUKZKUVTPUWBCWPZYOUWBIUVTPUUAYLWPUWCUUAPYLYTMHHWQWQWRWSWTXACYLUU
        MUUMVIEXBXEPUWBCXCXDWMWNXFXGYOXHXDZUVQUUFGYPKUVHUVDYQYMUVCYPYNMXIXJXOXD
        XKXLXMWLXPXNXQYMYQDUUBXRXSYKYSUUEDUUBYKUVTOYRUUDYMUVTUWAUVFYRUUDRYKUWDU
        VGUWAUVFOYRYPYNLNUUDYPYNXTYPYNYDYAYBYEYCYF $.
    $}

    $( The volume of a set is always nonnegative.  (Contributed by Mario
       Carneiro, 16-Mar-2014.) $)
    ovolge0 $p |- ( A C_ RR -> 0 <_ ( vol* ` A ) ) $=
      ( vf vy vx cr wss cc0 cioo ccom crn cuni caddc cabs cmin cxr clt csup cle
      cv wbr c1 cseq wceq wa cxp cin cn cmap wrex crab ccnv covol cfv wcel wral
      co wb ssrab2 0xr infmxrgelb mp2an eqid ovolmge0 mprgbir ovolval syl5breqr
      ) AEFGAHBSZIJKFCSLMNIVGIUAUBJOPQUCUDBREEUEUFUGUHUPUIZCOUJZOPUKQZAULUMRGVJ
      RTZGDSZRTZDVIVIOFGOUNVKVMDVIUOUQVHCOURUSDVIGUTVACAVLBVIVIVBZVCVDCABVIVNVE
      VF $.

    $( The domain and range of the outer volume function.  (Contributed by
       Mario Carneiro, 16-Mar-2014.) $)
    ovolf $p |- vol* : ~P RR --> ( 0 [,] +oo ) $=
      ( vx vf vy cr cc0 cpnf co covol cv wcel ccom crn wss cxr clt csup cle wor
      wbr syl cpw cicc wf wfn cfv wral cioo cuni caddc cabs cmin c1 cseq wa cxp
      wceq cin cmap wrex crab ccnv xrltso cnvso mpbi supex df-ovol fnmpti elpwi
      cn ovolcl ovolge0 pnfge w3a wb pnfxr elicc1 mp2an syl3anbrc rgen mpbir2an
      0xr ffnfv ) DUAZEFUBGZHUCHWCUDAIZHUEZWDJZAWCUFAWCWEUGBIZKLUHMCIUIUJUKKWHK
      ULUMLNOPUPUNBQDDUOUQVIURGUSCNUTZNOVAZPHNWIWJNORNWJRVBNOVCVDVEACBVFVGWGAWC
      WEWCJWEDMZWGWEDVHWKWFNJZEWFQSZWFFQSZWGWEVJZWEVKWKWLWNWOWFVLTENJFNJWGWLWMW
      NVMVNWAVOEFWFVPVQVRTVSAWCWDHWBVT $.

    $( If an outer volume is bounded above, then it is real.  (Contributed by
       Mario Carneiro, 18-Mar-2014.) $)
    ovollecl $p |- ( ( A C_ RR /\ B e. RR /\ ( vol* ` A ) <_ B ) ->
                     ( vol* ` A ) e. RR ) $=
      ( cr wss wcel covol cfv cle wbr w3a cxr cc0 ovolcl 3ad2ant1 simp2 ovolge0
      simp3 xrrege0 syl22anc ) ACDZBCEZAFGZBHIZJUBKEZUALUBHIZUCUBCETUAUDUCAMNTU
      AUCOTUAUEUCAPNTUAUCQUBBRS $.

    ${
      ovolss.1 $e |- M = { y e. RR* |
        E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( A C_ U. ran ( (,) o. f ) /\
           y = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) } $.
      ovolss.2 $e |- N = { y e. RR* |
        E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( B C_ U. ran ( (,) o. f ) /\
           y = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) } $.
      $( Lemma for ~ ovolss .  (Contributed by Mario Carneiro, 16-Mar-2014.) $)
      ovolsslem $p |- ( ( A C_ B /\ B C_ RR ) ->
                        ( vol* ` A ) <_ ( vol* ` B ) ) $=
        ( vx wss cr wa cxr csup cle wbr cv ccom wceq wcel cfv clt ccnv wral crn
        covol cioo cuni caddc cabs cmin c1 cseq cxp cin cn cmap co wrex crab wi
        ad2antrr anim1d reximdv ss2rabdv 3sstr4g ovolval adantr ssrab2 infmxrlb
        sstr2 sstr eqsstri mpan adantl eqbrtrd ralrimiva syl ssralv sylc ovolcl
        wb infmxrgelb sylancr mpbird breqtrrd ) BCJZCKJZLZBUFUAZFMUBUCZNZCUFUAZ
        OWIWJWLOPZWJIQZOPZIFUDZWIFEJWPIEUDZWQWICUGDQZRUEUHZJZAQZUIUJUKRWSRULUMU
        EMUBNSZLZDOKKUNUOUPUQURZUSZAMUTZBWTJZXCLZDXEUSZAMUTZFEWIXFXJAMWIXBMTZLZ
        XDXIDXEXMXAXHXCWGXAXHVAWHXLBCWTVKVBVCVDVEHGVFWIBKJZWRBCKVLZXNWPIEXNWOET
        ZLWJEMWKNZWOOXNWJXQSXPABDEGVGVHXPXQWOOPZXNEMJXPXREXKMGXJAMVIVMEWOVJVNVO
        VPVQVRWPIFEVSVTWIFMJWJMTZWNWQWBFXGMHXFAMVIVMWIXNXSXOBWAVRIFWJWCWDWEWHWM
        WLSWGACDFHVGVOWF $.
    $}

    $( The volume of a set is monotone with respect to set inclusion.
       (Contributed by Mario Carneiro, 16-Mar-2014.) $)
    ovolss $p |- ( ( A C_ B /\ B C_ RR ) -> ( vol* ` A ) <_ ( vol* ` B ) ) $=
      ( vy vf cioo cv ccom crn cuni wss caddc cabs cmin c1 wa cr wrex crab eqid
      cxr cseq clt csup wceq cle cxp cin cn cmap co ovolsslem ) CABDAEDFZGHIZJC
      FKLMGULGNUAHTUBUCUDZODUEPPUFUGUHUIUJZQCTRZBUMJUNODUOQCTRZUPSUQSUK $.

    $( If a set is contained in another of bounded measure, it too is bounded.
       (Contributed by Mario Carneiro, 18-Mar-2014.) $)
    ovolsscl $p |- ( ( A C_ B /\ B C_ RR /\ ( vol* ` B ) e. RR ) ->
                     ( vol* ` A ) e. RR ) $=
      ( wss cr covol cfv wcel w3a cle wbr 3adant3 simp3 ovolss ovollecl syl3anc
      sstr ) ABCZBDCZBEFZDGZHADCZTAEFZSIJZUBDGQRUATABDPKQRTLQRUCTABMKASNO $.

    $( A subset of a nullset is null.  (Contributed by Mario Carneiro,
       19-Mar-2014.) $)
    ovolssnul $p |- ( ( A C_ B /\ B C_ RR /\ ( vol* ` B ) = 0 ) ->
                      ( vol* ` A ) = 0 ) $=
      ( wss cr covol cfv cc0 wceq w3a cle wbr ovolss 3adant3 simp3 breqtrd sstr
      ovolge0 syl cxr wcel wa wb ovolcl 0xr xrletri3 sylancl mpbir2and ) ABCZBD
      CZBEFZGHZIZAEFZGHZUMGJKZGUMJKZULUMUJGJUHUIUMUJJKUKABLMUHUIUKNOULADCZUPUHU
      IUQUKABDPMZAQRULUMSTZGSTUNUOUPUAUBULUQUSURAUCRUDUMGUEUFUG $.

    ${
      ovollb2.1 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
      ${
        ovollb2.2 $e |- G = ( n e. NN |->
          <. ( ( 1st ` ( F ` n ) ) - ( ( B / 2 ) / ( 2 ^ n ) ) ) ,
             ( ( 2nd ` ( F ` n ) ) + ( ( B / 2 ) / ( 2 ^ n ) ) ) >. ) $.
        ovollb2.3 $e |- T = seq 1 ( + , ( ( abs o. - ) o. G ) ) $.
        ovollb2.4 $e |- ( ph -> F : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
        ovollb2.5 $e |- ( ph -> A C_ U. ran ( [,] o. F ) ) $.
        ovollb2.6 $e |- ( ph -> B e. RR+ ) $.
        ovollb2.7 $e |- ( ph -> sup ( ran S , RR* , < ) e. RR ) $.
        $( Lemma for ~ ovollb2 .  (Contributed by Mario Carneiro,
           24-Mar-2015.) $)
        ovollb2lem $p |- ( ph ->
          ( vol* ` A ) <_ ( sup ( ran S , RR* , < ) + B ) ) $=
          ( cfv co cr wcel cn vm vz vy vk covol crn cxr clt csup caddc wss cicc
          ccom cuni cle cxp cin wf ovolficcss syl sstrd ovolcl cc0 cpnf cico cv
          c1st c2 cdiv cexp cmin c2nd cop wa wbr ovolfcl sylan simp1d rphalfcld
          w3a crp adantr cn0 2nn nnnn0 adantl nnexpcl sylancr rpdivcld resubcld
          nnrpd rpred simp2d readdcld ltsubrpd simp3d lelttrd lttrd ltled df-br
          ltaddrpd sylib opelxpi elin sylanbrc eqid ovolsf frn syl6ss wrex wral
          syl2anc wceq fveq2d oveq2d oveq12d ovex eqbrtrd adantlr wi syl3anc wb
          syl6eq c1 fveq1i csu sseldi recnd rpcnd sylan2 ovolfsval oveq1d eqtrd
          cseq cc 3eqtr4d fsumser wfn ffn mpbird fmptd cabs icossxr rexrd fveq2
          supxrcl cioo oveq2 opeq12d opex fvmpt op1st sselda ltletr mpand op2nd
          breqtrrd lelttr mpan2d anim12d reximdva ralimdva ovolficc 3imtr4d mpd
          ovolfioo ovollb cfz fzfid pnfxr icossre ovolfsf elfznn ffvelrn syl2an
          0re mp2an fsumadd subcld addsubassd subadd23d subsub3d nnne0d divdird
          nncnd 2halvesd eqtr3d cuz simpr syl6eleq addcld eqidd syl6eqr geo2sum
          nnuz 3eqtr3d ffvelrnda fnfvelrn supxrub le2addd ralrimiva breq1 ralrn
          syl5eq 3syl supxrleub xrletrd ) ABUEPZEUFZUGUHUIZDUFZUGUHUIZCUJQZABRU
          KZUXHUGSABULGUMUFUNZRMATUORRUPZUQZGURZUXORUKLGUSUTVAZBVBUTAUXIUGUKZUX
          JUGSAUXIVCVDVEQZUGATUYAEURZUXIUYAUKATUXQHURZUYBAFTFVFZGPZVGPZCVHVIQZV
          HUYDVJQZVIQZVKQZUYEVLPZUYIUJQZVMZUXQHAUYDTSZVNZUYMUOSZUYMUXPSZUYMUXQS
          UYOUYJUYLUOVOUYPUYOUYJUYLUYOUYFUYIUYOUYFRSZUYKRSZUYFUYKUOVOZAUXRUYNUY
          RUYSUYTVTLGUYDVPVQZVRZUYOUYIUYOUYGUYHAUYGWASZUYNACNVSZWBUYOUYHUYOVHTS
          ZUYDWCSZUYHTSWDUYNVUFAUYDWEWFVHUYDWGWHWKWIZWLZWJZUYOUYKUYIUYOUYRUYSUY
          TVUAWMZVUHWNZUYOUYJUYFUYLVUIVUBVUKUYOUYFUYIVUBVUGWOUYOUYFUYKUYLVUBVUJ
          VUKUYOUYRUYSUYTVUAWPUYOUYKUYIVUJVUGXAWQWRWSUYJUYLUOWTXBUYOUYJRSUYLRSU
          YQVUIVUKUYJUYLRRXCXLUYMUOUXPXDXEJUUAZEHUUBVKUMZHUMZVUNXFZKXGUTZTUYAEX
          HUTVCVDUUCZXIZUXIUUFUTAUXMAUXLCOACNWLWNUUDZAUYCBUUGHUMUFUNUKZUXHUXJUO
          VOVULABUXOUKZVUTMAUAVFZGPZVGPZUBVFZUOVOZVVEVVCVLPZUOVOZVNZUATXJZUBBXK
          ZVVBHPZVGPZVVEUHVOZVVEVVLVLPZUHVOZVNZUATXJZUBBXKZVVAVUTAVVJVVRUBBAVVE
          BSZVNZVVIVVQUATVWAVVBTSZVNZVVFVVNVVHVVPVWCVVMVVDUHVOZVVFVVNAVWBVWDVVT
          AVWBVNZVVMVVDUYGVHVVBVJQZVIQZVKQZVVDUHVWEVVMVWHVVGVWGUJQZVMZVGPVWHVWE
          VVLVWJVGVWBVVLVWJXMAFVVBUYMVWJTHUYDVVBXMZUYJVWHUYLVWIVWKUYFVVDUYIVWGV
          KVWKUYEVVCVGUYDVVBGUUEZXNVWKUYHVWFUYGVIUYDVVBVHVJUUHXOZXPVWKUYKVVGUYI
          VWGUJVWKUYEVVCVLVWLXNVWMXPUUIJVWHVWIUUJUUKWFZXNVWHVWIVVDVWGVKXQZVVGVW
          GUJXQZUULYCZVWEVVDVWGVWEVVDRSZVVGRSZVVDVVGUOVOZAUXRVWBVWRVWSVWTVTLGVV
          BVPVQZVRZVWEUYGVWFAVUCVWBVUDWBZVWEVWFVWEVUEVVBWCSZVWFTSWDVWBVXDAVVBWE
          WFVHVVBWGWHZWKZWIZWOXRXSVWCVVMRSZVWRVVERSZVWDVVFVNVVNXTAVWBVXHVVTVWEV
          XHVVORSZVVMVVOUOVOZAUYCVWBVXHVXJVXKVTVULHVVBVPVQZVRXSAVWBVWRVVTVXBXSV
          WAVXIVWBABRVVEUXSUUMWBZVVMVVDVVEUUNYAUUOVWCVVHVVGVVOUHVOZVVPAVWBVXNVV
          TVWEVVGVWIVVOUHVWEVVGVWGVWEVWRVWSVWTVXAWMZVXGXAVWEVVOVWJVLPVWIVWEVVLV
          WJVLVWNXNVWHVWIVWOVWPUUPYCZUUQXSVWCVXIVWSVXJVVHVXNVNVVPXTVXMAVWBVWSVV
          TVXOXSAVWBVXJVVTVWEVXHVXJVXKVXLWMXSVVEVVGVVOUURYAUUSUUTUVAUVBAUXNUXRV
          VAVVKYBUXSLUBBUAGUVCXLAUXNUYCVUTVVSYBUXSVULUBBUAHUVFXLUVDUVEBEHKUVGXL
          AUXJUXMUOVOZUCVFZUXMUOVOZUCUXIXKZAVXTUDVFZEPZUXMUOVOZUDTXKZAVYCUDTAVY
          ATSZVNZVYBVYADPZCCVHVYAVJQZVIQZVKQZUJQZUXMUOVYFVYBVYAUJVUNYDYNZPZVYKV
          YAEVYLKYEVYFYDVYAUVHQZVVBVUMGUMZPZCVWFVIQZUJQZUAYFVYNVYPUAYFZVYNVYQUA
          YFZUJQVYMVYKVYFVYNVYPVYQUAVYFYDVYAUVIVYFVVBVYNSZVNZVYPWUBUYARVYPVCRSV
          DUGSUYARUKUVPUVJVCVDUVKUVQZVYFTUYAVYOURZVWBVYPUYASWUAAWUDVYEAUXRWUDLG
          VYOVYOXFZUVLUTWBVVBVYAUVMZTUYAVVBVYOUVNUVOYGYHZAWUAVYQYOSZVYEWUAAVWBW
          UHWUFVWEVYQVWECVWFACWASZVWBNWBZVXFWIYIZYJXSZUVRVYFVYRUAVUNYDVYAAWUAVV
          BVUNPZVYRXMZVYEWUAAVWBWUNWUFVWEWUMVVOVVMVKQZVYRAUYCVWBWUMWUOXMVULHVUN
          VVBVUOYKVQVWEVWIVWHVKQVVGVWGVWHVKQZUJQZWUOVYRVWEVVGVWGVWHVWEVVGVXOYHZ
          VWEVWGVXGYIZVWEVVDVWGVWEVVDVXBYHZWUSUVSUVTVWEVVOVWIVVMVWHVKVXPVWQXPVW
          EVVGVVDVKQZVYQUJQVVGVYQVVDVKQZUJQVYRWUQVWEVVGVVDVYQWURWUTWUKUWAVWEVYP
          WVAVYQUJAUXRVWBVYPWVAXMLGVYOVVBWUEYKVQYLVWEWUPWVBVVGUJVWEWUPVWGVWGUJQ
          ZVVDVKQWVBVWEVWGVVDVWGWUSWUTWUSUWBVWEWVCVYQVVDVKVWEUYGUYGUJQZVWFVIQWV
          CVYQVWEUYGUYGVWFVWEUYGVXCYIZWVEVWEVWFVXEUWEVWEVWFVXEUWCUWDVWEWVDCVWFV
          IVWECVWECWUJYIUWFYLUWGYLYMXOYPYPYMYJXSVYFVYATYDUWHPAVYEUWIZUWOUWJZWUB
          VYPVYQWUGWULUWKYQVYFVYSVYGVYTVYJUJVYFVYSVYAUJVYOYDYNZPVYGVYFVYPUAVYOY
          DVYAWUBVYPUWLWVGWUGYQVYADWVHIYEUWMVYFVYECYOSVYTVYJXMWVFVYFCAWUIVYENWB
          ZYICUAVYAUWNXLXPUWPUXDVYFVYGVYJUXLCVYFUYARVYGWUCATUYAVYADAUXRTUYADURZ
          LDGVYOWUEIXGUTZUWQYGVYFCVYIVYFCWVIWLZVYFVYIVYFCVYHWVIVYFVYHVYFVUEVYAW
          CSZVYHTSWDVYEWVMAVYAWEWFVHVYAWGWHWKWIZWLWJZAUXLRSVYEOWBWVLVYFUXKUGUKZ
          VYGUXKSZVYGUXLUOVOAWVPVYEAUXKUYAUGAWVJUXKUYAUKWVKTUYADXHUTVUQXIWBADTY
          RZVYEWVQAWVJWVRWVKTUYADYSUTTVYADUWRVQUXKVYGUWSXLVYFVYJCWVOWVLVYFCVYIW
          VLWVNWOWSUWTXRUXAAUYBETYRVXTVYDYBVUPTUYAEYSVXSVYCUCUDTEVXRVYBUXMUOUXB
          UXCUXEYTAUXTUXMUGSVXQVXTYBVURVUSUCUXIUXMUXFXLYTUXG $.
      $}

      $( It is often more convenient to do calculations with *closed* coverings
         rather than open ones; here we show that it makes no difference
         (compare ~ ovollb ).  (Contributed by Mario Carneiro, 24-Mar-2015.) $)
      ovollb2 $p |- ( ( F : NN --> ( <_ i^i ( RR X. RR ) ) /\
                       A C_ U. ran ( [,] o. F ) ) ->
                     ( vol* ` A ) <_ sup ( ran S , RR* , < ) ) $=
        ( vx cn cle cr ccom wss wa cfv cpnf wcel syl c0 co cmin c1 caddc vm cxp
        vn cin wf cicc crn cuni covol cxr clt csup wceq simpr ovolficcss adantr
        wbr sstrd ovolcl pnfge breqtrrd wne cc0 cico cabs eqid ovolsf frn pnfxr
        wb 0re icossre mp2an syl6ss cdm 1nn fdm syl5eleqr ne0i dm0rn0 necon3bii
        sylib supxrre2 syl2anc biimpar cv crp wral c1st cdiv cexp c2nd cop cmpt
        cseq fveq2 fveq2d oveq2d oveq12d opeq12d cbvmptv simplll simpllr simplr
        c2 oveq2 ovollb2lem ralrimiva xralrple sylan mpbird syldan pm2.61dane )
        FGHHUBUDCUEZAUFCIUGUHZJZKZAUILZBUGZUJUKULZGUQZXTMXQXTMUMZKZXRMXTGYCXRUJ
        NZXRMGUQXQYDYBXQAHJYDXQAXOHXNXPUNXNXOHJXPCUOUPURAUSOZUPXRUTOXQYBUNVAXQX
        TMVBZXTHNZYAXQYGYFXQXSHJXSPVBZYGYFVJXQXSVCMVDQZHXQFYIBUEZXSYIJXNYJXPBCV
        ERIZCIZYLVFDVGUPZFYIBVHOVCHNMUJNYIHJVKVIVCMVLVMVNXQBVOZPVBZYHXQSYNNYOXQ
        SFYNVPXQYJYNFUMYMFYIBVQOVRYNSVSOYNPXSPBVTWAWBXSWCWDWEXQYGKZYAXRXTEWFZTQ
        GUQZEWGWHZYPYREWGYPYQWGNZKAYQBTYKUAFUAWFZCLZWILZYQXEWJQZXEUUAWKQZWJQZRQ
        ZUUBWLLZUUFTQZWMZWNZISWOZUCCUUKDUAUCFUUJUCWFZCLZWILZUUDXEUUMWKQZWJQZRQZ
        UUNWLLZUUQTQZWMUUAUUMUMZUUGUURUUIUUTUVAUUCUUOUUFUUQRUVAUUBUUNWIUUAUUMCW
        PZWQUVAUUEUUPUUDWJUUAUUMXEWKXFWRZWSUVAUUHUUSUUFUUQTUVAUUBUUNWLUVBWQUVCW
        SWTXAUULVFXNXPYGYTXBXNXPYGYTXCYPYTUNXQYGYTXDXGXHXQYDYGYAYSVJYEEXRXTXIXJ
        XKXLXM $.
    $}

    $( The volume of a denumerable set is 0.  (Contributed by Mario Carneiro,
       17-Mar-2014.)  (Proof shortened by Mario Carneiro, 25-Mar-2015.) $)
    ovolctb $p |- ( ( A C_ RR /\ A ~~ NN ) -> ( vol* ` A ) = 0 ) $=
      ( vx vy cn wbr cr cfv cc0 wceq wa cle cid c1 cxr clt wf wcel cvv syl6eq
      cc vf cen wss covol ensym wf1o wex bren caddc cabs cmin ccom cof cseq crn
      cv co csup cxp cin cicc cuni cmpt cop simpll f1of adantl ffvelrnda sseldd
      leidd df-br sylib opelxpi syl2anc elin sylanbrc df-ov ax-mp eqtri mpteq2i
      opex fvi fmptd nnex a1i recnd feqmptd offval2 feq1d mpbird c1st c2nd wrex
      wral wfo f1ofo forn syl eleq2d wb f1ofn fvelrnb bitr3d fveq1d eqid fvmpt2
      wfn mpan2 sylan9eq fveq2d fvex op1st eqbrtrd op2nd breqtrrd breq2 anbi12d
      jca breq1 syl5ibcom reximdva sylbid ralrimiv ovolficc syldan ovollb2 absf
      csn subf fco mp2an fveq2 syl6eqr fmptco cme cnmet met0 sylancr 0xr adantr
      mpteq2dva eqtrd fconstmpt seqeq3d cz 1z nnuz ser0f rneqd c0 wne ne0i rnxp
      1nn mp2b supeq1d wor xrltso supsn breqtrd ovolge0 ovolcl xrletri3 sylancl
      mpbir2and ex exlimdv syl5bi imp sylan2 ) ADUBEAFUCZDAUBEZAUDGZHIZADUEUVKU
      VLUVNUVLDAUAUPZUFZUAUGUVKUVNDAUAUHUVKUVPUVNUAUVKUVPUVNUVKUVPJZUVNUVMHKEZH
      UVMKEZUVQUVMUIUJUKULZUVOUVOLUMUQZULZMUNZUOZNOURZHKUVQDKFFUSZUTZUWAPZAVAUW
      AULUOVBUCZUVMUWEKEUVQUWHDUWGBDBUPZUVOGZUWKLUQZVCZPUVQBDUWKUWKVDZUWGUWMUVQ
      UWJDQZJZUWNKQZUWNUWFQZUWNUWGQUWPUWKUWKKEUWQUWPUWKUWPAFUWKUVKUVPUWOVEUVQDA
      UWJUVOUVPDAUVOPUVKDAUVOVFVGZVHVIZVJZUWKUWKKVKVLUWPUWKFQZUXBUWRUWTUWTUWKUW
      KFFVMVNUWNKUWFVOVPBDUWLUWNUWLUWNLGZUWNUWKUWKLVQUWNRQZUXCUWNIUWKUWKWAZUWNR
      WBVRVSVTZWCUVQDUWGUWAUWMUVQBDUWKUWKLUVOUVORTTDRQUVQWDWEUWPUWKUWTWFZUXGUVQ
      BDAUVOUWSWGZUXHWHZWIWJZUVQUWIUWJUWAGZWKGZCUPZKEZUXMUXKWLGZKEZJZBDWMZCAWNZ
      UVQUXRCAUVQUXMAQZUWKUXMIZBDWMZUXRUVQUXMUVOUOZQZUXTUYBUVQUYCAUXMUVQDAUVOWO
      ZUYCAIUVPUYEUVKDAUVOWPVGDAUVOWQWRWSUVQUVODXGZUYDUYBWTUVPUYFUVKDAUVOXAVGBD
      UXMUVOXBWRXCUVQUYAUXQBDUWPUXLUWKKEZUWKUXOKEZJUYAUXQUWPUYGUYHUWPUXLUWKUWKK
      UWPUXLUWNWKGUWKUWPUXKUWNWKUVQUWOUXKUWJBDUWNVCZGZUWNUVQUWJUWAUYIUVQUWAUWMU
      YIUXIUXFSZXDUWOUXDUYJUWNIUXEBDUWNRUYIUYIXEXFXHXIZXJUWKUWKUWJUVOXKZUYMXLSU
      XAXMUWPUWKUWKUXOKUXAUWPUXOUWNWLGUWKUWPUXKUWNWLUYLXJUWKUWKUYMUYMXNSXOXRUYA
      UYGUXNUYHUXPUWKUXMUXLKXPUWKUXMUXOKXSXQXTYAYBYCUVKUVPUWHUWIUXSWTUXJCABUWAY
      DYEWJAUWCUWAUWCXEYFVNUVQUWEHYHZNOURZHUVQNUWDUYNOUVQUWDDUYNUSZUOZUYNUVQUWC
      UYPUVQUWCUIUYPMUNZUYPUVQUWBUYPUIMUVQUWBBDHVCZUYPUVQUWBBDUWKUWKUVTUQZVCUYS
      UVQBCDTTUSZUWNUXMUVTGZUYTUWAUVTUWPUWKTQZVUCUWNVUAQUXGUXGUWKUWKTTVMVNUYKUV
      QCVUAFUVTVUAFUVTPZUVQTFUJPVUATUKPVUDYGYIVUATFUJUKYJYKWEWGUXMUWNIVUBUWNUVT
      GUYTUXMUWNUVTYLUWKUWKUVTVQYMYNUVQBDUYTHUWPUVTTYOGQVUCUYTHIYPUXGUWKUVTTYQY
      RUUAUUBBDHUUCYMUUDMUUEQUYRUYPIUUFMDUUGUUHVRSUUIMDQDUUJUUKUYQUYNIUUNDMUULD
      UYNUUMUUOSUUPNOUUQHNQZUYOHIUURYSNHOUUSYKSUUTUVKUVSUVPAUVAYTUVQUVMNQZVUEUV
      NUVRUVSJWTUVKVUFUVPAUVBYTYSUVMHUVCUVDUVEUVFUVGUVHUVIUVJ $.
  $}

  $( The rational numbers have 0 outer Lebesgue measure.  (Contributed by Mario
     Carneiro, 17-Mar-2014.) $)
  ovolq $p |- ( vol* ` QQ ) = 0 $=
    ( cq cr wss cn cen wbr covol cfv cc0 wceq qssre qnnen ovolctb mp2an ) ABCAD
    EFAGHIJKLAMN $.

  $( The volume of a countable set is 0.  (Contributed by Mario Carneiro,
     17-Mar-2014.) $)
  ovolctb2 $p |- ( ( A C_ RR /\ A ~<_ NN ) -> ( vol* ` A ) = 0 ) $=
    ( cr wss cn cdom wbr wa cun covol cfv cc0 wceq simpl cen com nnenom domentr
    sylancl cvv syl2anc nnssre jctir unss sylib mpan2 adantl endom ax-mp ensymi
    unctb wcel reex ssex ssun2 ssdomg ee10 sbth ovolctb ssun1 ovolssnul mp3an1
    syl ) ABCZADEFZGZADHZBCZVFIJKLZAIJKLZVEVCDBCZGVGVEVCVJVCVDMUAUBADBUCUDZVEVG
    VFDNFZVHVKVEVFDEFZDVFEFZVLVEVFOEFZODNFVMVEAOEFZDOEFZVOVDVPVCVDDONFZVPPADOQU
    EUFVRVQPDOUGUHADUJRDOPUIVFODQRVEVFSUKZDVFCVNVEVGVSVKVFBULUMVBDAUNDVFSUOUPVF
    DUQTVFURTAVFCVGVHVIADUSAVFUTVAT $.

  $( The empty set has 0 outer Lebesgue measure.  (Contributed by Mario
     Carneiro, 17-Mar-2014.) $)
  ovol0 $p |- ( vol* ` (/) ) = 0 $=
    ( c0 cr wss cn cdom wbr covol cfv cc0 wceq 0ss nnex 0dom ovolctb2 mp2an ) A
    BCADEFAGHIJBKDLMANO $.

  $( A finite set has 0 outer Lebesgue measure.  (Contributed by Mario
     Carneiro, 13-Aug-2014.) $)
  ovolfi $p |- ( ( A e. Fin /\ A C_ RR ) -> ( vol* ` A ) = 0 ) $=
    ( cr wss cdom wbr covol cfv cc0 wceq cfn wcel com cen csdm isfinite sdomdom
    cn id sylbi nnenom ensymi domentr sylancl ovolctb2 syl2anr ) ABCZUFAQDEZAFG
    HIAJKZUFRUHALDEZLQMEUGUHALNEUIAOALPSQLTUAALQUBUCAUDUE $.

  $( A singleton has 0 outer Lebesgue measure.  (Contributed by Mario Carneiro,
     15-Aug-2014.) $)
  ovolsn $p |- ( A e. RR -> ( vol* ` { A } ) = 0 ) $=
    ( cr wcel csn cfn wss covol cfv cc0 wceq snfi snssi ovolfi sylancr ) ABCADZ
    ECOBFOGHIJAKABLOMN $.

  ${
    $d g h k n z C $.  $d k m n z F $.  $d f j k m z H $.  $d z N $.  $d z O $.
    $d f g h k m n y z A $.  $d f g h k m n y z B $.  $d k z S $.  $d k z T $.
    $d k m n z G $.  $d g h j k m n z ph $.  $d f k y z U $.
    ovolun.a $e |- ( ph -> ( A C_ RR /\ ( vol* ` A ) e. RR ) ) $.
    ovolun.b $e |- ( ph -> ( B C_ RR /\ ( vol* ` B ) e. RR ) ) $.
    ovolun.c $e |- ( ph -> C e. RR+ ) $.
    ${
      ovolun.s $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
      ovolun.t $e |- T = seq 1 ( + , ( ( abs o. - ) o. G ) ) $.
      ovolun.u $e |- U = seq 1 ( + , ( ( abs o. - ) o. H ) ) $.
      ovolun.f1 $e |- ( ph -> F e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ) $.
      ovolun.f2 $e |- ( ph -> A C_ U. ran ( (,) o. F ) ) $.
      ovolun.f3 $e |- ( ph -> sup ( ran S , RR* , < ) <_
                        ( ( vol* ` A ) + ( C / 2 ) ) ) $.
      ovolun.g1 $e |- ( ph -> G e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ) $.
      ovolun.g2 $e |- ( ph -> B C_ U. ran ( (,) o. G ) ) $.
      ovolun.g3 $e |- ( ph -> sup ( ran T , RR* , < ) <_
                        ( ( vol* ` B ) + ( C / 2 ) ) ) $.
      ovolun.h $e |- H = ( n e. NN |-> if ( ( n / 2 ) e. NN ,
        ( G ` ( n / 2 ) ) , ( F ` ( ( n + 1 ) / 2 ) ) ) ) $.
      $( Lemma for ~ ovolun .  (Contributed by Mario Carneiro, 7-May-2015.) $)
      ovolunlem1a $p |- ( ( ph /\ k e. NN ) ->
        ( U ` k ) <_ ( ( ( vol* ` A ) + ( vol* ` B ) ) + C ) ) $=
        ( vj vz cv cn wcel wa cfv c2 c1 caddc co cdiv cmul covol cr cc0 cpnf wf
        wss cle reex nnex elmap sylib adantr ffvelrnda wn wb nneo adantl syldan
        cif cmin ccom eqid ovolsf syl cxr sylancl 2nn cz rehalfcld ax-1cn mpbid
        wbr 1re clt 1z simprd readdcld cseq cuz syl6eleq syl2an syl2anc ovolfsf
        nnuz nnz fveq1i syl6ss c0 wne 1nn wceq letrd oveq2 fveq2d fveq2 oveq12d
        eqeq12d imbi2d c2nd c1st ovolfsval oveq1 eleq1d oveq1d 2cn syl6eq eqtrd
        wi 2ne0 fvex fvmpt fveq2i seq1i syl5eq a1i recnd eqeltrd 3eqtrd ffvelrn
        cc seqp1 sseldi cfl cico cxp cin cmap xpex inex2 con2bid biimpar ifclda
        fmptd cabs 0re pnfxr icossre mp2an fss nnred flcld 2timesi nnge1 leadd1
        peano2nn nnre mp3an13 syl5eqbr 2re 2pos pm3.2i lemuldiv2 elnnz1 nnmulcl
        flge sylanbrc sylancr rpred simpr flhalf eluz mpbird cfz elfznn elrege0
        simpld sylan2 elfzuz uztrn2 sermono 3brtr4g crn frn wfn fnfvelrn sseldd
        ffn csup cmnf ressxr supxrcl syl5eleqr ne0i dm0rn0 necon3bii supxrgtmnf
        cdm fdm xrre syl22anc supxrub le2addd halfnz syl5ib mtoi iffalse dividi
        df-2 syl6eqr ax-mp oveq12i mulid1i syl6eqel iftrue seqp1i eqtr4d oveq2i
        mpan nncnd addassd 3eqtr4a peano2nnd ifbieq12d divcan3d divcan3 mp3an23
        adddid ifex eqtr3d 3eqtr4rd 3eqtr4d oveq1i 3eqtr4g add4d syl5ibr expcom
        a2d nnind impcom 2halvesd oveq2d eqtr2d 3brtr4d ) AHUHZUIUJZUKZVULGULZU
        MVULUNUOUPZUMUQUPZUUAULZURUPZGULZBUSULZCUSULZUOUPZDUOUPZAUIUTVULGAUIVAV
        BUUBUPZGVCZVVEUTVDZUIUTGVCAUIVEUTUTUUCZUUDZLVCZVVFAIUIIUHZUMUQUPZUIUJZV
        VLKULZVVKUNUOUPZUMUQUPZJULZVQZVVILAVVKUIUJZUKZVVMVVNVVQVVIVVTUIVVIVVLKA
        UIVVIKVCZVVSAKVVIUIUUEUPZUJVWAUBVVIUIKVVHVEUTUTVFVFUUFUUGZVGVHVIZVJVKVV
        TVVMVLZVVPUIUJZVVQVVIUJVVTVWFVWEVVTVVMVWFVVSVVMVWFVLVMAVVKVNVOUUHUUIVVT
        UIVVIVVPJAUIVVIJVCZVVSAJVWBUJVWGSVVIUIJVWCVGVHVIZVJVKVPUUJUEUUKZGLUULVR
        VSZLVSZVWKVTZRWAWBZVAUTUJVBWCUJVVGUUMUUNVAVBUUOUUPZUIVVEUTGUUQWDZVKAVUM
        VUSUIUJZVUTUTUJVUNUMUIUJZVURUIUJZVWPWEVUNVURWFUJUNVURVEWJZVWRVUNVUQVUNV
        UPVUNVUPVUMVUPUIUJZAVULUVCZVOZUURZWGZUUSVUNUNVUQVEWJZVWSVUNUMUNURUPZVUP
        VEWJZVXEVUNVXFUNUNUOUPZVUPVEUNWHUUTZVUNUNVULVEWJZVXHVUPVEWJZVUMVXJAVULU
        VAVOVUNVULUTUJZVXJVXKVMZVUMVXLAVULUVDVOZUNUTUJZVXLVXOVXMWKWKUNVULUNUVBU
        VEWBWIUVFVUNVUPUTUJZVXGVXEVMZVXCVXOVXPUMUTUJZVAUMWLWJZUKVXQWKVXRVXSUVGU
        VHUVIUNVUPUMUVJUVEWBWIVUNVUQUTUJUNWFUJVXEVWSVMVXDWMVUQUNUVMWDWIVURUVKUV
        NZUMVURUVLUVOZAUIUTVUSGVWOVKVPAVVDUTUJVUMAVVCDAVVAVVBABUTVDVVAUTUJZMWNZ
        ACUTVDVVBUTUJZNWNZWOADOUVPZWOVJVUNVULUOVWKUNWPZULVUSVYGULVUOVUTVEVUNUFV
        WKVULUNVUSVUNVULUIUNWQULZAVUMUVQZXBWRZVUNVUSVULWQULUJZVULVUSVEWJZVUNVUL
        WFUJZVYLVUMVYMAVULXCZVOVULUVRWBVUNVUMVWPVYKVYLVMZVYIVYAVUMVYMVUSWFUJVYO
        VWPVYNVUSXCVULVUSUVSWSWTUVTUFUHZUNVUSUWAUPUJVUNVYPUIUJZVYPVWKULZUTUJZVY
        PVUSUWBVUNVYQUKZVYSVAVYRVEWJZVYTVYRVVEUJVYSWUAUKVUNUIVVEVYPVWKAUIVVEVWK
        VCZVUMAVVJWUBVWILVWKVWLXAWBVJVKVYRUWCVIZUWDUWEVUNVYPVUPVUSUWAUPUJZVYQWU
        AVUNVWTVYPVUPWQULUJVYQWUDVXBVYPVUPVUSUWFUNVYPVUPUIXBUWGWSVYTVYSWUAWUCWN
        VPUWHVULGVYGRXDVUSGVYGRXDUWIVUNVUREULZVURFULZUOUPZVVADUMUQUPZUOUPZVVBWU
        HUOUPZUOUPZVUTVVDVEVUNWUEWUFWUIWUJVUNEUWJZUTWUEAWULUTVDZVUMAWULVVEUTAUI
        VVEEVCZWULVVEVDAVWGWUNVWHEJVWJJVSZWUOVTZPWAWBZUIVVEEUWKWBVWNXEZVJVUNEUI
        UWLZVWRWUEWULUJZAWUSVUMAWUNWUSWUQUIVVEEUWOWBVJVXTUIVUREUWMWTZUWNZVUNFUW
        JZUTWUFAWVCUTVDZVUMAWVCVVEUTAUIVVEFVCZWVCVVEVDAVWAWVEVWDFKVWJKVSZWVFVTZ
        QWAWBZUIVVEFUWKWBVWNXEZVJVUNFUIUWLZVWRWUFWVCUJZAWVJVUMAWVEWVJWVHUIVVEFU
        WOWBVJVXTUIVURFUWMWTZUWNZAWUIUTUJZVUMAVVAWUHVYCADVYFWGZWOZVJZAWUJUTUJZV
        UMAVVBWUHVYEWVOWOZVJZVUNWUEWULWCWLUWPZWUIWVBAWWAUTUJZVUMAWWAWCUJZWVNUWQ
        WWAWLWJZWWAWUIVEWJZWWBAWULWCVDZWWCAWULUTWCWURUWRXEZWULUWSWBWVPAWUMWULXF
        XGZWWDWURAEUXEZXFXGZWWHAUNWWIUJWWJAUNUIWWIXHAWUNWWIUIXIWUQUIVVEEUXFWBUW
        TWWIUNUXAWBWWIXFWULXFEUXBUXCVIWULUXDWTUAWWAWUIUXGUXHVJWVQVUNWWFWUTWUEWW
        AVEWJAWWFVUMWWGVJWVAWULWUEUXIWTAWWEVUMUAVJXJVUNWUFWVCWCWLUWPZWUJWVMAWWK
        UTUJZVUMAWWKWCUJZWVRUWQWWKWLWJZWWKWUJVEWJZWWLAWVCWCVDZWWMAWVCUTWCWVIUWR
        XEZWVCUWSWBWVSAWVDWVCXFXGZWWNWVIAFUXEZXFXGZWWRAUNWWSUJWWTAUNUIWWSXHAWVE
        WWSUIXIWVHUIVVEFUXFWBUWTWWSUNUXAWBWWSXFWVCXFFUXBUXCVIWVCUXDWTUDWWKWUJUX
        GUXHVJWVTVUNWWPWVKWUFWWKVEWJAWWPVUMWWQVJWVLWVCWUFUXIWTAWWOVUMUDVJXJUXJA
        VUMVWRVUTWUGXIZVXTVWRAWXAAUMUGUHZURUPZGULZWXBEULZWXBFULZUOUPZXIZYFAVXFG
        ULZUNEULZUNFULZUOUPZXIZYFAUMVULURUPZGULZVULEULZVULFULZUOUPZXIZYFAUMVUPU
        RUPZGULZVUPEULZVUPFULZUOUPZXIZYFAWXAYFUGHVURWXBUNXIZWXHWXMAWYFWXDWXIWXG
        WXLWYFWXCVXFGWXBUNUMURXKXLWYFWXEWXJWXFWXKUOWXBUNEXMWXBUNFXMXNXOXPWXBVUL
        XIZWXHWXSAWYGWXDWXOWXGWXRWYGWXCWXNGWXBVULUMURXKXLWYGWXEWXPWXFWXQUOWXBVU
        LEXMWXBVULFXMXNXOXPWXBVUPXIZWXHWYEAWYHWXDWYAWXGWYDWYHWXCWXTGWXBVUPUMURX
        KXLWYHWXEWYBWXFWYCUOWXBVUPEXMWXBVUPFXMXNXOXPWXBVURXIZWXHWXAAWYIWXDVUTWX
        GWUGWYIWXCVUSGWXBVURUMURXKXLWYIWXEWUEWXFWUFUOWXBVUREXMWXBVURFXMXNXOXPAW
        XIUNJULZXQULZWYJXRULZVRUPZUNKULZXQULZWYNXRULZVRUPZUOUPZWXLAWXIVXFVYGULW
        YRVXFGVYGRXDAWYMWYQUOVWKVXFUNUNUIXBXHVXIAWYMUOVWKUNWMAUNVWKULZUNLULZXQU
        LZWYTXRULZVRUPZWYMAVVJUNUIUJZWYSXUCXIVWIXHLVWKUNVWLXSWDXUAWYKXUBWYLVRWY
        TWYJXQXUDWYTWYJXIXHIUNVVRWYJUILVVKUNXIZVVRVVQWYJXUEVWEVVRVVQXIXUEVVMUNU
        MUQUPZWFUJZUXKVVMVVLWFUJXUEXUGVVLXCXUEVVLXUFWFVVKUNUMUQXTYAUXLUXMVVMVVN
        VVQUXNWBXUEVVPUNJXUEVVPUMUMUQUPZUNXUEVVOUMUMUQXUEVVOVXHUMVVKUNUNUOXTUXP
        UXQYBUMYCYGUXOZYDXLYEUEUNJYHYIUXRZYJWYTWYJXRXUJYJUXSYDYKAVXFVWKULUMVWKU
        LZWYQVXFUMVWKUMYCUXTYJAXUKUMLULZXQULZXULXRULZVRUPZWYQAVVJVWQXUKXUOXIVWI
        WELVWKUMVWLXSWDXUMWYOXUNWYPVRXULWYNXQVWQXULWYNXIWEIUMVVRWYNUILVVKUMXIZV
        VRVVNWYNXUPVVMVVRVVNXIXUPVVLUNUIXUPVVLXUHUNVVKUMUMUQXTXUIYDZXHUYAVVMVVN
        VVQUYBWBXUPVVLUNKXUQXLYEUEUNKYHYIUXRZYJXULWYNXRXURYJUXSYDYLUYCYLAWXJWYM
        WXKWYQUOAWXJUNUOWUOUNWPZULWYMUNEXUSPXDAWYMUOWUOUNWMAVWGXUDUNWUOULWYMXIV
        WHXHJWUOUNWUPXSWDYKYLAWXKUNUOWVFUNWPZULWYQUNFXUTQXDAWYQUOWVFUNWMAVWAXUD
        UNWVFULWYQXIVWDXHKWVFUNWVGXSWDYKYLXNUYDVUMAWXSWYEAVUMWXSWYEYFWXSWYEVUNW
        XOVUPWUOULZVUPWVFULZUOUPZUOUPZWXRXVCUOUPZXIWXOWXRXVCUOXTVUNWYAXVDWYDXVE
        VUNWYAWXNUNUOUPZUNUOUPZGULZWXOXVAUOUPZXVBUOUPZXVDVUNWXTXVGGVUNWXNVXFUOU
        PWXNVXHUOUPWXTXVGVXFVXHWXNUOVXIUYEVUNUMVULUNUMYRUJZVUNYCYMZVUNVULVXNYNZ
        UNYRUJVUNWHYMZUYOVUNWXNUNUNVUNWXNVUMWXNUIUJZAVWQVUMXVOWEUMVULUVLUYFZVOZ
        UYGXVNXVNUYHUYIZXLVUNXVHXVGVYGULZXVJXVGGVYGRXDVUNXVSXVFVYGULZXVGVWKULZU
        OUPZXVJVUNXVFVYHUJXVSXWBXIVUNXVFUIVYHVUNWXNXVQUYJZXBWRUOVWKUNXVFYSWBVUN
        XVTXVIXWAXVBUOVUNXVTWXNVYGULZXVFVWKULZUOUPZXVIVUNWXNVYHUJXVTXWFXIVUNWXN
        UIVYHXVQXBWRUOVWKUNWXNYSWBVUNWXOXWDXVAXWEUOWXOXWDXIVUNWXNGVYGRXDYMVUNXV
        FLULZXQULZXWGXRULZVRUPZVUPJULZXQULZXWKXRULZVRUPZXWEXVAVUNXWHXWLXWIXWMVR
        VUNXWGXWKXQVUNXWGXVFUMUQUPZUIUJZXWOKULZXVGUMUQUPZJULZVQZXWSXWKVUNXVFUIU
        JZXWGXWTXIXWCIXVFVVRXWTUILVVKXVFXIZVVMXWPVVNVVQXWQXWSXXBVVLXWOUIVVKXVFU
        MUQXTZYAXXBVVLXWOKXXCXLXXBVVPXWRJXXBVVOXVGUMUQVVKXVFUNUOXTYBXLUYKUEXWPX
        WQXWSXWOKYHXWRJYHUYPYIWBVUNXWPVLZXWTXWSXIVUNWXNUMUQUPZUIUJZXXDVUNXXEVUL
        UIVUNVULUMXVMXVLUMVAXGZVUNYGYMUYLVYIYOVUNXVOXXFXXDVMXVQWXNVNWBWIXWPXWQX
        WSUXNWBVUNXWRVUPJVUNWXTUMUQUPZXWRVUPVUNWXTXVGUMUQXVRYBVUNVUPYRUJZXXHVUP
        XIZVUNVUPVXBUYGXXIXVKXXGXXJYCYGVUPUMUYMUYNWBZUYQXLYPZXLVUNXWGXWKXRXXLXL
        XNVUNVVJXXAXWEXWJXIAVVJVUMVWIVJZXWCLVWKXVFVWLXSWTAVWGVWTXVAXWNXIVUMVWHV
        XAJWUOVUPWUPXSWSUYRXNUYDVUNXVGLULZXQULZXXNXRULZVRUPZVUPKULZXQULZXXRXRUL
        ZVRUPZXWAXVBVUNXXOXXSXXPXXTVRVUNXXNXXRXQVUNWXTLULZXXNXXRVUNWXTXVGLXVRXL
        VUNXYBXXHUIUJZXXHKULZWXTUNUOUPZUMUQUPZJULZVQZXYDXXRVUNWXTUIUJXYBXYHXIVU
        NWXTXVGUIXVRVUNXVFXWCUYJZYOIWXTVVRXYHUILVVKWXTXIZVVMXYCVVNVVQXYDXYGXYJV
        VLXXHUIVVKWXTUMUQXTZYAXYJVVLXXHKXYKXLXYJVVPXYFJXYJVVOXYEUMUQVVKWXTUNUOX
        TYBXLUYKUEXYCXYDXYGXXHKYHXYFJYHUYPYIWBVUNXYCXYHXYDXIVUNXXHVUPUIXXKVXBYO
        XYCXYDXYGUYBWBVUNXXHVUPKXXKXLYPUYQZXLVUNXXNXXRXRXYLXLXNVUNVVJXVGUIUJXWA
        XXQXIXXMXYILVWKXVGVWLXSWTAVWAVWTXVBXYAXIVUMVWDVXAKWVFVUPWVGXSWSUYSXNYEY
        LVUNWXOXVAXVBVUNWXOVUNVVEUTWXOVWNAVVFXVOWXOVVEUJVUMVWMXVPUIVVEWXNGYQWSY
        TYNVUNXVAVUNVVEUTXVAVWNAUIVVEWUOVCZVWTXVAVVEUJVUMAVWGXYMVWHJWUOWUPXAWBV
        XAUIVVEVUPWUOYQWSYTYNZVUNXVBVUNVVEUTXVBVWNAUIVVEWVFVCZVWTXVBVVEUJVUMAVW
        AXYOVWDKWVFWVGXAWBVXAUIVVEVUPWVFYQWSYTYNZUYHYPVUNWYDWXPXVAUOUPZWXQXVBUO
        UPZUOUPXVEVUNWYBXYQWYCXYRUOVUNVUPXUSULZVULXUSULZXVAUOUPZWYBXYQVUNVULVYH
        UJZXYSYUAXIVYJUOWUOUNVULYSWBVUPEXUSPXDWXPXYTXVAUOVULEXUSPXDUYTVUAVUNVUP
        XUTULZVULXUTULZXVBUOUPZWYCXYRVUNYUBYUCYUEXIVYJUOWVFUNVULYSWBVUPFXUTQXDW
        XQYUDXVBUOVULFXUTQXDUYTVUAXNVUNWXPXVAWXQXVBVUNWXPVUNVVEUTWXPVWNAUIVVEVU
        LEWUQVKYTYNXYNVUNWXQVUNVVEUTWXQVWNAUIVVEVULFWVHVKYTYNXYPVUBYEXOVUCVUDVU
        EVUFVUGVPVUNWUKVVCWUHWUHUOUPZUOUPVVDVUNVVAWUHVVBWUHVUNVVAAVYBVUMVYCVJYN
        VUNWUHVUNDADUTUJVUMVYFVJZWGYNZVUNVVBAVYDVUMVYEVJYNYUHVUBVUNYUFDVVCUOVUN
        DVUNDYUGYNVUHVUIVUJVUKXJ $.

      $( Lemma for ~ ovolun .  (Contributed by Mario Carneiro, 12-Jun-2014.) $)
      ovolunlem1 $p |- ( ph ->
          ( vol* ` ( A u. B ) ) <_ ( ( ( vol* ` A ) + ( vol* ` B ) ) + C ) ) $=
        ( vz vk vm cun covol cfv crn cxr clt csup caddc wss wcel cle wbr simpld
        co cr unssd c0 wne cpnf cn wf cc0 cico cxp cin cv c2 cdiv cif cmap reex
        c1 wa xpex inex2 nnex elmap sylib adantr ffvelrnda wn wb adantl con2bid
        nneo biimpar syldan ifclda cmin ccom syl sylancl wfn wceq wral readdcld
        wrex simprd mpbird rspcev syl2anc syl3anc cioo cuni c1st c2nd cc oveq1d
        mpbid ax-1cn eqtrd oveq1 eleq1d fveq2d ifbieq12d fvex ifex fvmpt 3eqtrd
        eqeltrd eqeq1d breq1d breq2d anbi12d biimprcd reximdv syl5com rexlimdva
        fveq2 ralimdv ovolfioo 3imtr4d mpd fmptd cabs eqid ovolsf pnfxr icossre
        0re mp2an fss frn cdm 1nn cseq cuz cz 1z seqfn mp1i fneq1i fneq2i bitri
        nnuz sylibr fndm syl5eleqr dm0rn0 necon3bii rpred ovolunlem1a ralrimiva
        ne0i breq1 ralrn breq2 ralbidv ressxr syl6ss supxrbnd2 supxrbnd 2timesd
        cmul nncn a1i addsubassd cn0 simpr nnm1nn0 nnnn0addcl 2nn nnmulcl nncnd
        sylancr npcan 2ne0 divcan3 mp3an23 iffalse iftrue ovollb ovollecl rexrd
        2cn supxrleub letrd ) ABCUHZUIUJZGUKZULUMUNZBUIUJZCUIUJZUOVAZDUOVAZAUXE
        VBUPUXHVBUQZUXFUXHURUSZUXFVBUQABCVBABVBUPZUXIVBUQZLUTZACVBUPZUXJVBUQZMU
        TZVCAUXGVBUPZUXGVDVEZUXHVFUMUSZUXMAVGVBGVHZUYAAVGVIVFVJVAZGVHZUYEVBUPZU
        YDAVGURVBVBVKZVLZKVHZUYFAHVGHVMZVNVOVAZVGUQZUYLJUJZUYKVSUOVAZVNVOVAZIUJ
        ZVPZUYIKAUYKVGUQZVTZUYMUYNUYQUYIUYTVGUYIUYLJAVGUYIJVHZUYSAJUYIVGVQVAZUQ
        VUAUAUYIVGJUYHURVBVBVRVRWAWBZWCWDWEZWFWGUYTUYMWHZUYPVGUQZUYQUYIUQUYTVUF
        VUEUYTUYMVUFUYSUYMVUFWHWIAUYKWLWJWKWMUYTVGUYIUYPIAVGUYIIVHZUYSAIVUBUQVU
        GRUYIVGIVUCWCWDWEZWFWGWNWOUDUUAZGKUUBWPWQKWQZVUJUUCQUUDWRVIVBUQVFULUQUY
        GUUGUUEVIVFUUFUUHVGUYEVBGUUIWSVGVBGUUJWRZAGUUKZVDVEZUYBAVSVULUQVUMAVSVG
        VULUULAGVGWTZVULVGXAAUOVUJVSUUMZVSUUNUJZWTZVUNVSUUOUQVUQAUUPUOVUJVSUUQU
        URVUNVUOVGWTVUQVGGVUOQUUSVGVUPVUOUVBUUTUVAUVCZVGGUVDWRUVEVULVSUVKWRVULV
        DUXGVDGUVFUVGWEAUEVMZUFVMZURUSZUEUXGXBZUFVBXDZUYCAUXLVBUQVUSUXLURUSZUEU
        XGXBZVVCAUXKDAUXIUXJAUXOUXPLXEAUXRUXSMXEXCADNUVHXCZAVVEVUTGUJZUXLURUSZU
        FVGXBZAVVHUFVGABCDEFGUFHIJKLMNOPQRSTUAUBUCUDUVIUVJAVUNVVEVVIWIVURVVDVVH
        UEUFVGGVUSVVGUXLURUVLUVMWRXFZVVBVVEUFUXLVBVUTUXLXAVVAVVDUEUXGVUTUXLVUSU
        RUVNUVOXGXHAUXGULUPZVVCUYCWIAUXGVBULVUKUVPUVQZUFUEUXGUVRWRXPUXGUVSXIZAU
        YJUXEXJKWQUKXKZUPUXNVUIABCVVNABXJIWQUKXKUPZBVVNUPZSAUGVMZIUJZXLUJZVUSUM
        USZVUSVVRXMUJZUMUSZVTZUGVGXDZUEBXBZVUTKUJZXLUJZVUSUMUSZVUSVWFXMUJZUMUSZ
        VTZUFVGXDZUEBXBZVVOVVPAVWDVWLUEBAVWCVWLUGVGAVVQVGUQZVTZVWFVVRXAZUFVGXDZ
        VWCVWLVWOVNVVQUWAVAZVSWPVAZVGUQZVWSKUJZVVRXAZVWQVWOVWSVVQVVQVSWPVAZUOVA
        ZVGVWOVWSVVQVVQUOVAZVSWPVAVXDVWOVWRVXEVSWPVWOVVQVWNVVQXNUQZAVVQUWBWJZUV
        TXOVWOVVQVVQVSVXGVXGVSXNUQZVWOXQUWCUWDXRVWOVWNVXCUWEUQZVXDVGUQAVWNUWFZV
        WNVXIAVVQUWGWJVVQVXCUWHXHYGZVWOVXAVWSVNVOVAZVGUQZVXLJUJZVWSVSUOVAZVNVOV
        AZIUJZVPZVXQVVRVWOVWTVXAVXRXAVXKHVWSUYRVXRVGKUYKVWSXAZUYMVXMUYNUYQVXNVX
        QVXSUYLVXLVGUYKVWSVNVOXSZXTVXSUYLVXLJVXTYAVXSUYPVXPIVXSUYOVXOVNVOUYKVWS
        VSUOXSXOYAYBUDVXMVXNVXQVXLJYCVXPIYCYDYEWRVWOVXMWHZVXRVXQXAVWOVXPVGUQZVY
        AVWOVXPVVQVGVWOVXPVWRVNVOVAZVVQVWOVXOVWRVNVOVWOVWRXNUQVXHVXOVWRXAVWOVWR
        VWOVNVGUQVWNVWRVGUQZUWIVXJVNVVQUWJUWLZUWKXQVWRVSUWMWSXOVWOVXFVYCVVQXAZV
        XGVXFVNXNUQVNVIVEVYFUXBUWNVVQVNUWOUWPWRZXRZVXJYGVWOVXMVYBVWOVWTVXMVYBWH
        WIVXKVWSWLWRWKXPVXMVXNVXQUWQWRVWOVXPVVQIVYHYAYFVWPVXBUFVWSVGVUTVWSXAVWF
        VXAVVRVUTVWSKYPYHXGXHVWCVWPVWKUFVGVWPVWKVWCVWPVWHVVTVWJVWBVWPVWGVVSVUSU
        MVWFVVRXLYPYIVWPVWIVWAVUSUMVWFVVRXMYPYJYKYLYMYNYOYQAUXOVUGVVOVWEWIUXQVU
        HUEBUGIYRXHAUXOUYJVVPVWMWIUXQVUIUEBUFKYRXHYSYTACXJJWQUKXKUPZCVVNUPZUBAV
        VQJUJZXLUJZVUSUMUSZVUSVYKXMUJZUMUSZVTZUGVGXDZUECXBZVWLUECXBZVYIVYJAVYQV
        WLUECAVYPVWLUGVGVWOVWFVYKXAZUFVGXDZVYPVWLVWOVYDVWRKUJZVYKXAZWUAVYEVWOWU
        BVYCVGUQZVYCJUJZVWRVSUOVAZVNVOVAZIUJZVPZWUEVYKVWOVYDWUBWUIXAVYEHVWRUYRW
        UIVGKUYKVWRXAZUYMWUDUYNUYQWUEWUHWUJUYLVYCVGUYKVWRVNVOXSZXTWUJUYLVYCJWUK
        YAWUJUYPWUGIWUJUYOWUFVNVOUYKVWRVSUOXSXOYAYBUDWUDWUEWUHVYCJYCWUGIYCYDYEW
        RVWOWUDWUIWUEXAVWOVYCVVQVGVYGVXJYGWUDWUEWUHUWRWRVWOVYCVVQJVYGYAYFVYTWUC
        UFVWRVGVUTVWRXAVWFWUBVYKVUTVWRKYPYHXGXHVYPVYTVWKUFVGVYTVWKVYPVYTVWHVYMV
        WJVYOVYTVWGVYLVUSUMVWFVYKXLYPYIVYTVWIVYNVUSUMVWFVYKXMYPYJYKYLYMYNYOYQAU
        XRVUAVYIVYRWIUXTVUDUECUGJYRXHAUXRUYJVYJVYSWIUXTVUIUECUFKYRXHYSYTVCUXEGK
        QUWSXHZUXEUXHUWTXIVVMVVFWULAUXHUXLURUSZVVEVVJAVVKUXLULUQWUMVVEWIVVLAUXL
        VVFUXAUEUXGUXLUXCXHXFUXD $.
    $}

    $( Lemma for ~ ovolun .  (Contributed by Mario Carneiro, 12-Jun-2014.) $)
    ovolunlem2 $p |- ( ph ->
        ( vol* ` ( A u. B ) ) <_ ( ( ( vol* ` A ) + ( vol* ` B ) ) + C ) ) $=
      ( vg vh ccom crn wss caddc c1 cfv co cle wa cr wcel vn cioo cuni cabs cxr
      cv cmin cseq clt csup covol c2 cdiv wbr cxp cin cn cmap cun simpld simprd
      wrex crp rphalfcld eqid ovolgelb syl3anc reeanv w3a cmpt 3ad2ant1 simp3ll
      simp2l simp3lr simp2r simp3rl simp3rr ovolunlem1 rexlimdvv syl5bir mp2and
      cif 3exp ) ABUBHUFZJKUCLZMUDUGJZWDJNUHZKUEUIUJBUKOZDULUMPZMPQUNZRZHQSSUOU
      PUQURPZVBZCUBIUFZJKUCLZMWFWNJNUHZKUEUIUJCUKOZWIMPQUNZRZIWLVBZBCUSUKOWHWQM
      PDMPQUNZABSLZWHSTZWIVCTZWMAXBXCEUTAXBXCEVAADGVDZBWIWGHWGVEZVFVGACSLZWQSTZ
      XDWTAXGXHFUTAXGXHFVAXECWIWPIWPVEZVFVGWMWTRWKWSRZIWLVBHWLVBAXAWKWSHIWLWLVH
      AXJXAHIWLWLAWDWLTZWNWLTZRZXJXAAXMXJVIBCDWGWPMWFUAUQUAUFZULUMPZUQTXOWNOXNN
      MPULUMPWDOWBVJZJNUHZUAWDWNXPAXMXBXCRXJEVKAXMXGXHRXJFVKAXMDVCTXJGVKXFXIXQV
      EAXKXLXJVMWEWJWSAXMVLWEWJWSAXMVNAXKXLXJVOWOWRWKAXMVPWOWRWKAXMVQXPVEVRWCVS
      VTWA $.
  $}

  ${
    $d f g h x y A $.  $d f g h x y B $.
    $( The Lebesgue outer measure function is finitely sub-additive.  (Unlike
       the stronger ~ ovoliun , this does not require any choice principles.)
       (Contributed by Mario Carneiro, 12-Jun-2014.) $)
    ovolun $p |- ( ( ( A C_ RR /\ ( vol* ` A ) e. RR ) /\
                     ( B C_ RR /\ ( vol* ` B ) e. RR ) ) ->
                  ( vol* ` ( A u. B ) ) <_ ( ( vol* ` A ) + ( vol* ` B ) ) ) $=
      ( vx cr wss covol cfv wcel wa cun caddc co cle wbr crp wral simpll simplr
      cv simpr ovolunlem2 ralrimiva cxr unss biimpi ad2ant2r ovolcl syl readdcl
      wb ad2ant2l xralrple syl2anc mpbird ) ADEZAFGZDHZIZBDEZBFGZDHZIZIZABJZFGZ
      UPUTKLZMNZVEVFCSZKLMNZCOPZVCVICOVCVHOHZIABVHURVBVKQURVBVKRVCVKTUAUBVCVEUC
      HZVFDHZVGVJUJVCVDDEZVLUOUSVNUQVAUOUSIVNABDUDUEUFVDUGUHUQVAVMUOUSUPUTUIUKC
      VEVFULUMUN $.
  $}

  ${
    $d f g h x y A $.  $d f g h x y B $.
    $( Adding a nullset does not change the measure of a set.  (Contributed by
       Mario Carneiro, 25-Mar-2015.) $)
    ovolunnul $p |- ( ( A C_ RR /\ B C_ RR /\ ( vol* ` B ) = 0 ) ->
                  ( vol* ` ( A u. B ) ) = ( vol* ` A ) ) $=
      ( cr wss covol cfv cc0 wceq cle wbr clt cxr wcel wb ovolcl 3ad2ant1 caddc
      syl2anc adantr cmnf w3a cun wn simp1 simp2 unssd syl xrltnle wa mnfxr a1i
      ovolge0 ge0gtmnf simpr xrre2 syl32anc simpl3 0re syl6eqel ovolun syl22anc
      co oveq2d recnd addid1d eqtrd breqtrd ex sylbird pm2.18d sylancr xrletri3
      ssun1 ovolss mpbir2and ) ACDZBCDZBEFZGHZUAZABUBZEFZAEFZHZWBWCIJZWCWBIJZVT
      WEVTWEUCZWCWBKJZWEVTWCLMZWBLMZWHWGNVPVQWIVSAOZPZVTWACDZWJVTABCVPVQVSUDZVP
      VQVSUEZUFZWAOUGZWCWBUHRVTWHWEVTWHUIZWBWCVRQVBZWCIWRVPWCCMZVQVRCMWBWSIJVTV
      PWHWNSZWRTLMZWIWJTWCKJZWHWTXBWRUJUKWRVPWIXAWKUGVTWJWHWQSVTXCWHVTWIGWCIJZX
      CWLVPVQXDVSAULPWCUMRSVTWHUNTWCWBUOUPZVTVQWHWOSWRVRGCVPVQVSWHUQZURUSABUTVA
      WRWSWCGQVBWCWRVRGWCQXFVCWRWCWRWCXEVDVEVFVGVHVIVJVTAWADWMWFABVMWPAWAVNVKVT
      WJWIWDWEWFUINWQWLWBWCVLRVO $.
  $}

  ${
    $d k m x y z A $.  $d m x y z B $.
    $( The Lebesgue outer measure function is finitely sub-additive.  Finite
       sum version.  (Contributed by Mario Carneiro, 19-Jun-2014.) $)
    ovolfiniun $p |- ( ( A e. Fin /\ A. k e. A
                         ( B C_ RR /\ ( vol* ` B ) e. RR ) ) ->
                  ( vol* ` U_ k e. A B ) <_ sum_ k e. A ( vol* ` B ) ) $=
      ( vm wcel cr wss covol cfv wa wral ciun csu cle wbr cv wi c0 wceq fveq2d
      vx vy vz cfn csn cun raleq iuneq1 sumeq1 breq12d imbi12d 0le0 0iun fveq2i
      cc0 ovol0 eqtri 3brtr4i a1i wn ssun1 ssralv ax-mp imim1i csb caddc simprl
      sum0 nfcsb1v nfcv nfss nffv nfel1 nfan csbeq1a sseq1d eleq1d anbi12d rspc
      co mpan9 simpld ralrimiva iunss sylibr iunss1 syl5ss simpll simprd sylan2
      elun1 fsumrecl simprr cbviun cbvsumi 3brtr3g ovollecl syl3anc snid sselii
      ssun2 mpsyl readdcld iunxun csbeq1 iunxsn uneq2i ovolun syl21anc syl5eqbr
      vex snfi unfi mpan2 ad2antrr leadd1dd simplr disjsn eqidd recnd fsumsplit
      cin cc sumsn sylancr oveq2d eqtrd breqtrrd letrd 3brtr4g exp32 findcard2s
      cvv a2d syl5 imp ) AUDEBFGZBHIZFEZJZCAKZCABLZHIZAYRCMZNOZYTCUAPZKZCUUFBLZ
      HIZUUFYRCMZNOZQYTCRKZCRBLZHIZRYRCMZNOZQYTCUBPZKZCUUQBLZHIZUUQYRCMZNOZQZYT
      CUUQUCPZUEZUFZKZCUVFBLZHIZUVFYRCMZNOZQZUUAUUEQUAUBUCAUUFRSZUUGUULUUKUUPYT
      CUUFRUGUVMUUIUUNUUJUUONUVMUUHUUMHCUUFRBUHTUUFRYRCUIUJUKUUFUUQSZUUGUURUUKU
      VBYTCUUFUUQUGUVNUUIUUTUUJUVANUVNUUHUUSHCUUFUUQBUHTUUFUUQYRCUIUJUKUUFUVFSZ
      UUGUVGUUKUVKYTCUUFUVFUGUVOUUIUVIUUJUVJNUVOUUHUVHHCUUFUVFBUHTUUFUVFYRCUIUJ
      UKUUFASZUUGUUAUUKUUEYTCUUFAUGUVPUUIUUCUUJUUDNUVPUUHUUBHCUUFABUHTUUFAYRCUI
      UJUKUUPUULUOUOUUNUUONULUUNRHIUOUUMRHCBUMUNUPUQYRCVHURUSUVCUVGUVBQUUQUDEZU
      VDUUQEUTZJZUVLUVGUURUVBUUQUVFGZUVGUURQUUQUVEVAZYTCUUQUVFVBVCVDUVSUVGUVBUV
      KUVSUVGUVBUVKUVSUVGUVBJZJZDUVFCDPZBVEZLZHIZUVFUWEHIZDMZUVIUVJNUWCUWGDUUQU
      WELZHIZCUVDBVEZHIZVFVTZUWIUWCUWFFGZUWNFEUWGUWNNOUWGFEUWCUWEFGZDUVFKUWOUWC
      UWPDUVFUWCUWDUVFEZJZUWPUWHFEZUWCUVGUWQUWPUWSJZUVSUVGUVBVGZYTUWTCUWDUVFUWP
      UWSCCUWEFCUWDBVIZCFVJZVKCUWHFCUWEHCHVJZUXBVLZVMVNCPZUWDSZYQUWPYSUWSUXGBUW
      EFCUWDBVOZVPUXGYRUWHFUXGBUWEHUXHTZVQVRVSWAZWBWCDUVFUWEFWDWEZUWCUWKUWMUWCU
      WJFGZUUQUWHDMZFEUWKUXMNOUWKFEZUWCUWJUWFFUVTUWJUWFGUWADUUQUVFUWEWFVCUXKWGZ
      UWCUUQUWHDUVQUVRUWBWHUWDUUQEUWCUWQUWSUWDUUQUVEWKUWRUWPUWSUXJWIZWJWLZUWCUU
      TUVAUWKUXMNUVSUVGUVBWMUUSUWJHCDUUQBUWEDBVJZUXBUXHWNUNUUQYRUWHCDDYRVJZUXEU
      XIWOWPZUWJUXMWQWRZUWCUWLFGZUWMFEZUVDUVFEUWCUVGUYBUYCJZUVEUVFUVDUVEUUQXAUV
      DUCXKZWSWTUXAYTUYDCUVDUVFUYBUYCCCUWLFCUVDBVIZUXCVKCUWMFCUWLHUXDUYFVLVMVNU
      XFUVDSZYQUYBYSUYCUYGBUWLFCUVDBVOZVPUYGYRUWMFUYGBUWLHUYHTVQVRVSXBZWIZXCZUW
      CUWGUWJUWLUFZHIZUWNNUWFUYLHUWFUWJDUVEUWELZUFUYLDUUQUVEUWEXDUYNUWLUWJDUVDU
      WEUWLUYECUWDUVDBXEZXFXGUQUNUWCUXLUXNUYDUYMUWNNOUXOUYAUYIUWJUWLXHXIXJZUWFU
      WNWQWRUYKUWCUVFUWHDUVQUVFUDEZUVRUWBUVQUVEUDEUYQUVDXLUUQUVEXMXNXOZUXPWLUYP
      UWCUWNUXMUWMVFVTZUWINUWCUWKUXMUWMUYAUXQUYJUXTXPUWCUWIUXMUVEUWHDMZVFVTUYSU
      WCUUQUVEUWHUVFDUWCUVRUUQUVEYBRSUVQUVRUWBXQUUQUVDXRWEUWCUVFXSUYRUWRUWHUXPX
      TYAUWCUYTUWMUXMVFUWCUVDYMEUWMYCEUYTUWMSUYEUWCUWMUYJXTUWHUWMDUVDYMUWDUVDSU
      WEUWLHUYOTYDYEYFYGYHYIUVHUWFHCDUVFBUWEUXRUXBUXHWNUNUVFYRUWHCDUXSUXEUXIWOY
      JYKYNYOYLYP $.
  $}

  ${
    $d f g j k m x y z A $.  $d f g j k m n x y z B $.  $d f i j k m n x z F $.
    $d i j k m n w x y z J $.  $d i j m n w x y z K $.  $d i j k n w x y z L $.
    $d f j m n z H $.  $d z M $.  $d g i j k m n x y z ph $.  $d f k x y z S $.
    $d k m x G $.  $d g j k m x y z T $.  $d f j x y z U $.
    ovoliun.t $e |- T = seq 1 ( + , G ) $.
    ovoliun.g $e |- G = ( n e. NN |-> ( vol* ` A ) ) $.
    ovoliun.a $e |- ( ( ph /\ n e. NN ) -> A C_ RR ) $.
    ovoliun.v $e |- ( ( ph /\ n e. NN ) -> ( vol* ` A ) e. RR ) $.
    ${
      $d n G $.  $d n T $.
      ovoliun.r $e |- ( ph -> sup ( ran T , RR* , < ) e. RR ) $.
      ovoliun.b $e |- ( ph -> B e. RR+ ) $.
      ${
        ovoliun.s $e |- S = seq 1 ( + , ( ( abs o. - ) o. ( F ` n ) ) ) $.
        ovoliun.u $e |- U = seq 1 ( + , ( ( abs o. - ) o. H ) ) $.
        ovoliun.h $e |- H = ( k e. NN |-> ( ( F ` ( 1st ` ( J ` k ) ) ) `
                                                   ( 2nd ` ( J ` k ) ) ) ) $.
        ovoliun.j $e |- ( ph -> J : NN -1-1-onto-> ( NN X. NN ) ) $.
        ovoliun.f $e |- ( ph
               -> F : NN --> ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ) $.
        ovoliun.x1 $e |- ( ( ph /\ n e. NN ) ->
                          A C_ U. ran ( (,) o. ( F ` n ) ) ) $.
        ovoliun.x2 $e |- ( ( ph /\ n e. NN ) -> sup ( ran S , RR* , < ) <_
                           ( ( vol* ` A ) + ( B / ( 2 ^ n ) ) ) ) $.
        ${
          ovoliun.k $e |- ( ph -> K e. NN ) $.
          ovoliun.l1 $e |- ( ph -> L e. ZZ ) $.
          ovoliun.l2 $e |- ( ph ->
                            A. w e. ( 1 ... K ) ( 1st ` ( J ` w ) ) <_ L ) $.
          $( Lemma for ~ ovoliun .  (Contributed by Mario Carneiro,
             12-Jun-2014.) $)
          ovoliunlem1 $p |- ( ph ->
                ( U ` K ) <_ ( sup ( ran T , RR* , < ) + B ) ) $=
            ( vj vm vi vx vy vz c1 cfz co cima cv c2nd cfv c1st csu crn cxr clt
            cmin csup caddc cle ccom cseq cres wceq fveq2 fveq12d oveq12d fzfid
            fveq2d cn cxp wss wf1o syl elfznn sylancl wcel adantl wa cin adantr
            cr wf imassrn frn syl5ss xp1st ffvelrnd reex nnex elmap sylib xp2nd
            sseldi resubcld recnd ffvelrnda eqid eqtrd nnuz syl6eleq ffvelrn c2
            syl2an cfn cen wbr syl2anc fsumrecl sylan2 readdcld cvv cop vex a1i
            ciun wral wfn wb eqeltrd cmnf cc0 cpnf syl6ss cli c0 letrd cabs wf1
            f1of1 ssriv f1ores fvres inss2 cmap f1of sselda inex2 fsumf1o fmptd
            xpex ovolfsval fvex fvmpt cuz eqeltrrd fsumser fveq1i syl6eqr covol
            cexp cdiv f1oeng ensymd enfii rpred cn0 2nn nnexpcl sylancr nndivre
            cc nnnn0 csn relxp relres opelxp opelres ancom elsni opeq1d elimasn
            eleq1d syl6bbr pm5.32i 3bitr2ri bitri eqrelriiv df-res eqtri iunin2
            iuneq2dv syl6eq wrel relss ee10 wi breq1d ralima mpbird r19.21bi cz
            elfz5 ralrimiva op1std rspccv biantru iunid 3bitr2i syl6ibr relssdv
            ffn eleq2i xpiundir syl6sseq df-ss ssfi 2ndconst ax-mp adantrr rnss
            ssiun2 rnxpid sseld impr anassrs ovolsf icossxr supxrcl mnfxr rexrd
            cico mnflt cioo cuni ovollb xrltletrd xrre syl22anc ovolfsf elrege0
            1z sylan simpld simprd cdm supxrub breq2 ralbidv rspcev breq1 ralrn
            wrex rexbidv mpbid isumsup2 syl5eqbrr climrel releldmi isumless wne
            isumsup 0re pnfxr icossre mp2an 1nn syl5eleqr ne0i dm0rn0 necon3bii
            supxrre syl3anc eqtr4d breqtrd fsumle op2ndd fsum2d sumeq1d fsumadd
            fdm 3brtr3d simpr fvmpt2 serfre feq1i sylibr ressxr 1re zred nnge1d
            nnred eluzfz1 rspcv sylc elnnz1 sylanbrc fnfvelrn syl6eleqr geo2sum
            seqfn rneqi nnnn0d nnrpd rpdivcld nndivred subge02d eqbrtrd le2addd
            rpge0d eqbrtrrd ) AMURNUSUTZVAZULVBZVCVDZVXQVEVDZJVDZVDZVCVDZVYAVEV
            DZVJUTZULVFZNGVDZFVGZVHVIVKZDVLUTZVMAVYENVLUUAVJVNZLVNZURVOZVDZVYFA
            VYEVXOUMVBZMVDZVCVDZVYOVEVDZJVDZVDZVCVDZVYSVEVDZVJUTZUMVFVYMAVXPVYD
            VXOWUBULUMMVXOVPZVYOVXQVYOVQZVYBVYTVYCWUAVJWUDVYAVYSVCWUDVXRVYPVXTV
            YRWUDVXSVYQJVXQVYOVEVRWBVXQVYOVCVRVSZWBWUDVYAVYSVEWUEWBVTAURNWAZAWC
            WCWCWDZMUUBZVXOWCWEZVXOVXPWUCWFZAWCWUGMWFZWUHUEWCWUGMUUCWGUMVXOWCVY
            NNWHZUUDZWCWUGVXOMUUEWIZVYNVXOWJZVYNWUCVDVYOVQAVYNVXOMUUFWKAVXQVXPW
            JZWLZVYDWUQVYBVYCWUQVYAWOWOWDZWJZVYBWOWJWUQVMWURWMZWURVYAVMWURUUGZW
            UQWCWUTVXRVXTWUQVXTWUTWCUUHUTZWJWCWUTVXTWPWUQWCWVBVXSJAWCWVBJWPZWUP
            UFWNWUQVXQWUGWJZVXSWCWJAVXPWUGVXQAVXPMVGZWUGMVXOWQAWCWUGMWPZWVEWUGW
            EAWUKWVFUEWCWUGMUUIWGZWCWUGMWRWGWSZUUJZVXQWCWCWTWGZXAWUTWCVXTWURVMW
            OWOXBXBUUNUUKZXCXDXEWUQWVDVXRWCWJWVIVXQWCWCXFWGXAXGZVYAWOWOXFWGWUQW
            USVYCWOWJWVLVYAWOWOWTWGXHZXIUULAWUBUMVYKURNAWUOWLZVYNVYKVDZVYNLVDZV
            CVDZWVPVEVDZVJUTZWUBAWCWUTLWPZVYNWCWJZWVOWVSVQWUOAHWCHVBZMVDZVCVDZW
            WCVEVDZJVDZVDZWUTLAWWBWCWJZWLZWCWUTWWDWWFWWIWWFWVBWJWCWUTWWFWPWWIWC
            WVBWWEJAWVCWWHUFWNWWIWWCWUGWJZWWEWCWJAWCWUGWWBMWVGXJZWWCWCWCWTWGXAW
            UTWCWWFWVKXCXDXEWWIWWJWWDWCWJWWKWWCWCWCXFWGXAUDUUMZWULLVYKVYNVYKXKU
            UOXQWVNWVQVYTWVRWUAVJWVNWVPVYSVCWVNWWAWVPVYSVQWUOWWAAWULWKHVYNWWGVY
            SWCLWWBVYNVQZWWDVYPWWFVYRWWMWWEVYQJWWMWWCVYOVEWWBVYNMVRZWBWBWWMWWCV
            YOVCWWNWBVSUDVYPVYRUUPUUQWGZWBWVNWVPVYSVEWWOWBVTZXLANWCURUURVDZUIXM
            XNZWVNWVSWUBUVOWWPWVNWVSWVNWVQWVRWVNWVPWURWJZWVQWOWJWVNWUTWURWVPWVA
            AWVTWWAWVPWUTWJWUOWWLWULWCWUTVYNLXOXQXGZWVPWOWOXFWGWVNWWSWVRWOWJWWT
            WVPWOWOWTWGXHXIUUSUUTXLNGVYLUCUVAUVBAVYEUROUSUTZCUVCVDZIVFZWXADXPIV
            BZUVDUTZUVEUTZIVFZVLUTZVYIAVXPVYDULAVXOXRWJZVXPVXOXSXTVXPXRWJWUFAVX
            OVXPAWXIWUJVXOVXPXSXTWUFWUNVXOVXPXRWUCUVFYAUVGVXPVXOUVHYAZWVMYBAWXC
            WXGAWXAWXBIAUROWAZWXDWXAWJZAWXDWCWJZWXBWOWJZWXDOWHZSYCZYBZAWXAWXFIW
            XKADWOWJZWXEWCWJZWXFWOWJZWXLADUAUVIZWXLWXMWXSWXOWXMXPWCWJZWXDUVJWJW
            XSUVKWXDUVPXPWXDUVLUVMZWGDWXEUVNZXQZYBZYDAVYHDTWYAYDAWXAVXPWXDUVQZV
            AZUNVBZWXDJVDZVDZVCVDZWYKVEVDZVJUTZUNVFZIVFZWXAWXBWXFVLUTZIVFVYEWXH
            VMAWXAWYOWYQIWXKAWXLWLZWYHWYNUNWYRWYGWYHWDZXRWJZWYHWYSXSXTWYHXRWJAI
            WXAWYSYIZXRWJWYSXUAWEWYTWXLAXUAVXPXRAXUAVXPIWXAWYGYEWDZYIZWMZVXPAXU
            AIWXAVXPXUBWMZYIXUDAIWXAWYSXUEWYSXUEVQWYRWYSVXPWYGVPZXUEUOUPWYSXUFW
            YGWYHUVRVXPWYGUVSUOVBZUPVBZYFZWYSWJXUGWYGWJZXUHWYHWJZWLZXUIXUFWJZXU
            GXUHWYGWYHUVTXUMXUIVXPWJZXUJWLXUJXUNWLXULXUGXUHVXPWYGUPYGZUWAXUJXUN
            UWBXUJXUNXUKXUJXUNWXDXUHYFZVXPWJXUKXUJXUIXUPVXPXUJXUGWXDXUHXUGWXDUW
            CUWDUWFVXPWXDXUHIYGZXUOUWEUWGUWHUWIUWJUWKVXPWYGUWLUWMYHUWOIWXAVXPXU
            BUWNUWPAVXPXUCWEXUDVXPVQAVXPIWXAWYGYIZYEWDZXUCAUOUPVXPXUSAVXPWUGWEZ
            WUGUWQVXPUWQWVHWCWCUVRVXPWUGUWRUWSAXUNXUGWXAWJZXUIXUSWJZAVXSWXAWJZU
            LVXPYJXUNXVAUWTAXVCULVXPWUQXVCVXSOVMXTZAXVDULVXPAXVDULVXPYJZBVBZMVD
            ZVEVDZOVMXTZBVXOYJZUKAMWCYKZWUIXVEXVJYLAWVFXVKWVGWCWUGMUXOWGWUMXVDX
            VIULBWCVXOMVXQXVGVQVXSXVHOVMVXQXVGVEVRUXAUXBWIUXCUXDWUQVXSWWQWJOUXE
            WJZXVCXVDYLWUQVXSWCWWQWVJXMXNAXVLWUPUJWNVXSUROUXFYAUXCUXGXVCXVAULXU
            IVXPVXQXUIVQVXSXUGWXAXUGXUHVXQUOYGXUOUXHUWFUXIWGXVBXUGXURWJZXUHYEWJ
            ZWLXVMXVAXUGXUHXURYEUVTXVNXVMXUOUXJXURWXAXUGIWXAUXKUXPUXLUXMUXNIWXA
            WYGYEUXQUXRVXPXUCUXSXEXLZWXJYMIWXAWYSUYEXUAWYSUXTXQZWYRWYSWYHWYRWYT
            WYSWYHVCWYSVPZWFZWYSWYHXSXTXVPWXDYEWJXVRXUQWXDWYHYEUYAUYBWYSWYHXRXV
            QUVFWIUVGWYHWYSUVHYAZAWXLWYIWYHWJZWYNWOWJZAWXLXVTWLWLZWYLWYMXWBWYKW
            URWJZWYLWOWJXWBWUTWURWYKWVAXWBWCWUTWYIWYJAWXLWCWUTWYJWPZXVTWYRWYJWV
            BWJZXWDAWVCWXMXWEWXLUFWXOWCWVBWXDJXOXQWUTWCWYJWVKXCXDXEZUYCAWXLXVTW
            YIWCWJZWYRWYHWCWYIWYRWYHVXPVGZWCVXPWYGWQWYRXWHWUGVGZWCWYRXUTXWHXWIW
            EAXUTWXLWVHWNVXPWUGUYDWGWCUYFUXRWSZUYGUYHXAXGZWYKWOWOXFWGXWBXWCWYMW
            OWJXWKWYKWOWOWTWGXHZUYIYBZWXLAWXMWYQWOWJZWXOAWXMWLZWXBWXFSAWXRWXSWX
            TWXMWYAWYCWYDXQYDYCZWYRWYOEVGZVHVIVKZWYQXWMWYRXWRVHWJZXWNYNXWRVIXTX
            WRWYQVMXTZXWRWOWJZWYRXWQVHWEZXWSWYRXWQYOYPUYOUTZVHWYRWCXXCEWPZXWQXX
            CWEWYRXWDXXDXWFEWYJVYJWYJVNZXXEXKZUBUYJWGZWCXXCEWRWGZYOYPUYKYQZXWQU
            YLWGZXWPWYRYNWXBXWRYNVHWJWYRUYMYHWYRWXBWXPUYNXXJWYRWXNYNWXBVIXTWXPW
            XBUYPWGWYRXWDCUYQWYJVNVGUYRWEZWXBXWRVMXTXWFWXLAWXMXXKWXOUGYCCEWYJUB
            UYSYAUYTWXLAWXMXWTWXOUHYCZXWRWYQVUAVUBZXWPWYRWYOWCWYNUNVFZXWRVMWYRW
            YHWYNUNXXEURWCXMURUXEWJZWYRVUEYHZXVSXWJWYRXWDXWGWYIXXEVDZWYNVQXWFWY
            JXXEWYIXXFUUOVUFZWYRXWGWLZXWAYOWYNVMXTZXXSWYNXXCWJXWAXXTWLXXSXXQWYN
            XXCXXRWYRWCXXCWYIXXEWYRXWDWCXXCXXEWPXWFWYJXXEXXFVUCWGXJUUSWYNVUDXEZ
            VUGZXXSXWAXXTXYAVUHZWYRVLXXEURVOZXWQWOVIVKZYRXTXYDYRVUIWJWYRXYDEXYE
            YRUBWYRUOWYNHUNXXEEURWCXMUBXXPXXRXYBXYCWYRUQVBZXUGVMXTZUQXWQYJZUOWO
            VUPZWWBEVDZXUGVMXTZHWCYJZUOWOVUPWYRXXAXYFXWRVMXTZUQXWQYJZXYIXXMWYRX
            YMUQXWQWYRXXBXYFXWQWJXYMXXIXWQXYFVUJVUFUXGXYHXYNUOXWRWOXUGXWRVQXYGX
            YMUQXWQXUGXWRXYFVMVUKVULVUMYAZWYRXYHXYLUOWOWYREWCYKZXYHXYLYLWYRXXDX
            YPXXGWCXXCEUXOWGXYGXYKUQHWCEXYFXYJXUGVMVUNVUOWGVUQVURZVUSVUTXYDXYEY
            RVVAVVBWGVVCWYRXXNXYEXWRWYRUOWYNHUNXXEEURWCXMUBXXPXXRXYBXYCXYQVVEWY
            RXWQWOWEXWQYSVVDZXYIXWRXYEVQWYRXWQXXCWOXXHYOWOWJYPVHWJXXCWOWEVVFVVG
            YOYPVVHVVIYQWYREVUIZYSVVDZXYRWYRURXYSWJXYTWYRURWCXYSVVJWYRXXDXYSWCV
            QXXGWCXXCEVWDWGVVKXYSURVVLWGXYSYSXWQYSEVVMVVNXEXYOUOUQXWQVVOVVPVVQV
            VRXXLYTVVSAWYPXUAVYDULVFVYEAULWXAWYHWYNVYDIUNVXQWXDWYIYFVQZVYBWYLVY
            CWYMVJYUAVYAWYKVCYUAVXRWYIVXTWYJYUAVXSWXDJWXDWYIVXQXUQUNYGZUXHWBWXD
            WYIVXQXUQYUBVVTVSZWBYUAVYAWYKVEYUCWBVTWXKXVSXWBWYNXWLXIVWAAXUAVXPVY
            DULXVOVWBXLAWXAWXBWXFIWXKWYRWXBWXPXIZWYRWXFWYEXIVWCVWEAWXCWXGVYHDWX
            QWYFTWYAAVYGVHWEWXCVYGWJWXCVYHVMXTAVYGWOVHAWCWOFWPZVYGWOWEAWCWOVLKU
            RVOZWPYUEAIKURWCXMXXOAVUEYHZXWOWXDKVDZWXBWOXWOWXMWXNYUHWXBVQZAWXMVW
            FSIWCWXBWOKQVWGYAZSYMVWHWCWOFYUFPVWIVWJWCWOFWRWGVWKYQAWXCOYUFVDZVYG
            AWXBIKUROWXLAWXMYUIWXOYUJYCAOWCWWQAXVLUROVMXTOWCWJZUJAURURMVDZVEVDZ
            OURWOWJAVWLYHAYUNAYUMWUGWJZYUNWCWJAWVFURWCWJYUOWVGVVJWCWUGURMXOWIYU
            MWCWCWTWGZVWOAOUJVWMAYUNYUPVWNAURVXOWJZXVJYUNOVMXTZANWWQWJYUQWWRURN
            VWPWGUKXVIYURBURVXOXVFURVQZXVHYUNOVMYUSXVGYUMVEXVFURMVRWBUXAVWQVWRY
            TOVWSVWTZXMXNZYUDUUTAYUKYUFVGZVYGAYUFWWQYKZOWWQWJYUKYVBWJAXXOYVCYUG
            VLKURVXDWGYVAWWQOYUFVXAYAFYUFPVXEVXBYMVYGWXCVUJYAAWXGDDXPOUVDUTZUVE
            UTZVJUTZDVMAYULDUVOWJWXGYVFVQYUTADWYAXIDIOVXCYAAYOYVEVMXTYVFDVMXTAY
            VEADYVDUAAYVDAWYBOUVJWJYVDWCWJUVKAOYUTVXFXPOUVLUVMZVXGVXHVXMADYVEWY
            AADYVDWYAYVGVXIVXJVURVXKVXLYTVXN $.
        $}

        $d w ph $.
        $( Lemma for ~ ovoliun .  (Contributed by Mario Carneiro,
           12-Jun-2014.) $)
        ovoliunlem2 $p |- ( ph ->
              ( vol* ` U_ n e. NN A ) <_ ( sup ( ran T , RR* , < ) + B ) ) $=
          ( vm vz vj vw vx cn ciun covol cfv crn cxr clt csup caddc co wss wcel
          cr wral ralrimiva iunss sylibr ovolcl syl cc0 cpnf cico cle cxp wf cv
          c2nd c1st wa cmap adantr wf1o f1of ffvelrnda xp1st ffvelrnd reex xpex
          cin inex2 nnex elmap sylib xp2nd fmptd cabs cmin ccom eqid ovolsf frn
          3syl icossxr syl6ss supxrcl rpred readdcld rexrd cioo cuni wrex eliun
          wbr w3a 3adant3 wb ovolfioo syl2anc mpbid simp3 rsp 4syl fveq2 fveq2d
          wceq fveq12d vex syl6eq breq1d breq2d anbi12d rexlimdva mpd mpbird c1
          wi ad2antlr adantlr simplr sylan sylc ccnv simpl1 f1ocnv simpl2 simpr
          fovrnd fvex fvmpt cop df-ov fveq2i f1ocnvfv2 syl5eq op1st op2nd eqtrd
          opelxpi biimprd rspcev ee12an rexlimdv3a syl5bi ralrimiv cfz cfn fzfi
          ovollb elfznn ffvelrn nnre syl2an fimaxre3 sylancr flcl peano2zd zred
          cfl fllep1 letr syl3anc mpan2d ralimdva simpll crp cexp cdiv ad2antrl
          c2 simprr ovoliunlem1 expr syld wfn ffn breq1 ralrn supxrleub xrletrd
          cz ) AHUKBULZUMUNZFUOZUPUQURZEUOUPUQURZCUSUTZAUXAVCVAZUXBUPVBABVCVAZH
          UKVDUXGAUXHHUKOVEHUKBVCVFVGZUXAVHVIAUXCUPVAZUXDUPVBAUXCVJVKVLUTZUPAUK
          VMVCVCVNZWIZKVOZUKUXKFVOZUXCUXKVAAGUKGVPZLUNZVQUNZUXQVRUNZIUNZUNZUXMK
          AUXPUKVBZVSZUKUXMUXRUXTUYCUXTUXMUKVTUTZVBUKUXMUXTVOUYCUKUYDUXSIAUKUYD
          IVOZUYBUCWAUYCUXQUKUKVNZVBZUXSUKVBAUKUYFUXPLAUKUYFLWBZUKUYFLVOZUBUKUY
          FLWCVIZWDZUXQUKUKWEVIWFUXMUKUXTUXLVMVCVCWGWGWHWJZWKWLWMUYCUYGUXRUKVBU
          YKUXQUKUKWNVIWFUAWOZFKWPWQWRKWRZUYNWSTWTZUKUXKFXAXBVJVKXCXDZUXCXEVIAU
          XFAUXECQACRXFXGXHZAUXNUXAXIKWRUOXJVAZUXBUXDVMXMUYMAUYRUFVPZKUNZVRUNZU
          GVPZUQXMZVUBUYTVQUNZUQXMZVSZUFUKXKZUGUXAVDZAVUGUGUXAVUBUXAVBVUBBVBZHU
          KXKAVUGHVUBUKBXLAVUIVUGHUKAHVPZUKVBZVUIXNZUHVPZVUJIUNZUNZVRUNZVUBUQXM
          ZVUBVUOVQUNZUQXMZVSZUHUKXKZVUGVULVVAUGBVDZVUIVVAVULBXIVUNWRUOXJVAZVVB
          AVUKVVCVUIUDXOVULUXHUKUXMVUNVOZVVCVVBXPAVUKUXHVUIOXOAVUKVVDVUIAVUKVSV
          UNUYDVBVVDAUKUYDVUJIUCWDUXMUKVUNUYLWKWLWMXOUGBUHVUNXQXRXSAVUKVUIXTVVA
          UGBYAUUAVULVUTVUGUHUKVULVUMUKVBZVSZVUJVUMLUUBZUTZUKVBZVUTVVHKUNZVRUNZ
          VUBUQXMZVUBVVJVQUNZUQXMZVSZVUGVVFVUJVUMUKUKUKVVGVVFAUYHUYFUKVVGWBUYFU
          KVVGVOAVUKVUIVVEUUCZUBUKUYFLUUDUYFUKVVGWCYBAVUKVUIVVEUUEZVULVVEUUFZUU
          GZVVFVVOVUTVVFVVLVUQVVNVUSVVFVVKVUPVUBUQVVFVVJVUOVRVVFVVJVVHLUNZVQUNZ
          VVTVRUNZIUNZUNZVUOVVFVVIVVJVWDYEVVSGVVHUYAVWDUKKUXPVVHYEZUXRVWAUXTVWC
          VWEUXSVWBIVWEUXQVVTVRUXPVVHLYCZYDYDVWEUXQVVTVQVWFYDYFUAVWAVWCUUHUUIVI
          VVFVWAVUMVWCVUNVVFVWBVUJIVVFVWBVUJVUMUUJZVRUNVUJVVFVVTVWGVRVVFVVTVWGV
          VGUNZLUNZVWGVVHVWHLVUJVUMVVGUUKUULVVFUYHVWGUYFVBZVWIVWGYEVVFAUYHVVPUB
          VIVVFVUKVVEVWJVVQVVRVUJVUMUKUKUURXRUKUYFVWGLUUMXRUUNZYDVUJVUMHYGZUHYG
          ZUUOYHYDVVFVWAVWGVQUNVUMVVFVVTVWGVQVWKYDVUJVUMVWLVWMUUPYHYFUUQZYDYIVV
          FVVMVURVUBUQVVFVVJVUOVQVWNYDYJYKUUSVUFVVOUFVVHUKUYSVVHYEZVUCVVLVUEVVN
          VWOVUAVVKVUBUQVWOUYTVVJVRUYSVVHKYCZYDYIVWOVUDVVMVUBUQVWOUYTVVJVQVWPYD
          YJYKUUTUVAYLYMUVBUVCUVDAUXGUXNUYRVUHXPUXIUYMUGUXAUFKXQXRYNUXAFKTUVHXR
          AUXDUXFVMXMZVUBUXFVMXMZUGUXCVDZAVWSVUMFUNZUXFVMXMZUHUKVDZAVXAUHUKAVVE
          VSZUIVPZLUNZVRUNZUJVPZVMXMZUIYOVUMUVEUTZVDZUJVCXKZVXAVXCVXIUVFVBVXFVC
          VBZUIVXIVDZVXKYOVUMUVGAVXMVVEAVXLUIVXIAUYIVXDUKVBZVXLVXDVXIVBZUYJVXDV
          UMUVIUYIVXNVSVXEUYFVBVXFUKVBVXLUKUYFVXDLUVJVXEUKUKWEVXFUVKXBUVLZVEWAU
          JUIVXIVXFUVMUVNVXCVXJVXAUJVCVXCVXGVCVBZVSVXJVXFVXGUVRUNZYOUSUTZVMXMZU
          IVXIVDZVXAAVXQVXJVYAYPVVEAVXQVSZVXHVXTUIVXIVYBVXOVSZVXHVXGVXSVMXMZVXT
          VXQVYDAVXOVXGUVSYQVYCVXLVXQVXSVCVBZVXHVYDVSVXTYPAVXOVXLVXQVXPYRAVXQVX
          OYSVXQVYEAVXOVXQVXSVXQVXRVXGUVOUVPZUVQYQVXFVXGVXSUVTUWAUWBUWCYRVXCVXQ
          VYAVXAVXCVXQVYAVSZVSZUIBCDEFGHIJKLVUMVXSMNVYHAVUKUXHAVVEVYGUWDZOYTVYH
          AVUKBUMUNZVCVBVYIPYTVYHAUXEVCVBVYIQVIVYHACUWEVBVYIRVISTUAVYHAUYHVYIUB
          VIVYHAUYEVYIUCVIVYHAVUKVVCVYIUDYTVYHAVUKDUOUPUQURVYJCUWIVUJUWFUTUWGUT
          USUTVMXMVYIUEYTAVVEVYGYSVXQVXSUWTVBVXCVYAVYFUWHVXCVXQVYAUWJUWKUWLUWMY
          LYMVEAUXNUXOFUKUWNVWSVXBXPUYMUYOUKUXKFUWOVWRVXAUGUHUKFVUBVWTUXFVMUWPU
          WQYBYNAUXJUXFUPVBVWQVWSXPUYPUYQUGUXCUXFUWRXRYNUWS $.
      $}

      $( Lemma for ~ ovoliun .  (Contributed by Mario Carneiro,
         12-Jun-2014.) $)
      ovoliunlem3 $p |- ( ph ->
                ( vol* ` U_ n e. NN A ) <_ ( sup ( ran T , RR* , < ) + B ) ) $=
        ( vm cn cfv caddc cle nfcv cr wcel vg vf vj vk covol cv csb crn cxr clt
        ciun csup nfcsb1v csbeq1a cbviun fveq2i cxp cin cmap cioo ccom cuni wss
        co wf cabs cmin c1 cseq c2 cexp cdiv wbr wa wral wex wrex crp cn0 nnnn0
        2nn nnexpcl sylancr rpdivcl syl2an eqid ovolgelb syl3anc ralrimiva ovex
        nnrpd nnenom wceq coeq2 rneqd unieqd sseq2d seqeq3d supeq1d anbi12d syl
        breq1d axcc4 wf1o wi xpnnen ensymi bren mpbi c2nd c1st cmpt nffv fveq2d
        cen cbvmpt eqtri simpll nfv nfss sseq1d cbvral sylib sylan nfel1 eleq1d
        r19.21bi simplr simprl simprr nfov nfbr nfan fveq2 coeq2d sseq12d oveq2
        ad2antrr oveq2d exlimdv oveq12d breq12d simpld simprd ovoliunlem2 exp31
        mpi mpd syl5eqbr ) AENBUKZUEOMNEMUFZBUGZUKZUEOZDUHUIUJULZCPVDZQUUJUUMUE
        EMNBUULMBREUUKBUMZEUUKBUNZUOUPANQSSUQURZNUSVDZUAUFZVEZBUTEUFZUVAOZVAZUH
        ZVBZVCZPVFVGVAZUVDVAZVHVIZUHZUIUJULZBUEOZCVJUVCVKVDZVLVDZPVDZQVMZVNZENV
        OZVNZUAVPZUUNUUPQVMZABUTUBUFZVAZUHZVBZVCZPUVIUWDVAZVHVIZUHZUIUJULZUVQQV
        MZVNZUBUUTVQZENVOUWBAUWOENAUVCNTZVNBSVCZUVNSTZUVPVRTZUWOIJACVRTZUVOVRTU
        WSUWPLUWPUVOUWPVJNTUVCVSTUVONTWAUVCVTVJUVCWBWCWKCUVOWDWEBUVPUWJUBUWJWFW
        GWHWIUWNUVSUBUUTUAENUUSNUSWJWLUWDUVDWMZUWHUVHUWMUVRUXAUWGUVGBUXAUWFUVFU
        XAUWEUVEUWDUVDUTWNWOWPWQUXAUWLUVMUVQQUXAUIUWKUVLUJUXAUWJUVKUXAUWIUVJPVH
        UWDUVDUVIWNWRWOWSXBWTXCXAAUWAUWCUAANNNUQZUCUFZXDZUCVPZUWAUWCXEZNUXBXOVM
        UXEUXBNXFXGNUXBUCXHXIAUXDUXFUCAUXDUWAUWCAUXDVNZUWAVNZUULCPUVIUUKUVAOZVA
        ZVHVIZDPUVIUDNUDUFUXCOZXJOUXLXKOUVAOOXLZVAVHVIZUDMUVAFUXMUXCGFENUVNXLMN
        UULUEOZXLHEMNUVNUXOMUVNRZEUULUEEUERUUQXMZUVCUUKWMZBUULUEUURXNZXPXQUXHAU
        UKNTZUULSVCZAUXDUWAXRZAUYAMNAUWQENVOUYAMNVOAUWQENIWIUWQUYAEMNUWQMXSEUUL
        SUUQESRXTUXRBUULSUURYAYBYCYGYDUXHAUXTUXOSTZUYBAUYCMNAUWRENVOUYCMNVOAUWR
        ENJWIUWRUYCEMNMUVNSUXPYEEUXOSUXQYEUXRUVNUXOSUXSYFYBYCYGYDAUUOSTUXDUWAKY
        RAUWTUXDUWALYRUXKWFUXNWFUXMWFAUXDUWAYHUXGUVBUVTYIUXHUXTVNZUULUTUXIVAZUH
        ZVBZVCZUXKUHZUIUJULZUXOCVJUUKVKVDZVLVDZPVDZQVMZUXHUYHUYNVNZMNUXHUVTUYOM
        NVOUXGUVBUVTYJUVSUYOEMNUVSMXSUYHUYNEEUULUYGUUQEUYGRXTEUYJUYMQEUYJREQREU
        XOUYLPUXQEPREUYLRYKYLYMUXRUVHUYHUVRUYNUXRBUULUVGUYGUURUXRUVFUYFUXRUVEUY
        EUXRUVDUXIUTUVCUUKUVAYNZYOWOWPYPUXRUVMUYJUVQUYMQUXRUIUVLUYIUJUXRUVKUXKU
        XRUVJUXJPVHUXRUVDUXIUVIUYPYOWRWOWSUXRUVNUXOUVPUYLPUXSUXRUVOUYKCVLUVCUUK
        VJVKYQYSUUAUUBWTYBYCYGZUUCUYDUYHUYNUYQUUDUUEUUFYTUUGYTUUHUUI $.
    $}

    $( The Lebesgue outer measure function is countably sub-additive.  (Many
       books allow ` +oo ` as a value for one of the sets in the sum, but in
       our setup we can't do arithmetic on infinity, and in any case the volume
       of a union containing an infinitely large set is already infinitely
       large by monotonicity ~ ovolss , so we need not consider this case here,
       although we do allow the sum itself to be infinite.)  (Contributed by
       Mario Carneiro, 12-Jun-2014.) $)
    ovoliun $p |- ( ph ->
                    ( vol* ` U_ n e. NN A ) <_ sup ( ran T , RR* , < ) ) $=
      ( vm cxr wbr cn covol cfv cle cr wcel c1 syl vk vx crn clt csup cpnf ciun
      cmnf wa wb wss wf caddc cseq nnuz cz 1z a1i fmptd ffvelrnda serfre sylibr
      feq1i frn ressxr syl6ss supxrcl xrrebnd mnfxr ffvelrn sylancl rexrd mnflt
      cv 1nn wfn ffn fnfvelrn supxrub syl2anc xrltletrd biantrurd bitr4d co crp
      wral csb nfcv nfcsb1v csbeq1a cbviun fveq2i cmpt nffv fveq2d cbvmpt eqtri
      wceq ralrimiva nfv nfss sseq1d cbvral sylib ad2antrr r19.21bi nfel1 simpr
      eleq1d simplr ovoliunlem3 syl5eqbr iunss ovolcl xralrple sylan ex sylbird
      mpbird wn nltpnft pnfge breq2 syl5ibrcom pm2.61d ) ACUCZKUDUEZUFUDLZDMBUG
      ZNOZYGPLZAYHYGQRZYKAYLUHYGUDLZYHUIZYHAYGKRZYLYNUJAYFKUKZYOAYFQKAMQCULZYFQ
      UKAMQUMESUNZULYQAUAESMUOSUPRAUQURAMQUAVNEADMBNOZQEIGUSUTVAMQCYRFVCVBZMQCV
      DTVEVFZYFVGTZYGVHTAYMYHAUHSCOZYGUHKRAVIURAUUCAYQSMRZUUCQRZYTVOMQSCVJVKZVL
      UUBAUUEUHUUCUDLUUFUUCVMTAYPUUCYFRZUUCYGPLUUAACMVPZUUDUUGAYQUUHYTMQCVQTVOM
      SCVRVKYFUUCVSVTWAWBWCAYLYKAYLUIZYKYJYGUBVNZUMWDZPLZUBWEWFZUUIUULUBWEUUIUU
      JWERZUIZYJJMDJVNZBWGZUGZNOUUKPYIUURNDJMBUUQJBWHDUUPBWIZDUUPBWJZWKWLUUOUUQ
      UUJCJEFEDMYSWMJMUUQNOZWMGDJMYSUVAJYSWHZDUUQNDNWHUUSWNZDVNUUPWRZBUUQNUUTWO
      ZWPWQUUOUUQQUKZJMAUVFJMWFZYLUUNABQUKZDMWFZUVGAUVHDMHWSZUVHUVFDJMUVHJWTDUU
      QQUUSDQWHXAUVDBUUQQUUTXBXCXDXEXFUUOUVAQRZJMAUVKJMWFZYLUUNAYSQRZDMWFUVLAUV
      MDMIWSUVMUVKDJMJYSQUVBXGDUVAQUVCXGUVDYSUVAQUVEXIXCXDXEXFAYLUUNXJUUIUUNXHX
      KXLWSAYJKRZYLYKUUMUJAYIQUKZUVNAUVIUVOUVJDMBQXMVBYIXNTZUBYJYGXOXPXSXQXRAYH
      XTZYGUFWRZYKAYOUVRUVQUJUUBYGYATAYKUVRYJUFPLZAUVNUVSUVPYJYBTYGUFYJPYCYDXRY
      E $.

    ovoliun2.t $e |- ( ph -> T e. dom ~~> ) $.
    $( The Lebesgue outer measure function is countably sub-additive.  (This
       version is a little easier to read, but does not allow infinite values
       like ~ ovoliun .)  (Contributed by Mario Carneiro, 12-Jun-2014.) $)
    ovoliun2 $p |- ( ph ->
                     ( vol* ` U_ n e. NN A ) <_ sum_ n e. NN ( vol* ` A ) ) $=
      ( vm vx vk cn covol cfv cle cr c1 wcel vz ciun crn cxr clt csu ovoliun cv
      csup csb wss c0 wne wbr wral wrex wceq wf caddc cseq nnuz cz a1i cvv fvex
      1z cmpt nfcv nfcsb1v nffv csbeq1a fveq2d cbvmpt eqtri fvmpt2 mpan2 adantl
      wa ralrimiva nfel1 eleq1d cbvral sylib r19.21bi eqeltrd serfre sylibr frn
      feq1i syl cdm 1nn fdm syl5eleqr ne0i necon3bii cli syl5eqelr isumrecl cfz
      dm0rn0 co elfznn simpr syl6eleq simpl syl2an recnd fsumser fveq1i syl6eqr
      cuz fzfid ssriv cc0 nfv nfss sseq1d ovolge0 isumless adantr breq2 ralbidv
      eqbrtrrd rspcev syl2anc wfn wb breq1 ralrn rexbidv mpbird supxrre syl3anc
      ffn isumsup eqtr4d cbvsumi breqtrd ) ADNBUBOPCUCZUDUEUIZNBOPZDUFZQABCDEFG
      HIUGAUUANDKUHZBUJZOPZKUFZUUCAUUAYTRUEUIZUUGAYTRUKZYTULUMZUAUHZLUHZQUNZUAY
      TUOZLRUPZUUAUUHUQANRCURZUUIANRUSESUTZURUUPAKESNVASVBTAVFVCZAUUDNTZVRZUUDE
      PZUUFRUUSUVAUUFUQZAUUSUUFVDTUVBUUEOVEKNUUFVDEEDNUUBVGKNUUFVGGDKNUUBUUFKUU
      BVHZDUUEODOVHDUUDBVIZVJZDUHZUUDUQZBUUEODUUDBVKZVLZVMVNVOVPZVQZAUUFRTZKNAU
      UBRTZDNUOUVLKNUOAUVMDNIVSUVMUVLDKNKUUBRUVCVTDUUFRUVEVTUVGUUBUUFRUVIWAWBWC
      WDZWEWFNRCUUQFWIWGZNRCWHWJACWKZULUMZUUJASUVPTUVQASNUVPWLAUUPUVPNUQUVONRCW
      MWJWNUVPSWOWJUVPULYTULCXAWPWCAUUOMUHZCPZUULQUNZMNUOZLRUPZAUUGRTUVSUUGQUNZ
      MNUOZUWBAUUFKESNVAUURUVKUVNAUUQCWQWKFJWRZWSAUWCMNAUVRNTZVRZSUVRWTXBZUUFKU
      FZUVSUUGQUWGUWIUVRUUQPUVSUWGUUFKESUVRUWGUUDUWHTZVRZUUSUVBUWJUUSUWGUUDUVRX
      CZVQUVJWJUWGUVRNSXLPAUWFXDVAXEUWKUUFUWGAUUSUVLUWJAUWFXFUWLUVNXGXHXIUVRCUU
      QFXJXKAUWIUUGQUNUWFAUWHUUFKESNVAUURASUVRXMUWHNUKADUWHNUVFUVRXCXNVCUVKUVNU
      UTUUERUKZXOUUFQUNAUWMKNABRUKZDNUOUWMKNUOAUWNDNHVSUWNUWMDKNUWNKXPDUUERUVDD
      RVHXQUVGBUUERUVHXRWBWCWDUUEXSWJZUWEXTYAYDVSUWAUWDLUUGRUULUUGUQUVTUWCMNUUL
      UUGUVSQYBYCYEYFZAUUNUWALRACNYGZUUNUWAYHAUUPUWQUVONRCYOWJUUMUVTUAMNCUUKUVS
      UULQYIYJWJYKYLLUAYTYMYNALUUFMKECSNVAFUURUVKUVNUWOUWPYPYQNUUBUUFDKUVCUVEUV
      IYRXKYS $.
  $}

  ${
    $d f k n x A $.  $d f k x B $.
    $( A countable union of nullsets is null.  (Contributed by Mario Carneiro,
       8-Apr-2015.) $)
    ovoliunnul $p |- ( ( A ~<_ NN /\ A. n e. A
      ( B C_ RR /\ ( vol* ` B ) = 0 ) ) -> ( vol* ` U_ n e. A B ) = 0 ) $=
      ( vf vk cn wbr cr wss covol cfv cc0 wceq wa c0 wi syl6eq wcel cv c1 ovol0
      cdom wral ciun iuneq1 0iun fveq2d a1i wne csdm cvv reldom brrelexi adantr
      vx 0sdomg syl wfo wex fodomr expcom csb wrex eliun nfv nfcv nfcsb1v nfiun
      wb nfcri foelrn csbeq1a adantl eleq2d impancom reximdv syl6ibr com23 syld
      ex biimpd rexlimd syl5bi ssrdv fof ffvelrnda simpllr nfss nffv nfeq1 nfan
      wf sseq1d eqeq1d anbi12d rspc simpld ralrimiva iunss sylibr cle csu caddc
      sylc cmpt cseq eqid 0re syl6eqel cuz csn cxp cli mpteq2dva fconstmpt nnuz
      simprd cdm xpeq1i eqtr3i seqeq3d cz 1z serclim0 c0ex breldm mp2b ovoliun2
      seqex sumeq2dv cfn wo eqimssi orci sumz ax-mp breqtrd ovolge0 cxr ovolcl
      xrletri3 sylancl mpbir2and ovolssnul syl3anc exlimdv sylbird pm2.61dne
      0xr ) AFUBGZBHIZBJKZLMZNZCAUCZNZCABUDZJKZLMZAOAOMZUUSPUUPUUTUUROJKLUUTUUQ
      OJUUTUUQCOBUDOCAOBUECBUFQUGUAQUHUUPAOUIZOAUJGZUUSUUPAUKRZUVBUVAVIUUJUVCUU
      OAFUBULUMUNAUKUPUQUUPUVBFADSZURZDUSZUUSUUJUVBUVFPUUOUVBUUJUVFFADUTVAUNUUP
      UVEUUSDUUPUVEUUSUUPUVENZUUQEFCESZUVDKZBVBZUDZIZUVKHIZUVKJKZLMZUUSUVEUVLUU
      PUVEUOUUQUVKUOSZUUQRUVPBRZCAVCUVEUVPUVKRZCUVPABVDUVEUVQUVRCAUVECVECUOUVKE
      CFUVJCFVFCUVIBVGZVHVJUVECSZARZUVTUVIMZEFVCZUVQUVRPUVEUWAUWCEFAUVTUVDVKVTU
      VEUVQUWCUVRUVEUVQUWCUVRPUVEUVQNZUWCUVPUVJRZEFVCUVRUWDUWBUWEEFUVEUWBUVQUWE
      UVEUWBNZUVQUWEUWFBUVJUVPUWBBUVJMUVECUVIBVLZVMVNWAVOVPEUVPFUVJVDVQVTVRVSWB
      WCWDVMUVGUVJHIZEFUCUVMUVGUWHEFUVGUVHFRZNZUWHUVJJKZLMZUWJUVIARUUOUWHUWLNZU
      VGFAUVHUVDUVEFAUVDWLUUPFAUVDWEVMWFUUJUUOUVEUWIWGUUNUWMCUVIAUWHUWLCCUVJHUV
      SCHVFWHCUWKLCUVJJCJVFUVSWIWJWKUWBUUKUWHUUMUWLUWBBUVJHUWGWMUWBUULUWKLUWBBU
      VJJUWGUGWNWOWPXDZWQZWREFUVJHWSWTZUVGUVOUVNLXAGZLUVNXAGZUVGUVNFUWKEXBZLXAU
      VGUVJXCEFUWKXEZTXFZEUWTUXAXGUWTXGUWOUWJUWKLHUWJUWHUWLUWNXQZXHXIUVGUXAXCTX
      JKZLXKZXLZTXFZXMXRZUVGUWTUXEXCTUVGUWTEFLXEZUXEUVGEFUWKLUXBXNFUXDXLUXHUXEE
      FLXOFUXCUXDXPXSXTQYATYBRUXFLXMGUXFUXGRYCTYDUXFLXMXCUXETYIYEYFYGXIYHUVGUWS
      FLEXBZLUVGFUWKLEUXBYJFUXCIZFYKRZYLUXILMUXJUXKFUXCXPYMYNFETYOYPQYQUVGUVMUW
      RUWPUVKYRUQUVGUVNYSRZLYSRUVOUWQUWRNVIUVGUVMUXLUWPUVKYTUQUUIUVNLUUAUUBUUCU
      UQUVKUUDUUEVTUUFVSUUGUUH $.
  $}

  ${
    $d f g n w x y z A $.  $d f g m n w x y z C $.  $d n x F $.  $d f n y G $.
    $d f g n w y z B $.  $d g z M $.  $d f g n w y z ph $.
    ovolshft.1 $e |- ( ph -> A C_ RR ) $.
    ovolshft.2 $e |- ( ph -> C e. RR ) $.
    ovolshft.3 $e |- ( ph -> B = { x e. RR | ( x - C ) e. A } ) $.
    $( If ` B ` is a shift of ` A ` by ` C ` , then ` A ` is a shift of ` B `
       by ` -u C ` .  (Contributed by Mario Carneiro, 22-Mar-2014.)  (Revised
       by Mario Carneiro, 6-Apr-2015.) $)
    shft2rab $p |- ( ph -> A = { y e. RR | ( y - -u C ) e. B } ) $=
      ( cv cr wcel cmin co wa crab cc wceq syl2anr eleq1d cneg sseld caddc recn
      cab pm4.71rd recnd subneg adantr eleq12d wb id readdcl oveq1 elrab3 pncan
      syl 3bitrd pm5.32da bitr4d abbi2dv df-rab syl6eqr ) ADCJZKLZVDFUAMNZELZOZ
      CUEVGCKPAVHCDAVDDLZVEVIOVHAVIVEADKVDGUBUFAVEVGVIAVEOZVGVDFUCNZBJZFMNZDLZB
      KPZLZVKFMNZDLZVIVJVFVKEVOVEVDQLZFQLZVFVKRAVDUDZAFHUGZVDFUHSAEVORVEIUIUJVJ
      VKKLZVPVRUKVEVEFKLWCAVEULHVDFUMSVNVRBVKKVLVKRVMVQDVLVKFMUNTUOUQVJVQVDDVEV
      SVTVQVDRAWAWBVDFUPSTURUSUTVAVGCKVBVC $.

    ${
      ovolshft.4 $e |- M = { y e. RR* |
        E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( B C_ U. ran ( (,) o. f ) /\
           y = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) } $.
      ${
        ovolshft.5 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
        ovolshft.6 $e |- G = ( n e. NN |->
          <. ( ( 1st ` ( F ` n ) ) + C ) , ( ( 2nd ` ( F ` n ) ) + C ) >. ) $.
        ovolshft.7 $e |- ( ph -> F : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
        ovolshft.8 $e |- ( ph -> A C_ U. ran ( (,) o. F ) ) $.
        $( Lemma for ~ ovolshft .  (Contributed by Mario Carneiro,
           22-Mar-2014.) $)
        ovolshftlem1 $p |- ( ph -> sup ( ran S , RR* , < ) e. M ) $=
          ( caddc cabs cmin ccom c1 cseq crn cxr clt csup cn cle cr cxp cin cc0
          wf cpnf cico co wfn cv cfv c1st c2nd cop wcel wa wbr w3a sylan simp1d
          ovolfcl simp2d adantr simp3d leadd1dd df-br sylib readdcld elin fmptd
          opelxp sylanbrc eqid ovolfsf ffn 3syl wceq cvv opex fvmpt2 mpan2 ovex
          fveq2d op2nd syl6eq op1st oveq12d adantl recnd pnpcan2d eqtrd 3eqtr4d
          ovolfsval eqfnfvd seqeq3d syl6eqr rneqd supeq1d cioo cuni wrex eleq2d
          wral crab oveq1 eleq1d elrab syl6bb biimpa simprr wb ovolfioo syl2anc
          mpbid breq2 breq1 anbi12d rexbidv rspcv sylc adantlr ad2antrr simplrl
          wss breq1d ltaddsubd bitrd mpbird breq2d ltsubaddd rexbidva ralrimiva
          bitr4d syldan ssrab2 syl6eqss elovolmr eqeltrrd ) AUAUBUCUDZKUDZUEUFZ
          UGZUHUIUJZGUGZUHUIUJLAUHUUNUUPUIAUUMGAUUMUAUUKJUDZUEUFGAUULUUQUAUEAIU
          KUULUUQAUKULUMUMUNZUOZKUQZUKUPURUSUTZUULUQUULUKVAAIUKIVBZJVCZVDVCZFUA
          UTZUVCVEVCZFUAUTZVFZUUSKAUVBUKVGZVHZUVHULVGZUVHUURVGZUVHUUSVGUVJUVEUV
          GULVIUVKUVJUVDUVFFUVJUVDUMVGZUVFUMVGZUVDUVFULVIZAUKUUSJUQZUVIUVMUVNUV
          OVJSJUVBVMVKZVLZUVJUVMUVNUVOUVQVNZAFUMVGZUVINVOZUVJUVMUVNUVOUVQVPVQUV
          EUVGULVRVSUVJUVEUMVGUVGUMVGUVLUVJUVDFUVRUWAVTUVJUVFFUVSUWAVTUVEUVGUMU
          MWCWDUVHULUURWAWDRWBZKUULUULWEZWFUKUVAUULWGWHAUVPUKUVAUUQUQUUQUKVASJU
          UQUUQWEZWFUKUVAUUQWGWHUVJUVBKVCZVEVCZUWEVDVCZUCUTZUVFUVDUCUTZUVBUULVC
          ZUVBUUQVCZUVJUWHUVGUVEUCUTZUWIUVIUWHUWLWIAUVIUWFUVGUWGUVEUCUVIUWFUVHV
          EVCUVGUVIUWEUVHVEUVIUVHWJVGUWEUVHWIUVEUVGWKIUKUVHWJKRWLWMZWOUVEUVGUVD
          FUAWNZUVFFUAWNZWPWQZUVIUWGUVHVDVCUVEUVIUWEUVHVDUWMWOUVEUVGUWNUWOWRWQZ
          WSWTUVJUVFUVDFUVJUVFUVSXAUVJUVDUVRXAUVJFUWAXAXBXCAUUTUVIUWJUWHWIUWBKU
          ULUVBUWCXEVKAUVPUVIUWKUWIWISJUUQUVBUWDXEVKXDXFXGQXHXIXJAUUTEXKKUDUGXL
          YPZUUOLVGUWBAUWRUWGCVBZUIVIZUWSUWFUIVIZVHZIUKXMZCEXOZAUXCCEAUWSEVGZUW
          SUMVGZUWSFUCUTZDVGZVHZUXCAUXEUXIAUXEUWSBVBZFUCUTZDVGZBUMXPZVGUXIAEUXM
          UWSOXNUXLUXHBUWSUMUXJUWSWIUXKUXGDUXJUWSFUCXQXRXSXTYAAUXIVHZUXCUVDUXGU
          IVIZUXGUVFUIVIZVHZIUKXMZUXNUXHUVDUXJUIVIZUXJUVFUIVIZVHZIUKXMZBDXOZUXR
          AUXFUXHYBAUYCUXIADXKJUDUGXLYPZUYCTADUMYPUVPUYDUYCYCMSBDIJYDYEYFVOUYBU
          XRBUXGDUXJUXGWIZUYAUXQIUKUYEUXSUXOUXTUXPUXJUXGUVDUIYGUXJUXGUVFUIYHYIY
          JYKYLUXNUXBUXQIUKUXNUVIVHZUWTUXOUXAUXPUYFUWTUVEUWSUIVIUXOUYFUWGUVEUWS
          UIUVIUWGUVEWIUXNUWQWTYQUYFUVDFUWSAUVIUVMUXIUVRYMAUVTUXIUVINYNZAUXFUXH
          UVIYOZYRYSUYFUXAUWSUVGUIVIUXPUYFUWFUVGUWSUIUVIUWFUVGWIUXNUWPWTUUAUYFU
          WSFUVFUYHUYGAUVIUVNUXIUVSYMUUBUUEYIUUCYTUUFUUDAEUMYPUUTUWRUXDYCAEUXMU
          MOUXLBUMUUGUUHUWBCEIKYDYEYTCEUUMHKLPUUMWEUUIYEUUJ $.
      $}

      $( Lemma for ~ ovolshft .  (Contributed by Mario Carneiro,
         22-Mar-2014.) $)
      ovolshftlem2 $p |- ( ph -> { z e. RR* |
        E. g e. ( ( <_ i^i ( RR X. RR ) ) ^m NN ) ( A C_ U. ran ( (,) o. g ) /\
    z = sup ( ran seq 1 ( + , ( ( abs o. - ) o. g ) ) , RR* , < ) ) } C_ M ) $=
        ( caddc cxr cr co wcel cfv vn vm cioo cv ccom crn cuni wss cabs cmin c1
        cseq clt csup wceq wa cle cxp cin cn cmap wrex wral crab c1st c2nd cmpt
        cop ad3antrrr eqid fveq2 fveq2d oveq1d opeq12d cbvmptv simplr reex xpex
        wi wf inex2 elmap sylib simpr ovolshftlem1 eleq1a syl expimpd rexlimdva
        nnex ralrimiva rabss sylibr ) AEUCIUDZUEUFUGUHZDUDZOUIUJUEWNUEUKULZUFPU
        MUNZUOZUPZIUQQQURZUSZUTVARZVBZWPJSZVSZDPVCXDDPVDJUHAXFDPAWPPSZUPZWTXEIX
        CXHWNXCSZUPZWOWSXEXJWOUPZWRJSWSXEVSXKBCEFGWQHUAWNUBUTUBUDZWNTZVETZGORZX
        MVFTZGORZVHZVGJAEQUHXGXIWOKVIAGQSXGXIWOLVIAFBUDGUJRESBQVDUOXGXIWOMVINWQ
        VJUBUAUTXRUAUDZWNTZVETZGORZXTVFTZGORZVHXLXSUOZXOYBXQYDYEXNYAGOYEXMXTVEX
        LXSWNVKZVLVMYEXPYCGOYEXMXTVFYFVLVMVNVOXKXIUTXBWNVTXHXIWOVPXBUTWNXAUQQQV
        QVQVRWAWJWBWCXJWOWDWEWRJWPWFWGWHWIWKXDDPJWLWM $.
    $}

    $( The Lebesgue outer measure function is shift-invariant.  (Contributed by
       Mario Carneiro, 22-Mar-2014.) $)
    ovolshft $p |- ( ph -> ( vol* ` A ) = ( vol* ` B ) ) $=
      ( vf vy vg vz cv ccom crn wss cxr csup wceq cr vw cioo cuni caddc cabs c1
      cmin cseq clt wa cle cxp cin cn cmap co wrex crab ccnv covol ovolshftlem2
      cfv eqid cneg ssrab2 syl6eqss renegcld shft2rab eqssd supeq1d ovolval syl
      wcel 3eqtr4d ) ACUBIMZNOUCPJMUDUEUGNZVONUFUHOQUIRSUJIUKTTULUMUNUOUPZUQJQU
      RZQUIUSZRZDUBKMZNOUCPLMUDVPWANUFUHOQUIRSUJKVQUQLQURZQVSRZCUTVBZDUTVBZAQVR
      WBVSAVRWBABLJCDEKIWBFGHWBVCZVAAUAJLDCEVDIKVRADBMEUGUPCVMZBTURTHWGBTVEVFZA
      EGVGABUACDEFGHVHVRVCZVAVIVJACTPWDVTSFJCIVRWIVKVLADTPWEWCSWHLDKWBWFVKVLVN
      $.
  $}

  ${
    $d f k n x y A $.  $d f n y B $.  $d n x F $.  $d k n y G $.  $d k x y R $.
    $d f k m n x y C $.  $d f k n y ph $.  $d k x S $.
    ovolsca.1 $e |- ( ph -> A C_ RR ) $.
    ovolsca.2 $e |- ( ph -> C e. RR+ ) $.
    ovolsca.3 $e |- ( ph -> B = { x e. RR | ( C x. x ) e. A } ) $.
    $( If ` B ` is a scale of ` A ` by ` C ` , then ` A ` is a scale of ` B `
       by ` 1 / C ` .  (Contributed by Mario Carneiro, 22-Mar-2014.) $)
    sca2rab $p |- ( ph -> A = { y e. RR | ( ( 1 / C ) x. y ) e. B } ) $=
      ( cv cr wcel cdiv co cmul wa crab wceq adantr eleq1d c1 sseld pm4.71rd wb
      cab eleq2d crp rprecred remulcl oveq2 elrab3 syl simpr recnd rpcnd rpne0d
      sylancom divrec2d oveq2d divcan2d eqtr3d 3bitrd pm5.32da abbi2dv syl6eqr
      bitr4d df-rab ) ADCJZKLZUAFMNZVHONZELZPZCUEVLCKQAVMCDAVHDLZVIVNPVMAVNVIAD
      KVHGUBUCAVIVLVNAVIPZVLVKFBJZONZDLZBKQZLZFVKONZDLZVNVOEVSVKAEVSRVIISUFVOVK
      KLZVTWBUDAVIVJKLWCVOFAFUGLVIHSZUHVJVHUIUQVRWBBVKKVPVKRVQWADVPVKFOUJTUKULV
      OWAVHDVOFVHFMNZONWAVHVOWEVKFOVOVHFVOVHAVIUMUNZVOFWDUOZVOFWDUPZURUSVOVHFWF
      WGWHUTVATVBVCVFVDVLCKVGVE $.

    ovolsca.4 $e |- ( ph -> ( vol* ` A ) e. RR ) $.
    ${
      ovolsca.5 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
      ovolsca.6 $e |- G = ( n e. NN |->
      <. ( ( 1st ` ( F ` n ) ) / C ) , ( ( 2nd ` ( F ` n ) ) / C ) >. ) $.
      ovolsca.7 $e |- ( ph -> F : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
      ovolsca.8 $e |- ( ph -> A C_ U. ran ( (,) o. F ) ) $.
      ovolsca.9 $e |- ( ph -> R e. RR+ ) $.
      ovolsca.10 $e |- ( ph ->
        sup ( ran S , RR* , < ) <_ ( ( vol* ` A ) + ( C x. R ) ) ) $.
      $( Lemma for ~ ovolsca .  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
      ovolscalem1 $p |- ( ph ->
        ( vol* ` B ) <_ ( ( ( vol* ` A ) / C ) + R ) ) $=
        ( vy vk covol cfv caddc cabs cmin ccom c1 cseq crn cxr clt csup cdiv co
        cr wss wcel cv cmul crab ssrab2 syl6eqss ovolcl syl cc0 cpnf cico cn wf
        cle cxp cin c1st c2nd cop wa wbr w3a ovolfcl sylan simp3d simp1d simp2d
        rpregt0d adantr lediv1 syl3anc mpbid df-br sylib crp rerpdivcld opelxpi
        wb syl2anc elin sylanbrc fmptd eqid ovolsf icossxr syl6ss supxrcl rpred
        frn readdcld rexrd cioo cuni wrex wral eleq2d wceq oveq2 elrab ovolfioo
        eleq1d breq1 anbi12d cvv fveq2d ovex syl6eq adantl adantlr mpbird rpcnd
        csu cc syl2an recnd ovolfsval fsumser eqtrd supxrleub wfn ffn ralrn cfz
        syl6bb simprr breq2 rexbidv rspcv sylc opex fvmpt2 mpan2 breq1d simplrl
        op1st ltdivmul bitr2d ltmuldiv2 breq2d bitr4d rexbidva ex sylbid ovollb
        op2nd ralrimiv fzfid simpl elfznn resubcld wne rpne0d fsumdivc rpcnne0d
        oveq12d divsubdir 3eqtr4d simpr nnuz syl6eleq rpmulcld r19.21bi syl6eqr
        cuz fveq1i adddid divcan2d 3brtr4d fsumrecl ledivmul eqbrtrrd ralrimiva
        oveq1d xrletrd ) ADUCUDZUEUFUGUHZJUHZUIUJZUKZULUMUNZCUCUDZEUOUPZFUEUPZA
        DUQURZUWMULUSADEBUTZVAUPZCUSZBUQVBZUQMUXEBUQVCVDZDVEVFAUWQULURZUWRULUSA
        UWQVGVHVIUPZULAVJUXIUWPVKZUWQUXIURAVJVLUQUQVMZVNZJVKZUXJAHVJHUTZIUDZVOU
        DZEUOUPZUXOVPUDZEUOUPZVQZUXLJAUXNVJUSZVRZUXTVLUSZUXTUXKUSZUXTUXLUSUYBUX
        QUXSVLVSZUYCUYBUXPUXRVLVSZUYEUYBUXPUQUSZUXRUQUSZUYFAVJUXLIVKZUYAUYGUYHU
        YFVTQIUXNWAWBZWCUYBUYGUYHEUQUSVGEUMVSVRZUYFUYEWPUYBUYGUYHUYFUYJWDZUYBUY
        GUYHUYFUYJWEZAUYKUYAAELWFZWGZUXPUXREWHWIWJUXQUXSVLWKWLUYBUXQUQUSUXSUQUS
        UYDUYBUXPEUYLAEWMUSUYALWGZWNUYBUXREUYMUYPWNUXQUXSUQUQWOWQUXTVLUXKWRWSPW
        TZUWPJUWOUWOXAZUWPXAZXBVFZVJUXIUWPXGVFVGVHXCZXDZUWQXEVFAUXAAUWTFAUWSENL
        WNZAFSXFXHZXIZAUXMDXJJUHUKXKURZUWMUWRVLVSUYQAVUFUXNJUDZVOUDZUAUTZUMVSZV
        UIVUGVPUDZUMVSZVRZHVJXLZUADXMZAVUNUADAVUIDUSZVUIUQUSZEVUIVAUPZCUSZVRZVU
        NAVUPVUIUXFUSVUTADUXFVUIMXNUXEVUSBVUIUQUXCVUIXOUXDVURCUXCVUIEVAXPXSXQUU
        BAVUTVUNAVUTVRZUXPVURUMVSZVURUXRUMVSZVRZHVJXLZVUNVVAVUSUXPUXCUMVSZUXCUX
        RUMVSZVRZHVJXLZBCXMZVVEAVUQVUSUUCAVVJVUTACXJIUHUKXKURZVVJRACUQURUYIVVKV
        VJWPKQBCHIXRWQWJWGVVIVVEBVURCUXCVURXOZVVHVVDHVJVVLVVFVVBVVGVVCUXCVURUXP
        UMUUDUXCVURUXRUMXTYAUUEUUFUUGVVAVVDVUMHVJVVAUYAVRZVVBVUJVVCVULVVMVUJUXQ
        VUIUMVSZVVBVVMVUHUXQVUIUMUYAVUHUXQXOVVAUYAVUHUXTVOUDUXQUYAVUGUXTVOUYAUX
        TYBUSVUGUXTXOUXQUXSUUHHVJUXTYBJPUUIUUJZYCUXQUXSUXPEUOYDZUXREUOYDZUUMYEZ
        YFUUKVVMUYGVUQUYKVVNVVBWPAUYAUYGVUTUYLYGAVUQVUSUYAUULZAUYAUYKVUTUYOYGZU
        XPVUIEUUNWIUUOVVMVVCVUIUXSUMVSZVULVVMVUQUYHUYKVVCVWAWPVVSAUYAUYHVUTUYMY
        GVVTVUIUXREUUPWIVVMVUKUXSVUIUMUYAVUKUXSXOVVAUYAVUKUXTVPUDUXSUYAVUGUXTVP
        VVOYCUXQUXSVVPVVQUVCYEZYFUUQUURYAUUSWJUUTUVAUVDAUXBUXMVUFVUOWPUXGUYQUAD
        HJXRWQYHDUWPJUYSUVBWQAUWRUXAVLVSZVUIUXAVLVSZUAUWQXMZAVWEUBUTZUWPUDZUXAV
        LVSZUBVJXMZAVWHUBVJAVWFVJUSZVRZUIVWFUUAUPZUXRUXPUGUPZHYJZEUOUPZVWGUXAVL
        VWKVWOVWLVWMEUOUPZHYJVWGVWKVWLVWMEHVWKUIVWFUVEZAEYKUSZVWJAELYIZWGVWKUXN
        VWLUSZVRVWMVWKAUYAVWMUQUSVWTAVWJUVFZUXNVWFUVGZUYBUXRUXPUYMUYLUVHZYLZYMZ
        AEVGUVIZVWJAELUVJZWGUVKVWKVWPHUWOUIVWFVWKAUYAUXNUWOUDZVWPXOVWTVXAVXBUYB
        VUKVUHUGUPZUXSUXQUGUPZVXHVWPUYAVXIVXJXOAUYAVUKUXSVUHUXQUGVWBVVRUVMYFAUX
        MUYAVXHVXIXOUYQJUWOUXNUYRYNWBUYBUXRYKUSUXPYKUSVWRVXFVRZVWPVXJXOUYBUXRUY
        MYMUYBUXPUYLYMAVXKUYAAELUVLWGUXRUXPEUVNWIUVOYLVWKVWFVJUIUWBUDAVWJUVPUVQ
        UVRZVWKAUYAVWPYKUSVWTVXAVXBUYBVWPUYBVWMEVXCUYPWNYMYLYOYPVWKVWOUXAVLVSZV
        WNEUXAVAUPZVLVSZVWKVWFGUDZUWSEFVAUPZUEUPZVWNVXNVLAVXPVXRVLVSZUBVJAUXCVX
        RVLVSZBGUKZXMZVXSUBVJXMZAVYAULUMUNVXRVLVSZVYBTAVYAULURVXRULUSVYDVYBWPAV
        YAUXIULAVJUXIGVKZVYAUXIURAUYIVYEQGIUWNIUHZVYFXAZOXBVFZVJUXIGXGVFVUAXDAV
        XRAUWSVXQNAVXQAEFLSUVSXFXHXIBVYAVXRYQWQWJAGVJYRZVYBVYCWPAVYEVYIVYHVJUXI
        GYSVFVXTVXSBUBVJGUXCVXPVXRVLXTYTVFWJUVTVWKVWNVWFUEVYFUIUJZUDVXPVWKVWMHV
        YFUIVWFVWKUYIUYAUXNVYFUDVWMXOVWTAUYIVWJQWGVXBIVYFUXNVYGYNYLVXLVXEYOVWFG
        VYJOUWCUWAAVXNVXRXOVWJAVXNEUWTVAUPZVXQUEUPVXRAEUWTFVWSAUWTVUCYMAFSYIUWD
        AVYKUWSVXQUEAUWSEAUWSNYMVWSVXGUWEUWKYPWGUWFVWKVWNUQUSUXAUQUSZUYKVXMVXOW
        PVWKVWLVWMHVWQVXDUWGAVYLVWJVUDWGAUYKVWJUYNWGVWNUXAEUWHWIYHUWIUWJAUWPVJY
        RZVWEVWIWPAUXJVYMUYTVJUXIUWPYSVFVWDVWHUAUBVJUWPVUIVWGUXAVLXTYTVFYHAUXHU
        XAULUSVWCVWEWPVUBVUEUAUWQUXAYQWQYHUWL $.
    $}

    $( Lemma for ~ ovolshft .  (Contributed by Mario Carneiro, 22-Mar-2014.) $)
    ovolscalem2 $p |- ( ph -> ( vol* ` B ) <_ ( ( vol* ` A ) / C ) ) $=
      ( vy vf cfv cdiv co cle cv crp wcel cr cn vn vm covol wbr caddc wral cioo
      wa ccom crn cuni wss cabs cmin cseq cxr clt csup cmul cxp cin cmap adantr
      wrex rpmulcl sylan eqid ovolgelb syl3anc c1st c2nd cop cmpt ad2antrr crab
      c1 fveq2 fveq2d oveq1d opeq12d cbvmptv wf elmapi ad2antrl simprrl simprrr
      wceq simplr ovolscalem1 rexlimddv ralrimiva wb ssrab2 syl6eqss ovolcl syl
      rerpdivcld xralrple syl2anc mpbird ) ADUCLZCUCLZEMNZOUDZXAXCJPZUENOUDZJQU
      FZAXFJQAXEQRZUHZCUGKPZUIUJUKULZUEUMUNUIXJUIVPUOZUJUPUQURXBEXEUSNZUENOUDZU
      HZXFKOSSUTVAZTVBNZXICSULZXBSRZXMQRZXOKXQVDAXRXHFVCAXSXHIVCAEQRZXHXTGEXEVE
      VFCXMXLKXLVGZVHVIXIXJXQRZXOUHZUHBCDEXEXLUAXJUBTUBPZXJLZVJLZEMNZYFVKLZEMNZ
      VLZVMAXRXHYDFVNAYAXHYDGVNADEBPUSNCRZBSVOZWGXHYDHVNAXSXHYDIVNYBUBUATYKUAPZ
      XJLZVJLZEMNZYOVKLZEMNZVLYEYNWGZYHYQYJYSYTYGYPEMYTYFYOVJYEYNXJVQZVRVSYTYIY
      REMYTYFYOVKUUAVRVSVTWAYCTXPXJWBXIXOXJXPTWCWDXIYCXKXNWEAXHYDWHXIYCXKXNWFWI
      WJWKAXAUPRZXCSRXDXGWLADSULUUBADYMSHYLBSWMWNDWOWPAXBEIGWQJXAXCWRWSWT $.

    $( The Lebesgue outer measure function respects scaling of sets by positive
       reals.  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    ovolsca $p |- ( ph -> ( vol* ` B ) = ( ( vol* ` A ) / C ) ) $=
      ( vy covol cfv cdiv co cle wbr ovolscalem2 cmul wcel cr wceq recnd rpne0d
      c1 rpcnd divrecd cv crab ssrab2 syl6eqss rpreccld wss rerpdivcld ovollecl
      sca2rab syl3anc lemuldivd mpbird eqbrtrd letri3d mpbir2and ) ADKLZCKLZEMN
      ZUAVBVDOPZVDVBOPABCDEFGHIQZAVDVCUDEMNZRNZVBOAVCEAVCIUBAEGUEAEGUCUFAVHVBOP
      VCVBVGMNOPAJDCVGADEBUGRNCSZBTUHTHVIBTUIUJZAEGUKZABJCDEFGHUOADTULVDTSVEVBT
      SVJAVCEIGUMZVFDVDUNUPZQAVCVBVGIVMVKUQURUSAVBVDVMVLUTVA $.
  $}

  ${
    $d f g h k m n t u v x y z A $.  $d f g h k m n t u v x y z B $.  $d t H $.
    $d f g k m n t y z C $.  $d h i j k n t x y F $.  $d i j k n t u x y z K $.
    $d f h i j k n t x y z G $.  $d i j m n t x y z M $.  $d i j k m n x y W $.
    $d k y P $.  $d f g h i j k m n t v x y z ph $.  $d f h k n t x y z T $.
    $d k n t u x y N $.  $d h z S $.  $d h n t u x z U $.  $d t X $.
    ovolicc.1 $e |- ( ph -> A e. RR ) $.
    ovolicc.2 $e |- ( ph -> B e. RR ) $.
    ovolicc.3 $e |- ( ph -> A <_ B ) $.
    ${
      ovolicc1.4 $e |- G = ( n e. NN |->
        if ( n = 1 , <. A , B >. , <. 0 , 0 >. ) ) $.
      $( The measure of a closed interval is lower bounded by its length.
         (Contributed by Mario Carneiro, 13-Jun-2014.)  (Proof shortened by
         Mario Carneiro, 25-Mar-2015.) $)
      ovolicc1 $p |- ( ph -> ( vol* ` ( A [,] B ) ) <_ ( B - A ) ) $=
        ( co cfv c1 cr wcel syl cc0 cn cle wceq wbr vx vz cicc covol caddc cabs
        vk cmin ccom cseq crn cxr clt csup wss iccssre syl2anc ovolcl cpnf cico
        wf cxp cin cv cop wa df-br sylib opelxpi elin sylanbrc adantr 0le0 mpbi
        cif 0re mp2an mpbir2an ifcl sylancl fmptd ovolsf icossxr syl6ss supxrcl
        eqid frn resubcld cuni c1st c2nd wrex wral 1nn a1i op1stg w3a wb elicc2
        rexrd biimpa simp2d eqbrtrd simp3d op2ndg fveq2 iftrue opex fvmpt ax-mp
        breqtrrd syl6eq fveq2d breq1d breq2d rspcev syl12anc ralrimiva ovolficc
        anbi12d mpbird ovollb2 cc addid1 adantl cuz nnuz eleqtri simpr syl6eleq
        pnfxr icossre ffvelrn c2 fveq2i ovolfsval eqtrd c0ex oveq12d syl5eq cfz
        sseldi recnd ad2antrr elfzuz df-2 syl6eleqr eluz2b3 simplbi eqeq1 ifbid
        wne ifex wn simprbi neneqd iffalse op2nd op1st 0cn subidi seqid2 eqtr3d
        1z seq1i leidd wfn ffn breq1 ralrn supxrleub xrletrd ) ABCUCJZUDKZUEUFU
        HUIEUIZLUJZUKZULUMUNZCBUHJZAUVMMUOZUVNULNABMNZCMNZUVTFGBCUPUQZUVMUROAUV
        QULUOZUVRULNAUVQPUSUTJZULAQUWEUVPVAZUVQUWEUOAQRMMVBZVCZEVAZUWFADQDVDZLS
        ZBCVEZPPVEZVOZUWHEAUWJQNZVFUWLUWHNZUWMUWHNZUWNUWHNAUWPUWOAUWLRNZUWLUWGN
        ZUWPABCRTUWRHBCRVGVHAUWAUWBUWSFGBCMMVIUQUWLRUWGVJVKVLUWQUWMRNZUWMUWGNZP
        PRTUWTVMPPRVGVNPMNZUXBUXAVPVPPPMMVIVQUWMRUWGVJVRUWKUWLUWMUWHVSVTIWAZUVP
        EUVOUVOWFZUVPWFZWBOZQUWEUVPWGOPUSWCWDZUVQWEOAUVSACBGFWHZWTZAUWIUVMUCEUI
        UKWIUOZUVNUVRRTUXCAUXJUWJEKZWJKZUAVDZRTZUXMUXKWKKZRTZVFZDQWLZUAUVMWMZAU
        XRUAUVMAUXMUVMNZVFZLQNZUWLWJKZUXMRTZUXMUWLWKKZRTZUXRUYBUYAWNWOUYAUYCBUX
        MRAUYCBSZUXTAUWAUWBUYGFGBCMMWPUQZVLUYAUXMMNZBUXMRTZUXMCRTZAUXTUYIUYJUYK
        WQZAUWAUWBUXTUYLWRFGBCUXMWSUQXAZXBXCUYAUXMCUYERUYAUYIUYJUYKUYMXDAUYECSZ
        UXTAUWAUWBUYNFGBCMMXEUQZVLXKUXQUYDUYFVFDLQUWKUXNUYDUXPUYFUWKUXLUYCUXMRU
        WKUXKUWLWJUWKUXKLEKZUWLUWJLEXFUYBUYPUWLSWNDLUWNUWLQEUWKUWLUWMXGIBCXHZXI
        XJZXLZXMXNUWKUXOUYEUXMRUWKUXKUWLWKUYSXMXOXTXPXQXRAUVTUWIUXJUXSWRUWCUXCU
        AUVMDEXSUQYAUVMUVPEUXEYBUQAUVRUVSRTZUBVDZUVSRTZUBUVQWMZAVUCUXMUVPKZUVSR
        TZUAQWMZAVUEUAQAUXMQNZVFZVUDUVSUVSRVUHLUVPKZVUDUVSVUHUGUEYCUVOLLUXMPUGV
        DZYCNVUJPUEJVUJSVUHVUJYDYELLYFKZNVUHLQVUKWNYGYHWOVUHUXMQVUKAVUGYIYGYJVU
        HVUIVUHUWEMVUIUXBUSULNUWEMUOVPYKPUSYLVQVUHUWFUYBVUIUWENAUWFVUGUXFVLWNQU
        WELUVPYMVTUUBUUCVUHVUJLLUEJZUXMUUAJNZVFZVUJUVOKZVUJEKZWKKZVUPWJKZUHJZPV
        UNUWIVUJQNZVUOVUSSAUWIVUGVUMUXCUUDVUNVUJYNYFKZNZVUTVUNVUJVULYFKZVVAVUMV
        UJVVCNVUHVUJVULUXMUUEYEYNVULYFUUFYOUUGZVVBVUTVUJLUULZVUJUUHZUUIOZEUVOVU
        JUXDYPUQVUNVUSPPUHJPVUNVUQPVURPUHVUNVUQUWMWKKPVUNVUPUWMWKVUNVUPVUJLSZUW
        LUWMVOZUWMVUNVUTVUPVVISVVGDVUJUWNVVIQEUWJVUJSUWKVVHUWLUWMUWJVUJLUUJUUKI
        VVHUWLUWMUYQPPXHUUMXIOVUNVVHUUNVVIUWMSVUNVUJLVUNVVBVVEVVDVVBVUTVVEVVFUU
        OOUUPVVHUWLUWMUUQOYQZXMPPYRYRUURXLVUNVURUWMWJKPVUNVUPUWMWJVVJXMPPYRYRUU
        SXLYSPUUTUVAXLYQUVBVUHUVSUEUVOLUVDVUHLUVOKZUYPWKKZUYPWJKZUHJZUVSVUHUWIU
        YBVVKVVNSAUWIVUGUXCVLWNEUVOLUXDYPVTVUHVVLCVVMBUHVUHVVLUYECUYPUWLWKUYRYO
        AUYNVUGUYOVLYTVUHVVMUYCBUYPUWLWJUYRYOAUYGVUGUYHVLYTYSYQUVEUVCAUVSUVSRTV
        UGAUVSUXHUVFVLXCXRAUVPQUVGZVUCVUFWRAUWFVVOUXFQUWEUVPUVHOVUBVUEUBUAQUVPV
        UAVUDUVSRUVIUVJOYAAUWDUVSULNUYTVUCWRUXGUXIUBUVQUVSUVKUQYAUVL $.
    $}

    ${
      ovolicc2.4 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
      ovolicc2.5 $e |- ( ph -> F : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
      ovolicc2.6 $e |- ( ph -> U e. ( ~P ran ( (,) o. F ) i^i Fin ) ) $.
      ovolicc2.7 $e |- ( ph -> ( A [,] B ) C_ U. U ) $.
      ovolicc2.8 $e |- ( ph -> G : U --> NN ) $.
      ovolicc2.9 $e |- ( ( ph /\ t e. U ) ->
                            ( ( (,) o. F ) ` ( G ` t ) ) = t ) $.
      $( Lemma for ~ ovolicc2 .  (Contributed by Mario Carneiro,
         14-Jun-2014.) $)
      ovolicc2lem1 $p |- ( ( ph /\ X e. U ) -> ( P e. X <-> ( P e. RR /\
                             ( 1st ` ( F ` ( G ` X ) ) ) < P /\
                             P < ( 2nd ` ( F ` ( G ` X ) ) ) ) ) ) $=
        ( cr wcel wa cfv c1st c2nd cioo co clt wbr w3a ccom cn ffvelrnda cxp wf
        wceq cle cin wss inss2 fss sylancl fvco3 sylan syldan cv wral ralrimiva
        fveq2 fveq2d id eqeq12d rspccva cop adantr ffvelrnd 1st2nd2 syl syl6eqr
        df-ov 3eqtr3d eleq2d xp1st xp2nd cxr rexr elioo2 syl2an syl2anc bitrd
        wb ) AJGUAZUBZEJUAEJIUCZHUCZUDUCZWOUEUCZUFUGZUAZETUAWPEUHUIEWQUHUIUJZWM
        JWREWMWNUFHUKZUCZWOUFUCZJWRAWLWNULUAZXBXCUPZAGULJIRUMZAULTTUNZHUOZXDXEA
        ULUQXGURZHUOXIXGUSXHOUQXGUTULXIXGHVAVBZULXGWNUFHVCVDVEABVFZIUCZXAUCZXKU
        PZBGVGWLXBJUPZAXNBGSVHXNXOBJGXKJUPZXMXBXKJXPXLWNXAXKJIVIVJXPVKVLVMVDWMX
        CWPWQVNZUFUCWRWMWOXQUFWMWOXGUAZWOXQUPWMULXGWNHAXHWLXJVOXFVPZWOTTVQVRVJW
        PWQUFVTVSWAWBWMWPTUAZWQTUAZWSWTWKZWMXRXTXSWOTTWCVRWMXRYAXSWOTTWDVRXTWPW
        EUAWQWEUAYBYAWPWFWQWFWPWQEWGWHWIWJ $.

      ovolicc2.10 $e |- T = { u e. U | ( u i^i ( A [,] B ) ) =/= (/) } $.
      ${
        ovolicc2.11 $e |- ( ph -> H : T --> T ) $.
        ovolicc2.12 $e |- ( ( ph /\ t e. T ) ->
                              if ( ( 2nd ` ( F ` ( G ` t ) ) ) <_ B ,
                                   ( 2nd ` ( F ` ( G ` t ) ) ) , B ) e.
                              ( H ` t ) ) $.
        ovolicc2.13 $e |- ( ph -> A e. C ) $.
        ovolicc2.14 $e |- ( ph -> C e. T ) $.
        ovolicc2.15 $e |- K = seq 1 ( ( H o. 1st ) , ( NN X. { C } ) ) $.
        ovolicc2.16 $e |- W = { n e. NN | B e. ( K ` n ) } $.
        $( Lemma for ~ ovolicc2 .  (Contributed by Mario Carneiro,
           14-Jun-2014.) $)
        ovolicc2lem2 $p |- ( ( ph /\ ( N e. NN /\ -. N e. W ) ) ->
                                ( 2nd ` ( F ` ( G ` ( K ` N ) ) ) ) <_ B ) $=
          ( vx cn wcel wn cfv cle wbr wa clt cr adantr cxp wf cin wss inss2 fss
          c2nd sylancl cicc co c0 wne c1 nnuz cz 1z a1i algrf ffvelrnda cv wceq
          ineq1 neeq1d elrab2 sylib simpld ffvelrnd xp2nd syl ltnled simprl wex
          c1st adantrr simprd n0 xp1st w3a simpr elin wb syl2anc ad2antrr mpbid
          elicc2 simp1d ovolicc2lem1 syldan simp2d simp3d exlimddv simprr fveq2
          ltletrd mpbir3and eleq2d sylanbrc expr sylbird con1d impr ) AOUNUOZOP
          UOZUPONUQZLUQZKUQZVJUQZEURUSZAYEUTZYKYFYLYKUPEYJVAUSZYFYLEYJAEVBUOZYE
          RVCYLYIVBVBVDZUOZYJVBUOYLUNYOYHKAUNYOKVEZYEAUNURYOVFZKVEYRYOVGYQUAURY
          OVHUNYRYOKVIVKVCYLIUNYGLAIUNLVEYEUDVCYLYGIUOZYGDEVLVMZVFZVNVOZYLYGHUO
          YSUUBUTZAUNHONAFNHMVPUNVQUKVPVRUOAVSVTUJUGWAWBBWCZYTVFZVNVOUUBBYGIHUU
          DYGWDUUEUUAVNUUDYGYTWEWFUFWGWHZWIWJWJZYIVBVBWKWLWMAYEYMYFAYEYMUTZUTZY
          EEYGUOZYFAYEYMWNUUIUUJYNYIWPUQZEVAUSZYMAYNUUHRVCUUIUMWCZUUAUOZUULUMUU
          IUUBUUNUMWOUUIYSUUBAYEUUCYMUUFWQZWRUMUUAWSWHUUIUUNUTZUUKUUMEUUIUUKVBU
          OZUUNAYEUUQYMYLYPUUQUUGYIVBVBWTWLWQVCUUPUUMVBUOZDUUMURUSZUUMEURUSZUUP
          UUMYTUOZUURUUSUUTXAZUUPUUMYGUOZUVAUUPUUNUVCUVAUTUUIUUNXBUUMYGYTXCWHZW
          RAUVAUVBXDZUUHUUNADVBUOYNUVEQRDEUUMXHXEXFXGZXIAYNUUHUUNRXFUUPUURUUKUU
          MVAUSZUUMYJVAUSZUUPUVCUURUVGUVHXAZUUPUVCUVAUVDWIUUIUVCUVIXDZUUNAUUHYS
          UVJUUIYSUUBUUOWIZACDEUUMGIKLYGQRSTUAUBUCUDUEXJXKVCXGXLUUPUURUUSUUTUVF
          XMXQXNAYEYMXOAUUHYSUUJYNUULYMXAXDUVKACDEEGIKLYGQRSTUAUBUCUDUEXJXKXREJ
          WCZNUQZUOUUJJOUNPUVLOWDUVMYGEUVLONXPXSULWGXTYAYBYCYD $.

        $( Lemma for ~ ovolicc2 .  (Contributed by Mario Carneiro,
           14-Jun-2014.) $)
        ovolicc2lem3 $p |- ( ( ph /\
            ( N e. { n e. NN | A. m e. W n <_ m } /\
              P e. { n e. NN | A. m e. W n <_ m } ) ) ->
              ( N = P <-> ( 2nd ` ( F ` ( G ` ( K ` N ) ) ) ) =
                          ( 2nd ` ( F ` ( G ` ( K ` P ) ) ) ) ) ) $=
          ( vy vk vx cv cfv c2nd cle wbr wral crab weq fveq2 fveq2d wceq ssrab2
          cn cr nnssre sstri wcel sseli wa cxp cin wss inss2 fss sylancl adantr
          wf c1 nnuz cz 1z a1i algrf cicc wne eqsstri ffvelrn sylancom ffvelrnd
          co c0 xp2nd syl sylan2 wi ad2antll anim2i adantrr breq1 ralbidv elrab
          clt simprbi caddc breq2d imbi12d imbi2d wn nnnlt1 adantl pm2.21d nnre
          breq2 a1d lep1d peano2re letr syl3anc mpand ralimdva imim1d wo simplr
          wb simprl syl2anc nnred cif mpbid ad2antrr breq1d com23 a2d c1st ltp1
          nnleltp1 leloed bitr3d simpll ltnle rspccv mtod ovolicc2lem2 syl12anc
          w3a mpdan iftrue ralrimiva eqidd ifbieq12d rspcv sylc eqeltrrd algrp1
          eleq12d ad2ant2r eleqtrrd peano2nnd ovolicc2lem1 simp3d mpan2d imim2d
          lttr syl5ibrcom a1dd jaod sylbid expr syld expcom nnind syl3c eqord1
          ) AUOUPUOURZPUSZNUSZMUSZUTUSZUPURZPUSZNUSZMUSZUTUSZQGLURZKURZVAVBZKRV
          CZLVJVDZQPUSZNUSZMUSZUTUSGPUSZNUSZMUSZUTUSUOUPVEZUWDUWIUTUXBUWCUWHMUX
          BUWBUWGNUWAUWFPVFVGVGVGZUWAQVHZUWDUWRUTUXDUWCUWQMUXDUWBUWPNUWAQPVFVGV
          GVGUWAGVHZUWDUXAUTUXEUWCUWTMUXEUWBUWSNUWAGPVFVGVGVGUWOVJVKUWNLVJVIZVL
          VMUWAUWOVNZAUWAVJVNZUWEVKVNZUWOVJUWAUXFVOZAUXHVPZUWDVKVKVQZVNUXIUXKVJ
          UXLUWCMAVJUXLMWDZUXHAVJVAUXLVRZMWDUXNUXLVSUXMUCVAUXLVTVJUXNUXLMWAWBZW
          CUXKJVJUWBNAJVJNWDZUXHUFWCAUXHVJJPWDZUWBJVNUXKVJIPWDZIJVSZUXQAUXRUXHA
          FPIOWEVJWFUMWEWGVNAWHWIZULUIWJZWCIBURDEWKWQVRWRWLZBJVDJUHUYBBJVIWMZVJ
          IJPWAZWBVJJUWAPWNWOWPWPUWDVKVKWSWTZXAAUXGUWFUWOVNZVPVPUWFVJVNZUXKUWFU
          WLVAVBZKRVCZUWAUWFXIVBZUWEUWJXIVBZXBZUYFUYGAUXGUWOVJUWFUXFVOXCAUXGUXK
          UYFUXGUXHAUXJXDXEUYFUYIAUXGUYFUYGUYIUWNUYILUWFVJLUPVEUWMUYHKRUWKUWFUW
          LVAXFXGXHXJXCUXKUQURZUWLVAVBZKRVCZUWAUYMXIVBZUWEUYMPUSZNUSZMUSZUTUSZX
          IVBZXBZXBZXBUXKWEUWLVAVBZKRVCZUWAWEXIVBZUWEWEPUSZNUSZMUSZUTUSZXIVBZXB
          ZXBZXBUXKUYIUYLXBZXBZUXKUWFWEXKWQZUWLVAVBZKRVCZUWAVUPXIVBZUWEVUPPUSZN
          USZMUSZUTUSZXIVBZXBZXBZXBVUOUQUPUWFUYMWEVHZVUCVUMUXKVVGUYOVUEVUBVULVV
          GUYNVUDKRUYMWEUWLVAXFXGVVGUYPVUFVUAVUKUYMWEUWAXIXTVVGUYTVUJUWEXIVVGUY
          SVUIUTVVGUYRVUHMVVGUYQVUGNUYMWEPVFVGVGVGXLXMXMXNUQUPVEZVUCVUNUXKVVHUY
          OUYIVUBUYLVVHUYNUYHKRUYMUWFUWLVAXFXGVVHUYPUYJVUAUYKUYMUWFUWAXIXTVVHUY
          TUWJUWEXIVVHUYSUWIUTVVHUYRUWHMVVHUYQUWGNUYMUWFPVFVGVGVGXLXMXMXNZUYMVU
          PVHZVUCVVFUXKVVJUYOVURVUBVVEVVJUYNVUQKRUYMVUPUWLVAXFXGVVJUYPVUSVUAVVD
          UYMVUPUWAXIXTVVJUYTVVCUWEXIVVJUYSVVBUTVVJUYRVVAMVVJUYQVUTNUYMVUPPVFVG
          VGVGXLXMXMXNVVIUXKVULVUEUXKVUFVUKUXHVUFXOAUWAXPXQXRYAUYGUXKVUNVVFUXKU
          YGVUNVVFXBUXKUYGVPZVUNVURUYLXBZVVFUYGVUNVVLXBUXKUYGVURUYIUYLUYGVUQUYH
          KRUYGUWLRVNZVPZUWFVUPVAVBZVUQUYHVVNUWFUYGUWFVKVNZVVMUWFXSWCZYBVVNVVPV
          UPVKVNZUWLVKVNZVVOVUQVPUYHXBVVQVVNVVPVVRVVQUWFYCZWTVVMVVSUYGRVKUWLRVJ
          VKREUWKPUSVNZLVJVDVJUNVWALVJVIWMVLVMVOXQUWFVUPUWLYDYEYFYGYHXQVVKVURUY
          LVVEUXKUYGVURUYLVVEXBUXKUYGVURVPZVPZVUSUYLVVDVWCVUSUYJUXBYIZUYLVVDXBZ
          VWCUWAUWFVAVBZVUSVWDVWCUXHUYGVWFVUSYKAUXHVWBYJZUXKUYGVURYLZUWAUWFUUCY
          MVWCUWAUWFVWCUWAVWGYNVWCUWFVWHYNZUUDUUEVWCUYJVWEUXBVWCUYLUYJVVDVWCUYK
          VVDUYJVWCUYKUWJVVCXIVBZVVDVWCUWJVKVNZVVBUUAUSUWJXIVBZVWJVWCUWJVUTVNZV
          WKVWLVWJUULZVWCUWJUWGOUSZVUTVWCUWJEVAVBZUWJEYOZUWJVWOVWCVWPVWQUWJVHVW
          CAUYGUWFRVNZXOVWPAUXHVWBUUFZVWHVWCVWRVUPUWFVAVBZVWCVVPVWTXOZVWIVVPUWF
          VUPXIVBZVXAUWFUUBVVPVVRVXBVXAYKVVTUWFVUPUUGUUMYPWTVURVWRVWTXBUXKUYGVU
          QVWTKUWFRUWLUWFVUPVAXTUUHXCUUIABCDEFHIJLMNOPUWFRSTUAUBUCUDUEUFUGUHUIU
          JUKULUMUNUUJUUKVWPUWJEUUNWTVWCUWGIVNCURZNUSZMUSZUTUSZEVAVBZVXFEYOZVXC
          OUSZVNZCIVCZVWQVWOVNZVWCVJIUWFPAUXRUXHVWBUYAYQZVWHWPAVXKUXHVWBAVXJCIU
          JUUOYQVXJVXLCUWGIVXCUWGVHZVXHVWQVXIVWOVXNVXGVWPVXFEUWJEVXNVXFUWJEVAVX
          NVXEUWIUTVXNVXDUWHMVXCUWGNVFVGVGZYRVXOVXNEUUPUUQVXCUWGOVFUVBUURUUSUUT
          AUYGVUTVWOVHUXHVURAFPIOUWFWEVJWFUMUXTULUIUVAUVCUVDVWCAVUTJVNVWMVWNYKV
          WSVWCVJJVUPPVWCUXRUXSUXQVXMUYCUYDWBZVWCUWFVWHUVEWPZACDEUWJHJMNVUTSTUA
          UBUCUDUEUFUGUVFYMYPUVGZVWCUXIVWKVVCVKVNZUYKVWJVPVVDXBUXKUXIVWBUYEWCVW
          CUWIUXLVNVWKVWCVJUXLUWHMAUXMUXHVWBUXOYQZVWCJVJUWGNAUXPUXHVWBUFYQZVWCV
          JJUWFPVXPVWHWPWPWPUWIVKVKWSWTVWCVVBUXLVNVXSVWCVJUXLVVAMVXTVWCJVJVUTNV
          YAVXQWPWPVVBVKVKWSWTUWEUWJVVCUVJYEUVHUVIYSVWCUXBVVDUYLVWCVVDUXBVWJVXR
          UXBUWEUWJVVCXIUXCYRUVKUVLUVMUVNYSUVOYTUVPUVQYTUVRUVSUVT $.

        ovolicc2.17 $e |- M = sup ( W , RR , `' < ) $.
        $( Lemma for ~ ovolicc2 .  (Contributed by Mario Carneiro,
           14-Jun-2014.) $)
        ovolicc2lem4 $p |- ( ph -> ( B - A ) <_ sup ( ran S , RR* , < ) ) $=
          ( vy vz vx vi vj vm cv clt wbr ccom c1 cfz wral cmin crn cxr csup cle
          co cn cr wrex wss cfn wcel wf nnuz cz a1i cin wne crab ssrab2 eqsstri
          1z c0 fss sylancl syl2anc elfznn frn syl nnssre syl6ss fzfid wf1o wf1
          wceq wi wa adantl syl2an eqtrd c2nd fveq2 fveq2d wb ad2antlr nnred wn
          sylib simprd adantr simprl sylibr sseldi letrd sseldd syldan resubcld
          cfv csu cc0 cpnf sylan2 fsumrecl sselda caddc ffvelrnd xp1st cc recnd
          c1st ffvelrn w3a ovolicc2lem1 mpbid cima cres df-ima algrf cicc ssriv
          fco fssres syl5eqss wfo fvres fvco3 adantrr ad2antll eqeq12d ccnv cuz
          sstri sseqtri uzinf ax-mp cdom cioo cpw elin ssfi simpll ral0 raleqdv
          simplr mpbiri ralrimivw rabid2 eleqtrd simprr ovolicc2lem3 ralrimivva
          syl12anc syl5ibr dff13 sylanbrc f1domg sylc domfi necon3bd infmssuzcl
          mpi sylancr syl5eqel ad2antrr sseli elfzle2 infmssuzle mpan ralrimiva
          ex syl5eqbr ssrabdv jca sylbid f1f1orn f1oeq3 fofi fimaxre2 ad3antrrr
          f1ofo arch simpr simpllr nnre lelttr syl3anc ancomsd expdimp ralimdva
          an32s impancom reximdva mpd rexlimdva cabs cico cxp ovolfsf ffvelrnda
          rexrd eqid elrege0 simpld ovolsf 0re pnfxr icossre mp2an ressxr inss2
          supxrcl xp2nd fsumf1o ovolfsval sumeq2dv fsumsub fsumm1 addcomd algr0
          fsum1p peano2zd nnzd fzp1ss mp1i fsumshftm ax-1cn pncan sumeq1i oveq1
          oveq1i cbvsumv eqtri syl6eq oveq12d peano2nn addsub4d 3eqtrd eqeltrrd
          eleq2d elrab2 mpdan simp3d simp2d lt2subd elfzm11 ltnled ovolicc2lem2
          ltled cif iftrue breq1d eqidd ifbieq12d eleq12d rspcv algrp1 eleqtrrd
          nsyl fsumle subge0d addge01d breqtrrd adantlr ltle syl6eleq nnz elfz5
          mpbird sylibrd impr fsumless cseq fsumser fveq1i syl6eqr wfn fnfvelrn
          dfss3 ffn supxrub eqbrtrd xrletrd rexlimddv ) AUNUTZUOUTZVAVBZUNLNVCZ
          VDOVEVLZUUAZVFZEDVGVLZGVHZVIVAVJZVKVBUOVMAVXJUPUTZVKVBZUNVXOVFZUPVNVO
          ZVXPUOVMVOZAVXOVNVPZVXOVQVRZVYCAVXOVMVNAVXOVXMVXNUUBZVHZVMVXMVXNUUCZA
          VXNVMVYGVSZVYHVMVPAVMVMVXMVSZVXNVMVPZVYJAIVMLVSZVMINVSZVYKUDAVMHNVSZH
          IVPZVYNAFNHMVDVMVTUKVDWAVRZAWHWBZUJUGUUDZHBUTDEUUEVLWCWIWDZBIWEIUFVYT
          BIWFWGZVMHINWJWKZVMIVMLNUUGWLUQVXNVMUQUTZOWMZUUFZVMVMVXNVXMUUHWKZVXNV
          MVYGWNWOUUIZWPWQZAVXNVQVRVXNVXOVYGUUJZVYFAVDOWRZAVXNVXOVYGWSZWUIAVXNV
          YHVYGWSZWUKAVXNVMVYGWTZWULAVYJWUCVYGYDZURUTZVYGYDZXAZWUCWUOXAZXBZURVX
          NVFUQVXNVFWUMWUFAWUSUQURVXNVXNAWUCVXNVRZWUOVXNVRZXCZXCZWUQWUCNYDZLYDZ
          WUONYDZLYDZXAZWURWVCWUNWVEWUPWVGAWUTWUNWVEXAWVAAWUTXCZWUNWUCVXMYDZWVE
          WUTWUNWVJXAAWUCVXNVXMUUKXDAVYOWUCVMVRZWVJWVEXAWUTVYSWUDVMHWUCLNUULXEX
          FZUUMWVCWUPWUOVXMYDZWVGWVAWUPWVMXAAWUTWUOVXNVXMUUKUUNAVYOWUOVMVRZWVMW
          VGXAWVBVYSWVAWVNWUTWUOOWMXDVMHWUOLNUULXEXFUUOWVHWURWVCWVEKYDZXGYDZWVG
          KYDZXGYDXAZWVHWVOWVQXGWVEWVGKXHXIAWVBWUCJUTZUSUTZVKVBZUSPVFZJVMWEZVRZ
          WUOWWCVRZXCWURWVRXJZWVCWWDWWEWVCVXNWWCWUCAVXNWWCVPWVBAWWBJVMVXNVYLAWU
          EWBAWVSVXNVRZXCZWWAUSPWWHWVTPVRZXCZWVSOWVTWWJWVSWWGWVSVMVRAWWIWVSOWMX
          KXLAOVNVRZWWGWWIAPVNOPVMVNPEWVSNYDZVRZJVMWEVMULWWMJVMWFWGZWPUURZAOPVN
          VAUUPVJZPUMAPVDUUQYDZVPZPWIWDZWWPPVRPVMWWQWWNVTUUSZAVMVQVRZXMZWWSVYQW
          XBWHVDVMVTUUTUVAAWXAPWIAPWIXAZWXAAWXCXCZHVQVRZVMHUVBVBZWXAAWXEWXCAIVQ
          VRZVYPWXEAIUVCKVCVHUVDZVRZWXGAIWXHVQWCVRWXIWXGXCUBIWXHVQUVEXNXOWUAIHU
          VFWKXPZWXDWXEVMHNWTZWXFWXJWXDVYOWVDWVFXAZWURXBZURVMVFUQVMVFWXKAVYOWXC
          VYSXPWXDWXMUQURVMVMWXLWURWXDWVKWVNXCZXCZWVRWXLWVOWVQXGWXLWVEWVGKWVDWV
          FLXHXIXIWXOAWWDWWEWWFAWXCWXNUVGWXOWUCVMWWCWXDWVKWVNXQWXOWWBJVMVFVMWWC
          XAWXOWWBJVMWXOWWBWWAUSWIVFWWAUSUVHWXOWWAUSPWIAWXCWXNUVJUVIUVKUVLWWBJV
          MUVMXRZUVNWXOWUOVMWWCWXDWVKWVNUVOWXPUVNABCDEFWUOGHIUSJKLMNWUCPQRSTUAU
          BUCUDUEUFUGUHUIUJUKULUVPZUVRUVSUVQUQURVMHNUVTUWAVMHVQNUWBUWCHVMUWDWLU
          WPUWEUWGPVDUWFUWHUWIZXSZUWJWWIWVTVNVRWWHPVNWVTWWOUWKXDWWGWVSOVKVBAWWI
          WVSVDOUWLXKWWIOWVTVKVBWWHWWIOWWPWVTVKUMWWRWWIWWPWVTVKVBWWTWVTPVDUWMUW
          NUWQXDXTUWOUWRXPZAWUTWVAXQYAWVCVXNWWCWUOWXTAWUTWVAUVOYAUWSWXQYBUVSUWT
          UVQUQURVXNVMVYGUVTUWAVXNVMVYGUXAWOVXOVYHXAWUKWULXJVYIVXOVYHVXNVYGUXBU
          VAXRZVXNVXOVYGUXFWOVXNVXOVYGUXCWLZUPUNVXOUXDWLAVYBVYDUPVNAVXTVNVRZXCZ
          VYBVYDWYDVYBXCZVXTVXKVAVBZUOVMVOZVYDWYCWYGAVYBVXTUOUXGXKWYEWYFVXPUOVM
          WYDVXKVMVRZVYBWYFVXPXBWYDWYHXCZWYFVYBVXPWYIWYFXCVYAVXLUNVXOWYIVXJVXOV
          RZWYFVYAVXLXBWYIWYJXCZWYFVYAVXLWYKVYAWYFVXLWYKVXJVNVRZWYCVXKVNVRZVYAW
          YFXCVXLXBWYKVXOVNVXJAVYEWYCWYHWYJWUHUXEWYIWYJUXHYAAWYCWYHWYJUXIWYHWYM
          WYDWYJVXKUXJZXKVXJVXTVXKUXKUXLUXMUXNUXPUXOUXQUXPUXRUXSUWPUXTUXSAWYHVX
          PXCZXCZVXQVDVXKVEVLZWUOUYAVGVCKVCZYDZURYEZVXSAVXQVIVRWYOAVXQAEDRQYCZU
          YFXPWYPWYTAWYTVNVRWYOAWYQWYSURAVDVXKWRAWUOWYQVRZXCZWYSVNVRZYFWYSVKVBZ
          XUCWYSYFYGUYBVLZVRZXUDXUEXCXUBAWVNXUGWUOVXKWMAVMXUFWUOWYRAVMVKVNVNUYC
          ZWCZKVSZVMXUFWYRVSUAKWYRWYRUYGZUYDWOUYEZYHWYSUYHXNZUYIZYIXPZUYFAVXSVI
          VRZWYOAVXRVIVPZXUPAVXRVNVIAVXRXUFVNAVMXUFGVSZVXRXUFVPAXUJXURUAGKWYRXU
          KTUYJWOZVMXUFGWNWOYFVNVRYGVIVRXUFVNVPUYKUYLYFYGUYMUYNZWQUYOWQZVXRUYQW
          OXPWYPVXQVXOWYSURYEZWYTAVXQVNVRWYOXUAXPAXVBVNVRWYOAVXOWYSURWYBAWUOVXO
          VRZWVNXUDAVXOVMWUOWUGYJZAWVNXCZXUFVNWYSXUTXULXSZYBYIZXPXUOAVXQXVBVKVB
          WYOAVXQONYDZLYDZKYDZXGYDZFLYDZKYDZYPYDZVGVLZVDOVDVGVLZVEVLZWVPUQYEZXV
          QWUCVDYKVLZNYDZLYDZKYDZYPYDZUQYEZVGVLZYKVLZXVBVKAVXQXVOXWFXUAAXVKXVNA
          XVJXUHVRXVKVNVRAVMXUHXVIKAXUJXUIXUHVPVMXUHKVSZUAVKXUHUYPVMXUIXUHKWJWK
          ZAIVMXVHLUDAVMIONWUBAPVMOWWNWXRXSZYLZYLYLXVJVNVNUYRWOZAXVMXUHVRXVNVNV
          RAVMXUHXVLKXWHAIVMFLUDAHIFWUAUJXSZYLYLXVMVNVNYMWOZYCZAXVBXWFVNAXVBVXN
          WVEWYRYDZUQYEVXNWVPWVOYPYDZVGVLZUQYEZXWFAVXOWYSVXNXWOURUQVYGWVEWUOWVE
          WYRXHWUJWYAWVLAXVCWVNWYSYNVRXVDXVEWYSXVFYOYBUYSAVXNXWOXWQUQWVIXUJWVEV
          MVRXWOXWQXAAXUJWUTUAXPWVIIVMWVDLAVYMWUTUDXPAVYNWVKWVDIVRWUTWUBWUDVMIW
          UCNYQXEYLZKWYRWVEXUKUYTWLVUAAXWRVXNWVPUQYEZVXNXWPUQYEZVGVLXVKXVRYKVLZ
          XVNXWDYKVLZVGVLXWFAVXNWVPXWPUQWUJWVIWVPWUTAWVKWVPVNVRZWUDAWVKXCZWVOXU
          HVRZXXDXXEVMXUHWVEKAXWGWVKXWHXPZXXEIVMWVDLAVYMWVKUDXPZAVMIWUCNWUBUYEY
          LYLWVOVNVNUYRWOZYHYOZWVIXWPWVIXXFXWPVNVRWVIVMXUHWVEKAXWGWUTXWHXPXWSYL
          WVOVNVNYMWOYOZVUBAXWTXXBXXAXXCVGAXWTXVRXVKYKVLXXBAWVPXVKUQVDOAPWWQOWW
          TWXRXSZXXJWUCOXAZWVOXVJXGXXMWVEXVIKXXMWVDXVHLWUCONXHXIXIXIVUCAXVRXVKA
          XVRAXVQWVPUQAVDXVPWRZWUCXVQVRZAWVKXXDWUCXVPWMZXXIYHZYIZYOZAXVKXWKYOZV
          UDXFAXXAVDNYDZLYDZKYDZYPYDZVDVDYKVLZOVEVLZXWPUQYEZYKVLXXCAXWPXYDUQVDO
          XXLXXKWUCVDXAZWVOXYCYPXYHWVEXYBKXYHWVDXYALWUCVDNXHXIXIXIVUFAXYDXVNXYG
          XWDYKAXYCXVMYPAXYBXVLKAXYAFLAFNHMVDVMVTUKVYRUJVUEXIXIXIAXYGXYEVDVGVLZ
          XVPVEVLZWUOVDYKVLZNYDZLYDZKYDZYPYDZURYEZXWDAXWPXYOUQURVDXYEOVYRAVDVYR
          VUGAOXWIVUHZAWUCXYFVRWUTXWPYNVRAXYFVXNWUCVYQXYFVXNVPAWHVDOVUIVUJYJXXK
          YBWUCXYKXAZWVOXYNYPXYRWVEXYMKXYRWVDXYLLWUCXYKNXHXIXIXIVUKXYPXVQXYOURY
          EXWDXYJXVQXYOURXYIVDXVPVEVDYNVRZXYSXYIVDXAVULVULVDVDVUMUYNVUPVUNXVQXY
          OXWCURUQWUOWUCXAZXYNXWBYPXYTXYMXWAKXYTXYLXVTLXYTXYKXVSNWUOWUCVDYKVUOX
          IXIXIXIVUQVURVUSVUTXFVUTAXVKXVRXVNXWDXXTXXSAXVNXWMYOAXWDAXVQXWCUQXXNX
          XOAWVKXWCVNVRZXXPXXEXWBXUHVRYUAXXEVMXUHXWAKXXGXXEIVMXVTLXXHAVYNXVSVMV
          RXVTIVRZWVKWUBWUCVVAVMIXVSNYQXEZYLYLXWBVNVNYMWOYHZYIZYOVVBVVCVVCZXVGV
          VDAVXQXVOXUAXWNAEXVNXVKDRXWMXWKQAEVNVRZXVJYPYDEVAVBZEXVKVAVBZAEXVHVRZ
          YUGYUHYUIYRZAOVMVRZYUJAOPVRYULYUJXCWXRWWMYUJJOVMPWVSOXAWWLXVHEWVSONXH
          VVEULVVFXNXOAXVHIVRYUJYUKXJXWJACDEEGIKLXVHQRSTUAUBUCUDUEYSVVGYTVVHADV
          NVRZXVNDVAVBZDXVMXGYDVAVBZADFVRZYUMYUNYUOYRZUIAFIVRYUPYUQXJXWLACDEDGI
          KLFQRSTUAUBUCUDUEYSVVGYTVVIVVJVVNAYFXWEVKVBZXVOXWFVKVBAYURXWDXVRVKVBA
          XVQXWCWVPUQXXNYUDXXQAXXOXCZXWCWVPYUDXXQYUSXXDXWCWVPVAVBZWVPXWBXGYDVAV
          BZYUSWVPXVTVRZXXDYUTYVAYRZYUSWVPWVDMYDZXVTYUSWVPEVKVBZWVPEVVOZWVPYVDY
          USYVEYVFWVPXAAXXOWVKWUCPVRZXMZXCYVEYUSWVKYVHXXOWVKAXXPXDZYUSOWUCVKVBZ
          YVGYUSWUCOVAVBZYVJXMYUSWUCWAVRZVDWUCVKVBZYVKYUSXXOYVLYVMYVKYRZAXXOUXH
          YUSVYQOWAVRZXXOYVNXJWHAYVOXXOXYQXPWUCVDOVVKUWHYTVVHYUSWUCOYUSWUCYVIXL
          AWWKXXOWXSXPVVLYTYVGOWWPWUCVKUMWWRYVGWWPWUCVKVBWWTWUCPVDUWMUWNUWQVWDU
          WSABCDEFGHIJKLMNWUCPQRSTUAUBUCUDUEUFUGUHUIUJUKULVVMYBYVEWVPEVVPWOYUSW
          VDHVRZCUTZLYDZKYDZXGYDZEVKVBZYVTEVVOZYVQMYDZVRZCHVFZYVFYVDVRZAVYOWVKY
          VPXXOVYSXXPVMHWUCNYQXEAYWEXXOAYWDCHUHUWOXPYWDYWFCWVDHYVQWVDXAZYWBYVFY
          WCYVDYWGYWAYVEYVTEWVPEYWGYVTWVPEVKYWGYVSWVOXGYWGYVRWVEKYVQWVDLXHXIXIZ
          VVQYWHYWGEVVRVVSYVQWVDMXHVVTVWAUWCVVDXXOAWVKXVTYVDXAXXPAFNHMWUCVDVMVT
          UKVYRUJUGVWBYHVWCAXXOYUBYVBYVCXJXXOAWVKYUBXXPYUCYHACDEWVPGIKLXVTQRSTU
          AUBUCUDUEYSYBYTVVIVVNVWEAXVRXWDXXRYUEVWFVWNAXVOXWEXWNAXVRXWDXXRYUEYCV
          WGYTXTYUFVWHXPWYPWYQWYSVXOURWYPVDVXKWRAXUBXUDWYOXUNVWIZAXUBXUEWYOXUCX
          UDXUEXUMXOVWIWYPVXJWYQVRZUNVXOVFZVXOWYQVPAWYHVXPYWKAWYHXCZVXLYWJUNVXO
          YWLWYJXCZVXLVXJVXKVKVBZYWJYWMWYLWYMVXLYWNXBYWMVXJYWLVXOVMVXJAVXOVMVPW
          YHWUGXPYJZXLWYHWYMAWYJWYNXKVXJVXKVWJWLYWMVXJWWQVRVXKWAVRZYWJYWNXJYWMV
          XJVMWWQYWOVTVWKWYHYWPAWYJVXKVWLXKVXJVDVXKVWMWLVWOUXOVWPUNVXOWYQVXDXRV
          WQXTWYPWYTVXKGYDZVXSVKWYPWYTVXKYKWYRVDVWRZYDYWQWYPWYSURWYRVDVXKWYPXUB
          XCZWYSVVRWYPVXKVMWWQAWYHVXPXQZVTVWKYWSWYSYWIYOVWSVXKGYWRTVWTVXAWYPXUQ
          YWQVXRVRZYWQVXSVKVBAXUQWYOXVAXPWYPGVMVXBZWYHYXAAYXBWYOAXURYXBXUSVMXUF
          GVXEWOXPYWTVMVXKGVXCWLVXRYWQVXFWLVXGVXHVXI $.
      $}

      $( Lemma for ~ ovolicc2 .  (Contributed by Mario Carneiro,
         14-Jun-2014.) $)
      ovolicc2lem5 $p |- ( ph -> ( B - A ) <_ sup ( ran S , RR* , < ) ) $=
        ( vz vh vx vy vn vm cv wcel cmin co crn cxr clt csup cle cuni wrex cicc
        wbr rexrd lbicc2 syl3anc sseldd eluni2 sylib wa wf cfv c2nd cif wex cfn
        wral wss cioo ccom cpw cin elin simprd c0 wne crab eqsstri ssfi sylancl
        ssrab2 adantr cr cxp inss2 cn weq ineq1 neeq1d elrab2 simplbi ffvelrnda
        ffvelrn syl2an syldan sseldi xp2nd syl syl2anc simprbi adantl n0 simprr
        ifcl wb elicc2 mpbid simp1d adantrr simp2d c1st simpld wceq fvco3 sylan
        w3a sylan2 1st2nd2 fveq2d df-ov syl6eqr 3eqtr3d eleqtrd xp1st rexr expr
        cop exlimdv mpd breq2 inelcm sylanbrc fveq2 eqid elioo2 ltled mpbir3and
        simp3d letrd ifboth min2 simprl jca ex reximdv2 ralrimiva ac6sfi breq1d
        eleq2 eqidd ifbieq12d eleq12d cbvralv cseq ccnv adantlr simprrl simprrr
        csn rspccva simprlr simprll eleq2d cbvrabv ovolicc2lem4 anassrs syl5bir
        c1 expimpd rexlimddv ) ADUAUGZUHZEDUIUJFUKULUMUNUOUSZUAHADHUPZUHUVRUAHU
        QADEURUJZUVTDQADULUHEULUHDEUOUSZDUWAUHZADKUTAELUTMDEVAVBZVCUADHVDVEAUVQ
        HUHZUVRVFZVFZGGUBUGZVGZCUGZJVHZIVHZVIVHZEUOUSZUWMEVJZUWJUWHVHZUHZCGVMZV
        FZUBVKZUVSAUWTUWFAGVLUHZUWOUCUGZUHZUCGUQZCGVMUWTAHVLUHZGHVNUXAAHVOIVPZU
        KVQZUHZUXEAHUXGVLVRUHZUXHUXEVFPHUXGVLVSVEVTGBUGZUWAVRZWAWBZBHWCHTUXLBHW
        GWDHGWEWFAUXDCGAUWJGUHZVFZUXCUCHUQZUXDUXNUWOUVTUHUXOUXNUWAUVTUWOAUWAUVT
        VNZUXMQWHUXNUWOUWAUHZUWOWIUHZDUWOUOUSZUWOEUOUSZUXNUWMWIUHZEWIUHZUXRUXNU
        WLWIWIWJZUHZUYAUXNUOUYCVRZUYCUWLUOUYCWKAUXMUWKWLUHZUWLUYEUHAHWLJVGZUWJH
        UHZUYFUXMRUXMUYHUWJUWAVRZWAWBZUXLUYJBUWJHGBCWMUXKUYIWAUXJUWJUWAWNWOTWPZ
        WQZHWLUWJJWSWTZAWLUYEUWKIOWRXAXBZUWLWIWIXCZXDZAUYBUXMLWHZUWNUWMEWIXJXEU
        XNDUWMUOUSZUWBUXSUXNUDUGZUYIUHZUDVKZUYRUXNUYJVUAUXMUYJAUXMUYHUYJUYKXFXG
        UDUYIXHVEUXNUYTUYRUDAUXMUYTUYRAUXMUYTVFZVFZDUYSUWMADWIUHZVUBKWHZVUCUYSW
        IUHZDUYSUOUSZUYSEUOUSZVUCUYSUWAUHZVUFVUGVUHYBZVUCUYSUWJUHZVUIVUCUYTVUKV
        UIVFAUXMUYTXIUYSUWJUWAVSVEZVTVUCVUDUYBVUIVUJXKVUEAUYBVUBLWHDEUYSXLXEXMZ
        XNZVUCUYDUYAAUXMUYDUYTUYNXOZUYOXDZVUCVUFVUGVUHVUMXPVUCUYSUWMVUNVUPVUCVU
        FUWLXQVHZUYSUMUSZUYSUWMUMUSZVUCUYSVUQUWMVOUJZUHZVUFVURVUSYBZVUCUYSUWJVU
        TVUCVUKVUIVULXRVUCUWKUXFVHZUWLVOVHZUWJVUTAVUBUYFVVCVVDXSZAUXMUYFUYTUYMX
        OAWLUYEIVGZUYFVVEOWLUYEUWKVOIXTYAXAAUXMVVCUWJXSZUYTUXMAUYHVVGUYLSYCXOVU
        CVVDVUQUWMYMZVOVHVUTVUCUWLVVHVOVUCUYDUWLVVHXSVUOUWLWIWIYDXDYEVUQUWMVOYF
        YGYHYIVUCVUQWIUHZUYAVVAVVBXKZVUCUYDVVIVUOUWLWIWIYJXDVUPVVIVUQULUHUWMULU
        HVVJUYAVUQYKUWMYKVUQUWMUYSUUAWTXEXMUUDUUBUUEYLYNYOAUWBUXMMWHUWNUYRUWBUX
        SUWMEUWMUWODUOYPEUWODUOYPUUFXEUXNUYAUYBUXTUYPUYQUWMEUUGXEAUXQUXRUXSUXTY
        BXKZUXMAVUDUYBVVKKLDEUWOXLXEWHUUCZVCUCUWOHVDVEUXNUXCUXCUCHGUXNUXBHUHZUX
        CVFZUXBGUHZUXCVFUXNVVNVFZVVOUXCVVPVVMUXBUWAVRZWAWBZVVOUXNVVMUXCUUHVVPUX
        CUXQVVRUXNVVMUXCXIZUXNUXQVVNVVLWHUWOUXBUWAYQXEUXLVVRBUXBHGBUCWMUXKVVQWA
        UXJUXBUWAWNWOTWPYRVVSUUIUUJUUKYOUULUXCUWQCUCGGUBUXBUWPUWOUUOUUMXEWHUWGU
        WSUVSUBUWGUWIUWRUVSUWRUXBJVHZIVHZVIVHZEUOUSZVWBEVJZUXBUWHVHZUHZUCGVMZUW
        GUWIVFUVSVWFUWQUCCGUCCWMZVWDUWOVWEUWPVWHVWCUWNVWBEUWMEVWHVWBUWMEUOVWHVW
        AUWLVIVWHVVTUWKIUXBUWJJYSYEYEZUUNVWIVWHEUUPUUQUXBUWJUWHYSUURZUUSUWGUWIV
        WGUVSAUWFUWIVWGVFZUVSAUWFVWKVFZVFZBCDEUVQFGHUEIJUWHUWHXQVPWLUVQUVEWJUVN
        UUTZEUFUGZVWNVHZUHZUFWLWCZWIUMUVAUNZVWRAVUDVWLKWHAUYBVWLLWHAUWBVWLMWHNA
        VVFVWLOWHAUXIVWLPWHAUXPVWLQWHAUYGVWLRWHAUYHVVGVWLSUVBTAUWFUWIVWGUVCVWMV
        WGUXMUWQAUWFUWIVWGUVDVWFUWQUCUWJGVWJUVFYAAUWEUVRVWKUVGZVWMUWEUVQUWAVRZW
        AWBZUVQGUHAUWEUVRVWKUVHVWMUVRUWCVXBVWTAUWCVWLUWDWHDUVQUWAYQXEUXLVXBBUVQ
        HGBUAWMUXKVXAWAUXJUVQUWAWNWOTWPYRVWNYTVWQEUEUGZVWNVHZUHUFUEWLUFUEWMVWPV
        XDEVWOVXCVWNYSUVIUVJVWSYTUVKUVLYLUVMUVOYNYOUVP $.
    $}

    ovolicc2.m $e |- M = { y e. RR* |
        E. f e. ( ( <_ i^i ( RR X. RR ) ) ^m NN )
          ( ( A [,] B ) C_ U. ran ( (,) o. f ) /\
          y = sup ( ran seq 1 ( + , ( ( abs o. - ) o. f ) ) , RR* , < ) ) } $.
    $( The measure of a closed interval is upper bounded by its length.
       (Contributed by Mario Carneiro, 14-Jun-2014.) $)
    ovolicc2 $p |- ( ph -> ( B - A ) <_ ( vol* ` ( A [,] B ) ) ) $=
      ( cxr cle cv wcel cioo wss wceq wa cr cn vz vv vu vg vt vk vx cmin co clt
      ccnv csup cicc covol cfv wbr wral ccom crn cuni cabs c1 cseq cxp cin cmap
      caddc wrex elovolm wi cpw cfn ctg wf wfn ioof ax-mp dffn3 mpbi simpr reex
      ffn xpex inex2 nnex elmap sylib inss2 ressxr xpss12 mp2an fss sylancl fco
      sstri sylancr adantrr frn syl ctb retopbas bastg syl6ss fvex elpw2 sylibr
      crest ccmp eqid icccmp syl2anc ctop wb retop uniretop cmpsub mpbid adantr
      iccssre simprr unieq sseq2d ineq1d rexeqdv imbi12d rspcv syl3c wex simprl
      pweq elin simprd simpld elpwid ralrimiv fveq2 crab ad2antrr expr mpd wne
      sseld fvelrnb sylibd eqeq1d ac6sfi simprll simprlr simprrl simprrr fveq2d
      c0 eqeq12d rspccva sylan ovolicc2lem5 exlimdv rexlimdvaa breq2 syl5ibrcom
      id imp3a rexlimdva syl5bi ssrab2 eqsstri resubcld rexrd infmxrgelb mpbird
      ovolval breqtrrd ) ADCUHUIZFKUJUKULZCDUMUIZUNUOZLAUVMUVNLUPZUVMUAMZLUPZUA
      FUQZAUVSUAFUVRFNUVOOEMZURZUSZUTZPZUVRVGVAUHURUWAURVBVCZUSKUJULZQZRZELSSVD
      ZVEZTVFUIZVHAUVSBUVOUVREFJVIAUWIUVSEUWLAUWAUWLNZRZUWEUWHUVSAUWMUWEUWHUVSV
      JAUWMUWERZRZUVSUWHUVMUWGLUPZUWPUVOUBMZUTPZUBUWCVKZVLVEZVHZUWQUWPUWCOUSZVM
      UOZVKZNZUVOUCMZUTZPZUWSUBUXGVKZVLVEZVHZVJZUCUXEUQZUWEUXBUWPUWCUXDPUXFUWPU
      WCUXCUXDUWPTUXCUWBVNZUWCUXCPAUWMUXOUWEUWNKKVDZUXCOVNZTUXPUWAVNZUXOOUXPVOZ
      UXQUXPSVKZOVNUXSVPUXPUXTOWBVQUXPOVRVSUWNTUWKUWAVNZUWKUXPPUXRUWNUWMUYAAUWM
      VTUWKTUWAUWJLSSWAWAWCWDWEWFWGZUWKUWJUXPLUWJWHSKPZUYCUWJUXPPWIWISKSKWJWKWO
      TUWKUXPUWAWLWMTUXPUXCOUWAWNWPZWQTUXCUWBWRWSUXCWTNUXCUXDPXAUXCWTXBVQXCUWCU
      XDUXCVMXDXEXFAUXNUWOAUXDUVOXGUIZXHNZUXNACSNZDSNZUYFGHCDUYEUXDUXDXIUYEXIXJ
      XKAUXDXLNUVOSPZUYFUXNXMXNAUYGUYHUYIGHCDXSXKZUVOUXDSUCUBXOXPWPXQXRAUWMUWEX
      TUXMUWEUXBVJUCUWCUXEUXGUWCQZUXIUWEUXLUXBUYKUXHUWDUVOUXGUWCYAYBUYKUWSUBUXK
      UXAUYKUXJUWTVLUXGUWCYJYCYDYEYFYGAUWMUXBUWQVJUWEUWNUWSUWQUBUXAUWNUWRUXANZU
      WSRZRZUWRTUDMZVNZUEMZUYOUOZUWBUOZUYQQZUEUWRUQZRZUDYHZUWQUYNUWRVLNZUFMZUWB
      UOZUYQQZUFTVHZUEUWRUQVUCUYNUWRUWTNZVUDUYNUYLVUIVUDRUWNUYLUWSYIUWRUWTVLYKW
      GZYLUYNVUHUEUWRUYNUYQUWRNUYQUWCNZVUHUYNUWRUWCUYQUYNUWRUWCUYNVUIVUDVUJYMYN
      UUBUYNUWBTVOZVUKVUHXMUWNVULUYMUWNUXOVULUYDTUXCUWBWBWSXRUFTUYQUWBUUCWSUUDY
      OVUGUYTUEUFUWRTUDVUEUYRQVUFUYSUYQVUEUYRUWBYPUUEUUFXKUYNVUBUWQUDUWNUYMVUBU
      WQUWNUYMVUBRZRZUCUGCDUWFUXGUVOVEUULUUAUCUWRYQZUWRUWAUYOAUYGUWMVUMGYRAUYHU
      WMVUMHYRACDLUPUWMVUMIYRUWFXIUWNUYAVUMUYBXRUWNUYLUWSVUBUUGUWNUYLUWSVUBUUHU
      WNUYMUYPVUAUUIVUNVUAUGMZUWRNVUPUYOUOZUWBUOZVUPQZUWNUYMUYPVUAUUJUYTVUSUEVU
      PUWRUYQVUPQZUYSVURUYQVUPVUTUYRVUQUWBUYQVUPUYOYPUUKVUTUVAUUMUUNUUOVUOXIUUP
      YSUUQYTUURWQYTUVRUWGUVMLUUSUUTYSUVBUVCUVDYOAFKPUVMKNUVQUVTXMFUWEBMUWGQREU
      WLVHZBKYQKJVVABKUVEUVFAUVMADCHGUVGUVHUAFUVMUVIWPUVJAUYIUVPUVNQUYJBUVOEFJU
      VKWSUVL $.
  $}

  ${
    $d f m n y z A $.  $d f m n y z B $.
    $( The measure of a closed interval.  (Contributed by Mario Carneiro,
       14-Jun-2014.) $)
    ovolicc $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                    ( vol* ` ( A [,] B ) ) = ( B - A ) ) $=
      ( vn vm vy vf vz cr wcel cle wbr co cmin wceq cn cv c1 ccom cxr wa anbi2d
      w3a cicc covol cfv cop cc0 cif cmpt simp1 simp2 simp3 eqeq1 ifbid cbvmptv
      ovolicc1 cioo crn cuni wss caddc cabs cseq clt csup cxp cmap wrex rexbidv
      cin crab cbvrabv ovolicc2 wb iccssre syl2anc ovolcl syl resubcld xrletri3
      rexrd mpbir2and ) AHIZBHIZABJKZUBZABUCLZUDUEZBAMLZNZWHWIJKZWIWHJKZWFABCDO
      DPZQNZABUFZUGUGUFZUHZUIWCWDWEUJZWCWDWEUKZWCWDWEULZDCOWQCPZQNZWOWPUHWMXANW
      NXBWOWPWMXAQUMUNUOUPWFEABFWGUQFPZRURUSUTZGPZVAVBMRXCRQVCURSVDVEZNZTZFJHHV
      FVJOVGLZVHZGSVKWRWSWTXJXDEPZXFNZTZFXIVHGESXEXKNZXHXMFXIXNXGXLXDXEXKXFUMUA
      VIVLVMWFWHSIZWISIWJWKWLTVNWFWGHUTZXOWFWCWDXPWRWSABVOVPWGVQVRWFWIWFBAWSWRV
      SWAWHWIVTVPWB $.
  $}

  ${
    $d x A $.
    $( The measure of a right-unbounded interval.  (Contributed by Mario
       Carneiro, 14-Jun-2014.) $)
    ovolicopnf $p |- ( A e. RR -> ( vol* ` ( A [,) +oo ) ) = +oo ) $=
      ( vx cr wcel cpnf co covol cfv wceq clt wbr wn caddc cmnf cc0 cle cxr syl
      wa wb c1 wss pnfxr icossre mpan2 adantr ovolge0 0re mnflt ax-mp wi ovolcl
      cico mnfxr 0xr xrltletr mp3an12 mpani mpd simpr mpbir2and ltp1d cicc cmin
      xrrebnd simpl peano2re readdcld lep1d letrd addge02d mpbid ovolicc pncand
      a1i syl3anc recnd eqtrd cv elicc2 syl2anc biimpa simp1d elicopnf ad2antrr
      w3a simp2d ex ssrdv ovolss eqbrtrrd lenltd pm2.65da nltpnft mpbird ) ACDZ
      AEUMFZGHZEIZWREJKZLZWPWTWRWRUAMFZJKZWPWTSZWRXDWRCDZNWRJKZWTXDOWRPKZXFXDWQ
      CUBZXGWPXHWTWPEQDXHUCAEUDUEZUFZWQUGRZXDNOJKZXGXFOCDZXLUHOUIUJXDWRQDZXLXGS
      XFUKZWPXNWTWPXHXNXIWQULRZUFZNQDOQDXNXOUNUONOWRUPUQRURUSWPWTUTXDXNXEXFWTST
      XQWRVERVAZVBXDXBWRPKXCLXDAXBAMFZVCFZGHZXBWRPXDYAXSAVDFZXBXDWPXSCDZAXSPKZY
      AYBIWPWTVFZXDXBAXDXEXBCDXRWRVGRZYEVHZXDOXBPKYDXDOWRXBXMXDUHVOXRYFXKXDWRXR
      VIVJXDAXBYEYFVKVLAXSVMVPXDXBAXDXBYFVQXDAYEVQVNVRXDXTWQUBXHYAWRPKXDBXTWQXD
      BVSZXTDZYHWQDZXDYISZYJYHCDZAYHPKZYKYLYMYHXSPKZXDYIYLYMYNWFZXDWPYCYIYOTYEY
      GAXSYHVTWAWBZWCYKYLYMYNYPWGWPYJYLYMSTWTYIAYHWDWEVAWHWIXJXTWQWJWAWKXDXBWRY
      FXRWLVLWMWPXNWSXATXPWRWNRWO $.
  $}

  $( The measure of the real numbers.  (Contributed by Mario Carneiro,
     14-Jun-2014.) $)
  ovolre $p |- ( vol* ` RR ) = +oo $=
    ( covol cfv cpnf wceq cle wbr cxr wcel wss ssid ovolcl ax-mp pnfge cc0 cico
    cr co 0re pnfxr mp2an ovolicopnf icossre ovolss eqbrtrri xrletri3 mpbir2an
    wa wb ) PABZCDZUICEFZCUIEFZUIGHZUKPPIZUMPJZPKLZUIMLNCOQZABZCUIENPHZURCDRNUA
    LUQPIZUNURUIEFUSCGHZUTRSNCUBTUOUQPUCTUDUMVAUJUKULUGUHUPSUICUETUF $.

  ${
    $d x y A $.  $d x B $.
    $( The predicate " ` A ` is Lebesgue-measurable".  A set is measurable if
       it splits every other set ` x ` in a "nice" way, that is, if the measure
       of the pieces ` x i^i A ` and ` x \ A ` sum up to the measure of ` x `
       (assuming that the measure of ` x ` is a real number, so that this
       addition makes sense).  (Contributed by Mario Carneiro, 17-Mar-2014.) $)
    ismbl $p |- ( A e. dom vol <->
                  ( A C_ RR /\ A. x e. ~P RR ( ( vol* ` x ) e. RR ->
      ( vol* ` x ) = ( ( vol* ` ( x i^i A ) ) + ( vol* ` ( x \ A ) ) ) ) ) ) $=
      ( vy cvol cdm wcel cr cv covol cfv cin cdif caddc co wceq wa fveq2d ovolf
      wral wi cpw ccnv cima wss ineq2 difeq2 oveq12d eqeq2d ralbidv crab df-vol
      cab cres dmeqi cc0 cpnf cicc fdmi ineq2i 3eqtri dfrab2 eqtr4i elrab2 reex
      dmres elpw2 wf wfn ffn elpreima mp2b imbi1i impexp bitri ralbii2 anbi12i
      wb ) BDEZFBGUAZFZAHZIJZWABKZIJZWABLZIJZMNZOZAIUBGUCZSZPBGUDZWBGFZWHTZAVSS
      ZPWBWACHZKZIJZWAWOLZIJZMNZOZAWISZWJCBVSVRWOBOZXAWHAWIXCWTWGWBXCWQWDWSWFMX
      CWPWCIWOBWAUEQXCWRWEIWOBWAUFQUGUHUIVRXBCULZVSKZXBCVSUJVRIXDUMZEXDIEZKXEDX
      FCAUKUNIXDVEXGVSXDVSUOUPUQNZIRURUSUTXBCVSVAVBVCVTWKWJWNBGVDVFWHWMAWIVSWAW
      IFZWHTWAVSFZWLPZWHTXJWMTXIXKWHVSXHIVGIVSVHXIXKVQRVSXHIVIVSWAGIVJVKVLXJWLW
      HVMVNVOVPVN $.

    $( From ~ ovolun , it suffices to show that the measure of ` x ` is at
       least the sum of the measures of ` x i^i A ` and ` x \ A ` .
       (Contributed by Mario Carneiro, 15-Jun-2014.) $)
    ismbl2 $p |- ( A e. dom vol <->
                  ( A C_ RR /\ A. x e. ~P RR ( ( vol* ` x ) e. RR ->
     ( ( vol* ` ( x i^i A ) ) + ( vol* ` ( x \ A ) ) ) <_ ( vol* ` x ) ) ) ) $=
      ( cvol cdm wcel cr wss cv covol cfv wi wral wa cle wbr wb ovolsscl mp3an1
      adantl syl5ss cin cdif caddc co wceq cpw ismbl elpwi inss1 difss readdcld
      simprr letri3d cun inundif fveq2i simprl ovolun syl22anc syl5eqbrr bitr4d
      biantrurd expr pm5.74d sylan2 ralbidva pm5.32i bitri ) BCDEBFGZAHZIJZFEZV
      KVJBUAZIJZVJBUBZIJZUCUDZUEZKZAFUFZLZMVIVLVQVKNOZKZAVTLZMABUGVIWAWDVIVSWCA
      VTVJVTEVIVJFGZVSWCPVJFUHVIWEMVLVRWBVIWEVLVRWBPVIWEVLMZMZVRVKVQNOZWBMWBWGV
      KVQVIWEVLULWGVNVPWFVNFEZVIVMVJGWEVLWIVJBUIZVMVJQRSZWFVPFEZVIVOVJGWEVLWLVJ
      BUJZVOVJQRSZUKUMWGWHWBWGVKVMVOUNZIJZVQNWOVJIVJBUOUPWGVMFGWIVOFGWLWPVQNOWG
      VMVJFWJVIWEVLUQZTWKWGVOVJFWMWQTWNVMVOURUSUTVBVAVCVDVEVFVGVH $.

    $( A self-referencing abbreviated definition of the Lebesgue measure.
       (Contributed by Mario Carneiro, 19-Mar-2014.) $)
    volres $p |- vol = ( vol* |` dom vol ) $=
      ( vy vx covol cv cfv cin cdif caddc wceq ccnv cima wral cab cres cdm cvol
      co cr resdmres df-vol dmeqi reseq2i 3eqtr4ri ) CCADZCEUDBDZFCEUDUEGCEHQIA
      CJRKLBMZNZOZNUGCPOZNPCUFSUIUHCPUGBATZUAUBUJUC $.

    $( The domain and range of the Lebesgue measure function.  (Contributed by
       Mario Carneiro, 19-Mar-2014.) $)
    volf $p |- vol : dom vol --> ( 0 [,] +oo ) $=
      ( cvol cdm cc0 cpnf cicc co wf cr cpw wss wfun wa covol cres ovolf funres
      cxp ffun mp2b volres funeqi mpbir resss eqsstri fssxp ax-mp sstri funssxp
      pm3.2i mpbi simpli ) ABZCDEFZAGZULHIZJZAKZAUOUMQZJZLUNUPLUQUSUQMULNZKZUOU
      MMGZMKVAOUOUMMRULMPSAUTTUAUBAMURAUTMTMULUCUDVBMURJOUOUMMUEUFUGUIUOUMAUHUJ
      UK $.

    $( The volume of a measurable set is the same as its outer volume.
       (Contributed by Mario Carneiro, 17-Mar-2014.) $)
    mblvol $p |- ( A e. dom vol -> ( vol ` A ) = ( vol* ` A ) ) $=
      ( cvol cdm wcel cfv covol cres volres fveq1i fvres syl5eq ) ABCZDABEAFLGZ
      EAFEABMHIALFJK $.

    $( A measurable set is a subset of the reals.  (Contributed by Mario
       Carneiro, 17-Mar-2014.) $)
    mblss $p |- ( A e. dom vol -> A C_ RR ) $=
      ( vx cvol cdm wcel cr wss cv covol cfv cin cdif caddc co wceq wi cpw wral
      ismbl simplbi ) ACDEAFGBHZIJZFEUBUAAKIJUAALIJMNOPBFQRBAST $.

    $( The defining property of measurability.  (Contributed by Mario Carneiro,
       17-Mar-2014.) $)
    mblsplit $p |- ( ( A e. dom vol /\ B C_ RR /\ ( vol* ` B ) e. RR ) ->
        ( vol* ` B ) = ( ( vol* ` ( B i^i A ) ) + ( vol* ` ( B \ A ) ) ) ) $=
      ( vx cvol cdm wcel cr wss covol cfv cin cdif caddc co wceq cpw reex elpw2
      wi fveq2d cv wral ismbl simprbi fveq2 eleq1d ineq1 difeq1 oveq12d eqeq12d
      imbi12d rspccv syl syl5bir 3imp ) ADEFZBGHZBIJZGFZURBAKZIJZBALZIJZMNZOZUQ
      BGPZFZUPUSVESZBGQRUPCUAZIJZGFZVJVIAKZIJZVIALZIJZMNZOZSZCVFUBZVGVHSUPAGHVS
      CAUCUDVRVHCBVFVIBOZVKUSVQVEVTVJURGVIBIUEZUFVTVJURVPVDWAVTVMVAVOVCMVTVLUTI
      VIBAUGTVTVNVBIVIBAUHTUIUJUKULUMUNUO $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( The complement of a measurable set is measurable.  (Contributed by Mario
       Carneiro, 18-Mar-2014.) $)
    cmmbl $p |- ( A e. dom vol -> ( RR \ A ) e. dom vol ) $=
      ( vx cvol cdm wcel cr cdif wss covol cfv cin caddc co wceq mp3an1 3adant1
      ovolsscl recnd syl5eqr fveq2d cv wi cpw wral difssd elpwi w3a inss1 difss
      addcomd mblsplit indifcom simp2 sseqin2 sylib difin difeq2d dfin4 syl6eqr
      ssdifssd oveq12d 3eqtr4d 3expia sylan2 ralrimiva ismbl sylanbrc ) ACDZEZF
      AGZFHBUAZIJZFEZVLVKVJKZIJZVKVJGZIJZLMZNZUBZBFUCZUDVJVHEVIFAUEVIVTBWAVKWAE
      VIVKFHZVTVKFUFVIWBVMVSVIWBVMUGZVKAKZIJZVKAGZIJZLMWGWELMVLVRWCWEWGWCWEWBVM
      WEFEZVIWDVKHWBVMWHVKAUHWDVKQOPRWCWGWBVMWGFEZVIWFVKHWBVMWIVKAUIWFVKQOPRUJA
      VKUKWCVOWGVQWELWCVNWFIWCVNFWFKZWFFVKAULWCWFFHWJWFNWCVKFAVIWBVMUMUTWFFUNUO
      SZTWCVPWDIWCVPVKWFGZWDWCVPVKVNGWLVKVJUPWCVNWFVKWKUQSVKAURUSTVAVBVCVDVEBVJ
      VFVG $.

    $( A nullset is measurable.  (Contributed by Mario Carneiro,
       18-Mar-2014.) $)
    nulmbl $p |- ( ( A C_ RR /\ ( vol* ` A ) = 0 ) -> A e. dom vol ) $=
      ( vx cr wss covol cfv cc0 wceq wa cv wcel cin cdif caddc co cle wi mp3an1
      wbr cpw wral cdm simpl elpwi inss2 ovolssnul adantr oveq1d difss ovolsscl
      cvol adantl recnd addid2d eqtrd simprl ovolss sylancr eqbrtrd expr sylan2
      ralrimiva ismbl2 sylanbrc ) ACDZAEFGHZIZVEBJZEFZCKZVHALZEFZVHAMZEFZNOZVIP
      SZQZBCTZUAAUKUBKVEVFUCVGVQBVRVHVRKVGVHCDZVQVHCUDVGVSVJVPVGVSVJIZIZVOVNVIP
      WAVOGVNNOVNWAVLGVNNVGVLGHZVTVKADVEVFWBVHAUEVKAUFRUGUHWAVNWAVNVTVNCKZVGVMV
      HDZVSVJWCVHAUIZVMVHUJRULUMUNUOWAWDVSVNVIPSWEVGVSVJUPVMVHUQURUSUTVAVBBAVCV
      D $.

    $( A set of outer measure zero is measurable.  The term "outer measure
       zero" here is slightly different from "nullset/negligible set"; a
       nullset has ` vol* ( A ) = 0 ` while "outer measure zero" means that for
       any ` x ` there is a ` y ` containing ` A ` with volume less than
       ` x ` .  Assuming AC, these notions are equivalent (because the
       intersection of all such ` y ` is a nullset) but in ZF this is a
       strictly weaker notion.  Proposition 563Gb of [Fremlin5] p. 193.
       (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    nulmbl2 $p |- ( A. x e. RR+ E. y e. dom vol ( A C_ y /\ ( vol* ` y ) <_ x )
      -> A e. dom vol ) $=
      ( vz wss covol cfv cle wbr wa crp cr wcel cdif caddc co ovolsscl ad2antrr
      syl3anc cun cv cvol cdm wrex wral cin wi cpw c0 wne 1rp ne0i ax-mp r19.2z
      c1 mpan simprl mblss adantr sstrd rexlimiva rexlimivw syl inss1 a1i elpwi
      simpr difssd readdcld adantl rpre ad2antlr simprrr ovollecl simprrl sslin
      syl5ss ovolss syl2anc ssdifssd unssd ovolun syl22anc ssun1 sseqtr4i ssdif
      undif1 difundir sseqtri difun1 wceq ssequn2 sylib difeq2d uneq1d syl5sseq
      syl5eqr letrd le2addd mblsplit recnd addassd eqtrd breqtrrd difss sylancr
      oveq1d leadd2dd rexlimdvaa ralimdva impcom cxr rexrd simprr xralrple expr
      wb mpbird ralrimiva ismbl2 sylanbrc ) CBUAZEZYBFGZAUAZHIZJZBUBUCZUDZAKUEZ
      CLEZDUAZFGZLMZYLCUFZFGZYLCNZFGZOPZYMHIZUGZDLUHZUECYHMYJYIAKUDZYKKUIUJZYJU
      UCUOKMUUDUKKUOULUMYIAKUNUPYIYKAKYGYKBYHYBYHMZYGJZCYBLUUEYCYFUQUUEYBLEZYGY
      BURUSZUTVAVBVCYJUUADUUBYJYLUUBMZYNYTYJUUIYNJZJZYTYSYMYEOPZHIZAKUEZUUJYJUU
      NUUJYIUUMAKUUJYEKMZJZYGUUMBYHUUPUUFJZYSYMYBCNZFGZOPZUULUUJYSLMZUUOUUFUUJY
      PYRUUJYOYLEZYLLEZYNYPLMZUVBUUJYLCVDVEUUIUVCYNYLLVFUSZUUIYNVGZYOYLQSZUUJYQ
      YLEUVCYNYRLMZUUJYLCVHUVEUVFYQYLQSZVIZRUUQYMUUSUUJYNUUOUUFUVFRZUUQUURYBEZU
      UGYDLMZUUSLMZUUQYBCVHUUFUUGUUPUUHVJZUUQUUGYELMZYFUVMUVOUUOUVPUUJUUFYEVKVL
      ZUUPUUEYCYFVMZYBYEVNSZUURYBQSZVIUUQYMYEUVKUVQVIUUQYSYLYBUFZFGZYLYBNZFGZUU
      SOPZOPZUUTHUUQYPYRUWBUWEUUJUVDUUOUUFUVGRUUJUVHUUOUUFUVIRZUUQUWAYLEZUVCYNU
      WBLMUWHUUQYLYBVDZVEUUJUVCUUOUUFUVERZUVKUWAYLQSZUUQUWDUUSUUQUWCYLEUVCYNUWD
      LMZUUQYLYBVHUWJUVKUWCYLQSZUVTVIZUUQYOUWAEZUWALEYPUWBHIUUQYCUWOUUPUUEYCYFV
      OZCYBYLVPVCUUQUWAYLLUWIUWJVQYOUWAVRVSUUQYRUWCUURTZFGZUWEUWGUUQUWQLEZUWELM
      UWRUWEHIZUWRLMUUQUWCUURLUUQYLLYBUWJVTZUUQYBLCUVOVTZWAZUWNUUQUWCLEUWLUURLE
      UVNUWTUXAUWMUXBUVTUWCUURWBWCZUWQUWEVNSUWNUUQYQUWQEUWSYRUWRHIUUQUWCCNZUURT
      ZYQUWQYQUWCYBTZCNZUXFYLUXGEYQUXHEYLYLYBTUXGYLYBWDYLYBWGWEYLUXGCWFUMUWCYBC
      WHWIUUQUXEUWCUURUUQUXEYLYBCTZNUWCYLYBCWJUUQUXIYBYLUUQYCUXIYBWKUWPCYBWLWMW
      NWQWOWPUXCYQUWQVRVSUXDWRWSUUQUUTUWBUWDOPZUUSOPUWFUUQYMUXJUUSOUUQUUEUVCYNY
      MUXJWKUUPUUEYGUQUWJUVKYBYLWTSXGUUQUWBUWDUUSUUQUWBUWKXAUUQUWDUWMXAUUQUUSUV
      TXAXBXCXDUUQUUSYEYMUVTUVQUVKUUQUUSYDYEUVTUVSUVQUUQUVLUUGUUSYDHIYBCXEUVOUU
      RYBVRXFUVRWRXHWRXIXJXKUUKYSXLMYNYTUUNXQUUKYSUUJUVAYJUVJVJXMYJUUIYNXNAYSYM
      XOVSXRXPXSDCXTYA $.

    $( A union of measurable sets is measurable.  (Contributed by Mario
       Carneiro, 18-Mar-2014.) $)
    unmbl $p |- ( ( A e. dom vol /\ B e. dom vol ) ->
                  ( A u. B ) e. dom vol ) $=
      ( vx wcel wa cun cr wss covol cfv cin cdif caddc co inss1 ovolsscl mp3an1
      cle adantl syl5ss cvol cdm cv wbr cpw wral mblss anim12i unss sylib elpwi
      wi difss simprl syl2anc readdcld incom indifcom uneq2i indi undif2 ineq2i
      3eqtr2ri fveq2i ovolun syl22anc syl5eqbr leadd1dd simplr mblsplit syl3anc
      eqtri difun1 oveq2i syl6eqr oveq2d simpll simprr addassd 3eqtr4d breqtrrd
      wceq recnd expr sylan2 ralrimiva ismbl2 sylanbrc ) AUAUBZDZBWIDZEZABFZGHZ
      CUCZIJZGDZWOWMKZIJZWOWMLZIJZMNZWPRUDZULZCGUEZUFWMWIDWLAGHZBGHZEWNWJXFWKXG
      AUGBUGUHABGUIUJWLXDCXEWOXEDWLWOGHZXDWOGUKWLXHWQXCWLXHWQEZEZXBWOAKZIJZWOAL
      ZBKZIJZMNZXAMNZWPRXJWSXPXAXIWSGDZWLWRWOHXHWQXRWOWMOWRWOPQSXJXLXOXIXLGDZWL
      XKWOHXHWQXSWOAOZXKWOPQSZXJXMGHZXMIJZGDZXOGDZXJXMWOGWOAUMZWLXHWQUNZTZXIYDW
      LXMWOHXHWQYDYFXMWOPQSZXNXMHYBYDYEXMBOZXNXMPQUOZUPXIXAGDZWLWTWOHXHWQYLWOWM
      UMWTWOPQSZXJWSXKXNFZIJZXPRWRYNIYNXKWOBALZKZFWOAYPFZKWRXNYQXKXNBXMKYQXMBUQ
      BWOAURVLUSWOAYPUTYRWMWOABVAVBVCVDXJXKGHXSXNGHYEYOXPRUDXJXKWOGXTYGTYAXJXNX
      MGYJYHTYKXKXNVEVFVGVHXJXLYCMNZXLXOXAMNZMNWPXQXJYCYTXLMXJYCXOXMBLZIJZMNZYT
      XJWKYBYDYCUUCWBWJWKXIVIYHYIBXMVJVKXAUUBXOMWTUUAIWOABVMVDVNVOVPXJWJXHWQWPY
      SWBWJWKXIVQYGWLXHWQVRAWOVJVKXJXLXOXAXJXLYAWCXJXOYKWCXJXAYMWCVSVTWAWDWEWFC
      WMWGWH $.

    $( A shift of a measurable set is measurable.  (Contributed by Mario
       Carneiro, 22-Mar-2014.) $)
    shftmbl $p |- ( ( A e. dom vol /\ B e. RR ) ->
                  { x e. RR | ( x - B ) e. A } e. dom vol ) $=
      ( vy vz wcel cr wa cv cmin crab wss covol cfv cin cdif caddc a1i ovolshft
      co cvol cdm wceq cpw wral ssrab2 elpwi cneg simpll simprl simplr renegcld
      wi eqidd simprr eqeltrrd mblsplit syl3anc inss1 syl5ss mblss syl shft2rab
      ineq2d inrab wb elin rabbiia eqtr4i syl6eq ssdifssd difeq2d eldif oveq12d
      wn difrab 3eqtr4d expr sylan2 ralrimiva ismbl sylanbrc ) BUAUBZFZCGFZHZAI
      CJTBFZAGKZGLZDIZMNZGFZWKWJWHOZMNZWJWHPZMNZQTZUCZUMZDGUDZUEWHWCFWIWFWGAGUF
      RWFWSDWTWJWTFWFWJGLZWSWJGUGWFXAWLWRWFXAWLHZHZEIZCUHZJTZWJFZEGKZMNZXHBOZMN
      ZXHBPZMNZQTZWKWQXCWDXHGLZXIGFXIXNUCWDWEXBUIZXOXCXGEGUFRXCWKXIGXCEWJXHXEWF
      XAWLUJZXCCWDWEXBUKZULZXCXHUNSZWFXAWLUOUPBXHUQURXTXCWNXKWPXMQXCEWMXJXEXCWM
      WJGWJWHUSXQUTXSXCXJXHXFWHFZEGKZOZXFWMFZEGKZXCBYBXHXCAEBWHCXCWDBGLXPBVAVBX
      RXCWHUNVCZVDYCXGYAHZEGKYEXGYAEGVEYDYGEGYDYGVFXDGFZXFWJWHVGRVHVIVJSXCEWOXL
      XEXCWJGWHXQVKXSXCXLXHYBPZXFWOFZEGKZXCBYBXHYFVLYIXGYAVOHZEGKYKXGYAEGVPYJYL
      EGYJYLVFYHXFWJWHVMRVHVIVJSVNVQVRVSVTDWHWAWB $.
  $}

  $( The empty set is measurable.  (Contributed by Mario Carneiro,
     18-Mar-2014.) $)
  0mbl $p |- (/) e. dom vol $=
    ( c0 cr wss covol cfv cc0 wceq cvol cdm wcel 0ss ovol0 nulmbl mp2an ) ABCAD
    EFGAHIJBKLAMN $.

  $( The set of all real numbers is measurable.  (Contributed by Mario
     Carneiro, 18-Mar-2014.) $)
  rembl $p |- RR e. dom vol $=
    ( cr c0 cdif cvol cdm dif0 wcel 0mbl cmmbl ax-mp eqeltrri ) ABCZADEZAFBMGLM
    GHBIJK $.

  $( An intersection of measurable sets is measurable.  (Contributed by Mario
     Carneiro, 18-Mar-2014.) $)
  inmbl $p |- ( ( A e. dom vol /\ B e. dom vol ) -> ( A i^i B ) e. dom vol ) $=
    ( cvol cdm wcel wa cr cdif cun cin difundi wceq mblss dfss4 sylib ineqan12d
    wss syl5eq cmmbl unmbl syl2an syl eqeltrrd ) ACDZEZBUDEZFZGGAHZGBHZIZHZABJZ
    UDUGUKGUHHZGUIHZJULGUHUIKUEUFUMAUNBUEAGQUMALAMAGNOUFBGQUNBLBMBGNOPRUGUJUDEZ
    UKUDEUEUHUDEUIUDEUOUFASBSUHUITUAUJSUBUC $.

  $( A difference of measurable sets is measurable.  (Contributed by Mario
     Carneiro, 18-Mar-2014.) $)
  difmbl $p |- ( ( A e. dom vol /\ B e. dom vol ) -> ( A \ B ) e. dom vol ) $=
    ( cvol cdm wcel wa cr cdif cin wceq indif2 mblss df-ss sylib difeq1d syl5eq
    wss adantr cmmbl inmbl sylan2 eqeltrrd ) ACDZEZBUCEZFAGBHZIZABHZUCUDUGUHJUE
    UDUGAGIZBHUHAGBKUDUIABUDAGQUIAJALAGMNOPRUEUDUFUCEUGUCEBSAUFTUAUB $.

  ${
    $d k x y z A $.  $d x y z B $.
    $( A finite union of measurable sets is measurable.  (Contributed by Mario
       Carneiro, 20-Mar-2014.) $)
    finiunmbl $p |- ( ( A e. Fin /\ A. k e. A B e. dom vol ) ->
                      U_ k e. A B e. dom vol ) $=
      ( vy vx vz cfn wcel wral ciun cv wi c0 cun wceq iuneq1 eleq1d imbi12d weq
      raleq cvol cdm csn 0iun 0mbl eqeltri a1i wss ssun1 ssralv ax-mp imim1i wa
      ssun2 iunxun csb vex csbeq1 ralsn nfv nfcsb1v nfel1 csbeq1a cbvral cbviun
      nfcv iunxsn eqtri eleq1i 3bitr4i unmbl sylan2b syl5eqel expcom syl sylcom
      findcard2 imp ) AGHBUAUBZHZCAIZCABJZVSHZVTCDKZIZCWDBJZVSHZLVTCMIZCMBJZVSH
      ZLVTCEKZIZCWKBJZVSHZLZVTCWKFKZUCZNZIZCWRBJZVSHZLZWAWCLDEFAWDMOZWEWHWGWJVT
      CWDMTXCWFWIVSCWDMBPQRDESZWEWLWGWNVTCWDWKTXDWFWMVSCWDWKBPQRWDWROZWEWSWGXAV
      TCWDWRTXEWFWTVSCWDWRBPQRWDAOZWEWAWGWCVTCWDATXFWFWBVSCWDABPQRWJWHWIMVSCBUD
      UEUFUGWOXBLWKGHWOWSWNXAWSWLWNWKWRUHWSWLLWKWQUIVTCWKWRUJUKULWSVTCWQIZWNXAL
      WQWRUHWSXGLWQWKUNVTCWQWRUJUKWNXGXAWNXGUMWTWMCWQBJZNZVSCWKWQBUOXGWNXHVSHZX
      IVSHCWKBUPZVSHZEWQICWPBUPZVSHZXGXJXLXNEWPFUQZEFSXKXMVSCWKWPBURZQUSVTXLCEW
      QVTEUTCXKVSCWKBVAZVBCESBXKVSCWKBVCZQVDXHXMVSXHEWQXKJXMCEWQBXKEBVFXQXRVEEW
      PXKXMXOXPVGVHVIVJWMXHVKVLVMVNVOVPUGVQVR $.
  $}

  $( The Lebesgue measure function is finitely additive.  (Contributed by Mario
     Carneiro, 18-Mar-2014.) $)
  volun $p |- ( ( ( A e. dom vol /\ B e. dom vol /\ ( A i^i B ) = (/) ) /\
                  ( ( vol ` A ) e. RR /\ ( vol ` B ) e. RR ) ) ->
                ( vol ` ( A u. B ) ) = ( ( vol ` A ) + ( vol ` B ) ) ) $=
    ( cvol wcel cin c0 wceq cfv cr wa cun caddc covol cdif wss mblss syl mblvol
    co eqtri cdm w3a simpl1 simpl2 unssd cle wbr readdcl adantl simprl syl22anc
    simprr ovolun ovollecl syl3anc mblsplit indir inidm incom uneq12i unabs a1i
    simpl3 fveq2d eqeq1i disj3 bitr3i biimpi uncom difeq1i difun2 oveq12d eqtrd
    syl6reqr ex wb eleq1d bi2anan9 3adant3 unmbl oveqan12d eqeq12d 3imtr4d imp
    ) ACUAZDZBWEDZABEZFGZUBZACHZIDZBCHZIDZJZABKZCHZWKWMLSZGZWJAMHZIDZBMHZIDZJZW
    PMHZWTXBLSZGZWOWSWJXDXGWJXDJZXEWPAEZMHZWPANZMHZLSZXFXHWFWPIOZXEIDZXEXMGWFWG
    WIXDUCZXHABIXHWFAIOZXPAPQZXHWGBIOZWFWGWIXDUDBPQZUEZXHXNXFIDZXEXFUFUGZXOYAXD
    YBWJWTXBUHUIXHXQXAXSXCYCXRWJXAXCUJXTWJXAXCULABUMUKWPXFUNUOAWPUPUOXHWIXMXFGW
    FWGWIXDVCWIXJWTXLXBLWIXIAMXIAGWIXIAAEZBAEZKZAABAUQYFAWHKAYDAYEWHAURBAUSZUTA
    BVATTVBVDWIXKBMWIBBANZXKWIBYHGZWIYEFGYIYEWHFYGVEBAVFVGVHXKBAKZANYHWPYJAABVI
    VJBAVKTVNVDVLQVMVOWFWGWOXDVPWIWFWLXAWGWNXCWFWKWTIARZVQWGWMXBIBRZVQVRVSWFWGW
    SXGVPWIWFWGJZWQXEWRXFYMWPWEDWQXEGABVTWPRQWFWGWKWTWMXBLYKYLWAWBVSWCWD $.

  $( Addition of non-disjoint sets.  (Contributed by Mario Carneiro,
     25-Mar-2015.) $)
  volinun $p |- ( ( ( A e. dom vol /\ B e. dom vol ) /\
                  ( ( vol ` A ) e. RR /\ ( vol ` B ) e. RR ) ) ->
    ( ( vol ` A ) + ( vol ` B ) ) =
      ( ( vol ` ( A i^i B ) ) + ( vol ` ( A u. B ) ) ) ) $=
    ( cvol wcel wa cfv cr caddc co cin cdif cun wceq eqtri a1i covol mblvol wss
    c0 recnd cdm inundif fveq2i inmbl adantr difmbl difin0 ineq2i in0 syl inss1
    indifcom ad2antrr simprl eqeltrrd ovolsscl syl3anc eqeltrd syl32anc syl5eqr
    mblss difssd volun oveq1d simprr addassd undif1 simplr incom disjdif oveq2d
    syl5reqr 3eqtrd ) ACUAZDZBVNDZEZACFZGDZBCFZGDZEZEZVRVTHIABJZCFZABKZCFZHIZVT
    HIWEWGVTHIZHIWEABLZCFZHIWCVRWHVTHWCVRWDWFLZCFZWHWLACABUBUCWCWDVNDZWFVNDZWDW
    FJZSMZWEGDWGGDZWMWHMVQWNWBABUDUEZVQWOWBABUFUEZWQWCWPAWDBKZJZSWDABULXBASJSXA
    SAABUGUHAUINNOWCWEWDPFZGWCWNWEXCMWSWDQUJWCWDARZAGRZAPFZGDZXCGDXDWCABUKOVOXE
    VPWBAVAUMZWCVRXFGVOVRXFMVPWBAQUMVQVSWAUNUOZWDAUPUQURZWCWGWFPFZGWCWOWGXKMWTW
    FQUJWCWFARXEXGXKGDWCABVBXHXIWFAUPUQURZWDWFVCUSUTVDWCWEWGVTWCWEXJTWCWGXLTWCV
    TVQVSWAVEZTVFWCWIWKWEHWCWKWFBLZCFZWIXNWJCABVGUCWCWOVPWFBJZSMZWRWAXOWIMWTVOV
    PWBVHXQWCXPBWFJSWFBVIBAVJNOXLXMWFBVCUSVLVKVM $.

  ${
    $d k m n w x y z A $.  $d m n w x y z B $.
    $( The volume of a disjoint finite union of measurable sets is the sum of
       the measures.  (Contributed by Mario Carneiro, 25-Jun-2014.)  (Revised
       by Mario Carneiro, 11-Dec-2016.) $)
    volfiniun $p |- ( ( A e. Fin /\
                        A. k e. A ( B e. dom vol /\ ( vol ` B ) e. RR ) /\
                        Disj_ k e. A B ) ->
                      ( vol ` U_ k e. A B ) = sum_ k e. A ( vol ` B ) ) $=
      ( vz vm wcel cvol cfv cr wa wral wdisj ciun csu wceq wi c0 anbi12d fveq2d
      syl vw vy vn cfn cdm cv csn cun disjeq1 iuneq1 sumeq1 eqeq12d imbi12d weq
      raleq cc0 covol 0mbl mblvol ax-mp ovol0 eqtri 0iun fveq2i sum0 3eqtr4i wn
      a1i wss ssun1 ssralv disjss1 anim12i imim1i csb caddc co oveq1 iunxun vex
      csbeq1 iunxsn uneq2i cin nfcv nfcsb1v csbeq1a cbviun simpll simprl ralimi
      simpl mpsyl finiunmbl syl2anc syl5eqelr ssun2 snid sselii nfel1 nffv nfan
      eleq1d rspc simpld simplr elin wrex eliun w3a simplrr cbvdisj sylib elun1
      simpr1 simpr2 simpr3 disji syl122anc eqeltrrd 3exp2 rexlimdv syl5bi imp3a
      mtod eq0rdv cle wbr nfv cbvral mblss sylan2 ralrimiva sylibr simprd recnd
      r19.21bi cvv cbvsumi eqeq12i iunss biimpa fsumrecl jca ovolfiniun syl3anc
      adantr ovollecl eqeltrd volun syl32anc syl5eq disjsn eqidd snfi fsumsplit
      unfi sylancl cc sumsn sylancr oveq2d eqtrd syl5ibr 3imtr4g a2d findcard2s
      ex syl5 3impib ) AUDFBGUEZFZBGHZIFZJZCAKZCABLZCABMZGHZAUVMCNZOZUVOCUAUFZK
      ZCUWBBLZJZCUWBBMZGHZUWBUVMCNZOZPUVOCQKZCQBLZJZCQBMZGHZQUVMCNZOZPUVOCUBUFZ
      KZCUWQBLZJZCUWQBMZGHZUWQUVMCNZOZPZUVOCUWQDUFZUGZUHZKZCUXHBLZJZCUXHBMZGHZU
      XHUVMCNZOZPZUVPUVQJZUWAPUAUBDAUWBQOZUWEUWLUWIUWPUXRUWCUWJUWDUWKUVOCUWBQUO
      CUWBQBUIRUXRUWGUWNUWHUWOUXRUWFUWMGCUWBQBUJSUWBQUVMCUKULUMUAUBUNZUWEUWTUWI
      UXDUXSUWCUWRUWDUWSUVOCUWBUWQUOCUWBUWQBUIRUXSUWGUXBUWHUXCUXSUWFUXAGCUWBUWQ
      BUJSUWBUWQUVMCUKULUMUWBUXHOZUWEUXKUWIUXOUXTUWCUXIUWDUXJUVOCUWBUXHUOCUWBUX
      HBUIRUXTUWGUXMUWHUXNUXTUWFUXLGCUWBUXHBUJSUWBUXHUVMCUKULUMUWBAOZUWEUXQUWIU
      WAUYAUWCUVPUWDUVQUVOCUWBAUOCUWBABUIRUYAUWGUVSUWHUVTUYAUWFUVRGCUWBABUJSUWB
      AUVMCUKULUMUWPUWLQGHZUPUWNUWOUYBQUQHZUPQUVKFUYBUYCOURQUSUTVAVBUWMQGCBVCVD
      UVMCVEVFVHUXEUXKUXDPUWQUDFZUXFUWQFZVGZJZUXPUXKUWTUXDUXIUWRUXJUWSUWQUXHVIZ
      UXIUWRPUWQUXGVJZUVOCUWQUXHVKUTUYHUXJUWSPUYICUWQUXHBVLUTVMVNUYGUXKUXDUXOUY
      GUXKUXDUXOPUYGUXKJZEUWQCEUFZBVOZMZGHZUWQUYLGHZENZOZEUXHUYLMZGHZUXHUYOENZO
      ZUXDUXOUYQVUAUYJUYNCUXFBVOZGHZVPVQZUYPVUCVPVQZOUYNUYPVUCVPVRUYJUYSVUDUYTV
      UEUYJUYSUYMVUBUHZGHZVUDUYRVUFGUYRUYMEUXGUYLMZUHVUFEUWQUXGUYLVSVUHVUBUYMEU
      XFUYLVUBDVTZCUYKUXFBWAZWBWCVBVDUYJUYMUVKFZVUBUVKFZUYMVUBWDZQOUYNIFVUCIFZV
      UGVUDOUYJUYMUXAUVKCEUWQBUYLEBWEZCUYKBWFZCUYKBWGZWHZUYJUYDUVLCUWQKZUXAUVKF
      UYDUYFUXKWIZUYHUYJUVLCUXHKZVUSUYIUYJUXIVVAUYGUXIUXJWJZUVOUVLCUXHUVLUVNWLW
      KTUVLCUWQUXHVKWMUWQBCWNWOWPZUYJVULVUNUXFUXHFZUYJUXIVULVUNJZUXGUXHUXFUXGUW
      QWQUXFVUIWRWSZVVBUVOVVECUXFUXHVULVUNCCVUBUVKCUXFBWFZWTCVUCICVUBGCGWEZVVGX
      AWTXBCDUNZUVLVULUVNVUNVVIBVUBUVKCUXFBWGZXCVVIUVMVUCIVVIBVUBGVVJSXCRXDWMZX
      EUYJUAVUMUYJUWBVUMFZUYEUYDUYFUXKXFZVVLUWBUYMFZUWBVUBFZJUYJUYEUWBUYMVUBXGU
      YJVVNVVOUYEVVNUWBUYLFZEUWQXHUYJVVOUYEPZEUWBUWQUYLXIUYJVVPVVQEUWQUYJUYKUWQ
      FZVVPVVOUYEUYJVVRVVPVVOXJZJZUYKUXFUWQVVTUCUXHCUCUFZBVOZLZUYKUXHFZVVDVVPVV
      OEDUNZVVTUXJVWCUYGUXIUXJVVSXKCUCUXHBVWBUCBWECVWABWFCVWABWGXLXMVVTVVRVWDUY
      JVVRVVPVVOXOZUYKUWQUXGXNZTVVDVVTVVFVHUYJVVRVVPVVOXPUYJVVRVVPVVOXQUCUXHVWB
      UYLVUBUYKUXFUWBCVWAUYKBWACVWAUXFBWAXRXSVWFXTYAYBYCYDYCYEYFUYJUYNUYMUQHZIU
      YJVUKUYNVWHOVVCUYMUSTUYJUYMIVIZUWQUYLUQHZENZIFVWHVWKYGYHZVWHIFUYJUYLIVIZE
      UWQKVWIUYJVWMEUWQVVRUYJVWDVWMVWGUYJVWDJZUYLUVKFZVWMVWNVWOUYOIFZUYJVWOVWPJ
      ZEUXHUYJUXIVWQEUXHKZVVBUVOVWQCEUXHUVOEYIVWOVWPCCUYLUVKVUPWTCUYOICUYLGVVHV
      UPXAZWTXBCEUNZUVLVWOUVNVWPVWTBUYLUVKVUQXCVWTUVMUYOIVWTBUYLGVUQSZXCRYJXMZY
      QZXEUYLYKZTYLYMEUWQUYLIUUAYNUYJUWQVWJEVUTVVRUYJVWDVWJIFZVWGVWNVWQVXEVXCVW
      OVWPVXEVWOUYOVWJIUYLUSXCUUBZTYLUUCUYJUYDVWMVXEJZEUWQKZVWLVUTUYHUYJVXGEUXH
      KZVXHUYIUYJVWRVXIVXBVWQVXGEUXHVWQVWMVXEVWOVWMVWPVXDUUGVXFUUDWKTVXGEUWQUXH
      VKWMUWQUYLEUUEWOUYMVWKUUHUUFUUIUYJVULVUNVVKYOZUYMVUBUUJUUKUULUYJUYTUYPUXG
      UYOENZVPVQVUEUYJUWQUXGUYOUXHEUYJUYFUWQUXGWDQOVVMUWQUXFUUMYNUYJUXHUUNUYJUY
      DUXGUDFUXHUDFVUTUXFUUOUWQUXGUUQUURVWNUYOVWNVWOVWPVXCYOYPUUPUYJVXKVUCUYPVP
      UYJUXFYRFVUCUUSFVXKVUCOVUIUYJVUCVXJYPUYOVUCEUXFYRVWEUYLVUBGVUJSUUTUVAUVBU
      VCULUVDUXBUYNUXCUYPUXAUYMGVURVDUWQUVMUYOCEEUVMWEZVWSVXAYSYTUXMUYSUXNUYTUX
      LUYRGCEUXHBUYLVUOVUPVUQWHVDUXHUVMUYOCEVXLVWSVXAYSYTUVEUVHUVFUVIUVGUVJ $.
  $}

  ${
    $d a b k n x y $.  $d a b k m x y A $.  $d a b m n x y B $.  $d k n x N $.
    iundisj.1 $e |- ( n = k -> A = B ) $.
    $( Rewrite a countable union as a disjoint union.  (Contributed by Mario
       Carneiro, 20-Mar-2014.) $)
    iundisj $p |- U_ n e. NN A = U_ n e. NN ( A \ U_ k e. ( 1 ..^ n ) B ) $=
      ( vx vm cn ciun c1 cv cfzo co cdif wcel wrex cr nfcv wceq eleq2d csb crab
      clt ccnv csup wa cuz cfv wss c0 wne nnuz sseqtri rabn0 biimpri infmssuzcl
      ssrab2 sylancr nfrab1 nfsup nfcsb1 nfcri csbeq1a elrabf simpld simprd wbr
      sylib nnred ltnrd eliun ad2antrr elfzouz syl6eleqr simpr elrab infmssuzle
      ad2antlr sylanbrc elfzolt2 lelttrd ex rexlimdva syl5bi mtod eldifd csbeq1
      cle oveq2 iuneq1d difeq12d rspcev syl2anc nfv nfcsb1v nfdif cbvrex sylibr
      eldifi reximi impbii 3bitr4i eqriv ) FDHAIZDHACJDKZLMZBIZNZIZFKZAOZDHPZXJ
      XHOZDHPZXJXDOXJXIOXLXNXLXJDGKZAUAZCJXOLMZBIZNZOZGHPZXNXLXKDHUBZQUCUDZUEZH
      OZXJDYDAUAZCJYDLMZBIZNZOZYAXLYEXJYFOZXLYDYBOZYEYKUFXLYBJUGUHZUIZYBUJUKZYL
      YBHYMXKDHUQULUMZYOXLXKDHUNUOYBJUPURXKYKDYDHDYBQYCXKDHUSDQRDYCRUTZDHRDFYFD
      YDAYQVAVBXEYDSAYFXJDYDAVCTVDVHZVEZXLXJYFYHXLYEYKYRVFXLXJYHOZYDYDUCVGZXLYD
      XLYDYSVIZVJYTXJBOZCYGPXLUUACXJYGBVKXLUUCUUACYGXLCKZYGOZUFZUUCUUAUUFUUCUFZ
      YDUUDYDXLYDQOUUEUUCUUBVLZUUGUUDUUEUUDHOZXLUUCUUEUUDYMHUUDJYDVMULVNVRZVIUU
      HUUGYNUUDYBOZYDUUDWHVGYPUUGUUIUUCUUKUUJUUFUUCVOXKUUCDUUDHXEUUDSABXJETVPVS
      UUDYBJVQURUUEUUDYDUCVGXLUUCUUDJYDVTVRWAWBWCWDWEWFXTYJGYDHXOYDSZXSYIXJUULX
      PYFXRYHDXOYDAWGUULCXQYGBXOYDJLWIWJWKTWLWMXMXTDGHXMGWNDFXSDXPXRDXOAWODXRRW
      PVBXEXOSZXHXSXJUUMAXPXGXRDXOAVCUUMCXFXQBXEXOJLWIWJWKTWQWRXMXKDHXJAXGWSWTX
      ADXJHAVKDXJHXHVKXBXC $.

    $( A disjoint union is disjoint.  (Contributed by Mario Carneiro,
       4-Jul-2014.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
    iundisj2 $p |- Disj_ n e. NN ( A \ U_ k e. ( 1 ..^ n ) B ) $=
      ( vx vy va vb cn c1 cv cfzo weq csb cin c0 wtru wcel wss co ciun wdisj wo
      cdif wceq wral wa tru eqeq12 csbeq1 ineqan12d eqeq1d orbi12d equcom incom
      syl6bb syl6eq cr nnssre a1i biidd cle wbr w3a wn wne nesym clt wb nnre id
      leltne syl3an wi nfcsb1v nfcv nfdif csbeq1a oveq2 iuneq1d difeq12d csbief
      vex ineq12i cuz cfv simp1 nnuz syl6eleq simp2 nnzd simp3 elfzo2 syl3anbrc
      cz csbhypf equcoms eqcomd ssiun2s ssdifssd ssrin syl5eqss disjdif sylancl
      syl 3expia 3adant3 sylbird syl5bir orrd adantl wlogle mpan rgen2a disjors
      sseq0 mpbir ) DJACKDLZMUAZBUBZUEZUCFGNZDFLZYBOZDGLZYBOZPZQUFZUDZGJUGFJUGY
      JFGJRYDJSZYFJSZUHZYJUIRHINZDHLZYBOZDILZYBOZPZQUFZUDYJYJFGHIJHFNZIGNZUHZYN
      YCYTYIYOYDYQYFUJUUCYSYHQUUAUUBYPYEYRYGDYOYDYBUKDYQYFYBUKULUMUNHGNZIFNZUHZ
      YNYCYTYIUUFYNGFNYCYOYFYQYDUJGFUOUQUUFYSYHQUUFYSYGYEPYHUUDUUEYPYGYRYEDYOYF
      YBUKDYQYDYBUKULYGYEUPURUMUNJUSTRUTVARYMUHYJVBYKYLYDYFVCVDZVEZYJRUUHYCYIYC
      VFYFYDVGZUUHYIYFYDVHUUHUUIYDYFVIVDZYIYKYDUSSYLYFUSSUUGUUGUUJUUIVJYDVKYFVK
      UUGVLYDYFVMVNYKYLUUJYIVOUUGYKYLUUJYIYKYLUUJVEZYHCKYFMUAZBUBZDYFAOZUUMUEZP
      ZTUUPQUFYIUUKYHDYDAOZCKYDMUAZBUBZUEZUUOPZUUPYEUUTYGUUODYDYBUUTFWDDUUQUUSD
      YDAVPDUUSVQVRDFNZAUUQYAUUSDYDAVSUVBCXTUURBXSYDKMVTWAWBWCDYFYBUUOGWDDUUNUU
      MDYFAVPDUUMVQVRDGNZAUUNYAUUMDYFAVSUVCCXTUULBXSYFKMVTWAWBWCWEUUKUUTUUMTUVA
      UUPTUUKUUQUUMUUSUUKYDUULSZUUQUUMTUUKYDKWFWGZSYFWPSUUJUVDUUKYDJUVEYKYLUUJW
      HWIWJUUKYFYKYLUUJWKWLYKYLUUJWMYDKYFWNWOCUULBYDUUQCFNUUQBUUQBUFFCDFCLZABDU
      VFVQDBVQEWQWRWSWTXFXAUUTUUMUUOXBXFXCUUMUUNXDYHUUPXQXEXGXHXIXJXKXLXMXNXODJ
      YBFGXPXR $.
  $}

  ${
    $d k n z E $.  $d i k n x z F $.  $d k G $.  $d k z H $.  $d k x z S $.
    $d k n x z ph $.
    voliunlem.3 $e |- ( ph -> F : NN --> dom vol ) $.
    voliunlem.5 $e |- ( ph -> Disj_ i e. NN ( F ` i ) ) $.
    ${
      voliunlem1.6 $e |- H = ( n e. NN |-> ( vol* ` ( E i^i ( F ` n ) ) ) ) $.
      voliunlem1.7 $e |- ( ph -> E C_ RR ) $.
      voliunlem1.8 $e |- ( ph -> ( vol* ` E ) e. RR ) $.
      $( Lemma for ~ voliun .  (Contributed by Mario Carneiro, 20-Mar-2014.) $)
      voliunlem1 $p |- ( ( ph /\ k e. NN ) -> ( ( seq 1 ( + , H ) ` k ) +
                         ( vol* ` ( E \ U. ran F ) ) ) <_ ( vol* ` E ) ) $=
        ( cn wcel c1 co cfv covol caddc wceq vz cfz ciun cin crn cuni cdif cseq
        cv wa cle cr wss adantr difss ovolsscl mp3an1 syl2anc inss1 wral elfznn
        wbr wfn cvol cdm ffn syl fnfvelrn sylan elssuni sylan2 ralrimiva sylibr
        wf iunss sscond syl5ss ovolss leadd2dd oveq2 eleq1d ineq2d fveq2d fveq2
        wi iuneq1d eqeq12d anbi12d imbi2d csn cz 1z fzsn iuneq1 mp2b 1ex iunxsn
        eqtri 1nn ffvelrn syl5eqel fvex fvmpt ax-mp seq1 ineq2i fveq2i 3eqtr4ri
        sylancl jctir cun peano2nn syl2an unmbl syl5com cuz simpr nnuz syl6eleq
        ex fzsuc 3syl iunxun uneq2i syl6eq sylibrd oveq1 mblsplit syl3anc inss2
        ovex in32 adantl eluzfz2 ssiun2s df-ss c0 wb mpbid recnd syl5eq syl6req
        sylib indif2 uncom wdisj wne ad2antrr nnred clt elfzle2 nnleltp1 disji2
        gtned syl121anc iuneq2dv iun0 3eqtr3g uneqdifeq syl5eqr oveq12d addcomd
        iunin2 3eqtrd seqp1 oveq2d eqtrd syl5ibr expcom a2d nnind impcom simprd
        anim12d eqcomd oveq1d simpld 3brtr4d ) ACUIZMNZUJZEDOUVSUBPZDUIZFQZUCZU
        DZRQZEFUEZUFZUGZRQZSPUWGEUWEUGZRQZSPZUVSSGOUHZQZUWKSPERQZUKUWAUWKUWMUWG
        UWAEULUMZUWQULNZUWKULNZAUWRUVTKUNZAUWSUVTLUNZUWJEUMUWRUWSUWTEUWIUOUWJEU
        PUQURUWAUWRUWSUWMULNZUXAUXBUWLEUMUWRUWSUXCEUWEUOZUWLEUPUQURUWAUWRUWSUWG
        ULNZUXAUXBUWFEUMUWRUWSUXEEUWEUSUWFEUPUQURZUWAUWJUWLUMUWLULUMUWKUWMUKVBU
        WAUWEUWIEUWAUWDUWIUMZDUWBUTZUWEUWIUMAUXHUVTAUXGDUWBUWCUWBNZAUWCMNZUXGUW
        CUVSVAZAUXJUJUWDUWHNZUXGAFMVCZUXJUXLAMVDVEZFVNZUXMHMUXNFVFVGMUWCFVHVIUW
        DUWHVJVGVKVLUNDUWBUWDUWIVOVMVPUWAUWLEULUXDUXAVQUWJUWLVRURVSUWAUWPUWGUWK
        SUWAUWGUWPUWAUWEUXNNZUWGUWPTZUVTAUXPUXQUJZADOUAUIZUBPZUWDUCZUXNNZEUYAUD
        ZRQZUXSUWOQZTZUJZWEADOOUBPZUWDUCZUXNNZEUYIUDZRQZOUWOQZTZUJZWEAUXRWEZADO
        UVSOSPZUBPZUWDUCZUXNNZEUYSUDZRQZUYQUWOQZTZUJZWEUYPUACUVSUXSOTZUYGUYOAVU
        FUYBUYJUYFUYNVUFUYAUYIUXNVUFDUXTUYHUWDUXSOOUBVTWFZWAVUFUYDUYLUYEUYMVUFU
        YCUYKRVUFUYAUYIEVUGWBWCUXSOUWOWDWGWHWIUXSUVSTZUYGUXRAVUHUYBUXPUYFUXQVUH
        UYAUWEUXNVUHDUXTUWBUWDUXSUVSOUBVTWFZWAVUHUYDUWGUYEUWPVUHUYCUWFRVUHUYAUW
        EEVUIWBWCUXSUVSUWOWDWGWHWIZUXSUYQTZUYGVUEAVUKUYBUYTUYFVUDVUKUYAUYSUXNVU
        KDUXTUYRUWDUXSUYQOUBVTWFZWAVUKUYDVUBUYEVUCVUKUYCVUARVUKUYAUYSEVULWBWCUX
        SUYQUWOWDWGWHWIVUJAUYJUYNAUYIOFQZUXNUYIDOWJZUWDUCZVUMOWKNZUYHVUNTUYIVUO
        TWLOWMDUYHVUNUWDWNWODOUWDVUMWPUWCOFWDZWQWRZAUXOOMNZVUMUXNNHWSMUXNOFWTXI
        XAOGQZEVUMUDZRQZUYMUYLVUSVUTVVBTWSDOEUWDUDZRQZVVBMGUWCOTZVVCVVARVVEUWDV
        UMEVUQWBWCJVVARXBXCXDVUPUYMVUTTWLSGOXEXDUYKVVARUYIVUMEVURXFXGXHXJUVTAUX
        RVUEAUVTUXRVUEWEUWAUXPUYTUXQVUDUWAUXPUWEUYQFQZXKZUXNNZUYTUWAVVFUXNNZUXP
        VVHAUXOUYQMNZVVIUVTHUVSXLZMUXNUYQFWTXMZUXPVVIVVHUWEVVFXNXTXOUWAUYSVVGUX
        NUWAUYSDUWBUYQWJZXKZUWDUCZVVGUWAUVSOXPQZNZUYRVVNTUYSVVOTUWAUVSMVVPAUVTX
        QZXRXSZOUVSYADUYRVVNUWDWNYBVVOUWEDVVMUWDUCZXKVVGDUWBVVMUWDYCVVTVVFUWEDU
        YQUWDVVFUVSOSYKUWCUYQFWDZWQYDWRYEZWAYFUXQVUDUWAUWGEVVFUDZRQZSPZUWPVWDSP
        ZTUWGUWPVWDSYGUWAVUBVWEVUCVWFUWAVUBVUAVVFUDZRQZVUAVVFUGZRQZSPZVWDUWGSPV
        WEUWAVVIVUAULUMVUBULNZVUBVWKTVVLUWAVUAEULEUYSUSZUXAVQUWAUWRUWSVWLUXAUXB
        VUAEUMUWRUWSVWLVWMVUAEUPUQURVVFVUAYHYIUWAVWHVWDVWJUWGSUWAVWGVWCRUWAVWGV
        WCUYSUDZVWCEUYSVVFYLUWAVWCUYSUMVWNVWCTUWAVWCVVFUYSEVVFYJUWAUYQVVPNUYQUY
        RNVVFUYSUMZUWAUYQMVVPUVTVVJAVVKYMZXRXSOUYQYNDUYRUWDUYQVVFVWAYOYBZVQVWCU
        YSYPUUCUUAWCUWAVWIUWFRUWAVWIEUYSVVFUGZUDUWFEUYSVVFUUDUWAVWRUWEEUWAVVFUW
        EXKZUYSTZVWRUWETZUWAUYSVVGVWSVWBUWEVVFUUEUUBUWAVWOVVFUWEUDZYQTVWTVXAYRV
        WQUWADUWBVVFUWDUDZUCDUWBYQUCVXBYQUWADUWBVXCYQUWAUXIUJZBMBUIZFQZUUFZVVJU
        XJUYQUWCUUGVXCYQTAVXGUVTUXIIUUHUWAVVJUXIVWPUNUXIUXJUWAUXKYMZVXDUWCUYQVX
        DUWCVXHUUIVXDUWCUVSUKVBZUWCUYQUUJVBZUXIVXIUWAUWCOUVSUUKYMVXDUXJUVTVXIVX
        JYRVXHUWAUVTUXIVVRUNUWCUVSUULURYSUUNBMVXFVVFUWDUYQUWCVXEUYQFWDVXEUWCFWD
        UUMUUOUUPDUWBVVFUWDUVCDUWBUUQUURVVFUWEUYSUUSURYSWBUUTWCUVAUWAVWDUWGUWAV
        WDUWAUWRUWSVWDULNZUXAUXBVWCEUMUWRUWSVXKEVVFUSVWCEUPUQURYTUWAUWGUXFYTUVB
        UVDUWAVUCUWPUYQGQZSPZVWFUWAVVQVUCVXMTVVSSGOUVSUVEVGUWAVXLVWDUWPSUWAVVJV
        XLVWDTVWPDUYQVVDVWDMGUWCUYQTZVVCVWCRVXNUWDVVFEVWAWBWCJVWCRXBXCVGUVFUVGW
        GUVHUVNUVIUVJUVKUVLZUVMUVOUVPUWAUXPUWRUWSUWQUWNTUWAUXPUXQVXOUVQUXAUXBUW
        EEYHYIUVR $.
    $}

    voliunlem.6 $e |- H = ( n e. NN |-> ( vol* ` ( x i^i ( F ` n ) ) ) ) $.
    $( Lemma for ~ voliun .  (Contributed by Mario Carneiro, 20-Mar-2014.) $)
    voliunlem2 $p |- ( ph -> U. ran F e. dom vol ) $=
      ( vk cr wss cv covol cfv wcel cn cle wbr cxr crn cuni cin cdif caddc wceq
      vz co wi cpw wral cvol cdm frn syl mblss reex elpw2 sylibr syl6ss sspwuni
      wf ssriv sylib elpwi w3a cun inundif fveq2i inss1 syl5ss ovolsscl 3adant1
      simp2 mp3an1 difss ovolun syl22anc syl5eqbrr cmin c1 cseq csup rexrd nnuz
      clt cz 1z a1i fveq2 ineq2d fveq2d fvex fvmpt adantl adantr eqeltrd serfre
      ressxr supxrcl simp3 resubcld ciun iunin2 wfn ffn fniunfv 3ad2ant1 syl5eq
      wa 3syl eqid ovoliun eqbrtrrd wdisj voliunlem1 ffvelrnda leaddsub syl3anc
      wb simpl3 mpbid ralrimiva breq1 mpbird supxrleub syl2anc xrletrd readdcld
      ralrn letri3d mpbir2and 3expia sylan2 ismbl sylanbrc ) AEUAZUBZKLZBMZNOZK
      PZUUAYTYRUCZNOZYTYRUDZNOZUEUHZUFZUIZBKUJZUKYRULUMZPAYQUUJLYSAYQUUKUUJAQUU
      KEVBZYQUUKLGQUUKEUNUOBUUKUUJYTUUKPYTKLZYTUUJPZYTUPYTKUQURUSVCUTYQKVAVDAUU
      IBUUJUUNAUUMUUIYTKVEAUUMUUBUUHAUUMUUBVFZUUHUUAUUGRSUUGUUARSZUUOUUAUUCUUEV
      GZNOZUUGRUUQYTNYTYRVHVIUUOUUCKLUUDKPZUUEKLUUFKPZUURUUGRSUUOUUCYTKYTYRVJZA
      UUMUUBVNZVKUUMUUBUUSAUUCYTLUUMUUBUUSUVAUUCYTVLVOVMZUUOUUEYTKYTYRVPZUVBVKU
      UMUUBUUTAUUEYTLUUMUUBUUTUVDUUEYTVLVOVMZUUCUUEVQVRVSUUOUUPUUDUUAUUFVTUHZRS
      ZUUOUUDUEFWAWBZUAZTWFWCZUVFUUOUUDUVCWDUUOUVITLZUVJTPUUOUVIKTUUOQKUVHVBZUV
      IKLUUOJFWAQWEWAWGPUUOWHWIUUOJMZQPZXJZUVMFOZYTUVMEOZUCZNOZKUVNUVPUVSUFUUOD
      UVMYTDMZEOZUCZNOZUVSQFUVTUVMUFZUWBUVRNUWDUWAUVQYTUVTUVMEWJWKWLIUVRNWMWNWO
      UUOUVSKPZUVNUUMUUBUWEAUVRYTLUUMUUBUWEYTUVQVJUVRYTVLVOVMWPWQWRZQKUVHUNUOWS
      UTZUVIWTUOUUOUVFUUOUUAUUFAUUMUUBXAZUVEXBWDZUUODQUWBXCZNOUUDUVJRUUOUWJUUCN
      UUOUWJYTDQUWAXCZUCUUCDQYTUWAXDUUOUWKYRYTAUUMUWKYRUFZUUBAUULEQXEUWLGQUUKEX
      FDQEXGXKXHWKXIWLUUOUWBUVHDFUVHXLIUUOUWBKLUVTQPZUUOUWBYTKYTUWAVJZUVBVKWPUU
      OUWCKPZUWMUUMUUBUWOAUWBYTLUUMUUBUWOUWNUWBYTVLVOVMWPXMXNUUOUVJUVFRSZUGMZUV
      FRSZUGUVIUKZUUOUWSUVMUVHOZUVFRSZJQUKZUUOUXAJQUVOUWTUUFUEUHUUARSZUXAUUOCJD
      YTEFAUUMUULUUBGXHAUUMCQCMEOXOUUBHXHIUVBUWHXPUVOUWTKPUUTUUBUXCUXAXTUUOQKUV
      MUVHUWFXQUUOUUTUVNUVEWPAUUMUUBUVNYAUWTUUFUUAXRXSYBYCUUOUVLUVHQXEUWSUXBXTU
      WFQKUVHXFUWRUXAUGJQUVHUWQUWTUVFRYDYJXKYEUUOUVKUVFTPUWPUWSXTUWGUWIUGUVIUVF
      YFYGYEYHUUOUUSUUTUUBUUPUVGXTUVCUVEUWHUUDUUFUUAXRXSYEUUOUUAUUGUWHUUOUUDUUF
      UVCUVEYIYKYLYMYNYCBYRYOYP $.

    voliunlem3.1 $e |- S = seq 1 ( + , G ) $.
    voliunlem3.2 $e |- G = ( n e. NN |-> ( vol ` ( F ` n ) ) ) $.
    voliunlem3.4 $e |- ( ph -> A. i e. NN ( vol ` ( F ` i ) ) e. RR ) $.
    $( Lemma for ~ voliun .  (Contributed by Mario Carneiro, 20-Mar-2014.) $)
    voliunlem3 $p |- ( ph -> ( vol ` U. ran F ) = sup ( ran S , RR* , < ) ) $=
      ( cfv covol wcel syl cn cr crn cuni cvol cxr clt csup cdm wceq voliunlem2
      vz vk mblvol cle wbr cv ciun caddc cmpt c1 cseq eqid ffvelrnda mblss wral
      wa wss weq fveq2 fveq2d eleq1d rspccva sylan eqeltrrd ovoliun wfn fniunfv
      wf ffn mpteq2dva syl5eq seqeq3d syl5req rneqd supeq1d 3brtr3d cpnf wi cc0
      cmnf cpw frn elpw2 sylibr ssriv syl6ss sspwuni sylib ovolcl ovolge0 mnflt
      reex 0re ax-mp mnfxr xrltletr mp3an12 mpani sylc wb xrrebnd cdif co simpl
      0xr sseq1d cin simpll ineq1d elssuni adantll sseqin2 eqtrd eqtr4d adantrr
      fnfvelrn 3eqtr4g syl6eqr fveq1d difeq1 difid syl6eq adantr adantl imbi12d
      c0 ovol0 3ad2ant1 sylbird mpbird syl2anc oveq12d nnuz cz a1i fvex eqeltrd
      1z fvmpt serfre feq1i recnd addid1d breq12d expr pm5.74da w3a wdisj simp2
      pm5.74d simp3 voliunlem1 3exp1 vtoclg mpcom mpand nltpnft rexr pnfge 3syl
      mpd wn ex breq2 imbi2d syl5ibrcom pm2.61d ralrimiv breq1 ressxr supxrleub
      ralrn supxrcl xrletri3 mpbir2and ) AFUAZUBZUCOZUWFPOZCUAZUDUEUFZAUWFUCUGZ
      QUWGUWHUHABDEFHIJKUIUWFULRAUWHUWJUHZUWHUWJUMUNZUWJUWHUMUNZAESEUOZFOZUPZPO
      UQESUWPPOZURZUSUTZUAZUDUEUFUWHUWJUMAUWPUWTEUWSUWTVAUWSVAAUWOSQZVEZUWPUWKQ
      ZUWPTVFASUWKUWOFIVBZUWPVCRUXCUWPUCOZUWRTUXCUXDUXFUWRUHZUXEUWPULRZADUOZFOZ
      UCOZTQZDSVDZUXBUXFTQZNUXLUXNDUWOSDEVGZUXKUXFTUXOUXJUWPUCUXIUWOFVHVIVJVKVL
      VMVNAUWQUWFPAFSVOZUWQUWFUHASUWKFVQZUXPISUWKFVRRZESFVPRVIAUDUXAUWIUEAUWTCA
      CUQGUSUTZUWTLAGUWSUQUSAGESUXFURZUWSMAESUXFUWRUXHVSVTWAWBWCWDWEAUWNUJUOZUW
      HUMUNZUJUWIVDZAUYCUKUOZCOZUWHUMUNZUKSVDZAUYFUKSAUWHWFUEUNZUYDSQZUYFWGZAWI
      UWHUEUNZUYHUYJAUWHUDQZWHUWHUMUNZUYKAUWFTVFZUYLAUWETWJZVFUYNAUWEUWKUYOAUXQ
      UWEUWKVFISUWKFWKRBUWKUYOBUOZUWKQUYPTVFZUYPUYOQUYPVCUYPTXAWLWMWNWOUWETWPWQ
      ZUWFWRRZAUYNUYMUYRUWFWSRUYLWIWHUEUNZUYMUYKWHTQUYTXBWHWTXCWIUDQWHUDQUYLUYT
      UYMVEUYKWGXDXNWIWHUWHXEXFXGXHAUYKUYHVEZUWHTQZUYJAUYLVUBVUAXIUYSUWHXJRAUYN
      VUBUYJWGZUYRUWFUYOQZAUYNVUCWGZAUYNVUDUYRUWFTXAWLWMAUYQUYPPOZTQZUYIUYDUQHU
      SUTZOZUYPUWFXKZPOZUQXLZVUFUMUNZWGZWGZWGZWGAVUEWGBUWFUYOUYPUWFUHZAVUPVUEVU
      QAVEZUYQUYNVUOVUCVURUYPUWFTVUQAXMZXOVURVUGVUBVUNUYJVURVUFUWHTVURUYPUWFPVU
      SVIVJVURUYIVUMUYFVUQAUYIVUMUYFXIVUQAUYIVEZVEZVULUYEVUFUWHUMVVAVULUYEWHUQX
      LUYEVVAVUIUYEVUKWHUQVVAUYDVUHCVVAVUHUXSCVVAHGUQUSVVAESUYPUWPXPZPOZURZUXTH
      GVUQAVVDUXTUHUYIVURESVVCUXFVURUXBVEZVVCUWRUXFVVEVVBUWPPVVEVVBUWFUWPXPZUWP
      VVEUYPUWFUWPVUQAUXBXQXRVVEUWPUWFVFZVVFUWPUHAUXBVVGVUQUXCUWPUWEQZVVGAUXPUX
      BVVHUXRSUWOFYEVLUWPUWEXSRXTUWPUWFYAWQYBVIAUXBUXGVUQUXHXTYCVSYDKMYFWALYGYH
      VUQVUKWHUHVUTVUQVUKYOPOWHVUQVUJYOPVUQVUJUWFUWFXKYOUYPUWFUWFYIUWFYJYKVIYPY
      KYLUUAVVAUYEVVAUYEVUTUYETQZVUQASTUYDCASTUXSVQSTCVQZAUKGUSSUUBUSUUCQAUUGUU
      DVUTUYDGOZUYDFOZUCOZTUYIVVKVVMUHAEUYDUXFVVMSGEUKVGUWPVVLUCUWOUYDFVHVIMVVL
      UCUUEUUHYMAUXMUYIVVMTQZNUXLVVNDUYDSDUKVGZUXKVVMTVVOUXJVVLUCUXIUYDFVHVIVJV
      KVLUUFUUISTCUXSLUUJWMZVBZYMUUKUULYBVUQVUFUWHUHVUTUYPUWFPVHYLUUMUUNUUSYNYN
      UUOAUYQVUGUYIVUMAUYQVUGUUPDUKEUYPFHAUYQUXQVUGIYQAUYQDSUXJUUQVUGJYQKAUYQVU
      GUURAUYQVUGUUTUVAUVBUVCUVDUVJYRUVEAUYHUVKZUWHWFUHZUYJAUYLVVSVVRXIUYSUWHUV
      FRAUYJVVSUYIUYEWFUMUNZWGAUYIVVTVUTVVIUYEUDQVVTVVQUYEUVGUYEUVHUVIUVLVVSUYF
      VVTUYIUWHWFUYEUMUVMUVNUVOYRUVPUVQACSVOZUYCUYGXIAVVJVWAVVPSTCVRRUYBUYFUJUK
      SCUYAUYEUWHUMUVRUWARYSAUWIUDVFZUYLUWNUYCXIAUWITUDAVVJUWITVFVVPSTCWKRUVSWO
      ZUYSUJUWIUWHUVTYTYSAUYLUWJUDQZUWLUWMUWNVEXIUYSAVWBVWDVWCUWIUWBRUWHUWJUWCY
      TUWDYB $.
  $}

  ${
    $d i k m n x y $.  $d i k m x y A $.  $d i m n x B $.
    $( The measurable sets are closed under countable union.  (Contributed by
       Mario Carneiro, 18-Mar-2014.) $)
    iunmbl $p |- ( A. n e. NN A e. dom vol -> U_ n e. NN A e. dom vol ) $=
      ( vk vm vy vi wcel cn wral ciun cv csb c1 cfzo wceq nfcsb1v nfel1 weq cvv
      cfv vx cvol cdm co cdif cmpt crn cuni wrex cab csbeq1a eleq1d cbvral nfcv
      cbviun csbeq1 iundisj eqtri difexg ralimi dfiun2g syl5eq sylbi eqid rnmpt
      nfv syl unieqi syl6eqr cin covol wa rspc impcom cfn fzofi wss cuz elfzouz
      nnuz syl6eleqr ssriv ssralv ax-mp adantr finiunmbl sylancr difmbl syl2anc
      fmptd wdisj iundisj2 simpr oveq2 iuneq1d difeq12d fvmptg disjeq2dv mpbiri
      wi voliunlem2 eqeltrd ) AUBUCZGZBHIZBHAJZCHBCKZALZDMXGNUDZBDKZALZJZUEZUFZ
      UGZUHZXCXEXFEKZXMOCHUIEUJZUHZXPXEXHXCGZCHIZXFXSOXDXTBCHXDCVFBXHXCBXGAPZQZ
      BCRAXHXCBXGAUKZULZUMYAXFCHXMJZXSXFCHXHJYFBCHAXHCAUNYBYDUOXHXKDCBXGXJAUPUQ
      URYAXMSGZCHIYFXSOXTYGCHXHXLXCUSUTCEHXMSVAVGVBVCXOXRCEHXMXNXNVDZVEVHVIXEUA
      FEXNEHUAKXQXNTVJVKTUFZXECHXMXCXNXEXGHGZVLZXTXLXCGZXMXCGYJXEXTXDXTBXGHYCYE
      VMVNYKXIVOGXKXCGZDXIIZYLMXGVPXEYNYJXEYMDHIZYNXDYMBDHXDDVFBXKXCBXJAPQBDRAX
      KXCBXJAUKULUMXIHVQYOYNWTDXIHXJXIGXJMVRTHXJMXGVSVTWAWBYMDXIHWCWDVCWEXIXKDW
      FWGXHXLWHWIYHWJXEFHFKZXNTZWKFHBYPALZDMYPNUDZXKJZUEZWKYRXKDFBYPXJAUPWLXEFH
      YQUUAXEYPHGZVLZUUBUUASGZYQUUAOXEUUBWMUUCYRXCGZUUDUUBXEUUEXDUUEBYPHBYRXCBY
      PAPQBFRAYRXCBYPAUKULVMVNYRYTXCUSVGCYPXMUUAHSXNCFRZXHYRXLYTBXGYPAUPUUFDXIY
      SXKXGYPMNWNWOWPYHWQWIWRWSYIVDXAXB $.

    voliun.1 $e |- S = seq 1 ( + , G ) $.
    voliun.2 $e |- G = ( n e. NN |-> ( vol ` A ) ) $.
    $( The Lebesgue measure function is countably additive.  (Contributed by
       Mario Carneiro, 18-Mar-2014.)  (Proof shortened by Mario Carneiro,
       11-Dec-2016.) $)
    voliun $p |- ( ( A. n e. NN ( A e. dom vol /\ ( vol ` A ) e. RR ) /\
                   Disj_ n e. NN A ) ->
                   ( vol ` U_ n e. NN A ) = sup ( ran S , RR* , < ) ) $=
      ( vx vi vm cvol wcel cfv cr cn wral cmpt cv eqid wceq fveq2d cdm wa wdisj
      crn cuni caddc c1 cseq cxr clt csup ciun cin covol wf simpl ralimi adantr
      fmpt sylib wb fvmpt2 adantrr ralimiaa disjeq2 biimpar nfcv nffvmpt1 fveq2
      syl cbvdisj nffv cbvmpt eleq1d biimprd impr nfv nfel1 voliunlem3 wrex cab
      cbvral dfiun2g rnmpt unieqi syl6eqr mpteq12 sylancr syl6reqr syl5eq rneqd
      seqeq3d supeq1d 3eqtr4d ) AJUAZKZAJLZMKZUBZCNOZCNAUCZUBZCNAPZUDZUEZJLUFCN
      CQZXCLZJLZPZUGUHZUDZUIUJUKCNAULZJLBUDZUIUJUKXBGXJHIXCXIINGQZIQZXCLZUMUNLP
      ZXBWPCNOZNWOXCUOWTXRXAWSWPCNWPWRUPUQURZCNWOAXCXCRZUSUTXBCNXGUCZHNHQZXCLZU
      CWTYAXAWTXGASZCNOYAXAVAWSYDCNXFNKZWPYDWRCNAWOXCXTVBZVCVDCNXGAVEVJVFCHNXGY
      CHXGVGCNAYBVHZXFYBXCVIZVKUTXQRXJRCINXHXPJLIXHVGCXPJCJVGZCNAXOVHVLXFXOSXGX
      PJXFXOXCVITVMXBXHMKZCNOZYCJLZMKZHNOWTYKXAWSYJCNYEWPWRYJYEWPUBZYJWRYNXHWQM
      YNXGAJYFTZVNVOVPVDURYJYMCHNYJHVQCYLMCYCJYIYGVLVRXFYBSZXHYLMYPXGYCJYHTVNWB
      UTVSXBXLXEJXBXLXNASCNVTGWAZUEZXEXBXRXLYRSXSCGNAWOWCVJXDYQCGNAXCXTWDWEWFTX
      BUIXMXKUJXBBXJXBBUFDUGUHXJEXBDXIUFUGXBXICNWQPZDXBNNSXHWQSZCNOZXIYSSNRWTUU
      AXAWSYTCNYEWPYTWRYOVCVDURCNXHNWQWGWHFWIWLWJWKWMWN $.
  $}

  ${
    $d k n x F $.  $d k x A $.  $d x B $.
    $( Lemma for ~ volsup .  (Contributed by Mario Carneiro, 4-Jul-2014.) $)
    volsuplem $p |- ( ( A. n e. NN ( F ` n ) C_ ( F ` ( n + 1 ) ) /\
                      ( A e. NN /\ B e. ( ZZ>= ` A ) ) ) ->
                      ( F ` A ) C_ ( F ` B ) ) $=
      ( vx vk cv cfv c1 caddc co wss cn wcel wa wi wceq fveq2 sseq2d imbi2d cuz
      wral cz ssid a1ii nnuz uztrn2 oveq1 fveq2d sseq12d rspccva sylan2 anassrs
      sstr2 syl5com expcom a2d uzind4 com12 impr ) CGZDHZVAIJKZDHZLZCMUBZAMNZBA
      UAHZNZADHZBDHZLZVIVFVGOZVLVMVJEGZDHZLZPVMVJVJLZPVMVJFGZDHZLZPVMVJVRIJKZDH
      ZLZPVMVLPEFABVNAQZVPVQVMWDVOVJVJVNADRSTVNVRQZVPVTVMWEVOVSVJVNVRDRSTVNWAQZ
      VPWCVMWFVOWBVJVNWADRSTVNBQZVPVLVMWGVOVKVJVNBDRSTAUCNVMVQVJUDUEVRVHNZVMVTW
      CVMWHVTWCPVMWHOVSWBLZVTWCVFVGWHWIVGWHOVFVRMNWIIVRAMUFUGVEWICVRMVAVRQZVBVS
      VDWBVAVRDRWJVCWADVAVRIJUHUIUJUKULUMVJVSWBUNUOUPUQURUSUT $.
  $}

  ${
    $d j k m n x F $.
    $( The volume of the limit of an increasing sequence of measurable sets is
       the limit of the volumes.  (Contributed by Mario Carneiro,
       14-Aug-2014.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
    volsup $p |- ( ( F : NN --> dom vol /\
                   A. n e. NN ( F ` n ) C_ ( F ` ( n + 1 ) ) ) ->
                 ( vol ` U. ran F ) = sup ( ( vol " ran F ) , RR* , < ) ) $=
      ( vk vm cn cvol cfv c1 caddc co wss wa cr wcel cxr wceq fveq2 fveq2d cpnf
      syl vj vx cdm wf cv wral crn cuni cima clt csup cfzo ciun cdif cmpt wdisj
      cseq ffvelrn ad2ant2r cfn fzofi simpll elfzouz syl6eleqr syl2an ralrimiva
      nnuz finiunmbl sylancr difmbl syl2anc covol mblvol difssd simprr eqeltrrd
      cuz mblss ovolsscl syl3anc eqeltrd jca expr ralimdva iundisj2 eqid voliun
      imp sylancl iundisj wfn ffn ad2antrr fniunfv syl5eqr ccom cz seqfn fneq2i
      1z ax-mp mpbir a1i cc0 cicc volf fco wi eqeq12d imbi2d weq seq1 1nn oveq2
      fzo0 syl6eq iuneq1d 0iun difeq2d dif0 eqtrd fvex fvmpt oveq1 adantl rspcv
      c0 cun sylc ffvelrnd eleq1d eqtr4d wn cle wbr ovolcl cmnf wb frn sstri ex
      eqtri seqp1 eleq2s undif2 simpr simpllr sseq12d ssequn1 sylib syl5req cin
      simplll peano2nn disjdif simplr volun cfz adantr elfznn elfzuz3 volsuplem
      syl32anc syl12anc iunss sylibr syl6eleq eluzfz2 ssiun2s eqssd nnzd fzval3
      eqtr3d difeq12d oveq2d 3eqtrd syl5ibr expcom a2d nnind impcom fvco3 sylan
      eqfnfvd rneqd rnco2 supeq1d 3eqtr3d wrex rexnal pnfge xrrebnd ovolge0 0re
      iunmbl mnflt mnfxr xrltletr mp3an12 mpani biantrurd 3bitr4d mtbid nltpnft
      0xr mpbird simprl fnfvelrn elssuni ovolss eqbrtrrd pnfxr xrletri3 imassrn
      mpbir2and iccssxr wfun ffun funfvima2 supxrpnf 3eqtr4d rexlimdvaa syl5bir
      pm2.61d ) EFUCZBUDZAUEZBGZUYGHIJZBGZKZAEUFZLZCUEZBGZFGZMNZCEUFZBUGZUHZFGZ
      FUYSUIZOUJUKZPZUYMUYRVUDUYMUYRLZCEUYODHUYNULJZDUEZBGZUMZUNZUMZFGZICEVUJFG
      ZUOZHUQZUGZOUJUKZVUAVUCVUEVUJUYENZVUMMNZLZCEUFZCEVUJUPVULVUQPUYMUYRVVAUYM
      UYQVUTCEUYMUYNENZUYQVUTUYMVVBUYQLZLZVURVUSVVDUYOUYENZVUIUYENZVURUYFVVBVVE
      UYLUYQEUYEUYNBURZUSZVVDVUFUTNVUHUYENZDVUFUFVVFHUYNVAVVDVVIDVUFVVDUYFVUGEN
      ZVVIVUGVUFNZUYFUYLVVCVBVVKVUGHVQGZEVUGHUYNVCVGVDEUYEVUGBURVEVFVUFVUHDVHVI
      UYOVUIVJVKZVVDVUMVUJVLGZMVVDVURVUMVVNPVVMVUJVMTVVDVUJUYOKUYOMKZUYOVLGZMNZ
      VVNMNVVDUYOVUIVNVVDVVEVVOVVHUYOVRZTVVDUYPVVPMVVDVVEUYPVVPPZVVHUYOVMZTUYMV
      VBUYQVOVPVUJUYOVSVTWAWBWCWDWHUYOVUHDCUYNVUGBQZWEVUJVUOCVUNVUOWFVUNWFZWGWI
      VUEVUKUYTFVUEVUKCEUYOUMZUYTUYOVUHDCVWAWJVUEBEWKZVWCUYTPUYFVWDUYLUYREUYEBW
      LZWMCEBWNTWORVUEOVUPVUBUJVUEVUPFBWPZUGVUBVUEVUOVWFVUEUAEVUOVWFVUOEWKZVUEV
      WGVUOVVLWKZHWQNZVWHWTIVUNHWRXAEVVLVUOVGWSXBXCVUEEXDSXEJZVWFUDZVWFEWKVUEUY
      EVWJFUDZUYFVWKXFUYFUYLUYRVBZEUYEVWJFBXGVIEVWJVWFWLTVUEUAUEZENZLZVWNVUOGZV
      WNBGZFGZVWNVWFGZVWOVUEVWQVWSPZVUEUBUEZVUOGZVXBBGZFGZPZXHVUEHVUOGZHBGZFGZP
      ZXHVUEVXAXHZVUEVWNHIJZVUOGZVXLBGZFGZPZXHVXKUBUAVWNVXBHPZVXFVXJVUEVXQVXCVX
      GVXEVXIVXBHVUOQVXQVXDVXHFVXBHBQRXIXJUBUAXKZVXFVXAVUEVXRVXCVWQVXEVWSVXBVWN
      VUOQVXRVXDVWRFVXBVWNBQRXIXJZVXBVXLPZVXFVXPVUEVXTVXCVXMVXEVXOVXBVXLVUOQVXT
      VXDVXNFVXBVXLBQRXIXJVXSVXJVUEVXGHVUNGZVXIVWIVXGVYAPWTIVUNHXLXAHENVYAVXIPX
      MCHVUMVXIEVUNUYNHPZVUJVXHFVYBVUJUYOVXHVYBVUJUYOYGUNUYOVYBVUIYGUYOVYBVUIDY
      GVUHUMYGVYBDVUFYGVUHVYBVUFHHULJYGUYNHHULXNHXOXPXQDVUHXRXPXSUYOXTXPUYNHBQY
      ARVWBVXHFYBYCXAUUBXCVWOVUEVXAVXPVUEVWOVXAVXPXHVXAVXPVWPVWQVXLVUNGZIJZVWSV
      YCIJZPVWQVWSVYCIYDVWPVXMVYDVXOVYEVWOVXMVYDPZVUEVYFVWNVVLEIVUNHVWNUUCVGUUD
      YEVWPVXOVWRVXNVWRUNZYHZFGZVWSVYGFGZIJZVYEVWPVXNVYHFVWPVYHVWRVXNYHZVXNVWRV
      XNUUEVWPVWRVXNKZVYLVXNPVWPVWOUYLVYMVUEVWOUUFZUYFUYLUYRVWOUUGZUYKVYMAVWNEA
      UAXKZUYHVWRUYJVXNUYGVWNBQVYPUYIVXLBUYGVWNHIYDRUUHYFYIVWRVXNUUIUUJUUKRVWPV
      WRUYENZVYGUYENZVWRVYGUULYGPZVWSMNZVYJMNVYIVYKPVWPEUYEVWNBUYFUYLUYRVWOUUMZ
      VYNYJZVWPVXNUYENZVYQVYRVWPEUYEVXLBWUAVWOVXLENZVUEVWNUUNYEZYJZWUBVXNVWRVJV
      KZVYSVWPVWRVXNUUOXCVWPVWOUYRVYTVYNUYMUYRVWOUUPZUYQVYTCVWNECUAXKZUYPVWSMWU
      IUYOVWRFUYNVWNBQRYKYFYIVWPVYJVYGVLGZMVWPVYRVYJWUJPWUGVYGVMTVWPVYGVXNKVXNM
      KZVXNVLGZMNWUJMNVWPVXNVWRVNVWPWUCWUKWUFVXNVRTVWPVXOWULMVWPWUCVXOWULPWUFVX
      NVMTVWPWUDUYRVXOMNZWUEWUHUYQWUMCVXLEUYNVXLPZUYPVXOMWUNUYOVXNFUYNVXLBQZRYK
      YFYIVPVYGVXNVSVTWAVWRVYGUUQUVCVWPVYJVYCVWSIVWPVYJVXNDHVXLULJZVUHUMZUNZFGZ
      VYCVWPVYGWURFVWPVWRWUQVXNVWPDHVWNUURJZVUHUMZVWRWUQVWPWVAVWRVWPVUHVWRKZDWU
      TUFWVAVWRKVWPWVBDWUTVWPVUGWUTNZLUYLVVJVWNVUGVQGNZWVBVWPUYLWVCVYOUUSWVCVVJ
      VWPVUGVWNUUTYEWVCWVDVWPVUGHVWNUVAYEVUGVWNABUVBUVDVFDWUTVUHVWRUVEUVFVWPVWN
      WUTNZVWRWVAKVWPVWNVVLNWVEVWPVWNEVVLVYNVGUVGHVWNUVHTDWUTVUHVWNVWRVUGVWNBQU
      VITUVJVWPDWUTWUPVUHVWPVWNWQNWUTWUPPVWPVWNVYNUVKHVWNUVLTXQUVMXSRVWPWUDVYCW
      USPWUECVXLVUMWUSEVUNWUNVUJWURFWUNUYOVXNVUIWUQWUOWUNDVUFWUPVUHUYNVXLHULXNX
      QUVNRVWBWURFYBYCTYLUVOUVPXIUVQUVRUVSUVTUWAVUEUYFVWOVWTVWSPVWMEUYEVWNFBUWB
      UWCYLUWDUWEFBUWFXPUWGUWHUUAUYRYMUYQYMZCEUWIUYMVUDUYQCEUWJUYMWVFVUDCEUYMVV
      BWVFLZLZUYTVLGZSVUAVUCWVHWVISPZWVISYNYOZSWVIYNYOZWVHWVIONZWVKWVHUYTMKZWVM
      WVHUYTUYENZWVNUYFWVOUYLWVGUYFAEUYHUMZUYTUYEUYFVWDWVPUYTPVWEAEBWNTUYFUYHUY
      ENZAEUFWVPUYENUYFWVQAEEUYEUYGBURVFUYHAUWOTVPWMZUYTVRTZUYTYPTZWVIUWKTWVHVV
      PSWVIYNWVHVVPSPZVVPSUJYOZYMZWVHUYQWWBUYMVVBWVFVOWVHVVQYQVVPUJYOZWWBLZUYQW
      WBWVHVVPONZVVQWWEYRWVHVVOWWFWVHVVEVVOUYFVVBVVEUYLWVFVVGUSZVVRTZUYOYPZTZVV
      PUWLTWVHUYPVVPMWVHVVEVVSWWGVVTTZYKWVHWWDWWBWVHVVOWWDWWHVVOWWFXDVVPYNYOZWW
      DWWIUYOUWMWWFYQXDUJYOZWWLWWDXDMNWWMUWNXDUWPXAYQONXDONWWFWWMWWLLWWDXHUWQUX
      EYQXDVVPUWRUWSUWTYITUXAUXBUXCWVHWWFWWAWWCYRWWJVVPUXDTUXFZWVHUYOUYTKZWVNVV
      PWVIYNYOWVHUYOUYSNZWWOWVHVWDVVBWWPUYFVWDUYLWVGVWEWMUYMVVBWVFUXGEUYNBUXHVK
      ZUYOUYSUXITWVSUYOUYTUXJVKUXKWVHWVMSONWVJWVKWVLLYRWVTUXLWVISUXMWIUXOWVHWVO
      VUAWVIPWVRUYTVMTWVHVUBOKSVUBNVUCSPVUBFUGZOFUYSUXNWWRVWJOVWLWWRVWJKXFUYEVW
      JFYSXAXDSUXPYTYTWVHUYPSVUBWVHUYPVVPSWWKWWNYAWVHUYFWWPUYPVUBNZUYFUYLWVGVBW
      WQUYFFUXQZUYSUYEKWWPWWSXHVWLWWTXFUYEVWJFUXRXAEUYEBYSUYSUYOFUXSVIYIVPVUBUX
      TVIUYAUYBUYCUYD $.
  $}

  ${
    $d f k n x A $.  $d f k x B $.
    $( The measurable sets are closed under countable union.  (Contributed by
       Mario Carneiro, 18-Mar-2014.) $)
    iunmbl2 $p |- ( ( A ~<_ NN /\ A. n e. A B e. dom vol ) ->
                    U_ n e. A B e. dom vol ) $=
      ( vf vk vx cn wbr wcel wral ciun csdm cen wi com ex syl cv cfv wceq mpan2
      cdom cvol cdm wo brdom2 nnenom sdomentr cfn isfinite finiunmbl sylbir wex
      wf1o bren wa ccnv csb wrex nfv nfcv nfcsb1v nfcri nfrex ffvelrnda 3adant3
      f1of simp3 f1ocnvfv1 eqcomd csbeq1a eleqtrd csbeq1d eleq2d rspcev syl2anc
      w3a fveq2 3exp rexlimd f1ocnvdm rspce rexlimdva impbid eliun eqrdv adantr
      3bitr4g rspcsbela sylan an32s ralrimiva iunmbl eqeltrd exlimiv sylbi jaoi
      imp ) AGUBHZBUCUDZICAJZCABKZWTIZWSAGLHZAGMHZUEXAXCNZAGUFXDXFXEXDAOLHZXFXD
      GOMHXGUGAGOUHUAXGAUIIZXFAUJXHXAXCABCUKPULQXEAGDRZUNZDUMXFAGDUOXJXFDXJXAXC
      XJXAUPZXBEGCERZXIUQZSZBURZKZWTXJXBXPTXAXJFXBXPXJFRZBIZCAUSZXQXOIZEGUSZXQX
      BIXQXPIXJXSYAXJXRYACAXJCUTXTCEGCGVACFXOCXNBVBVCZVDXJCRZAIZXRYAXJYDXRVQZYC
      XISZGIZXQCYFXMSZBURZIZYAXJYDYGXRXJAGYCXIAGXIVGVEVFYEXQBYIXJYDXRVHYEYCYHTB
      YITYEYHYCXJYDYHYCTXRAGYCXIVIVFVJCYHBVKQVLXTYJEYFGXLYFTZXOYIXQYKCXNYHBXLYF
      XMVRVMVNVOVPVSVTXJXTXSEGXJXLGIZUPZXNAIZXTXSNAGXLXIWAZYNXTXSXRXTCXNAYBYCXN
      TBXOXQCXNBVKVNWBPQWCWDCXQABWEEXQGXOWEWHWFWGXKXOWTIZEGJXPWTIXKYPEGXJYLXAYP
      YMYNXAYPYOCXNABWTWIWJWKWLXOEWMQWNPWOWPWQWPWR $.
  $}

  ${
    $d n x B $.  $d j k n x C $.  $d n x E $.  $d j k n x F $.  $d j k n x G $.
    $d j k n x H $.  $d j k n x ph $.  $d j k n x z S $.  $d j x z T $.
    $d j x z U $.
    ioombl1.b $e |- B = ( A (,) +oo ) $.
    ioombl1.a $e |- ( ph -> A e. RR ) $.
    ioombl1.e $e |- ( ph -> E C_ RR ) $.
    ioombl1.v $e |- ( ph -> ( vol* ` E ) e. RR ) $.
    ioombl1.c $e |- ( ph -> C e. RR+ ) $.
    ioombl1.s $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
    ioombl1.t $e |- T = seq 1 ( + , ( ( abs o. - ) o. G ) ) $.
    ioombl1.u $e |- U = seq 1 ( + , ( ( abs o. - ) o. H ) ) $.
    ioombl1.f1 $e |- ( ph -> F : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
    ioombl1.f2 $e |- ( ph -> E C_ U. ran ( (,) o. F ) ) $.
    ioombl1.f3 $e |- ( ph -> sup ( ran S , RR* , < ) <_
                       ( ( vol* ` E ) + C ) ) $.
    ioombl1.p $e |- P = ( 1st ` ( F ` n ) ) $.
    ioombl1.q $e |- Q = ( 2nd ` ( F ` n ) ) $.
    ioombl1.g $e |- G = ( n e. NN |->
   <. if ( if ( P <_ A , A , P ) <_ Q , if ( P <_ A , A , P ) , Q ) , Q >. ) $.
    ioombl1.h $e |- H = ( n e. NN |->
   <. P , if ( if ( P <_ A , A , P ) <_ Q , if ( P <_ A , A , P ) , Q ) >. ) $.
    $( Lemma for ~ ioombl1 .  (Contributed by Mario Carneiro, 18-Aug-2014.) $)
    ioombl1lem1 $p |- ( ph ->
                        ( G : NN --> ( <_ i^i ( RR X. RR ) ) /\
                          H : NN --> ( <_ i^i ( RR X. RR ) ) ) ) $=
      ( cn cle cr cxp cin wf wbr cif cop cv wcel wa adantr cfv c1st w3a ovolfcl
      c2nd sylan simp1d syl5eqel ifcl syl2anc min2 df-br sylib opelxpi sylanbrc
      simp2d elin fmptd max1 simp3d 3brtr4g breq2 ifboth jca ) AUJUKULULUMZUNZM
      UOUJWHNUOAJUJEBUKUPZBEUQZFUKUPZWJFUQZFURZWHMAJUSZUJUTZVAZWMUKUTZWMWGUTZWM
      WHUTWPWLFUKUPZWQWPWJULUTZFULUTZWSWPBULUTZEULUTZWTAXBWOPVBZWPEWNLVCZVDVCZU
      LUFWPXFULUTZXEVGVCZULUTZXFXHUKUPZAUJWHLUOWOXGXIXJVEUCLWNVFVHZVIVJZWIBEULV
      KVLZWPFXHULUGWPXGXIXJXKVRVJZWJFVMVLWLFUKVNVOWPWLULUTZXAWRWPWTXAXOXMXNWKWJ
      FULVKVLZXNWLFULULVPVLWMUKWGVSVQUHVTAJUJEWLURZWHNWPXQUKUTZXQWGUTZXQWHUTWPE
      WLUKUPZXRWPEWJUKUPZEFUKUPZXTWPXCXBYAXLXDEBWAVLWPXFXHEFUKWPXGXIXJXKWBUFUGW
      CWKYAYBXTWJFWJWLEUKWDFWLEUKWDWEVLEWLUKVNVOWPXCXOXSXLXPEWLULULVPVLXQUKWGVS
      VQUIVTWF $.

    $( Lemma for ~ ioombl1 .  (Contributed by Mario Carneiro, 18-Aug-2014.) $)
    ioombl1lem2 $p |- ( ph -> sup ( ran S , RR* , < ) e. RR ) $=
      ( crn cxr clt csup wcel covol cfv caddc co cmnf wbr cle wss cc0 cpnf cico
      cr cn wf cxp cin cabs cmin ccom eqid ovolsf syl frn icossxr supxrcl rpred
      syl6ss readdcld mnfxr a1i wfn ffn 1nn fnfvelrn sylancl sseldd 0re icossre
      pnfxr mp2an ffvelrn sseldi mnflt supxrub syl2anc xrltletrd xrre syl22anc
      c1 ) AGUJZUKULUMZUKUNZKUOUPZDUQURZVFUNUSXEULUTXEXHVAUTXEVFUNAXDUKVBZXFAXD
      VCVDVEURZUKAVGXJGVHZXDXJVBAVGVAVFVFVIVJLVHXKUCGLVKVLVMLVMZXLVNTVOVPZVGXJG
      VQVPVCVDVRWAZXDVSVPZAXGDRADSVTWBAUSXCGUPZXEUSUKUNAWCWDAXDUKXPXNAGVGWEZXCV
      GUNZXPXDUNZAXKXQXMVGXJGWFVPWGVGXCGWHWIZWJXOAXPVFUNUSXPULUTAXJVFXPVCVFUNVD
      UKUNXJVFVBWKWMVCVDWLWNAXKXRXPXJUNXMWGVGXJXCGWOWIWPXPWQVPAXIXSXPXEVAUTXNXT
      XDXPWRWSWTUEXEXHXAXB $.

    $( Lemma for ~ ioombl1 .  (Contributed by Mario Carneiro, 18-Aug-2014.) $)
    ioombl1lem3 $p |- ( ( ph /\ n e. NN ) ->
      ( ( ( ( abs o. - ) o. G ) ` n ) + ( ( ( abs o. - ) o. H ) ` n ) ) =
      ( ( ( abs o. - ) o. F ) ` n ) ) $=
      ( cv cn wcel wa cle wbr cif cmin co caddc cabs ccom cfv c2nd c1st cxp cin
      cr wf w3a ovolfcl sylan simp2d syl5eqel recnd adantr ifcl syl2anc npncand
      simp1d wceq ioombl1lem1 simpld eqid ovolfsval cop cvv opex fvmpt2 sylancl
      simpr fveq2d op2ndg eqtrd op1stg oveq12d simprd oveq12i syl6eqr 3eqtr4d )
      AJUJZUKULZUMZFEBUNUOZBEUPZFUNUOZXDFUPZUQURZXFEUQURZUSURFEUQURZWTUTUQVAZMV
      AZVBZWTXJNVAZVBZUSURWTXJLVAZVBZXBFXFEXBFXBFWTLVBZVCVBZVGUGXBXQVDVBZVGULZX
      RVGULZXSXRUNUOZAUKUNVGVGVEVFZLVHZXAXTYAYBVIUCLWTVJVKZVLVMZVNXBXFXBXDVGULZ
      FVGULZXFVGULZXBBVGULZEVGULZYGAYJXAPVOXBEXSVGUFXBXTYAYBYEVSVMZXCBEVGVPVQYF
      XEXDFVGVPVQZVNXBEYLVNVRXBXLXGXNXHUSXBXLWTMVBZVCVBZYNVDVBZUQURZXGAUKYCMVHZ
      XAXLYQVTAYRUKYCNVHZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIWAZWBMXKWTXKWCWD
      VKXBYOFYPXFUQXBYOXFFWEZVCVBZFXBYNUUAVCXBXAUUAWFULYNUUAVTAXAWJZXFFWGJUKUUA
      WFMUHWHWIZWKXBYIYHUUBFVTYMYFXFFVGVGWLVQWMXBYPUUAVDVBZXFXBYNUUAVDUUDWKXBYI
      YHUUEXFVTYMYFXFFVGVGWNVQWMWOWMXBXNWTNVBZVCVBZUUFVDVBZUQURZXHAYSXAXNUUIVTA
      YRYSYTWPNXMWTXMWCWDVKXBUUGXFUUHEUQXBUUGEXFWEZVCVBZXFXBUUFUUJVCXBXAUUJWFUL
      UUFUUJVTUUCEXFWGJUKUUJWFNUIWHWIZWKXBYKYIUUKXFVTYLYMEXFVGVGWLVQWMXBUUHUUJV
      DVBZEXBUUFUUJVDUULWKXBYKYIUUMEVTYLYMEXFVGVGWNVQWMWOWMWOXBXPXRXSUQURZXIAYD
      XAXPUUNVTUCLXOWTXOWCWDVKFXREXSUQUGUFWQWRWS $.

    $( Lemma for ~ ioombl1 .  (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    ioombl1lem4 $p |- ( ph -> ( ( vol* ` ( E i^i B ) ) +
                ( vol* ` ( E \ B ) ) ) <_ ( ( vol* ` E ) + C ) ) $=
      ( vz vx vj vk cin covol cfv caddc co crn cxr clt csup wss cr a1i ovolsscl
      wcel syl3anc cle c0 wne cv wbr wral wrex cc0 cpnf simpld ccom eqid ovolsf
      cn wf syl frn syl6ss cdm c1 1nn wceq fdm syl5eleqr dm0rn0 necon3bii sylib
      ne0i wa ffvelrnda sseldi adantr cseq simpr ovolfsf syl2an elrege0 breqtrd
      nnuz simprd fveq1i cli eqidd wfn syl2anc ralrimiva breq2 ralbidv isumsup2
      rspcev wb breq1 ralrn rexbidv mpbird supxrre adantlr letrd cuni c1st c2nd
      ffn wi cvv sylancl fveq2d eqtrd ad2ant2r ad2antrr mpd syl5bir recnd inss1
      cdif difss readdcld ioombl1lem2 rpred cico cxp ioombl1lem1 cabs 0re pnfxr
      cmin icossre mp2an syl6eleq simpl elfznn addge01d mpbid ioombl1lem3 serle
      cuz cfz 3brtr4g cz 1z icossxr fnfvelrn sylan breqtrrd syl5eqbrr climserle
      supxrub syl5eqbr suprcl addge02d cicc cioo ssralv ax-mp breq1i w3a simp1d
      ovolfcl syl5eqel syl5ss sselda ltle opex fvmpt2 ifcl simp2d op1stg simplr
      cif cop sseldd min1 inss2 sseli ad2antlr rexrd elioo2 eleq2i ltpnf df-3an
      pm4.71i bitr4i 3bitr4g syl6bi ltled simprr ifboth expr syld breq2i op2ndg
      eqbrtrd breq2d sylibrd anim12d reximdva ralimdva ovolfioo 3imtr4d ovollb2
      syl5 ovolficc breq1d wn eldifn biantrurd bitr4d mtbird max2 le2addd seqex
      lenltd eqeltri cc eqcomd seradd oveq12i 3eqtr4g climadd climuni ) AKCUNZU
      OUPZKCUUBZUOUPZUQURZGUSZUTVAVBZKUOUPZDUQURAVUIVUKAVUHKVCZKVDVCZVUOVDVGZVU
      IVDVGVUPAKCUUAZVEQRVUHKVFVHZAVUJKVCZVUQVURVUKVDVGVVAAKCUUCZVEQRVUJKVFVHZU
      UDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUUEZAVUODRADSUUFUUDAVULHUSZVDVAVB
      ZIUSZVDVAVBZUQURZVUNVIAVUIVUKVVFVVHVUTVVCAVVEVDVCZVVEVJVKZUJVLZUKVLZVIVMZ
      UJVVEVNZUKVDVOZVVFVDVGAVVEVPVQUUGURZVDAWBVVQHWCZVVEVVQVCAWBVIVDVDUUHUNZMW
      CZVVRAVVTWBVVSNWCZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUUIZVRZHMUUJUUMVS
      ZMVSZVWEVTZUAWAWDZWBVVQHWEWDVPVDVGVQUTVGZVVQVDVCUUKUULVPVQUUNUUOZWFZAHWGZ
      VJVKZVVKAWHVWKVGVWLAWHWBVWKWIAVVRVWKWBWJVWGWBVVQHWKWDWLVWKWHWPWDVWKVJVVEV
      JHWMWNWOZAVVPULVLZHUPZVVMVIVMZULWBVNZUKVDVOZAVUNVDVGZVWOVUNVIVMZULWBVNZVW
      RVVDAVWTULWBAVWNWBVGZWQZVWOVWNGUPZVUNVXCVVQVDVWOVWIAWBVVQVWNHVWGWRWSZVXCV
      VQVDVXDVWIAWBVVQVWNGAWBVVSLWCZWBVVQGWCZUCGLVWDLVSZVXHVTZTWAWDZWRWSZAVWSVX
      BVVDWTZVXCVWNUQVWEWHXAZUPZVWNUQVXHWHXAZUPZVWOVXDVIVXCJVWEVXHWHVWNVXCVWNWB
      WHUVCUPAVXBXBZXGUUPZVXCAJVLZWBVGZVXSVWEUPZVDVGZVXSWHVWNUVDURVGZAVXBUUQZVX
      SVWNUURZAVXTWQZVVQVDVYAVWIAWBVVQVXSVWEAVVTWBVVQVWEWCVWCMVWEVWFXCWDWRZWSZX
      DVXCAVXTVXSVXHUPZVDVGZVYCVYDVYEVYFVYJVPVYIVIVMZVYFVYIVVQVGVYJVYKWQAWBVVQV
      XSVXHAVXFWBVVQVXHWCUCLVXHVXIXCWDWRVYIXEWOZVRZXDZVXCAVXTVYAVYIVIVMVYCVYDVY
      EVYFVYAVYAVXSVWDNVSZUPZUQURZVYIVIVYFVPVYPVIVMZVYAVYQVIVMVYFVYPVDVGZVYRVYF
      VYPVVQVGVYSVYRWQAWBVVQVXSVYOAVWAWBVVQVYOWCAVVTVWAVWBXHZNVYOVYOVTZXCWDWRVY
      PXEWOZXHZVYFVYAVYPVYHVYFVYSVYRWUBVRZUUSUUTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEU
      FUGUHUIUVAZXFXDUVBVWNHVXMUAXIZVWNGVXOTXIZUVEVXCVXDVXPVUNVIWUGVXCVUNJVXHWH
      VWNWBXGVXQVXCVXOGVUNXJTAGVUNXJVMZVXBAGVUMVDVAVBZVUNXJAUKVYIUMJVXHGWHWBXGT
      WHUVFVGAUVGVEZVYFVYIXKVYMVYFVYJVYKVYLXHZAVWSUMVLZGUPZVUNVIVMZUMWBVNZWUMVV
      MVIVMZUMWBVNZUKVDVOZVVDAWUNUMWBAWULWBVGZWQVUMUTVCZWUMVUMVGZWUNAWUTWUSAVUM
      VVQUTAVXGVUMVVQVCVXJWBVVQGWEWDZVPVQUVHWFWTAGWBXLZWUSWVAAVXGWVCVXJWBVVQGYJ
      WDZWBWULGUVIUVJVUMWUMUVNXMXNWUQWUOUKVUNVDVVMVUNWJZWUPWUNUMWBVVMVUNWUMVIXO
      XPXRXMZXQAVUMVDVCVUMVJVKZVVNUJVUMVNZUKVDVOZVUNWUIWJAVUMVVQVDWVBVWIWFAGWGZ
      VJVKZWVGAWHWVJVGWVKAWHWBWVJWIAVXGWVJWBWJVXJWBVVQGWKWDWLWVJWHWPWDWVJVJVUMV
      JGWMWNWOAWVIWURWVFAWVHWUQUKVDAWVCWVHWUQXSWVDVVNWUPUJUMWBGVVLWUMVVMVIXTYAW
      DYBYCUKUJVUMYDVHUVKZWTUVLAVXTVYJVXBVYMYEAVXTVYKVXBWUKYEUVMUVOZYFXNVWQVXAU
      KVUNVDWVEVWPVWTULWBVVMVUNVWOVIXOXPXRXMZAVVOVWQUKVDAHWBXLZVVOVWQXSAVVRWVOV
      WGWBVVQHYJWDVVNVWPUJULWBHVVLVWOVVMVIXTYAWDYBYCZUKUJVVEUVPVHAVVGVDVCZVVGVJ
      VKZVVNUJVVGVNZUKVDVOZVVHVDVGAVVGVVQVDAWBVVQIWCZVVGVVQVCAVWAWWAVYTINVYOWUA
      UBWAWDZWBVVQIWEWDVWIWFZAIWGZVJVKZWVRAWHWWDVGWWEAWHWBWWDWIAWWAWWDWBWJWWBWB
      VVQIWKWDWLWWDWHWPWDWWDVJVVGVJIWMWNWOZAWVTVWNIUPZVVMVIVMZULWBVNZUKVDVOZAVW
      SWWGVUNVIVMZULWBVNZWWJVVDAWWKULWBVXCWWGVXDVUNVXCVVQVDWWGVWIAWBVVQVWNIWWBW
      RWSZVXKVXLVXCVWNUQVYOWHXAZUPZVXPWWGVXDVIVXCJVYOVXHWHVWNVXRVXCAVXTVYSVYCVY
      DVYEWUDXDVYNVXCAVXTVYPVYIVIVMVYCVYDVYEVYFVYPVYQVYIVIVYFVPVYAVIVMZVYPVYQVI
      VMVYFVYBWWPVYFVYAVVQVGVYBWWPWQVYGVYAXEWOXHZVYFVYPVYAWUDVYHUVQUUTWUEXFXDUV
      BVWNIWWNUBXIZWUGUVEWVMYFXNWWIWWLUKVUNVDWVEWWHWWKULWBVVMVUNWWGVIXOXPXRXMZA
      WVSWWIUKVDAIWBXLZWVSWWIXSAWWAWWTWWBWBVVQIYJWDVVNWWHUJULWBIVVLWWGVVMVIXTYA
      WDYBYCZUKUJVVGUVPVHAVUIVVEUTVAVBZVVFVIAVVTVUHUVRMVSUSYGVCZVUIWXBVIVMVWCAK
      UVSLVSUSYGVCZWXCUDAVXSLUPZYHUPZVVMVAVMZVVMWXEYIUPZVAVMZWQZJWBVOZUKKVNZVXS
      MUPZYHUPZVVMVIVMZVVMWXMYIUPZVIVMZWQZJWBVOZUKVUHVNZWXDWXCWXLWXKUKVUHVNZAWX
      TVUPWXLWYAYKVUSWXKUKVUHKUVTUWAAWXKWXSUKVUHAVVMVUHVGZWQZWXJWXRJWBWYCVXTWQZ
      WXGWXOWXIWXQWXGEVVMVAVMZWYDWXOEWXFVVMVAUFUWBZWYDWYEEVVMVIVMZWXOWYDEVDVGZV
      VMVDVGZWYEWYGYKZAVXTWYHWYBVYFEWXFVDUFVYFWXFVDVGZWXHVDVGZWXFWXHVIVMZAVXFVX
      TWYKWYLWYMUWCUCLVXSUWEUVJZUWDUWFZYEWYCWYIVXTAVUHVDVVMAVUHKVDVUSQUWGZUWHWT
      ZEVVMUWIZXMWYCVXTWYGWXOWYCVXTWYGWQZWQZWXNEBVIVMZBEUWPZFVIVMZXUBFUWPZVVMVI
      AVXTWXNXUDWJWYBWYGVYFWXNXUDFUWQZYHUPZXUDVYFWXMXUEYHVYFVXTXUEYLVGWXMXUEWJA
      VXTXBZXUDFUWJJWBXUEYLMUHUWKYMZYNVYFXUDVDVGZFVDVGZXUFXUDWJVYFXUBVDVGZXUJXU
      IVYFBVDVGZWYHXUKAXULVXTPWTWYOXUABEVDUWLZXMZVYFFWXHVDUGVYFWYKWYLWYMWYNUWMU
      WFZXUCXUBFVDUWLXMZXUOXUDFVDVDUWNXMYOYPWYTXUDXUBVVMAVXTXUIWYBWYGXUPYPAVXTX
      UKWYBWYGXUNYPZWYTVUHVDVVMAVUHVDVCZWYBWYSWYPYQAWYBWYSUWOUWRZWYTXUKXUJXUDXU
      BVIVMXUQAVXTXUJWYBWYGXUOYPXUBFUWSXMWYTBVVMVIVMZWYGXUBVVMVIVMZWYTBVVMAXULW
      YBWYSPYQXUSWYTVVMCVGZBVVMVAVMZWYBXVBAWYSVUHCVVMKCUWTUXAUXBAXVBXVCYKWYBWYS
      AXVBWYIXVCWQZXVCAVVMBVQUVSURZVGZWYIXVCVVMVQVAVMZUWCZXVBXVDABUTVGVWHXVFXVH
      XSABPUXCUULBVQVVMUXDYMCXVEVVMOUXEXVDXVDXVGWQXVHXVDXVGWYIXVGXVCVVMUXFWTUXH
      WYIXVCXVGUXGUXIUXJZWYIXVCXBUXKYQYRUXLWYCVXTWYGUXMXUAXUTWYGXVABEBXUBVVMVIX
      TEXUBVVMVIXTUXNXMYFUXSUXOUXPYSWYDWXIVVMFVIVMZWXQWXIVVMFVAVMZWYDXVJFWXHVVM
      VAUGUXQZWYDWYIXUJXVKXVJYKZWYQAVXTXUJWYBXUOYEVVMFUWIZXMYSWYDWXPFVVMVIAVXTW
      XPFWJWYBVYFWXPXUEYIUPZFVYFWXMXUEYIXUHYNVYFXUIXUJXVOFWJXUPXUOXUDFVDVDUXRXM
      YOYEUXTUYAUYBUYCUYDUYHAVUQVXFWXDWXLXSQUCUKKJLUYEXMZAXURVVTWXCWXTXSWYPVWCU
      KVUHJMUYIXMUYFYRVUHHMUAUYGXMAVVJVVKVVPWXBVVFWJVWJVWMWVPUKUJVVEYDVHXFAVUKV
      VGUTVAVBZVVHVIAVWAVUJUVRNVSUSYGVCZVUKXVQVIVMVYTAWXDXVRUDAWXLVXSNUPZYHUPZV
      VMVIVMZVVMXVSYIUPZVIVMZWQZJWBVOZUKVUJVNZWXDXVRWXLWXKUKVUJVNZAXWFVVAWXLXWG
      YKVVBWXKUKVUJKUVTUWAAWXKXWEUKVUJAVVMVUJVGZWQZWXJXWDJWBXWIVXTWQZWXGXWAWXIX
      WCXWJWXGWYGXWAWXGWYEXWJWYGWYFXWJWYHWYIWYJAVXTWYHXWHWYOYEXWIWYIVXTAVUJVDVV
      MAVUJKVDVVBQUWGZUWHWTZWYRXMYSXWJXVTEVVMVIAVXTXVTEWJXWHVYFXVTEXUDUWQZYHUPZ
      EVYFXVSXWMYHVYFVXTXWMYLVGXVSXWMWJXUGEXUDUWJJWBXWMYLNUIUWKYMZYNVYFWYHXUIXW
      NEWJWYOXUPEXUDVDVDUWNXMYOYEUYJUYAWXIXVKXWJXWCXVLXWJXVKXVJXWCXWJWYIXUJXVMX
      WLAVXTXUJXWHXUOYEXVNXMXWIVXTXVJXWCXWIVXTXVJWQZWQZVVMXUDXWBVIXWQVVMXUBVIVM
      ZXVJVVMXUDVIVMZXWQVVMBXUBXWQVUJVDVVMAVUJVDVCZXWHXWPXWKYQAXWHXWPUWOUWRZAXU
      LXWHXWPPYQZXWQXULWYHXUKXXBAVXTWYHXWHXVJWYOYPZXUMXMXWQVVMBVIVMXVCUYKXWQXVC
      XVBXWHXVBUYKAXWPVVMKCUYLUXBXWQXVCXVDXVBXWQWYIXVCXXAUYMAXVBXVDXSXWHXWPXVIY
      QUYNUYOXWQVVMBXXAXXBUYSYCXWQWYHXULBXUBVIVMXXCXXBEBUYPXMYFXWIVXTXVJUXMXUCX
      WRXVJXWSXUBFXUBXUDVVMVIXOFXUDVVMVIXOUXNXMAVXTXWBXUDWJXWHXVJVYFXWBXWMYIUPZ
      XUDVYFXVSXWMYIXWOYNVYFWYHXUIXXDXUDWJWYOXUPEXUDVDVDUXRXMYOYPUVKUXOUXPYSUYB
      UYCUYDUYHXVPAXWTVWAXVRXWFXSXWKVYTUKVUJJNUYIXMUYFYRVUJINUBUYGXMAWVQWVRWVTX
      VQVVHWJWWCWWFWXAUKUJVVGYDVHXFUYQAGVVIXJVMWUHVVIVUNWJAVVFVVHULHIGWHYLWBXGW
      UJAUKVYAULJVWEHWHWBXGUAWUJVYFVYAXKVYHWWQWVNXQGYLVGAGVXOYLTUQVXHWHUYRUYTVE
      AUKVYPULJVYOIWHWBXGUBWUJVYFVYPXKWUDWUCWWSXQVXCVWOVXEYTVXCWWGWWMYTVXCVXPVX
      NWWOUQURVXDVWOWWGUQURVXCJVWEVYOVXHWHVWNVXRVXCAVXTVYAVUAVGVYCVYDVYEVYFVYAV
      YHYTXDVXCAVXTVYPVUAVGVYCVYDVYEVYFVYPWUDYTXDVXCAVXTVYIVYQWJVYCVYDVYEVYFVYQ
      VYIWUEVUBXDVUCWUGVWOVXNWWGWWOUQWUFWWRVUDVUEVUFWVLVVIVUNGVUGXMXFUEYF $.
  $}

  ${
    $d f m n x y A $.
    $( An open right-unbounded interval is measurable.  (Contributed by Mario
       Carneiro, 16-Jun-2014.)  (Proof shortened by Mario Carneiro,
       25-Mar-2015.) $)
    ioombl1 $p |- ( A e. RR* -> ( A (,) +oo ) e. dom vol ) $=
      ( vx vy vf vm wcel cr cpnf cioo co wss cv cfv caddc cle wbr wa ccom eqid
      cn vn cxr wceq cmnf w3o cvol cdm elxr covol cin cdif cpw wral ioossre a1i
      wi elpwi crp crn cuni cabs cmin c1 cseq clt csup cxp cmap simplrl simplrr
      wrex ovolgelb syl3anc c1st c2nd cif cop cmpt simplll adantr simplr simprl
      simpr wf reex xpex inex2 nnex elmap sylib simprrl simprrr fveq2d ifbieq2d
      fveq2 breq1d breq12d ifbieq12d opeq12d ioombl1lem4 rexlimddv ralrimiva wb
      cbvmptv inss1 ovolsscl mp3an1 adantl difss readdcld simprr alrple syl2anc
      mpbird expr sylan2 ismbl2 sylanbrc oveq1 iooid syl6eq 0mbl syl6eqel rembl
      c0 ioomax 3jaoi sylbi ) AUBFAGFZAHUCZAUDUCZUEAHIJZUFUGZFZAUHYIYNYJYKYIYLG
      KZBLZUIMZGFZYPYLUJZUIMZYPYLUKZUIMZNJZYQOPZUPZBGULZUMYNYOYIAHUNUOYIUUEBUUF
      YPUUFFYIYPGKZUUEYPGUQYIUUGYRUUDYIUUGYRQZQZUUDUUCYQCLZNJZOPZCURUMZUUIUULCU
      RUUIUUJURFZQZYPIDLZRUSUTKZNVAVBRZUUPRVCVDZUSUBVEVFUUKOPZQZUULDOGGVGZUJZTV
      HJZUUOUUGYRUUNUVADUVDVKYIUUGYRUUNVIZYIUUGYRUUNVJZUUIUUNWCYPUUJUUSDUUSSZVL
      VMUUOUUPUVDFZUVAQZQZAYLUUJUALZUUPMZVNMZUVLVOMZUUSNUURETELZUUPMZVNMZAOPZAU
      VQVPZUVPVOMZOPZUVSUVTVPZUVTVQZVRZRVCVDZNUURETUVQUWBVQZVRZRVCVDZUAYPUUPUWD
      UWGYLSYIUUHUUNUVIVSUUOUUGUVIUVEVTUUOYRUVIUVFVTUUIUUNUVIWAUVGUWESUWHSUVJUV
      HTUVCUUPWDUUOUVHUVAWBUVCTUUPUVBOGGWEWEWFWGWHWIWJUUOUVHUUQUUTWKUUOUVHUUQUU
      TWLUVMSUVNSEUATUWCUVMAOPZAUVMVPZUVNOPZUWJUVNVPZUVNVQUVOUVKUCZUWBUWLUVTUVN
      UWMUWAUWKUVSUVTUWJUVNUWMUVSUWJUVTUVNOUWMUVRUWIUVQUVMAUWMUVQUVMAOUWMUVPUVL
      VNUVOUVKUUPWOZWMZWPUWOWNZUWMUVPUVLVOUWNWMZWQUWPUWQWRZUWQWSXDEUATUWFUVMUWL
      VQUWMUVQUVMUWBUWLUWOUWRWSXDWTXAXBUUIUUCGFYRUUDUUMXCUUIYTUUBUUHYTGFZYIYSYP
      KUUGYRUWSYPYLXEYSYPXFXGXHUUHUUBGFZYIUUAYPKUUGYRUWTYPYLXIUUAYPXFXGXHXJYIUU
      GYRXKCUUCYQXLXMXNXOXPXBBYLXQXRYJYLYEYMYJYLHHIJYEAHHIXSHXTYAYBYCYKYLGYMYKY
      LUDHIJGAUDHIXSYFYAYDYCYGYH $.
  $}

  $( A closed unbounded-above interval is measurable.  (Contributed by Mario
     Carneiro, 16-Jun-2014.) $)
  icombl1 $p |- ( A e. RR -> ( A [,) +oo ) e. dom vol ) $=
    ( cr wcel csn cpnf cioo cun cico cvol cdm cxr clt wbr wceq rexr pnfxr ltpnf
    co a1i syl2anc snunioo syl3anc wss covol cfv cc0 snssi ovolsn ioombl1 unmbl
    nulmbl syl eqeltrrd ) ABCZADZAEFRZGZAEHRZIJZUNAKCZEKCZAELMUQURNAOZVAUNPSAQA
    EUAUBUNUOUSCZUPUSCZUQUSCUNUOBUCUOUDUEUFNVCABUGAUHUOUKTUNUTVDVBAUIULUOUPUJTU
    M $.

  $( A closed-below, open-above real interval is measurable.  (Contributed by
     Mario Carneiro, 16-Jun-2014.) $)
  icombl $p |- ( ( A e. RR /\ B e. RR* ) -> ( A [,) B ) e. dom vol ) $=
    ( cr wcel cxr wa clt wbr cico co cpnf cun wceq ad2antrr pnfxr wi c0 syl2anc
    cle wb cvol cdm cdif uncom rexr simplr a1i xrltle sylan imp pnfge syl icoun
    syl32anc syl5eq wss cin ssun1 syl5sseq incom icodisj mp3an3 uneqdifeq mpbid
    icombl1 xrleloe simpr w3a xrre2 expr syl31anc orim1d oveq1 ax-mp ico0 mp2an
    wo mpd mpbir syl6eq 0mbl syl6eqel jaoi difmbl eqeltrrd adantr xrlenlt bitrd
    wn biimpar pm2.61dan ) ACDZBEDZFZABGHZABIJZUAUBZDWNWOFZAKIJZBKIJZUCZWPWQWRW
    TWPLZWSMZXAWPMZWRXBWPWTLZWSWTWPUDWRAEDZWMKEDZABSHZBKSHZXEWSMWLXFWMWOAUEZNZW
    LWMWOUFZXGWROUGZWNWOXHWLXFWMWOXHPXJABUHUIUJWRWMXIXLBUKULZABKUMUNUOZWRWTWSUP
    WTWPUQZQMXCXDTWRXBWTWSWTWPURXOUSWRXPWPWTUQZQWTWPUTWRXFWMXQQMZXKXLXFWMXGXROA
    BKVAVBRUOWTWPWSVCRVDWRWSWQDZWTWQDZXAWQDWLXSWMWOAVENWRBCDZBKMZVQZXTWRBKGHZYB
    VQZYCWRXIYEXNWRWMXGXIYETXLXMBKVFRVDWRYDYAYBWRXFWMXGWOYDYAPXKXLXMWNWOVGXFWMX
    GVHWOYDYAABKVIVJVKVLVRYAXTYBBVEYBWTQWQYBWTKKIJZQBKKIVMYFQMZKKSHZXGYHOKUKVNX
    GXGYGYHTOOKKVOVPVSVTWAWBWCULWSWTWDRWEWNWOWIZFWPQWQWNWPQMZYIWNYJBASHZYIWLXFW
    MYJYKTXJABVOUIWNWMXFYKYITWLWMVGWLXFWMXJWFBAWGRWHWJWAWBWK $.

  ${
    $d w x y z A $.  $d w x y z B $.
    $( An open real interval is measurable.  (Contributed by Mario Carneiro,
       16-Jun-2014.) $)
    ioombl $p |- ( A (,) B ) e. dom vol $=
      ( vx vy vz wcel wa cioo co clt wbr cmnf wceq cico c0 wb cle cr cpnf pnfxr
      cxr cvol cdm csn cdif cun snunioo 3expa adantrr wss cin lbico1 snssd cicc
      iccid ad2antrr ineq1d simpll simplr df-icc df-ioo xrltnle ixxdisj syl3anc
      vw cv eqtr3d uneqdifeq syl2anc mpbid mnfxr a1i simprr simprl xrre2 icombl
      syl32anc covol cfv cc0 ovolsn syl nulmbl difmbl eqeltrrd expr uncom mnfle
      simpr xrlelttrd pnfge df-ico xrltletr ixxun syl5eq ioomax syl6eq syl5sseq
      xrlenlt ssun1 incom rembl wo xrleloe sylancl w3a mp3anl3 orim1d mpd oveq1
      icombl1 ax-mp ico0 mp2an mpbir 0mbl syl6eqel jaoi eleq1d syl5ibcom mpjaod
      wi sylancr wn ioo0 ancoms bitrd biimpar pm2.61dan ndmioo pm2.61i ) AUAFZB
      UAFZGZABHIZUBUCZFZYNABJKZYQYNYRGZLAJKZYQLAMZYNYRYTYQYNYRYTGZGZABNIZAUDZUE
      ZYOYPUUCUUEYOUFUUDMZUUFYOMZYNYRUUGYTYLYMYRUUGABUGUHUIUUCUUEUUDUJUUEYOUKZO
      MUUGUUHPUUCAUUDYNYRAUUDFZYTYLYMYRUUJABULUHUIUMUUCAAUNIZYOUKZUUIOUUCUUKUUE
      YOYLUUKUUEMYMUUBAUOUPUQUUCYLYLYMUULOMYLYMUUBURZUUMYLYMUUBUSZCDEVEAABHQQJJ
      UNCDEUTCDEVAZAVEVFZVBVCVDVGUUEYOUUDVHVIVJUUCUUDYPFZUUEYPFZUUFYPFUUCARFZYM
      UUQUUCLUAFZYLYMYTYRUUSUUTUUCVKVLUUMUUNYNYRYTVMYNYRYTVNLABVOVQZUUNABVPVIUU
      CUUERUJUUEVRVSVTMZUURUUCARUVAUMUUCUUSUVBUVAAWAWBUUEWCVIUUDUUEWDVIWEWFYSLB
      HIZYPFUUAYQYSRBSNIZUEZUVCYPYSUVDUVCUFZRMZUVEUVCMZYSUVFLSHIZRYSUVFUVCUVDUF
      ZUVIUVDUVCWGYSUUTYMSUAFZLBJKBSQKZUVJUVIMUUTYSVKVLZYLYMYRUSZUVKYSTVLZYSLAB
      UVMYLYMYRURZUVNYLLAQKZYMYRAWHUPZYNYRWIWJYSYMUVLUVNBWKWBZCDEVELBSNHJJQJHJQ
      UUOCDEWLZBUUPWSZUUOUUPBSWMLBUUPWMWNVQWOWPWQZYSUVDRUJUVDUVCUKZOMUVGUVHPYSU
      VFUVDRUVDUVCWTUWBWRYSUWCUVCUVDUKZOUVDUVCXAYSUUTYMUVKUWDOMUVMUVNUVOCDEVELB
      SNJJQJHUUOUVTUWAVCVDWOUVDUVCRVHVIVJYSRYPFUVDYPFZUVEYPFXBYSBRFZBSMZXCZUWEY
      SBSJKZUWGXCZUWHYSUVLUWJUVSYSYMUVKUVLUWJPUVNTBSXDXEVJYSUWIUWFUWGYLYMUVKYRU
      WIUWFYBTYLYMUVKXFYRUWIUWFABSVOWFXGXHXIUWFUWEUWGBXKUWGUVDOYPUWGUVDSSNIZOBS
      SNXJUWKOMZSSQKZUVKUWMTSWKXLUVKUVKUWLUWMPTTSSXMXNXOWQXPXQXRWBRUVDWDYCWEUUA
      UVCYOYPLABHXJXSXTYSUVQYTUUAXCZUVRYSUUTYLUVQUWNPVKUVPLAXDYCVJYAYNYRYDZGYOO
      YPYNYOOMZUWOYNUWPBAQKZUWOABYEYMYLUWQUWOPBAWSYFYGYHXPXQYIYNYDYOOYPABYJXPXQ
      YK $.
  $}

  $( A closed real interval is measurable.  (Contributed by Mario Carneiro,
     16-Jun-2014.) $)
  iccmbl $p |- ( ( A e. RR /\ B e. RR ) -> ( A [,] B ) e. dom vol ) $=
    ( cr wcel wa cicc cdif cvol cdm wss wceq iccssre dfss4 sylib cmnf cioo cpnf
    co cun ioombl difreicc unmbl mp2an syl6eqel cmmbl syl eqeltrrd ) ACDBCDEZCC
    ABFRZGZGZUIHIZUHUICJUKUIKABLUICMNUHUJULDUKULDUHUJOAPRZBQPRZSZULABUAUMULDUNU
    LDUOULDOATBQTUMUNUBUCUDUJUEUFUG $.

  $( A closed real interval has finite volume.  (Contributed by Mario Carneiro,
     25-Aug-2014.) $)
  iccvolcl $p |- ( ( A e. RR /\ B e. RR ) -> ( vol ` ( A [,] B ) ) e. RR ) $=
    ( cr wcel wa cicc co cvol cfv covol cdm wceq iccmbl syl wbr c0 cxr rexr cc0
    eqeltrd mblvol clt icc0 syl2an biimpar fveq2 ovol0 syl6eq 0re syl6eqel cmin
    wb cle ovolicc 3expa resubcl ancoms adantr simpr simpl ltlecasei ) ACDZBCDZ
    EZABFGZHIZVEJIZCVDVEHKDVFVGLABMVEUANVDVGCDZBAVDBAUBOZEVEPLZVHVDVJVIVBAQDBQD
    VJVIULVCARBRABUCUDUEVJVGSCVJVGPJISVEPJUFUGUHUIUJNVDABUMOZEVGBAUKGZCVBVCVKVG
    VLLABUNUOVDVLCDZVKVCVBVMBAUPUQURTVBVCUSVBVCUTVAT $.

  $( The measure of an open interval.  (Contributed by Mario Carneiro,
     2-Sep-2014.) $)
  ovolioo $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
                  ( vol* ` ( A (,) B ) ) = ( B - A ) ) $=
    ( cr wcel wbr co covol cfv cvol mblvol syl 3adant3 cun caddc cin c0 wss cc0
    wceq clt cle w3a cioo cmin cdm ioombl ax-mp cicc wa iccmbl cpr a1i cfn prfi
    prssi ovolfi sylancr nulmbl syl2anc csn df-pr ineq2i indi eqtri simp1 ltnrd
    eliooord simpld nsyl disjsn sylibr simp2 simprd uneq12d un0 syl6eq ioossicc
    syl5eq iccssre ovolicc resubcld eqeltrd ovolsscl syl3anc syl5eqel eqtrd 0re
    wn syl6eqel volun syl32anc cxr rexr id prunioo syl3an fveq2d oveq2d addid1d
    recnd 3eqtr3d syl5eqr ) ACDZBCDZABUAEZUBZABUCFZGHZXGIHZBAUDFZXGIUEZDZXIXHSA
    BUFZXGJUGZXFABUHFZIHZXOGHZXIXJXCXDXPXQSZXEXCXDUIXOXKDXRABUJXOJKLXFXGABUKZMZ
    IHZXIXSIHZNFZXPXIXFXLXSXKDZXGXSOZPSXICDYBCDYAYCSXLXFXMULXFXSCQZXSGHZRSZYDXC
    XDYFXEABCUOLZXFXSUMDYFYHABUNYIXSUPUQZXSURUSZXFYEXGAUTZOZXGBUTZOZMZPYEXGYLYN
    MZOYPXSYQXGABVAVBXGYLYNVCVDXFYPPPMPXFYMPYOPXFAXGDZWHYMPSXFAATEZYRXFAXCXDXEV
    EZVFYRYSABTEZAABVGVHVIXGAVJVKXFBXGDZWHYOPSXFBBTEZUUBXFBXCXDXEVLZVFUUBUUAUUC
    BABVGVMVIXGBVJVKVNPVOVPVRXFXIXHCXNXFXGXOQZXOCQZXQCDXHCDUUEXFABVQULXCXDUUFXE
    ABVSLXFXQXJCABVTZXFBAUUDYTWAWBXGXOWCWDWEZXFYBRCXFYBYGRXFYDYBYGSYKXSJKYJWFZW
    GWIXGXSWJWKXFXTXOIXCAWLDXDBWLDXEXEXTXOSAWMBWMXEWNABWOWPWQXFYCXIRNFXIXFYBRXI
    NUUIWRXFXIXFXIUUHWTWSWFXAUUGXAXB $.

  ${
    $d x y $.  $d n x F $.  $d n G $.
    ovolfs2.1 $e |- G = ( ( abs o. - ) o. F ) $.
    $( Alternative expression for the interval length function.  (Contributed
       by Mario Carneiro, 26-Mar-2015.) $)
    ovolfs2 $p |- ( F : NN --> ( <_ i^i ( RR X. RR ) ) ->
      G = ( ( vol* o. (,) ) o. F ) ) $=
      ( vn vx vy cn cle cr wf cv cfv cioo covol wcel co wceq cxr fveq2d feqmptd
      cxp cin cmpt ccom wa c1st c2nd cmin wbr w3a ovolfcl ovolioo syl cop inss2
      ressxr xpss12 mp2an sstri ffvelrn sseldi 1st2nd2 df-ov ovolfsval 3eqtr4rd
      wss syl6eqr mpteq2dva cc0 cpnf cico ovolfsf cpw ioof ffvelrnda cicc ovolf
      id a1i fveq2 fmptco 3eqtr4d ) GHIIUAZUBZAJZDGDKZBLZUCDGWFALZMLZNLZUCBNMUD
      ZAUDWEDGWGWJWEWFGOUEZWHUFLZWHUGLZMPZNLZWNWMUHPZWJWGWLWMIOWNIOWMWNHUIUJWPW
      QQAWFUKWMWNULUMWLWIWONWLWIWMWNUNZMLWOWLWHWRMWLWHRRUAZOWHWRQWLWDWSWHWDWCWS
      HWCUOIRVFZWTWCWSVFUPUPIRIRUQURUSGWDWFAUTVAZWHRRVBUMSWMWNMVCVGSABWFCVDVEVH
      WEDGVIVJVKPBABCVLTWEDEGWSWHEKZMLZNLZWJAWKXAWEDGWDAWEVRTWEEFWSIVMZXCFKZNLX
      DMNWEWSXEXBMWSXEMJWEVNVSZVOWEEWSXEMXGTWEFXEVIVJVPPZNXEXHNJWEVQVSTXFXCNVTW
      AXBWHQXCWINXBWHMVTSWAWB $.
  $}

  ${
    $d f x y z A $.  $d f x y z B $.
    $( An open interval with finite volume has real endpoints.  (Contributed by
       Mario Carneiro, 26-Mar-2015.) $)
    ioorcl2 $p |- ( ( ( A (,) B ) =/= (/) /\ ( vol* ` ( A (,) B ) ) e. RR ) ->
      ( A e. RR /\ B e. RR ) ) $=
      ( vz cioo co covol cfv cr wcel wa cxr clt wbr adantr cle wceq cc0 syl2anc
      wi wss c0 wne cv wex n0 caddc cmin elioore peano2re adantl resubcld rexrd
      c1 eliooxr simpld ltp1 0re simpr ioossre ovolge0 mp1i lep1 letrd subge02d
      a1i mpbid ovolioo syl3anc recnd nncand eqtrd iooss1 sylan simprd eliooord
      wn xrltle mpd iooss2 sstrd ovolss sylancl eqbrtrrd xrlenlt lenltd 3imtr3d
      ex wb mt4d xrre2 syl32anc readdcld addge01d pncan2d jca exlimiv sylbi imp
      ) ABDEZUAUBZWSFGZHIZAHIZBHIZJZWTCUCZWSIZCUDXBXESZCWSUEXGXHCXGXBXEXGXBJZXC
      XDXIXFXAUMUFEZUGEZKIZAKIZXFKIZXKALMZAXFLMZXCXIXKXIXFXJXGXFHIZXBXFABUHNZXB
      XJHIXGXAUIUJZUKZULZXIXMBKIZXGXMYBJXBXFABUNNZUOZXIXFXRULZXIXAXJLMZXOXBYFXG
      XAUPUJZXIAXKOMZXJXAOMZXOVPZYFVPZXIYHYIXIYHJZXKXFDEZFGZXJXAOXIYNXJPYHXIYNX
      FXKUGEZXJXIXKHIXQXKXFOMZYNYOPXTXRXIQXJOMZYPXIQXAXJQHIXIUQVEXGXBURZXSWSHTZ
      QXAOMXIABUSZWSUTVAXBXAXJOMXGXAVBUJVCZXIXFXJXRXSVDVFXKXFVGVHXIXFXJXIXFXRVI
      ZXIXJXSVIZVJVKNYLYMWSTYSYNXAOMYLYMAXFDEZWSXIXMYHYMUUDTYDAXKXFVLVMXIUUDWST
      ZYHXIYBXFBOMZUUEXIXMYBYCVNZXIXFBLMZUUFXIXPUUHXGXPUUHJXBXFABVONZVNZXIXNYBU
      UHUUFSYEUUGXFBVQRVRAXFBVSRNVTYTYMWSWAWBWCWGXIXMXLYHYJWHYDYAAXKWDRXIXJXAXS
      YRWEZWFWIXIXPUUHUUIUOZXKAXFWJWKXIXNYBXFXJUFEZKIZUUHBUUMLMZXDYEUUGXIUUMXIX
      FXJXRXSWLZULZUUJXIYFUUOYGXIUUMBOMZYIUUOVPZYKXIUURYIXIUURJZXFUUMDEZFGZXJXA
      OXIUVBXJPUURXIUVBUUMXFUGEZXJXIXQUUMHIXFUUMOMZUVBUVCPXRUUPXIYQUVDUUAXIXFXJ
      XRXSWMVFXFUUMVGVHXIXFXJUUBUUCWNVKNUUTUVAWSTYSUVBXAOMUUTUVAXFBDEZWSXIYBUUR
      UVAUVETUUGXFUUMBVSVMXIUVEWSTZUURXIXMAXFOMZUVFYDXIXPUVGUULXIXMXNXPUVGSYDYE
      AXFVQRVRAXFBVLRNVTYTUVAWSWAWBWCWGXIUUNYBUURUUSWHUUQUUGUUMBWDRUUKWFWIXFBUU
      MWJWKWOWGWPWQWR $.
  $}

  ${
    $d a b w x y z A $.  $d w x y z B $.  $d a b F $.
    ioorf.1 $e |- F = ( x e. ran (,) |-> if ( x = (/) , <. 0 , 0 >. ,
      <. sup ( x , RR* , `' < ) , sup ( x , RR* , < ) >. ) ) $.
    $( Define a function from open intervals to their endpoints.  (Contributed
       by Mario Carneiro, 26-Mar-2015.) $)
    ioorf $p |- F : ran (,) --> ( <_ i^i ( RR* X. RR* ) ) $=
      ( va vb vy vz vw cioo cle cxr cv c0 wceq cc0 clt csup wcel wa wbr crn cxp
      cin cop ccnv cif co wrex cr cpw wf wfn wb ioof ffn ovelrn mp2b 0le0 df-br
      mpbi 0xr opelxpi mp2an mpbir2an a1i wn simplr supeq1d wne simplll simpllr
      elin simpr neneqad eqnetrrd df-ioo idd xrltle ixxlb syl3anc eqtrd opeq12d
      ixxub ioon0 ad2antrr mpbid wi mpd sylib sylanbrc eqeltrd ifclda rexlimivv
      ex sylbi fmpti ) AIUAZJKKUBZUCZALZMNZOOUDZWTKPUEZQZWTKPQZUDZUFZBCWTWQRZWT
      DLZELZIUGZNZEKUHDKUHZXGWSRZWRUIUJZIUKIWRULXHXMUMUNWRXOIUODEKKWTIUPUQXLXND
      EKKXIKRZXJKRZSZXLXNXRXLSZXAXBXFWSXBWSRZXSXASXTXBJRZXBWRRZOOJTYAUROOJUSUTO
      KRZYCYBVAVAOOKKVBVCXBJWRVLVDVEXSXAVFZSZXFXIXJUDZWSYEXDXIXEXJYEXDXKKXCQZXI
      YEKWTXKXCXRXLYDVGZVHYEXPXQXKMVIZYGXINXPXQXLYDVJZXPXQXLYDVKZYEWTXKMYHYEWTM
      XSYDVMVNVOZAFGHXIXJPPIAFGVPZHLZKRZXQSYNXJPTVQZYNXJVRZXPYOSXIYNPTVQZXIYNVR
      ZVSVTWAYEXEXKKPQZXJYEKWTXKPYHVHYEXPXQYIYTXJNYJYKYLAFGHXIXJPPIYMYPYQYRYSWC
      VTWAWBYEYFJRZYFWRRZYFWSRYEXIXJJTZUUAYEXIXJPTZUUCYEYIUUDYLXRYIUUDUMXLYDXIX
      JWDWEWFXRUUDUUCWGXLYDXIXJVRWEWHXIXJJUSWIXRUUBXLYDXIXJKKVBWEYFJWRVLWJWKWLW
      NWMWOWP $.

    $( Define a function from open intervals to their endpoints.  (Contributed
       by Mario Carneiro, 26-Mar-2015.) $)
    ioorval $p |- ( A e. ran (,) -> ( F ` A ) = if ( A = (/) , <. 0 , 0 >. ,
      <. sup ( A , RR* , `' < ) , sup ( A , RR* , < ) >. ) ) $=
      ( cv c0 wceq cc0 cop cxr clt ccnv csup cif cioo eqeq1 supeq1 opeq12d opex
      crn ifbieq2d ifex fvmpt ) ABAEZFGZHHIZUDJKLZMZUDJKMZIZNBFGZUFBJUGMZBJKMZI
      ZNOTCUDBGZUEUKUJUNUFUDBFPUOUHULUIUMJUDBUGQJUDBKQRUADUKUFUNHHSULUMSUBUC $.

    $( The function ` F ` is an "inverse" of sorts to the open interval
       function.  (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    ioorinv2 $p |- ( ( A (,) B ) =/= (/) ->
      ( F ` ( A (,) B ) ) = <. A , B >. ) $=
      ( vy vz vw cioo c0 wceq cc0 cop cxr clt csup wcel cv wa wbr ccnv ioorebas
      wne cfv cif crn ioorval ax-mp ifnefalse wex eliooxr exlimiv simpld simprd
      co n0 sylbi id df-ioo idd xrltle ixxlb syl3anc ixxub opeq12d eqtrd syl5eq
      ) BCIUOZJUCZVHDUDZVHJKLLMZVHNOUAPZVHNOPZMZUEZBCMZVHIUFQVJVOKBCUBAVHDEUGUH
      VIVOVNVPVHJVKVNUIVIVLBVMCVIBNQZCNQZVIVLBKVIVQVRVIARZVHQZAUJVQVRSZAVHUPVTW
      AAVSBCUKULUQZUMZVIVQVRWBUNZVIURZAFGHBCOOIAFGUSZHRZNQZVRSWGCOTUTZWGCVAZVQW
      HSBWGOTUTZBWGVAZVBVCVIVQVRVIVMCKWCWDWEAFGHBCOOIWFWIWJWKWLVDVCVEVFVG $.

    $( The function ` F ` is an "inverse" of sorts to the open interval
       function.  (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    ioorinv $p |- ( A e. ran (,) -> ( (,) ` ( F ` A ) ) = A ) $=
      ( va vb cioo wcel c0 wceq cfv cv co cxr wrex wi wne cop fveq2d cc0 crn wn
      cxp cr cpw wf wfn wb ioof ffn ovelrn mp2b wa ioorinv2 df-ov syl6eqr df-ne
      neeq1 syl5bbr fveq2 id eqeq12d imbi12d mpbiri a1i rexlimivv clt ccnv csup
      sylbi cif ioorebas ioorval ax-mp iooid iftrue eqtri fveq2i eqtr4i biimpri
      eqeq2i 3eqtr4a pm2.61d2 ) BGUAZHZBIJZBCKZGKZBJZWEBELZFLZGMZJZFNOENOZWFUBZ
      WIPZNNUCZUDUEZGUFGWQUGWEWNUHUIWQWRGUJEFNNBGUKULWMWPEFNNWMWPPWJNHWKNHUMWMW
      PWLIQZWLCKZGKZWLJZPWSXAWJWKRZGKWLWSWTXCGAWJWKCDUNSWJWKGUOUPWMWOWSWIXBWOBI
      QWMWSBIUQBWLIURUSWMWHXABWLWMWGWTGBWLCUTSWMVAVBVCVDVEVFVJWFTTGMZCKZGKZXDWH
      BXFTTRZGKXDXEXGGXEXDIJZXGXDNVGVHVIXDNVGVIRZVKZXGXDWDHXEXJJTTVLAXDCDVMVNXH
      XJXGJTVOZXHXGXIVPVNVQVRTTGUOVSWFWGXEGWFBXDCBXDJWFXDIBXKWAVTZSSXLWBWC $.

    $( The function ` F ` does not always return real numbers, but it does on
       intervals of finite volume.  (Contributed by Mario Carneiro,
       26-Mar-2015.) $)
    ioorcl $p |- ( ( A e. ran (,) /\ ( vol* ` A ) e. RR ) ->
      ( F ` A ) e. ( <_ i^i ( RR X. RR ) ) ) $=
      ( va vb cioo wcel covol cfv cr wa cle cxp cxr c0 wceq cc0 cop wi ffvelrni
      crn cin inss1 adantr sseldi clt ccnv csup cif ioorval iftrue sylan9eq 0re
      ioorf opelxpi mp2an syl6eqel wne cv co wrex cpw wf wfn wb ioof ffn ovelrn
      ioorinv2 adantl ioorcl2 ancoms eqeltrd fveq2 eleq1d neeq1 anbi12d imbi12d
      mp2b syl mpbiri a1i rexlimivv sylbi impl pm2.61dane elin sylanbrc ) BGUBZ
      HZBIJZKHZLZBCJZMHWOKKNZHZWOMWPUCHWNMOONZUCZMWOMWRUDWKWOWSHWMWJWSBCACDUOUA
      UEUFWNWQBPWNBPQZLWORRSZWPWNWTWOWTXABOUGUHUIBOUGUISZUJZXAWKWOXCQWMABCDUKUE
      WTXAXBULUMRKHZXDXAWPHUNUNRRKKUPUQURWKWMBPUSZWQWKBEUTZFUTZGVAZQZFOVBEOVBZW
      MXELZWQTZWRKVCZGVDGWRVEWKXJVFVGWRXMGVHEFOOBGVIVTXIXLEFOOXIXLTXFOHXGOHLXIX
      LXHIJZKHZXHPUSZLZXHCJZWPHZTXQXRXFXGSZWPXPXRXTQXOAXFXGCDVJVKXQXFKHXGKHLZXT
      WPHXPXOYAXFXGVLVMXFXGKKUPWAVNXIXKXQWQXSXIWMXOXEXPXIWLXNKBXHIVOVPBXHPVQVRX
      IWOXRWPBXHCVOVPVSWBWCWDWEWFWGWOMWPWHWI $.
  $}

  ${
    $d a f i j k n r x y z F $.  $d a i j k m n w x y z G $.  $d j n x y z K $.
    $d a j k m n x y z A $.  $d a i j k m n x y z C $.  $d i j k n w x y z M $.
    $d m n E $.  $d n x y z H $.  $d n x y z J $.  $d i j n z N $.  $d n y S $.
    $d a f i j k m n r x y z ph $.  $d a i j k m n x y z T $.
    uniioombl.1 $e |- ( ph -> F : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
    $( A union of closed intervals differs from the equivalent union of open
       intervals by a nullset.  (Contributed by Mario Carneiro,
       25-Mar-2015.) $)
    uniiccdif $p |- ( ph -> ( U. ran ( (,) o. F ) C_ U. ran ( [,] o. F ) /\
      ( vol* ` ( U. ran ( [,] o. F ) \ U. ran ( (,) o. F ) ) ) = 0 ) ) $=
      ( vx cioo cicc wss cfv wceq c1st c2nd cn wcel cr wbr syl wfn cvv cdom com
      ccom crn cuni cdif covol cc0 cima cun ssun1 cv ciun csn wa co cpr cle w3a
      cxp cin wf ovolfcl sylan cxr rexr id prunioo syl3an fvco3 inss2 ffvelrnda
      sseldi 1st2nd2 df-ov syl6eqr eqtrd df-pr preq12d syl5eqr uneq12d 3eqtr4rd
      cop fveq2d iuneq2dv cpw ffn ax-mp ressxr xpss12 mp2an sstri sylancl fnfco
      iccf fss sylancr fniunfv iunun ioof wfun cdm wfo fo1st fofn fnfun eqimss2
      fndm 3syl dfimafn2 syl2anc fnima eqtr3d rnco2 syl6eq fo2nd syl5eq 3eqtr3d
      ssv syl5sseqr ovolficcss ssdifssd cen ccrd cres con0 omelon nnenom ensymi
      isnumi fofun fof fdmi sseqtr4i fores dffn4 sylib foco mpsyl domentr unctb
      fodomnum reldom brrelexi ssid syl5sseq ssundif ssdomg sylc domtr ovolctb2
      jca ) AEBUAZUBUCZFBUAZUBUCZGUUNUULUDZUEHUFIZAUULJBUBZUGZKUUQUGZUHZUHZUULU
      UNUULUUTUIADLDUJZUUMHZUKZDLUVBUUKHZUVBJBUAZHZULZUVBKBUAZHZULZUHZUHZUKZUUN
      UVAADLUVCUVMAUVBLMZUMZUVBBHZJHZUVQKHZEUNZUVRUVSUOZUHZUVRUVSFUNZUVMUVCUVPU
      VRNMZUVSNMZUVRUVSUPOZUQZUWBUWCIZALUPNNURZUSZBUTZUVOUWGCBUVBVAVBUWDUVRVCMU
      WEUVSVCMUWFUWFUWHUVRVDUVSVDUWFVEUVRUVSVFVGPUVPUVEUVTUVLUWAUVPUVEUVQEHZUVT
      AUWKUVOUVEUWLICLUWJUVBEBVHVBUVPUWLUVRUVSWAZEHUVTUVPUVQUWMEUVPUVQUWIMUVQUW
      MIUVPUWJUWIUVQUPUWIVIZALUWJUVBBCVJVKUVQNNVLPZWBUVRUVSEVMVNVOUVPUVLUVGUVJU
      OUWAUVGUVJVPUVPUVGUVRUVJUVSAUWKUVOUVGUVRICLUWJUVBJBVHVBAUWKUVOUVJUVSICLUW
      JUVBKBVHVBVQVRVSUVPUVCUVQFHZUWCAUWKUVOUVCUWPICLUWJUVBFBVHVBUVPUWPUWMFHUWC
      UVPUVQUWMFUWOWBUVRUVSFVMVNVOVTWCAUUMLQZUVDUUNIAFVCVCURZQZLUWRBUTZUWQUWRVC
      WDZFUTUWSWMUWRUXAFWEWFAUWKUWJUWRGUWTCUWJUWIUWRUWNNVCGZUXBUWIUWRGWGWGNVCNV
      CWHWIWJLUWJUWRBWNWKZUWRLFBWLWODLUUMWPPAUVNDLUVEUKZDLUVLUKZUHUVADLUVEUVLWQ
      AUXDUULUXEUUTAUUKLQZUXDUULIAEUWRQZUWTUXFUWRNWDZEUTUXGWRUWRUXHEWEWFUXCUWRL
      EBWLWODLUUKWPPAUXEDLUVHUKZDLUVKUKZUHUUTDLUVHUVKWQAUXIUURUXJUUSAUXIUVFUBZU
      URAUVFLUGZUXIUXKAUVFWSZLUVFWTZGZUXLUXIIAUVFLQZUXMAJRQZLRBUTZUXPRRJXAZUXQX
      BRRJXCWFAUWKUWJRGUXRCUWJXQLUWJRBWNWKZRLJBWLWOZLUVFXDPAUXPUXNLIUXOUYALUVFX
      FLUXNXEXGDLUVFXHXIAUXPUXLUXKIUYALUVFXJPXKJBXLXMAUXJUVIUBZUUSAUVILUGZUXJUY
      BAUVIWSZLUVIWTZGZUYCUXJIAUVILQZUYDAKRQZUXRUYGRRKXAZUYHXNRRKXCWFUXTRLKBWLW
      OZLUVIXDPAUYGUYELIUYFUYJLUVIXFLUYEXEXGDLUVIXHXIAUYGUYCUYBIUYJLUVIXJPXKKBX
      LXMVSXOVSXOXPZXRAUUONGUUOLSOZUUPAUUNNUULAUWKUUNNGCBXSPXTAUUOTSOZTLYAOZUYL
      AUUOUUTSOZUUTTSOZUYMAUUTRMZUUOUUTGZUYOAUYPUYQAUURTSOZUUSTSOZUYPAUURLSOZLT
      YAOZUYSLYBWTMZALUURJUUQYCZBUAZXAZVUATYDMUYNVUCYELTYFYGZTLYHWIZAUUQUURVUDX
      AZLUUQBXAZVUFJWSZUUQJWTZGVUIUXSVUKXBRRJYIWFUUQRVULUUQXQZRRJUXSRRJUTXBRRJY
      JWFYKYLUUQJYMWIABLQZVUJAUWKVUNCLUWJBWEPLBYNYOZLUUQUURVUDBYPWOLUURVUEYTYQY
      FUURLTYRWKAUUSLSOZVUBUYTVUCALUUSKUUQYCZBUAZXAZVUPVUHAUUQUUSVUQXAZVUJVUSKW
      SZUUQKWTZGVUTUYIVVAXNRRKYIWFUUQRVVBVUMRRKUYIRRKUTXNRRKYJWFYKYLUUQKYMWIVUO
      LUUQUUSVUQBYPWOLUUSVURYTYQYFUUSLTYRWKUURUUSYSXIZUUTTSUUAUUBPAUUNUVAGUYRAU
      UNUUNUVAUUNUUCUYKUUDUUNUULUUTUUEYOUUOUUTRUUFUUGVVCUUOUUTTUUHXIVUGUUOTLYRW
      KUUOUUIXIUUJ $.

    uniioombl.2 $e |- ( ph -> Disj_ x e. NN ( (,) ` ( F ` x ) ) ) $.
    uniioombl.3 $e |- S = seq 1 ( + , ( ( abs o. - ) o. F ) ) $.
    $( A disjoint union of open intervals has volume equal to the sum of the
       volume of the intervals.  (This proof does not use countable choice,
       unlike ~ voliun .)  Lemma 565Ca of [Fremlin5] p. 213.  (Contributed by
       Mario Carneiro, 26-Mar-2015.) $)
    uniioovol $p |- ( ph ->
      ( vol* ` U. ran ( (,) o. F ) ) = sup ( ran S , RR* , < ) ) $=
      ( cioo covol cfv cxr wceq cle wbr cn cr wf wss wcel syl ccom crn cuni clt
      vy vn csup cxp cin ssid ovollb sylancl cv wral wa c1 cfz co ciun cvol csu
      caddc cabs cmin cseq c2nd c1st adantr elfznn eqid ovolfsval cdm fvco3 cop
      syl2an inss2 ffvelrn sseldi 1st2nd2 fveq2d syl6eqr ioombl syl6eqel mblvol
      df-ov eqtrd w3a ovolfcl ovolioo 3eqtrd eqtr4d nnuz syl6eleq simp2d simp1d
      cuz simpr resubcld eqeltrd recnd fsumser fveq1i cfn wdisj fzfid ralrimiva
      syl6reqr jca ssriv sylan disjeq2dv mpbird disjss1 mpsyl volfiniun syl3anc
      finiunmbl syl2anc 3eqtr2d iunss1 mp1i cpw wfn ioof ressxr mp2an sstri fss
      xpss12 fco sylancr ffn fniunfv 3syl sseqtrd frn sspwuni cc0 cpnf wb sylib
      ovolss eqbrtrd ovolsf breq1 ralrn icossxr syl6ss ovolcl supxrleub supxrcl
      cico xrletri3 mpbir2and ) AHDUAZUBZUCZIJZCUBZKUDUGZLZUURUUTMNZUUTUURMNZAO
      MPPUHZUIZDQZUUQUUQRUVBEUUQUJUUQCDGUKULAUVCUEUMZUURMNZUEUUSUNZAUVIUFUMZCJZ
      UURMNZUFOUNZAUVLUFOAUVJOSZUOZUVKBUPUVJUQURZBUMZUUOJZUSZIJZUURMUVOUVKUVPUV
      RUTJZBVAZUVSUTJZUVTUVOUWBUVJVBVCVDUADUAZUPVEZJUVKUVOUWABUWDUPUVJUVOUVQUVP
      SZUOZUVQUWDJZUVQDJZVFJZUWIVGJZVDURZUWAUVOUVFUVQOSZUWHUWLLUWFAUVFUVNEVHZUV
      QUVJVIZDUWDUVQUWDVJZVKVOUWGUWAUVRIJZUWKUWJHURZIJZUWLUWGUVRUTVLZSZUWAUWQLU
      WGUVRUWRUWTUWGUVRUWIHJZUWRUVOUVFUWMUVRUXBLZUWFUWNUWOOUVEUVQHDVMZVOUWGUXBU
      WKUWJVNZHJUWRUWGUWIUXEHUWGUWIUVDSUWIUXELUWGUVEUVDUWIMUVDVPZUVOUVFUWMUWIUV
      ESUWFUWNUWOOUVEUVQDVQVOVRUWIPPVSTVTUWKUWJHWEWAWFZUWKUWJWBWCZUVRWDTUWGUVRU
      WRIUXGVTUWGUWKPSZUWJPSZUWKUWJMNZWGZUWSUWLLUVOUVFUWMUXLUWFUWNUWODUVQWHVOZU
      WKUWJWITWJZWKUVOUVJOUPWPJAUVNWQWLWMUWGUWAUWGUWAUWLPUXNUWGUWJUWKUWGUXIUXJU
      XKUXMWNUWGUXIUXJUXKUXMWOWRWSZWTXAUVJCUWEGXBXGUVOUVPXCSZUXAUWAPSZUOZBUVPUN
      BUVPUVRXDZUWCUWBLUVOUPUVJXEZUVOUXRBUVPUWGUXAUXQUXHUXOXHXFUVPORZUVOBOUVRXD
      ZUXSBUVPOUWOXIZAUYBUVNAUYBBOUXBXDFABOUVRUXBAUVFUWMUXCEUXDXJXKXLVHBUVPOUVR
      XMXNUVPUVRBXOXPUVOUVSUWTSZUWCUVTLUVOUXPUXABUVPUNUYDUXTUVOUXABUVPUXHXFUVPU
      VRBXQXRUVSWDTXSUVOUVSUUQRUUQPRZUVTUURMNUVOUVSBOUVRUSZUUQUYAUVSUYFRUVOUYCB
      UVPOUVRXTYAUVOOPYBZUUOQZUUOOYCUYFUUQLAUYHUVNAKKUHZUYGHQOUYIDQZUYHYDAUVFUV
      EUYIRUYJEUVEUVDUYIUXFPKRZUYKUVDUYIRYEYEPKPKYIYFYGOUVEUYIDYHULOUYIUYGHDYJY
      KZVHOUYGUUOYLBOUUOYMYNYOAUYEUVNAUUPUYGRZUYEAUYHUYMUYLOUYGUUOYPTUUPPYQUUAZ
      VHUVSUUQUUBXRUUCXFAOYRYSUULURZCQZCOYCUVIUVMYTAUVFUYPECDUWDUWPGUUDZTOUYOCY
      LUVHUVLUEUFOCUVGUVKUURMUUEUUFYNXLAUUSKRZUURKSZUVCUVIYTAUUSUYOKAUVFUYPUUSU
      YOREUYQOUYOCYPYNYRYSUUGUUHZAUYEUYSUYNUUQUUITZUEUUSUURUUJXRXLAUYSUUTKSZUVA
      UVBUVCUOYTVUAAUYRVUBUYTUUSUUKTUURUUTUUMXRUUN $.

    $( An almost-disjoint union of closed intervals (disjoint interiors) has
       volume equal to the sum of the volume of the intervals.  (This proof
       does not use countable choice, unlike ~ voliun .)  (Contributed by Mario
       Carneiro, 25-Mar-2015.) $)
    uniiccvol $p |- ( ph ->
      ( vol* ` U. ran ( [,] o. F ) ) = sup ( ran S , RR* , < ) ) $=
      ( cicc ccom cfv cxr wceq cle cn cr wf wss cioo wcel syl crn cuni clt csup
      covol wbr cxp cin ssid ovollb2 sylancl uniioovol cv ciun wral wa c1st cop
      co ioossicc df-ov 3sstr3i a1i inss2 ffvelrn sseldi 1st2nd2 fveq2d 3sstr4d
      c2nd fvco3 sylan ralrimiva ss2iun wfn cpw ax-mp ressxr xpss12 mp2an sstri
      ioof ffn fss fnfco sylancr fniunfv iccf 3sstr3d ovolficcss ovolss syl2anc
      eqbrtrrd wb ovolcl cc0 cpnf cico cabs cmin eqid ovolsf frn icossxr syl6ss
      supxrcl xrletri3 mpbir2and ) AHDIZUAUBZUEJZCUAZKUCUDZLZXKXMMUFZXMXKMUFZAN
      MOOUGZUHZDPZXJXJQXOEXJUIXJCDGUJUKARDIZUAUBZUEJZXMXKMABCDEFGULAYAXJQXJOQZY
      BXKMUFABNBUMZXTJZUNZBNYDXIJZUNZYAXJAYEYGQZBNUOYFYHQAYIBNAXSYDNSZYIEXSYJUP
      ZYDDJZRJZYLHJZYEYGYKYLUQJZYLVJJZURZRJZYQHJZYMYNYRYSQYKYOYPRUSYOYPHUSYRYSY
      OYPUTYOYPRVAYOYPHVAVBVCYKYLYQRYKYLXQSYLYQLYKXRXQYLMXQVDZNXRYDDVEVFYLOOVGT
      ZVHYKYLYQHUUAVHVINXRYDRDVKNXRYDHDVKVIVLVMBNYEYGVNTAXTNVOZYFYALARKKUGZVOZN
      UUCDPZUUBUUCOVPZRPUUDWBUUCUUFRWCVQAXSXRUUCQUUEEXRXQUUCYTOKQZUUGXQUUCQVRVR
      OKOKVSVTWANXRUUCDWDUKZUUCNRDWEWFBNXTWGTAXINVOZYHXJLAHUUCVOZUUEUUIUUCKVPZH
      PUUJWHUUCUUKHWCVQUUHUUCNHDWEWFBNXIWGTWIAXSYCEDWJTZYAXJWKWLWMAXKKSZXMKSZXN
      XOXPUPWNAYCUUMUULXJWOTAXLKQUUNAXLWPWQWRUSZKANUUOCPZXLUUOQAXSUUPECDWSWTIDI
      ZUUQXAGXBTNUUOCXCTWPWQXDXEXLXFTXKXMXGWLXH $.

    ${
      uniioombl.a $e |- A = U. ran ( (,) o. F ) $.
      uniioombl.e $e |- ( ph -> ( vol* ` E ) e. RR ) $.
      uniioombl.c $e |- ( ph -> C e. RR+ ) $.
      uniioombl.g $e |- ( ph -> G : NN --> ( <_ i^i ( RR X. RR ) ) ) $.
      uniioombl.s $e |- ( ph -> E C_ U. ran ( (,) o. G ) ) $.
      uniioombl.t $e |- T = seq 1 ( + , ( ( abs o. - ) o. G ) ) $.
      uniioombl.v $e |- ( ph ->
        sup ( ran T , RR* , < ) <_ ( ( vol* ` E ) + C ) ) $.
      $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
         25-Mar-2015.) $)
      uniioombllem1 $p |- ( ph -> sup ( ran T , RR* , < ) e. RR ) $=
        ( cr crn wss c0 wne cxr clt csup cpnf wbr wcel cc0 co cn wf cle cxp cin
        cico cabs cmin ccom eqid ovolsf syl frn 0re pnfxr icossre syl6ss cdm c1
        mp2an 1nn wceq fdm syl5eleqr dm0rn0 necon3bii sylib covol caddc icossxr
        ne0i cfv supxrcl rpred readdcld rexrd ltpnf xrlelttrd supxrbnd syl3anc
        a1i ) AFUAZTUBWNUCUDZWNUEUFUGZUHUFUIWPTUJAWNUKUHURULZTAUMWQFUNZWNWQUBAU
        MUOTTUPUQIUNWRPFIUSUTVAIVAZWSVBRVCVDZUMWQFVEVDZUKTUJUHUEUJZWQTUBVFVGUKU
        HVHVLVIAFVJZUCUDZWOAVKXCUJXDAVKUMXCVMAWRXCUMVNWTUMWQFVOVDVPXCVKWCVDXCUC
        WNUCFVQVRVSAWPGVTWDZDWAULZUHAWNUEUBWPUEUJAWNWQUEXAUKUHWBVIWNWEVDAXFAXED
        NADOWFWGZWHXBAVGWMSAXFTUJXFUHUFUIXGXFWIVDWJWNWKWL $.

      $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      uniioombllem2a $p |- ( ( ( ph /\ J e. NN ) /\ z e. NN ) ->
        ( ( (,) ` ( F ` z ) ) i^i ( (,) ` ( G ` J ) ) ) e. ran (,) ) $=
        ( cn wcel wa cv cfv cioo cin c1st cle wbr cif c2nd co crn cop cxp inss2
        cr wceq wf adantr ffvelrnda sseldi 1st2nd2 fveq2d df-ov syl6eqr ineq12d
        syl cxr ovolfcl sylan simp1d rexrd simp2d iooin syl22anc eqtrd ioorebas
        w3a syl6eqel ) AKUBUCZUDZCUEZUBUCZUDZWEIUFZUGUFZKJUFZUGUFZUHZWHUIUFZWJU
        IUFZUJUKWNWMULZWHUMUFZWJUMUFZUJUKWPWQULZUGUNZUGUOWGWLWMWPUGUNZWNWQUGUNZ
        UHZWSWGWIWTWKXAWGWIWMWPUPZUGUFWTWGWHXCUGWGWHUSUSUQZUCWHXCUTWGUJXDUHZXDW
        HUJXDURZWDUBXEWEIAUBXEIVAZWCLVBZVCVDWHUSUSVEVJVFWMWPUGVGVHWDWKXAUTWFWDW
        KWNWQUPZUGUFXAWDWJXIUGWDWJXDUCWJXIUTWDXEXDWJXFAUBXEKJRVCVDWJUSUSVEVJVFW
        NWQUGVGVHVBVIWGWMVKUCWPVKUCWNVKUCZWQVKUCZXBWSUTWGWMWGWMUSUCZWPUSUCZWMWP
        UJUKZWDXGWFXLXMXNWAXHIWEVLVMZVNVOWGWPWGXLXMXNXOVPVOWDXJWFWDWNWDWNUSUCZW
        QUSUCZWNWQUJUKZAUBXEJVAWCXPXQXRWARJKVLVMZVNVOVBWDXKWFWDWQWDXPXQXRXSVPVO
        VBWMWPWNWQVQVRVSWOWRVTWB $.

      ${
        uniioombllem2.h $e |- H = ( z e. NN |->
          ( ( (,) ` ( F ` z ) ) i^i ( (,) ` ( G ` J ) ) ) ) $.
        uniioombllem2.k $e |- K = ( x e. ran (,) |->
          if ( x = (/) , <. 0 , 0 >. ,
          <. sup ( x , RR* , `' < ) , sup ( x , RR* , < ) >. ) ) $.
        $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
           26-Mar-2015.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
        uniioombllem2 $p |- ( ( ph /\ J e. NN ) -> seq 1 ( + , ( vol* o. H ) )
          ~~> ( vol* ` ( ( (,) ` ( G ` J ) ) i^i A ) ) ) $=
          ( vn vy cn wcel wa caddc cabs cmin ccom c1 cseq crn cr clt csup covol
          cfv cioo cin cli cv nnuz eqid cz 1z a1i eqidd cc0 cle wbr cpnf co cxp
          cico wf cmpt uniioombllem2a wss inss2 c1st c2nd wceq ffvelrnda sseldi
          cop 1st2nd2 syl fveq2d df-ov syl6eqr ioossre syl6eqss ovolfcl ovolioo
          w3a sylan eqtrd simp2d simp1d resubcld eqeltrd ovolsscl adantr ioorcl
          syl3anc syl2anc fmptd cxr ioorf feqmptd fveq2 fmptco mpbird wral wrex
          sylib cuni wdisj cvv fvex fvmpt2 mpan2 ralrimiva inss1 ciun mp2an wfn
          ressxr ioof ffn fniunfv eqtr3d syl6ss c0 wne ovolfsf elrege0 sylan9eq
          simpld simprd fveq1d ioorinv ineq1d eqeq12d rspccva disjss2 uniioovol
          feq1d sylc mpteq2dva xpss12 sstri cpw rneqd unieqd inex1 incom syl6eq
          3eqtr4d iuneq2i iunin2 eqtri syl5eqr fvco3 iuneq2dv ax-mp fss sylancl
          fnfco sylancr ineq2d 3eqtr2d ovolsf fnfvelrn frn icossxr syldan breq2
          supxrub ralbidv rspcev isumsup2 ovolfs2 coass coeq2d syl5eq 0re pnfxr
          seqeq3d icossre cdm 1nn fdm syl5eleqr dm0rn0 necon3bii wb breq1 ralrn
          ne0i rexbidv supxrre 3brtr3d ) ALUHUIZUJZUKULUMUNMKUNZUNZUOUPZUXMUQZU
          RUSUTZUKVAKUNZUOUPLJVBZVCVBZDVDZVAVBZVEUXJBUFVFZUXLVBZUGUFUXLUXMUOUHV
          GUXMVHZUOVIUIUXJVJVKUXJUYAUHUIUJZUYBVLUYDUYBURUIZVMUYBVNVOZUYDUYBVMVP
          VSVQZUIUYEUYFUJUXJUHUYGUYAUXLUXJUHVNURURVRZVDZUXKVTZUHUYGUXLVTUXJUYJU
          HUYICUHCVFZIVBZVCVBZUXRVDZMVBZWAZVTUXJCUHUYOUYIUYPUXJUYKUHUIZUJZUYNVC
          UQZUIZUYNVAVBURUIZUYOUYIUIABCDEFGHIJLNOPQRSTUAUBUCWBZUXJVUAUYQUXJUYNU
          XRWCZUXRURWCZUXRVAVBZURUIZVUAVUCUXJUYMUXRWDVKUXJUXRUXQWEVBZUXQWFVBZVC
          VQZURUXJUXRVUGVUHWJZVCVBVUIUXJUXQVUJVCUXJUXQUYHUIUXQVUJWGUXJUYIUYHUXQ
          VNUYHWDZAUHUYILJTWHWIUXQURURWKWLWMVUGVUHVCWNWOZVUGVUHWPWQZUXJVUEVUHVU
          GUMVQZURUXJVUEVUIVAVBZVUNUXJUXRVUIVAVULWMUXJVUGURUIZVUHURUIZVUGVUHVNV
          OZWTZVUOVUNWGAUHUYIJVTUXIVUSTJLWRXAZVUGVUHWSWLXBUXJVUHVUGUXJVUPVUQVUR
          VUTXCUXJVUPVUQVURVUTXDXEXFZUYNUXRXGXJXHBUYNMUEXIXKZUYPVHZXLUXJUHUYIUX
          KUYPUXJCUGUHUYSUYNUGVFZMVBUYOKMVUBKCUHUYNWAZWGUXJUDVKZUXJUGUYSVNXMXMV
          RZVDZMUYSVVHMVTUXJBMUEXNVKXOVVDUYNMXPXQZUUMXRZUXKUXLUXLVHZUUAWLWHUYBU
          UBYAZUUDUYDUYEUYFVVLUUEUXJUXNXMUSUTZURUIVVDUXMVBZVVMVNVOZUGUHXSZVVNBV
          FZVNVOZUGUHXSZBURXTZUXJVVMUXTURUXJVCUXKUNZUQZYBZVAVBVVMUXTUXJBUXMUXKV
          VJUXJVVQUXKVBZVCVBZVVQIVBZVCVBZWCZBUHXSBUHVWGYCZBUHVWEYCUXJVWHBUHUXJV
          VQUHUIZUJVWEVWGUXRVDZVWGUXJUYKUXKVBZVCVBZUYNWGZCUHXSVWJVWEVWKWGZUXJVW
          NCUHUYRVWMUYOVCVBZUYNUYRVWLUYOVCUXJUYQVWLUYKUYPVBZUYOUXJUYKUXKUYPVVIU
          UFUYQUYOYDUIVWQUYOWGUYNMYECUHUYOYDUYPVVCYFYGUUCWMUYRUYTVWPUYNWGVUBBUY
          NMUEUUGWLZXBYHVWNVWOCVVQUHUYKVVQWGZVWMVWEUYNVWKVWSVWLVWDVCUYKVVQUXKXP
          WMVWSUYMVWGUXRVWSUYLVWFVCUYKVVQIXPWMUUHUUIUUJXAVWGUXRYIWQYHAVWIUXIOXH
          BUHVWEVWGUUKUUNUYCUULUXJVWCUXSVAUXJVWCKUQZYBZUXRCUHUYMYJZVDZUXSUXJVWB
          VWTUXJVWAKUXJCUHVWPWAVVEVWAKUXJCUHVWPUYNVWRUUOUXJCUGUHVVGUYOVVDVCVBVW
          PUXKVCUYRUYIVVGUYOUYIUYHVVGVUKURXMWCZVXDUYHVVGWCYMYMURXMURXMUUPYKUUQZ
          VVBWIVVIUXJUGVVGURUURZVCVVGVXFVCVTZUXJYNVKXOVVDUYOVCXPXQVVFUVDZUUSUUT
          UXJVXCCUHUYKKVBZYJZVXAVXJCUHUXRUYMVDZYJVXCCUHVXIVXKUYQVXIUYNVXKUYQUYN
          YDUIVXIUYNWGUYMUXRUYLVCYEUVACUHUYNYDKUDYFYGUYMUXRUVBUVCUVECUHUXRUYMUV
          FUVGUXJKUHYLZVXJVXAWGUXJUHUYSKVTVXLUXJCUHUYNUYSKVUBUDXLUHUYSKYOWLCUHK
          YPWLUVHUXJVXBDUXRUXJCUHUYKVCIUNZVBZYJZVXBDUXJCUHVXNUYMUXJUHUYIIVTZUYQ
          VXNUYMWGAVXPUXINXHZUHUYIUYKVCIUVIXAUVJUXJVXOVXMUQYBZDUXJVXMUHYLZVXOVX
          RWGUXJVCVVGYLZUHVVGIVTZVXSVXGVXTYNVVGVXFVCYOUVKUXJVXPUYIVVGWCVYAVXQVX
          EUHUYIVVGIUVLUVMVVGUHVCIUVNUVOCUHVXMYPWLQWOYQUVPUVQWMYQZUXJUXSUXRWCZV
          UDVUFUXTURUIVYCUXJUXRDYIVKVUMVVAUXSUXRXGXJXFUXJVVOUGUHUXJVVDUHUIZVVNU
          XNUIZVVOUXJUXMUHYLZVYDVYEUXJUHUYGUXMVTZVYFUXJUYJVYGVVJUXMUXKUXLVVKUYC
          UVRWLZUHUYGUXMYOWLZUHVVDUXMUVSXAUXJUXNXMWCVYEVVOUXJUXNUYGXMUXJVYGUXNU
          YGWCVYHUHUYGUXMUVTWLZVMVPUWAYRUXNVVNUWDXAUWBYHVVSVVPBVVMURVVQVVMWGVVR
          VVOUGUHVVQVVMVVNVNUWCUWEUWFXKZUWGUXJUXLUXPUKUOUXJUXLVAVCUNUXKUNZUXPUX
          JUYJUXLVYLWGVVJUXKUXLVVKUWHWLUXJVYLVAVWAUNUXPVAVCUXKUWIUXJVWAKVAVXHUW
          JUWKXBUWNUXJVVMUXOUXTUXJUXNURWCUXNYSYTZUYKVVQVNVOZCUXNXSZBURXTZVVMUXO
          WGUXJUXNUYGURVYJVMURUIVPXMUIUYGURWCUWLUWMVMVPUWOYKYRUXJUXMUWPZYSYTZVY
          MUXJUOVYQUIVYRUXJUOUHVYQUWQUXJVYGVYQUHWGVYHUHUYGUXMUWRWLUWSVYQUOUXEWL
          VYQYSUXNYSUXMUWTUXAYAUXJVYPVVTVYKUXJVYOVVSBURUXJVYFVYOVVSUXBVYIVYNVVR
          CUGUHUXMUYKVVNVVQVNUXCUXDWLUXFXRBCUXNUXGXJVYBYQUXH $.
      $}

      ${
        uniioombl.m $e |- ( ph -> M e. NN ) $.
        uniioombl.m2 $e |- ( ph ->
          ( abs ` ( ( T ` M ) - sup ( ran T , RR* , < ) ) ) < C ) $.
        uniioombl.k $e |- K = U. ( ( (,) o. G ) " ( 1 ... M ) ) $.
        $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
           8-May-2015.) $)
        uniioombllem3a $p |- ( ph ->
          ( K = U_ j e. ( 1 ... M ) ( (,) ` ( G ` j ) ) /\
            ( vol* ` K ) e. RR ) ) $=
          ( c1 cfz co cv cfv cioo ciun wceq covol cr wcel ccom cima cuni cn cpw
          wfun cxr cxp ioof cle cin wss inss2 ressxr xpss12 mp2an sstri sylancl
          wf fss sylancr ffun funiunfv 3syl elfznn fvco3 syl2an iuneq2dv eqtr3d
          fco syl5eq csu wbr wral wa c1st cop ffvelrn sseldi 1st2nd2 syl fveq2d
          c2nd df-ov syl6eqr ioossre syl6eqss ralrimiva iunss sylibr fzfid cmin
          eqsstrd ovolfcl ovolioo eqtrd simp2d simp1d resubcld eqeltrd fsumrecl
          w3a cfn jca ovolfiniun syl2anc eqbrtrd ovollecl syl3anc ) AKGUFLUGUHZ
          GUIZJUJZUKUJZULZUMKUNUJZUOUPZAKUKJUQZYFURUSZYJUEAGYFYGYMUJZULZYNYJAUT
          UOVAZYMVOZYMVBYPYNUMAVCVCVDZYQUKVOUTYSJVOZYRVEAUTVFUOUOVDZVGZJVOZUUBY
          SVHYTSUUBUUAYSVFUUAVIZUOVCVHZUUEUUAYSVHVJVJUOVCUOVCVKVLVMUTUUBYSJVPVN
          UTYSYQUKJWFVQUTYQYMVRGYFYMVSVTAGYFYOYIAUUCYGUTUPZYOYIUMYGYFUPZSYGLWAZ
          UTUUBYGUKJWBWCWDWEWGZAKUOVHYFYIUNUJZGWHZUOUPYKUUKVFWIYLAKYJUOUUIAYIUO
          VHZGYFWJYJUOVHAUULGYFAUUGWKZYIYHWLUJZYHWSUJZUKUHZUOUUMYIUUNUUOWMZUKUJ
          UUPUUMYHUUQUKUUMYHUUAUPYHUUQUMUUMUUBUUAYHUUDAUUCUUFYHUUBUPUUGSUUHUTUU
          BYGJWNWCWOYHUOUOWPWQWRUUNUUOUKWTXAZUUNUUOXBXCZXDGYFYIUOXEXFXIAYFUUJGA
          UFLXGZUUMUUJUUOUUNXHUHZUOUUMUUJUUPUNUJZUVAUUMYIUUPUNUURWRUUMUUNUOUPZU
          UOUOUPZUUNUUOVFWIZXRZUVBUVAUMAUUCUUFUVFUUGSUUHJYGXJWCZUUNUUOXKWQXLUUM
          UUOUUNUUMUVCUVDUVEUVGXMUUMUVCUVDUVEUVGXNXOXPZXQAYKYJUNUJZUUKVFAKYJUNU
          UIWRAYFXSUPUULUUJUOUPZWKZGYFWJUVIUUKVFWIUUTAUVKGYFUUMUULUVJUUSUVHXTXD
          YFYIGYAYBYCKUUKYDYEXT $.

        $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
           26-Mar-2015.) $)
        uniioombllem3 $p |- ( ph ->
          ( ( vol* ` ( E i^i A ) ) + ( vol* ` ( E \ A ) ) ) <
        ( ( ( vol* ` ( K i^i A ) ) + ( vol* ` ( K \ A ) ) ) + ( C + C ) ) ) $=
          ( vj vz vw vn vk cin covol cfv cdif caddc co clt wss cr wcel a1i cioo
          inss1 ccom crn cuni cc0 wceq simpld cn cle cxp sstrd ovolsscl syl3anc
          wf syl difssd c1 cfz cv wral wa c1st c2nd elfznn syl2an sseldi fveq2d
          syl6eqr ralrimiva sylibr readdcld cuz cima cun wfn cxr ressxr sylancl
          mp2an ffn cmin peano2nnd syl6eleq syl5eq cc nncnd ax-1cn eqtrd syl6eq
          nnuz syl5sseqr csup ovollb unss1 ax-mp sseqtrd eqsstri syl6ss syl2anc
          wbr unss2 cpnf eqid resubcld nnaddcl cz nnzd adantr adantl csu mpbird
          wb simp2d simp1d recnd fsumser ad2antrr oveq12d lelttrd uniiccdif cop
          cicc ovolficcss uniioombllem3a inss2 ffvelrn 1st2nd2 ioossre syl6eqss
          ciun df-ov iunss eqsstrd simprd rpred ssun2 cpw ioof xpss12 sstri fss
          fco sylancr fnima uzsplit oveq2d uneq1d imaeq2d eqtr3d imaundi unieqd
          pncan uniun uneq1i uniioombllem1 ovollecl ssrin indir ovolss syl22anc
          ssid ovolun letrd cico 0re pnfxr cabs ovolsf ffvelrnd cmpt cseq rexrd
          icossre id syl2anr ffvelrnda syldan fmptd frn icossxr supxrcl wrex 1z
          addcom eleq2d biimpa eluzsub eluzelz zcnd npcand eqcomd eqeq2d rspcev
          syl6eleqr oveq1 cvv elrnmpt ex ssrdv imass2 rnco2 eqidd feqmptd fveq2
          vex fmptco rneqd syl5eqr imaco 3sstr4g unissd fveq1i nnred fzdisj cn0
          ltp1d nnnn0 nn0addge1 sylan elfz5 fzsplit fzfid w3a ovolfcl fsumsplit
          c0 ovolfsval adantlr peano2zd elfzuz uztrn2 fsumshftm pncan2d sumeq1d
          pncan2 nncn fvex fvmpt simpr 3eqtrd 3eqtr3d fnfvelrn eqeltrrd supxrub
          mpbid breq1 ralrn supxrleub xrletrd absdifltd ltsub23d ltadd2dd difss
          leaddsub2d ssdifd difundir lt2addd add4d breqtrd ) AGCUJZUKULZGCUMZUK
          ULZUNUOJCUJZUKULZDUNUOZJCUMZUKULZDUNUOZUNUOVWFVWIUNUODDUNUOUNUOUPAVWB
          VWDVWGVWJAVWAGUQZGURUQZGUKULURUSZVWBURUSVWKAGCVBUTAGVAIVCZVDZVEZURSAV
          WPUUCIVCVDVEZURAVWPVWQUQVWQVWPUMUKULVFVGAIRUUAVHAVIVJURURVKZUJZIVOZVW
          QURUQRIUUDVPVLZVLZPVWAGVMVNZAVWCGUQVWLVWMVWDURUSAGCVQVXBPVWCGVMVNZAVW
          FDAVWEJUQZJURUQZJUKULURUSZVWFURUSZVXEAJCVBZUTZAJUEVRKVSUOZUEVTZIULZVA
          ULZUUKZURAJVXOVGZVXGABCDEFUEGHIJKLMNOPQRSTUAUBUCUDUUEZVHAVXNURUQZUEVX
          KWAVXOURUQAVXRUEVXKAVXLVXKUSZWBZVXNVXMWCULZVXMWDULZVAUOZURVXTVXNVYAVY
          BUUBZVAULVYCVXTVXMVYDVAVXTVXMVWRUSVXMVYDVGVXTVWSVWRVXMVJVWRUUFZAVWTVX
          LVIUSZVXMVWSUSVXSRVXLKWEZVIVWSVXLIUUGWFWGVXMURURUUHVPWHVYAVYBVAUULWIV
          YAVYBUUIUUJWJUEVXKVXNURUUMWKUUNZAVXPVXGVXQUUOZVWEJVMVNZADQUUPZWLZAVWI
          DAVWHJUQZVXFVXGVWIURUSZAJCVQZVYHVYIVWHJVMVNZVYKWLZAVWBVWFVWNKVRUNUOZW
          MULZWNZVEZUKULZUNUOZVWGVXCAVWFWUBVYJAWUAVWPUQVWPURUQZVWPUKULZURUSZWUB
          URUSZAJWUAWOZWUAVWPWUAJUUQAVWPVWNVXKWNZVEZWUAWOZWUHAVWPWUIVYTWOZVEWUK
          AVWOWULAVWOVWNVXKVYSWOZWNZWULAVWNVIWNZVWOWUNAVWNVIWPZWUOVWOVGAVIURUUR
          ZVWNVOZWUPAWQWQVKZWUQVAVOVIWUSIVOZWURUUSAVWTVWSWUSUQWUTRVWSVWRWUSVYEU
          RWQUQZWVAVWRWUSUQWRWRURWQURWQUUTWTUVAVIVWSWUSIUVBWSVIWUSWUQVAIUVCUVDV
          IWUQVWNXAVPVIVWNUVEVPAVIWUMVWNAVIVRVYRVRXBUOZVSUOZVYSWOZWUMAVIVRWMULZ
          WVDXKAVYRWVEUSWVEWVDVGAVYRVIWVEAKUBXCXKXDVRVYRUVFVPXEAWVCVXKVYSAWVBKV
          RVSAKXFUSZVRXFUSZWVBKVGAKUBXGZXHKVRUVMWSUVGUVHXIUVIUVJVWNVXKVYSUVKXJU
          VLWUIVYTUVNXJJWUJWUAUDUVOWIZXLZVXAAWUDFVDZWQUPXMZURUSZWUEWVLVJYAZWUFV
          XAABCDEFGHILMNOPQRSTUAUVPZAVWTVWPVWPUQWVNRVWPUWBVWPFITXNWSVWPWVLUVQVN
          ZWUAVWPVMVNZWLZVYLAVWBVWEWUAWOZUKULZWUCVXCAWVSVWPUQWUDWUFWVTURUSAWUHW
          VSVWPVXEWVSWUHUQVXIVWEJWUAXOXPWVIXLZVXAWVPWVSVWPVMVNWVRAVWAWVSUQWVSUR
          UQVWBWVTVJYAAVWAWUHCUJZWVSAGWUHUQVWAWWBUQAGVWPWUHSWVIXQZGWUHCUVRVPWWB
          VWEWUACUJZWOZWVSJWUACUVSWWDWUAUQWWEWVSUQWUACVBWWDWUAVWEYBXPXRXSAWVSVW
          PURWWAVXAVLVWAWVSUVTXTAVWEURUQVXHWUAURUQZWUGWVTWUCVJYAAVWEJURVXJVYHVL
          VYJAWUAVWPURWVJVXAVLZWVQVWEWUAUWCUWAUWDAWUBDVWFWVQVYKVYJAWUBWVLKFULZX
          BUOZDWVQAWVLWWHWVOAVFYCUWEUOZURWWHVFURUSYCWQUSWWJURUQUWFUWGVFYCUWNWTZ
          AVIWWJKFAVWTVIWWJFVOZRFIUWHXBVCZIVCZWWNYDZTUWIVPZUBUWJWGZYEZVYKAWUBUN
          WWMUFVIUFVTZKUNUOZIULZUWKZVCZVRUWLZVDZWQUPXMZWWIAWUBWVQUWMAWXEWQUQZWX
          FWQUSAWXEWWJWQAVIWWJWXDVOZWXEWWJUQAVIVWSWXBVOZWXHAUFVIWXAVWSWXBAWWSVI
          USZWWTVIUSZWXAVWSUSWXJWXJKVIUSZWXKAWXJUWOUBWWSKYFUWPZAVIVWSWWTIRUWQUW
          RWXBYDZUWSZWXDWXBWXCWXCYDZWXDYDZUWIVPZVIWWJWXDUWTVPVFYCUXAZXSZWXEUXBV
          PAWWIWWRUWMZAWXIWUAVAWXBVCVDZVEUQWUBWXFVJYAWXOAVYTWYBAVAIVYSWNZWNZVAW
          XBVDZWNZVYTWYBAWYCWYEUQWYDWYFUQAWYCIUFVIWWTUWKZVDZWNZWYEAVYSWYHUQWYCW
          YIUQABVYSWYHABVTZVYSUSZWYJWYHUSZAWYKWBZWYJWWTVGZUFVIUXCZWYLWYMWYJKXBU
          OZVIUSWYJWYPKUNUOZVGZWYOWYMWYPWVEVIWYMVRYGUSZKYGUSZWYJVRKUNUOZWMULZUS
          ZWYPWVEUSWYSWYMUXDUTAWYTWYKAKUBYHYIAWYKXUCAVYSXUBWYJAVYRXUAWMAWVFWVGV
          YRXUAVGWVHXHKVRUXEWSWHUXFUXGKVRWYJUXHVNXKUXOWYMWYQWYJWYMWYJKWYMWYJWYK
          WYJYGUSAVYRWYJUXIYJUXJAWVFWYKWVHYIUXKUXLWYNWYRUFWYPVIWWSWYPVGWWTWYQWY
          JWWSWYPKUNUXPUXMUXNXTWYJUXQUSWYLWYOYMBUYFUFVIWWTWYJWYGUXQWYGYDUXRXPWK
          UXSUXTVYSWYHIUYAVPAWYIIWYGVCZVDWYEIWYGUYBAXUDWXBAUFUGVIVIWWTUGVTZIULW
          XAWYGIWXMAWYGUYCAUGVIVWSIRUYDXUEWWTIUYEUYGUYHUYIXQWYCWYEVAUYAVPVAIVYS
          UYJVAWXBUYBUYKUYLWUAWXDWXBWXQXNXTAWXFWWIVJYAZWYJWWIVJYAZBWXEWAZAXUHUH
          VTZWXDULZWWIVJYAZUHVIWAZAXUKUHVIAXUIVIUSZWBZWWHXUJUNUOZWVLVJYAZXUKXUN
          WVKWQUQZXUOWVKUSXUPAXUQXUMAWVKWWJWQAWWLWVKWWJUQWWPVIWWJFUWTVPWXSXSYIX
          UNKXUIUNUOZFULZXUOWVKXUNXUSXURUNWWNVRUWLZULZXUOXURFXUTTUYMXUNVRXURVSU
          OZVYBVYAXBUOZUEYKVXKXVCUEYKZVYRXURVSUOZXVCUEYKZUNUOXVAXUOXUNVXKXVEXVC
          XVBUEAVXKXVEUJVUGVGZXUMAKVYRUPYAXVGAKAKUBUYNZUYQVRKVYRXURUYOVPYIXUNKX
          VBUSZXVBVXKXVEWOVGXUNXVIKXURVJYAZAKURUSXUIUYPUSXVJXUMXVHXUIUYRKXUIUYS
          WFXUNKWVEUSXURYGUSXVIXVJYMXUNKVIWVEAWXLXUMUBYIZXKXDZXUNXURAWXLXUMXURV
          IUSZUBKXUIYFUYTZYHZKVRXURVUAXTYLKVRXURVUBVPXUNVRXURVUCXUNVXLXVBUSZWBZ
          XVCXVQVYBVYAXVQVYAURUSZVYBURUSZVYAVYBVJYAZXUNVWTVYFXVRXVSXVTVUDZXVPAV
          WTXUMRYIZVXLXURWEZIVXLVUEZWFZYNXVQXVRXVSXVTXWEYOYEYPZVUFXUNXVCUEWWNVR
          XURXUNVWTVYFVXLWWNULXVCVGZXVPXWBXWCIWWNVXLWWOVUHZWFXUNXURVIWVEXVNXKXD
          XWFYQXUNXVDWWHXVFXUJUNXUNXVDKXUTULWWHXUNXVCUEWWNVRKXUNVXSWBZVWTVYFXWG
          AVWTXUMVXSRYRVXSVYFXUNVYGYJXWHXTXVLXWIXVCAVXSXVCURUSXUMVXTVYBVYAVXTXV
          RXVSXVTAVWTVYFXWAVXSRVYGXWDWFZYNVXTXVRXVSXVTXWJYOYEVUIYPYQKFXUTTUYMWI
          XUNXVFVYRKXBUOZXURKXBUOZVSUOZUIVTZKUNUOZIULZWDULZXWPWCULZXBUOZUIYKVRX
          UIVSUOZXWSUIYKXUJXUNXVCXWSUEUIKVYRXURXUNKXVKYHZXUNKXXAVUJXVOXUNVXLXVE
          USZWBZXVCXXCVYBVYAXXCXVRXVSXVTXXCVWTVYFXWAAVWTXUMXXBRYRXUNVYRVIUSVXLV
          YSUSVYFXXBXUNKXVKXCVXLVYRXURVUKVRVXLVYRVIXKVULWFXWDXTZYNXXCXVRXVSXVTX
          XDYOYEYPVXLXWOVGZVYBXWQVYAXWRXBXXEVXMXWPWDVXLXWOIUYEZWHXXEVXMXWPWCXXF
          WHYSVUMXUNXWMXWTXWSUIXUNXWKVRXWLXUIVSXUNWVFWVGXWKVRVGXUNKXVKXGZXHKVRV
          UPWSXUNKXUIXXGXUMXUIXFUSAXUIVUQYJVUNYSVUOXUNXWSUIWXCVRXUIXUNXWNXWTUSZ
          WBZXWNWXCULZXWNWXBULZWDULZXXKWCULZXBUOZXWSXUNWXIXWNVIUSZXXJXXNVGXXHAW
          XIXUMWXOYIXWNXUIWEZWXBWXCXWNWXPVUHWFXXIXXLXWQXXMXWRXBXXIXXKXWPWDXXIXX
          OXXKXWPVGXXHXXOXUNXXPYJUFXWNWXAXWPVIWXBWWSXWNVGWWTXWOIWWSXWNKUNUXPWHW
          XNXWOIVURVUSVPZWHXXIXXKXWPWCXXQWHYSXIXUNXUIVIWVEAXUMVUTXKXDXXIXWSXXIX
          WQXWRXXIXWRURUSZXWQURUSZXWRXWQVJYAZXXIVWTXWOVIUSZXXRXXSXXTVUDAVWTXUMX
          XHRYRXXHXXOWXLXYAXUNXXPXVKXWNKYFUWPIXWOVUEXTZYNXXIXXRXXSXXTXYBYOYEYPY
          QVVAYSVVBXEXUNFVIWPZXVMXUSWVKUSAXYCXUMAWWLXYCWWPVIWWJFXAVPYIXVNVIXURF
          VVCXTVVDWVKXUOVVEXTXUNWWHXUJWVLAWWHURUSXUMWWQYIXUNWWJURXUJWWKAVIWWJXU
          IWXDWXRUWQWGAWVMXUMWVOYIVVOVVFWJAWXDVIWPZXUHXULYMAWXHXYDWXRVIWWJWXDXA
          VPXUGXUKBUHVIWXDWYJXUJWWIVJVVGVVHVPYLAWXGWWIWQUSXUFXUHYMWXTWYABWXEWWI
          VVIXTYLVVJAWVLDWWHWVOVYKWWQAWVLDXBUOWWHUPYAZWWHWVLDUNUOUPYAZAWWHWVLXB
          UOUWHULDUPYAXYEXYFWBUCAWWHWVLDWWQWVOVYKVVKVVFVHVVLYTZVVMYTAVWDVWIWUBU
          NUOZVWJVXDAVWIWUBVYPWVQWLZVYQAVWDVWHWUAWOZUKULZXYHVXDAXYJVWPUQWUDWUFX
          YKURUSAWUHXYJVWPVYMXYJWUHUQJCVVNVWHJWUAXOXPWVIXLZVXAWVPXYJVWPVMVNXYIA
          VWCXYJUQXYJURUQVWDXYKVJYAAVWCWUHCUMZXYJAGWUHCWWCVVPXYMVWHWUACUMZWOZXY
          JJWUACVVQXYNWUAUQXYOXYJUQWUACVVNXYNWUAVWHYBXPXRXSAXYJVWPURXYLVXAVLVWC
          XYJUVTXTAVWHURUQVYNWWFWUGXYKXYHVJYAAVWHJURVYOVYHVLVYPWWGWVQVWHWUAUWCU
          WAUWDAWUBDVWIWVQVYKVYPXYGVVMYTVVRAVWFDVWIDAVWFVYJYPADVYKYPZAVWIVYPYPX
          YPVVSVVT $.

        uniioombl.n $e |- ( ph -> N e. NN ) $.
        uniioombl.n2 $e |- ( ph -> A. j e. ( 1 ... M ) ( abs `
        ( sum_ i e. ( 1 ... N )
          ( vol* ` ( ( (,) ` ( F ` i ) ) i^i ( (,) ` ( G ` j ) ) ) ) -
          ( vol* ` ( ( (,) ` ( G ` j ) ) i^i A ) ) ) ) < ( C / M ) ) $.
        uniioombl.l $e |- L = U. ( ( (,) o. F ) " ( 1 ... N ) ) $.
        $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
           26-Mar-2015.) $)
        uniioombllem4 $p |- ( ph ->
          ( vol* ` ( K i^i A ) ) <_ ( ( vol* ` ( K i^i L ) ) + C ) ) $=
          ( cin covol cfv c1 cfz co caddc cuz cv cioo ciun wss cr wcel a1i ccom
          inss1 crn cuni cima imassrn unissi cicc cdif wceq uniiccdif simpld cn
          cc0 cle cxp ovolficcss syl sstrd cxr clt wbr sylancl syl3anc ovolsscl
          wf cun cmin nnuz syl5eq cc nncnd uneq1d eqtrd syl6eq inss2 ressxr fss
          ioof fco sylancr 3syl fvco3 iuneq2dv eqtr3d wfun ffun funiunfv elfznn
          syl2an ineq2d incom iunin2 iuneq2i 3eqtr4g readdcld fveq2d fzfid wral
          wa sylib r19.21bi adantr ralrimiva syl2anc cvol eqtri syl6eqr eqeltrd
          csu c0 wdisj mpbid cmul csup uniioombllem1 ssid ovollb ovollecl ssun2
          eqsstri peano2nnd syl6eleq uzsplit ax-1cn pncan oveq2d iuneq1d iunxun
          cpw wfn xpss12 mp2an sstri fniunfv sylan 3eqtr4d indi 3eqtr4ri eqtr3i
          ffn uneq2d syl5sseqr syl6ss rpred syl22anc eqbrtrd iunss fsumrecl cfn
          ovolun jca ovolfiniun cdiv nndivred cdm c1st c2nd cop ffvelrn 1st2nd2
          sseldi df-ov ioombl syl6eqel adantlr inmbl finiunmbl syl5eqss ioossre
          syl5ss syl6eqss ovolfcl ovolioo simp2d simp1d resubcld mblsplit sslin
          w3a 3sstr4i mp1i dfss1 indifdir difeq12i eqcomd ineq1d fveq2 cbvdisjv
          wb ssriv syl6sseqr uzdisj syl5reqr disjiun syl13anc uneqdifeq syl5eqr
          uzss oveq12d cabs absdifltd ltled mblvol rgenw disjss2 mpsyl sumeq2dv
          disjss1 volfiniun 3eqtr3d breqtrrd eqbrtrrd mpbird fsumle chash recnd
          lesubaddd leadd2d fsumconst cn0 hashfz1 oveq1d nnne0d divcan2d 3eqtrd
          nnnn0 breqtrd letrd leadd2dd ) ALCULZUMUNZLMULZUMUNZHUONUPUQZGOUOURUQ
          ZUSUNZGUTZJUNZVAUNZHUTZKUNZVAUNZULZVBZVBZUMUNZURUQZVUTDURUQAVUQLVCZLV
          DVCZLUMUNVDVEZVURVDVEVVOALCVHZVFALVAKVGZVIZVJZVDLVWAVCZALVVSVVAVKZVJZ
          VWAUHVWCVVTVVSVVAVLVMUUGVFZAVWAVNKVGVIVJZVDAVWAVWFVCVWFVWAVOUMUNVTVPA
          KUBVQVRAVSWAVDVDWBZULZKWLZVWFVDVCUBKWCWDWEZWEZAVWBVWAVDVCZVWAUMUNZVDV
          EZVVQVWEVWJAVWLFVIWFWGUUAZVDVEVWMVWOWAWHZVWNVWJABCDEFIJKPQRSTUAUBUCUD
          UEUUBAVWIVWAVWAVCVWPUBVWAUUCVWAFKUDUUDWIVWAVWOUUEWJLVWAWKWJZVUQLWKWJA
          VUTVVMAVUSLVCZVVPVVQVUTVDVEZVWRALMVHVFZVWKVWQVUSLWKWJZAVVLLVCZVVPVVQV
          VMVDVEZAVVLVUQLAVUSVVLWMZVVLVUQVVLVUSUUFAVUQVUSLGVVCVVFVBZULZWMZVXDAV
          UQLMVXEWMZULVXGACVXHLAGVSVVFVBZGUOOUPUQZVVFVBZVXEWMZCVXHAVXIGVXJVVCWM
          ZVVFVBVXLAGVSVXMVVFAVSUOVVBUOWNUQZUPUQZVVCWMZVXMAVSUOUSUNZVXPWOAVVBVX
          QVEZVXQVXPVPAVVBVSVXQAOUIUUHWOUUIZUOVVBUUJWDWPAVXOVXJVVCAVXNOUOUPAOWQ
          VEUOWQVEVXNOVPAOUIWRUUKOUOUULWIUUMZWSWTUUNGVXJVVCVVFUUOXAACVAJVGZVIZV
          JZVXISAGVSVVDVYAUNZVBZVYCVXIAVSVDUUPZVYAWLZVYAVSUUQVYEVYCVPAWFWFWBZVY
          FVAWLZVSVYHJWLZVYGXEAVSVWHJWLZVWHVYHVCZVYJPVWHVWGVYHWAVWGXBZVDWFVCZVY
          NVWGVYHVCXCXCVDWFVDWFUURUUSUUTZVSVWHVYHJXDWIVSVYHVYFVAJXFXGZVSVYFVYAU
          VGGVSVYAUVAXHAGVSVYDVVFAVYKVVDVSVEZVYDVVFVPZPVSVWHVVDVAJXIZUVBXJXKWPA
          MVXKVXEAMVYAVXJVKZVJZVXKUKAGVXJVYDVBZWUAVXKAVYGVYAXLWUBWUAVPVYPVSVYFV
          YAXMGVXJVYAXNXHAGVXJVYDVVFAVYKVYQVYRVVDVXJVEZPVVDOXOZVYSXPXJXKWPZWSUV
          CZXQLMVXEUVDXAAVXFVVLVUSAVXELULVXEHVVAVVIVBZULZVXFVVLALWUGVXEALVWDWUG
          UHAHVVAVVGVVSUNZVBZVWDWUGAVSVYFVVSWLZVVSXLWUJVWDVPAVYIVSVYHKWLZWUKXEA
          VWIVYLWULUBVYOVSVWHVYHKXDWIVSVYHVYFVAKXFXGVSVYFVVSXMHVVAVVSXNXHAHVVAW
          UIVVIAVWIVVGVSVEZWUIVVIVPVVGVVAVEZUBVVGNXOZVSVWHVVGVAKXIXPXJXKWPXQLVX
          EXRHVVAVXEVVIULZVBVVLWUHHVVAWUPVVKWUPVVKVPWUNGVVCVVIVVFULZVBZVVIVXEUL
          ZVVKWUPGVVCVVIVVFXSZGVVCVVJWUQVVJWUQVPZVVDVVCVEVVFVVIXRZVFXTZVXEVVIXR
          UVEVFXTHVVAVXEVVIXSUVFYAUVHWTZUVIVVRUVJZVWKVWQVVLLWKWJZYBAVUTDVXAADUA
          UVKZYBAVURVXDUMUNZVVNWAAVUQVXDUMWVDYCAVUSVDVCVWSVVLVDVCVXCWVHVVNWAWHA
          VUSLVDVWTVWKWEVXAAVVLLVDWVEVWKWEWVFVUSVVLUVQUVLUVMAVVMDVUTWVFWVGVXAAV
          VMVVAVVKUMUNZHYPZDWVFAVVAWVIHAUONYDZAWUNYFZVVKLVCZVVPVVQWVIVDVEZAWVMH
          VVAAVXBWVMHVVAYEWVEHVVAVVKLUVNYGYHZAVVPWUNVWKYIZAVVQWUNVWQYIVVKLWKWJZ
          UVOWVGAVVAUVPVEZVVKVDVCZWVNYFZHVVAYEVVMWVJWAWHWVKAWVTHVVAWVLWVSWVNWVL
          VVKLVDWVOWVPWEWVQUVRYJVVAVVKHUVSYKAWVJVVADNUVTUQZHYPZDWAAVVAWVIWWAHWV
          KWVQAWWAVDVEWUNADNWVGUFUWAZYIZWVLWVIWWAWAWHVVIMULZUMUNZWVIURUQZWWFWWA
          URUQZWAWHWVLVVICULZUMUNZWWGWWHWAWVLWWJWWIWWEULZUMUNZWWIWWEVOZUMUNZURU
          QZWWGWVLWWEYLUWBZVEWWIVDVCWWJVDVEZWWJWWOVPWVLWWEGVXJVVJVBZWWPWVLWWEVV
          IVXKULZWWRAWWEWWSVPWUNAMVXKVVIWUEXQYIWWRGVXJWUQVBWWSGVXJVVJWUQWVAWUCW
          VBVFXTGVXJVVIVVFXSYMYNZWVLVXJUVPVEZVVJWWPVEZGVXJYEWWRWWPVEZWVLUOOYDZW
          VLWXBGVXJWVLWUCYFZVVFWWPVEZVVIWWPVEZWXBAWUCWXFWUNAWUCYFZVVFVVEUWCUNZV
          VEUWDUNZVAUQZWWPWXHVVFWXIWXJUWEZVAUNWXKWXHVVEWXLVAWXHVVEVWGVEVVEWXLVP
          WXHVWHVWGVVEVYMAVYKVYQVVEVWHVEWUCPWUDVSVWHVVDJUWFXPUWHVVEVDVDUWGWDYCW
          XIWXJVAUWIYNWXIWXJUWJUWKUWLWVLWXGWUCWVLVVIVVHUWCUNZVVHUWDUNZVAUQZWWPW
          VLVVIWXMWXNUWEZVAUNWXOWVLVVHWXPVAWVLVVHVWGVEVVHWXPVPWVLVWHVWGVVHVYMAV
          WIWUMVVHVWHVEWUNUBWUOVSVWHVVGKUWFXPUWHVVHVDVDUWGWDYCWXMWXNVAUWIYNZWXM
          WXNUWJUWKYIVVFVVIUWMYKZYJVXJVVJGUWNYKZYOWVLWWICVDVVICXBACVDVCWUNACVYC
          VDSAVYCVNJVGVIVJZVDAVYCWXTVCWXTVYCVOUMUNVTVPAJPVQVRAVYKWXTVDVCPJWCWDW
          EUWOYIUWQWVLWWIVVIVCZVVIVDVCZVVIUMUNZVDVEZWWQWYAWVLVVICVHVFWVLVVIWXOV
          DWXQWXMWXNUWPUWRZWVLWYCWXNWXMWNUQZVDWVLWYCWXOUMUNZWYFWVLVVIWXOUMWXQYC
          WVLWXMVDVEZWXNVDVEZWXMWXNWAWHZUXFZWYGWYFVPAVWIWUMWYKWUNUBWUOKVVGUWSXP
          ZWXMWXNUWTWDWTWVLWXNWXMWVLWYHWYIWYJWYLUXAWVLWYHWYIWYJWYLUXBUXCYOZWWIV
          VIWKWJZWWEWWIUXDWJWVLWWLWWFWWNWVIURWVLWWKWWEUMWVLWWEWWIVCZWWKWWEVPMCV
          CZWYOWVLWUAVYCMCVYTVYBVYAVXJVLVMUKSUXGZMCVVIUXEUXHWWEWWIUXIYGYCWVLWWM
          VVKUMWVLWWMCMVOZVVIULZVVKWYSCVVIULZMVVIULZVOWWMCMVVIUXJWYTWWIXUAWWECV
          VIXRMVVIXRUXKYMWVLVVIWYRULWUSWYSVVKWVLWYRVXEVVIAWYRVXEVPZWUNAVXHCVPZX
          UBACVXHWUFUXLAWYPMVXEULZYQVPXUCXUBUXPWYQAXUDVXKVXEULZYQAMVXKVXEWUEUXM
          AGVSVVFYRZVXJVSVCZVVCVSVCVXJVVCULZYQVPXUEYQVPABVSBUTZJUNZVAUNZYRXUFQB
          GVSXUKVVFXUIVVDVPXUJVVEVAXUIVVDJUXNYCUXOYGZXUGAGVXJVSWUDUXQZVFAVVCVXQ
          VSAVXRVVCVXQVCVXSUOVVBUYEWDWOUXRAYQVXOVVCULXUHUOVVBUXSAVXOVXJVVCVXTUX
          MUXTGVSVVFVXJVVCUYAUYBWTMVXECUYCXGYSYIXQWYRVVIXRVVKWURWUSWVCWUTYMYAUY
          DYCUYFWTWVLWWJWWAWNUQZWWFWAWHWWJWWHWAWHWVLXUNVXJVVJUMUNZGYPZWWFWAWVLX
          UNXUPWVLWWJWWAWYNWWDUXCWVLVXJXUOGWXDWXEVVJVVIVCZWYBWYDXUOVDVEXUQWXEVV
          FVVIXBVFWVLWYBWUCWYEYIWVLWYDWUCWYMYIVVJVVIWKWJZUVOZWVLXUNXUPWGWHZXUPW
          WJWWAURUQWGWHZWVLXUPWWJWNUQUYGUNWWAWGWHZXUTXVAYFAXVBHVVAUJYHWVLXUPWWJ
          WWAXUSWYNWWDUYHYSVRUYIWVLWWFWWRUMUNZXUPWVLWWEWWRUMWWTYCWVLWWRYLUNZVXJ
          VVJYLUNZGYPZXVCXUPWVLWXAWXBXVEVDVEZYFZGVXJYEGVXJVVJYRZXVDXVFVPWXDWVLX
          VHGVXJWXEWXBXVGWXRWXEXVEXUOVDWXEWXBXVEXUOVPWXRVVJUYJWDZXURYOUVRYJXUGW
          VLGVSVVJYRZXVIXUMVVJVVFVCZGVSYEWVLXUFXVKXVLGVSVVFVVIVHUYKAXUFWUNXULYI
          GVSVVJVVFUYLUYMGVXJVSVVJUYOUYMVXJVVJGUYPWJWVLWXCXVDXVCVPWXSWWRUYJWDWV
          LVXJXVEXUOGXVJUYNUYQWTZUYRWVLWWJWWAWWFWYNWWDWVLWWFXUPVDXVMXUSYOZVUDYS
          UYSWVLWVIWWAWWFWVQWWDXVNVUEUYTVUAAWWBVVAVUBUNZWWAYTUQZNWWAYTUQDAWVRWW
          AWQVEWWBXVPVPWVKAWWAWWCVUCVVAWWAHVUFYKAXVONWWAYTANVSVENVUGVEXVONVPUFN
          VUMNVUHXHVUIADNADWVGVUCANUFWRANUFVUJVUKVULVUNVUOVUPVUO $.

        $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
           25-Aug-2014.) $)
        uniioombllem5 $p |- ( ph ->
          ( ( vol* ` ( E i^i A ) ) + ( vol* ` ( E \ A ) ) ) <_
          ( ( vol* ` E ) + ( 4 x. C ) ) ) $=
          ( vn cin covol cfv cdif caddc co c4 cmul wss wcel inss1 a1i cioo ccom
          cr crn cuni cicc cc0 wceq uniiccdif simpld cn cle wf ovolficcss sstrd
          cxp syl ovolsscl syl3anc difssd readdcld cfz cima imassrn eqsstri cxr
          c1 unissi clt csup wbr uniioombllem1 ssid ovollb sylancl ovollecl 4re
          rpred remulcl sylancr uniioombllem3 ltled uniioombllem4 3sstr4i sscon
          mp1i ovolss syl2anc le2addd recnd add32d cvol cdm ciun cpw wfun inss2
          cv ioof ressxr xpss12 mp2an sstri fss fco ffun syl6eqr syl2an breqtrd
          eqtr4d letrd leadd1dd addassd c2 2timesd oveq2d funiunfv 3syl wral wa
          cfn fzfid c1st elfznn fvco3 ffvelrn sseldi 1st2nd2 fveq2d df-ov eqtrd
          c2nd cop ioombl syl6eqel ralrimiva finiunmbl eqeltrrd mblsplit oveq1d
          2t2e4 oveq1i cc 2cn mulassd 3eqtrd syl5eqr ) AICUMZUNUOZICUPZUNUOZUQU
          RZLCUMZUNUOZLCUPZUNUOZUQURZDDUQURZUQURZIUNUOZUSDUTURZUQURZAUVMUVOAUVL
          IVAZIVGVAZUWDVGVBZUVMVGVBUWGAICVCVDAIVEKVFZVHZVIZVGUCAUWLVJKVFVHVIZVG
          AUWLUWMVAUWMUWLUPUNUOVKVLAKUBVMVNAVOVPVGVGVTZUMZKVQZUWMVGVAUBKVRWAVSZ
          VSZTUVLIWBWCAUVNIVAUWHUWIUVOVGVBAICWDUWRTUVNIWBWCWEZAUWAUWBAUVRUVTAUV
          QLVAZLVGVAZLUNUOZVGVBZUVRVGVBUWTALCVCVDALUWLVGLUWLVAZALUWJWKNWFURZWGZ
          VIUWLUHUXFUWKUWJUXEWHWLWIZVDZUWQVSZAUXDUWLVGVAZUWLUNUOZVGVBZUXCUXHUWQ
          AUXJFVHWJWMWNZVGVBUXKUXMVPWOZUXLUWQABCDEFIJKPQRSTUAUBUCUDUEWPZAUWPUWL
          UWLVAUXNUBUWLWQUWLFKUDWRWSUWLUXMWTWCLUWLWBWCZUVQLWBWCZAUVSLVAUXAUXCUV
          TVGVBALCWDUXIUXPUVSLWBWCZWEZADDADUAXBZUXTWEZWEZAUWDUWETAUSVGVBDVGVBUW
          EVGVBXAUXTUSDXCXDWEAUVPUWCUWSUYBABCDEFIJKLNPQRSTUAUBUCUDUEUFUGUHXEXFA
          UWCUWDUWBUQURZUWBUQURZUWFVPAUWAUYCUWBUXSAUWDUWBTUYAWEZUYAAUWAUXBDUQUR
          ZUYCUXSAUXBDUXPUXTWEUYEAUWALMUMZUNUOZDUQURZLMUPZUNUOZUQURZUYFVPAUVRUV
          TUYIUYKUXQUXRAUYHDAUYGLVAZUXAUXCUYHVGVBUYMALMVCVDUXIUXPUYGLWBWCZUXTWE
          AUYJLVAUXAUXCUYKVGVBALMWDZUXIUXPUYJLWBWCZABCDEFGHIJKLMNOPQRSTUAUBUCUD
          UEUFUGUHUIUJUKXGAUVSUYJVAZUYJVGVAUVTUYKVPWOMCVAUYQAVEJVFZWKOWFURZWGZV
          IZUYRVHZVIMCUYTVUBUYRUYSWHWLUKSXHMCLXIXJAUYJLVGUYOUXIVSUVSUYJXKXLXMAU
          YLUYHUYKUQURZDUQURUYFAUYHDUYKAUYHUYNXNADUXTXNZAUYKUYPXNXOAUXBVUCDUQAM
          XPXQZVBUXAUXCUXBVUCVLAULUYSULYBZUYRUOZXRZMVUEAVUHVUAMAVOVGXSZUYRVQZUY
          RXTVUHVUAVLAWJWJVTZVUIVEVQVOVUKJVQZVUJYCAVOUWOJVQZUWOVUKVAVULPUWOUWNV
          UKVPUWNYAZVGWJVAZVUOUWNVUKVAYDYDVGWJVGWJYEYFYGVOUWOVUKJYHWSVOVUKVUIVE
          JYIXDVOVUIUYRYJULUYSUYRUUAUUBUKYKAUYSUUEVBVUGVUEVBZULUYSUUCVUHVUEVBAW
          KOUUFAVUPULUYSAVUFUYSVBZUUDZVUGVUFJUOZUUGUOZVUSUUPUOZVEURZVUEVURVUGVU
          SVEUOZVVBAVUMVUFVOVBZVUGVVCVLVUQPVUFOUUHZVOUWOVUFVEJUUIYLVURVVCVUTVVA
          UUQZVEUOVVBVURVUSVVFVEVURVUSUWNVBVUSVVFVLVURUWOUWNVUSVUNAVUMVVDVUSUWO
          VBVUQPVVEVOUWOVUFJUUJYLUUKVUSVGVGUULWAUUMVUTVVAVEUUNYKUUOVUTVVAUURUUS
          UUTUYSVUGULUVAXLUVBUXIUXPMLUVCWCUVDYNYMAUYFUWDDUQURZDUQURUYCVPAUXBVVG
          DUXPAUWDDTUXTWEZUXTAUXBUXMVVGUXPUXOVVHAUWPUXDUXBUXMVPWOUBUXGLFKUDWRWS
          UEYOYPAUWDDDAUWDTXNZVUDVUDYQYMYOYPAUYDUWDUWBUWBUQURZUQURUWFAUWDUWBUWB
          VVIAUWBUYAXNZVVKYQAUWEVVJUWDUQAUWEYRYRUTURZDUTURZVVJVVLUSDUTUVEUVFAVV
          MYRYRDUTURZUTURYRUWBUTURVVJAYRYRDYRUVGVBAUVHVDZVVOVUDUVIAVVNUWBYRUTAD
          VUDYSYTAUWBVVKYSUVJUVKYTYNYMYO $.
      $}

      $( Lemma for ~ uniioombl .  (Contributed by Mario Carneiro,
         26-Mar-2015.) $)
      uniioombllem6 $p |- ( ph ->
        ( ( vol* ` ( E i^i A ) ) + ( vol* ` ( E \ A ) ) ) <_
          ( ( vol* ` E ) + ( 4 x. C ) ) ) $=
        ( cn vm vj va vy vn vi vz vk cv cfv crn cxr clt csup cmin co cabs covol
        wbr cin cdif caddc c4 cmul cle cuz wral wrex c1 nnuz cz 1z a1i wa eqidd
        wcel cr cli ccom cc0 cpnf cico cxp eqid ovolfsf ffvelrnda elrege0 sylib
        wf syl simpld simprd uniioombllem1 wss ovolsf frn icossxr supxrub sylan
        syl6ss ralrimiva wfn wb wceq breq2 ralbidv rspcev syl2anc c0 wne climi2
        syl3anc r19.2uz cfz cioo csu cmpt ad2antrr cvv fvex inex1 elfznn syl2an
        weq fveq2 fveq2d ineq1d eqtrd inss2 cop adantr cif cbvmptv supeq1 ax-mp
        rexuz3 sylibr cima cuni rexlimddv ffn breq1 ralrn mpbid 0re pnfxr mp2an
        isumsup2 icossre cdm 1nn syl5eleqr ne0i necon3bii supxrre breqtrrd cdiv
        fdm dm0rn0 cseq crp simplrl nnrpd rpdivcld rgenw fnmpt mp1i fvco2 fvmpt
        adantl simpr syl6eleq c1st ffvelrn sseldi 1st2nd2 df-ov syl6eqr ioossre
        c2nd syl6eqss w3a ovolfcl ovolioo simp2d simp1d resubcld ovolsscl recnd
        eqeltrd fsumser eqcomd ccnv eqeq1 opeq12d ifbieq2d uniioombllem2 sylan2
        adantlr cfn fzfi rexfiuz simprll simprlr simprrl simprrr cbvsumv ineq2d
        wdisj sumeq2sdv syl5eq oveq12d breq1d cbvralv uniioombllem5 anassrs ) A
        UAUIZFUJZFUKZULUMUNZUOUPUQUJDUMUSZGCUTURUJGCVAURUJVBUPGURUJZVCDVDUPVBUP
        VEUSZUATAUYAUAUBUIZVFUJVGUBTVHUYAUATVHAUXTUXRDUBUAFVITVJVIVKVPZAVLVMZOA
        UXQTVPZVNUXRVOAFUXSVQUMUNZUXTVRABUCUIZUQUOVSIVSZUJZUAUCUYJFVITVJRUYFAUY
        ITVPVNZUYKVOUYLUYKVQVPZVTUYKVEUSZUYLUYKVTWAWBUPZVPUYMUYNVNATUYOUYIUYJAT
        VEVQVQWCZUTZIWIZTUYOUYJWIPIUYJUYJWDZWEWJWFUYKWGWHZWKUYLUYMUYNUYTWLAUXTV
        QVPZUXRUXTVEUSZUATVGZUXRBUIZVEUSZUATVGZBVQVHABCDEFGHIJKLMNOPQRSWMZAVUDU
        XTVEUSZBUXSVGZVUCAVUHBUXSAUXSULWNVUDUXSVPVUHAUXSUYOULATUYOFWIZUXSUYOWNA
        UYRVUJPFIUYJUYSRWOWJZTUYOFWPWJZVTWAWQWTUXSVUDWRWSXAZAFTXBZVUIVUCXCAVUJV
        UNVUKTUYOFUUAWJVUHVUBBUATFVUDUXRUXTVEUUBUUCWJUUDVUFVUCBUXTVQVUDUXTXDVUE
        VUBUATVUDUXTUXRVEXEXFXGXHUUHAUXSVQWNUXSXIXJZVUDUDUIZVEUSZBUXSVGZUDVQVHZ
        UXTUYHXDAUXSUYOVQVULVTVQVPWAULVPUYOVQWNUUEUUFVTWAUUIUUGWTAFUUJZXIXJZVUO
        AVIVUTVPVVAAVITVUTUUKAVUJVUTTXDVUKTUYOFUURWJUULVUTVIUUMWJVUTXIUXSXIFUUS
        UUNWHAVUAVUIVUSVUGVUMVURVUIUDUXTVQVUPUXTXDVUQVUHBUXSVUPUXTVUDVEXEXFXGXH
        UDBUXSUUOXLUUPXKUYAUBUAVITVJXMWJAUYGUYAVNZVNZVIUEUIZXNUPZUFUIZHUJZXOUJZ
        UYDIUJZXOUJZUTZURUJZUFXPZVVJCUTZURUJZUOUPZUQUJZDUXQUUQUPZUMUSZUBVIUXQXN
        UPZVGZUYCUETVVCVWAUEUYIVFUJZVGZUCTVHZVWAUETVHVVCVWCUCVKVHZVWDVVCVVSUEVW
        BVGZUCVKVHZUBVVTVGZVWEVVCVWGUBVVTVVCUYDVVTVPZVNZVWFUCTVHZVWGVWJVVOVVMVV
        RUCUEVBURUGTUGUIZHUJZXOUJZVVJUTZXQZVSZVIUUTZVITVJUYEVWJVLVMVWJDUXQADUVA
        VPZVVBVWIOXRVWJUXQAUYGUYAVWIUVBUVCUVDVWJVVDTVPZVNZVVMVVDVWRUJVXAVVLUFVW
        QVIVVDVXAVVFVVEVPZVNZVVFVWQUJZVVFVWPUJZURUJZVVLVXAVWPTXBZVVFTVPZVXDVXFX
        DVXBVWOXSVPZUGTVGVXGVXAVXIUGTVWNVVJVWMXOXTYAUVEUGTVWOVWPXSVWPWDZUVFUVGV
        VFVVDYBZTURVWPVVFUVHYCVXCVXEVVKURVXCVXHVXEVVKXDVXBVXHVXAVXKUVJUGVVFVWOV
        VKTVWPUGUFYDZVWNVVHVVJVXLVWMVVGXOVWLVVFHYEYFYGVXJVVHVVJVVGXOXTYAUVIWJYF
        YHVXAVVDTVIVFUJVWJVWTUVKVJUVLVXCVVLVXCVVKVVJWNZVVJVQWNZVVJURUJZVQVPZVVL
        VQVPVXMVXCVVHVVJYIVMVWJVXNVWTVXBVWJVVJVVIUVMUJZVVIUVTUJZXOUPZVQVWJVVJVX
        QVXRYJZXOUJVXSVWJVVIVXTXOVWJVVIUYPVPVVIVXTXDVWJUYQUYPVVIVEUYPYIVVCUYRUY
        DTVPZVVIUYQVPVWIAUYRVVBPYKZUYDUXQYBZTUYQUYDIUVNYCUVOVVIVQVQUVPWJYFVXQVX
        RXOUVQUVRZVXQVXRUVSUWAXRVWJVXPVWTVXBVWJVXOVXRVXQUOUPZVQVWJVXOVXSURUJZVY
        EVWJVVJVXSURVYDYFVWJVXQVQVPZVXRVQVPZVXQVXRVEUSZUWBZVYFVYEXDVVCUYRVYAVYJ
        VWIVYBVYCIUYDUWCYCZVXQVXRUWDWJYHVWJVXRVXQVWJVYGVYHVYIVYKUWEVWJVYGVYHVYI
        VYKUWFUWGUWJXRVVKVVJUWHXLUWIUWKUWLAVWIVWRVVOVRUSZVVBVWIAVYAVYLVYCABUHCD
        EFGHIVWPUYDUGXOUKZVWLXIXDZVTVTYJZVWLULUMUWMZUNZVWLULUMUNZYJZYLZXQJKLMNO
        PQRSUGUHTVWOUHUIZHUJZXOUJZVVJUTUGUHYDZVWNWUCVVJWUDVWMWUBXOVWLWUAHYEYFYG
        YMUGBVYMVYTVUDXIXDZVYOVUDULVYPUNZVUDULUMUNZYJZYLUGBYDZVYNWUEVYSWUHVYOVW
        LVUDXIUWNWUIVYQWUFVYRWUGULVWLVUDVYPYNULVWLVUDUMYNUWOUWPYMUWQUWRUWSXKUYE
        VWKVWGXCVLVVSUCUEVITVJYPYOWHXAVVTUWTVPVWEVWHXCVIUXQUXAVVSVVTUCUEUBUXBYO
        YQUYEVWDVWEXCVLVWAUCUEVITVJYPYOYQVWAUCUEVITVJXMWJAVVBVWTVWAVNZUYCAVVBWU
        JVNZVNZBCDEFUGUHGHIXOIVSZVVTYRYSZXOHVSVVEYRYSZUXQVVDATUYQHWIWUKJYKABTVU
        DHUJXOUJUXIWUKKYKLMAUYBVQVPWUKNYKAVWSWUKOYKAUYRWUKPYKAGWUMUKYSWNWUKQYKR
        AUXTUYBDVBUPVEUSWUKSYKAUYGUYAWUJUXCAUYGUYAWUJUXDWUNWDAVVBVWTVWAUXEWULVW
        AVVEVWNWUAIUJZXOUJZUTZURUJZUGXPZWUQCUTZURUJZUOUPZUQUJZVVRUMUSZUHVVTVGAV
        VBVWTVWAUXFVVSWVEUBUHVVTUBUHYDZVVQWVDVVRUMWVFVVPWVCUQWVFVVMWUTVVOWVBUOW
        VFVVMVVEVWOURUJZUGXPWUTVVEVVLWVGUFUGUFUGYDZVVKVWOURWVHVVHVWNVVJWVHVVGVW
        MXOVVFVWLHYEYFYGYFUXGWVFVVEWVGWUSUGWVFVWOWURURWVFVVJWUQVWNWVFVVIWUPXOUY
        DWUAIYEYFZUXHYFUXJUXKWVFVVNWVAURWVFVVJWUQCWVIYGYFUXLYFUXMUXNWHWUOWDUXOU
        XPYTYT $.
    $}

    $( A disjoint union of open intervals is measurable.  (This proof does not
       use countable choice, unlike ~ iunmbl .)  Lemma 565Ca of [Fremlin5]
       p. 214.  (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    uniioombl $p |- ( ph -> U. ran ( (,) o. F ) e. dom vol ) $=
      ( cioo cr wss cfv wcel caddc co cle cn cxr wa c4 c2 vz vr vf ccom cuni cv
      crn covol cin cdif wbr wi cpw wral cvol cdm cxp inss2 ressxr xpss12 mp2an
      wf ioof sstri fss sylancl fco sylancr frn syl sspwuni sylib crp cdiv cmul
      cabs cmin c1 cseq csup cmap wrex elpwi ad2antrl adantr rphalfcl rphalfcld
      clt simprr adantl ovolgelb syl3anc ad3antrrr wdisj elmapi simprrl simprrr
      eqid uniioombllem6 rexlimddv cc rpcn 2cn a1i cc0 wne 2ne0 divdiv1d oveq2i
      2t2e4 syl6eq oveq2d 4cn 4nn nnne0i divcan2d eqtrd breqtrd ralrimiva inss1
      wb ovolsscl difssd readdcld alrple syl2anc mpbird expr ismbl2 sylanbrc )
      AHDUDZUGZUEZIJZUAUFZUHKZILZYOYMUIZUHKZYOYMUJZUHKZMNZYPOUKZULZUAIUMZUNYMUO
      UPLAYLUUEJZYNAPUUEYKVBZUUFAQQUQZUUEHVBPUUHDVBZUUGVCAPOIIUQZUIZDVBZUUKUUHJ
      UUIEUUKUUJUUHOUUJURIQJZUUMUUJUUHJUSUSIQIQUTVAVDPUUKUUHDVEVFPUUHUUEHDVGVHP
      UUEYKVIVJYLIVKVLAUUDUAUUEAYOUUELZYQUUCAUUNYQRZRZUUCUUBYPUBUFZMNZOUKZUBVMU
      NZUUPUUSUBVMUUPUUQVMLZRZUUBYPSUUQTVNNZTVNNZVONZMNZUUROUVBYOHUCUFZUDUGUEJZ
      MVPVQUDUVGUDVRVSZUGQWHVTYPUVDMNOUKZRZUUBUVFOUKUCUUKPWANZUVBYOIJZYQUVDVMLZ
      UVKUCUVLWBUUPUVMUVAUUNUVMAYQYOIWCWDZWEUUPYQUVAAUUNYQWIZWEZUVAUVNUUPUVAUVC
      UUQWFZWGWJYOUVDUVIUCUVIWRZWKWLUVBUVGUVLLZUVKRZRZBYMUVDCUVIYODUVGAUULUUOUV
      AUWAEWMABPBUFDKHKWNUUOUVAUWAFWMGYMWRUVBYQUWAUVQWEUWBUVCUVBUVCVMLZUWAUVAUW
      CUUPUVRWJWEWGUVTPUUKUVGVBUVBUVKUVGUUKPWOWDUVBUVTUVHUVJWPUVSUVBUVTUVHUVJWQ
      WSWTUVBUVEUUQYPMUVBUVESUUQSVNNZVONUUQUVBUVDUWDSVOUVBUVDUUQTTVONZVNNUWDUVB
      UUQTTUVAUUQXALUUPUUQXBWJZTXALUVBXCXDZUWGTXEXFUVBXGXDZUWHXHUWESUUQVNXJXIXK
      XLUVBUUQSUWFSXALUVBXMXDSXEXFUVBSXNXOXDXPXQXLXRXSUUPUUBILYQUUCUUTYAUUPYSUU
      AUUPYRYOJZUVMYQYSILUWIUUPYOYMXTXDUVOUVPYRYOYBWLUUPYTYOJUVMYQUUAILUUPYOYMY
      CUVOUVPYTYOYBWLYDUVPUBUUBYPYEYFYGYHXSUAYMYIYJ $.

    $( An almost-disjoint union of closed intervals is measurable.  (This proof
       does not use countable choice, unlike ~ iunmbl .)  (Contributed by Mario
       Carneiro, 25-Mar-2015.) $)
    uniiccmbl $p |- ( ph -> U. ran ( [,] o. F ) e. dom vol ) $=
      ( cioo ccom crn cuni cicc cdif cun cvol wss wceq wcel cr syl2anc covol cn
      cdm cfv cc0 uniiccdif simpld undif sylib uniioombl cle cxp cin ovolficcss
      wf syl ssdifssd simprd nulmbl unmbl eqeltrrd ) AHDIJKZLDIJKZVBMZNZVCOUCZA
      VBVCPZVEVCQAVGVDUAUDUEQZADEUFZUGVBVCUHUIAVBVFRVDVFRZVEVFRABCDEFGUJAVDSPVH
      VJAVCSVBAUBUKSSULUMDUOVCSPEDUNUPUQAVGVHVIURVDUSTVBVDUTTVA $.
  $}

  ${
    $d c d f x y $.  $d a b c d x y B $.  $d x y C $.  $d a b f m n t w z ph $.
    $d a b c d i m n r t w x y z A $.  $d x y D $.  $d a b f m n t z G $.
    $d a b c d m n r w x y z F $.
    dyadmbl.1 $e |- F = ( x e. ZZ , y e. NN0 |->
      <. ( x / ( 2 ^ y ) ) , ( ( x + 1 ) / ( 2 ^ y ) ) >. ) $.
    $( The function ` F ` returns the endpoints of a dyadic rational covering
       of the real line.  (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    dyadf $p |- F : ( ZZ X. NN0 ) --> ( <_ i^i ( RR X. RR ) ) $=
      ( cv c2 co cdiv cle cr cxp wcel cn0 wral cz wbr syl cn nndivre syl2an cop
      cexp c1 caddc cin wf wa zre adantr lep1d cc0 clt wb peano2re nnexpcl mpan
      2nn adantl nnred nngt0d lediv1 syl112anc mpbid df-br opelxpi syl2anc elin
      sylib sylanbrc rgen2 fmpt2 mpbi ) AEZFBEZUBGZHGZVMUCUDGZVOHGZUAZIJJKZUEZL
      ZBMNAONOMKWACUFWBABOMVMOLZVNMLZUGZVSILZVSVTLZWBWEVPVRIPZWFWEVMVQIPZWHWEVM
      WCVMJLZWDVMUHZUIZUJWEWJVQJLZVOJLUKVOULPWIWHUMWLWEWJWMWLVMUNZQWEVOWDVORLZW
      CFRLWDWOUQFVNUOUPZURZUSWEVOWQUTVMVQVOVAVBVCVPVRIVDVHWEVPJLZVRJLZWGWCWJWOW
      RWDWKWPVMVOSTWCWMWOWSWDWCWJWMWKWNQWPVQVOSTVPVRJJVEVFVSIVTVGVIVJABOMVSWACD
      VKVL $.

    $( Value of the dyadic rational function ` F ` .  (Contributed by Mario
       Carneiro, 26-Mar-2015.) $)
    dyadval $p |- ( ( A e. ZZ /\ B e. NN0 ) -> ( A F B ) =
      <. ( A / ( 2 ^ B ) ) , ( ( A + 1 ) / ( 2 ^ B ) ) >. ) $=
      ( cz cn0 cv c2 cexp co cdiv c1 caddc cop wceq wa id oveqan12d oveq2 oveq1
      opeq12d opex ovmpt2a ) ABCDGHAIZJBIZKLZMLZUFNOLZUHMLZPCJDKLZMLZCNOLZULMLZ
      PEUFCQZUGDQZRUIUMUKUOUPUQUFCUHULMUPSUGDJKUAZTUPUQUJUNUHULMUFCNOUBURTUCFUM
      UOUDUE $.

    $( Volume of a dyadic rational interval.  (Contributed by Mario Carneiro,
       26-Mar-2015.) $)
    dyadovol $p |- ( ( A e. ZZ /\ B e. NN0 ) ->
      ( vol* ` ( [,] ` ( A F B ) ) ) = ( 1 / ( 2 ^ B ) ) ) $=
      ( wcel co cicc cfv covol c2 cdiv c1 cmin fveq2d cr cle wbr recnd cn0 cexp
      cz wa caddc cop dyadval df-ov syl6eqr wceq cn zre 2nn nnexpcl mpan syl2an
      nndivre peano2re syl adantr lep1d wb adantl nnred nngt0d lediv1 syl112anc
      cc0 clt ovolicc syl3anc nnne0d divsubdird cc ax-1cn pncan2 sylancl oveq1d
      mpbid eqtr3d 3eqtrd ) CUCGZDUAGZUDZCDEHZIJZKJCLDUBHZMHZCNUEHZWGMHZIHZKJZW
      JWHOHZNWGMHZWDWFWKKWDWFWHWJUFZIJWKWDWEWOIABCDEFUGPWHWJIUHUIPWDWHQGZWJQGZW
      HWJRSZWLWMUJWBCQGZWGUKGZWPWCCULZLUKGWCWTUMLDUNUOZCWGUQUPWBWIQGZWTWQWCWBWS
      XCXACURZUSXBWIWGUQUPWDCWIRSZWRWDCWBWSWCXAUTZVAWDWSXCWGQGVHWGVISXEWRVBXFWD
      WSXCXFXDUSZWDWGWCWTWBXBVCZVDZWDWGXHVECWIWGVFVGVSWHWJVJVKWDWICOHZWGMHWMWNW
      DWICWGWDWIXGTWDCXFTZWDWGXITWDWGXHVLVMWDXJNWGMWDCVNGNVNGXJNUJXKVOCNVPVQVRV
      TWA $.

    $( Two closed dyadic rational intervals are either in a subset relationship
       or are almost disjoint (the interiors are disjoint).  (Contributed by
       Mario Carneiro, 26-Mar-2015.)  (Proof shortened by Mario Carneiro,
       26-Apr-2016.) $)
    dyadss $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. NN0 /\ D e. NN0 ) ) ->
      ( ( [,] ` ( A F C ) ) C_ ( [,] ` ( B F D ) ) -> D <_ C ) ) $=
      ( wcel wa co cicc cfv cle wbr c2 c1 cdiv cr syl2anc cz cn0 wss cexp covol
      simpr caddc cop wceq simpllr simplrr dyadval fveq2d df-ov syl6eqr zred cn
      2nn nnexpcl sylancr nndivred peano2re syl iccssre eqsstrd simplll simplrl
      ovolss dyadovol 3brtr3d wb cc0 clt nnre nngt0 jca lerec syl2an mpbird 2re
      a1i nn0zd 1lt2 leexp2d ex ) CUAIZDUAIZJZEUBIZFUBIZJZJZCEGKLMZDFGKZLMZUCZF
      ENOZWLWPJZWQPFUDKZPEUDKZNOZWRXAQWTRKZQWSRKZNOZWRWMUEMZWOUEMZXBXCNWRWPWOSU
      CXEXFNOWLWPUFWRWODWSRKZDQUGKZWSRKZLKZSWRWOXGXIUHZLMXJWRWNXKLWRWGWJWNXKUIW
      FWGWKWPUJZWHWIWJWPUKZABDFGHULTUMXGXILUNUOWRXGSIXISIXJSUCWRDWSWRDXLUPZWRPU
      QIZWJWSUQIZURXMPFUSUTZVAWRXHWSWRDSIXHSIXNDVBVCXQVAXGXIVDTVEWMWOVHTWRWFWIX
      EXBUIWFWGWKWPVFWHWIWJWPVGZABCEGHVITWRWGWJXFXCUIXLXMABDFGHVITVJWRXPWTUQIZX
      AXDVKZXQWRXOWIXSURXRPEUSUTXPWSSIZVLWSVMOZJWTSIZVLWTVMOZJXTXSXPYAYBWSVNWSV
      OVPXSYCYDWTVNWTVOVPWSWTVQVRTVSWRPFEPSIWRVTWAWRFXMWBWREXRWBQPVMOWRWCWAWDVS
      WE $.

    $( Lemma for ~ dyaddisj .  (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    dyaddisjlem $p |- ( ( ( ( A e. ZZ /\ B e. ZZ ) /\
     ( C e. NN0 /\ D e. NN0 ) ) /\ C <_ D ) ->
       ( ( [,] ` ( A F C ) ) C_ ( [,] ` ( B F D ) ) \/
         ( [,] ` ( B F D ) ) C_ ( [,] ` ( A F C ) ) \/
       ( ( (,) ` ( A F C ) ) i^i ( (,) ` ( B F D ) ) ) = (/) ) ) $=
      ( cz wcel wa wbr co cicc cfv cioo wceq c2 adantr cr cn0 cle wss cexp cdiv
      cin c0 w3o clt c1 caddc cop simplll simplrl dyadval syl2anc df-ov syl6eqr
      fveq2d simpllr simplrr ineq12d incom syl6eq cmul wb zred recnd cn nnexpcl
      2nn sylancr nncnd nnne0d div13d cmin cc 2cn a1i cc0 2ne0 nn0zd expsubd 2z
      wne simpr znn0sub zexpcl eqeltrrd zmulcld eqeltrd zltp1le nndivred nngt0d
      mpbid nnred ltdivmul2 syl112anc peano2re syl ledivmul2 3bitr4d wi ioodisj
      cxr rexrd ex syl22anc sylbid imp eqtrd 3mix3 simprl peano2zd biimpa iccss
      adantrl 3sstr4d 3mix2 anassrs adantlr ltlecasei ) CIJZDIJZKZEUAJZFUAJZKZK
      ZEFUBLZKZCEGMZNOZDFGMZNOZUCZYOYMUCZYLPOZYNPOZUFZUGQZUHZDRFUDMZUEMZCREUDMZ
      UEMZYKUUDUUFUILZKZUUAUUBUUHYTUUDDUJUKMZUUCUEMZPMZUUFCUJUKMZUUEUEMZPMZUFZU
      GYKYTUUOQUUGYKYTUUNUUKUFZUUOYKYRUUNYSUUKYKYRUUFUUMULZPOUUNYKYLUUQPYKYCYFY
      LUUQQYCYDYHYJUMZYEYFYGYJUNZABCEGHUOUPZUSUUFUUMPUQURYKYSUUDUUJULZPOUUKYKYN
      UVAPYKYDYGYNUVAQYCYDYHYJUTZYEYFYGYJVAZABDFGHUOUPZUSUUDUUJPUQURVBZUUNUUKVC
      VDSYKUUGUUOUGQZYKUUGUUJUUFUBLZUVFYKDUUFUUCVEMZUILZUUIUVHUBLZUUGUVGYKYDUVH
      IJUVIUVJVFUVBYKUVHUUCUUEUEMZCVEMIYKCUUEUUCYKCYKCUURVGZVHYKUUEYKRVIJZYFUUE
      VIJVKUUSREVJVLZVMZYKUUCYKUVMYGUUCVIJVKUVCRFVJVLZVMZYKUUEUVNVNZVOYKUVKCYKR
      FEVPMZUDMZUVKIYKRFERVQJYKVRVSRVTWEYKWAVSYKEUUSWBZYKFUVCWBZWCYKRIJUVSUAJZU
      VTIJWDYKYJUWCYIYJWFYKEIJFIJYJUWCVFUWAUWBEFWGUPWORUVSWHVLWIZUURWJWKDUVHWLU
      PYKDTJZUUFTJZUUCTJZVTUUCUILZUUGUVIVFYKDUVBVGZYKCUUEUVLUVNWMZYKUUCUVPWPZYK
      UUCUVPWNZDUUFUUCWQWRYKUUITJZUWFUWGUWHUVGUVJVFYKUWEUWMUWIDWSWTZUWJUWKUWLUU
      IUUFUUCXAWRXBYKUUDXEJZUUJXEJZUUFXEJZUUMXEJZUVGUVFXCYKUUDYKDUUCUWIUVPWMZXF
      ZYKUUJYKUUIUUCUWNUVPWMXFZYKUUFUWJXFZYKUUMYKUULUUEYKCTJUULTJUVLCWSWTZUVNWM
      ZXFZUWOUWPKZUWQUWRKZKUVGUVFUUDUUJUUFUUMXDXGXHXIXJXKUUAYPYQXLZWTYKUUFUUDUB
      LZKUUBUUDUUMYKUXIUUDUUMUILZUUBYKUXIUXJKZKZYQUUBUXLUUDUUJNMZUUFUUMNMZYOYMU
      XLUWFUUMTJZUXIUUJUUMUBLZUXMUXNUCYKUWFUXKUWJSYKUXOUXKUXDSYKUXIUXJXMYKUXJUX
      PUXIYKUXJUXPYKDUUMUUCVEMZUILZUUIUXQUBLZUXJUXPYKYDUXQIJUXRUXSVFUVBYKUXQUVK
      UULVEMIYKUULUUEUUCYKUULUXCVHUVOUVQUVRVOYKUVKUULUWDYKCUURXNWJWKDUXQWLUPYKU
      WEUXOUWGUWHUXJUXRVFUWIUXDUWKUWLDUUMUUCWQWRYKUWMUXOUWGUWHUXPUXSVFUWNUXDUWK
      UWLUUIUUMUUCXAWRXBXOXQUUFUUMUUDUUJXPXHYKYOUXMQUXKYKYOUVANOUXMYKYNUVANUVDU
      SUUDUUJNUQURSYKYMUXNQUXKYKYMUUQNOUXNYKYLUUQNUUTUSUUFUUMNUQURSXRYQYPUUAXSW
      TXTYKUUMUUDUBLZUUBUXIYKUXTKZUUAUUBUYAYTUUPUGYKYTUUPQUXTUVESYKUXTUUPUGQZYK
      UWQUWRUWOUWPUXTUYBXCUXBUXEUWTUXAUXGUXFKUXTUYBUUFUUMUUDUUJXDXGXHXJXKUXHWTY
      AYKUUDTJUXIUWSSYKUXOUXIUXDSYBUWSUWJYB $.

    $( Two closed dyadic rational intervals are either in a subset relationship
       or are almost disjoint (the interiors are disjoint).  (Contributed by
       Mario Carneiro, 26-Mar-2015.) $)
    dyaddisj $p |- ( ( A e. ran F /\ B e. ran F ) ->
      ( ( [,] ` A ) C_ ( [,] ` B ) \/ ( [,] ` B ) C_ ( [,] ` A ) \/
        ( ( (,) ` A ) i^i ( (,) ` B ) ) = (/) ) ) $=
      ( va vc vb vd wcel wa wceq cn0 wrex cz cicc cfv cioo c0 crn cv co wss cin
      w3o cxp cle cr wf wfn wb dyadf ovelrn anbi12d mp2b reeanv bitr4i ad2antrl
      ffn nn0re ad2antll dyaddisjlem ancom anbi12i sylanb wo orcom incom eqeq1i
      orbi12i df-3or 3bitr4i sylib lecasei simpl fveq2d simpr sseq12d 3orbi123d
      wbr ineq12d eqeq1d syl5ibrcom rexlimdvva syl5bir rexlimivv sylbi ) CEUAZK
      ZDWIKZLZCGUBZHUBZEUCZMZHNOZDIUBZJUBZEUCZMZJNOZLZIPOGPOZCQRZDQRZUDZXFXEUDZ
      CSRZDSRZUEZTMZUFZWLWQGPOZXBIPOZLZXDPNUGZUHUIUIUGUEZEUJEXQUKZWLXPULABEFUMX
      QXREUTXSWJXNWKXOGHPNCEUNIJPNDEUNUOUPWQXBGIPPUQURXCXMGIPPXCWPXALZJNOHNOWMP
      KZWRPKZLZXMWPXAHJNNUQYCXTXMHJNNYCWNNKZWSNKZLZLZXMXTWOQRZWTQRZUDZYIYHUDZWO
      SRZWTSRZUEZTMZUFZYGYPWNWSYDWNUIKYCYEWNVAUSYEWSUIKYCYDWSVAVBABWMWRWNWSEFVC
      YGWSWNUHWAZLYKYJYMYLUEZTMZUFZYPYGYBYALZYEYDLZLYQYTYCUUAYFUUBYAYBVDYDYEVDV
      EABWRWMWSWNEFVCVFYKYJVGZYSVGYJYKVGZYOVGYTYPUUCUUDYSYOYKYJVHYRYNTYMYLVIVJV
      KYKYJYSVLYJYKYOVLVMVNVOXTXGYJXHYKXLYOXTXEYHXFYIXTCWOQWPXAVPZVQZXTDWTQWPXA
      VRZVQZVSXTXFYIXEYHUUHUUFVSXTXKYNTXTXIYLXJYMXTCWOSUUEVQXTDWTSUUGVQWBWCVTWD
      WEWFWGWH $.

    ${
      dyadmax.2 $e |- ( ph -> A e. ZZ ) $.
      dyadmax.3 $e |- ( ph -> B e. ZZ ) $.
      dyadmax.4 $e |- ( ph -> C e. NN0 ) $.
      dyadmax.5 $e |- ( ph -> D e. NN0 ) $.
      dyadmax.6 $e |- ( ph -> -. D < C ) $.
      dyadmax.7 $e |- ( ph -> ( [,] ` ( A F C ) ) C_ ( [,] ` ( B F D ) ) ) $.
      $( Lemma for ~ dyadmax .  (Contributed by Mario Carneiro,
         26-Mar-2015.) $)
      dyadmaxlem $p |- ( ph -> ( A = B /\ C = D ) ) $=
        ( cle wbr co cr wcel wceq c1 caddc c2 cexp cdiv cicc w3a cfv cop cz cn0
        dyadval syl2anc fveq2d df-ov syl6eqr clt wss dyadss syl22anc mpd nn0red
        wn wi eqleltd mpbir2and oveq2d eqtrd 3sstr3d cxr cn 2nn nnexpcl sylancr
        zred nndivred rexrd peano2re syl lep1d wb nnred nngt0d lediv1 syl112anc
        cc0 mpbid ubicc2 syl3anc sseldd elicc2 simp3d mpbird 1re leadd1d lbicc2
        a1i simp2d letri3d eqcomd jca ) ADEUAZFGUAAXCDEPQZEDPQZAXDDUBUCRZEUBUCR
        ZPQZAXHXFUDFUERZUFRZXGXIUFRZPQZAXJSTZEXIUFRZXJPQZXLAXJXNXKUGRZTZXMXOXLU
        HZADXIUFRZXJUGRZXPXJADFHRZUGUIZEGHRZUGUIZXTXPOAYBXSXJUJZUGUIXTAYAYEUGAD
        UKTZFULTZYAYEUAJLBCDFHIUMUNUOXSXJUGUPUQAYDXNXKUJZUGUIXPAYCYHUGAYCEFHRZY
        HAGFEHAGFUAGFPQZGFURQVDAYBYDUSZYJOAYFEUKTZYGGULTYKYJVEJKLMBCDEFGHIUTVAV
        BNAGFAGMVCAFLVCVFVGZVHAYLYGYIYHUAKLBCEFHIUMUNVIUOXNXKUGUPUQVJZAXSVKTZXJ
        VKTZXSXJPQZXJXTTAXSADXIADJVPZAUDVLTYGXIVLTVMLUDFVNVOZVQVRZAXJAXFXIADSTZ
        XFSTZYRDVSVTZYSVQVRZADXFPQZYQADYRWAAUUAUUBXISTZWGXIURQZUUEYQWBYRUUCAXIY
        SWCZAXIYSWDZDXFXIWEWFWHZXSXJWIWJWKAXNSTZXKSTZXQXRWBAEXIAEKVPZYSVQZAXGXI
        AESTZXGSTZUUMEVSVTZYSVQZXNXKXJWLUNWHWMAUUBUUPUUFUUGXHXLWBUUCUUQUUHUUIXF
        XGXIWEWFWNADEUBYRUUMUBSTAWOWRWPWNAXEXNXSPQZAXSSTZUUSXSXKPQZAXSXPTZUUTUU
        SUVAUHZAXTXPXSYNAYOYPYQXSXTTYTUUDUUJXSXJWQWJWKAUUKUULUVBUVCWBUUNUURXNXK
        XSWLUNWHWSAUUOUUAUUFUUGXEUUSWBUUMYRUUHUUIEDXIWEWFWNADEYRUUMWTVGAGFYMXAX
        B $.
    $}

    $( Any nonempty set of dyadic rational intervals has a maximal element.
       (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    dyadmax $p |- ( ( A C_ ran F /\ A =/= (/) ) ->
      E. z e. A A. w e. A ( ( [,] ` z ) C_ ( [,] ` w ) -> z = w ) ) $=
      ( vd vc va vn vb wa cv cz wrex cn0 wral wi wcel crn wss c0 wne clt wbr wn
      wceq crab cicc cfv weq wreu cc0 cuz wwe cvv ltweuz a1i nn0ex rabex ssrab2
      co nn0uz sseqtri id cxp cle cr cin wf wfn wb dyadf ffn ovelrn mp2b rexcom
      bitri biimpi rgen ssralv r19.2z syl2anr sylib rabn0 sylibr wereu syl13anc
      mpi reurex oveq2 eqeq2d 2rexbidv elrab eqeq1 oveq1 cbvrex2v syl5bb ralrab
      r19.23v ralbii ralcom bitr3i simplll sselda r19.29 sylbi simplrr ad2antrr
      expcom simp-5r simplrl simprl simprr dyadmaxlem oveq12 exp32 fveq2 sseq2d
      syl eqeq2 imbi12d imbi2d syl5ibrcom anassrs rexlimdva imp3a syld ralimdva
      a2d syl5bi imp an32s sseq1d ralbidv reximdva ex com23 expimpd rexlimdv
      mpd ) EFUAZUBZEUCUDZMZHNZINZUEUFUGZHCNZJNZKNZFVCZUHZJOPZCEPZKQUIZRZIUUQPZ
      UUJUJUKZDNZUJUKZUBZCDULZSZDERZCEPZUUFUURIUUQUMZUUSUUFUNUOUKZUEUPZUUQUQTZU
      UQUVIUBZUUQUCUDZUVHUVJUUFUNURUSUVKUUFUUPKQUTVAUSUVLUUFUUQQUVIUUPKQVBVDVEU
      SUUFUUPKQPZUVMUUFUUOKQPZCEPZUVNUUEUUEUVOCERZUVPUUDUUEVFUUDUVOCUUCRUVQUVOC
      UUCUUJUUCTZUVOUVRUUNKQPJOPZUVOOQVGZVHVIVIVGVJZFVKZFUVTVLZUVRUVSVMABFGVNZU
      VTUWAFVOZJKOQUUJFVPVQUUNJKOQVRVSVTWAUVOCEUUCWBWJUVOCEWCWDUUOCKEQVRWEUUPKQ
      WFWGIHUVIUUQUEUQWHWIUURIUUQWKYAUUFUURUVGIUUQUUHUUQTUUHQTZUUJUUKUUHFVCZUHZ
      JOPZCEPZMUUFUURUVGSZUUPUWJKUUHQKIULZUUNUWHCJEOUWLUUMUWGUUJUULUUHUUKFWLWMW
      NWOUUFUWFUWJUWKUUFUWFMZUURUWJUVGUURUVALNZUUGFVCZUHZLOPZDEPZUUISZHQRZUWMUW
      JUVGSZUUPUWRUUIHKQUUPUVAUWNUULFVCZUHZLOPDEPKHULZUWRUUNUXCUVAUUMUHCJDLEOUU
      JUVAUUMWPJLULZUUMUXBUVAUUKUWNUULFWQWMWRUXDUXCUWPDLEOUXDUXBUWOUVAUULUUGUWN
      FWLWMWNWSWTUWMUWTUXAUWMUWTMZUWIUVFCEUXFUUJETZMUWHUVFJOUXFUXGUUKOTZUWHUVFS
      UXFUXGUXHMZMUVFUWHUWGUJUKZUVBUBZUWGUVAUHZSZDERZUWMUXIUWTUXNUWMUXIMZUWTUXN
      UWTUWQUUISZHQRZDERZUXOUXNUWTUXPDERZHQRUXRUXSUWSHQUWQUUIDEXAXBUXPHDQEXCXDU
      XOUXQUXMDEUXOUVAETZMZUXQUXPUWQMZHQPZUXMUYAUWPHQPLOPZUXQUYCSZUYAUVAUUCTZUY
      DUXOEUUCUVAUUDUUEUWFUXIXEXFUWBUWCUYFUYDVMUWDUWELHOQUVAFVPVQWEUYDUWQHQPZUY
      EUWPLHOQVRUXQUYGUYCUXPUWQHQXGXKXHYAUYAUYBUXMHQUYAUUGQTZMZUXPUWQUXMUYIUWQU
      UIUXMUYIUWPUUIUXMSZLOUYAUYHUWNOTZUWPUYJSUYAUYHUYKMZMZUYJUWPUUIUXJUWOUJUKZ
      UBZUWGUWOUHZSZSUYMUUIUYOUYPUYMUUIUYOMZMZUXEIHULMUYPUYSABUUKUWNUUHUUGFGUYA
      UXHUYLUYRUWMUXGUXHUXTXIXJUYAUYHUYKUYRXIUUFUWFUXIUXTUYLUYRXLUYAUYHUYKUYRXM
      UYMUUIUYOXNUYMUUIUYOXOXPUUKUWNUUHUUGFXQYAXRUWPUXMUYQUUIUWPUXKUYOUXLUYPUWP
      UVBUYNUXJUVAUWOUJXSXTUVAUWOUWGYBYCYDYEYFYGYKYHYGYIYJYLYMYNUWHUVEUXMDEUWHU
      VCUXKUVDUXLUWHUUTUXJUVBUUJUWGUJXSYOUUJUWGUVAWPYCYPYEYFYGYQYRYLYSYTYLUUAUU
      B $.

    ${
      dyadmbl.2 $e |- G = { z e. A |
        A. w e. A ( ( [,] ` z ) C_ ( [,] ` w ) -> z = w ) } $.
      dyadmbl.3 $e |- ( ph -> A C_ ran F ) $.
      $( Lemma for ~ dyadmbl .  (Contributed by Mario Carneiro,
         26-Mar-2015.) $)
      dyadmbllem $p |- ( ph -> U. ( [,] " A ) = U. ( [,] " G ) ) $=
        ( va vm cicc cv wcel cxr wss wa wi vi cima cuni wrex eluni2 cfv cxp wfn
        vt wb cpw wf iccf ffn ax-mp crn cle cr cin cz dyadf inss2 ressxr xpss12
        cn0 frn mp2an sstri syl6ss eleq2 rexima sylancr weq crab wral c0 ssrab2
        wne adantr syl5ss simprl ssid fveq2 sseq2d rspcev sylancl rabn0 dyadmax
        sylibr syl2anc elrab simprlr simplrr sseldd simprll imbi1i impexp bitri
        sstr2 ad2antll ancrd imim1d syl5bir imim2d syl5bi ralimdv2 impr equequ1
        sseq1d imbi12d ralbidv elrab2 sylanbrc wfun ffun eqsstri fdmi syl6sseqr
        ad2antrr funfvima2 elunii exp32 rexlimdv rexlimdvaa sylbid ssrdv imass2
        cdm mpd uniss mp1i eqssd ) ANFUBZUCZNHUBZUCZALYNYPLOZYNPYQUAOZPZUAYMUDZ
        AYQYPPZUAYQYMUEAYTYQUIOZNUFZPZUIFUDZUUAANQQUGZUHZFUUFRYTUUEUJUUFQUKZNUL
        ZUUGUMUUFUUHNUNUOAFGUPZUUFKUUJUQURURUGZUSZUUFUTVEUGZUULGULUUJUULRBCGIVA
        UUMUULGVFUOUULUUKUUFUQUUKVBURQRZUUNUUKUUFRVCVCURQURQVDVGVHVHVIZYSUUDUAU
        IUUFFNYRUUCYQVJVKVLAUUDUUAUIFAUUBFPZUUDSZSZMOZNUFZEOZNUFZRZMEVMZTZEUUCY
        QNUFZRZLFVNZVOZMUVHUDZUUAUURUVHUUJRUVHVPVRZUVJUURUVHFUUJUVGLFVQAFUUJRUU
        QKVSVTUURUVGLFUDZUVKUURUUPUUCUUCRZUVLAUUPUUDWAUUCWBUVGUVMLUUBFLUIVMUVFU
        UCUUCYQUUBNWCWDWEWFUVGLFWGWIBCMEUVHGIWHWJUURUVIUUAMUVHUUSUVHPUUSFPZUUCU
        UTRZSZUURUVIUUATUVGUVOLUUSFLMVMUVFUUTUUCYQUUSNWCWDWKUURUVPUVIUUAUURUVPU
        VISZSZYQUUTPUUTYOPZUUAUVRUUCUUTYQUURUVNUVOUVIWLAUUPUUDUVQWMWNUVRUUSHPZU
        VSUVRUVNUVEEFVOZUVTUURUVNUVOUVIWOUURUVPUVIUWAUURUVPSZUVEUVEEUVHFUVAUVHP
        ZUVETZUVAFPZUUCUVBRZUVETZTZUWBUWEUVETUWDUWEUWFSZUVETUWHUWCUWIUVEUVGUWFL
        UVAFLEVMUVFUVBUUCYQUVANWCWDWKWPUWEUWFUVEWQWRUWBUWGUVEUWEUWGUWFUVCSZUVDT
        UWBUVEUWFUVCUVDWQUWBUVCUWJUVDUWBUVCUWFUVOUVCUWFTUURUVNUUCUUTUVBWSWTXAXB
        XCXDXEXFXGDOZNUFZUVBRZDEVMZTZEFVOZUWADUUSFHDMVMZUWOUVEEFUWQUWMUVCUWNUVD
        UWQUWLUUTUVBUWKUUSNWCXIDMEXHXJXKJXLXMUVRNXNZHNYHZRZUVTUVSTUUIUWRUMUUFUU
        HNXOUOAUWTUUQUVQAHUUFUWSAHFUUFHUWPDFVNFJUWPDFVQXPZUUOVTUUFUUHNUMXQXRXSH
        UUSNXTVLYIYQUUTYOYAWJYBXEYCYIYDYEXEYFYOYMRZYPYNRAHFRUXBUXAHFNYGUOYOYMYJ
        YKYL $.

      $( Any union of dyadic rational intervals is measurable.  (Contributed by
         Mario Carneiro, 26-Mar-2015.) $)
      dyadmbl $p |- ( ph -> U. ( [,] " A ) e. dom vol ) $=
        ( cicc com wbr wcel cen cfv wceq cr cn vn vf va vb cima cuni dyadmbllem
        cvol cdm csdm cfn isfinite wa cv ciun cxr cxp cpw wf wfun iccf funiunfv
        ffun mp2b wral simpr c1st c2nd co cop wss wi crab ssrab2 eqsstri syl5ss
        crn cle cin cz cn0 dyadf ax-mp inss2 sstri syl6ss adantr sselda 1st2nd2
        frn fveq2d df-ov syl6eqr xp1st xp2nd iccmbl syl2anc ralrimiva finiunmbl
        syl eqeltrd syl5eqelr sylan2br wf1o wex nnenom ensym entr sylancr sylib
        bren ccom rnco2 wfo f1ofo adantl fss syl2anr cioo ffvelrn syl2an sseldi
        wo fveq2 sseq1d eqeq1 imbi12d ralbidv elrab2 simprbi sseq2d eqeq2 rspcv
        sylc syld cdom cvv reex entri mp2an forn imaeq2d syl5eq caddc cabs cmin
        unieqd c1 cseq f1of c0 wdisj w3o simpl dyaddisj wf1 wb f1of1 f1fveq orc
        sylan syl6bi eqcom syl6bb olc a1i 3jaod mpd ralrimivva disjor uniiccmbl
        sylibr eqid eqeltrrd ex exlimdv syl5 xpex inex2 ssexi ssdomg mpsyl ccrd
        imp con0 omelon znnen nn0ennn xpen xpomen ensymi wfn ffn dffn4 fodomnum
        isnumi mpbi mp2 domentr domtr sylancl brdom2 mpjaodan ) ALFUEUFLHUEZUFZ
        UHUIZABCDEFGHIJKUGAHMUJNZUXEUXFOZHMPNZUXGAHUKOZUXHHULAUXJUMZUXEUAHUAUNZ
        LQZUOZUXFUPUPUQZUPURZLUSLUTUXNUXERVAUXOUXPLVCUAHLVBVDUXKUXJUXMUXFOZUAHV
        EUXNUXFOAUXJVFUXKUXQUAHUXKUXLHOUMZUXMUXLVGQZUXLVHQZLVIZUXFUXRUXMUXSUXTV
        JZLQUYAUXRUXLUYBLUXRUXLSSUQZOZUXLUYBRUXKHUYCUXLAHUYCVKUXJAHGVQZUYCAHFUY
        EHDUNZLQZEUNZLQZVKZUYFUYHRZVLZEFVEZDFVMFJUYMDFVNVOZKVPZUYEVRUYCVSZUYCVT
        WAUQZUYPGUSZUYEUYPVKBCGIWBZUYQUYPGWJWCZVRUYCWDWEWFWGWHZUXLSSWIWTWKUXSUX
        TLWLWMUXRUXSSOZUXTSOZUYAUXFOUXRUYDVUBVUAUXLSSWNWTUXRUYDVUCVUAUXLSSWOWTU
        XSUXTWPWQXAWRHUXMUAWSWQXBXCAUXIUXHUXITHUBUNZXDZUBXEZAUXHUXITHPNZVUFUXIT
        MPNMHPNVUGXFHMXGTMHXHXITHUBXKXJAVUEUXHUBAVUEUXHAVUEUMZLVUDXLVQZUFUXEUXF
        VUHVUIUXDVUHVUILVUDVQZUEUXDLVUDXMVUHVUJHLVUHTHVUDXNZVUJHRVUEVUKATHVUDXO
        XPTHVUDUUAWTUUBUUCUUGVUHUCUUDUUEUUFXLVUDXLUUHUUIZVUDVUETHVUDUSZHUYPVKTU
        YPVUDUSATHVUDUUJZAHUYEUYPUYOUYTWFTHUYPVUDXQXRVUHUCUNZUDUNZRZVUOVUDQZXSQ
        ZVUPVUDQZXSQZVSUUKRZYCZUDTVEUCTVEUCTVUSUULVUHVVCUCUDTTVUHVUOTOZVUPTOZUM
        ZUMZVURLQZVUTLQZVKZVVIVVHVKZVVBUUMZVVCVVGVURUYEOZVUTUYEOZVVLVUHTUYEVUDU
        SZVVDVVMVVFVUEVUMHUYEVKZVVOAVUNUYOTHUYEVUDXQXRZVVDVVEUUNZTUYEVUOVUDXTYA
        VUHVVOVVEVVNVVFVVQVVDVVEVFZTUYEVUPVUDXTYABCVURVUTGIUUOWQVVGVVJVVCVVKVVB
        VVGVVJVURVUTRZVVCVVGVUTFOZVVHUYIVKZVURUYHRZVLZEFVEZVVJVVTVLZVVGHFVUTUYN
        VUHVUMVVEVUTHOZVVFVUEVUMAVUNXPZVVSTHVUPVUDXTYAZYBVVGVURHOZVWEVUHVUMVVDV
        WJVVFVWHVVRTHVUOVUDXTYAZVWJVURFOZVWEUYMVWEDVURFHUYFVURRZUYLVWDEFVWMUYJV
        WBUYKVWCVWMUYGVVHUYIUYFVURLYDYEUYFVURUYHYFYGYHJYIYJWTVWDVWFEVUTFUYHVUTR
        ZVWBVVJVWCVVTVWNUYIVVIVVHUYHVUTLYDYKUYHVUTVURYLYGYMYNVVGVVTVUQVVCVUHTHV
        UDUUPZVVFVVTVUQUUQVUEVWOATHVUDUURXPTHVUOVUPVUDUUSUVAVUQVVBUUTUVBZYOVVGV
        VKVVTVVCVVGVWLVVIUYIVKZVUTUYHRZVLZEFVEZVVKVVTVLZVVGHFVURUYNVWKYBVVGVWGV
        WTVWIVWGVWAVWTUYMVWTDVUTFHUYFVUTRZUYLVWSEFVXBUYJVWQUYKVWRVXBUYGVVIUYIUY
        FVUTLYDYEUYFVUTUYHYFYGYHJYIYJWTVWSVXAEVURFUYHVURRZVWQVVKVWRVVTVXCUYIVVH
        VVIUYHVURLYDYKVXCVWRVUTVURRVVTUYHVURVUTYLVUTVURUVCUVDYGYMYNVWPYOVVBVVCV
        LVVGVVBVUQUVEUVFUVGUVHUVITVUSVVAUCUDVUQVURVUTXSVUOVUPVUDYDWKUVJUVLVULUV
        MUVKUVNUVOUVPUVQUWDAHMYPNZUXGUXIYCAHUYEYPNZUYEMYPNZVXDUYEYQOAVVPVXEUYEU
        YPUYCVRSSYRYRUVRUVSUYTUVTUYOHUYEYQUWAUWBUYEUYQYPNZUYQMPNVXFUYQUWCUIOZUY
        QUYEGXNZVXGMUWEOMUYQPNVXHUWFUYQMUYQMMUQZMVTMPNWAMPNUYQVXJPNVTTMUWGXFYSW
        ATMUWHXFYSVTMWAMUWIYTUWJYSZUWKMUYQUWPYTGUYQUWLZVXIUYRVXLUYSUYQUYPGUWMWC
        UYQGUWNUWQUYQUYEGUWOUWRVXKUYEUYQMUWSYTHUYEMUWTUXAHMUXBXJUXCXA $.
    $}

    $( Lemma for ~ opnmbl .  (Contributed by Mario Carneiro, 26-Mar-2015.) $)
    opnmbllem $p |- ( A e. ( topGen ` ran (,) ) -> A e. dom vol ) $=
      ( vz vw va vb cfv wcel cicc cv wss wa cxr cr co clt wbr vr vn vc cioo crn
      ctg crab cima cuni cvol cdm cpw wral weq fveq2 sseq1d elrab simprr sylibr
      fvex elpw sylan2b ralrimiva wfun wb cxp wf iccf ffun ax-mp ssrab2 cle cin
      cz cn0 dyadf frn inss2 ressxr mp2an sstri fdmi sseqtr4i funimass4 sspwuni
      xpss12 sylib cabs cmin ccom cres wrex cxmt eqid rexmet cmopn tgioo mopni2
      cbl crp mp3an1 caddc wceq elssuni uniretop syl6sseqr sselda bl2ioo syl2an
      rpre c1 c2 cexp cdiv 2re 1lt2 expnlbnd mp3an23 ad2antrl cmul cfl ad2antrr
      cn 2nn nnnn0 nnexpcl sylancr nnred syl syl112anc mpbird nndivred readdcld
      syl2anc rexrd recnd a1i ltadd2dd eqbrtrd wi remulcld fllelt simpld reflcl
      cc0 nngt0d ledivmul2 peano2re simprd mpbid ltled w3a elicc2 mpbir3and cop
      ltmuldiv flcld dyadval fveq2d df-ov syl6eqr eleqtrrd wfn ffn fnovrn rpred
      simplrl resubcld cc ax-1cn nnne0d divdird nnrecred lttrd leadd1dd lelttrd
      ltsubaddd iccssioo syl22anc eqsstrd simplrr sstrd sylanbrc funfvima2 expr
      elunii rexlimddv sylbid rexlimdva mpd ssrdv eqssd equequ1 imbi12d ralbidv
      ex cbvrabv dyadmbl eqeltrrd ) CUDUEUFJZKZLFMZLJZCNZFDUEZUGZUHZUIZCUJUKUXA
      UXHCUXAUXGCULZNZUXHCNUXAGMZLJZUXIKZGUXFUMZUXJUXAUXMGUXFUXKUXFKUXAUXKUXEKZ
      UXLCNZOZUXMUXDUXPFUXKUXEFGUNUXCUXLCUXBUXKLUOUPUQUXAUXQOUXPUXMUXAUXOUXPURU
      XLCUXKLUTVAUSVBVCLVDZUXFLUKZNZUXJUXNVEPPVFZPULZLVGUXRVHUYAUYBLVIVJZUXFUYA
      UXSUXFUXEUYAUXDFUXEVKZUXEVLQQVFZVMZUYAVNVOVFZUYFDVGZUXEUYFNABDEVPZUYGUYFD
      VQVJUYFUYEUYAVLUYEVRQPNZUYJUYEUYANVSVSQPQPWFVTWAWAWAUYAUYBLVHWBWCZGUXFUXI
      LWDVTUSUXGCWEWGUXAGCUXHUXAUXKCKZUXKUXHKZUXAUYLOZUXKUAMZWHWIWJUYEWKZWSJRZC
      NZUAWTWLZUYMUYPQWMJKUXAUYLUYSUYPUYPWNZWOUACUYPUXKUWTQUYPUYPWPJZUYTVUAWNWQ
      WRXAUYNUYRUYMUAWTUYNUYOWTKZOZUYRUXKUYOWIRZUXKUYOXBRZUDRZCNZUYMVUCUYQVUFCU
      YNUXKQKZUYOQKUYQVUFXCVUBUXACQUXKUXACUWTUIQCUWTXDXEXFXGZUYOXJUXKUYOUYPUYTX
      HXIUPUYNVUBVUGUYMUYNVUBVUGOZOZXKXLUBMZXMRZXNRZUYOSTZUYMUBYCVUBVUOUBYCWLZU
      YNVUGVUBXLQKXKXLSTVUPXOXPUYOXLUBXQXRXSVUKVULYCKZVUOOZOZUXKUXKVUMXTRZYAJZV
      ULDRZLJZKVVCUXGKZUYMVUSUXKVVAVUMXNRZVVAXKXBRZVUMXNRZLRZVVCVUSUXKVVHKZVUHV
      VEUXKVLTZUXKVVGVLTZUYNVUHVUJVURVUIYBZVUSVVJVVAVUTVLTZVUSVVMVUTVVFSTZVUSVU
      TQKZVVMVVNOVUSUXKVUMVVLVUSVUMVUSXLYCKVULVOKZVUMYCKYDVUQVVPVUKVUOVULYEXSZX
      LVULYFYGZYHZUUAZVUTUUBYIZUUCVUSVVAQKZVUHVUMQKZUUEVUMSTZVVJVVMVEVUSVVOVWBV
      VTVUTUUDYIZVVLVVSVUSVUMVVRUUFZVVAUXKVUMUUGYJYKZVUSUXKVVGVVLVUSVVFVUMVUSVW
      BVVFQKZVWEVVAUUHYIZVVRYLZVUSVVNUXKVVGSTZVUSVVMVVNVWAUUIVUSVUHVWHVWCVWDVVN
      VWKVEVVLVWIVVSVWFUXKVVFVUMUUPYJUUJZUUKVUSVVEQKVVGQKVVIVUHVVJVVKUULVEVUSVV
      AVUMVWEVVRYLZVWJVVEVVGUXKUUMYNUUNVUSVVCVVEVVGUUOZLJVVHVUSVVBVWNLVUSVVAVNK
      ZVVPVVBVWNXCVUSVUTVVTUUQZVVQABVVAVULDEUURYNUUSVVEVVGLUUTUVAZUVBVUSVVBUXFK
      ZVVDVUSVVBUXEKZVVCCNZVWRVUSVWOVVPVWSVWPVVQDUYGUVCZVWOVVPVWSUYHVXAUYIUYGUY
      FDUVDVJVNVOVVAVULDUVEXAYNVUSVVCVUFCVUSVVCVVHVUFVWQVUSVUDPKVUEPKVUDVVESTZV
      VGVUESTVVHVUFNVUSVUDVUSUXKUYOVVLVUSUYOUYNVUBVUGVURUVGUVFZUVHYOVUSVUEVUSUX
      KUYOVVLVXCYMZYOVUSVXBUXKVVEUYOXBRZSTVUSUXKVVGVXEVVLVWJVUSVVEUYOVWMVXCYMVW
      LVUSVVGVVEVUNXBRZVXESVUSVVAXKVUMVUSVVAVWEYPXKUVIKVUSUVJYQVUSVUMVVSYPVUSVU
      MVVRUVKUVLZVUSVUNUYOVVEVUSVUMVVRUVMZVXCVWMVUKVUQVUOURZYRYSUVNVUSUXKUYOVVE
      VVLVXCVWMUVQYKVUSVVGUXKVUNXBRZVUEVWJVUSUXKVUNVVLVXHYMVXDVUSVVGVXFVXJVLVXG
      VUSVVEUXKVUNVWMVVLVXHVWGUVOYSVUSVUNUYOUXKVXHVXCVVLVXIYRUVPVUDVUEVVEVVGUVR
      UVSUVTUYNVUBVUGVURUWAUWBUXDVWTFVVBUXEUXBVVBXCUXCVVCCUXBVVBLUOUPUQUWCUXRUX
      TVWRVVDYTUYCUYKUXFVVBLUWDVTYIUXKVVCUXGUWFYNUWGUWEUWHUWIUWJUWPUWKUWLUXAABH
      IUXFDUCMZLJZIMLJZNZUCIUNZYTZIUXFUMZUCUXFUGEVXQHMZLJZVXMNZHIUNZYTZIUXFUMUC
      HUXFUCHUNZVXPVYBIUXFVYCVXNVXTVXOVYAVYCVXLVXSVXMVXKVXRLUOUPUCHIUWMUWNUWOUW
      QUXFUXENUXAUYDYQUWRUWS $.
  $}

  ${
    $d w x y z A $.
    $( All open sets are measurable.  This proof, via ~ dyadmbl and
       ~ uniioombl , shows that it is possible to avoid choice for
       measurability of open sets and hence continuous functions, which extends
       the choice-free consequences of Lebesgue measure considerably farther
       than would otherwise be possible.  (Contributed by Mario Carneiro,
       26-Mar-2015.) $)
    opnmbl $p |- ( A e. ( topGen ` ran (,) ) -> A e. dom vol ) $=
      ( vz vw vx vy cz cn0 cv c2 cexp co cdiv caddc cop cmpt2 weq oveq1 opeq12d
      c1 oveq2d oveq1d oveq2 cbvmpt2v opnmbllem ) BCADEFGDHZIEHZJKZLKZUESMKZUGL
      KZNZODEBCFGUKBHZICHZJKZLKZULSMKZUNLKZNULUGLKZUPUGLKZNDBPZUHURUJUSUEULUGLQ
      UTUIUPUGLUEULSMQUARECPZURUOUSUQVAUGUNULLUFUMIJUBZTVAUGUNUPLVBTRUCUD $.
  $}

  ${
    $d x y A $.
    $( All open sets are measurable.  This alternative proof of ~ opnmbl is
       significantly shorter, at the expense of invoking countable choice
       ~ ax-cc .  (This was also the original proof before the current ~ opnmbl
       was discovered.)  (Contributed by Mario Carneiro, 17-Jun-2014.)
       (Proof modification is discouraged.) $)
    opnmblALT $p |- ( A e. ( topGen ` ran (,) ) -> A e. dom vol ) $=
      ( vx vy cdm wcel cioo cq cxp wss ctb ax-mp cn cdom wbr wral cen com mp2an
      cxr ioof cvol cima ctg cfv crn cv cuni wceq wa wex wb qtopbas ciun uniiun
      eltg3 wi ssdomg ccrd cres wfo con0 omelon qnnen xpen xpnnen nnenom entr2i
      entri isnumi wfun cr cpw wf ffun qssre ressxr sstri xpss12 sseqtr4i fores
      fodomnum mp2 domentr domtr sylancl imassrn wfn co ffn ioombl rgen2w ffnov
      fdmi mpbir2an frn sstr mpan2 dfss3 sylib iunmbl2 syl2anc eleq1 syl5ibrcom
      syl5eqel imp exlimiv sylbi eqid tgqioo eleq2s ) AUADZEZAFGGHZUBZUCUDZFUEZ
      UCUDAXOEZBUFZXNIZAXRUGZUHZUIZBUJZXLXNJEZXQYCUKULBAXNJUOKYBXLBXSYAXLXSXLYA
      XTXKEXSXTCXRCUFZUMZXKCXRUNXSXRLMNZYEXKECXROZYFXKEXSXRXNMNZXNLMNZYGYDXSYIU
      PULXRXNJUQKXNXMMNZXMLPNYJXMURDEZXMXNFXMUSZUTZYKQVAEQXMPNYLVBXMLQXMLLHZLGL
      PNZYPXMYOPNVCVCGLGLVDRVEVHZVFVGQXMVIRFVJZXMFDZIYNSSHZVKVLZFVMZYRTYTUUAFVN
      KXMYTYSGSIZUUCXMYTIGVKSVOVPVQZUUDGSGSVRRYTUUAFTWMVSXMFVTRXMXNYMWAWBYQXNXM
      LWCRXRXNLWDWEXSXRXKIZYHXSXNXKIUUEXNXPXKFXMWFYTXKFVMZXPXKIUUFFYTWGZXRYEFWH
      XKEZCSOBSOUUBUUGTYTUUAFWIKUUHBCSSXRYEWJWKBCSSXKFWLWNYTXKFWOKVQXRXNXKWPWQC
      XRXKWRWSXRYECWTXAXDAXTXKXBXCXEXFXGXOXOXHXIXJ $.
  $}

  ${
    $d x A $.  $d x B $.
    subopnmbl.1 $e |- J = ( ( topGen ` ran (,) ) |`t A ) $.
    $( Sets which are open in a measurable subspace are measurable.
       (Contributed by Mario Carneiro, 17-Jun-2014.) $)
    subopnmbl $p |- ( ( A e. dom vol /\ B e. J ) -> B e. dom vol ) $=
      ( vx cvol cdm wcel cv cin wceq cioo crn ctg cfv wrex crest co eleq2i ctop
      wb retop elrest syl5bb wa wi opnmbl id inmbl syl2anr eleq1a syl rexlimdva
      mpan sylbid imp ) AFGZHZBCHZBUQHZURUSBEIZAJZKZELMNOZPZUTUSBVDAQRZHZURVECV
      FBDSVDTHURVGVEUAUBEBAVDTUQUCUNUDURVCUTEVDURVAVDHZUEVBUQHZVCUTUFVHVAUQHURV
      IURVAUGURUHVAAUIUJVBUQBUKULUMUOUP $.
  $}

  ${
    $d m n x z A $.  $d n x z B $.
    $( The volume of ` A ` is the supremum of the sequence
       ` vol* `` ( A i^i ( -u n [,] n ) ) ` of volumes of bounded sets.
       (Contributed by Mario Carneiro, 30-Aug-2014.) $)
    volsup2 $p |- ( ( A e. dom vol /\ B e. RR /\ B < ( vol ` A ) ) ->
      E. n e. NN B < ( vol ` ( A i^i ( -u n [,] n ) ) ) ) $=
      ( vm cvol wcel cr cfv wbr cicc co cn cle wral cxr wb syl2anc wceq syl wss
      vx vz cdm clt w3a cv cneg cin wrex wn rexr 3ad2ant2 cc0 cpnf iccssxr volf
      simp3 ffvelrni sseldi 3ad2ant1 xrltnle mpbid cmpt crn cima csup cuni ciun
      negeq id oveq12d ineq2d eqid ovex inex2 fvmpt iuneq2i iunin2 eqtri wfn wf
      simpl1 nnre adantl renegcld iccmbl inmbl cbvmptv fmptd ffn fniunfv sselda
      wa mblss cabs recn abscld arch wi ltle syl2an 3expib adantr sylan2 elicc2
      absle 3imtr4d syld reximdva mpd ex eliun syl6ibr ssrdv df-ss sylib fveq2d
      3eqtr3a caddc peano2re lep1d lenegd iccss syl22anc sslin peano2nn 3sstr4d
      c1 ralrimiva volsup eqtr3d breq1d imassrn frn ax-mp sstri supxrleub breq1
      sylancr ralima fveq2 ralrn syl6bb bitrd 3bitrd mtbid rexnal sylibr mpbird
      ralbiia rexbidva ) AEUCZFZBGFZBAEHZUDIZUEZBACUFZUGZUURJKZUHZEHZUDIZCLUIUV
      BBMIZUJZCLUIZUUQUVDCLNZUJUVFUUQUUOBMIZUVGUUQUUPUVHUJZUUMUUNUUPUQUUQBOFZUU
      OOFZUUPUVIPUUNUUMUVJUUPBUKULZUUMUUNUVKUUPUUMUMUNJKZOUUOUMUNUOZUULUVMAEUPU
      RUSUTBUUOVAQVBUUQUVHEDLADUFZUGZUVOJKZUHZVCZVDZVEZOUDVFZBMIZUURBMIZCUWANZU
      VGUUQUUOUWBBMUUQUVTVGZEHZUUOUWBUUQUWFAEUUQCLUURUVSHZVHZACLUUTVHZUHZUWFAUW
      ICLUVAVHUWKCLUWHUVADUURUVRUVALUVSUVOUURRZUVQUUTAUWLUVPUUSUVOUURJUVOUURVIU
      WLVJVKVLZUVSVMZUUTAUUSUURJVNVOVPZVQCLAUUTVRVSUUQUVSLVTZUWIUWFRUUQLUULUVSW
      AZUWPUUQCLUVAUULUVSUUQUURLFZWMZUUMUUTUULFZUVAUULFZUUMUUNUUPUWRWBUWSUUSGFZ
      UURGFZUWTUWSUURUWRUXCUUQUURWCZWDZWEUXEUUSUURWFQAUUTWGQZDCLUVRUVAUWMWHWIZL
      UULUVSWJSZCLUVSWKSUUQAUWJTUWKARUUQUAAUWJUUQUAUFZAFZUXIUUTFZCLUIZUXIUWJFUU
      QUXJUXLUUQUXJWMUXIGFZUXLUUQAGUXIUUMUUNAGTUUPAWNUTWLUXMUXIWOHZUURUDIZCLUIZ
      UXLUXMUXNGFZUXPUXMUXIUXIWPWQZUXNCWRSUXMUXOUXKCLUXMUWRWMZUXOUXNUURMIZUXKUX
      MUXQUXCUXOUXTWSUWRUXRUXDUXNUURWTXAUXSUUSUXIMIZUXIUURMIZWMZUXMUYAUYBUEZUXT
      UXKUXMUYCUYDWSUWRUXMUYAUYBUYDUYDVJXBXCUWRUXMUXCUXTUYCPUXDUXIUURXFXDUXSUXB
      UXCUXKUYDPUXSUURUWRUXCUXMUXDWDZWEUYEUUSUURUXIXEQXGXHXIXJSXKCUXILUUTXLXMXN
      AUWJXOXPXRXQUUQUWQUWHUURYHXSKZUVSHZTZCLNUWGUWBRUXGUUQUYHCLUWSUVAAUYFUGZUY
      FJKZUHZUWHUYGUWSUUTUYJTZUVAUYKTUWSUYIGFUYFGFZUYIUUSMIZUURUYFMIZUYLUWSUYFU
      WSUXCUYMUXEUURXTSZWEUYPUWSUYOUYNUWSUURUXEYAZUWSUURUYFUXEUYPYBVBUYQUYIUYFU
      USUURYCYDUUTUYJAYESUWRUWHUVARUUQUWOWDUWSUYFLFZUYGUYKRUWRUYRUUQUURYFWDDUYF
      UVRUYKLUVSUVOUYFRZUVQUYJAUYSUVPUYIUVOUYFJUVOUYFVIUYSVJVKVLUWNUYJAUYIUYFJV
      NVOVPSYGYICUVSYJQYKYLUUQUWAOTUVJUWCUWEPUWAEVDZOEUVTYMUYTUVMOUULUVMEWAZUYT
      UVMTUPUULUVMEYNYOUVNYPYPUVLCUWABYQYSUUQUWEUBUFZEHZBMIZUBUVTNZUVGUUQEUULVT
      ZUVTUULTZUWEVUEPVUAVUFUPUULUVMEWJYOUUQUWQVUGUXGLUULUVSYNSUWDVUDCUBUULUVTE
      UURVUCBMYRYTYSUUQVUEUWHEHZBMIZCLNZUVGUUQUWPVUEVUJPUXHVUDVUIUBCLUVSVUBUWHR
      VUCVUHBMVUBUWHEUUAYLUUBSVUIUVDCLUWRVUHUVBBMUWRUWHUVAEUWOXQYLUUJUUCUUDUUEU
      UFUVDCLUUGUUHUUQUVCUVECLUWSUVJUVBOFZUVCUVEPUUQUVJUWRUVLXCUWSUXAVUKUXFUXAU
      VMOUVBUVNUULUVMUVAEUPURUSSBUVBVAQUUKUUI $.
  $}

  ${
    $d e u v x y z A $.  $d e u v x y z B $.  $d d e u v y z F $.
    volcn.1 $e |- F = ( x e. RR |-> ( vol ` ( A i^i ( B [,] x ) ) ) ) $.
    $( The function formed by restricting a measurable set to a closed interval
       with a varying endpoint produces an increasing continuous function on
       the reals.  (Contributed by Mario Carneiro, 30-Aug-2014.) $)
    volcn $p |- ( ( A e. dom vol /\ B e. RR ) -> F e. ( RR -cn-> RR ) ) $=
      ( vz wcel cr wa cmin co cabs cfv clt wbr wceq syl wss adantr cle vy vd ve
      vv vu cvol cdm wf cv wi wral crp wrex ccncf cicc cin covol simpll adantll
      iccmbl inmbl syl2anc mblvol inss2 mblss iccvolcl eqeltrrd syl3anc eqeltrd
      a1i fmptd simprr weq oveq12 ancoms fveq2d breq1d fveq2 oveqan12rd imbi12d
      ovolsscl ssid cc abssub syl2anr adantl ffvelrn anim12dan sylan w3a simpr2
      oveq2 ineq2d fvmpt simplll simplr eqtrd simpr1 simp1 syl2an oveq12d caddc
      recn fvex cun ffvelrnd leidd simpr3 iccss syl22anc sslin iccssre resubcld
      sstrd unssd readdcld ovolicc ovolun oveq2d ovollecl simpr wb simp2 elicc2
      breqtrd mpbir3and iccsplit eqimss ssun4 lecasei indi unss2 eqsstri syl6ss
      ax-mp ovolss letrd lesubadd2d mpbird ax-resscn eqbrtrd rpred lelttr mpand
      abssubge0 3brtr4d abssubge0d 3imtr4d wlogle anassrs anasss ancom2s imbi1d
      ralrimiva breq2 ralbidv rspcev ralrimivva elcncf2 mp2an sylanbrc ) BUFUGZ
      GZCHGZIZHHDUHZFUIZUAUIZJKZLMZUBUIZNOZUVGDMZUVHDMZJKZLMZUCUIZNOZUJZFHUKZUB
      ULUMZUCULUKUAHUKZDHHUNKGZUVEAHBCAUIZUOKZUPZUFMZHDUVEUWDHGZIZUWGUWFUQMZHUW
      IUWFUVBGZUWGUWJPUWIUVCUWEUVBGZUWKUVCUVDUWHURUVDUWHUWLUVCCUWDUTUSZBUWEVAVB
      UWFVCQUWIUWFUWERZUWEHRZUWEUQMZHGUWJHGUWNUWIBUWEVDVJUWIUWLUWOUWMUWEVEQUWIU
      WEUFMZUWPHUWIUWLUWQUWPPUWMUWEVCQUVDUWHUWQHGUVCCUWDVFUSVGUWFUWEWAVHVIEVKZU
      VEUWAUAUCHULUVEUVHHGZUVQULGZIIUWTUVJUVQNOZUVRUJZFHUKZUWAUVEUWSUWTVLUVEUWT
      UWSUXCUVEUWTUWSUXCUVEUWTIZUWSIUXBFHUXDUWSUVGHGZUXBUXDUDUIZUEUIZJKZLMZUVQN
      OZUXFDMZUXGDMZJKZLMZUVQNOZUJUXBUVHUVGJKZLMZUVQNOZUVNUVMJKZLMZUVQNOZUJUAFU
      EUDHUEUAVMZUDFVMZIZUXJUXAUXOUVRUYDUXIUVJUVQNUYDUXHUVILUYCUYBUXHUVIPUXFUVG
      UXGUVHJVNVOVPVQUYDUXNUVPUVQNUYDUXMUVOLUYCUYBUXKUVMUXLUVNJUXFUVGDVRUXGUVHD
      VRVSVPVQVTUEFVMZUDUAVMZIZUXJUXRUXOUYAUYGUXIUXQUVQNUYGUXHUXPLUYFUYEUXHUXPP
      UXFUVHUXGUVGJVNVOVPVQUYGUXNUXTUVQNUYGUXMUXSLUYFUYEUXKUVNUXLUVMJUXFUVHDVRU
      XGUVGDVRVSVPVQVTHHRUXDHWBVJUXDUWSUXEIZIZUXAUXRUVRUYAUYIUVJUXQUVQNUYHUVJUX
      QPZUXDUXEUVGWCGUVHWCGUYJUWSUVGXCUVHXCUVGUVHWDWEWFVQUYIUVPUXTUVQNUYIUVNHGZ
      UVMHGZIZUVPUXTPZUXDUVFUYHUYMUVEUVFUWTUWRSZUVFUWSUYKUXEUYLHHUVHDWGHHUVGDWG
      WHWIUYLUVMWCGUVNWCGUYNUYKUVMXCUVNXCUVMUVNWDWEQVQVTUXDUWSUXEUVHUVGTOZWJZIZ
      UVIUVQNOZUVOUVQNOZUXAUVRUYRUVOUVITOZUYSUYTUYRUVOBCUVGUOKZUPZUQMZBCUVHUOKZ
      UPZUQMZJKZUVITUYRUVMVUDUVNVUGJUYRUVMVUCUFMZVUDUYRUXEUVMVUIPUXDUWSUXEUYPWK
      ZAUVGUWGVUIHDAFVMZUWFVUCUFVUKUWEVUBBUWDUVGCUOWLWMVPEVUCUFXDWNQUYRVUCUVBGZ
      VUIVUDPUYRUVCVUBUVBGZVULUVCUVDUWTUYQWOZUYRUVDUXEVUMUXDUVDUYQUVCUVDUWTWPZS
      ZVUJCUVGUTVBBVUBVAVBZVUCVCQWQZUYRUVNVUFUFMZVUGUYRUWSUVNVUSPUXDUWSUXEUYPWR
      ZAUVHUWGVUSHDAUAVMZUWFVUFUFVVAUWEVUEBUWDUVHCUOWLWMVPEVUFUFXDWNQUYRVUFUVBG
      ZVUSVUGPUYRUVCVUEUVBGZVVBVUNUXDUVDUWSVVCUYQVUOUWSUXEUYPWSCUVHUTWTBVUEVAVB
      VUFVCQWQZXAUYRVUHUVITOVUDVUGUVIXBKZTOUYRVUDVUFUVHUVGUOKZXEZUQMZVVEUYRUVMV
      UDHVURUYRHHUVGDUXDUVFUYQUYOSZVUJXFZVGZUYRVVGHRZVVEHGVVHVVETOVVHHGUYRVUFVV
      FHUYRVUFVUCHUYRVUEVUBRZVUFVUCRZUYRUVDUXECCTOUYPVVMVUPVUJUYRCVUPXGUXDUWSUX
      EUYPXHZCUVGCUVHXIXJVUEVUBBXKQZUYRVULVUCHRZVUQVUCVEQZXNZUYRUWSUXEVVFHRZVUT
      VUJUVHUVGXLVBZXOZUYRVUGUVIUYRUVNVUGHVVDUYRHHUVHDVVIVUTXFZVGZUYRUVGUVHVUJV
      UTXMZXPZUYRVVHVUGVVFUQMZXBKZVVETUYRVUFHRVUGHGVVTVWGHGVVHVWHTOVVSVWDVWAUYR
      VWGUVIHUYQVWGUVIPUXDUVHUVGXQWFZVWEVIVUFVVFXRXJUYRVWGUVIVUGXBVWIXSYEZVVGVV
      EXTVHVWFUYRVUCVVGRVVLVUDVVHTOUYRVUCBVUEVVFXEZUPZVVGUYRVUBVWKRZVUCVWLRUYRV
      WMCUVHVUPVUTUYRCUVHTOZIZVUBVWKPZVWMVWOUVDUXEUVHVUBGZVWPUYRUVDVWNVUPSUYRUX
      EVWNVUJSVWOVWQUWSVWNUYPUYRUWSVWNVUTSUYRVWNYAUYRUYPVWNVVOSUYRVWQUWSVWNUYPW
      JYBZVWNUXDUVDUXEVWRUYQVUOUWSUXEUYPYCCUVGUVHYDWTSYFCUVGUVHYGVHVUBVWKYHQUYR
      UVHCTOZIZVUBVVFRZVWMVWTUWSUXEVWSUVGUVGTOVXAUYRUWSVWSVUTSUYRUXEVWSVUJSZUYR
      VWSYAVWTUVGVXBXGUVHUVGCUVGXIXJVUBVVFVUEYIQYJVUBVWKBXKQVWLVUFBVVFUPZXEZVVG
      BVUEVVFYKVXCVVFRVXDVVGRBVVFVDVXCVVFVUFYLYOYMYNVWBVUCVVGYPVBVWJYQUYRVUDVUG
      UVIVVKVWDVWEYRYSUUAUYRUVOHGUVIHGUVQHGVUAUYSIUYTUJUYRUVMUVNVVJVWCXMVWEUYRU
      VQUVEUWTUYQWPUUBUVOUVIUVQUUCVHUUDUYRUVJUVIUVQNUYQUVJUVIPUXDUVHUVGUUEWFVQU
      YRUVPUVOUVQNUYRUVNUVMVWCVVJUYRVUGVUDUVNUVMTUYRVVNVVQVUGVUDTOVVPVVRVUFVUCY
      PVBVVDVURUUFUUGVQUUHUUIUUJUUNUUKUULUVTUXCUBUVQULUBUCVMZUVSUXBFHVXEUVLUXAU
      VRUVKUVQUVJNUUOUUMUUPUUQVBUURHWCRZVXFUWCUVFUWBIYBYTYTUAUCUBFHHDUUSUUTUVA
      $.
  $}

  ${
    $d n u x y z A $.  $d n u x z B $.
    $( The Intermediate Value Theorem for the Lebesgue volume function.  For
       any positive ` B <_ ( vol `` A ) ` , there is a measurable subset of
       ` A ` whose volume is ` B ` .  (Contributed by Mario Carneiro,
       30-Aug-2014.) $)
    volivth $p |- ( ( A e. dom vol /\ B e. ( 0 [,] ( vol ` A ) ) ) ->
      E. x e. dom vol ( x C_ A /\ ( vol ` x ) = B ) ) $=
      ( vy cvol wcel cc0 cfv cicc co wa wbr wss wceq cxr adantr cle syl2anc syl
      cr vn vz vu cdm clt cv wrex cneg cin simpll cmnf mnfxr a1i iccssxr sseldi
      cn simpr cpnf volf ffvelrni w3a wb 0xr elicc1 sylancr mpbid simp2d wi 0re
      mnflt ax-mp xrltletr mpani mp3an12 sylc syl32anc volsup2 syl3anc ad2antrl
      xrre2 cmpt nnre renegcld nngt0 lt0neg2d lttrd iccssre cc ax-resscn cncfss
      ccncf ssid mp2an eqid volcn sselda wf cncff ffvelrnda syldan covol ineq2d
      oveq2 fveq2d fvex fvmpt csn inss2 rexrd iccid syl5sseq snssd sstrd ovolsn
      ovolssnul nulmbl mblvol 3eqtrd eqbrtrd simprr iccmbl inmbl xrltle mpd jca
      breqtrrd ivthle eqeq1d adantrr inss1 sseq1 anbi12d rspcev syl12anc sylbid
      fveq2 expr rexlimdva rexlimddv eqcomd wo simp3d xrleloe mpjaodan ) BEUDZF
      ZCGBEHZIJZFZKZCUUGUELZAUFZBMZUULEHZCNZKZAUUEUGZCUUGNZUUJUUKKZCBUAUFZUHZUU
      TIJZUIZEHZUELZUUQUAUPUUSUUFCTFZUUKUVEUAUPUGUUFUUIUUKUJZUUSUKOFZCOFZUUGOFZ
      UKCUELZUUKUVFUVHUUSULUMUUJUVIUUKUUJUUHOCGUUGUNUUFUUIUQZUOZPZUUJUVJUUKUUFU
      VJUUIUUFGURIJZOUUGGURUNZUUEUVOBEUSUTUOPZPUUSUVIGCQLZUVKUVNUUJUVRUUKUUJUVI
      UVRCUUGQLZUUJUUIUVIUVRUVSVAZUVLUUJGOFZUVJUUIUVTVBVCUVQGUUGCVDVEVFZVGPZUVH
      UWAUVIUVRUVKVHULVCUVHUWAUVIVAUKGUELZUVRUVKGTFZUWDVIGVJVKUKGCVLVMVNVOUUJUU
      KUQZUKCUUGVTVPZUWFBCUAVQVRUUSUUTUPFZUVEKZKZUBUFZDTBUVADUFZIJZUIZEHZWAZHZC
      NZUBUVBUGUUQUWJUCUVAUUTTCUWPUBUWJUUTUWHUUTTFZUUSUVEUUTWBVSZWCZUWTUUSUVFUW
      IUWGPUWJUVAGUUTUXAUWEUWJVIUMUWTUWJGUUTUELZUVAGUELUWHUXBUUSUVEUUTWDVSZUWJU
      UTUWTWEVFUXCWFUWJUVATFZUWSUVBTMUXAUWTUVAUUTWGRZUWJTTWKJZTWHWKJZUWPTWHMWHW
      HMUXFUXGMWIWHWLTTWHWJWMUWJUUFUXDUWPUXFFZUUSUUFUWIUVGPZUXADBUVAUWPUWPWNZWO
      RZUOUWJUCUFZUVBFUXLTFUXLUWPHTFUWJUVBTUXLUXEWPUWJTTUXLUWPUWJUXHTTUWPWQUXKT
      TUWPWRSWSWTUWJUVAUWPHZCQLCUUTUWPHZQLUWJUXMGCQUWJUXMBUVAUVAIJZUIZEHZUXPXAH
      ZGUWJUXDUXMUXQNUXADUVAUWOUXQTUWPUWLUVANZUWNUXPEUXSUWMUXOBUWLUVAUVAIXCXBXD
      UXJUXPEXEXFSUWJUXPUUEFZUXQUXRNUWJUXPTMUXRGNZUXTUWJUXPUVAXGZTUWJUXOUXPUYBB
      UXOXHUWJUVAOFUXOUYBNUWJUVAUXAXIUVAXJSXKZUWJUVATUXAXLZXMUWJUXPUYBMUYBTMUYB
      XAHGNZUYAUYCUYDUWJUXDUYEUXAUVAXNSUXPUYBXOVRZUXPXPRUXPXQSUYFXRUUSUVRUWIUWC
      PXSUWJCUVDUXNQUWJUVECUVDQLZUUSUWHUVEXTUWJUVIUVDOFZUVEUYGVHUUSUVIUWIUVNPUW
      JUVCUUEFZUYHUWJUUFUVBUUEFZUYIUXIUWJUXDUWSUYJUXAUWTUVAUUTYARBUVBYBRUYIUVOO
      UVDUVPUUEUVOUVCEUSUTUOSCUVDYCRYDUWJUWSUXNUVDNUWTDUUTUWOUVDTUWPUWLUUTNZUWN
      UVCEUYKUWMUVBBUWLUUTUVAIXCXBXDUXJUVCEXEXFSYFYEYGUWJUWRUUQUBUVBUWJUWKUVBFZ
      KZUWRBUVAUWKIJZUIZEHZCNZUUQUYMUWQUYPCUYMUWKTFZUWQUYPNUWJUVBTUWKUXEWPZDUWK
      UWOUYPTUWPUWLUWKNZUWNUYOEUYTUWMUYNBUWLUWKUVAIXCXBXDUXJUYOEXEXFSYHUWJUYLUY
      QUUQUWJUYLUYQKZKZUYOUUEFZUYOBMZUYQUUQVUBUUFUYNUUEFZVUCUWJUUFVUAUXIPVUBUXD
      UYRVUEUWJUXDVUAUXAPUWJUYLUYRUYQUYSYIUVAUWKYARBUYNYBRVUDVUBBUYNYJUMUWJUYLU
      YQXTUUPVUDUYQKAUYOUUEUULUYONZUUMVUDUUOUYQUULUYOBYKVUFUUNUYPCUULUYOEYPYHYL
      YMYNYQYOYRYDYSUUJUURKZUUFBBMZUUGCNZUUQUUFUUIUURUJVUHVUGBWLUMVUGCUUGUUJUUR
      UQYTUUPVUHVUIKABUUEUULBNZUUMVUHUUOVUIUULBBYKVUJUUNUUGCUULBEYPYHYLYMYNUUJU
      VSUUKUURUUAZUUJUVIUVRUVSUWBUUBUUJUVIUVJUVSVUKVBUVMUVQCUUGUUCRVFUUD $.
  $}

  ${
    $d m n s x y z G $.  $d k m n v w x z ph $.  $d w z S $.  $d k m v w x T $.
    $d k m n s v w x y z F $.  $d m n s u v w x y z .~ $.
    vitali.1 $e |- .~ = { <. x , y >. |
         ( ( x e. ( 0 [,] 1 ) /\ y e. ( 0 [,] 1 ) ) /\ ( x - y ) e. QQ ) } $.
    $( Lemma for ~ vitali .  (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    vitalilem1 $p |- .~ Er ( 0 [,] 1 ) $=
      ( vu vv vw cc0 co wtru cv wcel wa cmin cq wbr weq oveq12 eleq1d brab2ga
      c1 cicc wer wrel relopabi a1i simplr simpll cc cr unitssre sseli ad2antrr
      cneg recnd ad2antlr negsubdi2d qnegcl adantl eqeltrrd jca31 3imtr4i simpl
      sylib simpld simpr simprd jca caddc syl sseldi npncand qaddcl sylanbrc wb
      syl2anc subidd cz 0z zq ax-mp syl6eqel adantr pm4.71i pm4.24 3bitr4i trud
      iserd ) HUAUBIZCUCJEFGWICCUDJAKZWILBKZWILMWJWKNIZOLZMABCDUEUFEKZFKZCPZWOW
      NCPZJWNWILZWOWILZMZWNWONIZOLZMZWSWRMWOWNNIZOLZMWPWQXCWSWRXEWRWSXBUGWRWSXB
      UHXCXAUNZXDOXCWNWOWRWNUILZWSXBWRWNWIUJWNUKULUOZUMWSWOUILZWRXBWSWOWIUJWOUK
      ULUOUPZUQXBXFOLWTXAURUSUTVAWMXBABWNWOWIWICAEQZBFQMWLXAOWJWNWKWONRSDTZWMXE
      ABWOWNWIWICAFQZBEQZMWLXDOWJWOWKWNNRSDTVBUSWPWOGKZCPZMZWNXOCPZJXQWRXOWILZM
      WNXONIZOLZXRXQWRXSXQWRWSXQWTXBXQWPXCWPXPVCXLVDZVEVEZXQWSXSXQWSXSMZWOXONIZ
      OLZXQXPYDYFMWPXPVFWMYFABWOXOWIWICXMBGQZMWLYEOWJWOWKXONRSDTVDZVEVGZVHXQXAY
      EVIIZXTOXQWNWOXOXQWRXGYCXHVJXQXCXIYBXJVJXQXOXQWIUJXOUKYIVKUOVLXQXBYFYJOLX
      QWTXBYBVGXQYDYFYHVGXAYEVMVPUTWMYAABWNXOWIWICXKYGMWLXTOWJWNWKXONRSDTVNUSWR
      WNWNCPZVOJWRWRMZYLWNWNNIZOLZMWRYKYLYNWRYNWRWRYMHOWRWNXHVQHVRLHOLVSHVTWAWB
      WCWDWRWEWMYNABWNWNWIWICXKXNMWLYMOWJWNWKWNNRSDTWFUFWHWG $.

    vitali.2 $e |- S = ( ( 0 [,] 1 ) /. .~ ) $.
    vitali.3 $e |- ( ph -> F Fn S ) $.
    vitali.4 $e |- ( ph -> A. z e. S ( z =/= (/) -> ( F ` z ) e. z ) ) $.
    vitali.5 $e |- ( ph -> G : NN -1-1-onto-> ( QQ i^i ( -u 1 [,] 1 ) ) ) $.
    vitali.6 $e |- T = ( n e. NN |-> { s e. RR |
                         ( s - ( G ` n ) ) e. ran F } ) $.
    vitali.7 $e |- ( ph -> -. ran F e. ( ~P RR \ dom vol ) ) $.
    $( Lemma for ~ vitali .  (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    vitalilem2 $p |- ( ph ->
      ( ran F C_ ( 0 [,] 1 ) /\ ( 0 [,] 1 ) C_ U_ m e. NN ( T ` m ) /\
        U_ m e. NN ( T ` m ) C_ ( -u 1 [,] 2 ) ) ) $=
      ( wcel vv vw crn cc0 c1 cicc co wss cn cv cfv ciun cneg c2 wf wfn wral c0
      wne wi cec neeq1 cdm wer wceq vitalilem1 erdm eleq2i ecdmn0 bitr3i biimpi
      wa ax-mp ectocl adantl sseq1 a1i ecss sseld embantd ralimdva mpd sylanbrc
      ffnfv frn syl wrex cmin ccnv cq cin wf1o adantr f1ocnv f1of 3syl cqs ovex
      cvv erex mp2 ecelqsi sylib fveq2 wbr weq eleq1d simprd cr cle w3a 0re 1re
      simp1d simpld resubcld simp2d subge02d mpbid simp3d letrd recnd syl3anbrc
      elicc2i crab syl2anc oveq2d oveq1 elrab rabbidv reex rabex fvmpt eliun ex
      eleq2d ssrdv sseldi caddc 2re syl6eleqr simpr eleq12d imbi12d rspcv syl3c
      id fvex elec oveq12 brab2ga bitri lenegd negsubdi2d breqtrd renegcli elin
      vex ffvelrnd f1ocnvfv2 nncand eqtrd fnfvelrn eqeltrd rspcev sylibr biimpa
      eleqtrrd iccssre mp2an inss2 ffvelrnda ad2antrr sseldd subge0d lesubadd2d
      peano2re leadd1dd df-2 syl6breqr rexlimdva syl5bi 3jca ) AJUCZUDUEUFUGZUH
      ZUWEHUIHUJZGUKZULZUHUWIUEUMZUNUFUGZUHAFUWEJUOZUWFAJFUPZDUJZJUKZUWETZDFUQZ
      UWLOAUWNURUSZUWOUWNTZUTZDFUQZUWQPAUWTUWPDFAUWNFTZVLZUWRUWSUWPUXBUWRAUAUJZ
      EVAZURUSZUWRUAUWNUWEEFNUXEUWNURVBUXDUWETZUXFUXGUXDEVCZTUXFUXHUWEUXDUWEEVD
      ZUXHUWEVEBCEMVFZUWEEVGVMVHUXDEVIVJZVKVNVOUXCUWNUWEUWOUXBUWNUWEUHZAUBUJZEV
      AZUWEUHUXLUBUWNUWEEFNUXNUWNUWEVPUXMUWETZUXMEUWEUXIUXOUXJVQVRVNVOVSVTWAWBD
      FUWEJWDWCFUWEJWEWFZAUAUWEUWIAUXGUXDUWITZAUXGVLZUXDUWHTZHUIWGZUXQUXRUXDUXE
      JUKZWHUGZKWIZUKZUITZUXDUYDGUKZTZUXTUXRWJUWJUEUFUGZWKZUIUYBUYCUXRUIUYIKWLZ
      UYIUIUYCWLUYIUIUYCUOAUYJUXGQWMZUIUYIKWNUYIUIUYCWOWPUXRUYBWJTZUYBUYHTZUYBU
      YITZUXRUXGUYAUWETZVLZUYLUXRUYAUXETZUYPUYLVLZUXRUXEFTZUXAUXFUYQUXRUXEUWEEW
      QZFUXGUXEUYTTAUWEUXDEUXIUWEWSTEWSTUXJUDUEUFWRUWEEWSWTXAXBVONUUAZAUXAUXGPW
      MUXRUXGUXFAUXGUUBZUXKXCUWTUXFUYQUTDUXEFUWNUXEVEZUWRUXFUWSUYQUWNUXEURVBVUC
      UWOUYAUWNUXEUWNUXEJXDVUCUUGUUCUUDUUEUUFUYQUXDUYAEXEUYRUYAUXDEUXEJUUHUAUUR
      UUIBUJZCUJZWHUGZWJTUYLBCUXDUYAUWEUWEEBUAXFVUEUYAVEVLVUFUYBWJVUDUXDVUEUYAW
      HUUJXGMUUKUULXCZXHUXRUYBXITUWJUYBXJXEUYBUEXJXEUYMUXRUXDUYAUXRUXDXITZUDUXD
      XJXEZUXDUEXJXEZUXRUXGVUHVUIVUJXKVUBUDUEUXDXLXMYDXCZXNZUXRUYAXITZUDUYAXJXE
      ZUYAUEXJXEZUXRUYOVUMVUNVUOXKUXRUXGUYOUXRUYPUYLVUGXOXHUDUEUYAXLXMYDXCZXNZX
      PZUXRUWJUYAUXDWHUGZUMZUYBXJUXRVUSUEXJXEUWJVUTXJXEUXRVUSUYAUEUXRUYAUXDVUQV
      ULXPZVUQUEXITZUXRXMVQZUXRVUIVUSUYAXJXEUXRVUHVUIVUJVUKXQUXRUYAUXDVUQVULXRX
      SUXRVUMVUNVUOVUPXTYAUXRVUSUEVVAVVCUUMXSUXRUYAUXDUXRUYAVUQYBZUXRUXDVULYBZU
      UNUUOUXRUYBUXDUEVURVULVVCUXRVUNUYBUXDXJXEUXRVUMVUNVUOVUPXQUXRUXDUYAVULVUQ
      XRXSUXRVUHVUIVUJVUKXTYAUWJUEUYBUEXMUUPZXMYDYCUYBWJUYHUUQWCZUUSZUXRUXDLUJZ
      UYDKUKZWHUGZUWDTZLXIYEZUYFUXRVUHUXDVVJWHUGZUWDTZUXDVVMTVULUXRVVNUYAUWDUXR
      VVNUXDUYBWHUGUYAUXRVVJUYBUXDWHUXRUYJUYNVVJUYBVEUYKVVGUIUYIUYBKUUTYFYGUXRU
      XDUYAVVEVVDUVAUVBUXRUWMUYSUYAUWDTAUWMUXGOWMVUAFUXEJUVCYFUVDVVLVVOLUXDXILU
      AXFVVKVVNUWDVVIUXDVVJWHYHXGYIWCUXRUYEUYFVVMVEVVHIUYDVVIIUJZKUKZWHUGZUWDTZ
      LXIYEZVVMUIGVVPUYDVEZVVSVVLLXIVWAVVRVVKUWDVWAVVQVVJVVIWHVVPUYDKXDYGXGYJRV
      VLLXIYKYLYMWFUVHUXSUYGHUYDUIUWGUYDVEUWHUYFUXDUWGUYDGXDYPUVEYFHUXDUIUWHYNU
      VFYOYQABUWIUWKVUDUWITVUDUWHTZHUIWGAVUDUWKTZHVUDUIUWHYNAVWBVWCHUIAUWGUITZV
      LZVWBVWCVWEVWBVLZVUDXITZUWJVUDXJXEVUDUNXJXEVWCVWFVWGVUDUWGKUKZWHUGZUWDTZV
      WFVUDVVIVWHWHUGZUWDTZLXIYEZTZVWGVWJVLVWEVWBVWNVWEUWHVWMVUDVWDUWHVWMVEAIUW
      GVVTVWMUIGIHXFZVVSVWLLXIVWOVVRVWKUWDVWOVVQVWHVVIWHVVPUWGKXDYGXGYJRVWLLXIY
      KYLYMVOYPUVGVWLVWJLVUDXILBXFVWKVWIUWDVVIVUDVWHWHYHXGYIXCZXOZVWFUWJVWHVUDU
      WJXITZVWFVVFVQVWEVWHXITZVWBVWEUYHXIVWHVWRVVBUYHXIUHVVFXMUWJUEUVIUVJVWEUYI
      UYHVWHWJUYHUVKAUIUYIUWGKAUYJUIUYIKUOQUIUYIKWOWFUVLYRZYRWMZVWQVWFVWSUWJVWH
      XJXEZVWHUEXJXEZVWFVWHUYHTZVWSVXBVXCXKVWEVXDVWBVWTWMUWJUEVWHVVFXMYDXCZXQVW
      FUDVWIXJXEZVWHVUDXJXEVWFVWIXITZVXFVWIUEXJXEZVWFVWIUWETVXGVXFVXHXKVWFUWDUW
      EVWIAUWFVWDVWBUXPUVMVWFVWGVWJVWPXHUVNUDUEVWIXLXMYDXCZXQVWFVUDVWHVWQVXAUVO
      XSYAVWFVUDVWHUEYSUGZUNVWQVWFVWSVXJXITVXAVWHUVQWFUNXITVWFYTVQVWFVXHVUDVXJX
      JXEVWFVXGVXFVXHVXIXTVWFVUDVWHUEVWQVXAVVBVWFXMVQZUVPXSVWFVXJUEUEYSUGUNXJVW
      FVWHUEUEVXAVXKVXKVWFVWSVXBVXCVXEXTUVRUVSUVTYAUWJUNVUDVVFYTYDYCYOUWAUWBYQU
      WC $.

    $( Lemma for ~ vitali .  (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    vitalilem3 $p |- ( ph -> Disj_ m e. NN ( T ` m ) ) $=
      ( wcel vw vk vv cv cn cfv wa wmo wal wdisj weq wi wceq cr cmin co simprlr
      crn crab simprll fveq2 oveq2d eleq1d rabbidv reex rabex fvmpt syl eleqtrd
      oveq1 elrab sylib simpld recnd cq cc wf cneg cicc cin wss wf1o f1of inss1
      c1 fss sylancl adantr ffvelrnd qcn simprrl cec cc0 wer vitalilem1 a1i wbr
      ciun vitalilem2 simp1d simprd sseldd simprrr jca nnncan1d syl2anc eqeltrd
      c2 qsubcl oveq12 brab2ga sylanbrc erthi fveq2d wral eceq1 eqeq12d wne cqs
      c0 cvv ovex erex mp2 ecelqsi syl6eleqr adantl simpr cdm erdm ax-mp eleq2i
      ecdmn0 bitr3i neeq1 id rspcv wb sylc sylibr eleq12d imbi12d fvex vex elec
      syl3c eqcomd ectocld ralrimiva wfn ralrn mpbird 3eqtr3d subcand wf1 f1of1
      f1fveq syl12anc mpbid alrimivv eleq1 eleq2d anbi12d mo4 alrimiv dfdisj2
      ex ) AHUDZUETZUAUDZUVHGUFZTZUGZHUHZUAUIHUEUVKUJAUVNUAAUVMUBUDZUETZUVJUVOG
      UFZTZUGZUGZHUBUKZULZUBUIHUIUVNAUWBHUBAUVTUWAAUVTUGZUVHKUFZUVOKUFZUMZUWAUW
      CUVJUWDUWEUWCUVJUWCUVJUNTZUVJUWDUOUPZJURZTZUWCUVJLUDZUWDUOUPZUWITZLUNUSZT
      UWGUWJUGUWCUVJUVKUWNAUVIUVLUVSUQUWCUVIUVKUWNUMAUVIUVLUVSUTZIUVHUWKIUDZKUF
      ZUOUPZUWITZLUNUSZUWNUEGIHUKZUWSUWMLUNUXAUWRUWLUWIUXAUWQUWDUWKUOUWPUVHKVAV
      BVCVDRUWMLUNVEVFVGVHVIUWMUWJLUVJUNLUAUKZUWLUWHUWIUWKUVJUWDUOVJVCVKVLZVMVN
      ZUWCUWDVOTZUWDVPTUWCUEVOUVHKAUEVOKVQZUVTAUEVOWEVRZWEVSUPZVTZKVQZUXIVOWAUX
      FAUEUXIKWBZUXJQUEUXIKWCVHVOUXHWDUEUXIVOKWFWGWHZUWOWIZUWDWJVHZUWCUWEVOTZUW
      EVPTUWCUEVOUVOKUXLAUVMUVPUVRWKZWIZUWEWJVHZUWCUWHEWLZJUFZUVJUWEUOUPZEWLZJU
      FZUWHUYAUWCUXSUYBJUWCUWHUYAEWMWEVSUPZUYDEWNZUWCBCEMWOZWPUWCUWHUYDTZUYAUYD
      TZUGUWHUYAUOUPZVOTZUWHUYAEWQUWCUYGUYHUWCUWIUYDUWHAUWIUYDWAZUVTAUYKUYDHUEU
      VKWRZWAUYLUXGXHVSUPWAABCDEFGHIJKLMNOPQRSWSWTWHZUWCUWGUWJUXCXAZXBUWCUWIUYD
      UYAUYMUWCUWGUYAUWITZUWCUVJUWKUWEUOUPZUWITZLUNUSZTUWGUYOUGUWCUVJUVQUYRAUVM
      UVPUVRXCUWCUVPUVQUYRUMUXPIUVOUWTUYRUEGIUBUKZUWSUYQLUNUYSUWRUYPUWIUYSUWQUW
      EUWKUOUWPUVOKVAVBVCVDRUYQLUNVEVFVGVHVIUYQUYOLUVJUNUXBUYPUYAUWIUWKUVJUWEUO
      VJVCVKVLXAZXBXDUWCUYIUWEUWDUOUPZVOUWCUVJUWDUWEUXDUXNUXRXEUWCUXOUXEVUAVOTU
      XQUXMUWEUWDXIXFXGBUDZCUDZUOUPZVOTUYJBCUWHUYAUYDUYDEVUBUWHUMVUCUYAUMUGVUDU
      YIVOVUBUWHVUCUYAUOXJVCMXKXLXMXNUWCUWJDUDZEWLZJUFZVUEUMZDUWIXOZUXTUWHUMZUY
      NAVUIUVTAVUIUVJJUFZEWLZJUFZVUKUMZUAFXOZAVUNUAFUCUDZEWLZJUFZEWLZJUFZVURUMV
      UNAUCUVJUYDEFNVUQUVJUMZVUTVUMVURVUKVVAVUSVULJVVAVURVUKUMVUSVULUMVUQUVJJVA
      ZVURVUKEXPVHXNVVBXQAVUPUYDTZUGZVUSVUQJVVDVUQVUSVVDVUPVUREUYDUYEVVDUYFWPVV
      DVURVUQTZVUPVUREWQVVDVUQFTZVUEXTXRZVUEJUFZVUETZULZDFXOZVUQXTXRZVVEVVCVVFA
      VVCVUQUYDEXSFUYDVUPEUYEUYDYATEYATUYFWMWEVSYBUYDEYAYCYDYENYFYGAVVKVVCPWHVV
      DVVCVVLAVVCYHVVCVUPEYIZTVVLVVMUYDVUPUYEVVMUYDUMUYFUYDEYJYKYLVUPEYMYNVLVVJ
      VVLVVEULDVUQFVUEVUQUMZVVGVVLVVIVVEVUEVUQXTYOVVNVVHVURVUEVUQVUEVUQJVAVVNYP
      UUAUUBYQUUFVURVUPEVUQJUUCUCUUDUUEVLXMUUGXNUUHUUIAJFUUJVUIVUOYROVUHVUNDUAF
      JVUEVUKUMZVUGVUMVUEVUKVVOVUFVULJVUEVUKEXPXNVVOYPXQUUKVHUULWHZVUHVUJDUWHUW
      IVUEUWHUMZVUGUXTVUEUWHVVQVUFUXSJVUEUWHEXPXNVVQYPXQYQYSUWCUYOVUIUYCUYAUMZU
      YTVVPVUHVVRDUYAUWIVUEUYAUMZVUGUYCVUEUYAVVSVUFUYBJVUEUYAEXPXNVVSYPXQYQYSUU
      MUUNUWCUEUXIKUUOZUVIUVPUWFUWAYRUWCUXKVVTAUXKUVTQWHUEUXIKUUPVHUWOUXPUEUXIU
      VHUVOKUUQUURUUSUVGUUTUVMUVSHUBUWAUVIUVPUVLUVRUVHUVOUEUVAUWAUVKUVQUVJUVHUV
      OGVAUVBUVCUVDYTUVEHUAUEUVKUVFYT $.

    $( Lemma for ~ vitali .  (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    vitalilem4 $p |- ( ( ph /\ m e. NN ) -> ( vol* ` ( T ` m ) ) = 0 ) $=
      ( cr vk cv cn wcel wa cfv covol crn cmin co crab wceq fveq2 oveq2d eleq1d
      cc0 rabbidv reex rabex fvmpt adantl fveq2d wss c1 cicc ciun c2 vitalilem2
      cneg simp1d unitssre syl6ss adantr 1re renegcli iccssre mp2an cq cin wf1o
      inss2 wf f1of syl ffvelrnda sseldi eqidd ovolshft eqtr4d clt wbr cdiv cfl
      wn c3 caddc cmul cxr 3re rexri a1i cn0 cle crp 3nn nnrp ax-mp 0re ovolicc
      mp3an ax-1cn subid1i eqtri eqeltri ovolsscl mp3an23 simpr rpdivcl sylancr
      0le1 elrpd rpred rpge0d syl2anc cvol wral sylibr sylancl ralrimiva ovolcl
      fmptd mpbid cmpt cseq mblvol eqtrd adantlr eqid 2re wb flge0nn0 nnred cdm
      nn0p1nn remulcld rexrd cpw cdif elpw2 anim1i eldif mt3d inss1 qssre sstri
      ex fss shftmbl iunmbl mblss 3syl flltp1 ltdivmul2d csup nnuz cz 1z serfre
      eqeltrd frn ressxr csn mpteq2dva fconstmpt syl6eqr fveq1d recnd ser1const
      cxp seqeq3d wfn ffn fnfvelrn eqeltrrd supxrub wdisj jca vitalilem3 voliun
      cc eqtr3d breqtrrd xrltletrd simp3d ovolss subnegi 0lt1 lt0neg2 mpbi 2pos
      2cn lttri ltleii 3eqtr4i syl6breq xrlenlt pm2.65da wo ovolge0 0xr xrleloe
      df-3 ord mpd ) AHUBZUCUDZUEZUXOGUFZUGUFZJUHZUGUFZUPUXQUXSLUBZUXOKUFZUIUJZ
      UXTUDZLTUKZUGUFUYAUXQUXRUYFUGUXPUXRUYFULAIUXOUYBIUBZKUFZUIUJZUXTUDZLTUKZU
      YFUCGUYGUXOULZUYJUYELTUYLUYIUYDUXTUYLUYHUYCUYBUIUYGUXOKUMUNUOUQRUYELTURUS
      UTVAVBUXQLUXTUYFUYCAUXTTVCZUXPAUXTUPVDVEUJZTAUXTUYNVCZUYNHUCUXRVFZVCZUYPV
      DVIZVGVEUJZVCZABCDEFGHIJKLMNOPQRSVHZVJZVKVLZVMUXQUYRVDVEUJZTUYCUYRTUDZVDT
      UDZVUDTVCVDVNVOZVNUYRVDVPVQUXQVRVUDVSZVUDUYCVRVUDWAAUCVUHUXOKAUCVUHKVTUCV
      UHKWBZQUCVUHKWCWDZWEWFWFUXQUYFWGWHWIZAUPUYAULZUXPAUPUYAWJWKZWNVULAVUMWOUY
      PUGUFZWJWKZAVUMUEZWOWOUYAWLUJZWMUFZVDWPUJZUYAWQUJZVUNWOWRUDZVUPWOWSWTZXAV
      UPVUTVUPVUSUYAVUPVUSVUPVURXBUDZVUSUCUDZVUPVUQTUDZUPVUQXCWKVVCVUPVUQVUPWOX
      DUDZUYAXDUDVUQXDUDWOUCUDVVFXEWOXFXGVUPUYAAUYATUDZVUMAUYOVVGVUBUYOUYNTVCUY
      NUGUFZTUDVVGVKVVHVDTVVHVDUPUIUJZVDUPTUDVUFUPVDXCWKVVHVVIULXHVNXTUPVDXIXJV
      DXKXLXMVNXNUXTUYNXOXPWDZVMZAVUMXQYAZWOUYAXRXSZYBZVUPVUQVVMYCVUQUUAYDVURUU
      DWDZUUBZVVKUUEUUFAVUNWRUDZVUMAUYPYEUUCZUDZUYPTVCVVQAUXRVVRUDZHUCYFVVSAVVT
      HUCAUCVVRUXOGAIUCUYKVVRGAUYGUCUDZUEUXTVVRUDZUYHTUDUYKVVRUDAVWBVWAAVWBUXTT
      UUGZVVRUUHUDZSAVWBWNZVWDAVWEUEUXTVWCUDZVWEUEVWDAVWFVWEAUYMVWFVUCUXTTURUUI
      YGUUJUXTVWCVVRUUKYGUUPUULVMAUCTUYGKAVUIVUHTVCUCTKWBVUJVUHVRTVRVUDUUMUUNUU
      OUCVUHTKUUQYHWELUXTUYHUURYDRYKWEZYIUXRHUUSWDZUYPUUTUYPYJUVAVMZVUPVUQVUSWJ
      WKZWOVUTWJWKVUPVVEVWJVVNVUQUVBWDVUPWOVUSUYAWOTUDVUPWSXAVVPVVLUVCYLVUPVUTW
      PHUCUXRYEUFZYMZVDYNZUHZWRWJUVDZVUNXCVUPVWNWRVCVUTVWNUDVUTVWOXCWKVUPVWNTWR
      VUPUCTVWMWBZVWNTVCVUPUAVWLVDUCUVEVDUVFUDVUPUVGXAVUPUCTUAUBVWLVUPHUCVWKTVW
      LAUXPVWKTUDZVUMUXQVWKUYATUXQVWKUXSUYAUXQVVTVWKUXSULVWGUXRYOWDVUKYPZAVVGUX
      PVVJVMUVIZYQVWLYRZYKWEUVHZUCTVWMUVJWDUVKVLVUPVUSVWMUFZVUTVWNVUPVXBVUSWPUC
      UYAUVLUVSZVDYNZUFZVUTVUPVUSVWMVXDVUPVWLVXCWPVDVUPVWLHUCUYAYMVXCVUPHUCVWKU
      YAAUXPVWKUYAULVUMVWRYQUVMHUCUYAUVNUVOUVTUVPVUPUYAUWJUDVVDVXEVUTULVUPUYAVV
      KUVQVVOUYAVUSUVRYDYPVUPVWMUCUWAZVVDVXBVWNUDVUPVWPVXFVXAUCTVWMUWBWDVVOUCVU
      SVWMUWCYDUWDVWNVUTUWEYDVUPUYPYEUFZVUNVWOVUPVVSVXGVUNULAVVSVUMVWHVMUYPYOWD
      VUPVVTVWQUEZHUCYFZHUCUXRUWFZVXGVWOULAVXIVUMAVXHHUCUXQVVTVWQVWGVWSUWGYIVMA
      VXJVUMABCDEFGHIJKLMNOPQRSUWHVMUXRVWMHVWLVWMYRVWTUWIYDUWKUWLUWMVUPVUNWOXCW
      KZVUOWNZVUPVUNUYSUGUFZWOXCVUPUYTUYSTVCZVUNVXMXCWKAUYTVUMAUYOUYQUYTVUAUWNV
      MVUEVGTUDZVXNVUGYSUYRVGVPVQUYPUYSUWOYHVGUYRUIUJZVGVDWPUJVXMWOVGVDUXAXKUWP
      VUEVXOUYRVGXCWKVXMVXPULVUGYSUYRVGVUGYSUYRUPWJWKZUPVGWJWKUYRVGWJWKUPVDWJWK
      ZVXQUWQVUFVXRVXQYTVNVDUWRXGUWSUWTUYRUPVGVUGXHYSUXBVQUXCUYRVGXIXJUXLUXDUXE
      VUPVVQVVAVXKVXLYTVWIVVBVUNWOUXFYHYLUXGAVUMVULAUPUYAXCWKZVUMVULUXHZAUYMVXS
      VUCUXTUXIWDAUPWRUDUYAWRUDZVXSVXTYTUXJAUYMVYAVUCUXTYJWDUPUYAUXKXSYLUXMUXNV
      MWI $.

    $( Lemma for ~ vitali .  (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    vitalilem5 $p |- -. ph $=
      ( cc0 cn vm c1 cicc co covol cfv cle wbr clt wn 0lt1 cmin cr wcel 0re 1re
      wceq 0le1 ovolicc mp3an ax-1cn subid1i eqtri breqtrri eqeltri ltnlei mpbi
      cv ciun wss crn cneg c2 vitalilem2 simp2d cvol cdm wral crab cpw cdif wfn
      wa wf c0 wne wi cqs wer vitalilem1 erdm ax-mp syl6eleq elqsn0 sylancr a1i
      simpr qsss syl5eqss sselda elpwid sseld embantd ralimdva mpd sylanbrc frn
      ffnfv syl unitssre syl6ss reex elpw2 sylibr anim1i eldif ex adantr cq cin
      mt3d wf1o f1of inss1 qssre sylancl ffvelrnda syl2anc mblss csu caddc cmpt
      cseq eqid cli cxp nnuz syl6eq breqtrd cxr sstri fss shftmbl iunmbl ovolss
      fmptd ralrimiva vitalilem4 syl6eqel cuz mpteq2dva fconstmpt xpeq1i eqtr3i
      csn seqeq3d cz 1z serclim0 syl6eqbr seqex breldm ovoliun2 sumeq2dv cfn wo
      c0ex eqimssi orci sumz ovolge0 wb ovolcl 0xr xrletri3 mpbir2and mto ) ASU
      BUCUDZUEUFZSUGUHZSUVSUIUHUVTUJSUBUVSUIUKUVSUBSULUDZUBSUMUNUBUMUNSUBUGUHUV
      SUWAUQUOUPURSUBUSUTUBVAVBVCZVDSUVSUOUVSUBUMUWBUPVEVFVGAUVSUATUAVHZGUFZVIZ
      UEUFZSUGAUVRUWEVJZUWEUMVJZUVSUWFUGUHAIVKZUVRVJZUWGUWEUBVLZVMUCUDVJABCDEFG
      UAHIJKLMNOPQRVNVOAUWEVPVQZUNZUWHAUWDUWLUNZUATVRUWMAUWNUATATUWLUWCGAHTKVHH
      VHZJUFZULUDUWIUNKUMVSZUWLGAUWOTUNZWCUWIUWLUNZUWPUMUNUWQUWLUNAUWSUWRAUWSUW
      IUMVTZUWLWAUNZRAUWSUJZUXAAUXBWCUWIUWTUNZUXBWCUXAAUXCUXBAUWIUMVJUXCAUWIUVR
      UMAFUVRIWDZUWJAIFWBDVHZIUFZUVRUNZDFVRZUXDNAUXEWEWFZUXFUXEUNZWGZDFVRUXHOAU
      XKUXGDFAUXEFUNZWCZUXIUXJUXGUXMEVQUVRUQZUXEUVREWHZUNUXIUVREWIZUXNBCELWJZUV
      REWKWLUXMUXEFUXOAUXLWQMWMUVRUXEEWNWOUXMUXEUVRUXFUXMUXEUVRAFUVRVTZUXEAFUXO
      UXRMAUVREUXPAUXQWPWRWSWTXAXBXCXDXEDFUVRIXHXFFUVRIXGXIXJXKUWIUMXLXMXNXOUWI
      UWTUWLXPXNXQYAXRATUMUWOJATXSUWKUBUCUDZXTZJWDZUXTUMVJTUMJWDATUXTJYBUYAPTUX
      TJYCXIUXTXSUMXSUXSYDYEUUATUXTUMJUUBYFYGKUWIUWPUUCYHQUUFYGZUUGUWDUAUUDXIUW
      EYIXIZUVRUWEUUEYHAUWFSUQZUWFSUGUHZSUWFUGUHZAUWFTUWDUEUFZUAYJZSUGAUWDYKUAT
      UYGYLZUBYMZUAUYIUYJYNUYIYNAUWCTUNWCZUWNUWDUMVJUYBUWDYIXIUYKUYGSUMABCDEFGU
      AHIJKLMNOPQRUUHZUOUUIAUYJSYOUHUYJYOVQUNAUYJYKUBUUJUFZSUUOZYPZUBYMZSYOAUYI
      UYOYKUBAUYIUATSYLZUYOAUATUYGSUYLUUKTUYNYPUYQUYOUATSUULTUYMUYNYQUUMUUNYRUU
      PUBUUQUNUYPSYOUHUURUBUUSWLUUTUYJSYOYKUYIUBUVAUVGUVBXIUVCAUYHTSUAYJZSATUYG
      SUAUYLUVDTUYMVJZTUVEUNZUVFUYRSUQUYSUYTTUYMYQUVHUVITUAUBUVJWLYRYSAUWHUYFUY
      CUWEUVKXIAUWFYTUNZSYTUNUYDUYEUYFWCUVLAUWHVUAUYCUWEUVMXIUVNUWFSUVOYFUVPYSU
      VQ $.
  $}

  ${
    $d a b c f g m n s t w x y z .< $.
    $( If the reals can be well-ordered, then there are non-measurable sets.
       The proof uses "Vitali sets", named for Giuseppe Vitali (1905).
       (Contributed by Mario Carneiro, 16-Jun-2014.) $)
    vitali $p |- ( .< We RR -> dom vol C. ~P RR ) $=
      ( vx vy vw vs cr cv cfv wcel cvv wa cn cq c1 co wbr cdiv cc0 wss cmin wwe
      vz vf vg vc va vb vm vt vn c0 wne wi cpw wral cvol cdm wpss cuni wex reex
      pwex cxp cin weinxp wceq unipw weeq2 ax-mp bitr4i inex2 weeq1 spcev sylbi
      wb xpex dfac8c mpsyl cneg cicc wf1o cen cdom qex inex1 nnrecq cle nnrecre
      1re renegcli a1i 0re clt 0lt1 lt0neg2 mpbi ltleii nnrp rpge0d letrd nnge1
      rpreccld nnre nngt0 lerec mpanl12 syl2anc mpbid ax-1cn syl6breq syl3anbrc
      div1i elicc2i elin sylanbrc weq oveq2 nncn nnne0 recrecd eqeqan12d syl5ib
      impbid1 dom2 inss1 ssdomg mp2 qnnen domentr mp2an cmpt wn crab eleq1 eqid
      eleq1d fvex fveq2 wtru sylibr sbth bren copab cqs crn cdif oveq12 anbi12d
      bi2anan9 cbvopabv wfn fnmpti neeq1 eleq12d imbi12d cbvralv wer vitalilem1
      qsss trud unitssre sspwb sstri ssralv fvmpt imbi2d ralbiia ad2antlr oveq1
      id simprl cbvrabv oveq2d rabbidv syl5eq cbvmptv simprr vitalilem5 pm2.21i
      expr pm2.18d eldif mblss vex elpw ssriv ssnelpss syl exlimdv mpi exlimddv
      ex ) FAUAZUBGZUKULZUWNUCGZHZUWNIZUMZUBFUNZUOZUPUQZUWTURZUCUWTJIUWMUWTUSZB
      GZUAZBUTZUXAUCUTFVAVBUWMUXDAFFVCZVDZUAZUXGUWMFUXIUAZUXJFAVEUXDFVFUXJUXKVO
      FVGUXDFUXIVHVIVJUXFUXJBUXIUXHAFFVAVAVPVKUXDUXEUXIVLVMVNUBUWTJUCBVQVRUWMUX
      AKZLMNVSZNVTOZVDZUDGZWAZUDUTZUXCLUXOWBPZUXRLUXOWCPZUXOLWCPZUXSUXOJIUXTMUX
      NWDWEBCLUXONUXEQOZNCGZQOZJUXELIZUYBMIUYBUXNIZUYBUXOIUXEWFUYEUYBFIUXMUYBWG
      PUYBNWGPUYFUXEWHZUYEUXMRUYBUXMFIUYENWIWJZWKRFIUYEWLWKUYGUXMRWGPUYEUXMRUYH
      WLRNWMPZUXMRWMPZWNNFIZUYIUYJVOWINWOVIWPWQWKUYEUYBUYEUXEUXEWRXBWSWTUYEUYBN
      NQOZNWGUYENUXEWGPZUYBUYLWGPZUXEXAUYEUXEFIZRUXEWMPZUYMUYNVOZUXEXCUXEXDUYKU
      YIUYOUYPKUYQWIWNNUXEXEXFXGXHNXIXLXJUXMNUYBUYHWIXMXKUYBMUXNXNXOUYEUYCLIZKZ
      UYBUYDVFZBCXPZUYTNUYBQOZNUYDQOZVFUYSVUAUYBUYDNQXQUYEUYRVUBUXEVUCUYCUYEUXE
      UXEXRUXEXSXTUYRUYCUYCXRUYCXSXTYAYBUXEUYCNQXQYCYDVIUXOMWCPZMLWBPUYAMJIUXOM
      SVUDWDMUXNYEUXOMJYFYGYHUXOMLYIYJLUXOUUAYJLUXOUDUUBWPUXLUXQUXCUDUXLUXQUXCU
      XLUXQKZUERNVTOZUFGZVUFIZUGGZVUFIZKZVUGVUITOZMIZKZUFUGUUCZUUDZUEGZUWPHZYKZ
      UUEZUWTUXBUUFIZUXCVUEVVAUXLUXQVVAYLZVVAUXLUXQVVBKZKZVVAVVDBCDVUOVUPUHLUIG
      ZUHGZUXPHZTOZVUTIZUIFYMZYKUJVUSUXPEVUNUXEVUFIZUYCVUFIZKZUXEUYCTOZMIZKUFUG
      BCUFBXPZUGCXPZKZVUKVVMVUMVVOVVPVUHVVKVVQVUJVVLVUGUXEVUFYNVUIUYCVUFYNUUIVV
      RVULVVNMVUGUXEVUIUYCTUUGYPUUHUUJZVUPYOVUSVUPUUKVVDUEVUPVURVUSVUQUWPYQVUSY
      OZUULWKUXADGZUKULZVWAVUSHZVWAIZUMZDVUPUOZUWMVVCUXAVWBVWAUWPHZVWAIZUMZDVUP
      UOZVWFUXAVWIDUWTUOZVWJUWSVWIUBDUWTUBDXPZUWOVWBUWRVWHUWNVWAUKUUMVWLUWQVWGU
      WNVWAUWNVWAUWPYRVWLUVJUUNUUOUUPVUPUWTSVWKVWJUMVUPVUFUNZUWTVUPVWMSYSVUFVUO
      VUFVUOUUQYSBCVUOVVSUURWKUUSUUTVUFFSVWMUWTSUVAVUFFUVBWPUVCVWIDVUPUWTUVDVIV
      NVWEVWIDVUPVWAVUPIZVWDVWHVWBVWNVWCVWGVWAUEVWAVURVWGVUPVUSVUQVWAUWPYRVVTVW
      AUWPYQUVEYPUVFUVGYTUVHUXLUXQVVBUVKUHUJLVVJEGZUJGZUXPHZTOZVUTIZEFYMZUHUJXP
      ZVVJVWOVVGTOZVUTIZEFYMVWTVVIVXCUIEFUIEXPVVHVXBVUTVVEVWOVVGTUVIYPUVLVXAVXC
      VWSEFVXAVXBVWRVUTVXAVVGVWQVWOTVVFVWPUXPYRUVMYPUVNUVOUVPUXLUXQVVBUVQUVRUVS
      UVTUWAVVAVUTUWTIVUTUXBIYLKZUXCVUTUWTUXBUWBUXBUWTSVXDUXCUMBUXBUWTUXEUXBIUX
      EFSUXEUWTIUXEUWCUXEFBUWDUWEYTUWFUXBUWTVUTUWGVIVNUWHUWLUWIUWJUWK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Lebesgue integration
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                    Lesbesgue integral
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Introduce new constant symbols. $)
  $c MblFn $. $( Measurable function $)
  $c L^1 $. $( Integrable function $)
  $c S.1 $. $( Lebesgue integral, simple functions $)
  $c S.2 $. $( Lebesgue integral, nonnegative functions $)
  $c S. $. $( Lebesgue integral $)
  $c S_ $. $( Directed integral $)
  $c _d $. $( differential 'd' for integral $)

  $( Extend class notation with the class of measurable functions. $)
  cmbf $a class MblFn $.

  $( Extend class notation with the Lebesgue integral for simple functions. $)
  citg1 $a class S.1 $.

  $( Extend class notation with the Lebesgue integral for nonnegative
     functions. $)
  citg2 $a class S.2 $.

  $( Extend class notation with the class of integrable functions. $)
  cibl $a class L^1 $.

  $( Extend class notation with the general Lebesgue integral. $)
  citg $a class S. A B _d x $.

  ${
    $d k y A $.  $d k y B $.  $d a f g k x y z $.
    $( Define the class of measurable functions on the reals.  A real function
       is measurable if the preimage of every open interval is a measurable set
       (see ~ ismbl ) and a complex function is measurable if the real and
       imaginary parts of the function is measurable.  (Contributed by Mario
       Carneiro, 17-Jun-2014.) $)
    df-mbf $a |- MblFn = { f e. ( CC ^pm RR ) | A. x e. ran (,)
                           ( ( `' ( Re o. f ) " x ) e. dom vol /\
                             ( `' ( Im o. f ) " x ) e. dom vol ) } $.

    $( Define the Lebesgue integral for simple functions.  A simple function is
       a finite linear combination of indicator functions for finitely
       measurable sets, whose assigned value is the sum of the measures of the
       sets times their respective weights.  (Contributed by Mario Carneiro,
       18-Jun-2014.) $)
    df-itg1 $a |- S.1 = ( f e. { g e. MblFn | ( g : RR --> RR /\
        ran g e. Fin /\ ( vol ` ( `' g " ( RR \ { 0 } ) ) ) e. RR ) } |->
        sum_ x e. ( ran f \ { 0 } ) ( x x. ( vol ` ( `' f " { x } ) ) ) ) $.

    $( Define the Lebesgue integral for nonnegative functions.  A nonnegative
       function's integral is the supremum of the integrals of all simple
       functions that are less than the input function.  Note that this may be
       ` +oo ` for functions that take the value ` +oo ` on a set of positive
       measure or functions that are bounded below by a positive number on a
       set of infinite measure.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    df-itg2 $a |- S.2 = ( f e. ( ( 0 [,] +oo ) ^m RR ) |-> sup ( { x |
        E. g e. dom S.1 ( g oR <_ f /\ x = ( S.1 ` g ) ) } , RR* , < ) ) $.

    $( Define the class of integrable functions on the reals.  A function is
       integrable if it is measurable and the integrals of the pieces of the
       function are all finite.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    df-ibl $a |- L^1 = { f e. MblFn | A. k e. ( 0 ... 3 )
         ( S.2 ` ( x e. RR |-> [_ ( Re ` ( ( f ` x ) / ( _i ^ k ) ) ) / y ]_
                 if ( ( x e. dom f /\ 0 <_ y ) , y , 0 ) ) ) e. RR } $.

    $( Define the full Lebesgue integral, for complex-valued functions to
       ` RR ` .  The syntax is designed to be suggestive of the standard
       notation for integrals.  For example, our notation for the integral of
       ` x ^ 2 ` from ` 0 ` to ` 1 ` is
       ` S. ( 0 [,] 1 ) ( x ^ 2 ) _d x = ( 1 / 3 ) ` .  The only real function
       of this definition is to break the integral up into nonnegative real
       parts and send it off to ~ df-itg2 for further processing.  Note that
       this definition cannot handle integrals which evaluate to infinity,
       because addition and multiplication are not currently defined on
       extended reals.  (You can use ~ df-itg2 directly for this use-case.)
       (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    df-itg $a |- S. A B _d x = sum_ k e. ( 0 ... 3 ) ( ( _i ^ k ) x.
                ( S.2 ` ( x e. RR |-> [_ ( Re ` ( B / ( _i ^ k ) ) ) / y ]_
                  if ( ( x e. A /\ 0 <_ y ) , y , 0 ) ) ) ) $.
  $}

  ${
    $d f x y F $.  $d x y z A $.  $d x y B $.  $d x C $.
    $( The predicate " ` F ` is a measurable function".  This is more naturally
       stated for functions on the reals, see ~ ismbf and ~ ismbfcn for the
       decomposition of the real and imaginary parts.  (Contributed by Mario
       Carneiro, 17-Jun-2014.) $)
    ismbf1 $p |- ( F e. MblFn <-> ( F e. ( CC ^pm RR ) /\ A. x e. ran (,)
                   ( ( `' ( Re o. F ) " x ) e. dom vol /\
                     ( `' ( Im o. F ) " x ) e. dom vol ) ) ) $=
      ( vf cre cv ccom ccnv cima cvol cdm wcel cim cioo crn wral cnveqd imaeq1d
      wa coeq2 eleq1d cc cr cpm co cmbf wceq anbi12d ralbidv df-mbf elrab2 ) DC
      EZFZGZAEZHZIJZKZLUKFZGZUNHZUPKZRZAMNZODBFZGZUNHZUPKZLBFZGZUNHZUPKZRZAVCOC
      BUAUBUCUDUEUKBUFZVBVLAVCVMUQVGVAVKVMUOVFUPVMUMVEUNVMULVDUKBDSPQTVMUTVJUPV
      MUSVIUNVMURVHUKBLSPQTUGUHACUIUJ $.

    $( A measurable function is a function into the complexes.  (Contributed by
       Mario Carneiro, 17-Jun-2014.) $)
    mbff $p |- ( F e. MblFn -> F : dom F --> CC ) $=
      ( vx cmbf wcel cc cr cpm co cdm wf cre ccom ccnv cv cima cvol cim wa cioo
      simplbi crn wral ismbf1 wss cnex reex elpm2 syl ) ACDZAEFGHDZAIZEAJZUIUJK
      ALMBNZOPIZDQALMUMOUNDRBSUAUBBAUCTUJULUKFUDEFAUEUFUGTUH $.

    $( The domain of a measurable function is measurable.  (Contributed by
       Mario Carneiro, 17-Jun-2014.) $)
    mbfdm $p |- ( F e. MblFn -> dom F e. dom vol ) $=
      ( vx cmbf wcel cre ccom ccnv cr cima cdm wf wceq cc syl cioo wral cmnf co
      cpnf cxr cvol ref mbff fco sylancr fimacnv crn cv ioomax cxp wfn cpw ioof
      ffn ax-mp mnfxr pnfxr fnovrn mp3an eqeltrri cim cpm ismbf1 simprbi ralimi
      wa simpl imaeq2 eleq1d rspcv mpsyl eqeltrrd ) ACDZEAFZGZHIZAJZUAJZVMVQHVN
      KZVPVQLVMMHEKVQMAKVSUBAUCVQMHEAUDUEVQHVNUFNHOUGZDVMVOBUHZIZVRDZBVTPZVPVRD
      ZQSORZHVTUIOTTUJZUKZQTDSTDWFVTDWGHULZOKWHUMWGWIOUNUOUPUQTTQSOURUSUTVMWCVA
      AFGWAIVRDZVFZBVTPZWDVMAMHVBRDWLBAVCVDWKWCBVTWCWJVGVENWCWEBHVTWAHLWBVPVRWA
      HVOVHVIVJVKVL $.

    $( Lemma for ~ mbfconst .  (Contributed by Mario Carneiro, 17-Jun-2014.) $)
    mbfconstlem $p |- ( ( A e. dom vol /\ C e. RR ) ->
                        ( `' ( A X. { C } ) " B ) e. dom vol ) $=
      ( cvol cdm wcel cr wa csn cxp ccnv cima wss cnvimass a1i wf wceq ad2antlr
      c0 cin crn cnvimarndm fconst6g adantl imass2 3syl syl5eqssr eqssd fconstg
      frn fdm syl eqtrd simpll eqeltrd wn incom simpr disjsn sylibr fimacnvdisj
      syl5eq syl2anc 0mbl syl6eqel pm2.61dan ) ADEZFZCGFZHZCBFZACIZJZKZBLZVGFVJ
      VKHZVOAVGVPVOVMEZAVPVOVQVOVQMVPVMBNOVPVQVNVMUAZLZVOVMUBVPABVMPZVRBMVSVOMV
      KVTVJACBUCUDABVMUJVRBVNUEUFUGUHVPAVLVMPZVQAQVIWAVHVKACGUIZRAVLVMUKULUMVHV
      IVKUNUOVJVKUPZHZVOSVGWDWAVLBTZSQVOSQVIWAVHWCWBRWDWEBVLTZSVLBUQWDWCWFSQVJW
      CURBCUSUTVBAVLBVMVAVCVDVEVF $.

    $( The predicate " ` F ` is a measurable function".  A function is
       measurable iff the preimages of all open intervals are measurable sets
       in the sense of ~ ismbl .  (Contributed by Mario Carneiro,
       17-Jun-2014.) $)
    ismbf $p |- ( F : A --> RR -> ( F e. MblFn <->
                  A. x e. ran (,) ( `' F " x ) e. dom vol ) ) $=
      ( vy cr wf cdm wcel ccnv cima eleq1d wa cre cim cfv cmpt feqmptd cc0 cvv
      cc cvol cmbf cv cioo crn wral mbfdm fdm syl5ib wi cmnf co ioomax ioorebas
      cpnf eqeltrri wceq imaeq2 rspcv ax-mp fimacnv wb cpm ccom ffvelrn adantlr
      rered mpteq2dva recnd simpl ref a1i fveq2 fmptco 3eqtr4rd imaeq1d csn cxp
      cnveqd imf reim0d eqtrd fconstmpt syl6eqr 0re mbfconstlem sylancl eqeltrd
      simpr biantrud bitrd ralbidv wss ax-resscn fss mpan2 mblss elpm2r mpanl12
      cnex reex syl2an biantrurd ismbf1 syl6rbbr ex pm5.21ndd ) BECFZBUAGZHZCUB
      HZCIZAUCZJZXIHZAUDUEZUFZXKCGZXIHXHXJCUGXHXRBXIBECUHKUIXQXLEJZXIHZXHXJEXPH
      XQXTUJUKUOUDULEXPUMUKUOUNUPXOXTAEXPXMEUQXNXSXIXMEXLURKUSUTXHXSBXIBECVAKUI
      XHXJXKXQVBXHXJLZXQCTEVCULHZMCVDZIZXMJZXIHZNCVDZIZXMJZXIHZLZAXPUFZLZXKYAXQ
      YLYMYAXOYKAXPYAXOYFYKYAXNYEXIYAXLYDXMYACYCYAABXMCOZMOZPABYNPYCCYAABYOYNYA
      XMBHZLZYNXHYPYNEHXJBEXMCVEVFZVGVHYAADBTYNDUCZMOYOCMYQYNYRVIZYAABECXHXJVJQ
      ZYADTEMTEMFYAVKVLQYSYNMVMVNUUAVOVSVPKYAYJYFYAYIBRVQVRZIZXMJZXIYAYHUUCXMYA
      YGUUBYAYGABRPZUUBYAYGABYNNOZPUUEYAADBTYNYSNOUUFCNYTUUAYADTENTENFYAVTVLQYS
      YNNVMVNYAABUUFRYQYNYRWAVHWBABRWCWDVSVPYAXJREHUUDXIHXHXJWIWEBXMRWFWGWHWJWK
      WLYAYBYLXHBTCFZBEWMZYBXJXHETWMUUGWNBETCWOWPBWQTSHESHUUGUUHLYBWTXATEBCSSWR
      WSXBXCWKACXDXEXFXG $.

    $( A complex function is measurable iff the real and imaginary components
       of the function are measurable.  (Contributed by Mario Carneiro,
       17-Jun-2014.) $)
    ismbfcn $p |- ( F : A --> CC -> ( F e. MblFn <->
                    ( ( Re o. F ) e. MblFn /\ ( Im o. F ) e. MblFn ) ) ) $=
      ( vx cc wf cdm wcel cmbf cre ccom cim wa mbfdm fdm adantr cr syl wral cvv
      wb cvol eleq1d syl5ib wceq ref fco mpan cpm co ccnv cv cima crn ismbf imf
      cioo anbi12d r19.26 syl6bbr wss cnex reex elpm2r mpanl12 sylan2 biantrurd
      mblss bitrd ismbf1 syl6rbbr ex pm5.21ndd ) ADBEZAUAFZGZBHGZIBJZHGZKBJZHGZ
      LZVPBFZVNGVMVOBMVMWBAVNADBNUBUCWAVQFZVNGZVMVOVRWDVTVQMOVMWCAVNVMAPVQEZWCA
      UDDPIEVMWEUEADPIBUFUGZAPVQNQUBUCVMVOVPWATVMVOLZWABDPUHUIGZVQUJCUKZULVNGZV
      SUJWIULVNGZLCUPUMZRZLZVPWGWAWMWNWGWAWJCWLRZWKCWLRZLWMWGVRWOVTWPWGWEVRWOTV
      MWEVOWFOCAVQUNQWGAPVSEZVTWPTVMWQVODPKEVMWQUOADPKBUFUGOCAVSUNQUQWJWKCWLURU
      SWGWHWMVOVMAPUTZWHAVGDSGPSGVMWRLWHVAVBDPABSSVCVDVEVFVHCBVIVJVKVL $.

    $( Definitional property of a measurable function: the preimage of an open
       right-unbounded interval is measurable.  (Contributed by Mario Carneiro,
       17-Jun-2014.) $)
    mbfima $p |- ( ( F e. MblFn /\ F : A --> RR ) ->
                   ( `' F " ( B (,) C ) ) e. dom vol ) $=
      ( vx cmbf wcel cr wf wa cxr ccnv cioo co cima cvol cdm cv crn c0 wral cxp
      ismbf biimpac wfn cpw ioof ax-mp fnovrn mp3an1 wceq imaeq2 eleq1d rspccva
      ffn syl2an wn ndmioo imaeq2d ima0 syl6eq 0mbl syl6eqel adantl pm2.61dan )
      DFGZAHDIZJZBKGZCKGZJZDLZBCMNZOZPQZGZVHVLERZOZVOGZEMSZUAZVMVTGZVPVKVGVFWAE
      ADUCUDMKKUBZUEZVIVJWBWCHUFZMIWDUGWCWEMUOUHKKBCMUIUJVSVPEVMVTVQVMUKVRVNVOV
      QVMVLULUMUNUPVKUQZVPVHWFVNTVOWFVNVLTOTWFVMTVLBCURUSVLUTVAVBVCVDVE $.

    $( The preimage of any closed interval under a measurable function is
       measurable.  (Contributed by Mario Carneiro, 18-Jun-2014.) $)
    mbfimaicc $p |- ( ( ( F e. MblFn /\ F : A --> RR ) /\
                        ( B e. RR /\ C e. RR ) ) ->
                      ( `' F " ( B [,] C ) ) e. dom vol ) $=
      ( wcel cr wa ccnv cima cmnf cioo cpnf cun cdif cdm wceq adantl wfun syl
      co cmbf cicc cvol wss iccssre dfss4 sylib difreicc difeq2d eqtr3d imaeq2d
      wf funcnvcnv ad2antlr imadif eqtrd fimacnv mbfdm fdm eleq1d biimpac sylan
      ffun eqeltrd imaundi mbfima unmbl syl2anc syl5eqel difmbl adantr ) DUAEZA
      FDULZGZBFECFEGZGZDHZBCUBTZIZVQFIZVQJBKTZCLKTZMZIZNZUCOZVPVSVQFWCNZIZWEVPV
      RWGVQVPFFVRNZNZVRWGVPVRFUDZWJVRPVOWKVNBCUEQVRFUFUGVPWIWCFVOWIWCPVNBCUHQUI
      UJUKVPVQHRZWHWEPVMWLVLVOVMDRWLAFDVCDUMSUNFWCVQUOSUPVNWEWFEZVOVNVTWFEWDWFE
      WMVNVTAWFVMVTAPVLAFDUQQVLDOZWFEZVMAWFEZDURVMWOWPVMWNAWFAFDUSUTVAVBVDVNWDV
      QWAIZVQWBIZMZWFVQWAWBVEVNWQWFEWRWFEWSWFEAJBDVFACLDVFWQWRVGVHVIVTWDVJVHVKV
      D $.

    $( The preimage of a point under a measurable function is measurable.
       (Contributed by Mario Carneiro, 18-Jun-2014.) $)
    mbfimasn $p |- ( ( F e. MblFn /\ F : A --> RR /\ B e. RR ) ->
                     ( `' F " { B } ) e. dom vol ) $=
      ( cmbf wcel cr wf w3a ccnv cicc co cima csn cvol cdm cxr wceq simp3 iccid
      rexr 3syl imaeq2d wa mbfimaicc anabsan2 3impa eqeltrrd ) CDEZAFCGZBFEZHZC
      IZBBJKZLZULBMZLNOZUKUMUOULUKUJBPEUMUOQUHUIUJRBTBSUAUBUHUIUJUNUPEZUHUIUCUJ
      UQABBCUDUEUFUG $.

    $( A constant function is measurable.  (Contributed by Mario Carneiro,
       17-Jun-2014.) $)
    mbfconst $p |- ( ( A e. dom vol /\ B e. CC ) ->
                     ( A X. { B } ) e. MblFn ) $=
      ( vy vx wcel cc wa csn cxp cr cre ccnv cima cim wf fconstmpt cvv cfv cmpt
      a1i cvol cdm cpm co ccom cioo crn wral cmbf wss simplr fmptd mblss adantr
      cv cnex reex elpm2r mpanl12 syl2anc wceq ref feqmptd fveq2 fmptco syl6eqr
      cnveqd imaeq1d recl mbfconstlem sylan2 eqeltrd imf jca ralrimivw sylanbrc
      imcl ismbf1 ) AUAUBZEZBFEZGZABHIZFJUCUDEZKWCUEZLZCUOZMZVSEZNWCUEZLZWGMZVS
      EZGZCUFUGZUHWCUIEWBAFWCOZAJUJZWDWBDABFWCVTWADUOAEUKZDABPZULVTWQWAAUMUNFQE
      JQEWPWQGWDUPUQFJAWCQQURUSUTWBWNCWOWBWIWMWBWHABKRZHIZLZWGMZVSWBWFXBWGWBWEX
      AWBWEDAWTSXAWBDCAFBWGKRWTWCKWRWCDABSVAWBWSTZWBCFJKFJKOWBVBTVCWGBKVDVEDAWT
      PVFVGVHWAVTWTJEXCVSEBVIAWGWTVJVKVLWBWLABNRZHIZLZWGMZVSWBWKXGWGWBWJXFWBWJD
      AXESXFWBDCAFBWGNRXEWCNWRXDWBCFJNFJNOWBVMTVCWGBNVDVEDAXEPVFVGVHWAVTXEJEXHV
      SEBVQAWGXEVJVKVLVNVOCWCVRVP $.

    $( The identity function is measurable.  (Contributed by Mario Carneiro,
       17-Jun-2014.) $)
    mbfid $p |- ( A e. dom vol -> ( _I |` A ) e. MblFn ) $=
      ( vx vy vz cvol wcel cid ccnv cv cima cioo wa cin eqtri cxr wrex cr wf wb
      id cdm cres cmbf crn wral cnvresima cnvi imaeq1i imai ineq1i wceq cxp cpw
      co wfn ioof ffn ovelrn mp2b ioombl syl6eqel rexlimivv sylbi inmbl syl2anr
      wi a1i syl5eqel ralrimiva wss wf1o f1oi ax-mp mblss fss sylancr ismbf syl
      f1of mpbird ) AEUAZFZGAUBZUCFZWCHBIZJZWAFZBKUDZUEZWBWGBWHWBWEWHFZLWFWEAMZ
      WAWFGHZWEJZAMWKAWEGUFWMWEAWMGWEJWEWLGWEUGUHWEUINUJNWJWEWAFZWBWKWAFWBWJWEC
      IZDIZKUNZUKZDOPCOPZWNOOULZQUMZKRKWTUOWJWSSUPWTXAKUQCDOOWEKURUSWRWNCDOOWRW
      NVFWOOFWPOFLWRWEWQWAWRTWOWPUTVAVGVBVCWBTWEAVDVEVHVIWBAQWCRZWDWISWBAAWCRZA
      QVJXBAAWCVKXCAVLAAWCVSVMAVNAAQWCVOVPBAWCVQVRVT $.
  $}

  ${
    $d x A $.  $d x ph $.
    mbfmptcl.1 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    mbfmptcl.2 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( Lemma for the ` MblFn ` predicate applied to a mapping operation.
       (Contributed by Mario Carneiro, 11-Aug-2014.) $)
    mbfmptcl $p |- ( ( ph /\ x e. A ) -> B e. CC ) $=
      ( cc wcel cmpt wf wral cdm cmbf mbff syl wceq ralrimiva dmmptg feq2d eqid
      mpbid fmpt sylibr r19.21bi ) ADHIZBCACHBCDJZKZUFBCLAUGMZHUGKZUHAUGNIUJFUG
      OPAUICHUGADEIZBCLUICQAUKBCGRBCDESPTUBBCHDUGUGUAUCUDUE $.

    $( The domain of a measurable function is measurable.  (Contributed by
       Mario Carneiro, 31-Aug-2014.) $)
    mbfdm2 $p |- ( ph -> A e. dom vol ) $=
      ( cmpt cdm cvol wcel wral wceq ralrimiva dmmptg syl cmbf mbfdm eqeltrrd )
      ABCDHZIZCJIZADEKZBCLUACMAUCBCGNBCDEOPATQKUAUBKFTRPS $.
  $}

  ${
    $d x A $.  $d y B $.  $d x y ph $.
    ismbfcn2.1 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    $( A complex function is measurable iff the real and imaginary components
       of the function are measurable.  (Contributed by Mario Carneiro,
       13-Aug-2014.) $)
    ismbfcn2 $p |- ( ph -> ( ( x e. A |-> B ) e. MblFn <->
      ( ( x e. A |-> ( Re ` B ) ) e. MblFn /\
        ( x e. A |-> ( Im ` B ) ) e. MblFn ) ) ) $=
      ( vy cmpt cmbf wcel cre ccom cim wa cfv cc wf cr a1i feqmptd fveq2 wb syl
      eqid fmptd ismbfcn cv eqidd ref fmptco eleq1d imf anbi12d bitrd ) ABCDGZH
      IZJUNKZHIZLUNKZHIZMZBCDJNZGZHIZBCDLNZGZHIZMACOUNPUOUTUAABCDOUNEUNUCUDCUNU
      EUBAUQVCUSVFAUPVBHABFCODFUFZJNVAUNJEAUNUGZAFOQJOQJPAUHRSVGDJTUIUJAURVEHAB
      FCODVGLNVDUNLEVHAFOQLOQLPAUKRSVGDLTUIUJULUM $.
  $}

  ${
    $d x y z F $.  $d x y z ph $.  $d z A $.
    ismbfd.1 $e |- ( ph -> F : A --> RR ) $.
    ismbfd.2 $e |- ( ( ph /\ x e. RR* ) ->
                     ( `' F " ( x (,) +oo ) ) e. dom vol ) $.
    ismbfd.3 $e |- ( ( ph /\ x e. RR* ) ->
                     ( `' F " ( -oo (,) x ) ) e. dom vol ) $.
    $( Deduction to prove measurability of a real function.  The third
       hypothesis is not necessary, but the proof of this requires countable
       choice, so we derive this separately as ~ ismbf3d .  (Contributed by
       Mario Carneiro, 18-Jun-2014.) $)
    ismbfd $p |- ( ph -> F e. MblFn ) $=
      ( vz vy wcel cima cioo co wceq cxr cpnf cmnf cle wbr syl2anc cmbf ccnv cv
      cvol cdm crn wral wrex cxp cr cpw wf wfn wb ioof ffn ovelrn wa cin simprl
      mp2b pnfxr mnfxr simprr iooin syl22anc mnfle xrleid breq1 ifboth ad2antrl
      cif a1i xrmax1 sylancl ifcl sylancr xrletri3 mpbir2and xrmin2 pnfge breq2
      ad2antll oveq12d eqtrd imaeq2d wfun adantr ffun inpreima eqtr3d ralrimiva
      syl adantrr oveq2 eleq1d rspccva sylan inmbl imaeq2 syl5ibrcom rexlimdvva
      adantrl eqeltrd syl5bi ralrimiv ismbf mpbird ) ADUAJZDUBZHUCZKZUDUEZJZHLU
      FZUGZAXNHXOXKXOJZXKBUCZIUCZLMZNZIOUHBOUHZAXNOOUIZUJUKZLULLYCUMXQYBUNUOYCY
      DLUPBIOOXKLUQVAAYAXNBIOOAXROJZXSOJZURZURZXNYAXJXTKZXMJYHYIXJXRPLMZKZXJQXS
      LMZKZUSZXMYHXJYJYLUSZKZYIYNYHYOXTXJYHYOXRQRSZQXRVLZPXSRSZPXSVLZLMZXTYHYEP
      OJZQOJZYFYOUUANAYEYFUTZUUBYHVBVMUUCYHVCVMAYEYFVDZXRPQXSVEVFYHYRXRYTXSLYHY
      RXRNZYRXRRSZXRYRRSZYEUUGAYFYEQXRRSZXRXRRSZUUGXRVGXRVHYQUUIUUJUUGQXRQYRXRR
      VIXRYRXRRVIVJTVKYHYEUUCUUHUUDVCXRQVNVOYHYROJZYEUUFUUGUUHURUNYHUUCYEUUKVCU
      UDYQQXROVPVQUUDYRXRVRTVSYHYTXSNZYTXSRSZXSYTRSZYHUUBYFUUMVBUUEPXSVTVQYFUUN
      AYEYFXSPRSZXSXSRSZUUNXSWAXSVHYSUUOUUPUUNPXSPYTXSRWBXSYTXSRWBVJTWCYHYTOJZY
      FUULUUMUUNURUNYHUUBYFUUQVBUUEYSPXSOVPVQUUEYTXSVRTVSWDWEWFYHDWGZYPYNNYHCUJ
      DULZUURAUUSYGEWHCUJDWIWMYJYLDWJWMWKYHYKXMJZYMXMJZYNXMJAYEUUTYFFWNAYFUVAYE
      AXJQXRLMZKZXMJZBOUGYFUVAAUVDBOGWLUVDUVABXSOXRXSNZUVCYMXMUVEUVBYLXJXRXSQLW
      OWFWPWQWRXCYKYMWSTXDYAXLYIXMXKXTXJWTWPXAXBXEXFAUUSXIXPUNEHCDXGWMXH $.
  $}

  ${
    $d x F $.  $d x ph $.
    ismbf2d.1 $e |- ( ph -> F : A --> RR ) $.
    ismbf2d.2 $e |- ( ph -> A e. dom vol ) $.
    ismbf2d.3 $e |- ( ( ph /\ x e. RR ) ->
                      ( `' F " ( x (,) +oo ) ) e. dom vol ) $.
    ismbf2d.4 $e |- ( ( ph /\ x e. RR ) ->
                     ( `' F " ( -oo (,) x ) ) e. dom vol ) $.
    $( Deduction to prove measurability of a real function.  (Contributed by
       Mario Carneiro, 18-Jun-2014.) $)
    ismbf2d $p |- ( ph -> F e. MblFn ) $=
      ( wcel cr cpnf wceq cmnf cioo co cima c0 oveq1 syl6eq imaeq2d cv cxr ccnv
      w3o cvol cdm elxr iooid ima0 0mbl eqeltri syl6eqel adantl fimacnv eqeltrd
      wf syl ioomax eleq1d syl5ibrcom imp 3jaodan sylan2b oveq2 ismbfd ) ABCDEB
      UAZUBIZAVFJIZVFKLZVFMLZUDZDUCZVFKNOZPZUEUFZIZVFUGZAVHVPVIVJGVIVPAVIVNVLQP
      ZVOVIVMQVLVIVMKKNOQVFKKNRKUHSTVRQVOVLUIUJUKZULUMAVJVPAVPVJVLJPZVOIZAVTCVO
      ACJDUPVTCLECJDUNUQFUOZVJVNVTVOVJVMJVLVJVMMKNOZJVFMKNRURSTUSUTVAVBVCVGAVKV
      LMVFNOZPZVOIZVQAVHWFVIVJHAVIWFAWFVIWAWBVIWEVTVOVIWDJVLVIWDWCJVFKMNVDURSTU
      SUTVAVJWFAVJWEVRVOVJWDQVLVJWDMMNOQVFMMNVDMUHSTVSULUMVBVCVE $.
  $}

  ${
    $d x z A $.  $d x y z B $.  $d y z C $.  $d y z D $.  $d x y z ph $.
    mbfeqa.1 $e |- ( ph -> A C_ RR ) $.
    mbfeqa.2 $e |- ( ph -> ( vol* ` A ) = 0 ) $.
    mbfeqa.3 $e |- ( ( ph /\ x e. ( B \ A ) ) -> C = D ) $.
    ${
      mbfeqalem.4 $e |- ( ( ph /\ x e. B ) -> C e. RR ) $.
      mbfeqalem.5 $e |- ( ( ph /\ x e. B ) -> D e. RR ) $.
      $( Lemma for ~ mbfeqa .  (Contributed by Mario Carneiro, 2-Sep-2014.) $)
      mbfeqalem $p |- ( ph ->
        ( ( x e. B |-> C ) e. MblFn <-> ( x e. B |-> D ) e. MblFn ) ) $=
        ( vy vz wcel wa cr cfv wceq wb syl2anc cmpt ccnv cima cvol cdm cioo crn
        cv wral cmbf cin cdif cun inundif incom dfin4 eqtri id wss covol cc0 wn
        cab symdif2 eldifi adantl sylan2 eqid fvmpt2 3eqtr4d ralrimiva nffvmpt1
        eldif nfeq fveq2 eqeq12d cbvral sylib r19.21bi eleq1d sylan2br anass1rs
        nfv pm5.32da wfn wf fmptd ffn adantr elpreima 3bitr4d ex con1d syl5eqss
        syl abssdv unssad sstrd ovolssnul syl3anc nulmbl difmbl syl5eqel unssbd
        syl2anr unmbl syl5eqelr impbida ralbidv ismbf ) ABDEUAZUBLUHZUCZUDUEZNZ
        LUFUGZUIZBDFUAZUBXLUCZXNNZLXPUIZXKUJNZXRUJNZAXOXTLXPAXOXTAXOOZXSXSXMUKZ
        XSXMULZUMZXNXSXMUNYDYEXNNYFXNNZYGXNNYDYEXMXMXSULZULZXNYEXMXSUKZYJXSXMUO
        XMXSUPUQXOXOYIXNNZYJXNNAXOURAYIPUSYIUTQVARZYLAYICPAYIYFCAYIYFUMMUHZXMNZ
        YNXSNZSZVBZMVCCMXMXSVDAYRMCAYNCNZYQAYSVBZYQAYTOZYNDNZYNXKQZXLNZOZUUBYNX
        RQZXLNZOZYOYPUUAUUBUUDUUGAUUBYTUUDUUGSZUUBYTOAYNDCULZNZUUIYNDCVMAUUKOUU
        CUUFXLAUUCUUFRZMUUJABUHZXKQZUUMXRQZRZBUUJUIUULMUUJUIAUUPBUUJAUUMUUJNZOZ
        EFUUNUUOIUURUUMDNZEPNZUUNERUUQUUSAUUMDCVEZVFZUUQAUUSUUTUVAJVGBDEPXKXKVH
        ZVITUURUUSFPNZUUOFRUVBUUQAUUSUVDUVAKVGBDFPXRXRVHZVITVJVKUUPUULBMUUJUUPM
        WCBUUCUUFBDEYNVLBDFYNVLVNUUMYNRUUNUUCUUOUUFUUMYNXKVOUUMYNXRVOVPVQVRVSVT
        WAWBWDUUAXKDWEZYOUUESAUVFYTADPXKWFZUVFABDEPXKJUVCWGZDPXKWHWOWIDYNXLXKWJ
        WOUUAXRDWEZYPUUHSAUVIYTADPXRWFZUVIABDFPXRKUVEWGZDPXRWHWOWIDYNXLXRWJWOWK
        WLWMWPWNZWQZGWRAYICUSCPUSZCUTQVARZYMUVMGHYICWSWTYIXATZXMYIXBXEXCAYHXOAY
        FPUSYFUTQVARZYHAYFCPAYIYFCUVLXDZGWRAYFCUSUVNUVOUVQUVRGHYFCWSWTYFXATZWIY
        EYFXFTXGAXTOZXMYKYIUMZXNXMXSUNUVTYKXNNYLUWAXNNUVTYKXSYFULZXNYKYEUWBXMXS
        UOXSXMUPUQXTXTYHUWBXNNAXTURUVSXSYFXBXEXCAYLXTUVPWIYKYIXFTXGXHXIAUVGYBXQ
        SUVHLDXKXJWOAUVJYCYASUVKLDXRXJWOWK $.
    $}

    mbfeqa.4 $e |- ( ( ph /\ x e. B ) -> C e. CC ) $.
    mbfeqa.5 $e |- ( ( ph /\ x e. B ) -> D e. CC ) $.
    $( If two functions are equal almost everywhere, then one is measurable iff
       the other is.  (Contributed by Mario Carneiro, 17-Jun-2014.)  (Revised
       by Mario Carneiro, 2-Sep-2014.) $)
    mbfeqa $p |- ( ph ->
      ( ( x e. B |-> C ) e. MblFn <-> ( x e. B |-> D ) e. MblFn ) ) $=
      ( cre cfv cmpt cmbf wcel cim wa fveq2d recld cdif mbfeqalem imcld anbi12d
      cv ismbfcn2 3bitr4d ) ABDELMZNOPZBDEQMZNOPZRBDFLMZNOPZBDFQMZNOPZRBDENOPBD
      FNOPAUIUMUKUOABCDUHULGHABUEZDCUAPRZEFLISAUPDPRZEJTURFKTUBABCDUJUNGHUQEFQI
      SUREJUCURFKUCUBUDABDEJUFABDFKUFUG $.
  $}

  ${
    $d x F $.  $d x A $.
    $( The restriction of a measurable function is measurable.  (Contributed by
       Mario Carneiro, 18-Jun-2014.) $)
    mbfres $p |- ( ( F e. MblFn /\ A e. dom vol ) ->
                   ( F |` A ) e. MblFn ) $=
      ( vx cmbf wcel wa cre ccom cim cc cr ccnv cima adantr syl2anc sylancr cin
      wf inmbl syl5eqel cvol cdm cres ref wss cpm co simpr cioo crn wral ismbf1
      cv simplbi pmresg cvv wb cnex elpm2g mpbid simpld fco dmres mbfdm syl2anr
      id cpnf resco cnveqi imaeq1i cnvresima eqtr3i mbff ismbfcn syl ibi mbfima
      sylan cmnf ismbf2d imf simprd mpbir2and ) BDEZAUAUBZEZFZBAUCZDEZGWHHZDEZI
      WHHZDEZWGCWHUBZWJWGJKGRZWNJWHRZWNKWJRUDWGWPWNAUEZWGWHJAUFUGEZWPWQFZWGWFBJ
      KUFUGEZWRWDWFUHZWDWTWFWDWTGBHZLZCUMZMWEEIBHZLZXDMWEEFCUIUJUKCBULUNNJAKBWE
      UOOWGJUPEWFWRWSUQURXAJAWHUPWEUSPUTVAZWNJKGWHVBPWGWNABUBZQZWEBAVCWFWFXHWEE
      XIWEEWDWFVFBVDAXHSVETZWGWJLZXDVGUIUGZMZWEEXDKEZWGXMXCXLMZAQZWEXBAUCZLZXLM
      XMXPXRXKXLXQWJGBAVHVIZVJAXLXBVKVLWDXOWEEZWFXPWEEWDXBDEZXHKXBRZXTWDYAXEDEZ
      WDYAYCFZWDXHJBRZWDYDUQBVMZXHBVNVOVPZVAZWDWOYEYBUDYFXHJKGBVBPZXHXDVGXBVQOX
      OASVRTNWGXKVSXDUIUGZMZWEEXNWGYKXCYJMZAQZWEXRYJMYKYMXRXKYJXSVJAYJXBVKVLWDY
      LWEEZWFYMWEEWDYAYBYNYHYIXHVSXDXBVQOYLASVRTNVTWGCWNWLWGJKIRZWPWNKWLRWAXGWN
      JKIWHVBPXJWGWLLZXLMZWEEXNWGYQXFXLMZAQZWEXEAUCZLZXLMYQYSUUAYPXLYTWLIBAVHVI
      ZVJAXLXEVKVLWDYRWEEZWFYSWEEWDYCXHKXERZUUCWDYAYCYGWBZWDYOYEUUDWAYFXHJKIBVB
      PZXHXDVGXEVQOYRASVRTNWGYPYJMZWEEXNWGUUGXFYJMZAQZWEUUAYJMUUGUUIUUAYPYJUUBV
      JAYJXEVKVLWDUUHWEEZWFUUIWEEWDYCUUDUUJUUEUUFXHVSXDXEVQOUUHASVRTNVTWGWPWIWK
      WMFUQXGWNWHVNVOWC $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.  $d x ph $.
    mbfres2.1 $e |- ( ph -> F : A --> RR ) $.
    mbfres2.2 $e |- ( ph -> ( F |` B ) e. MblFn ) $.
    mbfres2.3 $e |- ( ph -> ( F |` C ) e. MblFn ) $.
    mbfres2.4 $e |- ( ph -> ( B u. C ) = A ) $.
    $( Measurability of a piecewise function: if ` F ` is measurable on subsets
       ` B ` and ` C ` of its domain, and these pieces make up all of ` A ` ,
       then ` F ` is measurable on the whole domain.  (Contributed by Mario
       Carneiro, 18-Jun-2014.) $)
    mbfres2 $p |- ( ph -> F e. MblFn ) $=
      ( vx cmbf wcel ccnv cima wral cres cun cr wf syl6eq cv cvol cdm cioo wceq
      crn wa reseq2d wfn ffn fnresdm eqtr2d adantr resundi cnveqd cnvun imaeq1d
      3syl imaundir wb ssun1 syl5sseq fssres syl2anc ismbf mpbid r19.21bi ssun2
      wss syl unmbl eqeltrd ralrimiva mpbird ) AEKLZEMZJUAZNZUBUCZLZJUDUFZOZAVT
      JWAAVQWALZUGZVRECPZMZVQNZEDPZMZVQNZQZVSWDVRWFWIQZVQNWKWDVPWLVQWDVPWEWHQZM
      WLWDEWMWDEECDQZPZWMAEWOUEWCAWOEBPZEAWNBEIUHABRESZEBUIWPEUEFBREUJBEUKURULU
      MECDUNTUOWEWHUPTUQWFWIVQUSTWDWGVSLZWJVSLZWKVSLAWRJWAAWEKLZWRJWAOZGACRWESZ
      WTXAUTAWQCBVIXBFAWNCBCDVAIVBBRCEVCVDJCWEVEVJVFVGAWSJWAAWHKLZWSJWAOZHADRWH
      SZXCXDUTAWQDBVIXEFAWNDBDCVHIVBBRDEVCVDJDWHVEVJVFVGWGWJVKVDVLVMAWQVOWBUTFJ
      BEVEVJVN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    mbfss.1 $e |- ( ph -> A C_ B ) $.
    mbfss.2 $e |- ( ph -> B e. dom vol ) $.
    mbfss.3 $e |- ( ( ph /\ x e. A ) -> C e. V ) $.
    mbfss.4 $e |- ( ( ph /\ x e. ( B \ A ) ) -> C = 0 ) $.
    mbfss.5 $e |- ( ph -> ( x e. A |-> C ) e. MblFn ) $.
    $( Change the domain of a measurability predicate.  (Contributed by Mario
       Carneiro, 17-Aug-2014.) $)
    mbfss $p |- ( ph -> ( x e. B |-> C ) e. MblFn ) $=
      ( cmpt cmbf wcel cfv wceq cc0 cres resmpt eqeltrd cre cdif cr cv wa wo cc
      cim cun elun undif2 wss ssequn1 sylib syl5eq syl5bbr biimpar mbfmptcl 0cn
      eleq2d syl6eqel jaodan syldan recld fmptd syl ismbfcn2 mpbid simpld difss
      eqid fveq2d re0 syl6eq mpteq2dva csn cxp fconstmpt cvol cdm mbfdm2 difmbl
      ax-mp syl2anc mbfconst sylancl syl5eqelr mbfres2 imcld simprd mpbir2and
      im0 ) ABDELMNBDEUAOZLZMNBDEUHOZLZMNADCDCUBZWNABDWMUCWNABUDZDNZUEZEAWSWRCN
      ZWRWQNZUFZEUGNZAXCWSXCWRCWQUIZNAWSWRCWQUJAXEDWRAXECDUIZDCDUKACDULZXFDPGCD
      UMUNUOZUTUPUQAXAXDXBABCEFKIURZAXBUEZEQUGJUSVAVBVCZVDWNVKVEAWNCRZBCWMLZMAX
      GXLXMPGBDCWMSVFAXMMNZBCWOLZMNZABCELMNXNXPUEKABCEXIVGVHZVITAWNWQRZBWQQLZMA
      XRBWQWMLZXSWQDULZXRXTPDCVJZBDWQWMSWCABWQWMQXJWMQUAOQXJEQUAJVLVMVNVOUOAXSW
      QQVPVQZMBWQQVRAWQVSVTZNZQUGNYCMNADYDNCYDNYEHABCEFKIWADCWBWDUSWQQWEWFWGZTX
      HWHADCWQWPABDWOUCWPWTEXKWIWPVKVEAWPCRZXOMAXGYGXOPGBDCWOSVFAXNXPXQWJTAWPWQ
      RZXSMAYHBWQWOLZXSYAYHYIPYBBDWQWOSWCABWQWOQXJWOQUHOQXJEQUHJVLWLVNVOUOYFTXH
      WHABDEXKVGWK $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z ph $.
    mbfmulc2re.1 $e |- ( ph -> F e. MblFn ) $.
    mbfmulc2re.2 $e |- ( ph -> B e. RR ) $.
    ${
      mbfmulc2lem.3 $e |- ( ph -> F : A --> RR ) $.
      $( Multiplication by a constant preserves measurability.  (Contributed by
         Mario Carneiro, 18-Jun-2014.) $)
      mbfmulc2lem $p |- ( ph -> ( ( A X. { B } ) oF x. F ) e. MblFn ) $=
        ( cc0 clt wbr cmul co wcel cr wa syl wb biantrurd ad2antrr 3bitr4d wceq
        vy vx vz w3o csn cxp cof cmbf 0re lttri4 sylancl wf cvol cdm cv remulcl
        adantl fconst6g fdm mbfdm eqeltrrd inidm off adantr ccnv cpnf cioo cima
        cmnf cdiv cfv cxr simprl rexrd elioopnf ffvelrnda ad2ant2rl cneg simprr
        wfn ffn eqidd mpdan breq2d renegcld simplr lt0neg1d ltmuldiv2 syl112anc
        ofc1 mpbid recnd mulneg1d breq1d ltnegd bitr4d lt0ne0d div2negd 3bitr2d
        bitr3d redivcld elioomnf anassrs pm5.32da elpreima eqrdv mbfima syl2anc
        eqeltrd ltdivmul ismbf2d cc simpr 0cn syl6eqel oveq1d mul02lem2 caofid2
        a1i eqtrd mbfconst elrpd rerpdivcld 3jaodan ) ACHIJZCHUAZHCIJZUEZBCUFUG
        ZDKUHLZUIMZACNMZHNMYIFUJCHUKULAYFYLYGYHAYFOZUBBYKABNYKUMZYFAUCUBBBBKNNN
        YJDUNUOZYPUCUPZNMZUBUPZNMZOYQYSKLNMAYQYSUQURAYMBNYJUMFBCNUSPGADUOZBYPAB
        NDUMZUUABUAGBNDUTPADUIMZUUAYPMEDVAPVBZUUDBVCVDZVEABYPMZYFUUDVEYNYTOZYKV
        FZYSVGVHLZVIZDVFZVJYSCVKLZVHLZVIZYPUUGUDUUJUUNUUGUDUPZBMZUUOYKVLZUUIMZO
        ZUUPUUODVLZUUMMZOZUUOUUJMZUUOUUNMZUUGUUPUURUVAYNYTUUPUURUVAQYNYTUUPOZOZ
        UURUUQNMZYSUUQIJZOZUVHUVAUVFYSVMMZUURUVIQZUVFYSYNYTUUPVNZVOZYSUUQVPZPUV
        FUVGUVHAUUPUVGYFYTABNUUOYKUUEVQZVRZRUVFUUTUULIJZUUTNMZUVQOZUVHUVAUVFUVR
        UVQAUUPUVRYFYTABNUUODGVQZVRZRUVFUVHYSCUUTKLZIJZUUTYSVSZCVSZVKLZIJZUVQUV
        FUUQUWBYSIUVFUUPUUQUWBUAZYNYTUUPVTUVFBCUUTKDYPNUUOAUUFYFUVEUUDSAYMYFUVE
        FSZUVFUUBDBWAZAUUBYFUVEGSBNDWBZPUVFUUPOUUTWCWKWDZWEUVFUWEUUTKLZUWDIJZUW
        GUWCUVFUVRUWDNMZUWENMZHUWEIJZUWNUWGQUWAUVFYSUVLWFZUVFCUWIWFZUVFYFUWQAYF
        UVEWGZUVFCUWIWHWLZUUTUWDUWEWIWJUVFUWNUWBVSZUWDIJUWCUVFUWMUXBUWDIUVFCUUT
        UVFCUWIWMZUVFUUTUWAWMWNZWOUVFYSUWBUVLUVFUUQUWBNUWLUVPVBZWPWQXAUVFUWFUUL
        UUTIUVFYSCUVFYSUVLWMUXCUVFCUWTWRZWSZWEWTUVFUULVMMZUVAUVSQZUVFUULUVFYSCU
        VLUWIUXFXBVOZUULUUTXCZPTWTXDXEUUGYKBWAZUVCUUSQZAUXLYFYTAYOUXLUUEBNYKWBP
        ZSZBUUOUUIYKXFZPUUGUWJUVDUVBQZAUWJYFYTAUUBUWJGUWKPZSZBUUOUUMDXFZPTXGAUU
        NYPMZYFYTAUUCUUBUYAEGBVJUULDXHXIZSXJUUGUUHVJYSVHLZVIZUUKUULVGVHLZVIZYPU
        UGUDUYDUYFUUGUUPUUQUYCMZOZUUPUUTUYEMZOZUUOUYDMZUUOUYFMZUUGUUPUYGUYIYNYT
        UUPUYGUYIQUVFUYGUVGUUQYSIJZOZUYMUYIUVFUVJUYGUYNQZUVMYSUUQXCZPUVFUVGUYMU
        VPRUVFUULUUTIJZUVRUYQOZUYMUYIUVFUVRUYQUWARUVFUYMUWBYSIJZUYQUVFUUQUWBYSI
        UWLWOUVFUWDUWMIJZUWDUXBIJUYQUYSUVFUWMUXBUWDIUXDWEUVFUWFUUTIJZUYQUYTUVFU
        WFUULUUTIUXGWOUVFUWOUVRUWPUWQVUAUYTQUWRUWAUWSUXAUWDUUTUWEXKWJXAUVFUWBYS
        UXEUVLWPTWQUVFUXHUYIUYRQZUXJUULUUTVPZPTWTXDXEUUGUXLUYKUYHQZUXOBUUOUYCYK
        XFZPUUGUWJUYLUYJQZUXSBUUOUYEDXFZPTXGAUYFYPMZYFYTAUUCUUBVUHEGBUULVGDXHXI
        ZSXJXLAYGOZYKBHUFUGZUIVUJUCBCHKNDYPXMXMAUUFYGUUDVEZAUUBYGGVEVUJCHXMAYGX
        NXOXPHXMMZVUJXOXTVUJYROZCYQKLHYQKLZHVUNCHYQKAYGYRWGXQYRVUOHUAVUJYQXRURY
        AXSVUJUUFVUMVUKUIMVULXOBHYBULXJAYHOZUBBYKAYOYHUUEVEAUUFYHUUDVEVUPYTOZUU
        JUYFYPVUQUDUUJUYFVUQUUSUYJUVCUYLVUQUUPUURUYIVUPYTUUPUURUYIQVUPUVEOZUURU
        VIUVHUYIVURUVJUVKVURYSVUPYTUUPVNZVOZUVNPVURUVGUVHAUUPUVGYHYTUVOVRZRVURU
        YQUYRUVHUYIVURUVRUYQAUUPUVRYHYTUVTVRZRVURUVHUWCUYQVURUUQUWBYSIAUUPUWHYH
        YTABCUUTKDYPNUUOUUDFUXRAUUPOUUTWCWKVRZWEVURYTUVRYMYHUYQUWCQVUSVVBAYMYHU
        VEFSZAYHUVEWGZYSUUTCXKWJWQVURUXHVUBVURUULVURYSCVUSVURCVVDVVEYCYDVOZVUCP
        TWTXDXEVUQUXLUXMAUXLYHYTUXNSZUXPPVUQUWJVUFAUWJYHYTUXRSZVUGPTXGAVUHYHYTV
        UISXJVUQUYDUUNYPVUQUDUYDUUNVUQUYHUVBUYKUVDVUQUUPUYGUVAVUPYTUUPUYGUVAQVU
        RUYGUYNUYMUVAVURUVJUYOVUTUYPPVURUVGUYMVVARVURUYSUVQUYMUVAVURUVRYTYMYHUY
        SUVQQVVBVUSVVDVVEUUTYSCWIWJVURUUQUWBYSIVVCWOVURUVAUVSUVQVURUXHUXIVVFUXK
        PVURUVRUVQVVBRWQTWTXDXEVUQUXLVUDVVGVUEPVUQUWJUXQVVHUXTPTXGAUYAYHYTUYBSX
        JXLYEWD $.
    $}

    mbfmulc2re.3 $e |- ( ph -> F : A --> CC ) $.
    $( Multiplication by a constant preserves measurability.  (Contributed by
       Mario Carneiro, 15-Aug-2014.) $)
    mbfmulc2re $p |- ( ph -> ( ( A X. { B } ) oF x. F ) e. MblFn ) $=
      ( vx cmul co cfv cmpt cmbf cvv cr cc wceq wcel offval2 eqeltrd csn cxp cv
      cof cdm fdm syl dmexg eqeltrrd adantr ffvelrnda fconstmpt a1i feqmptd cre
      wf cim wa remul2d mpteq2dva recld eqidd eqtr4d ismbfcn2 mpbid simpld eqid
      fmptd mbfmulc2lem immul2d imcld simprd recnd mulcld mpbir2and ) ABCUAUBZD
      IUDZJHBCHUCZDKZIJZLZMAHBCVSIVPDNOPADUEZBNABPDUPWBBQGBPDUFUGADMRWBNREDMUHU
      GUIZACORVRBRZFUJZABPVRDGUKZVPHBCLQAHBCULUMZAHBPDGUNZSAWAMRHBVTUOKZLZMRHBV
      TUQKZLZMRAWJVPHBVSUOKZLZVQJZMAWJHBCWMIJZLWOAHBWIWPAWDURZCVSWEWFUSUTAHBCWM
      IVPWNNOOWCWEWQVSWFVAZWGAWNVBSVCABCWNAWNMRZHBVSUQKZLZMRZAHBVSLZMRWSXBURADX
      CMWHEUIAHBVSWFVDVEZVFFAHBWMOWNWRWNVGVHVITAWLVPXAVQJZMAWLHBCWTIJZLXEAHBWKX
      FWQCVSWEWFVJUTAHBCWTIVPXANOOWCWEWQVSWFVKZWGAXAVBSVCABCXAAWSXBXDVLFAHBWTOX
      AXGXAVGVHVITAHBVTWQCVSACPRWDACFVMUJWFVNVDVOT $.
  $}

  ${
    $d x A $.  $d x z F $.  $d x z G $.  $d y z H $.  $d x y z ph $.
    mbfmax.1 $e |- ( ph -> F : A --> RR ) $.
    mbfmax.2 $e |- ( ph -> F e. MblFn ) $.
    mbfmax.3 $e |- ( ph -> G : A --> RR ) $.
    mbfmax.4 $e |- ( ph -> G e. MblFn ) $.
    mbfmax.5 $e |- H = ( x e. A |->
      if ( ( F ` x ) <_ ( G ` x ) , ( G ` x ) , ( F ` x ) ) ) $.
    $( The maximum of two functions is measurable.  (Contributed by Mario
       Carneiro, 18-Jun-2014.) $)
    mbfmax $p |- ( ph -> H e. MblFn ) $=
      ( wbr cr wcel wa syl2anc cpnf wb clt syl vy vz cfv cle cif ffvelrnda ifcl
      cv fmptd cxr ccnv cioo co cima cun cvol cdm wo wn wf adantr rexrd xrmaxle
      simplr syl3anc notbid ianor syl6bb w3a pnfxr elioo2 sylancl 3anan12 fveq2
      wceq breq12d ifbieq12d fvex ifex fvmpt adantl eleq1d jca biantrud 3bitr4d
      ltpnf xrltnle 3bitr2d orbi12d pm5.32da andi wfn ffn elpreima elun syl6bbr
      bitrd eqrdv cmbf mbfima unmbl eqeltrd cmnf cin xrmaxlt mnfxr df-3an mnflt
      sylancr biantrurd bitr4d anbi12d anandi elin inmbl ismbfd ) AUACFABCBUHZD
      UCZXQEUCZUDLZXSXRUEZMFAXQCNOXSMNXRMNYAMNACMXQEIUFACMXQDGUFXTXSXRMUGPKUIZA
      UAUHZUJNZOZFUKZYCQULUMZUNZDUKZYGUNZEUKZYGUNZUOZUPUQZYEUBYHYMYEUBUHZYHNZYO
      YJNZYOYLNZURZYOYMNYEYOCNZYOFUCZYGNZOZYTYODUCZYGNZOZYTYOEUCZYGNZOZURZYPYSY
      EUUCYTUUEUUHURZOUUJYEYTUUBUUKYEYTOZUUDUUGUDLZUUGUUDUEZYCUDLZUSZUUDYCUDLZU
      SZUUGYCUDLZUSZURZUUBUUKUULUUPUUQUUSOZUSUVAUULUUOUVBUULUUDUJNZUUGUJNZYDUUO
      UVBRUULUUDYECMYODACMDUTZYDGVAZUFZVBZUULUUGYECMYOEACMEUTZYDIVAZUFZVBZAYDYT
      VDZUUDUUGYCVCVEVFUUQUUSVGVHUULUUBYCUUNSLZUUPUULUUNYGNZUVNUUNMNZUUNQSLZOZO
      ZUUBUVNUULUVOUVPUVNUVQVIZUVSUULYDQUJNZUVOUVTRUVMVJYCQUUNVKVLUVPUVNUVQVMVH
      UULUUAUUNYGYTUUAUUNVOYEBYOYAUUNCFXQYOVOZXTUUMXSXRUUGUUDUWBXRUUDXSUUGUDXQY
      ODVNZXQYOEVNZVPUWDUWCVQKUUMUUGUUDYOEVRYODVRVSVTWAZWBUULUVRUVNUULUVPUVQUUL
      UUGMNZUUDMNZUVPUVKUVGUUMUUGUUDMUGPZUULUVPUVQUWHUUNWFTWCWDWEUULYDUUNUJNUVN
      UUPRUVMUULUUNUWHVBYCUUNWGPWQUULUUEUURUUHUUTUULUUEYCUUDSLZUWGUUDQSLZOZOZUW
      IUURUULUUEUWGUWIUWJVIZUWLUULYDUWAUUEUWMRUVMVJYCQUUDVKVLUWGUWIUWJVMVHUULUW
      KUWIUULUWGUWJUVGUULUWGUWJUVGUUDWFTWCWDUULYDUVCUWIUURRUVMUVHYCUUDWGPWHUULU
      UHYCUUGSLZUWFUUGQSLZOZOZUWNUUTUULUUHUWFUWNUWOVIZUWQUULYDUWAUUHUWRRUVMVJYC
      QUUGVKVLUWFUWNUWOVMVHUULUWPUWNUULUWFUWOUVKUULUWFUWOUVKUUGWFTWCWDUULYDUVDU
      WNUUTRUVMUVLYCUUGWGPWHWIWEWJYTUUEUUHWKVHYEFCWLZYPUUCRAUWSYDACMFUTUWSYBCMF
      WMTVAZCYOYGFWNTYEYQUUFYRUUIYEDCWLZYQUUFRYEUVEUXAUVFCMDWMTZCYOYGDWNTYEECWL
      ZYRUUIRYEUVIUXCUVJCMEWMTZCYOYGEWNTWIWEYOYJYLWOWPWRAYMYNNZYDAYJYNNZYLYNNZU
      XEADWSNZUVEUXFHGCYCQDWTPAEWSNZUVIUXGJICYCQEWTPYJYLXAPVAXBYEYFXCYCULUMZUNZ
      YIUXJUNZYKUXJUNZXDZYNYEUBUXKUXNYEYOUXKNZYOUXLNZYOUXMNZOZYOUXNNYEYTUUAUXJN
      ZOZYTUUDUXJNZOZYTUUGUXJNZOZOZUXOUXRYEUXTYTUYAUYCOZOUYEYEYTUXSUYFUULUUNYCS
      LZUUDYCSLZUUGYCSLZOZUXSUYFUULUVCUVDYDUYGUYJRUVHUVLUVMUUDUUGYCXEVEUULUUNUX
      JNZUVPXCUUNSLZOZUYGOZUXSUYGUULUYKUVPUYLUYGVIZUYNUULXCUJNZYDUYKUYORXFUVMXC
      YCUUNVKXIUVPUYLUYGXGVHUULUUAUUNUXJUWEWBUULUYMUYGUULUVPUYLUWHUULUVPUYLUWHU
      UNXHTWCXJWEUULUYAUYHUYCUYIUULUYAUWGXCUUDSLZOZUYHOZUYHUULUYAUWGUYQUYHVIZUY
      SUULUYPYDUYAUYTRXFUVMXCYCUUDVKXIUWGUYQUYHXGVHUULUYRUYHUULUWGUYQUVGUULUWGU
      YQUVGUUDXHTWCXJXKUULUYCUWFXCUUGSLZOZUYIOZUYIUULUYCUWFVUAUYIVIZVUCUULUYPYD
      UYCVUDRXFUVMXCYCUUGVKXIUWFVUAUYIXGVHUULVUBUYIUULUWFVUAUVKUULUWFVUAUVKUUGX
      HTWCXJXKXLWEWJYTUYAUYCXMVHYEUWSUXOUXTRUWTCYOUXJFWNTYEUXPUYBUXQUYDYEUXAUXP
      UYBRUXBCYOUXJDWNTYEUXCUXQUYDRUXDCYOUXJEWNTXLWEYOUXLUXMXNWPWRAUXNYNNZYDAUX
      LYNNZUXMYNNZVUEAUXHUVEVUFHGCXCYCDWTPAUXIUVIVUGJICXCYCEWTPUXLUXMXOPVAXBXP
      $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x V $.
    mbfneg.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    mbfneg.2 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    $( The negative of a measurable function is measurable.  (Contributed by
       Mario Carneiro, 31-Jul-2014.) $)
    mbfneg $p |- ( ph -> ( x e. A |-> -u B ) e. MblFn ) $=
      ( c1 cneg cmpt cmul co cmbf cvv cr cc wceq syl wcel a1i csn mbfmptcl eqid
      cxp cof cdm wf fmptd fdm dmexg eqeltrrd cv 1re renegcli fconstmpt offval2
      wa eqidd mulm1d mpteq2dva eqtrd mbfmulc2re ) ACHIZUAUDZBCDJZKUELZBCDIZJZM
      AVFBCVCDKLZJVHABCVCDKVDVENOEAVEUFZCNACPVEUGVJCQABCDPVEABCDEGFUBZVEUCUHZCP
      VEUIRAVEMSVJNSGVEMUJRUKVCOSZABULCSUQZHUMUNZTFVDBCVCJQABCVCUOTAVEURUPABCVI
      VGVNDVKUSUTVAACVCVEGVMAVOTVLVBUK $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y ph $.
    mbfpos.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    ${
      mbfpos.2 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
      $( The positive part of a measurable function is measurable.
         (Contributed by Mario Carneiro, 31-Jul-2014.) $)
      mbfpos $p |- ( ph -> ( x e. A |-> if ( 0 <_ B , B , 0 ) ) e. MblFn ) $=
        ( vy cv cc0 cfv cmpt cle wbr cif cmbf wcel wceq cr syl2anc nfcv csn cxp
        wa c0ex fvconst2 adantl simpr fvmpt2 breq12d ifbieq12d mpteq2dva wf 0re
        eqid fconst6 a1i cvol cc mbfdm2 recnd mbfconst fmptd nffvmpt1 nfbr nfif
        cdm fveq2 cbvmpt mbfmax eqeltrrd ) ABCBHZCIUAUBZJZVKBCDKZJZLMZVOVMNZKZB
        CIDLMZDINZKOABCVQVTAVKCPZUCZVPVSVOVMDIWBVMIVODLWAVMIQACIVKUDUEUFZWBWADR
        PVODQAWAUGEBCDRVNVNUNZUHSZUIWEWCUJUKAGCVLVNVRCRVLULACIRUMUOUPACUQVFPIUR
        PVLOPABCDRFEUSAIIRPAUMUPUTCIVASABCDRVNEWDVBFBGCVQGHZVLJZWFVNJZLMZWHWGNG
        VQTWIBWHWGBWGWHLBWGTZBLTBCDWFVCZVDWKWJVEVKWFQZVPWIVOVMWHWGWLVMWGVOWHLVK
        WFVLVGZVKWFVNVGZUIWNWMUJVHVIVJ $.
    $}

    ${
      mbfposr.2 $e |- ( ph ->
        ( x e. A |-> if ( 0 <_ B , B , 0 ) ) e. MblFn ) $.
      mbfposr.3 $e |- ( ph ->
        ( x e. A |-> if ( 0 <_ -u B , -u B , 0 ) ) e. MblFn ) $.
      $( Converse to ~ mbfpos .  (Contributed by Mario Carneiro,
         11-Aug-2014.) $)
      mbfposr $p |- ( ph -> ( x e. A |-> B ) e. MblFn ) $=
        ( cr cc0 cle wbr wcel wa 0re clt wb biantrurd sylan 3bitr4d ad2antrr vy
        cmpt eqid fmptd cif cv ifcl sylancl mbfdm2 ccnv cpnf cioo cima cvol cdm
        co cneg cmnf wal wceq cfv simplr simpllr lt0neg1d mpbid simpll renegcld
        ltnegd a1i maxlt syl3anc 3bitr4rd 3bitr3d rexrd elioomnf elioopnf simpr
        cxr syl fvmpt2 syl2anc eleq1d pm5.32da wf wfn ffn elpreima 3syl alrimiv
        nfmpt1 nfcnv nfcv nfima cleqf sylibr cmbf mbfima eqeltrrd bitr4d notbid
        wn maxle ltnled ltlecasei le0neg1d lenegd ismbf2d ) AUACBCDUBZABCDHXHEX
        HUCZUDZABCIDJKZDIUEZHFABUFZCLZMZDHLZIHLZXLHLZENXKDIHUGZUHZUIAUAUFZHLZMZ
        XHUJZYAUKULUPZUMZUNUOZLYAIYCYAIOKZMZBCIDUQZJKZYJIUEZUBZUJZURYAUQZULUPZU
        MZYFYGYIXMYQLZXMYFLZPZBUSYQYFUTYIYTBYIXNXMYMVAZYPLZMZXNXMXHVAZYELZMZYRY
        SYIXNUUBUUEYIXNMZYLYPLZDYELZUUBUUEUUGYLHLZYLYOOKZMZXPYADOKZMZUUHUUIUUGU
        UKUUMUULUUNUUGYJYOOKZIYOOKZUUOMZUUMUUKUUGUUPUUOUUGYHUUPYCYHXNVBUUGYAAYB
        YHXNVCZVDVEQUUGYADUURYIAXNXPAYBYHVFZERZVHUUGXQYJHLZYOHLZUUKUUQPXQUUGNVI
        UUGDUUTVGUUGYAUURVGZIYJYOVJVKVLUUGUUJUUKYIAXNUUJUUSXOUVAXQUUJXODEVGNYKY
        JIHUGUHZRQUUGXPUUMUUTQVMUUGYOVRLZUUHUULPUUGYOUVCVNYOYLVOVSUUGYAVRLZUUIU
        UNPZUUGYAUURVNYADVPZVSSYIAXNUUBUUHPUUSXOUUAYLYPXOXNUUJUUAYLUTAXNVQZUVDB
        CYLHYMYMUCZVTWAZWBRYIAXNUUEUUIPZUUSXOUUDDYEXOXNXPUUDDUTUVIEBCDHXHXIVTWA
        ZWBZRSWCAYRUUCPZYBYHACHYMWDZYMCWEZUVOABCYLHYMUVDUVJUDZCHYMWFZCXMYPYMWGW
        HTAYSUUFPZYBYHACHXHWDZXHCWEZUVTXJCHXHWFZCXMYEXHWGWHZTSWIBYQYFBYNYPBYMBC
        YLWJWKZBYPWLWMBYDYEBXHBCDWJWKZBYEWLZWMZWNWOAYQYGLZYBYHAYMWPLZUVPUWIGUVR
        CURYOYMWQWATWRYCIYAJKZMZBCXLUBZUJZYEUMZYFYGUWLXMUWOLZYSPZBUSUWOYFUTUWLU
        WQBUWLXNXMUWMVAZYELZMZUUFUWPYSUWLXNUWSUUEUWLXNMZXLYELZUUIUWSUUEUXAXRYAX
        LOKZMZUUNUXBUUIUXAUXCUUMUXDUUNUXAXLYAJKZXADYAJKZXAUXCUUMUXAUXEUXFUXAUXE
        UWKUXFMZUXFUXAXQXPYBUXEUXGPXQUXANVIUWLAXNXPAYBUWKVFZERZAYBUWKXNVCZIDYAX
        BVKUXAUWKUXFYCUWKXNVBQWSWTUXAYAXLUXJUXAXPXQXRUXINXSUHZXCUXAYADUXJUXIXCS
        UXAXRUXCUXKQUXAXPUUMUXIQVMUXAUVFUXBUXDPUXAYAUXJVNZYAXLVPVSUXAUVFUVGUXLU
        VHVSSUWLAXNUWSUXBPUXHXOUWRXLYEXOXNXRUWRXLUTUVIXTBCXLHUWMUWMUCZVTWAZWBRU
        WLAXNUVLUXHUVNRSWCAUWPUWTPZYBUWKACHUWMWDZUWMCWEZUXOABCXLHUWMXTUXMUDZCHU
        WMWFZCXMYEUWMWGWHTAUVTYBUWKUWDTSWIBUWOYFBUWNYEBUWMBCXLWJWKZUWGWMUWHWNWO
        AUWOYGLZYBUWKAUWMWPLZUXPUYAFUXRCYAUKUWMWQWATWRAYBVQZXQYCNVIZXDYCYDURYAU
        LUPZUMZYGLIYAYCIYAOKZMZUWNUYEUMZUYFYGUYHXMUYILZXMUYFLZPZBUSUYIUYFUTUYHU
        YLBUYHXNUWRUYELZMZXNUUDUYELZMZUYJUYKUYHXNUYMUYOUYHXNMZXLUYELZDUYELZUYMU
        YOUYQXRXLYAOKZMZXPDYAOKZMZUYRUYSUYQUYTVUBVUAVUCUYQUYTUYGVUBMZVUBUYQXQXP
        YBUYTVUDPXQUYQNVIUYHAXNXPAYBUYGVFZERZAYBUYGXNVCZIDYAVJVKUYQUYGVUBYCUYGX
        NVBQWSUYQXRUYTUYHAXNXRVUEXTRQUYQXPVUBVUFQVMUYQUVFUYRVUAPUYQYAVUGVNZYAXL
        VOVSUYQUVFUYSVUCPZVUHYADVOZVSSUYHAXNUYMUYRPVUEXOUWRXLUYEUXNWBRUYHAXNUYO
        UYSPZVUEXOUUDDUYEUVMWBZRSWCAUYJUYNPZYBUYGAUXPUXQVUMUXRUXSCXMUYEUWMWGWHT
        AUYKUYPPZYBUYGAUWAUWBVUNXJUWCCXMUYEXHWGWHZTSWIBUYIUYFBUWNUYEUXTBUYEWLZW
        MBYDUYEUWFVUPWMZWNWOAUYIYGLZYBUYGAUYBUXPVURFUXRCURYAUWMWQWATWRYCYAIJKZM
        ZYNYOUKULUPZUMZUYFYGVUTXMVVBLZUYKPZBUSVVBUYFUTVUTVVDBVUTXNUUAVVALZMZUYP
        VVCUYKVUTXNVVEUYOVUTXNMZYLVVALZUYSVVEUYOVVGUUJYOYLOKZMZVUCVVHUYSVVGVVIV
        UBVVJVUCVVGYLYOJKZXAYADJKZXAVVIVUBVVGVVKVVLVVGYJYOJKZIYOJKZVVMMZVVLVVKV
        VGVVNVVMVVGVUSVVNYCVUSXNVBVVGYAAYBVUSXNVCZXEVEQVVGYADVVPVUTAXNXPAYBVUSV
        FZERZXFVVGXQUVAUVBVVKVVOPXQVVGNVIVVGDVVRVGVVGYAVVPVGZIYJYOXBVKVLWTVVGYO
        YLVVSVUTAXNUUJVVQUVDRZXCVVGDYAVVRVVPXCSVVGUUJVVIVVTQVVGXPVUBVVRQVMVVGUV
        EVVHVVJPVVGYOVVSVNYOYLVPVSVVGUVFVUIVVGYAVVPVNVUJVSSVUTAXNVVEVVHPVVQXOUU
        AYLVVAUVKWBRVUTAXNVUKVVQVULRSWCAVVCVVFPZYBVUSAUVPUVQVWAUVRUVSCXMVVAYMWG
        WHTAVUNYBVUSVUOTSWIBVVBUYFBYNVVAUWEBVVAWLWMVUQWNWOAVVBYGLZYBVUSAUWJUVPV
        WBGUVRCYOUKYMWQWATWRUYDUYCXDXG $.
    $}

    $( A function is measurable iff its positive and negative parts are
       measurable.  (Contributed by Mario Carneiro, 11-Aug-2014.) $)
    mbfposb $p |- ( ph -> ( ( x e. A |-> B ) e. MblFn <->
      ( ( x e. A |-> if ( 0 <_ B , B , 0 ) ) e. MblFn /\
        ( x e. A |-> if ( 0 <_ -u B , -u B , 0 ) ) e. MblFn ) ) ) $=
      ( vy cmpt cmbf wcel cc0 cle wbr cif wa wceq nfcv breq2d ifbieq12d adantr
      cr cneg cv cfv nffvmpt1 nfbr nfif fveq2 eqidd cbvmpt simpr fvmpt2 syl2anc
      mpteq2dva syl5eq wf fmptd ffvelrnda eleq1d biimpar mbfpos eqeltrrd negeqd
      eqid nfneg renegcld mbfneg adantlr simprl eqeltrd simprr mbfposr impbida
      jca ) ABCDGZHIZBCJDKLZDJMZGZHIZBCJDUAZKLZVTJMZGZHIZNZAVONZVSWDWFFCJFUBZVN
      UCZKLZWHJMZGZVRHAWKVROZVOAWKBCJBUBZVNUCZKLZWNJMZGVRFBCWJWPWIBWHJBJWHKBJPZ
      BKPZBCDWGUDZUEWSWQUFFWPPWGWMOZWIWOWHJWNJWTWHWNJKWGWMVNUGZQXAWTJUHZRUIABCW
      PVQAWMCIZNZWOVPWNJDJXDWNDJKXDXCDTIWNDOAXCUJEBCDTVNVNVCZUKULZQXFXDJUHZRUMU
      NZSWFFCWHWFCTWGVNACTVNUOVOABCDTVNEXEUPZSUQZAFCWHGZHIVOAXKVNHAXKBCWNGVNFBC
      WHWNWSFWNPXAUIABCWNDXFUMUNZURUSZUTVAWFFCJWHUAZKLZXNJMZGZWCHAXQWCOZVOAXQBC
      JWNUAZKLZXSJMZGWCFBCXPYAXOBXNJBJXNKWQWRBWHWSVDZUEYBWQUFFYAPWTXOXTXNJXSJWT
      XNXSJKWTWHWNXAVBZQYCXBRUIABCYAWBXDXTWAXSJVTJXDXSVTJKXDWNDXFVBZQYDXGRUMUNZ
      SWFFCXNWFWGCIZNWHXJVEWFFCWHTXJXMVFUTVAVMAWENZXKVNHAXKVNOWEXLSYGFCWHAYFWHT
      IWEACTWGVNXIUQVGYGWKVRHAWLWEXHSAVSWDVHVIYGXQWCHAXRWEYESAVSWDVJVIVKVAVL $.
  $}

  ${
    $d u v w x y z F $.  $d x y z ph $.
    ismbf3d.1 $e |- ( ph -> F : A --> RR ) $.
    ismbf3d.2 $e |- ( ( ph /\ x e. RR ) ->
                     ( `' F " ( x (,) +oo ) ) e. dom vol ) $.
    $( Simplified form of ~ ismbfd .  (Contributed by Mario Carneiro,
       18-Jun-2014.) $)
    ismbf3d $p |- ( ph -> F e. MblFn ) $=
      ( vy cr cima wceq syl cn cpnf cioo co wcel clt wbr wa cmnf vz vu ccnv cdm
      vv vw cvol wf fimacnv cneg ciun imaiun wss wral ioossre rgenw iunss mpbir
      cv wrex renegcl arch simpl biantrurd ltnegcon1 sylan2 cxr adantl renegcld
      wb rexrd elioopnf 3bitr4d rexbidva mpbid eliun sylibr ssriv eqssi imaeq2i
      nnre eqtr3i ralrimiva oveq1 imaeq2d eleq1d rspccva syl2an iunmbl eqeltrrd
      syl5eqelr cdiv cmin cioc cle w3a 3simpb simplr crp nnrp ad2antrl rpreccld
      c1 wi ltsubrpd simprr simpr nnrecre resubcl adantrr lelttr syl3anc mpan2d
      anassrs imdistanda syl5 mnfxr elioc2 sylancr rexr elioomnf adantr 3imtr4d
      rexlimdva sylibd simprl resubcld posdifd syl2anc mnflt ad2ant2r cdif wfun
      cc0 ad2antrr cun a1i pnfxr cin c0 nnrecl ltsub13d mpbir3and expr reximdva
      ltled mpd ex impbid bitr4d syl5bb eqrdv syl5eqr ffun funcnvcnv 4syl ltpnf
      imadif df-ioc df-ioo xrltnle xrlelttr xrlttr ixxun syl32anc uncom 3eqtr3g
      ioomax incom ixxdisj mp3an13 syl5eq uneqdifeq eqtr3d rspcv difmbl cbvralv
      sylc oveq2 sylib r19.21bi ismbf2d ) ABCDEADUCZHIZCUGUDZACHDUHZUWDCJECHDUI
      KAUWDGLUWCGUSZUJZMNOZIZUKZUWEUWCGLUWIUKZIUWKUWDGUWCLUWIULUWLHUWCUWLHUWLHU
      MUWIHUMZGLUNUWMGLUWHMUOUPGLUWIHUQURUAHUWLUAUSZHPZUWNUWIPZGLUTZUWNUWLPUWOU
      WNUJZUWGQRZGLUTZUWQUWOUWRHPUWTUWNVAUWRGVBKUWOUWSUWPGLUWOUWGLPZSZUWHUWNQRZ
      UWOUXCSZUWSUWPUXBUWOUXCUWOUXAVCVDUXAUWOUWGHPZUWSUXCVJUWGWAZUWNUWGVEVFUXBU
      WHVGPUWPUXDVJUXBUWHUXBUWGUXAUXEUWOUXFVHVIVKUWHUWNVLKVMVNVOGUWNLUWIVPVQVRV
      SVTWBAUWJUWEPZGLUNUWKUWEPAUXGGLAUWCBUSZMNOZIZUWEPZBHUNZUWHHPUXGUXAAUXKBHF
      WCZUXAUWGUXFVIUXKUXGBUWHHUXHUWHJZUXJUWJUWEUXNUXIUWIUWCUXHUWHMNWDWEWFWGWHW
      CUWJGWIKWKZWJFAUWCTUXHNOZIZUWEPZBHAUWCTUWNNOZIZUWEPZUAHUNUXRBHUNAUYAUAHAU
      WOSZGLUWCTUWNXCUWGWLOZWMOZWNOZIZUKZUXTUWEUYBUYGUWCGLUYEUKZIUXTGUWCLUYEULU
      YBUYHUXSUWCUYBBUYHUXSUXHUYHPUXHUYEPZGLUTZUYBUXHUXSPZGUXHLUYEVPUYBUYJUXHHP
      ZUXHUWNQRZSZUYKUYBUYJUYNUYBUYJUYKUYNUYBUYIUYKGLUYBUXASZUYLTUXHQRZUXHUYDWO
      RZWPZUYNUYIUYKUYRUYLUYQSUYOUYNUYLUYPUYQWQUYOUYLUYQUYMUYBUXAUYLUYQUYMXDUYB
      UXAUYLSZSZUYQUYDUWNQRZUYMUYTUWNUYCAUWOUYSWRZUYTUWGUXAUWGWSPUYBUYLUWGWTXAX
      BXEUYTUYLUYDHPZUWOUYQVUASUYMXDUYBUXAUYLXFUYBUXAVUCUYLUYBUWOUYCHPZVUCUXAAU
      WOXGUWGXHZUWNUYCXIWHZXJVUBUXHUYDUWNXKXLXMXNXOXPUYOTVGPZVUCUYIUYRVJZXQVUFT
      UYDUXHXRXSZUYBUYKUYNVJZUXAUYBUWNVGPZVUJUWOVUKAUWNXTVHUWNUXHYAKZYBYCYDVULY
      EUYBUYNUYJUYBUYNSZUYCUWNUXHWMOZQRZGLUTZUYJVUMVUNHPYNVUNQRZVUPVUMUWNUXHAUW
      OUYNWRZUYBUYLUYMYFZYGVUMUYMVUQUYBUYLUYMXFVUMUXHUWNVUSVURYHVOVUNGUUAYIVUMV
      UOUYIGLVUMUXAVUOUYIVUMUXAVUOSZSZUYIUYLUYPUYQVUMUYLVUTVUSYBZVVAUYLUYPVVBUX
      HYJKVVAUXHUYDVVBUYBUXAVUCUYNVUOVUFYKVVAUYCUWNUXHUXAVUDVUMVUOVUEXAVUMUWOVU
      TVURYBVVBVUMUXAVUOXFUUBUUFUYBUXAVUHUYNVUOVUIYKUUCUUDUUEUUGUUHUUIVULUUJUUK
      UULWEUUMUYBUYFUWEPZGLUNUYGUWEPUYBVVCGLUYOUWDUWCUYDMNOZIZYLZUYFUWEUYOUWCHV
      VDYLZIZVVFUYFUYOUWFDYMUWCUCYMVVHVVFJAUWFUWOUXAEYOCHDUUNDUUOHVVDUWCUURUUPU
      YOVVGUYEUWCUYOVVDUYEYPZHJZVVGUYEJZUYOUYEVVDYPZTMNOZVVIHUYOVUGUYDVGPZMVGPZ
      TUYDQRZUYDMQRZVVLVVMJVUGUYOXQYQUYOUYDVUFVKZVVOUYOYRYQUYOVUCVVPVUFUYDYJKUY
      OVUCVVQVUFUYDUUQKUBUEUFBTUYDMNNQWOQQWNQQUBUEUFUUSZUBUEUFUUTZUYDUXHUVAZVVT
      UXHUYDMUVBTUYDUXHUVCUVDUVEUYEVVDUVFUVHUVGUYOVVDHUMVVDUYEYSZYTJVVJVVKVJUYD
      MUOUYOVWBUYEVVDYSZYTVVDUYEUVIUYOVVNVWCYTJZVVRVUGVVNVVOVWDXQYRUBUEUFBTUYDM
      NQWOQQWNVVSVVTVWAUVJUVKKUVLVVDUYEHUVMXSVOWEUVNUYOUWDUWEPZVVEUWEPZVVFUWEPA
      VWEUWOUXAUXOYOUYOVUCUXLVWFVUFAUXLUWOUXAUXMYOUXKVWFBUYDHUXHUYDJZUXJVVEUWEV
      WGUXIVVDUWCUXHUYDMNWDWEWFUVOUVRUWDVVEUVPYIWJWCUYFGWIKWJWCUYAUXRUABHUWNUXH
      JZUXTUXQUWEVWHUXSUXPUWCUWNUXHTNUVSWEWFUVQUVTUWAUWB $.
  $}

  ${
    $d t u x A $.  $d u x y z B $.  $d u C $.  $d t u w x y z F $.  $d t w K $.
    $d t w x y z G $.  $d t u x y J $.
    mbfimaopn.1 $e |- J = ( TopOpen ` CCfld ) $.
    ${
      mbfimaopn.2 $e |- G = ( x e. RR , y e. RR |-> ( x + ( _i x. y ) ) ) $.
      mbfimaopn.3 $e |- B = ( (,) " ( QQ X. QQ ) ) $.
      mbfimaopn.4 $e |- K = ran ( x e. B , y e. B |-> ( x X. y ) ) $.
      $( Lemma for ~ mbfimaopn .  (Contributed by Mario Carneiro,
         25-Aug-2014.) $)
      mbfimaopnlem $p |- ( ( F e. MblFn /\ A e. J ) ->
        ( `' F " A ) e. dom vol ) $=
        ( wcel wa cima mp2an cc cn cdom wbr vt vw vz cmbf cv wss ccnv cuni wceq
        cvol cdm wex ctg cfv cioo crn ctx ccn chmeo cnrehmeo hmeocn ax-mp cnima
        co eqid cq cxp fveq2i tgqioo oveq12i ctb qtopbas eqeltri txbasval txval
        mpan 3eqtri syl6eleq wb txbas eltg3 sylib adantl ciun cr wfo wf1o f1ofo
        cnref1o elssuni cnfldtopon toponunii syl6sseqr ad2antlr foimacnv simprr
        sylancr imaeq2d syl6eq com cen omelon nnenom isnumi qnnen xpnnen cxr wf
        wral ioof fodomnum mp2 eqbrtri domentr wfn vex wrex eleq2i cre ccom cim
        domtr adantr fvco3 sylan eleq1d anbi12d cop fveq2 syl elpreima fco 3syl
        ffn ismbf mpbid sseldi rsp sylc syl2anc imauni eqtr3d imaiun cmpt2 ccrd
        wi ssdomg con0 ensymi cres xpen entri entr2i wfun cpw ffun qssre ressxr
        sstri xpss12 fdmi sseqtr4i fores xpdom1 nnex xpdom2 numdom xpex fnmpt2i
        elexi dffn4 mpbi sylancl ad2antrl elrnmpt2 bitri elin ffvelrnda opeq12d
        cin mbff opex fvmpt biantrurd bitr3d opelxp f1ocnv f1ofn mp2b imacnvcnv
        cnrecnv bitr3i 3bitr3g bitrd pm5.32da ref anandi syl6bbr 3bitr4d syl5bb
        imf eqrdv ismbfcn ibi simpld imassrn eqsstri simprl simprd inmbl imaeq2
        eqeltrrd syl5ibrcom rexlimdvva syl5bi ralrimiv ad2ant2r iunmbl2 eqeltrd
        ssralv mpan9 exlimddv ) EUDMZCGMZNZUAUEZHUFZFUGZCOZUYFUHZUIZNZEUGZCOZUJ
        UKZMUAUYDUYLUAULZUYCUYDUYIHUMUNZMZUYPUYDUYIUOUPZUMUNZUYTUQVDZUYQFVUAGUR
        VDMZUYDUYIVUAMFVUAGUSVDMVUBABFUYTGJUYTVEIUTFVUAGVAVBCFVUAGVCVPVUADUMUNZ
        VUCUQVDZDDUQVDZUYQUYTVUCUYTVUCUQVUCDUOVFVFVGZOZUMKVHVIZVUHVJDVKMZVUIVUD
        VUEUIDVUGVKKVLVMZVUJDDVKVKVNPVUIVUIVUEUYQUIVUJVUJABHDDVKVKLVOPVQVRHVKMZ
        UYRUYPVSVUIVUIVUKVUJVUJABHDDLVTPZUAUYIHVKWAVBWBWCUYEUYLNZUYNUBUYFUYMFUB
        UEZOZOZWDZUYOVUMUYNUYMUBUYFVUOWDZOVUQVUMCVURUYMVUMFUYIOZCVURVUMWEWEVGZQ
        FWFZCQUFZVUSCUIVUTQFWGZVVAABFJWIZVUTQFWHVBUYDVVBUYCUYLUYDCGUHQCGWJQGGIW
        KWLWMWNVUTQCFWOWQVUMVUSFUYJOVURVUMUYIUYJFUYEUYGUYKWPWRUBFUYFUUAWSUUBWRU
        BUYMUYFVUOUUCWSVUMUYFRSTZVUPUYOMZUBUYFXIZVUQUYOMUYGVVEUYEUYKUYGUYFHSTZH
        RSTVVEVUKUYGVVHUUFVULUYFHVKUUGVBHABDDAUEZBUEZVGZUUDZUPZRSLVVMDDVGZSTZVV
        NRSTZVVMRSTVVNUUEUKZMZVVNVVMVVLWFZVVORVVQMZVVPVVRWTUUHMZWTRXATVVTXBRWTX
        CUUIWTRXDPVVNRRVGZSTZVWBRXATVVPVVNRDVGZSTZVWDVWBSTZVWCDRSTZVWEDVUFSTVUF
        RXATVWGDVUGVUFSKVUFVVQMZVUFVUGUOVUFUUJZWFZVUGVUFSTVWAWTVUFXATVWHXBVUFRW
        TVUFVWBRVFRXATZVWKVUFVWBXATXEXEVFRVFRUUKPXFUULZXCUUMWTVUFXDPUOUUNZVUFUO
        UKZUFVWJXGXGVGZWEUUOZUOXHVWMXJVWOVWPUOUUPVBVUFVWOVWNVFXGUFZVWQVUFVWOUFV
        FWEXGUUQUURUUSZVWRVFXGVFXGUUTPVWOVWPUOXJUVAUVBVUFUOUVCPVUFVUGVWIXKXLXMV
        WLDVUFRXNPZDRDDVKVUJUVJUVDVBVWGVWFVWSDRRUVEUVFVBVVNVWDVWBYBPXFVVNVWBRXN
        PZRVVNUVGPVVLVVNXOVVSABDDVVKVVLVVLVEZVVIVVJAXPBXPUVHZUVIVVNVVLUVKUVLVVN
        VVMVVLXKXLVWTVVMVVNRYBPXMUYFHRYBUVMUVNUYCUYGVVGUYDUYKUYCVVFUBHXIUYGVVGU
        YCVVFUBHVUNHMZVUNVVKUIZBDXQADXQZUYCVVFVXCVUNVVMMVXEHVVMVUNLXRABDDVVKVUN
        VVLVXAVXBUVOUVPUYCVXDVVFABDDUYCVVIDMZVVJDMZNZNZVVFVXDUYMFVVKOZOZUYOMVXI
        XSEXTZUGVVIOZYAEXTZUGVVJOZUVTZVXKUYOVXIUCVXPVXKUCUEZVXPMVXQVXMMZVXQVXOM
        ZNZVXIVXQVXKMZVXQVXMVXOUVQVXIVXQEUKZMZVXQVXLUNZVVIMZVXQVXNUNZVVJMZNZNZV
        YCVXQEUNZVXJMZNZVXTVYAVXIVYCVYHVYKVXIVYCNZVYHVYJXSUNZVVIMZVYJYAUNZVVJMZ
        NZVYKVYMVYEVYOVYGVYQVYMVYDVYNVVIVXIVYBQEXHZVYCVYDVYNUIUYCVYSVXHEUWAZYCZ
        VYBQVXQXSEYDYEYFVYMVYFVYPVVJVXIVYSVYCVYFVYPUIWUAVYBQVXQYAEYDYEYFYGVYMVY
        NVYPYHZVVKMZVYJQMZVYJUYHUNZVVKMZNZVYRVYKVYMWUFWUCWUGVYMWUEWUBVVKVYMWUDW
        UEWUBUIVXIVYBQVXQEWUAUVRZUBVYJVUNXSUNZVUNYAUNZYHWUBQUYHVUNVYJUIWUIVYNWU
        JVYPVUNVYJXSYIVUNVYJYAYIUVSABUBFJUWKVYNVYPUWBUWCYJYFVYMWUDWUFWUHUWDUWEV
        YNVYPVVIVVJUWFWUGVYJUYHUGVVKOZMZVYKUYHQXOZWULWUGVSVVCQVUTUYHWGWUMVVDVUT
        QFUWGQVUTUYHUWHUWIQVYJVVKUYHYKVBWUKVXJVYJFVVKUWJXRUWLUWMUWNUWOUYCVXTVYI
        VSVXHUYCVXTVYCVYENZVYCVYGNZNVYIUYCVXRWUNVXSWUOUYCVYBWEVXLXHZVXLVYBXOVXR
        WUNVSUYCQWEXSXHVYSWUPUWPVYTVYBQWEXSEYLWQZVYBWEVXLYNVYBVXQVVIVXLYKYMUYCV
        YBWEVXNXHZVXNVYBXOVXSWUOVSUYCQWEYAXHVYSWURUXAVYTVYBQWEYAEYLWQZVYBWEVXNY
        NVYBVXQVVJVXNYKYMYGVYCVYEVYGUWQUWRYCUYCVYAVYLVSZVXHUYCVYSEVYBXOWUTVYTVY
        BQEYNVYBVXQVXJEYKYMYCUWSUWTUXBVXIVXMUYOMZVXOUYOMZVXPUYOMVXIWVAAUYSXIZVV
        IUYSMWVAUYCWVCVXHUYCVXLUDMZWVCUYCWVDVXNUDMZUYCWVDWVENZUYCVYSUYCWVFVSVYT
        VYBEUXCYJUXDZUXEUYCWUPWVDWVCVSWUQAVYBVXLYOYJYPYCVXIDUYSVVIDVUGUYSKUOVUF
        UXFUXGZUYCVXFVXGUXHYQWVAAUYSYRYSVXIWVBBUYSXIZVVJUYSMWVBUYCWVIVXHUYCWVEW
        VIUYCWVDWVEWVGUXIUYCWURWVEWVIVSWUSBVYBVXNYOYJYPYCVXIDUYSVVJWVHUYCVXFVXG
        WPYQWVBBUYSYRYSVXMVXOUXJYTUXLVXDVUPVXKUYOVXDVUOVXJUYMVUNVVKFUXKWRYFUXMU
        XNUXOUXPVVFUBUYFHUXTUYAUXQUYFVUPUBUXRYTUXSUYB $.
    $}

    $( The preimage of any open set (in the complex topology) under a
       measurable function is measurable.  (See also ~ cncombf , which explains
       why ` A e. dom vol ` is too weak a condition for this theorem.)
       (Contributed by Mario Carneiro, 25-Aug-2014.) $)
    mbfimaopn $p |- ( ( F e. MblFn /\ A e. J ) -> ( `' F " A ) e. dom vol ) $=
      ( vx vy vt vw cioo cq cxp cima cr cv ci cmul co caddc cmpt2 eqid cbvmpt2v
      crn oveq1 weq oveq2 oveq2d mbfimaopnlem ) EFAIJJKLZBGHMMGNZOHNZPQZRQZSCEF
      UHUHENZFNZKSUBZDGHEFMMULUMOUNPQZRQUMUKRQUIUMUKRUCHFUDUKUPUMRUJUNOPUEUFUAU
      HTUOTUG $.

    mbfimaopn2.2 $e |- K = ( J |`t B ) $.
    $( The preimage of any set open in the subspace topology of the range of
       the function is measurable.  (Contributed by Mario Carneiro,
       25-Aug-2014.) $)
    mbfimaopn2 $p |- ( ( ( F e. MblFn /\ F : A --> B /\ B C_ CC ) /\
      C e. K ) -> ( `' F " C ) e. dom vol ) $=
      ( vu cmbf wcel cc cima cdm cin wceq ctop cvv syl eqeltrd wf wss ccnv cvol
      w3a cv wrex crest co eleq2i wb cnfldtop simp3 cnex sylancl elrest sylancr
      ssexg syl5bb wa wfun simpl2 ffun inpreima mbfimaopn 3ad2antl1 fimacnv fdm
      3syl eqtr4d simpl1 mbfdm inmbl syl2anc imaeq2 eleq1d syl5ibrcom rexlimdva
      sylbid imp ) DJKZABDUAZBLUBZUEZCFKZDUCZCMZUDNZKZWDWECIUFZBOZPZIEUGZWIWECE
      BUHUIZKZWDWMFWNCHUJWDEQKBRKZWOWMUKEGULWDWCLRKWPWAWBWCUMUNBLRURUOICBEQRUPU
      QUSWDWLWIIEWDWJEKZUTZWIWLWFWKMZWHKWRWSWFWJMZWFBMZOZWHWRWBDVAWSXBPWAWBWCWQ
      VBZABDVCWJBDVDVIWRWTWHKZXAWHKXBWHKWAWBWQXDWCWJDEGVEVFWRXADNZWHWRWBXAXEPXC
      WBXAAXEABDVGABDVHVJSWRWAXEWHKWAWBWCWQVKDVLSTWTXAVMVNTWLWGWSWHCWKWFVOVPVQV
      RVSVT $.
  $}

  ${
    $d g x A $.  $d g x B $.  $d g x F $.  $d g x G $.
    $( The composition of a continuous function with a measurable function is
       measurable.  (More generally, ` G ` can be a Borel-measurable function,
       but notably the condition that ` G ` be only measurable is too weak, the
       usual counterexample taking ` G ` to be the Cantor function and ` F `
       the indicator function of the ` G ` -image of a nonmeasurable set, which
       is a subset of the Cantor set and hence null and measurable.)
       (Contributed by Mario Carneiro, 25-Aug-2014.) $)
    cncombf $p |- ( ( F e. MblFn /\ F : A --> B /\ G e. ( B -cn-> CC ) ) ->
                    ( G o. F ) e. MblFn ) $=
      ( vx vg wcel wf cc co ccom cr cre ccnv cima cim wa wss wceq cvv ccncf w3a
      cmbf cpm cv cvol cdm cioo crn simp3 cncff syl simp2 fco syl2anc fdm mbfdm
      wral 3ad2ant1 eqeltrrd mblss cnex elpm2r mpanl12 recncf a1i cncfco adantr
      reex cnvco imaeq1i imaco eqtri ccnfld ctopn crest simplll simpllr cncfrss
      cfv adantl ctg ccn simpr ax-resscn eqid tgioo2 cncfcn sylancl eleqtrd ctb
      retopbas bastg ax-mp simplr sseldi mbfimaopn2 syl31anc syl5eqel ralrimiva
      cnima 3adantl3 coeq1 coass syl6eq cnveqd imaeq1d eleq1d rspcv sylc imcncf
      jca ismbf1 sylanbrc ) CUCGZABCHZDBIUAJGZUBZDCKZILUDJGZMXSKZNZEUEZOZUFUGZG
      ZPXSKZNZYCOZYEGZQZEUHUIZURXSUCGXRAIXSHZALRZXTXRBIDHZXPYMXRXQYOXOXPXQUJZBI
      DUKULXOXPXQUMZABIDCUNUOXRAYEGYNXRCUGZAYEXRXPYRASYQABCUPULXOXPYRYEGXQCUQUS
      UTAVAULITGLTGYMYNQXTVBVIILAXSTTVCVDUOXRYKEYLXRYCYLGZQZYFYJYTMDKZBLUAJZGZF
      UEZCKZNZYCOZYEGZFUUBURZYFXRUUCYSXRBILDMYPMILUAJZGXRVEVFVGVHXOXPYSUUIXQXOX
      PQZYSQZUUHFUUBUULUUDUUBGZQZUUGCNZUUDNZYCOZOZYEUUGUUOUUPKZYCOUURUUFUUSYCUU
      DCVJVKUUOUUPYCVLVMUUNXOXPBIRZUUQVNVOVTZBVPJZGZUURYEGXOXPYSUUMVQXOXPYSUUMV
      RUUMUUTUULBLUUDVSWAZUUNUUDUVBYLWBVTZWCJZGYCUVEGUVCUUNUUDUUBUVFUULUUMWDUUN
      UUTLIRUUBUVFSUVDWEBLUVAUVBUVEUVAWFZUVBWFZUVAUVGWGWHWIWJUUNYLUVEYCYLWKGYLU
      VERWLYLWKWMWNUUKYSUUMWOWPYCUUDUVBUVEXAUOABUUQCUVAUVBUVGUVHWQWRWSWTXBZUUHY
      FFUUAUUBUUDUUASZUUGYDYEUVJUUFYBYCUVJUUEYAUVJUUEUUACKYAUUDUUACXCMDCXDXEXFX
      GXHXIXJYTPDKZUUBGZUUIYJXRUVLYSXRBILDPYPPUUJGXRXKVFVGVHUVIUUHYJFUVKUUBUUDU
      VKSZUUGYIYEUVMUUFYHYCUVMUUEYGUVMUUEUVKCKYGUUDUVKCXCPDCXDXEXFXGXHXIXJXLWTE
      XSXMXN $.
  $}

  ${
    $d x A $.  $d x F $.
    $( A continuous function is measurable.  (Contributed by Mario Carneiro,
       18-Jun-2014.)  (Revised by Mario Carneiro, 26-Mar-2015.) $)
    cnmbf $p |- ( ( A e. dom vol /\ F e. ( A -cn-> CC ) ) ->
                    F e. MblFn ) $=
      ( vx wcel cc ccncf co cre ccom ccnv cima cim wss cvv cfv ccn eqid syl2anc
      wa cr cvol cdm cpm cv cioo crn wral cmbf wf cncff mblss cnex reex mpanl12
      elpm2r syl2anr ctg crest simpll simplr recncf cncfco ccnfld wceq ad2antrr
      a1i ctopn ax-resscn syl6ss tgioo2 cncfcn sylancl rerest syl eqtrd eleqtrd
      oveq1d retopbas bastg ax-mp simpr sseldi cnima subopnmbl imcncf ralrimiva
      ctb jca ismbf1 sylanbrc ) AUAUBZDZBAEFGDZSZBETUCGDZHBIZJCUDZKZWKDZLBIZJWQ
      KZWKDZSZCUEUFZUGBUHDWMAEBUIZATMZWOWLAEBUJAUKZENDTNDXEXFSWOULUMETABNNUOUNU
      PWNXCCXDWNWQXDDZSZWSXBXIWLWRXDUQOZAURGZDZWSWLWMXHUSZXIWPXKXJPGZDWQXJDZXLX
      IWPATFGZXNXIAETBHWLWMXHUTZHETFGZDXIVAVFVBXIXPVCVGOZAURGZXJPGZXNXIAEMTEMXP
      YAVDXIATEWLXFWMXHXGVEZVHVIVHATXSXTXJXSQZXTQXSYCVJVKVLXIXTXKXJPXIXFXTXKVDY
      BAXJXSYCXJQVMVNVQVOZVPXIXDXJWQXDWGDXDXJMVRXDWGVSVTWNXHWAWBZWQWPXKXJWCRAWR
      XKXKQZWDRXIWLXAXKDZXBXMXIWTXNDXOYGXIWTXPXNXIAETBLXQLXRDXIWEVFVBYDVPYEWQWT
      XKXJWCRAXAXKYFWDRWHWFCBWIWJ $.
  $}

  ${
    $d r A $.  $d r x y F $.  $d r x y G $.  $d r x y ph $.
    mbfadd.1 $e |- ( ph -> F e. MblFn ) $.
    mbfadd.2 $e |- ( ph -> G e. MblFn ) $.
    ${
      mbfadd.3 $e |- ( ph -> F : A --> RR ) $.
      mbfadd.4 $e |- ( ph -> G : A --> RR ) $.
      $( The sum of two measurable functions is measurable.  (Contributed by
         Mario Carneiro, 15-Aug-2014.) $)
      mbfaddlem $p |- ( ph -> ( F oF + G ) e. MblFn ) $=
        ( vr caddc co cr wcel wa syl cq clt wbr adantr wb vy vx cof cvol cdm cv
        readdcl adantl wf wceq fdm cmbf mbfdm eqeltrrd inidm off ccnv cpnf cioo
        cima cmin cin ciun eliun cfv r19.42v simplr ffvelrnda ltsubaddd ltsub23
        wrex syl3anc anbi2d ancom syl6bb rexbidva wi resubcld rexlimdva qbtwnre
        qre lttr 3expia syl2anc impbid bitrd wfn ffn eqidd ofval breq2d 3bitr4d
        rexrd elioopnf biantrurd bitr4d anbi12d pm5.32da syl5bb elpreima anandi
        cxr elin 3bitr4g rexbidv eqrdv cn cdom wral cen qnnen endom ax-mp inmbl
        mbfima ad2antrr ralrimiva iunmbl2 sylancr ismbf3d ) AUABCDJUCKZAUBUABBB
        JLLLCDUDUEZYBUBUFZLMUAUFZLMZNYCYDJKLMAYCYDUGUHGHACUEZBYBABLCUIZYFBUJGBL
        CUKOACULMZYFYBMECUMOUNZYIBUOZUPZAYENZIPCUQIUFZURUSKZUTZDUQYDYMVAKZURUSK
        ZUTZVBZVCZYAUQYDURUSKZUTZYBYLUBYTUUBYCYTMYCYSMZIPVKZYLYCUUBMZIYCPYSVDYL
        YCBMZYCCVEZYNMZYCDVEZYQMZNZNZIPVKZUUFYCYAVEZUUAMZNZUUDUUEUUMUUFUUKIPVKZ
        NYLUUPUUFUUKIPVFYLUUFUUQUUOYLUUFNZYMUUGQRZYPUUIQRZNZIPVKZYDUUNQRZUUQUUO
        UURYDUUIVAKZUUGQRZYDUUGUUIJKZQRUVBUVCUURYDUUIUUGAYEUUFVGZYLBLYCDABLDUIZ
        YEHSVHZYLBLYCCAYGYEGSVHZVIUURUVBUVDYMQRZUUSNZIPVKZUVEUURUVAUVLIPUURYMPM
        ZNZUVAUUSUVKNUVLUVOUUTUVKUUSUVOYEYMLMZUUILMZUUTUVKTUURYEUVNUVGSZUVNUVPU
        URYMWAUHZUURUVQUVNUVISZYDYMUUIVJVLVMUUSUVKVNVOVPUURUVMUVEUURUVLUVEIPUVO
        UVDLMZUVPUUGLMZUVLUVEVQUURUWAUVNUURYDUUIUVGUVIVRZSUVSUURUWBUVNUVJSZUVDY
        MUUGWBVLVSUURUWAUWBUVEUVMVQUWCUVJUWAUWBUVEUVMIUVDUUGVTWCWDWEWFUURUUNUVF
        YDQYLBBUUGUUIJBCDYBYBYCACBWGZYEAYGUWEGBLCWHOSZADBWGZYEAUVHUWGHBLDWHOSZA
        BYBMYEYISZUWIYJUURUUGWIUURUUIWIWJWKWLUURUUKUVAIPUVOUUHUUSUUJUUTUVOUUHUW
        BUUSNZUUSUVOYMXBMUUHUWJTUVOYMUVSWMYMUUGWNOUVOUWBUUSUWDWOWPUVOUUJUVQUUTN
        ZUUTUVOYPXBMUUJUWKTUVOYPUVOYDYMUVRUVSVRWMYPUUIWNOUVOUVQUUTUVTWOWPWQVPUU
        RUUOUUNLMZUVCNZUVCUURYDXBMUUOUWMTUURYDUVGWMYDUUNWNOUURUWLUVCYLBLYCYAABL
        YAUIZYEYKSVHWOWPWLWRWSYLUUCUULIPYLYCYOMZYCYRMZNUUFUUHNZUUFUUJNZNUUCUULY
        LUWOUWQUWPUWRYLUWEUWOUWQTUWFBYCYNCWTOYLUWGUWPUWRTUWHBYCYQDWTOWQYCYOYRXC
        UUFUUHUUJXAXDXEYLYABWGZUUEUUPTAUWSYEAUWNUWSYKBLYAWHOSBYCUUAYAWTOWLWSXFY
        LPXGXHRZYSYBMZIPXIYTYBMPXGXJRUWTXKPXGXLXMYLUXAIPAUXAYEUVNAYOYBMZYRYBMZU
        XAAYHYGUXBEGBYMURCXOWDADULMUVHUXCFHBYPURDXOWDYOYRXNWDXPXQPYSIXRXSUNXT
        $.
    $}

    $( The sum of two measurable functions is measurable.  (Contributed by
       Mario Carneiro, 15-Aug-2014.) $)
    mbfadd $p |- ( ph -> ( F oF + G ) e. MblFn ) $=
      ( vx caddc co cdm cfv cmpt cmbf cc wcel syl eqid wa eqidd cr fmptd cof cv
      cin cvol wf wfn mbff ffn mbfdm offval cre cim elin simplbi ffvelrn syl2an
      simprbi readdd mpteq2dva inmbl syl2anc recld offval2 eqtr4d cres wss wceq
      inss1 resmpt ax-mp feqmptd eqeltrrd mbfres syl5eqelr ismbfcn2 mpbid inss2
      simpld mbfaddlem eqeltrd imaddd imcld simprd addcld mpbir2and ) ABCGUAZHF
      BIZCIZUCZFUBZBJZWJCJZGHZKZLAFWGWHWKWLGWIBCUDIZWOAWGMBUEZBWGUFABLNZWPDBUGO
      ZWGMBUHOAWHMCUEZCWHUFACLNZWSECUGOZWHMCUHOAWQWGWONZDBUIOZAWTWHWONZECUIOZWI
      PAWJWGNZQWKRAWJWHNZQWLRUJAWNLNFWIWMUKJZKZLNFWIWMULJZKZLNAXIFWIWKUKJZKZFWI
      WLUKJZKZWFHZLAXIFWIXLXNGHZKXPAFWIXHXQAWJWINZQZWKWLAWPXFWKMNXRWRXRXFXGWJWG
      WHUMZUNWGMWJBUOUPZAWSXGWLMNXRXAXRXFXGXTUQWHMWJCUOUPZURUSAFWIXLXNGXMXOWOSS
      AXBXDWIWONZXCXEWGWHUTVAZXSWKYAVBZXSWLYBVBZAXMRAXORVCVDAWIXMXOAXMLNZFWIWKU
      LJZKZLNZAFWIWKKZLNYGYJQAYKFWGWKKZWIVEZLWIWGVFYMYKVGWGWHVHFWGWIWKVIVJAYLLN
      YCYMLNABYLLAFWGMBWRVKDVLYDWIYLVMVAVNAFWIWKYAVOVPZVRAXOLNZFWIWLULJZKZLNZAF
      WIWLKZLNYOYRQAYSFWHWLKZWIVEZLWIWHVFUUAYSVGWGWHVQFWHWIWLVIVJAYTLNYCUUALNAC
      YTLAFWHMCXAVKEVLYDWIYTVMVAVNAFWIWLYBVOVPZVRAFWIXLSXMYEXMPTAFWIXNSXOYFXOPT
      VSVTAXKYIYQWFHZLAXKFWIYHYPGHZKUUCAFWIXJUUDXSWKWLYAYBWAUSAFWIYHYPGYIYQWOSS
      YDXSWKYAWBZXSWLYBWBZAYIRAYQRVCVDAWIYIYQAYGYJYNWCAYOYRUUBWCAFWIYHSYIUUEYIP
      TAFWIYPSYQUUFYQPTVSVTAFWIWMXSWKWLYAYBWDVOWEVT $.

    $( The difference of two measurable functions is measurable.  (Contributed
       by Mario Carneiro, 5-Sep-2014.) $)
    mbfsub $p |- ( ph -> ( F oF - G ) e. MblFn ) $=
      ( vx cmin cof co cdm cmpt caddc cmbf wcel wa syl eqidd syl2anc eqeltrrd
      cc cin cv cneg wf mbff elin simplbi ffvelrn syl2an simprbi negsubd eqcomd
      cfv mpteq2dva cvol wfn ffn mbfdm eqid offval inmbl negcld offval2 3eqtr4d
      cres wceq inss1 resmpt mp1i feqmptd mbfres inss2 mbfneg mbfadd eqeltrd
      wss ) ABCGHIZFBJZCJZUAZFUBZBUMZKZFVTWACUMZUCZKZLHIZMAFVTWBWDGIZKFVTWBWELI
      ZKVQWGAFVTWHWIAWAVTNZOZWIWHWKWBWDAVRTBUDZWAVRNZWBTNWJABMNZWLDBUEPZWJWMWAV
      SNZWAVRVSUFZUGVRTWABUHUIZAVSTCUDZWPWDTNWJACMNZWSECUEPZWJWMWPWQUJVSTWACUHU
      IZUKULUNAFVRVSWBWDGVTBCUOJZXCAWLBVRUPWOVRTBUQPAWSCVSUPXAVSTCUQPAWNVRXCNZD
      BURPZAWTVSXCNZECURPZVTUSAWMOWBQAWPOWDQUTAFVTWBWELWCWFXCTTAXDXFVTXCNZXEXGV
      RVSVARZWRWKWDXBVBAWCQAWFQVCVDAWCWFAFVRWBKZVTVEZWCMVTVRVPXKWCVFAVRVSVGFVRV
      TWBVHVIAXJMNXHXKMNABXJMAFVRTBWOVJDSXIVTXJVKRSAFVTWDTXBAFVSWDKZVTVEZFVTWDK
      ZMVTVSVPXMXNVFAVRVSVLFVSVTWDVHVIAXLMNXHXMMNACXLMAFVSTCXAVJESXIVTXLVKRSVMV
      NVO $.
  $}

  ${
    $d x A $.  $d x C $.  $d x ph $.
    mbfmulc2.1 $e |- ( ph -> C e. CC ) $.
    mbfmulc2.2 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    mbfmulc2.3 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    $( A complex constant times a measurable function is measurable.
       (Contributed by Mario Carneiro, 17-Aug-2014.) $)
    mbfmulc2 $p |- ( ph -> ( x e. A |-> ( C x. B ) ) e. MblFn ) $=
      ( cmul co cmpt cmbf wcel cfv caddc cvv cr a1i offval2 cre cim csn cxp cof
      cneg cvol cdm cc mbfdm2 cv wa recld adantr mbfmptcl mulcld ovex fconstmpt
      recnd wceq eqidd imcld renegcld negsubd mulneg1d oveq2d 3eqtr4d mpteq2dva
      cmin remuld eqtrd ismbfcn2 mpbid simpld eqid fmptd simprd mbfadd eqeltrrd
      mbfmulc2re immuld eqtr4d mpbir2and ) ABCEDJKZLMNBCWDUAOZLZMNBCWDUBOZLZMNA
      CEUAOZUCUDZBCDUAOZLZJUEZKZCEUBOZUFZUCUDZBCDUBOZLZWMKZPUEZKZWFMAXBBCWIWKJK
      ZWPWRJKZPKZLWFABCXCXDPWNWTUGUHZUIQABCDFIHUJZABUKCNZULZWIWKXIWIAWIRNXHAEGU
      MZUNZUSXIWKXIDABCDFIHUOZUMZUSZUPZXDQNXIWPWRJUQSABCWIWKJWJWLXFRRXGXKXMWJBC
      WILUTABCWIURSZAWLVAZTABCWPWRJWQWSXFRRXGAWPRNXHAWOAEGVBZVCZUNXIDXLVBZWQBCW
      PLUTABCWPURSAWSVAZTTABCXEWEXIXCWOWRJKZUFZPKXCYBVIKXEWEXIXCYBXOXIWOWRXIWOA
      WORNXHXRUNZUSZXIWRXTUSZUPVDXIXDYCXCPXIWOWRYEYFVEVFXIEDAEUINXHGUNZXLVJVGVH
      VKAWNWTACWIWLAWLMNZWSMNZABCDLMNYHYIULIABCDXLVLVMZVNZXJABCWKUIWLXNWLVOVPZV
      TACWPWSAYHYIYJVQZXSABCWRUIWSYFWSVOVPZVTVRVSAWJWSWMKZCWOUCUDZWLWMKZXAKZWHM
      AYRBCWIWRJKZWOWKJKZPKZLWHABCYSYTPYOYQXFQQXGYSQNXIWIWRJUQSYTQNXIWOWKJUQSAB
      CWIWRJWJWSXFRRXGXKXTXPYATABCWOWKJYPWLXFRRXGYDXMYPBCWOLUTABCWOURSXQTTABCWG
      UUAXIEDYGXLWAVHWBAYOYQACWIWSYMXJYNVTACWOWLYKXRYLVTVRVSABCWDXIEDYGXLUPVLWC
      $.
  $}

  ${
    $d m n x y z A $.  $d m y z B $.  $d n t x y z ph $.  $d m n x y z Z $.
    $d m t z G $.
    mbfsup.1 $e |- Z = ( ZZ>= ` M ) $.
    mbfsup.2 $e |- G = ( x e. A |-> sup ( ran ( n e. Z |-> B ) , RR , < ) ) $.
    mbfsup.3 $e |- ( ph -> M e. ZZ ) $.
    mbfsup.4 $e |- ( ( ph /\ n e. Z ) -> ( x e. A |-> B ) e. MblFn ) $.
    mbfsup.5 $e |- ( ( ph /\ ( n e. Z /\ x e. A ) ) -> B e. RR ) $.
    mbfsup.6 $e |- ( ( ph /\ x e. A ) -> E. y e. RR A. n e. Z B <_ y ) $.
    $( The supremum of a sequence of measurable, real-valued functions is
       measurable.  Note that in this and related theorems, ` B ( n , x ) ` is
       a function of both ` n ` and ` x ` , since it is an ` n ` -indexed
       sequence of functions on ` x ` .  (Contributed by Mario Carneiro,
       14-Aug-2014.)  (Revised by Mario Carneiro, 7-Sep-2014.) $)
    mbfsup $p |- ( ph -> G e. MblFn ) $=
      ( vz cr clt wcel wbr vt vm cmpt crn csup cv wss wne cle wral wrex anassrs
      wa c0 an32s eqid fmptd frn syl cdm cuz cfv uzid syl6eleqr adantr wceq fdm
      wf cz eleqtrrd ne0i dm0rn0 necon3bii sylib wfn wb ffn breq1 nffvmpt1 nfcv
      ralrn nfbr nfv weq fveq2 breq1d cbvral simpr fvmpt2 ralbidva syl5bb bitrd
      syl2anc rexbidv mpbird suprcl syl3anc ccnv cpnf cioo cima ciun cvol supex
      co cvv ltso sylancl breq2d 3jca adantlr simplr suprlub breq2 rexrn cbvrex
      w3a fvmpt2i adantl eqcomd sylan9eqr rexbidva 3bitrd ralrimiva nfmpt1 nffv
      cid nfcxfr nfrex nfbi bibi12d r19.21bi ffvelrnda biantrurd bitr4d 3bitr4d
      elioopnf elpreima cn cdom cxr rexr ad2antlr adantllr eliun r19.42v syl6bb
      pm5.32da eqrdv cen zex uzssz ssdomg mp2 eqbrtri znnen domentr cmbf mbfima
      mp2an iunmbl2 sylancr eqeltrd ismbf3d ) AUADGABDFIEUCZUDZQRUEZQGABUFZDSZU
      MZUVFQUGZUVFUNUHZPUFZCUFZUITZPUVFUJZCQUKZUVGQSUVJIQUVEVHZUVKUVJFIEQUVEAFU
      FZISZUVIEQSZAUVTUVIUWANULZUOZUVEUPZUQZIQUVEURUSZUVJUVEUTZUNUHZUVLUVJHUWGS
      UWHUVJHIUWGAHISUVIAHHVAVBZIAHVISHUWISLHVCUSJVDVEUVJUVRUWGIVFUWEIQUVEVGUSV
      JUWGHVKUSUWGUNUVFUNUVEVLVMVNZUVJUVQEUVNUITZFIUJZCQUKOUVJUVPUWLCQUVJUVPUBU
      FZUVEVBZUVNUITZUBIUJZUWLUVJUVEIVOZUVPUWPVPUVJUVRUWQUWEIQUVEVQUSZUVOUWOPUB
      IUVEUVMUWNUVNUIVRWAUSUWPUVSUVEVBZUVNUITZFIUJUVJUWLUWOUWTUBFIFUWNUVNUIFIEU
      WMVSZFUIVTFUVNVTWBUWTUBWCUBFWDZUWNUWSUVNUIUWMUVSUVEWEZWFWGUVJUWTUWKFIUVJU
      VTUMZUWSEUVNUIUXDUVTUWAUWSEVFUVJUVTWHUWCFIEQUVEUWDWIWMWFWJWKWLWNWOZCPUVFW
      PWQKUQZAUAUFZQSZUMZGWRUXGWSWTXEZXAZFIBDEUCZWRUXJXAZXBZXCUTZUXIPUXKUXNUXIU
      VMDSZUVMGVBZUXJSZUMZUXPUVMUXLVBZUXJSZFIUKZUMZUVMUXKSZUVMUXNSZUXIUXPUXRUYB
      UXIUXPUMZUXGUXQRTZUXGUXTRTZFIUKZUXRUYBUXIUYGUYIVPZPDUXIUXGUVHGVBZRTZUXGUV
      HUXLVBZRTZFIUKZVPZBDUJUYJPDUJUXIUYPBDUXIUVIUMZUYLUXGUVGRTZUXGUVMRTZPUVFUK
      ZUYOUYQUYKUVGUXGRUYQUVIUVGXFSUYKUVGVFUXIUVIWHQUVFRXGXDBDUVGXFGKWIXHXIUYQU
      VKUVLUVQXQZUXHUYRUYTVPAUVIVUAUXHUVJUVKUVLUVQUWFUWJUXEXJXKAUXHUVIXLCPPUVFU
      XGXMWMUYQUYTUXGUWNRTZUBIUKZUYOUYQUWQUYTVUCVPAUVIUWQUXHUWRXKUYSVUBPUBIUVEU
      VMUWNUXGRXNXOUSVUCUXGUWSRTZFIUKZUYQUYOVUBVUDUBFIFUXGUWNRFUXGVTFRVTUXAWBVU
      DUBWCUXBUWNUWSUXGRUXCXIXPAUVIVUEUYOVPUXHUVJVUDUYNFIUXDUWSUYMUXGRUVTUVJUWS
      EYGVBZUYMFIEUVEUWDXRUVJUYMVUFUVIUYMVUFVFABDEUXLUXLUPZXRXSXTYAXIYBXKWKWLYC
      YDUYPUYJBPDUYPPWCUYGUYIBBUXGUXQRBUXGVTZBRVTZBUVMGBGBDUVGUCKBDUVGYEYHBUVMV
      TYFWBUYHBFIBIVTBUXGUXTRVUHVUIBDEUVMVSWBYIYJBPWDZUYLUYGUYOUYIVUJUYKUXQUXGR
      UVHUVMGWEXIVUJUYNUYHFIVUJUYMUXTUXGRUVHUVMUXLWEXIWNYKWGVNYLUYFUXRUXQQSZUYG
      UMZUYGUYFUXGUUASZUXRVULVPUXHVUMAUXPUXGUUBUUCZUXGUXQYQUSUYFVUKUYGUXIDQUVMG
      ADQGVHZUXHUXFVEYMYNYOUYFUYAUYHFIUYFUVTUMZUYAUXTQSZUYHUMZUYHVUPVUMUYAVURVP
      UYFVUMUVTVUNVEUXGUXTYQUSAUXPUVTUYHVURVPZUXHAUVTUXPVUSAUVTUMZUXPUMVUQUYHVU
      TDQUVMUXLVUTBDEQUXLUWBVUGUQZYMYNUOUUDYOYBYPUUHUXIGDVOZUYDUXSVPAVVBUXHAVUO
      VVBUXFDQGVQUSVEDUVMUXJGYRUSUYEUVMUXMSZFIUKZUXIUYCFUVMIUXMUUEUXIVVDUXPUYAU
      MZFIUKZUYCAVVDVVFVPUXHAVVCVVEFIVUTUXLDVOZVVCVVEVPVUTDQUXLVHZVVGVVADQUXLVQ
      USDUVMUXJUXLYRUSYBVEUXPUYAFIUUFUUGWKYPUUIUXIIYSYTTZUXMUXOSZFIUJZUXNUXOSIV
      IYTTVIYSUUJTVVIIUWIVIYTJVIXFSUWIVIUGUWIVIYTTUUKHUULUWIVIXFUUMUUNUUOUUPIVI
      YSUUQUUTAVVKUXHAVVJFIVUTUXLUURSVVHVVJMVVADUXGWSUXLUUSWMYDVEIUXMFUVAUVBUVC
      UVD $.
  $}

  ${
    $d m n r x y z A $.  $d m n r x y z ph $.  $d m n r x y z Z $.
    $d m r y z B $.
    mbfinf.1 $e |- Z = ( ZZ>= ` M ) $.
    mbfinf.2 $e |- G = ( x e. A |->
      sup ( ran ( n e. Z |-> B ) , RR , `' < ) ) $.
    mbfinf.3 $e |- ( ph -> M e. ZZ ) $.
    mbfinf.4 $e |- ( ( ph /\ n e. Z ) -> ( x e. A |-> B ) e. MblFn ) $.
    mbfinf.5 $e |- ( ( ph /\ ( n e. Z /\ x e. A ) ) -> B e. RR ) $.
    mbfinf.6 $e |- ( ( ph /\ x e. A ) -> E. y e. RR A. n e. Z y <_ B ) $.
    $( The infimum of a sequence of measurable, real-valued functions is
       measurable.  (Contributed by Mario Carneiro, 7-Sep-2014.) $)
    mbfinf $p |- ( ph -> G e. MblFn ) $=
      ( vm cr wcel wa wceq vr vz cneg cmpt crn clt csup cmbf ccnv cv wss c0 wne
      crab cle wbr wral wrex wf anass1rs eqid fmptd frn syl cdm cuz cfv cz uzid
      syl6eleqr adantr fdm eleqtrrd ne0i dm0rn0 necon3bii sylib wfn breq2 ralrn
      wb ffn nfcv nffvmpt1 nfbr nfv fveq2 breq2d cbvral fvmpt2 syl2anc ralbidva
      simpr syl5bb bitrd rexbidv mpbird infmsup syl3anc wal rabid recnd adantlr
      simplr negcon2 eqcom syl6bb eqeq1d cvv negex mpan2 adantl ralrimiva nfeq1
      cc 3bitr4d nfbi bibi12d r19.21bi rexbidva fvelrnb renegcld pm5.32da sseld
      sylibr pm4.71rd bitr4d alrimiv nfrab1 cleqf negeqd eqtrd mpteq2dva syl5eq
      supeq1d ltso supex a1i anassrs mbfneg renegcl ad2antrl lenegd biimpd impr
      ralbidv rspcev rexlimddv mbfsup eqeltrd ) AGBDFIEUCZUDZUEZQUFUGZUCZUDZUHA
      GBDFIEUDZUEZQUFUIUGZUDUUPKABDUUSUUOABUJDRZSZUUSUAUJZUCZUURRZUAQUNZQUFUGZU
      CZUUOUVAUURQUKZUURULUMZCUJZUBUJZUOUPZUBUURUQZCQURZUUSUVGTUVAIQUUQUSZUVHUV
      AFIEQUUQAFUJZIRZUUTEQRZNUTZUUQVAZVBZIQUUQVCVDUVAUUQVEZULUMZUVIUVAHUWBRUWC
      UVAHIUWBAHIRUUTAHHVFVGZIAHVHRHUWDRLHVIVDJVJVKUVAUVOUWBITUWAIQUUQVLVDVMUWB
      HVNVDUWBULUURULUUQVOVPVQUVAUVNUVJEUOUPZFIUQZCQUROUVAUVMUWFCQUVAUVMUVJPUJZ
      UUQVGZUOUPZPIUQZUWFUVAUUQIVRZUVMUWJWAUVAUVOUWKUWAIQUUQWBVDZUVLUWIUBPIUUQU
      VKUWHUVJUOVSVTVDUWJUVJUVPUUQVGZUOUPZFIUQUVAUWFUWIUWNPFIFUVJUWHUOFUVJWCFUO
      WCFIEUWGWDZWEUWNPWFUWGUVPTZUWHUWMUVJUOUWGUVPUUQWGZWHWIUVAUWNUWEFIUVAUVQSZ
      UWMEUVJUOUWRUVQUVRUWMETZUVAUVQWMUVSFIEQUUQUVTWJWKZWHWLWNWOWPWQCUBUAUURWRW
      SUVAUVFUUNUVAQUVEUUMUFUVAUVBUVERZUVBUUMRZWAZUAWTUVEUUMTUVAUXCUAUXAUVBQRZU
      VDSZUVAUXBUVDUAQXAUVAUXEUXDUXBSUXBUVAUXDUVDUXBUVAUXDSZUWHUVCTZPIURZUWGUUL
      VGZUVBTZPIURZUVDUXBUXFUXGUXJPIUXFUXGUXJWAZPIUXFUWMUVCTZUVPUULVGZUVBTZWAZF
      IUQUXLPIUQUXFUXPFIUXFUVQSZEUVCTZUUKUVBTZUXMUXOUXQUXRUVBUUKTZUXSUXQEXORZUV
      BXORUXRUXTWAUVAUVQUYAUXDUWREUVSXBXCUXQUVBUVAUXDUVQXDXBEUVBXEWKUVBUUKXFXGU
      XQUWMEUVCUVAUVQUWSUXDUWTXCXHUXQUXNUUKUVBUVQUXNUUKTZUXFUVQUUKXIRUYBEXJFIUU
      KXIUULUULVAZWJXKXLXHXPXMUXLUXPPFIUXGUXJFFUWHUVCUWOXNFUXIUVBFIUUKUWGWDXNXQ
      UXPPWFUWPUXGUXMUXJUXOUWPUWHUWMUVCUWQXHUWPUXIUXNUVBUWGUVPUULWGXHXRWIYEXSXT
      UXFUWKUVDUXHWAUVAUWKUXDUWLVKPIUVCUUQYAVDUXFUULIVRZUXBUXKWAUXFIQUULUSZUYDU
      VAUYEUXDUVAFIUUKQUULUWREUVSYBUYCVBZVKIQUULWBVDPIUVBUULYAVDXPYCUVAUXBUXDUV
      AUUMQUVBUVAUYEUUMQUKUYFIQUULVCVDYDYFYGWNYHUAUVEUUMUVDUAQYIUAUUMWCYJYEYOYK
      YLYMYNABDUUNXIUUNXIRUVAQUUMUFYPYQYRABUBDUUKFBDUUNUDZHIJUYGVALAUVQSBDEQAUV
      QUUTUVRNYSMYTAUVQUUTSSENYBUVAUWFUUKUVKUOUPZFIUQZUBQURZCQOUVAUVJQRZUWFSSUV
      JUCZQRZUUKUYLUOUPZFIUQZUYJUYKUYMUVAUWFUVJUUAUUBUVAUYKUWFUYOUVAUYKSZUWFUYO
      UYPUWEUYNFIUYPUVQSUVJEUVAUYKUVQXDUVAUVQUVRUYKUVSXCUUCWLUUDUUEUYIUYOUBUYLQ
      UVKUYLTUYHUYNFIUVKUYLUUKUOVSUUFUUGWKUUHUUIYTUUJ $.
  $}

  ${
    $d i k n x y A $.  $d i k m y z B $.  $d i k y z H $.  $d i k n x y ph $.
    $d m M $.  $d i k m n x y z Z $.
    mbflimsup.1 $e |- Z = ( ZZ>= ` M ) $.
    mbflimsup.2 $e |- G = ( x e. A |-> ( limsup ` ( n e. Z |-> B ) ) ) $.
    mbflimsup.h $e |- H = ( m e. RR |->
      sup ( ( ( ( n e. Z |-> B ) " ( m [,) +oo ) ) i^i RR* ) , RR* , < ) ) $.
    mbflimsup.3 $e |- ( ph -> M e. ZZ ) $.
    mbflimsup.4 $e |- ( ( ph /\ x e. A ) ->
      ( limsup ` ( n e. Z |-> B ) ) e. RR ) $.
    mbflimsup.5 $e |- ( ( ph /\ n e. Z ) -> ( x e. A |-> B ) e. MblFn ) $.
    mbflimsup.6 $e |- ( ( ph /\ ( n e. Z /\ x e. A ) ) -> B e. RR ) $.
    $( The limit supremum of a sequence of measurable real-valued functions is
       measurable.  (Contributed by Mario Carneiro, 7-Sep-2014.)  (Revised by
       Mario Carneiro, 9-May-2016.) $)
    mbflimsup $p |- ( ph -> G e. MblFn ) $=
      ( cr wcel cle vi vy vz vk cv cuz cfv cmpt crn csup ccnv cmbf clsp wa cima
      clt cxr cvv fvex eqeltri mptex a1i cz uzssz eqsstri zssre sstri cpnf wceq
      wss uzsup syl adantr limsupval2 c0 wne wral wrex imassrn wf anass1rs eqid
      wbr fmptd ltpnf limsupgre syl3anc frn syl5ss cdm ineq1d dfss1 mpbi syl6eq
      cin fdm uzid syl6eleqr eqnetrd imadisj necon3bii sylibr leidd wb limsuple
      ne0i rexrd mpbid ssralv mpsyl wfn limsupgf ffn ax-mp breq2 mpbird ralbidv
      breq1 rspcev syl2anc cres resmpt wi adantll syl12anc simpr adantlr syl2an
      3syl sseli limsupgle syl211anc adantl ralbidva ralrimiva mpteq2dva syl5eq
      syl31anc simpll an32s ralima sylancr df-ima feqmptd reseq1d uztrn2 dm0rn0
      infmxrre simplll simpllr eluzelz sylib ffvelrn uzss syl6sseqr sseldi sylc
      syl6eleq fveq1d fvres eqtr3d breq1d eluzle biimt bitrd ralrn eluz biimprd
      impr syldan fnfvelrn eqeltrrd suprub expr suprcl suprleub mpbir2and eqtrd
      letri3d rneqd supeq1d 3eqtrd simprr ralrnmpt rexbidv mbfsup anasss breq2d
      ad2ant2lr mbfinf eqeltrd ) AGBCUAJFUAUEZUFUGZDUHZUIZRUPUJZUHZUIZRUPUKZUJZ
      UHZULAGBCFJDUHZUMUGZUHUXALABCUXCUWTABUECSZUNZUXCHJUOZUQUWSUJZUXFRUWSUJZUW
      TUXEJEUXBHURMUXBURSUXEFJDJIUFUGZURKIUFUSUTVAVBJRVJZUXEJVCRJUXIVCKIVDVEZVF
      VGZVBZAJUQUPUJVHVIZUXDAIVCSZUXNNIJKVKVLVMVNUXEUXFRVJUXFVOVPZUBUEZUCUEZTWC
      ZUCUXFVQZUBRVRZUXGUXHVIUXEUXFHUIZRHJVSUXERRHVTZUYBRVJUXEUXOJRUXBVTUXCVHUP
      WCZUYCAUXOUXDNVMUXEFJDRUXBAFUEZJSZUXDDRSZQWAZUXBWBZWDUXEUXCRSZUYDOUXCWEVL
      EUXBHIJMKWFWGZRRHWHVLWIUXEHWJZJWOZVOVPUXPUXEUYMJVOUXEUYMRJWOZJUXEUYLRJUXE
      UYCUYLRVIUYKRRHWPVLWKUXJUYNJVIUXLJRWLWMWNUXEIJSZJVOVPAUYOUXDAIUXIJAUXOIUX
      ISNIWQVLKWRVMJIXFVLWSUXFVOUYMVOHJWTXAXBUXEUYJUXCUXRTWCZUCUXFVQZUYAOUXEUYQ
      UXCUXQHUGZTWCZUBJVQZUXJUXEUYSUBRVQZUYTUXLUXEUXCUXCTWCZVUAUXEUXCOXCZUXEUXJ
      JUQUXBVTZUXCUQSZVUBVUAXDUXMUXEFJDUQUXBUXEUYFUNDUYHXGUYIWDZUXEUXCOXGZUXCJU
      BEUXBHMXEWGXHUYSUBJRXIXJUXEHRXKZUXJUYQUYTXDRUQHVTVUHEUXBHMXLRUQHXMXNUXMUY
      PUYSUCUBRJHUXRUYRUXCTXOUUAUUBXPUXTUYQUBUXCRUXQUXCVIZUXSUYPUCUXFUXQUXCUXRT
      XRXQXSXTUBUCUXFUUHWGUXERUXFUWRUWSUXEUXFHJYAZUIUWRHJUUCUXEVUJUWQUXEVUJUAJU
      WLHUGZUHZUWQUXEVUJUARVUKUHZJYAZVULUXEHVUMJUXEUARRHUYKUUDUUEUXJVUNVULVIUXL
      UARJVUKYBXNWNUXEUAJVUKUWPUXEUWLJSZUNZVUKUWPVIVUKUWPTWCZUWPVUKTWCZVUPVUQUW
      LUDUEZTWCZVUSUXBUGZUWPTWCZYCZUDJVQZVUPVVCUDJVUPVUSJSZVUTVVBVUPVVEVUTUNZUN
      ZUWORVJZUWOVOVPZUXRUXQTWCZUCUWOVQZUBRVRZVVAUWOSVVBVUPVVHVVFVUPUWMRUWNVTZV
      VHVUPFUWMDRUWNVUPUYEUWMSZUNAUYFUXDUYGAUXDVUOVVNUUIVUOVVNUYFUXEIUYEUWLJKUU
      FZYDAUXDVUOVVNUUJQYEZUWNWBZWDZUWMRUWNWHVLZVMVUPVVIVVFVUPUWNWJZVOVPVVIVUPV
      VTUWMVOVUPVVMVVTUWMVIVVRUWMRUWNWPVLVUPUWLVCSZUWLUWMSUWMVOVPAVUOVWAUXDAVUO
      UNZUWLUXISZVWAVWBUWLJUXIAVUOYFKUURZIUWLUUKVLZYGZUWLWQUWMUWLXFYIWSVVTVOUWO
      VOUWNUUGXAUULZVMVUPVVLVVFVUPVUKRSZUXRVUKTWCZUCUWOVQZVVLUXEUYCUWLRSZVWHVUO
      UYKJRUWLUXLYJRRUWLHUUMYHZVUPVWJVUSUWNUGZVUKTWCZUDUWMVQZVUPVWOVUTVVAVUKTWC
      ZYCZUDUWMVQZVUPUWMJVJZVWQUDJVQZVWRVUPUWMUXIJVUPVWCUWMUXIVJAVUOVWCUXDVWDYG
      IUWLUUNVLKUUOZVUPVUKVUKTWCZVWTVUPVUKVWLXCVUPUXJVUDVWKVUKUQSVXBVWTXDUXJVUP
      UXLVBZUXEVUDVUOVUFVMZVUPJRUWLUXLUXEVUOYFUUPZVUPVUKVWLXGVUKJUWLUDEUXBHMYKY
      LXHVWQUDUWMJXIUUQVUPVWNVWQUDUWMVUPVUSUWMSZUNZVWNVWPVWQVXGVWMVVAVUKTVXGVUS
      UXBUWMYAZUGZVWMVVAVXGVUSVXHUWNVXGVWSVXHUWNVIVUPVWSVXFVXAVMFJUWMDYBVLUUSVX
      FVXIVVAVIVUPVUSUWMUXBUUTYMUVAZUVBVXGVUTVWPVWQXDVXFVUTVUPUWLVUSUVCYMVUTVWP
      UVDVLUVEYNXPVUPVVMUWNUWMXKZVWJVWOXDVVRUWMRUWNXMZVWIVWNUCUDUWMUWNUXRVWMVUK
      TXRUVFYIXPZVVKVWJUBVUKRUXQVUKVIVVJVWIUCUWOUXQVUKUXRTXOXQXSXTZVMVVGVWMVVAU
      WOVUPVVFVXFVWMVVAVIVUPVVEVUTVXFVUPVVEUNVXFVUTVUPVWAVUSVCSVXFVUTXDVVEVWFJV
      CVUSUXKYJUWLVUSUVGYHUVHUVIZVXJUVJVVGVXKVXFVWMUWOSVVGVVMVXKVUPVVMVVFVVRVMV
      XLVLVXOUWMVUSUWNUVKXTUVLUBUCUWOVVAUVMYRUVNYOVUPUXJVUDVWKUWPUQSVUQVVDXDVXC
      VXDVXEVUPUWPVUPVVHVVIVVLUWPRSZVVSVWGVXNUBUCUWOUVOWGZXGUWPJUWLUDEUXBHMYKYL
      XPVUPVURVWJVXMVUPVVHVVIVVLVWHVURVWJXDVVSVWGVXNVWLUBUCUCUWOVUKUVPYRXPVUPVU
      KUWPVWLVXQUVSUVQZYPUVRUVTYQUWAUWBYPYQABUBCUWPUAUXAIJKUXAWBNVWBBUBCDFBCUWP
      UHZUWLUWMUWMWBVXSWBVWEVWBVVNUNAUYFBCDUHULSAVUOVVNYSVUOVVNUYFAVVOYDPXTVWBV
      VNUXDUNZUNAUYFUXDUYGAVUOVXTYSVUOVVNUYFAUXDVVOUWIVWBVVNUXDUWCQYEAUXDVUODUX
      QTWCZFUWMVQZUBRVRZVUPVVLVYCVXNVUPVVKVYBUBRVUPUYGFUWMVQVVKVYBXDVUPUYGFUWMV
      VPYOVVJVYAFUCUWMDUWNRVVQUXRDUXQTXRUWDVLUWEXHYTUWFAVUOUXDVXPAUXDVUOVXPVXQY
      TUWGUXEUYJUXCUWPTWCZUAJVQZUXQUWPTWCZUAJVQZUBRVROUXEUXCVUKTWCZUAJVQZVYEUXJ
      UXEVYHUARVQZVYIUXLUXEVUBVYJVUCUXEUXJVUDVUEVUBVYJXDUXMVUFVUGUXCJUAEUXBHMXE
      WGXHVYHUAJRXIXJUXEVYHVYDUAJVUPVUKUWPUXCTVXRUWHYNXHVYGVYEUBUXCRVUIVYFVYDUA
      JUXQUXCUWPTXRXQXSXTUWJUWK $.
  $}

  ${
    $d j k m n x y A $.  $d k C $.  $d j k m n x y ph $.  $d j k m n x y z Z $.
    $d j k m y z B $.  $d j k m y M $.
    mbflim.1 $e |- Z = ( ZZ>= ` M ) $.
    mbflim.2 $e |- ( ph -> M e. ZZ ) $.
    mbflim.4 $e |- ( ( ph /\ x e. A ) -> ( n e. Z |-> B ) ~~> C ) $.
    mbflim.5 $e |- ( ( ph /\ n e. Z ) -> ( x e. A |-> B ) e. MblFn ) $.
    ${
      mbflimlem.6 $e |- ( ( ph /\ ( n e. Z /\ x e. A ) ) -> B e. RR ) $.
      $( The pointwise limit of a sequence of measurable real-valued functions
         is measurable.  (Contributed by Mario Carneiro, 7-Sep-2014.) $)
      mbflimlem $p |- ( ph -> ( x e. A |-> C ) e. MblFn ) $=
        ( vy vj vk cmpt cfv cv wcel vm clsp cmbf wa cli wbr wceq anass1rs fmptd
        cr eqid cdm cmin cabs clt cuz wral wrex crp adantr climrel releldmi syl
        cz co climcau syl2anc caurcvg climuni mpteq2dva cpnf cico cima cxr csup
        cin ffvelrnda climrecl mbflimsup eqeltrrd ) ABCFHDQZUBRZQZBCEQUCABCWBEA
        BSCTZUDZWAWBUEUFWAEUEUFZWBEUGWENOPWAGHIWEFHDUJWAAFSHTWDDUJTMUHWAUKUIZWE
        GVDTZWAUEULTZOSWARPSZWARUMVEUNRNSUOUFOWJUPRUQPHURNUSUQAWHWDJUTZWEWFWIKW
        AEUEVAVBVCNPOWAGHIVFVGVHZKWBEWAVIVGVJABCDUAFWCUAUJWAUASVKVLVEVMVNVPVNUO
        VOQZGHIWCUKWMUKJWEWBPWAGHIWKWLWEHUJWJWAWGVQVRLMVSVT $.
    $}

    mbflim.6 $e |- ( ( ph /\ ( n e. Z /\ x e. A ) ) -> B e. V ) $.
    $( The pointwise limit of a sequence of measurable functions is
       measurable.  (Contributed by Mario Carneiro, 7-Sep-2014.) $)
    mbflim $p |- ( ph -> ( x e. A |-> C ) e. MblFn ) $=
      ( vk cmpt wcel cre cfv cim cmbf cv wa cvv cuz eqeltri mptex a1i cz adantr
      fvex cc anassrs mbfmptcl an32s eqid fmptd ffvelrnda wceq wral simpr recld
      cr fvmpt2 syl2anc fveq2d eqtr4d ralrimiva nffvmpt1 nfcv nffv nfeq eqeq12d
      fveq2 cbvral sylibr r19.21bi climre ismbfcn2 mpbid simpld mbflimlem imcld
      nfv anasss climim simprd cli wbr climcl syl mpbir2and ) ABCEPUAQBCERSZPUA
      QBCETSZPUAQABCDRSZWMFGIJKABUBCQZUCZEOFIDPZFIWOPZGUDIJLWSUDQWQFIWOIGUESUDJ
      GUEUKUFZUGUHAGUIQWPKUJZWQIULOUBZWRWQFIDULWRAFUBZIQZWPDULQZAXDUCZBCDHMAXDW
      PDHQNUMUNZUOZWRUPZUQURZWQXBWSSZXBWRSZRSZUSZOIWQXCWSSZXCWRSZRSZUSZFIUTXNOI
      UTWQXRFIWQXDUCZXOWOXQXSXDWOVCQXOWOUSWQXDVAZXSDXHVBFIWOVCWSWSUPVDVEXSXPDRX
      SXDXEXPDUSXTXHFIDULWRXIVDVEZVFVGVHXNXROFIFXKXMFIWOXBVIFXLRFRVJFIDXBVIZVKV
      LXROWDXBXCUSZXKXOXMXQXBXCWSVNYCXLXPRXBXCWRVNZVFVMVOVPVQVRXFBCWOPUAQZBCDTS
      ZPUAQZXFBCDPUAQYEYGUCMXFBCDXGVSVTZWAAXDWPUCUCZDAXDWPXEXGWEZVBWBABCYFWNFGI
      JKWQEOWRFIYFPZGUDIJLYKUDQWQFIYFWTUGUHXAXJWQXBYKSZXLTSZUSZOIWQXCYKSZXPTSZU
      SZFIUTYNOIUTWQYQFIXSYOYFYPXSXDYFVCQYOYFUSXTXSDXHWCFIYFVCYKYKUPVDVEXSXPDTY
      AVFVGVHYNYQOFIFYLYMFIYFXBVIFXLTFTVJYBVKVLYQOWDYCYLYOYMYPXBXCYKVNYCXLXPTYD
      VFVMVOVPVQWFXFYEYGYHWGYIDYJWCWBABCEWQWREWHWIEULQLEWRWJWKVSWL $.
  $}

  $c 0p $.

  $( Extend class notation to include the zero polynomial. $)
  c0p $a class 0p $.

  $( Define the zero polynomial.  (Contributed by Mario Carneiro,
     19-Jun-2014.) $)
  df-0p $a |- 0p = ( CC X. { 0 } ) $.

  $( The zero function evaluates to zero at every point.  (Contributed by Mario
     Carneiro, 23-Jul-2014.) $)
  0pval $p |- ( A e. CC -> ( 0p ` A ) = 0 ) $=
    ( cc wcel c0p cfv cc0 csn cxp df-0p fveq1i c0ex fvconst2 syl5eq ) ABCADEABF
    GHZEFADNIJBFAKLM $.

  ${
    $d x A $.  $d x F $.  $d x ph $.
    $( Two ways to say that the function ` F ` on the reals is nonnegative.
       (Contributed by Mario Carneiro, 17-Aug-2014.) $)
    0plef $p |- ( F : RR --> ( 0 [,) +oo ) <->
      ( F : RR --> RR /\ 0p oR <_ F ) ) $=
      ( vx cr cc0 cpnf wf c0p cle wbr wss wcel cfv wral wb baib syl wfn cvv a1i
      cc cico co cofr cxr 0re pnfxr icossre mp2an fss mpan2 cv ffvelrn ralbidva
      elrege0 ffn ffnfv csn cxp 0cn fnconstg ax-mp df-0p fneq1i mpbir cnex reex
      wa wceq ax-resscn sseqin2 mpbi 0pval adantl eqidd ofrfval 3bitr4d biadan2
      cin ) CDEUAUBZAFZCCAFZGAHUCIZVTVSCJZWADCKEUDKWCUEUFDEUGUHCVSCAUIUJWABUKZA
      LZVSKZBCMZDWEHIZBCMVTWBWAWFWHBCWAWDCKVGZWECKZWFWHNCCWDAULWFWJWHWEUNOPUMWA
      ACQZVTWGNCCAUOZVTWKWGBCVSAUPOPWABTCDWEHCGARRGTQZWAWMTDUQURZTQZDTKWOUSTDTU
      TVATGWNVBVCVDSWLTRKWAVESCRKWAVFSCTJTCVRCVHVICTVJVKWDTKWDGLDVHWAWDVLVMWIWE
      VNVOVPVQ $.

    0pledm.1 $e |- ( ph -> A C_ CC ) $.
    0pledm.2 $e |- ( ph -> F Fn A ) $.
    $( Adjust the domain of the left argument to match the right, which works
       better in our theorems.  (Contributed by Mario Carneiro,
       28-Jul-2014.) $)
    0pledm $p |- ( ph -> ( 0p oR <_ F <-> ( A X. { 0 } ) oR <_ F ) ) $=
      ( vx cc0 cfv cle wbr cc wral c0p cxp wceq cvv wfn wcel 0cn a1i cv cin csn
      cofr sseqin2 sylib raleqdv fnconstg ax-mp df-0p fneq1i mpbir cnex sylancl
      wss ssexg eqid 0pval adantl wa eqidd ofrfval inidm c0ex fvconst2 3bitr4d
      ) AGFUAZCHZIJZFKBUBZLVIFBLMCIUDZJBGUCZNZCVKJAVIFVJBABKUOZVJBODBKUEUFUGAFK
      BGVHIVJMCPPMKQZAVOKVLNZKQZGKRZVQSKGKUHUIKMVPUJUKULTEKPRZAUMTAVNVSBPRDUMBK
      PUPUNZVJUQVGKRVGMHGOAVGURUSAVGBRZUTVHVAZVBAFBBGVHIBVMCPPVMBQZAVRWCSBGKUHU
      ITEVTVTBVCWAVGVMHGOABGVGVDVEUSWBVBVF $.
  $}

  ${
    $d f g k m x y z F $.  $d k m x y A $.
    $( The predicate " ` F ` is a simple function".  A simple function is a
       finite nonnegative linear combination of indicator functions for
       finitely measurable sets.  We use the idiom ` F e. dom S.1 ` to
       represent this concept because ` S.1 ` is the first preparation function
       for our final definition ` S. ` (see ~ df-itg ); unlike that operator,
       which can integrate any function, this operator can only integrate
       simple functions.  (Contributed by Mario Carneiro, 18-Jun-2014.) $)
    isi1f $p |- ( F e. dom S.1 <-> ( F e. MblFn /\ ( F : RR --> RR /\
        ran F e. Fin /\ ( vol ` ( `' F " ( RR \ { 0 } ) ) ) e. RR ) ) ) $=
      ( vg vf vx cr cv crn cfn wcel ccnv csn cdif cima cvol cfv w3a cmbf eleq1d
      wf citg1 cc0 cdm wceq feq1 rneq imaeq1d fveq2d 3anbi123d crab cmul co csu
      cnveq sumex df-itg1 dmmpti elrab2 ) EEBFZSZURGZHIZURJZEUAKZLZMZNOZEIZPZEE
      ASZAGZHIZAJZVDMZNOZEIZPBAQTUBURAUCZUSVIVAVKVGVOEEURAUDVPUTVJHURAUERVPVFVN
      EVPVEVMNVPVBVLVDURAUMUFUGRUHCVHBQUICFZGVCLZDFZVQJVSKMNOUJUKZDULTVRVTDUNDC
      BUOUPUQ $.

    $( Simple functions are measurable.  (Contributed by Mario Carneiro,
       18-Jun-2014.) $)
    i1fmbf $p |- ( F e. dom S.1 -> F e. MblFn ) $=
      ( citg1 cdm wcel cmbf cr wf crn cfn ccnv cc0 csn cdif cima cvol cfv isi1f
      w3a simplbi ) ABCDAEDFFAGAHIDAJFKLMNOPFDRAQS $.

    $( A simple function is a function on the reals.  (Contributed by Mario
       Carneiro, 26-Jun-2014.) $)
    i1ff $p |- ( F e. dom S.1 -> F : RR --> RR ) $=
      ( citg1 cdm wcel cr wf crn cfn ccnv cc0 csn cdif cima cvol cfv cmbf isi1f
      w3a simprbi simp1d ) ABCDZEEAFZAGHDZAIEJKLMNOEDZUAAPDUBUCUDRAQST $.

    $( A simple function has finite range.  (Contributed by Mario Carneiro,
       26-Jun-2014.) $)
    i1frn $p |- ( F e. dom S.1 -> ran F e. Fin ) $=
      ( citg1 cdm wcel cr wf crn cfn ccnv cc0 csn cdif cima cvol cfv cmbf isi1f
      w3a simprbi simp2d ) ABCDZEEAFZAGHDZAIEJKLMNOEDZUAAPDUBUCUDRAQST $.

    $( Any preimage of a simple function is measurable.  (Contributed by Mario
       Carneiro, 26-Jun-2014.) $)
    i1fima $p |- ( F e. dom S.1 -> ( `' F " A ) e. dom vol ) $=
      ( vy citg1 cdm wcel crn cin ccnv cv csn cima ciun cvol cr wf wceq wss cfn
      adantr wfun i1ff inpreima iunid imaeq2i imaiun eqtr3i cnvimass cnvimarndm
      ffun sseqtr4i df-ss mpbi 3eqtr3g 3syl wral i1frn ssfi sylancl cmbf i1fmbf
      inss2 frn syl syl5ss sselda mbfimasn syl3anc ralrimiva finiunmbl eqeltrrd
      wa syl2anc ) BDEFZCABGZHZBIZCJZKZLZMZVQALZNEZVNOOBPZBUAZWAWBQBUBZOOBUJWEV
      QVPLZWBVQVOLZHZWAWBAVOBUCVQCVPVSMZLWGWAWJVPVQCVPUDUECVQVPVSUFUGWBWHRWIWBQ
      WBBEWHBAUHBUIUKWBWHULUMUNUOVNVPSFZVTWCFZCVPUPWAWCFVNVOSFVPVORWKBUQAVOVBZV
      OVPURUSVNWLCVPVNVRVPFZVLBUTFZWDVROFWLVNWOWNBVATVNWDWNWFTVNVPOVRVNVPVOOWMV
      NWDVOORWFOOBVCVDVEVFOVRBVGVHVIVPVTCVJVMVK $.

    $( Any preimage of a simple function not containing zero has finite
       measure.  (Contributed by Mario Carneiro, 26-Jun-2014.) $)
    i1fima2 $p |- ( ( F e. dom S.1 /\ -. 0 e. A ) ->
                    ( vol ` ( `' F " A ) ) e. RR ) $=
      ( citg1 cdm wcel cc0 wn cima cvol cfv covol wceq i1fima adantr mblvol syl
      wa cr wss cin ccnv csn cdif crn wf wfun i1ff inpreima cnvimass cnvimarndm
      ffun 3syl sseqtr4i df-ss mpbi syl6req c0 inss1 sseli adantl disjsn sylibr
      con3i wb inss2 frn syl5ss reldisj mpbid imass2 eqsstrd mblss cfn cmbf w3a
      isi1f simprbi simp3d eqeltrrd ovolsscl syl3anc eqeltrd ) BCDEZFAEZGZQZBUA
      ZAHZIJZWHKJZRWFWHIDZEZWIWJLWCWLWEABMNWHOPWFWHWGRFUBZUCZHZSWORSZWOKJZREWJR
      EWFWHWGABUDZTZHZWOWFWTWHWGWRHZTZWHWFRRBUEZBUFWTXBLWCXCWEBUGZNRRBUKAWRBUHU
      LWHXASXBWHLWHBDXABAUIBUJUMWHXAUNUOUPWFWSWNSZWTWOSWFWSWMTUQLZXEWFFWSEZGZXF
      WEXHWCXGWDWSAFAWRURUSVCUTWSFVAVBWFWSRSZXFXEVDWCXIWEWCWSWRRAWRVEWCXCWRRSXD
      RRBVFPVGNWSWMRVHPVIWSWNWGVJPVKWFWOWKEZWPWCXJWEWNBMNZWOVLPWFWOIJZWQRWFXJXL
      WQLXKWOOPWCXLREZWEWCXCWRVMEZXMWCBVNEXCXNXMVOBVPVQVRNVSWHWOVTWAWB $.

    $( Preimage of a singleton.  (Contributed by Mario Carneiro,
       26-Jun-2014.) $)
    i1fima2sn $p |- ( ( F e. dom S.1 /\ A e. ( B \ { 0 } ) ) ->
                    ( vol ` ( `' F " { A } ) ) e. RR ) $=
      ( cc0 csn cdif wcel citg1 cdm wn ccnv cima cvol cfv cr eldifn elsni snidg
      eqeltrrd nsyl i1fima2 sylan2 ) ABDEZFGZCHIGDAEZGZJCKUELMNOGUDAUCGUFABUCPU
      FDAUCDAQDUERSTUECUAUB $.

    ${
      $d x y F $.  $d x y ph $.
      i1fd.1 $e |- ( ph -> F : RR --> RR ) $.
      i1fd.2 $e |- ( ph -> ran F e. Fin ) $.
      i1fd.3 $e |- ( ( ph /\ x e. ( ran F \ { 0 } ) ) ->
                     ( `' F " { x } ) e. dom vol ) $.
      i1fd.4 $e |- ( ( ph /\ x e. ( ran F \ { 0 } ) ) ->
                     ( vol ` ( `' F " { x } ) ) e. RR ) $.
      $( A simplified set of assumptions to show that a given function is
         simple.  (Contributed by Mario Carneiro, 26-Jun-2014.) $)
      i1fd $p |- ( ph -> F e. dom S.1 ) $=
        ( vy wcel cr cc0 cdif cima cvol cfv wa wceq wss syl wn cmbf wf crn ccnv
        cfn csn w3a citg1 cv cioo wral wfun ad2antrr ffun funcnvcnv imadif 4syl
        cdm cpw cxr cxp ioof frn ax-mp sseli elpwid ad2antlr dfss4 sylib eqtr3d
        imaeq2d fimacnv rembl syl6eqel wi wal cin adantr inpreima iunid imaeq2i
        ciun imaiun eqtr3i cnvimass cnvimarndm sseqtr4i df-ss mpbi 3eqtr3g 3syl
        inss2 ssfi sylancl simpll c0 inss1 con3i adantl disjsn sylibr wb sselda
        reldisj syl2anc ralrimiva finiunmbl eqeltrrd ex alrimiv elndif cvv reex
        difexg eleq2 notbid imaeq2 eleq1d imbi12d spcv difmbl spv imp pm2.61dan
        adantlr ismbf mpbird covol mblvol csu cle wbr mblss fsumrecl fveq2d jca
        sylc ovolfiniun eqbrtrrd ovollecl syl3anc neldifsn ee10 isi1f sylanbrc
        eqeltrd 3jca ) ACUAIZJJCUBZCUCZUEIZCUDZJKUFZLZMZNOZJIZUGCUHURIAUUHUULBU
        IZMZNURZIZBUJUCZUKZAUVABUVBAUURUVBIZPZKUURIZUVAUVEUVFPZUULJMZUULJUURLZM
        ZLZUUSUUTUVGUULJUVILZMZUVKUUSUVGUUICULZUULUDULUVMUVKQAUUIUVDUVFDUMZJJCU
        NZCUOJUVIUULUPUQUVGUVLUURUULUVGUURJRZUVLUURQUVDUVQAUVFUVDUURJUVBJUSZUUR
        UTUTVAZUVRUJUBUVBUVRRVBUVSUVRUJVCVDVEVFVGUURJVHVIVKVJUVGUVHUUTIUVJUUTIZ
        UVKUUTIUVGUVHJUUTUVGUUIUVHJQUVOJJCVLSVMVNUVGKHUIZIZTZUULUWAMZUUTIZVOZHV
        PZKUVIIZTZUVTAUWGUVDUVFAUWFHAUWCUWEAUWCPZBUWAUUJVQZUULUURUFZMZWBZUWDUUT
        UWJUUIUVNUWNUWDQAUUIUWCDVRUVPUVNUULUWKMZUWDUULUUJMZVQZUWNUWDUWAUUJCVSUU
        LBUWKUWLWBZMUWOUWNUWRUWKUULBUWKVTWABUULUWKUWLWCWDUWDUWPRUWQUWDQUWDCURUW
        PCUWAWECWFWGUWDUWPWHWIWJWKZUWJUWKUEIZUWMUUTIZBUWKUKUWNUUTIUWJUUKUWKUUJR
        ZUWTAUUKUWCEVRUWAUUJWLZUUJUWKWMWNZUWJUXABUWKUWJUURUWKIZPZAUURUUJUUMLZIZ
        UXAAUWCUXEWOZUWJUWKUXGUURUWJUWKUUMVQWPQZUWKUXGRZUWJKUWKIZTZUXJUWCUXMAUX
        LUWBUWKUWAKUWAUUJWQVEWRWSUWKKWTXAUXBUXJUXKXBUXCUWKUUMUUJXDVDVIXCZFXEZXF
        UWKUWMBXGXEXHZXIXJZUMUVFUWIUVEKUURJXKWSUWFUWIUVTVOHUVIJXLIZUVIXLIXMJUUR
        XLXNVDUWAUVIQZUWCUWIUWEUVTUXSUWBUWHUWAUVIKXOXPUXSUWDUVJUUTUWAUVIUULXQXR
        XSXTYQUVHUVJYAXEXHAUVFTZUVAUVDAUXTUVAAUWGUXTUVAVOZUXQUWFUYAHBUWAUURQZUW
        CUXTUWEUVAUYBUWBUVFUWAUURKXOXPUYBUWDUUSUUTUWAUURUULXQXRXSYBSYCYEYDXFAUU
        IUUHUVCXBDBJCYFSYGAUUIUUKUUQDEAUWCUWDNOZJIZVOZHVPKUUNIZTZUUQAUYEHAUWCUY
        DUWJUYCUWDYHOZJUWJUWEUYCUYHQUXPUWDYISUWJUWDJRZUWKUWMYHOZBYJZJIUYHUYKYKY
        LUYHJIUWJUWEUYIUXPUWDYMSUWJUWKUYJBUXDUXFUWMNOZUYJJUXFUXAUYLUYJQUXOUWMYI
        SUXFAUXHUYLJIUXIUXNGXEXHZYNUWJUWNYHOZUYHUYKYKUWJUWNUWDYHUWSYOUWJUWTUWMJ
        RZUYJJIZPZBUWKUKUYNUYKYKYLUXDUWJUYQBUWKUXFUYOUYPUXFUXAUYOUXOUWMYMSUYMYP
        XFUWKUWMBYRXEYSUWDUYKYTUUAUUFXIXJKJUUBUYEUYGUUQVOHUUNUXRUUNXLIXMJUUMXLX
        NVDUWAUUNQZUWCUYGUYDUUQUYRUWBUYFUWAUUNKXOXPUYRUYCUUPJUYRUWDUUONUWAUUNUU
        LXQYOXRXSXTUUCUUGCUUDUUE $.
    $}

    $( Any simple function takes the value zero on a set of unbounded measure,
       so in particular this set is not empty.  (Contributed by Mario Carneiro,
       18-Jun-2014.) $)
    i1f0rn $p |- ( F e. dom S.1 -> 0 e. ran F ) $=
      ( citg1 cdm wcel cc0 crn cpnf cr pnfnre neli wn cvol cfv covol wceq rembl
      wa mblvol ax-mp ovolre ccnv cima cnvimarndm wf i1ff fdm syl adantr syl5eq
      eqtri fveq2d i1fima2 eqeltrrd syl5eqelr ex mt3i ) ABCDZEAFZDZGHDZGHIJUQUS
      KZUTUQVAQZGHLMZHVCHNMZGHLCDVCVDOPHRSTUJVBAUAURUBZLMVCHVBVEHLVBVEACZHAUCUQ
      VFHOZVAUQHHAUDVGAUEHHAUFUGUHUIUKURAULUMUNUOUP $.

    $( The value of the integral on simple functions.  (Contributed by Mario
       Carneiro, 18-Jun-2014.) $)
    itg1val $p |- ( F e. dom S.1 -> ( S.1 ` F ) =
           sum_ x e. ( ran F \ { 0 } ) ( x x. ( vol ` ( `' F " { x } ) ) ) ) $=
      ( vg vf citg1 cfv crn csn cdif cv ccnv cima cvol cmul co csu wceq cr wcel
      sumex cc0 cfn w3a cmbf crab cdm rneq difeq1d imaeq1d fveq2d oveq2d adantr
      wf cnveq sumeq12dv df-itg1 fvmpt dmmpti eleq2s ) BEFBGZUAHZIZAJZBKZVCHZLZ
      MFZNOZAPZQBRRCJZUMVJGUBSVJKRVAILMFRSUCCUDUEZEUFDBDJZGZVAIZVCVLKZVELZMFZNO
      ZAPZVIVKEVLBQZVNVBVRVHAVTVMUTVAVLBUGUHVTVRVHQVCVNSVTVQVGVCNVTVPVFMVTVOVDV
      EVLBUNUIUJUKULUOADCUPZVBVHATUQDVKVSEVNVRATWAURUS $.

    $( The value of the integral on simple functions.  (Contributed by Mario
       Carneiro, 26-Jun-2014.) $)
    itg1val2 $p |- ( ( F e. dom S.1 /\
        ( A e. Fin /\ ( ran F \ { 0 } ) C_ A /\ A C_ ( RR \ { 0 } ) ) ) ->
      ( S.1 ` F ) = sum_ x e. A ( x x. ( vol ` ( `' F " { x } ) ) ) ) $=
      ( citg1 cdm wcel cc0 csn cdif wss cr wa cfv cvol cmul co wceq syl c0 wn
      cfn crn w3a cv ccnv cima itg1val adantr simpr2 cc sselda simpr3 i1fima2sn
      csu eldifi adantlr syldan remulcld recnd wf cin i1ff ad2antrr dffn3 sylib
      wfn ffn eldifn adantl ssdifssd simpr sseldd biantrud eldif syl6rbbr mtbid
      simplr3 disjsn sylibr fimacnvdisj syl2anc fveq2d covol mblvol ax-mp ovol0
      0mbl eqtri syl6eq oveq2d sylan2 mul01d eqtrd simpr1 fsumss ) CDEFZBUAFZCU
      BZGHZIZBJZBKWSIZJZUCZLZCDMZWTAUDZCUEXGHZUFZNMZOPZAUNZBXKAUNWPXFXLQXDACUGU
      HXEWTBXKAWPWQXAXCUIZXEXGWTFZXGBFZXKUJFXEWTBXGXMUKXEXOLZXKXPXGXJXPXGXBFZXG
      KFZXEBXBXGWPWQXAXCULUKZXGKWSUORZXEXOXQXJKFZXSWPXQYAXDXGKCUMUPUQURUSUQXEXG
      BWTIZFZLZXKXGGOPGYDXJGXGOYDXJSNMZGYDXISNYDKWRCUTZWRXHVASQZXISQYDKKCUTZYFW
      PYHXDYCCVBVCYHCKVFYFKKCVGKCVDVERYDXGWRFZTYGYDXNYIYCXNTXEXGBWTVHVIYDYIYIXG
      WSFTZLXNYDYJYIYDXQYJYDYBXBXGYDBXBWTWQXAXCWPYCVQVJXEYCVKVLXGKWSVHRVMXGWRWS
      VNVOVPWRXGVRVSKWRXHCVTWAWBYESWCMZGSNEFYEYKQWGSWDWEWFWHWIWJYDXGYDXGYCXEXOX
      RXGBWTUOXTWKUSWLWMWPWQXAXCWNWOWM $.

    $( Closure of the integral on simple functions.  (Contributed by Mario
       Carneiro, 26-Jun-2014.) $)
    itg1cl $p |- ( F e. dom S.1 -> ( S.1 ` F ) e. RR ) $=
      ( vx citg1 cdm wcel cfv crn cc0 csn cdif cv ccnv cima cvol cmul co csu cr
      cfn wss itg1val i1frn difss ssfi sylancl wa wf frn syl ssdifssd i1fima2sn
      i1ff sselda remulcld fsumrecl eqeltrd ) ACDEZACFAGZHIZJZBKZALVAIMNFZOPZBQ
      RBAUAUQUTVCBUQURSEUTURTUTSEAUBURUSUCURUTUDUEUQVAUTEUFVAVBUQUTRVAUQURRUSUQ
      RRAUGURRTAULRRAUHUIUJUMVAURAUKUNUOUP $.

    $( Closure of the integral on positive simple functions.  (Contributed by
       Mario Carneiro, 19-Jun-2014.) $)
    itg1ge0 $p |- ( ( F e. dom S.1 /\ 0p oR <_ F ) -> 0 <_ ( S.1 ` F ) ) $=
      ( vx vy citg1 wcel c0p cle wbr wa cc0 cfv wss adantr syl cvv wfn a1i wceq
      cr cc cdm cofr crn csn cdif cv ccnv cima cvol cmul co csu cfn i1frn difss
      ssfi sylancl wf frn ssdifssd sselda i1fima2sn adantlr remulcld eldifi cxp
      i1ff wral 0cn fnconstg ax-mp df-0p fneq1i mpbir ffn cnex reex cin sseqin2
      ax-resscn mpbi 0pval adantl eqidd ofrfval biimpa wb breq2 mpbird r19.21bi
      ralrn sylan2 i1fima ad2antrr covol mblss ovolge0 breqtrrd mulge0d fsumge0
      mblvol itg1val ) ADUAEZFAGUBHZIZJAUCZJUDZUEZBUFZAUGXIUDZUHZUIKZUJUKZBULZA
      DKZGXEXHXMBXCXHUMEZXDXCXFUMEXHXFLXPAUNXFXGUOXFXHUPUQMXEXIXHEZIZXIXLXEXHSX
      IXEXFSXGXESSAURZXFSLXCXSXDAVGZMSSAUSNUTVAZXCXQXLSEXDXIXFAVBVCZVDXRXIXLYAY
      BXQXEXIXFEJXIGHZXIXFXGVEXEYCBXFXEYCBXFVHZJCUFZAKZGHZCSVHZXCXDYHXCCTSJYFGS
      FAOOFTPZXCYITXGVFZTPZJTEYKVITJTVJVKTFYJVLVMVNQXCXSASPZXTSSAVONZTOEXCVPQSO
      EXCVQQSTLTSVRSRVTSTVSWAYETEYEFKJRXCYEWBWCXCYESEIYFWDWEWFXEYLYDYHWGXCYLXDY
      MMYCYGBCSAXIYFJGWHWKNWIWJWLXRXKUIUAEZJXLGHXCYNXDXQXJAWMWNYNJXKWOKZXLGYNXK
      SLJYOGHXKWPXKWQNXKXAWRNWSWTXCXOXNRXDBAXBMWR $.
  $}

  $( The zero function is simple.  (Contributed by Mario Carneiro,
     18-Jun-2014.) $)
  i1f0 $p |- ( RR X. { 0 } ) e. dom S.1 $=
    ( vx cr cc0 csn cxp citg1 cdm wcel wtru wf 0re fconst6 a1i crn cfn wss snfi
    cvol adantl pm2.21dd rnxpss ssfi mp2an cv cdif wa ccnv difss sstri sseli wn
    cima eldifn cfv i1fd trud ) BCDZEZFGHIAURBBURJIBCBKLMURNZOHZIUQOHUSUQPUTCQB
    UQUAZUQUSUBUCMIAUDZUSUQUEZHZUFZVBUQHZURUGVBDULZRGHVDVFIVCUQVBVCUSUQUSUQUHVA
    UIUJSZVDVFUKIVBUSUQUMSZTVEVFVGRUNBHVHVITUOUP $.

  $( The zero function has zero integral.  (Contributed by Mario Carneiro,
     18-Jun-2014.) $)
  itg10 $p |- ( S.1 ` ( RR X. { 0 } ) ) = 0 $=
    ( vx cr cc0 csn cxp citg1 cfv crn cdif cv ccnv cima cvol cmul co csu c0 cdm
    wcel wceq i1f0 itg1val ax-mp wss rnxpss ssdif0 mpbi sumeq1i sum0 3eqtri ) B
    CDZEZFGZULHZUKIZAJZULKUPDLMGNOZAPZQUQAPCULFRSUMURTUAAULUBUCUOQUQAUNUKUDUOQT
    BUKUEUNUKUFUGUHUQAUIUJ $.

  ${
    $d x y A $.  $d y z F $.
    i1f1.1 $e |- F = ( x e. RR |-> if ( x e. A , 1 , 0 ) ) $.
    $( Lemma for ~ i1f1 and ~ itg11 .  (Contributed by Mario Carneiro,
       18-Jun-2014.) $)
    i1f1lem $p |- ( F : RR --> { 0 , 1 } /\
                    ( A e. dom vol -> ( `' F " { 1 } ) = A ) ) $=
      ( vy cr cc0 c1 cpr wf wcel wceq cv cif 1ex c0ex wa eqeq1d wn syl6bb prid2
      cvol cdm ccnv csn cima wi wral prid1 keepel rgenw fmpt mpbi cfv wfn fmptd
      wb a1i ffn elpreima 3syl fvex elsnc eleq1 ifbid ifex fvmpt ax-1ne0 necomi
      wne iffalse necon3bbid mpbiri con4i iftrue impbii syl5bb pm5.32i pm4.71rd
      mblss sseld bitr4d eqrdv pm3.2i ) FGHIZCJZBUBUCKZCUDHUEZUFZBLUGAMZBKZHGNZ
      WEKZAFUHWFWMAFWKHGWEGHOUAGHPUIUJZUKAFWEWLCDULUMWGEWIBWGEMZWIKZWOFKZWOBKZQ
      ZWRWGWPWQWOCUNZWHKZQZWSWGWFCFUOWPXBUQWGAFWLWECWMWGWJFKQWNURDUPFWECUSFWOWH
      CUTVAWQXAWRXAWTHLZWQWRWTHWOCVBVCWQXCWRHGNZHLZWRWQWTXDHAWOWLXDFCWJWOLWKWRH
      GWJWOBVDVEDWRHGOPVFVGRXEWRWRXEWRSZXESGHVJHGVHVIXFXEGHXFXDGHWRHGVKRVLVMVNW
      RHGVOVPTVQVRTWGWRWQWGBFWOBVTWAVSWBWCWD $.

    $( Base case simple functions are indicator functions of measurable sets.
       (Contributed by Mario Carneiro, 18-Jun-2014.) $)
    i1f1 $p |- ( ( A e. dom vol /\ ( vol ` A ) e. RR ) -> F e. dom S.1 ) $=
      ( vy cvol wcel cfv cr wa wf cc0 c1 wss csn cima wceq mp2an a1i cdif prssi
      cdm cpr ccnv wi i1f1lem simpli 0re 1re fss cfn crn prfi cv cif prid2 c0ex
      1ex prid1 keepel fmptd frn syl ssfi sylancr cun ax-mp df-pr sseqtri ssdif
      equncomi difun2 difss eqsstri sstri sseli imaeq2d simpri adantr sylan9eqr
      elsni sneqd simpll eqeltrd fveq2d simplr i1fd ) BFUBZGZBFHZIGZJZECIICKZWL
      ILMUCZCKZWNINZWMWOWICUDZMOZPZBQZUEZABCDUFZUGZLIGMIGWPUHUILMIUARIWNICUJRSW
      LWNUKGCULZWNNZXDUKGLMUMWLWOXEWLAIAUNZBGZMLUOZWNCXHWNGWLXFIGJXGMLWNLMURUPL
      MUQUSUTSDVAIWNCVBZVCWNXDVDVEWLEUNZXDLOZTZGZJZWQXJOZPZBWHXMWLXPWSBXMXOWRWQ
      XMXJMXMXJWRGXJMQXLWRXJXLWRXKVFZXKTZWRXDXQNXLXRNXDWNXQWOXEXCXIVGWNXKWRLMVH
      VKVIXDXQXKVJVGXRWRXKTWRWRXKVLWRXKVMVNVOVPXJMWAVCWBVQWIWTWKWOXAXBVRVSVTZWI
      WKXMWCWDXNXPFHWJIXNXPBFXSWEWIWKXMWFWDWG $.

    $( The integral of an indicator function is the volume of the set.
       (Contributed by Mario Carneiro, 18-Jun-2014.)  (Revised by Mario
       Carneiro, 23-Aug-2014.) $)
    itg11 $p |- ( ( A e. dom vol /\ ( vol ` A ) e. RR ) ->
                  ( S.1 ` F ) = ( vol ` A ) ) $=
      ( vy vz cvol wcel cfv cr citg1 wceq c0 cc0 csn ax-mp c1 cmul wss eqtrd wa
      cdm wi cxp covol ovol0 0mbl mblvol itg10 3eqtr4ri cv cif cmpt noel mtbiri
      eleq2 iffalse syl mpteq2dv fconstmpt 3eqtr4g fveq2d fveq2 3eqtr4a a1i wne
      wn wex n0 crn cdif ccnv cima co csu i1f1 adantr itg1val wf i1f1lem simpli
      cpr ssdif difprsnss sstri mblss sselda eleq1 ifbid c0ex ifex fvmpt iftrue
      frn 1ex adantl wfn ffn fnfvelrn sylancr eqeltrrd ax-1ne0 eldifsn sylanbrc
      snssd eqssd sumeq1d cc 1re simpri ad2antrr oveq2d simplr recnd mulid2d id
      eqeltrd sneq imaeq2d oveq12d sumsn ex exlimdv syl5bi pm2.61dne ) BGUBZHZB
      GIZJHZUAZCKIZYHLZBMBMLZYLUCYJYMJNOZUDZKIZMGIZYKYHMUEIZNYQYPUFMYFHYQYRLUGM
      UHPUIUJYMCYOKYMAJAUKZBHZQNULZUMAJNUMCYOYMAJUUANYMYTVGUUANLYMYTYSMHYSUNBMY
      SUPUOYTQNUQURUSDAJNUTVAVBBMGVCVDVEBMVFEUKZBHZEVHYJYLEBVIYJUUCYLEYJUUCYLYJ
      UUCUAZYKCVJZYNVKZFUKZCVLZUUGOZVMZGIZRVNZFVOZYHUUDCKUBHZYKUUMLYJUUNUUCABCD
      VPVQFCVRURUUDUUMQOZUULFVOZYHUUDUUFUUOUULFUUDUUFUUOUUFUUOSUUDUUFNQWBZYNVKZ
      UUOUUEUUQSZUUFUURSJUUQCVSZUUSUUTYGUUHUUOVMZBLZUCZABCDVTZWAZJUUQCWNPUUEUUQ
      YNWCPNQWDWEVEUUDQUUFUUDQUUEHQNVFZQUUFHUUDUUBCIZQUUEUUDUVGUUCQNULZQUUDUUBJ
      HZUVGUVHLYJBJUUBYGBJSYIBWFVQWGZAUUBUUAUVHJCYSUUBLYTUUCQNYSUUBBWHWIDUUCQNW
      OWJWKWLURUUCUVHQLYJUUCQNWMWPTUUDCJWQZUVIUVGUUEHUUTUVKUVEJUUQCWRPUVJJUUBCW
      SWTXAUVFUUDXBVEQUUENXCXDXEXFXGUUDUUPQUVAGIZRVNZYHUUDQJHUVMXHHUUPUVMLXIUUD
      UVMYHXHUUDUVMQYHRVNYHUUDUVLYHQRUUDUVABGYGUVBYIUUCUUTUVCUVDXJXKVBXLUUDYHUU
      DYHYGYIUUCXMXNZXOTZUVNXQUULUVMFQJUUGQLZUUGQUUKUVLRUVPXPUVPUUJUVAGUVPUUIUU
      OUUHUUGQXRXSVBXTYAWTUVOTTTYBYCYDYE $.
  $}

  ${
    $d k x y A $.  $d x y B $.  $d k y F $.  $d k x ph $.
    itg1addlem.1 $e |- ( ph -> F : X --> Y ) $.
    itg1addlem.2 $e |- ( ph -> A e. Fin ) $.
    itg1addlem.3 $e |- ( ( ph /\ k e. A ) -> B C_ ( `' F " { k } ) ) $.
    itg1addlem.4 $e |- ( ( ph /\ k e. A ) -> B e. dom vol ) $.
    itg1addlem.5 $e |- ( ( ph /\ k e. A ) -> ( vol ` B ) e. RR ) $.
    $( Decompose a preimage, which is always a disjoint union.  (Contributed by
       Mario Carneiro, 25-Jun-2014.)  (Proof shortened by Mario Carneiro,
       11-Dec-2016.) $)
    itg1addlem1 $p |- ( ph ->
      ( vol ` U_ k e. A B ) = sum_ k e. A ( vol ` B ) ) $=
      ( vx wcel cvol cfv wa wral wceq syl cfn cdm cr wdisj csu cv jca ralrimiva
      ciun ccnv csn cima wss adantrr simprr sseldd wfn wb wf ffn fniniseg mpbid
      adantr simprd ralrimivva invdisj volfiniun syl3anc ) ABUANCOUBNZCOPZUCNZQ
      ZDBRDBCUDZDBCUIOPBVJDUESIAVLDBADUFZBNZQVIVKKLUGUHAMUFZEPZVNSZMCRDBRVMAVRD
      MBCAVOVPCNZQZQZVPFNZVRWAVPEUJVNUKULZNZWBVRQZWACWCVPAVOCWCUMVSJUNAVOVSUOUP
      WAEFUQZWDWEURAWFVTAFGEUSWFHFGEUTTVCFVNVPEVATVBVDVEDMBCVQVFTBCDVGVH $.
  $}

  ${
    $d i j y z A $.  $d i j B $.  $d w y z H $.  $d w y I $.  $d v w x y z P $.
    $d i j u v w x y z F $.  $d i j u v w x y z G $.  $d i j v w x y z ph $.
    i1fadd.1 $e |- ( ph -> F e. dom S.1 ) $.
    i1fadd.2 $e |- ( ph -> G e. dom S.1 ) $.
    $( Decompose the preimage of a sum.  (Contributed by Mario Carneiro,
       19-Jun-2014.) $)
    i1faddlem $p |- ( ( ph /\ A e. CC ) -> ( `' ( F oF + G ) " { A } ) =
      U_ y e. ran G ( ( `' F " { ( A - y ) } ) i^i ( `' G " { y } ) ) ) $=
      ( cc wcel wa caddc co csn cima cmin cr wceq wb cvv syl vz cof ccnv crn cv
      cin ciun wrex cfv wfn wf citg1 cdm i1ff ffn reex a1i offn adantr fniniseg
      inidm ad2antrr simprl fnfvelrn syl2anc simprr eqidd ofval ad2ant2r eqtr3d
      oveq1d wss ax-resscn fss sylancl ffvelrnd pncand mpbir2and sylanbrc oveq2
      eqtr2d elin sneqd imaeq2d ineq12d eleq2d rspcev ex anbi12d anandi simprrl
      simprrr oveq12d simplr eqeltrrd npcand 3eqtrd jca sylbid syl5bi rexlimdvw
      sneq syl5bir impbid bitrd eliun syl6bbr eqrdv ) ACHIZJZUADEKUBLZUCCMNZBEU
      DZDUCZCBUEZOLZMZNZEUCZXOMZNZUFZUGZXJUAUEZXLIZYDYBIZBXMUHZYDYCIXJYEYDPIZYD
      XKUIZCQZJZYGXJXKPUJZYEYKRAYLXIAPPKPDESSAPPDUKZDPUJZADULUMZIYMFDUNTZPPDUOT
      ZAPPEUKZEPUJZAEYOIYRGEUNTZPPEUOTZPSIAUPUQZUUBPVAZURUSPCYDXKUTTXJYKYGXJYKY
      GXJYKJZYDEUIZXMIZYDXNCUUEOLZMZNZXSUUEMZNZUFZIZYGUUDYSYHUUFAYSXIYKUUAVBZXJ
      YHYJVCZPYDEVDVEUUDYDUUIIZYDUUKIZUUMUUDUUPYHYDDUIZUUGQZUUOUUDUUGUURUUEKLZU
      UEOLUURUUDCUUTUUEOUUDYICUUTXJYHYJVFAYHYIUUTQZXIYJAPPUURUUEKPDESSYDYQUUAUU
      BUUBUUCAYHJZUURVGUVBUUEVGVHZVIVJVKUUDUURUUEUUDPHYDDAPHDUKZXIYKAYMPHVLZUVD
      YPVMPPHDVNVOVBUUOVPUUDPHYDEAPHEUKZXIYKAYRUVEUVFYTVMPPHEVNVOZVBUUOVPVQWAUU
      DYNUUPYHUUSJRAYNXIYKYQVBPUUGYDDUTTVRUUDUUQYHUUEUUEQZUUOUUDUUEVGUUDYSUUQYH
      UVHJRUUNPUUEYDEUTTVRYDUUIUUKWBVSYFUUMBUUEXMXOUUEQZYBUULYDUVIXRUUIYAUUKUVI
      XQUUHXNUVIXPUUGXOUUECOVTWCWDUVIXTUUJXSXOUUEXBWDWEWFWGVEWHXJYFYKBXMYFYDXRI
      ZYDYAIZJZXJYKYDXRYAWBXJUVLYHUURXPQZJZYHUUEXOQZJZJZYKXJUVJUVNUVKUVPXJYNUVJ
      UVNRAYNXIYQUSPXPYDDUTTXJYSUVKUVPRAYSXIUUAUSPXOYDEUTTWIUVQYHUVMUVOJZJZXJYK
      YHUVMUVOWJXJUVSYKXJUVSJZYHYJXJYHUVRVCZUVTYIUUTXPXOKLCAYHUVAXIUVRUVCVIUVTU
      URXPUUEXOKXJYHUVMUVOWKXJYHUVMUVOWLZWMUVTCXOAXIUVSWNUVTUUEXOHUWBUVTPHYDEAU
      VFXIUVSUVGVBUWAVPWOWPWQWRWHXCWSWTXAXDXEBYDXMYBXFXGXH $.

    $( Decompose the preimage of a product.  (Contributed by Mario Carneiro,
       19-Jun-2014.) $)
    i1fmullem $p |- ( ( ph /\ A e. ( CC \ { 0 } ) ) ->
      ( `' ( F oF x. G ) " { A } ) = U_ y e. ( ran G \ { 0 } )
        ( ( `' F " { ( A / y ) } ) i^i ( `' G " { y } ) ) ) $=
      ( cc0 csn wcel wa cmul co cima cdiv cr wceq wb cvv syl vz cc cdif cof crn
      ccnv cv cin ciun wrex cfv wfn wf citg1 cdm i1ff ffn reex a1i inidm adantr
      fniniseg eqidd ofval eqeq1d pm5.32da wne ad2antrr simprl fnfvelrn syl2anc
      offn eldifsni ad2antlr simprr ffvelrnd recnd mul01d 3netr4d oveq2 necon3i
      eldifsn sylanbrc divcan4d oveq1d eqtr3d mpbir2and elin sneqd imaeq2d sneq
      ineq12d eleq2d rspcev anbi12d anandi 3bitr4g eldifi wss frn simpld sseldd
      ex wi sylib simprd divcan1d oveq12 syl5ibrcom imdistanda sylbid rexlimdva
      anassrs impbid 3bitrd eliun syl6bbr eqrdv ) ACUBHIZUCJZKZUADELUDMZUFCINZB
      EUEZXSUCZDUFZCBUGZOMZIZNZEUFZYGIZNZUHZUIZYAUAUGZYCJZYPYNJZBYEUJZYPYOJYAYQ
      YPPJZYPYBUKZCQZKZYTYPDUKZYPEUKZLMZCQZKZYSYAYBPULZYQUUCRAUUIXTAPPLPDESSAPP
      DUMZDPULZADUNUOZJUUJFDUPTZPPDUQZTZAPPEUMZEPULZAEUULJUUPGEUPTZPPEUQTZPSJZA
      URUSZUVAPUTZVLVAPCYPYBVBTYAYTUUBUUGYAYTKZUUAUUFCYAPPUUDUUELPDESSYPAUUKXTU
      UOVAZAUUQXTUUSVAZUUTYAURUSZUVFUVBUVCUUDVCUVCUUEVCVDVEVFYAUUHYSYAUUHYSYAUU
      HKZUUEYEJZYPYFCUUEOMZIZNZYKUUEIZNZUHZJZYSUVGUUEYDJZUUEHVGZUVHUVGUUQYTUVPA
      UUQXTUUHUUSVHZYAYTUUGVIZPYPEVJVKUVGUUFUUDHLMZVGUVQUVGCHUUFUVTXTCHVGAUUHCU
      BHVMVNYAYTUUGVOZUVGUUDUVGUUDUVGPPYPDAUUJXTUUHUUMVHZUVSVPVQZVRVSUUEHUUFUVT
      UUEHUUDLVTWATZUUEYDHWBWCUVGYPUVKJZYPUVMJZUVOUVGUWEYTUUDUVIQZUVSUVGUUFUUEO
      MUUDUVIUVGUUDUUEUWCUVGUUEUVGPPYPEAUUPXTUUHUURVHUVSVPVQUWDWDUVGUUFCUUEOUWA
      WEWFUVGUUKUWEYTUWGKRUVGUUJUUKUWBUUNTPUVIYPDVBTWGUVGUWFYTUUEUUEQZUVSUVGUUE
      VCUVGUUQUWFYTUWHKRUVRPUUEYPEVBTWGYPUVKUVMWHWCYRUVOBUUEYEYGUUEQZYNUVNYPUWI
      YJUVKYMUVMUWIYIUVJYFUWIYHUVIYGUUECOVTWIWJUWIYLUVLYKYGUUEWKWJWLWMWNVKXCYAY
      RUUHBYEYAYGYEJZKZYRYTUUDYHQZUUEYGQZKZKZUUHYAYRUWORUWJYAYPYJJZYPYMJZKYTUWL
      KZYTUWMKZKYRUWOYAUWPUWRUWQUWSYAUUKUWPUWRRUVDPYHYPDVBTYAUUQUWQUWSRUVEPYGYP
      EVBTWOYPYJYMWHYTUWLUWMWPWQVAUWKYTUWNUUGYAUWJYTUWNUUGXDYAUWJYTKZKZUUGUWNYH
      YGLMZCQUXACYGXTCUBJAUWTCUBXSWRVNUXAYGUXAYDPYGUXAUUPYDPWSAUUPXTUWTUURVHPPE
      WTTUXAYGYDJZYGHVGZUXAUWJUXCUXDKYAUWJYTVIYGYDHWBXEZXAXBVQUXAUXCUXDUXEXFXGU
      WNUUFUXBCUUDYHUUEYGLXHVEXIXMXJXKXLXNXOBYPYEYNXPXQXR $.

    $( The sum of two simple functions is a simple function.  (Contributed by
       Mario Carneiro, 18-Jun-2014.) $)
    i1fadd $p |- ( ph -> ( F oF + G ) e. dom S.1 ) $=
      ( vu vv vz caddc cr cv wcel wa wf syl wss wceq cc0 cvol cfv vy vx cof cvv
      vw readdcl adantl citg1 cdm i1ff reex a1i inidm off crn cmpt2 cfn cxp wfo
      i1frn xpfi syl2anc wfn eqid ovex fnmpt2i dffn4 mpbi fofi sylancl wrex cab
      co rspceov mp3an3 eqeq1 2rexbidv elab sylibr dffn3 sylib rnmpt2 syl6sseqr
      ffn frn ssfi csn cdif ccnv cima cmin cin ciun cc ssdifssd recnd i1faddlem
      sselda syldan wral adantr ad2antrr i1fmbf eldifi ad2antlr sseldd resubcld
      cmbf mbfimasn syl3anc inmbl ralrimiva finiunmbl eqeltrd covol csu cle wbr
      mblvol mblss inss1 adantrr simprr oveq2d subid1d imaeq2d fveq2d i1fima2sn
      eqtrd sneqd sylan eqeltrrd ovolsscl expr wne inss2 sylan2 i1fima sylan2br
      eldifsn pm2.61dne fsumrecl syl5ss jca ovolfiniun eqbrtrd ovollecl i1fd )
      AUABCIUCVMZAUBUAJJJIJJJBCUDUDUBKZJLUAKZJLMUUJUUKIVMZJLAUUJUUKUFUGABUHUIZL
      ZJJBNZDBUJOZACUUMLZJJCNZECUJOZJUDLAUKULZUUTJUMZUNZAFGBUOZCUOZFKZGKZIVMZUP
      ZUOZUQLZUUIUOZUVIPUVKUQLAUVCUVDURZUQLZUVLUVIUVHUSZUVJAUVCUQLZUVDUQLZUVMAU
      UNUVODBUTOAUUQUVPECUTOZUVCUVDVAVBUVHUVLVCUVNFGUVCUVDUVGUVHUVHVDZUVEUVFIVE
      VFUVLUVHVGVHUVLUVIUVHVIVJAUVKUEKZUVGQZGUVDVKFUVCVKZUEVLZUVIAJUWBUUINUVKUW
      BPAUBUAJJJIUVCUVDUWBBCUDUDUUJUVCLZUUKUVDLZMZUULUWBLZAUWEUULUVGQZGUVDVKFUV
      CVKZUWFUWCUWDUULUULQUWHUULVDFGUVCUVDUUJUUKUULIVNVOUWAUWHUEUULUUJUUKIVEUVS
      UULQUVTUWGFGUVCUVDUVSUULUVGVPVQVRVSUGABJVCZJUVCBNAUUOUWIUUPJJBWDOJBVTWAAC
      JVCZJUVDCNAUURUWJUUSJJCWDOJCVTWAUUTUUTUVAUNJUWBUUIWEOFGUEUVCUVDUVGUVHUVRW
      BWCUVIUVKWFVBAUUKUVKRWGZWHZLZMZUUIWIUUKWGZWJZHUVDBWIZUUKHKZWKVMZWGZWJZCWI
      UWRWGZWJZWLZWMZSUIZAUWMUUKWNLZUWPUXEQUWNUUKAUWLJUUKAUVKJUWKAJJUUINZUVKJPZ
      UVBJJUUIWEZOWOWRWPZAHUUKBCDEWQWSZUWNUVPUXDUXFLZHUVDWTUXEUXFLAUVPUWMUVQXAZ
      UWNUXMHUVDUWNUWRUVDLZMZUXAUXFLZUXCUXFLZUXMUXPBXHLZUUOUWSJLUXQUXPUUNUXSAUU
      NUWMUXODXBBXCOAUUOUWMUXOUUPXBUXPUUKUWRUXPUVKJUUKUXPUXHUXIAUXHUWMUXOUVBXBU
      XJOUWMUUKUVKLAUXOUUKUVKUWKXDXEXFUWNUVDJUWRUWNUURUVDJPAUURUWMUUSXAJJCWEOWR
      ZXGJUWSBXIXJZUXPCXHLZUURUWRJLUXRUXPUUQUYBAUUQUWMUXOEXBCXCOAUURUWMUXOUUSXB
      UXTJUWRCXIXJZUXAUXCXKVBXLUVDUXDHXMVBXNZUWNUWPSTZUWPXOTZJUWNUWPUXFLZUYEUYF
      QUYDUWPXSOUWNUWPJPZUVDUXDXOTZHXPZJLUYFUYJXQXRUYFJLUWNUYGUYHUYDUWPXTOUWNUV
      DUYIHUXNUXPUYIJLZUWRRUWNUXOUWRRQZUYKUWNUXOUYLMZMZUXDUXAPZUXAJPZUXAXOTZJLU
      YKUYOUYNUXAUXCYAULUYNUXQUYPUWNUXOUXQUYLUYAYBZUXAXTOUYNUXASTZUYQJUYNUXQUYS
      UYQQUYRUXAXSOUYNUYSUWQUWOWJZSTZJUYNUXAUYTSUYNUWTUWOUWQUYNUWSUUKUYNUWSUUKR
      WKVMUUKUYNUWRRUUKWKUWNUXOUYLYCYDUYNUUKUWNUXGUYMUXKXAYEYIYJYFYGUWNVUAJLZUY
      MAUUNUWMVUBDUUKUVKBYHYKXAXNYLUXDUXAYMXJYNUWNUXOUWRRYOZUYKUXOVUCMUWNUWRUVD
      UWKWHLZUYKUWRUVDRYTUWNVUDMZUXDUXCPZUXCJPZUXCXOTZJLUYKVUFVUEUXAUXCYPZULVUD
      UWNUXOVUGUWRUVDUWKXDUXPUXRVUGUYCUXCXTOZYQVUEUXCSTZVUHJVUEUXRVUKVUHQAUXRUW
      MVUDAUUQUXREUXBCYROXBUXCXSOUWNUUQVUDVUKJLAUUQUWMEXAUWRUVDCYHYKYLUXDUXCYMX
      JYSYNUUAZUUBUWNUYFUXEXOTZUYJXQUWNUWPUXEXOUXLYGUWNUVPUXDJPZUYKMZHUVDWTVUMU
      YJXQXRUXNUWNVUOHUVDUXPVUNUYKUXPUXDUXCJVUIVUJUUCVULUUDXLUVDUXDHUUEVBUUFUWP
      UYJUUGXJXNUUH $.

    $( The pointwise product of two simple functions is a simple function.
       (Contributed by Mario Carneiro, 5-Sep-2014.) $)
    i1fmul $p |- ( ph -> ( F oF x. G ) e. dom S.1 ) $=
      ( vu vv vz cmul cr cvv cv wcel wa wf syl cfn wss wceq cfv vy vx vw cof co
      remulcl adantl citg1 cdm i1ff reex a1i inidm off crn cmpt2 cxp i1frn xpfi
      wfo syl2anc wfn eqid ovex fnmpt2i dffn4 mpbi fofi sylancl wrex cab mp3an3
      rspceov eqeq1 2rexbidv elab sylibr ffn dffn3 sylib frn syl6sseqr ssfi cc0
      rnmpt2 csn cdif ccnv cima cdiv cin ciun cc ax-resscn syl6ss ssdifd sselda
      cvol i1fmullem syldan wral difss i1fima inmbl ralrimivw finiunmbl eqeltrd
      adantr covol mblvol csu cle mblss inss2 ad2antrr i1fima2sn sylan eqeltrrd
      wbr ovolsscl syl3anc fsumrecl fveq2d jca ovolfiniun eqbrtrd ovollecl i1fd
      ralrimiva ) AUABCIUDUEZAUBUAJJJIJJJBCKKUBLZJMUALZJMNYKYLIUEZJMAYKYLUFUGAB
      UHUIZMZJJBOZDBUJPZACYNMZJJCOZECUJPZJKMAUKULZUUAJUMZUNZAFGBUOZCUOZFLZGLZIU
      EZUPZUOZQMZYJUOZUUJRUULQMAUUDUUEUQZQMZUUMUUJUUIUTZUUKAUUDQMZUUEQMZUUNAYOU
      UPDBURPAYRUUQECURPZUUDUUEUSVAUUIUUMVBUUOFGUUDUUEUUHUUIUUIVCZUUFUUGIVDVEUU
      MUUIVFVGUUMUUJUUIVHVIAUULUCLZUUHSZGUUEVJFUUDVJZUCVKZUUJAJUVCYJOUULUVCRAUB
      UAJJJIUUDUUEUVCBCKKYKUUDMZYLUUEMZNZYMUVCMZAUVFYMUUHSZGUUEVJFUUDVJZUVGUVDU
      VEYMYMSUVIYMVCFGUUDUUEYKYLYMIVMVLUVBUVIUCYMYKYLIVDUUTYMSUVAUVHFGUUDUUEUUT
      YMUUHVNVOVPVQUGABJVBZJUUDBOAYPUVJYQJJBVRPJBVSVTACJVBZJUUECOAYSUVKYTJJCVRP
      JCVSVTUUAUUAUUBUNJUVCYJWAPFGUCUUDUUEUUHUUIUUSWEWBUUJUULWCVAAYLUULWDWFZWGZ
      MZNZYJWHYLWFWIZHUUEUVLWGZBWHYLHLZWJUEWFZWIZCWHUVRWFZWIZWKZWLZWRUIZAUVNYLW
      MUVLWGZMUVPUWDSAUVMUWFYLAUULWMUVLAUULJWMAJJYJOUULJRUUCJJYJWAPWNWOWPWQAHYL
      BCDEWSWTZAUWDUWEMZUVNAUVQQMZUWCUWEMZHUVQXAUWHAUUQUVQUUERUWIUURUUEUVLXBUUE
      UVQWCVIZAUWJHUVQAUVTUWEMZUWBUWEMZUWJAYOUWLDUVSBXCPAYRUWMEUWACXCPZUVTUWBXD
      VAZXEUVQUWCHXFVAXHXGZUVOUVPWRTZUVPXITZJUVOUVPUWEMZUWQUWRSUWPUVPXJPUVOUVPJ
      RZUVQUWCXITZHXKZJMUWRUXBXLXSUWRJMUVOUWSUWTUWPUVPXMPUVOUVQUXAHAUWIUVNUWKXH
      ZUVOUVRUVQMZNZUWCUWBRZUWBJRZUWBXITZJMUXAJMZUXFUXEUVTUWBXNULUXEUWMUXGAUWMU
      VNUXDUWNXOZUWBXMPUXEUWBWRTZUXHJUXEUWMUXKUXHSUXJUWBXJPUVOYRUXDUXKJMAYRUVNE
      XHUVRUUECXPXQXRUWCUWBXTYAZYBUVOUWRUWDXITZUXBXLUVOUVPUWDXIUWGYCUVOUWIUWCJR
      ZUXINZHUVQXAUXMUXBXLXSUXCUVOUXOHUVQUXEUXNUXIAUXNUVNUXDAUWJUXNUWOUWCXMPXOU
      XLYDYIUVQUWCHYEVAYFUVPUXBYGYAXGYH $.

    ${
      itg1add.3 $e |- I = ( i e. RR , j e. RR |-> if ( ( i = 0 /\ j = 0 ) , 0 ,
        ( vol ` ( ( `' F " { i } ) i^i ( `' G " { j } ) ) ) ) ) $.
      $( Lemma for ~ itg1add .  The function ` I ` represents the pieces into
         which we will break up the domain of the sum.  Since it is infinite
         only when both ` i ` and ` j ` are zero, we arbitrarily define it to
         be zero there to simplify the sums that are manipulated in
         ~ itg1addlem4 and ~ itg1addlem5 .  (Contributed by Mario Carneiro,
         26-Jun-2014.) $)
      itg1addlem2 $p |- ( ph -> I : ( RR X. RR ) --> RR ) $=
        ( cc0 wceq wa csn cvol cfv cr wcel syl ad2antrr wss cv ccnv cin cif cxp
        cima wral wf covol iffalse adantl cdm citg1 i1fima inmbl syl2anc mblvol
        wn eqtrd wne wo neorian inss1 mblss cdif simplrl simpr eldifsn sylanbrc
        i1fima2sn eqeltrrd ovolsscl syl3anc inss2 adantr simplrr jaodan eqeltrd
        a1i sylan2br ex iftrue 0re syl6eqel pm2.61d2 ralrimivva fmpt2 sylib ) A
        BUAZJKCUAZJKLZJDUBWIMZUFZEUBWJMZUFZUCZNOZUDZPQZCPUGBPUGPPUEPFUHAWSBCPPA
        WIPQZWJPQZLZLZWKWSXCWKURZWSXCXDLZWRWPUIOZPXEWRWQXFXDWRWQKXCWKJWQUJUKXEW
        PNULZQZWQXFKAXHXBXDAWMXGQZWOXGQZXHADUMULZQZXIGWLDUNRZAEXKQZXJHWNEUNZRWM
        WOUOUPSWPUQRUSXDXCWIJUTZWJJUTZVAXFPQZWIJWJJVBXCXPXRXQXCXPLZWPWMTZWMPTZW
        MUIOZPQXRXTXSWMWOVCVSXSXIYAAXIXBXPXMSZWMVDRXSWMNOZYBPXSXIYDYBKYCWMUQRXS
        XLWIPJMVEZQZYDPQAXLXBXPGSXSWTXPYFAWTXAXPVFXCXPVGWIPJVHVIWIPDVJUPVKWPWMV
        LVMXCXQLZWPWOTZWOPTZWOUIOZPQXRYHYGWMWOVNVSYGXJYIXCXJXQXCXNXJAXNXBHVOXOR
        VOZWOVDRYGWONOZYJPYGXJYLYJKYKWOUQRYGXNWJYEQZYLPQAXNXBXQHSYGXAXQYMAWTXAX
        QVPXCXQVGWJPJVHVIWJPEVJUPVKWPWOVLVMVQVTVRWAWKWRJPWKJWQWBWCWDWEWFBCPPWRP
        FIWGWH $.

      $( Lemma for ~ itg1add .  (Contributed by Mario Carneiro,
         26-Jun-2014.) $)
      itg1addlem3 $p |- ( ( ( A e. RR /\ B e. RR ) /\
                             -. ( A = 0 /\ B = 0 ) ) ->
          ( A I B ) = ( vol ` ( ( `' F " { A } ) i^i ( `' G " { B } ) ) ) ) $=
        ( cr wcel wa cc0 wceq ccnv csn cima cvol wn co cin cfv cv bi2anan9 sneq
        eqeq1 imaeq2d ineqan12d fveq2d ifbieq2d c0ex fvex ifex ovmpt2a sylan9eq
        cif iffalse ) BLMCLMNBOPZCOPZNZUABCHUBVBOFQZBRZSZGQZCRZSZUCZTUDZURZVJDE
        BCLLDUEZOPZEUEZOPZNZOVCVLRZSZVFVNRZSZUCZTUDZURVKHVLBPZVNCPZNZVPVBWBVJOW
        CVMUTWDVOVAVLBOUHVNCOUHUFWEWAVITWCWDVRVEVTVHWCVQVDVCVLBUGUIWDVSVGVFVNCU
        GUIUJUKULKVBOVJUMVITUNUOUPVBOVJUSUQ $.

      itg1add.4 $e |- P = ( + |` ( ran F X. ran G ) ) $.
      $( Lemma for itg1add .  (Contributed by Mario Carneiro, 28-Jun-2014.) $)
      itg1addlem4 $p |- ( ph -> ( S.1 ` ( F oF + G ) ) =
        sum_ y e. ran F sum_ z e. ran G ( ( y + z ) x. ( y I z ) ) ) $=
        ( caddc co cc0 wcel cr wceq wa vw vx vv cof citg1 cfv crn csn cdif cmin
        cv cmul csu ccnv cima cvol cdm cfn wss i1fadd cxp wfo i1frn syl syl2anc
        xpfi wfn cres cc wf ax-addf ffn ax-mp i1ff frn ax-resscn syl6ss fnssres
        xpss12 sylancr fneq1i sylibr dffn4 sylib fofi difss sylancl cvv opelxpi
        ssfi cop syl6sseqr funfvima2 df-ov 3eltr4g dffn3 a1i ssdifd wral sselda
        wi wb cin adantr inss2 i1fima ad2antrr wn syl5ss adantlr resubcld recnd
        wne npcand oveq12 00id syl6eq itg1addlem3 syl21anc fovrnd syldan fveq2d
        sumeq2dv 3eqtr4d oveq2d eqtrd anasss fsumcom oveq12d ex adantl readdcld
        oveq1 remulcld oveq1d ad2antrl c0 vex 0re fsumss wfun ffun rneqi df-ima
        fdmi syl5 imp eqtr4i reex inidm anim12dan readdcl ralrimivva funimassov
        mpbird syl5eqss itg1val2 syl13anc ciun inmbl eldifsni ad2antlr necon3ai
        off eqnetrd itg1addlem2 eqeltrrd itg1addlem1 i1faddlem fsummulc2 mulcld
        3eqtrd cmpt wf1o adantrr ad2ant2rl subcan2ad dom2lem f1f1orn eqid fvmpt
        wf1 ovex f1f 3syl fsumf1o wrex cab simpr simplr mpan sylc pncand eqcomd
        eqeq2d rspcev ralrimiva ssabral rnmpt eldifi simprr eldifn wbr eliniseg
        inss1 brelrn sylbi nsyl pm2.21d ssrdv ss0 covol 0mbl mblvol ovol0 eqtri
        mul01d expr iftrue c0ex ovmpt2a mp2an mul01i pm2.61d2 f1ofo an32s dfin4
        cif 0cn eqsstr3i sseli elsni syl6eqel mul02d sylan2 3eqtr2d ) AGHNUDOZU
        EUFZHUGZDUGZPUHZUIZUAUKZVUCCUKZUJOZVUDIOZULOZUAUMZCUMZUYSGUGZBUKZVUDNOZ
        VUKVUDIOZULOZBUMZCUMVUJUYSVUNCUMBUMAUYRVUBVUCUYQUNVUCUHUOZUPUFZULOZUAUM
        ZVUBUYSVUGCUMZUAUMVUIAUYQUEUQZQVUBURQZUYQUGZVUAUIVUBUSVUBRVUAUIUSUYRVUS
        SAGHJKUTAUYTURQZVUBUYTUSZVVBAVUJUYSVAZURQZVVFUYTDVBZVVDAVUJURQZUYSURQZV
        VGAGVVAQZVVIJGVCVDZAHVVAQZVVJKHVCVDZVUJUYSVFVEADVVFVGZVVHANVVFVHZVVFVGZ
        VVOANVIVIVAZVGZVVFVVRUSZVVQVVRVINVJZVVSVKVVRVINVLVMAVUJVIUSUYSVIUSVVTAV
        UJRVIARRGVJZVUJRUSAVVKVWBJGVNVDZRRGVOVDZVPVQAUYSRVIARRHVJZUYSRUSAVVMVWE
        KHVNVDZRRHVOVDZVPVQVUJVIUYSVIVSVEZVVRVVFNVRVTVVFDVVPMWAWBVVFDWCWDVVFUYT
        DWEVEZUYTVUAWFZUYTVUBWJWGZAVVCUYTVUAARUYTUYQVJVVCUYTUSAUBBRRRNVUJUYSUYT
        GHWHWHAUBUKZVUJQVUKUYSQTZTVWLVUKWKZNUFZNVVFUOZVWLVUKNOUYTAVWMVWOVWPQZVW
        MVWNVVFQZAVWQVWLVUKVUJUYSWIANUUAZVVFNUQZUSZVWRVWQXAVWAVWSVKVVRVINUUBVMZ
        AVVFVVRVWTVWHVVRVINVKUUEWLZVVFVWNNWMVTUUFUUGVWLVUKNWNUYTVVPUGVWPDVVPMUU
        CNVVFUUDUUHZWOAGRVGZRVUJGVJAVWBVXEVWCRRGVLVDRGWPWDAHRVGZRUYSHVJAVWEVXFV
        WFRRHVLVDRHWPWDRWHQAUUIWQZVXGRUUJUVDRUYTUYQVOVDWRAUYTRVUAAUYTVWPRVXDAVW
        PRUSZVULRQZCUYSWSBVUJWSZAVXIBCVUJUYSAVUKVUJQZVUDUYSQZTTVUKRQZVUDRQZTVXI
        AVXKVXMVXLVXNAVUJRVUKVWDWTZAUYSRVUDVWGWTZUUKVUKVUDUULVDUUMAVWSVXAVXHVXJ
        XBVXBVXCBCVUJUYSRNUUNVTUUOUUPZWRUAVUBUYQUUQUURAVUBVURVUTUAAVUCVUBQZTZVU
        RVUCUYSVUFCUMZULOVUTVXSVUQVXTVUCULVXSCUYSGUNZVUEUHZUOZHUNZVUDUHZUOZXCZU
        USZUPUFUYSVYGUPUFZCUMVUQVXTVXSUYSVYGCHRRAVWEVXRVWFXDAVVJVXRVVNXDZVYGVYF
        USVXSVXLTZVYCVYFXEWQAVYGUPUQZQZVXRVXLAVYCVYLQZVYFVYLQZVYMAVVKVYNJVYBGXF
        VDAVVMVYOKVYEHXFVDVYCVYFUUTVEXGVYKVUFVYIRVYKVUERQVXNVUEPSVUDPSZTZXHZVUF
        VYISVYKVUCVUDVXSVUCRQVXLAVUBRVUCAVUBUYTRVWJVXQXIWTZXDZAVXLVXNVXRVXPXJZX
        KZWUAVYKVUEVUDNOZPXMVYRVYKWUCVUCPVYKVUCVUDVYKVUCVYTXLZVYKVUDWUAXLXNVXRV
        UCPXMAVXLVUCUYTPUVAUVBUVEVYQWUCPVYQWUCPPNOZPVUEPVUDPNXOXPXQUVCVDAVUEVUD
        EFGHIJKLXRXSZVYKVUEVUDRRRIARRVARIVJZVXRVXLAEFGHIJKLUVFZXGWUBWUAXTZUVGUV
        HVXSVUPVYHUPAVXRVUCVIQVUPVYHSVXSVUCVYSXLZACVUCGHJKUVIYAYBVXSUYSVUFVYICW
        UFYCYDYEVXSUYSVUFVUCCVYJWUJVYKVUFWUIXLZUVJYFYCAVUBUYSVUGUACVWKVVNAVXRVX
        LVUGVIQZVYKVUCVUFWUDWUKUVKZYGYHUVLAUYSVUOVUHCAVXLTZUCUYTUCUKZVUDUJOZUVM
        ZUGZVUNBUMZUYTVUGUAUMZVUOVUHWUNWUSUYTWUCVUFULOZUAUMWUTWUNWURVUNUYTWVABU
        AWUQVUEVUKVUESVULWUCVUMVUFULVUKVUEVUDNYMVUKVUEVUDIYMYIAVVDVXLVWIXDZWUNU
        YTRWUQUWBZUYTWURWUQUVNZWUNUCBUYTRWUPVUKVUDUJOZWUNWUOUYTQZWUPRQWUNWVFTZW
        UOVUDWUNUYTRWUOAUYTRUSVXLVXQXDZWTZWUNVXNWVFVXPXDXKYJWUNWVFVUKUYTQZTZWUP
        WVESWUOVUKSXBWUNWVKTZWUOVUKVUDWUNWVFWUOVIQWVJWVGWUOWVIXLUVOWVLVUKAWVJVX
        MVXLWVFAUYTRVUKVXQWTUVPXLWUNVUDVIQZWVKWUNVUDVXPXLZXDUVQYJUVRZUYTRWUQUVS
        VDZVUCUYTQZVUCWUQUFVUESWUNUCVUCWUPVUEUYTWUQWUOVUCVUDUJYMWUQUVTZVUCVUDUJ
        UWCUWAYKWUNVUKWURQZTZVUNWVTVULVUMWVTVUKVUDWUNWURRVUKWUNWVCUYTRWUQVJWURR
        USWVOUYTRWUQUWDUYTRWUQVOUWEZWTZWUNVXNWVSVXPXDZYLWVTVUKVUDRRRIAWUGVXLWVS
        WUHXGWWBWWCXTYNXLUWFWUNUYTWVAVUGUAWUNWVQTZWUCVUCVUFULWWDVUCVUDWWDVUCWUN
        UYTRVUCWVHWTXLWUNWVMWVQWVNXDXNYOYCYFWUNVUJWURVUNBWUNVUJVUKWUPSZUCUYTUWG
        ZBUWHZWURWUNWWFBVUJWSVUJWWGUSWUNWWFBVUJWUNVXKTZVULUYTQVUKVULVUDUJOZSZWW
        FWWHVUKVUDWKZNUFZVWPVULUYTWWHVXAWWKVVFQZWWLVWPQZAVXAVXLVXKVXCXGWWHVXKVX
        LWWMWUNVXKUWIAVXLVXKUWJVUKVUDVUJUYSWIVEVWSVXAWWMWWNXAVXBVVFWWKNWMUWKUWL
        VUKVUDNWNVXDWOWWHWWIVUKWWHVUKVUDWWHVUKAVXKVXMVXLVXOXJZXLWUNWVMVXKWVNXDU
        WMUWNWWEWWJUCVULUYTWUOVULSWUPWWIVUKWUOVULVUDUJYMUWOUWPVEUWQWWFBVUJUWRWB
        UCBUYTWUPWUQWVRUWSWLWWHVUNWWHVULVUMWWHVUKVUDWWOWUNVXNVXKVXPXDZYLWWHVUKV
        UDRRRIAWUGVXLVXKWUHXGWWOWWPXTYNXLZWUNVUKWURVUJUIZQVUKRVUJUIZQZVUNPSZWUN
        WWRWWSVUKWUNWURRVUJWWAWRWTWUNWWTTVUKPSVYPTZWXAWUNWWTWXBXHZWXAWUNWWTWXCT
        ZTZVUNVULPULOPWXEVUMPVULULWXEVUMVYAVUKUHUOZVYFXCZUPUFZPWXEVXMVXNWXCVUMW
        XHSWWTVXMWUNWXCVUKRVUJUWTYPZWUNVXNWXDVXPXDZWUNWWTWXCUXAAVUKVUDEFGHIJKLX
        RXSWXEWXHYQUPUFZPWXEWXGYQUPWXEWXGYQUSWXGYQSWXEWXGWXFYQWXFVYFUXEWXEUCWXF
        YQWXEWUOWXFQZWUOYQQWXEVXKWXLWWTVXKXHWUNWXCVUKRVUJUXBYPWXLWUOVUKGUXCZVXK
        VUKWHQWXLWXMXBBYRZGVUKWUOWHUCYRZUXDVMWUOVUKGWXOWXNUXFUXGUXHUXIUXJXIWXGU
        XKVDYBWXKYQUXLUFZPYQVYLQWXKWXPSUXMYQUXNVMUXOUXPXQYFYEWXEVULWXEVULWXEVUK
        VUDWXIWXJYLXLUXQYFUXRWXBVUNPPULOPWXBVULPVUMPULWXBVULWUEPVUKPVUDPNXOXPXQ
        WXBVUMPPIOZPVUKPVUDPIXOPRQZWXRWXQPSYSYSEFPPRREUKZPSFUKZPSTZPVYAWXSUHUOV
        YDWXTUHUOXCUPUFZUYHPIWYAPWYBUXSLUXTUYAUYBXQYIPUYIUYCXQUYDYAWUNVVDUYTWUR
        WUQVBZWURURQWVBWUNWVDWYCWVPUYTWURWUQUYEVDUYTWURWUQWEVEYTWUNVUBUYTVUGUAV
        VEWUNVWJWQAVXRVXLWULWUMUYFVUCUYTVUBUIZQWUNVUCVUAQZVUGPSWYDVUAVUCWYDUYTV
        UAXCVUAUYTVUAUYGUYTVUAXEUYJUYKWUNWYETZVUGPVUFULOPWYFVUCPVUFULWYEVUCPSWU
        NVUCPUYLYKZYOWYFVUFWYFVUFWYFVUEVUDRRRIAWUGVXLWYEWUHXGWYFVUCVUDWYFVUCPRW
        YGYSUYMWUNVXNWYEVXPXDZXKWYHXTXLUYNYFUYOWVBYTYDYCAUYSVUJVUNCBVVNVVLAVXLV
        XKVUNVIQWWQYGYHUYP $.

      $( Lemma for itg1add .  (Contributed by Mario Carneiro, 27-Jun-2014.) $)
      itg1addlem5 $p |- ( ph ->
        ( S.1 ` ( F oF + G ) ) = ( ( S.1 ` F ) + ( S.1 ` G ) ) ) $=
        ( vy vz co csu wcel syl adantr cr cc0 crn cv cmul caddc cof cfv cdm cfn
        citg1 i1frn wa wf wss frn sselda recnd cxp itg1addlem2 ad2antrr adantlr
        i1ff fovrnd mulcld fsumcl fsumadd itg1addlem4 adddird sumeq2dv csn cdif
        eqtrd ccnv cima cvol wceq itg1val cin inss2 a1i i1fima inmbl syl2anc wn
        ciun ssdifssd wne eldifsni ad2antlr simpl necon3ai itg1addlem3 syl21anc
        eqeltrrd itg1addlem1 iunin2 mblss imaeq2i imaiun cnvimarndm 3eqtr3i fdm
        iunid syl5eq df-ss sylib syl5req fveq2d 3eqtr4d oveq2d fsummulc2 difssd
        sseqtr4d dfin4 eqsstr3i sseli elsni oveq1d 0re syl6eqel mul02d cuz olcd
        wo sumz sylan2 fsumss inss1 simpr incom iuneq2i eqtri cnvimass syl5sseq
        3eqtrd cc anasss fsumcom oveq12d ) AEUAZFUAZLUBZUUAMUBZGNZUCNZMOZYTUUBU
        UCUCNZMOZUDNZLOZYSUUELOZYSUUGLOZUDNEFUDUENUIUFZEUIUFZFUIUFZUDNAYSUUEUUG
        LAEUIUGZPZYSUHPZHEUJQZAUUAYSPZUKZYTUUDMAYTUHPZUUSAFUUOPZUVAIFUJQZRZUUTU
        UBYTPZUKZUUAUUCUVFUUAUUTUUASPZUVEAYSSUUAASSEULZYSSUMZAUUPUVHHEVAQZSSEUN
        QZUOZRZUPZUVFUUCUVFUUAUUBSSSGASSUQSGULZUUSUVEACDEFGHIJURZUSUVMAUVEUUBSP
        ZUUSAYTSUUBASSFULZYTSUMZAUVBUVRIFVAQZSSFUNQZUOZUTZVBUPZVCZVDUUTYTUUFMUV
        DUVFUUBUUCUVFUUBUWCUPZUWDVCZVDVEAUULYSYTUUAUUBUDNUUCUCNZMOZLOUUIALMBCDE
        FGHIJKVFAYSUWIUUHLUUTUWIYTUUDUUFUDNZMOUUHUUTYTUWHUWJMUVFUUAUUBUUCUVNUWF
        UWDVGVHUUTYTUUDUUFMUVDUWEUWGVEVKVHVKAUUMUUJUUNUUKUDAUUMYSTVIZVJZUUAEVLZ
        UUAVIZVMZVNUFZUCNZLOZUWLUUELOUUJAUUPUUMUWRVOHLEVPQAUWLUWQUUELAUUAUWLPZU
        KZUWQUUAYTUUCMOZUCNUUEUWTUWPUXAUUAUCUWTMYTUWOFVLZUUBVIZVMZVQZWDZVNUFYTU
        XEVNUFZMOUWPUXAUWTYTUXEMFSSAUVRUWSUVTRZAUVAUWSUVCRZUXEUXDUMUWTUVEUKZUWO
        UXDVRVSUXJUWOVNUGZPZUXDUXKPZUXEUXKPZAUXLUWSUVEAUUPUXLHUWNEVTZQZUSAUXMUW
        SUVEAUVBUXMIUXCFVTQZUSUWOUXDWAZWBUXJUUCUXGSUXJUVGUVQUUATVOZUUBTVOZUKZWC
        ZUUCUXGVOZUWTUVGUVEAUWLSUUAAYSSUWKUVKWEUOZRZUWTYTSUUBAUVSUWSUWARUOZUXJU
        UATWFZUYBUWSUYGAUVEUUAYSTWGWHUYAUUATUXSUXTWIWJQAUUAUUBCDEFGHIJWKZWLZUXJ
        UUAUUBSSSGAUVOUWSUVEUVPUSUYEUYFVBZWMWNUWTUWOUXFVNUWTUXFUWOMYTUXDWDZVQZU
        WOMYTUWOUXDWOUWTUWOUYKUMUYLUWOVOUWTUWOSUYKUWTUXLUWOSUMUWTUUPUXLAUUPUWSH
        RUXOQUWOWPQUWTUYKFUGZSUXBMYTUXCWDZVMUXBYTVMUYKUYMUYNYTUXBMYTXBWQMUXBYTU
        XCWRFWSWTUWTUVRUYMSVOZUXHSSFXAZQXCXLUWOUYKXDXEXFXGUWTYTUUCUXGMUYIVHXHXI
        UWTYTUUCUUAMUXIUWTUUAUYDUPUXJUUCUYJUPZXJVKVHAUWLYSUUELAYSUWKXKUWTYTUUDM
        UXIUXJUUAUUCUXJUUAUYEUPUYQVCVDUUAYSUWLVJZPAUUAUWKPZUUETVOUYRUWKUUAUYRYS
        UWKVQUWKYSUWKXMYSUWKVRXNXOAUYSUKZUUEYTTMOZTUYTYTUUDTMUYTUVEUKZUUDTUUCUC
        NZTVUBUUATUUCUCUYSUXSAUVEUUATXPWHZXQVUBUUCVUBUUCVUBUUAUUBSSSGAUVOUYSUVE
        UVPUSVUBUUATSVUDXRXSAUVEUVQUYSUWBUTVBUPXTVKVHUYTYTTYAUFZUMZUVAYCVUATVOU
        YTUVAVUFAUVAUYSUVCRYBYTMTYDQVKYEUURYFYNAUUNYTUWKVJZUUBUXDVNUFZUCNZMOZVU
        GYSUUFLOZMOZUUKAUVBUUNVUJVOIMFVPQAVUGVUIVUKMAUUBVUGPZUKZVUIUUBYSUUCLOZU
        CNVUKVUNVUHVUOUUBUCVUNLYSUXEWDZVNUFYSUXGLOVUHVUOVUNYSUXELESSAUVHVUMUVJR
        AUUQVUMUURRZUXEUWOUMVUNUUSUKZUWOUXDYGVSVURUXLUXMUXNAUXLVUMUUSUXPUSAUXMV
        UMUUSUXQUSUXRWBVURUUCUXGSVURUVGUVQUYBUYCVUNYSSUUAAUVIVUMUVKRUOZVUNUVQUU
        SAVUGSUUBAYTSUWKUWAWEUOZRZVURUUBTWFZUYBVUMVVBAUUSUUBYTTWGWHUYAUUBTUXSUX
        TYHWJQUYHWLZVURUUAUUBSSSGAUVOVUMUUSUVPUSVUSVVAVBZWMWNVUNUXDVUPVNVUNVUPU
        XDLYSUWOWDZVQZUXDVUPLYSUXDUWOVQZWDVVFLYSUXEVVGUXEVVGVOUUSUWOUXDYIVSYJLY
        SUXDUWOWOYKVUNUXDVVEUMVVFUXDVOVUNUXDSVVEVUNUYMUXDSFUXCYLAUYOVUMAUVRUYOU
        VTUYPQRYMVUNVVEEUGZSUWMLYSUWNWDZVMUWMYSVMVVEVVHVVIYSUWMLYSXBWQLUWMYSUWN
        WREWSWTAVVHSVOZVUMAUVHVVJUVJSSEXAQRXCXLUXDVVEXDXEXFXGVUNYSUUCUXGLVVCVHX
        HXIVUNYSUUCUUBLVUQVUNUUBVUTUPZVURUUCVVDUPZXJVKVHAVULYTVUKMOUUKAVUGYTVUK
        MAYTUWKXKVUNYSUUFLVUQVURUUBUUCVUNUUBYOPUUSVVKRVVLVCVDUUBYTVUGVJZPAUUBUW
        KPZVUKTVOVVMUWKUUBVVMYTUWKVQUWKYTUWKXMYTUWKVRXNXOAVVNUKZVUKYSTLOZTVVOYS
        UUFTLVVOUUSUKZUUFVUCTVVQUUBTUUCUCVVNUXTAUUSUUBTXPWHZXQVVQUUCVVQUUCVVQUU
        AUUBSSSGAUVOVVNUUSUVPUSAUUSUVGVVNUVLUTVVQUUBTSVVRXRXSVBUPXTVKVHVVOYSVUE
        UMZUUQYCVVPTVOVVOUUQVVSAUUQVVNUURRYBYSLTYDQVKYEUVCYFAYTYSUUFMLUVCUURAUV
        EUUSUUFYOPAUVEUKZUUSUKZUUBUUCVWAUUBVVTUVQUUSUWBRZUPVWAUUCVWAUUAUUBSSSGA
        UVOUVEUUSUVPUSVVTYSSUUAAUVIUVEUVKRUOVWBVBUPVCYPYQVKYNYRXH $.
    $}

    $( The integral of a sum of simple functions is the sum of the integrals.
       (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg1add $p |- ( ph ->
      ( S.1 ` ( F oF + G ) ) = ( ( S.1 ` F ) + ( S.1 ` G ) ) ) $=
      ( vi vj caddc crn cxp cres cr cv cc0 wceq wa ccnv csn cima eqid cin cmpt2
      cvol cfv cif itg1addlem5 ) AHBICIJKZFGBCFGLLFMZNOGMZNOPNBQUHRSCQUIRSUAUCU
      DUEUBZDEUJTUGTUF $.
  $}

  ${
    $d k m n w x y z A $.  $d k m n w x y z F $.  $d k m n w x y z ph $.
    $d z B $.
    i1fmulc.2 $e |- ( ph -> F e. dom S.1 ) $.
    i1fmulc.3 $e |- ( ph -> A e. RR ) $.
    $( Decompose the preimage of a constant times a function.  (Contributed by
       Mario Carneiro, 25-Jun-2014.) $)
    i1fmulclem $p |- ( ( ( ph /\ A =/= 0 ) /\ B e. RR ) ->
    ( `' ( ( RR X. { A } ) oF x. F ) " { B } ) = ( `' F " { ( B / A ) } ) ) $=
      ( vz vx wa cr wcel csn cmul co cv wceq cvv wf syl recnd cc0 wne ccnv cima
      vy cxp cof cdiv cfv reex a1i wfn citg1 cdm i1ff eqidd ofc1 adantlr eqeq1d
      eqcom simplr ad3antrrr ad2antrr ffvelrnda simpllr divmuld syl5bb pm5.32da
      ffn bitr4d wb remulcl adantl wss fconstg snssd fss syl2anc inidm fniniseg
      off 3bitr4d eqrdv ) ABUAUBZIZCJKZIZGJBLZUFZDMUGNZUCCLUDZDUCCBUHNZLUDZWGGO
      ZJKZWNWJUIZCPZIZWOWNDUIZWLPZIZWNWKKZWNWMKZWGWOWQWTWGWOIZWQBWSMNZCPZWTXDWP
      XECWEWOWPXEPZWFAWOXGWDAJBWSMDQJWNJQKAUJUKZFAJJDRZDJULZADUMUNKXIEDUOSZJJDV
      IZSAWOIWSUPUQURURUSWTWLWSPXDXFWSWLUTXDCBWSXDCWEWFWOVATXDBABJKZWDWFWOFVBTX
      DWSWGJJWNDAXIWDWFXKVCZVDTAWDWFWOVEVFVGVJVHWGWJJULZXBWRVKWGJJWJRZXOAXPWDWF
      AHUEJJJMJJJWIDQQHOZJKUEOZJKIXQXRMNJKAXQXRVLVMAJWHWIRZWHJVNJJWIRAXMXSFJBJV
      OSABJFVPJWHJWIVQVRXKXHXHJVSWAVCJJWJVISJCWNWJVTSWGXJXCXAVKWGXIXJXNXLSJWLWN
      DVTSWBWC $.

    $( A nonnegative constant times a simple function gives another simple
       function.  (Contributed by Mario Carneiro, 25-Jun-2014.) $)
    i1fmulc $p |- ( ph -> ( ( RR X. { A } ) oF x. F ) e. dom S.1 ) $=
      ( vx vy vz cr csn cmul co wcel cc0 wceq wa cvv wf syl adantr vw cxp citg1
      cof cdm reex a1i i1ff 0re cv simplr oveq1d mul02lem2 adantl eqtrd caofid2
      i1f0 syl6eqel wne remulcl fconst6g inidm off crn cfn cmpt i1frn ovex eqid
      wss wfo wfn fnmpti dffn4 mpbi fofi sylancl wrex cab id elsni oveq2 eqeq2d
      rspcev syl2anr eqeq1 rexbidv sylibr fconstg ffn dffn3 sylib frn syl6sseqr
      elab rnmpt ssfi syl2anc cdif ccnv cima cdiv cvol sselda i1fmulclem syldan
      ssdifssd i1fima ad2antrr eqeltrd fveq2d redivcld eldifsni divne0d eldifsn
      cfv recnd sylanbrc i1fima2sn i1fd pm2.61dane ) AIBJZUBZCKUDLZUCUEZMBNABNO
      ZPZYDINJZUBYEYGFIBNKICQIIIQMZYGUFUGAIICRZYFACYEMZYJDCUHSZTABIMZYFETNIMYGU
      IUGYGFUJZIMZPZBYNKLNYNKLZNYPBNYNKAYFYOUKULYOYQNOYGYNUMUNUOUPUQURABNUSZPZG
      YDAIIYDRZYRAFGIIIKIIIYCCQQYOGUJZIMZPYNUUAKLIMAYNUUAUTUNAYMIIYCREIBIVASYLY
      IAUFUGZUUCIVBZVCZTAYDVDZVEMZYRAGCVDZBUUAKLZVFZVDZVEMZUUFUUKVJUUGAUUHVEMZU
      UHUUKUUJVKZUULAYKUUMDCVGSUUJUUHVLUUNGUUHUUIUUJBUUAKVHUUJVIZVMUUHUUJVNVOUU
      HUUKUUJVPVQAUUFHUJZUUIOZGUUHVRZHVSZUUKAIUUSYDRUUFUUSVJAFUAIIIKYBUUHUUSYCC
      QQYNYBMZUAUJZUUHMZPZYNUVAKLZUUSMZAUVCUVDUUIOZGUUHVRZUVEUVBUVBUVDBUVAKLZOZ
      UVGUUTUVBVTUUTYNBUVAKYNBWAULUVFUVIGUVAUUHUUAUVAOUUIUVHUVDUUAUVABKWBWCWDWE
      UURUVGHUVDYNUVAKVHUUPUVDOUUQUVFGUUHUUPUVDUUIWFWGWOWHUNAYMIYBYCREIBIWISACI
      VLZIUUHCRAYJUVJYLIICWJSICWKWLUUCUUCUUDVCIUUSYDWMSGHUUHUUIUUJUUOWPWNUUKUUF
      WQWRTYSUUAUUFYHWSZMZPZYDWTUUAJXAZCWTUUABXBLZJZXAZXCUEZYSUVLUUBUVNUVQOYSUV
      KIUUAAUVKIVJYRAUUFIYHAYTUUFIVJUUEIIYDWMSXGTXDZABUUACDEXEXFZAUVQUVRMZYRUVL
      AYKUWADUVPCXHSXIXJUVMUVNXCXPUVQXCXPZIUVMUVNUVQXCUVTXKUVMYKUVOIYHWSMZUWBIM
      AYKYRUVLDXIUVMUVOIMUVONUSUWCUVMUUABUVSAYMYRUVLEXIZAYRUVLUKZXLUVMUUABUVMUU
      AUVSXQUVMBUWDXQUVLUUANUSYSUUAUUFNXMUNUWEXNUVOINXOXRUVOICXSWRXJXTYA $.

    $( The integral of a constant times a simple function is the constant times
       the original integral.  (Contributed by Mario Carneiro, 25-Jun-2014.) $)
    itg1mulc $p |- ( ph ->
      ( S.1 ` ( ( RR X. { A } ) oF x. F ) ) = ( A x. ( S.1 ` F ) ) ) $=
      ( vm vk vn cr cmul co cfv wceq cc0 wa wcel syl adantr recnd cdiv vx citg1
      vy csn cxp cof itg10 cvv reex a1i wf cdm i1ff 0re simplr oveq1d mul02lem2
      adantl eqtrd caofid2 fveq2d simpr itg1cl mul02d 3eqtr4a wne crn cdif ccnv
      cv cima csu wss i1fmulc frn ssdifssd sselda cc divcan2d i1fmulclem syldan
      cvol eqcomd oveq12d ad2antrr redivcld eldifsni divne0d sylanbrc i1fima2sn
      eldifsn syl2anc mulassd eqtr3d sumeq2dv cfn i1frn difss sylancl fsummulc2
      ssfi mulcld eqtr4d itg1val cmpt id sneq imaeq2d eqid eldifi wfn ffn eqidd
      wral adantlr ffvelrnda divcan3d fnfvelrn sylan eqeltrd ralrimiva wb oveq1
      ofc1 eleq1d ralrn mpbird r19.21bi sylan2 oveq2 mulne0d simpl ssel2 syl2an
      eqeltrrd adantrl divmuld bicomd eqcom 3bitr4g f1o2d ovex remulcld fsumf1o
      fvmpt oveq2d 3eqtr4d pm2.61dane ) AIBUDUECJUFKZUBLZBCUBLZJKZMBNABNMZOZINU
      DZUEZUBLNUUJUULUGUUNUUIUUPUBUUNUAIBNJICUHIIIUHPZUUNUIUJAIICUKZUUMACUBULZP
      ZUURDCUMQZRABIPZUUMERNIPUUNUNUJUUNUAVJZIPZOZBUVCJKNUVCJKZNUVEBNUVCJAUUMUV
      DUOUPUVDUVFNMUUNUVCUQURUSUTVAUUNUULNUUKJKZNUUNBNUUKJAUUMVBUPAUVGNMUUMAUUK
      AUUKAUUTUUKIPDCVCQSVDRUSVEABNVFZOZUUIVGZUUOVHZFVJZUUIVIUVLUDVKZWBLZJKZFVL
      ZBUVKUVLBTKZCVIZUVQUDZVKZWBLZJKZFVLZJKZUUJUULUVIUVPUVKBUWBJKZFVLUWDUVIUVK
      UVOUWEFUVIUVLUVKPZOZBUVQJKZUWAJKUVOUWEUWGUWHUVLUWAUVNJUWGUVLBUWGUVLUVIUVK
      IUVLUVIUVJIUUOUVIIIUUIUKZUVJIVMUVIUUIUUSPZUWIAUWJUVHABCDEVNRZUUIUMQZIIUUI
      VOQVPZVQZSZUVIBVRPZUWFUVIBAUVBUVHERSZRZAUVHUWFUOZVSUWGUVNUWAUWGUVMUVTWBUV
      IUWFUVLIPUVMUVTMUWNABUVLCDEVTWAVAWCWDUWGBUVQUWAUWRUWGUVQUWGUVLBUWNAUVBUVH
      UWFEWEZUWSWFZSZUWGUWAUWGUUTUVQIUUOVHPZUWAIPAUUTUVHUWFDWEUWGUVQIPUVQNVFUXC
      UXAUWGUVLBUWOUWGBUWTSUWFUVLNVFUVIUVLUVJNWGURUWSWHUVQINWKWIUVQICWJWLSZWMWN
      WOUVIUVKUWBBFUVIUVJWPPZUVKUVJVMUVKWPPUVIUWJUXEUWKUUIWQQUVJUUOWRUVJUVKXAWS
      ZUWQUWGUVQUWAUXBUXDXBWTXCUVIUWJUUJUVPMUWKFUUIXDQUVIUUKUWCBJUVIUUKCVGZUUOV
      HZGVJZUVRUXIUDZVKZWBLZJKZGVLZUWCUVIUUTUUKUXNMAUUTUVHDRZGCXDQUVIUXHUXMUVKU
      WBGFHUVKHVJZBTKZXEZUVQUXIUVQMZUXIUVQUXLUWAJUXSXFUXSUXKUVTWBUXSUXJUVSUVRUX
      IUVQXGXHVAWDUXFUVIHGUVKUXHUXQBUXIJKZUXRUXRXIZUVIUXPUVKPZOZUXQUXGPZUXQNVFU
      XQUXHPUYBUVIUXPUVJPUYDUXPUVJUUOXJUVIUYDHUVJUVIUYDHUVJXNZUCVJZUUILZBTKZUXG
      PZUCIXNZUVIUYIUCIUVIUYFIPZOZUYHUYFCLZUXGUYLUYHBUYMJKZBTKUYMUYLUYGUYNBTAUY
      KUYGUYNMUVHAIBUYMJCUHIUYFUUQAUIUJEAUURCIXKZUVAIICXLZQAUYKOUYMXMYDXOZUPUYL
      UYMBUYLUYMUVIIIUYFCAUURUVHUVARZXPSUVIUWPUYKUWQRAUVHUYKUOXQUSUVIUYOUYKUYMU
      XGPUVIUURUYOUYRUYPQZIUYFCXRXSXTYAUVIUUIIXKZUYEUYJYBUVIUWIUYTUWLIIUUIXLQZU
      YDUYIHUCIUUIUXPUYGMUXQUYHUXGUXPUYGBTYCYEYFQYGYHYIUYCUXPBUYCUXPUVIUVKIUXPU
      WMVQSUVIUWPUYBUWQRUYBUXPNVFUVIUXPUVJNWGURAUVHUYBUOWHUXQUXGNWKWIUVIUXIUXHP
      ZOZUXTUVJPZUXTNVFUXTUVKPVUBUVIUXIUXGPVUDUXIUXGUUOXJUVIVUDGUXGUVIVUDGUXGXN
      ZUYNUVJPZUCIXNZUVIVUFUCIUYLUYGUYNUVJUYQUVIUYTUYKUYGUVJPVUAIUYFUUIXRXSYOYA
      UVIUYOVUEVUGYBUYSVUDVUFGUCICUXIUYMMUXTUYNUVJUXIUYMBJYJYEYFQYGYHYIVUCBUXIU
      VIUWPVUBUWQRVUCUXIUVIUXHIUXIUVIUXGIUUOUVIUURUXGIVMUYRIICVOQVPVQZSAUVHVUBU
      OVUBUXINVFUVIUXIUXGNWGURYKUXTUVJNWKWIUVIUYBVUBOZOZUXTUXPMZUXQUXIMZUXPUXTM
      UXIUXQMVUJVULVUKVUJUXPBUXIVUJUXPUVIUVKIVMUYBUXPIPVUIUWMUYBVUBYLUVKIUXPYMY
      NSVUJBAUVBUVHVUIEWESVUJUXIUVIVUBUXIIPUYBVUHYPSAUVHVUIUOYQYRUXPUXTYSUXIUXQ
      YSYTUUAUWFUVLUXRLUVQMUVIHUVLUXQUVQUVKUXRUXPUVLBTYCUYAUVLBTUUBUUEURVUCUXMV
      UCUXIUXLVUHUVIUUTVUBUXLIPUXOUXIUXGCWJXSUUCSUUDUSUUFUUGUUH $.
  $}

  ${
    $d x y z A $.  $d x y z F $.  $d y z G $.
    i1fres.1 $e |- G = ( x e. RR |-> if ( x e. A , ( F ` x ) , 0 ) ) $.
    $( The "restriction" of a simple function to a measurable subset is
       simple.  (It's not actually a restriction because it is zero instead of
       undefined outside ` A ` .)  (Contributed by Mario Carneiro,
       29-Jun-2014.) $)
    i1fres $p |- ( ( F e. dom S.1 /\ A e. dom vol ) -> G e. dom S.1 ) $=
      ( vy wcel cvol wa cr wf wss cv cfv cc0 adantr syl syl2anc wceq wne vz cdm
      citg1 crn cif wfn i1ff ffn fnfvelrn sylan ad2antrr ifcl fmptd frn fss cfn
      i1f0rn i1frn ssfi csn cdif ccnv cima cin eleq1 fveq2 eqidd ifbieq12d fvex
      c0ex ifex fvmpt adantl eqeq1d eldifsni ad2antlr necomd iffalse syl5ibrcom
      wn neeq1d necon4bd pm4.71rd bitrd iftrue pm5.32i syl6bb pm5.32da fniniseg
      an12 anbi2d 3bitr4d elin syl6bbr eqrdv simplr i1fima inmbl eqeltrd fveq2d
      wb covol mblvol eqtrd inss2 a1i mblss i1fima2sn adantlr eqeltrrd ovolsscl
      syl3anc i1fd ) CUCUBGZBHUBZGZIZFDXQJCUDZDKZXRJLZJJDKXQAJAMZBGZYACNZOUEZXR
      DXQYAJGZIYCXRGZOXRGZYDXRGXQCJUFZYEYFXQJJCKZYHXNYIXPCUGPZJJCUHQZJYACUIUJXN
      YGXPYECUQUKYBYCOXRULREUMZXQYIXTYJJJCUNQJXRJDUORXQXRUPGZDUDZXRLZYNUPGXNYMX
      PCURPXQXSYOYLJXRDUNQXRYNUSRXQFMZYNOUTVAGZIZDVBYPUTZVCZBCVBYSVCZVDZXOYRUAY
      TUUBYRUAMZYTGZUUCBGZUUCUUAGZIZUUCUUBGYRUUCJGZUUCDNZYPSZIZUUEUUHUUCCNZYPSZ
      IZIZUUDUUGYRUUKUUHUUEUUMIZIUUOYRUUHUUJUUPYRUUHIZUUJUUEUUEUULOUEZYPSZIZUUP
      UUQUUJUUSUUTUUQUUIUURYPUUHUUIUURSYRAUUCYDUURJDYAUUCSZYBUUEYCOUULOYAUUCBVE
      YAUUCCVFUVAOVGVHEUUEUULOUUCCVIVJVKVLVMVNUUQUUSUUEUUQUUEUURYPUUQUURYPTUUEV
      TZOYPTUUQYPOYQYPOTXQUUHYPYNOVOVPVQUVBUUROYPUUEUULOVRWAVSWBWCWDUUEUUSUUMUU
      EUURUULYPUUEUULOWEVNWFWGWHUUHUUEUUMWJWGYRDJUFZUUDUUKXAXQUVCYQXQXSUVCYLJXR
      DUHQPJYPUUCDWIQYRUUFUUNUUEYRYHUUFUUNXAXQYHYQYKPJYPUUCCWIQWKWLUUCBUUAWMWNW
      OZYRXPUUAXOGZUUBXOGZXNXPYQWPXNUVEXPYQYSCWQUKZBUUAWRRZWSYRYTHNZUUBXBNZJYRU
      VIUUBHNZUVJYRYTUUBHUVDWTYRUVFUVKUVJSUVHUUBXCQXDYRUUBUUALZUUAJLZUUAXBNZJGU
      VJJGUVLYRBUUAXEXFYRUVEUVMUVGUUAXGQYRUUAHNZUVNJYRUVEUVOUVNSUVGUUAXCQXNYQUV
      OJGXPYPYNCXHXIXJUUBUUAXKXLWSXM $.
  $}

  ${
    $d x F $.
    i1fpos.1 $e |- G = ( x e. RR |-> if ( 0 <_ ( F ` x ) , ( F ` x ) , 0 ) ) $.
    $( The positive part of a simple function is simple.  (Contributed by Mario
       Carneiro, 28-Jun-2014.) $)
    i1fpos $p |- ( F e. dom S.1 -> G e. dom S.1 ) $=
      ( citg1 cdm wcel cr cv ccnv cc0 cpnf cico co cima cfv cif cmpt biantrurd
      wa cle wbr simpr i1ff ffvelrnda elrege0 syl6bbr wf wfn wb adantr elpreima
      3syl 3bitr4d ifbid mpteq2dva syl5eq cvol i1fima eqid i1fres mpdan eqeltrd
      ffn ) BEFZGZCAHAIZBJKLMNZOZGZVGBPZKQZRZVEVFCAHKVKUAUBZVKKQZRVMDVFAHVOVLVF
      VGHGZTZVNVJVKKVQVKVHGZVPVRTZVNVJVQVPVRVFVPUCSVQVNVKHGZVNTVRVQVTVNVFHHVGBB
      UDZUESVKUFUGVQHHBUHZBHUIVJVSUJVFWBVPWAUKHHBVDHVGVHBULUMUNUOUPUQVFVIURFGVM
      VEGVHBUSAVIBVMVMUTVAVBVC $.
  $}

  ${
    $d x y z ph $.  $d y z A $.
    i1fposd.1 $e |- ( ph -> ( x e. RR |-> A ) e. dom S.1 ) $.
    $( Deduction form of ~ i1fposd .  (Contributed by Mario Carneiro,
       6-Aug-2014.) $)
    i1fposd $p |- ( ph -> ( x e. RR |-> if ( 0 <_ A , A , 0 ) ) e. dom S.1 ) $=
      ( vy cr cc0 cv cmpt cfv cle wbr cif nfcv wceq breq2d eqidd ifbieq12d wcel
      syl citg1 nffvmpt1 nfbr nfif fveq2 cbvmpt wa simpr wf wral i1ff eqid fmpt
      cdm sylibr r19.21bi fvmpt2 syl2anc mpteq2dva syl5eq i1fpos eqeltrrd ) AEF
      GEHZBFCIZJZKLZVEGMZIZBFGCKLZCGMZIZUAUNZAVHBFGBHZVDJZKLZVNGMZIVKEBFVGVPVFB
      VEGBGVEKBGNZBKNBFCVCUBZUCVRVQUDEVPNVCVMOZVFVOVEGVNGVSVEVNGKVCVMVDUEZPVTVS
      GQRUFABFVPVJAVMFSZUGZVOVIVNGCGWBVNCGKWBWACFSZVNCOAWAUHAWCBFAFFVDUIZWCBFUJ
      AVDVLSZWDDVDUKTBFFCVDVDULZUMUOUPBFCFVDWFUQURZPWGWBGQRUSUTAWEVHVLSDEVDVHVH
      ULVATVB $.
  $}

  $( The difference of two simple functions is a simple function.  (Contributed
     by Mario Carneiro, 6-Aug-2014.) $)
  i1fsub $p |- ( ( F e. dom S.1 /\ G e. dom S.1 ) ->
    ( F oF - G ) e. dom S.1 ) $=
    ( citg1 cdm wcel wa cr c1 cneg csn cxp cof co cc i1ff ax-resscn fss sylancl
    wf cvv cmul caddc cmin wceq wss reex ofnegsub mp3an1 syl2an simpl simpr 1re
    renegcli a1i i1fmulc i1fadd eqeltrrd ) ACDZEZBUREZFZAGHIZJKBUALMZUBLMZABUCL
    MZURUSGNASZGNBSZVDVEUDZUTUSGGASGNUEZVFAOPGGNAQRUTGGBSVIVGBOPGGNBQRGTEVFVGVH
    UFGABTUGUHUIVAAVCUSUTUJVAVBBUSUTUKVBGEVAHULUMUNUOUPUQ $.

  $( The integral of a difference of two simple functions.  (Contributed by
     Mario Carneiro, 6-Aug-2014.) $)
  itg1sub $p |- ( ( F e. dom S.1 /\ G e. dom S.1 ) ->
    ( S.1 ` ( F oF - G ) ) = ( ( S.1 ` F ) - ( S.1 ` G ) ) ) $=
    ( citg1 wcel cr c1 cneg cmul cof co caddc cfv cmin cc itg1cl recnd eqtrd wf
    wceq i1ff cdm csn cxp simpl simpr 1re renegcli a1i i1fmulc itg1add itg1mulc
    syl mulm1d oveq2d wss ax-resscn fss sylancl cvv reex ofnegsub mp3an1 syl2an
    wa fveq2d negsub 3eqtr3d ) ACUAZDZBVHDZVDZAEFGZUBUCBHIJZKIJZCLZACLZBCLZGZKJ
    ZABMIJZCLVPVQMJZVKVOVPVMCLZKJVSVKAVMVIVJUDVKVLBVIVJUEZVLEDVKFUFUGUHZUIUJVKW
    BVRVPKVKWBVLVQHJVRVKVLBWCWDUKVKVQVKVJVQNDZWCVJVQBOPZULUMQUNQVKVNVTCVIENARZE
    NBRZVNVTSZVJVIEEARENUOZWGATUPEENAUQURVJEEBRWJWHBTUPEENBUQUREUSDWGWHWIUTEABU
    SVAVBVCVEVIVPNDWEVSWASVJVIVPAOPWFVPVQVFVCVG $.

  ${
    $d x A $.  $d k x F $.  $d x G $.  $d k x ph $.
    itg10a.1 $e |- ( ph -> F e. dom S.1 ) $.
    itg10a.2 $e |- ( ph -> A C_ RR ) $.
    itg10a.3 $e |- ( ph -> ( vol* ` A ) = 0 ) $.
    ${
      itg10a.4 $e |- ( ( ph /\ x e. ( RR \ A ) ) -> ( F ` x ) = 0 ) $.
      $( The integral of a simple function supported on a nullset is zero.
         (Contributed by Mario Carneiro, 11-Aug-2014.) $)
      itg10a $p |- ( ph -> ( S.1 ` F ) = 0 ) $=
        ( vk cfv cc0 cmul wcel wceq syl wa cr wss adantr eqtrd citg1 crn csn cv
        cdif ccnv cima cvol co csu cdm itg1val covol wfn wb wf ffn fniniseg wne
        i1ff eldifsni ad2antlr simprl eldif simplrr simpll sylan eqtr3d syl5bir
        wn ex mpand necon1ad sylbid ssrdv sstrd ovolssnul syl3anc nulmbl mblvol
        mpd syl2anc oveq2d frn ssdifssd sselda recnd mul01d sumeq2dv cuz cfn wo
        i1frn difss ssfi sylancl olcd sumz ) ADUAJZDUBZKUCZUEZIUDZDUFXCUCUGZUHJ
        ZLUIZIUJZKADUAUKMZWSXGNEIDULOAXGXBKIUJZKAXBXFKIAXCXBMZPZXFXCKLUIKXKXEKX
        CLXKXEXDUMJZKXKXDUHUKMZXEXLNXKXDQRXLKNZXMXKXDCQXKBXDCXKBUDZXDMZXOQMZXOD
        JZXCNZPZXOCMZXKDQUNZXPXTUOAYBXJAQQDUPZYBAXHYCEDUTOZQQDUQOSQXCXODUROXKXT
        YAXKXTPZXCKUSZYAXJYFAXTXCWTKVAVBYEYAXCKYEXQYAVJZXCKNZXKXQXSVCXQYGPXOQCU
        EMZYEYHXOQCVDYEYIYHYEYIPXRXCKXKXQXSYIVEYEAYIXRKNAXJXTVFHVGVHVKVIVLVMWAV
        KVNVOZACQRZXJFSZVPXKXDCRYKCUMJKNZXNYJYLAYMXJGSXDCVQVRZXDVSWBXDVTOYNTWCX
        KXCXKXCAXBQXCAWTQXAAYCWTQRYDQQDWDOWEWFWGWHTWIAXBKWJJRZXBWKMZWLXIKNAYPYO
        AWTWKMZXBWTRYPAXHYQEDWMOWTXAWNWTXBWOWPWQXBIKWROTT $.
    $}

    ${
      itg1ge0a.4 $e |- ( ( ph /\ x e. ( RR \ A ) ) -> 0 <_ ( F ` x ) ) $.
      $( The integral of an almost positive simple function is positive.
         (Contributed by Mario Carneiro, 11-Aug-2014.) $)
      itg1ge0a $p |- ( ph -> 0 <_ ( S.1 ` F ) ) $=
        ( vk cc0 cfv cle wcel wss syl wa cr wbr wceq ad2antrr crn csn cdif ccnv
        cv cima cvol cmul co csu citg1 cfn cdm i1frn difss ssfi sylancl wf i1ff
        frn ssdifssd sselda i1fima2sn sylan remulcld clt covol i1fima mblvol wb
        0le0 wfn ffn fniniseg wn simprl eldif wi ex simprr breq2d adantr lenltd
        0re a1i bitrd sylibd syl5bir mpand con4d sylbid ssrdv ovolssnul syl3anc
        impancom eqtrd oveq2d cc recnd syl5breqr simpr ovolge0 breqtrrd mulge0d
        mul01d mblss ltlecasei fsumge0 itg1val ) AJDUAZJUBZUCZIUEZDUDXMUBZUFZUG
        KZUHUIZIUJZDUKKZLAXLXQIAXJULMZXLXJNXLULMADUKUMMZXTEDUNOXJXKUOXJXLUPUQAX
        MXLMZPZXMXPAXLQXMAXJQXKAQQDURZXJQNAYAYDEDUSOZQQDUTOVAVBZAYAYBXPQMZEXMXJ
        DVCVDZVEYCJXQLRXMJYCXMJVFRZPZJJXQLVKYJXQXMJUHUIJYJXPJXMUHYJXPXOVGKZJAXP
        YKSZYBYIAXOUGUMMZYLAYAYMEXNDVHOZXOVIOZTYJXOCNCQNZCVGKJSZYKJSYJBXOCYJBUE
        ZXOMZYRQMZYRDKZXMSZPZYRCMZAYSUUCVJZYBYIADQVLZUUEAYDUUFYEQQDVMOQXMYRDVNO
        TYCUUCYIUUDYCUUCPZUUDYIUUGYTUUDVOZYIVOZYCYTUUBVPYTUUHPYRQCUCMZUUGUUIYRQ
        CVQUUGUUJJUUALRZUUIAUUJUUKVRYBUUCAUUJUUKHVSTUUGUUKJXMLRZUUIUUGUUAXMJLYC
        YTUUBVTWAUUGJXMJQMZUUGWDWEYCXMQMZUUCYFWBWCWFWGWHWIWJWOWKWLAYPYBYIFTAYQY
        BYIGTXOCWMWNWPWQYJXMYCXMWRMYIYCXMYFWSWBXEWPWTYCUULPZXMXPYCUUNUULYFWBYCY
        GUULYHWBYCUULXAUUOJYKXPLUUOXOQNZJYKLRUUOYMUUPAYMYBUULYNTXOXFOXOXBOAYLYB
        UULYOTXCXDYFUUMYCWDWEXGXHAYAXSXRSEIDXIOXC $.
    $}

    itg1lea.4 $e |- ( ph -> G e. dom S.1 ) $.
    itg1lea.5 $e |- ( ( ph /\ x e. ( RR \ A ) ) -> ( F ` x ) <_ ( G ` x ) ) $.
    $( Approximate version of ~ itg1le .  If ` F <_ G ` for almost all ` x ` ,
       then ` S.1 F <_ S.1 G ` .  (Contributed by Mario Carneiro,
       28-Jun-2014.)  (Revised by Mario Carneiro, 6-Aug-2014.) $)
    itg1lea $p |- ( ph -> ( S.1 ` F ) <_ ( S.1 ` G ) ) $=
      ( cc0 citg1 cfv cmin co cle wbr wcel cr syl cof i1fsub syl2anc cv cdif wa
      cdm eldifi i1ff ffvelrnda subge0d sylan2 mpbird wceq cvv wfn ffn reex a1i
      wb wf inidm eqidd ofval breqtrrd itg1ge0a itg1sub breqtrd itg1cl mpbid )
      AKELMZDLMZNOZPQVLVKPQAKEDNUAOZLMZVMPABCVNAELUGZRZDVPRZVNVPRIFEDUBUCGHABUD
      ZSCUERZUFZKVSEMZVSDMZNOZVSVNMZPWAKWDPQZWCWBPQZJVTAVSSRZWFWGUTVSSCUHZAWHUF
      ZWBWCASSVSEAVQSSEVAZIEUITZUJASSVSDAVRSSDVAZFDUITZUJUKULUMVTAWHWEWDUNWIASS
      WBWCNSEDUOUOVSAWKESUPWLSSEUQTAWMDSUPWNSSDUQTSUORAURUSZWOSVBWJWBVCWJWCVCVD
      ULVEVFAVQVRVOVMUNIFEDVGUCVHAVKVLAVQVKSRIEVITAVRVLSRFDVITUKVJ $.
  $}

  ${
    $d x F $.  $d x G $.
    $( If one simple function dominates another, then the integral of the
       larger is also larger.  (Contributed by Mario Carneiro, 28-Jun-2014.)
       (Revised by Mario Carneiro, 6-Aug-2014.) $)
    itg1le $p |- ( ( F e. dom S.1 /\ G e. dom S.1 /\ F oR <_ G ) ->
                   ( S.1 ` F ) <_ ( S.1 ` G ) ) $=
      ( vx citg1 cdm wcel cle wbr c0 cr a1i cfv wa cvv wfn i1ff ffn 3syl eqidd
      wf cofr w3a simp1 wss 0ss covol cc0 wceq ovol0 simp2 cv cdif eldifi simpl
      wi simpr reex inidm ofrval 3exp 3impia imp sylan2 itg1lea ) ADEZFZBVEFZAB
      GUAHZUBZCIABVFVGVHUCIJUDVIJUEKIUFLUGUHVIUIKVFVGVHUJCUKZJIULFVIVJJFZVJALZV
      JBLZGHZVJJIUMVIVKVNVFVGVHVKVNUOVFVGMZVHVKVNVOJJVLVMGJABNNVJVOVFJJATAJOVFV
      GUNAPJJAQRVOVGJJBTBJOVFVGUPBPJJBQRJNFVOUQKZVPJURVOVKMZVLSVQVMSUSUTVAVBVCV
      D $.
  $}

  ${
    $d j n x y z A $.  $d j k n x y z F $.  $d j k y G $.  $d j k n x ph $.
    itg1climres.1 $e |- ( ph -> A : NN --> dom vol ) $.
    itg1climres.2 $e |- ( ( ph /\ n e. NN ) ->
      ( A ` n ) C_ ( A ` ( n + 1 ) ) ) $.
    itg1climres.3 $e |- ( ph -> U. ran A = RR ) $.
    itg1climres.4 $e |- ( ph -> F e. dom S.1 ) $.
    itg1climres.5 $e |- G =
      ( x e. RR |-> if ( x e. ( A ` n ) , ( F ` x ) , 0 ) ) $.
    $( Restricting the simple function ` F ` to the increasing sequence
       ` A ( n ) ` of measurable sets whose union is ` RR ` yields a sequence
       of simple functions whose integrals approach the integral of ` F ` .
       (Contributed by Mario Carneiro, 15-Aug-2014.) $)
    itg1climres $p |- ( ph -> ( n e. NN |-> ( S.1 ` G ) ) ~~> ( S.1 ` F ) ) $=
      ( vj cn cfv cvol wcel syl cr wceq cle vk vz vy citg1 cmpt crn cc0 cdif cv
      csn ccnv cima cmul co csu cli cin c1 cvv nnuz cz 1z a1i cfn wss cdm i1frn
      difss ssfi sylancl clt csup covol i1fima ad2antrr ffvelrnda adantlr inmbl
      wa syl2anc mblvol inss1 mblss i1fima2sn eqeltrrd ovolsscl syl3anc eqeltrd
      sylan adantr eqid fmptd caddc wbr wral wf peano2nn ovolss ralrimiva fveq2
      3brtr4d ineq2d fveq2d fvex fvmpt breq12d ralbiia cbvralv bitr4i wrex cuni
      sylibr breq1d cxr inex2 sseq12d ciun wfn ffn fniunfv 3syl eqtrd eqtr3d c0
      sylib wne wb breqtrrd i1ff recnd nnex mptex oveq2d eqtr4d adantl fniniseg
      frn eqeq1d nfcv sumeq2sdv sslin ffvelrn syl2an oveq1 sylancr breq2 rspcev
      r19.21bi ralbidv climsup volsup iuneq2i cbviunv iunin2 3eqtr2i syl5eq fdm
      df-ss 1nn ne0i mp1i eqnetrd dm0rn0 necon3bii breq1 rexbidv mpbird supxrre
      ralrn ccom rnco2 eqidd cpnf feqmptd fmptco rneqd syl5reqr supeq1d 3eqtr4d
      cicc volf ssdifssd sselda ovex climmulc2 cc remulcld anasss i1fres i1f0rn
      cif fnfvelrn ifcl ssdif ssdifd itg1val2 syl13anc wal c0ex fvmpt2 eldifsni
      ifex mpan2 ad2antlr neeq1 syl5ibrcom iffalse necon1ai syl6 pm4.71rd bitrd
      iftrue pm5.32i ancom bitri syl6bb pm5.32da syl6bbr anbi1d 3bitr4d alrimiv
      anass syl5bb nfmpt1 nfcxfr nfcnv nfima sumeq2dv mpteq2dva fveq1d sylan9eq
      elin cleqf sumex climfsum itg1val ) ADMFUDNZUEZEUFZUGUJZUHZUAUIZEUKVUBUJZ
      ULZONZUMUNZUAUOZEUDNZUPAVUAVUFUALDMVUBVUDDUIZCNZUQZONZUMUNZUEZUYRURUSMUTU
      RVAPZAVBVCAUYSVDPZVUAUYSVEVUAVDPZAEUDVFZPZVUPJEVGQUYSUYTVHUYSVUAVIVJZAVUB
      VUAPZVSZVUEVUBLDMVULUEZVUNURUSMUTVUOVVBVBVCZVVBVVCVVCUFZRVKVLZVUEUPVVBBLV
      VCURMUTVVDVVBDMVULRVVCVVBVUIMPZVSZVULVUKVMNZRVVHVUKOVFZPZVULVVISVVHVUDVVJ
      PZVUJVVJPZVVKAVVLVVAVVGAVUSVVLJVUCEVNQZVOZAVVGVVMVVAAMVVJVUICGVPZVQVUDVUJ
      VRVTZVUKWAQZVVHVUKVUDVEZVUDRVEZVUDVMNZRPVVIRPVVSVVHVUDVUJWBZVCVVHVVLVVTVV
      OVUDWCZQZVVHVUEVWARVVHVVLVUEVWASVVOVUDWAQZVVBVUERPZVVGAVUSVVAVWFJVUBUYSEW
      DWIZWJWEVUKVUDWFWGWHZVVCWKZWLZVVBLUIZVVCNZVWKURWMUNZVVCNZTWNZLMVVBVULVUDV
      UIURWMUNZCNZUQZONZTWNZDMWOZVWOLMWOZVVBVWTDMVVHVVIVWRVMNZVULVWSTVVHVUKVWRV
      EZVWRRVEZVVIVXCTWNVVHVUJVWQVEZVXDAVVGVXFVVAHVQVUJVWQVUDUUAQZVVHVWRVVJPZVX
      EVVHVVLVWQVVJPZVXHVVOVVBMVVJCWPZVWPMPVXIVVGAVXJVVAGWJVUIWQMVVJVWPCUUBUUCV
      UDVWQVRVTZVWRWCQVUKVWRWRVTVVRVVHVXHVWSVXCSVXKVWRWAQXAWSVXBVUDVWKCNZUQZONZ
      VUDVWMCNZUQZONZTWNZLMWOVXAVWOVXRLMVWKMPZVWLVXNVWNVXQTDVWKVULVXNMVVCVUIVWK
      SZVUKVXMOVXTVUJVXLVUDVUIVWKCWTXBZXCZVWIVXMOXDXEZVXSVWMMPZVWNVXQSVWKWQZDVW
      MVULVXQMVVCVUIVWMSZVUKVXPOVYFVUJVXOVUDVUIVWMCWTXBZXCVWIVXPOXDXEQXFXGVWTVX
      RDLMVXTVULVXNVWSVXQTVYBVXTVWRVXPOVXTVWQVXOVUDVXTVWPVWMCVUIVWKURWMUUDXCXBZ
      XCXFXHXIXLUUHVVBVWFVWLVUETWNZLMWOZVWLBUIZTWNZLMWOZBRXJZVWGVVBVULVUETWNZDM
      WOZVYJVVBVYODMVVHVVIVWAVULVUETVVHVVSVVTVVIVWATWNVWBVWDVUKVUDWRUUEVVRVWEXA
      WSVYJVXNVUETWNZLMWOVYPVYIVYQLMVXSVWLVXNVUETVYCXMXGVYOVYQDLMVXTVULVXNVUETV
      YBXMXHXIXLVYMVYJBVUERVYKVUESVYLVYILMVYKVUEVWLTUUFUUIUUGVTZUUJVVBDMVUKUEZU
      FZXKZONZOVYTULZXNVKVLZVUEVVFVVBMVVJVYSWPZVWKVYSNZVWMVYSNZVEZLMWOZWUBWUDSV
      VBDMVUKVVJVYSVVQVYSWKZWLZVVBVXDDMWOZWUIVVBVXDDMVXGWSWUIVXMVXPVEZLMWOWULWU
      HWUMLMVXSWUFVXMWUGVXPDVWKVUKVXMMVYSVYAWUJVXLVUDVWKCXDXOXEZVXSVYDWUGVXPSVY
      EDVWMVUKVXPMVYSVYGWUJVXOVUDVWMCXDXOXEQXPXGVXDWUMDLMVXTVUKVXMVWRVXPVYAVYHX
      PXHXIXLLVYSUUKVTVVBVUDWUAOVVBLMWUFXQZVUDWUAVVBWUOVUDDMVUJXQZUQZVUDWUOLMVX
      MXQDMVUKXQWUQLMWUFVXMWUNUULDLMVUKVXMVYAUUMDMVUDVUJUUNUUOVVBWUQVUDRUQZVUDV
      VBWUPRVUDAWUPRSVVAAWUPCUFXKZRAVXJCMXRWUPWUSSGMVVJCXSDMCXTYAIYBWJXBVVBVVTW
      URVUDSVVBVVLVVTAVVLVVAVVNWJVWCQVUDRUURYEYBUUPVVBWUEVYSMXRWUOWUASWUKMVVJVY
      SXSLMVYSXTYAYCXCVVBVVEXNVKVLZVVFWUDVVBVVERVEZVVEYDYFZUBUIZVYKTWNZUBVVEWOZ
      BRXJZWUTVVFSVVBMRVVCWPZWVAVWJMRVVCYQQVVBVVCVFZYDYFWVBVVBWVHMYDVVBWVGWVHMS
      VWJMRVVCUUQQURMPMYDYFVVBUUSMURUUTUVAUVBWVHYDVVEYDVVCUVCUVDYEVVBWVFVYNVYRV
      VBWVEVYMBRVVBWVGVVCMXRWVEVYMYGVWJMRVVCXSWVDVYLUBLMVVCWVCVWLVYKTUVEUVIYAUV
      FUVGBUBVVEUVHWGVVBXNVVEWUCVKVVBWUCOVYSUVJZUFVVEOVYSUVKVVBWVIVVCVVBDUCMVVJ
      VUKUCUIZONVULVYSOVVQVVBVYSUVLVVBUCVVJUGUVMUVTUNZOVVJWVKOWPVVBUWAVCUVNWVJV
      UKOWTUVOUVPUVQUVRYCUVSYHVVBVUBAVUARVUBAUYSRUYTAVUSRREWPZUYSRVEZJEYIZRREYQ
      YAZUWBUWCZYJVUNUSPVVBDMVUMYKYLVCVVBVXSVSZVWLVVBMRVWKVVCVWJVPYJVXSVWKVUNNZ
      VUBVWLUMUNZSVVBVXSWVRVUBVXNUMUNZWVSDVWKVUMWVTMVUNVXTVULVXNVUBUMVYBYMZVUNW
      KZVUBVXNUMUWDXEZVXSVWLVXNVUBUMVYCYMYNYOUWEUYRUSPADMUYQYKYLVCAVVAVXSWVRUWF
      PWVQWVRVVBMRVWKVUNVVBDMVUMRVUNVVHVUBVULVVBVUBRPVVGWVPWJVWHUWGWWBWLVPYJUWH
      AVXSVWKUYRNVWKDMVUAVUMUAUOZUEZNZVUAWVRUAUOZAVWKUYRWWEADMUYQWWDAVVGVSZUYQV
      UAVUBFUKZVUCULZONZUMUNZUAUOZWWDWWHFVURPZVUQFUFZUYTUHVUAVEZVUARUYTUHVEUYQW
      WMSWWHVUSVVMWWNAVUSVVGJWJVVPBVUJEFKUWIVTZAVUQVVGVUTWJWWHRUYSFWPWWOUYSVEWW
      PWWHBRVYKVUJPZVYKENZUGUWKZUYSFWWHVYKRPZVSWWSUYSPZUGUYSPZWWTUYSPWWHERXRZWX
      AWXBAWXDVVGAVUSWVLWXDJWVNRREXSYAWJZRVYKEUWLWIAWXCVVGWXAAVUSWXCJEUWJQVOWWR
      WWSUGUYSUWMVTKWLRUYSFYQWWOUYSUYTUWNYAWWHUYSRUYTAWVMVVGWVOWJUWOUAVUAFUWPUW
      QWWHVUAWWLVUMUAWWHVVAVSZWWKVULVUBUMWXFWWJVUKOWXFVYKWWJPZVYKVUKPZYGZBUWRWW
      JVUKSWXFWXIBWXFWXAVYKFNZVUBSZVSZWXAWWSVUBSZVSZWWRVSZWXGWXHWXFWXLWXAWXMWWR
      VSZVSWXOWXFWXAWXKWXPWXFWXAVSZWXKWWRWWTVUBSZVSZWXPWXQWXKWXRWXSWXQWXJWWTVUB
      WXAWXJWWTSZWXFWXAWWTUSPWXTWWRWWSUGVYKEXDUWSUXBBRWWTUSFKUWTUXCYOYRWXQWXRWW
      RWXQWXRWWTUGYFZWWRWXQWYAWXRVUBUGYFZVVAWYBWWHWXAVUBUYSUGUXAUXDWWTVUBUGUXEU
      XFWWRWWTUGWWRWWSUGUXGUXHUXIUXJUXKWXSWWRWXMVSWXPWWRWXRWXMWWRWWTWWSVUBWWRWW
      SUGUXLYRUXMWWRWXMUXNUXOUXPUXQWXAWXMWWRUYBUXRWXFFRXRZWXGWXLYGWWHWYCVVAWWHW
      WNRRFWPWYCWWQFYIRRFXSYAWJRVUBVYKFYPQWXHVYKVUDPZWWRVSWXFWXOVYKVUDVUJUYLWXF
      WYDWXNWWRWXFWXDWYDWXNYGWWHWXDVVAWXEWJRVUBVYKEYPQUXSUYCUXTUYABWWJVUKBWWIVU
      CBFBFBRWWTUEKBRWWTUYDUYEUYFBVUCYSUYGBVUKYSUYMXLXCYMUYHYBUYIUYJVXSWWFVUAWV
      TUAUOZWWGDVWKWWDWYEMWWEVXTVUAVUMWVTUAWWAYTWWEWKVUAWVTUAUYNXEVXSVUAWVRWVTU
      AWWCYTYNUYKUYOAVUSVUHVUGSJUAEUYPQYH $.
  $}

  ${
    $d g j k m n x y z F $.  $d g j k n x G $.  $d m J $.  $d j k m n x y ph $.
    $d m x y A $.
    mbfi1fseq.1 $e |- ( ph -> F e. MblFn ) $.
    mbfi1fseq.2 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    ${
      mbfi1fseq.3 $e |- J = ( m e. NN , y e. RR |->
        ( ( |_ ` ( ( F ` y ) x. ( 2 ^ m ) ) ) / ( 2 ^ m ) ) ) $.
      $( Lemma for ~ mbfi1fseq .  (Contributed by Mario Carneiro,
         16-Aug-2014.) $)
      mbfi1fseqlem1 $p |- ( ph -> J : ( NN X. RR ) --> ( 0 [,) +oo ) ) $=
        ( cv cfv c2 co cc0 wcel cr wral cn wa cle wbr cexp cmul cfl cdiv cxp wf
        cpnf cico simpr ffvelrn syl2an elrege0 sylib simpld cn0 nnexpcl sylancr
        2nn nnnn0 ad2antrl nnred remulcld reflcl syl nndivred clt nnnn0d mulge0
        nn0ge0d syl12anc flge0nn0 syl2anc nngt0d divge0 syl22anc sylanbrc fmpt2
        ralrimivva ) ABIZDJZKCIZUALZUBLZUCJZWBUDLZMUGUHLZNZBOPCQPQOUEWFEUFAWGCB
        QOAWAQNZVSONZRZRZWEONMWESTZWGWKWDWBWKWCONZWDONZWKVTWBWKVTONZMVTSTZWKVTW
        FNZWOWPRZAOWFDUFWIWQWJGWHWIUIOWFVSDUJUKVTULUMZUNWKWBWHWBQNZAWIWHKQNWAUO
        NWTURWAUSKWAUPUQUTZVAZVBZWCVCVDZXAVEWKWNMWDSTWBONZMWBVFTWLXDWKWDWKWMMWC
        STZWDUONXCWKWRXEMWBSTXFWSXBWKWBWKWBXAVGVIVTWBVHVJWCVKVLVIXBWKWBXAVMWDWB
        VNVOWEULVPVRCBQOWEWFEHVQUM $.

      mbfi1fseq.4 $e |- G = ( m e. NN |-> ( x e. RR |->
        if ( x e. ( -u m [,] m ) ,
        if ( ( m J x ) <_ m , ( m J x ) , m ) , 0 ) ) ) $.
      $( Lemma for ~ mbfi1fseq .  (Contributed by Mario Carneiro,
         16-Aug-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
      mbfi1fseqlem2 $p |- ( A e. NN -> ( G ` A ) = ( x e. RR |->
        if ( x e. ( -u A [,] A ) ,
        if ( ( A J x ) <_ A , ( A J x ) , A ) , 0 ) ) ) $=
        ( cr cv cneg cicc co cle cif cc0 wcel wbr cmpt cn wceq negeq id oveq12d
        eleq2d oveq1 breq12d ifbieq12d eqidd mpteq2dv reex mptex fvmpt ) EDBMBN
        ZENZOZUSPQZUAZUSURHQZUSRUBZVCUSSZTSZUCBMURDOZDPQZUAZDURHQZDRUBZVJDSZTSZ
        UCUDGUSDUEZBMVFVMVNVBVIVETVLTVNVAVHURVNUTVGUSDPUSDUFVNUGZUHUIVNVDVKVCUS
        VJDVNVCVJUSDRUSDURHUJZVOUKVPVOULVNTUMULUNLBMVMUOUPUQ $.

      $( Lemma for ~ mbfi1fseq .  (Contributed by Mario Carneiro,
         16-Aug-2014.) $)
      mbfi1fseqlem3 $p |- ( ( ph /\ A e. NN ) -> ( G ` A ) : RR -->
        ran ( m e. ( 0 ... ( A x. ( 2 ^ A ) ) ) |-> ( m / ( 2 ^ A ) ) ) ) $=
        ( cn wcel cr cc0 co cdiv cfv syl wa c2 cexp cmul cfz cmpt crn cneg cicc
        cv wf cle wbr cif wceq clt cxp cfl wral cpnf cico cxr wss pnfxr icossre
        wb 0re mp2an simpr ffvelrn syl2an sseldi cn0 2nn nnnn0 nnexpcl ad2antrl
        sylancr nnred remulcld reflcl ralrimivva fmpt2 sylib fovrn syl3an1 nnre
        nndivred 3expa nngt0 jca lemul1 syl3anc biimpa cuz simplr adantr fveq2d
        ad2antlr cz simpl oveq2d oveq12d ovex ovmpt2a syl2anc ffvelrnda elrege0
        oveq1d simpld nnnn0d mulge0 syl12anc flge0nn0 nn0cnd nncnd nnne0d eqtrd
        nn0ge0d divcan1d eqeltrd nn0uz syl6eleq nnmulcl mpdan nnzd elfz5 mpbird
        oveq1 eqid fvmpt recnd divcan4d elfznn0 nn0red adantl fnfvelrn eqeltrrd
        wfn fmptd nndivre syl2anr ffn wn eluzfz2 ifclda eluzfz1 nncn nnne0 ifcl
        div0d mbfi1fseqlem2 feq1d ) ADMNZUAZOEPDUBDUCQZUDQZUEQZEUJZUUPRQZUFZUGZ
        DGSZUKOUVBBOBUJZDUHDUIQNZDUVDHQZDULUMZUVFDUNZPUNZUFZUKUUOBOUVIUVBUVJUUO
        UVDONZUAZUVHUVBNPUVBNUVIUVBNUVLUVGUVFDUVBUVLUVGUAZUVFUUPUDQZUVASZUVFUVB
        UVMUVOUVNUUPRQZUVFUVMUVNUURNZUVOUVPUOUVMUVQUVNUUQULUMZUVLUVGUVRUVLUVFON
        ZDONZUUPONZPUUPUPUMZUAZUVGUVRVFAUUNUVKUVSAMOUQOHUKZUUNUVKUVSACUJZFSZUBU
        USUCQZUDQZURSZUWGRQZONZCOUSEMUSUWDAUWKECMOAUUSMNZUWEONZUAZUAZUWIUWGUWOU
        WHONUWIONUWOUWFUWGUWOPUTVAQZOUWFPONUTVBNUWPOVCVGVDPUTVEVHAOUWPFUKZUWMUW
        FUWPNUWNJUWLUWMVIOUWPUWEFVJVKVLUWOUWGUWLUWGMNZAUWMUWLUBMNZUUSVMNUWRVNUU
        SVOUBUUSVPVRVQZVSVTUWHWATUWTWHWBECMOUWJOHKWCWDDUVDOMOHWEWFWIZUUNUVTAUVK
        DWGWSZUVLUUPMNZUWCUUNUXCAUVKUUNUWSDVMNUXCVNDVOUBDVPVRZWSZUXCUWAUWBUUPWG
        UUPWJWKTUVFDUUPWLWMWNUVMUVNPWOSZNUUQWTNUVQUVRVFUVMUVNVMUXFUVMUVNUVDFSZU
        UPUDQZURSZVMUVMUVNUXIUUPRQZUUPUDQUXIUVMUVFUXJUUPUDUVMUUNUVKUVFUXJUOUVLU
        UNUVGAUUNUVKWPWQUUOUVKUVGWPECDUVDMOUWJUXJHUUSDUOZUWEUVDUOZUAZUWIUXIUWGU
        UPRUXMUWHUXHURUXMUWFUXGUWGUUPUDUXMUWEUVDFUXKUXLVIWRUXMUUSDUBUCUXKUXLXAX
        BZXCWRUXNXCKUXIUUPRXDXEXFXIUVMUXIUUPUVMUXIUVLUXIVMNZUVGUVLUXHONPUXHULUM
        ZUXOUVLUXGUUPUVLUXGONZPUXGULUMZUVLUXGUWPNUXQUXRUAZUUOOUWPUVDFAUWQUUNJWQ
        XGUXGXHWDZXJUVLUUPUXEVSZVTUVLUXSUWAPUUPULUMUXPUXTUYAUVLUUPUVLUUPUXEXKXS
        UXGUUPXLXMUXHXNXFWQZXOUVMUUPUVLUXCUVGUXEWQZXPZUVMUUPUYCXQZXTXRUYBYAYBYC
        UVMUUQUVLUUQMNZUVGUUNUYFAUVKUUNUXCUYFUXDDUUPYDYEWSZWQYFUVNPUUQYGXFYHZEU
        VNUUTUVPUURUVAUUSUVNUUPRYIUVAYJZUVNUUPRXDYKTUVMUVFUUPUVMUVFUVLUVSUVGUXA
        WQYLUYDUYEYMXRUVMUVAUURYSZUVQUVOUVBNUVLUYJUVGUUOUYJUVKUUOUUROUVAUKUYJUU
        OEUURUUTOUVAUUSUURNZUUSONUXCUUTONUUOUYKUUSUUSUUQYNYOUUNUXCAUXDYPUUSUUPU
        UAUUBUYIYTUUROUVAUUCTWQZWQUYHUURUVNUVAYQXFYRUVLDUVBNUVGUUDUVLUUQUVASZDU
        VBUVLUYMUUQUUPRQZDUVLUUQUURNZUYMUYNUOUVLUUQUXFNZUYOUVLUUQVMUXFUVLUUQUYG
        XKYBYCZPUUQUUETZEUUQUUTUYNUURUVAUUSUUQUUPRYIUYIUUQUUPRXDYKTUVLDUUPUVLDU
        XBYLUVLUUPUXEXPUVLUUPUXEXQYMXRUVLUYJUYOUYMUVBNUYLUYRUURUUQUVAYQXFYRWQUU
        FUVLPUVASZPUVBUVLUYSPUUPRQZPUVLPUURNZUYSUYTUOUVLUYPVUAUYQPUUQUUGTZEPUUT
        UYTUURUVAUUSPUUPRYIUYIPUUPRXDYKTUVLUXCUYTPUOUXEUXCUUPUUPUUHUUPUUIUUKTXR
        UVLUYJVUAUYSUVBNUYLVUBUURPUVAYQXFYRUVEUVHPUVBUUJXFUVJYJYTUUOOUVBUVCUVJU
        UNUVCUVJUOAABCDEFGHIJKLUULYPUUMYH $.

      $( Lemma for ~ mbfi1fseq .  This lemma is not as interesting as it is
         long - it is simply checking that ` G ` is in fact a sequence of
         simple functions, by verifying that its range is in
         ` ( 0 ... n 2 ^ n ) / ( 2 ^ n ) ` (which is to say, the numbers from
         ` 0 ` to ` n ` in increments of ` 1 / ( 2 ^ n ) ` ), and also that the
         preimage of each point ` k ` is measurable, because it is equal to
         ` ( -u n [,] n ) i^i ( ``' F " ( k [,) k + 1 / ( 2 ^ n ) ) ) ` for
         ` k < n ` and ` ( -u n [,] n ) i^i ( ``' F " ( k [,) +oo ) ) ` for
         ` k = n ` .  (Contributed by Mario Carneiro, 16-Aug-2014.) $)
      mbfi1fseqlem4 $p |- ( ph -> G : NN --> dom S.1 ) $=
        ( wcel cr co cle wbr cc0 wa syl syl2anc vn vk cn wfn cv cfv cdm wral wf
        cneg cicc cif cmpt cexp cmul cdiv crn wss cn0 2nn nnnn0 nnexpcl sylancr
        c2 adantl eqid frn fss cfn ffn sylib csn cdif ccnv cima cmnf caddc cioo
        weq cvol wceq ad2antlr cvv simpr ovex ifex fvmpt2 sylancl eqtrd adantlr
        c1 eqeq1d wne neeq1 syl5ibrcom necon1ai pm4.71rd iftrue wb nnred adantr
        iffalse cfl cpnf cxr 0re remulcld reflcl syl3anc ifcl biantrurd 3bitr4d
        breq1 clt syl112anc lemul1 bitrd fveq2d oveq2d oveq12d breq2d sylan9bbr
        cz 3bitr2d ssdifssd sselda nncnd nnne0d eqeltrd biimparc ad2antrr recnd
        ralrimiva rexrd elioomnf elpreima bitr4d 3bitrd wn syl5bb citg1 a1i cfz
        reex mptex fnmpti mbfi1fseqlem3 elfznn0 nndivre syl2anr fmptd wfo fzfid
        nn0red dffn4 fofi ssfi cin mbfi1fseqlem2 vex c0ex eldifsni syl6 simpllr
        fveq1d cico pnfxr icossre mp2an ffvelrn syl2an sseldi ad2antrl nndivred
        ralrimivva fmpt2 fovrn syl3an1 3expa lemin letri3d eqeq2d min2 biantrud
        leidd ffvelrnda elrege0 simpld nngt0d lemuldiv nnmulcl mpdan nnzd simpl
        cxp flge ovmpt2a eleqtrrd wrex rnmpt abeq2i elfzelz zcnd divcan1d oveq1
        eleq1d rexlimdva syl5bi imp syldan flbi eqtr3d eqbrtrrd ex impbid1 nnre
        jca eldifi nn0ge0d ifboth eqbrtrd ralrn mpbird r19.21bi sylan2 divmul3d
        sstrd ifnefalse eleq2d nnrecred readdcld ltmul1 adddird recid2d anbi12d
        ancom syl6bb pm2.61dane notbid lenltd anbi2d pm5.32da fniniseg renegcld
        eldif iccmbl mblss sseld adantrd eqrdv rembl mbfima difmbl inmbl mblvol
        elin cmbf covol sylbid expimpd ssrdv iccssre iccvolcl eqeltrrd ovolsscl
        i1fd ffnfv sylanbrc ) AFUCUDZUAUEZFUFZUUAUGZLZUAUCUHUCVVLFUIVVIADUCBMBU
        EZDUEZUJVVOUKNLVVOVVNGNZVVOOPVVPVVOULQULZUMFBMVVQUUDUUEKUUFUUBAVVMUAUCA
        VVJUCLZRZUBVVKVVSMDQVVJVDVVJUNNZUONZUUCNZVVOVVTUPNZUMZUQZVVKUIZVWEMURZM
        MVVKUIZABCVVJDEFGHIJKUUGZVVSVWBMVWDUIZVWGVVSDVWBVWCMVWDVVOVWBLZVVOMLVVT
        UCLZVWCMLVVSVWKVVOVVOVWAUUHUUNVVRVWLAVVRVDUCLZVVJUSLZVWLUTVVJVAZVDVVJVB
        VCZVEVVOVVTUUIUUJVWDVFZUUKZVWBMVWDVGSZMVWEMVVKVHTZVVSVWEVILZVVKUQZVWEUR
        ZVXBVILVVSVWBVILVWBVWEVWDUULZVXAVVSQVWAUUMVVSVWDVWBUDZVXDVVSVWJVXEVWRVW
        BMVWDVJSVWBVWDUUOVKVWBVWEVWDUUPTVVSVWFVXCVWIMVWEVVKVGSZVWEVXBUUQTVVSUBU
        EZVXBQVLZVMZLZRZVVKVNVXGVLVOZVVJUJZVVJUKNZUBUAVSZMEVNZVPVXGWKVVTUPNZVQN
        ZVRNZVOZULZVXPVPVXGVRNZVOZVMZUURZVTUGZVXKBVXLVYEVXKVVNMLZVVNVVKUFZVXGWA
        ZRZVYGVVNVXNLZVVNVYDLZRZRZVVNVXLLZVVNVYELZVXKVYGVYIVYMVXKVYGRZVYIVYKVVJ
        VVNGNZVVJOPZVYRVVJULZQULZVXGWAZVYKWUBRVYMVYQVYHWUAVXGVVSVYGVYHWUAWAZVXJ
        VVSVYGRZVYHVVNBMWUAUMZUFZWUAVVRVYHWUFWAAVYGVVRVVNVVKWUEABCVVJDEFGHIJKUU
        SUVEWBZWUDVYGWUAWCLWUFWUAWAZVVSVYGWDZVYKVYTQVYSVYRVVJVVJVVNGWEUAUUTWFUV
        AWFBMWUAWCWUEWUEVFZWGWHWIZWJWLVYQWUBVYKVYQWUBWUAQWMZVYKVYQWULWUBVXGQWMZ
        VXJWUMVVSVYGVXGVXBQUVBWBWUAVXGQWNWOVYKWUAQVYKVYTQXBWPUVCZWQVYQVYKWUBVYL
        VYKWUBVYTVXGWAZVYQVYLVYKWUAVYTVXGVYKVYTQWRWLVYQWUOVVNVYALZVXGVVNEUFZOPZ
        RZVYLVYQWUOWUSWSVXGVVJVYQVXORZWUOVVJVYROPZWURWUSWUTVVJVYTOPZWVAVVJVVJOP
        ZRZWUOWVAWUTVVJMLZVYRMLZWVEWVBWVDWSVYQWVEVXOVYQVVJAVVRVXJVYGUVDZWTZXAZV
        YQWVFVXOVVSVYGWVFVXJAVVRVYGWVFAUCMUWOMGUIZVVRVYGWVFACUEZEUFZVDVVOUNNZUO
        NZXCUFZWVMUPNZMLZCMUHDUCUHWVJAWVQDCUCMAVVOUCLZWVKMLZRZRZWVOWVMWWAWVNMLW
        VOMLWWAWVLWVMWWAQXDUVFNZMWVLQMLZXDXELWWBMURZXFUVGQXDUVHUVIZAMWWBEUIZWVS
        WVLWWBLWVTIWVRWVSWDMWWBWVKEUVJUVKUVLWWAWVMWVRWVMUCLZAWVSWVRVWMVVOUSLWWG
        UTVVOVAVDVVOVBVCUVMZWTXGWVNXHSWWHUVNUVODCUCMWVPMGJUVPVKVVJVVNMUCMGUVQUV
        RUVSZWJXAZWVIVVJVYRVVJUVTXIWUTVYTVVJWAVYTVVJOPZWVBRWUOWVBWUTVYTVVJWUTWV
        FWVEVYTMLZWWJWVIVYSVYRVVJMXJZTWVIUWAWUTVXGVVJVYTVYQVXOWDUWBWUTWWKWVBWUT
        WVFWVEWWKWWJWVIVYRVVJUWCZTXKXLWUTWVCWVAWUTVVJWVIUWEUWDXLVXOWURVVJWUQOPZ
        VYQWVAVXGVVJWUQOXMVYQVWAWUQVVTUONZXCUFZOPZVVJWWQVVTUPNZOPZWWOWVAVYQWVEW
        WQMLZVVTMLZQVVTXNPZWWRWWTWSWVHVYQWWPMLZWXAVYQWUQVVTVVSVYGWUQMLZVXJWUDWX
        EQWUQOPZWUDWUQWWBLWXEWXFRVVSMWWBVVNEAWWFVVRIXAZUWFWUQUWGVKUWHWJZVYQVVTV
        YQVVRVWLWVGVWPSZWTZXGZWWPXHSZWXJVYQVVTWXIUWIZVVJWWQVVTUWJXOVYQWWOVWAWWP
        OPZWWRVYQWVEWXEWXBWXCWWOWXNWSWVHWXHWXJWXMVVJWUQVVTXPXOVYQWXDVWAYCLWXNWW
        RWSWXKVYQVWAVYQVVRVWAUCLZWVGVVRVWLWXOVWPVVJVVTUWKUWLSUWMWWPVWAUWPTXQVYQ
        VYRWWSVVJOVYQVVRVYGVYRWWSWAWVGVXKVYGWDZDCVVJVVNUCMWVPWWSGDUAVSZCBVSZRZW
        VOWWQWVMVVTUPWXSWVNWWPXCWXSWVLWUQWVMVVTUOWXSWVKVVNEWXQWXRWDXRWXSVVOVVJV
        DUNWXQWXRUWNXSZXTXRWXTXTJWWQVVTUPWEUWQTZYAXLYBWUTWUPWURWUTVVNMVYAVYQVYG
        VXOWXPXAVXOVYAMWAVYQVXOMVXTWRVEUWRXKYDVYQVXGVVJWMZRZWWQVXGVVTUONZWAZWYD
        WWPOPZWWPWYDWKVQNZXNPZRZWUOWUSVYQWYEWYIWSZWYBVYQWXDWYDYCLZWYJWXKVXKWYKV
        YGVVSVXJVXGVWELZWYKVVSVXIVWEVXGVVSVXBVWEVXHVXFYEYFVVSWYLWYKWYLVXGVWCWAZ
        DVWBUWSZVVSWYKWYNUBVWEDUBVWBVWCVWDVWQUWTUXAVVSWYMWYKDVWBVVSVWKRZWYKWYMV
        WCVVTUONZYCLWYOWYPVVOYCWYOVVOVVTWYOVVOVWKVVOYCLVVSVVOQVWAUXBVEZUXCWYOVV
        TVVRVWLAVWKVWPWBZYGWYOVVTWYRYHUXDWYQYIWYMWYDWYPYCVXGVWCVVTUOUXEUXFWOUXG
        UXHUXIUXJXAWWPWYDUXKTXAWYCWUOVXGVVJOPZVYRVXGWAZRZWYTWYEWYBWUOXUAWSVYQWY
        BWUOXUAWYBWUOXUAWYBWUORZWYSWYTXUBVYRVXGVVJOXUBVYTVYRVXGXUBVYSVYTVYRWAZX
        UBVYTVVJWMZVYSWUOXUDWYBVYTVXGVVJWNYJVYSVYTVVJVYSVYRVVJXBWPSZVYSVYRVVJWR
        ZSWYBWUOWDUXLZXUEUXMXUGUXQUXNXUAVYTVYRVXGXUAVYSXUCWYTVYSWYSVYRVXGVVJOXM
        YJXUFSWYSWYTWDWIUXOVEWYCWYSWYTVXKWYSVYGWYBVXJVVSVXGVXBLWYSVXGVXBVXHUXRV
        VSWYSUBVXBVVSWYSUBVXBUHZVYHVVJOPZBMUHZVVSXUIBMWUDVYHWUAVVJOWUKWUDWWKQVV
        JOPZWUAVVJOPZWUDWVFWVEWWKWWIVVRWVEAVYGVVJUXPZWBZWWNTWUDVVJVVRVWNAVYGVWO
        WBUXSVYKWWKXUKXULVYTQVYTWUAVVJOXMQWUAVVJOXMUXTTUYAYMVVSVVKMUDZXUHXUJWSV
        VSVWHXUOVWTMMVVKVJZSZWYSXUIUBBMVVKVXGVYHVVJOXMUYBSUYCUYDUYEYKXKVYQWYTWY
        EWSWYBVYQWYTWWSVXGWAWYEVYQVYRWWSVXGWYAWLVYQWWQVXGVVTVYQWWQWXLYLVYQVXGVX
        KVXGMLZVYGVVSVXIMVXGVVSVXBMVXHVVSVXBVWEMVXFVWSUYGYEYFXAZYLZVYQVVTWXIYGZ
        VYQVVTWXIYHZUYFXQXAYDWYCWUSWYHWYFRWYIWYCWUPWYHWURWYFWYBWUPVVNVXTLZVYQWY
        HWYBVYAVXTVVNVXGVVJMVXTUYHUYIVYQXVCWUQVXRXNPZWWPVXRVVTUONZXNPZWYHVYQWUQ
        VXSLZWXEXVDRZXVCXVDVYQVXRXELXVGXVHWSVYQVXRVYQVXGVXQXUSVYQVVTWXIUYJZUYKZ
        YNVXRWUQYOSVYQXVCVYGXVGRZXVGVYQEMUDZXVCXVKWSVYQWWFXVLVVSWWFVXJVYGWXGYKM
        WWBEVJSZMVVNVXSEYPSVYQVYGXVGWXPXKYQVYQWXEXVDWXHXKXLVYQWXEVXRMLWXBWXCXVD
        XVFWSWXHXVJWXJWXMWUQVXRVVTUYLXOVYQXVEWYGWWPXNVYQXVEWYDVXQVVTUONZVQNWYGV
        YQVXGVXQVVTXUTVYQVXQXVIYLXVAUYMVYQXVNWKWYDVQVYQVVTXVAXVBUYNXSWIYAYRYBVY
        QWURWYFWSZWYBVYQXURWXEWXBWXCXVOXUSWXHWXJWXMVXGWUQVVTXPXOXAUYOWYHWYFUYPU
        YQXLUYRVYLWUPVVNVYCLZYSZRVYQWUSVVNVYAVYCVUEVYQXVQWURWUPVYQXVQWUQVXGXNPZ
        YSWURVYQXVPXVRVYQWUQVYBLZWXEXVRRZXVPXVRVYQVXGXELXVSXVTWSVYQVXGXUSYNVXGW
        UQYOSVYQXVPVYGXVSRZXVSVYQXVLXVPXWAWSXVMMVVNVYBEYPSVYQVYGXVSWXPXKYQVYQWX
        EXVRWXHXKXLUYSVYQVXGWUQXUSWXHUYTYQVUAYTYQYBVUBYRVUBVXKXUOVYOVYJWSZVXKVW
        HXUOVVSVWHVXJVWTXAXUPSMVXGVVNVVKVUCZSVYPVYMVXKVYNVVNVXNVYDVUPVXKVYMVYGV
        XKVYKVYGVYLVXKVXNMVVNVXKVXNVYFLZVXNMURZVXKVXMMLZWVEXWDVXKVVJVVRWVEAVXJX
        UMWBZVUDZXWGVXMVVJVUFTZVXNVUGSVUHVUIWQYTXLVUJVXKXWDVYDVYFLZVYEVYFLXWIAX
        WJVVRVXJAVYAVYFLZVYCVYFLZXWJAMVYFLVXTVYFLZXWKVUKAEVUQLZMMEUIZXWMHAWWFWW
        DXWOIWWEMWWBMEVHWHZMVPVXREVULTVXOMVXTVYFXJVCAXWNXWOXWLHXWPMVPVXGEVULTVY
        AVYCVUMTYKVXNVYDVUNTYIZVXKVXLVTUFZVXLVURUFZMVXKVXLVYFLXWRXWSWAXWQVXLVUO
        SVXKVXLVXNURXWEVXNVURUFZMLXWSMLVXKBVXLVXNVXKVYOVYJVYKVXKXUOXWBVVSXUOVXJ
        XUQXAXWCSVXKVYGVYIVYKVYQVYIWUBVYKVYQVYHWUAVXGVVSVYGWUCVXJWUDVYHWUFWUAWU
        GWUDVYGWUAMLZWUHWUIWUDWWLWWCXXAWUDWVFWVEWWLWWIXUNWWMTXFVYKVYTQMXJWHBMWU
        AMWUEWUJWGTWIWJWLWUNVUSVUTVUSVVAVXKXWFWVEXWEXWHXWGVXMVVJVVBTVXKVXNVTUFZ
        XWTMVXKXWDXXBXWTWAXWIVXNVUOSVXKXWFWVEXXBMLXWHXWGVXMVVJVVCTVVDVXLVXNVVEX
        IYIVVFYMUAUCVVLFVVGVVH $.

      $( Lemma for ~ mbfi1fseq .  Verify that ` G ` describes an increasing
         sequence of positive functions.  (Contributed by Mario Carneiro,
         16-Aug-2014.) $)
      mbfi1fseqlem5 $p |- ( ( ph /\ A e. NN ) ->
        ( 0p oR <_ ( G ` A ) /\ ( G ` A ) oR <_ ( G ` ( A + 1 ) ) ) ) $=
        ( cn wcel cle wbr co cc0 cr c2 wa c0p cfv cofr caddc cneg cicc cif wral
        c1 cv cexp cmul cfl cdiv clt cn0 cpnf wf adantr ffvelrnda elrege0 sylib
        simpld 2nn nnnn0 nnexpcl sylancr ad2antlr nnred remulcld nnnn0d nn0ge0d
        cico mulge0 syl12anc flge0nn0 syl2anc nn0red nngt0d syl22anc wceq simpr
        divge0 fveq2d simpl oveq2d oveq12d ovex ovmpt2a adantll breqtrrd ifboth
        breq2 0le0 sylancl ralrimiva cc cvv wfn csn fnconstg ax-mp df-0p fneq1i
        cxp 0re mpbir a1i citg1 cdm mbfi1fseqlem4 i1ff ffn 3syl wss adantl cmpt
        mbfi1fseqlem2 fveq1d ffvelrn syl2an reflcl syl ifcl eqid fvmpt2 ofrfval
        eqtrd mpbird 2cn recnd mulassd wb mpbid cz eqbrtrd 3brtr4d letrd iftrue
        cnex reex cin ax-resscn sseqin2 mpbi 0pval pnfxr icossre mp2an ad2antrl
        sseldi nndivred ralrimivva fmpt2 fovrn syl3an1 3expa nnre mbfi1fseqlem1
        cxr ad2antrr peano2nn fovrnd min1 expp1 eqeltrrd nnne0d divcan1d oveq1d
        3eqtr2d flle 2re 2pos pm3.2i lemul1 syl3anc eqtr4d flcld 2z zmulcl flge
        lemuldiv syl112anc lep1d renegcld lenegd iccss sselda wn iffalse simprd
        min2 pm2.61dan inidm jca ) ADMNZUAZUBDGUCZOUDZPZUWSDUJUEQZGUCZUWTPZUWRU
        XARBUKZDUFZDUGQZNZDUXEHQZDOPZUXIDUHZRUHZOPZBSUIUWRUXMBSUWRUXESNZUAZRUXK
        OPZRROPZUXMUXORUXIOPZRDOPZUXPUXORUXEFUCZTDULQZUMQZUNUCZUYAUOQZUXIOUXOUY
        CSNZRUYCOPUYASNZRUYAUPPRUYDOPUXOUYCUXOUYBSNZRUYBOPZUYCUQNUXOUXTUYAUXOUX
        TSNZRUXTOPZUXOUXTRURVNQZNUYIUYJUAZUWRSUYKUXEFASUYKFUSZUWQJUTVAUXTVBVCZV
        DZUXOUYAUWQUYAMNZAUXNUWQTMNZDUQNZUYPVEDVFZTDVGVHVIZVJZVKZUXOUYLUYFRUYAO
        PUYHUYNVUAUXOUYAUXOUYAUYTVLVMUXTUYAVOVPUYBVQVRZVSZUXOUYCVUCVMVUAUXOUYAU
        YTVTUYCUYAWDWAUWQUXNUXIUYDWBAECDUXEMSCUKZFUCZTEUKZULQZUMQZUNUCZVUHUOQZU
        YDHVUGDWBZVUEUXEWBZUAZVUJUYCVUHUYAUOVUNVUIUYBUNVUNVUFUXTVUHUYAUMVUNVUEU
        XEFVULVUMWCWEVUNVUGDTULVULVUMWFWGZWHWEVUOWHKUYCUYAUOWIWJWKZWLUWQUXSAUXN
        UWQDUYSVMVIUXJUXRUXSUXPUXIDUXIUXKROWNDUXKROWNWMVRWOUXHUXPUXQUXMUXKRUXKU
        XLROWNRUXLROWNWMWPWQUWRBWRSRUXLOSUBUWSWSWSUBWRWTZUWRVUQWRRXAXFZWRWTZRSN
        ZVUSXGWRRSXBXCWRUBVURXDXEXHXIUWRUWSXJXKZNSSUWSUSUWSSWTAMVVADGABCEFGHIJK
        LXLZVAUWSXMSSUWSXNXOZWRWSNUWRUUAXISWSNUWRUUBXIZSWRXPWRSUUCSWBUUDSWRUUEU
        UFUXEWRNUXEUBUCRWBUWRUXEUUGXQUXOUXEUWSUCZUXEBSUXLXRZUCZUXLUWQVVEVVGWBAU
        XNUWQUXEUWSVVFABCDEFGHIJKLXSXTVIUXOUXNUXLSNZVVGUXLWBUWRUXNWCZUXOUXKSNZV
        UTVVHUXOUXISNZDSNZVVJAUWQUXNVVKAMSXFZSHUSZUWQUXNVVKAVUKSNZCSUIEMUIVVNAV
        VOECMSAVUGMNZVUESNZUAZUAZVUJVUHVVSVUISNVUJSNVVSVUFVUHVVSUYKSVUFVUTURUVA
        NUYKSXPXGUUHRURUUIUUJAUYMVVQVUFUYKNVVRJVVPVVQWCSUYKVUEFYAYBUULVVSVUHVVP
        VUHMNZAVVQVVPUYQVUGUQNVVTVEVUGVFTVUGVGVHUUKZVJVKVUIYCYDVWAUUMUUNECMSVUK
        SHKUUOVCDUXESMSHUUPUUQUURZUWQVVLAUXNDUUSVIZUXJUXIDSYEVRZXGUXHUXKRSYEWPB
        SUXLSVVFVVFYFYGVRYIZYHYJUWRUXDUXLUXEUXBUFZUXBUGQZNZUXBUXEHQZUXBOPZVWIUX
        BUHZRUHZOPZBSUIUWRVWMBSUXOUXHVWMUXOUXHUAZUXKVWKUXLVWLOUXOUXKVWKOPZUXHUX
        OUXKVWIOPZUXKUXBOPZVWOUXOUXKUXIVWIVWDVWBUXOVWISNZRVWIOPZUXOVWIUYKNVWRVW
        SUAUXOUXBUXEUYKMSHAVVMUYKHUSUWQUXNACEFHIJKUUTUVBUWQUXBMNZAUXNDUVCZVIZVV
        IUVDVWIVBVCZVDZUXOVVKVVLUXKUXIOPVWBVWCUXIDUVEVRUXOUYDUXTTUXBULQZUMQZUNU
        CZVXEUOQZUXIVWIOUXOUYDVXEUMQZVXGOPZUYDVXHOPZUXOVXIUYCTUMQZVXGOUXOVXIUYD
        UYATUMQZUMQUYDUYAUMQZTUMQVXLUXOVXEVXMUYDUMUXOTWRNZUYRVXEVXMWBYKUWQUYRAU
        XNUYSVITDUVFVHZWGUXOUYDUYATUXOUYDUXOUXIUYDSVUPVWBUVGZYLUXOUYAVUAYLZVXOU
        XOYKXIZYMUXOVXNUYCTUMUXOUYCUYAUXOUYCVUDYLVXRUXOUYAUYTUVHUVIUVJUVKUXOVXL
        VXFOPZVXLVXGOPZUXOVXLUYBTUMQZVXFOUXOUYCUYBOPZVXLVYBOPZUXOUYGVYCVUBUYBUV
        LYDUXOUYEUYGTSNZRTUPPZUAZVYCVYDYNVUDVUBVYGUXOVYEVYFUVMUVNUVOXIUYCUYBTUV
        PUVQYOUXOVXFUXTVXMUMQVYBUXOVXEVXMUXTUMVXPWGUXOUXTUYATUXOUXTUYOYLVXRVXSY
        MUVRWLUXOVXFSNZVXLYPNZVXTVYAYNUXOUXTVXEUYOUXOVXEUXOUYQUXBUQNVXEMNVEUXOU
        XBVXBVLZTUXBVGVHZVJZVKZUXOUYCYPNTYPNVYIUXOUYBVUBUVSUVTUYCTUWAWPVXFVXLUW
        BVRYOYQUXOUYDSNVXGSNZVXESNRVXEUPPVXJVXKYNVXQUXOVYHVYNVYMVXFYCYDVYLUXOVX
        EVYKVTUYDVXGVXEUWCUWDYOVUPUXOVWTUXNVWIVXHWBVXBVVIECUXBUXEMSVUKVXHHVUGUX
        BWBZVUMUAZVUJVXGVUHVXEUOVYPVUIVXFUNVYPVUFUXTVUHVXEUMVYPVUEUXEFVYOVUMWCW
        EVYPVUGUXBTULVYOVUMWFWGZWHWEVYQWHKVXGVXEUOWIWJVRYRYSUXOUXKDUXBVWDVWCUXO
        UXBVXBVJZUXOVVKVVLUXKDOPVWBVWCUXIDUWMVRUXODVWCUWEZYSVWJVWPVWQVWOVWIUXBV
        WIVWKUXKOWNUXBVWKUXKOWNWMVRUTUXHUXLUXKWBUXOUXHUXKRYTXQVWNVWHVWLVWKWBUXO
        UXGVWGUXEUXOVWFSNUXBSNZVWFUXFOPZDUXBOPZUXGVWGXPUXOUXBVYRUWFVYRUXOWUBWUA
        VYSUXODUXBVWCVYRUWGYOVYSVWFUXBUXFDUWHWAUWIVWHVWKRYTYDYRUXOUXHUWJZUAUXLR
        VWLOWUCUXLRWBUXOUXHUXKRUWKXQUXORVWLOPZWUCUXORVWKOPZUXQWUDUXOVWSRUXBOPZW
        UEUXOVWRVWSVXCUWLUXOUXBVYJVMVWJVWSWUFWUEVWIUXBVWIVWKROWNUXBVWKROWNWMVRW
        OVWHWUEUXQWUDVWKRVWKVWLROWNRVWLROWNWMWPUTYQUWNWQUWRBSSUXLVWLOSUWSUXCWSW
        SVVCUWRUXCVVANZSSUXCUSUXCSWTAMVVAGUSVWTWUGUWQVVBVXAMVVAUXBGYAYBUXCXMSSU
        XCXNXOVVDVVDSUWOVWEUXOUXEUXCUCZUXEBSVWLXRZUCZVWLUXOVWTWUHWUJWBVXBVWTUXE
        UXCWUIABCUXBEFGHIJKLXSXTYDUXOUXNVWLSNZWUJVWLWBVVIUXOVWKSNZVUTWUKUXOVWRV
        YTWULVXDVYRVWJVWIUXBSYEVRXGVWHVWKRSYEWPBSVWLSWUIWUIYFYGVRYIYHYJUWP $.

      $( Lemma for ~ mbfi1fseq .  Verify that ` G ` converges pointwise to
         ` F ` , and wrap up the existence quantifier.  (Contributed by Mario
         Carneiro, 16-Aug-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
      mbfi1fseqlem6 $p |- ( ph -> E. g ( g : NN --> dom S.1 /\ A. n e. NN
        ( 0p oR <_ ( g ` n ) /\ ( g ` n ) oR <_ ( g ` ( n + 1 ) ) ) /\
        A. x e. RR ( n e. NN |-> ( ( g ` n ) ` x ) ) ~~> ( F ` x ) ) ) $=
        ( cn cfv cle wbr co cr wcel vk vj citg1 cdm wf cv cofr c1 caddc wa wral
        c0p cmpt cli w3a mbfi1fseqlem4 mbfi1fseqlem5 ralrimiva cabs simpr recnd
        wex clt wrex abscld cc0 cpnf cico ffvelrnda elrege0 sylib readdcld arch
        simpld syl c2 cdiv cexp cmin cvv cuz eqid cz nnz ad2antrl cn0 1z a1i cc
        nnuz 1re rehalfcli recni 0re halfgt0 ltleii absid mp2an halflt1 eqbrtri
        wceq expcnv nnex mptex nnnn0 oveq2 ovex fvmpt expcl sylancr eqeltrd weq
        adantl oveq2d eqtr4d adantr ad2antrr fveq1d ffvelrnd cmul nnred oveq12d
        cfl mpbird wb syl112anc mpbid eqbrtrd cneg cicc cif 3eqtrd simprd letrd
        ifex syl2anc iftrue fveq2d fveq1 ralbidv climsubc2 subid1d simprl sylan
        breqtrd uztrn2 reexpcl resubcld fveq2 fvex ad3antrrr 2nn nnexpcl nnne0d
        i1ff divcan4d eqcomd 2cn wne eluzelz exprecd remulcld ax-1cn divsubdird
        2ne0 fllep1 reflcl lesubaddd peano2rem nngt0d lediv1 mbfi1fseqlem2 c0ex
        vex fvmpt2 sylancl addge01d simplrr ltled eluzle absled renegcld elicc2
        mpbir3and simpl ovmpt2a nndivred flle ledivmul2 absge0d 3brtr4d climsqz
        addge02d eqtrd rexlimddv eqeltri breq2d breq12d anbi12d mpteq2dv breq1d
        feq1 3anbi123d spcev syl3anc ) ANUCUDZHUEZULFUFZHOZPUGZQZUXIUXHUHUIRZHO
        ZUXJQZUJZFNUKZFNBUFZUXIOZUMZUXQGOZUNQZBSUKZNUXFDUFZUEZULUXHUYCOZUXJQZUY
        EUXLUYCOZUXJQZUJZFNUKZFNUXQUYEOZUMZUXTUNQZBSUKZUOZDVBABCEGHIJKLMUPZAUXO
        FNABCUXHEGHIJKLMUQURAUYABSAUXQSTZUJZUXQUSOZUXTUIRZUAUFZVCQZUYAUANUYRUYT
        STZVUBUANVDUYRUYSUXTUYRUXQUYRUXQAUYQUTZVAZVEZUYRUXTSTZVFUXTPQZUYRUXTVFV
        GVHRZTZVUGVUHUJZASVUIUXQGKVIZUXTVJZVKVNZVLZUYTUAVMVOUYRVUANTZVUBUJZUJZU
        XTUBFNUXTUHVPVQRZUXHVRRZVSRZUMZUXSVUAVTVUAWAOZVVCWBVUPVUAWCTUYRVUBVUAWD
        WEUYRVVBUXTUNQVUQUYRVVBUXTVFVSRUXTUNUYRVFUXTUBFWFVUTUMZVVBUHVTNWJUHWCTU
        YRWGWHUYRVUSFVUSWITZUYRVUSUHWKWLZWMZWHVUSUSOZUHVCQUYRVVHVUSUHVCVUSSTZVF
        VUSPQVVHVUSXAVVFVFVUSWNVVFWOWPVUSWQWRWSWTWHXBUYRUXTVUNVAZVVBVTTUYRFNVVA
        XCXDWHUYRUBUFZNTZUJZVVKVVDOZVUSVVKVRRZWIVVMVVKWFTZVVNVVOXAVVLVVPUYRVVKX
        EZXMZFVVKVUTVVOWFVVDUXHVVKVUSVRXFZVVDWBVUSVVKVRXGXHVOZVVMVVEVVPVVOWITVV
        GVVRVUSVVKXIXJXKVVMVVKVVBOZUXTVVOVSRZUXTVVNVSRVVLVWAVWBXAZUYRFVVKVVAVWB
        NVVBFUBXLZVUTVVOUXTVSVVSXNVVBWBUXTVVOVSXGXHZXMVVMVVNVVOUXTVSVVTXNXOUUAU
        YRUXTVVJUUBUUEXPUXSVTTVURFNUXRXCXDWHVURVVKVVCTZUJZVWAVWBSVWGVVLVWCVURVU
        PVWFVVLUYRVUPVUBUUCZUHVVKVUANWJUUFUUDZVWEVOZVWGUXTVVOUYRVUGVUQVWFVUNXQZ
        VWGVVIVVPVVOSTVVFVWGVVLVVPVWIVVQVOZVUSVVKUUGXJUUHXKVWGVVKUXSOZUXQVVKHOZ
        OZSVWGVVLVWMVWOXAVWIFVVKUXRVWONUXSVWDUXQUXIVWNUXHVVKHUUIXRUXSWBUXQVWNUU
        JXHVOZVWGSSUXQVWNVWGVWNUXFTSSVWNUEVWGNUXFVVKHAUXGUYQVUQVWFUYPUUKVWIXSVW
        NUUOVOUYRUYQVUQVWFVUDXQZXSXKVWGVWBUXTVPVVKVRRZXTRZYCOZVWRVQRZVWAVWMPVWG
        VWBVWSUHVSRZVWRVQRZVXAPVWGVWBVWSVWRVQRZUHVWRVQRZVSRVXCVWGUXTVXDVVOVXEVS
        VWGVXDUXTVWGUXTVWRUYRUXTWITVUQVWFVVJXQVWGVWRVWGVWRVWGVPNTVVPVWRNTUULVWL
        VPVVKUUMXJZYAZVAZVWGVWRVXFUUNZUUPUUQVWGVPVVKVPWITVWGUURWHVPVFUUSVWGUVEW
        HVWFVVKWCTVURVUAVVKUUTXMUVAYBVWGVWSUHVWRVWGVWSVWGUXTVWRVWKVXGUVBZVAUHWI
        TVWGUVCWHVXHVXIUVDXOVWGVXBVWTPQZVXCVXAPQZVWGVXKVWSVWTUHUIRPQZVWGVWSSTZV
        XMVXJVWSUVFVOVWGVWSUHVWTVXJUHSTVWGWKWHVWGVXNVWTSTZVXJVWSUVGVOZUVHYDVWGV
        XBSTZVXOVWRSTZVFVWRVCQZVXKVXLYEVWGVXNVXQVXJVWSUVIVOVXPVXGVWGVWRVXFUVJZV
        XBVWTVWRUVKYFYGYHVWJVWGVWMUXQVVKYIZVVKYJRTZVVKUXQIRZVVKPQZVYCVVKYKZVFYK
        ZVYEVXAVWGVWMVWOUXQBSVYFUMZOZVYFVWPVWGUXQVWNVYGVWGVVLVWNVYGXAVWIABCVVKE
        GHIJKLMUVLVOXRVWGUYQVYFVTTVYHVYFXAVWQVYBVYEVFVYDVYCVVKVVKUXQIXGUBUVNYOU
        VMYOBSVYFVTVYGVYGWBUVOUVPYLVWGVYBVYFVYEXAVWGVYBUYQVYAUXQPQZUXQVVKPQZVWQ
        VWGVYIVYJVWGUYSVVKPQVYIVYJUJVWGUYSUYTVVKUYRUYSSTVUQVWFVUFXQZUYRVUCVUQVW
        FVUOXQZVWGVVKVWIYAZVWGVUHUYSUYTPQVWGVUGVUHVWGVUJVUKUYRVUJVUQVWFVULXQVUM
        VKYMVWGUYSUXTVYKVWKUVQYGVWGUYTVUAVVKVYLVWGVUAVURVUPVWFVWHXPYAZVYMVWGUYT
        VUAVYLVYNUYRVUPVUBVWFUVRUVSVWFVUAVVKPQVURVUAVVKUVTXMYNZYNVWGUXQVVKVWQVY
        MUWAYGZVNVWGVYIVYJVYPYMVWGVYASTVVKSTVYBUYQVYIVYJUOYEVWGVVKVYMUWBVYMVYAV
        VKUXQUWCYPUWDVYBVYEVFYQVOVWGVYEVYCVXAVWGVYDVYEVYCXAVWGVYCVXAVVKPVWGVVLU
        YQVYCVXAXAVWIVWQECVVKUXQNSCUFZGOZVPEUFZVRRZXTRZYCOZVYTVQRVXAIEUBXLZCBXL
        ZUJZWUBVWTVYTVWRVQWUEWUAVWSYCWUEVYRUXTVYTVWRXTWUEVYQUXQGWUCWUDUTYRWUEVY
        SVVKVPVRWUCWUDUWEXNZYBYRWUFYBLVWTVWRVQXGUWFYPZVWGVXAUXTVVKVWGVWTVWRVXPV
        XFUWGVWKVYMVWGVXAUXTPQZVWTVWSPQZVWGVXNWUIVXJVWSUWHVOVWGVXOVUGVXRVXSWUHW
        UIYEVXPVWKVXGVXTVWTUXTVWRUWIYFYDZVWGUXTUYTVVKVWKVYLVYMVWGVFUYSPQUXTUYTP
        QVWGUXQUYRUXQWITVUQVWFVUEXQUWJVWGUXTUYSVWKVYKUWMYGVYOYNYNYHVYDVYCVVKYQV
        OWUGUWNYLZUWKVWGVWMVXAUXTPWUKWUJYHUWLUWOURUYOUXGUXPUYBUODHHENBSUXQVYSYI
        VYSYJRTVYSUXQIRZVYSPQWULVYSYKVFYKUMZUMVTMENWUMXCXDUWPUYCHXAZUYDUXGUYJUX
        PUYNUYBNUXFUYCHUXBWUNUYIUXOFNWUNUYFUXKUYHUXNWUNUYEUXIULUXJUXHUYCHYSZUWQ
        WUNUYEUXIUYGUXMUXJWUOUXLUYCHYSUWRUWSYTWUNUYMUYABSWUNUYLUXSUXTUNWUNFNUYK
        UXRWUNUXQUYEUXIWUOXRUWTUXAYTUXCUXDUXE $.
    $}

    $( A characterization of measurability in terms of simple functions (this
       is an if and only if for nonnegative functions, although we don't prove
       it).  Any nonnegative measurable function is the limit of an increasing
       sequence of nonnegative simple functions.  This proof is an example of a
       poor de Bruijn factor - the formalized proof is much longer than an
       average hand proof, which usually just describes the function ` G ` and
       "leaves the details as an exercise to the reader".  (Contributed by
       Mario Carneiro, 16-Aug-2014.)  (Revised by Mario Carneiro,
       23-Aug-2014.) $)
    mbfi1fseq $p |- ( ph -> E. g ( g : NN --> dom S.1 /\ A. n e. NN
      ( 0p oR <_ ( g ` n ) /\ ( g ` n ) oR <_ ( g ` ( n + 1 ) ) ) /\
        A. x e. RR ( n e. NN |-> ( ( g ` n ) ` x ) ) ~~> ( F ` x ) ) ) $=
      ( vy vk vm cr cv co cfv cmul cfl cdiv cle cif cc0 vj vz cn cneg cicc wcel
      cexp cmpt2 wbr cmpt weq oveq2 oveq2d fveq2d oveq12d fveq2 oveq1d cbvmpt2v
      c2 eleq1 breq1d eqidd ifbieq12d cbvmptv negeq eleq2d oveq1 breq12d syl5eq
      id mpteq2dv mbfi1fseqlem6 ) ABHCIDEJUCHKHLZJLZUDZVNUEMZUFZVNVMUAUBUCKUBLZ
      ENZUSUALZUGMZOMZPNZWAQMZUHZMZVNRUIZWFVNSZTSZUJZUJWEFGUAUBIHUCKWDVMENZUSIL
      ZUGMZOMZPNZWMQMVSWMOMZPNZWMQMUAIUKZWCWQWAWMQWRWBWPPWRWAWMVSOVTWLUSUGULZUM
      UNWSUOUBHUKZWQWOWMQWTWPWNPWTVSWKWMOVRVMEUPUQUNUQURJIUCWJBKBLZWLUDZWLUEMZU
      FZWLXAWEMZWLRUIZXEWLSZTSZUJZJIUKZWJBKXAVPUFZVNXAWEMZVNRUIZXLVNSZTSZUJXIHB
      KWIXOHBUKZVQXKWHTXNTVMXAVPUTXPWGXMWFVNXLVNXPWFXLVNRVMXAVNWEULZVAXQXPVNVBV
      CXPTVBVCVDXJBKXOXHXJXKXDXNTXGTXJVPXCXAXJVOXBVNWLUEVNWLVEXJVJZUOVFXJXMXFXL
      VNXEWLXJXLXEVNWLRVNWLXAWEVGZXRVHXSXRVCXJTVBVCVKVIVDVL $.
  $}

  ${
    $d g n x y A $.  $d f g h k n x y F $.  $d f g h k n x y ph $.
    mbfi1flim.1 $e |- ( ph -> F e. MblFn ) $.
    ${
      mbfi1flimlem.2 $e |- ( ph -> F : RR --> RR ) $.
      $( Lemma for ~ mbfi1flim .  (Contributed by Mario Carneiro,
         5-Sep-2014.) $)
      mbfi1flimlem $p |- ( ph -> E. g ( g : NN --> dom S.1 /\
          A. x e. RR ( n e. NN |-> ( ( g ` n ) ` x ) ) ~~> ( F ` x ) ) ) $=
        ( vy cn wf cfv cle wbr wa cr cc0 cli ffvelrnda wcel cvv vf vh citg1 cdm
        vk cv c0p cofr c1 caddc co wral cmpt cif w3a cneg cmbf feqmptd eqeltrrd
        wex cpnf cico 0re ifcl sylancl max1 sylancr elrege0 sylanbrc eqid fmptd
        mbfpos mbfi1fseq renegcld mbfneg eeanv 3simpb anim12i sylib r19.26 cmin
        an4 cof i1fsub adantl simprl simprr nnex a1i inidm off weq fveq2 breq2d
        wb eqidd ifbieq12d fvex c0ex ifex fvmpt negeqd negex anbi12d nnuz cz 1z
        mptex cc i1ff syl an32s recnd adantr wceq wfn ffn ofval 3syl reex eqtrd
        fveq1d oveq12d 3eqtr4d adantlr climsub max0sub breqtrd ex ralimdva ovex
        sylbid feq1 fveq1 mpteq2dv breq1d ralbidv spcev ee12an syl5bir exlimdvv
        expimpd syl5 mp2and ) AIUCUDZUAUFZJZUGDUFZUUFKZLUHZMUUIUUHUIUJUKZUUFKUU
        JMNDIULZDIBUFZUUIKZUMZUUMHOPHUFZEKZLMZUUQPUNZUMZKZQMZBOULZUOZUAUTZIUUEU
        BUFZJZUGUUHUVFKZUUJMUVHUUKUVFKUUJMNDIULZDIUUMUVHKZUMZUUMHOPUUQUPZLMZUVL
        PUNZUMZKZQMZBOULZUOZUBUTZIUUECUFZJZDIUUMUUHUWAKZKZUMZUUMEKZQMZBOULZNZCU
        TZABUADUUTAHOUUQAOOUUPEGRZAEHOUUQUMUQAHOOEGURFUSZVLAHOUUSPVAVBUKZUUTAUU
        POSNZUUSOSZPUUSLMZUUSUWMSUWNUUQOSZPOSZUWOUWKVCUURUUQPOVDVEUWNUWRUWQUWPV
        CUWKPUUQVFVGUUSVHVIUUTVJZVKVMABUBDUVOAHOUVLUWNUUQUWKVNZAHOUUQOUWKUWLVOV
        LAHOUVNUWMUVOUWNUVNOSZPUVNLMZUVNUWMSUWNUVLOSZUWRUXAUWTVCUVMUVLPOVDVEUWN
        UWRUXCUXBVCUWTPUVLVFVGUVNVHVIUVOVJZVKVMUVEUVTNUVDUVSNZUBUTUAUTAUWJUVDUV
        SUAUBVPAUXEUWJUAUBUXEUUGUVGNZUVCUVRNZNZAUWJUXEUUGUVCNZUVGUVRNZNUXHUVDUX
        IUVSUXJUUGUULUVCVQUVGUVIUVRVQVRUUGUVCUVGUVRWBVSAUXFUXGUWJUXGUVBUVQNZBOU
        LZAUXFNZUWJUVBUVQBOVTUXMIUUEUUFUVFWAWCZWCZUKZJZUXLDIUUMUUHUXPKZKZUMZUWF
        QMZBOULZUWJUXMBHIIIUXNUUEUUEUUEUUFUVFTTUUMUUESUUPUUESNUUMUUPUXNUKUUESUX
        MUUMUUPWDWEAUUGUVGWFZAUUGUVGWGZITSUXMWHWIZUYEIWJZWKUXMUXKUYABOUXMUUMOSZ
        NZUXKUUOPUWFLMZUWFPUNZQMZUVKPUWFUPZLMZUYLPUNZQMZNZUYAUYGUXKUYPWOUXMUYGU
        VBUYKUVQUYOUYGUVAUYJUUOQHUUMUUSUYJOUUTHBWLZUURUYIUUQPUWFPUYQUUQUWFPLUUP
        UUMEWMZWNUYRUYQPWPZWQUWSUYIUWFPUUMEWRWSWTXAWNUYGUVPUYNUVKQHUUMUVNUYNOUV
        OUYQUVMUYMUVLPUYLPUYQUVLUYLPLUYQUUQUWFUYRXBZWNUYTUYSWQUXDUYMUYLPUWFXCWS
        WTXAWNXDWEUYHUYPUYAUYHUYPNZUXTUYJUYNWAUKZUWFQVUAUYJUYNUEUUOUVKUXTUITIXE
        UIXFSVUAXGWIUYHUYKUYOWFUXTTSVUADIUXSWHXHWIUYHUYKUYOWGVUAIXIUEUFZUUOUYHI
        XIUUOJUYPUYHDIUUNXIUUOUYHUUHISZNZUUNUXMVUDUYGUUNOSUXMVUDNZOOUUMUUIVUFUU
        IUUESOOUUIJUXMIUUEUUHUUFUYCRUUIXJXKRXLXMUUOVJZVKXNRVUAIXIVUCUVKUYHIXIUV
        KJUYPUYHDIUVJXIUVKVUEUVJUXMVUDUYGUVJOSVUFOOUUMUVHVUFUVHUUESOOUVHJUXMIUU
        EUUHUVFUYDRUVHXJXKRXLXMUVKVJZVKXNRUYHVUCISZVUCUXTKZVUCUUOKZVUCUVKKZWAUK
        ZXOUYPUYHVUINUUMVUCUXPKZKZUUMVUCUUFKZKZUUMVUCUVFKZKZWAUKZVUJVUMUXMVUIUY
        GVUOVUTXOUXMVUINZUYGNZVUOUUMVUPVURUXNUKZKZVUTVVAVUOVVDXOUYGVVAUUMVUNVVC
        UXMIIVUPVURUXNIUUFUVFTTVUCUXMUUGUUFIXPUYCIUUEUUFXQXKUXMUVGUVFIXPUYDIUUE
        UVFXQXKUYEUYEUYFVVAVUPWPVVAVURWPXRYBXNVVAOOVUQVUSWAOVUPVURTTUUMVVAVUPUU
        ESOOVUPJVUPOXPUXMIUUEVUCUUFUYCRVUPXJOOVUPXQXSVVAVURUUESOOVURJVUROXPUXMI
        UUEVUCUVFUYDRVURXJOOVURXQXSOTSVVAXTWIZVVEOWJVVBVUQWPVVBVUSWPXRYAXLVUIVU
        JVUOXOUYHDVUCUXSVUOIUXTDUEWLZUUMUXRVUNUUHVUCUXPWMYBUXTVJUUMVUNWRXAWEVUI
        VUMVUTXOUYHVUIVUKVUQVULVUSWADVUCUUNVUQIUUOVVFUUMUUIVUPUUHVUCUUFWMYBVUGU
        UMVUPWRXADVUCUVJVUSIUVKVVFUUMUVHVURUUHVUCUVFWMYBVUHUUMVURWRXAYCWEYDYEYF
        UYHVUBUWFXOZUYPUYHUWFOSVVGUXMOOUUMEAOOEJUXFGXNRUWFYGXKXNYHYIYLYJUWIUXQU
        YBNCUXPUUFUVFUXOYKUWAUXPXOZUWBUXQUWHUYBIUUEUWAUXPYMVVHUWGUYABOVVHUWEUXT
        UWFQVVHDIUWDUXSVVHUUMUWCUXRUUHUWAUXPYNYBYOYPYQXDYRYSYTUUBUUCUUAYTUUD $.
    $}

    mbfi1flim.2 $e |- ( ph -> F : A --> RR ) $.
    $( Any real measurable function has a sequence of simple functions that
       converges to it.  (Contributed by Mario Carneiro, 5-Sep-2014.) $)
    mbfi1flim $p |- ( ph -> E. g ( g : NN --> dom S.1 /\
        A. x e. A ( n e. NN |-> ( ( g ` n ) ` x ) ) ~~> ( F ` x ) ) ) $=
      ( vy cv cfv cmpt cr wcel cc0 cli wral wa syl wceq cn citg1 cdm wf cif wbr
      wex cvv cvol wss cmbf iftrue mpteq2ia feqmptd eqeltrrd syl5eqel fvex c0ex
      ifex a1i mbfdm2 mblss rembl cdif wn eldifn adantl iffalse mbfss ffvelrnda
      0re ifclda adantr eqid fmptd mbfi1flimlem ssralv sselda eleq1 fveq2 eqidd
      wi ifbieq12d fvmpt eqtrd breq2d ralbidva sylibd anim2d eximdv mpd ) AUAUB
      UCDJZUDZEUABJZEJWLKKLZWNIMIJZCNZWPFKZOUEZLZKZPUFZBMQZRZDUGWMWOWNFKZPUFZBC
      QZRZDUGABDEWTAICMWSUHACUIUCZNCMUJZAICWSUHAICWSLICWRLZUKICWSWRWQWROULUMAFX
      KUKAICMFHUNGUOUPZWSUHNAWQRWQWROWPFUQURUSUTZVACVBSZMXINAVCUTXMAWPMCVDNZRWQ
      VEZWSOTXOXPAWPMCVFVGWQWROVHSXLVIAIMWSMWTAWSMNWPMNAWQWROMACMWPFHVJOMNAXPRV
      KUTVLVMWTVNZVOVPAXDXHDAXCXGWMAXCXBBCQZXGAXJXCXRWBXNXBBCMVQSAXBXFBCAWNCNZR
      ZXAXEWOPXTXAXSXEOUEZXEXTWNMNXAYATACMWNXNVRIWNWSYAMWTWPWNTZWQXSWROXEOWPWNC
      VSWPWNFVTYBOWAWCXQXSXEOWNFUQURUSWDSXSYAXETAXSXEOULVGWEWFWGWHWIWJWK $.
  $}

  ${
    $d f g k m n x y A $.  $d k n x P $.  $d f g k m n x y ph $.  $d k n x Q $.
    $d f g k m n x y F $.  $d f g k m n x y G $.
    mbfmul.1 $e |- ( ph -> F e. MblFn ) $.
    mbfmul.2 $e |- ( ph -> G e. MblFn ) $.
    ${
      mbfmul.3 $e |- ( ph -> F : A --> RR ) $.
      mbfmul.4 $e |- ( ph -> G : A --> RR ) $.
      ${
        mbfmul.5 $e |- ( ph -> P : NN --> dom S.1 ) $.
        mbfmul.6 $e |- ( ( ph /\ x e. A ) ->
          ( n e. NN |-> ( ( P ` n ) ` x ) ) ~~> ( F ` x ) ) $.
        mbfmul.7 $e |- ( ph -> Q : NN --> dom S.1 ) $.
        mbfmul.8 $e |- ( ( ph /\ x e. A ) ->
          ( n e. NN |-> ( ( Q ` n ) ` x ) ) ~~> ( G ` x ) ) $.
        $( Lemma for ~ mbfmul .  (Contributed by Mario Carneiro,
           7-Sep-2014.) $)
        mbfmullem2 $p |- ( ph -> ( F oF x. G ) e. MblFn ) $=
          ( cfv cr wcel cn vk cmul cof co cv cmpt cmbf cvol cdm wf wfn ffn wceq
          syl fdm mbfdm eqeltrrd inidm wa eqidd offval c1 cvv nnuz cz a1i mptex
          1z nnex citg1 ffvelrnda i1ff adantlr wss mblss sselda adantr ffvelrnd
          recnd eqid fmptd fveq2 fveq1d oveq12d ovex adantl fvex eqtr4d climmul
          cc fvmpt cres resmpt reex i1fmul i1fmbf mbfres syl2anc mbflim eqeltrd
          ) AGHUBUCZUDBCBUEZGQZXBHQZUBUDZUFUGABCCXCXDUBCGHUHUIZXFACRGUJZGCUKKCR
          GULUNACRHUJHCUKLCRHULUNAGUIZCXFAXGXHCUMKCRGUOUNAGUGSXHXFSIGUPUNUQZXIC
          URAXBCSZUSZXCUTXKXDUTVAABCXBFUEZDQZQZXBXLEQZQZUBUDZXEFVBVCTVDVBVESZAV
          HVFXKXCXDUAFTXNUFZFTXPUFZFTXQUFZVBVCTVDXRXKVHVFNYAVCSXKFTXQVIVGVFPXKT
          WJUAUEZXSXKFTXNWJXSXKXLTSZUSZXNYDRRXBXMAYCRRXMUJZXJAYCUSZXMVJUIZSYEAT
          YGXLDMVKZXMVLUNZVMXKXBRSZYCACRXBACXFSZCRVNZXICVOUNZVPVQZVRVSXSVTZWAVK
          XKTWJYBXTXKFTXPWJXTYDXPYDRRXBXOAYCRRXOUJZXJYFXOYGSYPATYGXLEOVKZXOVLUN
          ZVMYNVRVSXTVTZWAVKXKYBTSZUSYBYAQZXBYBDQZQZXBYBEQZQZUBUDZYBXSQZYBXTQZU
          BUDZYTUUAUUFUMXKFYBXQUUFTYAXLYBUMZXNUUCXPUUEUBUUJXBXMUUBXLYBDWBWCZUUJ
          XBXOUUDXLYBEWBWCZWDYAVTUUCUUEUBWEWKWFYTUUIUUFUMXKYTUUGUUCUUHUUEUBFYBX
          NUUCTXSUUKYOXBUUBWGWKFYBXPUUETXTUULYSXBUUDWGWKWDWFWHWIYFBRXQUFZCWLZBC
          XQUFZUGYFYLUUNUUOUMAYLYCYMVQBRCXQWMUNYFUUMUGSYKUUNUGSYFXMXOXAUDZUUMUG
          YFBRRXNXPUBRXMXOVCVCYFYEXMRUKYIRRXMULUNYFYPXORUKYRRRXOULUNRVCSYFWNVFZ
          UUQRURYFYJUSZXNUTUURXPUTVAYFUUPYGSUUPUGSYFXMXOYHYQWOUUPWPUNUQAYKYCXIV
          QCUUMWQWRUQXQVCSAYCXJUSUSXNXPUBWEVFWSWT $.
      $}

      $( Lemma for ~ mbfmul .  (Contributed by Mario Carneiro, 7-Sep-2014.) $)
      mbfmullem $p |- ( ph -> ( F oF x. G ) e. MblFn ) $=
        ( vf vn vy vg vm cn cv cfv cmpt cli wa fveq2 vx citg1 cdm wbr wral cmul
        wf wex cof co cmbf wcel mbfi1flim eeanv adantr simprll simprlr mpteq2dv
        cr weq fveq1d cbvmptv syl6eq breq12d rspccva simprrl simprrr mbfmullem2
        sylan ex exlimdvv syl5bir mp2and ) ANUBUCZIOZUGZJNKOZJOZVOPZPZQZVQCPZRU
        DZKBUEZSZIUHZNVNLOZUGZJNVQVRWGPZPZQZVQDPZRUDZKBUEZSZLUHZCDUFUIUJUKULZAK
        BIJCEGUMAKBLJDFHUMWFWPSWEWOSZLUHIUHAWQWEWOILUNAWRWQILAWRWQAWRSZUABVOWGM
        CDACUKULWREUOADUKULWRFUOABUSCUGWRGUOABUSDUGWRHUOAVPWDWOUPWSWDUAOZBULZMN
        WTMOZVOPZPZQZWTCPZRUDZAVPWDWOUQWCXGKWTBKUAUTZWAXEWBXFRXHWAJNWTVSPZQXEXH
        JNVTXIVQWTVSTURJMNXIXDJMUTZWTVSXCVRXBVOTVAVBVCVQWTCTVDVEVIAWEWHWNVFWSWN
        XAMNWTXBWGPZPZQZWTDPZRUDZAWEWHWNVGWMXOKWTBXHWKXMWLXNRXHWKJNWTWIPZQXMXHJ
        NWJXPVQWTWITURJMNXPXLXJWTWIXKVRXBWGTVAVBVCVQWTDTVDVEVIVHVJVKVLVM $.
    $}

    $( The product of two measurable functions is measurable.  (Contributed by
       Mario Carneiro, 7-Sep-2014.) $)
    mbfmul $p |- ( ph -> ( F oF x. G ) e. MblFn ) $=
      ( vx cmul co cfv cmpt cmbf cc wcel syl eqid wa eqidd cvv cr offval2 cv wf
      cof cdm cin cvol wfn mbff ffn mbfdm offval cre cim simplbi ffvelrn syl2an
      cmin elin simprbi remuld mpteq2dva inmbl ovex a1i recld imcld eqtr4d cres
      syl2anc wss inss1 resmpt ax-mp feqmptd eqeltrrd mbfres syl5eqelr ismbfcn2
      wceq mpbid simpld inss2 fmptd mbfmullem simprd mbfsub caddc immuld mbfadd
      eqeltrd mulcld mpbir2and ) ABCGUCZHFBUDZCUDZUEZFUAZBIZWQCIZGHZJZKAFWNWOWR
      WSGWPBCUFUDZXBAWNLBUBZBWNUGABKMZXCDBUHNZWNLBUINAWOLCUBZCWOUGACKMZXFECUHNZ
      WOLCUINAXDWNXBMZDBUJNZAXGWOXBMZECUJNZWPOAWQWNMZPWRQAWQWOMZPWSQUKAXAKMFWPW
      TULIZJZKMFWPWTUMIZJZKMAXPFWPWRULIZJZFWPWSULIZJZWMHZFWPWRUMIZJZFWPWSUMIZJZ
      WMHZUQUCHZKAXPFWPXSYAGHZYDYFGHZUQHZJYIAFWPXOYLAWQWPMZPZWRWSAXCXMWRLMYMXEY
      MXMXNWQWNWOURZUNWNLWQBUOUPZAXFXNWSLMYMXHYMXMXNYOUSWOLWQCUOUPZUTVAAFWPYJYK
      UQYCYHXBRRAXIXKWPXBMZXJXLWNWOVBVIZYJRMYNXSYAGVCVDYKRMYNYDYFGVCVDAFWPXSYAG
      XTYBXBSSYSYNWRYPVEZYNWSYQVEZAXTQZAYBQZTAFWPYDYFGYEYGXBSSYSYNWRYPVFZYNWSYQ
      VFZAYEQZAYGQZTTVGAYCYHAWPXTYBAXTKMZYEKMZAFWPWRJZKMUUHUUIPAUUJFWNWRJZWPVHZ
      KWPWNVJUULUUJVSWNWOVKFWNWPWRVLVMAUUKKMYRUULKMABUUKKAFWNLBXEVNDVOYSWPUUKVP
      VIVQAFWPWRYPVRVTZWAZAYBKMZYGKMZAFWPWSJZKMUUOUUPPAUUQFWOWSJZWPVHZKWPWOVJUU
      SUUQVSWNWOWBFWOWPWSVLVMAUURKMYRUUSKMACUURKAFWOLCXHVNEVOYSWPUURVPVIVQAFWPW
      SYQVRVTZWAZAFWPXSSXTYTXTOWCZAFWPYASYBUUAYBOWCZWDAWPYEYGAUUHUUIUUMWEZAUUOU
      UPUUTWEZAFWPYDSYEUUDYEOWCZAFWPYFSYGUUEYGOWCZWDWFWJAXRXTYGWMHZYEYBWMHZWGUC
      HZKAXRFWPXSYFGHZYDYAGHZWGHZJUVJAFWPXQUVMYNWRWSYPYQWHVAAFWPUVKUVLWGUVHUVIX
      BRRYSUVKRMYNXSYFGVCVDUVLRMYNYDYAGVCVDAFWPXSYFGXTYGXBSSYSYTUUEUUBUUGTAFWPY
      DYAGYEYBXBSSYSUUDUUAUUFUUCTTVGAUVHUVIAWPXTYGUUNUVEUVBUVGWDAWPYEYBUVDUVAUV
      FUVCWDWIWJAFWPWTYNWRWSYPYQWKVRWLWJ $.
  $}

  ${
    $d g x A $.  $d f g x y F $.  $d g x y G $.  $d f L $.
    itg2val.1 $e |- L = { x | E. g e. dom S.1
                          ( g oR <_ F /\ x = ( S.1 ` g ) ) } $.
    $( The set of lower sums is a set of extended reals.  (Contributed by Mario
       Carneiro, 28-Jun-2014.) $)
    itg2lcl $p |- L C_ RR* $=
      ( cv cle cofr wbr citg1 cfv wceq wa cdm wrex cab cxr wcel itg1cl rexrd
      simpr eleq1d syl5ibrcom rexlimiv abssi eqsstri ) DBFZCGHIZAFZUGJKZLZMZBJN
      ZOZAPQEUNAQULUIQRZBUMUGUMRZUOULUJQRUPUJUGSTULUIUJQUHUKUAUBUCUDUEUF $.

    $( Value of the integral on nonnegative real functions.  (Contributed by
       Mario Carneiro, 28-Jun-2014.) $)
    itg2val $p |- ( F : RR --> ( 0 [,] +oo ) ->
                    ( S.2 ` F ) = sup ( L , RR* , < ) ) $=
      ( vf cv cle wbr citg1 wceq wa wrex cab cxr clt csup cc0 cpnf cicc cfv cdm
      cofr cr citg2 xrltso supex reex ovex breq2 anbi1d rexbidv syl6eqr supeq1d
      co abbidv df-itg2 fvmptmap ) FCBGZFGZHUCZIZAGUSJUAKZLZBJUBZMZANZOPQDOPQUD
      RSTUOUEODPUFUGUHRSTUIUTCKZOVGDPVHVGUSCVAIZVCLZBVEMZANDVHVFVKAVHVDVJBVEVHV
      BVIVCUTCUSVAUJUKULUPEUMUNAFBUQUR $.

    $( Elementhood in the set ` L ` of lower sums of the integral.
       (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg2l $p |- ( A e. L <-> E. g e. dom S.1
      ( g oR <_ F /\ A = ( S.1 ` g ) ) ) $=
      ( wcel cv cle cofr wbr citg1 cfv wceq wa cdm wrex cab eleq2i cvv syl6eqel
      simpr fvex rexlimivw eqeq1 anbi2d rexbidv elab3 bitri ) BEGBCHZDIJKZAHZUJ
      LMZNZOZCLPZQZARZGUKBUMNZOZCUPQZEURBFSUQVAABUTBTGCUPUTBUMTUKUSUBUJLUCUAUDU
      LBNZUOUTCUPVBUNUSUKULBUMUEUFUGUHUI $.

    $( Sufficient condition for elementhood in the set ` L ` .  (Contributed by
       Mario Carneiro, 28-Jun-2014.) $)
    itg2lr $p |- ( ( G e. dom S.1 /\ G oR <_ F ) -> ( S.1 ` G ) e. L ) $=
      ( citg1 cdm wcel cle cofr wbr wa cv cfv wceq wrex eqid breq1 fveq2 eqeq2d
      anbi12d rspcev mpanr2 itg2l sylibr ) DGHZIZDCJKZLZMBNZCUILZDGOZUKGOZPZMZB
      UGQZUMEIUHUJUMUMPZUQUMRUPUJURMBDUGUKDPZULUJUOURUKDCUISUSUNUMUMUKDGTUAUBUC
      UDAUMBCEFUEUF $.
  $}

  ${
    $d g x z A $.  $d x z B $.  $d g h x y z F $.  $d g h x y z G $.
    $( A real function is a nonnegative extended real function if all its
       values are greater or equal to zero.  (Contributed by Mario Carneiro,
       28-Jun-2014.)  (Revised by Mario Carneiro, 28-Jul-2014.) $)
    xrge0f $p |- ( ( F : RR --> RR /\ 0p oR <_ F ) ->
                   F : RR --> ( 0 [,] +oo ) ) $=
      ( vx cr wf c0p cle cofr wbr wa wfn cv cfv cc0 cpnf cicc wcel wral a1i cvv
      co ffn adantr csn cxp cc wss ax-resscn 0pledm 0re fnconstg mp1i reex wceq
      inidm fvconst2 adantl eqidd ofrfval cxr ffvelrn biantrurd elxrge0 syl6bbr
      c0ex rexrd ralbidva 3bitrd biimpa ffnfv sylanbrc ) CCADZEAFGZHZIACJZBKZAL
      ZMNOTZPZBCQZCVQADVKVNVMCCAUAZUBVKVMVSVKVMCMUCUDZAVLHMVPFHZBCQVSVKCACUEUFV
      KUGRVTUHVKBCCMVPFCWAASSMCPWACJVKUICMCUJUKVTCSPVKULRZWCCUNVOCPZVOWALMUMVKC
      MVOVDUOUPVKWDIZVPUQURVKWBVRBCWEWBVPUSPZWBIVRWEWFWBWEVPCCVOAUTVEVAVPVBVCVF
      VGVHBCVQAVIVJ $.

    $( The integral of a nonnegative real function is an extended real number.
       (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg2cl $p |- ( F : RR --> ( 0 [,] +oo ) -> ( S.2 ` F ) e. RR* ) $=
      ( vg vx cr cc0 cpnf cicc co wf citg2 cfv cv cle cofr wbr citg1 wa cdm cxr
      wceq wrex cab clt csup eqid itg2val wcel itg2lcl supxrcl ax-mp syl6eqel
      wss ) DEFGHAIAJKBLZAMNOCLUMPKTQBPRUACUBZSUCUDZSCBAUNUNUEZUFUNSULUOSUGCBAU
      NUPUHUNUIUJUK $.

    $( The integral of a nonnegative real function ` F ` is an upper bound on
       the integrals of all simple functions ` G ` dominated by ` F ` .
       (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg2ub $p |- ( ( F : RR --> ( 0 [,] +oo ) /\ G e. dom S.1 /\ G oR <_ F ) ->
                   ( S.1 ` G ) <_ ( S.2 ` F ) ) $=
      ( vg vx cr cc0 cpnf cicc co wf citg1 cdm wcel cle cofr wbr cfv wceq cxr
      cv w3a wa wrex cab clt csup citg2 wss eqid itg2lcl itg2lr 3adant1 supxrub
      sylancr itg2val 3ad2ant1 breqtrrd ) EFGHIAJZBKLZMZBANOZPZUAZBKQZCTZAVAPDT
      VEKQRUBCUSUCDUDZSUEUFZAUGQZNVCVFSUHVDVFMZVDVGNPDCAVFVFUIZUJUTVBVIURDCABVF
      VJUKULVFVDUMUNURUTVHVGRVBDCAVFVJUOUPUQ $.

    $( Any upper bound on the integrals of all simple functions ` G ` dominated
       by ` F ` is greater than ` ( S.2 `` F ) ` , the least upper bound.
       (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg2leub $p |- ( ( F : RR --> ( 0 [,] +oo ) /\ A e. RR* ) ->
      ( ( S.2 ` F ) <_ A <->
        A. g e. dom S.1 ( g oR <_ F -> ( S.1 ` g ) <_ A ) ) ) $=
      ( vx vz cxr wa cfv cle wbr cv citg1 wceq wrex wi wral bitri ralbii bitr3i
      wal cr cc0 cpnf cicc co wf wcel cofr cdm cab clt csup eqid itg2val adantr
      citg2 breq1d wss itg2lcl supxrleub mpan adantl eqeq1 anbi2d rexbidv ralab
      wb r19.23v ancomsimp impexp albii ralcom4 fvex breq1 imbi2d ceqsalv bitrd
      syl6bb ) UAUBUCUDUECUFZAFUGZGZCUPHZAIJBKZCIUHJZDKZWCLHZMZGZBLUIZNZDUJZFUK
      ULZAIJZWDWFAIJZOZBWIPZWAWBWLAIVSWBWLMVTDBCWKWKUMZUNUOUQWAWMEKZAIJZEWKPZWP
      VTWMWTVGZVSWKFURVTXADBCWKWQUSEWKAUTVAVBWTWDWRWFMZGZBWINZWSOZETZWPWJXDWSED
      WEWRMZWHXCBWIXGWGXBWDWEWRWFVCVDVEVFXFXBWDWSOZOZBWIPZETZWPXEXJEXEXCWSOZBWI
      PXJXCWSBWIVHXLXIBWIXLXBWDGWSOXIWDXBWSVIXBWDWSVJQRSVKXKXIETZBWIPWPXIBEWIVL
      XMWOBWIXHWOEWFWCLVMXBWSWNWDWRWFAIVNVOVPRSQQVRVQ $.

    $( The integral of a nonnegative real function is greater or equal to
       zero.  (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg2ge0 $p |- ( F : RR --> ( 0 [,] +oo ) -> 0 <_ ( S.2 ` F ) ) $=
      ( vy cr cc0 cpnf cicc co wf csn cxp citg1 cfv citg2 cle cofr wbr wcel cxr
      itg10 cvv cv wral wa ffvelrn w3a 0xr pnfxr elicc1 mp2an simp2bi ralrimiva
      wb syl wfn 0re fnconstg mp1i ffn reex a1i inidm wceq c0ex fvconst2 adantl
      eqidd ofrfval mpbird cdm i1f0 itg2ub mp3an2 mpdan syl5eqbrr ) CDEFGZAHZDC
      DIJZKLZAMLZNSVPVQANOPZVRVSNPZVPVTDBUAZALZNPZBCUBVPWDBCVPWBCQZUCZWCVOQZWDC
      VOWBAUDWGWCRQZWDWCENPZDRQERQWGWHWDWIUEULUFUGDEWCUHUIUJUMUKVPBCCDWCNCVQATT
      DCQVQCUNVPUOCDCUPUQCVOAURCTQVPUSUTZWJCVAWEWBVQLDVBVPCDWBVCVDVEWFWCVFVGVHV
      PVQKVIQVTWAVJAVQVKVLVMVN $.

    $( The integral of a nonnegative simple function using ` S.2 ` is the same
       as its value under ` S.1 ` .  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    itg2itg1 $p |- ( ( F e. dom S.1 /\ 0p oR <_ F ) ->
                     ( S.2 ` F ) = ( S.1 ` F ) ) $=
      ( vg vx citg1 cdm wcel c0p cle cofr wbr wa cfv cv adantr cr wf wb syl2anc
      cxr cvv citg2 wceq wral itg1le 3expia ancoms ralrimiva cc0 cpnf cicc i1ff
      wi co xrge0f sylan itg1cl rexrd itg2leub mpbird simpl reex adantl caofref
      a1i leid itg2ub syl3anc itg2cl syl xrletri3 mpbir2and ) ADEZFZGAHIZJZKZAU
      ALZADLZUBZVQVRHJZVRVQHJZVPVTBMZAVNJZWBDLVRHJZULZBVLUCZVMWFVOVMWEBVLWBVLFZ
      VMWEWGVMWCWDWBAUDUEUFUGNVPOUHUIUJUMAPZVRSFZVTWFQVMOOAPVOWHAUKZAUNUOZVPVRV
      MVROFVOAUPNUQZVRBAURRUSVPWHVMAAVNJZWAWKVMVOUTVMWMVOVMCOHOATOTFVMVAVDWJCMZ
      OFWNWNHJVMWNVEVBVCNAAVFVGVPVQSFZWIVSVTWAKQVPWHWOWKAVHVIWLVQVRVJRVK $.

    $( The integral of the zero function.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    itg20 $p |- ( S.2 ` ( RR X. { 0 } ) ) = 0 $=
      ( vx cc0 csn cxp citg2 cfv citg1 cdm wcel c0p cle cofr wbr wceq i1f0 wtru
      cr cvv reex a1i wf i1ff ax-mp cv leid adantl caofref cc wss ax-resscn wfn
      ffn syl 0pledm mpbird trud itg2itg1 mp2an itg10 eqtri ) QBCDZEFZVAGFZBVAG
      HIZJVAKLZMZVBVCNOVFPVFVAVAVEMPAQKQVARQRIPSTQQVAUAZPVDVGOVAUBUCTZAUDZQIVIV
      IKMPVIUEUFUGPQVAQUHUIPUJTPVGVAQUKVHQQVAULUMUNUOUPVAUQURUSUT $.

    $( If an ` S.2 ` integral is bounded above, then it is real.  (Contributed
       by Mario Carneiro, 28-Jun-2014.) $)
    itg2lecl $p |- ( ( F : RR --> ( 0 [,] +oo ) /\
                       A e. RR /\ ( S.2 ` F ) <_ A ) -> ( S.2 ` F ) e. RR ) $=
      ( cr cc0 cpnf cicc co wf wcel citg2 cfv cle wbr w3a itg2cl 3ad2ant1 simp2
      cxr itg2ge0 simp3 xrrege0 syl22anc ) CDEFGBHZACIZBJKZALMZNUERIZUDDUELMZUF
      UECIUCUDUGUFBOPUCUDUFQUCUDUHUFBSPUCUDUFTUEAUAUB $.

    $( If one function dominates another, then the integral of the larger is
       also larger.  (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itg2le $p |- ( ( F : RR --> ( 0 [,] +oo ) /\ G : RR --> ( 0 [,] +oo ) /\
                     F oR <_ G ) -> ( S.2 ` F ) <_ ( S.2 ` G ) ) $=
      ( vh vx vy vz cr cc0 cpnf wf cle wbr cfv cv wi wcel wa cxr fss sylancl co
      cicc cofr w3a citg2 citg1 cdm wral cvv reex a1i i1ff adantl ressxr simpll
      wss iccssxr simplr xrletr caoftrn simprl simprr syl3anc expr syld ancomsd
      itg2ub exp4b com23 3impia ralrimiv simp1 itg2cl 3ad2ant2 itg2leub syl2anc
      wb mpbird ) GHIUBUAZAJZGVSBJZABKUCZLZUDZAUEMBUEMZKLZCNZAWBLZWGUFMWEKLZOZC
      UFUGZUHZWDWJCWKVTWAWCWGWKPZWJOVTWAQZWMWCWJWNWMWCWHWIWNWMQZWHWCWIWOWHWCQWG
      BWBLZWIWODEFGKRKKWGABUIGUIPWOUJUKWOGGWGJZGRUPGRWGJWMWQWNWGULUMUNGGRWGSTWO
      VTVSRUPZGRAJVTWAWMUOHIUQZGVSRASTWOWAWRGRBJVTWAWMURWSGVSRBSTDNZRPENZRPFNZR
      PUDWTXAKLXAXBKLQWTXBKLOWOWTXAXBUSUMUTWNWMWPWIWNWMWPQZQWAWMWPWIVTWAXCURWNW
      MWPVAWNWMWPVBBWGVGVCVDVEVFVHVIVJVKWDVTWERPZWFWLVQVTWAWCVLWAVTXDWCBVMVNWEC
      AVOVPVR $.

    $( Integral of a constant function.  (Contributed by Mario Carneiro,
       12-Aug-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itg2const $p |- ( ( A e. dom vol /\ ( vol ` A ) e. RR /\
      B e. ( 0 [,) +oo ) ) -> ( S.2 ` ( x e. RR |-> if ( x e. A , B , 0 ) ) ) =
        ( B x. ( vol ` A ) ) ) $=
      ( cvol wcel cfv cr cc0 co cif cmpt citg1 cmul cle wbr wceq c1 cvv a1i 0re
      cdm cpnf cico w3a cv citg2 c0p cofr csn cxp cof reex simpl3 wa 1re keepel
      eqidd offval2 oveq2 ifsb simp3 elrege0 sylib simpld recnd mulid1d ifeq12d
      fconstmpt mul01d syl5eq mpteq2dv eqtrd eqid i1f1 3adant3 i1fmulc eqeltrrd
      wral simprd 0le0 breq2 ifboth sylancl ralrimivw cc wss ax-resscn wfn ifcl
      adantr ralrimiva fnmpt syl 0pledm ofrfval2 bitrd mpbird itg2itg1 itg1mulc
      syl2anc fveq2d itg11 oveq2d 3eqtr3d ) BDUAEZBDFZGEZCHUBUCIZEZUDZAGAUEZBEZ
      CHJZKZUFFZXNLFZCXFMIZXJXNLUAZEUGXNNUHZOZXOXPPXJGCUIUJZAGXLQHJZKZMUKIZXNXR
      XJYDAGCYBMIZKXNXJAGCYBMYAYCRXHGGREXJULSZXEXGXIXKGEZUMYBGEXJYGUNZXLQHGUOTU
      PSYAAGCKPXJAGCVHSXJYCUQURXJAGYEXMXJYEXLCQMIZCHMIZJXMXLQHYEYIYJYBQCMUSYBHC
      MUSUTXJXLYICYJHXJCXJCXJCGEZHCNOZXJXIYKYLUNXEXGXIVACVBVCZVDZVEZVFXJCYOVIVG
      VJVKVLZXJCYCXEXGYCXREXIABYCYCVMZVNVOZYNVPVQXJXTHXMNOZAGVRZXJYSAGXJYLHHNOZ
      YSXJYKYLYMVSVTXLYLUUAYSCHCXMHNWAHXMHNWAWBWCWDXJXTGHUIUJZXNXSOYTXJGXNGWEWF
      XJWGSXJXMGEZAGVRXNGWHXJUUCAGYHYKHGEZUUCXJYKYGYNWJTXLCHGWIWCZWKAGXMXNGXNVM
      WLWMWNXJAGHXMNUUBXNRGGYFUUDYHTSUUEUUBAGHKPXJAGHVHSXJXNUQWOWPWQXNWRWTXJYDL
      FCYCLFZMIXPXQXJCYCYRYNWSXJYDXNLYPXAXJUUFXFCMXEXGUUFXFPXIABYCYQXBVOXCXDVL
      $.

    $( When the base set of a constant function has infinite volume, the
       integral is also infinite and vice-versa.  (Contributed by Mario
       Carneiro, 30-Aug-2014.) $)
    itg2const2 $p |- ( ( A e. dom vol /\ B e. RR+ ) -> ( ( vol ` A ) e. RR <->
      ( S.2 ` ( x e. RR |-> if ( x e. A , B , 0 ) ) ) e. RR ) ) $=
      ( vz cvol wcel wa cfv cr cc0 cmul co wceq ad2antlr sylanbrc adantl adantr
      cle wbr cxr cdm crp cv cif cmpt citg2 cpnf cico simpll simpr rpre elrege0
      rpge0 itg2const syl3anc remulcld eqeltrd covol mblvol ad2antrr caddc cdiv
      wss mblss ad3antrrr peano2re simplr rerpdivcld ovollecl wrex cicc simplll
      c1 rexrd wf elxrge0 0xr 0le0 mpbir2an ifcl sylancl eqid fmptd itg2ge0 syl
      ge0p1rpd rpdivcld rpge0d breq2d biimpar w3a wb iccssxr volf sseldi elicc1
      ffvelrni sylancr mpbir3and volivth syl2anc ex simprl simprrr oveq2d recnd
      rpne0 divcan2d 3eqtrd cofr simpl wral leidd iftrue sselda 3brtr4d iffalse
      wne wn breq2 ifboth eqbrtrd pm2.61dan ralrimiva cvv reex a1i eqidd syldan
      ofrfval2 syl2an itg2le eqbrtrrd clt ltp1 ltnled mpbid pm2.21dd rexlimdvaa
      syld imp wo eqeltrrd xrletri mpjaodan impbida ) BEUAZFZCUBFZGZBEHZIFZAIAU
      CZBFZCJUDZUEZUFHZIFZUUJUULGZUUQCUUKKLZIUUSUUHUULCJUGUHLFZUUQUUTMUUHUUIUUL
      UIUUJUULUJZUUSCIFZJCRSZUVAUUIUVCUUHUULCUKZNZUUIUVDUUHUULCUMZNCULZOABCUNUO
      UUSCUUKUVFUVBUPUQUUJUURGZUUKBURHZIUUHUUKUVJMUUIUURBUSUTZUVIUVJUUQVMVALZCV
      BLZRSZUVJIFZUVMUVJRSZUVIUVNGBIVCZUVMIFZUVNUVOUUHUVQUUIUURUVNBVDVEUVIUVRUV
      NUVIUVLCUURUVLIFZUUJUUQVFZPZUUHUUIUURVGZVHZQUVIUVNUJBUVMVIUOUVIUVPUVOUVIU
      VPDUCZBVCZUWDEHZUVMMZGZDUUGVJZUVOUVIUVPUWIUVIUVPGZUUHUVMJUUKVKLFZUWIUUHUU
      IUURUVPVLZUWJUWKUVMTFZJUVMRSZUVMUUKRSZUWJUVMUVIUVRUVPUWCQVNUVIUWNUVPUVIUV
      MUVIUVLCUVIUUQUUJUURUJUVIIJUGVKLZUUPVOZJUUQRSUUJUWQUURUUJAIUUOUWPUUPUUJUU
      MIFZGZCUWPFZJUWPFZUUOUWPFUWSCTFZUVDUWTUWSCUUIUVCUUHUWRUVENVNUUIUVDUUHUWRU
      VGNCVPZOUXAJTFZJJRSZVQVRJVPVSZUUNCJUWPVTWAZUUPWBWCQZUUPWDWEWFUWBWGWHQUVIU
      WOUVPUVIUUKUVJUVMRUVKWIWJUWJUXDUUKTFZUWKUWMUWNUWOWKWLVQUWJUUHUXIUWLUUHUWP
      TUUKJUGWMUUGUWPBEWNWQWOZWEJUUKUVMWPWRWSDBUVMWTXAXBUVIUWHUVODUUGUVIUWDUUGF
      ZUWHGZGZUVLUUQRSZUVOUXMAIUUMUWDFZCJUDZUEZUFHZUVLUUQRUXMUXRCUWFKLZCUVMKLZU
      VLUXMUXKUWFIFUVAUXRUXSMUVIUXKUWHXCUXMUWFUVMIUVIUXKUWEUWGXDZUVIUVRUXLUWCQU
      QUXMUVCUVDUVAUVIUVCUXLUUIUVCUUHUURUVENZQUXMCUVIUUIUXLUWBQWHUVHOAUWDCUNUOU
      XMUWFUVMCKUYAXEUVIUXTUVLMUXLUVIUVLCUVIUVLUWAXFUVICUYBXFUUICJXRUUHUURCXGNX
      HQXIUXMIUWPUXQVOZUWQUXQUUPRXJSZUXRUUQRSUUJUYCUURUXLUUJAIUXPUWPUXQUUJUXPUW
      PFZUWRUUJUWTUXAUYEUUJUXBUVDUWTUUJCUUIUVCUUHUVEPZVNUUIUVDUUHUVGPZUXCOUXFUX
      OCJUWPVTWAQZUXQWBWCUTUVIUWQUXLUXHQUVIUUJUWEUYDUXLUUJUURXKUXKUWEUWGXCUUJUW
      EUXPUUORSZAIXLZUYDUUJUWEGZUYIAIUYKUWRGZUXOUYIUYLUXOGZCCUXPUUORUYMCUUJUVCU
      WEUWRUXOUYFVEXMUXOUXPCMUYLUXOCJXNPUYMUUNUUOCMUYLUWDBUUMUUJUWEUWRVGXOUUNCJ
      XNWEXPUYLUXOXSZGUXPJUUORUYNUXPJMUYLUXOCJXQPUUJJUUORSZUWEUWRUYNUUJUVDUXEUY
      OUYGVRUUNUVDUXEUYOCJCUUOJRXTJUUOJRXTYAWAVEYBYCYDUUJUYDUYJUUJAIUXPUUORUXQU
      UPYEUWPUWPIYEFUUJYFYGUYHUXGUUJUXQYHUUJUUPYHYJWJYIYKUXQUUPYLUOYMUXMUUQUVLY
      NSZUXNXSUURUYPUUJUXLUUQYONUXMUUQUVLUUJUURUXLVGUURUVSUUJUXLUVTNYPYQYRYSYTU
      UAUVIUVJTFUWMUVNUVPUUBUVIUUKUVJTUVKUUHUXIUUIUURUXJUTUUCUVIUVMUWCVNUVJUVMU
      UDXAUUEUQUUF $.
  $}

  ${
    $d f g m n x z F $.
    $( Definitional property of the ` S.2 ` integral: for any function ` F `
       there is a countable sequence ` g ` of simple functions less than ` F `
       whose integrals converge to the integral of ` F ` .  (This theorem is
       for the most part unnecessary in lieu of ~ itg2i1fseq , but unlike that
       theorem this one doesn't require ` F ` to be measurable.)  (Contributed
       by Mario Carneiro, 14-Aug-2014.) $)
    itg2seq $p |- ( F : RR --> ( 0 [,] +oo ) -> E. g ( g : NN --> dom S.1 /\
        A. n e. NN ( g ` n ) oR <_ F /\ ( S.2 ` F ) =
        sup ( ran ( n e. NN |-> ( S.1 ` ( g ` n ) ) ) , RR* , < ) ) ) $=
      ( vf vm cr cc0 cn citg1 cle wbr clt wa wral cxr wcel wn syl cmnf wb vx vz
      cpnf cicc co wf cdm cv cfv cofr citg2 wceq c1 cdiv cmin cif wex cmpt csup
      crn w3a wrex wi ad2antlr ltpnf iftrue adantl simpr 3brtr4d iffalse itg2cl
      nnre xrrebnd itg2ge0 0re mnflt ax-mp mnfxr 0xr xrltletr mp3an12 mpani mpd
      biantrurd nltpnft con2bid 3bitr2rd adantlr nnrp rpreccld ltsubrpd eqbrtrd
      biimpa crp pm2.61dan nnrecre resubcld ifclda rexrd adantr xrltnle syl2anc
      mpbid itg2leub syldan mtbid rexanali sylibr itg1cl syl2an anbi2d rexbidva
      ltnle mpbird ralrimiva cmap ovex i1ff reex breq1 fveq2 breq2d fveq2d eqid
      weq ressxr syl6ss syl5eqelr simplrl syl3anc rexr mpan fvex fvmpt ralimdva
      wss wfn impr breq2 breq1d elmap ssriv ssexi nnenom anbi12d axcc4 ad2antll
      simprl simpl cbvmptv rneqi supeq1i ffvelrn fmptd ad2antrl frn supxrcl w3o
      ralimi elxr arch rexbidv simplrr posdifd nnrecl bitr4d expr rexnal syl6bb
      ltsub13 syl2anr 3imtr3d con4d breqtrrd a1d c0 wne 1nn ne0i r19.2z sylancr
      pnfge simplr mtbird nrexdv pm2.21d syl5 3jaodan sylan2b adantll syl5eqssr
      xrltle fnmpti fnfvelrn supxrub xrletr mpan2d syld adantld ralbidv imbi12d
      eqeltrrd rspcv syl3c itg2ub 3expia sylan2 anassrs adantrd ralbiia cbvralv
      syl6breqr bitr4i ffn ralrn 3syl supxrleub xrletri3 adantrr mpbir2and 3jca
      ex eximdv ) FGUCUDUECUFZHIUGZAUHZUFZBUHZUYFUIZCJUJZKZCUKUIZUCULZUYHUYLUMU
      YHUNUEZUOUEZUPZUYIIUIZLKZMZBHNZMZAUQZUYGUYKBHNZUYLBHUYQURZUTZOLUSZULZVAZA
      UQUYDDUHZCUYJKZUYPVUIIUIZLKZMZDUYEVBZBHNVUBUYDVUNBHUYDUYHHPZMZVUNVUJVUKUY
      PJKZQZMZDUYEVBZVUPVUJVUQVCDUYENZQVUTVUPUYLUYPJKZVVAVUPUYPUYLLKZVVBQZVUPUY
      MVVCVUPUYMMZUYHUCUYPUYLLVVEUYHFPZUYHUCLKVUOVVFUYDUYMUYHVLVDZUYHVERUYMUYPU
      YHULZVUPUYMUYHUYOVFZVGVUPUYMVHVIVUPUYMQZMZUYPUYOUYLLVVJUYPUYOULZVUPUYMUYH
      UYOVJZVGVVKUYLUYNUYDVVJUYLFPZVUOUYDVVJVVNUYDVVNSUYLLKZUYLUCLKZMZVVPVVJUYD
      UYLOPZVVNVVQTCVKZUYLVMRUYDVVOVVPUYDGUYLJKZVVOCVNUYDSGLKZVVTVVOGFPVWAVOGVP
      VQUYDVVRVWAVVTMVVOVCZVVSSOPZGOPVVRVWBVRVSSGUYLVTWARWBWCWDUYDUYMVVPUYDVVRU
      YMVVPQTVVSUYLWERWFWGWMZWHZVUOUYNWNPUYDVVJVUOUYHUYHWIWJVDWKWLWOVUPUYPOPZVV
      RVVCVVDTVUPUYPVUPUYMUYHUYOFVVGVVKUYLUYNVWEVUOUYNFPZUYDVVJUYHWPZVDWQWRZWSZ
      UYDVVRVUOVVSWTUYPUYLXAXBXCUYDVUOVWFVVBVVATVWJUYPDCXDXEXFVUJVUQDUYEXGXHVUP
      VUMVUSDUYEVUPVUIUYEPZMVULVURVUJVUPUYPFPZVUKFPVULVURTVWKVWIVUIXIUYPVUKXMXJ
      XKXLXNXOVUMUYSDUYEABHUYEFFXPUEZFFXPXQUAUYEVWMUAUHZUYEPFFVWNUFVWNVWMPVWNXR
      FFVWNXSXSUUAXHUUBUUCUUDVUIUYIULZVUJUYKVULUYRVUIUYICUYJXTVWOVUKUYQUYPLVUIU
      YIIYAYBUUEUUFRUYDVUAVUHAUYDVUAVUHUYDVUAMZUYGVUCVUGUYDUYGUYTUUHUYTVUCUYDUY
      GUYSUYKBHUYKUYRUUIUUSUUGVWPVUGUYLVUFJKZVUFUYLJKZVWPUYLEHEUHZUYFUIZIUIZURZ
      UTZOLUSZVUFJVWPVXDOPZUYPVWNJKZBHNZUYLVWNJKZVCZUAONZUYPVXDJKZBHNZUYLVXDJKZ
      VWPVXDVUFOOVUEVXCLVUDVXBBEHUYQVXABEYEZUYIVWTIUYHVWSUYFYAYCZUUJUUKZUULZVWP
      VUEOYPZVUFOPZVWPVUEFOVWPHFVUDUFZVUEFYPZUYGVXTUYDUYTUYGBHUYQFVUDUYGVUOMZUY
      IUYEPZUYQFPZHUYEUYHUYFUUMZUYIXIRZVUDYDZUUNZUUOZHFVUDUUPZRYFYGZVUEUUQZRYHU
      YDVXJVUAUYDVXIUAOVWNOPZUYDVWNFPZVWNUCULZVWNSULZUURVXIVWNUUTUYDVYNVXIVYOVY
      PUYDVYNMZVXHVXGVYQVWNUYLLKZVWNUYPLKZBHVBZVXHQZVXGQZUYDVYNVYRVYTUYDVYNVYRM
      ZMZUYMVYTWUDUYMMZVYTVWNUYHLKZBHVBZWUEVYNWUGUYDVYNVYRUYMYIVWNBUVARWUEVYSWU
      FBHWUEUYPUYHVWNLUYMVVHWUDVVIVGYBUVBXNWUDVVJMZUYNUYLVWNUOUEZLKZBHVBZVYTWUH
      WUIFPGWUILKZWUKWUHUYLVWNUYDVVJVVNWUCVWDWHZUYDVYNVYRVVJYIZWQWUHVYRWULUYDVY
      NVYRVVJUVCWUHVWNUYLWUNWUMUVDXCWUIBUVEXBWUHWUJVYSBHWUHVUOMZWUJVWNUYOLKZVYS
      WUOVWGVVNVYNWUJWUPTVUOVWGWUHVWHVGWUHVVNVUOWUMWTWUHVYNVUOWUNWTUYNUYLVWNUVJ
      YJWUOUYPUYOVWNLVVJVVLWUDVUOVVMVDYBUVFXLXCWOUVGVYNVYMVVRVYRWUATUYDVWNYKZVV
      SVWNUYLXAUVKVYQVYTVXFQZBHVBWUBVYQVYSWURBHVYQVUOMVYMVWFVYSWURTVYNVYMUYDVUO
      WUQVDUYDVUOVWFVYNVWJWHVWNUYPXAXBXLVXFBHUVHUVIUVLUVMUYDVYOMZVXHVXGWUSUYLUC
      VWNJWUSVVRUYLUCJKUYDVVRVYOVVSWTUYLUWBRUYDVYOVHUVNUVOVXGVXFBHVBZUYDVYPMZVX
      HHUVPUVQZVXGWUTUMHPWVBUVRHUMUVSVQVXFBHUVTYLWVAWUTVXHWVAVXFBHWVAVUOMZVXFUY
      PSJKZWVCVWLWVDQZUYDVUOVWLVYPVWIWHVWLSUYPLKZWVEUYPVPVWLVWCVWFWVFWVETVRUYPY
      KSUYPXAUWAXCRWVCVWNSUYPJUYDVYPVUOUWCYBUWDUWEUWFUWGUWHUWIXOWTUYDUYGUYTVXLU
      YDUYGMZUYSVXKBHWVGVUOMZUYRVXKUYKWVHUYRUYPUYQJKZVXKWVHVWFUYQOPZUYRWVIVCUYD
      VUOVWFUYGVWJWHZWVHUYQUYGVUOVYDUYDVYFUWJWSZUYPUYQUWLXBWVHWVIUYQVXDJKZVXKWV
      HVXCOYPUYQVXCPZWVMWVHVXCVUEOVXPWVGVXRVUOWVGVUEFOWVGVXTVYAUYGVXTUYDVYHVGVY
      JRYFYGZWTZUWKVUOWVNWVGVUOUYHVXBUIZUYQVXCEUYHVXAUYQHVXBEBYEVWTUYIIVWSUYHUY
      FYAYCVXBYDZUYIIYMYNVXBHYQVUOWVQVXCPEHVXAVXBVWTIYMZWVRUWMHUYHVXBUWNYLUXBVG
      VXCUYQUWOXBWVHVWFWVJVXEWVIWVMMVXKVCWVKWVLWVHVXDVUFOVXQWVHVXRVXSWVPVYLRYHU
      YPUYQVXDUWPYJUWQUWRUWSYOYRVXIVXLVXMVCUAVXDOVWNVXDULZVXGVXLVXHVXMWVTVXFVXK
      BHVWNVXDUYPJYSUWTVWNVXDUYLJYSUXAUXCUXDVXQUXLVWPVWRUBUHZUYLJKZUBVUENZVWPWW
      CVWSVUDUIZUYLJKZEHNZVWPUYQUYLJKZBHNZWWFUYDUYGUYTWWHWVGUYSWWGBHWVHUYKWWGUY
      RUYDUYGVUOUYKWWGVCZVYBUYDVYCWWIVYEUYDVYCUYKWWGCUYIUXEUXFUXGUXHUXIYOYRWWFV
      XAUYLJKZEHNWWHWWEWWJEHVWSHPWWDVXAUYLJBVWSUYQVXAHVUDVXOVYGWVSYNYTUXJWWGWWJ
      BEHVXNUYQVXAUYLJVXOYTUXKUXMXHVWPVXTVUDHYQWWCWWFTVYIHFVUDUXNWWBWWEUBEHVUDW
      WAWWDUYLJXTUXOUXPXNVWPVXRVVRVWRWWCTVYKUYDVVRVUAVVSWTUBVUEUYLUXQXBXNUYDUYG
      VUGVWQVWRMTZUYTWVGVVRVXSWWKUYDVVRUYGVVSWTWVGVXRVXSWVOVYLRUYLVUFUXRXBUXSUX
      TUYAUYBUYCWC $.

    $(
    @( Refinement of ~ itg2seq : the sequence of functions in ~ itg2seq can be
       chosen to be weakly increasing. @)
    itg2seq2 @p |- ( F : RR --> ( 0 [,] +oo ) -> E. g ( g : NN --> dom S.1 /\
        A. n e. NN ( ( g ` ( n + 1 ) ) oR <_ ( g ` n ) /\
        ( g ` n ) oR <_ F ) /\ ( S.2 ` F ) =
        sup ( ran ( n e. NN |-> ( S.1 ` ( g ` n ) ) ) , RR* , < ) ) ) @=
      ? @.
    $)
  $}

  ${
    $d x y A $.  $d x F $.  $d x y G $.  $d x y ph $.
    itg2uba.1 $e |- ( ph -> F : RR --> ( 0 [,] +oo ) ) $.
    itg2uba.2 $e |- ( ph -> G e. dom S.1 ) $.
    itg2uba.3 $e |- ( ph -> A C_ RR ) $.
    itg2uba.4 $e |- ( ph -> ( vol* ` A ) = 0 ) $.
    itg2uba.5 $e |- ( ( ph /\ x e. ( RR \ A ) ) -> ( G ` x ) <_ ( F ` x ) ) $.
    $( Approximate version of ~ itg2ub .  If ` F ` approximately dominates
       ` G ` , then ` S.1 G <_ S.2 F ` .  (Contributed by Mario Carneiro,
       11-Aug-2014.) $)
    itg2uba $p |- ( ph -> ( S.1 ` G ) <_ ( S.2 ` F ) ) $=
      ( cfv cr wcel cc0 syl wceq wa cle wbr cvv vy citg1 cv cif cmpt cdm itg1cl
      citg2 rexrd cdif cvol wss covol nulmbl syl2anc cmmbl wn ifnot eldif baibr
      ifbid syl5eqr mpteq2ia i1fres cpnf cicc co cxr itg2cl i1ff eldifi ffvelrn
      wf syl2an leidd eleq1 fveq2 ifbieq2d eqid c0ex fvex ifex iffalse sylan9eq
      fvmpt sylbi adantl breqtrrd itg1lea cofr wral iftrue elxrge0 sylib simprd
      ffvelrnda adantr eqbrtrd sylan2br anassrs pm2.61dan ralrimiva a1i feqmptd
      reex eqidd ofrfval2 mpbird itg2ub syl3anc xrletrd ) AEUBKZBLBUCZCMZNXMEKZ
      UDZUEZUBKZDUHKZAXLAEUBUFZMZXLLMGEUGOUIAXRAXQXTMZXRLMAYALCUJZUKUFZMZYBGACY
      DMZYEACLULCUMKNPYFHICUNUOCUPOBYCEXQBLXPXMYCMZXONUDZXMLMZXPXNUQZXONUDYHXNX
      ONURYIYJYGXONYGYIYJXMLCUSZUTVAVBVCVDUOZXQUGOUIALNVEVFVGZDVMZXSVHMFDVIOAUA
      CEXQGHIYLAUAUCZYCMZQZYOEKZYRYOXQKZRYQYRALLEVMZYOLMZYRLMYPAYAYTGEVJOYOLCVK
      LLYOEVLVNVOYPYSYRPZAYPUUAYOCMZUQZQUUBYOLCUSUUAUUDYSUUCNYRUDZYRBYOXPUUELXQ
      XMYOPXNUUCXOYRNXMYOCVPXMYOEVQVRXQVSUUCNYRVTYOEWAWBWEUUCNYRWCWDWFWGWHWIAYN
      YBXQDRWJSZXRXSRSFYLAUUFXPXMDKZRSZBLWKAUUHBLAYIQZXNUUHUUIXNQXPNUUGRXNXPNPU
      UIXNNXOWLWGUUINUUGRSZXNUUIUUGVHMZUUJUUIUUGYMMUUKUUJQALYMXMDFWPUUGWMWNWOWQ
      WRUUIYJQXPXOUUGRYJXPXOPUUIXNNXOWCWGAYIYJXOUUGRSZYIYJQAYGUULYKJWSWTWRXAXBA
      BLXPUUGRXQDTTTLTMAXEXCXPTMUUIXNNXOVTXMEWAWBXCUUGTMUUIXMDWAXCAXQXFABLYMDFX
      DXGXHDXQXIXJXK $.
  $}

  ${
    $d x A $.  $d f x F $.  $d f x G $.  $d f x ph $.
    itg2lea.1 $e |- ( ph -> F : RR --> ( 0 [,] +oo ) ) $.
    itg2lea.2 $e |- ( ph -> G : RR --> ( 0 [,] +oo ) ) $.
    itg2lea.3 $e |- ( ph -> A C_ RR ) $.
    itg2lea.4 $e |- ( ph -> ( vol* ` A ) = 0 ) $.
    ${
      itg2lea.5 $e |- ( ( ph /\ x e. ( RR \ A ) ) -> ( F ` x ) <_ ( G ` x ) )
          $.
      $( Approximate version of ~ itg2le .  If ` F <_ G ` for almost all
         ` x ` , then ` S.2 F <_ S.2 G ` .  (Contributed by Mario Carneiro,
         11-Aug-2014.) $)
      itg2lea $p |- ( ph -> ( S.2 ` F ) <_ ( S.2 ` G ) ) $=
        ( vf cfv cle wbr wcel wa cr cc0 wf adantr citg2 cv cofr citg1 wral cpnf
        wi cdm cicc co simprl wss wceq cdif i1ff ad2antrl eldifi ffvelrn syl2an
        covol rexrd cxr iccssxr sseldi simprr cvv wfn ffn syl a1i inidm ofrfval
        reex eqidd mpbid r19.21bi sylan2 adantlr xrletrd itg2uba expr ralrimiva
        wb itg2cl itg2leub syl2anc mpbird ) ADUALEUALZMNZKUBZDMUCNZWJUDLWHMNZUG
        ZKUDUHZUEZAWMKWNAWJWNOZWKWLAWPWKPZPZBCEWJAQRUFUIUJZESZWQGTZAWPWKUKACQUL
        WQHTACUTLRUMWQITWRBUBZQCUNOZPZXBWJLZXBDLZXBELZXDXEWRQQWJSZXBQOZXEQOXCWP
        XHAWKWJUOUPZXBQCUQZQQXBWJURUSVAXDWSVBXFRUFVCZWRQWSDSZXIXFWSOXCAXMWQFTZX
        KQWSXBDURUSVDXDWSVBXGXLWRWTXIXGWSOXCXAXKQWSXBEURUSVDXCWRXIXEXFMNZXKWRXO
        BQWRWKXOBQUEAWPWKVEWRBQQXEXFMQWJDVFVFWRXHWJQVGXJQQWJVHVIWRXMDQVGXNQWSDV
        HVIQVFOWRVMVJZXPQVKWRXIPZXEVNXQXFVNVLVOVPVQAXCXFXGMNWQJVRVSVTWAWBAXMWHV
        BOZWIWOWCFAWTXRGEWDVIWHKDWEWFWG $.
    $}

    itg2eqa.5 $e |- ( ( ph /\ x e. ( RR \ A ) ) -> ( F ` x ) = ( G ` x ) ) $.
    $( Approximate equality of integrals.  If ` F = G ` for almost all ` x ` ,
       then ` S.2 F = S.2 G ` .  (Contributed by Mario Carneiro,
       12-Aug-2014.) $)
    itg2eqa $p |- ( ph -> ( S.2 ` F ) = ( S.2 ` G ) ) $=
      ( citg2 cfv cle wbr cr wcel wa cxr cc0 syl wceq cv cdif cpnf cicc iccssxr
      co wf eldifi ffvelrn syl2an sseldi xrleid breqtrd itg2lea eqbrtrrd itg2cl
      wb xrletri3 syl2anc mpbir2and ) ADKLZEKLZUAZVBVCMNZVCVBMNZABCDEFGHIABUBZO
      CUCPZQZVGDLZVJVGELZMVIVJRPVJVJMNVISUDUEUGZRVJSUDUFAOVLDUHZVGOPVJVLPVHFVGO
      CUIOVLVGDUJUKULVJUMTZJUNUOABCEDGFHIVIVJVKVJMJVNUPUOAVBRPZVCRPZVDVEVFQURAV
      MVOFDUQTAOVLEUHVPGEUQTVBVCUSUTVA $.
  $}

  ${
    $d f t u v w x y z A $.  $d f x y z F $.  $d f x y z ph $.
    itg2mulc.2 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    itg2mulc.3 $e |- ( ph -> ( S.2 ` F ) e. RR ) $.
    ${
      itg2mulclem.4 $e |- ( ph -> A e. RR+ ) $.
      $( Lemma for ~ itg2mulc .  (Contributed by Mario Carneiro,
         8-Jul-2014.) $)
      itg2mulclem $p |- ( ph ->
        ( S.2 ` ( ( RR X. { A } ) oF x. F ) ) <_ ( A x. ( S.2 ` F ) ) ) $=
        ( vy cr cmul co cfv cle wbr wcel cc0 cpnf wf adantr cvv a1i vf vz vw vv
        vu vx csn cxp cof citg2 cv cofr citg1 wi cdm wral wa cdiv cicc cico wss
        c1 clt df-ico df-icc cxr idd xrltle ixxssixx fss sylancl simpr rpreccld
        crp rpred i1fmulc itg2ub 3expia syl2anc i1ff adantl ffvelrnda 0re pnfxr
        wb icossre mp2an ad2antrr rpgt0d ledivmul syl112anc wne rpne0d divrec2d
        recnd breq1d ralbidva reex ovex feqmptd cmpt fconstmpt offval2 ofrfval2
        bitr3d 3bitr4d itg1mulc itg1cl eqtr4d bitr2d 3imtr4d ralrimiva ge0mulcl
        wceq fconstg syl rpre rpge0 elrege0 sylanbrc snssd inidm remulcld rexrd
        off itg2leub mpbird ) AHBUGZUHZCIUIZJZUJKBCUJKZIJZLMZUAUKZYKLULZMZYOUMK
        ZYMLMZUNZUAUMUOZUPZAYTUAUUAAYOUUANZUQZHVBBURJZUGUHZYOYJJZCYPMZUUGUMKZYL
        LMZYQYSUUDHOPUSJZCQZUUGUUANZUUHUUJUNAUULUUCAHOPUTJZCQZUUNUUKVAZUULDUBUC
        UDUEOPUSLVCLLUTUBUCUDVDUBUCUDVEOVFNUEUKZVFNUQOUUQLMVGUUQPVHVIZHUUNUUKCV
        JVKRUUDUUEYOAUUCVLZUUDUUEAUUEVNNZUUCABFVMZRVOZVPUULUUMUUHUUJCUUGVQVRVSU
        UDGUKZYOKZBUVCCKZIJZLMZGHUPUUEUVDIJZUVELMZGHUPYQUUHUUDUVGUVIGHUUDUVCHNZ
        UQZUVDBURJZUVELMZUVGUVIUVKUVDHNUVEHNBHNZOBVCMZUVMUVGWEUUDHHUVCYOUUCHHYO
        QAYOVTWAZWBZUUDHHUVCCAHHCQZUUCAUUOUUNHVAZUVRDOHNPVFNUVSWCWDOPWFWGHUUNHC
        VJVKRWBZAUVNUUCUVJABFVOZWHZAUVOUUCUVJABFWIZWHUVDUVEBWJWKUVKUVLUVHUVELUV
        KUVDBUVKUVDUVQWOUVKBUWBWOUUDBOWLUVJUUDBABVNNZUUCFRWMZRWNWPXEWQUUDGHUVDU
        VFLYOYKSHSHSNZUUDWRTZUVQUVFSNUVKBUVEIWSTUUDGHHYOUVPWTZUUDGHBUVEIYICSVNH
        UWGAUWDUUCUVJFWHUVTYIGHBXAXNUUDGHBXBTACGHUVEXAXNUUCAGHUUNCDWTRZXCXDUUDG
        HUVHUVELUUGCSSHUWGUVHSNUVKUUEUVDIWSTUVTUUDGHUUEUVDIUUFYOSVNHUWGAUUTUUCU
        VJUVAWHUVQUUFGHUUEXAXNUUDGHUUEXBTUWHXCUWIXDXFUUDUUJYRBURJZYLLMZYSUUDUUI
        UWJYLLUUDUUIUUEYRIJUWJUUDUUEYOUUSUVBXGUUDYRBUUDYRUUCYRHNZAYOXHWAZWOUUDB
        AUVNUUCUWARZWOUWEWNXIWPUUDUWLYLHNZUVNUVOUWKYSWEUWMAUWOUUCERUWNAUVOUUCUW
        CRYRYLBWJWKXJXKXLAHUUKYKQZYMVFNYNUUBWEAHUUNYKQUUPUWPAUFGHHHIUUNUUNUUNYI
        CSSUFUKZUUNNUVCUUNNUQUWQUVCIJUUNNAUWQUVCXMWAAHYHYIQZYHUUNVAHUUNYIQAUWDU
        WRFHBVNXOXPABUUNAUWDBUUNNZFUWDUVNOBLMUWSBXQBXRBXSXTXPYAHYHUUNYIVJVSDUWF
        AWRTZUWTHYBYEUURHUUNUUKYKVJVKAYMABYLUWAEYCYDYMUAYKYFVSYG $.
    $}

    itg2mulc.4 $e |- ( ph -> A e. ( 0 [,) +oo ) ) $.
    $( The integral of a nonnegative constant times a function is the constant
       times the integral of the original function.  (Contributed by Mario
       Carneiro, 28-Jun-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itg2mulc $p |- ( ph ->
      ( S.2 ` ( ( RR X. { A } ) oF x. F ) ) = ( A x. ( S.2 ` F ) ) ) $=
      ( vy cc0 wbr cr cmul co citg2 wa cle wf adantr wcel cvv cc vx vz vw vv vu
      clt csn cxp cof cfv wceq cpnf cico crp elrege0 sylib simpld anim1i sylibr
      elrp itg2mulclem cdiv c1 ge0mulcl adantl fconst6g syl reex a1i inidm cicc
      cv off wss df-ico df-icc cxr idd xrltle ixxssixx sylancl remulcld syl3anc
      fss itg2lecl rpreccld feqmptd 0re pnfxr icossre mp2an ax-resscn ffvelrnda
      cmpt sstri mulid2d mpteq2dva eqtr4d ofc12 fconstmpt syl6eq rpne0d recid2d
      1re recnd mpteq2dv eqtrd offval2 rpcnd w3a mulass caofass fveq2d divrec2d
      3eqtr2d 3brtr4d lemuldiv2d mpbird itg2cl rexrd xrletri3 syl2anc mpbir2and
      wb simplr oveq1d mul02 eqtr3d caofid2 itg20 mul02d simpr wo leloe sylancr
      simprd mpbid mpjaodan ) AHBUFIZJBUGUHZCKUIZLZMUJZBCMUJZKLZUKZHBUKZAYSNZUU
      FUUCUUEOIZUUEUUCOIZUUHBCAJHULUMLZCPZYSDQZAUUDJRZYSEQZUUHBJRZYSNBUNRAUUPYS
      AUUPHBOIZABUUKRZUUPUUQNFBUOUPZUQZURBUTUSZVAZUUHUUJUUDUUCBVBLZOIUUHJVCBVBL
      ZUGUHZUUBUUALZMUJUVDUUCKLUUDUVCOUUHUVDUUBAJUUKUUBPZYSAUAGJJJKUUKUUKUUKYTC
      SSUAVLZUUKRGVLZUUKRNUVHUVIKLZUUKRAUVHUVIVDVEAUURJUUKYTPFJBUUKVFVGDJSRZAVH
      VIZUVLJVJVMZQUUHJHULVKLZUUBPZUUEJRZUUIUUCJRAUVOYSAUVGUUKUVNVNUVOUVMUBUCUD
      UEHULVKOUFOOUMUBUCUDVOUBUCUDVPHVQRUEVLZVQRNHUVQOIVRUVQULVSVTJUUKUVNUUBWDW
      AZQAUVPYSABUUDUUTEWBZQUVBUUEUUBWEWCZUUHBUVAWFZVAUUHCUVFMUUHCGJVCUVICUJZKL
      ZWNZUVEYTUUALZCUUALUVFUUHCGJUWBWNUWDUUHGJUUKCUUMWGZUUHGJUWCUWBUUHUVIJRNZU
      WBUUHJTUVICAJTCPZYSAUULUUKTVNUWHDUUKJTHJRZULVQRUUKJVNWHWIHULWJWKWLWOJUUKT
      CWDWAZQZWMZWPWQWRUUHGJVCUWBKUWECSJTUVKUUHVHVIZVCJRUWGXDVIUWLUUHUWEGJUVDBK
      LZWNZGJVCWNUUHUWEJUWNUGUHUWOUUHJUVDBKSUNUNUWMUWAUVAWSGJUWNWTXAUUHGJUWNVCU
      UHBABTRZYSABUUTXEQZUUHBUVAXBZXCXFXGUWFXHUUHUAGUBJKKTKUVEYTCKSUWMUUHUVDTRJ
      TUVEPUUHUVDUWAXIJUVDTVFVGUUHUWPJTYTPUWQJBTVFVGUWKUVHTRZUVITRUBVLZTRXJUVJU
      WTKLUVHUVIUWTKLKLUKUUHUVHUVIUWTXKVEXLXOXMUUHUUCBUUHUUCUVTXEUWQUWRXNXPUUHU
      UDUUCBUUOUVTUVAXQXRAUUFUUIUUJNYDZYSAUUCVQRZUUEVQRUXAAUVOUXBUVRUUBXSVGAUUE
      UVSXTUUCUUEYAYBQYCAUUGNZUUCHHUUDKLUUEUXCUUCJHUGUHZMUJHUXCUUBUXDMUXCUAJBHK
      TCSJJUVKUXCVHVIAUWHUUGUWJQAUUPUUGUUTQUWIUXCWHVIUXCUWSNZHUVHKLZBUVHKLHUXEH
      BUVHKAUUGUWSYEYFUWSUXFHUKUXCUVHYGVEYHYIXMYJXAUXCUUDUXCUUDAUUNUUGEQXEYKUXC
      HBUUDKAUUGYLYFXOAUUQYSUUGYMZAUUPUUQUUSYPAUWIUUPUUQUXGYDWHUUTHBYNYOYQYR $.
  $}

  ${
    $d f g y z F $.  $d f g y z G $.  $d f g y z H $.  $d f g x y z ph $.
    $d x y A $.  $d x y B $.  $d x U $.
    itg2split.a $e |- ( ph -> A e. dom vol ) $.
    itg2split.b $e |- ( ph -> B e. dom vol ) $.
    itg2split.i $e |- ( ph -> ( vol* ` ( A i^i B ) ) = 0 ) $.
    itg2split.u $e |- ( ph -> U = ( A u. B ) ) $.
    itg2split.c $e |- ( ( ph /\ x e. U ) -> C e. ( 0 [,] +oo ) ) $.
    itg2split.f $e |- F = ( x e. RR |-> if ( x e. A , C , 0 ) ) $.
    itg2split.g $e |- G = ( x e. RR |-> if ( x e. B , C , 0 ) ) $.
    itg2split.h $e |- H = ( x e. RR |-> if ( x e. U , C , 0 ) ) $.
    itg2split.sf $e |- ( ph -> ( S.2 ` F ) e. RR ) $.
    itg2split.sg $e |- ( ph -> ( S.2 ` G ) e. RR ) $.
    $( Lemma for ~ itg2split .  (Contributed by Mario Carneiro,
       11-Aug-2014.) $)
    itg2splitlem $p |- ( ph ->
      ( S.2 ` H ) <_ ( ( S.2 ` F ) + ( S.2 ` G ) ) ) $=
      ( cr vf vy citg2 cfv caddc co cle wbr cv cofr citg1 cdm wral wcel cc0 cif
      wi wa cmpt simprl itg1cl syl cvol adantr eqid i1fres syl2anc readdcld cin
      wss inss1 mblss syl5ss covol wceq cof cvv reex a1i fvex c0ex ifex offval2
      eqidd i1fadd eqeltrrd cdif i1ff eldifi ffvelrn syl2an leidd iftrue adantl
      wf wn eldifn sylnib imnan sylibr imp iffalse oveq12d recnd eqtrd breqtrrd
      elin ad2antrr syl6bb wfn ffn adantlr cxr 0le0 ifclda fmptd r19.21bi eldif
      nfcv fveq2 cid fveq2d breqtrd syldan pm2.61dan ifbieq12d syl5sseqr sselda
      cc eleq1 nfv nfan ofrfval2 3brtr4d a1d ralrimi wb mpbird itg2ub syl3anc
      addid1d cun eleq2d elun notbid ioran biimpar simprr cpnf cicc 0xr elxrge0
      wo mpbir2an inidm ofrfval mpbid sylan2 nfmpt1 nfcxfr nfeq1 eqeq1d fvmpt2i
      nffv 0cn ax-mp syl6eq sylan9eq sylbi vtoclgaf sylbir sylan anassrs oveq1d
      fvi 0re ifcl sylancl addid2d ovex fvmpt itg1lea itg1add eqtr3d ssun1 nfbr
      feqmptd biimpd impr ssun2 le2addd letrd expr ralrimiva rexrd itg2leub ) A
      IUCUDGUCUDZHUCUDZUEUFZUGUHZUAUIZIUGUJZUHZUXAUKUDZUWSUGUHZUQZUAUKULZUMZAUX
      FUAUXGAUXAUXGUNZUXCUXEAUXIUXCURZURZUXDBTBUIZCUNZUXLUXAUDZUOUPZUSZUKUDZBTU
      XLDUNZUXNUOUPZUSZUKUDZUEUFZUWSUXKUXIUXDTUNAUXIUXCUTZUXAVAVBUXKUXQUYAUXKUX
      PUXGUNZUXQTUNUXKUXICVCULZUNZUYDUYCAUYFUXJJVDZBCUXAUXPUXPVEVFVGZUXPVAVBZUX
      KUXTUXGUNZUYATUNUXKUXIDUYEUNZUYJUYCAUYKUXJKVDZBDUXAUXTUXTVEVFVGZUXTVAVBZV
      HAUWSTUNUXJAUWQUWRRSVHZVDUXKUXDBTUXOUXSUEUFZUSZUKUDZUYBUGUXKUBCDVIZUXAUYQ
      UYCAUYSTVJUXJAUYSCTCDVKAUYFCTVJZJCVLZVBVMVDAUYSVNUDUOVOUXJLVDUXKUXPUXTUEV
      PUFZUYQUXGAVUBUYQVOUXJABTUXOUXSUEUXPUXTVQVQVQTVQUNZAVRVSZUXOVQUNAUXLTUNZU
      RZUXMUXNUOUXLUXAVTZWAWBVSZUXSVQUNVUFUXRUXNUOVUGWAWBVSZAUXPWDZAUXTWDZWCVDZ
      UXKUXPUXTUYHUYMWEWFUXKUBUIZTUYSWGUNZURZVUMUXAUDZVUMCUNZVUPUOUPZVUMDUNZVUP
      UOUPZUEUFZVUMUYQUDZUGVUOVUQVUPVVAUGUHVUOVUQURZVUPVUPVVAUGVUOVUPVUPUGUHZVU
      QVUOVUPUXKTTUXAWOZVUMTUNZVUPTUNZVUNUXKUXIVVEUYCUXAWHZVBZVUMTUYSWIZTTVUMUX
      AWJWKZWLZVDVVCVVAVUPUOUEUFVUPVVCVURVUPVUTUOUEVUQVURVUPVOVUOVUQVUPUOWMWNVV
      CVUSWPZVUTUOVOZVUOVUQVVMVUOVUQVUSURZWPVUQVVMUQVUOVUMUYSUNZVVOVUNVVPWPUXKV
      UMTUYSWQWNVUMCDXGWRVUQVUSWSWTXAVUSVUPUOXBZVBXCVVCVUPVUOVUPYIUNVUQVUOVUPVV
      KXDVDUUAXEXFVUOVUQWPZURZVUPVUTVVAUGVVSVUSVUPVUTUGUHVVSVUSURVUPVUPVUTUGVUO
      VVDVVRVUSVVLXHVUSVUTVUPVOVVSVUSVUPUOWMWNXFVVSVVMURVUPUOVUTUGVUOVVRVVMVUPU
      OUGUHZVUOVVRVVMURZVUMFUNZWPZVVTVUOVWCVWAVUOVWCVUQVUSUUMZWPVWAVUOVWBVWDVUO
      VWBVUMCDUUBZUNVWDVUOFVWEVUMAFVWEVOUXJVUNMXHUUCVUMCDUUDXIUUEVUQVUSUUFXIUUG
      VUOVWCURVUPVUMIUDZUOUGVUOVUPVWFUGUHZVWCVUNUXKVVFVWGVVJUXKVWGUBTUXKUXCVWGU
      BTUMAUXIUXCUUHUXKUBTTVUPVWFUGTUXAIVQVQUXKVVEUXATXJVVITTUXAXKVBAITXJZUXJAT
      UOUUIUUJUFZIWOZVWHABTUXLFUNZEUOUPZVWIIVUFVWKEUOVWIAVWKEVWIUNZVUENXLZUOVWI
      UNZVUFVWKWPZURVWOUOXMUNUOUOUGUHZUUKXNUOUULUUNZVSXOZQXPZTVWIIXKVBVDVUCUXKV
      RVSZVXATUUOUXKVVFURZVUPWDVXBVWFWDUUPUUQXQUURVDVUOVVFVWCVWFUOVOZVUNVVFUXKV
      VJWNZVVFVWCURVUMTFWGZUNVXCVUMTFXRUXLIUDZUOVOZVXCBVUMVXEBVUMXSZBVWFUOBVUMI
      BIBTVWLUSZQBTVWLUUSUUTZVXHUVDUVAUXLVUMVOZVXFVWFUOUXLVUMIXTUVBUXLVXEUNVUEV
      WPURVXGUXLTFXRVUEVWPVXFVWLYAUDZUOBTVWLIQUVCVWPVXLUOYAUDZUOVWPVWLUOYAVWKEU
      OXBYBUOYIUNVXMUOVOUVEUOYIUVOUVFUVGUVHUVIUVJUVKUVLYCYDUVMVVMVVNVVSVVQWNXFY
      EVVSVVAUOVUTUEUFVUTVVSVURUOVUTUEVVRVURUOVOVUOVUQVUPUOXBWNUVNVVSVUTVUOVUTY
      IUNVVRVUOVUTVUOVVGUOTUNVUTTUNVVKUVPVUSVUPUOTUVQUVRXDVDUVSXEXFYEVUOVVFVVBV
      VAVOVXDBVUMUYPVVATUYQVXKUXOVURUXSVUTUEVXKUXMVUQUXNUOVUPUOUXLVUMCYJUXLVUMU
      XAXTZVXKUOWDZYFVXKUXRVUSUXNUOVUPUOUXLVUMDYJVXNVXOYFXCUYQVEVURVUTUEUVTUWAV
      BXFUWBUXKVUBUKUDUYRUYBUXKVUBUYQUKVULYBUXKUXPUXTUYHUYMUWCUWDYCUXKUXQUYAUWQ
      UWRUYIUYNAUWQTUNUXJRVDAUWRTUNUXJSVDUXKTVWIGWOZUYDUXPGUXBUHZUXQUWQUGUHAVXP
      UXJABTUXMEUOUPZVWIGVUFUXMEUOVWIVUFUXMVWKVWMAUXMVWKVUEACFUXLAVWECFCDUWEMYG
      YHZXLVWNYDVWOVUFUXMWPZURVWRVSXOZOXPVDUYHUXKVXQUXOVXRUGUHZBTUMZUXKVYBBTAUX
      JBABYKUXIUXCBUXIBYKBUXAIUXBBUXAXSBUXBXSVXJUWFYLYLZUXKVYBVUEUXKUXMVYBUXKUX
      MURZUXNEUXOVXRUGVYEUXNVWLEUGUXKUXMVUEUXNVWLUGUHZUXKCTUXLUXKUYFUYTUYGVUAVB
      YHUXKVYFBTAUXIUXCVYFBTUMZAUXIURZUXCVYGVYHBTUXNVWLUGUXAIVQVQVWIVUCVYHVRVSU
      XNVQUNVYHVUEURVUGVSAVUEVWLVWIUNUXIVWSXLVYHBTTUXAUXIVVEAVVHWNUWGIVXIVOVYHQ
      VSYMUWHUWIXQZYDVYEVWKVWLEVOZAUXMVWKUXJVXSXLVWKEUOWMZVBYCUXMUXOUXNVOUXKUXM
      UXNUOWMWNUXMVXREVOUXKUXMEUOWMWNYNVXTVYBUXKVXTUOUOUXOVXRUGVWQVXTXNVSUXMUXN
      UOXBUXMEUOXBYNWNYEYOYPAVXQVYCYQUXJABTUXOVXRUGUXPGVQVQVWIVUDVUHVYAVUJGBTVX
      RUSVOAOVSYMVDYRGUXPYSYTUXKTVWIHWOZUYJUXTHUXBUHZUYAUWRUGUHAVYLUXJABTUXREUO
      UPZVWIHVUFUXREUOVWIVUFUXRVWKVWMAUXRVWKVUEADFUXLAVWEDFDCUWJMYGYHZXLVWNYDVW
      OVUFUXRWPZURVWRVSXOZPXPVDUYMUXKVYMUXSVYNUGUHZBTUMZUXKVYRBTVYDUXKVYRVUEUXK
      UXRVYRUXKUXRURZUXNEUXSVYNUGVYTUXNVWLEUGUXKUXRVUEVYFUXKDTUXLUXKUYKDTVJUYLD
      VLVBYHVYIYDVYTVWKVYJAUXRVWKUXJVYOXLVYKVBYCUXRUXSUXNVOUXKUXRUXNUOWMWNUXRVY
      NEVOUXKUXREUOWMWNYNVYPVYRUXKVYPUOUOUXSVYNUGVWQVYPXNVSUXRUXNUOXBUXREUOXBYN
      WNYEYOYPAVYMVYSYQUXJABTUXSVYNUGUXTHVQVQVWIVUDVUIVYQVUKHBTVYNUSVOAPVSYMVDY
      RHUXTYSYTUWKUWLUWMUWNAVWJUWSXMUNUWTUXHYQVWTAUWSUYOUWOUWSUAIUWPVGYR $.

    $( The ` S.2 ` integral splits under an almost disjoint union.  (The proof
       avoids the use of ~ itg2add which requires CC.) (Contributed by Mario
       Carneiro, 11-Aug-2014.) $)
    itg2split $p |- ( ph -> ( S.2 ` H ) = ( ( S.2 ` F ) + ( S.2 ` G ) ) ) $=
      ( cr vf vg vy citg2 cfv caddc co wceq cle itg2splitlem cmin cv cofr citg1
      wbr wi cdm wral wcel wa adantr cc0 cpnf wf cif adantlr wn cxr 0xr elxrge0
      cicc 0le0 mpbir2an ifclda fmptd readdcld itg2lecl syl3anc itg1cl ad2antrl
      a1i cof simprll simprrl itg1add cin i1fadd wss inss1 cvol mblss syl covol
      syl5ss cdif nfv nfcv cmpt nfmpt1 nfcxfr nfbr nfan eldifi cvv wfn i1ff ffn
      reex inidm eqidd sylan2 ffvelrn syl2an rexrd 0re wb fvex syl5sseqr sselda
      syldan simpr dffn5 sylib ofrfval2 r19.21bi adantl iffalse breqtrd syl2anc
      mpbid recnd iftrue breqtrrd fveq2 expr ralrimiva resubcld itg2leub mpbird
      xrletrd ofval iccssxr sseldi simprrr cun ssun2 eldifn sylnib imnan sylibr
      elin imp leadd2dd addid1d simprlr ssun1 ad2antrr 3eqtr4d leadd1dd addid2d
      fvmpt2 ad3antrrr eleq2d biorf elun syl6rbbr bitrd ifbid pm2.61dan eqbrtrd
      wo eqtrd ralrimi nffv breq12d itg2uba eqbrtrrd adantrr leaddsub2d anassrs
      ex cbvral lesubd leaddsub itg2cl xrletri3 mpbir2and ) AIUDUEZGUDUEZHUDUEZ
      UFUGZUHZUWHUWKUIUOZUWKUWHUIUOZABCDEFGHIJKLMNOPQRSUJZAUWNUWIUWHUWJUKUGZUIU
      OZAUWQUAULZGUIUMZUOZUWRUNUEZUWPUIUOZUPZUAUNUQZURZAUXCUAUXDAUWRUXDUSZUWTUX
      BAUXFUWTUTZUTZUWJUWHUXAAUWJTUSZUXGSVAAUWHTUSZUXGATVBVCVKUGZIVDZUWKTUSUWMU
      XJABTBULZFUSZEVBVEZUXKIAUXMTUSZUTZUXNEVBUXKAUXNEUXKUSZUXPNVFZVBUXKUSZUXQU
      XNVGUTUXTVBVHUSVBVBUIUOVIVLVBVJVMZWAVNZQVOZAUWIUWJRSVPZUWOUWKIVQVRZVAZUXF
      UXATUSZAUWTUWRVSVTZUXHUWJUWHUXAUKUGZUIUOZUBULZHUWSUOZUYKUNUEZUYIUIUOZUPZU
      BUXDURZUXHUYOUBUXDUXHUYKUXDUSZUYLUYNAUXGUYQUYLUTZUYNAUXGUYRUTZUTZUXAUYMUF
      UGZUWHUIUOUYNUYTUWRUYKUFWBUGZUNUEVUAUWHUIUYTUWRUYKAUXFUWTUYRWCZAUXGUYQUYL
      WDZWEUYTUCCDWFZIVUBAUXLUYSUYCVAZUYTUWRUYKVUCVUDWGAVUETWHUYSAVUECTCDWIACWJ
      UQUSCTWHJCWKWLWNVAAVUEWMUEVBUHUYSLVAUYTUCULZVUBUEZVUGIUEZUIUOZUCTVUEWOZUY
      TUXMVUBUEZUXMIUEZUIUOZBVUKURVUJUCVUKURUYTVUNBVUKAUYSBABWPUXGUYRBUXFUWTBUX
      FBWPBUWRGUWSBUWRWQBUWSWQZBGBTUXMCUSZEVBVEZWRZOBTVUQWSWTXAXBUYQUYLBUYQBWPB
      UYKHUWSBUYKWQVUOBHBTUXMDUSZEVBVEZWRZPBTVUTWSWTXAXBXBXBUYTUXMVUKUSZVUNUYTV
      VBUTZVULUXMUWRUEZUXMUYKUEZUFUGZVUMUIVVBUYTUXPVULVVFUHUXMTVUEXCZUYTTTVVDVV
      EUFTUWRUYKXDXDUXMUYTTTUWRVDZUWRTXEZUYTUXFVVHVUCUWRXFWLZTTUWRXGWLZUYTTTUYK
      VDZUYKTXEZUYTUYQVVLVUDUYKXFWLZTTUYKXGWLZTXDUSZUYTXHWAZVVQTXIUYTUXPUTZVVDX
      JVVRVVEXJUUAXKVVCVUPVVFVUMUIUOVVCVUPUTZVVFVVDVUMVVCVVFVHUSZVUPVVCVVFVVCVV
      DVVEUYTVVHUXPVVDTUSZVVBVVJVVGTTUXMUWRXLXMZUYTVVLUXPVVETUSZVVBVVNVVGTTUXMU
      YKXLXMZVPXNZVAVVSVVDVVCVWAVUPVWBVAZXNVVCVUMVHUSZVUPVVCUXKVHVUMVBVCUUBUYTU
      XLUXPVUMUXKUSVVBVUFVVGTUXKUXMIXLXMUUCZVAVVSVVFVVDVBUFUGVVDUIVVSVVEVBVVDVV
      CVWCVUPVWDVAVBTUSZVVSXOWAVWFVVSVVEVUTVBUIVVCVVEVUTUIUOZVUPVVBUYTUXPVWJVVG
      UYTVWJBTUYTUYLVWJBTURZAUXGUYQUYLUUDAUYSVVMUYLVWKXPVVOAVVMUTZBTVVEVUTUIUYK
      HXDXDUXKVVPVWLXHWAVVEXDUSVWLUXPUTUXMUYKXQWAAUXPVUTUXKUSVVMUXQVUSEVBUXKUXQ
      VUSUXNUXRAVUSUXNUXPADFUXMACDUUEZDFDCUUFMXRXSVFUXSXTUXTUXQVUSVGZUTUYAWAVNZ
      VFVWLVVMUYKBTVVEWRUHAVVMYABTUYKYBYCHVVAUHVWLPWAYDXTYJYEXKZVAVVSVWNVUTVBUH
      VVCVUPVWNVVCVUPVUSUTZVGVUPVWNUPVVCUXMVUEUSZVWQVVBVWRVGUYTUXMTVUEUUGYFUXMC
      DUUKUUHVUPVUSUUIUUJUULVUSEVBYGWLYHUUMVVSVVDVVSVVDVWFYKUUNYHVVSVVDVUQVUMUI
      VVCVVDVUQUIUOZVUPVVBUYTUXPVWSVVGUYTVWSBTUYTUWTVWSBTURZAUXFUWTUYRUUOAUYSVV
      IUWTVWTXPVVKAVVIUTZBTVVDVUQUIUWRGXDXDUXKVVPVXAXHWAVVDXDUSVXAUXPUTUXMUWRXQ
      WAAUXPVUQUXKUSVVIUXQVUPEVBUXKUXQVUPUXNUXRAVUPUXNUXPACFUXMAVWMCFCDUUPMXRZX
      SVFUXSXTUXTUXQVUPVGZUTUYAWAVNZVFVXAVVIUWRBTVVDWRUHAVVIYABTUWRYBYCGVURUHVX
      AOWAYDXTYJYEXKZVAVVSUXOEVUMVUQVVSUXNUXOEUHVVCCFUXMACFWHUYSVVBVXBUUQXSUXNE
      VBYLWLVVCVUMUXOUHZVUPVVBUYTUXPVXFVVGVVRUXPUXOUXKUSZVXFUYTUXPYAAUXPVXGUYSU
      YBVFBTUXOUXKIQUVAYIXKZVAVUPVUQEUHVVCVUPEVBYLYFUURYMYTVVCVXCUTZVVFVVEVUMVV
      CVVTVXCVWEVAVXIVVEVVCVWCVXCVWDVAZXNVVCVWGVXCVWHVAVXIVVFVBVVEUFUGVVEUIVXIV
      VDVBVVEVVCVWAVXCVWBVAVWIVXIXOWAVXJVXIVVDVUQVBUIVVCVWSVXCVXEVAVXCVUQVBUHVV
      CVUPEVBYGYFYHUUSVXIVVEVXIVVEVXJYKUUTYHVXIVVEVUTVUMUIVVCVWJVXCVWPVAVXIVUMU
      XOVUTVVCVXFVXCVXHVAVXIUXNVUSEVBVXIUXNUXMVWMUSZVUSVXIFVWMUXMAFVWMUHUYSVVBV
      XCMUVBUVCVXCVXKVUSXPVVCVXCVUSVUPVUSUVKVXKVUPVUSUVDUXMCDUVEUVFYFUVGUVHUVLY
      MYTUVIUVJUWAUVMVUNVUJBUCVUKVUNUCWPBVUHVUIUIBVUHWQBUIWQBVUGIBIBTUXOWRQBTUX
      OWSWTBVUGWQUVNXAUXMVUGUHVULVUHVUMVUIUIUXMVUGVUBYNUXMVUGIYNUVOUWBYCYEUVPUV
      QUYTUXAUYMUWHAUXGUYGUYRUYHUVRUYTUYQUYMTUSVUDUYKVSWLAUXJUYSUYEVAUVSYJUVTYO
      YPUXHTUXKHVDZUYIVHUSUYJUYPXPAVXLUXGABTVUTUXKHVWOPVOVAUXHUYIUXHUWHUXAUYFUY
      HYQXNUYIUBHYRYIYSUWCYOYPATUXKGVDUWPVHUSUWQUXEXPABTVUQUXKGVXDOVOAUWPAUWHUW
      JUYESYQXNUWPUAGYRYIYSAUWITUSUXIUXJUWNUWQXPRSUYEUWIUWJUWHUWDVRYSAUWHVHUSZU
      WKVHUSUWLUWMUWNUTXPAUXLVXMUYCIUWEWLAUWKUYDXNUWHUWKUWFYIUWG $.
  $}

  ${
    $d j k x A $.  $d f m n t x y z G $.  $d j k n w x y H $.  $d n t x y P $.
    $d j k m n w x y z F $.  $d f j k m n t w x y z ph $.  $d f k n t x y S $.
    $d j k n w x y T $.
    itg2mono.1 $e |- G = ( x e. RR |-> sup ( ran
                           ( n e. NN |-> ( ( F ` n ) ` x ) ) , RR , < ) ) $.
    itg2mono.2 $e |- ( ( ph /\ n e. NN ) -> ( F ` n ) e. MblFn ) $.
    itg2mono.3 $e |- ( ( ph /\ n e. NN ) ->
                       ( F ` n ) : RR --> ( 0 [,) +oo ) ) $.
    itg2mono.4 $e |- ( ( ph /\ n e. NN ) ->
                       ( F ` n ) oR <_ ( F ` ( n + 1 ) ) ) $.
    itg2mono.5 $e |- ( ( ph /\ x e. RR ) ->
      E. y e. RR A. n e. NN ( ( F ` n ) ` x ) <_ y ) $.
    itg2mono.6 $e |- S =
      sup ( ran ( n e. NN |-> ( S.2 ` ( F ` n ) ) ) , RR* , < ) $.
    ${
      itg2mono.7 $e |- ( ph -> T e. ( 0 (,) 1 ) ) $.
      itg2mono.8 $e |- ( ph -> H e. dom S.1 ) $.
      itg2mono.9 $e |- ( ph -> H oR <_ G ) $.
      itg2mono.10 $e |- ( ph -> S e. RR ) $.
      itg2mono.11 $e |- A = ( n e. NN |-> { x e. RR |
        ( T x. ( H ` x ) ) <_ ( ( F ` n ) ` x ) } ) $.
      $( Lemma for ~ itg2mono .  We show that for any constant ` t ` less than
         one, ` t x. S.1 H ` is less than ` S ` , and so ` S.1 H <_ S ` , which
         is one half of the equality in ~ itg2mono .  Consider the sequence
         ` A ( n ) = { x | t x. H <_ F ( n ) } ` .  This is an increasing
         sequence of measurable sets whose union is ` RR ` , and so
         ` H |`` A ( n ) ` has an integral which equals ` S.1 H ` in the limit,
         by ~ itg1climres .  Then by taking the limit in
         ` ( t x. H ) |`` A ( n ) <_ F ( n ) ` , we get ` t x. S.1 H <_ S ` as
         desired.  (Contributed by Mario Carneiro, 16-Aug-2014.)  (Revised by
         Mario Carneiro, 23-Aug-2014.) $)
      itg2monolem1 $p |- ( ph -> ( T x. ( S.1 ` H ) ) <_ S ) $=
        ( vk vj vw vz vm citg1 cfv cmul co cn cr cv wcel cc0 cmpt citg2 c1 nnuz
        cif a1i cvv cle wbr crab cdm wa cneg csn cxp cof caddc cmnf cioo wn clt
        wfn wb adantl cpnf wss cxr 0re mp2an fss sylancl 0xr 1re i1fmulc adantr
        wf sylib i1ff syl reex ffn ffvelrnda eqidd recnd ad2antrr adantlr eqtrd
        remulcld breq1d breq2d syl2anc fmptd ralrimiva weq fveq2 fveq2d breq12d
        wral cbvralv r19.21bi feq1d peano2nn mpbid syl3anc fveq1d rabbidv rabex
        wceq fvmpt crn wrex csup adantrr c0 wne eqid fvex ralbiia bitr4i mpbird
        frn breqtrd mpteq2dv sylibr elrege0 cz cvol ccnv cima cdif readdcl cico
        cin pnfxr icossre w3a rexri elioo2 simp1d renegcld inidm elpreima simpr
        1z biantrurd bitr4d elioomnf ax-mp syl6rbbr cmin ofc1 cc mulneg1d ofval
        off negsubd ltsubaddd addid2d 3bitrd notbid eldif baib lenltd rabbi2dva
        3bitr4d rembl cmbf i1fmbf mbfadd mbfima cmmbl inmbl eqeltrrd cofr oveq1
        sylancr rspccva syl2an ofrfval wi letr ss2rabdv 3sstr4d ciun cuni an32s
        mpan2d 1nn syl5eleqr dm0rn0 necon3bii breq1 ralrn syl6bb rexbidv suprcl
        ne0i simp3d simprr ltmul1 syl112anc mulid2d rneqd supeq1d supex ltletrd
        fdm ltso suprlub syl31anc breq2 rexbiia simplr ffvelrnd simpld adantlrr
        rexrn reximdva anassrs simplrr simp2d lemul2 mul01d simprd letrd r19.2z
        ltle mpd ltlecasei rabid2 syl6eqr iuneq2dv fniunfv 3eqtr2rd itg1climres
        iunrab nnex mptex eleq2d ifbid i1fres itg1cl eqeltrd oveq2d ovex eqtr4d
        climmulc2 cli cicc rexr anim1i elxrge0 3imtr4i ssriv itg2cl cab elabrex
        rnmpt syl6eleqr supxrub syl6breqr itg2lecl itg2le ralbidv syl5bb rspcev
        climsup eqnetrd fnmpti supxrre syl5req c0ex ifex fconstmpt offval2 ifsb
        oveq2 ifeq2d syl5eq iftrue biimpa rabid simprbi eqbrtrd iffalse feqmptd
        ad2antlr pm2.61dan ofrfval2 itg2ub itg1mulc 3eqtr2d 3brtr4d climle ) AF
        JUGUHZUIUJEUBUCUKFBULBUMZUCUMZDUHZUNZVXKJUHZUOUTZUPZUGUHZUIUJZUPZGUKGUM
        ZHUHZUQUHZUPZURUKUSURUUAUNAUUSVAZAVXJFUBUCUKVXRUPZVXTURVBUKUSVYEABDUCJV
        XQAGUKFVXOUIUJZVXKVYBUHZVCVDZBULVEZUUBVFZDAVYAUKUNZVGZULULVYBULFVHZVIVJ
        JUIVKZUJZVLVKUJZUUCVMUOVNUJZUUDZUUEZUUHZVYJVYKVYMVYIBULVYTVYMVXKULUNZVG
        ZVXKVYSUNZVOZVYHVYGVPVDZVOVXKVYTUNZVYIWUCWUDWUFWUCWUDVXKVYQUHZVYRUNZWUH
        UOVPVDZWUFWUCWUDWUBWUIVGZWUIWUCVYQULVQZWUDWUKVRWUCULULVYQWKZWULVYMWUMWU
        BVYMBCULULULVLULULULVYBVYPVBVBWUBCUMZULUNZVGVXKWUNVLUJULUNVYMVXKWUNUUFV
        SVYMULUOVTUUGUJZVYBWKZWUPULWAZULULVYBWKZMUOULUNZVTWBUNWURWCUUIUOVTUUJWD
        ZULWUPULVYBWEWFZVYMVYPUGVFZUNZULULVYPWKZAWVDVYLAVYNJRAFAFULUNZUOFVPVDZF
        URVPVDZAFUOURVNUJUNZWVFWVGWVHUUKZQUOWBUNZURWBUNWVIWVJVRWGURWHUULUOURFUU
        MWDWLZUUNZUUOZWIWJZVYPWMWNZULVBUNZVYMWOVAZWVRULUUPZUVJZWJULULVYQWPWNULV
        XKVYRVYQUUQWNWUCWUBWUIVYMWUBUURUUTUVAWUCWUJWUHULUNZWUJVGZWUIWUCWWAWUJVY
        MULULVXKVYQWVTWQUUTWVKWUIWWBVRWGUOWUHUVBUVCUVDWUCWUJVYHVYGUVEUJZUOVPVDV
        YHUOVYGVLUJZVPVDWUFWUCWUHWWCUOVPWUCWUHVYHVYGVHZVLUJWWCVYMULULVYHWWEVLUL
        VYBVYPVBVBVXKVYMWUSVYBULVQWVBULULVYBWPWNVYMWVEVYPULVQWVPULULVYPWPWNWVRW
        VRWVSWUCVYHWRWUCVXKVYPUHVYNVXOUIUJWWEVYMULVYNVXOUIJVBULVXKWVRAVYNULUNVY
        LWVNWJAJULVQZVYLAULULJWKZWWFAJWVCUNZWWGRJWMWNZULULJWPWNZWJWUCVXOWRUVFWU
        CFVXOAFUVGUNZVYLWUBAFWVMWSZWTWUCVXOAWUBVXOULUNZVYLAULULVXKJWWIWQZXAWSUV
        HXBUVIWUCVYHVYGWUCVYHVYMULULVXKVYBWVBWQZWSWUCVYGAWUBVYGULUNZVYLAWUBVGZF
        VXOAWVFWUBWVMWJWWNXCZXAZWSZUVKXBXDWUCVYHVYGUOWWOWWSWUTWUCWCVAUVLWUCWWDV
        YGVYHVPWUCVYGWWTUVMXEUVNUVNUVOWUBWUGWUEVRVYMWUGWUBWUEVXKULVYSUVPUVQVSWU
        CVYGVYHWWSWWOUVRUVTUVSVYMULVYKUNVYTVYKUNZWUAVYKUNUWAVYMVYSVYKUNZWXAVYMV
        YQUWBUNWUMWXBVYMVYBVYPLVYMWVDVYPUWBUNWVOVYPUWCWNUWDWVTULVMUOVYQUWEXFVYS
        UWFWNULVYTUWGUWKUWHUAXGZAVXLUKUNZVGZVYGVXKVXLHUHZUHZVCVDZBULVEZVYGVXKVX
        LURVLUJZHUHZUHZVCVDZBULVEZVXMWXJDUHZWXEWXHWXMBULWXEWUBVGZWXHWXGWXLVCVDZ
        WXMWXEWXQBULWXEWXFWXKVCUWIZVDZWXQBULXMAWXSUCUKAVYBVYAURVLUJZHUHZWXRVDZG
        UKXMWXSUCUKXMAWYBGUKNXHWYBWXSGUCUKGUCXIZVYBWXFWYAWXKWXRVYAVXLHXJZWYCWXT
        WXJHVYAVXLURVLUWJXKXLXNWLXOWXEBULULWXGWXLVCULWXFWXKVBVBWXEULWUPWXFWKZWX
        FULVQAWYEUCUKAWUQGUKXMZWYEUCUKXMAWUQGUKMXHZWUQWYEGUCUKWYCULWUPVYBWXFWYD
        XPXNWLXOZULWUPWXFWPWNWXEULWUPWXKWKZWXKULVQAWYFWXJUKUNZWYIWXDWYGVXLXQZWU
        QWYIGWXJUKVYAWXJYCZULWUPVYBWXKVYAWXJHXJZXPUWLUWMZULWUPWXKWPWNWVQWXEWOVA
        ZWYOWVSWXPWXGWRWXPWXLWRUWNXRXOWXPWWPWXGULUNZWXLULUNWXHWXQVGWXMUWOWXPFVX
        OAWVFWXDWUBWVMWTWXEULULVXKJAWWGWXDWWIWJWQXCWXEULULVXKWXFWXEWYEWURULULWX
        FWKWYHWVAULWUPULWXFWEWFWQWXEULULVXKWXKWXEWYIWURULULWXKWKWYNWVAULWUPULWX
        KWEWFWQVYGWXGWXLUWPXSUXBUWQWXDVXMWXIYCAGVXLVYJWXIUKDWYCVYIWXHBULWYCVYHW
        XGVYGVCWYCVXKVYBWXFWYDXTZXEYAUAWXHBULWOYBYDVSZWXEWYJWXOWXNYCWXDWYJAWYKV
        SGWXJVYJWXNUKDWYLVYIWXMBULWYLVYHWXLVYGVCWYLVXKVYBWXKWYMXTXEYAUAWXMBULWO
        YBYDWNUWRAULUCUKWXIUWSZUCUKVXMUWSZDYEUWTZAULWXHUCUKYFZBULVEZWYSAXUBBULX
        MULXUCYCAXUBBULWWQXUBUOVXOAWUBUOVXOVPVDZXUBAWUBXUDVGZVGZVYGWXGVPVDZUCUK
        YFZXUBXUFVYGUDUMZVPVDZUDGUKVYHUPZYEZYFZXUHXUFVYGXULULVPYGZVPVDZXUMXUFVY
        GVXOXUNAWUBWWPXUDWWRYHZAWUBWWMXUDWWNYHZAWUBXUNULUNZXUDWWQXULULWAZXULYIY
        JZUEUMZWUNVCVDZUEXULXMZCULYFZXURWWQUKULXUKWKZXUSWWQGUKVYHULXUKAVYLWUBVY
        HULUNWWOUXAXUKYKZXGZUKULXUKYPWNZWWQXUKVFZYIYJZXUTWWQURXVIUNXVJWWQURUKXV
        IUXCWWQXVEXVIUKYCXVGUKULXUKUYBWNUXDXVIURUXLWNXVIYIXULYIXUKUXEUXFWLZWWQX
        VDVYHWUNVCVDZGUKXMZCULYFOWWQXVCXVMCULWWQXVCUFUMZXUKUHZWUNVCVDZUFUKXMZXV
        MWWQXUKUKVQZXVCXVQVRWWQXVEXVRXVGUKULXUKWPWNZXVBXVPUEUFUKXUKXVAXVOWUNVCU
        XGUXHWNXVQVXKXVNHUHZUHZWUNVCVDZUFUKXMXVMXVPXWBUFUKXVNUKUNXVOXWAWUNVCGXV
        NVYHXWAUKXUKGUFXIZVXKVYBXVTVYAXVNHXJXTZXVFVXKXVTYLYDXDYMXVLXWBGUFUKXWCV
        YHXWAWUNVCXWDXDXNYNUXIUXJYOZCUEXULUXKXSZYHXUFVYGURVXOUIUJZVXOVPXUFWVHVY
        GXWGVPVDZAWVHXUEAWVFWVGWVHWVLUXMWJXUFWVFURULUNZWWMXUDWVHXWHVRAWVFXUEWVM
        WJZXWIXUFWHVAXUQAWUBXUDUXNFURVXOUXOUXPXRXUFVXOXUFVXOXUQWSUXQYQAWUBVXOXU
        NVCVDZXUDAXWKBULAWUNJUHZGUKWUNVYBUHZUPZYEZULVPYGZVCVDZCULXMZXWKBULXMAJI
        WXRVDXWRSACULULXWLXWPVCULJIVBVBWWJAULULIWKIULVQABULXUNULIXWFKXGULULIWPW
        NWVQAWOVAZXWSWVSAWUOVGXWLWRWUOWUNIUHXWPYCABWUNXUNXWPULIBCXIZULXULXWOVPX
        WTXUKXWNXWTGUKVYHXWMVXKWUNVYBXJYRUXRUXSZKULXWOVPUYCUXTYDVSUWNXRXWKXWQBC
        ULXWTVXOXWLXUNXWPVCVXKWUNJXJXXAXLXNYSXOYHUYAXUFXUSXUTXVDWWPXUOXUMVRAWUB
        XUSXUDXVHYHAWUBXUTXUDXVKYHAWUBXVDXUDXWEYHXUPCUEUDXULVYGUYDUYEXRXUFXUMVY
        GVXLXUKUHZVPVDZUCUKYFZXUHXUFXVRXUMXXDVRAWUBXVRXUDXVSYHXUJXXCUDUCUKXUKXU
        IXXBVYGVPUYFUYLWNXXCXUGUCUKWXDXXBWXGVYGVPGVXLVYHWXGUKXUKWYQXVFVXKWXFYLY
        DXEUYGUXIXRXUFXUGWXHUCUKXUFWXDVGWWPWYPXUGWXHUWOXUFWWPWXDXUFFVXOXWJXUQXC
        WJAWUBWXDWYPXUDWWQWXDVGZWYPUOWXGVCVDZXXEWXGWUPUNWYPXXFVGZXXEULWUPVXKWXF
        AWXDWYEWUBWYHXAAWUBWXDUYHUYIWXGYTWLZUYJUYKVYGWXGVUBXFUYMVUCUYNAWUBVXOUO
        VCVDZXUBAWUBXXIVGZVGZUKYIYJZWXHUCUKXMXUBURUKUNXXLUXCUKURUXLUVCZXXKWXHUC
        UKXXKWXDVGZVYGUOWXGXXKWWPWXDAWUBWWPXXIWWRYHWJWUTXXNWCVAZXXNWYPXXFAWUBWX
        DXXGXXIXXHUYKZUYJXXNVYGFUOUIUJZUOVCXXNXXIVYGXXQVCVDZAWUBXXIWXDUYOXXNWWM
        WUTWVFWVGXXIXXRVRXXKWWMWXDAWUBWWMXXIWWNYHWJXXOAWVFXXJWXDWVMWTZAWVGXXJWX
        DAWVFWVGWVHWVLUYPWTVXOUOFUYQUXPXRXXNFXXNFXXSWSUYRYQXXNWYPXXFXXPUYSUYTXH
        WXHUCUKVUAUWKUYNWUTWWQWCVAWWNVUDXHXUBBULVUEYSWXHUCBUKULVUKVUFAUCUKVXMWX
        IWYRVUGADUKVQZWYTXUAYCAUKVYKDWKXXTWXCUKVYKDWPWNUCUKDVUHWNVUIRVXQYKZVUJW
        WLVXTVBUNAUCUKVXSVULVUMVAAUBUMZUKUNZVGZXYBVYFUHZXYDXYEBULVXKXYBDUHZUNZV
        XOUOUTZUPZUGUHZULXYCXYEXYJYCAUCXYBVXRXYJUKVYFUCUBXIZVXQXYIUGXYKBULVXPXY
        HXYKVXNXYGVXOUOXYKVXMXYFVXKVXLXYBDXJVUNVUOYRXKZVYFYKXYIUGYLYDZVSXYDXYIW
        VCUNZXYJULUNXYDWWHXYFVYKUNXYNAWWHXYCRWJAUKVYKXYBDWXCWQBXYFJXYIXYIYKVUPX
        FZXYIVUQWNVURWSXYCXYBVXTUHZFXYEUIUJZYCAXYCXYPFXYJUIUJZXYQUCXYBVXSXYRUKV
        XTXYKVXRXYJFUIXYLVUSVXTYKZFXYJUIVUTYDZXYCXYEXYJFUIXYMVUSVVAVSVVBAVYDVYD
        YEZULVPYGZEVVCABUBVYDURUKUSVYEAGUKVYCULVYDVYMULUOVTVVDUJZVYBWKZEULUNZVY
        CEVCVDZVYCULUNVYMWUQWUPYUCWAZYUDMBWUPYUCWUBUOVXKVCVDZVGVXKWBUNZYUHVGVXK
        WUPUNVXKYUCUNWUBYUIYUHVXKVVEVVFVXKYTVXKVVGVVHVVIZULWUPYUCVYBWEWFZAYUEVY
        LTWJVYMVYCYUAWBVPYGZEVCVYMYUAWBWAZVYCYUAUNVYCYULVCVDAYUMVYLAUKWBVYDWKYU
        MAGUKVYCWBVYDVYMYUDVYCWBUNYUKVYBVVJWNVYDYKZXGUKWBVYDYPWNWJVYMVYCVXKVYCY
        CGUKYFBVVKZYUAVYLVYCYUOUNAGBUKVYCVYBUQYLZVVLVSGBUKVYCVYDYUNVVMVVNYUAVYC
        VVOXFPVVPZEVYBVVQXSYUNXGZAXYBVYDUHZXYBURVLUJZVYDUHZVCVDZUBUKAVYCWYAUQUH
        ZVCVDZGUKXMZYVBUBUKXMZAYVDGUKVYMYUDULYUCWYAWKZWYBYVDYUKAULYUCXYBHUHZWKZ
        UBUKXMZWXTUKUNYVGVYLAYUDGUKXMYVJAYUDGUKYUKXHYUDYVIGUBUKGUBXIZULYUCVYBYV
        HVYAXYBHXJZXPXNWLVYAXQYVIYVGUBWXTUKXYBWXTYCULYUCYVHWYAXYBWXTHXJXPUWLUWM
        NVYBWYAVVRXSXHYVFYVHUQUHZYUTHUHZUQUHZVCVDZUBUKXMYVEYVBYVPUBUKXYCYUSYVMY
        VAYVOVCGXYBVYCYVMUKVYDYVKVYBYVHUQYVLXKZYUNYVHUQYLYDZXYCYUTUKUNYVAYVOYCX
        YBXQGYUTVYCYVOUKVYDVYAYUTYCVYBYVNUQVYAYUTHXJXKYUNYVNUQYLYDWNXLYMYVDYVPG
        UBUKYVKVYCYVMYVCYVOVCYVQYVKWYAYVNUQYVKWXTYUTHVYAXYBURVLUWJXKXKXLXNYNYSX
        OAYUEYUFGUKXMZYUSVXKVCVDZUBUKXMZBULYFZTAYUFGUKYUQXHYWAYVSBEULYWAVYCVXKV
        CVDZGUKXMZVXKEYCZYVSYWAYVMVXKVCVDZUBUKXMYWDYVTYWFUBUKXYCYUSYVMVXKVCYVRX
        DYMYWCYWFGUBUKYVKVYCYVMVXKVCYVQXDXNYNYWEYWCYUFGUKVXKEVYCVCUYFVVSVVTVWAX
        FZVWBAEYULYUBPAYUAULWAZYUAYIYJZXVAVXKVCVDZUEYUAXMZBULYFZYULYUBYCAUKULVY
        DWKZYWHYURUKULVYDYPWNAVYDVFZYIYJYWIAYWNUKYIAYWMYWNUKYCYURUKULVYDUYBWNXX
        LAXXMVAVWCYWNYIYUAYIVYDUXEUXFWLAYWLYWBYWGAYWKYWABULAVYDUKVQZYWKYWAVRYWO
        AGUKVYCVYDYUPYUNVWDVAYWJYVTUEUBUKVYDXVAYUSVXKVCUXGUXHWNUXJYOBUEYUAVWEXS
        VWFYQAUKULXYBVXTAUCUKVXSULVXTWXEFVXRAWVFWXDWVMWJWXEVXQWVCUNZVXRULUNWXEW
        WHVXMVYKUNYWPAWWHWXDRWJAUKVYKVXLDWXCWQBVXMJVXQXYAVUPXFVXQVUQWNXCXYSXGWQ
        AUKULXYBVYDYURWQXYDBULXYGVYGUOUTZUPZUGUHZYVMXYPYUSVCXYDYVIYWRWVCUNYWRYV
        HWXRVDZYWSYVMVCVDXYDULWUPYVHWKZYUGYVIAYXAUBUKAWYFYXAUBUKXMWYGWUQYXAGUBU
        KYVKULWUPVYBYVHYVLXPXNWLXOZYUJULWUPYUCYVHWEWFXYDULFVIVJZXYIVYOUJZYWRWVC
        XYDYXDBULFXYHUIUJZUPYWRXYDBULFXYHUIYXCXYIVBULVBWVQXYDWOVAZXYDWVFWUBAWVF
        XYCWVMWJZWJXYHVBUNXYDWUBVGZXYGVXOUOVXKJYLVWGVWHVAYXCBULFUPYCXYDBULFVWIV
        AXYDXYIWRVWJXYDBULYXEYWQXYDYXEXYGVYGXXQUTYWQXYGVXOUOYXEVYGXXQXYHVXOFUIV
        WLXYHUOFUIVWLVWKXYDXYGXXQUOVYGXYDFAWWKXYCWWLWJUYRVWMVWNYRXBZXYDFXYIXYOY
        XGWIUWHXYDYWTYWQVXKYVHUHZVCVDZBULXMXYDYXKBULYXHXYGYXKYXHXYGVGZYWQVYGYXJ
        VCXYGYWQVYGYCYXHXYGVYGUOVWOVSYXLVXKVYGYXJVCVDZBULVEZUNZYXMYXHXYGYXOYXHX
        YFYXNVXKXYCXYFYXNYCAWUBGXYBVYJYXNUKDYVKVYIYXMBULYVKVYHYXJVYGVCYVKVXKVYB
        YVHYVLXTXEYAUAYXMBULWOYBYDVXBVUNVWPYXOWUBYXMYXMBULVWQVWRWNVWSYXHXYGVOZV
        GYWQUOYXJVCYXPYWQUOYCYXHXYGVYGUOVWTVSYXHUOYXJVCVDZYXPYXHYXJWUPUNZYXQXYD
        ULWUPVXKYVHYXBWQYXRYXJULUNYXQYXJYTVWRWNWJVWSVXCXHXYDBULYWQYXJVCYWRYVHVB
        VBVBYXFYWQVBUNYXHXYGVYGUOFVXOUIVUTVWGVWHVAYXJVBUNYXHVXKYVHYLVAXYDYWRWRX
        YDBULWUPYVHYXBVXAVXDYOYVHYWRVXEXSXYDXYPXYRYXDUGUHYWSXYCXYPXYRYCAXYTVSXY
        DFXYIXYOYXGVXFXYDYXDYWRUGYXIXKVXGXYCYUSYVMYCAYVRVSVXHVXI $.
    $}

    ${
      itg2monolem2.7 $e |- ( ph -> P e. dom S.1 ) $.
      itg2monolem2.8 $e |- ( ph -> P oR <_ G ) $.
      itg2monolem2.9 $e |- ( ph -> -. ( S.1 ` P ) <_ S ) $.
      $( Lemma for ~ itg2mono .  (Contributed by Mario Carneiro,
         16-Aug-2014.) $)
      itg2monolem2 $p |- ( ph -> S e. RR ) $=
        ( cxr wcel cn citg1 cfv cr cmnf clt wbr cle cv citg2 cmpt crn wss wf wa
        csup cc0 cpnf cicc co cico anim1i elrege0 elxrge0 3imtr4i ssriv sylancl
        rexr fss itg2cl syl eqid fmptd frn supxrcl syl5eqel cdm itg1cl c1 mnfxr
        a1i wral 1nn ralrimiva wceq fveq2 feq1d rspcv mpsyl itg2ge0 mnflt ax-mp
        0re 0xr xrltletr mp3an12 mpani mpd fveq2d fvex fvmpt fnfvelrn syl5eqelr
        wi wfn ffn supxrub syl2anc syl6breqr xrltletrd wn xrltnle mpbird xrltle
        wb rexrd xrre syl22anc ) AERSZDUAUBZUCSZUDEUEUFEXSUGUFZEUCSAEFTFUHZGUBZ
        UIUBZUJZUKZRUEUOZRNAYFRULZYGRSATRYEUMZYHAFTYDRYEAYBTSUNZUCUPUQURUSZYCUM
        ZYDRSYJUCUPUQUTUSZYCUMYMYKULYLKBYMYKBUHZUCSZUPYNUGUFZUNYNRSZYPUNYNYMSYN
        YKSYOYQYPYNVGVAYNVBYNVCVDVEUCYMYKYCVHVFZYCVIVJYEVKZVLZTRYEVMVJZYFVNVJVO
        ZADUAVPSXTODVQVJZAUDVRGUBZUIUBZEUDRSZAVSVTAUCYKUUDUMZUUERSZVRTSZAYLFTWA
        UUGWBAYLFTYRWCYLUUGFVRTYBVRWDZUCYKYCUUDYBVRGWEZWFWGWHZUUDVIVJZUUBAUPUUE
        UGUFZUDUUEUEUFZAUUGUUNUULUUDWIVJAUDUPUEUFZUUNUUOUPUCSUUPWLUPWJWKAUUHUUP
        UUNUNUUOXCZUUMUUFUPRSUUHUUQVSWMUDUPUUEWNWOVJWPWQAUUEYGEUGAYHUUEYFSUUEYG
        UGUFUUAAUUEVRYEUBZYFUUIUURUUEWDWBFVRYDUUETYEUUJYCUUDUIUUKWRYSUUDUIWSWTW
        KAYETXDZUUIUURYFSAYIUUSYTTRYEXEVJWBTVRYEXAVFXBYFUUEXFXGNXHXIAEXSUEUFZYA
        AUUTXSEUGUFXJZQAXRXSRSZUUTUVAXNUUBAXSUUCXOZEXSXKXGXLAXRUVBUUTYAXCUUBUVC
        EXSXMXGWQEXSXPXQ $.

      $( Lemma for ~ itg2mono .  (Contributed by Mario Carneiro,
         16-Aug-2014.) $)
      itg2monolem3 $p |- ( ph -> ( S.1 ` P ) <_ S ) $=
        ( wbr wcel c1 vt citg1 cfv cle cv caddc crp wral cmul cdiv itg2monolem2
        co wa cr adantr recnd cdm itg1cl syl simpr rpred readdcld cc0 0re citg2
        a1i cxr 0xr cpnf cicc wf cn 1nn cico wss anim1i elrege0 elxrge0 3imtr4i
        rexr ssriv fss sylancl ralrimiva wceq fveq2 feq1d rspcv itg2cl cmpt crn
        mpsyl clt csup eqid fmptd frn supxrcl syl5eqel itg2ge0 fvex fvmpt ax-mp
        fveq2d wfn fnfvelrn syl5eqelr supxrub syl2anc syl6breqr xrletrd lelttrd
        ffn ltaddrpd gt0ne0d div23d c2 cif redivcld remulcld 1re rehalfcli ifcl
        max2 sylancr wb rexrd xrltnle mpbird lemul1 syl112anc crab cmbf adantlr
        wn mpbid cofr wrex ltletrd breq1 cioo halfgt0 mulid1d breqtrrd ltdivmul
        max1 halflt1 ifboth rexri elioo2 mp2an syl3anbrc oveq2d breq12d cbvrabv
        w3a mpteq2i itg2monolem1 letrd eqbrtrd ledivmul2 mulgt0d lemul2 alrple
        ) ADUBUCZEUDRZUVEEUAUEZUFULZUDRZUAUGUHZAUVIUAUGAUVGUGSZUMZUVIEUVEUIULZE
        UVHUIULUDRZUVLUVMUVHUJULZEUDRZUVNUVLUVOEUVHUJULZUVEUIULZEUDUVLEUVEUVHUV
        LEAEUNSZUVKABCDEFGHIJKLMNOPQUKZUOZUPUVLUVEUVLDUBUQSZUVEUNSZAUWBUVKOUOZD
        URZUSZUPUVLUVHUVLEUVGUWAUVLUVGAUVKUTZVAVBZUPZUVLUVHUVLVCEUVHVCUNSUVLVDV
        FZUWAUWHAVCEUDRUVKAVCTGUCZVEUCZEVCVGSZAVHVFAUNVCVIVJULZUWKVKZUWLVGSTVLS
        ZAUNUWNFUEZGUCZVKZFVLUHUWOVMAUWSFVLAUWQVLSZUMZUNVCVIVNULZUWRVKZUXBUWNVO
        UWSKBUXBUWNBUEZUNSZVCUXDUDRZUMUXDVGSZUXFUMUXDUXBSUXDUWNSUXEUXGUXFUXDVTV
        PUXDVQUXDVRVSWAUNUXBUWNUWRWBWCZWDUWSUWOFTVLUWQTWEZUNUWNUWRUWKUWQTGWFZWG
        WHWLZUWKWIUSAEFVLUWRVEUCZWJZWKZVGWMWNZVGNAUXNVGVOZUXOVGSAVLVGUXMVKZUXPA
        FVLUXLVGUXMUXAUWSUXLVGSUXHUWRWIUSUXMWOZWPZVLVGUXMWQUSZUXNWRUSWSZAUWOVCU
        WLUDRUXKUWKWTUSAUWLUXOEUDAUXPUWLUXNSUWLUXOUDRUXTAUWLTUXMUCZUXNUWPUYBUWL
        WEVMFTUXLUWLVLUXMUXIUWRUWKVEUXJXDUXRUWKVEXAXBXCAUXMVLXEZUWPUYBUXNSAUXQU
        YCUXSVLVGUXMXMUSVMVLTUXMXFWCXGUXNUWLXHXINXJXKUOZUVLEUVGUWAUWGXNZXLZXOZX
        PUVLUVRTXQUJULZUVQUDRZUVQUYHXRZUVEUIULZEUVLUVQUVEUVLEUVHUWAUWHUYGXSZUWF
        XTUVLUYJUVEUVLUVQUNSZUYHUNSZUYJUNSZUYLTYAYBZUYIUVQUYHUNYCWCZUWFXTZUWAUV
        LUVQUYJUDRZUVRUYKUDRZUVLUYNUYMUYSUYPUYLUYHUVQYDYEUVLUYMUYOUWCVCUVEWMRUY
        SUYTYFUYLUYQUWFUVLVCEUVEUWJUWAUWFUYDAEUVEWMRZUVKAVUAUVFYOZQAEVGSUVEVGSV
        UAVUBYFUYAAUVEAUWBUWCOUWEUSZYGEUVEYHXIYIUOXLZUVQUYJUVEYJYKYPUVLBCFVLUYJ
        CUEZDUCZUIULZVUEUWRUCZUDRZCUNYLZWJEUYJFGHDIAUWTUWRYMSUVKJYNAUWTUXCUVKKY
        NAUWTUWRUWQTUFULGUCUDYQZRUVKLYNAUXEUXDUWRUCZVUEUDRFVLUHCUNYRUVKMYNNUVLU
        YOVCUYJWMRZUYJTWMRZUYJVCTUUAULSZUYQUVLVCUYHUYJUWJUYNUVLUYPVFUYQVCUYHWMR
        UVLUUBVFUVLUYNUYMUYHUYJUDRUYPUYLUYHUVQUUFYEYSZUVLUVQTWMRZUYHTWMRZVUNUVL
        VUQEUVHTUIULZWMRZUVLEUVHVUSWMUYEUVLUVHUWIUUCUUDUVLUVSTUNSZUVHUNSZVCUVHW
        MRZVUQVUTYFUWAVVAUVLYAVFUWHUYFETUVHUUEYKYIUUGUYIVUQVURVUNUVQUYHUVQUYJTW
        MYTUYHUYJTWMYTUUHWCUWMTVGSVUOUYOVUMVUNUUPYFVHTYAUUIVCTUYJUUJUUKUULUWDAD
        HVUKRUVKPUOUWAFVLVUJUYJUXDDUCZUIULZVULUDRZBUNYLVUIVVFCBUNVUEUXDWEZVUGVV
        EVUHVULUDVVGVUFVVDUYJUIVUEUXDDWFUUMVUEUXDUWRWFUUNUUOUUQUURZUUSUUTUVLUVM
        UNSUVSVVBVVCUVPUVNYFUVLEUVEUWAUWFXTUWAUWHUYFUVMEUVHUVAYKYPUVLUWCVVBUVSV
        CEWMRUVIUVNYFUWFUWHUWAUVLVCUYKEUWJUYRUWAUVLUYJUVEUYQUWFVUPVUDUVBVVHYSUV
        EUVHEUVCYKYIWDAUWCUVSUVFUVJYFVUCUVTUAUVEEUVDXIYI $.
    $}

    $( The Monotone Convergence Theorem for nonnegative functions.  If
       ` { ( F `` n ) : n e. NN } ` is a monotone increasing sequence of
       positive, measurable, real-valued functions, and ` G ` is the pointwise
       limit of the sequence, then ` ( S.2 `` G ) ` is the limit of the
       sequence ` { ( S.2 `` ( F `` n ) ) : n e. NN } ` .  (Contributed by
       Mario Carneiro, 16-Aug-2014.) $)
    itg2mono $p |- ( ph -> ( S.2 ` G ) = S ) $=
      ( vm cfv cle wbr wcel cn cr vf vz citg2 wceq cv cofr citg1 wi cdm wral wa
      wn cmbf adantlr cc0 cpnf cico co wf c1 caddc simprll simprlr itg2monolem3
      wrex simprr expr pm2.18d ralrimiva cicc cxr cmpt crn clt csup wss wne 0re
      wb pnfxr icossre mp2an fss sylancl ffvelrnda an32s eqid fmptd frn syl 1nn
      c0 fdm syl5eleqr ne0i dm0rn0 necon3bii sylib wfn breq1 ralrn fveq2 fveq1d
      ffn fvex fvmpt breq1d ralbiia cbvralv bitr4i syl6bb rexbidv mpbird suprcl
      weq syl3anc rexrd feq1d rspcv mpsyl elrege0 simpld simprd ax-mp syl5eqelr
      a1i fnfvelrn suprub syl31anc letrd elxrge0 sylanbrc anim1i 3imtr4i itg2cl
      rexr syl2anc adantr cvv eqidd supxrcl syl5eqel itg2leub r19.21bi w3a 3jca
      ssriv ad2antlr simplr eqeltrrd simpr ltso supex fvmpt2 breq12d reex inidm
      breqtrrd ofrfval itg2le fveq2d supxrleub syl5eqbr xrletri3 mpbir2and ) AG
      UCOZDUDZUVFDPQZDUVFPQZAUVHUAUEZGPUFZQZUVJUGODPQZUHZUAUGUIZUJZAUVNUAUVOAUV
      JUVORZUVLUVMAUVQUVLUKZUKUVMAUVRUVMULZUVMAUVRUVSUKZUKBCUVJDEFGHAEUEZSRZUWA
      FOZUMRUVTIUNAUWBTUOUPUQURZUWCUSZUVTJUNAUWBUWCUWAUTVAURFOUVKQUVTKUNABUEZTR
      ZUWFUWCOZCUEZPQZESUJZCTVEZUVTLUNMAUVQUVLUVSVBAUVQUVLUVSVCAUVRUVSVFVDVGVHV
      GVIATUOUPVJURZGUSZDVKRZUVHUVPVSABTESUWHVLZVMZTVNVOZUWMGAUWGUKZUWRVKRUOUWR
      PQUWRUWMRUWSUWRUWSUWQTVPZUWQWLVQZUBUEZUWIPQZUBUWQUJZCTVEZUWRTRUWSSTUWPUSZ
      UWTUWSESUWHTUWPAUWBUWGUWHTRAUWBUKZTTUWFUWCUXGUWEUWDTVPZTTUWCUSJUOTRZUPVKR
      UXHVRVTUOUPWAWBTUWDTUWCWCWDWEWFUWPWGZWHZSTUWPWIWJZUWSUWPUIZWLVQZUXAUWSUTU
      XMRUXNUWSUTSUXMWKUWSUXFUXMSUDUXKSTUWPWMWJWNUXMUTWOWJUXMWLUWQWLUWPWPWQWRZU
      WSUXEUWLLUWSUXDUWKCTUWSUXDNUEZUWPOZUWIPQZNSUJZUWKUWSUWPSWSZUXDUXSVSUWSUXF
      UXTUXKSTUWPXDWJZUXCUXRUBNSUWPUXBUXQUWIPWTXAWJUXSUWFUXPFOZOZUWIPQZNSUJUWKU
      XRUYDNSUXPSRZUXQUYCUWIPEUXPUWHUYCSUWPENXOZUWFUWCUYBUWAUXPFXBZXCZUXJUWFUYB
      XEXFZXGXHUWJUYDENSUYFUWHUYCUWIPUYHXGXIXJXKXLXMZCUBUWQXNXPZXQUWSUOUWFUTFOZ
      OZUWRUXIUWSVRYFUWSUYMTRZUOUYMPQZUWSUYMUWDRUYNUYOUKATUWDUWFUYLUTSRZAUWEESU
      JZTUWDUYLUSZWKAUWEESJVIZUWEUYREUTSUWAUTUDZTUWDUWCUYLUWAUTFXBZXRXSXTWEUYMY
      AWRZYBUYKUWSUYNUYOVUBYCUWSUWTUXAUXEUYMUWQRUYMUWRPQUXLUXOUYJUWSUYMUTUWPOZU
      WQUYPVUCUYMUDWKEUTUWHUYMSUWPUYTUWFUWCUYLVUAXCUXJUWFUYLXEXFYDUWSUXTUYPVUCU
      WQRUYAWKSUTUWPYGWDYECUBUWQUYMYHYIYJUWRYKYLHWHZADESUWCUCOZVLZVMZVKVNVOZVKM
      AVUGVKVPZVUHVKRASVKVUFUSZVUIAESVUEVKVUFUXGTUWMUWCUSZVUEVKRUXGUWEUWDUWMVPZ
      VUKJBUWDUWMUWGUOUWFPQZUKUWFVKRZVUMUKUWFUWDRUWFUWMRUWGVUNVUMUWFYPYMUWFYAUW
      FYKYNUUGZTUWDUWMUWCWCWDUWCYOWJVUFWGZWHZSVKVUFWIWJZVUGUUAWJUUBZDUAGUUCYQXM
      ADVUHUVFPMAVUHUVFPQZUXBUVFPQZUBVUGUJZAVVBUYBUCOZUVFPQZNSUJZAVVDNSAUYEUKZT
      UWMUYBUSZUWNUYBGUVKQZVVDVVFTUWDUYBUSZVULVVGAVVINSAUYQVVINSUJUYSUWEVVIENSU
      YFTUWDUWCUYBUYGXRXIWRUUDVUOTUWDUWMUYBWCWDZAUWNUYEVUDYRVVFVVHUXBUYBOZUXBGO
      ZPQZUBTUJZVVFUYCUWFGOZPQZBTUJVVNVVFVVPBTVVFUWGUKZUYCUWRVVOPVVQUWTUXAUXEUU
      EZUYCUWQRUYCUWRPQAUWGVVRUYEUWSUWTUXAUXEUXLUXOUYJUUFUNVVQUXQUYCUWQUYEUXQUY
      CUDAUWGUYIUUHVVQUXTUYEUXQUWQRAUWGUXTUYEUYAUNAUYEUWGUUISUXPUWPYGYQUUJCUBUW
      QUYCYHYQVVQUWGUWRYSRVVOUWRUDVVFUWGUUKTUWQVNUULUUMBTUWRYSGHUUNWDUURVIVVPVV
      MBUBTBUBXOUYCVVKVVOVVLPUWFUXBUYBXBUWFUXBGXBUUOXIWRVVFUBTTVVKVVLPTUYBGYSYS
      VVFVVGUYBTWSVVJTUWMUYBXDWJAGTWSZUYEATTGUSVVSABTUWRTGUYKHWHTTGXDWJYRTYSRVV
      FUUPYFZVVTTUUQVVFUXBTRUKZVVKYTVWAVVLYTUUSXMUYBGUUTXPVIAVVBUXPVUFOZUVFPQZN
      SUJZVVEAVUFSWSZVVBVWDVSAVUJVWEVUQSVKVUFXDWJVVAVWCUBNSVUFUXBVWBUVFPWTXAWJV
      WCVVDNSUYEVWBVVCUVFPEUXPVUEVVCSVUFUYFUWCUYBUCUYGUVAVUPUYBUCXEXFXGXHXKXMAV
      UIUVFVKRZVUTVVBVSVURAUWNVWFVUDGYOWJZUBVUGUVFUVBYQXMUVCAVWFUWOUVGUVHUVIUKV
      SVWGVUSUVFDUVDYQUVE $.
  $}

  ${
    $d k m n x y z F $.  $d k n y z M $.  $d k m n x y z P $.  $d k m y z ph $.
    $d k y z S $.
    itg2i1fseq.1 $e |- ( ph -> F e. MblFn ) $.
    itg2i1fseq.2 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    itg2i1fseq.3 $e |- ( ph -> P : NN --> dom S.1 ) $.
    itg2i1fseq.4 $e |- ( ph -> A. n e. NN
      ( 0p oR <_ ( P ` n ) /\ ( P ` n ) oR <_ ( P ` ( n + 1 ) ) ) ) $.
    itg2i1fseq.5 $e |- ( ph -> A. x e. RR
      ( n e. NN |-> ( ( P ` n ) ` x ) ) ~~> ( F ` x ) ) $.
    $( Subject to the conditions coming from ~ mbfi1fseq , the sequence of
       simple functions are all less than the target function ` F ` .
       (Contributed by Mario Carneiro, 17-Aug-2014.) $)
    itg2i1fseqle $p |- ( ( ph /\ M e. NN ) -> ( P ` M ) oR <_ F ) $=
      ( vy cn wcel wa cfv cle wbr cr wceq vk cofr cv wral cmpt fveq1d eqid fvex
      fveq2 fvmpt ad2antlr c1 simplr cli mpteq2dv breq12d rspccva sylan adantlr
      nnuz adantl citg1 cdm ffvelrnda i1ff syl an32s eqeltrd adantllr caddc c0p
      wf co simpr ralimi oveq1 fveq2d cvv wfn 3syl peano2nn ffvelrn syl2an reex
      ffn a1i inidm eqidd ofrfval mpbid r19.21bi 3brtr4d eqbrtrrd ralrimiva cc0
      climub cpnf cicc cico wss cxr rexr anim1i elrege0 elxrge0 3imtr4i sylancl
      ssriv fss adantr mpbird ) AFMNZOZFCPZEQUBZRLUCZXNPZXPEPZQRZLSUDXMXSLSXMXP
      SNZOZFDMXPDUCZCPZPZUEZPZXQXRQXLYFXQTAXTDFYDXQMYEYBFTXPYCXNYBFCUIUFYEUGZXP
      XNUHUJUKYAXRUAYEULFMUTAXLXTUMAXTYEXRUNRZXLADMBUCZYCPZUEZYIEPZUNRZBSUDXTYH
      KYMYHBXPSYIXPTZYKYEYLXRUNYNDMYJYDYIXPYCUIUOYIXPEUIUPUQURUSAXTUAUCZMNZYOYE
      PZSNXLAXTOZYPOZYQXPYOCPZPZSYPYQUUATYRDYOYDUUAMYEYBYOTZXPYCYTYBYOCUIZUFYGX
      PYTUHUJVAZAYPXTUUASNAYPOZSSXPYTUUEYTVBVCZNZSSYTVLZAMUUFYOCIVDZYTVEZVFVDVG
      VHVIAXTYPYQYOULVJVMZYEPZQRXLYSUUAXPUUKCPZPZYQUULQAYPXTUUAUUNQRZUUEUUOLSUU
      EYTUUMXORZUUOLSUDAYCYBULVJVMZCPZXORZDMUDZYPUUPAVKYCXORZUUSOZDMUDUUTJUVBUU
      SDMUVAUUSVNVOVFUUSUUPDYOMUUBYCYTUURUUMXOUUCUUBUUQUUKCYBYOULVJVPVQUPUQURUU
      ELSSUUAUUNQSYTUUMVRVRUUEUUGUUHYTSVSUUIUUJSSYTWEVTUUEUUMUUFNZSSUUMVLUUMSVS
      AMUUFCVLUUKMNZUVCYPIYOWAZMUUFUUKCWBWCUUMVESSUUMWEVTSVRNZUUEWDWFZUVGSWGZUU
      EXTOZUUAWHUVIUUNWHWIWJWKVGUUDYPUULUUNTZYRYPUVDUVJUVEDUUKYDUUNMYEYBUUKTXPY
      CUUMYBUUKCUIUFYGXPUUMUHUJVFVAWLVIWPWMWNXMLSSXQXRQSXNEVRVRXMXNUUFNSSXNVLXN
      SVSAMUUFFCIVDXNVESSXNWEVTAESVSZXLASWOWQWRVMZEVLZUVKASWOWQWSVMZEVLUVNUVLWT
      UVMHBUVNUVLYISNZWOYIQRZOYIXANZUVPOYIUVNNYIUVLNUVOUVQUVPYIXBXCYIXDYIXEXFXH
      SUVNUVLEXIXGSUVLEWEVFXJUVFXMWDWFZUVRUVHYAXQWHYAXRWHWIXK $.

    itg2i1fseq.6 $e |- S = ( m e. NN |-> ( S.1 ` ( P ` m ) ) ) $.
    $( Subject to the conditions coming from ~ mbfi1fseq , the integral of the
       sequence of simple functions converges to the integral of the target
       function.  (Contributed by Mario Carneiro, 17-Aug-2014.) $)
    itg2i1fseq $p |- ( ph -> ( S.2 ` F ) = sup ( ran S , RR* , < ) ) $=
      ( vy cfv cr cn cmpt wcel wbr citg2 crn clt csup cxr cc0 cpnf cico feqmptd
      vz cv co wa wceq fveq2 fveq1d cbvmptv rneqi supeq1i cli c1 nnuz cz 1z a1i
      citg1 cdm wf ffvelrnda i1ff syl an32s fmptd caddc cle cofr wral c0p oveq1
      breq2d fveq2d breq12d anbi12d rspccva simprd cvv wfn ffn peano2nn ffvelrn
      sylan syl2an reex inidm eqidd ofrfval mpbid r19.21bi fvmpt adantl 3brtr4d
      eqid fvex wrex wss 0re pnfxr icossre sseldi itg2i1fseqle adantr ralrimiva
      mp2an breq2 ralbidv rspcev syl2anc breq1d ralbiia rexbii climsup mpteq2dv
      sylibr climuni syl5eqr mpteq2dva eqtr4d supeq1d syl6eqr itg2itg1 syl6reqr
      syl5eq rneqd simpld cmbf i1fmbf 0plef sylanbrc itg2mono ) AGUAOBPFQBUKZFU
      KZCOZOZRZUBZPUCUDZRZUAOZDUBZUEUCUDZAGUUGUAAGNPEQNUKZEUKZCOZOZRZUBZPUCUDZR
      ZUUGAGNPUUKGOZRUURANPUFUGUHULZGIUIANPUUQUUSAUUKPSZUMZUUQFQUUKUUBOZRZUBZPU
      CUDZUUSPUVEUUPUCUVDUUOFEQUVCUUNUUAUULUNZUUKUUBUUMUUAUULCUOZUPZUQZURUSUVBU
      VDUVFUTTUVDUUSUTTZUVFUUSUNUVBUJEUVDVAQVBVAVCSUVBVDVEUVBEQUUNPUVDAUULQSZUV
      AUUNPSAUVLUMZPPUUKUUMUVMUUMVFVGZSZPPUUMVHZAQUVNUULCJVIZUUMVJVKZVIVLUVJVMU
      VBUVLUMUUNUUKUULVAVNULZCOZOZUULUVDOZUVSUVDOZVOAUVLUVAUUNUWAVOTZUVMUWDNPUV
      MUUMUVTVOVPZTZUWDNPVQUVMVRUUMUWETZUWFAVRUUBUWETZUUBUUAVAVNULZCOZUWETZUMZF
      QVQUVLUWGUWFUMZKUWLUWMFUULQUVGUWHUWGUWKUWFUVGUUBUUMVRUWEUVHVTUVGUUBUUMUWJ
      UVTUWEUVHUVGUWIUVSCUUAUULVAVNVSWAWBWCWDWKZWEZUVMNPPUUNUWAVOPUUMUVTWFWFUVM
      UVPUUMPWGUVRPPUUMWHVKZUVMPPUVTVHZUVTPWGUVMUVTUVNSZUWQAQUVNCVHUVSQSZUWRUVL
      JUULWIZQUVNUVSCWJWLUVTVJVKPPUVTWHVKPWFSUVMWMVEZUXAPWNZUVMUVAUMZUUNWOZUXCU
      WAWOWPWQWRVLUVLUWBUUNUNUVBFUULUVCUUNQUVDUVIUVDXBZUUKUUMXCWSZWTUVLUWCUWAUN
      ZUVBUVLUWSUXGUWTFUVSUVCUWAQUVDUUAUVSUNUUKUUBUVTUUAUVSCUOUPUXEUUKUVTXCWSVK
      WTXAUVBUUNUJUKZVOTZEQVQZUJPXDZUWBUXHVOTZEQVQZUJPXDUVBUUSPSUUNUUSVOTZEQVQZ
      UXKUVBUUTPUUSUFPSUGUESUUTPXEXFXGUFUGXHXMAPUUTUUKGIVIXIUVBUXNEQAUVLUVAUXNU
      VMUXNNPUVMUUMGUWETUXNNPVQABCFGUULHIJKLXJUVMNPPUUNUUSVOPUUMGWFWFUWPAGPWGZU
      VLAPUUTGVHUXPIPUUTGWHVKXKUXAUXAUXBUXDUXCUUSWOWPWQWRVLXLUXJUXOUJUUSPUXHUUS
      UNUXIUXNEQUXHUUSUUNVOXNXOXPXQZUXMUXJUJPUXLUXIEQUVLUWBUUNUXHVOUXFXRXSXTYCY
      AAUUDYTGOZUTTZBPVQUVAUVKLUXSUVKBUUKPYTUUKUNZUUDUVDUXRUUSUTUXTFQUUCUVCYTUU
      KUUBUOYBYTUUKGUOWBWDWKUVFUUSUVDYDXQYEYFYGBNPUUFUUQUXTPUUEUUPUCUXTUUDUUOUX
      TUUDEQYTUUMOZRUUOFEQUUCUYAUVGYTUUBUUMUVHUPUQUXTEQUYAUUNYTUUKUUMUOYBYLYMYH
      UQZYIWAAUUJFQUUBUAOZRZUBZUEUCUDZUUHAUEUUIUYEUCADUYDADEQUUMUAOZRZUYDAUYHEQ
      UUMVFOZRDAEQUYGUYIUVMUVOUWGUYGUYIUNUVQUVMUWGUWFUWNYNZUUMYJXQYFMYKFEQUYCUY
      GUVGUUBUUMUAUVHWAUQZYIYMYHANUJUYFECUUGUYBUVMUVOUUMYOSUVQUUMYPVKUVMUVPUWGP
      UUTUUMVHUVRUYJUUMYQYRUWOUXQUEUYEUYHUBUCUYDUYHUYKURUSYSYGYG $.

    ${
      itg2i1fseq2.7 $e |- ( ph -> M e. RR ) $.
      itg2i1fseq2.8 $e |- ( ( ph /\ k e. NN ) -> ( S.1 ` ( P ` k ) ) <_ M ) $.
      $( In an extension to the results of ~ itg2i1fseq , if there is an upper
         bound on the integrals of the simple functions approaching ` F ` ,
         then ` S.2 F ` is real and the standard limit relation applies.
         (Contributed by Mario Carneiro, 17-Aug-2014.) $)
      itg2i1fseq2 $p |- ( ph -> S ~~> ( S.2 ` F ) ) $=
        ( cr cfv cn vz vy crn clt csup citg2 cli c1 nnuz cz wcel 1z cv citg1 wa
        a1i cdm ffvelrnda itg1cl syl fmptd caddc co cle wbr wf peano2nn ffvelrn
        cofr syl2an wral c0p simpr ralimi wceq fveq2 oveq1 fveq2d breq12d sylan
        rspccva itg1le syl3anc fvex fvmpt adantl 3brtr4d wrex eqbrtrd ralrimiva
        breq2 ralbidv rspcev syl2anc climsup cxr itg2i1fseq wss wne frn fdm 1nn
        c0 ne0i mp1i eqnetrd dm0rn0 necon3bii sylib wfn wb ffn breq1 ralrn 3syl
        rexbidv mpbird supxrre eqtrd breqtrrd ) ADDUCZRUDUEZHUFSZUGAUAEDUHTUIUH
        UJUKAULUPAFTFUMZCSZUNSZRDAYDTUKUOYEUNUQZUKYFRUKATYGYDCLURYEUSUTOVAZAEUM
        ZTUKZUOZYICSZUNSZYIUHVBVCZCSZUNSZYIDSZYNDSZVDYKYLYGUKYOYGUKZYLYOVDVIZVE
        ZYMYPVDVEATYGYICLURATYGCVFYNTUKZYSYJLYIVGZTYGYNCVHVJAGUMZCSZUUDUHVBVCZC
        SZYTVEZGTVKZYJUUAAVLUUEYTVEZUUHUOZGTVKUUIMUUKUUHGTUUJUUHVMVNUTUUHUUAGYI
        TUUDYIVOZUUEYLUUGYOYTUUDYICVPUULUUFYNCUUDYIUHVBVQVRVSWAVTYLYOWBWCYJYQYM
        VOAFYIYFYMTDYDYIVOYEYLUNYDYICVPVROYLUNWDWEWFZYJYRYPVOZAYJUUBUUNUUCFYNYF
        YPTDYDYNVOYEYOUNYDYNCVPVROYOUNWDWEUTWFWGAIRUKYQIVDVEZETVKZYQUAUMZVDVEZE
        TVKZUARWHZPAUUOETYKYQYMIVDUUMQWIWJUUSUUPUAIRUUQIVOUURUUOETUUQIYQVDWKWLW
        MWNZWOAYCYAWPUDUEZYBABCDFGHJKLMNOWQAYARWRZYAXCWSZUBUMZUUQVDVEZUBYAVKZUA
        RWHZUVBYBVOATRDVFZUVCYHTRDWTUTADUQZXCWSUVDAUVJTXCAUVIUVJTVOYHTRDXAUTUHT
        UKTXCWSAXBTUHXDXEXFUVJXCYAXCDXGXHXIAUVHUUTUVAAUVGUUSUARAUVIDTXJUVGUUSXK
        YHTRDXLUVFUURUBETDUVEYQUUQVDXMXNXOXPXQUAUBYAXRWCXSXT $.
    $}

    itg2i1fseq3.7 $e |- ( ph -> ( S.2 ` F ) e. RR ) $.
    $( Special case of ~ itg2i1fseq2 : if the integral of ` F ` is a real
       number, then the standard limit relation holds on the integrals of
       simple functions approaching ` F ` .  (Contributed by Mario Carneiro,
       17-Aug-2014.) $)
    itg2i1fseq3 $p |- ( ph -> S ~~> ( S.2 ` F ) ) $=
      ( cfv wcel wa cr cc0 cle vk citg2 cv cn cpnf cicc co wf cdm cofr wbr cico
      citg1 wss cxr rexr anim1i elrege0 elxrge0 3imtr4i ssriv sylancl ffvelrnda
      fss adantr itg2i1fseqle itg2ub syl3anc itg2i1fseq2 ) ABCDUAEFGGUBOZHIJKLM
      NAUAUCZUDPZQRSUEUFUGZGUHZVKCOZUMUIZPVOGTUJUKVOUMOVJTUKAVNVLARSUEULUGZGUHV
      QVMUNVNIBVQVMBUCZRPZSVRTUKZQVRUOPZVTQVRVQPVRVMPVSWAVTVRUPUQVRURVRUSUTVARV
      QVMGVDVBVEAUDVPVKCJVCABCFGVKHIJKLVFGVOVGVHVI $.
  $}

  ${
    $d f g j k m n x y z F $.  $d f g j k m n x y P $.  $d f g j k m n x y Q $.
    $d f g j k m n x y z G $.  $d f g j k m y z ph $.
    itg2add.f1 $e |- ( ph -> F e. MblFn ) $.
    itg2add.f2 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    itg2add.f3 $e |- ( ph -> ( S.2 ` F ) e. RR ) $.
    itg2add.g1 $e |- ( ph -> G e. MblFn ) $.
    itg2add.g2 $e |- ( ph -> G : RR --> ( 0 [,) +oo ) ) $.
    itg2add.g3 $e |- ( ph -> ( S.2 ` G ) e. RR ) $.
    ${
      itg2add.p1 $e |- ( ph -> P : NN --> dom S.1 ) $.
      itg2add.p2 $e |- ( ph -> A. n e. NN
        ( 0p oR <_ ( P ` n ) /\ ( P ` n ) oR <_ ( P ` ( n + 1 ) ) ) ) $.
      itg2add.p3 $e |- ( ph -> A. x e. RR
        ( n e. NN |-> ( ( P ` n ) ` x ) ) ~~> ( F ` x ) ) $.
      itg2add.q1 $e |- ( ph -> Q : NN --> dom S.1 ) $.
      itg2add.q2 $e |- ( ph -> A. n e. NN
        ( 0p oR <_ ( Q ` n ) /\ ( Q ` n ) oR <_ ( Q ` ( n + 1 ) ) ) ) $.
      itg2add.q3 $e |- ( ph -> A. x e. RR
        ( n e. NN |-> ( ( Q ` n ) ` x ) ) ~~> ( G ` x ) ) $.
      $( Lemma for ~ itg2add .  (Contributed by Mario Carneiro,
         17-Aug-2014.) $)
      itg2addlem $p |- ( ph ->
        ( S.2 ` ( F oF + G ) ) = ( ( S.2 ` F ) + ( S.2 ` G ) ) ) $=
        ( cr vy vk vj vm vz vf vg cn cv caddc cof cfv citg1 cmpt citg2 cli wceq
        co wbr mbfadd cc0 cpnf cico cvv wcel ge0addcl adantl reex a1i inidm off
        wa cdm simpl simpr i1fadd nnex c0p cle c1 wf ffvelrnda weq fveq2 breq2d
        wral fveq2d breq12d anbi12d rspccva sylan simpld breq2 feq1 imbi12d wfn
        wi i1ff ffn syl adantr cc wss eqidd ofrfval elrege0 vtoclga sylc simprd
        ofval breqtrrd ffvelrn syl2an r19.21bi le2addd ralrimiva fveq1d cbvmptv
        mpbid nnuz mpteq2dv mptex eqid fvex fvmpt an32s eqeltrd oveq12d 3eqtr4d
        recnd eqtrd climadd itg1cl fss sylancl itg2i1fseqle syl3anc itg2i1fseq3
        1z itg2ub cofr oveq1 csn cxp 0cn fnconstg ax-mp df-0p fneq1i mpbir cnex
        cin ax-resscn sseqin2 mpbi biimpa simplbi2 ralimdva imp syldan sylanbrc
        0pval ffnfv ex 0plef sylib peano2nn mpbird sylan2 3brtr4d jca syl5eqbrr
        3syl cz readdcld itg1add cicc rexr anim1i elxrge0 3imtr4i ssriv eqbrtrd
        cxr breq1d itg2i1fseq2 climuni syl2anc ) AEUHEUIZCDUJUKZUKURZULZUMULZUN
        ZFGUWJURZUOULZUPUSUWNFUOULZGUOULZUJURZUPUSUWPUWSUQAUAUWKUWNUBUCUDUWOUWS
        AFGHKUTAUAUETTTUJVAVBVCURZUWTUWTFGVDVDUAUIZUWTVEUEUIZUWTVEVLUXAUXBUJURU
        WTVEAUXAUXBVFVGILTVDVEZAVHVIZUXDTVJZVKAUFUGUHUHUHUWJUMVMZUXFUXFCDVDVDUF
        UIZUXFVEZUGUIZUXFVEZVLZUXGUXIUWJURUXFVEAUXKUXGUXIUXHUXJVNUXHUXJVOVPVGNQ
        UHVDVEAVQVIZUXLUHVJZVKAVRUDUIZUWKULZVSUUAZUSZUXOUXNVTUJURZUWKULZUXPUSZV
        LUDUHAUXNUHVEZVLZUXQUXTUYBVRUXNCULZUXNDULZUWJURZUXOUXPUYBTTUYEWAZVRUYEU
        XPUSZUYBTUWTUYEWAUYFUYGVLUYBUFUGTTTUJUWTUWTUWTUYCUYDVDVDUXGUWTVEUXIUWTV
        EVLUXGUXIUJURUWTVEUYBUXGUXIVFVGUYBUYCUXFVEZVRUYCUXPUSZTUWTUYCWAZAUHUXFU
        XNCNWBZUYBUYIUYCUXRCULZUXPUSZAVRUWICULZUXPUSZUYNUWIVTUJURZCULZUXPUSZVLZ
        EUHWFUYAUYIUYMVLZOUYSUYTEUXNUHEUDWCZUYOUYIUYRUYMVUAUYNUYCVRUXPUWIUXNCWD
        ZWEVUAUYNUYCUYQUYLUXPVUBVUAUYPUXRCUWIUXNVTUJUUBZWGWHWIWJWKZWLVRUXGUXPUS
        ZTUWTUXGWAZWQZUYIUYJWQUFUYCUXFUXGUYCUQVUEUYIVUFUYJUXGUYCVRUXPWMTUWTUXGU
        YCWNWOUXHVUEVUFUXHVUEVLUXGTWPZBUIZUXGULZUWTVEZBTWFZVUFUXHVUHVUEUXHTTUXG
        WAVUHUXGWRZTTUXGWSWTZXAUXHVUEVAVUJVSUSZBTWFZVULUXHVUEVUPUXHBXBTVAVUJVST
        VRUXGVDVDVRXBWPZUXHVUQXBVAUUCUUDZXBWPZVAXBVEVUSUUEXBVAXBUUFUUGXBVRVURUU
        HUUIUUJVIVUNXBVDVEUXHUUKVIUXCUXHVHVITXBXCXBTUULTUQUUMTXBUUNUUOVUIXBVEVU
        IVRULVAUQUXHVUIUVBVGUXHVUITVEZVLZVUJXDXEUUPUXHVUPVULUXHVUOVUKBTVVAVUJTV
        EZVUOVUKWQUXHTTVUIUXGVUMWBVUKVVBVUOVUJXFUUQWTUURUUSUUTBTUWTUXGUVCUVAUVD
        ZXGXHUYBUYDUXFVEZVRUYDUXPUSZTUWTUYDWAZAUHUXFUXNDQWBZUYBVVEUYDUXRDULZUXP
        USZAVRUWIDULZUXPUSZVVJUYPDULZUXPUSZVLZEUHWFUYAVVEVVIVLZRVVNVVOEUXNUHVUA
        VVKVVEVVMVVIVUAVVJUYDVRUXPUWIUXNDWDZWEVUAVVJUYDVVLVVHUXPVVPVUAUYPUXRDVU
        CWGWHWIWJWKZWLVUGVVEVVFWQUFUYDUXFUXGUYDUQVUEVVEVUFVVFUXGUYDVRUXPWMTUWTU
        XGUYDWNWOVVCXGXHUXCUYBVHVIZVVRUXEVKUYEUVEUVFXIAUHUHUYCUYDUWJUHCDVDVDUXN
        AUHUXFCWAZCUHWPNUHUXFCWSWTZAUHUXFDWAZDUHWPQUHUXFDWSWTZUXLUXLUXMUYBUYCXD
        UYBUYDXDXJZXKUYBUYEUYLVVHUWJURZUXOUXSUXPUYBUYEVWDUXPUSUXAUYCULZUXAUYDUL
        ZUJURZUXAUYLULZUXAVVHULZUJURZVSUSZUATWFUYBVWKUATUYBUXATVEZVLZVWEVWFVWHV
        WIUYBTTUXAUYCUYBUYHTTUYCWAZUYKUYCWRWTZWBZUYBTTUXAUYDUYBVVDTTUYDWAZVVGUY
        DWRWTZWBZUYBTTUXAUYLUYBUYLUXFVEZTTUYLWAZAVVSUXRUHVEZVWTUYANUXNUVGZUHUXF
        UXRCXLXMZUYLWRWTZWBUYBTTUXAVVHUYBVVHUXFVEZTTVVHWAZAVWAVXBVXFUYAQVXCUHUX
        FUXRDXLXMZVVHWRWTZWBUYBVWEVWHVSUSZUATUYBUYMVXJUATWFUYBUYIUYMVUDXIUYBUAT
        TVWEVWHVSTUYCUYLVDVDUYBVWNUYCTWPVWOTTUYCWSWTZUYBVXAUYLTWPVXETTUYLWSWTZV
        VRVVRUXEVWMVWEXDZVWMVWHXDZXEXSXNUYBVWFVWIVSUSZUATUYBVVIVXOUATWFUYBVVEVV
        IVVQXIUYBUATTVWFVWIVSTUYDVVHVDVDUYBVWQUYDTWPVWRTTUYDWSWTZUYBVXGVVHTWPVX
        ITTVVHWSWTZVVRVVRUXEVWMVWFXDZVWMVWIXDZXEXSXNXOXPUYBUATTVWGVWJVSTUYEVWDV
        DVDUYBUYEUXFVEUYFUYETWPUYBUYCUYDUYKVVGVPUYEWRTTUYEWSUVMUYBTTVWDWAZVWDTW
        PUYBVWDUXFVEVXTUYBUYLVVHVXDVXHVPVWDWRWTTTVWDWSWTVVRVVRUXEUYBTTVWEVWFUJT
        UYCUYDVDVDUXAVXKVXPVVRVVRUXEVXMVXRXJZUYBTTVWHVWIUJTUYLVVHVDVDUXAVXLVXQV
        VRVVRUXEVXNVXSXJXEUVHVWCUYAAVXBUXSVWDUQVXCAUHUHUYLVVHUWJUHCDVDVDUXRVVTV
        WBUXLUXLUXMAVXBVLZUYLXDVYBVVHXDXJUVIUVJUVKXPAUDUHUXAUXOULZUNZUXAUWOULZU
        PUSUATAVWLVLZVYDUXAFULZUXAGULZUJURZVYEUPVYFVYDEUHUXAUWLULZUNZVYIUPEUDUH
        VYJVYCVUAUXAUWLUXOUWIUXNUWKWDXQZXRVYFVYGVYHUDEUHUXAUYNULZUNZEUHUXAVVJUL
        ZUNZVYKVTVDUHXTVTUVNVEZVYFYSVIAEUHVUIUYNULZUNZVUIFULZUPUSZBTWFVWLVYNVYG
        UPUSZPWUAWUBBUXATBUAWCZVYSVYNVYTVYGUPWUCEUHVYRVYMVUIUXAUYNWDYAVUIUXAFWD
        WHWJWKVYKVDVEVYFEUHVYJVQYBVIAEUHVUIVVJULZUNZVUIGULZUPUSZBTWFVWLVYPVYHUP
        USZSWUGWUHBUXATWUCWUEVYPWUFVYHUPWUCEUHWUDVYOVUIUXAVVJWDYAVUIUXAGWDWHWJW
        KVYFUYAVLZUXNVYNULZWUIWUJVWETUYAWUJVWEUQVYFEUXNVYMVWEUHVYNVUAUXAUYNUYCV
        UBXQVYNYCUXAUYCYDYEVGZAUYAVWLVWETVEVWPYFYGYJWUIUXNVYPULZWUIWULVWFTUYAWU
        LVWFUQVYFEUXNVYOVWFUHVYPVUAUXAVVJUYDVVPXQVYPYCUXAUYDYDYEVGZAUYAVWLVWFTV
        EVWSYFYGYJWUIVYCVWGUXNVYKULZWUJWULUJURAUYAVWLVYCVWGUQVWMVYCUXAUYEULZVWG
        UYBVYCWUOUQVWLUYBUXAUXOUYEVWCXQXAVYAYKYFUYAWUNVYCUQVYFEUXNVYJVYCUHVYKVY
        LVYKYCUXAUXOYDYEVGWUIWUJVWEWULVWFUJWUKWUMYHYIYLUVLATTVYGVYHUJTFGVDVDUXA
        ATUWTFWAZFTWPITUWTFWSWTATUWTGWAZGTWPLTUWTGWSWTUXDUXDUXEVYFVYGXDVYFVYHXD
        XJXKXPEUCUHUWMUCUIZUWKULZUMULZEUCWCUWLWUSUMUWIWURUWKWDWGXRZAUWQUWRJMUVO
        AUXOUMULZUWSVSUSZUDUHWFUBUIZUHVEWVDUWKULZUMULZUWSVSUSZAWVCUDUHUYBWVBUYC
        UMULZUYDUMULZUJURZUWSVSUYBWVBUYEUMULWVJUYBUXOUYEUMVWCWGUYBUYCUYDUYKVVGU
        VPYKZUYBWVHWVIUWQUWRUYBUYHWVHTVEUYKUYCYMWTZUYBVVDWVITVEVVGUYDYMWTZAUWQT
        VEUYAJXAAUWRTVEUYAMXAUYBTVAVBUVQURZFWAZUYHUYCFUXPUSWVHUWQVSUSUYBWUPUWTW
        VNXCZWVOAWUPUYAIXABUWTWVNVUTVAVUIVSUSZVLVUIUWDVEZWVQVLVUIUWTVEVUIWVNVEV
        UTWVRWVQVUIUVRUVSVUIXFVUIUVTUWAUWBZTUWTWVNFYNYOUYKABCEFUXNHINOPYPFUYCYT
        YQUYBTWVNGWAZVVDUYDGUXPUSWVIUWRVSUSUYBWUQWVPWVTAWUQUYALXAWVSTUWTWVNGYNY
        OVVGABDEGUXNKLQRSYPGUYDYTYQXOUWCXPWVCWVGUDWVDUHUDUBWCZWVBWVFUWSVSWWAUXO
        WVEUMUXNWVDUWKWDWGUWEWJWKUWFAUWQUWRUDUBUHWVDCULZUMULZUNZUBUHWVDDULZUMUL
        ZUNZUWNVTVDUHXTVYQAYSVIABCWWDUBEFHINOPWWDYCZJYRUWNVDVEAEUHUWMVQYBVIABDW
        WGUBEGKLQRSWWGYCZMYRUYBUXNWWDULZWVHXBUYAWWJWVHUQAUBUXNWWCWVHUHWWDUBUDWC
        ZWWBUYCUMWVDUXNCWDWGWWHUYCUMYDYEVGZUYBWVHWVLYJYGUYBUXNWWGULZWVIXBUYAWWM
        WVIUQAUBUXNWWFWVIUHWWGWWKWWEUYDUMWVDUXNDWDWGWWIUYDUMYDYEVGZUYBWVIWVMYJY
        GUYBWVBWVJUXNUWNULZWWJWWMUJURWVKUYAWWOWVBUQAUCUXNWUTWVBUHUWNUCUDWCWUSUX
        OUMWURUXNUWKWDWGWVAUXOUMYDYEVGUYBWWJWVHWWMWVIUJWWLWWNYHYIYLUWPUWSUWNUWG
        UWH $.
    $}

    $d n x ph $.
    $( The ` S.2 ` integral is linear.  (Measurability is an essential
       component of this theorem; otherwise consider the characteristic
       function of a nonmeasurable set and its complement.)  (Contributed by
       Mario Carneiro, 17-Aug-2014.) $)
    itg2add $p |- ( ph ->
      ( S.2 ` ( F oF + G ) ) = ( ( S.2 ` F ) + ( S.2 ` G ) ) ) $=
      ( vf vn vx vg cn cv cfv wbr wa cr adantr citg1 cdm wf c0p cle c1 caddc co
      cofr wral cmpt cli w3a wex citg2 wceq mbfi1fseq eeanv cmbf wcel cpnf cico
      cof simprl1 simprl2 simprl3 simprr1 simprr2 simprr3 itg2addlem ex syl5bir
      cc0 exlimdvv mp2and ) ANUAUBZJOZUCZUDKOZVQPZUEUIZQVTVSUFUGUHZVQPWAQRKNUJZ
      KNLOZVTPUKWDBPULQLSUJZUMZJUNZNVPMOZUCZUDVSWHPZWAQWJWBWHPWAQRKNUJZKNWDWJPU
      KWDCPULQLSUJZUMZMUNZBCUGVCUHUOPBUOPZCUOPZUGUHUPZALJKBDEUQALMKCGHUQWGWNRWF
      WMRZMUNJUNAWQWFWMJMURAWRWQJMAWRWQAWRRLVQWHKBCABUSUTWRDTASVMVAVBUHZBUCWRET
      AWOSUTWRFTACUSUTWRGTASWSCUCWRHTAWPSUTWRITVRWCWEWMAVDVRWCWEWMAVEVRWCWEWMAV
      FWIWKWLWFAVGWIWKWLWFAVHWIWKWLWFAVIVJVKVNVLVO $.
  $}

  ${
    $d k x A $.  $d k n x y z F $.  $d k n x ph $.
    itg2gt0.1 $e |- ( ph -> A e. dom vol ) $.
    itg2gt0.2 $e |- ( ph -> 0 < ( vol ` A ) ) $.
    itg2gt0.3 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    itg2gt0.4 $e |- ( ph -> F e. MblFn ) $.
    itg2gt0.5 $e |- ( ( ph /\ x e. A ) -> 0 < ( F ` x ) ) $.
    $( If the function ` F ` is strictly positive on a set of positive measure,
       then the integral of the function is positive.  (Contributed by Mario
       Carneiro, 30-Aug-2014.) $)
    itg2gt0 $p |- ( ph -> 0 < ( S.2 ` F ) ) $=
      ( vk cc0 cvol wbr cle cn wcel syl adantr cr cvv vn vz cfv clt citg2 wn wa
      ccnv c1 cv cdiv co cpnf cioo cima cmpt crn cuni cxr cdm cicc iccssxr volf
      covol ffvelrni sseldi wss ciun wfn wceq wf cico fex sylancl cnvexg imaexg
      reex eqid fmptd ffn fniunfv wral cmbf 0re pnfxr icossre mp2an fss syl2anc
      mbfima ffvelrnda ralrimiva iunmbl eqeltrrd mblss ovolcl 0xr mblvol sselda
      a1i wrex elrege0 sylib simpld syldan nnrecl wb ad2antrr biantrurd nnrecre
      elpreima adantl rexrd adantlr elioopnf oveq2 oveq1d imaeq2d syl2anr mpbid
      fvmptg ex sylibrd eqbrtrd sylancr elxrge0 sylanbrc itg2cl crp simpr elrpd
      adantrr mpbird syl3anc simprd breq1 xrlenlt ax-mp frn sstri eleq2d eluni2
      3bitr2d id 3bitr4rd rexbidva eleq2 rexrn syl5bb ssrdv csup caddc peano2nn
      ovolss nnre lep1d nngt0 nnred nngt0d lerec syl22anc iooss1 imass2 3sstr4d
      volsup eqtr3d fveq2d cif nnrecgt0 ltle mpd 0le0 mpbir2an ifcl rexr anim1i
      wi 3imtr4i ssriv 0nrp cmul syl6eqelr itg2const2 itg2const simplrr eqeltrd
      eqtrd rpmulcld mtoi wo itg2ge0 xrleloe mt3d cofr biimpa syl6bi sylc ltled
      ord ifboth iffalse pm2.61dan ovex c0ex ifex fvex feqmptd ofrfval2 biimpar
      eqidd itg2le xrltletrd expr con3d an32s fveq2 breq1d ralrn ralima imassrn
      imp 3syl supxrleub sylibr xrletrd sylibd mt4d ) AKCLUCZUDMZKDUEUCZUDMZFAU
      YKUFZUYHKNMZUYIUFZAUYLUYMAUYLUGZUYHUAODUHZUIUAUJZUKULZUMUNULZUOZUPZUQZURZ
      VDUCZKAUYHUSPZUYLACLUTZPZVUEEVUGKUMVAULZUSUYHKUMVBZVUFVUHCLVCVEVFQZRAVUDU
      SPZUYLAVUCSVGZVUKAVUCVUFPZVULAJOJUJZVUAUCZVHZVUCVUFAVUAOVIZVUPVUCVJAOTVUA
      VKZVUQAUAOUYTTVUAAUYTTPZUYQOPZAUYPTPZVUSADTPZVVAASKUMVLULZDVKZSTPZVVBGVQS
      VVCTDVMVNDTVOQZUYPUYSTVPQRVUAVRZVSZOTVUAVTZQZJOVUAWAQAVUOVUFPZJOWBVUPVUFP
      AVVKJOAOVUFVUNVUAAUAOUYTVUFVUAAUYTVUFPZVUTADWCPSSDVKZVVLHAVVDVVCSVGZVVMGK
      SPZUMUSPVVNWDWEKUMWFWGSVVCSDWHVNSUYRUMDWJWIRVVGVSZWKZWLVUOJWMQWNZVUCWOQZV
      UCWPQRKUSPZUYOWQWTAUYHVUDNMUYLAUYHCVDUCZVUDNAVUGUYHVWAVJECWRQACVUCVGVULVW
      AVUDNMABCVUCABUJZCPZVWBVUOPZJOXAZVWBVUCPZAVWCVWEAVWCUGZUIVUNUKULZVWBDUCZU
      DMZJOXAZVWEVWGVWISPZKVWIUDMVWKAVWCVWBSPZVWLACSVWBAVUGCSVGECWOQWSZAVWMUGZV
      WLKVWINMZVWOVWIVVCPVWLVWPUGASVVCVWBDGWKVWIXBXCZXDZXEZIVWIJXFWIVWGVWJVWDJO
      VWGVUNOPZUGZVWBUYPVWHUMUNULZUOZPZVWLVWJUGZVWDVWJVXAVXDVWMVWIVXBPZUGZVXFVX
      EVXADSVIZVXDVXGXGZAVXHVWCVWTAVVDVXHGSVVCDVTQZXHSVWBVXBDXKZQVXAVWMVXFVWGVW
      MVWTVWNRXIVXAVWHUSPZVXFVXEXGAVWTVXLVWCAVWTUGZVWHVWTVWHSPZAVUNXJXLZXMZXNVW
      HVWIXOZQUUCVXAVUOVXCVWBVWTVWTVXCTPZVUOVXCVJZVWGVWTUUDZAVXRVWCAVVAVXRVVFUY
      PVXBTVPQZRUAVUNUYTVXCOTVUAUYQVUNVJZUYSVXBUYPVYBUYRVWHUMUNUYQVUNUIUKXPXQXR
      VVGYAZXSUUAVXAVWLVWJVWGVWLVWTVWSRXIUUEUUFXTYBVWFVWBUBUJZPZUBVUBXAZAVWEUBV
      WBVUBUUBAVUQVYFVWEXGVVJVYEVWDUBJOVUAVYDVUOVWBUUGUUHQUUIYCUUJVVSCVUCUUNWIY
      DRUYOVUDLVUBUOZUSUDUUKZKNAVUDVYHVJUYLAVUCLUCZVUDVYHAVUMVYIVUDVJVVRVUCWRQA
      OVUFVUAVKZVUOVUNUIUULULZVUAUCZVGZJOWBVYIVYHVJVVPAVYMJOVXMVXCUYPUIVYKUKULZ
      UMUNULZUOZVUOVYLVXMVXBVYOVGZVXCVYPVGVXMVYNUSPVYNVWHNMZVYQVXMVYNVXMVYKOPZV
      YNSPVWTVYSAVUNUUMZXLZVYKXJQXMVXMVUNVYKNMZVYRVXMVUNVWTVUNSPZAVUNUUOXLZUUPV
      XMWUCKVUNUDMZVYKSPKVYKUDMWUBVYRXGWUDVWTWUEAVUNUUQXLVXMVYKWUAUURVXMVYKWUAU
      USVUNVYKUUTUVAXTVYNVWHUMUVBWIVXBVYOUYPUVCQVWTVWTVXRVXSAVXTVYAVYCXSZVWTVYS
      VYPTPZVYLVYPVJAVYTAVVAWUGVVFUYPVYOTVPQUAVYKUYTVYPOTVUAUYQVYKVJZUYSVYOUYPW
      UHUYRVYNUMUNUYQVYKUIUKXPXQXRVVGYAXSUVDWLJVUAUVEWIUVFRUYOVWBKNMZBVYGWBZVYH
      KNMZUYOWUJVYDLUCZKNMZUBVUBWBZUYOWUNVUOLUCZKNMZJOWBZUYOWUPJOUYOVWTUGZWUOVX
      CLUCZKNWURVUOVXCLVWTVWTVXRVXSUYOVXTAVXRUYLVYARVYCXSUVGAVWTUYLWUSKNMZVXMUY
      LWUTVXMUYLKWUSUDMZUFZWUTVXMWVAUYKAVWTWVAUYKAVWTWVAUGZUGZKBSVXDVWHKUVHZUPZ
      UEUCZUYJVVTWVDWQWTWVDSVUHWVFVKZWVGUSPZAVWTWVHWVAVXMBSWVEVUHWVFVXMWVEVUHPZ
      VWMVXMVWHVUHPZKVUHPZWVJVXMVXLKVWHNMZWVKVXPVXMKVWHUDMZWVMVWTWVNAVUNUVIXLZV
      XMVVOVXNWVNWVMUVQWDVXOKVWHUVJYEUVKZVWHYFYGWVLVVTKKNMWQUVLKYFUVMVXDVWHKVUH
      UVNVNRWVFVRVSYLZWVFYHQZAUYJUSPZWVCASVUHDVKZWVSAVVDVVCVUHVGWVTGBVVCVUHVWMK
      VWBNMZUGVWBUSPZWWAUGVWBVVCPVWBVUHPVWMWWBWWAVWBUVOUVPVWBXBVWBYFUVRUVSSVVCV
      UHDWHVNZDYHQRWVDKWVGUDMZKWVGVJZWVDWWEKYIPZUVTWVDWWEWWFWVDWWEUGZKVWHWUSUWA
      ULZYIWWGKWVGWWHWVDWWEYJZWWGVXCVUFPZWUSSPZVWHVVCPZWVGWWHVJWVDWWJWWEAVWTWWJ
      WVAVXMVUOVXCVUFWUFVVQWNZYLRZWWGWWKWVGSPZWWGWVGKSWWIWDUWBWWGWWJVWHYIPZWWKW
      WOXGWWNWVDWWPWWEAVWTWWPWVAVXMVWHVXOWVOYKYLRZBVXCVWHUWCWIYMZWVDWWLWWEAVWTW
      WLWVAVXMVXNWVMWWLVXOWVPVWHXBYGYLRBVXCVWHUWDYNUWGWWGVWHWUSWWQWWGWUSWWRAVWT
      WVAWWEUWEYKUWHUWFYBUWIWVDWWDWWEWVDKWVGNMZWWDWWEUWJZWVDWVHWWSWVQWVFUWKQWVD
      VVTWVIWWSWWTXGWQWVRKWVGUWLYEXTUWSUWMWVDWVHWVTWVFDNUWNMZWVGUYJNMWVQAWVTWVC
      WWCRAWVCWVEVWINMZBSWBZWXAAVWTWXCWVAVXMWXBBSVXMVWMUGZVXDWXBVXMVXDWXBVWMVXM
      VXDUGZVWHVWINMZVWPWXBWXEVWHVWIVXMVXNVXDVXORVXMVXDVWMVWLWXEVWMVXFVXMVXDVXG
      VXMVXHVXIAVXHVWTVXJRVXKQUWOZXDZAVWMVWLVWTVWRXNXEWXEVXLVXFVWJVXMVXLVXDVXPR
      WXEVWMVXFWXGYOVXLVXFVXEVWJVXQVWLVWJYJUWPUWQUWRVXMVXDVWMVWPWXHAVWMVWPVWTVW
      OVWLVWPVWQYOXNZXEVXDWXFVWPWXBVWHKVWHWVEVWINYPKWVEVWINYPUWTWIXNWXDVXDUFZUG
      WVEKVWINWXJWVEKVJWXDVXDVWHKUXAXLWXDVWPWXJWXIRYDUXBWLYLAWXAWXCABSWVEVWINWV
      FDTTTVVEAVQWTWVETPVWOVXDVWHKUIVUNUKUXCUXDUXEWTVWITPVWOVWBDUXFWTAWVFUXJABS
      VVCDGUXGUXHUXIXEWVFDUXKYNUXLUXMUXNVXMWUSUSPZVVTWUTWVBXGVXMWWJWXKWWMWWJVUH
      USWUSVUIVUFVUHVXCLVCVEVFQWQWUSKYQVNYCUYAUXOYDWLAWUNWUQXGZUYLAVURVUQWXLVVH
      VVIWUMWUPUBJOVUAVYDVUOVJWULWUOKNVYDVUOLUXPUXQUXRUYBRYMUYOLVUFVIZVUBVUFVGZ
      WUJWUNXGVUFVUHLVKZWXMVCVUFVUHLVTYRAWXNUYLAVYJWXNVVPOVUFVUAYSQRWUIWUMBUBVU
      FVUBLVWBWULKNYPUXSYEYMVYGUSVGVVTWUKWUJXGVYGLUQZUSLVUBUXTWXPVUHUSWXOWXPVUH
      VGVCVUFVUHLYSYRVUIYTYTWQBVYGKUYCWGUYDYDUYEYBAVUEVVTUYMUYNXGVUJWQUYHKYQVNU
      YFUYG $.
  $}

  ${
    $d d m u x y z C $.  $d d m n u w x y z F $.  $d m n u x y z ph $.
    $d d u x M $.
    itg2cn.1 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    itg2cn.2 $e |- ( ph -> F e. MblFn ) $.
    itg2cn.3 $e |- ( ph -> ( S.2 ` F ) e. RR ) $.
    $( Lemma for ~ itgcn .  (Contributed by Mario Carneiro, 30-Aug-2014.) $)
    itg2cnlem1 $p |- ( ph -> sup ( ran ( n e. NN |-> ( S.2 ` ( x e. RR |->
    if ( ( F ` x ) <_ n , ( F ` x ) , 0 ) ) ) ) , RR* , < ) = ( S.2 ` F ) ) $=
      ( vy vm cr cn cle wbr cc0 cmpt wcel cvv wceq wa syl vz vw cfv cif crn clt
      cv csup citg2 cxr fvex c0ex ifex eqid fvmpt2 mpan2 mpteq2dv rneqd supeq1d
      mpteq2ia nfcv nfmpt1 nfmpt nffv nfrn nfsup weq fveq2 breq2 fveq1d cbvmptv
      ifbid reex mptex fvmpt eqtr4i syl6eq cbvmpt eqtr3i ccnv cpnf cioo co cima
      cdif cmbf breq1d eqidd ifbieq12d adantl wn wb ad2antlr rexrd elioopnf wfn
      nnre cico wf ffn ad2antrr elpreima simpr biantrurd wss 0re sylancl adantr
      ffvelrnda 3bitr4d mpteq2dva a1i cdm iffalse feqmptd eqeltrrd syl2anc 0le0
      iftrue elrege0 ifcl adantlr fmptd mpbird wral sylib leidd 3brtr4d eqbrtrd
      c1 ifboth ralrimiva ofrfval2 wrex breq1 ralbidv rspcev fveq2d c0 syl31anc
      bitr4d pnfxr icossre mp2an fss notbid eldif baib 3eqtr4a difss cvol rembl
      lenltd eldifn cres resmpt ax-mp mbfima cmmbl syl5eqel mbfss eqeltrd feq1d
      mbfres mpbir2an caddc cofr simpld ad3antlr peano2re lep1d letrd pm2.61dan
      simprd peano2nn inidm ofrfval mpbid r19.21bi an32s rneqi supeq1i itg2mono
      wne frn 1nn fdm syl5eleqr n0i dm0rn0 necon3bbii suprleub arch ad2antrl wi
      ralrn ltle syl2an simprl fnfvelrn rexlimddv suprub suprcl syl3anc letri3d
      impr eqtrd mpbir2and eqtr4d eqtr3d ) ABJCKBUGZDUCZCUGZLMZUXLNUDZOZUEZJUFU
      HZOZUIUCCKBJUXOOZUIUCZOZUEZUJUFUHZDUIUCAHUAUYDICKUXTOZUXSBJCKUXKUXTUCZOZU
      EZJUFUHZOUXSHJIKHUGZIUGZUYEUCZUCZOZUEZJUFUHZOBJUYIUXRUXKJPZJUYHUXQUFUYQUY
      GUXPUYQCKUYFUXOUYQUXOQPZUYFUXORUXNUXLNUXKDUKZULUMZBJUXOQUXTUXTUNUOUPUQURU
      SUTBHJUYIUYPHUYIVABUYOJUFBUYNBIKUYMBKVAZBUYJUYLBUYKUYEBCKUXTVUABJUXOVBVCB
      UYKVAVDBUYJVAVDVCVEBJVABUFVAVFBHVGZJUYHUYOUFVUBUYGUYNVUBUYGCKUYJUXTUCZOZU
      YNVUBCKUYFVUCUXKUYJUXTVHUQVUDIKUYJBJUXLUYKLMZUXLNUDZOZUCZOUYNCIKVUCVUHCIV
      GZUYJUXTVUGVUIBJUXOVUFVUIUXNVUEUXLNUXMUYKUXLLVIVLZUQZVJVKIKUYMVUHUYKKPZUY
      JUYLVUGCUYKUXTVUGKUYEVUKUYEUNZBJVUFVMVNVOZVJUTVPVQURUSVRVSAVULSZUYLHJUYJJ
      DVTUYKWAWBWCZWDZWEZPZUYJDUCZNUDZOZWFVUOVUGHJVUTUYKLMZVUTNUDZOUYLVVBBHJVUF
      VVDVUBVUEVVCUXLNVUTNVUBUXLVUTUYKLUXKUYJDVHZWGVVEVUBNWHWIVKVULUYLVUGRZAVUN
      WJZVUOHJVVAVVDVUOUYJJPZSZVUSVVCVUTNVVIUYJVUQPZWKZUYKVUTUFMZWKVUSVVCVVIVVJ
      VVLVVIVUTVUPPZVUTJPZVVLSZVVJVVLVVIUYKUJPVVMVVOWLVVIUYKVULUYKJPZAVVHUYKWQZ
      WMZWNUYKVUTWOTVVIVVJVVHVVMSZVVMVVIDJWPZVVJVVSWLAVVTVULVVHAJNWAWRWCZDWSZVV
      TEJVWADWTTZXAJUYJVUPDXBTVVIVVHVVMVUOVVHXCXDUUAVVIVVNVVLVUOJJUYJDAJJDWSZVU
      LAVWBVWAJXEZVWDENJPZWAUJPVWEXFUUBNWAUUCUUDJVWAJDUUEXGZXHXIZXDXJUUFVVHVUSV
      VKWLVUOVUSVVHVVKUYJJVUQUUGUUHWJVVIVUTUYKVWHVVRUUMXJVLXKUUIVUOHVURJVVAQVUR
      JXEZVUOJVUQUUJZXLJUUKXMZPVUOUULXLZVVAQPVUOVUSSVUSVUTNUYJDUKULUMXLVUOUYJJV
      URWEPZSVUSWKZVVANRVWMVWNVUOUYJJVURUUNWJVUSVUTNXNTAHVURVVAOZWFPVULAVWOHJVU
      TOZVURUUOZWFVWOHVURVUTOZVWQHVURVVAVUTVUSVUTNXSUTVWIVWQVWRRVWJHJVURVUTUUPU
      UQVPAVWPWFPVURVWKPZVWQWFPADVWPWFAHJVWADEXOFXPAVUQVWKPZVWSADWFPVWDVWTFVWGJ
      UYKWADUURXQVUQUUSTVURVWPUVDXQUUTXHUVAUVBVUOJVWAUYLWSJVWAVUGWSVUOBJVUFVWAV
      UGAUYQVUFVWAPZVULAUYQSZUXLVWAPZNVWAPZVXAAJVWAUXKDEXIZVXDVWFNNLMZXFXRNXTUV
      EVUEUXLNVWAYAXGYBZVUGUNZYCVUOJVWAUYLVUGVVGUVCYDVUOVUGBJUXLUYKYJUVFWCZLMZU
      XLNUDZOZUYLVXIUYEUCZLUVGZVUOVUGVXLVXNMVUFVXKLMZBJYEVUOVXOBJVUOUYQSZVUEVXO
      VXPVUESZUXLUXLVUFVXKLVXQUXLVXPUXLJPZVUEAUYQVXRVULVXBVXRNUXLLMZVXBVXCVXRVX
      SSVXEUXLXTYFZUVHZYBZXHZYGVUEVUFUXLRZVXPVUEUXLNXSZWJVXQVXJVXKUXLRVXQUXLUYK
      VXIVYCVULVVPAUYQVUEVVQUVIZVXQVVPVXIJPVYFUYKUVJTVXPVUEXCVXQUYKVYFUVKUVLVXJ
      UXLNXSTYHVXPVUEWKZSVUFNVXKLVYGVUFNRVXPVUEUXLNXNWJVXPNVXKLMZVYGAUYQVYHVULV
      XBVXSVXFVYHVXBVXRVXSVXTUVNZXRVXJVXSVXFVYHUXLNUXLVXKNLVINVXKNLVIYKXGYBXHYI
      UVMYLVUOBJVUFVXKLVUGVXLVWKVWAQVWLVXGVXKQPVXPVXJUXLNUYSULUMXLVUOVUGWHZVUOV
      XLWHYMYDVVGVUOVXIKPZVXMVXLRVULVYKAUYKUVOWJCVXIUXTVXLKUYEUXMVXIRZBJUXOVXKV
      YLUXNVXJUXLNUXMVXIUXLLVIVLUQVUMBJVXKVMVNVOTYHAVVHSZVVNUYMVUTLMZIKYEZUYMUA
      UGZLMZIKYEZUAJYNAJJUYJDVWGXIVYMVYNIKVYMVULSZUYMVUHVUTLVYSUYJUYLVUGVULVVFV
      YMVUNWJVJAVULVVHVUHVUTLMZVUOVYTHJVUOVUGDVXNMZVYTHJYEVUOWUAVUFUXLLMZBJYEVU
      OWUBBJAUYQWUBVULVXBUXLUXLLMZVXSWUBVXBUXLVYAYGVYIVUEWUCVXSWUBUXLNUXLVUFUXL
      LYONVUFUXLLYOYKXQZYBYLVUOBJVUFUXLLVUGDQQJJQPVUOVMXLZVUFQPVXPVUEUXLNUYSULU
      MZXLZVYBVYJADBJUXLOZRVULABJVWADEXOZXHYMYDVUOHJJVUHVUTLJVUGDQQVUOJQVUGWSVU
      GJWPVUOBJVUFQVUGWUGVXHYCJQVUGWTTAVVTVULVWCXHWUEWUEJUVPVVIVUHWHVVIVUTWHUVQ
      UVRUVSUVTYIYLVYRVYOUAVUTJVYPVUTRVYQVYNIKVYPVUTUYMLVIYPYQXQUJUYCIKUYLUIUCZ
      OZUEUFUYBWUKUYBIKVUGUIUCZOWUKCIKUYAWULVUIUXTVUGUIVUKYRVKIKWUJWULVULUYLVUG
      UIVUNYRUTVPUWAUWBUWCAUXSDUIAUXSWUHDABJUXRUXLVXBUXRUXLRUXRUXLLMZUXLUXRLMZV
      XBWUMUBUGZUXLLMZUBUXQYEZVXBWUQUYKUXPUCZUXLLMZIKYEZVXBWUSIKVXBVULSWURVUFUX
      LLVULWURVUFRZVXBCUYKUXOVUFKUXPVUJUXPUNZWUFVOZWJVXBWUBVULWUDXHYIYLVXBUXPKW
      PZWUQWUTWLVXBKQUXPWSWVDVXBCKUXOQUXPUYRVXBUXMKPZSZUYTXLWVBYCKQUXPWTTZWUPWU
      SUBIKUXPWUOWURUXLLYOUWPTYDZVXBUXQJXEZUXQYSUWDZWUOVYPLMZUBUXQYEZUAJYNZVXRW
      UMWUQWLVXBKJUXPWSZWVIVXBCKUXOJUXPWVFVXRVWFUXOJPVXBVXRWVEVYAXHXFUXNUXLNJYA
      XGWVBYCZKJUXPUWETZVXBYJUXPXMZPZWVJVXBYJKWVQUWFVXBWVNWVQKRWVOKJUXPUWGTUWHW
      VRWVQYSRZWKWVJWVQYJUWIWVSUXQYSUXPUWJUWKYFTZVXBVXRWUQWVMVYAWVHWVLWUQUAUXLJ
      VYPUXLRWVKWUPUBUXQVYPUXLWUOLVIYPYQXQZVYAUAUBUBUXQUXLUWLYTYDVXBWVIWVJWVMUX
      LUXQPZWUNWVPWVTWWAVXBUXLUYKUFMZWWBIKVXBVXRWWCIKYNVYAUXLIUWMTVXBVULWWCSZSZ
      WURUXLUXQWWEWURVUFUXLVULWVAVXBWWCWVCUWNWWEVUEVYDVXBVULWWCVUEVXBVXRVVPWWCV
      UEUWOVULVYAVVQUXLUYKUWQUWRUXFVYETUXGWWEWVDVULWURUXQPVXBWVDWWDWVGXHVXBVULW
      WCUWSKUYKUXPUWTXQXPUXAUAUBUXQUXLUXBYTVXBUXRUXLVXBWVIWVJWVMUXRJPWVPWVTWWAU
      AUBUXQUXCUXDVYAUXEUXHXKWUIUXIYRUXJ $.

    itg2cn.4 $e |- ( ph -> C e. RR+ ) $.
    ${
      itg2cn.5 $e |- ( ph -> M e. NN ) $.
      itg2cn.6 $e |- ( ph -> -. ( S.2 ` ( x e. RR |-> if ( ( F ` x ) <_ M ,
        ( F ` x ) , 0 ) ) ) <_ ( ( S.2 ` F ) - ( C / 2 ) ) ) $.
      $( Lemma for ~ itgcn .  (Contributed by Mario Carneiro, 31-Aug-2014.) $)
      itg2cnlem2 $p |- ( ph ->
      E. d e. RR+ A. u e. dom vol ( ( vol ` u ) < d ->
        ( S.2 ` ( x e. RR |-> if ( x e. u , ( F ` x ) , 0 ) ) ) < C ) ) $=
        ( wcel cfv clt wbr cr cc0 cle c2 cdiv co crp cv cvol cif cmpt citg2 cdm
        wi wral wrex rphalfcld nnrpd rpdivcld wa caddc ccnv cpnf cioo cima cdif
        cin simprl cmbf adantr cico wss cxr 0re pnfxr icossre mp2an fss sylancl
        wf mbfima syl2anc inmbl difmbl covol c0 inass disjdif ineq2i in0 3eqtri
        wceq fveq2i ovol0 eqtri a1i cun inundif eqcomi cicc mblss syl ffvelrnda
        sselda elrege0 sylib simpld rexrd simprd sylanbrc syldan eqid 0le0 ifcl
        elxrge0 fmptd breq1 ifboth ralrimiva cvv ofrfval2 mpbird itg2le syl3anc
        eqidd itg2lecl itg2split rpred fveq2d iftrue wn adantl biantrurd ltnled
        wb ad2antrr con1bid mpbid eqbrtrrd lelttrd breq2 eqbrtrd breqtrd anim1i
        0xr mpbir2an cofr rexr 3imtr4i ssriv leidd feqmptd inss2 sseli syl31anc
        reex ifle cmmbl undif2 ssequn1 syl5req mpteq2ia eqtrd cmin baib wfn ffn
        eldif elpreima nnred elioopnf simpr 3bitr2d 3bitr2rd bitrd ifbid breq1d
        mtbird resubcld ltsubadd2d ltadd1d cmul mblvol simprr ovolcl xrltle mpd
        mpteq2dva ovollecl eqeltrd nnnn0d nn0ge0d eldifn difssd 3brtr4d iffalse
        remulcld pm2.61dan ralrimivw itg2const nngt0d ltmuldiv2 syl112anc rpcnd
        cn lt2addd 2halvesd expr imbi1d ralbidv rspcev ) ADUAUBUCZFUBUCZUDNCUEZ
        UFOZUXJPQZBRBUEZUXKNZUXNEOZSUGUHZUIOZDPQZUKZCUFUJZULZUXLGUEZPQZUXSUKZCU
        YAULZGUDUMAUXIFADKUNAFLUOUPZAUXTCUYAAUXKUYANZUXMUXSAUYHUXMUQZUQZUXRUXIU
        XIURUCZDPUYJUXRBRUXNUXKEUSFUTVAUCZVBZVDZNZUXPSUGZUHZUIOZBRUXNUXKUYMVCZN
        ZUXPSUGZUHZUIOZURUCUYKPUYJBUYNUYSUXPUXKUYQVUBUXQUYJUYHUYMUYANZUYNUYANAU
        YHUXMVEZUYJEVFNZRREVQZVUDAVUFUYIIVGAVUGUYIARSUTVHUCZEVQZVUHRVIZVUGHSRNZ
        UTVJNVUJVKVLSUTVMVNRVUHREVOVPVGRFUTEVRVSZUXKUYMVTVSUYJUYHVUDUYSUYANVUEV
        ULUXKUYMWAVSUYNUYSVDZWBOZSWIUYJVUNWCWBOZSVUMWCWBVUMUXKUYMUYSVDZVDUXKWCV
        DWCUXKUYMUYSWDVUPWCUXKUYMUXKWEWFUXKWGWHWJWKWLWMUXKUYNUYSWNZWIUYJVUQUXKU
        XKUYMWOWPWMUYJUXOUXNRNZUXPSUTWQUCZNZUYJUXKRUXNUYJUYHUXKRVIZVUEUXKWRWSZX
        AZUYJVURUQZUXPVJNSUXPTQZVUTVVDUXPVVDUXPRNZVVEVVDUXPVUHNVVFVVEUQUYJRVUHU
        XNEAVUIUYIHVGZWTUXPXBXCZXDZXEVVDVVFVVEVVHXFZUXPXLXGZXHUYQXIZVUBXIZUXQXI
        UYJRVUSUYQVQZEUIOZRNZUYRVVOTQZUYRRNUYJBRUYPVUSUYQVVDVUTSVUSNZUYPVUSNVVK
        VVRSVJNSSTQZUUBXJSXLUUCZUYOUXPSVUSXKVPZVVLXMZAVVPUYIJVGZUYJVVNRVUSEVQZU
        YQETUUDZQZVVQVWBUYJVUIVUHVUSVIVWDVVGBVUHVUSVURSUXNTQZUQUXNVJNZVWGUQUXNV
        UHNUXNVUSNVURVWHVWGUXNUUEUUAUXNXBUXNXLUUFUUGRVUHVUSEVOVPZUYJVWFUYPUXPTQ
        ZBRULUYJVWJBRVVDUXPUXPTQZVVEVWJVVDUXPVVIUUHZVVJUYOVWKVVEVWJUXPSUXPUYPUX
        PTXNSUYPUXPTXNXOVSXPUYJBRUYPUXPTUYQEXQVUSRRXQNUYJUUMWMZVWAVVIUYJUYQYBZU
        YJBRVUHEVVGUUIZXRXSUYQEXTYAVVOUYQYCYAZUYJRVUSVUBVQZVVPVUCVVOTQZVUCRNUYJ
        BRVUAVUSVUBVVDVUTVVRVUAVUSNVVKVVTUYTUXPSVUSXKVPZVVMXMZVWCUYJVWQVWDVUBEV
        WEQZVWRVWTVWIUYJVXAVUAUXPTQZBRULUYJVXBBRVVDVWKVVEVXBVWLVVJUYTVWKVVEVXBU
        XPSUXPVUAUXPTXNSVUAUXPTXNXOVSXPUYJBRVUAUXPTVUBEXQVUSRVWMVWSVVIUYJVUBYBZ
        VWOXRXSVUBEXTYAVVOVUBYCYAZYDUYJUYRVUCUXIUXIVWPVXDUYJUXIUYJDADUDNUYIKVGZ
        UNYEZVXFUYJUYRBRUXNUYMNZUXPSUGZUHZUIOZUXIVWPUYJRVUSVXIVQZVVPVXJVVOTQZVX
        JRNUYJBRVXHVUSVXIVVDVUTVVRVXHVUSNVVKVVTVXGUXPSVUSXKVPZVXIXIZXMZVWCUYJVX
        KVWDVXIEVWEQZVXLVXOVWIUYJVXPVXHUXPTQZBRULUYJVXQBRVVDVWKVVEVXQVWLVVJVXGV
        WKVVEVXQUXPSUXPVXHUXPTXNSVXHUXPTXNXOVSXPUYJBRVXHUXPTVXIEXQVUSVUSVWMVXMV
        VKUYJVXIYBZVWOXRXSVXIEXTYAVVOVXIYCYAZVXFUYJVVNVXKUYQVXIVWEQZUYRVXJTQVWB
        VXOUYJVXTUYPVXHTQZBRULUYJVYABRVVDVVFVUKVVEUYOVXGUKZVYAVVIVUKVVDVKWMVVJV
        YBVVDUYNUYMUXNUXKUYMUUJUUKWMUYOVXGUXPSUUNUULXPUYJBRUYPVXHTUYQVXIXQVUSVU
        SVWMVWAVXMVWNVXRXRXSUYQVXIXTYAUYJVXJUXIPQVXJBRUXNRUYMVCZNZUXPSUGZUHZUIO
        ZURUCZUXIVYGURUCZPQUYJVVOVYHVYIPUYJVVOBRUXPUHZUIOVYHUYJEVYJUIVWOYFUYJBU
        YMVYCUXPRVXIVYFVYJVULUYJVUDVYCUYANVULUYMUUOWSUYMVYCVDZWBOZSWIUYJVYLVUOS
        VYKWCWBUYMRWEWJWKWLWMUYJUYMVYCWNUYMRWNZRUYMRUUPUYJUYMRVIZVYMRWIUYJVUDVY
        NVULUYMWRWSUYMRUUQXCUURVVKVXNVYFXIZBRVURUXPSUGZUHVYJBRVYPUXPVURUXPSYGUU
        SWPVXSUYJRVUSVYFVQZVVPVYGVVOTQZVYGRNUYJBRVYEVUSVYFVVDVUTVVRVYEVUSNVVKVV
        TVYDUXPSVUSXKVPZVYOXMZVWCUYJVYQVWDVYFEVWEQZVYRVYTVWIUYJWUAVYEUXPTQZBRUL
        UYJWUBBRVVDVWKVVEWUBVWLVVJVYDVWKVVEWUBUXPSUXPVYEUXPTXNSVYEUXPTXNXOVSXPU
        YJBRVYEUXPTVYFEXQVUSVUSVWMVYSVVKUYJVYFYBVWOXRXSVYFEXTYAVVOVYFYCYAZYDUUT
        UYJVVOUXIUVAUCZVYGPQZVVOVYIPQUYJWUEVYGWUDTQZYHUYJWUFBRUXPFTQZUXPSUGZUHZ
        UIOZWUDTQZAWUKYHUYIMVGUYJVYGWUJWUDTUYJVYFWUIUIUYJBRVYEWUHVVDVYDWUGUXPSV
        VDVYDVXGYHZWUGVURVYDWULYLUYJVYDVURWULUXNRUYMUVEUVBYIVVDWUGVXGVVDVXGVURU
        XPUYLNZUQZFUXPPQZWUGYHZVVDERUVCZVXGWUNYLAWUQUYIVURAVUIWUQHRVUHEUVDWSYMR
        UXNUYLEUVFWSVVDWUOVVFWUOUQZWUMWUNVVDVVFWUOVVIYJVVDFVJNZWUMWURYLVVDFAFRN
        ZUYIVURAFLUVGZYMZXEFUXPUVHWSVVDVURWUMUYJVURUVIYJUVJVVDFUXPWVBVVIYKUVKZY
        NUVLUVMUWEYFUVNUVOUYJWUDVYGUYJVVOUXIVWCVXFUVPWUCYKXSUYJVVOUXIVYGVWCVXFW
        UCUVQYOYPUYJVXJUXIVYGVXSVXFWUCUVRXSYQUYJVUCFUXLUVSUCZUXIVXDUYJFUXLAWUTU
        YIWVAVGZUYJUXLUXKWBOZRUYJUYHUXLWVFWIVUEUXKUVTWSZUYJVVAUXJRNZWVFUXJTQZWV
        FRNVVBAWVHUYIAUXJUYGYEVGZUYJWVFUXJPQZWVIUYJUXLWVFUXJPWVGAUYHUXMUWAZYPUY
        JWVFVJNZUXJVJNWVKWVIUKUYJVVAWVMVVBUXKUWBWSUYJUXJWVJXEWVFUXJUWCVSUWDUXKU
        XJUWFYAUWGZUWNVXFUYJVUCBRUXOFSUGZUHZUIOZWVDTUYJVWQRVUSWVPVQVUBWVPVWEQZV
        UCWVQTQVWTUYJBRWVOVUSWVPUYJWVOVUSNZVURUYJFVUSNZVVRWVSUYJWUSSFTQZWVTUYJF
        WVEXEUYJFUYJFAFUXBNUYILVGZUWHUWIZFXLXGVVTUXOFSVUSXKVPVGZWVPXIXMUYJWVRVU
        AWVOTQZBRULUYJWWEBRUYJUYTWWEUYJUYTUQZUXPFVUAWVOTWWFWULWUGUYTWULUYJUXNUX
        KUYMUWJYIWWFWUGVXGUYJUYTUXOWUPVXGYLZUYJUYSUXKUXNUYJUXKUYMUWKXAZUYJUXOVU
        RWWGVVCWVCXHXHYNYOUYTVUAUXPWIUYJUYTUXPSYGYIWWFUXOWVOFWIWWHUXOFSYGWSUWLU
        YJUYTYHZUQVUASWVOTWWIVUASWIUYJUYTUXPSUWMYIUYJSWVOTQZWWIUYJWWAVVSWWJWWCX
        JUXOWWAVVSWWJFSFWVOSTYRSWVOSTYRXOVPVGYSUWOUWPUYJBRVUAWVOTVUBWVPXQVUSVUS
        VWMVWSWWDVXCUYJWVPYBXRXSVUBWVPXTYAUYJUYHUXLRNZFVUHNZWVQWVDWIVUEWVNUYJWU
        TWWAWWLWVEWWCFXBXGBUXKFUWQYAYTUYJWVDUXIPQZUXMWVLUYJWWKUXIRNWUTSFPQWWMUX
        MYLWVNVXFWVEUYJFWWBUWRUXLUXIFUWSUWTXSYQUXCYSUYJDUYJDVXEUXAUXDYTUXEXPUYF
        UYBGUXJUDUYCUXJWIZUYEUXTCUYAWWNUYDUXMUXSUYCUXJUXLPYRUXFUXGUXHVS $.
    $}

    $( A sort of absolute continuity of the Lebesgue integral (this is the core
       of ~ ftc1a which is about actual absolute continuity).  (Contributed by
       Mario Carneiro, 1-Sep-2014.) $)
    itg2cn $p |- ( ph ->
      E. d e. RR+ A. u e. dom vol ( ( vol ` u ) < d ->
        ( S.2 ` ( x e. RR |-> if ( x e. u , ( F ` x ) , 0 ) ) ) < C ) ) $=
      ( vm cr cfv cle wbr cc0 citg2 wcel cn cxr vn vz vy cv cif cmpt c2 cdiv co
      cmin wn cvol clt wi cdm wral crp rphalfcld ltsubrpd rpred resubcld ltnled
      wrex mpbid crn csup wss wb wf wa cpnf cicc ffvelrnda elrege0 sylib simpld
      cico rexrd simprd elxrge0 sylanbrc 0xr 0le0 mpbir2an ifcl sylancl adantlr
      eqid fmptd itg2cl syl frn supxrleub syl2anc itg2cnlem1 breq1d breq1 ralrn
      wfn ffn weq breq2 ifbid mpteq2dv fveq2d fvex fvmpt ralbiia syl6bb 3bitr3d
      mtbid rexnal sylibr adantr cmbf simprl simprr fveq2 cbvmptv fveq2i breq1i
      eqidd ifbieq12d sylnib itg2cnlem2 elequ1 imbi2i ralbii rexbii rexlimddv )
      ABLBUDZEMZKUDZNOZYLPUEZUFZQMZEQMZDUGUHUIZUJUIZNOZUKZCUDZULMFUDUMOZBLYKUUC
      RZYLPUEZUFZQMZDUMOZUNZCULUOZUPZFUQVCZKSAUUAKSUPZUKUUBKSVCAYRYTNOZUUNAYTYR
      UMOUUOUKAYRYSIADJURZUSAYTYRAYRYSIAYSUUPUTVAZIVBVDAUASBLYLUAUDZNOZYLPUEZUF
      ZQMZUFZVEZTUMVFZYTNOZUBUDZYTNOZUBUVDUPZUUOUUNAUVDTVGZYTTRUVFUVIVHASTUVCVI
      ZUVJAUASUVBTUVCAUURSRZVJZLPVKVLUIZUVAVIUVBTRUVMBLUUTUVNUVAAYKLRZUUTUVNRZU
      VLAUVOVJZYLUVNRZPUVNRZUVPUVQYLTRPYLNOZUVRUVQYLUVQYLLRZUVTUVQYLPVKVQUIZRUW
      AUVTVJALUWBYKEGVMYLVNVOZVPVRUVQUWAUVTUWCVSYLVTWAUVSPTRPPNOWBWCPVTWDUUSYLP
      UVNWEWFWGUVAWHWIUVAWJWKUVCWHZWIZSTUVCWLWKAYTUUQVRUBUVDYTWMWNAUVEYRYTNABUA
      EGHIWOWPAUVCSWSZUVIUUNVHAUVKUWFUWESTUVCWTWKUWFUVIYMUVCMZYTNOZKSUPUUNUVHUW
      HUBKSUVCUVGUWGYTNWQWRUWHUUAKSYMSRZUWGYQYTNUAYMUVBYQSUVCUAKXAZUVAYPQUWJBLU
      UTYOUWJUUSYNYLPUURYMYLNXBXCXDXEUWDYPQXFXGWPXHXIWKXJXKUUAKSXLXMAUWIUUBVJZV
      JZUUDUCLUCUDZUUCRZUWMEMZPUEZUFZQMZDUMOZUNZCUUKUPZFUQVCUUMUWLUCCDEYMFALUWB
      EVIUWKGXNAEXORUWKHXNAYRLRUWKIXNADUQRUWKJXNAUWIUUBXPUWLUUAUCLUWOYMNOZUWOPU
      EZUFZQMZYTNOAUWIUUBXQYQUXEYTNYPUXDQBUCLYOUXCBUCXAZYNUXBYLPUWOPUXFYLUWOYMN
      YKUWMEXRZWPUXGUXFPYBZYCXSXTYAYDYEUULUXAFUQUUJUWTCUUKUUIUWSUUDUUHUWRDUMUUG
      UWQQBUCLUUFUWPUXFUUEUWNYLPUWOPBUCCYFUXGUXHYCXSXTYAYGYHYIXMYJ $.
  $}

  ${
    ibllem.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Conditioned equality theorem for the if statement.  (Contributed by
       Mario Carneiro, 31-Jul-2014.) $)
    ibllem $p |- ( ph -> if ( ( x e. A /\ 0 <_ B ) , B , 0 ) =
                         if ( ( x e. A /\ 0 <_ C ) , C , 0 ) ) $=
      ( cv wcel cc0 cle wbr wa breq2d pm5.32da ifbid wceq adantrr ifeq1da eqtrd
      cif ) ABGCHZIDJKZLZDITUAIEJKZLZDITUEEITAUCUEDIAUAUBUDAUALDEIJFMNOAUEDEIAU
      ADEPUDFQRS $.
  $}

  ${
    $d f k x y z A $.  $d k y z B $.  $d f k x F $.  $d k x y ph $.  $d x V $.
    isibl.1 $e |- ( ph -> G =
      ( x e. RR |-> if ( ( x e. A /\ 0 <_ T ) , T , 0 ) ) ) $.
    isibl.2 $e |- ( ( ph /\ x e. A ) -> T = ( Re ` ( B / ( _i ^ k ) ) ) ) $.
    ${
      isibl.3 $e |- ( ph -> dom F = A ) $.
      isibl.4 $e |- ( ( ph /\ x e. A ) -> ( F ` x ) = B ) $.
      $( The predicate " ` F ` is integrable".  The "integrable" predicate
         corresponds roughly to the range of validity of ` S. A B _d x ` ,
         which is to say that the expression ` S. A B _d x ` doesn't make sense
         unless ` ( x e. A |-> B ) e. L^1 ` .  (Contributed by Mario Carneiro,
         28-Jun-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
      isibl $p |- ( ph -> ( F e. L^1 <-> ( F e. MblFn /\
                    A. k e. ( 0 ... 3 ) ( S.2 ` G ) e. RR ) ) ) $=
        ( vy wcel cr cc0 cfv cre cle wa vf cibl cmbf cv cdm ci cexp co cdiv wbr
        cif cmpt citg2 c3 cfz wral csb wceq fvex nfcv breq2 anbi2d id ifbieq12d
        eqidd csbief eleq2d oveq1d fveq2d breq2d anbi12d syl5eq mpteq2dv eleq1d
        fveq1 ralbidv df-ibl elrab2 anbi1d ifbid eqtr4d ibllem eqtrd syl5bb
        dmeq ) GUBNGUCNZBOBUDZGUEZNZPWGGQZUFFUDUGUHZUIUHZRQZSUJZTZWMPUKZULZUMQZ
        ONZFPUNUOUHZUPZTAWFHUMQZONZFWTUPZTBOMWGUAUDZQZWKUIUHZRQZWGXEUEZNZPMUDZS
        UJZTZXKPUKZUQZULZUMQZONZFWTUPXAUAGUCUBXEGURZXRWSFWTXSXQWROXSXPWQUMXSBOX
        OWPXSXOXJPXHSUJZTZXHPUKZWPMXHXNYBXGRUSMYBUTXKXHURZXMYAXKPXHPYCXLXTXJXKX
        HPSVAVBYCVCYCPVEVDVFXSYAWOXHPWMPXSXJWIXTWNXSXIWHWGXEGWEVGXSXHWMPSXSXGWL
        RXSXFWJWKUIWGXEGVOVHVIZVJVKYDXSPVEVDVLVMVIVNVPBMUAFVQVRAXAXDWFAWSXCFWTA
        WRXBOAWQHUMAWQBOWGCNZPESUJTEPUKZULHABOWPYFAWPYEWNTZWMPUKYFAWOYGWMPAWIYE
        WNAWHCWGKVGVSVTABCWMEAYETZWMDWKUIUHZRQEYHWLYIRYHWJDWKUILVHVIJWAWBWCVMIW
        AVIVNVPVBWD $.
    $}

    isibl2.3 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( The predicate " ` F ` is integrable" when ` F ` is a mapping operation.
       (Contributed by Mario Carneiro, 31-Jul-2014.)  (Revised by Mario
       Carneiro, 23-Aug-2014.) $)
    isibl2 $p |- ( ph -> ( ( x e. A |-> B ) e. L^1 <->
  ( ( x e. A |-> B ) e. MblFn /\ A. k e. ( 0 ... 3 ) ( S.2 ` G ) e. RR ) ) ) $=
      ( vy cfv cdiv cre cr cc0 cle wa nfcv cv cmpt ci cexp co wcel wbr nffvmpt1
      cif nfv nfov nffv nfbr nfan nfif eleq1 fveq2 oveq1d fveq2d breq2d anbi12d
      eqidd ifbieq12d cbvmpt simpr fvmpt2 syl2anc eqtr4d ibllem mpteq2dv syl5eq
      wceq eqid wf cdm fmptd fdm syl isibl ) ALCLUAZBCDUBZMZWBUCFUAUDUEZNUEZOMZ
      FWAGAGBPBUAZCUFZQERUGSEQUIZUBZLPVTCUFZQWERUGZSZWEQUIZUBZIAWNBPWGQWFWAMZWC
      NUEZOMZRUGZSZWQQUIZUBWILBPWMWTWLBWEQWJWKBWJBUJBQWERBQTZBRTBWDOBOTBWBWCNBC
      DVTUHBNTBWCTUKULZUMUNXBXAUOLWTTVTWFVLZWLWSWEQWQQXCWJWGWKWRVTWFCUPXCWEWQQR
      XCWDWPOXCWBWOWCNVTWFWAUQURUSZUTVAXDXCQVBVCVDABPWTWHABCWQEAWGSZWQDWCNUEZOM
      EXEWPXFOXEWODWCNXEWGDHUFWODVLAWGVEKBCDHWAWAVMZVFVGURUSJVHVIVJVKVHAWJSZWEV
      BACHWAVNWAVOCVLABCDHWAKXGVPCHWAVQVRXHWBVBVS $.
  $}

  ${
    $d f k x y z A $.  $d k y z B $.  $d k G $.  $d k x y z K $.
    $d k x y ph $.  $d y z T $.  $d x V $.
    $( An integrable function is measurable.  (Contributed by Mario Carneiro,
       7-Jul-2014.) $)
    iblmbf $p |- ( F e. L^1 -> F e. MblFn ) $=
      ( vx vy vf vk cibl cmbf cr cv cfv ci cexp cdiv cre cdm wcel cc0 cle wbr
      co wa cif csb cmpt citg2 c3 cfz wral crab df-ibl ssrab2 eqsstri sseli ) F
      GAFBHCBIZDIZJKEILTMTNJUNUOOPQCIZRSUAUPQUBUCUDUEJHPEQUFUGTUHZDGUIGBCDEUJUQ
      DGUKULUM $.

    iblitg.1 $e |- ( ph -> G =
      ( x e. RR |-> if ( ( x e. A /\ 0 <_ T ) , T , 0 ) ) ) $.
    iblitg.2 $e |- ( ( ph /\ x e. A ) -> T = ( Re ` ( B / ( _i ^ K ) ) ) ) $.
    iblitg.3 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    iblitg.4 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( If a function is integrable, then the ` S.2 ` integrals of the
       function's decompositions all exist.  (Contributed by Mario Carneiro,
       7-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    iblitg $p |- ( ( ph /\ K e. ZZ ) -> ( S.2 ` G ) e. RR ) $=
      ( wcel wa cfv cr cc0 c4 co c3 vk cz citg2 cv ci cmo cexp cdiv cre cle wbr
      cif cmpt wceq adantr adantlr iexpcyc oveq2d fveq2d ad2antlr eqtr4d ibllem
      mpteq2dv eqtrd cfz wral c1 cmin 4nn zmodfz mpan2 4cn ax-1cn caddc addcomi
      cn 3cn df-4 eqtr4i subaddrii oveq2i syl6eleq adantl cmbf cibl eqidd mpbid
      isibl2 simprd oveq2 breq2d anbi2d ifbieq12d eleq1d rspcv sylc eqeltrd ) A
      GUBMZNZFUCOBPBUDCMZQDUEGRUFSZUGSZUHSZUIOZUJUKZNZXDQULZUMZUCOZPWSFXHUCWSFB
      PWTQEUJUKNEQULZUMZXHAFXKUNWRIUOWSBPXJXGWSBCEXDWSWTNEDUEGUGSZUHSZUIOZXDAWT
      EXNUNWRJUPWRXDXNUNAWTWRXCXMUIWRXBXLDUHGUQURUSUTVAVBVCVDUSWSXAQTVESZMZBPWT
      QDUEUAUDZUGSZUHSZUIOZUJUKZNZXTQULZUMZUCOZPMZUAXOVFZXIPMZWRXPAWRXAQRVGVHSZ
      VESZXOWRRVPMXAYJMVIGRVJVKYITQVERVGTVLVMVQVGTVNSTVGVNSRVGTVMVQVOVRVSVTWAWB
      WCAYGWRABCDUMZWDMZYGAYKWEMYLYGNKABCDXTUAYDHAYDWFAWTNXTWFLWHWGWIUOYFYHUAXA
      XOXQXAUNZYEXIPYMYDXHUCYMBPYCXGYMYBXFXTQXDQYMYAXEWTYMXTXDQUJYMXSXCUIYMXRXB
      DUHXQXAUEUGWJURUSZWKWLYNYMQWFWMVCUSWNWOWPWQ $.
  $}

  ${
    $d k x y z $.  $d k y z A $.  $d k y B $.  $d y z T $.
    dfitg.1 $e |- T = ( Re ` ( B / ( _i ^ k ) ) ) $.
    $( Evaluate the class substitution in ~ df-itg .  (Contributed by Mario
       Carneiro, 28-Jun-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    dfitg $p |- S. A B _d x = sum_ k e. ( 0 ... 3 ) ( ( _i ^ k ) x.
             ( S.2 ` ( x e. RR |-> if ( ( x e. A /\ 0 <_ T ) , T , 0 ) ) ) ) $=
      ( vy cc0 co cv cr cre cfv wcel cle wbr wa cif citg2 cmul citg c3 cfz cexp
      ci cdiv csb cmpt csu df-itg wceq fvex nfcv id syl6eqr breq2d anbi2d eqidd
      ifbieq12d csbief mpteq2i fveq2i oveq2i a1i sumeq2i eqtri ) ABCUAHUBUCIZUE
      EJZUDIZAKGCVIUFIZLMZAJBNZHGJZOPZQZVMHRZUGZUHZSMZTIZEUIVGVIAKVLHDOPZQZDHRZ
      UHZSMZTIZEUIAGBCEUJVGVTWFEVTWFUKVHVGNVSWEVITVRWDSAKVQWCGVKVPWCVJLULGWCUMV
      MVKUKZVOWBVMHDHWGVNWAVLWGVMDHOWGVMVKDWGUNFUOZUPUQWHWGHURUSUTVAVBVCVDVEVF
      $.
  $}

  ${
    $d k x y $.  $d k y A $.  $d k y B $.  $d k C $.
    $( An integral is a set.  (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    itgex $p |- S. A B _d x e. _V $=
      ( vk vy citg cc0 c3 cfz co ci cv cexp cr cdiv cre cfv wcel cle wbr wa cif
      csb cmpt citg2 cmul csu cvv df-itg sumex eqeltri ) ABCFGHIJZKDLMJZANECUMO
      JPQALBRGELZSTUAUNGUBUCUDUEQUFJZDUGUHAEBCDUIULUODUJUK $.

    itgeq1f.1 $e |- F/_ x A $.
    itgeq1f.2 $e |- F/_ x B $.
    $( Equality theorem for an integral.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    itgeq1f $p |- ( A = B -> S. A C _d x = S. B C _d x ) $=
      ( vk wceq cc0 co cv cr wcel cfv wa cif cmpt citg2 cmul csu c3 cfz ci cexp
      cdiv cre cle wbr citg wral eqid nfeq eleq2 anbi1d ralrimi mpteq12 sylancr
      ifbid a1d fveq2d oveq2d sumeq2sdv dfitg 3eqtr4g ) BCHZIUAUBJZUCGKUDJZALAK
      ZBMZIDVGUEJUFNZUGUHZOZVJIPZQZRNZSJZGTVFVGALVHCMZVKOZVJIPZQZRNZSJZGTABDUIA
      CDUIVEVFVPWBGVEVOWAVGSVEVNVTRVELLHVMVSHZALUJVNVTHLUKVEWCALABCEFULVEWCVHLM
      VEVLVRVJIVEVIVQVKBCVHUMUNURUSUOALVMLVSUPUQUTVAVBABDVJGVJUKZVCACDVJGWDVCVD
      $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality theorem for an integral.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    itgeq1 $p |- ( A = B -> S. A C _d x = S. B C _d x ) $=
      ( nfcv itgeq1f ) ABCDABEACEF $.
  $}

  ${
    $d k x y z $.  $d k y z A $.  $d k y z B $.
    $( Bound-variable hypothesis builder for an integral.  (Contributed by
       Mario Carneiro, 28-Jun-2014.) $)
    nfitg1 $p |- F/_ x S. A B _d x $=
      ( vk vz citg cc0 c3 cfz co ci cv cexp cr cdiv cre cfv citg2 cmul nfcv cle
      wcel wbr wa cif csb cmpt csu df-itg nfmpt1 nffv nfov nfsum nfcxfr ) AABCF
      GHIJZKDLMJZANECUPOJPQALBUBGELZUAUCUDUQGUEUFZUGZRQZSJZDUHAEBCDUIAUOVADAUOT
      AUPUTSAUPTASTAUSRARTANURUJUKULUMUN $.
  $}

  ${
    $d k x y z $.  $d k z A $.  $d k z B $.
    nfitg.1 $e |- F/_ y A $.
    nfitg.2 $e |- F/_ y B $.
    $( Bound-variable hypothesis builder for an integral: if ` y ` is
       (effectively) not free in ` A ` and ` B ` , it is not free in
       ` S. A B _d x ` .  (Contributed by Mario Carneiro, 28-Jun-2014.) $)
    nfitg $p |- F/_ y S. A B _d x $=
      ( vk cc0 co cv cr cdiv cre cfv cle citg2 cmul nfcv nfov nffv citg c3 cexp
      cfz ci wcel wbr cif cmpt csu eqid dfitg nfcri nfbr nfan nfif nfmpt nfcxfr
      wa nfsum ) BACDUAHUBUDIZUEGJUCIZAKAJCUFZHDVBLIZMNZOUGZUSZVEHUHZUIZPNZQIZG
      UJACDVEGVEUKULBVAVKGBVARBVBVJQBVBRZBQRBVIPBPRBAKVHBKRVGBVEHVCVFBBACEUMBHV
      EOBHRZBORBVDMBMRBDVBLFBLRVLSTZUNUOVNVMUPUQTSUTUR $.
  $}

  ${
    $d k x y z $.  $d k x y z A $.  $d k z B $.  $d k z C $.
    cbvitg.1 $e |- ( x = y -> B = C ) $.
    ${
      cbvitg.2 $e |- F/_ y B $.
      cbvitg.3 $e |- F/_ x C $.
      $( Change bound variable in an integral.  (Contributed by Mario Carneiro,
         28-Jun-2014.) $)
      cbvitg $p |- S. A B _d x = S. A C _d y $=
        ( vk cc0 co cv cr wcel cdiv cre cfv cle citg2 nfcv c3 cfz ci wbr wa cif
        cexp cmpt cmul csu citg wceq nfv nfov nffv nfbr nfan nfif oveq1d fveq2d
        eleq1 breq2d anbi12d eqidd ifbieq12d cbvmpt oveq2d sumeq2i eqid 3eqtr4i
        a1i dfitg ) JUAUBKZUCILZUGKZAMALZCNZJDVOOKZPQZRUDZUEZVSJUFZUHZSQZUIKZIU
        JVMVOBMBLZCNZJEVOOKZPQZRUDZUEZWIJUFZUHZSQZUIKZIUJACDUKBCEUKVMWEWOIVNVMN
        ZWDWNVOUIWPWCWMSWCWMULWPABMWBWLWABVSJVQVTBVQBUMBJVSRBJTZBRTBVRPBPTBDVOO
        GBOTBVOTUNUOZUPUQWRWQURWKAWIJWGWJAWGAUMAJWIRAJTZARTAWHPAPTAEVOOHAOTAVOT
        UNUOZUPUQWTWSURVPWFULZWAWKVSJWIJXAVQWGVTWJVPWFCVAXAVSWIJRXAVRWHPXADEVOO
        FUSUTZVBVCXBXAJVDVEVFVKUTVGVHACDVSIVSVIVLBCEWIIWIVIVLVJ $.
    $}

    $d y B $.  $d x C $.
    $( Change bound variable in an integral.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    cbvitgv $p |- S. A B _d x = S. A C _d y $=
      ( nfcv cbvitg ) ABCDEFBDGAEGH $.
  $}

  ${
    $d k x $.  $d k A $.  $d k B $.  $d k C $.
    $( Equality theorem for an integral.  (Contributed by Mario Carneiro,
       28-Jun-2014.) $)
    itgeq2 $p |- ( A. x e. A B = C -> S. A B _d x = S. A C _d x ) $=
      ( vk wceq wral cc0 co cv cr wcel cdiv cre cfv cle citg2 cmul eqid wn cexp
      c3 cfz ci wbr wa cif cmpt citg wi simpl con3i iffalse eqtr4d oveq1 fveq2d
      csu syl breq2d anbi2d eqidd ifbieq12d ja ralimi2 mpteq12 oveq2d sumeq2sdv
      a1d sylancr dfitg 3eqtr4g ) CDFZABGZHUBUCIZUDEJUAIZAKAJZBLZHCVOMIZNOZPUEZ
      UFZVSHUGZUHZQOZRIZEUQVNVOAKVQHDVOMIZNOZPUEZUFZWGHUGZUHZQOZRIZEUQABCUIABDU
      IVMVNWEWMEVMWDWLVORVMWCWKQVMKKFWBWJFZAKGWCWKFKSVLWNABKVQVLUJWNVPKLVQVLWNV
      QTZWBHWJWOWATWBHFWAVQVQVTUKULWAVSHUMURWOWITWJHFWIVQVQWHUKULWIWGHUMURUNVLW
      AWIVSHWGHVLVTWHVQVLVSWGHPVLVRWFNCDVOMUOUPZUSUTWPVLHVAVBVCVHVDAKWBKWJVEVIU
      PVFVGABCVSEVSSVJABDWGEWGSVJVK $.

    $( The domain of an integral only matters in its intersection with
       ` RR ` .  (Contributed by Mario Carneiro, 29-Jun-2014.) $)
    itgresr $p |- S. A B _d x = S. ( A i^i RR ) B _d x $=
      ( vk cc0 c3 cfz co cv cr wcel cfv wa cif cmpt citg2 cmul csu citg dfitg
      ci cexp cdiv cre cle wbr cin simpr biantrud elin syl6bbr anbi1d mpteq2dva
      ifbid fveq2d oveq2d sumeq2i eqid 3eqtr4i ) EFGHZUADIZUBHZAJAIZBKZECVBUCHU
      DLZUEUFZMZVEENZOZPLZQHZDRUTVBAJVCBJUGZKZVFMZVEENZOZPLZQHZDRABCSAVLCSUTVKV
      RDVAUTKZVJVQVBQVSVIVPPVSAJVHVOVSVCJKZMZVGVNVEEWAVDVMVFWAVDVDVTMVMWAVTVDVS
      VTUHUIVCBJUJUKULUNUMUOUPUQABCVEDVEURZTAVLCVEDWBTUS $.

    $( The integral of anything on the empty set is zero.  (Contributed by
       Mario Carneiro, 13-Aug-2014.) $)
    itg0 $p |- S. (/) A _d x = 0 $=
      ( vk c0 cc0 c3 co ci cv wcel cfv cif cmpt citg2 cmul csu wceq ax-mp eqtri
      cr citg cfz cexp cdiv cre cle wbr wa eqid dfitg csn cxp ifan noel iffalse
      wn mpteq2i fconstmpt eqtr4i fveq2i itg20 oveq2i cc ax-icn elfznn0 sylancr
      cn0 expcl mul01d syl5eq sumeq2i cuz wss cfn wo fzfi olci sumz ) ADBUAEFUB
      GZHCIZUCGZATAIZDJZEBWAUDGUEKZUFUGZUHWDELZMZNKZOGZCPZEADBWDCWDUIUJWJVSECPZ
      EVSWIECVTVSJZWIWAEOGEWHEWAOWHTEUKULZNKEWGWMNWGATEMWMATWFEWFWCWEWDELZELZEW
      CWEWDEUMWCUPWOEQWBUNWCWNEUORSUQATEURUSUTVASVBWLWAWLHVCJVTVGJWAVCJVDVTFVEH
      VTVHVFVIVJVKVSEVLKVMZVSVNJZVOWKEQWQWPEFVPVQVSCEVRRSS $.

    $( The integral of zero on any set is zero.  (Contributed by Mario
       Carneiro, 29-Jun-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itgz $p |- S. A 0 _d x = 0 $=
      ( vk cc0 c3 co ci cv cr wcel cre cfv cif cmpt citg2 cmul cc ax-icn syl6eq
      csu citg cfz cexp cdiv cle wbr wa dfitg csn cxp cn0 elfznn0 expcl sylancr
      eqid cz wne elfzelz ine0 expne0i mp3an12 syl div0d fveq2d re0 ifeq1d ifid
      mpteq2dv fconstmpt syl6eqr itg20 oveq2d mul01d eqtrd sumeq2i cuz wss wceq
      cfn wo fzfi olci sumz ax-mp 3eqtri ) ABDUADEUBFZGCHZUCFZAIAHBJDDWHUDFZKLZ
      UEUFUGZWJDMZNZOLZPFZCTWFDCTZDABDWJCWJUOUHWFWODCWGWFJZWOWHDPFDWQWNDWHPWQWN
      IDUIUJZOLDWQWMWROWQWMAIDNWRWQAIWLDWQWLWKDDMDWQWKWJDDWQWJDKLDWQWIDKWQWHWQG
      QJZWGUKJWHQJRWGEULGWGUMUNZWQWGUPJZWHDUQZWGDEURWSGDUQXAXBRUSGWGUTVAVBVCVDV
      ESVFWKDVGSVHAIDVIVJVDVKSVLWQWHWTVMVNVOWFDVPLVQZWFVSJZVTWPDVRXDXCDEWAWBWFC
      DWCWDWE $.
  $}

  ${
    $d x ph $.
    itgeq2dv.1 $e |- ( ( ph /\ x e. A ) -> B = C ) $.
    $( Equality theorem for an integral.  (Contributed by Mario Carneiro,
       7-Jul-2014.) $)
    itgeq2dv $p |- ( ph -> S. A B _d x = S. A C _d x ) $=
      ( wceq wral citg ralrimiva itgeq2 syl ) ADEGZBCHBCDIBCEIGAMBCFJBCDEKL $.
  $}

  ${
    $d k x y z A $.  $d k y z B $.  $d k x ph $.  $d x V $.
    itgmpt.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( Change bound variable in an integral.  (Contributed by Mario Carneiro,
       29-Jun-2014.) $)
    itgmpt $p |- ( ph -> S. A B _d x = S. A ( ( x e. A |-> B ) ` y ) _d y ) $=
      ( cv cmpt cfv citg fveq2 nffvmpt1 nfcv cbvitg wcel wa wceq simpr eqid
      fvmpt2 syl2anc itgeq2dv syl5req ) ACDCHZBDEIZJZKBDBHZUFJZKBDEKCBDUGUIUEUH
      UFLBDEUEMCUINOABDUIEAUHDPZQUJEFPUIERAUJSGBDEFUFUFTUAUBUCUD $.

    itgcl.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( The integral of an integrable function is a complex number.
       (Contributed by Mario Carneiro, 29-Jun-2014.) $)
    itgcl $p |- ( ph -> S. A B _d x e. CC ) $=
      ( vk citg cc0 c3 co ci cv cr wcel cfv wa cc eqidd cfz cexp cdiv cre citg2
      cle wbr cif cmpt cmul csu dfitg fzfid ax-icn elfznn0 adantl expcl sylancr
      eqid cn0 cz elfzelz iblitg sylan2 recnd mulcld fsumcl syl5eqel ) ABCDIJKU
      ALZMHNZUBLZBOBNCPZJDVKUCLUDQZUFUGRVMJUHUIZUEQZUJLZHUKSBCDVMHVMUSULAVIVPHA
      JKUMAVJVIPZRZVKVOVRMSPVJUTPZVKSPUNVQVSAVJKUOUPMVJUQURVRVOVQAVJVAPVOOPVJJK
      VBABCDVMVNVJEAVNTAVLRVMTGFVCVDVEVFVGVH $.
  $}

  ${
    $d x k $.  $d x K $.
    itgvallem.1 $e |- ( _i ^ K ) = T $.
    $( Substitution lemma.  (Contributed by Mario Carneiro, 7-Jul-2014.)
       (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itgvallem $p |- ( k = K -> ( S.2 ` ( x e. RR |->
        if ( ( x e. A /\ 0 <_ ( Re ` ( B / ( _i ^ k ) ) ) ) ,
             ( Re ` ( B / ( _i ^ k ) ) ) , 0 ) ) ) =
             ( S.2 ` ( x e. RR |->
        if ( ( x e. A /\ 0 <_ ( Re ` ( B / T ) ) ) ,
             ( Re ` ( B / T ) ) , 0 ) ) ) ) $=
      ( cv cr cc0 ci cexp co cdiv cre cfv cle wbr wa cif wceq wcel citg2 syl6eq
      cmpt oveq2 oveq2d fveq2d breq2d anbi2d eqidd ifbieq12d mpteq2dv ) EHZFUAZ
      AIAHBUBZJCKUNLMZNMZOPZQRZSZUSJTZUEAIUPJCDNMZOPZQRZSZVDJTZUEUCUOAIVBVGUOVA
      VFUSJVDJUOUTVEUPUOUSVDJQUOURVCOUOUQDCNUOUQKFLMDUNFKLUFGUDUGUHZUIUJVHUOJUK
      ULUMUH $.
  $}

  ${
    $d x ph $.
    itgvallem3.1 $e |- ( ( ph /\ x e. A ) -> B = 0 ) $.
    $( Lemma for ~ itgposval and ~ itgreval .  (Contributed by Mario Carneiro,
       7-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itgvallem3 $p |- ( ph ->
      ( S.2 ` ( x e. RR |-> if ( ( x e. A /\ 0 <_ B ) , B , 0 ) ) ) = 0 ) $=
      ( cr cv wcel cc0 cle wbr wa cif cmpt citg2 cfv csn cxp wceq syl6eq fveq2d
      adantrr ifeq1da ifid mpteq2dv fconstmpt syl6eqr itg20 ) ABFBGCHZIDJKZLZDI
      MZNZOPFIQRZOPIAUMUNOAUMBFINUNABFULIAULUKIIMIAUKDIIAUIDISUJEUBUCUKIUDTUEBF
      IUFUGUAUHT $.
  $}

  ${
    $d k x A $.
    $( The zero function is integrable on any measurable set.  (Unlike
       ~ iblconst , this does not require ` A ` to have finite measure.)
       (Contributed by Mario Carneiro, 23-Aug-2014.) $)
    ibl0 $p |- ( A e. dom vol -> ( A X. { 0 } ) e. L^1 ) $=
      ( vx vk cvol cdm wcel cc0 csn cr cv ci co cre cfv wa c3 wceq eqidd c0ex
      cc cxp cibl cmbf cexp cdiv cle wbr cif cmpt citg2 cfz wral mbfconst mpan2
      0cn elfzelz ad2antlr wne ax-icn ine0 w3a expclz expne0i div0d mp3an12 syl
      cz fveq2d re0 syl6eq itgvallem3 0re syl6eqel ralrimiva wf fconst fdm mp1i
      fvconst2 adantl isibl mpbir2and ) ADEFZAGHZUAZUBFWEUCFZBIBJZAFZGGKCJZUDLZ
      UELZMNZUFUGOWLGUHUIZUJNZIFZCGPUKLZULWCGTFWFUOAGUMUNWCWOCWPWCWIWPFZOZWNGIW
      RBAWLWRWHOZWLGMNGWSWKGMWSWIVGFZWKGQZWQWTWCWHWIGPUPUQKTFZKGURZWTXAUSUTXBXC
      WTVAWJKWIVBKWIVCVDVEVFVHVIVJVKVLVMVNWCBAGWLCWEWMWCWMRWCWHOWLRAWDWEVOWEEAQ
      WCAGSVPAWDWEVQVRWHWGWENGQWCAGWGSVSVTWAWB $.
  $}

  ${
    $d k x A $.  $d k B $.  $d k x ph $.  $d x V $.
    itgcnlem.r $e |- R = ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ ( Re ` B ) ) , ( Re ` B ) , 0 ) ) ) $.
    itgcnlem.s $e |- S = ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ -u ( Re ` B ) ) , -u ( Re ` B ) , 0 ) ) ) $.
    itgcnlem.t $e |- T = ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ ( Im ` B ) ) , ( Im ` B ) , 0 ) ) ) $.
    itgcnlem.u $e |- U = ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ -u ( Im ` B ) ) , -u ( Im ` B ) , 0 ) ) ) $.
    ${
      itgcnlem1.v $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
      $( Lemma for ~ iblcnlem .  (Contributed by Mario Carneiro, 6-Aug-2014.)
         (Revised by Mario Carneiro, 23-Aug-2014.) $)
      iblcnlem1 $p |- ( ph ->
        ( ( x e. A |-> B ) e. L^1 <-> ( ( x e. A |-> B ) e. MblFn /\
          ( R e. RR /\ S e. RR ) /\ ( T e. RR /\ U e. RR ) ) ) ) $=
        ( wcel cr cc0 co cfv wa c1 vk cmpt cibl cmbf cv ci cexp cre cle wbr cif
        cdiv citg2 c3 cfz wral w3a cc eqidd isibl2 cpr c2 cz 0z 1ex wceq ax-icn
        elexi ax-mp itgvallem eleq1d ralpr div1d fveq2d ibllem mpteq2dv syl6eqr
        exp0 exp1 cim imval syl syl5req anbi12d syl5bb cneg cn0 2nn0 3nn0 i2 i3
        renegd ax-1cn negnegi oveq2i negcld wne ax-1ne0 negne0i div2neg mp3an23
        syl5eq negcli eqtr3d imnegd eqcomi ine0 3eqtr3d cun 1re 3re 1lt3 ltleii
        caddc cuz 1nn0 nn0uz eleqtri nn0zi elfz5 mp2an mpbir fzsplit fzpr 1e0p1
        wb preq2i 3eqtr4i 2z 1p1e2 df-3 oveq12i uneq12i eqtri raleqi ralunb an4
        bitri 3bitr4g anbi2d 3anass syl6bbr bitrd ) ABCDUBZUCNUUDUDNZBOBUECNZPD
        UFUAUEZUGQULQUHRZUIUJSUUHPUKUBZUMRZONZUAPUNUOQZUPZSZUUEEONZFONZSZGONZHO
        NZSZUQZABCDUUHUAUUIURAUUIUSAUUFSZUUHUSMUTAUUNUUEUUQUUTSZSUVAAUUMUVCUUEA
        UUKUAPTVAZUPZUUKUAVBUNVAZUPZSZUUOUURSZUUPUUSSZSUUMUVCAUVEUVIUVGUVJUVEBO
        UUFPDTULQZUHRZUIUJSUVLPUKZUBZUMRZONZBOUUFPDUFULQUHRZUIUJSUVQPUKZUBZUMRZ
        ONZSAUVIUUKUVPUWAUAPTPVCVDVHVEUUGPVFUUJUVOOBCDTUAPUFURNZUFPUGQTVFVGUFVR
        VIVJVKUUGTVFUUJUVTOBCDUFUATUWBUFTUGQUFVFVGUFVSVIVJVKVLAUVPUUOUWAUURAUVO
        EOAUVOBOUUFPDUHRZUIUJSUWCPUKZUBZUMREAUVNUWEUMABOUVMUWDABCUVLUWCUVBUVKDU
        HUVBDMVMVNVOVPVNIVQVKAUVTGOAGBOUUFPDVTRZUIUJSUWFPUKZUBZUMRUVTKAUWHUVSUM
        ABOUWGUVRABCUWFUVQUVBDURNZUWFUVQVFMDWAWBVOVPVNWCVKWDWEUVGBOUUFPDTWFZULQ
        ZUHRZUIUJSUWLPUKZUBZUMRZONZBOUUFPDUFWFZULQZUHRZUIUJSUWSPUKZUBZUMRZONZSA
        UVJUUKUWPUXCUAVBUNVBWGWHVHUNWGWIVHUUGVBVFUUJUWOOBCDUWJUAVBWJVJVKUUGUNVF
        UUJUXBOBCDUWQUAUNWKVJVKVLAUWPUUPUXCUUSAUWOFOAFBOUUFPUWCWFZUIUJSUXDPUKZU
        BZUMRUWOJAUXFUWNUMABOUXEUWMABCUXDUWLUVBDWFZUHRUXDUWLUVBDMWLUVBUXGUWKUHU
        VBUXGUWJWFZULQZUXGUWKUVBUXIUXGTULQUXGUXHTUXGULTWMWNWOUVBUXGUVBDMWPZVMXB
        UVBUWIUXIUWKVFZMUWIUWJURNUWJPWQUXKTWMXCTWMWRWSDUWJWTXAWBXDVNXDVOVPVNWCV
        KAUXBHOAHBOUUFPUWFWFZUIUJSUXLPUKZUBZUMRUXBLAUXNUXAUMABOUXMUWTABCUXLUWSU
        VBUXGVTRZUXGUFULQZUHRZUXLUWSUVBUXGURNUXOUXQVFUXJUXGWAWBUVBDMXEUVBUXPUWR
        UHUVBUXPUXGUWQWFZULQZUWRUFUXRUXGULUXRUFUFVGWNXFWOUVBUWIUXSUWRVFZMUWIUWQ
        URNUWQPWQUXTUFVGXCUFVGXGWSDUWQWTXAWBXBVNXHVOVPVNWCVKWDWEWDUUMUUKUAUVDUV
        FXIZUPUVHUUKUAUULUYAUULPTUOQZTTXNQZUNUOQZXIZUYATUULNZUULUYEVFUYFTUNUIUJ
        ZTUNXJXKXLXMTPXORZNUNVCNUYFUYGYFTWGUYHXPXQXRUNWIXSTPUNXTYAYBTPUNYCVIUYB
        UVDUYDUVFPPTXNQZUOQZPUYIVAZUYBUVDPVCNUYJUYKVFVDPYDVITUYIPUOYEWOTUYIPYEY
        GYHVBVBTXNQZUOQZVBUYLVAZUYDUVFVBVCNUYMUYNVFYIVBYDVIUYCVBUNUYLUOYJYKYLUN
        UYLVBYKYGYHYMYNYOUUKUAUVDUVFYPYRUUOUUPUURUUSYQYSYTUUEUUQUUTUUAUUBUUC $.
    $}

    itgcnlem.v $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( Expand out the forall in ~ isibl2 .  (Contributed by Mario Carneiro,
       6-Aug-2014.) $)
    iblcnlem $p |- ( ph ->
      ( ( x e. A |-> B ) e. L^1 <-> ( ( x e. A |-> B ) e. MblFn /\
        ( R e. RR /\ S e. RR ) /\ ( T e. RR /\ U e. RR ) ) ) ) $=
      ( wcel cr wa cc0 cfv wceq cmpt cmbf cibl w3a wi iblmbf a1i simp1 wb cc cv
      cif cre cle wbr citg2 cneg cim eqid 0cn elimel iblcnlem1 adantr wral mbff
      wf cdm ralrimiva fnmpt fndm 3syl feq2d biimpa sylan2 sylibr iftrue ralimi
      wfn fmpt syl mpteq12 sylancr eleq1d imim2i imp fveq2d a1d ralimi2 syl6eqr
      ibllem negeqd anbi12d 3anbi123d 3bitr3d ex pm5.21ndd ) ABCDUAZUBOZWQUCOZW
      REPOZFPOZQZGPOZHPOZQZUDZWSWRUEAWQUFUGXFWRUEAWRXBXEUHUGAWRWSXFUIAWRQZBCDUJ
      OZDRULZUAZUCOZXJUBOZBPBUKZCOZRXIUMSZUNUOQXORULZUAZUPSZPOZBPXNRXOUQZUNUOQX
      TRULZUAZUPSZPOZQZBPXNRXIURSZUNUOQYFRULZUAZUPSZPOZBPXNRYFUQZUNUOQYKRULZUAZ
      UPSZPOZQZUDZWSXFAXKYQUIWRABCXIXRYCYIYNXRUSYCUSYIUSYNUSXIUJOAXNQDRUJUTVAUG
      VBVCXGXJWQUCXGCCTXIDTZBCVDZXJWQTCUSXGXHBCVDZYSXGCUJWQVFZYTWRAWQVGZUJWQVFZ
      UUAWQVEAUUCUUAAUUBCUJWQADIOZBCVDWQCVRUUBCTAUUDBCNVHBCDWQIWQUSZVICWQVJVKVL
      VMVNBCUJDWQUUEVSVOZXHYRBCXHDRVPZVQVTBCXICDWAWBZWCXGXLWRYEXBYPXEXGXJWQUBUU
      HWCXGXSWTYDXAXGXREPXGXRBPXNRDUMSZUNUOQUUIRULZUAZUPSEXGXQUUKUPXGPPTZXPUUJT
      ZBPVDZXQUUKTPUSZXGYTUUNUUFXHUUMBCPXNXHUEZUUMXMPOZUUPBCXOUUIUUPXNQZXIDUMUU
      PXNYRXHYRXNUUGWDWEZWFZWJWGWHVTBPXPPUUJWAWBWFJWIWCXGYCFPXGYCBPXNRUUIUQZUNU
      OQUVARULZUAZUPSFXGYBUVCUPXGUULYAUVBTZBPVDZYBUVCTUUOXGYTUVEUUFXHUVDBCPUUPU
      VDUUQUUPBCXTUVAUURXOUUIUUTWKWJWGWHVTBPYAPUVBWAWBWFKWIWCWLXGYJXCYOXDXGYIGP
      XGYIBPXNRDURSZUNUOQUVFRULZUAZUPSGXGYHUVHUPXGUULYGUVGTZBPVDZYHUVHTUUOXGYTU
      VJUUFXHUVIBCPUUPUVIUUQUUPBCYFUVFUURXIDURUUSWFZWJWGWHVTBPYGPUVGWAWBWFLWIWC
      XGYNHPXGYNBPXNRUVFUQZUNUOQUVLRULZUAZUPSHXGYMUVNUPXGUULYLUVMTZBPVDZYMUVNTU
      UOXGYTUVPUUFXHUVOBCPUUPUVOUUQUUPBCYKUVLUURYFUVFUVKWKWJWGWHVTBPYLPUVMWAWBW
      FMWIWCWLWMWNWOWP $.

    itgcnlem.i $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( Expand out the sum in ~ dfitg .  (Contributed by Mario Carneiro,
       1-Aug-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itgcnlem $p |- ( ph ->
      S. A B _d x = ( ( R - S ) + ( _i x. ( T - U ) ) ) ) $=
      ( co ci cmul cc0 wcel vk citg cmin caddc cneg c3 cfz cv cexp cdiv cre cfv
      cr cle wbr wa cif cmpt citg2 csu eqid dfitg cn0 wceq c2 nn0uz df-3 syl6eq
      oveq2 i3 itgvallem oveq12d cc ax-icn a1i expcl sylan cz nn0z eqidd iblitg
      recnd sylan2 mulcld c1 df-2 i2 1e0p1 exp1 ax-mp cibl cmbf iblmbf mbfmptcl
      0z syl div1d fveq2d ibllem mpteq2dv syl6reqr oveq2d iblcnlem mpbid simp2d
      w3a simpld mulid2d eqtr3d eqeltrd exp0 fsum1 sylancr eqtrd 0nn0 jctil cim
      syl5req fsump1i renegd ax-1cn negnegi oveq2i negcld syl5eq negcli ax-1ne0
      imval negne0i div2neg mp3an23 simprd mulm1d simp3d addcld negsubd addsubd
      wne mulcl 3eqtrd imnegd eqcomi 3eqtr3d mulneg12 subcld addassd adddid
      ine0 ) ABCDUBZEFUCPZQGRPZUDPZQHUEZRPZUDPZUUJUUKUUNUDPZUDPUUJQGHUCPZRPZUDP
      AUUISUFUGPQUAUHZUIPZBUMBUHCTZSDUUTUJPUKULZUNUOUPUVBSUQURZUSULZRPZUAUTZUUO
      BCDUVBUAUVBVAVBAUFVCTUVFUUOVDAUVEQUEZBUMUVASDUVGUJPZUKULZUNUOUPUVISUQZURZ
      USULZRPZUULUUOUAVESUFVCVFVGUUSUFVDZUUTUVGUVDUVLRUVNUUTQUFUIPUVGUUSUFQUIVI
      VJVHBCDUVGUAUFVJVKVLAUUSVCTZUPUUTUVDAQVMTZUVOUUTVMTUVPAVNVOZQUUSVPVQUVOAU
      USVRTZUVDVMTUUSVSAUVRUPUVDABCDUVBUVCUUSIAUVCVTAUVAUPZUVBVTONWAWBWCWDZAUVE
      WEUEZBUMUVASDUWAUJPZUKULZUNUOUPUWCSUQZURZUSULZRPZEUUKUDPZUULUAWESVEVCVFWF
      UUSVEVDZUUTUWAUVDUWFRUWIUUTQVEUIPUWAUUSVEQUIVIWGVHBCDUWAUAVEWGVKVLUVTAUVE
      QBUMUVASDQUJPUKULZUNUOUPUWJSUQZURZUSULZRPZEUWHUASSWEVCVFWHUUSWEVDZUUTQUVD
      UWMRUWOUUTQWEUIPZQUUSWEQUIVIUVPUWPQVDVNQWIWJZVHBCDQUAWEUWQVKVLUVTASSUGPUV
      EUAUTZEVDSVCTAUWRWEBUMUVASDWEUJPZUKULZUNUOUPUWTSUQZURZUSULZRPZEASVRTUXDVM
      TUWRUXDVDWOAUXDEVMAWEERPUXDEAEUXCWERAUXCBUMUVASDUKULZUNUOUPUXESUQZURZUSUL
      EAUXBUXGUSABUMUXAUXFABCUWTUXEUVSUWSDUKUVSDABCDIABCDURZWKTZUXHWLTZOUXHWMWP
      NWNZWQWRWSWTWRJXAXBAEAEAEUMTZFUMTZAUXJUXLUXMUPZGUMTZHUMTZUPZAUXIUXJUXNUXQ
      XFOABCDEFGHIJKLMNXCXDZXEZXGWBZXHXIZUXTXJUVEUXDUASUUSSVDZUUTWEUVDUXCRUYBUU
      TQSUIPZWEUUSSQUIVIUVPUYCWEVDVNQXKWJZVHBCDWEUASUYDVKVLXLXMUYAXNXOXPAUWNUUK
      EUDAUWMGQRAGBUMUVASDXQULZUNUOUPUYESUQZURZUSULUWMLAUYGUWLUSABUMUYFUWKABCUY
      EUWJUVSDVMTZUYEUWJVDUXKDYHWPWSWTWRXRXBXBXSAUWHUWGUDPUWHFUEZUDPUWHFUCPUULA
      UWGUYIUWHUDAUWAFRPUWGUYIAFUWFUWARAFBUMUVASUXEUEZUNUOUPUYJSUQZURZUSULUWFKA
      UYLUWEUSABUMUYKUWDABCUYJUWCUVSDUEZUKULUYJUWCUVSDUXKXTUVSUYMUWBUKUVSUYMUWA
      UEZUJPZUYMUWBUVSUYOUYMWEUJPUYMUYNWEUYMUJWEYAYBYCUVSUYMUVSDUXKYDZWQYEUVSUY
      HUYOUWBVDZUXKUYHUWAVMTUWASYRUYQWEYAYFWEYAYGYIDUWAYJYKWPXIWRXIWSWTWRYEXBAF
      AFAUXLUXMUXSYLWBZYMXIXBAUWHFAEUUKUXTAUVPGVMTUUKVMTVNAGAUXOUXPAUXJUXNUXQUX
      RYNZXGWBZQGYSXMZYOUYRYPAEUUKFUXTVUAUYRYQYTXSAUVMUUNUULUDAUVGHRPZUVMUUNAHU
      VLUVGRAHBUMUVASUYEUEZUNUOUPVUCSUQZURZUSULUVLMAVUEUVKUSABUMVUDUVJABCVUCUVI
      UVSUYMXQULZUYMQUJPZUKULZVUCUVIUVSUYMVMTVUFVUHVDUYPUYMYHWPUVSDUXKUUAUVSVUG
      UVHUKUVSVUGUYMUVGUEZUJPZUVHQVUIUYMUJVUIQQVNYBUUBYCUVSUYHVUJUVHVDZUXKUYHUV
      GVMTUVGSYRVUKQVNYFQVNUUHYIDUVGYJYKWPYEWRUUCWSWTWRYEXBAUVPHVMTVUBUUNVDVNAH
      AUXOUXPUYSYLWBZQHUUDXMXIXBXSYLYEAUUJUUKUUNAEFUXTUYRUUEVUAAUVPUUMVMTUUNVMT
      VNAHVULYDZQUUMYSXMUUFAUUPUURUUJUDAQGUUMUDPZRPUUPUURAQGUUMUVQUYTVUMUUGAVUN
      UUQQRAGHUYTVULYPXBXIXBYT $.
  $}

  ${
    $d x A $.  $d x ph $.
    iblrelem.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    $( Integrability of a real function.  (Contributed by Mario Carneiro,
       31-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    iblrelem $p |- ( ph -> ( ( x e. A |-> B ) e. L^1 <->
      ( ( x e. A |-> B ) e. MblFn /\
        ( S.2 ` ( x e. RR |->
          if ( ( x e. A /\ 0 <_ B ) , B , 0 ) ) ) e. RR /\
        ( S.2 ` ( x e. RR |->
          if ( ( x e. A /\ 0 <_ -u B ) , -u B , 0 ) ) ) e. RR ) ) ) $=
      ( cmpt wcel cr cc0 cfv cle wbr wa cif citg2 cneg w3a eqid itgvallem3 0re
      cibl cmbf cv cre cim iblcnlem reim0d syl6eqel negeqd neg0 syl6eq biantrud
      jca rered ibllem fveq2d eleq1d anbi12d bitr3d anbi2d 3anass 3bitr4g bitrd
      mpteq2dv ) ABCDFZUAGVEUBGZBHBUCCGZIDUDJZKLMVHINZFZOJZHGZBHVGIVHPZKLMVMINZ
      FZOJZHGZMZBHVGIDUEJZKLMVSINFOJZHGZBHVGIVSPZKLMWBINFOJZHGZMZQZVFBHVGIDKLMD
      INZFZOJZHGZBHVGIDPZKLMWKINZFZOJZHGZQZABCDVKVPVTWCHVKRVPRVTRWCREUFAVFVRWEM
      ZMVFWJWOMZMWFWPAWQWRVFAVRWQWRAWEVRAWAWDAVTIHABCVSAVGMZDEUGZSTUHAWCIHABCWB
      WSWBIPIWSVSIWTUIUJUKSTUHUMULAVLWJVQWOAVKWIHAVJWHOABHVIWGABCVHDWSDEUNZUOVD
      UPUQAVPWNHAVOWMOABHVNWLABCVMWKWSVHDXAUIUOVDUPUQURUSUTVFVRWEVAVFWJWOVAVBVC
      $.

    ${
      iblpos.2 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
      $( Lemma for ~ iblpos .  (Contributed by Mario Carneiro, 31-Jul-2014.)
         (Revised by Mario Carneiro, 23-Aug-2014.) $)
      iblposlem $p |- ( ph -> ( S.2 ` ( x e. RR |->
        if ( ( x e. A /\ 0 <_ -u B ) , -u B , 0 ) ) ) = 0 ) $=
        ( cr cv wcel cc0 cneg cle wbr wa cif cmpt citg2 cfv adantrr syl6eq wceq
        csn cxp le0neg2d mpbid simprr wb renegcld 0re sylancl mpbir2and ifeq1da
        letri3 ifid mpteq2dv fconstmpt syl6eqr fveq2d itg20 ) ABGBHCIZJDKZLMZNZ
        VAJOZPZQRGJUBUCZQRJAVEVFQAVEBGJPVFABGVDJAVDVCJJOJAVCVAJJAVCNZVAJUAZVAJL
        MZVBAUTVIVBAUTNZJDLMVIFVJDEUDUESAUTVBUFVGVAGIJGIVHVIVBNUGVGDAUTDGIVBESU
        HUIVAJUMUJUKULVCJUNTUOBGJUPUQURUST $.

      $( Integrability of a nonnegative function.  (Contributed by Mario
         Carneiro, 31-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
      iblpos $p |- ( ph -> ( ( x e. A |-> B ) e. L^1 <->
        ( ( x e. A |-> B ) e. MblFn /\
          ( S.2 ` ( x e. RR |-> if ( x e. A , B , 0 ) ) ) e. RR ) ) ) $=
        ( cmpt cibl wcel cmbf cr cv cc0 cle wbr wa cif citg2 cfv cneg iblposlem
        w3a iblrelem df-3an syl6bb 0re syl6eqel biantrud pm4.71rd ancom syl6rbb
        ex ifbid mpteq2dv fveq2d eleq1d anbi2d 3bitr2d ) ABCDGZHIZUSJIZBKBLCIZM
        DNOZPZDMQZGZRSZKIZPZBKVBMDTZNOPVJMQGRSZKIZPZVIVABKVBDMQZGZRSZKIZPAUTVAV
        HVLUBVMABCDEUCVAVHVLUDUEAVLVIAVKMKABCDEFUAUFUGUHAVHVQVAAVGVPKAVFVORABKV
        EVNAVDVBDMAVBVCVBPVDAVBVCAVBVCFULUIVCVBUJUKUMUNUOUPUQUR $.
    $}

    $( Integrability of a real function.  (Contributed by Mario Carneiro,
       11-Aug-2014.) $)
    iblre $p |- ( ph -> ( ( x e. A |-> B ) e. L^1 <->
      ( ( x e. A |-> if ( 0 <_ B , B , 0 ) ) e. L^1 /\
        ( x e. A |-> if ( 0 <_ -u B , -u B , 0 ) ) e. L^1 ) ) ) $=
      ( cmpt cmbf wcel cr cc0 cle wbr wa cif citg2 cfv cibl ifan mpteq2i 0re cv
      cneg w3a mbfposb wb fveq2i eleq1i anbi12i a1i anbi12d 3anass an4 iblrelem
      3bitr4g ifcl sylancl max1 sylancr iblpos renegcld 3bitr4d ) ABCDFZGHZBIBU
      ACHZJDKLZMDJNZFZOPZIHZBIVDJDUBZKLZMVJJNZFZOPZIHZUCZBCVEDJNZFZGHZBIVDVQJNZ
      FZOPZIHZMZBCVKVJJNZFZGHZBIVDWEJNZFZOPZIHZMZMZVBQHVRQHZWFQHZMAVCVIVOMZMVSW
      GMZWCWKMZMVPWMAVCWQWPWRABCDEUDWPWRUEAVIWCVOWKVHWBIVGWAOBIVFVTVDVEDJRSUFUG
      VNWJIVMWIOBIVLWHVDVKVJJRSUFUGUHUIUJVCVIVOUKVSWCWGWKULUNABCDEUMAWNWDWOWLAB
      CVQAVDMZDIHZJIHZVQIHETVEDJIUOUPWSXAWTJVQKLTEJDUQURUSABCWEWSVJIHZXAWEIHWSD
      EUTZTVKVJJIUOUPWSXAXBJWEKLTXCJVJUQURUSUJVA $.

    itgreval.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( Lemma for ~ itgposval and ~ itgreval .  (Contributed by Mario Carneiro,
       31-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    itgrevallem1 $p |- ( ph -> S. A B _d x =
 ( ( S.2 ` ( x e. RR |-> if ( ( x e. A /\ 0 <_ B ) , B , 0 ) ) ) -
   ( S.2 ` ( x e. RR |-> if ( ( x e. A /\ 0 <_ -u B ) , -u B , 0 ) ) ) ) ) $=
      ( cr wcel cc0 cfv cle wbr wa cif cmpt citg2 cneg cmin co ci citg cre cmul
      cv caddc eqid itgcnlem rered ibllem mpteq2dv fveq2d negeqd oveq12d reim0d
      cim itgvallem3 neg0 syl6eq subidi oveq2d ax-icn mul01i cmbf cibl iblrelem
      0cn w3a mpbid simp2d simp3d resubcld recnd addid1d 3eqtrd ) ABCDUABGBUDCH
      ZIDUBJZKLMVPINZOZPJZBGVOIVPQZKLMVTINZOZPJZRSZTBGVOIDUOJZKLMWEINOPJZBGVOIW
      EQZKLMWGINOPJZRSZUCSZUESBGVOIDKLMDINZOZPJZBGVOIDQZKLMWNINZOZPJZRSZIUESWRA
      BCDVSWCWFWHGVSUFWCUFWFUFWHUFEFUGAWDWRWJIUEAVSWMWCWQRAVRWLPABGVQWKABCVPDAV
      OMZDEUHZUIUJUKAWBWPPABGWAWOABCVTWNWSVPDWTULUIUJUKUMAWJTIUCSIAWIITUCAWIIIR
      SIAWFIWHIRABCWEWSDEUNZUPABCWGWSWGIQIWSWEIXAULUQURUPUMIVFUSURUTTVAVBURUMAW
      RAWRAWMWQABCDOZVCHZWMGHZWQGHZAXBVDHXCXDXEVGFABCDEVEVHZVIAXCXDXEXFVJVKVLVM
      VN $.

    ${
      itgposval.3 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
      $( The integral of a nonnegative function.  (Contributed by Mario
         Carneiro, 31-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
      itgposval $p |- ( ph -> S. A B _d x =
                        ( S.2 ` ( x e. RR |-> if ( x e. A , B , 0 ) ) ) ) $=
        ( citg cr wcel cc0 cle wbr wa cif cmpt citg2 cfv cmin co cv ex pm4.71rd
        cneg itgrevallem1 ancom syl6rbb ifbid mpteq2dv fveq2d iblposlem oveq12d
        cmbf cibl iblpos mpbid simprd recnd subid1d 3eqtrd ) ABCDHBIBUACJZKDLMZ
        NZDKOZPZQRZBIVAKDUDZLMNVGKOPQRZSTBIVADKOZPZQRZKSTVKABCDEFUEAVFVKVHKSAVE
        VJQABIVDVIAVCVADKAVAVBVANVCAVAVBAVAVBGUBUCVBVAUFUGUHUIUJABCDEGUKULAVKAV
        KABCDPZUMJZVKIJZAVLUNJVMVNNFABCDEGUOUPUQURUSUT $.
    $}

    $( Decompose the integral of a real function into positive and negative
       parts.  (Contributed by Mario Carneiro, 31-Jul-2014.) $)
    itgreval $p |- ( ph -> S. A B _d x =
                    ( S. A if ( 0 <_ B , B , 0 ) _d x -
                      S. A if ( 0 <_ -u B , -u B , 0 ) _d x ) ) $=
      ( citg cr wcel cc0 cle wbr wa cif cmpt citg2 cfv cmin 0re cibl cv cneg co
      itgrevallem1 ifcl sylancl w3a iblrelem mpbid simp1d mbfpos mpteq2i fveq2i
      cmbf ifan simp2d syl5eqelr max1 sylancr iblpos mpbir2and syl6eqr renegcld
      itgposval mbfneg simp3d oveq12d eqtr4d ) ABCDGBHBUACIZJDKLZMDJNZOZPQZBHVI
      JDUBZKLZMVNJNZOZPQZRUCBCVJDJNZGZBCVOVNJNZGZRUCABCDEFUDAVTVMWBVRRAVTBHVIVS
      JNZOZPQZVMABCVSAVIMZDHIZJHIZVSHIESVJDJHUEUFZABCVSOZTIWJUNIWEHIABCDEABCDOZ
      UNIZVMHIZVRHIZAWKTIWLWMWNUGFABCDEUHUIZUJZUKAWEVMHVLWDPBHVKWCVIVJDJUOULUMZ
      AWLWMWNWOUPUQABCVSWIWFWHWGJVSKLSEJDURUSZUTVAWRVDWQVBAWBBHVIWAJNZOZPQZVRAB
      CWAWFVNHIZWHWAHIWFDEVCZSVOVNJHUEUFZABCWAOZTIXEUNIXAHIABCVNXCABCDHEWPVEUKA
      XAVRHVQWTPBHVPWSVIVOVNJUOULUMZAWLWMWNWOVFUQABCWAXDWFWHXBJWAKLSXCJVNURUSZU
      TVAXGVDXFVBVGVH $.
  $}

  ${
    $d x A $.  $d x ph $.
    itgrecl.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    itgrecl.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( Real closure of an integral.  (Contributed by Mario Carneiro,
       11-Aug-2014.) $)
    itgrecl $p |- ( ph -> S. A B _d x e. RR ) $=
      ( citg cr cv wcel cc0 cle wbr wa cif cmpt citg2 cfv cneg cmin co cmbf w3a
      itgrevallem1 cibl iblrelem mpbid resubcl 3adant1 syl eqeltrd ) ABCDGBHBIC
      JZKDLMNDKOPQRZBHULKDSZLMNUNKOPQRZTUAZHABCDEFUDABCDPZUBJZUMHJZUOHJZUCZUPHJ
      ZAUQUEJVAFABCDEUFUGUSUTVBURUMUOUHUIUJUK $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x ph $.
    iblcn.1 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    $( Integrability of a complex function.  (Contributed by Mario Carneiro,
       6-Aug-2014.) $)
    iblcn $p |- ( ph -> ( ( x e. A |-> B ) e. L^1 <->
                  ( ( x e. A |-> ( Re ` B ) ) e. L^1 /\
                    ( x e. A |-> ( Im ` B ) ) e. L^1 ) ) ) $=
      ( cmpt cmbf wcel cr cc0 cfv cle wbr wa cif citg2 w3a cibl 3anass eqid cre
      cv cneg cim ismbfcn2 anbi1d 3bitr4g iblcnlem1 recld iblrelem syl6bb imcld
      an4 anbi12d 3bitr4d ) ABCDFZGHZBIBUBCHZJDUAKZLMNUSJOFPKZIHZBIURJUSUCZLMNV
      BJOFPKZIHZNZBIURJDUDKZLMNVFJOFPKZIHZBIURJVFUCZLMNVIJOFPKZIHZNZQZBCUSFZGHZ
      VENZBCVFFZGHZVLNZNZUPRHVNRHZVQRHZNAUQVEVLNZNVOVRNZWCNVMVTAUQWDWCABCDEUEUF
      UQVEVLSVOVEVRVLUMUGABCDUTVCVGVJUTTVCTVGTVJTEUHAWAVPWBVSAWAVOVAVDQVPABCUSA
      URNZDEUIUJVOVAVDSUKAWBVRVHVKQVSABCVFWEDEULUJVRVHVKSUKUNUO $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x V $.
    itgcnval.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgcnval.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( Decompose the integral of a complex function into real and imaginary
       parts.  (Contributed by Mario Carneiro, 6-Aug-2014.) $)
    itgcnval $p |- ( ph -> S. A B _d x =
      ( S. A ( Re ` B ) _d x + ( _i x. S. A ( Im ` B ) _d x ) ) ) $=
      ( citg cr wcel cc0 cfv cle wbr wa cif cmpt citg2 co eqid cv cre cneg cmin
      ci cmul caddc itgcnlem cibl cmbf iblmbf mbfmptcl recld iblcn mpbid simpld
      cim syl itgrevallem1 imcld simprd oveq2d oveq12d eqtr4d ) ABCDHBIBUACJZKD
      UBLZMNOVFKPQRLZBIVEKVFUCZMNOVHKPQRLZUDSZUEBIVEKDUQLZMNOVKKPQRLZBIVEKVKUCZ
      MNOVMKPQRLZUDSZUFSZUGSBCVFHZUEBCVKHZUFSZUGSABCDVGVIVLVNEVGTVITVLTVNTFGUHA
      VQVJVSVPUGABCVFAVEOZDABCDEABCDQZUIJZWAUJJGWAUKURFULZUMABCVFQUIJZBCVKQUIJZ
      AWBWDWEOGABCDWCUNUOZUPUSAVRVOUEUFABCVKVTDWCUTAWDWEWFVAUSVBVCVD $.

    $( Real part of an integral.  (Contributed by Mario Carneiro,
       14-Aug-2014.) $)
    itgre $p |- ( ph -> ( Re ` S. A B _d x ) = S. A ( Re ` B ) _d x ) $=
      ( citg cre cfv ci cim cmul co caddc wcel wa cmpt cibl itgrecl itgcnval cv
      fveq2d cmbf iblmbf syl recld iblcn mpbid simpld imcld simprd crred eqtrd
      mbfmptcl ) ABCDHZIJBCDIJZHZKBCDLJZHZMNONZIJURAUPVAIABCDEFGUAUCAURUTABCUQA
      BUBCPQZDABCDEABCDRZSPZVCUDPGVCUEUFFUOZUGABCUQRSPZBCUSRSPZAVDVFVGQGABCDVEU
      HUIZUJTABCUSVBDVEUKAVFVGVHULTUMUN $.

    $( Imaginary part of an integral.  (Contributed by Mario Carneiro,
       14-Aug-2014.) $)
    itgim $p |- ( ph -> ( Im ` S. A B _d x ) = S. A ( Im ` B ) _d x ) $=
      ( citg cim cfv cre ci cmul co caddc wcel wa cmpt cibl itgrecl itgcnval cv
      fveq2d cmbf iblmbf syl recld iblcn mpbid simpld imcld simprd crimd eqtrd
      mbfmptcl ) ABCDHZIJBCDKJZHZLBCDIJZHZMNONZIJUTAUPVAIABCDEFGUAUCAURUTABCUQA
      BUBCPQZDABCDEABCDRZSPZVCUDPGVCUEUFFUOZUGABCUQRSPZBCUSRSPZAVDVFVGQGABCDVEU
      HUIZUJTABCUSVBDVEUKAVFVGVHULTUMUN $.

    $( The negative of an integrable function is integrable.  (Contributed by
       Mario Carneiro, 25-Aug-2014.) $)
    iblneg $p |- ( ph -> ( x e. A |-> -u B ) e. L^1 ) $=
      ( cneg cmpt cibl wcel cfv cc0 cle wbr cif wa breq2d ifbieq12d mpteq2dva
      cre cim cv cmbf iblmbf syl mbfmptcl renegd eqidd iblcn mpbid simpld recld
      iblre simprd eqeltrd negeqd recnd negnegd eqtrd negcld mpbir2and imnegd
      imcld ) ABCDHZIJKBCVEUALZIJKZBCVEUBLZIJKZAVGBCMVFNOZVFMPZIZJKBCMVFHZNOZVM
      MPZIZJKAVLBCMDUALZHZNOZVRMPZIZJABCVKVTABUCCKQZVJVSVFMVRMWBVFVRMNWBDABCDEA
      BCDIZJKZWCUDKGWCUEUFFUGZUHZRWFWBMUIZSTABCMVQNOZVQMPZIZJKZWAJKZABCVQIJKZWK
      WLQAWMBCDUBLZIJKZAWDWMWOQGABCDWEUJUKZULABCVQWBDWEUMZUNUKZUOUPAVPWJJABCVOW
      IWBVNWHVMMVQMWBVMVQMNWBVMVRHVQWBVFVRWFUQWBVQWBVQWQURUSUTZRWSWGSTAWKWLWRUL
      UPABCVFWBVEWBDWEVAZUMUNVBAVIBCMVHNOZVHMPZIZJKBCMVHHZNOZXDMPZIZJKAXCBCMWNH
      ZNOZXHMPZIZJABCXBXJWBXAXIVHMXHMWBVHXHMNWBDWEVCZRXLWGSTABCMWNNOZWNMPZIZJKZ
      XKJKZAWOXPXQQAWMWOWPUOABCWNWBDWEVDZUNUKZUOUPAXGXOJABCXFXNWBXEXMXDMWNMWBXD
      WNMNWBXDXHHWNWBVHXHXLUQWBWNWBWNXRURUSUTZRXTWGSTAXPXQXSULUPABCVHWBVEWTVDUN
      VBABCVEWTUJVB $.

    $( Negation of an integral.  (Contributed by Mario Carneiro,
       25-Aug-2014.) $)
    itgneg $p |- ( ph -> -u S. A B _d x = S. A -u B _d x ) $=
      ( citg ci co cneg cr wcel cmpt cibl cc0 cle wbr cif cmin cre cfv cim cmul
      caddc cv wa cmbf iblmbf mbfmptcl recld iblcn mpbid simpld itgcl cc ax-icn
      syl imcld simprd mulcl sylancr 0re ifcl sylancl iblre renegcld negsubdi2d
      negdid itgreval negeqd negcld iblneg renegd breq2d eqidd itgeq2dv negnegd
      ifbieq12d recnd eqtrd oveq12d 3eqtr4d mulneg2 imnegd eqtr4d oveq2d eqtr3d
      wceq itgcnval ) ABCDUAUBZHZIBCDUCUBZHZUDJZUEJZKZBCDKZUAUBZHZIBCWRUCUBZHZU
      DJZUEJZBCDHZKBCWRHAWQWLKZWOKZUEJXDAWLWOABCWKLABUFCMUGZDABCDEABCDNZOMZXIUH
      MGXIUIURFUJZUKZABCWKNOMZBCWMNOMZAXJXMXNUGGABCDXKULUMZUNZUOAIUPMZWNUPMZWOU
      PMUQABCWMLXHDXKUSZAXMXNXOUTZUOZIWNVAVBVIAXFWTXGXCUEABCPWKQRZWKPSZHZBCPWKK
      ZQRZYEPSZHZTJZKYHYDTJZXFWTAYDYHABCYCLXHWKLMPLMZYCLMXLVCYBWKPLVDVEABCYCNOM
      ZBCYGNOMZAXMYLYMUGXPABCWKXLVFUMZUNUOABCYGLXHYELMYKYGLMXHWKXLVGVCYFYEPLVDV
      EAYLYMYNUTUOVHAWLYIABCWKXLXPVJVKAWTBCPWSQRZWSPSZHZBCPWSKZQRZYRPSZHZTJYJAB
      CWSXHWRXHDXKVLZUKABCWSNOMZBCXANOMZABCWRNOMUUCUUDUGABCDEFGVMZABCWRUUBULUMZ
      UNVJAYQYHUUAYDTABCYPYGXHYOYFWSPYEPXHWSYEPQXHDXKVNZVOUUGXHPVPZVSVQABCYTYCX
      HYSYBYRPWKPXHYRWKPQXHYRYEKWKXHWSYEUUGVKXHWKXHWKXLVTVRWAZVOUUIUUHVSVQWBWAW
      CAIWNKZUDJZXGXCAXQXRUUKXGWIUQYAIWNWDVBAUUJXBIUDABCPWMQRZWMPSZHZBCPWMKZQRZ
      UUOPSZHZTJZKZBCPXAQRZXAPSZHZBCPXAKZQRZUVDPSZHZTJZUUJXBAUUTUURUUNTJUVHAUUN
      UURABCUUMLXHWMLMYKUUMLMXSVCUULWMPLVDVEABCUUMNOMZBCUUQNOMZAXNUVIUVJUGXTABC
      WMXSVFUMZUNUOABCUUQLXHUUOLMYKUUQLMXHWMXSVGVCUUPUUOPLVDVEAUVIUVJUVKUTUOVHA
      UVCUURUVGUUNTABCUVBUUQXHUVAUUPXAPUUOPXHXAUUOPQXHDXKWEZVOUVLUUHVSVQABCUVFU
      UMXHUVEUULUVDPWMPXHUVDWMPQXHUVDUUOKWMXHXAUUOUVLVKXHWMXHWMXSVTVRWAZVOUVMUU
      HVSVQWBWFAWNUUSABCWMXSXTVJVKABCXAXHWRUUBUSAUUCUUDUUFUTVJWCWGWHWBWAAXEWPAB
      CDEFGWJVKABCWRUPUUBUUEWJWC $.
  $}

  ${
    $d k x A $.  $d x B $.  $d k C $.  $d k x ph $.  $d x V $.
    iblss.1 $e |- ( ph -> A C_ B ) $.
    iblss.2 $e |- ( ph -> A e. dom vol ) $.
    iblss.3 $e |- ( ( ph /\ x e. B ) -> C e. V ) $.
    iblss.4 $e |- ( ph -> ( x e. B |-> C ) e. L^1 ) $.
    $( A subset of an integrable function is integrable.  (Contributed by Mario
       Carneiro, 12-Aug-2014.) $)
    iblss $p |- ( ph -> ( x e. A |-> C ) e. L^1 ) $=
      ( wcel cr cc0 ci cle wbr wa cif syl eqidd vk cmpt cibl cmbf cexp cdiv cre
      cv cfv citg2 cfz wral cres wss wceq resmpt cvol cdm iblmbf mbfres syl2anc
      co c3 eqeltrrd cpnf cicc wf ifan simpll sselda sylan cxr mbfmptcl elfzelz
      cc cz ad3antlr wne ax-icn expclz mp3an12 expne0i divcld recld 0re sylancl
      ine0 ifcl rexrd max1 sylancr elxrge0 sylanbrc syldan wn 0xr 0le0 mpbir2an
      ifclda syl5eqel eqid fmptd iblitg sylan2 leidd breq1 ifboth iftrue adantl
      a1i cofr breqtrrd con3and iffalse 3brtr4d pm2.61dan 3brtr4g ralrimiva cvv
      ex reex ofrfval2 mpbird itg2le syl3anc itg2lecl isibl2 mpbir2and ) ABCEUB
      ZUCKYIUDKBLBUHZCKZMENUAUHZUEVBZUFVBZUGUIZOPZQYOMRZUBZUJUIZLKZUAMVCUKVBZUL
      ABDEUBZCUMZYIUDACDUNUUCYIUOGBDCEUPSAUUBUDKZCUQURKUUCUDKAUUBUCKUUDJUUBUSSZ
      HCUUBUTVAVDAYTUAUUAAYLUUAKZQZLMVEVFVBZYRVGZBLYJDKZYPQYOMRZUBZUJUIZLKZYSUU
      MOPZYTUUGBLYQUUHYRUUGYJLKZQZYQYKYPYOMRZMRZUUHYKYPYOMVHZUUQYKUURMUUHUUQYKU
      UJUURUUHKZUUQAYKUUJAUUFUUPVIZACDYJGVJZVKZUUQUUJQZUURVLKMUUROPZUVAUVEUURUV
      EYOLKZMLKZUURLKUVEYNUVEEYMUUQAUUJEVOKZUVBABDEFUUEIVMZVKUVEYLVPKZYMVOKZUUF
      UVKAUUPUUJYLMVCVNZVQZNVOKZNMVRZUVKUVLVSWGNYLVTWASUVEUVKYMMVRZUVNUVOUVPUVK
      UVQVSWGNYLWBWASWCWDZWEYPYOMLWHWFZWIUVEUVHUVGUVFWEUVRMYOWJWKZUURWLWMZWNMUU
      HKZUUQYKWOZQUWBMVLKMMOPZWPWQMWLWRZXJWSWTZYRXAXBZUUFAUVKUUNUVMABDEYOUULYLF
      AUULTAUUJQYOTJIXCXDUUGUUILUUHUULVGYRUULOXKPZUUOUWGUUGBLUUKUUHUULUUQUUKUUJ
      UURMRZUUHUUJYPYOMVHZUUQUUJUURMUUHUWAUWBUUQUUJWOZQZUWEXJWSWTZUULXAXBUUGUWH
      YQUUKOPZBLULUUGUWNBLUUQUUSUWIYQUUKOUUQUUJUUSUWIOPUVEUUSUURUWIOUVEUURUUROP
      ZUVFUUSUUROPZUVEUURUVSXEUVTYKUWOUVFUWPUURMUURUUSUUROXFMUUSUUROXFXGVAUUJUW
      IUURUOUUQUUJUURMXHXIXLUWLMMUUSUWIOUWDUWLWQXJUWLUWCUUSMUOUUQYKUUJUUQYKUUJU
      VDXTXMYKUURMXNSUWKUWIMUOUUQUUJUURMXNXIXOXPUUTUWJXQXRUUGBLYQUUKOYRUULXSUUH
      UUHLXSKUUGYAXJUWFUWMUUGYRTUUGUULTYBYCYRUULYDYEUUMYRYFYEXRABCEYOUAYRVOAYRT
      AYKQYOTAYKUUJUVIUVCUVJWNYGYH $.
  $}

  ${
    $d x A $.  $d k x B $.  $d k C $.  $d k x ph $.  $d x V $.
    iblss2.1 $e |- ( ph -> A C_ B ) $.
    iblss2.2 $e |- ( ph -> B e. dom vol ) $.
    iblss2.3 $e |- ( ( ph /\ x e. A ) -> C e. V ) $.
    iblss2.4 $e |- ( ( ph /\ x e. ( B \ A ) ) -> C = 0 ) $.
    iblss2.5 $e |- ( ph -> ( x e. A |-> C ) e. L^1 ) $.
    $( Change the domain of an integrability predicate.  (Contributed by Mario
       Carneiro, 13-Aug-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    iblss2 $p |- ( ph -> ( x e. B |-> C ) e. L^1 ) $=
      ( vk cmpt wcel cr cc0 ci wa cif wceq cibl cmbf cv cexp co cre cfv cle wbr
      cdiv citg2 c3 cfz iblmbf syl mbfss wss adantr sselda iftrue adantl eqtr4d
      wral ifid cdif simplll simpr simplr eldifd syl2anc oveq1d simpllr elfzelz
      wn cz cc wne ax-icn ine0 w3a expclz expne0i div0d mp3an12 3syl fveq2d re0
      eqtrd syl6eq ifeq1d ifeq1da iffalse 3eqtr4a pm2.61dan ifan mpteq2dv eqidd
      3eqtr4g iblitg sylan2 eqeltrd ralrimiva wo cun elun undif2 ssequn1 syl5eq
      sylib eleq2d syl5bbr mbfmptcl 0cn syl6eqel jaodan syldan isibl2 mpbir2and
      biimpar ) ABDEMZUANXTUBNBOBUCZDNZPEQLUCZUDUEZUJUEZUFUGZUHUIZRYFPSZMZUKUGZ
      ONZLPULUMUEZVCABCDEFGHIJABCEMZUANYMUBNKYMUNUOZUPAYKLYLAYCYLNZRZYJBOYACNZY
      GRYFPSZMZUKUGZOYPYIYSUKYPBOYHYRYPYBYGYFPSZPSZYQUUAPSZYHYRYPYQUUBUUCTYPYQR
      ZUUBUUAUUCUUDYBUUBUUATYPCDYAACDUQZYOGURUSYBUUAPUTUOYQUUCUUATYPYQUUAPUTVAV
      BYPYQVNZRZYBPPSPUUBUUCYBPVDUUGYBUUAPPUUGYBRZUUAYGPPSPUUHYGYFPPUUHYFPUFUGP
      UUHYEPUFUUHYEPYDUJUEZPUUHEPYDUJUUHAYADCVEZNZEPTAYOUUFYBVFUUHYADCUUGYBVGYP
      UUFYBVHVIJVJVKUUHYOYCVONZUUIPTZAYOUUFYBVLYCPULVMZQVPNZQPVQZUULUUMVRVSUUOU
      UPUULVTYDQYCWAQYCWBWCWDWEWHWFWGWIWJYGPVDWIWKUUFUUCPTYPYQUUAPWLVAWMWNYBYGY
      FPWOYQYGYFPWOWRWPWFYOAUULYTONUUNABCEYFYSYCFAYSWQAYQRYFWQKIWSWTXAXBABDEYFL
      YIVPAYIWQAYBRYFWQAYBYQUUKXCZEVPNZAUUQYBUUQYACUUJXDZNAYBYACUUJXEAUUSDYAAUU
      SCDXDZDCDXFAUUEUUTDTGCDXGXIXHXJXKXSAYQUURUUKABCEFYNIXLAUUKREPVPJXMXNXOXPX
      QXR $.
  $}

  ${
    $d x ph $.
    itgitg2.1 $e |- ( ( ph /\ x e. RR ) -> A e. RR ) $.
    itgitg2.2 $e |- ( ( ph /\ x e. RR ) -> 0 <_ A ) $.
    itgitg2.3 $e |- ( ph -> ( x e. RR |-> A ) e. L^1 ) $.
    $( Transfer an integral using ` S.2 ` to an equivalent integral using
       ` S. ` .  (Contributed by Mario Carneiro, 6-Aug-2014.) $)
    itgitg2 $p |- ( ph -> S. RR A _d x = ( S.2 ` ( x e. RR |-> A ) ) ) $=
      ( cr citg cv wcel cc0 cif cmpt citg2 cfv itgposval iftrue mpteq2ia fveq2i
      syl6eq ) ABGCHBGBIGJZCKLZMZNOBGCMZNOABGCDFEPUCUDNBGUBCUACKQRST $.
  $}

  ${
    $d x F $.
    $( A simple function is integrable.  (Contributed by Mario Carneiro,
       6-Aug-2014.) $)
    i1fibl $p |- ( F e. dom S.1 -> F e. L^1 ) $=
      ( vx citg1 wcel cr cfv cmpt cc0 cle wbr wa cif mpteq2dva wceq 0re cvv a1i
      citg2 mpbird eqeltrd cv cibl i1ff feqmptd cmbf cneg i1fmbf eqeltrrd simpr
      cdm biantrurd ifbid fveq2d c0p cofr eqid i1fpos csn cxp ffvelrnda sylancr
      wral max1 ralrimiva reex fvex c0ex fconstmpt eqidd ofrfval2 wss ax-resscn
      ifex cc wfn fnmpti 0pledm itg2itg1 syl2anc eqtr3d itg1cl syl cmul cof 1re
      c1 co renegcli offval2 recnd mulm1d eqtrd i1fmulc renegcld negex iblrelem
      id i1fposd mpbir3and ) ACUJZDZABEBUAZAFZGZUBXABEEAAUCZUDZXAXDUBDXDUEDBEXB
      EDZHXCIJZKZXCHLZGZRFZEDBEXGHXCUFZIJZKZXMHLZGZRFZEDXAAXDUEXFAUGUHXAXLBEXHX
      CHLZGZCFZEXAXTRFZXLYAXAXTXKRXABEXSXJXAXGKZXHXIXCHYCXGXHXAXGUIZUKULMUMXAXT
      WTDZUNXTIUOZJZYBYANBAXTXTUPZUQZXAYGEHURUSZXTYFJZXAYKHXSIJZBEVBXAYLBEYCHED
      ZXCEDYLOXAEEXBAXEUTZHXCVCVAVDXABEHXSIYJXTPEPEPDXAVEQZYMYCOQZXSPDYCXHXCHXB
      AVFVGVMZQYJBEHGNXABEHVHQZXAXTVIVJSXAEXTEVNVKXAVLQZXTEVOXABEXSXTYQYHVPQVQS
      XTVRVSVTXAYEYAEDYIXTWAWBTXAXRBEXNXMHLZGZCFZEXAUUARFZXRUUBXAUUAXQRXABEYTXP
      YCXNXOXMHYCXGXNYDUKULMUMXAUUAWTDZUNUUAYFJZUUCUUBNXABXMXAEWFUFZURUSZAWCWDW
      GZBEXMGZWTXAUUHBEUUFXCWCWGZGUUIXABEUUFXCWCUUGAPEEYOUUFEDZYCWFWEWHZQYNUUGB
      EUUFGNXABEUUFVHQXFWIXABEUUJXMYCXCYCXCYNWJWKMWLXAUUFAXAWQUUKXAUULQWMUHWRZX
      AUUEYJUUAYFJZXAUUNHYTIJZBEVBXAUUOBEYCYMXMEDUUOOYCXCYNWNHXMVCVAVDXABEHYTIY
      JUUAPEPYOYPYTPDYCXNXMHXCWOVGVMZQYRXAUUAVIVJSXAEUUAYSUUAEVOXABEYTUUAUUPUUA
      UPVPQVQSUUAVRVSVTXAUUDUUBEDUUMUUAWAWBTXABEXCYNWPWST $.

    $( Transfer an integral using ` S.1 ` to an equivalent integral using
       ` S. ` .  (Contributed by Mario Carneiro, 6-Aug-2014.) $)
    itgitg1 $p |- ( F e. dom S.1 -> S. RR ( F ` x ) _d x = ( S.1 ` F ) ) $=
      ( citg1 wcel cr cfv citg cc0 cle wbr cmin co cmpt cibl 0re syl cvv mpbird
      wceq a1i cdm cif cneg cof i1ff ffvelrnda feqmptd i1fibl eqeltrrd itgreval
      cv citg2 wa ifcl sylancl max1 sylancr id i1fposd itgitg2 c0p cofr csn cxp
      wral ralrimiva reex fconstmpt eqidd ofrfval2 cc wss ax-resscn wf wfn eqid
      fmptd ffn 0pledm itg2itg1 syl2anc eqtrd renegcld c1 cmul renegcli offval2
      1re recnd mulm1d mpteq2dva i1fmulc oveq12d itg1sub eqtr4d max0sub 3eqtr4d
      fveq2d 3eqtrd ) BCUAZDZAEAUKZBFZGAEHXCIJZXCHUBZGZAEHXCUCZIJZXGHUBZGZKLZAE
      XEMZAEXIMZKUDLZCFZBCFXAAEXCXAEEXBBBUEZUFZXABAEXCMZNXAAEEBXPUGZBUHUIUJXAXK
      XLCFZXMCFZKLZXOXAXFXTXJYAKXAXFXLULFZXTXAAXEXAXBEDUMZXCEDZHEDZXEEDXQOXDXCH
      EUNUOZYDYFYEHXEIJZOXQHXCUPUQZXAXLWTDZXLNDXAAXCXABXRWTXSXAURZUIUSZXLUHPUTX
      AYJVAXLIVBZJZYCXTSYLXAYNEHVCVDZXLYMJZXAYPYHAEVEXAYHAEYIVFXAAEHXEIYOXLQEEE
      QDXAVGTZYFYDOTZYGYOAEHMSXAAEHVHTZXAXLVIZVJRXAEXLEVKVLXAVMTZXAEEXLVNXLEVOX
      AAEXEEXLYGXLVPVQEEXLVRPVSRXLVTWAWBXAXJXMULFZYAXAAXIYDXGEDZYFXIEDYDXCXQWCZ
      OXHXGHEUNUOZYDYFUUCHXIIJZOUUDHXGUPUQZXAXMWTDZXMNDXAAXGXAEWDUCZVCVDZBWEUDL
      ZAEXGMZWTXAUUKAEUUIXCWELZMUULXAAEUUIXCWEUUJBQEEYQUUIEDZYDWDWHWFZTXQUUJAEU
      UIMSXAAEUUIVHTXSWGXAAEUUMXGYDXCYDXCXQWIWJWKWBXAUUIBYKUUNXAUUOTWLUIUSZXMUH
      PUTXAUUHVAXMYMJZUUBYASUUPXAUUQYOXMYMJZXAUURUUFAEVEXAUUFAEUUGVFXAAEHXIIYOX
      MQEEYQYRUUEYSXAXMVIZVJRXAEXMUUAXAEEXMVNXMEVOXAAEXIEXMUUEXMVPVQEEXMVRPVSRX
      MVTWAWBWMXAYJUUHXOYBSYLUUPXLXMWNWAWOXAXNBCXAAEXEXIKLZMXRXNBXAAEUUTXCYDYEU
      UTXCSXQXCWPPWKXAAEXEXIKXLXMQEEYQYGUUEYTUUSWGXSWQWRWS $.
  $}

  ${
    $d x A $.  $d x ph $.
    itgle.1 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itgle.2 $e |- ( ph -> ( x e. A |-> C ) e. L^1 ) $.
    itgle.3 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    itgle.4 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    itgle.5 $e |- ( ( ph /\ x e. A ) -> B <_ C ) $.
    $( Monotonicity of an integral.  (Contributed by Mario Carneiro,
       11-Aug-2014.) $)
    itgle $p |- ( ph -> S. A B _d x <_ S. A C _d x ) $=
      ( cr wcel cc0 cle wbr wa cif cmpt a1i 0re cv citg2 cneg cmin co citg cmbf
      cfv cibl w3a iblrelem mpbid simp2d simp3d cpnf cicc wf cxr ad2ant2r rexrd
      cofr simprr elxrge0 sylanbrc wn 0le0 mpbir2an ifclda eqid fmptd wral max1
      0xr sylancr ifcl sylancl max2 letrd maxle syl3anc mpbir2and iftrue adantl
      wb wceq 3brtr4d ex iffalse pm2.61d1 ifan 3brtr4g ralrimivw cvv reex eqidd
      ofrfval2 mpbird itg2le renegcld lenegd le2subd itgrevallem1 ) ABKBUAZCLZM
      DNOZPZDMQZRZUBUHZBKXDMDUCZNOZPZXJMQZRZUBUHZUDUEBKXDMENOZPZEMQZRZUBUHZBKXD
      MEUCZNOZPZYAMQZRZUBUHZUDUEBCDUFBCEUFNAXIYFXTXOABCDRZUGLZXIKLZXOKLZAYGUILY
      HYIYJUJFABCDHUKULZUMABCERZUGLZXTKLZYFKLZAYLUILYMYNYOUJGABCEIUKULZUNAYMYNY
      OYPUMAYHYIYJYKUNAKMUOUPUEZXHUQKYQXSUQXHXSNVAZOZXIXTNOABKXGYQXHAXCKLZPZXFD
      MYQUUAXFPZDURLXEDYQLUUBDAXDDKLZYTXEHUSUTUUAXDXEVBDVCVDMYQLZUUAXFVEPUUDMUR
      LMMNOZVMVFMVCVGZSVHZXHVIVJABKXRYQXSUUAXQEMYQUUAXQPZEURLXPEYQLUUHEAXDEKLZY
      TXPIUSUTUUAXDXPVBEVCVDUUDUUAXQVEPUUFSVHZXSVIVJAYSXGXRNOZBKVKAUUKBKAXDXEDM
      QZMQZXDXPEMQZMQZXGXRNAXDUUMUUONOZAXDUUPAXDPZUULUUNUUMUUONUUQUULUUNNOZMUUN
      NOZDUUNNOZUUQMKLZUUIUUSTIMEVLVNUUQDEUUNHIUUQUUIUVAUUNKLZITXPEMKVOVPZJUUQU
      VAUUIEUUNNOTIMEVQVNVRUUQUVAUUCUVBUURUUSUUTPWDUVAUUQTSZHUVCMDUUNVSVTWAXDUU
      MUULWEAXDUULMWBWCXDUUOUUNWEAXDUUNMWBWCWFWGXDVEZMMUUMUUONUUEUVEVFSZXDUULMW
      HXDUUNMWHWFWIXDXEDMWJXDXPEMWJWKWLABKXGXRNXHXSWMYQYQKWMLAWNSZUUGUUJAXHWOAX
      SWOWPWQXHXSWRVTAKYQYEUQKYQXNUQYEXNYROZYFXONOABKYDYQYEUUAYCYAMYQUUAYCPZYAU
      RLYBYAYQLUVIYAAXDYAKLZYTYBUUQEIWSZUSUTUUAXDYBVBYAVCVDUUDUUAYCVEPUUFSVHZYE
      VIVJABKXMYQXNUUAXLXJMYQUUAXLPZXJURLXKXJYQLUVMXJAXDXJKLZYTXKUUQDHWSZUSUTUU
      AXDXKVBXJVCVDUUDUUAXLVEPUUFSVHZXNVIVJAUVHYDXMNOZBKVKAUVQBKAXDYBYAMQZMQZXD
      XKXJMQZMQZYDXMNAXDUVSUWANOZAXDUWBUUQUVRUVTUVSUWANUUQUVRUVTNOZMUVTNOZYAUVT
      NOZUUQUVAUVNUWDTUVOMXJVLVNUUQYAXJUVTUVKUVOUUQUVNUVAUVTKLZUVOTXKXJMKVOVPZU
      UQDENOYAXJNOJUUQDEHIWTULUUQUVAUVNXJUVTNOTUVOMXJVQVNVRUUQUVAUVJUWFUWCUWDUW
      EPWDUVDUVKUWGMYAUVTVSVTWAXDUVSUVRWEAXDUVRMWBWCXDUWAUVTWEAXDUVTMWBWCWFWGUV
      EMMUVSUWANUVFXDUVRMWHXDUVTMWHWFWIXDYBYAMWJXDXKXJMWJWKWLABKYDXMNYEXNWMYQYQ
      UVGUVLUVPAYEWOAXNWOWPWQYEXNWRVTXAABCDHFXBABCEIGXBWF $.
  $}

  ${
    $d x A $.  $d x ph $.
    itgge0.1 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itgge0.2 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    itgge0.3 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
    $( The integral of a positive function is positive.  (Contributed by Mario
       Carneiro, 25-Aug-2014.) $)
    itgge0 $p |- ( ph -> 0 <_ S. A B _d x ) $=
      ( cc0 citg cle itgz cmpt csn cxp cibl fconstmpt cvol wcel cr syl cdm cmbf
      iblmbf mbfdm2 ibl0 syl5eqelr cv wa 0re a1i itgle syl5eqbrr ) AHBCHIBCDIJB
      CKABCHDABCHLCHMNZOBCHPACQUARUMORABCDSABCDLZORUNUBREUNUCTFUDCUETUFEHSRABUG
      CRUHUIUJFGUKUL $.
  $}

  ${
    $d k A $.  $d k B $.  $d k C $.  $d k x ph $.
    itgss.1 $e |- ( ph -> A C_ B ) $.
    itgss.2 $e |- ( ( ph /\ x e. ( B \ A ) ) -> C = 0 ) $.
    $( Expand the set of an integral by adding zeroes outside the domain.
       (Contributed by Mario Carneiro, 11-Aug-2014.)  (Revised by Mario
       Carneiro, 23-Aug-2014.) $)
    itgss $p |- ( ph -> S. A C _d x = S. B C _d x ) $=
      ( vk cc0 co ci cr wcel cdiv cre cfv wa cif citg2 wceq c3 cfz cexp cle wbr
      cv cmpt cmul csu citg cz elfzelz wn iffalse ad2antll eldif adantlr oveq1d
      cdif cc wne ax-icn expclz mp3an12 expne0i div0d ad2antlr eqtrd fveq2d re0
      ine0 syl6eq ifeq1d ifid sylan2br eqtr4d iftrue pm2.61d2 adantl wss adantr
      expr sseld con3and pm2.61dan ifan 3eqtr4g mpteq2dv oveq2d sylan2 sumeq2dv
      syl eqid dfitg ) AIUAUBJZKHUFZUCJZBLBUFZCMZIEWQNJZOPZUDUEZQXAIRZUGZSPZUHJ
      ZHUIWOWQBLWRDMZXBQXAIRZUGZSPZUHJZHUIBCEUJBDEUJAWOXFXKHWPWOMAWPUKMZXFXKTWP
      IUAULAXLQZXEXJWQUHXMXDXISXMBLXCXHXMWSXBXAIRZIRZXGXNIRZXCXHXMXGXOXPTXMXGQZ
      XOXNXPXQWSXOXNTZXMXGWSUMZXRXMXGXSQZQXOIXNXSXOITZXMXGWSXNIUNZUOXTXMWRDCUSM
      ZXNITWRDCUPXMYCQZXNXBIIRIYDXBXAIIYDXAIOPIYDWTIOYDWTIWQNJZIYDEIWQNAYCEITXL
      GUQURXLYEITAYCXLWQKUTMZKIVAZXLWQUTMVBVKKWPVCVDYFYGXLWQIVAVBVKKWPVEVDVFVGV
      HVIVJVLVMXBIVNVLVOVPWBWSXNIVQVRXGXPXNTXMXGXNIVQVSVPXMXGUMZQZXOIXPYIXSYAXM
      WSXGXMCDWRACDVTXLFWAWCWDYBWLYHXPITXMXGXNIUNVSVPWEWSXBXAIWFXGXBXAIWFWGWHVI
      WIWJWKBCEXAHXAWMZWNBDEXAHYJWNWG $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Expand the set of an integral by adding zeroes outside the domain.
       (Contributed by Mario Carneiro, 11-Aug-2014.) $)
    itgss2 $p |- ( A C_ B -> S. A C _d x = S. B if ( x e. A , C , 0 ) _d x ) $=
      ( wss cv wcel cc0 cif citg wceq iftrue adantl itgeq2dv id cdif wn iffalse
      eldifn syl itgss eqtr3d ) BCEZABAFZBGZDHIZJABDJACUFJUCABUFDUEUFDKUCUEDHLM
      NUCABCUFUCOUDCBPGZUFHKZUCUGUEQUHUDCBSUEDHRTMUAUB $.
  $}

  ${
    $d x y A $.  $d k x y z B $.  $d k y z C $.  $d k y z D $.  $d k x y ph $.
    itgeqa.1 $e |- ( ( ph /\ x e. B ) -> C e. CC ) $.
    itgeqa.2 $e |- ( ( ph /\ x e. B ) -> D e. CC ) $.
    itgeqa.3 $e |- ( ph -> A C_ RR ) $.
    itgeqa.4 $e |- ( ph -> ( vol* ` A ) = 0 ) $.
    itgeqa.5 $e |- ( ( ph /\ x e. ( B \ A ) ) -> C = D ) $.
    $( Approximate equality of integrals.  If ` C ( x ) = D ( x ) ` for almost
       all ` x ` , then ` S. B C ( x ) _d x = S. B D ( x ) _d x ` and one is
       integrable iff the other is.  (Contributed by Mario Carneiro,
       12-Aug-2014.)  (Revised by Mario Carneiro, 2-Sep-2014.) $)
    itgeqa $p |- ( ph ->
      ( ( ( x e. B |-> C ) e. L^1 <-> ( x e. B |-> D ) e. L^1 ) /\
        S. B C _d x = S. B D _d x ) ) $=
      ( vk vy wcel wceq cr cc0 co cfv wa cmpt cibl wb citg cmbf cv ci cexp cdiv
      cre cle wbr cif citg2 c3 cfz wral mbfeqa cpnf cicc ifan cxr cc adantlr cz
      elfzelz ad2antlr wne ax-icn ine0 expclz mp3an12 expne0i divcld recld ifcl
      syl 0re sylancl rexrd max1 sylancr elxrge0 sylanbrc 0xr 0le0 mpbir2an a1i
      wn ifclda syl5eqel adantr eqid fmptd wss covol simpll simpr eldifn eldifd
      cdif syl2anc oveq1d fveq2d ibllem cvv eldifi adantl fvex c0ex ifex fvmpt2
      3eqtr4d ralrimiva nfv nffvmpt1 nfeq fveq2 eqeq12d cbvral r19.21bi itg2eqa
      sylib eleq1d ralbidva anbi12d eqidd isibl2 cmul csu oveq2d sumeq2dv dfitg
      3bitr4d 3eqtr4g jca ) ABDEUAZUBNZBDFUAZUBNZUCBDEUDZBDFUDZOAYQUENZBPBUFZDN
      ZQEUGLUFZUHRZUIRZUJSZUKULZTZUUIQUMZUAZUNSZPNZLQUOUPRZUQZTYSUENZBPUUEQFUUG
      UIRZUJSZUKULZTZUUTQUMZUAZUNSZPNZLUUPUQZTYRYTAUUCUURUUQUVGABCDEFIJKGHURAUU
      OUVFLUUPAUUFUUPNZTZUUNUVEPUVIMCUUMUVDUVIBPUULQUSUTRZUUMUVIUULUVJNUUDPNZUV
      IUULUUEUUJUUIQUMZQUMUVJUUEUUJUUIQVAUVIUUEUVLQUVJUVIUUETZUVLVBNQUVLUKULZUV
      LUVJNUVMUVLUVMUUIPNZQPNZUVLPNUVMUUHUVMEUUGAUUEEVCNUVHGVDUVMUUFVENZUUGVCNZ
      UVHUVQAUUEUUFQUOVFVGZUGVCNZUGQVHZUVQUVRVIVJUGUUFVKVLVQZUVMUVQUUGQVHZUVSUV
      TUWAUVQUWCVIVJUGUUFVMVLVQZVNVOZVRUUJUUIQPVPVSVTUVMUVPUVOUVNVRUWEQUUIWAWBU
      VLWCWDQUVJNZUVIUUEWITUWFQVBNQQUKULWEWFQWCWGWHZWJWKWLUUMWMZWNUVIBPUVCUVJUV
      DUVIUVCUVJNUVKUVIUVCUUEUVAUUTQUMZQUMUVJUUEUVAUUTQVAUVIUUEUWIQUVJUVMUWIVBN
      QUWIUKULZUWIUVJNUVMUWIUVMUUTPNZUVPUWIPNUVMUUSUVMFUUGAUUEFVCNUVHHVDUWBUWDV
      NVOZVRUVAUUTQPVPVSVTUVMUVPUWKUWJVRUWLQUUTWAWBUWIWCWDUWGWJWKWLUVDWMZWNACPW
      OUVHIWLACWPSQOUVHJWLAMUFZPCXAZNUWNUUMSZUWNUVDSZOZUVHAUWRMUWOAUUDUUMSZUUDU
      VDSZOZBUWOUQUWRMUWOUQAUXABUWOAUUDUWONZTZUULUVCUWSUWTUXCBDUUIUUTUXCUUETZUU
      HUUSUJUXDEFUUGUIUXDAUUDDCXANEFOAUXBUUEWQUXDUUDDCUXCUUEWRUXBUUDCNWIAUUEUUD
      PCWSVGWTKXBXCXDXEUXCUVKUULXFNUWSUULOUXBUVKAUUDPCXGXHZUUKUUIQUUHUJXIXJXKBP
      UULXFUUMUWHXLVSUXCUVKUVCXFNUWTUVCOUXEUVBUUTQUUSUJXIXJXKBPUVCXFUVDUWMXLVSX
      MXNUXAUWRBMUWOUXAMXOBUWPUWQBPUULUWNXPBPUVCUWNXPXQUUDUWNOUWSUWPUWTUWQUUDUW
      NUUMXRUUDUWNUVDXRXSXTYCYAVDYBZYDYEYFABDEUUILUUMVCAUUMYGAUUETZUUIYGGYHABDF
      UUTLUVDVCAUVDYGUXGUUTYGHYHYNAUUPUUGUUNYIRZLYJUUPUUGUVEYIRZLYJUUAUUBAUUPUX
      HUXILUVIUUNUVEUUGYIUXFYKYLBDEUUILUUIWMYMBDFUUTLUUTWMYMYOYP $.
  $}

  ${
    $d x y z A $.  $d x y B $.  $d y z C $.  $d x y ph $.
    itgss3.1 $e |- ( ph -> A C_ B ) $.
    itgss3.2 $e |- ( ph -> B C_ RR ) $.
    itgss3.3 $e |- ( ph -> ( vol* ` ( B \ A ) ) = 0 ) $.
    itgss3.4 $e |- ( ( ph /\ x e. B ) -> C e. CC ) $.
    $( Expand the set of an integral by a nullset.  (Contributed by Mario
       Carneiro, 13-Aug-2014.)  (Revised by Mario Carneiro, 2-Sep-2014.) $)
    itgss3 $p |- ( ph ->
      ( ( ( x e. A |-> C ) e. L^1 <-> ( x e. B |-> C ) e. L^1 ) /\
         S. A C _d x = S. B C _d x ) ) $=
      ( vy cmpt cibl wcel wceq cc0 wa cc adantr syl wf wb citg cif csb nfcv nfv
      cv nfcsb1v nfif eleq1 csbeq1a eqidd ifbieq12d cbvmpt wss cvol cmbf iftrue
      cdm mpteq2ia eqtr4i simpr syl5eqelr iblmbf wral sselda syldan fmptd feq1i
      eqid sylib fmpt sylibr r19.21bi mbfdm2 cun undif id cr covol cfv ssdifssd
      cdif nulmbl syl2anc unmbl syl2anr eqeltrrd eldifn adantl iffalse syl5eqel
      wn iblss2 eqtr3i 0cn ifcl sylancl dfss4 difmbl iblss eleq2d biimpa itgeqa
      impbida simpld bitrd itgss2 simprd eqtrd jca ) ABCEKZLMZBDEKLMZUABCEUBZBD
      EUBZNAXMBDBUGZCMZEOUCZKZLMZXNAXMYAAXMPZXTJDJUGZCMZBYCEUDZOUCZKZLBJDXSYFJX
      SUEZYDBYEOYDBUFBYCEUHZBOUEUIZXQYCNZXRYDEOYEOXQYCCUJBYCEUKZYKOULUMZUNZYBJC
      DYFQACDUOZXMFRAXMCUPUSZMZDYPMZYBJCYFQYBJCYFKZLMYSUQMYBYSXLLXLJCYEKYSBJCEY
      EJEUEYIYLUNJCYFYEYDYEOURUTVAZAXMVBVCZYSVDSYBYFQMZJCYBCQYSTZUUBJCVEYBCQXLT
      ZUUCAUUDXMABCEQXLAXRXQDMZEQMZACDXQFVFIVGXLVJVHRCQXLYSYTVIVKJCQYFYSYSVJVLV
      MVNZVOAYQPCDCWCZVPZDYPAUUIDNZYQAYOUUJFCDVQVKRYQYQUUHYPMZUUIYPMAYQVRAUUHVS
      UOUUHVTWAONUUKADVSCGWBZHUUHWDWEZCUUHWFWGWHVGUUGYBYCUUHMZPYDWMZYFONUUNUUOY
      BYCDCWIWJYDYEOWKSUUAWNWLAYAPZXLYSLBCXSKXLYSBCXSEXREOURZUTBJCXSYFYHYJYMUNW
      OUUPJCDYFQAYOYAFRAYAYRYQUUPJDYFQUUPYGLMYGUQMUUPYGXTLYNAYAVBVCZYGVDSUUPUUB
      JDUUPDQYGTZUUBJDVEAUUSYAADQXTTUUSABDXSQXTAUUEPUUFOQMXSQMIWPXREOQWQWRZXTVJ
      VHDQXTYGYNVIVKRJDQYFYGYGVJVLVMVNZVOAYRPDUUHWCZCYPAUVBCNZYRAYOUVCFCDWSVKZR
      YRYRUUKUVBYPMAYRVRUUMDUUHWTWGWHVGUVAUURXAWLXEAYAXNUAZBDXSUBZXPNZABUUHDXSE
      UUTIUULHAXQUVBMZPXRXSENAUVHXRAUVBCXQUVDXBXCUUQSXDZXFXGAXOUVFXPAYOXOUVFNFB
      CDEXHSAUVEUVGUVIXIXJXK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    itgioo.1 $e |- ( ph -> A e. RR ) $.
    itgioo.2 $e |- ( ph -> B e. RR ) $.
    itgioo.3 $e |- ( ( ph /\ x e. ( A [,] B ) ) -> C e. CC ) $.
    $( Equality of integrals on open and closed intervals.  (Contributed by
       Mario Carneiro, 2-Sep-2014.) $)
    itgioo $p |- ( ph -> S. ( A (,) B ) C _d x = S. ( A [,] B ) C _d x ) $=
      ( co cmpt cibl wcel wb citg wceq wss cr syl2anc cdif c0 cioo ioossicc a1i
      cicc iccssre cpr covol cfv cc0 clt wbr wa rexrd icc0 biimpar difeq1d 0dif
      cxr 0ss eqsstri cle cun uncom adantr simpr prunioo syl3anc syl5req difun2
      syl6eqss syl6eq difss ltlecasei prssi cfn ovolfi sylancr ovolssnul itgss3
      prfi simprd ) ABCDUAIZEJKLBCDUDIZEJKLMBWBENBWCENOABWBWCEWBWCPACDUBUCACQLZ
      DQLZWCQPFGCDUERAWCWBSZCDUFZPZWGQPZWGUGUHUIOZWFUGUHUIOAWHDCADCUJUKZULZWFTW
      BSZWGWLWCTWBAWCTOZWKACURLZDURLZWNWKMACFUMZADGUMZCDUNRUOUPWMTWGWBUQWGUSUTV
      JACDVAUKZULZWFWGWBSZWGWTWFWGWBVBZWBSXAWTWCXBWBWTXBWBWGVBZWCWGWBVCWTWOWPWS
      XCWCOAWOWSWQVDAWPWSWRVDAWSVECDVFVGVHUPWGWBVIVKWGWBVLVJGFVMAWDWEWIFGCDQVNR
      ZAWGVOLWIWJCDVTXDWGVPVQWFWGVRVGHVSWA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    itgless.1 $e |- ( ph -> A C_ B ) $.
    itgless.2 $e |- ( ph -> A e. dom vol ) $.
    itgless.3 $e |- ( ( ph /\ x e. B ) -> C e. RR ) $.
    itgless.4 $e |- ( ( ph /\ x e. B ) -> 0 <_ C ) $.
    itgless.5 $e |- ( ph -> ( x e. B |-> C ) e. L^1 ) $.
    $( Expand the integral of a nonnegative function.  (Contributed by Mario
       Carneiro, 31-Aug-2014.) $)
    itgless $p |- ( ph -> S. A C _d x <_ S. B C _d x ) $=
      ( citg wcel cc0 cle wceq syl cr cmpt wa wbr cv cif wss itgss2 cibl iblmbf
      cmbf mbfdm2 sselda syldan 0re ifcl sylancl cdif wn eldifn adantl mpteq2ia
      iffalse iftrue iblss syl5eqel iblss2 leidd breq1 ifboth syl2anc eqbrtrd
      itgle ) ABCEKZBDBUAZCLZEMUBZKZBDEKNACDUCVJVNOFBCDEUDPABDVMEABCDVMQFABDEQA
      BDERZUELVOUGLJVOUFPHUHAVLSEQLZMQLZVMQLZAVLVKDLZVPACDVKFUIHUJUKVLEMQULZUMA
      VKDCUNLZSVLUOZVMMOWAWBAVKDCUPUQVLEMUSPABCVMRBCERUEBCVMEVLEMUTURABCDEQFGHJ
      VAVBVCJAVSSZVPVQVRHUKVTUMHWCEENTZMENTZVMENTZWCEHVDIVLWDWEWFEMEVMENVEMVMEN
      VEVFVGVIVH $.
  $}

  ${
    $d k x y A $.  $d k x y B $.
    $( A constant function is integrable.  (Contributed by Mario Carneiro,
       12-Aug-2014.) $)
    iblconst $p |- ( ( A e. dom vol /\ ( vol ` A ) e. RR /\ B e. CC ) ->
      ( A X. { B } ) e. L^1 ) $=
      ( vx vk cvol wcel cfv cr cc cmpt cibl cmbf cv cc0 ci co cle wa cif citg2
      cdm w3a csn cxp fconstmpt cexp cdiv cre wbr c3 cfz wral 3adant2 syl5eqelr
      mbfconst cmul ifan mpteq2i fveq2i cpnf cico wceq simpl1 simpl2 cz elfzelz
      simpl3 adantl wne ax-icn ine0 expclz mp3an12 syl expne0i divcld recld 0re
      ifcl sylancl sylancr elrege0 sylanbrc itg2const syl5eq remulcld ralrimiva
      max1 syl3anc eqeltrd eqidd isibl2 mpbir2and syl5eqel ) AEUAFZAEGZHFZBIFZU
      BZABUCUDZCABJZKCABUEZWSXAKFXALFCHCMAFZNBODMZUFPZUGPZUHGZQUIZRXGNSZJZTGZHF
      ZDNUJUKPZULWSXAWTLXBWOWRWTLFWQABUOUMUNWSXLDXMWSXDXMFZRZXKXHXGNSZWPUPPZHXO
      XKCHXCXPNSZJZTGZXQXJXSTCHXIXRXCXHXGNUQURUSXOWOWQXPNUTVAPFZXTXQVBWOWQWRXNV
      CWOWQWRXNVDZXOXPHFZNXPQUIZYAXOXGHFZNHFZYCXOXFXOBXEWOWQWRXNVGXOXDVEFZXEIFZ
      XNYGWSXDNUJVFVHZOIFZONVIZYGYHVJVKOXDVLVMVNXOYGXENVIZYIYJYKYGYLVJVKOXDVOVM
      VNVPVQZVRXHXGNHVSVTZXOYFYEYDVRYMNXGWHWAXPWBWCCAXPWDWIWEXOXPWPYNYBWFWJWGWS
      CABXGDXJIWSXJWKWSXCRXGWKWOWQWRXCVGWLWMWN $.

    $( Integral of a constant function.  (Contributed by Mario Carneiro,
       12-Aug-2014.) $)
    itgconst $p |- ( ( A e. dom vol /\ ( vol ` A ) e. RR /\ B e. CC ) ->
      S. A B _d x = ( B x. ( vol ` A ) ) ) $=
      ( vy wcel cfv cr cc citg ci cmul caddc wceq cc0 cle cif cmpt citg2 recnd
      co cvol cdm w3a cre cim cv wral recl 3ad2ant3 wa wbr cneg cmin simplr csn
      cxp fconstmpt simpl1 simp2 adantr iblconst syl3anc syl5eqelr itgrevallem1
      cibl simpr ifan mpteq2i fveq2i cpnf cico 0re ifcl sylancl sylancr elrege0
      sylanbrc itg2const syl5eq renegcl adantl oveq12d subdird max0sub 3eqtr2rd
      max1 oveq1d eqtr4d ralrimiva simpl itgeq2dv oveq1 eqeq12d rspcv sylc imcl
      oveq2d ax-icn a1i mulassd mulcl adddird simpl3 itgcnval replim 3eqtr4d )
      BUAUBEZBUAFZGEZCHEZUCZABCUDFZIZJABCUEFZIZKTZLTZXLJXNKTZLTZXHKTZABCICXHKTX
      KXQXLXHKTZXRXHKTZLTXTXKXMYAXPYBLXKXLGEZABDUFZIZYDXHKTZMZDGUGZXMYAMZXJXGYC
      XICUHUIZXKYGDGXKYDGEZUJZYEAGAUFBEZNYDOUKZUJYDNPZQZRFZAGYMNYDULZOUKZUJYRNP
      ZQZRFZUMTZYFYLABYDXKYKYMUNYLABYDQBYDUOUPZVEABYDUQYLXGXIYDHEUUDVEEXGXIXJYK
      URZXKXIYKXGXIXJUSZUTZYLYDXKYKVFZSBYDVAVBVCVDYLUUCYNYDNPZXHKTZYSYRNPZXHKTZ
      UMTUUIUUKUMTZXHKTYFYLYQUUJUUBUULUMYLYQAGYMUUINPZQZRFZUUJYPUUORAGYOUUNYMYN
      YDNVGVHVIYLXGXIUUINVJVKTZEZUUPUUJMUUEUUGYLUUIGEZNUUIOUKZUURYLYKNGEZUUSUUH
      VLYNYDNGVMVNZYLUVAYKUUTVLUUHNYDWFVOUUIVPVQABUUIVRVBVSYLUUBAGYMUUKNPZQZRFZ
      UULUUAUVDRAGYTUVCYMYSYRNVGVHVIYLXGXIUUKUUQEZUVEUULMUUEUUGYLUUKGEZNUUKOUKZ
      UVFYLYRGEZUVAUVGYKUVIXKYDVTWAZVLYSYRNGVMVNZYLUVAUVIUVHVLUVJNYRWFVOUUKVPVQ
      ABUUKVRVBVSWBYLUUIUUKXHYLUUIUVBSYLUUKUVKSXKXHHEYKXKXHUUFSZUTWCYLUUMYDXHKY
      KUUMYDMXKYDWDWAWGWEWHWIZYGYIDXLGYDXLMZYEXMYFYAUVNABYDXLUVNYMWJWKYDXLXHKWL
      WMWNWOXKXPJXNXHKTZKTYBXKXOUVOJKXKXNGEZYHXOUVOMZXJXGUVPXICWPUIZUVMYGUVQDXN
      GYDXNMZYEXOYFUVOUVSABYDXNUVSYMWJWKYDXNXHKWLWMWNWOWQXKJXNXHJHEZXKWRWSXKXNU
      VRSZUVLWTWHWBXKXLXRXHXKXLYJSXKUVTXNHEXRHEWRUWAJXNXAVOUVLXBWHXKABCHXGXIXJY
      MXCXKABCQBCUOUPVEABCUQBCVAVCXDXKCXSXHKXJXGCXSMXICXEUIWGXF $.
  $}

  ${
    $d x A $.  $d x ph $.
    ibladd.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    ibladd.2 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    ibladd.3 $e |- ( ( ph /\ x e. A ) -> D = ( B + C ) ) $.
    ibladd.4 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    ibladd.5 $e |- ( ph -> ( x e. A |-> C ) e. MblFn ) $.
    ibladd.6 $e |- ( ph -> ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ B ) , B , 0 ) ) ) e. RR ) $.
    ibladd.7 $e |- ( ph -> ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ C ) , C , 0 ) ) ) e. RR ) $.
    $( Lemma for ~ ibladd .  (Contributed by Mario Carneiro, 17-Aug-2014.) $)
    ibladdlem $p |- ( ph -> ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ D ) , D , 0 ) ) ) e. RR ) $=
      ( cr cc0 wcel cle wbr cif 0re cpnf cicc co cv wa cmpt wf caddc citg2 ifan
      cfv cxr readdcld eqeltrd ifcl sylancl rexrd max1 sylancr elxrge0 sylanbrc
      wn 0xr 0le0 mpbir2an a1i ifclda adantr syl5eqel eqid fmptd cof reex eqidd
      cvv offval2 wceq iftrue ibar ifbid oveq12d eqtr2d simpl con3i iffalse syl
      00id 3eqtr4a pm2.61i mpteq2i syl6eq fveq2d cvol cdm wss mbfdm2 mblss cdif
      rembl eldifn adantl intnanrd cmbf mpteq2ia mbfpos syl5eqelr mbfss elrege0
      cico itg2add eqtr3d cofr addge0d wral max2 le2addd eqbrtrd ifboth syl2anc
      breq1 3brtr4d pm2.61d1 syl5eqbr ralrimivw ofrfval2 mpbird itg2le itg2lecl
      ex syl3anc ) ANOUAUBUCZBNBUDZCPZOFQRZUEFOSZUFZUGZBNYMODQRZDOSZOEQRZEOSZUH
      UCZOSZUFZUIUKZNPYPUIUKZUUEQRZUUFNPABNYOYKYPAYLNPZUEYOYMYNFOSZOSZYKYMYNFOU
      JZAUUJYKPUUHAYMUUIOYKAYMUEZUUIULPOUUIQRZUUIYKPUULUUIUULFNPZONPZUUINPUULFD
      EUHUCZNIUULDEGHUMUNZTYNFONUOUPUQUULUUOUUNUUMTUUQOFURUSUUIUTVAOYKPZAYMVBZU
      EZUUROULPOOQRZVCVDOUTVEVFZVGVHVIZYPVJVKZAUUEBNYMYRUEZDOSZUFZUIUKZBNYMYTUE
      ZEOSZUFZUIUKZUHUCZNAUVGUVKUHVLUCZUIUKUUEUVMAUVNUUDUIAUVNBNUVFUVJUHUCZUFUU
      DABNUVFUVJUHUVGUVKVONNNVOPAVMVFZAUVFNPZUUHAUVFYMYSOSZNYMYRDOUJZAYMYSONUUL
      DNPZUUOYSNPZGTYRDONUOUPZUUOUUTTVFZVGVIZVHAUVJNPZUUHAUVJYMUUAOSZNYMYTEOUJZ
      AYMUUAONUULENPZUUOUUANPZHTYTEONUOUPZUWCVGVIZVHAUVGVNAUVKVNVPBNUVOUUCYMUVO
      UUCVQYMUUCUUBUVOYMUUBOVRZYMYSUVFUUAUVJUHYMYRUVEDOYMYRVSVTZYMYTUVIEOYMYTVS
      VTZWAWBUUSOOUHUCOUVOUUCWGUUSUVFOUVJOUHUUSUVEVBZUVFOVQZUVEYMYMYRWCWDUVEDOW
      EZWFUUSUVIVBUVJOVQZUVIYMYMYTWCWDUVIEOWEWFZWAYMUUBOWEZWHWIWJWKWLAUVGUVKABC
      NUVFNACWMWNZPCNWOABCDNJGWPCWQWFZNUXAPAWSVFZAUVQYMUWDVHAYLNCWRPZUEZUWOUWPU
      XEYMYRUXDUUSAYLNCWTXAZXBUWQWFABCUVFUFBCYSUFXCBCYSUVFUWMXDABCDGJXEXFXGABNU
      VFOUAXIUCZUVGAUVFUXGPUUHAUVFUVRUXGUVSAYMYSOUXGUULUWAOYSQRZYSUXGPUWBUULUUO
      UVTUXHTGODURUSZYSXHVAOUXGPZUUTUXJUUOUVATVDOXHVEVFZVGVIVHUVGVJVKLABCNUVJNU
      XBUXCAUWEYMUWKVHUXEUUSUWRUXFUWSWFABCUVJUFBCUUAUFXCBCUUAUVJUWNXDABCEHKXEXF
      XGABNUVJUXGUVKAUVJUXGPUUHAUVJUWFUXGUWGAYMUUAOUXGUULUWIOUUAQRZUUAUXGPUWJUU
      LUUOUWHUXLTHOEURUSZUUAXHVAUXKVGVIVHUVKVJVKMXJXKAUVHUVLLMUMUNAYQNYKUUDUGYP
      UUDQXLRZUUGUVDABNUUCYKUUDAUUCYKPUUHAYMUUBOYKUULUUBULPOUUBQRZUUBYKPUULUUBU
      ULYSUUAUWBUWJUMUQUULYSUUAUWBUWJUXIUXMXMZUUBUTVAUVBVGVHZUUDVJVKAUXNYOUUCQR
      ZBNXNAUXRBNAYOUUJUUCQUUKAYMUUJUUCQRZAYMUXSUULUUIUUBUUJUUCQUULFUUBQRZUXOUU
      IUUBQRZUULFUUPUUBQIUULDEYSUUAGHUWBUWJUULUUOUVTDYSQRTGODXOUSUULUUOUWHEUUAQ
      RTHOEXOUSXPXQUXPYNUXTUXOUYAFOFUUIUUBQXTOUUIUUBQXTXRXSYMUUJUUIVQAYMUUIOVRX
      AYMUUCUUBVQAUWLXAYAYIUUSOOUUJUUCQUVAUUSVDVFYMUUIOWEUWTYAYBYCYDABNYOUUCQYP
      UUDVOYKYKUVPUVCUXQAYPVNAUUDVNYEYFYPUUDYGYJUUEYPYHYJ $.
  $}

  ${
    $d x A $.  $d x V $.  $d x ph $.
    itgadd.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgadd.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itgadd.3 $e |- ( ( ph /\ x e. A ) -> C e. V ) $.
    itgadd.4 $e |- ( ph -> ( x e. A |-> C ) e. L^1 ) $.
    $( Add two integrals over the same domain.  (Contributed by Mario Carneiro,
       17-Aug-2014.) $)
    ibladd $p |- ( ph -> ( x e. A |-> ( B + C ) ) e. L^1 ) $=
      ( cmpt wcel cr cc0 cfv cle wbr wa cif citg2 caddc co cibl cmbf cv cre cim
      cneg cof cvol cdm w3a iblcnlem mpbid simp1d mbfdm2 eqidd offval2 eqeltrrd
      eqid mbfadd mbfmptcl recld readdd ismbfcn2 simpld simp2d ibladdlem negeqd
      renegcld recnd negdid eqtrd mbfneg simprd jca imcld imaddd simp3d cvv a1i
      ovex mpbir3and ) ABCDEUAUBZKZUCLWEUDLBMBUECLZNWDUFOZPQRWGNSKTOZMLZBMWFNWG
      UHZPQRWJNSKTOZMLZRBMWFNWDUGOZPQRWMNSKTOZMLZBMWFNWMUHZPQRWPNSKTOZMLZRABCDK
      ZBCEKZUAUIUBWEUDABCDEUAWSWTUJUKFFABCDFAWSUDLZBMWFNDUFOZPQRXBNSKTOZMLZBMWF
      NXBUHZPQRXENSKTOZMLZRZBMWFNDUGOZPQRXINSKTOZMLZBMWFNXIUHZPQRXLNSKTOZMLZRZA
      WSUCLXAXHXOULHABCDXCXFXJXMFXCUTXFUTXJUTXMUTGUMUNZUOZGUPGIAWSUQAWTUQURAWSW
      TXQAWTUDLZBMWFNEUFOZPQRXSNSKTOZMLZBMWFNXSUHZPQRYBNSKTOZMLZRZBMWFNEUGOZPQR
      YFNSKTOZMLZBMWFNYFUHZPQRYINSKTOZMLZRZAWTUCLXRYEYLULJABCEXTYCYGYJFXTUTYCUT
      YGUTYJUTIUMUNZUOZVAUSAWIWLABCXBXSWGAWFRZDABCDFXQGVBZVCZYOEABCEFYNIVBZVCZY
      ODEYPYRVDZABCXBKUDLZBCXIKUDLZAXAUUAUUBRXQABCDYPVEUNZVFZABCXSKUDLZBCYFKUDL
      ZAXRUUEUUFRYNABCEYRVEUNZVFZAXDXGAXAXHXOXPVGZVFAYAYDAXRYEYLYMVGZVFVHABCXEY
      BWJYOXBYQVJYOXSYSVJYOWJXBXSUAUBZUHXEYBUAUBYOWGUUKYTVIYOXBXSYOXBYQVKYOXSYS
      VKVLVMABCXBMYQUUDVNABCXSMYSUUHVNAXDXGUUIVOAYAYDUUJVOVHVPAWOWRABCXIYFWMYOD
      YPVQZYOEYRVQZYODEYPYRVRZAUUAUUBUUCVOZAUUEUUFUUGVOZAXKXNAXAXHXOXPVSZVFAYHY
      KAXRYEYLYMVSZVFVHABCXLYIWPYOXIUULVJYOYFUUMVJYOWPXIYFUAUBZUHXLYIUAUBYOWMUU
      SUUNVIYOXIYFYOXIUULVKYOYFUUMVKVLVMABCXIMUULUUOVNABCYFMUUMUUPVNAXKXNUUQVOA
      YHYKUURVOVHVPABCWDWHWKWNWQVTWHUTWKUTWNUTWQUTWDVTLYODEUAWBWAUMWC $.

    $( Subtract two integrals over the same domain.  (Contributed by Mario
       Carneiro, 25-Aug-2014.) $)
    iblsub $p |- ( ph -> ( x e. A |-> ( B - C ) ) e. L^1 ) $=
      ( cneg caddc co cmpt cibl wcel cmbf iblmbf syl mbfmptcl cmin cv mpteq2dva
      wa negsubd cc negcld iblneg ibladd eqeltrrd ) ABCDEKZLMZNBCDEUAMZNOABCULU
      MABUBCPUDZDEABCDFABCDNZOPUOQPHUORSGTZABCEFABCENZOPUQQPJUQRSITZUEUCABCDUKU
      FUPHUNEURUGABCEFIJUHUIUJ $.

    ${
      itgadd.5 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
      itgadd.6 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
      ${
        itgadd.7 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
        itgadd.8 $e |- ( ( ph /\ x e. A ) -> 0 <_ C ) $.
        $( Lemma for ~ itgadd .  (Contributed by Mario Carneiro,
           17-Aug-2014.) $)
        itgaddlem1 $p |- ( ph -> S. A ( B + C ) _d x =
          ( S. A B _d x + S. A C _d x ) ) $=
          ( caddc co cr wcel cc0 cmpt citg cv cif citg2 cfv wa readdcld addge0d
          ibladd itgposval cof oveq12d cpnf cico cvol cdm wss cmbf iblpos mpbid
          cibl simpld mbfdm2 mblss syl a1i cle wbr elrege0 sylanbrc wn 0re 0le0
          rembl mpbir2an ifclda adantr cdif wceq eldifn adantl iffalse mpteq2ia
          iftrue syl5eqel mbfss eqid fmptd simprd itg2add cvv reex eqidd eqtr4d
          offval2 00id syl6eq pm2.61i mpteq2i fveq2d 3eqtr2d ) ABCDEOPZUABQBUBZ
          CRZXBSUCZTZUDUEZBCDUAZBCEUAZOPZABCXBAXDUFZDEKLUGABCDEFGHIJUIXKDEKLMNU
          HUJAXJBQXDDSUCZTZUDUEZBQXDESUCZTZUDUEZOPXMXPOUKPZUDUEXGAXHXNXIXQOABCD
          KHMUJABCELJNUJULAXMXPABCQXLSUMUNPZACUOUPZRCQUQABCDQABCDTZURRZXNQRZAYA
          VARYBYCUFHABCDKMUSUTZVBZKVCCVDVEZQXTRAVNVFZAXLXSRZXDAXDDSXSXKDQRSDVGV
          HDXSRKMDVIVJSXSRZAXDVKZUFYISQRSSVGVHVLVMSVIVOVFZVPZVQAXCQCVRRZUFZYJXL
          SVSYMYJAXCQCVTWAZXDDSWBZVEABCXLTYAURBCXLDXDDSWDZWCYEWEWFABQXLXSXMAYHX
          CQRZYLVQZXMWGWHAYBYCYDWIABCQXOXSYFYGAXOXSRZXDAXDESXSXKEQRSEVGVHEXSRLN
          EVIVJYKVPZVQYNYJXOSVSYOXDESWBZVEABCXOTBCETZURBCXOEXDESWDZWCAUUCURRZXQ
          QRZAUUCVARUUEUUFUFJABCELNUSUTZVBWEWFABQXOXSXPAYTYRUUAVQZXPWGWHAUUEUUF
          UUGWIWJAXRXFUDAXRBQXLXOOPZTXFABQXLXOOXMXPWKXSXSQWKRAWLVFYSUUHAXMWMAXP
          WMWOBQUUIXEXDUUIXEVSXDUUIXBXEXDXLDXOEOYQUUDULXDXBSWDWNYJUUISXEYJUUISS
          OPSYJXLSXOSOYPUUBULWPWQXDXBSWBWNWRWSWQWTXAWN $.
      $}

      $( Lemma for ~ itgadd .  (Contributed by Mario Carneiro, 17-Aug-2014.) $)
      itgaddlem2 $p |- ( ph -> S. A ( B + C ) _d x =
        ( S. A B _d x + S. A C _d x ) ) $=
        ( cc0 caddc co cle wbr citg wcel cr cif cneg cmin cv wa max0sub oveq12d
        wceq syl 0re sylancl recnd renegcld addsub4d readdcld addcld addsubeq4d
        ifcl 3eqtr4rd mpbird itgeq2dv cmpt cibl ibladd iblre simprd simpld max1
        mpbid sylancr addge0d itgaddlem1 3eqtr3d itgcl eqeltrd itgreval 3eqtr4d
        cc 3eqtrd ) ABCMDENOZPQZVTMUAZRZBCMVTUBZPQZWDMUAZRZUCOZBCMDPQZDMUAZRZBC
        MDUBZPQZWLMUAZRZUCOZBCMEPQZEMUAZRZBCMEUBZPQZWTMUAZRZUCOZNOZBCVTRBCDRZBC
        ERZNOAWHBCWJWRNOZRZBCWNXBNOZRZUCOZWKWSNOZWOXCNOZUCOXEAWGXINOZWCXKNOZUHW
        HXLUHABCWFXHNOZRBCWBXJNOZRXOXPABCXQXRABUDCSUEZXQXRUHWBWFUCOZXHXJUCOZUHX
        SWJWNUCOZWRXBUCOZNOVTYAXTXSYBDYCENXSDTSZYBDUHKDUFUIXSETSZYCEUHLEUFUIUGX
        SWJWRWNXBXSWJXSYDMTSZWJTSKUJWIDMTURUKZULZXSWRXSYEYFWRTSLUJWQEMTURUKZULZ
        XSWNXSWLTSZYFWNTSXSDKUMZUJWMWLMTURUKZULZXSXBXSWTTSZYFXBTSXSELUMZUJXAWTM
        TURUKZULZUNXSVTTSZXTVTUHXSDEKLUOZVTUFUIUSXSWFXHWBXJXSWFXSWDTSZYFWFTSXSV
        TYTUMZUJWEWDMTURUKZULXSWJWRYHYJUPXSWBXSYSYFWBTSYTUJWAVTMTURUKZULXSWNXBY
        NYRUPUQUTVAABCWFXHTUUCABCWBVBVCSZBCWFVBVCSZABCVTVBVCSUUEUUFUEABCDEFGHIJ
        VDZABCVTYTVEVIZVFZXSWJWRYGYIUOZABCWJWRTYGABCWJVBVCSZBCWNVBVCSZABCDVBVCS
        UUKUULUEHABCDKVEVIZVGZYIABCWRVBVCSZBCXBVBVCSZABCEVBVCSUUOUUPUEJABCELVEV
        IZVGZVDUUCUUJXSYFUUAMWFPQUJUUBMWDVHVJXSWJWRYGYIXSYFYDMWJPQUJKMDVHVJZXSY
        FYEMWRPQUJLMEVHVJZVKVLABCWBXJTUUDAUUEUUFUUHVGZXSWNXBYMYQUOZABCWNXBTYMAU
        UKUULUUMVFZYQAUUOUUPUUQVFZVDUUDUVBXSYFYSMWBPQUJYTMVTVHVJXSWNXBYMYQXSYFY
        KMWNPQUJYLMWLVHVJZXSYFYOMXBPQUJYPMWTVHVJZVKVLVMAWGXIWCXKABCWFTUUCUUIVNA
        XIXMVRABCWJWRTYGUUNYIUURYGYIUUSUUTVLZAWKWSABCWJTYGUUNVNZABCWRTYIUURVNZU
        PVOABCWBTUUDUVAVNAXKXNVRABCWNXBTYMUVCYQUVDYMYQUVEUVFVLZAWOXCABCWNTYMUVC
        VNZABCXBTYQUVDVNZUPVOUQVIAXIXMXKXNUCUVGUVJUGAWKWSWOXCUVHUVIUVKUVLUNVSAB
        CVTYTUUGVPAXFWPXGXDNABCDKHVPABCELJVPUGVQ $.
    $}

    $( Add two integrals over the same domain.  (Contributed by Mario Carneiro,
       17-Aug-2014.) $)
    itgadd $p |- ( ph -> S. A ( B + C ) _d x =
      ( S. A B _d x + S. A C _d x ) ) $=
      ( caddc co cfv citg ci cmul wcel cmpt cibl cr cre cim cv wa cmbf mbfmptcl
      iblmbf syl readdd recld iblcn mpbid simpld itgaddlem2 eqtrd imaddd simprd
      itgeq2dv imcld oveq2d ax-icn a1i itgcl adddid oveq12d mulcl sylancr add4d
      cc cvv ovex ibladd itgcnval 3eqtr4d ) ABCDEKLZUAMZNZOBCVOUBMZNZPLZKLZBCDU
      AMZNZOBCDUBMZNZPLZKLZBCEUAMZNZOBCEUBMZNZPLZKLZKLZBCVONBCDNZBCENZKLAWAWCWI
      KLZWFWLKLZKLWNAVQWQVTWRKAVQBCWBWHKLZNWQABCVPWSABUCCQUDZDEABCDFABCDRZSQZXA
      UEQHXAUGUHGUFZABCEFABCERZSQZXDUEQJXDUGUHIUFZUIURABCWBWHTWTDXCUJZABCWBRSQZ
      BCWDRSQZAXBXHXIUDHABCDXCUKULZUMZWTEXFUJZABCWHRSQZBCWJRSQZAXEXMXNUDJABCEXF
      UKULZUMZXGXLUNUOAVTOWEWKKLZPLWRAVSXQOPAVSBCWDWJKLZNXQABCVRXRWTDEXCXFUPURA
      BCWDWJTWTDXCUSZAXHXIXJUQZWTEXFUSZAXMXNXOUQZXSYAUNUOUTAOWEWKOVIQZAVAVBABCW
      DTXSXTVCZABCWJTYAYBVCZVDUOVEAWCWIWFWLABCWBTXGXKVCABCWHTXLXPVCAYCWEVIQWFVI
      QVAYDOWEVFVGAYCWKVIQWLVIQVAYEOWKVFVGVHUOABCVOVJVOVJQWTDEKVKVBABCDEFGHIJVL
      VMAWOWGWPWMKABCDFGHVMABCEFIJVMVEVN $.

    $( Subtract two integrals over the same domain.  (Contributed by Mario
       Carneiro, 25-Aug-2014.) $)
    itgsub $p |- ( ph -> S. A ( B - C ) _d x =
      ( S. A B _d x - S. A C _d x ) ) $=
      ( cneg caddc co citg cmin cmpt cibl wcel cmbf iblmbf cc syl negcld iblneg
      mbfmptcl cv wa itgadd itgneg oveq2d eqtr4d negsubd itgeq2dv itgcl 3eqtr3d
      ) ABCDEKZLMZNZBCDNZBCENZKZLMZBCDEOMZNUSUTOMAURUSBCUPNZLMVBABCDUPUAABCDFAB
      CDPZQRVESRHVETUBGUEZHABUFCRUGZEABCEFABCEPZQRVHSRJVHTUBIUEZUCABCEFIJUDUHAV
      AVDUSLABCEFIJUIUJUKABCUQVCVGDEVFVIULUMAUSUTABCDFGHUNABCEFIJUNULUO $.
  $}

  ${
    $d k m t w x y z A $.  $d k m t w x y z B $.  $d k m t w x y z ph $.
    $d m t w y z C $.
    itgfsum.1 $e |- ( ph -> A e. dom vol ) $.
    itgfsum.2 $e |- ( ph -> B e. Fin ) $.
    itgfsum.3 $e |- ( ( ph /\ ( x e. A /\ k e. B ) ) -> C e. V ) $.
    itgfsum.4 $e |- ( ( ph /\ k e. B ) -> ( x e. A |-> C ) e. L^1 ) $.
    $( Take a finite sum of integrals over the same domain.  (Contributed by
       Mario Carneiro, 24-Aug-2014.) $)
    itgfsum $p |- ( ph -> ( ( x e. A |-> sum_ k e. B C ) e. L^1 /\
      S. A sum_ k e. B C _d x = sum_ k e. B S. A C _d x ) ) $=
      ( vy vm csu cibl wcel citg wceq wa adantr vt vw vz wss cmpt ssid wi cv c0
      cfn cc0 csn cxp cun sseq1 sumeq1 syl6eq mpteq2dv fconstmpt syl6eqr eleq1d
      sum0 anbi1d itgz itgeq2dv 3eqtr4a biantrud bitr4d imbi12d eqeq12d anbi12d
      imbi2d weq cvol cdm ibl0 syl a1d wn ssun1 sstr mpan imim1i csb caddc nfcv
      co nfcsb1v csbeq1a cbvsumi simprl disjsn sylibr eqidd simprr ssfi syl2anc
      cin cc simplrr sselda wral cmbf anass1rs mbfmptcl an32s ralrimiva adantlr
      iblmbf nfel1 cbvral sylib r19.21bi syldan fsumsplit cvv vex unssbd csbeq1
      snss rspcv sylc sumsn sylancr oveq2d syl5eq mpteq2dva nfov oveq12d cbvmpt
      eqtrd a1i syl5eqelr nfv cbvitg 3eqtr4g itgcl itgeq2 mprg a2d mpteq2i elex
      sumex csbex eqtri nfmpt ibladd eqeltrd itgadd oveq12i nfitg eqcomd eqtr4d
      3eqtr3g 3eqtr4d jca ex expr syl5 expcom adantl findcard2s mpcom mpi ) ADD
      UDZBCDEFNZUEZOPZBCUVFQZDBCEQZFNZRZSZDUFDUJPZAUVEUVMUGZIAUAUHZDUDZBCUVPEFN
      ZUEZOPZBCUVRQZUVPUVJFNZRZSZUGZUGAUIDUDZCUKULUMZOPZUGZUGAUBUHZDUDZBCUWJEFN
      ZUEZOPZBCUWLQZUWJUVJFNZRZSZUGZUGAUWJUCUHZULZUNZDUDZBCUXBEFNZUEZOPZBCUXDQZ
      UXBUVJFNZRZSZUGZUGAUVOUGUAUBUCDUVPUIRZUWEUWIAUXLUVQUWFUWDUWHUVPUIDUOUXLUW
      DUWHUWCSUWHUXLUVTUWHUWCUXLUVSUWGOUXLUVSBCUKUEUWGUXLBCUVRUKUXLUVRUIEFNUKUV
      PUIEFUPEFVBUQZURBCUKUSUTVAVCUXLUWCUWHUXLBCUKQUKUWAUWBBCVDUXLBCUVRUKUXLUVR
      UKRBUHCPZUXMTVEUXLUWBUIUVJFNUKUVPUIUVJFUPUVJFVBUQVFVGVHVIVLUAUBVMZUWEUWSA
      UXOUVQUWKUWDUWRUVPUWJDUOUXOUVTUWNUWCUWQUXOUVSUWMOUXOBCUVRUWLUVPUWJEFUPZUR
      VAUXOUWAUWOUWBUWPUXOBCUVRUWLUXOUVRUWLRUXNUXPTVEUVPUWJUVJFUPVJVKVIVLUVPUXB
      RZUWEUXKAUXQUVQUXCUWDUXJUVPUXBDUOUXQUVTUXFUWCUXIUXQUVSUXEOUXQBCUVRUXDUVPU
      XBEFUPZURVAUXQUWAUXGUWBUXHUXQBCUVRUXDUXQUVRUXDRUXNUXRTVEUVPUXBUVJFUPVJVKV
      IVLUVPDRZUWEUVOAUXSUVQUVEUWDUVMUVPDDUOUXSUVTUVHUWCUVLUXSUVSUVGOUXSBCUVRUV
      FUVPDEFUPZURVAUXSUWAUVIUWBUVKUXSBCUVRUVFUXSUVRUVFRUXNUXTTVEUVPDUVJFUPVJVK
      VIVLAUWHUWFACVNVOPUWHHCVPVQVRUWJUJPZUWTUWJPVSZSAUWSUXKUYBAUWSUXKUGZUGUYAA
      UYBUYCUWSUXCUWRUGAUYBSZUXKUXCUWKUWRUWJUXBUDUXCUWKUWJUXAVTUWJUXBDWAWBWCUYD
      UXCUWRUXJAUYBUXCUWRUXJUGAUYBUXCSZSZUWRUXJUYFUWRSZUXFUXIUYGUXELCBLUHZUWJFM
      UHZEWDZMNZWDZBUYHFUWTEWDZWDZWEWGZUEZOUYFUXEUYPRUWRUYFUXEBCUYKUYMWEWGZUEUY
      PUYFBCUXDUYQUYFUXNSZUXDUXBUYJMNZUYQUXBEUYJFMMEWFZFUYIEWHZFUYIEWIZWJZUYRUY
      SUYKUXAUYJMNZWEWGUYQUYRUWJUXAUYJUXBMUYFUWJUXAWRUIRZUXNUYFUYBVUEAUYBUXCWKU
      WJUWTWLWMZTUYRUXBWNUYFUXBUJPZUXNUYFUVNUXCVUGAUVNUYEITAUYBUXCWOZDUXBWPWQZT
      UYRUYIUXBPZUYIDPZUYJWSPZUYRUXBDUYIAUYBUXCUXNWTXAUYRVULMDUYREWSPZFDXBZVULM
      DXBZAUXNVUNUYEAUXNSVUMFDAFUHDPZUXNVUMAVUPSZBCEGVUQBCEUEZOPZVURXCPKVURXIVQ
      AUXNVUPEGPJXDXEXFXGXHVUMVULFMDMEWSUYTXJFUYJWSVUAXJFMVMZEUYJWSVUBVAXKXLZXM
      ZXNXOUYRVUDUYMUYKWEUYRUWTXPPZUYMWSPZVUDUYMRUCXQZUYRUWTDPZVUOVVDUYFVVFUXNU
      YFUXADUDVVFUYFUWJUXADVUHXRUWTDVVEXTWMZTVVAVULVVDMUWTDMUCVMZUYJUYMWSFUYIUW
      TEXSZVAYAYBZUYJUYMMUWTXPVVIYCYDYEYKZYFYGBLCUYQUYOLUYQWFZBUYLUYNWEBUYHUYKW
      HZBWEWFBUYHUYMWHZYHZBLVMZUYKUYLUYMUYNWEBUYHUYKWIZBUYHUYMWIZYIZYJUQTUYGLCU
      YLUYNXPUYLXPPUYGUYHCPSBUYHUYKUWJUYJMUUCUUDYLZUYGLCUYLUEZUWMOUWMBCUYKUEVWA
      BCUWLUYKUWJEUYJFMUYTVUAVUBWJZUUABLCUYKUYLLUYKWFZVVMVVQYJUUEUYFUWNUWQWKYMZ
      UYGUYNXPPZLCUYGUYMXPPZBCXBZVWELCXBUYFVWGUWRUYFVWFBCUYRVVDVWFVVJUYMWSUUBVQ
      XGTVWFVWEBLCVWFLYNBUYNXPVVNXJVVPUYMUYNXPVVRVAXKXLXMZUYFLCUYNUEZOPUWRUYFVW
      IBCUYMUEZOBLCUYMUYNLUYMWFZVVNVVRYJUYFVVFBCUYJUEZOPZMDXBZVWJOPZVVGAVWNUYEA
      VUSFDXBVWNAVUSFDKXGVUSVWMFMDVUSMYNFVWLOFBCUYJFCWFZVUAUUFXJVUTVURVWLOVUTBC
      EUYJVUBURVAXKXLTZVWMVWOMUWTDVVHVWLVWJOVVHBCUYJUYMVVIURVAYAYBZYMTZUUGUUHUY
      GBCUYSQZUXBBCUYJQZMNZUXGUXHUYGBCUYQQZBCUYKQZBCUYMQZWEWGZVWTVXBUYGLCUYOQLC
      UYLQZLCUYNQZWEWGVXCVXFUYGLCUYLUYNXPVVTVWDVWHVWSUUIBLCUYQUYOVVSVVLVVOYOVXD
      VXGVXEVXHWEBLCUYKUYLVVQVWCVVMYOBLCUYMUYNVVRVWKVVNYOUUJYPUYFVWTVXCRUWRUYFB
      CUYSUYQVVKVETUYGVXBUWJVXAMNZUXAVXAMNZWEWGZVXFUYFVXBVXKRUWRUYFUWJUXAVXAUXB
      MVUFUYFUXBWNVUIUYFVUJVUKVXAWSPUYFUXBDUYIVUHXAUYFVUKSBCUYJWSUYFUXNVUKVULVV
      BXFUYFVWMMDVWQXMYQXNXOTUYGVXDVXIVXEVXJWEUYGUWOUWPVXDVXIUYFUWNUWQWOUWLUYKR
      ZUWOVXDRBCBCUWLUYKYRVXLUXNVWBYLYSUWJUVJVXAFMMUVJWFZBFCUYJVWPVUAUUKZVUTBCE
      UYJVUTEUYJRUXNVUBTVEZWJUUNUYGVXJVXEUYGVVCVXEWSPZVXJVXERVVEUYFVXPUWRUYFBCU
      YMWSVVJVWRYQTVXAVXEMUWTXPVVHBCUYJUYMVVHUYJUYMRUXNVVITVEYCYDUULYIUUMUUOUXD
      UYSRZUXGVWTRBCBCUXDUYSYRVXQUXNVUCYLYSUXBUVJVXAFMVXMVXNVXOWJYPUUPUUQUURYTU
      USUUTUVAYTUVBUVCUVD $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y F $.  $d x ph $.
    iblabs.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    iblabs.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    ${
      iblabs.3 $e |- G = ( x e. RR |->
        if ( x e. A , ( abs ` ( F ` B ) ) , 0 ) ) $.
      iblabs.4 $e |- ( ph -> ( x e. A |-> ( F ` B ) ) e. L^1 ) $.
      iblabs.5 $e |- ( ( ph /\ x e. A ) -> ( F ` B ) e. RR ) $.
      $( Lemma for ~ iblabs .  (Contributed by Mario Carneiro, 25-Aug-2014.) $)
      iblabslem $p |- ( ph -> ( G e. MblFn /\ ( S.2 ` G ) e. RR ) ) $=
        ( wcel cr cabs cc0 cmpt cc co caddc cmbf citg2 cfv cif cvol cdm wss cle
        vy cv wbr wa cneg cibl w3a iblrelem mpbid simp1d mbfdm2 mblss syl rembl
        a1i wceq iftrue adantl recnd abscld eqeltrd cdif wn eldifn iffalse ccom
        eqidd absf feqmptd fveq2 fmptco mpteq2ia syl6reqr ccncf fmptd ax-resscn
        wf eqid ssid cncfss mp2an abscncf sselii cncombf syl3anc mbfss syl5eqel
        cof cvv cpnf cico reex ifan 0re ifcl sylancl max1 sylancr sylanbrc 0le0
        elrege0 mpbir2an ifclda adantr renegcld offval2 oveq12i max0add oveq12d
        3eqtr4d 00id 3eqtr4a pm2.61d1 syl5eq mpteq2dv eqtrd fveq2d ifbid mbfpos
        ex ibar syl5eqelr simp2d mbfneg simp3d itg2add readdcld jca ) AFUAMFUBU
        CZNMAFBNBUJZCMZDEUCZOUCZPUDZQZUAJABCNUUBNACUEUFZMCNUGABCYTNABCYTQZUAMZB
        NYSPYTUHUKZULZYTPUDZQZUBUCZNMZBNYSPYTUMZUHUKZULZUUMPUDZQZUBUCZNMZAUUEUN
        MUUFUULUUSUOKABCYTLUPUQZURZLUSCUTVAZNUUDMAVBVCZAYSULZUUBUUANYSUUBUUAVDA
        YSUUAPVEZVFZUVDYTUVDYTLVGZVHVIAYRNCVJMZULZYSVKZUUBPVDUVHUVJAYRNCVLVFZYS
        UUAPVMZVAABCUUBQZOUUEVNZUAAUVNBCUUAQUVMABUICRYTUIUJZOUCUUAUUEOUVGAUUEVO
        AUIRNORNOWEAVPVCVQUVOYTOVRVSBCUUBUUAUVEVTWAAUUFCRUUEWEORRWBSZMZUVNUAMUV
        AABCYTRUUEUVGUUEWFWCUVQARNWBSZUVPONRUGRRUGUVRUVPUGWDRWGRNRWHWIWJWKVCCRU
        UEOWLWMVIWNWOAYQUUKUURTSZNAYQUUJUUQTWPSZUBUCUVSAFUVTUBAUVTUUCFAUVTBNUUI
        UUPTSZQUUCABNUUIUUPTUUJUUQWQPWRWSSZUWBNWQMAWTVCAUUIUWBMZYRNMZAUUIYSUUGY
        TPUDZPUDZUWBYSUUGYTPXAZAYSUWEPUWBUVDUWENMZPUWEUHUKZUWEUWBMUVDYTNMZPNMZU
        WHLXBUUGYTPNXCXDUVDUWKUWJUWIXBLPYTXEXFUWEXIXGPUWBMZAUVJULUWLUWKPPUHUKXB
        XHPXIXJVCZXKWOZXLZAUUPUWBMZUWDAUUPYSUUNUUMPUDZPUDZUWBYSUUNUUMPXAZAYSUWQ
        PUWBUVDUWQNMZPUWQUHUKZUWQUWBMUVDUUMNMZUWKUWTUVDYTLXMZXBUUNUUMPNXCXDUVDU
        WKUXBUXAXBUXCPUUMXEXFUWQXIXGUWMXKWOZXLZAUUJVOAUUQVOXNABNUWAUUBAUWAUWFUW
        RTSZUUBUUIUWFUUPUWRTUWGUWSXOAYSUXFUUBVDZAYSUXGUVDUWEUWQTSZUUAUXFUUBUVDU
        WJUXHUUAVDLYTXPVAUVDUWFUWEUWRUWQTYSUWFUWEVDAYSUWEPVEVFYSUWRUWQVDAYSUWQP
        VEVFXQUVFXRYHUVJPPTSPUXFUUBXSUVJUWFPUWRPTYSUWEPVMZYSUWQPVMZXQUVLXTYAYBY
        CYDJWAYEAUUJUUQABCNUUIUWBUVBUVCAUWCYSUWNXLUVIUVJUUIPVDUVKUVJUUIUWFPUWGU
        XIYBVAABCUUIQBCUWEQUABCUWEUUIYSUUGUUHYTPYSUUGYIYFVTABCYTLUVAYGYJWNABNUU
        IUWBUUJUWOUUJWFWCAUUFUULUUSUUTYKZABCNUUPUWBUVBUVCAUWPYSUXDXLUVIUVJUUPPV
        DUVKUVJUUPUWRPUWSUXJYBVAABCUUPQBCUWQQUABCUWQUUPYSUUNUUOUUMPYSUUNYIYFVTA
        BCUUMUXCABCYTNLUVAYLYGYJWNABNUUPUWBUUQUXEUUQWFWCAUUFUULUUSUUTYMZYNYDAUU
        KUURUXKUXLYOVIYP $.
    $}

    $( The absolute value of an integrable function is integrable.
       (Contributed by Mario Carneiro, 25-Aug-2014.) $)
    iblabs $p |- ( ph -> ( x e. A |-> ( abs ` B ) ) e. L^1 ) $=
      ( cabs cfv cmpt wcel cmbf cr cc0 citg2 cc co caddc cle wbr vy cibl cv cif
      ccom iblmbf syl mbfmptcl eqidd wf absf a1i feqmptd fveq2 ccncf eqid fmptd
      fmptco wss ax-resscn cncfss mp2an abscncf sselii cncombf syl3anc eqeltrrd
      ssid cpnf cicc cre cim cxr abscld rexrd absge0d elxrge0 sylanbrc 0xr 0le0
      wa mpbir2an ifclda adantr cof cvv cico reex recld recnd elrege0 0re imcld
      wn offval2 wceq iftrue oveq12d eqtr4d 00id iffalse 3eqtr4a pm2.61i fveq2d
      mpteq2i syl6req iblcn mpbid simpld iblabslem simprd itg2add eqtrd eqeltrd
      readdcld cofr addge0d wral ci ax-icn mulcl sylancr abstrid replimd absmul
      cmul c1 absi oveq1i mulid2d syl5eq eqtr2d oveq2d 3brtr4d adantl ralrimivw
      ex pm2.61d1 ofrfval2 mpbird itg2le itg2lecl iblpos mpbir2and ) ABCDHIZJZU
      BKUUFLKBMBUCZCKZUUENUDZJZOIZMKZAHBCDJZUEZUUFLABUACPDUAUCZHIUUEUUMHABCDEAU
      UMUBKZUUMLKZGUUMUFUGZFUHZAUUMUIAUAPMHPMHUJAUKULUMUUODHUNURAUUQCPUUMUJHPPU
      OQZKZUUNLKUURABCDPUUMUUSUUMUPUQUVAAPMUOQZUUTHMPUSPPUSUVBUUTUSUTPVHPMPVAVB
      VCVDULCPUUMHVEVFVGAMNVIVJQZUUJUJZBMUUHDVKIZHIZDVLIZHIZRQZNUDZJZOIZMKUUKUV
      LSTZUULABMUUIUVCUUJAUUIUVCKUUGMKZAUUHUUENUVCAUUHWAZUUEVMKNUUESTUUEUVCKUVO
      UUEUVODUUSVNZVOUVODUUSVPZUUEVQVRNUVCKZAUUHWNZWAZUVRNVMKNNSTZVSVTNVQWBULZW
      CWDZUUJUPUQZAUVLBMUUHUVFNUDZJZOIZBMUUHUVHNUDZJZOIZRQZMAUVLUWFUWIRWEQZOIUW
      KAUVKUWLOAUWLBMUWEUWHRQZJUVKABMUWEUWHRUWFUWIWFNVIWGQZUWNMWFKAWHULZAUWEUWN
      KUVNAUUHUVFNUWNUVOUVFMKNUVFSTUVFUWNKUVOUVEUVOUVEUVODUUSWIZWJZVNZUVOUVEUWQ
      VPZUVFWKVRNUWNKZUVTUWTNMKUWAWLVTNWKWBULZWCWDZAUWHUWNKUVNAUUHUVHNUWNUVOUVH
      MKNUVHSTUVHUWNKUVOUVGUVOUVGUVODUUSWMZWJZVNZUVOUVGUXDVPZUVHWKVRUXAWCWDZAUW
      FUIAUWIUIWOBMUWMUVJUUHUWMUVJWPUUHUWMUVIUVJUUHUWEUVFUWHUVHRUUHUVFNWQUUHUVH
      NWQWRUUHUVINWQZWSUVSNNRQNUWMUVJWTUVSUWENUWHNRUUHUVFNXAUUHUVHNXAWRUUHUVINX
      AZXBXCXEXFXDAUWFUWIAUWFLKZUWGMKZABCDVKUWFEFGUWFUPZABCUVEJUBKZBCUVGJUBKZAU
      UPUXMUXNWAGABCDUUSXGXHZXIUWPXJZXIABMUWEUWNUWFUXBUXLUQAUXJUXKUXPXKZAUWILKZ
      UWJMKZABCDVLUWIEFGUWIUPZAUXMUXNUXOXKUXCXJZXIABMUWHUWNUWIUXGUXTUQAUXRUXSUY
      AXKZXLXMAUWGUWJUXQUYBXOXNAUVDMUVCUVKUJUUJUVKSXPTZUVMUWDABMUVJUVCUVKAUVJUV
      CKUVNAUUHUVINUVCUVOUVIVMKNUVISTUVIUVCKUVOUVIUVOUVFUVHUWRUXEXOVOUVOUVFUVHU
      WRUXEUWSUXFXQUVIVQVRUWBWCWDZUVKUPUQAUYCUUIUVJSTZBMXRAUYEBMAUUHUYEAUUHUYEU
      VOUUEUVIUUIUVJSUVOUVEXSUVGYFQZRQZHIUVFUYFHIZRQUUEUVISUVOUVEUYFUWQUVOXSPKZ
      UVGPKZUYFPKXTUXDXSUVGYAYBYCUVODUYGHUVODUUSYDXDUVOUVHUYHUVFRUVOUYHXSHIZUVH
      YFQZUVHUVOUYIUYJUYHUYLWPXTUXDXSUVGYEYBUVOUYLYGUVHYFQUVHUYKYGUVHYFYHYIUVOU
      VHUVOUVHUXEWJYJYKYLYMYNUUHUUIUUEWPAUUHUUENWQYOUUHUVJUVIWPAUXHYOYNYQUVSNNU
      UIUVJSUWAUVSVTULUUHUUENXAUXIYNYRYPABMUUIUVJSUUJUVKWFUVCUVCUWOUWCUYDAUUJUI
      AUVKUIYSYTUUJUVKUUAVFUVLUUJUUBVFABCUUEUVPUVQUUCUUD $.
  $}

  ${
    $d k x A $.  $d k B $.  $d k x ph $.  $d x V $.
    iblabsr.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    iblabsr.2 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    iblabsr.3 $e |- ( ph -> ( x e. A |-> ( abs ` B ) ) e. L^1 ) $.
    $( A measurable function is integrable iff its absolute value is
       integrable.  (See ~ iblabs for the forward implication.)  (Contributed
       by Mario Carneiro, 25-Aug-2014.) $)
    iblabsr $p |- ( ph -> ( x e. A |-> B ) e. L^1 ) $=
      ( vk wcel cr cc0 ci co cfv cle wbr wa adantr c1 cmpt cibl cmbf cv cre cif
      cexp cdiv citg2 c3 cfz wral cpnf cicc wf cabs ifan cc mbfmptcl adantlr cz
      cxr elfzelz ad2antlr wne ax-icn ine0 expclz mp3an12 syl expne0i recld 0re
      divcld ifcl sylancl rexrd max1 sylancr elxrge0 sylanbrc 0xr 0le0 mpbir2an
      wn a1i ifclda syl5eqel eqid fmptd abscld absge0d iblpos mpbid simprd cofr
      releabsd absdivd wceq elfznn0 absexp absi oveq1i 1exp syl5eq eqtrd oveq2d
      recnd div1d breqtrd breq1 ifboth syl2anc iftrue adantl 3brtr4d ex iffalse
      cn0 pm2.61d1 syl5eqbr ralrimivw reex eqidd ofrfval2 mpbird itg2le syl3anc
      cvv itg2lecl ralrimiva isibl2 mpbir2and ) ABCDUAZUBJYNUCJBKBUDZCJZLDMIUDZ
      UGNZUHNZUEOZPQZRYTLUFZUAZUIOZKJZILUJUKNZULGAUUEIUUFAYQUUFJZRZKLUMUNNZUUCU
      OZBKYPDUPOZLUFZUAZUIOZKJZUUDUUNPQZUUEUUHBKUUBUUIUUCUUHUUBUUIJYOKJZUUHUUBY
      PUUAYTLUFZLUFZUUIYPUUAYTLUQZUUHYPUURLUUIUUHYPRZUURVBJLUURPQZUURUUIJUVAUUR
      UVAYTKJZLKJZUURKJUVAYSUVADYRAYPDURJUUGABCDEGFUSZUTZUVAYQVAJZYRURJZUUGUVGA
      YPYQLUJVCVDZMURJZMLVEZUVGUVHVFVGMYQVHVIVJZUVAUVGYRLVEZUVIUVJUVKUVGUVMVFVG
      MYQVKVIVJZVNZVLZVMUUAYTLKVOVPVQUVAUVDUVCUVBVMUVPLYTVRVSUURVTWALUUIJZUUHYP
      WEZRUVQLVBJLLPQZWBWCLVTWDZWFZWGWHSZUUCWIWJZAUUOUUGABCUUKUAZUCJZUUOAUWDUBJ
      UWEUUORHABCUUKAYPRZDUVEWKZUWFDUVEWLZWMWNWOSUUHUUJKUUIUUMUOZUUCUUMPWPQZUUP
      UWCAUWIUUGABKUULUUIUUMAUULUUIJZUUQAYPUUKLUUIUWFUUKVBJZLUUKPQZUUKUUIJZUWFU
      UKUWGVQZUWHUUKVTZWAUVQAUVRRUVTWFWGSUUMWIWJSUUHUWJUUBUULPQZBKULUUHUWQBKUUH
      UUBUUSUULPUUTUUHYPUUSUULPQZUUHYPUWRUVAUURUUKUUSUULPUVAYTUUKPQZUWMUURUUKPQ
      ZUVAYTYSUPOZUUKPUVAYSUVOWQUVAUXAUUKYRUPOZUHNZUUKUVADYRUVFUVLUVNWRUVAUXCUU
      KTUHNUUKUVAUXBTUUKUHUVAUXBMUPOZYQUGNZTUVAUVJYQXSJZUXBUXEWSVFUUGUXFAYPYQUJ
      WTVDMYQXAVSUVAUXETYQUGNZTUXDTYQUGXBXCUVAUVGUXGTWSUVIYQXDVJXEXFXGUVAUUKAYP
      UUKURJUUGUWFUUKUWGXHUTXIXFXFXJUVADUVFWLZUUAUWSUWMUWTYTLYTUURUUKPXKLUURUUK
      PXKXLXMYPUUSUURWSUUHYPUURLXNXOYPUULUUKWSUUHYPUUKLXNXOXPXQUVRLLUUSUULPUVSU
      VRWCWFYPUURLXRYPUUKLXRXPXTYAYBUUHBKUUBUULPUUCUUMYIUUIUUIKYIJUUHYCWFUWBUUH
      UWKUUQUUHYPUUKLUUIUVAUWLUWMUWNAYPUWLUUGUWOUTUXHUWPWAUWAWGSUUHUUCYDUUHUUMY
      DYEYFUUCUUMYGYHUUNUUCYJYHYKABCDYTIUUCEAUUCYDUWFYTYDFYLYM $.
  $}

  ${
    $d k x A $.  $d k B $.  $d k x C $.  $d k x ph $.  $d x V $.
    itgmulc2.1 $e |- ( ph -> C e. CC ) $.
    itgmulc2.2 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgmulc2.3 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( Multiply an integral by a constant.  (Contributed by Mario Carneiro,
       25-Aug-2014.) $)
    iblmulc2 $p |- ( ph -> ( x e. A |-> ( C x. B ) ) e. L^1 ) $=
      ( cmul co cmpt wcel cr cc0 ci cfv cle wbr wa vk cibl cmbf cv cexp cre cif
      cdiv citg2 c3 cfz wral iblmbf syl mbfmulc2 cpnf cicc cabs ifan cxr adantr
      wf cc mbfmptcl mulcld adantlr cz elfzelz ad2antlr wne ax-icn ine0 mp3an12
      expclz expne0i recld 0re ifcl sylancl rexrd max1 sylancr elxrge0 sylanbrc
      divcld wn 0xr 0le0 mpbir2an a1i ifclda syl5eqel eqid csn cxp cof cvv cico
      fmptd reex abscld absge0d elrege0 wceq fconstmpt eqidd offval2 oveq2 ifsb
      absmuld ifeq1da mul01d ifeq2d eqtr3d syl5eq mpteq2dv fveq2d iblabs iblpos
      recnd eqtrd mpbid simprd abscl itg2mulc remulcld eqeltrd cofr releabsd c1
      absge0 absdivd cn0 elfznn0 breq1 iftrue adantl 3brtr4d iffalse syl3anc ex
      absexp absi oveq1i oveq2d 3eqtrd breqtrd ifboth syl2anc pm2.61d1 syl5eqbr
      1exp ralrimivw ofrfval2 mpbird itg2le itg2lecl ralrimiva isibl2 mpbir2and
      div1d ) ABCEDJKZLZUBMUVCUCMBNBUDZCMZOUVBPUAUDZUEKZUHKZUFQZRSZTUVIOUGZLZUI
      QZNMZUAOUJUKKZULABCDEFGHABCDLZUBMUVPUCMIUVPUMUNZUOAUVNUAUVOAUVFUVOMZTZNOU
      PUQKZUVLVBZBNUVEUVBURQZOUGZLZUIQZNMZUVMUWERSZUVNUVSBNUVKUVTUVLUVSUVDNMZTU
      VKUVEUVJUVIOUGZOUGZUVTUVEUVJUVIOUSZUVSUWJUVTMUWHUVSUVEUWIOUVTUVSUVETZUWIU
      TMOUWIRSZUWIUVTMUWLUWIUWLUVINMZONMZUWINMUWLUVHUWLUVBUVGAUVEUVBVCMUVRAUVET
      ZEDAEVCMZUVEGVAZABCDFUVQHVDZVEZVFZUWLUVFVGMZUVGVCMZUVRUXBAUVEUVFOUJVHVIZP
      VCMZPOVJZUXBUXCVKVLPUVFVNVMUNZUWLUXBUVGOVJZUXDUXEUXFUXBUXHVKVLPUVFVOVMUNZ
      WEZVPZVQUVJUVIONVRVSVTUWLUWOUWNUWMVQUXKOUVIWAWBUWIWCWDOUVTMZUVSUVEWFZTUXL
      OUTMOORSZWGWHOWCWIZWJWKVAWLZUVLWMWSZAUWFUVRAUWEEURQZBNUVEDURQZOUGZLZUIQZJ
      KZNANUXRWNWOZUYAJWPKZUIQUWEUYCAUYEUWDUIAUYEBNUXRUXTJKZLUWDABNUXRUXTJUYDUY
      AWQNOUPWRKZNWQMZAWTWJAUXRNMZUWHAEGXAZVAAUXTUYGMUWHAUVEUXSOUYGUWPUXSNMOUXS
      RSUXSUYGMUWPDUWSXAZUWPDUWSXBZUXSXCWDOUYGMZAUXMTZUYMUWOUXNVQWHOXCWIWJWKVAZ
      UYDBNUXRLXDABNUXRXEWJAUYAXFXGABNUYFUWCAUYFUVEUXRUXSJKZUXROJKZUGZUWCUVEUXS
      OUYFUYPUYQUXTUXSUXRJXHUXTOUXRJXHXIAUVEUWBUYQUGUYRUWCAUVEUWBUYPUYQUWPEDUWR
      UWSXJXKAUVEUYQOUWBAUXRAUXRUYJXTXLXMXNXOXPYAXQAUXRUYAABNUXTUYGUYAUYOUYAWMW
      SABCUXSLZUCMZUYBNMZAUYSUBMUYTVUATABCDFHIXRABCUXSUYKUYLXSYBYCZAUWQUXRUYGMZ
      GUWQUYIOUXRRSVUCEYDEYKUXRXCWDUNYEXNAUXRUYBUYJVUBYFYGVAUVSUWANUVTUWDVBZUVL
      UWDRYHSZUWGUXQAVUDUVRABNUWCUVTUWDAUWCUVTMZUWHAUVEUWBOUVTUWPUWBUTMOUWBRSZU
      WBUVTMUWPUWBUWPUVBUWTXAZVTUWPUVBUWTXBZUWBWCWDUXLUYNUXOWJWKVAZUWDWMWSVAUVS
      VUEUVKUWCRSZBNULUVSVUKBNUVSUVKUWJUWCRUWKUVSUVEUWJUWCRSZUVSUVEVULUWLUWIUWB
      UWJUWCRUWLUVIUWBRSZVUGUWIUWBRSZUWLUVIUVHURQZUWBRUWLUVHUXJYIUWLVUOUWBUVGUR
      QZUHKUWBYJUHKUWBUWLUVBUVGUXAUXGUXIYLUWLVUPYJUWBUHUWLVUPPURQZUVFUEKZYJUWLU
      XEUVFYMMZVUPVURXDVKUVRVUSAUVEUVFUJYNVIPUVFUUBWBUWLVURYJUVFUEKZYJVUQYJUVFU
      EUUCUUDUWLUXBVUTYJXDUXDUVFUULUNXOYAUUEUWLUWBAUVEUWBVCMUVRUWPUWBVUHXTVFUVA
      UUFUUGAUVEVUGUVRVUIVFUVJVUMVUGVUNUVIOUVIUWIUWBRYOOUWIUWBRYOUUHUUIUVEUWJUW
      IXDUVSUVEUWIOYPYQUVEUWCUWBXDUVSUVEUWBOYPYQYRUUAUXMOOUWJUWCRUXNUXMWHWJUVEU
      WIOYSUVEUWBOYSYRUUJUUKUUMUVSBNUVKUWCRUVLUWDWQUVTUVTUYHUVSWTWJUXPAUWHVUFUV
      RVUJVFUVSUVLXFUVSUWDXFUUNUUOUVLUWDUUPYTUWEUVLUUQYTUURABCUVBUVIUAUVLVCAUVL
      XFUWPUVIXFUWTUUSUUT $.

    ${
      itgmulc2.4 $e |- ( ph -> C e. RR ) $.
      itgmulc2.5 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
      ${
        itgmulc2.6 $e |- ( ph -> 0 <_ C ) $.
        itgmulc2.7 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
        $( Lemma for ~ itgmulc2 : positive real case.  (Contributed by Mario
           Carneiro, 25-Aug-2014.) $)
        itgmulc2lem1 $p |- ( ph ->
          ( C x. S. A B _d x ) = S. A ( C x. B ) _d x ) $=
          ( cr wcel cc0 cmpt cmul co adantr cif citg2 cfv citg csn cxp cof cpnf
          cv cico wa cle wbr elrege0 sylanbrc 0re 0le0 mpbir2an a1i ifclda eqid
          fmptd cmbf cibl iblpos mpbid simprd itg2mulc cvv reex fconstmpt eqidd
          wceq offval2 oveq2 mul01d ifeq2d syl5eq mpteq2dva eqtrd fveq2d eqtr3d
          wn ifsb itgposval oveq2d remulcld iblmulc2 mulge0d 3eqtr4d ) AEBNBUIZ
          COZDPUAZQZUBUCZRSZBNWLEDRSZPUAZQZUBUCZEBCDUDZRSBCWQUDANEUEUFZWNRUGSZU
          BUCWPWTAEWNABNWMPUHUJSZWNAWMXDOWKNOZAWLDPXDAWLUKZDNOPDULUMDXDOKMDUNUO
          PXDOZAWLWCUKXGPNOPPULUMUPUQPUNURUSUTTZWNVAVBABCDQZVCOZWONOZAXIVDOXJXK
          UKIABCDKMVEVFVGAENOZPEULUMZEXDOJLEUNUOVHAXCWSUBAXCBNEWMRSZQWSABNEWMRX
          BWNVINXDNVIOAVJUSAXLXEJTXHXBBNEQVMABNEVKUSAWNVLVNABNXNWRAXEUKZXNWLWQE
          PRSZUAWRWLDPXNWQXPWMDERVOWMPERVOWDXOWLXPPWQAXPPVMXEAEGVPTVQVRVSVTWAWB
          AXAWOERABCDKIMWEWFABCWQXFEDAXLWLJTZKWGABCDEFGHIWHXFEDXQKAXMWLLTMWIWEW
          J $.
      $}

      $( Lemma for ~ itgmulc2 : real case.  (Contributed by Mario Carneiro,
         25-Aug-2014.) $)
      itgmulc2lem2 $p |- ( ph ->
        ( C x. S. A B _d x ) = S. A ( C x. B ) _d x ) $=
        ( cmul co citg cc0 cle wbr cmin wcel cr cif cneg cv wceq adantr max0sub
        wa syl oveq1d 0re ifcl sylancl recnd renegcld subdird itgeq2dv remulcld
        cc eqtr3d iblmulc2 itgsub cmpt cibl iblre simpld simprd oveq2d itgreval
        mpbid subdid itgcl sylancr itgmulc2lem1 oveq12d 3eqtr4d 3eqtr2d 3eqtrrd
        max1 3eqtrd ) ABCEDLMZNBCOEPQZEOUAZDLMZOEUBZPQZWDOUAZDLMZRMZNBCWCNZBCWG
        NZRMZEBCDNZLMZABCVTWHABUCCSZUGZWBWFRMZDLMVTWHWOWPEDLWOETSZWPEUDZAWQWNJU
        EEUFZUHUIWOWBWFDAWBURSWNAWBAWQOTSZWBTSZJUJWAEOTUKULZUMZUEZAWFURSWNAWFAW
        DTSZWTWFTSZAEJUNZUJWEWDOTUKULZUMZUEZWODKUMUOUSUPABCWCWGTWOWBDAXAWNXBUEZ
        KUQABCDWBFXCHIUTWOWFDAXFWNXHUEZKUQABCDWFFXIHIUTVAAWKWBWLLMZWFWLLMZRMWPW
        LLMWMAWIXMWJXNRABCWBODPQZDOUAZLMZWBODUBZPQZXROUAZLMZRMZNBCXQNZBCYANZRMZ
        WIXMABCXQYATWOWBXPXKWODTSZWTXPTSKUJXODOTUKULZUQABCXPWBTXCYGABCXPVBVCSZB
        CXTVBVCSZABCDVBVCSYHYIUGIABCDKVDVIZVEZUTWOWBXTXKWOXRTSZWTXTTSWODKUNZUJX
        SXROTUKULZUQABCXTWBTXCYNAYHYIYJVFZUTVAABCWCYBWOWBXPXTRMZLMWCYBWOYPDWBLW
        OYFYPDUDKDUFUHZVGWOWBXPXTXDWOXPYGUMZWOXTYNUMZVJUSUPAXMWBBCXPNZBCXTNZRMZ
        LMWBYTLMZWBUUALMZRMYEAWLUUBWBLABCDKIVHZVGAWBYTUUAXCABCXPTYGYKVKZABCXTTY
        NYOVKZVJAUUCYCUUDYDRABCXPWBTXCYGYKXBYGAWTWQOWBPQUJJOEVRVLZWOWTYFOXPPQUJ
        KODVRVLZVMABCXTWBTXCYNYOXBYNUUHWOWTYLOXTPQUJYMOXRVRVLZVMVNVSVOABCWFXPLM
        ZWFXTLMZRMZNBCUUKNZBCUULNZRMZWJXNABCUUKUULTWOWFXPXLYGUQABCXPWFTXIYGYKUT
        WOWFXTXLYNUQABCXTWFTXIYNYOUTVAABCWGUUMWOWFYPLMWGUUMWOYPDWFLYQVGWOWFXPXT
        XJYRYSVJUSUPAXNWFUUBLMWFYTLMZWFUUALMZRMUUPAWLUUBWFLUUEVGAWFYTUUAXIUUFUU
        GVJAUUQUUNUURUUORABCXPWFTXIYGYKXHYGAWTXEOWFPQUJXGOWDVRVLZUUIVMABCXTWFTX
        IYNYOXHYNUUSUUJVMVNVSVOVNAWBWFWLXCXIABCDFHIVKUOAWPEWLLAWQWRJWSUHUIVPVQ
        $.
    $}

    $( Multiply an integral by a constant.  (Contributed by Mario Carneiro,
       25-Aug-2014.) $)
    itgmulc2 $p |- ( ph -> ( C x. S. A B _d x ) = S. A ( C x. B ) _d x ) $=
      ( cfv ci cmul co caddc citg cc wcel mulcld cr itgcl cre cim cneg cv recld
      wa recnd adantr cmpt cibl iblmbf syl mbfmptcl iblcn mpbid simpld iblmulc2
      ax-icn imcld simprd mulcl sylancr renegcld adddird itgcnval oveq2d adddid
      cmbf add4d itgmulc2lem2 a1i mul12d eqtrd oveq12d 3eqtrd mulassd mul4d ixi
      oveq1i mulm1d syl5eq mulneg1d eqtr3d addcomd cmin negsubd remuld itgeq2dv
      c1 3eqtr4d itgadd immuld replimd oveq1d ) AEUAJZKEUBJZLMZNMZBCDOZLMZBCEDL
      MZUAJZOZKBCXAUBJZOZLMZNMZEWSLMBCXAOABCWODUAJZLMZOZKBCWODUBJZLMZOZLMZNMZBC
      WPUCZXKLMZOZKBCWPXHLMZOZLMZNMZNMZXJXRNMZXNYANMZNMWTXGAXJXNXRYAABCXIPABUDC
      QZUFZWOXHAWOPQYFAWOAEGUEZUGZUHZYGXHYGDABCDFABCDUIZUJQZYKVHQIYKUKULHUMZUEZ
      UGZRZABCXHWOSYIYNABCXHUIUJQZBCXKUIUJQZAYLYQYRUFIABCDYMUNUOZUPZUQZTAKPQZXM
      PQXNPQURABCXLPYGWOXKYJYGXKYGDYMUSZUGZRZABCXKWOSYIUUCAYQYRYSUTZUQZTZKXMVAV
      BABCXQPYGXPXKAXPPQYFAXPAWPAEGUSZVCZUGZUHUUDRZABCXKXPSUUKUUCUUFUQZTZAUUBXT
      PQYAPQURABCXSPYGWPXHAWPPQZYFAWPUUIUGZUHZYORZABCXHWPSUUPYNYTUQZTZKXTVAVBZV
      IAWTWOWSLMZWQWSLMZNMYCAWOWQWSYIAUUBUUOWQPQURUUPKWPVAVBZABCDFHITVDAUVBXOUV
      CYBNAUVBWOBCXHOZKBCXKOZLMZNMZLMWOUVELMZWOUVGLMZNMXOAWSUVHWOLABCDFHIVEZVFA
      WOUVEUVGYIABCXHSYNYTTZAUUBUVFPQUVGPQURABCXKSUUCUUFTZKUVFVAVBZVGAUVIXJUVJX
      NNABCXHWOSYIYNYTYHYNVJAUVJKWOUVFLMZLMXNAWOKUVFYIUUBAURVKZUVMVLAUVOXMKLABC
      XKWOSYIUUCUUFYHUUCVJVFVMVNVOAUVCWQUVHLMWQUVELMZWQUVGLMZNMZYBAWSUVHWQLUVKV
      FAWQUVEUVGUVDUVLUVNVGAUVSYAXRNMYBAUVQYAUVRXRNAUVQKWPUVELMZLMYAAKWPUVEUVPU
      UPUVLVPAUVTXTKLABCXHWPSUUPYNYTUUIYNVJVFVMAUVRKKLMZWPUVFLMZLMZUWBUCZXRAKWP
      KUVFUVPUUPUVPUVMVQAUWCWIUCZUWBLMUWDUWAUWEUWBLVRVSAUWBAWPUVFUUPUVMRVTWAAXP
      UVFLMUWDXRAWPUVFUUPUVMWBABCXKXPSUUKUUCUUFUUJUUCVJWCVOVNAYAXRUVAUUNWDVMVOV
      NVMAXCYDXFYENABCXIXQNMZOXCYDABCUWFXBYGXIWPXKLMZUCZNMXIUWGWEMUWFXBYGXIUWGY
      PYGWPXKUUQUUDRWFYGXQUWHXINYGWPXKUUQUUDWBVFYGEDAEPQYFGUHZYMWGWJWHABCXIXQPY
      PUUAUULUUMWKWCAXFKXMXTNMZLMYEAXEUWJKLAXEBCXLXSNMZOUWJABCXDUWKYGEDUWIYMWLW
      HABCXLXSPUUEUUGUURUUSWKVMVFAKXMXTUVPUUHUUTVGVMVNWJAEWRWSLAEGWMWNABCXAPYGE
      DUWIYMRABCDEFGHIUQVEWJ $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y ph $.  $d x V $.
    itgabs.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgabs.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    $( The triangle inequality for integrals.  (Contributed by Mario Carneiro,
       25-Aug-2014.) $)
    itgabs $p |- ( ph -> ( abs ` S. A B _d x ) <_ S. A ( abs ` B ) _d x ) $=
      ( vy cc0 citg cabs cfv wbr cle cmul co cmpt cibl wcel cc clt wceq ccj csb
      wa cv cre cim itgcl cjcld wral cmbf iblmbf syl mbfmptcl ralrimiva nfcsb1v
      nfel1 csbeq1a eleq1d cbvral sylib r19.21bi nfcv cbvmpt syl5eqelr iblmulc2
      nfv adantr mulcld iblcn mpbid simpld cvv a1i iblabs recld abscld releabsd
      ovex itgle c2 cexp sqvald absvalsqd mulcomd cbvitg oveq2i itgmulc2 syl5eq
      recnd 3eqtrd fveq2d resqcld rered itgre 3eqtr3d eqtr3d nffv abscjd oveq1d
      cr absmuld eqtrd itgeq2dv eqtr4d 3brtr4d wb simpr lemul2 syl112anc mpbird
      itgrecl ex absge0d itgge0 breq1 syl5ibcom wo 0re leloe sylancr mpjaod ) A
      IBCDJZKLZUAMZYEBCDKLZJZNMZIYEUBZAYFYIAYFUEZYIYEYEOPZYEYHOPZNMZAYNYFAHCYDU
      CLZBHUFZDUDZOPZUGLZJZHCYRKLZJZYLYMNAHCYSUUAAHCYSQRSZHCYRUHLQRSZAHCYRQRSUU
      CUUDUEAHCYQYOTAYDABCDEFGUIZUJZAYQTSZHCADTSZBCUKUUGHCUKAUUHBCABCDEABCDQZRS
      UUIULSGUUIUMUNFUOZUPUUHUUGBHCUUHHVHBYQTBYPDUQZURBUFZYPUBZDYQTBYPDUSZUTVAV
      BVCZAHCYQQUUIRBHCDYQHDVDZUUKUUNVEGVFZVGZAHCYRAYPCSZUEZYOYQAYOTSUUSUUFVIZU
      UOVJZVKVLVMAHCYRVNYRVNSUUTYOYQOVTVOZUURVPUUTYRUVBVQUUTYRUVBVRUUTYRUVBVSWA
      AYEWBWCPZYLYTAYEAYEAYDUUEVRZWKZWDAUVDUGLHCYRJZUGLUVDYTAUVDUVGUGAUVDYDYOOP
      YOYDOPZUVGAYDUUEWEAYDYOUUEUUFWFAUVHYOHCYQJZOPUVGYDUVIYOOBHCDYQUUNUUPUUKWG
      WHAHCYQYOTUUFUUOUUQWIWJWLWMAUVDAYEUVEWNWOAHCYRVNUVCUURWPWQWRAYMYEHCYQKLZJ
      ZOPZUUBYHUVKYEOBHCYGUVJUUMDYQKUUNWMHYGVDBYQKBKVDUUKWSWGWHAUVLHCYEUVJOPZJU
      UBAHCUVJYEXBUVFUUTYQUUOVRAHCYQTUUOUUQVPWIAHCUUAUVMUUTUUAYOKLZUVJOPUVMUUTY
      OYQUVAUUOXCUUTUVNYEUVJOUUTYDAYDTSUUSUUEVIWTXAXDXEXFWJXGVIYKYEXBSZYHXBSZUV
      OYFYIYNXHAUVOYFUVEVIZAUVPYFABCYGAUULCSUEZDUUJVRZABCDEFGVPZXMVIUVQAYFXIYEY
      HYEXJXKXLXNAIYHNMYJYIABCYGUVTUVSUVRDUUJXOXPIYEYHNXQXRAIYENMZYFYJXSZAYDUUE
      XOAIXBSUVOUWAUWBXHXTUVEIYEYAYBVLYC $.
  $}

  ${
    $d k x A $.  $d k x B $.  $d k C $.  $d k x ph $.  $d k x U $.  $d x V $.
    itgsplit.i $e |- ( ph -> ( vol* ` ( A i^i B ) ) = 0 ) $.
    itgsplit.u $e |- ( ph -> U = ( A u. B ) ) $.
    itgsplit.c $e |- ( ( ph /\ x e. U ) -> C e. V ) $.
    itgsplit.a $e |- ( ph -> ( x e. A |-> C ) e. L^1 ) $.
    itgsplit.b $e |- ( ph -> ( x e. B |-> C ) e. L^1 ) $.
    $( The ` S. ` integral splits under an almost disjoint union.  (Contributed
       by Mario Carneiro, 11-Aug-2014.) $)
    itgsplit $p |- ( ph -> S. U C _d x = ( S. A C _d x + S. B C _d x ) ) $=
      ( vk cc0 co cr wcel wa cif adantr c3 cfz ci cv cexp cdiv cre cfv cle cmpt
      wbr citg2 cmul csu caddc citg cvol cdm cibl cmbf iblmbf syl cun syl5sseqr
      ssun1 sselda syldan mbfdm2 ssun2 cin covol wceq cxr cpnf cicc eleq2d elun
      cc wo syl6bb biimpa mbfmptcl jaodan adantlr ax-icn elfznn0 adantl sylancr
      cn0 expcl wne cz elfzelz ine0 expne0i mp3an12 divcld recld 0re ifcl rexrd
      sylancl max1 elxrge0 sylanbrc ifan mpteq2i iblitg sylan2 itg2split oveq2d
      eqidd recnd adddid eqtrd sumeq2dv fzfid mulcld fsumadd eqid dfitg oveq12i
      3eqtr4g ) ANUAUBOZUCMUDZUEOZBPBUDZFQZNEYFUFOZUGUHZUIUKZRYJNSZUJZULUHZUMOZ
      MUNZYDYFBPYGCQZYKRYJNSZUJZULUHZUMOZMUNZYDYFBPYGDQZYKRYJNSZUJZULUHZUMOZMUN
      ZUOOZBFEUPBCEUPZBDEUPZUOOAYPYDUUAUUGUOOZMUNUUIAYDYOUULMAYEYDQZRZYOYFYTUUF
      UOOZUMOUULUUNYNUUOYFUMUUNBCDYKYJNSZFYSUUEYMACUQURZQUUMABCEGABCEUJZUSQUURU
      TQKUURVAVBZAYQYHEGQZACFYGACDVCZCFCDVEIVDVFJVGZVHTADUUQQUUMABDEGABDEUJZUSQ
      UVCUTQLUVCVAVBZAUUCYHUUTADFYGAUVADFDCVIIVDVFJVGZVHTACDVJVKUHNVLUUMHTAFUVA
      VLUUMITUUNYHRZUUPVMQNUUPUIUKZUUPNVNVOOQUVFUUPUVFYJPQZNPQZUUPPQUVFYIUVFEYF
      AYHEVRQZUUMAYHYQUUCVSZUVJAYHUVKAYHYGUVAQUVKAFUVAYGIVPYGCDVQVTWAAYQUVJUUCA
      BCEGUUSUVBWBABDEGUVDUVEWBWCVGWDUUNYFVRQZYHUUNUCVRQZYEWIQZUVLWEUUMUVNAYEUA
      WFWGUCYEWJWHZTUUNYFNWKZYHUUNYEWLQZUVPUUMUVQAYENUAWMZWGUVMUCNWKUVQUVPWEWNU
      CYEWOWPVBTWQWRZWSYKYJNPWTXBXAUVFUVIUVHUVGWSUVSNYJXCWHUUPXDXEBPYRYQUUPNSYQ
      YKYJNXFXGBPUUDUUCUUPNSUUCYKYJNXFXGBPYLYHUUPNSYHYKYJNXFXGUUMAUVQYTPQUVRABC
      EYJYSYEGAYSXLAYQRYJXLKUVBXHZXIUUMAUVQUUFPQUVRABDEYJUUEYEGAUUEXLAUUCRYJXLL
      UVEXHXIZXJXKUUNYFYTUUFUVOUUMAUVQYTVRQUVRAUVQRYTUVTXMXIZUUNUUFUWAXMZXNXOXP
      AYDUUAUUGMANUAXQUUNYFYTUVOUWBXRUUNYFUUFUVOUWCXRXSXOBFEYJMYJXTZYAUUJUUBUUK
      UUHUOBCEYJMUWDYABDEYJMUWDYAYBYC $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x V $.  $d x ph $.
    itgspliticc.1 $e |- ( ph -> A e. RR ) $.
    itgspliticc.2 $e |- ( ph -> C e. RR ) $.
    itgspliticc.3 $e |- ( ph -> B e. ( A [,] C ) ) $.
    itgspliticc.4 $e |- ( ( ph /\ x e. ( A [,] C ) ) -> D e. V ) $.
    itgspliticc.5 $e |- ( ph -> ( x e. ( A [,] B ) |-> D ) e. L^1 ) $.
    itgspliticc.6 $e |- ( ph -> ( x e. ( B [,] C ) |-> D ) e. L^1 ) $.
    $( The ` S. ` integral splits on closed intervals with matching endpoints.
       (Contributed by Mario Carneiro, 13-Aug-2014.) $)
    itgspliticc $p |- ( ph -> S. ( A [,] C ) D _d x =
      ( S. ( A [,] B ) D _d x + S. ( B [,] C ) D _d x ) ) $=
      ( vz cicc co cle wcel wceq syl vy cin covol cfv csn cc0 wbr cif cxr rexrd
      cr w3a wb elicc2 syl2anc mpbid simp1d df-icc xrmaxle xrlemin ixxin simp2d
      cv syl22anc iftrue simp3d oveq12d iccid 3eqtrd fveq2d ovolsn cun iccsplit
      eqtrd syl3anc itgsplit ) ABCDOPZDEOPZFCEOPZGAVQVRUBZUCUDDUEZUCUDZUFAVTWAU
      CAVTCDQUGZDCUHZDEQUGZDEUHZOPZDDOPZWAACUIRDUIRZWIEUIRVTWGSACHUJADADUKRZWCW
      EADVSRZWJWCWEULZJACUKRZEUKRZWKWLUMHICEDUNUOUPZUQZUJZWQAEIUJBUANCDDEQQOBUA
      NURCDNVCZUSWRDEUTVAVDAWDDWFDOAWCWDDSAWJWCWEWOVBWCDCVETAWEWFDSAWJWCWEWOVFW
      EDEVETVGAWIWHWASWQDVHTVIVJAWJWBUFSWPDVKTVNAWMWNWKVSVQVRVLSHIJCEDVMVOKLMVP
      $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x V $.  $d x ph $.
    itgsplitioo.1 $e |- ( ph -> A e. RR ) $.
    itgsplitioo.2 $e |- ( ph -> C e. RR ) $.
    itgsplitioo.3 $e |- ( ph -> B e. ( A [,] C ) ) $.
    itgsplitioo.4 $e |- ( ( ph /\ x e. ( A (,) C ) ) -> D e. CC ) $.
    itgsplitioo.5 $e |- ( ph -> ( x e. ( A (,) B ) |-> D ) e. L^1 ) $.
    itgsplitioo.6 $e |- ( ph -> ( x e. ( B (,) C ) |-> D ) e. L^1 ) $.
    $( The ` S. ` integral splits on open intervals with matching endpoints.
       (Contributed by Mario Carneiro, 2-Sep-2014.) $)
    itgsplitioo $p |- ( ph -> S. ( A (,) C ) D _d x =
      ( S. ( A (,) B ) D _d x + S. ( B (,) C ) D _d x ) ) $=
      ( cioo co caddc wceq cr wcel cc0 c0 clt wbr citg wn cle wo cicc wb elicc2
      w3a syl2anc mpbid simp2d simp1d leloed ord cc cxr wss rexrd iooss1 sselda
      cv syldan itgcl addid2d eqcomd oveq1 itgeq1 syl iooid syl6eq itg0 eqeq12d
      oveq1d syl5ibrcom simp3d iooss2 addid1d oveq2 syl5eqr oveq2d syl5ibcom wa
      csn cun cin covol cfv indir jca adantr leidd ioodisj syl21anc incom ltnrd
      syld eliooord simpld nsyl disjsn sylibr syl5eq uneq12d un0 fveq2d ioojoin
      ovol0 3jca sylan adantlr cmpt cibl ssun1 ioossre snssd unssd cdif difeq1i
      uncom difun2 eqtri difss eqsstri ovolsn ovolssnul syl3anc syl5sseq itgss3
      a1i itgsplit simprd eqtr4d ex ecased ) ACDUAUBZDEUAUBZBCEMNZFUCZBCDMNZFUC
      ZBDEMNZFUCZONZPZAYQUDCDPZUUFAYQUUGACDUEUBZYQUUGUFADQRZUUHDEUEUBZADCEUGNRZ
      UUIUUHUUJUJZIACQREQRUUKUULUHGHCEDUIUKULZUMZACDGAUUIUUHUUJUUMUNZUOULUPAUUF
      UUGUUDSUUDONZPAUUPUUDAUUDABUUCFUQABVCZUUCRUUQYSRZFUQRZAUUCYSUUQACURRZUUHU
      UCYSUSACGUTZUUNCDEVAUKVBJVDLVEVFVGUUGYTUUDUUEUUPUUGYSUUCPYTUUDPCDEMVHBYSU
      UCFVIVJUUGUUBSUUDOUUGUUBBTFUCZSUUGUUATPUUBUVBPUUGUUADDMNZTCDDMVHDVKZVLBUU
      ATFVIVJBFVMZVLVOVNVPWRAYRUDDEPZUUFAYRUVFAUUJYRUVFUFAUUIUUHUUJUUMVQZADEUUO
      HUOULUPAUUBUUBSONZPUVFUUFAUVHUUBAUUBABUUAFUQAUUQUUARUURUUSAUUAYSUUQAEURRZ
      UUJUUAYSUSAEHUTZUVGCDEVRUKVBJVDKVEVSVGUVFUUBYTUVHUUEUVFUUAYSPUUBYTPDECMVT
      BUUAYSFVIVJUVFSUUDUUBOUVFSUVBUUDUVEUVFTUUCPUVBUUDPUVFTUVCUUCUVDDEDMVTWABT
      UUCFVIVJWAWBVNWCWRAYQYRWDZUUFAUVKWDZYTBUUADWEZWFZFUCZUUDONUUEUVLBUVNUUCFY
      SUQUVLUVNUUCWGZWHWITWHWISUVLUVPTWHUVLUVPUUAUUCWGZUVMUUCWGZWFZTUUAUVMUUCWJ
      UVLUVSTTWFTUVLUVQTUVRTUVLUUTDURRZWDZUVTUVIWDZDDUEUBUVQTPAUWAUVKAUUTUVTUVA
      ADUUOUTZWKWLAUWBUVKAUVTUVIUWCUVJWKWLUVLDAUUIUVKUUOWLZWMCDDEWNWOUVLUVRUUCU
      VMWGZTUVMUUCWPUVLDUUCRZUDUWETPUVLDDUAUBZUWFUVLDUWDWQUWFUWGYRDDEWSWTXAUUCD
      XBXCXDXETXFVLXDXGXIVLUVLUVNUUCWFZYSAUUTUVTUVIUJUVKUWHYSPAUUTUVTUVIUVAUWCU
      VJXJCDEXHXKZVGAUURUUSUVKJXLZUVLBUUAFXMXNRZBUVNFXMXNRZAUWKUVKKWLUVLUWKUWLU
      HZUUBUVOPZUVLBUUAUVNFUUAUVNUSUVLUUAUVMXOYKUVLUUAUVMQUUAQUSUVLCDXPYKUVLDQU
      WDXQZXRUVLUVNUUAXSZUVMUSZUVMQUSUVMWHWISPZUWPWHWISPUWQUVLUWPUVMUUAXSZUVMUW
      PUVMUUAWFZUUAXSUWSUVNUWTUUAUUAUVMYAXTUVMUUAYBYCUVMUUAYDYEYKUWOUVLUUIUWRUW
      DDYFVJUWPUVMYGYHUVLUUQUVNRUURUUSUVLUVNYSUUQUVLUWHUVNYSUVNUUCXOUWIYIVBUWJV
      DYJZWTULABUUCFXMXNRUVKLWLYLUVLUUBUVOUUDOUVLUWMUWNUXAYMVOYNYOYP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y z F $.  $d x y z G $.
    $( A bounded function times an integrable function is integrable.
       (Contributed by Mario Carneiro, 12-Aug-2014.) $)
    bddmulibl $p |- ( ( F e. MblFn /\ G e. L^1 /\ E. x e. RR A. y e. dom F
      ( abs ` ( F ` y ) ) <_ x ) -> ( F oF x. G ) e. L^1 ) $=
      ( vz cmbf wcel cfv cabs cle wbr cr cmul co wa cmpt cc wf a1i cc0 cibl cdm
      cv wral wrex cof cin cvol wfn mbff ad2antrr ffn syl iblmbf ad2antlr mbfdm
      eqid eqidd offval cvv ovex simpll mbfmul eqeltrrd cif citg2 ccom mbfmptcl
      absf feqmptd fveq2 fmptco ccncf fmptd ax-resscn ssid cncfss mp2an abscncf
      wss sselii cncombf syl3anc cpnf cxr abscld rexrd absge0d elxrge0 sylanbrc
      cicc wn 0xr 0le0 mpbir2an ifclda adantr c0 wceq csn cico reex simprl elin
      cxp simprbi ffvelrn syl2an elrege0 0re fconstmpt offval2 oveq2 ifsb recnd
      mul01d ifeq2d syl5eq mpteq2dv eqtrd fveq2d mbfdm2 ffvelrnda simplr iblabs
      inss2 iblss iblpos mpbid simprd simplrl wex neq0 remulcld eqeltrd iffalse
      ex iftrue adantl 3brtr4d simplbi simprr breq1d rspccva exlimdv syl5bi imp
      letrd itg2mulc eqtr3d noel eleq2 mtbiri syl6eqr eqeltri syl6eqel pm2.61d2
      itg20 mulge0d absmuld abscl absge0 jca lemul1a syl31anc eqbrtrd pm2.61dan
      cofr ralrimivw ofrfval2 mpbird itg2le mpbir2and iblabsr rexlimdvaa 3impia
      itg2lecl ) CFGZDUAGZBUCZCHZIHZAUCZJKZBCUBZUDZALUECDMUFZNZUAGZUVRUVSOZUWFU
      WIALUWJUWCLGZUWFOZOZUWHEUWEDUBZUGZEUCZCHZUWPDHZMNZPZUAUWMEUWEUWNUWQUWRMUW
      OCDUHUBZUXAUWMUWEQCRZCUWEUIUVRUXBUVSUWLCUJUKZUWEQCULUMUWMUWNQDRZDUWNUIUWM
      DFGZUXDUVSUXEUVRUWLDUNUOZDUJUMZUWNQDULUMUVRUWEUXAGUVSUWLCUPUKUWMUXEUWNUXA
      GUXFDUPUMUWOUQUWMUWPUWEGZOUWQURUWMUWPUWNGZOUWRURUSZUWMEUWOUWSUTUWSUTGUWMU
      WPUWOGZOZUWQUWRMVASZUWMUWHUWTFUXJUWMCDUVRUVSUWLVBUXFVCVDZUWMEUWOUWSIHZPZU
      AGUXPFGELUXKUXOTVEZPZVFHZLGZUWMIUWTVGZUXPFUWMEBUWOQUWSUVTIHUXOUWTIUWMEUWO
      UWSUTUXNUXMVHZUWMUWTURUWMBQLIQLIRUWMVISVJUVTUWSIVKVLUWMUWTFGUWOQUWTRIQQVM
      NZGZUYAFGUXNUWMEUWOUWSQUWTUYBUWTUQVNUYDUWMQLVMNZUYCILQVTQQVTUYEUYCVTVOQVP
      QLQVQVRVSWASUWOQUWTIWBWCVDUWMLTWDWKNZUXRRZELUXKUWCUWRIHZMNZTVEZPZVFHZLGZU
      XSUYLJKZUXTUWMELUXQUYFUXRUWMUXQUYFGUWPLGZUWMUXKUXOTUYFUXLUXOWEGTUXOJKUXOU
      YFGUXLUXOUXLUWSUYBWFZWGUXLUWSUYBWHZUXOWIWJTUYFGZUWMUXKWLZOZUYRTWEGTTJKZWM
      WNTWIWOSZWPWQZUXRUQVNZUWMUWOWRWSZUYMUWMVUEWLZUYMUWMVUFOZUYLUWCELUXKUYHTVE
      ZPZVFHZMNZLVUGLUWCWTXEZVUIUWGNZVFHUYLVUKVUGVUMUYKVFVUGVUMELUWCVUHMNZPUYKV
      UGELUWCVUHMVULVUIUTLTWDXANZLUTGZVUGXBSUWMUWKVUFUYOUWJUWKUWFXCZUKUWMVUHVUO
      GZVUFUYOUWMUXKUYHTVUOUXLUYHLGZTUYHJKZUYHVUOGUXLUWRUWMUXDUXIUWRQGZUXKUXGUX
      KUXHUXIUWPUWEUWNXDZXFUWNQUWPDXGXHZWFZUXLUWRVVCWHZUYHXIWJTVUOGZUYTVVFTLGZV
      UAXJWNTXIWOSWPZUKVULELUWCPWSVUGELUWCXKSVUGVUIURXLVUGELVUNUYJVUGVUNUXKUYIU
      WCTMNZVEUYJUXKUYHTVUNUYIVVIVUHUYHUWCMXMVUHTUWCMXMXNVUGUXKVVITUYIVUGUWCUWM
      UWCQGVUFUWMUWCVUQXOWQXPXQXRXSXTYAVUGUWCVUIUWMLVUOVUIRVUFUWMELVUHVUOVUIUWM
      VURUYOVVHWQVUIUQVNWQUWMVUJLGZVUFUWMEUWOUYHPZFGZVVJUWMVVKUAGVVLVVJOUWMEUWO
      UWRQVVCUWMEUWOUWNUWRQUWOUWNVTUWMUWEUWNYFSUWMEUWOUWSUTUXNUXMYBUWMUWNQUWPDU
      XGYCUWMDEUWNUWRPUAUWMEUWNQDUXGVJUVRUVSUWLYDVDYGYEUWMEUWOUYHVVDVVEYHYIYJWQ
      ZVUGUWKTUWCJKZUWCVUOGUWJUWKUWFVUFYKZUWMVUFVVNVUFUXKEYLUWMVVNEUWOYMUWMUXKV
      VNEUWMUXKVVNUXLTUWQIHZUWCVVGUXLXJSUXLUWQUWMUXBUXHUWQQGUXKUXCUXKUXHUXIVVBU
      UAZUWEQUWPCXGXHZWFZUWJUWKUWFUXKYKZUXLUWQVVRWHUWMUWFUXHVVPUWCJKZUXKUWJUWKU
      WFUUBVVQUWDVWABUWPUWEUVTUWPWSZUWBVVPUWCJVWBUWAUWQIUVTUWPCVKYAUUCUUDXHZUUH
      ZYQUUEUUFUUGUWCXIWJUUIUUJVUGUWCVUJVVOVVMYNYOYQVUEUYLLTWTXEZVFHZLVUEUYKVWE
      VFVUEUYKELTPVWEVUEELUYJTVUEUYSUYJTWSVUEUXKUWPWRGUWPUUKUWOWRUWPUULUUMUXKUY
      ITYPZUMXSELTXKUUNYAVWFTLUURXJUUOUUPUUQUWMUYGLUYFUYKRUXRUYKJUVHKZUYNVUDUWM
      ELUYJUYFUYKUWMUYJUYFGUYOUWMUXKUYITUYFUXLUYIWEGTUYIJKUYIUYFGUXLUYIUXLUWCUY
      HVVTVVDYNWGUXLUWCUYHVVTVVDVWDVVEUUSUYIWIWJVUBWPWQZUYKUQVNUWMVWHUXQUYJJKZE
      LUDUWMVWJELUWMUXKVWJUXLUXOUYIUXQUYJJUXLUXOVVPUYHMNZUYIJUXLUWQUWRVVRVVCUUT
      UXLVVPLGUWKVUSVUTOZVWAVWKUYIJKVVSVVTUXLVVAVWLVVCVVAVUSVUTUWRUVAUWRUVBUVCU
      MVWCVVPUWCUYHUVDUVEUVFUXKUXQUXOWSUWMUXKUXOTYRYSUXKUYJUYIWSUWMUXKUYITYRYSY
      TUYSVWJUWMUYSTTUXQUYJJVUAUYSWNSUXKUXOTYPVWGYTYSUVGUVIUWMELUXQUYJJUXRUYKUT
      UYFUYFVUPUWMXBSVUCVWIUWMUXRURUWMUYKURUVJUVKUXRUYKUVLWCUYLUXRUVQWCUWMEUWOU
      XOUYPUYQYHUVMUVNYOUVOUVP $.

    $( A bounded function is integrable.  (Contributed by Mario Carneiro,
       12-Aug-2014.) $)
    bddibl $p |- ( ( F e. MblFn /\ ( vol ` dom F ) e. RR /\
      E. x e. RR A. y e. dom F ( abs ` ( F ` y ) ) <_ x ) -> F e. L^1 ) $=
      ( vz cmbf wcel cdm cvol cfv cr cv cabs cle c1 cmul cibl 3ad2ant1 wfn syl
      cc wbr wral wrex w3a csn cxp cof co mbfdm wf mbff ffn ax-1cn a1i fnconstg
      wa eqidd wceq 1ex fvconst2 adantl ffvelrnda mulid1d offveq simp2 iblconst
      syl3anc bddmulibl syld3an2 eqeltrrd ) CEFZCGZHIJFZBKCILIAKMUABVLUBAJUCZUD
      ZCVLNUEUFZOUGUHZCPVODVLDKZCIZNOCVPCHGZVKVMVLVTFZVNCUIQZVOVLTCUJZCVLRVKVMW
      CVNCUKQZVLTCULSZVONTFZVPVLRWFVOUMUNZVLNTUOSWEVOVRVLFZUPZVSUQWHVRVPINURVOV
      LNVRUSUTVAWIVSVOVLTVRCWDVBVCVDVKVPPFZVMVNVQPFVOWAVMWFWJWBVKVMVNVEWGVLNVFV
      GABCVPVHVIVJ $.

    $( A continuous function on a closed interval is integrable.  (Contributed
       by Mario Carneiro, 12-Aug-2014.) $)
    cniccibl $p |- ( ( A e. RR /\ B e. RR /\ F e. ( ( A [,] B ) -cn-> CC ) ) ->
      F e. L^1 ) $=
      ( vy vx cr wcel cicc co cc ccncf w3a cmbf cdm cvol cfv wral wrex 3adant3
      cv cabs cle wbr cibl iccmbl simp3 cnmbf syl2anc wf wceq cncff 3syl fveq2d
      fdm iccvolcl eqeltrd cniccbdd raleqdv rexbidv mpbird bddibl syl3anc ) AFG
      ZBFGZCABHIZJKIGZLZCMGZCNZOPZFGDTCPUAPETUBUCZDVIQZEFRZCUDGVGVEONGZVFVHVCVD
      VNVFABUESVCVDVFUFZVECUGUHVGVJVEOPZFVGVIVEOVGVFVEJCUIVIVEUJVOVEJCUKVEJCUNU
      LZUMVCVDVPFGVFABUOSUPVGVMVKDVEQZEFREDABCUQVGVLVREFVGVKDVIVEVQURUSUTEDCVAV
      B $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y ph $.
    itggt0.1 $e |- ( ph -> 0 < ( vol ` A ) ) $.
    itggt0.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itggt0.3 $e |- ( ( ph /\ x e. A ) -> B e. RR+ ) $.
    $( The integral of a strictly positive function is positive.  (Contributed
       by Mario Carneiro, 30-Aug-2014.) $)
    itggt0 $p |- ( ph -> 0 < S. A B _d x ) $=
      ( vy cc0 cr cv wcel cmpt cfv clt crp syl wa wbr wceq citg2 citg cibl cmbf
      cif iblmbf mbfdm2 cpnf cico co cle rpred rpge0d elrege0 sylanbrc 0re 0le0
      wn mpbir2an a1i ifclda adantr eqid fmptd cvol cdm mblss rembl cdif eldifn
      adantl iffalse iftrue mpteq2ia syl5eqel wral rpgt0d sselda eqeltrd fvmpt2
      wss mbfss syl2anc eqtrd breqtrrd ralrimiva nfcv nffvmpt1 nfv fveq2 breq2d
      nfbr cbvral sylibr r19.21bi itg2gt0 itgposval ) AIBJBKZCLZDIUEZMZUANBCDUB
      OAHCXAABCDPABCDMZUCLXBUDLFXBUFQZGUGZEABJWTIUHUIUJZXAAWTXELZWRJLZAWSDIXEAW
      SRZDJLIDUKSDXELXHDGULZXHDGUMZDUNUOIXELZAWSURZRXKIJLIIUKSUPUQIUNUSUTVAZVBX
      AVCZVDABCJWTXEACVEVFZLCJWAXDCVGQZJXOLAVHUTAXFWSXMVBAWRJCVILZRXLWTITXQXLAW
      RJCVJVKWSDIVLQABCWTMXBUDBCWTDWSDIVMZVNXCVOWBAIHKZXANZOSZHCAIWRXANZOSZBCVP
      YAHCVPAYCBCXHIDYBOXHDGVQXHYBWTDXHXGWTPLYBWTTACJWRXPVRXHWTDPWSWTDTAXRVKZGV
      SBJWTPXAXNVTWCYDWDWEWFYAYCHBCBIXTOBIWGBOWGBJWTXSWHWLYCHWIXSWRTXTYBIOXSWRX
      AWJWKWMWNWOWPABCDXIFXJWQWE $.
  $}

  ${
    $d d u x y z A $.  $d d u y z B $.  $d d u y C $.  $d d u x y ph $.
    itgcn.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgcn.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itgcn.3 $e |- ( ph -> C e. RR+ ) $.
    $( Transfer ~ itg2cn to the full Lebesgue integral.  (Contributed by Mario
       Carneiro, 1-Sep-2014.) $)
    itgcn $p |- ( ph -> E. d e. RR+ A. u e. dom vol
      ( ( u C_ A /\ ( vol ` u ) < d ) -> S. u ( abs ` B ) _d x < C ) ) $=
      ( vy cfv cr wcel cc0 cif cmpt citg2 wa cv cvol clt wbr cabs cdm wral wrex
      wi crp wss citg cpnf cico co cle cibl cmbf iblmbf mbfmptcl abscld absge0d
      syl elrege0 sylanbrc wn 0re 0le0 mpbir2an ifclda adantr eqid fmptd mbfdm2
      mblss rembl cdif wceq eldifn adantl iffalse iftrue mpteq2ia iblabs iblpos
      mpbid simpld syl5eqel mbfss simprd itg2cn cc simprr sselda adantlr syldan
      a1i simprl iblss itgposval sseld pm4.71d ifbid ifan syl6eq mpteq2dv eqtrd
      fveq2d nfv nffvmpt1 nfcv nfif elequ1 fveq2 ifbieq12d cbvmpt cvv fvex c0ex
      eqidd ifex fvmpt2 mpan2 ifeq1d eqtri fveq2i syl6eqr breq1d biimprd imim2d
      expr com23 imp4a ralimdva reximdv mpd ) ACUAZUBMHUAUCUDZLNLUAZYQOZYSBNBUA
      ZDOZEUEMZPQZRZMZPQZRZSMZFUCUDZUIZCUBUFZUGZHUJUHYQDUKZYRTBYQUUCULZFUCUDZUI
      ZCUULUGZHUJUHALCFUUEHABNUUDPUMUNUOZUUEAUUDUUSOZUUANOZAUUBUUCPUUSAUUBTZUUC
      NOPUUCUPUDUUCUUSOUVBEABDEGABDERZUQOUVCUROJUVCUSVCZIUTZVAZUVBEUVEVBZUUCVDV
      EPUUSOZAUUBVFZTUVHPNOPPUPUDVGVHPVDVIWQVJZVKUUEVLZVMABDNUUDUUSADUULODNUKAB
      DEGUVDIVNDVOVCNUULOAVPWQAUUTUUBUVJVKAUUANDVQOZTUVIUUDPVRUVLUVIAUUANDVSVTU
      UBUUCPWAVCABDUUDRBDUUCRZURBDUUDUUCUUBUUCPWBWCAUVMUROZUUESMNOZAUVMUQOZUVNU
      VOTABDEGIJWDZABDUUCUVFUVGWEWFZWGWHWIAUVNUVOUVRWJKWKAUUMUURHUJAUUKUUQCUULA
      YQUULOZTZUUKUUNYRUUPUVTUUNUUKYRUUPUIZAUVSUUNUUKUWAUIAUVSUUNTZTZUUJUUPYRUW
      CUUPUUJUWCUUOUUIFUCUWCUUOBNUUAYQOZUUDPQZRZSMZUUIUWCUUOBNUWDUUCPQZRZSMUWGU
      WCBYQUUCUWCUWDTZEUWCUWDUUBEWLOZUWCYQDUUAAUVSUUNWMZWNAUUBUWKUWBUVEWOZWPZVA
      UWCBYQDUUCNUWLAUVSUUNWRUWCUUBTEUWMVAAUVPUWBUVQVKWSUWJEUWNVBWTUWCUWIUWFSUW
      CBNUWHUWEUWCUWHUWDUUBTZUUCPQUWEUWCUWDUWOUUCPUWCUWDUUBUWCYQDUUAUWLXAXBXCUW
      DUUBUUCPXDXEXFXHXGUUHUWFSUUHBNUWDUUAUUEMZPQZRUWFLBNUUGUWQYTBUUFPYTBXIBNUU
      DYSXJBPXKXLLUWQXKYSUUAVRZYTUWDUUFPUWPPLBCXMYSUUAUUEXNUWRPXTXOXPBNUWQUWEUV
      AUWDUWPUUDPUVAUUDXQOUWPUUDVRUUBUUCPEUEXRXSYABNUUDXQUUEUVKYBYCYDWCYEYFYGYH
      YIYJYKYLYMYNYOYP $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                    Lesbesgue directed integral
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Extend class notation with the directed integral. $)
  cdit $a class S_ [ A -> B ] C _d x $.

  $( Define the directed integral, which is just a regular integral but with a
     sign change when the limits are interchanged.  The ` A ` and ` B ` here
     are the lower and upper limits of the integral, usually written as a
     subscript and superscript next to the integral sign.  We define the region
     of integration to be an open interval instead of closed so that we can use
     ` +oo , -oo ` for limits and also integrate up to a singularity at an
     endpoint.  (Contributed by Mario Carneiro, 13-Aug-2014.) $)
  df-ditg $a |- S_ [ A -> B ] C _d x = if ( A <_ B ,
    S. ( A (,) B ) C _d x , -u S. ( B (,) A ) C _d x ) $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.
    $( Equality theorem for the directed integral.  (Contributed by Mario
       Carneiro, 13-Aug-2014.) $)
    ditgeq1 $p |- ( A = B -> S_ [ A -> C ] D _d x = S_ [ B -> C ] D _d x ) $=
      ( wceq cle wbr cioo co citg cneg cif breq1 oveq1 itgeq1 syl oveq2 df-ditg
      cdit negeqd ifbieq12d 3eqtr4g ) BCFZBDGHZABDIJZEKZADBIJZEKZLZMCDGHZACDIJZ
      EKZADCIJZEKZLZMABDETACDETUDUEUKUGUJUMUPBCDGNUDUFULFUGUMFBCDIOAUFULEPQUDUI
      UOUDUHUNFUIUOFBCDIRAUHUNEPQUAUBABDESACDESUC $.

    $( Equality theorem for the directed integral.  (Contributed by Mario
       Carneiro, 13-Aug-2014.) $)
    ditgeq2 $p |- ( A = B -> S_ [ C -> A ] D _d x = S_ [ C -> B ] D _d x ) $=
      ( wceq cle wbr cioo co citg cneg cif breq2 oveq2 itgeq1 syl oveq1 df-ditg
      cdit negeqd ifbieq12d 3eqtr4g ) BCFZDBGHZADBIJZEKZABDIJZEKZLZMDCGHZADCIJZ
      EKZACDIJZEKZLZMADBETADCETUDUEUKUGUJUMUPBCDGNUDUFULFUGUMFBCDIOAUFULEPQUDUI
      UOUDUHUNFUIUOFBCDIRAUHUNEPQUAUBADBESADCESUC $.

    $( Equality theorem for the directed integral.  (The domain of the equality
       here is very rough; for more precise bounds one should decompose it with
       ~ ditgpos first and use the equality theorems for ~ df-itg .)
       (Contributed by Mario Carneiro, 13-Aug-2014.) $)
    ditgeq3 $p |- ( A. x e. RR D = E ->
      S_ [ A -> B ] D _d x = S_ [ A -> B ] E _d x ) $=
      ( wceq cr wral cioo co citg cneg cif cdit wss ioossre ssralv ax-mp itgeq2
      wi cle wbr syl negeqd ifeq12d df-ditg 3eqtr4g ) DEFZAGHZBCUAUBZABCIJZDKZA
      CBIJZDKZLZMUJAUKEKZAUMEKZLZMABCDNABCENUIUJULUPUOURUIUHAUKHZULUPFUKGOUIUST
      BCPUHAUKGQRAUKDESUCUIUNUQUIUHAUMHZUNUQFUMGOUIUTTCBPUHAUMGQRAUMDESUCUDUEAB
      CDUFABCEUFUG $.

    ditgeq3dv.1 $e |- ( ( ph /\ x e. RR ) -> D = E ) $.
    $( Equality theorem for the directed integral.  (Contributed by Mario
       Carneiro, 13-Aug-2014.) $)
    ditgeq3dv $p |- ( ph -> S_ [ A -> B ] D _d x = S_ [ A -> B ] E _d x ) $=
      ( wceq cr wral cdit ralrimiva ditgeq3 syl ) AEFHZBIJBCDEKBCDFKHAOBIGLBCDE
      FMN $.
  $}

  $( A directed integral is a set.  (Contributed by Mario Carneiro,
     7-Sep-2014.) $)
  ditgex $p |- S_ [ A -> B ] C _d x e. _V $=
    ( cdit cle wbr cioo co citg cneg cif cvv df-ditg itgex negex ifex eqeltri )
    ABCDEBCFGZABCHIZDJZACBHIDJZKZLMABCDNSUAUCATDOUBPQR $.

  ${
    $d x A $.
    $( Value of the directed integral from a point to itself.  (Contributed by
       Mario Carneiro, 13-Aug-2014.) $)
    ditg0 $p |- S_ [ A -> A ] B _d x = 0 $=
      ( cdit cle wbr cioo co citg cneg cif cc0 df-ditg wceq c0 iooid ax-mp itg0
      itgeq1 eqtri negeqi neg0 ifeq12 mp2an ifid ) ABBCDBBEFZABBGHZCIZUHJZKZLAB
      BCMUJUFLLKZLUHLNUILNUJUKNUHAOCIZLUGONUHULNBPAUGOCSQACRTZUILJLUHLUMUAUBTUF
      UHLUILUCUDUFLUETT $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d z C $.  $d z D $.
    cbvditg.1 $e |- ( x = y -> C = D ) $.
    ${
      cbvditg.2 $e |- F/_ y C $.
      cbvditg.3 $e |- F/_ x D $.
      $( Change bound variable in a directed integral.  (Contributed by Mario
         Carneiro, 7-Sep-2014.) $)
      cbvditg $p |- S_ [ A -> B ] C _d x = S_ [ A -> B ] D _d y $=
        ( cle wbr cioo co citg cneg cif cdit biid cbvitg df-ditg negeqi 3eqtr4i
        ifbieq12i ) CDJKZACDLMZENZADCLMZENZOZPUDBUEFNZBUGFNZOZPACDEQBCDFQUDUDUF
        UIUJULUDRABUEEFGHISUHUKABUGEFGHISUAUCACDETBCDFTUB $.
    $}

    $d y C $.  $d x D $.
    $( Change bound variable in a directed integral.  (Contributed by Mario
       Carneiro, 7-Sep-2014.) $)
    cbvditgv $p |- S_ [ A -> B ] C _d x = S_ [ A -> B ] D _d y $=
      ( nfcv cbvditg ) ABCDEFGBEHAFHI $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    ditgpos.1 $e |- ( ph -> A <_ B ) $.
    $( Value of the directed integral in the forward direction.  (Contributed
       by Mario Carneiro, 13-Aug-2014.) $)
    ditgpos $p |- ( ph -> S_ [ A -> B ] C _d x = S. ( A (,) B ) C _d x ) $=
      ( cdit cle wbr cioo co citg cneg cif df-ditg wceq iftrue syl syl5eq ) ABC
      DEGCDHIZBCDJKELZBDCJKELMZNZUABCDEOATUCUAPFTUAUBQRS $.

    ditgneg.2 $e |- ( ph -> A e. RR ) $.
    ditgneg.3 $e |- ( ph -> B e. RR ) $.
    $( Value of the directed integral in the backward direction.  (Contributed
       by Mario Carneiro, 13-Aug-2014.) $)
    ditgneg $p |- ( ph -> S_ [ B -> A ] C _d x = -u S. ( A (,) B ) C _d x ) $=
      ( cle wbr cdit cioo co citg cneg wceq wa cc0 c0 syl6eq letri3d ditg0 neg0
      biantrurd bitr4d eqtr4i ditgeq2 oveq1 iooid itgeq1 syl itg0 negeqd syl6bi
      3eqtr4a wn cif df-ditg iffalse syl5eq pm2.61d1 ) ADCIJZBDCEKZBCDLMZENZOZP
      ZAVBCDPZVGAVBCDIJZVBQVHAVIVBFUDACDGHUAUEVHBDDEKZROZVCVFVJRVKBDEUBUCUFBCDD
      EUGVHVERVHVEBSENZRVHVDSPVEVLPVHVDDDLMSCDDLUHDUITBVDSEUJUKBEULTUMUOUNVBUPV
      CVBBDCLMENZVFUQVFBDCEURVBVMVFUSUTVA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.  $d x V $.  $d x X $.  $d x Y $.
    ditgcl.x $e |- ( ph -> X e. RR ) $.
    ditgcl.y $e |- ( ph -> Y e. RR ) $.
    ditgcl.a $e |- ( ph -> A e. ( X [,] Y ) ) $.
    ditgcl.b $e |- ( ph -> B e. ( X [,] Y ) ) $.
    ditgcl.c $e |- ( ( ph /\ x e. ( X (,) Y ) ) -> C e. V ) $.
    ditgcl.i $e |- ( ph -> ( x e. ( X (,) Y ) |-> C ) e. L^1 ) $.
    $( Closure of a directed integral.  (Contributed by Mario Carneiro,
       13-Aug-2014.) $)
    ditgcl $p |- ( ph -> S_ [ A -> B ] C _d x e. CC ) $=
      ( cc wcel cle wbr co syl2anc cdit cr cicc w3a wb elicc2 mpbid simp1d cioo
      wa citg simpr ditgpos cv cxr wss rexrd simp2d iooss1 simp3d iooss2 sselda
      sstrd syldan cvol cdm ioombl a1i iblss adantr eqeltrd cneg ditgneg negcld
      itgcl lecasei ) ABCDEUAZOPCDACUBPZGCQRZCHQRZACGHUCSZPZVRVSVTUDZKAGUBPZHUB
      PZWBWCUEIJGHCUFTUGZUHZADUBPZGDQRZDHQRZADWAPZWHWIWJUDZLAWDWEWKWLUEIJGHDUFT
      UGZUHZACDQRZUJZVQBCDUISZEUKZOWPBCDEAWOULUMAWROPWOABWQEFABUNZWQPWSGHUISZPZ
      EFPZAWQWTWSAWQGDUISZWTAGUOPZVSWQXCUPAGIUQZAVRVSVTWFURGCDUSTAHUOPZWJXCWTUP
      AHJUQZAWHWIWJWMUTGDHVATVCZVBMVDABWQWTEFXHWQVEVFZPACDVGVHMNVIVOVJVKADCQRZU
      JZVQBDCUISZEUKZVLZOXKBDCEAXJULAWHXJWNVJAVRXJWGVJVMAXNOPXJAXMABXLEFAWSXLPX
      AXBAXLWTWSAXLGCUISZWTAXDWIXLXOUPXEAWHWIWJWMURGDCUSTAXFVTXOWTUPXGAVRVSVTWF
      UTGCHVATVCZVBMVDABXLWTEFXPXLXIPADCVGVHMNVIVOVNVJVKVP $.

    $( Reverse a directed integral.  (Contributed by Mario Carneiro,
       13-Aug-2014.) $)
    ditgswap $p |- ( ph -> S_ [ B -> A ] C _d x = -u S_ [ A -> B ] C _d x ) $=
      ( cneg wcel cle wbr co adantr cdit wceq cr cicc w3a elicc2 syl2anc simp1d
      wb mpbid wa cioo citg simpr ditgneg ditgpos negeqd eqtr4d cc cv cxr rexrd
      wss simp2d iooss1 simp3d iooss2 sselda cmpt cibl cmbf iblmbf syl mbfmptcl
      sstrd syldan cvol cdm ioombl a1i iblss itgcl negnegd 3eqtr4rd lecasei ) A
      BDCEUAZBCDEUAZOZUBCDACUCPZGCQRZCHQRZACGHUDSZPZWIWJWKUEZKAGUCPZHUCPZWMWNUI
      IJGHCUFUGUJZUHZADUCPZGDQRZDHQRZADWLPZWSWTXAUEZLAWOWPXBXCUIIJGHDUFUGUJZUHZ
      ACDQRZUKZWFBCDULSEUMZOWHXGBCDEAXFUNZAWIXFWRTAWSXFXETUOXGWGXHXGBCDEXIUPUQU
      RADCQRZUKZBDCULSZEUMZOZOXMWHWFXKXMAXMUSPXJABXLEUSABUTZXLPXOGHULSZPEUSPAXL
      XPXOAXLGCULSZXPAGVAPWTXLXQVCAGIVBAWSWTXAXDVDGDCVEUGAHVAPWKXQXPVCAHJVBAWIW
      JWKWQVFGCHVGUGVOZVHABXPEFABXPEVIZVJPXSVKPNXSVLVMMVNVPABXLXPEFXRXLVQVRPADC
      VSVTMNWAWBTWCXKWGXNXKBDCEAXJUNZAWSXJXETAWIXJWRTUOUQXKBDCEXTUPWDWE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.  $d x ps $.  $d x th $.
    $d x V $.  $d x X $.  $d x Y $.
    ditgsplit.x $e |- ( ph -> X e. RR ) $.
    ditgsplit.y $e |- ( ph -> Y e. RR ) $.
    ditgsplit.a $e |- ( ph -> A e. ( X [,] Y ) ) $.
    ditgsplit.b $e |- ( ph -> B e. ( X [,] Y ) ) $.
    ditgsplit.c $e |- ( ph -> C e. ( X [,] Y ) ) $.
    ditgsplit.d $e |- ( ( ph /\ x e. ( X (,) Y ) ) -> D e. V ) $.
    ditgsplit.i $e |- ( ph -> ( x e. ( X (,) Y ) |-> D ) e. L^1 ) $.
    ${
      ditgsplit.1 $e |- ( ( ps /\ th ) <-> ( A <_ B /\ B <_ C ) ) $.
      $( Lemma for ~ ditgsplit .  (Contributed by Mario Carneiro,
         13-Aug-2014.) $)
      ditgsplitlem $p |- ( ( ( ph /\ ps ) /\ th ) -> S_ [ A -> C ] D _d x =
        ( S_ [ A -> B ] D _d x + S_ [ B -> C ] D _d x ) ) $=
        ( wcel cdit caddc co wceq wa cioo citg cr cle wbr w3a wb elicc2 syl2anc
        cicc mpbid simp1d adantr simpr sylib simpld simprd mpbir3and cv cxr wss
        cc rexrd simp2d iooss1 simp3d iooss2 sstrd sselda cmpt cibl cmbf iblmbf
        syl mbfmptcl syldan adantlr cvol cdm ioombl a1i iblss itgsplitioo letrd
        ditgpos oveq12d 3eqtr4d anassrs ) ABCDEGHUAZDEFHUAZDFGHUAZUBUCZUDABCUEZ
        UEZDEGUFUCZHUGDEFUFUCZHUGZDFGUFUCZHUGZUBUCWNWQWSDEFGHAEUHTZWRAXEJEUIUJZ
        EKUIUJZAEJKUOUCZTZXEXFXGUKZNAJUHTZKUHTZXIXJULLMJKEUMUNUPZUQZURZAGUHTZWR
        AXPJGUIUJZGKUIUJZAGXHTZXPXQXRUKZPAXKXLXSXTULLMJKGUMUNUPZUQZURZWSFEGUOUC
        TZFUHTZEFUIUJZFGUIUJZAYEWRAYEJFUIUJZFKUIUJZAFXHTZYEYHYIUKZOAXKXLYJYKULL
        MJKFUMUNUPZUQURZWSYFYGWSWRYFYGUEAWRUSSUTZVAZWSYFYGYNVBZAYDYEYFYGUKULZWR
        AXEXPYQXNYBEGFUMUNURVCADVDZWTTZHVGTZWRAYSYRJKUFUCZTYTAWTUUAYRAWTJGUFUCZ
        UUAAJVETZXFWTUUBVFAJLVHZAXEXFXGXMVIZJEGVJUNAKVETZXRUUBUUAVFAKMVHZAXPXQX
        RYAVKJGKVLUNZVMVNADUUAHIADUUAHVOZVPTUUIVQTRUUIVRVSQVTWAWBADXAHVOVPTWRAD
        XAUUAHIAXAJFUFUCZUUAAUUCXFXAUUJVFUUDUUEJEFVJUNAUUFYIUUJUUAVFUUGAYEYHYIY
        LVKJFKVLUNVMXAWCWDZTAEFWEWFQRWGURADXCHVOVPTWRADXCUUAHIAXCUUBUUAAUUCYHXC
        UUBVFUUDAYEYHYIYLVIJFGVJUNUUHVMXCUUKTAFGWEWFQRWGURWHWSDEGHWSEFGXOYMYCYO
        YPWIWJWSWOXBWPXDUBWSDEFHYOWJWSDFGHYPWJWKWLWM $.
    $}

    $( This theorem is the raison d'&ecirc;tre for the directed integral,
       because unlike ~ itgspliticc , there is no constraint on the ordering of
       the points ` A , B , C ` in the domain.  (Contributed by Mario Carneiro,
       13-Aug-2014.) $)
    ditgsplit $p |- ( ph -> S_ [ A -> C ] D _d x =
      ( S_ [ A -> B ] D _d x + S_ [ B -> C ] D _d x ) ) $=
      ( caddc co wa cc0 cdit wceq cr wcel cle wbr cicc w3a elicc2 syl2anc mpbid
      wb simp1d adantr ad2antrr biid ditgsplitlem adantlr oveq1d ditgcl addassd
      ditgswap oveq2d negidd eqtrd addid1d 3eqtrd eqtr2d adantllr lecasei ancom
      cneg addid2d 3eqtr3d eqtr3d ) ABCEFUAZBCDFUAZBDEFUAZQRZUBZCDACUCUDZHCUEUF
      ZCIUEUFZACHIUGRZUDZWAWBWCUHZLAHUCUDZIUCUDZWEWFULJKHICUIUJUKUMZADUCUDZHDUE
      UFZDIUEUFZADWDUDZWJWKWLUHZMAWGWHWMWNULJKHIDUIUJUKUMZACDUEUFZSZVTCEAWAWPWI
      UNAEUCUDZWPAWRHEUEUFZEIUEUFZAEWDUDZWRWSWTUHZNAWGWHXAXBULJKHIEUIUJUKUMZUNW
      QCEUEUFZSVTDEAWJWPXDWOUOAWRWPXDXCUOWQDEUEUFZVTXDAWPXEBCDEFGHIJKLMNOPWPXES
      UPUQURAXDEDUEUFZVTWPAXDSXFSZVSVPBEDFUAZQRZVRQRZVPXGVQXIVRQAXDXFBCEDFGHIJK
      LNMOPXDXFSUPUQUSAXJVPUBZXDXFAXJVPXHVRQRZQRVPTQRVPAVPXHVRABCEFGHIJKLNOPUTZ
      ABEDFGHIJKNMOPUTZABDEFGHIJKMNOPUTZVAAXLTVPQAXLXHXHVLZQRTAVRXPXHQABEDFGHIJ
      KNMOPVBVCAXHXNVDVEVCAVPXMVFVGZUOVHVIVJWQECUEUFZSZXJVPVSAXKWPXRXQUOXSXIVQV
      RQXSXIVPBECFUAZVQQRZQRZVQXSXHYAVPQAWPXRBECDFGHIJKNLMOPWPXRVKUQVCAYBVQUBZW
      PXRAVPXTQRZVQQRTVQQRYBVQAYDTVQQAYDVPVPVLZQRTAXTYEVPQABCEFGHIJKLNOPVBVCAVP
      XMVDVEUSAVPXTVQXMABECFGHIJKNLOPUTZABCDFGHIJKLMOPUTZVAAVQYGVMVNZUOVEUSVOVJ
      ADCUEUFZSZVTCEAWAYIWIUNAWRYIXCUNYJXDSZVSVQBDCFUAZVPQRZQRZVPYKVRYMVQQAYIXD
      BDCEFGHIJKMLNOPYIXDSUPUQVCAYNVPUBZYIXDAVQYLQRZVPQRTVPQRYNVPAYPTVPQAYPVQVQ
      VLZQRTAYLYQVQQABCDFGHIJKLMOPVBVCAVQYGVDVEUSAVQYLVPYGABDCFGHIJKMLOPUTZXMVA
      AVPXMVMVNZUOVHYJXRSVTDEAWJYIXRWOUOAWRYIXRXCUOAXRXEVTYIAXRSXESZVSYNVPYTVRY
      MVQQYTYMVRXTQRZVPQRZVRYTYLUUAVPQAXRXEBDECFGHIJKMNLOPXRXEVKUQUSAUUBVRUBXRX
      EAUUBVRXTVPQRZQRVRTQRVRAVRXTVPXOYFXMVAAUUCTVRQAUUCXTXTVLZQRTAVPUUDXTQABEC
      FGHIJKNLOPVBVCAXTYFVDVEVCAVRXOVFVGUOVHVCAYOXRXEYSUOVHVIYJXFVTXRYJXFSZVSXJ
      VPUUEVQXIVRQUUEXIYBVQUUEXHYAVPQUUEYAXHYLQRZVQQRZXHUUEXTUUFVQQAYIXFBEDCFGH
      IJKNMLOPYIXFVKUQUSAUUGXHUBYIXFAUUGXHYLVQQRZQRXHTQRXHAXHYLVQXNYRYGVAAUUHTX
      HQAUUHYLYLVLZQRTAVQUUIYLQABDCFGHIJKMLOPVBVCAYLYRVDVEVCAXHXNVFVGUOVHVCAYCY
      IXFYHUOVHUSAXKYIXFXQUOVHURVJVJVJ $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Derivatives
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Real and complex differentiation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
         Derivatives of functions of one complex or real variable
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Introduce new constant symbols. $)
  $c limCC $. $( Limit operator $)
  $c _D $. $( Derivative operator $)
  $c Dn $. $( n-th derivative operator $)
  $c C^n $. $( Continuously differentiable function $)

  $( The limit operator. $)
  climc $a class limCC $.

  $( The derivative operator. $)
  cdv $a class _D $.

  $( The ` n ` -th derivative operator. $)
  cdvn $a class Dn $.

  $( The set of ` n ` -times continuously differentiable functions. $)
  ccpn $a class C^n $.

  ${
    $d f j s x y z $.
    $( Define the set of limits of a complex function at a point.  Under normal
       circumstances, this will be a singleton or empty, depending on whether
       the limit exists.  (Contributed by Mario Carneiro, 24-Dec-2016.) $)
    df-limc $a |- limCC = ( f e. ( CC ^pm CC ) , x e. CC |->
      { y | [. ( TopOpen ` CCfld ) / j ]. ( z e. ( dom f u. { x } ) |->
      if ( z = x , y , ( f ` z ) ) ) e.
        ( ( ( j |`t ( dom f u. { x } ) ) CnP j ) ` x ) } ) $.

    $( Define the derivative operator on functions on the reals.  This acts on
       functions to produce a function that is defined where the original
       function is differentiable, with value the derivative of the function at
       these points.  The set ` s ` here is the ambient topological space under
       which we are evaluating the continuity of the difference quotient.
       Although the definition is valid for any subset of ` CC ` and is
       well-behaved when ` s ` contains no isolated points, we will restrict
       our attention to the cases ` s = RR ` or ` s = CC ` for the majority of
       the development, these corresponding respectively to real and complex
       differentiation.  (Contributed by Mario Carneiro, 7-Aug-2014.) $)
    df-dv $a |- _D = ( s e. ~P CC , f e. ( CC ^pm s ) |->
      U_ x e. ( ( int ` ( ( TopOpen ` CCfld ) |`t s ) ) ` dom f )
        ( { x } X. ( ( z e. ( dom f \ { x } ) |->
          ( ( ( f ` z ) - ( f ` x ) ) / ( z - x ) ) ) limCC x ) ) ) $.

    $( Define the ` n ` -th derivative operator on functions on the complexes.
       This just iterates the derivative operation according to the last
       argument.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    df-dvn $a |- Dn = ( s e. ~P CC , f e. ( CC ^pm s ) |->
      seq 0 ( ( ( x e. _V |-> ( s _D x ) ) o. 1st ) , ( NN0 X. { f } ) ) ) $.

    $( Define the set of ` n ` -times continuously differentiable functions.
       (Contributed by Stefan O'Rear, 15-Nov-2014.) $)
    df-cpn $a |- C^n = ( s e. ~P CC |-> ( x e. NN0 |-> { f e. ( CC ^pm s ) |
                         ( ( s Dn f ) ` x ) e. ( dom f -cn-> CC ) } ) ) $.

    $( The derivative function is a relation.  (Contributed by Mario Carneiro,
       7-Aug-2014.)  (Revised by Mario Carneiro, 24-Dec-2016.) $)
    reldv $p |- Rel ( S _D F ) $=
      ( vx vf vs vz cdv co wrel cvv cxp wss cv cfv cmin wral rgenw mpbir df-rel
      cc cdm ccnfld ctopn crest cnt csn cdif cdiv cmpt climc ciun cpm cpw relxp
      reliun mpbi df-dv ovmptss ax-mp ) ABGHZIUTJJKZLZCDMZUAZUBUCNEMZUDHUENNZCM
      ZUFZFVDVHUGFMZVCNVGVCNOHVIVGOHUHHUIVGUJHZKZUKZVALZDTVEULHZPZETUMZPVBVOEVP
      VMDVNVLIZVMVQVKIZCVFPVRCVFVHVJUNQCVFVKUORVLSUPQQEDVPVNVLAGBVACFDEUQURUSUT
      SR $.
  $}

  ${
    $d f j x y z A $.  $d f j x y z B $.  $d f j x y z F $.  $d f j x y z K $.
    $d y z C $.  $d y G $.  $d f j x y J $.
    limcval.j $e |- J = ( K |`t ( A u. { B } ) ) $.
    limcval.k $e |- K = ( TopOpen ` CCfld ) $.
    ${
      limcvallem.g $e |- G =
        ( z e. ( A u. { B } ) |-> if ( z = B , C , ( F ` z ) ) ) $.
      $( Lemma for ~ ellimc .  (Contributed by Mario Carneiro, 25-Dec-2016.) $)
      limcvallem $p |- ( ( F : A --> CC /\ A C_ CC /\ B e. CC ) ->
        ( G e. ( ( J CnP K ) ` B ) -> C e. CC ) ) $=
        ( cc wf wss wcel w3a ccnp co cfv ctopon wa csn cun cv wceq cif ssun2 wb
        simpl3 snssg syl mpbiri crest cnfldtopon simpl2 snssd resttopon sylancr
        wral unssd syl5eqel simpr cnpf2 syl3anc fmpt sylibr iftrue eleq1d rspcv
        a1i sylc ex ) BLEMZBLNZCLOZPZFCGHQRSOZDLOZVPVQUAZCBCUBZUCZOZAUDZCUEZDWC
        ESZUFZLOZAWAUSZVRVSWBVTWANZVTBUGVSVOWBWIUHVMVNVOVQUIZCWALUJUKULVSWALFMZ
        WHVSGWATSZOHLTSOZVQWKVSGHWAUMRZWLIVSWMWALNWNWLOHJUNZVSBVTLVMVNVOVQUOVSC
        LWJUPUTWAHLUQURVAWMVSWOVJVPVQVBCFGHWALVCVDAWALWFFKVEVFWGVRACWAWDWFDLWDD
        WEVGVHVIVKVL $.
    $}

    $( Value and set bounds on the limit operator.  (Contributed by Mario
       Carneiro, 25-Dec-2016.) $)
    limcfval $p |- ( ( F : A --> CC /\ A C_ CC /\ B e. CC ) ->
      ( ( F limCC B ) = { y |
        ( z e. ( A u. { B } ) |-> if ( z = B , y , ( F ` z ) ) ) e.
        ( ( J CnP K ) ` B ) } /\ ( F limCC B ) C_ CC ) ) $=
      ( vf vx vj cc wcel co cv wceq cfv cvv wa wf wss w3a csn cun cif cmpt ccnp
      climc cab cpm cdm crest ccnfld ctopn wsbc cmpt2 df-limc a1i simplrl dmeqd
      fvex simpll1 fdm syl eqtrd simplrr sneqd eqeq2d fveq1d ifbieq2d mpteq12dv
      uneq12d syl6eqr oveq12d fveq12d eleq12d sbcied abbidv cnex elpm2r mpanl12
      simpr 3adant3 simp3 eqid limcvallem abssdv ssex ovmpt2d eqsstrd jca ) CME
      UAZCMUBZDMNZUCZEDUIOZBCDUDZUEZBPZDQZAPZWTERZUFZUGZDFGUHOZRZNZAUJZQWQMUBWP
      JKEDMMUKOZMBJPZULZKPZUDZUEZWTXMQZXBWTXKRZUFZUGZXMLPZXOUMOZXTUHOZRZNZLUNUO
      RZUPZAUJZXIUISUIJKXJMYGUQQWPKABJLURUSWPXKEQZXMDQZTZTZYFXHAYKYDXHLYESYESNY
      KUNUOVBUSYKXTYEQZTZXSXEYCXGYMBXOXRWSXDYMXLCXNWRYMXLEULZCYMXKEWPYHYIYLUTZV
      AYMWMYNCQWMWNWOYJYLVCCMEVDVEVFYMXMDWPYHYIYLVGZVHVMZYMXPXAXQXCXBYMXMDWTYPV
      IYMWTXKEYOVJVKVLYMXMDYBXFYMYAFXTGUHYMYAGWSUMOFYMXTGXOWSUMYMXTYEGYKYLWCIVN
      ZYQVOHVNYRVOYPVPVQVRVSWMWNEXJNZWOMSNZYTWMWNTYSVTVTMMCESSWAWBWDWMWNWOWEWPX
      IMUBXISNWPXHAMBCDXBEXEFGHIXEWFWGWHZXIMVTWIVEWJZWPWQXIMUUBUUAWKWL $.

    ellimc.g $e |- G =
        ( z e. ( A u. { B } ) |-> if ( z = B , C , ( F ` z ) ) ) $.
    ellimc.f $e |- ( ph -> F : A --> CC ) $.
    ellimc.a $e |- ( ph -> A C_ CC ) $.
    ellimc.b $e |- ( ph -> B e. CC ) $.
    $( Value of the limit predicate. ` C ` is the limit of the function ` F `
       at ` B ` if the function ` G ` , formed by adding ` B ` to the domain of
       ` F ` and setting it to ` C ` , is continuous at ` B ` .  (Contributed
       by Mario Carneiro, 25-Dec-2016.) $)
    ellimc $p |- ( ph ->
      ( C e. ( F limCC B ) <-> G e. ( ( J CnP K ) ` B ) ) ) $=
      ( vy co wcel wceq cc climc csn cun cv cfv cif cmpt cab wss wf wa limcfval
      ccnp syl3anc simpld eleq2d wi wb limcvallem ifeq1 mpteq2dv syl6eqr eleq1d
      elab3g syl bitrd ) AEFDUAQZREBCDUBUCZBUDZDSZPUDZVIFUEZUFZUGZDHIUMQUEZRZPU
      HZRZGVORZAVGVQEAVGVQSZVGTUIZACTFUJZCTUIZDTRZVTWAUKMNOPBCDFHIJKULUNUOUPAVS
      ETRUQZVRVSURAWBWCWDWEMNOBCDEFGHIJKLUSUNVPVSPETVKESZVNGVOWFVNBVHVJEVLUFZUG
      GWFBVHVMWGVJVKEVLUTVALVBVCVDVEVF $.
  $}

  ${
    $d f j x y z $.  $d u v w x z A $.  $d u v w x y z B $.  $d u v w x z ph $.
    $d u v w z C $.  $d u v w x y z F $.  $d u v w z K $.
    $( Reverse closure for the limit operator.  (Contributed by Mario Carneiro,
       28-Dec-2016.) $)
    limcrcl $p |- ( C e. ( F limCC B ) ->
      ( F : dom F --> CC /\ dom F C_ CC /\ B e. CC ) ) $=
      ( vf vx vz vy vj climc co wcel cc cpm wa cdm wf wss cv cfv cnex w3a crest
      csn cun weq cif cmpt ccnp ccnfld ctopn wsbc df-limc elmpt2cl elpm2 anbi1i
      cab df-3an bitr4i sylib ) BCAIJKCLLMJZKZALKZNZCOZLCPZVDLQZVBUAZDEUTLFDRZO
      ERZUCUDZFEUEGRFRVHSUFUGVIHRZVJUBJVKUHJSKHUIUJSUKGUPCAIBEGFDHULUMVCVEVFNZV
      BNVGVAVLVBLLCTTUNUOVEVFVBUQURUS $.

    $( Closure of the limit operator.  (Contributed by Mario Carneiro,
       25-Dec-2016.) $)
    limccl $p |- ( F limCC B ) C_ CC $=
      ( vx vz vy climc co cc wcel cdm csn cun wceq cfv cif cmpt ccnfld wss eqid
      cv ctopn crest ccnp cab wf w3a wa limcrcl limcfval simprd id sseldd ssriv
      syl ) CBAFGZHCTZUOIZUOHUPUQUODBJZAKLZDTZAMETUTBNOPAQUANZUSUBGZVAUCGNIEUDM
      ZUOHRZUQURHBUEURHRAHIUFVCVDUGAUPBUHEDURABVBVAVBSVASUIUNUJUQUKULUM $.

    limccl.f $e |- ( ph -> F : A --> CC ) $.
    $( It suffices to consider functions which are not defined at ` B ` to
       define the limit of a function.  In particular, the value of the
       original function ` F ` at ` B ` does not affect the limit of ` F ` .
       (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    limcdif $p |- ( ph ->
      ( F limCC B ) = ( ( F |` ( A \ { B } ) ) limCC B ) ) $=
      ( vx vz co cc wss wcel wa wceq wf adantr ex cfv cmpt eqid sylbi climc csn
      cdif cres cv cdm fdm syl w3a limcrcl adantl simp2d eqsstr3d simp3d undif1
      jca cun difss fssres sylancl snssd unssd syl5eqssr unssad wb ccnfld ctopn
      cif crest ccnp simprl simprr ellimc eqcomi oveq2i mpteq12i wo elun orbi2i
      elsn pm5.61 fvres ifeq2da mpteq2ia eqtr4i ssdifssd bitr4d pm5.21ndd eqrdv
      wn ) AFDCUAHZDBCUBZUCZUDZCUAHZABIJZCIKZLZFUEZWKKZWSWOKZAWTWRAWTLZWPWQXBBD
      UFZIAXCBMZWTABIDNZXDEBIDUGUHOXBXCIDNZXCIJZWQWTXFXGWQUIACWSDUJUKZULUMXBXFX
      GWQXHUNUPPAXAWRAXALZWPWQXIBWLIXIBWLUQZWMWLUQZIBWLUOZXIWMWLIXIWMWNUFZIAXMW
      MMZXAAWMIWNNZXNAXEWMBJXOEBWLURBIWMDUSUTZWMIWNUGUHOXIXMIWNNZXMIJZWQXAXQXRW
      QUIACWSWNUJUKZULUMXICIXIXQXRWQXSUNZVAVBVCVDXTUPPAWRWTXAVEAWRLZWTGXJGUEZCM
      ZWSYBDQZVHZRZCVFVGQZXJVIHZYGVJHQKXAYAGBCWSDYFYHYGYHSYGSZYFSAXEWREOAWPWQVK
      ZAWPWQVLZVMYAGWMCWSWNYFYHYGXJXKYGVIXKXJXLVNZVOYIYFGXKYERGXKYCWSYBWNQZVHZR
      GXJYEXKYEYLYESVPGXKYNYEYBXKKYBWMKZYBWLKZVQZYNYEMZYBWMWLVRYQYOYCVQZYRYPYCY
      OGCVTVSYSYCYMYDWSYSYCWJZLYOYTLYMYDMZYOYCWAYOUUAYTYBWMDWBOTWCTTWDWEAXOWRXP
      OYABIWLYJWFYKVMWGPWHWI $.

    limccl.a $e |- ( ph -> A C_ CC ) $.
    limccl.b $e |- ( ph -> B e. CC ) $.
    ellimc2.k $e |- K = ( TopOpen ` CCfld ) $.
    $( Write the definition of a limit directly in terms of open sets of the
       topology on the complexes.  (Contributed by Mario Carneiro,
       25-Dec-2016.) $)
    ellimc2 $p |- ( ph -> ( C e. ( F limCC B ) <-> ( C e. CC /\
      A. u e. K ( C e. u -> E. w e. K ( B e. w /\
        ( F " ( w i^i ( A \ { B } ) ) ) C_ u ) ) ) ) ) $=
      ( vz wcel cc wa wss wral wb syl vv climc co csn cdif cin cima wrex limccl
      cv wi sseli pm4.71ri cun wceq cfv cif cmpt ccnp eqid ellimc adantr ctopon
      crest wf cnfldtopon snssd unssd resttopon sylancr ssun2 snssg mpbiri elun
      wo elsn orbi2i bitri simpllr wn pm5.61 ffvelrnda ad2ant2r sylan2b anassrs
      a1i ifclda fmptd w3a iscnp baibd syl31anc iftrue fvmptg eleq1d imbi1d crn
      sylan ctop cnfldtop cnex ssex ad2antrr restval rexeqdv inex1 rgenw imaeq2
      cvv vex eleq2 sseq1d anbi12d rexrnmpt mp1i ad3antrrr elin rbaib wfn ifexg
      fvex sylancl ralrimivw fnmpt fmpt df-f baib 3syl simplrr inss2 syl5ibrcom
      sylbi ralrimiv undif1 ineq2i indi eqtr3i raleqi ralunb 3bitrd wne ralbiia
      bitr3d eldifsni ifnefalse syl6bb cres df-ima resmpt rneqd syl5eq wfun cdm
      ffun difss sstri fdm syl5sseqr syl2anc 3bitr4d rexbidva pm5.74da ralbidva
      funimass4 bitrd pm5.32da syl5bb ) FGEUBUCZNZFONZUVIPAUVJFCUJZNZEBUJZNZGUV
      MDEUDZUEZUFZUGUVKQZPZBHUHZUKZCHRZPUVIUVJUVHOFEGUIULUMAUVJUVIUWBAUVJPZUVIM
      DUVOUNZMUJZEUOZFUWEGUPZUQZURZEHUWDVDUCZHUSUCUPNZEUWIUPZUVKNZEUAUJZNZUWIUW
      NUGZUVKQZPZUAUWJUHZUKZCHRZUWBAUVIUWKSUVJAMDEFGUWIUWJHUWJUTLUWIUTZIJKVAVBU
      WCUWJUWDVCUPNZHOVCUPNZEUWDNZUWDOUWIVEZUWKUXASAUXCUVJAUXDUWDOQZUXCHLVFZADU
      VOOJAEOKVGVHZUWDHOVIVJVBUXDUWCUXHWFAUXEUVJAUXEUVOUWDQZUVODVKAEONUXEUXJSKE
      UWDOVLTVMZVBUWCMUWDUWHOUWIUWEUWDNZUWCUWEDNZUWFVOZUWHONUXLUXMUWEUVONZVOUXN
      UWEDUVOVNUXOUWFUXMMEVPZVQVRUWCUXNPUWFFUWGOAUVJUXNUWFVSUWCUXNUWFVTZUWGONZU
      XNUXQPUWCUXMUXQPUXRUXMUWFWAAUXMUXRUVJUXQADOUWEGIWBWCWDWEWGWDUXBWHUXCUXDUX
      EWIUWKUXFUXAUACEUWIUWJHUWDOWJWKWLUWCUWTUWACHUWCUVKHNZPZUWTUVLUWSUKZUWAUWC
      UWTUYASUXSUWCUWMUVLUWSUWCUWLFUVKAUXEUVJUWLFUOUXKMEUWHFUWDOUWIUWFFUWGWMZUX
      BWNWRWOWPVBUXTUVLUWSUVTUWCUXSUVLUWSUVTSUWCUXSUVLPZPZUWSUWRUABHUVMUWDUFZUR
      ZWQZUHZEUYENZUWIUYEUGZUVKQZPZBHUHZUVTUYDUWRUAUWJUYGUYDHWSNUWDXINZUWJUYGUO
      HLWTAUYNUVJUYCAUXGUYNUXIUWDOXAXBTXCBUWDHWSXIXDVJXEUYEXINZBHRUYHUYMSUYDUYO
      BHUVMUWDBXJXFXGUWRUYLBUAHUYEUYFXIUYFUTUWNUYEUOZUWOUYIUWQUYKUWNUYEEXKUYPUW
      PUYJUVKUWNUYEUWIXHXLXMXNXOUYDUYLUVSBHUYDUVMHNZPZUYIUVNUYKUVRUYRUXEUYIUVNS
      AUXEUVJUYCUYQUXKXPUYIUVNUXEEUVMUWDXQXRTUYRMUYEUWHURZWQZUVKQZUWGUVKNZMUVQR
      ZUYKUVRUYRVUAUWHUVKNZMUVQRZVUCUYRVUDMUYERZVUAVUEUYRUWHXINZMUYERUYSUYEXSZV
      UFVUASUYRVUGMUYEUYRUVJUWGXINVUGAUVJUYCUYQVSUWEGYAUWFFUWGOXIXTYBYCMUYEUWHU
      YSXIUYSUTZYDVUFVUHVUAVUFUYEUVKUYSVEVUHVUAPMUYEUVKUWHUYSVUIYEUYEUVKUYSYFVR
      YGYHUYRVUDMUVMUVOUFZRZVUFVUESUYRVUDMVUJUYRVUDUWEVUJNZUVLUWCUXSUVLUYQYIVUL
      UXOVUDUVLSVUJUVOUWEUVMUVOYJULUXOUWHFUVKUXOUWFUWHFUOUXPUYBYLWOTYKYMVUFVUEV
      UKVUFVUDMUVQVUJUNZRVUEVUKPVUDMUYEVUMUVMUVPUVOUNZUFUYEVUMVUNUWDUVMDUVOYNYO
      UVMUVPUVOYPYQYRVUDMUVQVUJYSVRXRTUUCVUDVUBMUVQUWEUVQNUWEUVPNZVUDVUBSUVQUVP
      UWEUVMUVPYJZULVUOUWHUWGUVKVUOUWEEUUAUWHUWGUOUWEDEUUDUWEEFUWGUUETWOTUUBUUF
      UYRUYJUYTUVKUYRUYJUWIUYEUUGZWQUYTUWIUYEUUHUYRVUQUYSUYEUWDQVUQUYSUOUYRUVMU
      WDYJMUWDUYEUWHUUIXOUUJUUKXLUYRGUULZUVQGUUMZQUVRVUCSUYRDOGVEZVURAVUTUVJUYC
      UYQIXPZDOGUUNTUYRDUVQVUSUVQUVPDVUPDUVOUUOUUPUYRVUTVUSDUOVVADOGUUQTUURMUVQ
      UVKGUVDUUSUUTXMUVAYTWEUVBUVEUVCYTUVFUVG $.

    limcnlp.n $e |- ( ph -> -. B e. ( ( limPt ` K ) ` A ) ) $.
    $( If ` B ` is not a limit point of the domain of the function ` F ` , then
       every point is a limit of ` F ` at ` B ` .  (Contributed by Mario
       Carneiro, 25-Dec-2016.) $)
    limcnlp $p |- ( ph -> ( F limCC B ) = CC ) $=
      ( vu vv cc cv wcel cdif wss wa cfv c0 vx climc co csn cin cima wi ellimc2
      wrex wral ccld ctop cnfldtop adantr ssdifssd cnfldtopon toponunii sylancr
      ccl clscld cldopn syl wb islp mtbid eldifd wceq difin2 sscls ssdif0 sylib
      clp eqtr3d imaeq2d ima0 syl6eq syl6eqss eleq2 ineq1 sseq1d anbi12d rspcev
      0ss syl12anc a1d ralrimivw ex pm4.71d bitr4d eqrdv ) AUADCUBUCZMAUANZWKOW
      LMOZWLKNZOZCLNZOZDWPBCUDZPZUEZUFZWNQZRZLEUIZUGZKEUJZRWMALKBCWLDEFGHIUHAWM
      XFAWMXFAWMRZXEKEXGXDWOXGMWSEUSSSZPZEOZCXIOZDXIWSUEZUFZWNQZXDXGXHEUKSOZXJX
      GEULOZWSMQZXOEIUMZXGBMWRABMQZWMGUNUOZWSEMMEEIUPUQZUTURXHEMYAVAVBAXKWMACMX
      HHACBEVLSSOZCXHOZJAXPXSYBYCVCXRGCBEMYAVDURVEVFUNXGXMTWNXGXMDTUFTXGXLTDXGW
      SXHPZXLTXGXQYDXLVGXTWSXHMVHVBXGWSXHQZYDTVGXGXPXQYEXRXTWSEMYAVIURWSXHVJVKV
      MVNDVOVPWNWCVQXCXKXNRLXIEWPXIVGZWQXKXBXNWPXICVRYFXAXMWNYFWTXLDWPXIWSVSVNV
      TWAWBWDWEWFWGWHWIWJ $.
  $}

  ${
    $d u v x y z A $.  $d u v x y z B $.  $d u v x y z C $.  $d u v x y z ph $.
    $d u v x y z F $.
    ellimc3.f $e |- ( ph -> F : A --> CC ) $.
    ellimc3.a $e |- ( ph -> A C_ CC ) $.
    ellimc3.b $e |- ( ph -> B e. CC ) $.
    $( Write the epsilon-delta definition of a limit.  (Contributed by Mario
       Carneiro, 28-Dec-2016.) $)
    ellimc3 $p |- ( ph -> ( C e. ( F limCC B ) <-> ( C e. CC /\
      A. x e. RR+ E. y e. RR+ A. z e. A
        ( ( z =/= B /\ ( abs ` ( z - B ) ) < y ) ->
          ( abs ` ( ( F ` z ) - C ) ) < x ) ) ) ) $=
      ( vv co wcel cc wss wa wrex wi crp vu climc cv csn cdif cima ccnfld ctopn
      cin cfv wral wne cmin cabs clt wbr eqid ellimc2 ccom cbl cnxmet a1i simpr
      cxmt simplr blcntr syl3anc rpxr adantl cnfldtopn blopn eleq2 sseq2 anbi2d
      cxr wceq rexbidv imbi12d rspcv mpid mopni2 mp3an1 ssrin imass2 sstr2 3syl
      syl com12 reximdv syl5com impr rexlimiva syl6 ralrimdva r19.29r ad3antrrr
      rpxrd ineq1 imaeq2d sseq1d anbi12d rspcev expr rexlimdva anim2d syl9 syl5
      syl2anc imp3a exp3a expdimp com23 impbid wb wfun cdm ad2antrr inss2 difss
      wf fdm syl5sseqr syl5ss funimass4 simplrr sselda elbl3 syl22anc cnmetdval
      ffun breq1d simplrl simpllr eldifi ffvelrn ralbidva imbi1i impexp ralbii2
      bitrd syl2an ancom bitr2i eldifsn imbi2i 3bitr4i 3bitr3g anassrs rexbidva
      elin bitri pm5.32da ) AGHFUBMNGONZGUAUCZNZFLUCZNZHUUPEFUDZUEZUIZUFZUUNPZQ
      ZLUGUHUJZRZSZUAUVDUKZQUUMDUCZFULZUVHFUMMUNUJZCUCZUOUPZQUVHHUJZGUMMUNUJZBU
      CZUOUPZSZDEUKZCTRZBTUKZQALUAEFGHUVDIJKUVDUQZURAUUMUVGUVTAUUMQZUVGHFUVKUNU
      MUSZUTUJZMZUUSUIZUFZGUVOUWDMZPZCTRZBTUKZUVTUWBUVGUWKUWBUVGUWJBTUWBUVOTNZQ
      ZUVGUUQUVAUWHPZQZLUVDRZUWJUWMUVGGUWHNZUWPUWMUWCOVDUJNZUUMUWLUWQUWRUWMVAVB
      ZAUUMUWLVEZUWBUWLVCUWCGUVOOVFVGUWMUWHUVDNZUVGUWQUWPSZSUWMUWRUUMUVOVONZUXA
      UWSUWTUWLUXCUWBUVOVHVIUWCGUVOUVDOUVDUWAVJZVKVGUVFUXBUAUWHUVDUUNUWHVPZUUOU
      WQUVEUWPUUNUWHGVLUXEUVCUWOLUVDUXEUVBUWNUUQUUNUWHUVAVMVNVQVRVSWGVTUWOUWJLU
      VDUUPUVDNZUUQUWNUWJUXFUUQQUWEUUPPZCTRZUWNUWJUWRUXFUUQUXHVACUUPUWCFUVDOUXD
      WAWBUWNUXGUWICTUXGUWNUWIUXGUWFUUTPUWGUVAPUWNUWISUWEUUPUUSWCUWFUUTHWDUWGUV
      AUWHWEWFWHWIWJWKWLWMWNUWBUWKUVFUAUVDUWBUUNUVDNZQUUOUWKUVEUWBUXIUUOUWKUVES
      ZUXIUUOQUWHUUNPZBTRZUWBUXJUWRUXIUUOUXLVABUUNUWCGUVDOUXDWAWBUWBUXLUWKUVEUX
      LUWKQUXKUWJQZBTRUWBUVEUXKUWJBTWOUWBUXMUVEBTUWMUXKUWJUVEUWMUWJUWPUXKUVEUWM
      UWIUWPCTUWMUVKTNZQZUWEUVDNZFUWENZUWIUWPSUXOUWRFONZUVKVONZUXPUWRUXOVAVBZAU
      XRUUMUWLUXNKWPZUXOUVKUWMUXNVCZWQUWCFUVKUVDOUXDVKVGUXOUWRUXRUXNUXQUXTUYAUY
      BUWCFUVKOVFVGUXPUXQUWIUWPUWOUXQUWIQLUWEUVDUUPUWEVPZUUQUXQUWNUWIUUPUWEFVLU
      YCUVAUWGUWHUYCUUTUWFHUUPUWEUUSWRWSWTXAXBXCXHXDUXKUWOUVCLUVDUXKUWNUVBUUQUW
      NUXKUVBUVAUWHUUNWEWHXEWIXFXIXDXGXJXGXKXLWNXMUWBUWJUVSBTUWMUWIUVRCTUWBUWLU
      XNUWIUVRXNUWBUWLUXNQZQZUWIUVMUWHNZDUWFUKZUVRUYEHXOZUWFHXPZPUWIUYGXNUYEEOH
      XTZUYHAUYJUUMUYDIXQZEOHYJWGUYEUWFUUSUYIUWEUUSXRUYEEUUSUYIEUURXSZUYEUYJUYI
      EVPUYKEOHYAWGYBYCDUWFUWHHYDXHUYEUVHUWENZUYFSZDUUSUKUVLUVPSZDUUSUKUYGUVRUY
      EUYNUYODUUSUYEUVHUUSNZQZUYMUVLUYFUVPUYQUYMUVHFUWCMZUVKUOUPZUVLUYQUWRUXSUX
      RUVHONZUYMUYSXNUWRUYQVAVBZUYQUVKUWBUWLUXNUYPYEWQAUXRUUMUYDUYPKWPZUYEUUSOU
      VHAUUSOPUUMUYDAUUSEOUYLJYCXQYFZUVHUWCFUVKOYGYHUYQUYRUVJUVKUOUYQUYTUXRUYRU
      VJVPVUCVUBUVHFUWCUWCUQZYIXHYKYTUYQUYFUVMGUWCMZUVOUOUPZUVPUYQUWRUXCUUMUVMO
      NZUYFVUFXNVUAUYQUVOUWBUWLUXNUYPYLWQAUUMUYDUYPYMZUYEUYJUVHENZVUGUYPUYKUVHE
      UURYNEOUVHHYOUUAZUVMUWCGUVOOYGYHUYQVUEUVNUVOUOUYQVUGUUMVUEUVNVPVUJVUHUVMG
      UWCVUDYIXHYKYTVRYPUYNUYFDUUSUWFUVHUWFNZUYFSUYPUYMQZUYFSUYPUYNSVUKVULUYFVU
      KUYMUYPQVULUVHUWEUUSUUJUYMUYPUUBUUKYQUYPUYMUYFYRUUCYSUYOUVQDUUSEVUIUVIQZU
      YOSVUIUVIUYOSZSUYPUYOSVUIUVQSVUIUVIUYOYRUYPVUMUYOUVHEFUUDYQUVQVUNVUIUVIUV
      LUVPYRUUEUUFYSUUGYTUUHUUIYPYTUULYT $.
  $}

  ${
    $d s t u w x B $.  $d s t u w x C $.  $d s t u w x F $.  $d s t u w x K $.
    $d t u w x A $.  $d s u x L $.  $d t u w x ph $.
    limcflf.f $e |- ( ph -> F : A --> CC ) $.
    limcflf.a $e |- ( ph -> A C_ CC ) $.
    limcflf.b $e |- ( ph -> B e. ( ( limPt ` K ) ` A ) ) $.
    limcflf.k $e |- K = ( TopOpen ` CCfld ) $.
    ${
      limcflf.c $e |- C = ( A \ { B } ) $.
      limcflf.l $e |- L = ( ( ( nei ` K ) ` { B } ) |`t C ) $.
      $( Lemma for ~ limcflf .  (Contributed by Mario Carneiro,
         25-Dec-2016.) $)
      limcflflem $p |- ( ph -> L e. ( Fil ` C ) ) $=
        ( cfv wcel cc wss wb sylancr mpbid csn cnei crest co cfil ccl cdif ctop
        clp cnfldtop cnfldtopon toponunii fveq2i syl6eleqr ctopon difss eqsstri
        islp a1i syl5ss lpss sseldd trnei syl3anc syl5eqel ) AGCUAZFUBNNDUCUDZD
        UENZMACDFUFNZNZOZVGVHOZACBVFUGZVINZVJACBFUINNZOZCVNOZJAFUHOZBPQZVPVQRFK
        UJZICBFPPFFKUKZULZURSTDVMVILUMUNAFPUONOZDPQCPOVKVLRWCAWAUSADBPDVMBLBVFU
        PUQIUTAVOPCAVRVSVOPQVTIBFPWBVASJVBDCFPVCVDTVE $.

      $( The limit operator can be expressed as a filter limit, from the filter
         of neighborhoods of ` B ` restricted to ` A \ { B } ` , to the
         topology of the complexes.  (If ` B ` is not a limit point of ` A ` ,
         then it is still formally a filter limit, but the neighborhood filter
         is not a proper filter in this case.)  (Contributed by Mario Carneiro,
         25-Dec-2016.) $)
      limcflf $p |- ( ph -> ( F limCC B ) = ( ( K fLimf L ) ` ( F |` C ) ) ) $=
        ( vu vt cfv cc wcel wss wa vx vw vs climc co cres cflf cv csn cdif cima
        cin wrex wi wral wb cnei cmpt crn cvv vex inex1 rgenw eqid imaeq2 inss2
        wceq resima2 ax-mp syl6eq sseq1d rexrnmpt mp1i crest fvex difss eqsstri
        syl5ss cnex ssex ad2antrr restval sylancr rexeqdv ctop cnfldtop opnneip
        syl syl5eq mp3an1 a1i ineq12d imaeq2d rspcev sylan anasss rexlimiva cnt
        id simprl cnfldtopon toponunii neii1 ntropn lpss sseldd snssd ad3antrrr
        neiint syl3anc mpbid snssg mpbird ntrss2 ssrin imass2 3syl simprr sstrd
        eleq2 ineq2i ineq1 syl5eqr anbi12d syl12anc rexlimdvaa impbid2 3bitr4rd
        clp anassrs pm5.74da ralbidva pm5.32da ellimc2 ctopon limcflflem fssres
        cfil wf sylancl isflf 3bitr4d eqrdv ) AUAECUDUEZEDUFZFGUGUEPZAUAUHZQRZU
        UGNUHZRZCUBUHZRZEUUKBCUIZUJZULZUKZUUISZTZUBFUMZUNZNFUOZTUUHUUJUUEUCUHZU
        KZUUISZUCGUMZUNZNFUOZTZUUGUUDRUUGUUFRZAUUHUVAUVGAUUHTZUUTUVFNFUVJUUIFRZ
        TUUJUUSUVEUVJUVKUUJUUSUVEUPUVJUVKUUJTZTZUVDUCOUUMFUQPZPZOUHZDULZURZUSZU
        MZEUVQUKZUUISZOUVOUMZUVEUUSUVQUTRZOUVOUOUVTUWCUPUVMUWDOUVOUVPDOVAVBVCUV
        DUWBOUCUVOUVQUVRUTUVRVDUVBUVQVGZUVCUWAUUIUWEUVCUUEUVQUKZUWAUVBUVQUUEVEU
        VQDSUWFUWAVGUVPDVFEUVQDVHVIVJVKVLVMUVMUVDUCGUVSUVMGUVODVNUEZUVSMUVMUVOU
        TRDUTRZUWGUVSVGUUMUVNVOAUWHUUHUVLADQSUWHADBQDUUNBLBUUMVPVQZIVRDQVSVTWHW
        AODUVOUTUTWBWCWIWDUVMUUSUWCUURUWCUBFUUKFRZUULUUQUWCUWJUULTUUKUVORZUUQUW
        CFWERZUWJUULUWKFKWFZCFUUKWGWJUWBUUQOUUKUVOUVPUUKVGZUWAUUPUUIUWNUVQUUOEU
        WNUVPUUKDUUNUWNWSDUUNVGUWNLWKWLWMVKWNWOWPWQUVMUWBUUSOUVOUVMUVPUVORZUWBT
        ZTZUVPFWRPPZFRZCUWRRZEUWRDULZUKZUUISZUUSUWQUWLUVPQSZUWSUWMUWQUWLUWOUXDU
        WMUVMUWOUWBWTZUUMFUVPQQFFKXAZXBZXCWCZUVPFQUXGXDWCUWQUWTUUMUWRSZUWQUWOUX
        IUXEUWQUWLUUMQSZUXDUWOUXIUPUWLUWQUWMWKAUXJUUHUVLUWPACQABFYIPPZQCAUWLBQS
        UXKQSUWMIBFQUXGXEWCJXFZXGXHUXHUUMFUVPQUXGXIXJXKUWQCQRZUWTUXIUPAUXMUUHUV
        LUWPUXLXHCUWRQXLWHXMUWQUXBUWAUUIUWQUWRUVPSZUXAUVQSUXBUWASUWQUWLUXDUXNUW
        MUXHUVPFQUXGXNWCUWRUVPDXOUXAUVQEXPXQUVMUWOUWBXRXSUURUWTUXCTUBUWRFUUKUWR
        VGZUULUWTUUQUXCUUKUWRCXTUXOUUPUXBUUIUXOUUOUXAEUXOUUOUUKDULUXADUUNUUKLYA
        UUKUWRDYBYCWMVKYDWNYEYFYGYHYJYKYLYMAUBNBCUUGEFHIUXLKYNAFQYOPRZGDYRPRDQU
        UEYSZUVIUVHUPUXPAUXFWKABCDEFGHIJKLMYPABQEYSDBSUXQHUWIBQDEYQYTUUGNUUEFGQ
        DUCUUAXJUUBUUC $.
    $}

    $( If ` B ` is a limit point of the domain of the function ` F ` , then
       there is at most one limit value of ` F ` at ` B ` .  (Contributed by
       Mario Carneiro, 25-Dec-2016.) $)
    limcmo $p |- ( ph -> E* x x e. ( F limCC B ) ) $=
      ( cv climc co wcel wmo csn cfv cc wf eqid cdif cres cnei crest limcflflem
      cflf cha cfil cnfldhaus a1i wss difss fssres sylancl cnfldtopon toponunii
      hausflf syl3anc limcflf eleq2d mobidv mpbird ) ABKZEDLMZNZBOVCECDPZUAZUBZ
      FVFFUCQQVGUDMZUFMQZNZBOZAFUGNZVIVGUHQNVGRVHSZVLVMAFJUIUJACDVGEFVIGHIJVGTZ
      VITZUEACRESVGCUKVNGCVFULCRVGEUMUNBVHFVIRVGRFFJUOUPUQURAVEVKBAVDVJVCACDVGE
      FVIGHIJVOVPUSUTVAVB $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y D $.  $d y K $.  $d z ph $.
    limcmpt.a $e |- ( ph -> A C_ CC ) $.
    limcmpt.b $e |- ( ph -> B e. CC ) $.
    limcmpt.f $e |- ( ( ph /\ z e. A ) -> D e. CC ) $.
    limcmpt.j $e |- J = ( K |`t ( A u. { B } ) ) $.
    limcmpt.k $e |- K = ( TopOpen ` CCfld ) $.
    $( Express the limit operator for a function defined by a mapping.
       (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    limcmpt $p |- ( ph -> ( C e. ( ( z e. A |-> D ) limCC B ) <->
 ( z e. ( A u. { B } ) |-> if ( z = B , C , D ) ) e. ( ( J CnP K ) ` B ) ) ) $=
      ( vy cmpt wcel wceq cfv cif wa climc co csn cun cv ccnp nfcv nfv nffvmpt1
      nfif eqeq1 fveq2 ifbieq2d cbvmpt cc eqid fmptd ellimc wn elun elsn orbi2i
      pm5.61 simplbi sylanb adantl sylan2 fvmpt2 syl2anc anassrs ifeq2da eleq1d
      wo bitri mpteq2dva bitrd ) AEBCFOZDUAUBPBCDUCZUDZBUEZDQZEVTVQRZSZOZDGHUFU
      BRZPBVSWAEFSZOZWEPANCDEVQWDGHLMBNVSWCNUEZDQZEWHVQRZSNWCUGWIBEWJWIBUHBEUGB
      CFWHUIUJVTWHQWAWIWBWJEVTWHDUKVTWHVQULUMUNABCFUOVQKVQUPZUQIJURAWDWGWEABVSW
      CWFAVTVSPZTWAWBFEAWLWAUSZWBFQZAWLWMTZTVTCPZFUOPZWNWOWPAWLWPWAVMZWMWPWLWPV
      TVRPZVMWRVTCVRUTWSWAWPBDVAVBVNWRWMTWPWMWPWAVCVDVEZVFWOAWPWQWTKVGBCFUOVQWK
      VHVIVJVKVOVLVP $.
  $}

  ${
    $d z A $.  $d z B $.  $d z C $.  $d z ph $.
    limcmpt2.a $e |- ( ph -> A C_ CC ) $.
    limcmpt2.b $e |- ( ph -> B e. A ) $.
    limcmpt2.f $e |- ( ( ph /\ ( z e. A /\ z =/= B ) ) -> D e. CC ) $.
    limcmpt2.j $e |- J = ( K |`t A ) $.
    limcmpt2.k $e |- K = ( TopOpen ` CCfld ) $.
    $( Express the limit operator for a function defined by a mapping.
       (Contributed by Mario Carneiro, 25-Dec-2016.) $)
    limcmpt2 $p |- ( ph -> ( C e. ( ( z e. ( A \ { B } ) |-> D ) limCC B ) <->
      ( z e. A |-> if ( z = B , C , D ) ) e. ( ( J CnP K ) ` B ) ) ) $=
      ( cmpt co wcel cun crest ccnp cc csn cdif cv wceq cif cfv ssdifssd sseldd
      climc wne wa eldifsn sylan2b eqid limcmpt undif1 wss snssd ssequn2 syl5eq
      sylib mpteq1d oveq2d syl6eqr oveq1d fveq1d eleq12d bitrd ) AEBCDUAZUBZFND
      UIOPBVJVIQZBUCZDUDEFUEZNZDHVKROZHSOZUFZPBCVMNZDGHSOZUFZPABVJDEFVOHACTVIIU
      GACTDIJUHVLVJPAVLCPVLDUJUKFTPVLCDULKUMVOUNMUOAVNVRVQVTABVKCVMAVKCVIQZCCVI
      UPAVICUQWACUDADCJURVICUSVAUTZVBADVPVSAVOGHSAVOHCROGAVKCHRWBVCLVDVEVFVGVH
      $.
  $}

  ${
    $d u v x B $.  $d u v x C $.  $d u v x F $.
    $( Any limit of ` F ` is also a limit of the restriction of ` F ` .
       (Contributed by Mario Carneiro, 28-Dec-2016.) $)
    limcresi $p |- ( F limCC B ) C_ ( ( F |` C ) limCC B ) $=
      ( vx vu vv climc co cv wcel cc cin cdif cima wss wa wrex wi wral wf ctopn
      cres cdm csn ccnfld cfv limcrcl simp1d simp2d eqid ellimc2 ibi wceq inss2
      simp3d difss sstri resima2 ax-mp inss1 ssdif sslin mp2b eqsstri sstr mpan
      imass2 anim2i reximi imim2i ralimi syl fresin syl5ss mpbird ssriv ) DCAGH
      ZCBUBZAGHZDIZVQJZVTVSJVTKJZVTEIZJZAFIZJZVRWECUCZBLZAUDZMZLZNZWCOZPZFUEUAU
      FZQZRZEWOSZPZWAWBWDWFCWEWGWIMZLZNZWCOZPZFWOQZRZEWOSZPZWSWAXHWAFEWGAVTCWOW
      AWGKCTZWGKOZAKJZAVTCUGZUHZWAXIXJXKXLUIZWAXIXJXKXLUOZWOUJZUKULXGWRWBXFWQEW
      OXEWPWDXDWNFWOXCWMWFWLXBOXCWMWLCWKNZXBWKBOWLXQUMWKWJBWEWJUNWJWHBWHWIUPWGB
      UNUQUQCWKBURUSWJWTOZWKXAOXQXBOWHWGOXRWGBUTZWHWGWIVAUSWJWTWEVBWKXACVGVCVDW
      LXBWCVEVFVHVIVJVKVHVLWAFEWHAVTVRWOWAXIWHKVRTXMWGKCBVMVLWAWHWGKXSXNVNXOXPU
      KVOVP $.
  $}

  ${
    $d z A $.  $d x z B $.  $d x z C $.  $d x z F $.  $d z K $.  $d x z ph $.
    limcres.f $e |- ( ph -> F : A --> CC ) $.
    limcres.c $e |- ( ph -> C C_ A ) $.
    limcres.a $e |- ( ph -> A C_ CC ) $.
    limcres.k $e |- K = ( TopOpen ` CCfld ) $.
    limcres.j $e |- J = ( K |`t ( A u. { B } ) ) $.
    limcres.i $e |- ( ph -> B e. ( ( int ` J ) ` ( C u. { B } ) ) ) $.
    $( If ` B ` is an interior point of ` C u. { B } ` relative to the domain
       ` A ` , then a limit point of ` F |`` C ` extends to a limit of ` F ` .
       (Contributed by Mario Carneiro, 27-Dec-2016.) $)
    limcres $p |- ( ph -> ( ( F |` C ) limCC B ) = ( F limCC B ) ) $=
      ( vz co cc wcel wss wceq cfv vx cres climc cv wa wi cdm wf limcrcl simp3d
      limccl sseli jca a1i csn cun cif cmpt ccnp crest ctop cuni cnt cnfldtopon
      wb ctopon adantr simprl snssd unssd resttopon syl5eqel topontop syl unss1
      sylancr toponuni sseqtrd elun simplrr ffvelrnda ifcl syl2anc elsni adantl
      wo iftrue eqeltrd jaodan sylan2b eqid fmptd feq2d mpbid toponunii cnprest
      syl22anc ellimc fssres sstrd resmpt elsn orbi2i bitri fvres sylbi ifeq2da
      wn pm5.61 mpteq2ia syl6reqr oveq1i cvv cnex restabs syl3anc oveq1d fveq1d
      ssex syl5req eleq12d bitrd 3bitr4rd ex pm5.21ndd eqrdv ) AUAEDUBZCUCOZECU
      COZACPQZUAUDZPQZUEZYKYHQZYKYIQZYNYMUFAYNYJYLYNYGUGZPYGUHYPPRYJCYKYGUIUJYH
      PYKCYGUKULUMUNYOYMUFAYOYJYLYOEUGZPEUHYQPRYJCYKEUIUJYIPYKCEUKULUMUNAYMYNYO
      VEAYMUEZNBCUOZUPZNUDZCSZYKUUAETZUQZURZCFGUSOTQZUUEDYSUPZUBZCFUUGUTOZGUSOZ
      TZQZYOYNYRFVAQZUUGFVBZRCUUGFVCTTQZUUNPUUEUHZUUFUULVEYRFYTVFTZQZUUMYRFGYTU
      TOZUUQLYRGPVFTZQZYTPRZUUSUUQQGKVDZYRBYSPABPRYMJVGZYRCPAYJYLVHZVIVJZYTGPVK
      VPVLZYTFVMVNYRUUGYTUUNYRDBRZUUGYTRZAUVHYMIVGZDBYSVOVNZYRUURYTUUNSUVGYTFVQ
      VNZVRAUUOYMMVGYRYTPUUEUHUUPYRNYTUUDPUUEUUAYTQYRUUABQZUUAYSQZWFUUDPQZUUABY
      SVSYRUVMUVOUVNYRUVMUEYLUUCPQUVOAYJYLUVMVTYRBPUUAEABPEUHZYMHVGZWAUUBYKUUCP
      WBWCYRUVNUEZUUDYKPUVRUUBUUDYKSUVNUUBYRUUACWDWEUUBYKUUCWGVNAYJYLUVNVTWHWIW
      JUUEWKZWLYRYTUUNPUUEUVLWMWNUUGCUUEFGUUNPUUNWKPGUVCWOWPWQYRNBCYKEUUEFGLKUV
      SUVQUVDUVEWRYRYNNUUGUUBYKUUAYGTZUQZURZCGUUGUTOZGUSOZTZQUULYRNDCYKYGUWBUWC
      GUWCWKKUWBWKYRUVPUVHDPYGUHUVQUVJBPDEWSWCYRDBPUVJUVDWTUVEWRYRUWBUUHUWEUUKY
      RUUHNUUGUUDURZUWBYRUVIUUHUWFSUVKNYTUUGUUDXAVNNUUGUWAUUDUUAUUGQZUUADQZUUBW
      FZUWAUUDSUWGUWHUVNWFUWIUUADYSVSUVNUUBUWHNCXBXCXDUWIUUBUVTUUCYKUWIUUBXHZUE
      UWHUWJUEUVTUUCSZUWHUUBXIUWHUWKUWJUUADEXEVGXFXGXFXJXKYRCUWDUUJYRUWCUUIGUSY
      RUUIUUSUUGUTOZUWCFUUSUUGUTLXLYRUVAUVIYTXMQZUWLUWCSUVAYRUVCUNUVKYRUVBUWMUV
      FYTPXNXSVNUUGYTGUUTXMXOXPXTXQXRYAYBYCYDYEYF $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x K $.
    cnplimc.k $e |- K = ( TopOpen ` CCfld ) $.
    cnplimc.j $e |- J = ( K |`t A ) $.
    $( A function is continuous at ` B ` iff its limit at ` B ` equals the
       value of the function there.  (Contributed by Mario Carneiro,
       28-Dec-2016.) $)
    cnplimc $p |- ( ( A C_ CC /\ B e. A ) -> ( F e. ( ( J CnP K ) ` B ) <->
      ( F : A --> CC /\ ( F ` B ) e. ( F limCC B ) ) ) ) $=
      ( vx cc wss wcel wa ccnp co cfv wf ctopon crest wceq cif climc cnfldtopon
      wi simpl resttopon sylancr syl5eqel cnpf2 3expia sylancl pm4.71rd csn cun
      cmpt simpr simplr snssd ssequn2 sylib feq2d mpbird oveq2d syl6reqr oveq1d
      cv feqmptd fveq1d eleq12d eqid ifid fveq2 adantl ifeq1da syl5eqr mpteq2ia
      simpll sseldd ellimc bitr4d pm5.32da bitrd ) AIJZBAKZLZCBDEMNZOZKZAICPZWG
      LWHBCOZCBUANKZLWDWGWHWDDAQOZKZEIQOKZWGWHUCWDDEARNZWKGWDWMWBWNWKKEFUBZWBWC
      UDAEIUEUFUGWOWLWMWGWHBCDEAIUHUIUJUKWDWHWGWJWDWHLZWGHABULZUMZHVEZCOZUNZBEW
      RRNZEMNZOZKWJWPCXAWFXDWPHWRICWPWRICPWHWDWHUOZWPWRAICWPWQAJWRASWPBAWBWCWHU
      PZUQWQAURUSZUTVAVFWPBWEXCWPDXBEMWPXBWNDWPWRAERXGVBGVCVDVGVHWPHABWICXAXBEX
      BVIFHWRWTWSBSZWIWTTZWSWRKZWTXHWTWTTXIXHWTVJXJXHWTWIWTXHWTWISXJWSBCVKVLVMV
      NVOXEWBWCWHVPZWPAIBXKXFVQVRVSVTWA $.
  $}

  ${
    $d x A $.  $d x F $.
    $( ` F ` is a continuous function iff the limit of the function at each
       point equals the value of the function.  (Contributed by Mario Carneiro,
       28-Dec-2016.) $)
    cnlimc $p |- ( A C_ CC -> ( F e. ( A -cn-> CC ) <->
      ( F : A --> CC /\ A. x e. A ( F ` x ) e. ( F limCC x ) ) ) ) $=
      ( cc wss ccncf co wcel ccnfld ctopn cfv crest wf wral wa wceq eqid ctopon
      ccn wb cv ccnp climc ssid cnfldtopon toponunii restid ax-mp eqcomi cncfcn
      mpan2 eleq2d resttopon mpan cncnp sylancl cnplimc baibd ralbidva pm5.32da
      an32s 3bitrd ) BDEZCBDFGZHCIJKZBLGZVESGZHZBDCMZCAUAZVFVEUBGKHZABNZOZVIVJC
      KCVJUCGHZABNZOVCVDVGCVCDDEVDVGPDUDBDVEVFVEVEQZVFQZVEDLGZVEVEDRKZHZVRVEPVE
      VPUEZVEVSDDVEWAUFUGUHUIUJUKULVCVFBRKHZVTVHVMTVTVCWBWABVEDUMUNWAACVFVEBDUO
      UPVCVIVLVOVCVIOVKVNABVCVJBHZVIVKVNTVCWCOVKVIVNBVJCVFVEVPVQUQURVAUSUTVB $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    cnlimci.f $e |- ( ph -> F e. ( A -cn-> D ) ) $.
    cnlimci.c $e |- ( ph -> B e. A ) $.
    $( If ` F ` is a continuous function, then the limit of the function at any
       point equals its value.  (Contributed by Mario Carneiro,
       28-Dec-2016.) $)
    cnlimci $p |- ( ph -> ( F ` B ) e. ( F limCC B ) ) $=
      ( vx wcel cv cfv climc co wral cc wss ccncf cncfrss syl cncfrss2 simplbda
      ssid cncfss sylancl sseldd wf syl2anc wceq fveq2 oveq2 eleq12d rspcv sylc
      cnlimc ) ACBIHJZEKZEUOLMZIZHBNZCEKZECLMZIZGABOPZEBOQMZIZUSAEBDQMZIZVCFBDE
      RSAVFVDEADOPZOOPVFVDPAVGVHFBDETSOUBBDOUCUDFUEVCVEBOEUFUSHBEUNUAUGURVBHCBU
      OCUHUPUTUQVAUOCEUIUOCELUJUKULUM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x D $.  $d x Y $.
    cnmptlimc.f $e |- ( ph -> ( x e. A |-> X ) e. ( A -cn-> D ) ) $.
    cnmptlimc.b $e |- ( ph -> B e. A ) $.
    cnmptlimc.1 $e |- ( x = B -> X = Y ) $.
    $( If ` F ` is a continuous function, then the limit of the function at any
       point equals its value.  (Contributed by Mario Carneiro,
       28-Dec-2016.) $)
    cnmptlimc $p |- ( ph -> Y e. ( ( x e. A |-> X ) limCC B ) ) $=
      ( cmpt cfv climc co wcel wceq wral wf ccncf cncff syl eqid fmpt sylibr cv
      eleq1d rspcv sylc fvmptg syl2anc cnlimci eqeltrrd ) ADBCFKZLZGUMDMNADCOZG
      EOZUNGPIAUOFEOZBCQZUPIACEUMRZURAUMCESNOUSHCEUMTUABCEFUMUMUBZUCUDUQUPBDCBU
      EDPFGEJUFUGUHBDFGCEUMJUTUIUJACDEUMHIUKUL $.
  $}

  ${
    $d x y B $.  $d x y C $.  $d x y D $.  $d x y F $.  $d x y G $.  $d x ph $.
    $d x A $.  $d x K $.
    limccnp.f $e |- ( ph -> F : A --> D ) $.
    limccnp.d $e |- ( ph -> D C_ CC ) $.
    limccnp.k $e |- K = ( TopOpen ` CCfld ) $.
    limccnp.j $e |- J = ( K |`t D ) $.
    limccnp.c $e |- ( ph -> C e. ( F limCC B ) ) $.
    limccnp.b $e |- ( ph -> G e. ( ( J CnP K ) ` C ) ) $.
    $( If the limit of ` F ` at ` B ` is ` C ` and ` G ` is continuous at
       ` C ` , then the limit of ` G o. F ` at ` B ` is ` G ( C ) ` .
       (Contributed by Mario Carneiro, 28-Dec-2016.) $)
    limccnp $p |- ( ph -> ( G ` C ) e. ( ( G o. F ) limCC B ) ) $=
      ( vx cfv co wcel cc vy ccom climc csn cun cv wceq cmpt crest ccnp wa cuni
      cif eqid cnprcl syl ctopon cnfldtopon resttopon sylancr syl5eqel toponuni
      wss eleqtrrd ad2antrr wn wf elun elsni orim2i sylbi adantl orcomd orcanai
      wo ffvelrnd ifclda eqidd cnpf2 syl3anc feqmptd fveq2 fmptco fvco3 syl2anc
      a1i ifeq2da fvif syl6eqr mpteq2dva eqtr4d fss cdm fdm w3a simp2d eqsstr3d
      limcrcl simp3d ellimc mpbid wb cnfldtop fmptd snssd unssd feq2d toponunii
      ctop cnprest2 oveq2i fveq1i ssun2 snssg mpbiri iftrue fvmptg fveq2d cnpco
      syl6eleqr eqeltrrd fco mpbird ) ADGQZGFUBZCUCRSPBCUDZUEZPUFZCUGZYDYHYEQZU
      MZUHZCIYGUIRZIUJRQZSAGPYGYIDYHFQZUMZUHZUBZYLYNAYRPYGYPGQZUHYLAPUAYGEYPUAU
      FZGQYSYQGAYHYGSZUKZYIDYOEADESZUUAYIADHULZEAGDHIUJRZQZSZDUUDSODGHIUUDUUDUN
      UOUPAHEUQQZSZEUUDUGAHIEUIRZUUHMAITUQQSZETVCZUUJUUHSILURZKEITUSUTVAZEHVBUP
      VDZVEUUBYIVFZUKZBEYHFABEFVGZUUAUUPJVEZUUBYIYHBSZUUBUUTYIUUAUUTYIVOZAUUAUU
      TYHYFSZVOUVAYHBYFVHUVBYIUUTYHCVIVJVKVLVMVNZVPVQZAYQVRAUAETGAUUIUUKUUGETGV
      GZUUNUUKAUUMWFODGHIETVSVTZWAYTYPGWBWCAPYGYKYSUUBYKYIYDYOGQZUMYSUUBYIYJUVG
      YDUUQUURUUTYJUVGUGUUSUVCBEYHGFWDWEWGYIDYOGWHWIWJWKAYQCYMHUJRZQZSGCYQQZUUE
      QZSYRYNSAYQCYMUUJUJRZQZUVIAYQYNSZYQUVMSZADFCUCRSZUVNNAPBCDFYQYMIYMUNZLYQU
      NZAUURUULBTFVGJKBETFWLWEABFWMZTAUURUVSBUGJBEFWNUPAUVSTFVGZUVSTVCZCTSZAUVP
      UVTUWAUWBWONCDFWRUPZWPWQZAUVTUWAUWBUWCWSZWTXAAIXISZYMULZEYQVGZUULUVNUVOXB
      UWFAILXCWFAYGEYQVGUWHAPYGYPEYQUVDUVRXDAYGUWGEYQAYMYGUQQSZYGUWGUGAUUKYGTVC
      UWIUUMABYFTUWDACTUWEXEXFYGITUSUTYGYMVBUPXGXAKECYQYMIUWGTUWGUNTIUUMXHXJVTX
      ACUVHUVLHUUJYMUJMXKXLXTAGUUFUVKOAUVJDUUEACYGSZUUCUVJDUGAUWJYFYGVCZYFBXMAU
      WBUWJUWKXBUWECYGTXNUPXOUUOPCYPDYGEYQYIDYOXPUVRXQWEXRVDCYQGYMHIXSWEYAAPBCY
      DYEYLYMIUVQLYLUNAUVEUURBTYEVGUVFJBETGFYBWEUWDUWEWTYC $.
  $}

  ${
    $d x y B $.  $d x y C $.  $d x y D $.  $d x y H $.  $d x ph $.  $d x y X $.
    $d x A $.  $d y R $.  $d y S $.  $d x y Y $.
    limccnp2.r $e |- ( ( ph /\ x e. A ) -> R e. X ) $.
    limccnp2.s $e |- ( ( ph /\ x e. A ) -> S e. Y ) $.
    limccnp2.x $e |- ( ph -> X C_ CC ) $.
    limccnp2.y $e |- ( ph -> Y C_ CC ) $.
    limccnp2.k $e |- K = ( TopOpen ` CCfld ) $.
    limccnp2.j $e |- J = ( ( K tX K ) |`t ( X X. Y ) ) $.
    limccnp2.c $e |- ( ph -> C e. ( ( x e. A |-> R ) limCC B ) ) $.
    limccnp2.d $e |- ( ph -> D e. ( ( x e. A |-> S ) limCC B ) ) $.
    limccnp2.h $e |- ( ph -> H e. ( ( J CnP K ) ` <. C , D >. ) ) $.
    $( The image of a convergent sequence under a continuous map is convergent
       to the image of the original point.  Binary operation version.
       (Contributed by Mario Carneiro, 28-Dec-2016.) $)
    limccnp2 $p |- ( ph ->
      ( C H D ) e. ( ( x e. A |-> ( R H S ) ) limCC B ) ) $=
      ( vy co cmpt climc wcel csn cun wceq cif crest ccnp cfv cop ccom cxp cuni
      cv wa eqid cnprcl syl ctopon ctx cc wss cnfldtopon txtopon xpss12 syl2anc
      mp2an resttopon sylancr syl5eqel toponuni eleqtrrd opelxp simpld ad2antrr
      sylib wn simpll simpr elun ord elsni syl6 con1d imp ifclda simprd opelxpi
      wo eqidd wf a1i cnpf2 syl3anc feqmptd fveq2 iftrue oveq12d eqtr4d iffalse
      df-ov pm2.61i eqtr3i syl6eq fmptco cdm fdm limcrcl simp2d eqsstr3d simp3d
      fmptd snssd unssd ssun2 wb snssg mpbiri adantr sseldd limcmpt mpbid txcnp
      w3a ctop topontopi feq2d toponunii cnprest2 oveq2i syl6eleqr opeq12d opex
      fveq1i fvmpt fveq2d cnpco eqeltrrd fovrnd mpbird ) AEFIUDZBCGHIUDZUEDUFUD
      UGBCDUHZUIZBUSZDUJZUUFUUGUKZUEZDKUUIULUDZKUMUDUNZUGAIBUUIUUKEGUKZUUKFHUKZ
      UOZUEZUPZUUMUUOABUCUUILMUQZUURUCUSZIUNZUULUUSIAUUJUUIUGZUTZUUPLUGUUQMUGUU
      RUVAUGUVEUUKEGLAELUGZUVDUUKAUVFFMUGZAEFUOZUVAUGUVFUVGUTAUVHJURZUVAAIUVHJK
      UMUDZUNZUGZUVHUVIUGUBUVHIJKUVIUVIVAVBVCAJUVAVDUNZUGZUVAUVIUJAJKKVEUDZUVAU
      LUDZUVMSAUVOVFVFUQZVDUNUGZUVAUVQVGZUVPUVMUGKVFVDUNUGZUVTUVRKRVHZUWAKKVFVF
      VIVLZALVFVGZMVFVGZUVSPQLVFMVFVJVKZUVAUVOUVQVMVNVOZUVAJVPVCVQEFLMVRWAZVSVT
      UVEUUKWBZUTZAUUJCUGZGLUGAUVDUWHWCZUVEUWHUWJUVEUWJUUKUVEUWJWBUUJUUHUGZUUKU
      VEUWJUWLUVEUVDUWJUWLWNAUVDWDUUJCUUHWEWAWFUUJDWGWHWIWJZNVKWKUVEUUKFHMAUVGU
      VDUUKAUVFUVGUWGWLVTUWIAUWJHMUGUWKUWMOVKWKUUPUUQLMWMVKZAUUSWOAUCUVAVFIAUVN
      UVTUVLUVAVFIWPZUWFUVTAUWAWQZUBUVHIJKUVAVFWRWSZWTUVBUURUJUVCUURIUNZUULUVBU
      URIXAUUPUUQIUDZUWRUULUUPUUQIXFUUKUWSUULUJUUKUWSUUFUULUUKUUPEUUQFIUUKEGXBZ
      UUKFHXBZXCUUKUUFUUGXBXDUWHUWSUUGUULUWHUUPGUUQHIUUKEGXEUUKFHXEXCUUKUUFUUGX
      EXDXGXHXIXJAUUSDUUNJUMUDZUNZUGIDUUSUNZUVJUNZUGUUTUUOUGAUUSDUUNUVPUMUDZUNZ
      UXCAUUSDUUNUVOUMUDUNUGZUUSUXGUGZABUUPUUQDUUNKKUUIVFVFAUVTUUIVFVGUUNUUIVDU
      NUGZUWAACUUHVFACBCGUEZXKZVFACLUXKWPUXLCUJABCGLUXKNUXKVAXQCLUXKXLVCAUXLVFU
      XKWPZUXLVFVGZDVFUGZAEUXKDUFUDUGZUXMUXNUXOYITDEUXKXMVCZXNXOZADVFAUXMUXNUXO
      UXQXPZXRXSUUIKVFVMVNZUWPUWPADUUIUGZUUHUUIVGZUUHCXTAUXOUYAUYBYAUXSDUUIVFYB
      VCYCZAUXPBUUIUUPUEUUOUGTABCDEGUUNKUXRUXSAUWJUTZLVFGAUWCUWJPYDNYEUUNVAZRYF
      YGAFBCHUEDUFUDUGBUUIUUQUEUUOUGUAABCDFHUUNKUXRUXSUYDMVFHAUWDUWJQYDOYEUYERY
      FYGYHAUVOYJUGZUUNURZUVAUUSWPZUVSUXHUXIYAUYFAUVQUVOUWBYKWQAUUIUVAUUSWPUYHA
      BUUIUURUVAUUSUWNUUSVAZXQAUUIUYGUVAUUSAUXJUUIUYGUJUXTUUIUUNVPVCYLYGUWEUVAD
      UUSUUNUVOUYGUVQUYGVAUVQUVOUWBYMYNWSYGDUXBUXFJUVPUUNUMSYOYSYPAIUVKUXEUBAUX
      DUVHUVJAUYAUXDUVHUJUYCBDUURUVHUUIUUSUUKUUPEUUQFUWTUXAYQUYIEFYRYTVCUUAVQDU
      USIUUNJKUUBVKUUCABCDUUFUUGUUNKUXRUXSUYDGHVFLMIAUWOUWJUWQYDNOUUDUYERYFUUE
      $.
  $}

  ${
    $d x A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y ph $.  $d y R $.
    $d x S $.  $d y T $.
    limcco.r $e |- ( ( ph /\ ( x e. A /\ R =/= C ) ) -> R e. B ) $.
    limcco.s $e |- ( ( ph /\ y e. B ) -> S e. CC ) $.
    limcco.c $e |- ( ph -> C e. ( ( x e. A |-> R ) limCC X ) ) $.
    limcco.d $e |- ( ph -> D e. ( ( y e. B |-> S ) limCC C ) ) $.
    limcco.1 $e |- ( y = R -> S = T ) $.
    limcco.2 $e |- ( ( ph /\ ( x e. A /\ R = C ) ) -> T = D ) $.
    $( Composition of two limits.  (Contributed by Mario Carneiro,
       29-Dec-2016.) $)
    limcco $p |- ( ph -> D e. ( ( x e. A |-> T ) limCC X ) ) $=
      ( wceq wcel cc csn cun cv cif cmpt ccom climc co ccnfld ctopn crest wa wo
      cfv wn wne expr necon1bd wb limccl sseldi adantr elsnc2g syl sylibrd orrd
      elun sylibr eqid fmptd cdm wf fdm wss limcrcl simp2d eqsstr3d snssd unssd
      ccnp limcmpt mpbid limccnp ssun2 snssg mpbiri iftrue fvmptg syl2anc eqidd
      w3a eqeq1 ifbieq2d fmptco anassrs ifeq1da syl5reqr mpteq2dva eqtrd oveq1d
      ifid 3eltr3d ) AFCEFUAZUBZCUCZFRZGIUDZUEZUNZXHBDHUEZUFZKUGUHGBDJUEZKUGUHA
      DKFXDXJXHUIUJUNZXDUKUHZXMABDHXDXJABUCDSZULZHESZHXCSZUMHXDSXPXQXRXPXQUOHFR
      ZXRXPXQHFAXOHFUPXQLUQURXPFTSZXRXSUSAXTXOAXJKUGUHZTFKXJUTNVAZVBHFTVCVDVEVF
      HEXCVGVHZXJVIVJAEXCTAECEIUEZVKZTAETYDVLYEERACEITYDMYDVIVJETYDVMVDAYETYDVL
      ZYETVNZXTAGYDFUGUHZSZYFYGXTWKOFGYDVOVDVPVQZAFTYBVRVSXMVIZXNVIZNAYIXHFXNXM
      VTUHUNSOACEFGIXNXMYJYBMYLYKWAWBWCAFXDSZYIXIGRAYMXCXDVNZXCEWDAFYASYMYNUSNF
      XDYAWEVDWFOCFXGGXDYHXHXFGIWGXHVIWHWIAXKXLKUGAXKBDXSGJUDZUEXLABCDXDHXGYOXJ
      XHYCAXJWJAXHWJXEHRXFXSIJGXEHFWLPWMWNABDYOJXPJXSJJUDYOXSJXAXPXSJGJAXOXSJGR
      QWOWPWQWRWSWTXB $.
  $}

  ${
    $d a g k u v x y z A $.  $d a g k u v x y z C $.  $d a g k u v x y F $.
    $d a g k u v y B $.  $d a g k u v y ph $.
    limciun.1 $e |- ( ph -> A e. Fin ) $.
    limciun.2 $e |- ( ph -> A. x e. A B C_ CC ) $.
    limciun.3 $e |- ( ph -> F : U_ x e. A B --> CC ) $.
    limciun.4 $e |- ( ph -> C e. CC ) $.
    $( A point is a limit of ` F ` on the finite union ` U_ x e. A B ( x ) `
       iff it is the limit of the restriction of ` F ` to each ` B ( x ) ` .
       (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    limciun $p |- ( ph -> ( F limCC C ) =
      ( CC i^i |^|_ x e. A ( ( F |` B ) limCC C ) ) ) $=
      ( va cc cin wss wral cv wcel wa cima nfcv vy vu vv vg vk vz climc co cres
      ciin limccl limcresi rgenw ssiin mpbir ssini a1i elriin ciun ccnfld ctopn
      csn cdif cfv wrex wi simprl wf cfn wex ad2antrr csb simplrr nfcsb1v nfres
      nfov nfcri wceq csbeq1a reseq2d oveq1d eleq2d rspc mpan9 wb ssiun2 cbviun
      syl6sseqr adantl fssres syl2anc simpr nfss sseq1d sylc eqid ellimc2 mpbid
      adantlr simprd simplrl rsp syl3c ralrimiva nfdif nfin nfima nfrex difeq1d
      nfv nfan ineq2d imaeq12d anbi2d rexbidv cbvral sylibr eleq2 ineq1 imaeq2d
      anbi12d ac6sfi crn cint ctop cnfldtop frn ad2antrl wfo adantr dffn4 sylib
      wfn ffn fofi syl indifcom imaeq2i eqtri iunss cnfldtopon toponunii ralimi
      rintopn syl3anc simpl ad2antll ralrn mpbird elrint sylanbrc iunin1 eqtr4i
      imaiun inss2 fnfvelrn sylan intss1 syl5ss ssdifd sslin 3syl inss1 resima2
      imass2 ax-mp sstr2 adantld ralimdva imp syl5eqss rspcev syl12anc exlimddv
      expr mpbir2and ex syl5bi ssrdv eqssd ) AFEUGUHZLBCFDUIZEUGUHZUJZMZUWAUWEN
      AUWALUWDEFUKUWAUWDNUWAUWCNZBCOUWFBCEDFULUMBCUWCUWAUNUOUPUQAUAUWEUWAUAPZUW
      EQUWGLQZUWGUWCQZBCOZRZAUWGUWAQZBLUWGUWCCURAUWKUWLAUWKRZUWLUWHUWGUBPZQZEUC
      PZQZFUWPBCDUSZEVBZVCZMZSZUWNNZRZUCUTVAVDZVEZVFZUBUXEOAUWHUWJVGUWMUXGUBUXE
      UWMUWNUXEQZUWOUXFUWMUXHUWORZRZCUXEUDPZVHZEBPZUXKVDZQZUWBUXNDUWSVCZMZSZUWN
      NZRZBCOZRZUXFUDUXJCVIQZEUEPZQZUWBUYDUXPMZSZUWNNZRZUEUXEVEZBCOZUYBUDVJAUYC
      UWKUXIGVKZUXJUYEFBKPZDVLZUIZUYDUYNUWSVCZMZSZUWNNZRZUEUXEVEZKCOUYKUXJVUAKC
      UXJUYMCQZRZUWOVUAVFZUBUXEOZUXHUWOVUAVUCUWHVUEVUCUWGUYOEUGUHZQZUWHVUERZUXJ
      UWJVUBVUGAUWHUWJUXIVMUWIVUGBUYMCBUAVUFBUYOEUGBFUYNBFTBUYMDVNZVOZBUGTBETVP
      VQUXMUYMVRZUWCVUFUWGVUKUWBUYOEUGVUKDUYNFBUYMDVSZVTZWAWBWCWDUWMVUBVUGVUHWE
      UXIUWMVUBRZUEUBUYNEUWGUYOUXEVUNUWRLFVHZUYNUWRNZUYNLUYOVHAVUOUWKVUBIVKVUBV
      UPUWMVUBUYNKCUYNUSUWRKCUYNWFBKCDUYNKDTVUIVULWGWHWIUWRLUYNFWJWKVUNVUBDLNZB
      COZUYNLNZUWMVUBWLAVURUWKVUBHVKVUQVUSBUYMCBUYNLVUIBLTWMVUKDUYNLVULWNWCWOAE
      LQZUWKVUBJVKUXEWPZWQWSWRWTUWMUXHUWOVUBXAUWMUXHUWOVUBVMVUDUBUXEXBXCXDUYJVU
      ABKCUYJKXJUYTBUEUXEBUXETUYEUYSBUYEBXJBUYRUWNBUYOUYQVUJBUYDUYPBUYDTBUYNUWS
      VUIBUWSTXEXFXGBUWNTWMXKXHVUKUYIUYTUEUXEVUKUYHUYSUYEVUKUYGUYRUWNVUKUWBUYOU
      YFUYQVUMVUKUXPUYPUYDVUKDUYNUWSVULXIXLXMWNXNXOXPXQUYIUXTBUECUXEUDUYDUXNVRZ
      UYEUXOUYHUXSUYDUXNEXRVVBUYGUXRUWNVVBUYFUXQUWBUYDUXNUXPXSXTWNYAYBWKUXJUYBR
      ZLUXKYCZYDZMZUXEQZEVVFQZFVVFUWTMZSZUWNNZUXFVVCUXEYEQZVVDUXENZVVDVIQZVVGVV
      LVVCUXEVVAYFUQUXLVVMUXJUYACUXEUXKYGYHVVCUYCCVVDUXKYIZVVNUXJUYCUYBUYLYJVVC
      UXKCYMZVVOUXLVVPUXJUYACUXEUXKYNZYHZCUXKYKYLCVVDUXKYOWKVVDUXELLUXEUXEVVAUU
      AUUBUUDUUEVVCVUTEUFPZQZUFVVDOZVVHUWMVUTUXIUYBAVUTUWKJYJZVKVVCVWAUXOBCOZUY
      AVWCUXJUXLUXTUXOBCUXOUXSUUFUUCUUGVVCVVPVWAVWCWEVVRVVTUXOUFBCUXKVVSUXNEXRU
      UHYPUUIUFLVVDEUUJUUKVVCVVJBCFDVVFUWSVCZMZSZUSZUWNVVJFBCVWEUSZSVWGVVIVWHFV
      VIUWRVWDMVWHVVFUWRUWSYQBCVWDDUULUUMYRBFCVWEUUNYSVVCVWFUWNNZBCOZVWGUWNNUYB
      VWJUXJUXLUYAVWJUXLUXTVWIBCUXLUXMCQZRZUXSVWIUXOVWLVWFUXRNUXSVWIVFVWLVWFFDU
      XNUWSVCZMZSZUXRVWLVWDVWMNVWEVWNNVWFVWONVWLVVFUXNUWSVWLVVFVVEUXNLVVEUUOVWL
      UXNVVDQZVVEUXNNUXLVVPVWKVWPVVQCUXMUXKUUPUUQUXNVVDUURYPUUSUUTVWDVWMDUVAVWE
      VWNFUVEUVBUXRUWBVWNSZVWOUXQVWNUWBUXNDUWSYQYRVWNDNVWQVWOVRDVWMUVCFVWNDUVDU
      VFYSWHVWFUXRUWNUVGYPUVHUVIUVJWIBCVWFUWNYTXQUVKUXDVVHVVKRUCVVFUXEUWPVVFVRZ
      UWQVVHUXCVVKUWPVVFEXRVWRUXBVVJUWNVWRUXAVVIFUWPVVFUWTXSXTWNYAUVLUVMUVNUVOX
      DUWMUCUBUWREUWGFUXEAVUOUWKIYJAUWRLNZUWKAVURVWSHBCDLYTXQYJVWBVVAWQUVPUVQUV
      RUVSUVT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y F $.  $d x ph $.
    limcun.1 $e |- ( ph -> A C_ CC ) $.
    limcun.2 $e |- ( ph -> B C_ CC ) $.
    limcun.3 $e |- ( ph -> F : ( A u. B ) --> CC ) $.
    $( A point is a limit of ` F ` on ` A u. B ` iff it is the limit of the
       restriction of ` F ` to ` A ` and to ` B ` .  (Contributed by Mario
       Carneiro, 30-Dec-2016.) $)
    limcun $p |- ( ph -> ( F limCC C ) =
      ( ( ( F |` A ) limCC C ) i^i ( ( F |` B ) limCC C ) ) ) $=
      ( vy climc co cres cc wcel wf wss a1i wa adantr cvv vx cin cv cdm limcrcl
      wi simp3d inss1 sseli syl cpr ciin cfn prfi wral cnex ssex ralprg syl2anc
      wb sseq1 mpbir2and ciun cun cuni uniiun uniprg syl5eqr feq2d mpbird simpr
      wceq limciun eleq2d reseq2 oveq1d anbi2d limccl syl6bbr elriin elin bitrd
      pm4.71ri 3bitr4g ex pm5.21ndd eqrdv ) AUAEDJKZEBLZDJKZECLZDJKZUBZADMNZUAU
      CZWHNZWOWMNZWPWNUFAWPEUDZMEOWRMPWNDWOEUEUGQWQWNUFAWQWOWJNZWNWMWJWOWJWLUHU
      IWSWIUDZMWIOWTMPWNDWOWIUEUGUJQAWNWPWQUTAWNRZWPWOMIBCUKZEIUCZLZDJKZULUBZNZ
      WQXAWHXFWOXAIXBXCDEXBUMNXABCUNQXAXCMPZIXBUOZBMPZCMPZAXJWNFSZAXKWNGSZXABTN
      ZCTNZXIXJXKRUTXAXJXNXLBMUPUQUJZXAXKXOXMCMUPUQUJZXHXJXKIBCTTXCBMVAXCCMVAUR
      USVBXAIXBXCVCZMEOBCVDZMEOZAXTWNHSXAXRXSMEXAXRXBVEZXSIXBVFXAXNXOYAXSVLXPXQ
      BCTTVGUSVHVIVJAWNVKVMVNXAWOMNZWOXENZIXBUOZRZWSWOWLNZRZXGWQXAYEYBYGRYGXAYD
      YGYBXAXNXOYDYGUTXPXQYCWSYFIBCTTXCBVLZXEWJWOYHXDWIDJXCBEVOVPVNXCCVLZXEWLWO
      YIXDWKDJXCCEVOVPVNURUSVQYGYBWSYBYFWJMWODWIVRUISWCVSIMWOXEXBVTWOWJWLWAWDWB
      WEWFWG $.
  $}

  ${
    $d x y z A $.  $d x y z F $.  $d x y J $.
    dvlem.1 $e |- ( ph -> F : D --> CC ) $.
    dvlem.2 $e |- ( ph -> D C_ CC ) $.
    dvlem.3 $e |- ( ph -> B e. D ) $.
    $( Closure for a difference quotient.  (Contributed by Mario Carneiro,
       1-Sep-2014.)  (Revised by Mario Carneiro, 9-Feb-2015.) $)
    dvlem $p |- ( ( ph /\ A e. ( D \ { B } ) ) ->
        ( ( ( F ` A ) - ( F ` B ) ) / ( A - B ) ) e. CC ) $=
      ( csn cdif wcel wa cfv cmin co cc adantr ffvelrnd subcld sseldd wf simprl
      wne cdiv eldifsn wss simprr subne0d divcld sylan2b ) BDCIJKABDKZBCUCZLZBE
      MZCEMZNOZBCNOZUDOPKBDCUEAUMLZUPUQURUNUOURDPBEADPEUAUMFQZAUKULUBZRURDPCEUS
      ACDKUMHQZRSURBCURDPBADPUFUMGQZUTTZURDPCVBVATZSURBCVCVDAUKULUGUHUIUJ $.
  $}

  ${
    $d f j s x y z A $.  $d x y z B $.  $d f j s x y z F $.  $d f j s x y J $.
    $d x y z C $.  $d f j s x y z K $.  $d f j s x y z S $.  $d f j s x y T $.
    $d x y G $.
    dvval.t $e |- T = ( K |`t S ) $.
    dvval.k $e |- K = ( TopOpen ` CCfld ) $.
    $( Value and set bounds on the derivative operator.  (Contributed by Mario
       Carneiro, 7-Aug-2014.)  (Revised by Mario Carneiro, 25-Dec-2016.) $)
    dvfval $p |- ( ( S C_ CC /\ F : A --> CC /\ A C_ S ) -> ( ( S _D F ) =
      U_ x e. ( ( int ` T ) ` A ) ( { x } X. ( ( z e. ( A \ { x } ) |->
          ( ( ( F ` z ) - ( F ` x ) ) / ( z - x ) ) ) limCC x ) ) /\
          ( S _D F ) C_ ( ( ( int ` T ) ` A ) X. CC ) ) ) $=
      ( vs vf cc wss co cfv cv cmin cxp wceq crest wf w3a cdv cnt csn cdif cdiv
      cmpt climc ciun cpw cpm cdm ccnfld ctopn cvv cmpt2 df-dv wa oveq1i simprl
      a1i oveq2d syl6eqr syl5eqr fveq2d simprr dmeqd simpl2 fdm fveq12d difeq1d
      syl eqtrd fveq1d oveq12d oveq1d mpteq12dv xpeq2d iuneq12d simpr wcel cnex
      simp1 elpw2 sylibr simp2 simp3 syl22anc wral xpss2 ax-mp rgenw iunxpconst
      elpm2r limccl ss2iun sseqtri fvex xpex ssex ovmpt2dx eqsstrd jca ) DLMZCL
      FUAZCDMZUBZDFUCNZACEUDOZOZAPZUEZBCXMUFZBPZFOZXLFOZQNZXOXLQNZUGNZUHZXLUINZ
      RZUJZSXIXKLRZMXHJKDFLUKZLJPZULNZAKPZUMZUNUOOZYGTNZUDOZOZXMBYJXMUFZXOYIOZX
      LYIOZQNZXSUGNZUHZXLUINZRZUJZYDUCLDULNZUPUCJKYFYHUUCUQSXHABKJURVBXHYGDSZYI
      FSZUSZUSZAYNXKUUBYCUUHYJCYMXJUUHYLEUDUUHYLGYGTNZEGYKYGTIUTUUHUUIGDTNEUUHY
      GDGTXHUUEUUFVAVCHVDVEVFUUHYJFUMZCUUHYIFXHUUEUUFVGZVHUUHXFUUJCSXEXFXGUUGVI
      CLFVJVMVNZVKUUHUUAYBXMUUHYTYAXLUIUUHBYOYSXNXTUUHYJCXMUULVLUUHYRXRXSUGUUHY
      PXPYQXQQUUHXOYIFUUKVOUUHXLYIFUUKVOVPVQVRVQVSVTXHUUEUSYGDLULXHUUEWAVCXHXED
      YFWBZXEXFXGWDDLWCWEWFZXHLUPWBZUUMXFXGFUUDWBUUOXHWCVBUUNXEXFXGWGXEXFXGWHLD
      CFUPYFWOWIXHYDYEMZYDUPWBUUPXHYDAXKXMLRZUJZYEYCUUQMZAXKWJYDUURMUUSAXKYBLMU
      USXLYAWPYBLXMWKWLWMAXKYCUUQWQWLAXKLWNWRVBZYDYEXKLCXJWSWCWTXAVMXBZXHXIYDYE
      UVAUUTXCXD $.

    eldv.g $e |- G = ( z e. ( A \ { B } ) |->
        ( ( ( F ` z ) - ( F ` B ) ) / ( z - B ) ) ) $.
    eldv.s $e |- ( ph -> S C_ CC ) $.
    eldv.f $e |- ( ph -> F : A --> CC ) $.
    eldv.a $e |- ( ph -> A C_ S ) $.
    $( The differentiable predicate.  A function ` F ` is differentiable at
       ` B ` with derivative ` C ` iff ` F ` is defined in a neighborhood of
       ` B ` and the difference quotient has limit ` C ` at ` B ` .
       (Contributed by Mario Carneiro, 7-Aug-2014.)  (Revised by Mario
       Carneiro, 25-Dec-2016.) $)
    eldv $p |- ( ph -> ( B ( S _D F ) C <->
      ( B e. ( ( int ` T ) ` A ) /\ C e. ( G limCC B ) ) ) ) $=
      ( vx co cfv cmin cop cdv wcel cnt cv csn cdif cdiv cmpt climc cxp ciun wa
      wbr wceq cc wss wf dvfval syl3anc simpld eleq2d df-br bicomi sneq difeq2d
      fveq2 oveq2d oveq2 oveq12d mpteq12dv syl6eqr id opeliunxp2 3bitr3g ) ADEU
      AZFHUBRZUCZVPQCGUDSSZQUEZUFZBCWAUGZBUEZHSZVTHSZTRZWCVTTRZUHRZUIZVTUJRZUKU
      LZUCDEVQUNZDVSUCEIDUJRZUCUMAVQWKVPAVQWKUOZVQVSUPUKUQZAFUPUQCUPHURCFUQWNWO
      UMNOPQBCFGHJKLUSUTVAVBWLVRDEVQVCVDQVSWJDEWMVTDUOZWIIVTDUJWPWIBCDUFZUGZWDD
      HSZTRZWCDTRZUHRZUIIWPBWBWHWRXBWPWAWQCVTDVEVFWPWFWTWGXAUHWPWEWSWDTVTDHVGVH
      VTDWCTVIVJVKMVLWPVMVJVNVO $.
  $}

  ${
    $d x z A $.  $d z B $.  $d z C $.  $d x z F $.  $d x z K $.  $d x z S $.
    $d x J $.
    dvcl.s $e |- ( ph -> S C_ CC ) $.
    dvcl.f $e |- ( ph -> F : A --> CC ) $.
    dvcl.a $e |- ( ph -> A C_ S ) $.
    $( The derivative function takes values in the complex numbers.
       (Contributed by Mario Carneiro, 7-Aug-2014.)  (Revised by Mario
       Carneiro, 9-Feb-2015.) $)
    dvcl $p |- ( ( ph /\ B ( S _D F ) C ) -> C e. CC ) $=
      ( vz cdv co wbr wa csn cdif cfv cmin wcel eqid cv cdiv cmpt limccl ccnfld
      climc cc ctopn crest cnt eldv simplbda sseldi ) ACDEFKLMZNJBCOPJUAZFQCFQR
      LUOCRLUBLUCZCUFLZUGDCUPUDAUNCBUEUHQZEUILZUJQQSDUQSAJBCDEUSFUPURUSTURTUPTG
      HIUKULUM $.

    ${
      dvbssntr.j $e |- J = ( K |`t S ) $.
      dvbssntr.k $e |- K = ( TopOpen ` CCfld ) $.
      $( The set of differentiable points is a subset of the interior of the
         domain of the function.  (Contributed by Mario Carneiro, 7-Aug-2014.)
         (Revised by Mario Carneiro, 9-Feb-2015.) $)
      dvbssntr $p |- ( ph -> dom ( S _D F ) C_ ( ( int ` J ) ` A ) ) $=
        ( vx vz co cdm cfv cc cxp wss cv cdv cnt cdif cmin cdiv cmpt climc ciun
        csn wceq wf wa dvfval syl3anc simprd dmss syl dmxpss syl6ss ) ACDUANZOZ
        BEUBPPZQRZOZVBAUTVCSZVAVDSAUTLVBLTZUIZMBVGUCMTZDPVFDPUDNVHVFUDNUENUFVFU
        GNRUHUJZVEACQSBQDUKBCSVIVEULGHILMBCEDFJKUMUNUOUTVCUPUQVBQURUS $.
    $}

    $( The set of differentiable points is a subset of the domain of the
       function.  (Contributed by Mario Carneiro, 6-Aug-2014.)  (Revised by
       Mario Carneiro, 9-Feb-2015.) $)
    dvbss $p |- ( ph -> dom ( S _D F ) C_ A ) $=
      ( cdv co cdm ccnfld cfv eqid ctop wcel wss cvv cc sylancr ctopon dvbssntr
      ctopn crest cuni cnfldtop cnex ssexg sylancl resttop cnfldtopon resttopon
      cnt wceq toponuni syl sseqtrd ntrss2 syl2anc sstrd ) ACDHIJBKUBLZCUCIZULL
      LZBABCDVAUTEFGVAMUTMZUAAVANOZBVAUDZPVBBPAUTNOCQOZVDUTVCUEACRPZRQOVFEUFCRQ
      UGUHCUTQUISABCVEGAVACTLOZCVEUMAUTRTLOVGVHUTVCUJECUTRUKSCVAUNUOUPBVAVEVEMU
      QURUS $.
  $}

  ${
    $d f j s x y z F $.  $d s S $.
    $( The set of differentiable points is a subset of the ambient topology.
       (Contributed by Mario Carneiro, 18-Mar-2015.) $)
    dvbsss $p |- dom ( S _D F ) C_ S $=
      ( vs vf vx vz cop cdv cdm wcel co wss cc cpm cvv wa cxp cv cfv c0 cpw cnt
      wrel ccnfld ctopn crest csn cdif cmin cdiv cmpt climc ciun reldmmpt2 mpbi
      df-dv df-rel sseli opelxp1 syl wi opeq1 eleq1d eleq1 oveq2 eleq2d anbi12d
      imbi12d dmmpt2ssx opeliunxp sylib vtoclg mpcom simpld elpwid wf simprd wb
      wceq elpm2g sylancr mpbid dvbss sstrd df-ov ndmfv syl5eq dmeqd dm0 syl6eq
      cnex wn 0ss syl6eqss pm2.61i ) ABGZHIZJZABHKZIZALWRWTBIZAWRXAABWRAMWRAMUA
      ZJZBMANKZJZAOJZWRXCXEPZWRWPOOQZJXFWQXHWPWQUCWQXHLCDXBMCRZNKZEDRZIZUDUESXI
      UFKUBSSERZUGZFXLXNUHFRZXKSXMXKSUIKXOXMUIKUJKUKXMULKQUMZHEFDCUPZUNWQUQUOUR
      ABOOUSUTXIBGZWQJZXIXBJZBXJJZPZVAWRXGVACAOXIAVSZXSWRYBXGYCXRWPWQXIABVBVCYC
      XTXCYAXEXIAXBVDYCXJXDBXIAMNVEVFVGVHXSXRCXBXIUGXJQUMZJYBWQYDXRCDXBXJXPHXQV
      IURCXBXJBVJVKVLVMZVNZVOWRXAMBVPZXAALZWRXEYGYHPZWRXCXEYEVQWRMOJXCXEYIVRWKY
      FMABOXBVTWAWBZVNWRYGYHYJVQZWCYKWDWRWLZWTTAYLWTTITYLWSTYLWSWPHSTABHWEWPHWF
      WGWHWIWJAWMWNWO $.
  $}

  ${
    $d f s x z $.  $d s x y z F $.  $d x y z K $.  $d s x y z S $.
    perfdvf.1 $e |- K = ( TopOpen ` CCfld ) $.
    $( The derivative is a function, whenever it is defined relative to a
       perfect subset of the complex numbers.  (Contributed by Mario Carneiro,
       25-Dec-2016.) $)
    perfdvf $p |- ( ( K |`t S ) e. Perf ->
                  ( S _D F ) : dom ( S _D F ) --> CC ) $=
      ( vx vy vz vs cdv cdm wcel co cc wa wss cv cfv sylancr eqid c0 vf cop wfn
      crest cperf wf crn wfun wbr wmo wal cnt csn cdif cmin cdiv cmpt climc cpm
      wi cpw cxp ciun ccnfld ctopn df-dv dmmpt2ssx simpl oveq2 opeliunxp2 sylib
      sseldi simprd cvv cnex simpld elpm2g mpbid adantr sseli elpwid sstrd ctop
      wb cuni ctopon cnfldtopon resttopon topontop wceq toponuni sseqtrd ntrss2
      syl syl2anc sselda dvlem ssdifssd clp a1i ntrss3 sseqtr4d restabs syl3anc
      fmptd simpr perfopn eqeltrrd cnfldtop toponunii restperf lpss3 lpdifsn ex
      ntropn limcmo moanimv sylibr eldv mobidv mpbird alrimiv wrel reldv dffun6
      mpbiran funfn wex vex elrn dvcl exlimdv syl5bi ssrdv sylanbrc wn f0 df-ov
      df-f ndmfv syl5eq dmeqd dm0 syl6eq feq12d mpbiri a1d pm2.61i ) ABUBZIJZKZ
      CAUDLZUEKZABILZJZMUUNUFZUTUUKUUMUUPUUKUUMNZUUNUUOUCZUUNUGZMOUUPUUQUUNUHZU
      URUUQEPZFPZUUNUIZFUJZEUKZUUTUUQUVDEUUQUVDUVABJZUULULQQZKZUVBGUVFUVAUMZUNZ
      GPZBQUVABQUOLUVKUVAUOLZUPLZUQZUVAURLKZNZFUJZUUQUVHUVOFUJZUTUVQUUQUVHUVRUU
      QUVHNZFUVJUVAUVNCUVSGUVJUVMMUVNUVSUVKUVAUVFBUUQUVFMBUFZUVHUUQUVTUVFAOZUUQ
      BMAUSLZKZUVTUWANZUUQAMVAZKZUWCUUQUUIHUWEHPZUMMUWGUSLZVBVCZKZUWFUWCNZUUQUU
      JUWIUUIHUAUWEUWHEUAPZJZVDVEQUWGUDLULQQUVIGUWMUVIUNUVKUWLQUVAUWLQUOLUVLUPL
      UQUVAURLVBVCIEGUAHVFVGZUUKUUMVHVLHUWEUWHABUWBUWGAMUSVIVJZVKZVMUUQMVNKZUWF
      UWCUWDWDZVOUUQUWFUWCUWPVPZMABVNUWEVQZRVRVPZVSUUQUVFMOZUVHUUQUVFAMUUKUWAUU
      MUUKUVTUWAUUKUWCUWDUUKUWFUWCUUKUWJUWKUUJUWIUUIUWNVTUWOVKZVMUUKUWQUWFUWRVO
      UUKUWFUWCUXCVPUWTRVRVMVSZUUQAMUWSWAZWBZVSZUUQUVGUVFUVAUUQUULWCKZUVFUULWEZ
      OZUVGUVFOZUUQUULAWFQKZUXHUUQCMWFQZKZAMOUXLCDWGZUXEACMWHRZAUULWIWNZUUQUVFA
      UXIUXDUUQUXLAUXIWJUXPAUULWKWNZWLZUVFUULUXIUXISZWMWOZWPWQUVNSZXEUVSUVFMUVI
      UXGWRUVSUVAUVFCWSQZQZKZUVAUVJUYCQKZUUQUVGUYDUVAUUQUVGUVGUYCQZUYDUUQCUVGUD
      LZUEKZUVGUYGOZUUQUULUVGUDLZUYHUEUUQUXNUVGAOUWFUYKUYHWJUXNUUQUXOWTUUQUVGUX
      IAUUQUXHUXJUVGUXIOUXQUXSUVFUULUXIUXTXAWOUXRXBZUWSUVGACUXMUWEXCXDUUQUUMUVG
      UULKZUYKUEKUUKUUMXFUUQUXHUXJUYMUXQUXSUVFUULUXIUXTXOWOUULUYKUXIUVGUXTUYKSX
      GWOXHUUQCWCKZUVGMOUYIUYJWDCDXIZUUQUVGAMUYLUXEWBCUYHMUVGMCUXOXJZUYHSXKRVRU
      UQUYNUXBUXKUYGUYDOUYNUUQUYOWTUXFUYAUVFUVGCMUYPXLXDWBWPUVSUYNUXBUYEUYFWDUY
      OUXGUVAUVFCMUYPXMRVRDXPXNUVHUVOFXQXRUUQUVCUVPFUUQGUVFUVAUVBAUULBUVNCUULSD
      UYBUXEUXAUXDXSXTYAYBUUTUUNYCUVEABYDEFUUNYEYFXRUUNYGVKUUQFUUSMUVBUUSKUVCEY
      HUUQUVBMKZEUVBUUNFYIYJUUQUVCUYQEUUQUVCUYQUUQUVFUVAUVBABUXEUXAUXDYKXNYLYMY
      NUUOMUUNYSYOXNUUKYPZUUPUUMUYRUUPTMTUFMYQUYRUUOTMUUNTUYRUUNUUIIQTABIYRUUII
      YTUUAZUYRUUOTJTUYRUUNTUYSUUBUUCUUDUUEUUFUUGUUH $.
  $}

  $( Both ` RR ` and ` CC ` are subsets of ` CC ` .  (Contributed by Mario
     Carneiro, 10-Feb-2015.) $)
  recnprss $p |- ( S e. { RR , CC } -> S C_ CC ) $=
    ( cr cc cpr wcel wceq wo wss elpri ax-resscn sseq1 mpbiri eqimss jaoi syl )
    ABCDEABFZACFZGACHZABCIPRQPRBCHJABCKLACMNO $.

  ${
    recnperf.k $e |- K = ( TopOpen ` CCfld ) $.
    $( Both ` RR ` and ` CC ` are perfect subsets of ` CC ` .  (Contributed by
       Mario Carneiro, 28-Dec-2016.) $)
    recnperf $p |- ( S e. { RR , CC } -> ( K |`t S ) e. Perf ) $=
      ( cr cc cpr wcel wo crest co cperf elpri oveq2 reperf syl6eqel ctopon cfv
      wceq cnfldtopon toponunii restid ax-mp cnperf eqeltri jaoi syl ) ADEFGADR
      ZAERZHBAIJZKGZADELUGUJUHUGUIBDIJKADBIMBCNOUHUIBEIJZKAEBIMUKBKBEPQZGUKBRBC
      SZBULEEBUMTUAUBBCUCUDOUEUF $.
  $}

  $( Explicitly write out the functionality condition on derivative for
     ` S = RR ` and ` CC ` .  (Contributed by Mario Carneiro, 9-Feb-2015.) $)
  dvfg $p |- ( S e. { RR , CC } -> ( S _D F ) : dom ( S _D F ) --> CC ) $=
    ( cr cc cpr wcel ccnfld ctopn cfv crest cperf cdv cdm eqid recnperf perfdvf
    co wf syl ) ACDEFGHIZAJQKFABLQZMDUARATTNZOABTUBPS $.

  ${
    $d n w x y z A $.  $d n w x y z F $.
    $( The derivative is a function.  (Contributed by Mario Carneiro,
       8-Aug-2014.)  (Revised by Mario Carneiro, 9-Feb-2015.) $)
    dvf $p |- ( RR _D F ) : dom ( RR _D F ) --> CC $=
      ( cr cc cpr wcel cdv co cdm wf reex prid1 dvfg ax-mp ) BBCDEBAFGZHCNIBCJK
      BALM $.

    $( The derivative is a function.  (Contributed by Mario Carneiro,
       9-Feb-2015.) $)
    dvfcn $p |- ( CC _D F ) : dom ( CC _D F ) --> CC $=
      ( cc cr cpr wcel cdv co cdm wf cnex prid2 dvfg ax-mp ) BCBDEBAFGZHBNICBJK
      BALM $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z S $.  $d x y z T $.
    $d z K $.  $d z ph $.
    dvres.k $e |- K = ( TopOpen ` CCfld ) $.
    dvres.t $e |- T = ( K |`t S ) $.
    ${
      dvres.g $e |- G = ( z e. ( A \ { x } ) |->
        ( ( ( F ` z ) - ( F ` x ) ) / ( z - x ) ) ) $.
      dvres.s $e |- ( ph -> S C_ CC ) $.
      dvres.f $e |- ( ph -> F : A --> CC ) $.
      dvres.a $e |- ( ph -> A C_ S ) $.
      dvres.b $e |- ( ph -> B C_ S ) $.
      dvres.y $e |- ( ph -> y e. CC ) $.
      $( Lemma for ~ dvres .  (Contributed by Mario Carneiro, 8-Aug-2014.)
         (Revised by Mario Carneiro, 28-Dec-2016.) $)
      dvreslem $p |- ( ph -> ( x ( S _D ( F |` B ) ) y <->
        ( x ( S _D F ) y /\ x e. ( ( int ` T ) ` B ) ) ) ) $=
        ( cfv cv cin cnt wcel csn cdif cres cmin co cdiv cmpt climc wa cdv wceq
        wbr difss inss2 sstri simpr sseldi fvres syl ctop cuni wss cvv cnfldtop
        crest cc ssexg sylancl resttop sylancr syl5eqel inss1 syl5ss cnfldtopon
        cnex ctopon resttopon toponuni sseqtrd eqid ntrss2 syl6ss sselda adantr
        syl2anc oveq12d oveq1d mpteq2dva reseq1i ssdif resmpt eqtri syl6eqr cun
        mp2b wf sstrd dvlem fmptd mp1i difssd unssd ssun1 ntrss syl3anc restntr
        a1i ssind oveq1i restabs syl5eq fveq2d fveq1d eqtr3d undif1 snssd sylib
        ssequn2 oveq2d fveq12d eleqtrrd eqtrd eleq2d pm5.32da ntrin elin syl6bb
        limcres anbi1d bitrd an32 fresin eldv 3bitr4d ) ABUAZEFUBZHUCTZTZUDZCUA
        ZDYTYSUEZUFZDUAZIFUGZTZYSUUHTZUHUIZUUGYSUHUIZUJUIZUKZYSULUIZUDZUMZYSEUU
        ATZUDZUUDJYSULUIZUDZUMZYSFUUATZUDZUMZYSUUDGUUHUNUIUPYSUUDGIUNUIUPZUVDUM
        AUUQUUSUVDUMZUVAUMZUVEAUUQUUCUVAUMUVHAUUCUUPUVAAUUCUMZUUOUUTUUDUVIUUOJU
        UFUGZYSULUIUUTUVIUUNUVJYSULUVIUUNDUUFUUGITZYSITZUHUIZUULUJUIZUKZUVJUVID
        UUFUUMUVNUVIUUGUUFUDZUMZUUKUVMUULUJUVQUUIUVKUUJUVLUHUVQUUGFUDUUIUVKUOUV
        QUUFFUUGUUFYTFYTUUEUQEFURZUSUVIUVPUTVAUUGFIVBVCUVIUUJUVLUOZUVPUVIYSFUDU
        VSAUUBFYSAUUBYTFAHVDUDZYTHVEZVFUUBYTVFAHKGVIUIZVDMAKVDUDZGVGUDZUWBVDUDK
        LVHZAGVJVFZVJVGUDUWDOVSGVJVGVKVLZGKVGVMVNVOZAYTGUWAAYTEGEFVPZQVQZAHGVTT
        ZUDGUWAUOAHUWBUWKMAKVJVTTUDUWFUWBUWKUDKLVROGKVJWAVNVOGHWBVCZWCZYTHUWAUW
        AWDZWEWIZUVRWFWGYSFIVBVCWHWJWKWLUVJDEUUEUFZUVNUKZUUFUGZUVOJUWQUUFNWMYTE
        VFZUUFUWPVFZUWRUVOUOUWIYTEUUEWNZDUWPUUFUVNWOWSWPWQWKUVIUWPYSUUFJKUWPUUE
        WRZVIUIZKUVIDUWPUVNVJJUVIUUGYSEIAEVJIWTZUUCPWHAEVJVFUUCAEGVJQOXAWHZAUUB
        EYSAUUBYTEUWOUWIWFZWGXBNXCUWSUWTUVIUWIUXAXDUVIUWPEVJEUUEUQUXEVQLUXCWDUV
        IYSYTKEVIUIZUCTZTZUUFUUEWRZUXCUCTZTAUUBUXIYSAUUBYTUWAEUFZWRZUUATZEUBZUX
        IAUUBUXNEAUVTUXMUWAVFYTUXMVFZUUBUXNVFUWHAYTUXLUWAUWMAUWAEXEXFUXPAYTUXLX
        GXKUXMYTHUWAUWNXHXIUXFXLAYTHEVIUIZUCTZTZUXOUXIAUVTEUWAVFZUWSUXSUXOUOUWH
        AEGUWAQUWLWCZUWSAUWIXKYTHUXQUWAEUWNUXQWDXJXIAYTUXRUXHAUXQUXGUCAUXQUWBEV
        IUIZUXGHUWBEVIMXMAUWCEGVFUWDUYBUXGUOUWCAUWEXKQUWGEGKVDVGXNXIXOXPXQXRWCW
        GUVIUXJYTUXKUXHUVIUXCUXGUCUVIUXBEKVIUVIUXBEUUEWRZEEUUEXSUVIUUEEVFUYCEUO
        UVIUUEYTEUVIYSYTAUUBYTYSUWOWGXTZUWIWFUUEEYBYAXOYCXPUVIUXJYTUUEWRZYTYTUU
        EXSUVIUUEYTVFUYEYTUOUYDUUEYTYBYAXOYDYEYLYFYGYHAUUCUVGUVAAUUCYSUURUVCUBZ
        UDUVGAUUBUYFYSAUVTUXTFUWAVFUUBUYFUOUWHUYAAFGUWARUWLWCEFHUWAUWNYIXIYGYSU
        URUVCYJYKYMYNUUSUVDUVAYOYKADYTYSUUDGHUUHUUNKMLUUNWDOAUXDYTVJUUHWTPEVJIF
        YPVCUWJYQAUVFUVBUVDADEYSUUDGHIJKMLNOPQYQYMYR $.

      dvres2lem.d $e |- ( ph -> x ( S _D F ) y ) $.
      dvres2lem.x $e |- ( ph -> x e. B ) $.
      $( Lemma for ~ dvres2 .  (Contributed by Mario Carneiro, 9-Feb-2015.)
         (Revised by Mario Carneiro, 28-Dec-2016.) $)
      dvres2lem $p |- ( ph -> x ( B _D ( F |` B ) ) y ) $=
        ( cv cres cdv wbr cin crest cnt cfv wcel cdif cmin cdiv cmpt climc cuni
        co csn cun ctop wss cvv cnfldtop cc cnex ssexg sylancl resttop syl5eqel
        sylancr syl5ss ctopon wceq cnfldtopon resttopon toponuni sseqtrd difssd
        inss1 syl unssd inundif ssdif unss2 3syl syl5eqssr eqid syl3anc wa eldv
        ntrss mpbid simpld sseldd elin sylanbrc inss2 a1i restntr oveq1i syl5eq
        restabs fveq2d fveq1d eqtr3d eleqtrd limcresi simprd sseldi difss sstri
        sseli fvres oveqan12rd oveq1d sylan2 reseq1i resmpt mp2b eqtri eleqtrrd
        mpteq2dva syl6eqr sstrd wf fresin mpbir2and ) ABUBZCUBZFIFUCZUDUQUEYHEF
        UFZKFUGUQZUHUIZUIZUJYIDYKYHURZUKZDUBZYJUIZYHYJUIZULUQZYQYHULUQZUMUQZUNZ
        YHUOUQZUJAYHYKHUPZFUKZUSZHUHUIZUIZFUFZYNAYHUUIUJYHFUJZYHUUJUJAEUUHUIZUU
        IYHAHUTUJZUUGUUEVAEUUGVAUULUUIVAAHKGUGUQZUTMAKUTUJZGVBUJZUUNUTUJKLVCZAG
        VDVAZVDVBUJUUPOVEGVDVBVFVGZGKVBVHVJVIZAYKUUFUUEAYKGUUEAYKEGEFVSZQVKAHGV
        LUIZUJGUUEVMAHUUNUVBMAKVDVLUIUJUURUUNUVBUJKLVNOGKVDVOVJVIGHVPVTZVQAUUEF
        VRWAAEYKEFUKZUSZUUGEFWBAEUUEVAUVDUUFVAUVEUUGVAAEGUUEQUVCVQEUUEFWCUVDUUF
        YKWDWEWFUUGEHUUEUUEWGZWKWHAYHUULUJZYIJYHUOUQZUJZAYHYIGIUDUQUEUVGUVIWITA
        DEYHYIGHIJKMLNOPQWJWLZWMWNUAYHUUIFWOWPAYKHFUGUQZUHUIZUIZUUJYNAUUMFUUEVA
        YKFVAZUVMUUJVMUUTAFGUUERUVCVQUVNAEFWQZWRZYKHUVKUUEFUVFUVKWGWSWHAYKUVLYM
        AUVKYLUHAUVKUUNFUGUQZYLHUUNFUGMWTAUUOFGVAUUPUVQYLVMUUOAUUQWRRUUSFGKUTVB
        XBWHXAXCXDXEXFAYIJYPUCZYHUOUQZUUDAUVHUVSYIYHYPJXGAUVGUVIUVJXHXIAUUCUVRY
        HUOAUUCDYPYQIUIZYHIUIZULUQZUUAUMUQZUNZUVRADYPUUBUWCYQYPUJAYQFUJZUUBUWCV
        MYPFYQYPYKFYKYOXJUVOXKXLAUWEWIYTUWBUUAUMUWEAYRUVTYSUWAULYQFIXMAUUKYSUWA
        VMUAYHFIXMVTXNXOXPYBUVRDEYOUKZUWCUNZYPUCZUWDJUWGYPNXQYKEVAYPUWFVAUWHUWD
        VMUVAYKEYOWCDUWFYPUWCXRXSXTYCXOYAADYKYHYIFYLYJUUCKYLWGLUUCWGAFGVDROYDAE
        VDIYEYKVDYJYEPEVDIFYFVTUVPWJYG $.
    $}

    $( Restriction of a derivative.  Note that our definition of derivative
       ~ df-dv would still make sense if we demanded that ` x ` be an element
       of the domain instead of an interior point of the domain, but then it is
       possible for a non-differentiable function to have two different
       derivatives at a single point ` x ` when restricted to different subsets
       containing ` x ` ; a classic example is the absolute value function
       restricted to ` [ 0 , +oo ) ` and ` ( -oo , 0 ] ` .  (Contributed by
       Mario Carneiro, 8-Aug-2014.)  (Revised by Mario Carneiro,
       9-Feb-2015.) $)
    dvres $p |- ( ( ( S C_ CC /\ F : A --> CC ) /\ ( A C_ S /\ B C_ S ) ) ->
      ( S _D ( F |` B ) ) = ( ( S _D F ) |` ( ( int ` T ) ` B ) ) ) $=
      ( vx vy vz cc wss wf wa cres co cfv cv wbr cdv cnt relres wcel cin simpll
      reldv simplr inss1 fssres sylancl resres wfn wceq fnresdm reseq1d syl5eqr
      ffn 3syl feq1d mpbid simprl syl5ss dvcl ex adantrd wb cdif cmin cdiv cmpt
      csn eqid adantr simplrr simpr dvreslem pm5.21ndd brres syl6bbr eqbrrdiv
      vex ) CLMZALENZOZACMZBCMZOZOZIJCEBPZUAQZCEUAQZBDUBRRZPZCWJUGWLWMUCWIISZJS
      ZWKTZWOWPWLTZWOWMUDZOZWOWPWNTWIWPLUDZWQWTWIWQXAWIABUEZWOWPCWJWCWDWHUFZWIX
      BLEXBPZNZXBLWJNWIWDXBAMXEWCWDWHUHZABUIZALXBEUJUKWIXBLXDWJWIXDEAPZBPWJEABU
      LWIXHEBWIWDEAUMXHEUNXFALEURAEUOUSUPUQUTVAWIXBACXGWEWFWGVBZVCVDVEWIWRXAWSW
      IWRXAWIAWOWPCEXCXFXIVDVEVFWIXAWQWTVGWIXAOIJKABCDEKAWOVLVHKSZERWOERVIQXJWO
      VIQVJQVKZFGHXKVMWIWCXAXCVNWIWDXAXFVNWIWFXAXIVNWEWFWGXAVOWIXAVPVQVEVRWOWPW
      LWMJWBVSVTWA $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z S $.
    $( Restriction of the base set of a derivative.  The primary application of
       this theorem says that if a function is complex differentiable then it
       is also real differentiable.  Unlike ~ dvres , there is no simple
       reverse relation relating real differentiable functions to complex
       differentiability, and indeed there are functions like ` Re ( x ) `
       which are everywhere real-differentiable but nowhere
       complex-differentiable.)  (Contributed by Mario Carneiro,
       9-Feb-2015.) $)
    dvres2 $p |- ( ( ( S C_ CC /\ F : A --> CC ) /\ ( A C_ S /\ B C_ S ) ) ->
      ( ( S _D F ) |` B ) C_ ( B _D ( F |` B ) ) ) $=
      ( vx vy vz cc wss wa cdv co cres cv wbr wcel cfv cmin eqid df-br wrel a1i
      relres cop w3a ccnfld ctopn crest csn cdif cdiv cmpt simp1l simp1r simp2l
      simp2r simp3l dvcl mpdan simp3r dvres2lem 3expia vex brres bitr3i 3imtr3g
      wf relssdv ) CHIZAHDVGZJZACIZBCIZJZJZEFCDKLZBMZBDBMKLZVQUAVOVPBUCUBVOENZF
      NZVPOZVSBPZJZVSVTVROZVSVTUDZVQPZWEVRPVKVNWCWDVKVNWCUEZEFGABCUFUGQZCUHLZDG
      AVSUIUJGNZDQVSDQRLWJVSRLUKLULZWHWHSWISWKSVIVJVNWCUMZVIVJVNWCUNZVKVLVMWCUO
      ZVKVLVMWCUPWGWAVTHPVKVNWAWBUQZWGAVSVTCDWLWMWNURUSWOVKVNWAWBUTVAVBWCVSVTVQ
      OWFVSVTVPBFVCVDVSVTVQTVEVSVTVRTVFVH $.
  $}

  $( Restriction of a complex differentiable function to the reals.
     (Contributed by Mario Carneiro, 10-Feb-2015.) $)
  dvres3 $p |- ( ( ( S e. { RR , CC } /\ F : A --> CC ) /\
    ( A C_ CC /\ S C_ dom ( CC _D F ) ) ) ->
      ( S _D ( F |` S ) ) = ( ( CC _D F ) |` S ) ) $=
    ( cr cc cpr wcel wf wa wss cdv co cdm cres wceq ad2antrr ssid dvbss syl2anc
    a1i reldv recnprss simplr simprr simprl sstrd fssres ssdmres sylib sseqtr4d
    wrel relssres sylancr wfun dvfg ffun syl dvres2 syl22anc funssres eqtr3d )
    BDEFGZAECHZIZAEJZBECKLZMZJZIZIZBCBNZKLZVFBNZMZNZVLVMVJVLUKVLMZVNJVOVLOBVKUA
    VJVPBVNVJBBVKVBBEJZVCVIBUBPZVJVCBAJBEVKHVBVCVIUCZVJBVGAVDVEVHUDZVJAECEEJZVJ
    EQTZVSVDVEVHUEZRUFAEBCUGSBBJVJBQTRVJVHVNBOVTBVFUHUIUJVLVNULUMVJVLUNZVMVLJZV
    OVMOVJVPEVLHZWDVBWFVCVIBVKUOPVPEVLUPUQVJWAVCVEVQWEWBVSWCVRABECURUSVLVMUTSVA
    $.

  ${
    dvres3a.j $e |- J = ( TopOpen ` CCfld ) $.
    $( Restriction of a complex differentiable function to the reals.  This
       version of ~ dvres3 assumes that ` F ` is differentiable on its domain,
       but does not require ` F ` to be differentiable on the whole real line.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    dvres3a $p |- ( ( ( S e. { RR , CC } /\ F : A --> CC ) /\
      ( A e. J /\ dom ( CC _D F ) = A ) ) ->
        ( S _D ( F |` S ) ) = ( ( CC _D F ) |` S ) ) $=
      ( cr cc wcel wf wa cdv co cdm wceq cres wss cin ad2antrr a1i sylancr wrel
      cpr reldv simplr inss2 fssres sylancl rescom resres eqtri wfn ffn fnresdm
      recnprss 3syl reseq1d syl5eqr feq1d mpbid inss1 dvbss dmres simprr ineq2d
      syl5eq sseqtr4d relssres wfun dvfg ffun syl ssid ctopon cnfldtopon simprl
      cfv toponss dvres2 syl22anc funssres syl2anc eqtr3d ) BFGUBHZAGCIZJZADHZG
      CKLZMZANZJZJZBCBOZKLZWGBOZMZOZWMWNWKWMUAWMMZWOPWPWMNBWLUCWKWQBAQZWOWKWRBW
      LWCBGPZWDWJBUNRZWKWRGCWROZIZWRGWLIWKWDWRAPXBWCWDWJUDZBAUEAGWRCUFUGWKWRGXA
      WLWKXACAOZBOZWLXEWLAOXACABUHCBAUIUJWKXDCBWKWDCAUKXDCNXCAGCULACUMUOUPUQURU
      SWRBPWKBAUTSVAWKWOBWHQWRWGBVBWKWHABWEWFWIVCVDVEVFWMWOVGTWKWMVHZWNWMPZWPWN
      NWKWQGWMIZXFWCXHWDWJBWLVIRWQGWMVJVKWKGGPZWDAGPZWSXGXIWKGVLSXCWKDGVMVPHWFX
      JDEVNWEWFWIVOADGVQTWTABGCVRVSWMWNVTWAWB $.
  $}

  ${
    $d x z B $.  $d x z F $.  $d x z ph $.
    dvidlem.1 $e |- ( ph -> F : CC --> CC ) $.
    dvidlem.2 $e |- ( ( ph /\ ( x e. CC /\ z e. CC /\ z =/= x ) ) ->
                  ( ( ( F ` z ) - ( F ` x ) ) / ( z - x ) ) = B ) $.
    dvidlem.3 $e |- B e. CC $.
    $( Lemma for ~ dvid and ~ dvconst .  (Contributed by Mario Carneiro,
       8-Aug-2014.)  (Revised by Mario Carneiro, 9-Feb-2015.) $)
    dvidlem $p |- ( ph -> ( CC _D F ) = ( CC X. { B } ) ) $=
      ( cc co csn wf wfn a1i wcel cfv cmpt climc wceq ax-mp cdv cxp dvfcn dvbss
      cdm wss ssid cv wrel wbr reldv ccnfld ctopn cnt cdif cmin cdiv simpr ctop
      wa cnfldtop cnfldtopon toponunii ntrtop syl6eleqr limcresi ccncf cncfmptc
      eqid syl3anc eqidd cnmptlimc sseldi eldifsn 3exp2 imp43 sylan2b mpteq2dva
      cres difss resmpt syl6eqr oveq1d eleqtrrd crest restid eqcomi adantr eldv
      wne mpbir2and releldm sylancr ex ssrdv eqssd feq2d mpbii ffn syl fnconstg
      mp1i wfun wb ffun funbrfvb syl2anc mpbird fvconst2g sylan eqtr4d eqfnfvd
      ) ABIIEUAJZIDKUBZAIIXMLZXMIMAXMUEZIXMLZXOEUCZAXPIIXMAXPIAIIEIIUFZAIUGZNZF
      YAUDABIXPABUHZIOZYBXPOZAYCUTZXMUIYBDXMUJZYDIEUKYEYFYBIULUMPZUNPPZODCIYBKZ
      UOZCUHZEPYBEPUPJYKYBUPJUQJZQZYBRJZOYEYBIYHAYCURZYGUSOZYHISYGYGVIZVAZYGIIY
      GYGYQVBVCZVDTVEYEDCIDQZYJVSZYBRJZYNYEYTYBRJUUBDYBYJYTVFYECIYBIDDYEDIOZXSX
      SYTIIVGJOUUCYEHNXSYEXTNZUUDCDIIVHVJYOYKYBSDVKVLVMYEYMUUAYBRYEYMCYJDQZUUAY
      ECYJYLDYKYJOYEYKIOZYKYBWJZUTYLDSZYKIYBVNAYCUUFUUGUUHAYCUUFUUGUUHGVOVPVQVR
      YJIUFUUAUUESIYIVTCIYJDWATWBWCWDYECIYBDIYGEYMYGYGIWEJZYGYPUUIYGSYRYGUSIYSW
      FTWGYQYMVIUUDAIIELYCFWHUUDWIWKZYBDXMWLWMZWNWOWPWQWRIIXMWSWTUUCXNIMAHIDIXA
      XBYEYBXMPZDYBXNPZYEUULDSZYFUUJYEXMXCZYDUUNYFXDXQUUOYEXRXPIXMXEXBUUKYBDXMX
      FXGXHAUUCYCUUMDSUUCAHNIDYBIXIXJXKXL $.
  $}

  ${
    $d x z A $.
    $( Derivative of a constant function.  (Contributed by Mario Carneiro,
       8-Aug-2014.)  (Revised by Mario Carneiro, 9-Feb-2015.) $)
    dvconst $p |- ( A e. CC -> ( CC _D ( CC X. { A } ) ) = ( CC X. { 0 } ) ) $=
      ( vx vz cc wcel cc0 csn cxp fconst6g cv wne w3a wa cmin co cdiv fvconst2g
      cfv wceq eqtrd simpr2 syldan 3ad2antr1 oveq12d subid adantr oveq1d simpr1
      subcld simpr3 subne0d div0d 0cn dvidlem ) ADEZBCFDAGHZDADIUOBJZDEZCJZDEZU
      SUQKZLZMZUSUPRZUQUPRZNOZUSUQNOZPOFVGPOFVCVFFVGPVCVFAANOZFVCVDAVEANUOVBUTV
      DASUOURUTVAUAZDAUSDQUBUOUTURVEASVADAUQDQUCUDUOVHFSVBAUEUFTUGVCVGVCUSUQVIU
      OURUTVAUHZUIVCUSUQVIVJUOURUTVAUJUKULTUMUN $.

    $( Derivative of the identity function.  (Contributed by Mario Carneiro,
       8-Aug-2014.)  (Revised by Mario Carneiro, 9-Feb-2015.) $)
    dvid $p |- ( CC _D ( _I |` CC ) ) = ( CC X. { 1 } ) $=
      ( vx vz cc cid cres cdv co c1 csn cxp wceq wtru wf1o wf f1oi cv wcel cmin
      cfv fvresi f1of mp1i wne cdiv simp2 simp1 subcld simp3 subne0d oveqan12rd
      w3a 3adant3 diveq1bd adantl ax-1cn dvidlem trud ) CDCEZFGCHIJKLABHURCCURM
      CCURNLCOCCURUAUBAPZCQZBPZCQZVAUSUCZUKZVAURSZUSURSZRGZVAUSRGZUDGHKLVDVGVHV
      DVAUSUTVBVCUEZUTVBVCUFZUGVDVAUSVIVJUTVBVCUHUIUTVBVGVHKVCVBUTVEVAVFUSRCVAT
      CUSTUJULUMUNUOUPUQ $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z K $.  $d x y z S $.
    $d y z J $.
    dvcnp.j $e |- J = ( K |`t A ) $.
    dvcnp.k $e |- K = ( TopOpen ` CCfld ) $.
    ${
      dvcnp.g $e |- G = ( z e. A |-> if ( z = B , ( ( S _D F ) ` B ) ,
        ( ( ( F ` z ) - ( F ` B ) ) / ( z - B ) ) ) ) $.
      $( The difference quotient is continuous at ` B ` when the original
         function is differentiable at ` B ` .  (Contributed by Mario Carneiro,
         8-Aug-2014.)  (Revised by Mario Carneiro, 28-Dec-2016.) $)
      dvcnp $p |- ( ( ( S e. { RR , CC } /\ F : A --> CC /\ A C_ S ) /\
        B e. dom ( S _D F ) ) -> G e. ( ( J CnP K ) ` B ) ) $=
        ( cc wcel wf wss co wa cfv cmin cmpt cpr w3a cdv cdm wceq cdiv cif ccnp
        cr cv csn cdif climc crest cnt wfun wb dvfg 3ad2ant1 ffun funfvbrb 3syl
        eqid recnprss simp2 simp3 eldv bitrd simplbda sstrd adantr dvbss sselda
        wbr wne eldifsn dvlem sylan2br limcmpt2 mpbid syl5eqel ) DUILUAMZBLENZB
        DOZUBZCDEUCPZUDZMZQZFABAUJZCUECWFRZWJERCERSPWJCSPUFPZUGTZCGHUHPRZKWIWKA
        BCUKULZWLTZCUMPMZWMWNMWEWHCBHDUNPZUORRMZWQWEWHCWKWFVNZWSWQQWEWGLWFNZWFU
        PWHWTUQWBWCXAWDDEURUSWGLWFUTCWFVAVBWEABCWKDWREWPHWRVCJWPVCWBWCDLOWDDVDU
        SZWBWCWDVEZWBWCWDVFZVGVHVIWIABCWKWLGHWEBLOWHWEBDLXDXBVJVKZWEWGBCWEBDEXB
        XCXDVLVMZWJBMWJCVOQWIWJWOMWLLMWJBCVPWIWJCBEWEWCWHXCVKXEXFVQVRIJVSVTWA
        $.
    $}

    $( A function is continuous at each point for which it is differentiable.
       (Contributed by Mario Carneiro, 9-Aug-2014.)  (Revised by Mario
       Carneiro, 28-Dec-2016.) $)
    dvcnp2 $p |- ( ( ( S C_ CC /\ F : A --> CC /\ A C_ S ) /\
      B e. dom ( S _D F ) ) -> F e. ( ( J CnP K ) ` B ) ) $=
      ( vz co wcel cc wss cfv climc cc0 caddc cmin cmpt cmul vy cdv cdm w3a wbr
      wf cv wex ccnp eldmg ibi wa simpl2 ctx ffvelrnda crest ctop cuni cnfldtop
      cnt cvv simpl1 cnex sylancl resttop sylancr simpl3 ctopon wceq cnfldtopon
      ssexg resttopon toponuni syl sseqtrd eqid ntrss2 syl2anc cdif simp1 simp2
      csn cdiv eldv simprbda sseldd ffvelrnd adantr subcld ssid a1i cxp txtopon
      simp3 mp2an restid ax-mp eqcomi sstrd dvlem ssdifssd sselda simplbda cres
      toponunii limcresi difss resmpt oveq1i sseqtri subidd ccn subcn cncfmptid
      ccncf cncfmptc syl3anc cncfmpt2f oveq1 cnmptlimc eqeltrrd sseldi cop dvcl
      mulcn 0cn opelxpi cncnpi limccnp2 mul01d eldifsni adantl subne0d divcan1d
      simpr wne mpteq2dva oveq1d 3eltr3d fmptd limcdif eleqtrrd addid2d feqmptd
      syl6eq eqidd addcn npcand eqtr4d wb cnplimc mpbir2and exlimdv imp sylan2
      ex ) BCDUBJZUCZKZCLMZALDUFZACMZUDZBUAUGZUUQUEZUAUHZDBEFUIJNKZUUSUVFUABUUQ
      UURUJUKUVCUVFUVGUVCUVEUVGUAUVCUVEUVGUVCUVEULZUVGUVABDNZDBOJZKZUUTUVAUVBUV
      EUMZUVHPUVIQJIAIUGZDNZUVIRJZUVIQJZSZBOJUVIUVJUVHIABPUVIUVOUVIQFFUNJZFLLUV
      HUVMAKZULZUVNUVIUVHALUVMDUVLUOZUVHUVILKZUVSUVHALBDUVLUVHAFCUPJZUTNNZABUVH
      UWCUQKZAUWCURZMUWDAMUVHFUQKCVAKZUWEFHUSUVHUUTLVAKUWGUUTUVAUVBUVEVBZVCCLVA
      VKVDCFVAVEVFUVHACUWFUUTUVAUVBUVEVGZUVHUWCCVHNKZCUWFVIUVHFLVHNKZUUTUWJFHVJ
      ZUWHCFLVLVFCUWCVMVNVOAUWCUWFUWFVPVQVRUVCUVEBUWDKZUVDIABWBZVSZUVOUVMBRJZWC
      JZSZBOJKZUVCIABUVDCUWCDUWRFUWCVPHUWRVPUUTUVAUVBVTZUUTUVAUVBWAZUUTUVAUVBWN
      ZWDZWEWFZWGZWHZWIZUXFLLMZUVHLWJZWKZUXJHUVRLLWLZUPJZUVRUVRUXKVHNZKZUXLUVRV
      IUWKUWKUXNUWLUWLFFLLWMWOZUVRUXMUXKUXKUVRUXOXEZWPWQWRZUVHPIUWOUVOSZBOJZIAU
      VOSZBOJZUVHUVDPTJIUWOUWQUWPTJZSZBOJPUXSUVHIUWOBUVDPUWQUWPTUVRFLLUVHUVMBAD
      UVLUVHACLUWIUWHWSZUXDWTUVHUVMUWOKZULZUVMBUVHUWOLUVMUVHALUWNUYDXAXBZUVHBLK
      ZUYEUVHALBUYDUXDWFZWHZWIZUXJUXJHUXQUVCUVEUWMUWSUXCXCUVHIAUWPSZBOJZIUWOUWP
      SZBOJZPUYMUYLUWOXDZBOJUYOBUWOUYLXFUYPUYNBOUWOAMZUYPUYNVIAUWNXGZIAUWOUWPXH
      WQXIXJUVHBBRJZPUYMUVHBUYIXKUVHIABLUWPUYSUVHIUVMBRFAHRUVRFXLJZKUVHFHXMWKUV
      HALMZUXHIAUVMSALXOJZKUYDUXIIALXNVDUVHUYHVUAUXHIABSVUBKUYIUYDUXJIBALXPXQXR
      UXDUVMBBRXSXTYAYBUVHTUYTKUVDPYCZUXKKZTVUCUVRFUIJZNKFHYEUVHUVDLKPLKZVUDUVC
      ABUVDCDUWTUXAUXBYDZYFUVDPLLYGVDVUCTUVRFUXKUXPYHVFYIUVHUVDVUGYJUVHUYCUXRBO
      UVHIUWOUYBUVOUYFUVOUWPUYFUVNUVIUYFALUVMDUVHUVAUYEUVLWHUYFUWOAUVMUYRUVHUYE
      YOYBWGUVHUWBUYEUXEWHWIUYKUYFUVMBUYGUYJUYEUVMBYPUVHUVMABYKYLYMYNYQYRYSUVHU
      YAUXTUWOXDZBOJUXSUVHABUXTUVHIAUVOLUXTUXGUXTVPYTUUAVUHUXRBOUYQVUHUXRVIUYRI
      AUWOUVOXHWQXIUUEUUBUVHIABLUVIUVIUVHUWBVUAUXHIAUVISVUBKUXEUYDUXJIUVIALXPXQ
      UXDUVMBVIUVIUUFXTUVHQUYTKPUVIYCZUXKKZQVUIVUENKFHUUGUVHVUFUWBVUJYFUXEPUVIL
      LYGVFVUIQUVRFUXKUXPYHVFYIUVHUVIUXEUUCUVHUVQDBOUVHUVQIAUVNSDUVHIAUVPUVNUVT
      UVNUVIUWAUXFUUHYQUVHIALDUVLUUDUUIYRYSUVHVUABAKUVGUVAUVKULUUJUYDUXDABDEFHG
      UUKVRUULUUPUUMUUNUUO $.
  $}

  ${
    $d x A $.  $d x F $.  $d x S $.
    $( A differentiable function is continuous.  (Contributed by Mario
       Carneiro, 7-Sep-2014.)  (Revised by Mario Carneiro, 7-Sep-2015.) $)
    dvcn $p |- ( ( ( S C_ CC /\ F : A --> CC /\ A C_ S ) /\
      dom ( S _D F ) = A ) -> F e. ( A -cn-> CC ) ) $=
      ( vx cc wss wf w3a cdv co cdm wceq wa crest wcel wral eqid ctopon sylancl
      cfv ccnfld ctopn ccncf cv ccnp simpl2 dvcnp2 ralrimiva raleq biimpd mpan9
      ccn cnfldtopon simpl3 simpl1 sstrd resttopon sylancr cncnp mpbir2and ssid
      wb toponunii restid ax-mp eqcomi cncfcn eleqtrrd ) BEFZAECGZABFZHZBCIJKZA
      LZMZCUAUBTZANJZVPULJZAEUCJZVOCVROZVJCDUDZVQVPUEJTOZDAPZVIVJVKVNUFVLWBDVMP
      ZVNWCVLWBDVMAWABCVQVPVQQZVPQZUGUHVNWDWCWBDVMAUIUJUKVOVQARTOZVPERTZOZVTVJW
      CMVBVOWIAEFZWGVPWFUMZVOABEVIVJVKVNUNVIVJVKVNUOUPZAVPEUQURWKDCVQVPAEUSSUTV
      OWJEEFVSVRLWLEVAAEVPVQVPWFWEVPENJZVPWIWMVPLWKVPWHEEVPWKVCVDVEVFVGSVH $.
  $}

  ${
    $d f s x F $.  $d f s G $.  $d f s x S $.
    dvnfval.1 $e |- G = ( x e. _V |-> ( S _D x ) ) $.
    $( Value of the iterated derivative.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    dvnfval $p |- ( ( S C_ CC /\ F e. ( CC ^pm S ) ) ->
        ( S Dn F ) = seq 0 ( ( G o. 1st ) , ( NN0 X. { F } ) ) ) $=
      ( vs vf cc cpm co wcel wa cv cvv cdv c1st cn0 cc0 cseq wceq wss cmpt ccom
      cpw csn cxp cdvn df-dvn a1i simprl oveq1d mpteq2dv syl6eqr coeq1d seqeq2d
      cmpt2 simprr sneqd xpeq2d seqeq3d eqtrd simpr oveq2d simpl elpw2 ovmpt2dx
      cnex sylibr seqex ) BHUAZCHBIJZKZLZFGBCHUDZHFMZIJZANVOAMZOJZUBZPUCZQGMZUE
      ZUFZRSZDPUCZQCUEZUFZRSZUGVKNUGFGVNVPWDUPTVMAGFUHUIVMVOBTZWACTZLLZWDWEWCRS
      WHWKVTWEWCRWKVSDPWKVSANBVQOJZUBDWKANVRWLWKVOBVQOVMWIWJUJUKULEUMUNUOWKWCWG
      WERWKWBWFQWKWACVMWIWJUQURUSUTVAVMWILVOBHIVMWIVBVCVMVJBVNKVJVLVDBHVGVEVHVJ
      VLVBWHNKVMWEWGRVIUIVF $.
  $}

  ${
    $d f k n x F $.  $d f k m n M $.  $d f n x N $.  $d f k m n s x S $.
    $( The iterated derivative is a function.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    dvnff $p |- ( ( S e. { RR , CC } /\ F e. ( CC ^pm S ) ) ->
        ( S Dn F ) : NN0 --> ( CC ^pm dom F ) ) $=
      ( vx vk vn cc wcel co wa cn0 cdm wf cvv cv cdv cc0 a1i wceq cnex wss cdvn
      cr cpr cpm cmpt c1st ccom csn cxp nn0uz cz 0z cfv fvconst2g adantll dmexg
      cseq ad2antlr wb elpm2g biimpa simpld adantr syl3anc eqeltrd vex algrflem
      mpan fpmg oveq2 eqid ovex fvmpt ax-mp eqtri dvfg ad2antrr recnprss simprl
      sylancr mpbid simprd sstrd dvbss elpm2r syl22anc seqf dvnfval sylan feq1d
      syl5eqel mpbird ) AUBFUCZGZBFAUDHZGZIZJFBKZUDHZABUAHZLJWSCMACNZOHZUEZUFUG
      ZJBUHUIZPUQZLWQDEXDWSXEPJUJPUKGWQULQWQDNZJGZIZXGXEUMZBWSWPXHXJBRWNJBXGWOU
      NUOXIWRMGZFMGZWRFBLZBWSGWPXKWNXHBWOUPZURXLXISQWQXMXHWQXMWRATZWNWPXMXOIZXL
      WNWPXPUSSFABMWMUTVHVAZVBVCWRFBMMVIVDVEWQXGWSGZENZWSGZIZIZXGXSXDHZAXGOHZWS
      YCXGXCUMZYDXGXSXCDVFZEVFVGXGMGYEYDRYFCXGXBYDMXCXAXGAOVJXCVKZAXGOVLVMVNVOY
      BXLXKYDKZFYDLZYHWRTYDWSGXLYBSQWPXKWNYAXNURZWNYIWPYAAXGVPVQYBYHXGKZWRYBYKA
      XGWNAFTZWPYAAVRZVQYBYKFXGLZYKWRTZYBXRYNYOIZWQXRXTVSYBXLXKXRYPUSSYJFWRXGMM
      UTVTWAZVBYBYKWRAYBYNYOYQWBZWQXOYAWQXMXOXQWBVCWCWDYRWCFWRYHYDMMWEWFWKWGWQJ
      WSWTXFWNYLWPWTXFRYMCABXCYGWHWIWJWL $.

    $( Zero times iterated derivative.  (Contributed by Stefan O'Rear,
       15-Nov-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    dvn0 $p |- ( ( S C_ CC /\ F e. ( CC ^pm S ) ) ->
        ( ( S Dn F ) ` 0 ) = F ) $=
      ( vx cc wss cpm co wcel wa cc0 cdvn cfv cvv cv cdv cmpt c1st ccom cn0 csn
      cseq eqid dvnfval fveq1d 0z wceq simpr 0nn0 fvconst2g sylancl seq1i eqtrd
      cxp ) ADEZBDAFGZHZIZJABKGZLJCMACNOGPZQRZSBTUMZJUAZLBUQJURVBCABUSUSUBUCUDU
      QBUTVAJUEUQUPJSHJVALBUFUNUPUGUHSBJUOUIUJUKUL $.

    $( Successor iterated derivative.  (Contributed by Stefan O'Rear,
       15-Nov-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    dvnp1 $p |- ( ( S C_ CC /\ F e. ( CC ^pm S ) /\ N e. NN0 ) ->
        ( ( S Dn F ) ` ( N + 1 ) ) = ( S _D ( ( S Dn F ) ` N ) ) ) $=
      ( vx cc wss cpm co wcel cn0 w3a c1 caddc cvv cdv cc0 cfv wceq fvex fveq1d
      cv cmpt c1st ccom csn cxp cseq cdvn cuz simp3 nn0uz syl6eleq syl algrflem
      seqp1 syl6eq eqid dvnfval 3adant3 oveq2 ovex fvmpt fveq2d syl5eqr 3eqtr4d
      ax-mp ) AEFZBEAGHIZCJIZKZCLMHZDNADUAZOHZUBZUCUDZJBUEUFZPUGZQZCVQQZVNQZVKA
      BUHHZQACWAQZOHZVJVRVSVKVPQZVOHZVTVJCPUIQZIVRWERVJCJWFVGVHVIUJUKULVOVPPCUO
      UMVSWDVNCVQSVKVPSUNUPVJVKWAVQVGVHWAVQRVIDABVNVNUQZURUSZTVJWCWBVNQZVTWBNIW
      IWCRCWASDWBVMWCNVNVLWBAOUTWGAWBOVAVBVFVJWBVSVNVJCWAVQWHTVCVDVE $.

    $( One times iterated derivative.  (Contributed by Mario Carneiro,
       1-Jan-2017.) $)
    dvn1 $p |- ( ( S C_ CC /\ F e. ( CC ^pm S ) ) ->
        ( ( S Dn F ) ` 1 ) = ( S _D F ) ) $=
      ( cc wss cpm co wcel wa cdvn cfv cc0 caddc cdv 0p1e1 fveq2i cn0 wceq 0nn0
      c1 dvnp1 mp3an3 dvn0 oveq2d eqtrd syl5eqr ) ACDZBCAEFGZHZSABIFZJKSLFZUIJZ
      ABMFZUJSUINOUHUKAKUIJZMFZULUFUGKPGUKUNQRABKTUAUHUMBAMABUBUCUDUE $.

    $( The N-times derivative is a function.  (Contributed by Stefan O'Rear,
       16-Nov-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    dvnf $p |- ( ( S e. { RR , CC } /\ F e. ( CC ^pm S ) /\ N e. NN0 ) ->
      ( ( S Dn F ) ` N ) : dom ( ( S Dn F ) ` N ) --> CC ) $=
      ( cr cc cpr wcel cpm co cn0 cdm wf wss wa cvv cnex elpm2g sylancr mpbid
      wb w3a cdvn cfv dvnff ffvelrnda 3impa simp1 simp2 simprd ssexd simpld ) A
      DEFZGZBEAHIGZCJGZUAZCABUBIZUCZKZEURLZUSBKZMZUPUREVAHIZGZUTVBNZUMUNUOVDUMU
      NNJVCCUQABUDUEUFUPEOGZVAOGVDVETPUPVAAULUMUNUOUGZUPVAEBLZVAAMZUPUNVHVINZUM
      UNUOUHUPVFUMUNVJTPVGEABOULQRSUIUJEVAUROOQRSUK $.

    $( The set of N-times differentiable points is a subset of the domain of
       the function.  (Contributed by Stefan O'Rear, 16-Nov-2014.)  (Revised by
       Mario Carneiro, 11-Feb-2015.) $)
    dvnbss $p |- ( ( S e. { RR , CC } /\ F e. ( CC ^pm S ) /\ N e. NN0 ) ->
      dom ( ( S Dn F ) ` N ) C_ dom F ) $=
      ( cr cc wcel cpm co cn0 cdm wf wss wa wb cnex elpm2g sylancr mpbid simprd
      cvv cpr w3a cdvn cfv dvnff ffvelrnda 3impa simp1 simp2 ssexd ) ADEUAZFZBE
      AGHFZCIFZUBZCABUCHZUDZJZEUQKZURBJZLZUOUQEUTGHZFZUSVAMZULUMUNVCULUMMIVBCUP
      ABUEUFUGUOETFZUTTFVCVDNOUOUTAUKULUMUNUHZUOUTEBKZUTALZUOUMVGVHMZULUMUNUIUO
      VEULUMVINOVFEABTUKPQRSUJEUTUQTTPQRS $.

    $( The ` N ` -th derivative of the ` M ` -th derivative of ` F ` is the
       same as the ` M + N ` -th derivative of ` F ` .  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    dvnadd $p |- ( ( ( S e. { RR , CC } /\ F e. ( CC ^pm S ) ) /\
      ( M e. NN0 /\ N e. NN0 ) ) ->
      ( ( S Dn ( ( S Dn F ) ` M ) ) ` N ) = ( ( S Dn F ) ` ( M + N ) ) ) $=
      ( cc wcel co wa cn0 cfv caddc wi cc0 c1 fveq2 oveq2 fveq2d eqeq12d imbi2d
      wceq vn vk cr cpr cpm cdvn cv wss recnprss ad2antrr cdm cvv ssid a1i cnex
      wf wb elpm2g mpan simplbda simpl pmss12g syl22anc adantr ffvelrnda sseldd
      dvnff dvn0 syl2anc nn0cn adantl addid1d eqtr4d simpr dvnp1 syl3anc ax-1cn
      cdv addassd simpllr nn0addcl adantll eqtr3d syl5ibr expcom a2d com12 impr
      nn0ind ) AUCEUDZFZBEAUEGZFZHZCIFZDIFZDACABUFGZJZUFGZJZCDKGZWQJZTZWPWNWOHZ
      XCXDUAUGZWSJZCXEKGZWQJZTZLXDMWSJZCMKGZWQJZTZLXDUBUGZWSJZCXNKGZWQJZTZLXDXN
      NKGZWSJZCXSKGZWQJZTZLXDXCLUAUBDXEMTZXIXMXDYDXFXJXHXLXEMWSOYDXGXKWQXEMCKPQ
      RSXEXNTZXIXRXDYEXFXOXHXQXEXNWSOYEXGXPWQXEXNCKPQRSXEXSTZXIYCXDYFXFXTXHYBXE
      XSWSOYFXGYAWQXEXSCKPQRSXEDTZXIXCXDYGXFWTXHXBXEDWSOYGXGXAWQXEDCKPQRSXDXJWR
      XLXDAEUHZWRWLFZXJWRTWKYHWMWOAUIUJZXDEBUKZUEGZWLWRWNYLWLUHZWOWNEEUHZYKAUHZ
      EULFZWKYMYNWNEUMUNWKWMYKEBUPZYOYPWKWMYQYOHUQUOEABULWJURUSUTYPWNUOUNWKWMVA
      EYKEAULWJVBVCVDWNIYLCWQABVGVEVFZAWRVHVIXDXKCWQXDCWOCEFZWNCVJVKZVLQVMXNIFZ
      XDXRYCXDUUAXRYCLXRYCXDUUAHZAXOVRGZAXQVRGZTXOXQAVRPUUBXTUUCYBUUDUUBYHYIUUA
      XTUUCTXDYHUUAYJVDZXDYIUUAYRVDXDUUAVNAWRXNVOVPUUBXPNKGZWQJZYBUUDUUBUUFYAWQ
      UUBCXNNXDYSUUAYTVDUUAXNEFXDXNVJVKNEFUUBVQUNVSQUUBYHWMXPIFZUUGUUDTUUEWKWMW
      OUUAVTWOUUAUUHWNCXNWAWBABXPVOVPWCRWDWEWFWIWGWH $.

    $( An N-times differentiable point is an M-times differeentiable point, if
       ` M <_ N ` .  (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    dvn2bss $p |- ( ( S e. { RR , CC } /\ F e. ( CC ^pm S ) /\
      M e. ( 0 ... N ) ) ->
        dom ( ( S Dn F ) ` N ) C_ dom ( ( S Dn F ) ` M ) ) $=
      ( cc wcel co cc0 cdvn cfv cdm cn0 3ad2ant3 cuz syl22anc nn0cnd wss cvv wf
      syl3an3 cr cpr cpm cfz w3a cmin caddc wceq simp1 elfznn0 elfzuz3 uznn0sub
      simp2 dvnadd elfzuz2 nn0uz syl6eleqr pncan3d fveq2d eqtrd dmeqd cnex dvnf
      syl a1i dvnbss wa elpmi 3ad2ant2 simprd sstrd elpm2r syl3anc eqsstr3d ) A
      UAEUBZFZBEAUCGZFZCHDUDGFZUEZDABIGZJZKDCUFGZACWAJZIGJZKZWDKZVTWEWBVTWECWCU
      GGZWAJZWBVTVPVRCLFZWCLFZWEWIUHVPVRVSUIZVPVRVSUMVSVPWJVRCDUJZMZVTDCNJFZWKV
      SVPWOVRCHDUKMCDULVDZABCWCUNOVTWHDWAVTCDVTCWNPVTDVTDHNJZLVSVPDWQFVRCHDUOMU
      PUQPURUSUTVAVTVPWDVQFZWKWFWGQWLVTERFZVPWGEWDSZWGAQWRWSVTVBVEWLVSVPVRWJWTW
      MABCVCTVTWGBKZAVSVPVRWJWGXAQWMABCVFTVTXAEBSZXAAQZVRVPXBXCVGVSEABVHVIVJVKE
      AWGWDRVOVLOWPAWDWCVFVMVN $.

    $( Multiple derivative version of ~ dvres3a .  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    dvnres $p |- ( ( ( S e. { RR , CC } /\ F e. ( CC ^pm CC ) /\ N e. NN0 ) /\
      dom ( ( CC Dn F ) ` N ) = dom F ) ->
        ( ( S Dn ( F |` S ) ) ` N ) = ( ( ( CC Dn F ) ` N ) |` S ) ) $=
      ( cc wcel co cfv cdm wceq cres wi cc0 fveq2 dmeqd reseq1d eqeq12d imbi12d
      wa eqeq1d wss vx vn cr cpr cpm cn0 w3a cv c1 caddc imbi2d recnprss adantr
      cdvn pmresg dvn0 syl2anc ssid a1i sylan eqtr4d prid2 simplr simprl dvnbss
      a1d cnex syl3anc cdv simprr dvnp1 eqtr3d wf elpm2 simprbi syl sstrd dvbss
      dvnf eqsstrd eqssd expr imim1d oveq2 ccnfld simpll cnt ctop eqid cnfldtop
      ctopn cnfldtopon toponunii ntrss2 sylancr crest restid eqcomi dvbssntr wb
      ax-mp isopn3 mpbird eqtr2d dvres3a syl22anc syl5ibr a2d syld expcom com12
      nn0ind 3impia imp ) AUCDUDZEZBDDUEFEZCUFEZUGCDBUNFZGZHZBHZIZCABAJZUNFZGZX
      TAJZIZXPXQXRYCYHKZXRXPXQRZYIYJUAUHZXSGZHZYBIZYKYEGZYLAJZIZKZKYJLXSGZHZYBI
      ZLYEGZYSAJZIZKZKYJUBUHZXSGZHZYBIZUUFYEGZUUGAJZIZKZKYJUUFUIUJFZXSGZHZYBIZU
      UNYEGZUUOAJZIZKZKYJYIKUAUBCYKLIZYRUUEYJUVBYNUUAYQUUDUVBYMYTYBUVBYLYSYKLXS
      MZNSUVBYOUUBYPUUCYKLYEMUVBYLYSAUVCOPQUKYKUUFIZYRUUMYJUVDYNUUIYQUULUVDYMUU
      HYBUVDYLUUGYKUUFXSMZNSUVDYOUUJYPUUKYKUUFYEMUVDYLUUGAUVEOPQUKYKUUNIZYRUVAY
      JUVFYNUUQYQUUTUVFYMUUPYBUVFYLUUOYKUUNXSMZNSUVFYOUURYPUUSYKUUNYEMUVFYLUUOA
      UVGOPQUKYKCIZYRYIYJUVHYNYCYQYHUVHYMYAYBUVHYLXTYKCXSMZNSUVHYOYFYPYGYKCYEMU
      VHYLXTAUVIOPQUKYJUUDUUAYJUUBYDUUCYJADTZYDDAUEFEZUUBYDIXPUVJXQAULUMZDADBXO
      UOZAYDUPUQYJYSBAXPDDTZXQYSBIUVNXPDURZUSDBUPUTOVAVFUUFUFEZYJUUMUVAYJUVPUUM
      UVAKYJUVPRZUUMUUQUULKUVAUVQUUQUUIUULYJUVPUUQUUIYJUVPUUQRZRZUUHYBUVSDXOEZX
      QUVPUUHYBTUVTUVSUCDVGVBUSZXPXQUVRVCZYJUVPUUQVDZDBUUFVEVHZUVSYBDUUGVIFZHZU
      UHUVSUUPYBUWFYJUVPUUQVJUVSUUOUWEUVSUVNXQUVPUUOUWEIUVNUVSUVOUSZUWBUWCDBUUF
      VKVHZNVLZUVSUUHDUUGUWGUVSUVTXQUVPUUHDUUGVMZUWAUWBUWCDBUUFVSVHZUVSUUHYBDUW
      DUVSXQYBDTZUWBXQYBDBVMUWLDDBVGVGVNVOVPVQZVRVTWAZWBWCUVQUUQUULUUTYJUVPUUQU
      ULUUTKUULUUTUVSAUUJVIFZAUUKVIFZIUUJUUKAVIWDUVSUURUWOUUSUWPUVSUVJUVKUVPUUR
      UWOIYJUVJUVRUVLUMYJUVKUVRUVMUMUWCAYDUUFVKVHUVSUUSUWEAJZUWPUVSUUOUWEAUWHOU
      VSXPUWJUUHWEWKGZEZUWFUUHIUWPUWQIXPXQUVRWFUWKUVSUWSUUHUWRWGGGZUUHIZUVSUWTU
      UHUVSUWRWHEZUUHDTZUWTUUHTUWRUWRWIZWJZUWMUUHUWRDDUWRUWRUXDWLWMZWNWOUVSUUHY
      BUWTUWDUVSYBUWFUWTUWIUVSUUHDUUGUWRUWRUWGUWKUWMUWRDWPFZUWRUXBUXGUWRIUXEUWR
      WHDUXFWQXAWRUXDWSVTVQWAUVSUXBUXCUWSUXAWTUXEUWMUUHUWRDUXFXBWOXCUVSUUHYBUWF
      UWNUWIXDUUHAUUGUWRUXDXEXFVAPXGWBXHXIXJXHXLXKXMXN $.

    $( Condition for n-times continuous differentiability.  (Contributed by
       Stefan O'Rear, 15-Nov-2014.)  (Revised by Mario Carneiro,
       11-Feb-2015.) $)
    cpnfval $p |- ( S C_ CC -> ( C^n ` S ) = ( n e. NN0 |->
      { f e. ( CC ^pm S ) | ( ( S Dn f ) ` n ) e. ( dom f -cn-> CC ) } ) ) $=
      ( vs cc wss cpw wcel ccpn cfv cn0 cv cdvn co cdm ccncf cpm crab cmpt wceq
      cnex elpw2 oveq2 oveq1 fveq1d eleq1d rabeqbidv mpteq2dv nn0ex mptex fvmpt
      df-cpn sylbir ) AEFAEGZHAIJCKCLZABLZMNZJZUPOEPNZHZBEAQNZRZSZTAEUAUBDACKUO
      DLZUPMNZJZUSHZBEVDQNZRZSVCUNIVDATZCKVIVBVJVGUTBVHVAVDAEQUCVJVFURUSVJUOVEU
      QVDAUPMUDUEUFUGUHCBDULCKVBUIUJUKUM $.

    $( The ` C^n ` object is a function.  (Contributed by Stefan O'Rear,
       16-Nov-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    fncpn $p |- ( S C_ CC -> ( C^n ` S ) Fn NN0 ) $=
      ( vn vf cc wss ccpn cfv cn0 wfn cv cdvn cdm ccncf wcel cpm crab cmpt ovex
      co rabex eqid fnmpti cpnfval fneq1d mpbiri ) ADEZAFGZHIBHBJACJZKSGUHLDMSN
      ZCDAOSZPZQZHIBHUKULUICUJDAORTULUAUBUFHUGULACBUCUDUE $.

    $( Condition for n-times continuous differentiability.  (Contributed by
       Stefan O'Rear, 15-Nov-2014.)  (Revised by Mario Carneiro,
       11-Feb-2015.) $)
    elcpn $p |- ( ( S C_ CC /\ N e. NN0 ) -> ( F e. ( ( C^n ` S ) ` N ) <->
      ( F e. ( CC ^pm S ) /\ ( ( S Dn F ) ` N ) e. ( dom F -cn-> CC ) ) ) ) $=
      ( vf vn cc wss cn0 wcel wa cfv cv cdvn co cdm ccncf cpm crab fveq1d wceq
      ccpn cmpt cpnfval fveq2 eleq1d rabbidv eqid ovex rabex fvmpt eleq2d oveq2
      sylan9eq dmeq oveq1d eleq12d elrab syl6bb ) AFGZCHIZJZBCAUAKZKZIBCADLZMNZ
      KZVDOZFPNZIZDFAQNZRZIBVJICABMNZKZBOZFPNZIZJVAVCVKBUSUTVCCEHELZVEKZVHIZDVJ
      RZUBZKVKUSCVBWAADEUCSECVTVKHWAVQCTZVSVIDVJWBVRVFVHVQCVEUDUEUFWAUGVIDVJFAQ
      UHUIUJUMUKVIVPDBVJVDBTZVFVMVHVOWCCVEVLVDBAMULSWCVGVNFPVDBUNUOUPUQUR $.

    $( ` C^n ` conditions are ordered by strength.  (Contributed by Stefan
       O'Rear, 16-Nov-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    cpnord $p |- ( ( S e. { RR , CC } /\ M e. NN0 /\ N e. ( ZZ>= ` M ) ) ->
        ( ( C^n ` S ) ` N ) C_ ( ( C^n ` S ) ` M ) ) $=
      ( cc wcel cn0 cfv wss wa cv wi co wceq fveq2 sseq1d imbi2d cdm wf syl3anc
      syl vn vm vf cr cpr cuz ccpn c1 caddc ssid a1ii cpm cdvn ccncf simprl cdv
      recnprss ad2antrr adantr simplll eluznn0 adantll dvnf dvnbss dvnp1 simprr
      cz eqeltrrd cncff fdm cvv wb cnex elpm2g sylancr mpbid simprd sstrd dvbss
      eqsstr3d eqssd feq2d dvcn syl31anc jca ex peano2nn0 elcpn syl2anc 3imtr4d
      ssrdv sstr2 expcom a2d uzind4 com12 3impia ) AUDDUEZEZBFEZCBUFGZEZCAUGGZG
      ZBXCGZHZXBWSWTIZXFXGUAJZXCGZXEHZKXGXEXEHZKXGUBJZXCGZXEHZKXGXLUHUILZXCGZXE
      HZKXGXFKUAUBBCXHBMZXJXKXGXRXIXEXEXHBXCNOPXHXLMZXJXNXGXSXIXMXEXHXLXCNOPXHX
      OMZXJXQXGXTXIXPXEXHXOXCNOPXHCMZXJXFXGYAXIXDXEXHCXCNOPBVGEXGXKXEUJUKXLXAEZ
      XGXNXQXGYBXNXQKZXGYBIZXPXMHYCYDUCXPXMYDUCJZDAULLEZXOAYEUMLZGZYEQZDUNLZEZI
      ZYFXLYGGZYJEZIZYEXPEZYEXMEZYDYLYOYDYLIZYFYNYDYFYKUOZYRADHZYIDYMRZYIAHZAYM
      UPLZQZYIMZYNYDYTYLWSYTWTYBAUQURZUSZYRYMQZDYMRZUUAYRWSYFXLFEZUUIWSWTYBYLUT
      ZYSYDUUJYLWTYBUUJWSXLBVAVBZUSZAYEXLVCSZYRUUHYIDYMYRUUHYIYRWSYFUUJUUHYIHUU
      KYSUUMAYEXLVDSZYRYIUUDUUHYRYIDUUCRZUUEYRUUCYJEUUPYRYHUUCYJYRYTYFUUJYHUUCM
      UUGYSUUMAYEXLVESYDYFYKVFVHYIDUUCVITYIDUUCVJTZYRUUHAYMUUGUUNYRUUHYIAUUOYRY
      IDYERZUUBYRYFUURUUBIZYSYRDVKEWSYFUUSVLVMUUKDAYEVKWRVNVOVPVQZVRVSVTWAWBVPU
      UTUUQYIAYMWCWDWEWFYDYTXOFEZYPYLVLUUFYDUUJUVAUULXLWGTAYEXOWHWIYDYTUUJYQYOV
      LUUFUULAYEXLWHWIWJWKXPXMXEWLTWMWNWOWPWQ $.

    $( A ` C^n ` function is continuous.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    cpncn $p |- ( ( S e. { RR , CC } /\ F e. ( ( C^n ` S ) ` N ) ) ->
      F e. ( dom F -cn-> CC ) ) $=
      ( cr cc cpr wcel ccpn cfv wa cc0 cdvn cdm ccncf wss cpm wceq cn0 syl2anc
      co recnprss adantr cuz simpl 0nn0 a1i elfvdm adantl wfn fndm 3syl eleqtrd
      fncpn nn0uz syl6eleq cpnord syl3anc simpr sseldd elcpn simpld dvn0 simprd
      wb mpbid eqeltrrd ) ADEFGZBCAHIZIZGZJZKABLTIZBBMENTZVKAEOZBEAPTGZVLBQVGVN
      VJAUAUBZVKVOVLVMGZVKBKVHIZGZVOVQJZVKVIVRBVKVGKRGZCKUCIZGVIVROVGVJUDWAVKUE
      UFZVKCRWBVKCVHMZRVJCWDGVGBCVHUGUHVKVNVHRUIWDRQVPAUMRVHUJUKULUNUOAKCUPUQVG
      VJURUSVKVNWAVSVTVDVPWCABKUTSVEZVAABVBSVKVOVQWEVCVF $.

    $( The restriction of a ` C^n ` function is ` C^n ` .  (Contributed by
       Mario Carneiro, 11-Feb-2015.) $)
    cpnres $p |- ( ( S e. { RR , CC } /\ F e. ( ( C^n ` CC ) ` N ) ) ->
        ( F |` S ) e. ( ( C^n ` S ) ` N ) ) $=
      ( cc wcel ccpn cfv wa cres cpm co cdvn cdm ccncf wss cn0 wfn wceq elcpn
      wb cr cpr simpl simpr ssid elfvdm adantl fncpn ax-mp fndm eleqtrd sylancr
      mp1i mpbid simpld pmresg syl2anc simprd cncff syl fdm dvnres syl31anc cin
      wf resres rescom eqtr3i ffn fnresdm reseq1d syl5eq inss2 rescncf eqeltrrd
      3syl mpsyl dmres oveq1i syl6eleqr eqeltrd recnprss adantr mpbir2and ) AUA
      DUBZEZBCDFGZGEZHZBAIZCAFGGEZWJDAJKEZCAWJLKGZWJMZDNKZEZWIWFBDDJKEZWLWFWHUC
      ZWIWQCDBLKGZBMZDNKEZWIWHWQXAHZWFWHUDWIDDOZCPEZWHXBTDUEZWICWGMZPWHCXFEWFBC
      WGUFUGWGPQZXFPRWIXCXGXEDUHUIPWGUJUMUKZDBCSULUNZUOZDADBWEUPUQWIWMWSAIZWOWI
      WFWQXDWSMWTRZWMXKRWRXJXHWIWTDWSVEZXLWIXAXMWIWQXAXIURZWTDWSUSUTZWTDWSVAUTA
      BCVBVCWIXKAWTVDZDNKZWOWIWSXPIZXKXQWIXRWSWTIZAIZXKXKWTIXRXTWSAWTVFWSAWTVGV
      HWIXSWSAWIXMWSWTQXSWSRXOWTDWSVIWTWSVJVPVKVLXPWTOWIXAXRXQEAWTVMXNWTDXPWSVN
      VQVOWNXPDNBAVRVSVTWAWIADOZXDWKWLWPHTWFYAWHAWBWCXHAWJCSUQWD $.
  $}

  ${
    $d y A $.  $d y B $.  $d y z C $.  $d y z G $.  $d y z J $.  $d x y z ph $.
    $d x y z F $.  $d z K $.  $d z L $.  $d z S $.  $d z X $.  $d z Y $.
    dvadd.f $e |- ( ph -> F : X --> CC ) $.
    dvadd.x $e |- ( ph -> X C_ S ) $.
    dvadd.g $e |- ( ph -> G : Y --> CC ) $.
    dvadd.y $e |- ( ph -> Y C_ S ) $.
    ${
      dvaddbr.s $e |- ( ph -> S C_ CC ) $.
      dvadd.k $e |- ( ph -> K e. V ) $.
      dvadd.l $e |- ( ph -> L e. V ) $.
      dvadd.bf $e |- ( ph -> C ( S _D F ) K ) $.
      dvadd.bg $e |- ( ph -> C ( S _D G ) L ) $.
      dvadd.j $e |- J = ( TopOpen ` CCfld ) $.
      $( The sum rule for derivatives at a point.  (Contributed by Mario
         Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 28-Dec-2016.) $)
      dvaddbr $p |- ( ph -> C ( S _D ( F oF + G ) ) ( K + L ) ) $=
        ( vz vx vy caddc co cof cdv wbr cin crest cnt cfv wcel csn cdif cv cmin
        cdiv cmpt climc eqid eldv mpbid simpld elin sylanbrc ctop cuni wss wceq
        wa ctopon cc cnfldtopon resttopon sylancr topontop syl toponuni sseqtrd
        ntrin syl3anc eleqtrrd ssdif mp1i sselda sstrd ntrss2 syl2anc dvlem a1i
        sseldd syldan simprd cun fmptd ssdifssd syl5ss difssd unssd ssun1 ntrss
        cres restntr cvv cnex ssexg sylancl restabs fveq2d fveq1d eqtr3d undif1
        eleqtrd snssd ssequn2 sylib syl5eq oveq2d fveq12d limcres resmpt oveq1d
        dvcl mpdan adantl wfn ffn adantr eqidd ofval sstri sseli ffvelrn syl2an
        wf ffvelrnd eqtrd subcld ctx inss1 inss2 txtopon mp2an toponunii restid
        ssid cxp ax-mp eqcomi cnfldtop ccn cop ccnp addcn opelxpi cncnpi eldifi
        limccnp2 oveq12d difss addsub4d wne subne0d divdird mpteq2dva addcl off
        eldifsni mpbir2and ) ABGHUEUFZCDEUEUGUFZUHUFUIBJKUJZFCUKUFZULUMZUMZUNUV
        LUBUVNBUOZUPZUBUQZUVMUMZBUVMUMZURUFZUVTBURUFZUSUFZUTZBVAUFZUNABJUVPUMZK
        UVPUMZUJZUVQABUWHUNZBUWIUNZBUWJUNAUWKGUBJUVRUPZUVTDUMZBDUMZURUFZUWDUSUF
        ZUTZBVAUFZUNZABGCDUHUFUIZUWKUWTVLSAUBJBGCUVODUWRFUVOVBZUAUWRVBZPLMVCVDZ
        VEZAUWLHUBKUVRUPZUVTEUMZBEUMZURUFZUWDUSUFZUTZBVAUFZUNZABHCEUHUFUIZUWLUX
        MVLTAUBKBHCUVOEUXKFUXBUAUXKVBZPNOVCVDZVEZBUWHUWIVFVGAUVOVHUNZJUVOVIZVJZ
        KUXSVJZUVQUWJVKAUVOCVMUMUNZUXRAFVNVMUMUNZCVNVJZUYBFUAVOZPCFVNVPVQZCUVOV
        RVSZAJCUXSMAUYBCUXSVKUYFCUVOVTVSZWAZAKCUXSOUYHWAZJKUVOUXSUXSVBZWBWCWDZA
        UVLUBUVSUWQUXJUEUFZUTZBVAUFUWGAUBUVSBGHUWQUXJUEFFUUAUFZFVNVNAUVTUVSUNZU
        VTUWMUNUWQVNUNAUVSUWMUVTUVNJVJZUVSUWMVJZAJKUUBZUVNJUVRWEWFZWGAUVTBJDLAJ
        CVNMPWHZAUWHJBAUXRUXTUWHJVJUYGUYIJUVOUXSUYKWIWJUXEWMZWKZWNAUYPUVTUXFUNU
        XJVNUNAUVSUXFUVTUVNKVJZUVSUXFVJZAJKUUCZUVNKUVRWEWFZWGAUVTBKENAKCVNOPWHZ
        AUWIKBAUXRUYAUWIKVJUYGUYJKUVOUXSUYKWIWJUXQWMZWKZWNVNVNVJAVNUUHWLZVUKUAU
        YOVNVNUUIZUKUFZUYOUYOVULVMUMZUNZVUMUYOVKUYCUYCVUOUYEUYEFFVNVNUUDUUEZUYO
        VUNVULVULUYOVUPUUFZUUGUUJUUKAGUWSUBUVSUWQUTZBVAUFZAUWKUWTUXDWOAUWRUVSXD
        ZBVAUFUWSVUSAUWMBUVSUWRFUWMUVRWPZUKUFZFAUBUWMUWQVNUWRVUCUXCWQUYTAJVNUVR
        VUAWRUAVVBVBABUVNFJUKUFZULUMZUMZUVSUVRWPZVVBULUMZUMABUVNUXSJUPZWPZUVPUM
        ZJUJZVVEABVVJUNBJUNZBVVKUNAUVQVVJBAUXRVVIUXSVJUVNVVIVJZUVQVVJVJUYGAUVNV
        VHUXSAUVNCUXSAUVNJCUYSMWSZUYHWAZAUXSJWTXAVVMAUVNVVHXBWLVVIUVNUVOUXSUYKX
        CWCUYLWMVUBBVVJJVFVGAUVNUVOJUKUFZULUMZUMZVVKVVEAUXRUXTUYQVVRVVKVKUYGUYI
        UYQAUYSWLUVNUVOVVPUXSJUYKVVPVBXEWCAUVNVVQVVDAVVPVVCULAFVHUNZJCVJCXFUNZV
        VPVVCVKVVSAFUAUULWLZMAUYDVNXFUNZVVTPXGCVNXFXHXIZJCFVHXFXJWCXKXLXMXOAVVF
        UVNVVGVVDAVVBVVCULAVVAJFUKAVVAJUVRWPZJJUVRXNAUVRJVJVWDJVKABJVUBXPUVRJXQ
        XRXSXTXKAVVFUVNUVRWPZUVNUVNUVRXNAUVRUVNVJVWEUVNVKABUVNAVVLBKUNZBUVNUNZV
        UBVUIBJKVFVGZXPUVRUVNXQXRXSZYAWDYBAVUTVURBVAAUYRVUTVURVKUYTUBUWMUVSUWQY
        CVSYDXMXOAHUXLUBUVSUXJUTZBVAUFZAUWLUXMUXPWOAUXKUVSXDZBVAUFUXLVWKAUXFBUV
        SUXKFUXFUVRWPZUKUFZFAUBUXFUXJVNUXKVUJUXOWQVUGAKVNUVRVUHWRUAVWNVBABUVNFK
        UKUFZULUMZUMZVVFVWNULUMZUMABUVNUXSKUPZWPZUVPUMZKUJZVWQABVXAUNVWFBVXBUNA
        UVQVXABAUXRVWTUXSVJUVNVWTVJZUVQVXAVJUYGAUVNVWSUXSVVOAUXSKWTXAVXCAUVNVWS
        XBWLVWTUVNUVOUXSUYKXCWCUYLWMVUIBVXAKVFVGAUVNUVOKUKUFZULUMZUMZVXBVWQAUXR
        UYAVUDVXFVXBVKUYGUYJVUDAVUFWLUVNUVOVXDUXSKUYKVXDVBXEWCAUVNVXEVWPAVXDVWO
        ULAVVSKCVJVVTVXDVWOVKVWAOVWCKCFVHXFXJWCXKXLXMXOAVVFUVNVWRVWPAVWNVWOULAV
        WMKFUKAVWMKUVRWPZKKUVRXNAUVRKVJVXGKVKABKVUIXPUVRKXQXRXSXTXKVWIYAWDYBAVW
        LVWJBVAAVUEVWLVWJVKVUGUBUXFUVSUXJYCVSYDXMXOAUEUYOFUUMUFUNGHUUNZVULUNZUE
        VXHUYOFUUOUFUMUNFUAUUPAGVNUNZHVNUNZVXIAUXAVXJSAJBGCDPLMYEYFAUXNVXKTAKBH
        CEPNOYEYFGHVNVNUUQWJVXHUEUYOFVULVUQUURVQUUTAUWFUYNBVAAUBUVSUWEUYMAUYPVL
        ZUWEUWPUXIUEUFZUWDUSUFUYMVXLUWCVXMUWDUSVXLUWCUWNUXGUEUFZUWOUXHUEUFZURUF
        VXMVXLUWAVXNUWBVXOURVXLUVTUVNUNZUWAVXNVKUYPVXPAUVTUVNUVRUUSYGVXLJKUWNUX
        GUEUVNDEXFXFUVTADJYHZUYPAJVNDYQZVXQLJVNDYIVSYJZAEKYHZUYPAKVNEYQZVXTNKVN
        EYIVSYJZAJXFUNZUYPAJVNVJVWBVYCVUAXGJVNXFXHXIZYJZAKXFUNZUYPAKVNVJVWBVYFV
        UHXGKVNXFXHXIZYJZUVNVBZVXLUVTJUNZVLUWNYKVXLUVTKUNZVLUXGYKYLYFVXLVWGUWBV
        XOVKAVWGUYPVWHYJVXLJKUWOUXHUEUVNDEXFXFBVXSVYBVYEVYHVYIVXLVVLVLUWOYKVXLV
        WFVLUXHYKYLYFUVAVXLUWNUXGUWOUXHAVXRVYJUWNVNUNUYPLUVSJUVTUVSUVNJUVNUVRUV
        BZUYSYMZYNJVNUVTDYOYPZAVYAVYKUXGVNUNUYPNUVSKUVTUVSUVNKVYLVUFYMYNKVNUVTE
        YOYPZAUWOVNUNUYPAJVNBDLVUBYRYJZAUXHVNUNUYPAKVNBENVUIYRYJZUVCYSYDVXLUWPU
        XIUWDVXLUWNUWOVYNVYPYTVXLUXGUXHVYOVYQYTVXLUVTBAUVSVNUVTAUVSJVNVYMVUAWSW
        GZABVNUNUYPAJVNBVUAVUBWMYJZYTVXLUVTBVYRVYSUYPUVTBUVDAUVTUVNBUVJYGUVEUVF
        YSUVGYDWDAUBUVNBUVLCUVOUVMUWFFUXBUAUWFVBPAUCUDJKUVNUEVNVNVNDEXFXFUCUQZV
        NUNUDUQZVNUNVLVYTWUAUEUFVNUNAVYTWUAUVHYGLNVYDVYGVYIUVIVVNVCUVK $.

      $( The product rule for derivatives at a point.  (Contributed by Mario
         Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 28-Dec-2016.) $)
      dvmulbr $p |- ( ph -> C ( S _D ( F oF x. G ) )
                      ( ( K x. ( G ` C ) ) + ( L x. ( F ` C ) ) ) ) $=
        ( vz vx vy cfv cmul caddc cof cdv wbr cin crest cnt wcel cdif cmin cdiv
        co cv cmpt climc wa eqid eldv simpld elin sylanbrc ctop wss wceq ctopon
        mpbid cc sylancr syl sseqtrd syl3anc eleqtrrd wf adantr adantl ffvelrnd
        sseldi cdm dvbss wrel reldv sseldd subcld sstrd mulcld ssdif mp1i dvlem
        releldm a1i simprd cres fmptd ssdifssd difssd unssd ssun1 ntrss restntr
        cun cvv ssexg sylancl restabs fveq2d fveq1d eqtr3d eleqtrd undif1 snssd
        cnex ssequn2 sylib syl5eq oveq2d fveq12d limcres resmpt oveq1d ccnp cop
        syl2anc mpdan opelxpi cncnpi limccnp2 eqidd eqtrd oveq12d wfn ffn ofval
        dvcl div23d csn cuni cnfldtopon resttopon topontop toponuni ntrin inss1
        ctx eldifi wne eldifsni subne0d divcld inss2 sselda syldan ssid txtopon
        cxp mp2an toponunii restid ax-mp eqcomi syl5ss cnfldtop dvcnp2 syl31anc
        wb cnplimc difss sstri feqresmpt mulcn ccncf cncfmptc cnmptlimc limcdif
        ccn addcn divdird npncand subdird mulcomd 3eqtr4d 3eqtr3d mpteq2dva off
        subdid mulcl mpbir2and ) ABGBEUEZUFURZHBDUEZUFURZUGURZCDEUFUHURZUIURUJB
        JKUKZFCULURZUMUEZUEZUNUWQUBUWSBUUAZUOZUBUSZUWRUEZBUWRUEZUPURZUXEBUPURZU
        QURZUTZBVAURZUNABJUXAUEZKUXAUEZUKZUXBABUXMUNZBUXNUNZBUXOUNAUXPGUBJUXCUO
        ZUXEDUEZUWOUPURZUXIUQURZUTZBVAURZUNZABGCDUIURZUJZUXPUYDVBSAUBJBGCUWTDUY
        BFUWTVCZUAUYBVCZPLMVDVLZVEAUXQHUBKUXCUOZUXEEUEZUWMUPURZUXIUQURZUTZBVAUR
        ZUNZABHCEUIURZUJZUXQUYPVBTAUBKBHCUWTEUYNFUYGUAUYNVCZPNOVDVLZVEBUXMUXNVF
        VGAUWTVHUNZJUWTUUBZVIZKVUBVIZUXBUXOVJAUWTCVKUEUNZVUAAFVMVKUEUNZCVMVIZVU
        EFUAUUCZPCFVMUUDVNZCUWTUUEVOZAJCVUBMAVUECVUBVJVUICUWTUUFVOZVPZAKCVUBOVU
        KVPZJKUWTVUBVUBVCZUUGVQVRZAUWQUBUXDUYAUYKUFURZUYMUWOUFURZUGURZUTZBVAURU
        XLAUBUXDBUWNUWPVUPVUQUGFFUUIURZFVMVMAUXEUXDUNZVBZUYAUYKVVBUXTUXIVVBUXSU
        WOVVBJVMUXEDAJVMDVSZVVALVTZVVBUWSJUXEJKUUHZVVAUXEUWSUNZAUXEUWSUXCUUJWAZ
        WCZWBZAUWOVMUNZVVAAJVMBDLAUYEWDZJBAJCDPLMWEAUYEWFUYFBVVKUNCDWGSBGUYEWOV
        NWHZWBZVTZWIVVBUXEBVVBJVMUXEAJVMVIZVVAAJCVMMPWJZVTZVVHWHZABVMUNVVAAJVMB
        VVPVVLWHVTZWIVVBUXEBVVRVVSVVAUXEBUUKAUXEUWSBUULWAUUMZUUNZVVBKVMUXEEAKVM
        EVSZVVANVTZVVBUWSKUXEJKUUOZVVGWCWBZWKVVBUYMUWOAVVAUXEUYJUNUYMVMUNAUXDUY
        JUXEUWSKVIZUXDUYJVIZAVWDUWSKUXCWLWMZUUPAUXEBKENAKCVMOPWJZAUYQWDZKBAKCEP
        NOWEAUYQWFUYRBVWJUNZCEWGTBHUYQWOVNZWHZWNZUUQZVVNWKVMVMVIZAVMUURWPZVWQUA
        VUTVMVMUUTZULURZVUTVUTVWRVKUEZUNZVWSVUTVJVUFVUFVXAVUHVUHFFVMVMUUSUVAZVU
        TVWTVWRVWRVUTVXBUVBZUVCUVDUVEZAUBUXDBGUWMUYAUYKUFVUTFVMVMVWAVWEVWQVWQUA
        VXDAGUYCUBUXDUYAUTZBVAURZAUXPUYDUYIWQAUYBUXDWRZBVAURUYCVXFAUXRBUXDUYBFU
        XRUXCXFZULURZFAUBUXRUYAVMUYBAUXEBJDLVVPVVLWNUYHWSUWSJVIZUXDUXRVIZAVVEUW
        SJUXCWLWMZAJVMUXCVVPWTUAVXIVCABUWSFJULURZUMUEZUEZUXDUXCXFZVXIUMUEZUEABU
        WSVUBJUOZXFZUXAUEZJUKZVXOABVXTUNBJUNZBVYAUNAUXBVXTBAVUAVXSVUBVIUWSVXSVI
        ZUXBVXTVIVUJAUWSVXRVUBAUWSCVUBAUWSJCVVEMUVFZVUKVPZAVUBJXAXBVYCAUWSVXRXC
        WPVXSUWSUWTVUBVUNXDVQVUOWHVVLBVXTJVFVGAUWSUWTJULURZUMUEZUEZVYAVXOAVUAVU
        CVXJVYHVYAVJVUJVULVXJAVVEWPUWSUWTVYFVUBJVUNVYFVCXEVQAUWSVYGVXNAVYFVXMUM
        AFVHUNZJCVICXGUNZVYFVXMVJVYIAFUAUVGWPZMAVUGVMXGUNZVYJPXQCVMXGXHXIZJCFVH
        XGXJVQXKXLXMXNAVXPUWSVXQVXNAVXIVXMUMAVXHJFULAVXHJUXCXFZJJUXCXOAUXCJVIVY
        NJVJABJVVLXPUXCJXRXSXTYAXKAVXPUWSUXCXFZUWSUWSUXCXOAUXCUWSVIVYOUWSVJABUW
        SAVYBBKUNZBUWSUNZVVLVWMBJKVFVGZXPUXCUWSXRXSXTZYBVRYCAVXGVXEBVAAVXKVXGVX
        EVJVXLUBUXRUXDUYAYDVOYEXMXNAUWMEBVAURZUBUXDUYKUTZBVAURZAVWBUWMVYTUNZAEB
        FKULURZFYFURUEUNZVWBWUCVBZAVUGVWBKCVIZVWKWUEPNOVWLKBCEWUDFWUDVCZUAUVHUV
        IAKVMVIZVYPWUEWUFUVJVWIVWMKBEWUDFUAWUHUVKYHVLWQAEUXDWRZBVAURVYTWUBAKBUX
        DEFKUXCXFZULURZFNUXDKVIAUXDUWSKUWSUXCUVLZVWDUVMWPZVWIUAWULVCABUWSWUDUMU
        EZUEZVXPWULUMUEZUEABUWSVUBKUOZXFZUXAUEZKUKZWUPABWUTUNVYPBWVAUNAUXBWUTBA
        VUAWUSVUBVIUWSWUSVIZUXBWUTVIVUJAUWSWURVUBVYEAVUBKXAXBWVBAUWSWURXCWPWUSU
        WSUWTVUBVUNXDVQVUOWHVWMBWUTKVFVGAUWSUWTKULURZUMUEZUEZWVAWUPAVUAVUDVWFWV
        EWVAVJVUJVUMVWFAVWDWPUWSUWTWVCVUBKVUNWVCVCXEVQAUWSWVDWUOAWVCWUDUMAVYIWU
        GVYJWVCWUDVJVYKOVYMKCFVHXGXJVQXKXLXMXNZAVXPUWSWUQWUOAWULWUDUMAWUKKFULAU
        XCKVIWUKKVJABKVWMXPUXCKXRXSZYAXKVYSYBVRYCAWUJWUABVAAUBKVMUXDENWUNUVNYEX
        MXNAUFVUTFUVTURZUNZGUWMYGZVWRUNZUFWVJVUTFYFURZUEUNFUAUVOZAGVMUNZUWMVMUN
        WVKAUYFWVNSAJBGCDPLMYSYIZAKVMBENVWMWBZGUWMVMVMYJYHWVJUFVUTFVWRVXCYKVNYL
        AUBUXDBHUWOUYMUWOUFVUTFVMVMVWOVVNVWQVWQUAVXDAHUYOUBUXDUYMUTZBVAURZAUXQU
        YPUYTWQAUYNUXDWRZBVAURUYOWVRAUYJBUXDUYNFUYJUXCXFZULURZFAUBUYJUYMVMUYNVW
        NUYSWSVWHAKVMUXCVWIWTUAWWAVCABWUPVXPWWAUMUEZUEWVFAVXPUWSWWBWUOAWWAWUDUM
        AWVTKFULAWVTWUKKKUXCXOWVGXTYAXKVYSYBVRYCAWVSWVQBVAAVWGWVSWVQVJVWHUBUYJU
        XDUYMYDVOYEXMXNAUWOUBUWSUWOUTZBVAURZUBUXDUWOUTZBVAURZAUBUWSBVMUWOUWOAVV
        JUWSVMVIVWPWWCUWSVMUVPURUNVVMAUWSCVMVYDPWJVWQUBUWOUWSVMUVQVQVYRUXEBVJUW
        OYMUVRAWWDWWCUXDWRZBVAURWWFAUWSBWWCAUBUWSUWOVMWWCAVVJVVFVVMVTWWCVCWSUVS
        AWWGWWEBVAUXDUWSVIWWGWWEVJAWUMUBUWSUXDUWOYDWMYEYNXNAWVIHUWOYGZVWRUNZUFW
        WHWVLUEUNWVMAHVMUNZVVJWWIAUYRWWJTAKBHCEPNOYSYIZVVMHUWOVMVMYJYHWWHUFVUTF
        VWRVXCYKVNYLAUGWVHUNUWNUWPYGZVWRUNZUGWWLWVLUEUNFUAUWAAUWNVMUNUWPVMUNWWM
        AGUWMWVOWVPWKAHUWOWWKVVMWKUWNUWPVMVMYJYHWWLUGVUTFVWRVXCYKVNYLAUXKVUSBVA
        AUBUXDUXJVURVVBUXTUYKUFURZUYLUWOUFURZUGURZUXIUQURWWNUXIUQURZWWOUXIUQURZ
        UGURUXJVURVVBWWNWWOUXIVVBUXTUYKVVBUXSUWOVVIVVBJVMBDVVDAVYBVVAVVLVTZWBZW
        IZVWEWKVVBUYLUWOVVBUYKUWMVWEVVBKVMBEVWCAVYPVVAVWMVTWBZWIZWWTWKVVBUXEBVV
        RVVBJVMBVVQWWSWHWIZVVTUWBVVBWWPUXHUXIUQVVBUXSUYKUFURZUWOUYKUFURZUPURZWX
        FUWOUWMUFURZUPURZUGURWXEWXHUPURWWPUXHVVBWXEWXFWXHVVBUXSUYKVVIVWEWKVVBUW
        OUYKWWTVWEWKVVBUWOUWMWWTWXBWKUWCVVBWWNWXGWWOWXIUGVVBUXSUWOUYKVVIWWTVWEU
        WDVVBWWOUWOUYLUFURWXIVVBUYLUWOWXCWWTUWEVVBUWOUYKUWMWWTVWEWXBUWJYNYOVVBU
        XFWXEUXGWXHUPVVBVVFUXFWXEVJVVGVVBJKUXSUYKUFUWSDEXGXGUXEADJYPZVVAAVVCWXJ
        LJVMDYQVOVTZAEKYPZVVAAVWBWXLNKVMEYQVOVTZAJXGUNZVVAAVVOVYLWXNVVPXQJVMXGX
        HXIZVTZAKXGUNZVVAAWUIVYLWXQVWIXQKVMXGXHXIZVTZUWSVCZVVBUXEJUNVBUXSYMVVBU
        XEKUNVBUYKYMYRYIVVBVYQUXGWXHVJAVYQVVAVYRVTVVBJKUWOUWMUFUWSDEXGXGBWXKWXM
        WXPWXSWXTVVBVYBVBUWOYMVVBVYPVBUWMYMYRYIYOUWFYEVVBWWQVUPWWRVUQUGVVBUXTUY
        KUXIWXAVWEWXDVVTYTVVBUYLUWOUXIWXCWWTWXDVVTYTYOUWGUWHYEVRAUBUWSBUWQCUWTU
        WRUXKFUYGUAUXKVCPAUCUDJKUWSUFVMVMVMDEXGXGUCUSZVMUNUDUSZVMUNVBWYAWYBUFUR
        VMUNAWYAWYBUWKWALNWXOWXRWXTUWIVYDVDUWL $.
    $}

    dvadd.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvadd.df $e |- ( ph -> C e. dom ( S _D F ) ) $.
    dvadd.dg $e |- ( ph -> C e. dom ( S _D G ) ) $.
    $( The sum rule for derivatives at a point.  (Contributed by Mario
       Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 10-Feb-2015.) $)
    dvadd $p |- ( ph -> ( ( S _D ( F oF + G ) ) ` C ) =
                  ( ( ( S _D F ) ` C ) + ( ( S _D G ) ` C ) ) ) $=
      ( co cdv wfun cfv cc wcel caddc cof wbr wceq cr cpr cdm wf dvfg ffun 3syl
      ccnfld ctopn cvv wss recnprss syl fvex a1i wb funfvbrb 4syl mpbid dvaddbr
      eqid funbrfv sylc ) ACDEUAUBOZPOZQZBBCDPOZRZBCEPOZRZUAOZVIUCBVIRVOUDACUES
      UFTZVIUGZSVIUHVJLCVHUIVQSVIUJUKABCDEULUMRZVLVNUNFGHIJKAVPCSUOLCUPUQVLUNTA
      BVKURUSVNUNTABVMURUSABVKUGZTZBVLVKUCZMAVPVSSVKUHVKQVTWAUTLCDUIVSSVKUJBVKV
      AVBVCABVMUGZTZBVNVMUCZNAVPWBSVMUHVMQWCWDUTLCEUIWBSVMUJBVMVAVBVCVRVEVDBVOV
      IVFVG $.

    $( The product rule for derivatives at a point.  (Contributed by Mario
       Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 10-Feb-2015.) $)
    dvmul $p |- ( ph -> ( ( S _D ( F oF x. G ) ) ` C ) =
                  ( ( ( ( S _D F ) ` C ) x. ( G ` C ) ) +
                    ( ( ( S _D G ) ` C ) x. ( F ` C ) ) ) ) $=
      ( cmul co cdv cfv cc wcel cof wfun caddc wbr wceq cr cpr cdm wf dvfg ffun
      3syl ccnfld ctopn cvv wss recnprss syl fvex a1i wb funfvbrb mpbid dvmulbr
      4syl eqid funbrfv sylc ) ACDEOUAPZQPZUBZBBCDQPZRZBEROPBCEQPZRZBDROPUCPZVJ
      UDBVJRVPUEACUFSUGTZVJUHZSVJUIVKLCVIUJVRSVJUKULABCDEUMUNRZVMVOUOFGHIJKAVQC
      SUPLCUQURVMUOTABVLUSUTVOUOTABVNUSUTABVLUHZTZBVMVLUDZMAVQVTSVLUIVLUBWAWBVA
      LCDUJVTSVLUKBVLVBVEVCABVNUHZTZBVOVNUDZNAVQWCSVNUIVNUBWDWEVALCEUJWCSVNUKBV
      NVBVEVCVSVFVDBVPVJVGVH $.
  $}

  ${
    $d x y z F $.  $d x y z G $.  $d x y z ph $.  $d x z S $.  $d x z X $.
    dvaddf.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvaddf.f $e |- ( ph -> F : X --> CC ) $.
    dvaddf.g $e |- ( ph -> G : X --> CC ) $.
    dvaddf.df $e |- ( ph -> dom ( S _D F ) = X ) $.
    dvaddf.dg $e |- ( ph -> dom ( S _D G ) = X ) $.
    $( The sum rule for everywhere-differentiable functions.  (Contributed by
       Mario Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro,
       10-Feb-2015.) $)
    dvaddf $p |- ( ph -> ( S _D ( F oF + G ) ) =
                   ( ( S _D F ) oF + ( S _D G ) ) ) $=
      ( vx co caddc cvv cc wf wcel syl mpbid adantr vy cdv cof cv cfv cr dvbsss
      cpr cdm syl6eqssr ssexd wfn dvfg feq2d ffn recnprss wa addcl adantl inidm
      wss off dvbss wbr ccnfld ctopn fvex a1i eleq2d biimpar wfun ffun funfvbrb
      wb 4syl eqid dvaddbr reldv releldmi ssrdv eqssd eqidd dvadd eqcomd offveq
      ex ) ABCUBLZBDUBLZMUCZLBCDWILZUBLZAKEKUDZWGUEZWLWHUEZMWGWHWKNAEBUFOUHZFAE
      WGUIZBIBCUGUJZUKZAEOWGPZWGEULAWPOWGPZWSABWOQZWTFBCUMZRAWPEOWGIUNSEOWGUORA
      EOWHPZWHEULAWHUIZOWHPZXCAXAXEFBDUMZRAXDEOWHJUNSEOWHUORAEOWKPZWKEULAWKUIZO
      WKPZXGAXAXIFBWJUMRAXHEOWKAXHEAEBWJAXABOVAZFBUPRZAKUAEEEMOOOCDNNWLOQUAUDZO
      QUQWLXLMLOQAWLXLURUSGHWRWREUTVBWQVCAKEXHAWLEQZWLXHQZAXMUQZWLWMWNMLZWKVDXN
      XOWLBCDVEVFUEZWMWNNEEAEOCPXMGTZAEBVAXMWQTZAEODPXMHTZXSAXJXMXKTWMNQXOWLWGV
      GVHWNNQXOWLWHVGVHXOWLWPQZWLWMWGVDZAYAXMAWPEWLIVIVJZXOXAWTWGVKYAYBVNAXAXMF
      TZXBWPOWGVLWLWGVMVOSXOWLXDQZWLWNWHVDZAYEXMAXDEWLJVIVJZXOXAXEWHVKYEYFVNYDX
      FXDOWHVLWLWHVMVOSXQVPVQWLXPWKBWJVRVSRWFVTWAUNSEOWKUORXOWMWBXOWNWBXOWLWKUE
      XPXOWLBCDEEXRXSXTXSYDYCYGWCWDWEWD $.

    $( The product rule for everywhere-differentiable functions.  (Contributed
       by Mario Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro,
       10-Feb-2015.) $)
    dvmulf $p |- ( ph -> ( S _D ( F oF x. G ) ) =
                   ( ( ( S _D F ) oF x. G ) oF + ( ( S _D G ) oF x. F ) ) ) $=
      ( vx cmul co cfv wcel cc wf adantr cvv a1i vy cv cof cdv caddc wa wss cdm
      cmpt dvbsss syl6eqssr cr cpr eleq2d biimpar dvmul mpteq2dva dvfg recnprss
      syl mulcl adantl ssexd inidm off dvbss wbr ccnfld ctopn fvex wfun wb ffun
      funfvbrb 3syl mpbid eqid dvmulbr reldv releldmi ssrdv eqssd feq2d feqmptd
      ex ovex offval2 3eqtr4d ) AKEKUBZBCDLUCZMZUDMZNZUIKEWIBCUDMZNZWIDNZLMZWIB
      DUDMZNZWICNZLMZUEMZUIWLWNDWJMZWRCWJMZUEUCMAKEWMXBAWIEOZUFZWIBCDEEAEPCQXEG
      RZAEBUGXEAEWNUHZBIBCUJUKZRZAEPDQXEHRZXJABULPUMZOZXEFRAWIXHOZXEAXHEWIIUNUO
      ZAWIWRUHZOZXEAXPEWIJUNUOZUPUQAKEPWLAWLUHZPWLQZEPWLQAXMXTFBWKURUTAXSEPWLAX
      SEAEBWKAXMBPUGZFBUSUTZAKUAEEELPPPCDSSWIPOUAUBZPOUFWIYCLMPOAWIYCVAVBGHAEBX
      LFXIVCZYDEVDVEXIVFAKEXSAXEWIXSOZXFWIXBWLVGYEXFWIBCDVHVINZWOWSSEEXGXJXKXJA
      YAXEYBRWOSOXFWIWNVJTZWSSOXFWIWRVJTZXFXNWIWOWNVGZXOXFXHPWNQZWNVKXNYIVLAYJX
      EAXMYJFBCURUTZRXHPWNVMWIWNVNVOVPXFXQWIWSWRVGZXRXFXPPWRQZWRVKXQYLVLAYMXEAX
      MYMFBDURUTZRXPPWRVMWIWRVNVOVPYFVQVRWIXBWLBWKVSVTUTWEWAWBWCVPWDAKEWQXAUEXC
      XDSSSYDWQSOXFWOWPLWFTXASOXFWSWTLWFTAKEWOWPLWNDSSSYDYGWPSOXFWIDVJTAKEPWNAY
      JEPWNQYKAXHEPWNIWCVPWDAKEPDHWDWGAKEWSWTLWRCSSSYDYHWTSOXFWICVJTAKEPWRAYMEP
      WRQYNAXPEPWRJWCVPWDAKEPCGWDWGWGWH $.
  $}

  ${
    $d x A $.  $d x F $.  $d x ph $.  $d x S $.  $d x X $.
    dvcmul.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvcmul.f $e |- ( ph -> F : X --> CC ) $.
    dvcmul.a $e |- ( ph -> A e. CC ) $.
    ${
      dvcmul.x $e |- ( ph -> X C_ S ) $.
      dvcmul.c $e |- ( ph -> C e. dom ( S _D F ) ) $.
      $( The product rule when one argument is a constant.  (Contributed by
         Mario Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro,
         10-Feb-2015.) $)
      dvcmul $p |- ( ph -> ( ( S _D ( ( S X. { A } ) oF x. F ) ) ` C ) =
                     ( A x. ( ( S _D F ) ` C ) ) ) $=
        ( cxp cmul co cdv cfv cc0 cc syl wceq csn cof wcel wf fconst6g wss ssid
        caddc a1i cdm cr cpr recnprss dvbss sseldd cres dvconst dmeqd c0ex fdmi
        fconst syl6eq sseqtr4d dvres3 syl22anc xpssres oveq2d reseq1d eqtrd fdm
        3eqtr3d sylibr eleqtrrd dvmul fveq1d fvconst2 oveq1d ffvelrnd fvconst2g
        fconst2 mul02d syl2anc dvfg mulcomd oveq12d mulcld addid2d 3eqtrd ) ACD
        DBUAZLZEMUBNONPCDWJONZPZCEPZMNZCDEONZPZCWJPZMNZUHNQBWPMNZUHNWSACDWJEDFA
        BRUCZDRWJUDIDBRUESDDUFADUGUIHJGACDWKUJZAFDCJAWOUJZFCAFDEADUKRULUCZDRUFZ
        GDUMSZHJUNKUOZUOZADQUAZWKUDZXADTAWKDXHLZTXIADRWILZDUPZONZRXKONZDUPZWKXJ
        AXCRRXKUDZRRUFZDXNUJZUFXMXOTGAWTXPIRBRUESXQARUGUIADRXRXEAXRRXHLZUJRAXNX
        SAWTXNXSTIBUQSZURRXHXSRQUSVAUTVBVCRDXKVDVEAXLWJDOAXDXLWJTXERWIDVFSVGAXO
        XSDUPZXJAXNXSDXTVHAXDYAXJTXERXHDVFSVIVKZDQWKUSVTVLDXHWKVJSVMKVNAWNQWRWS
        UHAWNQWMMNQAWLQWMMAWLCXJPZQACWKXJYBVOACDUCZYCQTXGDQCUSVPSVIVQAWMAFRCEHX
        FVRWAVIAWRWPBMNWSAWQBWPMAWTYDWQBTIXGDBCRVSWBVGAWPBAXBRCWOAXCXBRWOUDGDEW
        CSKVRZIWDVIWEAWSABWPIYEWFWGWH $.
    $}

    dvcmulf.df $e |- ( ph -> dom ( S _D F ) = X ) $.
    $( The product rule when one argument is a constant.  (Contributed by Mario
       Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 10-Feb-2015.) $)
    dvcmulf $p |- ( ph -> ( S _D ( ( S X. { A } ) oF x. F ) ) =
                          ( ( S X. { A } ) oF x. ( S _D F ) ) ) $=
      ( vx cmul co cdv wf cc wcel syl cc0 wceq cvv csn cxp cof wss fconstg c0ex
      caddc snssd fss syl2anc cdm fconst cres ccnfld ctopn cfv crest cnt cr cpr
      recnprss ssid a1i dvbsss eqsstr3d eqid dvres syl22anc cmpt resmpt reseq1i
      fconstmpt 3eqtr4g oveq2d dvconst dmeqd fdmi syl6eq dvres3 xpssres reseq1d
      sseqtr4d eqtrd 3eqtr3d ctop ctopon cnfldtopon resttopon topontop toponuni
      cuni sylancr sseqtrd ntrss2 dvbssntr eqssd reseq12d 3eqtr4d mpbiri dvmulf
      feq1d fdm cin cv sseqin2 sylib mpteq1d wfn ssexd fvconst2g sylan wa eqidd
      ffn offval inidm dvfg feq2d mpbid ovex oveq1d mul02 adantl caofid2 adantr
      0cn fvex feqmptd offval2 ffvelrnda mulcld addid2d mulcomd mpteq2dva ) ACE
      BUAZUBZDKUCZLZMLCYPMLZDYQLZCDMLZYPYQLZUGUCLZCCYOUBZDYQLZMLUUDUUAYQLZACYPD
      EFAEYOYPNZYOOUDZEOYPNABOPZUUGHEBOUEQZABOHUHZEYOOYPUIUJGAERUAZYSNZYSUKESAU
      UMEUULEUULUBZNERUFULAEUULYSUUNACUUDEUMZMLZCUUDMLZEUNUOUPZCUQLZURUPUPZUMZY
      SUUNACOUDZCOUUDNZCCUDZECUDZUUPUVASACUSOUTZPZUVBFCVAQZACYOUUDNZUUHUVCAUUIU
      VIHCBOUEQZUUKCYOOUUDUIUJUVDACVBVCAEUUAUKZCIUVKCUDACDVDVCVEZCECUUSUUDUURUU
      RVFZUUSVFZVGVHAUUOYPCMAJCBVIZEUMZJEBVIZUUOYPAUVEUVPUVQSUVLJCEBVJQUUDUVOEJ
      CBVLVKJEBVLZVMVNAJCRVIZEUMZJERVIZUVAUUNAUVEUVTUWASUVLJCERVJQAUUQUVSUUTEAU
      UQCUULUBZUVSACOYOUBZCUMZMLZOUWCMLZCUMZUUQUWBAUVGOOUWCNZOOUDZCUWFUKZUDUWEU
      WGSFAOYOUWCNZUUHUWHAUUIUWKHOBOUEQUUKOYOOUWCUIUJUWIAOVBVCACOUWJUVHAUWJOUUL
      UBZUKOAUWFUWLAUUIUWFUWLSHBVOQZVPOUULUWLORUFULVQVRWBOCUWCVSVHAUWDUUDCMAUVB
      UWDUUDSUVHOYOCVTQVNAUWGUWLCUMZUWBAUWFUWLCUWMWAAUVBUWNUWBSUVHOUULCVTQWCWDJ
      CRVLVRAUUTEAUUSWEPZEUUSWKZUDUUTEUDAUUSCWFUPPZUWOAUUROWFUPPUVBUWQUURUVMWGU
      VHCUUROWHWLZCUUSWIQAECUWPUVLAUWQCUWPSUWRCUUSWJQWMEUUSUWPUWPVFWNUJAEUVKUUT
      IAECDUUSUURUVHGUVLUVNUVMWOVEWPWQUUNUWASAJERVLZVCWRWDZXAWSEUULYSXBQIWTAUUE
      YRCMAJCEXCZBJXDZDUPZKLZVIJEUXDVIUUEYRAJUXAEUXDAUVEUXAESUVLECXEXFZXGAJCEBU
      XCKUXAUUDDUVFTAUVIUUDCXHUVJCYOUUDXNQZAEODNDEXHGEODXNQZFAECUVFFUVLXIZUXAVF
      ZAUUIUXBCPUXBUUDUPBSHCBUXBOXJXKZAUXBEPZXLZUXCXMZXOAJEEBUXCKEYPDTTAUUGYPEX
      HUUJEYOYPXNQUXGUXHUXHEXPAUUIUXKUXBYPUPBSHEBUXBOXJXKUXMXOWRVNAJUXABUXBUUAU
      PZKLZVIJEUXOVIZUUFUUCAJUXAEUXOUXEXGAJCEBUXNKUXAUUDUUAUVFTUXFAEOUUANZUUAEX
      HAUVKOUUANZUXQAUVGUXRFCDXQQAUVKEOUUAIXRXSZEOUUAXNQFUXHUXIUXJUXLUXNXMXOAUU
      CJERUXNBKLZUGLZVIUXPAJERUXTUGYTUUBTOTUXHROPZUXLYFVCUXTTPUXLUXNBKXTVCAYTUU
      NUWAAYTUUNDYQLUUNAYSUUNDYQUWTYAAJERRKODTOOUXHGUYBAYFVCZUYCUXBOPRUXBKLRSAU
      XBYBYCYDWCUWSVRAJEUXNBKUUAYPTTOUXHUXNTPUXLUXBUUAYGVCAUUIUXKHYEZAJEOUUAUXS
      YHYPUVQSAUVRVCYIYIAJEUYAUXOUXLUYAUXTUXOUXLUXTUXLUXNBAEOUXBUUAUXSYJZUYDYKY
      LUXLUXNBUYEUYDYMWCYNWCWRWR $.
  $}

  ${
    $d y z C $.  $d y z F $.  $d y z G $.  $d y z J $.  $d z L $.  $d y z ph $.
    $d y z K $.  $d y S $.  $d z T $.  $d y z X $.  $d z Y $.
    dvco.f $e |- ( ph -> F : X --> CC ) $.
    dvco.x $e |- ( ph -> X C_ S ) $.
    dvco.g $e |- ( ph -> G : Y --> X ) $.
    dvco.y $e |- ( ph -> Y C_ T ) $.
    ${
      dvcobr.s $e |- ( ph -> S C_ CC ) $.
      dvcobr.t $e |- ( ph -> T C_ CC ) $.
      dvco.k $e |- ( ph -> K e. V ) $.
      dvco.l $e |- ( ph -> L e. V ) $.
      dvco.bf $e |- ( ph -> ( G ` C ) ( S _D F ) K ) $.
      dvco.bg $e |- ( ph -> C ( T _D G ) L ) $.
      dvco.j $e |- J = ( TopOpen ` CCfld ) $.
      $( The chain rule for derivatives at a point.  (Contributed by Mario
         Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 28-Dec-2016.) $)
      dvcobr $p |- ( ph -> C ( T _D ( F o. G ) ) ( K x. L ) ) $=
        ( vz vy cmul co ccom cdv wbr crest cnt cfv wcel csn cdif cmin cdiv cmpt
        cv climc wa eqid wf cc wss sstrd fss syl2anc eldv mpbid simpld wceq cif
        ctx dvcl mpdan ad2antrr adantr eldifi ffvelrn syl2an ffvelrnd cdm dvbss
        wn wrel reldv releldm sylancr sseldd subcld ad2antlr cc0 simpr subeq0ad
        wne necon3abid mpbird divcld ifclda dvlem a1i ctopon cnfldtopon txtopon
        ssid mp2an toponunii restid ax-mp eqcomi anim1i eldifsn sylibr eldifsni
        cxp anasss ifnefalse adantl eqeltrd cres limcresi feqmptd reseq1d difss
        syl resmpt syl6eq oveq1d syl5sseq ccnp dvcnp2 simprd fveq2 oveq1 eqeq1d
        oveq12d eqtrd fvco3 syl31anc wb cnplimc mpteq2ia oveq1i syl6eleqr eqeq1
        ifbieq2d iftrue ad2antll limcco ccn cop opelxpi cncnpi limccnp2 biimpar
        mulcn mul01d subne0d div0d oveq2d syl5ibr imp 3eqtr4d dmdcan2d ifbothda
        eqtr4d mpteq2dva eleqtrd fco mpbir2and ) ABHIUFUGZDEFUHZUIUGUJBLGDUKUGZ
        ULUMUMUNZUVMUDLBUOZUPZUDUTZUVNUMZBUVNUMZUQUGZUVSBUQUGZURUGZUSZBVAUGZUNA
        UVPIUDUVRUVSFUMZBFUMZUQUGZUWCURUGZUSZBVAUGUNZABIDFUIUGZUJZUVPUWLVBUBAUD
        LBIDUVOFUWKGUVOVCZUCUWKVCRALKFVDZKVEVFZLVEFVDZOAKCVENQVGZLKVEFVHVIZPVJV
        KZVLAUVMUDUVRUWGUWHVMZHUWGEUMZUWHEUMZUQUGZUWIURUGZVNZUWJUFUGZUSZBVAUGUW
        FAUDUVRBHIUXGUWJUFGGVOUGZGVEVEAUVSUVRUNZVBZUXBHUXFVEAHVEUNZUXKUXBAUWHHC
        EUIUGUJZUXMUAAKUWHHCEQMNVPVQZVRZUXLUXBWFZVBZUXEUWIUXRUXCUXDUXLUXCVEUNUX
        QUXLKVEUWGEAKVEEVDZUXKMVSZAUWPUVSLUNZUWGKUNZUXKOUVSLUVQVTZLKUVSFWAWBZWC
        ZVSUXLUXDVEUNUXQUXLKVEUWHEUXTUXLLKBFAUWPUXKOVSABLUNZUXKAUWMWDZLBALDFRUW
        TPWEAUWMWGUWNBUYGUNZDFWHUBBIUWMWIWJZWKZVSZWCZWCZVSWLZUXRUWGUWHUXRLVEUVS
        FAUWRUXKUXQUWTVRZUXKUYAAUXQUYCWMWCZUXRLVEBFUYOAUYFUXKUXQUYJVRWCZWLZUXRU
        WIWNWQUXQUXLUXQWOUXRUXBUWIWNUXRUWGUWHUYPUYQWPWRWSZWTXAAUVSBLFUWTALDVEPR
        VGZUYJXBVEVEVFAVEXGXCZVUAUCUXJVEVEXQZUKUGZUXJUXJVUBXDUMZUNZVUCUXJVMGVEX
        DUMUNZVUFVUEGUCXEZVUGGGVEVEXFXHZUXJVUDVUBVUBUXJVUHXIZXJXKXLAUDUEUVRKUWH
        UOUPZUWHHUWGUEUTZUWHVMZHVUKEUMZUXDUQUGZVUKUWHUQUGZURUGZVNZUXGBAUXKUWGUW
        HWQZUWGVUJUNZUXLVURVBUYBVURVBVUSUXLUYBVURUYDXMUWGKUWHXNXOXRAVUKVUJUNZVB
        VUQVUPVEVUTVUQVUPVMZAVUTVUKUWHWQVVAVUKKUWHXPVUKUWHHVUPXSYGZXTAVUKUWHKEM
        UWSALKBFOUYJWCXBYAAFBVAUGZUDUVRUWGUSZBVAUGZUWHAFUVRYBZBVAUGVVCVVEBUVRFY
        CAVVFVVDBVAAVVFUDLUWGUSZUVRYBZVVDAFVVGUVRAUDLKFOYDYEUVRLVFVVHVVDVMLUVQY
        FUDLUVRUWGYHXKYIYJYKAUWRUWHVVCUNZAFBGLUKUGZGYLUGUMUNZUWRVVIVBZADVEVFUWR
        LDVFUYHVVKRUWTPUYILBDFVVJGVVJVCZUCYMUUAALVEVFZUYFVVKVVLUUBUYTUYJLBFVVJG
        UCVVMUUCVIVKYNWKAHUEVUJVUPUSZUWHVAUGZUEVUJVUQUSZUWHVAUGAUWHKGCUKUGZULUM
        UMUNZHVVPUNZAUXNVVSVVTVBUAAUEKUWHHCVVREVVOGVVRVCUCVVOVCQMNVJVKYNVVQVVOU
        WHVAUEVUJVUQVUPVVBUUDUUEUUFVUKUWGVMZVULUXBVUPUXFHVUKUWGUWHUUGVWAVUNUXEV
        UOUWIURVWAVUMUXCUXDUQVUKUWGEYOYJVUKUWGUWHUQYPYRUUHUXBUXGHVMAUXKUXBHUXFU
        UIUUJUUKAUVPUWLUXAYNAUFUXJGUULUGUNHIUUMZVUBUNZUFVWBUXJGYLUGUMUNGUCUURAU
        XMIVEUNZVWCUXOAUWNVWDUBALBIDFRUWTPVPVQHIVEVEUUNVIVWBUFUXJGVUBVUIUUOWJUU
        PAUXIUWEBVAAUDUVRUXHUWDUXLUXHUXEUWCURUGZUWDUXBHUWJUFUGZVWEVMUXFUWJUFUGZ
        VWEVMUXHVWEVMUXLHUXFHUXGVMVWFUXHVWEHUXGUWJUFYPYQUXFUXGVMVWGUXHVWEUXFUXG
        UWJUFYPYQUXLUXBVBZHWNUFUGWNVWFVWEVWHHUXPUUSVWHUWJWNHUFVWHUWJWNUWCURUGZW
        NVWHUWIWNUWCURUXLUWIWNVMUXBUXLUWGUWHUXLKVEUWGAUWQUXKUWSVSZUYDWKUXLKVEUW
        HVWJUYLWKWPUUQYJUXLVWIWNVMUXBUXLUWCUXLUVSBUXLLVEUVSAVVNUXKUYTVSZUXKUYAA
        UYCXTWKZUXLLVEBVWKUYKWKZWLZUXLUVSBVWLVWMUXKUVSBWQAUVSLBXPXTUUTZUVAVSZYS
        UVBVWHVWEVWIWNVWHUXEWNUWCURUXLUXBUXEWNVMZUXBVWQUXLUXCUXDVMUWGUWHEYOUXLU
        XCUXDUYEUYMWPUVCUVDYJVWPYSUVEUXRUXEUWIUWCUYNUYRUXLUWCVEUNUXQVWNVSUYSUXL
        UWCWNWQUXQVWOVSUVFUVGUXLUWBUXEUWCURUXLUVTUXCUWAUXDUQAUWPUYAUVTUXCVMUXKO
        UYCLKUVSEFYTWBAUWAUXDVMZUXKAUWPUYFVWROUYJLKBEFYTVIVSYRYJUVHUVIYJUVJAUDL
        BUVMDUVOUVNUWEGUWOUCUWEVCRAUXSUWPLVEUVNVDMOLKVEEFUVKVIPVJUVL $.
    $}

    dvco.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvco.t $e |- ( ph -> T e. { RR , CC } ) $.
    dvco.df $e |- ( ph -> ( G ` C ) e. dom ( S _D F ) ) $.
    dvco.dg $e |- ( ph -> C e. dom ( T _D G ) ) $.
    $( The chain rule for derivatives at a point.  (Contributed by Mario
       Carneiro, 9-Aug-2014.)  (Revised by Mario Carneiro, 10-Feb-2015.) $)
    dvco $p |- ( ph -> ( ( T _D ( F o. G ) ) ` C ) =
                 ( ( ( S _D F ) ` ( G ` C ) ) x. ( ( T _D G ) ` C ) ) ) $=
      ( co cfv cc wcel ccom cdv wfun cmul wbr wceq cr cpr cdm wf dvfg ffun 3syl
      ccnfld ctopn cvv wss recnprss syl fvex wb funfvbrb 4syl mpbid eqid dvcobr
      a1i funbrfv sylc ) ADEFUAZUBQZUCZBBFRZCEUBQZRZBDFUBQZRZUDQZVKUEBVKRVRUFAD
      UGSUHZTZVKUIZSVKUJVLNDVJUKWASVKULUMABCDEFUNUORZVOVQUPGHIJKLACVSTZCSUQMCUR
      USAVTDSUQNDURUSVOUPTAVMVNUTVGVQUPTABVPUTVGAVMVNUIZTZVMVOVNUEZOAWCWDSVNUJV
      NUCWEWFVAMCEUKWDSVNULVMVNVBVCVDABVPUIZTZBVQVPUEZPAVTWGSVPUJVPUCWHWIVANDFU
      KWGSVPULBVPVBVCVDWBVEVFBVRVKVHVI $.
  $}

  ${
    $d x y z F $.  $d x y z G $.  $d x z ph $.  $d x y z S $.  $d x y z X $.
    $d x z T $.  $d x z Y $.
    dvcof.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvcof.t $e |- ( ph -> T e. { RR , CC } ) $.
    dvcof.f $e |- ( ph -> F : X --> CC ) $.
    dvcof.g $e |- ( ph -> G : Y --> X ) $.
    dvcof.df $e |- ( ph -> dom ( S _D F ) = X ) $.
    dvcof.dg $e |- ( ph -> dom ( T _D G ) = Y ) $.
    $( The chain rule for everywhere-differentiable functions.  (Contributed by
       Mario Carneiro, 10-Aug-2014.)  (Revised by Mario Carneiro,
       10-Feb-2015.) $)
    dvcof $p |- ( ph -> ( T _D ( F o. G ) ) =
                 ( ( ( S _D F ) o. G ) oF x. ( T _D G ) ) ) $=
      ( vx cfv wcel cc wf adantr syl vy cv ccom cdv co cmpt cmul cof wa wss cdm
      dvbsss syl6eqssr cr ffvelrnda wceq eleqtrrd eleq2d biimpar dvco mpteq2dva
      cpr dvfg recnprss fco syl2anc dvbss wbr ccnfld ctopn cvv fvex a1i wfun wb
      ffun funfvbrb 4syl mpbid eqid reldv releldmi ex ssrdv eqssd feq2d feqmptd
      dvcobr ssexd fveq2 fmptco offval2 3eqtr4d ) ANGNUBZCDEUCZUDUEZOZUFNGWNEOZ
      BDUDUEZOZWNCEUDUEZOZUGUEZUFWPWSEUCZXAUGUHUEANGWQXCAWNGPZUIZWNBCDEFGAFQDRZ
      XEJSZAFBUJXEAFWSUKZBLBDULUMSZAGFERZXEKSZAGCUJXEAGXAUKZCMCEULUMZSZABUNQVBZ
      PZXEHSZACXPPZXEISZXFWRFXIAGFWNEKUOZAXIFUPXELSUQZAWNXMPZXEAXMGWNMURUSZUTVA
      ANGQWPAWPUKZQWPRZGQWPRAXSYFICWOVCTAYEGQWPAYEGAGCWOAXSCQUJZICVDZTAXGXKGQWO
      RJKGFQDEVEVFXNVGANGYEAXEWNYEPZXFWNXCWPVHYIXFWNBCDEVIVJOZWTXBVKFGXHXJXLXOX
      FXQBQUJXRBVDTXFXSYGXTYHTWTVKPXFWRWSVLVMZXBVKPXFWNXAVLVMZXFWRXIPZWRWTWSVHZ
      YBXFXQXIQWSRZWSVNYMYNVOXRBDVCZXIQWSVPWRWSVQVRVSXFYCWNXBXAVHZYDXFXSXMQXARZ
      XAVNYCYQVOXTCEVCZXMQXAVPWNXAVQVRVSYJVTWHWNXCWPCWOWAWBTWCWDWEWFVSWGANGWTXB
      UGXDXAVKVKVKAGCXPIXNWIYKYLANUAGFWRUAUBZWSOWTEWSYAANGFEKWGAUAFQWSAYOFQWSRA
      XQYOHYPTAXIFQWSLWFVSWGYTWRWSWJWKANGQXAAYRGQXARAXSYRIYSTAXMGQXAMWFVSWGWLWM
      $.
  $}

  ${
    $d x y C $.  $d x y F $.  $d x ph $.  $d x X $.
    dvcj.f $e |- ( ph -> F : X --> CC ) $.
    dvcj.x $e |- ( ph -> X C_ RR ) $.
    dvcj.c $e |- ( ph -> C e. dom ( RR _D F ) ) $.
    $( The derivative of the conjugate of a function.  (This doesn't follow
       from ~ dvcobr because ` * ` is not a function on the reals, and even if
       we used complex derivatives, ` * ` is not complex-differentiable.)
       (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by Mario
       Carneiro, 10-Feb-2015.) $)
    dvcjbr $p |- ( ph ->
      C ( RR _D ( * o. F ) ) ( * ` ( ( RR _D F ) ` C ) ) ) $=
      ( vx cr co cfv ccj wcel cmin cdiv climc cc wss a1i wf vy cdv ccom wbr crn
      cioo ctg cnt csn cdif cv cmpt ccnfld ctopn ax-resscn eqid tgioo2 dvbssntr
      cdm sseldd syl6ss simpl simpr dvbss syl2anc dvlem fmptd ssid crest ctopon
      wceq cnfldtopon toponunii restid ax-mp eqcomi wfun dvf ffun funfvbrb mp2b
      wa sylib eldv mpbid simprd ccn ccnp ccncf cjcncf cncfcn1 eleqtri ffvelrni
      wb syl cncnpi sylancr limccnp eqidd cjf fveq2 fmptco adantr eldifi adantl
      feqmptd ffvelrnd subcld sselda sylan2 resubcld recnd wne eldifsni subne0d
      cjdivd cjsub fvco3 syl2an oveq12d eqtr4d cjred eqtrd mpteq2dva oveq1d fco
      eleqtrd mpbir2and ) ABBICUBJZKZLKZILCUCZUBJUDBDUFUEUGKZUHKKZMZYKHDBUIZUJZ
      HUKZYLKZBYLKZNJZYRBNJZOJZULZBPJZMAYIUSZYNBADICYMUMUNKZIQRZAUOSZEFUUGUUGUP
      ZUQZUUJURGUTAYKLHYQYRCKZBCKZNJZUUBOJZULZUCZBPJUUEAYQBYJQUUPLUUGUUGAHYQUUO
      QUUPAYRBDCEADIQFUOVAAUUFDBADQCTZDIRZUUFDREFUURUUSWBZDICUUHUUTUOSUURUUSVBU
      URUUSVCVDVEGUTZVFZUUPUPZVGQQRAQVHSUUJUUGQVIJZUUGUUGQVJKZMUVDUUGVKUUGUUJVL
      ZUUGUVEQQUUGUVFVMZVNVOVPAYOYJUUPBPJMZABYJYIUDZYOUVHWBABUUFMZUVIGUUFQYITYI
      VQUVJUVIWNCVRZUUFQYIVSBYIVTWAWCAHDBYJIYMCUUPUUGUUKUUJUVCUUIEFWDWEWFALUUGU
      UGWGJZMYJQMZLYJUUGUUGWHJKMLQQWIJUVLWJUUGUUJWKWLAUVJUVMGUUFQBYIUVKWMWOYJLU
      UGUUGQUVGWPWQWRAUUQUUDBPAUUQHYQUUOLKZULUUDAHUAYQQUUOUAUKZLKUVNUUPLUVBAUUP
      WSAUAQQLQQLTZAWTSXFUVOUUOLXAXBAHYQUVNUUCAYRYQMZWBZUVNUUNLKZUUBLKZOJUUCUVR
      UUNUUBUVRUULUUMUVRDQYRCAUURUVQEXCUVQYRDMZAYRDYPXDZXEXGZAUUMQMZUVQADQBCEUV
      AXGXCZXHUVRUUBUVRYRBUVQAUWAYRIMUWBADIYRFXIXJZABIMUVQADIBFUVAUTXCZXKZXLUVR
      YRBUVRYRUWFXLUVRBUWGXLUVQYRBXMAYRDBXNXEXOXPUVRUVSUUAUVTUUBOUVRUVSUULLKZUU
      MLKZNJZUUAUVRUULQMUWDUVSUWKVKUWCUWEUULUUMXQVEUVRYSUWIYTUWJNAUURUWAYSUWIVK
      UVQEUWBDQYRLCXRXSAYTUWJVKZUVQAUURBDMUWLEUVADQBLCXRVEXCXTYAUVRUUBUWHYBXTYC
      YDYCYEYGAHDBYKIYMYLUUDUUGUUKUUJUUDUPUUIAUVPUURDQYLTWTEDQQLCYFWQFWDYH $.
  $}

  ${
    $d x y F $.  $d x X $.
    $( The derivative of the conjugate of a function.  (Contributed by Mario
       Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro, 10-Feb-2015.) $)
    dvcj $p |- ( ( F : X --> CC /\ X C_ RR ) ->
      ( RR _D ( * o. F ) ) = ( * o. ( RR _D F ) ) ) $=
      ( vx vy cc wf cr wa cdv co cdm cv ccj ccom cmpt wcel feqmptd fveq2 fmptco
      cfv wss wfun wbr wceq ffun ax-mp simpll simplr simpr dvcjbr funbrfv mpsyl
      dvf mpteq2dva cjf fco mpan ad2antrr vex fvex breldm ssrdv ffvelrn adantlr
      syl cjcjd cjcld simpl a1i 3eqtr4d oveq2d dmeqd eqssd feq2d mpbii ffvelrni
      ex sseqtrd adantl ) BEAFZBGUAZHZCGAIJZKZCLZGMANZIJZTZOCWDWEWCTZMTZOWGMWCN
      WBCWDWHWJWGUBZWBWEWDPZHZWEWJWGUCZWHWJUDWGKZEWGFZWKWFUMZWOEWGUEUFWMWEABVTW
      AWLUGVTWAWLUHWBWLUIUJZWEWJWGUKULUNWBCWDEWGWBWPWDEWGFWQWBWOWDEWGWBWOWDWBWO
      GMWFNZIJZKZWDWBCWOXAWBWEWOPZWEXAPZWBXBHZWEWHMTZWTUCXCXDWEWFBVTBEWFFZWAXBE
      EMFZVTXFUOBEEMAUPUQURVTWAXBUHWBXBUIUJWEXEWTCUSZWHMUTVAVEVQVBWBWTWCWBWSAGI
      WBCBWEATZMTZMTZOCBXIOWSAWBCBXKXIWBWEBPZHZXIVTXLXIEPWABEWEAVCVDZVFUNWBCDBE
      XJDLZMTZXKWFMXMXIXNVGWBCDBEXIXPXJAMXNWBCBEAVTWAVHQZWBDEEMXGWBUOVIQZXOXIMR
      SXRXOXJMRSXQVJVKVLVRWBCWDWOWBWLXBWMWNXBWRWEWJWGXHWIMUTVAVEVQVBVMVNVOQWBCD
      WDEWIXPWJWCMWLWIEPWBWDEWEWCAUMZVPVSWBCWDEWCWDEWCFWBXSVIQXRXOWIMRSVJ $.
  $}

  ${
    $d n x y A $.  $d n x y z F $.  $d x N $.
    $( The derivative of a real function is real.  (Contributed by Mario
       Carneiro, 1-Sep-2014.) $)
    dvfre $p |- ( ( F : A --> RR /\ A C_ RR ) ->
                  ( RR _D F ) : dom ( RR _D F ) --> RR ) $=
      ( vx vy vz cr wf wss wa cdv co cv cfv wcel cc ccj ccom wceq cmpt feqmptd
      cdm wfn wral dvf mp1i ffvelrni adantl simpr fvco3 sylancr ax-resscn mpan2
      ffn fss dvcj sylan ffvelrn adantlr cjred mpteq2dva recnd simpl cjf fmptco
      fveq2 3eqtr4d oveq2d eqtr3d fveq1d adantr cjrebd ralrimiva ffnfv sylanbrc
      a1i ) AFBGZAFHZIZFBJKZVSUAZUBZCLZVSMZFNZCVTUCVTFVSGVTOVSGZWAVRBUDZVTOVSUM
      UEVRWDCVTVRWBVTNZIZWCWGWCONVRVTOWBVSWFUFUGWHWBPVSQZMZWCPMZWCWHWEWGWJWKRWF
      VRWGUHVTOWBPVSUIUJVRWJWCRWGVRWBWIVSVRFPBQZJKZWIVSVPAOBGZVQWMWIRVPFOHWNUKA
      FOBUNULBAUOUPVRWLBFJVRDADLZBMZPMZSDAWPSWLBVRDAWQWPVRWOANZIZWPVPWRWPFNVQAF
      WOBUQURZUSUTVRDEAOWPELZPMWQBPWSWPWTVAVRDAFBVPVQVBTZVREOOPOOPGVRVCVOTXAWPP
      VEVDXBVFVGVHVIVJVHVKVLCVTFVSVMVN $.

    $( The ` N ` -th derivative of a real function is real.  (Contributed by
       Mario Carneiro, 1-Jan-2017.) $)
    dvnfre $p |- ( ( F : A --> RR /\ A C_ RR /\ N e. NN0 ) ->
                  ( ( RR Dn F ) ` N ) : dom ( ( RR Dn F ) ` N ) --> RR ) $=
      ( cr wf wss wcel co cfv cdm wa wi cc0 wceq fveq2 dmeqd feq12d imbi2d cvv
      cc vx vn cn0 cdvn cv caddc simpl cpm ax-resscn fss mpan2 cnex reex elpm2r
      c1 mpanl12 sylan sylancr fdm adantr eqtrd mpbird cdv simprr cpr prid1 a1i
      dvn0 simprl dvnbss syl3anc sseqtrd simplr sstrd dvfre syl2anc expr expcom
      dvnp1 a2d nn0ind com12 3impia ) ADBEZADFZCUCGZCDBUDHZIZJZDWHEZWFWDWEKZWJW
      KUAUEZWGIZJZDWMEZLWKMWGIZJZDWPEZLWKUBUEZWGIZJZDWTEZLWKWSUOUFHZWGIZJZDXDEZ
      LWKWJLUAUBCWLMNZWOWRWKXGWNWQDWMWPWLMWGOZXGWMWPXHPQRWLWSNZWOXBWKXIWNXADWMW
      TWLWSWGOZXIWMWTXJPQRWLXCNZWOXFWKXKWNXEDWMXDWLXCWGOZXKWMXDXLPQRWLCNZWOWJWK
      XMWNWIDWMWHWLCWGOZXMWMWHXNPQRWKWRWDWDWEUGWKWQADWPBWKDTFZBTDUHHGZWPBNUIWDA
      TBEZWEXPWDXOXQUIADTBUJUKTSGDSGXQWEKXPULUMTDABSSUNUPUQZDBVHURZWKWQBJZAWKWP
      BXSPWDXTANZWEADBUSUTZVAQVBWSUCGZWKXBXFWKYCXBXFLWKYCXBXFWKYCXBKZKZXFDWTVCH
      ZJZDYFEZYEXBXADFYHWKYCXBVDYEXAADYEXAXTAYEDDTVEGZXPYCXAXTFYIYEDTUMVFVGWKXP
      YDXRUTZWKYCXBVIZDBWSVJVKWKYAYDYBUTVLWDWEYDVMVNXAWTVOVPYEXEYGDXDYFYEXOXPYC
      XDYFNXOYEUIVGYJYKDBWSVSVKZYEXDYFYLPQVBVQVRVTWAWBWC $.
  $}

  ${
    $d k n x N $.
    $( Derivative of a power function.  (Contributed by Mario Carneiro,
       9-Aug-2014.)  (Revised by Mario Carneiro, 10-Feb-2015.) $)
    dvexp $p |- ( N e. NN -> ( CC _D ( x e. CC |-> ( x ^ N ) ) ) =
                  ( x e. CC |-> ( N x. ( x ^ ( N - 1 ) ) ) ) ) $=
      ( cc cexp co cmpt cdv c1 cmin cmul wceq caddc mpteq2dv oveq2d id wcel a1i
      oveq1 cvv wf vn vk oveq2 oveq12d eqeq12d cid cres mpteq2ia mptresid eqtri
      cv exp1 oveq2i csn cxp cc0 1m1e0 exp0 syl5eq syl6eq fconstmpt eqtr4i dvid
      1t1e1 cn cof nncn adantr ax-1cn pncan sylancl nnnn0 expcl syl2anr adddird
      wa cn0 mulid2d 3eqtrd mpteq2dva mulcld nnm1nn0 simpr eqidd eqcomi offval2
      cnex mulassd expm1t ancoms eqtr4d eqtrd oveq1d eqcomd sylan9eq prid2 eqid
      cr cpr fmptd wf1o f1oi f1of mp1i cdm dmeqd fdm syl 1ex fconst feq1i mpbir
      fdmi dvmulf expp1 3eqtr2rd ex nnind ) CACAUKZUAUKZDEZFZGEZACXTXSXTHIEZDEZ
      JEZFZKCACXSHDEZFZGEZACHXSHHIEZDEZJEZFZKCACXSUBUKZDEZFZGEZACYOXSYOHIEZDEZJ
      EZFZKZCACXSYOHLEZDEZFZGEZACUUDXSUUDHIEZDEZJEZFZKZCACXSBDEZFZGEZACBXSBHIEZ
      DEZJEZFZKUAUBBXTHKZYCYJYGYNUUTYBYICGUUTACYAYHXTHXSDUCMNUUTACYFYMUUTXTHYEY
      LJUUTOUUTYDYKXSDXTHHIRNUDMUEXTYOKZYCYRYGUUBUVAYBYQCGUVAACYAYPXTYOXSDUCMNU
      VAACYFUUAUVAXTYOYEYTJUVAOUVAYDYSXSDXTYOHIRNUDMUEXTUUDKZYCUUGYGUUKUVBYBUUF
      CGUVBACYAUUEXTUUDXSDUCMNUVBACYFUUJUVBXTUUDYEUUIJUVBOUVBYDUUHXSDXTUUDHIRNU
      DMUEXTBKZYCUUOYGUUSUVCYBUUNCGUVCACYAUUMXTBXSDUCMNUVCACYFUURUVCXTBYEUUQJUV
      COUVCYDUUPXSDXTBHIRNUDMUEYJCUFCUGZGEZYNYIUVDCGYIACXSFZUVDACYHXSXSULUHACUI
      ZUJUMYNCHUNZUOZUVEYNACHFZUVIACYMHXSCPZYMHHJEHUVKYLHHJUVKYLXSUPDEHYKUPXSDU
      QUMXSURUSNVDUTUHACHVAZVBVCVBVBYOVEPZUUCUULUVMUUCVPZUUKYRUVDJVFZEZUVEYQUVO
      EZLVFZEZCYQUVDUVOEZGEZUUGUVMUUCUUKUUBUVDUVOEZUVQUVREZUVSUVMUUKACYOYPJEZYP
      LEZFUWCUVMACUUJUWEUVMUVKVPZUUJUUDYPJEUWDHYPJEZLEUWEUWFUUIYPUUDJUWFUUHYOXS
      DUWFYOCPZHCPZUUHYOKUVMUWHUVKYOVGVHZVIYOHVJVKNNUWFYOHYPUWJUWIUWFVIQZUVKUVK
      YOVQPZYPCPUVMUVKOZYOVLZXSYOVMVNZVOUWFUWGYPUWDLUWFYPUWOVRZNVSVTUVMACUWDYPL
      UWBUVQSCCCSPUVMWGQZUWFYOYPUWJUWOWAUWOUVMUWBACUUAXSJEZFACUWDFUVMACUUAXSJUU
      BUVDSCCUWQUWFYOYTUWJUVKUVKYSVQPYTCPUVMUWMYOWBXSYSVMVNZWAZUVMUVKWCZUVMUUBW
      DUVDUVFKUVMUVFUVDUVGWEQZWFUVMACUWRUWDUWFUWRYOYTXSJEZJEUWDUWFYOYTXSUWJUWSU
      XAWHUWFYPUXCYOJUVKUVMYPUXCKXSYOWIWJNWKVTWLUVMUVQACUWGFYQUVMACHYPJUVEYQSCC
      UWQUWKUWOUVEUVJKUVMUVEUVIUVJVCUVLUJQUVMYQWDZWFUVMACUWGYPUWPVTWLWFWKUUCUVS
      UWCUUCUVPUWBUVQUVRYRUUBUVDUVORWMWNWOUVNCYQUVDCCWRCWSPUVNWRCWGWPQUVMCCYQTU
      UCUVMACYPCYQUWOYQWQWTVHCCUVDXACCUVDTUVNCXBCCUVDXCXDUVNYRXEUUBXEZCUVNYRUUB
      UVMUUCWCXFUVNCCUUBTZUXECKUVMUXFUUCUVMACUUACUUBUWTUUBWQWTVHCCUUBXGXHWLUVEX
      ECKUVNCUVHUVECUVHUVETCUVHUVITCHXIXJCUVHUVEUVIVCXKXLXMQXNUVMUWAUUGKUUCUVMU
      VTUUFCGUVMUVTACYPXSJEZFUUFUVMACYPXSJYQUVDSCCUWQUWOUXAUXDUXBWFUVMACUUEUXGU
      VKUVKUWLUUEUXGKUVMUWMUWNXSYOXOVNVTWKNVHXPXQXR $.
  $}

  ${
    $d x N $.
    $( Derivative of an exponential, possibly zero power.  (Contributed by
       Stefan O'Rear, 13-Nov-2014.)  (Revised by Mario Carneiro,
       10-Feb-2015.) $)
    dvexp2 $p |- ( N e. NN0 -> ( CC _D ( x e. CC |-> ( x ^ N ) ) ) =
        ( x e. CC |-> if ( N = 0 , 0 , ( N x. ( x ^ ( N - 1 ) ) ) ) ) ) $=
      ( cn0 wcel cn cc0 wceq wo cc cexp co cdv c1 mpteq2dv eqtr4d csn fconstmpt
      cmpt cxp syl6eq cv cmin cif elnn0 dvexp wn nnne0 neneqd iffalse syl oveq2
      cmul exp0 mpteq2dva syl6eqr oveq2d ax-1cn dvconst ax-mp iftrue jaoi sylbi
      sylan9eq ) BCDBEDZBFGZHIAIAUAZBJKZRZLKZAIVEFBVFBMUBKJKULKZUCZRZGZBUDVDVMV
      EVDVIAIVJRVLABUEVDAIVKVJVDVEUFVKVJGVDBFBUGUHVEFVJUIUJNOVEVIAIFRZVLVEVIIFP
      SZVNVEVIIIMPSZLKZVOVEVHVPILVEVHAIMRVPVEAIVGMVEVFIDVGVFFJKMBFVFJUKVFUMVCUN
      AIMQUOUPMIDVQVOGUQMURUSTAIFQTVEAIVKFVEFVJUTNOVAVB $.
  $}

  ${
    $d x y z A $.
    $( Derivative of the reciprocal function.  (Contributed by Mario Carneiro,
       25-Feb-2015.)  (Revised by Mario Carneiro, 28-Dec-2016.) $)
    dvrec $p |- ( A e. CC -> ( CC _D ( x e. ( CC \ { 0 } ) |-> ( A / x ) ) ) =
        ( x e. ( CC \ { 0 } ) |-> -u ( A / ( x ^ 2 ) ) ) ) $=
      ( vy vz cc wcel cc0 cdiv cmpt cneg wne eqid cfv cmin wceq cmul adantl syl
      co wf csn cdif cv cdv c2 cexp wfn cdm dvfcn wss ssid a1i wa eldifsn divcl
      3expb sylan2b fmptd difssd dvbss wbr ccnfld ctopn cnt climc ctop cnfldtop
      simpr cha cnfldhaus cnfldtopon toponunii sncld mp2an cldopn ax-mp isopn3i
      ccld syl6eleqr eldifi sqvald oveq2d simpl eldifsni divdiv1d eqtr4d negeqd
      0cn divcld divnegd eqtrd ccncf negcld cdivcncf oveq2 cnmptlimc cres cncff
      eqeltrd limcdif eldifad ad2antlr subcld adantr syl2anc subdird negsubdi2d
      mulneg12 oveq1d ovex fvmpt simpll divassd 3eqtr2d oveq12d 3eqtr4d 3eqtr3d
      divcan2d subne0d mpteq2dva difss resmpt syl6eqr eleqtrd crest restid eldv
      divcan3d eqcomi mpbir2and vex negex breldm ex ssrdv eqssd feq2d mpbii cvv
      mp1i ffn wral rgenw fnmpt wfun ffun funbrfv sylc oveq1 eqfnfvd ) BEFZCEGU
      AZUBZEAUUMBAUCZHSZIZUDSZAUUMBUUNUEUFSZHSZJZIZUUKUUMEUUQTZUUQUUMUGUUKUUQUH
      ZEUUQTZUVBUUPUIZUUKUVCUUMEUUQUUKUVCUUMUUKUUMEUUPEEUJZUUKEUKZULUUKAUUMUUOE
      UUPUUNUUMFUUKUUNEFZUUNGKZUMUUOEFZUUNEGUNUUKUVHUVIUVJBUUNUOUPUQUUPLZURZUUK
      EUULUSUTUUKCUUMUVCUUKCUCZUUMFZUVMUVCFZUUKUVNUMZUVMBUVMUEUFSZHSZJZUUQVAZUV
      OUVPUVTUVMUUMVBVCMZVDMMZFUVSDUUMUVMUAZUBZDUCZUUPMZUVMUUPMZNSZUWEUVMNSZHSZ
      IZUVMVESZFUVPUVMUUMUWBUUKUVNVHZUWAVFFZUUMUWAFZUWBUUMOUWAUWALZVGZUULUWAVRM
      FZUWOUWAVIFGEFUWRUWAUWPVJWHGUWAEEUWAUWAUWPVKVLZVMVNUULUWAEUWSVOVPUUMUWAVQ
      VNVSUVPUVSDUUMBUVMHSZJZUWEHSZIZUVMVESZUWLUVPUVSUXAUVMHSZUXDUVPUVSUWTUVMHS
      ZJUXEUVPUVRUXFUVPUVRBUVMUVMPSZHSUXFUVPUVQUXGBHUVPUVMUVNUVMEFZUUKUVMEUULVT
      ZQZWAWBUVPBUVMUVMUUKUVNWCZUXJUXJUVNUVMGKZUUKUVMEGWDZQZUXNWEWFWGUVPUWTUVMU
      VPBUVMUXKUXJUXNWIZUXJUXNWJWKUVPDUUMUVMEUXBUXEUVPUXAEFUXCUUMEWLSFZUVPUWTUX
      OWMDUXAUXCUXCLWNRZUWMUWEUVMUXAHWOWPWSUVPUXDUXCUWDWQZUVMVESUWLUVPUUMUVMUXC
      UVPUXPUUMEUXCTUXQUUMEUXCWRRWTUVPUWKUXRUVMVEUVPUWKDUWDUXBIZUXRUVPDUWDUWJUX
      BUVPUWEUWDFZUMZUWJUWIUXBPSZUWIHSUXBUYAUWHUYBUWIHUYAUWIJZUWTUWEHSZPSZUWIUY
      DJZPSZUWHUYBUYAUWIEFUYDEFUYEUYGOUYAUWEUVMUYAUWEEUULUXTUWEUUMFZUVPUWEUUMUW
      CVTQZXAZUVNUXHUUKUXTUXIXBZXCZUYAUWTUWEUVPUWTEFUXTUXOXDZUYJUYAUYHUWEGKUYIU
      WEEGWDRZWIZUWIUYDXHXEUYAUVMUWENSZUYDPSUVMUYDPSZUWEUYDPSZNSUYEUWHUYAUVMUWE
      UYDUYKUYJUYOXFUYAUYCUYPUYDPUYAUWEUVMUYJUYKXGXIUYAUWFUYQUWGUYRNUYAUWFBUWEH
      SZUVMUWTPSZUWEHSUYQUYAUYHUWFUYSOUYIAUWEUUOUYSUUMUUPUUNUWEBHWOUVKBUWEHXJXK
      RUYAUYTBUWEHUYABUVMUUKUVNUXTXLUYKUVNUXLUUKUXTUXMXBXRXIUYAUVMUWTUWEUYKUYMU
      YJUYNXMXNUYAUWGUWTUYRUVNUWGUWTOUUKUXTAUVMUUOUWTUUMUUPUUNUVMBHWOUVKBUVMHXJ
      XKXBUYAUWTUWEUYMUYJUYNXRWFXOXPUYAUYFUXBUWIPUYAUWTUWEUYMUYJUYNWJWBXQXIUYAU
      XBUWIUYAUXAUWEUYAUWTUYMWMUYJUYNWIUYLUYAUWEUVMUYJUYKUXTUWEUVMKUVPUWEUUMUVM
      WDQXSYHWKXTUWDUUMUJUXRUXSOUUMUWCYADUUMUWDUXBYBVPYCXIWFYDUVPDUUMUVMUVSEUWA
      UUPUWKUWAUWAEYESZUWAUWNVUAUWAOUWQUWAVFEUWSYFVPYIUWPUWKLUVFUVPUVGULUUKUUME
      UUPTUVNUVLXDUVPEUULUSYGYJZUVMUVSUUQCYKUVRYLZYMRYNYOYPYQYRUUMEUUQUUARUUTYS
      FZAUUMUUBUVAUUMUGUUKVUDAUUMUUSYLUUCAUUMUUTUVAYSUVALZUUDYTUVPUVMUUQMZUVSUV
      MUVAMZUVPUUQUUEZUVTVUFUVSOUVDVUHUVPUVEUVCEUUQUUFYTVUBUVMUVSUUQUUGUUHUVNVU
      GUVSOUUKAUVMUUTUVSUUMUVAUUNUVMOZUUSUVRVUIUURUVQBHUUNUVMUEUFUUIWBWGVUEVUCX
      KQWFUUJ $.
  $}

  ${
    $d x ph $.  $d x X $.  $d x Y $.
    dvmptres3.j $e |- J = ( TopOpen ` CCfld ) $.
    dvmptres3.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvmptres3.x $e |- ( ph -> X e. J ) $.
    dvmptres3.y $e |- ( ph -> ( S i^i X ) = Y ) $.
    dvmptres3.a $e |- ( ( ph /\ x e. X ) -> A e. CC ) $.
    dvmptres3.b $e |- ( ( ph /\ x e. X ) -> B e. V ) $.
    dvmptres3.d $e |- ( ph ->
      ( CC _D ( x e. X |-> A ) ) = ( x e. X |-> B ) ) $.
    $( Function-builder for derivative: restrict a derivative to a subset.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    dvmptres3 $p |- ( ph ->
      ( S _D ( x e. Y |-> A ) ) = ( x e. Y |-> B ) ) $=
      ( cres cc wceq syl cmpt cdv co cr cpr wcel cdm eqid fmptd dmeqd ralrimiva
      wf wfn wral fnmpt fndm eqtrd dvres3a syl22anc rescom resres eqtri reseq2d
      cin syl5eq ffn fnresdm 3syl reseq1d inss2 syl6eqssr resmpt 3eqtr3d oveq2d
      wss eqtr4d ) AEBHCUAZEQZUBUCZRVQUBUCZEQZEBICUAZUBUCBIDUAZAEUDRUEUFHRVQULZ
      HFUFVTUGZHSVSWASKABHCRVQNVQUHUIZLAWEBHDUAZUGZHAVTWGPUJAWGHUMZWHHSADGUFZBH
      UNWIAWJBHOUKBHDWGGWGUHUOTZHWGUPTUQHEVQFJURUSAVRWBEUBAVQHQZEQZVQIQZVRWBAWM
      VQEHVDZQZWNWMVRHQWPVQHEUTVQEHVAVBAWOIVQMVCVEAWLVQEAWDVQHUMWLVQSWFHRVQVFHV
      QVGVHVIAIHVOZWNWBSAIWOHMEHVJVKZBHICVLTVMVNAWGHQZEQZWGIQZWAWCAWTWGWOQZXAWT
      WGEQHQXBWGHEUTWGEHVAVBAWOIWGMVCVEAWSVTEAWSWGVTAWIWSWGSWKHWGVGTPVPVIAWQXAW
      CSWRBHIDVLTVMVM $.
  $}

  ${
    $d x A $.  $d x ph $.  $d x S $.
    dvmptid.1 $e |- ( ph -> S e. { RR , CC } ) $.
    $( Function-builder for derivative: derivative of the identity.
       (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by Mario
       Carneiro, 11-Feb-2015.) $)
    dvmptid $p |- ( ph -> ( S _D ( x e. S |-> x ) ) = ( x e. S |-> 1 ) ) $=
      ( cv c1 ccnfld ctopn cfv cc eqid ctopon wcel cnfldtopon toponmax wceq a1i
      cmpt cdv co mp1i wss cin cr cpr recnprss syl df-ss sylib simpr ax-1cn cid
      wa cres csn cxp mptresid oveq2i dvid fconstmpt 3eqtri dvmptres3 ) ABBEZFC
      GHIZJJCVDKZDVDJLIMJVDMAVDVENJVDOUAACJUBZCJUCCPACUDJUEMVFDCUFUGCJUHUIAVCJM
      ZUJFJMAVGUMUKQJBJVCRZSTZBJFRZPAVIJULJUNZSTJFUOUPVJVHVKJSBJUQURUSBJFUTVAQV
      B $.

    dvmptc.2 $e |- ( ph -> A e. CC ) $.
    $( Function-builder for derivative: derivative of a constant.  (Contributed
       by Mario Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro,
       11-Feb-2015.) $)
    dvmptc $p |- ( ph -> ( S _D ( x e. S |-> A ) ) = ( x e. S |-> 0 ) ) $=
      ( cc0 ccnfld ctopn cfv cc wcel wceq syl csn cxp cdv co cmpt fconstmpt wss
      eqid ctopon cnfldtopon toponmax cin cr cpr recnprss df-ss sylib cv adantr
      mp1i wa 0cn a1i dvconst oveq2i 3eqtr3g dvmptres3 ) ABCGDHIJZKKDVBUBZEVBKU
      CJLKVBLAVBVCUDKVBUEUNADKUAZDKUFDMADUGKUHLVDEDUINDKUJUKACKLZBULKLZFUMGKLAV
      FUOUPUQAKKCOPZQRZKGOPZKBKCSZQRBKGSAVEVHVIMFCURNVGVJKQBKCTUSBKGTUTVA $.
  $}

  ${
    $d x y ph $.  $d x S $.  $d x V $.  $d x W $.  $d x X $.  $d x Y $.
    $d x Z $.
    dvmptadd.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvmptadd.a $e |- ( ( ph /\ x e. X ) -> A e. CC ) $.
    dvmptadd.b $e |- ( ( ph /\ x e. X ) -> B e. V ) $.
    dvmptadd.da $e |- ( ph -> ( S _D ( x e. X |-> A ) ) = ( x e. X |-> B ) ) $.
    $( Closure lemma for ~ dvmptcmul and other related theorems.  (Contributed
       by Mario Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro,
       11-Feb-2015.) $)
    dvmptcl $p |- ( ( ph /\ x e. X ) -> B e. CC ) $=
      ( cc wcel cmpt wf wral cdv cdm syl mpbid co cpr dvfg dmeqd wceq ralrimiva
      cr dmmptg eqtrd feq2d feq1d eqid fmpt sylibr r19.21bi ) ADLMZBGAGLBGDNZOZ
      UPBGPAGLEBGCNZQUAZOZURAUTRZLUTOZVAAEUGLUBMVCHEUSUCSAVBGLUTAVBUQRZGAUTUQKU
      DADFMZBGPVDGUEAVEBGJUFBGDFUHSUIUJTAGLUTUQKUKTBGLDUQUQULUMUNUO $.

    ${
      dvmptadd.c $e |- ( ( ph /\ x e. X ) -> C e. CC ) $.
      dvmptadd.d $e |- ( ( ph /\ x e. X ) -> D e. W ) $.
      dvmptadd.dc $e |- ( ph ->
        ( S _D ( x e. X |-> C ) ) = ( x e. X |-> D ) ) $.
      $( Function-builder for derivative, addition rule.  (Contributed by Mario
         Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
      dvmptadd $p |- ( ph ->
        ( S _D ( x e. X |-> ( A + C ) ) ) = ( x e. X |-> ( B + D ) ) ) $=
        ( cmpt co cdv caddc cof eqid fmptd cdm dmeqd wcel wral ralrimiva dmmptg
        cc wceq syl eqtrd dvaddf cvv ovex dmex syl6eqelr offval2 oveq2d 3eqtr3d
        eqidd ) AGBJCRZBJERZUAUBZSZTSGVDTSZGVETSZVFSGBJCEUASRZTSBJDFUASRAGVDVEJ
        KABJCUKVDLVDUCUDABJEUKVEOVEUCUDAVHUEBJDRZUEZJAVHVKNUFADHUGZBJUHVLJULAVM
        BJMUIBJDHUJUMUNAVIUEZBJFRZUEZJAVIVOQUFAFIUGZBJUHVPJULAVQBJPUIBJFIUJUMUN
        ZUOAVGVJGTABJCEUAVDVEUPUKUKAJVNUPVRVIGVETUQURUSZLOAVDVCAVEVCUTVAABJDFUA
        VHVIUPHIVSMPNQUTVB $.

      $( Function-builder for derivative, product rule.  (Contributed by Mario
         Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
      dvmptmul $p |- ( ph ->
        ( S _D ( x e. X |-> ( A x. C ) ) ) =
          ( x e. X |-> ( ( B x. C ) + ( D x. A ) ) ) ) $=
        ( cmul co cvv cmpt cof cdv caddc cc eqid fmptd cdm dmeqd wcel wral wceq
        ralrimiva dmmptg syl eqtrd dvmulf ovex dmex syl6eqelr offval2 oveq2d cv
        eqidd wa a1i 3eqtr3d ) AGBJCUAZBJEUAZRUBZSZUCSGVHUCSZVIVJSZGVIUCSZVHVJS
        ZUDUBSGBJCERSUAZUCSBJDERSZFCRSZUDSUAAGVHVIJKABJCUEVHLVHUFUGABJEUEVIOVIU
        FUGAVLUHBJDUAZUHZJAVLVSNUIADHUJZBJUKVTJULAWABJMUMBJDHUNUOUPAVNUHZBJFUAZ
        UHZJAVNWCQUIAFIUJZBJUKWDJULAWEBJPUMBJFIUNUOUPZUQAVKVPGUCABJCERVHVITUEUE
        AJWBTWFVNGVIUCURUSUTZLOAVHVDZAVIVDZVAVBABJVQVRUDVMVOTTTWGVQTUJABVCJUJVE
        ZDERURVFVRTUJWJFCRURVFABJDERVLVITHUEWGMONWIVAABJFCRVNVHTIUEWGPLQWHVAVAV
        G $.
    $}

    ${
      dvmptres2.z $e |- ( ph -> Z C_ X ) $.
      dvmptres2.j $e |- J = ( K |`t S ) $.
      dvmptres2.k $e |- K = ( TopOpen ` CCfld ) $.
      dvmptres2.i $e |- ( ph -> ( ( int ` J ) ` Z ) = Y ) $.
      $( Function-builder for derivative: restrict a derivative to a subset.
         (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by Mario
         Carneiro, 11-Feb-2015.) $)
      dvmptres2 $p |- ( ph ->
        ( S _D ( x e. Z |-> A ) ) = ( x e. Y |-> B ) ) $=
        ( wss cmpt cres cdv co cnt cfv cc wf wceq cr cpr wcel recnprss syl eqid
        fmptd dmeqd wral ralrimiva dmmptg eqtrd dvbsss syl6eqssr sstrd syl22anc
        cdm resmpt oveq2d reseq1d reseq2d ctop cuni ctopon cnfldtopon resttopon
        dvres crest sylancr syl5eqel topontop toponuni sseqtrd syl2anc eqsstr3d
        ntrss2 3eqtrd 3eqtr3d ) AEBICUAZKUBZUCUDZEWHUCUDZKFUEUFUFZUBZEBKCUAZUCU
        DBJDUAZAEUGTZIUGWHUHIETKETWJWMUIAEUJUGUKULWPLEUMUNZABICUGWHMWHUOUPAIWKV
        FZEAWRBIDUAZVFZIAWKWSOUQADHULZBIURWTIUIAXABINUSBIDHUTUNVAEWHVBVCZAKIEPX
        BVDZIKEFWHGRQVPVEAWIWNEUCAKITWIWNUIPBIKCVGUNVHAWMWSWLUBWSJUBZWOAWKWSWLO
        VIAWLJWSSVJAJITXDWOUIAJKIAJWLKSAFVKULZKFVLZTWLKTAFEVMUFZULZXEAFGEVQUDZX
        GQAGUGVMUFULWPXIXGULGRVNWQEGUGVOVRVSZEFVTUNAKEXFXCAXHEXFUIXJEFWAUNWBKFX
        FXFUOWEWCWDPVDBIJDVGUNWFWG $.
    $}

    ${
      dvmptres.y $e |- ( ph -> Y C_ X ) $.
      dvmptres.j $e |- J = ( K |`t S ) $.
      dvmptres.k $e |- K = ( TopOpen ` CCfld ) $.
      dvmptres.t $e |- ( ph -> Y e. J ) $.
      $( Function-builder for derivative: restrict a derivative to an open
         subset.  (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by
         Mario Carneiro, 11-Feb-2015.) $)
      dvmptres $p |- ( ph ->
        ( S _D ( x e. Y |-> A ) ) = ( x e. Y |-> B ) ) $=
        ( ctop wcel cnt cfv wceq crest co cpr cnfldtop resttop sylancr syl5eqel
        cr cc isopn3i syl2anc dvmptres2 ) ABCDEFGHIJJKLMNOPQAFSTJFTJFUAUBUBJUCA
        FGEUDUEZSPAGSTEUKULUFZTUPSTGQUGKEGUQUHUIUJRJFUMUNUO $.
    $}

    ${
      $d x C $.
      dvmptcmul.c $e |- ( ph -> C e. CC ) $.
      $( Function-builder for derivative, product rule for constant
         multiplier.  (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by
         Mario Carneiro, 11-Feb-2015.) $)
      dvmptcmul $p |- ( ph ->
        ( S _D ( x e. X |-> ( C x. A ) ) ) = ( x e. X |-> ( C x. B ) ) ) $=
        ( cmul co cmpt cc0 cc wcel cfv cdv caddc cv adantr 0cn a1i ccnfld ctopn
        wa crest dvmptc cdm dmeqd wral wceq ralrimiva dmmptg syl eqtrd eqsstr3d
        wss dvbsss eqid cnt ctop cuni ctopon cnfldtopon cr cpr recnprss sylancr
        resttopon topontop toponuni sseqtrd ntrss2 syl2anc fmptd dvbssntr eqssd
        dvmptres2 mul02d oveq1d dvmptcl mulcld addid2d mulcomd 3eqtrd mpteq2dva
        dvmptmul ) AFBHECNOPUAOBHQCNOZDENOZUBOZPBHEDNOZPABEQCDFRGHIAERSZBUCZHSZ
        MUDZQRSZAWRUIZUEUFABEQFUGUHTZFUJOZXBRFHHIAWPWQFSZMUDWTAXDUIUEUFABEFIMUK
        AHFBHCPZUAOZULZFAXGBHDPZULZHAXFXHLUMADGSZBHUNXIHUOAXJBHKUPBHDGUQURUSZXG
        FVAAFXEVBUFUTZXCVCZXBVCZAHXCVDTTZHAXCVESZHXCVFZVAXOHVAAXCFVGTSZXPAXBRVG
        TSFRVAZXRXBXNVHAFVIRVJSXSIFVKURZFXBRVMVLZFXCVNURAHFXQXLAXRFXQUOYAFXCVOU
        RVPHXCXQXQVCVQVRAHXGXOXKAHFXEXCXBXTABHCRXEJXEVCVSXLXMXNVTUTWAWBJKLWKABH
        WNWOXAWNQWMUBOWMWOXAWLQWMUBXACJWCWDXAWMXADEABCDFGHIJKLWEZWSWFWGXADEYBWS
        WHWIWJUS $.

      dvmptdivc.0 $e |- ( ph -> C =/= 0 ) $.
      $( Function-builder for derivative, division rule for constant divisor.
         (Contributed by Mario Carneiro, 18-May-2016.) $)
      dvmptdivc $p |- ( ph ->
        ( S _D ( x e. X |-> ( A / C ) ) ) = ( x e. X |-> ( B / C ) ) ) $=
        ( cdiv co cmul cmpt cdv wcel c1 reccld dvmptcmul cv adantr cc0 divrec2d
        wa cc wne mpteq2dva oveq2d dvmptcl 3eqtr4d ) AFBHUAEOPZCQPZRZSPBHUODQPZ
        RFBHCEOPZRZSPBHDEOPZRABCDUOFGHIJKLAEMNUBUCAUTUQFSABHUSUPABUDHTZUHZCEJAE
        UITVBMUEZAEUFUJVBNUEZUGUKULABHVAURVCDEABCDFGHIJKLUMVDVEUGUKUN $.
    $}

    $( Function-builder for derivative, product rule for negatives.
       (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by Mario
       Carneiro, 11-Feb-2015.) $)
    dvmptneg $p |- ( ph ->
      ( S _D ( x e. X |-> -u A ) ) = ( x e. X |-> -u B ) ) $=
      ( c1 cneg cmul co cmpt cdv wcel mulm1d mpteq2dva neg1cn dvmptcmul dvmptcl
      cc a1i cv wa oveq2d 3eqtr3d ) AEBGLMZCNOZPZQOBGUJDNOZPEBGCMZPZQOBGDMZPABC
      DUJEFGHIJKUJUDRAUAUEUBAULUOEQABGUKUNABUFGRUGZCISTUHABGUMUPUQDABCDEFGHIJKU
      CSTUI $.

    ${
      dvmptsub.c $e |- ( ( ph /\ x e. X ) -> C e. CC ) $.
      dvmptsub.d $e |- ( ( ph /\ x e. X ) -> D e. W ) $.
      dvmptsub.dc $e |- ( ph ->
        ( S _D ( x e. X |-> C ) ) = ( x e. X |-> D ) ) $.
      $( Function-builder for derivative, subtraction rule.  (Contributed by
         Mario Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro,
         11-Feb-2015.) $)
      dvmptsub $p |- ( ph ->
        ( S _D ( x e. X |-> ( A - C ) ) ) = ( x e. X |-> ( B - D ) ) ) $=
        ( co cmpt cdv cneg caddc cmin cv wcel wa negcld negex dvmptneg dvmptadd
        cvv a1i negsubd mpteq2dva oveq2d dvmptcl 3eqtr3d ) AGBJCEUAZUBRZSZTRBJD
        FUAZUBRZSGBJCEUCRZSZTRBJDFUCRZSABCDURVAGHUKJKLMNABUDJUEUFZEOUGVAUKUEVFF
        UHULABEFGIJKOPQUIUJAUTVDGTABJUSVCVFCELOUMUNUOABJVBVEVFDFABCDGHJKLMNUPAB
        EFGIJKOPQUPUMUNUQ $.
    $}
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d x ph $.  $d x V $.  $d x X $.
    dvmptcj.a $e |- ( ( ph /\ x e. X ) -> A e. CC ) $.
    dvmptcj.b $e |- ( ( ph /\ x e. X ) -> B e. V ) $.
    dvmptcj.da $e |- ( ph ->
      ( RR _D ( x e. X |-> A ) ) = ( x e. X |-> B ) ) $.
    $( Function-builder for derivative, conjugate rule.  (Contributed by Mario
       Carneiro, 1-Sep-2014.)  (Revised by Mario Carneiro, 11-Feb-2015.) $)
    dvmptcj $p |- ( ph ->
      ( RR _D ( x e. X |-> ( * ` A ) ) ) = ( x e. X |-> ( * ` B ) ) ) $=
      ( vy cr ccj cmpt ccom cdv co cfv cc wf wceq wss eqid fmptd cdm dmeqd wcel
      wral ralrimiva dmmptg syl eqtrd dvbsss syl6eqssr syl2anc cv eqidd cjf a1i
      dvcj feqmptd fveq2 fmptco oveq2d cpr reex prid1 dvmptcl 3eqtr3d ) AKLBFCM
      ZNZOPZLKVIOPZNZKBFCLQZMZOPBFDLQZMAFRVISFKUAVKVMTABFCRVIGVIUBUCAFVLUDZKAVQ
      BFDMZUDZFAVLVRIUEADEUFZBFUGVSFTAVTBFHUHBFDEUIUJUKKVIULUMVIFUSUNAVJVOKOABJ
      FRCJUOZLQZVNVILGAVIUPAJRRLRRLSAUQURUTZWACLVAVBVCABJFRDWBVPVLLABCDKEFKKRVD
      UFAKRVEVFURGHIVGIWCWADLVAVBVH $.

    $( Function-builder for derivative, real part.  (Contributed by Mario
       Carneiro, 1-Sep-2014.) $)
    dvmptre $p |- ( ph ->
      ( RR _D ( x e. X |-> ( Re ` A ) ) ) = ( x e. X |-> ( Re ` B ) ) ) $=
      ( cr c2 cdiv co cfv cmpt cdv cc wcel wceq syl ccj caddc cmul cre cpr reex
      c1 prid1 a1i cv wa cjcld addcld dvmptcl dvmptcj dvmptadd reccli dvmptcmul
      2cn 2ne0 reval cc0 wne divrec2 mp3an23 eqtrd mpteq2dva oveq2d 3eqtr4d ) A
      JBFUGKLMZCCUANZUBMZUCMZOZPMBFVJDDUANZUBMZUCMZOJBFCUDNZOZPMBFDUDNZOABVLVPV
      JJQFJJQUERAJQUFUHUIZABUJFRUKZCVKGWBCGULZUMZWBDVOABCDJEFWAGHIUNZWBDWEULZUM
      ZABCDVKVOJEQFWAGHIWCWFABCDEFGHIUOUPVJQRAKUSUTUQUIURAVSVNJPABFVRVMWBVRVLKL
      MZVMWBCQRVRWHSGCVATWBVLQRZWHVMSZWDWIKQRZKVBVCZWJUSUTVLKVDVETVFVGVHABFVTVQ
      WBVTVPKLMZVQWBDQRVTWMSWEDVATWBVPQRZWMVQSZWGWNWKWLWOUSUTVPKVDVETVFVGVI $.

    $( Function-builder for derivative, imaginary part.  (Contributed by Mario
       Carneiro, 1-Sep-2014.) $)
    dvmptim $p |- ( ph ->
      ( RR _D ( x e. X |-> ( Im ` A ) ) ) = ( x e. X |-> ( Im ` B ) ) ) $=
      ( cr c2 ci cmul co cfv cmpt cc wcel wceq syl c1 cdiv ccj cmin cdv cim cpr
      reex prid1 a1i cv cjcld subcld dvmptcl dvmptcj dvmptsub 2cn ax-icn mulcli
      wa 2ne0 mulne0i reccli dvmptcmul imval2 cc0 wne divrec2 mp3an23 mpteq2dva
      ine0 eqtrd oveq2d 3eqtr4d ) AJBFUAKLMNZUBNZCCUCOZUDNZMNZPZUENBFVPDDUCOZUD
      NZMNZPJBFCUFOZPZUENBFDUFOZPABVRWBVPJQFJJQUGRAJQUHUIUJZABUKFRUTZCVQGWHCGUL
      ZUMZWHDWAABCDJEFWGGHIUNZWHDWKULZUMZABCDVQWAJEQFWGGHIWIWLABCDEFGHIUOUPVPQR
      AVOKLUQURUSZKLUQURVAVKVBZVCUJVDAWEVTJUEABFWDVSWHWDVRVOUBNZVSWHCQRWDWPSGCV
      ETWHVRQRZWPVSSZWJWQVOQRZVOVFVGZWRWNWOVRVOVHVITVLVJVMABFWFWCWHWFWBVOUBNZWC
      WHDQRWFXASWKDVETWHWBQRZXAWCSZWMXBWSWTXCWNWOWBVOVHVITVLVJVN $.
  $}

  ${
    $d x ph $.  $d x X $.  $d x Y $.
    dvmptntr.s $e |- ( ph -> S C_ CC ) $.
    dvmptntr.x $e |- ( ph -> X C_ S ) $.
    dvmptntr.a $e |- ( ( ph /\ x e. X ) -> A e. CC ) $.
    dvmptntr.j $e |- J = ( K |`t S ) $.
    dvmptntr.k $e |- K = ( TopOpen ` CCfld ) $.
    dvmptntr.i $e |- ( ph -> ( ( int ` J ) ` X ) = Y ) $.
    $( Function-builder for derivative: expand the function from an open set to
       its closure.  (Contributed by Mario Carneiro, 1-Sep-2014.)  (Revised by
       Mario Carneiro, 11-Feb-2015.) $)
    dvmptntr $p |- ( ph ->
      ( S _D ( x e. X |-> A ) ) = ( S _D ( x e. Y |-> A ) ) ) $=
      ( cdv co cfv wss wceq cc cmpt cres ctop wcel cuni ctopon crest cnfldtopon
      cnt resttopon sylancr syl5eqel topontop syl toponuni sseqtrd eqid syl2anc
      ntridm fveq2d eqtr3d reseq2d fmptd dvres syl22anc ntrss2 eqsstr3d 3eqtr4d
      wf sstrd ssid resmpt mp1i oveq2d ) ADBGCUAZHUBZOPZDVOOPZDBHCUAZOPADVOGUBZ
      OPZVQVRAVRGEUIQZQZUBZVRHWBQZUBZWAVQAWCWEVRAWCWBQZWCWEAEUCUDZGEUEZRZWGWCSA
      EDUFQZUDZWHAEFDUGPZWKLAFTUFQUDDTRZWMWKUDFMUHIDFTUJUKULZDEUMUNZAGDWIJAWLDW
      ISWODEUOUNUPZGEWIWIUQZUSURAWCHWBNUTVAVBAWNGTVOVIZGDRZWTWAWDSIABGCTVOKVOUQ
      VCZJJGGDEVOFMLVDVEAWNWSWTHDRVQWFSIXAJAHGDAHWCGNAWHWJWCGRWPWQGEWIWRVFURVGZ
      JVJGHDEVOFMLVDVEVHAVTVODOGGRVTVOSAGVKBGGCVLVMVNVAAVPVSDOAHGRVPVSSXBBGHCVL
      UNVNVA $.
  $}

  ${
    $d y A $.  $d x C $.  $d x D $.  $d y E $.  $d y F $.  $d y T $.  $d x V $.
    $d x y ph $.  $d y W $.  $d x X $.  $d x y Y $.
    dvmptco.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvmptco.t $e |- ( ph -> T e. { RR , CC } ) $.
    dvmptco.a $e |- ( ( ph /\ x e. X ) -> A e. Y ) $.
    dvmptco.b $e |- ( ( ph /\ x e. X ) -> B e. V ) $.
    dvmptco.c $e |- ( ( ph /\ y e. Y ) -> C e. CC ) $.
    dvmptco.d $e |- ( ( ph /\ y e. Y ) -> D e. W ) $.
    dvmptco.da $e |- ( ph -> ( S _D ( x e. X |-> A ) ) = ( x e. X |-> B ) ) $.
    dvmptco.dc $e |- ( ph -> ( T _D ( y e. Y |-> C ) ) = ( y e. Y |-> D ) ) $.
    dvmptco.e $e |- ( y = A -> C = E ) $.
    dvmptco.f $e |- ( y = A -> D = F ) $.
    $( Function-builder for derivative, chain rule.  (Contributed by Mario
       Carneiro, 1-Sep-2014.) $)
    dvmptco $p |- ( ph ->
      ( S _D ( x e. X |-> E ) ) = ( x e. X |-> ( F x. B ) ) ) $=
      ( cmpt ccom cdv co cmul cof eqid fmptd cdm dmeqd wcel wral wceq ralrimiva
      cc dmmptg syl eqtrd dvcof eqidd fmptco oveq2d ovex dmex syl6eqelr dvmptcl
      cvv feq1d mpbird fco syl2anc mpbid fmpt sylibr r19.21bi offval2 3eqtr3d
      wf ) AHCOFUFZBNDUFZUGZUHUIIWDUHUIZWEUGZHWEUHUIZUJUKUIHBNJUFZUHUIBNKEUJUIU
      FAIHWDWEONQPACOFUTWDTWDULUMABNDOWERWEULUMZAWGUNCOGUFZUNZOAWGWLUCUOAGMUPZC
      OUQWMOURAWNCOUAUSCOGMVAVBVCAWIUNZBNEUFZUNZNAWIWPUBUOAELUPZBNUQWQNURAWRBNS
      USBNELVAVBVCZVDAWFWJHUHABCNODFJWEWDRAWEVEZAWDVEUDVFVGABNKEUJWHWIVLUTLANWO
      VLWSWIHWEUHVHVIVJAKUTUPZBNANUTBNKUFZWCZXABNUQANUTWHWCZXCAOUTWGWCZNOWEWCXD
      AXEOUTWLWCACOGUTWLACFGIMOQTUAUCVKWLULUMAOUTWGWLUCVMVNWKNOUTWGWEVOVPANUTWH
      XBABCNODGKWEWGRWTUCUEVFZVMVQBNUTKXBXBULVRVSVTSXFUBWAWB $.
  $}

  ${
    $d a b c d A $.  $d a b c i x I $.  $d a b c i x ph $.  $d a b c d i x S $.
    $d a b c d B $.  $d a b c d i x X $.
    dvmptfsum.j $e |- J = ( K |`t S ) $.
    dvmptfsum.k $e |- K = ( TopOpen ` CCfld ) $.
    dvmptfsum.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvmptfsum.x $e |- ( ph -> X e. J ) $.
    dvmptfsum.i $e |- ( ph -> I e. Fin ) $.
    dvmptfsum.a $e |- ( ( ph /\ i e. I /\ x e. X ) -> A e. CC ) $.
    dvmptfsum.b $e |- ( ( ph /\ i e. I /\ x e. X ) -> B e. CC ) $.
    dvmptfsum.d $e |- ( ( ph /\ i e. I ) -> ( S _D ( x e. X |-> A ) ) =
        ( x e. X |-> B ) ) $.
    $( Function-builder for derivative, finite sums rule.  (Contributed by
       Stefan O'Rear, 12-Nov-2014.) $)
    dvmptfsum $p |- ( ph -> ( S _D ( x e. X |-> sum_ i e. I A ) ) =
        ( x e. X |-> sum_ i e. I B ) ) $=
      ( va wcel vb vc wss csu cmpt cdv co wceq ssid cfn wi cv c0 csn cun sumeq1
      sseq1 mpteq2dv oveq2d eqeq12d imbi12d imbi2d weq cc0 cc wa 0cn a1i dvmptc
      ctopon cfv crest cnfldtopon cr cpr recnprss syl resttopon sylancr toponss
      syl5eqel syl2anc dvmptres sum0 mpteq2i oveq2i 3eqtr4g a1d ssun1 sstr mpan
      imim1i csb caddc cvv simpll ad3antrrr ad2antlr ssfi simp-4l sselda simplr
      wn w3a nfv nfcsb1v nfel1 nfim eleq1 3anbi3d csbeq1a eleq1d syl3anc fsumcl
      chvar adantlrr sumex nfcv sumeq2sdv cbvmpt sylibr wral ancom2s ralrimivva
      nfsum 3expb rspc2 ancoms mpan9 syl12anc nfmpt nfcsb csbeq2dv sumsns eqtrd
      fsumsplit mpteq2dva syl5eq adantrr a2d eqeq12i ad2antll simplll ssun2 vex
      biimpi snss ad2antrl nfov nfeq anbi2d 3eqtr3g dvmptadd cin simpllr disjsn
      simpr eqidd 3eqtr4d exp32 syl5 expcom adantl findcard2s mpcom mpi ) AGGUC
      ZEBJGCFUDZUEZUFUGZBJGDFUDZUEZUHZGUIGUJTZAUVGUVMUKZOASULZGUCZEBJUVPCFUDZUE
      ZUFUGZBJUVPDFUDZUEZUHZUKZUKAUMGUCZEBJUMCFUDZUEZUFUGZBJUMDFUDZUEZUHZUKZUKA
      UAULZGUCZEBJUWMCFUDZUEZUFUGZBJUWMDFUDZUEZUHZUKZUKAUWMUBULZUNZUOZGUCZEBJUX
      DCFUDZUEZUFUGZBJUXDDFUDZUEZUHZUKZUKAUVOUKSUAUBGUVPUMUHZUWDUWLAUXMUVQUWEUW
      CUWKUVPUMGUQUXMUVTUWHUWBUWJUXMUVSUWGEUFUXMBJUVRUWFUVPUMCFUPURUSUXMBJUWAUW
      IUVPUMDFUPURUTVAVBSUAVCZUWDUXAAUXNUVQUWNUWCUWTUVPUWMGUQUXNUVTUWQUWBUWSUXN
      UVSUWPEUFUXNBJUVRUWOUVPUWMCFUPURUSUXNBJUWAUWRUVPUWMDFUPURUTVAVBUVPUXDUHZU
      WDUXLAUXOUVQUXEUWCUXKUVPUXDGUQUXOUVTUXHUWBUXJUXOUVSUXGEUFUXOBJUVRUXFUVPUX
      DCFUPURUSUXOBJUWAUXIUVPUXDDFUPURUTVAVBUVPGUHZUWDUVOAUXPUVQUVGUWCUVMUVPGGU
      QUXPUVTUVJUWBUVLUXPUVSUVIEUFUXPBJUVRUVHUVPGCFUPURUSUXPBJUWAUVKUVPGDFUPURU
      TVAVBAUWKUWEAEBJVDUEZUFUGUXQUWHUWJABVDVDEHIVEEJMVDVETZABULZETVFVGVHZUXTAB
      VDEMUXRAVGVHVIAHEVJVKZTJHTJEUCAHIEVLUGZUYAKAIVEVJVKTEVEUCZUYBUYATILVMAEVN
      VEVOTZUYCMEVPVQEIVEVRVSWANJHEVTWBKLNWCUWGUXQEUFBJUWFVDCFWDWEWFBJUWIVDDFWD
      WEWGWHUWMUJTZUXBUWMTXCZVFAUXAUXLUYFAUXAUXLUKZUKUYEAUYFUYGUXAUXEUWTUKAUYFV
      FZUXLUXEUWNUWTUWMUXDUCUXEUWNUWMUXCWIUWMUXDGWJWKZWLUYHUXEUWTUXKUYHUXEUWTUX
      KUYHUXEUWTVFZVFZESJUWMBUVPCWMZFUDZFUXBUYLWMZWNUGZUEZUFUGSJUWMBUVPDWMZFUDZ
      FUXBUYQWMZWNUGZUEZUXHUXJUYKSUYMUYRUYNUYSEWOVEJUYKAUYDAUYFUYJWPZMVQUYHUXEU
      VPJTZUYMVETUWTUYHUXEVFZVUCVFZUWMUYLFVUEUVNUWNUYEAUVNUYFUXEVUCOWQZUXEUWNUY
      HVUCUYIWRZGUWMWSWBVUEFULZUWMTZVFAVUHGTZVUCUYLVETZAUYFUXEVUCVUIWTVUEUWMGVU
      HVUGXAVUDVUCVUIXBAVUJUXSJTZXDZCVETZUKAVUJVUCXDZVUKUKBSVUOVUKBVUOBXEZBUYLV
      EBUVPCXFZXGZXHBSVCZVUMVUOVUNVUKVUSVULVUCAVUJUXSUVPJXIXJZVUSCUYLVEBUVPCXKZ
      XLZVAPXOZXMXNXPUYRWOTUYKVUCVFUWMUYQFXQVHUWTESJUYMUEZUFUGZSJUYRUEZUHZUYHUX
      EUWTVVGUWQVVEUWSVVFUWPVVDEUFBSJUWOUYMSUWOXRBUWMUYLFBUWMXRZVUQYEVUSUWMCUYL
      FVVAXSXTWFBSJUWRUYRSUWRXRBUWMUYQFVVHBUVPDXFZYEVUSUWMDUYQFBUVPDXKZXSXTUUAU
      UFUUBUYHUXEVUCUYNVETZUWTVUEAUXBGTZVUCVVKAUYFUXEVUCUUCZUXEVVLUYHVUCUXEUXCG
      UCZVVLUXCUXDUCUXEVVNUXCUWMUUDUXCUXDGWJWKUXBGUBUUEZUUGYAZWRZVUDVUCUUQZAVUN
      FGYBBJYBZVVLVUCVFZVVKAVUNBFJGAVUJVULVUNAVUJVULVUNPYFYCYDVUCVVLVVSVVKUKVUN
      VVKVUKBFUVPUXBJGVURFUYNVEFUXBUYLXFXGVVBFUBVCZUYLUYNVEFUXBUYLXKXLYGYHYIYJZ
      XPUYHUXEVUCUYSVETZUWTVUEAVVLVUCVWCVVMVVQVVRADVETZFGYBBJYBZVVTVWCAVWDBFJGA
      VUJVULVWDAVUJVULVWDQYFYCYDVUCVVLVWEVWCUKVWDVWCUYQVETZBFUVPUXBJGBUYQVEVVIX
      GZFUYSVEFUXBUYQXFXGVUSDUYQVEVVJXLZVWAUYQUYSVEFUXBUYQXKXLYGYHYIYJZXPUYKAVV
      LESJUYNUEZUFUGZSJUYSUEZUHVUBUXEVVLUYHUWTVVPUUHAVVLVFZEBJFUXBCWMZUEZUFUGZB
      JFUXBDWMZUEZVWKVWLAVUJVFZEBJCUEZUFUGZBJDUEZUHZUKVWMVWPVWRUHZUKFUBVWMVXDFV
      WMFXEFVWPVWRFEVWOUFFEXRFUFXRFBJVWNFJXRZFUXBCXFYKUUIFBJVWQVXEFUXBDXFYKUUJX
      HVWAVWSVWMVXCVXDVWAVUJVVLAVUHUXBGXIUUKVWAVXAVWPVXBVWRVWAVWTVWOEUFVWABJCVW
      NFUXBCXKURUSVWABJDVWQFUXBDXKURUTVARXOVWOVWJEUFBSJVWNUYNSVWNXRBFUXBUYLBUXB
      XRZVUQYLVUSFUXBCUYLVVAYMXTWFBSJVWQUYSSVWQXRBFUXBUYQVXFVVIYLVUSFUXBDUYQVVJ
      YMXTUULWBUUMUYKUXGUYPEUFUYHUXEUXGUYPUHUWTVUDUXGSJUXDUYLFUDZUEUYPBSJUXFVXG
      SUXFXRBUXDUYLFBUXDXRZVUQYEVUSUXDCUYLFVVAXSXTVUDSJVXGUYOVUEVXGUYMUXCUYLFUD
      ZWNUGUYOVUEUWMUXCUYLUXDFVUEUYFUWMUXCUUNUMUHAUYFUXEVUCUUOUWMUXBUUPYAZVUEUX
      DUURZVUEUVNUXEUXDUJTVUFUYHUXEVUCXBZGUXDWSWBZVUEVUHUXDTZVFZAVUJVUCVUKAUYFU
      XEVUCVXNWTZVUEUXDGVUHVXLXAZVUDVUCVXNXBZVVCXMYPVUEVXIUYNUYMWNVUEUXBWOTZVVK
      VXIUYNUHVVOVWBUYLFUXBWOYNVSUSYOYQYRYSUSUYHUXEUXJVUAUHUWTVUDUXJSJUXDUYQFUD
      ZUEVUABSJUXIVXTSUXIXRBUXDUYQFVXHVVIYEVUSUXDDUYQFVVJXSXTVUDSJVXTUYTVUEVXTU
      YRUXCUYQFUDZWNUGUYTVUEUWMUXCUYQUXDFVXJVXKVXMVXOAVUJVUCVWFVXPVXQVXRVUMVWDU
      KVUOVWFUKBSVUOVWFBVUPVWGXHVUSVUMVUOVWDVWFVUTVWHVAQXOXMYPVUEVYAUYSUYRWNVUE
      VXSVWCVYAUYSUHVVOVWIUYQFUXBWOYNVSUSYOYQYRYSUUSUUTYTUVAUVBUVCYTUVDUVEUVF
      $.
  $}

  ${
    $d x y z C $.  $d x y z F $.  $d x y z J $.  $d x y z ph $.  $d x y z S $.
    $d y z X $.  $d x z Y $.
    dvcnv.j $e |- J = ( TopOpen ` CCfld ) $.
    dvcnv.k $e |- K = ( J |`t S ) $.
    dvcnv.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvcnv.y $e |- ( ph -> Y e. K ) $.
    dvcnv.f $e |- ( ph -> F : X -1-1-onto-> Y ) $.
    dvcnv.i $e |- ( ph -> `' F e. ( Y -cn-> X ) ) $.
    dvcnv.d $e |- ( ph -> dom ( S _D F ) = X ) $.
    dvcnv.z $e |- ( ph -> -. 0 e. ran ( S _D F ) ) $.
    ${
      dvcnv.c $e |- ( ph -> C e. X ) $.
      $( Lemma for ~ dvcnvre .  (Contributed by Mario Carneiro, 25-Feb-2015.)
         (Revised by Mario Carneiro, 8-Sep-2015.) $)
      dvcnvlem $p |- ( ph ->
        ( F ` C ) ( S _D `' F ) ( 1 / ( ( S _D F ) ` C ) ) ) $=
        ( co wcel cc vz vy vx cfv c1 cdv cdiv ccnv wbr cnt cdif cmin cmpt climc
        csn cv wf1o f1of syl ffvelrnd ctop wceq ctopon crest wss cnfldtopon cpr
        wf cr recnprss resttopon sylancr syl5eqel topontop isopn3i eleqtrrd wne
        syl2anc wa f1ocnv eldifi ffvelrn syl2an anim1i sylibr anasss cdm dvbsss
        3syl eldifsn syl6eqssr sstrd sselda sylan2 sseldd adantr subcld toponss
        fss cc0 eldifsni adantl subeq0ad wf1 wb f1of1 f1fveq syl12anc necon3bid
        bitrd mpbird divcld limcresi feqmptd reseq1d difss resmpt syl6eq oveq1d
        cres ax-mp syl5sseq f1ocnvfv1 cnlimci eqeltrrd subne0d divne0d sylanbrc
        ccom dvlem eqid a1i mpbid eldv ccn wn oveq2 eqidd mpteq2dva oveq12d ctx
        fmptd wfun dvfg ffun 4syl simprd ccnp mp2an ax-1cn cnmptc cnmptid divcn
        funfvbrb cnmpt12f feq2d crn wfn ffn fnfvelrn nelne2 cncnpi limccnp ovex
        toponunii fvmpt fmptco recdivd eqtrd 3eltr3d oveq1 fveq2 necomd syl3anc
        f1ocnvfvb pm2.21d impr limcco eqcomd oveq2d f1ocnvfv2 eleqtrd mpbir2and
        necon3abid ) ABDUDZUEBCDUFRZUDZUGRZCDUHZUFRUIUWEHFUJUDZUDZSUWHUAHUWEUOZ
        UKZUAUPZUWIUDZUWEUWIUDZULRZUWNUWEULRZUGRZUMZUWEUNRZSAUWEHUWKAGHBDAGHDUQ
        ZGHDVHZMGHDURUSZQUTZAFVASZHFSZUWKHVBAFCVCUDZSZUXFAFECVDRZUXHJAETVCUDSZC
        TVEZUXJUXHSEIVFZACVITVGSZUXLKCVJUSZCETVKVLVMZCFVNUSLHFVOVRVPAUWHUAUWMUW
        OBULRZUWODUDZUWEULRZUGRZUMZUWEUNRUXAAUAUBUWMGBUOZUKZBUWHUWOUBUPZBULRZUY
        DDUDZUWEULRZUGRZUXTUWEAUWNUWMSZUWOBVQZUWOUYCSZAUYIVSZUYJVSUWOGSZUYJVSUY
        KUYLUYMUYJAHGUWIVHZUWNHSZUYMUYIAUXBHGUWIUQUYNMGHDVTHGUWIURWIZUWNHUWLWAZ
        HGUWNUWIWBWCWDUWOGBWJWEWFAUYDUYCSZVSZUYEUYGUYSUYDBUYRAUYDGSZUYDTSUYDGUY
        BWAZAGTUYDAGCTAGUWFWGZCOCDWHWKZUXOWLZWMWNZABTSUYRACTBUXOAGCBVUCQWOWOWPZ
        WQZUYSUYFUWEAGTDVHZUYTUYFTSUYRAUXCHTVEVUHUXDAHCTAUXIUXGHCVEUXPLHFCWRVRZ
        UXOWLZGHTDWSVRZVUAGTUYDDWBWCZAUWETSUYRAHTUWEVUJUXEWOWPZWQZUYSUYGWTVQUYD
        BVQZUYRVUOAUYDGBXAXBZUYSUYGWTUYDBUYSUYGWTVBUYFUWEVBZUYDBVBZUYSUYFUWEVUL
        VUMXCUYSGHDXDZUYTBGSZVUQVURXEAVUSUYRAUXBVUSMGHDXFUSWPUYRUYTAVUAXBAVUTUY
        RQWPGHUYDBDXGXHXJXIXKZXLAUWIUWEUNRZUAUWMUWOUMZUWEUNRZBAUWIUWMXTZUWEUNRV
        VBVVDUWEUWMUWIXMAVVEVVCUWEUNAVVEUAHUWOUMZUWMXTZVVCAUWIVVFUWMAUAHGUWIUYP
        XNXOUWMHVEVVGVVCVBHUWLXPUAHUWMUWOXQYAXRXSYBAUWPBVVBAUXBVUTUWPBVBMQGHBDY
        CVRZAHUWEGUWINUXEYDYEWOAUWGUCTWTUOZUKZUEUCUPZUGRZUMZUDZVVMUBUYCUYGUYEUG
        RZUMZYIZBUNRUWHUBUYCUYHUMZBUNRAUYCBUWGVVJVVPVVMEVVJVDRZEAUBUYCVVOVVJVVP
        UYSVVOTSVVOWTVQVVOVVJSAUYDBGDVUKVUDQYJUYSUYGUYEVUNVUGVVAUYSUYDBVUEVUFVU
        PYFZYGVVOTWTWJYHZVVPYKZUUBVVJTVEZATVVIXPZYLIVVSYKZABGUWJUDSZUWGVVPBUNRS
        ZABUWGUWFUIZVWFVWGVSABVUBSZVWHABGVUBQOVPZAUXNVUBTUWFVHZUWFUUCVWIVWHXEKC
        DUUDZVUBTUWFUUEBUWFUUNUUFYMAUBGBUWGCFDVVPEJIVWBUXOVUKVUCYNYMUUGAVVMVVSE
        YORSUWGVVJSZVVMUWGVVSEUUHRUDSAUCUEVVKUGVVSEVVSEVVJVVSVVJVCUDSZAUXKVWCVW
        NUXMVWDVVJETVKUUIZYLZAUCUEVVSEVVJTVWPUXKAUXMYLUETSAUUJYLUUKAUCVVSVVJVWP
        UULUGEVVSUUAREYORSAEVVSIVWEUUMYLUUOAUWGTSUWGWTVQZVWMAGTBUWFAVWKGTUWFVHA
        UXNVWKKVWLUSZAVUBGTUWFOUUPYMQUTAUWGUWFUUQZSZWTVWSSYPVWQAUWFVUBUURZVWIVW
        TAVWKVXAVWRVUBTUWFUUSUSVWJVUBBUWFUUTVRPUWGWTVWSUVAVRUWGTWTWJYHZUWGVVMVV
        SEVVJVVJVVSVWOUVEUVBVRUVCAVWMVVNUWHVBVXBUCUWGVVLUWHVVJVVMVVKUWGUEUGYQVV
        MYKUEUWGUGUVDUVFUSAVVQVVRBUNAVVQUBUYCUEVVOUGRZUMVVRAUBUCUYCVVJVVOVVLVXC
        VVPVVMVWAAVVPYRAVVMYRVVKVVOUEUGYQUVGAUBUYCVXCUYHUYSUYGUYEVUNVUGVVAVVTUV
        HYSUVIXSUVJUYDUWOVBZUYEUXQUYGUXSUGUYDUWOBULUVKVXDUYFUXRUWEULUYDUWODUVLX
        SYTAUYIUWOBVBZUXTUWHVBZUYLVXEVXFUYLUWEUWNVQVXEYPUYLUWNUWEUYIUWNUWEVQAUW
        NHUWEXAXBUVMUYLVXEUWEUWNUYLUXBVUTUYOUWEUWNVBVXEXEAUXBUYIMWPAVUTUYIQWPUY
        IUYOAUYQXBGHBUWNDUVOUVNUWDYMUVPUVQUVRAUYAUWTUWEUNAUAUWMUXTUWSUYLUXQUWQU
        XSUWRUGUYLBUWPUWOULABUWPVBUYIAUWPBVVHUVSWPUVTUYLUXRUWNUWEULAUXBUYOUXRUW
        NVBUYIMUYQGHUWNDUWAWCXSYTYSXSUWBAUAHUWEUWHCFUWIUWTEJIUWTYKUXOAUYNGTVEHT
        UWIVHUYPVUDHGTUWIWSVRVUIYNUWC $.
    $}

    $( A weak version of ~ dvcnvre , valid for both real and complex domains
       but under the hypothesis that the inverse function is already known to
       be continuous, and the image set is known to be open.  A more advanced
       proof can show that these conditions are unnecessary.  (Contributed by
       Mario Carneiro, 25-Feb-2015.)  (Revised by Mario Carneiro,
       8-Sep-2015.) $)
    dvcnv $p |- ( ph -> ( S _D `' F ) =
      ( x e. Y |-> ( 1 / ( ( S _D F ) ` ( `' F ` x ) ) ) ) ) $=
      ( cfv cc wcel adantr ccnv cdv co cv cmpt c1 cdiv cdm wf cpr dvfg recnprss
      cr syl wss wf1o f1ocnv f1of 3syl dvbsss syl6eqssr sstrd fss syl2anc crest
      ctopon cnfldtopon resttopon sylancr syl5eqel toponss dvbss wceq f1ocnvfv2
      wa wbr sylan ccncf wn ffvelrnda dvcnvlem eqbrtrrd reldv releldmi ex ssrdv
      cc0 crn eqssd feq2d mpbid feqmptd wfun ffun funbrfv sylc mpteq2dva eqtrd
      ) ACDUAZUBUCZBHBUDZWTQZUEBHUFXAWSQZCDUBUCZQUGUCZUEABHRWTAWTUHZRWTUIZHRWTU
      IACUMRUJSZXGKCWSUKUNZAXFHRWTAXFHAHCWSAXHCRUOZKCULUNZAHGWSUIZGRUOHRWSUIAGH
      DUPZHGWSUPXLMGHDUQHGWSURUSZAGCRAGXDUHZCOCDUTVAXKVBHGRWSVCVDAFCVFQZSHFSZHC
      UOAFECVEUCZXPJAERVFQSXJXRXPSEIVGXKCERVHVIVJLHFCVKVDVLABHXFAXAHSZXAXFSZAXS
      VOZXAXEWTVPZXTYAXCDQZXAXEWTAXMXSYCXAVMMGHXADVNVQYAXCCDEFGHIJAXHXSKTAXQXSL
      TAXMXSMTAWSHGVRUCSXSNTAXOGVMXSOTAWGXDWHSVSXSPTAHGXAWSXNVTWAWBZXAXEWTCWSWC
      WDUNWEWFWIWJWKWLABHXBXEYAWTWMZYBXBXEVMYAXGYEAXGXSXITXFRWTWNUNYDXAXEWTWOWP
      WQWR $.
  $}

  ${
    $d x y N $.
    $( Derivative of an exponential of integer exponent.  (Contributed by Mario
       Carneiro, 26-Feb-2015.) $)
    dvexp3 $p |- ( N e. ZZ -> ( CC _D ( x e. ( CC \ { 0 } ) |-> ( x ^ N ) ) ) =
                  ( x e. ( CC \ { 0 } ) |-> ( N x. ( x ^ ( N - 1 ) ) ) ) ) $=
      ( vy cz wcel wa cc cc0 cexp co cmpt c1 cmin cmul wceq cvv a1i oveq2d cdiv
      c2 cn0 cr cneg cn wo csn cdif cdv elznn0nn cif ccnfld ctopn cfv cpr prid2
      cnex expcl ancoms c0ex ovex ifex dvexp2 difssd crest ctop eqid cnfldtopon
      cnfldtop toponunii restid ax-mp eqcomi ccld cha cnfldhaus 0cn sncld mp2an
      cv cldopn dvmptres id oveq1 oveq12d wne eldifsn 0z peano2zm expclz mp3an3
      ifid sylbi adantl mul02d sylan9eqr ifeq1da mpteq2dva eqtr4d eldifi simpll
      syl5eqr recnd nnnn0 ad2antlr expneg2 syl3anc eldifsni nnz expclzd expne0d
      sylanbrc simpr sylib reccl syl negex expcld dvexp ax-1cn dvrec mp1i oveq2
      negeqd dvmptco 2z expmulz syl22anc eqcomd mulneg1d zmulcl reccld mul2negd
      sylancl mulcld mul12d expsubd nncn zcnd eqtrd 3eqtrd sub32d caddc times2d
      negsubd nncand oveq1d divrec2d 3eqtr3rd jaoi ) BDEBUAEZBUBEZBUCZUDEZFZUEG
      AGHUFZUGZAVSZBIJZKZUHJZAUUPBUUQBLMJZIJZNJZKZOZBUIUUJUVEUUNUUJUUTAUUPBHOZH
      UVCUJZKUVDUUJAUURUVGGUKULUMZUVHPGUUPGUBGUNEZUUJUBGUPUOZQUUQGEZUUJUURGEUUQ
      BUQURUVGPEUUJUVKFUVFHUVCUSBUVBNUTVAQABVBUUJGUUOVCUVHGVDJZUVHUVHVEEUVLUVHO
      UVHUVHVFZVHUVHVEGGUVHUVHUVMVGVIZVJVKVLZUVMUUPUVHEZUUJUUOUVHVMUMEZUVPUVHVN
      EHGEUVQUVHUVMVOVPHUVHGUVNVQVRUUOUVHGUVNVTVKZQWAUUJAUUPUVCUVGUUJUUQUUPEZFZ
      UVCUVFUVCUVCUJUVGUVFUVCWKUVTUVFUVCHUVCUVFUVTUVCHUUQHLMJZIJZNJHUVFBHUVBUWB
      NUVFWBUVFUVAUWAUUQIBHLMWCRWDUVTUWBUVSUWBGEZUUJUVSUVKUUQHWEZFUWCUUQGHWFUVK
      UWDUWADEZUWCHDEUWEWGHWHVKUUQUWAWIWJWLWMWNWOWPXAWQWRUUNUUTGAUUPLUUQUULIJZS
      JZKZUHJAUUPLUWFTIJZSJZUCZUULUUQUULLMJZIJZNJZNJZKUVDUUNUUSUWHGUHUUNAUUPUUR
      UWGUUNUVSFZUVKBGEUULUAEZUURUWGOUVSUVKUUNUUQGUUOWSWMZUWPBUUKUUMUVSWTXBZUUM
      UWQUUKUVSUULXCZXDUUQBXEXFWQRUUNACUWFUWNLCVSZSJZLUXATIJZSJZUCZGGUWGUWKPPUU
      PUUPUVIUUNUVJQZUXFUWPUWFGEUWFHWEUWFUUPEUWPUUQUULUWRUVSUWDUUNUUQGHXGWMZUUM
      UULDEZUUKUVSUULXHXDZXIUWPUUQUULUWRUXGUXIXJUWFGHWFXKUWNPEZUWPUULUWMNUTZQUU
      NUXAUUPEZFZUXAGEUXAHWEFZUXBGEUXMUXLUXNUUNUXLXLUXAGHWFXMUXAXNXOUXEPEUXMUXD
      XPQUUNAUWFUWNGUVHUVHPGUUPUXFUUNUVKFZUUQUULUUNUVKXLUUMUWQUUKUVKUWTXDXQUXJU
      XOUXKQUUMGAGUWFKUHJAGUWNKOUUKAUULXRWMUUNGUUOVCUVOUVMUVPUUNUVRQWALGEZGCUUP
      UXBKUHJCUUPUXEKOUUNXSCLXTYAUXAUWFLSYBUXAUWFOZUXDUWJUXQUXCUWILSUXAUWFTIWCR
      YCYDUUNAUUPUWOUVCUWPUWOLUUQUULTNJZIJZSJZUCZBUWMNJZUCZNJUXTUYBNJZUVCUWPUWK
      UYAUWNUYCNUWPUWJUXTUWPUWIUXSLSUWPUXSUWIUWPUVKUWDUXHTDEZUXSUWIOUWRUXGUXIUY
      EUWPYEQUUQUULTYFYGYHRYCUWPBUWMUWSUWPUUQUWLUWRUXGUWPUXHUWLDEUXIUULWHXOZXIZ
      YIWDUWPUXTUYBUWPUXSUWPUUQUXRUWRUXGUWPUXHUYEUXRDEUXIYEUULTYJYMZXIZUWPUUQUX
      RUWRUXGUYHXJZYKZUWPBUWMUWSUYGYNYLUWPUYDBUXTUWMNJZNJUVCUWPUXTBUWMUYKUWSUYG
      YOUWPUYLUVBBNUWPUUQUWLUXRMJZIJUWMUXSSJUVBUYLUWPUUQUWLUXRUWRUXGUYHUYFYPUWP
      UYMUVAUUQIUWPUYMUULUXRMJZLMJUVAUWPUULLUXRUUMUULGEUUKUVSUULYQXDZUXPUWPXSQU
      WPUXRUYHYRUUAUWPUYNBLMUWPUYNUULUULBMJZMJBUWPUXRUYPUULMUWPUXRUULUULUUBJUYP
      UWPUULUYOUUCUWPUULBUYOUWSUUDYSRUWPUULBUYOUWSUUEYSUUFYSRUWPUWMUXSUYGUYIUYJ
      UUGUUHRYSYTWQYTUUIWL $.
  $}

  ${
    $d k n w $.  $d w x y D $.  $d w x y F $.  $d w x y z J $.
    $( Derivative of the exponential function at 0.  The key step in the proof
       is ~ eftlub , to show that
       ` abs ( exp ( x ) - 1 - x ) <_ abs ( x ) ^ 2 x. ( 3 / 4 ) ` .
       (Contributed by Mario Carneiro, 9-Aug-2014.)  (Revised by Mario
       Carneiro, 28-Dec-2016.) $)
    dveflem $p |- 0 ( CC _D exp ) 1 $=
      ( vk vn cc0 c1 cc co wbr cfv wcel cmin cdiv wceq cabs clt wa a1i c2 caddc
      cmul c4 vz vw vy vx ce cdv ccnfld ctopn cnt csn cdif cmpt climc ctop eqid
      0cn cnfldtop cnfldtopon toponunii ntrtop ax-mp eleqtrri wne wral crp wrex
      cv wi ax-1cn cle cif 1rp mpan2 eldifsn simprl subid1d fveq2d breq1d cr wb
      ifcl abscld rpre adantr ltmin syl3anc bitrd simplr sylibr fveq2 oveq1d id
      1re oveq12d ovex fvmpt syl simplrl efcl subcld simplrr divcld simpll cexp
      rpred c3 abscl ad2antrr subcl sylancl remulcld resqcld cn 3re 4nn nndivre
      mp2an remulcl cfa cuz cn0 divcan2d divsubdird dividd oveq2d subsub4d df-2
      eqtrd 1e0p1 syl6req efsep oveq2i mpbird oveq1i breqtrd wtru trud mpbir2an
      csu wf 1nn0 0nn0 efval2 nn0uz sumeq1i addid2d eqtr2d eft0val syl6eqr exp1
      fac1 syl6eq div1 eqcomd addcl sylancr 2nn0 eftlcl subaddd 3eqtr3d absmuld
      eqtr3d 2nn simpr ltled eftlub eqbrtrrd df-3 fac2 eqtr2i oveq12i syl6breqr
      2t2e4 sqge0d 3lt4 4cn mulid1i breqtrri 4re 4pos pm3.2i mp3an mpbir ltleii
      ltdivmul lemul2ad recnd sqcld mulid1d letrd sqvald mpbid lemul2d ad2ant2l
      absgt0 elrpd lelttrd eqbrtrd sylbid adantld ralrimiva breq2 anbi2d imbi1d
      ex sylan2b ralbidv rspcev syl2anc rgen eldifi eldifsni fmpti difssd crest
      ellimc3 restid eqcomi ef0 mpteq2ia wss ssid eff eldv ) CDEUEUFFGZCEUGUHHZ
      UIHHZIZDUAECUJZUKZUAVGZUEHZDJFZUYKKFZULZCUMFIZCEUYGUPUYFUNIZUYGELUYFUYFUO
      ZUQZUYFEEUYFUYFUYRURUSZUTVAVBUYPDEIZUBVGZCVCZVUBCJFZMHZUCVGZNGZOZVUBUYOHZ
      DJFZMHZUDVGZNGZVHZUBUYJVDZUCVEVFZUDVEVDZVIVUPUDVEVULVEIZVULDVJGZVULDVKZVE
      IZVUCVUEVUTNGZOZVUMVHZUBUYJVDZVUPVURDVEIVVAVLVUSVULDVEWAVMVURVVDUBUYJVUBU
      YJIZVURVUBEIZVUCOZVVDVUBECVNZVURVVHOZVVBVUMVUCVVJVVBVUBMHZVULNGZVVKDNGZOZ
      VUMVVJVVBVVKVUTNGZVVNVVJVUEVVKVUTNVVJVUDVUBMVVJVUBVURVVGVUCVOZVPVQVRVVJVV
      KVSIZVULVSIZDVSIZVVOVVNVTVVJVUBVVPWBVURVVRVVHVULWCWDVVSVVJWMPVVKVULDWEWFW
      GVVJVVNVUMVVJVVNOZVUKVUBUEHZDJFZVUBKFZDJFZMHZVULNVVTVUJVWDMVVTVUIVWCDJVVT
      VVFVUIVWCLVVTVVHVVFVURVVHVVNWHVVIWIUAVUBUYNVWCUYJUYOUYKVUBLZUYMVWBUYKVUBK
      VWFUYLVWADJUYKVUBUEWJWKVWFWLWNUYOUOZVWBVUBKWOWPWQWKVQVVTVWEVVKVULVVTVWDVV
      TVWCDVVTVWBVUBVVTVWADVVTVVGVWAEIZVURVVGVUCVVNWRZVUBWSZWQVUAVVTVIPZWTVWIVU
      RVVGVUCVVNXAXBVWKWTWBVVTVUBVWIWBVVTVULVURVVHVVNXCXEVVHVVMVWEVVKVJGZVURVVL
      VVHVVMOZVWLVVKVWESFZVVKVVKSFZVJGVWMVWNVVKQXDFZVWOVJVWMVWNVWPXFTKFZSFZVWPV
      WMVVKVWEVVGVVQVUCVVMVUBXGXHZVWMVWDVWMVWCDVWMVWBVUBVWMVWHVUAVWBEIVVGVWHVUC
      VVMVWJXHZVIVWADXIXJZVVGVUCVVMXCZVVGVUCVVMWHZXBVUAVWMVIPZWTZWBZXKVWMVWPVSI
      VWQVSIZVWRVSIVWMVVKVWSXLZXFVSIZTXMIVXGXNXOXFTXPXQZVWPVWQXRXJVXHVWMVWNVWPQ
      DRFZQXSHZQSFZKFZSFZVWRVJVWMQXTHAVGBYAVUBBVGZXDFVXPXSHZKFULZHZAYSZMHZVWNVX
      OVJVWMVUBVWDSFZMHVYAVWNVWMVYBVXTMVWMVUBVWBVUBJFZVUBKFZSFVYCVYBVXTVWMVYCVU
      BVWMVWBVUBVXAVXBWTVXBVXCYBVWMVYDVWDVUBSVWMVYDVWCVUBVUBKFZJFVWDVWMVWBVUBVU
      BVXAVXBVXBVXCYCVWMVYEDVWCJVWMVUBVXBVXCYDYEYHYEVWMVYCVWADVUBRFZJFZVXTVWMVW
      ADVUBVWTVXDVXBYFVWMVYGVXTLVYFVXTRFZVWALVWMVWAVYHVWMVUBDVYFABVXRDQVXRUOZYG
      UUAVXBVXDVWMVUBCDABVXRCDVYIYIUUBVXBCEIZVWMUPPVWMCCXTHZVXSAYSZRFCVWARFVWAV
      WMVYLVWACRVWMVWAYAVXSAYSZVYLVVGVWAVYMLVUCVVMVUBABVXRVYIUUCXHYAVYKVXSAUUDU
      UEYJYEVWMVWAVWTUUFUUGVWMCVUBCXDFCXSHKFZRFCDRFDVWMVYNDCRVVGVYNDLVUCVVMVUBU
      UHXHYEYIUUIYKVWMVUBDXDFZDXSHZKFZVUBDRVWMVYQVUBDKFZVUBVWMVYQVUBVYPKFVYRVWM
      VYOVUBVYPKVVGVYOVUBLVUCVVMVUBUUJXHWKVYPDVUBKUUKYLUULVVGVYRVUBLVUCVVMVUBUU
      MXHYHYEYKUUNVWMVWAVYFVXTVWTVWMVUAVVGVYFEIVIVXBDVUBUUOUUPVWMVVGQYAIVXTEIVX
      BUUQVUBABVXRQVYIUURXJUUSYMYHUUTVQVWMVUBVWDVXBVXEUVAUVBVWMVUBABVXRBYAVVKVX
      PXDFVXQKFULZBYAVWPVXLKFDVXKKFVXPXDFSFULZQVYIVYSUOVYTUOQXMIVWMUVCPVXBVWMVV
      KDVWSVVSVWMWMPZVVHVVMUVDUVEUVFUVGVWQVXNVWPSXFVXKTVXMKUVHVXMQQSFTVXLQQSUVI
      YNUVMUVJUVKYLUVLVWMVWRVWPDSFVWPVJVWMVWQDVWPVXGVWMVXJPWUAVXHVWMVVKVWSUVNVW
      QDVJGVWMVWQDVXJWMVWQDNGZXFTDSFZNGZXFTWUCNUVOTUVPUVQUVRVXIVVSTVSIZCTNGZOWU
      BWUDVTXNWMWUEWUFUVSUVTUWAXFDTUWEUWBUWCUWDPUWFVWMVWPVWMVVKVWMVVKVWSUWGZUWH
      UWIYOUWJVWMVVKWUGUWKYOVWMVWEVVKVVKVXFVWSVWMVVKVWSVWMVUCCVVKNGZVXCVVGVUCWU
      HVTVUCVVMVUBUWOXHUWLUWPUWMYMUWNVVJVVLVVMVOUWQUWRUXEUWSUWTUXFUXAVUOVVEUCVU
      TVEVUFVUTLZVUNVVDUBUYJWUIVUHVVCVUMWUIVUGVVBVUCVUFVUTVUENUXBUXCUXDUXGUXHUX
      IUXJUYPVUAVUQOVTYPUDUCUBUYJCDUYOUYJEUYOYTYPUAUYJEUYNUYOVWGUYKUYJIZUYMUYKW
      UJUYLDWUJUYKEIUYLEIUYKEUYIUXKZUYKWSWQVUAWUJVIPWTWUKUYKECUXLXBUXMPYPEUYIUX
      NVYJYPUPPUXPYQYRUYEUYHUYPOVTYPUAECDEUYFUEUYOUYFUYFEUXOFZUYFUYQWULUYFLUYSU
      YFUNEUYTUXQVAUXRUYRUAUYJUYNUYLCUEHZJFZUYKCJFZKFZWUJWUPWUNUYKKFUYNWUJWUOUY
      KWUNKWUJUYKWUKVPYEWUNUYMUYKKWUMDUYLJUXSYLYNYJUXTEEUYAYPEUYBPZEEUEYTYPUYCP
      WUQUYDYQYR $.
  $}

  ${
    $d x y z $.
    $( Derivative of the exponential function.  (Contributed by Mario Carneiro,
       9-Aug-2014.)  (Proof shortened by Mario Carneiro, 10-Feb-2015.) $)
    dvef $p |- ( CC _D exp ) = exp $=
      ( vx vz cc ce cdv co wceq wtru cfv cmpt wf wcel wbr cmin cc0 c1 caddc a1i
      cmul cvv vy cv cdm dvfcn dvbsss csn cxp cof ccnfld ctopn wss efcl fconstg
      syl snssd fss syl2anc ssid wa subcl ancoms eqid fmptd 0cn ax-1cn cop snid
      elexi opelxpi mpan2 eleqtrrd df-br sylibr ccom eff oveq1 ovex fvmpt subid
      dvconst eqtrd dveflem syl6eqbr cr cpr prid2 simpr dvmptid simpl id dvmptc
      cnex dvmptsub subid1i fconstmpt eqtr4i syl6eq dvcobr 1t1e1 syl6breq eqidd
      mpteq2i feqmptd fveq2 fmptco oveq2d breqd mpbid dvmulbr ffvelrnd fvconst2
      mul02d mulid2d oveq12d addid2d breqtrd offval2 efadd pncan3 fveq2d eqtr3d
      fvex mpteq2dva eqtr4d vex breldm ssriv eqssi feq2i mpbi wfun ffun funbrfv
      ax-mp mpsyl mpteq2ia trud ) CDEFZDGHYRACAUBZDIZJZDHYRACYSYRIZJUUAHACCYRCC
      YRKZHYRUCZCYRKZUUCDUDZUUDCCYRUUDCCDUEACUUDYSCLZYSYTYRMZYSUUDLUUGYSYTCCYTU
      FZUGZBCBUBZYSNFZDIZJZSUHFZEFZMUUHUUGYSOYSUUNIZSFZPYSUUJIZSFZQFZYTUUPUUGYS
      CUUJUUNUIUJIZOPCCCUUGCUUIUUJKZUUICUKCCUUJKUUGYTCLZUVCYSULZCYTCUMUNUUGYTCU
      VEUOCUUICUUJUPUQCCUKUUGCURRZUUGBCUUMCUUNUUGUUKCLZUSZUULCLZUUMCLUVGUUGUVIU
      UKYSUTVAZUULULUNUUNVBVCZUVFUVFOCLZUUGVDRPCLZUUGVERZUUGYSOVFZCUUJEFZLYSOUV
      PMUUGUVOCOUFZUGZUVPUUGOUVQLUVOUVRLOOCVDVHVGYSOCUVQVIVJUUGUVDUVPUVRGUVEYTV
      TUNVKYSOUVPVLVMUUGYSPCDBCUULJZVNZEFZMYSPCUUNEFZMUUGYSPPSFPUWAUUGYSCCDUVSU
      VBPPCCCCCDKZUUGVORZUVFUUGBCUULCUVSUVJUVSVBZVCUVFUVFUVFUVNUVNUUGYSUVSIZOPY
      RUUGUWFYSYSNFZOBYSUULUWGCUVSUUKYSYSNVPUWEYSYSNVQVRYSVSWAWBWCUUGYSPVFZCUVS
      EFZLYSPUWIMUUGUWHCPUFZUGZUWIUUGPUWJLUWHUWKLPPCVEVHVGYSPCUWJVIVJUUGUWIBCPO
      NFZJZUWKUUGBUUKPYSOCCCCCWDCWELUUGWDCWLWFRZUUGUVGWGUVMUVHVERUUGBCUWNWHUUGU
      VGWIZUVLUVHVDRUUGBYSCUWNUUGWJZWKWMUWMBCPJUWKBCUWLPPVEWNXBBCPWOWPWQVKYSPUW
      IVLVMUVBVBZWRWSWTUUGUWAUWBYSPUUGUVTUUNCEUUGBUACCUULUAUBZDIUUMUVSDUVJUUGUV
      SXAUUGUACCDUWDXCUWRUULDXDXEXFXGXHUWQXIUUGUVAOYTQFYTUUGUUROUUTYTQUUGUUQUUG
      CCYSUUNUVKUWPXJXLUUGUUTPYTSFYTUUGUUSYTPSCYTYSYSDYBZXKXFUUGYTUVEXMWAXNUUGY
      TUVEXOWAXPUUGUUPYRYSYTUUGUUODCEUUGUUOBCYTUUMSFZJZDUUGBCYTUUMSUUJUUNTTTCTL
      UUGWLRYTTLUVHUWSRUUMTLUVHUULDYBRUUJBCYTJGUUGBCYTWORUUGUUNXAXQUUGDBCUUKDIZ
      JUXAUUGBCCDUWDXCUUGBCUWTUXBUVHYSUULQFZDIZUWTUXBUVHUUGUVIUXDUWTGUWOUVJYSUU
      LXRUQUVHUXCUUKDYSUUKXSXTYAYCYDYDXFXGXHZYSYTYRAYEUWSYFUNYGYHYIYJRXCACUUBYT
      YRYKZUUGUUHUUBYTGUUEUXFUUFUUDCYRYLYNUXEYSYTYRYMYOYPWQHACCDUWCHVORXCYDYQ
      $.

    $( Derivative of the sine and cosine functions.  (Contributed by Mario
       Carneiro, 21-May-2016.) $)
    dvsincos $p |- ( ( CC _D sin ) = cos /\
      ( CC _D cos ) = ( x e. CC |-> -u ( sin ` x ) ) ) $=
      ( vy cc cdv co ccos wceq cneg cmpt wtru ci cmul ce cdiv caddc c2 wcel a1i
      ax-icn c1 csin cv cfv wa cr cpr cnex prid2 simpr mulcld efcl syl cc0 ine0
      divcld negcli mulcl sylancr negcld addcld adantl ax-1cn dvmptid dvmptcmul
      wne mulid1i mpteq2i syl6eq wf eff feqmptd oveq2d dvef syl5eq eqtr3d fveq2
      dvmptco dvmptdivc divcan4d mpteq2dva eqtrd dvmptneg divneg2d dvmptadd 2cn
      sylancl negne0i 2ne0 cmin df-sin subcld mulcomi oveq2i divsubdird negsubd
      divdiv1d eqtr4d oveq1d df-cos 3eqtr4d divnegd sinval negnegi mulneg2 irec
      negeqd syl5eqr subdird divrecd jca trud ) CUADEZFGZCFDEZACAUBZUAUCZHZIZGZ
      UDJXMXSJCACKXOLEZMUCZKNEZKHZXOLEZMUCZKNEZHZOEZPNEZIZDEACYAYEOEZPNEIZXLFJA
      YHYKPCCCCUECUFQJUECUGUHRZJXOCQZUDZYBYGYOYAKYOXTCQYACQYOKXOKCQZYOSRZJYNUIZ
      UJZXTUKULZYQKUMVEZYOUNRZUOZYOYFYOYEKYOYDCQZYECQZYOYCCQZYNUUDKSUPZYRYCXOUQ
      URZYDUKULZYQUUBUOZUSZUTYOYAYEYTUUIUTZJAYBYAYGYECCCCYMUUCYTJCACYBIDEACYAKL
      EZKNEZIACYAIJAYAUUMKCCCYMYTYOYAKYTYQUJZJABXTKBUBZMUCZUUQCCYAYACCCCYMYMYSY
      QUUPCQUUQCQJUUPUKVAZUURJCACXTIDEACKTLEZIACKIJAXOTKCCCYMYRTCQYOVBRZJACYMVC
      ZYPJSRZVDACUUSKKSVFVGVHJCMDEZCBCUUQIZDEUVDJMUVDCDJBCCMCCMVIJVJRVKZVLJUVCM
      UVDVMUVEVNVOZUUPXTMVPZUVGVQZUVBUUAJUNRZVRJACUUNYAYOYAKYTYQUUBVSVTWAUUKUUI
      JCACYGIDEACYEYCLEZKNEZHZIACYEIJAYFUVKCCCYMUUJYOUVJKYOUUEUUFUVJCQUUIUUGYEY
      CUQWFZYQUUBUOJAYEUVJKCCCYMUUIUVMJABYDYCUUQUUQCCYEYECCCCYMYMUUHUUFYOUUGRZU
      URUURJCACYDIDEACYCTLEZIACYCIJAXOTYCCCCYMYRUUTUVAUUFJUUGRVDACUVOYCYCUUGVFV
      GVHUVFUUPYDMVPZUVPVQZUVBUVIVRWBJACUVLYEYOUVLUVJYCNEYEYOUVJKUVMYQUUBWCYOYE
      YCUUIUVNYCUMVEYOKSUNWGRVSWAVTWAWDPCQZJWERZPUMVEZJWHRZVRJUAYJCDJUAACYAYEWI
      EZPKLEZNEZIYJAWJJACUWDYIYOUWBKNEZPNEZUWDYIYOUWFUWBKPLEZNEUWDYOUWBKPYOYAYE
      YTUUIWKZYQUVRYOWERZUUBUVTYOWHRZWPUWGUWCUWBNKPSWEWLWMVHZYOUWEYHPNYOUWEYBYF
      WIEYHYOYAYEKYTUUIYQUUBWNYOYBYFUUCUUJWOWQWRVOVTVNVLFYLGJAWSRZWTJCYLDEACUUM
      UVJOEZPNEZIXNXRJAYKUWMPCCCYMUULYOUUMUVJUUOUVMUTJAYAUUMYEUVJCCCCYMYTUUOUVH
      UUIUVMUVQWDUVSUWAVRJFYLCDUWLVLJACXQUWNYOUWFHUWEHZPNEXQUWNYOUWEPYOUWBKUWHY
      QUUBUOUWIUWJXAYOXPUWFYOXPUWDUWFYNXPUWDGJXOXBVAUWKWQXFYOUWMUWOPNYOUWBKLEZU
      WBYCLEZHZUWMUWOYOUWPUWBYCHZLEZUWRUWSKUWBLKSXCWMYOUWBCQUUFUWTUWRGUWHUUGUWB
      YCXDWFXGYOUUMYEKLEZHZOEUUMUXAWIEUWMUWPYOUUMUXAUUOYOUUEYPUXACQUUISYEKUQWFW
      OYOUVJUXBUUMOYOUUEYPUVJUXBGUUISYEKXDWFVLYOYAYEKYTUUIYQXHWTYOUWEUWQYOUWEUW
      BTKNEZLEUWQYOUWBKUWHYQUUBXIUXCYCUWBLXEWMVHXFWTWRWTVTWTXJXK $.
  $}

  $( Derivative of the sine function.  (Contributed by Mario Carneiro,
     21-May-2016.) $)
  dvsin $p |- ( CC _D sin ) = cos $=
    ( vx cc csin cdv co ccos wceq cv cfv cneg cmpt dvsincos simpli ) BCDEFGBFDE
    ABAHCIJKGALM $.

  $( Derivative of the cosine function.  (Contributed by Mario Carneiro,
     21-May-2016.) $)
  dvcos $p |- ( CC _D cos ) = ( x e. CC |-> -u ( sin ` x ) ) $=
    ( cc csin cdv co ccos wceq cv cfv cneg cmpt dvsincos simpri ) BCDEFGBFDEABA
    HCIJKGALM $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
              Results on real differentiation
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d y z A $.  $d y z B $.  $d u x y z F $.  $d u x y z U $.  $d u x y z X $.
    $d u y ph $.  $d y z S $.  $d z T $.
    dvferm.a $e |- ( ph -> F : X --> RR ) $.
    dvferm.b $e |- ( ph -> X C_ RR ) $.
    dvferm.u $e |- ( ph -> U e. ( A (,) B ) ) $.
    dvferm.s $e |- ( ph -> ( A (,) B ) C_ X ) $.
    dvferm.d $e |- ( ph -> U e. dom ( RR _D F ) ) $.
    ${
      dvferm1.r $e |- ( ph -> A. y e. ( U (,) B ) ( F ` y ) <_ ( F ` U ) ) $.
      ${
        dvferm1.z $e |- ( ph -> 0 < ( ( RR _D F ) ` U ) ) $.
        dvferm1.t $e |- ( ph -> T e. RR+ ) $.
        dvferm1.l $e |- ( ph -> A. z e. ( X \ { U } )
          ( ( z =/= U /\ ( abs ` ( z - U ) ) < T ) ->
            ( abs ` ( ( ( ( F ` z ) - ( F ` U ) ) / ( z - U ) ) -
              ( ( RR _D F ) ` U ) ) ) < ( ( RR _D F ) ` U ) ) ) $.
        dvferm1.x $e |- S =
          ( ( U + if ( B <_ ( U + T ) , B , ( U + T ) ) ) / 2 ) $.
        $( Lemma for ~ dvferm .  (Contributed by Mario Carneiro,
           24-Feb-2015.) $)
        dvferm1lem $p |- -. ph $=
          ( cfv clt wbr cc0 cmin co cdiv cr cdv cdm wf wss dvfre ffvelrnd recnd
          syl2anc subidd caddc cabs wa csn cdif wcel cv wne wi wral cioo cxr c0
          cle ne0i ndmioo necon1ai 3syl simpld eliooord syl sseldi rexrd xrltle
          ioossre mpd iooss1 sstrd cif c2 cmnf simprd rpred readdcld ifcl mnfxr
          a1i mnflt xrlttrd breq2 ifboth xrmin2 xrre syl22anc syl5eqel ltaddrpd
          rehalfcld avglt1 mpbid syl6breqr avglt2 syl5eqbr xrmin1 xrltletrd w3a
          wb elioo2 mpbir3and sseldd gtned sylanbrc ltled abssubge0d ltsubadd2d
          eldifsn ltletrd mpbird eqbrtrd wceq neeq1 oveq1 fveq2d breq1d anbi12d
          jca fveq2 oveq1d oveq12d imbi12d rspcv syl3c resubcld posdifd syl3anc
          elrpd rerpdivcld absdifltd eqbrtrrd gt0div wn sylc lenltd pm2.65i ) A
          HIUAZFIUAZUBUCZAUUMUDUULUUKUEUFZUBUCZAUUOUDUUNFHUEUFZUGUFZUBUCZAHUHIU
          IUFZUAZUUTUEUFZUDUUQUBAUUTAUUTAUUSUJZUHHUUSAJUHIUKJUHULUVBUHUUSUKKLJI
          UMUPOUNZUOUQAUVAUUQUBUCZUUQUUTUUTURUFUBUCZAUUQUUTUEUFZUSUAZUUTUBUCZUV
          DUVEUTAFJHVAVBZVCZCVDZHVEZUVKHUEUFZUSUAZGUBUCZUTZUVKIUAZUUKUEUFZUVMUG
          UFZUUTUEUFZUSUAZUUTUBUCZVFZCUVIVGFHVEZUUPUSUAZGUBUCZUTZUVHAFJVCUWDUVJ
          AHEVHUFZJFAUWHDEVHUFZJADVIVCZDHVKUCZUWHUWIULAUWJEVIVCZAHUWIVCZUWIVJVE
          UWJUWLUTZMUWIHVLUWNUWIVJDEVMVNVOZVPZADHUBUCZUWKAUWQHEUBUCZAUWMUWQUWRU
          TMHDEVQVRZVPAUWJHVIVCZUWQUWKVFUWPAHAUWIUHHDEWBMVSZVTZDHWAUPWCDHEWDUPN
          WEAFUWHVCZFUHVCZHFUBUCZFEUBUCZAFHEHGURUFZVKUCZEUXGWFZURUFZWGUGUFZUHTA
          UXJAHUXIUXAAUXIVIVCZUXGUHVCZWHUXIUBUCZUXIUXGVKUCZUXIUHVCZAUWLUXGVIVCZ
          UXLAUWJUWLUWOWIZAUXGAHGUXAAGRWJZWKZVTZUXHEUXGVIWLUPZUXTAWHEUBUCZWHUXG
          UBUCZUXNAWHHEWHVIVCAWMWNUXBUXRAHUHVCZWHHUBUCUXAHWOVRAUWQUWRUWSWIZWPAU
          XMUYDUXTUXGWOVRUXHUYCUYDUXNEUXGEUXIWHUBWQUXGUXIWHUBWQWRUPAUWLUXQUXOUX
          RUYAEUXGWSUPZUXIUXGWTXAZWKXDXBZAHUXKFUBAHUXIUBUCZHUXKUBUCZAUWRHUXGUBU
          CZUYJUYFAHGUXARXCUXHUWRUYLUYJEUXGEUXIHUBWQUXGUXIHUBWQWRUPZAUYEUXPUYJU
          YKXMUXAUYHHUXIXEUPXFTXGZAFUXIEAFUYIVTUYBUXRAFUXKUXIUBTAUYJUXKUXIUBUCZ
          UYMAUYEUXPUYJUYOXMUXAUYHHUXIXHUPXFXIZAUWLUXQUXIEVKUCUXRUYAEUXGXJUPXKA
          UWTUWLUXCUXDUXEUXFXLXMUXBUXRHEFXNUPXOZXPZAHFUXAUYNXQZFJHYBXRSAUWDUWFU
          YSAUWEUUPGUBAHFUXAUYIAHFUXAUYIUYNXSXTAUUPGUBUCFUXGUBUCAFUXIUXGUYIUYHU
          XTUYPUYGYCAFHGUYIUXAUXSYAYDYEYLUWCUWGUVHVFCFUVIUVKFYFZUVPUWGUWBUVHUYT
          UVLUWDUVOUWFUVKFHYGUYTUVNUWEGUBUYTUVMUUPUSUVKFHUEYHZYIYJYKUYTUWAUVGUU
          TUBUYTUVTUVFUSUYTUVSUUQUUTUEUYTUVRUUNUVMUUPUGUYTUVQUULUUKUEUVKFIYMYNV
          UAYOYNYIYJYPYQYRAUUQUUTUUTAUUNUUPAUULUUKAJUHFIKUYRUNZAJUHHIKAUWIJHNMX
          PUNZYSZAUUPAFHUYIUXAYSZAUXEUDUUPUBUCZUYNAHFUXAUYIYTXFZUUBUUCUVCUVCUUD
          XFVPUUEAUUNUHVCUUPUHVCVUFUUOUURXMVUDVUEVUGUUNUUPUUFUUAYDAUUKUULVUCVUB
          YTYDAUULUUKVKUCZUUMUUGAUXCBVDZIUAZUUKVKUCZBUWHVGVUHUYQPVUKVUHBFUWHVUI
          FYFVUJUULUUKVKVUIFIYMYJYQUUHAUULUUKVUBVUCUUIXFUUJ $.
      $}

      $d x z ph $.
      $( One-sided version of ~ dvferm .  A point ` U ` which is the local
         maximum of its right neighborhood has derivative at most zero.
         (Contributed by Mario Carneiro, 24-Feb-2015.)  (Proof shortened by
         Mario Carneiro, 28-Dec-2016.) $)
      dvferm1 $p |- ( ph -> ( ( RR _D F ) ` U ) <_ 0 ) $=
        ( cr co cfv wbr cmin wcel cc vz vu vx cdv cc0 cle clt wn cv wne cabs wa
        cdiv wi csn cdif wral crp wrex cdm wf wss dvfre syl2anc ffvelrnd anim1i
        cmpt elrp sylibr climc ccnfld ctopn crest cnt wfun wb dvf ffun funfvbrb
        mp2b sylib eqid ax-resscn a1i fss sylancl eldv mpbid simprd adantr cioo
        syl6ss sseldd dvlem fmptd ssdifssd ellimc3 wceq fveq2 oveq1d oveq1 ovex
        oveq12d fvmpt fveq2d breqan12rd imbi2d ralbidva rexbidv rspcv caddc cif
        id sylc c2 ad3antrrr simplr simpr dvferm1lem imnani nrexdv pm2.65da 0re
        simpllr lenlt mpbird ) AENFUDOZPZUEUFQZUEYHUGQZUHZAYJUAUIZEUJYLEROZUKPU
        BUIZUGQULZYLFPZEFPZROZYMUMOZYHROZUKPZYHUGQZUNZUAGEUOZUPZUQZUBURUSZAYJUL
        ZYHURSZYOYLUCUUEUCUIZFPZYQROZUUJEROZUMOZVGZPZYHROZUKPZBUIZUGQZUNZUAUUEU
        QZUBURUSZBURUQZUUGUUHYHNSZYJULUUIAUVEYJAYGUTZNEYGAGNFVAZGNVBZUVFNYGVAHI
        GFVCVDLVEZVFYHVHVIUUHYHTSZUVDUUHYHUUOEVJOSZUVJUVDULAUVKYJAEGVKVLPZNVMOZ
        VNPPSZUVKAEYHYGQZUVNUVKULAEUVFSZUVOLUVFTYGVAYGVOUVPUVOVPFVQUVFTYGVREYGV
        SVTWAAUCGEYHNUVMFUUOUVLUVMWBUVLWBUUOWBZNTVBZAWCWDAUVGUVRGTFVAHWCGNTFWEW
        FZIWGWHWIWJUUHBUBUAUUEEYHUUOAUUETUUOVAYJAUCUUEUUNTUUOAUUJEGFUVSAGNTIWCW
        LZACDWKOZGEKJWMZWNUVQWOWJUUHGTUUDAGTVBYJUVTWJWPAETSYJAGTEUVTUWBWMWJWQWH
        WIUVCUUGBYHURUUSYHWRZUVBUUFUBURUWCUVAUUCUAUUEUWCYLUUESZULUUTUUBYOUWDUWC
        UURUUAUUSYHUGUWDUUQYTUKUWDUUPYSYHRUCYLUUNYSUUEUUOUUJYLWRZUULYRUUMYMUMUW
        EUUKYPYQRUUJYLFWSWTUUJYLERXAXCUVQYRYMUMXBXDWTXEUWCXMXFXGXHXIXJXNUUHUUFU
        BURUUHYNURSZULZUUFUWGUUFULBUACDEDEYNXKOZUFQDUWHXLXKOXOUMOZYNEFGAUVGYJUW
        FUUFHXPAUVHYJUWFUUFIXPAEUWASYJUWFUUFJXPAUWAGVBYJUWFUUFKXPAUVPYJUWFUUFLX
        PAUUSFPYQUFQBEDWKOUQYJUWFUUFMXPAYJUWFUUFYDUUHUWFUUFXQUWGUUFXRUWIWBXSXTY
        AYBAUVEUENSYIYKVPUVIYCYHUEYEWFYF $.
    $}

    ${
      dvferm2.r $e |- ( ph -> A. y e. ( A (,) U ) ( F ` y ) <_ ( F ` U ) ) $.
      ${
        dvferm2.z $e |- ( ph -> ( ( RR _D F ) ` U ) < 0 ) $.
        dvferm2.t $e |- ( ph -> T e. RR+ ) $.
        dvferm2.l $e |- ( ph -> A. z e. ( X \ { U } )
          ( ( z =/= U /\ ( abs ` ( z - U ) ) < T ) ->
            ( abs ` ( ( ( ( F ` z ) - ( F ` U ) ) / ( z - U ) ) -
              ( ( RR _D F ) ` U ) ) ) < -u ( ( RR _D F ) ` U ) ) ) $.
        dvferm2.x $e |- S =
          ( ( if ( A <_ ( U - T ) , ( U - T ) , A ) + U ) / 2 ) $.
        $( Lemma for ~ dvferm .  (Contributed by Mario Carneiro,
           24-Feb-2015.) $)
        dvferm2lem $p |- -. ph $=
          ( cfv clt wbr cc0 cmin co cneg cdiv cr cdv caddc cabs wa cdif wcel cv
          csn wne wi wral cioo cxr cle wss ne0i ndmioo necon1ai simprd eliooord
          c0 3syl syl ioossre sseldi rexrd xrltle syl2anc mpd iooss2 sstrd cmnf
          cif c2 mnfxr a1i rpred resubcld simpld ifcl xrmax2 xrltletrd ltsubrpd
          mnflt breq1 ifboth syl32anc readdcld rehalfcld syl5eqel xrmax1 avglt1
          xrre2 wb mpbid syl6breqr xrlelttrd avglt2 w3a elioo2 mpbir3and sseldd
          syl5eqbr ltned eldifsn sylanbrc ltled abssuble0d lelttrd ltsub23d jca
          eqbrtrd wceq neeq1 oveq1 fveq2d breq1d anbi12d oveq1d oveq12d imbi12d
          fveq2 rspcv syl3c ffvelrnd recnd wf renegcld breqtrd posdifd mpbird
          redivcld dvfre absdifltd negidd lt0neg1d divneg2d negsubdi2d breqtrrd
          subne0d cdm gt0div syl3anc wn sylc lenltd pm2.65i ) AHIUAZFIUAZUBUCZA
          UUSUDUURUUQUEUFZUBUCZAUVAUDUUTFHUEUFZUGZUHUFZUBUCZAUDUUTUVBUHUFZUGZUV
          DUBAUVFUDUBUCUDUVGUBUCAUVFHUIIUJUFZUAZUVIUGZUKUFZUDUBAUVIUVJUEUFUVFUB
          UCZUVFUVKUBUCZAUVFUVIUEUFZULUAZUVJUBUCZUVLUVMUMAFJHUQUNZUOZCUPZHURZUV
          SHUEUFZULUAZGUBUCZUMZUVSIUAZUUQUEUFZUWAUHUFZUVIUEUFZULUAZUVJUBUCZUSZC
          UVQUTFHURZUVBULUAZGUBUCZUMZUVPAFJUOUWLUVRADHVAUFZJFAUWPDEVAUFZJAEVBUO
          ZHEVCUCZUWPUWQVDADVBUOZUWRAHUWQUOZUWQVJURUWTUWRUMZMUWQHVEUXBUWQVJDEVF
          VGVKZVHZAHEUBUCZUWSADHUBUCZUXEAUXAUXFUXEUMMHDEVIVLZVHAHVBUOZUWRUXEUWS
          USAHAUWQUIHDEVMMVNZVOZUXDHEVPVQVRDHEVSVQNVTAFUWPUOZFUIUOZDFUBUCZFHUBU
          CZAFDHGUEUFZVCUCZUXODWBZHUKUFZWCUHUFZUITAUXRAUXQHAWAVBUOZUXQVBUOZUXHW
          AUXQUBUCUXQHUBUCZUXQUIUOZUXTAWDWEZAUXOVBUOZUWTUYAAUXOAHGUXIAGRWFZWGZV
          OZAUWTUWRUXCWHZUXPUXODVBWIVQZUXJAWAUXOUXQUYDUYHUYJAUXOUIUOWAUXOUBUCUY
          GUXOWMVLAUWTUYEUXOUXQVCUCUYIUYHDUXOWJVQZWKAUXOHUBUCZUXFUYBAHGUXIRWLAU
          XFUXEUXGWHUXPUYLUXFUYBUXODUXOUXQHUBWNDUXQHUBWNWOVQZWAUXQHXBWPZUXIWQWR
          WSZADUXQFUYIUYJAFUYOVOAUWTUYEDUXQVCUCUYIUYHDUXOWTVQAUXQUXSFUBAUYBUXQU
          XSUBUCZUYMAUYCHUIUOZUYBUYPXCUYNUXIUXQHXAVQXDTXEZXFAFUXSHUBTAUYBUXSHUB
          UCZUYMAUYCUYQUYBUYSXCUYNUXIUXQHXGVQXDXLZAUWTUXHUXKUXLUXMUXNXHXCUYIUXJ
          DHFXIVQXJZXKZAFHUYOUYTXMZFJHXNXOSAUWLUWNVUCAUWMHFUEUFZGUBAFHUYOUXIAFH
          UYOUXIUYTXPXQAHGFUXIUYFUYOAUXOUXQFUYGUYNUYOUYKUYRXRXSYAXTUWKUWOUVPUSC
          FUVQUVSFYBZUWDUWOUWJUVPVUEUVTUWLUWCUWNUVSFHYCVUEUWBUWMGUBVUEUWAUVBULU
          VSFHUEYDZYEYFYGVUEUWIUVOUVJUBVUEUWHUVNULVUEUWGUVFUVIUEVUEUWFUUTUWAUVB
          UHVUEUWEUURUUQUEUVSFIYKYHVUFYIYHYEYFYJYLYMAUVFUVIUVJAUUTUVBAUURUUQAJU
          IFIKVUBYNZAJUIHIKAUWQJHNMXKYNZWGZAFHUYOUXIWGZAFHAFUYOYOZAHUXIYOZVUCUU
          IZUUAZAUVHUUJZUIHUVHAJUIIYPJUIVDVUOUIUVHYPKLJIUUBVQOYNZAUVIVUPYQUUCXD
          VHAUVIAUVIVUPYOUUDYRAUVFVUNUUEXDAUUTUVBAUUTVUIYOAUVBVUJYOVUMUUFYRAUUT
          UIUOUVCUIUOUDUVCUBUCUVAUVEXCVUIAUVBVUJYQAUDVUDUVCUBAUXNUDVUDUBUCUYTAF
          HUYOUXIYSXDAFHVUKVULUUGUUHUUTUVCUUKUULYTAUUQUURVUHVUGYSYTAUURUUQVCUCZ
          UUSUUMAUXKBUPZIUAZUUQVCUCZBUWPUTVUQVUAPVUTVUQBFUWPVURFYBVUSUURUUQVCVU
          RFIYKYFYLUUNAUURUUQVUGVUHUUOXDUUP $.
      $}

      $d x z ph $.
      $( One-sided version of ~ dvferm .  A point ` U ` which is the local
         maximum of its left neighborhood has derivative at least zero.
         (Contributed by Mario Carneiro, 24-Feb-2015.)  (Proof shortened by
         Mario Carneiro, 28-Dec-2016.) $)
      dvferm2 $p |- ( ph -> 0 <_ ( ( RR _D F ) ` U ) ) $=
        ( cr co cfv wbr cmin wcel cc vz vu vx cc0 cdv cle clt wn cv wne cabs wa
        cdiv cneg wi csn cdif wral crp wrex cmpt cdm wss dvfre syl2anc ffvelrnd
        adantr renegcld lt0neg1d biimpa elrpd climc ccnfld ctopn crest cnt wfun
        wf wb dvf ffun funfvbrb mp2b sylib eqid ax-resscn a1i fss sylancl mpbid
        eldv simprd syl6ss cioo sseldd dvlem fmptd ssdifssd ellimc3 wceq oveq1d
        fveq2 oveq1 oveq12d ovex fvmpt fveq2d breqan12rd ralbidva rexbidv rspcv
        id imbi2d cif caddc c2 ad3antrrr simpllr simplr simpr dvferm2lem imnani
        sylc nrexdv pm2.65da 0re lenlt sylancr mpbird ) AUDENFUEOZPZUFQZYKUDUGQ
        ZUHZAYMUAUIZEUJYOEROZUKPUBUIZUGQULZYOFPZEFPZROZYPUMOZYKROZUKPZYKUNZUGQZ
        UOZUAGEUPZUQZURZUBUSUTZAYMULZUUEUSSYRYOUCUUIUCUIZFPZYTROZUUMEROZUMOZVAZ
        PZYKROZUKPZBUIZUGQZUOZUAUUIURZUBUSUTZBUSURZUUKUULUUEUULYKAYKNSZYMAYJVBZ
        NEYJAGNFVRZGNVCZUVINYJVRHIGFVDVELVFZVGVHAYMUDUUEUGQAYKUVLVIVJVKUULYKTSZ
        UVGUULYKUUREVLOSZUVMUVGULAUVNYMAEGVMVNPZNVOOZVPPPSZUVNAEYKYJQZUVQUVNULA
        EUVISZUVRLUVITYJVRYJVQUVSUVRVSFVTUVITYJWAEYJWBWCWDAUCGEYKNUVPFUURUVOUVP
        WEUVOWEUURWEZNTVCZAWFWGAUVJUWAGTFVRHWFGNTFWHWIZIWKWJWLVGUULBUBUAUUIEYKU
        URAUUITUURVRYMAUCUUIUUQTUURAUUMEGFUWBAGNTIWFWMZACDWNOZGEKJWOZWPUVTWQVGU
        ULGTUUHAGTVCYMUWCVGWRAETSYMAGTEUWCUWEWOVGWSWJWLUVFUUKBUUEUSUVBUUEWTZUVE
        UUJUBUSUWFUVDUUGUAUUIUWFYOUUISZULUVCUUFYRUWGUWFUVAUUDUVBUUEUGUWGUUTUUCU
        KUWGUUSUUBYKRUCYOUUQUUBUUIUURUUMYOWTZUUOUUAUUPYPUMUWHUUNYSYTRUUMYOFXBXA
        UUMYOERXCXDUVTUUAYPUMXEXFXAXGUWFXLXHXMXIXJXKYCUULUUJUBUSUULYQUSSZULZUUJ
        UWJUUJULBUACDCEYQROZUFQUWKCXNEXOOXPUMOZYQEFGAUVJYMUWIUUJHXQAUVKYMUWIUUJ
        IXQAEUWDSYMUWIUUJJXQAUWDGVCYMUWIUUJKXQAUVSYMUWIUUJLXQAUVBFPYTUFQBCEWNOU
        RYMUWIUUJMXQAYMUWIUUJXRUULUWIUUJXSUWJUUJXTUWLWEYAYBYDYEAUDNSUVHYLYNVSYF
        UVLUDYKYGYHYI $.
    $}

    dvferm.r $e |- ( ph -> A. y e. ( A (,) B ) ( F ` y ) <_ ( F ` U ) ) $.
    $( Fermat's theorem on stationary points.  A point ` U ` which is a local
       maximum has derivative equal to zero.  (Contributed by Mario Carneiro,
       1-Sep-2014.) $)
    dvferm $p |- ( ph -> ( ( RR _D F ) ` U ) = 0 ) $=
      ( cr co cc0 cle wbr wcel syl2anc cdv cfv wceq cioo wss cv wral cxr c0 wne
      wa ne0i ndmioo necon1ai 3syl simpld clt eliooord syl ioossre sseldi rexrd
      wi xrltle mpd iooss1 ssralv dvferm1 simprd iooss2 dvferm2 wb cdm wf dvfre
      sylc ffvelrnd 0re letri3 sylancl mpbir2and ) AENFUAOZUBZPUCZWCPQRZPWCQRZA
      BCDEFGHIJKLAEDUDOZCDUDOZUEZBUFFUBEFUBQRZBWHUGZWJBWGUGACUHSZCEQRZWIAWLDUHS
      ZAEWHSZWHUIUJWLWNUKZJWHEULWPWHUICDUMUNUOZUPZACEUQRZWMAWSEDUQRZAWOWSWTUKJE
      CDURUSZUPAWLEUHSZWSWMVCWRAEAWHNECDUTJVAVBZCEVDTVECEDVFTMWJBWGWHVGVPVHABCD
      EFGHIJKLACEUDOZWHUEZWKWJBXDUGAWNEDQRZXEAWLWNWQVIZAWTXFAWSWTXAVIAXBWNWTXFV
      CXCXGEDVDTVECEDVJTMWJBXDWHVGVPVKAWCNSPNSWDWEWFUKVLAWBVMZNEWBAGNFVNGNUEXHN
      WBVNHIGFVOTLVQVRWCPVSVTWA $.
  $}

  ${
    $d t u v w x y z A $.  $d t u v w x y ph $.  $d z T $.  $d y z X $.
    $d t u v w x y z B $.  $d t u v w x y z F $.  $d u v w x y z U $.
    rolle.a $e |- ( ph -> A e. RR ) $.
    rolle.b $e |- ( ph -> B e. RR ) $.
    rolle.lt $e |- ( ph -> A < B ) $.
    rolle.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    rolle.d $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    ${
      rolle.r $e |- ( ph -> A. y e. ( A [,] B ) ( F ` y ) <_ ( F ` U ) ) $.
      rolle.u $e |- ( ph -> U e. ( A [,] B ) ) $.
      rolle.n $e |- ( ph -> -. U e. { A , B } ) $.
      $( Lemma for ~ rolle .  (Contributed by Mario Carneiro, 1-Sep-2014.) $)
      rollelem $p |- ( ph -> E. x e. ( A (,) B ) ( ( RR _D F ) ` x ) = 0 ) $=
        ( co wcel cr cfv wceq cioo cdv cc0 cv wrex cpr cun wo cxr cle wbr rexrd
        cicc ltled prunioo syl3anc eleqtrrd elun sylib ord mt3d ccncf cncff syl
        wf wss iccssre syl2anc ioossicc a1i cdm wral ssralv dvferm fveq2 eqeq1d
        sylc rspcev ) AFDEUAPZQZFRGUBPZSZUCTZBUDZWASZUCTZBVSUEAVTFDEUFZQZOAVTWH
        AFVSWGUGZQVTWHUHAFDEUMPZWINADUIQEUIQDEUJUKWIWJTADHULAEIULADEHIJUNDEUOUP
        UQFVSWGURUSUTVAZACDEFGWJAGWJRVBPQWJRGVEKWJRGVCVDADRQERQWJRVFHIDEVGVHWKV
        SWJVFZADEVIVJZAFVSWAVKWKLUQAWLCUDGSFGSUJUKZCWJVLWNCVSVLWMMWNCVSWJVMVQVN
        WFWCBFVSWDFTWEWBUCWDFWAVOVPVRVH $.
    $}

    rolle.e $e |- ( ph -> ( F ` A ) = ( F ` B ) ) $.
    $( Rolle's theorem.  If ` F ` is a real continuous function on
       ` [ A , B ] ` which is differentiable on ` ( A , B ) ` , and
       ` F ( A ) = F ( B ) ` , then there is some ` x e. ( A , B ) ` such that
       ` ( RR _D F ) `` x = 0 ` .  (Contributed by Mario Carneiro,
       1-Sep-2014.) $)
    rolle $p |- ( ph -> E. x e. ( A (,) B ) ( ( RR _D F ) ` x ) = 0 ) $=
      ( vy vu cfv wa cr wceq wcel ad2antrr cc vv vt cv cle wbr cicc co wral cdv
      wrex cc0 cioo ltled evthicc reeanv sylibr r19.26 cpr clt ccncf cdm ralimi
      wn simpl fveq2 breq1d cbvralv sylib ad2antrl simplrl simprr rollelem expr
      weq cneg cmpt wf cncff syl ffvelrnda renegcld eqid fmptd wss wb ax-resscn
      cncfss mp2an sseldi negfcncf cncffvrn sylancr mpbird crn ctg ccnfld ctopn
      ssid a1i iccssre syl2anc fss sylancl negcld tgioo2 cnt dvmptntr cvv prid1
      iccntr reex ioossicc sseli sylan2 feqmptd oveq2d dvf feq2d mpbii 3eqtr3rd
      fvex negex ffvelrnd adantr negeqd fvmpt bitr4d imp fveq1d sylan9eq eqeq1d
      simplrr wi syl5ibrcom cxr rexrd impancom wfn ex sylbird eqtrd dmmptg mprg
      dvmptneg dmeqd syl6eq simpr lenegd adantl breq12d syl5ib ralimdva adantrr
      eleq2d biimpar ffvelrni negeq0d rexbidva mpbid wo elpr eqcomd jaod syl5bi
      eleq1 imbi12d imbi2d chvarv anim12d lbicc2 syl3anc letri3d breq2 bi2anan9
      vex breq1 bibi2d ralbidva csn cxp fnconstg eqfnfv fvconst2 eqeq2d ralbiia
      ffn syl6bb fconstmpt eqeq2i biimpi recnd dvmptc dvmptres2 sylan9eqr eqidd
      0cn c0ex ralrimiva c0 ioon0 r19.2z sylan syldan ecased syl5bir rexlimdvva
      wne syld mpd ) ALUCZENZMUCZENZUDUEZLCDUFUGZUHZUAUCZENZUXKUDUEZLUXOUHZOZUA
      UXOUJMUXOUJZBUCZPEUIUGZNZUKQZBCDULUGZUJZAUXPMUXOUJUXTUAUXOUJOUYBAMLUALCDE
      FGACDFGHUMZIUNUXPUXTMUAUXOUXOUOUPAUYAUYHMUAUXOUXOUYAUXNUXSOZLUXOUHZAUXLUX
      ORZUXQUXORZOZOZUYHUXNUXSLUXOUQUYOUYKUYHUYOUYKOZUXLCDURZRZUXQUYQRZUYHUYOUY
      KUYRVCZUYHUYOUYKUYTOZOBUBCDUXLEACPRZUYNVUAFSADPRZUYNVUAGSACDUSUEZUYNVUAHS
      AEUXOPUTUGZRZUYNVUAISAUYDVAZUYGQUYNVUAJSUYKUBUCZENZUXMUDUEZUBUXOUHZUYOUYT
      UYKUXPVUKUYJUXNLUXOUXNUXSVDVBUXNVUJLUBUXOLUBVNZUXKVUIUXMUDUXJVUHEVEVFVGVH
      VIAUYLUYMVUAVJUYOUYKUYTVKVLVMUYOUYKUYSVCZUYHUYOUYKVUMOZOZUYCPMUXOUXMVOZVP
      ZUIUGZNZUKQZBUYGUJZUYHVUOBUBCDUXQVUQAVUBUYNVUNFSAVUCUYNVUNGSAVUDUYNVUNHSA
      VUQVUERZUYNVUNAVVBUXOPVUQVQZAMUXOVUPPVUQAUYLOZUXMAUXOPUXLEAVUFUXOPEVQZIUX
      OPEVRVSZVTWAVUQWBZWCAPTWDZVUQUXOTUTUGZRZVVBVVCWEWFAEVVIRVVJAVUEVVIEVVHTTW
      DVUEVVIWDWFTWRUXOPTWGWHIWIMUXOEVUQVVGWJVSUXOTPVUQWKWLWMSAVURVAZUYGQUYNVUN
      AVVKMUYGUXLUYDNZVOZVPZVAZUYGAVURVVNAVURPMUYGVUPVPUIUGVVNAMVUPPULWNWONZWPW
      QNZUXOUYGVVHAWFWSZAVUBVUCUXOPWDFGCDWTXAZVVDUXMAUXOTUXLEAVVEVVHUXOTEVQVVFW
      FUXOPTEXBXCVTZXDVVQVVQWBZXEZVWAAVUBVUCUXOVVPXFNNUYGQFGCDXJXAZXGAMUXMVVLPX
      HUYGPPTURRAPTXKXIWSZUXLUYGRZAUYLUXMTRUYGUXOUXLCDXLXMVVTXNVVLXHRAVWEOUXLUY
      DYAWSAUYDPMUXOUXMVPZUIUGMUYGVVLVPPMUYGUXMVPUIUGAEVWFPUIAMUXOPEVVFXOXPAMUY
      GTUYDAVUGTUYDVQUYGTUYDVQEXQZAVUGUYGTUYDJXRXSXOAMUXMPVVPVVQUXOUYGVVRVVSVVT
      VWBVWAVWCXGXTUUDUUAZUUEVVMXHRZVVOUYGQMUYGMUYGVVMXHUUBVWIVWEVVLYBWSUUCUUFS
      UYOUYKVUHVUQNZUXQVUQNZUDUEZUBUXOUHZVUMUYPUXJVUQNZVWKUDUEZLUXOUHZVWMUYOUYK
      VWPUYOUYJVWOLUXOUYJUXSUYOUXJUXORZOZVWOUXNUXSUUGVWRUXSUXKVOZUXRVOZUDUEVWOV
      WRUXRUXKVWRUXOPUXQEAVVEUYNVWQVVFSAUYLUYMVWQYLZYCUYOUXOPUXJEAVVEUYNVVFYDVT
      ZUUHVWRVWNVWSVWKVWTUDVWQVWNVWSQUYOMUXJVUPVWSUXOVUQMLVNUXMUXKUXLUXJEVEYEVV
      GUXKYBYFUUIVWRUYMVWKVWTQVXAMUXQVUPVWTUXOVUQMUAVNZUXMUXRUXLUXQEVEZYEVVGUXR
      YBYFVSUUJYGUUKUULYHVWOVWLLUBUXOVULVWNVWJVWKUDUXJVUHVUQVEVFVGVHUUMAUYLUYMV
      UNYLUYOUYKVUMVKVLAVVAUYHWEUYNVUNAVUTUYFBUYGAUYCUYGRZOZVUTUYEVOZUKQUYFVXFV
      USVXGUKAVXEVUSUYCVVNNVXGAUYCVURVVNVWHYIMUYCVVMVXGUYGVVNMBVNZVVLUYEUXLUYCU
      YDVEYEVVNWBUYEYBYFYJYKVXFUYEVXFUYCVUGRZUYETRAVXIVXEAVUGUYGUYCJUUNUUOVUGTU
      YCUYDVWGUUPVSUUQYGUURSUUSVMUYPUYRUYSOZUXMCENZQZUXRVXKQZOZUYHAVXJVXNYMUYNU
      YKAUYRVXLUYSVXMUYRUXLCQZUXLDQZUUTAVXLUXLCDMUVOUVAAVXOVXLVXPVXOVXLYMAUXLCE
      VEWSAVXLVXPDENZVXKQAVXKVXQKUVBVXPUXMVXQVXKUXLDEVEYKYNUVCUVDZAUYRVXLYMZYMA
      UYSVXMYMZYMMUAVXCVXSVXTAVXCUYRUYSVXLVXMUXLUXQUYQUVEVXCUXMUXRVXKVXDYKUVFUV
      GVXRUVHUVISUYOVXNUYKUYHUYOVXNOZUYKUXKVXKQZLUXOUHZUYHVYAVYBUYJLUXOVYAVWQVY
      BUYJWEZUYOVWQVXNVYDVWRVYDVXNVYBUXKVXKUDUEZVXKUXKUDUEZOZWEVWRUXKVXKVXBAVXK
      PRZUYNVWQAUXOPCEVVFACYORZDYORZCDUDUECUXORACFYPZADGYPZUYICDUVJUVKYCZSUVLVX
      NUYJVYGVYBVXLUXNVYEVXMUXSVYFUXMVXKUXKUDUVMUXRVXKUXKUDUVPUVNUVQYNYQYHUVRAV
      YCUYHYMUYNVXNAVYCEUXOVXKUVSUVTZQZUYHAVYOUXKUXJVYNNZQZLUXOUHZVYCAEUXOYRZVY
      NUXOYRZVYOVYRWEAVVEVYSVVFUXOPEUWFVSAVYHVYTVYMUXOVXKPUWAVSLUXOEVYNUWBXAVYQ
      VYBLUXOVWQVYPVXKUXKUXOVXKUXJCEYAUWCUWDUWEUWGAVYOUYHAVYOUYFBUYGUHZUYHAVYOO
      ZUYFBUYGWUBVXEUYEUYCMUYGUKVPZNUKWUBUYCUYDWUCVYOAUYDPMUXOVXKVPZUIUGWUCVYOE
      WUDPUIVYOEWUDQVYNWUDEMUXOVXKUWHUWIUWJXPAMVXKUKPVVPVVQTPUYGUXOVWDAVXKTRUXL
      PRZAVXKVYMUWKZYDUKTRAWUEOUWPWSAMVXKPVWDWUFUWLVVSVWBVWAVWCUWMUWNYIMUYCUKUK
      UYGWUCVXHUKUWOWUCWBUWQYFYJUWRAUYGUWSUXGZWUAUYHAWUGVUDHAVYIVYJWUGVUDWEVYKV
      YLCDUWTXAWMUYFBUYGUXAUXBUXCYSYTSYTYQUXHUXDYSUXEUXFUXI $.
  $}

  ${
    $d x z A $.  $d x z B $.  $d x z F $.  $d x z G $.  $d x z ph $.
    cmvth.a $e |- ( ph -> A e. RR ) $.
    cmvth.b $e |- ( ph -> B e. RR ) $.
    cmvth.lt $e |- ( ph -> A < B ) $.
    cmvth.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    cmvth.g $e |- ( ph -> G e. ( ( A [,] B ) -cn-> RR ) ) $.
    cmvth.df $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    cmvth.dg $e |- ( ph -> dom ( RR _D G ) = ( A (,) B ) ) $.
    $( Cauchy's Mean Value Theorem.  If ` F , G ` are real continuous functions
       on ` [ A , B ] ` differentiable on ` ( A , B ) ` , then there is some
       ` x e. ( A , B ) ` such that ` F ` ' ` ( x ) / G ` ' ` ( x ) = `
       ` ( F ( A ) - F ( B ) ) / ( G ( A ) - G ( B ) ) ` .  (We express the
       condition without division, so that we need no nonzero constraints.)
       (Contributed by Mario Carneiro, 29-Dec-2016.) $)
    cmvth $p |- ( ph -> E. x e. ( A (,) B )
      ( ( ( F ` B ) - ( F ` A ) ) x. ( ( RR _D G ) ` x ) ) =
      ( ( ( G ` B ) - ( G ` A ) ) x. ( ( RR _D F ) ` x ) ) ) $=
      ( vz cr co cmin cmul wcel cc cicc cfv cmpt cdv cc0 wceq cioo ccnfld ctopn
      cv wrex subcn mulcn wss ccncf wf cncff syl cxr cle wbr rexrd ltled ubicc2
      eqid syl3anc ffvelrnd lbicc2 resubcld iccssre syl2anc syl6ss a1i cncfmptc
      ax-resscn feqmptd eqeltrrd remulcl cncfmpt2ss resubcl cdm wa recnd adantr
      crn ctg ffvelrnda mulcld remulcld subcld tgioo2 cnt dvmptntr cvv cpr reex
      iccntr prid1 ioossicc sseli sylan2 ovex fvex oveq2d feq2d mpbii dvmptcmul
      dvf 3eqtr3rd dvmptsub eqtrd dmeqd dmmpti syl6eq nnncan2d nnncan1d subdird
      eqtr4d mulcomd subdid oveq12d 3eqtr4d fveq2 fvmpt3i rolle fveq1d sylan9eq
      eqeq1d subeq0ad bitrd rexbidva mpbid ) ABUJZONCDUAPZDEUBZCEUBZQPZNUJZFUBZ
      RPZDFUBZCFUBZQPZYREUBZRPZQPZUCZUDPZUBZUEUFZBCDUGPZUKYQYMOFUDPZUBZRPZUUCYM
      OEUDPZUBZRPZUFZBUUKUKABCDUUGGHIANYTUUEOQUHUIUBZYNUUSVEZUUSUUTULANYQYSORUU
      SYNUUTUUSUUTUMZAYQOSYNTUNZOTUNZNYNYQUCYNOUOPZSAYOYPAYNODEAEUVDSYNOEUPJYNO
      EUQURZACUSSZDUSSZCDUTVAZDYNSZACGVBZADHVBZACDGHIVCZCDVDVFZVGZAYNOCEUVEAUVF
      UVGUVHCYNSZUVJUVKUVLCDVHVFZVGZVIZAYNOTACOSZDOSZYNOUNGHCDVJVKZVOVLZUVCAVOV
      MZNYQYNOVNVFAFNYNYSUCZUVDANYNOFAFUVDSYNOFUPKYNOFUQURZVPZKVQVOYQYSVRVSANUU
      CUUDORUUSYNUUTUVAAUUCOSZUVBUVCNYNUUCUCUVDSAUUAUUBAYNODFUWEUVMVGZAYNOCFUWE
      UVPVGZVIZUWBUWCNUUCYNOVNVFAENYNUUDUCZUVDANYNOEUVEVPZJVQVOUUCUUDVRVSVOYTUU
      EVTVSAUUHWANUUKYQYRUULUBZRPZUUCYRUUOUBZRPZQPZUCZWAUUKAUUHUWRAUUHONUUKUUFU
      CUDPUWRANUUFOUGWEWFUBZUUSYNUUKUWCUWAAYRYNSZWBZYTUUEUXAYQYSAYQTSZUWTAYQUVR
      WCZWDUXAYSAYNOYRFUWEWGWCZWHZUXAUUEUXAUUCUUDAUWGUWTUWJWDAYNOYREUVEWGZWIWCZ
      WJUUSUUTWKZUUTAUVSUVTYNUWSWLUBUBUUKUFGHCDWQVKZWMANYTUWNUUEUWPOWNWNUUKOOTW
      OSAOTWPWRVMZYRUUKSZAUWTYTTSUUKYNYRCDWSWTZUXEXAUWNWNSAUXKWBZYQUWMRXBVMANYS
      UWMYQOWNUUKUXJUXKAUWTYSTSUXLUXDXAUWMWNSUXMYRUULXCVMAUULOUWDUDPNUUKUWMUCON
      UUKYSUCUDPAFUWDOUDUWFXDANUUKTUULAUULWAZTUULUPUUKTUULUPFXHAUXNUUKTUULMXEXF
      ZVPANYSOUWSUUSYNUUKUWCUWAUXDUXHUUTUXIWMXIUXCXGUXKAUWTUUETSUXLUXGXAUWPWNSU
      XMUUCUWORXBVMANUUDUWOUUCOWNUUKUXJUXKAUWTUUDTSUXLUXAUUDUXFWCZXAUWOWNSUXMYR
      UUOXCVMAUUOOUWKUDPNUUKUWOUCONUUKUUDUCUDPAEUWKOUDUWLXDANUUKTUUOAUUOWAZTUUO
      UPUUKTUUOUPEXHAUXQUUKTUUOLXEXFZVPANUUDOUWSUUSYNUUKUWCUWAUXPUXHUUTUXIWMXIA
      UUCUWJWCZXGXJXKZXLNUUKUWQUWRUWNUWPQXBZUWRVEZXMXNAYQUUBRPZUUCYPRPZQPZYQUUA
      RPZUUCYORPZQPZCUUGUBZDUUGUBZAYOUUBRPZYPUUBRPZQPZYPUUARPZUYLQPZQPZYOUUARPZ
      UYNQPZUYQUYKQPZQPZUYEUYHAUYPUYKUYNQPUYTAUYKUYNUYLAYOUUBAYOUVNWCZAUUBUWIWC
      ZWHZAYPUUAAYPUVQWCZAUUAUWHWCZWHZAYPUUBVUDVUBWHXOAUYQUYNUYKAYOUUAVUAVUEWHV
      UFVUCXPXRAUYCUYMUYDUYOQAYOYPUUBVUAVUDVUBXQAUYDYPUUCRPUYOAUUCYPUXSVUDXSAYP
      UUAUUBVUDVUEVUBXTXKYAAUYFUYRUYGUYSQAYOYPUUAVUAVUDVUEXQAUYGYOUUCRPUYSAUUCY
      OUXSVUAXSAYOUUAUUBVUAVUEVUBXTXKYAYBAUVOUYIUYEUFUVPNCUUFUYEYNUUGYRCUFZYTUY
      CUUEUYDQVUGYSUUBYQRYRCFYCXDVUGUUDYPUUCRYRCEYCXDYAUUGVEZYTUUEQXBZYDURAUVIU
      YJUYHUFUVMNDUUFUYHYNUUGYRDUFZYTUYFUUEUYGQVUJYSUUAYQRYRDFYCXDVUJUUDYOUUCRY
      RDEYCXDYAVUHVUIYDURYBYEAUUJUURBUUKAYMUUKSZWBZUUJUUNUUQQPZUEUFUURVULUUIVUM
      UEAVUKUUIYMUWRUBVUMAYMUUHUWRUXTYFNYMUWQVUMUUKUWRYRYMUFZUWNUUNUWPUUQQVUNUW
      MUUMYQRYRYMUULYCXDVUNUWOUUPUUCRYRYMUUOYCXDYAUYBUYAYDYGYHVULUUNUUQVULYQUUM
      AUXBVUKUXCWDAUUKTYMUULUXOWGWHVULUUCUUPAUUCTSVUKUXSWDAUUKTYMUUOUXRWGWHYIYJ
      YKYL $.
  $}

  ${
    $d x z A $.  $d x z B $.  $d x z F $.  $d x z ph $.
    mvth.a $e |- ( ph -> A e. RR ) $.
    mvth.b $e |- ( ph -> B e. RR ) $.
    mvth.lt $e |- ( ph -> A < B ) $.
    mvth.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    mvth.d $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    $( The Mean Value Theorem.  If ` F ` is a real continuous function on
       ` [ A , B ] ` which is differentiable on ` ( A , B ) ` , then there is
       some ` x e. ( A , B ) ` such that ` ( RR _D F ) `` x ` is equal to the
       average slope over ` [ A , B ] ` .  (Contributed by Mario Carneiro,
       1-Sep-2014.)  (Proof shortened by Mario Carneiro, 29-Dec-2016.) $)
    mvth $p |- ( ph -> E. x e. ( A (,) B ) ( ( RR _D F ) ` x ) =
      ( ( ( F ` B ) - ( F ` A ) ) / ( B - A ) ) ) $=
      ( vz cfv cmin co cr cmul wceq cc wcel c1 cid cicc cres cdv cioo wrex cdiv
      cmpt ccncf mptresid iccssre syl2anc ax-resscn cncfmptid sylancl syl5eqelr
      cv wss cdm oveq2i crn ctg ccnfld ctopn cpr reex prid1 a1i simpr recnd 1re
      wa dvmptid eqid tgioo2 iccntr dvmptres2 syl5eqr dmeqd dmmpti syl6eq cmvth
      cnt 1ex cxr cle wbr rexrd ubicc2 syl3anc fvresi syl lbicc2 oveq12d adantr
      ltled oveq1d fveq1d eqidd fvmpt3i sylan9eq oveq2d cncff ffvelrnd resubcld
      mulid1d eqtrd eqeq12d dvf feq2d mpbii ffvelrnda cc0 wne clt posdifd mpbid
      wf gt0ne0d divmuld bitr4d eqcom 3bitr4g rexbidva ) ADELZCELZMNZBUQZOUACDU
      BNZUCZUDNZLZPNZDYJLZCYJLZMNZYHOEUDNZLZPNZQZBCDUENZUFYRYGDCMNZUGNZQZBUUAUF
      ABCDEYJFGHIAYJKYIKUQZUHZYIOUINZKYIUJZAYIOURZORURUUFUUGSACOSZDOSZUUIFGCDUK
      ULZUMKYIOUNUOUPJAYKUSKUUATUHZUSUUAAYKUUMAYKOUUFUDNUUMUUFYJOUDUUHUTAKUUETO
      UEVAVBLZVCVDLZOOUUAYIOORVESAORVFVGVHZAUUEOSZVLZUUEAUUQVIVJTOSUURVKVHAKOUU
      PVMUULUUOUUOVNZVOUUSAUUJUUKYIUUNWCLLUUAQFGCDVPULVQVRZVSKUUATUUMWDUUMVNZVT
      WAWBAYTUUDBUUAAYHUUASZVLZYSYMQZUUCYRQZYTUUDUVCUVDUUBYRPNZYGQUVEUVCYSUVFYM
      YGUVCYPUUBYRPAYPUUBQUVBAYNDYOCMADYISZYNDQACWESZDWESZCDWFWGZUVGACFWHZADGWH
      ZACDFGHWPZCDWIWJZYIDWKWLACYISZYOCQAUVHUVIUVJUVOUVKUVLUVMCDWMWJZYICWKWLWNW
      OWQUVCYMYGTPNYGUVCYLTYGPAUVBYLYHUUMLTAYHYKUUMUUTWRKYHTTUUAUUMUUEYHQTWSUVA
      WDWTXAXBUVCYGAYGRSUVBAYGAYEYFAYIODEAEUUGSYIOEXRIYIOEXCWLZUVNXDAYIOCEUVQUV
      PXDXEVJWOZXFXGXHUVCYGUUBYRUVRAUUBRSUVBAUUBADCGFXEVJWOAUUARYHYQAYQUSZRYQXR
      UUARYQXREXIAUVSUUARYQJXJXKXLAUUBXMXNUVBAUUBACDXOWGXMUUBXOWGHACDFGXPXQXSWO
      XTYAYMYSYBYRUUCYBYCYDXQ $.
  $}

  ${
    $d a b x y A $.  $d a b x y B $.  $d a b x y ph $.  $d b X $.  $d a b Y $.
    $d a b x y F $.  $d a b x y M $.
    dvlip.a $e |- ( ph -> A e. RR ) $.
    dvlip.b $e |- ( ph -> B e. RR ) $.
    dvlip.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> CC ) ) $.
    dvlip.d $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    dvlip.m $e |- ( ph -> M e. RR ) $.
    dvlip.l $e |- ( ( ph /\ x e. ( A (,) B ) ) ->
      ( abs ` ( ( RR _D F ) ` x ) ) <_ M ) $.
    $( A function with derivative bounded by ` M ` is Lipschitz continuous with
       Lipchitz constant equal to ` M ` .  (Contributed by Mario Carneiro,
       3-Mar-2015.) $)
    dvlip $p |- ( ( ph /\ ( X e. ( A [,] B ) /\ Y e. ( A [,] B ) ) ) ->
      ( abs ` ( ( F ` X ) - ( F ` Y ) ) ) <_ ( M x. ( abs ` ( X - Y ) ) ) ) $=
      ( co wcel cfv cle cr cc vb va vy cicc wa cmin cabs cmul wbr wi wceq fveq2
      cv oveq2d fveq2d oveq2 imbi2d oveq1d oveq1 weq wb oveqan12d oveq12 ancoms
      breq12d wss iccssre syl2anc wf ccncf cncff ffvelrn anim12dan sylan simprd
      syl simpld abssubd ax-resscn syl6ss sselda adantrl adantrr w3a cc0 adantr
      simpr2 ffvelrnd simpr1 subeq0ad biimpar abs00bd clt cioo c0 wne cxr rexrd
      sseldd ad2antrr elicc2 mpbid cdv 0re a1i cdm ffvelrnda abscld absge0d imp
      letrd adantlr syldan sylbird recnd eqcomd eqbrtrd cdiv cre wrex cmpt cres
      ex c1 ccom divcld feqresmpt fmptco feqmptd cncfco recld cvv sylan2 syl6eq
      eqid eqtrd fvex fvmpt syl3anc eqtr3d resubcld simp2d iooss1 simp3d iooss2
      ioon0 sstrd ssn0 wex n0 feq2d mpbii exlimdv sylan2b simpr3 subge0d mpbird
      dvf mulge0d equcom syl6bb mul01d eqle sylancr breq2d syl5ibrcom wo leloed
      mpjaod subcld ord syl6 necon1ad posdifd gt0ne0d divrec2d iccss2 necon3bid
      wn eqidd ref rescncf divccncf recncf eqeltrrd crn ctg ccnfld ctopn tgioo2
      sylc cnt iccntr dvmptntr ioossicc sseli ovex cpr reex prid1 ioossre dvres
      syl22anc ctop retop iooretop isopn3i mp2an reseq2i syl5ss fssres mpteq2ia
      fvres 3eqtr3d dvmptdivc dvmptre dmmptg mprg fveq1d sylan9eq ubicc2 lbicc2
      dmeqd mvth oveq12d resubd divsubdird dividd re1 eqeq12d rexbidva remulcld
      releabsd lemul1ad absmuld divcan1d breqtrd breq1d syl5ibcom rexlimdva mpd
      ledivmul2 syl112anc pm2.61dane abssubge0d breqtrrd wlogle expcom vtocl2ga
      impcom ) GCDUDOZPZHVUKPZUEAGEQZHEQZUFOZUGQZFGHUFOZUGQZUHOZRUIZVUMVULAVVAU
      JZAUAUMZEQZUBUMZEQZUFOZUGQZFVVCVVEUFOZUGQZUHOZRUIZUJAVVDVUOUFOZUGQZFVVCHU
      FOZUGQZUHOZRUIZUJVVBUBUAHGVUKVUKVVEHUKZVVLVVRAVVSVVHVVNVVKVVQRVVSVVGVVMUG
      VVSVVFVUOVVDUFVVEHEULUNUOVVSVVJVVPFUHVVSVVIVVOUGVVEHVVCUFUPUOUNVEUQVVCGUK
      ZVVRVVAAVVTVVNVUQVVQVUTRVVTVVMVUPUGVVTVVDVUNVUOUFVVCGEULURUOVVTVVPVUSFUHV
      VTVVOVURUGVVCGHUFUSUOUNVEUQAVVEVUKPZVVCVUKPZUEZVVLAUCUMZEQZBUMZEQZUFOZUGQ
      ZFVWDVWFUFOZUGQZUHOZRUIZVVLVVFVVDUFOZUGQZFVVEVVCUFOZUGQZUHOZRUIZUBUABUCVU
      KUCUAUTZBUBUTZVWMVVLVAVWTVXAUEZVWIVVHVWLVVKRVXBVWHVVGUGVWTVXAVWEVVDVWGVVF
      UFVWDVVCEULZVWFVVEEULVBUOVXBVWKVVJFUHVXBVWJVVIUGVWDVVCVWFVVEUFVCUOUNVEVDU
      CUBUTZBUAUTZVWMVWSVAVXDVXEUEZVWIVWOVWLVWRRVXFVWHVWNUGVXDVXEVWEVVFVWGVVDUF
      VWDVVEEULZVWFVVCEULVBUOVXFVWKVWQFUHVXFVWJVWPUGVWDVVEVWFVVCUFVCUOUNVEVDACS
      PZDSPZVUKSVFZIJCDVGVHZAVWCUEZVVHVWOVVKVWRRVXLVVDVVFVXLVVFTPZVVDTPZAVUKTEV
      IZVWCVXMVXNUEAEVUKTVJOPZVXOKVUKTEVKVPZVXOVWAVXMVWBVXNVUKTVVEEVLVUKTVVCEVL
      VMVNZVOVXLVXMVXNVXRVQVRVXLVVJVWQFUHVXLVVCVVEAVWBVVCTPVWAAVUKTVVCAVUKSTVXK
      VSVTZWAWBAVWAVVETPVWBAVUKTVVEVXSWAWCVRUNVEAVWAVWBVVEVVCRUIZWDZUEZVVHFVVIU
      HOZVVKRVYBVVHVYCRUIZVVDVVFVYBVVDVVFUKZUEZVVHWEVYCRVYFVVGVYBVVGWEUKVYEVYBV
      VDVVFVYBVUKTVVCEAVXOVYAVXQWFZAVWAVWBVXTWGZWHZVYBVUKTVVEEVYGAVWAVWBVXTWIZW
      HZWJZWKWLVYBWEVYCRUIZVYEVYBVVEVVCWMUIZVYMUBUAUTZVYBVYNVVEVVCWNOZWOWPZVYMV
      YBVVEWQPZVVCWQPZVYQVYNVAVYBVVEVYBVUKSVVEAVXJVYAVXKWFZVYJWSZWRZVYBVVCVYBVU
      KSVVCVYTVYHWSZWRZVVEVVCUUFVHVYBVYQVYMVYBVYQUEFVVIAFSPZVYAVYQMWTVYBVVISPZV
      YQVYBVVCVVEWUCWUAUUAZWFVYBVYQCDWNOZWOWPZWEFRUIZVYBVYPWUHVFZVYQWUIVYBVYPCV
      VCWNOZWUHVYBCWQPCVVERUIZVYPWULVFVYBCAVXHVYAIWFZWRVYBVVESPZWUMVVEDRUIZVYBV
      WAWUOWUMWUPWDZVYJVYBVXHVXIVWAWUQVAWUNAVXIVYAJWFZCDVVEXAVHXBUUBCVVEVVCUUCV
      HVYBDWQPVVCDRUIZWULWUHVFVYBDWURWRVYBVVCSPZCVVCRUIZWUSVYBVWBWUTWVAWUSWDZVY
      HVYBVXHVXIVWBWVBVAWUNWURCDVVCXAVHXBUUDCVVCDUUEVHUUGZVYPWUHUUHVNAWUIWUJVYA
      WUIAVWFWUHPZBUUIZWUJBWUHUUJAWVEWUJAWVDWUJBAWVDWUJAWVDUEZWEVWFSEXCOZQZUGQZ
      FWESPZWVFXDXEWVFWVHAWUHTVWFWVGAWVGXFZTWVGVIWUHTWVGVIZEUURAWVKWUHTWVGLUUKU
      ULZXGZXHAWUEWVDMWFWVFWVHWVNXINXKYCUUMXJUUNXLXMVYBWEVVIRUIZVYQVYBWVOVXTAVW
      AVWBVXTUUOZVYBVVCVVEWUCWUAUUPUUQWFUUSYCXNVYBVYOVVIWEUKZVYMVYBWVQUAUBUTVYO
      VYBVVCVVEVYBVVCWUCXOVYBVVEWUAXOWJUAUBUUTUVAVYBVYMWVQWEFWEUHOZRUIZVYBWVJWE
      WVRUKWVSXDVYBWVRWEVYBFVYBFAWUEVYAMWFZXOUVBXPWEWVRUVCUVDWVQVYCWVRWERVVIWEF
      UHUPUVEUVFXNVYBVXTVYNVYOUVGWVPVYBVVEVVCWUAWUCUVHXBZUVIWFXQVYBVVDVVFWPZUEZ
      VVHVVIXROZFRUIZVYDWWCWWDYDVVIXROZVVHUHOZFRWWCVVHVVIWWCVVHWWCVVGVYBVVGTPZW
      WBVYBVVDVVFVYIVYKUVJZWFZXHZXOWWCVVIVYBWUFWWBWUGWFZXOWWCVVIWWCVYNWEVVIWMUI
      ZVYBWWBVYNVYBVYNVVDVVFVYBVYNUVSVYOVYEVYBVYNVYOWWAUVKVYOVVFVVDVVEVVCEULXPU
      VLUVMXJZWWCVVEVVCVYBWUOWWBWUAWFZVYBWUTWWBWUCWFZUVNXBZUVOUVPWWCWVHVVGXROZX
      SQZWWFUKZBVYPXTZWWGFRUIZWWCVWFSUCVVEVVCUDOZVWEVVGXROZXSQZYAZXCOZQZVVCWXFQ
      ZVVEWXFQZUFOZVVIXROZUKZBVYPXTWXAWWCBVVEVVCWXFWWOWWPWWNWWCXSBTVWFVVGXROZYA
      ZEWXCYBZYEZYEWXFWXCSVJOWWCUCBWXCTWXDVWFXSQWXEWXQXSWWCVWDWXCPZUEZVWEVVGWWC
      WXRVWDVUKPVWETPZWWCWXCVUKVWDVYBWXCVUKVFZWWBVYBVWAVWBWYAVYJVYHCDVVEVVCUVQV
      HZWFZWAWWCVUKTVWDEAVXOVYAWWBVXQWTZXGXMZVYBWWHWWBWXRWWIWTWWCVVGWEWPZWXRVYB
      WYFWWBVYBVVGWEVVDVVFVYLUVRWKZWFYFZWWCUCBWXCTVWEWXNWXDWXPWXOWYEWWCUCVUKTWX
      CEWYDWYCYGWWCWXOUVTVWFVWEVVGXRUSYHWWCBTSXSTSXSVIWWCUWAXEYIVWFWXDXSULYHWWC
      WXCTSWXQXSWWCWXCTTWXPWXOVYBWXPWXCTVJOPZWWBVYBWYAVXPWYIWYBAVXPVYAKWFVUKTWX
      CEUWBUWKWFWWCWWHWYFWXOTTVJOPWWJWYGBVVGWXOWXOYOUWCVHYJXSTSVJOPWWCUWDXEYJUW
      EWWCWXGXFUCVYPVWDWVGQZVVGXROZXSQZYAZXFZVYPWWCWXGWYMWWCWXGSUCVYPWXEYAXCOWY
      MWWCUCWXESWNUWFUWGQZUWHUWIQZWXCVYPSTVFZWWCVSXEZWWCWUOWUTWXCSVFWWOWWPVVEVV
      CVGVHWXSWXEWXSWXDWYHYKXOWYPWYPYOZUWJZWYSVYBWXCWYOUWLQZQVYPUKZWWBVYBWUOWUT
      XUBWUAWUCVVEVVCUWMVHWFUWNWWCUCWXDWYKYLVYPVWDVYPPZWWCWXRWXDTPVYPWXCVWDVVEV
      VCUWOZUWPZWYHYMWYKYLPWWCXUCUEWYJVVGXRUWQXEWWCUCVWEWYJVVGSTVYPSSTUWRPWWCST
      UWSUWTXEXUCWWCWXRWXTXUEWYEYMWWCXUCVWDWUHPWYJTPWWCVYPWUHVWDVYBWUKWWBWVCWFZ
      WAWWCWUHTVWDWVGAWVLVYAWWBWVMWTZXGXMWWCSEVYPYBZXCOZWVGVYPYBZSUCVYPVWEYAZXC
      OUCVYPWYJYAZWWCXUIWVGVYPXUAQZYBZXUJWWCWYQVXOVXJVYPSVFZXUIXUNUKWYRWYDAVXJV
      YAWWBVXKWTXUOWWCVVEVVCUXAXEVUKVYPSWYOEWYPWYSWYTUXBUXCXUMVYPWVGWYOUXDPVYPW
      YOPXUMVYPUKUXEVVEVVCUXFVYPWYOUXGUXHUXIYNWWCXUHXUKSXCWWCUCVUKTVYPEWYDWWCVY
      PWXCVUKXUDWYCUXJYGUNWWCXUJUCVYPVWDXUJQZYAZXULVYBXUJXUQUKWWBVYBUCVYPTXUJVY
      BWVLWUKVYPTXUJVIAWVLVYAWVMWFWVCWUHTVYPWVGUXKVHYIWFUCVYPXUPWYJVWDVYPWVGUXM
      UXLYNUXNWWJWYGUXOUXPYPZUYCWYLYLPZWYNVYPUKUCVYPUCVYPWYLYLUXQXUSXUCWYKXSYQX
      EUXRYNUYDWWCWXMWWTBVYPWWCVWFVYPPZUEZWXHWWSWXLWWFWWCXUTWXHVWFWYMQWWSWWCVWF
      WXGWYMXURUXSUCVWFWYLWWSVYPWYMUCBUTZWYKWWRXSXVBWYJWVHVVGXRVWDVWFWVGULURUOW
      YMYOWWRXSYQYRUXTXVAWXKYDVVIXRXVAWXKVVDVVGXROZXSQZVVFVVGXROZXSQZUFOZYDXVAW
      XIXVDWXJXVFUFXVAVVCWXCPZWXIXVDUKVYBXVHWWBXUTVYBVYRVYSVXTXVHWUBWUDWVPVVEVV
      CUYAYSWTUCVVCWXEXVDWXCWXFVWTWXDXVCXSVWTVWEVVDVVGXRVXCURUOWXFYOZXVCXSYQYRV
      PXVAVVEWXCPZWXJXVFUKVYBXVJWWBXUTVYBVYRVYSVXTXVJWUBWUDWVPVVEVVCUYBYSWTUCVV
      EWXEXVFWXCWXFVXDWXDXVEXSVXDVWEVVFVVGXRVXGURUOXVIXVEXSYQYRVPUYEWWCXVGYDUKX
      UTWWCXVCXVEUFOZXSQZXVGYDWWCXVCXVEWWCVVDVVGVYBVXNWWBVYIWFZWWJWYGYFWWCVVFVV
      GVYBVXMWWBVYKWFZWWJWYGYFUYFWWCXVLYDXSQYDWWCXVKYDXSWWCVVGVVGXROXVKYDWWCVVD
      VVFVVGXVMXVNWWJWYGUYGWWCVVGWWJWYGUYHYTUOUYIYNYTWFYPURUYJUYKXBWWCWWTWXBBVY
      PXVAWWSVVHUHOZFRUIWWTWXBXVAXVOWVIFXVAWWSVVHXVAWWRXVAWVHVVGWWCXUTWVDWVHTPW
      WCVYPWUHVWFXUFWAZWWCWUHTVWFWVGXUGXGXMZVYBWWHWWBXUTWWIWTZWWCWYFXUTWYGWFZYF
      ZYKZWWCVVHSPZXUTWWKWFZUYLXVAWVHXVQXHVYBWUEWWBXUTWVTWTXVAXVOWWRUGQZVVHUHOZ
      WVIRXVAWWSXWDVVHXWAXVAWWRXVTXHXWCWWCWEVVHRUIXUTWWCVVGWWJXIWFXVAWWRXVTUYMU
      YNXVAWWRVVGUHOZUGQXWEWVIXVAWWRVVGXVTXVRUYOXVAXWFWVHUGXVAWVHVVGXVQXVRXVSUY
      PUOYTUYQWWCXUTWVDWVIFRUIZXVPVYBWVDXWGWWBAWVDXWGVYANXLXLXMXKWWTXVOWWGFRWWS
      WWFVVHUHUSUYRUYSUYTVUAXQWWCXWBWUEWUFWWMWWEVYDVAWWKAWUEVYAWWBMWTWWLWWQVVHF
      VVIVUBVUCXBVUDVYBVVJVVIFUHVYBVVEVVCWUAWUCWVPVUEUNVUFVUGVUHVUIVDVUJ $.
  $}

  ${
    $d t x y z B $.  $d t x y z F $.  $d t x y z M $.  $d t x z ph $.
    $d t y z Y $.  $d t y z Z $.
    dvlipcn.x $e |- ( ph -> X C_ CC ) $.
    dvlipcn.f $e |- ( ph -> F : X --> CC ) $.
    dvlipcn.a $e |- ( ph -> A e. CC ) $.
    dvlipcn.r $e |- ( ph -> R e. RR* ) $.
    dvlipcn.b $e |- B = ( A ( ball ` ( abs o. - ) ) R ) $.
    dvlipcn.d $e |- ( ph -> B C_ dom ( CC _D F ) ) $.
    dvlipcn.m $e |- ( ph -> M e. RR ) $.
    dvlipcn.l $e |- ( ( ph /\ x e. B ) ->
      ( abs ` ( ( CC _D F ) ` x ) ) <_ M ) $.
    $( A complex function with derivative bounded by ` M ` on an open ball is
       Lipschitz continuous with Lipchitz constant equal to ` M ` .
       (Contributed by Mario Carneiro, 18-Mar-2015.) $)
    dvlipcn $p |- ( ( ph /\ ( Y e. B /\ Z e. B ) ) ->
      ( abs ` ( ( F ` Y ) - ( F ` Z ) ) ) <_ ( M x. ( abs ` ( Y - Z ) ) ) ) $=
      ( vt cc vz vy wcel wa c1 cc0 cicc co cv cmul cmin caddc cfv cmpt cabs cle
      wbr 1elunit 0elunit cr 0re a1i 1re cres ccom ccncf wss cdv cdm ssid dvbss
      sstrd adantr simprl sseldd unitssre ax-resscn sstri sseldi mulcomd simprr
      simpr iirev adantl oveq12d cxr ad2antrr blcvx syl23anc eqeltrd wf syl2anc
      wceq feqmptd fvres mpteq2ia syl6eq fveq2 eqid cncfmptc mp3an23 syl ax-1cn
      cncfmpt2f cnt ctop ax-mp syl22anc sylancr reseq2d eqtrd dmeqd syl5eq cioo
      sylib sylancl cvv sylan2 fvex cneg mulcld recnd dvmptres mulid1d mpteq2dv
      dvmptcmul negex oveq2d dvfcn wral abscld fveq2d ralrimiva weq breq1d nfcv
      nffv oveq2 fvmpt mul01d eqidd fssres fmptco fmptd wb ccnfld ctopn ctx ccn
      addcn mulcn cncfmptid mp2an subcn mp3an cncffvrn crest cnfldtop toponunii
      mpbird cnfldtopon restid eqcomi dvres cxmt cnxmet cnfldtopn blopn syl3anc
      cbl syl5eqel isopn3i cin dmres dvcn syl31anc cncfco eqeltrrd crn ffvelrnd
      df-ss ctg tgioo2 iccntr dvmptntr cpr reex prid1 cnex prid2 ioossicc sseli
      subcld sselda ffvelrnda dvmptid ioossre iooretop dvmptsub mpteq2i syl6eqr
      syldan dvmptc df-neg neg1cn mulcom mulm1d negsubd feq2d mpbii feq1d mpbid
      dvmptadd 3eqtr3d dvmptco ovex dmmptg mp1i remulcld fveq1d fvmpt2 sylan9eq
      rgenw mpan2 ffvelrn absmuld absge0d cbvralv rspcv lemul1ad eqbrtrd nfmpt1
      sylc nfv nfov cbvral r19.21bi dvlip mpanr12 1m1e0 addid1d subid1i addid2d
      nfbr fveq2i abs1 eqtri oveq2i 3brtr3d ) AIDUCZJDUCZUDZUDZUESUFUEUGUHZISUI
      ZUJUHZJUEVUOUKUHZUJUHZULUHZFUMZUNZUMZUFVVAUMZUKUHZUOUMZGIJUKUHZUOUMZUJUHZ
      UEUFUKUHZUOUMZUJUHZIFUMZJFUMZUKUHZUOUMVVHUPVUMUEVUNUCZUFVUNUCZVVEVVKUPUQU
      RUSVUMUAUFUEVVAVVHUEUFUFUTUCZVUMVAVBZUEUTUCZVUMVCVBVUMFDVDZSVUNVUSUNZVEVV
      AVUNTVFUHZVUMSUAVUNDVUSUAUIZFUMZVUTVWAVVTVUMVUOVUNUCZUDZVUSVUOIUJUHZVUQJU
      JUHZULUHZDVWFVUPVWGVURVWHULVWFIVUOVUMITUCZVWEVUMDTIADTVGZVULADHTADTFVHUHZ
      VIZHPAHTFTTVGZATVJZVBZLKVKVLZKVLZVMZAVUJVUKVNZVOZVMVWFVUNTVUOVUNUTTVPVQVR
      ZVUMVWEWBZVSZVTVWFJVUQVUMJTUCZVWEVUMDTJVWSAVUJVUKWAZVOZVMVWFVUNTVUQVXBVWE
      VUQVUNUCVUMVUOWCWDVSZVTWEVWFCTUCZEWFUCZVUJVUKVWEVWIDUCAVXIVULVWEMWGAVXJVU
      LVWENWGVUMVUJVWEVWTVMVUMVUKVWEVXFVMVXCIJCEDVUOOWHWIWJZVUMVWAUUAAVVTUADVWD
      UNZWMVULAVVTUADVWCVVTUMZUNVXLAUADTVVTAHTFWKZDHVGZDTVVTWKZLVWQHTDFUUBWLZWN
      UADVXMVWDVWCDFWOWPWQVMZVWCVUSFWRZUUCVUMVUNDTVWAVVTVUMVWAVUNDVFUHUCZVUNDVW
      AWKZVUMSVUNVUSDVWAVXKVWAWSUUDVUMVWKVWAVWBUCVXTVYAUUEVWSVUMSVUPVURULUUFUUG
      UMZVUNVYBWSZULVYBVYBUUHUHVYBUUIUHZUCVUMVYBVYCUUJVBVUMSIVUOUJVYBVUNVYCUJVY
      DUCVUMVYBVYCUUKVBZVUMVWJSVUNIUNVWBUCZVXAVWJVUNTVGZVWNVYFVXBVWOSIVUNTWTXAX
      BSVUNVUOUNVWBUCZVUMVYGVWNVYHVXBVWOSVUNTUULUUMVBZXDVUMSJVUQUJVYBVUNVYCVYEV
      UMVXESVUNJUNVWBUCZVXGVXEVYGVWNVYJVXBVWOSJVUNTWTXAXBVUMSUEVUOUKVYBVUNVYCUK
      VYDUCVUMVYBVYCUUNVBSVUNUEUNVWBUCZVUMUETUCZVYGVWNVYKXCVXBVWOSUEVUNTWTUUOVB
      VYIXDXDXDVUNTDVWAUUPWLUUTVUMVWNVXPVWKTVVTVHUHZVIZDWMZVVTDTVFUHUCVWNVUMVWO
      VBZAVXPVULVXQVMVWSAVYOVULAVYNVWLDVDZVIZDAVYMVYQAVYMVWLDVYBXEUMUMZVDZVYQAV
      WNVXNHTVGZVWKVYMVYTWMZVWPLKVWRHDTVYBFVYBVYCVYBTUUQUHZVYBVYBXFUCZWUCVYBWMV
      YBVYCUURZVYBXFTTVYBVYBVYCUVAUUSUVBXGUVCUVDZXHAVYSDVWLAWUDDVYBUCVYSDWMZWUE
      ADCEUOUKVEZUVJUMUHZVYBOAWUHTUVEUMUCZVXIVXJWUIVYBUCWUJAUVFVBMNWUHCEVYBTVYB
      VYCUVGUVHUVIUVKDVYBUVLXIZXJXKXLAVYRDVWMUVMZDVWLDUVNADVWMVGZWULDWMPDVWMUWA
      XOXMXKVMZDTVVTUVOUVPUVQUVRVUMUTVVAVHUHZVISUFUEXNUHZVUSVWLUMZVVFUJUHZUNZVI
      ZWUPVUMWUOWUSVUMWUOUTSWUPVUTUNVHUHWUSVUMSVUTUTXNUVSUWBUMZVYBVUNWUPUTTVGVU
      MVQVBVUNUTVGVUMVPVBVWFHTVUSFAVXNVULVWELWGVWFDHVUSAVXOVULVWEVWQWGVXKVOUVTV
      YBVYCUWCZVYCVUMVVQVVSVUNWVAXEUMUMWUPWMVVRVCUFUEUWDXPUWEVUMSUAVUSVVFVWDVWC
      VWLUMZUTTVUTWUQTXQWUPDUTUTTUWFZUCVUMUTTUWGUWHVBZTWVDUCVUMUTTUWIUWJVBVUOWU
      PUCZVUMVWEVUSDUCZWUPVUNVUOUFUEUWKUWLZVXKXRZVUMVVFTUCWVFVUMIJVXAVXGUWMZVMZ
      VUMVWCDUCZVWCHUCVWDTUCVUMDHVWCAVXOVULVWQVMUWNVUMHTVWCFAVXNVULLVMZUWOUXBWV
      CXQUCVUMWVLUDVWCVWLXSVBVUMUTSWUPVUSUNVHUHSWUPIJXTZULUHZUNSWUPVVFUNVUMSVUP
      IVURWVNUTTXQWUPWVEVUMWVFUDZIVUOVUMVWJWVFVXAVMZWVFVUMVWEVUOTUCWVHVXDXRZYAW
      VQVUMUTSWUPVUPUNVHUHSWUPIUEUJUHZUNSWUPIUNVUMSVUOUEIUTUTWUPWVEWVRVVSWVPVCV
      BZVUMSVUOUEUTWVAVYBUTUTWUPWVEVUMVUOUTUCZUDZVUOVUMWWAWBYBVVSWWBVCVBVUMSUTW
      VEUWPWUPUTVGVUMUFUEUWQVBZWVBVYCWUPWVAUCVUMUFUEUWRVBZYCZVXAYFVUMSWUPWVSIVU
      MIVXAYDZYEXKWVPJVUQVUMVXEWVFVXGVMWVFVUMVWEVUQTUCWVHVXHXRZYAWVNXQUCWVPJYGV
      BVUMUTSWUPVURUNVHUHSWUPJUEXTZUJUHZUNSWUPWVNUNVUMSVUQWWHJUTXQWUPWVEWWGWWHX
      QUCWVPUEYGVBVUMUTSWUPVUQUNVHUHSWUPUFUEUKUHZUNSWUPWWHUNVUMSUEUFVUOUEUTUTUT
      WUPWVEVYLWVPXCVBVVQWVPVAVBVUMSUEUFUTWVAVYBUTUTWUPWVEVYLWWBXCVBVVQWWBVAVBV
      UMSUEUTWVEVYLVUMXCVBUXCWWCWVBVYCWWDYCWVRWVTWWEUWSSWUPWWHWWJUEUXDUWTUXAVXG
      YFVUMSWUPWWIWVNVUMWWIWWHJUJUHZWVNVUMVXEWWHTUCWWIWWKWMVXGUXEJWWHUXFXPVUMJV
      XGUXGXKYEXKUXMVUMSWUPWVOVVFVUMIJVXAVXGUXHYEXKVUMVYMVYQTVXLVHUHUADWVCUNZVU
      MVYMVYTVYQVUMVWNVXNWUAVWKWUBVYPWVMAWUAVULKVMVWSWUFXHVUMVYSDVWLAWUGVULWUKV
      MXJXKZVUMVVTVXLTVHVXRYHVUMVYQUADVWCVYQUMZUNWWLVUMUADTVYQVUMDTVYMWKZDTVYQW
      KVUMVYNTVYMWKWWOVVTYIVUMVYNDTVYMWUNUXIUXJVUMDTVYMVYQWWMUXKUXLWNUADWWNWVCV
      WCDVWLWOWPWQUXNVXSVWCVUSVWLWRUXOXKZXLWURXQUCZSWUPYJWUTWUPWMVUMWWQSWUPWUQV
      VFUJUXPZUYCSWUPWURXQUXQUXRXKVUMGVVGAGUTUCZVULQVMVUMVVFWVJYKUXSZVUMVWCWUOU
      MZUOUMZVVHUPUQZUAWUPVUMVUOWUOUMZUOUMZVVHUPUQZSWUPYJWXCUAWUPYJVUMWXFSWUPWV
      PWXEWUQUOUMZVVGUJUHZVVHUPWVPWXEWURUOUMWXHWVPWXDWURUOVUMWVFWXDVUOWUSUMZWUR
      VUMVUOWUOWUSWWPUXTWVFWWQWXIWURWMWWRSWUPWURXQWUSWUSWSUYAUYDUYBYLWVPWUQVVFW
      VPVWMTVWLWKVUSVWMUCWUQTUCFYIWVPDVWMVUSAWUMVULWVFPWGWVIVOVWMTVUSVWLUYEXIZW
      VKUYFXKWVPWXGGVVGWVPWUQWXJYKAWWSVULWVFQWGWVPVVFWVKYKWVPVVFWVKUYGWVPWVGUBU
      IZVWLUMZUOUMZGUPUQZUBDYJZWXGGUPUQZWVIAWXOVULWVFABUIZVWLUMZUOUMZGUPUQZBDYJ
      WXOAWXTBDRYMWXTWXNBUBDBUBYNZWXSWXMGUPWYAWXRWXLUOWXQWXKVWLWRYLYOUYHXOWGWXN
      WXPUBVUSDWXKVUSWMZWXMWXGGUPWYBWXLWUQUOWXKVUSVWLWRYLYOUYIUYMUYJUYKYMWXFWXC
      SUAWUPWXFUAUYNSWXBVVHUPSWXAUOSUOYPSVWCWUOSUTVVAVHSUTYPSVHYPSVUNVUTUYLUYOS
      VWCYPYQYQSUPYPSVVHYPVUDSUAYNZWXEWXBVVHUPWYCWXDWXAUOVUOVWCWUOWRYLYOUYPXOUY
      QUYRUYSVUMVVDVVNUOVUMVVBVVLVVCVVMUKVUMVVBWVSJUFUJUHZULUHZFUMZVVLVVOVVBWYF
      WMURSUEVUTWYFVUNVVAVUOUEWMZVUSWYEFWYGVUPWVSVURWYDULVUOUEIUJYRWYGVUQUFJUJW
      YGVUQUEUEUKUHUFVUOUEUEUKYRUYTWQYHWEYLVVAWSZWYEFXSYSXGVUMWYEIFVUMWYEIUFULU
      HIVUMWVSIWYDUFULWWFVUMJVXGYTWEVUMIVXAVUAXKYLXMVUMVVCIUFUJUHZJUEUJUHZULUHZ
      FUMZVVMVVPVVCWYLWMUSSUFVUTWYLVUNVVAVUOUFWMZVUSWYKFWYMVUPWYIVURWYJULVUOUFI
      UJYRWYMVUQUEJUJWYMVUQVVIUEVUOUFUEUKYRUEXCVUBZWQYHWEYLWYHWYKFXSYSXGVUMWYKJ
      FVUMWYKUFJULUHJVUMWYIUFWYJJULVUMIVXAYTVUMJVXGYDWEVUMJVXGVUCXKYLXMWEYLVUMV
      VKVVHUEUJUHVVHVVJUEVVHUJVVJUEUOUMUEVVIUEUOWYNVUEVUFVUGVUHVUMVVHVUMVVHWWTY
      BYDXMVUI $.
  $}

  ${
    $d r x A $.  $d r x B $.  $d r x F $.  $d r x J $.  $d r x ph $.
    $d r x M $.  $d r x R $.  $d r x S $.  $d r x Y $.  $d r x Z $.
    dvlip2.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvlip2.j $e |- J = ( ( abs o. - ) |` ( S X. S ) ) $.
    dvlip2.x $e |- ( ph -> X C_ S ) $.
    dvlip2.f $e |- ( ph -> F : X --> CC ) $.
    dvlip2.a $e |- ( ph -> A e. S ) $.
    dvlip2.r $e |- ( ph -> R e. RR* ) $.
    dvlip2.b $e |- B = ( A ( ball ` J ) R ) $.
    dvlip2.d $e |- ( ph -> B C_ dom ( S _D F ) ) $.
    dvlip2.m $e |- ( ph -> M e. RR ) $.
    dvlip2.l $e |- ( ( ph /\ x e. B ) ->
      ( abs ` ( ( S _D F ) ` x ) ) <_ M ) $.
    $( Combine the results of ~ dvlip and ~ dvlipcn into one.  (Contributed by
       Mario Carneiro, 18-Mar-2015.)  (Revised by Mario Carneiro,
       8-Sep-2015.) $)
    dvlip2 $p |- ( ( ph /\ ( Y e. B /\ Z e. B ) ) ->
      ( abs ` ( ( F ` Y ) - ( F ` Z ) ) ) <_ ( M x. ( abs ` ( Y - Z ) ) ) ) $=
      ( vr wcel wa cr wceq cfv cmin co cabs cmul cle wbr cc cif cv clt wrex cxr
      cxmt ccom cxp cres wss cnxmet cpr recnprss syl xmetres2 syl5eqel ad2antrr
      cq sylancr cbl simplrr syl6eleq wb elbl syl3anc mpbid simpld simplrl ifcl
      xmetcl syl2anc simprd breq1 ifboth qbtwnxr wi qre rexr cioo simpr eleqtrd
      adantr xmetsym xpeq12d reseq2d syl5eq remetdval 3eqtrd eqbrtrrd absdifltd
      oveqd eqid w3a rexrd elioo2 mpbir3and sseldi fvres fveq2d ccncf ad3antrrr
      biimpa eqtrd eqbrtrd syl22anc ex wf cdv cdm ax-resscn a1i ad4antr sseqtrd
      sstrd dvres eqeltrrd dmeqd dmres oveq1d df-ss sylib fveq1d syldan eleq2d
      cin adantl xrmaxlt cicc ioossicc simprll simplr resubcld readdcld simprlr
      caddc oveq12d elicc2 simp1d eleqtrrd simp2d absdifled mpbir2and xrlelttrd
      simp3d elbl3 mpbird ssrdv syl6sseqr resabs1 dvbss fssres syl5eqss crn ctg
      blssm cnt ccnfld ctopn tgioo2 ctop retop cmopn tgioo eqeltrd isopn3i dvcn
      blopn syl31anc rescncf sylc oveq2d iccntr 3eqtr3d syl5ss sseqtr4d reseq1d
      sylan9eq eqtr4d sselda simp-4l sylan dvlip mp2and sylbid sylan2 rexlimdva
      exp32 imp3a mpd wfn absf subf fco ffn fnresdm mp2b syl6eq anbi12d 3sstr3d
      mp2an breq1d 3imtr3d imp dvlipcn an32s wo elpri mpjaodan ) AKDUDZLDUDZUEZ
      UEZFUFUGZKGUHZLGUHZUIUJZUKUHZIKLUIUJUKUHULUJZUMUNZFUOUGZUYGUYHUEZCKHUJZCL
      HUJZUMUNZUYRUYQUPZUCUQZURUNZVUAEURUNZUEZUCVMUSZUYNUYPUYTUTUDZEUTUDZUYTEUR
      UNZVUEUYPUYRUTUDZUYQUTUDZVUFUYPHFVAUHZUDZCFUDZLFUDZVUIAVULUYFUYHAHUKUIVBZ
      FFVCZVDZVUKNAVUOUOVAUHUDFUOVEZVUQVUKUDVFAFUFUOVGUDZVURMFVHVIZVUOFUOVJVNVK
      VLZAVUMUYFUYHQVLZUYPVUNUYREURUNZUYPLCEHVOUHZUJZUDZVUNVVCUEZUYPLDVVEAUYDUY
      EUYHVPSVQUYPVULVUMVUGVVFVVGVRVVAVVBAVUGUYFUYHRVLZLHCEFVSVTWAZWBZCLHFWEVTZ
      UYPVULVUMKFUDZVUJVVAVVBUYPVVLUYQEURUNZUYPKVVEUDZVVLVVMUEZUYPKDVVEAUYDUYEU
      YHWCSVQUYPVULVUMVUGVVNVVOVRVVAVVBVVHKHCEFVSVTWAZWBZCKHFWEVTZUYSUYRUYQUTWD
      WFVVHUYPVVCVVMVUHUYPVUNVVCVVIWGUYPVVLVVMVVPWGUYSVVCVVMVUHUYRUYQUYRUYTEURW
      HUYQUYTEURWHWIWFUCUYTEWJVTUYPVUDUYNUCVMVUAVMUDUYPVUAUFUDZVUDUYNWKVUAWLUYP
      VVSUEZVUBVUCUYNVVTVUBUYQVUAURUNZUYRVUAURUNZUEZVUCUYNWKVVTVUJVUIVUAUTUDZVU
      BVWCVRUYPVUJVVSVVRWQUYPVUIVVSVVKWQVVSVWDUYPVUAWMUUAUYQUYRVUAUUBVTVVTVWCVU
      CUYNVVTVWCVUCUEZUEZKGCVUAUIUJZCVUAUUJUJZUUCUJZVDZUHZLVWJUHZUIUJZUKUHZUYLU
      YMUMVWFVWMUYKUKVWFVWKUYIVWLUYJUIVWFKVWIUDZVWKUYIUGVWFVWGVWHWNUJZVWIKVWGVW
      HUUDZVWFKVWPUDZKUFUDZVWGKURUNZKVWHURUNZUYPVWSVVSVWEUYPKFUFVVQUYGUYHWOZWPZ
      VLZVWFVWTVXAVWFKCUIUJUKUHZVUAURUNVWTVXAUEVWFUYQVXEVUAURUYPUYQVXEUGVVSVWEU
      YPUYQKCHUJZKCVUOUFUFVCZVDZUJZVXEUYPVULVUMVVLUYQVXFUGVVAVVBVVQCKHFWRVTUYPH
      VXHKCUYPHVUQVXHNUYPVUPVXGVUOUYPFUFFUFVXBVXBWSWTXAZXFUYPVWSCUFUDZVXIVXEUGV
      XCUYPCFUFVVBVXBWPZKCVXHVXHXGZXBWFXCVLVVTVWAVWBVUCUUEXDVWFKCVUAVXDUYPVXKVV
      SVWEVXLVLZUYPVVSVWEUUFZXEWAZWBVWFVWTVXAVXPWGVWFVWGUTUDZVWHUTUDZVWRVWSVWTV
      XAXHVRVWFVWGVWFCVUAVXNVXOUUGZXIZVWFVWHVWFCVUAVXNVXOUUHZXIZVWGVWHKXJWFXKXL
      ZKVWIGXMVIVWFLVWIUDZVWLUYJUGVWFVWPVWILVWQVWFLVWPUDZLUFUDZVWGLURUNZLVWHURU
      NZUYPVYFVVSVWEUYPLFUFVVJVXBWPZVLZVWFVYGVYHVWFLCUIUJUKUHZVUAURUNVYGVYHUEVW
      FUYRVYKVUAURUYPUYRVYKUGVVSVWEUYPUYRLCHUJZLCVXHUJZVYKUYPVULVUMVUNUYRVYLUGV
      VAVVBVVJCLHFWRVTUYPHVXHLCVXJXFUYPVYFVXKVYMVYKUGVYIVXLLCVXHVXMXBWFXCVLVVTV
      WAVWBVUCUUIXDVWFLCVUAVYJVXNVXOXEWAZWBVWFVYGVYHVYNWGVWFVXQVXRVYEVYFVYGVYHX
      HVRVXTVYBVWGVWHLXJWFXKXLZLVWIGXMVIUUKXNVWFVWOVYDVWNUYMUMUNZVYCVYOVWFVWOVY
      DUEVYPVWFBVWGVWHVWJIKLVXSVYAVWFGDVDZVWIVDZVWJVWIUOXOUJZVWFVWIDVEZVYRVWJUG
      VWFVWIVVEDVWFBVWIVVEVWFBUQZVWIUDZWUAVVEUDZVWFWUBUEZWUCWUACHUJZEURUNZWUDWU
      EVUAEWUDVULWUAFUDZVUMWUEUTUDUYPVULVVSVWEWUBVVAXPZWUDWUAUFFWUDWUAUFUDZVWGW
      UAUMUNZWUAVWHUMUNZVWFWUBWUIWUJWUKXHZVWFVWGUFUDZVWHUFUDZWUBWULVRVXSVYAVWGV
      WHWUAUULWFXQZUUMZUYPUYHVVSVWEWUBVXBXPUUNZUYPVUMVVSVWEWUBVVBXPZWUACHFWEVTW
      UDVUAVWFVVSWUBVXOWQZXIUYPVUGVVSVWEWUBVVHXPZWUDWUEWUACUIUJUKUHZVUAUMWUDWUE
      WUACVXHUJZWVAWUDHVXHWUACUYPHVXHUGVVSVWEWUBVXJXPXFWUDWUIVXKWVBWVAUGWUPVWFV
      XKWUBVXNWQZWUACVXHVXMXBWFXRWUDWVAVUAUMUNWUJWUKWUDWUIWUJWUKWUOUUOWUDWUIWUJ
      WUKWUOUUSWUDWUACVUAWUPWVCWUSUUPUUQXSVVTVWCVUCWUBVPUURWUDVULVUGVUMWUGWUCWU
      FVRWUHWUTWURWUQWUAHCEFUUTXTUVAYAUVBSUVCZGVWIDUVDVIZVWFVYTVYQDUOXOUJUDZVYR
      VYSUDWVDVWFUFUOVEZDUOVYQYBZDUFVEZUFVYQYCUJZYDZDUGZWVFWVGVWFYEYFZVWFJUOGYB
      ZDJVEZWVHAWVNUYFUYHVVSVWEPYGAWVOUYFUYHVVSVWEADFGYCUJZYDZJTAJFGVUTPOUVEYIY
      GJUODGUVFWFZUYPWVIVVSVWEUYPDFUFUYPDVVEFSUYPVULVUMVUGVVEFVEVVAVVBVVHHCEFUV
      JVTUVGVXBYHZVLZUYPWVLVVSVWEUYPWVKUFGYCUJZDVDZYDZDUYPWVJWWBUYPWVJWWADWNUVH
      UVIUHZUVKUHZUHZVDZWWBUYPWVGWVNJUFVEWVIWVJWWGUGWVGUYPYEYFAWVNUYFUYHPVLUYPJ
      FUFAJFVEZUYFUYHOVLVXBYHWVSJDUFWWDGUVLUVMUHZWWIXGZWWIWWJUVNZYJXTUYPWWFDWWA
      UYPWWDUVOUDDWWDUDWWFDUGUVPUYPDCEVXHVOUHZUJZWWDUYPDVVEWWMSUYPVVDWWLCEUYPHV
      XHVOVXJXNXFXAUYPVXHVUKUDVUMVUGWWMWWDUDUYPHVXHVUKVXJVVAYKVVBVVHVXHCEWWDFVX
      HVXHUVQUHZVXMWWNXGUVRUWBVTUVSDWWDUVTVNWTXRZYLUYPWWCDWWAYDZYTZDWWADYMUYPDW
      WPVEWWQDUGUYPDWVQWWPADWVQVEZUYFUYHTVLUYPWVPWWAUYPFUFGYCVXBYNZYLYHDWWPYOYP
      XAXRVLZDUFVYQUWAUWCDUOVWIVYQUWDUWEYKVWFUFVWJYCUJZYDWVJVWPVDZYDZVWPVWFWXAW
      XBVWFUFVYRYCUJZWVJVWIWWEUHZVDZWXAWXBVWFWVGWVHWVIVWIUFVEWXDWXFUGWVMWVRWVTV
      WFVWIDUFWVDWVTYIDVWIUFWWDVYQWWIWWJWWKYJXTVWFVYRVWJUFYCWVEUWFVWFWXEVWPWVJV
      WFWUMWUNWXEVWPUGVXSVYAVWGVWHUWGWFWTUWHZYLVWFWXCVWPWVKYTZVWPWVJVWPYMVWFVWP
      WVKVEWXHVWPUGVWFVWPDWVKVWFVWPVWIDVWQWVDUWIZWWTUWJVWPWVKYOYPXAXRAIUFUDZUYF
      UYHVVSVWEUAYGVWFWUAVWPUDZUEZWUAWXAUHZUKUHWUAWVPUHZUKUHZIUMWXLWXMWXNUKWXLW
      XMWUAWVJUHZWUAWVPDVDZUHZWXNVWFWXKWXMWUAWXBUHWXPVWFWUAWXAWXBWXGYQWUAVWPWVJ
      XMUWLUYPWXPWXRUGVVSVWEWXKUYPWUAWVJWXQUYPWVJWWBWXQWWOUYPWVPWWADWWSUWKUWMYQ
      XPWXLWUADUDZWXRWXNUGVWFVWPDWUAWXIUWNZWUADWVPXMVIXCXNVWFWXKWXSWXOIUMUNZWXT
      VWFAWXSWYAAUYFUYHVVSVWEUWOUBUWPYRXSUWQYAUWRXDUXBUWSUXCUWTUXAUXDAUYOUYFUYN
      AUYOUEZUYFKCEVUOVOUHZUJZUDZLWYDUDZUEZUYNWYBUYFWYGWYBUYDWYEUYEWYFWYBDWYDKW
      YBDVVEWYDSWYBVVDWYCCEWYBHVUOVOWYBHVUQVUONWYBVUQVUOUOUOVCZVDZVUOWYBVUPWYHV
      UOWYBFUOFUOAUYOWOZWYJWSWTWYHUFVUOYBZVUOWYHUXEWYIVUOUGUOUFUKYBWYHUOUIYBWYK
      UXFUXGWYHUOUFUKUIUXHUXOWYHUFVUOUXIWYHVUOUXJUXKUXLXAXNXFXAZYSWYBDWYDLWYLYS
      UXMXQWYBBCWYDEGIJKLWYBJFUOAWWHUYOOWQWYJYHAWVNUYOPWQWYBCFUOAVUMUYOQWQWYJWP
      AVUGUYORWQWYDXGWYBDWVQWYDUOGYCUJZYDAWWRUYOTWQWYLWYBWVPWYMWYBFUOGYCWYJYNZY
      LUXNAWXJUYOUAWQWYBWUAWYDUDZWUAWYMUHZUKUHZIUMUNZWYBWXSWYAWYOWYRAWXSWYAWKUY
      OAWXSWYAUBYAWQWYBDWYDWUAWYLYSWYBWXOWYQIUMWYBWXNWYPUKWYBWUAWVPWYMWYNYQXNUX
      PUXQUXRUXSYRUXTAUYHUYOUYAZUYFAVUSWYSMFUFUOUYBVIWQUYC $.
  $}

  ${
    $d ph x y a b $.  $d A x y a b $.  $d B x y a b $.  $d F x y a b $.
    c1liplem1.a $e |- ( ph -> A e. RR ) $.
    c1liplem1.b $e |- ( ph -> B e. RR ) $.
    c1liplem1.le $e |- ( ph -> A <_ B ) $.
    c1liplem1.f $e |- ( ph -> F e. ( CC ^pm RR ) ) $.
    c1liplem1.dv $e |- ( ph -> ( ( RR _D F ) |` ( A [,] B ) ) e.
        ( ( A [,] B ) -cn-> RR ) ) $.
    c1liplem1.cn $e |- ( ph -> ( F |` ( A [,] B ) ) e.
        ( ( A [,] B ) -cn-> RR ) ) $.
    c1liplem1.k $e |- K = sup ( ( abs " ( ( RR _D F ) " ( A [,] B ) ) ) ,
        RR , < ) $.
    $( Lemma for ~ c1lip1 .  (Contributed by Stefan O'Rear, 15-Nov-2014.) $)
    c1liplem1 $p |- ( ph -> ( K e. RR /\ A. x e. ( A [,] B )
        A. y e. ( A [,] B ) ( x < y -> ( abs ` ( ( F ` y ) - ( F ` x ) ) ) <_
          ( K x. ( abs ` ( y - x ) ) ) ) ) ) $=
      ( cr wcel cfv cabs cle cc vb va cv clt wbr cmin co cmul wi cicc wral cima
      cdv csup wss c0 wne wrex crn imassrn wf absf frn ax-mp sstri a1i wfun cdm
      dvf ffun cres wceq ccncf cncff fdm 3syl ssdmres sylibr cxr lbicc2 syl3anc
      rexrd wa funfvima2 imp syl21anc fdmi sseqtr4i mp2an ne0i ax-resscn cncfss
      sseldi cniccbdd fvelima fvres adantl fveq2d fveq2 breq1d rspccva eqbrtrrd
      ssid mpan adantll syl5ibcom rexlimdva syl5 breq1 ralrimiv ex reximdva mpd
      suprcl syl5eqel cdiv simplrr syl ad2antrr ffvelrnd recnd eqeltrrd simplrl
      subcld iccssre syl2anc sseldd resubcld simpr wb difrp mpbid rpne0d divcld
      crp absdivd syl6eleqr ltled cioo eqtrd ubicc2 oveq1d iccss2 ad2antlr sylc
      oveq12d resabs1 rescncf ctg cnt cpm cnex reex elpm2 simplbi simprbi ctopn
      ccnfld eqid tgioo2 dvres syl22anc iccntr reseq2d dmeqd syl5ss sstrd sylib
      ioossicc mvth adantrr ad2antll sseld impr eqeltrd eleq1 rexlimdv funfvima
      fveq1d suprub syl31anc syl6breqr absrpcld ledivmuld rpcnd mulcomd breqtrd
      expr abscld ralrimivva jca ) AGOPZBUCZCUCZUDUEZUWNFQZUWMFQZUFUGZRQZGUWNUW
      MUFUGZRQZUHUGZSUEZUIZCDEUJUGZUKBUXEUKAGROFUMUGZUXEULZULZOUDUNZONAUXHOUOZU
      XHUPUQZUAUCZUBUCZSUEZUAUXHUKZUBOURZUXIOPUXJAUXHRUSZORUXGUTTORVAZUXQOUOVBT
      ORVCVDVEZVFADUXFQZUXGPZUXTRQZUXHPZUXKAUXFVGZUXEUXFVHZUOZDUXEPZUYAUYDAUYET
      UXFVAZUYDFVIZUYETUXFVJVDZVFAUXFUXEVKZVHUXEVLZUYFAUYKUXEOVMUGZPUXEOUYKVAUY
      LLUXEOUYKVNUXEOUYKVOVPUXEUXFVQVRZADVSPEVSPDESUEUYGADHWBAEIWBJDEVTWAUYDUYF
      WCZUYGUYAUXEDUXFWDWEWFRVGZUXGRVHZUOUYAUYCUIUXRUYPVBTORVJVDZUXGTUYQUXGUXFU
      SZTUXFUXEUTUYHUYSTUOUYIUYETUXFVCVDVETORVBWGZWHUXGUXTRWDWIUXHUYBWJVPZAUWMU
      YKQZRQZUXMSUEZBUXEUKZUBOURZUXPADOPZEOPZUYKUXETVMUGZPVUFHIAUYMVUIUYKOTUOZT
      TUOUYMVUIUOWKTXCUXEOTWLWILWMUBBDEUYKWNWAAVUEUXOUBOAUXMOPWCZVUEUXOVUKVUEWC
      ZUXNUAUXHUXLUXHPZUWNRQZUXLVLZCUXGURZVULUXNUYPVUMVUPUYRCUXLUXGRWOXDVULVUOU
      XNCUXGVULUWNUXGPZWCVUNUXMSUEZVUOUXNVULVUQVURVUQUXLUXFQZUWNVLZUAUXEURZVULV
      URUYDVUQVVAUYJUAUWNUXEUXFWOXDVULVUTVURUAUXEVULUXLUXEPZWCVUSRQZUXMSUEZVUTV
      URVUEVVBVVDVUKVUEVVBWCZUXLUYKQZRQZVVCUXMSVVEVVFVUSRVVBVVFVUSVLVUEUXLUXEUX
      FWPWQWRVUDVVGUXMSUEBUXLUXEUWMUXLVLZVUCVVGUXMSVVHVUBVVFRUWMUXLUYKWSWRWTXAX
      BXEVUTVVCVUNUXMSVUSUWNRWSWTXFXGXHWEVUNUXLUXMSXIXFXGXHXJXKXLXMZUBUAUXHXNWA
      XOZAUXDBCUXEUXEAUWMUXEPZUWNUXEPZWCZWCZUWOUXCVVNUWOWCZUWSUXAGUHUGZUXBSVVOU
      WSUXAXPUGZGSUEUWSVVPSUEVVOUWRUWTXPUGZRQZVVQGSVVOUWRUWTVVOUWPUWQVVOUWNFUXE
      VKZQZUWPTVVOVVLVWAUWPVLAVVKVVLUWOXQZUWNUXEFWPXRVVOVWAVVOUXEOUWNVVTAUXEOVV
      TVAZVVMUWOAVVTUYMPZVWCMUXEOVVTVNXRXSZVWBXTYAYBVVOUWMVVTQZUWQTVVOVVKVWFUWQ
      VLAVVKVVLUWOYCZUWMUXEFWPXRVVOVWFVVOUXEOUWMVVTVWEVWGXTYAYBYDZVVOUWTVVOUWNU
      WMVVOUXEOUWNAUXEOUOZVVMUWOAVUGVUHVWIHIDEYEYFXSZVWBYGZVVOUXEOUWMVWJVWGYGZY
      HYAZVVOUWTVVOUWOUWTYOPZVVNUWOYIZVVOUWMOPZUWNOPZUWOVWNYJVWLVWKUWMUWNYKYFYL
      YMZYPVVOVVSUXIGSVVOUXJUXKUXPVVSUXHPZVVSUXISUEUXJVVOUXSVFAUXKVVMUWOVUAXSAU
      XPVVMUWOVVIXSVVOUYPVVRUYQPZVVRUXGPZVWSUYPVVOUYRVFVVOVVRTUYQVVOUWRUWTVWHVW
      MVWRYNUYTYQVVOUWNFUWMUWNUJUGZVKZQZUWMVXCQZUFUGZUWTXPUGZVVRUXGVVOVXFUWRUWT
      XPVVOVXDUWPVXEUWQUFVVOUWNVXBPZVXDUWPVLVVOUWMVSPZUWNVSPZUWMUWNSUEZVXHVVOUW
      MVWLWBZVVOUWNVWKWBZVVOUWMUWNVWLVWKVWOYRZUWMUWNUUAWAUWNVXBFWPXRVVOUWMVXBPZ
      VXEUWQVLVVOVXIVXJVXKVXOVXLVXMVXNUWMUWNVTWAUWMVXBFWPXRUUFUUBVVOUXMOVXCUMUG
      ZQZVXGVLZUBUWMUWNYSUGZURVXGUXGPZVVOUBUWMUWNVXCVWLVWKVWOVVOVVTVXBVKZVXCVXB
      OVMUGZVVOVXBUXEUOZVYAVXCVLVVMVYCAUWODEUWMUWNUUCUUDZFVXBUXEUUGXRVVOVYCVWDV
      YAVYBPVYDAVWDVVMUWOMXSUXEOVXBVVTUUHUUEYBVVOVXPVHUXFVXSVKZVHZVXSVVOVXPVYEV
      VOVXPUXFVXBYSUSUUIQZUUJQQZVKZVYEVVOVUJFVHZTFVAZVYJOUOZVXBOUOZVXPVYIVLVUJV
      VOWKVFVVOFTOUUKUGPZVYKAVYNVVMUWOKXSZVYNVYKVYLTOFUULUUMUUNZUUOXRVVOVYNVYLV
      YOVYNVYKVYLVYPUUPXRVVOVWPVWQVYMVWLVWKUWMUWNYEYFVYJVXBOVYGFUURUUQQZVYQUUSZ
      VYQVYRUUTUVAUVBVVOVYHVXSUXFVVOVWPVWQVYHVXSVLVWLVWKUWMUWNUVCYFUVDYTZUVEVVO
      VXSUYEUOVYFVXSVLVVOVXSUXEUYEVVOVXSVXBUXEUWMUWNUVIVYDUVFZAUYFVVMUWOUYNXSUV
      GVXSUXFVQUVHYTUVJVVOVXRVXTUBVXSVVNUWOUXMVXSPZVXRVXTUIVVNUWOWUAWCZWCZVXQUX
      GPVXRVXTWUCVXQUXMUXFQZUXGWUCVXQUXMVYEQZWUDVVNUWOVXQWUEVLWUAVVOUXMVXPVYEVY
      SUVSUVKWUAWUEWUDVLVVNUWOUXMVXSUXFWPUVLYTWUCUYDUYFUXMUXEPZWUDUXGPZUYDWUCUY
      JVFAUYFVVMWUBUYNXSVVNUWOWUAWUFVVOVXSUXEUXMVYTUVMUVNUYOWUFWUGUXEUXMUXFWDWE
      WFUVOVXQVXGUXGUVPXFUWHUVQXMYBUYPVWTWCVXAVWSUXGVVRRUVRWEWFUBUAUXHVVSUVTUWA
      NUWBXBVVOUWSGUXAVVOUWRVWHUWIAUWLVVMUWOVVJXSZVVOUWTVWMVWRUWCZUWDYLVVOUXAGV
      VOUXAWUIUWEVVOGWUHYAUWFUWGXKUWJUWK $.
  $}

  ${
    $d ph x y k a b $.  $d A x y k a b $.  $d B x y k a b $.  $d F x y k a b $.
    c1lip1.a $e |- ( ph -> A e. RR ) $.
    c1lip1.b $e |- ( ph -> B e. RR ) $.
    c1lip1.f $e |- ( ph -> F e. ( CC ^pm RR ) ) $.
    c1lip1.dv $e |- ( ph -> ( ( RR _D F ) |` ( A [,] B ) ) e.
        ( ( A [,] B ) -cn-> RR ) ) $.
    c1lip1.cn $e |- ( ph -> ( F |` ( A [,] B ) ) e.
        ( ( A [,] B ) -cn-> RR ) ) $.
    $( C1 functions are Lipschitz continuous on closed intervals.  (Contributed
       by Stefan O'Rear, 16-Nov-2014.) $)
    c1lip1 $p |- ( ph -> E. k e. RR A. x e. ( A [,] B ) A. y e. ( A [,] B )
        ( abs ` ( ( F ` y ) - ( F ` x ) ) ) <_
          ( k x. ( abs ` ( y - x ) ) ) ) $=
      ( cfv cmin co cabs cmul cle cr wcel va vb cv wbr cicc wral wrex clt wa c0
      wne cc0 0re ne0i ax-mp ral0 wceq cxr wb rexrd icc0 syl2anc biimpar mpbiri
      raleqdv ralrimivw r19.2z sylancr wi cdv cima csup adantr simpr cres ccncf
      cc cpm eqid c1liplem1 oveq1 breq2d imbi2d 2ralbidv rspcev syl weq w3o wss
      iccssre ad2antrr sseld anim12d imp lttri4 breq1 fveq2 oveq2d fveq2d oveq2
      breq12d imbi12d breq2 oveq1d rspc2v ad2antlr pm2.27 adantl fvres ad2antrl
      syld 0le0 wf cncff simpl ffvelrn syl2an eqeltrrd subidd abs00bd ad3antrrr
      recnd simprl sseldd simplr mul01d eqtrd syl5ibcom ancoms ad2antll abssubd
      a1d recn abssub biimpd embantd 3jaodan mpdan ralrimdvva reximdva mpd
      ltlecasei ) ACUCZGMZBUCZGMZNOZPMZFUCZUUCUUENOZPMZQOZRUDZCDEUEOZUFZBUUNUFZ
      FSUGZEDAEDUHUDZUIZSUJUKZUUPFSUFUUQULSTUUTUMSULUNUOUUSUUPFSUUSUUPUUOBUJUFU
      UOBUPUUSUUOBUUNUJAUUNUJUQZUURADURTEURTUVAUURUSADHUTAEIUTDEVAVBVCVEVDVFUUP
      FSVGVHADERUDZUIZUAUCZUBUCZUHUDZUVEGMZUVDGMZNOZPMZUUIUVEUVDNOZPMZQOZRUDZVI
      ZUBUUNUFUAUUNUFZFSUGZUUQUVCPSGVJOZUUNVKVKSUHVLZSTUVFUVJUVSUVLQOZRUDZVIZUB
      UUNUFUAUUNUFZUIUVQUVCUAUBDEGUVSADSTZUVBHVMAESTZUVBIVMAUVBVNAGVQSVROTUVBJV
      MAUVRUUNVOUUNSVPOZTUVBKVMAGUUNVOZUWFTZUVBLVMUVSVSVTUVPUWCFUVSSUUIUVSUQZUV
      OUWBUAUBUUNUUNUWIUVNUWAUVFUWIUVMUVTUVJRUUIUVSUVLQWAWBWCWDWEWFUVCUVPUUPFSU
      VCUUISTZUIZUVPUUMBCUUNUUNUWKUUEUUNTZUUCUUNTZUIZUIZUUEUUCUHUDZBCWGZUUCUUEU
      HUDZWHZUVPUUMVIZUWOUUESTZUUCSTZUIZUWSUWKUWNUXCUWKUWLUXAUWMUXBUWKUUNSUUEAU
      UNSWIZUVBUWJAUWDUWEUXDHIDEWJVBZWKZWLUWKUUNSUUCUXFWLWMWNZUUEUUCWOWFUWOUWPU
      WTUWQUWRUWOUWPUIUVPUWPUUMVIZUUMUWNUVPUXHVIUWKUWPUVOUXHUUEUVEUHUDZUVGUUFNO
      ZPMZUUIUVEUUENOZPMZQOZRUDZVIUAUBUUEUUCUUNUUNUABWGZUVFUXIUVNUXOUVDUUEUVEUH
      WPUXPUVJUXKUVMUXNRUXPUVIUXJPUXPUVHUUFUVGNUVDUUEGWQWRWSUXPUVLUXMUUIQUXPUVK
      UXLPUVDUUEUVENWTWSWRXAXBUBCWGZUXIUWPUXOUUMUVEUUCUUEUHXCUXQUXKUUHUXNUULRUX
      QUXJUUGPUXQUVGUUDUUFNUVEUUCGWQXDWSUXQUXMUUKUUIQUXQUXLUUJPUVEUUCUUENWAWSWR
      XAXBXEXFUWPUXHUUMVIUWOUWPUUMXGXHXKUWOUWQUIUUMUVPUWOUWQUUMUWOUUFUUFNOZPMZU
      UIUUEUUENOZPMZQOZRUDZUWQUUMUWOUYCULULRUDXLUWOUXSULUYBULRUWOUXRUWOUUFUWOUU
      FUWOUUEUWGMZUUFSUWLUYDUUFUQUWKUWMUUEUUNGXIXJUWKUUNSUWGXMZUWLUYDSTUWNAUYEU
      VBUWJAUWHUYELUUNSUWGXNWFWKZUWLUWMXOUUNSUUEUWGXPXQXRYBZXSXTUWOUYBUUIULQOUL
      UWOUYAULUUIQUWOUXTUWOUUEUWOUUEUWOUUNSUUEAUXDUVBUWJUWNUXEYAUWKUWLUWMYCYDYB
      XSXTWRUWOUUIUWOUUIUVCUWJUWNYEYBYFYGXAVDUWQUXSUUHUYBUULRUWQUXRUUGPUWQUUFUU
      DUUFNUUEUUCGWQXDWSUWQUYAUUKUUIQUWQUXTUUJPUUEUUCUUENWAWSWRXAYHWNYLUWOUWRUI
      ZUVPUWRUUFUUDNOZPMZUUIUUEUUCNOZPMZQOZRUDZVIZUUMUWNUVPUYOVIZUWKUWRUWMUWLUY
      PUVOUYOUUCUVEUHUDZUVGUUDNOZPMZUUIUVEUUCNOZPMZQOZRUDZVIUAUBUUCUUEUUNUUNUAC
      WGZUVFUYQUVNVUCUVDUUCUVEUHWPVUDUVJUYSUVMVUBRVUDUVIUYRPVUDUVHUUDUVGNUVDUUC
      GWQWRWSVUDUVLVUAUUIQVUDUVKUYTPUVDUUCUVENWTWSWRXAXBUBBWGZUYQUWRVUCUYNUVEUU
      EUUCUHXCVUEUYSUYJVUBUYMRVUEUYRUYIPVUEUVGUUFUUDNUVEUUEGWQXDWSVUEVUAUYLUUIQ
      VUEUYTUYKPUVEUUEUUCNWAWSWRXAXBXEYIXFUYHUWRUYNUUMUWOUWRVNUYHUYNUUMUYHUYJUU
      HUYMUULRUWOUYJUUHUQUWRUWOUUFUUDUYGUWOUUDUWOUUCUWGMZUUDSUWMVUFUUDUQUWKUWLU
      UCUUNGXIYJUWKUYEUWMVUFSTUWNUYFUWLUWMVNUUNSUUCUWGXPXQXRYBYKVMUYHUYLUUKUUIQ
      UWOUYLUUKUQZUWRUWOUXCVUGUXGUXAUUEVQTUUCVQTVUGUXBUUEYMUUCYMUUEUUCYNXQWFVMW
      RXAYOYPXKYQYRYSYTUUAIHUUB $.
  $}

  ${
    $d ph x y k a b $.  $d A x y k a b $.  $d B x y k a b $.  $d F x y k a b $.
    c1lip2.a $e |- ( ph -> A e. RR ) $.
    c1lip2.b $e |- ( ph -> B e. RR ) $.
    c1lip2.f $e |- ( ph -> F e. ( ( C^n ` RR ) ` 1 ) ) $.
    c1lip2.rn $e |- ( ph -> ran F C_ RR ) $.
    c1lip2.dm $e |- ( ph -> ( A [,] B ) C_ dom F ) $.
    $( C1 functions are Lipschitz continuous on closed intervals.  (Contributed
       by Stefan O'Rear, 16-Nov-2014.)  (Revised by Stefan O'Rear,
       6-May-2015.) $)
    c1lip2 $p |- ( ph -> E. k e. RR A. x e. ( A [,] B ) A. y e. ( A [,] B )
        ( abs ` ( ( F ` y ) - ( F ` x ) ) ) <_
          ( k x. ( abs ` ( y - x ) ) ) ) $=
      ( c1 cr cfv wcel cc co ax-resscn cc0 ccpn cpm cdvn cdm ccncf wss cn0 1nn0
      wa wb elcpn mp2an simplbi syl cicc cdv cres wf wfn wfun pmfun funfn sylib
      crn df-f sylanbrc cnex reex elpm2 simprbi dvfre syl2anc wceq caddc fveq2i
      0p1e1 0nn0 dvnp1 mp3an13 syl5eqr dvn0 sylancr oveq2d eqtrd eqeltrrd cncff
      fdm 3syl feq2d mpbid cncffvrn mpbird rescncf sylc cpr prid1 nn0uz eleqtri
      cuz cpnord mp3an sseldi c1lip1 ) ABCDEFGHIAGMNUAOZOZPZGQNUBRPZJXFXGMNGUCR
      ZOZGUDZQUERZPZNQUFZMUGPXFXGXLUIUJSUHNGMUKULZUMUNZADEUORZXJUFZNGUPRZXJNUER
      ZPZXRXPUQXPNUERZPLAXTXJNXRURZAXRUDZNXRURZYBAXJNGURZXJNUFZYDAGXJUSZGVDNUFY
      EAGUTZYGAXGYHXOQNGVAUNGVBVCKXJNGVEVFZAXGYFXOXGXJQGURYFQNGVGVHVIVJUNXJGVKV
      LAYCXJNXRAXRXKPZXJQXRURYCXJVMAXIXRXKAXINTXHOZUPRZXRAXITMVNRZXHOZYLYMMXHVP
      VOAXGYNYLVMZXOXMXGTUGPZYOSVQNGTVRVSUNVTAYKGNUPAXMXGYKGVMSXONGWAWBZWCWDAXF
      XLJXFXGXLXNVJUNWEZXJQXRWFXJQXRWGWHWIWJAXMYJXTYBUJSYRXJQNXRWKWBWLXJNXPXRWM
      WNAXQGXSPZGXPUQYAPLAYSYEYIAXMGXKPYSYEUJSAYKGXKYQAGTXDOZPZYKXKPZAXEYTGNNQW
      OPYPMTWSOZPXEYTUFNQVHWPVQMUGUUCUHWQWRNTMWTXAJXBUUAXGUUBXMYPUUAXGUUBUIUJSV
      QNGTUKULVJUNWEXJQNGWKWBWLXJNXPGWMWNXC $.
  $}

  ${
    $d ph x y k a b $.  $d A x y k a b $.  $d B x y k a b $.  $d F x y k a b $.
    c1lip3.a $e |- ( ph -> A e. RR ) $.
    c1lip3.b $e |- ( ph -> B e. RR ) $.
    c1lip3.f $e |- ( ph -> ( F |` RR ) e. ( ( C^n ` RR ) ` 1 ) ) $.
    c1lip3.rn $e |- ( ph -> ( F " RR ) C_ RR ) $.
    c1lip3.dm $e |- ( ph -> ( A [,] B ) C_ dom F ) $.
    $( C1 functions are Lipschitz continuous on closed intervals.  (Contributed
       by Stefan O'Rear, 16-Nov-2014.) $)
    c1lip3 $p |- ( ph -> E. k e. RR A. x e. ( A [,] B ) A. y e. ( A [,] B )
        ( abs ` ( ( F ` y ) - ( F ` x ) ) ) <_
          ( k x. ( abs ` ( y - x ) ) ) ) $=
      ( cr cfv cmin co cabs wral wcel wa cres cmul cle wbr cicc wrex crn df-ima
      cv cima syl5eqssr cdm cin iccssre syl2anc ssind dmres syl6sseqr c1lip2 wi
      wss sseld anim12d imp fvres oveqan12rd fveq2d breq1d syl anassrs ralimdva
      biimpd reximdv mpd ) ACUIZGMUAZNZBUIZVPNZOPZQNZFUIVOVROPQNUBPZUCUDZCDEUEP
      ZRZBWDRZFMUFVOGNZVRGNZOPZQNZWBUCUDZCWDRZBWDRZFMUFABCDEFVPHIJAVPUGGMUJMGMU
      HKUKAWDMGULZUMVPULAWDMWNADMSEMSWDMVAHIDEUNUOZLUPGMUQURUSAWFWMFMAWEWLBWDAV
      RWDSZTWCWKCWDAWPVOWDSZWCWKUTZAWPWQTZTVRMSZVOMSZTZWRAWSXBAWPWTWQXAAWDMVRWO
      VBAWDMVOWOVBVCVDXBWCWKXBWAWJWBUCXBVTWIQXAWTVQWGVSWHOVOMGVEVRMGVEVFVGVHVLV
      IVJVKVKVMVN $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y z F $.  $d x y z ph $.
    dveq0.a $e |- ( ph -> A e. RR ) $.
    dveq0.b $e |- ( ph -> B e. RR ) $.
    dveq0.c $e |- ( ph -> F e. ( ( A [,] B ) -cn-> CC ) ) $.
    dveq0.d $e |- ( ph -> ( RR _D F ) = ( ( A (,) B ) X. { 0 } ) ) $.
    $( If a continuous function has zero derivative at all points on the
       interior of a closed interval, then it must be a constant function.
       (Contributed by Mario Carneiro, 2-Sep-2014.)  (Proof shortened by Mario
       Carneiro, 3-Mar-2015.) $)
    dveq0 $p |- ( ph -> F = ( ( A [,] B ) X. { ( F ` A ) } ) ) $=
      ( co cfv cc wcel wa wceq adantr cle wbr cr cabs cc0 vx vy cicc csn cxp wf
      wfn ccncf cncff syl ffn cvv fvex fnconstg mp1i cv fvconst2 adantl cxr w3a
      rexrd wb elicc2 syl2anc biimpa simp1d simp2d simp3d letrd lbicc2 ffvelrnd
      syl3anc ffvelrnda cmin subcld cmul simpr jca cdv cdm cioo dmeqd c0ex snnz
      wne dmxp ax-mp syl6eq 0re a1i fveq1d sylan9eq abs00bd 0le0 syl6eqbr dvlip
      syldan recnd abscld mul02d breqtrd absge0d letri3 mpbir2and abs00d eqtr2d
      c0 sylancl subeq0d eqfnfvd ) AUABCUCIZDXKBDJZUDUEZAXKKDUFZDXKUGADXKKUHILX
      NGXKKDUIUJZXKKDUKUJXLULLXMXKUGABDUMZXKXLULUNUOAUAUPZXKLZMZXQXMJZXLXQDJZXR
      XTXLNAXKXLXQXPUQURXSXLYAXSXKKBDAXNXRXOOXSBUSLCUSLBCPQBXKLZXSBABRLZXREOZVA
      XSCACRLZXRFOZVAXSBXQCYDXSXQRLZBXQPQZXQCPQZAXRYGYHYIUTZAYCYEXRYJVBEFBCXQVC
      VDVEZVFZYFXSYGYHYIYKVGXSYGYHYIYKVHVIBCVJVLZVKZAXKKXQDXOVMZXSXLYAVNIZXSXLY
      AYNYOVOZXSYPSJZTNZYRTPQZTYRPQZXSYRTBXQVNIZSJZVPIZTPAXRYBXRMYRUUDPQXSYBXRY
      MAXRVQVRAUBBCDTBXQEFGARDVSIZVTBCWAIZTUDZUEZVTZUUFAUUEUUHHWBUUGXGWEUUIUUFN
      TWCWDUUFUUGWFWGWHTRLZAWIWJAUBUPZUUFLZMZUUKUUEJZSJTTPUUMUUNAUULUUNUUKUUHJT
      AUUKUUEUUHHWKUUFTUUKWCUQWLWMWNWOWPWQXSUUCXSUUCXSUUBXSBXQXSBYDWRXSXQYLWRVO
      WSWRWTXAXSYPYQXBXSYRRLUUJYSYTUUAMVBXSYPYQWSWIYRTXCXHXDXEXIXFXJ $.
  $}

  ${
    $d x C $.  $d x y F $.  $d x y G $.  $d x y ph $.  $d x X $.
    dv11cn.x $e |- X = ( A ( ball ` ( abs o. - ) ) R ) $.
    dv11cn.a $e |- ( ph -> A e. CC ) $.
    dv11cn.r $e |- ( ph -> R e. RR* ) $.
    dv11cn.f $e |- ( ph -> F : X --> CC ) $.
    dv11cn.g $e |- ( ph -> G : X --> CC ) $.
    dv11cn.d $e |- ( ph -> dom ( CC _D F ) = X ) $.
    dv11cn.e $e |- ( ph -> ( CC _D F ) = ( CC _D G ) ) $.
    dv11cn.c $e |- ( ph -> C e. X ) $.
    dv11cn.p $e |- ( ph -> ( F ` C ) = ( G ` C ) ) $.
    $( Two functions defined on a ball whose derivatives are the same and which
       are equal at any given point ` C ` in the ball must be equal
       everywhere.  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    dv11cn $p |- ( ph -> F = G ) $=
      ( vx co cc0 cc vy cmin cof csn cxp wceq cvv wf wfn ffn syl wcel cabs ccom
      cbl cfv ovex eqeltri a1i inidm offn 0cn fnconstg mp1i cv subcl adantl off
      ffvelrnda cle wbr cmul simpr adantr jca cxmt cxr wss cnxmet blssm syl3anc
      wa syl5eqss cdv cdm cmpt feqmptd offval2 oveq2d cpr cnex prid2 fvex dvfcn
      cr feq2d mpbii eqtr3d 3eqtr3rd dvmptsub subidd mpteq2dva fconstmpt 3eqtrd
      syl6eqr dmeqd wne snnzg dmxp mp2b syl6eq eqimss2 0re fveq1d c0ex fvconst2
      c0 sylan9eq abs00bd 0le0 syl6eqbr dvlipcn syldan fveq2 oveq12d eqid fvmpt
      ffvelrnd subeq0bd subid1d eqtrd fveq2d sselda sseldd subcld abscld mul02d
      recnd 3brtr3d wb absge0d letri3 sylancl mpbir2and abs00d eqfnfvd ofsubeq0
      eqtr4d mpbid ) AEFUBUCRZGSUDZUEZUFZEFUFZAQGUUJUULAGGUBGEFUGUGAGTEUHZEGUIK
      GTEUJUKAGTFUHZFGUILGTFUJUKGUGULZAGBDUMUBUNZUOUPZRZUGHBDUUSUQURUSZUVAGUTZV
      ASTULZUULGUIAVBGSTVCVDAQVEZGULZWBZUVDUUJUPZSUVDUULUPZUVFUVGAGTUVDUUJAQUAG
      GGUBTTTEFUGUGUVDTULUAVEZTULWBUVDUVIUBRTULAUVDUVIVFVGKLUVAUVAUVBVHZVIZUVFU
      VGUMUPZSUFZUVLSVJVKZSUVLVJVKZUVFUVGCUUJUPZUBRZUMUPZSUVDCUBRZUMUPZVLRZUVLS
      VJAUVEUVECGULZWBUVRUWAVJVKUVFUVEUWBAUVEVMAUWBUVEOVNVOAQBGDUUJSGUVDCAGUUTT
      HAUURTVPUPULZBTULDVQULUUTTVRUWCAVSUSIJUURBDTVTWAWCZUVJIJHATUUJWDRZWEZGUFG
      UWFVRAUWFUULWEZGAUWEUULAUWETQGUVDEUPZUVDFUPZUBRZWFZWDRQGUVDTEWDRZUPZUWMUB
      RZWFZUULAUUJUWKTWDAQGUWHUWIUBEFUGTTUVAAGTUVDEKVIZAGTUVDFLVIZAQGTEKWGZAQGT
      FLWGZWHZWIAQUWHUWMUWIUWMTUGUGGTWOTWJULAWOTWKWLUSUWPUWMUGULUVFUVDUWLWMUSZA
      UWLTQGUWHWFZWDRQGUWMWFZAEUXBTWDUWRWIAQGTUWLAUWLWEZTUWLUHGTUWLUHEWNAUXDGTU
      WLMWPWQZWGZWRUWQUXAAUWLTFWDRUXCTQGUWIWFZWDRNUXFAFUXGTWDUWSWIWSWTAUWOQGSWF
      UULAQGUWNSUVFUWMAGTUVDUWLUXEVIXAXBQGSXCXEXDZXFUVCUUKXQXGUWGGUFVBSTXHGUUKX
      IXJXKGUWFXLUKSWOULZAXMUSUVFUVDUWEUPZUMUPSSVJUVFUXJAUVEUXJUVHSAUVDUWEUULUX
      HXNGSUVDXOXPZXRXSXTYAYBYCUVFUVQUVGUMUVFUVQUVGSUBRUVGUVFUVPSUVGUBAUVPSUFUV
      EAUVPCUWKUPZCEUPZCFUPZUBRZSACUUJUWKUWTXNAUWBUXLUXOUFOQCUWJUXOGUWKUVDCUFUW
      HUXMUWIUXNUBUVDCEYDUVDCFYDYEUWKYFUXMUXNUBUQYGUKAUXMUXNAGTCEKOYHPYIXDVNWIU
      VFUVGUVKYJYKYLUVFUVTUVFUVTUVFUVSUVFUVDCAGTUVDUWDYMACTULUVEAGTCUWDOYNVNYOY
      PYRYQYSUVFUVGUVKUUAUVFUVLWOULUXIUVMUVNUVOWBYTUVFUVGUVKYPXMUVLSUUBUUCUUDUU
      EUVEUVHSUFAUXKVGUUHUUFAUUQUUOUUPUUMUUNYTUVAKLGEFUGUUGWAUUI $.
  $}

  ${
    $d x y z A $.  $d x y O $.  $d x y z ph $.  $d z S $.  $d z X $.  $d z Y $.
    $d x y z B $.  $d x y z F $.
    dvgt0.a $e |- ( ph -> A e. RR ) $.
    dvgt0.b $e |- ( ph -> B e. RR ) $.
    dvgt0.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    ${
      dvgt0lem.d $e |- ( ph -> ( RR _D F ) : ( A (,) B ) --> S ) $.
      $( Lemma for ~ dvgt0 and ~ dvlt0 .  (Contributed by Mario Carneiro,
         19-Feb-2015.) $)
      dvgt0lem1 $p |- ( ( ( ph /\
        ( X e. ( A [,] B ) /\ Y e. ( A [,] B ) ) ) /\ X < Y ) ->
          ( ( ( F ` Y ) - ( F ` X ) ) / ( Y - X ) ) e. S ) $=
        ( co wcel wbr cfv wceq cxr cr wss syl2anc vz cicc wa clt cres cmin cdiv
        cle iccssxr simplrl sseldi simplrr iccssre ad2antrr sseldd simpr ubicc2
        ltled syl3anc fvres syl lbicc2 oveq12d oveq1d cv cioo wrex ccncf iccss2
        cdv ad2antlr rescncf wf cdm rexrd w3a elicc2 mpbid simp2d iooss1 simp3d
        sylc wb iooss2 sstrd fssres crn ctg cnt ax-resscn a1i cncff fss sylancl
        cc ccnfld ctopn tgioo2 dvres syl22anc iccntr reseq2d eqtrd feq1d mpbird
        eqid fdm mvth ffvelrnda eleq1 syl5ibcom rexlimdva mpd eqeltrrd ) AFBCUB
        LZMZGXOMZUCZUCZFGUDNZUCZGEFGUBLZUEZOZFYCOZUFLZGFUFLZUGLZGEOZFEOZUFLZYGU
        GLDYAYFYKYGUGYAYDYIYEYJUFYAGYBMZYDYIPYAFQMZGQMZFGUHNZYLYAXOQFBCUIZAXPXQ
        XTUJZUKZYAXOQGYPAXPXQXTULZUKZYAFGYAXORFAXORSZXRXTABRMZCRMZUUAHIBCUMTUNZ
        YQUOZYAXORGUUDYSUOZXSXTUPZURZFGUQUSGYBEUTVAYAFYBMZYEYJPYAYMYNYOUUIYRYTU
        UHFGVBUSFYBEUTVAVCVDYAUAVEZRYCVJLZOZYHPZUAFGVFLZVGYHDMZYAUAFGYCUUEUUFUU
        GYAYBXOSZEXORVHLMZYCYBRVHLMXRUUPAXTBCFGVIVKAUUQXRXTJUNXORYBEVLWBYAUUNDU
        UKVMZUUKVNUUNPYAUURUUNDREVJLZUUNUEZVMZYABCVFLZDUUSVMZUUNUVBSUVAAUVCXRXT
        KUNYAUUNBGVFLZUVBYABQMBFUHNZUUNUVDSYABAUUBXRXTHUNZVOYAFRMZUVEFCUHNZYAXP
        UVGUVEUVHVPZYQYAUUBUUCXPUVIWCUVFAUUCXRXTIUNZBCFVQTVRVSBFGVTTYACQMGCUHNZ
        UVDUVBSYACUVJVOYAGRMZBGUHNZUVKYAXQUVLUVMUVKVPZYSYAUUBUUCXQUVNWCUVFUVJBC
        GVQTVRWABGCWDTWEUVBDUUNUUSWFTYAUUNDUUKUUTYAUUKUUSYBVFWGWHOZWIOOZUEZUUTY
        ARWOSZXOWOEVMZUUAYBRSZUUKUVQPUVRYAWJWKYAXOREVMZUVRUVSAUWAXRXTAUUQUWAJXO
        REWLVAUNWJXORWOEWMWNUUDYAUVGUVLUVTUUEUUFFGUMTXOYBRUVOEWPWQOZUWBXFZUWBUW
        CWRWSWTYAUVPUUNUUSYAUVGUVLUVPUUNPUUEUUFFGXATXBXCXDXEZUUNDUUKXGVAXHYAUUM
        UUOUAUUNYAUUJUUNMUCUULDMUUMUUOYAUUNDUUJUUKUWDXIUULYHDXJXKXLXMXN $.

      dvgt0lem.o $e |- O Or RR $.
      dvgt0lem.i $e |- ( ( ( ph /\
        ( x e. ( A [,] B ) /\ y e. ( A [,] B ) ) ) /\ x < y ) ->
          ( F ` x ) O ( F ` y ) ) $.
      $( Lemma for ~ dvgt0 and ~ dvlt0 .  (Contributed by Mario Carneiro,
         19-Feb-2015.) $)
      dvgt0lem2 $p |- ( ph -> F Isom < , O ( ( A [,] B ) , ran F ) ) $=
        ( clt wiso wcel wor cr wb cicc co cima crn cres wbr cfv wral ralrimivva
        cv wi wa ex wss iccssre syl2anc ltso soss ee10 a1i ccncf cncff syl ssid
        wf soisores syl22anc mpbird wfn wceq ffn 3syl isoeq1 mpbid fnima isoeq5
        fnresdm ) ADEUAUBZGVRUCZOHGPZVRGUDZOHGPZAVRVSOHGVRUEZPZVTAWDBUJZCUJZOUF
        ZWEGUGWFGUGHUFZUKZCVRUHBVRUHZAWIBCVRVRAWEVRQWFVRQULULWGWHNUMUIAVRORZSHR
        ZVRSGVEZVRVRUNZWDWJTAVRSUNZSORWKADSQESQWOIJDEUOUPUQVRSOURUSWLAMUTAGVRSV
        AUBQZWMKVRSGVBZVCWNAVRVDUTBCVRVRSOHGVFVGVHAGVRVIZWCGVJWDVTTAWPWMWRKWQVR
        SGVKVLZVRGVQVRVSOHGWCVMVLVNAWRVSWAVJVTWBTWSVRGVOVRVSWAOHGVPVLVN $.
    $}

    ${
      dvgt0.d $e |- ( ph -> ( RR _D F ) : ( A (,) B ) --> RR+ ) $.
      $( A function on a closed interval with positive derivative is
         increasing.  (Contributed by Mario Carneiro, 19-Feb-2015.) $)
      dvgt0 $p |- ( ph -> F Isom < , < ( ( A [,] B ) , ran F ) ) $=
        ( vx vy crp clt cv co wcel wa wbr cfv cc0 cr ltso cicc cmin cdiv rpgt0d
        dvgt0lem1 wb ccncf cncff syl ad2antrr simplrr ffvelrnd simplrl resubcld
        wf wss iccssre syl2anc sseldd simpr posdifd mpbid gt0div syl3anc mpbird
        dvgt0lem2 ) AIJBCKDLEFGHUAAIMZBCUBNZOZJMZVIOZPZPZVHVKLQZPZVHDRZVKDRZLQS
        VRVQUCNZLQZVPVTSVSVKVHUCNZUDNZLQZVPWBABCKDVHVKEFGHUFUEVPVSTOWATOSWALQZV
        TWCUGVPVRVQVPVITVKDAVITDUPZVMVOADVITUHNOWEGVITDUIUJUKZAVJVLVOULZUMZVPVI
        TVHDWFAVJVLVOUNZUMZUOVPVKVHVPVITVKAVITUQZVMVOABTOCTOWKEFBCURUSUKZWGUTZV
        PVITVHWLWIUTZUOVPVOWDVNVOVAVPVHVKWNWMVBVCVSWAVDVEVFVPVQVRWJWHVBVFVG $.
    $}

    ${
      dvlt0.d $e |- ( ph -> ( RR _D F ) : ( A (,) B ) --> ( -oo (,) 0 ) ) $.
      $( A function on a closed interval with negative derivative is
         decreasing.  (Contributed by Mario Carneiro, 19-Feb-2015.) $)
      dvlt0 $p |- ( ph -> F Isom < , `' < ( ( A [,] B ) , ran F ) ) $=
        ( vx vy cmnf cc0 co clt cr wor wcel wa wbr mpbid cioo ccnv ltso mpbi cv
        cnvso cicc cfv caddc cmin cmul cdiv dvgt0lem1 eliooord syl simprd wb wf
        ccncf ad2antrr simplrr ffvelrnd simplrl resubcld 0re a1i iccssre sseldd
        cncff wss syl2anc simpr posdifd ltdivmul syl112anc recnd mul01d breqtrd
        ltsubaddd addid2d fvex brcnv sylibr dvgt0lem2 ) AIJBCKLUAMZDNUBZEFGHONP
        OWFPUCONUFUDAIUEZBCUGMZQZJUEZWHQZRZRZWGWJNSZRZWJDUHZWGDUHZNSWQWPWFSWOWP
        LWQUIMZWQNWOWPWQUJMZLNSWPWRNSWOWSWJWGUJMZLUKMZLNWOWSWTULMZLNSZWSXANSZWO
        KXBNSZXCWOXBWEQXEXCRABCWEDWGWJEFGHUMXBKLUNUOUPWOWSOQLOQZWTOQLWTNSZXCXDU
        QWOWPWQWOWHOWJDAWHODURZWLWNADWHOUSMQXHGWHODVIUOUTZAWIWKWNVAZVBZWOWHOWGD
        XIAWIWKWNVCZVBZVDXFWOVEVFZWOWJWGWOWHOWJAWHOVJZWLWNABOQCOQXOEFBCVGVKUTZX
        JVHZWOWHOWGXPXLVHZVDZWOWNXGWMWNVLWOWGWJXRXQVMTWSLWTVNVOTWOWTWOWTXSVPVQV
        RWOWPWQLXKXMXNVSTWOWQWOWQXMVPVTVRWQWPNWGDWAWJDWAWBWCWD $.
    $}

    ${
      dvge0.d $e |- ( ph -> ( RR _D F ) : ( A (,) B ) --> ( 0 [,) +oo ) ) $.
      dvge0.x $e |- ( ph -> X e. ( A [,] B ) ) $.
      dvge0.y $e |- ( ph -> Y e. ( A [,] B ) ) $.
      dvge0.l $e |- ( ph -> X <_ Y ) $.
      $( A function on a closed interval with nonnegative derivative is weakly
         increasing.  (Contributed by Mario Carneiro, 30-Apr-2016.) $)
      dvge0 $p |- ( ph -> ( F ` X ) <_ ( F ` Y ) ) $=
        ( clt wbr cle cc0 co wcel cr wceq cmin wa cdiv cpnf cico cicc dvgt0lem1
        cfv wi exp31 mp2and elrege0 simprbi wb ccncf wf cncff ffvelrnd resubcld
        imp syl adantr wss iccssre syl2anc sseldd posdifd biimpa ge0div syl3anc
        mpbird ex subge0d sylibd leidd fveq2 breq1d syl5ibrcom wo leloed mpjaod
        mpbid ) AEFNOZEDUIZFDUIZPOZEFUAZAWDQWFWEUBRZPOZWGAWDWJAWDUCZWJQWIFEUBRZ
        UDRZPOZWKWMQUEUFRZSZWNAWDWPAEBCUGRZSZFWQSZWDWPUJKLAWRWSUCWDWPABCWODEFGH
        IJUHUKULVAWPWMTSWNWMUMUNVBWKWITSZWLTSZQWLNOZWJWNUOAWTWDAWFWEAWQTFDADWQT
        UPRSWQTDUQIWQTDURVBZLUSZAWQTEDXCKUSZUTVCAXAWDAFEAWQTFABTSCTSWQTVDGHBCVE
        VFZLVGZAWQTEXFKVGZUTVCAWDXBAEFXHXGVHVIWIWLVJVKVLVMAWFWEXDXEVNVOAWGWHWFW
        FPOAWFXDVPWHWEWFWFPEFDVQVRVSAEFPOWDWHVTMAEFXHXGWAWCWB $.
    $}
  $}

  ${
    $d x M $.  $d x N $.  $d x P $.  $d x Q $.  $d x R $.  $d x S $.  $d x X $.
    $d x ph $.  $d x Y $.
    dvle.m $e |- ( ph -> M e. RR ) $.
    dvle.n $e |- ( ph -> N e. RR ) $.
    dvle.a $e |- ( ph ->
      ( x e. ( M [,] N ) |-> A ) e. ( ( M [,] N ) -cn-> RR ) ) $.
    dvle.b $e |- ( ph ->
      ( RR _D ( x e. ( M (,) N ) |-> A ) ) = ( x e. ( M (,) N ) |-> B ) ) $.
    dvle.c $e |- ( ph ->
      ( x e. ( M [,] N ) |-> C ) e. ( ( M [,] N ) -cn-> RR ) ) $.
    dvle.d $e |- ( ph ->
      ( RR _D ( x e. ( M (,) N ) |-> C ) ) = ( x e. ( M (,) N ) |-> D ) ) $.
    dvle.f $e |- ( ( ph /\ x e. ( M (,) N ) ) -> B <_ D ) $.
    dvle.x $e |- ( ph -> X e. ( M [,] N ) ) $.
    dvle.y $e |- ( ph -> Y e. ( M [,] N ) ) $.
    dvle.l $e |- ( ph -> X <_ Y ) $.
    dvle.p $e |- ( x = X -> A = P ) $.
    dvle.q $e |- ( x = X -> C = Q ) $.
    dvle.r $e |- ( x = Y -> A = R ) $.
    dvle.s $e |- ( x = Y -> C = S ) $.
    $( If ` A ( x ) , C ( x ) ` are differentiable functions and
       ` A `` <_ C `` ` , then for ` x <_ y ` ,
       ` A ( y ) - A ( x ) <_ C ( y ) - C ( x ) ` .  (Contributed by Mario
       Carneiro, 16-May-2016.) $)
    dvle $p |- ( ph -> ( R - P ) <_ ( S - Q ) ) $=
      ( cmin co cicc wcel cr wral cmpt wf ccncf cncff syl eqid fmpt sylibr wceq
      cv eleq1d rspcv sylc resubcld caddc recnd subcld addcomd subsub2d subsubd
      cle 3eqtr4d cfv ccnfld ctopn subcn ax-resscn resubcl cncfmpt2ss cioo cpnf
      cc0 cdv wa wbr cdm wss ioossicc sseli r19.21bi sylan2 fmptd ioossre dvfre
      cico sylancl dmeqd lerel brrelex2i ralrimiva dmmptg eqtrd feq12d brrelexi
      cvv subge0d mpbird elrege0 sylanbrc crn ctg cc a1i iccssre syl2anc tgioo2
      mpbid cnt iccntr dvmptntr reex prid1 dvmptsub feq1d dvge0 oveq12d fvmpt3i
      cpr ovex 3brtr3d subled eqbrtrd ) AIJHUIUJZGANKLUKUJZULZCUMULZBYRUNZIUMUL
      ZUCAYRUMBYRCUOZUPZUUAAUUCYRUMUQUJZULUUDQYRUMUUCURUSBYRUMCUUCUUCUTVAVBZYTU
      UBBNYRBVDZNVCZCIUMUGVEVFVGZAJHAYSEUMULZBYRUNZJUMULZUCAYRUMBYREUOZUPZUUKAU
      UMUUEULUUNSYRUMUUMURUSBYRUMEUUMUUMUTVAVBZUUJUULBNYRUUHEJUMUHVEVFVGZAMYRUL
      ZUUKHUMULZUBUUOUUJUURBMYRUUGMVCZEHUMUFVEVFVGZVHAUUQUUAGUMULZUBUUFYTUVABMY
      RUUSCGUMUEVEVFVGZAIYQUIUJZHJIUIUJZUIUJZGVOAIHJUIUJZVIUJUVFIVIUJUVCUVEAIUV
      FAIUUIVJZAHJAHUUTVJZAJUUPVJZVKVLAIJHUVGUVIUVHVMAHJIUVHUVIUVGVNVPAHGUVDUUT
      UVBAJIUUPUUIVHAMBYRECUIUJZUOZVQZNUVKVQZHGUIUJZUVDVOAKLUVKMNOPABECUMUIVRVS
      VQZYRUVOUTZUVOUVPVTSQWAECWBWCAKLWDUJZWFWEWSUJZUMUVKWGUJZUPUVQUVRBUVQFDUIU
      JZUOZUPABUVQUVTUVRUWAAUUGUVQULZWHZUVTUMULWFUVTVOWIZUVTUVRULUWCFDAFUMULZBU
      VQAUVQUMBUVQFUOZUPZUWEBUVQUNAUMBUVQEUOZWGUJZWJZUMUWIUPZUWGAUVQUMUWHUPUVQU
      MWKZUWKABUVQEUMUWHUWBAUUGYRULZUUJUVQYRUUGKLWLWMZAUUJBYRUUOWNZWOUWHUTWPKLW
      QZUVQUWHWRWTAUWJUVQUMUWIUWFTAUWJUWFWJZUVQAUWIUWFTXAAFXIULZBUVQUNUWQUVQVCA
      UWRBUVQUWCDFVOWIZUWRUADFVOXBXCUSZXDBUVQFXIXEUSXFXGYABUVQUMFUWFUWFUTVAVBWN
      ZADUMULZBUVQAUVQUMBUVQDUOZUPZUXBBUVQUNAUMBUVQCUOZWGUJZWJZUMUXFUPZUXDAUVQU
      MUXEUPUWLUXHABUVQCUMUXEUWBAUWMYTUWNAYTBYRUUFWNZWOUXEUTWPUWPUVQUXEWRWTAUXG
      UVQUMUXFUXCRAUXGUXCWJZUVQAUXFUXCRXAADXIULZBUVQUNUXJUVQVCAUXKBUVQUWCUWSUXK
      UADFVOXBXHUSZXDBUVQDXIXEUSXFXGYABUVQUMDUXCUXCUTVAVBWNZVHUWCUWDUWSUAUWCFDU
      XAUXMXJXKUVTXLXMUWAUTWPAUVQUVRUVSUWAAUVSUMBUVQUVJUOWGUJUWAABUVJUMWDXNXOVQ
      ZUVOYRUVQUMXPWKAWAXQAKUMULZLUMULZYRUMWKOPKLXRXSAUWMWHZUVJUXQECUWOUXIVHVJU
      VOUVPXTUVPAUXOUXPYRUXNYBVQVQUVQVCOPKLYCXSYDABEFCDUMXIXIUVQUMUMXPYLULAUMXP
      YEYFXQUWBAUWMEXPULUWNUXQEUWOVJWOUWTTUWBAUWMCXPULUWNUXQCUXIVJWOUXLRYGXFYHX
      KUBUCUDYIAUUQUVLUVNVCUBBMUVJUVNYRUVKUUSEHCGUIUFUEYJUVKUTZECUIYMZYKUSAYSUV
      MUVDVCUCBNUVJUVDYRUVKUUHEJCIUIUHUGYJUXRUXSYKUSYNYOYPYO $.
  $}

  ${
    $d w x y A $.  $d w x y B $.  $d w x y F $.  $d w x z G $.  $d w x y z M $.
    $d x y C $.  $d w x y z N $.  $d w x y z ph $.
    dvivth.1 $e |- ( ph -> M e. ( A (,) B ) ) $.
    dvivth.2 $e |- ( ph -> N e. ( A (,) B ) ) $.
    dvivth.3 $e |- ( ph -> F e. ( ( A (,) B ) -cn-> RR ) ) $.
    dvivth.4 $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    ${
      dvivth.5 $e |- ( ph -> M < N ) $.
      dvivth.6 $e |- ( ph ->
        C e. ( ( ( RR _D F ) ` N ) [,] ( ( RR _D F ) ` M ) ) ) $.
      dvivth.7 $e |- G = ( y e. ( A (,) B ) |-> ( ( F ` y ) - ( C x. y ) ) ) $.
      $( Lemma for ~ dvivth .  (Contributed by Mario Carneiro, 24-Feb-2015.) $)
      dvivthlem1 $p |- ( ph -> E. x e. ( M [,] N ) ( ( RR _D F ) ` x ) = C ) $=
        ( co cr wcel vz vw cv cicc cres cfv cle wbr wral wrex wceq cioo ioossre
        cdv sseldi ltled ccncf wf wss cmul cmin cncff syl ffvelrnda cdm sylancl
        dvfre eleqtrrd ffvelrnd iccssre syl2anc sseldd adantr remulcld resubcld
        wa a1i sselda fmptd iccssioo2 fssres ax-resscn fss cmpt oveq2i cpr reex
        cc prid1 recnd feq2d mpbid feqmptd oveq2d eqtr3d crn ctg ccnfld remulcl
        wb ctopn sylan c1 ax-1cn dvmptid dvmptcmul eqtrd eqid cvv mpbird simpld
        fvres wi ad2antrr cc0 weq fveq2 oveq1d simprl simprr sylib exp32 wo clt
        ovex eliooord cxr w3a c0 elioo2 mpbir3and eqeltrd simprd xrltle raleqdv
        rexrd mpd fveq2d letri3d mpbir2and mulid1d mpteq2dv tgioo2 syl5eq dmeqd
        iooretop dvmptres dvmptsub dmmptg mprg syl6eq syl31anc rescncf cncffvrn
        sylancr evthicc breqan12rd ralbidva adantl ioossicc ssralv ax-mp syl6bi
        dvcn sylc syldan fveq1d fvmpt syl5ss breq1d cbvralv dvferm subeq0d elpr
        vex wne ne0i ndmioo necon1ai 3syl iooss2 dvferm1 eqbrtrrd elicc2 simp3d
        suble0d breqtrrd simp2d eqbrtrd iooss1 dvferm2 breqtrd subge0d jaod cun
        syl5bi elun prunioo syl3anc eleq2d syl5bbr biimpar mpjaod syld reximdva
        ) AUAUCZHIJUDRZUEZUFZBUCZUXHUFZUGUHZUAUXGUIZBUXGUJZUXJSGUNRZUFZFUKZBUXG
        UJAUXNUXKUXIUGUHUAUXGUIBUXGUJABUABUAIJUXHADEULRZSIDEUMZKUOZAUXRSJUXSLUO
        ZAIJUXTUYAOUPZAUXHUXGSUQRTZUXGSUXHURZAUXRSHURZUXGUXRUSZUYDACUXRCUCZGUFZ
        FUYGUTRZVARZSHAUYGUXRTZVPZUYHUYIAUXRSUYGGAGUXRSUQRTUXRSGURZMUXRSGVBVCZV
        DZUYLFUYGAFSTZUYKAJUXOUFZIUXOUFZUDRZSFAUYQSTZUYRSTZUYSSUSAUXOVEZSJUXOAU
        YMUXRSUSZVUBSUXOURZUYNUXSUXRGVGVFZAJUXRVUBLNVHVIZAVUBSIUXOVUEAIUXRVUBKN
        VHVIZUYQUYRVJVKPVLZVMZAUXRSUYGVUCAUXSVQZVRVNZVOQVSZAIUXRTZJUXRTZUYFKLDE
        IJVTVKZUXRSUXGHWAVKASWHUSZUXHUXGWHUQRTZUYCUYDWTWBAUYFHUXRWHUQRTZVUQVUOA
        VUPUXRWHHURZVUCSHUNRZVEZUXRUKZVURVUPAWBVQZAUYEVUPVUSVULWBUXRSWHHWCVFVUJ
        AVVACUXRUYGUXOUFZFVARZWDZVEZUXRAVUTVVFAVUTSCUXRUYJWDZUNRVVFHVVHSUNQWEAC
        UYHVVDUYIFSSSUXRSSWHWFTASWHWGWIVQZUYLUYHUYOWJAUXRSUYGUXOAVUDUXRSUXOURVU
        EAVUBUXRSUXONWKWLZVDAUXOSCUXRUYHWDZUNRCUXRVVDWDAGVVKSUNACUXRSGUYNWMWNAC
        UXRSUXOVVJWMWOUYLUYIVUKWJVUIACUYIFSULWPWQUFZWRXAUFZSSUXRVVIAUYGSTZVPZUY
        IAUYPVVNUYISTVUHFUYGWSXBWJAUYPVVNVUHVMASCSUYIWDUNRCSFXCUTRZWDCSFWDACUYG
        XCFSWHSVVIASWHUYGVVCVRXCWHTVVOXDVQACSVVIXEAFVUHWJZXFACSVVPFAFVVQUUAUUBX
        GVUJVVMVVMXHZUUCVVRUXRVVLTADEUUFVQUUGUUHUUDZUUEVVEXITZVVGUXRUKCUXRCUXRV
        VEXIUUIVVTUYKVVDFVAYEVQUUJUUKZUXRSHUVDUULUXRWHUXGHUUMUVEUXGWHSUXHUUNUUO
        XJUUPXKAUXMUXQBUXGAUXJUXGTZVPZUXMUXFHUFZUXJHUFZUGUHZUAIJULRZUIZUXQVWCUX
        MVWFUAUXGUIZVWHVWBUXMVWIWTAVWBUXLVWFUAUXGUXFUXGTVWBUXIVWDUXKVWEUGUXFUXG
        HXLUXJUXGHXLUUQUURUUSVWGUXGUSVWIVWHXMIJUUTZVWFUAVWGUXGUVAUVBUVCVWCUXJVW
        GTZVWHUXQXMZUXJIJWFZTZVWCVWKVWHUXQVWCVWKVWHVPZVPZUXPFVWCUXPWHTVWOVWCUXP
        AVWBUXJUXRTZUXPSTZAUXGUXRUXJVUOVRZAUXRSUXJUXOVVJVDUVFZWJVMAFWHTVWBVWOVV
        QXNVWPUXJVUTUFZUXPFVARZXOVWCVXAVXBUKZVWOVWCVXAUXJVVFUFZVXBAVXAVXDUKVWBA
        UXJVUTVVFVVSUVGVMVWCVWQVXDVXBUKVWSCUXJVVEVXBUXRVVFCBXPVVDUXPFVAUYGUXJUX
        OXQXRVVFXHUXPFVAYEUVHVCXGZVMVWPUBIJUXJHUXRAUYEVWBVWOVULXNVUCVWPUXSVQVWC
        VWKVWHXSAVWGUXRUSVWBVWOAVWGUXGUXRVWJVUOUVIXNVWPUXJUXRVVAVWCVWQVWOVWSVMA
        VVBVWBVWOVWAXNVHVWPVWHUBUCZHUFZVWEUGUHZUBVWGUIZVWCVWKVWHXTVWFVXHUAUBVWG
        UAUBXPVWDVXGVWEUGUXFVXFHXQUVJUVKZYAUVLWOUVMYBVWNUXJIUKZUXJJUKZYCVWCVWLU
        XJIJBUVOUVNVWCVXKVWLVXLVWCVXKVWHUXQVWCVXKVWHVPZVPZUXQUXPFUGUHZFUXPUGUHZ
        VXNVXBXOUGUHVXOVXNVXAVXBXOUGVWCVXCVXMVXEVMVXNUBDJUXJHUXRAUYEVWBVXMVULXN
        VUCVXNUXSVQVXNUXJIDJULRZVWCVXKVWHXSZAIVXQTZVWBVXMAVXSISTZDIYDUHZIJYDUHZ
        UXTAVYAIEYDUHZAVUMVYAVYCVPKIDEYFVCXKZOADYGTZJYGTZVXSVXTVYAVYBYHWTAVYEEY
        GTZAVUMUXRYIUVPVYEVYGVPZKUXRIUVQVYHUXRYIDEUVRUVSUVTZXKZAJUYAYPZDJIYJVKY
        KXNYLAVXQUXRUSZVWBVXMAVYGJEUGUHZVYLAVYEVYGVYIYMZAJEYDUHZVYMADJYDUHZVYOA
        VUNVYPVYOVPLJDEYFVCYMZAVYFVYGVYOVYMXMVYKVYNJEYNVKYQDJEUWAVKXNVXNUXJUXRV
        VAVWCVWQVXMVWSVMAVVBVWBVXMVWAXNVHVXNVXHUBUXJJULRZUIVXIVXNVWHVXIVWCVXKVW
        HXTVXJYAVXNVXHUBVYRVWGVXNUXJIJULVXRXRYOXJUWBUWCVXNUXPFVWCVWRVXMVWTVMZAU
        YPVWBVXMVUHXNZUWFWLVXNFUYRUXPUGAFUYRUGUHZVWBVXMAUYPUYQFUGUHZWUAAFUYSTZU
        YPWUBWUAYHZPAUYTVUAWUCWUDWTVUFVUGUYQUYRFUWDVKWLZUWEXNVXNUXJIUXOVXRYRUWG
        VXNUXPFVYSVYTYSYTYBVWCVXLVWHUXQVWCVXLVWHVPZVPZUXQVXOVXPWUGUXPUYQFUGWUGU
        XJJUXOVWCVXLVWHXSZYRAWUBVWBWUFAUYPWUBWUAWUEUWHXNUWIWUGXOVXBUGUHVXPWUGXO
        VXAVXBUGWUGUBIEUXJHUXRAUYEVWBWUFVULXNVUCWUGUXSVQWUGUXJJIEULRZWUHAJWUITZ
        VWBWUFAWUJJSTZVYBVYOUYAOVYQAIYGTZVYGWUJWUKVYBVYOYHWTAIUXTYPZVYNIEJYJVKY
        KXNYLAWUIUXRUSZVWBWUFAVYEDIUGUHZWUNVYJAVYAWUOVYDAVYEWULVYAWUOXMVYJWUMDI
        YNVKYQDIEUWJVKXNWUGUXJUXRVVAVWCVWQWUFVWSVMAVVBVWBWUFVWAXNVHWUGVXHUBIUXJ
        ULRZUIVXIWUGVWHVXIVWCVXLVWHXTVXJYAWUGVXHUBWUPVWGWUGUXJJIULWUHWNYOXJUWKV
        WCVXCWUFVXEVMUWLWUGUXPFVWCVWRWUFVWTVMZAUYPVWBWUFVUHXNZUWMWLWUGUXPFWUQWU
        RYSYTYBUWNUWPAVWKVWNYCZVWBWUSUXJVWGVWMUWOZTAVWBUXJVWGVWMUWQAWUTUXGUXJAW
        ULVYFIJUGUHWUTUXGUKWUMVYKUYBIJUWRUWSUWTUXAUXBUXCUXDUXEYQ $.

      $( Lemma for ~ dvivth .  (Contributed by Mario Carneiro, 20-Feb-2015.) $)
      dvivthlem2 $p |- ( ph -> C e. ran ( RR _D F ) ) $=
        ( vx co wcel cc cv cr cdv cfv wceq cicc wrex crn dvivthlem1 wa cioo wfn
        wf cdm dvf feq2d mpbii ffn syl adantr iccssioo2 syl2anc sselda fnfvelrn
        wss eleq1 syl5ibcom rexlimdva mpd ) AQUAZUBFUCRZUDZEUEZQHIUFRZUGEVKUHZS
        ZAQBCDEFGHIJKLMNOPUIAVMVPQVNAVJVNSZUJZVLVOSZVMVPVRVKCDUKRZULZVJVTSVSAWA
        VQAVTTVKUMZWAAVKUNZTVKUMWBFUOAWCVTTVKMUPUQVTTVKURUSUTAVNVTVJAHVTSIVTSVN
        VTVEJKCDHIVAVBVCVTVJVKVDVBVLEVOVFVGVHVI $.
    $}

    $( Darboux' theorem, or the intermediate value theorem for derivatives.  A
       differentiable function's derivative satisfies the intermediate value
       property, even though it may not be continuous (so that ~ ivthicc does
       not directly apply).  (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    dvivth $p |- ( ph ->
      ( ( ( RR _D F ) ` M ) [,] ( ( RR _D F ) ` N ) ) C_ ran ( RR _D F ) ) $=
      ( vw wceq cr co cfv wa wcel adantr syl cc vx clt wbr w3o cdv cicc crn wss
      vy cioo ioossre sseldi lttri4d cv wrex cneg cmpt cmul cmin ccncf wf cncff
      ffvelrnda renegcld eqid fmptd wb ax-resscn cncfss mp2an negfcncf cncffvrn
      ssid sylancr mpbird cdm cvv cpr reex prid1 a1i recnd feqmptd oveq2d dvfre
      fvex sylancl feq2d mpbid eqtr3d dvmptneg dmeqd dmmptg negex syl6eq simprl
      mprg simprr ffvelrnd eleqtrrd iccssre syl2anc sseldd iccneg syl3anc fveq2
      fveq1d fvmpt eqtrd oveq12d dvivthlem2 rneqd eleqtrd elrnmpt ax-mp dvmptcl
      negeqd sylib neg11ad eqcom syl6bb rexbidva wfn ffn fvelrnb expr ssrdv csn
      oveq1d cxr rexrd iccid sylan9eqr fnfvelrn snssd eqsstrd 3jaodan mpdan ) A
      EFUBUCZEFLZFEUBUCZUDEMDUENZOZFUUBOZUFNZUUBUGZUHZAEFABCUJNZMEBCUKZGULAUUHM
      FUUIHULUMAYSUUGYTUUAAYSPUAUUEUUFAYSUAUNZUUEQZUUJUUFQZAYSUUKPZPZUULKUNZUUB
      OZUUJLZKUUHUOZUUNUUJUPZUUPUPZLZKUUHUOZUURUUNUUSKUUHUUTUQZUGZQZUVBUUNUUSMK
      UUHUUODOZUPZUQZUENZUGUVDUUNUIBCUUSUVHUIUUHUIUNZUVHOUUSUVJURNUSNUQZEFAEUUH
      QZUUMGRZAFUUHQZUUMHRZAUVHUUHMUTNZQZUUMAUVQUUHMUVHVAZAKUUHUVGMUVHAUUOUUHQZ
      PUVFAUUHMUUODADUVPQZUUHMDVAZIUUHMDVBSZVCVDUVHVEZVFAMTUHZUVHUUHTUTNZQZUVQU
      VRVGVHADUWEQUWFAUVPUWEDUWDTTUHUVPUWEUHVHTVMUUHMTVIVJIULKUUHDUVHUWCVKSUUHT
      MUVHVLVNVORUUNUVIVPUVCVPZUUHUUNUVIUVCUUNKUVFUUPMVQUUHMMTVRQUUNMTVSVTWAZUU
      NUVSPZUVFUUNUUHMUUODAUWAUUMUWBRZVCWBZUUPVQQUWIUUOUUBWFWAZUUNUUBMKUUHUVFUQ
      ZUENKUUHUUPUQUUNDUWMMUEUUNKUUHMDUWJWCWDUUNKUUHMUUBAUUHMUUBVAZUUMAUUBVPZMU
      UBVAZUWNAUWAUUHMUHUWPUWBUUIUUHDWEWGZAUWOUUHMUUBJWHWIZRZWCWJZWKZWLUUTVQQZU
      WGUUHLKUUHKUUHUUTVQWMUXBUVSUUPWNWAWQWOAYSUUKWPUUNUUSUUDUPZUUCUPZUFNZFUVIO
      ZEUVIOZUFNUUNUUKUUSUXEQZAYSUUKWRZUUNUUCMQZUUDMQZUUJMQUUKUXHVGAUXJUUMAUUHM
      EUUBUWRGWSZRAUXKUUMAUWOMFUUBUWQAFUUHUWOHJWTZWSZRUUNUUEMUUJAUUEMUHZUUMAUXJ
      UXKUXOUXLUXNUUCUUDXAXBRUXIXCZUUCUUDUUJXDXEWIUUNUXFUXCUXGUXDUFUUNUXFFUVCOZ
      UXCUUNFUVIUVCUXAXGUUNUVNUXQUXCLUVOKFUUTUXCUUHUVCUUOFLUUPUUDUUOFUUBXFXQUVC
      VEZUUDWNXHSXIUUNUXGEUVCOZUXDUUNEUVIUVCUXAXGUUNUVLUXSUXDLUVMKEUUTUXDUUHUVC
      UUOELUUPUUCUUOEUUBXFXQUXRUUCWNXHSXIXJWTUVKVEXKUUNUVIUVCUXAXLXMUUSVQQUVEUV
      BVGUUJWNKUUHUUTUUSUVCVQUXRXNXOXRUUNUVAUUQKUUHUWIUVAUUJUUPLUUQUWIUUJUUPUUN
      UUJTQUVSUUNUUJUXPWBRUUNKUVFUUPMVQUUHUWHUWKUWLUWTXPXSUUJUUPXTYAYBWIUUNUUBU
      UHYCZUULUURVGUUNUWNUXTUWSUUHMUUBYDSKUUHUUJUUBYESVOYFYGAYTPUUEUUDYHZUUFYTA
      UUEUUDUUDUFNZUYAYTUUCUUDUUDUFEFUUBXFYIAUUDYJQUYBUYALAUUDUXNYKUUDYLSYMAUYA
      UUFUHYTAUUDUUFAUUBUWOYCZFUWOQUUDUUFQAUWPUYCUWQUWOMUUBYDSUXMUWOFUUBYNXBYOR
      YPAUUAPUAUUEUUFAUUAUUKUULAUUAUUKPZPUIBCUUJDUIUUHUVJDOUUJUVJURNUSNUQZFEAUV
      NUYDHRAUVLUYDGRAUVTUYDIRAUWOUUHLUYDJRAUUAUUKWPAUUAUUKWRUYEVEXKYFYGYQYR $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z ph $.
    dvne0.a $e |- ( ph -> A e. RR ) $.
    dvne0.b $e |- ( ph -> B e. RR ) $.
    dvne0.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    dvne0.d $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    dvne0.z $e |- ( ph -> -. 0 e. ran ( RR _D F ) ) $.
    $( A function on a closed interval with nonzero derivative is either
       monotone increasing or monotone decreasing.  (Contributed by Mario
       Carneiro, 19-Feb-2015.) $)
    dvne0 $p |- ( ph -> ( F Isom < , < ( ( A [,] B ) , ran F ) \/
      F Isom < , `' < ( ( A [,] B ) , ran F ) ) ) $=
      ( co clt cr cc0 wceq crp wcel wa wb adantr cfv vx vy vz cicc wiso ccnv wo
      crn cdv cmnf cioo cin c0 wss cun cv wne wn notbid syl5ibrcom necon2ad imp
      eleq1 wbr cdm ccncf cncff syl iccssre syl2anc dvfre frn sselda 0re lttri2
      sylancl cxr 0xr elioomnf ax-mp baib elrp orbi12d bitr4d mpbid elun sylibr
      wf ex ssrdv disjssun syl5ibcom wfn feq2d ffn anim1i df-f dvgt0 syldan wex
      orcd n0 elin wrex fvelrnb wral ffvelrnda cle ad2antrr cres simplrl simprl
      wi ioossicc rescncf mpsyl ctg cnt cc ax-resscn a1i fss syl5ss ccnfld eqid
      ctopn tgioo2 dvres syl22anc ctop retop isopn3i mp2an reseq2i eqtrd fveq1d
      iooretop expr sylanbrc syl5bi fnresdm syl5eq dmeqd dvivth oveq12d 3sstr3d
      rneqd simplrr sylib simprd simpld ltle mpd simprr elicc2 mpbir3and sseldd
      w3a mtod ltnle mpbird ralrimiva ffnfv dvlt0 imbi1d rexlimdva sylbid imp3a
      olcd exlimdv pm2.61dane ) ABCUDJZDUHZKKDUEZUVLUVMKKUFDUEZUGZLDUIJZUHZUJMU
      KJZULZUMAUVTUMNZUVROUNZUVPAUWAUWBAUVRUVSOUOZUNUWAUWBAUAUVRUWCAUAUPZUVRPZU
      WDUWCPZAUWEQZUWDUVSPZUWDOPZUGZUWFUWGUWDMUQZUWJAUWEUWKAUWEUWDMAUWEURUWDMNZ
      MUVRPZURZIUWLUWEUWMUWDMUVRVCUSUTVAVBUWGUWKUWDMKVDZMUWDKVDZUGZUWJUWGUWDLPZ
      MLPZUWKUWQRAUVRLUWDAUVQVEZLUVQWHZUVRLUNAUVLLDWHZUVLLUNZUXAADUVLLVFJPZUXBG
      UVLLDVGVHZABLPZCLPZUXCEFBCVIVJZUVLDVKVJZUWTLUVQVLVHVMZVNUWDMVOVPUWGUWRUWJ
      UWQRUXJUWRUWHUWOUWIUWPUWHUWRUWOMVQPZUWHUWRUWOQRVRMUWDVSVTWAUWIUWRUWPUWDWB
      WAWCVHWDWEUWDUVSOWFWGWIWJUVRUVSOWKWLVBAUWBQZUVNUVOUXLBCDAUXFUWBESAUXGUWBF
      SAUXDUWBGSUXLUVQBCUKJZWMZUWBQUXMOUVQWHAUXNUWBAUXMLUVQWHZUXNAUXAUXOUXIAUWT
      UXMLUVQHWNWEZUXMLUVQWOVHZWPUXMOUVQWQWGWRXAWSAUVTUMUQZUVPUXRUWDUVTPZUAWTAU
      VPUAUVTXBAUXSUVPUAUXSUWEUWHQAUVPUWDUVRUVSXCAUWEUWHUVPAUWEUBUPZUVQTZUWDNZU
      BUXMXDZUWHUVPXMZAUXNUWEUYCRUXQUBUXMUWDUVQXEVHAUYBUYDUBUXMAUXTUXMPZQUYAUVS
      PZUVPXMUYBUYDAUYEUYFUVPAUYEUYFQZQZUVOUVNUYHBCDAUXFUYGESAUXGUYGFSAUXDUYGGS
      UYHUXNUCUPZUVQTZUVSPZUCUXMXFUXMUVSUVQWHAUXNUYGUXQSUYHUYKUCUXMUYHUYIUXMPZQ
      ZUYJLPZUYJMKVDZUYKUYHUXMLUYIUVQAUXOUYGUXPSXGZUYMUYOMUYJXHVDZURZUYMUYQUWMA
      UWNUYGUYLIXIUYHUYLUYQUWMUYHUYLUYQQZQZUYAUYJUDJZUVRMUYTUXTLDUXMXJZUIJZTZUY
      IVUCTZUDJVUCUHVUAUVRUYTBCVUBUXTUYIAUYEUYFUYSXKUYHUYLUYQXLZAVUBUXMLVFJPZUY
      GUYSUXMUVLUNAUXDVUGBCXNZGUVLLUXMDXOXPXIAVUCVEZUXMNUYGUYSAVUIUWTUXMAVUCUVQ
      AVUCUVQUXMUKUHXQTZXRTTZXJZUVQALXSUNZUVLXSDWHZUXCUXMLUNVUCVULNVUMAXTYAAUXB
      VUMVUNUXEXTUVLLXSDYBVPUXHAUXMUVLLVUHUXHYCUVLUXMLVUJDYDYFTZVUOYEZVUOVUPYGY
      HYIAVULUVQUXMXJZUVQVUKUXMUVQVUJYJPUXMVUJPVUKUXMNYKBCYQUXMVUJYLYMYNAUXNVUQ
      UVQNUXQUXMUVQUUAVHUUBYOZUUCHYOXIUUDUYTVUDUYAVUEUYJUDUYTUXTVUCUVQAVUCUVQNU
      YGUYSVURXIZYPUYTUYIVUCUVQVUSYPUUEUYTVUCUVQVUSUUGUUFUYTMVUAPZUWSUYAMXHVDZU
      YQUWSUYTVNYAUYTUYAMKVDZVVAUYTUYALPZVVBUYTUYFVVCVVBQZAUYEUYFUYSUUHUXKUYFVV
      DRVRMUYAVSVTUUIZUUJUYTVVCUWSVVBVVAXMUYTVVCVVBVVEUUKZVNUYAMUULVPUUMUYHUYLU
      YQUUNUYTVVCUYNVUTUWSVVAUYQUURRVVFUYHUYSUYLUYNVUFUYPWSUYAUYJMUUOVJUUPUUQYR
      UUSUYMUYNUWSUYOUYRRUYPVNUYJMUUTVPUVAUXKUYKUYNUYOQRVRMUYJVSVTYSUVBUCUXMUVS
      UVQUVCYSUVDUVIYRUYBUYFUWHUVPUYAUWDUVSVCUVEWLUVFUVGUVHYTUVJYTVBUVK $.

    $( A function on a closed interval with nonzero derivative is one-to-one.
       (Contributed by Mario Carneiro, 19-Feb-2015.) $)
    dvne0f1 $p |- ( ph -> F : ( A [,] B ) -1-1-> RR ) $=
      ( cicc co crn wf1 cr wss clt wiso ccnv isof1o 3syl wf1o dvne0 f1of1 ccncf
      wo jaoi wcel wf cncff frn f1ss syl2anc ) ABCJKZDLZDMZUNNOZUMNDMAUMUNPPDQZ
      UMUNPPRZDQZUEUMUNDUAZUOABCDEFGHIUBUQUTUSUMUNPPDSUMUNPURDSUFUMUNDUCTADUMNU
      DKUGUMNDUHUPGUMNDUIUMNDUJTUMUNNDUKUL $.

  $}

  ${
    $d d e r v x y z B $.  $d t D $.  $d d e r u v w x y z ph $.  $d u w z R $.
    $d d e r t u v w x y z A $.  $d r t u v w x E $.  $d r u v w x z X $.
    $d d e r t u v w x y z C $.  $d d e r t u v w x y z F $.
    $d d e r t u v w x y z G $.
    lhop1.a $e |- ( ph -> A e. RR ) $.
    lhop1.b $e |- ( ph -> B e. RR* ) $.
    lhop1.l $e |- ( ph -> A < B ) $.
    lhop1.f $e |- ( ph -> F : ( A (,) B ) --> RR ) $.
    lhop1.g $e |- ( ph -> G : ( A (,) B ) --> RR ) $.
    lhop1.if $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    lhop1.ig $e |- ( ph -> dom ( RR _D G ) = ( A (,) B ) ) $.
    lhop1.f0 $e |- ( ph -> 0 e. ( F limCC A ) ) $.
    lhop1.g0 $e |- ( ph -> 0 e. ( G limCC A ) ) $.
    lhop1.gn0 $e |- ( ph -> -. 0 e. ran G ) $.
    lhop1.gd0 $e |- ( ph -> -. 0 e. ran ( RR _D G ) ) $.
    lhop1.c $e |- ( ph -> C e. ( ( z e. ( A (,) B ) |->
      ( ( ( RR _D F ) ` z ) / ( ( RR _D G ) ` z ) ) ) limCC A ) ) $.
    ${
      lhop1lem.e $e |- ( ph -> E e. RR+ ) $.
      lhop1lem.d $e |- ( ph -> D e. RR ) $.
      lhop1lem.db $e |- ( ph -> D <_ B ) $.
      lhop1lem.x $e |- ( ph -> X e. ( A (,) D ) ) $.
      lhop1lem.t $e |- ( ph -> A. t e. ( A (,) D )
       ( abs ` ( ( ( ( RR _D F ) ` t ) / ( ( RR _D G ) ` t ) ) - C ) ) < E ) $.
      lhop1lem.r $e |- R = ( A + ( r / 2 ) ) $.
      $( Lemma for ~ lhop1 .  (Contributed by Mario Carneiro, 29-Dec-2016.) $)
      lhop1lem $p |- ( ph ->
          ( abs ` ( ( ( F ` X ) / ( G ` X ) ) - C ) ) < ( 2 x. E ) ) $=
        ( vv vx vu vw cfv cdiv co cmin cabs c2 cmul cioo cr cxr wcel cle iooss2
        wbr wss syl2anc sseldd ffvelrnd recnd cc0 crn wn wne wceq wfn syl eleq1
        wf syl5ibcom necon3bd mpd divcld cv cdv cmpt climc cc sseldi subcld a1i
        rpred cdif cin crab wa wrex wi wral clt crp wb adantr eqid oveq1i rexrd
        fveq2d syl22anc mpbird ltled sselda cres ad2antrr ax-resscn cdm sylancl
        ccncf sylancr sylc eqtrd sylib syl3anc fvres fveq2 oveq2d oveq1d breq1d
        oveq12d mp2an crest ctx ctopon cvv ax-mp limcresi c1 ffn limccl 2re csn
        fnfvelrn abscld remulcld cima ccnfld ccom cbl cxmt cnxmet simprl simprr
        ctopn eliooord simpld ioossre difrp cnfldtopn mopni3 syl31anc rehalfcld
        mpbid caddc readdcld syl5eqel cnmetdval halfcld syl5eq rphalfcld rpge0d
        pncan2d absidd rphalflt eqbrtrd elbl3 ltaddrpd syl6breqr resubcld lttrd
        3eqtrd ltaddsub2d syl5eqbr w3a elioo2 mpbir3and sylanbrc simprd xrletrd
        elin ffvelrnda syldan subeq0ad cicc xrltletrd iccssioo fss dvcn rescncf
        adantl cncffvrn ctg cnt syl6ss tgioo2 dvres iccntr reseq2d dmeqd syl5ss
        ioossicc sseqtr4d ssdmres ubicc2 lbicc2 eqeq12d biimpar eqcomd sylan9eq
        rolle fveq1d dvf feq2d mpbii rexlimdva ex sylbid ralrimiva neeq1d rspcv
        eqeltrd sstrd iccssre iooss1 cmvth divmuleqd bitr4d rexbidva syl5ibrcom
        mulcomd oveq1 rspcev adantlr ssrin lbioo disjsn mpbir disj3 mpbi ineq2i
        c0 syl6sseq ssrexv syl5com anassrs expimpd inss2 difss sstri sseli ovex
        fvmpt rexbiia sylibr fnmpti rexima dfrex2 ssrab simprbi ralinexa notbid
        nsyl expr elrab3 notrab abssub sylan rabbidva blcld eqeltrrd cnfldtopon
        ccld toponunii cldopn syl5eqelr ssid cxp cnex ssexi txrest mp4an restid
        eldifsn eqtr2i subid1d txtopon eqcomi resmpt sseqtri cncfmptc cnmptlimc
        eqidd feqresmpt syl5sseq ccn cop ccnp subcn 0cn opelxpi cncnpi limccnp2
        divcn resttopon fmptd ellimc2 eleq2 anbi2d rexbidv imbi12d sylbird mt3d
        sseq2 mulid2d 1re 1lt2 ltmul1dd eqbrtrrd lelttrd ) ALJUPZLKUPZUQURZFUSU
        RZUTUPZIVAIVBURZAVYOAVYNFAVYLVYMAVYLADEVCURZVDLJQADGVCURZVYRLAEVEVFZGEV
        GVIVYSVYRVJZOUHDGEVHVKZUIVLZVMZVNZAVYMAVYRVDLKRWUCVMZVNZAVOKVPZVFZVQVYM
        VOVRZUCAWUIVYMVOAVYMWUHVFZVYMVOVSWUIAKVYRVTZLVYRVFWUKAVYRVDKWCZWULRVYRV
        DKUUAWAWUCVYRLKUUEVKVYMVOWUHWBWDWEWFZWGZABVYRBWHZVDJWIURZUPWUPVDKWIURZU
        PUQURWJZDWKURWLFDWUSUUBUEWMZWNUUFAIUFWPZAVAIVAVDVFAUUCWOZWVAUUGAVYPIVGV
        IZDULWHZVFZBDLVCURZVYLWUPJUPZUSURZVYMWUPKUPZUSURZUQURZWJZWVDWVFDUUDZWQZ
        WRZUUHZUMWHZFUSURZUTUPZIVGVIZVQZUMWLWSZVJZWTZULUUIUUPUPZXAZAWVEWWCVQZXB
        ZULWWEXCWWFVQAWWHULWWEAWVDWWEVFZWVEWWGAWWIWVEWTZWTZWWAUMWVPXCZWWCWWKWVT
        UMWVPXAZWWLVQWWKUNWHZWVLUPZFUSURZUTUPZIVGVIZUNWVOXAZWWMWWKVYLWWNJUPZUSU
        RZVYMWWNKUPZUSURZUQURZFUSURZUTUPZIVGVIZUNWVOXAZWWSWWKMWHZLDUSURZXDVIZDW
        XIUTUSUUJZUUKUPURZWVDVJZWTZMXEXAZWXHWWKWXLWLUULUPVFZWWIWVEWXJXEVFZWXPWX
        QWWKUUMWOAWWIWVEUUNAWWIWVEUUOAWXRWWJADLXDVIZWXRAWXSLGXDVIZALVYSVFWXSWXT
        WTUILDGUUQWAZUURADVDVFZLVDVFZWXSWXRXFNAVYSVDLDGUUSUIWMZDLUUTVKUVEXGMWVD
        WXLDWXJWWEWLWWEWWEXHZUVAZUVBUVCWWKWXOWXHMXEWWKWXIXEVFZWTWXKWXNWXHWWKWYG
        WXKWXNWXHXBWWKWYGWXKWTZWTWXGUNWXMWVFWRZXAZWXNWXHAWYHWYJWWJAWYHWTZHWYIVF
        ZVYLHJUPZUSURZVYMHKUPZUSURZUQURZFUSURZUTUPZIVGVIZWYJWYKHWXMVFZHWVFVFZWY
        LWYKXUAHDWXLURZWXIXDVIZWYKXUCWXIVAUQURZWXIXDWYKXUCHDUSURZUTUPZXUEUTUPXU
        EWYKHWLVFZDWLVFZXUCXUGVSWYKHWYKHDXUEUVFURZVDUKWYKDXUEAWYBWYHNXGZWYKWXIW
        YKWXIAWYGWXKUUNZWPZUVDUVGUVHZVNZAXUIWYHADNVNZXGZHDWXLWXLXHZUVIVKWYKXUFX
        UEUTWYKXUFXUJDUSURXUEHXUJDUSUKXIWYKDXUEXUQWYKWXIWYKWXIXUMVNUVJUVNUVKXKW
        YKXUEWYKXUEWYKWXIXULUVLZWPZWYKXUEXUSUVMUVOUWCWYKWYGXUEWXIXDVIXULWXIUVPW
        AZUVQWYKWXQWXIVEVFXUIXUHXUAXUDXFWXQWYKUUMWOWYKWXIXUMXJXUQXUOHWXLDWXIWLU
        VRXLXMWYKXUBHVDVFZDHXDVIZHLXDVIZXUNWYKDXUJHXDWYKDXUEXUKXUSUVSUKUVTZWYKH
        XUJLXDUKWYKXUJLXDVIXUEWXJXDVIWYKXUEWXIWXJXUTXUMWYKLDAWYCWYHWYDXGZXUKUWA
        XVAAWYGWXKUUOUWBWYKDXUELXUKXUTXVFUWDXMUWEZWYKDVEVFZLVEVFZXUBXVBXVCXVDUW
        FXFWYKDXUKXJZAXVIWYHALWYDXJZXGDLHUWGVKUWHZHWXMWVFUWLUWIWYKWYSIWYKWYRWYK
        WYQFWYKWYNWYPWYKVYLWYMAVYLWLVFZWYHWUEXGWYKWYMWYKVYRVDHJAVYRVDJWCZWYHQXG
        WYKWVFVYRHAWVFVYRVJZWYHAVYTLEVGVIXVOOALGEXVKAGUGXJZOALGWYDUGAWXSWXTWYAU
        WJZXNZUHUWKDLEVHVKZXGXVLVLZVMVNWNZWYKVYMWYOAVYMWLVFZWYHWUGXGWYKWYOWYKVY
        RVDHKAWUMWYHRXGXVTVMVNWNZWYKXUBWVJVOVRZBWVFXCZWYPVOVRZXVLAXWEWYHAXWDBWV
        FAWUPWVFVFZWTZVOWURVPZVFZVQZXWDAXWKXWGUDXGXWHXWJWVJVOXWHWVJVOVSVYMWVIVS
        ZXWJXWHVYMWVIAXWBXWGWUGXGZXWHWVIAXWGWUPVYRVFZWVIVDVFAWVFVYRWUPXVSXOZAVY
        RVDWUPKRUWMUWNVNZUWOXWHXWLXWJXWHXWLWTZUOWHZVDKWUPLUWPURZXPZWIURZUPZVOVS
        ZUOWUPLVCURZXAXWJXWQUOWUPLXWTXWHWUPVDVFZXWLXWHVYRVDWUPDEUUSZXWOWMZXGZAW
        YCXWGXWLWYDXQZXWHWUPLXDVIZXWLXWHDWUPXDVIZXXJXWGXXKXXJWTAWUPDLUUQUXBZUWJ
        ZXGXWQXWSVYRVJZKVYRVDYAURZVFZXWTXWSVDYAURVFXWHXXNXWLXWHXVHVYTXXKLEXDVIZ
        XXNAXVHXWGADNXJXGAVYTXWGOXGXWHXXKXXJXXLUURAXXQXWGALGEXVKXVPOXVQUHUWQXGD
        EWUPLUWRXLXGZAXXPXWGXWLAXXPWUMRAVDWLVJZKVYRWLYAURZVFZXXPWUMXFXRAXXSVYRW
        LKWCZVYRVDVJZWURXSZVYRVSZXYAXXSAXRWOZAWUMXXSXYBRXRVYRVDWLKUWSXTZXYCAXXF
        WOZTVYRVDKUWTUVCVYRWLVDKUXCYBXMZXQVYRVDXWSKUXAYCXWQXXAXSWURXXDXPZXSZXXD
        XWQXXAXYJXWQXXAWURXWSVCVPUXDUPZUXEUPZUPZXPZXYJXWQXXSXYBXYCXWSVDVJXXAXYO
        VSXXSXWQXRWOAXYBXWGXWLXYGXQXYCXWQXXFWOXWQXWSVYRVDXXRXXFUXFVYRXWSVDXYLKW
        WEWYEWWEWYEUXGZUXHXLXWQXYNXXDWURXWQXXEWYCXYNXXDVSXXHXXIWUPLUXIVKUXJYDZU
        XKXWQXXDXYDVJXYKXXDVSXWQXXDVYRXYDXWQXXDXWSVYRWUPLUXMXXRUXLZAXYEXWGXWLTX
        QUXNXXDWURUXOYEYDXWQLXWTUPZWUPXWTUPZXWHXYSXYTVSXWLXWHXYSVYMXYTWVIXWHLXW
        SVFZXYSVYMVSXWHWUPVEVFZXVIWUPLVGVIZYUAXWHWUPXXGXJZAXVIXWGXVKXGZXWHWUPLX
        XGAWYCXWGWYDXGXXMXNZWUPLUXPYFLXWSKYGWAXWHWUPXWSVFZXYTWVIVSXWHYUBXVIYUCY
        UGYUDYUEYUFWUPLUXQYFWUPXWSKYGWAUXRUXSUXTUYBXWQXXCXWJUOXXDXWQXWRXXDVFZWT
        ZXXBXWIVFXXCXWJYUIXXBXWRWURUPZXWIXWQYUHXXBXWRXYJUPYUJXWQXWRXXAXYJXYQUYC
        XWRXXDWURYGUYAYUIWURVYRVTZXWRVYRVFZYUJXWIVFZXWQYUKYUHXWQVYRWLWURWCZYUKA
        YUNXWGXWLAXYDWLWURWCYUNKUYDAXYDVYRWLWURTUYEUYFZXQVYRWLWURUUAZWAXGXWQXXD
        VYRXWRXYRXOVYRXWRWURUUEZVKUYMXXBVOXWIWBWDUYGWFUYHUYIWEWFZUYJXGXWDXWFBHW
        VFWUPHVSZWVJWYPVOYUSWVIWYOVYMUSWUPHKYHYIUYKUYLYCZWGAFWLVFZWYHWUTXGWNUUF
        AIVDVFWYHWVAXGWYKWYQXWRWUQUPZYUJUQURZVSZUOHLVCURZXAZWYSIXDVIZWYKLJHLUWP
        URZXPZUPZHYVIUPZUSURZXWRVDKYVHXPZWIURZUPZVBURZLYVMUPZHYVMUPZUSURZXWRVDY
        VIWIURZUPZVBURZVSZUOYVEXAYVFWYKUOHLYVIYVMXUNXVFXVGWYKYVHVYRVJZJXXOVFZYV
        IYVHVDYAURZVFWYKYVHVYSVYRWYKXVHGVEVFZXVCWXTYVHVYSVJXVJAYWGWYHXVPXGZXVEA
        WXTWYHXVQXGDGHLUWRXLAWUAWYHWUBXGZUYNZAYWEWYHAYWEXVNQAXXSJXXTVFZYWEXVNXF
        XRAXXSVYRWLJWCZXYCWUQXSZVYRVSZYWKXYFAXVNXXSYWLQXRVYRVDWLJUWSXTZXYHSVYRV
        DJUWTUVCVYRWLVDJUXCYBXMXGVYRVDYVHJUXAYCWYKYWDXXPYVMYWFVFYWJAXXPWYHXYIXG
        VYRVDYVHKUXAYCWYKYVTXSWUQYVEXPZXSZYVEWYKYVTYWPWYKYVTWUQYVHXYMUPZXPZYWPW
        YKXXSYWLXYCYVHVDVJZYVTYWSVSXXSWYKXRWOZAYWLWYHYWOXGXYCWYKXXFWOZWYKXVBWYC
        YWTXUNXVFHLUYOVKZVYRYVHVDXYLJWWEWYEXYPUXHXLWYKYWRYVEWUQWYKXVBWYCYWRYVEV
        SXUNXVFHLUXIVKZUXJYDZUXKWYKYVEYWMVJYWQYVEVSWYKYVEVYRYWMWYKYVEVYSVYRWYKY
        VEWVFVYSWYKXVHDHVGVIYVEWVFVJXVJWYKDHXUKXUNXVEXNDHLUYPVKWYKYWGLGVGVIZWVF
        VYSVJYWHAYXFWYHXVRXGDLGVHVKUYNZYWIUYNZAYWNWYHSXGUXNYVEWUQUXOYEYDWYKYVNX
        SWURYVEXPZXSZYVEWYKYVNYXIWYKYVNWURYWRXPZYXIWYKXXSXYBXYCYWTYVNYXKVSYXAAX
        YBWYHXYGXGYXBYXCVYRYVHVDXYLKWWEWYEXYPUXHXLWYKYWRYVEWURYXDUXJYDZUXKWYKYV
        EXYDVJYXJYVEVSWYKYVEVYRXYDYXHAXYEWYHTXGUXNYVEWURUXOYEYDUYQWYKYWCYVDUOYV
        EWYKXWRYVEVFZWTZYWCWYNYUJVBURZYVBWYPVBURZVSYVDYXNYVPYXOYWBYXPYXNYVLWYNY
        VOYUJVBYXNYVJVYLYVKWYMUSYXNLYVHVFZYVJVYLVSYXNHVEVFZXVIHLVGVIZYXQWYKYXRY
        XMWYKHXUNXJXGZAXVIWYHYXMXVKXQZWYKYXSYXMWYKHLXUNXVFXVGXNXGZHLUXPYFZLYVHJ
        YGWAYXNHYVHVFZYVKWYMVSYXNYXRXVIYXSYYDYXTYYAYYBHLUXQYFZHYVHJYGWAYLWYKYXM
        YVOXWRYXIUPYUJWYKXWRYVNYXIYXLUYCXWRYVEWURYGUYAYLYXNYWBWYPYVBVBURYXPYXNY
        VSWYPYWAYVBVBYXNYVQVYMYVRWYOUSYXNYXQYVQVYMVSYYCLYVHKYGWAYXNYYDYVRWYOVSY
        YEHYVHKYGWAYLWYKYXMYWAXWRYWPUPYVBWYKXWRYVTYWPYXEUYCXWRYVEWUQYGUYAYLYXNW
        YPYVBWYKWYPWLVFYXMXWCXGZYXNVYRWLXWRWUQAVYRWLWUQWCZWYHYXMAYWMWLWUQWCYYGJ
        UYDAYWMVYRWLWUQSUYEUYFXQWYKYVEVYRXWRYXHXOZVMZVUBYDUXRYXNWYNWYPYVBYUJWYK
        WYNWLVFYXMXWAXGYYFYYIYXNVYRWLXWRWURAYUNWYHYXMYUOXQZYYHVMWYKXWFYXMYUTXGY
        XNXWKYUJVOVRAXWKWYHYXMUDXQYXNXWJYUJVOYXNYUMYUJVOVSXWJYXNYUKYULYUMYXNYUN
        YUKYYJYUPWAYYHYUQVKYUJVOXWIWBWDWEWFUYRUYSUYTUVEWYKYVDYVGUOYVEYXNYVGYVDY
        VCFUSURZUTUPZIXDVIZYXNXWRVYSVFCWHZWUQUPZYYNWURUPZUQURZFUSURZUTUPZIXDVIZ
        CVYSXCZYYMWYKYVEVYSXWRYXGXOAUUUAWYHYXMUJXQYYTYYMCXWRVYSYYNXWRVSZYYSYYLI
        XDUUUBYYRYYKUTUUUBYYQYVCFUSUUUBYYOYVBYYPYUJUQYYNXWRWUQYHYYNXWRWURYHYLYJ
        XKYKUYLYCYVDWYSYYLIXDYVDWYRYYKUTWYQYVCFUSVUCXKYKVUAUYGWFXNWXGWYTUNHWYIW
        WNHVSZWXFWYSIVGUUUCWXEWYRUTUUUCWXDWYQFUSUUUCWXAWYNWXCWYPUQUUUCWWTWYMVYL
        USWWNHJYHYIUUUCWXBWYOVYMUSWWNHKYHYIYLYJXKYKVUDVKVUEWXNWYIWVOVJWYJWXHXBW
        XNWYIWVDWVFWRWVOWXMWVDWVFVUFWVFWVNWVDWVFWVMWRVUMVSZWVFWVNVSUUUDDWVFVFVQ
        DLVUGWVFDVUHVUIWVFWVMVUJVUKVULVUNWXGUNWYIWVOVUOWAVUPVUQVURUYGWFWWRWXGUN
        WVOWWNWVOVFWWNWVFVFZWWRWXGXFWVOWVFWWNWVOWVNWVFWVDWVNVUSWVFWVMVUTVVAZVVB
        UUUEWWQWXFIVGUUUEWWPWXEUTUUUEWWOWXDFUSBWWNWVKWXDWVFWVLWUPWWNVSZWVHWXAWV
        JWXCUQUUUGWVGWWTVYLUSWUPWWNJYHYIUUUGWVIWXBVYMUSWUPWWNKYHYIYLWVLXHZWXAWX
        CUQVVCVVDYJXKYKWAVVEVVFWVLWVFVTWVOWVFVJWWMWWSXFBWVFWVKWVLWVHWVJUQVVCUUU
        HVVGUUUFWVTWWRUMUNWVFWVOWVLWVQWWOVSZWVSWWQIVGUUUIWVRWWPUTWVQWWOFUSVUCXK
        YKVVHYMVVFWVTUMWVPVVIYEWWCWVPWLVJWWLWWAUMWLWVPVVJVVKVVNVVOUYJWVEWWCULWW
        EVVLYEAWVCVQZVYNWWBVFZWWFAVYNWLVFZUUUKUUUJXFWUOWWAUUUJUMVYNWLWVQVYNVSZW
        VTWVCUUUMWVSVYPIVGUUUMWVRVYOUTWVQVYNFUSVUCXKYKVVMVVPWAAWWBWWEVFVYNWWNVF
        ZWVEWVPWWNVJZWTZULWWEXAZXBZUNWWEXCZUUUKWWFXBZAWWBWLWVTUMWLWSZWQZWWEWVTU
        MWLVVQAUUVAWWEVWDUPZVFUUVBWWEVFAFWVQWXLURZIVGVIZUMWLWSZUUVAUUVCAUUVEWVT
        UMWLAWVQWLVFZWTUUVDWVSIVGAYVAUUVGUUVDWVSVSWUTYVAUUVGWTUUVDFWVQUSURUTUPW
        VSFWVQWXLXURUVIFWVQVVRYDVVSYKVVTAWXQYVAIVEVFUUVFUUVCVFWXQAUUMWOWUTAIWVA
        XJUMWXLFIUUVFWWEWLWYFUUVFXHVWAYFVWBUUVAWWEWLWLWWEWWEWYEVWCZVWEZVWFWAVWG
        AUUULUUUSAVYNWVLDWKURVFUUULUUUSWTABWVFDVYLVYMWVHWVJUQWWEWWEWLVOUUDZWQZY
        NURZYOURZWWEWLUUVKXWHVYLWVGAXVMXWGWUEXGZXWHWVGAXWGXWNWVGVDVFXWOAVYRVDWU
        PJQUWMUWNVNZWNZXWHWVJWLVFXWDWVJUUVKVFXWHVYMWVIXWMXWPWNZYURWVJWLVOVWOUWI
        WLWLVJAWLVWHWOZUUVKWLVJZAWLUUVJVUTZWOWYEWWEWWEYOURZWLUUVKVWIZYNURZWWEWL
        YNURZUUVLYOURZUUVMWWEWLYPUPZVFZUUWGWLYQVFUUVKYQVFUUWCUUWEVSUUVHUUVHVWJU
        UVKWLVWJUUVTVWKWLUUVKWWEWWEUUWFUUWFYQYQVWLVWMUUWDWWEUUVLYOUUWGUUWDWWEVS
        UUVHWWEUUWFWLUUVIVWNYRXIVWPAVYLVOUSURVYLBWVFWVHWJDWKURAVYLWUEVWQABWVFDV
        YLVOVYLWVGUSUUWAWWEWLWLUUVNUUVOUUVRUUVRWYEUUWAWLWLVWIZYNURZUUWAUUWAUUWH
        YPUPZVFZUUWIUUWAVSUUWGUUWGUUWKUUVHUUVHWWEWWEWLWLVWRYMZUUWAUUWJUUWHUUWHU
        UWAUUWLVWEZVWNYRVWSZABVDVYLWJZDWKURZBWVFVYLWJZDWKURZVYLUUWPUUWOWVFXPZDW
        KURUUWRDWVFUUWOYSUUWSUUWQDWKWVFVDVJZUUWSUUWQVSDLUUSZBVDWVFVYLVWTYRXIVXA
        ABVDDVDVYLVYLAVYLVDVFXXSXXSUUWOVDVDYAURZVFWUDXYFXYFBVYLVDVDVXBYFNWUPDVS
        ZVYLVXDVXCWMAJDWKURZBWVFWVGWJZDWKURZVOAJWVFXPZDWKURUUXDUUXFDWVFJYSAUUXG
        UUXEDWKABVYRVDWVFJQXVSVXEYJVXFUAVLAUSUUWAWWEVXGURVFZVYLVOVXHZUUWHVFZUSU
        UXIUUWAWWEVXIURZUPVFWWEWYEVXJZAXVMVOWLVFZUUXJWUEVXKVYLVOWLWLVXLXTUUXIUS
        UUWAWWEUUWHUUWMVXMYBVXNVWBAVYMVOUSURVYMBWVFWVJWJDWKURAVYMWUGVWQABWVFDVY
        MVOVYMWVIUSUUWAWWEWLWLXWMXWPUUVRUUVRWYEUUWNABVDVYMWJZDWKURZBWVFVYMWJZDW
        KURZVYMUUXOUUXNWVFXPZDWKURUUXQDWVFUUXNYSUUXRUUXPDWKUUWTUUXRUUXPVSUUXABV
        DWVFVYMVWTYRXIVXAABVDDVDVYMVYMAVYMVDVFXXSXXSUUXNUUXBVFWUFXYFXYFBVYMVDVD
        VXBYFNUUXCVYMVXDVXCWMAKDWKURZBWVFWVIWJZDWKURZVOAKWVFXPZDWKURUUXSUUYADWV
        FKYSAUUYBUUXTDWKABVYRVDWVFKRXVSVXEYJVXFUBVLAUUXHVYMVOVXHZUUWHVFZUSUUYCU
        UXKUPVFUUXLAXWBUUXMUUYDWUGVXKVYMVOWLWLVXLXTUUYCUSUUWAWWEUUWHUUWMVXMYBVX
        NVWBAUQUUVMWWEVXGURVFVYLVYMVXHZUUWBVFZUQUUYEUUVMWWEVXIURUPVFWWEUUVLWYEU
        UVLXHVXOAXVMVYMUUVKVFZUUYFWUEAXWBWUJUUYGWUGWUNVYMWLVOVWOUWIVYLVYMWLUUVK
        VXLVKUUYEUQUUVMWWEUUWBUUWBUUVMUUWGUUVLUUVKYPUPVFZUUVMUUWBYPUPVFUUVHUUWG
        UUVSUUYHUUVHUUVTUUVKWWEWLVXPYMWWEUUVLWLUUVKVWRYMVWEVXMYBVXNAULUNWVFDVYN
        WVLWWEABWVFWVKWLWVLXWHWVHWVJUUVPUUVQYURWGUUUHVXQWVFWLVJAWVFVDWLUUXAXRVV
        AWOXUPWYEVXRUVEUWJUUURUUUTUNWWBWWEWWNWWBVSZUUUNUUUKUUUQWWFWWNWWBVYNVXSU
        UYIUUUPWWDULWWEUUYIUUUOWWCWVEWWNWWBWVPVYEVXTVYAVYBUYLYCVYCVYDAYTIVBURIV
        YQXDAIAIWVAVNVYFAYTVAIYTVDVFAVYGWOWVBUFYTVAXDVIAVYHWOVYIVYJVYK $.
    $}

    $( L'H&ocirc;pital's Rule for limits from the right.  If ` F ` and ` G `
       are differentiable real functions on ` ( A , B ) ` , and ` F ` and ` G `
       both approach 0 at ` A ` , and ` G ( x ) ` and ` G ` ' ` ( x ) ` are not
       zero on ` ( A , B ) ` , and the limit of
       ` F ` ' ` ( x ) / G ` ' ` ( x ) ` at ` A ` is ` C ` , then the limit
       ` F ( x ) / G ( x ) ` at ` A ` also exists and equals ` C ` .
       (Contributed by Mario Carneiro, 29-Dec-2016.) $)
    lhop1 $p |- ( ph -> C e. ( ( z e. ( A (,) B ) |->
      ( ( F ` z ) / ( G ` z ) ) ) limCC A ) ) $=
      ( wcel vy vd ve vv vx vr cioo co cv cdv cfv cdiv cmpt climc wne cmin cabs
      cr cc clt wbr wa wi wral crp wrex simpr rphalfcld breq2 imbi2d rexralbidv
      c2 wceq rspcv syl caddc cle cif crab cin eliooord adantl simprd biantrurd
      rabid sseldi ad3antrrr rpred adantr ltsubaddd cxr rexrd ad2antrr readdcld
      ioossre wb xrltmin syl3anc 3bitr4rd ifcl syl2anc simpld w3a elioo5 breq1d
      baibd wss eleq1 weq fveq2 oveq12d eqid ovex fvmpt3i oveq1d fveq2d cdm cc0
      wf crn wn a1i sylbid ralrimdva dvf feq2d mpbii ffvelrnda wfn ffn fnfvelrn
      expr sylan syl5ibcom necon3bd mpd divcld fmptd recnd ellimc3 ltled xrmin1
      syl31anc 3bitr4d rabbi2dva iooss2 dfss1 sylib eqtr3d eleq2d syl5bbr lbioo
      abssubge0d mtbiri bicomd imbi12d ralbiia oveq1 ralrab bitr4i adantrr cmul
      necon2ai raleqdv simprll iocssre ifclda ltaddrp2d mpbir2and xrmin2 elioc1
      cioc mpbir3and sseldd simprlr simprr lhop1lem rpcnd 2ne0 divcan2d breqtrd
      syl5bi expdimp sylibrd adantld com23 reximdva syld anim2d ax-resscn sstri
      2cn 3imtr4d ) AEBCDUGUHZBUIZURFUJUHZUKZUWOURGUJUHZUKZULUHZUMZCUNUHTZEBUWN
      UWOFUKZUWOGUKZULUHZUMZCUNUHTZSAEUSTZUAUIZCUOZUXICUPUHZUQUKZUBUIZUTVAZVBZU
      XIUXAUKZEUPUHZUQUKZUCUIZUTVAZVCZUAUWNVDUBVEVFZUCVEVDZVBUXHUDUIZCUOZUYDCUP
      UHZUQUKZUXMUTVAZVBZUYDUXFUKZEUPUHZUQUKZUEUIZUTVAZVCZUDUWNVDZUBVEVFZUEVEVD
      ZVBUXBUXGAUYCUYRUXHAUYCUYQUEVEAUYMVETZVBZUYCUXOUXRUYMVLULUHZUTVAZVCZUAUWN
      VDZUBVEVFZUYQUYTVUAVETZUYCVUEVCUYTUYMAUYSVGZVHZUYBVUEUCVUAVEUXSVUAVMZUYAV
      UCUBUAVEUWNVUIUXTVUBUXOUXSVUAUXRUTVIVJVKVNVOUYTVUDUYPUBVEUYTUXMVETZVBZVUD
      UYOUDUWNVUKUYDUWNTZVBZUYIVUDUYNVUMUYHVUDUYNVCZUYEVUMUYHVUDUYDFUKZUYDGUKZU
      LUHZEUPUHZUQUKZUYMUTVAZVCZVUNVUKVULUYHVVAVUKVULUYHVBZUYDCDUXMCVPUHZVQVAZD
      VVCVRZUGUHZTZVVAVVBUYDUYHUDUWNVSZTVUKVVGUYHUDUWNWEVUKVVHVVFUYDVUKUWNVVFVT
      ZVVHVVFVUKUYHUDUWNVVFVUMUYDVVEUTVAZUYFUXMUTVAZVVGUYHVUMUYDVVCUTVAZUYDDUTV
      AZVVLVBZVVKVVJVUMVVMVVLVUMCUYDUTVAZVVMVULVVOVVMVBVUKUYDCDWAWBZWCWDVUMUYDC
      UXMVUMUWNURUYDCDWOZVUKVULVGWFZACURTZUYSVUJVULHWGZVUKUXMURTZVULVUKUXMUYTVU
      JVGWHZWIWJVUMUYDWKTZDWKTZVVCWKTZVVJVVNWPVUMUYDVVRWLZAVWDUYSVUJVULIWGZVUKV
      WEVULVUKVVCVUKUXMCVWBAVVSUYSVUJHWMWNWLZWIZUYDDVVCWQWRWSVUMCWKTZVVEWKTZVWC
      VVOVVGVVJWPVUMCVVTWLVUMVWDVWEVWKVWGVWIVVDDVVCWKWTXAVWFVUMVVOVVMVVPXBZVWJV
      WKVWCXCVVGVVOVVJCVVEUYDXDXFUUCVUMUYGUYFUXMUTVUMCUYDVVTVVRVUMCUYDVVTVVRVWL
      UUAUUMXEUUDUUEVUKVVFUWNXGZVVIVVFVMVUKVWDVVEDVQVAZVWMAVWDUYSVUJIWMZVUKVWDV
      WEVWNVWOVWHDVVCUUBZXACVVEDUUFXAVVFUWNUUGUUHUUIZUUJUUKUYTVUJVVGVVAVUDUXIUW
      PUKZUXIUWRUKZULUHZEUPUHZUQUKZVUAUTVAZUAVVHVDZUYTVUJVVGVBZVBZVUTVUDUXNVXCV
      CZUAUWNVDVXDVUCVXGUAUWNUXIUWNTZUXOUXNVUBVXCVXHUXNUXOVXHUXJUXNVXHUXICUXICV
      MVXHCUWNTCDUULUXICUWNXHUUNUVCWDUUOVXHUXRVXBVUAUTVXHUXQVXAUQVXHUXPVWTEUPBU
      XIUWTVWTUWNUXABUAXIUWQVWRUWSVWSULUWOUXIUWPXJUWOUXIUWRXJXKUXAXLZUWQUWSULXM
      XNXOXPXEUUPUUQUYHUXNVXCUAUDUWNUDUAXIZUYGUXLUXMUTVXJUYFUXKUQUYDUXICUPUURXP
      XEUUSUUTVXFVXDVXCUAVVFVDZVUTVXFVXCUAVVHVVFUYTVUJVVHVVFVMVVGVWQUVAUVDUYTVX
      EVXKVUTUYTVXEVXKVBZVBZVUSVLVUAUVBUHZUYMUTVXMBUACDEVVECUFUIVLULUHVPUHZVUAF
      GUYDUFAVVSUYSVXLHWMZAVWDUYSVXLIWMZACDUTVAZUYSVXLJWMZAUWNURFXSUYSVXLKWMAUW
      NURGXSZUYSVXLLWMAUWPXQZUWNVMUYSVXLMWMAUWRXQZUWNVMUYSVXLNWMAXRFCUNUHTUYSVX
      LOWMAXRGCUNUHTUYSVXLPWMAXRGXTZTZYAZUYSVXLQWMAXRUWRXTZTZYAZUYSVXLRWMAUXBUY
      SVXLSWMUYTVUFVXLVUHWIVXMCVVCUVLUHZURVVEVXMVWJVVCURTVYIURXGVXMCVXPWLZVXMUX
      MCVXMUXMUYTVUJVVGVXKUVEZWHZVXPWNZCVVCUVFXAVXMVVEVYITZVWKCVVEUTVAZVVEVVCVQ
      VAZVXMVVDDVVCWKVXMVWDVVDVXQWIVXMVVDYAZVBZVVCVYRUXMCVXMVWAVYQVYLWIVXMVVSVY
      QVXPWIWNWLUVGVXMVYOVXRCVVCUTVAZVXSVXMCUXMVXPVYKUVHVXMVWJVWDVWEVYOVXRVYSVB
      WPVYJVXQVXMVVCVYMWLZCDVVCWQWRUVIVXMVWDVWEVYPVXQVYTDVVCUVJXAVXMVWJVWEVYNVW
      KVYOVYPXCWPVYJVYTCVVCVVEUVKXAUVMUVNVXMVWDVWEVWNVXQVYTVWPXAUYTVUJVVGVXKUVO
      UYTVXEVXKUVPVXOXLUVQUYTVXNUYMVMVXLUYTUYMVLUYTUYMVUGUVRVLUSTUYTUWLYBVLXRUO
      UYTUVSYBUVTWIUWAYLYCUWBYLYCUWCVULVUNVVAWPVUKVULUYNVUTVUDVULUYLVUSUYMUTVUL
      UYKVURUQVULUYJVUQEUPBUYDUXEVUQUWNUXFBUDXIUXCVUOUXDVUPULUWOUYDFXJUWOUYDGXJ
      XKUXFXLZUXCUXDULXMXNXOXPXEVJWBUWDUWEUWFYDUWGUWHYDUWIAUCUBUAUWNCEUXAABUWNU
      WTUSUXAAUWOUWNTZVBZUWQUWSAUWNUSUWOUWPAVYAUSUWPXSUWNUSUWPXSFYEAVYAUWNUSUWP
      MYFYGYHAUWNUSUWOUWRAVYBUSUWRXSUWNUSUWRXSZGYEAVYBUWNUSUWRNYFYGZYHWUCVYHUWS
      XRUOAVYHWUBRWIWUCVYGUWSXRWUCUWSVYFTZUWSXRVMVYGAUWRUWNYIZWUBWUFAWUDWUGWUEU
      WNUSUWRYJVOUWNUWOUWRYKYMUWSXRVYFXHYNYOYPYQVXIYRUWNUSXGAUWNURUSVVQUWJUWKYB
      ZACHYSZYTAUEUBUDUWNCEUXFABUWNUXEUSUXFWUCUXCUXDWUCUXCAUWNURUWOFKYHYSWUCUXD
      AUWNURUWOGLYHYSWUCVYEUXDXRUOAVYEWUBQWIWUCVYDUXDXRWUCUXDVYCTZUXDXRVMVYDAGU
      WNYIZWUBWUJAVXTWUKLUWNURGYJVOUWNUWOGYKYMUXDXRVYCXHYNYOYPYQWUAYRWUHWUIYTUW
      MYP $.
  $}

  ${
    $d a x y z A $.  $d a x y z B $.  $d a x y z C $.  $d a x y z ph $.
    $d a x y z F $.  $d a x y z G $.
    lhop2.a $e |- ( ph -> A e. RR* ) $.
    lhop2.b $e |- ( ph -> B e. RR ) $.
    lhop2.l $e |- ( ph -> A < B ) $.
    lhop2.f $e |- ( ph -> F : ( A (,) B ) --> RR ) $.
    lhop2.g $e |- ( ph -> G : ( A (,) B ) --> RR ) $.
    lhop2.if $e |- ( ph -> dom ( RR _D F ) = ( A (,) B ) ) $.
    lhop2.ig $e |- ( ph -> dom ( RR _D G ) = ( A (,) B ) ) $.
    lhop2.f0 $e |- ( ph -> 0 e. ( F limCC B ) ) $.
    lhop2.g0 $e |- ( ph -> 0 e. ( G limCC B ) ) $.
    lhop2.gn0 $e |- ( ph -> -. 0 e. ran G ) $.
    lhop2.gd0 $e |- ( ph -> -. 0 e. ran ( RR _D G ) ) $.
    lhop2.c $e |- ( ph -> C e. ( ( z e. ( A (,) B ) |->
      ( ( ( RR _D F ) ` z ) / ( ( RR _D G ) ` z ) ) ) limCC B ) ) $.
    $( L'H&ocirc;pital's Rule for limits from the left.  If ` F ` and ` G ` are
       differentiable real functions on ` ( A , B ) ` , and ` F ` and ` G `
       both approach 0 at ` B ` , and ` G ( x ) ` and ` G ` ' ` ( x ) ` are not
       zero on ` ( A , B ) ` , and the limit of
       ` F ` ' ` ( x ) / G ` ' ` ( x ) ` at ` B ` is ` C ` , then the limit
       ` F ( x ) / G ( x ) ` at ` B ` also exists and equals ` C ` .
       (Contributed by Mario Carneiro, 29-Dec-2016.) $)
    lhop2 $p |- ( ph -> C e. ( ( z e. ( A (,) B ) |->
      ( ( F ` z ) / ( G ` z ) ) ) limCC B ) ) $=
      ( cr va vx vy cv clt wbr wa cioo co cfv cdiv cmpt climc wcel wss wrex cxr
      cq rexrd syl3anc wne simpr wb adantr ad2antrr elioore adantl iooneg mpbid
      cneg adantrr recnd negnegd renegcld cle syl2anc mpd ffvelrnd cc0 crn wceq
      wf wn wfn ax-resscn fss sylancl ffn syl fnfvelrn eleq1 syl5ibcom necon3bd
      cc divcld cres limcresi ioossre resmpt ax-mp oveq1i sseqtri negcncf negeq
      eqid mp1i cnmptlimc sseldi ltnegd fmptd cdv cdm c1 cmul cvv a1i ffvelrnda
      reex fvex ax-1cn feqmptd fveq2 eqtrd mpteq2dva oveq1d eleqtrd impr limcco
      pm2.21d oveq12d nfcv nfov fvmpt2 syl5eq eleqtrrd fveq2d cun ctop cpnf cin
      qssre qbtwnxr ssrexv mpsyl simprl eqeltrd mpbird simprrl wi xrltle iooss1
      sselda syldan ccncf simprrr cpr prid1 neg1cn ccnfld ctopn tgioo2 iooretop
      ctg dvmptid dvmptres oveq2d dvf feq2d mpbii eqtr3d dvmptco mulcomd mulm1d
      dvmptneg dmeqd negex dmmpti syl6eq eqeltrrd eliooord ltnegcon1d ltned frn
      simpld neneqd ssneldd rneqd eleq2d eqcom negeq0d sylbird syl5bi rexlimdva
      elrnmpti sylbid mtod sylan nfmpt1 nffv cbvmpt fveq1d mpan2 sylan9eq lhop1
      div2negd nffvmpt1 simprd gtned csn crest sstri cnt ssun2 snssg cnfldtopon
      mpbiri ctopon snssd unssd resttopon sylancr topontop indi cif pnfxr iooin
      syl6ss syl22anc xrltnle iffalse ltpnf mpbir2and dfss1 sylib uneq12d retop
      elioopnf ssex elrestr rerest isopn3i limcres 3eqtr2d rexlimddv ) ACUAUDZU
      EUFZVUEDUEUFZUGZEBCDUHUIZBUDZFUJZVUJGUJZUKUIZULZDUMUIZUNUATURTUOAVUHUAURU
      PZVUHUATUPUUAACUQUNZDUQUNZCDUEUFVUPHADIUSZJUACDUUBUTVUHUAURTUUCUUDAVUETUN
      ZVUHUGZUGZEBVUEDUHUIZVUJVJZVJZFUJZVVEGUJZUKUIZULZDUMUIZVUOVVBBUBVVCDVJZVU
      EVJZUHUIZVVKEVVDUBUDZVJZFUJZVVOGUJZUKUIZVVHDVVBVUJVVCUNZVVDVVMUNZVVDVVKVA
      VVBVVSUGZVVSVVTVVBVVSVBVWAVUTDTUNZVUJTUNZVVSVVTVCVVBVUTVVSAVUTVUHUUEZVDAV
      WBVVAVVSIVEZVVSVWCVVBVUJVUEDVFVGZVUEDVUJVHUTVIVKVVBVVNVVMUNZUGZVVPVVQVWHV
      VPVWHVUITVVOFAVUITFWBZVVAVWGKVEVVBVWGVVOVVCUNZVVOVUIUNZVWHVWJVVOVJZVVMUNZ
      VWHVWLVVNVVMVWHVVNVWHVVNVWGVVNTUNZVVBVVNVVKVVLVFVGZVLZVMVVBVWGVBZUUFVWHVU
      TVWBVVOTUNVWJVWMVCVVBVUTVWGVWDVDAVWBVVAVWGIVEZVWHVVNVWOVNZVUEDVVOVHUTUUGV
      VBVVCVUIVVOVVBVUQCVUEVOUFZVVCVUIUOZAVUQVVAHVDZVVBVUFVWTAVUTVUFVUGUUHZVVBV
      UQVUEUQUNZVUFVWTUUIVXBVVBVUEVWDUSZCVUEUUJVPVQCVUEDUUKVPZUULUUMZVRZVLVWHVV
      QVWHVUITVVOGAVUITGWBZVVAVWGLVEVXGVRZVLVWHVSGVTZUNZWCZVVQVSVAAVXMVVAVWGQVE
      VWHVXLVVQVSVWHVVQVXKUNZVVQVSWAZVXLVWHGVUIWDZVWKVXNVWHVUIWNGWBZVXPVVBVXQVW
      GVVBVXITWNUOZVXQAVXIVVALVDZWEVUITWNGWFWGZVDVUIWNGWHZWIVXGVUIVVOGWJVPZVVQV
      SVXKWKWLWMVQWOVVBBTVVDULZDUMUIZBVVCVVDULZDUMUIZVVKVYDVYCVVCWPZDUMUIVYFDVV
      CVYCWQVYGVYEDUMVVCTUOVYGVYEWAVUEDWRBTVVCVVDWSWTXAXBVVBBTDWNVVDVVKVXRVYCTW
      NUUNUIZUNVVBWEBTVYCVYCXEXCXFAVWBVVAIVDZVUJDXDXGXHVVBEUCVVMUCUDZUBVVMVVPUL
      ZUJZVYJUBVVMVVQULZUJZUKUIZULZVVKUMUIUBVVMVVRULZVVKUMUIVVBUCVVKVVLEVYKVYMV
      VBDVYIVNZVVBVVLVVBVUEVWDVNUSVVBVUGVVKVVLUEUFAVUTVUFVUGUUOZVVBVUEDVWDVYIXI
      VIVVBUBVVMVVPTVYKVXHVYKXEZXJVVBUBVVMVVQTVYMVXJVYMXEZXJVVBTVYKXKUIZXLUBVVM
      VVOTFXKUIZUJZVJZULZXLVVMVVBWUBWUFVVBWUBUBVVMWUDXMVJZXNUIZULWUFVVBUBUCVVOW
      UGVYJFUJZVYJWUCUJZTTVVPWUDWNXOVVMVUITTWNUUPUNVVBTWNXRUUQXPZWUKVXGWUGWNUNV
      WHUURXPZVVBVYJVUIUNUGZWUIVVBVUITVYJFAVWIVVAKVDZXQVLZWUJXOUNWUMVYJWUCXSXPV
      VBUBVVNXMTWNVVMWUKVWPXMWNUNZVWHXTXPVVBUBVVNXMTUHVTUVCUJZUUSUUTUJZWNTVVMWU
      KVVBVWNUGZVVNVVBVWNVBVLWUPWUSXTXPVVBUBTWUKUVDVVMTUOZVVBVVKVVLWRZXPWURWURX
      EZUVAWVBVVMWUQUNVVBVVKVVLUVBXPUVEUVNZVVBWUCTUCVUIWUIULZXKUIUCVUIWUJULVVBF
      WVDTXKVVBUCVUITFWUNYAZUVFVVBUCVUIWNWUCVVBWUCXLZWNWUCWBVUIWNWUCWBZFUVGVVBW
      VFVUIWNWUCAWVFVUIWAVVAMVDUVHUVIZYAUVJVYJVVOFYBZVYJVVOWUCYBUVKVVBUBVVMWUHW
      UEVWHWUHWUGWUDXNUIWUEVWHWUDWUGVWHVUIWNVVOWUCVVBWVGVWGWVHVDVXGVRZWULUVLVWH
      WUDWVJUVMYCYDYCZUVOUBVVMWUEWUFWUDUVPZWUFXEZUVQUVRVVBTVYMXKUIZXLUBVVMVVOTG
      XKUIZUJZVJZULZXLVVMVVBWVNWVRVVBWVNUBVVMWVPWUGXNUIZULWVRVVBUBUCVVOWUGVYJGU
      JZVYJWVOUJZTTVVQWVPWNXOVVMVUIWUKWUKVXGWULWUMWVTVVBVUITVYJGVXSXQVLZWWAXOUN
      WUMVYJWVOXSXPWVCVVBWVOTUCVUIWVTULZXKUIUCVUIWWAULVVBGWWCTXKVVBUCVUITGVXSYA
      ZUVFVVBUCVUIWNWVOVVBWVOXLZWNWVOWBVUIWNWVOWBZGUVGVVBWWEVUIWNWVOAWWEVUIWAVV
      ANVDUVHUVIZYAUVJVYJVVOGYBZVYJVVOWVOYBUVKVVBUBVVMWVSWVQVWHWVSWUGWVPXNUIWVQ
      VWHWVPWUGVWHVUIWNVVOWVOVVBWWFVWGWWGVDZVXGVRZWULUVLVWHWVPWWJUVMYCYDYCZUVOU
      BVVMWVQWVRWVPUVPZWVRXEZUVQUVRVVBUBUCVVMVUIDVSVVOWUIVVPVVKVVBVWGVWKVVODVAV
      XGVKZWUOVVBUBTVVOULZVVKUMUIZUBVVMVVOULZVVKUMUIZDWWPWWOVVMWPZVVKUMUIWWRVVK
      VVMWWOWQWWSWWQVVKUMWUTWWSWWQWAWVAUBTVVMVVOWSWTXAXBVVBVVKVJZDWWPVVBDVVBDVY
      IVLVMVVBUBTVVKWNVVOWWTVXRWWOVYHUNVVBWEUBTWWOWWOXEXCXFVYRVVNVVKXDXGUVSXHZV
      VBVSFDUMUIZWVDDUMUIAVSWXBUNVVAOVDVVBFWVDDUMWVEYEYFWVIVVBVWGVVODWAZVVPVSWA
      ZVWHWXCWXDVWHVVODVWHVVODVWSVWHDVVNVWRVWOVWHVVKVVNUEUFZVVNVVLUEUFZVWGWXEWX
      FUGVVBVVNVVKVVLUVTVGUWDUWAUWBUWEZYIYGYHVVBUBUCVVMVUIDVSVVOWVTVVQVVKWWNWWB
      WXAVVBVSGDUMUIZWWCDUMUIAVSWXHUNVVAPVDVVBGWWCDUMWWDYEYFWWHVVBVWGWXCVXOVWHW
      XCVXOWXGYIYGYHVVBVYMVTZVXKVSVVBVVMVXKVYMWBWXIVXKUOVVBUBVVMVVQVXKVYMVYBWUA
      XJVVMVXKVYMUWCWIAVXMVVAQVDUWFVVBVSWVNVTZUNZVSWVOVTZUNZAWXMWCZVVARVDVVBWXK
      VSWVRVTZUNZWXMVVBWXJWXOVSVVBWVNWVRWWKUWGUWHWXPVSWVQWAZUBVVMUPVVBWXMUBVVMW
      VQVSWVRWWMWWLUWNVVBWXQWXMUBVVMWXQWVQVSWAZVWHWXMVSWVQUWIVWHWXRWVPVSWAZWXMV
      WHWVPWWJUWJVWHWVPWXLUNZWXSWXMVWHWVOVUIWDZVWKWXTVWHWWFWYAWWIVUIWNWVOWHZWIV
      XGVUIVVOWVOWJVPWVPVSWXLWKWLZUWKUWLUWMUWLUWOUWPVVBEUBVVMWUDWVPUKUIZULZVVKU
      MUIUCVVMVYJWUBUJZVYJWVNUJZUKUIZULZVVKUMUIVVBUBBVVMVUIDEVVOVUJWUCUJZVUJWVO
      UJZUKUIZWYDVVKWWNVVBVUJVUIUNZUGZWYJWYKVVBVUIWNVUJWUCWVHXQVVBVUIWNVUJWVOWW
      GXQWYNWXNWYKVSVAAWXNVVAWYMRVEWYNWXMWYKVSWYNWYKWXLUNZWYKVSWAWXMVVBWYAWYMWY
      OVVBWWFWYAWWGWYBWIVUIVUJWVOWJUWQWYKVSWXLWKWLWMVQWOWXAAEBVUIWYLULDUMUIUNVV
      ASVDVUJVVOWAWYJWUDWYKWVPUKVUJVVOWUCYBVUJVVOWVOYBYJVVBVWGWXCWYDEWAZVWHWXCW
      YPWXGYIYGYHVVBWYIWYEVVKUMVVBWYIUBVVMVVNWUBUJZVVNWVNUJZUKUIZULWYEUCUBVVMWY
      HWYSUBWYFWYGUKUBVYJWUBUBTVYKXKUBTYKZUBXKYKZUBVVMVVPUWRYLUBVYJYKZUWSUBUKYK
      ZUBVYJWVNUBTVYMXKWYTXUAUBVVMVVQUWRYLXUBUWSYLUCWYSYKVYJVVNWAZWYFWYQWYGWYRU
      KVYJVVNWUBYBVYJVVNWVNYBYJUWTVVBUBVVMWYSWYDVWHWYSWUEWVQUKUIWYDVWHWYQWUEWYR
      WVQUKVVBVWGWYQVVNWUFUJZWUEVVBVVNWUBWUFWVKUXAVWGWUEXOUNXUEWUEWAWVLUBVVMWUE
      XOWUFWVMYMUXBUXCVVBVWGWYRVVNWVRUJZWVQVVBVVNWVNWVRWWKUXAVWGWVQXOUNXUFWVQWA
      WWLUBVVMWVQXOWVRWWMYMUXBUXCYJVWHWUDWVPWVJWWJVWHWXNWVPVSVAAWXNVVAVWGRVEVWH
      WXMWVPVSWYCWMVQUXEYCYDYNYEYOUXDVVBVYPVYQVVKUMVVBVYPUBVVMVVNVYKUJZVVNVYMUJ
      ZUKUIZULVYQUCUBVVMVYOXUIUBVYLVYNUKUBVVMVVPVYJUXFXUCUBVVMVVQVYJUXFYLUCXUIY
      KXUDVYLXUGVYNXUHUKVYJVVNVYKYBVYJVVNVYMYBYJUWTVVBUBVVMXUIVVRVWHXUGVVPXUHVV
      QUKVWHVWGVVPXOUNXUGVVPWAVWQVVOFXSUBVVMVVPXOVYKVYTYMWGVWHVWGVVQXOUNXUHVVQW
      AVWQVVOGXSUBVVMVVQXOVYMWUAYMWGYJYDYNYEYFVVNVVDWAZVVPVVFVVQVVGUKXUJVVOVVEF
      VVNVVDXDZYPXUJVVOVVEGXUKYPYJVVBVVSVVDVVKWAZVVHEWAZVWAXULXUMVWAVVDVVKVWAVV
      KVVDVVBVVKTUNVVSVYRVDVWAVUJDUEUFZVVKVVDUEUFVWAVUEVUJUEUFZXUNVVSXUOXUNUGVV
      BVUJVUEDUVTVGUXGVWAVUJDVWFVWEXIVIUXHUWEYIYGYHVVBVVJBVVCVUMULZDUMUIVUNVVCW
      PZDUMUIVUOVVBVVIXUPDUMVVBBVVCVVHVUMVWAVVFVUKVVGVULUKVWAVVEVUJFVWAVUJVWAVU
      JVWFVLVMZYPVWAVVEVUJGXURYPYJYDYEVVBXUQXUPDUMVVBVXAXUQXUPWAVXFBVUIVVCVUMWS
      WIYEVVBVUIDVVCVUNWURVUIDUXIZYQZUXJUIZWURVVBBVUIVUMWNVUNWYNVUKVULVVBVUIWNV
      UJFVVBVWIVXRVUIWNFWBWUNWEVUITWNFWFWGXQVVBVUIWNVUJGVXTXQWYNVXMVULVSVAAVXMV
      VAWYMQVEWYNVXLVULVSWYNVULVXKUNZVULVSWAVXLVVBVXPWYMXVBVVBVXQVXPVXTVYAWIVUI
      VUJGWJUWQVULVSVXKWKWLWMVQWOVUNXEXJVXFVUIWNUOVVBVUITWNCDWRZWEUXKXPWVBXVAXE
      VVBDVVCXUSYQZXVDXVAUXLUJUJZVVBDXVDUNZXUSXVDUOZXUSVVCUXMVVBVWBXVFXVGVCVYID
      XVDTUXNWIUXPVVBXVAYRUNZXVDXVAUNXVEXVDWAVVBXVAXUTUXQUJUNZXVHVVBWURWNUXQUJU
      NXUTWNUOXVIWURWVBUXOVVBXUTTWNVVBVUIXUSTVUITUOVVBXVCXPVVBDTVYIUXRUXSZWEUYG
      XUTWURWNUXTUYAXUTXVAUYBWIVVBXVDWUQXUTUXJUIZXVAVVBVUEYSUHUIZXUTYTZXVDXVKVV
      BXVMXVLVUIYTZXVLXUSYTZYQXVDXVLVUIXUSUYCVVBXVNVVCXVOXUSVVBXVNVUECVOUFZCVUE
      UYDZYSDVOUFZYSDUYDZUHUIZVVCVVBVXDYSUQUNZVUQVURXVNXVTWAVXEXWAVVBUYEXPVXBAV
      URVVAVUSVDZVUEYSCDUYFUYHVVBXVQVUEXVSDUHVVBXVPWCZXVQVUEWAVVBVUFXWCVXCVVBVU
      QVXDVUFXWCVCVXBVXECVUEUYIVPVIXVPCVUEUYJWIVVBXVRWCZXVSDWAVVBDYSUEUFZXWDVVB
      VWBXWEVYIDUYKWIVVBVURXWAXWEXWDVCXWBUYEDYSUYIWGVIXVRYSDUYJWIYJYCVVBXUSXVLU
      OXVOXUSWAVVBDXVLVVBDXVLUNZVWBVUGVYIVYSVVBVXDXWFVWBVUGUGVCVXEVUEDUYQWIUYLU
      XRXUSXVLUYMUYNUYOYNVVBWUQYRUNZXUTXOUNZXVLWUQUNZXVMXVKUNXWGVVBUYPXPVVBXUTT
      UOZXWHXVJXUTTXRUYRWIXWIVVBVUEYSUVBXPXVLXUTWUQYRXOUYSUTUVSVVBXWJXVAXVKWAXV
      JXUTWUQWURWVBWUQXEUYTWIYOXVDXVAVUAVPYOVUBVUCYFVUD $.
  $}

  ${
    $d r z B $.  $d r z C $.  $d r z D $.  $d r z F $.  $d r z ph $.
    $d r z G $.  $d r z I $.
    lhop.a $e |- ( ph -> A C_ RR ) $.
    lhop.f $e |- ( ph -> F : A --> RR ) $.
    lhop.g $e |- ( ph -> G : A --> RR ) $.
    lhop.i $e |- ( ph -> I e. ( topGen ` ran (,) ) ) $.
    lhop.b $e |- ( ph -> B e. I ) $.
    lhop.d $e |- D = ( I \ { B } ) $.
    lhop.if $e |- ( ph -> D C_ dom ( RR _D F ) ) $.
    lhop.ig $e |- ( ph -> D C_ dom ( RR _D G ) ) $.
    lhop.f0 $e |- ( ph -> 0 e. ( F limCC B ) ) $.
    lhop.g0 $e |- ( ph -> 0 e. ( G limCC B ) ) $.
    lhop.gn0 $e |- ( ph -> -. 0 e. ( G " D ) ) $.
    lhop.gd0 $e |- ( ph -> -. 0 e. ( ( RR _D G ) " D ) ) $.
    lhop.c $e |- ( ph -> C e. ( ( z e. D |->
      ( ( ( RR _D F ) ` z ) / ( ( RR _D G ) ` z ) ) ) limCC B ) ) $.
    $( L'H&ocirc;pital's Rule.  If ` I ` is an open set of the reals, ` F ` and
       ` G ` are real functions on ` A ` containing all of ` I ` except
       possibly ` B ` , which are differentiable everywhere on ` I \ { B } ` ,
       ` F ` and ` G ` both approach 0, and the limit of
       ` F ` ' ` ( x ) / G ` ' ` ( x ) ` at ` B ` is ` C ` , then the limit
       ` F ( x ) / G ( x ) ` at ` B ` also exists and equals ` C ` .
       (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    lhop $p |- ( ph -> C e. ( ( z e. D |->
      ( ( F ` z ) / ( G ` z ) ) ) limCC B ) ) $=
      ( vr cv cmin cr cres cfv co wss crp cdiv cmpt climc wcel cioo crn syl3anc
      eqid a1i wa wceq syl6sseqr syl sseldd cdif cin adantr rexrd wf cun uneq1i
      cxr clt wbr syl5eq c0 wb syl2anc wn eqtri sylancl mpbid syl5sseqr cdv cdm
      ax-resscn fss sstrd fssres cnt ioossre dvres syl22anc ctop retop iooretop
      cc isopn3i mp2an reseq2i syl6eq dmeqd ssdmres sylib eqtrd limcresi sseldi
      df-ima imass2 syl5eqssr ssneldd rneqd syl6eqr eqsstrd resmpt fveq1d fvres
      cc0 cima sylan9eq oveq12d mpteq2dva eqtr4d oveq1d syl5sseq mpteq2ia crest
      eleqtrrd sselda ffvelrnda syldan recnd fmptd undif1 ssequn2 fveq2d ctopon
      mpd sylancr cabs ccom cxp cbl wrex cxmt ctg rexmet cmopn tgioo caddc cuni
      mopni2 elssuni uniretop bl2ioo syl2an sseq1d csn simprl resubcld ltsubrpd
      rpre rpred ssun1 unass uncom eqtr3i readdcld ltaddrpd syl32anc w3a elioo2
      ioojoin mpbir3and snssd incom ubioo lbioo pm3.2ni elun mtbir disjsn mpbir
      uneqdifeq ssdif ad2antll dvbss ccnfld ctopn tgioo2 lhop2 ssun2 lhop1 elin
      wo sylanbrc wne wfn simpr fnfvima eleq1 syl5ibcom necon3bd divcld adantlr
      ffn difss eqsstri syl6ss syl5ss simprr oveq2d rerest cnfldtopon resttopon
      topontop eqeltrrd restopn2 mpbir2and limcres sstri feq2d 3eqtr3rd eleqtrd
      limcun expr sylbid rexlimdva ) ADUCUDZUUAUEUUBUFUFUUCUGZUUDUHUIZIUJZUCUKU
      UEZEBFBUDZGUHZUYOHUHZULUIZUMZDUNUIZUOZAUYKUFUUFUHUOZIUPUQUUGUHZUOZDIUOUYN
      VUBAUYKUYKUSZUUHUTMNUCIUYKDVUCUFUYKUYKUUIUHZVUEVUFUSUUJUUMURAUYMVUAUCUKAU
      YJUKUOZVAZUYMDUYJUEUIZDUYJUUKUIZUPUIZIUJZVUAVUHUYLVUKIADUFUOZUYJUFUOUYLVU
      KVBVUGAIUFDAVUDIUFUJZMVUDIVUCUULUFIVUCUUNUUOVCVDZNVEZUYJUVCDUYJUYKVUEUUPU
      UQUURAVUGVULVUAAVUGVULVAZVAZEBVUKDUUSZVFZUYRUMZVUIDUPUIZUGZDUNUIZVVADVUJU
      PUIZUGZDUNUIZVGZUYTVUREVVDUOEVVGUOEVVHUOVUREBVVBUYOGVVBUGZUHZUYOHVVBUGZUH
      ZULUIZUMZDUNUIVVDVURBVUIDEVVIVVKVURVUIVURDUYJAVUMVUQVUPVHZVURUYJAVUGVULUU
      TZUVDZUVAVIZVVOVURDUYJVVOVVPUVBZVURCUFGVJZVVBCUJZVVBUFVVIVJAVVTVUQKVHZVUR
      VVBVUTCVURVVBVVEVKZVVBVUTVVBVVEUVEVURVUSVWCVKZVUKVBZVUTVWCVBZVURVWDVVBVUS
      VKZVVEVKZVUKVUSVVBVKZVVEVKVWDVWHVUSVVBVVEUVFVWIVWGVVEVUSVVBUVGVLUVHVURVUI
      VMUOZDVMUOVUJVMUOZVUIDVNVOZDVUJVNVOZVWHVUKVBVVRVURDVVOVIVURVUJVURDUYJVVOV
      VQUVIVIZVVSVURDUYJVVOVVPUVJZVUIDVUJUVNUVKVPVURVUSVUKUJZVUSVWCVGZVQVBVWEVW
      FVRVURDVUKVURDVUKUOZVUMVWLVWMVVOVVSVWOVURVWJVWKVWRVUMVWLVWMUVLVRVVRVWNVUI
      VUJDUVMVSUVOZUVPZVWQVWCVUSVGZVQVUSVWCUVQVXAVQVBDVWCUOZVTVXBDVVBUOZDVVEUOZ
      UWPVXCVXDVUIDUVRDVUJUVSUVTDVVBVVEUWAUWBVWCDUWCUWDWAVUSVWCVUKUWEWBWCZWDZVU
      RVUTFCVURVUTIVUSVFZFVULVUTVXGUJAVUGVUKIVUSUWFUWGOVCZAFCUJZVUQAFUFGWEUIZWF
      ZCPACUFGUFWRUJZAWGUTAVVTVXLCWRGVJZKWGCUFWRGWHWBZJUWHWIZVHWIZWIZCUFVVBGWJV
      SVURCUFHVJZVWAVVBUFVVKVJAVXRVUQLVHZVXQCUFVVBHWJVSVURUFVVIWEUIZWFVXJVVBUGZ
      WFZVVBVURVXTVYAVURVXTVXJVVBVUCWKUHZUHZUGZVYAVURVXLVXMCUFUJZVVBUFUJZVXTVYE
      VBVXLVURWGUTZAVXMVUQVXNVHZAVYFVUQJVHZVYGVURVUIDWLZUTZCVVBUFVUCGUWIUWJUHZV
      YMUSZVYMVYNUWKZWMWNVYDVVBVXJVUCWOUOZVVBVUCUOVYDVVBVBWPVUIDWQVVBVUCWSWTZXA
      XBZXCVURVVBVXKUJVYBVVBVBVURVVBFVXKVURVVBVUTFVXFVXHWIZAFVXKUJVUQPVHZWIVVBV
      XJXDXEXFVURUFVVKWEUIZWFUFHWEUIZVVBUGZWFZVVBVURWUAWUCVURWUAWUBVYDUGZWUCVUR
      VXLCWRHVJZVYFVYGWUAWUEVBVYHAWUFVUQAVXRVXLWUFLWGCUFWRHWHWBVHZVYJVYLCVVBUFV
      UCHVYMVYNVYOWMWNVYDVVBWUBVYQXAXBZXCVURVVBWUBWFZUJWUDVVBVBVURVVBFWUIVYSAFW
      UIUJVUQQVHZWIVVBWUBXDXEXFVURGDUNUIZVVIDUNUIXSDVVBGXGAXSWUKUOVUQRVHZXHVURH
      DUNUIZVVKDUNUIXSDVVBHXGAXSWUMUOVUQSVHZXHVURVVKUQZHFXTZXSVURWUOHVVBXTZWUPH
      VVBXIVURVVBFUJZWUQWUPUJVYSVVBFHXJVDXKAXSWUPUOZVTZVUQTVHZXLVURWUAUQZWUBFXT
      ZXSVURWVBWUBVVBXTZWVCVURWVBWUCUQWVDVURWUAWUCWUHXMWUBVVBXIXNVURWURWVDWVCUJ
      VYSVVBFWUBXJVDXOAXSWVCUOVTVUQUAVHZXLVURBFUYOVXJUHZUYOWUBUHZULUIZUMZDUNUIZ
      BVVBUYOVXTUHZUYOWUAUHZULUIZUMZDUNUIZEVURWVIVVBUGZDUNUIWVJWVODVVBWVIXGVURW
      VPWVNDUNVURWVPBVVBWVHUMZWVNVURWURWVPWVQVBVYSBFVVBWVHXPVDVURBVVBWVMWVHVURU
      YOVVBUOZVAWVKWVFWVLWVGULVURWVRWVKUYOVYAUHWVFVURUYOVXTVYAVYRXQUYOVVBVXJXRY
      AVURWVRWVLUYOWUCUHWVGVURUYOWUAWUCWUHXQUYOVVBWUBXRYAYBYCYDYEYFAEWVJUOVUQUB
      VHZVEUWLVURVVCVVNDUNVURVVCBVVBUYRUMZVVNVURVVBVUTUJVVCWVTVBVXFBVUTVVBUYRXP
      VDBVVBVVMUYRWVRVVJUYPVVLUYQULUYOVVBGXRUYOVVBHXRYBYGXNYEYIVUREBVVEUYOGVVEU
      GZUHZUYOHVVEUGZUHZULUIZUMZDUNUIVVGVURBDVUJEWWAWWCVVOVWNVWOVURVVTVVECUJZVV
      EUFWWAVJVWBVURVVEVUTCVURVWCVVEVUTVVEVVBUWMVXEWDZVXPWIZCUFVVEGWJVSVURVXRWW
      GVVEUFWWCVJVXSWWICUFVVEHWJVSVURUFWWAWEUIZWFVXJVVEUGZWFZVVEVURWWJWWKVURWWJ
      VXJVVEVYCUHZUGZWWKVURVXLVXMVYFVVEUFUJZWWJWWNVBVYHVYIVYJWWOVURDVUJWLZUTZCV
      VEUFVUCGVYMVYNVYOWMWNWWMVVEVXJVYPVVEVUCUOWWMVVEVBWPDVUJWQVVEVUCWSWTZXAXBZ
      XCVURVVEVXKUJWWLVVEVBVURVVEFVXKVURVVEVUTFWWHVXHWIZVYTWIVVEVXJXDXEXFVURUFW
      WCWEUIZWFWUBVVEUGZWFZVVEVURWXAWXBVURWXAWUBWWMUGZWXBVURVXLWUFVYFWWOWXAWXDV
      BVYHWUGVYJWWQCVVEUFVUCHVYMVYNVYOWMWNWWMVVEWUBWWRXAXBZXCVURVVEWUIUJWXCVVEV
      BVURVVEFWUIWWTWUJWIVVEWUBXDXEXFVURWUKWWADUNUIXSDVVEGXGWULXHVURWUMWWCDUNUI
      XSDVVEHXGWUNXHVURWWCUQZWUPXSVURWXFHVVEXTZWUPHVVEXIVURVVEFUJZWXGWUPUJWWTVV
      EFHXJVDXKWVAXLVURWXAUQZWVCXSVURWXIWUBVVEXTZWVCVURWXIWXBUQWXJVURWXAWXBWXEX
      MWUBVVEXIXNVURWXHWXJWVCUJWWTVVEFWUBXJVDXOWVEXLVURWVJBVVEUYOWWJUHZUYOWXAUH
      ZULUIZUMZDUNUIZEVURWVIVVEUGZDUNUIWVJWXODVVEWVIXGVURWXPWXNDUNVURWXPBVVEWVH
      UMZWXNVURWXHWXPWXQVBWWTBFVVEWVHXPVDVURBVVEWXMWVHVURUYOVVEUOZVAWXKWVFWXLWV
      GULVURWXRWXKUYOWWKUHWVFVURUYOWWJWWKWWSXQUYOVVEVXJXRYAVURWXRWXLUYOWXBUHWVG
      VURUYOWXAWXBWXEXQUYOVVEWUBXRYAYBYCYDYEYFWVSVEUWNVURVVFWWFDUNVURVVFBVVEUYR
      UMZWWFVURVVEVUTUJVVFWXSVBWWHBVUTVVEUYRXPVDBVVEWWEUYRWXRWWBUYPWWDUYQULUYOV
      VEGXRUYOVVEHXRYBYGXNYEYIEVVDVVGUWOUWQVURUYSVUTUGZDUNUIVVADUNUIUYTVVHVURWX
      TVVADUNVURVUTFUJWXTVVAVBVXHBFVUTUYRXPVDYEVURFDVUTUYSVYMFVUSVKZYHUIZVYMVUR
      BFUYRWRUYSAUYOFUOZUYRWRUOZVUQAWYCVAZUYPUYQWYEUYPAWYCUYOCUOZUYPUFUOAFCUYOV
      XOYJZACUFUYOGKYKYLYMWYEUYQAWYCWYFUYQUFUOWYGACUFUYOHLYKYLYMWYEWUTUYQXSUWRA
      WUTWYCTVHWYEWUSUYQXSWYEUYQWUPUOZUYQXSVBWUSWYEHCUWSZVXIWYCWYHAWYIWYCAVXRWY
      ILCUFHUXGVDVHAVXIWYCVXOVHAWYCUWTCFHUYOUXAURUYQXSWUPUXBUXCUXDYSUXEUXFZUYSU
      SYNVXHAFWRUJVUQAFIWRFVXGIOIVUSUXHUXIAIUFWRVUOWGUXJZUXKVHVYNWYBUSVURDVUKWY
      BWKUHZUHZVUTVUSVKZWYLUHVURDVUKWYMVWSVURWYMVUKVUCIYHUIZWKUHZUHZVUKVURVUKWY
      LWYPVURWYBWYOWKVURWYBVYMIYHUIZWYOVURWYAIVYMYHVURWYAIVUSVKZIWYAVXGVUSVKWYS
      FVXGVUSOVLIVUSYOWAVURVUSIUJWYSIVBVURVUSVUKIVWTAVUGVULUXLZWIVUSIYPXEVPUXMV
      URVUNWYRWYOVBAVUNVUQVUOVHIVUCVYMVYNVUCUSUXNVDZXFYQXQVURWYOWOUOVUKWYOUOZWY
      QVUKVBVURWYRWYOWOXUAVURWYRIYRUHUOZWYRWOUOVURVYMWRYRUHUOIWRUJZXUCVYMVYNUXO
      AXUDVUQWYKVHIVYMWRUXPYTIWYRUXQVDUXRVURXUBVUKVUCUOZVULXUEVURVUIVUJWQUTWYTV
      URVYPVUDXUBXUEVULVAVRWPAVUDVUQMVHIVUKVUCUXSYTUXTVUKWYOWSVSXFYIVURWYNVUKWY
      LVURWYNVUKVUSVKZVUKVUKVUSYOVURVWPXUFVUKVBVWTVUSVUKYPXEVPYQYIUYAVURVVBVVED
      VVAVVBWRUJVURVVBUFWRVYKWGUYBUTVVEWRUJVURVVEUFWRWWPWGUYBUTVURVUTWRVVAVJVWC
      WRVVAVJVURBVUTUYRWRVVAVURUYOVUTUOWYCWYDVURVUTFUYOVXHYJWYJYLVVAUSYNVURVUTV
      WCWRVVAVXEUYCWCUYFUYDUYEUYGUYHUYIYS $.
  $}

  ${
    $d x y C $.  $d r x y F $.  $d r x y ph $.  $d r x y X $.  $d r x y Y $.
    $d x y R $.
    dvcnvre.f $e |- ( ph -> F e. ( X -cn-> RR ) ) $.
    dvcnvre.d $e |- ( ph -> dom ( RR _D F ) = X ) $.
    dvcnvre.z $e |- ( ph -> -. 0 e. ran ( RR _D F ) ) $.
    dvcnvre.1 $e |- ( ph -> F : X -1-1-onto-> Y ) $.
    ${
      dvcnvre.c $e |- ( ph -> C e. X ) $.
      dvcnvre.r $e |- ( ph -> R e. RR+ ) $.
      dvcnvre.s $e |- ( ph -> ( ( C - R ) [,] ( C + R ) ) C_ X ) $.
      $( Lemma for ~ dvcnvre .  (Contributed by Mario Carneiro,
         24-Feb-2015.) $)
      dvcnvrelem1 $p |- ( ph -> ( F ` C ) e. ( ( int ` ( topGen ` ran (,) ) ) `
        ( F " ( ( C - R ) [,] ( C + R ) ) ) ) ) $=
        ( cr cfv wcel wa clt wbr wi vx vy cmin co caddc cicc cres crn wceq wrex
        cv cima ctg cnt cdv cdm dvbsss syl6eqssr sseldd rpred resubcld readdcld
        cioo ltsubrpd ltaddrpd lttrd ltled ccncf rescncf sylc evthicc2 wf cncff
        wss syl ffvelrnd adantr wiso cxr cle rexrd lbicc2 syl3anc w3a wb elicc2
        ccnv syl2anc mpbir3and isorel exp32 com4l syl3c fvres breq12d wfun ffun
        biimpd sylibd fdm sseqtr4d funfvima2 mpd df-ima simprr eleqtrd ad2antrl
        syl5eq mpbid simp2d simprll lelttr mpand syld ubicc2 brcnv syl5bb wo cc
        fvex ax-resscn a1i fss sylancl sstrd ccnfld ctopn tgioo2 dvres syl22anc
        eqid iccntr reseq2d eqtrd dmeqd cin mpjaod simp3d ltletr mpan2d ssneldd
        dmres ioossicc syl5ss df-ss sylib cc0 resss syl6eqss rnss dvne0 simprlr
        elioo2 fveq2d eleqtrrd expr rexlimdvva ) ADBCUCUDZBCUEUDZUFUDZUGZUHZUAU
        KZUBUKZUFUDZUIZUBNUJUANUJBDOZDUUTULZVCUHUMOZUNOZOZPZAUAUBUURUUSUVAABCAE
        NBAENDUOUDZUPZNHNDUQURZKUSZACLUTZVAZABCUVPUVQVBZAUURUUSUVRUVSAUURBUUSUV
        RUVPUVSABCUVPLVDZABCUVPLVEZVFVGZAUUTEVNZDENVHUDPZUVAUUTNVHUDPMGENUUTDVI
        VJZVKAUVFUVLUAUBNNAUVCNPZUVDNPZQZUVFUVLAUWHUVFQZQZUVGUVCUVDVCUDZUVKUWJU
        VGUWKPZUVGNPZUVCUVGRSZUVGUVDRSZAUWMUWIAENBDAUWDENDVLZGENDVMVOZKVPVQZUWJ
        UUTUVBRRUVAVRZUWNUUTUVBRRWGZUVAVRZUWJUWSUURDOZUVGRSZUWNUWJUWSUURUVAOZBU
        VAOZRSZUXCUWJUURUUTPZBUUTPZUURBRSZUWSUXFTAUXGUWIAUURVSPZUUSVSPZUURUUSVT
        SZUXGAUURUVRWAZAUUSUVSWAZUWBUURUUSWBWCZVQZAUXHUWIAUXHBNPZUURBVTSZBUUSVT
        SZUVPAUURBUVRUVPUVTVGABUUSUVPUVSUWAVGAUURNPZUUSNPZUXHUXQUXRUXSWDWEUVRUV
        SUURUUSBWFWHWIVQZAUXIUWIUVTVQZUWSUXGUXHUXIUXFUWSUXGUXHUXIUXFTUWSUXGUXHQ
        ZQUXIUXFUUTUVBUURBRRUVAWJWRWKWLWMUWJUXDUXBUXEUVGRUWJUXGUXDUXBUIUXPUURUU
        TDWNVOZUWJUXHUXEUVGUIUYBBUUTDWNVOZWOWSUWJUVCUXBVTSZUXCUWNUWJUXBNPZUYGUX
        BUVDVTSZUWJUXBUVEPZUYHUYGUYIWDZUWJUXBUVHUVEUWJUXGUXBUVHPZUXPUWJDWPZUUTD
        UPZVNZUXGUYLTUWJUWPUYMAUWPUWIUWQVQZENDWQVOZUWJUUTEUYNAUWCUWIMVQUWJUWPUY
        NEUIUYPENDWTVOXAZUUTUURDXBWHXCUWJUVHUVBUVEDUUTXDAUWHUVFXEXHZXFUWHUYJUYK
        WEAUVFUVCUVDUXBWFXGXIZXJUWJUWFUYHUWMUYGUXCQUWNTAUWFUWGUVFXKZAUYHUWIAENU
        URDUWQAUUTEUURMUXOUSVPVQZUWRUVCUXBUVGXLWCXMXNUWJUXAUUSDOZUVGRSZUWNUWJUX
        AUXEUUSUVAOZUWTSZVUDUWJUXHUUSUUTPZBUUSRSZUXAVUFTUYBAVUGUWIAUXJUXKUXLVUG
        UXMUXNUWBUURUUSXOWCZVQZAVUHUWIUWAVQZUXAUXHVUGVUHVUFUXAUXHVUGVUHVUFTUXAU
        XHVUGQZQVUHVUFUUTUVBBUUSRUWTUVAWJWRWKWLWMVUFVUEUXERSUWJVUDUXEVUERBUVAXT
        ZUUSUVAXTXPUWJVUEVUCUXEUVGRUWJVUGVUEVUCUIVUJUUSUUTDWNVOZUYFWOXQWSUWJUVC
        VUCVTSZVUDUWNUWJVUCNPZVUOVUCUVDVTSZUWJVUCUVEPZVUPVUOVUQWDZUWJVUCUVHUVEU
        WJVUGVUCUVHPZVUJUWJUYMUYOVUGVUTTUYQUYRUUTUUSDXBWHXCUYSXFUWHVURVUSWEAUVF
        UVCUVDVUCWFXGXIZXJUWJUWFVUPUWMVUOVUDQUWNTVUAAVUPUWIAENUUSDUWQAUUTEUUSMV
        UIUSVPVQZUWRUVCVUCUVGXLWCXMXNAUWSUXAXRUWIAUURUUSUVAUVRUVSUWEANUVAUOUDZU
        PUVMUURUUSVCUDZUGZUPZVVDAVVCVVEAVVCUVMUUTUVJOZUGZVVEANXSVNZEXSDVLZENVNU
        UTNVNVVCVVHUIVVIAYAYBAUWPVVIVVJUWQYAENXSDYCYDUVOAUUTENMUVOYEEUUTNUVIDYF
        YGOZVVKYKZVVKVVLYHYIYJAVVGVVDUVMAUXTUYAVVGVVDUIUVRUVSUURUUSYLWHYMYNZYOA
        VVFVVDUVNYPZVVDUVMVVDUUBAVVDUVNVNVVNVVDUIAVVDEUVNAVVDUUTEUURUUSUUCMUUDH
        XAVVDUVNUUEUUFXHYNAVVCUHZUVMUHZUUGAVVCUVMVNVVOVVPVNAVVCVVEUVMVVMUVMVVDU
        UHUUIVVCUVMUUJVOIUUAUUKVQZYQUWJUWSUWOUXAUWJUWSUVGVUCRSZUWOUWJUWSUXEVUER
        SZVVRUWJUXHVUGVUHUWSVVSTUYBVUJVUKUWSUXHVUGVUHVVSUWSUXHVUGVUHVVSTUWSVULQ
        VUHVVSUUTUVBBUUSRRUVAWJWRWKWLWMUWJUXEUVGVUEVUCRUYFVUNWOWSUWJVVRVUQUWOUW
        JVUPVUOVUQVVAYRUWJUWMVUPUWGVVRVUQQUWOTUWRVVBAUWFUWGUVFUULZUVGVUCUVDYSWC
        YTXNUWJUXAUVGUXBRSZUWOUWJUXAUXDUXEUWTSZVWAUWJUXGUXHUXIUXAVWBTUXPUYBUYCU
        XAUXGUXHUXIVWBUXAUXGUXHUXIVWBTUXAUYDQUXIVWBUUTUVBUURBRUWTUVAWJWRWKWLWMV
        WBUXEUXDRSUWJVWAUXDUXERUURUVAXTVUMXPUWJUXEUVGUXDUXBRUYFUYEWOXQWSUWJVWAU
        YIUWOUWJUYHUYGUYIUYTYRUWJUWMUYHUWGVWAUYIQUWOTUWRVUBVVTUVGUXBUVDYSWCYTXN
        VVQYQUWJUVCVSPUVDVSPUWLUWMUWNUWOWDWEUWJUVCVUAWAUWJUVDVVTWAUVCUVDUVGUUMW
        HWIUWJUVKUVEUVJOZUWKUWJUVHUVEUVJUYSUUNUWHVWCUWKUIAUVFUVCUVDYLXGYNUUOUUP
        UUQXC $.

      dvcnvre.t $e |- T = ( topGen ` ran (,) ) $.
      dvcnvre.j $e |- J = ( TopOpen ` CCfld ) $.
      dvcnvre.m $e |- M = ( J |`t X ) $.
      dvcnvre.n $e |- N = ( J |`t Y ) $.
      $( Lemma for ~ dvcnvre .  (Contributed by Mario Carneiro, 19-Feb-2015.)
         (Revised by Mario Carneiro, 8-Sep-2015.) $)
      dvcnvrelem2 $p |- ( ph -> ( ( F ` C ) e. ( ( int ` T ) ` Y ) /\
        `' F e. ( ( N CnP M ) ` ( F ` C ) ) ) ) $=
        ( cfv cnt wcel ccnv ccnp co cmin caddc cicc cima ctop cr wss cioo retop
        crn ctg eqeltri a1i wf1o wfo wceq f1ofo forn 3syl ccncf wf frn eqsstr3d
        cncff imassrn syl5sseq uniretop unieqi eqtr4i ntrss syl3anc dvcnvrelem1
        cuni fveq2i fveq1i syl6eleqr sseldd cres crest wfun f1of ffun funcnvres
        f1ocnv ccn cdv cdm dvbsss syl6eqssr ax-resscn syl6ss cncfss syl2anc wf1
        cc f1of1 syl f1ores ccmp wb tgioo2 eqtri oveq1i cvv cnfldtop sstrd reex
        restabs syl5eq rpred resubcld readdcld eqid icccmp eqeltrrd syl5ss sylc
        rescncf cncffvrn mpbird cncfcnvcn mpbid cncfcn eleqtrd cle ltled ctopon
        wbr resttopon sylancr toponuni fveq1d syl5eqel ltsubrpd ltaddrpd elicc2
        w3a mpbir3and wi fdm sseqtr4d funfvima2 cnfldtopon cncnpi ssexg sylancl
        mpd oveq1d eleqtrrd topontop sseqtrd cdif cun cin difssd unssd ffvelrnd
        ssun1 elin sylanbrc restntr 3eqtr4g fveq2d eqtr3d feq3 cnprest syl22anc
        feq2d jca ) ABEUBZJDUCUBZUBZUDEUEZUVQHGUFUGUBUDZAEBCUHUGZBCUIUGZUJUGZUK
        ZUVRUBZUVSUVQADULUDZJUMUNZUWEJUNZUWFUVSUNUWGADUOUQURUBZULRUPUSUTZAJEUQZ
        UMAIJEVAZIJEVBUWLJVCNIJEVDIJEVEVFZAEIUMVGUGUDZIUMEVHZUWLUMUNKIUMEVKZIUM
        EVIVFZVJZAUWLUWEJEUWDVLZUWNVMZJUWEDUMUMUWJVTDVTVNDUWJRVOVPZVQVRAUVQUWEU
        WJUCUBZUBUWFABCEIJKLMNOPQVSUWEUVRUXCDUWJUCRWAWBWCZWDAUWAUVTUWEWEZUVQHUW
        EWFUGZGUFUGZUBZUDZAUXEUVQFUWEWFUGZGUFUGZUBZUXHAEUWDWEZUEZUXEUXLAJIUVTVH
        ZUVTWGUXNUXEVCAUWMJIUVTVAUXONIJEWKJIUVTWHVFZJIUVTWIUWDEWJVFAUXNUXJGWLUG
        ZUDUVQUXJVTZUDUXNUXLUDAUXNUWEIVGUGZUXQAUWEUWDVGUGZUXSUXNAUWDIUNZIXBUNZU
        XTUXSUNQAIUMXBAIUMEWMUGWNUMLUMEWOWPZWQWRZUWEUWDIWSWTAUWDUWEUXMVAZUXNUXT
        UDZAIJEXAZUYAUYEAUWMUYGNIJEXCXDQIJUWDEXEWTZAFUWDWFUGZXFUDUXMUWDUWEVGUGU
        DZUYEUYFXGADUWDWFUGZUYIXFAUYKFUMWFUGZUWDWFUGZUYIDUYLUWDWFDUWJUYLRFSXHXI
        ZXJAFULUDZUWDUMUNUMXKUDZUYMUYIVCUYOAFSXLUTZAUWDIUMQUYCXMUYPAXNUTZUWDUMF
        ULXKXOVRXPAUWBUMUDZUWCUMUDZUYKXFUDABCAIUMBUYCOWDZACPXQZXRZABCVUAVUBXSZU
        WBUWCUYKDRUYKXTYAWTYBAUYJUWDUWEUXMVHZAUYEVUEUYHUWDUWEUXMWHXDAUWEXBUNZUX
        MUWDUMVGUGUDZUYJVUEXGAUWEUWLXBUWTAUWLUMXBUWRWQWRYCZAUYAUWOVUGQKIUMUWDEY
        EYDUWDUMUWEUXMYFWTYGUXMFUYIUWDUWESUYIXTYHWTYIWDAVUFUYBUXSUXQVCVUHUYDUWE
        IFUXJGSUXJXTTYJWTYKAUVQUWEUXRABUWDUDZUVQUWEUDZAVUIBUMUDZUWBBYLYOZBUWCYL
        YOZVUAAUWBBVUCVUAABCVUAPUUAYMABUWCVUAVUDABCVUAPUUBYMAUYSUYTVUIVUKVULVUM
        UUDXGVUCVUDUWBUWCBUUCWTUUEAEWGZUWDEWNZUNVUIVUJUUFAUWOUWPVUNKUWQIUMEWIVF
        AUWDIVUOQAUWOUWPVUOIVCKUWQIUMEUUGVFUUHUWDBEUUIWTUUNAUXJUWEYNUBUDZUWEUXR
        VCAFXBYNUBUDZVUFVUPFSUUJZVUHUWEFXBYPYQUWEUXJYRXDYKUVQUXNUXJGUXRUXRXTUUK
        WTYBAUVQUXGUXKAUXFUXJGUFAUXFFJWFUGZUWEWFUGZUXJHVUSUWEWFUAXJAUYOUWIJXKUD
        ZVUTUXJVCUYQUXAAUWHUYPVVAUWSXNJUMXKUULUUMUWEJFULXKXOVRXPUUOYSUUPAHULUDZ
        UWEHVTZUNUVQUWEHUCUBZUBZUDVVCGVTZUVTVHZUWAUXIXGAHJYNUBZUDZVVBAHVUSVVHUA
        AVUQJXBUNVUSVVHUDVURAJUMXBUWSWQWRJFXBYPYQYTZJHUUQXDAUWEJVVCUXAAVVIJVVCV
        CVVJJHYRXDZUURAUVQUWEUMJUUSZUUTZUVRUBZJUVAZVVEAUVQVVNUDUVQJUDUVQVVOUDAU
        WFVVNUVQAUWGVVMUMUNUWEVVMUNZUWFVVNUNUWKAUWEVVLUMAUWEJUMUXAUWSXMAUMJUVBU
        VCVVPAUWEVVLUVEUTVVMUWEDUMUXBVQVRUXDWDAIJBEAUWMIJEVHNIJEWHXDOUVDUVQVVNJ
        UVFUVGAUWEDJWFUGZUCUBZUBZVVOVVEAUWGUWHUWIVVSVVOVCUWKUWSUXAUWEDVVQUMJUXB
        VVQXTUVHVRAUWEVVRVVDAVVQHUCAUYLJWFUGZVUSVVQHAUYOUWHUYPVVTVUSVCUYQUWSUYR
        JUMFULXKXOVRDUYLJWFUYNXJUAUVIUVJYSUVKYKAVVCIUVTVHZVVGAUXOVWAUXPAJVVCIUV
        TVVKUVOYIAGIYNUBZUDIVVFVCVWAVVGXGAGFIWFUGZVWBTAVUQUYBVWCVWBUDVURUYDIFXB
        YPYQYTIGYRIVVFVVCUVTUVLVFYIUWEUVQUVTHGVVCVVFVVCXTVVFXTUVMUVNYGUVP $.
    $}

    $( The derivative rule for inverse functions.  If ` F ` is a continuous and
       differentiable bijective function from ` X ` to ` Y ` which never has
       derivative ` 0 ` , then ` ``' F ` is also differentiable, and its
       derivative is the reciprocal of the derivative of ` F ` .  (Contributed
       by Mario Carneiro, 24-Feb-2015.) $)
    dvcnvre $p |- ( ph -> ( RR _D `' F ) =
      ( x e. Y |-> ( 1 / ( ( RR _D F ) ` ( `' F ` x ) ) ) ) ) $=
      ( cr cfv eqid cc wcel wceq wss co sylancr wa wb vr vy ccnfld cioo crn ctg
      ctopn tgioo2 cpr reex prid1 a1i cnt ctop retop wf1o f1ofo forn 3syl ccncf
      wfo wf cncff frn eqsstr3d uniretop ntrss2 ccnv f1ocnvfv2 sylan crest ccnp
      cabs cmin ccom cxp cres cbl crp wrex f1ocnv f1of ffvelrnda cdv cdm dvbsss
      ax-resscn syl fss sylancl dvbssntr eqssd isopn3 mpbird rexmet cmopn tgioo
      cv cxmt mopni2 mp3an1 syldan c2 cdiv ad2antrr wn adantr rphalfcl ad2antrl
      cc0 caddc cicc clt wbr cle sseldd resubcld readdcld elicc2 syl2anc biimpa
      w3a rpred simp1d simplrl rphalflt ltsub2dd simp2d ltletrd simp3d ltadd2dd
      lelttrd cxr rexrd elioo2 ex ssrdv ctopon syl6ss resttopon bl2ioo sseqtr4d
      mpbir3and rpre simprr dvcnvrelem2 rexlimddv simpld eqeltrrd simprd fveq2d
      sstrd ccn wral ralrimiva cnfldtopon cncnp mpbir2and cncfcn eleqtrrd dvcnv
      eleqtrd ) ABJCUCUGKZUDUEUFKZDEUVCLZUVCUVEUHZJJMUINAJMUJUKULAEUVDNZEUVDUMK
      ZKZEOZAUVIEAUVDUNNZEJPZUVIEPUOAECUEZJADECUPZDECVAUVMEOIDECUQDECURUSACDJUT
      QNZDJCVBZUVMJPFDJCVCZDJCVDUSVEZEUVDJVFVGRABEUVIABWRZENZUVSUVINAUVTSZUVSCV
      HZKZCKZUVSUVIAUVNUVTUWDUVSOIDEUVSCVIVJZUWAUWDUVINZUWBUWDUVCEVKQZUVCDVKQZV
      LQZKZNZUWAUWCUAWRZVMVNVOJJVPVQZVRKQZDPZUWFUWKSUAVSAUVTUWCDNZUWOUAVSVTZAED
      UVSUWBAUVNEDUWBUPEDUWBVBZIDECWAEDUWBWBUSZWCZADUVDNZUWPUWQAUXADUVHKZDOZAUX
      BDAUVKDJPZUXBDPUOADJCWDQZWEZJGUXFJPAJCWFULVEZDUVDJVFVGRADUXFUXBGADJCUVDUV
      CJMPZAWGULAUVPUXHDMCVBAUVOUVPFUVQWHWGDJMCWIWJUXGUVFUVEWKVEWLAUVKUXDUXAUXC
      TUOUXGDUVDJVFWMRWNUWMJWSKNUXAUWPUWQUWMUWMLZWOUADUWMUWCUVDJUWMUWMWPKZUXIUX
      JLWQWTXAVJXBUWAUWLVSNZUWOSZSZUWCUWLXCXDQZUVDCUVCUWHUWGDEAUVOUVTUXLFXEAUXF
      DOUVTUXLGXEAXJUXEUENXFUVTUXLHXEAUVNUVTUXLIXEUWAUWPUXLUWTXGZUXKUXNVSNZUWAU
      WOUWLXHZXIZUXMUWCUXNVNQZUWCUXNXKQZXLQZUWNDUXMUYAUWCUWLVNQZUWCUWLXKQZUDQZU
      WNUXMUBUYAUYDUXMUBWRZUYANZUYEUYDNZUXMUYFSZUYGUYEJNZUYBUYEXMXNZUYEUYCXMXNZ
      UYHUYIUXSUYEXOXNZUYEUXTXOXNZUXMUYFUYIUYLUYMYBZUXMUXSJNZUXTJNZUYFUYNTUXMUW
      CUXNUXMDJUWCAUXDUVTUXLUXGXEUXOXPZUXMUXNUXRYCZXQZUXMUWCUXNUYQUYRXRZUXSUXTU
      YEXSXTYAZYDZUYHUYBUXSUYEUYHUWCUWLUXMUWCJNZUYFUYQXGZUYHUWLUWAUXKUWOUYFYEZY
      CZXQZUXMUYOUYFUYSXGVUBUYHUXNUWLUWCUYHUXNUYHUXKUXPVUEUXQWHYCZVUFVUDUYHUXKU
      XNUWLXMXNVUEUWLYFWHZYGUYHUYIUYLUYMVUAYHYIUYHUYEUXTUYCVUBUXMUYPUYFUYTXGUYH
      UWCUWLVUDVUFXRZUYHUYIUYLUYMVUAYJUYHUXNUWLUWCVUHVUFVUDVUIYKYLUYHUYBYMNUYCY
      MNUYGUYIUYJUYKYBTUYHUYBVUGYNUYHUYCVUJYNUYBUYCUYEYOXTUUCYPYQUXMVUCUWLJNZUW
      NUYDOUYQUXKVUKUWAUWOUWLUUDXIUWCUWLUWMUXIUUAXTUUBUWAUXKUWOUUEUULUVDLUVEUWH
      LZUWGLZUUFUUGZUUHUUIYPYQWLAUVKUVLUVGUVJTUOUVREUVDJVFWMRWNIAUWBUWGUWHUUMQZ
      EDUTQZAUWBVUONZUWRUWBUVSUWIKZNZBEUUNZUWSAVUSBEUWAUWBUWJVURUWAUWFUWKVUNUUJ
      UWAUWDUVSUWIUWEUUKUVBUUOAUWGEYRKNZUWHDYRKNZVUQUWRVUTSTAUVCMYRKNZEMPZVVAUV
      CUVEUUPZAEJMUVRWGYSZEUVCMYTRAVVCDMPZVVBVVEADJMUXGWGYSZDUVCMYTRBUWBUWGUWHE
      DUUQXTUURAVVDVVGVUPVUOOVVFVVHEDUVCUWGUWHUVEVUMVULUUSXTUUTGHUVA $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y F $.  $d x y ph $.
    $d x y T $.
    dvcvx.a $e |- ( ph -> A e. RR ) $.
    dvcvx.b $e |- ( ph -> B e. RR ) $.
    dvcvx.l $e |- ( ph -> A < B ) $.
    dvcvx.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> RR ) ) $.
    dvcvx.d $e |- ( ph -> ( RR _D F ) Isom < , < ( ( A (,) B ) , W ) ) $.
    dvcvx.t $e |- ( ph -> T e. ( 0 (,) 1 ) ) $.
    dvcvx.c $e |- C = ( ( T x. A ) + ( ( 1 - T ) x. B ) ) $.
    $( A real function with strictly increasing derivative is strictly convex.
       (Contributed by Mario Carneiro, 20-Jun-2015.) $)
    dvcvx $p |- ( ph -> ( F ` C ) <
        ( ( T x. ( F ` A ) ) + ( ( 1 - T ) x. ( F ` B ) ) ) ) $=
      ( cr co cmin clt wbr wcel vx vy cv cicc cres cdv cdiv wceq cioo wrex cmul
      cfv c1 caddc cc0 elioore syl remulcld 1re resubcl sylancr readdcld ax-1cn
      syl5eqel cc a1i recnd subdird mulid2d oveq1d eqtrd eliooord simprd posdif
      wb sylancl mpbid ltmul2 syl112anc eqbrtrrd ltsubadd2d syl6breqr wss ccncf
      cle leidd simpld ltsub2dd eqbrtrd ltaddsub2d ltled iccss syl22anc rescncf
      wa sylc cdm wf ax-resscn iccssre syl2anc dvres iccntr reseq2d dmeqd dmres
      cin cxr rexrd sseqtr4d df-ss sylib syl5eq mvth fveq1d fvres adantr ubicc2
      sylan9eq syl3anc lbicc2 oveq12d eqeq12d ad2antrl ad2antll sselda ffvelrnd
      sseldd resubcld gt0ne0d redivcld mulcomd subdid breq12d jca eqtr3d oveq2d
      3bitr3d divdiv1d 3eqtr4d mpbird syl5eqbr crn ctg cnt cncff fss ctopn eqid
      ccnfld tgioo2 iooss2 wiso isof1o f1odm iooss1 reeanv adantl anbi12d lttrd
      wf1o 3syl adantrr adantrl isorel syl12anc breq12 syl5ibcom posdifd ltdiv1
      addsubd pncan3 adddird 3eqtr3d breq1d ltaddsubd subsub3d addcomd subsub4d
      lt2mul2div nncand eqtr4d 3bitr3rd sylibd sylbid rexlimdvva syl5bir mp2and
      ) AUAUCZOFBDUDPZUEZUFPZULZDUWKULZBUWKULZQPZDBQPZUGPZUHZUABDUIPZUJZUBUCZOF
      DCUDPZUEZUFPZULZCUXDULZDUXDULZQPZCDQPZUGPZUHZUBDCUIPZUJZDFULZEBFULZUKPZUM
      EQPZCFULZUKPZUNPRSZAUABDUWKHADEBUKPZUXRCUKPZUNPZONAUYBUYCAEBAEUOUMUIPTZEO
      TZMEUOUMUPUQZHURZAUXRCAUMOTZUYFUXROTZUSUYGUMEUTVAZIURZVBVDZABUYDDRABUYBQP
      ZUYCRSBUYDRSAUXRBUKPZUYNUYCRAUYOUMBUKPZUYBQPUYNAUMEBUMVETZAVCVFZAEUYGVGZA
      BHVGZVHAUYPBUYBQABUYTVIVJVKZABCRSZUYOUYCRSZJABOTZCOTZUYJUOUXRRSZVUBVUCVOH
      IUYKAEUMRSZVUFAUOERSZVUGAUYEVUHVUGWOMEUOUMVLUQZVMAUYFUYIVUGVUFVOUYGUSEUMV
      NVPVQZBCUXRVRVSVQVTABUYBUYCHUYHUYLWAVQNWBZAUWJBCUDPZWCZFVULOWDPTZUWKUWJOW
      DPTAVUDVUEBBWESDCWESZVUMHIABHWFADCUYMIADUYDCRNAUYDCRSUYCCUYBQPZRSAUYCCECU
      KPZQPZVUPRAUYCUMCUKPZVUQQPVURAUMECUYRUYSACIVGZVHAVUSCVUQQACVUTVIVJVKZAUYB
      VUQCUYHAECUYGIURZIAVUBUYBVUQRSZJAVUDVUEUYFVUHVUBVVCVOHIUYGAVUHVUGVUIWGZBC
      EVRVSVQWHWIAUYBUYCCUYHUYLIWJUUAUUBZWKZBCBDWLWMZKVULOUWJFWNWPAUWLWQOFUFPZU
      WTUEZWQZUWTAUWLVVIAUWLVVHUWJUIUUCUUDULZUUEULZULZUEZVVIAOVEWCZVULVEFWRZVUL
      OWCZUWJOWCZUWLVVNUHVVOAWSVFZAVULOFWRZVVOVVPAVUNVVTKVULOFUUFUQZWSVULOVEFUU
      GVPZAVUDVUEVVQHIBCWTXAZAVUDDOTZVVRHUYMBDWTXAVULUWJOVVKFUUJUUHULZVWEUUIZVW
      EVWFUUKZXBWMAVVMUWTVVHAVUDVWDVVMUWTUHHUYMBDXCXAXDVKZXEAVVJUWTVVHWQZXGZUWT
      VVHUWTXFAUWTVWIWCVWJUWTUHAUWTBCUIPZVWIACXHTZVUOUWTVWKWCACIXIZVVFBDCUULXAZ
      AVWKGRRVVHUUMZVWKGVVHUVAVWIVWKUHLVWKGRRVVHUUNVWKGVVHUUOUVBZXJUWTVWIXKXLXM
      VKXNAUBDCUXDUYMIVVEAUXCVULWCZVUNUXDUXCOWDPTAVUDVUEBDWESZCCWESVWQHIABDHUYM
      VUKWKZACIWFBCDCWLWMZKVULOUXCFWNWPAUXEWQVVHUXMUEZWQZUXMAUXEVXAAUXEVVHUXCVV
      LULZUEZVXAAVVOVVPVVQUXCOWCZUXEVXDUHVVSVWBVWCAVWDVUEVXEUYMIDCWTXAVULUXCOVV
      KFVWEVWFVWGXBWMAVXCUXMVVHAVWDVUEVXCUXMUHUYMIDCXCXAXDVKZXEAVXBUXMVWIXGZUXM
      VVHUXMXFAUXMVWIWCVXGUXMUHAUXMVWKVWIABXHTZVWRUXMVWKWCABHXIZVWSBDCUUPXAZVWP
      XJUXMVWIXKXLXMVKXNUXAUXNWOUWSUXLWOZUBUXMUJUAUWTUJAUYAUWSUXLUAUBUWTUXMUUQA
      VXKUYAUAUBUWTUXMAUWIUWTTZUXBUXMTZWOZWOZVXKUWIVVHULZUXOUXPQPZUWQUGPZUHZUXB
      VVHULZUXSUXOQPZUXJUGPZUHZWOZUYAVXOUWSVXSUXLVYCVXOUWMVXPUWRVXRAVXNUWMUWIVV
      IULZVXPAUWIUWLVVIVWHXOVXLVYEVXPUHVXMUWIUWTVVHXPXQXSAUWRVXRUHVXNAUWPVXQUWQ
      UGAUWNUXOUWOUXPQADUWJTZUWNUXOUHAVXHDXHTZVWRVYFVXIADUYMXIZVWSBDXRXTZDUWJFX
      PUQABUWJTZUWOUXPUHAVXHVYGVWRVYJVXIVYHVWSBDYAXTZBUWJFXPUQYBVJXQYCVXOUXFVXT
      UXKVYBAVXNUXFUXBVXAULZVXTAUXBUXEVXAVXFXOVXMVYLVXTUHVXLUXBUXMVVHXPUURXSAUX
      KVYBUHVXNAUXIVYAUXJUGAUXGUXSUXHUXOQACUXCTZUXGUXSUHAVYGVWLVUOVYMVYHVWMVVFD
      CXRXTZCUXCFXPUQADUXCTZUXHUXOUHAVYGVWLVUOVYOVYHVWMVVFDCYAXTDUXCFXPUQYBVJXQ
      YCUUSVXOVYDVXRVYBRSZUYAVXOVXPVXTRSZVYDVYPVXOUWIUXBRSZVYQVXOUWIDUXBVXLUWIO
      TAVXMUWIBDUPYDAVWDVXNUYMXQVXMUXBOTAVXLUXBDCUPYEVXOBUWIRSZUWIDRSZVXLVYSVYT
      WOAVXMUWIBDVLYDVMVXODUXBRSZUXBCRSZVXMWUAWUBWOAVXLUXBDCVLYEWGUUTVXOVWOUWIV
      WKTZUXBVWKTZVYRVYQVOAVWOVXNLXQAVXLWUCVXMAUWTVWKUWIVWNYFUVCAVXMWUDVXLAUXMV
      WKUXBVXJYFUVDVWKGUWIUXBRRVVHUVEUVFVQVXPVXRVXTVYBRUVGUVHAVYPUYAVOVXNAVXQUX
      RUGPZVYAEUGPZRSZWUECBQPZUGPZWUFWUHUGPZRSZUYAVYPAWUEOTWUFOTWUHOTUOWUHRSZWU
      GWUKVOAVXQUXRAUXOUXPAVULODFVWAAUWJVULDVVGVYIYHYGZAVULOBFVWAAUWJVULBVVGVYK
      YHYGZYIZUYKAUXRVUJYJZYKAVYAEAUXSUXOAVULOCFVWAAUXCVULCVWTVYNYHYGZWUMYIZUYG
      AEVVDYJZYKACBIHYIZAVUBWULJABCHIUVIVQZWUEWUFWUHUVJVSAVXQEUKPZVYAUXRUKPZRSZ
      EUXOUKPZUXQQPZUXTUXRUXOUKPZQPZRSZWUGUYAAWVBWVFWVCWVHRAWVBEVXQUKPWVFAVXQEA
      VXQWUOVGZUYSYLAEUXOUXPUYSAUXOWUMVGZAUXPWUNVGYMVKAWVCUXRVYAUKPWVHAVYAUXRAV
      YAWURVGZAUXRUYKVGZYLAUXRUXSUXOWVMAUXSWUQVGWVKYMVKYNAVXQOTUYFVUHWOVYAOTUYJ
      VUFWOWVDWUGVOWUOAUYFVUHUYGVVDYOWURAUYJVUFUYKVUJYOVXQEVYAUXRUVTWMAWVFWVGUN
      PZUXTRSUXOUXQQPZUXTRSWVIUYAAWVNWVOUXTRAWVEWVGUNPZUXQQPWVNWVOAWVEWVGUXQAWV
      EAEUXOUYGWUMURZVGAWVGAUXRUXOUYKWUMURZVGAUXQAEUXPUYGWUNURZVGUVKAWVPUXOUXQQ
      AEUXRUNPZUXOUKPUMUXOUKPWVPUXOAWVTUMUXOUKAEVETUYQWVTUMUHUYSVCEUMUVLVPVJAEU
      XRUXOUYSWVMWVKUVMAUXOWVKVIUVNVJYPUVOAWVFWVGUXTAWVEUXQWVQWVSYIWVRAUXRUXSUY
      KWUQURZUVPAUXOUXQUXTWUMWVSWWAWAYRYRAWUIVXRWUJVYBRAWUIVXQUXRWUHUKPZUGPVXRA
      VXQUXRWUHWVJWVMAWUHWUTVGZWUPAWUHWVAYJZYSAWWBUWQVXQUGAUYCUYOQPZUYCUYBUNPZB
      QPZWWBUWQAWWEUYCUYNQPWWGAUYOUYNUYCQVUAYQAUYCBUYBAUYCUYLVGZUYTAUYBUYHVGZUV
      QVKAUXRCBWVMVUTUYTYMADWWFBQADUYDWWFNAUYBUYCWWIWWHUVRXMZVJYTYQVKAWUJVYAEWU
      HUKPZUGPVYBAVYAEWUHWVLUYSWWCWUSWWDYSAUXJWWKVYAUGACWWFQPZVUQUYBQPZUXJWWKAC
      UYCQPZUYBQPWWLWWMACUYCUYBVUTWWHWWIUVSAWWNVUQUYBQAWWNCVURQPVUQAUYCVURCQVVA
      YQACVUQVUTAVUQVVBVGUWAVKVJYPADWWFCQWWJYQAECBUYSVUTUYTYMYTYQUWBYNUWCXQUWDU
      WEUWFUWGUWH $.
  $}

  ${
    $d k y z A $.  $d k x y M $.  $d k x y N $.  $d k x y ph $.  $d x y z X $.
    $d y z B $.  $d x y C $.  $d x y D $.  $d x V $.
    dvfsumle.m $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    dvfsumle.a $e |- ( ph ->
      ( x e. ( M [,] N ) |-> A ) e. ( ( M [,] N ) -cn-> RR ) ) $.
    dvfsumle.v $e |- ( ( ph /\ x e. ( M (,) N ) ) -> B e. V ) $.
    dvfsumle.b $e |- ( ph ->
      ( RR _D ( x e. ( M (,) N ) |-> A ) ) = ( x e. ( M (,) N ) |-> B ) ) $.
    dvfsumle.c $e |- ( x = M -> A = C ) $.
    dvfsumle.d $e |- ( x = N -> A = D ) $.
    dvfsumle.x $e |- ( ( ph /\ k e. ( M ..^ N ) ) -> X e. RR ) $.
    ${
      dvfsumle.l $e |- ( ( ph /\ ( k e. ( M ..^ N ) /\
        x e. ( k (,) ( k + 1 ) ) ) ) -> X <_ B ) $.
      $( Compare a finite sum to an integral (the integral here is given as a
         function with a known derivative).  (Contributed by Mario Carneiro,
         14-May-2016.) $)
      dvfsumle $p |- ( ph -> sum_ k e. ( M ..^ N ) X <_ ( D - C ) ) $=
        ( cr vy cfzo co csu cv c1 caddc csb cmin cle cfn wcel fzofi a1i wa wral
        cfz cicc cz cin wceq cuz cfv eluzel2 syl eluzelz syl2anc inss1 syl6eqss
        fzval2 sselda cmpt wf ccncf cncff eqid sylibr nfcsb1v nfel1 weq csbeq1a
        fmpt eleq1d rspc syldan ralrimiva fzofzp1 csbeq1 rspccva syl2an elfzofz
        mpan9 resubcld cmul cc elfzoelz adantl zred recnd ax-1cn pncan2 sylancl
        oveq2d peano2re subdid mulid1d 3eqtr3d ccnfld ctopn wss adantr elfzole1
        mulcn wbr elfzle2 iccss syl22anc iccssre sstrd ax-resscn syl6ss syl3anc
        cncfmptc cioo cdv cxr rexrd ioossre dvmptres eqtrd cbvmpt sseli adantlr
        nfcv cdm oveq2 cvv eqeq2 biimpa csbied cncfmptid remulcl cncfmpt2ss cpr
        reex prid1 iooss1 iooss2 ioossicc syl5ss crn dvmptid iooretop dvmptcmul
        ctg tgioo2 mpteq2dv cres resmpt sylc eqeltrrd syl5eqelr impcom r19.21bi
        rescncf sylan2 fmptd dvfre dmeqd dmmptg feq12d mpbid oveq2i nfbr breq2d
        3eqtr3g anassrs lep1d lbicc2 ubicc2 eqbrtrrd fsumle fsumtscopo2 breqtrd
        dvle vex ) AHIUBUCZKGUDUWGBGUEZUFUGUCZCUHZBUWHCUHZUIUCZGUDFEUIUCUJAUWGK
        UWLGUWGUKULAHIUMUNRAUWHUWGULZUOZUWJUWKABUAUEZCUHZTULZUAHIUQUCZUPZUWIUWR
        ULZUWJTULZUWMAUWQUAUWRAUWOUWRULZUWOHIURUCZULZUWQAUWRUXCUWOAUWRUXCUSUTZU
        XCAHUSULZIUSULZUWRUXEVAAIHVBVCULZUXFLHIVDVEZAUXHUXGLHIVFVEZHIVJVGUXCUSV
        HVIVKACTULZBUXCUPZUXDUWQAUXCTBUXCCVLZVMZUXLAUXMUXCTVNUCULZUXNMUXCTUXMVO
        VEZBUXCTCUXMUXMVPWBZVQZUXKUWQBUWOUXCBUWPTBUWOCVRZVSBUAVTZCUWPTBUWOCWAZW
        CWDZWLWEZWFZHIUWHWGZUWQUXAUAUWIUWRUWOUWIVAUWPUWJTBUWOUWICWHZWCWIWJAUWSU
        WHUWRULUWKTULZUWMUYDUWHHIWKUWQUYGUAUWHUWRUAGVTUWPUWKTBUWOUWHCWHZWCWIWJW
        MUWNKUWIWNUCZKUWHWNUCZUIUCZKUWLUJUWNKUWIUWHUIUCZWNUCKUFWNUCZUYKKUWNUYLU
        FKWNUWNUWHWOULUFWOULZUYLUFVAUWNUWHUWNUWHUWMUWHUSULAUWHHIWPWQWRZWSZWTUWH
        UFXAXBXCUWNKUWIUWHUWNKRWSZUWNUWIUWNUWHTULUWITULUYOUWHXDVEZWSUYPXEUWNKUY
        QXFZXGUWNUAKUWOWNUCZKUWPBUWODUHZUYJUWKUYIUWJUWHUWIUWHUWIUYOUYRUWNUAKUWO
        TWNXHXIVCZUWHUWIURUCZVUBVPZVUBVUDXMUWNKTULVUCWOXJTWOXJZUAVUCKVLVUCTVNUC
        ZULRUWNVUCTWOUWNVUCUXCTUWNHTULZITULZHUWHUJXNZUWIIUJXNZVUCUXCXJZAVUGUWMA
        HUXIWRZXKZAVUHUWMAIUXJWRZXKZUWMVUIAUWHHIXLWQZUWNUWTVUJUWMUWTAUYEWQUWIHI
        XOVEZHIUWHUWIXPXQZAUXCTXJZUWMAVUGVUHVUSVULVUNHIXRVGXKZXSZXTYAVUEUWNXTUN
        ZUAKVUCTYCYBUWNVUCTXJVUEUAVUCUWOVLVUFULVVAXTUAVUCTUUAXBXTKUWOUUBUUCUWNT
        UAUWHUWIYDUCZUYTVLYEUCUAVVCUYMVLUAVVCKVLUWNUAUWOUFKTWOVVCTTWOUUDULUWNTW
        OUUEUUFUNZUWNVVCWOUWOUWNVVCHIYDUCZWOUWNVVCHUWIYDUCZVVEUWNHYFULVUIVVCVVF
        XJUWNHVUMYGVUPHUWHUWIUUGVGUWNIYFULVUJVVFVVEXJUWNIVUOYGVUQHUWIIUUHVGXSZU
        WNVVEUXCWOHIUUIZUWNUXCTWOVUTXTYAUUJXSVKUYNUWNUWOVVCULZUOWTUNUWNUAUWOUFT
        YDUUKUUOVCZVUBWOTVVCVVDUWNTWOUWOVVBVKUYNUWNUWOTULUOWTUNUWNUATVVDUULVVCT
        XJUWNUWHUWIYHUNVUBVUDUUPZVUDVVCVVJULUWNUWHUWIUUMUNZYIUYQUUNUWNUAVVCUYMK
        UYSUUQYJUWNUAVUCUWPVLBVUCCVLZVUFBUAVUCCUWPUACYNZUXSUYAYKUWNUXMVUCUURZVV
        MVUFUWNVUKVVOVVMVAVURBUXCVUCCUUSVEUWNVUKUXOVVOVUFULVURAUXOUWMMXKUXCTVUC
        UXMUVEUUTUVAUVBUWNUAUWPVUATVVJVUBTVVEVVCVVDUWNUWOVVEULZUOUWPUWNUXLUXDUW
        QVVPUWNUXNUXLAUXNUWMUXPXKUXQVQVVEUXCUWOVVHYLUXDUXLUWQUYBUVCWJWSUWNDTULZ
        BVVEUPZVVPVUATULZUWNVVETBVVEDVLZVMZVVRUWNTBVVECVLZYEUCZYOZTVWCVMZVWAUWN
        VVETVWBVMVVETXJVWEUWNBVVECTVWBBUEZVVEULZUWNVWFUXCULZUXKVVEUXCVWFVVHYLAV
        WHUXKUWMAUXKBUXCUXRUVDYMUVFVWBVPUVGHIYHVVEVWBUVHXBUWNVWDVVETVWCVVTAVWCV
        VTVAUWMOXKZUWNVWDVVTYOZVVEUWNVWCVVTVWIUVIUWNDJULZBVVEUPVWJVVEVAUWNVWKBV
        VEAVWGVWKUWMNYMWFBVVEDJUVJVEYJUVKUVLBVVETDVVTVVTVPWBVQVVQVVSBUWOVVEBVUA
        TBUWODVRZVSUXTDVUATBUWODWAZWCWDWLUWNVWCVVTTUAVVEUWPVLZYEUCUAVVEVUAVLVWI
        VWBVWNTYEBUAVVECUWPVVNUXSUYAYKUVMBUAVVEDVUAUADYNVWLVWMYKUVPVVGVVKVUDVVL
        YIUWNKDUJXNZBVVCUPVVIKVUAUJXNZUWNVWOBVVCAUWMVWFVVCULVWOSUVQWFVWOVWPBUWO
        VVCBKVUAUJBKYNBUJYNVWLUVNUXTDVUAKUJVWMUVOWDWLUWNUWHYFULZUWIYFULZUWHUWIU
        JXNZUWHVUCULUWNUWHUYOYGZUWNUWIUYRYGZUWNUWHUYOUVRZUWHUWIUVSYBUWNVWQVWRVW
        SUWIVUCULVWTVXAVXBUWHUWIUVTYBVXBUWOUWHKWNYPUYHUWOUWIKWNYPUYFUWEUWAUWBAU
        WPUWKUWJEGUAFHIUYHUYFUWOHVAZBUWOCEYQUWOYQULZVXCUAUWFZUNVXCUXTUOVWFHVAZC
        EVAVXCUXTVXFUWOHVWFYRYSPVEYTUWOIVAZBUWOCFYQVXDVXGVXEUNVXGUXTUOVWFIVAZCF
        VAVXGUXTVXHUWOIVWFYRYSQVEYTLAUXBUOUWPUYCWSUWCUWD $.
    $}

    ${
      dvfsumge.l $e |- ( ( ph /\ ( k e. ( M ..^ N ) /\
        x e. ( k (,) ( k + 1 ) ) ) ) -> B <_ X ) $.
      $( Compare a finite sum to an integral (the integral here is given as a
         function with a known derivative).  (Contributed by Mario Carneiro,
         14-May-2016.) $)
      dvfsumge $p |- ( ph -> ( D - C ) <_ sum_ k e. ( M ..^ N ) X ) $=
        ( cr cmin cfzo csu cle wbr cneg cvv cicc cmpt cc0 df-neg mpteq2i ccnfld
        co ccncf ctopn cfv eqid subcn cc wss 0re a1i cuz cz eluzel2 syl eluzelz
        wcel zred iccssre syl2anc ax-resscn cncfmptc syl3anc resubcl cncfmpt2ss
        syl6ss syl5eqel cv cioo wa negex cpr reex prid1 ioossicc sseli wf cncff
        wral fmpt sylibr r19.21bi sylan2 recnd dvmptneg wceq negeqd renegcld c1
        caddc cxr adantr rexrd elfzole1 adantl iooss1 cfz fzofzp1 elfzle2 sstrd
        iooss2 sselda cdv cdm adantlr fmptd ioossre dvfre dmeqd ralrimiva eqtrd
        sylancl dmmptg feq12d mpbid syldan anasss adantrr lenegd dvfsumle fzofi
        cfn fsumneg eluzle ubicc2 eleq1d rspcv sylc neg2subd negsubdi2d 3brtr3d
        lbicc2 eqtr4d resubcld fsumrecl mpbird ) AFEUAUNZHIUBUNZKGUCZUDUEUUKUFZ
        UUIUFZUDUEAUUJKUFZGUCFUFZEUFZUAUNZUULUUMUDABCUFZDUFZUUPUUOGHIUGUUNLABHI
        UHUNZUURUIBUUTUJCUAUNZUIUUTTUOUNZBUUTUURUVACUKULABUJCTUAUMUPUQZUUTUVCUR
        ZUVCUVDUSAUJTVIZUUTUTVATUTVAZBUUTUJUIUVBVIUVEAVBVCAUUTTUTAHTVIZITVIZUUT
        TVAAHAIHVDUQVIZHVEVILHIVFVGVJZAIAUVIIVEVILHIVHVGVJZHIVKVLVMVRUVFAVMVCBU
        JUUTTVNVOMVMUJCVPVQVSUUSUGVIABVTZHIWAUNZVIZWBZDWCVCABCDTJUVMTTUTWDVIATU
        TWEWFVCUVOCUVNAUVLUUTVIZCTVIZUVMUUTUVLHIWGWHZAUVQBUUTAUUTTBUUTCUIZWIZUV
        QBUUTWKZAUVSUVBVIUVTMUUTTUVSWJVGBUUTTCUVSUVSURWLWMZWNZWOWPNOWQUVLHWRZCE
        PWSUVLIWRZCFQWSAGVTZUUJVIZWBZKRWTAUWGUVLUWFUWFXAXBUNZWAUNZVIZWBWBZDKUDU
        EUUNUUSUDUESUWLDKAUWGUWKDTVIZUWHUWKUVNUWMUWHUWJUVMUVLUWHUWJHUWIWAUNZUVM
        UWHHXCVIZHUWFUDUEZUWJUWNVAUWHHAUVGUWGUVJXDXEUWGUWPAUWFHIXFXGHUWFUWIXHVL
        UWHIXCVIZUWIIUDUEZUWNUVMVAUWHIAUVHUWGUVKXDXEUWHUWIHIXIUNVIZUWRUWGUWSAHI
        UWFXJXGUWIHIXKVGHUWIIXMVLXLXNUWHUWMBUVMUWHUVMTBUVMDUIZWIZUWMBUVMWKUWHTB
        UVMCUIZXOUNZXPZTUXCWIZUXAUWHUVMTUXBWIUVMTVAUXEUWHBUVMCTUXBUVNUWHUVPUVQU
        VRAUVPUVQUWGUWCXQWOUXBURXRHIXSUVMUXBXTYDUWHUXDUVMTUXCUWTAUXCUWTWRUWGOXD
        ZUWHUXDUWTXPZUVMUWHUXCUWTUXFYAUWHDJVIZBUVMWKUXGUVMWRUWHUXHBUVMAUVNUXHUW
        GNXQYBBUVMDJYEVGYCYFYGBUVMTDUWTUWTURWLWMWNYHYIAUWGKTVIUWKRYJYKYGYLAUUJK
        GUUJYNVIAHIYMVCZUWHKRWPYOAUUQEFUAUNUUMAFEAFAIUUTVIZUWAFTVIZAUWOUWQHIUDU
        EZUXJAHUVJXEZAIUVKXEZAUVIUXLLHIYPVGZHIYQVOUWBUVQUXKBIUUTUWECFTQYRYSYTZW
        PZAEAHUUTVIZUWAETVIZAUWOUWQUXLUXRUXMUXNUXOHIUUDVOUWBUVQUXSBHUUTUWDCETPY
        RYSYTZWPZUUAAFEUXQUYAUUBUUEUUCAUUIUUKAFEUXPUXTUUFAUUJKGUXIRUUGYKUUH $.
    $}
  $}

  ${
    $d k y z A $.  $d k x y M $.  $d k x y N $.  $d k x y ph $.  $d x y z X $.
    $d x y C $.  $d x y D $.  $d x V $.  $d x y z Y $.
    dvfsumabs.m $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    dvfsumabs.a $e |- ( ph ->
      ( x e. ( M [,] N ) |-> A ) e. ( ( M [,] N ) -cn-> CC ) ) $.
    dvfsumabs.v $e |- ( ( ph /\ x e. ( M (,) N ) ) -> B e. V ) $.
    dvfsumabs.b $e |- ( ph ->
      ( RR _D ( x e. ( M (,) N ) |-> A ) ) = ( x e. ( M (,) N ) |-> B ) ) $.
    dvfsumabs.c $e |- ( x = M -> A = C ) $.
    dvfsumabs.d $e |- ( x = N -> A = D ) $.
    dvfsumabs.x $e |- ( ( ph /\ k e. ( M ..^ N ) ) -> X e. CC ) $.
    dvfsumabs.y $e |- ( ( ph /\ k e. ( M ..^ N ) ) -> Y e. RR ) $.
    dvfsumabs.l $e |- ( ( ph /\ ( k e. ( M ..^ N ) /\
      x e. ( k (,) ( k + 1 ) ) ) ) -> ( abs ` ( X - B ) ) <_ Y ) $.
    $( Compare a finite sum to an integral (the integral here is given as a
       function with a known derivative).  (Contributed by Mario Carneiro,
       14-May-2016.) $)
    dvfsumabs $p |- ( ph -> ( abs ` ( sum_ k e. ( M ..^ N ) X - ( D - C ) ) )
      <_ sum_ k e. ( M ..^ N ) Y ) $=
      ( vy cfzo co cv c1 caddc csb cmin csu cabs cfv cle cfn wcel fzofi a1i cfz
      wa cc wral cicc cz cin wceq cuz eluzel2 syl eluzelz fzval2 inss1 syl6eqss
      syl2anc sselda cmpt wf ccncf cncff eqid fmpt sylibr nfcsb1v nfel1 csbeq1a
      weq eleq1d rspc mpan9 syldan fzofzp1 csbeq1 rspccva syl2an elfzofz subcld
      ralrimiva fsumsub eqeq2 biimpa csbied oveq2d eqtrd fveq2d abscld fsumrecl
      cvv cmul wbr cxr adantl zred rexrd syl3anc wss adantr ax-resscn cncfmpt2f
      cr sylancl cdv cdm cioo mulcld adantlr sylan2 ovex syl5ss ax-1cn iooretop
      sstrd dvmptres mulid1d syl6eq nfcv nfov nffv oveq2 oveq12d fvmptf recnd
      vex fsumtscopo2 fsumcl fsumabs elfzoelz peano2re lep1d ubicc2 lbicc2 cres
      elfzole1 elfzle2 iccss syl22anc resmpt ccnfld ctopn ctx ccn subcn iccssre
      mulcn syl6ss ssid cncfmptc cncfmptid rescncf sylc eqeltrrd crn ctg tgioo2
      r19.21bi cnt iccntr dvmptntr reex prid1 ioossicc sseli dvmptcmul mpteq2dv
      dvmptid dvmptsub iooss1 iooss2 dmeqd dmmpti fveq1d fvmpt2 anassrs eqbrtrd
      cpr simpr nfmpt1 nfbr fveq2 breq1d dvlip ex mp2and peano2cn sub4d pncan2d
      subdid 3eqtr3d oveq1d 3eqtr2rd abs1 eqtr2d 3brtr4d fsumle letrd eqbrtrrd
      ) AHIUCUDZKBGUEZUFUGUDZCUHZBUXPCUHZUIUDZUIUDZGUJZUKULZUXOKGUJZFEUIUDZUIUD
      ZUKULUXOLGUJZUMAUYBUYFUKAUYBUYDUXOUXTGUJZUIUDUYFAUXOKUXTGUXOUNUOAHIUPUQZS
      AUXPUXOUOZUSZUXRUXSABUBUEZCUHZUTUOZUBHIURUDZVAZUXQUYOUOZUXRUTUOZUYJAUYNUB
      UYOAUYLUYOUOUYLHIVBUDZUOZUYNAUYOUYSUYLAUYOUYSVCVDZUYSAHVCUOZIVCUOZUYOVUAV
      EAIHVFULUOZVUBMHIVGVHZAVUDVUCMHIVIVHZHIVJVMUYSVCVKVLVNACUTUOZBUYSVAZUYTUY
      NAUYSUTBUYSCVOZVPZVUHAVUIUYSUTVQUDZUOZVUJNUYSUTVUIVRVHBUYSUTCVUIVUIVSVTWA
      ZVUGUYNBUYLUYSBUYMUTBUYLCWBWCBUBWEZCUYMUTBUYLCWDWFWGWHWIZWPZHIUXPWJZUYNUY
      RUBUXQUYOUYLUXQVEUYMUXRUTBUYLUXQCWKZWFWLWMZAUYPUXPUYOUOUXSUTUOZUYJVUPUXPH
      IWNUYNVUTUBUXPUYOUBGWEUYMUXSUTBUYLUXPCWKZWFWLWMZWOZWQAUYHUYEUYDUIAUYMUXSU
      XREGUBFHIVVAVURUYLHVEZBUYLCEXFUYLXFUOZVVDUBUUAZUQVVDVUNUSBUEZHVEZCEVEVVDV
      UNVVHUYLHVVGWRWSQVHWTUYLIVEZBUYLCFXFVVEVVIVVFUQVVIVUNUSVVGIVEZCFVEVVIVUNV
      VJUYLIVVGWRWSRVHWTMVUOUUBXAXBXCAUYCUXOUYAUKULZGUJUYGAUYBAUXOUYAGUYIUYKKUX
      TSVVCWOZUUCXDAUXOVVKGUYIUYKUYAVVLXDZXEAUXOLGUYITXEAUXOUYAGUYIVVLUUDAUXOVV
      KLGUYIVVMTUYKUXQBUXPUXQVBUDZKVVGXGUDZCUIUDZVOZULZUXPVVQULZUIUDZUKULZLUXQU
      XPUIUDZUKULZXGUDZVVKLUMUYKUXQVVNUOZUXPVVNUOZVWAVWDUMXHZUYKUXPXIUOZUXQXIUO
      ZUXPUXQUMXHZVWEUYKUXPUYKUXPUYJUXPVCUOAUXPHIUUEXJXKZXLZUYKUXQUYKUXPXRUOZUX
      QXRUOZVWKUXPUUFVHZXLZUYKUXPVWKUUGZUXPUXQUUHXMZUYKVWHVWIVWJVWFVWLVWPVWQUXP
      UXQUUIXMZUYKVWEVWFUSVWGUYKUBUXPUXQVVQLUXQUXPVWKVWOUYKBUYSVVPVOZVVNUUJZVVQ
      VVNUTVQUDZUYKVVNUYSXNZVXAVVQVEUYKHXRUOZIXRUOZHUXPUMXHZUXQIUMXHZVXCAVXDUYJ
      AHVUEXKZXOZAVXEUYJAIVUFXKZXOZUYJVXFAUXPHIUUKXJZUYKUYQVXGUYJUYQAVUQXJUXQHI
      UULVHZHIUXPUXQUUMUUNZBUYSVVNVVPUUOVHUYKVXCVWTVUKUOVXAVXBUOVXNUYKBVVOCUIUU
      PUUQULZUYSVXOVSZUIVXOVXOUURUDVXOUUSUDZUOUYKVXOVXPUUTUQUYKBKVVGXGVXOUYSVXP
      XGVXQUOUYKVXOVXPUVBUQUYKKUTUOZUYSUTXNZUTUTXNZBUYSKVOVUKUOSUYKUYSXRUTAUYSX
      RXNZUYJAVXDVXEVYAVXHVXJHIUVAVMXOZXPUVCZVXTUYKUTUVDZUQBKUYSUTUVEXMUYKVXSVX
      TBUYSVVGVOVUKUOVYCVYDBUYSUTUVFXSXQAVULUYJNXOXQUYSUTVVNVWTUVGUVHUVIUYKXRVV
      QXTUDZYABUXPUXQYBUDZKDUIUDZVOZYAVYFUYKVYEVYHUYKVYEXRBVYFVVPVOXTUDVYHUYKBV
      VPXRYBUVJUVKULZVXOVVNVYFXRUTXNUYKXPUQZUYKVVNUYSXRVXNVYBYJUYKVVGVVNUOVVGUY
      SUOZVVPUTUOZUYKVVNUYSVVGVXNVNUYKVYKUSZVVOCVYMKVVGUYKVXRVYKSXOUYKUYSUTVVGV
      YCVNYCZAVYKVUGUYJAVUGBUYSVUMUVMYDZWOZWIVXOVXPUVLZVXPUYKVWMVWNVVNVYIUVNULU
      LVYFVEVWKVWOUXPUXQUVOVMUVPUYKBVVPVYGXRVYIVXOXFHIYBUDZVYFXRXRUTUWMUOUYKXRU
      TUVQUVRUQZVVGVYRUOZUYKVYKVYLVYRUYSVVGHIUVSZUVTZVYPYEVYGXFUOZUYKVYTUSZKDUI
      YFZUQUYKBVVOKCDXRUTJVYRVYSVYTUYKVYKVVOUTUOWUBVYNYEUYKVXRVYTSXOUYKXRBVYRVV
      OVOXTUDBVYRKUFXGUDZVOBVYRKVOUYKBVVGUFKXRUTVYRVYSUYKVYRUTVVGUYKVYRUYSUTWUA
      VYCYGVNUFUTUOZWUDYHUQUYKBVVGUFXRVYIVXOUTXRVYRVYSUYKXRUTVVGVYJVNWUGUYKVVGX
      RUOUSYHUQUYKBXRVYSUWCUYKVYRUYSXRWUAVYBYGVYQVXPVYRVYIUOUYKHIYIUQYKSUWAUYKB
      VYRWUFKUYKKSYLZUWBXBVYTUYKVYKVUGWUBVYOYEAVYTDJUOUYJOYDAXRBVYRCVOXTUDBVYRD
      VOVEUYJPXOUWDUYKVYFHUXQYBUDZVYRUYKHXIUOVXFVYFWUIXNUYKHVXIXLVXLHUXPUXQUWEV
      MUYKIXIUOVXGWUIVYRXNUYKIVXKXLVXMHUXQIUWFVMYJVYQVXPVYFVYIUOUYKUXPUXQYIUQYK
      XBZUWGBVYFVYGVYHWUEVYHVSZUWHYMTUYKVVGVYEULZUKULZLUMXHZBVYFVAUYLVYFUOUYLVY
      EULZUKULZLUMXHZUYKWUNBVYFUYKVVGVYFUOZUSZWUMVYGUKULZLUMWUSWULVYGUKWUSWULVV
      GVYHULZVYGWUSVVGVYEVYHUYKVYEVYHVEWURWUJXOUWIWUSWURWUCWVAVYGVEUYKWURUWNWUE
      BVYFVYGXFVYHWUKUWJXSXBXCAUYJWURWUTLUMXHUAUWKUWLWPWUNWUQBUYLVYFBWUPLUMBWUO
      UKBUKYNBUYLVYEBXRVVQXTBXRYNBXTYNBVVNVVPUWOYOBUYLYNYPYPBUMYNBLYNUWPVUNWUMW
      UPLUMVUNWULWUOUKVVGUYLVYEUWQXCUWRWGWHUWSUWTUXAUYKUYAVVTUKUYKVVTKUXQXGUDZU
      XRUIUDZKUXPXGUDZUXSUIUDZUIUDWVBWVDUIUDZUXTUIUDUYAUYKVVRWVCVVSWVEUIUYKVWEW
      VCXFUOVVRWVCVEVWRWVBUXRUIYFBUXQVVPWVCVVNVVQXFBUXQYNBWVBUXRUIBWVBYNBUIYNZB
      UXQCWBYOVVGUXQVEVVOWVBCUXRUIVVGUXQKXGYQBUXQCWDYRVVQVSZYSXSUYKVWFWVEUTUOVV
      SWVEVEVWSUYKWVDUXSUYKKUXPSUYKUXPVWKYTZYCZVVBWOBUXPVVPWVEVVNVVQUTBUXPYNBWV
      DUXSUIBWVDYNWVGBUXPCWBYOBGWEVVOWVDCUXSUIVVGUXPKXGYQBUXPCWDYRWVHYSVMYRUYKW
      VBWVDUXRUXSUYKKUXQSUYKUXPUTUOUXQUTUOWVIUXPUXBVHZYCWVJVUSVVBUXCUYKWVFKUXTU
      IUYKKVWBXGUDWUFWVFKUYKVWBUFKXGUYKUXPUFWVIWUGUYKYHUQUXDZXAUYKKUXQUXPSWVKWV
      IUXEWUHUXFUXGUXHXCUYKVWDLUFXGUDLUYKVWCUFLXGUYKVWCUFUKULUFUYKVWBUFUKWVLXCU
      XIYMXAUYKLUYKLTYTYLUXJUXKUXLUXMUXN $.
  $}

  ${
    $d x ph $.  $d x S $.
    dvmptrecl.s $e |- ( ph -> S C_ RR ) $.
    dvmptrecl.a $e |- ( ( ph /\ x e. S ) -> A e. RR ) $.
    dvmptrecl.v $e |- ( ( ph /\ x e. S ) -> B e. V ) $.
    dvmptrecl.b $e |- ( ph ->
      ( RR _D ( x e. S |-> A ) ) = ( x e. S |-> B ) ) $.
    $( Real closure of a derivative.  (Contributed by Mario Carneiro,
       18-May-2016.) $)
    dvmptrecl $p |- ( ( ph /\ x e. S ) -> B e. RR ) $=
      ( cr wcel cmpt wf wral cdv co cdm wss eqid fmptd dvfre syl2anc dmeqd wceq
      ralrimiva dmmptg syl eqtrd feq12d mpbid fmpt sylibr r19.21bi ) ADKLZBEAEK
      BEDMZNZUOBEOAKBECMZPQZRZKUSNZUQAEKURNEKSVAABECKURHURTUAGEURUBUCAUTEKUSUPJ
      AUTUPRZEAUSUPJUDADFLZBEOVBEUEAVCBEIUFBEDFUGUHUIUJUKBEKDUPUPTULUMUN $.
  $}

  ${
    $d y z A $.  $d c e k m y z B $.  $d x z C $.  $d c k x y D $.  $d x y E $.
    $d c e y z G $.  $d m y z H $.  $d c e k m x y ph $.  $d c e k m x y z S $.
    $d y L $.  $d k x z M $.  $d c u v w x z T $.  $d k m x y z Y $.  $d x Z $.
    $d k x U $.  $d k m u v w x y z X $.
    dvfsum.s $e |- S = ( T (,) +oo ) $.
    dvfsum.z $e |- Z = ( ZZ>= ` M ) $.
    dvfsum.m $e |- ( ph -> M e. ZZ ) $.
    dvfsum.d $e |- ( ph -> D e. RR ) $.
    dvfsum.md $e |- ( ph -> M <_ ( D + 1 ) ) $.
    dvfsum.t $e |- ( ph -> T e. RR ) $.
    dvfsum.a $e |- ( ( ph /\ x e. S ) -> A e. RR ) $.
    dvfsum.b1 $e |- ( ( ph /\ x e. S ) -> B e. V ) $.
    dvfsum.b2 $e |- ( ( ph /\ x e. Z ) -> B e. RR ) $.
    dvfsum.b3 $e |- ( ph ->
      ( RR _D ( x e. S |-> A ) ) = ( x e. S |-> B ) ) $.
    dvfsum.c $e |- ( x = k -> B = C ) $.
    ${
      dvfsumrlimf.g $e |- G = ( x e. S |->
        ( sum_ k e. ( M ... ( |_ ` x ) ) C - A ) ) $.
      $( Lemma for ~ dvfsumrlim .  (Contributed by Mario Carneiro,
         18-May-2016.) $)
      dvfsumrlimf $p |- ( ph -> G : S --> RR ) $=
        ( cv cfl cfv cfz co csu cmin cr wcel wa fzfid wral ralrimiva adantr cuz
        elfzuz syl6eleqr weq eleq1d rspccva syl2an fsumrecl resubcld fmptd ) AB
        GKBUFZUGUHZUIUJZEIUKZCULUJUMJAVJGUNZUOZVMCVOVLEIVOKVKUPVODUMUNZBMUQZIUF
        ZMUNEUMUNZVRVLUNZAVQVNAVPBMUBURUSVTVRKUTUHMVRKVKVAOVBVPVSBVRMBIVCDEUMUD
        VDVEVFVGTVHUEVI $.
    $}

    ${
      dvfsum.u $e |- ( ph -> U e. RR* ) $.
      dvfsum.l $e |- ( ( ph /\ ( x e. S /\ k e. S ) /\
        ( D <_ x /\ x <_ k /\ k <_ U ) ) -> C <_ B ) $.
      ${
        dvfsum.h $e |- H = ( x e. S |-> ( ( ( x - ( |_ ` x ) ) x. B ) +
          ( sum_ k e. ( M ... ( |_ ` x ) ) C - A ) ) ) $.
        dvfsumlem1.1 $e |- ( ph -> X e. S ) $.
        dvfsumlem1.2 $e |- ( ph -> Y e. S ) $.
        dvfsumlem1.3 $e |- ( ph -> D <_ X ) $.
        dvfsumlem1.4 $e |- ( ph -> X <_ Y ) $.
        dvfsumlem1.5 $e |- ( ph -> Y <_ U ) $.
        ${
          dvfsumlem1.6 $e |- ( ph -> Y <_ ( ( |_ ` X ) + 1 ) ) $.
          $( Lemma for ~ dvfsumrlim .  (Contributed by Mario Carneiro,
             17-May-2016.) $)
          dvfsumlem1 $p |- ( ph -> ( H ` Y ) =
            ( ( ( ( Y - ( |_ ` X ) ) x. [_ Y / x ]_ B ) - [_ Y / x ]_ A ) +
              sum_ k e. ( M ... ( |_ ` X ) ) C ) ) $=
            ( cfl cfv cmin co csb cmul cfz csu caddc c1 clt wbr wceq wa cr wcel
            cz cle cpnf cioo ioossre eqsstri sseldi flcld reflcl syl flle letrd
            wb flbi baibd syl21anc biimpar oveq2d oveq1d sumeq1d oveq12d adantr
            simpr peano2zd eqeltrd flid eqtrd recnd subcld cc ax-1cn a1i cv wss
            wral dvmptrecl ralrimiva nfcsb1v nfel1 csbeq1a eleq1d rspc subsub4d
            sylc subdird mulid2d 3eqtr3d cuz zred peano2rem 1re mpbird peano2zm
            lesubaddd syl2anc mpbid eluz2 syl3anbrc elfzuz syl6eleqr syl2an cvv
            flge ovex sylancl 3eqtr4d nfcv nfov eqeq2 csbied eqcomd pncan fzfid
            rspccva fsumm1 csbeq1d fsumcl addsubd nppcan3d wo peano2re mpjaodan
            mulcld leloed id fveq2 fvmptf subadd23d ) AOOUQURZUSUTZBODVAZVBUTZL
            UVAVCUTZEJVDZBOCVAZUSUTZVEUTZONUQURZUSUTZUVCVBUTZLUVJVCUTZEJVDZUVGU
            SUTZVEUTZOKURZUVLUVGUSUTUVNVEUTAOUVJVFVEUTZVGVHZUVIUVPVIOUVRVIZAUVS
            VJZUVDUVLUVHUVOVEUWAUVBUVKUVCVBUWAUVAUVJOUSAUVAUVJVIZUVSAOVKVLZUVJV
            MVLZUVJOVNVHZUWBUVSWEAGVKOGHVOVPUTVKQHVOVQVRZULVSZANAGVKNUWFUKVSZVT
            ZAUVJNOANVKVLZUVJVKVLZUWHNWAWBZUWHUWGAUWJUVJNVNVHUWHNWCWBUNWDUWCUWD
            VJUWBUWEUVSOUVJWFWGWHWIZWJWKUWAUVFUVNUVGUSUWAUVEUVMEJUWAUVAUVJLVCUW
            MWJWLWKWMAUVTVJZUVIUVLUVCUSUTZUVOUVCVEUTZVEUTUVPUWNUVDUWOUVHUWPVEUW
            NUVDOUVRUSUTZUVCVBUTZUWOUWNUVBUWQUVCVBUWNUVAUVROUSUWNUVAOUVRUWNOVMV
            LUVAOVIUWNOUVRVMAUVTWOZUWNUVJUWNNAUWJUVTUWHWNVTWPWQOWRWBUWSWSZWJWKA
            UWRUWOVIUVTAUVKVFUSUTZUVCVBUTUVLVFUVCVBUTZUSUTUWRUWOAUVKVFUVCAOUVJA
            OUWGWTZAUVJUWLWTZXAZVFXBVLZAXCXDZAOGVLZDXBVLZBGXGUVCXBVLZULAUXIBGAB
            XEZGVLVJZDABCDGMGVKXFAUWFXDUCUDUFXHWTXIUXIUXJBOGBUVCXBBODXJZXKUXKOV
            IZDUVCXBBODXLZXMXNXPZXQAUXAUWQUVCVBAOUVJVFUXCUXDUXGXOWKAUXBUVCUVLUS
            AUVCUXPXRWJXSWNWSUWNUVHUVNUVCVEUTZUVGUSUTZUWPUWNUVFUXQUVGUSUWNLUVRV
            CUTZEJVDZUVNBUVRDVAZVEUTZUVFUXQAUXTUYBVIUVTAUXTLUVRVFUSUTZVCUTZEJVD
            ZUYAVEUTUYBAEUYAJLUVRALVMVLZUVRVMVLLUVRVNVHZUVRLXTURZVLSAUVJUWIWPAL
            VFUSUTZUVJVNVHZUYGAUYINVNVHZUYJAUYIFNALVKVLUYIVKVLALSYAZLYBWBTUWHAU
            YIFVNVHLFVFVEUTVNVHUAALVFFUYLVFVKVLAYCXDZTYFYDUMWDAUWJUYIVMVLZUYKUY
            JWEUWHAUYFUYNSLYEWBNUYIYOYGYHALVFUVJUYLUYMUWLYFYHLUVRYIYJAUXIBPXGZJ
            XEZPVLZEXBVLZUYPUXSVLZAUXIBPAUXKPVLVJDUEWTXIZUYSUYPUYHPUYPLUVRYKRYL
            UXIUYRBUYPPUXKUYPVIZDEXBUGXMUUFZYMUYPUVRVIZUYAEVUCBUVRDEYNUVRYNVLVU
            CUVJVFVEYPXDVUCUXKUVRVIZVJVUADEVIVUCVUAVUDUYPUVRUXKUUAWIUGWBUUBUUCU
            UGAUYEUVNUYAVEAUYDUVMEJAUYCUVJLVCAUVJXBVLUXFUYCUVJVIUXDXCUVJVFUUDYQ
            WJWLWKWSWNUWNUVEUXSEJUWNUVAUVRLVCUWTWJWLUWNUVCUYAUVNVEUWNBOUVRDUWSU
            UHWJYRWKAUXRUWPVIUVTAUVNUVCUVGAUVMEJALUVJUUEAUYOUYQUYRUYPUVMVLZUYTV
            UEUYPUYHPUYPLUVJYKRYLVUBYMUUIZUXPAUXHCXBVLZBGXGUVGXBVLZULAVUGBGUXLC
            UCWTXIVUGVUHBOGBUVGXBBOCXJZXKUXNCUVGXBBOCXLZXMXNXPZUUJWNWSWMUWNUVLU
            VCUVOAUVLXBVLUVTAUVKUVCUXEUXPUUOZWNAUXJUVTUXPWNAUVOXBVLUVTAUVNUVGVU
            FVUKXAWNUUKWSAOUVRVNVHUVSUVTUULUPAOUVRUWGAUWKUVRVKVLUWLUVJUUMWBUUPY
            HUUNAUXHUVIYNVLUVQUVIVIULUVDUVHVEYPBOUXKUXKUQURZUSUTZDVBUTZLVUMVCUT
            ZEJVDZCUSUTZVEUTUVIGKYNBOYSBUVDUVHVEBUVBUVCVBBUVBYSBVBYSUXMYTBVEYSB
            UVFUVGUSBUVFYSBUSYSVUIYTYTUXNVUOUVDVURUVHVEUXNVUNUVBDUVCVBUXNUXKOVU
            MUVAUSUXNUUQUXKOUQUURZWMUXOWMUXNVUQUVFCUVGUSUXNVUPUVEEJUXNVUMUVALVC
            VUSWJWLVUJWMWMUJUUSYQAUVLUVGUVNVULVUKVUFUUTYR $.

          $( Lemma for ~ dvfsumrlim .  (Contributed by Mario Carneiro,
             17-May-2016.) $)
          dvfsumlem2 $p |- ( ph -> ( ( H ` Y ) <_ ( H ` X ) /\
          ( ( H ` X ) - [_ X / x ]_ B ) <_ ( ( H ` Y ) - [_ Y / x ]_ B ) ) ) $=
            ( vy cfv cle wbr csb cmin co cmul caddc cr cpnf cioo wcel clt wa wb
            cxr rexrd syl mpbid resubcld cv wral syl3anc wss a1i sselda cmpt wf
            eqid fmptd nfcv nfcsb1v csbeq1a cbvmpt fmpt sylibr syldan ralrimiva
            r19.21bi wceq csbeq1 eleq1d rspcv sylc remulcld weq recnd subdid cc
            ccncf syl6ss ax-resscn cncfmptc remulcl cncfmpt2ss c1 syl5ss ax-1cn
            cdv dvmptres dvmptcmul mulid1d mpteq2dv eqtrd cdm mpbird adantr w3a
            letrd eleq1 breq2 breq1 3anbi23d imbi12d breq2d cneg oveq1d subdird
            wi oveq2 cc0 3brtr4d oveq2d cfl cfz ioossre eqsstri sseldi syl6eleq
            csu elioopnf simpld reflcl cicc ubicc2 pnfxr simprd ltpnf syl6sseqr
            iccssioo dvmptrecl lbicc2 fzfid cuz elfzuz syl6eleqr rspccva syl2an
            syl22anc fsumrecl ccnfld ctopn mulcn cncfmptid sylancl cpr ioossicc
            reex prid1 crn ctg simpr dvmptid tgioo2 iooretop cres resmpt dmmptg
            syl31anc cncffvrn sylancr syl5eqelr rescncf eqeltrrd oveq2i 3eqtr3g
            dmeqd sseli simpl elicc2 syl2anc biimpa simp1d simp2d simp3d simp2r
            dvcn anbi2d vex csbief syl5eqr breq1d nfv nfbr nfim anbi1d 3anbi12d
            chvar vtoclg mpcom syl123anc sylan2 dvle eqbrtrd subsubd negsubdi2d
            lesubd nnncan2d mulcomd 3eqtr3d negeqd eqtr3d negsubdid eqtr4d flle
            3eqtrd breqtrrd subge0d lemul2ad lesub1dd leadd1dd dvfsumlem1 leidd
            xrletrd fllep1 subcld addcomd subsub2d 3eqtr4d simp2l vtoclgf vtocl
            peano2rem renegcld 1re lesubadd2d suble0d le0neg1d mulneg1d 3brtr3d
            subled lenegd mulid2d sub32d addsubd jca ) AOKURZNKURZUSUTVVEBNDVAZ
            VBVCZVVDBODVAZVBVCZUSUTAONUUAURZVBVCZVVHVDVCZBOCVAZVBVCZLVVJUUBVCZE
            JUUGZVEVCZNVVJVBVCZVVFVDVCZBNCVAZVBVCZVVPVEVCZVVDVVEUSAVVNVWAVVPAVV
            LVVMAVVKVVHAOVVJAGVFOGHVGVHVCZVFQHVGUUCZUUDZULUUEZANVFVIZVVJVFVIAVW
            GHNVJUTZANVWCVIZVWGVWHVKZANGVWCUKQUUFAHVMVIZVWIVWJVLAHUBVNZHNUUHVOV
            PZUUIZNUUJVOZVQZAONOUUKVCZVIZBUQVRZDVAZVFVIZUQVWQVSZVVHVFVIZANVMVIZ
            OVMVIZNOUSUTZVWRANVWNVNZAOVWFVNZUNNOUULVTZAVXAUQVWQAVWSVWQVIZVWSGVI
            ZVXAAVWQGVWSAVWQVWCGAVWKVGVMVIZVWHOVGVJUTZVWQVWCWAVWLVXLAUUMWBAVWGV
            WHVWMUUNAOVFVIZVXMVWFOUUOVOHVGNOUUQUVFZQUUPZWCZAVXAUQGAGVFBGDWDZWEV
            XAUQGVSABGDVFVXRABCDGMGVFWAZAVWEWBZUCUDUFUURVXRWFWGUQGVFVWTVXRBUQGD
            VWTUQDWHBVWSDWIZBVWSDWJZWKZWLWMWPZWNWOZVXAVXCUQOVWQVWSOWQZVWTVVHVFB
            VWSODWRWSWTXAZXBZAVWRBVWSCVAZVFVIZUQVWQVSZVVMVFVIZVXIAVYJUQVWQAVXJV
            XKVYJVXQAVYJUQGAGVFBGCWDZWEZVYJUQGVSABGCVFVYMUCVYMWFZWGZUQGVFVYIVYM
            BUQGCVYIUQCWHBVWSCWIBVWSCWJWKZWLWMWPZWNWOZVYJVYLUQOVWQVYFVYIVVMVFBV
            WSOCWRZWSWTXAZVQZAVVSVVTAVVRVVFANVVJVWNVWOVQZANVWQVIZVXBVVFVFVIZAVX
            DVXEVXFWUDVXGVXHUNNOUUSVTZVYEVXAWUEUQNVWQVWSNWQZVWTVVFVFBVWSNDWRZWS
            WTXAZXBZAWUDVYKVVTVFVIZWUFVYSVYJWUKUQNVWQWUGVYIVVTVFBVWSNCWRZWSWTXA
            ZVQZAVVOEJALVVJUUTADVFVIZBPVSJVRZPVIEVFVIZWUPVVOVIZAWUOBPUEWOWURWUP
            LUVAURPWUPLVVJUVBRUVCWUOWUQBWUPPBJXCDEVFUGWSUVDUVEUVGZAVVNVVRVVHVDV
            CZVVTVBVCVWAWUBAWUTVVTAVVRVVHWUCVYGXBZWUMVQWUNAVVTWUTVVNWUMWVAWUBAV
            VTVVMVVHONVBVCZVDVCZVBVCZWUTVVNVBVCZUSAWVCVVMVVTAVVHWVBVYGAONVWFVWN
            VQZXBZWUAWUMAWVCVVHOVDVCZVVHNVDVCZVBVCVVMVVTVBVCZUSAVVHONAVVHVYGXDZ
            AOVWFXDZANVWNXDZXEAUQVVHVWSVDVCZVVHVYIVWTWVIVVTWVHVVMNONOVWNVWFAUQV
            VHVWSVFVDUVHUVIURZVWQWVOWFZWVOWVPUVJZAVXCVWQXFWAZVFXFWAZUQVWQVVHWDV
            WQVFXGVCZVIVYGAVWQVFXFAVWQVWCVFVXOVWDXHZXIXHZWVSAXIWBZUQVVHVWQVFXJV
            TAVWQVFWAWVSUQVWQVWSWDWVTVIWWAXIUQVWQVFUVKUVLZXIVVHVWSXKXLAVFUQNOVH
            VCZWVNWDXPVCUQWWEVVHXMVDVCZWDUQWWEVVHWDAUQVWSXMVVHVFXFWWEVFVFXFUVMV
            IAVFXFUVOUVPWBZAVWSWWEVIZVKZVWSAWWEVFVWSAWWEVWQVFNOUVNZWWAXNZWCXDZX
            MXFVIZWWIXOWBZAUQVWSXMVFVHUVQUVRURZWVOXFVFWWEWWGAVWSVFVIZVKZVWSAWWP
            UVSXDWWMWWQXOWBAUQVFWWGUVTWWKWVOWVPUWAZWVPWWEWWOVIANOUWBWBZXQZWVKXR
            AUQWWEWWFVVHAVVHWVKXSXTYAAUQGVYIWDZVWQUWCZUQVWQVYIWDZWVTAVWQGWAZWXB
            WXCWQVXPUQGVWQVYIUWDVOAWXDWXAGVFXGVCZVIWXBWVTVIVXPAWXAVYMWXEVYQAVYM
            WXEVIZVYNVYPAWVSVYMGXFXGVCVIZWXFVYNVLXIAWVSGXFVYMWEVXSVFVYMXPVCZYBZ
            GWQWXGWWCABGCXFVYMABVRZGVIZVKCUCXDVYOWGVXTAWXIVXRYBZGAWXHVXRUFUWNAD
            MVIZBGVSWXLGWQAWXMBGUDWOBGDMUWEVOYAGVFVYMUXDUWFGXFVFVYMUWGUWHYCUWIG
            VFVWQWXAUWJXAUWKZAUQVYIVWTVFWWOWVOVFGWWEWWGAVXKVKVYIVYRXDVYDAWXHVXR
            VFWXAXPVCUQGVWTWDUFVYMWXAVFXPVYQUWLVYCUWMAWWEVWQGWWJVXPXNWWRWVPWWSX
            QZWWHAVXJVVHVWTUSUTZWWEVWQVWSWWJUWOZAVXJVKZAVXKOGVIZFVWSUSUTZVWSOUS
            UTZOIUSUTZWXPAVXJUWPZVXQAWXSVXJULYDWXRFNVWSAFVFVIVXJTYDAVWGVXJVWNYD
            WXRWWPNVWSUSUTZWYAAVXJWWPWYDWYAYEZAVWGVXNVXJWYEVLVWNVWFNOVWSUWQUWRU
            WSZUWTZAFNUSUTZVXJUMYDZWXRWWPWYDWYAWYFUXAZYFWXRWWPWYDWYAWYFUXBZAWYB
            VXJUOYDZWXSAVXKWXSVKZWXTWYAWYBYEZYEZWXPAVXKWXSWYNUXCAVXKWUPGVIZVKZW
            XTVWSWUPUSUTZWUPIUSUTZYEZYEZEVWTUSUTZYPZWYOWXPYPJOGWUPOWQZXUAWYOXUB
            WXPXUDWYQWYMWYTWYNAXUDWYPWXSVXKWUPOGYGUXEXUDWYRWYAWYSWYBWXTWUPOVWSU
            SYHWUPOIUSYIYJYJXUDEVVHVWTUSXUDEBWUPDVAZVVHBWUPDEJUXFBEWHZUGUXGZBWU
            PODWRUXHUXIYKAWXKWYPVKZFWXJUSUTZWXJWUPUSUTZWYSYEZYEZEDUSUTZYPZXUCBU
            QXUAXUBBXUABUXJBEVWTUSXUFBUSWHZVYAUXKUXLBUQXCZXULXUAXUMXUBXUPXUHWYQ
            XUKWYTAXUPWXKVXKWYPWXJVWSGYGUXMXUPXUIWXTXUJWYRWYSWXJVWSFUSYHWXJVWSW
            UPUSYIUXNYJXUPDVWTEUSVYBYLYKUIUXOUXPUXQUXRZUXSWUFVXIUNVWSNVVHVDYQWU
            LVWSOVVHVDYQVYTUXTUYAUYDAWVEWUTVVLVBVCZVVMVEVCZWVCVVMVBVCYMZWVDAWUT
            VVLVVMAWUTWVAXDZAVVLVYHXDZAVVMWUAXDZUYBAXUSWVCYMZVVMVEVCXUTAXURXVDV
            VMVEAVVLWUTVBVCZYMXURXVDAVVLWUTXVBXVAUYCAXVEWVCAVVKVVRVBVCZVVHVDVCW
            VBVVHVDVCXVEWVCAXVFWVBVVHVDAONVVJWVLWVMAVVJVWOXDUYEZYNAVVKVVRVVHAVV
            KVWPXDZAVVRWUCXDZWVKYOAWVBVVHAWVBWVFXDZWVKUYFUYGUYHUYIYNAWVCVVMAWVC
            WVGXDZXVCUYJUYKAWVCVVMXVKXVCUYCUYMUYNUYDAWUTVVSVVTWVAWUJWUMAVVHVVFV
            VRVYGWUIWUCAYRVVRUSUTVVJNUSUTZAVWGXVLVWNNUYLVOANVVJVWNVWOUYOYCAWUDW
            XPUQVWQVSVVHVVFUSUTZWUFAWXPUQVWQXUQWOWXPXVMUQNVWQWUGVWTVVFVVHUSWUHY
            LWTXAZUYPUYQYFUYRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUO
            UPUYSZABCDEFGHIJKLMNNPQRSTUAUBUCUDUEUFUGUHUIUJUKUKUMANVWNUYTANOIVXG
            VXHUHUNUOVUAAVWGNVVJXMVEVCZUSUTVWNNVUBVOUYSZYSAVWBVVFVBVCZVVQVVHVBV
            CZVVGVVIUSAVWAVVFVBVCZVVPVEVCVVNVVHVBVCZVVPVEVCXVRXVSUSAXVTXWAVVPAV
            WAVVFWUNWUIVQAVVNVVHWUBVYGVQWUSAVVSVVFVBVCZVVTVBVCZVVLVVHVBVCZVVMVB
            VCZXVTXWAUSAVVRXMVBVCZVVFVDVCZVVTVBVCZVVKXMVBVCZVVHVDVCZVVMVBVCZXWC
            XWEUSAXWHXWIVVFVDVCZVVMVBVCZXWKAXWGVVTAXWFVVFAVVRVFVIXWFVFVIWUCVVRV
            UJVOZWUIXBZWUMVQAXWLVVMAXWIVVFAVVKVFVIXWIVFVIVWPVVKVUJVOZWUIXBZWUAV
            QZAXWJVVMAXWIVVHXWPVYGXBZWUAVQAXWGXWMVVTXWOXWRWUMAXWGXWMVBVCZVVMVVF
            WVBVDVCZVBVCZVVTUSAXWTVVMXWLXWGVBVCZVBVCZXXBAXWGXWLVBVCZVVMVEVCVVMX
            XEVEVCXWTXXDAXXEVVMAXWGXWLAXWGXWOXDZAXWLXWQXDZVUCXVCVUDAXWGXWLVVMXX
            FXXGXVCUYBAVVMXWLXWGXVCXXGXXFVUEVUFAXXCXXAVVMVBAXWIXWFVBVCZVVFVDVCW
            VBVVFVDVCXXCXXAAXXHWVBVVFVDAXXHXVFWVBAVVKVVRXMXVHXVIWWMAXOWBZUYEXVG
            YAYNAXWIXWFVVFAXWIXWPXDZAXWFXWNXDAVVFWUIXDZYOAWVBVVFXVJXXKUYFUYGYTY
            AAVVMVVTXXAWUAWUMAVVFWVBWUIWVFXBAWVJVVFOVDVCZVVFNVDVCZVBVCXXAUSAUQV
            YIVWTVVFVWSVDVCZVVFVVTXXMVVMXXLNONOVWNVWFWXNWXOAUQVVFVWSVFVDWVOVWQW
            VPWVQAWUEWVRWVSUQVWQVVFWDWVTVIWUIWWBWWCUQVVFVWQVFXJVTWWDXIVVFVWSXKX
            LAVFUQWWEXXNWDXPVCUQWWEVVFXMVDVCZWDUQWWEVVFWDAUQVWSXMVVFVFXFWWEWWGW
            WLWWNWWTXXKXRAUQWWEXXOVVFAVVFXXKXSXTYAWWHAVXJVWTVVFUSUTZWXQWXRANGVI
            ZVXKWYHWYDVWSIUSUTZXXPWYCAXXQVXJUKYDVXQWYIWYJWXRVWSOIWXRVWSWYGVNAVX
            EVXJVXHYDAIVMVIVXJUHYDWYKWYLVUAAXXQWYPVKZWYHNWUPUSUTZWYSYEZYEZEVVFU
            SUTZYPZAXXQVXKVKZWYHWYDXXRYEZYEZXXPYPJVWSUQUXFJUQXCZXYBXYGXYCXXPXYH
            XXSXYEXYAXYFAXYHWYPVXKXXQWUPVWSGYGUXEXYHXXTWYDWYSXXRWYHWUPVWSNUSYHW
            UPVWSIUSYIYJYJXYHEVWTVVFUSXYHEXUEVWTXUGBWUPVWSDWRUXHUXIYKXXQXYBXYCA
            XXQWYPXYAVUGXUNXYDBNGBNWHXYBXYCBXYBBUXJBEVVFUSXUFXUOBNDWIUXKUXLWXJN
            WQZXULXYBXUMXYCXYIXUHXXSXUKXYAAXYIWXKXXQWYPWXJNGYGUXMXYIXUIWYHXUJXX
            TWYSWXJNFUSYHWXJNWUPUSYIUXNYJXYIDVVFEUSBNDWJYLYKUIVUHUXQVUIUXRUXSWU
            FVXIUNWULVWSNVVFVDYQVYTVWSOVVFVDYQUXTAVVFONXXKWVLWVMXEUYNVURUYAVURA
            XWLXWJVVMXWQXWSWUAAXWLXWJUSUTXWJYMZXWLYMZUSUTAXWIYMZVVHVDVCXYLVVFVD
            VCXYJXYKUSAVVHVVFXYLVYGWUIAXWIXWPVUKAXWIYRUSUTZYRXYLUSUTAXYMVVKXMUS
            UTZAXYNOXVPUSUTUPAOVVJXMVWFVWOXMVFVIAVULWBZVUMYCAVVKXMVWPXYOVUNYCAX
            WIXWPVUOVPXVNUYPAXWIVVHXXJWVKVUPAXWIVVFXXJXXKVUPVUQAXWLXWJXWQXWSVUS
            YCUYQYFAXWGXWBVVTVBAXWGVVSXMVVFVDVCZVBVCXWBAVVRXMVVFXVIXXIXXKYOAXYP
            VVFVVSVBAVVFXXKVUTYTYAYNAXWJXWDVVMVBAXWJVVLXMVVHVDVCZVBVCXWDAVVKXMV
            VHXVHXXIWVKYOAXYQVVHVVLVBAVVHWVKVUTYTYAYNVUQAVVSVVTVVFAVVSWUJXDAVVT
            WUMXDXXKVVAAVVLVVMVVHXVBXVCWVKVVAYSUYRAVWAVVPVVFAVWAWUNXDAVVPWUSXDZ
            XXKVVBAVVNVVPVVHAVVNWUBXDXYRWVKVVBYSAVVEVWBVVFVBXVQYNAVVDVVQVVHVBXV
            OYNYSVVC $.
        $}

        $( Lemma for ~ dvfsumrlim .  (Contributed by Mario Carneiro,
           17-May-2016.) $)
        dvfsumlem3 $p |- ( ph -> ( ( H ` Y ) <_ ( H ` X ) /\
          ( ( H ` X ) - [_ X / x ]_ B ) <_ ( ( H ` Y ) - [_ Y / x ]_ B ) ) ) $=
          ( vm vy cfv cle wbr csb cmin co wa c1 caddc cpnf cioo ioossre eqsstri
          cfl cr sseldi wcel reflcl peano2re 3syl cz adantr cv adantlr cmpt cdv
          wceq cxr w3a 3adant1r simpr dvfsumlem2 wf cmul cfz csu wss a1i sselda
          syl resubcld dvmptrecl remulcld fzfid wral ralrimiva elfzuz syl6eleqr
          cuz weq eleq1d rspccva syl2an ffvelrnd wb rexrd elioopnf mpbid simprd
          clt fllep1 ltletrd flcld syl2anc mpbir2and letrd oveq1d simpld adantl
          elfzelz zred ad2antrr elfzle1 xrletrd csbeq1 rspcv sylc fveq2 oveq12d
          cvv ovex fvmpt3i ax-mp fsumrecl readdcld fmptd syl6eleq peano2zd flge
          flle flidm breqtrrd eluz2 syl3anbrc lep1d elfzle2 1re leaddsub mpbird
          syl3anc flid eqle monoord2 leidd nfcsb1v nfel1 csbeq1a rspc mpan9 vex
          eqcomd eqid syldan syl5eqel 3brtr4g monoord fvex 3brtr3g jca lecasei
          ) AOKURZNKURZUSUTZUVSBNDVAZVBVCZUVRBODVAZVBVCZUSUTZVDONVKURZVEVFVCZAG
          VLOGHVGVHVCZVLQHVGVIVJZULVMZANVLVNZUWFVLVNZUWGVLVNZAGVLNUWIUKVMZNVOZU
          WFVPZVQZAOUWGUSUTZVDBCDEFGHIJKLMNOPQRALVRVNZUWRSVSAFVLVNZUWRTVSALFVEV
          FVCUSUTZUWRUAVSAHVLVNZUWRUBVSABVTZGVNZCVLVNZUWRUCWAAUXDDMVNZUWRUDWAAU
          XCPVNZDVLVNZUWRUEWAAVLBGCWBWCVCBGDWBWDZUWRUFVSUGAIWEVNZUWRUHVSAUXDJVT
          ZGVNVDZFUXCUSUTUXCUXKUSUTUXKIUSUTWFZEDUSUTZUWRUIWGUJANGVNZUWRUKVSAOGV
          NZUWRULVSAFNUSUTZUWRUMVSANOUSUTUWRUNVSAOIUSUTZUWRUOVSAUWRWHWIAUWGOUSU
          TZVDZUVTUWEUXTUVROVKURZKURZUVSUXTGVLOKAGVLKWJZUXSABGUXCUXCVKURZVBVCZD
          WKVCZLUYDWLVCZEJWMZCVBVCZVFVCVLKAUXDVDZUYFUYIUYJUYEDUYJUXCUYDAGVLUXCG
          VLWNAUWIWOZWPZUYJUXCVLVNUYDVLVNUYLUXCVOWQWRABCDGMUYKUCUDUFWSZWTUYJUYH
          CUYJUYGEJUYJLUYDXAUYJUXHBPXBZUXKPVNEVLVNZUXKUYGVNZAUYNUXDAUXHBPUEXCVS
          UYPUXKLXFURPUXKLUYDXDRXEUXHUYOBUXKPBJXGDEVLUGXHXIXJUUAUCWRUUBUJUUCVSZ
          AUXPUXSULVSZXKZUXTGVLUYAKUYQUXTUYAUWHGUXTUYAUWHVNZUYAVLVNZHUYAXQUTZUX
          TOVLVNZVUAAVUCUXSUWJVSZOVOZWQZUXTHUWGUYAAUXBUXSUBVSZUXTUWKUWLUWMAUWKU
          XSUWNVSZUWOUWPVQZVUFAHUWGXQUTZUXSAHNUWGUBUWNUWQAUWKHNXQUTZANUWHVNZUWK
          VUKVDZANGUWHUKQUUDAHWEVNZVULVUMXLAHUBXMZHNXNWQXOXPAUWKNUWGUSUTZUWNNXR
          ZWQXSZVSUXTUXSUWGUYAUSUTZAUXSWHUXTVUCUWGVRVNZUXSVUSXLVUDUXTUWFUXTNVUH
          XTUUEZOUWGUUFYAXOZXSUXTVUNUYTVUAVUBVDXLAVUNUXSVUOVSHUYAXNWQYBQXEZXKZU
          XTGVLNKUYQAUXOUXSUKVSZXKZUXTUVRUYBUSUTZUYBBUYADVAZVBVCZUWDUSUTZUXTBCD
          EFGHIJKLMUYAOPQRAUWSUXSSVSZAUWTUXSTVSZAUXAUXSUAVSZVUGAUXDUXEUXSUCWAZA
          UXDUXFUXSUDWAZAUXGUXHUXSUEWAZAUXIUXSUFVSZUGAUXJUXSUHVSZAUXLUXMUXNUXSU
          IWGZUJVVCUYRUXTFUWGUYAVVLVUIVUFUXTFNUWGVVLVUHVUIAUXQUXSUMVSZUXTUWKVUP
          VUHVUQWQZYCZVVBYCUXTVUCUYAOUSUTVUDOUUGWQZAUXRUXSUOVSZUXTOUYAVEVFVCZUY
          AVKURZVEVFVCUSUXTVUCOVWEUSUTVUDOXRWQUXTVWFUYAVEVFUXTVUCVWFUYAWDVUDOUU
          HWQYDUUIWIZYEUXTUYBUWGKURZUVSVVDUXTGVLUWGKUYQAUWGGVNZUXSAUWGUWHGAUWGU
          WHVNZUWMVUJUWQVURAVUNVWJUWMVUJVDXLVUOHUWGXNWQYBQXEVSZXKZVVFUXTUPKUWGU
          YAUXTVUTUYAVRVNVUSUYAUWGXFURVNVVAUXTOVUDXTVVBUWGUYAUUJUUKZUXTUPVTZUWG
          UYAWLVCVNZVDZGVLVWNKUXTUYCVWOUYQVSVWPVWNUWHGVWPVWNUWHVNZVWNVLVNZHVWNX
          QUTZVWPVWNVWOVWNVRVNZUXTVWNUWGUYAYGYFYHZVWPHUWGVWNUXTUXBVWOVUGVSUXTUW
          MVWOVUIVSVXAAVUJUXSVWOVURYIVWOUWGVWNUSUTZUXTVWNUWGUYAYJYFXSVWPVUNVWQV
          WRVWSVDXLZAVUNUXSVWOVUOYIHVWNXNZWQYBQXEZXKZUXTVWNUWGUYAVEVBVCZWLVCVNZ
          VDZVWNVEVFVCZKURZVWNKURZUSUTZVXLBVWNDVAZVBVCZVXKBVXJDVAZVBVCZUSUTZVXI
          BCDEFGHIJKLMVWNVXJPQRUXTUWSVXHVVKVSUXTUWTVXHVVLVSZAUXAUXSVXHUAYIUXTUX
          BVXHVUGVSZUXTUXDUXEVXHVVNWAUXTUXDUXFVXHVVOWAUXTUXGUXHVXHVVPWAUXTUXIVX
          HVVQVSUGUXTUXJVXHVVRVSZUXTUXLUXMUXNVXHVVSWGUJVXIVWNUWHGVXIVWQVWRVWSVX
          IVWNVXHVWTUXTVWNUWGVXGYGYFZYHZVXIHUWGVWNVXTUXTUWMVXHVUIVSZVYCAVUJUXSV
          XHVURYIVXHVXBUXTVWNUWGVXGYJYFZXSZVXIVUNVXCVXIHVXTXMZVXDWQYBQXEVXIVXJU
          WHGVXIVXJUWHVNZVXJVLVNZHVXJXQUTZVXIVWRVYIVYCVWNVPWQZVXIHVWNVXJVXTVYCV
          YKVYFVXIVWNVYCUULZXSVXIVUNVYHVYIVYJVDXLVYGHVXJXNWQYBQXEVXIFUWGVWNVXSV
          YDVYCUXTFUWGUSUTVXHVWBVSVYEYCVYLVXIVXJUYAIVXIVXJVYKXMUXTUYAWEVNVXHUXT
          UYAVUFXMZVSVYAVXIVXJUYAUSUTZVWNVXGUSUTZVXHVYOUXTVWNUWGVXGUUMYFVXIVWRV
          EVLVNZVUAVYNVYOXLVYCVYPVXIUUNWOVXIVUCVUAUXTVUCVXHVUDVSVUEWQVWNVEUYAUU
          OUUQUUPUXTUYAIUSUTVXHUXTUYAOIVYMUXTOVUDXMVVRVWCVWDYKZVSYKVXIVYIVXJVWN
          VKURZVEVFVCZWDVXJVYSUSUTVYKVXIVWNVYRVEVFVXIVYRVWNVXIVWTVYRVWNWDVYBVWN
          UURWQUVHYDVXJVYSUUSYAWIZYEUUTUXTVWHUVSUSUTZUWBVWHBUWGDVAZVBVCZUSUTZUX
          TBCDEFGHIJKLMNUWGPQRVVKVVLVVMVUGVVNVVOVVPVVQUGVVRVVSUJVVEVWKVVTVWAUXT
          UWGUYAIUXTUWGVUIXMVYMVVRVVBVYQYKUXTUWGVUIUVAWIZYEYCYCUXTUWBVVIUWDUXTU
          VSUWAVVFUXTUXOVXNVLVNZUPGXBZUWAVLVNZVVEUXTWUFUPGUXTUXHBGXBZVWNGVNZWUF
          AWUIUXSAUXHBGUYMXCVSUXHWUFBVWNGBVXNVLBVWNDUVBUVCBUPXGDVXNVLBVWNDUVDXH
          UVEUVFZXCZWUFWUHUPNGVWNNWDVXNUWAVLBVWNNDYLXHYMYNWRZUXTUYBVVHVVDUXTUYA
          GVNWUGVVHVLVNZVVCWULWUFWUNUPUYAGVWNUYAWDVXNVVHVLBVWNUYADYLXHYMYNWRZUX
          TUVRUWCUYSUXTUXPWUGUWCVLVNZUYRWULWUFWUPUPOGVWNOWDVXNUWCVLBVWNODYLXHYM
          YNWRUXTUWBWUCVVIWUMUXTVWHWUBVWLUXTVWIWUGWUBVLVNZVWKWULWUFWUQUPUWGGVWN
          UWGWDVXNWUBVLBVWNUWGDYLXHYMYNWRWUOUXTWUAWUDWUEXPUXTUWGUQYQUQVTZKURZBW
          URDVAZVBVCZWBZURZUYAWVBURZWUCVVIUSUXTUPWVBUWGUYAVWMVWPVWNWVBURZVXOVLV
          WNYQVNWVEVXOWDUPUVGUQVWNWVAVXOYQWVBUQUPXGWUSVXLWUTVXNVBWURVWNKYOBWURV
          WNDYLYPWVBUVIZWUSWUTVBYRZYSYTZVWPVXLVXNVXFUXTVWOWUJWUFVXEWUKUVJWRUVKV
          XIVXOVXQWVEVXJWVBURZUSVXIVXMVXRVYTXPWVHVXJYQVNWVIVXQWDVWNVEVFYRUQVXJW
          VAVXQYQWVBWURVXJWDWUSVXKWUTVXPVBWURVXJKYOBWURVXJDYLYPWVFWVGYSYTUVLUVM
          UWGYQVNWVCWUCWDUWFVEVFYRUQUWGWVAWUCYQWVBWURUWGWDWUSVWHWUTWUBVBWURUWGK
          YOBWURUWGDYLYPWVFWVGYSYTUYAYQVNWVDVVIWDOVKUVNUQUYAWVAVVIYQWVBWURUYAWD
          WUSUYBWUTVVHVBWURUYAKYOBWURUYADYLYPWVFWVGYSYTUVOYCUXTVVGVVJVWGXPYCUVP
          UVQ $.
      $}

      dvfsumlem4.g $e |- G = ( x e. S |->
        ( sum_ k e. ( M ... ( |_ ` x ) ) C - A ) ) $.
      dvfsumlem4.0 $e |- ( ( ph /\ ( x e. S /\ D <_ x /\ x <_ U ) ) ->
       0 <_ B ) $.
      dvfsumlem4.1 $e |- ( ph -> X e. S ) $.
      dvfsumlem4.2 $e |- ( ph -> Y e. S ) $.
      dvfsumlem4.3 $e |- ( ph -> D <_ X ) $.
      dvfsumlem4.4 $e |- ( ph -> X <_ Y ) $.
      dvfsumlem4.5 $e |- ( ph -> Y <_ U ) $.
      $( Lemma for ~ dvfsumrlim .  (Contributed by Mario Carneiro,
         18-May-2016.) $)
      dvfsumlem4 $p |- ( ph ->
        ( abs ` ( ( G ` Y ) - ( G ` X ) ) ) <_ [_ X / x ]_ B ) $=
        ( vm cfv cmin co cabs cfl cfz csu csb wcel cr wceq fzfid wral ralrimiva
        cle cv elfzuz syl6eleqr weq eleq1d syl2an fsumrecl nfcsb1v csbeq1a rspc
        nfel1 sylc resubcld nfcv nfov oveq2d sumeq1d oveq12d fvmptf syl2anc wbr
        fveq2 caddc cmul cpnf a1i nfv csbeq1 rspcv sseldi syl remulcld readdcld
        reflcl cc0 fracge0 w3a rexrd 3jca wa simpr1 nfbr nfim eleq1 breq2 breq1
        wi 3anbi123d anbi2d breq2d imbi12d vtoclgf mpcom mpdan mulge0d addge02d
        mpbid id oveq1d 3brtr3d recnd addcomd c1 letrd fracle1 lemul1ad mulid2d
        breqtrd cuz rspccva fveq2d wss ioossre eqsstri dvmptrecl cbvral xrletrd
        cioo sylib lesub1dd cmpt eqid dvfsumlem3 simprd subsub3d subge0d mpbird
        eqtrd 1re subge02d eqbrtrrd simpld leadd1dd absdifled mpbir2and eqbrtrd
        ) AOKURZNKURZUSUTZVAURLOVBURZVCUTZEJVDZBOCVEZUSUTZLNVBURZVCUTZEJVDZBNCV
        EZUSUTZUSUTZVAURZBNDVEZVLAUVKUWBVAAUVIUVPUVJUWAUSAOGVFZUVPVGVFUVIUVPVHU
        MAUVNUVOAUVMEJALUVLVIADVGVFZBPVJZJVMZPVFZEVGVFZUWHUVMVFZAUWFBPUEVKZUWKU
        WHLUUAURZPUWHLUVLVNRVOUWFUWJBUWHPBJVPDEVGUGVQUUBZVRVSAUWECVGVFZBGVJZUVO
        VGVFZUMAUWOBGUCVKZUWOUWQBOGBUVOVGBOCVTZWCBVMZOVHZCUVOVGBOCWAZVQWBWDWEZB
        OLUWTVBURZVCUTZEJVDZCUSUTZUVPGKVGBOWFZBUVNUVOUSBUVNWFBUSWFZUWSWGZUXAUXF
        UVNCUVOUSUXAUXEUVMEJUXAUXDUVLLVCUWTOVBWNZWHWIUXBWJZUJWKWLANGVFZUWAVGVFU
        VJUWAVHULAUVSUVTAUVREJALUVQVIAUWGUWIUWJUWHUVRVFZUWLUXNUWHUWMPUWHLUVQVNR
        VOUWNVRVSAUXMUWPUVTVGVFZULUWRUWOUXOBNGBUVTVGBNCVTZWCUWTNVHZCUVTVGBNCWAZ
        VQWBWDWEZBNUXGUWAGKVGBNWFZBUVSUVTUSBUVSWFUXIUXPWGZUXQUXFUVSCUVTUSUXQUXE
        UVREJUXQUXDUVQLVCUWTNVBWNZWHWIUXRWJZUJWKWLWJUUCAUWCUWDVLWMUWAUWDUSUTZUV
        PVLWMUVPUWAUWDWOUTZVLWMAUYDNUVQUSUTZUWDWPUTZUWAWOUTZUWDUSUTZUVPAUWAUWDU
        XSAUXMBUQVMZDVEZVGVFZUQGVJZUWDVGVFZULAUWFBGVJUYMAUWFBGABCDGMGVGUUDAGHWQ
        UUJUTVGQHWQUUEUUFZWRUCUDUFUUGVKUWFUYLBUQGUWFUQWSBUYKVGBUYJDVTWCBUQVPDUY
        KVGBUYJDWAVQUUHUUKZUYLUYNUQNGUYJNVHUYKUWDVGBUYJNDWTVQXAWDZWEAUYHUWDAUYG
        UWAAUYFUWDANUVQAGVGNUYOULXBZANVGVFZUVQVGVFUYRNXFXCWEZUYQXDZUXSXEZUYQWEZ
        UXCAUWAUYHUWDUXSVUBUYQAXGUYGVLWMUWAUYHVLWMAUYFUWDUYTUYQAUYSXGUYFVLWMUYR
        NXHXCAUXMFNVLWMZNIVLWMZXIZXGUWDVLWMZAUXMVUDVUEULUNANOIANUYRXJAOAGVGOUYO
        UMXBZXJUHUOUPUUIXKUXMAVUFXLZVUGAUXMVUDVUEXMAUWTGVFZFUWTVLWMZUWTIVLWMZXI
        ZXLZXGDVLWMZXSZVUIVUGXSBNGUXTVUIVUGBVUIBWSBXGUWDVLBXGWFZBVLWFZBNDVTZXNX
        OUXQVUNVUIVUOVUGUXQVUMVUFAUXQVUJUXMVUKVUDVULVUEUWTNGXPUWTNFVLXQUWTNIVLX
        RXTYAUXQDUWDXGVLBNDWAZYBYCUKYDYEYFZYGAUWAUYGUXSVUAYHYIUULAUYIOUVLUSUTZB
        ODVEZWPUTZUVPWOUTZVVCUSUTZUVPVUCAVVEVVCAVVDUVPAVVBVVCAOUVLVUHAOVGVFZUVL
        VGVFVUHOXFXCWEZAUWEUYMVVCVGVFZUMUYPUYLVVIUQOGUYJOVHUYKVVCVGBUYJODWTVQXA
        WDZXDZUXCXEZVVJWEUXCANBGUWTUXDUSUTZDWPUTZUXGWOUTZUUMZURZUWDUSUTZOVVPURZ
        VVCUSUTZUYIVVFVLAVVSVVQVLWMZVVRVVTVLWMZABCDEFGHIJVVPLMNOPQRSTUAUBUCUDUE
        UFUGUHUIVVPUUNZULUMUNUOUPUUOZUUPAVVQUYHUWDUSAUXMUYHVGVFVVQUYHVHULVUBBNV
        VOUYHGVVPVGUXTBUYGUWAWOBUYFUWDWPBUYFWFBWPWFZVUSWGBWOWFZUYAWGUXQVVNUYGUX
        GUWAWOUXQVVMUYFDUWDWPUXQUWTNUXDUVQUSUXQYJUYBWJVUTWJUYCWJVWCWKWLZYKAVVSV
        VEVVCUSAUWEVVEVGVFVVSVVEVHUMVVLBOVVOVVEGVVPVGUXHBVVDUVPWOBVVBVVCWPBVVBW
        FVWEBODVTZWGVWFUXJWGUXAVVNVVDUXGUVPWOUXAVVMVVBDVVCWPUXAUWTOUXDUVLUSUXAY
        JUXKWJBODWAZWJUXLWJVWCWKWLZYKYLAUVPVVCVVDUSUTZUSUTZVVFUVPVLAVWLUVPVVDWO
        UTZVVCUSUTVVFAUVPVVCVVDAUVPUXCYMZAVVCVVJYMZAVVDVVKYMZUUQAVWMVVEVVCUSAUV
        PVVDVWNVWPYNYKUUTAXGVWKVLWMZVWLUVPVLWMAVWQVVDVVCVLWMAVVDYOVVCWPUTVVCVLA
        VVBYOVVCVVHYOVGVFAUVAWRZVVJAUWEFOVLWMZOIVLWMZXIZXGVVCVLWMZAUWEVWSVWTUMA
        FNOTUYRVUHUNUOYPUPXKUWEAVXAXLZVXBAUWEVWSVWTXMVUPVXCVXBXSBOGUXHVXCVXBBVX
        CBWSBXGVVCVLVUQVURVWHXNXOUXAVUNVXCVUOVXBUXAVUMVXAAUXAVUJUWEVUKVWSVULVWT
        UWTOGXPUWTOFVLXQUWTOIVLXRXTYAUXADVVCXGVLVWIYBYCUKYDYEYFZAVVGVVBYOVLWMVU
        HOYQXCYRAVVCVWOYSYTAVVCVVDVVJVVKUURUUSAUVPVWKUXCAVVCVVDVVJVVKWEUVBYIUVC
        YPYPAUVPUWDUWAWOUTZUYEVLAUVPUYHVXEUXCVUBAUWDUWAUYQUXSXEAUVPVVEUYHUXCVVL
        VUBAXGVVDVLWMUVPVVEVLWMAVVBVVCVVHVVJAVVGXGVVBVLWMVUHOXHXCVXDYGAUVPVVDUX
        CVVKYHYIAVVSVVQVVEUYHVLAVWAVWBVWDUVDVWJVWGYLYPAUYGUWDUWAVUAUYQUXSAUYGYO
        UWDWPUTUWDVLAUYFYOUWDUYTVWRUYQVVAAUYSUYFYOVLWMUYRNYQXCYRAUWDAUWDUYQYMZY
        SYTUVEYPAUWDUWAVXFAUWAUXSYMYNYTAUVPUWAUWDUXCUXSUYQUVFUVGUVH $.
    $}

    dvfsumrlim.l $e |- ( ( ph /\ ( x e. S /\ k e. S ) /\ ( D <_ x /\ x <_ k ) )
      -> C <_ B ) $.
    dvfsumrlim.g $e |- G = ( x e. S |->
      ( sum_ k e. ( M ... ( |_ ` x ) ) C - A ) ) $.
    dvfsumrlim.k $e |- ( ph -> ( x e. S |-> B ) ~~>r 0 ) $.
    $( Lemma for ~ dvfsumrlim .  Satisfy the assumption of ~ dvfsumlem4 .
       (Contributed by Mario Carneiro, 18-May-2016.) $)
    dvfsumrlimge0 $p |- ( ( ph /\ ( x e. S /\ D <_ x ) ) -> 0 <_ B ) $=
      ( vu vv vw vz cv wcel cle wbr wa cpnf cico cc0 cxr wne clt csup wceq cioo
      co cr ioossre eqsstri simprl sseldi renepnfd icopnfsup syl2anc wss adantr
      rexrd syl6eleq wb elioopnf syl mpbid simprd df-ioo df-ico xrltletr ixxss1
      syl6sseqr cmpt crli cbvmptv syl5eqbrr rlimres2 cc dvmptrecl adantrr recnd
      a1i rlimconst sselda ralrimiva eleq1d rspccva sylan syldan simpll simplrl
      wral simplrr elicopnf simplbda syl122anc rlimle ) ABULZGUMZFXNUNUOZUPZUPZ
      IXNUQURVFZEDUSDXRXNUTUMXNUQVAXSUTVBVCUQVDXRXNXRGVGXNGHUQVEVFZVGNHUQVHVIZA
      XOXPVJZVKZVQXRXNYCVLXNVMVNXRIXSGEUSXRXSXTGXRHUTUMZHXNVBUOZXSXTVOAYDXQAHSV
      QVPZXRXNVGUMZYEXRXNXTUMZYGYEUPZXRXNGXTYBNVRXRYDYHYIVSYFHXNVTWAWBWCUHUIUJU
      KHXNUQURVBVBUNVEVBUHUIUJWDUHUIUJWEHXNUKULWFWGVNNWHZXRIGEWIBGDWIZUSWJBIGDE
      UDWKAYKUSWJUOXQUGVPWLWMXRIXSGDDYJXRGVGVOZDWNUMIGDWIDWJUOYLXRYAWRXRDAXODVG
      UMZXPABCDGLYLAYAWRTUAUCWOZWPZWQIGDWSVNWMXRIULZXSUMZYPGUMZEVGUMZXRXSGYPYJW
      TZXRYMBGXHZYRYSAUUAXQAYMBGYNXAVPYMYSBYPGXNYPVDDEVGUDXBXCXDXEXRYMYQYOVPXRY
      QUPAXOYRXPXNYPUNUOZEDUNUOAXQYQXFAXOXPYQXGYTAXOXPYQXIXRYQYPVGUMZUUBXRYGYQU
      UCUUBUPVSYCXNYPXJWAXKUEXLXM $.

    $( Compare a finite sum to an integral (the integral here is given as a
       function with a known derivative).  The statement here says that if
       ` x e. S |-> B ` is a decreasing function with antiderivative ` A `
       converging to zero, then the difference between
       ` sum_ k e. ( M ... ( |_ `` x ) ) B ( k ) ` and
       ` A ( x ) = S. u e. ( M [,] x ) B ( u ) _d u ` converges to a constant
       limit value, with the remainder term bounded by ` B ( x ) ` .
       (Contributed by Mario Carneiro, 18-May-2016.) $)
    dvfsumrlim $p |- ( ph -> G e. dom ~~>r ) $=
      ( ve vc vy cr wss cpnf co ioossre eqsstri a1i wf cc dvfsumrlimf ax-resscn
      cioo fss sylancl cxr clt csup supeq1i wcel wceq ressxr renepnfd ioopnfsup
      wne sseldi syl2anc syl5eq cv cle wbr cabs cfv wral wrex crp cmin cmpt cc0
      wi crli rlimmptrcl ralrimiva rlim0 mpbid wa c1 caddc cif cico wb peano2re
      ifcl adantr rexico elicopnf simprbda ltp1d simplbda maxle syl3anc ltletrd
      syl simprd elioopnf mpbir2and syl6eleqr jca adantlr simprrl adantrr leidd
      simpld csb nfv nfcv nfcsb1v nffv nfbr nfim csbeq1a breq1d imbi12d elrege0
      breq2 rspc expr simprrr w3a ffvelrnd anassrs mpid dvmptrecl dvfsumrlimge0
      fveq2d sylanbrc nfel1 eleq1d syl3c sylib absid cdv pnfxr syl3an3 3adant1r
      3simpa 3adantr3 sstri pnfge dvfsumlem4 subcld abscld simprll rpred lelttr
      mpand sylbid syld com23 ralrimdva jctild syldan expimpd reximdv2 ralimdva
      cz sylbird mpd caucvgr ) AUHGUIUJJGUKULZAGHUMVBUNZUKNHUMUOUPZUQZAGUKJURUK
      USULGUSJURZABCDEFGHIJKLMNOPQRSTUAUBUCUDUFUTVAGUKUSJVCVDZAGVEVFVGUVTVEVFVG
      ZUMVEGUVTVFNVHAHVEVIZHUMVNUWEUMVJAUKVEHVKSVOZAHSVLHVMVPVQAUIVRZBVRZVSVTZD
      WAWBZUHVRZVFVTZWIZBGWCZUIUKWDZUHWEWCZUWHUJVRZVSVTZUWRJWBZUWHJWBZWFUNZWAWB
      ZUWLVFVTZWIZUJGWCZUIGWDZUHWEWCABGDWGZWHWJVTUWQUGAUHUIBGDADUSVIBGAGDWHBLUA
      UGWKWLUWBWMWNAUWPUXGUHWEAUWLWEVIZWOZUWPUWOUIFHWPWQUNZVSVTZUXKFWRZUMWSUNZW
      DZUXGUXJUVSUXMUKVIZUXOUWPWTUVSUXJUWAUQAUXPUXIAUXKUKVIZFUKVIZUXPAHUKVIZUXQ
      SHXAZXLQUXLUXKFUKXBVPZXCUWMGUXMUIBXDVPUXJUWOUXFUIUXNGUXJUWHUXNVIZUWOUWHGV
      IZUXFWOZUXJUYBUYCFUWHVSVTZWOZUWOUYDWIZAUYBUYFUXIAUYBWOZUYCUYEUYHUWHUVTGUY
      HUWHUVTVIZUWHUKVIZHUWHVFVTZAUYBUYJUXMUWHVSVTZAUXPUYBUYJUYLWOWTUYAUXMUWHXE
      XLZXFZUYHHUXKUWHAUXSUYBSXCZUYHUXSUXQUYOUXTXLZUYNUYHHUYOXGUYHUYEUXKUWHVSVT
      ZUYHUYLUYEUYQWOZAUYBUYJUYLUYMXHUYHUXRUXQUYJUYLUYRWTAUXRUYBQXCUYPUYNFUXKUW
      HXIXJWNZXMXKUYHUWFUYIUYJUYKWOWTAUWFUYBUWGXCHUWHXNXLXONXPUYHUYEUYQUYSYBXQX
      RAUXIUYFUYGAUXIUYFWOZWOZUWOUXFUYCVUAUWOUXEUJGVUAUWRGVIZWOUWSUWOUXDVUAVUBU
      WSUWOUXDWIZAUYTVUBUWSWOZVUCAUYTVUDWOZWOZUWOBUWHDYCZWAWBZUWLVFVTZUXDVUFUWO
      UWHUWHVSVTZVUIVUFUWHVUFGUKUWHUWAAUYTUYCVUDAUXIUYCUYEXSZXTZVOYAVUFUYCUWOVU
      JVUIWIZWIVULUWNVUMBUWHGVUJVUIBVUJBYDBVUHUWLVFBVUGWABWAYEBUWHDYFZYGBVFYEBU
      WLYEYHYIUWIUWHVJZUWJVUJUWMVUIUWIUWHUWHVSYNVUOUWKVUHUWLVFVUODVUGWABUWHDYJZ
      UUDYKYLYOXLUUAVUFVUIVUGUWLVFVTZUXDVUFVUHVUGUWLVFVUFVUGUKVIZWHVUGVSVTZWOZV
      UHVUGVJVUFVUGWHUMWSUNZVIZVUTVUFUYCFUWIVSVTZDVVAVIZWIZBGWCZUYEVVBVULAVVFVU
      EAVVEBGAUWIGVIZVVCVVDAVVGVVCWOWODUKVIZWHDVSVTZVVDAVVGVVHVVCABCDGLUWBTUAUC
      UUBXTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUUCZDYMUUEYPWLXCAUYTUYEVUDAUXIUYCU
      YEYQXTZVVEUYEVVBWIBUWHGUYEVVBBUYEBYDBVUGVVAVUNUUFYIVUOVVCUYEVVDVVBUWIUWHF
      VSYNVUODVUGVVAVUPUUGYLYOUUHVUGYMUUIZVUGUUJXLYKVUFUXCVUGVSVTZVUQUXDVUFBCDE
      FGHUMIJKLUWHUWRMNOAKUVOVIVUEPXCAUXRVUEQXCAKFWPWQUNVSVTVUERXCAUXSVUESXCAVV
      GCUKVIVUETXRAVVGDLVIVUEUAXRAUWIMVIVVHVUEUBXRAUKBGCWGUUKUNUXHVJVUEUCXCUDUM
      VEVIVUFUULUQAVVGIVRZGVIWOZVVCUWIVVNVSVTZVVNUMVSVTZYRZEDVSVTZVUEVVRAVVOVVC
      VVPWOVVSVVCVVPVVQUUOUEUUMUUNUFAVVGVVCUWIUMVSVTZYRVVIVUEAVVGVVCVVIVVTVVJUU
      PXRVULAUYTVUBUWSXSZVVKAUYTVUBUWSYQVUFUWRVEVIUWRUMVSVTVUFGVEUWRGUKVEUWAVKU
      UQVWAVOUWRUURXLUUSVUFUXCUKVIVURUWLUKVIVVMVUQWOUXDWIVUFUXBVUFUWTUXAVUFGUSU
      WRJAUWCVUEUWDXCZVWAYSVUFGUSUWHJVWBVULYSUUTUVAVUFVURVUSVVLYBVUFUWLAUXIUYFV
      UDUVBUVCUXCVUGUWLUVDXJUVEUVFUVGYTYPUVHUVIVUKUVJYTUVKUVLUVMUVPUVNUVQUVR $.

    ${
      dvfsumrlim2.1 $e |- ( ph -> X e. S ) $.
      dvfsumrlim2.2 $e |- ( ph -> D <_ X ) $.
      $( Compare a finite sum to an integral (the integral here is given as a
         function with a known derivative).  The statement here says that if
         ` x e. S |-> B ` is a decreasing function with antiderivative ` A `
         converging to zero, then the difference between
         ` sum_ k e. ( M ... ( |_ `` x ) ) B ( k ) ` and
         ` S. u e. ( M [,] x ) B ( u ) _d u = A ( x ) ` converges to a constant
         limit value, with the remainder term bounded by ` B ( x ) ` .
         (Contributed by Mario Carneiro, 18-May-2016.) $)
      dvfsumrlim2 $p |- ( ( ph /\ G ~~>r L ) ->
        ( abs ` ( ( G ` X ) - L ) ) <_ [_ X / x ]_ B ) $=
        ( vy vu vv vw vz crli wbr wa cpnf cico co cfv cv cmin cabs csb cxr csup
        clt wceq wcel wne cr cioo ioossre eqsstri sseldi rexrd renepnfd syl2anc
        icopnfsup adantr cc wf dvfsumrlimf ad2antrr ffvelrnd recnd wss syl6eleq
        wb elioopnf mpbid simprd df-ioo df-ico xrltletr ixxss1 syl6sseqr sselda
        syl cle subcld cmpt pnfxr icossre sylancl cdm rlimf adantl cfl cfz ovex
        csu dmmpti feq2i sylib rlimconst feqmptd simpr eqbrtrrd rlimsub rlimabs
        rlimres2 wral a1i dvmptrecl ralrimiva nfcsb1v nfel1 csbeq1a eleq1d rspc
        sylc abscld abssubd cz adantlr w3a c1 caddc cdv 3simpa syl3an3 3adant1r
        cc0 dvfsumrlimge0 3adantr3 elicopnf simplbda simprbda dvfsumlem4 rlimle
        pnfge eqbrtrd ) AJKUQURZUSZULNUTVAVBZNJVCZULVDZJVCZVEVBZVFVCZBNDVGZUUTK
        VEVBZVFVCUVEAUUSVHVJVIUTVKZUUQANVHVLNUTVMUVGANAGVNNGHUTVOVBZVNPHUTVPVQZ
        UJVRZVSANUVJVTNWBWAWCUURUUSUVCUVFULWDUURUVAUUSVLZUSZUUTUVBUVLUUTUVLGVNN
        JAGVNJWEUUQUVKABCDEFGHIJLMOPQRSTUAUBUCUDUEUFUHWFWGZANGVLZUUQUVKUJWGWHWI
        ZUVLUVBUVLGVNUVAJUVMUURUUSGUVAAUUSGWJUUQAUUSUVHGAHVHVLZHNVJURZUUSUVHWJA
        HUAVSZANVNVLZUVQANUVHVLZUVSUVQUSZANGUVHUJPWKAUVPUVTUWAWLUVRHNWMXBWNWOUM
        UNUOUPHNUTVAVJVJXCVOVJUMUNUOWPUMUNUOWQHNUPVDWRWSWAPWTZWCZXAWHWIZXDZUURU
        LUUSUUTUVBUUTKWDUVOUWDUURUUSVNWJZUUTWDVLULUUSUUTXEUUTUQURAUWFUUQAUVSUTV
        HVLZUWFUVJXFNUTXGXHZWCUURGWDNJUURJXIZWDJWEZGWDJWEUUQUWJAKJXJXKUWIGWDJBG
        LBVDZXLVCXMVBEIXOZCVEVBJUWLCVEXNUHXPXQXRZAUVNUUQUJWCWHULUUSUUTXSWAUURUL
        UUSGUVBKUWCUURJULGUVBXEKUQUURULGWDJUWMXTAUUQYAYBYEYCYDAULUUSUVEXEUVEUQU
        RZUUQAUWFUVEWDVLUWNUWHAUVEAUVNDVNVLZBGYFUVEVNVLZUJAUWOBGABCDGMGVNWJAUVI
        YGUBUCUEYHYIUWOUWPBNGBUVEVNBNDYJYKUWKNVKDUVEVNBNDYLYMYNYOZWIULUUSUVEXSW
        AWCUVLUVCUWEYPAUWPUUQUVKUWQWGUVLUVDUVBUUTVEVBVFVCZUVEXCUVLUUTUVBUVOUWDY
        QAUVKUWRUVEXCURUUQAUVKUSZBCDEFGHUTIJLMNUVAOPQALYRVLUVKRWCAFVNVLUVKSWCAL
        FUUAUUBVBXCURUVKTWCAHVNVLUVKUAWCAUWKGVLZCVNVLUVKUBYSAUWTDMVLUVKUCYSAUWK
        OVLUWOUVKUDYSAVNBGCXEUUCVBBGDXEVKUVKUEWCUFUWGUWSXFYGAUWTIVDZGVLUSZFUWKX
        CURZUWKUXAXCURZUXAUTXCURZYTZEDXCURZUVKUXFAUXBUXCUXDUSUXGUXCUXDUXEUUDUGU
        UEUUFUHAUWTUXCUWKUTXCURZYTUUGDXCURZUVKAUWTUXCUXIUXHABCDEFGHIJLMOPQRSTUA
        UBUCUDUEUFUGUHUIUUHUUIYSAUVNUVKUJWCAUUSGUVAUWBXAAFNXCURUVKUKWCAUVKUVAVN
        VLZNUVAXCURZAUVSUVKUXJUXKUSWLUVJNUVAUUJXBZUUKUWSUVAVHVLUVAUTXCURUWSUVAA
        UVKUXJUXKUXLUULVSUVAUUOXBUUMYSUUPUUN $.
    $}

    dvfsumrlim3.1 $e |- ( x = X -> B = E ) $.
    $( Conjoin the statements of ~ dvfsumrlim and ~ dvfsumrlim2 .  (This is
       useful as a target for lemmas, because the hypotheses to this theorem
       are complex, and we don't want to repeat ourselves.)  (Contributed by
       Mario Carneiro, 18-May-2016.) $)
    dvfsumrlim3 $p |- ( ph -> ( G : S --> RR /\ G e. dom ~~>r /\
      ( ( G ~~>r L /\ X e. S /\ D <_ X ) ->
        ( abs ` ( ( G ` X ) - L ) ) <_ E ) ) ) $=
      ( cr wf crli cdm wcel wbr cle w3a cfv cmin co cabs dvfsumrlimf dvfsumrlim
      wi wa csb cz adantr c1 caddc cv adantlr cmpt cdv wceq 3adant1r cc0 simprr
      simprl dvfsumrlim2 nfcvd csbiegf syl breqtrd exp42 com24 3impd 3jca ) AGU
      LKUMKUNUOUPKLUNUQZOGUPZFOURUQZUSOKUTLVAVBVCUTZJURUQZVFABCDEFGHIKMNPQRSTUA
      UBUCUDUEUFUGUIVDABCDEFGHIKMNPQRSTUAUBUCUDUEUFUGUHUIUJVEAWKWLWMWOAWMWLWKWO
      AWMWLWKWOAWMWLVGZVGZWKVGZWNBODVHZJURWQBCDEFGHIKLMNOPQRAMVIUPWPSVJAFULUPWP
      TVJAMFVKVLVBURUQWPUAVJAHULUPWPUBVJABVMZGUPZCULUPWPUCVNAXADNUPWPUDVNAWTPUP
      DULUPWPUEVNAULBGCVOVPVBBGDVOZVQWPUFVJUGAXAIVMZGUPVGFWTURUQWTXCURUQVGEDURU
      QWPUHVRUIAXBVSUNUQWPUJVJAWMWLVTZAWMWLWAWBWRWLWSJVQWQWLWKXDVJBODJGWLBJWCUK
      WDWEWFWGWHWIWJ $.
  $}

  ${
    $d z A $.  $d k m z B $.  $d x z C $.  $d k x D $.  $d z G $.  $d k x ph $.
    $d x z E $.  $d k x z M $.  $d k m x z S $.  $d k m x z X $.  $d k x z Y $.
    $d x T $.  $d k x U $.  $d x V $.  $d x Z $.
    dvfsum2.s $e |- S = ( T (,) +oo ) $.
    dvfsum2.z $e |- Z = ( ZZ>= ` M ) $.
    dvfsum2.m $e |- ( ph -> M e. ZZ ) $.
    dvfsum2.d $e |- ( ph -> D e. RR ) $.
    dvfsum2.u $e |- ( ph -> U e. RR* ) $.
    dvfsum2.md $e |- ( ph -> M <_ ( D + 1 ) ) $.
    dvfsum2.t $e |- ( ph -> T e. RR ) $.
    dvfsum2.a $e |- ( ( ph /\ x e. S ) -> A e. RR ) $.
    dvfsum2.b1 $e |- ( ( ph /\ x e. S ) -> B e. V ) $.
    dvfsum2.b2 $e |- ( ( ph /\ x e. Z ) -> B e. RR ) $.
    dvfsum2.b3 $e |- ( ph ->
      ( RR _D ( x e. S |-> A ) ) = ( x e. S |-> B ) ) $.
    dvfsum2.c $e |- ( x = k -> B = C ) $.
    dvfsum2.l $e |- ( ( ph /\ ( x e. S /\ k e. S ) /\
      ( D <_ x /\ x <_ k /\ k <_ U ) ) -> B <_ C ) $.
    dvfsum2.g $e |- G = ( x e. S |->
      ( sum_ k e. ( M ... ( |_ ` x ) ) C - A ) ) $.
    dvfsum2.0 $e |- ( ( ph /\ ( x e. S /\ D <_ x ) ) -> 0 <_ B ) $.
    dvfsum2.1 $e |- ( ph -> X e. S ) $.
    dvfsum2.2 $e |- ( ph -> Y e. S ) $.
    dvfsum2.3 $e |- ( ph -> D <_ X ) $.
    dvfsum2.4 $e |- ( ph -> X <_ Y ) $.
    dvfsum2.5 $e |- ( ph -> Y <_ U ) $.
    dvfsum2.e $e |- ( x = Y -> B = E ) $.
    $( The reverse of ~ dvfsumrlim , when comparing a finite sum of
       _increasing_ terms to an integral.  In this case there is no point in
       stating the limit properties, because the terms of the sum aren't
       approaching zero, but there is nevertheless still a natural asymptotic
       statement that can be made.  (Contributed by Mario Carneiro,
       20-May-2016.) $)
    dvfsum2 $p |- ( ph -> ( abs ` ( ( G ` Y ) - ( G ` X ) ) ) <_ E ) $=
      ( vm cfv cmin co cabs cfl cfz csu csb cle wcel cr wceq fzfid cv ralrimiva
      wral elfzuz syl6eleqr weq eleq1d fsumrecl nfcsb1v nfel1 csbeq1a rspc sylc
      syl2an resubcld nfcv nfov fveq2 oveq2d sumeq1d oveq12d fvmptf recnd eqtrd
      syl2anc wbr caddc cmul cpnf a1i rspcv sseldi reflcl syl remulcld readdcld
      nfv cc0 fracge0 wi letrd breq2 breq2d imbi12d syl3c mulge0d addge02d cneg
      mpbid wa renegcld cc negeqd w3a lenegd mulneg2d fsumneg oveq1d negsubdi2d
      neg2subd 3eqtr4d negdid eqtr4d nfneg 3brtr3d mpbird c1 breqtrd cuz fveq2d
      rspccva abssubd wss cioo ioossre eqsstri dvmptrecl cbvral csbeq1 lesub1dd
      sylib expr cmpt cpr reex prid1 dvmptneg adantrr 3adant3 simp2r dvfsumlem3
      3ad2ant1 eqid simprd eqeltrd id csbnegg adantl csbied 3brtr4d 1re fracle1
      nfbr nfim lemul1ad mulid2d leadd1dd lesubadd2d simpld absdifled mpbir2and
      addcomd eqbrtrd ) APLUTZOLUTZVAVBZVCUTZMOVDUTZVEVBZEJVFZBOCVGZVAVBZMPVDUT
      ZVEVBZEJVFZBPCVGZVAVBZVAVBVCUTZKVHAUWIUWSUWNVAVBZVCUTUWTAUWHUXAVCAUWFUWSU
      WGUWNVAAPGVIZUWSVJVIUWFUWSVKUNAUWQUWRAUWPEJAMUWOVLZADVJVIZBQVOZJVMZQVIZEV
      JVIZUXFUWPVIZAUXDBQUGVNZUXIUXFMUUAUTZQUXFMUWOVPSVQUXDUXHBUXFQBJVRZDEVJUIV
      SZUUCZWFZVTZAUXBCVJVIZBGVOZUWRVJVIZUNAUXQBGUEVNZUXQUXSBPGBUWRVJBPCWAZWBBV
      MZPVKZCUWRVJBPCWCZVSWDWEZWGZBPMUYBVDUTZVEVBZEJVFZCVAVBZUWSGLVJBPWHZBUWQUW
      RVABUWQWHBVAWHZUYAWIUYCUYIUWQCUWRVAUYCUYHUWPEJUYCUYGUWOMVEUYBPVDWJZWKZWLU
      YDWMUKWNWQAOGVIZUWNVJVIUWGUWNVKUMAUWLUWMAUWKEJAMUWJVLZAUXEUXGUXHUXFUWKVIZ
      UXJUYQUXFUXKQUXFMUWJVPSVQUXNWFZVTZAUYOUXRUWMVJVIZUMUXTUXQUYTBOGBUWMVJBOCW
      AZWBUYBOVKZCUWMVJBOCWCZVSWDWEZWGZBOUYJUWNGLVJBOWHZBUWLUWMVABUWLWHUYLVUAWI
      VUBUYIUWLCUWMVAVUBUYHUWKEJVUBUYGUWJMVEUYBOVDWJZWKZWLVUCWMUKWNWQWMUUBAUWSU
      WNAUWSUYFWOZAUWNVUEWOZUUDWPAUWTKVHWRUWSKVAVBZUWNVHWRUWNUWSKWSVBZVHWRAVUKO
      UWJVAVBZBODVGZWTVBZUWNWSVBZVUNVAVBZUWNAUWSKUYFAUXBUXDBGVOZKVJVIZUNAUXDBGA
      BCDGNGVJUUEAGHXAUUFVBVJRHXAUUGUUHZXBUEUFUHUUIZVNZUXDVUSBPGUYCDKVJURVSXCWE
      ZWGZAVUPVUNAVUOUWNAVUMVUNAOUWJAGVJOVUTUMXDZAOVJVIZUWJVJVIVVEOXEXFWGZAUYOB
      USVMZDVGZVJVIZUSGVOZVUNVJVIZUMAVURVVKVVBUXDVVJBUSGUXDUSXIBVVIVJBVVHDWAWBB
      USVRDVVIVJBVVHDWCVSUUJUUMVVJVVLUSOGVVHOVKVVIVUNVJBVVHODUUKVSXCWEZXGZVUEXH
      ZVVMWGZVUEAVUKPUWOVAVBZKWTVBZUWSWSVBZKVAVBZVUQVVDAVVSKAVVRUWSAVVQKAPUWOAG
      VJPVUTUNXDZAPVJVIZUWOVJVIVWAPXEXFWGZVVCXGZUYFXHZVVCWGZVVPAUWSVVSKUYFVWEVV
      CAXJVVRVHWRUWSVVSVHWRAVVQKVWCVVCAVWBXJVVQVHWRVWAPXKXFAUXBFUYBVHWRZXJDVHWR
      ZXLZBGVOZFPVHWRZXJKVHWRZUNAVWIBGAUYBGVIZVWGVWHULUUNVNZAFOPUAVVEVWAUOUPXMV
      WIVWKVWLXLBPGUYCVWGVWKVWHVWLUYBPFVHXNUYCDKXJVHURXOXPXCXQZXRAUWSVVRUYFVWDX
      SYAUULAVVTVUQVHWRVUQXTZVVTXTZVHWRAVUNVUPVAVBZKVVSVAVBZVWPVWQVHAVUPXTZVUNX
      TZVAVBZVVSXTZKXTZVAVBZVWRVWSVHAOBGUYBUYGVAVBZDXTZWTVBZUYHEXTZJVFZCXTZVAVB
      ZWSVBZUUOZUTZBOVXGVGZVAVBZPVXNUTZBPVXGVGZVAVBZVXBVXEVHAVXRVXOVHWRZVXQVXTV
      HWRZABVXKVXGVXIFGHIJVXNMVJOPQRSTUAUCUDAVWMYBZCUEYCVYCDVVAYCAUYBQVIYBDUGYC
      ABCDVJNGVJVJYDUUPVIAVJYDUUQUURXBVYCCUEWOUFUHUUSUXLDEUIYEUBAVWMUXFGVIZYBZV
      WGUYBUXFVHWRUXFIVHWRYFZYFZDEVHWRVXIVXGVHWRUJVYGDEAVYEUXDVYFAVWMUXDVYDVVAU
      UTUVAVYGVYDVURUXHAVWMVYDVYFUVBAVYEVURVYFVVBUVDUXDUXHBUXFGUXMXCWEYGYAVXNUV
      EZUMUNUOUPUQUVCZUVFAVXOVWTVXPVXAVAAVXOVUMVXAWTVBZUWKVXIJVFZUWMXTZVAVBZWSV
      BZVWTAUYOVYNVJVIVXOVYNVKUMAVYNVWTVJAVYNVUOXTZUWNXTZWSVBVWTAVYJVYOVYMVYPWS
      AVUMVUNAVUMVVGWOAVUNVVMWOZYHAUWLXTZVYLVAVBUWMUWLVAVBVYMVYPAUWLUWMAUWLUYSW
      OZAUWMVUDWOZYLAVYKVYRVYLVAAUWKEJUYPAUYQYBEUYRWOYIYJAUWLUWMVYSVYTYKYMWMAVU
      OUWNAVUOVVNWOVUJYNYOZAVUPVVOYCUVGBOVXMVYNGVXNVJVUFBVYJVYMWSBVUMVXAWTBVUMW
      HBWTWHBVUNBODWAZYPWIBWSWHZBVYKVYLVABVYKWHUYLBUWMVUAYPWIWIVUBVXHVYJVXLVYMW
      SVUBVXFVUMVXGVXAWTVUBUYBOUYGUWJVAVUBUVHVUGWMVUBDVUNBODWCZYEWMVUBVXJVYKVXK
      VYLVAVUBUYHUWKVXIJVUHWLVUBCUWMVUCYEWMWMVYHWNWQWUAWPZAUYOVXPVXAVKUMBODGUVI
      XFWMAVXRVXCVXSVXDVAAVXRVVQVXDWTVBZUWPVXIJVFZUWRXTZVAVBZWSVBZVXCAUXBWUJVJV
      IVXRWUJVKUNAWUJVXCVJAWUJVVRXTZUWSXTZWSVBVXCAWUFWUKWUIWULWSAVVQKAVVQVWCWOA
      KVVCWOZYHAUWQXTZWUHVAVBUWRUWQVAVBWUIWULAUWQUWRAUWQUXPWOZAUWRUYEWOZYLAWUGW
      UNWUHVAAUWPEJUXCAUXIYBEUXOWOYIYJAUWQUWRWUOWUPYKYMWMAVVRUWSAVVRVWDWOVUIYNY
      OZAVVSVWEYCUVGBPVXMWUJGVXNVJUYKBWUFWUIWSBWUFWHWUCBWUGWUHVABWUGWHUYLBUWRUY
      AYPWIWIUYCVXHWUFVXLWUIWSUYCVXFVVQVXGVXDWTUYCUYBPUYGUWOVAUYCUVHUYMWMUYCDKU
      RYEZWMUYCVXJWUGVXKWUHVAUYCUYHUWPVXIJUYNWLUYCCUWRUYDYEWMWMVYHWNWQWUQWPZABP
      VXGVXDGUNUYCVXGVXDVKAWURUVJUVKWMYQAVUPVUNAVUPVVOWOZVYQYLAVVSKAVVSVWEWOZWU
      MYLYQAVUPVUNWUTVYQYKAVVSKWVAWUMYKUVLAVVTVUQVWFVVPYGYRXMAVUQUWNVHWRVUPVUNU
      WNWSVBVHWRAVUOVUNUWNVVNVVMVUEAVUOYSVUNWTVBVUNVHAVUMYSVUNVVGYSVJVIAUVMXBZV
      VMAUYOVWJFOVHWRZXJVUNVHWRZUMVWNUOVWIWVCWVDXLBOGWVCWVDBWVCBXIBXJVUNVHBXJWH
      BVHWHWUBUVOUVPVUBVWGWVCVWHWVDUYBOFVHXNVUBDVUNXJVHWUDXOXPWDXQZAVVFVUMYSVHW
      RVVEOUVNXFUVQAVUNVYQUVRYTUVSAVUPVUNUWNVVOVVMVUEUVTYRXMAUWNVUPVULVUEVVOAUW
      SKUYFVVCXHZAXJVUOVHWRUWNVUPVHWRAVUMVUNVVGVVMAVVFXJVUMVHWRVVEOXKXFWVEXRAUW
      NVUOVUEVVNXSYAAVUPVVSVULVVOVWEWVFAVUPVVSVHWRVXCVWTVHWRAVXRVXOVXCVWTVHAVYA
      VYBVYIUWAWUSWUEYQAVUPVVSVVOVWEYGYRAVVSKUWSWSVBVULVHAVVRKUWSVWDVVCUYFAVVRY
      SKWTVBKVHAVVQYSKVWCWVBVVCVWOAVWBVVQYSVHWRVWAPUVNXFUVQAKWUMUVRYTUVSAKUWSWU
      MVUIUWDYTXMXMAUWNUWSKVUEUYFVVCUWBUWCUWE $.
  $}

  ${
    $d s t u v w x y z C $.  $d d r s t u v w x y z D $.  $d d e r s u y z G $.
    $d d e r s t u v w x y z A $.  $d d e r s t u v w x y z B $.  $d t x z X $.
    $d t y E $.  $d s u v w y H $.  $d d e r s t u v w x y z ph $.  $d t x Y $.
    $d d r s t u v w x y z F $.  $d s u v w x y z L $.  $d y R $.
    ftc1.g $e |- G = ( x e. ( A [,] B ) |-> S. ( A (,) x ) ( F ` t ) _d t ) $.
    ftc1.a $e |- ( ph -> A e. RR ) $.
    ftc1.b $e |- ( ph -> B e. RR ) $.
    ftc1.le $e |- ( ph -> A <_ B ) $.
    ftc1.s $e |- ( ph -> ( A (,) B ) C_ D ) $.
    ftc1.d $e |- ( ph -> D C_ RR ) $.
    ftc1.i $e |- ( ph -> F e. L^1 ) $.

    ${
      ftc1a.f $e |- ( ph -> F : D --> CC ) $.
      ${
        ftc1lem1.x $e |- ( ph -> X e. ( A [,] B ) ) $.
        ftc1lem1.y $e |- ( ph -> Y e. ( A [,] B ) ) $.
        $( Lemma for ~ ftc1a and ~ ftc1 .  (Contributed by Mario Carneiro,
           31-Aug-2014.) $)
        ftc1lem1 $p |- ( ( ph /\ X <_ Y ) ->
          ( ( G ` Y ) - ( G ` X ) ) = S. ( X (,) Y ) ( F ` t ) _d t ) $=
          ( cle wbr wa cfv cmin co cioo cv citg caddc wceq cicc wcel itgeq1 syl
          oveq2 itgex fvmpt adantr wss iccssre syl2anc sseldd w3a elicc2 simp2d
          cr wb mpbid simpr mpbir3and cc cxr rexrd simp3d iooss2 sselda adantlr
          sstrd ffvelrnda syldan cmpt cibl cvv cvol cdm ioombl a1i fvex feqmptd
          eqeltrrd iblss iooss1 itgsplitioo eqtrd oveq12d itgcl pncan2d ) AIJUA
          UBZUCZJHUDZIHUDZUEUFCDIUGUFZCUHZGUDZUIZCIJUGUFZXEUIZUJUFZXFUEUFZXHWTX
          AXIXBXFUEWTXACDJUGUFZXEUIZXIAXAXLUKZWSAJDEULUFZUMZXMTBJCDBUHZUGUFZXEU
          IZXLXNHXPJUKXQXKUKXRXLUKXPJDUGUPCXQXKXEUNUOKCXKXEUQURUOUSWTCDIJXEADVG
          UMZWSLUSAJVGUMZWSAXNVGJAXSEVGUMZXNVGUTLMDEVAVBZTVCZUSWTIDJULUFUMZIVGU
          MZDIUAUBZWSAYEWSAXNVGIYBSVCUSAYFWSAYEYFIEUAUBZAIXNUMZYEYFYGVDZSAXSYAY
          HYIVHLMDEIVEVBVIZVFZUSAWSVJAYDYEYFWSVDVHZWSAXSXTYLLYCDJIVEVBUSVKWTXDX
          KUMXDFUMZXEVLUMZWTXKFXDAXKFUTWSAXKDEUGUFZFAEVMUMZJEUAUBZXKYOUTAEMVNZA
          XTDJUAUBZYQAXOXTYSYQVDZTAXSYAXOYTVHLMDEJVEVBVIVODJEVPVBZOVSUSVQAYMYNW
          SAFVLXDGRVTZVRWAACXCXEWBWCUMWSACXCFXEWDAXCYOFAYPYGXCYOUTYRAYEYFYGYJVO
          DIEVPVBOVSXCWEWFZUMADIWGWHXEWDUMZAYMUCXDGWIZWHZAGCFXEWBWCACFVLGRWJQWK
          ZWLZUSACXGXEWBWCUMWSACXGFXEWDAXGYOFAXGXKYOADVMUMYFXGXKUTADLVNYKDIJWMV
          BUUAVSOVSZXGUUCUMAIJWGWHUUFUUGWLZUSWNWOAXBXFUKZWSAYHUUKSBIXRXFXNHXPIU
          KXQXCUKXRXFUKXPIDUGUPCXQXCXEUNUOKCXCXEUQURUOUSWPAXJXHUKWSAXFXHACXCXEW
          DUUDAXDXCUMUCUUEWHUUHWQACXGXEVLAXDXGUMYMYNAXGFXDUUIVQUUBWAUUJWQWRUSWO
          $.
      $}

      $( Lemma for ~ ftc1 .  (Contributed by Mario Carneiro, 12-Aug-2014.) $)
      ftc1lem2 $p |- ( ph -> G : ( A [,] B ) --> CC ) $=
        ( co wcel wa cvv cicc cv cioo cfv citg cc a1i cxr cle wbr wss cr adantr
        fvex rexrd w3a wb elicc2 syl2anc biimpa simp3d iooss2 sstrd cvol ioombl
        cdm cmpt cibl feqmptd eqeltrrd iblss itgcl fmptd ) ABDEUAQZCDBUBZUCQZCU
        BZGUDZUEUFHAVOVNRZSZCVPVRTVRTRZVTVQVPRSVQGUNZUGVTCVPFVRTVTVPDEUCQZFVTEU
        HRVOEUIUJZVPWCUKVTEAEULRZVSKUMUOVTVOULRZDVOUIUJZWDAVSWFWGWDUPZADULRWEVS
        WHUQJKDEVOURUSUTVADVOEVBUSAWCFUKVSMUMVCVPVDVFRVTDVOVEUGWAVTVQFRSWBUGACF
        VRVGZVHRVSAGWIVHACFUFGPVIOVJUMVKVLIVM $.

      $( The Fundamental Theorem of Calculus, part one.  The function ` G `
         formed by varying the right endpoint of an integral of ` F ` is
         continuous if ` F ` is integrable.  (Contributed by Mario Carneiro,
         1-Sep-2014.) $)
      ftc1a $p |- ( ph -> G e. ( ( A [,] B ) -cn-> CC ) ) $=
        ( wcel cfv clt wbr vz vy vd ve vu vw vs vr cicc co ccncf cmin cabs wral
        cc wf cv wi crp wrex ftc1lem2 wa wss cvol citg cdm cvv fvex a1i feqmptd
        cmpt cibl eqeltrrd adantr simpr itgcn weq wb oveq12 fveq2d breq1d fveq2
        oveqan12d imbi12d ancoms iccssre ad2antrr ad3antrrr simprr sseldd recnd
        cr syl2anc simprl abssubd ffvelrnd cle cioo wceq simpr3 simpr1 ftc1lem1
        w3a simpr2 mpdan adantlr ad2ant2r cxr rexrd simprl1 elicc2 mpbid simp2d
        iooss1 simprl2 simp3d iooss2 sstrd ioombl iblss itgcl abscld iblmbf syl
        mbfmptcl iblabs itgrecl rpred itgabs simplr covol mblvol ioossre ovolcl
        cmbf ax-mp mp1i simp1d resubcld rpxrd ovolss sylancr simprl3 abssubge0d
        ioossicc ovolicc syl3anc breqtrd eqbrtrrd xrlelttrd jca anbi12d cbvitgv
        syl5eqbr sseq1 itgeq1 syl5eq rspcv syl3c lelttrd expr wlogle ralrimivva
        eqbrtrd ex anassrs reximdva mpd r19.12 ralrimiva ralcom sylib ax-resscn
        syl6ss ssid elcncf2 sylancl mpbir2and ) AHDEUIUJZUOUKUJQZUVSUOHUPZUAUQZ
        UBUQZULUJZUMRZUCUQZSTZUWBHRZUWCHRZULUJZUMRZUDUQZSTZURZUAUVSUNZUCUSUTZUD
        USUNUBUVSUNZABCDEFGHIJKLMNOPVAZAUWPUBUVSUNZUDUSUNUWQAUWSUDUSAUWLUSQZVBZ
        UWOUBUVSUNZUCUSUTZUWSUXAUEUQZFVCZUXDVDRZUWFSTZVBZUFUXDUFUQZGRZUMRZVEZUW
        LSTZURZUEVDVFZUNZUCUSUTUXCUXAUFUEFUXJUWLVGUCUXJVGQUXAUXIFQVBUXIGVHVIAUF
        FUXJVKZVLQUWTAGUXQVLAUFFUOGPVJOVMVNAUWTVOVPUXAUXPUXBUCUSAUWTUWFUSQZUXPU
        XBURAUWTUXRVBZVBZUXPUXBUXTUXPVBZUWNUBUAUVSUVSUYAUGUQZUHUQZULUJZUMRZUWFS
        TZUYBHRZUYCHRZULUJZUMRZUWLSTZURZUWNUWCUWBULUJZUMRZUWFSTZUWIUWHULUJZUMRZ
        UWLSTZURZUBUAUHUGUVSUGUAVQZUHUBVQZUYLUWNVRUYTVUAVBZUYFUWGUYKUWMVUBUYEUW
        EUWFSVUBUYDUWDUMUYBUWBUYCUWCULVSVTWAVUBUYJUWKUWLSVUBUYIUWJUMUYTVUAUYGUW
        HUYHUWIULUYBUWBHWBUYCUWCHWBWCVTWAWDWEUGUBVQZUHUAVQZUYLUYSVRVUCVUDVBZUYF
        UYOUYKUYRVUEUYEUYNUWFSVUEUYDUYMUMUYBUWCUYCUWBULVSVTWAVUEUYJUYQUWLSVUEUY
        IUYPUMVUCVUDUYGUWIUYHUWHULUYBUWCHWBUYCUWBHWBWCVTWAWDWEAUVSWLVCZUXSUXPAD
        WLQZEWLQZVUFJKDEWFWMZWGUYAUWCUVSQZUWBUVSQZVBZVBZUWGUYOUWMUYRVUMUWEUYNUW
        FSVUMUWBUWCVUMUWBVUMUVSWLUWBAVUFUXSUXPVULVUIWHZUYAVUJVUKWIZWJWKVUMUWCVU
        MUVSWLUWCVUNUYAVUJVUKWNZWJWKWOWAVUMUWKUYQUWLSVUMUWHUWIVUMUVSUOUWBHAUWAU
        XSUXPVULUWRWHZVUOWPVUMUVSUOUWCHVUQVUPWPWOWAWDUYAVUJVUKUWCUWBWQTZXCZUWGU
        WMUYAVUSUWGVBZVBZUWKCUWCUWBWRUJZCUQZGRZVEZUMRZUWLSVVAUWJVVEUMUXTVUSUWJV
        VEWSZUXPUWGAVUSVVGUXSAVUSVBZVURVVGAVUJVUKVURWTVVHBCDEFGHUWCUWBIAVUGVUSJ
        VNAVUHVUSKVNADEWQTVUSLVNADEWRUJZFVCZVUSMVNAFWLVCVUSNVNAGVLQVUSOVNAFUOGU
        PVUSPVNAVUJVUKVURXAAVUJVUKVURXDXBXEXFXGVTVVAVVFCVVBVVDUMRZVEZUWLVVAVVEV
        VACVVBVVDVGVVDVGQZVVAVVCVVBQVBZVVCGVHZVIZVVACVVBFVVDVGVVAVVBVVIFVVAVVBD
        UWBWRUJZVVIVVADXHQDUWCWQTZVVBVVQVCVVADAVUGUXSUXPVUTJWHZXIVVAUWCWLQZVVRU
        WCEWQTZVVAVUJVVTVVRVWAXCZVUJVUKVURUWGUYAXJVVAVUGVUHVUJVWBVRVVSAVUHUXSUX
        PVUTKWHZDEUWCXKWMXLZXMDUWCUWBXNWMVVAEXHQUWBEWQTZVVQVVIVCVVAEVWCXIVVAUWB
        WLQZDUWBWQTZVWEVVAVUKVWFVWGVWEXCZVUJVUKVURUWGUYAXOVVAVUGVUHVUKVWHVRVVSV
        WCDEUWBXKWMXLZXPDUWBEXQWMXRAVVJUXSUXPVUTMWHXRZVVBUXOQZVVAUWCUWBXSZVIZVV
        MVVAVVCFQVBVVOVIACFVVDVKZVLQUXSUXPVUTAGVWNVLACFUOGPVJOVMWHXTZYAYBVVACVV
        BVVKVVNVVDVVACVVBVVDVGVVACVVBVVDVKZVLQVWPYOQVWOVWPYCYDVVPYEYBVVACVVBVVD
        VGVVPVWOYFYGVVAUWLUXTUWTUXPVUTAUWTUXRWNWGYHVVACVVBVVDVGVVPVWOYIVVAVWKUX
        PVVBFVCZVVBVDRZUWFSTZVBZVVLUWLSTZVWMUXTUXPVUTYJVVAVWQVWSVWJVVAVWRVVBYKR
        ZUWFSVWKVWRVXBWSVWLVVBYLYPVVAVXBUWDUWFVVBWLVCVXBXHQVVAUWCUWBYMVVBYNYQVV
        AUWDVVAUWBUWCVVAVWFVWGVWEVWIYRZVVAVVTVVRVWAVWDYRZYSXIVVAUWFUXTUXRUXPVUT
        AUWTUXRWIWGYTVVAVXBUWCUWBUIUJZYKRZUWDWQVVAVVBVXEVCVXEWLVCZVXBVXFWQTUWCU
        WBUUEVVAVVTVWFVXGVXDVXCUWCUWBWFWMVVBVXEUUAUUBVVAVVTVWFVURVXFUWDWSVXDVXC
        VUJVUKVURUWGUYAUUCZUWCUWBUUFUUGUUHVVAUWEUWDUWFSVVAUWCUWBVXDVXCVXHUUDUYA
        VUSUWGWIUUIUUJUUNUUKUXNVWTVXAURUEVVBUXOUXDVVBWSZUXHVWTUXMVXAVXIUXEVWQUX
        GVWSUXDVVBFUUOVXIUXFVWRUWFSUXDVVBVDWBWAUULVXIUXLVVLUWLSVXIUXLCUXDVVKVEV
        VLUFCUXDUXKVVKUFCVQUXJVVDUMUXIVVCGWBVTUUMCUXDVVBVVKUUPUUQWAWDUURUUSUUTU
        VDUVAUVBUVCUVEUVFUVGUVHUWOUCUBUSUVSUVIYDUVJUWPUDUBUSUVSUVKUVLAUVSUOVCUO
        UOVCUVTUWAUWQVBVRAUVSWLUOVUIUVMUVNUOUVOUBUDUCUAUVSUOHUVPUVQUVR $.
    $}

    ftc1.c $e |- ( ph -> C e. ( A (,) B ) ) $.
    ftc1.f $e |- ( ph -> F e. ( ( K CnP L ) ` C ) ) $.
    ftc1.j $e |- J = ( L |`t RR ) $.
    ftc1.k $e |- K = ( L |`t D ) $.
    ftc1.l $e |- L = ( TopOpen ` CCfld ) $.
    $( Lemma for ~ ftc1 .  (Contributed by Mario Carneiro, 1-Sep-2014.)
       (Revised by Mario Carneiro, 8-Sep-2015.) $)
    ftc1lem3 $p |- ( ph -> F : D --> CC ) $=
      ( ctopon cfv wcel cc ccnp co wf wss cnfldtopon ax-resscn syl6ss resttopon
      crest cr sylancr syl5eqel a1i cnpf2 syl3anc ) AKGUEUFZUGLUHUEUFUGZHFKLUIU
      JUFUGGUHHUKAKLGUQUJZVDUCAVEGUHULVFVDUGLUDUMZAGURUHRUNUOGLUHUPUSUTVEAVGVAU
      AFHKLGUHVBVC $.

    ${
      ftc1.h $e |- H = ( z e. ( ( A [,] B ) \ { C } ) |->
      ( ( ( G ` z ) - ( G ` C ) ) / ( z - C ) ) ) $.
      ${
        ftc1.e $e |- ( ph -> E e. RR+ ) $.
        ftc1.r $e |- ( ph -> R e. RR+ ) $.
        ftc1.fc $e |- ( ( ph /\ y e. D ) -> ( ( abs ` ( y - C ) ) < R ->
          ( abs ` ( ( F ` y ) - ( F ` C ) ) ) < E ) ) $.
        ftc1.x1 $e |- ( ph -> X e. ( A [,] B ) ) $.
        ftc1.x2 $e |- ( ph -> ( abs ` ( X - C ) ) < R ) $.
        ${
          ftc1.y1 $e |- ( ph -> Y e. ( A [,] B ) ) $.
          ftc1.y2 $e |- ( ph -> ( abs ` ( Y - C ) ) < R ) $.
          $( Lemma for ~ ftc1 .  (Contributed by Mario Carneiro,
             31-Aug-2014.) $)
          ftc1lem4 $p |- ( ( ph /\ X < Y ) -> ( abs `
          ( ( ( ( G ` Y ) - ( G ` X ) ) / ( Y - X ) ) - ( F ` C ) ) ) < E ) $=
            ( clt wbr wa cfv cmin co cdiv cabs cioo cv citg caddc cmul cle wceq
            cr wcel wi cicc wss iccssre syl2anc sseldd ltle imp ftc1lem3 syldan
            ftc1lem1 cc rexrd wb elicc2 mpbid simp2d iooss1 simp3d iooss2 sstrd
            cxr w3a sselda ffvelrnda ffvelrnd adantr npcand itgeq2dv subcld cvv
            cvol cdm a1i cmpt cibl eqeltrrd csn cxp fconstmpt covol syl syl3anc
            mblvol iblconst iblsub itgconst oveq2d eqtrd 3eqtrd oveq1d resubcld
            syl5eqelr recnd posdifd fveq2d abscld rpred absdifltd simpld simprd
            cc0 lttrd breq1d ioombl fvex feqmptd iblss ioossicc iccmbl iccvolcl
            ax-mp mblss ovolsscl itgadd eqtr3d ovolioo syl5eq ovex itgcl mulcld
            syl5eqel biimpa gt0ne0d divdird divcan4d divcld absdivd 0re sylancr
            pncand mpd absidd iblabs itgrecl remulcld itgabs breqtrrd ralrimiva
            crp wral eliooord adantl readdcld mpbir2and oveq1 fveq2 rspcv syl3c
            imbi12d difrp adantlr itggt0 itgsub mulcomd breqtrd biimpar lelttrd
            ltdivmul syl112anc mpbird eqbrtrd ) ARSUTVAZVBZSMVCRMVCVDVEZSRVDVEZ
            VFVEZHLVCZVDVEZVGVCZERSVHVEZEVIZLVCZUXDVDVEZVJZVGVCZUXBVFVEZKUTUWTU
            XFUXKUXBVFVEZVGVCUXLUXBVGVCZVFVEUXMUWTUXEUXNVGUWTUXEUXNUXDVKVEZUXDV
            DVEUXNUWTUXCUXPUXDVDUWTUXCUXKUXDUXBVLVEZVKVEZUXBVFVEUXNUXQUXBVFVEZV
            KVEUXPUWTUXAUXRUXBVFUWTUXAEUXGUXIVJZUXKEUXGUXDVJZVKVEZUXRAUWSRSVMVA
            ZUXAUXTVNAUWSUYCARVOVPZSVOVPZUWSUYCVQAFGVRVEZVORAFVOVPZGVOVPZUYFVOV
            SUAUBFGVTWAZUPWBZAUYFVOSUYIURWBZRSWCWAWDZABEFGILMRSTUAUBUCUDUEUFABE
            FGHILMOPQTUAUBUCUDUEUFUGUHUIUJUKWEZUPURWGWFAUXTUYBVNUWSAEUXGUXJUXDV
            KVEZVJUXTUYBAEUXGUYNUXIAUXHUXGVPZVBZUXIUXDAUYOUXHIVPZUXIWHVPAUXGIUX
            HAUXGFGVHVEZIAUXGFSVHVEZUYRAFWRVPFRVMVAZUXGUYSVSAFUAWIAUYDUYTRGVMVA
            ZARUYFVPZUYDUYTVUAWSZUPAUYGUYHVUBVUCWJUAUBFGRWKWAWLWMFRSWNWAAGWRVPS
            GVMVAZUYSUYRVSAGUBWIAUYEFSVMVAZVUDASUYFVPZUYEVUEVUDWSZURAUYGUYHVUFV
            UGWJUAUBFGSWKWAWLWOFSGWPWAWQUDWQZWTZAIWHUXHLUYMXAWFZAUXDWHVPZUYOAIW
            HHLUYMAUYRIHUDUGWBZXBZXCZXDXEAEUXGUXJUXDWHUYPUXIUXDVUJVUNXFZAEUXGUX
            IUXDWHVUJAEUXGIUXIXGVUHUXGXHXIZVPZARSUUAZXJZUXIXGVPAUYQVBUXHLUUBXJA
            LEIUXIXKXLAEIWHLUYMUUCUFXMUUDVUNAEUXGUXDXKUXGUXDXNXOZXLEUXGUXDXPAVU
            QUXGXHVCZVOVPZVUKVUTXLVPVUSAVVAUXGXQVCZVOVUQVVAVVCVNVURUXGXTUUHZAUX
            GRSVRVEZVSZVVEVOVSZVVEXQVCZVOVPVVCVOVPVVFARSUUEXJAVVEVUPVPZVVGAUYDU
            YEVVIUYJUYKRSUUFWAZVVEUUIXRAVVEXHVCZVVHVOAVVIVVKVVHVNVVJVVEXTXRAUYD
            UYEVVKVOVPUYJUYKRSUUGWAXMUXGVVEUUJXSUURZVUMUXGUXDYAXSYIZYBZVUNVVMUU
            KUULXCUWTUYAUXQUXKVKUWTUYAUXDVVAVLVEZUXQAUYAVVOVNZUWSAVUQVVBVUKVVPV
            USVVLVUMEUXGUXDYCXSXCUWTVVAUXBUXDVLUWTVVAVVCUXBVVDUWTUYDUYEUYCVVCUX
            BVNAUYDUWSUYJXCAUYEUWSUYKXCUYLRSUUMXSUUNZYDYEYDYFYGUWTUXKUXQUXBAUXK
            WHVPUWSAEUXGUXJXGUXJXGVPUYPUXIUXDVDUUOXJZVVNUUPZXCZUWTUXDUXBAVUKUWS
            VUMXCZUWTUXBAUXBVOVPZUWSASRUYKUYJYHZXCZYJZUUQVWEUWTUXBAUWSYRUXBUTVA
            ZARSUYJUYKYKUUSZUUTZUVAUWTUXSUXDUXNVKUWTUXDUXBVWAVWEVWHUVBYDYFYGUWT
            UXNUXDUWTUXKUXBVVTVWEVWHUVCVWAUVGYEYLUWTUXKUXBVVTVWEVWHUVDUWTUXOUXB
            UXLVFUWTUXBVWDUWTVWFYRUXBVMVAZVWGUWTYRVOVPVWBVWFVWIVQUVEVWDYRUXBWCU
            VFUVHUVIYDYFUWTUXMKUTVAZUXLUXBKVLVEZUTVAZUWTUXLEUXGUXJVGVCZVJZVWKAU
            XLVOVPZUWSAUXKVVSYMXCAVWNVOVPUWSAEUXGVWMUYPUXJVUOYMZAEUXGUXJXGVVRVV
            NUVJZUVKZXCAVWKVOVPUWSAUXBKVWCAKUMYNZUVLZXCAUXLVWNVMVAUWSAEUXGUXJWH
            VUOVVNUVMXCAUWSYRVWKVWNVDVEZUTVAZVWNVWKUTVAZUWTYREUXGKVWMVDVEZVJZVX
            AUTUWTEUXGVXDUWTYRUXBVVAUTVWGVVQUVNAEUXGVXDXKXLVPUWSAEUXGKVWMVOAKVO
            VPZUYOVWSXCZAEUXGKXKUXGKXNXOZXLEUXGKXPAVUQVVBKWHVPZVXHXLVPVUSVVLAKV
            WSYJZUXGKYAXSYIZVWPVWQYBXCAUYOVXDUVPVPZUWSUYPVWMKUTVAZVXLUYPUYQCVIZ
            HVDVEZVGVCZJUTVAZVXNLVCZUXDVDVEZVGVCZKUTVAZVQZCIUVQZUXHHVDVEZVGVCZJ
            UTVAZVXMVUIAVYCUYOAVYBCIUOUVOXCUYPVYFHJVDVEZUXHUTVAUXHHJVKVEZUTVAUY
            PVYGRUXHAVYGVOVPUYOAHJAIVOHUEVULWBZAJUNYNZYHXCAUYDUYOUYJXCAUXGVOUXH
            AUXGIVOVUHUEWQWTZAVYGRUTVAZUYOAVYLRVYHUTVAZARHVDVEVGVCJUTVAVYLVYMVB
            UQARHJUYJVYIVYJYOWLYPXCUYPRUXHUTVAZUXHSUTVAZUYOVYNVYOVBAUXHRSUVRUVS
            ZYPYSUYPUXHSVYHVYKAUYEUYOUYKXCAVYHVOVPUYOAHJVYIVYJUVTXCUYPVYNVYOVYP
            YQASVYHUTVAZUYOAVYGSUTVAZVYQASHVDVEVGVCJUTVAVYRVYQVBUSASHJUYKVYIVYJ
            YOWLYQXCYSUYPUXHHJVYKAHVOVPUYOVYIXCAJVOVPUYOVYJXCYOUWAVYBVYFVXMVQCU
            XHIVXNUXHVNZVXQVYFVYAVXMVYSVXPVYEJUTVYSVXOVYDVGVXNUXHHVDUWBYLYTVYSV
            XTVWMKUTVYSVXSUXJVGVYSVXRUXIUXDVDVXNUXHLUWCYGYLYTUWFUWDUWEUYPVWMVOV
            PVXFVXMVXLWJVWPVXGVWMKUWGWAWLUWHUWIUWTVXEEUXGKVJZVWNVDVEZVXAAVXEWUA
            VNUWSAEUXGKVWMVOVXGVXKVWPVWQUWJXCUWTVYTVWKVWNVDUWTVYTKVVAVLVEZKUXBV
            LVEZVWKAVYTWUBVNZUWSAVUQVVBVXIWUDVUSVVLVXJEUXGKYCXSXCUWTVVAUXBKVLVV
            QYDAWUCVWKVNUWSAKUXBVXJAUXBVWCYJUWKXCYFYGYEUWLAVXCVXBAVWNVWKVWRVWTY
            KUWMWFUWNUWTVWOVXFVWBVWFVWJVWLWJUWTUXKVVTYMAVXFUWSVWSXCVWDVWGUXLKUX
            BUWOUWPUWQUWR $.
        $}

        $( Lemma for ~ ftc1 .  (Contributed by Mario Carneiro, 14-Aug-2014.)
           (Revised by Mario Carneiro, 28-Dec-2016.) $)
        ftc1lem5 $p |- ( ( ph /\ X =/= C ) ->
          ( abs ` ( ( H ` X ) - ( F ` C ) ) ) < E ) $=
          ( wne clt wbr wo cfv cmin co cabs cicc cr wcel iccssre syl2anc sseldd
          wss cioo ioossicc sseldi lttri2d biimpa wa cdiv cneg cdif wceq adantr
          simpr ltned eldifsn sylanbrc cv fveq2 oveq1d oveq1 oveq12d ovex fvmpt
          csn syl cc ftc1lem3 ftc1lem2 ffvelrnd subcld recnd subeq0ad necon3bid
          cc0 biimpar syldan div2negd negsubdi2d 3eqtr2d fveq2d abs00bd eqbrtrd
          subidd rpgt0d ftc1lem4 gtned jaodan ) ARHUQZRHURUSZHRURUSZUTZRNVAZHLV
          AZVBVCZVDVAZKURUSZAXRYAARHAFGVEVCZVFRAFVFVGGVFVGYGVFVKTUAFGVHVIZUOVJZ
          AYGVFHYHAFGVLVCYGHFGVMUFVNZVJZVOVPAXSYFXTAXSVQZYEHMVAZRMVAZVBVCZHRVBV
          CZVRVCZYCVBVCZVDVAKURYLYDYRVDYLYBYQYCVBYLYBYNYMVBVCZRHVBVCZVRVCZYSVSZ
          YTVSZVRVCZYQYLRYGHWNVTZVGZYBUUAWAZYLRYGVGZXRUUFAUUHXSUOWBYLRHARVFVGXS
          YIWBAXSWCWDZRYGHWEZWFDRDWGZMVAZYMVBVCZUUKHVBVCZVRVCUUAUUENUUKRWAZUUMY
          SUUNYTVRUUOUULYNYMVBUUKRMWHWIUUKRHVBWJWKUKYSYTVRWLWMZWOYLYSYTAYSWPVGX
          SAYNYMAYGWPRMABEFGILMSTUAUBUCUDUEABEFGHILMOPQSTUAUBUCUDUEUFUGUHUIUJWQ
          WRZUOWSZAYGWPHMUUQYJWSZWTWBAYTWPVGXSARHARYIXAZAHYKXAZWTWBAXSXRYTXDUQZ
          UUIAUVBXRAYTXDRHARHUUTUVAXBXCXEXFXGAUUDYQWAXSAUUBYOUUCYPVRAYNYMUURUUS
          XHARHUUTUVAXHWKWBXIWIXJABCDEFGHIJKLMNOPQRHSTUAUBUCUDUEUFUGUHUIUJUKULU
          MUNUOUPYJAHHVBVCZVDVAXDJURAUVCAHUVAXMXKAJUMXNXLZXOXLAXTVQZYEUUAYCVBVC
          ZVDVAKURUVEYDUVFVDUVEYBUUAYCVBUVEUUFUUGUVEUUHXRUUFAUUHXTUOWBUVEHRAHVF
          VGXTYKWBAXTWCXPUUJWFUUPWOWIXJABCDEFGHIJKLMNOPQHRSTUAUBUCUDUEUFUGUHUIU
          JUKULUMUNYJUVDUOUPXOXLXQXF $.
      $}

      $( Lemma for ~ ftc1 .  (Contributed by Mario Carneiro, 14-Aug-2014.)
         (Proof shortened by Mario Carneiro, 28-Dec-2016.) $)
      ftc1lem6 $p |- ( ph -> ( F ` C ) e. ( H limCC C ) ) $=
        ( vs vv vw vy vu cfv climc co wcel cc cv wne cmin cabs clt wbr cicc csn
        wa cdif wral crp wrex ftc1lem3 cioo sseldd ffvelrnd ccom cxp cres cmopn
        wi cxmt ccnp wss cnxmet cr ax-resscn syl6ss adantr xmetres2 sylancr a1i
        crest wceq eqid cnfldtopn metrest syl5eq oveq1d fveq1d eleqtrd metcnpi2
        simpr syl22anc ad2antrr ovresd sselda iccssre ioossicc sseldi cnmetdval
        syl2anc eqtrd breq1d wf ffvelrnda imbi12d ralbidva simprll eldifsni syl
        simplrl simplrr simprlr oveq1 fveq2d fveq2 rspccva sylan eldifad simprr
        cle cibl ftc1lem5 mpdan expr adantld ralrimdva sylbid anassrs reximdva
        mpd ralrimiva cdiv ftc1lem2 dvlem fmptd ssdifssd ellimc3 mpbir2and ) AG
        IUMZKGUNUOUPUUIUQUPZUHURZGUSZUUKGUTUOVAUMUIURZVBVCZVFUUKKUMUUIUTUOVAUMU
        JURZVBVCZVSZUHEFVDUOZGVEZVGZVHZUIVIVJZUJVIVHAHUQGIABDEFGHIJLMNOPQRSTUAU
        BUCUDUEUFVKZAEFVLUOZHGSUBVMZVNZAUVBUJVIAUUOVIUPZVFZUKURZGVAUTVOZHHVPVQZ
        UOZUUMVBVCZUVIIUMZUUIUVJUOZUUOVBVCZVSZUKHVHZUIVIVJZUVBUVHUVKHVTUMUPZUVJ
        UQVTUMUPZIGUVKVRUMZNWAUOZUMZUPZUVGUVSUVHUWAHUQWBZUVTWCAUWFUVGAHWDUQTWEW
        FZWGUVJHUQWHWIUWAUVHWCWJAUWEUVGAIGMNWAUOZUMZUWDUCAGUWHUWCAMUWBNWAAMNHWK
        UOZUWBUEAUWAUWFUWJUWBWLWCUWGUVJUVKNUWBUQHUVKWMNUFWNZUWBWMZWOWIWPWQWRWSW
        GAUVGXAUIUKUUOUVKUVJGIUWBNHUQUWLUWKWTXBUVHUVRUVAUIVIAUVGUUMVIUPZUVRUVAV
        SAUVGUWMVFZVFZUVRUVIGUTUOZVAUMZUUMVBVCZUVNUUIUTUOZVAUMZUUOVBVCZVSZUKHVH
        ZUVAUWOUVQUXBUKHUWOUVIHUPZVFZUVMUWRUVPUXAUXEUVLUWQUUMVBUXEUVLUVIGUVJUOZ
        UWQUXEUVIGUVJHUWOUXDXAAGHUPUWNUXDUVEXCXDUXEUVIUQUPGUQUPZUXFUWQWLUWOHUQU
        VIAUWFUWNUWGWGXEAUXGUWNUXDAUURUQGAUURWDUQAEWDUPZFWDUPZUURWDWBPQEFXFXJWE
        WFZAUVDUURGEFXGUBXHZVMZXCUVIGUVJUVJWMZXIXJXKXLUXEUVOUWTUUOVBUXEUVNUQUPU
        UJUVOUWTWLUWOHUQUVIIAHUQIXMUWNUVCWGXNAUUJUWNUXDUVFXCUVNUUIUVJUXMXIXJXLX
        OXPUWOUXCUUQUHUUTUWOUUKUUTUPZUXCUUQUWOUXNUXCVFZVFUUNUUPUULUWOUXOUUNUUPU
        WOUXOUUNVFZVFZUULUUPUXQUXNUULUWOUXNUXCUUNXQZUUKUURGXRXSUXQBULCDEFGHUUMU
        UOIJKLMNUUKOAUXHUWNUXPPXCAUXIUWNUXPQXCAEFYJVCUWNUXPRXCAUVDHWBUWNUXPSXCA
        HWDWBUWNUXPTXCAIYKUPUWNUXPUAXCAGUVDUPUWNUXPUBXCAIUWIUPUWNUXPUCXCUDUEUFU
        GAUVGUWMUXPXTAUVGUWMUXPYAUXQUXCULURZHUPUXSGUTUOZVAUMZUUMVBVCZUXSIUMZUUI
        UTUOZVAUMZUUOVBVCZVSZUWOUXNUXCUUNYBUXBUYGUKUXSHUVIUXSWLZUWRUYBUXAUYFUYH
        UWQUYAUUMVBUYHUWPUXTVAUVIUXSGUTYCYDXLUYHUWTUYEUUOVBUYHUWSUYDVAUYHUVNUYC
        UUIUTUVIUXSIYEWQYDXLXOYFYGUXQUUKUURUUSUXRYHUWOUXOUUNYIYLYMYNYOYNYPYQYRY
        SYTUUAAUJUIUHUUTGUUIKACUUTCURZJUMGJUMUTUOUYIGUTUOUUBUOUQKAUYIGUURJABDEF
        HIJOPQRSTUAUVCUUCUXJUXKUUDUGUUEAUURUQUUSUXJUUFUXLUUGUUH $.
    $}

    $( The Fundamental Theorem of Calculus, part one.  The function formed by
       varying the right endpoint of an integral is differentiable at ` C `
       with derivative ` F ( C ) ` if the original function is continuous at
       ` C ` .  (Contributed by Mario Carneiro, 1-Sep-2014.) $)
    ftc1 $p |- ( ph -> C ( RR _D G ) ( F ` C ) ) $=
      ( vz cfv cr cdv co wbr cicc cnt wcel csn cdif cv cmin cdiv cmpt cioo ctop
      climc wss crn ctg crest tgioo2 retop eqeltri a1i iccssre syl2anc iooretop
      eqtr4i eleqtrri ioossicc cuni uniretop unieqi syl22anc sseldd ftc1lem6 cc
      ssntr eqid ax-resscn ftc1lem3 ftc1lem2 eldv mpbir2and ) AFFHUFZUGIUHUIUJF
      DEUKUIZJULUFUFZUMWKUEWLFUNUOUEUPZIUFFIUFUQUIWNFUQUIURUIUSZFVBUIUMADEUTUIZ
      WMFAJVAUMZWLUGVCZWPJUMZWPWLVCZWPWMVCWQAJUTVDVEUFZVAJLUGVFUIXAUBLUDVGVNZVH
      VIVJADUGUMEUGUMWRNODEVKVLZWSAWPXAJDEVMXBVOVJWTADEVPVJWLJWPUGUGXAVQJVQVRJX
      AXBVSVNWDVTTWAABUECDEFGHIWOJKLMNOPQRSTUAUBUCUDWOWEZWBAUEWLFWKUGJIWOLUBUDX
      DUGWCVCAWFVJABCDEGHIMNOPQRSABCDEFGHIJKLMNOPQRSTUAUBUCUDWGWHXCWIWJ $.
  $}

  ${
    $d t x y A $.  $d t x y B $.  $d t x y F $.  $d y G $.  $d t x y ph $.
    ftc1cn.g $e |- G =
      ( x e. ( A [,] B ) |-> S. ( A (,) x ) ( F ` t ) _d t ) $.
    ftc1cn.a $e |- ( ph -> A e. RR ) $.
    ftc1cn.b $e |- ( ph -> B e. RR ) $.
    ftc1cn.le $e |- ( ph -> A <_ B ) $.
    ftc1cn.f $e |- ( ph -> F e. ( ( A (,) B ) -cn-> CC ) ) $.
    ftc1cn.i $e |- ( ph -> F e. L^1 ) $.
    $( Strengthen the assumptions of ~ ftc1 to when the function ` F ` is
       continuous on the entire interval ` ( A , B ) ` ; in this case we can
       calculate ` _D G ` exactly.  (Contributed by Mario Carneiro,
       1-Sep-2014.) $)
    ftc1cn $p |- ( ph -> ( RR _D G ) = F ) $=
      ( co cr wceq cc a1i cfv wcel vy cioo cdv wfun cdm wfn wf dvf ffun syl crn
      cicc ctg cnt ccnfld ctopn wss ax-resscn ssid ioossre ccncf cncff ftc1lem2
      iccssre syl2anc tgioo2 dvbssntr iccntr sseqtrd cv wa wbr crest adantr cle
      eqid cibl simpr cuni ccnp sstri ctop cnfldtop cnfldtopon toponunii restid
      ccn ax-mp eqcomi cncfcn syl6eleq ctopon resttopon sylancr toponuni eleq2d
      mp2an biimpa cncnpi ftc1 vex breldm ex ssrdv eqssd df-fn sylanbrc funbrfv
      fvex ffn sylc eqfnfvd ) AUADEUBNZOGUCNZFAXNUDZXNUEZXMPXNXMUFAXPQXNUGZXOXQ
      AGUHRXPQXNUIUJZAXPXMAXPDEULNZUBUKUMSZUNSSZXMAXSOGXTUOUPSZOQUQAURRABCDEXMF
      GHIJKXMXMUQZAXMUSZRXMOUQZADEUTZRMAFXMQVANZTXMQFUGZLXMQFVBUJZVCADOTZEOTZXS
      OUQIJDEVDVEYBYBVPZVFZYLVGAYJYKYAXMPIJDEVHVEVIAUAXMXPAUAVJZXMTZYNXPTZAYOVK
      ZYNYNFSZXNVLZYPYQBCDEYNXMFGXTYBXMVMNZYBHAYJYOIVNAYKYOJVNADEVOVLYOKVNYCYQY
      DRYEYQYFRAFVQTYOMVNAYOVRYQFYTYBWGNZTZYNYTVSZTZFYNYTYBVTNSTAUUBYOAFYGUUALX
      MQUQZQQUQYGUUAPXMOQYFURWAZQUSXMQYBYTYBYLYTVPZYBQVMNZYBYBWBTUUHYBPYBYLWCYB
      WBQQYBYBYLWDZWEWFWHWIWJWQWKVNAYOUUDAXMUUCYNAYTXMWLSTZXMUUCPAYBQWLSTUUEUUJ
      UUIUUEAUUFRXMYBQWMWNXMYTWOUJWPWRYNFYTYBUUCUUCVPWSVEYMUUGYLWTZYNYRXNUAXAYN
      FXIXBUJXCXDXEXNXMXFXGAYHFXMUFYIXMQFXJUJYQXOYSYNXNSYRPAXOYOXRVNUUKYNYRXNXH
      XKXL $.
  $}

  ${
    $d t x A $.  $d t x B $.  $d t x F $.  $d t x ph $.
    ftc2.a $e |- ( ph -> A e. RR ) $.
    ftc2.b $e |- ( ph -> B e. RR ) $.
    ftc2.le $e |- ( ph -> A <_ B ) $.
    ftc2.c $e |- ( ph -> ( RR _D F ) e. ( ( A (,) B ) -cn-> CC ) ) $.
    ftc2.i $e |- ( ph -> ( RR _D F ) e. L^1 ) $.
    ftc2.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> CC ) ) $.
    $( The Fundamental Theorem of Calculus, part two.  If ` F ` is a function
       continuous on ` [ A , B ] ` and continuously differentiable on
       ` ( A , B ) ` , then the integral of the derivative of ` F ` is equal to
       ` F ( B ) - F ( A ) ` .  (Contributed by Mario Carneiro, 2-Sep-2014.) $)
    ftc2 $p |- ( ph ->
      S. ( A (,) B ) ( ( RR _D F ) ` t ) _d t = ( ( F ` B ) - ( F ` A ) ) ) $=
      ( vx cfv co cr cmin cmpt wcel wceq cc cioo cv cdv citg caddc cneg csn cxp
      cicc cxr cle wbr rexrd ubicc2 syl3anc fvex fvconst2 syl ccnfld ctopn eqid
      ctx ccn subcn a1i wss ssid ioossre ccncf wf cncff ftc1a feqmptd cncfmpt2f
      eqeltrrd cc0 crn ctg ax-resscn iccssre syl2anc wa adantr wb elicc2 biimpa
      cvv w3a simp3d iooss2 cvol cdm ioombl iblss itgcl ffvelrnda subcld tgioo2
      cibl cnt iccntr dvmptntr reex prid1 ioossicc sylan2 ftc1cn 3eqtr3d oveq2d
      cpr sseli eqtr3d dvmptsub subidd mpteq2dva 3eqtrd fconstmpt syl6eqr dveq0
      fveq1d oveq2 itgeq1 fveq2 oveq12d ovex fvmpt lbicc2 c0 syl6eq itg0 df-neg
      iooid negex ffvelrnd pncan3d negsubd ) ADEMZBCDUANZBUBZOEUCNZMZUDZYQPNZUE
      NYQCEMZUFZUENUUBYQUUDPNAUUCUUEYQUEADCDUINZCLUUFBCLUBZUANZUUAUDZUUGEMZPNZQ
      ZMZUGUHZMZUUMUUCUUEADUUFRZUUOUUMSACUJRZDUJRZCDUKULZUUPACFUMZADGUMZHCDUNUO
      ZUUFUUMDCUULUPUQURADUULMZUUOUUCADUULUUNACDUULFGALUUIUUJPUSUTMZUUFUVDVAZPU
      VDUVDVBNUVDVCNRAUVDUVEVDVEALBCDYRYTLUUFUUIQZUVFVAZFGHYRYRVFAYRVGVEYROVFAC
      DVHVEJAYTYRTVINRYRTYTVJIYRTYTVKURZVLAELUUFUUJQZUUFTVINZALUUFTEAEUVJRUUFTE
      VJKUUFTEVKURZVMZKVOVNAOUULUCNZLYRVPQZYRVPUGUHAUVMOLYRUUKQUCNLYRUUGYTMZUVO
      PNZQUVNALUUKOUAVQVRMZUVDUUFYROTVFAVSVEZACORZDORZUUFOVFFGCDVTWAZAUUGUUFRZW
      BZUUIUUJUWCBUUHUUAWGUUAWGRZUWCYSUUHRWBYSYTUPZVEUWCBUUHYRUUAWGUWCUURUUGDUK
      ULZUUHYRVFUWCDAUVTUWBGWCUMUWCUUGORZCUUGUKULZUWFAUWBUWGUWHUWFWHZAUVSUVTUWB
      UWIWDFGCDUUGWEWAWFWICUUGDWJWAUUHWKWLRUWCCUUGWMVEUWDUWCYSYRRZWBUWEVEABYRUU
      AQZWSRUWBAYTUWKWSABYRTYTUVHVMJVOZWCWNWOZAUUFTUUGEUVKWPZWQUVDUVEWRZUVEAUVS
      UVTUUFUVQWTMMYRSFGCDXAWAZXBALUUIUVOUUJUVOOTTYROOTXJRAOTXCXDVEUUGYRRZAUWBU
      UITRYRUUFUUGCDXEXKZUWMXFAYRTUUGYTUVHWPZAOUVFUCNYTOLYRUUIQUCNLYRUVOQZALBCD
      YTUVFUVGFGHIJXGALUUIOUVQUVDUUFYRUVRUWAUWMUWOUVEUWPXBALYRTYTUVHVMZXHUWQAUW
      BUUJTRUWRUWNXFUWSAOUVIUCNZOLYRUUJQUCNUWTALUUJOUVQUVDUUFYRUVRUWAUWNUWOUVEU
      WPXBAYTUXBUWTAEUVIOUCUVLXIUXAXLXLXMALYRUVPVPAUWQWBUVOUWSXNXOXPLYRVPXQXRXS
      XTAUUPUVCUUCSUVBLDUUKUUCUUFUULUUGDSZUUIUUBUUJYQPUXCUUHYRSUUIUUBSUUGDCUAYA
      BUUHYRUUAYBURUUGDEYCYDUULVAZUUBYQPYEYFURXLACUUFRZUUMUUESAUUQUURUUSUXEUUTU
      VAHCDYGUOZLCUUKUUEUUFUULUUGCSZUUKVPUUDPNUUEUXGUUIVPUUJUUDPUXGUUIBYHUUAUDZ
      VPUXGUUHYHSUUIUXHSUXGUUHCCUANYHUUGCCUAYACYLYIBUUHYHUUAYBURBUUAYJYIUUGCEYC
      YDUUDYKXRUXDUUDYMYFURXHXIAYQUUBAUUFTDEUVKUVBYNZABYRUUAWGUWDAUWJWBUWEVEUWL
      WOYOAYQUUDUXIAUUFTCEUVKUXFYNYPXH $.
  $}

  ${
    $d t A $.  $d t B $.  $d t F $.  $d t ph $.  $d t X $.  $d t Y $.
    ftc2ditg.x $e |- ( ph -> X e. RR ) $.
    ftc2ditg.y $e |- ( ph -> Y e. RR ) $.
    ftc2ditg.a $e |- ( ph -> A e. ( X [,] Y ) ) $.
    ftc2ditg.b $e |- ( ph -> B e. ( X [,] Y ) ) $.
    ftc2ditg.c $e |- ( ph -> ( RR _D F ) e. ( ( X (,) Y ) -cn-> CC ) ) $.
    ftc2ditg.i $e |- ( ph -> ( RR _D F ) e. L^1 ) $.
    ftc2ditg.f $e |- ( ph -> F e. ( ( X [,] Y ) -cn-> CC ) ) $.
    $( Lemma for ~ ftc2ditg .  (Contributed by Mario Carneiro, 3-Sep-2014.) $)
    ftc2ditglem $p |- ( ( ph /\ A <_ B ) ->
      S_ [ A -> B ] ( ( RR _D F ) ` t ) _d t = ( ( F ` B ) - ( F ` A ) ) ) $=
      ( cr co cfv wcel adantr cc cle wbr wa cv cdv cdit cioo citg simpr ditgpos
      cmin cicc cres wss iccssre syl2anc sseldd ccncf crn ctg wf wceq ax-resscn
      cnt a1i cncff syl ccnfld ctopn tgioo2 dvres syl22anc iccntr reseq2d eqtrd
      eqid cxr rexrd w3a elicc2 mpbid simp2d iooss1 simp3d iooss2 sstrd rescncf
      wb sylc eqeltrd cmpt cibl feqmptd reseq1d resmpt cvv cvol cdm ioombl fvex
      eqeltrrd iblss iccss2 ftc2 fveq1d sylan9eq itgeq2dv ubicc2 lbicc2 syl3anc
      fvres oveqan12d 3eqtr3d ) ACDUAUBZUCZBCDBUDZOEUEPZQZUFBCDUGPZXRUHZDEQZCEQ
      ZUKPZXOBCDXRAXNUIZUJXOBXSXPOECDULPZUMZUEPZQZUHDYFQZCYFQZUKPZXTYCXOBCDYFAC
      ORZXNAFGULPZOCAFORZGORZYMOUNZHIFGUOUPZJUQZSZADORZXNAYMODYQKUQZSZYDXOYGXQX
      SUMZXSTURPZXOYGXQYEUGUSUTQZVDQQZUMZUUCXOOTUNZYMTEVAZYPYEOUNZYGUUGVBUUHXOV
      CVEAUUIXNAEYMTURPRZUUINYMTEVFVGSAYPXNYQSAUUJXNAYLYTUUJYRUUACDUOUPSYMYEOUU
      EEVHVIQZUULVPZUULUUMVJVKVLXOUUFXSXQAUUFXSVBZXNAYLYTUUNYRUUACDVMUPSVNVOZXO
      XSFGUGPZUNZXQUUPTURPRZUUCUUDRAUUQXNAXSFDUGPZUUPAFVQRFCUAUBZXSUUSUNAFHVRAY
      LUUTCGUAUBZACYMRZYLUUTUVAVSZJAYNYOUVBUVCWHHIFGCVTUPWAWBFCDWCUPAGVQRDGUAUB
      ZUUSUUPUNAGIVRAYTFDUAUBZUVDADYMRZYTUVEUVDVSZKAYNYOUVFUVGWHHIFGDVTUPWAWDFD
      GWEUPWFSZAUURXNLSUUPTXSXQWGWIWJXOYGBXSXRWKZWLXOYGUUCUVIUUOXOUUCBUUPXRWKZX
      SUMZUVIXOXQUVJXSAXQUVJVBXNABUUPTXQAUURUUPTXQVALUUPTXQVFVGWMSZWNXOUUQUVKUV
      IVBUVHBUUPXSXRWOVGVOVOXOBXSUUPXRWPUVHXSWQWRRXOCDWSVEXRWPRXOXPUUPRUCXPXQWT
      VEXOXQUVJWLUVLAXQWLRXNMSXAXBWJAYFYETURPRZXNAYEYMUNZUUKUVMAUVBUVFUVNJKFGCD
      XCUPNYMTYEEWGWISXDXOBXSYHXRXOXPXSRYHXPUUCQXRXOXPYGUUCUUOXEXPXSXQXKXFXGXOC
      VQRZDVQRZXNYKYCVBZXOCYSVRXODUUBVRYDUVOUVPXNVSDYERZCYERZUVQCDXHCDXIUVRUVSY
      IYAYJYBUKDYEEXKCYEEXKXLUPXJXMVO $.

    $( Directed integral analog of ~ ftc2 .  (Contributed by Mario Carneiro,
       3-Sep-2014.) $)
    ftc2ditg $p |- ( ph ->
      S_ [ A -> B ] ( ( RR _D F ) ` t ) _d t = ( ( F ` B ) - ( F ` A ) ) ) $=
      ( cr co cfv wceq wcel cc cv cdv cdit cmin cicc wss iccssre syl2anc sseldd
      ftc2ditglem cle wbr wa cneg cvv cioo fvex a1i cmpt ccncf wf cncff feqmptd
      cibl eqeltrrd ditgswap adantr negeqd ffvelrnd negsubdi2d 3eqtrd lecasei
      syl ) ABCDBUAZOEUBPZQZUCZDEQZCEQZUDPZRCDAFGUEPZOCAFOSGOSWAOUFHIFGUGUHZJUI
      AWAODWBKUIABCDEFGHIJKLMNUJADCUKULZUMZVQBDCVPUCZUNZVSVRUDPZUNZVTAVQWFRWCAB
      DCVPUOFGHIKJVPUOSAVNFGUPPZSUMVNVOUQURAVOBWIVPUSVDABWITVOAVOWITUTPSWITVOVA
      LWITVOVBVMVCMVEVFVGWDWEWGABDCEFGHIKJLMNUJVHAWHVTRWCAVSVRAWATCEAEWATUTPSWA
      TEVANWATEVBVMZJVIAWATDEWJKVIVJVGVKVL $.
  $}

  ${
    $d t y A $.  $d t y C $.  $d t x ph $.  $d t x y X $.  $d t x y Y $.
    $d x y E $.  $d x y F $.
    itgparts.x $e |- ( ph -> X e. RR ) $.
    itgparts.y $e |- ( ph -> Y e. RR ) $.
    itgparts.le $e |- ( ph -> X <_ Y ) $.
    itgparts.a $e |- ( ph ->
      ( x e. ( X [,] Y ) |-> A ) e. ( ( X [,] Y ) -cn-> CC ) ) $.
    itgparts.c $e |- ( ph ->
      ( x e. ( X [,] Y ) |-> C ) e. ( ( X [,] Y ) -cn-> CC ) ) $.
    itgparts.b $e |- ( ph ->
      ( x e. ( X (,) Y ) |-> B ) e. ( ( X (,) Y ) -cn-> CC ) ) $.
    itgparts.d $e |- ( ph ->
      ( x e. ( X (,) Y ) |-> D ) e. ( ( X (,) Y ) -cn-> CC ) ) $.
    itgparts.ad $e |- ( ph -> ( x e. ( X (,) Y ) |-> ( A x. D ) ) e. L^1 ) $.
    itgparts.bc $e |- ( ph -> ( x e. ( X (,) Y ) |-> ( B x. C ) ) e. L^1 ) $.
    itgparts.da $e |- ( ph ->
      ( RR _D ( x e. ( X [,] Y ) |-> A ) ) = ( x e. ( X (,) Y ) |-> B ) ) $.
    itgparts.dc $e |- ( ph ->
      ( RR _D ( x e. ( X [,] Y ) |-> C ) ) = ( x e. ( X (,) Y ) |-> D ) ) $.
    itgparts.e $e |- ( ( ph /\ x = X ) -> ( A x. C ) = E ) $.
    itgparts.f $e |- ( ( ph /\ x = Y ) -> ( A x. C ) = F ) $.
    $( Integration by parts.  If ` B ( x ) ` is the derivative of ` A ( x ) `
       and ` D ( x ) ` is the derivative of ` C ( x ) ` , and
       ` E = ( A x. B ) ( X ) ` and ` F = ( A x. B ) ( Y ) ` , then under
       suitable integrability and differentiability assumptions, the integral
       of ` A x. D ` from ` X ` to ` Y ` is equal to ` F - E ` minus the
       integral of ` B x. C ` .  (Contributed by Mario Carneiro,
       3-Sep-2014.) $)
    itgparts $p |- ( ph -> S. ( X (,) Y ) ( A x. D ) _d x =
      ( ( F - E ) - S. ( X (,) Y ) ( B x. C ) _d x ) ) $=
      ( vt cioo co cmul citg caddc cmin cc cv wcel wa cmpt wral ccncf cncff syl
      eqid fmpt sylibr r19.21bi cicc ioossicc sseli sylan2 mulcld itgcl pncan2d
      wf itgadd cdv cfv fveq2 nfcv nfmpt1 nfov nffv cbvitg crn ctg ccnfld ctopn
      cr wss ax-resscn a1i iccssre syl2anc tgioo2 cnt wceq iccntr dvmptntr reex
      cpr prid1 eqtr3d dvmptmul mulcomd oveq2d mpteq2dva 3eqtrd ctx addcn mulcn
      ccn cres resmpt ax-mp rescncf mpsyl syl5eqelr cncfmpt2f eqeltrd cibl ftc2
      ibladd syl5eq fveq1d adantr cvv simpr ovex sylancl eqtrd itgeq2dv csb cxr
      fvmpt2 cle wbr rexrd ubicc2 syl3anc csbex fvmpts csbied lbicc2 oveq12d
      3eqtr3d oveq1d ) ABIJUEUFZDEUGUFZUHZBUUDCFUGUFZUHZUIUFZUUFUJUFUUHHGUJUFZU
      UFUJUFAUUFUUHABUUDUUEUKABULZUUDUMZUNZDEADUKUMZBUUDAUUDUKBUUDDUOZVKZUUNBUU
      DUPAUUOUUDUKUQUFZUMUUPPUUDUKUUOURUSBUUDUKDUUOUUOUTVAVBVCZUULAUUKIJVDUFZUM
      ZEUKUMZUUDUUSUUKIJVEZVFZAUVABUUSAUUSUKBUUSEUOZVKZUVABUUSUPAUVDUUSUKUQUFZU
      MZUVEOUUSUKUVDURUSBUUSUKEUVDUVDUTVAVBVCZVGZVHZSVIABUUDUUGUKUUMCFUULAUUTCU
      KUMZUVCAUVKBUUSAUUSUKBUUSCUOZVKZUVKBUUSUPAUVLUVFUMZUVMNUUSUKUVLURUSBUUSUK
      CUVLUVLUTVAVBVCZVGZAFUKUMZBUUDAUUDUKBUUDFUOZVKZUVQBUUDUPAUVRUUQUMUVSQUUDU
      KUVRURUSBUUDUKFUVRUVRUTVAVBVCZVHZRVIVJAUUIUUJUUFUJABUUDUUEUUGUIUFZUHZUUIU
      UJABUUDUUEUUGUKUVJSUWARVLABUUDUUKWEBUUSCEUGUFZUOZVMUFZVNZUHZJUWEVNZIUWEVN
      ZUJUFZUWCUUJAUWHUDUUDUDULZUWFVNZUHUWKBUDUUDUWGUWMUUKUWLUWFVOUDUWGVPBUWLUW
      FBWEUWEVMBWEVPBVMVPBUUSUWDVQVRBUWLVPVSVTAUDIJUWEKLMAUWFBUUDUWBUOZUUQAUWFW
      EBUUDUWDUOVMUFBUUDUUEFCUGUFZUIUFZUOUWNABUWDWEUEWAWBVNZWCWDVNZUUSUUDWEUKWF
      AWGWHZAIWEUMZJWEUMZUUSWEWFKLIJWIWJZAUUTUNCEUVOUVHVHUWRUWRUTZWKZUXCAUWTUXA
      UUSUWQWLVNVNUUDWMKLIJWNWJZWOABCDEFWEUKUKUUDWEWEUKWQUMAWEUKWPWRWHUVPUURAWE
      UVLVMUFWEBUUDCUOZVMUFUUOABCWEUWQUWRUUSUUDUWSUXBUVOUXDUXCUXEWOTWSUVIUVTAWE
      UVDVMUFWEBUUDEUOZVMUFUVRABEWEUWQUWRUUSUUDUWSUXBUVHUXDUXCUXEWOUAWSWTABUUDU
      WPUWBUUMUWOUUGUUEUIUUMFCUVTUVPXAXBXCXDZABUUEUUGUIUWRUUDUXCUIUWRUWRXEUFUWR
      XHUFZUMAUWRUXCXFWHABDEUGUWRUUDUXCUGUXIUMAUWRUXCXGWHZPAUXGUVDUUDXIZUUQUUDU
      USWFZUXKUXGWMUVBBUUSUUDEXJXKUXLAUVGUXKUUQUMUVBOUUSUKUUDUVDXLXMXNXOABCFUGU
      WRUUDUXCUXJAUXFUVLUUDXIZUUQUXLUXMUXFWMUVBBUUSUUDCXJXKUXLAUVNUXMUUQUMUVBNU
      USUKUUDUVLXLXMXNQXOXOXPAUWFUWNXQUXHABUUDUUEUUGUKUVJSUWARXSXPABCEUGUWRUUSU
      XCUXJNOXOXRXTABUUDUWGUWBUUMUWGUUKUWNVNZUWBAUWGUXNWMUULAUUKUWFUWNUXHYAYBUU
      MUULUWBYCUMUXNUWBWMAUULYDUUEUUGUIYEBUUDUWBYCUWNUWNUTYKYFYGYHAUWIHUWJGUJAU
      WIBJUWDYIZHAJUUSUMZUXOYCUMUWIUXOWMAIYJUMZJYJUMZIJYLYMZUXPAIKYNZAJLYNZMIJY
      OYPBJUWDCEUGYEZYQBJUWDUUSUWEYCUWEUTZYRYFABJUWDHWELUCYSYGAUWJBIUWDYIZGAIUU
      SUMZUYDYCUMUWJUYDWMAUXQUXRUXSUYEUXTUYAMIJYTYPBIUWDUYBYQBIUWDUUSUWEYCUYCYR
      YFABIUWDGWEKUBYSYGUUAUUBWSUUCWS $.
  $}

  ${
    $d m n y z B $.  $d m n u y z E $.  $d m n u x z K $.  $d t u v x y z M $.
    $d m n t u v x y z ph $.  $d m n t u v x y z X $.  $d m n t u v x y z Y $.
    $d m n t u v y z A $.  $d m n t v x y z C $.  $d m n u v x y z W $.
    $d m n u x z L $.  $d t u v x y z N $.  $d m n u v x y z Z $.
    $d m n u x z L $.  $d m n u x y z W $.  $d m n u x y z Z $.
    itgsubst.x $e |- ( ph -> X e. RR ) $.
    itgsubst.y $e |- ( ph -> Y e. RR ) $.
    itgsubst.le $e |- ( ph -> X <_ Y ) $.
    itgsubst.z $e |- ( ph -> Z e. RR* ) $.
    itgsubst.w $e |- ( ph -> W e. RR* ) $.
    itgsubst.a $e |- ( ph ->
      ( x e. ( X [,] Y ) |-> A ) e. ( ( X [,] Y ) -cn-> ( Z (,) W ) ) ) $.
    itgsubst.b $e |- ( ph ->
      ( x e. ( X (,) Y ) |-> B ) e. ( ( ( X (,) Y ) -cn-> CC ) i^i L^1 ) ) $.
    itgsubst.c $e |- ( ph ->
      ( u e. ( Z (,) W ) |-> C ) e. ( ( Z (,) W ) -cn-> CC ) ) $.
    itgsubst.da $e |- ( ph ->
      ( RR _D ( x e. ( X [,] Y ) |-> A ) ) = ( x e. ( X (,) Y ) |-> B ) ) $.
    itgsubst.e $e |- ( u = A -> C = E ) $.
    itgsubst.k $e |- ( x = X -> A = K ) $.
    itgsubst.l $e |- ( x = Y -> A = L ) $.
    ${
      itgsubst.m $e |- ( ph -> M e. ( Z (,) W ) ) $.
      itgsubst.n $e |- ( ph -> N e. ( Z (,) W ) ) $.
      itgsubst.cl2 $e |- ( ( ph /\ x e. ( X [,] Y ) ) -> A e. ( M (,) N ) ) $.
      $( Lemma for ~ itgsubst .  (Contributed by Mario Carneiro,
         12-Sep-2014.) $)
      itgsubstlem $p |- ( ph ->
        S_ [ K -> L ] C _d u = S_ [ X -> Y ] ( E x. B ) _d x ) $=
        ( vt vv vz vy cmul co cdit cioo citg ditgpos cv cr cicc cmpt cdv cfv cc
        cmin ccncf csb wss ax-resscn a1i wcel syl2anc wf wral ccom eqidd fmptco
        wceq syl fmptd wb ioossicc cxr clt wbr wa eliooord simpld simprd syl6ss
        eqid cdm sseli cle sseldi rexrd adantr w3a elicc2 sselda cncff r19.21bi
        fmpt sylibr syldan ioombl cibl resmpt rescncf eqeltrrd cniccibl syl3anc
        cres sylc iblss sylan2 fveq2 cbvitg fvmpt2 itgeq2dv syl5eq mpteq2dva wn
        nfcv lbicc2 mpd ax-mp mpsyl syl5eqelr iccntr dvmptntr fdm cncfco eqtr3d
        c0 cabs fveq1d crn ccnfld ctopn iccssre itgeq1 iccssioo syl22anc syl5ss
        ctg oveq2 ioossre sstrd cncffvrn mpbird biimpa simp3d iooss2 cvol itgcl
        adantlr nffvmpt1 oveq2d n0i feq3 syl5ibcom simprbi syl6 mtod ioo0 mtbid
        f00 letrid ord ftc1cn tgioo2 cnt 3eqtr3rd dmeqd eqtrd dvcn syl31anc cpr
        reex prid1 cin sylib nfcsb1v csbeq1a cbvmpt sstri syl6eq csbeq1 dvmptco
        elin nfcvd csbiegf oveq1d ctx ccn mulcn cncfmpt2f eqeltrd cof fco feq1d
        3eqtrd mpbid offval2 eqtr4d cmbf wrex iblmbf cniccbdd wi ssralv raleqdv
        fveq1i syl5eqr fveq2d breq1d ralbiia syl6rbb syl5ib reximdv ftc2 nfmpt1
        fvres bddmulibl nfov nffv cvv ovex mpan2 sylan9eq simp2d ubicc2 ditgeq2
        caddc ditgex fvmpt oveq12d ralrimiva eleq1d rspcv ditgcl pncan2d eqtr2d
        ditgsplit 3eqtr3d ) ABMNGEUOUPZUQBMNURUPZVUJUSZCHIFUQZABMNVUJRUTAUKVUKU
        KVAZVBBMNVCUPZCJDURUPZFUSZVDZVEUPZVFZUSZNVURVFZMVURVFZVHUPZVULVUMAUKMNV
        URPQRAVUSBVUKVUJVDZVUKVGVIUPZAVUSVBBVUKVUQVDVEUPBVUKCDFVJZEUOUPZVDVVEAB
        VUQVBURUUAUUIVFZUUBUUCVFZVUOVUKVBVGVKZAVLVMZAMVBVNZNVBVNZVUOVBVKPQMNUUD
        VOZAVUQVGVNZBVUOAVUOVGVURVPZVVPBVUOVQAVURVUOVGVIUPZVNVVQAULJKURUPZCJULV
        AZURUPZFUSZVDZBVUODVDZVRVURVVRABULVUOVVSDVWBVUQVWDVWCUJAVWDVSZAVWCVSVVT
        DWAVWAVUPWAVWBVUQWAVVTDJURUUJCVWAVUPFUUEWBZVTAVUOVVSVGVWDVWCAVWDVUOVVSV
        IUPVNZVUOVVSVWDVPZABVUODVVSVWDUJVWDWNZWCZAVVSVGVKVWDVUOOLURUPZVIUPVNZVW
        GVWHWDAVVSVWKVGAVVSJKVCUPZVWKJKWEZAOWFVNLWFVNOJWGWHZKLWGWHZVWMVWKVKZSTA
        VWOJLWGWHZAJVWKVNVWOVWRWIUHJOLWJWBWKAOKWGWHZVWPAKVWKVNVWSVWPWIUIKOLWJWB
        WLOLJKUUFUUGZUUHZAVWKVBVGVWKVBVKAOLUUKZVMVLWMUULUAVUOVWKVVSVWDUUMVOUUNA
        VVKVVSVGVWCVPVVSVBVKVBVWCVEUPZWOZVVSWAVWCVVSVGVIUPZVNVVLAULVVSVWBVGVWCV
        VTVVSVNAVVTVWMVNZVWBVGVNVVSVWMVVTVWNWPAVXFWIZCVWAFVGVXGCVAZVWAVNZVXHVVS
        VNZFVGVNZVXGVWAVVSVXHVXGKWFVNZVVTKWQWHZVWAVVSVKAVXLVXFAKAVWKVBKVXBUIWRZ
        WSZWTVXGVVTVBVNZJVVTWQWHZVXMAVXFVXPVXQVXMXAZAJVBVNZKVBVNZVXFVXRWDAVWKVB
        JVXBUHWRZVXNJKVVTXBVOUUOUUPJVVTKUUQVOZXCZAVXJVXKVXFAVXJVXHVWKVNZVXKAVVS
        VWKVXHVXAXCAVXKCVWKAVWKVGCVWKFVDZVPZVXKCVWKVQAVYEVWKVGVIUPVNZVYFUCVWKVG
        VYEXDWBZCVWKVGFVYEVYEWNXFXGXEZXHZUUTZXHZVXGCVWAVVSFVGVYBVWAUURWOZVNVXGJ
        VVTXIVMVYKACVVSFVDZXJVNVXFACVVSVWMFVGVVSVWMVKZAVWNVMVVSVYMVNAJKXIVMAVXH
        VWMVNVYDVXKAVWMVWKVXHVWTXCVYIXHAVXSVXTCVWMFVDZVWMVGVIUPZVNZVYPXJVNVYAVX
        NAVYEVWMXPZVYPVYQAVWQVYSVYPWAVWTCVWKVWMFXKWBAVWQVYGVYSVYQVNVWTUCVWKVGVW
        MVYEXLXQXMZJKVYPXNXOXRZWTXRUUSZXSZVWCWNWCAVVSVWKVBVXAVXBWMAVXDVYNWOZVVS
        AVXCVYNAVBULVWMUKVWAVUNVYNVFZUSZVDZVEUPVBULVWMVWBVDZVEUPVYNVXCAWUGWUHVB
        VEAULVWMWUFVWBVXGWUFCVWAVXHVYNVFZUSVWBUKCVWAWUEWUIVUNVXHVYNXTCVVSFVUNUV
        AUKWUIYGYAVXGCVWAWUIFVXGVXIWIVXJVXKWUIFWAVYCVYLCVVSFVGVYNVYNWNZYBVOYCYD
        YEUVBAULUKJKVYNWUGWUGWNVYAVXNAKJWQWHZYFJKWQWHZAVVSYRWAZWUKAWUMVUOYRWAZA
        MVUOVNZWUNYFAMWFVNZNWFVNZMNWQWHZWUOAMPWSZANQWSZRMNYHXOZVUOMUVCWBAWUMVUO
        YRVWDVPZWUNAVWHWUMWVBVWJVVSYRVUOVWDUVDUVEWVBVWDYRWAWUNVUOVWDUVKUVFUVGUV
        HAJWFVNZVXLWUMWUKWDAJVYAWSZVXOJKUVIVOUVJAWUKWULAKJVXNVYAUVLUVMYIZAVYNVY
        PVVSXPZVXEVYOWVFVYNWAVWNCVWMVVSFXKYJVYOAVYRWVFVXEVNVWNVYTVWMVGVVSVYPXLY
        KYLWUAUVNAULVWBVBVVIVVJVWMVVSVVLAVWMVWKVBVWTVXBWMWUBVVJVVJWNZUVOZWVGAVX
        SVXTVWMVVIUVPVFZVFVVSWAVYAVXNJKYMVOYNUVQZUVRAVVSVGVYNVPZWUDVVSWAACVVSFV
        GVYNVYJWUJWCZVVSVGVYNYOWBUVSVVSVBVWCUVTUWAYPXMZVUOVGVURXDWBBVUOVGVUQVUR
        VURWNXFXGXEWVHWVGAVVMVVNVUOWVIVFVUKWAPQMNYMVOZYNABULDEVWBCVVTFVJZVBVBVU
        QVVGVGVGVUKVVSVBVBVGUWBVNAVBVGUWCUWDVMZWVPBVAZVUKVNZAWVQVUOVNZDVVSVNZVU
        KVUOWVQMNWEZWPZUJXSZAEVGVNZBVUKAVUKVGBVUKEVDZVPZWWDBVUKVQAWWEVVFVNZWWFA
        WWGWWEXJVNZAWWEVVFXJUWEVNWWGWWHWIUBWWEVVFXJUWNUWFZWKZVUKVGWWEXDWBBVUKVG
        EWWEWWEWNXFXGXEZWUCAWVOVGVNZULVVSAWVKWWLULVVSVQWVLULVVSVGWVOVYNCULVVSFW
        VOULFYGCVVTFUWGCVVTFUWHUWIZXFXGXEAVBVWDVEUPVBBVUKDVDVEUPWWEABDVBVVIVVJV
        UOVUKVVLVVOAWVSWIZVWKVGDVWKVBVGVXBVLUWJADVWKVNZBVUOAVUOVWKVWDVPZWWOBVUO
        VQAVWLWWPUAVUOVWKVWDXDWBZBVUOVWKDVWDVWIXFXGXEZWRWVHWVGWVNYNUDYQAVXCVYNU
        LVVSWVOVDWVJWWMUWKVWFCVVTDFUWLUWMABVUKVVHVUJAWVRWIZVVGGEUOWWSWVTVVGGWAW
        WCCDFGVVSWVTCGUWOUEUWPWBUWQYEUXFZABGEUOVVJVUKWVGUOVVJVVJUWRUPVVJUWSUPVN
        AVVJWVGUWTVMABVUKGVDZBVUOGVDZVUKXPZVVFVUKVUOVKZWXCWXAWAWWABVUOVUKGXKYJZ
        WXDAWXBVVRVNZWXCVVFVNWWAAVYEVWDVRZWXBVVRABCVUOVWKDFGVWDVYEWWRVWEAVYEVSU
        EVTZAVUOVWKVGVWDVYEUAUCYPXMZVUOVGVUKWXBXLYKYLWWJUXAUXBAVUSWXAWWEUOUXCUP
        ZXJAVUSVVEWXJWWTABVUKGEUOWXAWWEVYMVGVGVUKVYMVNAMNXIVMZWVRAWVSGVGVNZWWBA
        WXLBVUOAVUOVGWXBVPZWXLBVUOVQAVUOVGWXGVPZWXMAVYFWWPWXNVYHWWQVUOVWKVGVYEV
        WDUXDVOAVUOVGWXGWXBWXHUXEUXGBVUOVGGWXBWXBWNXFXGXEZXSZWWKAWXAVSAWWEVSUXH
        UXIAWXAUXJVNZWWHUMVAZWXAVFZYSVFZUNVAZWQWHZUMWXAWOZVQZUNVBUXKZWXJXJVNAWX
        AXJVNWXQABVUKVUOGVGWXDAWWAVMWXKWXOAVVMVVNWXFWXBXJVNPQWXIMNWXBXNXOXRWXAU
        XLWBAWWGWWHWWIWLAWXRWXBVFZYSVFZWYAWQWHZUMVUOVQZUNVBUXKZWYEAVVMVVNWXFWYJ
        PQWXIUNUMMNWXBUXMXOAWYIWYDUNVBWYIWYHUMVUKVQZAWYDWXDWYIWYKUXNWWAWYHUMVUK
        VUOUXOYJAWYDWYBUMVUKVQWYKAWYBUMWYCVUKAVUKVGWXAVPWYCVUKWAABVUKGVGWXAWXPW
        XAWNWCVUKVGWXAYOWBUXPWYBWYHUMVUKWXRVUKVNZWXTWYGWYAWQWYLWXSWYFYSWYLWXSWX
        RWXCVFWYFWXRWXCWXAWXEUXQWXRVUKWXBUYGUXRUXSUXTUYAUYBUYCUYDYIUNUMWXAWWEUY
        HXOUXBWVMUYEAVVABVUKWVQVUSVFZUSVULUKBVUKVUTWYMVUNWVQVUSXTBVUNVUSBVBVURV
        EBVBYGBVEYGBVUOVUQUYFUYIBVUNYGUYJUKWYMYGYAABVUKWYMVUJAWVRWYMWVQVVEVFZVU
        JAWVQVUSVVEWWTYTWVRVUJUYKVNWYNVUJWAGEUOUYLBVUKVUJUYKVVEVVEWNYBUYMUYNYCY
        DAVVDCJIFUQZCJHFUQZVHUPWYPVUMUYRUPZWYPVHUPVUMAVVBWYOVVCWYPVHANBVUOCJDFU
        QZVDZVFZVVBWYOANWYSVURABVUOWYRVUQWWNCJDFWWNDVBVNZJDWQWHZDKWQWHZWWNDVWMV
        NZXUAXUBXUCXAZWWNVVSVWMDVWNUJWRZAXUDXUEWDZWVSAVXSVXTXUGVYAVXNJKDXBVOWTU
        XGUYOUTYEZYTANVUOVNZWYTWYOWAAWUPWUQWURXUIWUSWUTRMNUYPXOZBNWYRWYOVUOWYSW
        VQNWAZDIWAWYRWYOWAUGCDIJFUYQWBWYSWNZCJIFUYSUYTWBYQAMWYSVFZVVCWYPAMWYSVU
        RXUHYTAWUOXUMWYPWAWVABMWYRWYPVUOWYSWVQMWAZDHWAWYRWYPWAUFCDHJFUYQWBXULCJ
        HFUYSUYTWBYQVUAAWYOWYQWYPVHACJHIFVGJKVYAVXNAWVCVXLWULJVWMVNWVDVXOWVEJKY
        HXOZAWUOXUDBVUOVQZHVWMVNZWVAAXUDBVUOXUFVUBZXUDXUQBMVUOXUNDHVWMUFVUCVUDX
        QZAXUIXUPIVWMVNZXUJXURXUDXUTBNVUOXUKDIVWMUGVUCVUDXQZVYJWUAVUHUWQAWYPVUM
        ACJHFVGJKVYAVXNXUOXUSVYJWUAVUEACHIFVGJKVYAVXNXUSXVAVYJWUAVUEVUFUXFVUIVU
        G $.
    $}

    $( Integration by ` u ` -substitution.  If ` A ( x ) ` is a continuous,
       differentiable function from ` [ X , Y ] ` to ` ( Z , W ) ` , whose
       derivative is continuous and integrable, and ` C ( u ) ` is a continuous
       function on ` ( Z , W ) ` , then the integral of ` C ( u ) ` from
       ` K = A ( X ) ` to ` L = A ( Y ) ` is equal to the integral of
       ` C ( A ( x ) ) _D A ( x ) ` from ` X ` to ` Y ` .  In this part of the
       proof we discharge the assumptions in ~ itgsubstlem , which use the fact
       that ` ( Z , W ) ` is open to shrink the interval a little to
       ` ( M , N ) ` where ` Z < M < N < W ` - this is possible because
       ` A ( x ) ` is a continuous function on a closed interval, so its range
       is in fact a closed interval, and we have some wiggle room on the
       edges.  (Contributed by Mario Carneiro, 7-Sep-2014.) $)
    itgsubst $p |- ( ph ->
      S_ [ K -> L ] C _d u = S_ [ X -> Y ] ( E x. B ) _d x ) $=
      ( vz vy vn vm vv cv cicc co cmpt cfv cle wral wrex wa cdit cmul wceq cioo
      wbr ccncf cr wss cc ioossre ax-resscn cncfss mp2an sseldi evthicc wcel cq
      clt cxr ressxr sstri wf cncff syl adantr simprl ffvelrnd eliooord qbtwnxr
      simprd syl3anc qre ad2antrl ad2antrr rexrd simpld simprrl xrlttrd simprrr
      w3a wb elioo2 syl2anc mpbir3and anass wi ffvelrnda simplr xrlelttr mpan2d
      ralimdva imp an32s sylanbr ex reximdv2 rexlimdvaa xrltletr mpand ralbidva
      jca mpd nfel1 weq eleq1d csb nfcv nfcsb1v csbeq1a cbvmpt syl5eqelr csbeq1
      cdv cbvditg nfcvd csbiegf 3syl syl5eqr citg ditgpos sylbid ancom 3biant1d
      reeanv bitr4i r19.26 simplrl simplrr bitr4d nffvmpt1 nfv fveq2 simpr eqid
      cbvral fmpt sylibr r19.21bi fvmpt2 syl5bb cibl cin oveq2i 3eqtr3g simprll
      simprlr simprr rspc mpan9 itgsubstlem ditgeq1 ditgeq2 eqtrd csbeq1d nfcsb
      oveq12d nfov ioossicc sylan2 oveq1d itgeq2dv 3eqtr4d 3eqtr3d expr syl5bir
      sseli rexlimdvva syl5bi syl2and ) AUFUKZBKLULUMZDUNZUOZUGUKZUWKUOZUPVDZUF
      UWJUQZUGUWJURZUWNUWLUPVDZUFUWJUQZUGUWJURZUSCHIFUTZBKLGEVAUMZUTZVBZAUGUFUG
      UFKLUWKNOPAUWJMJVCUMZVEUMZUWJVFVEUMZUWKUXEVFVGVFVHVGUXFUXGVGMJVIZVJUWJUXE
      VFVKVLSVMVNAUWQUWLUHUKZVQVDZUFUWJUQZUHUXEURZUWTUIUKZUWLVQVDZUFUWJUQZUIUXE
      URZUXDAUWPUXLUGUWJAUWMUWJVOZUWPUSZUSZUWNUXIVQVDZUXIJVQVDZUSZUHVPURZUXLUXS
      UWNVRVOZJVRVOZUWNJVQVDZUYCUXSUXEVRUWNUXEVFVRUXHVSVTZUXSUWJUXEUWMUWKAUWJUX
      EUWKWAZUXRAUWKUXFVOUYHSUWJUXEUWKWBWCZWDAUXQUWPWEWFZVMZAUYEUXRRWDUXSMUWNVQ
      VDZUYFUXSUWNUXEVOZUYLUYFUSZUYJUWNMJWGZWCZWIUHUWNJWHWJUXSUYBUXKUHVPUXEUXSU
      XIVPVOZUYBUSZUXIUXEVOZUXKUSUXSUYRUSZUYSUXKUYTUYSUXIVFVOZMUXIVQVDZUYAUYQVU
      AUXSUYBUXIWKZWLZUYTMUWNUXIAMVRVOZUXRUYRQWMZUXSUYDUYRUYKWDUYTUXIVUDWNUXSUY
      LUYRUXSUYLUYFUYPWOWDUXSUYQUXTUYAWPWQUXSUYQUXTUYAWRUYTVUEUYEUYSVUAVUBUYAWS
      WTVUFAUYEUXRUYRRWMMJUXIXAXBXCUXSAUXQUSZUWPUSUYRUXKAUXQUWPXDVUGUYRUWPUXKVU
      GUYRUSZUWPUXKVUHUWOUXJUFUWJVUHUWIUWJVOZUSZUWOUXTUXJVUHUXTVUIVUGUYQUXTUYAW
      PWDVUJUWLVRVOZUYDUXIVRVOZUWOUXTUSUXJXEVUJUXEVRUWLUYGVUHUWJUXEUWIUWKAUYHUX
      QUYRUYIWMZXFVMVUHUYDVUIVUHUXEVRUWNUYGVUHUWJUXEUWMUWKVUMAUXQUYRXGWFVMWDVUJ
      UXIVUHVUAVUIUYQVUAVUGUYBVUCWLWDWNUWLUWNUXIXHWJXIXJXKXLXMXTXNXOYAXPAUWSUXP
      UGUWJAUXQUWSUSZUSZMUXMVQVDZUXMUWNVQVDZUSZUIVPURZUXPVUOVUEUYDUYLVUSAVUEVUN
      QWDVUOUXEVRUWNUYGVUOUWJUXEUWMUWKAUYHVUNUYIWDAUXQUWSWEWFZVMZVUOUYLUYFVUOUY
      MUYNVUTUYOWCZWOUIMUWNWHWJVUOVURUXOUIVPUXEVUOUXMVPVOZVURUSZUXMUXEVOZUXOUSV
      UOVVDUSZVVEUXOVVFVVEUXMVFVOZVUPUXMJVQVDZVVCVVGVUOVURUXMWKZWLZVUOVVCVUPVUQ
      WPVVFUXMUWNJVVFUXMVVJWNVUOUYDVVDVVAWDAUYEVUNVVDRWMZVUOVVCVUPVUQWRVUOUYFVV
      DVUOUYLUYFVVBWIWDWQVVFVUEUYEVVEVVGVUPVVHWSWTAVUEVUNVVDQWMVVKMJUXMXAXBXCVU
      OVUGUWSUSVVDUXOAUXQUWSXDVUGVVDUWSUXOVUGVVDUSZUWSUXOVVLUWRUXNUFUWJVVLVUIUS
      ZVUQUWRUXNVVLVUQVUIVUGVVCVUPVUQWRWDVVMUXMVRVOZUYDVUKVUQUWRUSUXNXEVVMUXMVV
      LVVGVUIVVCVVGVUGVURVVIWLWDWNVVLUYDVUIVVLUXEVRUWNUYGVVLUWJUXEUWMUWKAUYHUXQ
      VVDUYIWMZAUXQVVDXGWFVMWDVVMUXEVRUWLUYGVVLUWJUXEUWIUWKVVOXFVMUXMUWNUWLXQWJ
      XRXJXKXLXMXTXNXOYAXPUXLUXPUSZUXOUXKUSZUHUXEURUIUXEURZAUXDVVPUXPUXLUSVVRUX
      LUXPUUAUXOUXKUIUHUXEUXEUUCUUDAVVQUXDUIUHUXEUXEVVQUXNUXJUSZUFUWJUQZAVVEUYS
      USZUSZUXDUXNUXJUFUWJUUEVWBVVTUWLUXMUXIVCUMZVOZUFUWJUQZUXDVWBVVSVWDUFUWJVW
      BVUIUSZVVSUWLVFVOZUXNUXJWSZVWDVWFUXJUXNVWGVWFUXEVFUWLUXHVWBUWJUXEUWIUWKAU
      YHVWAUYIWDXFVMUUBVWFVVNVULVWDVWHWTVWFUXEVRUXMUYGAVVEUYSVUIUUFVMVWFUXEVRUX
      IUYGAVVEUYSVUIUUGVMUXMUXIUWLXAXBUUHXSVWBVWEDVWCVOZBUWJUQZUXDAVWEVWJWTVWAV
      WEBUKZUWKUOZVWCVOZBUWJUQAVWJVWDVWMUFBUWJBUWLVWCBUWJDUWIUUIYBVWMUFUUJUFBYC
      UWLVWLVWCUWIVWKUWKUUKYDUUNAVWMVWIBUWJAVWKUWJVOZUSZVWLDVWCVWOVWNDUXEVOZVWL
      DVBAVWNUULAVWPBUWJAUYHVWPBUWJUQUYIBUWJUXEDUWKUWKUUMZUUOUUPUUQZBUWJDUXEUWK
      VWQUURXBYDXSUUSWDAVWAVWJUXDAVWAVWJUSZUSZUJBKDYEZBLDYEZCUJUKZFYEZUTZUGKLCB
      UWMDYEZFYEZBUWMEYEZVAUMZUTZUXAUXCVWTUGUJVXFVXHVXDVXGVXAVXBUXMUXIJKLMAKVFV
      OZVWSNWDALVFVOZVWSOWDAKLUPVDVWSPWDAVUEVWSQWDAUYEVWSRWDAUGUWJVXFUNZUXFVOVW
      SAVXMUWKUXFBUGUWJDVXFUGDYFBUWMDYGZBUWMDYHZYIZSYJWDAUGKLVCUMZVXHUNZVXQVHVE
      UMUUTUVAZVOVWSAVXRBVXQEUNZVXSBUGVXQEVXHUGEYFBUWMEYGZBUWMEYHZYIZTYJWDAUJUX
      EVXDUNZUXEVHVEUMZVOVWSAVYDCUXEFUNVYECUJUXEFVXDUJFYFZCVXCFYGZCVXCFYHZYIUAY
      JWDAVFVXMYLUMZVXRVBVWSAVFUWKYLUMVXTVYIVXRUBUWKVXMVFYLVXPUVBVYCUVCWDCVXCVX
      FFYKBUWMKDYKBUWMLDYKAVVEUYSVWJUVDAVVEUYSVWJUVEVWTVWJUXQVXFVWCVOZAVWAVWJUV
      FVWIVYJBUWMUWJBVXFVWCVXNYBBUGYCZDVXFVWCVXOYDUVGUVHUVIAVXEUXAVBVWSAVXECVXA
      VXBFUTZUXACUJVXAVXBFVXDVYHVYFVYGYMAVYLCHVXBFUTZUXAAVXKVXAHVBVYLVYMVBNBKDH
      VFVXKBHYNUDYOCVXAHVXBFUVJYPAVXLVXBIVBVYMUXAVBOBLDIVFVXLBIYNUEYOCVXBIHFUVK
      YPUVLYQWDAVXJUXCVBVWSAVXJBKLCDFYEZEVAUMZUTZUXCBUGKLVYOVXIVYKVYNVXGEVXHVAV
      YKCDVXFFVXOUVMVYBUVOUGVYOYFBVXGVXHVABCVXFFVXNBFYFUVNBVAYFVYAUVPYMABVXQVYO
      YRBVXQUXBYRVYPUXCABVXQVYOUXBAVWKVXQVOZUSZVYNGEVAVYRVWPVYNGVBVYQAVWNVWPVXQ
      UWJVWKKLUVQUWEVWRUVRCDFGUXEVWPCGYNUCYOWCUVSUVTABKLVYOPYSABKLUXBPYSUWAYQWD
      UWBUWCYTYTUWDUWFUWGUWHYA $.
  $}


$(
###############################################################################
                 BASIC REAL AND COMPLEX FUNCTIONS
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                             Polynomials
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Abstract polynomials, continued
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    evlslem1.p $e |- P = ( I mPoly R ) $.
    evlslem1.b $e |- B = ( Base ` P ) $.
    evlslem1.c $e |- C = ( Base ` S ) $.
    evlslem1.k $e |- K = ( Base ` R ) $.
    evlslem1.d $e |- D = { h e. ( NN0 ^m I ) | ( `' h " NN ) e. Fin } $.
    evlslem1.t $e |- T = ( mulGrp ` S ) $.
    evlslem1.x $e |- .^ = ( .g ` T ) $.
    evlslem1.m $e |- .x. = ( .r ` S ) $.
    evlslem1.v $e |- V = ( I mVar R ) $.
    evlslem1.e $e |- E = ( p e. B |-> ( S gsum ( b e. D |->
              ( ( F ` ( p ` b ) ) .x. ( T gsum ( b oF .^ G ) ) ) ) ) ) $.
    evlslem1.i $e |- ( ph -> I e. _V ) $.
    evlslem1.r $e |- ( ph -> R e. CRing ) $.
    evlslem1.s $e |- ( ph -> S e. CRing ) $.
    evlslem1.f $e |- ( ph -> F e. ( R RingHom S ) ) $.
    evlslem1.g $e |- ( ph -> G : I --> C ) $.

    ${
      $d ph b x $.  $d C b x $.  $d D b $.  $d G x $.  $d I h $.  $d .x. x $.
      $d R b $.  $d S b x $.  $d T x $.  $d .^ x $.  $d Y b $.  $d b h $.
      evlslem6.y $e |- ( ph -> Y e. B ) $.
      $( Lemma for ~ evlseu .  Finiteness and consistency of the top-level
         sum.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
      evlslem6 $p |- ( ph -> ( ( b e. D |-> ( ( F ` ( Y ` b ) ) .x.
          ( T gsum ( b oF .^ G ) ) ) ) : D --> C /\ ( `' ( b e. D |->
          ( ( F ` ( Y ` b ) ) .x. ( T gsum ( b oF .^ G ) ) ) ) "
          ( _V \ { ( 0g ` S ) } ) ) e. Fin ) ) $=
        ( vx cv cfv cof co cgsu cmpt wf ccnv cvv c0g csn cdif cima cfn wcel crg
        wa ccrg crngrng syl adantr crh rhmf mplelf ffvelrnda ffvelrnd eqid ccmn
        mgpbas crngmgp simpr psrbagev2 rngcl syl3anc fmptd wss mplelsfi feqmptd
        wceq cnveqd imaeq1d eqimss2 cghm rhmghm ghmid 3syl fvex a1i rnglz sylan
        suppssfv suppssov1 ssfi syl2anc jca ) ADCTDTURZRUSZMUSZHXMNLUTVAVBVAZIV
        AZVCZVDXRVEVFGVGUSZVHVIVJZVKVLZATDXQCXRAXMDVLZVNZGVMVLZXOCVLXPCVLXQCVLA
        YDYBAGVOVLZYDUMGVPVQZVRYCPCXNMAPCMVDZYBAMFGVSVAVLZYGUNPCFGMUDUCVTVQVRAD
        PXMRABDEFJOPRUAUDUBUEUPWAZWBWCYCXMCDHLJNOHVGUSZUECGHUFUCWFUGYJWDAHWEVLZ
        YBAYEYKUMGHUFWGVQVRAYBWHAOCNVDYBUOVRAOVFVLYBUKVRWIZCGIXOXPUCUHWJWKXRWDW
        LARVEZVFFVGUSZVHVIZVJZVKVLXTYPWMYAABEFROVOYNUAUBYNWDZUPULWNATUQXOXPDCYP
        IVFXSXSATXNDMYPVFYNXSAYPTDXNVCZVEZYOVJZWPYTYPWMAYMYSYOARYRATDPRYIWOWQWR
        YTYPWSVQAYHMFGWTVAVLYNMUSXSWPUNFGMXAFGMYNXSYQXSWDZXBXCXNVFVLYCXMRXDXEXH
        AYDUQURZCVLXSUUBIVAXSWPYFCGIUUBXSUCUHUUAXFXGXOVFVLYCXNMXDXEYLXIYPXTXJXK
        XL $.
    $}

    ${
      $d b p x .0. $.  $d p B $.  $d b y z C $.  $d b p x y z D $.  $d b p F $.
      $d b p y z .^ $.  $d b h p x A $.  $d h I $.  $d x K $.  $d b x y z ph $.
      $d b p y z G $.  $d b p x H $.  $d b p S $.  $d b p y T $.  $d b p .x. $.
      $d x R $.
      evlslem3.z $e |- .0. = ( 0g ` R ) $.
      evlslem3.k $e |- ( ph -> A e. D ) $.
      evlslem3.q $e |- ( ph -> H e. K ) $.
      $( Lemma for ~ evlseu .  Polynomial evaluation of a scaled monomial.
         (Contributed by Stefan O'Rear, 8-Mar-2015.) $)
      evlslem3 $p |- ( ph -> ( E ` ( x e. D |-> if ( x = A , H , .0. ) ) ) =
            ( ( F ` H ) .x. ( T gsum ( A oF .^ G ) ) ) ) $=
        ( vy vz cv wceq cif cmpt cfv cof co cgsu wcel cvv crg crngrng mplmon2cl
        ccrg syl fveq1 fveq2d oveq1d mpteq2dv oveq2d fvmpt wa simpr c0g eqeltri
        ovex fvex ifexg syl2anc adantr eqeq1 ifbid eqid fvmptg mpteq2dva rngmnd
        a1i cmnd ccnv cn cima cfn cn0 cmap crab rabex crh wf rhmf ifcl ffvelrnd
        rng0cl mgpbas ccmn crngmgp cmnmnd simprl simprr mulgnn0cl syl3anc sylan
        ad2antrr psrbagf inidm csn cdif wb cc0 wfn ffn eldifi adantl wn ffvelrn
        syl2an 3eqtrd eqtrd off wss psrbag simplbda fnfvof syl22anc wo ad2antlr
        eldifn elpreima mpbir2and mtand elnn0 sylib orel1 sylc mulg0 ssfi rngcl
        suppss gsumcl fmptd eldifsni neneqd iffalse rhmghm ghmid sylan2 suppss2
        cghm rnglz gsumpt iftrue oveq1 oveq12d ) ABFBVDZCVEZQUAVFZVGZMVHZIUCFUC
        VDZUVSVHZOVHZJUWAPNVIZVJZVKVJZKVJZVGZVKVJZCUCFUWACVEZQUAVFZOVHZUWFKVJZV
        GZVHZQOVHZJCPUWDVJZVKVJZKVJZAUVSDVLUVTUWIVEABDSFGHLRCVMQUAUDUHUSUGUNAHV
        QVLHVNVLZUOHVOVRZUEVAUTVPUBUVSIUCFUWAUBVDZVHZOVHZUWFKVJZVGZVKVJUWIDMUXB
        UVSVEZUXFUWHIVKUXGUCFUXEUWGUXGUXDUWCUWFKUXGUXCUWBOUWAUXBUVSVSVTWAWBWCUM
        IUWHVKWIWDVRAUWIIUWNVKVJUWOAUWHUWNIVKAUCFUWGUWMAUWAFVLZWEZUWCUWLUWFKUXI
        UWBUWKOUXIUXHUWKVMVLZUWBUWKVEAUXHWFAUXJUXHAQSVLZUAVMVLZUXJVAUXLAUAHWGVH
        VMUSHWGWJWHWTUWJQUASVMWKWLWMBUWAUVRUWKFVMUVSUVPUWAVEUVQUWJQUAUVPUWACWNW
        OUVSWPWQWLVTWAWRWCAFEUWNIVMCIWGVHZUFUXMWPZAIVNVLZIXAVLAIVQVLZUXOUPIVOVR
        ZIWSVRFVMVLAFLVDXBXCXDXEVLZLXFRXGVJZXHVMUHUXRLUXSXFRXGWIXIWHWTUTAUCFUWM
        EUWNUXIUXOUWLEVLZUWFEVLZUWMEVLAUXOUXHUXQWMAUXTUXHASEUWKOAOHIXJVJVLZSEOX
        KUQSEHIOUGUFXLVRAUXKUASVLZUWKSVLVAAUWTUYCUXASHUAUGUSXOVRUWJQUASXMWLXNWM
        UXIREUWEJVMJWGVHZEIJUIUFXPZUYDWPZAJXQVLZUXHAUXPUYGUPIJUIXRVRZWMARVMVLZU
        XHUNWMZUXIVBVCRRRNXFEEUWAPVMVMUXIVBVDZXFVLZVCVDZEVLZWEZWEJXAVLZUYLUYNUY
        KUYMNVJEVLAUYPUXHUYOAUYGUYPUYHJXSVRYEUXIUYLUYNXTUXIUYLUYNYAENJUYKUYMUYE
        UJYBYCAUYIUXHRXFUWAXKZUNFLUWARVMUHYFYDZAREPXKZUXHURWMZUYJUYJRYGUUAZUXIU
        WAXBXCXDZXEVLZUWEXBVMUYDYHYIXDZVUBUUBVUDXEVLAUXHUYQVUCAUYIUXHUYQVUCWEYJ
        UNFLUWARVMUHUUCVRUUDUXIREVBUWEVUBUYDVUAUXIUYKRVUBYIVLZWEZUYKUWEVHZUYKUW
        AVHZUYKPVHZNVJZYKVUINVJZUYDVUFUWARYLZPRYLZUYIUYKRVLZVUGVUJVEUXIVULVUEUX
        IUYQVULUYRRXFUWAYMVRZWMAVUMUXHVUEAUYSVUMURREPYMVRYEAUYIUXHVUEUNYEVUEVUN
        UXIUYKRVUBYNZYORNUWAPVMUYKUUEUUFVUFVUHYKVUINVUFVUHXCVLZYPVUQVUHYKVEZUUG
        ZVURVUFVUQUYKVUBVLZVUEVUTYPUXIUYKRVUBUUIYOVUFVUQWEZVUTVUNVUQVUEVUNUXIVU
        QVUPUUHVUFVUQWFVVAVULVUTVUNVUQWEYJUXIVULVUEVUQVUOYERUYKXCUWAUUJVRUUKUUL
        VUFVUHXFVLZVUSUXIUYQVUNVVBVUEUYRVUPRXFUYKUWAYQYRVUHUUMUUNVUQVURUUOUUPWA
        VUFVUIEVLZVUKUYDVEUXIUYSVUNVVCVUEUYTVUPREUYKPYQYRENJVUIUYDUYEUYFUJUUQVR
        YSUUTVUBVUDUURWLUVAZEIKUWLUWFUFUKUUSYCUWNWPZUVBAFUWMUCCYHZUXMAUWAFVVFYI
        VLZWEZUWMUXMUWFKVJZUXMVVHUWLUXMUWFKVVHUWLUAOVHZUXMVVHUWKUAOVVGUWKUAVEZA
        VVGUWJYPVVKVVGUWACUWAFCUVCUVDUWJQUAUVEVRYOVTAVVJUXMVEZVVGAOHIUVJVJVLZVV
        LAUYBVVMUQHIOUVFVRHIOUAUXMUSUXNUVGVRWMYTWAVVHUXOUYAVVIUXMVEAUXOVVGUXQWM
        VVGAUXHUYAUWAFVVFYNVVDUVHEIKUWFUXMUFUKUXNUVKWLYTUVIUVLYTACFVLUWOUWSVEUT
        UCCUWMUWSFUWNUWJUWLUWPUWFUWRKUWJUWKQOUWJQUAUVMVTUWJUWEUWQJVKUWACPUWDUVN
        WCUVOVVEUWPUWRKWIWDVRYS $.
    $}

    $d x A $.  $d b p v w x y z B $.  $d b p x y z C $.  $d b p v w x y z ph $.
    $d w x y z E $.  $d b p x F $.  $d b v x y K $.  $d b p x z T $.  $d x V $.
    $d b p v w x y z D $.  $d b h p v w x y z I $.  $d b h p v w x y z R $.
    $d b p v x z G $.  $d b p v w x y z P $.  $d b p w x y z S $.
    $d b p v w z .x. $.  $d b p v x z .^ $.
    evlslem1.a $e |- A = ( algSc ` P ) $.
    $( Lemma for ~ evlseu , give a formula for (the unique) polynomial
       evaluation homomorphism.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    evlslem1 $p |- ( ph -> ( E e. ( P RingHom S ) /\
          ( E o. A ) = F /\ ( E o. V ) = G ) ) $=
      ( vx vy vw vz vv crh co wcel ccom wceq cplusg cfv cmulr cur eqid cvv ccrg
      crg crngrng syl syl2anc cv rngidcl wa cc0 csn c0g cif cmpt cof cgsu simpr
      adantr fveq2d wf evlslem3 a1i fvex feqmptd offval2 ffvelrnda mgpbas mulg0
      mpteq2dva eqtrd oveq2d ccmn rhmf 3eqtrd oveq1d rhm1 cgrp rnggrp ccnv cima
      cz fveq2 cfn cn0 ovex cdif evlslem6 simpld simprd wfn mplelf ffn ad2antrr
      syl3anc ffvelrnd psrbagev2 eqidd fveq1 mpteq2dv fvmpt weq oveq12d 3eqtr4d
      eqtr4d caddc offval adantrl c1 adantl mplrng mplascl psrbag0 0z fconstmpt
      wral cxp rngidval cmnd crngmgp cmnmnd gsumz rngridm ralrimiva rspcva csca
      eqeq12d casa mplassa asclrhm mplsca eleqtrrd 3eqtr3d rngcmn cn cmap rabex
      eqeltri gsumcl fmptd simplrl simplrr mpladd fveq1d simprl simprr syl22anc
      crab fnfvof cghm rhmghm ghmlin rngdir syl13anc grpcl ad2antll isghmd cmgp
      gsumadd rhmmhm simprll simprrl simprlr simprrr mgpplusg mhmlin mulgnn0dir
      cmhm inidm psrbagev1 cmn4 syl122anc psrbagaddcl rngcl evlslem2 isrhmd crn
      psrbagf wss fnmpti frn fnco fvco2 sylan eqfnfvd mvrval psrbagsn 1nn0 0nn0
      mvrf2 keepel oveq1 eqeq1d mulg1 iftrue wn iffalse ifbothda adantlr eldifn
      ifcl elsn sylnib suppss2 gsumpt rnglidm 3jca ) ALFHVBVCVDLBVEZNVFLRVEZOVF
      AUQURCDFVGVHZHVGVHZFHFVIVHZJFVJVHZLHVJVHZUBVUCVKZVUDVKZVUBVKUHAPVLVDZGVNV
      DZFVNVDZUKAGVMVDZVUHULGVOVPZFGPVLUAUUAVQZAHVMVDZHVNVDZUMHVOVPZAGVJVHZBVHZ
      LVHZVUPNVHZVUCLVHVUDAVUPQVDZUQVRZBVHZLVHZVVANVHZVFZUQQUUFVURVUSVFZAVUHVUT
      VUKQGVUPUDVUPVKZVSVPZAVVEUQQAVVAQVDZVTZVVCUREURVRZPWAWBUUGZVFVVAGWCVHZWDW
      EZLVHVVDIVVLOMWFZVCZWGVCZJVCZVVDVVJVVBVVNLVVJURBQEFGKPVLVVAVVMUAUEVVMVKZU
      DUPAVUGVVIUKWIZAVUHVVIVUKWIAVVIWHZUUBWJVVJURVVLCDEFGHIJKLMNOVVAPQRVVMSTUA
      UBUCUDUEUFUGUHUIUJVVTAVUJVVIULWIAVUMVVIUMWIANGHVBVCVDZVVIUNWIAPDOWKZVVIUO
      WIVVSAVVLEVDZVVIAVUGVWDUKEKPVLUEUUCVPWIVWAWLVVJVVRVVDVUDJVCZVVDVVJVVQVUDV
      VDJAVVQVUDVFVVIAVVQIUQPVUDWEZWGVCZVUDAVVPVWFIWGAVVPUQPWAVVAOVHZMVCZWEVWFA
      UQPWAVWHMVVLOVLXLVLUKWAXLVDAVVAPVDZVTZUUDWMVWHVLVDVWKVVAOWNZWMVVLUQPWAWEV
      FAUQPWAUUEWMAUQPDOUOWOWPAUQPVWIVUDVWKVWHDVDZVWIVUDVFAPDVVAOUOWQZDMIVWHVUD
      DHIUFUCWRZHVUDIUFVUFUUHZUGWSVPWTXAXBAIUUIVDZVUGVWGVUDVFAIXCVDZVWQAVUMVWRU
      MHIUFUUJVPZIUUKVPZUKPUQIVLVUDVWPUULVQXAWIXBVVJVUNVVDDVDVWEVVDVFAVUNVVIVUO
      WIAQDVVANAVWBQDNWKZUNQDGHNUDUCXDVPZWQDHJVUDVVDUCUHVUFUUMVQXAXEZUUNVVEVVFU
      QVUPQVVAVUPVFZVVCVURVVDVUSVXDVVBVUQLVVAVUPBXMWJVVAVUPNXMUUQUUOVQAVUQVUCLA
      BGFVBVCZVDZVUQVUCVFABFUUPVHZFVBVCZVXEAFUURVDZBVXHVDAVUGVUJVXIUKULFGPVLUAU
      USVQBVXGFUPVXGVKUUTVPAGVXGFVBAFGPVLVMUAUKULUVAXFUVBZGFVUPBVUCVVGVUEXGVPWJ
      AVWBVUSVUDVFZUNGHVUPNVUDVVGVUFXGVPZUVCAUQURCEFGHJKUSUTVALPVVMUAUBUHVVSUEU
      KULUMAUQURUYTVUAFHLCDUBUCUYTVKZVUAVKZAVUIFXHVDZVULFXIVPZAVUNHXHVDVUOHXIVP
      ASCHTETVRZSVRZVHZNVHZIVXQOVVOVCWGVCZJVCZWEZWGVCZDLAVXRCVDZVTZEDVYCHVLHWCV
      HZUCVYGVKZAHXCVDZVYEAVUNVYIVUOHUVDVPZWIEVLVDZVYFEKVRXJUVEXKXNVDZKXOPUVFVC
      ZUVRVLUEVYLKVYMXOPUVFXPUVGUVHZWMVYFEDVYCWKZVYCXJVLVYGWBXQZXKXNVDZVYFCDEFG
      HIJKLMNOPQRVXRSTUAUBUCUDUEUFUGUHUIUJAVUGVYEUKWIAVUJVYEULWIAVUMVYEUMWIAVWB
      VYEUNWIAVWCVYEUOWIAVYEWHXRZXSVYFVYOVYQVYRXTUVIUJUVJZAVVACVDZVVKCVDZVTZVTZ
      HTEVXQVVAVVKUYTVCZVHZNVHZVYAJVCZWEZWGVCZHTEVXQVVAVHZNVHZVYAJVCZWEZWGVCZHT
      EVXQVVKVHZNVHZVYAJVCZWEZWGVCZVUAVCZWUDLVHZVVALVHZVVKLVHZVUAVCWUCWUIHWUMWU
      RVUAWFVCZWGVCWUTWUCWUHWVDHWGWUCWUHTEWULWUQVUAVCZWEWVDWUCTEWUGWVEWUCVXQEVD
      ZVTZWUGWUKWUPVUAVCZVYAJVCZWVEWVGWUFWVHVYAJWVGWUFWUJWUOGVGVHZVCZNVHZWVHWVG
      WUEWVKNWVGWUEVXQVVAVVKWVJWFVCZVHZWVKWVGVXQWUDWVMWVGCFWVJUYTGPVVAVVKUAUBWV
      JVKZVXMAVYTWUAWVFUVKAVYTWUAWVFUVLUVMUVNWVGVVAEYAZVVKEYAZVYKWVFWVNWVKVFWUC
      WVPWVFWUCEQVVAWKWVPWUCCEFGKPQVVAUAUDUBUEAVYTWUAUVOZYBZEQVVAYCVPWIWUCWVQWV
      FWUCEQVVKWKWVQWUCCEFGKPQVVKUAUDUBUEAVYTWUAUVPZYBZEQVVKYCVPWIVYKWVGVYNWMWU
      CWVFWHZEWVJVVAVVKVLVXQUVSUVQXAWJWVGNGHUVTVCVDZWUJQVDWUOQVDWVLWVHVFAWWCWUB
      WVFAVWBWWCUNGHNUWAVPYDWUCEQVXQVVAWVSWQZWUCEQVXQVVKWWAWQZWVJVUAGHWUJNWUOQU
      DWVOVXNUWBYEXAXFWVGVUNWUKDVDWUPDVDVYADVDWVIWVEVFAVUNWUBWVFVUOYDWVGQDWUJNA
      VXAWUBWVFVXBYDZWWDYFWVGQDWUONWWFWWEYFWVGVXQDEIMKOPVUDUEVWOUGVWPAVWRWUBWVF
      VWSYDWWBAVWCWUBWVFUOYDAVUGWUBWVFUKYDYGDVUAHJWUKWUPVYAUCVXNUHUWCUWDXAWTWUC
      TEWULWUQVUAWUMWURVLVLVLVYKWUCVYNWMZWULVLVDWVGWUKVYAJXPWMWUQVLVDWVGWUPVYAJ
      XPWMWUCWUMYHWUCWURYHWPYOXBWUCEDVUAWUMHWURVLVYGUCVYHVXNAVYIWUBVYJWIWWGWUCE
      DWUMWKZWUMXJVYPXKXNVDZWUCCDEFGHIJKLMNOPQRVVASTUAUBUCUDUEUFUGUHUIUJAVUGWUB
      UKWIZAVUJWUBULWIZAVUMWUBUMWIZAVWBWUBUNWIZAVWCWUBUOWIZWVRXRZXSWUCEDWURWKZW
      URXJVYPXKXNVDZWUCCDEFGHIJKLMNOPQRVVKSTUAUBUCUDUEUFUGUHUIUJWWJWWKWWLWWMWWN
      WVTXRZXSWUCWWHWWIWWOXTWUCWWPWWQWWRXTUWIXAWUCWUDCVDZWVAWUIVFWUCVXOVYTWUAWW
      SAVXOWUBVXPWIWVRWVTCUYTFVVAVVKUBVXMUWEYESWUDVYDWUICLVXRWUDVFZVYCWUHHWGWWT
      TEVYBWUGWWTVXTWUFVYAJWWTVXSWUENVXQVXRWUDYIWJXFYJXBUJHWUHWGXPYKVPWUCWVBWUN
      WVCWUSVUAWUCVYTWVBWUNVFWVRSVVAVYDWUNCLSUQYLZVYCWUMHWGWXATEVYBWULWXAVXTWUK
      VYAJWXAVXSWUJNVXQVXRVVAYIWJXFYJXBUJHWUMWGXPYKVPWUAWVCWUSVFAVYTSVVKVYDWUSC
      LSURYLZVYCWURHWGWXBTEVYBWUQWXBVXTWUPVYAJWXBVXSWUONVXQVXRVVKYIWJXFYJXBUJHW
      URWGXPYKUWFYMYNZUWGAWUBUTVRZEVDZUSVRZEVDZVTZVTZVTZWXDVVAVHZWXFVVKVHZGVIVH
      ZVCZNVHZIWXDWXFYPWFVCZOVVOVCZWGVCZJVCZWXKNVHZIWXDOVVOVCZWGVCZJVCZWXLNVHZI
      WXFOVVOVCZWGVCZJVCZJVCZVAEVAVRZWXPVFWXNVVMWDWELVHVAEVAUTYLWXKVVMWDWELVHZV
      AEVAUSYLWXLVVMWDWELVHZJVCWXJWXSWXTWYDJVCZWYBWYFJVCZJVCZWYHWXJWXOWYLWXRWYM
      JWXJNGUWHVHZIUWRVCVDZWXKQVDZWXLQVDZWXOWYLVFAWYPWXIAVWBWYPUNGHNWYOIWYOVKZU
      FUWJVPWIWXJEQWXDVVAWXJCEFGKPQVVAUAUDUBUEAVYTWUAWXHUWKYBAWUBWXEWXGUWLZYFZW
      XJEQWXFVVKWXJCEFGKPQVVKUAUDUBUEAVYTWUAWXHUWMYBAWUBWXEWXGUWNZYFZQWXMJWYOIN
      WXKWXLQGWYOWYSUDWRGWXMWYOWYSWXMVKZUWOHJIUFUHUWOZUWPYEAWXHWXRWYMVFWUBAWXHV
      TZWXRIWYAWYEJWFVCZWGVCWYMXUFWXQXUGIWGXUFVAPWYIWXDVHZWYIWXFVHZYPVCZWYIOVHZ
      MVCZWEVAPXUHXUKMVCZXUIXUKMVCZJVCZWEWXQXUGXUFVAPXULXUOXUFWYIPVDZVTZVWQXUHX
      OVDXUIXOVDXUKDVDXULXUOVFAVWQWXHXUPVWTYDXUFPXOWYIWXDXUFVUGWXEPXOWXDWKZAVUG
      WXHUKWIZAWXEWXGUVOZEKWXDPVLUEUXHVQZWQXUFPXOWYIWXFXUFVUGWXGPXOWXFWKZXUSAWX
      EWXGUVPZEKWXFPVLUEUXHVQZWQXUFPDWYIOAVWCWXHUOWIZWQDJMIXUHXUIXUKVWOUGXUEUWQ
      UWDWTXUFVAPXUJXUKMWXPOVLVLVLXUSXUJVLVDXUQXUHXUIYPXPWMXUKVLVDXUQWYIOWNWMXU
      FVAPPXUHXUIYPPWXDWXFVLVLXUFXURWXDPYAXVAPXOWXDYCVPZXUFXVBWXFPYAXVDPXOWXFYC
      VPZXUSXUSPUWSZXUQXUHYHZXUQXUIYHZYQAOVAPXUKWEVFWXHAVAPDOUOWOWIWPXUFVAPXUMX
      UNJWYAWYEVLVLVLXUSXUMVLVDXUQXUHXUKMXPWMXUNVLVDXUQXUIXUKMXPWMXUFVAPPXUHXUK
      MPWXDOVLVLXVFAOPYAZWXHAVWCXVKUOPDOYCVPZWIZXUSXUSXVHXVIXUQXUKYHZYQXUFVAPPX
      UIXUKMPWXFOVLVLXVGXVMXUSXUSXVHXVJXVNYQWPYNXBXUFPDJWYAIWYEVLVUDVWOVWPXUEAV
      WRWXHVWSWIZXUSXUFPDWYAWKZWYAXJVLVUDWBXQZXKXNVDZXUFWXDDEIMKOPVUDUEVWOUGVWP
      XVOXUTXVEXUSUWTZXSXUFPDWYEWKZWYEXJXVQXKXNVDZXUFWXFDEIMKOPVUDUEVWOUGVWPXVO
      XVCXVEXUSUWTZXSXUFXVPXVRXVSXTXUFXVTXWAXWBXTUWIXAYRYMWXJVWRWXTDVDWYDDVDWYB
      DVDZWYFDVDZWYNWYHVFAVWRWXIVWSWIWXJQDWXKNAVXAWXIVXBWIZXUAYFWXJQDWXLNXWEXUC
      YFAWXHXWCWUBXUFWXDDEIMKOPVUDUEVWOUGVWPXVOXUTXVEXUSYGYRAWXHXWDWUBXUFWXFDEI
      MKOPVUDUEVWOUGVWPXVOXVCXVEXUSYGYRDJIWYFWXTWYDWYBVWOXUEUXAUXBXAWXJVAWXPCDE
      FGHIJKLMNOWXNPQRVVMSTUAUBUCUDUEUFUGUHUIUJAVUGWXIUKWIZAVUJWXIULWIZAVUMWXIU
      MWIZAVWBWXIUNWIZAVWCWXIUOWIZVVSWXJVUGWXEWXGWXPEVDXWFWYTXUBEKWXDWXFPVLUEUX
      CYEWXJVUHWYQWYRWXNQVDAVUHWXIVUKWIXUAXUCQGWXMWXKWXLUDXUDUXDYEWLWXJWYJWYCWY
      KWYGJWXJVAWXDCDEFGHIJKLMNOWXKPQRVVMSTUAUBUCUDUEUFUGUHUIUJXWFXWGXWHXWIXWJV
      VSWYTXUAWLWXJVAWXFCDEFGHIJKLMNOWXLPQRVVMSTUAUBUCUDUEUFUGUHUIUJXWFXWGXWHXW
      IXWJVVSXUBXUCWLYMYNUXEUCVXMVXNVYSWXCUXFAUQQUYRNALCYAZBQYAZBUXGCUXIZUYRQYA
      XWKASCVYDLHVYCWGXPUJUXJWMZAQCBWKZXWLAVXFXWOVXJQCGFBUDUBXDVPZQCBYCVPZAXWOX
      WMXWPQCBUXKVPCQLBUXLYEAVXANQYAVXBQDNYCVPVVJVVAUYRVHZVVCVVDAXWLVVIXWRVVCVF
      XWQQLBVVAUXMUXNVXCXAUXOAUQPUYSOAXWKRPYAZRUXGCUXIZUYSPYAXWNAPCRWKZXWSACFGP
      RVLUAUIUBUKVUKUXTZPCRYCVPZAXXAXWTXXBPCRUXKVPCPLRUXLYEXVLVWKVVAUYSVHZVVARV
      HZLVHZVWHAXWSVWJXXDXXFVFXXCPLRVVAUXMUXNVWKXXFUREVVKUTPUTUQYLZYSWAWDZWEZVF
      VUPVVMWDWEZLVHVUSIXXIOVVOVCZWGVCZJVCZVWHVWKXXEXXJLVWKUTEGVUPURKPRVLVVAVMV
      VMUIUEVVSVVGAVUGVWJUKWIZAVUJVWJULWIZAVWJWHZUXPWJVWKURXXICDEFGHIJKLMNOVUPP
      QRVVMSTUAUBUCUDUEUFUGUHUIUJXXNXXOAVUMVWJUMWIAVWBVWJUNWIAVWCVWJUOWIVVSAXXI
      EVDZVWJAVUGXXQUKUTEKPVVAVLUEUXQVPWIAVUTVWJVVHWIWLVWKXXMVUDVWHJVCZVWHVWKVU
      SVUDXXLVWHJAVXKVWJVXLWIVWKXXLIUTPXXGWXDOVHZVUDWDZWEZWGVCVVAXYAVHZVWHVWKXX
      KXYAIWGAXXKXYAVFVWJAXXKUTPXXHXXSMVCZWEXYAAUTPXXHXXSMXXIOVLXODUKXXHXOVDAWX
      DPVDZVTZXXGYSWAXOUXRUXSUYAWMAPDWXDOUOWQZAXXIYHAUTPDOUOWOWPAUTPXYCXXTXXGYS
      XXSMVCZXXTVFWAXXSMVCZXXTVFXYCXXTVFXYEYSWAYSXXHVFXYGXYCXXTYSXXHXXSMUYBUYCW
      AXXHVFXYHXYCXXTWAXXHXXSMUYBUYCXYEXXGVTZXYGXXSXXTXYIXXSDVDZXYGXXSVFXYEXYJX
      XGXYFWIDMIXXSVWOUGUYDVPXXGXXTXXSVFXYEXXGXXSVUDUYEZYTYOXYEXXGUYFZVTXYHVUDX
      XTXYEXYHVUDVFZXYLXYEXYJXYMXYFDMIXXSVUDVWOVWPUGWSVPWIXYLXXTVUDVFZXYEXXGXXS
      VUDUYGZYTYOUYHWTXAWIXBVWKPDXYAIVLVVAVUDVWOVWPAVWQVWJVWTWIXXNXXPVWKUTPXXTD
      XYAVWKXYDVTXYJVUDDVDZXXTDVDAXYDXYJVWJXYFUYIAXYPVWJXYDAVUNXYPVUODHVUDUCVUF
      VSVPYDXXGXXSVUDDUYKVQXYAVKZUVJVWKPXXTUTVVAWBZVUDWXDPXYRXQVDZXYNVWKXYSXYLX
      YNXYSWXDXYRVDXXGWXDPXYRUYJUTVVAUYLUYMXYOVPYTUYNUYOVWJXYBVWHVFAUTVVAXXTVWH
      PXYAXXGXXTXXSVWHXYKWXDVVAOXMXAXYQVWLYKYTXEYMVWKVUNVWMXXRVWHVFAVUNVWJVUOWI
      VWNDHJVUDVWHUCUHVUFUYPVQXAXEXAUXOUYQ $.
  $}

  ${
    $d m n A $.  $d x y C $.  $d m n x y F $.  $d m n x y G $.  $d m x y z I $.
    $d m n x y P $.  $d m n x y ph $.  $d x y z R $.  $d m n x y S $.
    $d m n V $.
    evlseu.p $e |- P = ( I mPoly R ) $.
    evlseu.c $e |- C = ( Base ` S ) $.
    evlseu.a $e |- A = ( algSc ` P ) $.
    evlseu.v $e |- V = ( I mVar R ) $.
    evlseu.i $e |- ( ph -> I e. _V ) $.
    evlseu.r $e |- ( ph -> R e. CRing ) $.
    evlseu.s $e |- ( ph -> S e. CRing ) $.
    evlseu.f $e |- ( ph -> F e. ( R RingHom S ) ) $.
    evlseu.g $e |- ( ph -> G : I --> C ) $.
    $( For a given intepretation of the variables ` G ` and of the scalars
       ` F ` , this extends to a homomorphic interpretation of the polynomial
       ring in exactly one way.  (Contributed by Stefan O'Rear, 9-Mar-2015.) $)
    evlseu $p |- ( ph -> E! m e. ( P RingHom S )
            ( ( m o. A ) = F /\ ( m o. V ) = G ) ) $=
      ( vx vy vz vn cv ccom wceq wa crh co wrex wrmo wreu cbs cfv ccnv cima cfn
      wcel cn0 cmap crab cmgp cmg cof cgsu cmulr cmpt w3a evlslem1 coeq1 eqeq1d
      cn eqid anbi12d rspcev 3impb syl crn cun cres wral wfun csca cvv crg ccrg
      wi wf crngrng mpllmod asclf syl2anc ffun funcoeqres sylan mvrf2 anim12dan
      mplrng ex resundi uneq12 syl5eq syl6 ralrimivw weq eqtr3 cin cdm wss cmrc
      csubrg cmps casp cascl casa psrassa mvrf frn aspval2 mplbas2 cpw mplsubrg
      mplval2 subsubrg2 fveq2d ressascl syl6reqr rneqd cmre subrgmre 3syl unssd
      syl3anc ad2antrr wfn wb rhmf ffn adantr uneq1d submrc eqtr2d simpr rhmeql
      fveq12d assarng eqsstr3d 3eqtr3d ad2antlr mrcsscl eqsstrd simprl fnreseql
      simprr fneqeql2 3imtr4d syl5 ralrimivva reseq1 rmo4 sylibr rmoim sylanbrc
      sylc reu5 ) AGUEZBUFZHUGZUVGKUFZIUGZUHZGDFUIUJZUKZUVLGUVMULZUVLGUVMUMAUAD
      UNUOZFUBUCUEUPVMUQURUSUCUTJVAUJVBZUBUEZUAUEUOHUOFVCUOZUVRIUVSVDUOZVEUJVFU
      JFVGUOZUJVHVFUJVHZUVMUSZUWBBUFZHUGZUWBKUFZIUGZVIUVNABUVPCUVQDEFUVSUWAUCUW
      BUVTHIJEUNUOZKUAUBLUVPVNZMUWHVNUVQVNUVSVNUVTVNUWAVNOUWBVNPQRSTNVJUWCUWEUW
      GUVNUVLUWEUWGUHGUWBUVMUVGUWBUGZUVIUWEUVKUWGUWJUVHUWDHUVGUWBBVKVLUWJUVJUWF
      IUVGUWBKVKVLVOVPVQVRAUVLUVGBVSZKVSZVTZWAZHBUPUFZIKUPUFZVTZUGZWHZGUVMWBUWR
      GUVMULZUVOAUWSGUVMAUVLUVGUWKWAZUWOUGZUVGUWLWAZUWPUGZUHZUWRAUVLUXEAUVIUXBU
      VKUXDABWCZUVIUXBADWDUOZUNUOZUVPBWIZUXFAJWEUSZEWFUSZUXIPAEWGUSUXKQEWJVRZUX
      JUXKUHBUVPUXGUXHDNUXGVNDEJWELWSZDEJWELWKUXHVNUWIWLWMZUXHUVPBWNVRUVGBHWOWP
      AKWCZUVKUXDAJUVPKWIZUXOAUVPDEJKWELOUWIPUXLWQZJUVPKWNVRUVGKIWOWPWRWTUXEUWN
      UXAUXCVTUWQUVGUWKUWLXAUXAUWOUXCUWPXBXCXDXEAUWRUDUEZUWMWAZUWQUGZUHZGUDXFZW
      HZUDUVMWBGUVMWBUWTAUYCGUDUVMUVMUYAUWNUXSUGZAUVGUVMUSZUXRUVMUSZUHZUHZUYBUW
      NUXSUWQXGUYHUWMUVGUXRXHXIZXJZUVPUYIXJZUYDUYBUYHUYJUYKUYHUYJUHZUVPUWMDXLUO
      ZXKUOZUOZUYIAUVPUYOUGUYGUYJAUWLJEXMUJZXNUOZUOZUYPXOUOZVSZUWLVTZUYPXLUOZXK
      UOZUOZUVPUYOAUYPXPUSZUWLUYPUNUOZXJZUYRVUDUGAEUYPJWEUYPVNZPQXQZAJVUFKWIVUG
      AVUFEUYPJKWEVUHOVUFVNZPUXLXRJVUFKXSVRUYQUYSVUCUWLVUFUYPUYQVNZUYSVNZVUCVNZ
      VUJXTWMAUYQDEUYPJKWELVUHOVUKPQYAAUYOVUAVUBUVPYBXHZXKUOZUOZVUDAUWMVUAUYNVU
      OAUYMVUNXKAUVPVUBUSZUYMVUNUGADEUYPUVPJWEVUHLUWIPUXLYCZUVPUYPDDEUYPUVPJLVU
      HUWIYDZYEVRYFAUWKUYTUWLABUYSAUYSDXOUOZBAVUQUYSVUTUGVURUYSUVPUYPDVULVUSYGV
      RNYHYIZUUAUUFAVUBVUFYJUOUSZVUQVUAUVPXJVUPVUDUGAVUEUYPWFUSVVBVUIUYPUUGVUFU
      YPVUJYKYLVURAUYTUWLUVPAUYTUWKUVPVVAAUXIUWKUVPXJZUXNUXHUVPBXSVRZUUHAUXPUWL
      UVPXJZUXQJUVPKXSVRZYMVUBUVPVUAVUCVUOVUFVUMVUOVNUUBYNUUCUUIYOUYLUYMUVPYJUO
      USZUYJUYIUYMUSZUYOUYIXJAVVGUYGUYJADWFUSZVVGAUXJUXKVVIPUXLUXMWMUVPDUWIYKVR
      YOUYHUYJUUDUYGVVHAUYJDFUVGUXRUUEUUJUYMUWMUYNUYIUVPUYNVNUUKYNUULWTUYHUVGUV
      PYPZUXRUVPYPZUWMUVPXJUYDUYJYQUYHUYEUVPCUVGWIVVJAUYEUYFUUMUVPCDFUVGUWIMYRU
      VPCUVGYSYLZUYHUYFUVPCUXRWIVVKAUYEUYFUUOUVPCDFUXRUWIMYRUVPCUXRYSYLZUYHUWKU
      WLUVPAVVCUYGVVDYTAVVEUYGVVFYTYMUVPUVGUXRUWMUUNYNUYHVVJVVKUYBUYKYQVVLVVMUV
      PUVGUXRUUPWMUUQUURUUSUWRUXTGUDUVMUYBUWNUXSUWQUVGUXRUWMUUTVLUVAUVBUVLUWRGU
      VMUVCUVEUVLGUVMUVFUVD $.
  $}

  ${
    $d a b f g i r s w x z I $.  $d a b f g i r s w x S $.
    $( Well-behaved binary operation property of ` evalSub ` .  (Contributed by
       Stefan O'Rear, 19-Mar-2015.) $)
    reldmevls $p |- Rel dom evalSub $=
      ( vi vs vb vr vw vf vx vg cvv ccrg cv cbs cfv csubrg cress ccom cmpt wceq
      co csb cmpl cascl cmap csn cxp cmvr cpws crh crio ces df-evls reldmmpt2
      wa ) ABIJCBKZLMDUNNMEAKZUNDKZOSZUASFKZEKZUBMPGUPCKUOUCSZGKZUDUEQRURUOUQUF
      SPGUOHUTVAHKMQQRUMFUSUNUTUGSUHSUITQTUJGEFHABDCUKUL $.

    mpfrcl.q $e |- Q = ran ( ( I evalSub S ) ` R ) $.
    $( Reverse closure for the set of polynomial functions.  (Contributed by
       Stefan O'Rear, 19-Mar-2015.) $)
    mpfrcl $p |- ( X e. Q -> ( I e. _V /\ S e. CRing /\
          R e. ( SubRing ` S ) ) ) $=
      ( vb vr vw vf vx vg wcel co cfv c0 wceq cv cmpt csb va vi ces crn wne cvv
      vs ccrg csubrg w3a ne0i eleq2s rneq rn0 syl6eq necon3i wa fveq1 reldmevls
      0fv ovprc1 necon1ai wex wi n0 cbs cress cmpl cascl ccom cmap csn cxp cmvr
      cpws crh crio df-evls elmpt2cl2 a1d exlimiv sylbi jcai syl wn cdm nfcsb1v
      fvex nfcv nfmpt csbeq1a mpteq2dv csbief fveq2 adantl csbeq1d id oveqan12d
      oveq1 oveq2 oveqan12rd oveq2d adantr xpeq1d eqeq2d coeq2d simpl mpteq12dv
      mpteq1d eqeq12d anbi12d riotaeqbidv eqtrd syl5eq mptex ovmpt2a dmeqd eqid
      csbeq2dv dmmptss syl6eqss ssneld ndmfv syl6 necon1ad com12 df-3an sylibr
      3syl ) EAMBDCUCNZOZUDZPUEZYKPUEZDUFMZCUHMZBCUIOZMZUJZYMEYLAYLEUKFULYKPYLP
      YKPQZYLPUDPYKPUMUNUOUPYNYOYPUQZYRUQYSYNUUAYRYNYJPUEZUUAYJPYKPYJPQYKBPOPBY
      JPURBUTUOUPUUBYOYPYOYJPDCUCUSVAVBUUBUARZYJMZUAVCYOYPVDZUAYJVEUUDUUEUAUUDY
      PYOUBUGUFUHGUGRZVFOZHUUFUIOZIUBRZUUFHRZVGNZVHNZJRZIRZVIOVJZKUUJGRZUUIVKNZ
      KRZVLZVMZSZQZUUMUUIUUKVNNZVJZKUUILUUQUURLROZSZSZQZUQZJUUNUUFUUQVONZVPNZVQ
      ZTZSZTZDCUCUUCKIJLUBUGHGVRZVSVTWAWBWCWDUUAYNYRUUAYRYKPUUAYRWEBYJWFZMWEYTU
      UAUVQYQBUUAUVQHYQGCVFOZIDCUUJVGNZVHNZUUOKUUJUUPDVKNZUUSVMZSZQZUUMDUVSVNNZ
      VJZKDLUWAUVESZSZQZUQZJUUNCUWAVONZVPNZVQZTZTZSZWFYQUUAYJUWPUBUGDCUFUHUVOUW
      PUCUUIDQZUUFCQZUQZUVOHUUHGUUGUVMTZSZUWPGUUGUVNUXAUUFVFWHGHUUHUWTGUUHWIGUU
      GUVMWGWJUUPUUGQHUUHUVMUWTGUUGUVMWKWLWMUWSHUUHUWTYQUWOUWRUUHYQQUWQUUFCUIWN
      WOUWSUWTGUVRUVMTUWOUWSGUUGUVRUVMUWRUUGUVRQUWQUUFCVFWNWOWPUWSGUVRUVMUWNUWS
      UVMIUVTUVLTUWNUWSIUULUVTUVLUWQUWRUUIDUUKUVSVHUWQWQZUUFCUUJVGWSZWRWPUWSIUV
      TUVLUWMUWSUVIUWJJUVKUWLUWSUVJUWKUUNVPUWRUWQUUFCUUQUWAVOUWRWQUUIDUUPVKWTZX
      AXBUWSUVBUWDUVHUWIUWSUVAUWCUUOUWSKUUJUUTUWBUWSUUQUWAUUSUWQUUQUWAQUWRUXDXC
      ZXDWLXEUWSUVDUWFUVGUWHUWSUVCUWEUUMUWQUWRUUIDUUKUVSVNUXBUXCWRXFUWSKUUIUVFD
      UWGUWQUWRXGUWSLUUQUWAUVEUXEXIXHXJXKXLXSXMXSXMXHXNUVPHYQUWOCUIWHXOXPXQHYQU
      WOUWPUWPXRXTYAYBBYJYCYDYEYFWCYOYPYRYGYHYI $.
  $}

  ${
    $d I b f g i r s w x $.  $d R f r x $.  $d S b f g i r s w x $.  $d T f $.
    $d W f $.
    evlsval.q $e |- Q = ( ( I evalSub S ) ` R ) $.
    evlsval.w $e |- W = ( I mPoly U ) $.
    evlsval.v $e |- V = ( I mVar U ) $.
    evlsval.u $e |- U = ( S |`s R ) $.
    evlsval.t $e |- T = ( S ^s ( B ^m I ) ) $.
    evlsval.b $e |- B = ( Base ` S ) $.
    evlsval.a $e |- A = ( algSc ` W ) $.
    evlsval.x $e |- X = ( x e. R |-> ( ( B ^m I ) X. { x } ) ) $.
    evlsval.y $e |- Y = ( x e. I |-> ( g e. ( B ^m I ) |-> ( g ` x ) ) ) $.
    $( Value of the polynomial evaluation map function.  (Contributed by Stefan
       O'Rear, 11-Mar-2015.) $)
    evlsval $p |- ( ( I e. _V /\ S e. CRing /\ R e. ( SubRing ` S ) ) ->
        Q = ( iota_ f e. ( W RingHom T ) ( ( f o. A ) = X /\
              ( f o. V ) = Y ) ) ) $=
      ( vr vi vs vb vw cvv wcel ccrg csubrg cfv w3a cv cress co cmpl cascl ccom
      cbs cmap csn cxp cmpt wceq cmvr wa cpws crh crio ces fveq2 adantl csbeq1d
      csb fvex simplr fveq2d simpll oveq1 ad2antlr oveq12d simprr simprl coeq2d
      ovex xpeq1d mpteq2dv eqeq12d oveq1d mpteq1d mpteq12dv anbi12d riotaeqbidv
      a1i anassrs csbied eqtrd df-evls mptex ovmpt2a fveq1d syl5eq oveq2 oveq2d
      3adant3 mpteq1 eqeq1d eqid riotaex fvmpt wtru oveq2i eqtri oveq1i oveq12i
      wb fveq2i coeq2i xpeq1i mpteq2i eqeq12i mpteq12i anbi12i syl6eqr 3ad2ant3
      trud ) KUJUKZFULUKZEFUMUNZUKZUODEUEYLIUPZKFUEUPZUQURZUSURZUTUNZVAZAYOFVBU
      NZKVCURZAUPZVDZVEZVFZVGZYNKYPVHURZVAZAKJUUAUUBJUPUNZVFZVFZVGZVIZIYQFUUAVJ
      URZVKURZVLZVFZUNZYNBVAZNVGZYNLVAZOVGZVIZIMGVKURZVLZYJYKDUURVGYMYJYKVIZDEK
      FVMURZUNUURPUVFEUVGUUQUFUGKFUJULUHUGUPZVBUNZUEUVHUMUNZUIUFUPZUVHYOUQURZUS
      URZYNUIUPZUTUNZVAZAYOUHUPZUVKVCURZUUCVEZVFZVGZYNUVKUVLVHURZVAZAUVKJUVRUUI
      VFZVFZVGZVIZIUVNUVHUVRVJURZVKURZVLZVQZVFZVQZUUQVMUVKKVGZUVHFVGZVIZUWMUHYT
      UWLVQUUQUWPUHUVIYTUWLUWOUVIYTVGUWNUVHFVBVNVOVPUWPUHYTUWLUUQUJYTUJUKUWPFVB
      VRWQUWPUVQYTVGZVIZUEUVJUWKYLUUPUWRUVHFUMUWNUWOUWQVSVTUWRUWKUIYQUWJVQUUPUW
      RUIUVMYQUWJUWRUVKKUVLYPUSUWNUWOUWQWAUWOUVLYPVGUWNUWQUVHFYOUQWBWCWDVPUWRUI
      YQUWJUUPUJYQUJUKUWRKYPUSWHWQUWPUWQUVNYQVGZUWJUUPVGUWPUWQUWSVIZVIZUWGUUMIU
      WIUUOUXAUVNYQUWHUUNVKUWPUWQUWSWEZUXAUVHFUVRUUAVJUWNUWOUWTVSZUXAUVQYTUVKKV
      CUWPUWQUWSWFUWNUWOUWTWAZWDZWDWDUXAUWAUUFUWFUULUXAUVPYSUVTUUEUXAUVOYRYNUXA
      UVNYQUTUXBVTWGUXAAYOUVSUUDUXAUVRUUAUUCUXEWIWJWKUXAUWCUUHUWEUUKUXAUWBUUGYN
      UXAUVKKUVLYPVHUXDUXAUVHFYOUQUXCWLWDWGUXAAUVKUWDKUUJUXDUXAJUVRUUAUUIUXEWMW
      NWKWOWPWRWSWTWNWSWTAUIIJUFUGUEUHXAUEYLUUPFUMVRXBXCXDXEXHYMYJUURUVEVGYKYMU
      URYNKFEUQURZUSURZUTUNZVAZAEUUDVFZVGZYNKUXFVHURZVAZUUKVGZVIZIUXGUUNVKURZVL
      ZUVEUEEUUPUXQYLUUQYOEVGZUUMUXOIUUOUXPUXRYQUXGUUNVKUXRYPUXFKUSYOEFUQXFZXGZ
      WLUXRUUFUXKUULUXNUXRYSUXIUUEUXJUXRYRUXHYNUXRYQUXGUTUXTVTWGAYOEUUDXIWKUXRU
      UHUXMUUKUXRUUGUXLYNUXRYPUXFKVHUXSXGWGXJWOWPUUQXKUXOIUXPXLXMUVEUXQVGXNUVCU
      XOIUVDUXPUVDUXPVGXNMUXGGUUNVKMKHUSURUXGQHUXFKUSSXOXPZGFCKVCURZVJURUUNTUYB
      UUAFVJCYTKVCUAXQZXOXPXRWQUVCUXOXSXNUUTUXKUVBUXNUUSUXINUXJBUXHYNBMUTUNUXHU
      BMUXGUTUYAXTXPYANAEUYBUUCVEZVFUXJUCAEUYDUUDUYBUUAUUCUYCYBYCXPYDUVAUXMOUUK
      LUXLYNLKHVHURUXLRHUXFKVHSXOXPYAOAKJUYBUUIVFZVFUUKUDAKUYEUUJJUYBUUIUUAUUIU
      YCUUIXKYEYCXPYDYFWQWPYIYGYHWT $.

    $d A m $.  $d B g $.  $d B x $.  $d I m $.  $d Q m $.  $d R g m $.
    $d S m $.  $d T m x $.  $d V m $.  $d W m $.  $d X m $.  $d Y m $.
    $( Characterizing properties of the polynomial evaluation map function.
       (Contributed by Stefan O'Rear, 12-Mar-2015.) $)
    evlsval2 $p |- ( ( I e. _V /\ S e. CRing /\ R e. ( SubRing ` S ) ) ->
        ( Q e. ( W RingHom T ) /\ ( ( Q o. A ) = X /\ ( Q o. V ) = Y ) ) ) $=
      ( vm cvv wcel ccrg csubrg cfv w3a cv ccom wceq crh crab crio evlsval wreu
      wa co cbs eqid simp1 subrgcrng 3adant1 cmap simp2 pwscrng sylancl csn cxp
      ovex cmpt cres wss subrgss 3ad2ant3 resmpt syl syl6eqr crngrng pwsdiagrhm
      crg 3ad2ant2 simp3 resrhm syl2anc eqeltrrd wf fvex eqeltri simpl1 sylancr
      wb elmapg biimpa simplr ffvelrnd simpl2 pwselbasb mpbird riotacl2 eqeltrd
      fmptd evlseu coeq1 eqeq1d anbi12d elrab sylib ) JUEUFZFUGUFZEFUHUIUFZUJZD
      UDUKZBULZMUMZXOKULZNUMZUSZUDLGUNUTZUOZUFDYAUFDBULZMUMZDKULZNUMZUSZUSXNDXT
      UDYAUPZYBABCDEFGHUDIJKLMNOPQRSTUAUBUCUQXNXTUDYAURYHYBUFXNBGVAUIZLHGUDMNJK
      PYIVBZUAQXKXLXMVCXLXMHUGUFXKEFHRVDVEXNXLCJVFUTZUEUFZGUGUFXKXLXMVGCJVFVLZF
      YKUEGSVHVIXNACYKAUKZVJVKZVMZEVNZMHGUNUTZXNYQAEYOVMZMXNECVOZYQYSUMXMXKYTXL
      ECFTVPVQACEYOVRVSUBVTXNYPFGUNUTUFZXMYQYRUFXNFWCUFZYLUUAXLXKUUBXMFWAWDYMAC
      FYPYKUEGSTYPVBWBVIXKXLXMWEFGHYPERWFWGWHXNAJIYKYNIUKZUIZVMZYINXNYNJUFZUSZU
      UEYIUFZYKCUUEWIZUUGIYKUUDCUUEUUGUUCYKUFZUSJCYNUUCUUGUUJJCUUCWIZUUGCUEUFXK
      UUJUUKWNCFVAUIUETFVAWJWKXKXLXMUUFWLCJUUCUEUEWOWMWPXNUUFUUJWQWRUUEVBXDUUGX
      LYLUUHUUIWNXKXLXMUUFWSYMCFYKYIUGUUEGUESTYJWTVIXAUCXDXEXTUDYAXBVSXCXTYGUDD
      YAXODUMZXQYDXSYFUULXPYCMXODBXFXGUULXRYENXODKXFXGXHXIXJ $.
  $}

  ${
    $d B x y $.  $d I x y $.  $d R x y $.  $d S x y $.  $d T x $.
    evlsrhm.q $e |- Q = ( ( I evalSub S ) ` R ) $.
    evlsrhm.w $e |- W = ( I mPoly U ) $.
    evlsrhm.u $e |- U = ( S |`s R ) $.
    evlsrhm.t $e |- T = ( S ^s ( B ^m I ) ) $.
    evlsrhm.b $e |- B = ( Base ` S ) $.
    $( Polynomial evaluation is a homomorphism (into the product ring).
       (Contributed by Stefan O'Rear, 12-Mar-2015.) $)
    evlsrhm $p |- ( ( I e. V /\ S e. CRing /\ R e. ( SubRing ` S ) ) ->
        Q e. ( W RingHom T ) ) $=
      ( vx vy wcel cfv co eqid cvv ccrg csubrg crh elex w3a cascl ccom cmap csn
      cv cxp cmpt wceq cmvr wa evlsval2 simpld syl3an1 ) GHQGUAQZDUBQZCDUCRQZBI
      EUDSQZGHUEUTVAVBUFVCBIUGRZUHOCAGUISZOUKZUJULUMZUNBGFUOSZUHOGPVEVFPUKRUMUM
      ZUNUPOVDABCDEFPGVHIVGVIJKVHTLMNVDTVGTVITUQURUS $.
  $}

  ${
    $d B x y $.  $d I x y $.  $d R x y $.  $d S x y $.  $d X x $.
    evlssca.q $e |- Q = ( ( I evalSub S ) ` R ) $.
    evlssca.w $e |- W = ( I mPoly U ) $.
    evlssca.u $e |- U = ( S |`s R ) $.
    evlssca.b $e |- B = ( Base ` S ) $.
    evlssca.a $e |- A = ( algSc ` W ) $.
    evlssca.i $e |- ( ph -> I e. V ) $.
    evlssca.s $e |- ( ph -> S e. CRing ) $.
    evlssca.r $e |- ( ph -> R e. ( SubRing ` S ) ) $.
    evlssca.x $e |- ( ph -> X e. R ) $.
    $( Polynomial evaluation maps scalars to constant functions.  (Contributed
       by Stefan O'Rear, 13-Mar-2015.) $)
    evlssca $p |- ( ph -> ( Q ` ( A ` X ) ) = ( ( B ^m I ) X. { X } ) ) $=
      ( vx vy ccom cfv cmap co cv csn cxp cmpt wceq cmvr cpws crh wcel cvv ccrg
      wa csubrg elex syl eqid evlsval2 syl3anc simprd simpld fveq1d wf subrgrng
      cbs crg mplasclf wss subrgss ressbas2 3syl feq2d mpbird fvco3 sneq xpeq2d
      syl2anc ovex snex xpex fvmpt 3eqtr3d ) AKDBUCZUDZKUAECHUEUFZUAUGZUHZUIZUJ
      ZUDZKBUDDUDZWJKUHZUIZAKWHWNAWHWNUKZDHGULUFZUCUAHUBWJWKUBUGUDUJUJZUKZADJFW
      JUMUFZUNUFUOZWSXBURZAHUPUOZFUQUOEFUSUDUOZXDXEURAHIUOXFQHIUTVARSUABCDEFXCG
      UBHWTJWNXALMWTVBNXCVBOPWNVBZXAVBVCVDVEVFVGAEJVJUDZBVHZKEUOZWIWPUKAXJGVJUD
      ZXIBVHABXIJGHXLIMXIVBXLVBPQAXGGVKUOSEFGNVIVAVLAEXLXIBAXGECVMEXLUKSECFOVNE
      CGFNOVOVPVQVRTEXIKDBVSWBAXKWOWRUKTUAKWMWREWNWKKUKWLWQWJWKKVTWAXHWJWQCHUEW
      CKWDWEWFVAWG $.
  $}

  ${
    $d B g x $.  $d I g x $.  $d R g x $.  $d S g x $.  $d X g x $.
    evlsvar.q $e |- Q = ( ( I evalSub S ) ` R ) $.
    evlsvar.v $e |- V = ( I mVar U ) $.
    evlsvar.u $e |- U = ( S |`s R ) $.
    evlsvar.b $e |- B = ( Base ` S ) $.
    evlsvar.i $e |- ( ph -> I e. W ) $.
    evlsvar.s $e |- ( ph -> S e. CRing ) $.
    evlsvar.r $e |- ( ph -> R e. ( SubRing ` S ) ) $.
    evlsvar.x $e |- ( ph -> X e. I ) $.
    $( Polynomial evaluation maps variables to projections.  (Contributed by
       Stefan O'Rear, 12-Mar-2015.) $)
    evlsvar $p |- ( ph -> ( Q ` ( V ` X ) ) =
          ( g e. ( B ^m I ) |-> ( g ` X ) ) ) $=
      ( cfv vx ccom cmap co cmpt cmpl cascl csn cxp wceq cpws crh wcel cvv ccrg
      cv wa csubrg elex syl eqid evlsval2 syl3anc simprd fveq1d wfn wf subrgrng
      cbs crg mvrf2 ffn fvco2 syl2anc fveq2 mpteq2dv ovex mptex fvmpt 3eqtr3d )
      AKCIUBZTZKUAHGBHUCUDZUAUPZGUPZTZUEZUEZTZKITCTZGWCKWETZUEZAKWAWHACHFUFUDZU
      GTZUBUADWCWDUHUIUEZUJZWAWHUJZACWMEWCUKUDZULUDUMZWPWQUQZAHUNUMZEUOUMDEURTU
      MZWSWTUQAHJUMXAPHJUSUTQRUAWNBCDEWRFGHIWMWOWHLWMVAZMNWRVAOWNVAWOVAWHVAZVBV
      CVDVDVEAIHVFZKHUMZWBWJUJAHWMVITZIVGXEAXGWMFHIJXCMXGVAPAXBFVJUMRDEFNVHUTVK
      HXGIVLUTSHCIKVMVNAXFWIWLUJSUAKWGWLHWHWDKUJGWCWFWKWDKWEVOVPXDGWCWKBHUCVQVR
      VSUTVT $.
  $}

  ${
    $d B i r $.  $d I i r $.  $d R i r $.
    evlval.q $e |- Q = ( I eval R ) $.
    evlval.b $e |- B = ( Base ` R ) $.
    $( Value of the simple/same ring evaluation map.  (Contributed by Stefan
       O'Rear, 19-Mar-2015.)  (Revised by Mario Carneiro, 12-Jun-2015.) $)
    evlval $p |- Q = ( ( I evalSub R ) ` B ) $=
      ( vi vr cevl co ces cfv cvv wcel wa wceq cv cbs syl6eqr c0 oveq12 fveq12d
      fveq2 adantl df-evl ovmpt2a wn mpt2ndm0 0fv reldmevls ovprc fveq1d eqtr4d
      fvex pm2.61i eqtri ) BDCIJZADCKJZLZEDMNCMNOZUQUSPGHDCMMHQZRLZGQZVAKJZLZUS
      IVCDPZVACPZOVBAVDURVCDVACKUAVGVBAPVFVGVBCRLAVACRUCFSUDUBGHUEZAURUNUFUTUGZ
      UQATLZUSVIUQTVJGHVEIDCMMVHUHAUISVIAURTDCKUJUKULUMUOUP $.

    evlrhm.w $e |- W = ( I mPoly R ) $.
    evlrhm.t $e |- T = ( R ^s ( B ^m I ) ) $.
    $( The simple evaluation map is a ring homomorphism.  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    evlrhm $p |- ( ( I e. V /\ R e. CRing ) -> Q e. ( W RingHom T ) ) $=
      ( wcel ccrg wa cress co cmpl crh adantl eqid cfv crg crngrng subrgid wceq
      csubrg syl evlval evlsrhm mpd3an3 ressid oveq2d syl6eqr oveq1d eleqtrd )
      EFLZCMLZNZBECAOPZQPZDRPZGDRPUPUQACUFUALZBVALURCUBLZVBUQVCUPCUCSACIUDUGABA
      CDUSEFUTABCEHIUHUTTUSTKIUIUJURUTGDRURUTECQPGURUSCEQUQUSCUEUPACMIUKSULJUMU
      NUO $.
  $}

  ${
    $d i r $.  $d x A $.  $d b r x y B $.  $d b r x Q $.  $d b r x R $.
    evl1fval.o $e |- O = ( eval1 ` R ) $.
    evl1fval.q $e |- Q = ( 1o eval R ) $.
    evl1fval.b $e |- B = ( Base ` R ) $.
    $( Value of the simple/same ring evalutation map.  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    evl1fval $p |- O = ( ( x e. ( B ^m ( B ^m 1o ) ) |-> ( x o.
        ( y e. B |-> ( 1o X. { y } ) ) ) ) o. Q ) $=
      ( vr vb cvv c1o cmap co cv cmpt ccom cevl c0 vi wcel csn cxp wceq ce1 cfv
      cbs csb fvex a1i wa fveq2 syl6eqr sylan9eqr oveq1d oveq12d mpteq1d coeq2d
      id mpteq12dv simpl oveq2d coeq12d csbied df-evl1 ovex mptex eqeltri fvmpt
      coex syl5eq wn fvprc co02 ces df-evl reldmmpt2 ovprc2 eqtr4d pm2.61i ) EL
      UBZFACCMNOZNOZAPZBCMBPUCUDZQZRZQZDRZUEWBFEUFUGZWJGJEKJPZUHUGZAKPZWNMNOZNO
      ZWEBWNWFQZRZQZMWLSOZRZUIWJLUFWLEUEZKWMXAWJLWMLUBXBWLUHUJUKXBWNWMUEZULZWSW
      IWTDXDAWPWRWDWHXDWNCWOWCNXCXBWNWMCXCUTXBWMEUHUGCWLEUHUMIUNUOZXDWNCMNXEUPU
      QXDWQWGWEXDBWNCWFXEURUSVAXDWTMESOZDXDWLEMSXBXCVBVCHUNVDVEABJKVFWIDAWDWHCW
      CNVGVHDXFLHMESVGVIVKVJVLWBVMZFWITRZWJXGFTXHXGFWKTGEUFVNVLWIVOUNXGDTWIXGDX
      FTHMESUAJLLWMUAPWLVPOUGSUAJVQVRVSVLUSVTWA $.

    evl1val.m $e |- M = ( 1o mPoly R ) $.
    evl1val.k $e |- K = ( Base ` M ) $.
    $( Value of the simple/same ring evalutation map.  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    evl1val $p |- ( ( R e. CRing /\ A e. K ) -> ( O ` A ) = ( ( Q ` A ) o.
        ( y e. B |-> ( 1o X. { y } ) ) ) ) $=
      ( vx wcel cfv c1o cmap co ccom ccrg csn cxp cmpt evl1fval fveq1i cpws cbs
      wa cv wceq crh con0 1on simpl eqid evlrhm sylancr rhmf syl fvco3 sylancom
      wf syl5eq ffvelrn crg cvv crngrng adantr ovex sylancl eleqtrrd coeq1 fvex
      pwsbas eqeltri mptex coex fvmpt eqtrd ) EUAOZBFOZUIZBHPZBDPZNCCQRSZRSZNUJ
      ZACQAUJUBUCZUDZTZUDZPZWEWJTZWCWDBWLDTZPZWMBHWONACDEHIJKUEUFWAWBFEWFUGSZUH
      PZDVCZWPWMUKWCDGWQULSOZWSWCQUMOWAWTUNWAWBUOCDEWQQUMGJKLWQUPZUQURFWRGWQDMW
      RUPUSUTZFWRBWLDVAVBVDWCWEWGOWMWNUKWCWEWRWGWAWBWSWEWROXBFWRBDVEVBWCEVFOZWF
      VGOWGWRUKWAXCWBEVHVICQRVJCEWFVFVGWQXAKVOVKVLNWEWKWNWGWLWHWEWJVMWLUPWEWJBD
      VNACWICEUHPVGKEUHVNVPVQVRVSUTVT $.
  $}

  ${
    $d x y B $.  $d x y P $.  $d x y R $.  $d x T $.
    evl1rhm.q $e |- O = ( eval1 ` R ) $.
    evl1rhm.w $e |- P = ( Poly1 ` R ) $.
    evl1rhm.t $e |- T = ( R ^s B ) $.
    evl1rhm.b $e |- B = ( Base ` R ) $.
    $( Polynomial evaluation is a homomorphism (into the product ring).
       (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    evl1rhm $p |- ( R e. CRing -> O e. ( P RingHom T ) ) $=
      ( vx vy wcel c1o co crh eqid cbs cfv cvv a1i ccrg cmap csn cmpt ccom cevl
      cv evl1fval cpws wceq ovex pwsbas mpan2 mpteq1d crngrng fvex eqeltri wf1o
      cxp wf c0 df1o2 0ex mapsnf1o3 f1of mp1i pwsco1rhm eqeltrd cmpl 1on evlrhm
      con0 mpan eqidd ply1bas cplusg ply1plusg proplem3 cmulr ply1mulr rhmpropd
      cps1 wa eleqtrrd rhmco syl2anc syl5eqel ) CUALZEJAAMUBNZUBNZJUGZKAMKUGZUC
      USUDZUEZUDZMCUFNZUEZBDONZJKAWPCEFWPPZIUHWHWOCWIUINZDONZLWPBWTONZLWQWRLWHW
      OJWTQRZWNUDXAWHJWJXCWNWHWISLZWJXCUJAMUBUKZACWIUASWTWTPZIULUMUNWHAWIXCCJWM
      SSDWTHXFXCPCUOASLWHACQRSICQUPUQZTXDWHXETAWIWMURAWIWMUTWHKAMWMVAVBXGVCWMPV
      DAWIWMVEVFVGVHWHWPMCVINZWTONZXBMVLLWHWPXILVJAWPCWTMVLXHWSIXHPZXFVKVMWHJKB
      QRZXCBWTXHWTWHXKVNWHXCVNZXKXHQRUJWHBCCWBRZXKGXMPXKPVOTXLWHWKXKLWLXKLWCZJK
      BVPRZXHVPRZXOXPUJWHXOCXHBGXJXOPVQTVRWHWKXCLWLXCLWCWCZWKWLWTVPRNVNWHXNJKBV
      SRZXHVSRZXRXSUJWHCXHXRBGXJXRPVTTVRXQWKWLWTVSRNVNWAWDBWTDWOWPWEWFWG $.
  $}

  ${
    $d x y B $.  $d y R $.  $d x y X $.
    evl1sca.o $e |- O = ( eval1 ` R ) $.
    evl1sca.p $e |- P = ( Poly1 ` R ) $.
    evl1sca.b $e |- B = ( Base ` R ) $.
    evl1sca.a $e |- A = ( algSc ` P ) $.
    $( Polynomial evaluation maps scalars to constant functions.  (Contributed
       by Mario Carneiro, 12-Jun-2015.) $)
    evl1sca $p |- ( ( R e. CRing /\ X e. B ) ->
        ( O ` ( A ` X ) ) = ( B X. { X } ) ) $=
      ( vy vx wcel cfv c1o co cxp cmpt wceq eqid ccrg wa cevl csn ccom cmap cbs
      cv crg crngrng adantr ply1sclf ffvelrn sylancom cmpl cps1 ply1bas evl1val
      syl syldan cress cascl ressid oveq2d fveq2d ply1ascl syl6reqr fveq1d con0
      wf evlval 1on a1i simpl csubrg subrgid simpr evlssca eqtrd coeq1d wral c0
      wf1o df1o2 cvv fvex eqeltri 0ex mapsnf1o3 f1of mp1i fmpt sylibr fconstmpt
      eqidd fmptcof syl6eqr 3eqtrd ) DUAMZFBMZUBZFANZENZXBODUCPZNZKBOKUHUDQZRZU
      EZBOUFPZFUDZQZXGUEZBXJQZWSWTXBCUGNZMZXCXHSWSWTBXNAVJZXOXADUIMZXPWSXQWTDUJ
      UKZAXNCDBHJIXNTZULUSBXNFAUMUNKXBBXDDXNODUOPZEGXDTZIXTTCDDUPNZXNHYBTXSUQUR
      UTXAXEXKXGXAXEFODBVAPZUOPZVBNZNZXDNXKXAXBYFXDXAFAYEXAYEXTVBNAXAYDXTVBXAYC
      DOUOWSYCDSWTBDUAIVCUKVDVEACDHJVFVGVHVEXAYEBXDBDYCOVIYDFBXDDOYAIVKYDTYCTIY
      ETOVIMXAVLVMWSWTVNXAXQBDVONMXRBDIVPUSWSWTVQVRVSVTXAXLKBFRXMXAKLBXIXFFFXGX
      KXABXIXGVJZXFXIMKBWABXIXGWCYGXAKBOXGWBWDBDUGNWEIDUGWFWGWHXGTZWIBXIXGWJWKK
      BXIXFXGYHWLWMXAXGWOXKLXIFRSXALXIFWNVMLUHXFSFWOWPKBFWNWQWR $.

    evl1scad.u $e |- U = ( Base ` P ) $.
    evl1scad.1 $e |- ( ph -> R e. CRing ) $.
    evl1scad.2 $e |- ( ph -> X e. B ) $.
    evl1scad.3 $e |- ( ph -> Y e. B ) $.
    $( Polynomial evaluation builder for scalars.  (Contributed by Mario
       Carneiro, 4-Jul-2015.) $)
    evl1scad $p |- ( ph ->
        ( ( A ` X ) e. U /\ ( ( O ` ( A ` X ) ) ` Y ) = X ) ) $=
      ( cfv wcel wceq ccrg crg wf crngrng ply1sclf ffvelrnd csn evl1sca syl2anc
      3syl cxp fveq1d fvconst2g eqtrd jca ) AHBRZFSIUPGRZRZHTACFHBAEUASZEUBSCFB
      UCOEUDBFDECKMLNUEUJPUFAURICHUGUKZRZHAIUQUTAUSHCSZUQUTTOPBCDEGHJKLMUHUIULA
      VBICSVAHTPQCHICUMUIUNUO $.
  $}

  ${
    $d y z B $.  $d z R $.
    evl1var.q $e |- O = ( eval1 ` R ) $.
    evl1var.v $e |- X = ( var1 ` R ) $.
    evl1var.b $e |- B = ( Base ` R ) $.
    $( Polynomial evaluation maps the variable to the identity function.
       (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    evl1var $p |- ( R e. CRing -> ( O ` X ) = ( _I |` B ) ) $=
      ( vy vz ccrg wcel cfv c1o co cv ccom c0 cbs eqid cmvr cevl cmpt cmap ccnv
      csn cxp cid cres cpl1 wceq crg crngrng vr1cl syl cmpl ply1bas mpdan df1o2
      cps1 evl1val cvv fvex eqeltri mapsncnv coeq2i ressid oveq2d fveq1d vr1val
      0ex cress syl6eqr fveq2d con0 evlval 1on a1i csubrg subrgid 0lt1o evlsvar
      id eqtr3d coeq1d syl5eqr wf1o mapsnf1o2 f1ococnv2 mp1i 3eqtrd ) BJKZDCLZD
      MBUANZLZHAMHOUEUFUBZPZIAMUCNZQIOLUBZWRUDZPZUGAUHZWKDBUILZRLZKZWLWPUJWKBUK
      KZXDBULZXCXBBDFXBSZXCSZUMUNHDAWMBXCMBUONZCEWMSZGXISXBBBUSLZXCXGXKSXHUPUTU
      QWKWPWNWSPWTWSWOWNIHAMWRQURABRLVAGBRVBVCZVJWRSZVDVEWKWNWRWSWKQMBAVKNZTNZL
      ZWMLWNWRWKXPDWMWKXPQMBTNZLDWKQXOXQWKXNBMTABJGVFVGVHBDFVIVLVMWKAWMABXNIMXO
      VNQAWMBMXJGVOXOSXNSGMVNKWKVPVQWKWBWKXEABVRLKXFABGVSUNQMKWKVTVQWAWCWDWEWQA
      WRWFWTXAUJWKIAMWRQURXLVJXMWGWQAWRWHWIWJ $.

    evl1vard.p $e |- P = ( Poly1 ` R ) $.
    evl1vard.u $e |- U = ( Base ` P ) $.
    evl1vard.1 $e |- ( ph -> R e. CRing ) $.
    evl1vard.2 $e |- ( ph -> Y e. B ) $.
    $( Polynomial evaluation builder for the variable.  (Contributed by Mario
       Carneiro, 4-Jul-2015.) $)
    evl1vard $p |- ( ph -> ( X e. U /\ ( ( O ` X ) ` Y ) = Y ) ) $=
      ( wcel cfv wceq ccrg syl crg crngrng vr1cl 3syl cid evl1var fveq1d fvresi
      cres eqtrd jca ) AGEPZHGFQZQZHRADSPZDUAPULNDUBECDGJLMUCUDAUNHUEBUIZQZHAHU
      MUPAUOUMUPRNBDFGIJKUFTUGAHBPUQHROBHUHTUJUK $.
  $}

  ${
    $d x y z B $.  $d x y ph $.  $d x y z R $.
    evl1addd.q $e |- O = ( eval1 ` R ) $.
    evl1addd.p $e |- P = ( Poly1 ` R ) $.
    evl1addd.b $e |- B = ( Base ` R ) $.
    evl1addd.u $e |- U = ( Base ` P ) $.
    evl1addd.1 $e |- ( ph -> R e. CRing ) $.
    evl1addd.2 $e |- ( ph -> Y e. B ) $.
    evl1addd.3 $e |- ( ph -> ( M e. U /\ ( ( O ` M ) ` Y ) = V ) ) $.

    ${
      evl1addd.4 $e |- ( ph -> ( N e. U /\ ( ( O ` N ) ` Y ) = W ) ) $.
      ${
        evl1addd.g $e |- .+b = ( +g ` P ) $.
        evl1addd.a $e |- .+ = ( +g ` R ) $.
        $( Polynomial evaluation builder for addition of polynomials.
           (Contributed by Mario Carneiro, 4-Jul-2015.) $)
        evl1addd $p |- ( ph ->
          ( ( M .+b N ) e. U /\ ( ( O ` ( M .+b N ) ) ` Y ) = ( V .+ W ) ) ) $=
          ( co wcel cfv wceq cgrp cpws cghm crh ccrg evl1rhm syl rhmghm ghmgrp1
          eqid simpld grpcl syl3anc cof cplusg ghmlin cbs cvv fvex eqeltri rhmf
          a1i wf ffvelrnd pwsplusgval eqtrd fveq1d wfn pwselbas fnfvof syl22anc
          ffn simprd oveq12d 3eqtrd jca ) AHIEUDZGUEZMWDJUFZUFZKLDUDZUGACUHUEZH
          GUEZIGUEZWEAJCFBUIUDZUJUDUEZWIAJCWLUKUDUEZWMAFULUEWNRBCFWLJNOWLUQZPUM
          UNZCWLJUOUNZCWLJUPUNAWJMHJUFZUFZKUGZTURZAWKMIJUFZUFZLUGZUAURZGECHIQUB
          USUTAWGMWRXBDVAUDZUFZWSXCDUDZWHAMWFXFAWFWRXBWLVBUFZUDZXFAWMWJWKWFXJUG
          WQXAXEEXICWLHJIGQUBXIUQZVCUTAWLVDUFZDXIFWRXBBULVEWLWOXLUQZRBVEUEZABFV
          DUFVEPFVDVFVGVIZAGXLHJAWNGXLJVJWPGXLCWLJQXMVHUNZXAVKZAGXLIJXPXEVKZUCX
          KVLVMVNAWRBVOZXBBVOZXNMBUEXGXHUGABBWRVJXSABFBXLULWRWLVEWOPXMRXOXQVPBB
          WRVSUNABBXBVJXTABFBXLULXBWLVEWOPXMRXOXRVPBBXBVSUNXOSBDWRXBVEMVQVRAWSK
          XCLDAWJWTTVTAWKXDUAVTWAWBWC $.
      $}

      ${
        evl1subd.s $e |- .- = ( -g ` P ) $.
        evl1subd.d $e |- D = ( -g ` R ) $.
        $( Polynomial evaluation builder for subtraction of polynomials.
           (Contributed by Mario Carneiro, 4-Jul-2015.) $)
        evl1subd $p |- ( ph ->
          ( ( M .- N ) e. U /\ ( ( O ` ( M .- N ) ) ` Y ) = ( V D W ) ) ) $=
          ( co wcel cfv wceq cgrp cpws cghm crh ccrg evl1rhm syl rhmghm ghmgrp1
          eqid simpld grpsubcl syl3anc cof csg ghmsub cvv cbs crngrng 3syl fvex
          crg rnggrp eqeltri a1i rhmf ffvelrnd pwssub syl22anc eqtrd fveq1d wfn
          wf pwselbas ffn fnfvof simprd oveq12d 3eqtrd jca ) AGIHUDZFUEZMWHJUFZ
          UFZKLCUDZUGADUHUEZGFUEZIFUEZWIAJDEBUIUDZUJUDUEZWMAJDWPUKUDUEZWQAEULUE
          ZWRRBDEWPJNOWPUQZPUMUNZDWPJUOUNZDWPJUPUNAWNMGJUFZUFZKUGZTURZAWOMIJUFZ
          UFZLUGZUAURZFDHGIQUBUSUTAWKMXCXGCVAUDZUFZXDXHCUDZWLAMWJXKAWJXCXGWPVBU
          FZUDZXKAWQWNWOWJXOUGXBXFXJFDWPGJHXNIQUBXNUQZVCUTAEUHUEZBVDUEZXCWPVEUF
          ZUEXGXSUEXOXKUGAWSEVIUEXQREVFEVJVGXRABEVEUFVDPEVEVHVKVLZAFXSGJAWRFXSJ
          VTXAFXSDWPJQXSUQZVMUNZXFVNZAFXSIJYBXJVNZXSEXCXGBCXNVDWPWTYAUCXPVOVPVQ
          VRAXCBVSZXGBVSZXRMBUEXLXMUGABBXCVTYEABEBXSULXCWPVDWTPYARXTYCWABBXCWBU
          NABBXGVTYFABEBXSULXGWPVDWTPYARXTYDWABBXGWBUNXTSBCXCXGVDMWCVPAXDKXHLCA
          WNXETWDAWOXIUAWDWEWFWG $.
      $}

      ${
        evl1muld.t $e |- .xb = ( .r ` P ) $.
        evl1muld.s $e |- .x. = ( .r ` R ) $.
        $( Polynomial evaluation builder for multiplication of polynomials.
           (Contributed by Mario Carneiro, 4-Jul-2015.) $)
        evl1muld $p |- ( ph ->
         ( ( M .xb N ) e. U /\ ( ( O ` ( M .xb N ) ) ` Y ) = ( V .x. W ) ) ) $=
          ( co wcel cfv wceq crg cpws crh ccrg evl1rhm syl rhmrcl1 simpld rngcl
          eqid syl3anc cof cmulr rhmmul cbs cvv fvex eqeltri wf rhmf pwsmulrval
          a1i ffvelrnd eqtrd fveq1d wfn pwselbas fnfvof syl22anc simprd oveq12d
          ffn 3eqtrd jca ) AHIEUDZGUEZMWBJUFZUFZKLFUDZUGACUHUEZHGUEZIGUEZWCAJCD
          BUIUDZUJUDUEZWGADUKUEWKRBCDWJJNOWJUQZPULUMZCWJJUNUMAWHMHJUFZUFZKUGZTU
          OZAWIMIJUFZUFZLUGZUAUOZGCEHIQUBUPURAWEMWNWRFUSUDZUFZWOWSFUDZWFAMWDXBA
          WDWNWRWJUTUFZUDZXBAWKWHWIWDXFUGWMWQXAHICWJEXEJGQUBXEUQZVAURAWJVBUFZDX
          EFWNWRBUKVCWJWLXHUQZRBVCUEZABDVBUFVCPDVBVDVEVIZAGXHHJAWKGXHJVFWMGXHCW
          JJQXIVGUMZWQVJZAGXHIJXLXAVJZUCXGVHVKVLAWNBVMZWRBVMZXJMBUEXCXDUGABBWNV
          FXOABDBXHUKWNWJVCWLPXIRXKXMVNBBWNVSUMABBWRVFXPABDBXHUKWRWJVCWLPXIRXKX
          NVNBBWRVSUMXKSBFWNWRVCMVOVPAWOKWSLFAWHWPTVQAWIWTUAVQVRVTWA $.
      $}
    $}

    ${
      evl1vsd.4 $e |- ( ph -> N e. B ) $.
      evl1vsd.s $e |- .xb = ( .s ` P ) $.
      evl1vsd.t $e |- .x. = ( .r ` R ) $.
      $( Polynomial evaluation builder for scalar multiplication of
         polynomials.  (Contributed by Mario Carneiro, 4-Jul-2015.) $)
      evl1vsd $p |- ( ph ->
        ( ( N .xb M ) e. U /\ ( ( O ` ( N .xb M ) ) ` Y ) = ( N .x. V ) ) ) $=
        ( cascl cfv cmulr co wcel wceq wa eqid evl1scad evl1muld casa csca ccrg
        cbs ply1assa ply1sca fveq2d syl5eq eleqtrd simpld syl3anc eleq1d fveq1d
        syl asclmul1 eqeq1d anbi12d mpbid ) AICUCUDZUDZHCUEUDZUFZGUGZLVNJUDZUDZ
        IKFUFZUHZUIIHEUFZGUGZLVTJUDZUDZVRUHZUIABCDVMFGVLHJIKLMNOPQRAVKBCDGJILMN
        OVKUJZPQTRUKSVMUJZUBULAVOWAVSWDAVNVTGACUMUGZICUNUDZUPUDZUGHGUGZVNVTUHAD
        UOUGZWGQCDNUQVFAIBWITABDUPUDWIOADWHUPAWKDWHUHQCDUONURVFUSUTVAAWJLHJUDUD
        KUHSVBVKIEVMWHWIGCHWEWHUJWIUJPWFUAVGVCZVDAVQWCVRALVPWBAVNVTJWLUSVEVHVIV
        J $.
    $}

    ${
      evl1expd.f $e |- .xb = ( .g ` ( mulGrp ` P ) ) $.
      evl1expd.e $e |- .^ = ( .g ` ( mulGrp ` R ) ) $.
      evl1expd.4 $e |- ( ph -> N e. NN0 ) $.
      $( Polynomial evaluation builder for an exponential.  (Contributed by
         Mario Carneiro, 12-Jun-2015.) $)
      evl1expd $p |- ( ph ->
        ( ( N .xb M ) e. U /\ ( ( O ` ( N .xb M ) ) ` Y ) = ( N .^ V ) ) ) $=
        ( vx vy wcel cfv wceq cmgp cmnd cn0 crg ccrg crngrng syl ply1rng rngmgp
        eqid 3syl simpld mgpbas mulgnn0cl syl3anc cpws cmg cmhm evl1rhm mhmmulg
        crh rhmmhm cbs cvv eqidd cplusg fvex eqeltri pwsmgp sylancl wss ssv a1i
        co wa ovex simprd proplem3 mulgpropd oveqd eqtrd fveq1d ffvelrnd syl5eq
        cv wf rhmf eleqtrd pwsmulg syl23anc oveq2d jca ) AIHEWAZFUEZLWTJUFZUFZI
        KGWAZUGACUHUFZUIUEZIUJUEZHFUEZXAADUKUEZCUKUEXFADULUEZXIQDUMUNZCDNUOCXEX
        EUQZUPURUBAXHLHJUFZUFZKUGZSUSZFEXEIHFCXEXLPUTZTVAVBAXCLIXMDUHUFZBVCWAZV
        DUFZWAZUFZXDALXBYAAXBIXMDBVCWAZUHUFZVDUFZWAZYAAJXEYDVEWAUEZXGXHXBYFUGAJ
        CYCVHWAUEZYGAXJYHQBCDYCJMNYCUQZOVFUNZCYCJXEYDXLYDUQZVIUNUBXPFEYEJXEYDIH
        XQTYEUQZVGVBAYEXTIXMAUCUDYDVJUFZYEXTYDXSVKYLXTUQZAYMVLAYMXSVJUFZUGZYDVM
        UFZXSVMUFZUGZAXJBVKUEZYPYSWBQBDVJUFVKODVJVNVOZYMYOYQYRDBXRYDULVKYCXSYIX
        RUQZXSUQZYKYMUQYOUQZYQUQYRUQVPVQZUSZYMVKVRAYMVSVTUCWLZUDWLZYQWAVKUEAUUG
        VKUEUUHVKUEWBZWBUUGUUHYQWCVTAUUIUCUDYQYRAYPYSUUEWDWEWFWGWHWIAYBIXNGWAZX
        DAXRUIUEZYTXGXMYOUELBUEYBUUJUGAXIUUKXKDXRUUBUPUNYTAUUAVTUBAXMYCVJUFZYOA
        FUULHJAYHFUULJWMYJFUULCYCJPUULUQZWNUNXPWJAUULYMYOUULYCYDYKUUMUTUUFWKWOR
        LYOXRXTGBIVKXMXSUUCUUDYNUAWPWQAXNKIGAXHXOSWDWRWHWHWS $.
    $}
  $}

  ${
    mpfconst.b $e |- B = ( Base ` S ) $.
    mpfconst.q $e |- Q = ran ( ( I evalSub S ) ` R ) $.
    mpfconst.i $e |- ( ph -> I e. V ) $.
    mpfconst.s $e |- ( ph -> S e. CRing ) $.
    mpfconst.r $e |- ( ph -> R e. ( SubRing ` S ) ) $.
    ${
      mpfconst.x $e |- ( ph -> X e. R ) $.
      $( Constants are multivariate polynomial functions.  (Contributed by
         Mario Carneiro, 19-Mar-2015.) $)
      mpfconst $p |- ( ph -> ( ( B ^m I ) X. { X } ) e. Q ) $=
        ( co cfv cress eqid cbs wcel cmap csn cxp ces crn cmpl evlssca wfn cpws
        cascl crh wf ccrg csubrg evlsrhm syl3anc rhmf ffn 3syl crg subrgrng syl
        csca wa mplrng mpllmod asclf syl2anc wss wceq subrgss ressbas2 cvv ovex
        a1i mplsca fveq2d eqtrd eleqtrd ffvelrnd fnfvelrn eqeltrrd syl6eleqr )
        ABFUAOZHUBUCZDFEUDOPZUEZCAHFEDQOZUFOZUJPZPZWFPZWEWGAWJBWFDEWHFGWIHWFRZW
        IRZWHRZIWJRZKLMNUGAWFWISPZUHZWKWQTWLWGTAWFWIEWDUIOZUKOTZWQWSSPZWFULWRAF
        GTZEUMTDEUNPTZWTKLMBWFDEWSWHFGWIWMWNWOWSRIUOUPWQXAWIWSWFWQRZXARUQWQXAWF
        URUSAWIVCPZSPZWQHWJAXBWHUTTZXFWQWJULKAXCXGMDEWHWOVAVBXBXGVDWJWQXEXFWIWP
        XERWIWHFGWNVEWIWHFGWNVFXFRXDVGVHAHDXFNADWHSPZXFAXCDBVIDXHVJMDBEIVKDBWHE
        WOIVLUSAWHXESAWIWHFGVMWNKWHVMTAEDQVNVOVPVQVRVSVTWQWKWFWAVHWBJWC $.
    $}

    $d B f $.  $d I f $.  $d J f $.  $d R f $.  $d S f $.
    mpfproj.j $e |- ( ph -> J e. I ) $.
    $( Projections are multivariate polynomial functions.  (Contributed by
       Mario Carneiro, 20-Mar-2015.) $)
    mpfproj $p |- ( ph -> ( f e. ( B ^m I ) |-> ( f ` J ) ) e. Q ) $=
      ( co cfv eqid cbs wcel cress cmvr ces cmap cmpt evlsvar crn cmpl wfn cpws
      cv crh wf ccrg csubrg evlsrhm syl3anc rhmf ffn 3syl crg subrgrng fnfvelrn
      syl mvrcl syl2anc syl6eleqr eqeltrrd ) AHGEDUAPZUBPZQZDGEUCPQZQZFBGUDPZHF
      UKQUECABVLDEVIFGVJIHVLRZVJRZVIRZJLMNOUFAVMVLUGZCAVLGVIUHPZSQZUIZVKVTTVMVR
      TAVLVSEVNUJPZULPTZVTWBSQZVLUMWAAGITEUNTDEUOQTZWCLMNBVLDEWBVIGIVSVOVSRZVQW
      BRJUPUQVTWDVSWBVLVTRZWDRURVTWDVLUSUTAVTVSVIGVJIHWFVPWGLAWEVIVATNDEVIVQVBV
      DOVEVTVKVLVCVFKVGVH $.
  $}

  ${
    mpfaddcl.q $e |- Q = ran ( ( I evalSub S ) ` R ) $.
    $( Polynomial functions are a subring.  (Contributed by Mario Carneiro,
       19-Mar-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    mpfsubrg $p |- ( ( I e. _V /\ S e. CRing /\ R e. ( SubRing ` S ) ) ->
        Q e. ( SubRing ` ( S ^s ( ( Base ` S ) ^m I ) ) ) ) $=
      ( cvv wcel ccrg csubrg cfv w3a ces co cress cmpl cbs cima cmap eqid crg
      cpws crn crh wf wfn wceq evlsrhm rhmf fnima 4syl syl6reqr subrgrng mplrng
      ffn sylan2 3adant2 subrgid syl rhmima syl2anc eqeltrd ) DFGZCHGZBCIJGZKZA
      BDCLMJZDCBNMZOMZPJZQZCCPJZDRMUAMZIJZVEVJVFUBZAVEVFVHVLUCMGZVIVLPJZVFUDVFV
      IUEVJVNUFVKVFBCVLVGDFVHVFSVHSZVGSZVLSVKSUGZVIVPVHVLVFVISZVPSUHVIVPVFUNVIV
      FUIUJEUKVEVOVIVHIJGZVJVMGVSVEVHTGZWAVBVDWBVCVDVBVGTGWBBCVGVRULVHVGDFVQUMU
      OUPVIVHVTUQURVFVHVLVIUSUTVA $.

    ${
      mpff.b $e |- B = ( Base ` S ) $.
      $( Polynomial functions are functions.  (Contributed by Mario Carneiro,
         19-Mar-2015.) $)
      mpff $p |- ( F e. Q -> F : ( B ^m I ) --> B ) $=
        ( wcel cmap co cbs cfv cpws ccrg cvv eqcomi oveq1i oveq2i csubrg mpfrcl
        eqid simp2d ovex a1i w3a wss mpfsubrg subrgss 3syl id sseldd pwselbas )
        EBIZADAFJKZDDLMZFJKZNKZLMZOEURPUQUODNUPAFJAUPHQRSHUSUBZUNFPIZDOIZCDTMIZ
        BCDFEGUAZUCUOPIUNAFJUDUEUNBUSEUNVAVBVCUFBURTMIBUSUGVDBCDFGUHBUSURUTUIUJ
        UNUKULUM $.
    $}

    ${
      mpfaddcl.p $e |- .+ = ( +g ` S ) $.
      $( The sum of multivariate polynomial functions.  (Contributed by Mario
         Carneiro, 19-Mar-2015.) $)
      mpfaddcl $p |- ( ( F e. Q /\ G e. Q ) -> ( F oF .+ G ) e. Q ) $=
        ( wcel cbs cfv cmap co ccrg cvv eqid csubrg syl sseldd wa cplusg mpfrcl
        cpws cof w3a adantr simp2d ovex a1i wss subrgss simpl simpr pwsplusgval
        mpfsubrg subrgacl 3expib mpcom eqeltrrd ) EBJZFBJZUAZEFDDKLZGMNZUDNZUBL
        ZNZEFAUENBVCVFKLZAVGDEFVEOPVFVFQVIQZVCGPJZDOJZCDRLJZVAVKVLVMUFZVBBCDGEH
        UCUGZUHVEPJVCVDGMUIUJVCBVIEVCBVFRLJZBVIUKVCVNVPVOBCDGHUPSZBVIVFVJULSZVA
        VBUMTVCBVIFVRVAVBUNTIVGQZUOVPVCVHBJZVQVPVAVBVTBVGVFEFVSUQURUSUT $.
    $}

    ${
      mpfmulcl.t $e |- .x. = ( .r ` S ) $.
      $( The product of multivariate polynomial functions.  (Contributed by
         Mario Carneiro, 19-Mar-2015.) $)
      mpfmulcl $p |- ( ( F e. Q /\ G e. Q ) -> ( F oF .x. G ) e. Q ) $=
        ( wcel cbs cfv cmap co ccrg cvv eqid csubrg syl sseldd wa cmulr cof w3a
        cpws mpfrcl adantr ovex a1i wss mpfsubrg subrgss simpl simpr pwsmulrval
        simp2d subrgmcl 3expib mpcom eqeltrrd ) EAJZFAJZUAZEFCCKLZGMNZUENZUBLZN
        ZEFDUCNAVCVFKLZCVGDEFVEOPVFVFQVIQZVCGPJZCOJZBCRLJZVAVKVLVMUDZVBABCGEHUF
        UGZUPVEPJVCVDGMUHUIVCAVIEVCAVFRLJZAVIUJVCVNVPVOABCGHUKSZAVIVFVJULSZVAVB
        UMTVCAVIFVRVAVBUNTIVGQZUOVPVCVHAJZVQVPVAVBVTAVFVGEFVSUQURUSUT $.
    $}
  $}

  ${
    $d ch i x $.  $d et x $.  $d ph f g i j $.  $d ph y $.  $d ps f g i j $.
    $d ps y $.  $d rh x $.  $d si x $.  $d ta x $.  $d th x $.  $d ze x $.
    $d A x y $.  $d B f g i x $.  $d I f g i j x $.  $d I y $.  $d .+ f g x $.
    $d Q f g $.  $d R f g i j $.  $d R y $.  $d S f g i j $.  $d S y $.
    $d .x. f g x $.  $d i y $.  $d j y $.
    mpfind.cb $e |- B = ( Base ` S ) $.
    mpfind.cp $e |- .+ = ( +g ` S ) $.
    mpfind.ct $e |- .x. = ( .r ` S ) $.
    mpfind.cq $e |- Q = ran ( ( I evalSub S ) ` R ) $.
    mpfind.ad $e |- ( ( ph /\ ( ( f e. Q /\ ta ) /\ ( g e. Q /\ et ) ) ) ->
        ze ) $.
    mpfind.mu $e |- ( ( ph /\ ( ( f e. Q /\ ta ) /\ ( g e. Q /\ et ) ) ) ->
        si ) $.
    mpfind.wa $e |- ( x = ( ( B ^m I ) X. { f } ) -> ( ps <-> ch ) ) $.
    mpfind.wb $e |- ( x = ( g e. ( B ^m I ) |-> ( g ` f ) ) ->
        ( ps <-> th ) ) $.
    mpfind.wc $e |- ( x = f -> ( ps <-> ta ) ) $.
    mpfind.wd $e |- ( x = g -> ( ps <-> et ) ) $.
    mpfind.we $e |- ( x = ( f oF .+ g ) -> ( ps <-> ze ) ) $.
    mpfind.wf $e |- ( x = ( f oF .x. g ) -> ( ps <-> si ) ) $.
    mpfind.wg $e |- ( x = A -> ( ps <-> rh ) ) $.
    mpfind.co $e |- ( ( ph /\ f e. R ) -> ch ) $.
    mpfind.pr $e |- ( ( ph /\ f e. I ) -> th ) $.
    mpfind.a $e |- ( ph -> A e. Q ) $.
    $( Prove a property of polynomials by "structural" induction, under a
       simplified model of structure which loses the sum of products
       structure.  (Contributed by Mario Carneiro, 19-Mar-2015.) $)
    mpfind $p |- ( ph -> rh ) $=
      ( vy vi vj cab wcel cv ces co cfv wceq cress cmpl cbs crn syl6eleq wfn wb
      wrex cmap cpws wf crh cvv ccrg csubrg w3a mpfrcl syl eqid evlsrhm fvelrnb
      rhmf ffn mpbid wfun ccnv cima ffun adantr cascl cplusg cmulr cmvr syl2anc
      wa crg elpreima simpld syl3anc cof ovex ffvelrnd eqtrd fnfvelrn syl6eleqr
      fvimacnvi jca wi fvex eleq1 vex elab syl5bbr anbi12d oveq12 eleq1d vtocl2
      imbi12d syl12anc eqeltrd mpbir2and adantlr cmgp mgpplusg eleq2d ralrimiva
      csn cxp wral cbvralv sylib r19.21bi simpr cmpt simp1d simp2d crngrng cghm
      simp3d subrgcrng mplrng simprl simprr rngacl rhmghm a1i pwsplusgval simpl
      ghmlin bi2anan9 anbi2d rngcl cmhm rhmmhm mgpbas mhmlin pwsmulrval mplassa
      csca casa asclrhm mplsca fveq2d wss subrgss ressbas2 biimpar evlssca snex
      biimpa xpex sneq xpeq2d syldan mvrcl evlsvar mptex sylibr mpteq2dv mplind
      fveq2 syl5ibcom rexlimdva mpd elabg ) AKBJUTZVAZIAUQVBZOTPVCVDVEZVEZKVFZU
      QTPOVGVDZVHVDZVIVEZVNZUWMAKUWOVJZVAZUXAAKNUXBUPUDVKAUWOUWTVLZUXCUXAVMAUWT
      PLTVOVDZVPVDZVIVEZUWOVQZUXDAUWOUWSUXFVRVDVAZUXHATVSVAZPVTVAZOPWAVEVAZWBZU
      XIAKNVAZUXMUPNOPTKUDWCWDZLUWOOPUXFUWRTVSUWSUWOWEZUWSWEZUWRWEZUXFWEZUAWFWD
      ZUWTUXGUWSUXFUWOUWTWEZUXGWEZWHWDZUWTUXGUWOWIWDZUQUWTKUWOWGWDWJAUWQUWMUQUW
      TAUWNUWTVAZXAZUWPUWLVAZUWQUWMUYFUWOWKZUWNUWOWLUWLWMZVAUYGAUYHUYEAUXHUYHUY
      CUWTUXGUWOWNWDZWOUYFURUSUWTUWSWPVEZUWSWQVEZUWRUWSWRVEZUYITUWRVIVEZTUWRWSV
      DZUWNUWSUYNWEUYOWEZUXQUYLWEZUYMWEZUYKWEZUYAAURVBZUYIVAZUSVBZUYIVAZXAZUYTV
      UBUYLVDZUYIVAZUYEAVUDXAZVUFVUEUWTVAZVUEUWOVEZUWLVAZVUGUWSXBVAZUYTUWTVAZVU
      BUWTVAZVUHAVUKVUDAUXJUWRXBVAZVUKAUXJUXKUXLUXOUUAZAUWRVTVAZVUNAUXKUXLVUPAU
      XJUXKUXLUXOUUBZAUXJUXKUXLUXOUUEZOPUWRUXRUUFWTZUWRUUCWDZUWSUWRTVSUXQUUGWTW
      OZVUGVULUYTUWOVEZUWLVAZVUGVUAVULVVCXAZAVUAVUCUUHZAVUAVVDVMZVUDAUXDVVFUYDU
      WTUYTUWLUWOXCWDWOWJXDZVUGVUMVUBUWOVEZUWLVAZVUGVUCVUMVVIXAZAVUAVUCUUIZAVUC
      VVJVMZVUDAUXDVVLUYDUWTVUBUWLUWOXCWDWOWJXDZUWTUYLUWSUYTVUBUYAUYQUUJXEVUGVU
      IVVBVVHMXFZVDZUWLVUGVUIVVBVVHUXFWQVEZVDZVVOVUGUWOUWSUXFUUDVDVAZVULVUMVUIV
      VQVFAVVRVUDAUXIVVRUXTUWSUXFUWOUUKWDWOVVGVVMUYLVVPUWSUXFUYTUWOVUBUWTUYAUYQ
      VVPWEZUUOXEVUGUXGMVVPPVVBVVHUXEVTVSUXFUXSUYBAUXKVUDVUQWOZUXEVSVAVUGLTVOXG
      ZUULZVUGUWTUXGUYTUWOAUXHVUDUYCWOZVVGXHZVUGUWTUXGVUBUWOVWCVVMXHZUBVVSUUMXI
      VUGAVVBNVAZVVCXAZVVHNVAZVVIXAZVVOUWLVAZAVUDUUNZVUGVWFVVCVUGVVBUXBNVUGUXDV
      ULVVBUXBVAAUXDVUDUYDWOZVVGUWTUYTUWOXJWTUDXKVUGUYHVUAVVCAUYHVUDUYJWOZVVEUY
      TUWLUWOXLWTXMZVUGVWHVVIVUGVVHUXBNVUGUXDVUMVVHUXBVAVWLVVMUWTVUBUWOXJWTUDXK
      VUGUYHVUCVVIVWMVVKVUBUWLUWOXLWTXMZARVBZNVAZEXAZSVBZNVAZFXAZXAZXAZGXNAVWGV
      WIXAZXAZVWJXNRSVVBVVHUYTUWOXOZVUBUWOXOZVWPVVBVFZVWSVVHVFZXAZVXCVXEGVWJVXJ
      VXBVXDAVXHVWRVWGVXIVXAVWIVXHVWQVWFEVVCVWPVVBNXPEVWPUWLVAVXHVVCBEJVWPRXQUI
      XRVWPVVBUWLXPXSXTVXIVWTVWHFVVIVWSVVHNXPFVWSUWLVAVXIVVIBFJVWSSXQUJXRVWSVVH
      UWLXPXSXTUUPUUQZGVWPVWSVVNVDZUWLVAVXJVWJBGJVXLVWPVWSVVNXGUKXRVXJVXLVVOUWL
      VWPVVBVWSVVHVVNYAYBXSYDUEYCYEYFAVUFVUHVUJXAVMZVUDAUXDVXMUYDUWTVUEUWLUWOXC
      WDWOYGYHAVUDUYTVUBUYMVDZUYIVAZUYEVUGVXOVXNUWTVAZVXNUWOVEZUWLVAZVUGVUKVULV
      UMVXPVVAVVGVVMUWTUWSUYMUYTVUBUYAUYRUURXEVUGVXQVVBVVHQXFZVDZUWLVUGVXQVVBVV
      HUXFWRVEZVDZVXTVUGUWOUWSYIVEZUXFYIVEZUUSVDVAZVULVUMVXQVYBVFAVYEVUDAUXIVYE
      UXTUWSUXFUWOVYCVYDVYCWEZVYDWEZUUTWDWOVVGVVMUWTUYMVYAVYCVYDUWOUYTVUBUWTUWS
      VYCVYFUYAUVAUWSUYMVYCVYFUYRYJUXFVYAVYDVYGVYAWEZYJUVBXEVUGUXGPVYAQVVBVVHUX
      EVTVSUXFUXSUYBVVTVWBVWDVWEUCVYHUVCXIVUGAVWGVWIVXTUWLVAZVWKVWNVWOVXCHXNVXE
      VYIXNRSVVBVVHVXFVXGVXJVXCVXEHVYIVXKHVWPVWSVXSVDZUWLVAVXJVYIBHJVYJVWPVWSVX
      SXGULXRVXJVYJVXTUWLVWPVVBVWSVVHVXSYAYBXSYDUFYCYEYFAVXOVXPVXRXAVMZVUDAUXDV
      YKUYDUWTVXNUWLUWOXCWDWOYGYHAUYTUYNVAZUYTUYKVEZUYIVAZUYEAVYLXAZVYNVYMUWTVA
      ZVYMUWOVEZUWLVAZVYOUWSUVEVEZVIVEZUWTUYTUYKAVYTUWTUYKVQZVYLAUYKVYSUWSVRVDV
      AZWUAAUWSUVFVAZWUBAUXJVUPWUCVUOVUSUWSUWRTVSUXQUVDWTUYKVYSUWSUYSVYSWEUVGWD
      VYTUWTVYSUWSUYKVYTWEUYAWHWDWOAVYLUYTVYTVAAUYNVYTUYTAUWRVYSVIAUWSUWRTVSVTU
      XQVUOVUSUVHUVIYKUVPXHVYOVYQUXEUYTYMZYNZUWLVYOUYKLUWOOPUWRTVSUWSUYTUXPUXQU
      XRUAUYSAUXJVYLVUOWOAUXKVYLVUQWOAUXLVYLVURWOAUYTOVAZVYLAOUYNUYTAOLUVJZOUYN
      VFAUXLWUGVUROLPUAUVKWDOLUWRPUXRUAUVLWDYKUVMZUVNAVYLWUFWUEUWLVAZWUHAWUIURO
      ACROYOWUIUROYOACROUNYLCWUIRUROCUXEVWPYMZYNZUWLVAVWPUYTVFZWUIBCJWUKUXEWUJV
      WAVWPUVOUVQUGXRWULWUKWUEUWLWULWUJWUDUXEVWPUYTUVRUVSYBXSYPYQYRUVTYFAVYNVYP
      VYRXAVMZVYLAUXDWUMUYDUWTVYMUWLUWOXCWDWOYGYHAUYTTVAZUYTUYOVEZUYIVAZUYEAWUN
      XAZWUPWUOUWTVAZWUOUWOVEZUWLVAZWUQUWTUWSUWRTUYOVSUYTUXQUYPUYAAUXJWUNVUOWOZ
      AVUNWUNVUTWOAWUNYSZUWAWUQWUSSUXEUYTVWSVEZYTZUWLWUQLUWOOPUWRSTUYOVSUYTUXPU
      YPUXRUAWVAAUXKWUNVUQWOAUXLWUNVURWOWVBUWBAWVDUWLVAZURTASUXEVWPVWSVEZYTZUWL
      VAZRTYOWVEURTYOAWVHRTAVWPTVAXADWVHUOBDJWVGSUXEWVFVWAUWCUHXRUWDYLWVHWVERUR
      TWULWVGWVDUWLWULSUXEWVFWVCVWPUYTVWSUWGUWEYBYPYQYRYFAWUPWURWUTXAVMZWUNAUXD
      WVIUYDUWTWUOUWLUWOXCWDWOYGYHAUYEYSAUXJUYEVUOWOAVUPUYEVUSWOUWFUWNUWLUWOXLW
      TUWPKUWLXPUWHUWIUWJAUXNUWMIVMUPBIJKNUMUWKWDWJ $.
  $}

  ${
    pf1const.b $e |- B = ( Base ` R ) $.
    pf1const.q $e |- Q = ran ( eval1 ` R ) $.
    $( Constants are polynomial functions.  (Contributed by Mario Carneiro,
       12-Jun-2015.) $)
    pf1const $p |- ( ( R e. CRing /\ X e. B ) -> ( B X. { X } ) e. Q ) $=
      ( ccrg wcel wa csn cxp ce1 cfv crn cpl1 eqid cbs co wf adantr evl1sca wfn
      cascl cpws crh evl1rhm rhmf ffn crg crngrng ply1sclf syl ffvelrn sylancom
      3syl fnfvelrn syl2anc eqeltrrd syl6eleqr ) CGHZDAHZIZADJKZCLMZNZBVBDCOMZU
      CMZMZVDMZVCVEVGAVFCVDDVDPZVFPZEVGPZUAVBVDVFQMZUBZVHVMHZVIVEHVBVDVFCAUDRZU
      ERHZVMVPQMZVDSVNUTVQVAAVFCVPVDVJVKVPPEUFTVMVRVFVPVDVMPZVRPUGVMVRVDUHUOUTV
      AAVMVGSZVOVBCUIHZVTUTWAVACUJTVGVMVFCAVKVLEVSUKULAVMDVGUMUNVMVHVDUPUQURFUS
      $.

    $( The identity is a polynomial function.  (Contributed by Mario Carneiro,
       20-Mar-2015.) $)
    pf1id $p |- ( R e. CRing -> ( _I |` B ) e. Q ) $=
      ( ccrg wcel cid cres ce1 cfv crn cv1 eqid evl1var cpl1 cbs wfn cpws co wf
      crh evl1rhm rhmf ffn 3syl crg crngrng vr1cl syl fnfvelrn syl2anc eqeltrrd
      syl6eleqr ) CFGZHAIZCJKZLZBUOCMKZUQKZUPURACUQUSUQNZUSNZDOUOUQCPKZQKZRZUSV
      DGZUTURGUOUQVCCASTZUBTGVDVGQKZUQUAVEAVCCVGUQVAVCNZVGNDUCVDVHVCVGUQVDNZVHN
      UDVDVHUQUEUFUOCUGGVFCUHVDVCCUSVBVIVJUIUJVDUSUQUKULUMEUN $.

    $( Polynomial functions are a subring.  (Contributed by Mario Carneiro,
       19-Mar-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    pf1subrg $p |- ( R e. CRing -> Q e. ( SubRing ` ( R ^s B ) ) ) $=
      ( ccrg wcel ce1 cfv cpl1 cbs cima cpws co csubrg crn crh wf wfn eqid wceq
      evl1rhm rhmf ffn fnima 4syl syl6eqr casa crg ply1assa assarng 3syl rhmima
      subrgid syl2anc eqeltrrd ) CFGZCHIZCJIZKIZLZBCAMNZOIZUQVAURPZBUQURUSVBQNG
      ZUTVBKIZURRURUTSVAVDUAAUSCVBURURTUSTZVBTDUBZUTVFUSVBURUTTZVFTUCUTVFURUDUT
      URUEUFEUGUQVEUTUSOIGZVAVCGVHUQUSUHGUSUIGVJUSCVGUJUSUKUTUSVIUNULURUSVBUTUM
      UOUP $.
  $}

  ${
    $d x y z B $.  $d y E $.  $d x y F $.  $d x Q $.  $d x y R $.
    pf1rcl.q $e |- Q = ran ( eval1 ` R ) $.
    $( Reverse closure for the set of polynomial functions.  (Contributed by
       Mario Carneiro, 12-Jun-2015.) $)
    pf1rcl $p |- ( X e. Q -> R e. CRing ) $=
      ( vx vy wcel c0 wceq wn cfv c1o cmap co cv cmpt ccom crn eqid rneqi rnco2
      ccrg n0i cbs csn cxp cevl cima ce1 evl1fval 3eqtri cdm cin wss inss2 neq0
      wex cvv csubrg ces evlval mpfrcl simp2d exlimiv sylbi con1i sseq0 sylancr
      imadisj sylibr syl5eq nsyl2 ) CAGAHIBUBGZACUCVMJZAEBUDKZVOLMNMNEOZFVOLFOU
      EUFPQPZLBUGNZRZUHZHABUIKZRVQVRQZRVTDWAWBEFVOVRBWAWASVRSZVOSZUJTVQVRUAUKVN
      VQULZVSUMZHIZVTHIVNWFVSUNVSHIZWGWEVSUOWHVMWHJVPVSGZEUQVMEVSUPWIVMEWILURGV
      MVOBUSKGVSVOBLVPVRVOLBUTNKVOVRBLWCWDVATVBVCVDVEVFWFVSVGVHVQVSVIVJVKVL $.

    ${
      pf1f.b $e |- B = ( Base ` R ) $.
      $( Polynomial functions are functions.  (Contributed by Mario Carneiro,
         12-Jun-2015.) $)
      pf1f $p |- ( F e. Q -> F : B --> B ) $=
        ( wcel cpws co cbs cfv ccrg cvv eqid pf1rcl fvex eqeltri a1i csubrg wss
        pf1subrg subrgss 3syl id sseldd pwselbas ) DBGZACACAHIZJKZLDUHMUHNFUINZ
        BCDEOZAMGUGACJKMFCJPQRUGBUIDUGCLGBUHSKGBUITUKABCFEUABUIUHUJUBUCUGUDUEUF
        $.

      mpfpf1.q $e |- E = ran ( 1o eval R ) $.
      $( Convert a multivariate polynomial function to univariate.
         (Contributed by Mario Carneiro, 12-Jun-2015.) $)
      mpfpf1 $p |- ( F e. E ->
          ( F o. ( y e. B |-> ( 1o X. { y } ) ) ) e. Q ) $=
        ( vx wcel cv c1o co cfv cbs ccom crn eqid cpws ccrg cevl wceq cpl1 wrex
        csn cxp cmpt cvv csubrg ces evlval rneqi mpfrcl simp2d id syl6eleq cmpl
        eqtri cmap crh wf wfn con0 1on evlrhm sylancr cps1 ply1bas rhmf fvelrnb
        wb ffn 4syl mpbid ce1 evl1val evl1rhm fnfvelrn sylan syl6eleqr eqeltrrd
        wa 3syl coeq1 eleq1d syl5ibcom rexlimdva sylc ) FEKZDUAKZJLZMDUBNZOZFUC
        ZJDUDOZPOZUEZFABMALUFUGUHZQZCKZWJMUIKWKBDUJOKEBDMFEWMRZBMDUKNOZRIWMXCBW
        MDMWMSZHULUMUSUNUOZWJFXBKZWRWJFEXBWJUPIUQWJWMMDURNZDBMUTNTNZVANKZWQXHPO
        ZWMVBWMWQVCXFWRVLWJMVDKWKXIVEXEBWMDXHMVDXGXDHXGSZXHSVFVGWQXJXGXHWMWPDDV
        HOZWQWPSZXLSWQSZVIZXJSVJWQXJWMVMJWQFWMVKVNVOWKWOXAJWQWKWLWQKZWCZWNWSQZC
        KWOXAXQWLDVPOZOZXRCAWLBWMDWQXGXSXSSZXDHXKXOVQXQXTXSRZCWKXSWQVCZXPXTYBKW
        KXSWPDBTNZVANKWQYDPOZXSVBYCBWPDYDXSYAXMYDSHVRWQYEWPYDXSXNYESVJWQYEXSVMW
        DWQWLXSVSVTGWAWBWOXRWTCWNFWSWEWFWGWHWI $.

      $( Convert a univariate polynomial function to multivariate.
         (Contributed by Mario Carneiro, 12-Jun-2015.) $)
      pf1mpf $p |- ( F e. Q ->
          ( F o. ( x e. ( B ^m 1o ) |-> ( x ` (/) ) ) ) e. E ) $=
        ( vy vz wcel cv cfv cbs c1o co ccom eqid syl ccrg ce1 wceq cpl1 wrex c0
        cmap cmpt pf1rcl crn id syl6eleq cpws crh wf wfn wb evl1rhm ffn fvelrnb
        rhmf 4syl mpbid wa cevl csn cxp cid cres cmpl cps1 ply1bas coeq1d coass
        evl1val ccnv df1o2 cvv fvex eqeltri mapsncnv coeq1i mapsnf1o2 f1ococnv1
        0ex wf1o mp1i syl5eqr coeq2d syl5eq simpl ovex a1i con0 1on evlrhm mpan
        ffvelrnda pwselbas fcoi1 3eqtrd fnfvelrn sylan syl6eleqr eqeltrd eleq1d
        coeq1 syl5ibcom rexlimdva sylc ) FCLZDUALZJMZDUBNZNZFUCZJDUDNZONZUEZFAB
        PUGQZUFAMNUHZRZELZCDFGUIZXKFXNUJZLZXSXKFCYEXKUKGULXKXNXQDBUMQZUNQLZXRYG
        ONZXNUOXNXRUPYFXSUQXKXLYHYDBXQDYGXNXNSZXQSZYGSHURTXRYIXQYGXNXRSZYISVAXR
        YIXNUSJXRFXNUTVBVCXLXPYCJXRXLXMXRLZVDZXOYARZELXPYCYNYOXMPDVEQZNZEYNYOYQ
        KBPKMVFVGUHZRZYARZYQVHXTVIZRZYQYNXOYSYAKXMBYPDXRPDVJQZXNYJYPSZHUUCSZXQD
        DVKNZXRYKUUFSYLVLZVOVMYNYTYQYRYARZRUUBYQYRYAVNYNUUHUUAYQYNUUHYAVPZYARZU
        UAUUIYRYAAKBPYAUFVQBDONVRHDOVSVTZWEYASZWAWBXTBYAWFUUJUUAUCYNABPYAUFVQUU
        KWEUULWCXTBYAWDWGWHWIWJYNXTBYQUOUUBYQUCYNBDXTDXTUMQZONZUAYQUUMVRUUMSZHU
        UNSZXLYMWKXTVRLYNBPUGWLWMXLXRUUNXMYPXLYPUUCUUMUNQLZXRUUNYPUOZPWNLXLUUQW
        OBYPDUUMPWNUUCUUDHUUEUUOWPWQXRUUNUUCUUMYPUUGUUPVATZWRWSXTBYQWTTXAYNYQYP
        UJZEXLYPXRUPZYMYQUUTLXLUURUVAUUSXRUUNYPUSTXRXMYPXBXCIXDXEXPYOYBEXOFYAXG
        XFXHXIXJ $.
    $}

    ${
      pf1addcl.a $e |- .+ = ( +g ` R ) $.
      $( The sum of multivariate polynomial functions.  (Contributed by Mario
         Carneiro, 12-Jun-2015.) $)
      pf1addcl $p |- ( ( F e. Q /\ G e. Q ) -> ( F oF .+ G ) e. Q ) $=
        ( wcel cbs cfv co ccrg cvv eqid adantr wf pf1f wb pwselbasb sylancl cof
        wa cpws cplusg pf1rcl a1i mpbird adantl pwsplusgval csubrg pf1subrg syl
        fvex subrgacl 3expib mpcom eqeltrrd ) DBHZEBHZUBZDECCIJZUCKZUDJZKZDEAUA
        KBUTVBIJZAVCCDEVALMVBVBNZVENZURCLHZUSBCDFUEOZVAMHZUTCIUMZUFUTDVEHZVAVAD
        PZURVMUSVABCDFVANZQOUTVHVJVLVMRVIVKVACVAVELDVBMVFVNVGSTUGUTEVEHZVAVAEPZ
        USVPURVABCEFVNQUHUTVHVJVOVPRVIVKVACVAVELEVBMVFVNVGSTUGGVCNZUIBVBUJJHZUT
        VDBHZUTVHVRVIVABCVNFUKULVRURUSVSBVCVBDEVQUNUOUPUQ $.
    $}

    ${
      pf1mulcl.t $e |- .x. = ( .r ` R ) $.
      $( The product of multivariate polynomial functions.  (Contributed by
         Mario Carneiro, 12-Jun-2015.) $)
      pf1mulcl $p |- ( ( F e. Q /\ G e. Q ) -> ( F oF .x. G ) e. Q ) $=
        ( wcel cbs cfv co ccrg cvv eqid adantr wf pf1f wb pwselbasb sylancl cof
        cpws cmulr pf1rcl fvex a1i mpbird adantl pwsmulrval csubrg pf1subrg syl
        wa subrgmcl 3expib mpcom eqeltrrd ) DAHZEAHZUMZDEBBIJZUBKZUCJZKZDECUAKA
        UTVBIJZBVCCDEVALMVBVBNZVENZURBLHZUSABDFUDOZVAMHZUTBIUEZUFUTDVEHZVAVADPZ
        URVMUSVAABDFVANZQOUTVHVJVLVMRVIVKVABVAVELDVBMVFVNVGSTUGUTEVEHZVAVAEPZUS
        VPURVAABEFVNQUHUTVHVJVOVPRVIVKVABVAVELEVBMVFVNVGSTUGGVCNZUIAVBUJJHZUTVD
        AHZUTVHVRVIVAABVNFUKULVRURUSVSAVBVCDEVQUNUOUPUQ $.
    $}
  $}

  ${
    $d a b f g x y .+ $.  $d a b f g w x y B $.  $d f x et $.  $d a b f g ph $.
    $d b x y A $.  $d x ch $.  $d a b f g y ps $.  $d b f g Q $.  $d a b w R $.
    $d x rh $.  $d x si $.  $d x ta $.  $d x th $.  $d a b f g x y .x. $.
    $d x ze $.
    pf1ind.cb $e |- B = ( Base ` R ) $.
    pf1ind.cp $e |- .+ = ( +g ` R ) $.
    pf1ind.ct $e |- .x. = ( .r ` R ) $.
    pf1ind.cq $e |- Q = ran ( eval1 ` R ) $.
    pf1ind.ad $e |- ( ( ph /\ ( ( f e. Q /\ ta ) /\ ( g e. Q /\ et ) ) ) ->
        ze ) $.
    pf1ind.mu $e |- ( ( ph /\ ( ( f e. Q /\ ta ) /\ ( g e. Q /\ et ) ) ) ->
        si ) $.
    pf1ind.wa $e |- ( x = ( B X. { f } ) -> ( ps <-> ch ) ) $.
    pf1ind.wb $e |- ( x = ( _I |` B ) -> ( ps <-> th ) ) $.
    pf1ind.wc $e |- ( x = f -> ( ps <-> ta ) ) $.
    pf1ind.wd $e |- ( x = g -> ( ps <-> et ) ) $.
    pf1ind.we $e |- ( x = ( f oF .+ g ) -> ( ps <-> ze ) ) $.
    pf1ind.wf $e |- ( x = ( f oF .x. g ) -> ( ps <-> si ) ) $.
    pf1ind.wg $e |- ( x = A -> ( ps <-> rh ) ) $.
    pf1ind.co $e |- ( ( ph /\ f e. B ) -> ch ) $.
    pf1ind.pr $e |- ( ph -> th ) $.
    pf1ind.a $e |- ( ph -> A e. Q ) $.
    $( Prove a property of polynomials by "structural" induction, under a
       simplified model of structure which loses the sum of products
       structure.  (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    pf1ind $p |- ( ph -> rh ) $=
      ( vb vw vy va cab wcel c1o cmap co c0 cv cfv cmpt ccom csn cxp cres coass
      cid ccnv df1o2 cbs cvv fvex eqeltri 0ex eqid mapsncnv wf1o wceq mapsnf1o2
      coeq2i f1ococnv2 mp1i syl5eqr coeq2d syl5eq wf pf1f fcoi1 eqtrd cof wa wi
      3syl mpfpf1 vex elab eleq1 syl5bbr anbi1d ovex oveq1 eleq1d imbi12d oveq2
      expcom an4s expimpd vtocl2ga syl2an exp3acom23 impcom wfn ffn syl sylibrd
      mpff a1i ofco syl5bi imp coeq1 weq cascl ccrg cmpl adantr crh con0 fveq2d
      1on sylan coeq1d sylibr eqeltrrd crn ces evlval rneqi an4 anbi2d ad2antrl
      cevl ad2antll mapsnf1o3 f1of inidm cpl1 pf1rcl csca casa mplassa ply1ascl
      ce1 sylancr asclrhm mplsca oveq1d eleqtrrd rhmf ffvelrnda evl1val syl2anc
      evl1sca cress ressid oveq2d syl6eqr fveq1d csubrg crngrng subrgid evlssca
      simpr eqtr3d 3eqtr3d wral snex xpex ralrimiva sneq xpeq2d rspccva resiexg
      ax-mp eqeltrd el1o fveq2 sylbi mpteq2dv syl5ibrcom pf1mpf mpfind wb elabg
      crg mpbid ) AKBJUSZUTZIAKUOLVAVBVCZVDUOVEZVFZVGZVHZUPLVAUPVEVIVJVGZVHZKUX
      CAUXKKVMLVKZVHZKAUXKKUXHUXJVHZVHUXMKUXHUXJVLAUXNUXLKAUXNUXHUXHVNZVHZUXLUX
      OUXJUXHUOUPLVAUXHVDVOLOVPVFVQSOVPVRVSZVTUXHWAZWBWFUXELUXHWCUXPUXLWDAUOLVA
      UXHVDVOUXQVTUXRWEUXELUXHWGWHWIZWJWKAKNUTZLLKWLUXMKWDUNLNOKUBSWMLLKWNWSWOA
      UQVEZUXJVHZUXCUTUXEURVEZVIZVJZUXJVHZUXCUTUOUXEUYCUXFVFZVGZUXJVHZUXCUTZUYC
      UXJVHZUXCUTZUXFUXJVHZUXCUTZUYCUXFMWPZVCZUXJVHZUXCUTZUYCUXFPWPZVCZUXJVHZUX
      CUTZUXKUXCUTUQUXILMVAOUUHVCZUUAZLOPURUOVASTUAVUCLVAOUUBVCVFLVUCOVAVUCWAZS
      UUCZUUDZAUYCVUDUTZUYLWQUXFVUDUTZUYNWQWQZUYRVUJVUHVUIWQZUYLUYNWQZWQZAUYRVU
      HUYLVUIUYNUUEZAVUKVULUYRAVUKWQZVULUYKUYMUYOVCZUXCUTZUYRVUKAVULVUQWRVUKVUL
      AVUQVUHUYKNUTZUYMNUTZVULAWQZVUQWRZVUIUPLNOVUDUYCUBSVUDWAZWTZUPLNOVUDUXFUB
      SVVBWTZEFWQZAWQZGWRUYLFWQZAWQZUYKRVEZUYOVCZUXCUTZWRVVAQRUYKUYMNNQVEZUYKWD
      ZVVFVVHGVVKVVMVVEVVGAVVMEUYLFEVVLUXCUTVVMUYLBEJVVLQXAUGXBVVLUYKUXCXCXDXEX
      EZGVVLVVIUYOVCZUXCUTVVMVVKBGJVVOVVLVVIUYOXFUIXBVVMVVOVVJUXCVVLUYKVVIUYOXG
      XHXDXIVVIUYMWDZVVHVUTVVKVUQVVPVVGVULAVVPFUYNUYLFVVIUXCUTVVPUYNBFJVVIRXAUH
      XBVVIUYMUXCXCXDUUFXEZVVPVVJVUPUXCVVIUYMUYKUYOXJXHXIVVLNUTZVVINUTZWQZVVEAG
      VVREVVSFAGWRAVVREWQVVSFWQWQZGUCXKXLXMXNXOXPXQVUOUYQVUPUXCVUOUXEUXEUXELMUY
      CUXFUXJVQVQVQVUOUXELUYCWLZUYCUXEXRVUHVWBAVUILVUDLOUYCVAVUGSYBUUGUXELUYCXS
      XTZVUOUXELUXFWLZUXFUXEXRVUIVWDAVUHLVUDLOUXFVAVUGSYBUUIUXELUXFXSXTZLUXEUXJ
      WCLUXEUXJWLVUOUPLVAUXJVDVOUXQVTUXJWAUUJLUXEUXJUUKWHZUXEVQUTVUOLVAVBXFYCZV
      WGLVQUTZVUOUXQYCZUXEUULZYDXHYAXMYEYFAVUJVUBVUJVUMAVUBVUNAVUKVULVUBVUOVULU
      YKUYMUYSVCZUXCUTZVUBVUKAVULVWLWRVUKVULAVWLVUHVURVUSVUTVWLWRZVUIVVCVVDVVFH
      WRVVHUYKVVIUYSVCZUXCUTZWRVWMQRUYKUYMNNVVMVVFVVHHVWOVVNHVVLVVIUYSVCZUXCUTV
      VMVWOBHJVWPVVLVVIUYSXFUJXBVVMVWPVWNUXCVVLUYKVVIUYSXGXHXDXIVVPVVHVUTVWOVWL
      VVQVVPVWNVWKUXCVVIUYMUYKUYSXJXHXIVVTVVEAHVVREVVSFAHWRAVWAHUDXKXLXMXNXOXPX
      QVUOVUAVWKUXCVUOUXEUXEUXELPUYCUXFUXJVQVQVQVWCVWEVWFVWGVWGVWIVWJYDXHYAXMYE
      YFUYAUYEWDUYBUYFUXCUYAUYEUXJYGXHUYAUYHWDUYBUYIUXCUYAUYHUXJYGXHUQURYHUYBUY
      KUXCUYAUYCUXJYGXHUQUOYHUYBUYMUXCUYAUXFUXJYGXHUYAUYPWDUYBUYQUXCUYAUYPUXJYG
      XHUYAUYTWDUYBVUAUXCUYAUYTUXJYGXHUYAUXIWDUYBUXKUXCUYAUXIUXJYGXHAUYCLUTZWQZ
      LUYDVJZUYFUXCVWRUYCOUUMVFZYIVFZVFZOUUSVFZVFZVXBVUCVFZUXJVHZVWSUYFVWROYJUT
      ZVXBVAOYKVCZVPVFZUTVXDVXFWDAVXGVWQAUXTVXGUNNOKUBUUNXTZYLZALVXIUYCVXAAVXAO
      VXHYMVCZUTLVXIVXAWLAVXAVXHUUOVFZVXHYMVCZVXLAVXHUUPUTZVXAVXNUTAVAYNUTZVXGV
      XOYPVXJVXHOVAYNVXHWAZUUQUUTVXAVXMVXHVXAVWTOVWTWAZVXAWAZUURZVXMWAUVAXTAOVX
      MVXHYMAVXHOVAYNYJVXQVXPAYPYCVXJUVBUVCUVDLVXIOVXHVXASVXIWAZUVEXTUVFUPVXBLV
      UCOVXIVXHVXCVXCWAZVUESVXQVYAUVGUVHAVXGVWQVXDVWSWDVXJVXALVWTOVXCUYCVYBVXRS
      VXSUVIYQVWRVXEUYEUXJVWRUYCVAOLUVJVCZYKVCZYIVFZVFZVUCVFVXEUYEVWRVYFVXBVUCV
      WRUYCVYEVXAVWRVYEVXHYIVFVXAVWRVYDVXHYIVWRVYCOVAYKVWRVXGVYCOWDVXKLOYJSUVKX
      TUVLYOVXTUVMUVNYOVWRVYELVUCLOVYCVAYNVYDUYCVUFVYDWAVYCWASVYEWAVXPVWRYPYCVX
      KALOUVOVFUTZVWQAVXGOUXAUTVYGVXJOUVPLOSUVQWSYLAVWQUVSUVRUVTYRUWAALVVLVIZVJ
      ZUXCUTZQLUWBVWQVWSUXCUTZAVYJQLAVVLLUTWQCVYJULBCJVYILVYHUXQVVLUWCUWDUEXBYS
      UWEVYJVYKQUYCLQURYHZVYIVWSUXCVYLVYHUYDLVVLUYCUWFUWGXHUWHYQYTAUYCVAUTZUYJA
      UYJVYMUXNUXCUTAUXNUXLUXCUXSADUXLUXCUTUMBDJUXLVWHUXLVQUTUXQLVQUWIUWJUFXBYS
      UWKVYMUYIUXNUXCVYMUYHUXHUXJVYMUOUXEUYGUXGVYMUYCVDWDUYGUXGWDUYCUWLUYCVDUXF
      UWMUWNUWOYRXHUWPYFAUXTUXIVUDUTUNUOLNOVUDKUBSVVBUWQXTUWRYTAUXTUXDIUWSUNBIJ
      KNUKUWTXTUXB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Polynomial degrees
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c mDeg $. $( Multivariate polynomial degree $)
  $c deg1 $. $( Univariate polynomial degree $)

  $( Multivariate polynomial degree. $)
  cmdg $a class mDeg $.

  $( Univariate polynomial degree. $)
  cdg1 $a class deg1 $.

  ${
    $d i r h f $.
    $( Define the degree of a polynomial.  Note (SO): as an experiment I am
       using a definition which makes the degree of the zero polynomial
       ` -oo ` , contrary to the convention used in ~ df-dgr .  (Contributed by
       Stefan O'Rear, 19-Mar-2015.) $)
    df-mdeg $a |- mDeg = ( i e. _V , r e. _V |->
      ( f e. ( Base ` ( i mPoly r ) ) |->
        sup ( ran ( h e. ( `' f " ( _V \ { ( 0g ` r ) } ) ) |->
          ( CCfld gsum h ) ) , RR* , < ) ) ) $.

    $( Define the degree of a univariate polynomial.  (Contributed by Stefan
       O'Rear, 23-Mar-2015.) $)
    df-deg1 $a |- deg1 = ( r e. _V |-> ( 1o mDeg r ) ) $.

    $( Multivariate degree is a binary operation.  (Contributed by Stefan
       O'Rear, 28-Mar-2015.) $)
    reldmmdeg $p |- Rel dom mDeg $=
      ( vi vr vf vh cvv cv cmpl cbs cfv ccnv c0g csn cdif cima ccnfld cgsu cmpt
      co crn cxr clt csup cmdg df-mdeg reldmmpt2 ) ABEECAFBFZGRHIDCFJEUFKILMNOD
      FPRQSTUAUBQUCCDABUDUE $.
  $}

  ${
    $d A h x y $.  $d I h m $.  $d I x y $.  $d V h x y $.
    tdeglem.a $e |- A = { m e. ( NN0 ^m I ) | ( `' m " NN ) e. Fin } $.
    tdeglem.h $e |- H = ( h e. A |-> ( CCfld gsum h ) ) $.
    $( Functionality of the total degree helper function.  (Contributed by
       Stefan O'Rear, 19-Mar-2015.) $)
    tdeglem1 $p |- ( I e. V -> H : A --> NN0 ) $=
      ( wcel ccnfld cv cgsu co cn0 wa cc0 cnfld0 crg ccmn cnrng rngcmn mp1i cfv
      simpl csubmnd nn0subm a1i psrbagf ccnv cvv csn cdif cima cfn psrbagsuppfi
      ancoms gsumsubmcl fmptd ) EFIZBAJBKZLMNDUSUTAIZOZENUTJFPQJRIJSIVBTJUAUBUS
      VAUDNJUEUCIVBUFUGACUTEFGUHVAUSUTUIUJPUKULUMUNIACEFUTGUOUPUQHUR $.

    $d X h $.  $d X m $.  $d Y h $.  $d Y m $.
    $( Additivity of the total degree helper function.  (Contributed by Stefan
       O'Rear, 26-Mar-2015.) $)
    tdeglem3 $p |- ( ( I e. V /\ X e. A /\ Y e. A ) ->
        ( H ` ( X oF + Y ) ) = ( ( H ` X ) + ( H ` Y ) ) ) $=
      ( wcel ccnfld caddc co cgsu cfv cc wf cn0 oveq2 w3a cof cnfldbas cnfldadd
      cc0 cnfld0 crg ccmn cnrng rngcmn simp1 wa wss psrbagf nn0sscn fss sylancl
      mp1i 3adant3 3adant2 ccnv cvv csn cdif cima cfn psrbagsuppfi gsumadd wceq
      ancoms psrbagaddcl cv ovex fvmpt syl oveqan12d 3adant1 3eqtr4d ) EFKZGAKZ
      HAKZUAZLGHMUBNZONZLGONZLHONZMNZWCDPZGDPZHDPZMNZWBEQMGLHFUEUCUFUDLUGKLUHKW
      BUILUJURVSVTWAUKVSVTEQGRZWAVSVTULESGRSQUMZWLACGEFIUNUOESQGUPUQUSVSWAEQHRZ
      VTVSWAULESHRWMWNACHEFIUNUOESQHUPUQUTVSVTGVAVBUEVCVDZVEVFKZWAVTVSWPACEFGIV
      GVJUSVSWAHVAWOVEVFKZVTWAVSWQACEFHIVGVJUTVHWBWCAKWHWDVIACGHEFIVKBWCLBVLZON
      ZWDADWRWCLOTJLWCOVMVNVOVTWAWKWGVIVSVTWAWIWEWJWFMBGWSWEADWRGLOTJLGOVMVNBHW
      SWFADWRHLOTJLHOVMVNVPVQVR $.

    $d A w z $.  $d H x $.  $d I w z $.  $d V w z $.  $d X w x z $.  $d X y $.
    $( There is only one multi-index with total degree 0.  (Contributed by
       Stefan O'Rear, 29-Mar-2015.) $)
    tdeglem4 $p |- ( ( I e. V /\ X e. A ) -> ( ( H ` X ) = 0 <->
          X = ( I X. { 0 } ) ) ) $=
      ( vx vy wcel wa cfv cc0 wceq ccnfld cgsu co cn0 csn cxp cv wral wn rexnal
      wrex wne df-ne cdif cmpt caddc oveq2 ovex ad2antlr psrbagf feqmptd adantr
      fvmpt oveq2d cc cnfldbas cnfld0 cnfldadd ccmn cnrng rngcmn mp1i simpll wf
      crg ffvelrnda nn0cnd ccnv cvv cima cfn cnveqd imaeq1d psrbagsuppfi ancoms
      eqeltrrd cin incom disjdif eqtri a1i cun difsnid eqcomd gsumsplit2 3eqtrd
      c0 ad2antrl cn difexg syl csubmnd nn0subm eldifi ffvelrn syl2an fmptd wss
      eqid cres difss resmpt ax-mp resss eqsstr3i cnvss mp2b sylancl gsumsubmcl
      imass1 ssfi cmnd rngmnd simprl ffvelrnd fveq2 gsumsn syl3anc simprr sylib
      elnn0 orel2 sylc eqeltrd nn0nnaddcl syl2anc nnne0d eqnetrd expr rexlimdva
      wo syl5bir necon4bd wfn wb ffn 0nn0 fnconstg eqfnfv c0ex fvconst2 ralbiia
      eqeq2d syl6bb sylibrd fconstmpt oveq2i gsumz mpan syl5eq eqtrd syl5ibrcom
      psrbag0 eqeq1d impbid ) EFLZGALZMZGDNZOPZGEOUAZUBZPZUVDUVFJUCZGNZOPZJEUDZ
      UVIUVDUVMUVEOUVMUEUVLUEZJEUGUVDUVEOUHZUVLJEUFUVDUVNUVOJEUVNUVKOUHZUVDUVJE
      LZMUVOUVKOUIZUVDUVQUVPUVOUVDUVQUVPMZMZUVEQKEUVJUAZUJZKUCZGNZUKZRSZQKUWAUW
      DUKRSZULSZOUVTUVEQGRSZQKEUWDUKZRSUWHUVCUVEUWIPUVBUVSBGQBUCZRSZUWIADUWKGQR
      UMIQGRUNUSUOUVTGUWJQRUVDGUWJPUVSUVDKETGACGEFHUPZUQURZUTUVTEVAUWBUWAULKQFU
      WDOVBVCVDQVKLZQVELUVTVFQVGVHZUVBUVCUVSVIZUVTUWCELZMUWDUVTETUWCGUVDETGVJZU
      VSUWMURZVLVMUVTGVNZVOUVGUJZVPZUWJVNZUXBVPZVQUVTUXAUXDUXBUVTGUWJUWNVRVSUVD
      UXCVQLZUVSUVCUVBUXFACEFGHVTWAURWBZUWBUWAWCZWMPUVTUXHUWAUWBWCWMUWBUWAWDUWA
      EWEWFWGUVQEUWBUWAWHZPUVDUVPUVQUXIEEUVJWIWJWNWKWLUVTUWHUVTUWFTLUWGWOLUWHWO
      LUVTUWBTUWEQVOOVCUWPUVTUVBUWBVOLUWQEUWAFWPWQTQWRNLUVTWSWGUVTKUWBUWDTUWEUV
      TUWSUWRUWDTLUWCUWBLUWTUWCEUWAWTETUWCGXAXBUWEXEXCUVTUXEVQLUWEVNZUXBVPZUXEX
      DZUXKVQLUXGUWEUWJXDUXJUXDXDUXLUWEUWJUWBXFZUWJUWBEXDUXMUWEPEUWAXGKEUWBUWDX
      HXIUWJUWBXJXKUWEUWJXLUXJUXDUXBXPXMUXEUXKXQXNXOUVTUWGUVKWOUVTQXRLZUVQUVKVA
      LUWGUVKPUWOUXNUVTVFQXSZVHUVDUVQUVPXTZUVTUVKUVTETUVJGUWTUXPYAZVMUWDVAUVKKQ
      UVJEVBUWCUVJGYBYCYDUVTUVNUVKWOLZUVLYQZUXRUVTUVPUVNUVDUVQUVPYEUVRYFUVTUVKT
      LUXSUXQUVKYGYFUVLUXRYHYIYJUWFUWGYKYLYMYNYOYRYPYRYSUVDUVIUVKUVJUVHNZPZJEUD
      ZUVMUVDGEYTZUVHEYTZUVIUYBUUAUVDUWSUYCUWMETGUUBWQOTLUYDUVDUUCEOTUUDVHJEGUV
      HUUEYLUYAUVLJEUVQUXTOUVKEOUVJUUFUUGUUIUUHUUJUUKUVDUVFUVIUVHDNZOPUVDUYEQUV
      HRSZOUVDUVHALZUYEUYFPUVBUYGUVCACEFHUUSURBUVHUWLUYFADUWKUVHQRUMIQUVHRUNUSW
      QUVDUYFQJEOUKZRSZOUVHUYHQRJEOUULUUMUVBUYIOPZUVCUXNUVBUYJUWOUXNVFUXOXIEJQF
      OVCUUNUUOURUUPUUQUVIUVEUYEOGUVHDYBUUTUURUVA $.
  $}

  ${
    $d h x $.
    $( Simplification of total degree for the univariate case.  (Contributed by
       Stefan O'Rear, 23-Mar-2015.) $)
    tdeglem2 $p |- ( h e. ( NN0 ^m 1o ) |-> ( h ` (/) ) ) =
        ( h e. ( NN0 ^m 1o ) |-> ( CCfld gsum h ) ) $=
      ( vx cn0 c1o cmap co c0 cfv ccnfld cgsu wcel wceq csn cmpt elmapi feqmptd
      cv cvv cc 0ex oveq2d cmnd crg cnrng rngmnd mp1i wf ffvelrn sylancl nn0cnd
      a1i snid cnfldbas fveq2 gsumsn syl3anc eqtrd df1o2 oveq2i eleq2s mpteq2ia
      eqcomd ) ACDEFZGAQZHZIVDJFZVDVCKVFVEVFVELVDCGMZEFZVCVDVHKZVFIBVGBQZVDHZNZ
      JFZVEVIVDVLIJVIBVGCVDVDCVGOZPUAVIIUBKZGRKZVESKVMVELIUCKVOVIUDIUEUFVPVITUK
      VIVEVIVGCVDUGGVGKVECKVNGTULVGCGVDUHUIUJVKSVEBIGRUMVJGVDUNUOUPUQDVGCEURUSU
      TVBVA $.
  $}

  ${
    $d A h $.  $d B f i r $.  $d I f i r $.  $d I m $.  $d R f i r $.
    $d V f $.  $d W f $.  $d .0. h i r $.  $d f h $.
    mdegval.d $e |- D = ( I mDeg R ) $.
    mdegval.p $e |- P = ( I mPoly R ) $.
    mdegval.b $e |- B = ( Base ` P ) $.
    mdegval.z $e |- .0. = ( 0g ` R ) $.
    mdegval.a $e |- A = { m e. ( NN0 ^m I ) | ( `' m " NN ) e. Fin } $.
    mdegval.h $e |- H = ( h e. A |-> ( CCfld gsum h ) ) $.
    $( Value of the multivariate degree function.  (Contributed by Stefan
       O'Rear, 19-Mar-2015.) $)
    mdegfval $p |- D = ( f e. B |-> sup ( ( H " ( `'
        f " ( _V \ { .0. } ) ) ) , RR* , < ) ) $=
      ( cvv cmpt cbs vi vr cmdg co cv ccnv csn cdif cima cxr clt csup wcel wceq
      wa ccnfld cgsu crn cmpl cfv c0g oveq12 syl6eqr fveq2d fveq2 sneqd difeq2d
      imaeq2d mpteq1d rneqd supeq1d adantl mpteq12dv df-mdeg fvex eqeltri mptex
      ovmpt2a cres reseq1i wss cdm cnvimass wf eqid simpr mplelf fdm syl resmpt
      syl5sseq syl5req df-ima mpteq2dva eqtrd wn c0 reldmmdeg ovprc mpt0 syl5eq
      reldmmpl base0 3eqtr4g eqtr4d pm2.61i eqtri ) CJEUCUDZFBIFUEZUFZRKUGZUHZU
      IZUIZUJUKULZSZLJRUMERUMUOZXHXPUNXQXHFBGXMUPGUEUQUDZSZURZUJUKULZSZXPUAUBJE
      RRFUAUEZUBUEZUSUDZTUTZGXJRYDVAUTZUGZUHZUIZXRSZURZUJUKULZSYBUCYCJUNZYDEUNZ
      UOZFYFYMBYAYPYFDTUTZBYPYEDTYPYEJEUSUDZDYCJYDEUSVBMVCVDNVCYOYMYAUNYNYOUJYL
      XTUKYOYKXSYOGYJXMXRYOYIXLXJYOYHXKRYOYGKYOYGEVAUTKYDEVAVEOVCVFVGVHVIVJVKVL
      VMFGUAUBVNFBYABYQRNDTVOVPVQVRXQFBYAXOXQXIBUMZUOZUJXTXNUKYTXTIXMVSZURXNYTX
      SUUAYTUUAGAXRSZXMVSZXSIUUBXMQVTYTXMAWAUUCXSUNYTXIWBZXMAXIXLWCYTAETUTZXIWD
      UUDAUNYTBADEHJUUEXIMUUEWENPXQYSWFWGAUUEXIWHWIWKGAXMXRWJWIWLVJIXMWMVCVKWNW
      OXQWPZXHFWQXOSZXPUUFXHWQUUGJEUCWRWSFXOWTVCUUFFBWQXOUUFYQWQTUTBWQUUFDWQTUU
      FDYRWQMJEUSXBWSXAVDNXCXDVIXEXFXG $.

    $d F f $.  $d H f $.  $d .0. f $.
    $( Value of the multivariate degree function at some particular
       polynomial.  (Contributed by Stefan O'Rear, 19-Mar-2015.) $)
    mdegval $p |- ( F e. B -> ( D ` F ) = sup ( ( H " ( `' F " (
        _V \ { .0. } ) ) ) , RR* , < ) ) $=
      ( cima cxr clt vf cv ccnv cvv csn cdif csup cnveq imaeq1d imaeq2d supeq1d
      wceq mdegfval xrltso supex fvmpt ) UAHIUAUBZUCZUDKUEUFZRZRZSTUGIHUCZUSRZR
      ZSTUGBCUQHULZSVAVDTVEUTVCIVEURVBUSUQHUHUIUJUKABCDEUAFGIJKLMNOPQUMSVDTUNUO
      UP $.

    $d A x y $.  $d B x $.  $d F x y $.  $d G x y $.  $d H x y $.  $d I h $.
    $d R x $.  $d W x $.  $d .0. x y $.  $d h m $.
    $( Property of being of limited degree.  (Contributed by Stefan O'Rear,
       19-Mar-2015.) $)
    mdegleb $p |- ( ( F e. B /\ G e. RR* ) -> ( ( D ` F ) <_ G <->
          A. x e. A ( G < ( H ` x ) -> ( F ` x ) = .0. ) ) ) $=
      ( wcel vy cxr wa cfv cle wbr ccnv cvv csn cdif cima clt csup cv wral wceq
      wi mdegval adantr breq1d wss wb crn imassrn cn0 wf mplrcl tdeglem1 syl cr
      frn nn0ssre ressxr sstri syl6ss syl5ss supxrleub sylancom wfn ffn cdm cbs
      cnvimass eqid simpl mplelf syl5sseq ralima syl2anc elpreima imbi1d impexp
      fdm breq1 wn con34b simplr ffvelrnda sseldi xrltnle bicomd wne wo eldifsn
      ianor xchnxbir orcom fvex notnoti biorfi nne 3bitr2i a1i imbi12d pm5.74da
      syl5bb bitrd ralbidv2 3bitrd ) ICTZJUBTZUCZIDUDZJUEUFKIUGUHMUIUJZUKZUKZUB
      ULUMZJUEUFZUAUNZJUEUFZUAYFUOZJAUNZKUDZULUFZYLIUDZMUPZUQZABUOZYBYCYGJUEXTY
      CYGUPYABCDEFGHIKLMNOPQRSURUSUTXTYAYFUBVAYHYKVBYBYFKVCZUBKYEVDYBYSVEUBYBBV
      EKVFZYSVEVAYBLUHTZYTXTUUAYACEFLIOPVGUSBGHKLUHRSVHVIZBVEKVKVIVEVJUBVLVMVNZ
      VOVPUAYFJVQVRYBYKYMJUEUFZAYEUOZYRYBKBVSZYEBVAYKUUEVBYBYTUUFUUBBVEKVTVIYBI
      WAZYEBIYDWCYBBFWBUDZIVFZUUGBUPYBCBEFHLUUHIOUUHWDPRXTYAWEWFZBUUHIWMVIWGYJU
      UDUAABYEKYIYMJUEWNWHWIYBUUDYQAYEBYBYLYETZUUDUQYLBTZYOYDTZUCZUUDUQZUULYQUQ
      ZYBUUKUUNUUDYBIBVSZUUKUUNVBYBUUIUUQUUJBUUHIVTVIBYLYDIWJVIWKUUOUULUUMUUDUQ
      ZUQYBUUPUULUUMUUDWLYBUULUURYQUURUUDWOZUUMWOZUQYBUULUCZYQUUMUUDWPUVAUUSYNU
      UTYPUVAYNUUSUVAYAYMUBTYNUUSVBXTYAUULWQUVAVEUBYMUUCYBBVEYLKUUBWRWSJYMWTWIX
      AUUTYOUHTZWOZYOMXBZWOZXCZUVAYPUVBUVDUCUVFUUMUVBUVDXEYOUHMXDXFUVFYPVBUVAUV
      FUVEUVCXCUVEYPUVCUVEXGUVCUVEUVBYLIXHXIXJYOMXKXLXMXPXNXPXOXPXQXRXQXS $.

    ${
      $d D x $.  $d X x $.
      mdeglt.f $e |- ( ph -> F e. B ) $.
      medglt.x $e |- ( ph -> X e. A ) $.
      mdeglt.lt $e |- ( ph -> ( D ` F ) < ( H ` X ) ) $.
      $( If there is an upper limit on the degree of a polynomial that is lower
         than the degree of some exponent bag, then that exponent bag is
         unrepresented in the polynomial.  (Contributed by Stefan O'Rear,
         26-Mar-2015.) $)
      mdeglt $p |- ( ph -> ( F ` X ) = .0. ) $=
        ( vx cfv clt wbr wceq wcel cv wi wral cle cxr ccnv cvv csn cdif mdegval
        cima csup syl wss crn imassrn cn0 wf mplrcl tdeglem1 frn 4syl cr ressxr
        nn0ssre sstri syl6ss syl5ss supxrcl eqeltrd mdegleb syl2anc mpbid fveq2
        xrleid wb breq2d eqeq1d imbi12d rspcva mpd ) AIDUDZLJUDZUEUFZLIUDZMUGZU
        BALBUHWJUCUIZJUDZUEUFZWOIUDZMUGZUJZUCBUKZWLWNUJZUAAWJWJULUFZXAAWJUMUHZX
        CAWJJIUNUOMUPUQUSZUSZUMUEUTZUMAICUHZWJXGUGTBCDEFGHIJKMNOPQRSURVAAXFUMVB
        XGUMUHAXFJVCZUMJXEVDAXIVEUMAXHKUOUHBVEJVFXIVEVBTCEFKIOPVGBGHJKUORSVHBVE
        JVIVJVEVKUMVMVLVNVOVPXFVQVAVRZWJWCVAAXHXDXCXAWDTXJUCBCDEFGHIWJJKMNOPQRS
        VSVTWAWTXBUCLBWOLUGZWQWLWSWNXKWPWKWJUEWOLJWBWEXKWRWMMWOLIWBWFWGWHVTWI
        $.
    $}

    $d D x $.
    mdegldg.y $e |- Y = ( 0g ` P ) $.
    $( A nonzero polynomial has some coefficient which witnesses its degree.
       (Contributed by Stefan O'Rear, 23-Mar-2015.) $)
    mdegldg $p |- ( ( R e. Ring /\ F e. B /\ F =/= Y ) ->
        E. x e. A ( ( F ` x ) =/= .0. /\ ( H ` x ) = ( D ` F ) ) ) $=
      ( crg wcel wne w3a cfv ccnv cvv csn cdif cima cv wceq wa wrex cxr mdegval
      clt csup 3ad2ant2 cfn c0 wss wfun cn0 wf mplrcl tdeglem1 ffun simp2 simp1
      syl mplelsfi imafi syl2anc cxp simp3 cgrp rnggrp 3ad2ant1 mpl0 neeqtrd wb
      wfn cbs eqid mplelf ffn fvex eqeltri fnsuppeq0 sylancl necon3bid cnvimass
      c0g mpbird cdm fdm syl5sseq fnimaeq0 crn imassrn syl5ss cr nn0ssre ressxr
      frn sstri syl6ss wor xrltso fisupcl mpan syl3anc eqeltrd fvelimab rexsupp
      bitrd mpbid ) FUAUBZICUBZILUCZUDZIDUEZJIUFUGMUHZUIZUJZUJZUBZAUKZIUEMUCYIJ
      UEYCULZUMABUNZYBYCYGUOUQURZYGXTXSYCYLULYABCDEFGHIJKMNOPQRSUPUSYBYGUTUBZYG
      VAUCZYGUOVBZYLYGUBZYBJVCZYFUTUBYMYBBVDJVEZYQYBKUGUBZYRXTXSYSYACEFKIOPVFUS
      ZBGHJKUGRSVGVKZBVDJVHVKYBCEFIKUAMOPQXSXTYAVIZXSXTYAVJVLJYFVMVNYBYNYFVAUCZ
      YBUUCIBYDVOZUCYBILUUDXSXTYAVPYBBEFHKMUGLORQTYTXSXTFVQUBYAFVRVSVTWAYBYFVAI
      UUDYBIBWCZMUGUBYFVAULZIUUDULWBYBBFWDUEZIVEZUUEYBCBEFHKUUGIOUUGWEPRUUBWFZB
      UUGIWGVKZMFWNUEUGQFWNWHWIBIUGMWJWKWLWOYBYGVAYFVAYBJBWCZYFBVBZYGVAULUUFWBY
      BYRUUKUUABVDJWGVKZYBIWPZYFBIYEWMYBUUHUUNBULUUIBUUGIWQVKWRZBYFJWSVNWLWOYBY
      GVDUOYBYGJWTZVDJYFXAYBYRUUPVDVBUUABVDJXFVKXBVDXCUOXDXEXGXHUOUQXIYMYNYOUDY
      PXJUOYGUQXKXLXMXNYBYHYJAYFUNZYKYBUUKUULYHUUQWBUUMUUOABYFYCJXOVNYBUUEUUQYK
      WBUUJYJABIMXPVKXQXR $.
  $}

  ${
    $d I x y $.  $d R y $.
    mdegxrcl.d $e |- D = ( I mDeg R ) $.
    mdegxrcl.p $e |- P = ( I mPoly R ) $.
    mdegxrcl.b $e |- B = ( Base ` P ) $.
    $( Closure of polynomial degree in the extended reals.  (Contributed by
       Stefan O'Rear, 19-Mar-2015.) $)
    mdegxrcl $p |- ( F e. B -> ( D ` F ) e. RR* ) $=
      ( vy vx wcel cfv cv ccnv cima cn0 cvv cxr eqid cn cfn cmap co crab ccnfld
      cgsu cmpt c0g csn cdif clt mdegval wss crn imassrn wf mplrcl tdeglem1 frn
      csup 3syl cr nn0ssre ressxr sstri syl6ss syl5ss supxrcl syl eqeltrd ) EAL
      ZEBMJKNOUAPUBLKQFUCUDUEZUFJNUGUDUHZEORDUIMZUJUKPZPZSULVAZSVMABCDJKEVNFVOG
      HIVOTVMTZVNTZUMVLVQSUNVRSLVLVQVNUOZSVNVPUPVLWAQSVLFRLVMQVNUQWAQUNACDFEHIU
      RVMJKVNFRVSVTUSVMQVNUTVBQVCSVDVEVFVGVHVQVIVJVK $.

    $d B f $.  $d B z $.  $d D f $.  $d I f $.  $d I z $.  $d R f $.  $d R z $.
    $d V f $.  $d V z $.  $d W f $.  $d W z $.  $d y z $.
    $( Functionality of polynomial degree in the extended reals.  (Contributed
       by Stefan O'Rear, 19-Mar-2015.) $)
    mdegxrf $p |- D : B --> RR* $=
      ( vf vz vy vx cxr cv cfv wcel ccnv cima co eqid wf wfn wral cfn cmap crab
      cn cn0 ccnfld cgsu cmpt cvv c0g csn cdif clt xrltso supex mdegfval fnmpti
      csup mdegxrcl rgen ffnfv mpbir2an ) AMBUABAUBINZBOMPZIAUCJAKLNQUGRUDPLUHE
      UESUFZUIKNUJSUKZJNQULDUMOZUNUORRZMUPVABMVKUPUQURVHABCDJKLVIEVJFGHVJTVHTVI
      TUSUTVGIAABCDVFEFGHVBVCIAMBVDVE $.
  $}

  ${
    $d I a b $.  $d R b $.
    mdegcl.d $e |- D = ( I mDeg R ) $.
    mdegcl.p $e |- P = ( I mPoly R ) $.
    mdegcl.b $e |- B = ( Base ` P ) $.
    $( Sharp closure for multivariate polynomials.  (Contributed by Stefan
       O'Rear, 23-Mar-2015.) $)
    mdegcl $p |- ( F e. B -> ( D ` F ) e. ( NN0 u. { -oo } ) ) $=
      ( vb va wcel cima cfn cn0 cvv cxr clt cmnf c0 cfv cv ccnv cn cmap co crab
      ccnfld cgsu cmpt c0g csn cdif csup cun eqid mdegval wceq supeq1 eleq1d wa
      wne wss crn imassrn wf mplrcl tdeglem1 frn 3syl syl5ss adantr syl6ss wfun
      ssun1 ffun id cmpl reldmmpl elbasov simprd mplelsfi imafi syl2anc nn0ssre
      simpr cr ressxr sstri wor xrltso fisupcl mpan syl3anc sseldd xrsup0 ssun2
      w3a mnfxr elexi snid sselii eqeltri a1i pm2.61ne eqeltrd ) EALZEBUAJKUBUC
      UDMNLKOFUEUFUGZUHJUBUIUFUJZEUCPDUKUAZULUMMZMZQRUNZOSULZUOZXHABCDJKEXIFXJG
      HIXJUPZXHUPZXIUPZUQXGXMXOLTQRUNZXOLZXLTXLTURXMXSXOQXLTRUSUTXGXLTVBZVAZXLX
      OXMYBXLOXOXGXLOVCYAXGXLXIVDZOXIXKVEXGFPLZXHOXIVFZYCOVCACDFEHIVGZXHJKXIFPX
      QXRVHZXHOXIVIVJVKVLZOXNVOVMYBXLNLZYAXLQVCZXMXLLZXGYIYAXGXIVNZXKNLYIXGYDYE
      YLYFYGXHOXIVPVJXGACDEFPXJHIXPXGVQXGYDDPLEACVRFDVSHIVTWAWBXIXKWCWDVLXGYAWF
      YBXLOQYHOWGQWEWHWIVMQRWJYIYAYJWRYKWKQXLRWLWMWNWOXTXGXSSXOWPXNXOSXNOWQSSQW
      SWTXAXBXCXDXEXF $.
  $}

  ${
    $d I x y $.  $d R y $.  $d V y $.
    mdeg0.d $e |- D = ( I mDeg R ) $.
    mdeg0.p $e |- P = ( I mPoly R ) $.
    mdeg0.z $e |- .0. = ( 0g ` P ) $.
    $( Degree of the zero polynomial.  (Contributed by Stefan O'Rear,
       20-Mar-2015.) $)
    mdeg0 $p |- ( ( I e. V /\ R e. Ring ) -> ( D ` .0. ) = -oo ) $=
      ( vy vx wcel cfv ccnv cima cvv cxr clt eqid c0 crg wa cv cn cfn cmap crab
      cn0 ccnfld cgsu cmpt c0g csn cdif csup cmnf cgrp cbs rnggrp mplgrp sylan2
      co wceq grpidcl mdegval 3syl cxp simpl adantl mpl0 cnveqd imaeq1d wf fvex
      wss fconst6 a1i eldifi fvconst2 syl suppss ss0 eqtrd imaeq2d ima0 supeq1d
      syl6eq xrsup0 ) DELZCUALZUBZFAMZJKUCNUDOUELKUHDUFVBUGZUIJUCZUJVBUKZFNZPCU
      LMZUMZUNZOZOZQRUOZUPWKBUQLZFBURMZLWLXBVCWJWICUQLZXCCUSZBCDEHUTVAXDBFXDSZI
      VDWMXDABCJKFWODWQGHXGWQSZWMSZWOSVEVFWKXBTQRUOUPWKQXATRWKXAWOTOTWKWTTWOWKW
      TWMWRVGZNZWSOZTWKWPXKWSWKFXJWKWMBCKDWQEFHXIXHIWIWJVHWJXEWIXFVIVJVKVLWKXLT
      VOXLTVCWKWMPJXJTWQWMPXJVMWKWMWQPCULVNZVPVQWNWMTUNLZWNXJMWQVCZWKXNWNWMLXOW
      NWMTVRWMWQWNXMVSVTVIWAXLWBVTWCWDWOWEWGWFWHWGWC $.

    mdegnn0cl.b $e |- B = ( Base ` P ) $.
    $d B x $.  $d D x $.  $d F x $.  $d I h m $.  $d R h x $.  $d .0. x $.
    $d m x $.
    $( Degree of a nonzero polynomial.  (Contributed by Stefan O'Rear,
       23-Mar-2015.) $)
    mdegnn0cl $p |- ( ( R e. Ring /\ F e. B /\ F =/= .0. ) ->
        ( D ` F ) e. NN0 ) $=
      ( vx vh vm wcel wne cv cfv cn0 eqid crg w3a c0g ccnv cn cima cmap co crab
      cfn ccnfld cgsu cmpt wceq wa wrex mdegldg cvv wf mplrcl 3ad2ant2 tdeglem1
      syl ffvelrnda eleq1 syl5ibcom adantld rexlimdva mpd ) DUAOZEAOZEGPZUBZLQZ
      ERDUCRZPZVNMNQUDUEUFUJONSFUGUHUIZUKMQULUHUMZRZEBRZUNZUOZLVQUPVTSOZLVQABCD
      MNEVRFGVOHIKVOTVQTZVRTZJUQVMWBWCLVQVMVNVQOUOZWAWCVPWFVSSOWAWCVMVQSVNVRVMF
      UROZVQSVRUSVKVJWGVLACDFEIKUTVAVQMNVRFURWDWEVBVCVDVSVTSVEVFVGVHVI $.
  $}

  $( Theorem on arithmetic of extended reals useful for degrees.  (Contributed
     by Stefan O'Rear, 23-Mar-2015.) $)
  degltlem1 $p |- ( ( X e. ( NN0 u. { -oo } ) /\ Y e. ZZ ) ->
      ( X < Y <-> X <_ ( Y - 1 ) ) ) $=
    ( cn0 cmnf csn cun wcel wo cz clt wbr c1 cmin co cle wb elun nn0z syl breq1
    zltlem1 sylan cr zre mnflt cxr peano2zm zred rexrd mnfle 2thd elsni bibi12d
    wceq syl5ibrcom impcom jaoian sylanb ) ACDEZFGACGZAUSGZHBIGZABJKZABLMNZOKZP
    ZACUSQUTVBVFVAUTAIGVBVFARABUAUBVBVAVFVBVFVADBJKZDVDOKZPZVBVGVHVBBUCGVGBUDBU
    ESVBVDUFGVHVBVDVBVDBUGUHUIVDUJSUKVAADUNZVFVIPADULVJVCVGVEVHADBJTADVDOTUMSUO
    UPUQUR $.

  $( Theorem on arithmetic of extended reals useful for degrees.  (Contributed
     by Stefan O'Rear, 1-Apr-2015.) $)
  degltp1le $p |- ( ( X e. ( NN0 u. { -oo } ) /\ Y e. ZZ ) ->
      ( X < ( Y + 1 ) <-> X <_ Y ) ) $=
    ( cn0 cmnf csn cun wcel cz wa c1 caddc co clt wbr cmin wb peano2z degltlem1
    cle cc sylan2 wceq zcn ax-1cn pncan sylancl breq2d adantl bitrd ) ACDEFGZBH
    GZIABJKLZMNZAULJOLZSNZABSNZUKUJULHGUMUOPBQAULRUAUKUOUPPUJUKUNBASUKBTGJTGUNB
    UBBUCUDBJUEUFUGUHUI $.

  ${
    mdegaddle.y $e |- Y = ( I mPoly R ) $.
    mdegaddle.d $e |- D = ( I mDeg R ) $.
    mdegaddle.i $e |- ( ph -> I e. V ) $.
    mdegaddle.r $e |- ( ph -> R e. Ring ) $.

    ${
      $d ph c $.  $d B c $.  $d D c $.  $d F c $.  $d G c $.  $d I a b c $.
      $d .+ c $.  $d R b c $.  $d V b $.
      mdegaddle.b $e |- B = ( Base ` Y ) $.
      mdegaddle.p $e |- .+ = ( +g ` Y ) $.
      mdegaddle.f $e |- ( ph -> F e. B ) $.
      mdegaddle.g $e |- ( ph -> G e. B ) $.
      $( The degree of a sum is at most the maximum of the degrees of the
         factors.  (Contributed by Stefan O'Rear, 26-Mar-2015.) $)
      mdegaddle $p |- ( ph -> ( D ` ( F .+ G ) ) <_
            if ( ( D ` F ) <_ ( D ` G ) , ( D ` G ) , ( D ` F ) ) ) $=
        ( cfv wcel vc vb va co cle wbr cif cv ccnv cn cima cfn cmap crab ccnfld
        cn0 cgsu cmpt clt c0g wceq wi wral cplusg cof eqid mpladd fveq1d adantr
        wa wfn cvv cbs wf mplelf ffn syl ovex rabex simpr fnfvof syl22anc eqtrd
        a1i adantrr simprl cxr mdegxrcl ifcl syl2anc cr nn0ssre ressxr tdeglem1
        w3a ffvelrnda sseldi 3jca xrmax1 simprr jca xrlelttr sylc mdeglt xrmax2
        sstri oveq12d cgrp rnggrp rng0cl grplid expr ralrimiva wb mplrng rngacl
        crg syl3anc mdegleb mpbird ) AFGDUDZCSFCSZGCSZUEUFZYCYBUGZUEUFZYEUAUHZU
        BUCUHUIUJUKULTZUCUPHUMUDZUNZUOUBUHUQUDURZSZUSUFZYGYASZEUTSZVAZVBZUAYJVC
        ZAYQUAYJAYGYJTZYMYPAYSYMVJZVJZYNYGFSZYGGSZEVDSZUDZYOAYSYNUUEVAYMAYSVJZY
        NYGFGUUDVEUDZSZUUEAYNUUHVAYSAYGYAUUGABJUUDDEHFGKOUUDVFZPQRVGVHVIUUFFYJV
        KZGYJVKZYJVLTZYSUUHUUEVAAUUJYSAYJEVMSZFVNUUJABYJJEUCHUUMFKUUMVFZOYJVFZQ
        VOYJUUMFVPVQVIAUUKYSAYJUUMGVNUUKABYJJEUCHUUMGKUUNOUUORVOYJUUMGVPVQVIUUL
        UUFYHUCYIUPHUMVRVSWDAYSVTYJUUDFGVLYGWAWBWCWEUUAUUEYOYOUUDUDZYOUUAUUBYOU
        UCYOUUDUUAYJBCJEUBUCFYKHYGYOLKOYOVFZUUOYKVFZAFBTZYTQVIAYSYMWFZUUAYBWGTZ
        YEWGTZYLWGTZWOZYBYEUEUFZYMVJYBYLUSUFAYSUVDYMUUFUVAUVBUVCAUVAYSAUUSUVAQB
        CJEFHLKOWHVQZVIAUVBYSAYCWGTZUVAUVBAGBTZUVGRBCJEGHLKOWHVQZUVFYDYCYBWGWIW
        JZVIZUUFUPWGYLUPWKWGWLWMXFAYJUPYGYKAHITZYJUPYKVNMYJUBUCYKHIUUOUURWNVQWP
        WQZWRWEUUAUVEYMAUVEYTAUVAUVGUVEUVFUVIYBYCWSWJVIAYSYMWTZXAYBYEYLXBXCXDUU
        AYJBCJEUBUCGYKHYGYOLKOUUQUUOUURAUVHYTRVIUUTUUAUVGUVBUVCWOZYCYEUEUFZYMVJ
        YCYLUSUFAYSUVOYMUUFUVGUVBUVCAUVGYSUVIVIUVKUVMWRWEUUAUVPYMAUVPYTAUVAUVGU
        VPUVFUVIYBYCXEWJVIUVNXAYCYEYLXBXCXDXGAUUPYOVAZYTAEXHTZYOUUMTZUVQAEXQTZU
        VRNEXIVQAUVTUVSNUUMEYOUUNUUQXJVQUUMUUDEYOYOUUNUUIUUQXKWJVIWCWCXLXMAYABT
        ZUVBYFYRXNAJXQTZUUSUVHUWAAUVLUVTUWBMNJEHIKXOWJQRBDJFGOPXPXRUVJUAYJBCJEU
        BUCYAYEYKHYOLKOUUQUUOUURXSWJXT $.
    $}

    ${
      $d ph x $.  $d B x $.  $d D x $.  $d F x $.  $d G x $.  $d I a b x $.
      $d .x. x $.  $d R b x $.
      mdegvscale.b $e |- B = ( Base ` Y ) $.
      mdegvscale.k $e |- K = ( Base ` R ) $.
      mdegvscale.p $e |- .x. = ( .s ` Y ) $.
      mdegvscale.f $e |- ( ph -> F e. K ) $.
      mdegvscale.g $e |- ( ph -> G e. B ) $.
      $( The degree of a scalar multiple of a polynomial is at most the degree
         of the original polynomial.  (Contributed by Stefan O'Rear,
         26-Mar-2015.) $)
      mdegvscale $p |- ( ph -> ( D ` ( F .x. G ) ) <_ ( D ` G ) ) $=
        ( vx vb va co cfv cle wbr cv ccnv cn cima cfn wcel cn0 cmap crab ccnfld
        cgsu cmpt clt c0g wceq wi wral wa cmulr adantr simpr mplvscaval adantrr
        eqid simprl simprr mdeglt oveq2d crg rngrz syl2anc 3eqtrd ralrimiva cxr
        expr wb clmod cbs mpllmod mplsca fveq2d syl5eq eleqtrd lmodvscl syl3anc
        csca mdegxrcl syl mdegleb mpbird ) AFGEUDZCUEGCUEZUFUGZWSUAUHZUBUCUHUIU
        JUKULUMUCUNHUOUDUPZUQUBUHURUDUSZUEUTUGZXAWRUEZDVAUEZVBZVCZUAXBVDZAXHUAX
        BAXAXBUMZXDXGAXJXDVEZVEZXEFXAGUEZDVFUEZUDZFXFXNUDZXFAXJXEXOVBXDAXJVEBXB
        KDEXNUCGHIFXALRQPXNVKZXBVKZAFIUMZXJSVGAGBUMZXJTVGAXJVHVIVJXLXMXFFXNXLXB
        BCKDUBUCGXCHXAXFMLPXFVKZXRXCVKZAXTXKTVGAXJXDVLAXJXDVMVNVOAXPXFVBZXKADVP
        UMZXSYCOSIDXNFXFQXQYAVQVRVGVSWBVTAWRBUMZWSWAUMZWTXIWCAKWDUMZFKWMUEZWEUE
        ZUMXTYEAHJUMYDYGNOKDHJLWFVRAFIYISAIDWEUEYIQADYHWEAKDHJVPLNOWGWHWIWJTFEY
        HYIBKGPYHVKRYIVKWKWLAXTYFTBCKDGHMLPWNWOUAXBBCKDUBUCWRWSXCHXFMLPYAXRYBWP
        VRWQ $.
    $}

    ${
      $d I x y $.  $d R y $.
      mdegvsca.b $e |- B = ( Base ` Y ) $.
      mdegvsca.e $e |- E = ( RLReg ` R ) $.
      mdegvsca.p $e |- .x. = ( .s ` Y ) $.
      mdegvsca.f $e |- ( ph -> F e. E ) $.
      mdegvsca.g $e |- ( ph -> G e. B ) $.
      $( The degree of a scalar multiple of a polynomial is exactly the degree
         of the original polynomial when the multiple is a non-zero-divisor.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      mdegvsca $p |- ( ph -> ( D ` ( F .x. G ) ) = ( D ` G ) ) $=
        ( vy vx cv ccnv cn cima cfn wcel cn0 cmap crab ccnfld cgsu cmpt cvv c0g
        co cfv csn cdif cxr clt csup cxp cmulr cof cbs eqid rrgss sseldi cnveqd
        mplvsca imaeq1d ovex rabex a1i rrgsupp eqtrd imaeq2d supeq1d wceq clmod
        mplelf csca crg mpllmod syl2anc mplsca eleqtrd lmodvscl syl3anc mdegval
        fveq2d syl 3eqtr4d ) AUAUBUCUDUEUFUGUHZUBUIIUJUQZUKZULUAUCUMUQUNZGHEUQZ
        UDZUODUPURZUSUTZUFZUFZVAVBVCZWSHUDXCUFZUFZVAVBVCZWTCURZHCURZAVAXEXHVBAX
        DXGWSAXDWRGUSVDHDVEURZVFUQZUDZXCUFXGAXAXNXCAWTXMABWRKDEXLUBHIDVGURZGLRX
        OVHZPXLVHZWRVHZAFXOGXODFQXPVISVJZTVLVKVMAXODXLFWRUOGHXBQXPXQXBVHZWRUOUH
        AWPUBWQUIIUJVNVOVPOSABWRKDUBIXOHLXPPXRTWCVQVRVSVTAWTBUHZXJXFWAAKWBUHZGK
        WDURZVGURZUHHBUHZYAAIJUHDWEUHYBNOKDIJLWFWGAGXOYDXSADYCVGAKDIJWELNOWHWMW
        ITGEYCYDBKHPYCVHRYDVHWJWKWRBCKDUAUBWTWSIXBMLPXTXRWSVHZWLWNAYEXKXIWATWRB
        CKDUAUBHWSIXBMLPXTXRYFWLWNWO $.
    $}

    ${
      $d ph x $.  $d B x $.  $d F x $.  $d I a b x $.  $d R a b x $.  $d V b $.
      mdegle0.b $e |- B = ( Base ` Y ) $.
      mdegle0.a $e |- A = ( algSc ` Y ) $.
      mdegle0.f $e |- ( ph -> F e. B ) $.
      $( A polynomial has nonpositive degree iff it is a constant.
         (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
      mdegle0 $p |- ( ph -> ( ( D ` F ) <_ 0 <->
            F = ( A ` ( F ` ( I X. { 0 } ) ) ) ) ) $=
        ( vx cc0 wcel wceq vb va cfv cle wbr cv ccnv cn cima cfn cmap co ccnfld
        cn0 crab cgsu cmpt clt c0g wi wral csn cxp cxr 0xr eqid mdegleb sylancl
        wb cif wa wn wne cr tdeglem1 syl ffvelrnda nn0re nn0ge0 jca ne0gt0 3syl
        tdeglem4 sylan necon3abid bitr3d imbi1d eqeq2 bibi1d pm2.24 2thd adantl
        fveq2 biimt ifbothda adantr bitr4d ralbidva cbs mplelf feqmptd ffvelrnd
        wf psrbag0 mplascl eqeq12d cvv fvex rgenw mpteqb mp1i bitrd ) AFDUCRUDU
        EZRQUFZUAUBUFUGUHUIUJSUBUNGUKULUOZUMUAUFUPULUQZUCZURUEZXNFUCZEUSUCZTZUT
        ZQXOVAZFGRVBVCZFUCZBUCZTZAFCSRVDSXMYCVIPVEQXOCDIEUAUBFRXPGXTKJNXTVFZXOV
        FZXPVFZVGVHAYCXSXNYDTZYEXTVJZTZQXOVAZYGAYBYMQXOAXNXOSZVKZYBYKVLZYAUTZYM
        YPXRYQYAYPXQRVMZXRYQYPXQUNSZXQVNSZRXQUDUEZVKYSXRVIAXOUNXNXPAGHSZXOUNXPX
        CLXOUAUBXPGHYIYJVOVPVQYTUUAUUBXQVRXQVSVTXQWAWBYPYKXQRAUUCYOXQRTYKVILXOU
        AUBXPGHXNYIYJWCWDWEWFWGAYMYRVIZYOYKXSYETZYRVIZYAYRVIZUUDAYEXTYEYLTUUEYM
        YRYEYLXSWHWIXTYLTYAYMYRXTYLXSWHWIYKUUFAYKUUEYRXNYDFWMYKYAWJWKWLYQUUGAYQ
        YAWNWLWOWPWQWRAYGQXOXSUQZQXOYLUQZTZYNAFUUHYFUUIAQXOEWSUCZFACXOIEUBGUUKF
        JUUKVFZNYIPWTZXAAQBUUKXOIEUBGHYEXTJYIYHUULOLMAXOUUKYDFUUMAUUCYDXOSLXOUB
        GHYIXDVPXBXEXFXSXGSZQXOVAUUJYNVIAUUNQXOXNFXHXIQXOXSYLXGXJXKXLWQXL $.
    $}

    ${
      $d ph c d x $.  $d B x $.  $d F c d x $.  $d G c d x $.  $d I a b d x $.
      $d I c e $.  $d J d x $.  $d K d x $.  $d R b d x $.  $d R c $.
      $d .x. x $.  $d V b $.  $d a c e $.  $d d e $.  $d e x $.
      mdegmulle2.b $e |- B = ( Base ` Y ) $.
      mdegmulle2.t $e |- .x. = ( .r ` Y ) $.
      mdegmulle2.f $e |- ( ph -> F e. B ) $.
      mdegmulle2.g $e |- ( ph -> G e. B ) $.
      mdegmulle2.j1 $e |- ( ph -> J e. NN0 ) $.
      mdegmulle2.k1 $e |- ( ph -> K e. NN0 ) $.
      mdegmulle2.j2 $e |- ( ph -> ( D ` F ) <_ J ) $.
      mdegmulle2.k2 $e |- ( ph -> ( D ` G ) <_ K ) $.
      ${
        $d A b $.  $d A c $.  $d A d $.  $d A e $.  $d A x $.  $d H d $.
        $d H x $.  $d V e $.
        mdegmullem.a $e |- A = { a e. ( NN0 ^m I ) | ( `' a " NN ) e. Fin } $.
        mdegmullem.h $e |- H = ( b e. A |-> ( CCfld gsum b ) ) $.
        $( Lemma for ~ mdegmulle2 .  (Contributed by Stefan O'Rear,
           26-Mar-2015.) $)
        mdegmullem $p |- ( ph -> ( D ` ( F .x. G ) ) <_ ( J + K ) ) $=
          ( vx vc vd ve co cfv caddc cle wbr cv clt wceq wi wral wcel cofr crab
          c0g wa cmin cof cmulr cmpt cgsu eqid mplmul fveq1d adantr breq2 oveq1
          rabbidv fveq2d oveq2d mpteq12dv fvmpt ad2antrl ad2antrr elrabi adantl
          ovex adantrr cxr w3a mdegxrcl syl cn0 cr ressxr sstri sseldi tdeglem1
          nn0ssre wf ffvelrnd 3jca anim1i anasss xrlelttr mdeglt oveq1d crg cbs
          mplelf ssrab2 simplrl simpr psrbagconcl syl3anc rnglz syl2anc anassrs
          sylc eqtrd rngrz wo simplrr nn0red psrbagf ffvelrnda nn0cnd mpteq2dva
          wn cvv fvex a1i feqmptd offval2 lenltd cmap rabex le2add simp1 eqtr3d
          syl22anc tdeglem3 3adant3 3adant2 pncan3d 3eqtr4d breq1d sylibd ioran
          anbi12d syl6bbr nn0addcld 3imtr3d mt4d mpjaodan cmnd rngmnd ccnv cima
          cn cfn eqeltri gsumz sylancl 3eqtrd ralrimiva wb mplrng rngcl mdegleb
          expr mpbird ) AGHFUOZDUPKLUQUOZURUSZUVQUKUTZIUPZVAUSZUVSUVPUPZEVHUPZV
          BZVCZUKBVDZAUWEUKBAUVSBVEZUWAUWDAUWGUWAVIZVIZUWBUVSULBEUMUNUTZULUTZUR
          VFZUSZUNBVGZUMUTZGUPZUWKUWOVJVKZUOZHUPZEVLUPZUOZVMZVNUOZVMZUPZEUMUWJU
          VSUWLUSZUNBVGZUWPUVSUWOUWQUOZHUPZUWTUOZVMZVNUOZUWCAUWBUXEVBUWHAUVSUVP
          UXDAUMUNCBNEFUWTOULGHJQUAUWTVOZUBUIUCUDVPVQVRUWGUXEUXLVBAUWAULUVSUXCU
          XLBUXDUWKUVSVBZUXBUXKEVNUXNUMUWNUXAUXGUXJUXNUWMUXFUNBUWKUVSUWJUWLVSWA
          UXNUWSUXIUWPUWTUXNUWRUXHHUWKUVSUWOUWQVTWBWCWDWCUXDVOEUXKVNWJWEWFUWIUX
          LEUMUXGUWCVMZVNUOZUWCUWIUXKUXOEVNUWIUMUXGUXJUWCUWIUWOUXGVEZVIZKUWOIUP
          ZVAUSZUXJUWCVBZLUXHIUPZVAUSZUWIUXQUXTUYAUWIUXQUXTVIZVIZUXJUWCUXIUWTUO
          ZUWCUYEUWPUWCUXIUWTUYEBCDNEPOGIJUWOUWCRQUAUWCVOZUIUJAGCVEZUWHUYDUCWGU
          WIUXQUWOBVEZUXTUXQUYIUWIUXFUNUWOBWHWIZWKUYEGDUPZWLVEZKWLVEZUXSWLVEZWM
          ZUYKKURUSZUXTVIZUYKUXSVAUSUWIUXQUYOUXTUXRUYLUYMUYNAUYLUWHUXQAUYHUYLUC
          CDNEGJRQUAWNWOWGAUYMUWHUXQAWPWLKWPWQWLXBWRWSZUEWTWGUXRWPWLUXSUYRUXRBW
          PUWOIABWPIXCZUWHUXQAJMVEZUYSSBPOIJMUIUJXAWOWGZUYJXDZWTXEWKUWIUXQUXTUY
          QUXRUYPUXTAUYPUWHUXQUGWGXFXGUYKKUXSXHYBXIXJUWIUXQUYFUWCVBZUXTUXREXKVE
          ZUXIEXLUPZVEVUCAVUDUWHUXQTWGZUXRBVUEUXHHABVUEHXCUWHUXQACBNEOJVUEHQVUE
          VOZUAUIUDXMWGUXRUXGBUXHUXFUNBXNUXRUYTUWGUXQUXHUXGVEAUYTUWHUXQSWGZAUWG
          UWAUXQXOZUWIUXQXPUNBUXGOUVSJMUWOUIUXGVOXQXRWTZXDVUEEUWTUXIUWCVUGUXMUY
          GXSXTWKYCYAUWIUXQUYCUYAUWIUXQUYCVIZVIZUXJUWPUWCUWTUOZUWCVULUXIUWCUWPU
          WTVULBCDNEPOHIJUXHUWCRQUAUYGUIUJAHCVEZUWHVUKUDWGUWIUXQUXHBVEZUYCVUJWK
          VULHDUPZWLVEZLWLVEZUYBWLVEZWMZVUPLURUSZUYCVIZVUPUYBVAUSUWIUXQVUTUYCUX
          RVUQVURVUSAVUQUWHUXQAVUNVUQUDCDNEHJRQUAWNWOWGAVURUWHUXQAWPWLLUYRUFWTW
          GUXRWPWLUYBUYRUXRBWPUXHIVUAVUJXDZWTXEWKUWIUXQUYCVVBUXRVVAUYCAVVAUWHUX
          QUHWGXFXGVUPLUYBXHYBXIWCUWIUXQVUMUWCVBZUYCUXRVUDUWPVUEVEVVDVUFUXRBVUE
          UWOGABVUEGXCUWHUXQACBNEOJVUEGQVUGUAUIUCXMWGUYJXDVUEEUWTUWPUWCVUGUXMUY
          GYDXTWKYCYAUXRUWAUXTUYCYEZAUWGUWAUXQYFUXRUXSKURUSZUYBLURUSZVIZUVTUVQU
          RUSZVVEYLZUWAYLUXRVVHUXSUYBUQUOZUVQURUSZVVIUXRUXSWQVEUYBWQVEKWQVELWQV
          EVVHVVLVCUXRUXSVUBYGZUXRUYBVVCYGZUXRKAKWPVEUWHUXQUEWGYGZUXRLALWPVEUWH
          UXQUFWGYGZUXSUYBKLUUAUUDUXRVVKUVTUVQURUXRUWOUXHUQVKUOZIUPZVVKUVTUXRUY
          TUYIVUOVVRVVKVBVUHUYJVUJBPOIJMUWOUXHUIUJUUEXRUXRVVQUVSIUXRUYTUYIUWGVV
          QUVSVBVUHUYJVUIUYTUYIUWGWMZPJPUTZUWOUPZVVTUVSUPZVWAVJUOZUQUOZVMPJVWBV
          MVVQUVSVVSPJVWDVWBVVSVVTJVEVIZVWAVWBVWEVWAVVSJWPVVTUWOUYTUYIJWPUWOXCU
          WGBOUWOJMUIYHUUFZYIYJVWEVWBVVSJWPVVTUVSUYTUWGJWPUVSXCUYIBOUVSJMUIYHUU
          GZYIYJUUHYKVVSPJVWAVWCUQUWOUXHMYMYMUYTUYIUWGUUBZVWAYMVEVWEVVTUWOYNYOZ
          VWCYMVEVWEVWBVWAVJWJYOVVSPJWPUWOVWFYPZVVSPJVWBVWAVJUVSUWOMYMYMVWHVWBY
          MVEVWEVVTUVSYNYOVWIVVSPJWPUVSVWGYPZVWJYQYQVWKUUIXRWBUUCUUJUUKUXRVVHUX
          TYLZUYCYLZVIVVJUXRVVFVWLVVGVWMUXRUXSKVVMVVOYRUXRUYBLVVNVVPYRUUMUXTUYC
          UULUUNUXRUVTUVQUXRUVTUXRBWPUVSIVUAVUIXDYGUXRUVQAUVQWPVEUWHUXQAKLUEUFU
          UOZWGYGYRUUPUUQUURYKWCUWIEUUSVEZUXGYMVEUXPUWCVBAVWOUWHAVUDVWOTEUUTWOV
          RUXFUNBBOUTUVAUVCUVBUVDVEZOWPJYSUOZVGYMUIVWPOVWQWPJYSWJYTUVEYTUXGUMEY
          MUWCUYGUVFUVGYCUVHUVNUVIAUVPCVEZUVQWLVEUVRUWFUVJANXKVEZUYHVUNVWRAUYTV
          UDVWSSTNEJMQUVKXTUCUDCNFGHUAUBUVLXRAWPWLUVQUYRVWNWTUKBCDNEPOUVPUVQIJU
          WCRQUAUYGUIUJUVMXTUVO $.
      $}

      $( The multivariate degree of a product of polynomials is at most the sum
         of the degrees of the polynomials.  (Contributed by Stefan O'Rear,
         26-Mar-2015.) $)
      mdegmulle2 $p |- ( ph -> ( D ` ( F .x. G ) ) <_ ( J + K ) ) $=
        ( va vb cv ccnv cn cima cfn wcel cn0 cmap co crab ccnfld cgsu cmpt eqid
        mdegmullem ) AUEUGUHUIUJUKULUEUMHUNUOUPZBCDEFGUFVBUQUFUGURUOUSZHIJKLUEU
        FMNOPQRSTUAUBUCUDVBUTVCUTVA $.
    $}
  $}

  ${
    $d R r $.
    deg1fval.d $e |- D = ( deg1 ` R ) $.
    $( Relate univariate polynomial degree to multivariate.  (Contributed by
       Stefan O'Rear, 23-Mar-2015.)  (Revised by Mario Carneiro,
       7-Oct-2015.) $)
    deg1fval $p |- D = ( 1o mDeg R ) $=
      ( vr cdg1 cfv c1o cmdg co cvv wcel wceq cv oveq2 df-deg1 ovex fvmpt wn c0
      fvprc reldmmdeg ovprc2 eqtr4d pm2.61i eqtri ) ABEFZGBHIZCBJKZUFUGLDBGDMZH
      IUGJEUIBGHNDOGBHPQUHRUFSUGBETGBHUAUBUCUDUE $.
  $}

  ${
    deg1xrf.d $e |- D = ( deg1 ` R ) $.
    deg1xrf.p $e |- P = ( Poly1 ` R ) $.
    deg1xrf.b $e |- B = ( Base ` P ) $.
    $( Functionality of univariate polynomial degree, weak range.  (Contributed
       by Stefan O'Rear, 23-Mar-2015.) $)
    deg1xrf $p |- D : B --> RR* $=
      ( c1o cmpl co deg1fval eqid cps1 cfv ply1bas mdegxrf ) ABHDIJZDHBDEKQLCDD
      MNZAFRLGOP $.

    $( Closure of univariate polynomial degree in extended reals.  (Contributed
       by Stefan O'Rear, 23-Mar-2015.) $)
    deg1xrcl $p |- ( F e. B -> ( D ` F ) e. RR* ) $=
      ( cxr deg1xrf ffvelrni ) AIEBABCDFGHJK $.

    $( Sharp closure of univariate polynomial degree.  (Contributed by Stefan
       O'Rear, 23-Mar-2015.) $)
    deg1cl $p |- ( F e. B -> ( D ` F ) e. ( NN0 u. { -oo } ) ) $=
      ( c1o cmpl co deg1fval eqid cps1 cfv ply1bas mdegcl ) ABIDJKZDEIBDFLRMCDD
      NOZAGSMHPQ $.
  $}

  ${
    $d ph c $.  $d ph x y $.  $d B x y $.  $d I a b $.  $d I c $.  $d R b c $.
    $d R x y $.  $d S b c $.  $d S x y $.  $d V c $.  $d W c $.
    mdegpropd.b1 $e |- ( ph -> B = ( Base ` R ) ) $.
    mdegpropd.b2 $e |- ( ph -> B = ( Base ` S ) ) $.
    mdegpropd.p $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` R ) y ) = ( x ( +g ` S ) y ) ) $.
    $( Property deduction for polynomial degree.  (Contributed by Stefan
       O'Rear, 28-Mar-2015.) $)
    mdegpropd $p |- ( ph -> ( I mDeg R ) = ( I mDeg S ) ) $=
      ( vc vb va co cfv cv cima cmpt cvv eqid cmpl cbs ccnv cfn wcel cn0 ccnfld
      cn cmap crab cgsu c0g csn cdif cxr csup cmdg mplbaspropd grpidpropd sneqd
      clt difeq2d imaeq2d supeq1d mpteq12dv mdegfval 3eqtr4g ) AKGEUANZUBOZLMPU
      CUHQUDUEMUFGUINUJZUGLPUKNRZKPUCZSEULOZUMZUNZQZQZUOVAUPZRKGFUANZUBOZVKVLSF
      ULOZUMZUNZQZQZUOVAUPZRGEUQNZGFUQNZAKVIVRVTWFABCDEFGHIJURAUOVQWEVAAVPWDVKA
      VOWCVLAVNWBSAVMWAABCDEFHIJUSUTVBVCVCVDVEVJVIWGVHEKLMVKGVMWGTVHTVITVMTVJTZ
      VKTZVFVJVTWHVSFKLMVKGWAWHTVSTVTTWATWIWJVFVG $.
  $}

  $( Univariate polynomial degree respects protection.  (Contributed by Stefan
     O'Rear, 28-Mar-2015.) $)
  deg1fvi $p |- ( deg1 ` R ) = ( deg1 ` ( _I ` R ) ) $=
    ( cid cfv cdg1 cvv wcel wceq fvi fveq2d wn c0 wfn wf cpl1 00ply1bas deg1xrf
    cxr eqid ffn fvprc ax-mp fn0 mpbi 3eqtr4a pm2.61i eqcomi ) ABCZDCZADCZAEFZU
    HUIGUJUGADAEHIUJJZKDCZKUHUIULKLZULKGKQULMUMKULKNCZKULRUNROPKQULSUAULUBUCUKU
    GKDABTIADTUDUEUF $.

  ${
    $d ph x y $.  $d B x y $.  $d R x y $.  $d S x y $.
    deg1propd.b1 $e |- ( ph -> B = ( Base ` R ) ) $.
    deg1propd.b2 $e |- ( ph -> B = ( Base ` S ) ) $.
    deg1propd.p $e |- ( ( ph /\ ( x e. B /\ y e. B ) ) ->
        ( x ( +g ` R ) y ) = ( x ( +g ` S ) y ) ) $.
    $( Property deduction for polynomial degree.  (Contributed by Stefan
       O'Rear, 28-Mar-2015.) $)
    deg1propd $p |- ( ph -> ( deg1 ` R ) = ( deg1 ` S ) ) $=
      ( c1o cmdg co cdg1 cfv mdegpropd eqid deg1fval 3eqtr4g ) AJEKLJFKLEMNZFMN
      ZABCDEFJGHIOSESPQTFTPQR $.
  $}

  ${
    deg1z.d $e |- D = ( deg1 ` R ) $.
    deg1z.p $e |- P = ( Poly1 ` R ) $.
    deg1z.z $e |- .0. = ( 0g ` P ) $.
    $( Degree of the zero univariate polynomial.  (Contributed by Stefan
       O'Rear, 23-Mar-2015.) $)
    deg1z $p |- ( R e. Ring -> ( D ` .0. ) = -oo ) $=
      ( c1o con0 wcel crg cfv cmnf wceq 1on cmpl co deg1fval eqid ply1mpl0 mpan
      mdeg0 ) HIJCKJDALMNOAHCPQZCHIDACERUCSZBCUCDUDFGTUBUA $.

    deg1nn0cl.b $e |- B = ( Base ` P ) $.
    $( Degree of a nonzero univariate polynomial.  (Contributed by Stefan
       O'Rear, 23-Mar-2015.)  (Revised by Mario Carneiro, 7-Oct-2015.) $)
    deg1nn0cl $p |- ( ( R e. Ring /\ F e. B /\ F =/= .0. ) ->
        ( D ` F ) e. NN0 ) $=
      ( c1o cmpl co deg1fval eqid ply1mpl0 cps1 cfv ply1bas mdegnn0cl ) ABKDLMZ
      DEKFBDGNUAOZCDUAFUBHIPCDDQRZAHUCOJST $.

    ${
      $d B x $.  $d D x $.  $d R x $.  $d .0. x $.
      $( Degree image of a set of polynomials whcih does not include zero.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      deg1n0ima $p |- ( R e. Ring -> ( D " ( B \ { .0. } ) ) C_ NN0 ) $=
        ( vx crg wcel cv cfv cn0 csn cdif wss adantl cxr wral cima wa wne simpl
        eldifi eldifsni deg1nn0cl syl3anc ralrimiva wfun cdm wb wf deg1xrf ffun
        ax-mp difss fdmi sseqtr4i funimass4 mp2an sylibr ) DKLZJMZBNOLZJAEPZQZU
        AZBVHUBORZVDVFJVHVDVEVHLZUCVDVEALZVEEUDZVFVDVKUEVKVLVDVEAVGUFSVKVMVDVEA
        EUGSABCDVEEFGHIUHUIUJBUKZVHBULZRVJVIUMATBUNVNABCDFGIUOZATBUPUQVHAVOAVGU
        RATBVPUSUTJVHOBVAVBVC $.
    $}

    $( A polynomial is nonzero iff it has definite degree.  (Contributed by
       Stefan O'Rear, 23-Mar-2015.) $)
    deg1nn0clb $p |- ( ( R e. Ring /\ F e. B ) ->
        ( F =/= .0. <-> ( D ` F ) e. NN0 ) ) $=
      ( crg wcel wa cfv cn0 wn wceq cmnf cr eleq1d deg1nn0cl 3expia mnfnre neli
      wne nn0re mto deg1z adantr mtbiri fveq2 notbid syl5ibrcom necon2ad impbid
      ) DKLZEALZMZEFUEZEBNZOLZUPUQUSVAABCDEFGHIJUAUBURVAEFURVAPEFQZFBNZOLZPURVD
      ROLZVERSLRSUCUDRUFUGURVCROUPVCRQUQBCDFGHIUHUITUJVBVAVDVBUTVCOEFBUKTULUMUN
      UO $.

    $( A polynomial is zero iff it has negative degree.  (Contributed by Stefan
       O'Rear, 1-Apr-2015.) $)
    deg1lt0 $p |- ( ( R e. Ring /\ F e. B ) ->
      ( ( D ` F ) < 0 <-> F = .0. ) ) $=
      ( crg wcel wa cfv cc0 clt wbr wceq wne cmnf w3a cn0 deg1nn0cl nn0nlt0 syl
      wn 3expia necon4ad deg1z 0re mnflt ax-mp syl6eqbr adantr fveq2 syl5ibrcom
      cr breq1d impbid ) DKLZEALZMZEBNZOPQZEFRZVBVDEFUTVAEFSZVDUFZUTVAVFUAVCUBL
      VGABCDEFGHIJUCVCUDUEUGUHVBVDVEFBNZOPQZUTVIVAUTVHTOPBCDFGHIUIOUQLTOPQUJOUK
      ULUMUNVEVCVHOPEFBUOURUPUS $.

    ${
      $d A b d $.  $d B b $.  $d D b d $.  $d F b d $.  $d R b $.
      $d Y a b d $.  $d .0. b $.  $d a c $.
      deg1ldg.y $e |- Y = ( 0g ` R ) $.
      deg1ldg.a $e |- A = ( coe1 ` F ) $.
      $( A nonzero univariate polynomial always has a nonzero leading
         coefficient.  (Contributed by Stefan O'Rear, 23-Mar-2015.) $)
      deg1ldg $p |- ( ( R e. Ring /\ F e. B /\ F =/= .0. ) ->
          ( A ` ( D ` F ) ) =/= Y ) $=
        ( vb va wne cfv cn0 c0 vc vd crg wcel w3a cv c1o cmap co cmpt wceq wrex
        wa cmpl deg1fval eqid cps1 ply1bas psr1baslem tdeglem2 ply1mpl0 mdegldg
        fvcoe1 fveq1 fvex fvmpt fveq2d adantl eqtr4d neeq1d anbi1d ancom syl6bb
        3ad2antl2 rexbidva wf1o wfo df1o2 nn0ex 0ex mapsnf1o2 f1ofo eqeq1 fveq2
        wb anbi12d cbvexfo mp2b deg1nn0cl ceqsrexv syl bitrd mpbid ) EUCUDZFBUD
        ZFHQZUEZOUFZFRZGQZWRPSUGUHUIZTPUFZRZUJZRZFCRZUKZUMZOXAULZXFARZGQZOXABCU
        GEUNUIZEPUAFXDUGHGCEIUOXLUPZDEEUQRZBJXNUPLURMUAUSPUTDEXLHXMJKVAVBWQXIUB
        UFZXFUKZXOARZGQZUMZUBSULZXKWQXIXGXEARZGQZUMZOXAULZXTWQXHYCOXAWQWRXAUDZU
        MZXHYBXGUMYCYFWTYBXGYFWSYAGYFWSTWRRZARZYAWOWNYEWSYHUKWPAFBWRNVCVNYEYAYH
        UKWQYEXEYGAPWRXCYGXAXDTXBWRVDXDUPZTWRVEVFVGVHVIVJVKYBXGVLVMVOXASXDVPXAS
        XDVQYDXTWEPSUGXDTVRVSVTYIWAXASXDWBYCXSOUBXASXDXEXOUKZXGXPYBXRXEXOXFWCYJ
        YAXQGXEXOAWDVJWFWGWHVMWQXFSUDXTXKWEBCDEFHIJKLWIXRXKUBXFSXPXQXJGXOXFAWDV
        JWJWKWLWM $.

      deg1ldgn.r $e |- ( ph -> R e. Ring ) $.
      deg1ldgn.f $e |- ( ph -> F e. B ) $.
      deg1ldgn.x $e |- ( ph -> X e. NN0 ) $.
      deg1ldgn.e $e |- ( ph -> ( A ` X ) = Y ) $.
      $( An index at which a polynomial is zero, cannot be its degree.
         (Contributed by Stefan O'Rear, 23-Mar-2015.) $)
      deg1ldgn $p |- ( ph -> ( D ` F ) =/= X ) $=
        ( cfv wceq wne wa fveq2 adantl crg wcel adantr cn0 wi eleq1a syl imp wb
        deg1nn0clb syl2anc mpbird deg1ldg syl3anc eqnetrrd ex necon2d mpd ) AHB
        UAZIUBGDUAZHUCTAVFHVEIAVFHUBZVEIUCAVGUDZVFBUAZVEIVGVIVEUBAVFHBUEUFVHFUG
        UHZGCUHZGJUCZVIIUCAVJVGQUIAVKVGRUIVHVLVFUJUHZAVGVMAHUJUHVGVMUKSHUJVFULU
        MUNAVLVMUOZVGAVJVKVNQRCDEFGJKLMNUPUQUIURBCDEFGIJKLMNOPUSUTVAVBVCVD $.

    $}

    ${
      deg1ldgdomn.e $e |- E = ( RLReg ` R ) $.
      deg1ldgdomn.a $e |- A = ( coe1 ` F ) $.
      $( A nonzero univariate polynomial over a domain always has a
         non-zero-divisor leading coefficient.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      deg1ldgdomn $p |- ( ( R e. Domn /\ F e. B /\ F =/= .0. ) ->
          ( A ` ( D ` F ) ) e. E ) $=
        ( wcel wne cfv cn0 eqid syl3an1 cdomn w3a cbs c0g simp1 wf 3ad2ant2 crg
        coe1f domnrng deg1nn0cl ffvelrnd deg1ldg domnrrg syl3anc ) EUAOZGBOZGHP
        ZUBZUPGCQZAQZEUCQZOVAEUDQZPZVAFOUPUQURUEUSRVBUTAUQUPRVBAUFURABDEGVBNLJV
        BSZUIUGUPEUHOZUQURUTROEUJZBCDEGHIJKLUKTULUPVFUQURVDVGABCDEGVCHIJKLVCSZN
        UMTVBEFVAVCVEMVHUNUO $.
    $}
  $}

  ${
    $d A x y $.  $d B y $.  $d F y $.  $d G x y $.  $d R y $.  $d .0. b x y $.
    $d a b $.
    deg1leb.d $e |- D = ( deg1 ` R ) $.
    deg1leb.p $e |- P = ( Poly1 ` R ) $.
    deg1leb.b $e |- B = ( Base ` P ) $.
    deg1leb.y $e |- .0. = ( 0g ` R ) $.
    deg1leb.a $e |- A = ( coe1 ` F ) $.
    $( Property of being of limited degree.  (Contributed by Stefan O'Rear,
       23-Mar-2015.) $)
    deg1leb $p |- ( ( F e. B /\ G e. RR* ) -> ( ( D ` F ) <_ G <->
          A. x e. NN0 ( G < x -> ( A ` x ) = .0. ) ) ) $=
      ( vy vb cfv cn0 c0 wceq va wcel cxr wa cle wbr cv c1o cmap co cmpt clt wi
      wral cmpl deg1fval eqid cps1 ply1bas psr1baslem tdeglem2 mdegleb wf1o wfo
      wb df1o2 nn0ex 0ex mapsnf1o2 f1ofo breq2 fveq2 eqeq1d imbi12d cbvfo fveq1
      mp2b fvex fvmpt fveq2d adantl fvcoe1 adantlr eqtr4d imbi2d syl5bbr bitr4d
      ralbidva ) GCUBZHUCUBZUDZGDQHUEUFHOUGZPRUHUIUJZSPUGZQZUKZQZULUFZWLGQZITZU
      MZOWMUNZHAUGZULUFZXCBQZITZUMZARUNZOWMCDUHFUOUJZFPUAGHWPUHIDFJUPXIUQEFFURQ
      ZCKXJUQLUSMUAUTPVAVBXHWRWQBQZITZUMZOWMUNZWKXBWMRWPVCWMRWPVDXNXHVEPRUHWPSV
      FVGVHWPUQZVIWMRWPVJXMXGOAWMRWPWQXCTZWRXDXLXFWQXCHULVKXPXKXEIWQXCBVLVMVNVO
      VQWKXMXAOWMWKWLWMUBZUDZXLWTWRXRXKWSIXRXKSWLQZBQZWSXQXKXTTWKXQWQXSBPWLWOXS
      WMWPSWNWLVPXOSWLVRVSVTWAWIXQWSXTTWJBGCWLNWBWCWDVMWEWHWFWG $.

    $( Value of the univariate degree as a supremum.  (Contributed by Stefan
       O'Rear, 29-Mar-2015.) $)
    deg1val $p |- ( F e. B -> ( D ` F ) =
          sup ( ( `' A " ( _V \ { .0. } ) ) , RR* , < ) ) $=
      ( vx vy cfv c1o ccnv cima cxr clt wcel cn0 cmap co cmpt cvv csn cdif csup
      c0 cmpl deg1fval eqid cps1 ply1bas psr1baslem tdeglem2 mdegval ccom imaco
      df1o2 nn0ex 0ex mapsncnv coe1fval2 cnveqd cnvco cocnvcnv1 syl6req imaeq1d
      cv eqtri syl5eqr supeq1d eqtrd ) FBUAZFCOMUBPUCUDZUJMVKOUEZFQZUFGUGUHZRRZ
      STUIAQZVTRZSTUIVQBCPEUKUDZEMNFVRPGCEHULWDUMDEEUNOZBIWEUMJUOKNUPMUQURVPSWA
      WCTVPWAVRVSUSZVTRWCVRVSVTUTVPWFWBVTVPWBFVRQZUSZQZWFVPAWHNABDEFWGLJIMNUBPV
      RUJVAVBVCVRUMVDVEVFWIWGQVSUSWFFWGVGVRVSVHVLVIVJVMVNVO $.

    $d D x $.  $d F x $.
    $( If the degree of a univariate polynomial is less than some index, then
       that coefficient must be zero.  (Contributed by Stefan O'Rear,
       23-Mar-2015.) $)
    deg1lt $p |- ( ( F e. B /\ G e. NN0 /\ ( D ` F ) < G ) ->
        ( A ` G ) = .0. ) $=
      ( vx wcel cn0 cfv clt wbr wceq w3a simp3 cv wi wral cle deg1xrcl 3ad2ant1
      simp2 cxr xrleid wb simp1 deg1leb syl2anc mpbid breq2 fveq2 eqeq1d rspcva
      syl imbi12d mpd ) FBOZGPOZFCQZGRSZUAZVGGAQZHTZVDVEVGUBVHVEVFNUCZRSZVKAQZH
      TZUDZNPUEZVGVJUDZVDVEVGUIVHVFVFUFSZVPVHVFUJOZVRVDVEVSVGBCDEFIJKUGUHZVFUKV
      AVHVDVSVRVPULVDVEVGUMVTNABCDEFVFHIJKLMUNUOUPVOVQNGPVKGTZVLVGVNVJVKGVFRUQW
      AVMVIHVKGAURUSVBUTUOVC $.

    $( Conversely, a nonzero coefficient sets a lower bound on the degree.
       (Contributed by Stefan O'Rear, 23-Mar-2015.) $)
    deg1ge $p |- ( ( F e. B /\ G e. NN0 /\ ( A ` G ) =/= .0. ) ->
        G <_ ( D ` F ) ) $=
      ( wcel cn0 cfv wne cle wbr cxr wa wn wceq wb deg1xrcl nn0re rexrd xrltnle
      clt syl2an deg1lt 3expia sylbird necon1ad 3impia ) FBNZGONZGAPZHQGFCPZRSZ
      UPUQUAZUTURHVAUTUBZUSGUISZURHUCZUPUSTNGTNVCVBUDUQBCDEFIJKUEUQGGUFUGUSGUHU
      JUPUQVCVDABCDEFGHIJKLMUKULUMUNUO $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y I $.  $d x y J $.  $d y ph $.  $d x y R $.
    $d x .xb $.  $d x y .x. $.
    coe1mul3.s $e |- Y = ( Poly1 ` R ) $.
    coe1mul3.t $e |- .xb = ( .r ` Y ) $.
    coe1mul3.u $e |- .x. = ( .r ` R ) $.
    coe1mul3.b $e |- B = ( Base ` Y ) $.
    coe1mul3.d $e |- D = ( deg1 ` R ) $.
    ${
      coe1mul3.r $e |- ( ph -> R e. Ring ) $.
      coe1mul3.f1 $e |- ( ph -> F e. B ) $.
      coe1mul3.f2 $e |- ( ph -> I e. NN0 ) $.
      coe1mul3.f3 $e |- ( ph -> ( D ` F ) <_ I ) $.
      coe1mul3.g1 $e |- ( ph -> G e. B ) $.
      coe1mul3.g2 $e |- ( ph -> J e. NN0 ) $.
      coe1mul3.g3 $e |- ( ph -> ( D ` G ) <_ J ) $.
      $( The coefficient vector of multiplication in the univariate polynomial
         ring, at indices high enough that at most one component can be active
         in the sum.  (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
      coe1mul3 $p |- ( ph -> ( ( coe1 ` ( F .xb G ) ) ` ( I + J ) ) =
            ( ( ( coe1 ` F ) ` I ) .x. ( ( coe1 ` G ) ` J ) ) ) $=
        ( vx vy caddc cco1 cfv cn0 cc0 cfz cmin cmpt cgsu crg wcel wceq coe1mul
        co cv syl3anc fveq1d nn0addcld oveq2 oveq1 fveq2d oveq2d mpteq12dv eqid
        ovex fvmpt syl cbs cvv c0g cmnd rngmnd a1i cle wbr cr nn0addge1 syl2anc
        nn0red wa wb fznn0 mpbir2and adantr coe1f elfznn0 syl2an fznn0sub rngcl
        ffvelrn fmptd csn cdif wne eldifsn clt adantl lttri2d ad2antrr deg1xrcl
        wf wo cxr rexrd resubcld ltaddsub2d bitrd biimpa xrlelttrd deg1lt rngrz
        ltadd1d eqtrd simpr oveq1d jaodan ex sylbid impr sylan2b suppss2 gsumpt
        rnglz fveq2 oveq12d nn0cnd pncan2d 3eqtrd ) AIJUFUSZGHEUSUGUHZUHYNUDUID
        UEUJUDUTZUKUSZUEUTZGUGUHZUHZYPYRULUSZHUGUHZUHZFUSZUMZUNUSZUMZUHZDUEUJYN
        UKUSZYTYNYRULUSZUUBUHZFUSZUMZUNUSZIYSUHZJUUBUHZFUSZAYNYOUUGADUOUPZGBUPZ
        HBUPZYOUUGUQQRUAUEBDEFUDGHKLMNOURVAVBAYNUIUPZUUHUUNUQAIJSUBVCZUDYNUUFUU
        NUIUUGYPYNUQZUUEUUMDUNUVCUEYQUUDUUIUULYPYNUJUKVDUVCUUCUUKYTFUVCUUAUUJUU
        BYPYNYRULVEVFVGVHVGUUGVIDUUMUNVJVKVLAUUNIUUMUHZUUOYNIULUSZUUBUHZFUSZUUQ
        AUUIDVMUHZUUMDVNIDVOUHZUVHVIZUVIVIZAUURDVPUPQDVQVLUUIVNUPAUJYNUKVJVRAIU
        UIUPZIUIUPZIYNVSVTZSAIWAUPZJUIUPUVNAISWDZUBIJWBWCAUVAUVLUVMUVNWEWFUVBIY
        NWGVLWHZAUEUUIUULUVHUUMAYRUUIUPZWEZUURYTUVHUPZUUKUVHUPZUULUVHUPAUURUVRQ
        WIZAUIUVHYSXFZYRUIUPZUVTUVRAUUSUWCRYSBKDGUVHYSVIZOLUVJWJVLYRYNWKZUIUVHY
        RYSWOWLZAUIUVHUUBXFZUUJUIUPZUWAUVRAUUTUWHUAUUBBKDHUVHUUBVIZOLUVJWJVLYRU
        JYNWMZUIUVHUUJUUBWOWLZUVHDFYTUUKUVJNWNVAUUMVIZWPAUUIUULUEIWQZUVIYRUUIUW
        NWRUPAUVRYRIWSZWEUULUVIUQZYRUUIIWTAUVRUWOUWPUVSUWOYRIXAVTZIYRXAVTZXGZUW
        PUVSYRIUVSYRUVRUWDAUWFXBZWDZAUVOUVRUVPWIZXCUVSUWSUWPUVSUWQUWPUWRUVSUWQW
        EZUULYTUVIFUSZUVIUXCUUKUVIYTFUXCUUTUWIHCUHZUUJXAVTUUKUVIUQAUUTUVRUWQUAX
        DUVSUWIUWQUVRUWIAUWKXBWIUXCUXEJUUJAUXEXHUPZUVRUWQAUUTUXFUABCKDHPLOXEVLX
        DAJXHUPUVRUWQAJAJUBWDZXIXDUVSUUJXHUPUWQUVSUUJUVSYNYRAYNWAUPUVRAYNUVBWDW
        IZUXAXJXIWIAUXEJVSVTUVRUWQUCXDUVSUWQJUUJXAVTZUVSUWQYRJUFUSYNXAVTUXIUVSY
        RIJUXAUXBAJWAUPUVRUXGWIZXQUVSYRJYNUXAUXJUXHXKXLXMXNUUBBCKDHUUJUVIPLOUVK
        UWJXOVAVGUVSUXDUVIUQZUWQUVSUURUVTUXKUWBUWGUVHDFYTUVIUVJNUVKXPWCWIXRUVSU
        WRWEZUULUVIUUKFUSZUVIUXLYTUVIUUKFUXLUUSUWDGCUHZYRXAVTYTUVIUQAUUSUVRUWRR
        XDUVSUWDUWRUWTWIUXLUXNIYRAUXNXHUPZUVRUWRAUUSUXORBCKDGPLOXEVLXDAIXHUPUVR
        UWRAIUVPXIXDUVSYRXHUPUWRUVSYRUXAXIWIAUXNIVSVTUVRUWRTXDUVSUWRXSXNYSBCKDG
        YRUVIPLOUVKUWEXOVAXTUVSUXMUVIUQZUWRUVSUURUWAUXPUWBUWLUVHDFUUKUVIUVJNUVK
        YHWCWIXRYAYBYCYDYEYFYGAUVLUVDUVGUQUVQUEIUULUVGUUIUUMYRIUQZYTUUOUUKUVFFY
        RIYSYIUXQUUJUVEUUBYRIYNULVDVFYJUWMUUOUVFFVJVKVLAUVFUUPUUOFAUVEJUUBAIJAI
        SYKAJUBYKYLVFVGYMYM $.
    $}

    coe1mul4.z $e |- .0. = ( 0g ` Y ) $.
    coe1mul4.r $e |- ( ph -> R e. Ring ) $.
    coe1mul4.f1 $e |- ( ph -> F e. B ) $.
    coe1mul4.f2 $e |- ( ph -> F =/= .0. ) $.
    coe1mul4.g1 $e |- ( ph -> G e. B ) $.
    coe1mul4.g2 $e |- ( ph -> G =/= .0. ) $.
    $( Value of the "leading" coefficient of a product of two nonzero
       polynomials.  This will fail to actually be the leading coefficient only
       if it is zero (requiring the basic ring to contain zero divisors).
       (Contributed by Stefan O'Rear, 25-Mar-2015.) $)
    coe1mul4 $p |- ( ph -> ( ( coe1 ` ( F .xb G ) ) `
            ( ( D ` F ) + ( D ` G ) ) ) = ( ( ( coe1 ` F ) ` ( D ` F ) ) .x.
            ( ( coe1 ` G ) ` ( D ` G ) ) ) ) $=
      ( cfv crg wcel wne cn0 deg1nn0cl syl3anc nn0red leidd coe1mul3 ) ABCDEFGH
      GCUBZHCUBZIKLMNOQRADUCUDZGBUDGJUEULUFUDQRSBCIDGJOKPNUGUHZAULAULUOUIUJTAUN
      HBUDHJUEUMUFUDQTUABCIDHJOKPNUGUHZAUMAUMUPUIUJUK $.
  $}

  ${
    deg1addle.y $e |- Y = ( Poly1 ` R ) $.
    deg1addle.d $e |- D = ( deg1 ` R ) $.
    deg1addle.r $e |- ( ph -> R e. Ring ) $.

    ${
      deg1addle.b $e |- B = ( Base ` Y ) $.
      deg1addle.p $e |- .+ = ( +g ` Y ) $.
      deg1addle.f $e |- ( ph -> F e. B ) $.
      deg1addle.g $e |- ( ph -> G e. B ) $.
      $( The degree of a sum is at most the maximum of the degrees of the
         factors.  (Contributed by Stefan O'Rear, 26-Mar-2015.) $)
      deg1addle $p |- ( ph -> ( D ` ( F .+ G ) ) <_
            if ( ( D ` F ) <_ ( D ` G ) , ( D ` G ) , ( D ` F ) ) ) $=
        ( c1o con0 eqid wcel ply1bascl2 cmpl cbs cfv deg1fval 1on a1i ply1plusg
        co syl mdegaddle ) APEUAUHZUBUCZCDEFGPQUKUKRZCEJUDPQSAUEUFKULRDEUKHIUMM
        UGAFBSFULSNBHEFILTUIAGBSGULSOBHEGILTUIUJ $.

      ${
        deg1addle2.l1 $e |- ( ph -> L e. RR* ) $.
        deg1addle2.l2 $e |- ( ph -> ( D ` F ) <_ L ) $.
        deg1addle2.l3 $e |- ( ph -> ( D ` G ) <_ L ) $.
        $( If both factors have degree bounded by ` L ` , then the sum of the
           polynomials also has degree bounded by ` L ` .  (Contributed by
           Stefan O'Rear, 1-Apr-2015.) $)
        deg1addle2 $p |- ( ph -> ( D ` ( F .+ G ) ) <_ L ) $=
          ( wcel co cfv cle wbr cif cxr crg ply1rng syl rngacl syl3anc deg1xrcl
          ifcl syl2anc deg1addle wa wb xrmaxle mpbir2and xrletrd ) AFGDUAZCUBZF
          CUBZGCUBZUCUDZVDVCUEZHAVABTZVBUFTAIUGTZFBTZGBTZVGAEUGTVHLIEJUHUIOPBDI
          FGMNUJUKBCIEVAKJMULUIAVDUFTZVCUFTZVFUFTAVJVKPBCIEGKJMULUIZAVIVLOBCIEF
          KJMULUIZVEVDVCUFUMUNQABCDEFGIJKLMNOPUOAVFHUCUDZVCHUCUDZVDHUCUDZRSAVLV
          KHUFTVOVPVQUPUQVNVMQVCVDHURUKUSUT $.
      $}

      deg1add.l $e |- ( ph -> ( D ` G ) < ( D ` F ) ) $.
      $( Exact degree of a sum of two polynomials of unequal degree.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      deg1add $p |- ( ph -> ( D ` ( F .+ G ) ) = ( D ` F ) ) $=
        ( cfv wceq wcel syl co cle wbr cif deg1addle wn clt wb deg1xrcl xrltnle
        cxr syl2anc iffalse breqtrd cn0 cco1 c0g wne crg ply1rng rngacl syl3anc
        mpbid cmnf nltmnf wa adantr fveq2 deg1z sylan9eqr ex necon3bd deg1nn0cl
        eqid mpd cplusg coe1addfv syl31anc deg1lt oveq2d cbs rnggrp wf ffvelrnd
        cgrp coe1f grprid 3eqtrd deg1ldg eqnetrd deg1ge xrletri3 mpbir2and ) AF
        GDUAZCQZFCQZRZWOWPUBUCZWPWOUBUCZAWOWPGCQZUBUCZWTWPUDZWPUBABCDEFGHIJKLMN
        OUEAXAUFZXBWPRAWTWPUGUCZXCPAWTUKSZWPUKSZXDXCUHAGBSZXEOBCHEGJILUITZAFBSZ
        XFNBCHEFJILUITZWTWPUJULVCXAWTWPUMTUNAWNBSZWPUOSZWPWNUPQZQZEUQQZURWSAHUS
        SZXIXGXKAEUSSZXPKHEIUTTNOBDHFGLMVAVBZAXQXIFHUQQZURZXLKNAWTVDUGUCZUFZXTA
        XEYBXHWTVETAYAFXSAFXSRZYAAYCVFWTWPVDUGAXDYCPVGYCAWPXSCQZVDFXSCVHAXQYDVD
        RKCHEXSJIXSVNZVITVJUNVKVLVOZBCHEFXSJIYELVMVBZAXNWPFUPQZQZXOAXNYIWPGUPQZ
        QZEVPQZUAZYIXOYLUAZYIAXQXIXGXLXNYMRKNOYGBYLDEFGWPHILMYLVNZVQVRAYKXOYIYL
        AXGXLXDYKXOROYGPYJBCHEGWPXOJILXOVNZYJVNVSVBVTAEWESZYIEWAQZSYNYIRAXQYQKE
        WBTAUOYRWPYHAXIUOYRYHWCNYHBHEFYRYHVNZLIYRVNZWFTYGWDYRYLEYIXOYTYOYPWGULW
        HAXQXIXTYIXOURKNYFYHBCHEFXOXSJIYELYPYSWIVBWJXMBCHEWNWPXOJILYPXMVNWKVBAW
        OUKSZXFWQWRWSVFUHAXKUUAXRBCHEWNJILUITXJWOWPWLULWM $.
    $}

    ${
      deg1vscale.b $e |- B = ( Base ` Y ) $.
      deg1vscale.k $e |- K = ( Base ` R ) $.
      deg1vscale.p $e |- .x. = ( .s ` Y ) $.
      deg1vscale.f $e |- ( ph -> F e. K ) $.
      deg1vscale.g $e |- ( ph -> G e. B ) $.
      $( The degree of a scalar times a polynomial is at most the degree of the
         original polynomial.  (Contributed by Stefan O'Rear, 26-Mar-2015.) $)
      deg1vscale $p |- ( ph -> ( D ` ( F .x. G ) ) <_ ( D ` G ) ) $=
        ( c1o con0 eqid cmpl co deg1fval wcel 1on a1i cps1 cfv ply1bas ply1vsca
        mdegvscale ) ABCDEFGRHSRDUAUBZULTZCDKUCRSUDAUEUFLIDDUGUHZBJUNTMUINDULEI
        JUMOUJPQUK $.
    $}

    ${
      deg1vsca.b $e |- B = ( Base ` Y ) $.
      deg1vsca.e $e |- E = ( RLReg ` R ) $.
      deg1vsca.p $e |- .x. = ( .s ` Y ) $.
      deg1vsca.f $e |- ( ph -> F e. E ) $.
      deg1vsca.g $e |- ( ph -> G e. B ) $.
      $( The degree of a scalar times a polynomial is exactly the degree of the
         original polynomial when the scalar is not a zero divisor.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      deg1vsca $p |- ( ph -> ( D ` ( F .x. G ) ) = ( D ` G ) ) $=
        ( c1o con0 eqid cmpl co deg1fval wcel 1on a1i cps1 cfv ply1bas ply1vsca
        mdegvsca ) ABCDEFGHRSRDUAUBZULTZCDKUCRSUDAUEUFLIDDUGUHZBJUNTMUINDULEIJU
        MOUJPQUK $.
    $}

    ${
      deg1invg.b $e |- B = ( Base ` Y ) $.
      deg1invg.n $e |- N = ( invg ` Y ) $.
      deg1invg.f $e |- ( ph -> F e. B ) $.
      $( The degree of the negated polynomial is the same as the original.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      deg1invg $p |- ( ph -> ( D ` ( N ` F ) ) = ( D ` F ) ) $=
        ( cfv cur wcel wceq syl eqid fveq2d cid cminusg cvsca co clmod ply1lmod
        crg ply1sca2 grpinvfvi lmodvneg1 syl2anc crlreg fvi cui 1unit unitnegcl
        wss unitrrg sseldd eqeltrd deg1vsca eqtr3d ) ADUANZONZDUBNZNZEGUCNZUDZC
        NEFNZCNECNAVHVICAGUEPZEBPVHVIQADUGPZVJJGDHUFRMVGVDVCVEFBGEKLGDHUHVGSZVD
        SDVEVESZUIUJUKTABCDVGDULNZVFEGHIJKVNSZVLAVFDONZVENZVNAVDVPVEAVCDOAVKVCD
        QJDUGUMRTTADUNNZVNVQAVKVRVNUQJDVRVNVOVRSZURRAVKVPVRPZVQVRPJAVKVTJDVRVPV
        SVPSUORDVRVEVPVSVMUPUKUSUTMVAVB $.
    $}

    ${
      deg1suble.b $e |- B = ( Base ` Y ) $.
      deg1suble.m $e |- .- = ( -g ` Y ) $.
      deg1suble.f $e |- ( ph -> F e. B ) $.
      deg1suble.g $e |- ( ph -> G e. B ) $.
      $( The degree of a difference of polynomials is bounded by the maximum of
         degrees.  (Contributed by Stefan O'Rear, 26-Mar-2015.) $)
      deg1suble $p |- ( ph -> ( D ` ( F .- G ) ) <_
            if ( ( D ` F ) <_ ( D ` G ) , ( D ` G ) , ( D ` F ) ) ) $=
        ( cfv co cle wbr wcel cminusg cplusg cif eqid cgrp crg ply1rng grpinvcl
        rnggrp 3syl syl2anc deg1addle wceq grpsubval fveq2d eqcomd breq2d eqidd
        deg1invg ifbieq12d 3brtr4d ) AEFHUAPZPZHUBPZQZCPECPZVCCPZRSZVGVFUCEFGQZ
        CPVFFCPZRSZVJVFUCRABCVDDEVCHIJKLVDUDZNAHUETZFBTZVCBTADUFTHUFTVMKHDIUGHU
        IUJOBHVBFLVBUDZUHUKULAVIVECAEBTVNVIVEUMNOBVDHVBGEFLVLVOMUNUKUOAVKVHVJVF
        VGVFAVJVGVFRAVGVJABCDFVBHIJKLVOOUSUPZUQVPAVFURUTVA $.

      deg1sub.l $e |- ( ph -> ( D ` G ) < ( D ` F ) ) $.
      $( Exact degree of a difference of two polynomials of unequal degree.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      deg1sub $p |- ( ph -> ( D ` ( F .- G ) ) = ( D ` F ) ) $=
        ( co cfv wcel eqid cminusg cplusg wceq grpsubval syl2anc fveq2d ply1rng
        cgrp crg rnggrp 3syl grpinvcl clt deg1invg eqbrtrd deg1add eqtrd ) AEFG
        QZCREFHUARZRZHUBRZQZCRECRZAURVBCAEBSFBSZURVBUCNOBVAHUSGEFLVATZUSTZMUDUE
        UFABCVADEUTHIJKLVENAHUHSZVDUTBSADUISHUISVGKHDIUGHUJUKOBHUSFLVFULUEAUTCR
        FCRVCUMABCDFUSHIJKLVFOUNPUOUPUQ $.
    $}

    ${
      deg1mulle2.b $e |- B = ( Base ` Y ) $.
      deg1mulle2.t $e |- .x. = ( .r ` Y ) $.
      deg1mulle2.f $e |- ( ph -> F e. B ) $.
      deg1mulle2.g $e |- ( ph -> G e. B ) $.
      deg1mulle2.j1 $e |- ( ph -> J e. NN0 ) $.
      deg1mulle2.k1 $e |- ( ph -> K e. NN0 ) $.
      deg1mulle2.j2 $e |- ( ph -> ( D ` F ) <_ J ) $.
      deg1mulle2.k2 $e |- ( ph -> ( D ` G ) <_ K ) $.
      $( Produce a bound on the product of two univariate polynomials given
         bounds on the factors.  (Contributed by Stefan O'Rear,
         26-Mar-2015.) $)
      deg1mulle2 $p |- ( ph -> ( D ` ( F .x. G ) ) <_ ( J + K ) ) $=
        ( c1o con0 cmpl co eqid deg1fval wcel 1on a1i cps1 cfv ply1bas ply1mulr
        mdegmulle2 ) ABCDEFGUBHIUCUBDUDUEZUPUFZCDLUGUBUCUHAUIUJMJDDUKULZBKURUFN
        UMDUPEJKUQOUNPQRSTUAUO $.
    $}
  $}

  ${
    deg1sublt.d $e |- D = ( deg1 ` R ) $.
    deg1sublt.p $e |- P = ( Poly1 ` R ) $.
    deg1sublt.b $e |- B = ( Base ` P ) $.
    deg1sublt.m $e |- .- = ( -g ` P ) $.
    deg1sublt.l $e |- ( ph -> L e. NN0 ) $.
    deg1sublt.r $e |- ( ph -> R e. Ring ) $.
    deg1sublt.fb $e |- ( ph -> F e. B ) $.
    deg1sublt.fd $e |- ( ph -> ( D ` F ) <_ L ) $.
    deg1sublt.gb $e |- ( ph -> G e. B ) $.
    deg1sublt.gd $e |- ( ph -> ( D ` G ) <_ L ) $.
    deg1sublt.a $e |- A = ( coe1 ` F ) $.
    deg1sublt.c $e |- C = ( coe1 ` G ) $.
    deg1sublt.eq $e |- ( ph -> ( ( coe1 ` F ) ` L ) = ( ( coe1 ` G ) ` L ) ) $.
    $( Subtraction of two polynomials limited to the same degree with the same
       leading coefficient gives a polynomial with a smaller degree.
       (Contributed by Stefan O'Rear, 26-Mar-2015.) $)
    deg1sublt $p |- ( ph -> ( D ` ( F .- G ) ) < L ) $=
      ( co cfv wceq clt wbr cco1 c0g eqid cgrp wcel crg ply1rng rnggrp grpsubcl
      wn wo syl3anc csg cn0 coe1subfv syl31anc oveq1d cbs syl wf coe1f ffvelrnd
      3syl grpsubid syl2anc 3eqtrd deg1ldgn neneqd cle cif deg1xrcl ifcl nn0red
      cxr rexrd deg1suble wa xrmaxle mpbir2and xrletrd xrleloe mpbid orel2 sylc
      wb ) AHIKUEZEUFZJUGZUSWPJUHUIZWQUTZWRAWPJAWOUJUFZCEFGWOJGUKUFZFUKUFZLMXBU
      LNXAULZWTULQAFUMUNZHCUNZICUNZWOCUNZAGUOUNZFUOUNXDQFGMUPFUQVLRTCFKHINOURVA
      ZPAJWTUFZJHUJUFUFZJIUJUFZUFZGVBUFZUEZXMXMXNUEZXAAXHXEXFJVCUNXJXOUGQRTPCGH
      IKXNJFMNOXNULZVDVEAXKXMXMXNUDVFAGUMUNZXMGVGUFZUNXPXAUGAXHXRQGUQVHAVCXSJXL
      AXFVCXSXLVITXLCFGIXSXLULNMXSULZVJVHPVKXSGXNXMXAXTXCXQVMVNVOVPVQAWPJVRUIZW
      SAWPHEUFZIEUFZVRUIZYCYBVSZJAXGWPWCUNZXICEFGWOLMNVTVHZAYCWCUNZYBWCUNZYEWCU
      NAXFYHTCEFGILMNVTVHZAXEYIRCEFGHLMNVTVHZYDYCYBWCWAVNAJAJPWBWDZACEGHIKFMLQN
      ORTWEAYEJVRUIZYBJVRUIZYCJVRUIZSUAAYIYHJWCUNZYMYNYOWFWNYKYJYLYBYCJWGVAWHWI
      AYFYPYAWSWNYGYLWPJWJVNWKWQWRWLWM $.
  $}

  ${
    deg1le0.d $e |- D = ( deg1 ` R ) $.
    deg1le0.p $e |- P = ( Poly1 ` R ) $.
    deg1le0.b $e |- B = ( Base ` P ) $.
    deg1le0.a $e |- A = ( algSc ` P ) $.
    $( A polynomial has nonpositive degree iff it is a constant.  (Contributed
       by Stefan O'Rear, 29-Mar-2015.) $)
    deg1le0 $p |- ( ( R e. Ring /\ F e. B ) -> ( ( D ` F ) <_ 0 <->
          F = ( A ` ( ( coe1 ` F ) ` 0 ) ) ) ) $=
      ( crg wcel wa cfv cc0 cle c1o wceq con0 eqid wbr csn cxp cco1 co deg1fval
      cmpl 1on a1i simpl cps1 ply1bas ply1ascl simpr mdegle0 cn0 coe1fv sylancl
      0nn0 fveq2d eqeq2d bitr4d ) EKLZFBLZMZFCNOPUAFQOUBUCFNZANZRFOFUDNZNZANZRV
      EABCEFQSQEUGUEZVKTCEGUFQSLVEUHUIVCVDUJDEEUKNZBHVLTIULADEHJUMVCVDUNZUOVEVJ
      VGFVEVIVFAVEVDOUPLVIVFRVMUSVHFOBVHTUQURUTVAVB $.
  $}

  ${
    deg1sclle.d $e |- D = ( deg1 ` R ) $.
    deg1sclle.p $e |- P = ( Poly1 ` R ) $.
    deg1sclle.k $e |- K = ( Base ` R ) $.
    deg1sclle.a $e |- A = ( algSc ` P ) $.
    $( A scalar polynomial has nonpositive degree.  (Contributed by Stefan
       O'Rear, 29-Mar-2015.) $)
    deg1sclle $p |- ( ( R e. Ring /\ F e. K ) -> ( D ` ( A ` F ) ) <_ 0 ) $=
      ( crg wcel wa cfv cc0 cle wbr cco1 wceq ply1sclid fveq2d wb eqid ply1sclf
      cbs ffvelrnda deg1le0 syldan mpbird ) DKLZEFLZMZEANZBNOPQZUMOUMRNNZANSZUL
      EUOAACDFEHJITUAUJUKUMCUENZLUNUPUBUJFUQEAAUQCDFHJIUQUCZUDUFAUQBCDUMGHURJUG
      UHUI $.

    deg1scl.z $e |- .0. = ( 0g ` R ) $.
    $( A nonzero scalar polynomial has zero degree.  (Contributed by Stefan
       O'Rear, 29-Mar-2015.) $)
    deg1scl $p |- ( ( R e. Ring /\ F e. K /\ F =/= .0. ) ->
        ( D ` ( A ` F ) ) = 0 ) $=
      ( crg wcel wne w3a cfv cc0 3adant3 eqid cle wbr wceq deg1sclle cn0 wb cbs
      c0g simp1 ply1sclf ffvelrnda ply1scln0 deg1nn0cl syl3anc nn0le0eq0 mpbid
      syl ) DMNZEFNZEGOZPZEAQZBQZRUAUBZVCRUCZURUSVDUTABCDEFHIJKUDSVAVCUENZVDVEU
      FVAURVBCUGQZNZVBCUHQZOVFURUSUTUIURUSVHUTURFVGEAAVGCDFIKJVGTZUJUKSACDFEVIG
      IKLVITZJULVGBCDVBVIHIVKVJUMUNVCUOUQUP $.
  $}

  ${
    deg1mul2.d $e |- D = ( deg1 ` R ) $.
    deg1mul2.p $e |- P = ( Poly1 ` R ) $.
    deg1mul2.e $e |- E = ( RLReg ` R ) $.
    deg1mul2.b $e |- B = ( Base ` P ) $.
    deg1mul2.t $e |- .x. = ( .r ` P ) $.
    deg1mul2.z $e |- .0. = ( 0g ` P ) $.
    deg1mul2.r $e |- ( ph -> R e. Ring ) $.
    deg1mul2.fb $e |- ( ph -> F e. B ) $.
    deg1mul2.fz $e |- ( ph -> F =/= .0. ) $.
    deg1mul2.fc $e |- ( ph -> ( ( coe1 ` F ) ` ( D ` F ) ) e. E ) $.
    deg1mul2.gb $e |- ( ph -> G e. B ) $.
    deg1mul2.gz $e |- ( ph -> G =/= .0. ) $.
    $( Degree of multiplication of two nonzero polynomials when the first leads
       with a non-zero-divisor coefficient.  (Contributed by Stefan O'Rear,
       26-Mar-2015.) $)
    deg1mul2 $p |- ( ph -> ( D ` ( F .x. G ) ) = ( ( D ` F ) + ( D ` G ) ) ) $=
      ( co cfv caddc wceq cle wbr crg wcel wne cn0 deg1nn0cl syl3anc deg1mulle2
      nn0red leidd cco1 c0g ply1rng rngcl nn0addcld cmulr eqid coe1mul4 deg1ldg
      syl cbs wi wf coe1f ffvelrnd rrgeq0i syl2anc necon3d eqnetrd deg1ge wa wb
      mpd cxr deg1xrcl rexrd xrletri3 mpbir2and ) AHIFUCZCUDZHCUDZICUDZUEUCZUFZ
      WGWJUGUHZWJWGUGUHZABCEFHIWHWIDLKQNORUAAEUIUJZHBUJZHJUKWHULUJQRSBCDEHJKLPN
      UMUNZAWNIBUJZIJUKZWIULUJQUAUBBCDEIJKLPNUMUNZAWHAWHWPUPUQAWIAWIWSUPUQUOAWF
      BUJZWJULUJWJWFURUDZUDZEUSUDZUKWMADUIUJZWOWQWTAWNXDQDELUTVGRUABDFHINOVAUNZ
      AWHWIWPWSVBZAXBWHHURUDUDZWIIURUDZUDZEVCUDZUCZXCABCEFXJHIDJLOXJVDZNKPQRSUA
      UBVEAXIXCUKZXKXCUKAWNWQWRXMQUAUBXHBCDEIXCJKLPNXCVDZXHVDZVFUNAXKXCXIXCAXGG
      UJXIEVHUDZUJXKXCUFXIXCUFVITAULXPWIXHAWQULXPXHVJUAXHBDEIXPXONLXPVDZVKVGWSV
      LXPEXJGXGXIXCMXQXLXNVMVNVOVTVPXABCDEWFWJXCKLNXNXAVDVQUNAWGWAUJZWJWAUJWKWL
      WMVRVSAWTXRXEBCDEWFKLNWBVGAWJAWJXFUPWCWGWJWDVNWE $.
  $}

  ${
    deg1mul3.d $e |- D = ( deg1 ` R ) $.
    deg1mul3.p $e |- P = ( Poly1 ` R ) $.
    deg1mul3.e $e |- E = ( RLReg ` R ) $.
    deg1mul3.b $e |- B = ( Base ` P ) $.
    deg1mul3.t $e |- .x. = ( .r ` P ) $.
    deg1mul3.a $e |- A = ( algSc ` P ) $.
    $( Degree of multiplication of a polynomial on the left by a
       non-zero-dividing scalar.  (Contributed by Stefan O'Rear,
       29-Mar-2015.) $)
    deg1mul3 $p |- ( ( R e. Ring /\ F e. E /\ G e. B ) ->
        ( D ` ( ( A ` F ) .x. G ) ) = ( D ` G ) ) $=
      ( wcel cfv ccnv cn0 eqid crg w3a cco1 cvv c0g csn cdif cima cxr clt cmulr
      csup cxp cof cbs wceq rrgss sseli coe1sclmul syl3an2 cnveqd imaeq1d nn0ex
      co a1i simp1 simp2 coe1f 3ad2ant3 rrgsupp eqtrd supeq1d 3ad2ant1 ply1sclf
      wf ply1rng 3ad2ant2 ffvelrnd simp3 rngcl syl3anc deg1val syl 3eqtr4d ) EU
      APZHGPZIBPZUBZHAQZIFVDZUCQZRZUDEUEQZUFUGZUHZUIUJULZIUCQZRWNUHZUIUJULZWJCQ
      ZICQZWHUIWOWRUJWHWOSHUFUMWQEUKQZUNVDZRZWNUHWRWHWLXDWNWHWKXCWFWEHEUOQZPZWG
      WKXCUPGXEHXEEGLXETZUQURZABDEFXBXEHIKMXGONXBTZUSUTVAVBWHXEEXBGSUDHWQWMLXGX
      IWMTZSUDPWHVCVEWEWFWGVFWEWFWGVGWGWESXEWQVOWFWQBDEIXEWQTZMKXGVHVIVJVKVLWHW
      JBPZWTWPUPWHDUAPZWIBPWGXLWEWFXMWGDEKVPVMWHXEBHAWEWFXEBAVOWGABDEXEKOXGMVNV
      MWFWEXFWGXHVQVRWEWFWGVSBDFWIIMNVTWAWKBCDEWJWMJKMXJWKTWBWCWGWEXAWSUPWFWQBC
      DEIWMJKMXJXKWBVIWD $.
  $}

  ${
    $d a A $.  $d a B $.  $d a F $.  $d a G $.  $d a K $.  $d a .x. $.
    $d a R $.
    deg1mul3le.d $e |- D = ( deg1 ` R ) $.
    deg1mul3le.p $e |- P = ( Poly1 ` R ) $.
    deg1mul3le.k $e |- K = ( Base ` R ) $.
    deg1mul3le.b $e |- B = ( Base ` P ) $.
    deg1mul3le.t $e |- .x. = ( .r ` P ) $.
    deg1mul3le.a $e |- A = ( algSc ` P ) $.
    $( Degree of multiplication of a polynomial on the left by a scalar.
       (Contributed by Stefan O'Rear, 1-Apr-2015.) $)
    deg1mul3le $p |- ( ( R e. Ring /\ F e. K /\ G e. B ) ->
        ( D ` ( ( A ` F ) .x. G ) ) <_ ( D ` G ) ) $=
      ( wcel cfv cxr cn0 wceq va crg w3a co cco1 ccnv cvv c0g csn cdif cima clt
      csup cle wss ply1rng 3ad2ant1 ply1sclf simp2 ffvelrnd simp3 rngcl syl3anc
      wbr wf eqid coe1f syl cv wa cmulr eldifi simpl1 simpl2 simpr coe1sclmulfv
      simpl3 syl121anc sylan2 3ad2ant3 ssid suppssr oveq2d rngrz 3adant3 adantr
      a1i 3eqtrd suppss cdm cnvimass fdm syl5sseq nn0ssre ressxr syl6ss supxrss
      cr sstri syl2anc deg1val 3brtr4d ) EUBPZGIPZHBPZUCZGAQZHFUDZUEQZUFUGEUHQZ
      UIUJZUKZRULUMZHUEQZUFXKUKZRULUMZXHCQZHCQZUNXFXLXOUOXORUOXMXPUNVDXFSIUAXIX
      OXJXFXHBPZSIXIVEXFDUBPZXGBPXEXSXCXDXTXEDEKUPUQXFIBGAXCXDIBAVEXEABDEIKOLMU
      RUQXCXDXEUSUTXCXDXEVABDFXGHMNVBVCZXIBDEXHIXIVFZMKLVGVHXFUAVIZSXOUJPZVJZYC
      XIQZGYCXNQZEVKQZUDZGXJYHUDZXJYDXFYCSPZYFYITZYCSXOVLXFYKVJXCXDXEYKYLXCXDXE
      YKVMXCXDXEYKVNXCXDXEYKVQXFYKVOABDEFYHIGHYCKMLONYHVFZVPVRVSYEYGXJGYHXFSIXN
      XOYCXJXEXCSIXNVEZXDXNBDEHIXNVFZMKLVGVTZXOXOUOXFXOWAWGWBWCXFYJXJTZYDXCXDYQ
      XEIEYHGXJLYMXJVFZWDWEWFWHWIXFXOSRXFXNWJZXOSXNXKWKXFYNYSSTYPSIXNWLVHWMSWRR
      WNWOWSWPXLXOWQWTXFXSXQXMTYAXIBCDEXHXJJKMYRYBXAVHXEXCXRXPTXDXNBCDEHXJJKMYR
      YOXAVTXB $.
  $}

  ${
    $d x .^ $.  $d x C $.  $d x F $.  $d x K $.  $d x R $.  $d x .x. $.
    $d x X $.
    deg1tm.d $e |- D = ( deg1 ` R ) $.
    deg1tm.k $e |- K = ( Base ` R ) $.
    deg1tm.p $e |- P = ( Poly1 ` R ) $.
    deg1tm.x $e |- X = ( var1 ` R ) $.
    deg1tm.m $e |- .x. = ( .s ` P ) $.
    deg1tm.n $e |- N = ( mulGrp ` P ) $.
    deg1tm.e $e |- .^ = ( .g ` N ) $.
    $( Limiting degree of a polynomial term.  (Contributed by Stefan O'Rear,
       27-Mar-2015.) $)
    deg1tmle $p |- ( ( R e. Ring /\ C e. K /\ F e. NN0 ) ->
        ( D ` ( C .x. ( F .^ X ) ) ) <_ F ) $=
      ( vx wcel cfv crg cn0 w3a co cle wbr cv clt cco1 c0g wceq wi wral wa eqid
      simpl1 simpl2 simpl3 simprl nn0red ltned coe1tmfv2 expr ralrimiva cbs cxr
      simprr wb ply1tmcl nn0re rexrd 3ad2ant3 deg1leb syl2anc mpbird ) DUASZAHS
      ZGUBSZUCZAGJFUDEUDZBTGUEUFZGRUGZUHUFZWBVTUITZTDUJTZUKZULZRUBUMZVSWGRUBVSW
      BUBSZWCWFVSWIWCUNZUNZAGCDEFWBHIJWEWEUOZLMNOPQVPVQVRWJUPVPVQVRWJUQVPVQVRWJ
      URZVSWIWCUSWKGWBWKGWMUTVSWIWCVGVAVBVCVDVSVTCVETZSGVFSZWAWHVHWNAGCDEFHIJLM
      NOPQWNUOZVIVRVPWOVQVRGGVJVKVLRWDWNBCDVTGWEKMWPWLWDUOVMVNVO $.

    deg1tm.z $e |- .0. = ( 0g ` R ) $.
    $( Exact degree of a polynomial term.  (Contributed by Stefan O'Rear,
       27-Mar-2015.) $)
    deg1tm $p |- ( ( R e. Ring /\ ( C e. K /\ C =/= .0. ) /\ F e. NN0 ) ->
        ( D ` ( C .x. ( F .^ X ) ) ) = F ) $=
      ( wcel crg wne wa cn0 w3a co cfv wceq cle wbr deg1tmle 3adant2r cco1 eqid
      ply1tmcl simp3 coe1tmfv1 simp2r eqnetrd deg1ge syl3anc wb deg1xrcl nn0red
      cbs cxr syl rexrd xrletri3 syl2anc mpbir2and ) DUATZAHTZAKUBZUCZGUDTZUEZA
      GJFUFEUFZBUGZGUHZVSGUIUJZGVSUIUJZVLVMVPWAVNABCDEFGHIJLMNOPQRUKULVQVRCVEUG
      ZTZVPGVRUMUGZUGZKUBWBVLVMVPWDVNWCAGCDEFHIJMNOPQRWCUNZUOULZVLVOVPUPZVQWFAK
      VLVMVPWFAUHVNAGCDEFHIJKSMNOPQRUQULVLVMVNVPURUSWEWCBCDVRGKLNWGSWEUNUTVAVQV
      SVFTZGVFTVTWAWBUCVBVQWDWJWHWCBCDVRLNWGVCVGVQGVQGWIVDVHVSGVIVJVK $.
  $}

  ${
    deg1pw.d $e |- D = ( deg1 ` R ) $.
    deg1pw.p $e |- P = ( Poly1 ` R ) $.
    deg1pw.x $e |- X = ( var1 ` R ) $.
    deg1pw.n $e |- N = ( mulGrp ` P ) $.
    deg1pw.e $e |- .^ = ( .g ` N ) $.
    $( Limiting degree of a variable power.  (Contributed by Stefan O'Rear,
       1-Apr-2015.) $)
    deg1pwle $p |- ( ( R e. Ring /\ F e. NN0 ) -> ( D ` ( F .^ X ) ) <_ F ) $=
      ( crg wcel cfv cur co cle adantr eqid cn0 wa csca cvsca cbs wceq ply1lmod
      clmod ply1rng rngmgp simpr vr1cl mgpbas mulgnn0cl syl3anc lmodvs1 syl2anc
      cmnd syl fveq2d wbr simpl ply1sca rngidcl eqeltrrd deg1tmle eqbrtrrd ) CM
      NZEUANZUBZBUCOZPOZEGDQZBUDOZQZAOZVMAOERVJVOVMAVJBUHNZVMBUEOZNZVOVMUFVHVQV
      IBCIUGSVJFURNZVIGVRNZVSVHVTVIVHBMNVTBCIUIBFKUJUSSVHVIUKZVHWAVIVRBCGJIVRTZ
      ULSVRDFEGVRBFKWCUMLUNUOVNVLVKVRBVMWCVKTVNTZVLTUPUQUTVJVHVLCUEOZNZVIVPERVA
      VHVIVBVHWFVIVHCPOZVLWEVHCVKPBCMIVCUTWECWGWETZWGTVDVESWBVLABCVNDEWEFGHWHIJ
      WDKLVFUOVG $.

    $( Exact degree of a variable power over a nontrivial ring.  (Contributed
       by Stefan O'Rear, 1-Apr-2015.) $)
    deg1pw $p |- ( ( R e. NzRing /\ F e. NN0 ) -> ( D ` ( F .^ X ) ) = F ) $=
      ( wcel cur cfv co wceq adantr syl eqid cnzr cn0 cvsca csca ply1sca fveq2d
      oveq1d clmod cbs crg nzrrng ply1lmod cmnd ply1rng rngmgp 3syl simpr vr1cl
      wa mgpbas mulgnn0cl syl3anc lmodvs1 syl2anc eqtrd c0g wne nzrnz syl121anc
      rngidcl deg1tm eqtr3d ) CUAMZEUBMZUSZCNOZEGDPZBUCOZPZAOZVQAOEVOVSVQAVOVSB
      UDOZNOZVQVRPZVQVOVPWBVQVRVOCWANVMCWAQVNBCUAIUERUFUGVOBUHMZVQBUIOZMZWCVQQV
      OCUJMZWDVMWGVNCUKRZBCIULSVOFUMMZVNGWEMZWFVOWGBUJMWIWHBCIUNBFKUOUPVMVNUQZV
      OWGWJWHWEBCGJIWETZURSWEDFEGWEBFKWLUTLVAVBVRWBWAWEBVQWLWATVRTZWBTVCVDVEUFV
      OWGVPCUIOZMZVPCVFOZVGZVNVTEQWHVOWGWOWHWNCVPWNTZVPTZVJSVMWQVNCVPWPWSWPTZVH
      RWKVPABCVRDEWNFGWPHWRIJWMKLWTVKVIVL $.
  $}

  ${
    $d P x y $.  $d R x y $.
    ply1domn.p $e |- P = ( Poly1 ` R ) $.
    $( Univariate polynomials over a nonzero ring are a nonzero ring.
       (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    ply1nz $p |- ( R e. NzRing -> P e. NzRing ) $=
      ( cnzr wcel crg cur cfv cascl cbs c0g csn cdif nzrrng ply1rng syl wf eqid
      wne ply1sclf rngidcl ffvelrnd ply1scln0 syl3anc eldifsn sylanbrc rngelnzr
      nzrnz syl2anc ) BDEZAFEZBGHZAIHZHZAJHZAKHZLMEZADEUJBFEZUKBNZABCOPUJUNUOEU
      NUPSZUQUJBJHZUOULUMUJURVAUOUMQUSUMUOABVACUMRZVARZUORZTPUJURULVAEZUSVABULV
      CULRZUAPZUBUJURVEULBKHZSUTUSVGBULVHVFVHRZUHUMABVAULUPVHCVBVIUPRZVCUCUDUNU
      OUPUEUFUOAUNUPVJVDUGUI $.

    $( Univariate polynomials are nonzero iff the base is nonzero.  Or in
       contraposition, the univariate polynomials over the zero ring are also
       zero.  (Contributed by Mario Carneiro, 13-Jun-2015.) $)
    ply1nzb $p |- ( R e. Ring -> ( R e. NzRing <-> P e. NzRing ) ) $=
      ( vy vx wcel cnzr cur cfv c0g wne eqid wceq cv c1o csn cxp cif co con0 wa
      crg ply1nz simpl nzrnz adantl cc0 ccnv cima cfn cmap crab wral ifeq1 ifid
      cn0 syl6eq ralrimivw cmpt cmpl ply1mpl1 1on a1i mpl1 ply1mpl0 cgrp rnggrp
      cn syl mpl0 fconstmpt eqeq12d cvv wb fvex ifex rgenw mpteqb ax-mp syl5ibr
      syl6bb necon3d mpd isnzr sylanbrc ex impbid2 ) BUBFZBGFZAGFZABCUCWHWJWIWH
      WJUAZWHBHIZBJIZKZWIWHWJUDZWKAHIZAJIZKZWNWJWRWHAWPWQWPLZWQLZUEUFWKWLWMWPWQ
      WLWMMZWPWQMZWKDNOUGPQMZWLWMRZWMMZDENUHVHUIUJFEUPOUKSULZUMZXAXEDXFXAXDXCWM
      WMRWMXCWLWMWMUNXCWMUOUQURWKXBDXFXDUSZDXFWMUSZMZXGWKWPXHWQXIWKDXFOBUTSZBWP
      WLEOTWMXKLZXFLZWMLZWLLZABWPXKXLCWSVAOTFWKVBVCZWOVDWKWQXFWMPQXIWKXFXKBEOWM
      TWQXLXMXNABXKWQXLCWTVEXPWKWHBVFFWOBVGVIVJDXFWMVKUQVLXDVMFZDXFUMXJXGVNXQDX
      FXCWLWMBHVOBJVOVPVQDXFXDWMVMVRVSWAVTWBWCBWLWMXOXNWDWEWFWG $.

    $( Corollary of ~ deg1mul2 : the univariate polynomials over a domain are a
       domain.  This is true for multivariate but with a much more complicated
       proof.  (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
    ply1domn $p |- ( R e. Domn -> P e. Domn ) $=
      ( vx vy cdomn wcel cnzr cv cfv co wceq wral syl wne cn0 eqid crg syl3anc
      wa cmulr c0g wo wi cbs domnnzr ply1nz neanior cdg1 caddc domnrng ad2antrr
      wn crlreg simplrl simprl cco1 simpll deg1ldgdomn simplrr simprr deg1nn0cl
      deg1mul2 nn0addcld eqeltrd wb ply1rng rngcl deg1nn0clb syl2anc ex syl5bir
      mpbird necon4bd ralrimivva isdomn sylanbrc ) BFGZAHGZDIZEIZAUAJZKZAUBJZLV
      TWDLWAWDLUCZUDZEAUEJZMDWGMAFGVRBHGVSBUFABCUGNVRWFDEWGWGVRVTWGGZWAWGGZTZTZ
      WEWCWDWEUMVTWDOZWAWDOZTZWKWCWDOZVTWDWAWDUHWKWNWOWKWNTZWOWCBUIJZJZPGZWPWRV
      TWQJZWAWQJZUJKPWPWGWQABWBBUNJZVTWAWDWQQZCXBQZWGQZWBQZWDQZVRBRGZWJWNBUKZUL
      ZVRWHWIWNUOZWKWLWMUPZWPVRWHWLWTVTUQJZJXBGVRWJWNURXKXLXMWGWQABXBVTWDXCCXGX
      EXDXMQUSSVRWHWIWNUTZWKWLWMVAZVCWPWTXAWPXHWHWLWTPGXJXKXLWGWQABVTWDXCCXGXEV
      BSWPXHWIWMXAPGXJXNXOWGWQABWAWDXCCXGXEVBSVDVEWPXHWCWGGZWOWSVFXJWPARGZWHWIX
      PVRXQWJWNVRXHXQXIABCVGNULXKXNWGAWBVTWAXEXFVHSWGWQABWCWDXCCXGXEVIVJVMVKVLV
      NVODEWGAWBWDXEXFXGVPVQ $.

    $( The ring of univariate polynomials over an integral domain is itself an
       integral domain.  (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    ply1idom $p |- ( R e. IDomn -> P e. IDomn ) $=
      ( ccrg wcel cdomn wa cidom ply1crng ply1domn anim12i isidom 3imtr4i ) BDE
      ZBFEZGADEZAFEZGBHEAHENPOQABCIABCJKBLALM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The division algorithm for univariate polynomials
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Monic1p $. $( Monic polynomial $)
  $c Unic1p $. $( Unitic polynomial $)
  $c quot1p $. $( Univariate polynomial quotient $)
  $c rem1p $. $( Univariate polynomial remainder $)
  $c idlGen1p $. $( Univariate polynomial ideal generator $)

  $( Monic polynomials. $)
  cmn1 $a class Monic1p $.

  $( Unitic polynomials. $)
  cuc1p $a class Unic1p $.

  $( Univariate polynomial quotient. $)
  cq1p $a class quot1p $.

  $( Univariate polynomial remainder. $)
  cr1p $a class rem1p $.

  $( Univariate polynomial ideal generator. $)
  cig1p $a class idlGen1p $.

  ${
    $d r f g b p q i $.
    $( Define the set of monic univariate polynomials.  (Contributed by Stefan
       O'Rear, 28-Mar-2015.) $)
    df-mon1 $a |- Monic1p = ( r e. _V |-> { f e. ( Base ` ( Poly1 ` r ) ) |
      ( f =/= ( 0g ` ( Poly1 ` r ) ) /\
        ( ( coe1 ` f ) ` ( ( deg1 ` r ) ` f ) ) = ( 1r ` r ) ) } ) $.

    $( Define the set of unitic univariate polynomials, as the polynomials with
       an invertible leading coefficient.  This is not a standard concept but
       is useful to us as the set of polynomials which can be used as the
       divisor in the polynomial division theorem ~ ply1divalg .  (Contributed
       by Stefan O'Rear, 28-Mar-2015.) $)
    df-uc1p $a |- Unic1p = ( r e. _V |-> { f e. ( Base ` ( Poly1 ` r ) ) |
      ( f =/= ( 0g ` ( Poly1 ` r ) ) /\
        ( ( coe1 ` f ) ` ( ( deg1 ` r ) ` f ) ) e. ( Unit ` r ) ) } ) $.

    $( Define the quotient of two univariate polynomials, which is guaranteed
       to exist and be unique by ~ ply1divalg .  We actually use the reversed
       version for better harmony with our divisibility ~ df-dvdsr .
       (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
    df-q1p $a |- quot1p = ( r e. _V |-> [_ ( Poly1 ` r ) / p ]_
      [_ ( Base ` p ) / b ]_ ( f e. b , g e. b |->
        ( iota_ q e. b ( ( deg1 ` r ) ` ( f ( -g ` p ) ( q ( .r ` p ) g ) ) ) <
          ( ( deg1 ` r ) ` g ) ) ) ) $.

    $( Define the remainder after dividing two univariate polynomials.
       (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
    df-r1p $a |- rem1p = ( r e. _V |-> [_ ( Base ` ( Poly1 ` r ) ) / b ]_
        ( f e. b , g e. b |-> ( f ( -g ` ( Poly1 ` r ) )
        ( ( f ( quot1p ` r ) g ) ( .r ` ( Poly1 ` r ) ) g ) ) ) ) $.

    $( Define a choice function for generators of ideals over a division ring;
       this is the unique monic polynomial of minimal degree in the ideal.
       (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    df-ig1p $a |- idlGen1p = ( r e. _V |-> ( i e. ( LIdeal ` ( Poly1 `
      r ) ) |-> if ( i = { ( 0g ` ( Poly1 ` r ) ) } , ( 0g ` ( Poly1 ` r ) ) ,
      ( iota_ g e. ( i i^i ( Monic1p ` r ) ) ( ( deg1 ` r ) ` g ) =
      sup ( ( ( deg1 ` r ) " ( i \ { ( 0g ` ( Poly1 ` r ) ) } ) ) ,
      RR , `' < ) ) ) ) ) $.
  $}

  ${
    ply1divalg.p $e |- P = ( Poly1 ` R ) $.
    ply1divalg.d $e |- D = ( deg1 ` R ) $.
    ply1divalg.b $e |- B = ( Base ` P ) $.
    ply1divalg.m $e |- .- = ( -g ` P ) $.
    ply1divalg.z $e |- .0. = ( 0g ` P ) $.
    ply1divalg.t $e |- .xb = ( .r ` P ) $.
    ply1divalg.r1 $e |- ( ph -> R e. Ring ) $.
    ply1divalg.f $e |- ( ph -> F e. B ) $.
    ply1divalg.g1 $e |- ( ph -> G e. B ) $.
    ply1divalg.g2 $e |- ( ph -> G =/= .0. ) $.

    ${
      $d ph q r $.  $d B q r $.  $d D q r $.  $d F q r $.  $d G q r $.
      $d .- q r $.  $d .xb q r $.
      ply1divmo.g3 $e |- ( ph -> ( ( coe1 ` G ) ` ( D ` G ) ) e. E ) $.
      ply1divmo.e $e |- E = ( RLReg ` R ) $.
      $( Uniqueness of a quotient in a polynomial division.  For polynomials
         ` F , G ` such that ` G =/= 0 ` and the leading coefficient of ` G `
         is not a zero divisor, there is at most one polynomial ` q ` which
         satisfies ` F = ( G x. q ) + r ` where the degree of ` r ` is less
         than the degree of ` G ` .  (Contributed by Stefan O'Rear,
         26-Mar-2015.)  (Revised by NM, 17-Jun-2017.) $)
      ply1divmo $p |- ( ph -> E* q e. B
              ( D ` ( F .- ( G .xb q ) ) ) < ( D ` G ) ) $=
        ( vr cv co cfv clt wbr wa weq wi wral wrmo wcel cxr cle cif cgrp adantr
        w3a crg ply1rng syl rnggrp simprl syl3anc grpsubcl simprr deg1xrcl ifcl
        rngcl syl2anc 3jca deg1suble wb xrmaxlt biimpar jca xrlelttr sylc ex wn
        wne caddc cr cn0 deg1nn0cl ad2antrr nn0red wceq grpsubeq0 equcom syl6bb
        necon3bid nn0addge1 cco1 deg1mul2 breqtrrd cabel rngabl rngsubdi eqtr4d
        ablnnncan1 fveq2d xrlenlt mpbid necon4ad ralrimivva oveq2 oveq2d breq1d
        syld rmo4 sylibr ) AHILUFZFUGZJUGZCUHZICUHZUIUJZHIUEUFZFUGZJUGZCUHZYAUI
        UJZUKZLUEULZUMZUEBUNLBUNYBLBUOAYJLUEBBAXQBUPZYCBUPZUKZUKZYHXSYEJUGZCUHZ
        YAUIUJZYIYNYHYQYNYHUKZYPUQUPZXTYFURUJZYFXTUSZUQUPZYAUQUPZVBZYPUUAURUJZU
        UAYAUIUJZUKYQYNUUDYHYNYSUUBUUCYNYOBUPZYSYNDUTUPZXSBUPZYEBUPZUUGYNDVCUPZ
        UUHYNEVCUPZUUKAUULYMSVAZDEMVDVEZDVFVEZYNUUHHBUPZXRBUPZUUIUUOAUUPYMTVAZY
        NUUKIBUPZYKUUQUUNAUUSYMUAVAZAYKYLVGZBDFIXQORVMVHZBDJHXROPVIVHZYNUUHUUPY
        DBUPZUUJUUOUURYNUUKUUSYLUVDUUNUUTAYKYLVJZBDFIYCORVMVHZBDJHYDOPVIVHZBDJX
        SYEOPVIVHBCDEYONMOVKVEZYNYFUQUPZXTUQUPZUUBYNUUJUVIUVGBCDEYENMOVKVEZYNUU
        IUVJUVCBCDEXSNMOVKVEZYTYFXTUQVLVNYNUUSUUCUUTBCDEINMOVKVEZVOVAYRUUEUUFYN
        UUEYHYNBCEXSYEJDMNUUMOPUVCUVGVPVAYNUUFYHYNUVJUVIUUCUUFYHVQUVLUVKUVMXTYF
        YAVRVHVSVTYPUUAYAWAWBWCYNYQXQYCYNXQYCWEZYQWDZYNUVNUKZYAYPURUJZUVOUVPYAI
        YCXQJUGZFUGZCUHZYPURUVPYAYAUVRCUHZWFUGZUVTURUVPYAWGUPUWAWHUPZYAUWBURUJU
        VPYAAYAWHUPZYMUVNAUULUUSIKWEZUWDSUAUBBCDEIKNMQOWIVHWJWKUVPUULUVRBUPZUVR
        KWEZUWCAUULYMUVNSWJZYNUWFUVNYNUUHYLYKUWFUUOUVEUVABDJYCXQOPVIVHVAZYNUWGU
        VNYNUVRKXQYCYNUVRKWLZUELULZYIYNUUHYLYKUWJUWKVQUUOUVEUVABDJYCXQKOQPWMVHU
        ELWNWOWPVSZBCDEUVRKNMQOWIVHYAUWAWQVNUVPBCDEFGIUVRKNMUDORQUWHAUUSYMUVNUA
        WJAUWEYMUVNUBWJAYAIWRUHUHGUPYMUVNUCWJUWIUWLWSWTYNYPUVTWLUVNYNYOUVSCYNYO
        YDXRJUGUVSYNBDJHXRYDOPYNUUKDXAUPUUNDXBVEUURUVBUVFXEYNBDFJIYCXQORPUUNUUT
        UVEUVAXCXDXFVAWTYNUVQUVOVQZUVNYNUUCYSUWMUVMUVHYAYPXGVNVAXHWCXIXNXJYBYGL
        UEBYIXTYFYAUIYIXSYECYIXRYDHJXQYCIFXKXLXFXMXOXP $.
    $}

    ${
      $d d q .0. $.  $d d f q F $.  $d f q r I $.  $d f q r P $.  $d f q r R $.
      $d a d f g q r .- $.  $d a d f g q r B $.  $d a d f g q r .xb $.
      $d a d f g q r D $.  $d a d f g q r G $.  $d a d f g q ph $.
      $d f q r .x. $.
      ply1divex.o $e |- .1. = ( 1r ` R ) $.
      ply1divex.k $e |- K = ( Base ` R ) $.
      ply1divex.u $e |- .x. = ( .r ` R ) $.
      ply1divex.i $e |- ( ph -> I e. K ) $.
      ply1divex.g3 $e |- ( ph ->
        ( ( ( coe1 ` G ) ` ( D ` G ) ) .x. I ) = .1. ) $.
      $( Lemma for ~ ply1divalg : existence part.  (Contributed by Stefan
         O'Rear, 27-Mar-2015.) $)
      ply1divex $p |- ( ph -> E. q e. B
            ( D ` ( F .- ( G .xb q ) ) ) < ( D ` G ) ) $=
        ( vd vf va vg vr cfv cv caddc co clt wbr wrex wceq fveq2 breq1d rexbidv
        cn0 wne wa cmin cn wss nnssnn0 wcel crg adantr deg1nn0cl syl3anc nn0red
        simpr resubcld syl ssrexv mpsyl ad2antrr nn0re adantl ltsubadd2d biimpd
        arch reximdva mpd cc0 0nn0 cmnf deg1z 0re readdcl sylancl mnflt eqbrtrd
        cr oveq2 breq2d rspcev sylancr pm2.61ne wi c1 imbi1d ralbidv imbi2d weq
        wral syl2anc oveq2d fveq2d nn0cnd ralrimiva cco1 cle ad2antlr nn0addcld
        sylan cc ax-1cn wf eqid coe1f simplr ffvelrnd adantrr syl13anc adantlrr
        rngcl oveq1 imbi12d rspcva ad3antrrr rexlimdva rng0cl rngrz cgrp rnggrp
        ply1rng grpsubid1 eqtr2d addid1d breq12d biimpa cv1 cmgp cvsca nn0addcl
        ex cmg simprl csn cun cz wb deg1cl peano2nn0 nn0zd degltlem1 impr nn0cn
        peano2cn a1i addsubassd pncan eqtrd breqtrd ply1tmcl leidd deg1tmle c0g
        deg1mulle2 coe1tmmul2fv addcomd oveq1d rngass rnglidm 3eqtr3rd 3eqtr4rd
        deg1sublt grpsubcl simplrr cplusg rngacl grpsubsub4 rngdi eqtr4d ee12an
        expr cbvrexv syl6bb cbvralv sylib exp32 com12 a2d nn0ind impcom ) AICUP
        ZJCUPZUKUQZURUSZUTVAZUKVGVBZIJOUQZFUSZMUSZCUPZUXFUTVAZOBVBZAUXJNCUPZUXH
        UTVAZUKVGVBZININVCZUXIUXRUKVGUXTUXEUXQUXHUTINCVDVEVFAINVHZVIZUXEUXFVJUS
        ZUXGUTVAZUKVGVBZUXJVKVGVLUYBUYDUKVKVBZUYEVMUYBUYCXBVNUYFUYBUXEUXFUYBUXE
        UYBEVOVNZIBVNZUYAUXEVGVNAUYGUYAUBVPAUYHUYAUCVPAUYAVTBCDEINQPTRVQVRVSZAU
        XFXBVNZUYAAUXFAUYGJBVNZJNVHUXFVGVNZUBUDUEBCDEJNQPTRVQVRZVSZVPWAUYCUKWJW
        BUYDUKVKVGWCWDUYBUYDUXIUKVGUYBUXGVGVNZVIZUYDUXIUYPUXEUXFUXGUYBUXEXBVNUY
        OUYIVPAUYJUYAUYOUYNWEUYOUXGXBVNUYBUXGWFWGWHWIWKWLAWMVGVNUXQUXFWMURUSZUT
        VAZUXSWNAUXQWOUYQUTAUYGUXQWOVCUBCDENQPTWPWBAUYQXBVNZWOUYQUTVAAUYJWMXBVN
        UYSUYNWQUXFWMWRWSUYQWTWBXAUXRUYRUKWMVGUXGWMVCUXHUYQUXQUTUXGWMUXFURXCXDX
        EXFXGAUXIUXPUKVGAUYOVIZUYHULUQZCUPZUXHUTVAZVUAUXLMUSZCUPZUXFUTVAZOBVBZX
        HZULBXNZUXIUXPXHZAUYHUYOUCVPUYOAVUIAVUBUXFUMUQZURUSZUTVAZVUGXHZULBXNZXH
        AVUBUYQUTVAZVUGXHZULBXNZXHAVUIXHZAVUBUXFUXGXIURUSZURUSZUTVAZVUGXHZULBXN
        ZXHVUSUMUKUXGVUKWMVCZVUOVURAVVEVUNVUQULBVVEVUMVUPVUGVVEVULUYQVUBUTVUKWM
        UXFURXCXDXJXKXLUMUKXMZVUOVUIAVVFVUNVUHULBVVFVUMVUCVUGVVFVULUXHVUBUTVUKU
        XGUXFURXCXDXJXKXLZVUKVUTVCZVUOVVDAVVHVUNVVCULBVVHVUMVVBVUGVVHVULVVAVUBU
        TVUKVUTUXFURXCXDXJXKXLVVGAVUQULBAVUABVNZVIZVUPVUGVVJVUPVINBVNZVUAJNFUSZ
        MUSZCUPZUXFUTVAZVUGAVVKVVIVUPADVOVNZVVKAUYGVVPUBDEPUUEWBZBDNRTUUAWBWEVV
        JVUPVVOVVJVUBVVNUYQUXFUTVVJVUAVVMCVVJVVMVUANMUSZVUAAVVMVVRVCVVIAVVLNVUA
        MAVVPUYKVVLNVCVVQUDBDFJNRUATUUBXOXPVPADUUCVNZVVIVVRVUAVCAVVPVVSVVQDUUDW
        BZBDMVUANRTSUUFYDUUGXQAUYQUXFVCVVIAUXFAUXFUYMXRUUHVPUUIUUJVUFVVOONBUXKN
        VCZVUEVVNUXFUTVWAVUDVVMCVWAUXLVVLVUAMUXKNJFXCXPXQVEXEXOUUOXSUYOAVUIVVDA
        UYOVUIVVDXHAUYOVUIVVDAUYOVUIVIVIZUNUQZCUPZVVAUTVAZVWCJUOUQZFUSZMUSZCUPZ
        UXFUTVAZUOBVBZXHZUNBXNVVDVWBVWLUNBVWBVWCBVNZVWEVWKVWBVWMVWEVIZVIZVWCJKU
        XHVWCXTUPZUPZGUSZUXGEUUKUPZDUULUPZUUPUPZUSDUUMUPZUSZFUSZMUSZUXLMUSZCUPZ
        UXFUTVAZOBVBZVWKVWOVXECUPZUXHUTVAZVXIAUYOVWNVXKVUIUYTVWNVIZVWPBVXDXTUPZ
        CDEVWCVXDUXHMQPRSUYTUXHVGVNZVWNAUYLUYOVXNUYMUXFUXGUUNYDVPAUYGUYOVWNUBWE
        UYTVWMVWEUUQVXLVWDVVAXIVJUSZUXHYAUYTVWMVWEVWDVXOYAVAZUYTVWMVIZVWEVXPVXQ
        VWDVGWOUURUUSVNZVVAUUTVNVWEVXPUVAVWMVXRUYTBCDEVWCQPRUVBWGVXQVVAVXQUXFVU
        TAUYLUYOVWMUYMWEZUYOVUTVGVNAVWMUXGUVCYBYCUVDVWDVVAUVEXOWIUVFUYTVXOUXHVC
        VWNUYTVXOUXFVUTXIVJUSZURUSUXHUYTUXFVUTXIUYTUXFAUYLUYOUYMVPXRUYTUXGYEVNZ
        VUTYEVNUYOVYAAUXGUVGZWGZUXGUVHWBXIYEVNZUYTYFUVIUVJUYTVXTUXGUXFURUYTVYAV
        YDVXTUXGVCVYCYFUXGXIUVKWSXPUVLVPUVMUYTVWMVXDBVNZVWEVXQVVPUYKVXCBVNZVYEA
        VVPUYOVWMVVQWEAUYKUYOVWMUDWEZVXQUYGVWRLVNZUYOVYFAUYGUYOVWMUBWEZVXQUYGKL
        VNZVWQLVNZVYHVYIAVYJUYOVWMUIWEZVXQVGLUXHVWPVWMVGLVWPYGUYTVWPBDEVWCLVWPY
        HZRPUGYIWGVXQUXFUXGVXSAUYOVWMYJZYCYKZLEGKVWQUGUHYOVRZVYNBVWRUXGDEVXBVXA
        LVWTVWSUGPVWSYHZVXBYHZVWTYHZVXAYHZRUVNVRZBDFJVXCRUAYOVRZYLUYTVWMVXDCUPU
        XHYAVAVWEVXQBCEFJVXCUXFUXGDPQVYIRUAVYGWUAVXSVYNVXQUXFVXQUXFVXSVSUVOVXQU
        YGVYHUYOVXCCUPUXGYAVAVYIVYPVYNVWRCDEVXBVXAUXGLVWTVWSQUGPVYQVYRVYSVYTUVP
        VRUVRYLVYMVXMYHUYTVWMVWQUXHVXMUPZVCVWEVXQUXGUXFURUSZVXMUPUXFJXTUPZUPZVW
        RGUSZWUCVWQVXQJBVWRUXGDEFVXBGVXALVWTVWSUXFEUVQUPZWUHYHUGPVYQVYRVYSVYTRU
        AUHVYGVYIVYPVYNVXSUVSVXQUXHWUDVXMVXQUXFUXGVXQUXFVXSXRUYOVYAAVWMVYBYBUVT
        XQVXQWUFKGUSZVWQGUSZHVWQGUSZWUGVWQAWUJWUKVCUYOVWMAWUIHVWQGUJUWAWEVXQUYG
        WUFLVNVYJVYKWUJWUGVCVYIVXQVGLUXFWUEAVGLWUEYGZUYOVWMAUYKWULUDWUEBDEJLWUE
        YHRPUGYIWBWEVXSYKVYLVYOLEGWUFKVWQUGUHUWBYMVXQUYGVYKWUKVWQVCVYIVYOLEGHVW
        QUGUHUFUWCXOUWDUWEYLUWFYNVWOVXEBVNZVUIVXKVXIXHZAUYOVWNWUMVUIUYTVWMWUMVW
        EVXQVVSVWMVYEWUMAVVSUYOVWMVVTWEUYTVWMVTWUBBDMVWCVXDRSUWGVRYLYNAUYOVUIVW
        NUWHVUHWUNULVXEBVUAVXEVCZVUCVXKVUGVXIWUOVUBVXJUXHUTVUAVXECVDVEWUOVUFVXH
        OBWUOVUEVXGUXFUTWUOVUDVXFCVUAVXEUXLMYPXQVEVFYQYRXOWLAUYOVWNVXIVWKXHZVUI
        UYTVWMWUPVWEVXQVXHVWKOBVXQUXKBVNZVIZUXKVXCDUWIUPZUSZBVNZVXHVWCJWUTFUSZM
        USZCUPZUXFUTVAZVWKWURVVPWUQVYFWVAAVVPUYOVWMWUQVVQYSZVXQWUQVTZVXQVYFWUQW
        UAVPZBWUSDUXKVXCRWUSYHZUWJVRWURVXHWVEWURVXGWVDUXFUTWURVXFWVCCWURVXFVWCU
        XLVXDWUSUSZMUSZWVCWURVVSVWMVYEUXLBVNZVXFWVKVCAVVSUYOVWMWUQVVTYSUYTVWMWU
        QYJVXQVYEWUQWUBVPWURVVPUYKWUQWVLWVFAUYKUYOVWMWUQUDYSZWVGBDFJUXKRUAYOVRB
        WUSDMVWCVXDUXLRWVISUWKYMWURWVBWVJVWCMWURVVPUYKWUQVYFWVBWVJVCWVFWVMWVGWV
        HBWUSDFJUXKVXCRWVIUAUWLYMXPUWMXQVEWIVWJWVEUOWUTBVWFWUTVCZVWIWVDUXFUTWVN
        VWHWVCCWVNVWGWVBVWCMVWFWUTJFXCXPXQVEXEUWNYTYLYNWLUWOXSVWLVVCUNULBUNULXM
        ZVWEVVBVWKVUGWVOVWDVUBVVAUTVWCVUACVDVEWVOVWKVUAVWGMUSZCUPZUXFUTVAZUOBVB
        VUGWVOVWJWVRUOBWVOVWIWVQUXFUTWVOVWHWVPCVWCVUAVWGMYPXQVEVFWVRVUFUOOBUOOX
        MZWVQVUEUXFUTWVSWVPVUDCWVSVWGUXLVUAMVWFUXKJFXCXPXQVEUWPUWQYQUWRUWSUWTUX
        AUXBUXCUXDVUHVUJULIBVUAIVCZVUCUXIVUGUXPWVTVUBUXEUXHUTVUAICVDVEWVTVUFUXO
        OBWVTVUEUXNUXFUTWVTVUDUXMCVUAIUXLMYPXQVEVFYQYRXOYTWL $.
    $}

    ${
      $d ph q $.  $d B q $.  $d D q $.  $d F q $.  $d G q $.  $d .- q $.
      $d P q $.  $d R q $.  $d .xb q $.  $d .0. q $.
      ply1divalg.g3 $e |- ( ph -> ( ( coe1 ` G ) ` ( D ` G ) ) e. U ) $.
      ply1divalg.u $e |- U = ( Unit ` R ) $.
      $( The division algorithm for univariate polynomials over a ring.  For
         polynomials ` F , G ` such that ` G =/= 0 ` and the leading
         coefficient of ` G ` is a unit, there are unique polynomials ` q ` and
         ` r = F - ( G x. q ) ` such that the degree of ` r ` is less than the
         degree of ` G ` .  (Contributed by Stefan O'Rear, 27-Mar-2015.) $)
      ply1divalg $p |- ( ph -> E! q e. B
            ( D ` ( F .- ( G .xb q ) ) ) < ( D ` G ) ) $=
        ( cv co cfv clt wbr wrex wrmo wreu cmulr cur cco1 cbs eqid crg rnginvcl
        cinvr wcel syl2anc wceq unitrinv ply1divex crlreg wss unitrrg ply1divmo
        syl sseldd reu5 sylanbrc ) AHILUEFUFJUFCUGICUGZUHUIZLBUJVOLBUKVOLBULABC
        DEFEUMUGZEUNUGZHIVNIUOUGUGZEUTUGZUGZEUPUGZJKLMNOPQRSTUAUBVQUQZWAUQZVPUQ
        ZAEURVAZVRGVAZVTWAVASUCWAEGVSVRUDVSUQZWCUSVBAWEWFVRVTVPUFVQVCSUCEVPGVQV
        SVRUDWGWDWBVDVBVEABCDEFEVFUGZHIJKLMNOPQRSTUAUBAGWHVRAWEGWHVGSEGWHWHUQZU
        DVHVJUCVKWIVIVOLBVLVM $.

      $d B r $.  $d P r $.  $d R r $.  $d q r $.
      $( Reverse the order of multiplication in ~ ply1divalg via the opposite
         ring.  (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      ply1divalg2 $p |- ( ph -> E! q e. B
            ( D ` ( F .- ( q .xb G ) ) ) < ( D ` G ) ) $=
        ( vr cv cfv clt wbr wreu coppr cpl1 cmulr eqid cdg1 wceq wtru cbs eqidd
        co opprbas a1i cplusg wcel wa oppradd oveqi deg1propd trud eqtri fveq2i
        ply1baspropd csg ply1plusgpropd grpsubpropd c0g grpidpropd crg opprunit
        opprrng ply1divalg adantr simpr ply1opprmul eqcomd oveq2d fveq2d breq1d
        syl syl3anc reubidva mpbird ) AHLUFZIFUTZJUTZCUGZICUGZUHUIZLBUJHIWMEUKU
        GZULUGZUMUGZUTZJUTZCUGZWQUHUIZLBUJABCWTWSXAGHIJKLWTUNZCEUOUGZWSUOUGZNXG
        XHUPUQLUEEURUGZEWSUQXIUSZXIWSURUGUPUQXIEWSWSUNZXIUNVAVBZWMUEUFZEVCUGZUT
        WMXMWSVCUGZUTUPUQWMXIVDXMXIVDVEVEXNXOWMXMXNEWSXKXNUNVFVGVBZVHVIVJBDURUG
        ZWTURUGZOXQEULUGZURUGZXRDXSURMVKXTXRUPUQLUEXIEWSXJXLXPVLVIVJZVJZJDVMUGZ
        WTVMUGZPYCYDUPUQDWTXQXRUPUQYAVBDVCUGZWTVCUGZUPUQYEXSVCUGZYFDXSVCMVKYGYF
        UPUQLUEXIEWSXJXLXPVNVIVJZVBVOVIVJKDVPUGZWTVPUGZQYIYJUPUQLUEBDWTBXQUPUQO
        VBBXRUPUQYBVBWMXMYEUTWMXMYFUTUPUQWMBVDZXMBVDVEVEYEYFWMXMYHVGVBVQVIVJXAU
        NZAEVRVDZWSVRVDSEWSXKVTWITUAUBUCEWSGUDXKVSWAAWRXELBAYKVEZWPXDWQUHYNWOXC
        CYNWNXBHJYNXBWNYNYMIBVDZYKXBWNUPAYMYKSWBAYOYKUAWBAYKWCBEWSXAFIWMDWTMXKX
        FRYLOWDWJWEWFWGWHWKWL $.
    $}
  $}

  ${
    uc1pval.p $e |- P = ( Poly1 ` R ) $.
    uc1pval.b $e |- B = ( Base ` P ) $.
    uc1pval.z $e |- .0. = ( 0g ` P ) $.
    uc1pval.d $e |- D = ( deg1 ` R ) $.
    ${
      $d B f r $.  $d D f r $.  $d F f $.  $d R f r $.  $d U f r $.
      $d .0. f r $.
      uc1pval.c $e |- C = ( Unic1p ` R ) $.
      uc1pval.u $e |- U = ( Unit ` R ) $.
      $( Value of the set of unitic polynomials.  (Contributed by Stefan
         O'Rear, 28-Mar-2015.) $)
      uc1pval $p |- C = { f e. B | ( f =/= .0. /\
              ( ( coe1 ` f ) ` ( D ` f ) ) e. U ) } $=
        ( cfv cpl1 cbs syl6eqr fveq2d c0 vr cuc1p cv wne cco1 wcel wa crab wceq
        cvv c0g cdg1 fveq2 neeq2d fveq1d eleq12d anbi12d rabeqbidv df-uc1p fvex
        cui eqeltri rabex fvmpt wn fvprc wss ssrab2 syl5eq base0 ss0 syl eqtr4d
        syl5sseq pm2.61i eqtri ) BEUBOZGUCZHUDZVRCOZVRUEOZOZFUFZUGZGAUHZMEUJUFZ
        VQWEUIUAEVRUAUCZPOZUKOZUDZVRWGULOZOZWAOZWGVAOZUFZUGZGWHQOZUHWEUJUBWGEUI
        ZWPWDGWQAWRWQDQOZAWRWHDQWRWHEPOZDWGEPUMIRZSJRWRWJVSWOWCWRWIHVRWRWIDUKOH
        WRWHDUKXASKRUNWRWMWBWNFWRWLVTWAWRVRWKCWRWKEULOCWGEULUMLRUOSWRWNEVAOFWGE
        VAUMNRUPUQURGUAUSWDGAAWSUJJDQUTVBVCVDWFVEZVQTWEEUBVFXBWETVGWETUIXBAWETW
        DGAVHXBAWSTJXBWSTQOTXBDTQXBDWTTIEPVFVISVJRVIVNWEVKVLVMVOVP $.

      $( Being a unitic polynomial.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      isuc1p $p |- ( F e. C <-> ( F e. B /\ F =/= .0. /\
            ( ( coe1 ` F ) ` ( D ` F ) ) e. U ) ) $=
        ( vf wcel wne cfv cco1 wa w3a wceq neeq1 fveq12d eleq1d anbi12d uc1pval
        cv fveq2 elrab2 3anass bitr4i ) GBPGAPZGHQZGCRZGSRZRZFPZTZTUMUNURUAOUHZ
        HQZUTCRZUTSRZRZFPZTUSOGABUTGUBZVAUNVEURUTGHUCVFVDUQFVFVBUOVCUPUTGSUIUTG
        CUIUDUEUFABCDEFOHIJKLMNUGUJUMUNURUKUL $.
    $}

    ${
      $d B f r $.  $d D f r $.  $d F f $.  $d .1. f r $.  $d R f r $.
      $d .0. f r $.
      mon1pval.m $e |- M = ( Monic1p ` R ) $.
      mon1pval.o $e |- .1. = ( 1r ` R ) $.
      $( Value of the set of monic polynomials.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      mon1pval $p |- M = { f e. B | ( f =/= .0. /\
              ( ( coe1 ` f ) ` ( D ` f ) ) = .1. ) } $=
        ( cfv wceq cpl1 cbs syl6eqr c0 vr cmn1 cv wne cco1 wa crab cvv wcel c0g
        cdg1 cur fveq2d neeq2d fveq1d eqeq12d anbi12d rabeqbidv df-mon1 eqeltri
        fveq2 fvex rabex fvmpt wn fvprc wss ssrab2 syl5eq base0 syl5sseq eqtr4d
        ss0 syl pm2.61i eqtri ) GDUBOZFUCZHUDZVRBOZVRUEOZOZEPZUFZFAUGZMDUHUIZVQ
        WEPUADVRUAUCZQOZUJOZUDZVRWGUKOZOZWAOZWGULOZPZUFZFWHROZUGWEUHUBWGDPZWPWD
        FWQAWRWQCROZAWRWHCRWRWHDQOZCWGDQVAISZUMJSWRWJVSWOWCWRWIHVRWRWICUJOHWRWH
        CUJXAUMKSUNWRWMWBWNEWRWLVTWAWRVRWKBWRWKDUKOBWGDUKVALSUOUMWRWNDULOEWGDUL
        VANSUPUQURFUAUSWDFAAWSUHJCRVBUTVCVDWFVEZVQTWEDUBVFXBWETVGWETPXBAWETWDFA
        VHXBATROZTXBAWSXCJXBCTRXBCWTTIDQVFVIUMVIVJSVKWEVMVNVLVOVP $.

      $( Being a monic polynomial.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      ismon1p $p |- ( F e. M <-> ( F e. B /\ F =/= .0. /\
            ( ( coe1 ` F ) ` ( D ` F ) ) = .1. ) ) $=
        ( vf wcel cfv cco1 wceq wa wne w3a neeq1 fveq2 fveq12d anbi12d mon1pval
        cv eqeq1d elrab2 3anass bitr4i ) FGPFAPZFHUAZFBQZFRQZQZESZTZTUMUNURUBOU
        HZHUAZUTBQZUTRQZQZESZTUSOFAGUTFSZVAUNVEURUTFHUCVFVDUQEVFVBUOVCUPUTFRUDU
        TFBUDUEUIUFABCDEOGHIJKLMNUGUJUMUNURUKUL $.
    $}
  $}

  ${
    uc1pcl.p $e |- P = ( Poly1 ` R ) $.
    uc1pcl.b $e |- B = ( Base ` P ) $.
    ${
      uc1pcl.c $e |- C = ( Unic1p ` R ) $.
      $( Unitic polynomials are polynomials.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      uc1pcl $p |- ( F e. C -> F e. B ) $=
        ( wcel c0g cfv wne cdg1 cco1 cui eqid isuc1p simp1bi ) EBIEAIECJKZLEDMK
        ZKENKKDOKZIABTCDUAESFGSPTPHUAPQR $.
    $}

    ${
      mon1pcl.m $e |- M = ( Monic1p ` R ) $.
      $( Monic polynomials are polynomials.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      mon1pcl $p |- ( F e. M -> F e. B ) $=
        ( wcel c0g cfv wne cdg1 cco1 cur wceq eqid ismon1p simp1bi ) DEIDAIDBJK
        ZLDCMKZKDNKKCOKZPAUABCUBDETFGTQUAQHUBQRS $.
    $}
  $}

  ${
    uc1pn0.p $e |- P = ( Poly1 ` R ) $.
    uc1pn0.z $e |- .0. = ( 0g ` P ) $.
    ${
      uc1pn0.c $e |- C = ( Unic1p ` R ) $.
      $( Unitic polynomials are not zero.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      uc1pn0 $p |- ( F e. C -> F =/= .0. ) $=
        ( wcel cbs cfv wne cdg1 cco1 cui eqid isuc1p simp2bi ) DAIDBJKZIDELDCMK
        ZKDNKKCOKZISATBCUADEFSPGTPHUAPQR $.
    $}

    ${
      mon1pn0.m $e |- M = ( Monic1p ` R ) $.
      $( Monic polynomials are not zero.  (Contributed by Stefan O'Rear,
         28-Mar-2015.) $)
      mon1pn0 $p |- ( F e. M -> F =/= .0. ) $=
        ( wcel cbs cfv wne cdg1 cco1 cur wceq eqid ismon1p simp2bi ) CDICAJKZIC
        ELCBMKZKCNKKBOKZPTUAABUBCDEFTQGUAQHUBQRS $.
    $}
  $}

  ${
    uc1pdeg.d $e |- D = ( deg1 ` R ) $.
    uc1pdeg.c $e |- C = ( Unic1p ` R ) $.
    $( Unitic polynomials have nonnegative degrees.  (Contributed by Stefan
       O'Rear, 28-Mar-2015.) $)
    uc1pdeg $p |- ( ( R e. Ring /\ F e. C ) -> ( D ` F ) e. NN0 ) $=
      ( crg wcel wa cpl1 cfv cbs c0g wne cn0 simpl eqid uc1pcl adantl uc1pn0
      deg1nn0cl syl3anc ) CGHZDAHZIUCDCJKZLKZHZDUEMKZNZDBKOHUCUDPUDUGUCUFAUECDU
      EQZUFQZFRSUDUIUCAUECDUHUJUHQZFTSUFBUECDUHEUJULUKUAUB $.
  $}

  ${
    uc1pldg.d $e |- D = ( deg1 ` R ) $.
    uc1pldg.u $e |- U = ( Unit ` R ) $.
    uc1pldg.c $e |- C = ( Unic1p ` R ) $.
    $( Unitic polynomials have unit leading coefficients.  (Contributed by
       Stefan O'Rear, 28-Mar-2015.) $)
    uc1pldg $p |- ( F e. C -> ( ( coe1 ` F ) ` ( D ` F ) ) e. U ) $=
      ( wcel cpl1 cfv cbs c0g wne cco1 eqid isuc1p simp3bi ) EAIECJKZLKZIESMKZN
      EBKEOKKDITABSCDEUASPTPUAPFHGQR $.
  $}

  ${
    mon1pldg.d $e |- D = ( deg1 ` R ) $.
    mon1pldg.o $e |- .1. = ( 1r ` R ) $.
    mon1pldg.m $e |- M = ( Monic1p ` R ) $.
    $( Unitic polynomials have one leading coefficients.  (Contributed by
       Stefan O'Rear, 28-Mar-2015.) $)
    mon1pldg $p |- ( F e. M -> ( ( coe1 ` F ) ` ( D ` F ) ) = .1. ) $=
      ( wcel cpl1 cfv cbs c0g wne cco1 wceq eqid ismon1p simp3bi ) DEIDBJKZLKZI
      DTMKZNDAKDOKKCPUAATBCDEUBTQUAQUBQFHGRS $.
  $}

  ${
    mon1puc1p.c $e |- C = ( Unic1p ` R ) $.
    mon1puc1p.m $e |- M = ( Monic1p ` R ) $.
    $( Monic polynomials are unitic.  (Contributed by Stefan O'Rear,
       28-Mar-2015.) $)
    mon1puc1p $p |- ( ( R e. Ring /\ X e. M ) -> X e. C ) $=
      ( crg wcel wa cpl1 cfv cbs c0g wne cdg1 cco1 cui eqid mon1pcl adantl wceq
      mon1pn0 cur mon1pldg 1unit adantr eqeltrd isuc1p syl3anbrc ) BGHZDCHZIZDB
      JKZLKZHZDUMMKZNZDBOKZKDPKKZBQKZHDAHUKUOUJUNUMBDCUMRZUNRZFSTUKUQUJUMBDCUPV
      AUPRZFUBTULUSBUCKZUTUKUSVDUAUJURBVDDCURRZVDRZFUDTUJVDUTHUKBUTVDUTRZVFUEUF
      UGUNAURUMBUTDUPVAVBVCVEEVGUHUI $.
  $}

  ${
    uc1pmon1p.c $e |- C = ( Unic1p ` R ) $.
    uc1pmon1p.m $e |- M = ( Monic1p ` R ) $.
    uc1pmon1p.p $e |- P = ( Poly1 ` R ) $.
    uc1pmon1p.t $e |- .x. = ( .r ` P ) $.
    uc1pmon1p.a $e |- A = ( algSc ` P ) $.
    uc1pmon1p.d $e |- D = ( deg1 ` R ) $.
    uc1pmon1p.i $e |- I = ( invr ` R ) $.
    $( Make a unitic polynomial monic by multiplying a factor to normalize the
       leading coefficient.  (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    uc1pmon1p $p |- ( ( R e. Ring /\ X e. C ) ->
        ( ( A ` ( I ` ( ( coe1 ` X ) ` ( D ` X ) ) ) ) .x. X ) e. M ) $=
      ( wcel cfv eqid cn0 crg wa cco1 co cbs c0g wne cur wceq ply1rng adantr wf
      ply1sclf cui uc1pldg rnginvcl sylan2 ffvelrnd uc1pcl adantl rngcl syl3anc
      crlreg simpl unitrrg unitinvcl sseldd deg1mul3 uc1pdeg eqeltrd deg1nn0clb
      wss wb syldan mpbird csn cxp cmulr cof fveq2d coe1sclmul fveq1d cvv nn0ex
      a1i fvex wfn coe1f 3syl eqidd ofc1 mpdan unitlinv eqtrd ismon1p syl3anbrc
      ffn 3eqtrd ) EUAQZIBQZUBZICRZIUCRZRZGRZARZIFUDZDUERZQZXGDUFRZUGZXGCRZXGUC
      RZRZEUHRZUIXGHQXADUAQZXFXHQIXHQZXIWSXPWTDELUJUKXAEUERZXHXEAWSXRXHAULWTAXH
      DEXRLNXRSZXHSZUMUKWTWSXDEUNRZQZXEXRQZBCEYAIOYASZJUOZXREYAGXDYDPXSUPUQZURW
      TXQWSXHBDEILXTJUSUTZXHDFXFIXTMVAVBZXAXKXLTQZXAXLXBTXAWSXEEVCRZQXQXLXBUIWS
      WTVDZXAYAYJXEWSYAYJVLWTEYAYJYJSZYDVEUKWTWSYBXEYAQYEEYAGXDYDPVFUQVGYGAXHCD
      EFYJXEIOLYLXTMNVHVBZBCEIOJVIZVJWSWTXIXKYIVMYHXHCDEXGXJOLXJSZXTVKVNVOXAXNX
      BXMRXBTXEVPVQXCEVRRZVSUDZRZXOXAXLXBXMYMVTXAXBXMYQXAWSYCXQXMYQUIYKYFYGAXHD
      EFYPXRXEILXTXSNMYPSZWAVBWBXAYRXEXDYPUDZXOXAXBTQZYRYTUIYNXATXEXDYPXCWCWCXB
      TWCQXAWDWEXEWCQXAXDGWFWEXAXQTXRXCULXCTWGYGXCXHDEIXRXCSXTLXSWHTXRXCWQWIXAU
      UAUBXDWJWKWLWTWSYBYTXOUIYEEYPYAXOGXDYDPYSXOSZWMUQWNWRXHCDEXOXGHXJLXTYOOKU
      UBWOWP $.
  $}

  ${
    deg1submon1p.d $e |- D = ( deg1 ` R ) $.
    deg1submon1p.o $e |- O = ( Monic1p ` R ) $.
    deg1submon1p.p $e |- P = ( Poly1 ` R ) $.
    deg1submon1p.m $e |- .- = ( -g ` P ) $.
    deg1submon1p.r $e |- ( ph -> R e. Ring ) $.
    deg1submon1p.f1 $e |- ( ph -> F e. O ) $.
    deg1submon1p.f2 $e |- ( ph -> ( D ` F ) = X ) $.
    deg1submon1p.g1 $e |- ( ph -> G e. O ) $.
    deg1submon1p.g2 $e |- ( ph -> ( D ` G ) = X ) $.
    $( The difference of two monic polynomials of the same degree is a
       polynomial of lesser degree.  (Contributed by Stefan O'Rear,
       28-Mar-2015.) $)
    deg1submon1p $p |- ( ph -> ( D ` ( F .- G ) ) < X ) $=
      ( cfv wcel cco1 cbs cn0 crg c0g wne mon1pcl syl mon1pn0 deg1nn0cl syl3anc
      eqid eqeltrrd cle nn0red leidd eqbrtrd cur fveq2d mon1pldg eqtr3d 3eqtr2d
      wceq deg1sublt ) AEUASZCUBSZFUASZBCDEFIGJLVFULZMAEBSZIUCPADUDTEVFTZECUESZ
      UFZVIUCTNAEHTZVJOVFCDEHLVHKUGUHZAVMVLOCDEHVKLVKULZKUIUHVFBCDEVKJLVOVHUJUK
      UMZNVNAVIIIUNPAIAIVPUOUPZUQAFHTZFVFTQVFCDFHLVHKUGUHAFBSZIIUNRVQUQVEULVGUL
      AIVESZDURSZVSVGSZIVGSAVIVESZVTWAAVIIVEPUSAVMWCWAVCOBDWAEHJWAULZKUTUHVAAVR
      WBWAVCQBDWAFHJWDKUTUHAVSIVGRUSVBVD $.
  $}

  ${
    $d B b f g p q r $.  $d D b f g p r $.  $d F f g q $.  $d G f g q $.
    $d .- b f g p r $.  $d P b f g p q $.  $d R b f g p q r $.
    $d .x. b f g p r $.
    q1pval.q $e |- Q = ( quot1p ` R ) $.
    q1pval.p $e |- P = ( Poly1 ` R ) $.
    q1pval.b $e |- B = ( Base ` P ) $.
    q1pval.d $e |- D = ( deg1 ` R ) $.
    q1pval.m $e |- .- = ( -g ` P ) $.
    q1pval.t $e |- .x. = ( .r ` P ) $.
    $( Value of the univariate polynomial quotient function.  (Contributed by
       Stefan O'Rear, 28-Mar-2015.) $)
    q1pval $p |- ( ( F e. B /\ G e. B ) -> ( F Q G ) =
          ( iota_ q e. B ( D ` ( F .- ( q .x. G ) ) ) < ( D ` G ) ) ) $=
      ( vf cfv cvv wceq vg vr vp vb wcel wa cv clt crio cmpt2 cpl1 elbasfv cq1p
      co wbr cbs cmulr csg cdg1 fveq2 syl6eqr csbeq1d fvex eqeltri adantl simpr
      csb a1i ad2antrr ad2antlr eqidd oveqd oveq123d fveq12d fveq1d riotaeqbidv
      breq12d mpt2eq123dv csbied eqtrd df-q1p mpt2ex fvmpt syl5eq syl oveqan12d
      id oveq2 fveq2d riotabidv simpl riotaex ovmpt2d ) GAUEZHAUEZUFZQUAGHAAQUG
      ZJUGZUAUGZFUNZIUNZBRZWSBRZUHUOZJAUIZGWRHFUNZIUNZBRZHBRZUHUOZJAUIZDSWODQUA
      AAXEUJZTZWNWOESUEZXMACUKHELMULXNDEUMRXLKUBEUCUBUGZUKRZUDUCUGZUPRZQUAUDUGZ
      XSWQWRWSXQUQRZUNZXQURRZUNZXOUSRZRZWSYDRZUHUOZJXSUIZUJZVGZVGZXLSUMXOETZYKU
      CCYJVGXLYLUCXPCYJYLXPEUKRZCXOEUKUTLVAVBYLUCCYJXLSCSUEYLCYMSLEUKVCVDVHYLXQ
      CTZUFZYJUDAYIVGXLYOUDXRAYIYOXRCUPRZAYNXRYPTYLXQCUPUTVEMVAVBYOUDAYIXLSASUE
      YOAYPSMCUPVCVDZVHYOXSATZUFZQUAXSXSYHAAXEYOYRVFZYTYSYGXDJXSAYTYSYEXBYFXCUH
      YSYCXAYDBYSYDEUSRZBYLYDUUATYNYRXOEUSUTVINVAZYSWQWQYAWTYBIYSYBCURRZIYNYBUU
      CTYLYRXQCURUTVJOVAYSWQVKYSXTFWRWSYSXTCUQRZFYNXTUUDTYLYRXQCUQUTVJPVAVLVMVN
      YSWSYDBUUBVOVQVPVRVSVTVSVTQUAUBJUCUDWAQUAAAXEYQYQWBWCWDWEVEWQGTZWSHTZUFZX
      EXKTWPUUGXDXJJAUUGXBXHXCXIUHUUGXAXGBUUEUUFWQGWTXFIUUEWGWSHWRFWHWFWIUUFXCX
      ITUUEWSHBUTVEVQWJVEWNWOWKWNWOVFXKSUEWPXJJAWLVHWM $.

    $d C q $.  $d D q $.  $d .- q $.  $d .x. q $.  $d X q $.
    q1peqb.c $e |- C = ( Unic1p ` R ) $.
    $( Characterizing property of the polynomial quotient.  (Contributed by
       Stefan O'Rear, 28-Mar-2015.) $)
    q1peqb $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) ->
        ( ( X e. B /\ ( D ` ( F .- ( X .x. G ) ) ) < ( D ` G ) ) <->
          ( F Q G ) = X ) ) $=
      ( vq wcel crg w3a cvv co cfv clt wbr wa wceq elex adantr ovex eleq1 mpbii
      wi a1i wb cio simpr weu wreu cui c0g eqid simp1 simp2 uc1pcl 3ad2ant3 wne
      uc1pn0 cco1 uc1pldg ply1divalg2 df-reu sylib oveq2d fveq2d breq1d anbi12d
      oveq1 adantl iota2d crio q1pval syl2anc riotaiota syl eqtrd eqeq1d bitr4d
      cv ex pm5.21ndd ) FUATZHATZIBTZUBZKUCTZKATZHKIGUDZJUDZCUEZICUEZUFUGZUHZHI
      EUDZKUIZXEWRUOWQWSWRXDKAUJUKUPXGWRUOWQXGXFUCTWRHIEULXFKUCUMUNUPWQWRXEXGUQ
      WQWRUHZXESWKZATZHXIIGUDZJUDZCUEZXCUFUGZUHZSURZKUIXGXHXOXESKUCWQWRUSWQXOSU
      TZWRWQXNSAVAZXQWQACDFGFVBUEZHIJDVCUEZSMONPXTVDZQWNWOWPVEWNWOWPVFZWPWNIATZ
      WOABDFIMNRVGVHZWPWNIXTVIWOBDFIXTMYARVJVHWPWNXCIVKUEUEXSTWOBCFXSIOXSVDZRVL
      VHYEVMZXNSAVNVOUKXIKUIZXOXEUQXHYGXJWSXNXDXIKAUMYGXMXBXCUFYGXLXACYGXKWTHJX
      IKIGVTVPVQVRVSWAWBXHXFXPKWQXFXPUIWRWQXFXNSAWCZXPWQWOYCXFYHUIYBYDACDEFGHIJ
      SLMNOPQWDWEWQXRYHXPUIYFXNSAWFWGWHUKWIWJWLWM $.
  $}

  ${
    q1pcl.q $e |- Q = ( quot1p ` R ) $.
    q1pcl.p $e |- P = ( Poly1 ` R ) $.
    q1pcl.b $e |- B = ( Base ` P ) $.
    q1pcl.c $e |- C = ( Unic1p ` R ) $.
    $( Closure of the quotient by a unitic polynomial.  (Contributed by Stefan
       O'Rear, 28-Mar-2015.) $)
    q1pcl $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) -> ( F Q G ) e. B ) $=
      ( crg wcel w3a co cmulr cfv csg cdg1 eqid clt wbr wa q1peqb mpbiri simpld
      wceq ) ELMFAMGBMNZFGDOZAMZFUIGCPQZOCRQZOESQZQGUMQUAUBZUHUJUNUCUIUIUGUITAB
      UMCDEUKFGULUIHIJUMTULTUKTKUDUEUF $.
  $}

  ${
    r1pval.e $e |- E = ( rem1p ` R ) $.
    r1pval.p $e |- P = ( Poly1 ` R ) $.
    r1pval.b $e |- B = ( Base ` P ) $.
    ${
      $d B b f g r $.  $d F f g $.  $d G f g $.  $d .- b f g r $.
      $d Q b f g r $.  $d R b f g r $.  $d .x. b f g r $.
      r1pval.q $e |- Q = ( quot1p ` R ) $.
      r1pval.t $e |- .x. = ( .r ` P ) $.
      r1pval.m $e |- .- = ( -g ` P ) $.
      $( Value of the polynomial remainder function.  (Contributed by Stefan
         O'Rear, 28-Mar-2015.) $)
      r1pval $p |- ( ( F e. B /\ G e. B ) -> ( F E G ) =
          ( F .- ( ( F Q G ) .x. G ) ) ) $=
        ( vf vg co cvv cfv vr vb wcel wa cv cmpt2 wceq cpl1 elbasfv adantr cr1p
        cbs cq1p cmulr csg csb fveq2 syl6eqr fveq2d csbeq1d eqeltri simpr eqidd
        fvex oveqd oveq123d mpt2eq123dv csbied eqtrd df-r1p mpt2ex fvmpt syl5eq
        a1i syl simpl oveq12 oveq12d adantl ovex ovmpt2d ) GAUCZHAUCZUDZPQGHAAP
        UEZWEQUEZCRZWFERZIRZGGHCRZHERZIRZFSWDDSUCZFPQAAWIUFZUGWBWMWCABUHGDKLUIU
        JWMFDUKTWNJUADUBUAUEZUHTZULTZPQUBUEZWRWEWEWFWOUMTZRZWFWPUNTZRZWPUOTZRZU
        FZUPZWNSUKWODUGZXFUBAXEUPWNXGUBWQAXEXGWQBULTZAXGWPBULXGWPDUHTBWODUHUQKU
        RZUSLURUTXGUBAXEWNSASUCXGAXHSLBULVDVAZVNXGWRAUGZUDPQWRWRXDAAWIXGXKVBZXL
        XGXDWIUGXKXGWEWEXBWHXCIXGXCBUOTIXGWPBUOXIUSOURXGWEVCXGWTWGWFWFXAEXGXABU
        NTEXGWPBUNXIUSNURXGWSCWEWFXGWSDUMTCWODUMUQMURVEXGWFVCVFVFUJVGVHVIPQUAUB
        VJPQAAWIXJXJVKVLVMVOWEGUGZWFHUGZUDZWIWLUGWDXOWEGWHWKIXMXNVPXOWGWJWFHEWE
        GWFHCVQXMXNVBVRVRVSWBWCVPWBWCVBWLSUCWDGWKIVTVNWA $.
    $}

    r1pcl.c $e |- C = ( Unic1p ` R ) $.
    $( Closure of remainder following division by a unitic polynomial.
       (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
    r1pcl $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) -> ( F E G ) e. B ) $=
      ( crg wcel w3a co cq1p cfv cmulr eqid syl3anc wceq uc1pcl 3ad2ant3 r1pval
      csg simp2 syl2anc cgrp ply1rng 3ad2ant1 rnggrp syl q1pcl grpsubcl eqeltrd
      rngcl ) DLMZFAMZGBMZNZFGEOZFFGDPQZOZGCRQZOZCUEQZOZAUTURGAMZVAVGUAUQURUSUF
      ZUSUQVHURABCDGIJKUBUCZACVBDVDEFGVFHIJVBSZVDSZVFSZUDUGUTCUHMZURVEAMZVGAMUT
      CLMZVNUQURVPUSCDIUIUJZCUKULVIUTVPVCAMVHVOVQABCVBDFGVKIJKUMVJACVDVCGJVLUPT
      ACVFFVEJVMUNTUO $.

    r1pdeglt.d $e |- D = ( deg1 ` R ) $.
    $( The remainder has a degree smaller than the divisor.  (Contributed by
       Stefan O'Rear, 28-Mar-2015.) $)
    r1pdeglt $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) ->
        ( D ` ( F E G ) ) < ( D ` G ) ) $=
      ( crg wcel co cfv clt wceq eqid w3a cq1p cmulr csg uc1pcl 3ad2ant3 r1pval
      simp2 syl2anc fveq2d wbr wa q1peqb mpbiri simprd eqbrtrd ) ENOZGAOZHBOZUA
      ZGHFPZCQGGHEUBQZPZHDUCQZPDUDQZPZCQZHCQZRUTVAVFCUTURHAOZVAVFSUQURUSUHUSUQV
      IURABDEHJKLUEUFADVBEVDFGHVEIJKVBTZVDTZVETZUGUIUJUTVCAOZVGVHRUKZUTVMVNULVC
      VCSVCTABCDVBEVDGHVEVCVJJKMVLVKLUMUNUOUP $.
  $}

  ${
    r1pid.p $e |- P = ( Poly1 ` R ) $.
    r1pid.b $e |- B = ( Base ` P ) $.
    r1pid.c $e |- C = ( Unic1p ` R ) $.
    r1pid.q $e |- Q = ( quot1p ` R ) $.
    r1pid.e $e |- E = ( rem1p ` R ) $.
    r1pid.t $e |- .x. = ( .r ` P ) $.
    r1pid.m $e |- .+ = ( +g ` P ) $.
    $( Express the original polynomial ` F ` as ` F = ( q x. G ) + r ` using
       the quotient and remainder functions for ` q ` and ` r ` .  (Contributed
       by Mario Carneiro, 5-Jun-2015.) $)
    r1pid $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) ->
      F = ( ( ( F Q G ) .x. G ) .+ ( F E G ) ) ) $=
      ( wcel co syl3anc crg w3a csg cfv wceq uc1pcl r1pval sylan2 3adant1 cabel
      eqid oveq2d ply1rng 3ad2ant1 rngabl syl q1pcl 3ad2ant3 rngcl rnggrp simp2
      cgrp grpsubcl ablcom grpnpcan 3eqtrrd ) FUARZIARZJBRZUBZIJESZJGSZIJHSZDSV
      LIVLCUCUDZSZDSZVOVLDSZIVJVMVOVLDVHVIVMVOUEZVGVIVHJARZVRABCFJKLMUFZACEFGHI
      JVNOKLNPVNUKZUGUHUIULVJCUJRZVLARZVOARZVPVQUEVJCUARZWBVGVHWEVICFKUMUNZCUOU
      PVJWEVKARVSWCWFABCEFIJNKLMUQVIVGVSVHVTURACGVKJLPUSTZVJCVBRZVHWCWDVJWEWHWF
      CUTUPZVGVHVIVAZWGACVNIVLLWAVCTADCVLVOLQVDTVJWHVHWCVQIUEWIWJWGADCVNIVLLQWA
      VETVF $.
  $}

  ${
    dvdsq1p.p $e |- P = ( Poly1 ` R ) $.
    dvdsq1p.d $e |- .|| = ( ||r ` P ) $.
    dvdsq1p.b $e |- B = ( Base ` P ) $.
    dvdsq1p.c $e |- C = ( Unic1p ` R ) $.
    ${
      $d B q $.  $d C q $.  $d F q $.  $d G q $.  $d P q $.  $d Q q $.
      $d R q $.  $d .x. q $.
      dvdsq1p.t $e |- .x. = ( .r ` P ) $.
      dvdsq1p.q $e |- Q = ( quot1p ` R ) $.
      $( Divisibility in a polynomial ring is witnessed by the quotient.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      dvdsq1p $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) -> ( G .|| F <->
            F = ( ( F Q G ) .x. G ) ) ) $=
        ( vq wcel wceq syl cfv crg w3a wbr co cv wrex wb uc1pcl 3ad2ant3 dvdsr2
        wa eqcom simprr csg cdg1 clt simprl cmnf c0g cgrp simpl1 ply1rng rnggrp
        simpl2 simpr adantr rngcl syl3anc eqid grpsubeq0 biimprd impr fveq2d cr
        deg1z eqtrd uc1pdeg 3adant2 nn0red mnflt eqbrtrd q1peqb mpbi2and oveq1d
        cn0 eqtr4d expr syl5bi rexlimdva sylbid q1pcl dvdsrmul breq2 syl5ibrcom
        syl2anc impbid ) FUAQZHAQZIBQZUBZIHCUCZHHIEUDZIGUDZRZWTXAPUEZIGUDZHRZPA
        UFZXDWTIAQZXAXHUGWSWQXIWRABDFIJLMUHUIZPACDGIHLKNUJSWTXGXDPAXGHXFRZWTXEA
        QZUKZXDXFHULWTXLXKXDWTXLXKUKZUKZHXFXCWTXLXKUMXOXBXEIGXOXLHXFDUNTZUDZFUO
        TZTZIXRTZUPUCZXBXERZWTXLXKUQXOXSURXTUPXOXSDUSTZXRTZURXOXQYCXRWTXLXKXQYC
        RZXMYEXKXMDUTQZWRXFAQZYEXKUGXMDUAQZYFXMWQYHWQWRWSXLVADFJVBSZDVCSWQWRWSX
        LVDXMYHXLXIYGYIWTXLVEWTXIXLXJVFADGXEILNVGVHADXPHXFYCLYCVIZXPVIZVJVHVKVL
        VMXOWQYDURRWQWRWSXNVAXRDFYCXRVIZJYJVOSVPXOXTVNQZURXTUPUCWTYMXNWTXTWQWSX
        TWEQWRBXRFIYLMVQVRVSVFXTVTSWAWTXLYAUKYBUGXNABXRDEFGHIXPXEOJLYLYKNMWBVFW
        CWDWFWGWHWIWJWTXAXDIXCCUCZWTXIXBAQYNXJABDEFHIOJLMWKACDGIXBLKNWLWOHXCICW
        MWNWP $.
    $}

    ${
      dvdsr1p.z $e |- .0. = ( 0g ` P ) $.
      dvdsr1p.e $e |- E = ( rem1p ` R ) $.
      $( Divisibility in a polynomial ring in terms of the remainder.
         (Contributed by Stefan O'Rear, 28-Mar-2015.) $)
      dvdsr1p $p |- ( ( R e. Ring /\ F e. B /\ G e. C ) -> ( G .|| F <->
            ( F E G ) = .0. ) ) $=
        ( wcel cfv co wceq eqid crg w3a cq1p cmulr csg cgrp wb ply1rng 3ad2ant1
        wbr rnggrp syl simp2 q1pcl uc1pcl 3ad2ant3 rngcl syl3anc r1pval syl2anc
        grpsubeq0 eqeq1d dvdsq1p 3bitr4rd ) EUAPZGAPZHBPZUBZGGHEUCQZRZHDUDQZRZD
        UEQZRZISZGVLSZGHFRZISHGCUJVHDUFPZVFVLAPZVOVPUGVHDUAPZVRVEVFVTVGDEJUHUIZ
        DUKULVEVFVGUMZVHVTVJAPHAPZVSWAABDVIEGHVITZJLMUNVGVEWCVFABDEHJLMUOUPZADV
        KVJHLVKTZUQURADVMGVLILNVMTZVAURVHVQVNIVHVFWCVQVNSWBWEADVIEVKFGHVMOJLWDW
        FWGUSUTVBABCDVIEVKGHJKLMWFWDVCVD $.
    $}
  $}

  ${
    $d x A $.  $d x G $.  $d x K $.  $d x N $.  $d x O $.  $d x P $.  $d x R $.
    $d x ph $.  $d x .0. $.
    ply1rem.p $e |- P = ( Poly1 ` R ) $.
    ply1rem.b $e |- B = ( Base ` P ) $.
    ply1rem.k $e |- K = ( Base ` R ) $.
    ply1rem.x $e |- X = ( var1 ` R ) $.
    ply1rem.m $e |- .- = ( -g ` P ) $.
    ply1rem.a $e |- A = ( algSc ` P ) $.
    ply1rem.g $e |- G = ( X .- ( A ` N ) ) $.
    ply1rem.o $e |- O = ( eval1 ` R ) $.
    ply1rem.1 $e |- ( ph -> R e. NzRing ) $.
    ply1rem.2 $e |- ( ph -> R e. CRing ) $.
    ply1rem.3 $e |- ( ph -> N e. K ) $.
    ${
      ply1rem.u $e |- U = ( Monic1p ` R ) $.
      ply1rem.d $e |- D = ( deg1 ` R ) $.
      ply1rem.z $e |- .0. = ( 0g ` R ) $.
      $( A term of the form ` x - N ` is linear, monic, and has exactly one
         zero.  (Contributed by Mario Carneiro, 12-Jun-2015.) $)
      ply1remlem $p |- ( ph ->
         ( G e. U /\ ( D ` G ) = 1 /\ ( `' ( O ` G ) " { .0. } ) = { N } ) ) $=
        ( vx wcel cfv c1 wceq ccnv csn cima c0g wne cco1 cur co cgrp crg nzrrng
        syl ply1rng rnggrp vr1cl wf ply1sclf ffvelrnd grpsubcl syl3anc syl5eqel
        cnzr cn0 fveq2i clt cc0 cxr deg1xrcl 0xr a1i cr 1re rexr mp1i deg1sclle
        cle wbr syl2anc 0lt1 xrlelttrd cmgp cmg eqid mgpbas mulg1 fveq2d deg1pw
        sylancl eqtr3d breqtrrd deg1sub syl5eq eqtrd syl6eqel deg1nn0clb mpbird
        1nn0 wb csg fveq1i coe1subfv syl31anc cvsca oveq2d ply1sca oveq1d clmod
        ply1lmod lmodvs1 3eqtrd fveq1d rngidcl coe1tmfv1 cv cif coe1scl ax-1ne0
        csca cmpt neeq1 mpbiri ifnefalse fvex wa adantr cbs cvv fvmpt grpsubid1
        ax-mp syl6eq oveq12d ismon1p syl3anbrc simpr evl1vard evl1scad evl1subd
        ccrg simprd eqeq1d grpsubeq0 elsn syl6bbr pm5.32da wfn cpws eqeltri crh
        bitrd evl1rhm rhmf pwselbas fniniseg snssd sseld pm4.71rd 3bitr4d eqrdv
        ffn 3jca ) AHGUJZHDUKZULUMHLUKZUNNUOUPZKUOZUMAHCUJZHEUQUKZURZUVPHUSUKZU
        KZFUTUKZUMUVOAHMKBUKZJVAZCUAAEVBUJZMCUJZUWFCUJZUWGCUJZAEVCUJZUWHAFVCUJZ
        UWLAFVOUJZUWMUCFVDVEZEFOVFVEEVGVEAUWMUWIUWOCEFMROPVHVEZAICKBAUWMICBVIUW
        OBCEFIOTQPVJVEUEVKZCEJMUWFPSVLVMVNZAUWBUVPVPUJZAUVPULVPAUVPMDUKZULAUVPU
        WGDUKUWTHUWGDUAVQACDFMUWFJEOUGUWOPSUWPUWQAUWFDUKZULUWTVRAUXAVSULAUWJUXA
        VTUJUWQCDEFUWFUGOPWAVEVSVTUJAWBWCULWDUJULVTUJAWEULWFWGAUWMKIUJZUXAVSWIW
        JUWOUEBDEFKIUGOQTWHWKVSULVRWJAWLWCWMAULMEWNUKZWOUKZVAZDUKZUWTULAUXEMDAU
        WIUXEMUMUWPCUXDUXCMCEUXCUXCWPZPWQUXDWPZWRVEZWSAUWNULVPUJZUXFULUMUCXJDEF
        UXDULUXCMUGORUXGUXHWTXAXBZXCXDXEUXKXFZXJXGAUWMUVTUWBUWSXKUWOUWRCDEFHUWA
        UGOUWAWPZPXHWKXIAUWDULUWCUKZULMUSUKZUKZULUWFUSUKZUKZFXLUKZVAZUWEAUVPULU
        WCUXLWSAUXNULUWGUSUKZUKZUXTULUWCUYAHUWGUSUAVQXMAUWMUWIUWJUXJUYBUXTUMUWO
        UWPUWQUXJAXJWCZCFMUWFJUXSULEOPSUXSWPZXNXOXEAUXTUWEFUQUKZUXSVAZUWEAUXPUW
        EUXRUYEUXSAULUWEUXEEXPUKZVAZUSUKZUKZUXPUWEAULUYIUXOAUYHMUSAUYHUWEMUYGVA
        EYKUKZUTUKZMUYGVAZMAUXEMUWEUYGUXIXQAUWEUYLMUYGAFUYKUTAUWNFUYKUMUCEFVOOX
        RVEWSXSAEXTUJZUWIUYMMUMAUWMUYNUWOEFOYAVEUWPUYGUYLUYKCEMPUYKWPUYGWPZUYLW
        PYBWKYCWSYDAUWMUWEIUJZUXJUYJUWEUMUWOAUWMUYPUWOIFUWEQUWEWPZYEVEZUYCUWEUL
        EFUYGUXDIUXCMNUHQORUYOUXGUXHYFVMXBAUXRULUIVPUIYGZVSUMKUYEYHZYLZUKZUYEAU
        LUXQVUAAUWMUXBUXQVUAUMUWOUEUIBEFIKUYEOTQUYEWPZYIWKYDUXJVUBUYEUMXJUIULUY
        TUYEVPVUAUYSULUMZUYSVSURZUYTUYEUMVUDVUEULVSURYJUYSULVSYMYNUYSVSKUYEYOVE
        VUAWPFUQYPUUAUUCUUDUUEAFVBUJZUYPUYFUWEUMAUWMVUFUWOFVGVEZUYRIFUXSUWEUYEQ
        VUCUYDUUBWKXFYCCDEFUWEHGUWAOPUXMUGUFUYQUUFUUGUXLAUIUVRUVSAUYSIUJZUYSUVQ
        UKZNUMZYQZVUHUYSUVSUJZYQUYSUVRUJZVULAVUHVUJVULAVUHYQZVUJUYSKUMZVULVUNVU
        JUYSKUXSVAZNUMZVUOVUNVUIVUPNVUNVUIUYSUWGLUKZUKZVUPUYSUVQVURHUWGLUAVQXMV
        UNUWKVUSVUPUMVUNIUXSEFCMJUWFLUYSKUYSUBOQPAFUULUJZVUHUDYRZAVUHUUHZVUNIEF
        CLMUYSUBRQOPVVAVVBUUIVUNBIEFCLKUYSUBOQTPVVAAUXBVUHUEYRZVVBUUJSUYDUUKUUM
        XEUUNVUNVUFVUHUXBVUQVUOXKAVUFVUHVUGYRVVBVVCIFUXSUYSKNQUHUYDUUOVMUVCUIKU
        UPUUQUURAUVQIUUSZVUMVUKXKAIIUVQVIVVDAIFIFIUUTVAZYSUKZVOUVQVVEYTVVEWPZQV
        VFWPZUCIYTUJAIFYSUKYTQFYSYPUVAWCACVVFHLALEVVEUVBVAUJZCVVFLVIAVUTVVIUDIE
        FVVELUBOVVGQUVDVECVVFEVVELPVVHUVEVEUWRVKUVFIIUVQUVMVEINUYSUVQUVGVEAVULV
        UHAUVSIUYSAKIUEUVHUVIUVJUVKUVLUVN $.
    $}

    ply1rem.4 $e |- ( ph -> F e. B ) $.
    ${
      ply1rem.e $e |- E = ( rem1p ` R ) $.
      $( The polynomial remainder theorem, or little B&eacute;zout's theorem
         (by contrast to the regular B&eacute;zout's theorem ~ bezout ).  If a
         polynomial ` F ` is divided by the linear factor ` x - A ` , the
         remainder is equal to ` F ( A ) ` , the evaluation of the polynomial
         at ` A ` (interpreted as a constant polynomial).  (Contributed by
         Mario Carneiro, 12-Jun-2015.) $)
      ply1rem $p |- ( ph ->
        ( F E G ) = ( A ` ( ( O ` F ) ` N ) ) ) $=
        ( co cc0 cco1 cfv cdg1 cle wbr wceq cn0 wcel csn c1 caddc clt crg cuc1p
        cmnf cnzr nzrrng syl cmn1 ccnv cima ply1remlem simp1d mon1puc1p syl2anc
        c0g eqid r1pdeglt syl3anc simp2d breqtrd 1e0p1 syl6breq nn0leltp1 mpan2
        wb 0nn0 syl5ibrcom wi elsni cxr 0xr mnfle ax-mp syl6eqbr a1i cun deg1cl
        r1pcl elun sylib mpjaod deg1le0 mpbid cq1p cmulr cplusg cof cpws fveq2d
        wo r1pid cghm crh evl1rhm rhmghm ply1rng q1pcl mon1pcl rngcl ghmlin cbs
        ccrg cvv fvex eqeltri rhmf ffvelrnd pwsplusgval 3eqtrd wfn pwselbas ffn
        wf fveq1d fnfvof syl22anc rhmmul pwsmulrval eqtrd wa snidg simp3d rngrz
        eleqtrrd fniniseg simprd oveq2d oveq1d cgrp rnggrp grplid coe1f ffvelrn
        cxp sylancl evl1sca fvconst2 eqtr4d ) AGHFUGZUHUURUIUJZUJZBUJZKGLUJZUJZ
        BUJAUUREUKUJZUJZUHULUMZUURUVAUNZAUVEUOUPZUVFUVEVCUQZUPZAUVFUVHUVEUHURUS
        UGZUTUMZAUVEURUVKUTAUVEHUVDUJZURUTAEVAUPZGCUPZHEVBUJZUPZUVEUVMUTUMAEVDU
        PUVNUBEVEVFZUEAUVNHEVGUJZUPZUVQUVRAUVTUVMURUNZHLUJZVHEVNUJZUQVIZKUQZUNZ
        ABCUVDDEUVSHIJKLMUWCNOPQRSTUAUBUCUDUVSVOZUVDVOZUWCVOZVJZVKZUVPEUVSHUVPV
        OZUWGVLVMZCUVPUVDDEFGHUFNOUWLUWHVPVQAUVTUWAUWFUWJVRVSVTWAUVHUHUOUPZUVFU
        VLWDWEUVEUHWBWCWFUVJUVFWGAUVJUVEVCUHULUVEVCWHUHWIUPVCUHULUMWJUHWKWLWMWN
        AUVEUOUVIWOUPZUVHUVJXIAUURCUPZUWOAUVNUVOUVQUWPUVRUEUWMCUVPDEFGHUFNOUWLW
        QVQZCUVDDEUURUWHNOWPVFUVEUOUVIWRWSWTAUVNUWPUVFUVGWDUVRUWQBCUVDDEUURUWHN
        OSXAVMXBZAUVCUUTBAUVCKGHEXCUJZUGZHDXDUJZUGZLUJZUURLUJZEXEUJZXFUGZUJZKUX
        DUJZUUTAKUVBUXFAUVBUXBUURDXEUJZUGZLUJZUXCUXDEIXGUGZXEUJZUGZUXFAGUXJLAUV
        NUVOUVQGUXJUNUVRUEUWMCUVPDUXIUWSEUXAFGHNOUWLUWSVOZUFUXAVOZUXIVOZXJVQXHA
        LDUXLXKUGUPZUXBCUPZUWPUXKUXNUNALDUXLXLUGUPZUXRAEYAUPZUXTUCIDEUXLLUANUXL
        VOZPXMVFZDUXLLXNVFADVAUPZUWTCUPZHCUPZUXSAUVNUYDUVRDENXOVFAUVNUVOUVQUYEU
        VRUEUWMCUVPDUWSEGHUXONOUWLXPVQZAUVTUYFUWKCDEHUVSNOUWGXQVFZCDUXAUWTHOUXP
        XRVQZUWQUXIUXMDUXLUXBLUURCOUXQUXMVOZXSVQAUXLXTUJZUXEUXMEUXCUXDIVDYBUXLU
        YBUYKVOZUBIYBUPZAIEXTUJYBPEXTYCYDWNZACUYKUXBLAUXTCUYKLYLUYCCUYKDUXLLOUY
        LYEVFZUYIYFZACUYKUURLUYOUWQYFZUXEVOZUYJYGYHYMAUXGKUXCUJZUXHUXEUGZUWCUXH
        UXEUGZUXHAUXCIYIZUXDIYIZUYMKIUPZUXGUYTUNAIIUXCYLVUBAIEIUYKVDUXCUXLYBUYB
        PUYLUBUYNUYPYJIIUXCYKVFAIIUXDYLVUCAIEIUYKVDUXDUXLYBUYBPUYLUBUYNUYQYJZII
        UXDYKVFUYNUDIUXEUXCUXDYBKYNYOAUYSUWCUXHUXEAUYSKUWTLUJZUWBEXDUJZXFUGZUJZ
        KVUFUJZKUWBUJZVUGUGZUWCAKUXCVUHAUXCVUFUWBUXLXDUJZUGZVUHAUXTUYEUYFUXCVUN
        UNUYCUYGUYHUWTHDUXLUXAVUMLCOUXPVUMVOZYPVQAUYKEVUMVUGVUFUWBIVDYBUXLUYBUY
        LUBUYNACUYKUWTLUYOUYGYFZACUYKHLUYOUYHYFZVUGVOZVUOYQYRYMAVUFIYIZUWBIYIZU
        YMVUDVUIVULUNAIIVUFYLVUSAIEIUYKVDVUFUXLYBUYBPUYLUBUYNVUPYJZIIVUFYKVFAII
        UWBYLVUTAIEIUYKVDUWBUXLYBUYBPUYLUBUYNVUQYJIIUWBYKVFZUYNUDIVUGVUFUWBYBKY
        NYOAVULVUJUWCVUGUGZUWCAVUKUWCVUJVUGAVUDVUKUWCUNZAKUWDUPZVUDVVDYSZAKUWEU
        WDAVUDKUWEUPUDKIYTVFAUVTUWAUWFUWJUUAUUCAVUTVVEVVFWDVVBIUWCKUWBUUDVFXBUU
        EUUFAUVNVUJIUPVVCUWCUNUVRAIIKVUFVVAUDYFIEVUGVUJUWCPVURUWIUUBVMYRYHUUGAE
        UUHUPZUXHIUPVUAUXHUNAUVNVVGUVREUUIVFAIIKUXDVUEUDYFIUXEEUXHUWCPUYRUWIUUJ
        VMYHAUXHKIUUTUQUUMZUJZUUTAKUXDVVHAUXDUVALUJZVVHAUURUVALUWRXHAUYAUUTIUPZ
        VVJVVHUNUCAUOIUUSYLZUWNVVKAUWPVVLUWQUUSCDEUURIUUSVOONPUUKVFWEUOIUHUUSUU
        LUUNBIDELUUTUANPSUUOVMYRYMAVUDVVIUUTUNUDIUUTKUHUUSYCUUPVFYRYHXHUUQ $.
    $}

    facth1.z $e |- .0. = ( 0g ` R ) $.
    facth1.d $e |- .|| = ( ||r ` P ) $.
    $( The factor theorem and its converse.  A polynomial ` F ` has a root at
       ` A ` iff ` G = x - A ` is a factor of ` F ` .  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    facth1 $p |- ( ph -> ( G .|| F <-> ( ( O ` F ) ` N ) = .0. ) ) $=
      ( wbr cr1p cfv co c0g wceq crg wcel cuc1p wb cnzr nzrrng syl cmn1 cdg1 c1
      ccnv csn cima ply1remlem simp1d mon1puc1p syl2anc dvdsr1p syl3anc ply1rem
      eqid ply1scl0 eqcomd eqeq12d wf1 ply1sclf1 cpws cbs cvv fvex eqeltri ccrg
      a1i crh wf evl1rhm rhmf ffvelrnd pwselbas rng0cl f1fveq syl12anc 3bitrd )
      AHGDUIZGHFUJUKZULZEUMUKZUNZKGLUKZUKZBUKZNBUKZUNZXDNUNZAFUOUPZGCUPHFUQUKZU
      PZWRXBURAFUSUPXIUCFUTVAZUFAXIHFVBUKZUPZXKXLAXNHFVCUKZUKVDUNHLUKVENVFVGKVF
      UNABCXOEFXMHIJKLMNOPQRSTUAUBUCUDUEXMVOZXOVOUGVHVIXJFXMHXJVOZXPVJVKCXJDEFW
      SGHXAOUHPXQXAVOZWSVOZVLVMAWTXEXAXFABCEFWSGHIJKLMOPQRSTUAUBUCUDUEUFXSVNAXF
      XAAXIXFXAUNXLBEFXANOTUGXRVPVAVQVRAICBVSZXDIUPNIUPZXGXHURAXIXTXLBCEFIOTQPV
      TVAAIIKXCAIFIFIWAULZWBUKZUSXCYBWCYBVOZQYCVOZUCIWCUPAIFWBUKWCQFWBWDWEWGACY
      CGLALEYBWHULUPZCYCLWIAFWFUPYFUDIEFYBLUBOYDQWJVACYCEYBLPYEWKVAUFWLWMUEWLAX
      IYAXLIFNQUGWNVAICXDNBWOWPWQ $.
  $}

  ${
    $d d f g x B $.  $d d f g x D $.  $d f g x F $.  $d g N $.  $d d f g x O $.
    $d g x G $.  $d g P $.  $d x ph $.  $d d f g x R $.  $d d f g x W $.
    $d x T $.
    fta1g.p $e |- P = ( Poly1 ` R ) $.
    fta1g.b $e |- B = ( Base ` P ) $.
    fta1g.d $e |- D = ( deg1 ` R ) $.
    fta1g.o $e |- O = ( eval1 ` R ) $.
    fta1g.w $e |- W = ( 0g ` R ) $.
    fta1g.z $e |- .0. = ( 0g ` P ) $.
    fta1g.1 $e |- ( ph -> R e. IDomn ) $.
    fta1g.2 $e |- ( ph -> F e. B ) $.
    ${
      fta1glem.k $e |- K = ( Base ` R ) $.
      fta1glem.x $e |- X = ( var1 ` R ) $.
      fta1glem.m $e |- .- = ( -g ` P ) $.
      fta1glem.a $e |- A = ( algSc ` P ) $.
      fta1glem.g $e |- G = ( X .- ( A ` T ) ) $.
      fta1glem.3 $e |- ( ph -> N e. NN0 ) $.
      fta1glem.4 $e |- ( ph -> ( D ` F ) = ( N + 1 ) ) $.
      fta1glem.5 $e |- ( ph -> T e. ( `' ( O ` F ) " { W } ) ) $.
      $( Lemma for ~ fta1g .  (Contributed by Mario Carneiro, 7-Jun-2016.) $)
      fta1glem1 $p |- ( ph -> ( D ` ( F ( quot1p ` R ) G ) ) = N ) $=
        ( c1 cq1p cfv co cc wcel ax-1cn a1i crg wne cn0 cnzr cidom cdomn isidom
        ccrg simprbi domnnzr syl nzrrng cuc1p cmn1 wceq ccnv csn simplbi wa wfn
        cima wb wf cpws cbs cvv eqid fvex eqeltri crh evl1rhm ffvelrnd pwselbas
        rhmf ffn mpbid simpld ply1remlem simp1d mon1puc1p syl2anc q1pcl syl3anc
        fniniseg cmulr caddc peano2nn0 deg1nn0clb mpbird cdsr wbr simprd facth1
        eqeltrd dvdsq1p eqcomd ply1crng crngrng mon1pcl rnglz 3netr4d deg1nn0cl
        oveq1 necon3i nn0cnd crngcom eqtrd fveq2d crlreg 1nn0 syl6eqel cui cco1
        simp2d wss unitrrg uc1pldg sseldd deg1mul2 3eqtr3d 3eqtr3rd addcanad
        addcom sylancl oveq1d ) AUMHIFUNUOZUPZDUOZLUMUQURZAUSUTAUUHAFVAURZUUGCU
        RZUUGPVBZUUHVCURAFVDURZUUJAFVEURZUUMUCUUNFVFURZUUMUUNFVHURZUUOFVGZVIFVJ
        VKVKZFVLVKZAUUJHCURZIFVMUOZURZUUKUUSUDAUUJIFVNUOZURZUVBUUSAUVDIDUOZUMVO
        ZIMUOVPNVQZWAGVQVOZABCDEFUVCIJKGMONQRUEUFUGUHUITUURAUUNUUPUCUUNUUPUUOUU
        QVRVKZAGJURZGHMUOZUONVOZAGUVKVPUVGWAURZUVJUVLVSZULAUVKJVTZUVMUVNWBAJJUV
        KWCUVOAJFJFJWDUPZWEUOZVEUVKUVPWFUVPWGZUEUVQWGZUCJWFURAJFWEUOWFUEFWEWHWI
        UTACUVQHMAMEUVPWJUPURZCUVQMWCAUUPUVTUVIJEFUVPMTQUVRUEWKVKCUVQEUVPMRUVSW
        NVKUDWLWMJJUVKWOVKJNGUVKXDVKWPZWQZUVCWGZSUAWRZWSZUVAFUVCIUVAWGZUWCWTXAZ
        CUVAEUUFFHIUUFWGZQRUWFXBXCZAUUGIEXEUOZUPZPIUWJUPZVBUULAHPUWKUWLAHPVBZHD
        UOZVCURZAUWNLUMXFUPZVCUKALVCURUWPVCURUJLXGVKXNAUUJUUTUWMUWOWBUUSUDCDEFH
        PSQUBRXHXAXIAHUWKAIHEXJUOZXKZHUWKVOZAUWRUVLAUVJUVLUWAXLABCUWQEFHIJKGMON
        QRUEUFUGUHUITUURUVIUWBUDUAUWQWGZXMXIAUUJUUTUVBUWRUWSWBUUSUDUWGCUVAUWQEU
        UFFUWJHIQUWTRUWFUWJWGZUWHXOXCWPZXPAEVAURZICURZUWLPVOAEVHURZUXCAUUPUXEUV
        IEFQXQVKZEXRVKAUVDUXDUWECEFIUVCQRUWCXSVKZCEUWJIPRUXAUBXTXAYAUUGPUWKUWLU
        UGPIUWJYCYDVKZCDEFUUGPSQUBRYBXCYEALUJYEZAUWPUVEUUHXFUPZUMLXFUPZUMUUHXFU
        PAUWNIUUGUWJUPZDUOUWPUXJAHUXLDAHUWKUXLUXBAUXEUUKUXDUWKUXLVOUXFUWIUXGCEU
        WJUUGIRUXAYFXCYGYHUKACDEFUWJFYIUOZIUUGPSQUXMWGZRUXAUBUUSUXGAIPVBZUVEVCU
        RZAUVEUMVCAUVDUVFUVHUWDYNZYJYKAUUJUXDUXOUXPWBUUSUXGCDEFIPSQUBRXHXAXIAFY
        LUOZUXMUVEIYMUOUOZAUUJUXRUXMYOUUSFUXRUXMUXNUXRWGZYPVKAUVBUXSUXRURUWGUVA
        DFUXRISUXTUWFYQVKYRUWIUXHYSYTALUQURUUIUWPUXKVOUXIUSLUMUUCUUDAUVEUMUUHXF
        UXQUUEUUAUUB $.

      fta1glem.6 $e |- ( ph -> A. g e. B ( ( D ` g ) = N ->
        ( # ` ( `' ( O ` g ) " { W } ) ) <_ ( D ` g ) ) ) $.
      $( Lemma for ~ fta1g .  (Contributed by Mario Carneiro, 12-Jun-2015.) $)
      fta1glem2 $p |- ( ph ->
        ( # ` ( `' ( O ` F ) " { W } ) ) <_ ( D ` F ) ) $=
        ( vx cfv ccnv csn cima chash cq1p co cun cle cv wcel wceq wa cmulr cpws
        wo cof cdsr wbr wfn wb wf cbs cidom cvv eqid fvex eqeltri a1i crh cdomn
        ccrg isidom simplbi syl evl1rhm rhmf ffvelrnd pwselbas ffn mpbid simprd
        fniniseg cnzr simprbi domnnzr simpld facth1 mpbird cuc1p nzrrng cmn1 c1
        ply1remlem simp1d mon1puc1p syl2anc dvdsq1p syl3anc fveq2d q1pcl rhmmul
        crg mon1pcl pwsmulrval 3eqtrd fveq1d adantr simpr fnfvof syl22anc eqtrd
        eqeq1d ffvelrnda domneq0 caddc cfn cn0 wi breqtrd sylancl hashcl nn0red
        fveq2 cr bitrd pm5.32da andi syl6bb simp3d eleq2d bitr3d orbi12d syl5bb
        elun 3bitr4d eqrdv imaexg mp1i fta1glem1 cnveqd imaeq1d breq12d imbi12d
        cnvex wral hashbnd snfi unfi peano2re peano2nn0 eqeltrd hashun2 hashsng
        rspcv syl3c oveq2d 1re leadd1dd breqtrrd letrd eqbrtrd ) AINUPZUQOURZUS
        ZUTUPIJFVAUPZVBZNUPZUQZUVSUSZGURZVCZUTUPZIDUPZVDAUVTUWGUTAUOUVTUWGAUOVE
        ZKVFZUWJUVRUPZOVGZVHZUWKUWJUWCUPZOVGZVHZUWKUWJJNUPZUPZOVGZVHZVKZUWJUVTV
        FZUWJUWGVFZAUWNUWKUWPUWTVKZVHUXBAUWKUWMUXEAUWKVHZUWMUWOUWSFVIUPZVBZOVGZ
        UXEUXFUWLUXHOUXFUWLUWJUWCUWRUXGVLVBZUPZUXHAUWLUXKVGUWKAUWJUVRUXJAUVRUWB
        JEVIUPZVBZNUPZUWCUWRFKVJVBZVIUPZVBZUXJAIUXMNAJIEVMUPZVNZIUXMVGZAUXSGUVR
        UPOVGZAGKVFZUYAAGUVTVFZUYBUYAVHZUMAUVRKVOZUYCUYDVPAKKUVRVQUYEAKFKUXOVRU
        PZVSUVRUXOVTUXOWAZUFUYFWAZUDKVTVFZAKFVRUPVTUFFVRWBWCZWDZACUYFINANEUXOWE
        VBVFZCUYFNVQAFWGVFZUYLAFVSVFZUYMUDUYNUYMFWFVFZFWHZWIWJZKEFUXONUARUYGUFW
        KWJZCUYFEUXONSUYHWLWJZUEWMWNKKUVRWOWJZKOGUVRWRWJWPZWQABCUXREFIJKLGNPORS
        UFUGUHUIUJUAAUYNFWSVFZUDUYNUYOVUBUYNUYMUYOUYPWTZFXAWJWJZUYQAUYBUYAVUAXB
        ZUEUBUXRWAZXCXDAFXRVFZICVFZJFXEUPZVFZUXSUXTVPAVUBVUGVUDFXFWJZUEAVUGJFXG
        UPZVFZVUJVUKAVUMJDUPXHVGZUWRUQUVSUSZUWFVGZABCDEFVULJKLGNPORSUFUGUHUIUJU
        AVUDUYQVUEVULWAZTUBXIZXJZVUIFVULJVUIWAZVUQXKXLZCVUIUXREUWAFUXLIJRVUFSVU
        TUXLWAZUWAWAZXMXNWPXOAUYLUWBCVFZJCVFZUXNUXQVGUYRAVUGVUHVUJVVDVUKUEVVACV
        UIEUWAFIJVVCRSVUTXPXNZAVUMVVEVUSCEFJVULRSVUQXSWJZUWBJEUXOUXLUXPNCSVVBUX
        PWAZXQXNAUYFFUXPUXGUWCUWRKVSVTUXOUYGUYHUDUYKACUYFUWBNUYSVVFWMZACUYFJNUY
        SVVGWMZUXGWAZVVHXTYAYBYCUXFUWCKVOZUWRKVOZUYIUWKUXKUXHVGAVVLUWKAKKUWCVQV
        VLAKFKUYFVSUWCUXOVTUYGUFUYHUDUYKVVIWNZKKUWCWOWJZYCAVVMUWKAKKUWRVQVVMAKF
        KUYFVSUWRUXOVTUYGUFUYHUDUYKVVJWNZKKUWRWOWJZYCUYIUXFUYJWDAUWKYDKUXGUWCUW
        RVTUWJYEYFYGYHUXFUYOUWOKVFUWSKVFUXIUXEVPAUYOUWKAUYNUYOUDVUCWJYCAKKUWJUW
        CVVNYIAKKUWJUWRVVPYIKFUXGUWOUWSOUFVVKUBYJXNUUAUUBUWKUWPUWTUUCUUDAUYEUXC
        UWNVPUYTKOUWJUVRWRWJUXDUWJUWEVFZUWJUWFVFZVKAUXBUWJUWEUWFUUJAVVRUWQVVSUX
        AAVVLVVRUWQVPVVOKOUWJUWCWRWJAUWJVUOVFZVVSUXAAVUOUWFUWJAVUMVUNVUPVURUUEU
        UFAVVMVVTUXAVPVVQKOUWJUWRWRWJUUGUUHUUIUUKUULXOAUWHUWEUTUPZXHYKVBZUWIAUW
        HAUWGYLVFZUWHYMVFAUWEYLVFZUWFYLVFZVWCAUWEVTVFZMYMVFZVWAMVDVNVWDUWDVTVFV
        WFAUWCUWBNWBUUTUWDUVSVTUUMUUNUKAVWAUWBDUPZMVDAVVDHVEZDUPZMVGZVWINUPZUQZ
        UVSUSZUTUPZVWJVDVNZYNZHCUVAVWHMVGZVWAVWHVDVNZVVFUNABCDEFGIJKLMNOPQRSTUA
        UBUCUDUEUFUGUHUIUJUKULUMUUOZVWQVWRVWSYNHUWBCVWIUWBVGZVWKVWRVWPVWSVXAVWJ
        VWHMVWIUWBDYSZYHVXAVWOVWAVWJVWHVDVXAVWNUWEUTVXAVWMUWDUVSVXAVWLUWCVWIUWB
        NYSUUPUUQXOVXBUURUUSUVJUVKVWTYOZUWEMVTUVBXNZGUVCZUWEUWFUVDYPUWGYQWJYRAV
        WAYTVFVWBYTVFAVWAAVWDVWAYMVFVXDUWEYQWJYRZVWAUVEWJAUWIAUWIMXHYKVBZYMULAV
        WGVXGYMVFUKMUVFWJUVGYRAUWHVWAUWFUTUPZYKVBZVWBVDAVWDVWEUWHVXIVDVNVXDVXEU
        WEUWFUVHYPAVXHXHVWAYKAUYCVXHXHVGUMGUVTUVIWJUVLYOAVWBVXGUWIVDAVWAMXHVXFA
        MUKYRXHYTVFAUVMWDVXCUVNULUVOUVPUVQ $.
    $}

    fta1g.3 $e |- ( ph -> F =/= .0. ) $.
    $( The one-sided fundamental theorem of algebra.  A polynomial of degree
       ` n ` has at most ` n ` roots.  Unlike the real fundamental theorem
       ~ fta , which is only true in ` CC ` and other algebraically closed
       fields, this is true in any integral domain.  (Contributed by Mario
       Carneiro, 12-Jun-2015.) $)
    fta1g $p |- ( ph -> ( # ` ( `' ( O ` F ) " { W } ) ) <_ ( D ` F ) ) $=
      ( cfv wceq vf vx vd vg ccnv csn cima chash cle eqid wcel cv wi wral cidom
      wbr cn0 crg wne ccrg isidom simplbi crngrng 3syl deg1nn0cl syl3anc cc0 c1
      cdomn caddc co eqeq2 imbi1d ralbidv imbi2d wa c0 simprr 0nn0 syl6eqel syl
      wn wb simpl deg1nn0clb syl2an mpbird cco1 cascl simplrr syl6eqbr ad2antrr
      0le0 simplrl deg1le0 syl2anc mpbid cbs cxp fveq2d adantr wf coe1f ffvelrn
      sylancl evl1sca eqtrd fveq1d wfn cpws cvv a1i crh evl1rhm simprl ffvelrnd
      pwselbas ffn fniniseg simplbda simprbda fvconst2 3eqtr3rd ply1scl0 3eqtrd
      fvex rhmf necon3ad hash0 syl6eq expr fveq2 eqeq1d imaeq1d breq12d imbi12d
      ex cnveqd syl5bi sylc eq0rdv syl5breqr eqbrtrd ralrimiva cbvralv ad2antlr
      mpd peano2nn0 eqeltrd nn0ge0d syl5ibrcom a1dd wex cv1 csg simplll simpllr
      breq1d n0 fta1glem2 exp32 exlimdv pm2.61dne com23 ralrimdva expcom nn0ind
      a2d rspcv mpi ) AFCSZUVKTZFGSZUEZHUFZUGZUHSZUVKUIUPZUVKUJAFBUKZUAULZCSZUV
      KTZUVTGSZUEZUVOUGZUHSZUWAUIUPZUMZUABUNZUVLUVRUMZQAUVKUQUKZEUOUKZUWIAEURUK
      ZUVSFIUSUWKAUWLEUTUKZUWMPUWLUWNEVIUKEVAVBZEVCZVDQRBCDEFILJOKVEVFPUWLUWAUB
      ULZTZUWGUMZUABUNZUMUWLUWAVGTZUWGUMZUABUNZUMUWLUWAUCULZTZUWGUMZUABUNZUMUWL
      UWAUXDVHVJVKZTZUWGUMZUABUNZUMUWLUWIUMUBUCUVKUWQVGTZUWTUXCUWLUXLUWSUXBUABU
      XLUWRUXAUWGUWQVGUWAVLVMVNVOUWQUXDTZUWTUXGUWLUXMUWSUXFUABUXMUWRUXEUWGUWQUX
      DUWAVLVMVNVOUWQUXHTZUWTUXKUWLUXNUWSUXJUABUXNUWRUXIUWGUWQUXHUWAVLVMVNVOUWQ
      UVKTZUWTUWIUWLUXOUWSUWHUABUXOUWRUWBUWGUWQUVKUWAVLVMVNVOUWLUXBUABUWLUVTBUK
      ZUXAUWGUWLUXPUXAVPZVPZUWFVGUWAUIUXRUWFVQUHSZVGUXRUWEVQUHUXRUBUWEUXRUVTIUS
      ZUWQUWEUKZWBUXRUXTUWAUQUKZUXRUWAVGUQUWLUXPUXAVRZVSVTUWLUWMUXPUXTUYBWCUXQU
      WLUWNUWMUWOUWPWAZUXPUXAWDBCDEUVTILJOKWEWFWGUXRUYAUVTIUXRUYAUVTITUXRUYAVPZ
      UVTVGUVTWHSZSZDWISZSZHUYHSZIUYEUWAVGUIUPZUVTUYITZUYEUWAVGVGUIUWLUXPUXAUYA
      WJWMWKUYEUWMUXPUYKUYLWCUWLUWMUXQUYAUYDWLZUWLUXPUXAUYAWNZUYHBCDEUVTLJKUYHU
      JZWOWPWQZUYEUYGHUYHUYEUWQUWCSZUWQEWRSZUYGUFWSZSZHUYGUYEUWQUWCUYSUYEUWCUYI
      GSZUYSUYEUVTUYIGUYPWTUYEUWNUYGUYRUKZVUAUYSTUXRUWNUYAUWLUWNUXQUWOXAZXAUYEU
      QUYRUYFXBZVGUQUKVUBUYEUXPVUDUYNUYFBDEUVTUYRUYFUJKJUYRUJZXCWAVSUQUYRVGUYFX
      DXEUYHUYRDEGUYGMJVUEUYOXFWPXGXHUXRUYAUWQUYRUKZUYQHTZUXRUYRUYRUWCXBUWCUYRX
      IUYAVUFVUGVPWCUXRUYREUYREUYRXJVKZWRSZUOUWCVUHXKVUHUJZVUEVUIUJZUWLUXQWDUYR
      XKUKUXREWRYFXLUXRBVUIUVTGUXRUWNGDVUHXMVKUKBVUIGXBVUCUYRDEVUHGMJVUJVUEXNBV
      UIDVUHGKVUKYGVDUWLUXPUXAXOXPXQUYRUYRUWCXRUYRHUWQUWCXSVDZXTUYEVUFUYTUYGTUX
      RUYAVUFVUGVULYAUYRUYGUWQVGUYFYFYBWAYCWTUYEUWMUYJITUYMUYHDEIHJUYONOYDWAYEY
      QYHUUGUUAWTYIYJUXRVGVGUWAUIWMUYCUUBUUCYKUUDUXDUQUKZUWLUXGUXKUWLVUMUXGUXKU
      MUXGUDULZCSZUXDTZVUNGSZUEZUVOUGZUHSZVUOUIUPZUMZUDBUNZUWLVUMVPZUXKUXFVVBUA
      UDBUVTVUNTZUXEVUPUWGVVAVVEUWAVUOUXDUVTVUNCYLZYMVVEUWFVUTUWAVUOUIVVEUWEVUS
      UHVVEUWDVURUVOVVEUWCVUQUVTVUNGYLYRYNWTVVFYOYPUUEVVDVVCUXJUABVVDUXPVPUXIVV
      CUWGVVDUXPUXIVVCUWGUMZVVDUXPUXIVPZVPZVVGUWEVQVVIUWEVQTZUWGVVCVVIUWGVVJVGU
      WAUIUPVVIUWAVVIUWAUXHUQVVDUXPUXIVRVUMUXHUQUKUWLVVHUXDUUHUUFUUIUUJVVJUWFVG
      UWAUIVVJUWFUXSVGUWEVQUHYLYIYJUURUUKUULUWEVQUSUYAUBUUMVVIVVGUBUWEUUSVVIUYA
      VVGUBVVIUYAVVCUWGVVIUYAVVCVPZVPUYHBCDEUWQUDUVTEUUNSZUWQUYHSDUUOSZVKZUYRVV
      MUXDGHVVLIJKLMNOUWLVUMVVHVVKUUPVVDUXPUXIVVKWNVUEVVLUJVVMUJUYOVVNUJUWLVUMV
      VHVVKUUQVVDUXPUXIVVKWJVVIUYAVVCXOVVIUYAVVCVRUUTUVAUVBYSUVCYKUVDUVEYSUVFUV
      HUVGYTUWHUWJUAFBUVTFTZUWBUVLUWGUVRVVOUWAUVKUVKUVTFCYLZYMVVOUWFUVQUWAUVKUI
      VVOUWEUVPUHVVOUWDUVNUVOVVOUWCUVMUVTFGYLYRYNWTVVPYOYPUVIYTUVJ $.
  $}

  ${
    $d f x y B $.  $d f x y D $.  $d f x y O $.  $d f x y R $.  $d f x y W $.
    $d f P $.  $d f x y .0. $.
    fta1b.p $e |- P = ( Poly1 ` R ) $.
    fta1b.b $e |- B = ( Base ` P ) $.
    fta1b.d $e |- D = ( deg1 ` R ) $.
    fta1b.o $e |- O = ( eval1 ` R ) $.
    fta1b.w $e |- W = ( 0g ` R ) $.
    fta1b.z $e |- .0. = ( 0g ` P ) $.
    ${
      fta1blem.k $e |- K = ( Base ` R ) $.
      fta1blem.t $e |- .X. = ( .r ` R ) $.
      fta1blem.x $e |- X = ( var1 ` R ) $.
      fta1blem.s $e |- .x. = ( .s ` P ) $.
      fta1blem.1 $e |- ( ph -> R e. CRing ) $.
      fta1blem.2 $e |- ( ph -> M e. K ) $.
      fta1blem.3 $e |- ( ph -> N e. K ) $.
      fta1blem.4 $e |- ( ph -> ( M .X. N ) = W ) $.
      fta1blem.5 $e |- ( ph -> M =/= W ) $.
      fta1blem.6 $e |- ( ph -> ( ( M .x. X ) e. ( B \ { .0. } ) ->
       ( # ` ( `' ( O ` ( M .x. X ) ) " { W } ) ) <_ ( D ` ( M .x. X ) ) ) ) $.
      $( Lemma for ~ fta1b .  (Contributed by Mario Carneiro, 14-Jun-2015.) $)
      fta1blem $p |- ( ph -> N = W ) $=
        ( csn wcel wceq co cfv ccnv cima evl1vard evl1vsd simprd eqtrd wa wb wf
        wfn cpws cbs ccrg cvv eqid fvex eqeltri a1i crh evl1rhm syl rhmf simpld
        ffvelrnd pwselbas ffn fniniseg mpbir2and cfn wss cen wbr c1 chash cnvex
        cn0 cle imaexg ax-mp 1nn0 cdif wne cmgp cmg crngrng vr1cl mgpbas oveq2d
        crg mulg1 cco1 coe1tmfv1 syl3anc cxp fveq1d c0g fvconst2 syl6eq 3netr4d
        coe1z fveq2 necon3i eqnetrrd eldifsn mpd fveq2d deg1tm syl121anc eqtr3d
        sylanbrc breqtrd hashbnd rng0cl cid cres cof cascl ply1sclf rhmmul casa
        cmulr csca syl2anc oveq12d cr ply1assa ply1sca eleqtrd asclmul1 evl1sca
        syl5eq evl1var 3eqtr3d fnconstg fnresi fnfvof syl22anc fvconst2g fvresi
        pwsmulrval rngrz snssd hashsng cdom ssdomg mpsyl hashdom mp2an eqbrtrrd
        snfi sylibr hashcl nn0red letri3 sylancl eqtr4d hashen sylancr fisseneq
        1re mpbid eleqtrrd elsni ) AJLUKZULJLUMAJIMFUNZKUOZUPZUVSUQZUVSAJUWCULZ
        JHULZJUWAUOZLUMZUGAUWFIJGUNZLAUVTBULZUWFUWHUMZAHDEFGBMIKJJROUAPUEUGAHDE
        BKMJRUCUAOPUEUGURUFUDUBUSZUTUHVAAUWAHVEZUWDUWEUWGVBVCAHHUWAVDUWLAHEHEHV
        FUNZVGUOZVHUWAUWMVIUWMVJZUAUWNVJZUEHVIULZAHEVGUOZVIUAEVGVKVLVMZABUWNUVT
        KAKDUWMVNUNULZBUWNKVDAEVHULZUWTUEHDEUWMKROUWOUAVOVPZBUWNDUWMKPUWPVQVPZA
        UWIUWJUWKVRZVSVTHHUWAWAVPZHLJUWAWBVPWCAUWCWDULZUVSUWCWEZUVSUWCWFWGZUVSU
        WCUMAUWCVIULZWHWKULZUWCWIUOZWHWLWGZUXFUXIAUWBVIULUXIUWAUVTKVKWJUWBUVSVI
        WMWNZVMUXJAWOVMZAUXKUVTCUOZWHWLAUVTBNUKWPULZUXKUXOWLWGAUWIUVTNWQUXPUXDA
        IWHMDWRUOZWSUOZUNZFUNZUVTNAUXSMIFAMBULZUXSMUMAEXDULZUYAAUXAUYBUEEWTVPZB
        DEMUCOPXAVPZBUXRUXQMBDUXQUXQVJZPXBUXRVJZXEVPXCZAWHUXTXFUOZUOZWHNXFUOZUO
        ZWQUXTNWQAILUYIUYKUIAUYBIHULZUXJUYIIUMUYCUFUXNIWHDEFUXRHUXQMLSUAOUCUDUY
        EUYFXGXHAUYKWHWKUVSXIZUOZLAWHUYJUYMAUYBUYJUYMUMUYCDELNOTSXOVPXJUXJUYNLU
        MWOWKLWHLEXKUOVISEXKVKVLXLWNXMXNUXTNUYIUYKUXTNUMWHUYHUYJUXTNXFXPXJXQVPX
        RUVTBNXSYEUJXTAUXTCUOZUXOWHAUXTUVTCUYGYAAUYBUYLILWQUXJUYOWHUMUYCUFUIUXN
        ICDEFUXRWHHUXQMLQUAOUCUDUYEUYFSYBYCYDYFZUWCWHVIYGXHZALUWCALUWCULZLHULZL
        UWAUOZLUMZAUYBUYSUYCHELUASYHVPZAUYTLHIUKXIZYIHYJZGYKZUNZUOZLALUWAVUFAID
        YLUOZUOZMDYPUOZUNZKUOZVUIKUOZMKUOZUWMYPUOZUNZUWAVUFAUWTVUIBULUYAVULVUPU
        MUXBAHBIVUHAUYBHBVUHVDUYCVUHBDEHOVUHVJZUAPYMVPUFVSZUYDVUIMDUWMVUJVUOKBP
        VUJVJZVUOVJZYNXHAVUKUVTKADYOULZIDYQUOZVGUOZULUYAVUKUVTUMAUXAVVAUEDEOUUA
        VPAIHVVCUFAHUWRVVCUAAEVVBVGAUXAEVVBUMUEDEVHOUUBVPYAUUFUUCUYDVUHIFVUJVVB
        VVCBDMVUQVVBVJVVCVJPVUSUDUUDXHYAAVUPVUMVUNVUEUNVUFAUWNEVUOGVUMVUNHVHVIU
        WMUWOUWPUEUWSABUWNVUIKUXCVURVSABUWNMKUXCUYDVSUBVUTUUOAVUMVUCVUNVUDVUEAU
        XAUYLVUMVUCUMUEUFVUHHDEKIROUAVUQUUEYRAUXAVUNVUDUMUEHEKMRUCUAUUGVPYSVAUU
        HXJAVUGLVUCUOZLVUDUOZGUNZLAVUCHVEZVUDHVEZUWQUYSVUGVVFUMAUYLVVGUFHIHUUIV
        PVVHAHUUJVMUWSVUBHGVUCVUDVILUUKUULAVVFILGUNZLAVVDIVVELGAUYLUYSVVDIUMUFV
        UBHILHUUMYRAUYSVVELUMVUBHLUUNVPYSAUYBUYLVVILUMUYCUFHEGILUAUBSUUPYRVAVAV
        AAUWLUYRUYSVUAVBVCUXEHLLUWAWBVPWCUUQZAUVSWIUOZUXKUMZUXHAVVKWHUXKAUYSVVK
        WHUMVUBLHUURVPZAUXKWHUMZUXLWHUXKWLWGZUYPAVVKWHUXKWLVVMAUVSUWCUUSWGZVVKU
        XKWLWGZUXIAUXGVVPUXMVVJUVSUWCVIUUTUVAUVSWDULZUXIVVQVVPVCLUVEZUXMUVSUWCV
        IUVBUVCUVFUVDAUXKYTULWHYTULVVNUXLVVOVBVCAUXKAUXFUXKWKULUYQUWCUVGVPUVHUV
        OUXKWHUVIUVJWCUVKAVVRUXFVVLUXHVCVVSUYQUVSUWCUVLUVMUVPUVSUWCUVNXHUVQJLUV
        RVP $.
    $}

    $( The assumption that ` R ` be a domain in ~ fta1g is necessary.  Here we
       show that the statement is strong enough to prove that ` R ` is a
       domain.  (Contributed by Mario Carneiro, 12-Jun-2015.) $)
    fta1b $p |- ( R e. IDomn <-> ( R e. CRing /\ R e. NzRing /\
   A. f e. ( B \ { .0. } ) ( # ` ( `' ( O ` f ) " { W } ) ) <_ ( D ` f ) ) ) $=
      ( vx vy wcel cfv wa wceq cidom ccrg cnzr ccnv csn cima chash cle wbr cdif
      cv wral w3a cdomn isidom simplbi simprbi domnnzr syl simpl eldifsn adantl
      wne fta1g ralrimiva 3jca simp1 cmulr co wo wi cbs simp2 wn df-ne cv1 eqid
      cvsca simpll1 simplrl simplrr simprl simprr simpll3 cnveqd imaeq1d fveq2d
      fveq2 breq12d rspccv fta1blem expr syl5bir orrd ex isdomn sylanbrc impbii
      ralrimivva ) DUAQZDUBQZDUCQZEUKZFRZUDZGUEZUFZUGRZXCBRZUHUIZEAHUEUJZULZUMZ
      WTXAXBXLWTXADUNQZDUOZUPWTXNXBWTXAXNXOUQDURUSWTXJEXKWTXCXKQZSABCDXCFGHIJKL
      MNWTXPUTXPXCAQZWTXPXQXCHVCZXCAHVAZUPVBXPXRWTXPXQXRXSUQVBVDVEVFXMXAXNWTXAX
      BXLVGXMXBOUKZPUKZDVHRZVIGTZXTGTZYAGTZVJZVKZPDVLRZULOYHULXNXAXBXLVMXMYGOPY
      HYHXMXTYHQZYAYHQZSZSZYCYFYLYCSZYDYEYDVNXTGVCZYMYEXTGVOYLYCYNYEYLYCYNSZSZA
      BCDCVRRZYBYHXTYAFGDVPRZHIJKLMNYHVQZYBVQZYRVQYQVQXAXBXLYKYOVSXMYIYJYOVTXMY
      IYJYOWAYLYCYNWBYLYCYNWCYPXLXTYRYQVIZXKQUUAFRZUDZXFUFZUGRZUUABRZUHUIZVKXAX
      BXLYKYOWDXJUUGEUUAXKXCUUATZXHUUEXIUUFUHUUHXGUUDUGUUHXEUUCXFUUHXDUUBXCUUAF
      WHWEWFWGXCUUABWHWIWJUSWKWLWMWNWOWSOPYHDYBGYSYTMWPWQXOWQWR $.
  $}

  ${
    drnguc1p.p $e |- P = ( Poly1 ` R ) $.
    drnguc1p.b $e |- B = ( Base ` P ) $.
    drnguc1p.z $e |- .0. = ( 0g ` P ) $.
    drnguc1p.c $e |- C = ( Unic1p ` R ) $.
    $( Over a division ring, all nonzero polynomials are unitic.  (Contributed
       by Stefan O'Rear, 29-Mar-2015.) $)
    drnguc1p $p |- ( ( R e. DivRing /\ F e. B /\ F =/= .0. ) -> F e. C ) $=
      ( cdr wcel wne w3a cdg1 cfv cco1 cn0 eqid syl3an1 cui simp2 simp3 cbs c0g
      wf coe1f 3ad2ant2 drngrng deg1nn0cl ffvelrnd deg1ldg wa drngunit 3ad2ant1
      crg wb mpbir2and isuc1p syl3anbrc ) DKLZEALZEFMZNZVBVCEDOPZPZEQPZPZDUAPZL
      ZEBLVAVBVCUBVAVBVCUCVDVJVHDUDPZLZVHDUEPZMZVDRVKVFVGVBVARVKVGUFVCVGACDEVKV
      GSZHGVKSZUGUHVADUPLZVBVCVFRLDUIZAVECDEFVESZGIHUJTUKVAVQVBVCVNVRVGAVECDEVM
      FVSGIHVMSZVOULTVAVBVJVLVNUMUQVCVKDVIVHVMVPVISZVTUNUOURABVECDVIEFGHIVSJWAU
      SUT $.
  $}

  ${
    $d D g h $.  $d I g h $.  $d M g h $.  $d P g $.  $d R g h $.  $d U g h $.
    $d .0. g h $.
    ig1peu.p $e |- P = ( Poly1 ` R ) $.
    ig1peu.u $e |- U = ( LIdeal ` P ) $.
    ig1peu.z $e |- .0. = ( 0g ` P ) $.
    ig1peu.m $e |- M = ( Monic1p ` R ) $.
    ig1peu.d $e |- D = ( deg1 ` R ) $.
    $( There is a unique monic polynomial of minimal degree in any nonzero
       ideal.  (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    ig1peu $p |- ( ( R e. DivRing /\ I e. U /\ I =/= { .0. } ) ->
        E! g e. ( I i^i M ) ( D ` g ) =
            sup ( ( D " ( I \ { .0. } ) ) , RR , `' < ) ) $=
      ( wcel cfv wss eqid syl syl2anc adantr vh cdr csn wne w3a cv cdif cima cr
      clt ccnv csup wceq cin wrex wa weq wi wral wreu cc0 cuz c0 cn0 cbs lidlss
      3ad2ant2 ssdifd imass2 crg drngrng 3ad2ant1 deg1n0ima sstrd nn0uz ply1rng
      syl6sseq simp2 lidl0cl snssd simp3 necomd pssdifn0 wfn wb cxr deg1xrf ffn
      wf ax-mp a1i ssdifssd fnimaeq0 necon3bid mpbird infmssuzcl fvelimab mpbid
      cinvr cascl cmulr simpl2 ply1sclf cui cuc1p simpl1 sselda eldifsni adantl
      cco1 co drnguc1p syl3anc uc1pldg unitinvcl unitcl ffvelrnd eldifi lidlmcl
      syl22anc elin sylanbrc crlreg unitrrg sseldd deg1mul3 fveq2 eqeq1d rspcev
      uc1pmon1p eqeq2 rexbidv syl5ibcom ad2antrr simprl sseldi simprr ex sylibd
      wbr rexlimdva mpd csg inss2 deg1submon1p wn inss1 lidlsubcl simpr eldifsn
      cle fnfvima infmssuzle imassrn sstri cgrp rnggrp syl5ss grpsubcl deg1xrcl
      crn frn xrlenlt necon4ad syld grpsubeq0 ralrimivva reu4 ) CUBNZFDNZFHUCZU
      DZUEZEUFZAOZAFUVKUGZUHZUIUJUKULZUMZEFGUNZUOZUVSUAUFZAOZUVRUMZUPZEUAUQZURZ
      UAUVTUSEUVTUSUVSEUVTUTUVMUWDUAUVPUOZUWAUVMUVRUVQNZUWHUVMUVQVAVBOZPZUVQVCU
      DZUWIUVMUVQVDUWJUVMUVQABVEOZUVKUGZUHZVDUVMUVPUWNPUVQUWOPUVMFUWMUVKUVJUVIF
      UWMPUVLUWMFDBUWMQZJVFVGZVHUVPUWNAVIRUVMCVJNZUWOVDPUVIUVJUWRUVLCVKVLZUWMAB
      CHMIKUWPVMRVNVOVQZUVMUWLUVPVCUDZUVMUVKFPUVKFUDUXAUVMHFUVMBVJNZUVJHFNUVMUW
      RUXBUWSBCIVPRZUVIUVJUVLVRBDFHJKVSSVTUVMFUVKUVIUVJUVLWAWBUVKFWCSUVMUVQVCUV
      PVCUVMAUWMWDZUVPUWMPZUVQVCUMUVPVCUMWEUXDUVMUWMWFAWIZUXDUWMABCMIUWPWGZUWMW
      FAWHWJZWKZUVMFUWMUVKUWQWLZUWMUVPAWMSWNWOUVQVAWPSZUVMUXDUXEUWIUWHWEUXIUXJU
      AUWMUVPUVRAWQSWRUVMUWDUWAUAUVPUVMUWBUVPNZUPZUVOUWCUMZEUVTUOZUWDUWAUXMUWCU
      WBXJOOZCWSOZOZBWTOZOZUWBBXAOZXKZUVTNZUYBAOZUWCUMZUXOUXMUYBFNZUYBGNZUYCUXM
      UXBUVJUXTUWMNUWBFNZUYFUVMUXBUXLUXCTUVIUVJUVLUXLXBUXMCVEOZUWMUXRUXSUXMUWRU
      YIUWMUXSWIUVMUWRUXLUWSTZUXSUWMBCUYIIUXSQZUYIQZUWPXCRUXMUXRCXDOZNZUXRUYINU
      XMUWRUXPUYMNZUYNUYJUXMUWBCXEOZNZUYOUXMUVIUWBUWMNZUWBHUDZUYQUVIUVJUVLUXLXF
      UVMUVPUWMUWBUXJXGZUXLUYSUVMUWBFHXHXIUWMUYPBCUWBHIUWPKUYPQZXLXMZUYPACUYMUW
      BMUYMQZVUAXNRCUYMUXQUXPVUCUXQQZXOSZUYICUYMUXRUYLVUCXPRXQUXLUYHUVMUWBFUVKX
      RXIUWMBUYADFUXTUWBJUWPUYAQZXSXTUXMUWRUYQUYGUYJVUBUXSUYPABCUYAUXQGUWBVUALI
      VUFUYKMVUDYJSUYBFGYAYBUXMUWRUXRCYCOZNUYRUYEUYJUXMUYMVUGUXRUXMUWRUYMVUGPUY
      JCUYMVUGVUGQZVUCYDRVUEYEUYTUXSUWMABCUYAVUGUXRUWBMIVUHUWPVUFUYKYFXMUXNUYEE
      UYBUVTUVNUYBUMUVOUYDUWCUVNUYBAYGYHYISUWDUXNUVSEUVTUWCUVRUVOYKYLYMUUAUUBUV
      MUWGEUAUVTUVTUVMUVNUVTNZUWBUVTNZUPZUPZUWEUVNUWBBUUCOZXKZHUMZUWFVULUWEVUNA
      OZUVRUJYTZVUOVULUWEVUQVULUWEUPABCUVNUWBVUMGUVRMLIVUMQZUVMUWRVUKUWEUWSYNVU
      LUVNGNUWEVULUVTGUVNFGUUDZUVMVUIVUJYOZYPTVULUVSUWDYOVULUWBGNUWEVULUVTGUWBV
      USUVMVUIVUJYQZYPTVULUVSUWDYQUUEYRVULVUQVUNHVULVUNHUDZUVRVUPUUKYTZVUQUUFZV
      ULVVBVVCVULVVBUPZUWKVUPUVQNZVVCUVMUWKVUKVVBUWTYNVVEUXDUXEVUNUVPNZVVFUXDVV
      EUXHWKUVMUXEVUKVVBUXJYNVVEVUNFNZVVBVVGVULVVHVVBVULUXBUVJUVNFNUYHVVHUVMUXB
      VUKUXCTUVIUVJUVLVUKXBVULUVTFUVNFGUUGZVUTYPVULUVTFUWBVVIVVAYPBDFVUMUVNUWBJ
      VURUUHXTTVULVVBUUIVUNFHUUJYBUWMUVPAVUNUULXMVUPUVQVAUUMSYRVULUVRWFNZVUPWFN
      ZVVCVVDWEUVMVVJVUKUVMUVQWFUVRUVQAUVAZWFAUVPUUNUXFVVLWFPUXGUWMWFAUVBWJUUOU
      XKYPTVULVUNUWMNZVVKVULBUUPNZUVNUWMNZUYRVVMUVMVVNVUKUVMUXBVVNUXCBUUQRTZVUL
      UVTUWMUVNUVMUVTUWMPVUKUVMUVTFUWMVVIUWQUURTZVUTYEZVULUVTUWMUWBVVQVVAYEZUWM
      BVUMUVNUWBUWPVURUUSXMUWMABCVUNMIUWPUUTRUVRVUPUVCSYSUVDUVEVULVVNVVOUYRVUOU
      WFWEVVPVVRVVSUWMBVUMUVNUWBHUWPKVURUVFXMYSUVGUVSUWDEUAUVTUWFUVOUWCUVRUVNUW
      BAYGYHUVHYB $.
  $}

  ${
    ig1pval.p $e |- P = ( Poly1 ` R ) $.
    ig1pval.g $e |- G = ( idlGen1p ` R ) $.
    ${
      $d D i r $.  $d I g i $.  $d M g i r $.  $d R g i r $.  $d U i r $.
      $d .0. i r $.
      ig1pval.z $e |- .0. = ( 0g ` P ) $.
      ig1pval.u $e |- U = ( LIdeal ` P ) $.
      ig1pval.d $e |- D = ( deg1 ` R ) $.
      ig1pval.m $e |- M = ( Monic1p ` R ) $.
      $( Substitutions for the polynomial ideal generator function.
         (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
      ig1pval $p |- ( ( R e. V /\ I e. U ) -> ( G ` I ) =
        if ( I = { .0. } , .0. , ( iota_ g e. ( I i^i M ) ( D ` g ) =
             sup ( ( D " ( I \ { .0. } ) ) , RR , `' < ) ) ) ) $=
        ( vi cfv wceq cr vr wcel csn cdif cima clt ccnv csup cin crio cif cig1p
        cv cmpt cvv elex cpl1 clidl cdg1 cmn1 fveq2 syl6eqr fveq2d sneqd eqeq2d
        ineq2d difeq2d imaeq12d supeq1d eqeq12d riotaeqbidv ifbieq12d mpteq12dv
        c0g fveq1d df-ig1p fvex eqeltri mptex fvmpt syl5eq eqeq1 difeq1 imaeq2d
        syl ineq1 ifbieq2d eqid riotaex ifex sylan9eq ) CIUBZGDUBGFRGQDQUMZJUCZ
        SZJEUMZARZAWMWNUDZUEZTUFUGZUHZSZEWMHUIZUJZUKZUNZRGWNSZJWQAGWNUDZUEZTWTU
        HZSZEGHUIZUJZUKZWLGFXFWLFCULRZXFLWLCUOUBXOXFSCIUPUACQUAUMZUQRZURRZWMXQV
        NRZUCZSZXSWPXPUSRZRZYBWMXTUDZUEZTWTUHZSZEWMXPUTRZUIZUJZUKZUNXFUOULXPCSZ
        QXRYKDXEYLXRBURRZDYLXQBURYLXQCUQRBXPCUQVAKVBZVCNVBYLYAWOXSYJJXDYLXTWNWM
        YLXSJYLXSBVNRZJYLXQBVNYNVCMVBZVDZVEYPYLYGXBEYIXCYLYHHWMYLYHCUTRHXPCUTVA
        PVBVFYLYCWQYFXAYLWPYBAYLYBCUSRAXPCUSVAOVBZVOYLTYEWSWTYLYBAYDWRYRYLXTWNW
        MYQVGVHVIVJVKVLVMEQUAVPQDXEDYMUONBURVQVRVSVTWEWAVOQGXEXNDXFWMGSZWOXGXDX
        MJWMGWNWBYSXBXKEXCXLWMGHWFYSXAXJWQYSTWSXIWTYSWRXHAWMGWNWCWDVIVEVKWGXFWH
        XGJXMJYOUOMBVNVQVRXKEXLWIWJVTWK $.
    $}

    ${
      $d R g $.  $d .0. g $.
      ig1pval2.z $e |- .0. = ( 0g ` P ) $.
      $( Generator of the zero ideal.  (Contributed by Stefan O'Rear,
         29-Mar-2015.) $)
      ig1pval2 $p |- ( R e. Ring -> ( G ` { .0. } ) = .0. ) $=
        ( vg crg wcel csn cfv wceq cv cdg1 cdif cima cr clt eqid ccnv csup cmn1
        cin crio cif clidl ply1rng lidl0 syl ig1pval mpdan iftrue ax-mp syl6eq
        ) BIJZDKZCLZUQUQMZDHNBOLZLUTUQUQPQRSUAUBMHUQBUCLZUDUEZUFZDUPUQAUGLZJZUR
        VCMUPAIJVEABEUHAVDDVDTZGUIUJUTABVDHCUQVAIDEFGVFUTTVATUKULUSVCDMUQTUSDVB
        UMUNUO $.
    $}

    ${
      $d D g $.  $d G g $.  $d I g $.  $d M g $.  $d P g $.  $d R g $.
      $d U g $.  $d .0. g $.
      ig1pval3.z $e |- .0. = ( 0g ` P ) $.
      ig1pval3.u $e |- U = ( LIdeal ` P ) $.
      ig1pval3.d $e |- D = ( deg1 ` R ) $.
      ig1pval3.m $e |- M = ( Monic1p ` R ) $.
      $( Characterizing properties of the monic generator of a nonzero ideal of
         polynomials.  (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
      ig1pval3 $p |- ( ( R e. DivRing /\ I e. U /\ I =/= { .0. } ) ->
          ( ( G ` I ) e. I /\ ( G ` I ) e. M /\ ( D ` ( G ` I ) ) =
              sup ( ( D " ( I \ { .0. } ) ) , RR , `' < ) ) ) $=
        ( vg cdr wcel cfv wceq wa csn wne w3a cv cdif cima cr clt ccnv csup cin
        crab crio cif ig1pval 3adant3 wn simp3 neneqd iffalse eqtrd wreu ig1peu
        riotacl2 eqeltrd elin anbi1i fveq2 eqeq1d elrab df-3an 3bitr4i sylib
        syl ) CPQZFDQZFHUAZUBZUCZFERZOUDZARZAFVQUEUFUGUHUIUJZSZOFGUKZULZQZVTFQZ
        VTGQZVTARZWCSZUCZVSVTWDOWEUMZWFVSVTFVQSZHWMUNZWMVOVPVTWOSVRABCDOEFGPHIJ
        KLMNUOUPVSWNUQWOWMSVSFVQVOVPVRURUSWNHWMUTVNVAVSWDOWEVBWMWFQABCDOFGHILKN
        MVCWDOWEVDVNVEVTWEQZWKTWHWITZWKTWGWLWPWQWKVTFGVFVGWDWKOVTWEWAVTSWBWJWCW
        AVTAVHVIVJWHWIWKVKVLVM $.
    $}

    ${
      ig1pcl.u $e |- U = ( LIdeal ` P ) $.
      $( The monic generator of an ideal is always in the ideal.  (Contributed
         by Stefan O'Rear, 29-Mar-2015.) $)
      ig1pcl $p |- ( ( R e. DivRing /\ I e. U ) -> ( G ` I ) e. I ) $=
        ( cdr wcel wa cfv c0g csn wceq fveq2 id eleq12d wne eqid cmn1 cdg1 cdif
        w3a cima cr clt ccnv csup ig1pval3 simp1d crg drngrng ig1pval2 syl fvex
        3expa elsnc sylibr adantr pm2.61ne ) BIJZECJZKEDLZEJZAMLZNZDLZVGJZEVGEV
        GOZVDVHEVGEVGDPVJQRVBVCEVGSZVEVBVCVKUDVEVDBUALZJVDBUBLZLVMEVGUCUEUFUGUH
        UIOVMABCDEVLVFFGVFTZHVMTVLTUJUKUQVBVIVCVBVHVFOZVIVBBULJVOBUMABDVFFGVNUN
        UOVHVFVGDUPURUSUTVA $.

      ${
        ig1pdvds.d $e |- .|| = ( ||r ` P ) $.
        $( The monic generator of an ideal divides all elements of the ideal.
           (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
        ig1pdvds $p |- ( ( R e. DivRing /\ I e. U /\ X e. I ) ->
            ( G ` I ) .|| X ) $=
          ( wcel cfv wceq syl wss eqid syl2anc cxr c0 cdr w3a wbr c0g wa lidlss
          csn crg drngrng ply1rng 3ad2ant1 ig1pcl 3adant3 sseldd dvdsr01 adantr
          cbs 3ad2ant2 eleq2 biimpac 3ad2antl3 elsni breqtrrd cr1p co cdg1 cdif
          wne cima cr clt ccnv csup wn cuc1p simpl1 simpl2 simpl3 cmn1 ig1pval3
          cle simpr syl3anc simp2d mon1puc1p r1pdeglt simp3d breqtrd wb deg1xrf
          cq1p cmulr csg simp1d r1pval q1pcl lidlmcl syl22anc lidlsubcl eqeltrd
          wf ffvelrn sylancr cc0 cuz ssdifd imass2 cn0 deg1n0ima nn0uz syl6sseq
          sstrd cz uzssz zssre ressxr sstri syl6ss lidl0cl snssd necomd wfn ffn
          pssdifn0 ax-mp ssdifssd necon3bid mpbird infmssuzcl xrltnle mpbid a1i
          fnimaeq0 eldifsn sylanbrc fnfvima infmssuzle ex necon1bd mpd dvdsr1p
          pm2.61dane ) CUALZFDLZGFLZUBZFEMZGAUCZFBUDMZUGZUUFFUUJNZUEZUUGUUIGAUU
          FUUGUUIAUCZUUKUUFBUHLZUUGBUQMZLZUUMUUCUUDUUNUUEUUCCUHLZUUNCUIZBCHUJZO
          UKUUFFUUOUUGUUDUUCFUUOPZUUEUUOFDBUUOQZJUFZURUUCUUDUUGFLZUUEBCDEFHIJUL
          UMUNUUOABUUGUUIUVAKUUIQZUORUPUULGUUJLZGUUINUUEUUCUUKUVEUUDUUKUUEUVEFU
          UJGUSUTVAGUUIVBOVCUUFFUUJVHZUEZUUHGUUGCVDMZVEZUUINZUVGCVFMZFUUJVGZVIZ
          VJVKVLVMZUVIUVKMZWAUCZVNZUVJUVGUVOUVNVKUCZUVQUVGUVOUUGUVKMZUVNVKUVGUU
          QGUUOLZUUGCVOMZLZUVOUVSVKUCUVGUUCUUQUUCUUDUUEUVFVPZUUROZUVGFUUOGUVGUU
          DUUTUUCUUDUUEUVFVQZUVBOZUUCUUDUUEUVFVRZUNZUVGUUQUUGCVSMZLZUWBUWDUVGUV
          CUWJUVSUVNNZUVGUUCUUDUVFUVCUWJUWKUBUWCUWEUUFUVFWBZUVKBCDEFUWIUUIHIUVD
          JUVKQZUWIQZVTWCZWDUWACUWIUUGUWAQZUWNWERZUUOUWAUVKBCUVHGUUGUVHQZHUVAUW
          PUWMWFWCUVGUVCUWJUWKUWOWGWHUVGUVOSLZUVNSLUVRUVQWIUVGUUOSUVKXAZUVIUUOL
          UWSUUOUVKBCUWMHUVAWJZUVGFUUOUVIUWFUVGUVIGGUUGCWKMZVEZUUGBWLMZVEZBWMMZ
          VEZFUVGUVTUUPUVIUXGNUWHUVGFUUOUUGUWFUVGUVCUWJUWKUWOWNZUNUUOBUXBCUXDUV
          HGUUGUXFUWRHUVAUXBQZUXDQZUXFQZWORUVGUUNUUDUUEUXEFLZUXGFLUVGUUQUUNUWDU
          USOZUWEUWGUVGUUNUUDUXCUUOLZUVCUXLUXMUWEUVGUUQUVTUWBUXNUWDUWHUWQUUOUWA
          BUXBCGUUGUXIHUVAUWPWPWCUXHUUOBUXDDFUXCUUGJUVAUXJWQWRBDFUXFGUXEJUXKWSW
          RWTZUNUUOSUVIUVKXBXCUVGUVMSUVNUVGUVMXDXEMZSUVGUVMUVKUUOUUJVGZVIZUXPUV
          GUVLUXQPUVMUXRPUVGFUUOUUJUWFXFUVLUXQUVKXGOUVGUXRXHUXPUVGUUQUXRXHPUWDU
          UOUVKBCUUIUWMHUVDUVAXIOXJXKXLZUXPXMSXDXNXMVJSXOXPXQXQXRUVGUVMUXPPZUVM
          TVHZUVNUVMLUXSUVGUYAUVLTVHZUVGUUJFPUUJFVHUYBUVGUUIFUVGUUNUUDUUIFLUXMU
          WEBDFUUIJUVDXSRXTUVGFUUJUWLYAUUJFYDRUVGUVMTUVLTUVGUVKUUOYBZUVLUUOPZUV
          MTNUVLTNWIUWTUYCUXAUUOSUVKYCYEZUVGFUUOUUJUWFYFZUUOUVLUVKYMXCYGYHUVMXD
          YIRUNUVOUVNYJRYKUVGUVPUVIUUIUVGUVIUUIVHZUVPUVGUYGUEZUXTUVOUVMLZUVPUVG
          UXTUYGUXSUPUYHUYCUYDUVIUVLLZUYIUYCUYHUYEYLUVGUYDUYGUYFUPUYHUVIFLZUYGU
          YJUVGUYKUYGUXOUPUVGUYGWBUVIFUUIYNYOUUOUVLUVKUVIYPWCUVOUVMXDYQRYRYSYTU
          VGUUQUVTUWBUUHUVJWIUWDUWHUWQUUOUWAABCUVHGUUGUUIHKUVAUWPUVDUWRUUAWCYHU
          UB $.
      $}

      $d G x $.  $d I x $.  $d K x $.  $d P x $.  $d R x $.  $d U x $.
      ig1prsp.k $e |- K = ( RSpan ` P ) $.
      $( Any ideal of polynomials over a division ring is generated by the
         ideal's canonical generator.  (Contributed by Stefan O'Rear,
         29-Mar-2015.) $)
      ig1prsp $p |- ( ( R e. DivRing /\ I e. U ) ->
          I = ( K ` { ( G ` I ) } ) ) $=
        ( vx cdr wcel wa cfv csn wceq cv eqid crg cdsr wbr wral ig1pcl ig1pdvds
        3expa ralrimiva cbs drngrng ply1rng syl adantr wss lidlss adantl sseldd
        wb simpr lidldvgen syl3anc mpbir2and ) BLMZECMZNZEEDOZPFOQZVEEMZVEKRZAU
        AOZUBZKEUCZABCDEGHIUDZVDVJKEVBVCVHEMVJVIABCDEVHGHIVISZUEUFUGVDATMZVCVEA
        UHOZMVFVGVKNUQVBVNVCVBBTMVNBUIABGUJUKULVBVCURVDEVOVEVCEVOUMVBVOECAVOSZI
        UNUOVLUPKVOVIACVEEFVPIJVMUSUTVA $.
    $}
  $}

  ${
    $d P i j $.  $d R i j $.
    ply1lpir.p $e |- P = ( Poly1 ` R ) $.
    $( The ring of polynomials over a division ring has the principal ideal
       property.  (Contributed by Stefan O'Rear, 29-Mar-2015.) $)
    ply1lpir $p |- ( R e. DivRing -> P e. LPIR ) $=
      ( vi cdr wcel crg clidl cfv clpidl wss clpir drngrng ply1rng syl csn wceq
      vj cv eqid crsp cbs wrex cig1p lidlss adantl ig1pcl sseldd ig1prsp fveq2d
      wa sneq eqeq2d rspcev syl2anc wb adantr islpidl ex ssrdv islpir2 sylanbrc
      mpbird ) BEFZAGFZAHIZAJIZKALFVDBGFVEBMABCNOZVDDVFVGVDDSZVFFZVIVGFZVDVJUKZ
      VKVIRSZPZAUAIZIZQZRAUBIZUCZVLVIBUDIZIZVRFVIWAPZVOIZQZVSVLVIVRWAVJVIVRKVDV
      RVIVFAVRTZVFTZUEUFABVFVTVICVTTZWFUGUHABVFVTVIVOCWGWFVOTZUIVQWDRWAVRVMWAQZ
      VPWCVIWIVNWBVOVMWAULUJUMUNUOVLVEVKVSUPVDVEVJVHUQVRVGARVIVOVGTZWHWEUROVCUS
      UTVGAVFWJWFVAVB $.

    $( The polynomials over a field are a PID. (Contributed by Stefan O'Rear,
       29-Mar-2015.) $)
    ply1pid $p |- ( R e. Field -> P e. PID ) $=
      ( cfield wcel cidom clpir cpid fldidom ply1idom syl ccrg simplbi ply1lpir
      cdr isfld df-pid elin2 sylanbrc ) BDEZAFEZAGEZAHETBFEUABIABCJKTBOEZUBTUCB
      LEBPMABCNKAFGHQRS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Elementary properties of complex polynomials
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Poly $.
  $c Xp $.
  $c coeff $.
  $c deg $.

  $( Extend class notation to include the set of complex polynomials. $)
  cply $a class Poly $.

  $( Extend class notation to include the identity polynomial. $)
  cidp $a class Xp $.

  $( Extend class notation to include the coefficient function on
     polynomials. $)
  ccoe $a class coeff $.

  $( Extend class notation to include the degree function on polynomials. $)
  cdgr $a class deg $.

  ${
    $d a f k n x z $.
    $( Define the set of polynomials on the complexes with coefficients in the
       given subset.  (Contributed by Mario Carneiro, 17-Jul-2014.) $)
    df-ply $a |- Poly = ( x e. ~P CC |-> { f | E. n e. NN0
      E. a e. ( ( x u. { 0 } ) ^m NN0 ) f =
        ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) } ) $.

    $( Define the identity polynomial.  (Contributed by Mario Carneiro,
       17-Jul-2014.) $)
    df-idp $a |- Xp = ( _I |` CC ) $.

    $( Define the coefficient function for a polynomial.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    df-coe $a |- coeff = ( f e. ( Poly ` CC ) |-> ( iota_ a e. ( CC ^m NN0 )
        E. n e. NN0 ( ( a " ( ZZ>= ` ( n + 1 ) ) ) = { 0 } /\ f =
    ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) ) ) ) $.

    $( Define the degree of a polynomial.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    df-dgr $a |- deg = ( f e. ( Poly ` CC ) |->
      sup ( ( `' ( coeff ` f ) " ( CC \ { 0 } ) ) , NN0 , < ) ) $.
  $}

  ${
    $d a k n z A $.  $d a k n z N $.  $d a f k n x z S $.  $d a f k n z T $.
    $d a f n F $.
    $( Two ways to say that a function on the nonnegative integers has finite
       support.  (Contributed by Mario Carneiro, 22-Jul-2014.) $)
    plyco0 $p |- ( ( N e. NN0 /\ A : NN0 --> CC ) ->
      ( ( A " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } <->
        A. k e. NN0 ( ( A ` k ) =/= 0 -> k <_ N ) ) ) $=
      ( cn0 wcel cc wa cfv cc0 wceq wne cle wbr clt adantr syl2anc ad2antrr mpd
      wi wb vn wf c1 caddc co cuz cima csn wral simprr wfun cdm wss ffun adantl
      cv wn peano2nn0 eluznn0 ex syl ssrdv fdm sseqtr4d funfvima2 nn0z peano2zd
      cz ad2antrl eluz simplr eleq2d fvex elsnc syl6bb 3imtr3d necon3ad cr zred
      nn0re ltnled mpbird zleltp1 expr ralrimiva ccnv simpr syl2an nn0red ltp1d
      eluzle ad2antll ltletrd mpbid simprl fveq2 neeq1d imbi12d rspcva necon1bd
      breq1 wfn ad2antlr fniniseg mpbir2and funimass3 sylan uzid eqeltrrd snssd
      ffn eqssd impbida ) CDEZDFAUBZGZACUCUDUEZUFHZUGZIUHZJZBUPZAHZIKZYBCLMZSZB
      DUIZXPYAGZYFBDYHYBDEZYDYEYHYIYDGZGZYEYBXQNMZYKYLXQYBLMZUQZYKYDYNYHYIYDUJY
      KYMYCIYKYBXREZYCXSEZYMYCIJZXPYOYPSZYAYJXPAUKZXRAULZUMZYRXOYSXNDFAUNUOZXPX
      RDYTXPBXRDXPXQDEZYOYISXNUUCXOCUROZUUCYOYIYBXQUSUTVAVBXOYTDJXNDFAVCUOVDZXR
      YBAVEPQYKXQVHEZYBVHEZYOYMTXPUUFYAYJXPCXNCVHEZXOCVFOZVGZQYIUUGYHYDYBVFVIZX
      QYBVJPYKYPYCXTEYQYKXSXTYCXPYAYJVKVLYCIYBAVMVNVOVPVQRYKYBXQYIYBVREYHYDYBVT
      VIXPXQVREZYAYJXPXQUUJVSZQWAWBYKUUGUUHYEYLTUUKXPUUHYAYJUUIQYBCWCPWBWDWEXPY
      GGZXSXTUUNXSXTUMZXRAWFXTUGZUMZUUNUAXRUUPXPYGUAUPZXREZUURUUPEZXPYGUUSGZGZU
      UTUURDEZUURAHZIJZXPUUCUUSUVCUVAUUDYGUUSWGUURXQUSWHZUVBUURCLMZUQZUVEUVBCUU
      RNMUVHUVBCXQUURXPCVREZUVAXNUVIXOCVTOZOZXPUULUVAUUMOUVBUURUVFWIZUVBCUVKWJU
      USXQUURLMXPYGXQUURWKWLWMUVBCUURUVKUVLWAWNUVBUVGUVDIUVBUVCYGUVDIKZUVGSZUVF
      XPYGUUSWOYFUVNBUURDYBUURJZYDUVMYEUVGUVOYCUVDIYBUURAWPWQYBUURCLXAWRWSPWTRU
      VBADXBZUUTUVCUVEGTXOUVPXNUVADFAXKXCDIUURAXDVAXEWDVBXPUUOUUQTZYGXPYSUUAUVQ
      UUBUUEXRXTAXFPOWBUUNIXSUUNXQAHZIXSUUNXQCLMZUQZUVRIJXPUVTYGXPCXQNMUVTXPCUV
      JWJXPCXQUVJUUMWAWNOUUNUVSUVRIXPUUCYGUVRIKZUVSSZUUDYFUWBBXQDYBXQJZYDUWAYEU
      VSUWCYCUVRIYBXQAWPWQYBXQCLXAWRWSXGWTRXPUVRXSEZYGXPXQXREZUWDXPUUFUWEUUJXQX
      HVAXPYSUUAUWEUWDSUUBUUEXRXQAVEPROXIXJXLXM $.

    $( Value of the polynomial set function.  (Contributed by Mario Carneiro,
       17-Jul-2014.) $)
    plyval $p |- ( S C_ CC -> ( Poly ` S ) = { f | E. n e. NN0
      E. a e. ( ( S u. { 0 } ) ^m NN0 ) f =
        ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) } ) $=
      ( vx cc wss cply cfv cv cc0 co wceq cun cn0 cmap wrex cab cpw cfz csu csn
      wcel cexp cmul cmpt cnex elpw2 uneq1 oveq1d rexeqdv rexbidv abbidv df-ply
      nn0ex ovex ab2rexex fvmpt sylbir ) BHIBHUAZUEBJKCLAHMELUBNDLZFLKALVCUFNUG
      NDUCUHZOZFBMUDZPZQRNZSZEQSZCTZOBHUIUJGBVEFGLZVFPZQRNZSZEQSZCTVKVBJVLBOZVP
      VJCVQVOVIEQVQVEFVNVHVQVMVGQRVLBVFUKULUMUNUOGACDEFUPEFCQVHVDUQVGQRURUSUTVA
      $.

    $( Reverse closure of the parameter ` S ` of the polynomial set function.
       (Contributed by Mario Carneiro, 22-Jul-2014.) $)
    plybss $p |- ( F e. ( Poly ` S ) -> S C_ CC ) $=
      ( vx vf vz vn vk va cply cfv wcel cc cdm cpw cv cc0 cfz co cn0 wrex cexp
      cmul csu cmpt wceq csn cun cmap cab df-ply dmmptss elfvdm sseldi elpwid )
      BAIJKZALUOIMLNZACUPDOELPFOQRGOZHOJEOUQUARUBRGUCUDUEHCOPUFUGSUHRTFSTDUIICE
      DGFHUJUKBAIULUMUN $.

    $( Definition of a polynomial with coefficients in ` S ` .  (Contributed by
       Mario Carneiro, 17-Jul-2014.) $)
    elply $p |- ( F e. ( Poly ` S ) <-> ( S C_ CC /\ E. n e. NN0
      E. a e. ( ( S u. { 0 } ) ^m NN0 ) F =
        ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) ) ) $=
      ( vf cply cfv wcel cc wss cc0 cv cfz co wceq cn0 wrex cvv cexp csu plybss
      cmul cmpt csn cun cmap cab plyval eleq2d wi wa id cnex mptex syl6eqel a1i
      rexlimivv eqeq1 2rexbidv elab3 syl6bb biadan2 ) EBHIZJZBKLZEAKMDNZOPCNZFN
      ZIANVIUAPUDPCUBZUEZQZFBMUFUGRUHPZSDRSZBEUCVGVFEGNZVLQZFVNSDRSZGUIZJVOVGVE
      VSEABGCDFUJUKVRVOGEVMETJZDFRVNVMVTULVHRJVJVNJUMVMEVLTVMUNAKVKUOUPUQURUSVP
      EQVQVMDFRVNVPEVLUTVAVBVCVD $.

    $( The coefficient function can be assumed to have zeroes outside
       ` 0 ... n ` .  (Contributed by Mario Carneiro, 20-Jul-2014.)  (Revised
       by Mario Carneiro, 23-Aug-2014.) $)
    elply2 $p |- ( F e. ( Poly ` S ) <-> ( S C_ CC /\ E. n e. NN0
    E. a e. ( ( S u. { 0 } ) ^m NN0 ) ( ( a " ( ZZ>= ` ( n + 1 ) ) ) = { 0 } /\
  F = ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) ) ) ) $=
      ( vf vx cfv wcel cc cv co cc0 wceq wa cn0 wrex cvv sylancl cply wss caddc
      c1 cuz cima csn cfz cexp cmul csu cmpt cun cmap elply cif wf simpr simpll
      wb cnex ssexg snex unexg nn0ex mpbid ffvelrnda ssun2 c0ex snss mpbir ifcl
      elmapg eqid fmptd mpbird wne cle wi wral eleq1 fveq2 eqidd ifbieq12d fvex
      wbr wn ifex fvmpt ad2antll iffalse eqeq2d syl5ibcom necon1ad elfzle2 syl6
      anassrs ralrimiva simplr 0cn a1i snssd unssd syl2anc plyco0 imaeq1 eqeq1d
      fss fveq1 elfznn0 iftrue sylan9eq oveq1d sumeq2dv mpteq2dv anbi12d rspcev
      syl eqtrd syl12anc anbi2d rexbidv syl5ibrcom rexlimdva reximdva imdistani
      eqeq1 sylbi reximi anim2i sylibr impbii ) EBUAIJZBKUBZFLZDLZUDUCMUEIZUFZN
      UGZOZEAKNYPUHMZCLZYOIZALUUBUIMZUJMZCUKZULZOZPZFBYSUMZQUNMZRZDQRZPZYMYNEAK
      UUAUUBGLZIZUUDUJMZCUKZULZOZGUUKRZDQRZPUUNABCDEGUOYNUVBUUMYNUVAUULDQYNYPQJ
      ZPZUUTUULGUUKUVDUUOUUKJZPZUULUUTYTUUSUUGOZPZFUUKRZUVFHQHLZUUAJZUVJUUOIZNU
      PZULZUUKJZUVNYQUFZYSOZUUSUUSOZUVIUVFUVOQUUJUVNUQZUVFHQUVMUUJUVNUVFUVJQJPU
      VLUUJJNUUJJZUVMUUJJUVFQUUJUVJUUOUVFUVEQUUJUUOUQZUVDUVEURUVFUUJSJZQSJZUVEU
      WAUTUVFBSJZYSSJUWBUVFYNKSJUWDYNUVCUVEUSZVABKSVBTNVCBYSSSVDTZVEUUJQUUOSSVM
      TVFVGUVTYSUUJUBYSBVHNUUJVIVJVKUVKUVLNUUJVLTUVNVNZVOZUVFUWBUWCUVOUVSUTUWFV
      EUUJQUVNSSVMTVPUVFUVQUUBUVNIZNVQZUUBYPVRWFZVSZCQVTZUVFUWLCQUVDUVEUUBQJZUW
      LUVDUVEUWNPPZUWJUUBUUAJZUWKUWOUWPUWINUWOUWIUWPUUPNUPZOZUWPWGZUWINOUWNUWRU
      VDUVEHUUBUVMUWQQUVNUVJUUBOZUVKUWPUVLNUUPNUVJUUBUUAWAUVJUUBUUOWBUWTNWCWDUW
      GUWPUUPNUUBUUOWEVIWHWIZWJUWSUWQNUWIUWPUUPNWKWLWMWNUUBNYPWOWPWQWRUVFUVCQKU
      VNUQZUVQUWMUTYNUVCUVEWSUVFUVSUUJKUBUXBUWHUVFBYSKUWEUVFNKNKJUVFWTXAXBXCQUU
      JKUVNXHXDUVNCYPXEXDVPUVFUUSWCUVHUVQUVRPFUVNUUKYOUVNOZYTUVQUVGUVRUXCYRUVPY
      SYOUVNYQXFXGUXCUUGUUSUUSUXCAKUUFUURUXCUUAUUEUUQCUXCUWPPUUCUUPUUDUJUXCUWPU
      UCUWIUUPUUBYOUVNXIUWPUWIUWQUUPUWPUWNUWRUUBYPXJUXAXRUWPUUPNXKXSXLXMXNXOWLX
      PXQXTUUTUUIUVHFUUKUUTUUHUVGYTEUUSUUGYGYAYBYCYDYEYFYHUUNYNUUHFUUKRZDQRZPYM
      UUMUXEYNUULUXDDQUUIUUHFUUKYTUUHURYIYIYJABCDEFUOYKYL $.

    $d k z F $.
    $( The set of polynomials is unaffected by the addition of zero.  (This is
       built into the definition because all higher powers of a polynomial are
       effectively zero, so we require that the coefficient field contain zero
       to simplify some of our closure theorems.)  (Contributed by Mario
       Carneiro, 17-Jul-2014.) $)
    plyun0 $p |- ( Poly ` ( S u. { 0 } ) ) = ( Poly ` S ) $=
      ( vf vz vn vk va cc0 cun cply cfv cc wss cv co cn0 cmap wrex wcel elply
      wa csn cfz cexp cmul csu cmpt wceq snssi ax-mp biantru bitr2i unass unidm
      0cn unss uneq2i eqtri oveq1i rexeqi rexbii anbi12i 3bitr4i eqriv ) BAGUAZ
      HZIJZAIJZVEKLZBMZCKGDMUBNEMZFMJCMVJUCNUDNEUEUFUGZFVEVDHZOPNZQZDOQZTAKLZVK
      FVEOPNZQZDOQZTVIVFRVIVGRVHVPVOVSVPVPVDKLZTVHVTVPGKRVTUNGKUHUIUJAVDKUOUKVN
      VRDOVKFVMVQVLVEOPVLAVDVDHZHVEAVDVDULWAVDAVDUMUPUQURUSUTVACVEEDVIFSCAEDVIF
      SVBVC $.

    $( The polynomial is a function on the complexes.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    plyf $p |- ( F e. ( Poly ` S ) -> F : CC --> CC ) $=
      ( vz vn vk va cfv wcel cc cc0 cv co cn0 wrex wf wss wa cvv sylancl syl2an
      cply cfz cexp cmul csu cmpt wceq csn cun cmap elply simprbi fzfid 0cn a1i
      plybss snssd unssd ad2antrr adantr simplrr cnex ssexg nn0ex mpbid elfznn0
      elmapg ffvelrn sseldd simpr expcl mulcld eqid fmptd syl5ibrcom rexlimdvva
      wb fsumcl feq1 mpd ) BAUAGHZBCIJDKZUBLZEKZFKZGZCKZWDUCLZUDLZEUEZUFZUGZFAJ
      UHZUIZMUJLZNDMNZIIBOZWAAIPWPCAEDBFUKULWAWLWQDFMWOWAWBMHZWEWOHZQZQZWQWLIIW
      KOXACIWJIWKXAWGIHZQZWCWIEXCJWBUMXCWDWCHZQZWFWHXEWNIWFXCWNIPZXDWAXFWTXBWAA
      WMIABUPWAJIJIHWAUNUOUQURUSZUTXCMWNWEOZWDMHZWFWNHXDXCWSXHWAWRWSXBVAXCWNRHZ
      MRHWSXHVQXCXFIRHXJXGVBWNIRVCSVDWNMWERRVGSVEWDWBVFZMWNWDWEVHTVIXCXBXIWHIHX
      DXAXBVJXKWGWDVKTVLVRWKVMVNIIBWKVSVOVPVT $.

    $( The polynomial set function preserves the subset relation.  (Contributed
       by Mario Carneiro, 17-Jul-2014.) $)
    plyss $p |- ( ( S C_ T /\ T C_ CC ) -> ( Poly ` S ) C_ ( Poly ` T ) ) $=
      ( vf vz vn vk va wss cc cv cc0 co cfv wceq cun cn0 cmap wrex cvv wcel cfz
      wa cexp cmul csu cmpt csn cab cply wi simpr cnex ssexg sylancl snex unexg
      unss1 adantr mapss syl2anc ssrexv syl reximdv ss2abdv sstr plyval 3sstr4d
      adantl ) ABHZBIHZUBZCJDIKEJUALFJZGJMDJVLUCLUDLFUEUFNZGAKUGZOZPQLZRZEPRZCU
      HZVMGBVNOZPQLZRZEPRZCUHZAUIMZBUIMZVKVRWCCVKVQWBEPVKVPWAHZVQWBUJVKVTSTZVOV
      THZWGVKBSTZVNSTWHVKVJISTWJVIVJUKULBISUMUNKUOBVNSSUPUNVIWIVJABVNUQURVOVTPS
      USUTVMGVPWAVAVBVCVDVKAIHWEVSNABIVEDACFEGVFVBVJWFWDNVIDBCFEGVFVHVG $.

    $( Every polynomial ring is contained in the ring of polynomials over
       ` CC ` .  (Contributed by Mario Carneiro, 22-Jul-2014.) $)
    plyssc $p |- ( Poly ` S ) C_ ( Poly ` CC ) $=
      ( vf cply cfv cc wss c0 wceq 0ss sseq1 mpbiri wne cv wcel wex plybss ssid
      n0 plyss sylancl exlimiv sylbi pm2.61ine ) ACDZECDZFZUDGUDGHUFGUEFUEIUDGU
      EJKUDGLBMZUDNZBOUFBUDRUHUFBUHAEFEEFUFAUGPEQAESTUAUBUC $.

    $( Sufficient condition for elementhood in the set of polynomials.
       (Contributed by Mario Carneiro, 17-Jul-2014.)  (Revised by Mario
       Carneiro, 23-Aug-2014.) $)
    elplyr $p |- ( ( S C_ CC /\ N e. NN0 /\ A : NN0 --> S ) ->
      ( z e. CC |->
        sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( z ^ k ) ) ) e. ( Poly ` S ) ) $=
      ( vn va cc wss cn0 wcel cc0 cfz co cv cfv cmul csu wceq cvv w3a cexp cmpt
      wf csn cun cmap wrex simp1 simp2 simp3 ssun1 fss sylancl wb 0cn a1i snssd
      unssd ssexg nn0ex elmapg mpbird eqidd oveq2 sumeq1d mpteq2dv eqeq2d fveq1
      cply cnex oveq1d sumeq2sdv rspc2ev syl3anc elply sylanbrc ) CHIZEJKZJCBUD
      ZUAZVRAHLEMNZDOZBPZAOWCUBNZQNZDRZUCZAHLFOZMNZWCGOZPZWEQNZDRZUCZSZGCLUEZUF
      ZJUGNZUHFJUHZWHCVJPKVRVSVTUIZWAVSBWSKZWHWHSZWTVRVSVTUJWAXBJWRBUDZWAVTCWRI
      XDVRVSVTUKCWQULJCWRBUMUNWAWRTKZJTKXBXDUOWAWRHIHTKXEWACWQHXAWALHLHKWAUPUQU
      RUSVKWRHTUTUNVAWRJBTTVBUNVCWAWHVDWPXCWHAHWBWMDRZUCZSFGEBJWSWIESZWOXGWHXHA
      HWNXFXHWJWBWMDWIELMVEVFVGVHWKBSZXGWHWHXIAHXFWGXIWBWMWFDXIWLWDWEQWCWKBVIVL
      VMVGVHVNVOACDFWHGVPVQ $.
  $}

  ${
    $d j x z A $.  $d j k x z N $.  $d k z ph $.  $d j k z S $.
    elplyd.1 $e |- ( ph -> S C_ CC ) $.
    elplyd.2 $e |- ( ph -> N e. NN0 ) $.
    elplyd.3 $e |- ( ( ph /\ k e. ( 0 ... N ) ) -> A e. S ) $.
    $( Sufficient condition for elementhood in the set of polynomials.
       (Contributed by Mario Carneiro, 17-Jul-2014.) $)
    elplyd $p |- ( ph -> ( z e. CC |->
      sum_ k e. ( 0 ... N ) ( A x. ( z ^ k ) ) ) e. ( Poly ` S ) ) $=
      ( vj cc cc0 co cv cexp cmul csu cfv cn0 wcel cmpt cply nffvmpt1 nfcv nfov
      cfz csn cun cif wceq fveq2 oveq2 oveq12d cbvsumi wa elfznn0 adantl iftrue
      eqeltrd eqid fvmpt2 syl2anc eqtrd oveq1d sumeq2dv syl5eq mpteq2dv wss 0cn
      wf a1i snssd unssd elun1 syl adantlr ssun2 c0ex mpbir ifclda fmptd elplyr
      wn snss syl3anc eqeltrrd plyun0 syl6eleq ) ABKLFUFMZCBNZENZOMZPMZEQZUAZDL
      UGZUHZUBRZDUBRABKWIJNZESWKWITZCLUIZUAZRZWJWSOMZPMZJQZUAZWOWRABKXFWNAXFWIW
      KXBRZWLPMZEQWNWIXEXIJEEXCXDPESXAWSUCEPUDEXDUDUEJXIUDWSWKUJXCXHXDWLPWSWKXB
      UKWSWKWJOULUMUNAWIXIWMEAWTUOZXHCWLPXJXHXACXJWKSTZXADTXHXAUJWTXKAWKFUPUQXJ
      XACDWTXACUJAWTCLURUQZIUSESXADXBXBUTZVAVBXLVCVDVEVFVGAWQKVHFSTSWQXBVJXGWRT
      ADWPKGALKLKTAVIVKVLVMHAESXAWQXBAXKUOZWTCLWQAWTCWQTZXKXJCDTXOICDWPVNVOVPLW
      QTZXNWTWCUOXPWPWQVHWPDVQLWQVRWDVSVKVTXMWABXBWQJFWBWEWFDWGWH $.
  $}

  ${
    $d k z A $.  $d k z N $.  $d k z S $.
    ply1term.1 $e |- F = ( z e. CC |-> ( A x. ( z ^ N ) ) ) $.
    $( Lemma for ~ ply1term .  (Contributed by Mario Carneiro, 26-Jul-2014.) $)
    ply1termlem $p |- ( ( A e. CC /\ N e. NN0 ) -> F = ( z e. CC |->
      sum_ k e. ( 0 ... N ) ( if ( k = N , A , 0 ) x. ( z ^ k ) ) ) ) $=
      ( cc wcel cn0 wa cc0 cfz co cv wceq cexp cmul csu syl adantr cif cmpt cuz
      cfv wss simplr nn0uz syl6eleq elfz1eq adantl iftrue simpll eqeltrd expcld
      fzss1 mulcld cdif wn eldifn cz wb nn0zd fzsn eleq2d elsnc2g bitrd iffalse
      mtbid oveq1d simpr eldifi elfznn0 expcl syl2an mul02d eqtrd fzfid oveq12d
      csn fsumss oveq2 fsum1 syl2anc eqtr3d mpteq2dva syl6reqr ) BGHZEIHZJZAGKE
      LMZCNZEOZBKUAZANZWKPMZQMZCRZUBAGBWNEPMZQMZUBDWIAGWQWSWIWNGHZJZEELMZWPCRZW
      QWSXAXBWJWPCXAEKUCUDZHXBWJUEXAEIXDWGWHWTUFZUGUHEKEUOSXAWKXBHZJZWMWOXGWMBG
      XGWLWMBOXFWLXAWKEUIUJZWLBKUKZSXAWGXFWGWHWTULZTUMXGWNWKWIWTXFUFXGWKEIXHXAW
      HXFXETUMUNUPXAWKWJXBUQHZJZWPKWOQMKXLWMKWOQXLWLURWMKOXLXFWLXKXFURXAWKWJXBU
      SUJXLEUTHZXFWLVAXLEXAWHXKXETVBXMXFWKEVSZHWLXMXBXNWKEVCVDWKEUTVEVFSVHWLBKV
      GSVIXLWOXAWTWKIHZWOGHXKWIWTVJZXKWKWJHXOWKWJXBVKWKEVLSWNWKVMVNVOVPXAKEVQVT
      XAXMWSGHXCWSOXAEXEVBXABWRXJXAWNEXPXEUNUPWPWSCEWLWMBWOWRQXIWKEWNPWAVRWBWCW
      DWEFWF $.

    $( A one-term polynomial.  (Contributed by Mario Carneiro, 17-Jul-2014.) $)
    ply1term $p |- ( ( S C_ CC /\ A e. S /\ N e. NN0 ) ->
                     F e. ( Poly ` S ) ) $=
      ( vk cc wss wcel cn0 w3a cc0 csn cun cply cfv co cv wceq cfz cif cexp csu
      cmul ssel2 3adant3 simp3 ply1termlem syl2anc simp1 0cn a1i snssd unssd wa
      cmpt simpl2 elun1 syl ssun2 c0ex snss mpbir sylancl elplyd eqeltrd plyun0
      ifcl syl6eleq ) CHIZBCJZEKJZLZDCMNZOZPQZCPQVNDAHMEUARZGSZETZBMUBZASVSUCRU
      ERGUDUQZVQVNBHJZVMDWBTVKVLWCVMCHBUFUGVKVLVMUHZABGDEFUIUJVNAWAVPGEVNCVOHVK
      VLVMUKVNMHMHJVNULUMUNUOWDVNVSVRJZUPZBVPJZMVPJZWAVPJWFVLWGVKVLVMWEURBCVOUS
      UTWHVOVPIVOCVAMVPVBVCVDVTBMVPVIVEVFVGCVHVJ $.
  $}

  ${
    $d k m n x z A $.  $d k m n M $.  $d k m n x z N $.  $d k m n z ph $.
    $d k x z S $.
    $( A power is a polynomial.  (Contributed by Mario Carneiro,
       17-Jul-2014.) $)
    plypow $p |- ( ( S C_ CC /\ 1 e. S /\ N e. NN0 ) ->
                   ( z e. CC |-> ( z ^ N ) ) e. ( Poly ` S ) ) $=
      ( cc wss c1 wcel cn0 w3a cv cexp co cmul cmpt cply cfv wa id simp3 expcl
      syl2anr mulid2d mpteq2dva eqid ply1term eqeltrrd ) BDEZFBGZCHGZIZADFAJZCK
      LZMLZNZADULNBOPUJADUMULUJUKDGZQULUOUOUIULDGUJUORUGUHUISUKCTUAUBUCAFBUNCUN
      UDUEUF $.

    $( A constant function is a polynomial.  (Contributed by Mario Carneiro,
       17-Jul-2014.) $)
    plyconst $p |- ( ( S C_ CC /\ A e. S ) ->
                     ( CC X. { A } ) e. ( Poly ` S ) ) $=
      ( vz cc wss wcel wa cv cc0 cexp co cmul cmpt csn cxp cply cfv wceq exp0
      c1 adantl oveq2d ssel2 mulid1d eqtrd mpteq2dva fconstmpt syl6eqr cn0 0nn0
      adantr eqid ply1term mp3an3 eqeltrrd ) BDEZABFZGZCDACHZIJKZLKZMZDANOZBPQZ
      URVBCDAMVCURCDVAAURUSDFZGZVAATLKAVFUTTALVEUTTRURUSSUAUBVFAURADFVEBDAUCUKU
      DUEUFCDAUGUHUPUQIUIFVBVDFUJCABVBIVBULUMUNUO $.

    $( A test to show that a polynomial is nonzero.  (Contributed by Mario
       Carneiro, 23-Jul-2014.) $)
    ne0p $p |- ( ( A e. CC /\ ( F ` A ) =/= 0 ) -> F =/= 0p ) $=
      ( cc wcel cfv cc0 wne c0p wceq 0pval fveq1 eqeq1d syl5ibrcom necon3d imp
      ) ACDZABEZFGBHGPBHQFPQFIBHIZAHEZFIAJRQSFABHKLMNO $.

    $( The zero function is a polynomial.  (Contributed by Mario Carneiro,
       17-Jul-2014.) $)
    ply0 $p |- ( S C_ CC -> 0p e. ( Poly ` S ) ) $=
      ( cc wss c0p cc0 csn cun cply cfv cxp df-0p wcel id 0cn snssd unssd ssun2
      a1i c0ex snss mpbir plyconst sylancl syl5eqel plyun0 syl6eleq ) ABCZDAEFZ
      GZHIZAHIUGDBUHJZUJKUGUIBCEUILZUKUJLUGAUHBUGMUGEBEBLUGNROPULUHUICUHAQEUIST
      UAEUIUBUCUDAUEUF $.

    $( The identity function is a polynomial.  (Contributed by Mario Carneiro,
       17-Jul-2014.) $)
    plyid $p |- ( ( S C_ CC /\ 1 e. S ) -> Xp e. ( Poly ` S ) ) $=
      ( vz cc wss c1 wcel wa cidp cexp cmpt cply cfv cid cres mptresid mpteq2ia
      cv co exp1 df-idp 3eqtr4ri cn0 1nn0 plypow mp3an3 syl5eqel ) ACDZEAFZGHBC
      BQZEIRZJZAKLZBCUIJMCNUKHBCOBCUJUIUISPTUAUGUHEUBFUKULFUCBAEUDUEUF $.

    plyeq0.1 $e |- ( ph -> S C_ CC ) $.
    plyeq0.2 $e |- ( ph -> N e. NN0 ) $.
    plyeq0.3 $e |- ( ph -> A e. ( ( S u. { 0 } ) ^m NN0 ) ) $.
    plyeq0.4 $e |- ( ph -> ( A " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $.
    plyeq0.5 $e |- ( ph -> 0p =
      ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
    ${
      plyeq0.6 $e |- M = sup ( ( `' A " ( S \ { 0 } ) ) , RR , < ) $.
      plyeq0.7 $e |- ( ph -> ( `' A " ( S \ { 0 } ) ) =/= (/) ) $.
      $( Lemma for ~ plyeq0 .  If ` A ` is the coefficient function for a
         nonzero polynomial such that
         ` P ( z ) = sum_ k e. NN0 A ( k ) x. z ^ k = 0 ` for every ` z e. CC `
         and ` A ( M ) ` is the nonzero leading coefficient, then the function
         ` F ( z ) = P ( z ) / z ^ M ` is a sum of powers of ` 1 / z ` , and so
         the limit of this function as ` z ~~> +oo ` is the constant term,
         ` A ( M ) ` .  But ` F ( z ) = 0 ` everywhere, so this limit is also
         equal to zero so that ` A ( M ) = 0 ` , a contradiction.  (Contributed
         by Mario Carneiro, 22-Jul-2014.) $)
      plyeq0lem $p |- -. ph $=
        ( cc0 wcel cn co cc cn0 vm vn cfv csn wceq cxp cli wbr cfz cif csu cmin
        vx cv cexp cmul cmpt c1 cvv nnuz cz 1z a1i fzfid wa clt cabs wf cun wss
        cdiv cmap 0cn snssd unssd cnex ssexg sylancl nn0ex elmapg mpbid syl2anc
        wb ffvelrn syl2an adantr abscld recnd syl nnex mptex cr eqid ovex fvmpt
        adantl sylan eqeltrd weq oveq1 oveq2d ad2antrr cdif cima wne cle syl6ss
        wral nn0red wi caddc cuz elpreima fveq2 syl2anr cneg ad3antrrr breqtrrd
        nn0zd mpbird breqtrd nnne0 eqtrd ad2antlr expclzd mulcld adantlr fveq2d
        nncn simpr sylibr oveq1d 3eqtr4d syl6eleq mpbir2and syl31anc climconst2
        c0p 3eqtr3d expcl fss elfznn0 divcnv oveq2 nndivre crp nnrp elfzelz cdm
        ccnv cnvimass fdm syl5sseq csup c0 wrex nn0ssz sselda simplbda eldifsni
        plyco0 wfn ffn neeq1d breq1 imbi12d rspcv syl3c ralrimiva breq2 ralbidv
        rspcev suprzcl syl3anc syl5eqel sseldd zsubcl rpexpcld remulcld nnrecre
        rpred absge0d nnge1 1re simplr zltp1le leaddsub2d negsubdi2d lenegcon2d
        nnre zred znegcl ax-mp leexp2ad lemul2ad divrecd 3brtr4d rpge0d mulge0d
        eluz expn1 climsqz2 an32s absmuld 3eqtr4rd climabs0 wn ltned necon3bbii
        absidd elsn iffalse mul02d ifeq1d syl6eq mulid1d nn0ssre anim1i eldifsn
        ifid difun2 suprub syl6breqr simpllr letri3d exp0d pm2.61dane mpteq2dva
        subidd iftrue fconstmpt syl6eqr ifcl eqbrtrd ltlecasei snex xpex anasss
        eqimss2i 0pval sumeq2sdv sumex expne0d div0d fsumdivc fvconst2g expsubd
        fveq1d divassd sumeq2dv climfsum suprleub syl5eqbr nn0uz elfz5 ffvelrnd
        cfn wo elsni eleq1d syl5ibrcom ralrimiv olcd sumss2 syl21anc ltso supex
        eqeltri sumsn sylancr eqtr3d mp2an climuni elsnc simprd eldifbd pm2.65i
        fvex ) AFCUCZOUDZPZAVVSOUEZVWAAQVVTUFZVVSUGUHVWCOUGUHZVWBAVWCOGUIRZEUNZ
        FUDZPZVWFCUCZOUJZEUKZVVSUGAVWEVWJEUAUBQVWIUBUNZVWFFULRZUORZUPRZUQZVWCUR
        USQUTURVAPZAVBVCAOGVDZAVWFVWEPZVEZVWPVWJUGUHVWFFVWTVWFFVFUHZVEZVWPOVWJU
        GVXBVWPOUGUHUBQVWIVGUCZVWNUPRZUQZOUGUHVXBOUAUBQVXCVWLVKRZUQZVXEURUSQUTV
        WQVXBVBVCZVXBVXCSPZVXGOUGUHVXBVXCVXBVWIVWTVWISPZVXAATSCVHZVWFTPZVXJVWSA
        TDVVTVIZCVHZVXMSVJZVXKACVXMTVLRPZVXNJAVXMUSPZTUSPVXPVXNWCAVXOSUSPVXQADV
        VTSHAOSOSPZAVMVCZVNVOZVPVXMSUSVQVRVSVXMTCUSUSVTVRWAZVXTTVXMSCUUAWBZVWFG
        UUBZTSVWFCWDZWEZWFZWGZWHZVXCUBUUCWIVXEUSPVXBUBQVXDWJWKVCZVXBUAUNZQPZVEZ
        VYJVXGUCZVXCVYJVKRZWLVYKVYMVYNUEVXBUBVYJVXFVYNQVXGVWLVYJVXCVKUUDVXGWMVX
        CVYJVKWNWOWPZVXBVXCWLPVYKVYNWLPVYGVXCVYJUUEWQWRVYLVYJVXEUCZVXCVYJVWMUOR
        ZUPRZWLVYKVYPVYRUEVXBUBVYJVXDVYRQVXEUBUAWSZVWNVYQVXCUPVWLVYJVWMUOWTZXAV
        XEWMVXCVYQUPWNWOWPZVYLVXCVYQVYLVWIVWTVXJVXAVYKVYEXBZWGZVYLVYQVYLVYJVWMV
        YKVYJUUFPVXBVYJUUGWPVWTVWMVAPZVXAVYKVWSVWFVAPZFVAPZWUDAVWFOGUUHZAFACUUJ
        DVVTXCZXDZTFACUUIZWUITCWUHUUKAVXNWUJTUEVYATVXMCUULWIUUMZAFWUIWLVFUUNZWU
        IMAWUIVAVJWUIUUOXEZBUNZUMUNZXFUHZBWUIXHZUMWLUUPZWULWUIPAWUITVAWUKUUQXGN
        AGWLPZWUNGXFUHZBWUIXHZWURAGIXIZAWUTBWUIAWUNWUIPZVEZWUNTPZVWIOXEZVWFGXFU
        HZXJZETXHZWUNCUCZOXEZWUTAWUITWUNWUKUURAWVIWVCACGURXKRXLUCXDVVTUEZWVIKAG
        TPVXKWVLWVIWCIVYBCEGUVAWBWAWFWVDWVJWUHPZWVKAWVCWVEWVMACTUVBZWVCWVEWVMVE
        WCAVXNWVNVYATVXMCUVCWIZTWUNWUHCXMWIUUSWVJDOUUTWIWVHWVKWUTXJEWUNTEBWSZWV
        FWVKWVGWUTWVPVWIWVJOVWFWUNCXNUVDVWFWUNGXFUVEUVFUVGUVHUVIZWUQWVAUMGWLWUO
        GUEWUPWUTBWUIWUOGWUNXFUVJUVKUVLWBZUMBWUIUVMUVNUVOZUVPZXSZVWFFUVQZXOZXBZ
        UVRZUWAZUVSWRVYLVYRVXCURVYJVKRZUPRZVYPVYMXFVYLVYQWWGVXCWWFVYKWWGWLPVXBV
        YJUVTWPWUCVXBOVXCXFUHVYKVXBVWIVYFUWBWFZVYLVYQVYJURXPZUORZWWGXFVYLVYJVWM
        WWJVYKVYJWLPVXBVYJUWJWPVYKURVYJXFUHVXBVYJUWCWPVYLWWJVWMXLUCPZVWMWWJXFUH
        ZVYLURVWMURWLPVYLUWDVCZVYLVWMWWDUWKVYLURFVWFULRZVWMXPXFVYLVWFURXKRFXFUH
        ZURWWOXFUHVYLVXAWWPVWTVXAVYKUWEVYLWUEWUFVXAWWPWCVWTWUEVXAVYKVWSWUEAWUGW
        PXBAWUFVWSVXAVYKWWAXQVWFFUWFWBWAVYLVWFURFVWTVWFWLPZVXAVYKVWTVWFVWSVXLAV
        YCWPXIZXBWWNVWTFWLPZVXAVYKVWTFAFTPZVWSWVTWFXIZXBUWGWAVYLVWFFVWTVWFSPVXA
        VYKVWTVWFWWRWHXBVWTFSPZVXAVYKVWTFWXAWHZXBUWHXRUWIVYLWUDWWJVAPZWWLWWMWCW
        WDVWQWXDVBURUWLUWMVWMWWJUWTVRXTUWNVYLVYJSPZWWKWWGUEVYKWXEVXBVYJYIZWPZVY
        JUXAWIYAUWOWUAVYLVYMVYNWWHVYOVYLVXCVYJVXBVXIVYKVYHWFWXGVYKVYJOXEZVXBVYJ
        YBZWPUWPYCUWQVYLOVYRVYPXFVYLVXCVYQWUCWWFWWIVYLVYQWWEUWRZUWSWUAXRUXBVXBU
        AVWPVXEURUSUSQUTVXHVWPUSPVXBUBQVWOWJWKVCVYIVWTVYKVYJVWPUCZSPZVXAAVYKVWS
        WXLAVYKVEZVWSVEZWXKVWIVYQUPRZSVYKWXKWXOUEZAVWSUBVYJVWOWXOQVWPVYSVWNVYQV
        WIUPVYTXAVWPWMVWIVYQUPWNWOZYDZWXNVWIVYQWXMVXKVXLVXJVWSAVXKVYKVYBWFVYCVY
        DWEZWXNVYJVWMVYKWXEAVWSWXFYDZVYKWXHAVWSWXIYDZVWSWUEWUFWUDWXMWUGAWUFVYKW
        WAWFZWWBXOYEYFWRUXCZYGVYLWXOVGUCZVYRWXKVGUCVYPVYLWYDVXCVYQVGUCZUPRVYRVY
        LVWIVYQWUBVYLVYQWWFWHUXDVYLWYEVYQVXCUPVYLVYQWWFWXJUXJXAYCVYLWXKWXOVGVYK
        WXPVXBWXQWPYHWUAUXEUXFXTVXBVWHUXGZVWJOUEVXBVWFFXEWYFVXBVWFFVWTWWQVXAWWR
        WFVWTVXAYJUXHVWHVWFFEFUXKZUXIYKVWHVWIOUXLWIXRVWTFVWFXFUHZVEZVWPQVWJUDUF
        ZVWJUGWYIVWPUBQVWJUQWYJWYIUBQVWOVWJWYIVWLQPZVEZVWOVWJUEVWIOWYLVWIOUEZVE
        ZOVWNUPROVWOVWJWYNVWNWYNVWLVWMWYKVWLSPZWYIWYMVWLYIZYDWYKVWLOXEWYIWYMVWL
        YBYDVWTWUDWYHWYKWYMWWCXQYEUXMWYNVWIOVWNUPWYLWYMYJZYLWYNVWJVWHOOUJOWYNVW
        HVWIOOWYQUXNVWHOUXTUXOYMWYLWVFVEZVWIURUPRVWIVWOVWJWYRVWIWYIVXJWYKWVFVWT
        VXJWYHVYEWFZXBUXPWYRVWNURVWIUPWYRVWNVWLOUORURWYRVWMOVWLUOWYRVWMFFULROWY
        RVWFFFULWYRVWFFUEZVWFFXFUHZWYHWYIWVFXUAWYKVWTWVFXUAWYHVWTWVFVEZVWFWULFX
        FXUBWUIWLVJZWUMWURVWFWUIPZVWFWULXFUHAXUCVWSWVFAWUITWLWUKUXQXGZXBAWUMVWS
        WVFNXBAWURVWSWVFWVRXBXUBXUDVXLVWIWUHPZVWSVXLAWVFVYCYDXUBVWIVXMVVTXCZWUH
        XUBVWIVXMPZWVFVEVWIXUGPVWTXUHWVFAVXNVXLXUHVWSVYAVYCTVXMVWFCWDWEUXRVWIVX
        MOUXSYKDVVTUYAYNAXUDVXLXUFVEWCZVWSWVFAWVNXUIWVOTVWFWUHCXMWIXBYOUMBWUIVW
        FUYBYPMUYCYGYGVWTWYHWYKWVFUYDWYRVWFFVWTWWQWYHWYKWVFWWRXQVWTWWSWYHWYKWVF
        WXAXQUYEYOZYLWYRFVWTWXBWYHWYKWVFWXCXQUYIYCXAWYRVWLWYKWYOWYIWVFWYPYDUYFY
        CXAWYRVWHVWJVWIUEWYRWYTVWHXUJWYGYKVWHVWIOUYJWIYMUYGUYHUBQVWJUYKUYLWYIVW
        JSPZVWQWYJVWJUGUHWYIVXJVXRXUKWYSVMVWHVWIOSUYMVRVBVWJURQQURXLUCUTUYSZWJY
        QVRUYNWWRWXAUYOVWCUSPAQVVTWJOUYPUYQVCAVWSVYKWXLWYCUYRWXMOVWEVWIVYJVWFUO
        RZUPRZVYJFUORZVKRZEUKZVYJVWCUCZVWEWXKEUKWXMOXUOVKRVWEXUNEUKZXUOVKROXUQW
        XMOXUSXUOVKWXMVYJYRUCZVYJBSVWEVWIWUNVWFUORZUPRZEUKZUQZUCZOXUSAXUTXVEUEV
        YKAVYJYRXVDLVUHWFWXMWXEXUTOUEVYKWXEAWXFWPZVYJUYTWIWXMWXEXVEXUSUEXVFBVYJ
        XVCXUSSXVDBUAWSZVWEXVBXUNEXVGXVAXUMVWIUPWUNVYJVWFUOWTXAVUAXVDWMVWEXUNEV
        UBWOWIYSYLWXMXUOVYKWXEWWTXUOSPZAWXFWVTVYJFYTXOZWXMVYJFXVFVYKWXHAWXIWPWY
        BVUCZVUDWXMVWEXUNXUOEWXMOGVDXVIWXNVWIXUMWXSWXMWXEVXLXUMSPVWSXVFVYCVYJVW
        FYTWEZYFXVJVUEYSAVXRVYKXUROUEVXSQOVYJSVUFWQWXMVWEWXKXUPEWXNWXOVWIXUMXUO
        VKRZUPRWXKXUPWXNVYQXVLVWIUPWXNVYJVWFFWXTWYAWXMWUFVWSWYBWFVWSWUEWXMWUGWP
        VUGXAWXRWXNVWIXUMXUOWXSXVKWXMXVHVWSXVIWFWXMXUOOXEVWSXVJWFVUIYMVUJYMVUKA
        VWGVWIEUKZVWKVVSAVWGVWEVJVXJEVWGXHVWEOXLUCZVJZVWEVUQPZVURXVMVWKUEAFVWEA
        FVWEPZFGXFUHZAFWULGXFMAWULGXFUHZWVAWVQAXUCWUMWURWUSXVSWVAWCXUENWVRWVBUM
        BBWUIGVULYPXTVUMAFXVNPGVAPXVQXVRWCAFTXVNWVTVUNYNAGIXSFOGVUOWBXTVNAVXJEV
        WGAVXJVWHVVSSPZATSFCVYBWVTVUPZVWHVWIVVSSVWHVWFFCVWFFVUSYHVUTVVAVVBAXVPX
        VOVWRVVCVWGVWEVWIEOVVDVVEAFUSPXVTXVMVVSUEFWULUSMWLWUIVFVVFVVGVVHXWAVWIV
        VSEFUSVWFFCXNVVIVVJVVKYAVXRVWQVWDVMVBOURQXULWJYQVVLVVSOVWCVVMVRVVSOFCVV
        RVVNYKAVVSDVVTAWWTVVSWUHPZAFWUIPZWWTXWBVEZWVSAWVNXWCXWDWCWVOTFWUHCXMWIW
        AVVOVVPVVQ $.
    $}

    $( If a polynomial is zero at every point (or even just zero at the
       positive integers), then all the coefficients must be zero.  This is the
       basis for the method of equating coefficients of equal polynomials, and
       ensures that ~ df-coe is well-defined.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    plyeq0 $p |- ( ph -> A = ( NN0 X. { 0 } ) ) $=
      ( cn0 cc0 wceq wss wcel cvv cc cima c0 csn wf cxp wfn crn cun cmap co 0cn
      a1i snssd unssd cnex ssexg sylancl nn0ex elmapg mpbid ffn syl cdm imadmrn
      wb ccnv fdm fimacnv eqtr4d cdif simpr wne wa cr clt csup adantr caddc cuz
      c1 cfv c0p cfz cv cexp cmul cmpt eqid plyeq0lem pm2.21i pm2.61dane uneq1d
      csu undif1 imaeq2i imaundi eqtr3i un0 uncom 3eqtr4g eqimss wfun ffun ssid
      eqtrd funimass3 mpbird syl5eqssr df-f sylanbrc c0ex fconst2 sylib ) ALMUA
      ZCUBZCLXLUCNACLUDZCUEZXLOXMALDXLUFZCUBZXNACXPLUGUHPZXQIAXPQPZLQPXRXQVCAXP
      RORQPXSADXLRGAMRMRPAUIUJUKULUMXPRQUNUOUPXPLCQQUQUOURZLXPCUSUTAXOCCVAZSZXL
      CVBAYBXLOZYACVDZXLSZOZAYAYENYFAYAYDXPSZYEAXQYAYGNXTXQYALYGLXPCVELXPCVFVGU
      TAYDDXLVHZSZYEUFZTYEUFZYGYEAYITYEAYITNZYITAYLVIAYITVJZVKZYLYNBCDEYIVLVMVN
      ZFADROYMGVOAFLPYMHVOAXRYMIVOACFVRVPUHVQVSSXLNYMJVOAVTBRMFWAUHEWBZCVSBWBYP
      WCUHWDUHEWKWENYMKVOYOWFAYMVIWGWHWIWJYDYHXLUFZSYGYJYQXPYDDXLWLWMYDYHXLWNWO
      YETUFYEYKYEWPYETWQWOWRXCYAYEWSUTACWTZYAYAOYCYFVCAXQYRXTLXPCXAUTYAXBYAXLCX
      DUOXEXFLXLCXGXHLMCXIXJXK $.
  $}

  ${
    $d a f k n x z A $.  $d a f k n x z E $.  $d a f k n x z S $.
    plypf1.r $e |- R = ( CCfld |`s S ) $.
    plypf1.p $e |- P = ( Poly1 ` R ) $.
    plypf1.a $e |- A = ( Base ` P ) $.
    plypf1.e $e |- E = ( eval1 ` CCfld ) $.
    $( Write the set of complex polynomials in a subring in terms of the
       abstract polynomial construction.  (Contributed by Mario Carneiro,
       3-Jul-2015.) $)
    plypf1 $p |- ( S e. ( SubRing ` CCfld ) -> ( Poly ` S ) = ( E " A ) ) $=
      ( vz vk ccnfld cfv wcel cc cc0 co wceq cn0 cvv vf vn va vx csubrg cply cv
      cima cfz cexp cmul csu cmpt csn cun cmap wrex wss elply simprbi cpws cgsu
      wa cfn c0g eqid cnfldbas cnex a1i fzfid crg cnrng rngcmn subrgss ad2antrr
      ccmn mp1i wf ad2antll wb csubg subrgsubg cnfld0 adantr sylib feq3 elfznn0
      syl mpbid sseldd syl2anc mulcld fmptd fisuppfi pwsgsum gsumfsum mpteq2dva
      cdif eqtrd mp2an csubmnd cncrng sylancr cxp cbs pwselbasb sylibr cnfldmul
      ax-mp fconstmpt fnfvima syl3anc eqeltrrd cmgp cmg adantl pwselbas feqmptd
      eqidd simpr evl1vard evl1expd simprd eleq1 syl5 cle wbr cmnd rngmnd nn0ex
      ccnv ssfi wn wi cxr 0xr cmnf eqeltrd sylan2 suppss2 subg0cl snssd ssequn2
      elmapi ffvelrn syl2an adantrl simprl expcl mptex anassrs pwsrng cpl1 ccrg
      evl1rhm subrgply1 rhmima subgsubm 3syl cmulr fconst6g anass1rs pwsmulrval
      crh cof offval2 cascl evl1sca wfn rhmf ffn simpll subrg1asclcl mpbird cv1
      subrgsubm subrgvr1cl submmulgcl cnfldexp gsumsubmcl syl5ibrcom rexlimdvva
      subrgmcl wfun ffun fvelima mpan cdg1 cif cco1 ccom sselda cnfldex ply1coe
      cvsca fveq2d ply1rng cghm cmhm rhmghm ghmmhm clmod ply1lmod coe1f syl5ibr
      subrgbas imp ffvelrnda rngmgp vr1cl mgpbas mulgnn0cl csca ply1sca coe1sfi
      lmodvscl cnveqd imaeq1d eqimss2 lmod0vs suppssov1 gsummhm fmptco ffvelrni
      eqeq2d anbi2d evl1vsd oveq2d 3eqtr2d adantlr adantll anasss eldifn eldifi
      sylan fveq2 wne deg1ge 3expia deg1xrcl xrmax2 nn0red rexrd sylancl xrletr
      ifcl mpan2d syld jctild wo deg1cl nn0ge0 iftrue id clt cr 0re mnflt mnfxr
      elun xrltnle mpbi elsni breq2d mtbiri iffalse 0nn0 syl6eqel fznn0 sylibrd
      jaoi necon1bd oveq1d mul02d an32s pws0g eqtr3i syl6eq ssriv resmpt oveq2i
      mpd cres gsumres 3eqtr3a 3eqtrd elplyr syl5ibcom rexlimdva impbid eqrdv )
      DLUEMNZUADUFMZEAUHZVWLUAUGZVWMNZVWOVWNNZVWPVWOJOPUBUGZUIQZKUGZUCUGZMZJUGZ
      VWTUJQZUKQZKULZUMZRZUCDPUNZUOZSUPQZUQUBSUQZVWLVWQVWPDOURZVXLJDKUBVWOUCUSU
      TVWLVXHVWQUBUCSVXKVWLVWRSNZVXAVXKNZVCZVCZVWQVXHVXGVWNNVXQLOVAQZKVWSJOVXEU
      MZUMZVBQZVXGVWNVXQVYAJOLKVWSVXEUMVBQZUMVXGVXQJKOLVXEOVWSTVDVXRVXRVEMZVXRV
      FZVGVYCVFZOTNZVXQVHVIVXQPVWRVJZLVKNZLVPNZVXQVLLVMZVQVXQVXCONZVWTVWSNZVCVC
      ZVXBVXDVXQVYLVXBONZVYKVXQVYLVCZDOVXBVWLVXMVXPVYLDOLVGVNZVOVXQSDVXAVRZVWTS
      NZVXBDNZVYLVXQSVXJVXAVRZVYQVXOVYTVWLVXNVXAVXJSUUDVSVXQVXJDRZVYTVYQVTVXQVX
      IDURWUAVXQPDVWLPDNZVXPVWLDLWAMNWUBDLWBDLPWCUUAWHWDUUBVXIDUUCWEVXJDSVXAWFW
      HWIVWTVWRWGZSDVWTVXAUUEUUFZWJZUUGVYMVYKVYRVXDONZVXQVYKVYLUUHVYLVYRVXQVYKW
      UCVSVXCVWTUUIZWKZWLZVXQVWSTTVYCUNWRZVXTVYGVXQKVWSVXSTVXTVXSTNVYOJOVXEVHUU
      JVIVXTVFZWMWNWOVXQJOVYBVXFVXQVYKVCZVWSVXEKWULPVWRVJVXQVYKVYLVXEONWUIUUKWP
      WQWSVXQVWSVWNVXTVXRVDVYCVYEVXRVKNZVXRVPNVXQVYHVYFWUMVLVHLOTVXRVYDUULWTZVX
      RVMVQVYGVXQVWNVXRUEMNZVWNVXRWAMNVWNVXRXAMNVXQELUUMMZVXRUVDQNZAWUPUEMNZWUO
      LUUNNZWUQXBOWUPLVXREIWUPVFZVYDVGUUOXIZVWLWURVXPALWUPDBCWUTFGHUUPZWDEWUPVX
      RAUUQXCZVWNVXRWBVWNVXRUURUUSVXQKVWSVXSVWNVXTVYOOVXBUNXDZJOVXDUMZVXRUUTMZQ
      ZVXSVWNVYOWVGWVDWVEUKUVEQVXSVYOVXRXEMZLWVFUKWVDWVEOVKTVXRVYDWVHVFZVYHVYOV
      LVIZVYFVYOVHVIZVYOOOWVDVRZWVDWVHNZVYOVYNWVLWUEOVXBOUVAWHVYHVYFWVMWVLVTVLV
      HOLOWVHVKWVDVXRTVYDVGWVIXFWTXGVYOOOWVEVRZWVEWVHNZVYOJOVXDOWVEVXQVYKVYLWUF
      WUHUVBZWVEVFWMVYHVYFWVOWVNVTVLVHOLOWVHVKWVEVXRTVYDVGWVIXFWTXGXHWVFVFZUVCV
      YOJOVXBVXDUKWVDWVETOOWVKVYOVYNVYKWUEWDWVPWVDJOVXBUMRVYOJOVXBXJVIVYOWVEXSU
      VFWSVYOWUOWVDVWNNWVEVWNNWVGVWNNVXQWUOVYLWVCWDZVYOVXBWUPUVGMZMZEMZWVDVWNVY
      OWUSVYNWWAWVDRXBWUEWVSOWUPLEVXBIWUTVGWVSVFZUVHXCVYOEWUPXEMZUVIZAWWCURZWVT
      ANZWWAVWNNWWCWVHEVRZWWDVYOWUQWWGWVAWWCWVHWUPVXREWWCVFZWVIUVJXIZWWCWVHEUVK
      VQZVWLWWEVXPVYLVWLWURWWEWVBAWWCWUPWWHVNWHZVOZVYOWWFVYSWUDVYOWVSAWUPLDBCOV
      XBWUTWWBFGVWLVXPVYLUVLZHVGWUEUVMUVNWWCAEWVTXKXLXMVYOVWTLUVOMZWUPXNMZXOMZQ
      ZEMZWVEVWNVYOWWRJOVXCWWRMZUMWVEVYOJOOWWRVYOOLOWVHVKWWRVXRTVYDVGWVIWVJWVKV
      YOVWNWVHWWRVYOWUOVWNWVHURWVRVWNWVHVXRWVIVNWHVYOWWDWWEWWQANZWWRVWNNWWJWWLV
      YOAWWOXAMNZVYRWWNANWWTVYOWURWXAVWLWURVXPVYLWVBVOAWUPWWOWWOVFZUVPWHVYLVYRV
      XQWUCXPZVYOALDBCWWNWWNVFZWWMFGHUVQAWWPWWOVWTWWNWWPVFZUVRXLWWCAEWWQXKXLZWJ
      XQXRVYOJOWWSVXDVYOVYKVCZWWSVWTVXCLXNMXOMZQZVXDWXGWWQWWCNZWWSWXIRZWXGOWUPL
      WWPWWCWXHWWNVWTEVXCVXCIWUTVGWWHWUSWXGXBVIZVYOVYKXTZWXGOWUPLWWCEWWNVXCIWXD
      VGWUTWWHWXLWXMYAWXEWXHVFZVYOVYRVYKWXCWDZYBYCWXGVYKVYRWXIVXDRZWXMWXOVXCVWT
      UVSZWKWSWQWSWXFXMVWNVXRWVFWVDWVEWVQUWCXLXMWUKWMZVXQVWSVWNWUJVXTVYGWXRWNUV
      TXMVWOVXGVWNYDUWAUWBYEVWQVXAEMZVWORZUCAUQZVWLVWPEUWDZVWQWYAWWGWYBWWIWWCWV
      HEUWEXIUCVWOAEUWFUWGVWLWXTVWPUCAVWLVXAANZVCZWXSVWMNWXTVWPWYDWXSJOPPVXALUW
      HMZMZYFYGZWYFPUWIZUIQZVWTVXAUWJMZMZVXDUKQZKULZUMZVWMWYDWXSVXRKSJOWYLUMZUM
      ZVBQZJOLKSWYLUMZVBQZUMWYNWYDWXSWUPKSWYKWWQWUPUWOMZQZUMZVBQZEMVXREXUBUWKZV
      BQWYQWYDVXAXUCEWYDWUSVXAWWCNZVXAXUCRXBVWLAWWCVXAWWKUWLZWYJWWCWUPLWYTKWWPV
      XAWWOWWNWUTWXDWWHWYTVFZWXBWXEWYJVFZUWMUWNXCUWPWYDSWWCXUBWUPVXRETWUPVEMZWW
      HXUIVFZWUPVKNZWUPVPNWYDVYHXUKVLWUPLWUTUWQXIZWUPVMVQWUMVXRYHNWYDWUNVXRYIVQ
      STNZWYDYJVIZEWUPVXRUWRQNZEWUPVXRUWSQNWYDWUQXUOWVAWUPVXREUWTXIWUPVXREUXAVQ
      WYDKSXUAWWCXUBWYDVYRVCZWUPUXBNZWYKONZWXJXUAWWCNZVYHXUQXUPVLWUPLWUTUXCZVQX
      UPDOWYKVWLVXMWYCVYRVYPVOWYDSDVWTWYJVWLWYCSDWYJVRZWYCXVAVWLSCXEMZWYJVRZWYJ
      ABCVXAXVBXUHHGXVBVFUXDVWLDXVBRXVAXVCVTDLCFUXFDXVBSWYJWFWHUXEUXGZUXHZWJZXU
      PWWOYHNZVYRWWNWWCNZWXJXUKXVGXUPXULWUPWWOWXBUXIVQWYDVYRXTZVYHXVHXUPVLWWCWU
      PLWWNWXDWUTWWHUXJVQWWCWWPWWOVWTWWNWWCWUPWWOWXBWWHUXKWXEUXLXLZWYKWYTLOWWCW
      UPWWQWWHVYHLWUPUXMMRVLWUPLVKWUTUXNXIZXUGVGUXPXLZXUBVFWMWYDWYJYKZTVXIWRZUH
      ZVDNZXUBYKTXUIUNWRUHZXVOURXVQVDNWYDXUEXVPXUFWYJWWCWUPLVXAPXUHWWHWUTWCUXOW
      HWYDKUDWYKWWQSWWCXVOWYTDPXUIWYDXVOKSWYKUMZYKZXVNUHZRXVTXVOURWYDXVMXVSXVNW
      YDWYJXVRWYDKSDWYJXVDXRUXQUXRXVTXVOUXSWHWYDXUQUDUGZWWCNPXWAWYTQXUIRVYHXUQW
      YDVLXUTVQWYTLPWWCWUPXWAXUIWWHXVKXUGWCXUJUXTUYOXVEXVJUYAXVOXVQYLWKUYBWYDXU
      DWYPVXRVBWYDXUDKSXUAEMZUMWYPWYDKUDSWWCXUAXWAEMXWBXUBEXVLWYDXUBXSWYDUDWWCW
      VHEWWGWYDWWIVIXRXWAXUAEUYPUYCWYDKSXWBWYOXUPXWBJOVXCXWBMZUMWYOXUPJOOXWBXUP
      OLOWVHVKXWBVXRTVYDVGWVIVYHXUPVLVIVYFXUPVHVIXUPXUSXWBWVHNXVLWWCWVHXUAEWWIU
      YDWHXQXRXUPJOXWCWYLXUPVYKVCZXUSXWCWYLRXWDOWUPLWYTUKWWCWWQWYKEVXDVXCIWUTVG
      WWHWUSXWDXBVIZXUPVYKXTZXWDWXJWXKVCWXJWWSVXDRZVCXWDOWUPLWWPWWCWXHWWNVWTEVX
      CVXCIWUTVGWWHXWEXWFXWDOWUPLWWCEWWNVXCIWXDVGWUTWWHXWEXWFYAWXEWXNXUPVYRVYKX
      VIWDZYBXWDWXKXWGWXJXWDWXIVXDWWSXWDVYKVYRWXPXWFXWHWXQWKUYEUYFWIXUPXURVYKXV
      FWDXUGXHUYGYCWQWSWQWSUYHUYIWYDJKOLWYLOSTTVXRVYCVYDVGVYEVYFWYDVHVIXUNVYHVY
      IWYDVLVYJVQWYDVYKVYRWYLONZWYDVYKVCZVYRVCWYKVXDWYDVYRXURVYKXVFUYJVYKVYRWUF
      WYDWUGUYKZWLZUYLWYDWYIVDNZWYPYKWUJUHZWYIURXWNVDNWYDPWYHVJWYDSWYOKWYIVYCWY
      DVWTSWYIWRNZVCZWYOJOPUMZVYCXWPJOWYLPWYDVYKXWOWYLPRXWJXWOVCZWYLPVXDUKQPXWR
      WYKPVXDUKXWRVWTWYINZYMZWYKPRXWOXWTXWJVWTSWYIUYMXPXWRXWSWYKPXWRWYKPUYQZVYR
      VWTWYHYFYGZVCZXWSXWRXXAXXBVYRXWRXXAVWTWYFYFYGZXXBXWRXUEVYRXXAXXDYNWYDXUEV
      YKXWOXUFVOXWOVYRXWJVWTSWYIUYNZXPZXUEVYRXXAXXDWYJWWCWYEWUPLVXAVWTPWYEVFZWU
      TWWHWCXUHUYRUYSWKXWRXXDWYFWYHYFYGZXXBXWRPYONZWYFYONZXXHYPWYDXXJVYKXWOWYDX
      UEXXJXUFWWCWYEWUPLVXAXXGWUTWWHUYTWHVOZPWYFVUAXCXWRVWTYONXXJWYHYONZXXDXXHV
      CXXBYNXWRVWTXWRVWTXXFVUBVUCXXKXWRXXJXXIXXLXXKYPWYGWYFPYOVUFVUDVWTWYFWYHVU
      EXLVUGVUHXXFVUIXWRWYHSNZXWSXXCVTWYDXXMVYKXWOWYDWYFSNZWYFYQUNZNZVUJZXXMWYD
      WYFSXXOUONZXXQWYDXUEXXRXUFWWCWYEWUPLVXAXXGWUTWWHVUKWHWYFSXXOVUTWEXXNXXMXX
      PXXNWYHWYFSXXNWYGWYHWYFRWYFVULWYGWYFPVUMWHXXNVUNYRXXPWYHPSXXPWYGYMWYHPRXX
      PWYGPYQYFYGZYQPVUOYGZXXSYMZPVUPNXXTVUQPVURXIYQYONXXIXXTXYAVTVUSYPYQPVVAWT
      VVBXXPWYFYQPYFWYFYQVVCVVDVVEWYGWYFPVVFWHVVGVVHVVKWHZVOVWTWYHVVIWHVVJVVLVW
      BVVMXWRVXDXWOXWJVYRWUFXXEXWKYSVVNWSZVVOWQOVXIXDZXWQVYCJOPXJLYHNZVYFXYDVYC
      RVYHXYEVLLYIXIVHLOTVXRPVYDWCVVPWTVVQVVRYTWYIXWNYLWKWOWYDJOWYSWYMXWJLWYRWY
      IVWCZVBQLKWYIWYLUMZVBQWYSWYMXYFXYGLVBWYISURXYFXYGRKWYISVWTWYHWGZVVSKSWYIW
      YLVVTXIVWAXWJSOWYRLTWYIPVGWCVYHVYIXWJVLVYJVQXUMXWJYJVIXWJKSWYLOWYRXWLWYRV
      FWMXWJSWYLKWYIPXYCYTZXWJXWMWYRYKXVNUHZWYIURXYJVDNXWJPWYHVJZXYIWYIXYJYLWKV
      WDXWJWYIWYLKXYKXWSXWJVYRXWIXYHXWLYSWPVWEWQVWFWYDVXMXXMXVAWYNVWMNVWLVXMWYC
      VYPWDXYBXVDJWYJDKWYHVWGXLYRWXSVWOVWMYDVWHVWIYEVWJVWK $.
  $}

  ${
    $d m n A $.  $d k m n B $.  $d k m n M $.  $d k m n N $.  $d k m n z ph $.
    plyaddlem.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    plyaddlem.2 $e |- ( ph -> G e. ( Poly ` S ) ) $.
    plyaddlem.m $e |- ( ph -> M e. NN0 ) $.
    plyaddlem.n $e |- ( ph -> N e. NN0 ) $.
    plyaddlem.a $e |- ( ph -> A : NN0 --> CC ) $.
    plyaddlem.b $e |- ( ph -> B : NN0 --> CC ) $.
    plyaddlem.a2 $e |- ( ph -> ( A " ( ZZ>= ` ( M + 1 ) ) ) = { 0 } ) $.
    plyaddlem.b2 $e |- ( ph -> ( B " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $.
    plyaddlem.f $e |- ( ph -> F =
      ( z e. CC |-> sum_ k e. ( 0 ... M ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
    plyaddlem.g $e |- ( ph -> G =
      ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( B ` k ) x. ( z ^ k ) ) ) ) $.
    $( Derive the coefficient function for the sum of two polynomials.
       (Contributed by Mario Carneiro, 23-Jul-2014.) $)
    plyaddlem1 $p |- ( ph -> ( F oF + G ) = ( z e. CC |->
        sum_ k e. ( 0 ... if ( M <_ N , N , M ) )
          ( ( ( A oF + B ) ` k ) x. ( z ^ k ) ) ) ) $=
      ( caddc cof co cc cc0 cfz cv cfv cexp cmul csu cmpt cle wbr cif wcel cnex
      cvv a1i wa sumex offval2 fzfid cn0 elfznn0 adantr ffvelrnda expcl adantll
      wf mulcld sylan2 fsumadd wceq wfn ffn syl nn0ex inidm eqidd ofval adantlr
      oveq1d adddird eqtrd sumeq2dv wss cuz cz nn0zd ifcl syl2anc cr max1 eluz2
      nn0red syl3anbrc fzss2 cdif csn c1 cima wn eldifn adantl cun eldifi nn0uz
      cmin peano2nn0 syl6eleq uzsplit syl5eq nn0cnd ax-1cn pncan sylancl oveq2d
      wo uneq1d ad2antrr eleqtrd elun sylib ord mpd wi wfun cdm ssun2 syl5sseqr
      ffun fdm sseqtr4d funfvima2 elsni mul02d fsumss max2 oveq12d mpteq2dva
      3eqtr4d eqtr4d ) AGHUAUBZUCBUDUEIUFUCZFUGZCUHZBUGZUUFUIUCZUJUCZFUKZUEJUFU
      CZUUFDUHZUUIUJUCZFUKZUAUCZULBUDUEIJUMUNZJIUOZUFUCZUUFCDUUDUCUHZUUIUJUCZFU
      KZULABUDUUKUUOUAGHURURURUDURUPAUQUSUUKURUPAUUHUDUPZUTZUUEUUJFVAUSUUOURUPU
      VDUULUUNFVAUSSTVBABUDUVBUUPUVDUUSUUJUUNUAUCZFUKUUSUUJFUKZUUSUUNFUKZUAUCUV
      BUUPUVDUUSUUJUUNFUVDUEUURVCZUUFUUSUPZUVDUUFVDUPZUUJUDUPZUUFUURVEZUVDUVJUT
      ZUUGUUIUVDVDUDUUFCAVDUDCVJZUVCOVFVGZUVCUVJUUIUDUPZAUUHUUFVHVIZVKZVLUVIUVD
      UVJUUNUDUPZUVLUVMUUMUUIUVDVDUDUUFDAVDUDDVJZUVCPVFVGZUVQVKZVLVMUVDUUSUVAUV
      EFUVIUVDUVJUVAUVEVNUVLUVMUVAUUGUUMUAUCZUUIUJUCUVEUVMUUTUWCUUIUJAUVJUUTUWC
      VNUVCAVDVDUUGUUMUAVDCDURURUUFAUVNCVDVOOVDUDCVPVQAUVTDVDVOPVDUDDVPVQVDURUP
      AVRUSZUWDVDVSAUVJUTZUUGVTUWEUUMVTWAWBWCUVMUUGUUMUUIUVOUWAUVQWDWEVLWFUVDUU
      KUVFUUOUVGUAUVDUUEUUSUUJFAUUEUUSWGZUVCAUURIWHUHUPZUWFAIWIUPUURWIUPZIUURUM
      UNZUWGAIMWJAUURAJVDUPZIVDUPZUURVDUPNMUUQJIVDWKWLWJZAIWMUPZJWMUPZUWIAIMWPZ
      AJNWPZIJWNWLIUURWOWQIUEUURWRVQVFUUFUUEUPZUVDUVJUVKUUFIVEUVRVLUVDUUFUUSUUE
      WSUPZUTZUUJUEUUIUJUCZUEUWSUUGUEUUIUJUWSUUGUEWTZUPUUGUEVNUWSUUGCIXAUAUCZWH
      UHZXBZUXAUWSUUFUXCUPZUUGUXDUPZUWSUWQXCZUXEUWRUXGUVDUUFUUSUUEXDXEUWSUWQUXE
      UWSUUFUUEUXCXFZUPUWQUXEXSUWSUUFVDUXHUWRUVJUVDUWRUVIUVJUUFUUSUUEXGUVLVQZXE
      AVDUXHVNUVCUWRAVDUEUXBXAXIUCZUFUCZUXCXFZUXHAVDUEWHUHZUXLXHAUXBUXMUPUXMUXL
      VNAUXBVDUXMAUWKUXBVDUPMIXJVQXHXKUEUXBXLVQXMZAUXKUUEUXCAUXJIUEUFAIUDUPXAUD
      UPZUXJIVNAIMXNXOIXAXPXQXRXTWEYAYBUUFUUEUXCYCYDYEYFAUXEUXFYGZUVCUWRACYHZUX
      CCYIZWGUXPAUVNUXQOVDUDCYLVQAUXCVDUXRAUXLUXCVDUXCUXKYJUXNYKAUVNUXRVDVNOVDU
      DCYMVQYNUXCUUFCYOWLYAYFAUXDUXAVNUVCUWRQYAYBUUGUEYPVQWCUWSUUIUWRUVDUVJUVPU
      XIUVQVLYQWEUVHYRUVDUULUUSUUNFAUULUUSWGZUVCAUURJWHUHUPZUXSAJWIUPUWHJUURUMU
      NZUXTAJNWJUWLAUWMUWNUYAUWOUWPIJYSWLJUURWOWQJUEUURWRVQVFUUFUULUPZUVDUVJUVS
      UUFJVEUWBVLUVDUUFUUSUULWSUPZUTZUUNUWTUEUYDUUMUEUUIUJUYDUUMUXAUPUUMUEVNUYD
      UUMDJXAUAUCZWHUHZXBZUXAUYDUUFUYFUPZUUMUYGUPZUYDUYBXCZUYHUYCUYJUVDUUFUUSUU
      LXDXEUYDUYBUYHUYDUUFUULUYFXFZUPUYBUYHXSUYDUUFVDUYKUYCUVJUVDUYCUVIUVJUUFUU
      SUULXGUVLVQZXEAVDUYKVNUVCUYCAVDUEUYEXAXIUCZUFUCZUYFXFZUYKAVDUXMUYOXHAUYEU
      XMUPUXMUYOVNAUYEVDUXMAUWJUYEVDUPNJXJVQXHXKUEUYEXLVQXMZAUYNUULUYFAUYMJUEUF
      AJUDUPUXOUYMJVNAJNXNXOJXAXPXQXRXTWEYAYBUUFUULUYFYCYDYEYFAUYHUYIYGZUVCUYCA
      DYHZUYFDYIZWGUYQAUVTUYRPVDUDDYLVQAUYFVDUYSAUYOUYFVDUYFUYNYJUYPYKAUVTUYSVD
      VNPVDUDDYMVQYNUYFUUFDYOWLYAYFAUYGUXAVNUVCUYCRYAYBUUMUEYPVQWCUYDUUIUYCUVDU
      VJUVPUYLUVQVLYQWEUVHYRYTUUBUUAUUC $.

    $( Derive the coefficient function for the product of two polynomials.
       (Contributed by Mario Carneiro, 23-Jul-2014.) $)
    plymullem1 $p |- ( ph -> ( F oF x. G ) = ( z e. CC |->
        sum_ n e. ( 0 ... ( M + N ) ) ( sum_ k e. ( 0 ... n )
          ( ( A ` k ) x. ( B ` ( n - k ) ) ) x. ( z ^ n ) ) ) ) $=
      ( vm cmul cof co cc cc0 cfz cv cfv cexp csu cmpt caddc cmin cvv wcel cnex
      a1i wa sumex offval2 weq fveq2 oveq2 oveq12d oveq2d cn0 elfznn0 wf adantr
      wceq ffvelrnda expcl adantll mulcld sylan2 anim12dan mulcl syl fsum0diag2
      cuz wss nn0cnd ad2antrr adantl addsubd cz fznn0sub nn0uz syl6eleq eluzadd
      nn0zd syl2anc eqeltrd addid2d fveq2d eleqtrd fzss2 adantlr cdif csn c1 wn
      eldifn cun wo eldifi peano2nn0 uzsplit syl5eq ax-1cn pncan sylancl uneq1d
      cima eqtrd ad3antrrr elun sylib ord mpd wfun cdm ffun ssun2 syl5sseqr fdm
      sseqtr4d funfvima2 elsni oveq1d simplr syl2an mul02d fzfid fsumss eqtr4d
      wi sumeq2dv mul01d fsum2mul addcomd fsumcl cfn olcd sumz simpll fsummulc1
      3eqtr3d expaddd ad2antlr pncan3d eqtr3d 3eqtr4rd cbvsumv oveq2i mpteq2dva
      mul4d syl6eq ) AHIUCUDUEBUFUGJUHUEZFUIZCUJZBUIZUVBUKUEZUCUEZFULZUGKUHUEZU
      VBDUJZUVEUCUEZFULZUCUEZUMBUFUGJKUNUEZUHUEZUGGUIZUHUEZUVCUVOUVBUOUEZDUJZUC
      UEZFULUVDUVOUKUEZUCUEZGULZUMABUFUVGUVKUCHIUPUPUPUFUPUQAURUSUVGUPUQAUVDUFU
      QZUTZUVAUVFFVAUSUVKUPUQUWDUVHUVJFVAUSTUAVBABUFUWBUVLUWDUWBUVGUVHUVODUJZUV
      TUCUEZGULZUCUEZUVLUWDUVNUGUVMUVBUOUEZUHUEZUVFUWFUCUEZGULZFULZUVNUVPUVFUVR
      UVDUVQUKUEZUCUEZUCUEZFULZGULUWHUWBUWDUBUWKUVFUBUIZDUJZUVDUWRUKUEZUCUEZUCU
      EUWPFGUVMUBGVCZUXAUWFUVFUCUXBUWSUWEUWTUVTUCUWRUVODVDUWRUVOUVDUKVEVFVGUWRU
      VQVLZUXAUWOUVFUCUXCUWSUVRUWTUWNUCUWRUVQDVDUWRUVQUVDUKVEVFVGUWDUVBUVNUQZUV
      OUWJUQZUTUTUVFUFUQZUWFUFUQZUTUWKUFUQUWDUXDUXFUXEUXGUXDUWDUVBVHUQZUXFUVBUV
      MVIZUWDUXHUTUVCUVEUWDVHUFUVBCAVHUFCVJZUWCPVKVMUWCUXHUVEUFUQZAUVDUVBVNZVOZ
      VPZVQUXEUWDUVOVHUQZUXGUVOUWIVIZUWDUXOUTUWEUVTUWDVHUFUVODAVHUFDVJZUWCQVKVM
      UWCUXOUVTUFUQZAUVDUVOVNZVOZVPZVQZVRUVFUWFVSVTWAUWDUVAUVHUWKGULZFULUVAUWLF
      ULUWHUWMUWDUVAUYCUWLFUWDUVBUVAUQZUTZUVHUWJUWKGUYEUWIKWBUJZUQUVHUWJWCUYEUW
      IUGKUNUEZWBUJZUYFUYEUWIJUVBUOUEZKUNUEZUYHUYEJKUVBAJUFUQZUWCUYDAJNWDZWEAKU
      FUQZUWCUYDAKOWDZWEZUYEUVBUYDUXHUWDUVBJVIZWFWDWGUYEUYIUGWBUJZUQKWHUQZUYJUY
      HUQUYEUYIVHUYQUYDUYIVHUQUWDUVBUGJWIWFWJWKAUYRUWCUYDAKOWMWEKUGUYIWLWNWOUYE
      UYGKWBUYEKUYOWPWQWRKUGUWIWSVTUYEUVOUVHUQZUTUVFUWFUYEUXFUYSUYDUWDUXHUXFUYP
      UXNVQZVKUWDUYSUXGUYDUYSUWDUXOUXGUVOKVIUYAVQZWTVPUYEUVOUWJUVHXAUQZUTZUWKUV
      FUGUCUEUGVUCUWFUGUVFUCVUCUWFUGUVTUCUEUGVUCUWEUGUVTUCVUCUWEUGXBZUQUWEUGVLV
      UCUWEDKXCUNUEZWBUJZXPZVUDVUCUVOVUFUQZUWEVUGUQZVUCUYSXDZVUHVUBVUJUYEUVOUWJ
      UVHXEWFVUCUYSVUHVUCUVOUVHVUFXFZUQUYSVUHXGVUCUVOVHVUKVUBUXOUYEVUBUXEUXOUVO
      UWJUVHXHUXPVTZWFAVHVUKVLUWCUYDVUBAVHUGVUEXCUOUEZUHUEZVUFXFZVUKAVHUYQVUOWJ
      AVUEUYQUQUYQVUOVLAVUEVHUYQAKVHUQVUEVHUQOKXIVTWJWKUGVUEXJVTXKZAVUNUVHVUFAV
      UMKUGUHAUYMXCUFUQZVUMKVLUYNXLKXCXMXNVGXOXQXRWRUVOUVHVUFXSXTYAYBAVUHVUIYSZ
      UWCUYDVUBADYCZVUFDYDZWCVURAUXQVUSQVHUFDYEVTAVUFVHVUTAVUOVUFVHVUFVUNYFVUPY
      GAUXQVUTVHVLQVHUFDYHVTYIVUFUVODYJWNXRYBAVUGVUDVLUWCUYDVUBSXRWRUWEUGYKVTYL
      VUCUVTUYEUWCUXOUXRVUBAUWCUYDYMVULUXSYNYOXQVGVUCUVFUYEUXFVUBUYTVKUUAXQUYEU
      GUWIYPZYQYTUWDUVAUVHUVFUWFFGUWDUGJYPUWDUGKYPUYTVUAUUBUWDUVAUVNUWLFAUVAUVN
      WCZUWCAUVMJWBUJZUQVVBAUVMKJUNUEZVVCAJKUYLUYNUUCAVVDUGJUNUEZWBUJZVVCAKUYQU
      QJWHUQVVDVVFUQAKVHUYQOWJWKAJNWMJUGKWLWNAVVEJWBAJUYLWPWQWRWOJUGUVMWSVTVKUY
      EUWJUWKGVVAUYEUXEUTUVFUWFUYEUXFUXEUYTVKUWDUXEUXGUYDUYBWTVPUUDUWDUVBUVNUVA
      XAUQZUTZUWLUWJUGGULZUGVVHUWJUWKUGGVVHUXEUTZUWKUGUWFUCUEUGVVJUVFUGUWFUCVVH
      UVFUGVLUXEVVHUVFUGUVEUCUEUGVVHUVCUGUVEUCVVHUVCVUDUQUVCUGVLVVHUVCCJXCUNUEZ
      WBUJZXPZVUDVVHUVBVVLUQZUVCVVMUQZVVHUYDXDZVVNVVGVVPUWDUVBUVNUVAXEWFVVHUYDV
      VNVVHUVBUVAVVLXFZUQUYDVVNXGVVHUVBVHVVQVVGUXHUWDVVGUXDUXHUVBUVNUVAXHUXIVTZ
      WFAVHVVQVLUWCVVGAVHUGVVKXCUOUEZUHUEZVVLXFZVVQAVHUYQVWAWJAVVKUYQUQUYQVWAVL
      AVVKVHUYQAJVHUQVVKVHUQNJXIVTWJWKUGVVKXJVTXKZAVVTUVAVVLAVVSJUGUHAUYKVUQVVS
      JVLUYLXLJXCXMXNVGXOXQWEWRUVBUVAVVLXSXTYAYBAVVNVVOYSZUWCVVGACYCZVVLCYDZWCV
      WCAUXJVWDPVHUFCYEVTAVVLVHVWEAVWAVVLVHVVLVVTYFVWBYGAUXJVWEVHVLPVHUFCYHVTYI
      VVLUVBCYJWNWEYBAVVMVUDVLUWCVVGRWEWRUVCUGYKVTYLVVHUVEVVGUWDUXHUXKVVRUXMVQY
      OXQVKYLVVJUWFUWDUXEUXGVVGUYBWTYOXQYTVVHUWJUYQWCZUWJUUEUQZXGVVIUGVLVVHVWGV
      WFVVHUGUWIYPUUFUWJGUGUUGVTXQUWDUGUVMYPYQUUJUWDUVNUWAUWQGUWDUVOUVNUQZUTZUW
      AUVPUVSUVTUCUEZFULUWQVWIUVPUVSUVTFVWIUGUVOYPVWHUWDUXOUXRUVOUVMVIZUXTVQVWI
      UVBUVPUQZUTZUVCUVRVWIAUXHUVCUFUQVWLAUWCVWHUUHZUVBUVOVIZAVHUFUVBCPVMYNZVWI
      AUVQVHUQZUVRUFUQVWLVWNUVBUGUVOWIZAVHUFUVQDQVMYNZVPUUIVWIUVPUWPVWJFVWMUWPU
      VSUVEUWNUCUEZUCUEVWJVWMUVCUVEUVRUWNVWPVWIUWCUXHUXKVWLAUWCVWHYMZVWOUXLYNVW
      SVWIUWCVWQUWNUFUQVWLVXAVWRUVDUVQVNYNUUSVWMVWTUVTUVSUCVWMUVDUVBUVQUNUEZUKU
      EVWTUVTVWMUVDUVBUVQVWIUWCVWLVXAVKVWLVWQVWIVWRWFVWLUXHVWIVWOWFZUUKVWMVXBUV
      OUVDUKVWMUVBUVOVWMUVBVXCWDVWMUVOVWHUXOUWDVWLVWKUULWDUUMVGUUNVGXQYTYRYTUUO
      UWGUVKUVGUCUVHUWFUVJGFGFVCUWEUVIUVTUVEUCUVOUVBDVDUVOUVBUVDUKVEVFUUPUUQUUT
      UURYR $.
  $}

  ${
    $d k m n x y z B $.  $d a b j m n w x y z F $.  $d a b j k m n w x y z S $.
    $d m n x y z A $.  $d a b j m n w x y z G $.  $d a b j k m n w x y z ph $.
    $d k m n z M $.  $d k m n z N $.
    plyadd.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    plyadd.2 $e |- ( ph -> G e. ( Poly ` S ) ) $.
    plyadd.3 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x + y ) e. S ) $.
    ${
      plyadd.m $e |- ( ph -> M e. NN0 ) $.
      plyadd.n $e |- ( ph -> N e. NN0 ) $.
      plyadd.a $e |- ( ph -> A e. ( ( S u. { 0 } ) ^m NN0 ) ) $.
      plyadd.b $e |- ( ph -> B e. ( ( S u. { 0 } ) ^m NN0 ) ) $.
      plyadd.a2 $e |- ( ph -> ( A " ( ZZ>= ` ( M + 1 ) ) ) = { 0 } ) $.
      plyadd.b2 $e |- ( ph -> ( B " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $.
      plyadd.f $e |- ( ph -> F =
        ( z e. CC |-> sum_ k e. ( 0 ... M ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
      plyadd.g $e |- ( ph -> G =
        ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( B ` k ) x. ( z ^ k ) ) ) ) $.
      $( Lemma for ~ plyadd .  (Contributed by Mario Carneiro, 21-Jul-2014.) $)
      plyaddlem $p |- ( ph -> ( F oF + G ) e. ( Poly ` S ) ) $=
        ( caddc cof co cc0 csn cun cply cfv cc cle wbr cif cfz cv cexp cmul csu
        cmpt cn0 wf wss cmap wcel cvv plybss syl 0cn a1i snssd unssd cnex ssexg
        wb sylancl nn0ex elmapg mpbid fss syl2anc plyaddlem1 ifcl eqid un0addcl
        inidm off elfznn0 ffvelrn syl2an elplyd eqeltrd plyun0 syl6eleq ) AIJUD
        UEZUFZGUGUHZUIZUJUKZGUJUKZAWQDULUGKLUMUNZLKUOZUPUFZHUQZEFWPUFZUKZDUQXEU
        RUFUSUFHUTVAWTADEFGHIJKLMNPQAVBWSEVCZWSULVDZVBULEVCAEWSVBVEUFZVFZXHRAWS
        VGVFZVBVGVFZXKXHVPAXIULVGVFXLAGWRULAIXAVFGULVDMGIVHVIZAUGULUGULVFAVJVKV
        LVMZVNWSULVGVOVQZVRWSVBEVGVGVSVQVTZXOVBWSULEWAWBAVBWSFVCZXIVBULFVCAFXJV
        FZXRSAXLXMXSXRVPXPVRWSVBFVGVGVSVQVTZXOVBWSULFWAWBTUAUBUCWCADXGWSHXCXOAL
        VBVFKVBVFXCVBVFQPXBLKVBWDWBAVBWSXFVCXEVBVFXGWSVFXEXDVFABCVBVBVBUDWSWSWS
        EFVGVGAGWSBUQCUQXNWSWEOWFXQXTXMAVRVKZYAVBWGWHXEXCWIVBWSXEXFWJWKWLWMGWNW
        O $.

      plymul.x $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x x. y ) e. S ) $.
      $( Lemma for ~ plymul .  (Contributed by Mario Carneiro, 21-Jul-2014.) $)
      plymullem $p |- ( ph -> ( F oF x. G ) e. ( Poly ` S ) ) $=
        ( vn cmul cof co cc0 csn cun cply cfv cc caddc cfz cv cmin csu cexp cn0
        cmpt wf wss cmap wcel cvv plybss syl 0cn snssd unssd cnex ssexg sylancl
        a1i nn0ex elmapg mpbid syl2anc plymullem1 nn0addcld eqid un0addcl fzfid
        wb fss wa elfznn0 ffvelrn syl2an fznn0sub un0mulcl caovclg syldan ssun2
        jca c0ex snss mpbir fsumcllem adantr elplyd eqeltrd plyun0 syl6eleq ) A
        IJUFUGUHZGUIUJZUKZULUMZGULUMZAXGDUNUIKLUOUHZUPUHZUIUEUQZUPUHZHUQZEUMZXN
        XPURUHZFUMZUFUHZHUSZDUQXNUTUHUFUHUEUSVBXJADEFGHUEIJKLMNPQAVAXIEVCZXIUNV
        DZVAUNEVCAEXIVAVEUHZVFZYBRAXIVGVFZVAVGVFZYEYBWFAYCUNVGVFYFAGXHUNAIXKVFG
        UNVDMGIVHVIZAUIUNUIUNVFAVJVPVKVLZVMXIUNVGVNVOZVQXIVAEVGVGVRVOVSZYIVAXIU
        NEWGVTAVAXIFVCZYCVAUNFVCAFYDVFZYLSAYFYGYMYLWFYJVQXIVAFVGVGVRVOVSZYIVAXI
        UNFWGVTTUAUBUCWAADYAXIUEXLYIAKLPQWBAYAXIVFXNXMVFABCXOXTXIHYIAGXIBUQZCUQ
        ZYHXIWCZOWDAUIXNWEAXPXOVFZXQXIVFZXSXIVFZWHXTXIVFAYRWHYSYTAYBXPVAVFYSYRY
        KXPXNWIVAXIXPEWJWKAYLXRVAVFYTYRYNXPUIXNWLVAXIXRFWJWKWQABCXQXSXIXIXIUFAG
        XIYOYPYHYQUDWMWNWOUIXIVFZAUUAXHXIVDXHGWPUIXIWRWSWTVPXAXBXCXDGXEXF $.
    $}

    $( The sum of two polynomials is a polynomial.  (Contributed by Mario
       Carneiro, 21-Jul-2014.) $)
    plyadd $p |- ( ph -> ( F oF + G ) e. ( Poly ` S ) ) $=
      ( vz vk cv co cfv cc cmul wa cn0 wrex wcel va vm vb vn vw vj c1 caddc cuz
      cima cc0 csn wceq cfz cexp csu cmpt cun cof wss elply2 simprbi syl reeanv
      cmap cply w3a simp1l sylan simp1rl simp1rr simp2l simp3ll simp3rl simp3lr
      simp2r oveq1 oveq2d sumeq2sdv fveq2 oveq2 oveq12d cbvsumv cbvmptv simp3rr
      syl6eq plyaddlem 3expia rexlimdvva syl5bir mp2and ) AUALZUBLZUGUHMUINUJUK
      ULZUMZEJOUKWMUNMZKLZWLNZJLZWQUOMZPMZKUPZUQZUMZQZUADWNURRVEMZSZUBRSZUCLZUD
      LZUGUHMUINUJWNUMZFJOUKXJUNMZWQXINZWTPMZKUPZUQZUMZQZUCXFSZUDRSZEFUHUSMDVFN
      ZTZAEYATZXHGYCDOUTZXHJDKUBEUAVAVBVCAFYATZXTHYEYDXTJDKUDFUCVAVBVCXHXTQXGXS
      QZUDRSUBRSAYBXGXSUBUDRRVDAYFYBUBUDRRYFXEXRQZUCXFSUAXFSAWMRTZXJRTZQZQZYBXE
      XRUAUCXFXFVDYKYGYBUAUCXFXFYKWLXFTZXIXFTZQZYGYBYKYNYGVGZBCUEWLXIDUFEFWMXJY
      OAYCAYJYNYGVHZGVCYOAYEYPHVCYOABLZDTCLZDTQYQYRUHMDTYPIVIYHYIAYNYGVJYHYIAYN
      YGVKYKYLYMYGVLYKYLYMYGVPWOXDXRYKYNVMXKXQXEYKYNVNYOEXCUEOWPUFLZWLNZUELZYSU
      OMZPMZUFUPZUQWOXDXRYKYNVOJUEOXBUUDWSUUAUMZXBWPWRUUAWQUOMZPMZKUPUUDUUEWPXA
      UUGKUUEWTUUFWRPWSUUAWQUOVQZVRVSWPUUGUUCKUFWQYSUMZWRYTUUFUUBPWQYSWLVTWQYSU
      UAUOWAZWBWCWFWDWFYOFXPUEOXLYSXINZUUBPMZUFUPZUQXKXQXEYKYNWEJUEOXOUUMUUEXOX
      LXMUUFPMZKUPUUMUUEXLXNUUNKUUEWTUUFXMPUUHVRVSXLUUNUULKUFUUIXMUUKUUFUUBPWQY
      SXIVTUUJWBWCWFWDWFWGWHWIWJWIWJWK $.

    plymul.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x x. y ) e. S ) $.
    $( The product of two polynomials is a polynomial.  (Contributed by Mario
       Carneiro, 21-Jul-2014.) $)
    plymul $p |- ( ph -> ( F oF x. G ) e. ( Poly ` S ) ) $=
      ( vz vk cv co cfv cmul wa cn0 wrex wcel va vm vb vn vw vj c1 cuz cima cc0
      caddc csn wceq cfz cexp csu cmpt cun cmap cof cply wss elply2 simprbi syl
      cc reeanv w3a simp1l sylan simp1rl simp1rr simp2l simp3ll simp3rl simp3lr
      simp2r oveq1 oveq2d sumeq2sdv fveq2 oveq2 oveq12d cbvsumv cbvmptv simp3rr
      syl6eq plymullem 3expia rexlimdvva syl5bir mp2and ) AUAMZUBMZUGUKNUHOUIUJ
      ULZUMZEKVFUJWNUNNZLMZWMOZKMZWRUONZPNZLUPZUQZUMZQZUADWOURRUSNZSZUBRSZUCMZU
      DMZUGUKNUHOUIWOUMZFKVFUJXKUNNZWRXJOZXAPNZLUPZUQZUMZQZUCXGSZUDRSZEFPUTNDVA
      OZTZAEYBTZXIGYDDVFVBZXIKDLUBEUAVCVDVEAFYBTZYAHYFYEYAKDLUDFUCVCVDVEXIYAQXH
      XTQZUDRSUBRSAYCXHXTUBUDRRVGAYGYCUBUDRRYGXFXSQZUCXGSUAXGSAWNRTZXKRTZQZQZYC
      XFXSUAUCXGXGVGYLYHYCUAUCXGXGYLWMXGTZXJXGTZQZYHYCYLYOYHVHZBCUEWMXJDUFEFWNX
      KYPAYDAYKYOYHVIZGVEYPAYFYQHVEYPABMZDTCMZDTQZYRYSUKNDTYQIVJYIYJAYOYHVKYIYJ
      AYOYHVLYLYMYNYHVMYLYMYNYHVQWPXEXSYLYOVNXLXRXFYLYOVOYPEXDUEVFWQUFMZWMOZUEM
      ZUUAUONZPNZUFUPZUQWPXEXSYLYOVPKUEVFXCUUFWTUUCUMZXCWQWSUUCWRUONZPNZLUPUUFU
      UGWQXBUUILUUGXAUUHWSPWTUUCWRUOVRZVSVTWQUUIUUELUFWRUUAUMZWSUUBUUHUUDPWRUUA
      WMWAWRUUAUUCUOWBZWCWDWGWEWGYPFXQUEVFXMUUAXJOZUUDPNZUFUPZUQXLXRXFYLYOWFKUE
      VFXPUUOUUGXPXMXNUUHPNZLUPUUOUUGXMXOUUPLUUGXAUUHXNPUUJVSVTXMUUPUUNLUFUUKXN
      UUMUUHUUDPWRUUAXJWAUULWCWDWGWEWGYPAYTYRYSPNDTYQJVJWHWIWJWKWJWKWL $.

    plysub.5 $e |- ( ph -> -u 1 e. S ) $.
    $( The difference of two polynomials is a polynomial.  (Contributed by
       Mario Carneiro, 21-Jul-2014.) $)
    plysub $p |- ( ph -> ( F oF - G ) e. ( Poly ` S ) ) $=
      ( cc c1 cof co cvv wcel wf plyf syl cneg csn cxp cmul caddc cmin cply cfv
      wceq cnex a1i ofnegsub syl3anc wss plybss plyconst plymul plyadd eqeltrrd
      syl2anc ) AELMUAZUBUCZFUDNOZUENOZEFUFNOZDUGUHZALPQZLLERZLLFRZVDVEUIVGAUJU
      KAEVFQZVHGDESTAFVFQVIHDFSTLEFPULUMABCDEVCGABCDVBFADLUNZVADQVBVFQAVJVKGDEU
      OTKVADUPUTHIJUQIURUS $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y S $.
    $( The sum of two polynomials is a polynomial.  (Contributed by Mario
       Carneiro, 24-Jul-2014.) $)
    plyaddcl $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
      ( F oF + G ) e. ( Poly ` CC ) ) $=
      ( vx vy cply cfv wa cc plyssc simpl sseldi simpr cv caddc co addcl adantl
      wcel plyadd ) BAFGZSZCUASZHZDEIBCUDUAIFGZBAJZUBUCKLUDUAUECUFUBUCMLDNZISEN
      ZISHUGUHOPISUDUGUHQRT $.

    $( The product of two polynomials is a polynomial.  (Contributed by Mario
       Carneiro, 24-Jul-2014.) $)
    plymulcl $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
      ( F oF x. G ) e. ( Poly ` CC ) ) $=
      ( vx vy cply cfv wa cc plyssc simpl sseldi simpr cv caddc co addcl adantl
      wcel cmul mulcl plymul ) BAFGZSZCUCSZHZDEIBCUFUCIFGZBAJZUDUEKLUFUCUGCUHUD
      UEMLDNZISENZISHZUIUJOPISUFUIUJQRUKUIUJTPISUFUIUJUARUB $.

    $( The difference of two polynomials is a polynomial.  (Contributed by
       Mario Carneiro, 24-Jul-2014.) $)
    plysubcl $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
      ( F oF - G ) e. ( Poly ` CC ) ) $=
      ( vx vy cply cfv wa cc plyssc simpl sseldi simpr cv caddc co addcl adantl
      wcel cmul mulcl c1 cneg neg1cn a1i plysub ) BAFGZSZCUGSZHZDEIBCUJUGIFGZBA
      JZUHUIKLUJUGUKCULUHUIMLDNZISENZISHZUMUNOPISUJUMUNQRUOUMUNTPISUJUMUNUARUBU
      CISUJUDUEUF $.
  $}

  ${
    $d k y z B $.  $d a b f j m n w F $.  $d k x y z ph $.  $d a b j m n w S $.
    $d a b f j k m n w z $.  $d k x y z A $.  $d k z M $.  $d k z N $.
    $( Value of the coefficient function.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    coeval $p |- ( F e. ( Poly ` S ) -> ( coeff ` F ) =
      ( iota_ a e. ( CC ^m NN0 )
        E. n e. NN0 ( ( a " ( ZZ>= ` ( n + 1 ) ) ) = { 0 } /\ F =
      ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) ) ) ) $=
      ( vf cply cfv wcel cc ccoe cv co cc0 wceq wa cn0 wrex crio caddc cuz cima
      c1 csn cfz cexp cmul csu cmpt plyssc sseli eqeq1 anbi2d rexbidv riotabidv
      cmap df-coe riotaex fvmpt syl ) EBHIZJEKHIZJELIFMZDMZUDUANUBIUCOUEPZEAKOV
      EUFNCMZVDIAMVGUGNUHNCUIUJZPZQZDRSZFKRUQNZTZPVBVCEBUKULGEVFGMZVHPZQZDRSZFV
      LTVMVCLVNEPZVQVKFVLVRVPVJDRVRVOVIVFVNEVHUMUNUOUPAGCDFURVKFVLUSUTVA $.

    ${
      coeeu.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
      coeeu.2 $e |- ( ph -> A e. ( CC ^m NN0 ) ) $.
      coeeu.3 $e |- ( ph -> B e. ( CC ^m NN0 ) ) $.
      coeeu.4 $e |- ( ph -> M e. NN0 ) $.
      coeeu.5 $e |- ( ph -> N e. NN0 ) $.
      coeeu.6 $e |- ( ph -> ( A " ( ZZ>= ` ( M + 1 ) ) ) = { 0 } ) $.
      coeeu.7 $e |- ( ph -> ( B " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $.
      coeeu.8 $e |- ( ph -> F =
        ( z e. CC |-> sum_ k e. ( 0 ... M ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
      coeeu.9 $e |- ( ph -> F =
        ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( B ` k ) x. ( z ^ k ) ) ) ) $.
      $( Lemma for ~ coeeu .  (Contributed by Mario Carneiro, 22-Jul-2014.) $)
      coeeulem $p |- ( ph -> A = B ) $=
        ( cc0 cc vx vy cmin cof co cn0 csn cxp wceq wss ssid a1i nn0addcld cmap
        caddc cun wf wcel cvv cv wa subcl adantl nn0ex elmap sylib inidm sylibr
        cnex off 0cn snssi ax-mp ssequn2 mpbi c1 cuz cfv cima wne cle wbr wi wn
        wral clt cr wb nn0red syl2an wfn ffn syl eqidd adantrr adantr nn0cnd cz
        nn0uz nn0zd eluzadd syl2anc addid2d fveq2d eleqtrd eluzle lelttrd mpbid
        syl6eleq ltnled plyco0 r19.21bi necon1bd mpd eqtrd c0p cmpt cfz adantlr
        cmul csu oveq1d ffvelrnda sylan2 mulcld simpr sumex eqid fvmpt2 sylancl
        fzss2 sselda syldan cdif eldifn eldifi elfz5 sylibrd mul02d fsumss expr
        oveq1i syl6eleqr nn0re ltnle ofval addcomd eqeltrd simprr subidi syl6eq
        oveq12d sylbird necon1ad ralrimiva mpbird df-0p fconstmpt eqtri elfznn0
        cexp expcl adantll subdird sumeq2dv fzfid fsumsub fsumcl eqtr3d 3eqtr3d
        fveq1d subeq0bd 3eqtrrd mpteq2dva syl5eq plyeq0 ofsubeq0 syl3anc ) ACDU
        CUDUEZUFSUGZUHUIZCDUIZABUVSTFHIUOUEZTTUJATUKULAHIMNUMZAUVSTUFUNUEZTUVTU
        PZUFUNUEAUFTUVSUQZUVSUWEURAUAUBUFUFUFUCTTTCDUSUSUAUTZTURUBUTZTURVAUWHUW
        IUCUETURAUWHUWIVBVCACUWEURUFTCUQZKTUFCVIVDVEVFZADUWEURUFTDUQZLTUFDVIVDV
        EVFZUFUSURZAVDULZUWOUFVGZVJZTUFUVSVIVDVEVHUWFTUFUNUVTTUJZUWFTUISTURUWRV
        KSTVLVMUVTTVNVOUUBUUCAUVSUWCVPUOUEVQVRVSUVTUIZFUTZUVSVRZSVTUWTUWCWAWBZW
        CZFUFWEZAUXCFUFAUWTUFURZVAZUXBUXASUXFUXBWDZUWCUWTWFWBZUXASUIZAUWCWGURZU
        WTWGURZUXHUXGWHUXEAUWCUWDWIZUWTUUDZUWCUWTUUEWJAUXEUXHUXIAUXEUXHVAZVAZUX
        AUWTCVRZUWTDVRZUCUEZSAUXEUXAUXRUIZUXHAUFUFUXPUXQUCUFCDUSUSUWTAUWJCUFWKU
        WKUFTCWLWMAUWLDUFWKUWMUFTDWLWMUWOUWOUWPUXFUXPWNUXFUXQWNUUFZWOUXOUXRSSUC
        UESUXOUXPSUXQSUCUXOUWTHWAWBZWDZUXPSUIZUXOHUWTWFWBUYBUXOHUWCUWTAHWGURUXN
        AHMWIWPZAUXJUXNUXLWPZAUXEUXKUXHUXEUXKAUXMVCWOZAHUWCWAWBZUXNAUWCHVQVRZUR
        ZUYGAUWCSHUOUEZVQVRZUYHAUWCIHUOUEZUYKAHIAHMWQZAINWQZUUGAISVQVRZURHWRURZ
        UYLUYKURAIUFUYONWSXIAHMWTZHSIXAXBUUHAUYJHVQAHUYMXCXDXEZHUWCXFWMWPAUXEUX
        HUUIZXGUXOHUWTUYDUYFXJXHUXOUYAUXPSAUXEUXPSVTZUYAWCZUXHAVUAFUFACHVPUOUEV
        QVRVSUVTUIZVUAFUFWEZOAHUFURUWJVUBVUCWHMUWKCFHXKXBXHXLZWOXMXNUXOUWTIWAWB
        ZWDZUXQSUIZUXOIUWTWFWBVUFUXOIUWCUWTAIWGURUXNAINWIWPZUYEUYFAIUWCWAWBZUXN
        AUWCIVQVRZURZVUIAUWCSIUOUEZVQVRZVUJAHUYOURIWRURZUWCVUMURAHUFUYOMWSXIAIN
        WTZISHXAXBAVULIVQAIUYNXCXDXEZIUWCXFWMWPUYSXGUXOIUWTVUHUYFXJXHUXOVUEUXQS
        AUXEUXQSVTZVUEWCZUXHAVURFUFADIVPUOUEVQVRVSUVTUIZVURFUFWEZPAIUFURUWLVUSV
        UTWHNUWMDFIXKXBXHXLZWOXMXNUULSVKUUJUUKXOUUAUUMUUNUUOAUWCUFURUWGUWSUXDWH
        UWDUWQUVSFUWCXKXBUUPAXPBTSXQZBTSUWCXRUEZUXABUTZUWTUVAUEZXTUEZFYAZXQXPTU
        VTUHVVBUUQBTSUURUUSABTSVVGAVVDTURZVAZVVGVVCUXPVVEXTUEZUXQVVEXTUEZUCUEZF
        YAVVCVVJFYAZVVCVVKFYAZUCUESVVIVVCVVFVVLFUWTVVCURZVVIUXEVVFVVLUIUWTUWCUU
        TZVVIUXEVAZVVFUXRVVEXTUEVVLVVQUXAUXRVVEXTAUXEUXSVVHUXTXSYBVVQUXPUXQVVEV
        VIUFTUWTCAUWJVVHUWKWPYCZVVIUFTUWTDAUWLVVHUWMWPYCZVVHUXEVVETURZAVVDUWTUV
        BZUVCZUVDXOYDUVEVVIVVCVVJVVKFVVISUWCUVFZVVOVVIUXEVVJTURZVVPVVQUXPVVEVVR
        VWBYEYDZVVOVVIUXEVVKTURZVVPVVQUXQVVEVVSVWBYEYDZUVGVVIVVMVVNVVIVVCVVJFVW
        CVWEUVHVVIVVDBTSHXRUEZVVJFYAZXQZVRZVVDBTSIXRUEZVVKFYAZXQZVRZVVMVVNAVWKV
        WOUIVVHAVVDVWJVWNAGVWJVWNQRUVIUVKWPVVIVWKVWIVVMVVIVVHVWIUSURVWKVWIUIAVV
        HYFZVWHVVJFYGBTVWIUSVWJVWJYHYIYJVVIVWHVVCVVJFAVWHVVCUJZVVHAUYIVWQUYRHSU
        WCYKWMWPZVVIUWTVWHURZVVOVWDVVIVWHVVCUWTVWRYLVWEYMVVIUWTVVCVWHYNURZVAZVV
        JSVVEXTUEZSVXAUXPSVVEXTVXAVWSWDZUYCVWTVXCVVIUWTVVCVWHYOVCVWTVVIUXEVXCUY
        CWCVWTVVOUXEUWTVVCVWHYPVVPWMZVVQVWSUXPSAUXEUYTVWSWCVVHUXFUYTUYAVWSVUDUX
        FUWTUYOURZUYPVWSUYAWHUXFUWTUFUYOAUXEYFWSXIZAUYPUXEUYQWPUWTSHYQXBYRXSXMY
        DXNYBVXAVVEVVIVVHUXEVVTVWTVWPVXDVWAWJYSXOVWCYTXOVVIVWOVWMVVNVVIVVHVWMUS
        URVWOVWMUIVWPVWLVVKFYGBTVWMUSVWNVWNYHYIYJVVIVWLVVCVVKFAVWLVVCUJZVVHAVUK
        VXGVUPISUWCYKWMWPZVVIUWTVWLURZVVOVWFVVIVWLVVCUWTVXHYLVWGYMVVIUWTVVCVWLY
        NURZVAZVVKVXBSVXKUXQSVVEXTVXKVXIWDZVUGVXJVXLVVIUWTVVCVWLYOVCVXJVVIUXEVX
        LVUGWCVXJVVOUXEUWTVVCVWLYPVVPWMZVVQVXIUXQSAUXEVUQVXIWCVVHUXFVUQVUEVXIVV
        AUXFVXEVUNVXIVUEWHVXFAVUNUXEVUOWPUWTSIYQXBYRXSXMYDXNYBVXKVVEVVIVVHUXEVV
        TVXJVWPVXMVWAWJYSXOVWCYTXOUVJUVLUVMUVNUVOUVPAUWNUWJUWLUWAUWBWHUWOUWKUWM
        UFCDUSUVQUVRXH $.
    $}

    $( Uniqueness of the coefficient function.  (Contributed by Mario Carneiro,
       22-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    coeeu $p |- ( F e. ( Poly ` S ) -> E! a e. ( CC ^m NN0 )
                  E. n e. NN0 ( ( a " ( ZZ>= ` ( n + 1 ) ) ) = { 0 } /\ F =
        ( z e. CC |-> sum_ k e. ( 0 ... n ) ( ( a ` k ) x. ( z ^ k ) ) ) ) ) $=
      ( vm vw vj cfv wcel cv co wceq cc cmul csu wa cn0 wrex vb cply caddc cima
      c1 cuz cc0 csn cfz cexp cmpt cmap wi wral cun plyssc sseli elply2 simprbi
      wreu wss rexcom sylib syl 0cn snssi ssequn2 mpbi oveq1i rexeqi reeanv w3a
      ax-mp simp1l simp1rl simp1rr simp2l simp2r simp3ll simp3rl simp3lr oveq2d
      oveq1 sumeq2sdv fveq2 oveq2 oveq12d cbvsumv syl6eq cbvmptv simp3rr 3expia
      coeeulem rexlimdvva ralrimivva imaeq1 eqeq1d fveq1 oveq1d mpteq2dv eqeq2d
      syl5bir anbi12d rexbidv fveq2d imaeq2d sumeq1d cbvrexv syl6bb sylanbrc
      reu4 ) EBUBJZKZFLZDLZUEUCMZUFJZUDZUGUHZNZEAOUGXOUIMZCLZXNJZALZYBUJMZPMZCQ
      ZUKZNZRZDSTZFOSULMZTZYKUALZGLZUEUCMZUFJZUDZXSNZEAOUGYOUIMZYBYNJZYEPMZCQZU
      KZNZRZGSTZRZXNYNNZUMZUAYLUNFYLUNYKFYLUTXMYKFOXSUOZSULMZTZYMXMEOUBJZKZUUMX
      LUUNEBUPUQUUOYJFUULTDSTZUUMUUOOOVAUUPAOCDEFURUSYJDFSUULVBVCVDYKFUULYLUUKO
      SULXSOVAZUUKONUGOKUUQVEUGOVFVMXSOVGVHVIVJVCXMUUJFUAYLYLUUHYJUUFRZGSTDSTXM
      XNYLKZYNYLKZRZRZUUIYJUUFDGSSVKUVBUURUUIDGSSUVBXOSKZYOSKZRZUURUUIUVBUVEUUR
      VLZHXNYNBIEXOYOXMUVAUVEUURVNUUSUUTXMUVEUURVOUUSUUTXMUVEUURVPUVBUVCUVDUURV
      QUVBUVCUVDUURVRXTYIUUFUVBUVEVSYSUUEYJUVBUVEVTUVFEYHHOYAILZXNJZHLZUVGUJMZP
      MZIQZUKXTYIUUFUVBUVEWAAHOYGUVLYDUVINZYGYAYCUVIYBUJMZPMZCQUVLUVMYAYFUVOCUV
      MYEUVNYCPYDUVIYBUJWCZWBWDYAUVOUVKCIYBUVGNZYCUVHUVNUVJPYBUVGXNWEYBUVGUVIUJ
      WFZWGWHWIWJWIUVFEUUDHOYTUVGYNJZUVJPMZIQZUKYSUUEYJUVBUVEWKAHOUUCUWAUVMUUCY
      TUUAUVNPMZCQUWAUVMYTUUBUWBCUVMYEUVNUUAPUVPWBWDYTUWBUVTCIUVQUUAUVSUVNUVJPY
      BUVGYNWEUVRWGWHWIWJWIWMWLWNXBWOYKUUGFUAYLUUIYKYNXQUDZXSNZEAOYAUUBCQZUKZNZ
      RZDSTUUGUUIYJUWHDSUUIXTUWDYIUWGUUIXRUWCXSXNYNXQWPWQUUIYHUWFEUUIAOYGUWEUUI
      YAYFUUBCUUIYCUUAYEPYBXNYNWRWSWDWTXAXCXDUWHUUFDGSXOYONZUWDYSUWGUUEUWIUWCYR
      XSUWIXQYQYNUWIXPYPUFXOYOUEUCWCXEXFWQUWIUWFUUDEUWIAOUWEUUCUWIYAYTUUBCXOYOU
      GUIWFXGWTXAXCXHXIXKXJ $.

    $d k z F $.
    $( Lemma for properties of the coefficient function.  (Contributed by Mario
       Carneiro, 22-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    coelem $p |- ( F e. ( Poly ` S ) -> ( ( coeff ` F ) e. ( CC ^m NN0 ) /\
      E. n e. NN0 ( ( ( coeff ` F ) " ( ZZ>= ` ( n + 1 ) ) ) = { 0 } /\ F =
        ( z e. CC |-> sum_ k e. ( 0 ... n )
          ( ( ( coeff ` F ) ` k ) x. ( z ^ k ) ) ) ) ) ) $=
      ( va cfv wcel cv co cima cc0 wceq cc cmul csu cmpt wa cn0 wrex cply caddc
      ccoe c1 cuz csn cfz cexp cmap crab crio coeval coeeu riotacl2 syl eqeltrd
      wreu imaeq1 eqeq1d fveq1 oveq1d sumeq2sdv mpteq2dv eqeq2d anbi12d rexbidv
      elrab sylib ) EBUAGHZEUCGZFIZDIZUDUBJUEGZKZLUFZMZEANLVLUGJZCIZVKGZAIVRUHJ
      ZOJZCPZQZMZRZDSTZFNSUIJZUJZHVJWGHVJVMKZVOMZEANVQVRVJGZVTOJZCPZQZMZRZDSTZR
      VIVJWFFWGUKZWHABCDEFULVIWFFWGUQWRWHHABCDEFUMWFFWGUNUOUPWFWQFVJWGVKVJMZWEW
      PDSWSVPWJWDWOWSVNWIVOVKVJVMURUSWSWCWNEWSANWBWMWSVQWAWLCWSVSWKVTOVRVKVJUTV
      AVBVCVDVEVFVGVH $.

  $}

  ${
    $d a k n x z A $.  $d a n x F $.  $d k n z N $.  $d a n S $.
    coeeq.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    coeeq.2 $e |- ( ph -> N e. NN0 ) $.
    coeeq.3 $e |- ( ph -> A : NN0 --> CC ) $.
    coeeq.4 $e |- ( ph -> ( A " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $.
    coeeq.5 $e |- ( ph -> F =
      ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
    $( If ` A ` satisfies the properties of the coefficient function, it must
       be equal to the coefficient function.  (Contributed by Mario Carneiro,
       22-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    coeeq $p |- ( ph -> ( coeff ` F ) = A ) $=
      ( va vn cfv cv co wceq cc cn0 ccoe c1 caddc cuz cima cc0 csn cfz cexp csu
      cmul cmpt wrex cmap crio cply wcel coeval syl oveq1 fveq2d imaeq2d eqeq1d
      wa oveq2 sumeq1d mpteq2dv eqeq2d anbi12d rspcev syl12anc wreu wb wf nn0ex
      cnex elmap sylibr coeeu imaeq1 fveq1 oveq1d sumeq2sdv rexbidv mpbid eqtrd
      riota2 syl2anc ) AFUAOZMPZNPZUBUCQZUDOZUEZUFUGZRZFBSUFWKUHQZEPZWJOZBPWRUI
      QZUKQZEUJZULZRZVDZNTUMZMSTUNQZUOZCAFDUPOUQZWIXHRHBDENFMURUSACWMUEZWORZFBS
      WQWRCOZWTUKQZEUJZULZRZVDZNTUMZXHCRZAGTUQCGUBUCQZUDOZUEZWORZFBSUFGUHQZXMEU
      JZULZRZXRIKLXQYCYGVDNGTWKGRZXKYCXPYGYHXJYBWOYHWMYACYHWLXTUDWKGUBUCUTVAVBV
      CYHXOYFFYHBSXNYEYHWQYDXMEWKGUFUHVEVFVGVHVIVJVKACXGUQZXFMXGVLZXRXSVMATSCVN
      YIJSTCVPVOVQVRAXIYJHBDENFMVSUSXFXRMXGCWJCRZXEXQNTYKWPXKXDXPYKWNXJWOWJCWMV
      TVCYKXCXOFYKBSXBXNYKWQXAXMEYKWSXLWTUKWRWJCWAWBWCVGVHVIWDWGWHWEWF $.
  $}

  ${
    $d a f n x A $.  $d a f j n w x F $.  $d a j k n w x z S $.
    dgrval.1 $e |- A = ( coeff ` F ) $.
    $( Value of the degree function.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    dgrval $p |- ( F e. ( Poly ` S ) -> ( deg ` F ) =
      sup ( ( `' A " ( CC \ { 0 } ) ) , NN0 , < ) ) $=
      ( vf cply cfv wcel cc cdgr ccnv cc0 cima cn0 clt csup wceq ccoe cr wor cv
      csn cdif plyssc sseli fveq2 syl6eqr cnveqd imaeq1d supeq1d df-dgr nn0ssre
      wss ltso soss mp2 supex fvmpt syl ) CBFGZHCIFGZHCJGAKZILUBUCZMZNOPZQUTVAC
      BUDUEECEUAZRGZKZVCMZNOPVEVAJVFCQZNVIVDOVJVHVBVCVJVGAVJVGCRGAVFCRUFDUGUHUI
      UJEUKNVDONSUMSOTNOTULUNNSOUOUPUQURUS $.

    $( Lemma for ~ dgrcl and similar theorems.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    dgrlem $p |- ( F e. ( Poly ` S ) -> ( A : NN0 --> ( S u. { 0 } ) /\
        E. n e. ZZ A. x e. ( `' A " ( CC \ { 0 } ) ) x <_ n ) ) $=
      ( va vz vk cfv wcel cn0 cc0 cv cc wrex co wa cvv syl cply csn cun cle wbr
      wf ccnv cdif cima wral cz c1 caddc cuz wceq cfz cexp cmul csu cmpt elply2
      cmap wss simprbi simplrr simpll plybss 0cn snssd unssd cnex ssexg sylancl
      wb a1i nn0ex elmapg mpbid simplrl fss syl2anc simprl simprr coeeq syl5req
      ccoe feq1d ex rexlimdvva mpd nn0ssz wi wne wfn ffn elpreima biimpa simprd
      eldifsni simpld plyco0 r19.21bi syldan ralrimiva imaeq1d raleqdv rexlimdv
      cnveqd expr reximdva ssrexv mpsyl jca ) ECUAJKZLCMUBZUCZBUFZANZDNZUDUEZAB
      UGZOXOUHZUIZUJZDUKPZXNGNZXSULUMQUNJUIXOUOZEHOMXSUPQINZYFJHNYHUQQURQIUSUTU
      OZRZGXPLVBQZPZDLPZXQXNCOVCZYMHCIDEGVAVDZXNYJXQDGLYKXNXSLKZYFYKKZRZRZYJXQY
      SYJRZLXPYFUFZXQYTYQUUAXNYPYQYJVEYTXPSKZLSKYQUUAVNYTXPOVCZOSKUUBYTCXOOYTXN
      YNXNYRYJVFZCEVGTYTMOMOKYTVHVOVIVJZVKXPOSVLVMVPXPLYFSSVQVMVRZYTLXPYFBYTBEW
      FJYFFYTHYFCIEXSUUDXNYPYQYJVSZYTUUAUUCLOYFUFZUUFUUELXPOYFVTWAZYSYGYIWBZYSY
      GYIWCWDWEZWGVRWHWIWJLUKVCXNYDDLPZYEWKXNYMUULYOXNYLYDDLXNYPRYJYDGYKXNYPYQY
      JYDWLYSYJYDYTXTAYFUGZYBUIZUJYDYTXTAUUNYTXRUUNKZRZXRYFJZMWMZXTUUPUUQYBKZUU
      RUUPXRLKZUUSYTUUOUUTUUSRZYTYFLWNZUUOUVAVNYTUUHUVBUUILOYFWOTLXRYBYFWPTWQZW
      RUUQOMWSTYTUUOUUTUURXTWLZUUPUUTUUSUVCWTYTUVDALYTYGUVDALUJZUUJYTYPUUHYGUVE
      VNUUGUUIYFAXSXAWAVRXBXCWJXDYTXTAUUNYCYTUUMYAYBYTYFBUUKXHXEXFVRWHXIXGXJWJY
      DDLUKXKXLXM $.

    $( The domain and range of the coefficient function.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    coef $p |- ( F e. ( Poly ` S ) -> A : NN0 --> ( S u. { 0 } ) ) $=
      ( vx vn cply cfv wcel cn0 cc0 csn cun wf cv cle wbr ccnv cc cdif cima cz
      wral wrex dgrlem simpld ) CBGHIJBKLZMANEOFOPQEARSUGTUAUCFUBUDEABFCDUEUF
      $.

    $( The domain and range of the coefficient function.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    coef2 $p |- ( ( F e. ( Poly ` S ) /\ 0 e. S ) -> A : NN0 --> S ) $=
      ( cply cfv wcel cc0 wa cn0 csn cun wf coef adantr wceq wb wss simpr snssd
      ssequn2 sylib feq3 syl mpbid ) CBEFGZHBGZIZJBHKZLZAMZJBAMZUFUKUGABCDNOUHU
      JBPZUKULQUHUIBRUMUHHBUFUGSTUIBUAUBUJBJAUCUDUE $.

    $( The domain and range of the coefficient function.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    coef3 $p |- ( F e. ( Poly ` S ) -> A : NN0 --> CC ) $=
      ( cply cfv wcel cc cc0 cn0 wf plyssc sseli 0cn coef2 sylancl ) CBEFZGCHEF
      ZGIHGJHAKQRCBLMNAHCDOP $.
  $}

  ${
    $d a k n x y z A $.  $d a k n x y F $.  $d k z ph $.  $d a k m n x y z S $.
    $d k z B $.  $d k y z M $.  $d a k n z N $.  $d k z X $.
    $( The degree of any polynomial is a nonnegative integer.  (Contributed by
       Mario Carneiro, 22-Jul-2014.) $)
    dgrcl $p |- ( F e. ( Poly ` S ) -> ( deg ` F ) e. NN0 ) $=
      ( vn vx vy cply cfv wcel cc0 cn0 clt wor cr wss a1i cz cv wbr wral wrex
      cdgr ccoe ccnv cc csn cdif cima csup eqid dgrval nn0ssre ltso soss mp2 wn
      cle wi wa 0z cdm cnvimass cun wf wceq coef fdm syl syl5sseq dgrlem simprd
      nn0uz uzsupss syl3anc supcl eqeltrd ) BAFGHZBUAGBUBGZUCUDIUEZUFZUGZJKUHJV
      QABVQUIZUJVPCDEJVTKJKLZVPJMNMKLWBUKULJMKUMUNOVPIPHZVTJNDQZCQZUPRDVTSCPTZW
      EWDKRUODVTSWDWEKRWDEQKREVTTUQDJSURCJTWCVPUSOVPVQUTZVTJVQVSVAVPJAVRVBZVQVC
      ZWGJVDVQABWAVEJWHVQVFVGVHVPWIWFDVQACBWAVIVJCDEVTIJVKVLVMVNVO $.

    dgrub.1 $e |- A = ( coeff ` F ) $.
    dgrub.2 $e |- N = ( deg ` F ) $.
    $( If the ` M ` -th coefficient of ` F ` is nonzero, then the degree of
       ` F ` is at least ` M ` .  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    dgrub $p |- ( ( F e. ( Poly ` S ) /\ M e. NN0 /\
      ( A ` M ) =/= 0 ) -> M <_ N ) $=
      ( vn vx vy cfv wcel cn0 cc0 wbr clt wn cc syl cr cply ccnv cdif cima csup
      wne w3a cle csn simp1 simp2 coef3 ffvelrnd simp3 eldifsn sylanbrc cun wfn
      wf wa wb coef ffn elpreima 4syl mpbir2and wor wss nn0ssre ltso mp2 a1i cz
      soss cv wral wrex wi cdm cnvimass wceq fdm syl5sseq dgrlem simprd uzsupss
      0z nn0uz syl3anc supub sylc cdgr dgrval syl5eq breq1d mtbird nn0red dgrcl
      syl5eqel lenltd mpbird ) CBUAKLZDMLZDAKZNUFZUGZDEUHOEDPOZQXFXGAUBRNUIZUCZ
      UDZMPUEZDPOZXFXBDXJLZXLQXBXCXEUJZXFXMXCXDXILZXBXCXEUKZXFXDRLXEXOXFMRDAXFX
      BMRAUSXNABCFULSXPUMXBXCXEUNXDRNUOUPXFXBMBXHUQZAUSZAMURXMXCXOUTVAXNABCFVBZ
      MXQAVCMDXIAVDVEVFXBHIJMXJDPMPVGZXBMTVHTPVGXTVIVJMTPVNVKVLXBNVMLZXJMVHIVOZ
      HVOZUHOIXJVPHVMVQZYCYBPOQIXJVPYBYCPOYBJVOPOJXJVQVRIMVPUTHMVQYAXBWGVLXBAVS
      ZXJMAXIVTXBXRYEMWAXSMXQAWBSWCXBXRYDIABHCFWDWEHIJXJNMWHWFWIWJWKXFEXKDPXFXB
      EXKWAXNXBECWLKZXKGABCFWMWNSWOWPXFDEXFDXPWQXFEXFXBEMLXNXBEYFMGBCWRWSSWQWTX
      A $.

    $( All the coefficients above the degree of ` F ` are zero.  (Contributed
       by Mario Carneiro, 23-Jul-2014.) $)
    dgrub2 $p |- ( F e. ( Poly ` S ) ->
      ( A " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $=
      ( vk cply cfv wcel c1 caddc co cuz cima cc0 csn wceq cv cn0 wne cle dgrub
      wbr wi wral 3expia ralrimiva cc wf wb dgrcl syl5eqel coef3 plyco0 syl2anc
      cdgr mpbird ) CBHIJZADKLMNIOPQRZGSZAIPUAZVADUBUDZUEZGTUFZUSVDGTUSVATJVBVC
      ABCVADEFUCUGUHUSDTJTUIAUJUTVEUKUSDCUQITFBCULUMABCEUNAGDUOUPUR $.

    $( If all the coefficients above ` M ` are zero, then the degree of ` F `
       is at most ` M ` .  (Contributed by Mario Carneiro, 22-Jul-2014.) $)
    dgrlb $p |- ( ( F e. ( Poly ` S ) /\ M e. NN0 /\
      ( A " ( ZZ>= ` ( M + 1 ) ) ) = { 0 } ) -> N <_ M ) $=
      ( vy vx vn cfv wcel cn0 cc0 wbr clt wn wral 3ad2ant1 cr cply c1 caddc cuz
      co cima csn wceq w3a cle ccnv cc cdif csup cv simp2 wa wne cun wf wb wrex
      wfn cz dgrlem simpld ffn elpreima 3syl biimpa simprd eldifsni simp3 coef3
      syl wi plyco0 syl2anc mpbid syldan mpd nn0red adantr lenltd ralrimiva wor
      r19.21bi wss nn0ssre ltso soss mp2 a1i 0z cdm cnvimass fdm syl5sseq nn0uz
      uzsupss syl3anc supnub mp2and dgrval syl5eq breq2d mtbird syl5eqel mpbird
      cdgr dgrcl ) CBUAKLZDMLZADUBUCUEUDKUFNUGZUHZUIZEDUJODEPOZQXPXQDAUKULXNUMZ
      UFZMPUNZPOZXPXMDHUOZPOQZHXSRYAQXLXMXOUPZXPYCHXSXPYBXSLZUQZYBDUJOZYCYFYBAK
      ZNURZYGYFYHXRLZYIYFYBMLZYJXPYEYKYJUQZXPMBXNUSZAUTZAMVCYEYLVAXLXMYNXOXLYNI
      UOZJUOZUJOIXSRJVDVBZIABJCFVEZVFZSMYMAVGMYBXRAVHVIVJZVKYHULNVLVOXPYEYKYIYG
      VPZYFYKYJYTVFZXPUUAHMXPXOUUAHMRZXLXMXOVMXPXMMULAUTZXOUUCVAYDXLXMUUDXOABCF
      VNSAHDVQVRVSWGVTWAYFYBDYFYBUUBWBXPDTLYEXPDYDWBZWCWDVSWEXPJIHMXSDPMPWFZXPM
      TWHTPWFUUFWIWJMTPWKWLWMXLXMYPYOPOQIXSRYOYPPOYOYBPOHXSVBVPIMRUQJMVBZXOXLNV
      DLZXSMWHYQUUGUUHXLWNWMXLAWOZXSMAXRWPXLYNUUIMUHYSMYMAWQVOWRXLYNYQYRVKJIHXS
      NMWSWTXASXBXCXPEXTDPXLXMEXTUHXOXLECXJKZXTGABCFXDXESXFXGXPEDXPEXLXMEMLXOXL
      EUUJMGBCXKXHSWBUUEWDXI $.

    ${
      coeid.3 $e |- ( ph -> F e. ( Poly ` S ) ) $.
      coeid.4 $e |- ( ph -> M e. NN0 ) $.
      coeid.5 $e |- ( ph -> B e. ( ( S u. { 0 } ) ^m NN0 ) ) $.
      coeid.6 $e |- ( ph -> ( B " ( ZZ>= ` ( M + 1 ) ) ) = { 0 } ) $.
      coeid.7 $e |- ( ph -> F =
        ( z e. CC |-> sum_ k e. ( 0 ... M ) ( ( B ` k ) x. ( z ^ k ) ) ) ) $.
      $( Lemma for ~ coeid .  (Contributed by Mario Carneiro, 22-Jul-2014.) $)
      coeidlem $p |- ( ph -> F =
        ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $=
        ( cc cc0 wcel cn0 cfz co cv cfv cexp cmul csu cmpt wa wceq ccoe csn cun
        wf wss cmap cvv wb cply plybss syl 0cn a1i snssd unssd cnex ssexg nn0ex
        sylancl elmapg mpbid fss syl2anc coeeq adantr fveq1 oveq1d sumeq2sdv cz
        syl5req cuz cle wbr cdgr dgrcl syl5eqel nn0zd caddc cima imaeq1d eqtr3d
        dgrlb syl3anc eluz2 syl3anbrc fzss2 plyssc sseldi coef3 ffvelrnda expcl
        c1 elfznn0 adantll mulcld sylan2 cdif wn eldifn adantl wne eldifi dgrub
        wi 3expia syl2an elfzuz elfz5 syl2anr sylibrd necon1bd mpd simpr mul02d
        eqtrd fzfid fsumss eqtr4d mpteq2dva ) AGBQRHUAUBZFUCZDUDZBUCZYKUEUBZUFU
        BZFUGZUHBQRIUAUBZYKCUDZYNUFUBZFUGZUHPABQYPYTAYMQSZUIZYPYJYSFUGZYTUUBDCU
        JZYPUUCUJAUUDUUAACGUKUDDJABDEFGHLMATERULZUMZDUNZUUFQUOZTQDUNADUUFTUPUBS
        ZUUGNAUUFUQSZTUQSUUIUUGURAUUHQUQSUUJAEUUEQAGEUSUDZSZEQUOLEGUTVAARQRQSAV
        BVCVDVEZVFUUFQUQVGVIVHUUFTDUQUQVJVIVKUUMTUUFQDVLVMOPVNVTVOZUUDYJYOYSFUU
        DYLYRYNUFYKDCVPVQVRVAUUBYQYJYSFUUBHIWAUDSZYQYJUOUUBIVSSZHVSSIHWBWCZUUOU
        UBIUUBUULITSAUULUUALVOZUULIGWDUDTKEGWEWFVAWGZUUBHAHTSZUUAMVOZWGUUBUULUU
        TCHXBWHUBWAUDZWIZUUEUJUUQUURUVAUUBDUVBWIZUVCUUEUUBDCUVBUUNWJAUVDUUEUJUU
        AOVOWKCEGHIJKWLWMIHWNWOIRHWPVAYKYQSZUUBYKTSZYSQSYKIXCUUBUVFUIYRYNUUBTQY
        KCATQCUNZUUAAGQUSUDZSUVGAUUKUVHGEWQLWRCQGJWSVAVOWTUUAUVFYNQSZAYMYKXAZXD
        XEXFUUBYKYJYQXGSZUIZYSRYNUFUBRUVLYRRYNUFUVLUVEXHZYRRUJUVKUVMUUBYKYJYQXI
        XJUVLUVEYRRUVLYRRXKZYKIWBWCZUVEUUBUULUVFUVNUVOXNUVKUURUVKYKYJSZUVFYKYJY
        QXLZYKHXCVAZUULUVFUVNUVOCEGYKIJKXMXOXPUVKYKRWAUDSZUUPUVEUVOURUUBUVKUVPU
        VSUVQYKRHXQVAUUSYKRIXRXSXTYAYBVQUVLYNUUBUUAUVFUVIUVKAUUAYCUVRUVJXPYDYEU
        UBRHYFYGYHYIYE $.
    $}

    $d k z F $.

    $( Reconstruct a polynomial as an explicit sum of the coefficient function
       up to the degree of the polynomial.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    coeid $p |- ( F e. ( Poly ` S ) -> F =
      ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $=
      ( va vn vx vm cfv cv co wceq cc cexp cmul csu cply wcel c1 caddc cuz cima
      cc0 csn cfz cmpt wa cun cn0 cmap wss elply2 simprbi simpll simplrl simprl
      simplrr simprr fveq2 oveq2 oveq12d cbvsumv oveq1 oveq2d sumeq2sdv cbvmptv
      wrex syl5eq syl6eq coeidlem ex rexlimdvva mpd ) ECUAMUBZINZJNZUCUDOUEMUFU
      GUHZPZEKQUGVTUIOZLNZVSMZKNZWDROZSOZLTZUJZPZUKZICWAULUMUNOZVKJUMVKZEAQUGFU
      IODNZBMANZWOROZSODTUJPZVRCQUOWNKCLJEIUPUQVRWLWRJIUMWMVRVTUMUBZVSWMUBZUKZU
      KZWLWRXBWLUKZABVSCDEVTFGHVRXAWLURVRWSWTWLUSVRWSWTWLVAXBWBWKUTXCEWJAQWCWOV
      SMZWQSOZDTZUJXBWBWKVBKAQWIXFWFWPPZWIWCXDWFWOROZSOZDTXFWCWHXILDWDWOPWEXDWG
      XHSWDWOVSVCWDWOWFRVDVEVFXGWCXIXEDXGXHWQXDSWFWPWORVGVHVIVLVJVMVNVOVPVQ $.

    $( Reconstruct a polynomial as an explicit sum of the coefficient function
       up to the degree of the polynomial.  (Contributed by Mario Carneiro,
       22-Jul-2014.) $)
    coeid2 $p |- ( ( F e. ( Poly ` S ) /\ X e. CC ) -> ( F ` X ) =
                  sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( X ^ k ) ) ) $=
      ( vz cply cfv wcel cc cc0 cfz co cv cexp cmul csu cmpt coeid fveq1d oveq1
      wceq oveq2d sumeq2sdv eqid sumex fvmpt sylan9eq ) DBJKLZFMLFDKFIMNEOPZCQZ
      AKZIQZUNRPZSPZCTZUAZKUMUOFUNRPZSPZCTZULFDUTIABCDEGHUBUCIFUSVCMUTUPFUEZUMU
      RVBCVDUQVAUOSUPFUNRUDUFUGUTUHUMVBCUIUJUK $.

    $( Reconstruct a polynomial as an explicit sum of the coefficient function
       up to at least the degree of the polynomial.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    coeid3 $p |- ( ( F e. ( Poly ` S ) /\ M e. ( ZZ>= ` N ) /\ X e. CC ) ->
      ( F ` X ) = sum_ k e. ( 0 ... M ) ( ( A ` k ) x. ( X ^ k ) ) ) $=
      ( cfv wcel cuz cc cc0 cfz co cmul csu cn0 syl cply cv cexp coeid2 3adant2
      w3a wceq wss fzss2 3ad2ant2 elfznn0 wa coef3 3ad2ant1 ffvelrnda 3ad2antl3
      wf expcl mulcld sylan2 cdif wn eldifn adantl wne cle wbr wi simpl1 eldifi
      elfzuz nn0uz syl6eleqr dgrub 3expia syl2anc cz wb simpl2 eluzel2 necon1bd
      elfz5 sylibrd mpd oveq1d mul02d eqtrd fzfid fsumss ) DBUAJKZEFLJKZGMKZUFZ
      GDJZNFOPZCUBZAJZGWPUCPZQPZCRZNEOPZWSCRWJWLWNWTUGWKABCDFGHIUDUEWMWOXAWSCWK
      WJWOXAUHWLFNEUIUJWPWOKZWMWPSKZWSMKWPFUKWMXCULWQWRWMSMWPAWJWKSMAUQWLABDHUM
      UNUOWLWJXCWRMKZWKGWPURUPZUSUTWMWPXAWOVAKZULZWSNWRQPNXGWQNWRQXGXBVBZWQNUGX
      FXHWMWPXAWOVCVDXGXBWQNXGWQNVEZWPFVFVGZXBXGWJXCXIXJVHWJWKWLXFVIXGWPNLJZSXF
      WPXKKZWMXFWPXAKZXLWPXAWOVJZWPNEVKTVDZVLVMWJXCXIXJABDWPFHIVNVOVPXGXLFVQKZX
      BXJVRXOXGWKXPWJWKWLXFVSFEVTTWPNFWBVPWCWAWDWEXGWRXFWMXCXDXFXMXCXNWPEUKTXEU
      TWFWGWMNEWHWIWG $.
  $}

  ${
    $d d k x y z F $.  $d d k x y z G $.  $d d k x y z ph $.  $d d k x y S $.
    plyco.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    plyco.2 $e |- ( ph -> G e. ( Poly ` S ) ) $.
    plyco.3 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x + y ) e. S ) $.
    plyco.4 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x x. y ) e. S ) $.
    $( The composition of two polynomials is a polynomial.  (Contributed by
       Mario Carneiro, 23-Jul-2014.)  (Revised by Mario Carneiro,
       23-Aug-2014.) $)
    plyco $p |- ( ph -> ( F o. G ) e. ( Poly ` S ) ) $=
      ( vz vk cc cc0 co cexp cmul cmpt wcel cvv ccom cdgr cfv cfz ccoe csu cply
      vd cv plyf syl ffvelrnda feqmptd wceq coeid oveq1 oveq2d sumeq2sdv fmptco
      wf eqid cn0 dgrcl wi c1 caddc oveq2 sumeq1d mpteq2dv eleq1d imbi2d csn wa
      cxp cz exp0d cun wss plybss 0cn a1i snssd unssd coef 0nn0 ffvelrn sylancl
      sseldd adantr mulid1d eqtrd eqeltrd fveq2 oveq12d fsum1 sylancr mpteq2dva
      0z fconstmpt syl6eqr plyconst plyun0 syl6eleq cof simprr peano2nn0 syl2an
      syl2anc cn nn0p1nn exp1d eqtr4d adantlr plymul expr cnex ovex eqidd nnnn0
      offval2 ad2antlr expp1d sylibd expcom a2d nnind impcom adantrr sumex fvex
      plyadd cuz simplr nn0uz coef3 ad2antrr elfznn0 expcl mulcld fsump1 nn0ind
      mpcom ) AEFUAKMNEUBUCZUDOZLUIZEUEUCZUCZKUIZFUCZUUEPOZQOZLUFZRZDUGUCZAKBMM
      UUIUUDUUGBUIZUUEPOZQOZLUFZUULFEAMMUUHFAFUUNSZMMFUTHDFUJUKZULZAKMMFUUTUMZA
      EUUNSZEBMUURRUNGBUUFDLEUUCUUFVAZUUCVAUOUKUUOUUIUNZUUDUUQUUKLUVEUUPUUJUUGQ
      UUOUUIUUEPUPUQURUSUUCVBSZAUUMUUNSZAUVCUVFGDEVCUKAKMNUUOUDOZUUKLUFZRZUUNSZ
      VDAKMNNUDOZUUKLUFZRZUUNSZVDAKMNUHUIZUDOZUUKLUFZRZUUNSZVDAKMNUVPVEVFOZUDOZ
      UUKLUFZRZUUNSZVDAUVGVDBUHUUCUUONUNZUVKUVOAUWFUVJUVNUUNUWFKMUVIUVMUWFUVHUV
      LUUKLUUONNUDVGVHVIVJVKUUOUVPUNZUVKUVTAUWGUVJUVSUUNUWGKMUVIUVRUWGUVHUVQUUK
      LUUOUVPNUDVGVHVIVJVKUUOUWAUNZUVKUWEAUWHUVJUWDUUNUWHKMUVIUWCUWHUVHUWBUUKLU
      UOUWANUDVGVHVIVJVKUUOUUCUNZUVKUVGAUWIUVJUUMUUNUWIKMUVIUULUWIUVHUUDUUKLUUO
      UUCNUDVGVHVIVJVKAUVNMNUUFUCZVLVNZUUNAUVNKMUWJRUWKAKMUVMUWJAUUHMSZVMZUVMUW
      JUUINPOZQOZUWJUWMNVOSUWOMSUVMUWOUNWRUWMUWOUWJMUWMUWOUWJVEQOUWJUWMUWNVEUWJ
      QUWMUUIUVAVPUQUWMUWJAUWJMSUWLADNVLZVQZMUWJADUWPMAUVCDMVRGDEVSUKANMNMSAVTW
      AWBWCZAVBUWQUUFUTZNVBSUWJUWQSZAUVCUWSGUUFDEUVDWDUKZWEVBUWQNUUFWFWGZWHWIZW
      JWKZUXCWLUUKUWOLNUUENUNUUGUWJUUJUWNQUUENUUFWMUUENUUIPVGWNWOWPUXDWKWQKMUWJ
      WSWTAUWKUWQUGUCZUUNAUWQMVRZUWTUWKUXESUWRUXBUWJUWQXAXHDXBZXCWLUVPVBSZAUVTU
      WEAUXHUVTUWEVDAUXHVMZUVTUVSMUWAUUFUCZVLVNZKMUUIUWAPOZRZQXDZOZVFXDOZUUNSZU
      WEAUXHUVTUXQAUXHUVTVMZVMBCDUVSUXOAUXHUVTXEAUXHUXOUUNSUVTUXIBCDUXKUXMUXIUX
      KUXEUUNUXIUXFUXJUWQSZUXKUXESAUXFUXHUWRWIAUWSUWAVBSUXSUXHUXAUVPXFVBUWQUWAU
      UFWFXGUXJUWQXAXHUXGXCUXHAUXMUUNSZUXHUWAXISAUXTVDZUVPXJAKMUUIUUOPOZRZUUNSZ
      VDAKMUUIVEPOZRZUUNSZVDAKMUUIUVPPOZRZUUNSZVDUYAUYABUHUWAUUOVEUNZUYDUYGAUYK
      UYCUYFUUNUYKKMUYBUYEUUOVEUUIPVGVIVJVKUWGUYDUYJAUWGUYCUYIUUNUWGKMUYBUYHUUO
      UVPUUIPVGVIVJVKUWHUYDUXTAUWHUYCUXMUUNUWHKMUYBUXLUUOUWAUUIPVGVIVJVKZUYLAUY
      FFUUNAUYFKMUUIRZFAKMUYEUUIUWMUUIUVAXKWQUVBXLHWLUVPXISZAUYJUXTAUYNUYJUXTVD
      AUYNVMZUYJUYIFUXNOZUUNSZUXTAUYNUYJUYQAUYNUYJVMZVMBCDUYIFAUYNUYJXEAUUSUYRH
      WIAUUODSCUIZDSVMZUUOUYSVFODSZUYRIXMAUYTUUOUYSQODSZUYRJXMXNXOUYOUYPUXMUUNU
      YOUYPKMUYHUUIQOZRUXMUYOKMUYHUUIQUYIFTTMMTSZUYOXPWAUYHTSUYOUWLVMZUUIUVPPXQ
      WAAUWLUUIMSZUYNUVAXMZUYOUYIXRAFUYMUNUYNUVBWIXTUYOKMUXLVUCVUEUUIUVPVUGUYNU
      XHAUWLUVPXSYAYBWQXLVJYCYDYEYFUKYGAUYTVUAUXHIXMAUYTVUBUXHJXMXNYHAUYTVUAUXR
      IXMYKXOUXIUXPUWDUUNUXIUXPKMUVRUXJUXLQOZVFOZRUWDUXIKMUVRVUHVFUVSUXOTTTVUDU
      XIXPWAZUVRTSUXIUWLVMZUVQUUKLYIWAVUHTSVUKUXJUXLQXQWAUXIUVSXRUXIKMUXJUXLQUX
      KUXMTTTVUJUXJTSVUKUWAUUFYJWAUXLTSVUKUUIUWAPXQWAUXKKMUXJRUNUXIKMUXJWSWAUXI
      UXMXRXTXTUXIKMUWCVUIVUKUUKVUHLNUVPVUKUVPVBNYLUCAUXHUWLYMYNXCVUKUUEUWBSZVM
      UUGUUJVUKVBMUUFUTZUUEVBSZUUGMSVULAVUMUXHUWLAUVCVUMGUUFDEUVDYOUKYPUUEUWAYQ
      ZVBMUUEUUFWFXGVUKVUFVUNUUJMSVULAUWLVUFUXHUVAXMVUOUUIUUEYRXGYSUUEUWAUNUUGU
      XJUUJUXLQUUEUWAUUFWMUUEUWAUUIPVGWNYTWQXLVJYCYDYEUUAUUBWL $.
  $}

  ${
    $d m x z A $.  $d m F $.  $d k m x z N $.  $d k m z ph $.
    dgrle.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    dgrle.2 $e |- ( ph -> N e. NN0 ) $.
    dgrle.3 $e |- ( ( ph /\ k e. ( 0 ... N ) ) -> A e. CC ) $.
    dgrle.4 $e |- ( ph -> F =
      ( z e. CC |-> sum_ k e. ( 0 ... N ) ( A x. ( z ^ k ) ) ) ) $.
    $( Compute the coefficient function given a sum expression for the
       polynomial.  (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    coeeq2 $p |- ( ph ->
      ( coeff ` F ) = ( k e. NN0 |-> if ( k <_ N , A , 0 ) ) ) $=
      ( vm cn0 cc0 cc wcel wa co syl2anc cmul cle wbr cif cmpt cfz simpll simpr
      cv cuz cfv cz wb simplr nn0uz syl6eleq nn0zd ad2antrr elfz5 mpbird wn 0cn
      a1i ifclda eqid fmptd c1 caddc cima csn wceq wne wi fvmpt2 neeq1d iffalse
      wral necon1ai syl6bi ralrimiva nfv nffvmpt1 nfcv nfne fveq2 breq1 imbi12d
      nfim cbvral sylib wf plyco0 cexp csu oveq2 oveq12d cbvsumi elfznn0 adantl
      nfov elfzle2 iftrue syl adantlr eqeltrd oveq1d sumeq2dv syl5eqr mpteq2dva
      eqtrd eqtr4d coeeq ) ABEMEUHZGUAUBZCNUCZUDZDLFGHIAEMXNOXOAXLMPZQZXMCNOXQX
      MQZAXLNGUERZPZCOPZAXPXMUFXRXTXMXQXMUGXRXLNUIUJZPGUKPZXTXMULXRXLMYBAXPXMUM
      UNUOAYCXPXMAGIUPUQXLNGURSUSJSNOPXQXMUTQVAVBVCZXOVDZVEZAXOGVFVGRUIUJVHNVIV
      JZLUHZXOUJZNVKZYHGUAUBZVLZLMVPZAXLXOUJZNVKZXMVLZEMVPYMAYPEMXQYOXNNVKXMXQY
      NXNNXQXPXNOPZYNXNVJZAXPUGYDEMXNOXOYEVMZSVNXMXNNXMCNVOVQVRVSYPYLELMYPLVTYJ
      YKEEYINEMXNYHWAZENWBWCYKEVTWGXLYHVJZYOYJXMYKUUAYNYINXLYHXOWDZVNXLYHGUAWEW
      FWHWIAGMPMOXOWJYGYMULIYFXOLGWKSUSAFBOXSCBUHZXLWLRZTRZEWMZUDBOXSYIUUCYHWLR
      ZTRZLWMZUDKABOUUIUUFAUUCOPZQZUUIXSYNUUDTRZEWMUUFXSUULUUHELLUULWBEYIUUGTYT
      ETWBEUUGWBWSUUAYNYIUUDUUGTUUBXLYHUUCWLWNWOWPUUKXSUULUUEEUUKXTQZYNCUUDTUUM
      YNXNCUUMXPYQYRXTXPUUKXLGWQWRUUMXNCOUUMXMXNCVJXTXMUUKXLNGWTWRXMCNXAXBZAXTY
      AUUJJXCXDYSSUUNXIXEXFXGXHXJXK $.

    $( Given an explicit expression for a polynomial, the degree is at most the
       highest term in the sum.  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    dgrle $p |- ( ph -> ( deg ` F ) <_ N ) $=
      ( vm cfv wcel cn0 cc0 wceq cle wbr wi cply ccoe c1 caddc co cuz cima cdgr
      csn cv wne wral wa wn cif cmpt coeeq2 ad2antrr fveq1d nfcv nffvmpt1 nfeq1
      nfv breq1 notbid fveq2 eqeq1d imbi12d cid iffalse fveq2d cc 0cn fvi ax-mp
      nfim syl6eq fvmpt2i syl5ibr vtoclgaf imp adantll eqtrd necon1ad ralrimiva
      eqid ex wf wb coef3 syl plyco0 syl2anc mpbird dgrlb syl3anc ) AFDUAMNZGON
      ZFUBMZGUCUDUEUFMUGPUIQZFUHMZGRSHIAWTLUJZWSMZPUKXBGRSZTZLOULZAXELOAXBONZUM
      ZXDXCPXHXDUNZXCPQXHXIUMZXCXBEOEUJZGRSZCPUOZUPZMZPXJXBWSXNAWSXNQXGXIABCDEF
      GHIJKUQURUSXGXIXOPQZAXGXIXPXLUNZXKXNMZPQZTXIXPTEXBOEXBUTXIXPEXIEVCEXOPEOX
      MXBVAVBVPXKXBQZXQXIXSXPXTXLXDXKXBGRVDVEXTXRXOPXKXBXNVFVGVHXQXSXKONZXMVIMZ
      PQXQYBPVIMZPXQXMPVIXLCPVJVKPVLNYCPQVMPVLVNVOVQYAXRYBPEOXMXNXNWFVRVGVSVTWA
      WBWCWGWDWEAWROVLWSWHZWTXFWIIAWQYDHWSDFWSWFZWJWKWSLGWLWMWNWSDFGXAYEXAWFWOW
      P $.
  $}

  ${
    $d k z A $.  $d k z N $.  $d k z ph $.
    dgreq.1 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    dgreq.2 $e |- ( ph -> N e. NN0 ) $.
    dgreq.3 $e |- ( ph -> A : NN0 --> CC ) $.
    dgreq.4 $e |- ( ph -> ( A " ( ZZ>= ` ( N + 1 ) ) ) = { 0 } ) $.
    dgreq.5 $e |- ( ph -> F =
      ( z e. CC |-> sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
    dgreq.6 $e |- ( ph -> ( A ` N ) =/= 0 ) $.
    $( If the highest term in a polynomial expression is nonzero, then the
       polynomial's degree is completely determined.  (Contributed by Mario
       Carneiro, 24-Jul-2014.) $)
    dgreq $p |- ( ph -> ( deg ` F ) = N ) $=
      ( cfv cle wbr cn0 cc wcel cc0 cdgr wceq cv wf cfz co elfznn0 syl2an dgrle
      ffvelrn cply ccoe wne coeeq fveq1d eqnetrd dgrub syl3anc dgrcl syl nn0red
      eqid letri3d mpbir2and ) AFUANZGUBVEGOPGVEOPZABEUCZCNZDEFGHIAQRCUDVGQSVHR
      SVGTGUEUFSJVGGUGQRVGCUJUHLUIAFDUKNSZGQSGFULNZNZTUMVFHIAVKGCNTAGVJCABCDEFG
      HIJKLUNUOMUPVJDFGVEVJVBVEVBUQURAVEGAVEAVIVEQSHDFUSUTVAAGIVAVCVD $.
  $}

  ${
    $d k z A $.  $d k z F $.  $d k z S $.
    $( A constant function has degree 0.  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    0dgr $p |- ( A e. CC -> ( deg ` ( CC X. { A } ) ) = 0 ) $=
      ( vz vk cc wcel csn cxp cdgr cfv cc0 wceq cn0 cv co cexp cmul cmpt oveq2d
      simpl c1 cle wbr wss cply ssid plyconst mpan 0nn0 a1i cfz wa cz 0z mulid1
      csu exp0 sylan9eqr eqeltrd oveq2 fsum1 eqtrd mpteq2dva fconstmpt syl6reqr
      sylancr dgrle wb dgrcl nn0le0eq0 3syl mpbid ) ADEZDAFGZHIZJUAUBZVNJKZVLBA
      DCVMJDDUCVLVMDUDIEZDUEADUFUGZJLEVLUHUIVLCMZJJUJNZESVLBDVTABMZVSONZPNZCUOZ
      QBDAQVMVLBDWDAVLWADEZUKZWDAWAJONZPNZAWFJULEWHDEWDWHKUMWFWHADWEVLWHATPNAWE
      WGTAPWAUPRAUNUQZVLWESURWCWHCJVSJKWBWGAPVSJWAOUSRUTVEWIVAVBBDAVCVDVFVLVQVN
      LEVOVPVGVRDVMVHVNVIVJVK $.

    $( A function has degree zero iff it is a constant function.  (Contributed
       by Mario Carneiro, 23-Jul-2014.) $)
    0dgrb $p |- ( F e. ( Poly ` S ) ->
      ( ( deg ` F ) = 0 <-> F = ( CC X. { ( F ` 0 ) } ) ) ) $=
      ( vz vk cfv wcel cdgr cc0 wceq cc csn cxp wa cfz co cexp cmul cn0 eqtrd
      c1 cply ccoe cmpt cv eqid coeid adantr simplr oveq2d sumeq1d cz 0z adantl
      exp0 wf coef3 0nn0 ffvelrn sylancl ad2antrr mulid1d eqeltrd fveq2 oveq12d
      csu oveq2 fsum1 sylancr mpteq2dva fconstmpt syl6eqr fveq1d 0cn fvex ax-mp
      fvconst2 syl6eq sneqd xpeq2d eqtr4d ex plyf 0dgr eqeq1d syl5ibrcom impbid
      syl ) BAUAEFZBGEZHIZBJHBEZKZLZIZWHWJWNWHWJMZBJHBUBEZEZKZLZWMWOBCJWQUCZWSW
      OBCJHWINOZDUDZWPEZCUDZXBPOZQOZDVEZUCZWTWHBXHIWJCWPADBWIWPUEZWIUEUFUGWOCJX
      GWQWOXDJFZMZXGHHNOZXFDVEZWQXKXAXLXFDXKWIHHNWHWJXJUHUIUJXKXMWQXDHPOZQOZWQX
      KHUKFXOJFXMXOIULXKXOWQJXKXOWQTQOWQXKXNTWQQXJXNTIWOXDUNUMUIXKWQWHWQJFZWJXJ
      WHRJWPUOHRFXPWPABXIUPUQRJHWPURUSUTZVASZXQVBXFXODHXBHIXCWQXEXNQXBHWPVCXBHX
      DPVFVDVGVHXRSSVISCJWQVJVKZWOWLWRJWOWKWQWOWKHWSEZWQWOHBWSXSVLHJFZXTWQIVMJW
      QHHWPVNVPVOVQVRVSVTWAWHWJWNWMGEZHIZWHWKJFZYCWHJJBUOYAYDABWBVMJJHBURUSWKWC
      WGWNWIYBHBWMGVCWDWEWF $.
  $}

  ${
    $d j k n x y z A $.  $d j k n y z B $.  $d j k n x y z F $.  $d j k z M $.
    $d j k n x y z G $.  $d j k n z N $.  $d j k n x y z S $.
    coefv0.1 $e |- A = ( coeff ` F ) $.
    $( The result of evaluating a polynomial at zero is the constant term.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    coefv0 $p |- ( F e. ( Poly ` S ) -> ( F ` 0 ) = ( A ` 0 ) ) $=
      ( vk cfv wcel cc0 cfz co cexp cmul csu cc wceq 0cn cn0 syl wa c1 cv mpan2
      cply cdgr eqid coeid2 cuz wss dgrcl nn0uz syl6eleq fzss2 fveq2 oveq2 exp0
      elfz1eq ax-mp syl6eq oveq12d coef3 0nn0 ffvelrn sylancl mulid1d sylan9eqr
      wf adantr eqeltrd cn eldifn wn wo eldifi elfznn0 elnn0 sylib ord id cz 0z
      cdif elfz3 syl6 mt3d adantl 0expd oveq2d syl2an mul01d eqtrd fzfid fsumss
      syl6eqel fsum1 sylancr 3eqtr2d ) CBUCFGZHCFZHCUDFZIJZEUAZAFZHXAKJZLJZEMZH
      HIJZXDEMZHAFZWQHNGZWRXEOPABECWSHDWSUEUFUBWQXFWTXDEWQWSHUGFZGXFWTUHWQWSQXJ
      BCUIUJUKHHWSULRWQXAXFGZSXDXHNXKWQXDXHTLJZXHXKXAHOZXDXLOXAHUPXMXBXHXCTLXAH
      AUMXMXCHHKJZTXAHHKUNXIXNTOPHUOUQURUSZRWQXHWQQNAVFZHQGXHNGZABCDUTZVAQNHAVB
      VCZVDZVEWQXQXKXSVGVHWQXAWTXFWAGZSZXDXBHLJHYBXCHXBLYBXAYAXAVIGZWQYAYCXKXAW
      TXFVJYAYCVKXMXKYAYCXMYAXAQGZYCXMVLYAXAWTGYDXAWTXFVMXAWSVNRZXAVOVPVQXMXAHX
      FXMVRHVSGZHXFGVTHWBUQWMWCWDWEWFWGYBXBWQXPYDXBNGYAXRYEQNXAAVBWHWIWJWQHWSWK
      WLWQXGXLXHWQYFXLNGXGXLOVTWQXLXHNXTXSVHXDXLEHXOWNWOXTWJWP $.

    coeadd.2 $e |- B = ( coeff ` G ) $.
    ${
      coeadd.3 $e |- M = ( deg ` F ) $.
      coeadd.4 $e |- N = ( deg ` G ) $.
      $( Lemma for ~ coeadd and ~ dgradd .  (Contributed by Mario Carneiro,
         24-Jul-2014.) $)
      coeaddlem $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
        ( ( coeff ` ( F oF + G ) ) = ( A oF + B ) /\
          ( deg ` ( F oF + G ) ) <_ if ( M <_ N , N , M ) ) ) $=
        ( vk cfv wcel caddc co wceq cc cn0 cc0 vz vx cply cof ccoe cdgr cle wbr
        vy wa cif plyaddcl dgrcl syl5eqel adantl adantr syl2anc cvv cv addcl wf
        ifcl coef3 nn0ex a1i inidm off c1 cuz cima csn wne wi wral wo wn oveq12
        00id syl6eq wfn ffn eqidd ofval eqeq1d syl5ibr necon3ad neorian syl6ibr
        syl dgrub2 wb plyco0 mpbid r19.21bi cr nn0red max1 nn0re syl3anc mpan2d
        letr syld max2 jaod ralrimiva mpbird simpl simpr cfz cexp cmul csu cmpt
        coeid plyaddlem1 coeeq elfznn0 ffvelrn syl2an dgrle jca ) DCUCMZNZEYBNZ
        UJZDEOUDZPZUEMABYFPZQYGUFMFGUGUHZGFUKZUGUHYEUAYHRLYGYJCDEULZYEGSNZFSNZY
        JSNZYDYLYCYDGEUFMSKCEUMUNUOZYCYMYDYCFDUFMSJCDUMUNUPZYIGFSVBUQZYEUBUISSS
        ORRRABURURUBUSZRNUIUSZRNUJYRYSOPRNYEYRYSUTUOYCSRAVAZYDACDHVCUPZYDSRBVAZ
        YCBCEIVCUOZSURNYEVDVEZUUDSVFZVGZYEYHYJVHOPVIMVJTVKZQZLUSZYHMZTVLZUUIYJU
        GUHZVMZLSVNZYEUUMLSYEUUISNZUJZUUKUUIAMZTVLZUUIBMZTVLZVOZUULUUPUUKUUQTQU
        USTQUJZVPUVAUUPUVBUUJTUVBUUJTQUUPUUQUUSOPZTQUVBUVCTTOPTUUQTUUSTOVQVRVSU
        UPUUJUVCTYESSUUQUUSOSABURURUUIYEYTASVTUUASRAWAWIYEUUBBSVTUUCSRBWAWIUUDU
        UDUUEUUPUUQWBUUPUUSWBWCWDWEWFUUQTUUSTWGWHUUPUURUULUUTUUPUURUUIFUGUHZUUL
        YEUURUVDVMZLSYEAFVHOPVIMVJUUGQZUVELSVNZYCUVFYDACDFHJWJUPZYEYMYTUVFUVGWK
        YPUUAALFWLUQWMWNUUPUVDFYJUGUHZUULUUPFWONZGWONZUVIUUPFYEYMUUOYPUPWPZUUPG
        YEYLUUOYOUPWPZFGWQUQUUPUUIWONZUVJYJWONZUVDUVIUJUULVMUUOUVNYEUUIWRUOZUVL
        UUPYJYEYNUUOYQUPWPZUUIFYJXAWSWTXBUUPUUTUUIGUGUHZUULYEUUTUVRVMZLSYEBGVHO
        PVIMVJUUGQZUVSLSVNZYDUVTYCBCEGIKWJUOZYEYLUUBUVTUWAWKYOUUCBLGWLUQWMWNUUP
        UVRGYJUGUHZUULUUPUVJUVKUWCUVLUVMFGXCUQUUPUVNUVKUVOUVRUWCUJUULVMUVPUVMUV
        QUUIGYJXAWSWTXBXDXBXEYEYNSRYHVAZUUHUUNWKYQUUFYHLYJWLUQXFYEUAABCLDEFGYCY
        DXGYCYDXHYPYOUUAUUCUVHUWBYCDUARTFXIPUUQUAUSUUIXJPZXKPLXLXMQYDUAACLDFHJX
        NUPYDEUARTGXIPUUSUWEXKPLXLXMQYCUABCLEGIKXNUOXOZXPYEUAUUJRLYGYJYKYQYEUWD
        UUOUUJRNUUITYJXIPNUUFUUIYJXQSRUUIYHXRXSUWFXTYA $.

      $( Lemma for ~ coemul and ~ dgrmul .  (Contributed by Mario Carneiro,
         24-Jul-2014.) $)
      coemullem $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
        ( ( coeff ` ( F oF x. G ) ) = ( n e. NN0 |->
            sum_ k e. ( 0 ... n ) ( ( A ` k ) x. ( B ` ( n - k ) ) ) ) /\
          ( deg ` ( F oF x. G ) ) <_ ( M + N ) ) ) $=
        ( cfv wcel co cn0 cc0 wceq cc vz vj cply wa cmul cof ccoe cfz cmin cmpt
        cv csu cdgr caddc cle wbr plymulcl dgrcl syl5eqel nn0addcl syl2an fzfid
        wf coef3 adantr elfznn0 adantl ad2antrr fznn0sub ffvelrnd mulcld fsumcl
        ffvelrn eqid fmptd c1 cuz cima csn wi wral wn oveq2 oveq1 fveq2d oveq2d
        wne sumeq12dv sumex fvmpt ad2antrl simp2r simp2l nn0red simp3l 3ad2ant1
        w3a syl lesubadd2d simp3r leadd1dd cr readdcld letr syl3anc mpan2d mtod
        sylbid simpr dgrub 3expia syl2anc necon1bd mpd mul01d eqtrd impl oveq1d
        simpl imp ad3antrrr ad2antlr mul02d pm2.61dan sumeq2dv wss wo fzfi olci
        cfn sumz ax-mp syl6eq expr necon1ad ralrimiva wb cexp dgrub2 coeid jca
        plyco0 mpbird plymullem1 sumeq2i mpteq2i syl6eqr coeeq dgrle ) FCUCNZOZ
        GUUJOZUDZFGUEUFPZUGNEQREUKZUHPZDUKZANZUUOUUQUIPZBNZUEPZDULZUJZSUUNUMNHI
        UNPZUOUPUUMUAUVCTUBUUNUVDCFGUQZUUKHQOZIQOZUVDQOZUULUUKHFUMNQLCFURUSZUUL
        IGUMNQMCGURUSZHIUTVAZUUMEQUVBTUVCUUMUUOQOZUDZUUPUVADUVMRUUOVBUVMUUQUUPO
        ZUDZUURUUTUVMQTAVCZUUQQOZUURTOUVNUUMUVPUVLUUKUVPUULACFJVDVEZVEUUQUUOVFQ
        TUUQAVMVAUVOQTUUSBUUMQTBVCZUVLUVNUULUVSUUKBCGKVDVGZVHUVNUUSQOUVMUUQRUUO
        VIVGVJVKVLUVCVNZVOZUUMUVCUVDVPUNPVQNVRRVSZSZUBUKZUVCNZRWGUWEUVDUOUPZVTZ
        UBQWAZUUMUWHUBQUUMUWEQOZUDUWGUWFRUUMUWJUWGWBZUWFRSUUMUWJUWKUDZUDZUWFRUW
        EUHPZUURUWEUUQUIPZBNZUEPZDULZRUWJUWFUWRSZUUMUWKEUWEUVBUWRQUVCUUOUWESZUU
        PUWNUVAUWQDUUOUWERUHWCUWTUVAUWQSUVNUWTUUTUWPUURUEUWTUUSUWOBUUOUWEUUQUIW
        DWEWFVEWHUWAUWNUWQDWIWJZWKUWMUWRUWNRDULZRUWMUWNUWQRDUWMUUQUWNOZUDZUUQHU
        OUPZUWQRSZUWMUXCUXEUXFUUMUWLUXCUXEUDZUXFUUMUWLUXGWQZUWQUURRUEPRUXHUWPRU
        URUEUXHUWOIUOUPZWBUWPRSUXHUXIUWGUUMUWJUWKUXGWLUXHUXIUWEUUQIUNPZUOUPZUWG
        UXHUWEUUQIUXHUWEUUMUWJUWKUXGWMWNZUXHUUQUXHUXCUVQUUMUWLUXCUXEWOZUUQUWEVF
        ZWRZWNZUXHIUUMUWLUVGUXGUULUVGUUKUVJVGZWPWNZWSUXHUXKUXJUVDUOUPZUWGUXHUUQ
        HIUXPUXHHUUMUWLUVFUXGUUKUVFUULUVIVEZWPWNZUXRUUMUWLUXCUXEWTXAUXHUWEXBOUX
        JXBOUVDXBOUXKUXSUDUWGVTUXLUXHUUQIUXPUXRXCUXHHIUYAUXRXCUWEUXJUVDXDXEXFXH
        XGUXHUXIUWPRUXHUULUWOQOZUWPRWGZUXIVTUUMUWLUULUXGUUKUULXIZWPUXHUXCUYBUXM
        UUQRUWEVIZWRUULUYBUYCUXIBCGUWOIKMXJXKXLXMXNWFUXHUURUXHQTUUQAUUMUWLUVPUX
        GUVRWPUXOVJXOXPXKXQUXDUXEWBZUDZUWQRUWPUEPRUYGUURRUWPUEUXDUYFUURRSUXDUXE
        UURRUWMUUKUVQUURRWGZUXEVTUXCUUMUUKUWLUUKUULXSZVEUXNUUKUVQUYHUXEACFUUQHJ
        LXJXKVAXMXTXRUYGUWPUYGQTUWOBUUMUVSUWLUXCUYFUVTYAUXCUYBUWMUYFUYEYBVJYCXP
        YDYEUWNRVQNYFZUWNYJOZYGUXBRSUYKUYJRUWEYHYIUWNDRYKYLYMXPYNYOYPUUMUVHQTUV
        CVCZUWDUWIYQUVKUWBUVCUBUVDUUBXLUUCUUMUUNUATRUVDUHPZUWRUAUKZUWEYRPZUEPZU
        BULZUJUATUYMUWFUYOUEPZUBULZUJUUMUAABCDUBFGHIUYIUYDUXTUXQUVRUVTUUKAHVPUN
        PVQNVRUWCSUULACFHJLYSVEUULBIVPUNPVQNVRUWCSUUKBCGIKMYSVGUUKFUATRHUHPUURU
        YNUUQYRPZUEPDULUJSUULUAACDFHJLYTVEUULGUATRIUHPUUQBNUYTUEPDULUJSUUKUABCD
        GIKMYTVGUUDUATUYSUYQUYMUYRUYPUBUWEUYMOZUWFUWRUYOUEVUAUWJUWSUWEUVDVFZUXA
        WRXRUUEUUFUUGZUUHUUMUAUWFTUBUUNUVDUVEUVKUUMUYLUWJUWFTOVUAUWBVUBQTUWEUVC
        VMVAVUCUUIUUA $.
    $}

    $( The coefficient function of a sum is the sum of coefficients.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    coeadd $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
      ( coeff ` ( F oF + G ) ) = ( A oF + B ) ) $=
      ( cply cfv wcel wa caddc cof co ccoe wceq cdgr cle wbr eqid cif coeaddlem
      simpld ) DCHIZJEUDJKDELMZNZOIABUENPUFQIDQIZEQIZRSUHUGUARSABCDEUGUHFGUGTUH
      TUBUC $.

    $( A coefficient of a product of polynomials.  (Contributed by Mario
       Carneiro, 24-Jul-2014.) $)
    coemul $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ N e. NN0 ) ->
      ( ( coeff ` ( F oF x. G ) ) ` N ) =
      sum_ k e. ( 0 ... N ) ( ( A ` k ) x. ( B ` ( N - k ) ) ) ) $=
      ( vn cfv wcel cn0 cmul co cc0 cfz cmin wceq cdgr cply cof ccoe cv wa cmpt
      csu caddc cle wbr eqid coemullem simpld fveq1d oveq2 fveq2d oveq2d adantr
      oveq1 sumeq12dv sumex fvmpt sylan9eq 3impa ) ECUAKZLZFVELZGMLZGEFNUBOZUCK
      ZKZPGQOZDUDZAKZGVMROZBKZNOZDUGZSVFVGUEZVHVKGJMPJUDZQOZVNVTVMROZBKZNOZDUGZ
      UFZKVRVSGVJWFVSVJWFSVITKETKZFTKZUHOUIUJABCDJEFWGWHHIWGUKWHUKULUMUNJGWEVRM
      WFVTGSZWAVLWDVQDVTGPQUOWIWDVQSVMWALWIWCVPVNNWIWBVOBVTGVMRUSUPUQURUTWFUKVL
      VQDVAVBVCVD $.

    $( The coefficient function is one-to-one, so if the coefficients are equal
       then the functions are equal and vice-versa.  (Contributed by Mario
       Carneiro, 24-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    coe11 $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
                  ( F = G <-> A = B ) ) $=
      ( vz vk cfv wcel wceq ccoe cc cc0 cfz co cmul cn0 clt cply wa 3eqtr4g w3a
      fveq2 cdgr cv cexp csu cmpt ccnv csn cdif cima csup simp3 imaeq1d supeq1d
      cnveqd dgrval 3ad2ant1 3eqtr4d oveq2d simpl3 fveq1d oveq1d sumeq12dv eqid
      3ad2ant2 mpteq2dv coeid 3expia impbid2 ) DCUAJZKZEVNKZUBDELZABLZVQDMJEMJA
      BDEMUEFGUCVOVPVRVQVOVPVRUDZHNODUFJZPQZIUGZAJZHUGWBUHQZRQZIUIZUJZHNOEUFJZP
      QZWBBJZWDRQZIUIZUJZDEVSHNWFWLVSWAWIWEWKIVSVTWHOPVSAUKZNOULUMZUNZSTUOZBUKZ
      WOUNZSTUOZVTWHVSSWPWSTVSWNWRWOVSABVOVPVRUPUSUQURVOVPVTWQLVRACDFUTVAVPVOWH
      WTLVRBCEGUTVIVBVCVSWBWAKZUBZWCWJWDRXBWBABVOVPVRXAVDVEVFVGVJVOVPDWGLVRHACI
      DVTFVTVHVKVAVPVOEWMLVRHBCIEWHGWHVHVKVIVBVLVM $.

    coemulhi.3 $e |- M = ( deg ` F ) $.
    coemulhi.4 $e |- N = ( deg ` G ) $.
    $( The leading coefficient of a product of polynomials.  (Contributed by
       Mario Carneiro, 24-Jul-2014.) $)
    coemulhi $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
    ( ( coeff ` ( F oF x. G ) ) ` ( M + N ) ) = ( ( A ` M ) x. ( B ` N ) ) ) $=
      ( vk cfv wcel co cmul cc0 cn0 wceq cc cply wa caddc cof ccoe cfz cmin csu
      cv csn cdgr dgrcl syl5eqel nn0addcl syl2an coemul mpd3an3 cle wbr nn0ge0d
      adantl adantr nn0red addge01d mpbid cz nn0uz syl6eleq nn0zd elfz5 syl2anc
      cuz wb mpbird snssd elsni fveq2 oveq2 fveq2d oveq12d recnd pncan2d oveq2d
      syl wf coef3 ffvelrnd mulcld eqeltrd wn wne wi simpl eldifi elfznn0 dgrub
      cdif 3expia necon1bd imp oveq1d ad2antrr ad2antlr fznn0sub mul02d leadd1d
      eqtrd cr lesubadd2d bitr4d notbid biimpa simpr syldan wo eldifsni letri3d
      mul01d necon3abid ianor sylib mpjaodan fzfid fsumss sumsn 3eqtr2d ) DCUAM
      ZNZEYGNZUBZFGUCOZDEPUDOUEMMZQYKUFOZLUIZAMZYKYNUGOZBMZPOZLUHZFUJZYRLUHZFAM
      ZGBMZPOZYHYIYKRNZYLYSSYHFRNZGRNZUUEYIYHFDUKMRJCDULUMZYIGEUKMRKCEULUMZFGUN
      UOZABCLDEYKHIUPUQYJYTYMYRLYJFYMYJFYMNZFYKURUSZYJQGURUSUULYJGYIUUGYHUUIVAZ
      UTYJFGYJFYHUUFYIUUHVBZVCZYJGUUMVCZVDVEYJFQVLMZNYKVFNUUKUULVMYJFRUUQUUNVGV
      HYJYKUUJVIFQYKVJVKVNVOYJYNYTNZUBZYRUUBYKFUGOZBMZPOZTUUSYNFSZYRUVBSUURUVCY
      JYNFVPVAUVCYOUUBYQUVAPYNFAVQUVCYPUUTBYNFYKUGVRVSVTZWDYJUVBTNZUURYJUVBUUDT
      YJUVAUUCUUBPYJUUTGBYJFGYJFUUOWAYJGUUPWAWBVSWCZYJUUBUUCYJRTFAYHRTAWEZYIACD
      HWFVBZUUNWGYJRTGBYIRTBWEZYHBCEIWFVAZUUMWGWHWIZVBWIYJYNYMYTWQNZUBZYNFURUSZ
      WJZYRQSFYNURUSZWJZUVMUVOUBZYRQYQPOQUVRYOQYQPUVMUVOYOQSUVMUVNYOQYJYHYNRNZY
      OQWKZUVNWLUVLYHYIWMUVLYNYMNZUVSYNYMYTWNZYNYKWOZWDZYHUVSUVTUVNACDYNFHJWPWR
      UOWSWTXAUVRYQUVRRTYPBYJUVIUVLUVOUVJXBUVRUWAYPRNZUVLUWAYJUVOUWBXCYNQYKXDZW
      DWGXEXGUVMUVQUBZYRYOQPOQUWGYQQYOPUVMUVQYPGURUSZWJZYQQSZUVMUVQUWIUVMUVPUWH
      UVMUVPYKYNGUCOURUSUWHUVMFYNGYJFXHNUVLUUOVBZUVMYNUVMUWAUVSUVLUWAYJUWBVAUWC
      WDVCZYJGXHNUVLUUPVBZXFUVMYKYNGUVMYKYJUUEUVLUUJVBVCUWLUWMXIXJXKXLUVMUWIUWJ
      UVMUWHYQQYJYIUWEYQQWKZUWHWLUVLYHYIXMUVLUWAUWEUWBUWFWDYIUWEUWNUWHBCEYPGIKW
      PWRUOWSWTXNWCUWGYOUWGRTYNAYJUVGUVLUVQUVHXBUVLUVSYJUVQUWDXCWGXRXGUVMUVNUVP
      UBZWJZUVOUVQXOUVMYNFWKZUWPUVLUWQYJYNYMFXPVAUVMUWOYNFUVMYNFUWLUWKXQXSVEUVN
      UVPXTYAYBYJQYKYCYDYJUUAUVBUUDYJUUFUVEUUAUVBSUUNUVKYRUVBLFRUVDYEVKUVFXGYF
      $.
  $}

  ${
    $d k n A $.  $d k n F $.  $d k n S $.
    $( The coefficient function is linear under scalar multiplication.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    coemulc $p |- ( ( A e. CC /\ F e. ( Poly ` S ) ) ->
                    ( coeff ` ( ( CC X. { A } ) oF x. F ) ) =
                    ( ( NN0 X. { A } ) oF x. ( coeff ` F ) ) ) $=
      ( vk cc wcel cfv wa cn0 cmul co ccoe wf wfn eqid cvv syl adantl cc0 wceq
      vn cply csn cxp cof ssid plyconst mpan plyssc sseli plymulcl syl2an coef3
      wss ffn 3syl fconstg adantr nn0ex a1i offn cv cmin ad2antrr coefv0 simpll
      inidm 0cn fvconst2g sylancl eqtr3d nn0cnd subid1d fveq2d oveq12d ad2antlr
      simpr cfz csu coemul syl3anc cuz nn0uz syl6eleq fzss2 elfz1eq fveq2 oveq2
      ffvelrnda mulcld eqeltrd cdif wn eldifn wne cdgr cle wbr wi elfznn0 dgrub
      eldifi 3expia 0dgr ad3antrrr breq2d wb nn0le0eq0 bitrd sylibd id cz elfz3
      0z ax-mp syl6eqel necon1bd mpd oveq1d fznn0sub ffvelrn mul02d eqtrd fzfid
      syl6 fsumss fsum1 sylancr 3eqtr2d simpl eqidd ofc1 3eqtr4d eqfnfvd ) AEFZ
      CBUBGZFZHZUAIEAUCZUDZCJUEZKZLGZIYSUDZCLGZUUAKZYRUUBEUBGZFZIEUUCMUUCINYOYT
      UUGFZCUUGFZUUHYQEEUNYOUUIEUFAEUGUHZYPUUGCBUIUJZEYTCUKULUUCEUUBUUCOUMIEUUC
      UOUPYRIIJIUUDUUEPPYRIYSUUDMZUUDINYOUUMYQIAEUQURIYSUUDUOQYRIEUUEMZUUEINYQU
      UNYOUUEBCUUEOZUMRZIEUUEUOQZIPFYRUSUTZUURIVGVAYRUAVBZIFZHZSYTLGZGZUUSSVCKZ
      UUEGZJKZAUUSUUEGZJKZUUSUUCGZUUSUUFGUVAUVCAUVEUVGJUVASYTGZUVCAUVAUUIUVJUVC
      TYOUUIYQUUTUUKVDZUVBEYTUVBOZVEQUVAYOSEFUVJATYOYQUUTVFZVHEASEVIVJVKUVAUVDU
      USUUEUVAUUSUVAUUSYRUUTVQZVLVMVNVOZUVAUVISUUSVRKZDVBZUVBGZUUSUVQVCKZUUEGZJ
      KZDVSZSSVRKZUWADVSZUVFUVAUUIUUJUUTUVIUWBTUVKYQUUJYOUUTUULVPUVNUVBUUEEDYTC
      UUSUVLUUOVTWAUVAUWCUVPUWADUVAUUSSWBGZFUWCUVPUNUVAUUSIUWEUVNWCWDSSUUSWEQUV
      AUVQUWCFZHZUWAUVFEUWGUVQSTZUWAUVFTUWFUWHUVAUVQSWFRUWHUVRUVCUVTUVEJUVQSUVB
      WGUWHUVSUVDUUEUVQSUUSVCWHVNVOZQUVAUVFEFZUWFUVAUVFUVHEUVOUVAAUVGUVMYRIEUUS
      UUEUUPWIWJWKZURWKUVAUVQUVPUWCWLFZHZUWASUVTJKSUWMUVRSUVTJUWMUWFWMZUVRSTUWL
      UWNUVAUVQUVPUWCWNRUWMUWFUVRSUWMUVRSWOZUWHUWFUWMUWOUVQYTWPGZWQWRZUWHUVAUUI
      UVQIFZUWOUWQWSUWLUVKUWLUVQUVPFZUWRUVQUVPUWCXBZUVQUUSWTQZUUIUWRUWOUWQUVBEY
      TUVQUWPUVLUWPOXAXCULUWMUWQUVQSWQWRZUWHUWMUWPSUVQWQYOUWPSTYQUUTUWLAXDXEXFU
      WMUWRUXBUWHXGUWLUWRUVAUXARUVQXHQXIXJUWHUVQSUWCUWHXKSXLFZSUWCFXNSXMXOXPYEX
      QXRXSUWMUVTUVAUUNUVSIFZUVTEFUWLYRUUNUUTUUPURUWLUWSUXDUWTUVQSUUSXTQIEUVSUU
      EYAULYBYCUVASUUSYDYFUVAUXCUWJUWDUVFTXNUWKUWAUVFDSUWIYGYHYIYRIAUVGJUUEPEUU
      SUURYOYQYJUUQUVAUVGYKYLYMYN $.

    $( The coefficients of the zero polynomial are zero.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    coe0 $p |- ( coeff ` 0p ) = ( NN0 X. { 0 } ) $=
      ( vx c0p ccoe cfv cn0 cc0 csn cxp wceq wtru cc cmul cof wcel a1i cvv mp1i
      co wf caofid2 cply 0cn ssid ply0 ax-mp coemulc sylancl cnex plyf cv mul02
      wss adantl df-0p syl6eqr fveq2d nn0ex eqid coef3 3eqtr3d trud ) BCDZEFGZH
      ZIJKVCHZBLMZRZCDZVDVBVFRZVBVDJFKNZBKUADNZVHVIIVJJUBOZKKULVKKUCKUDUEZFKBUF
      UGJVGBCJVGVEBJAKFFLKBPKKKPNJUHOVKKKBSJVMKBUIQVLVLAUJZKNFVNLRFIJVNUKUMZTUN
      UOUPJAEFFLKVBPKKEPNJUQOVKEKVBSJVMVBKBVBURUSQVLVLVOTUTVA $.

    coesub.1 $e |- A = ( coeff ` F ) $.
    coesub.2 $e |- B = ( coeff ` G ) $.
    $( The coefficient function of a sum is the sum of coefficients.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    coesub $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
      ( coeff ` ( F oF - G ) ) = ( A oF - B ) ) $=
      ( cply cfv wcel cc cxp cof co ccoe cn0 wceq sseldi cvv wf wa c1 cneg cmul
      csn caddc cmin plyssc simpl wss ssid neg1cn plyconst mp2an simpr plymulcl
      sylancr eqid coeadd syl2anc coemulc oveq2i syl6eqr oveq2d eqtrd cnex plyf
      a1i adantr adantl ofnegsub syl3anc fveq2d nn0ex coef3 3eqtr3d ) DCHIZJZEV
      QJZUAZDKUBUCZUEZLZEUDMZNZUFMZNZOIZAPWBLZBWDNZWFNZDEUGMZNZOIABWLNZVTWHAWEO
      IZWFNZWKVTDKHIZJWEWQJZWHWPQVTVQWQDCUHZVRVSUIRVTWCWQJZEWQJZWRKKUJWAKJZWTKU
      KULWAKUMUNVTVQWQEWSVRVSUORZKWCEUPUQAWOKDWEFWOURUSUTVTWOWJAWFVTWOWIEOIZWDN
      ZWJVTXBXAWOXEQULXCWAKEVAUQBXDWIWDGVBVCVDVEVTWGWMOVTKSJZKKDTZKKETZWGWMQXFV
      TVFVHVRXGVSCDVGVIVSXHVRCEVGVJKDESVKVLVMVTPSJZPKATZPKBTZWKWNQXIVTVNVHVRXJV
      SACDFVOVIVSXKVRBCEGVOVJPABSVKVLVP $.
  $}

  ${
    $d k n z A $.  $d n M $.  $d k n z N $.
    coe1term.1 $e |- F = ( z e. CC |-> ( A x. ( z ^ N ) ) ) $.
    $( The coefficient function of a monomial.  (Contributed by Mario Carneiro,
       26-Jul-2014.)  (Revised by Mario Carneiro, 23-Aug-2014.) $)
    coe1termlem $p |- ( ( A e. CC /\ N e. NN0 ) ->
      ( ( coeff ` F ) = ( n e. NN0 |-> if ( n = N , A , 0 ) ) /\
        ( A =/= 0 -> ( deg ` F ) = N ) ) ) $=
      ( vk cc wcel cn0 wa cfv cv wceq cc0 cmpt wne adantr co cle ccoe cdgr cply
      cif wi wss ssid ply1term mp3an1 simpr simpl ifcl sylancl eqid fmptd caddc
      0cn c1 cuz cima csn wral eqeq1 ifbid fvmptg syl2anc neeq1d nn0re ad2antlr
      wbr leidd necon1ai breq1d syl5ibrcom sylbid ralrimiva wf wb plyco0 mpbird
      iffalse cfz cexp cmul ply1termlem elfznn0 oveq1d sylan2 sumeq2dv mpteq2dv
      csu eqtr4d coeeq iftrue ancoms biimpar dgreq ex jca ) BHIZEJIZKZDUALCJCMZ
      ENZBOUDZPZNBOQZDUBLENZUEXBAXFHGDEHHUFWTXADHUCLIZHUGABHDEFUHUIZWTXAUJZXBCJ
      XEHXFXBXEHIZXCJIXBWTOHIZXLWTXAUKZUQXDBOHULUMRXFUNZUOZXBXFEURUPSUSLUTOVANZ
      GMZXFLZOQZXRETVJZUEZGJVBZXBYBGJXBXRJIZKZXTXRENZBOUDZOQZYAYEXSYGOYEYDYGHIZ
      XSYGNXBYDUJXBYIYDXBWTXMYIXNUQYFBOHULUMRCXRXEYGJHXFXCXRNXDYFBOXCXREVCVDXOV
      EVFZVGYEYAYHEETVJZXAYKWTYDXAEEVHVKVIYHXREETYFYGOYFBOWAVLVMVNVOVPXBXAJHXFV
      QZXQYCVRXKXPXFGEVSVFVTZXBDAHOEWBSZYGAMXRWCSZWDSZGWKZPAHYNXSYOWDSZGWKZPZAB
      GDEFWEXBAHYSYQXBYNYRYPGXRYNIXBYDYRYPNXREWFYEXSYGYOWDYJWGWHWIWJWLZWMXBXGXH
      XBXGKAXFHGDEXBXIXGXJRXBXAXGXKRXBYLXGXPRXBXQXGYMRXBDYTNXGUUARXBEXFLZOQXGXB
      UUBBOXAWTUUBBNCEXEBJHXFXDBOWNXOVEWOVGWPWQWRWS $.

    $( The coefficient function of a monomial.  (Contributed by Mario Carneiro,
       26-Jul-2014.) $)
    coe1term $p |- ( ( A e. CC /\ N e. NN0 /\ M e. NN0 ) ->
                     ( ( coeff ` F ) ` M ) = if ( M = N , A , 0 ) ) $=
      ( vn cc wcel cn0 w3a ccoe cfv cv wceq cc0 cif cmpt wa wne cdgr wi 3adant3
      coe1termlem simpld fveq1d simp3 simp1 0cn ifcl sylancl eqeq1 ifbid fvmptg
      eqid syl2anc eqtrd ) BHIZEJIZDJIZKZDCLMZMZDGJGNZEOZBPQZRZMZDEOZBPQZURUSVC
      VHOUTURUSSZDVBVGVKVBVGOBPTCUAMEOUBABGCEFUDUEUFUCVAUTVJHIZVHVJOURUSUTUGVAU
      RPHIVLURUSUTUHUIVIBPHUJUKGDVFVJJHVGVDDOVEVIBPVDDEULUMVGUOUNUPUQ $.

    $( The degree of a monomial.  (Contributed by Mario Carneiro,
       26-Jul-2014.) $)
    dgr1term $p |- ( ( A e. CC /\ A =/= 0 /\ N e. NN0 ) ->
                     ( deg ` F ) = N ) $=
      ( vn cc wcel cn0 cc0 wne cdgr cfv wceq wa ccoe cv cif cmpt wi coe1termlem
      simprd 3impia 3com23 ) BGHZDIHZBJKZCLMDNZUEUFUGUHUEUFOCPMFIFQDNBJRSNUGUHT
      ABFCDEUAUBUCUD $.
  $}

  ${
    $d k z A $.  $d k z F $.  $d k z N $.  $d k z S $.
    $( A polynomial is a continuous function.  (Contributed by Mario Carneiro,
       23-Jul-2014.) $)
    plycn $p |- ( F e. ( Poly ` S ) -> F e. ( CC -cn-> CC ) ) $=
      ( vz vk cply cfv wcel ccnfld ctopn ccn co cc ccncf cc0 cmul cmpt eqid a1i
      cv cn0 cdgr cfz ccoe cexp csu coeid ctopon cnfldtopon fzfid wa wf elfznn0
      coef3 ffvelrn syl2an cnmptc adantl expcn syl ctx cnmpt12f eqeltrd cncfcn1
      mulcn fsumcn syl6eleqr ) BAEFGZBHIFZVHJKZLLMKVGBCLNBUAFZUBKZDSZBUCFZFZCSV
      LUDKZOKZDUEPVICVMADBVJVMQZVJQUFVGCVKVPDVHVHLVHQZVHLUGFGZVGVHVRUHZRVGNVJUI
      VGVLVKGZUJZCVNVOOVHVHVHVHLVSWBVTRZWBCVNVHVHLLWCWCVGTLVMUKVLTGZVNLGWAVMABV
      QUMVLVJULZTLVLVMUNUOUPWBWDCLVOPVIGWAWDVGWEUQCVHVLVRURUSOVHVHUTKVHJKGWBVHV
      RVDRVAVEVBVHVRVCVF $.

    $( The degree of the zero polynomial is zero.  Note: this differs from some
       other definitions of the degree of the zero polynomial, such as
       ` -u 1 , -oo ` or undefined.  But it is convenient for us to define it
       this way, so that we have ~ dgrcl , ~ dgreq0 and ~ coeid without having
       to special-case zero, although ~ plydivalg is a little more complicated
       as a result.  (Contributed by Mario Carneiro, 22-Jul-2014.) $)
    dgr0 $p |- ( deg ` 0p ) = 0 $=
      ( c0p cdgr cfv cc cc0 csn cxp df-0p fveq2i wcel wceq 0cn 0dgr ax-mp eqtri
      ) ABCDEFGZBCZEAPBHIEDJQEKLEMNO $.

    $( The coefficients of the identity function.  (Contributed by Mario
       Carneiro, 28-Jul-2014.) $)
    coeidp $p |- ( A e. NN0 ->
      ( ( coeff ` Xp ) ` A ) = if ( A = 1 , 1 , 0 ) ) $=
      ( vz c1 cc wcel cn0 cidp ccoe cfv wceq cc0 cif ax-1cn 1nn0 cv cmpt cid co
      cres cmul cexp mptresid exp1 oveq2d mulid2 eqtrd mpteq2ia df-idp 3eqtr4ri
      coe1term mp3an12 ) CDECFEAFEAGHIIACJCKLJMNBCGACBDBOZPQDSBDCULCUARZTRZPGBD
      UBBDUNULULDEZUNCULTRULUOUMULCTULUCUDULUEUFUGUHUIUJUK $.

    $( The degree of the identity function.  (Contributed by Mario Carneiro,
       26-Jul-2014.) $)
    dgrid $p |- ( deg ` Xp ) = 1 $=
      ( vz c1 cc wcel cc0 wne cn0 cidp cdgr cfv wceq ax-1cn ax-1ne0 1nn0 cv cid
      cmpt cres co cmul mptresid oveq2d mulid2 eqtrd mpteq2ia 3eqtr4ri dgr1term
      cexp exp1 df-idp mp3an ) BCDBEFBGDHIJBKLMNABHBACAOZQPCRACBULBUHSZTSZQHACU
      AACUNULULCDZUNBULTSULUOUMULBTULUIUBULUCUDUEUJUFUGUK $.

    dgreq0.1 $e |- N = ( deg ` F ) $.
    dgreq0.2 $e |- A = ( coeff ` F ) $.
    $( The leading coefficient of a polynomial is nonzero, unless the entire
       polynomial is zero.  (Contributed by Mario Carneiro, 22-Jul-2014.)
       (Proof shortened by Fan Zheng, 21-Jun-2016.) $)
    dgreq0 $p |- ( F e. ( Poly ` S ) -> ( F = 0p <-> ( A ` N ) = 0 ) ) $=
      ( vk cfv wcel c0p wceq cc0 cn0 cxp ccoe fveq2 syl6eq wa cc wbr csn syl5eq
      cply coe0 cdgr dgr0 fveq12d 0nn0 fvconst2g mp2an coefv0 adantr cn wn cmin
      c1 co clt simpr nnred ltm1d cle caddc cuz simpll nnm1nn0 adantl cv wne wi
      cima wral dgrub 3expia ad2ant2rl simplr eqeq1d syl5ibcom necon3d cr nn0re
      jcad ad2antll nnre ad2antrl ltlend nn0z nnz zltlem1 syl2anc bitr3d sylibd
      cz wb expr ralrimiv wf coef3 ad2antrr plyco0 mpbird syl3anc peano2rem syl
      dgrlb lenltd mpbid pm2.65da wo dgrcl syl5eqel elnn0 sylib ord mpd 3eqtr2d
      fveq2d sneqd xpeq2d syl5eqr 0dgrb df-0p a1i 3eqtr4d ex impbid2 ) CBUCHIZC
      JKZDAHZLKZYHYILMLUAZNZHZLYHDLAYLYHAJOHZYLYHACOHYNFCJOPUBUDQYHDJUEHZLYHDCU
      EHZYOECJUEPUBUFQUGLMIZYQYMLKUHUHMLLMUIUJQYGYJYHYGYJRZSLCHZUAZNZSYKNZCJYRY
      TYKSYRYSLYRYSLAHZYILYGYSUUCKYJABCFUKULYRDLAYRDUMIZUNDLKZYRUUDDUPUOUQZDURT
      ZYRUUDRZDUUHDYRUUDUSUTVAUUHDUUFVBTZUUGUNUUHYGUUFMIZAUUFUPVCUQVDHVKYKKZUUI
      YGYJUUDVEUUDUUJYRDVFVGZUUHUUKGVHZAHZLVIZUUMUUFVBTZVJZGMVLZUUHUUQGMYRUUDUU
      MMIZUUQYRUUDUUSRZRZUUOUUMDVBTZDUUMVIZRZUUPUVAUUOUVBUVCYGUUSUUOUVBVJYJUUDY
      GUUSUUOUVBABCUUMDFEVMVNVOUVADUUMUUNLUVAYJDUUMKZUUNLKYGYJUUTVPUVEYIUUNLDUU
      MAPVQVRVSWBUVAUUMDURTZUVDUUPUVAUUMDUUSUUMVTIYRUUDUUMWAWCUUDDVTIZYRUUSDWDZ
      WEWFUVAUUMWMIZDWMIZUVFUUPWNUUSUVIYRUUDUUMWGWCUUDUVJYRUUSDWHWEUUMDWIWJWKWL
      WOWPUUHUUJMSAWQZUUKUURWNUULYGUVKYJUUDABCFWRWSAGUUFWTWJXAABCUUFDFEXEXBUUHD
      UUFUUDUVGYRUVHVGZUUHUVGUUFVTIUVLDXCXDXFXGXHYRUUDUUEYRDMIZUUDUUEXIYGUVMYJY
      GDYPMEBCXJXKULDXLXMXNXOZXQYGYJUSXPXRXSYRYPLKZCUUAKZYRYPDLEUVNXTYGUVOUVPWN
      YJBCYAULXGJUUBKYRYBYCYDYEYF $.

    $( Two ways to say that the degree of ` F ` is strictly less than ` N ` .
       (Contributed by Mario Carneiro, 25-Jul-2014.) $)
    dgrlt $p |- ( ( F e. ( Poly ` S ) /\ M e. NN0 ) ->
      ( ( F = 0p \/ N < M ) <-> ( N <_ M /\ ( A ` M ) = 0 ) ) ) $=
      ( cfv wcel cn0 wa c0p wceq wbr wo cle cc0 cdgr ccoe wb cply fveq2d eqcomi
      clt simpr dgr0 3eqtr4g nn0ge0 ad2antlr eqbrtrd csn cxp coe0 c0ex fvconst2
      fveq1d eqtrd jca cr wi dgrcl syl5eqel nn0red nn0re ltle syl2an imp wne wn
      dgrub 3expia lenlt syl2anr sylibd necon4ad jaodan biimpa adantrr ad2antrr
      leloe fveq2 dgreq0 simprr eqeq2d bitr4d syl5ibr orim2d mpd orcomd impbida
      ) CBUAHIZDJIZKZCLMZEDUDNZOEDPNZDAHZQMZKZWMWNWSWOWMWNKZWPWRWTEQDPWTCRHZLRH
      ZEQWTCLRWMWNUEZUBFXBQUFUCUGWLQDPNWKWNDUHUIUJWTWQDJQUKULZHZQWTDAXDWTCSHLSH
      ZAXDWTCLSXCUBGXFXDUMUCUGUPWLXEQMWKWNJQDUNUOUIUQURWMWOKWPWRWMWOWPWKEUSIZDU
      SIZWOWPUTWLWKEWKEXAJFBCVAVBVCZDVDZEDVEVFVGWMWOWRWMWOWQQWMWQQVHZDEPNZWOVIZ
      WKWLXKXLABCDEGFVJVKWLXHXGXLXMTWKXJXIDEVLVMVNVOVGURVPWMWSKZWOWNXNWOEDMZOZW
      OWNOWMWPXPWRWMWPXPWKXGXHWPXPTWLXIXJEDVTVFVQVRXNXOWNWOXOWNXNEAHZWQMZEDAWAX
      NWNXQQMZXRWKWNXSTWLWSABCEFGWBVSXNWQQXQWMWPWRWCWDWEWFWGWHWIWJ $.
  $}

  ${
    $d k n F $.  $d k n G $.  $d k M $.  $d k n N $.  $d k n S $.
    dgradd.1 $e |- M = ( deg ` F ) $.
    dgradd.2 $e |- N = ( deg ` G ) $.
    $( The degree of a sum of polynomials is at most the maximum of the
       degrees.  (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    dgradd $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
                   ( deg ` ( F oF + G ) ) <_ if ( M <_ N , N , M ) ) $=
      ( cply cfv wcel wa caddc cof co ccoe wceq cdgr cle wbr eqid cif coeaddlem
      simprd ) BAHIZJCUDJKBCLMZNZOIBOIZCOIZUENPUFQIDERSEDUARSUGUHABCDEUGTUHTFGU
      BUC $.

    $( The degree of a sum of polynomials of unequal degrees is the degree of
       the larger polynomial.  (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    dgradd2 $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ M < N ) ->
                    ( deg ` ( F oF + G ) ) = N ) $=
      ( cfv wcel wbr caddc cdgr wceq cle cc cn0 cr cc0 wne eqid cply clt w3a co
      cof cif plyaddcl 3adant3 dgrcl syl nn0red syl5eqel 3ad2ant2 3ad2ant1 ifcl
      syl2anc dgradd leidd simp3 ltled breq1 ifboth letrd ccoe coeadd fveq1d wf
      cvv wfn coef3 ffn nn0ex a1i inidm wn ltnled mpbid wi simp1 dgrub necon1bd
      3expia mpd adantr eqidd ofval mpdan ffvelrnd addid2d 3eqtrd simp2 nn0ge0d
      wa 0re lelttrd gt0ne0d c0p dgreq0 fveq2 dgr0 3eqtr4g syl6bir necon3d sylc
      eqcomi eqnetrd syl3anc letri3d mpbir2and ) BAUAHZIZCXJIZDEUBJZUCZBCKUEZUD
      ZLHZEMXQENJEXQNJZXNXQDENJZEDUFZEXNXQXNXPOUAHIZXQPIXKXLYAXMABCUGUHZOXPUIUJ
      UKZXNEQIDQIXTQIXNEXLXKEPIZXMXLECLHZPGACUIULUMZUKZXNDXKXLDPIXMXKDBLHPFABUI
      ULUNZUKZXSEDQUOUPYGXKXLXQXTNJXMABCDEFGUQUHXNEENJZXSXTENJZXNEYGURXNDEYIYGX
      KXLXMUSZUTXSYJXSYKEDEXTENVADXTENVAVBUPVCXNYAYDEXPVDHZHZRSXRYBYFXNYNECVDHZ
      HZRXNYNEBVDHZYOXOUDZHZRYPKUDZYPXNEYMYRXKXLYMYRMXMYQYOABCYQTZYOTZVEUHVFXNY
      DYSYTMYFXNPPRYPKPYQYOVHVHEXNPOYQVGZYQPVIXKXLUUCXMYQABUUAVJUNPOYQVKUJXNPOY
      OVGZYOPVIXLXKUUDXMYOACUUBVJUMZPOYOVKUJPVHIXNVLVMZUUFPVNXNEYQHZRMZYDXNEDNJ
      ZVOZUUHXNXMUUJYLXNDEYIYGVPVQXNUUIUUGRXNXKYDUUGRSZUUIVRXKXLXMVSYFXKYDUUKUU
      IYQABEDUUAFVTWBUPWAWCWDXNYDWMYPWEWFWGXNYPXNPOEYOUUEYFWHWIWJXNXLERSYPRSXKX
      LXMWKXNEXNRDERQIXNWNVMYIYGXNDYHWLYLWOWPXLYPRERXLYPRMCWQMZERMYOACEGUUBWRUU
      LYEWQLHZERCWQLWSGUUMRWTXEXAXBXCXDXFYMOXPEXQYMTXQTVTXGXNXQEYCYGXHXI $.

    $( The degree of a product of polynomials is at most the sum of degrees.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    dgrmul2 $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
                    ( deg ` ( F oF x. G ) ) <_ ( M + N ) ) $=
      ( vn vk cply cfv wcel wa cmul cof co ccoe cn0 cv eqid cmin cmpt wceq cdgr
      cc0 cfz csu caddc cle wbr coemullem simprd ) BAJKZLCUMLMBCNOPZQKHRUEHSZUF
      PISZBQKZKUOUPUAPCQKZKNPIUGUBUCUNUDKDEUHPUIUJUQURAIHBCDEUQTURTFGUKUL $.

    $( The degree of a product of nonzero polynomials is the sum of degrees.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    dgrmul $p |- ( ( ( F e. ( Poly ` S ) /\ F =/= 0p ) /\
                     ( G e. ( Poly ` S ) /\ G =/= 0p ) ) ->
                   ( deg ` ( F oF x. G ) ) = ( M + N ) ) $=
      ( cfv wcel c0p wne wa co cdgr ad2ant2r cc cn0 ccoe cc0 eqid cply cmul cof
      caddc cle wbr dgrmul2 plymulcl dgrcl syl5eqel ad2antrr ad2antrl nn0addcld
      coemulhi wf coef3 ffvelrnd dgreq0 necon3bid biimpa adantr mulne0d eqnetrd
      wceq adantl dgrub syl3anc syl nn0red letri3d mpbir2and ) BAUAHZIZBJKZLZCV
      LIZCJKZLZLZBCUBUCMZNHZDEUDMZVDWAWBUEUFZWBWAUEUFZVMVPWCVNVQABCDEFGUGOVSVTP
      UAHIZWBQIWBVTRHZHZSKWDVMVPWEVNVQABCUHOZVSDEVMDQIVNVRVMDBNHQFABUIUJUKZVPEQ
      IVOVQVPECNHQGACUIUJULZUMZVSWGDBRHZHZECRHZHZUBMZSVMVPWGWPVDVNVQWLWNABCDEWL
      TZWNTZFGUNOVSWMWOVSQPDWLVMQPWLUOVNVRWLABWQUPUKWIUQVSQPEWNVPQPWNUOVOVQWNAC
      WRUPULWJUQVOWMSKZVRVMVNWSVMBJWMSWLABDFWQURUSUTVAVRWOSKZVOVPVQWTVPCJWOSWNA
      CEGWRURUSUTVEVBVCWFPVTWBWAWFTWATVFVGVSWAWBVSWAVSWEWAQIWHPVTUIVHVIVSWBWKVI
      VJVK $.
  $}

  ${
    $d x A $.  $d x F $.  $d x S $.
    $( Scalar multiplication by a nonzero constant does not change the degree
       of a function.  (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    dgrmulc $p |- ( ( A e. CC /\ A =/= 0 /\ F e. ( Poly ` S ) ) ->
                    ( deg ` ( ( CC X. { A } ) oF x. F ) ) = ( deg ` F ) ) $=
      ( cc wcel cc0 wne cply cfv csn cxp cmul co cdgr wceq c0p fveq2d caddc 0cn
      dgr0 w3a cof oveq2 fveq2 syl6eq eqeq12d wa ssid simpl1 plyconst fvconst2g
      wss sylancr sylancl simpl2 eqnetrd ne0p plyssc simpl3 sseldi simpr dgrmul
      eqid syl22anc 0dgr syl oveq1d cn0 dgrcl nn0cnd addid2d cvv cnex a1i simp1
      3eqtrd ofc12 mul01d sneqd xpeq2d eqtrd df-0p oveq2i 3eqtr4g pm2.61ne ) AD
      EZAFGZCBHIZEZUAZDAJKZCLUBZMZNIZCNIZOWKPWLMZNIZFOCPCPOZWNWQWOFWRWMWPNCPWKW
      LUCQWRWOPNIZFCPNUDTUEUFWJCPGZUGZWNWKNIZWORMZFWORMWOXAWKDHIZEZWKPGZCXDEWTW
      NXCOXADDULWFXEDUHWFWGWIWTUIZADUJUMXAFDEZFWKIZFGXFSXAXIAFXAWFXHXIAOXGSDAFD
      UKUNWFWGWIWTUOUPFWKUQUMXAWHXDCBURWFWGWIWTUSZUTWJWTVADWKCXBWOXBVCWOVCVBVDX
      AXBFWORXAWFXBFOXGAVEVFVGXAWOXAWOXAWIWOVHEXJBCVIVFVJVKVPWJWQWSFWJWPPNWJWKD
      FJZKZWLMZXLWPPWJXMDAFLMZJZKXLWJDAFLVLDDDVLEWJVMVNWFWGWIVOZXHWJSVNVQWJXOXK
      DWJXNFWJAXPVRVSVTWAPXLWKWLWBWCWBWDQTUEWE $.

    dgrsub.1 $e |- M = ( deg ` F ) $.
    dgrsub.2 $e |- N = ( deg ` G ) $.
    $( The degree of a difference of polynomials is at most the maximum of the
       degrees.  (Contributed by Mario Carneiro, 26-Jul-2014.) $)
    dgrsub $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
                   ( deg ` ( F oF - G ) ) <_ if ( M <_ N , N , M ) ) $=
      ( cply cfv wcel cc c1 cof co cdgr cle wbr cif sseli wceq wa cneg csn cmul
      cxp caddc cmin plyssc wss ssid neg1cn plyconst mp2an plymulcl eqid dgradd
      sylancr syl2an wf plyf cvv cnex ofnegsub mp3an1 fveq2d cc0 ax-1cn ax-1ne0
      wne negne0i dgrmulc mp3an12 syl6eqr adantl breq2d eqidd ifbieq12d 3brtr3d
      ) BAHIZJZCVSJZUAZBKLUBZUCUEZCUDMNZUFMNZOIZDWEOIZPQZWHDRZBCUGMNZOIDEPQZEDR
      PVTBKHIZJWEWMJZWGWJPQWAVSWMBAUHZSWAWDWMJZCWMJWNKKUIWCKJZWPKUJUKWCKULUMVSW
      MCWOSKWDCUNUQKBWEDWHFWHUOUPURWBWFWKOVTKKBUSZKKCUSZWFWKTZWAABUTACUTKVAJWRW
      SWTVBKBCVAVCVDURVEWBWIWLWHDEDWBWHEDPWAWHETVTWAWHCOIZEWQWCVFVIWAWHXATUKLVG
      VHVJWCACVKVLGVMVNZVOXBWBDVPVQVR $.
  $}

  ${
    $d d w x y z G $.  $d x y M $.  $d d y N $.  $d d w x y z ph $.
    dgrcolem1.1 $e |- N = ( deg ` G ) $.
    dgrcolem1.2 $e |- ( ph -> M e. NN ) $.
    dgrcolem1.3 $e |- ( ph -> N e. NN ) $.
    dgrcolem1.4 $e |- ( ph -> G e. ( Poly ` S ) ) $.
    $( The degree of a composition of a monomial with a polynomial.
       (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    dgrcolem1 $p |- ( ph ->
      ( deg ` ( x e. CC |-> ( ( G ` x ) ^ M ) ) ) = ( M x. N ) ) $=
      ( wcel cc cfv cexp co cdgr cmul wceq adantr c0p vy vd vz vw cn cv cmpt wi
      c1 caddc oveq2 mpteq2dv fveq2d oveq1 eqeq12d imbi2d wa cply syl ffvelrnda
      plyf exp1d mpteq2dva feqmptd eqtr4d syl6eqr nncnd mulid2d cof adantlr cn0
      wf nnnn0 adantl expp1d cvv cnex a1i ovex eqidd offval2 nncn ax-1cn oveq2d
      adddird eqtrd wne ccom fmptco wss ssid plypow syl3anc plyssc sseldi addcl
      mulcl plyco eqeltrrd cc0 simpr nnmulcld nnne0d eqnetrd fveq2 dgr0 necon3i
      syl6eq syl5eq eqid dgrmul syl22anc ex expcom a2d nnind mpcom ) EUEKABLBUF
      ZDMZENOZUGZPMZEFQOZRZHABLXSUAUFZNOZUGZPMZYEFQOZRZUHABLXSUINOZUGZPMZUIFQOZ
      RZUHABLXSUBUFZNOZUGZPMZYPFQOZRZUHABLXSYPUIUJOZNOZUGZPMZUUBFQOZRZUHAYDUHUA
      UBEYEUIRZYJYOAUUHYHYMYIYNUUHYGYLPUUHBLYFYKYEUIXSNUKULUMYEUIFQUNUOUPYEYPRZ
      YJUUAAUUIYHYSYIYTUUIYGYRPUUIBLYFYQYEYPXSNUKULUMYEYPFQUNUOUPYEUUBRZYJUUGAU
      UJYHUUEYIUUFUUJYGUUDPUUJBLYFUUCYEUUBXSNUKULUMYEUUBFQUNUOUPYEERZYJYDAUUKYH
      YBYIYCUUKYGYAPUUKBLYFXTYEEXSNUKULUMYEEFQUNUOUPAYMFYNAYMDPMZFAYLDPAYLBLXSU
      GZDABLYKXSAXRLKZUQXSALLXRDADCURMZKZLLDVLJCDVAUSZUTZVBVCABLLDUUQVDZVEUMGVF
      AFAFIVGZVHVEYPUEKZAUUAUUGAUVAUUAUUGUHAUVAUQZUUAUUGUVBUUAUQZUUEYRDQVIOZPMZ
      UUFUVBUUEUVERUUAUVBUUDUVDPUVBUUDBLYQXSQOZUGUVDUVBBLUUCUVFUVBUUNUQZXSYPAUU
      NXSLKUVAUURVJZUVBYPVKKZUUNUVAUVIAYPVMVNZSVOVCUVBBLYQXSQYRDVPVPLLVPKUVBVQV
      RYQVPKUVGXSYPNVSVRUVHUVBYRVTADUUMRUVAUUSSZWAVEUMSUVCUUFYTFUJOZUVEUVBUUFUV
      LRUUAUVBUUFYTYNUJOUVLUVBYPUIFUVAYPLKAYPWBVNUILKZUVBWCVRZAFLKUVAUUTSZWEUVB
      YNFYTUJUVBFUVOVHWDWFSUVCUVEYSFUJOZUVLUVCYRLURMZKZYRTWGZDUVQKZDTWGZUVEUVPR
      UVBUVRUUAUVBUALYEYPNOZUGZDWHYRUVQUVBBUALLXSUWBYQDUWCUVHUVKUVBUWCVTYEXSYPN
      UNWIUVBUCUDLUWCDUVBLLWJZUVMUVIUWCUVQKUWDUVBLWKVRUVNUVJUALYPWLWMUVBUUOUVQD
      CWNAUUPUVAJSWOZUCUFZLKUDUFZLKUQZUWFUWGUJOLKUVBUWFUWGWPVNUWHUWFUWGQOLKUVBU
      WFUWGWQVNWRWSSUVCYSWTWGUVSUVCYSYTWTUVBUUAXAUVBYTWTWGUUAUVBYTUVBYPFAUVAXAA
      FUEKUVAISXBXCSXDYRTYSWTYRTRYSTPMZWTYRTPXEXFXHXGUSUVBUVTUUAUWESUVBUWAUUAAU
      WAUVAAFWTWGUWAAFIXCDTFWTDTRZFUULWTGUWJUULUWIWTDTPXEXFXHXIXGUSSSLYRDYSFYSX
      JGXKXLUUAUVPUVLRUVBYSYTFUJUNVNWFVEVEXMXNXOXPXQ $.
  $}

  ${
    $d f w x y z A $.  $d f w x y z F $.  $d f w x y z M $.  $d d f g h x N $.
    $d f D $.  $d d f g h w x y z G $.  $d d f h w x y z ph $.
    dgrco.1 $e |- M = ( deg ` F ) $.
    dgrco.2 $e |- N = ( deg ` G ) $.
    dgrco.3 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    dgrco.4 $e |- ( ph -> G e. ( Poly ` S ) ) $.
    ${
      dgrco.5 $e |- A = ( coeff ` F ) $.
      dgrco.6 $e |- ( ph -> D e. NN0 ) $.
      dgrco.7 $e |- ( ph -> M = ( D + 1 ) ) $.
      dgrco.8 $e |- ( ph -> A. f e. ( Poly ` CC ) ( ( deg ` f ) <_ D ->
        ( deg ` ( f o. G ) ) = ( ( deg ` f ) x. N ) ) ) $.
      $( Lemma for ~ dgrco .  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
      dgrcolem2 $p |- ( ph -> ( deg ` ( F o. G ) ) = ( M x. N ) ) $=
        ( wcel wceq cc vx vy vz vw cn ccom cdgr cfv cmul co cc0 wa cv cexp cmin
        cmpt caddc cof cply wf syl ffvelrnda syldan cn0 coef3 syl5eqel ffvelrnd
        plyf dgrcl adantr expcld mulcld npcand mpteq2dva cvv a1i subcld offval2
        cnex eqidd feqmptd fveq2 fmptco 3eqtr4rd fveq2d clt plyssc sseldi addcl
        wbr adantl mulcl plyco oveq1 oveq2d ssid eqid ply1term syl3anc eqeltrrd
        wss plysubcl syl2anc c1 nn0p1nn eqeltrd nngt0d syl6eq breq1d syl5ibrcom
        c0p dgr0 idd wo cle ccoe cif dgrsub wne nnne0d wb dgreq0 syl5eq syl6bir
        necon3d mpd dgr1term breqtrd wfn ffn 3eqtrd nn0red mpbid eqtr3d csn cxp
        cr wi fconstmpt simpr ifeq1d ifid coesub fveq1d nn0ex inidm ax-mp ofval
        coe1term iftrue mpdan subidd dgrlt mpbir2and mpjaod ltmul1 syl112anc id
        nnre nngt0 expcl syl2anr oveq12d nn0leltp1 mpbird coeq1 eqeq12d imbi12d
        wral oveq1d rspcv syl3c ax-1cn plypow dgrmulc dgrcolem1 3brtr4d dgradd2
        eqtrd 0cn ffvelrn sylancl nn0cnd mul01d eqtr4d ad2antrr syl5eqr syl6eqr
        0dgr 0dgrb 3eqtr4d elnn0 sylib mpjaodan ) AIUERZFGUFZUGUHZHIUIUJZSIUKSZ
        AUWOULZUWQUATUAUMZGUHZFUHZHBUHZUXBHUNUJZUIUJZUOUJZUPZUATUXFUPZUQURUJZUG
        UHZUXIUGUHZUWRAUWQUXKSUWOAUWPUXJUGAUATUXGUXFUQUJZUPUATUXCUPUXJUWPAUATUX
        MUXCAUXATRZULZUXCUXFAUXNUXBTRUXCTRATTUXAGAGDUSUHZRZTTGUTZMDGVHVAZVBZATT
        UXBFAFUXPRZTTFUTLDFVHVAZVBVCZUXOUXDUXEAUXDTRZUXNAVDTHBAUYAVDTBUTZLBDFNV
        EVAZAHFUGUHZVDJAUYAUYGVDRLDFVIVAVFZVGZVJZUXOUXBHUXTAHVDRZUXNUYHVJVKZVLZ
        VMVNAUATUXGUXFUQUXHUXIVOTTTVORAVSVPZUXOUXCUXFUYCUYMVQUYMAUXHVTAUXIVTZVR
        AUAUBTTUXBUBUMZFUHZUXCGFUXTAUATTGUXSWAZAUBTTFUYBWAZUYPUXBFWBZWCZWDWEVJU
        WTUXHTUSUHZRZUXIVUBRZUXHUGUHZUXLWFWJUXKUXLSAVUCUWOAUWPUXIUOURZUJZUXHVUB
        AUATUXCUXFUOUWPUXIVOTTUYNUYCUYMVUAUYOVRAUWPVUBRVUDVUGVUBRAUCUDTFGAUXPVU
        BFDWGZLWHZAUXPVUBGVUHMWHZUCUMZTRUDUMZTRULZVUKVULUQUJTRAVUKVULWIWKZVUMVU
        KVULUIUJTRAVUKVULWLWKZWMAUBTUXDUYPHUNUJZUIUJZUPZGUFUXIVUBAUAUBTTUXBVUQU
        XFGVURUXTUYRAVURVTZUYPUXBSZVUPUXEUXDUIUYPUXBHUNWNZWOZWCAUCUDTVURGATTXAZ
        UYDUYKVURVUBRZVVCATWPVPZUYIUYHUBUXDTVURHVURWQZWRWSZVUJVUNVUOWMWTZTUWPUX
        IXBXCWTVJAVUDUWOVVHVJUWTFVURVUFUJZUGUHZIUIUJZUWRVUEUXLWFUWTVVJHWFWJZVVK
        UWRWFWJZAVVLUWOAVVIXKSZVVLVVLAVVLVVNUKHWFWJAHAHCXDUQUJZUEPACVDRZVVOUERO
        CXEVAXFZXGVVNVVJUKHWFVVNVVJXKUGUHZUKVVIXKUGWBXLXHXIXJAVVLXMAVVNVVLXNZVV
        JHXOWJZHVVIXPUHZUHZUKSZAVVJHVURUGUHZXOWJZVWDHXQZHXOAFVUBRZVVDVVJVWFXOWJ
        VUIVVGTFVURHVWDJVWDWQXRXCAVWFVWEHHXQHAVWEVWDHHAUYDUXDUKXSZUYKVWDHSUYIAH
        UKXSVWHAHVVQXTAUXDUKHUKAUXDUKSZFXKSZHUKSAUYAVWJVWIYALBDFHJNYBVAVWJHUYGU
        KJVWJUYGVVRUKFXKUGWBXLXHYCYDYEYFZUYHUBUXDVURHVVFYGWSUUAVWEHUUBXHYHAVWBH
        BVURXPUHZVUFUJZUHZUXDUXDUOUJZUKAHVWAVWMAVWGVVDVWAVWMSVUIVVGBVWLTFVURNVW
        LWQZUUCXCUUDAUYKVWNVWOSUYHAVDVDUXDUXDUOVDBVWLVOVOHAUYEBVDYIUYFVDTBYJVAA
        VDTVWLUTZVWLVDYIAVVDVWQVVGVWLTVURVWPVEVAVDTVWLYJVAVDVORAUUEVPZVWRVDUUFA
        UYKULUXDVTAHVWLUHZUXDSUYKAVWSHHSZUXDUKXQZUXDAUYDUYKUYKVWSVXASUYIUYHUYHU
        BUXDVURHHVVFUUIWSVWTVXAUXDSHWQVWTUXDUKUUJUUGXHVJUUHUUKAUXDUYIUULYKAVVIV
        UBRZUYKVVSVVTVWCULYAAVWGVVDVXBVUIVVGTFVURXBXCZUYHVWATVVIHVVJVVJWQVWAWQU
        UMXCUUNUUOZVJUWTVVJYQRZHYQRZIYQRZUKIWFWJZVVLVVMYAAVXEUWOAVVJAVXBVVJVDRZ
        VXCTVVIVIVAZYLVJAVXFUWOAHUYHYLVJUWOVXGAIUUSWKUWOVXHAIUUTWKVVJHIUUPUUQYM
        AVUEVVKSUWOAVVIGUFZUGUHZVUEVVKAVXKUXHUGAUAUBTTUXBUYQVUQUOUJUXGGVVIUXTUY
        RAUBTUYQVUQUOFVURVOTTUYNATTUYPFUYBVBAUYPTRZULUXDVUPAUYDVXMUYIVJVXMVXMUY
        KVUPTRAVXMUURUYHUYPHUVAUVBVLUYSVUSVRVUTUYQUXCVUQUXFUOUYTVVBUVCWCWEAVXBE
        UMZUGUHZCXOWJZVXNGUFZUGUHZVXOIUIUJZSZYRZEVUBUVIVVJCXOWJZVXLVVKSZVXCQAVY
        BVVJVVOWFWJZAVVJHVVOWFVXDPYHAVXIVVPVYBVYDYAVXJOVVJCUVDXCUVEVYAVYBVYCYRE
        VVIVUBVXNVVISZVXPVYBVXTVYCVYEVXOVVJCXOVXNVVIUGWBZXIVYEVXRVXLVXSVVKVYEVX
        QVXKUGVXNVVIGUVFWEVYEVXOVVJIUIVYFUVJUVGUVHUVKUVLYNVJUWTUXLUATUXEUPZUGUH
        ZUWRAUXLVYHSUWOATUXDYOYPZVYGUIURUJZUGUHZUXLVYHAVYJUXIUGAUATUXDUXEUIVYIV
        YGVOTTUYNUYJUYLVYIUATUXDUPSAUATUXDYSVPAVYGVTVRWEAUYDVWHVYGVUBRVYKVYHSUY
        IVWKAUBTVUPUPZGUFVYGVUBAUAUBTTUXBVUPUXEGVYLUXTUYRAVYLVTVVAWCAUCUDTVYLGA
        VVCXDTRZUYKVYLVUBRVVEVYMAUVMVPUYHUBTHUVNWSVUJVUNVUOWMWTUXDTVYGUVOWSYNVJ
        UWTUADGHIKAHUERUWOVVQVJAUWOYTAUXQUWOMVJUVPUVSZUVQTUXHUXIVUEUXLVUEWQUXLW
        QUVRWSVYNYKAUWSULZTUKGUHZFUHZYOYPZUGUHZHUKUIUJZUWQUWRAVYSVYTSUWSAVYSUKV
        YTAVYQTRVYSUKSATTVYPFUYBAUXRUKTRVYPTRZUXSUVTTTUKGUWAUWBZVGVYQUWIVAAHAHU
        YHUWCUWDUWEVJVYOUWPVYRUGVYOUWPUATVYQUPVYRVYOUAUBTTVYPUYQVYQGFAWUAUWSUXN
        WUBUWFVYOGTVYPYOYPZUATVYPUPVYOGUGUHZUKSZGWUCSZVYOWUDIUKKAUWSYTZUWGAWUEW
        UFYAZUWSAUXQWUHMDGUWJVAVJYMUATVYPYSXHAFUBTUYQUPSUWSUYSVJUYPVYPFWBWCUATV
        YQYSUWHWEVYOIUKHUIWUGWOUWKAIVDRUWOUWSXNAIWUDVDKAUXQWUDVDRMDGVIVAVFIUWLU
        WMUWN $.
    $}

    $( The degree of a composition of two polynomials is the product of the
       degrees.  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    dgrco $p |- ( ph -> ( deg ` ( F o. G ) ) = ( M x. N ) ) $=
      ( vf cc cfv wcel cdgr cle wbr wceq wi cc0 vx vd vy vg cply ccom cmul wral
      vh cv co plyssc sseldi cn0 dgrcl syl syl5eqel caddc imbi1d ralbidv imbi2d
      c1 breq2 wa nn0cnd adantr mul02d simprr ad2antrl nn0ge0d cr wb nn0red 0re
      letri3 sylancl mpbir2and oveq1d 3eqtr4d csn cmpt fconstmpt 0dgrb mpbid wf
      cxp plyf ffvelrnda feqmptd syl6eq eqidd fmptco 3eqtr4a fveq2d eqtr2d expr
      ralrimiva fveq2 breq1d coeq1 eqeq12d imbi12d cbvralv clt nn0p1nn ad2antlr
      wo cn nnred leloed simplr nn0leltp1 syl2anc rspcva adantl sylbird simprll
      ccoe eqid ad2antrr simprlr sylib dgrcolem2 sylbid ralrimdva syl5bi expcom
      jaod a2d nn0ind mpcom leidd syl6eqr rspcv syl3c ) ACLUEMZNKUJZOMZEPQZYQDU
      FZOMZYRFUGUKZRZSZKYPUHZEEPQZCDUFZOMZEFUGUKZRZABUEMZYPCBULZIUMEUNNAUUEAECO
      MZUNGACUUKNUUMUNNIBCUOUPUQZAYRUAUJZPQZUUCSZKYPUHZSAYRTPQZUUCSZKYPUHZSAYRU
      BUJZPQZUUCSZKYPUHZSAYRUVBVBURUKZPQZUUCSZKYPUHZSAUUESUAUBEUUOTRZUURUVAAUVJ
      UUQUUTKYPUVJUUPUUSUUCUUOTYRPVCUSUTVAUUOUVBRZUURUVEAUVKUUQUVDKYPUVKUUPUVCU
      UCUUOUVBYRPVCUSUTVAUUOUVFRZUURUVIAUVLUUQUVHKYPUVLUUPUVGUUCUUOUVFYRPVCUSUT
      VAUUOERZUURUUEAUVMUUQUUDKYPUVMUUPYSUUCUUOEYRPVCUSUTVAAUUTKYPAYQYPNZUUSUUC
      AUVNUUSVDZVDZUUBYRUUAUVPTFUGUKTUUBYRUVPFAFLNUVOAFAFDOMZUNHADUUKNZUVQUNNJB
      DUOUPUQVEVFVGUVPYRTFUGUVPYRTRZUUSTYRPQZAUVNUUSVHUVPYRUVNYRUNNZAUUSLYQUOZV
      IZVJUVPYRVKNTVKNUVSUUSUVTVDVLUVPYRUWCVMVNYRTVOVPVQZVRUWDVSUVPYQYTOUVPLTYQ
      MZVTWFZUCLUWEWAYQYTUCLUWEWBUVPUVSYQUWFRZUWDUVNUVSUWGVLAUUSLYQWCVIWDZUVPUC
      UALLUCUJZDMZUWEUWEDYQUVPLLUWIDUVPUVRLLDWEAUVRUVOJVFBDWGUPZWHUVPUCLLDUWKWI
      UVPYQUWFUALUWEWAUWHUALUWEWBWJUUOUWJRUWEWKWLWMWNWOWPWQUVBUNNZAUVEUVIAUWLUV
      EUVISUVEUDUJZOMZUVBPQZUWMDUFZOMZUWNFUGUKZRZSZUDYPUHZAUWLVDZUVIUVDUWTKUDYP
      YQUWMRZUVCUWOUUCUWSUXCYRUWNUVBPYQUWMOWRZWSUXCUUAUWQUUBUWRUXCYTUWPOYQUWMDW
      TWNUXCYRUWNFUGUXDVRXAXBXCUXBUXAUVHKYPUXBUVNUXAUVHUXBUVNUXAVDZVDZUVGYRUVFX
      DQZYRUVFRZXGUUCUXFYRUVFUXFYRUVNUWAUXBUXAUWBVIZVMUXFUVFUWLUVFXHNAUXEUVBXEX
      FXIXJUXFUXGUUCUXHUXFUXGUVCUUCUXFUWAUWLUVCUXGVLUXIAUWLUXEXKYRUVBXLXMUXEUVD
      UXBUWTUVDUDYQYPUWMYQRZUWOUVCUWSUUCUXJUWNYRUVBPUWMYQOWRZWSUXJUWQUUAUWRUUBU
      XJUWPYTOUWMYQDWTWNUXJUWNYRFUGUXKVRXAXBXNXOXPUXBUXEUXHUUCUXBUXEUXHVDZVDZYQ
      XRMZUVBLUIYQDYRFYRXSHUXBUVNUXAUXHXQADYPNUWLUXLAUUKYPDUULJUMXTUXNXSAUWLUXL
      XKUXBUXEUXHVHUXMUXAUIUJZOMZUVBPQZUXODUFZOMZUXPFUGUKZRZSZUIYPUHUXBUVNUXAUX
      HYAUWTUYBUDUIYPUWMUXORZUWOUXQUWSUYAUYCUWNUXPUVBPUWMUXOOWRZWSUYCUWQUXSUWRU
      XTUYCUWPUXROUWMUXODWTWNUYCUWNUXPFUGUYDVRXAXBXCYBYCWPYHYDWPYEYFYGYIYJYKAEA
      EUUNVMYLUUDUUFUUJSKCYPYQCRZYSUUFUUCUUJUYEYREEPUYEYRUUMEYQCOWRGYMZWSUYEUUA
      UUHUUBUUIUYEYTUUGOYQCDWTWNUYEYREFUGUYFVRXAXBYNYO $.
  $}

  ${
    $d k x z A $.  $d k x z F $.  $d k x z N $.  $d k x z ph $.  $d k x z S $.
    plycj.1 $e |- N = ( deg ` F ) $.
    plycj.2 $e |- G = ( ( * o. F ) o. * ) $.
    ${
      plycjlem.3 $e |- A = ( coeff ` F ) $.
      $( Lemma for ~ plycj and ~ coecj .  (Contributed by Mario Carneiro,
         24-Jul-2014.) $)
      plycjlem $p |- ( F e. ( Poly ` S ) -> G = ( z e. CC |->
        sum_ k e. ( 0 ... N ) ( ( ( * o. A ) ` k ) x. ( z ^ k ) ) ) ) $=
        ( vx cfv wcel cc co ccj cexp cmul csu syl2an cply cc0 cv cmpt ccom cjcl
        cfz adantl wf cjf a1i feqmptd wa fzfid cn0 coef3 adantr elfznn0 ffvelrn
        expcl sylan2 adantll mulcld fsumcl coeid fveq2 fmptco wceq oveq1 oveq2d
        sumeq2sdv fveq2d syl5eq fsumcj cjmuld fvco3 cjcj ad2antlr oveq1d eqtr2d
        cjexp oveq12d eqtr4d sumeq2dv eqtrd mpteq2dva ) ECUALMZFANUBGUGOZDUCZBL
        ZAUCZPLZWIQOZROZDSZPLZUDZANWHWIPBUELZWKWIQOZROZDSZUDWGFPEUEZPUEWQIWGAKN
        NWLWHWJKUCZWIQOZROZDSZPLZWPPXBWKNMZWLNMZWGWKUFUHZWGANNPNNPUIWGUJUKULZWG
        KANNXFWLXGEPWGXCNMZUMZWHXEDXMUBGUNXMWIWHMZUMWJXDXMUONBUIZWIUOMZWJNMZXNW
        GXOXLBCEJUPZUQWIGURZUONWIBUSZTXLXNXDNMZWGXNXLXPYAXSXCWIUTVAVBVCVDKBCDEG
        JHVEXKWKXFPVFVGXCWLVHZXFWOPYBWHXEWNDYBXDWMWJRXCWLWIQVIVJVKVLVGVMWGANWPX
        AWGXHUMZWPWHWNPLZDSXAYCWHWNDYCUBGUNYCXNUMZWJWMYCXOXPXQXNWGXOXHXRUQZXSXT
        TZYCXIXPWMNMXNXJXSWLWIUTTZVCVNYCWHYDWTDYEYDWJPLZWMPLZROWTYEWJWMYGYHVOYE
        WRYIWSYJRYCXOXPWRYIVHXNYFXSUONWIPBVPTYEYJWLPLZWIQOZWSYCXIXPYJYLVHXNXJXS
        WLWIWATYEYKWKWIQXHYKWKVHWGXNWKVQVRVSVTWBWCWDWEWFWE $.
    $}

    ${
      plycj.3 $e |- ( ( ph /\ x e. S ) -> ( * ` x ) e. S ) $.
      plycj.4 $e |- ( ph -> F e. ( Poly ` S ) ) $.
      $( The double conjugation of a polynomial is a polynomial.  (The single
         conjugation is not because our definition of polynomial includes only
         holomorphic functions, i.e. no dependence on ` ( * `` z ) `
         independently of ` z ` .)  (Contributed by Mario Carneiro,
         24-Jul-2014.) $)
      plycj $p |- ( ph -> G e. ( Poly ` S ) ) $=
        ( vz vk cc0 cfv cc ccj wcel wceq syl cn0 csn cun cply co ccoe ccom cexp
        cfz cv cmul csu cmpt eqid plycjlem wss plybss 0cn a1i snssd unssd dgrcl
        cdgr syl5eqel wa wf coef elfznn0 fvco3 syl2an ffvelrn wi wral ralrimiva
        wo fveq2 eleq1d rspccv elsni fveq2d cj0 syl6eq fvex sylibr orim12d elun
        elsnc 3imtr4g adantr mpd eqeltrd elplyd plyun0 syl6eleq ) AECMUAZUBZUCN
        ZCUCNZAEKOMFUHUDZLUIZPDUENZUFNZKUIWSUGUDUJUDLUKULZWPADWQQZEXBRJKWTCLDEF
        GHWTUMZUNSAKXAWOLFACWNOAXCCOUOJCDUPSAMOMOQAUQURUSUTAFDVBNZTGAXCXETQJCDV
        ASVCAWSWRQZVDZXAWSWTNZPNZWOATWOWTVEZWSTQZXAXIRXFAXCXJJWTCDXDVFSZWSFVGZT
        WOWSPWTVHVIXGXHWOQZXIWOQZAXJXKXNXFXLXMTWOWSWTVJVIAXNXOVKXFAXHCQZXHWNQZV
        NXICQZXIWNQZVNXNXOAXPXRXQXSABUIZPNZCQZBCVLXPXRVKAYBBCIVMYBXRBXHCXTXHRYA
        XICXTXHPVOVPVQSXQXSVKAXQXIMRXSXQXIMPNMXQXHMPXHMVRVSVTWAXIMXHPWBWFWCURWD
        XHCWNWEXICWNWEWGWHWIWJWKWJCWLWM $.
    $}

    coecj.3 $e |- A = ( coeff ` F ) $.
    $( Double conjugation of a polynomial causes the coefficients to be
       conjugated.  (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    coecj $p |- ( F e. ( Poly ` S ) -> ( coeff ` G ) = ( * o. A ) ) $=
      ( vz vk cfv wcel ccj cc cn0 wf cc0 wceq wb syl2anc vx cply ccom cv adantl
      cjcl plyssc sseli plycj cdgr dgrcl syl5eqel cjf coef3 sylancr c1 caddc co
      fco cuz cima csn wne cle wbr wi wral fvco3 sylan cj0 eqcomi a1i ffvelrnda
      eqeq12d 0cn bitrd necon3bid dgrub2 plyco0 mpbid r19.21bi sylbid ralrimiva
      wa cj11 mpbird plycjlem coeeq ) CBUBKZLZIMAUCZNJDEWJUANCDEFGUAUDZNLWLMKNL
      WJWLUFUEWINUBKCBUGUHUIWJECUJKOFBCUKULZWJNNMPONAPZONWKPZUMABCHUNZONNMAUSUO
      ZWJWKEUPUQURUTKZVAQVBZRZJUDZWKKZQVCZXAEVDVEZVFZJOVGZWJXEJOWJXAOLZWDZXCXAA
      KZQVCZXDXHXBQXIQXHXBQRXIMKZQMKZRZXIQRZXHXBXKQXLWJWNXGXBXKRWPONXAMAVHVIQXL
      RXHXLQVJVKVLVNXHXINLQNLZXMXNSWJONXAAWPVMXOXHVOVLXIQWETVPVQWJXJXDVFZJOWJAW
      RVAWSRZXPJOVGZABCEHFVRWJEOLZWNXQXRSWMWPAJEVSTVTWAWBWCWJXSWOWTXFSWMWQWKJEV
      STWFIABJCDEFGHWGWH $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x S $.  $d x V $.
    $( A polynomial with real coefficients distributes under conjugation.
       (Contributed by Mario Carneiro, 24-Jul-2014.) $)
    plyrecj $p |- ( ( F e. ( Poly ` RR ) /\ A e. CC ) ->
                    ( * ` ( F ` A ) ) = ( F ` ( * ` A ) ) ) $=
      ( vx cr cfv wcel cc wa cc0 cexp cmul csu ccj cn0 eqid syl2an eqtrd coeid2
      co wceq cply cdgr cfz cv ccoe fzfid wf coef2 mpan2 adantr elfznn0 ffvelrn
      recnd simpr expcl mulcld fsumcj cjmuld cjred oveq12d sumeq2dv fveq2d cjcl
      0re cjexp sylan2 3eqtr4d ) BDUAEFZAGFZHZIBUBEZUCSZCUDZBUEEZEZAVMJSZKSZCLZ
      MEZVLVOAMEZVMJSZKSZCLZABEZMEVTBEZVJVSVLVQMEZCLWCVJVLVQCVJIVKUFVJVMVLFZHZV
      OVPWHVOVJNDVNUGZVMNFZVODFWGVHWIVIVHIDFWIVDVNDBVNOZUHUIUJVMVKUKZNDVMVNULPZ
      UMZVJVIWJVPGFWGVHVIUNZWLAVMUOPZUPUQVJVLWFWBCWHWFVOMEZVPMEZKSWBWHVOVPWNWPU
      RWHWQVOWRWAKWHVOWMUSVJVIWJWRWATWGWOWLAVMVEPUTQVAQVJWDVRMVNDCBVKAWKVKOZRVB
      VIVHVTGFWEWCTAVCVNDCBVKVTWKWSRVFVG $.

    $( Polynomial multiplication has no zero divisors.  (Contributed by Mario
       Carneiro, 26-Jul-2014.) $)
    plymul0or $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) ) ->
      ( ( F oF x. G ) = 0p <-> ( F = 0p \/ G = 0p ) ) ) $=
      ( vx cfv wcel cmul c0p wceq ccoe cc0 cn0 syl6eq eqeq1d eqid adantr adantl
      co cc wf cply wa cof wo cdgr caddc csn cxp dgrcl nn0addcl syl2an fvconst2
      c0ex syl fveq2 coe0 fveq1d syl5ibrcom coemulhi coef3 mul0ord bitrd sylibd
      ffvelrnd wb dgreq0 orbi12d sylibrd cvv cnex a1i plyf 0cn cv mul02 caofid2
      id df-0p oveq1d mul01 caofid1 oveq2d jaod eqeq2i syl6ibr impbid ) BAUAEZF
      ZCWGFZUBZBCGUCZRZHIZBHIZCHIZUDZWJWMBUEEZBJEZEZKIZCUEEZCJEZEZKIZUDZWPWJWMW
      QXAUFRZWLJEZEZKIZXEWJXIWMXFLKUGZUHZEZKIZWJXFLFZXMWHWQLFZXALFZXNWIABUIZACU
      IZWQXAUJUKLKXFUMULUNWMXHXLKWMXFXGXKWMXGHJEXKWLHJUOUPMUQNURWJXIWSXCGRZKIXE
      WJXHXSKWRXBABCWQXAWROZXBOZWQOZXAOZUSNWJWSXCWJLSWQWRWHLSWRTWIWRABXTUTPWHXO
      WIXQPVDWJLSXAXBWILSXBTWHXBACYAUTQWIXPWHXRQVDVAVBVCWJWNWTWOXDWHWNWTVEWIWRA
      BWQYBXTVFPWIWOXDVEWHXBACXAYCYAVFQVGVHWJWPWLSXJUHZIZWMWJWNYEWOWJYEWNYDCWKR
      ZYDIWJDSKKGSCVISSSVIFWJVJVKZWISSCTWHACVLQKSFWJVMVKZYHDVNZSFZKYIGRKIWJYIVO
      QVPWNWLYFYDWNBYDCWKWNBHYDWNVQVRMVSNURWJYEWOBYDWKRZYDIWJDSKKGSBVISSYGWHSSB
      TWIABVLPYHYHYJYIKGRKIWJYIVTQWAWOWLYKYDWOCYDBWKWOCHYDWOVQVRMWBNURWCHYDWLVR
      WDWEWF $.

    $( The set of roots of a product is the union of the roots of the terms.
       (Contributed by Mario Carneiro, 28-Jul-2014.) $)
    ofmulrt $p |- ( ( A e. V /\ F : A --> CC /\ G : A --> CC ) ->
   ( `' ( F oF x. G ) " { 0 } ) = ( ( `' F " { 0 } ) u. ( `' G " { 0 } ) ) ) $=
      ( vx wcel cc wf cmul ccnv cc0 cima cfv wceq wa wo wfn syl wb fniniseg w3a
      cof co csn cun simp2 ffn simp3 simp1 inidm eqidd eqeq1d ffvelrnda mul0ord
      cv ofval bitrd pm5.32da offn orbi12d elun andi 3bitr4g 3bitr4d eqrdv ) AD
      FZAGBHZAGCHZUAZEBCIUBUCZJKUDZLZBJVKLZCJVKLZUEZVIEUOZAFZVPVJMZKNZOZVQVPBMZ
      KNZVPCMZKNZPZOZVPVLFZVPVOFZVIVQVSWEVIVQOZVSWAWCIUCZKNWEWIVRWJKVIAAWAWCIAB
      CDDVPVIVGBAQZVFVGVHUFZAGBUGRZVIVHCAQZVFVGVHUHZAGCUGRZVFVGVHUIZWQAUJZWIWAU
      KWIWCUKUPULWIWAWCVIAGVPBWLUMVIAGVPCWOUMUNUQURVIVJAQWGVTSVIAAIABCDDWMWPWQW
      QWRUSAKVPVJTRVIVPVMFZVPVNFZPVQWBOZVQWDOZPWHWFVIWSXAWTXBVIWKWSXASWMAKVPBTR
      VIWNWTXBSWPAKVPCTRUTVPVMVNVAVQWBWDVBVCVDVE $.
  $}

  ${
    $d F a $.
    $( Real-coefficient polynomials restrict to real functions.  (Contributed
       by Stefan O'Rear, 16-Nov-2014.) $)
    plyreres $p |- ( F e. ( Poly ` RR ) -> ( F |` RR ) : RR --> RR ) $=
      ( va cr cply cfv wcel cres wfn crn wss wf cc plybss wb plyf fnssresb wceq
      ffn adantl ccj 3syl mpbird cv wral wa fvres ffvelrn syl2an plyrecj sylan2
      recn cjre fveq2d eqtrd cjrebd eqeltrd ralrimiva fnfvrnss syl2anc sylanbrc
      df-f ) ACDEFZACGZCHZVCICJZCCVCKVBVDCLJZCAMVBLLAKZALHVDVFNCAOZLLARLCAPUAUB
      ZVBVDBUCZVCEZCFZBCUDVEVIVBVLBCVBVJCFZUEZVKVJAEZCVMVKVOQVBVJCAUFSVNVOVBVGV
      JLFZVOLFVMVHVJUKZLLVJAUGUHVNVOTEZVJTEZAEZVOVMVBVPVRVTQVQVJAUIUJVNVSVJAVMV
      SVJQVBVJULSUMUNUOUPUQBCCVCURUSCCVCVAUT $.
  $}

  ${
    $d ph z j k $.  $d A z j k $.  $d B z $.  $d N j k z $.
    dvply1.f $e |- ( ph -> F = ( z e. CC |-> sum_ k e. ( 0 ... N )
        ( ( A ` k ) x. ( z ^ k ) ) ) ) $.
    dvply1.g $e |- ( ph -> G = ( z e. CC |-> sum_ k e. ( 0 ... ( N - 1 ) )
        ( ( B ` k ) x. ( z ^ k ) ) ) ) $.
    dvply1.a $e |- ( ph -> A : NN0 --> CC ) $.
    dvply1.b $e |- B = ( k e. NN0 |-> ( ( k + 1 ) x. ( A ` ( k + 1 ) ) ) ) $.
    dvply1.n $e |- ( ph -> N e. NN0 ) $.
    $( Derivative of a polynomial, explicit sum version.  (Contributed by
       Stefan O'Rear, 13-Nov-2014.)  (Revised by Mario Carneiro,
       11-Feb-2015.) $)
    dvply1 $p |- ( ph -> ( CC _D F ) = G ) $=
      ( cc co cc0 cmul c1 wcel cn0 vj cdv cfz cv cfv cexp cmpt wceq cmin oveq2d
      csu cif ccnfld ctopn crest ctop eqid cnfldtop cnfldtopon toponunii restid
      ax-mp eqcomi cr cpr cnex prid2 a1i topopn mp1i fzfid wa wf elfznn0 syl2an
      ffvelrn adantr simpr ad2antlr expcld mulcld w3a 3adant3 0cn wn simpl2 syl
      3impa nn0cnd simpl3 cn wo elnn0 sylib orel2 sylc nnm1nn0 ifclda c0ex ovex
      cvv ifex adantl dvexp2 dvmptcmul dvmptfsum elfznn nnne0d iffalse sumeq2dv
      neneqd cuz wss 1nn0 nn0uz eleqtri fzss1 nnnn0d simplr eqeltrd cdif eldifn
      wne caddc 0p1e1 oveq1i eleq2i sylnibr eldifi wb syl6eleq ad2antrr elfzp12
      mpbid iftrue mul01d sylancl oveq1d oveq1 oveq12d eqtrd peano2nn0 ffvelrnd
      sylan2 fsumss ax-1cn pncan mulassd mulcomd 3eqtr2d sumeq1i fveq2d cbvsumv
      1m1e0 oveq2 3eqtr4g cz 1z nn0zd fveq2 id fsumshftm fvmpt2 3eqtr4d 3eqtr3d
      mpteq2dva eqtr4d 3eqtrd ) ANFUBONBNPHUCOZEUDZCUEZBUDZUVJUFOZQOZEUKUGZUBOB
      NUVIUVKUVJPUHZPUVJUVLUVJRUIOZUFOZQOZULZQOZEUKZUGZGAFUVONUBIUJABUVNUWANEUV
      IUMUNUEZUWDNUWDNUOOZUWDUWDUPSZUWEUWDUHUWDUWDUQZURZUWDUPNNUWDUWDUWGUSUTZVA
      VBVCUWGNVDNVESZAVDNVFVGZVHUWFNUWDSAUWHUWDNUWIVIVJAPHVKAUVJUVISZUVLNSZUVNN
      SAUWLVLZUWMVLZUVKUVMUWNUVKNSZUWMATNCVMZUVJTSZUWPUWLKUVJHVNZTNUVJCVPZVOZVQ
      UWOUVLUVJUWNUWMVRUWLUWRAUWMUWSVSVTZWAWHAUWLUWMWBZUVKUVTAUWLUWPUWMUXAWCUXC
      UVPPUVSNPNSUXCUVPVLWDVHUXCUVPWEZVLZUVJUVRUXEUVJUXEUWLUWRAUWLUWMUXDWFUWSWG
      ZWIUXEUVLUVQAUWLUWMUXDWJUXEUVJWKSZUVQTSZUXEUXDUXGUVPWLZUXGUXCUXDVRUXEUWRU
      XIUXFUVJWMWNUVPUXGWOWPUVJWQZWGVTWAWRWAUWNBUVMUVTUVKNXANUWJUWNUWKVHUXBUVTX
      ASUWOUVPPUVSWSUVJUVRQWTXBVHUWNUWRNBNUVMUGUBOBNUVTUGUHUWLUWRAUWSXCBUVJXDWG
      UXAXEXFAUWCBNPHRUIOZUCOZUVJDUEZUVMQOZEUKZUGGABNUWBUXOAUWMVLZRHUCOZUWAEUKU
      XQUVKUVSQOZEUKZUWBUXOUXPUXQUWAUXREUXPUVJUXQSZVLZUVTUVSUVKQUYAUXDUVTUVSUHZ
      UXTUXDUXPUXTUVJPUXTUVJUVJHXGZXHZXKXCUVPPUVSXIZWGUJXJUXPUXQUVIUWAERPXLUEZS
      UXQUVIXMUXPRTUYFXNXOXPRPHXQVJUYAUVKUVTUXPUWQUWRUWPUXTAUWQUWMKVQZUXTUVJUYC
      XRZUWTVOZUYAUVTUVSNUYAUXDUYBUYAUVJPUXTUVJPYCUXPUYDXCXKUYEWGUYAUVJUVRUYAUV
      JUXTUWRUXPUYHXCWIUYAUVLUVQAUWMUXTXSUXTUXHUXPUXTUXGUXHUYCUXJWGXCVTWAZXTWAU
      XPUVJUVIUXQYASZVLZUWAUVKPQOZPUYLUVTPUVKQUYLUVPUVTPUHUYLUVJPRYDOZHUCOZSZWE
      ZUVPUYPWLZUVPUYKUYQUXPUYKUXTUYPUVJUVIUXQYBUYOUXQUVJUYNRHUCYEYFYGYHXCUYLUW
      LUYRUYKUWLUXPUVJUVIUXQYIZXCUYLHUYFSZUWLUYRYJAUYTUWMUYKAHTUYFMXOYKYLUVJPHY
      MWGYNUYPUVPWOWPUVPPUVSYOWGUJUYKUXPUWLUYMPUHUYSUXPUWLVLUVKUXPUWQUWRUWPUWLU
      YGUWSUWTVOYPUUDUUAUXPPHVKUUEUXPRRUIOZUXKUCOZUAUDZRYDOZCUEZVUDUVLVUDRUIOZU
      FOZQOZQOZUAUKZUXLUVJRYDOZVUKCUEZQOZUVMQOZEUKZUXSUXOUXPUXLVUIUAUKUXLVUDVUE
      QOZUVLVUCUFOZQOZUAUKVUJVUOUXPUXLVUIVURUAUXPVUCUXLSZVLZVUIVUEVUDVUQQOZQOVU
      EVUDQOZVUQQOVURVUTVUHVVAVUEQVUTVUGVUQVUDQVUTVUFVUCUVLUFVUTVUCNSRNSVUFVUCU
      HVUTVUCVUSVUCTSZUXPVUCUXKVNZXCZWIUUFVUCRUUGYQUJUJUJVUTVUEVUDVUQVUTTNVUDCA
      UWQUWMVUSKYLVUSVUDTSZUXPVUSVVCVVFVVDVUCUUBWGXCZUUCZVUTVUDVVGWIZVUTUVLVUCA
      UWMVUSXSVVEVTUUHVUTVVBVUPVUQQVUTVUEVUDVVHVVIUUIYRUUJXJVUBUXLVUIUAVUAPUXKU
      CUUNYFUUKUXLVUNVUREUAUVJVUCUHZVUMVUPUVMVUQQVVJVUKVUDVULVUEQUVJVUCRYDYSZVV
      JVUKVUDCVVKUULYTUVJVUCUVLUFUUOYTUUMUUPUXPUXRVUIEUARRHRUUQSUXPUURVHZVVLUXP
      HAHTSUWMMVQUUSUYAUVKUVSUYIUYJWAUVJVUDUHZUVKVUEUVSVUHQUVJVUDCUUTVVMUVJVUDU
      VRVUGQVVMUVAVVMUVQVUFUVLUFUVJVUDRUIYSUJYTYTUVBUXPUXLUXNVUNEUXPUVJUXLSZVLZ
      UXMVUMUVMQVVOUWRVUMXASUXMVUMUHVVNUWRUXPUVJUXKVNXCVUKVULQWTETVUMXADLUVCYQY
      RXJUVDUVEUVFJUVGUVH $.
  $}

  ${
    $d a b c F $.  $d a b c S $.
    $( The derivative of a polynomial with coefficients in a subring is a
       polynomial with coefficients in the same ring.  (Contributed by Mario
       Carneiro, 1-Jan-2017.) $)
    dvply2g $p |- ( ( S e. ( SubRing ` CCfld ) /\ F e. ( Poly ` S ) ) ->
      ( CC _D F ) e. ( Poly ` S ) ) $=
      ( va vb vc ccnfld cfv wcel wa cc co cc0 cfz cv cn0 caddc cmul cmpt adantl
      c1 csubrg cply cdv cdgr ccoe cexp csu wf plyf feqmptd cuz simplr cz dgrcl
      wceq nn0zd adantr uzid peano2uz 3syl simpr coeid3 syl3anc mpteq2dva eqtrd
      eqid cmin nn0cnd ax-1cn pncan sylancl eqcomd sumeq1d mpteq2dv coef3 oveq1
      oveq2d fveq2d oveq12d cbvmptv peano2nn0 syl dvply1 subrgss elfznn0 simpll
      wss cnfldbas zsssubrg sseldd csubg subrgsubg cnfld0 subg0cl coef2 syl2anc
      ad2antrr ffvelrnd cnfldmul subrgmcl fmptd ffvelrnda sylan2 elplyd eqeltrd
      ) AFUAGHZBAUBGZHZIZJBUCKCJLBUDGZMKZDNZEOENZTPKZXNBUEGZGZQKZRZGZCNZXLUFKZQ
      KZDUGZRZXGXICXOXRDBYDXJTPKZXIBCJXTBGZRCJLYEMKXLXOGYAQKDUGZRXICJJBXHJJBUHX
      FABUISUJXICJYFYGXIXTJHZIZXHYEXJUKGZHZYHYFYGUOXFXHYHULYIXJUMHZXJYJHYKXIYLY
      HXIXJXHXJOHZXFABUNSZUPUQXJURXJXJUSUTXIYHVAXOADBYEXJXTXOVFZXJVFVBVCVDVEXIC
      JYCLYETVGKZMKZYBDUGXIXKYQYBDXIXJYPLMXIYPXJXIXJJHTJHYPXJUOXIXJYNVHVIXJTVJV
      KVLVQVMVNXHOJXOUHXFXOABYOVOSEDOXQXLTPKZYRXOGZQKXMXLUOZXNYRXPYSQXMXLTPVPZY
      TXNYRXOUUAVRVSVTXIYMYEOHYNXJWAWBWCXICXSADXJXFAJWGXHAJFWHWDUQYNXLXKHXIXLOH
      XSAHXLXJWEXIOAXLXRXIEOXQAXRXIXMOHZIZXFXNAHXPAHXQAHXFXHUUBWFUUCUMAXNXFUMAW
      GXHUUBAWIWQUUCXNUUBXNOHXIXMWASZUPWJUUCOAXNXOUUCXHLAHZOAXOUHXFXHUUBULXFUUE
      XHUUBXFAFWKGHUUEAFWLAFLWMWNWBWQXOABYOWOWPUUDWRAFQXNXPWSWTVCXRVFXAXBXCXDXE
      $.

    $( The derivative of a polynomial is a polynomial.  (Contributed by Stefan
       O'Rear, 14-Nov-2014.)  (Proof shortened by Mario Carneiro,
       1-Jan-2017.) $)
    dvply2 $p |- ( F e. ( Poly ` S ) -> ( CC _D F ) e. ( Poly ` CC ) ) $=
      ( cply cfv wcel cc ccnfld csubrg cdv co crg cnrng cnfldbas subrgid plyssc
      ax-mp sseli dvply2g sylancr ) BACDZEFGHDEZBFCDZEFBIJUBEGKEUALFGMNPTUBBAOQ
      FBRS $.
  $}

  ${
    $d n x F $.  $d x N $.  $d n x S $.
    $( Polynomials have polynomials as derivatives of all orders.  (Contributed
       by Mario Carneiro, 1-Jan-2017.) $)
    dvnply2 $p |- ( ( S e. ( SubRing ` CCfld ) /\ F e. ( Poly ` S ) /\
      N e. NN0 ) -> ( ( CC Dn F ) ` N ) e. ( Poly ` S ) ) $=
      ( vx vn ccnfld cfv wcel cn0 cc co wa cv cc0 wceq fveq2 eleq1d imbi2d cvv
      wi csubrg cply cdvn c1 caddc wss cpm ssid wf cnex a1i plyf adantl syl3anc
      fpmg dvn0 sylancr simpr eqeltrd cdv dvply2g ad2antrr dvnp1 mp3an1 sylibrd
      ex sylan expcom a2d nn0ind impcom 3impa ) AFUAGHZBAUBGZHZCIHZCJBUCKZGZVNH
      ZVPVMVOLZVSVTDMZVQGZVNHZTVTNVQGZVNHZTVTEMZVQGZVNHZTVTWFUDUEKZVQGZVNHZTVTV
      STDECWANOZWCWEVTWLWBWDVNWANVQPQRWAWFOZWCWHVTWMWBWGVNWAWFVQPQRWAWIOZWCWKVT
      WNWBWJVNWAWIVQPQRWACOZWCVSVTWOWBVRVNWACVQPQRVTWDBVNVTJJUFZBJJUGKHZWDBOJUH
      ZVTJSHZWSJJBUIZWQWSVTUJUKZXAVOWTVMABULUMJJBSSUOUNZJBUPUQVMVOURUSWFIHZVTWH
      WKVTXCWHWKTVTXCLZWHJWGUTKZVNHZWKVMWHXFTVOXCVMWHXFAWGVAVFVBXDWJXEVNVTWQXCW
      JXEOZXBWPWQXCXGWRJBWFVCVDVGQVEVHVIVJVKVL $.

    $( Polynomials have polynomials as derivatives of all orders.  (Contributed
       by Stefan O'Rear, 15-Nov-2014.)  (Revised by Mario Carneiro,
       1-Jan-2017.) $)
    dvnply $p |- ( ( F e. ( Poly ` S ) /\ N e. NN0 ) ->
      ( ( CC Dn F ) ` N ) e. ( Poly ` CC ) ) $=
      ( cply cfv wcel cc cn0 cdvn plyssc sseli ccnfld csubrg crg cnrng cnfldbas
      co subrgid ax-mp dvnply2 mp3an1 sylan ) BADEZFBGDEZFZCHFZCGBIQEUDFZUCUDBA
      JKGLMEFZUEUFUGLNFUHOGLPRSGBCTUAUB $.

    $( Polynomials are smooth.  (Contributed by Stefan O'Rear, 16-Nov-2014.)
       (Revised by Mario Carneiro, 11-Feb-2015.) $)
    plycpn $p |- ( F e. ( Poly ` S ) -> F e. |^| ran ( C^n ` CC ) ) $=
      ( vx vn cply cfv wcel cc ccpn crn cint cv wral cn0 wa co ccncf cnex syl
      wb cpm cdvn cdm plyf adantr fpm dvnply plycn wceq fdm oveq1d eleqtrrd wss
      wf ssid a1i elcpn sylan mpbir2and ralrimiva fncpn eleq2 ralrn mp2b sylibr
      wfn elintg mpbird ) BAEFZGZBHIFZJZKGBCLZGZCVLMZVJBDLZVKFZGZDNMZVOVJVRDNVJ
      VPNGZOZVRBHHUAPGZVPHBUBPFZBUCZHQPZGZWAHHBUNZWBVJWGVTABUDUEZHHBRRUFSWAWCHH
      QPZWEWAWCHEFGWCWIGABVPUGHWCUHSWAWDHHQWAWGWDHUIWHHHBUJSUKULVJHHUMZVTVRWBWF
      OTWJVJHUOZUPHBVPUQURUSUTWJVKNVFVOVSTWKHVAVNVRCDNVKVMVQBVBVCVDVECBVLVIVGVH
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The division algorithm for polynomials
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c quot $.

  $( Extend class notation to include the quotient of a polynomial division. $)
  cquot $a class quot $.

  ${
    $d f g q r $.
    $( Define the quotient function on polynomials.  This is the ` q ` of the
       expression ` f = g x. q + r ` in the division algorithm.  (Contributed
       by Mario Carneiro, 23-Jul-2014.) $)
    df-quot $a |- quot = ( f e. ( Poly ` CC ) ,
      g e. ( ( Poly ` CC ) \ { 0p } ) |->
      ( iota_ q e. ( Poly ` CC ) [. ( f oF - ( g oF x. q ) ) / r ].
        ( r = 0p \/ ( deg ` r ) < ( deg ` g ) ) ) ) $.
  $}

  ${
    $d f g q r F $.  $d f g q G $.  $d f g r R $.
    quotval.1 $e |- R = ( F oF - ( G oF x. q ) ) $.
    $( Value of the quotient function.  (Contributed by Mario Carneiro,
       23-Jul-2014.) $)
    quotval $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ G =/= 0p ) ->
                    ( F quot G ) = ( iota_ q e. ( Poly ` CC )
                      ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) ) $=
      ( vf vg vr cply cfv wcel c0p co wceq cdgr clt wbr wo cv cc wne cquot crio
      plyssc sseli wa csn cdif eldifsn cmul cof cmin wsbc oveq12 sylan2 syl6eqr
      oveq1 dfsbcq syl cvv ovex eqeltri eqeq1 fveq2 breq1d orbi12d sbcie fveq2d
      simpr breq2d orbi2d syl5bb bitrd riotabidv df-quot riotaex sylan2br 3impb
      wb ovmpt2a syl3an2 syl3an1 ) CBJKZLCUAJKZLZDWDLZDMUBZCDUCNAMOZAPKZDPKZQRZ
      SZEWEUDZOZWDWECBUEZUFWGWFDWELZWHWOWDWEDWPUFWFWQWHWOWQWHUGWFDWEMUHUIZLWODW
      EMUJGHCDWEWRITZMOZWSPKZHTZPKZQRZSZIGTZXBETZUKULZNZUMULZNZUNZEWEUDWNUCXFCO
      ZXBDOZUGZXLWMEWEXOXLXEIAUNZWMXOXKAOXLXPVTXOXKCDXGXHNZXJNZAXNXMXIXQOXKXROX
      BDXGXHURXFCXIXQXJUOUPFUQXEIXKAUSUTXPWIWJXCQRZSZXOWMXEXTIAAXRVAFCXQXJVBVCW
      SAOZWTWIXDXSWSAMVDYAXAWJXCQWSAPVEVFVGVHXOXSWLWIXOXCWKWJQXOXBDPXMXNVJVIVKV
      LVMVNVOGHIEVPWMEWEVQWAVRVSWBWC $.
  $}

  ${
    $d x y z A $.  $d d f p q x y z F $.  $d f p q x y z H $.  $d d x y z ph $.
    $d x y z B $.  $d f z D $.  $d x y z M $.  $d f p q x y z N $.  $d x y T $.
    $d d f g p q w x y z G $.  $d d f p x y R $.  $d d f g p q x y z S $.
    plydiv.pl $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x + y ) e. S ) $.
    plydiv.tm $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) -> ( x x. y ) e. S ) $.
    plydiv.rc $e |- ( ( ph /\ ( x e. S /\ x =/= 0 ) ) -> ( 1 / x ) e. S ) $.
    plydiv.m1 $e |- ( ph -> -u 1 e. S ) $.
    $( Lemma for ~ plydivalg .  (Contributed by Mario Carneiro,
       24-Jul-2014.) $)
    plydivlem1 $p |- ( ph -> 0 e. S ) $=
      ( cc0 c1 cneg caddc ax-1cn negidi cmul mul2negi 1t1e1 caovcld syl5eqelr
      co eqtri ) AIJJKZLTDJMNABCJUBDDDLEAJUBUBOTZDUCJJOTJJJMMPQUAABCUBUBDDDOFHH
      RSHRS $.

    plydiv.f $e |- ( ph -> F e. ( Poly ` S ) ) $.
    plydiv.g $e |- ( ph -> G e. ( Poly ` S ) ) $.
    plydiv.z $e |- ( ph -> G =/= 0p ) $.
    ${
      plydiv.r $e |- R = ( F oF - ( G oF x. q ) ) $.
      $( Lemma for ~ plydivalg .  (Contributed by Mario Carneiro,
         24-Jul-2014.) $)
      plydivlem2 $p |- ( ( ph /\ q e. ( Poly ` S ) ) -> R e. ( Poly ` S ) ) $=
        ( cv wcel co adantr cply cfv wa cmul cmin simpr caddc adantlr plymul c1
        cof cneg plysub syl5eqel ) AHQZEUAUBZRZUCZDFGUOUDUKSZUEUKSUPPURBCEFUSAF
        UPRUQMTURBCEGUOAGUPRUQNTAUQUFABQZERCQZERUCZUTVAUGSERUQIUHZAVBUTVAUDSERU
        QJUHZUIVCVDAUJULERUQLTUMUN $.

      ${
        plydiv.0 $e |- ( ph ->
                         ( F = 0p \/ ( ( deg ` F ) - ( deg ` G ) ) < 0 ) ) $.
        $( Lemma for ~ plydivex .  Base case of induction.  (Contributed by
           Mario Carneiro, 24-Jul-2014.) $)
        plydivlem3 $p |- ( ph -> E. q e. ( Poly ` S )
          ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) $=
          ( c0p cfv cc vz cply wcel cmul cof co cmin wceq cdgr clt wbr wrex wss
          wo plybss ply0 3syl cc0 cv cvv cnex a1i wf wfn plyf ffn inidm offn wa
          eqidd 0pval adantl ofval ffvelrnda mul01d eqtrd subid1d offveq eqeq1d
          syl caddc fveq2d cn0 dgrcl nn0red recnd addid2d eqcomd breq12d cr 0re
          ltsubaddd bitr4d orbi12d mpbird oveq2d syl5eq breq1d rspcev syl2anc
          oveq2 ) AREUBSZUCZFGRUDUEZUFZUGUEZUFZRUHZXGUISZGUISZUJUKZUNZDRUHZDUIS
          ZXJUJUKZUNZHXBULAFXBUCZETUMXCMEFUOEUPUQZAXLFRUHZFUISZXJUGUFURUJUKZUNQ
          AXHXSXKYAAXGFRAUATUAUSZFSZURUGFXEFUTTUTUCAVAVBZAXQTTFVCZFTVDMEFVEZTTF
          VFUQZATTUDTGRUTUTAGXBUCZTTGVCZGTVDNEGVEZTTGVFUQZAXCTTRVCRTVDXRERVETTR
          VFUQZYDYDTVGZVHYGAYBTUCZVIZYCVJYOYBXESYBGSZURUDUFURATTYPURUDTGRUTUTYB
          YKYLYDYDYMYOYPVJYNYBRSURUHAYBVKVLVMYOYPATTYBGAYHYINYJVTVNVOVPYOYCATTY
          BFAXQYEMYFVTVNVQVRZVSAXKXTURXJWAUFZUJUKYAAXIXTXJYRUJAXGFUIYQWBAYRXJAX
          JAXJAXJAYHXJWCUCNEGWDVTWEZWFWGWHWIAXTXJURAXTAXQXTWCUCMEFWDVTWEYSURWJU
          CAWKVBWLWMWNWOXPXLHRXBHUSZRUHZXMXHXOXKUUADXGRUUADFGYTXDUFZXFUFXGPUUAU
          UBXEFXFYTRGXDXAWPWQZVSUUAXNXIXJUJUUADXGUIUUCWBWRWNWSWT $.
      $}

      ${
        $d p ph $.
        plydiv.d $e |- ( ph -> D e. NN0 ) $.
        plydiv.e $e |- ( ph -> ( M - N ) = D ) $.
        plydiv.fz $e |- ( ph -> F =/= 0p ) $.
        plydiv.u $e |- U = ( f oF - ( G oF x. p ) ) $.
        plydiv.h $e |- H =
          ( z e. CC |-> ( ( ( A ` M ) / ( B ` N ) ) x. ( z ^ D ) ) ) $.
        plydiv.al $e |- ( ph -> A. f e. ( Poly ` S )
          ( ( f = 0p \/ ( ( deg ` f ) - N ) < D ) ->
            E. p e. ( Poly ` S ) ( U = 0p \/ ( deg ` U ) < N ) ) ) $.
        plydiv.a $e |- A = ( coeff ` F ) $.
        plydiv.b $e |- B = ( coeff ` G ) $.
        plydiv.m $e |- M = ( deg ` F ) $.
        plydiv.n $e |- N = ( deg ` G ) $.
        $( Lemma for ~ plydivex .  Induction step.  (Contributed by Mario
           Carneiro, 26-Jul-2014.) $)
        plydivlem4 $p |- ( ph -> E. q e. ( Poly ` S )
          ( R = 0p \/ ( deg ` R ) < N ) ) $=
          ( cmul cof co cmin cv c0p wceq cdgr cfv clt wo cply wrex wcel wi wral
          wbr cc wss cn0 plybss syl c1 cc0 wf plydivlem1 coef2 syl2anc syl5eqel
          cdiv dgrcl ffvelrnd sseldd wne wb dgreq0 necon3bid mpbid divrecd fvex
          eleq1 neeq1 anbi12d anbi2d oveq2 eleq1d imbi12d vtocl caovcld eqeltrd
          wa mp2and syl3anc cle ccoe cif eqid caddc syl6eq fveq1d eqtr4d oveq1d
          ex fveq2 nn0cnd eqtrd cvv wfn coef3 ffn 3syl a1i fveq2d adantr nn0red
          inidm breq1d orbi12d syl5eq eqeq1d plyf adantl off oveq2d csn divne0d
          ply1term plymul plysub dgrsub cxp coe1term iftrue ax-mp c0ex fvconst2
          3netr4d necon3i dgrmul syl22anc dgr1term npcand ifeq1d breqtrd coesub
          coe0 nn0ex eqidd coemulhi divcan1d 3eqtr3d ofval mpdan subidd ltsub1d
          3eqtrd breq2d bitrd orbi2d dgrlt bitr3d mpbir2and eqeq1 oveq1 rexbidv
          ifid rspcv syl3c simpr adantlr plyadd cnex w3a subsub4 caofass mulcom
          mulcl caofcom adddi caofdi biimpa rspcev rexlimdva mpd ) ALNMUQURZUSZ
          UTURZUSZMRVAZUXAUSZUXCUSZVBVCZUXGVDVEZPVFVMZVGZRIVHVEZVIZHVBVCZHVDVEZ
          PVFVMZVGZQUXLVIZAUXDUXLVJZKVAZVBVCZUXTVDVEZPUTUSZGVFVMZVGZJVBVCZJVDVE
          ZPVFVMZVGZRUXLVIZVKZKUXLVLUXDVBVCZUXDVDVEZPUTUSZGVFVMZVGZUXMABCILUXBU
          CABCINMAIVNVOZOEVEZPFVEZWFUSZIVJGVPVJZNUXLVJZALUXLVJZUYQUCILVQVRZAUYT
          UYRVSUYSWFUSZUQUSIAUYRUYSAIVNUYRVUDAVPIOEAVUCVTIVJZVPIEWAUCABCISTUAUB
          WBZEILUMWCWDAOLVDVEZVPUOAVUCVUHVPVJUCILWGVRWEZWHZWIZAIVNUYSVUDAVPIPFA
          MUXLVJZVUFVPIFWAUDVUGFIMUNWCWDAPMVDVEZVPUPAVULVUMVPVJUDIMWGVRWEZWHZWI
          ZAMVBWJZUYSVTWJZUEAMVBUYSVTAVULMVBVCUYSVTVCWKUDFIMPUPUNWLVRWMWNZWOABC
          UYRVUEIIIUQTVUJAUYSIVJZVURVUEIVJZVUOVUSAVUTVURXGZVVAABVAZIVJZVVCVTWJZ
          XGZXGZVSVVCWFUSZIVJZVKAVVBXGZVVAVKBUYSPFWPVVCUYSVCZVVGVVJVVIVVAVVKVVF
          VVBAVVKVVDVUTVVEVURVVCUYSIWQVVCUYSVTWRWSWTVVKVVHVUEIVVCUYSVSWFXAXBXCU
          AXDXSXHXEXFZUGDUYTINGUKUUCXIZUDSTUUDZSTUBUUEZULAUYPUYMOXJVMZOUXDXKVEZ
          VEZVTVCZAUYMOUXBVDVEZXJVMZVVTOXLZOXJAVUCUXBUXLVJZUYMVWBXJVMUCVVNILUXB
          OVVTUOVVTXMUUFWDAVWBVWAOOXLOAVWAVVTOOAVVTNVDVEZPXNUSZOAVUBNVBWJZVULVU
          QVVTVWEVCVVMAGNXKVEZVEZGVPVTUUAUUGZVEZWJVWFAUYTVTVWHVWJAUYRUYSVUKVUPA
          LVBWJUYRVTWJUIALVBUYRVTAVUCLVBVCUYRVTVCWKUCEILOUOUMWLVRWMWNVUSUUBZAVW
          HGGVCZUYTVTXLZUYTAUYTVNVJZVUAVUAVWHVWMVCAIVNUYTVUDVVLWIZUGUGDUYTNGGUK
          UUHXIVWLVWMUYTVCGXMVWLUYTVTUUIUUJXOZAVUAVWJVTVCUGVPVTGUUKUULVRUUMNVBV
          WHVWJNVBVCZGVWGVWIVWQVWGVBXKVEVWINVBXKXTUVBXOXPUUNVRUDUEINMVWDPVWDXMZ
          UPUUOUUPAVWEOPUTUSZPXNUSOAVWDVWSPXNAVWDGVWSAVWNUYTVTWJVUAVWDGVCVWOVWK
          UGDUYTNGUKUUQXIZUHXQXRAOPAOVUIYAAPVUNYAUURYBZYBUUSVWAOUWBXOUUTAVVROEU
          XBXKVEZUXCUSZVEZUYRUYRUTUSZVTAOVVQVXCAVUCVWCVVQVXCVCUCVVNEVXBILUXBUMV
          XBXMZUVAWDXPAOVPVJZVXDVXEVCVUIAVPVPUYRUYRUTVPEVXBYCYCOAVUCVPVNEWAEVPY
          DUCEILUMYEVPVNEYFYGAVWCVPVNVXBWAVXBVPYDVVNVXBIUXBVXFYEVPVNVXBYFYGVPYC
          VJAUVCYHZVXHVPYLAVXGXGUYRUVDAOVXBVEZUYRVCVXGAVWEVXBVEZVWDVWGVEZUYSUQU
          SZVXIUYRAVUBVULVXJVXLVCVVMUDVWGFINMVWDPVWGXMUNVWRUPUVEWDAVWEOVXBVXAYI
          AVXLUYTUYSUQUSUYRAVXKUYTUYSUQAVXKVWHUYTAVWDGVWGVWTYIVWPYBXRAUYRUYSVUK
          VUPVUSUVFYBUVGYJUVHUVIAUYRVUKUVJUVLAUYLUYMOVFVMZVGZUYPVVPVVSXGZAVXMUY
          OUYLAVXMUYNVWSVFVMUYOAUYMOPAUYMAUXSUYMVPVJVVOIUXDWGVRYKAOVUIYKAPVUNYK
          UVKAVWSGUYNVFUHUVMUVNUVOAUXSVXGVXNVXOWKVVOVUIVVQIUXDOUYMUYMXMVVQXMUVP
          WDUVQUVRUYKUYPUXMVKKUXDUXLUXTUXDVCZUYEUYPUYJUXMVXPUYAUYLUYDUYOUXTUXDV
          BUVSVXPUYCUYNGVFVXPUYBUYMPUTUXTUXDVDXTXRYMYNVXPUYIUXKRUXLVXPUYFUXHUYH
          UXJVXPJUXGVBVXPJUXTUXFUXCUSUXGUJUXTUXDUXFUXCUVTYOZYPVXPUYGUXIPVFVXPJU
          XGVDVXQYIYMYNUWAXCUWCUWDAUXKUXRRUXLAUXEUXLVJZXGZUXKUXRVXSUXKXGNUXEXNU
          RZUSZUXLVJZLMVYAUXAUSZUXCUSZVBVCZVYDVDVEZPVFVMZVGZUXRVXSVYBUXKVXSBCIN
          UXEAVUBVXRVVMYJZAVXRUWEAVVDCVAZIVJXGVVCVYJXNUSIVJVXRSUWFUWGYJVXSUXKVY
          HVXSUXHVYEUXJVYGVXSUXGVYDVBVXSUXGLUXBUXFVXTUSZUXCUSVYDVXSBCDVNXNUTVNU
          TLUXBUXFUTYCVNYCVJVXSUWHYHZVXSVUCVNVNLWAAVUCVXRUCYJILYQVRVXSBCVNVNVNU
          QVNVNVNNMYCYCVVCVNVJZVYJVNVJZXGZVVCVYJUQUSZVNVJVXSVVCVYJUWMYRZVXSVUBV
          NVNNWAVYIINYQVRZVXSVULVNVNMWAAVULVXRUDYJIMYQVRZVYLVYLVNYLZYSVXSBCVNVN
          VNUQVNVNVNMUXEYCYCVYQVYSVXRVNVNUXEWAAIUXEYQYRZVYLVYLVYTYSVYMVYNDVAZVN
          VJUWIZVVCVYJUTUSWUBUTUSVVCVYJWUBXNUSZUTUSVCVXSVVCVYJWUBUWJYRUWKVXSVYK
          VYCLUXCVXSVYKMNUXAUSZUXFVXTUSVYCVXSUXBWUEUXFVXTVXSBCVNUQVNNMYCVYLVYRV
          YSVYOVYPVYJVVCUQUSVCVXSVVCVYJUWLYRUWNXRVXSBCDVNXNVNUQMNUXEVNXNYCVYLVY
          SVYRWUAWUCVVCWUDUQUSVYPVVCWUBUQUSXNUSVCVXSVVCVYJWUBUWOYRUWPXQYTYBZYPV
          XSUXIVYFPVFVXSUXGVYDVDWUFYIYMYNUWQUXQVYHQVYAUXLQVAZVYAVCZUXNVYEUXPVYG
          WUHHVYDVBWUHHLMWUGUXAUSZUXCUSVYDUFWUHWUIVYCLUXCWUGVYAMUXAXAYTYOZYPWUH
          UXOVYFPVFWUHHVYDVDWUJYIYMYNUWRWDXSUWSUWT $.
      $}

      ${
        $d f p ph $.
        $( Lemma for ~ plydivalg .  (Contributed by Mario Carneiro,
           24-Jul-2014.) $)
        plydivex $p |- ( ph -> E. q e. ( Poly ` S )
          ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) $=
          ( co clt wo wcel vd vf vg vz vp vw cdgr cfv cmin cv wbr wrex c0p wceq
          cn cply cr cn0 dgrcl syl nn0red resubcld arch wa olc cmul cof wi wral
          adantr nnnn0 cc0 caddc breq2 orbi2d imbi1d ralbidv imbi2d weq adantlr
          c1 cdiv cneg simprl eqid simprr plydivlem3 expr ralrimiva eqeq1 fveq2
          wne oveq1d breq1d orbi12d oveq1 eqeq1d fveq2d rexbidv imbi12d cbvralv
          ccoe cc cexp cmpt simplll sylan simplr simpllr simprrr simprrl oveq2d
          cbvmptv oveq2 cbvrexv imbi2i ralbii sylib plydivlem4 ralrimdva syl5bi
          exp32 ancld cz wb adantl nn0zd ad2antrr zsubcld nn0z ad2antlr zleltp1
          cle syl2anc zred nn0re orbi2i bitr4i or12 syl6bb leloed bitr3d pm5.63
          wn df-ne anbi1i 3bitr4i orass jaob ralbidva r19.26 sylibrd expcom a2d
          nn0ind impcom syl6eqr rspcv sylc syl5 rexlimdva mpd ) AFUGUHZGUGUHZUI
          QZUAUJZRUKZUAUOULZDUMUNZDUGUHZUVDRUKZSZHEUPUHZULZAUVEUQTUVHAUVCUVDAUV
          CAFUVMTZUVCURTMEFUSUTVAAUVDAGUVMTZUVDURTZNEGUSZUTVAVBUVEUAVCUTAUVGUVN
          UAUOUVGFUMUNZUVGSZAUVFUOTZVDZUVNUVGUVSVEUWBUVOUBUJZUMUNZUWCUGUHZUVDUI
          QZUVFRUKZSZUWCGHUJZVFVGZQZUIVGZQZUMUNZUWMUGUHZUVDRUKZSZHUVMULZVHZUBUV
          MVIZUVTUVNVHZAUVOUWAMVJUWAAUWTUWAUVFURTZAUWTVHZUVFVKAUWDUWFBUJZRUKZSZ
          UWRVHZUBUVMVIZVHAUWDUWFVLRUKZSZUWRVHZUBUVMVIZVHUXCAUWDUWFUVFWAVMQZRUK
          ZSZUWRVHZUBUVMVIZVHUXCBUAUVFUXDVLUNZUXHUXLAUXRUXGUXKUBUVMUXRUXFUXJUWR
          UXRUXEUXIUWDUXDVLUWFRVNVOVPVQVRBUAVSZUXHUWTAUXSUXGUWSUBUVMUXSUXFUWHUW
          RUXSUXEUWGUWDUXDUVFUWFRVNVOVPVQVRZUXDUXMUNZUXHUXQAUYAUXGUXPUBUVMUYAUX
          FUXOUWRUYAUXEUXNUWDUXDUXMUWFRVNVOVPVQVRUXTAUXKUBUVMAUWCUVMTZUXJUWRAUY
          BUXJVDZVDBCUWMEUWCGHAUXDETZCUJZETVDZUXDUYEVMQETZUYCIVTAUYFUXDUYEVFQET
          ZUYCJVTAUYDUXDVLWLVDZWAUXDWBQETZUYCKVTAWAWCETZUYCLVJAUYBUXJWDAUVPUYCN
          VJAGUMWLZUYCOVJUWMWEZAUYBUXJWFWGWHWIUXBAUWTUXQAUXBUWTUXQVHAUXBVDZUWTU
          WTUWCUMWLZUWFUVFUNZVDZUWRVHZUBUVMVIZVDZUXQUYNUWTUYSUWTUCUJZUMUNZVUAUG
          UHZUVDUIQZUVFRUKZSZVUAUWKUWLQZUMUNZVUGUGUHZUVDRUKZSZHUVMULZVHZUCUVMVI
          ZUYNUYSUWSVUMUBUCUVMUBUCVSZUWHVUFUWRVULVUOUWDVUBUWGVUEUWCVUAUMWJVUOUW
          FVUDUVFRVUOUWEVUCUVDUIUWCVUAUGWKWMWNWOVUOUWQVUKHUVMVUOUWNVUHUWPVUJVUO
          UWMVUGUMUWCVUAUWKUWLWPZWQVUOUWOVUIUVDRVUOUWMVUGUGVUPWRWNWOWSWTXAUYNVU
          NUYRUBUVMUYNUYBVDZVUNUYQUWRVUQVUNUYQVDZVDZBCUDUWCXBUHZGXBUHZUVFUWMEVU
          AGUEUJZUWJQZUWLQZUCUWCGUFXCUWEVUTUHUVDVVAUHWBQZUFUJZUVFXDQZVFQZXEUWEU
          VDHUEVUSAUYFUYGAUXBUYBVURXFZIXGVUSAUYFUYHVVIJXGVUSAUYIUYJVVIKXGVUSAUY
          KVVILUTUYNUYBVURXHVUSAUVPVVINUTVUSAUYLVVIOUTUYMAUXBUYBVURXIVUQVUNUYOU
          YPXJVUQVUNUYOUYPXKVVDWEUFUDXCVVHVVEUDUJZUVFXDQZVFQUFUDVSVVGVVKVVEVFVV
          FVVJUVFXDWPXLXMVUSVUNVUFVVDUMUNZVVDUGUHZUVDRUKZSZUEUVMULZVHZUCUVMVIVU
          QVUNUYQWDVUMVVQUCUVMVULVVPVUFVUKVVOHUEUVMHUEVSZVUHVVLVUJVVNVVRVUGVVDU
          MVVRUWKVVCVUAUWLUWIVVBGUWJXNXLZWQVVRVUIVVMUVDRVVRVUGVVDUGVVSWRWNWOXOX
          PXQXRVUTWEVVAWEUWEWEUVDWEXSYBXTYAYCUYNUXQUWSUYRVDZUBUVMVIUYTUYNUXPVVT
          UBUVMVUQUXPUWHUYQSZUWRVHVVTVUQUXOVWAUWRVUQUXOUWDUWGUYPSZSZVWAVUQUXNVW
          BUWDVUQUWFUVFYMUKZUXNVWBVUQUWFYDTUVFYDTZVWDUXNYEVUQUWEUVDVUQUWEUYBUWE
          URTUYNEUWCUSYFYGVUQUVDVUQUVPUVQAUVPUXBUYBNYHUVRUTYGYIZUXBVWEAUYBUVFYJ
          YKUWFUVFYLYNVUQUWFUVFVUQUWFVWFYOUXBUVFUQTAUYBUVFYPYKUUAUUBVOVWCUWDUWG
          UYQSSZVWAUWGUWDUYPSZSUWGUWDUYQSZSVWCVWGVWHVWIUWGVWHUWDUWDUUDZUYPVDZSV
          WIUWDUYPUUCUYQVWKUWDUYOVWJUYPUWCUMUUEUUFYQYRYQUWDUWGUYPYSUWDUWGUYQYSU
          UGUWDUWGUYQUUHYRYTVPUWHUWRUYQUUIYTUUJUWSUYRUBUVMUUKYTUULUUMUUNUUOUTUU
          PUWSUXAUBFUVMUWCFUNZUWHUVTUWRUVNVWLUWDUVSUWGUVGUWCFUMWJVWLUWFUVEUVFRV
          WLUWEUVCUVDUIUWCFUGWKWMWNWOVWLUWQUVLHUVMVWLUWNUVIUWPUVKVWLUWMDUMVWLUW
          MFUWKUWLQDUWCFUWKUWLWPPUUQZWQVWLUWOUVJUVDRVWLUWMDUGVWMWRWNWOWSWTUURUU
          SUUTUVAUVB $.
      $}

      ${
        plydiveu.q $e |- ( ph -> q e. ( Poly ` S ) ) $.
        plydiveu.qd $e |- ( ph -> ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) $.
        plydiveu.t $e |- T = ( F oF - ( G oF x. p ) ) $.
        plydiveu.p $e |- ( ph -> p e. ( Poly ` S ) ) $.
        plydiveu.pd $e |- ( ph -> ( T = 0p \/ ( deg ` T ) < ( deg ` G ) ) ) $.
        $( Lemma for ~ plydivalg .  (Contributed by Mario Carneiro,
           24-Jul-2014.) $)
        plydiveu $p |- ( ph -> p = q ) $=
          ( vz cv cmin cof co cc cc0 csn cxp wceq c0p idd wne cdgr cfv ccoe cle
          wa wbr cif cply wcel cn0 plydivlem2 mpdan plysub dgrcl nn0red cr ifcl
          syl syl2anc eqid dgrsub clt wo dgrlt mpbid simpld breq1 ifboth adantr
          wb letrd caddc nn0addge1 cmul cmpt wf plyf ffvelrnda plymul mpteq2dva
          nnncan1d cvv cnex a1i subcld feqmptd offval2 syl5eq 3eqtr4d w3a subdi
          adantl caofdi eqtr4d fveq2d simpr syl22anc breqtrrd letri3d mpbir2and
          dgrmul eqtrd coesub fveq1d wfn coef3 ffn nn0ex inidm simprd ofval 0cn
          3syl subidi syl6eq dgreq0 biimpar syldan ex plymul0or eqeq1d wn biorf
          neneqd 3bitr4d sylibd pm2.61dne df-0p ofsubeq0 syl3anc ) AJUEZIUEZUFU
          GZUHZUIUJUKULZUMZUUGUUHUMZAUUJUNUUKAUUJUNUMZUUJUNAUUNUOAUUJUNUPZDFUUI
          UHZUNUMZUUNAUUOUUQAUUOUUPUQURZUUPUSURZURZUJUMZUUQAUUOVAZUUTHUQURZUUSU
          RZUJUVBUURUVCUUSUVBUURUVCUMZUURUVCUTVBZUVCUURUTVBZAUVFUUOAUURDUQURZFU
          QURZUTVBZUVIUVHVCZUVCAUURAUUPEVDURZVEZUURVFVEABCEDFAUUHUVLVEZDUVLVEZS
          ABCDEGHIKLMNOPQRVGVHZAUUGUVLVEZFUVLVEZUBABCFEGHJKLMNOPQUAVGVHZKLNVIZE
          UUPVJVNVKZAUVIVLVEUVHVLVEUVKVLVEAUVIAUVRUVIVFVEUVSEFVJVNVKAUVHAUVOUVH
          VFVEUVPEDVJVNVKUVJUVIUVHVLVMVOAUVCAHUVLVEZUVCVFVEZPEHVJVNZVKZAUVOUVRU
          URUVKUTVBUVPUVSEDFUVHUVIUVHVPZUVIVPZVQVOAUVIUVCUTVBZUVHUVCUTVBZUVKUVC
          UTVBZAUWHUVCFUSURZURUJUMZAFUNUMUVIUVCVRVBVSZUWHUWLVAZUCAUVRUWCUWMUWNW
          FUVSUWDUWKEFUVCUVIUWGUWKVPZVTVOWAZWBAUWIUVCDUSURZURUJUMZADUNUMUVHUVCV
          RVBVSZUWIUWRVAZTAUVOUWCUWSUWTWFUVPUWDUWQEDUVCUVHUWFUWQVPZVTVOWAZWBUVJ
          UWHUWIUWJUVIUVHUVIUVKUVCUTWCUVHUVKUVCUTWCWDVOWGWEUVBUVCUVCUUJUQURZWHU
          HZUURUTAUVCUXDUTVBZUUOAUVCVLVEUXCVFVEZUXEUWEAUUJUVLVEZUXFABCEUUGUUHUB
          SKLNVIZEUUJVJVNUVCUXCWIVOWEUVBUURHUUJWJUGZUHZUQURZUXDAUURUXKUMUUOAUUP
          UXJUQAUUPHUUGUXIUHZHUUHUXIUHZUUIUHZUXJAUDUIUDUEZGURZUXOUXMURZUFUHZUXP
          UXOUXLURZUFUHZUFUHZWKUDUIUXSUXQUFUHZWKUUPUXNAUDUIUYAUYBAUXOUIVEZVAZUX
          PUXQUXSAUIUIUXOGAGUVLVEUIUIGWLOEGWMVNZWNZAUIUIUXOUXMAUXMUVLVEUIUIUXMW
          LABCEHUUHPSKLWOEUXMWMVNZWNZAUIUIUXOUXLAUXLUVLVEUIUIUXLWLABCEHUUGPUBKL
          WOEUXLWMVNZWNZWQWPAUDUIUXRUXTUFDFWRUIUIUIWRVEZAWSWTZUYDUXPUXQUYFUYHXA
          UYDUXPUXSUYFUYJXAADGUXMUUIUHUDUIUXRWKRAUDUIUXPUXQUFGUXMWRUIUIUYLUYFUY
          HAUDUIUIGUYEXBZAUDUIUIUXMUYGXBZXCXDAFGUXLUUIUHUDUIUXTWKUAAUDUIUXPUXSU
          FGUXLWRUIUIUYLUYFUYJUYMAUDUIUIUXLUYIXBZXCXDXCAUDUIUXSUXQUFUXLUXMWRUIU
          IUYLUYJUYHUYOUYNXCXEABCUDUIUFUIWJHUUGUUHUIUFWRUYLAUWBUIUIHWLPEHWMVNAU
          VQUIUIUUGWLZUBEUUGWMVNZAUVNUIUIUUHWLZSEUUHWMVNZBUEZUIVECUEZUIVEUYCXFU
          YTVUAUXOUFUHWJUHUYTVUAWJUHUYTUXOWJUHUFUHUMAUYTVUAUXOXGXHXIXJZXKWEUVBU
          WBHUNUPZUXGUUOUXKUXDUMAUWBUUOPWEAVUCUUOQWEAUXGUUOUXHWEAUUOXLEHUUJUVCU
          XCUVCVPUXCVPXQXMXRXNAUVEUVFUVGVAWFUUOAUURUVCUWAUWEXOWEXPXKAUVDUJUMUUO
          AUVDUJUJUFUHZUJAUVDUVCUWQUWKUUIUHZURZVUDAUVCUUSVUEAUVOUVRUUSVUEUMUVPU
          VSUWQUWKEDFUXAUWOXSVOXTAUWCVUFVUDUMUWDAVFVFUJUJUFVFUWQUWKWRWRUVCAUVOV
          FUIUWQWLUWQVFYAUVPUWQEDUXAYBVFUIUWQYCYIAUVRVFUIUWKWLUWKVFYAUVSUWKEFUW
          OYBVFUIUWKYCYIVFWRVEAYDWTZVUGVFYEAUWRUWCAUWIUWRUXBYFWEAUWLUWCAUWHUWLU
          WPYFWEYGVHXRUJYHYJYKWEXRAUUQUVAAUVMUUQUVAWFUVTUUSEUUPUURUURVPUUSVPYLV
          NYMYNYOAUXJUNUMZHUNUMZUUNVSZUUQUUNAUWBUXGVUHVUJWFPUXHEHUUJYPVOAUUPUXJ
          UNVUBYQAVUIYRUUNVUJWFAHUNQYTVUIUUNYSVNUUAUUBUUCUUDYKAUYKUYPUYRUULUUMW
          FUYLUYQUYSUIUUGUUHWRUUEUUFWA $.
      $}

      $d p q ph $.
      $( The division algorithm on polynomials over a subfield ` S ` of the
         complex numbers.  If ` F ` and ` G =/= 0 ` are polynomials over
         ` S ` , then there is a unique quotient polynomial ` q ` such that the
         remainder ` F - G x. q ` is either zero or has degree less than
         ` G ` .  (Contributed by Mario Carneiro, 26-Jul-2014.) $)
      plydivalg $p |- ( ph -> E! q e. ( Poly ` S )
        ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) $=
        ( vp co wa wcel c0p wceq cdgr cfv clt wbr wo cply wrex cv cmul cof cmin
        wi wral wreu plydivex caddc simpll sylan cc0 wne cdiv cneg eqid simplrr
        c1 syl simprr simplrl simprl plydiveu ex ralrimivva oveq2 oveq2d syl5eq
        eqeq1d fveq2d breq1d orbi12d reu4 sylanbrc ) ADUAUBZDUCUDZGUCUDZUEUFZUG
        ZHEUHUDZUIWHFGQUJZUKULZRZUMULZRZUAUBZWNUCUDZWFUEUFZUGZSZHUJZWJUBZUNZQWI
        UOHWIUOWHHWIUPABCDEFGHIJKLMNOPUQAXBHQWIWIAWTWITZWJWITZSZSZWSXAXFWSSZBCW
        NEDFGQHXGABUJZETZCUJZETSZXHXJURRETAXEWSUSZIUTXGAXKXHXJUKRETXLJUTXGAXIXH
        VAVBSVGXHVCRETXLKUTXGAVGVDETXLLVHXGAFWITXLMVHXGAGWITXLNVHXGAGUAVBXLOVHW
        NVEAXCXDWSVFXFWHWRVIPAXCXDWSVJXFWHWRVKVLVMVNWHWRHQWIXAWDWOWGWQXADWNUAXA
        DFGWTWKRZWMRWNPXAXMWLFWMWTWJGWKVOVPVQZVRXAWEWPWFUEXADWNUCXNVSVTWAWBWC
        $.
    $}

    ${
      $d q R $.  $d q ph $.
      quotlem.8 $e |- R = ( F oF - ( G oF x. ( F quot G ) ) ) $.
      $( Lemma for properties of the polynomial quotient function.
         (Contributed by Mario Carneiro, 26-Jul-2014.) $)
      quotlem $p |- ( ph -> ( ( F quot G ) e. ( Poly ` S ) /\
        ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) ) $=
        ( vq co wceq wcel cc cquot cmul cof cmin c0p cdgr cfv clt wbr cply crab
        cv wo wa crio wne eqid quotval syl3anc wrex wreu plydivalg reurex caddc
        syl addcl adantl mulcl cc0 cdiv reccl cneg neg1cn a1i plyssc sseldi wss
        c1 wi wral rgenw riotass2 mpanl12 syl2anc eqtr4d riotacl2 eqeltrd oveq2
        id oveq2d syl6eqr eqeq1d fveq2d breq1d orbi12d elrab sylib ) AFGUAQZFGP
        ULZUBUCZQZUDUCZQZUERZXCUFUGZGUFUGZUHUIZUMZPEUJUGZUKZSWRXISDUERZDUFUGZXF
        UHUIZUMZUNAWRXHPXIUOZXJAWRXHPTUJUGZUOZXOAFXISGXISGUEUPWRXQRLMNXCEFGPXCU
        QZURUSAXHPXIUTZXHPXPVAZXOXQRZAXHPXIVAZXSABCXCEFGPHIJKLMNXRVBZXHPXIVCVEA
        BCXCTFGPBULZTSZCULZTSUNZYDYFVDQTSAYDYFVFVGYGYDYFUBQTSAYDYFVHVGYEYDVIUPU
        NVRYDVJQTSAYDVKVGVRVLTSAVMVNAXIXPFEVOZLVPAXIXPGYHMVPNXRVBXIXPVQXHXHVSZP
        XIVTXSXTUNYAYHYIPXIXHWIWAXHXHPXIXPWBWCWDWEAYBXOXJSYCXHPXIWFVEWGXHXNPWRX
        IWSWRRZXDXKXGXMYJXCDUEYJXCFGWRWTQZXBQDYJXAYKFXBWSWRGWTWHWJOWKZWLYJXEXLX
        FUHYJXCDUFYLWMWNWOWPWQ $.
    $}

    $( The quotient of two polynomials in a field ` S ` is also in the field.
       (Contributed by Mario Carneiro, 26-Jul-2014.) $)
    quotcl $p |- ( ph -> ( F quot G ) e. ( Poly ` S ) ) $=
      ( cquot co cply cfv wcel cof cdgr cmul cmin c0p wceq clt wbr eqid quotlem
      wo simpld ) AEFNOZDPQREFUKUASOUBSOZUCUDULTQFTQUEUFUIABCULDEFGHIJKLMULUGUH
      UJ $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y R $.  $d x y S $.
    $( Closure of the quotient function.  (Contributed by Mario Carneiro,
       26-Jul-2014.) $)
    quotcl2 $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ G =/= 0p ) ->
                    ( F quot G ) e. ( Poly ` CC ) ) $=
      ( vx vy cply cfv wcel c0p wne w3a cc cv wa caddc co addcl adantl sseldi
      c1 cmul mulcl cc0 cdiv reccl cneg neg1cn plyssc simp1 simp2 simp3 quotcl
      a1i ) BAFGZHZCUNHZCIJZKZDELBCDMZLHZEMZLHNZUSVAOPLHURUSVAQRVBUSVAUAPLHURUS
      VAUBRUTUSUCJNTUSUDPLHURUSUERTUFLHURUGUMURUNLFGZBAUHZUOUPUQUISURUNVCCVDUOU
      PUQUJSUOUPUQUKUL $.

    quotdgr.1 $e |- R = ( F oF - ( G oF x. ( F quot G ) ) ) $.
    $( Remainder property of the quotient function.  (Contributed by Mario
       Carneiro, 26-Jul-2014.) $)
    quotdgr $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ G =/= 0p ) ->
                    ( R = 0p \/ ( deg ` R ) < ( deg ` G ) ) ) $=
      ( vx vy cply cfv wcel c0p wne co cc cdgr cv wa adantl c1 sseldi w3a cquot
      wceq clt wbr caddc addcl cmul mulcl cc0 cdiv reccl cneg neg1cn a1i plyssc
      wo simp1 simp2 simp3 quotlem simprd ) CBHIZJZDVCJZDKLZUAZCDUBMNHIZJAKUCAO
      IDOIUDUEUQVGFGANCDFPZNJZGPZNJQZVIVKUFMNJVGVIVKUGRVLVIVKUHMNJVGVIVKUIRVJVI
      UJLQSVIUKMNJVGVIULRSUMNJVGUNUOVGVCVHCBUPZVDVEVFURTVGVCVHDVMVDVEVFUSTVDVEV
      FUTEVAVB $.
  $}

  ${
    $d z A $.  $d z F $.  $d z G $.  $d z S $.
    plyrem.1 $e |- G = ( Xp oF - ( CC X. { A } ) ) $.
    $( Closure of a linear factor.  (Contributed by Mario Carneiro,
       26-Jul-2014.) $)
    plyremlem $p |- ( A e. CC ->
    ( G e. ( Poly ` CC ) /\ ( deg ` G ) = 1 /\ ( `' G " { 0 } ) = { A } ) ) $=
      ( vz cc wcel cfv cdgr c1 wceq cc0 csn cidp cmin co caddc cmpt wa cvv a1i
      cply ccnv cima cxp cof wss ssid ax-1cn plyid mp2an plyconst mpan plysubcl
      sylancr syl5eqel cneg cv negcl addcom sylan negsub ancoms eqtrd mpteq2dva
      cnex negex simpr fconstmpt cid cres df-idp mptresid offval2 simpl 3eqtr4d
      eqtr4i syl6eqr fveq2d clt wbr 0dgr syl 0lt1 syl6eqbr dgrid eqcomi dgradd2
      eqid syl3anc eqtr3d syl5eq fveq1d adantr ovex fvmpt2 sylancl eqeq1d bitrd
      wb subeq0 pm5.32da wf wfn plyf fniniseg 4syl eleq1a pm4.71rd 3bitr4d elsn
      ffn syl6bbr eqrdv 3jca ) AEFZBEUAGZFZBHGZIJBUBKLUCZALZJXOBMEXTUDZNUEOZXPC
      XOMXPFZYAXPFZYBXPFEEUFZIEFYCEUGZUHEUIUJZYEXOYDYFAEUKULEMYAUMUNUOZXOEAUPZL
      UDZMPUEOZHGZXRIXOYKBHXOYKYBBXODEYIDUQZPOZQDEYMANOZQZYKYBXODEYNYOXOYMEFZRZ
      YNYMYIPOZYOXOYIEFZYQYNYSJAURZYIYMUSUTYQXOYSYOJYMAVAVBVCVDXODEYIYMPYJMSSEE
      SFXOVETZYISFYRAVFTXOYQVGZYJDEYIQJXODEYIVHTMDEYMQZJXOMVIEVJUUDVKDEVLVPTZVM
      XODEYMANMYASEEUUBUUCXOYQVNUUEYADEAQJXODEAVHTVMZVOCVQVRXOYJXPFZYCYJHGZIVSV
      TYLIJXOYEYTUUGYFUUAYIEUKUNYCXOYGTXOUUHKIVSXOYTUUHKJUUAYIWAWBWCWDEYJMUUHIU
      UHWHMHGIWEWFWGWIWJXODXSXTXOYMXSFZYMAJZYMXTFXOYQYMBGZKJZRZYQUUJRUUIUUJXOYQ
      UULUUJYRUULYOKJZUUJYRUUKYOKYRUUKYMYPGZYOXOUUKUUOJYQXOYMBYPXOBYBYPCUUFWKWL
      WMYRYQYOSFUUOYOJUUCYMANWNDEYOSYPYPWHWOWPVCWQYQXOUUNUUJWSYMAWTVBWRXAXOXQEE
      BXBBEXCUUIUUMWSYHEBXDEEBXKEKYMBXEXFXOUUJYQAEYMXGXHXIDAXJXLXMXN $.

    plyrem.2 $e |- R = ( F oF - ( G oF x. ( F quot G ) ) ) $.
    $( The polynomial remainder theorem, or little B&eacute;zout's theorem (by
       contrast to the regular B&eacute;zout's theorem ~ bezout ).  If a
       polynomial ` F ` is divided by the linear factor ` x - A ` , the
       remainder is equal to ` F ( A ) ` , the evaluation of the polynomial at
       ` A ` (interpreted as a constant polynomial).  (Contributed by Mario
       Carneiro, 26-Jul-2014.) $)
    plyrem $p |- ( ( F e. ( Poly ` S ) /\ A e. CC ) ->
                   R = ( CC X. { ( F ` A ) } ) ) $=
      ( cfv wcel cc cc0 csn cdgr wceq c1 clt c0p syl wb cvv cply wa cxp wbr wne
      wo wi plyssc simpl sseldi ccnv w3a plyremlem adantl simp1d simp2d ax-1ne0
      cima a1i eqnetrd fveq2 dgr0 syl6eq necon3i quotdgr syl3anc 0lt1 syl5breqr
      breq1d syl5ibrcom pm2.62 sylc breqtrd cn0 cquot co cmul cof cmin plymulcl
      quotcl2 plysubcl syl5eqel dgrcl nn0lt10b mpbid 0dgrb fveq1d fveq1i wf wfn
      syl2anc plyf adantr ffn cnex inidm eqidd cun simp3d ssun1 syl6eqssr snssg
      offn wss mpbird ofmulrt eleqtrrd fniniseg simprd anabss3 syl5eq ffvelrnda
      ofval subid1d eqtrd fvex fvconst2 3eqtr3d sneqd xpeq2d eqtr4d ) DCUAHZIZA
      JIZUBZBJKBHZLZUCZJADHZLZUCYFBMHZKNZBYINZYFYLOPUDZYMYFYLEMHZOPYFBQNZYLYPPU
      DZUFZYQYRUGYRYFDJUAHZIZEYTIZEQUEZYSYFYCYTDCUHYDYEUIUJZYFUUBYPONZEUKKLZURZ
      ALZNZYEUUBUUEUUIULYDAEFUMUNZUOZYFYPKUEUUCYFYPOKYFUUBUUEUUIUUJUPZOKUEYFUQU
      SUTEQYPKEQNYPQMHZKEQMVAVBVCVDRZBJDEGVEVFYFYRYQKYPPUDYFKOYPPVGUULVHYQYLKYP
      PYQYLUUMKBQMVAVBVCVIVJYQYRVKVLUULVMYFYLVNIZYOYMSYFBYTIZUUOYFBDEDEVOVPZVQV
      RVPZVSVRVPZYTGYFUUAUURYTIZUUSYTIUUDYFUUBUUQYTIZUUTUUKYFUUAUUBUUCUVAUUDUUK
      UUNJDEWAVFZJEUUQVTWLJDUURWBWLWCZJBWDRYLWERWFYFUUPYMYNSUVCJBWGRWFZYFYKYHJY
      FYJYGYFABHZAYIHZYJYGYFABYIUVDWHYFUVEYJKVSVPZYJYFUVEAUUSHZUVGABUUSGWIYDYEU
      VHUVGNYFJJYJKVSJDUURTTAYFJJDWJZDJWKYDUVIYECDWMZWNJJDWORYFJJVQJEUUQTTYFJJE
      WJZEJWKYFUUBUVKUUKJEWMRZJJEWORYFJJUUQWJZUUQJWKYFUVAUVMUVBJUUQWMRZJJUUQWOR
      JTIZYFWPUSZUVPJWQZXDZUVPUVPUVQYFYEUBYJWRYFAUURHKNZYEYFYEUVSYFAUURUKUUFURZ
      IZYEUVSUBZYFAUUGUUQUKUUFURZWSZUVTYFAUWDIZUUHUWDXEZYFUUHUUGUWDYFUUBUUEUUIU
      UJWTUUGUWCXAXBYEUWEUWFSYDAUWDJXCUNXFYFUVOUVKUVMUVTUWDNUVPUVLUVNJEUUQTXGVF
      XHYFUURJWKUWAUWBSUVRJKAUURXIRWFXJWNXNXKXLYFYJYDJJADUVJXMXOXPYEUVFYGNYDJYG
      AKBXQXRUNXSXTYAYB $.
  $}

  ${
    facth.1 $e |- G = ( Xp oF - ( CC X. { A } ) ) $.
    $( The factor theorem.  If a polynomial ` F ` has a root at ` A ` , then
       ` G = x - A ` is a factor of ` F ` (and the other factor is
       ` F quot G ` ).  (Contributed by Mario Carneiro, 26-Jul-2014.) $)
    facth $p |- ( ( F e. ( Poly ` S ) /\ A e. CC /\ ( F ` A ) = 0 ) ->
                   F = ( G oF x. ( F quot G ) ) ) $=
      ( cply cfv wcel cc cc0 wceq w3a co cof csn syl cdgr c1 c0p wne cquot cmul
      cmin cxp eqid plyrem 3adant3 simp3 sneqd xpeq2d eqtrd cvv wf wb a1i simp1
      cnex plyf ccnv cima plyremlem simp1d plyssc sseldi simp2d ax-1ne0 eqnetrd
      3ad2ant2 fveq2 dgr0 syl6eq necon3i quotcl2 syl3anc plymulcl syl2anc mpbid
      ofsubeq0 ) CBFGZHZAIHZACGZJKZLZCDCDUAMZUBNMZUCNMZIJOZUDZKZCWFKZWDWGIWBOZU
      DZWIVTWAWGWMKWCAWGBCDEWGUEUFUGWDWLWHIWDWBJVTWAWCUHUIUJUKWDIULHZIICUMZIIWF
      UMZWJWKUNWNWDUQUOWDVTWOVTWAWCUPZBCURPWDWFIFGZHZWPWDDWRHZWEWRHZWSWDWTDQGZR
      KZDUSWHUTAOKZWAVTWTXCXDLWCADEVAVHZVBZWDCWRHWTDSTZXAWDVSWRCBVCWQVDXFWDXBJT
      XGWDXBRJWDWTXCXDXEVERJTWDVFUOVGDSXBJDSKXBSQGJDSQVIVJVKVLPICDVMVNIDWEVOVPI
      WFURPICWFULVRVNVQ $.
  $}

  ${
    $d g x z A $.  $d g D $.  $d d f g x F $.  $d x z ph $.  $d f R $.
    fta1.1 $e |- R = ( `' F " { 0 } ) $.
    ${
      fta1.2 $e |- ( ph -> D e. NN0 ) $.
      fta1.3 $e |- ( ph -> F e. ( ( Poly ` CC ) \ { 0p } ) ) $.
      fta1.4 $e |- ( ph -> ( deg ` F ) = ( D + 1 ) ) $.
      fta1.5 $e |- ( ph -> A e. ( `' F " { 0 } ) ) $.
      fta1.6 $e |- ( ph -> A. g e. ( ( Poly ` CC ) \ { 0p } )
        ( ( deg ` g ) = D -> ( ( `' g " { 0 } ) e. Fin /\
          ( # ` ( `' g " { 0 } ) ) <_ ( deg ` g ) ) ) ) $.
      $( Lemma for ~ fta1 .  (Contributed by Mario Carneiro, 26-Jul-2014.) $)
      fta1lem $p |- ( ph -> ( R e. Fin /\ ( # ` R ) <_ ( deg ` F ) ) ) $=
        ( wcel cfv cc co cc0 wceq c0p c1 vx cfn chash cdgr cle wbr cidp csn cxp
        cmin cof cquot ccnv cima cun cmul cply wne cdif wa eldifsn sylib simpld
        wf wfn wb plyf ffn fniniseg 4syl mpbid simprd eqid facth syl3anc cnveqd
        imaeq1d cvv cnex a1i wss ssid plyid mp2an plyconst sylancr plysubcl syl
        ax-1cn w3a plyremlem simp2d ax-1ne0 eqnetrd dgr0 syl6eq necon3i quotcl2
        fveq2 ofmulrt simp3d uneq1d 3eqtrd uncom 3eqtr4g cv wi eqcomd 0cn mul01
        wral adantl caofid1 df-0p oveq2i 3netr4d oveq2 sylanbrc cn0 dgrcl caddc
        nn0cnd addcom fveq2d dgrmul syl22anc 3eqtr3d oveq1d eqeq1d cnveq eleq1d
        3eqtrrd addcanad breq12d anbi12d sylancl hashcl nn0red cr breqtrd rspcv
        imbi12d syl3c snfi eqeltrd peano2re hashun2 hashsng oveq2d 1re leadd1dd
        unfi breqtrrd letrd eqbrtrd jca ) ADUBMDUCNZFUDNZUEUFADFUGOBUHZUIZUJUKP
        ZULPZUMZQUHZUNZUUSUOZUBAFUMZUVDUNZUUSUVEUOZDUVFAUVHUVAUVBUPUKZPZUMZUVDU
        NZUVAUMUVDUNZUVEUOZUVIAUVGUVLUVDAFUVKAFOUQNZMZBOMZBFNQRZFUVKRAUVQFSURZA
        FUVPSUHUSZMUVQUVTUTIFUVPSVAVBZVCZAUVRUVSABUVHMZUVRUVSUTZKAUVQOOFVDFOVEU
        WDUWEVFUWCOFVGOOFVHOQBFVIVJVKZVCZAUVRUVSUWFVLBOFUVAUVAVMZVNVOZVPVQAOVRM
        ZOOUVAVDZOOUVBVDZUVMUVORUWJAVSVTZAUVAUVPMZUWKAUGUVPMZUUTUVPMZUWNOOWAZTO
        MZUWOOWBZWIOWCWDAUWQUVRUWPUWSUWGBOWEWFOUGUUTWGWFZOUVAVGWHZAUVBUVPMZUWLA
        UVQUWNUVASURZUXBUWCUWTAUVAUDNZQURUXCAUXDTQAUWNUXDTRZUVNUUSRZAUVRUWNUXEU
        XFWJUWGBUVAUWHWKWHZWLZTQURAWMVTWNUVASUXDQUVASRUXDSUDNQUVASUDWSWOWPWQWHZ
        OFUVAWRVOZOUVBVGWHOUVAUVBVRWTVOAUVNUUSUVEAUWNUXEUXFUXGXAXBXCGUVEUUSXDXE
        ZAUVEUBMZUUSUBMZUVFUBMZAUXLUVEUCNZUVBUDNZUEUFZAUVBUWAMZEXFZUDNZCRZUXSUM
        ZUVDUNZUBMZUYCUCNZUXTUEUFZUTZXGZEUWAXKUXPCRZUXLUXQUTZAUXBUVBSURZUXRUXJA
        UVKUVASUVJPZURUYKAFSUVKUYLAUVQUVTUWBVLAFUVKUWIXHAUVAOUVDUIZUVJPUYMUYLSA
        UAOQQUPOUVAVROOUWMUXAQOMAXIVTZUYNUAXFZOMUYOQUPPQRAUYOXJXLXMSUYMUVAUVJXN
        XOXNXEXPUVBSUVKUYLUVBSUVAUVJXQWQWHZUVBUVPSVAXRLATUXPCUWRAWIVTAUXPAUXBUX
        PXSMUXJOUVBXTWHYBACHYBZATCYAPZCTYAPZUXDUXPYAPZTUXPYAPAUWRCOMUYRUYSRWIUY
        QTCYCWFAUURUVKUDNZUYSUYTAFUVKUDUWIYDJAUWNUXCUXBUYKVUAUYTRUWTUXIUXJUYPOU
        VAUVBUXDUXPUXDVMUXPVMYEYFYGAUXDTUXPYAUXHYHYLYMZUYHUYIUYJXGEUVBUWAUXSUVB
        RZUYAUYIUYGUYJVUCUXTUXPCUXSUVBUDWSZYIVUCUYDUXLUYFUXQVUCUYCUVEUBVUCUYBUV
        CUVDUXSUVBYJVQZYKVUCUYEUXOUXTUXPUEVUCUYCUVEUCVUEYDVUDYNYOUUBUUAUUCZVCZB
        UUDZUVEUUSUULYPZUUEAUUQUVFUCNZUURUEADUVFUCUXKYDAVUJUXOTYAPZUURAVUJAUXNV
        UJXSMVUIUVFYQWHYRAUXOYSMVUKYSMAUXOAUXLUXOXSMVUGUVEYQWHYRZUXOUUFWHAUURAU
        VQUURXSMUWCOFXTWHYRAVUJUXOUUSUCNZYAPZVUKUEAUXLUXMVUJVUNUEUFVUGVUHUVEUUS
        UUGYPAVUMTUXOYAAUVRVUMTRUWGBOUUHWHUUIYTAVUKUYSUURUEAUXOCTVULACHYRTYSMAU
        UJVTAUXOUXPCUEAUXLUXQVUFVLVUBYTUUKJUUMUUNUUOUUP $.
    $}

    $( The easy direction of the Fundamental Theorem of Algebra:  A nonzero
       polynomial has at most ` deg ( F ) ` roots.  (Contributed by Mario
       Carneiro, 26-Jul-2014.) $)
    fta1 $p |- ( ( F e. ( Poly ` S ) /\ F =/= 0p ) ->
                 ( R e. Fin /\ ( # ` R ) <_ ( deg ` F ) ) ) $=
      ( vf vx cfv wcel c0p wa cdgr wceq cfn chash cle cc0 wi cc wral c0 vd cply
      vg wne wbr eqid cv ccnv csn cima cdif cn0 dgrcl adantr c1 caddc co imbi1d
      eqeq2 ralbidv wn eldifsni simplr wb eldifi ad2antrr 0dgrb mpbid fveq1d wf
      cxp syl wfn plyf ffn fniniseg 4syl biimpa simprd simpld fvconst2 3eqtr3rd
      fvex sneqd xpeq2d eqtrd df-0p syl6eqr ex necon3ad eq0rdv nn0ge0 3syl 0fin
      mpd id syl6eqel biantrurd fveq2 syl6eq breq1d bitr3d syl5ibrcom syld rgen
      hash0 eqeq1d cnveq imaeq1d eleq1d fveq2d breq12d anbi12d imbi12d ad2antlr
      cbvralv wex n0 simplll simpllr simprl simprr fta1lem exp32 exlimdv syl5bi
      a1dd pm2.61dne com23 ralrimdva nn0ind plyssc sseli rspcv sylbir sylan mpi
      eldifsn ) CBUBGZHZCIUDZJZCKGZUUCLZAMHZANGZUUCOUEZJZUUCUFUUBEUGZKGZUUCLZUU
      IUHZPUIZUJZMHZUUNNGZUUJOUEZJZQZERUBGZIUIZUKZSZUUDUUHQZUUBUUCULHZUVCYTUVEU
      UABCUMUNUUJFUGZLZUURQZEUVBSUUJPLZUURQZEUVBSUUJUAUGZLZUURQZEUVBSZUUJUVKUOU
      PUQZLZUURQZEUVBSZUVCFUAUUCUVFPLZUVHUVJEUVBUVSUVGUVIUURUVFPUUJUSURUTUVFUVK
      LZUVHUVMEUVBUVTUVGUVLUURUVFUVKUUJUSURUTUVFUVOLZUVHUVQEUVBUWAUVGUVPUURUVFU
      VOUUJUSURUTUVFUUCLZUVHUUSEUVBUWBUVGUUKUURUVFUUCUUJUSURUTUVJEUVBUUIUVBHZUV
      IUUNTLZUURUWCUVIUWDUWCUVIJZFUUNUWEUUIIUDZUVFUUNHZVAUWCUWFUVIUUIUUTIVBUNUW
      EUWGUUIIUWEUWGUUIILUWEUWGJZUUIRUUMVKZIUWHUUIRPUUIGZUIZVKZUWIUWHUVIUUIUWLL
      ZUWCUVIUWGVCUWHUUIUUTHZUVIUWMVDUWCUWNUVIUWGUUIUUTUVAVEZVFRUUIVGVLVHZUWHUW
      KUUMRUWHUWJPUWHUVFUUIGZUVFUWLGZPUWJUWHUVFUUIUWLUWPVIUWHUVFRHZUWQPLZUWEUWG
      UWSUWTJZUWEUWNRRUUIVJUUIRVMUWGUXAVDUWCUWNUVIUWOUNRUUIVNRRUUIVORPUVFUUIVPV
      QVRZVSUWHUWSUWRUWJLUWHUWSUWTUXBVTRUWJUVFPUUIWCWAVLWBWDWEWFWGWHWIWJWOWKWIU
      WCUURUWDPUUJOUEZUWCUWNUUJULHUXCUWORUUIUMUUJWLWMZUWDUUQUURUXCUWDUUOUUQUWDU
      UNTMUWDWPWNWQWRUWDUUPPUUJOUWDUUPTNGPUUNTNWSXFWTXAXBZXCXDXEUVNUCUGZKGZUVKL
      ZUXFUHZUUMUJZMHZUXJNGZUXGOUEZJZQZUCUVBSZUVKULHZUVRUVMUXOEUCUVBUUIUXFLZUVL
      UXHUURUXNUXRUUJUXGUVKUUIUXFKWSZXGUXRUUOUXKUUQUXMUXRUUNUXJMUXRUULUXIUUMUUI
      UXFXHXIZXJUXRUUPUXLUUJUXGOUXRUUNUXJNUXTXKUXSXLXMXNXPUXQUXPUVQEUVBUXQUWCJZ
      UVPUXPUURUYAUVPUXPUURQZUYAUVPJZUYBUUNTUYCUWDUURUXPUYCUURUWDUXCUWCUXCUXQUV
      PUXDXOUXEXCYGUUNTUDUWGFXQUYCUYBFUUNXRUYCUWGUYBFUYCUWGUXPUURUYCUWGUXPJZJUV
      FUVKUUNUCUUIUUNUFUXQUWCUVPUYDXSUXQUWCUVPUYDXTUYAUVPUYDVCUYCUWGUXPYAUYCUWG
      UXPYBYCYDYEYFYHWIYIYJYFYKVLYTCUUTHZUUAUVCUVDQZYSUUTCBYLYMUYEUUAJCUVBHUYFC
      UUTIYRUUSUVDECUVBUUICLZUUKUUDUURUUHUYGUUJUUCUUCUUICKWSZXGUYGUUOUUEUUQUUGU
      YGUUNAMUYGUUNCUHZUUMUJAUYGUULUYIUUMUUICXHXIDWHZXJUYGUUPUUFUUJUUCOUYGUUNAN
      UYJXKUYHXLXMXNYNYOYPWOYQ $.
  $}

  ${
    $d x y z F $.  $d x y z G $.  $d x y z H $.  $d x y z S $.
    quotcan.1 $e |- H = ( F oF x. G ) $.
    $( Exact division with a multiple.  (Contributed by Mario Carneiro,
       26-Jul-2014.) $)
    quotcan $p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ G =/= 0p ) ->
                    ( H quot G ) = F ) $=
      ( vx cfv wcel c0p co cmin cc wceq cmul cdgr wbr syl2anc cvv syl cle vy vz
      cply wne w3a cquot cof cc0 csn cxp clt wo wb plyssc simp2 sseldi simp1 wa
      plymulcl syl5eqel 3adant3 simp3 quotcl2 syl3anc plysubcl plymul0or a1i wf
      cnex cv mulcom adantl caofcom syl5eq oveq1d subdi caofdi eqtr4d eqeq1d wn
      plyf neneqd biorf 3bitr4d biimpd caddc wi eqid dgrmul expr syl21anc dgrcl
      cr cn0 nn0red nn0addge1 breq2 syl5ibrcom syld fveq2d breq2d lenltd bitr3d
      sylibd necon4ad quotdgr mpjaod df-0p syl6eq ofsubeq0 mpbid eqcomd ) BAUCG
      ZHZCXMHZCIUDZUEZBDCUFJZXQBXRKUGZJZLUHUIUJZMZBXRMZXQXTIYAXQDCXRNUGZJZXSJZI
      MZXTIMZYFOGZCOGZUKPZXQYGYHXQCXTYDJZIMZCIMZYHULZYGYHXQCLUCGZHZXTYPHZYMYOUM
      XQXMYPCAUNZXNXOXPUOZUPZXQBYPHXRYPHZYRXQXMYPBYSXNXOXPUQZUPXQDYPHZYQXPUUBXN
      XOUUDXPXNXOURDBCYDJZYPEABCUSUTVAZUUAXNXOXPVBZLDCVCVDZLBXRVEQZLCXTVFQXQYFY
      LIXQYFCBYDJZYEXSJYLXQDUUJYEXSXQDUUEUUJEXQFUALNLBCRLRHZXQVIVGZXQXNLLBVHZUU
      CABWASZXQXOLLCVHYTACWASZFVJZLHZUAVJZLHZURUUPUURNJZUURUUPNJMXQUUPUURVKVLVM
      VNVOXQFUAUBLKLNCBXRLKRUULUUOUUNXQUUBLLXRVHZUUHLXRWASZUUQUUSUBVJZLHUEUUPUU
      RUVCKJNJUUTUUPUVCNJKJMXQUUPUURUVCVPVLVQVRZVSXQYNVTYHYOUMXQCIUUGWBYNYHWCSW
      DWEXQYKXTIXQXTIUDZYJYLOGZTPZYKVTZXQUVEUVFYJXTOGZWFJZMZUVGXQYQXPYRUVEUVKWG
      UUAUUGUUIYQXPURYRUVEUVKLCXTYJUVIYJWHUVIWHWIWJWKXQUVGUVKYJUVJTPZXQYJWMHUVI
      WNHZUVLXQYJXQXOYJWNHYTACWLSWOZXQYRUVMUUILXTWLSYJUVIWPQUVFUVJYJTWQWRWSXQYJ
      YITPUVGUVHXQYIUVFYJTXQYFYLOUVDWTXAXQYJYIUVNXQYIXQYFYPHZYIWNHXQUUDYEYPHZUV
      OUUFXQYQUUBUVPUUAUUHLCXRUSQLDYEVEQLYFWLSWOXBXCXDXEXQUUDYQXPYGYKULUUFUUAUU
      GYFLDCYFWHXFVDXGXHXIXQUUKUUMUVAYBYCUMUULUUNUVBLBXRRXJVDXKXL $.

    $(
    plydivcn.2 @e |- A = ( CC \ ( `' G " { 0 } ) ) @.
    @( Given two polynomials that are known to be multiples of each other, one
       cannot just divide one by the other as functions to recover the
       quotient, because it would leave holes at each zero of the denominator
       function.  However, a more analytic solution to this algebraic problem
       is to extend the function by continuity over the singularities; here
       we show that this does indeed recover the divisor function.  (If they
       are not properly divisible, the result will have poles instead of
       removable singularities and the continuity extension will fail.)  See
       ~ df-zeta for a more general application of this technique. @)
    plydivcn @p |- ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` S ) /\ G =/= 0p ) ->
     F = ( iota_ f e. ( CC -cn-> CC ) ( f |` A ) = ( ( H oF / G ) |` A ) ) ) @=
      ? @.
    $)
  $}

  ${
    $d f D $.  $d f F $.  $d f k y z N $.  $d f k x Q $.  $d d f g k x y z R $.
    $d f z A $.  $d k x z ph $.
    vieta1.1 $e |- A = ( coeff ` F ) $.
    vieta1.2 $e |- N = ( deg ` F ) $.
    vieta1.3 $e |- R = ( `' F " { 0 } ) $.
    vieta1.4 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    vieta1.5 $e |- ( ph -> ( # ` R ) = N ) $.
    ${
      vieta1lem.6 $e |- ( ph -> D e. NN ) $.
      vieta1lem.7 $e |- ( ph -> ( D + 1 ) = N ) $.
      vieta1lem.8 $e |- ( ph -> A. f e. ( Poly ` CC ) ( ( D = ( deg ` f ) /\
    ( # ` ( `' f " { 0 } ) ) = ( deg ` f ) ) -> sum_ x e. ( `' f " { 0 } ) x =
          -u ( ( ( coeff ` f ) ` ( ( deg ` f ) - 1 ) ) /
               ( ( coeff ` f ) ` ( deg ` f ) ) ) ) ) $.
      vieta1lem.9 $e |- Q = ( F quot ( Xp oF - ( CC X. { z } ) ) ) $.
      $( Lemma for ~ vieta1 .  (Contributed by Mario Carneiro, 28-Jul-2014.) $)
      vieta1lem1 $p |- ( ( ph /\ z e. R ) ->
        ( Q e. ( Poly ` CC ) /\ D = ( deg ` Q ) ) ) $=
        ( cv wcel wa cc cply cfv cdgr wceq cidp csn cxp cof co cquot c0p plyssc
        cmin wne adantr sseldi c1 ccnv cc0 cima w3a cdm cnvimass eqsstri wf syl
        plyf fdm syl5sseq sselda eqid plyremlem simp1d simp2d ax-1ne0 a1i fveq2
        eqnetrd dgr0 syl6eq necon3i quotcl2 syl3anc syl5eqel ax-1cn nncnd dgrcl
        cn0 nn0cnd caddc addcom sylancr cmul eleq2i wb fniniseg syl5bb simplbda
        wfn ffn facth oveq2i syl6eqr fveq2d wo wn cn peano2nnd nnne0d syl5eqner
        eqeltrrd eqnetrrd syl2anc necon3abid mpbid neanior sylibr simprd dgrmul
        plymul0or syl22anc 3eqtrd oveq1d addcanad jca ) ACUAZGUBZUCZFUDUEUFZUBZ
        EFUGUFZUHYLFJUIUDYJUJZUKUQULUMZUNUMZYMTYLJYMUBYQYMUBZYQUOURZYRYMUBYLHUE
        UFZYMJHUPAJUUAUBZYKOUSZUTYLYSYQUGUFZVAUHZYQVBVCUJZVDYPUHZYLYJUDUBZYSUUE
        UUGVEAGUDYJAJVFZGUDGJVBUUFVDZUUINJUUFVGVHAUDUDJVIZUUIUDUHAUUBUUKOHJVKVJ
        ZUDUDJVLVJVMVNZYJYQYQVOZVPVJZVQZYLUUDVCURYTYLUUDVAVCYLYSUUEUUGUUOVRZVAV
        CURYLVSVTWBYQUOUUDVCYQUOUHZUUDUOUGUFZVCYQUOUGWAWCWDWEVJZUDJYQWFWGWHZYLV
        AEYOVAUDUBZYLWIVTAEUDUBZYKAEQWJUSZYLYOYLYNYOWLUBUVAUDFWKVJWMYLVAEWNUMZE
        VAWNUMZUUDYOWNUMZVAYOWNUMYLUVBUVCUVEUVFUHWIUVDVAEWOWPYLUVFJUGUFZYQFWQUL
        ZUMZUGUFZUVGAUVFUVHUHYKAUVFKUVHRMWDUSYLJUVJUGYLJYQYRUVIUMZUVJYLUUBUUHYJ
        JUFVCUHZJUVLUHUUCUUMAYKUUHUVMYKYJUUJUBZAUUHUVMUCZGUUJYJNWRAJUDXCZUVNUVO
        WSAUUKUVPUULUDUDJXDVJUDVCYJJWTVJXAXBYJHJYQUUNXEWGFYRYQUVITXFXGZXHYLYSYT
        YNFUOURZUVKUVGUHUUPUUTUVAYLYTUVRYLUURFUOUHXIZXJZYTUVRUCYLUVJUOURUVTYLJU
        VJUOUVQAJUOURZYKAUVHVCURUWAAUVHKVCMAKAUVFKXKRAEQXLXOXMXNJUOUVHVCJUOUHUV
        HUUSVCJUOUGWAWCWDWEVJUSXPYLUVSUVJUOYLYSYNUVJUOUHUVSWSUUPUVAUDYQFYDXQXRX
        SYQUOFUOXTYAYBUDYQFUUDYOUUDVOYOVOYCYEYFYLUUDVAYOWNUUQYGYFYHYI $.

      $( Lemma for ~ vieta1 : inductive step.  Let ` z ` be a root of ` F ` .
         Then ` F = ( Xp - z ) x. Q ` for some ` Q ` by the factor theorem, and
         ` Q ` is a degree- ` D ` polynomial, so by the induction hypothesis
         ` sum_ x e. ( ``' Q " 0 ) x = -u ( coeff `` Q ) `` ( D - 1 ) / `
         ` ( coeff `` Q ) `` D ` , so ` sum_ x e. R x = z - ( coeff `` Q ) `` `
         ` ( D - 1 ) / ( coeff `` Q ) `` D ` .  Now the coefficients of ` F `
         are ` A `` ( D + 1 ) = ( coeff `` Q ) `` D ` and ` A `` D = `
         ` sum_ k e. ( 0 ... D ) ( coeff `` Xp - z ) `` k x. ( coeff `` Q ) `
         ` `` ( D - k ) ` , which works out to ` -u z x. ( coeff `` Q ) `` D `
         ` + ( coeff `` Q ) `` ( D - 1 ) ` , so putting it all together we have
         ` sum_ x e. R x = -u A `` D / A `` ( D + 1 ) ` as we wanted to show.
         (Contributed by Mario Carneiro, 28-Jul-2014.) $)
      vieta1lem2 $p |- ( ph ->
        sum_ x e. R x = -u ( ( A ` ( N - 1 ) ) / ( A ` N ) ) ) $=
        ( vk cv wcel csu c1 cmin co cfv cdiv cneg wceq c0 wne chash cc0 eqnetrd
        caddc cn cfn wb cdgr cle wbr cply c0p wa fveq2 dgr0 syl6eq necon3i fta1
        syl syl2anc simpld necon3bid mpbid sylib csn ccnv cima cin wn cr simprd
        ccoe cc cn0 nn0red eqeltrd cun wss fveq2d cidp cmul adantr wf plyf 3syl
        cof sselda eleq2i wfn ffn syl3anc oveq2i syl6eqr imaeq1d syl5eq cvv a1i
        3eqtrd eqtr4d eqtr3d sylibr sylancr ax-1cn adantl oveq1d 1re eqeq12d id
        eqid mpd eqtrd wi fveq12d oveq12d negeqd ax-1ne0 fveq1d coef3 cif ax-mp
        coeidp breq2d dgrub 3expia necon1bd cfz syl2an peano2nnd nnne0d hasheq0
        wex eqeltrrd syl5eqner incom vieta1lem1 dgrcl ltp1d gtned snssi ssequn1
        n0 cxp cquot cdm cnvimass eqsstri fdm syl5sseq fniniseg syl5bb simplbda
        4syl cnveqd cnex w3a plyremlem simp1d ofmulrt simp3d uneq1d wo eqnetrrd
        facth plymul0or necon3abid neanior breqtrrd snfi hashun2 addcom hashsng
        nncnd 3brtr3d hashcl leadd2d mpbird mpbir2and syl5ib necon3ad fsumsplit
        letri3d disjsn sumsn negnegd eqeq2d cnveq anbi12d sumeq1d imbi12d rspcv
        wral mp2and simp2d dgrmul syl22anc coemulhi plyid mp2an plyconst coesub
        sylc ssid 1nn0 mp2b nn0ex inidm iftrue clt 0lt1 ltnlei mpbi 0dgr mtbiri
        sylan ofval mpan2 subid1i ffvelrnd mulid2d negcld nnm1nn0 dgreq0 divcld
        0re negdid mulcld divdird coemul 1e0p1 sumeq1i cuz 0nn0 eleqtri elfznn0
        nn0uz ffvelrn pncan nnuz syl6eleq fzss2 fznn0sub syldan sylan2br oveq2d
        sylancl fsump1 cdif eldifn eldifi cz elfzuz elfz5 bitr4d sylibrd sylan2
        1z mul02d fzfid fsumss 0z nesymi iffalse 0cn vex fvconst2 coefv0 df-neg
        syl5reqr subid1d oveq2 fsum1 3eqtr3rd 3eqtr4rd divcan4d exlimddv ) ACUB
        ZGUCZGBUBZBUDZKUEUFUGZDUHZKDUHZUIUGZUJZUKCAGULUMZVWJCUUDAGUNUHZUOUMVWRA
        VWSKUOPAKAEUEUQUGZKURRAEQUUAUUEZUUBZUPAVWSUOGULAGUSUCZVWSUOUKGULUKUTAVX
        CVWSJVAUHZVBVCZAJHVDUHUCZJVEUMZVXCVXEVFOAVXDUOUMVXGAVXDKUOMVXBUUFJVEVXD
        UOJVEUKZVXDVEVAUHZUOJVEVAVGVHVIVJVLZGHJNVKVMVNZGUSUUCVLVOVPCGUUNVQAVWJV
        FZVWLVWIVRZVWKBUDZFVSZUOVRZVTZVWKBUDZUQUGVWIUJZUJZEUEUFUGZFWEUHZUHZVWOU
        IUGZUJZUQUGZVWQVXLVXMVXQVWKGBVXLVXMVXQWAVXQVXMWAZULVXMVXQUUGVXLVWIVXQUC
        ZWBZVYGULUKVXLVWTEUMVYIVXLEVWTVXLEFVAUHZWCVXLFWFVDUHZUCZEVYJUKZABCDEFGH
        IJKLMNOPQRSTUUHZWDZVXLVYJVXLVYLVYJWGUCVXLVYLVYMVYNVNZWFFUUIVLZWHWIZVXLE
        VYRUUJUUKVXLVYHVWTEVYHVXMVXQWJZUNUHZVXQUNUHZUKVXLVWTEUKVYHVYSVXQUNVYHVX
        MVXQWKVYSVXQUKVWIVXQUULVXMVXQUUMVQWLVXLVYTVWTWUAEVXLVWSVYTVWTVXLGVYSUNV
        XLGWMWFVXMUUOZUFWSZUGZFWNWSZUGZVSZVXPVTZWUDVSVXPVTZVXQWJZVYSVXLGJVSZVXP
        VTZWUHNVXLWUKWUGVXPVXLJWUFVXLJWUDJWUDUUPUGZWUEUGZWUFVXLVXFVWIWFUCZVWIJU
        HUOUKZJWUNUKAVXFVWJOWOZAGWFVWIAJUUQZGWFGWULWURNJVXPUURUUSAVXFWFWFJWPZWU
        RWFUKOHJWQZWFWFJUUTWRUVAZWTZAVWJWUOWUPVWJVWIWULUCZAWUOWUPVFZGWULVWINXAA
        VXFWUSJWFXBWVCWVDUTOWUTWFWFJXCWFUOVWIJUVBUVEUVCUVDVWIHJWUDWUDYBZUVPXDFW
        UMWUDWUETXEXFZUVFXGXHVXLWFXIUCZWFWFWUDWPZWFWFFWPZWUHWUJUKWVGVXLUVGXJVXL
        WUDVYKUCZWVHVXLWVJWUDVAUHZUEUKZWUIVXMUKZVXLWUOWVJWVLWVMUVHWVBVWIWUDWVEU
        VIVLZUVJZWFWUDWQVLVXLVYLWVIVYPWFFWQVLWFWUDFXIUVKXDVXLWUIVXMVXQVXLWVJWVL
        WVMWVNUVLUVMXKZWLAVWSVWTUKVWJAVWSKVWTPRXLWOXMZVXLWUAEUKWUAEVBVCEWUAVBVC
        ZVXLWUAVYJEVBVXLVXQUSUCZWUAVYJVBVCZVXLVYLFVEUMZWVSWVTVFVYPVXLWUDVEUMZWW
        AVXLWUDVEUKZFVEUKUVNZWBZWWBWWAVFVXLWUFVEUMWWEVXLJWUFVEWVFAVXGVWJVXJWOZU
        VOVXLWWDWUFVEVXLWVJVYLWUFVEUKWWDUTWVOVYPWFWUDFUVQVMUVRVPWUDVEFVEUVSXNWD
        ZVXQWFFVXQYBVKVMZWDVYOUVTVXLWVRUEEUQUGZUEWUAUQUGZVBVCVXLVYTVXMUNUHZWUAU
        QUGZWWIWWJVBVXLVXMUSUCWVSVYTWWLVBVCVWIUWAVXLWVSWVTWWHVNZVXMVXQUWBXOVXLV
        YTVWTWWIWVQVXLUEWFUCZEWFUCZWWIVWTUKXPAWWOVWJAEQUWEZWOZUEEUWCXOXLVXLWWKU
        EWUAUQVWJWWKUEUKAVWIGUWDXQXRUWFVXLEWUAUEVYRVXLWUAVXLWVSWUAWGUCWWMVXQUWG
        VLWHZUEWCUCVXLXSXJUWHUWIVXLWUAEWWRVYRUWNUWJZXTUWKUWLYCVXQVWIUWOXNXHWVPA
        VXCVWJVXKWOVXLGWFVWKAGWFWKVWJWVAWOWTUWMVXLVXNVXTVXRVYEUQVXLVXNVWIVXTVXL
        WUOWUOVXNVWIUKWVBWVBVWKVWIBVWIWFVWKVWIUKYAUWPVMVXLVWIWVBUWQXLVXLVXRVYJU
        EUFUGZVYBUHZVYJVYBUHZUIUGZUJZVYEVXLVYMWUAVYJUKZVXRWXDUKZVYOVXLWUAEVYJWW
        SVYOYDVXLVYLEIUBZVAUHZUKZWXGVSZVXPVTZUNUHZWXHUKZVFZWXKVWKBUDZWXHUEUFUGZ
        WXGWEUHZUHZWXHWXQUHZUIUGZUJZUKZYEZIVYKUXDZVYMWXEVFZWXFYEZVYPAWYDVWJSWOW
        YCWYFIFVYKWXGFUKZWXNWYEWYBWXFWYGWXIVYMWXMWXEWYGWXHVYJEWXGFVAVGZUWRWYGWX
        LWUAWXHVYJWYGWXKVXQUNWYGWXJVXOVXPWXGFUWSXGZWLWYHXTUWTWYGWXOVXRWYAWXDWYG
        WXKVXQVWKBWYIUXAWYGWXTWXCWYGWXRWXAWXSWXBUIWYGWXPWWTWXQVYBWXGFWEVGZWYGWX
        HVYJUEUFWYHXRYFWYGWXHVYJWXQVYBWYJWYHYFYGYHXTUXBUXCUXNUXEVXLVYDWXCVXLVYC
        WXAVWOWXBUIVXLVYAWWTVYBVXLEVYJUEUFVYOXRWLVXLVWOWVKVYJUQUGZWUFWEUHZUHZWV
        KWUDWEUHZUHZWXBWNUGZWXBVXLKWYKDWYLVXLDJWEUHWYLLVXLJWUFWEWVFWLXHZVXLKVXD
        WYKMVXLVXDWUFVAUHZWYKVXLJWUFVAWVFWLVXLWVJWWBVYLWWAWYRWYKUKWVOVXLWVKUOUM
        WWBVXLWVKUEUOVXLWVJWVLWVMWVNUXFZUEUOUMVXLYIXJUPWUDVEWVKUOWWCWVKVXIUOWUD
        VEVAVGVHVIVJVLVYPWWGWFWUDFWVKVYJWVKYBZVYJYBZUXGUXHYDXHYFVXLWVJVYLWYMWYP
        UKWVOVYPWYNVYBWFWUDFWVKVYJWYNYBZVYBYBZWYTXUAUXIVMVXLWYPUEWXBWNUGWXBVXLW
        YOUEWXBWNVXLWYOUEWYNUHZUEVXLWVKUEWYNWYSWLVXLXUDUEWMWEUHZWUBWEUHZWUCUGZU
        HZUEVXLUEWYNXUGVXLWMVYKUCZWUBVYKUCZWYNXUGUKWFWFWKZWWNXUIWFUXOZXPWFUXJUX
        KZVXLXUKWUOXUJXULWVBVWIWFUXLXOZXUEXUFWFWMWUBXUEYBZXUFYBZUXMXOZYJVXLXUHU
        EUOUFUGZUEVXLUEWGUCZXUHXURUKUXPVXLWGWGUEUOUFWGXUEXUFXIXIUEXUEWGXBZVXLXU
        IWGWFXUEWPXUTXUMXUEWFWMXUOYKWGWFXUEXCUXQXJZVXLXUJWGWFXUFWPXUFWGXBXUNXUF
        WFWUBXUPYKWGWFXUFXCWRZWGXIUCVXLUXRXJZXVCWGUXSZVXLXUSVFZUEXUEUHZUEUEUKZU
        EUOYLZUEXUSXVFXVHUKVXLUEYNXQXVGXVHUEUKUEYBXVGUEUOUXTYMVIXVEUEWUBVAUHZVB
        VCZWBUEXUFUHZUOUKXVEXVJUEUOVBVCZUOUEUYAVCXVLWBUYBUOUEUYQXSUYCUYDXVEXVIU
        OUEVBXVEWUOXVIUOUKVXLWUOXUSWVBWOVWIUYEVLYOUYFXVEXVJXVKUOVXLXUJXUSXVKUOU
        MZXVJYEXUNXUJXUSXVMXVJXUFWFWUBUEXVIXUPXVIYBYPYQUYGYRYCUYHUYIUEXPUYJVIYD
        ZYDXRVXLWXBVXLWGWFVYJVYBVXLVYLWGWFVYBWPZVYPVYBWFFXUCYKVLZVYQUYKZUYLYDXK
        ZYGYHXLYGVXLVXSVYDUQUGZUJVYFVWQVXLVXSVYDVXLVWIWVBUYMZVXLVYCVWOVXLWGWFVY
        AVYBXVPAVYAWGUCZVWJAEURUCZXWAQEUYNVLWOUYKZVXLVWOWXBWFXVRXVQWIZVXLVXGVWO
        UOUMWWFVXLJVEVWOUOVXLVXFVXHVWOUOUKUTWUQDHJKMLUYOVLVOVPZUYPUYRVXLXVSVWPV
        XLVXSVWOWNUGZVYCUQUGZVWOUIUGXWFVWOUIUGZVYDUQUGVWPXVSVXLXWFVYCVWOVXLVXSV
        WOXVTXWDUYSZXWCXWDXWEUYTVXLXWGVWNVWOUIVXLVWMWYLUHZUOVWMYSUGZUAUBZWYNUHZ
        VWMXWLUFUGZVYBUHZWNUGZUAUDZVWNXWGVXLWVJVYLVWMWGUCZXWJXWQUKWVOVYPAXWRVWJ
        AKURUCXWRVXAKUYNVLWOWYNVYBWFUAWUDFVWMXUBXUCVUAXDVXLVWMDWYLWYQYJVXLUOUEY
        SUGZXWPUAUDZUOUOYSUGXWPUAUDZXUDVWMUEUFUGZVYBUHZWNUGZUQUGZXWQXWGVXLXWTUO
        UOUEUQUGZYSUGZXWPUAUDXXEXWSXXGXWPUAUEXXFUOYSVUBXEZVUCVXLXWPXXDUAUOUOUOU
        OVUDUHZUCVXLUOWGXXIVUEVUHVUFXJXWLXXGUCVXLXWLXWSUCZXWPWFUCXWSXXGXWLXXHXA
        VXLXXJVFXWMXWOVXLWGWFWYNWPZXWLWGUCZXWMWFUCXXJVXLWVJXXKWVOWYNWFWUDXUBYKV
        LXWLUEVUGWGWFXWLWYNVUIYTVXLXXJXWLXWKUCZXWOWFUCZVXLXWSXWKXWLVXLVWMUEVUDU
        HZUCXWSXWKWKVXLVWMURXXOVXLVWMEURAVWMEUKVWJAVWTUEUFUGZVWMEAVWTKUEUFRXRAW
        WOWWNXXPEUKWWPXPEUEVUJVURXMWOZAXWBVWJQWOWIVUKVULUEUOVWMVUMVLZWTVXLXVOXW
        NWGUCXXNXXMXVPXWLUOVWMVUNWGWFXWNVYBVUIYTZVUOUYSZVUPXWLXXFUKZXWMXUDXWOXX
        CWNXYAXWLUEWYNXYAXWLXXFUEXYAYAVUBXFZWLXYAXWNXXBVYBXYAXWLUEVWMUFXYBVUQWL
        YGVUSXHVXLXWSXWKXWPUAXXRXXTVXLXWLXWKXWSVUTUCZVFZXWPUOXWOWNUGUOXYDXWMUOX
        WOWNXYDXXJWBZXWMUOUKXYCXYEVXLXWLXWKXWSVVAXQXYDXXJXWMUOXYDXWMUOUMZXWLWVK
        VBVCZXXJVXLWVJXXLXYFXYGYEXYCWVOXYCXXMXXLXWLXWKXWSVVBZXWLVWMVUGVLWVJXXLX
        YFXYGWYNWFWUDXWLWVKXUBWYTYPYQYTXYDXXJXWLUEVBVCZXYGXYDXWLXXIUCZUEVVCUCXX
        JXYIUTXYCXYJVXLXYCXXMXYJXYHXWLUOVWMVVDVLXQVVIXWLUOUEVVEVURVXLXYGXYIUTXY
        CVXLWVKUEXWLVBWYSYOWOVVFVVGYRYCXRXYDXWOXYCVXLXXMXXNXYHXXSVVHVVJYDVXLUOV
        WMVVKVVLVXLXXAXWFXXDVYCUQVXLXXAUOWYNUHZVWMUOUFUGZVYBUHZWNUGZXWFVXLUOVVC
        UCXYNWFUCXXAXYNUKVVMVXLXYNXWFWFVXLXYKVXSXYMVWOWNVXLXYKUOXUGUHZVXSVXLUOW
        YNXUGXUQYJVXLXYOUOVWIUFUGZVXSVXLUOWGUCZXYOXYPUKVUEVXLWGWGUOVWIUFWGXUEXU
        FXIXIUOXVAXVBXVCXVCXVDXYQUOXUEUHZUOUKVXLXYQXYRUOUEUKZUEUOYLZUOUOYNXYSWB
        XYTUOUKUEUOYIVVNXYSUEUOVVOYMVIXQVXLUOXUFUHZVWIUKXYQVXLVWIUOWUBUHZYUAUOW
        FUCYUBVWIUKVVPWFVWIUOCVVQVVRYMVXLXUJYUBYUAUKXUNXUFWFWUBXUPVVSVLVWAWOUYH
        UYIVWIVVTXFYDVXLXYMWXBVWOVXLXYLVYJVYBVXLXYLEUOUFUGEVYJVXLVWMEUOUFXXQXRV
        XLEWWQVWBVYOXKWLXVRXLYGZXWIWIXWPXYNUAUOXWLUOUKZXWMXYKXWOXYMWNXWLUOWYNVG
        YUDXWNXYLVYBXWLUOVWMUFVWCWLYGVWDXOYUCYDVXLXXDUEVYCWNUGVYCVXLXUDUEXXCVYC
        WNXVNVXLXXBVYAVYBVXLVWMEUEUFXXQXRWLYGVXLVYCXWCUYLYDYGVWEVWFXRVXLXWHVXSV
        YDUQVXLVXSVWOXVTXWDXWEVWGXRVWEYHXMXKVWH $.
    $}

    vieta1.6 $e |- ( ph -> N e. NN ) $.
    $( The first-order Vieta's formula (see
       ~ http://en.wikipedia.org/wiki/Vieta%27s_formulas ).  If a polynomial of
       degree ` N ` has ` N ` distinct roots, then the sum over these roots can
       be calculated as ` -u A ( N - 1 ) / A ( N ) ` .  (If the roots are not
       distinct, then this formula is still true but must double-count some of
       the roots according to their multiplicities.)  (Contributed by Mario
       Carneiro, 28-Jul-2014.) $)
    vieta1 $p |- ( ph ->
      sum_ x e. R x = -u ( ( A ` ( N - 1 ) ) / ( A ` N ) ) ) $=
      ( cc cfv wcel wceq cc0 c1 co vf vy vd vk vg vz cply cv cdgr ccnv csn cima
      chash wa csu cmin ccoe cdiv cneg wi wral plyssc sseldi caddc eqeq1 anbi1d
      cn imbi1d ralbidv cn0 eqid coef3 adantr 0nn0 ffvelrn sylancl simpr fveq2d
      wf 1nn0 c0p wne ax-1ne0 a1i eqnetrrd fveq2 dgr0 syl6eq necon3i syl dgreq0
      wb necon3bid mpbid eqnetrd divcld negcld id sumsn syl2anc adantrr cfn wss
      cen wbr cle fta1 syldan simpld cfz cexp coeid2 oveq2d sumeq1d nn0uz 1e0p1
      cmul oveq2 oveq12d ffvelrnda expcl sylan mulcld cz 0z exp0d mulid1d eqtrd
      eqeltrd sylancr negeqd imaeq1d eqeq12d anbi12d fveq12d imbi12d syl6eqr
      oveq1d eqeq2d cnveq fsum1 mulneg2d divcan2d 3eqtrd negidd fsump1i 3eqtr2d
      jctil exp1d simprd wfn ffn fniniseg mpbir2and snssd hashsng simprr eqtr4d
      plyf snfi hashen fisseneq syl3anc 1m1e0 syl5eqr 3eqtr3d ex cbvsumv eqeq1i
      rgen imbi2i ralbii w3a cidp cquot simp1r simp3r simp1l simp3l simp2 sylib
      cxp cof vieta1lem2 3exp syl5bir ralrimdva cbvralv syl6ib biantrur syl6bbr
      nnind rspcv syl3c ) AFNUGOZPGUAUHZUIOZQZUWPUJZRUKZULZUMOZUWQQZUNZUXABUHZB
      UOZUWQSUPTZUWPUQOZOZUWQUXHOZURTZUSZQZUTZUAUWOVAZDUMOZGQZDUXEBUOZGSUPTZCOZ
      GCOZURTZUSZQZAEUGOUWOFEVBKVCAGVGPUXOMUBUHZUWQQZUXCUNZUXMUTZUAUWOVASUWQQZU
      XCUNZUXMUTZUAUWOVAUCUHZUWQQZUXCUNZUXMUTZUAUWOVAZUYLSVDTZUWQQZUXCUNZUXMUTZ
      UAUWOVAZUXOUBUCGUYESQZUYHUYKUAUWOVUBUYGUYJUXMVUBUYFUYIUXCUYESUWQVEVFVHVIU
      YEUYLQZUYHUYOUAUWOVUCUYGUYNUXMVUCUYFUYMUXCUYEUYLUWQVEVFVHVIUYEUYQQZUYHUYT
      UAUWOVUDUYGUYSUXMVUDUYFUYRUXCUYEUYQUWQVEVFVHVIUYEGQZUYHUXNUAUWOVUEUYGUXDU
      XMVUEUYFUWRUXCUYEGUWQVEVFVHVIUYKUAUWOUWPUWOPZUYJUXMVUFUYJUNZRUXHOZSUXHOZU
      RTZUSZUKZUXEBUOZVUKUXFUXLVUFUYIVUMVUKQZUXCVUFUYIUNZVUKNPZVUPVUNVUOVUJVUOV
      UHVUIVUOVJNUXHVSZRVJPZVUHNPVUFVUQUYIUXHNUWPUXHVKZVLVMZVNVJNRUXHVOVPZVUOVU
      QSVJPZVUINPVUTVTVJNSUXHVOVPZVUOVUIUXJRVUOSUWQUXHVUFUYIVQZVRZVUOUWPWAWBZUX
      JRWBZVUOUWQRWBVVFVUOSUWQRVVDSRWBVUOWCWDWEUWPWAUWQRUWPWAQUWQWAUIORUWPWAUIW
      FWGWHWIWJZVUFVVFVVGWLUYIVUFUWPWAUXJRUXHNUWPUWQUWQVKZVUSWKWMVMWNWOZWPZWQZV
      VLUXEVUKBVUKNUXEVUKQWRWSWTXAVUGVULUXAUXEBVUGUXAXBPZVULUXAXCZVULUXAXDXEZVU
      LUXAQVUFUYIVVMUXCVUOVVMUXBUWQXFXEZVUFUYIVVFVVMVVPUNVVHUXANUWPUXAVKXGXHXIZ
      XAVUFUYIVVNUXCVUOVUKUXAVUOVUKUXAPZVUPVUKUWPOZRQZVVLVUOVVSRUWQXJTZUDUHZUXH
      OZVUKVWBXKTZXQTZUDUOZRSXJTZVWEUDUOZRVUFUYIVUPVVSVWFQVVLUXHNUDUWPUWQVUKVUS
      VVIXLXHVUOVWGVWAVWEUDVUOSUWQRXJVVDXMXNVUOVVBVWHRQVUOVWEVUIVUKSXKTZXQTZVUH
      RUDRRSVJXOXPVWBSQVWCVUIVWDVWIXQVWBSUXHWFVWBSVUKXKXRXSVUOVWBVJPZUNVWCVWDVU
      OVJNVWBUXHVUTXTVUOVUPVWKVWDNPVVLVUKVWBYAYBYCVUORRXJTVWEUDUOZVUHQVURVUOVWL
      VUHVUKRXKTZXQTZVUHVUORYDPVWNNPVWLVWNQYEVUOVWNVUHNVUOVWNVUHSXQTVUHVUOVWMSV
      UHXQVUOVUKVVLYFXMVUOVUHVVAYGYHZVVAYIVWEVWNUDRVWBRQVWCVUHVWDVWMXQVWBRUXHWF
      VWBRVUKXKXRXSUUAYJVWOYHVNUUHVUOVUHVWJVDTVUHVUHUSZVDTRVUOVWJVWPVUHVDVUOVWJ
      VUIVUKXQTVUIVUJXQTZUSVWPVUOVWIVUKVUIXQVUOVUKVVLUUIXMVUOVUIVUJVVCVVKUUBVUO
      VWQVUHVUOVUHVUIVVAVVCVVJUUCYKUUDXMVUOVUHVVAUUEYHUUFUUJUUGVUOUWPNUUKZVVRVU
      PVVTUNWLVUFVWRUYIVUFNNUWPVSVWRNUWPUUSNNUWPUULWJVMNRVUKUWPUUMWJUUNUUOXAVUG
      VULUMOZUXBQZVVOVUGVWSUWQUXBVUFUYIVWSUWQQUXCVUOVWSSUWQVUOVUPVWSSQVVLVUKNUU
      PWJVVDYHXAVUFUYIUXCUUQUURVUFUYIVWTVVOWLZUXCVUOVULXBPVVMVXAVUKUUTVVQVULUXA
      UVAYJXAWNVULUXAUVBUVCXNVUFUYIVUKUXLQUXCVUOVUJUXKVUOVUHUXIVUIUXJURVUORUXGU
      XHVUORSSUPTUXGUVDVUOSUWQSUPVVDYRUVEVRVVEXSYKXAUVFUVGUVJUYLVGPZUYPUYQUEUHZ
      UIOZQZVXCUJZUWTULZUMOZVXDQZUNZVXGUXEBUOZVXDSUPTZVXCUQOZOZVXDVXMOZURTZUSZQ
      ZUTZUEUWOVAVUAVXBUYPVXSUEUWOUYPUYNUXAUYEUBUOZUXLQZUTZUAUWOVAZVXBVXCUWOPZU
      NZVXSVYBUYOUAUWOVYAUXMUYNVXTUXFUXLUXAUYEUXEUBBUYEUXEQWRUVHUVIUVKUVLZVYEVY
      CVXJVXRVYEVYCVXJUVMZBUFVXMUYLVXCUVNNUFUHUKUWBUPUWCTUVOTZVXGNUAVXCVXDVXMVK
      VXDVKVXGVKVXBVYDVYCVXJUVPVYEVYCVXEVXIUVQVXBVYDVYCVXJUVRVYEVYCVXEVXIUVSVYG
      VYCUYPVYEVYCVXJUVTVYFUWAVYHVKUWDUWEUWFUWGVXSUYTUEUAUWOVXCUWPQZVXJUYSVXRUX
      MVYIVXEUYRVXIUXCVYIVXDUWQUYQVXCUWPUIWFZYSVYIVXHUXBVXDUWQVYIVXGUXAUMVYIVXF
      UWSUWTVXCUWPYTYLZVRVYJYMYNVYIVXKUXFVXQUXLVYIVXGUXAUXEBVYKXNVYIVXPUXKVYIVX
      NUXIVXOUXJURVYIVXLUXGVXMUXHVXCUWPUQWFZVYIVXDUWQSUPVYJYRYOVYIVXDUWQVXMUXHV
      YLVYJYOXSYKYMYPUWHUWIUWLWJLUXNUXQUYDUTUAFUWOUWPFQZUXDUXQUXMUYDVYMUXDGFUIO
      ZQZUXQUNUXQVYMUWRVYOUXCUXQVYMUWQVYNGUWPFUIWFZYSVYMUXBUXPUWQGVYMUXADUMVYMU
      XAFUJZUWTULDVYMUWSVYQUWTUWPFYTYLJYQZVRVYMUWQVYNGVYPIYQZYMYNVYOUXQIUWJUWKV
      YMUXFUXRUXLUYCVYMUXADUXEBVYRXNVYMUXKUYBVYMUXIUXTUXJUYAURVYMUXGUXSUXHCVYMU
      XHFUQOCUWPFUQWFHYQZVYMUWQGSUPVYSYRYOVYMUWQGUXHCVYTVYSYOXSYKYMYPUWMUWN $.
  $}

  ${
    $d S a b c p $.  $d F a b c p $.  $d D a b c p $.
    $( An infinite set of values can be extended to a polynomial in at most one
       way.  (Contributed by Stefan O'Rear, 14-Nov-2014.) $)
    plyexmo $p |- ( ( D C_ CC /\ -. D e. Fin ) -> E* p ( p e. ( Poly ` S ) /\
        ( p |` D ) = F ) ) $=
      ( va cc wcel wa cv cfv wceq cmin cc0 c0p wfn cvv wf plyf syl adantr vb wn
      wss cfn cply cres wmo wi wal cof co csn cxp ccnv cima simplr simpll sseld
      simprll ffn simprrl cnex a1i sselda fnfvof syl22anc simprlr eqtr4d fveq1d
      ffvelrnd simprrr fvres 3eqtr3d subeq0bd eqtrd ex jcad wb plysubcl syl2anc
      adantl fniniseg 4syl sylibrd ssrdv ssfi mtod chash cdgr cle wbr wne df-ne
      expcom biimpri eqid fta1 syl2an simpld mt3d df-0p syl6eq ofsubeq0 syl3anc
      mpbid alrimivv eleq1 reseq1 eqeq1d anbi12d mo4 sylibr plyssc sseli anim1i
      moimi ) AFUCZAUDGZUBZHZDIZFUEJZGZYAAUFZCKZHZDUGZYABUEJZGZYEHZDUGXTYFEIZYB
      GZYKAUFZCKZHZHZYAYKKZUHZEUIDUIYGXTYRDEXTYPYQXTYPHZYAYKLUJUKZFMULZUMZKZYQY
      SYTNUUBYSYTNKZYTUNUUAUOZUDGZYSUUFXRXQXSYPUPYSAUUEUCZUUFXRUHYSUAAUUEYSUAIZ
      AGZUUHFGZUUHYTJZMKZHZUUHUUEGZYSUUIUUJUULYSAFUUHXQXSYPUQZURYSUUIUULYSUUIHZ
      UUKUUHYAJZUUHYKJZLUKZMUUPYAFOZYKFOZFPGZUUJUUKUUSKYSUUTUUIYSFFYAQZUUTYSYCU
      VCXTYCYEYOUSZFYARSZFFYAUTSTYSUVAUUIYSFFYKQZUVAYSYLUVFXTYFYLYNVAZFYKRSZFFY
      KUTSTUVBUUPVBVCYSAFUUHUUOVDZFLYAYKPUUHVEVFUUPUUQUURUUPFFUUHYAYSUVCUUIUVET
      UVIVJUUPUUHYDJZUUHYMJZUUQUURUUPUUHYDYMYSYDYMKUUIYSYDCYMXTYCYEYOVGXTYFYLYN
      VKVHTVIUUIUVJUUQKYSUUHAYAVLWAUUIUVKUURKYSUUHAYKVLWAVMVNVOVPVQYSYTYBGZFFYT
      QYTFOUUNUUMVRYSYCYLUVLUVDUVGFYAYKVSVTZFYTRFFYTUTFMUUHYTWBWCWDWEUUFUUGXRUU
      EAWFWNSWGYSUUDUBZUUFYSUVNHUUFUUEWHJYTWIJWJWKZYSUVLYTNWLZUUFUVOHUVNUVMUVPU
      VNYTNWMWOUUEFYTUUEWPWQWRWSVPWTXAXBYSUVBUVCUVFUUCYQVRUVBYSVBVCUVEUVHFYAYKP
      XCXDXEVPXFYFYODEYQYCYLYEYNYAYKYBXGYQYDYMCYAYKAXHXIXJXKXLYJYFDYIYCYEYHYBYA
      BXMXNXOXPS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Algebraic numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c AA $.

  $( Extend class notation to include the set of algebraic numbers. $)
  caa $a class AA $. $( Blackboard bold capital A $)

  $( Define the set of algebraic numbers.  An algebraic number is a root of a
     nonzero polynomial over the integers.  Here we construct it as the union
     of all kernels (preimages of ` { 0 } ` ) of all polynomials in
     ` ( Poly `` ZZ ) ` , except the zero polynomial ` 0p ` .  (Contributed by
     Mario Carneiro, 22-Jul-2014.) $)
  df-aa $a |- AA = U_ f e. ( ( Poly ` ZZ ) \ { 0p } ) ( `' f " { 0 } ) $.

  ${
    $d f g k m n x y z A $.  $d f k m n z B $.  $d i j P $.  $d i j k m z ph $.
    $d f i j m z F $.  $d i j k n x y K $.  $d i j k m n x y N $.
    $d f k m z R $.
    $( Elementhood in the set of algebraic numbers.  (Contributed by Mario
       Carneiro, 22-Jul-2014.) $)
    elaa $p |- ( A e. AA <-> ( A e. CC /\
      E. f e. ( ( Poly ` ZZ ) \ { 0p } ) ( f ` A ) = 0 ) ) $=
      ( caa wcel cz cply cfv c0p csn cdif cv ccnv cc0 cima ciun cc wceq wrex wa
      bitri df-aa eleq2i eliun wf wfn eldifi plyf fniniseg 4syl rexbiia r19.42v
      wb ffn ) ACDABEFGZHIZJZBKZLMINZOZDZAPDZAUQGMQZBUPRSZCUSABUAUBUTAURDZBUPRZ
      VCBAUPURUCVEVAVBSZBUPRVCVDVFBUPUQUPDUQUNDPPUQUDUQPUEVDVFULUQUNUOUFEUQUGPP
      UQUMPMAUQUHUIUJVAVBBUPUKTTT $.

    $( An algebraic number is a complex number.  (Contributed by Mario
       Carneiro, 23-Jul-2014.) $)
    aacn $p |- ( A e. AA -> A e. CC ) $=
      ( vf caa wcel cc cv cfv cc0 wceq cz cply c0p csn cdif wrex elaa simplbi )
      ACDAEDABFGHIBJKGLMNOABPQ $.

    $( The algebraic numbers are a subset of the complex numbers.  (Contributed
       by Mario Carneiro, 23-Jul-2014.) $)
    aasscn $p |- AA C_ CC $=
      ( vx caa cc cv aacn ssriv ) ABCADEF $.

    ${
      elqaa.1 $e |- ( ph -> A e. CC ) $.
      elqaa.2 $e |- ( ph -> F e. ( ( Poly ` QQ ) \ { 0p } ) ) $.
      elqaa.3 $e |- ( ph -> ( F ` A ) = 0 ) $.
      elqaa.4 $e |- B = ( coeff ` F ) $.
      elqaa.5 $e |- N = ( k e. NN0 |-> sup (
        { n e. NN | ( ( B ` k ) x. n ) e. ZZ } , RR , `' < ) ) $.
      elqaa.6 $e |- R = ( seq 0 ( x. , N ) ` ( deg ` F ) ) $.
      $( Lemma for ~ elqaa .  The function ` N ` represents the denominators of
         the rational coefficients ` B ` .  By multiplying them all together to
         make ` R ` , we get a number big enough to clear all the denominators
         and make ` R x. F ` an integer polynomial.  (Contributed by Mario
         Carneiro, 23-Jul-2014.) $)
      elqaalem1 $p |- ( ( ph /\ K e. NN0 ) ->
        ( ( N ` K ) e. NN /\ ( ( B ` K ) x. ( N ` K ) ) e. ZZ ) ) $=
        ( wcel cz cn cr cq cn0 wa cfv cv cmul co crab clt ccnv csup wceq oveq1d
        fveq2 eleq1d rabbidv supeq1d wor ltso cnvso mpbi supex fvmpt adantl cuz
        c1 wss c0 wne ssrab2 nnuz sseqtri wrex cply cc0 wf c0p eldifad 0z ax-mp
        csn coef2 sylancl ffvelrnda qmulz syl sylibr infmssuzcl sylancr eqeltrd
        zq rabn0 oveq2 elrab sylib ) AHUAPZUBZHIUCZHCUCZFUDZUEUFZQPZFRUGZPWQRPW
        RWQUEUFZQPZUBWPWQXBSUHUIZUJZXBWOWQXFUKAEHEUDZCUCZWSUEUFZQPZFRUGZSXEUJXF
        UAIXGHUKZSXKXBXEXLXJXAFRXLXIWTQXLXHWRWSUEXGHCUMULUNUOUPNSXBXESUHUQSXEUQ
        URSUHUSUTVAVBVCWPXBVEVDUCZVFXBVGVHZXFXBPXBRXMXAFRVIVJVKWPXAFRVLZXNWPWRT
        PXOAUATHCAGTVMUCZPVNTPZUATCVOAGXPVPVTKVQVNQPXQVRVNWJVSCTGMWAWBWCFWRWDWE
        XAFRWKWFXBVEWGWHWIXAXDFWQRWSWQUKWTXCQWSWQWRUEWLUNWMWN $.

      ${
        elqaa.7 $e |- P = ( x e. _V , y e. _V |->
          ( ( x x. y ) mod ( N ` K ) ) ) $.
        $( Lemma for ~ elqaa .  (Contributed by Mario Carneiro,
           23-Jul-2014.) $)
        elqaalem2 $p |- ( ( ph /\ K e. ( 0 ... ( deg ` F ) ) ) ->
          ( R mod ( N ` K ) ) = 0 ) $=
          ( wcel vi vj vm cc0 cdgr cfv cfz co wa cmo cmpt cn0 cseq wceq elfznn0
          cn cv fveq2i nnmulcl adantl cz elqaalem1 simpld adantlr sylan2 cuz cq
          cmul cply c0p csn cdif eldifi dgrcl 3syl syl6eleq adantr nnz ad2antrl
          nn0uz zmodcld nn0zd ad2antll nnrpd crp nnre modabs2 syl2anc modmul12d
          cr oveq1 eqid ovex fvmpt oveq12d cvv oveq12 oveq1d ovmpt2a syl6eq syl
          mp2an 3eqtr4rd weq fveq2 eqtr4d seqhomo syl5eq seqf ffvelrnd syl5eqel
          0z a1i vex nn0mulcl zmodcl syl2anr crab clt ccnv csup rabbidv supeq1d
          eleq1d cbvmptv eqtri nnzd fmptd ffvelrn syl2an c0ex nn0cn mul02d 0mod
          wf sylan9eqr mul01d simpr cdiv c1 nncnd nnne0d 1z syl6eqel nnred mod0
          dividd wb mpbird eqtrd seqz 3eqtr3d ) AKUDJUEUFZUGUHZTZUIZGHUPHUQZKLU
          FZUJUHZUKZUFZUUMFHULUUQLUFZUURUJUHZUKZUDUMUFZGUURUJUHZUDUUOAKULTZUVAU
          VEUNKUUMUOZAUVGUIZUVAUUMVHLUDUMZUFZUUTUFUVEGUVKUUTRURUVIUAUBVHFUPLUVD
          UUTUDUUMUAUQZUPTZUBUQZUPTZUIZUVLUVNVHUHZUPTZUVIUVLUVNUSZUTZUVLUUNTZUV
          IUVLULTZUVLLUFZUPTZUVLUUMUOZAUWBUWDUVGAUWBUIUWDUVLEUFUWCVHUHVATADEGHI
          JUVLLMNOPQRVBVCZVDZVEAUUMUDVFUFZTUVGAUUMULUWHAJVGVIUFZVJVKZVLTJUWITUU
          MULTZNJUWIUWJVMVGJVNVOZVTVPVQUVIUVPUIZUVLUURUJUHZUVNUURUJUHZVHUHZUURU
          JUHZUVQUURUJUHZUVLUUTUFZUVNUUTUFZFUHZUVQUUTUFZUWMUWNUVLUWOUVNUURUWMUW
          NUWMUVLUURUVMUVLVATUVIUVOUVLVRVSZUVIUURUPTZUVPUVIUXDKEUFUURVHUHVATADE
          GHIJKLMNOPQRVBVCZVQZWAWBUXCUWMUWOUWMUVNUURUVOUVNVATUVIUVMUVNVRWCZUXFW
          AWBUXGUWMUURUXFWDZUWMUVLWJTZUURWETZUWNUURUJUHUWNUNUVMUXIUVIUVOUVLWFVS
          UXHUVLUURWGWHUWMUVNWJTZUXJUWOUURUJUHUWOUNUVOUXKUVIUVMUVNWFWCUXHUVNUUR
          WGWHWIUWMUXAUWNUWOFUHZUWQUWMUWSUWNUWTUWOFUVMUWSUWNUNUVIUVOHUVLUUSUWNU
          PUUTUUQUVLUURUJWKUUTWLZUVLUURUJWMZWNVSUVOUWTUWOUNUVIUVMHUVNUUSUWOUPUU
          TUUQUVNUURUJWKUXMUVNUURUJWMZWNWCWOUWNWPTUWOWPTUXLUWQUNUXNUXOBCUWNUWOW
          PWPBUQZCUQZVHUHZUURUJUHZUWQFUXPUWNUNUXQUWOUNUIUXRUWPUURUJUXPUWNUXQUWO
          VHWQWRSUWPUURUJWMWSXBWTUWMUVRUXBUWRUNUVTHUVQUUSUWRUPUUTUUQUVQUURUJWKU
          XMUVQUURUJWMZWNXAXCUWAUVIUWBUWCUUTUFZUVLUVDUFZUNUWEUVIUWBUIZUYAUWCUUR
          UJUHZUYBUYCUWDUYAUYDUNUWGHUWCUUSUYDUPUUTUUQUWCUURUJWKUXMUWCUURUJWMZWN
          XAUWBUYBUYDUNUVIHUVLUVCUYDULUVDHUAXDUVBUWCUURUJUUQUVLLXEWRUVDWLZUYEWN
          UTXFVEXGXHVEUUOAUVGUVAUVFUNZUVHUVIGUPTZUYGAUYHUVGAGUVKUPRAULUPUUMUVJA
          UAUBVHUPLUDULVTUDVATAXLXMUWFUVPUVRAUVSUTXIUWLXJXKVQHGUUSUVFUPUUTUUQGU
          URUJWKUXMGUURUJWMWNXAVEUUPUAUBFULUVDKUDUUMULUDUUPUWBUVNULTUIZUIUVLUVN
          FUHZUWRULUVLWPTZUVNWPTUYJUWRUNUAXNZUBXNBCUVLUVNWPWPUXSUWRFBUAXDZCUBXD
          UIUXRUVQUURUJUXPUVLUXQUVNVHWQWRSUXTWSXBUYIUVQVATUXDUWRULTUUPUYIUVQUVL
          UVNXOWBUUOAUVGUXDUVHUXEVEZUVQUURXPXQXKUUPULULUVDYOZUWBUYBULTUWAUUOAUV
          GUYOUVHUVIHULUVCULUVDUVIUUQULTZUIZUVBUURUYQUVBAUYPUVBUPTZUVGAUYPUIUYR
          UUQEUFZUVBVHUHVATADEGUCIJUUQLMNOPLHULUYSIUQZVHUHZVATZIUPXRZWJXSXTZYAZ
          UKUCULUCUQZEUFZUYTVHUHZVATZIUPXRZWJVUDYAZUKQHUCULVUEVUKHUCXDZWJVUCVUJ
          VUDVULVUBVUIIUPVULVUAVUHVAVULUYSVUGUYTVHUUQVUFEXEWRYDYBYCYEYFRVBVCVDY
          GUVIUXDUYPUXEVQWAUYFYHVEUWEULULUVLUVDYIYJUUPUWBUIZUDUVLFUHZUDUVLVHUHZ
          UURUJUHZUDUDWPTZUYKVUNVUPUNYKUYLBCUDUVLWPWPUXSVUPFUXPUDUNCUAXDUIUXRVU
          OUURUJUXPUDUXQUVLVHWQWRSVUOUURUJWMWSXBUWBUUPVUPUDUURUJUHZUDUWBVUOUDUU
          RUJUWBUVLUVLYLZYMWRUUPUXJVURUDUNUUPUURUYNWDZUURYNXAZYPXHVUMUVLUDFUHZU
          VLUDVHUHZUURUJUHZUDUYKVUQVVBVVDUNUYLYKBCUVLUDWPWPUXSVVDFUYMUXQUDUNUIU
          XRVVCUURUJUXPUVLUXQUDVHWQWRSVVCUURUJWMWSXBUWBUUPVVDVURUDUWBVVCUDUURUJ
          UWBUVLVUSYQWRVVAYPXHAUUOYRAUWKUUOUWLVQUUPKUVDUFZUURUURUJUHZUDUUPUVGVV
          EVVFUNUUOUVGAUVHUTHKUVCVVFULUVDUUQKUNUVBUURUURUJUUQKLXEWRUYFUURUURUJW
          MWNXAUUPVVFUDUNZUURUURYSUHZVATZUUPVVHYTVAUUPUURUUPUURUYNUUAUUPUURUYNU
          UBUUGUUCUUDUUPUURWJTUXJVVGVVIUUHUUPUURUYNUUEVUTUURUURUUFWHUUIUUJUUKUU
          L $.
      $}

      $( Lemma for ~ elqaa .  (Contributed by Mario Carneiro, 23-Jul-2014.) $)
      elqaalem3 $p |- ( ph -> A e. AA ) $=
        ( vz cc wcel cc0 cmul co vf vm vx vy cv cfv wceq cply c0p csn cdif wrex
        cz caa cxp cof wne cdgr cfz cexp csu cmpt cvv cnex wa cseq fvex eqeltri
        a1i fconstmpt cq wf eldifad plyf syl feqmptd offval2 fzfid cn cn0 nn0uz
        0z crab ssrab2 cr clt ccnv csup fveq2 oveq1d eleq1d rabbidv supeq1d wor
        ltso cnvso mpbi supex fvmpt adantl c1 cuz wss c0 sseqtri zq ax-mp coef2
        sylancl ffvelrnda qmulz rabn0 sylibr infmssuzcl sylancr eqeltrd nnmulcl
        nnuz sseldi seqf dgrcl ffvelrnd nncnd adantr sylan2 eqid oveq2d mulassd
        syl5eqel 3eqtr4d mpteq2dva cdiv nnne0d cmo syl2anc eldifsn sylanbrc wfn
        eqtrd ffn elfznn0 coef3 expcl mulcld fsummulc2 coeid2 sumeq2dv divcan2d
        adantll sylan zsscn divcld mulcomd 3eqtr4rd oveq2 elrab cmpt2 elqaalem2
        simprbi wb crp nnre nnrp syl2an mpbid zmulcld elplyd sylib simprd oveq1
        mod0 divcan3d div0d mpteq2dv 0cn df-0p eqtri eqeq12d syl5ib necon3d mpd
        ovex fconst mp1i inidm fvconst2 ofval mpdan mul01d fveq1 eqeq1d rspcev
        elaa ) ABPQZBUAUEZUFZRUGZUAUMUHUFZUIUJZUKZULZBUNQIAPDUJZUOZGSUPTZUWTQZB
        UXDUFZRUGZUXAAUXDUWRQUXDUIUQZUXEAUXDOPRGURUFZUSTZDUBUEZCUFZSTZOUEZUXKUT
        TZSTZUBVAZVBZUWRAUXDOPDUXNGUFZSTZVBUXRAOPDUXSSUXCGVCVCVCPVCQAVDVIZDVCQA
        UXNPQZVEZDUXISHRVFZUFZVCNUXIUYDVGVHZVIZUXSVCQUYCUXNGVGVIUXCOPDVBUGAOPDV
        JVIZAOPPGAGVKUHUFZQZPPGVLZAGUYIUWSJVMZVKGVNVOZVPZVQZAOPUXTUXQUYCDUXJUXL
        UXOSTZUBVAZSTUXJDUYPSTZUBVAUXTUXQUYCUXJUYPDUBUYCRUXIVRADPQZUYBADADUYEVS
        NAVTVSUXIUYDAUBESVSHRVTWARUMQZAWBVIAUXKVTQZVEZUXLFUEZSTZUMQZFVSWCZVSUXK
        HUFZVUEFVSWDZVUBVUGVUFWEWFWGZWHZVUFVUAVUGVUJUGAEUXKEUEZCUFZVUCSTZUMQZFV
        SWCZWEVUIWHVUJVTHVUKUXKUGZWEVUOVUFVUIVUPVUNVUEFVSVUPVUMVUDUMVUPVULUXLVU
        CSVUKUXKCWIWJWKWLWMMWEVUFVUIWEWFWNWEVUIWNWOWEWFWPWQWRWSWTVUBVUFXAXBUFZX
        CVUFXDUQZVUJVUFQVUFVSVUQVUHXRXEVUBVUEFVSULZVURVUBUXLVKQVUSAVTVKUXKCAUYJ
        RVKQZVTVKCVLUYLUYTVUTWBRXFXGCVKGLXHXIXJFUXLXKVOVUEFVSXLXMVUFXAXNXOXPZXS
        ZUXKVSQVUKVSQVEUXKVUKSTVSQAUXKVUKXQWTXTAUYJUXIVTQUYLVKGYAVOZYBYIZYCZYDZ
        UXKUXJQZUYCVUAUYPPQUXKUXIUUAZUYCVUAVEZUXLUXOUYCVTPUXKCAVTPCVLZUYBAUYJVV
        JUYLCVKGLUUBVOZYDXJZUYBVUAUXOPQAUXNUXKUUCUUIZUUDYEUUEUYCUXSUYQDSAUYJUYB
        UXSUYQUGUYLCVKUBGUXIUXNLUXIYFUUFUUJYGUYCUXJUXPUYRUBVVGUYCVUAUXPUYRUGVVH
        VVIDUXLUXOUYCUYSVUAVVFYDVVLVVMYHYEUUGYJYKYSAOUXMUMUBUXIUMPXCAUUKVIVVCAV
        VGVEZUXMUXLVUGSTZDVUGYLTZSTZUMVVGAVUAUXMVVQUGVVHVUBUXLVUGVVPSTZSTUXLDST
        VVQUXMVUBVVRDUXLSVUBDVUGAUYSVUAVVEYDZVUBVUGVVBYCZVUBVUGVVBYMZUUHYGVUBUX
        LVUGVVPAVTPUXKCVVKXJZVVTVUBDVUGVVSVVTVWAUULYHVUBDUXLVVSVWBUUMUUNYEVVNVV
        OVVPVVGAVUAVVOUMQZVVHVUBVUGVUFQZVWCVVAVWDVUGVSQZVWCVUEVWCFVUGVSVUCVUGUG
        VUDVVOUMVUCVUGUXLSUUOWKUUPUUSVOYEVVNDVUGYNTRUGZVVPUMQZAUCUDBCUCUDVCVCUC
        UEUDUESTVUGYNTUUQZDEFGUXKHIJKLMNVWHYFUURVVNDVSQZVWEVWFVWGUUTZAVWIVVGVVD
        YDVVGAVUAVWEVVHVVBYEVWIDWEQVUGUVAQVWJVWEDUVBVUGUVCDVUGUVKUVDYOUVEUVFXPU
        VGXPAGUIUQZUXHAUYJVWKAGUYIUWSUKQUYJVWKVEJGUYIUIYPUVHUVIAUXDUIGUIUXDUIUG
        UXDUXCYLUPZTZUIUXCVWLTZUGAGUIUGUXDUIUXCVWLUVJAVWMGVWNUIAOPUXTDYLTZVBOPU
        XSVBVWMGAOPVWOUXSUYCUXSDAPPUXNGUYMXJVVFADRUQUYBADVVDYMZYDUVLYKAOPUXTDYL
        UXDUXCVCVCVCUYAUXTVCQUYCDUXSSUWBVIUYGUYOUYHVQUYNYJAOPRDYLTZVBOPRVBZVWNU
        IAOPVWQRADVVEVWPUVMUVNAOPRDYLUIUXCVCPVCUYARPQUYCUVOVIUYGUIVWRUGAUIPRUJU
        OVWRUVPOPRVJUVQVIZUYHVQVWSYJUVRUVSUVTUWAUXDUWRUIYPYQAUXFDRSTZRAUWNUXFVW
        TUGIAPPDRSPUXCGVCVCBPUXBUXCVLUXCPYRAPDUYFUWCPUXBUXCYTUWDAUYKGPYRUYMPPGY
        TVOUYAUYAPUWEUWNBUXCUFDUGAPDBUYFUWFWTABGUFRUGUWNKYDUWGUWHADVVEUWIYSUWQU
        XGUAUXDUWTUWOUXDUGUWPUXFRBUWOUXDUWJUWKUWLYOBUAUWMYQ $.
    $}

    $( The set of numbers generated by the roots of polynomials in the
       _rational numbers_ is the same as the set of algebraic numbers, which by
       ~ elaa are defined only in terms of polynomials over the integers.
       (Contributed by Mario Carneiro, 23-Jul-2014.) $)
    elqaa $p |- ( A e. AA <-> ( A e. CC /\
      E. f e. ( ( Poly ` QQ ) \ { 0p } ) ( f ` A ) = 0 ) ) $=
      ( vm vj vk vn wcel cc cv cfv wceq cq wa cz wss cmul co cn crab cr caa cc0
      cply c0p csn cdif wrex elaa wi zssq qsscn plyss mp2an ssdif ssrexv anim2i
      mp2b sylbi ccoe cdgr cn0 clt ccnv csup cmpt cseq simpll simplr simpr eqid
      fveq2 oveq1d eleq1d rabbidv cbvrabv syl6eq supeq1d elqaalem3 ex rexlimdva
      oveq2 cbvmptv imp impbii ) AUAGZAHGZABIZJUBKZBLUCJZUDUEZUFZUGZMZWEWFWHBNU
      CJZWJUFZUGZMWMABUHWPWLWFWNWIOZWOWKOWPWLUINLOLHOWQUJUKNLULUMWNWIWJUNWHBWOW
      KUOUQUPURWFWLWEWFWHWEBWKWFWGWKGZMZWHWEWSWHMAWGUSJZWGUTJPCVACIZWTJZDIZPQZN
      GZDRSZTVBVCZVDZVEZUBVFJZEFWGXIWFWRWHVGWFWRWHVHWSWHVIWTVJCEVAXHEIZWTJZFIZP
      QZNGZFRSZTXGVDXAXKKZTXFXPXGXQXFXLXCPQZNGZDRSXPXQXEXSDRXQXDXRNXQXBXLXCPXAX
      KWTVKVLVMVNXSXODFRXCXMKXRXNNXCXMXLPWAVMVOVPVQWBXJVJVRVSVTWCWD $.

    $( Every rational number is algebraic.  (Contributed by Mario Carneiro,
       23-Jul-2014.) $)
    qaa $p |- ( A e. QQ -> A e. AA ) $=
      ( vf vx cq wcel cc cv cfv cc0 wceq c0p cidp cmin co wne c1 a1i adantl cvv
      df-idp vy cply csn cdif caa qcn cxp cof wss qsscn cz 1z ax-mp plyid mp2an
      wrex zq plyconst mpan caddc qaddcl cmul qmulcl qnegcl plysub peano2cn syl
      cneg wfn cid cres fnresi fneq1i mpbir fnconstg inidm fveq1i fvresi syl5eq
      wa cnex fvconst2g ofval mpdan ax-1cn pncan2 sylancl eqtrd ax-1ne0 eqnetrd
      ne0p syl2anc eldifsn sylanbrc subidd fveq1 eqeq1d rspcev elqaa ) ADEZAFEZ
      ABGZHZIJZBDUBHZKUCUDZUPZAUEEAUFZWTLFAUCUGZMUHNZXFEZAXJHZIJZXGWTXJXEEXJKOZ
      XKWTCUADLXILXEEZWTDFUIZPDEZXOUJPUKEXQULPUQUMZDUNUOQXPWTXIXEEUJADURUSCGZDE
      UAGZDEVTZXSXTUTNDEWTXSXTVARYAXSXTVBNDEWTXSXTVCRPVHDEZWTXQYBXRPVDUMQVEWTAP
      UTNZFEZYCXJHZIOXNWTXAYDXHAVFVGZWTYEPIWTYEYCAMNZPWTYDYEYGJYFWTFFYCAMFLXISS
      YCLFVIZWTYHVJFVKZFVIFVLFLYITVMVNQZFADVOZFSEWTWAQZYLFVPZYDYCLHZYCJWTYDYNYC
      YIHYCYCLYITVQFYCVRVSRFAYCDWBWCWDWTXAPFEYGPJXHWEAPWFWGWHPIOWTWIQWJYCXJWKWL
      XJXEKWMWNWTXLAAMNZIWTXAXLYOJXHWTFFAAMFLXISSAYJYKYLYLYMXAALHZAJWTXAYPAYIHA
      ALYITVQFAVRVSRFAADWBWCWDWTAXHWOWHXDXMBXJXFXBXJJXCXLIAXBXJWPWQWRWLABWSWN
      $.

    $( The rational numbers are contained in the algebraic numbers.
       (Contributed by Mario Carneiro, 23-Jul-2014.) $)
    qssaa $p |- QQ C_ AA $=
      ( vx cq caa cv qaa ssriv ) ABCADEF $.

    $( The imaginary unit is algebraic.  (Contributed by Mario Carneiro,
       23-Jul-2014.) $)
    iaa $p |- _i e. AA $=
      ( vf vz ci wcel cc cv cfv cc0 wceq cz c0p c2 cexp co c1 caddc cmpt ax-1cn
      wtru a1i vx vy caa cply csn cdif wrex ax-icn wne cxp cof cnex sqcl adantl
      cvv wa eqidd fconstmpt offval2 wss cn0 zsscn 1z 2nn0 mp3an plyconst mp2an
      plypow zaddcl plyadd eqeltrrd trud 0cn sq0i oveq1d 0p1e1 eqid elexi fvmpt
      syl6eq ax-mp ax-1ne0 eqnetri ne0p eldifsn mpbir2an oveq1 i2 neg1cn negidi
      cneg addcomli fveq1 eqeq1d rspcev elaa ) CUCDCEDZCAFZGZHIZAJUDGZKUEUFZUGZ
      UHBEBFZLMNZOPNZQZXBDZCXGGZHIZXCXHXGXADZXGKUIZXKSBEXEQZEOUEUJZPUKNXGXASBEX
      EOPXMXNUOEEEUODSULTXDEDZXEEDSXDUMUNOEDSXOUPRTSXMUQXNBEOQISBEOURTUSSUAUBJX
      MXNXMXADZSJEUTZOJDZLVADXPVBVCVDBJLVHVETXNXADZSXQXRXSVBVCOJVFVGTUAFZJDUBFZ
      JDUPXTYAPNJDSXTYAVIUNVJVKVLHEDZHXGGZHUIXLVMYCOHYBYCOIVMBHXFOEXGXDHIZXFHOP
      NOYDXEHOPXDVNVOVPVTXGVQZOERVRVSWAWBWCHXGWDVGXGXAKWEWFWQXJUHBCXFHEXGXDCIZX
      FOWKZOPNHYFXEYGOPYFXECLMNYGXDCLMWGWHVTVOOYGHRWIORWJWLVTYEHEVMVRVSWAWTXJAX
      GXBWRXGIWSXIHCWRXGWMWNWOVGCAWPWF $.

    $( The reciprocal of an algebraic number is algebraic.  (Contributed by
       Mario Carneiro, 24-Jul-2014.) $)
    aareccl $p |- ( ( A e. AA /\ A =/= 0 ) -> ( 1 / A ) e. AA ) $=
      ( vz vk vn wcel cc0 wne wa cfv wceq cdiv co cz c0p cc adantr cexp cn0 syl
      cmul vf vg caa cv c1 cply csn cdif wrex elaa simprbi aacn reccl sylan cfz
      cdgr cmin ccoe csu cmpt wss zsscn simprl eldifsn sylib simpld dgrcl wf 0z
      a1i eqid coef2 sylancl fznn0sub adantl ffvelrnd elplyd 0cn cle wbr coefv0
      zcnd eqidd coeeq2 fveq1d 0nn0 breq1 oveq2 fveq2d ifbieq12d fvex c0ex ifex
      cif fvmpt ax-mp nn0ge0d iftrue nn0cnd subid1d syl5eq 3eqtrd simprd dgreq0
      eqtrd wb necon3bid mpbid eqnetrd ne0p sylancr sylanbrc oveq1 oveq2d sumex
      sumeq2sdv caddc coef3 elfznn0 ffvelrn syl2an ad2antrr expcl mulcld expcld
      simplr nn0zd expne0d divcld fveq2 oveq12d oveq1d fsumrev2 addid2d expsubd
      divassd dividd divdiv32d exprecd syl2anc 3eqtr4d sumeq2dv coeid2 fsumdivc
      simprr eqtr3d fzfid div0d 3eqtr3d 3eqtr2d fveq1 eqeq1d rspcev rexlimddv )
      AUCEZAFGZHZAUAUDZIZFJZUEAKLZUCEZUAMUFIZNUGUHZUUOUUTUAUVDUIZUUPUUOAOEZUVEA
      UAUJUKPUUQUURUVDEZUUTHZHZUVAOEZUVAUBUDZIZFJZUBUVDUIZUVBUUQUVJUVHUUOUVFUUP
      UVJAULZAUMUNPZUVIBOFUURUPIZUOLZUVQCUDZUQLZUURURIZIZBUDZUVSQLZTLZCUSZUTZUV
      DEZUVAUWGIZFJZUVNUVIUWGUVCEZUWGNGZUWHUVIBUWBMCUVQMOVAUVIVBVJUVIUURUVCEZUV
      QREUVIUWMUURNGZUVIUVGUWMUWNHUUQUVGUUTVCUURUVCNVDVEZVFZMUURVGSZUVIUVSUVREZ
      HZRMUVTUWAUWSUWMFMERMUWAVHUVIUWMUWRUWPPVIUWAMUURUWAVKZVLVMUWRUVTREUVIUVSF
      UVQVNVOVPZVQZUVIFOEFUWGIZFGUWLVRUVIUXCUVQUWAIZFUVIUXCFUWGURIZIZFCRUVSUVQV
      SVTZUWBFWNZUTZIZUXDUVIUWKUXCUXFJUXBUXEMUWGUXEVKWASUVIFUXEUXIUVIBUWBMCUWGU
      VQUXBUWQUWSUWBUXAWBZUVIUWGWCWDWEUVIUXJFUVQVSVTZUVQFUQLZUWAIZFWNZUXDFREUXJ
      UXOJWFCFUXHUXORUXIUVSFJZUXGUXLUWBFUXNFUVSFUVQVSWGUXPUVTUXMUWAUVSFUVQUQWHW
      IUXPFWCWJUXIVKUXLUXNFUXMUWAWKWLWMWOWPUVIUXOUXNUXDUVIUXLUXOUXNJUVIUVQUWQWQ
      UXLUXNFWRSUVIUXMUVQUWAUVIUVQUVIUVQUWQWSZWTWIXEXAXBUVIUWNUXDFGUVIUWMUWNUWO
      XCUVIUURNUXDFUVIUWMUURNJUXDFJXFUWPUWAMUURUVQUVQVKZUWTXDSXGXHXIFUWGXJXKUWG
      UVCNVDXLUVIUWIUVRUWBUVAUVSQLZTLZCUSZUVRDUDZUWAIZAUYBQLZTLZAUVQQLZKLZDUSZF
      UVIUVJUWIUYAJUVPBUVAUWFUYAOUWGUWCUVAJZUVRUWEUXTCUYIUWDUXSUWBTUWCUVAUVSQXM
      XNXPUWGVKUVRUXTCXOWOSUVIUYHUVRFUVQXQLZUVSUQLZUWAIZAUYKQLZTLZUYFKLZCUSUYAU
      VIUYGUYODCFUVQUVIUYBUVREZHZUYEUYFUYQUYCUYDUVIROUWAVHZUYBREZUYCOEUYPUVIUWM
      UYRUWPUWAMUURUWTXRSUYBUVQXSZROUYBUWAXTYAUVIUVFUYSUYDOEUYPUUOUVFUUPUVHUVOY
      BZUYTAUYBYCYAYDZUVIUYFOEZUYPUVIAUVQVUAUWQYEZPUVIUYFFGZUYPUVIAUVQVUAUUOUUP
      UVHYFZUVIUVQUWQYGZYHZPYIUYBUYKJZUYEUYNUYFKVUIUYCUYLUYDUYMTUYBUYKUWAYJUYBU
      YKAQWHYKYLYMUVIUVRUYOUXTCUWSUYOUWBUYFAUVSQLZKLZTLZUYFKLUWBVUKUYFKLZTLUXTU
      WSUYNVULUYFKUWSUYLUWBUYMVUKTUWSUYKUVTUWAUWSUYJUVQUVSUQUWSUVQUVIUVQOEUWRUX
      QPYNYLZWIUWSUYMAUVTQLVUKUWSUYKUVTAQVUNXNUWSAUVQUVSUVIUVFUWRVUAPZUVIUUPUWR
      VUFPZUWSUVSUWRUVSREZUVIUVSUVQXSZVOYGZUVIUVQMEUWRVUGPYOXEYKYLUWSUWBVUKUYFU
      XKUWSUYFVUJUVIVUCUWRVUDPZUVIUVFVUQVUJOEUWRVUAVURAUVSYCYAZUWSAUVSVUOVUPVUS
      YHZYIVUTUVIVUEUWRVUHPZYPUWSVUMUXSUWBTUWSUYFUYFKLZVUJKLUEVUJKLVUMUXSUWSVVD
      UEVUJKUWSUYFVUTVVCYQYLUWSUYFVUJUYFVUTVVAVUTVVBVVCYRUWSAUVSVUOVUPVUSYSUUAX
      NXBUUBXEUVIUVRUYEDUSZUYFKLFUYFKLUYHFUVIVVEFUYFKUVIUUSVVEFUVIUWMUVFUUSVVEJ
      UWPVUAUWAMDUURUVQAUWTUXRUUCYTUUQUVGUUTUUEUUFYLUVIUVRUYEUYFDUVIFUVQUUGVUDV
      UBVUHUUDUVIUYFVUDVUHUUHUUIUUJUVMUWJUBUWGUVDUVKUWGJUVLUWIFUVAUVKUWGUUKUULU
      UMYTUVAUBUJXLUUN $.

    $( The conjugate of an algebraic number is algebraic.  (Contributed by
       Mario Carneiro, 24-Jul-2014.) $)
    aacjcl $p |- ( A e. AA -> ( * ` A ) e. AA ) $=
      ( vf cc wcel cv cfv cc0 wceq cz cply c0p csn cdif wrex wa ccj caa cr elaa
      wss adantr fveq2 cj0 syl6eq difss zssre ax-resscn plyss mp2an sstri sseli
      cjcl id plyrecj syl2anr eqeq1d syl5ib reximdva imp jca 3imtr4i ) ACDZABEZ
      FZGHZBIJFZKLZMZNZOZAPFZCDZVKVCFZGHZBVHNZOAQDVKQDVJVLVOVBVLVIAULUAVBVIVOVB
      VEVNBVHVEVDPFZGHVBVCVHDZOZVNVEVPGPFGVDGPUBUCUDVRVPVMGVQVCRJFZDVBVPVMHVBVH
      VSVCVHVFVSVFVGUEIRTRCTVFVSTUFUGIRUHUIUJUKVBUMAVCUNUOUPUQURUSUTABSVKBSVA
      $.
  $}

  ${
    $d A a b c d e f g h i $.
    aannenlem.a $e |- H = ( a e. NN0 |-> { b e. CC | E. c e.
        { d e. ( Poly ` ZZ ) | ( d =/= 0p /\ ( deg ` d ) <_ a /\
            A. e e. NN0 ( abs ` ( ( coeff ` d ) ` e ) ) <_ a ) }
      ( c ` b ) = 0 } ) $.
    $( Lemma for ~ aannen .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aannenlem1 $p |- ( A e. NN0 -> ( H ` A ) e. Fin ) $=
      ( cn0 wcel cfv cc0 wceq cle wbr ccoe cz cc cfn wa c0p cdgr cabs wral cply
      wne w3a crab wrex breq2 ralbidv 3anbi23d rabbidv rexeqdv cnex rabex fvmpt
      cv ciun iunrab cneg cfz co cmap cdom fzfi mapfi mp2an a1i ovex cres neeq1
      cvv weq fveq2 breq1d fveq1d fveq2d 3anbi123d elrab simp3 anim2i sylbi wss
      wf wfn crn 0z eqid coef2 mpan2 ad2antrl ffn syl adantl ffvelrnda cr nn0re
      zred ad2antrr absled wb nn0z znegcld elfz bitr4d biimpd ralimdva fnfvrnss
      syl3anc impr syl2anc df-f sylanbrc elfznn0 ssriv fssres sylancl sylibr ex
      elmap syl5 simp2 simplll plyf 3syl simplrl cexp cmul simplrr adantr fvres
      csu 3eqtr3d cuz dgrcl eluz mpbird coeid3 eqeltrd sumeq2dv simp-4l simp-4r
      oveq1d nn0zd simpr simp1rl 3eqtr4d eqfnfvd reseq1d impbid1 expcom syl2ani
      3expa expr dom2d mpi domfi simp1 wi ccnv csn cima fniniseg syl6rbbr eqrdv
      eqeq1d chash fta1 simpld ralrimiv iunfi syl5eqelr ) AIJZACKEURZFURZKZLMZF
      GURZUAUFZUVSUBKZANOZBURZUVSPKZKZUCKZANOZBIUDZUGZGQUEKZUHZUIZERUHZSDAUVRFU
      VTUWADURZNOZUWFUWNNOZBIUDZUGZGUWJUHZUIZERUHUWMICUWNAMZUWTUWLERUXAUVRFUWSU
      WKUXAUWRUWIGUWJUXAUWOUWBUWQUWHUVTUWNAUWANUJUXAUWPUWGBIUWNAUWFNUJUKULUMUNU
      MHUWLERUOUPUQUVNUWMFUWKUVRERUHZUSZSUVRFEUWKRUTUVNUWKSJZUXBSJZFUWKUDUXCSJU
      VNAVAZAVBVCZLAVBVCZVDVCZSJZUWKUXIVEOZUXDUXJUVNUXGSJUXHSJUXJUXFAVFLAVFUXGU
      XHVGVHVIUVNUXIVMJUXKUXGUXHVDVJUVNDEUWKUXIUWNPKZUXHVKZUVOPKZUXHVKZVMUWNUWK
      JZUWNUWJJZUWCUXLKZUCKZANOZBIUDZTZUVNUXMUXIJZUXPUXQUWNUAUFZUWNUBKZANOZUYAU
      GZTZUYBUWIUYGGUWNUWJGDVNZUVTUYDUWBUYFUWHUYAUVSUWNUAVLUYIUWAUYEANUVSUWNUBV
      OVPUYIUWGUXTBIUYIUWFUXSANUYIUWEUXRUCUYIUWCUWDUXLUVSUWNPVOVQVRVPUKVSVTZUYG
      UYAUXQUYDUYFUYAWAWBWCUVNUYBUYCUVNUYBTZUXHUXGUXMWEZUYCUYKIUXGUXLWEZUXHIWDU
      YLUYKUXLIWFZUXLWGUXGWDZUYMUYKIQUXLWEZUYNUXQUYPUVNUYAUXQLQJUYPWHUXLQUWNUXL
      WIZWJWKZWLIQUXLWMWNZUYKUYNUXRUXGJZBIUDZUYOUYSUVNUXQUYAVUAUVNUXQTZUXTUYTBI
      VUBUWCIJZTZUXTUYTVUDUXTUXFUXRNOUXRANOTZUYTVUDUXRAVUDUXRVUBIQUWCUXLUXQUYPU
      VNUYRWOWPZWSUVNAWQJUXQVUCAWRWTXAVUDUXRQJUXFQJAQJZUYTVUEXBVUFVUDAUVNVUGUXQ
      VUCAXCWTZXDVUHUXRUXFAXEXJXFXGXHXKBIUXGUXLXIXLIUXGUXLXMXNDUXHIUWNAXOXPIUXG
      UXHUXLXQXRUXGUXHUXMUXFAVBVJLAVBVJYAXSXTYBUXPUVNUXQUYFTZUVOUWJJZUVOUBKZANO
      ZTZUXMUXOMZDEVNZXBZUVOUWKJZUXPUYHVUIUYJUYGUYFUXQUYDUYFUYAYCWBWCVUQVUJUVOU
      AUFZVULUWCUXNKZUCKZANOZBIUDZUGZTVUMUWIVVCGUVOUWJGEVNZUVTVURUWBVULUWHVVBUV
      SUVOUAVLVVDUWAVUKANUVSUVOUBVOVPVVDUWGVVABIVVDUWFVUTANVVDUWEVUSUCVVDUWCUWD
      UXNUVSUVOPVOVQVRVPUKVSVTVVCVULVUJVURVULVVBYCWBWCVUIVUMTZUVNVUPVVEUVNTVUNV
      UOVVEUVNVUNVUOVVEUVNVUNTZTZFRUWNUVOVVGUXQRRUWNWEUWNRWFUXQUYFVUMVVFYDQUWNY
      ERRUWNWMYFVVGVUJRRUVOWEUVORWFVUIVUJVULVVFYGQUVOYERRUVOWMYFVVGUVPRJZTZUXHU
      VSUXLKZUVPUVSYHVCZYIVCZGYMZUXHUVSUXNKZVVKYIVCZGYMZUVPUWNKZUVPUVOKZVVIUXHV
      VLVVOGVVIUVSUXHJZTZVVJVVNVVKYIVVTUVSUXMKZUVSUXOKZVVJVVNVVTUVSUXMUXOVVIVUN
      VVSVVEUVNVUNVVHYJYKVQVVSVWAVVJMVVIUVSUXHUXLYLWOVVSVWBVVNMVVIUVSUXHUXNYLWO
      YNUUDUUAVVIUXQAUYEYOKJZVVHVVQVVMMUXQUYFVUMVVFVVHUUBZVVIVWCUYFUXQUYFVUMVVF
      VVHUUCVVIUYEQJZVUGVWCUYFXBVVIUXQUYEIJVWEVWDQUWNYPUYEXCYFVVIAVVEUVNVUNVVHY
      GUUEZUYEAYQXLYRVVGVVHUUFZUXLQGUWNAUYEUVPUYQUYEWIYSXJVVIVUJAVUKYOKJZVVHVVR
      VVPMVVEVVFVVHVUJVUJVULVUIVVFVVHUUGUUNZVVIVWHVULVVGVULVVHVUIVUJVULVVFYJYKV
      VIVUKQJZVUGVWHVULXBVVIVUJVUKIJVWJVWIQUVOYPVUKXCYFVWFVUKAYQXLYRVWGUXNQGUVO
      AVUKUVPUXNWIVUKWIYSXJUUHUUIUUOVUOUXLUXNUXHUWNUVOPVOUUJUUKUULUUMUUPUUQUXIU
      WKUURXLUVNUXEFUWKUVPUWKJZUVPUWJJZUVPUAUFZTZUVNUXEVWKVWLVWMUVPUBKZANOZUWCU
      VPPKZKZUCKZANOZBIUDZUGZTVWNUWIVXBGUVPUWJGFVNZUVTVWMUWBVWPUWHVXAUVSUVPUAVL
      VXCUWAVWOANUVSUVPUBVOVPVXCUWGVWTBIVXCUWFVWSANVXCUWEVWRUCVXCUWCUWDVWQUVSUV
      PPVOVQVRVPUKVSVTVXBVWMVWLVWMVWPVXAUUSWBWCVWNUXEUUTUVNVWNUXBUVPUVALUVBUVCZ
      SVWNDUXBVXDVWNUWNVXDJZUWNRJUWNUVPKZLMZTZUWNUXBJVWNUVPRWFZVXEVXHXBVWLVXIVW
      MVWLRRUVPWEVXIQUVPYERRUVPWMWNYKRLUWNUVPUVDWNUVRVXGEUWNREDVNUVQVXFLUVOUWNU
      VPVOUVGVTUVEUVFVWNVXDSJVXDUVHKVWONOVXDQUVPVXDWIUVIUVJYTVIYBUVKFUWKUXBUVLX
      LUVMYT $.

    $( Lemma for ~ aannen .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aannenlem2 $p |- AA = U. ran H $=
      ( vg vh cv cfv cc0 wceq cle wbr cn0 cz wrex wcel wa caa c0p wne cdgr ccoe
      vf vi cabs wral w3a cply crab cc cab cuni crn csn cdif wex wi cpr cfz cun
      co cxr clt csup simp3 eldifi adantr 3adant2 eldifsni wss 0nn0 dgrcl prssi
      syl sylancr ssrab2 a1i unssd nn0ssre ressxr sstri syl6ss fvex prid2 elun1
      cr ax-mp supxrub sylancl fveq2 abs0 syl6eq c0ex prid1 syl6eqel wf 0z eqid
      adantl coef2 ffvelrnda nn0abscl ad2antrr simpr syl3anc elfz2nn0 syl3anbrc
      simplr dgrub fveq2d eqeq2d rspcev eqeq1 rexbidv elrab sylanbrc pm2.61dane
      elun2 syl2anc ralrimiva neeq1 breq1d fveq1d ralbidv 3anbi123d simp2 fveq1
      weq 3jca eqeq1d cfn mp2an breq2 rabbidv eleq2 impcom anim2i prfi fzfi wor
      abrexfi rabssab ssfi unfi ne0i xrltso fisupcl mpan eqidd 3anbi23d rexeqdv
      sseldd cnex rabex anbi12d spcev 3exp rexlimiv simp1 eldifsn 3imtr4i ssriv
      ssrexv cbvrexv syl6ib sylbi syl6bi rexlimivw exlimiv elaa eluniab 3bitr4i
      c0 impbii eqriv rnmpt unieqi eqtr4i ) UAUFJZDJZEJZKZLMZEFJZUBUCZUWGUDKZCJ
      ZNOZAJZUWGUEKZKZUHKZUWJNOZAPUIZUJZFQUKKZULZRZDUMULZMZCPRZUFUNZUOZBUPZUOHU
      AUXFHJZUMSZUXHIJZKZLMZIUWSUBUQZURZRZTZUXHUWBSZUXDTZUFUSZUXHUASUXHUXFSUXPU
      XSUXOUXIUXSUXLUXIUXSUTIUXNUXJUXNSZUXLUXIUXSUXTUXLUXIUJZUXHUWFEUWHUWILUXJU
      DKZVAZUXHUGJZUXJUEKZKZUHKZMZUGLUYBVBVDZRZHPULZVCZVEVFVGZNOZUWOUYMNOZAPUIZ
      UJZFUWSULZRZDUMULZSZUYTUXBMZCPRZUXSUYAUXIUXHUWDKZLMZEUYRRZVUAUXTUXLUXIVHU
      YAUXJUYRSZUXLVUFUYAUXJUWSSZUXJUBUCZUYBUYMNOZUWLUYEKZUHKZUYMNOZAPUIZUJZVUG
      UXTUXIVUHUXLUXTVUHUXIUXJUWSUXMVIVJZVKUXTUXIVUOUXLUXTUXITZVUIVUJVUNUXTVUIU
      XIUXJUWSUBVLVJVUQUYLVEVMZUYBUYLSZVUJVUQUYLPVEVUQUYCUYKPVUQLPSUYBPSZUYCPVM
      VNVUQVUHVUTVUPQUXJVOVQZLUYBPVPVRUYKPVMVUQUYJHPVSVTWAZPWIVEWBWCWDWEZUYBUYC
      SVUSLUYBUXJUDWFWGUYBUYCUYKWHWJZUYLUYBWKWLVUQVUMAPVUQUWLPSZTZVURVULUYLSZVU
      MVUQVURVVEVVCVJVVFVVGVUKLVUKLMZVVGVVFVVHVULLUYLVVHVULLUHKLVUKLUHWMWNWOLUY
      CSLUYLSLUYBWPWQLUYCUYKWHWJWRXBVVFVUKLUCZTZVULUYKSZVVGVVJVULPSZVULUYGMZUGU
      YIRZVVKVVFVVLVVIVVFVUKQSVVLVUQPQUWLUYEVUQVUHLQSPQUYEWSVUPWTUYEQUXJUYEXAZX
      CWLXDVUKXEVQVJVVJUWLUYISZVULVULMZVVNVVJVVEVUTUWLUYBNOZVVPVUQVVEVVIXKZVUQV
      UTVVEVVIVVAXFVVJVUHVVEVVIVVRVUQVUHVVEVVIVUPXFVVSVVFVVIXGUYEQUXJUWLUYBVVOU
      YBXAXLXHUWLUYBXIXJVULXAVVMVVQUGUWLUYIUGAYKZUYGVULVULVVTUYFVUKUHUYDUWLUYEW
      MXMXNXOWLUYJVVNHVULPUXHVULMUYHVVMUGUYIUXHVULUYGXPXQXRXSVULUYKUYCYAVQXTUYL
      VULWKYBYCYLVKUYQVUOFUXJUWSFIYKZUWHVUIUYNVUJUYPVUNUWGUXJUBYDZVWAUWIUYBUYMN
      UWGUXJUDWMZYEVWAUYOVUMAPVWAUWOVULUYMNVWAUWNVUKUHVWAUWLUWMUYEUWGUXJUEWMYFX
      MZYEYGYHXRXSUXTUXLUXIYIVUEUXLEUXJUYREIYKVUDUXKLUXHUWDUXJYJYMZXOYBUYSVUFDU
      XHUMDHYKZUWFVUEEUYRVWFUWEVUDLUWCUXHUWDWMYMZXQXRXSUYAUYMPSZUYTUYTMZVUCUXTU
      XIVWHUXLVUQUYLPUYMVVBVUQUYLYNSZUYLUVPUCZVURUYMUYLSZVWJVUQUYCYNSUYKYNSZVWJ
      LUYBUUAUYJHUNZYNSZUYKVWNVMVWMUYIYNSVWOLUYBUUBUGHUYIUYGUUDWJUYJHPUUEVWNUYK
      UUFYOUYCUYKUUGYOVTVWKVUQVUSVWKVVDUYLUYBUUHWJVTVVCVEVFUUCVWJVWKVURUJVWLUUI
      VEUYLVFUUJUUKXHUUOVKUYAUYTUULVUBVWICUYMPUWJUYMMZUXBUYTUYTVWPUXAUYSDUMVWPU
      WFEUWTUYRVWPUWRUYQFUWSVWPUWKUYNUWQUYPUWHUWJUYMUWINYPVWPUWPUYOAPUWJUYMUWON
      YPYGUUMYQUUNYQXNXOYBUXRVUAVUCTUFUYTUYSDUMUUPUUQUWBUYTMZUXQVUAUXDVUCUWBUYT
      UXHYRVWQUXCVUBCPUWBUYTUXBXPXQUURUUSYBUUTUVAYSUXRUXPUFUXDUXQUXPUXCUXQUXPUT
      CPUXCUXQUXHUXBSZUXPUWBUXBUXHYRVWRUXIVUEEUWTRZTUXPUXAVWSDUXHUMVWFUWFVUEEUW
      TVWGXQXRVWSUXOUXIUWTUXNVMZVWSUXOUTIUWTUXNVUHVUIUYBUWJNOZVULUWJNOZAPUIZUJZ
      TVUHVUITUXJUWTSUXTVXDVUIVUHVUIVXAVXCUVBYTUWRVXDFUXJUWSVWAUWHVUIUWKVXAUWQV
      XCVWBVWAUWIUYBUWJNVWCYEVWAUWPVXBAPVWAUWOVULUWJNVWDYEYGYHXRUXJUWSUBUVCUVDU
      VEVWTVWSVUEEUXNRUXOVUEEUWTUXNUVFVUEUXLEIUXNVWEUVGUVHWJYTUVIUVJUVKYSUVLUVQ
      UXHIUVMUXDUFUXHUVNUVOUVRUXGUXECUFPUXBBGUVSUVTUWA $.

    $d H f g $.
    $( Lemma for ~ aannen . $)
    $( The algebraic numbers are countable.  (Contributed by Stefan O'Rear,
       16-Nov-2014.) $)
    aannenlem3 $p |- AA ~~ NN $=
      ( vf vg caa cn cdom wbr com cc cv cfn cn0 wcel cfv cen wor wex aannenlem2
      cnso crn cuni wss ccrd cdm con0 omelon nn0ennn nnenom entri ensymi isnumi
      wfo mp2an wfn cc0 wceq c0p wne cdgr cle ccoe cabs wral w3a cply crab wrex
      cz cnex rabex fnmpti dffn4 mpbi fodomnum mp2 domentr a1i wb fvelrnb ax-mp
      aannenlem1 eleq1 syl5ibcom rexlimiv sylbi ssriv wi aasscn soss iunfictbso
      eqsstr3i syl3anc syl5eqbr exlimiv cvv ssexi nnssq qssaa sstri ssdomg sbth
      cq ) JKLMZKJLMZJKUAMJNLMZNKUAMXIOHPZUBZHUCXKHUEXMXKHXMJBUFZUGZNLABCDEFGUD
      ZXMXNNLMZXNQUHZXOXLUBZXONLMXQXMXNRLMZRNUAMXQRUIUJSZRXNBURZXTNUKSNRUAMYAUL
      RNRKNUMUNUOZUPNRUQUSBRUTZYBCRDPEPTVAVBEFPZVCVDYEVETCPZVFMAPYEVGTTVHTYFVFM
      ARVIVJFVNVKTVLVMZDOVLBYGDOVOVPGVQZRBVRVSRXNBVTWAYCXNRNWBUSWCXRXMHXNQXLXNS
      ZIPZBTZXLVBZIRVMZXLQSZYDYIYMWDYHIRXLBWEWFYLYNIRYJRSYKQSYLYNYJABCDEFGWGYKX
      LQWHWIWJWKWLWCXOOUHXMXSWMXOJOXPWNWQXOOXLWOWFXNXLWPWRWSWTWFKNUNUPJNKWBUSJX
      ASKJUHXJJOVOWNXBKXHJXCXDXEKJXAXFWAJKXGUS $.
  $}

  ${
    $d a b c d e $.
    $( The algebraic numbers are countable.  (Contributed by Stefan O'Rear,
       16-Nov-2014.) $)
    aannen $p |- AA ~~ NN $=
      ( ve va vb vc vd cn0 cfv cc0 wceq c0p wne cdgr cle wbr ccoe cabs wral w3a
      cv crab cz cply wrex cc cmpt eqid aannenlem3 ) ABFCSDSGHIDESZJKUHLGBSZMNA
      SUHOGGPGUIMNAFQREUAUBGTUCCUDTUEZBCDEUJUFUG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Liouville's approximation theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F a $.  $d X a $.  $d Y a $.  $d ph a $.
    aalioulem1.a $e |- ( ph -> F e. ( Poly ` ZZ ) ) $.
    aalioulem1.b $e |- ( ph -> X e. ZZ ) $.
    aalioulem1.c $e |- ( ph -> Y e. NN ) $.
    $( Lemma for ~ aaliou .  An integer polynomial cannot inflate the
       denominator of a rational by more than its degree.  (Contributed by
       Stefan O'Rear, 12-Nov-2014.) $)
    aalioulem1 $p |- ( ph -> ( ( F ` ( X / Y ) ) x. ( Y ^ ( deg ` F ) ) )
        e. ZZ ) $=
      ( va cdiv co cfv cexp cmul cc0 cz wcel cc cn0 syl2an adantr cdgr cfz ccoe
      cv csu cply wceq zcnd nncnd nnne0d divcld eqid coeid2 syl2anc fzfid dgrcl
      oveq1d syl expcld wa wf 0z coef2 sylancl elfznn0 ffvelrn mulcld fsummulc1
      expcl eqtrd mulassd adantl expdivd cn nnexpcl div13d cmin elfzelz expsubd
      wne nn0zd nnzd fznn0sub zexpcl eqeltrrd zmulcld eqeltrd fsumzcl ) ACDIJZB
      KZDBUAKZLJZMJZNWKUBJZHUDZBUCKZKZWIWOLJZMJZWLMJZHUEZOAWMWNWSHUEZWLMJXAAWJX
      BWLMABOUFKPZWIQPZWJXBUGEACDACFUHADGUIZADGUJZUKZWPOHBWKWIWPULZWKULUMUNUQAW
      NWSWLHANWKUOZADWKXEAXCWKRPZEOBUPURZUSAWOWNPZUTZWQWRXMWQAROWPVAZWORPZWQOPX
      LAXCNOPXNEVBWPOBXHVCVDWOWKVEZROWOWPVFSZUHZAXDXOWRQPXLXGXPWIWOVISZVGVHVJAW
      NWTHXIXMWTWQWRWLMJZMJOXMWQWRWLXRXSXMDWKADQPXLXETZAXJXLXKTZUSZVKXMWQXTXQXM
      XTWLDWOLJZIJZCWOLJZMJZOXMXTYFYDIJZWLMJYGXMWRYHWLMXMCDWOXMCACOPZXLFTUHZYAA
      DNVTXLXFTZXLXOAXPVLZVMUQXMYFYDWLXMCWOYJYLUSXMYDADVNPZXOYDVNPXLGXPDWOVOSZU
      IYCXMYDYNUJVPVJXMYEYFXMDWKWOVQJZLJZYEOXMDWKWOYAYKXLWOOPAWONWKVRVLXMWKYBWA
      VSXMDOPYORPZYPOPXMDAYMXLGTWBXLYQAWONWKWCVLDYOWDUNWEAYIXOYFOPXLFXPCWOWDSWF
      WGWFWGWHWG $.
  $}

  ${
    $d ph x p q r a b c d $.  $d A x p q r a b c d $.  $d F x p q r a b c d $.
    aalioulem2.a $e |- N = ( deg ` F ) $.
    aalioulem2.b $e |- ( ph -> F e. ( Poly ` ZZ ) ) $.
    aalioulem2.c $e |- ( ph -> N e. NN ) $.
    aalioulem2.d $e |- ( ph -> A e. RR ) $.
    $( Lemma for ~ aaliou .  (Contributed by Stefan O'Rear, 15-Nov-2014.) $)
    aalioulem2 $p |- ( ph -> E. x e. RR+ A. p e. ZZ A. q e. NN (
        ( F ` ( p / q ) ) = 0 -> ( A = ( p / q ) \/
          ( x / ( q ^ N ) ) <_ ( abs ` ( A - ( p / q ) ) ) ) ) ) $=
      ( cc0 wceq cle crp cr c1 wcel wa syl vr va vb vc vd cv cdiv cfv cmin cabs
      co wbr wo wi cn wral cz wrex cexp csn ccnv cima crab cun clt csup wss 1rp
      snssi ax-mp ssrab2 unssi wor cfn c0 wne ltso cnvso mpbi a1i snfi cab cdgr
      chash cply c0p nnne0d eqcomi dgr0 3netr4g fveq2 necon3i eqid fta1 syl2anc
      simpld abrexfi rabssab ssfi sylancl unfi sylancr 1ex snid elun1 ne0i mp2b
      rpssre sstri fisupcl syl13anc sseldi wn 0re rpge0 rgen breq1 rspcev mp2an
      ralbidv ssralv reximi ad2antrr resubcld recnd subeq0ad necon3abid biimprd
      simplr impr absrpcld cc simprl wfn oveq2 fveq2d ex rpred adantr ralimdva
      wb wf plyf fniniseg mpbir2and eqeq2d eqeq1 rexbidv elrab sylanbrc infmrlb
      ffn elun2 syl3anc expr orrd ralrimiva orbi2d imbi2d znq qre eqeq1d breq2d
      cq eqeq2 orbi12d imbi12d rspcv com12 ralrimivv simprr cn0 nnnn0d nnexpcld
      nnrpd rpdivcld simpllr adantl abscld rpre ad2antlr rpcnne0d divid eqbrtrd
      nnge1d lediv23d simpr letrd orim2d imim2d anassrs reximdva mpd ) AGUFZFUF
      ZUGUKZDUHZLMZCUWPMZBUFZCUWPUIUKZUJUHZNULZUMZUNZFUOUPZGUQUPZBOURZUWRUWSUWT
      UWOEUSUKZUGUKZUXBNULZUMZUNZFUOUPZGUQUPZBOURAUAUFZDUHZLMZCUXPMZUWTCUXPUIUK
      ZUJUHZNULZUMZUNZUAPUPZBOURZUXHAQUTZUBUFZCUCUFZUIUKZUJUHZMZUCDVALUTVBZURZU
      BOVCZVDZPVEVAZVFZORUXRUXSUYRUYANULZUMZUNZUAPUPZUYFAUYPOUYRUYGUYOOQORUYGOV
      GVHQOVIVJUYNUBOVKVLZAPUYQVMZUYPVNRZUYPVOVPZUYPPVGZUYRUYPRVUDAPVEVMVUDVQPV
      EVRVSVTAUYGVNRUYOVNRZVUEQWAAUYNUBWBZVNRZUYOVUIVGVUHAUYMVNRZVUJAVUKUYMWDUH
      DWCUHZNULZADUQWEUHRZDWFVPZVUKVUMSIAVULWFWCUHZVPVUOAELVULVUPAEJWGEVULHWHWI
      WJDWFVULVUPDWFWCWKWLTUYMUQDUYMWMWNWOWPUCUBUYMUYKWQTUYNUBOWRVUIUYOWSWTUYGU
      YOXAXBVUFAQUYGRQUYPRVUFQXCXDQUYGUYOXEUYPQXFXGVTVUGAUYPOPVUCXHXIZVTPUYPUYQ
      XJXKXLAVUAUAPAUXPPRZSZUXRUYTVUSUXRSZUXSUYSVUSUXRUXSXMZUYSVUSUXRVVASZSZVUG
      UDUFZUEUFZNULZUEUYPUPZUDPURZUYAUYPRZUYSVUGVVCVUQVTVVHVVCVVFUEOUPZUDPURZVV
      HLPRLVVENULZUEOUPZVVKXNVVLUEOVVEXOXPVVJVVMUDLPVVDLMVVFVVLUEOVVDLVVENXQXTX
      RXSVVJVVGUDPUYPOVGVVJVVGUNVUCVVFUEUYPOYAVJYBVJVTVVCUYAUYORZVVIVVCUYAORUYA
      UYKMZUCUYMURZVVNVVCUXTVVCUXTVVCCUXPACPRZVURVVBKYCAVURVVBYIZYDYEVUSUXRVVAU
      XTLVPZVUTVVSVVAVUTUXSUXTLVUTCUXPVUTCAVVQVURUXRKYCYEVUTUXPAVURUXRYIYEYFYGY
      HYJYKVVCUXPUYMRZUYAUYAMZVVPVVCVVTUXPYLRZUXRVVCUXPVVRYEVUSUXRVVAYMVVCDYLYN
      ZVVTVWBUXRSUUAAVWCVURVVBAYLYLDUUBZVWCAVUNVWDIUQDUUCTYLYLDUULTYCYLLUXPDUUD
      TUUEUYAWMVVOVWAUCUXPUYMUYIUXPMZUYKUYAUYAVWEUYJUXTUJUYIUXPCUIYOYPUUFXRWTUY
      NVVPUBUYAOUYHUYAMUYLVVOUCUYMUYHUYAUYKUUGUUHUUIUUJUYAUYOUYGUUMTUDUEUYAUYPU
      UKUUNUUOUUPYQUUQUYEVUBBUYROUWTUYRMZUYDVUAUAPVWFUYCUYTUXRVWFUYBUYSUXSUWTUY
      RUYANXQUURUUSXTXRWOUYEUXGBOUYEUXEGFUQUOUWNUQRZUWOUORZSZUYEUXEVWIUWPPRZUYE
      UXEUNVWIUWPUVDRVWJUWNUWOUUTUWPUVATZUYDUXEUAUWPPUXPUWPMZUXRUWRUYCUXDVWLUXQ
      UWQLUXPUWPDWKUVBVWLUXSUWSUYBUXCUXPUWPCUVEVWLUYAUXBUWTNVWLUXTUXAUJUXPUWPCU
      IYOYPUVCUVFUVGUVHTUVIUVJYBTAUXGUXOBOAUWTORZSZUXFUXNGUQVWNVWGSUXEUXMFUOVWN
      VWGVWHUXEUXMUNVWNVWISZUXDUXLUWRVWOUXCUXKUWSVWOUXCUXKVWOUXCSZUXJUWTUXBVWOU
      XJPRUXCVWOUXJVWOUWTUXIAVWMVWIYIZVWOUXIVWOUWOEVWNVWGVWHUVKAEUVLRVWMVWIAEJU
      VMYCUVNZUVOZUVPYRYSVWPUWTAVWMVWIUXCUVQYRVWOUXBPRUXCVWOUXAVWOUXAVWOCUWPAVV
      QVWMVWIKYCVWIVWJVWNVWKUVRYDYEUVSYSVWOUXJUWTNULUXCVWOUWTUWTUXIVWMUWTPRAVWI
      UWTUVTUWAVWQVWSVWOUWTUWTUGUKZQUXINVWOUWTYLRUWTLVPSVWTQMVWOUWTVWQUWBUWTUWC
      TVWOUXIVWRUWEUWDUWFYSVWOUXCUWGUWHYQUWIUWJUWKYTYTUWLUWM $.

    aalioulem3.e $e |- ( ph -> ( F ` A ) = 0 ) $.
    $( Lemma for ~ aaliou .  (Contributed by Stefan O'Rear, 15-Nov-2014.) $)
    aalioulem3 $p |- ( ph -> E. x e. RR+ A. r e. RR ( ( abs ` ( A - r ) ) <_ 1
        -> ( x x. ( abs ` ( F ` r ) ) ) <_ ( abs ` ( A - r ) ) ) ) $=
      ( co cabs cfv c1 cle cr wcel cc cc0 va vc vb cv cmin wbr cmul wi wral crp
      wrex caddc cicc 1re resubcl sylancl peano2re syl cpr ccpn cres reex prid1
      crn cint wss cn0 wfn ssid fncpn ax-mp 1nn0 fnfvelrn intss1 cz cply plycpn
      mp2an sseldi cpnres sylancr cima df-ima wf zssre ax-resscn plyss plyreres
      frn syl5eqss cdm iccssre syl2anc syl6ss wceq plyf fdm sseqtr4d c1lip3 w3a
      wa simp2 recnd adantr 3ad2ant1 abssubd simp3 eqbrtrd wb elicc4abs syl3anc
      a1i mpbird subidd fveq2d abs0 eqbrtri syl6eqbr fveq2 oveq2d oveq2 breq12d
      0le1 oveq1d oveq1 rspc2v simp1l ffvelrnd eqtrd breq1d mpd cdiv wne adantl
      ad2antrr abscld absge0d syl5ibrcom expimpd remulcld syl6eqel subid1d 3exp
      0cn sylibd com34 com23 ralrimdv reximdva cif 1rp wn df-ne biimpri absrpcl
      recn syl2an rpreccld ifclda eqid eqif mpbi simplrr simprl resubcld mul02d
      wo breqtrd letri3 mpbir2and ax-1cn mul01i syl6eq simpllr sylancom divrec2
      0re rpcnne0d 3expb simplr leabs ad2antlr lemul1ad letrd eqbrtrrd sylan2br
      simprr ledivmuld jaod mpi imim2d ralimdva imbi2d ralbidv rspcev rexlimdva
      expr ee12an ) ACFUDZUELZMNZOPUFZUWSDNZMNZUAUDZUXAUGLZPUFZUHZFQUIZUAQUKZUX
      BBUDZUXDUGLZUXAPUFZUHZFQUIZBUJUKZAUBUDZDNZUCUDZDNZUELZMNZUXEUXQUXSUELZMNZ
      UGLZPUFZUBCOUELZCOULLZUMLZUIUCUYIUIZUAQUKUXJAUCUBUYGUYHUADACQRZOQRZUYGQRZ
      JUNCOUOUPZAUYKUYHQRZJCUQURZAQQSUSRDOSUTNZNZRDQVAZOQUTNNRQSVBVCAUYQVDZVEZU
      YRDUYRUYTRZVUAUYRVFUYQVGVHZOVGRVUBSSVFVUCSVISVJVKVLVGOUYQVMVRUYRUYTVNVKAD
      VOVPNZRZDVUARHVODVQURVSQDOVTWAADQWBUYSVDZQDQWCAQQUYSWDZVUFQVFADQVPNZRVUGA
      VUDVUHDVOQVFQSVFVUDVUHVFWEWFVOQWGVRHVSDWHURQQUYSWIURWJAUYISDWKZAUYIQSAUYM
      UYOUYIQVFUYNUYPUYGUYHWLWMWFWNASSDWDZVUISWOAVUEVUJHVODWPURZSSDWQURWRWSAUYJ
      UXIUAQAUXEQRZXAZUYJUXHFQVUMUWSQRZUYJUXHVUMVUNUXBUYJUXGVUMVUNUXBUYJUXGUHVU
      MVUNUXBWTZUYJCDNZUXCUELZMNZUXFPUFZUXGVUOUWSUYIRZCUYIRZUYJVUSUHVUOVUTUWSCU
      ELMNZOPUFZVUOVVBUXAOPVUOUWSCVUOUWSVUMVUNUXBXBZXCZVUOCVUMVUNUYKUXBAUYKVULJ
      XDXEZXCXFVUMVUNUXBXGXHVUOUYKUYLVUNVUTVVCXIVVFUYLVUOUNXLVVDCOUWSXJXKXMVUMV
      UNVVAUXBAVVAVULAVVACCUELZMNZOPUFZAVVHTMNZOPAVVGTMACACJXCXNXOVVJTOPXPYCXQX
      RAUYKUYLUYKVVAVVIXIJUYLAUNXLJCOCXJXKXMXDXEUYFVUSUXRUXCUELZMNZUXEUXQUWSUEL
      ZMNZUGLZPUFUCUBUWSCUYIUYIUXSUWSWOZUYBVVLUYEVVOPVVPUYAVVKMVVPUXTUXCUXRUEUX
      SUWSDXSXTXOVVPUYDVVNUXEUGVVPUYCVVMMUXSUWSUXQUEYAXOXTYBUXQCWOZVVLVURVVOUXF
      PVVQVVKVUQMVVQUXRVUPUXCUEUXQCDXSYDXOVVQVVNUXAUXEUGVVQVVMUWTMUXQCUWSUEYEXO
      XTYBYFWMVUOVURUXDUXFPVUOVURUXCVUPUELZMNUXDVUOVUPUXCVUOVUPTSVUOAVUPTWOAVUL
      VUNUXBYGKURZUUDUUAVUOSSUWSDVUMVUNVUJUXBAVUJVULVUKXDXEVVEYHZXFVUOVVRUXCMVU
      OVVRUXCTUELUXCVUOVUPTUXCUEVVSXTVUOUXCVVTUUBYIXOYIYJUUEUUCUUFUUGUUHUUIYKAU
      XIUXPUAQVUMUXETWOZOOUXEMNZYLLZUUJZUJRUXIUXBVWDUXDUGLZUXAPUFZUHZFQUIZUXPVU
      MVWAOVWCUJOUJRVUMVWAXAUUKXLVUMVWAUULZXAVWBVUMUXESRZUXETYMZVWBUJRZVWIVULVW
      JAUXEUUPYNVWKVWIUXETUUMZUUNUXEUUOZUUQUURUUSVUMUXHVWGFQVUMVUNXAUXGVWFUXBVU
      MVUNUXGVWFVUMVUNUXGXAZXAZVWAVWDOWOZXAZVWIVWDVWCWOZXAZUVGZVWFVWDVWDWOVXAVW
      DUUTVWAVWDOVWCUVAUVBVWPVWRVWFVWTVWPVWAVWQVWFVWPVWAXAZVWFVWQOUXDUGLZUXAPUF
      VXBVXCTUXAPVXBVXCOTUGLTVXBUXDTOUGVXBUXDTWOZUXDTPUFZTUXDPUFZVXBUXDUXFTPVUM
      VUNUXGVWAUVCVXBUXFTUXAUGLZTVWAUXFVXGWOVWPUXETUXAUGYEYNVXBUXAVWPUXASRVWAVW
      PUXAVWPUWTVWPUWTVWPCUWSAUYKVULVWOJYOVUMVUNUXGUVDZUVEXCZYPZXCXDUVFYIUVHVXB
      UXCVWPUXCSRVWAVWPSSUWSDAVUJVULVWOVUKYOVWPUWSVXHXCYHZXDYQVXBUXDQRZTQRVXDVX
      EVXFXAXIVWPVXLVWAVWPUXCVXKYPZXDUVQUXDTUVIUPUVJXTOUVKUVLUVMVXBUWTVWPUWTSRV
      WAVXIXDYQXHVWQVWEVXCUXAPVWDOUXDUGYEYJYRYSVWPVWIVWSVWFVWPVWIXAVWFVWSVWCUXD
      UGLZUXAPUFZVWIVWPVWKVXOVWMVWPVWKXAZUXDVWBYLLZVXNUXAPVXPUXDSRZVWBSRZVWBTYM
      ZXAVXQVXNWOZVXPUXDVWPVXLVWKVXMXDZXCVXPVWBVWPVWKVWJVWLVXPUXEAVULVWOVWKUVNX
      CVWNUVOZUVRVXRVXSVXTVYAUXDVWBUVPUVSWMVXPVXQUXAPUFUXDVWBUXAUGLZPUFZVWPVYEV
      WKVWPUXDUXFVYDVXMVWPUXEUXAAVULVWOUVTZVXJYTVWPVWBUXAVWPUXEVWPUXEVYFXCYPZVX
      JYTVUMVUNUXGUWGVWPUXEVWBUXAVYFVYGVXJVWPUWTVXIYQVULUXEVWBPUFAVWOUXEUWAUWBU
      WCUWDXDVXPUXDUXAVWBVYBVWPUXAQRVWKVXJXDVYCUWHXMUWEUWFVWSVWEVXNUXAPVWDVWCUX
      DUGYEYJYRYSUWIUWJUWQUWKUWLUXOVWHBVWDUJUXKVWDWOZUXNVWGFQVYHUXMVWFUXBVYHUXL
      VWEUXAPUXKVWDUXDUGYEYJUWMUWNUWOUWRUWPYK $.

    $( Lemma for ~ aaliou .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aalioulem4 $p |- ( ph -> E. x e. RR+ A. p e. ZZ A. q e. NN (
        ( ( F ` ( p / q ) ) =/= 0 /\ ( abs ` ( A - ( p / q ) ) ) <_ 1 ) ->
          ( A = ( p / q ) \/ ( x / ( q ^ N ) ) <_
            ( abs ` ( A - ( p / q ) ) ) ) ) ) $=
      ( co cabs cfv cle wbr cmul cr wcel va cv cmin c1 wi wral crp wrex cc0 wne
      cdiv wa wceq wo cn cz aalioulem3 w3a cq simp2l simp2r znq syl2anc qre syl
      cexp simp3r oveq2 fveq2d breq1d fveq2 oveq2d breq12d imbi12d rspcv simp1r
      com23 sylc nnrpd simp1l nnzd rpexpcld rpdivcld rpred adantr cc cply recnd
      plyf ffvelrnd abscld remulcld resubcld rpcnd rpne0d divrecd rpge0d absidd
      absmuld oveq1d eqtrd cdgr mulcomd oveq2i syl6eq aalioulem1 eqeltrd simp3l
      mulne0d nnabscl eqeltrrd nnge1d 1re a1i ledivmuld mpbird rprecred lemul2d
      wf mpbid eqbrtrd simpr letrd olcd syld 3exp com34 ralrimdvv reximdva mpd
      ex ) ACUAUBZUCMZNOZUDPQZBUBZYLDOZNOZRMZYNPQZUEZUASUFZBUGUHGUBZFUBZUKMZDOZ
      UIUJZCUUEUCMZNOZUDPQZULZCUUEUMZYPUUDEVFMZUKMZUUIPQZUNZUEZFUOUFGUPUFZBUGUH
      ABCDEUAHIJKLUQAUUBUURBUGAYPUGTZULZUUBUUQGFUPUOUUTUUCUPTZUUDUOTZULZUUBUUQU
      UTUVCUUKUUBUUPUUTUVCUUKUUBUUPUEUUTUVCUUKURZUUBYPUUFNOZRMZUUIPQZUUPUVDUUES
      TZUUJUUBUVGUEUVDUUEUSTZUVHUVDUVAUVBUVIUUTUVAUVBUUKUTZUUTUVAUVBUUKVAZUUCUU
      DVBVCUUEVDVEZUUTUVCUUGUUJVGUVHUUBUUJUVGUUAUUJUVGUEUAUUESYLUUEUMZYOUUJYTUV
      GUVMYNUUIUDPUVMYMUUHNYLUUECUCVHVIZVJUVMYSUVFYNUUIPUVMYRUVEYPRUVMYQUUFNYLU
      UEDVKVIVLUVNVMVNVOVQVRUVDUVGUUPUVDUVGULZUUOUULUVOUUNUVFUUIUVDUUNSTUVGUVDU
      UNUVDYPUUMAUUSUVCUUKVPZUVDUUDEUVDUUDUVKVSUVDEUVDAEUOTAUUSUVCUUKVTZJVEWAWB
      ZWCWDWEUVDUVFSTUVGUVDYPUVEUVDYPUVPWDUVDUUFUVDWFWFUUEDUVDDUPWGOTZWFWFDXSUV
      DAUVSUVQIVEZUPDWIVEUVDUUEUVLWHWJZWKZWLWEUVDUUISTUVGUVDUUHUVDUUHUVDCUUEUVD
      ACSTUVQKVEUVLWMWHWKWEUVDUUNUVFPQUVGUVDUUNYPUDUUMUKMZRMZUVFPUVDYPUUMUVDYPU
      VPWNUVDUUMUVRWNZUVDUUMUVRWOZWPUVDUWCUVEPQZUWDUVFPQUVDUWGUDUUMUVERMZPQUVDU
      WHUVDUUMUUFRMZNOZUWHUOUVDUWJUUMNOZUVERMUWHUVDUUMUUFUWEUWAWSUVDUWKUUMUVERU
      VDUUMUVDUUMUVRWDUVDUUMUVRWQWRWTXAUVDUWIUPTUWIUIUJUWJUOTUVDUWIUUFUUDDXBOZV
      FMZRMZUPUVDUWIUUFUUMRMUWNUVDUUMUUFUWEUWAXCUUMUWMUUFREUWLUUDVFHXDXDXEUVDDU
      UCUUDUVTUVJUVKXFXGUVDUUMUUFUWEUWAUWFUUTUVCUUGUUJXHXIUWIXJVCXKXLUVDUDUVEUU
      MUDSTUVDXMXNUWBUVRXOXPUVDUWCUVEYPUVDUUMUVRXQUWBUVPXRXTYAWEUVDUVGYBYCYDYKY
      EYFYGVQYHYIYJ $.

    $d N a b x $.

    $( Lemma for ~ aaliou .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aalioulem5 $p |- ( ph -> E. x e. RR+ A. p e. ZZ A. q e. NN (
        ( F ` ( p / q ) ) =/= 0 -> ( A = ( p / q ) \/ ( x / ( q ^ N ) ) <_
            ( abs ` ( A - ( p / q ) ) ) ) ) ) $=
      ( co c1 cle wbr wa cn crp wcel va cv cdiv cfv cc0 wne cmin cabs wceq cexp
      wo wi wral cz wrex aalioulem4 cif simpr 1rp ifcl sylancl cr adantr simprr
      clt w3a nnrpd ad2antrr nnzd rpexpcld rpdivcld rpred 1re a1i cq znq adantl
      qre syl resubcld recnd abscld 3jca rprecred simplr min2 lediv1dd nnexpcld
      cmul nnnn0d 1nn nnmulcld nnge1d ledivmuld letrd ltle sylancr imp jca letr
      mpbird sylc olcd a1d pm3.21 min1 anim1i orim2d imim12d ltlecasei ralimdva
      anassrs oveq1 breq1d orbi2d imbi2d 2ralbidv rspcev ee12an rexlimdva mpd
      ex ) AGUBZFUBZUCMZDUDUEUFZCYEUGMZUHUDZNOPZQZCYEUIZUAUBZYDEUJMZUCMZYHOPZUK
      ZULZFRUMZGUNUMZUASUOYFYKBUBZYMUCMZYHOPZUKZULZFRUMGUNUMZBSUOZAUACDEFGHIJKL
      UPAYSUUFUASAYLSTZQZYLNOPZYLNUQZSTZYSYFYKUUJYMUCMZYHOPZUKZULZFRUMZGUNUMZUU
      FUUHUUGNSTUUKAUUGURUSUUIYLNSUTVAZUUHYRUUPGUNUUHYCUNTZQYQUUOFRUUHUUSYDRTZY
      QUUOULZUUHUUSUUTQZQZUVANYHUVCNYHVEPZQZUUOYQUVEUUNYFUVEUUMYKUVEUULVBTZNVBT
      ZYHVBTZVFZUULNOPZNYHOPZQUUMUVCUVIUVDUVCUVFUVGUVHUVCUULUVCUUJYMUUHUUKUVBUU
      RVCZUVCYDEUVCYDUUHUUSUUTVDZVGUVCEAERTUUGUVBJVHZVIVJZVKVLZUVGUVCVMVNZUVCYG
      UVCYGUVCCYEACVBTUUGUVBKVHUVBYEVBTZUUHUVBYEVOTUVRYCYDVPYEVRVSVQVTWAWBZWCVC
      UVEUVJUVKUVCUVJUVDUVCUULNYMUCMZNUVPUVCYMUVOWDUVQUVCUUJNYMUVCUUJUVLVLZUVQU
      VOUVCYLVBTZUVGUUJNOPUVCYLAUUGUVBWEZVLZVMYLNWFVAWGUVCUVTNOPNYMNWIMZOPUVCUW
      EUVCYMNUVCYDEUVMUVCEUVNWJWHNRTUVCWKVNWLWMUVCNNYMUVQUVQUVOWNXAWOVCUVCUVDUV
      KUVCUVGUVHUVDUVKULVMUVSNYHWPWQWRWSUULNYHWTXBXCXDXDUVCYIQZYFYJYPUUNYIYFYJU
      LUVCYIYFXEVQUWFYOUUMYKUVCYOUUMULYIUVCYOUUMUVCYOQUVFYNVBTZUVHVFZUULYNOPZYO
      QUUMUVCUWHYOUVCUVFUWGUVHUVPUVCYNUVCYLYMUWCUVOVKVLUVSWCVCUVCUWIYOUVCUUJYLY
      MUWAUWDUVOUVCUWBUVGUUJYLOPUWDVMYLNXFVAWGXGUULYNYHWTXBYBVCXHXIUVQUVSXJXLXK
      XKUUEUUQBUUJSYTUUJUIZUUDUUOGFUNRUWJUUCUUNYFUWJUUBUUMYKUWJUUAUULYHOYTUUJYM
      UCXMXNXOXPXQXRXSXTYA $.

    $( Lemma for ~ aaliou .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aalioulem6 $p |- ( ph -> E. x e. RR+ A. p e. ZZ A. q e. NN
        ( A = ( p / q ) \/ ( x / ( q ^ N ) ) <_
          ( abs ` ( A - ( p / q ) ) ) ) ) $=
      ( cle wbr cn wral cz wa crp wcel va vb cv cdiv co cfv wceq cexp cmin cabs
      cc0 wo wne wrex aalioulem2 aalioulem5 reeanv sylanbrc r19.26-2 cif adantl
      wi ifcl simpr w3a ad2antlr nnrp ad2antll ad2antrr rpexpcld rpdivcld rpred
      cr nnzd simplrl cq znq qre resubcld recnd abscld 3jca adantr simplrr min1
      syl syl2anc lediv1dd anim1i letr sylc orim2d embantd adantrd min2 adantld
      ex pm2.61dane anassrs ralimdva oveq1 breq1d orbi2d 2ralbidv rspcev ee12an
      syl5bir rexlimdvva mpd ) AGUCZFUCZUDUEZDUFZUKUGZCXLUGZUAUCZXKEUHUEZUDUEZC
      XLUIUEZUJUFZMNZULZVBZFOPGQPZXMUKUMZXOUBUCZXQUDUEZXTMNZULZVBZFOPGQPZRZUBSU
      NUASUNZXOBUCZXQUDUEZXTMNZULZFOPGQPZBSUNZAYDUASUNYKUBSUNYMAUACDEFGHIJKUOAU
      BCDEFGHIJKLUPYDYKUAUBSSUQURAYLYSUAUBSSYLYCYJRZFOPZGQPZAXPSTZYFSTZRZRZYSYC
      YJGFQOUSUUFXPYFMNZXPYFUTZSTZUUBXOUUHXQUDUEZXTMNZULZFOPZGQPZYSUUEUUIAUUGXP
      YFSVCZVAUUFUUAUUMGQUUFXJQTZRYTUULFOUUFUUPXKOTZYTUULVBZUUFUUPUUQRZRZUURXMU
      KUUTXNRZYCUULYJUVAXNYBUULUUTXNVDUVAYAUUKXOUUTYAUUKVBXNUUTYAUUKUUTYARUUJVM
      TZXRVMTZXTVMTZVEZUUJXRMNZYARUUKUUTUVEYAUUTUVBUVCUVDUUTUUJUUTUUHXQUUEUUIAU
      USUUOVFZUUTXKEUUQXKSTUUFUUPXKVGVHUUTEAEOTUUEUUSJVIVNVJZVKVLZUUTXRUUTXPXQA
      UUCUUDUUSVOZUVHVKVLUUTXSUUTXSUUTCXLACVMTUUEUUSKVIUUSXLVMTZUUFUUSXLVPTUVKX
      JXKVQXLVRWFVAVSVTWAZWBWCUUTUVFYAUUTUUHXPXQUUTUUHUVGVLZUUTXPUVJVLZUVHUUTXP
      VMTZYFVMTZUUHXPMNUVNUUTYFAUUCUUDUUSWDZVLZXPYFWEWGWHWIUUJXRXTWJWKWQWCWLWMW
      NUUTYERZYJUULYCUVSYEYIUULUUTYEVDUVSYHUUKXOUUTYHUUKVBYEUUTYHUUKUUTYHRUVBYG
      VMTZUVDVEZUUJYGMNZYHRUUKUUTUWAYHUUTUVBUVTUVDUVIUUTYGUUTYFXQUVQUVHVKVLUVLW
      BWCUUTUWBYHUUTUUHYFXQUVMUVRUVHUUTUVOUVPUUHYFMNUVNUVRXPYFWOWGWHWIUUJYGXTWJ
      WKWQWCWLWMWPWRWSWTWTYRUUNBUUHSYNUUHUGZYQUULGFQOUWCYPUUKXOUWCYOUUJXTMYNUUH
      XQUDXAXBXCXDXEXFXGXHXI $.

    $( Liouville's theorem on diophantine approximation:  Any algebraic number,
       being a root of a polynomial ` F ` in integer coefficients, is not
       approximable beyond order ` N = deg ( F ) ` by rational numbers.  In
       this form, it also applies to rational numbers themselves, which are not
       well approximable by other rational numbers.  (Contributed by Stefan
       O'Rear, 16-Nov-2014.) $)
    aaliou $p |- ( ph -> E. x e. RR+ A. p e. ZZ A. q e. NN ( A = ( p / q ) \/
      ( x / ( q ^ N ) ) < ( abs ` ( A - ( p / q ) ) ) ) ) $=
      ( cdiv co cn wral cz crp wcel cr va cv wceq cexp cmin cabs cfv cle wbr wo
      wrex clt aalioulem6 wa c2 rphalfcl adantl w3a ad2antlr nnrp ad2antll nnzd
      ad2antrr rpexpcld rpdivcld rpred simplr adantr znq qre syl resubcl syl2an
      wi cq recnd abscld 3jca rphalflt ltdiv1dd anim1i ex ltletr sylsyld orim2d
      anassrs ralimdva oveq1 breq1d orbi2d 2ralbidv rspcev ee12an rexlimdva mpd
      rpre ) ACGUBZFUBZMNZUCZUAUBZWREUDNZMNZCWSUENZUFUGZUHUIZUJZFOPZGQPZUARUKWT
      BUBZXBMNZXEULUIZUJZFOPGQPZBRUKZAUACDEFGHIJKLUMAXIXOUARAXARSZUNZXAUOMNZRSZ
      XIWTXRXBMNZXEULUIZUJZFOPZGQPZXOXPXSAXAUPZUQXQXHYCGQXQWQQSZUNXGYBFOXQYFWRO
      SZXGYBVNXQYFYGUNZUNZXFYAWTYIXTTSZXCTSZXETSZURXFXTXCULUIZXFUNZYAYIYJYKYLYI
      XTYIXRXBXPXSAYHYEUSZYIWREYGWRRSXQYFWRUTVAAEQSXPYHAEJVBVCVDZVEVFYIXCYIXAXB
      AXPYHVGYPVEVFYIXDYIXDXQCTSZWSTSZXDTSYHAYQXPKVHYHWSVOSYRWQWRVIWSVJVKCWSVLV
      MVPVQVRYIXFYNYIYMXFYIXRXAXBYIXRYOVFXPXATSAYHXAWPUSYPXPXRXAULUIAYHXAVSUSVT
      WAWBXTXCXEWCWDWEWFWGWGXNYDBXRRXJXRUCZXMYBGFQOYSXLYAWTYSXKXTXEULXJXRXBMWHW
      IWJWKWLWMWNWO $.
  $}

  ${
    $d ph k a b c d $.  $d A k a b c d $.  $d B k a b c d $.  $d C k a b c d $.
    $d F a b c d $.
    geolim3.a $e |- ( ph -> A e. ZZ ) $.
    geolim3.b1 $e |- ( ph -> B e. CC ) $.
    geolim3.b2 $e |- ( ph -> ( abs ` B ) < 1 ) $.
    geolim3.c $e |- ( ph -> C e. CC ) $.
    geolim3.f $e |- F = ( k e. ( ZZ>= ` A ) |-> ( C x. ( B ^ ( k - A ) ) ) ) $.
    $( Geometric series convergence with arbitrary shift, radix, and
       multiplicative constant.  (Contributed by Stefan O'Rear,
       16-Nov-2014.) $)
    geolim3 $p |- ( ph -> seq A ( + , F ) ~~> ( C / ( 1 - B ) ) ) $=
      ( caddc co cexp cmul c1 wceq cc0 wcel cc va cseq cuz cfv cv cmin cmpt cli
      cdiv seqeq3 ax-mp wbr cneg cshi cn0 nn0uz cz 0z a1i oveq2 eqid ovex fvmpt
      adantl geolim wa expcl sylan eqeltrd zcnd nn0cn fvex shftval4 syl2an uzid
      mptex syl uzaddcl oveq1 oveq2d pncan2 eqtr4d 3eqtrd negidd seqeq1d ax-1cn
      isermulc2 subcl sylancr wne cabs abs1 abscld gtned eqnetrd necon3i subeq0
      fveq2 necon3bid mpbird divrecd 3brtr4d znegcld isershft syl2anc syl5eqbr
      wb ) ALFBUBZLEBUCUDZDCEUEZBUFMZNMZOMZUGZBUBZDPCUFMZUIMZUHFXNQXHXOQKLFXNBU
      JUKAXOXQUHULZLXNBUMZUNMZBXSLMZUBZXQUHULZALXTRUBDPXPUIMZOMYBXQUHAYDDUAEUOC
      XJNMZUGZXTRUOUPRUQSAURUSJACUAYFHIUAUEZUOSZYGYFUDZCYGNMZQAEYGYEYJUOYFXJYGC
      NUTYFVACYGNVBVCVDZVEAYHVFZYIYJTYKACTSZYHYJTSHCYGVGVHVIYLYGXTUDZBYGLMZXNUD
      ZDCYOBUFMZNMZOMZDYIOMABTSZYGTSZYNYPQYHABGVJZYGVKZBYGXNEXIXMBUCVLVPZVMVNYL
      YOXISZYPYSQABXISZYHUUEABUQSZUUFGBVOVQYGBBVRVHEYOXMYSXIXNXJYOQZXLYRDOUUHXK
      YQCNXJYOBUFVSVTVTXNVADYROVBVCVQYLYRYIDOYLYRYJYIYLYQYGCNAYTUUAYQYGQYHUUBUU
      CBYGWAVNVTYKWBVTWCWGAYARLXTABUUBWDWEADXPJAPTSZYMXPTSWFHPCWHWIAXPRWJPCWJZA
      PWKUDZCWKUDZWJUUJAUUKPUULUUKPQAWLUSAUULPACHWMIWNWOPCUUKUULPCWKWRWPVQAXPRP
      CAUUIYMXPRQPCQXGWFHPCWQWIWSWTXAXBAUUGXSUQSXRYCXGGABGXCXQLXNBXSUUDXDXEWTXF
      $.
  $}

  ${
    $d A a k x p q $.

    $( Liouville's approximation theorem for algebraic numbers per se.
       (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou2 $p |- ( A e. ( AA i^i RR ) -> E. k e. NN E. x e. RR+ A. p e. ZZ
        A. q e. NN ( A = ( p / q ) \/ ( x / ( q ^ k ) ) <
            ( abs ` ( A - ( p / q ) ) ) ) ) $=
      ( va caa wcel cv cdiv co wceq cfv cn wral cz wrex cc cc0 c0p cr cexp cmin
      cin wa cabs clt wbr wo crp elin cply csn cdif wi elaa w3a cdgr cxp eldifn
      wn 3ad2ant1 simpr fveq1 adantl simpl2 simpl3 recnd fvex fvconst2 3eqtr3rd
      sneqd xpeq2d eqtrd df-0p syl6eqr elsn sylibr mtand wb eldifi 0dgrb mtbird
      syl cn0 dgrcl elnn0 sylib orel2 sylc eqid simp3 simp2 aaliou oveq2 oveq2d
      breq1d orbi2d 2ralbidv rexbidv rspcev syl2anc 3exp rexlimiv sylbi imp ) B
      GUAUDHBGHZBUAHZUEBEIDIZJKZLZAIZXICIZUBKZJKZBXJUCKUFMZUGUHZUIZDNOEPOZAUJQZ
      CNQZBGUAUKXGXHYAXGBRHZBFIZMZSLZFPULMZTUMZUNZQZUEXHYAUOZBFUPYIYJYBYEYJFYHY
      CYHHZYEXHYAYKYEXHUQZYCURMZNHZXKXLXIYMUBKZJKZXPUGUHZUIZDNOEPOZAUJQZYAYLYMS
      LZVAYNUUAUIZYNYLUUAYCRSYCMZUMZUSZLZYLUUFYCYGHZYKYEUUGVAXHYCYFYGUTVBYLUUFU
      EZYCTLUUGUUHYCRSUMZUSZTUUHYCUUEUUJYLUUFVCUUHUUDUUIRUUHUUCSUUHYDBUUEMZSUUC
      UUFYDUUKLYLBYCUUEVDVEYKYEXHUUFVFUUHYBUUKUUCLUUHBYKYEXHUUFVGVHRUUCBSYCVIVJ
      WDVKVLVMVNVOVPFTVQVRVSYLYCYFHZUUAUUFVTYKYEUULXHYCYFYGWAVBZPYCWBWDWCYLYMWE
      HZUUBYLUULUUNUUMPYCWFWDYMWGWHUUAYNWIWJZYLABYCYMDEYMWKUUMUUOYKYEXHWLYKYEXH
      WMWNXTYTCYMNXMYMLZXSYSAUJUUPXRYREDPNUUPXQYQXKUUPXOYPXPUGUUPXNYOXLJXMYMXIU
      BWOWPWQWRWSWTXAXBXCXDVEXEXFXE $.

    $( Liouville's approximation theorem extended to complex ` A ` .
       (Contributed by Stefan O'Rear, 20-Nov-2014.) $)
    aaliou2b $p |- ( A e. AA -> E. k e. NN E. x e. RR+ A. p e. ZZ
        A. q e. NN ( A = ( p / q ) \/ ( x / ( q ^ k ) ) <
            ( abs ` ( A - ( p / q ) ) ) ) ) $=
      ( wcel cr cdiv co cfv clt wbr cn wral cz crp wa c1 adantr cc0 caa cv wceq
      cexp cmin cabs wo wrex cin elin aaliou2 sylbir wn cim c2 1nn a1i cc imcld
      aacn recnd wne wb reim0b syl necon3bbid biimpa absrpcld rphalfcld nnexpcl
      cn0 1nn0 mpan2 ad2antll nnrpd rpdivcld rpred znq adantl qre subcld abscld
      cq cle nnge1d 1rp rpregt0 mp1i rpregt0d syl3anc mpbid rpcnd div1d breqtrd
      lediv2 imsubd reim0d oveq2d subid1d 3eqtrd fveq2d absimle ltletrd lelttrd
      rphalflt eqbrtrrd ralrimivva oveq2 breq1d orbi2d 2ralbidv oveq1 pm2.61dan
      olcd rspc2ev ) BUAFZBGFZBEUBZDUBZHIZUCZAUBZXSCUBZUDIZHIZBXTUEIZUFJZKLZUGZ
      DMNEONZAPUHCMUHZXPXQQBUAGUIFYKBUAGUJABCDEUKULXPXQUMZQZRMFZBUNJZUFJZUOHIZP
      FZYAYQXSRUDIZHIZYGKLZUGZDMNEONZYKYNYMUPUQYMYPYMYOYMYOYMBXPBURFZYLBUTZSZUS
      VAZXPYLYOTVBXPXQYOTXPUUDXQYOTUCVCUUEBVDVEVFVGVHZVIZYMUUBEDOMYMXROFZXSMFZQ
      ZQZUUAYAUUMYTYQYGUUMYTUUMYQYSYMYRUULUUISZUUMYSUUKYSMFZYMUUJUUKRVKFUUOVLXS
      RVJVMVNZVOZVPVQUUMYQUUNVQZUUMYFUUMBXTYMUUDUULUUFSZUUMXTUUMXTWCFZXTGFUULUU
      TYMXRXSVRVSXTVTVEZVAZWAZWBZUUMYTYQRHIZYQWDUUMRYSWDLZYTUVEWDLZUUMYSUUPWEUU
      MRGFTRKLQZYSGFTYSKLQYQGFTYQKLQUVFUVGVCRPFUVHUUMWFRWGWHUUMYSUUQWIUUMYQUUNW
      IRYSYQWOWJWKUUMYQUUMYQUUNWLWMWNUUMYQYPYGUURUUMYPYMYPPFZUULUUHSZVQUVDUUMUV
      IYQYPKLUVJYPXEVEUUMYFUNJZUFJZYPYGWDUUMUVKYOUFUUMUVKYOXTUNJZUEIYOTUEIYOUUM
      BXTUUSUVBWPUUMUVMTYOUEUUMXTUVAWQWRUUMYOYMYOURFUULUUGSWSWTXAUUMYFURFUVLYGW
      DLUVCYFXBVEXFXCXDXNXGYJUUCYAYBYSHIZYGKLZUGZDMNEONCARYQMPYCRUCZYIUVPEDOMUV
      QYHUVOYAUVQYEUVNYGKUVQYDYSYBHYCRXSUDXHWRXIXJXKYBYQUCZUVPUUBEDOMUVRUVOUUAY
      AUVRUVNYTYGKYBYQYSHXLXIXJXKXOWJXM $.
  $}

  ${
    $d F b c d $.  $d A a b c d $.  $d B a b c d $.  $d G a b d $.
    aaliou3lem.a $e |- G = ( c e. ( ZZ>= ` A ) |->
        ( ( 2 ^ -u ( ! ` A ) ) x. ( ( 1 / 2 ) ^ ( c - A ) ) ) ) $.
    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem1 $p |- ( ( A e. NN /\ B e. ( ZZ>= ` A ) ) ->
        ( G ` B ) e. RR ) $=
      ( cn wcel cuz cfv c2 cexp co cmin cmul wceq oveq2d crp cz rpexpcl sylancr
      wa cfa cneg c1 cdiv cr oveq1 ovex fvmpt adantl 2rp cn0 simpl nnnn0d faccl
      cv syl nnzd znegcld 2re 2ne0 rereccli halfgt0 elrpii eluzelz nnz rpmulcld
      zsubcl syl2anr rpred eqeltrd ) AFGZBAHIZGZUAZBCIZJAUBIZUCZKLZUDJUELZBAMLZ
      KLZNLZUFVNVPWCOVLDBVSVTDUPZAMLZKLZNLWCVMCWDBOZWFWBVSNWGWEWAVTKWDBAMUGPPEV
      SWBNUHUIUJVOWCVOVSWBVOJQGVRRGVSQGUKVOVQVOVQVOAULGVQFGVOAVLVNUMUNAUOUQURUS
      JVRSTVOVTQGWARGZWBQGVTJUTVAVBVCVDVNBRGARGWHVLABVEAVFBAVHVIVTWASTVGVJVK $.

    aaliou3lem.b $e |- F = ( a e. NN |-> ( 2 ^ -u ( ! ` a ) ) ) $.
    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem2 $p |- ( ( A e. NN /\ B e. ( ZZ>= ` A ) ) ->
        ( F ` B ) e. ( 0 (,] ( G ` B ) ) ) $=
      ( cn wcel cfv co wbr cle c2 cexp wceq oveq2d c1 cmul vb vd cuz wa cioc cr
      cc0 clt cfa cneg crp uznnssnn sselda cv fveq2 negeqd fvmpt syl cz 2rp cn0
      ovex nnnn0d faccl nnzd znegcld rpexpcl sylancr eqeltrd rpred rpgt0d caddc
      wi breq12d imbi2d weq cdiv cmin nnnn0 leidd nncn subidd 2re 2ne0 rereccli
      cc recni exp0 ax-mp syl6eq rpcnd mulid1d eqtrd breqtrrd nnz oveq1 3brtr4d
      uzid 3syl a1i rpge0d simpl halfgt0 elrpii eluzelz zsubcl syl2anr rpmulcld
      jca31 adantr adantl zmulcld simpr nncnd zcnd mulneg1d nnmulcld nnge1d 1re
      wb nnred leneg mpbid eqbrtrd 1nn0 eluz sylancl mpbird 1lt2 ltleii leexp2a
      nn0negzi mp3an12 2cn expn1 syl6breq lemul12a 3impia syl112anc ax-1cn mpan
      ex facp1 addcom adddid oveq1d 3eqtr3d wne rpcnne0 expaddz syl2anc addsubd
      peano2cn uznn0sub expp1 mulassd eqtr4d sylibrd peano2nnd peano2uz 3imtr4d
      expcom a2d uzind4 impcom cxr w3a 0xr aaliou3lem1 elioc2 mpbir3and ) AIJZB
      AUCKZJZUDZBCKZUGBDKZUELJZUVPUFJZUGUVPUHMZUVPUVQNMZUVOUVPUVOUVPOBUIKZUJZPL
      ZUKUVOBIJUVPUWDQUVLUVMIBAULZUMZEBOEUNZUIKZUJZPLZUWDICUWGBQZUWIUWCOPUWKUWH
      UWBUWGBUIUOUPRHOUWCPVBUQURUVOOUKJZUWCUSJUWDUKJUTUVOUWBUVOUWBUVOBVAJUWBIJU
      VOBUWFVCBVDURVEVFOUWCVGVHVIZVJUVOUVPUWMVKUVNUVLUWAUVLUAUNZCKZUWNDKZNMZVMU
      VLACKZADKZNMZVMZUVLUBUNZCKZUXBDKZNMZVMUVLUXBSVLLZCKZUXFDKZNMZVMUVLUWAVMUA
      UBABUWNAQZUWQUWTUVLUXJUWOUWRUWPUWSNUWNACUOUWNADUOVNVOUAUBVPZUWQUXEUVLUXKU
      WOUXCUWPUXDNUWNUXBCUOUWNUXBDUOVNVOUWNUXFQZUWQUXIUVLUXLUWOUXGUWPUXHNUWNUXF
      CUOUWNUXFDUOVNVOUWNBQZUWQUWAUVLUXMUWOUVPUWPUVQNUWNBCUOUWNBDUOVNVOUXAAUSJZ
      UVLOAUIKZUJZPLZUXQSOVQLZAAVRLZPLZTLZUWRUWSNUVLUXQUXQUYANUVLUXQUVLUXQUVLUW
      LUXPUSJZUXQUKJZUTUVLUXOUVLUXOUVLAVAJZUXOIJZAVSAVDZURVEVFOUXPVGZVHZVJVTUVL
      UYAUXQSTLUXQUVLUXTSUXQTUVLUXTUXRUGPLZSUVLUXSUGUXRPUVLAAWAZWBRUXRWFJZUYISQ
      UXROWCWDWEZWGZUXRWHWIWJRUVLUXQUVLUXQUYHWKWLWMWNEAUWJUXQICUWGAQZUWIUXPOPUY
      NUWHUXOUWGAUIUOUPRHOUXPPVBUQUVLUXNAUVMJUWSUYAQAWOZAWRFAUXQUXRFUNZAVRLZPLZ
      TLZUYAUVMDUYPAQZUYRUXTUXQTUYTUYQUXSUXRPUYPAAVRWPRRGUXQUXTTVBUQWSWQWTUXBUV
      MJZUVLUXEUXIUVLVUAUXEUXIVMUVLVUAUDZOUXBUIKZUJZPLZUXQUXRUXBAVRLZPLZTLZNMZO
      UXFUIKZUJZPLZUXQUXRUXFAVRLZPLZTLZNMZUXEUXIVUBVUIVUEOVUDUXBTLZPLZTLZVUHUXR
      TLZNMZVUPVUBVUIVVAVUBVUIUDVUEUFJZUGVUENMZUDVUHUFJZUDZVURUFJZUGVURNMZUDUXR
      UFJZUDZVUIVURUXRNMZVVAVUBVVEVUIVUBVVBVVCVVDVUBVUEVUBUWLVUDUSJZVUEUKJUTVUB
      VUCVUBVUCVUBUXBVAJZVUCIJVUBUXBUVLUVMIUXBUWEUMZVCZUXBVDURZVEVFZOVUDVGVHZVJ
      VUBVUEVVQXAVUBVUHVUBUXQVUGVUBUWLUYBUYCUTVUBUXOVUBUXOVUBUYDUYEVUBAUVLVUAXB
      VCUYFURVEVFUYGVHZVUBUXRUKJVUFUSJZVUGUKJUXRUYLXCXDVUAUXBUSJZUXNVVSUVLAUXBX
      EZUYOUXBAXFXGUXRVUFVGVHZXHVJXIXJVUBVVIVUIVUBVVFVVGVVHVUBVURVUBUWLVUQUSJZV
      URUKJUTVUBVUDUXBVVPVUAVVTUVLVWAXKZXLZOVUQVGVHZVJVUBVURVWFXAVVHVUBUYLWTXIX
      JVUBVUIXMVUBVVJVUIVUBVUROSUJZPLZUXRNVUBVWGVUQUCKJZVURVWHNMZVUBVWIVUQVWGNM
      ZVUBVUQVUCUXBTLZUJZVWGNVUBVUCUXBVUBVUCVVOXNZVUBUXBVWDXOZXPVUBSVWLNMZVWMVW
      GNMZVUBVWLVUBVUCUXBVVOVVMXQZXRVUBSUFJVWLUFJVWPVWQXTXSVUBVWLVWRYASVWLYBVHY
      CYDVUBVWCVWGUSJVWIVWKXTVWESYEYLVUQVWGYFYGYHOUFJSONMVWIVWJWCSOXSWCYIYJOVUQ
      VWGYKYMUROWFJZVWHUXRQYNOYOWIYPXJVVEVVIVUIVVJUDVVAVUEVUHVURUXRYQYRYSUUBVUB
      VULVUSVUOVUTNVUBVULOVUDVUQVLLZPLZVUSVUBVUKVWTOPVUBVUKVUCUXFTLZUJZVWTVUBVU
      JVXBVUBVVLVUJVXBQVVNUXBUUCURUPVUBVUDUXFTLVUDSUXBVLLZTLZVXCVWTVUBUXFVXDVUD
      TVUBUXBWFJZSWFJZUXFVXDQVWOYTUXBSUUDYGRVUBVUCUXFVWNVUBVXFUXFWFJVWOUXBUUMUR
      XPVUBVXEVUDSTLZVUQVLLVWTVUBVUDSUXBVUBVUDVVPXOZVXGVUBYTWTZVWOUUEVUBVXHVUDV
      UQVLVUBVUDVXIWLUUFWMUUGWMRVUBVVKVWCVXAVUSQZVVPVWEVWSOUGUUHUDZVVKVWCUDVXKU
      WLVXLUTOUUIWIOVUDVUQUUJUUAUUKWMVUBVUOUXQVUGUXRTLZTLVUTVUBVUNVXMUXQTVUBVUN
      UXRVUFSVLLZPLZVXMVUBVUMVXNUXRPVUBUXBSAVWOVXJUVLAWFJVUAUYJXJUULRVUBUYKVUFV
      AJZVXOVXMQUYMVUAVXPUVLAUXBUUNXKUXRVUFUUOVHWMRVUBUXQVUGUXRVUBUXQVVRWKVUBVU
      GVWBWKUYKVUBUYMWTUUPUUQVNUURVUBUXCVUEUXDVUHNVUBUXBIJUXCVUEQVVMEUXBUWJVUEI
      CEUBVPZUWIVUDOPVXQUWHVUCUWGUXBUIUOUPRHOVUDPVBUQURVUAUXDVUHQUVLFUXBUYSVUHU
      VMDFUBVPZUYRVUGUXQTVXRUYQVUFUXRPUYPUXBAVRWPRRGUXQVUGTVBUQXKVNVUBUXGVULUXH
      VUONVUBUXFIJUXGVULQVUBUXBVVMUUSEUXFUWJVULICUWGUXFQZUWIVUKOPVXSUWHVUJUWGUX
      FUIUOUPRHOVUKPVBUQURVUAUXHVUOQZUVLVUAUXFUVMJVXTAUXBUUTFUXFUYSVUOUVMDUYPUX
      FQZUYRVUNUXQTVYAUYQVUMUXRPUYPUXFAVRWPRRGUXQVUNTVBUQURXKVNUVAUVBUVCUVDUVEU
      VOUGUVFJUVQUFJUVRUVSUVTUWAUVGXTUVHABDFGUVIUGUVQUVPUVJVHUVK $.

    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem3 $p |- ( A e. NN -> ( seq A ( + , F ) e. dom ~~> /\
        sum_ b e. ( ZZ>= ` A ) ( F ` b ) e. RR+ /\
        sum_ b e. ( ZZ>= ` A ) ( F ` b ) <_
          ( 2 x. ( 2 ^ -u ( ! ` A ) ) ) ) ) $=
      ( wcel cfv crp c2 co cle wbr syl cc0 c1 cdiv cc cn caddc cseq cli cdm cuz
      cv csu cfa cneg cexp cmul eqid cz nnz uzid aaliou3lem1 wa cr clt cioc w3a
      aaliou3lem2 cxr 0xr elioc2 sylancr mpbid simp1d cmin 2cn 2ne0 reccli cabs
      wb a1i wceq 2re rereccli halfgt0 elrpii rprege0 absid halflt1 eqbrtri 2rp
      mp2b cn0 nnnn0 faccl nnzd znegcld rpexpcl rpcnd geolim3 seqex ovex breldm
      simp2d elrpd rpge0d simp3d cvgcmp eqidd isumrpcl recnd isumclim 1mhlfehlf
      isumle oveq2i mulcl sylancl div1d wne 1rp rpcnne0 divdiv2 mp3an23 3eqtr4d
      ax-mp mulcom syl5eq eqtrd breqtrd 3jca ) AUAIZUBBAUCUDUEZIAUFJZEUGZBJZEUH
      ZKIYKLLAUIJZUJZUKMZULMZNOYFECBAAYHYHUMZYFAUNIAYHIAUOZAUPPZAYICFGUQZYFYIYH
      IURZYJUSIZQYJUTOZYJYICJZNOZYTYJQUUCVAMIZUUAUUBUUDVBZAYIBCDFGHVCYTQVDIUUCU
      SIUUEUUFVOVEYSQUUCYJVFVGVHZVIZYFUBCAUCZYNRRLSMZVJMZSMZUDOUUIYGIYFAUUJYNFC
      YQUUJTIYFLVKVLVMVPUUJVNJZRUTOYFUUMUUJRUTUUJKIUUJUSIQUUJNOURUUMUUJVQUUJLVR
      VLVSVTWAUUJWBUUJWCWGWDWEVPYFYNYFLKIZYMUNIYNKIWFYFYLYFYLYFAWHIYLUAIAWIAWJP
      WKWLLYMWMVGWNZGWOZUUIUULUDUBCAWPYNUUKSWQWRPZYTYJYTYJUUHYTUUAUUBUUDUUGWSWT
      ZXAYTUUAUUBUUDUUGXBZXCZYFYJEBAAYHYHYPYPYRYTYJXDZUURUUTXEYFYKYHUUCEUHZYONY
      FYJUUCEBCAYHYPYQUVAUUHYTUUCXDZYSUUSUUTUUQXIYFUVBUULYOYFUUCUULECAYHYPYQUVC
      YTUUCYSXFUUPXGYFUULYNUUJSMZYOUUKUUJYNSXHXJYFYNLULMZRSMZUVEUVDYOYFUVEYFYNT
      IZLTIZUVETIUUOVKYNLXKXLXMYFUVGUVDUVFVQZUUOUVGRTIRQXNURZUVHLQXNURZUVIRKIUV
      JXORXPXTUUNUVKWFLXPXTYNRLXQXRPYFUVHUVGYOUVEVQVKUUOLYNYAVGXSYBYCYDYE $.
  $}

  ${
    $d A a b x $.  $d B a b x $.

    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 20-Nov-2014.) $)
    aaliou3lem8 $p |- ( ( A e. NN /\ B e. RR+ ) -> E. x e. NN ( 2 x. ( 2 ^ -u (
        ! ` ( x + 1 ) ) ) ) <_ ( B / ( ( 2 ^ ( ! ` x ) ) ^ A ) ) ) $=
      ( cn wcel crp c2 cdiv co cexp wbr c1 cfa cfv cmul cle cmin sylancr oveq2d
      syl va wa cv clt caddc cneg wrex cr 2rp rpdivcl rpred 2re expnbnd mp3an23
      mpan 1lt2 adantl simprl simpll nnaddm1cl syl2anc simplr rerpdivcl reexpcl
      nnnn0d cz nnaddcld nnm1nn0 peano2nn0 faccl zmulcld zsubcld rpexpcl simprr
      cn0 nnzd ltled a1i 1re ltleii nnred nn0ge0d nnge1d lemulge12d wceq oveq1d
      cuz facp1 nncnd nn0cnd subdid ax-1cn npcand pncand eqtrd 3eqtr2d breqtrrd
      cc wb eluz mpbird leexp2ad letrd cc0 wne rpcnne0 mp1i expsub syl12anc 2cn
      expmuld rpcnd rpexpcld rpne0d divrecd 3eqtrrd rpreccld rpmulcld ledivmuld
      mpbid mul12d breqtrd expneg eqtr4d 3brtr4d oveq1 fveq2d breq12d rexlimddv
      negeqd fveq2 rspcev ) BDEZCFEZUBZGCHIZGUAUCZJIZUDKZGGAUCZLUEIZMNZUFZJIZOI
      ZCGYTMNZJIZBJIZHIZPKZADUGZUADYNYSUADUGZYMYNYPUHEZUULYNYPGFEZYNYPFEUIGCUJU
      OUKUUMGUHEZLGUDKUULULUPYPGUAUMUNTUQYOYQDEZYSUBZUBZYQBUEIZLQIZDEZGGUUTLUEI
      ZMNZUFZJIZOIZCGUUTMNZJIZBJIZHIZPKZUUKUURUUPYMUVAYOUUPYSURZYMYNUUQUSZYQBUT
      VAUURGGUVCJIZHIZCLUVIHIZOIZUVFUVJPUURUVOUVQPKGUVNUVQOIZPKUURGCUVNUVPOIZOI
      ZUVRPUURYPUVSPKGUVTPKUURYPGUVCUVGBOIZQIZJIZUVSPUURYPYRUWCUURUUOYNUUMULYMY
      NUUQVBZGCVCRZUURUUOYQVOEYRUHEULUURYQUVLVEZGYQVDRZUURUWCUURUUNUWBVFEZUWCFE
      UIUURUVCUWAUURUVCUURUVBVOEZUVCDEUURUUTVOEZUWIUURUUSDEUWJUURYQBUVLUVMVGZUU
      SVHTZUUTVITZUVBVJTZVPZUURUVGBUURUVGUURUWJUVGDEUWLUUTVJTZVPZUURBUVMVPZVKZV
      LZGUWBVMRUKUURYPYRUWEUWGYOUUPYSVNVQUURGYQUWBUUOUURULVRZLGPKUURLGVSULUPVTV
      RUURUWBYQWGNEZYQUWBPKZUURYQUVGYQOIZUWBPUURYQUVGUURYQUVLWAUURUVGUWPWAUURYQ
      UWFWBUURUVGUWPWCWDUURUWBUVGUVBOIZUWAQIUVGUVBBQIZOIUXDUURUVCUXEUWAQUURUWJU
      VCUXEWEUWLUUTWHTWFUURUVGUVBBUURUVGUWPWIUURUVBUWMWJUURBUVMWIZWKUURUXFYQUVG
      OUURUXFUUSBQIYQUURUVBUUSBQUURUUSLUURUUSUWKWILWREUURWLVRWMWFUURYQBUURYQUVL
      WIUXGWNWOSWPWQUURYQVFEUWHUXBUXCWSUURYQUVLVPUWTYQUWBWTVAXAXBXCUURUWCUVNGUW
      AJIZHIZUVNUVIHIUVSUURGWREZGXDXEUBZUVCVFEZUWAVFEUWCUXIWEUUNUXKUURUIGXFXGUW
      OUWSGUVCUWAXHXIUURUXHUVIUVNHUURGUVGBUXJUURXJVRZUURBUVMVEUURUVGUWPVEXKSUUR
      UVNUVIUURUVNUURUUNUXLUVNFEUIUWOGUVCVMRZXLZUURUVIUURUVHBUURUUNUVGVFEUVHFEU
      IUWQGUVGVMRUWRXMZXLZUURUVIUXPXNZXOXPWQUURGUVSCUXAUURUVSUURUVNUVPUXNUURUVI
      UXPXQZXRUKUWDXSXTUURCUVNUVPUURCUWDXLZUXOUURUVPUXSXLYAYBUURGUVQUVNUXAUURUV
      QUURCUVPUWDUXSXRUKUXNXSXAUURUVFGLUVNHIZOIUVOUURUVEUYAGOUURUXJUVCVOEUVEUYA
      WEXJUURUVCUWNVEGUVCYCRSUURGUVNUXMUXOUURUVNUXNXNXOYDUURCUVIUXTUXQUXRXOYEUU
      JUVKAUUTDYTUUTWEZUUEUVFUUIUVJPUYBUUDUVEGOUYBUUCUVDGJUYBUUBUVCUYBUUAUVBMYT
      UUTLUEYFYGYJSSUYBUUHUVICHUYBUUGUVHBJUYBUUFUVGGJYTUUTMYKSWFSYHYLVAYI $.
  $}

  ${
    $d a b c d e $.  $d F b c d e $.  $d L c d e f $.  $d H d e f $.
    $d A a b c d e $.  $d B a b c d e $.
    aaliou3lem.c $e |- F = ( a e. NN |-> ( 2 ^ -u ( ! ` a ) ) ) $.
    aaliou3lem.d $e |- L = sum_ b e. NN ( F ` b ) $.
    aaliou3lem.e $e |- H = ( c e. NN |-> sum_ b e. ( 1 ... c ) ( F ` b ) ) $.
    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem4 $p |- L e. RR $=
      ( c1 cfv cv csu cr cn wcel c2 cexp co cmul cuz nnuz sumeq1i eqtri crp 1nn
      cseq cli cdm cfa cneg cle wbr cdiv cmin cmpt eqid aaliou3lem3 simp2d rpre
      caddc mp2b eqeltri ) CJUAKZELAKZEMZNCOVEEMVFHOVDVEEUBUCUDJOPZVFUEPZVFNPUF
      VGVAAJUGUHUIPVHVFQQJUJKUKRSZTSULUMJAFVDVIJQUNSFLJUOSRSTSUPZDEFVJUQGURUSVF
      UTVBVC $.

    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem5 $p |- ( A e. NN -> ( H ` A ) e. RR ) $=
      ( cn wcel cfv c1 cfz co cv cr c2 cexp csu oveq2 sumeq1d sumex fvmpt fzfid
      wceq wa elfznn adantl cfa cneg weq fveq2 negeqd oveq2d ovex crp 2rp nnnn0
      cz cn0 faccl syl nnzd znegcld rpexpcl sylancr rpred eqeltrd fsumrecl ) AK
      LZACMNAOPZFQZBMZFUAZRGANGQZOPZVOFUAVPKCVQAUGVRVMVOFVQANOUBUCJVMVOFUDUEVLV
      MVOFVLNAUFVLVNVMLZUHVNKLZVORLVSVTVLVNAUIUJVTVOSVNUKMZULZTPZREVNSEQZUKMZUL
      ZTPWCKBEFUMZWFWBSTWGWEWAWDVNUKUNUOUPHSWBTUQUEVTWCVTSURLWBVALWCURLUSVTWAVT
      WAVTVNVBLWAKLVNUTVNVCVDVEVFSWBVGVHVIVJVDVKVJ $.

    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem6 $p |- ( A e. NN -> ( ( H ` A ) x.
          ( 2 ^ ( ! ` A ) ) ) e. ZZ ) $=
      ( cn wcel cfv c2 cexp co cmul c1 cz cn0 cfa cfz cv csu wceq oveq2 sumeq1d
      sumex fvmpt oveq1d fzfid crp 2rp nnnn0 faccl syl rpexpcl sylancr rpcnd wa
      nnzd cneg cc elfznn weq fveq2 negeqd oveq2d adantl nnnn0d znegcld eqeltrd
      ovex fsummulc1 caddc adantr cc0 wne rpcnne0 ax-mp expaddz mpan syl2anc 2z
      cmin zcnd addcomd nncnd negsubd eqtrd cle wbr elfzle2 facwordi syl3anc wb
      nn0sub mpbid zexpcl eqeltrrd fsumzcl ) AKLZACMZNAUAMZOPZQPRAUBPZFUCZBMZFU
      DZXEQPZSXBXCXIXEQGARGUCZUBPZXHFUDXIKCXKAUEXLXFXHFXKARUBUFUGJXFXHFUHUIUJXB
      XJXFXHXEQPZFUDSXBXFXHXEFXBRAUKZXBXEXBNULLZXDSLZXEULLUMXBXDXBATLZXDKLZAUNZ
      AUOZUPVAZNXDUQURUSXBXGXFLZUTZXHNXGUAMZVBZOPZVCYBXHYFUEZXBYBXGKLZYGXGAVDZE
      XGNEUCZUAMZVBZOPYFKBEFVEZYLYENOYMYKYDYJXGUAVFVGVHHNYEOVMUIUPVIZYCYFYCXOYE
      SLZYFULLUMYCYDYCYDYCXGTLZYDKLYCXGYBYHXBYIVIVJZXGUOUPZVAVKZNYEUQURUSVLVNXB
      XFXMFXNYCXMYFXEQPZSYCXHYFXEQYNUJYCNYEXDVOPZOPZYTSYCYOXPUUBYTUEZYSXBXPYBYA
      VPZNVCLNVQVRUTZYOXPUTUUCXOUUEUMNVSVTNYEXDWAWBWCYCNSLUUATLUUBSLWDYCUUAXDYD
      WEPZTYCUUAXDYEVOPUUFYCYEXDYCYEYSWFYCXDUUDWFZWGYCXDYDUUGYCYDYRWHWIWJYCYDXD
      WKWLZUUFTLZYCYPXQXGAWKWLZUUHYQXBXQYBXSVPZYBUUJXBXGRAWMVIXGAWNWOYCYDTLXDTL
      UUHUUIWPYCYDYRVJYCXDYCXQXRUUKXTUPVJYDXDWQWCWRVLNUUAWSURWTVLXAVLVL $.

    $( Lemma for ~ aaliou3 .  (Contributed by Stefan O'Rear, 16-Nov-2014.) $)
    aaliou3lem7 $p |- ( A e. NN -> ( ( H ` A ) =/= L /\
        ( abs ` ( L - ( H ` A ) ) ) <_
          ( 2 x. ( 2 ^ -u ( ! ` ( A + 1 ) ) ) ) ) ) $=
      ( cn wcel c1 caddc co cfv crp c2 cexp cle cuz cv csu cfa cneg cmul wbr wa
      wne cmin cabs cseq cli cdm w3a peano2nn cdiv cmpt eqid aaliou3lem3 3simpc
      3syl wceq wb cfz cc nncn ax-1cn pncan sylancl oveq2d sumeq1d oveq1d eqidd
      nnuz weq fveq2 negeqd ovex fvmpt 2rp cn0 nnnn0 faccl nnzd znegcld rpexpcl
      cz syl sylancr rpcnd eqeltrd adantl 1nn simp1d mp1i isumsplit oveq2 sumex
      3eqtr4rd syl6eqr aaliou3lem4 recni aaliou3lem5 recnd simp2d mpbird eqcomd
      a1i subaddd eleq1 breq1 anbi12d cr adantr clt simprl difrp ltned resubcld
      rpmulcl rpred lttrd ltled simprr lesubadd2d mpbid absdifled mpbir2and jca
      ltsubrpd ex sylbid mpd ) AKLZAMNOZUAPZFUBZBPZFUCZQLZYTRRYPUDPZUEZSOZUFOZT
      UGZUHZACPZDUIZDUUHUJOZUKPUUETUGZUHZYOYPKLZNBYPULUMUNZLZUUAUUFUOUUGAUPZYPB
      GYQUUDMRUQOZGUBZYPUJOSOUFOURZEFGUUSUSHUTZUUOUUAUUFVAVBYOUUGUUJQLZUUJUUETU
      GZUHZUULYOYTUUJVCZUUGUVCVDYOUUJYTYOUUJYTVCUUHYTNOZDVCYOUVEKYSFUCZDYOMYPMU
      JOZVEOZYSFUCZYTNOMAVEOZYSFUCZYTNOUVFUVEYOUVIUVKYTNYOUVHUVJYSFYOUVGAMVEYOA
      VFLMVFLUVGAVCAVGVHAMVIVJVKVLVMYOYSFBMYPYQKVOYQUSUUPYOYRKLZUHYSVNUVLYSVFLY
      OUVLYSRYRUDPZUEZSOZVFEYRREUBZUDPZUEZSOUVOKBEFVPZUVRUVNRSUVSUVQUVMUVPYRUDV
      QVRVKHRUVNSVSVTUVLUVOUVLRQLZUVNWHLUVOQLWAUVLUVMUVLUVMUVLYRWBLUVMKLYRWCYRW
      DWIWEWFRUVNWGWJWKWLWMMKLZNBMULUUNLZYOWNUWAUWBMUAPZYSFUCZQLUWDRRMUDPUESOZU
      FOTUGMBGUWCUWEUUQUURMUJOSOUFOURZEFGUWFUSHUTWOWPWQYOUUHUVKYTNGAMUURVEOZYSF
      UCUVKKCUURAVCUWGUVJYSFUURAMVEWRVLJUVJYSFWSVTVMWTIXAYODUUHYTDVFLYODBCDEFGH
      IJXBZXCXIYOUUHABCDEFGHIJXDZXEYOYTYOUUMUUAUUPUUMUUOUUAUUFUUTXFWIWKXJXGXHUV
      DUUAUVAUUFUVBYTUUJQXKYTUUJUUETXLXMWIYOUVCUULYOUVCUHZUUIUUKUWJUUHDYOUUHXNL
      ZUVCUWIXOZUWJUUHDXPUGZUVAYOUVAUVBXQUWJUWKDXNLZUWMUVAVDUWLUWHUUHDXRVJXGZXS
      UWJUUKUUHUUEUJOZDTUGDUUHUUENOTUGZUWJUWPDUWJUUHUUEUWLUWJUUEYOUUEQLZUVCYOUV
      TUUDQLZUWRWAYOUVTUUCWHLUWSWAYOUUBYOUUBYOUUMYPWBLUUBKLUUPYPWCYPWDVBWEWFRUU
      CWGWJRUUDYAWJXOZYBZXTZUWNUWJUWHXIZUWJUWPUUHDUXBUWLUXCUWJUUHUUEUWLUWTYKUWO
      YCYDUWJUVBUWQYOUVAUVBYEUWJDUUHUUEUXCUWLUXAYFYGUWJDUUHUUEUXCUWLUXAYHYIYJYL
      YMYN $.

    $d L a b c d e f $.

    $( Example of a "Liouville number", a very simple definable transcendental
       real.  (Contributed by Stefan O'Rear, 20-Nov-2014.) $)
    aaliou3lem9 $p |- -. L e. AA $=
      ( vf vd wcel cdiv co cmin cabs cn cz wn c2 ve caa cv wceq cexp cfv clt wo
      wbr wral crp wrex wa caddc cfa cneg cmul aaliou3lem8 aaliou3lem6 ad2antrl
      c1 cle cn0 2nn nnnn0 faccl nnexpcl sylancr aaliou3lem5 recnd nncnd nnne0d
      3syl cr divcan4d wne aaliou3lem7 simpld eqnetrd necomd neneqd aaliou3lem4
      remulcld nndivred resubcl abscld 2rp peano2nn0 nnz znegcl rpexpcl rpmulcl
      nnred rpred simplr ad2antrr nnexpcld nnrpd rpdivcld oveq2d fveq2d eqbrtrd
      simprd simprr letrd lenltd mpbid oveq1 eqeq2d notbid breq2d anbi12d oveq2
      breq12d rspc2ev syl112anc rexlimddv pm4.56 rexbii rexnal bitri sylib nrex
      nrexdv aaliou2b mto ) CUBLCJUCZKUCZMNZUDZEUCZYHDUCZUENZMNZCYIONZPUFZUGUIZ
      UHZKQUJZJRUJZEUKULZDQULUUADQYLQLZYTEUKUUBYKUKLZUMZYJSZYQSZUMZKQULZJRULZYT
      SZUUDTTUAUCZVAUNNZUOUFZUPZUENZUQNZYKTUUKUOUFZUENZYLUENZMNZVBUIZUUIUAQUAYL
      YKURUUDUUKQLZUVAUMZUMZUUKBUFZUURUQNZRLZUURQLZCUVFUURMNZUDZSZUUTCUVIONZPUF
      ZUGUIZSZUUIUVBUVGUUDUVAUUKABCDEFGHIUSUTUVDTQLUUQVCLZUVHVDUVDUUKVCLZUUQQLU
      VPUVBUVQUUDUVAUUKVEUTZUUKVFUUQVEVMTUUQVGVHZUVDCUVIUVDUVICUVDUVIUVECUVDUVE
      UURUVDUVEUVBUVEVNLUUDUVAUUKABCDEFGHIVIUTZVJUVDUURUVSVKUVDUURUVSVLVOZUVBUV
      ECVPZUUDUVAUVBUWBCUVEONZPUFZUUPVBUIZUUKABCDEFGHIVQZVRUTVSVTWAUVDUVMUUTVBU
      IUVOUVDUVMUUPUUTUVDUVLUVDUVLUVDCVNLUVIVNLUVLVNLABCDEFGHIWBUVDUVFUURUVDUVE
      UURUVTUVDUURUVSWMWCUVSWDCUVIWEVHVJWFZUVDUUPUVDTUKLZUUOUKLZUUPUKLWGUVDUWHU
      UNRLZUWIWGUVDUUMQLZUUMRLUWJUVDUVQUULVCLUWKUVRUUKWHUULVFVMUUMWIUUMWJVMTUUN
      WKVHTUUOWLVHWNUVDUUTUVDYKUUSUUBUUCUVCWOUVDUUSUVDUURYLUVSUUBYLVCLUUCUVCYLV
      EWPWQWRWSWNZUVDUVMUWDUUPVBUVDUVLUWCPUVDUVIUVECOUWAWTXAUVBUWEUUDUVAUVBUWBU
      WEUWFXCUTXBUUDUVBUVAXDXEUVDUVMUUTUWGUWLXFXGUUGUVKUVOUMCUVFYHMNZUDZSZYNCUW
      MONZPUFZUGUIZSZUMJKUVFUURRQYGUVFUDZUUEUWOUUFUWSUWTYJUWNUWTYIUWMCYGUVFYHMX
      HZXIXJUWTYQUWRUWTYPUWQYNUGUWTYOUWPPUWTYIUWMCOUXAWTXAXKXJXLYHUURUDZUWOUVKU
      WSUVOUXBUWNUVJUXBUWMUVICYHUURUVFMXMZXIXJUXBUWRUVNUXBYNUUTUWQUVMUGUXBYMUUS
      YKMYHUURYLUEXHWTUXBUWPUVLPUXBUWMUVICOUXCWTXAXNXJXLXOXPXQUUIYSSZJRULUUJUUH
      UXDJRUUHYRSZKQULUXDUUGUXEKQYJYQXRXSYRKQXTYAXSYSJRXTYAYBYDYCECDKJYEYF $.
  $}

  ${
    $d i j k l m $.
    $( Example of a "Liouville number", a very simple definable transcendental
       real.  (Contributed by Stefan O'Rear, 23-Nov-2014.) $)
    aaliou3 $p |- sum_ k e. NN ( 2 ^ -u ( ! ` k ) ) e/ AA $=
      ( vj vl vi cn c2 cv cfa cfv cneg cexp csu caa cmpt eqid weq negeqd oveq2d
      co fveq2 c1 cfz cbvsumv wcel fvmpt eqcomd sumeq2i eqtri aaliou3lem9 nelir
      ovex ) EFAGZHIZJZKSZALZMBEFBGZHIZJZKSZNZCEUACGUBSDGZVAIZDLNZUPBDCVAOZUPEF
      VBHIZJZKSZDLEVCDLEUOVHADADPZUNVGFKVIUMVFULVBHTQRUCEVHVCDVBEUDVCVHBVBUTVHE
      VABDPZUSVGFKVJURVFUQVBHTQRVEFVGKUKUEUFUGUHVDOUIUJ $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                          Sequences and series
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Taylor polynomials and Taylor's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Tayl $. $( Taylor polynomial of a function $)
  $c Ana $. $( Analytic function $)

  $( Taylor polynomial of a function. $)
  ctayl $a class Tayl $.

  $( The class of analytic functions. $)
  cana $a class Ana $.

  ${
    $d a k n x y B $.  $d a f k n s x y F $.  $d a f k n s x y ph $.  $d x Y $.
    $d a k n x y N $.  $d a f k n s x y S $.  $d x y T $.  $d k x X $.
    $( Define the Taylor polynomial or Taylor series of a function.
       (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    df-tayl $a |- Tayl = ( s e. { RR , CC } , f e. ( CC ^pm s ) |->
        ( n e. ( NN0 u. { +oo } ) ,
          a e. |^|_ k e. ( ( 0 [,] n ) i^i ZZ ) dom ( ( s Dn f ) ` k ) |->
     U_ x e. CC ( { x } X. ( CCfld tsums
        ( k e. ( ( 0 [,] n ) i^i ZZ ) |-> ( ( ( ( ( s Dn f ) ` k ) ` a ) /
          ( ! ` k ) ) x. ( ( x - a ) ^ k ) ) ) ) ) ) ) $.

    $( Define the set of analytic functions, which are functions such that the
       Taylor series of the function at each point converges to the function in
       some neighborhood of the point.  (Contributed by Mario Carneiro,
       31-Dec-2016.) $)
    df-ana $a |- Ana = ( s e. { RR , CC } |-> { f e. ( CC ^pm s ) |
      A. x e. dom f x e. ( ( int ` ( ( TopOpen ` CCfld ) |`t s ) ) `
        dom ( f i^i ( +oo ( s Tayl f ) x ) ) ) } ) $.

    taylfval.s $e |- ( ph -> S e. { RR , CC } ) $.
    taylfval.f $e |- ( ph -> F : A --> CC ) $.
    taylfval.a $e |- ( ph -> A C_ S ) $.
    taylfval.n $e |- ( ph -> ( N e. NN0 \/ N = +oo ) ) $.
    taylfval.b $e |- ( ( ph /\ k e. ( ( 0 [,] N ) i^i ZZ ) ) ->
      B e. dom ( ( S Dn F ) ` k ) ) $.
    $( Lemma for ~ taylfval .  (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    taylfvallem1 $p |- ( ( ( ph /\ X e. CC ) /\
      k e. ( ( 0 [,] N ) i^i ZZ ) ) -> ( ( ( ( ( S Dn F ) ` k ) ` B ) /
        ( ! ` k ) ) x. ( ( X - B ) ^ k ) ) e. CC ) $=
      ( cc wcel cc0 co cz ad2antrr wss cicc cin cdvn cfv cfa cdiv cmin cexp cdm
      wa cv cr cpr cpm cn0 wf cvv cnex a1i elpm2r syl22anc cle wbr inss2 sseldi
      simpr cxr w3a inss1 wb 0xr cpnf wceq wo nn0re rexrd id pnfxr syl6eqel syl
      jaoi elicc1 sylancr mpbid simp2d elnn0z sylanbrc syl3anc adantlr ffvelrnd
      dvnf cn faccl nncnd nnne0d divcld simplr dvnbss fdm recnprss sstrd sseldd
      sseqtrd subcld expcld mulcld ) AHNOZUJZEUKZPGUAQZRUBZOZUJZCXIDFUCQUDZUDZX
      IUEUDZUFQHCUGQZXIUHQXMXOXPXMXNUIZNCXNXMDULNUMZOZFNDUNQOZXIUOOZXRNXNUPAXTX
      GXLISZAYAXGXLANUQOZXTBNFUPZBDTYAYDAURUSIJKNDBFUQXSUTVASZXMXIROPXIVBVCZYBX
      MXKRXIXJRVDXHXLVFZVEXMXIVGOZYGXIGVBVCZXMXIXJOZYIYGYJVHZXMXKXJXIXJRVIYHVEX
      MPVGOGVGOZYKYLVJVKAYMXGXLAGUOOZGVLVMZVNYMLYNYMYOYNGGVOVPYOGVLVGYOVQVRVSWA
      VTSPGXIWBWCWDWEXIWFWGZDFXIWKWHAXLCXROXGMWIZWJXMXPXMYBXPWLOYPXIWMVTZWNXMXP
      YRWOWPXMXQXIXMHCAXGXLWQXMXRNCXMXRBNXMXRFUIZBXMXTYAYBXRYSTYCYFYPDFXIWRWHXM
      YEYSBVMAYEXGXLJSBNFWSVTXCABNTXGXLABDNKAXTDNTIDWTVTXASXAYQXBXDYPXEXF $.

    $( Lemma for ~ taylfval .  (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    taylfvallem $p |- ( ( ph /\ X e. CC ) -> ( CCfld tsums
        ( k e. ( ( 0 [,] N ) i^i ZZ ) |-> ( ( ( ( ( S Dn F ) ` k ) ` B ) /
          ( ! ` k ) ) x. ( ( X - B ) ^ k ) ) ) ) C_ CC ) $=
      ( cc wcel cc0 cicc co cfv ccnfld wa cin cdvn cfa cdiv cmin cexp cmul cmpt
      cz cvv cnfldbas crg ccmn cnrng rngcmn mp1i ctps cnfldtps a1i taylfvallem1
      cv ovex inex1 eqid fmptd tsmscl ) AHNOUAZPGQRZUJUBZNEVJCEVBZDFUCRSSVKUDSU
      ERHCUFRVKUGRUHRZUIZTUKULTUMOTUNOVHUOTUPUQTUROVHUSUTVJUKOVHVIUJPGQVCVDUTVH
      EVJVLNVMABCDEFGHIJKLMVAVMVEVFVG $.

    taylfval.t $e |- T = ( N ( S Tayl F ) B ) $.
    $( Define the Taylor polynomial of a function.  The constant ` Tayl ` is a
       function of five arguments: ` S ` is the base set with respect to
       evaluate the derivatives (generally ` RR ` or ` CC ` ), ` F ` is the
       function we are approximating, at point ` B ` , to order ` N ` .  The
       result is a polynomial function of ` x ` .

       This "extended" version of ~ taylpfval additionally handles the case
       ` N = +oo ` , in which case this is not a polynomial but an infinite
       series, the Taylor series of the function.  (Contributed by Mario
       Carneiro, 30-Dec-2016.) $)
    taylfval $p |- ( ph -> T = U_ x e. CC ( { x } X. ( CCfld tsums
        ( k e. ( ( 0 [,] N ) i^i ZZ ) |-> ( ( ( ( ( S Dn F ) ` k ) ` B ) /
          ( ! ` k ) ) x. ( ( x - B ) ^ k ) ) ) ) ) ) $=
      ( co cc cc0 cvv wcel vn va vs vf ctayl cv csn ccnfld cicc cz cin cdvn cfv
      cfa cdiv cmin cexp cmul cmpt ctsu cxp ciun cn0 cpnf cun cdm ciin cr cmpt2
      cpr cpm df-tayl a1i wa eqidd oveq12 ad2antlr fveq1d dmeqd iineq2dv oveq1d
      wceq mpteq2dva oveq2d xpeq2d iuneq2d mpt2eq123dv simpr wf wss cnex elpm2r
      syl22anc wral nn0ex snex unex c0 wne cxr cle wbr 0xr nn0ssre ressxr sstri
      pnfxr snssi ax-mp unssi sseli wo elun nn0ge0 pnfge elsni syl5breqr lbicc2
      jaoi sylbi syl3anc 0z inelcm sylancl fvex dmex rgenw iinexg rgen mpt2exxg
      eqid mp2an ovmpt2dx simprl ineq1d simprr syl sylibr ralrimiva syl2anc wb
      fveq2d oveq12d mpteq12dv iineq1 elexi elsnc2 orbi2i neeq1d vtoclga r19.2z
      wrex oveq2 elex rexlimivw eliin 3syl mpbird adantl taylfvallem iunss xpex
      xpss12 ssex syl5eq ) AFIDEHUEPZPBQBUFZUGZUHGRIUIPZUJUKZDGUFZEHULPZUMZUMZU
      VKUNUMZUOPZUVGDUPPZUVKUQPZURPZUSZUTPZVAZVBZOAUAUBIDVCVDUGZVEZGRUAUFZUIPZU
      JUKZUVMVFZVGZBQUVHUHGUWHUBUFZUVMUMZUVOUOPZUVGUWKUPPZUVKUQPZURPZUSZUTPZVAZ
      VBZUWCUVFGUVJUWIVGZSAUCUDEHVHQVJZQUCUFZVKPZUAUBUWEGUWHUVKUXCUDUFZULPZUMZV
      FZVGZBQUVHUHGUWHUWKUXGUMZUVOUOPZUWOURPZUSZUTPZVAZVBZVIZUAUBUWEUWJUWTVIZUE
      QEVKPZSUEUCUDUXBUXDUXQVIWBABUDGUAUCUBVLVMAUXCEWBZUXEHWBVNZVNZUAUBUWEUXIUX
      PUWEUWJUWTUYBUWEVOUYBGUWHUXHUWIUYBUVKUWHTZVNZUXGUVMUYDUVKUXFUVLUYAUXFUVLW
      BAUYCUXCEUXEHULVPVQVRZVSVTUYBBQUXOUWSUYBUXNUWRUVHUYBUXMUWQUHUTUYBGUWHUXLU
      WPUYDUXKUWMUWOURUYDUXJUWLUVOUOUYDUWKUXGUVMUYEVRWAWAWCWDWEWFWGAUXTVNUXCEQV
      KAUXTWHWDJAQSTZEUXBTCQHWICEWJHUXSTUYFAWKVMJKLQECHSUXBWLWMUXRSTZAUWESTUWJS
      TZUAUWEWNUYGVCUWDWOVDWPWQUYHUAUWEUWFUWETZUWHWRWSZUWISTZGUWHWNUYHUYIRUWGTZ
      RUJTUYJUYIRWTTZUWFWTTRUWFXAXBZUYLUYMUYIXCVMUWEWTUWFVCUWDWTVCVHWTXDXEXFVDW
      TTUWDWTWJXGVDWTXHXIXJXKUYIUWFVCTZUWFUWDTZXLUYNUWFVCUWDXMUYOUYNUYPUWFXNUYP
      RVDUWFXAUYMRVDXAXBXCRXOXIUWFVDXPXQXSXTRUWFXRYAYBRUWGUJYCYDZUYKGUWHUVMUVKU
      VLYEYFYGGUWHUWISYHYDYIUAUBUWEUWJUWTSSUXRUXRYKYJYLVMYMAUWFIWBZUWKDWBZVNVNZ
      BQUWSUWBUYTUWRUWAUVHUYTUWQUVTUHUTUYTGUWHUWPUVJUVSUYTUWGUVIUJUYTUWFIRUIAUY
      RUYSYNWDYOUYTUWMUVPUWOUVRURUYTUWLUVNUVOUOUYTUWKDUVMAUYRUYSYPZUUBWAUYTUWNU
      VQUVKUQUYTUWKDUVGUPVUAWDWAUUCUUDWDWEWFAUYRVNZUWHUVJWBUWJUXAWBVUBUWGUVIUJV
      UBUWFIRUIAUYRWHWDYOGUWHUVJUWIUUEYQAIVCTZIUWDTZXLZIUWETZAVUCIVDWBZXLVUEMVU
      DVUGVUCIVDVDWTXGUUFUUGUUHYRIVCUWDXMYRZADUXATZDUWITZGUVJWNZAVUJGUVJNYSZAVU
      JGUVJUULZDSTZVUIVUKUUAAUVJWRWSZVUKVUMAVUFVUOVUHUYJVUOUAIUWEUYRUWHUVJWRUYR
      UWGUVIUJUWFIRUIUUMYOUUIUYQUUJYQVULVUJGUVJUUKYTVUJVUNGUVJDUWIUUNUUOGDUVJUW
      ISUUPUUQUURAUWCQQVAZWJZUWCSTAUWBVUPWJZBQWNVUQAVURBQAUVGQTZVNUVHQWJZUWAQWJ
      VURVUSVUTAUVGQXHUUSACDEGHIUVGJKLMNUUTUVHQUWAQUVCYTYSBQUWBVUPUVAYRUWCVUPQQ
      WKWKUVBUVDYQYMUVE $.

    $( Value of the Taylor series as a relation (elementhood in the domain here
       expresses that the series is convergent).  (Contributed by Mario
       Carneiro, 30-Dec-2016.) $)
    eltayl $p |- ( ph -> ( X T Y <-> ( X e. CC /\ Y e. ( CCfld tsums
        ( k e. ( ( 0 [,] N ) i^i ZZ ) |-> ( ( ( ( ( S Dn F ) ` k ) ` B ) /
          ( ! ` k ) ) x. ( ( X - B ) ^ k ) ) ) ) ) ) ) $=
      ( vx wcel cc co cop cv csn ccnfld cc0 cicc cz cin cdvn cfv cdiv cmin cexp
      cfa cmul cmpt ctsu cxp ciun wbr taylfval eleq2d df-br bicomi oveq1 oveq1d
      wa wceq oveq2d mpteq2dv opeliunxp2 3bitr3g ) AIJUAZERZVMQSQUBZUCUDFUEHUFT
      UGUHZCFUBZDGUITUJUJVQUNUJUKTZVOCULTZVQUMTZUOTZUPZUQTZURUSZRIJEUTZISRJUDFV
      PVRICULTZVQUMTZUOTZUPZUQTZRVGAEWDVMAQBCDEFGHKLMNOPVAVBWEVNIJEVCVDQSWCIJWJ
      VOIVHZWBWIUDUQWKFVPWAWHWKVTWGVRUOWKVSWFVQUMVOICULVEVFVIVJVIVKVL $.

    $( The Taylor series defines a function on a subset of the complexes.
       (Contributed by Mario Carneiro, 30-Dec-2016.) $)
    taylf $p |- ( ph -> T : dom T --> CC ) $=
      ( vx vy cc wss ccnfld co cdm wfn crn wf wfun wrel wbr wmo wal cxp csn cc0
      cv cicc cin cdvn cfv cfa cdiv cmin cexp cmul cmpt ctsu ciun taylfval wral
      cz wcel wa simpr snssd taylfvallem xpss12 syl2anc ralrimiva iunss eqsstrd
      sylibr relxp relss ee10 eltayl biimpd alrimiv ctopn cvv cnfldbas crg ccmn
      wi cnrng rngcmn mp1i ctps cnfldtps a1i ovex inex1 taylfvallem1 eqid fmptd
      cha cnfldhaus haustsms moanimv moim sylc dffun6 sylanbrc funfn sylib rnss
      ex syl rnxpss syl6ss df-f ) AEEUAZUBZEUCZQRXSQEUDAEUEZXTAEUFZOUMZPUMZEUGZ
      PUHZOUIYBAEQQUJZRZYHUFYCAEOQYDUKZSFULHUNTZVHUOZCFUMZDGUPTUQUQYMURUQUSTYDC
      UTTYMVATVBTZVCZVDTZUJZVEZYHAOBCDEFGHIJKLMNVFAYQYHRZOQVGYRYHRAYSOQAYDQVIZV
      JZYJQRYPQRYSUUAYDQAYTVKVLABCDFGHYDIJKLMVMYJQYPQVNVOVPOQYQYHVQVSVRZQQVTEYH
      WAWBAYGOAYFYTYEYPVIZVJZWKZPUIUUDPUHZYGAUUEPAYFUUDABCDEFGHYDYEIJKLMNWCWDWE
      AYTUUCPUHZWKUUFAYTUUGUUAPYLQYOSSWFUQZWGWHSWIVISWJVIUUAWLSWMWNSWOVIUUAWPWQ
      YLWGVIUUAYKVHULHUNWRWSWQUUAFYLYNQYOABCDFGHYDIJKLMWTYOXAXBUUHXAZUUHXCVIUUA
      UUHUUIXDWQXEXNYTUUCPXFVSYFUUDPXGXHWEOPEXIXJEXKXLAYAYHUCZQAYIYAUUJRUUBEYHX
      MXOQQXPXQXSQEXRXJ $.

    $( The Taylor series is always defined at the basepoint, with value equal
       to the value of the function.  (Contributed by Mario Carneiro,
       30-Dec-2016.) $)
    tayl0 $p |- ( ph -> ( B e. dom T /\ ( T ` B ) = ( F ` B ) ) ) $=
      ( wcel cc ccnfld cc0 co c1 cfv wbr cdm wceq wa cicc cz cin cdvn cdiv cmin
      cv cfa cexp cmul cmpt ctsu cr cpr wss recnprss syl sstrd wral cxr cle 0xr
      a1i cn0 cpnf wo nn0re rexrd id pnfxr syl6eqel nn0pnfge0 lbicc2 syl3anc 0z
      jaoi elin sylanbrc ralrimiva fveq2 dmeqd eleq2d rspcv sylc cpm cvv elpm2r
      wf cnex syl22anc dvn0 syl2anc fdm eleqtrd sseldd cgsu cnfldbas cnfld0 crg
      eqtrd cmnd cnrng rngmnd mp1i inex1 adantr inss2 simpr sseldi w3a inss1 wb
      ovex elicc1 sylancr mpbid simp2d elnn0z dvnf ffvelrnd faccl nnne0d divcld
      cn nncnd 0cn expcld cdif sylan2 oveq2d fveq1d syl6eq oveq12d oveq1d cfn
      mulcld eqid fmptd csn eldifi eldifsni adantl elnnne0 0expd mul01d suppss2
      wne gsumpt fac0 oveq2 exp0 ax-mp fvmpt div1d mulid1d 3eqtrd ccmn cnfldtps
      rngcmn ctps ccnv cima snfi ssfi tsmsid eqeltrrd subidd mpteq2dv mpbir2and
      eleqtrrd eltayl wfun taylf ffun funbrfv2b 3syl ) ACCGUAZEUBZCEUCZOCEUAUWB
      UDUEZAUWCCPOUWBQFRHUFSZUGUHZCFULZDGUISZUAZUAZUWHUMUAZUJSZCCUKSZUWHUNSZUOS
      ZUPZUQSZOABPCABDPKADURPUSZOZDPUTZIDVAVBZVCACRUWIUAZUCZBARUWGOZCUWJUCZOZFU
      WGVDCUXDOZARUWFOZRUGOZUXEARVEOZHVEOZRHVFUBZUXIUXKAVGVHAHVIOZHVJUDZVKZUXLL
      UXNUXLUXOUXNHHVLVMUXOHVJVEUXOVNVOVPWAVBZAUXPUXMLHVQVBRHVRVSUXJAVTVHRUWFUG
      WBWCZAUXGFUWGMWDUXGUXHFRUWGUWHRUDZUXFUXDCUXSUWJUXCUWHRUWIWEZWFWGWHWIAUXDG
      UCZBAUXCGAUXAGPDWJSOZUXCGUDUXBAPWKOZUWTBPGWMZBDUTUYBUYCAWNVHIJKPDBGWKUWSW
      LWOZDGWPWQZWFAUYDUYABUDJBPGWRVBXEWSZWTZAUWBQFUWGUWMRUWHUNSZUOSZUPZUQSZUWR
      AQUYKXASZUWBUYLAUYMRUYKUAZCUXCUAZTUJSZTUOSZUWBAUWGPUYKQWKRRXBXCQXDOZQXFOA
      XGQXHXIUWGWKOAUWFUGRHUFXRXJVHZUXRAFUWGUYJPUYKAUWHUWGOZUEZUWMUYIVUAUWKUWLV
      UAUXFPCUWJVUAUWTUYBUWHVIOZUXFPUWJWMAUWTUYTIXKAUYBUYTUYEXKVUAUWHUGORUWHVFU
      BZVUBVUAUWGUGUWHUWFUGXLAUYTXMZXNVUAUWHVEOZVUCUWHHVFUBZVUAUWHUWFOZVUEVUCVU
      FXOZVUAUWGUWFUWHUWFUGXPVUDXNVUAUXKUXLVUGVUHXQVGAUXLUYTUXQXKRHUWHXSXTYAYBU
      WHYCWCZDGUWHYDVSMYEVUAUWLVUAVUBUWLYIOVUIUWHYFVBZYJVUAUWLVUJYGYHZVUARUWHRP
      OZVUAYKVHVUIYLUUAUYKUUBZUUCZAUWGUYJFRUUDZRAUWHUWGVUOYMOZUEZUYJUWMRUOSZRVU
      QUYIRUWMUOVUQUWHVUQVUBUWHRUULZUWHYIOVUPAUYTVUBUWHUWGVUOUUEZVUIYNVUPVUSAUW
      HUWGRUUFUUGUWHUUHWCUUIYOVUPAUYTVURRUDVUTVUAUWMVUKUUJYNXEUUKZUUMAUXEUYNUYQ
      UDUXRFRUYJUYQUWGUYKUXSUWMUYPUYITUOUXSUWKUYOUWLTUJUXSCUWJUXCUXTYPUXSUWLRUM
      UATUWHRUMWEUUNYQYRUXSUYIRRUNSZTUWHRRUNUUOVULVVBTUDYKRUUPUUQYQYRVUMUYPTUOX
      RUURVBAUYQUWBTUOSUWBAUYPUWBTUOAUYPUWBTUJSUWBAUYOUWBTUJACUXCGUYFYPYSAUWBAB
      PCGJUYGYEZUUSXEYSAUWBVVCUUTXEUVAAUWGPUYKQWKRXBXCUYRQUVBOAXGQUVDXIQUVEOAUV
      CVHUYSVUNAVUOYTOUYKUVFWKVUOYMUVGZVUOUTVVDYTORUVHVVAVUOVVDUVIXTUVJUVKAUWQU
      YKQUQAFUWGUWPUYJAUWOUYIUWMUOAUWNRUWHUNACUYHUVLYSYOUVMYOUVOABCDEFGHCUWBIJK
      LMNUVPUVNAUWDPEWMEUVQUWCUWEXQABCDEFGHIJKLMNUVRUWDPEUVSCUWBEUVTUWAYA $.
  $}

  ${
    $d k u v x y B $.  $d k u v x y F $.  $d k u v x y N $.  $d k u v x y ph $.
    $d k u v y D $.  $d k u v x y S $.  $d x T $.  $d k x X $.
    taylpfval.s $e |- ( ph -> S e. { RR , CC } ) $.
    taylpfval.f $e |- ( ph -> F : A --> CC ) $.
    taylpfval.a $e |- ( ph -> A C_ S ) $.
    taylpfval.n $e |- ( ph -> N e. NN0 ) $.
    taylpfval.b $e |- ( ph -> B e. dom ( ( S Dn F ) ` N ) ) $.
    $( Lemma for ~ taylpfval and similar theorems.  (Contributed by Mario
       Carneiro, 31-Dec-2016.) $)
    taylplem1 $p |- ( ( ph /\ k e. ( ( 0 [,] N ) i^i ZZ ) ) ->
      B e. dom ( ( S Dn F ) ` k ) ) $=
      ( cc0 co cz wcel cfv cdm wa cc cv cicc cin cfz cdvn wceq 0z nn0zd sylancr
      fzval2 eleq2d biimpar cr cpr cpm wss cvv cnex a1i elpm2r syl22anc dvn2bss
      wf jca 3expa sylan adantr sseldd syldan ) AEUAZMGUBNOUCZPZVJMGUDNZPZCVJDF
      UENZQRZPAVNVLAVMVKVJAMOPGOPVMVKUFUGAGKUHMGUJUIUKULAVNSGVOQRZVPCADUMTUNZPZ
      FTDUONPZSVNVQVPUPZAVSVTHATUQPZVSBTFVCBDUPVTWBAURUSHIJTDBFUQVRUTVAVDVSVTVN
      WADFVJGVBVEVFACVQPVNLVGVHVI $.

    $( Lemma for ~ taylpfval and similar theorems.  (Contributed by Mario
       Carneiro, 31-Dec-2016.) $)
    taylplem2 $p |- ( ( ( ph /\ X e. CC ) /\ k e. ( 0 ... N ) ) ->
 ( ( ( ( ( S Dn F ) ` k ) ` B ) / ( ! ` k ) ) x. ( ( X - B ) ^ k ) ) e. CC ) $=
      ( cc wcel cc0 co cz cfv wceq wa cfz cicc cin cdvn cfa cdiv cmin cexp cmul
      cv wb 0z nn0zd fzval2 sylancr eleq2d adantr biimpa cpnf orcd taylfvallem1
      cn0 taylplem1 syldan ) AHNOZUAZEUKZPGUBQZOZVHPGUCQRUDZOZCVHDFUEQSSVHUFSUG
      QHCUHQVHUIQUJQNOVGVJVLAVJVLULVFAVIVKVHAPROGROVIVKTUMAGLUNPGUOUPUQURUSABCD
      EFGHIJKAGVCOGUTTLVAABCDEFGIJKLMVDVBVE $.

    taylpfval.t $e |- T = ( N ( S Tayl F ) B ) $.
    $( Define the Taylor polynomial of a function.  The constant ` Tayl ` is a
       function of five arguments: ` S ` is the base set with respect to
       evaluate the derivatives (generally ` RR ` or ` CC ` ), ` F ` is the
       function we are approximating, at point ` B ` , to order ` N ` .  The
       result is a polynomial function of ` x ` .  (Contributed by Mario
       Carneiro, 31-Dec-2016.) $)
    taylpfval $p |- ( ph -> T = ( x e. CC |-> sum_ k e. ( 0 ... N )
     ( ( ( ( ( S Dn F ) ` k ) ` B ) / ( ! ` k ) ) x. ( ( x - B ) ^ k ) ) ) ) $=
      ( cc cc0 co ccnfld wcel csn cfz cdvn cfv cfa cdiv cmin cexp cmul csu ciun
      cv cxp cmpt cicc cz cin ctsu cpnf wceq orcd taylplem1 taylfval cgsu ctopn
      cn0 cvv cnfldbas cnfld0 crg ccmn cnrng rngcmn mp1i ctps cnfldtps a1i ovex
      wa inex1 taylfvallem1 eqid fmptd cfn 0z nn0zd fzval2 sylancr adantr fzfid
      cdif eqeltrrd fisuppfi cnfldhaus haustsmsid gsumfsum sumeq1d eqtr4d sneqd
      cha eqtrd xpeq2d iuneq2dv dfmpt3 syl6eqr ) AFBPBULZUAZQIUBRZDGULZEHUCRUDU
      DXIUEUDUFRXFDUGRXIUHRUIRZGUJZUAZUMZUKZBPXKUNAFBPXGSGQIUORZUPUQZXJUNZURRZU
      MZUKXNABCDEFGHIJKLAIVFTIUSUTMVAZACDEGHIJKLMNVBZOVCABPXSXMAXFPTZVSZXRXLXGY
      CXRSXQVDRZUAXLYCXPPXQSSVEUDZVGQVHVISVJTSVKTYCVLSVMVNSVOTYCVPVQXPVGTYCXOUP
      QIUOVRVTVQYCGXPXJPXQACDEGHIXFJKLXTYAWAZXQWBWCZYCXPPVGQUAWKXQYCXHXPWDAXHXP
      UTZYBAQUPTIUPTYHWEAIMWFQIWGWHWIZYCQIWJWLZYGWMYEWBZYEWTTYCYEYKWNVQWOYCYDXK
      YCYDXPXJGUJXKYCXPXJGYJYFWPYCXHXPXJGYIWQWRWSXAXBXCXABPXKXDXE $.

    $( The Taylor polynomial is a function on the complexes (even if the base
       set of the original function is the reals).  (Contributed by Mario
       Carneiro, 31-Dec-2016.) $)
    taylpf $p |- ( ph -> T : CC --> CC ) $=
      ( vx vk cc wf cc0 co cfv cfz cv cdvn cfa cdiv cmin cexp cmul cmpt wcel wa
      csu fzfid taylplem2 fsumcl eqid fmptd taylpfval feq1d mpbird ) APPEQPPNPR
      GUASZCOUBZDFUCSTTVBUDTUESNUBZCUFSVBUGSUHSZOULZUIZQANPVEPVFAVCPUJUKZVAVDOV
      GRGUMABCDOFGVCHIJKLUNUOVFUPUQAPPEVFANBCDEOFGHIJKLMURUSUT $.

    ${
      taylpval.x $e |- ( ph -> X e. CC ) $.
      $( Value of the Taylor polynomial.  (Contributed by Mario Carneiro,
         31-Dec-2016.) $)
      taylpval $p |- ( ph -> ( T ` X ) = sum_ k e. ( 0 ... N )
       ( ( ( ( ( S Dn F ) ` k ) ` B ) / ( ! ` k ) ) x. ( ( X - B ) ^ k ) ) ) $=
        ( vx co cfv cmin cc0 cfz cdvn cfa cdiv cexp cmul csu cvv taylpfval wceq
        cv cc wa wcel simplr oveq1d oveq2d sumeq2dv sumex a1i fvmptd ) AQIUAHUB
        RZCFULZDGUCRSSVDUDSUERZQULZCTRZVDUFRZUGRZFUHVCVEICTRZVDUFRZUGRZFUHZUMEU
        IAQBCDEFGHJKLMNOUJAVFIUKZUNZVCVIVLFVOVDVCUOZUNZVHVKVEUGVQVGVJVDUFVQVFIC
        TAVNVPUPUQUQURUSPVMUIUOAVCVLFUTVAVB $.
    $}

    ${
      taylply2.1 $e |- ( ph -> D e. ( SubRing ` CCfld ) ) $.
      taylply2.2 $e |- ( ph -> B e. D ) $.
      taylply2.3 $e |- ( ( ph /\ k e. ( 0 ... N ) ) ->
        ( ( ( ( S Dn F ) ` k ) ` B ) / ( ! ` k ) ) e. D ) $.
      $( The Taylor polynomial is a polynomial of degree (at most) ` N ` .
         This version of ~ taylply shows that the coefficients of ` T ` are in
         a subring of the complexes.  (Contributed by Mario Carneiro,
         1-Jan-2017.) $)
      taylply2 $p |- ( ph -> ( T e. ( Poly ` D ) /\ ( deg ` T ) <_ N ) ) $=
        ( wcel cc vy vx vu vv cply cfv cdgr cle wbr cc0 cfz co cv cdvn cfa cdiv
        cexp cmul csu cmpt cidp csn cxp cmin cof ccom taylpfval wa simpr cdm cr
        cpr cpm cn0 wss cvv wf cnex a1i elpm2r syl22anc dvnbss syl3anc wceq fdm
        sseqtrd recnprss sstrd sseldd adantr subcld cres df-idp mptresid eqtr4i
        syl fconstmpt offval2 eqidd oveq1 oveq2d sumeq2sdv fmptco eqtr4d ccnfld
        cid csubrg cnfldbas subrgss elplyd cnfld1 subrg1cl plyid plyconst csubg
        c1 syl2anc caddc subrgsubg cnfldadd subgcl 3expb cnfldmul subrgmcl cneg
        sylan cminusg ax-1cn cnfldneg ax-mp eqid subginvcl plysub plyco eqeltrd
        syl5eqelr fveq2d dgrco ccnv cima plyremlem simp2d nn0cnd mulid1d 3eqtrd
        w3a dgrcl eqtrd elfznn0 adantl dvnf dvn2bss ffvelrnd faccl nncnd nnne0d
        cn divcld dgrle eqbrtrd jca ) AFDUEUFZSFUGUFZIUHUIAFUATUJIUKULZCGUMZEHU
        NULZUFZUFZUVEUOUFZUPULZUAUMZUVEUQULZURULZGUSZUTZVATCVBZVCZVDVEULZVFZUVB
        AFUBTUVDUVJUBUMZCVDULZUVEUQULZURULZGUSZUTUVSAUBBCEFGHIJKLMNOVGAUBUATTUW
        AUVNUWDUVRUVOAUVTTSZVHUVTCAUWEVIZACTSZUWEAIUVFUFVJZTCAUWHBTAUWHHVJZBAEV
        KTVLZSZHTEVMULSZIVNSUWHUWIVOJATVPSZUWKBTHVQZBEVOUWLUWMAVRVSZJKLTEBHVPUW
        JVTWAZMEHIWBWCAUWNUWIBWDKBTHWEWPWFABETLAUWKETVOJEWGWPWHWHNWIZWJZWKAUBTU
        VTCVDVAUVQVPTTUWOUWFUWRVAUBTUVTUTZWDAVAXFTWLUWSWMUBTWNWOVSUVQUBTCUTWDAU
        BTCWQVSWRAUVOWSZUVKUWAWDZUVDUVMUWCGUXAUVLUWBUVJURUVKUWAUVEUQWTXAXBXCXDZ
        AUCUDDUVOUVRAUAUVJDGIADXEXGUFSZDTVOZPDTXEXHXIWPZMRXJZAUCUDDVAUVQAUXDXPD
        SZVAUVBSUXEAUXCUXGPDXEXPXKXLWPZDXMXQAUXDCDSUVQUVBSUXEQCDXNXQADXEXOUFSZU
        CUMZDSZUDUMZDSZVHZUXJUXLXRULDSZAUXCUXIPDXEXSWPZUXIUXKUXMUXOXRDXEUXJUXLX
        TYAYBYFZAUXCUXNUXJUXLURULDSZPUXCUXKUXMUXRDXEURUXJUXLYCYDYBYFZAXPYEZXPXE
        YGUFZUFZDXPTSUYBUXTWDYHXPYIYJAUXIUXGUYBDSUXPUXHDXEUYAXPUYAYKYLXQYPYMZUX
        QUXSYNYOAUVCUVOUGUFZIUHAUVCUVSUGUFUYDUVRUGUFZURULZUYDAFUVSUGUXBYQADUVOU
        VRUYDUYEUYDYKUYEYKUXFUYCYRAUYFUYDXPURULUYDAUYEXPUYDURAUVRTUEUFSZUYEXPWD
        ZUVRYSUJVBYTUVPWDZAUWGUYGUYHUYIUUFUWQCUVRUVRYKUUAWPUUBXAAUYDAUYDAUVOUVB
        SUYDVNSUXFDUVOUUGWPUUCUUDUUHUUEAUAUVJDGUVOIUXFMAUVEUVDSZVHZUVHUVIUYKUVG
        VJZTCUVGUYKUWKUWLUVEVNSZUYLTUVGVQAUWKUYJJWJZAUWLUYJUWPWJZUYJUYMAUVEIUUI
        UUJZEHUVEUUKWCUYKUWHUYLCUYKUWKUWLUYJUWHUYLVOUYNUYOAUYJVIEHUVEIUULWCACUW
        HSUYJNWJWIUUMUYKUVIUYKUYMUVIUUQSUYPUVEUUNWPZUUOUYKUVIUYQUUPUURUWTUUSUUT
        UVA $.
    $}

    $( The Taylor polynomial is a polynomial of degree (at most) ` N ` .
       (Contributed by Mario Carneiro, 31-Dec-2016.) $)
    taylply $p |- ( ph -> ( T e. ( Poly ` CC ) /\ ( deg ` T ) <_ N ) ) $=
      ( cc ccnfld wcel cfv co cdm wss vk crg csubrg cnrng cnfldbas subrgid mp1i
      cdvn cpr cpm cn0 cvv cnex a1i elpm2r syl22anc dvnbss syl3anc wceq fdm syl
      cr wf sseqtrd recnprss sstrd sseldd cv cc0 cfz wa cfa adantr elfznn0 dvnf
      adantl simpr dvn2bss ffvelrnd cn faccl nncnd nnne0d divcld taylply2 ) ABC
      NDEUAFGHIJKLMOUBPNOUCQPAUDNOUEUFUGAGDFUHRZQSZNCAWGBNAWGFSZBADVBNUIZPZFNDU
      JRPZGUKPWGWHTHANULPZWJBNFVCZBDTWKWLAUMUNHIJNDBFULWIUOUPZKDFGUQURAWMWHBUSI
      BNFUTVAVDABDNJAWJDNTHDVEVAVFVFLVGAUAVHZVIGVJRPZVKZCWOWFQZQWOVLQZWQWRSZNCW
      RWQWJWKWOUKPZWTNWRVCAWJWPHVMZAWKWPWNVMZWPXAAWOGVNVPZDFWOVOURWQWGWTCWQWJWK
      WPWGWTTXBXCAWPVQDFWOGVRURACWGPWPLVMVGVSWQWSWQXAWSVTPXDWOWAVAZWBWQWSXEWCWD
      WE $.
  $}

  ${
    $d j k x y B $.  $d j k x F $.  $d j k x y N $.  $d j k x y ph $.
    $d j k x S $.
    dvtaylp.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvtaylp.f $e |- ( ph -> F : A --> CC ) $.
    dvtaylp.a $e |- ( ph -> A C_ S ) $.
    dvtaylp.n $e |- ( ph -> N e. NN0 ) $.
    dvtaylp.b $e |- ( ph -> B e. dom ( ( S Dn F ) ` ( N + 1 ) ) ) $.
    $( The derivative of the Taylor polynomial is the Taylor polynomial of the
       derivative of the function.  (Contributed by Mario Carneiro,
       31-Dec-2016.) $)
    dvtaylp $p |- ( ph -> ( CC _D ( ( N + 1 ) ( S Tayl F ) B ) ) =
                            ( N ( S Tayl ( S _D F ) ) B ) ) $=
      ( vx cc cc0 c1 co cfv cmul wceq wcel vk vj vy caddc cfz cv cdvn cdiv cmin
      cfa cexp csu cmpt cdv ctayl cif ctopn crest cvv fvex cnfldtopon toponunii
      ccnfld eqid restid ax-mp eqcomi cr cpr cnex prid2 a1i toponmax mp1i fzfid
      ctopon w3a wa cdm cpm cn0 adantr wss elpm2r syl22anc elfznn0 dvnf syl3anc
      wf adantl cicc cz cin 0z peano2nn0 syl nn0zd fzval2 sylancr eleq2d biimpa
      taylplem1 syldan ffvelrnd cn faccl nncnd nnne0d divcld simp3 sstrd sseldd
      3adant3 subcld expcld mulcld 0cn wn nn0cnd simpr sylanbrc ax-1cn ad2antrr
      3expa oveq1 oveq2d mpteq2dva dvnadd syl2anc fveq1d fveq2d 3eqtr3d oveq12d
      eqtrd 1nn0 fveq2 cuz oveq1d sylan2 taylpfval recnprss dvnbss fdm 3ad2ant1
      sseqtrd 3ad2ant2 wne neneqad elnnne0 nnm1nn0 ifclda c0ex ovex ifex dvmptc
      dvmptid dvmptsub subid1i mpteq2i syl6eq dvexp2 ifeq2d dvmptcmul dvmptfsum
      dvmptco mulid1d 1z dvfg dvbss dvn1 addcomd dmeqd eleqtrrd taylplem2 oveq2
      fsumshft elfznn ifnefalse simpll nn0uz eleqtri fzss1 sseli simplr mulassd
      npcand div23d divcan5rd pncan3d 3eqtr3rd 3eqtr2d sumeq2dv sumeq1i syl6eqr
      facp1 0p1e1 oveq1i an32s cdif eldif wi biimpri sylan nnuz elfzuz3 elfzuzb
      syl6eleq ex necon1bd sylan2b iftrue eldifi adantlr mul01d fsumss 3eqtr2rd
      impr 3eqtr4d ) AMLMNFOUDPZUEPZCUAUFZDEUGPZQZQZUYAUJQZUHPZLUFZCUIPZUYAUKPZ
      RPZUAULUMZUNPZLMNFUEPCUBUFZDDEUNPZUGPZQZQZUYMUJQZUHPZUYHUYMUKPZRPZUBULZUM
      ZMUXSCDEUOPPZUNPFCDUYNUOPPZAUYLLMUXTUYFUYANSZNUYAUYHUYAOUIPZUKPZRPZUPZRPZ
      UAULZUMVUCALUYJVUKMUAUXTVCUQQZVUMMVUMMURPZVUMVUMUSTVUNVUMSVCUQUTVUMUSMMVU
      MVUMVUMVDZVAZVBVEVFVGVUOMVHMVIZTZAVHMVJVKZVLVUMMVPQTMVUMTAVUPMVUMVMVNANUX
      SVOAUYAUXTTZUYGMTZVQZUYFUYIAVUTUYFMTZVVAAVUTVRZUYDUYEVVDUYCVSZMCUYCVVDDVU
      QTZEMDVTPTZUYAWATZVVEMUYCWIAVVFVUTGWBAVVGVUTAMUSTZVVFBMEWIZBDWCVVGVVIAVJV
      LGHIMDBEUSVUQWDWEZWBVUTVVHAUYAUXSWFZWJZDEUYAWGWHAVUTUYANUXSWKPWLWMZTZCVVE
      TAVUTVVOAUXTVVNUYAANWLTZUXSWLTUXTVVNSWNAUXSAFWATZUXSWATZJFWOWPZWQNUXSWRWS
      WTXAABCDUAEUXSGHIVVSKXBXCXDZVVDUYEVVDVVHUYEXETVVMUYAXFWPZXGZVVDUYEVWAXHZX
      IZXMZVVBUYHUYAVVBUYGCAVUTVVAXJAVUTCMTZVVAABMCABDMIAVVFDMWCZGDUUAWPZXKAUXS
      UYBQZVSZBCAVWJEVSZBAVVFVVGVVRVWJVWKWCGVVKVVSDEUXSUUBWHAVVJVWKBSHBMEUUCWPU
      UEKXLXLZUUDXNZVUTAVVHVVAVVLUUFZXOZXPVVBUYFVUJVWEVVBVUFNVUIMNMTZVVBVUFVRXQ
      VLVVBVUFXRZVRZUYAVUHVVBUYAMTVWQVVBUYAVWNXSWBVWRUYHVUGVVBUYHMTZVWQVWMWBVWR
      UYAXETZVUGWATZVWRVVHUYANUUGZVWTVVBVVHVWQVWNWBVWRUYANVVBVWQXTUUHUYAUUIZYAU
      YAUUJZWPXOXPUUKZXPVVDLUYIVUJUYFMMMVURVVDVUSVLZAVUTVVAUYIMTVWOYDAVUTVVAVUJ
      MTZVXEYDZVVDMLMUYIUMUNPLMVUJORPZUMLMVUJUMVVDLUCUYHOUCUFZUYAUKPZVUFNUYAVXJ
      VUGUKPZRPZUPZMMUYIVUJMUSMMVXFVXFAVUTVVAVWSVWMYDOMTZVVDVVAVRZYBVLZVVDVXJMT
      ZVRZVXJUYAVVDVXRXTVVDVVHVXRVVMWBXOVXNUSTVXSVUFNVXMUULUYAVXLRUUMUUNVLVVDML
      MUYHUMUNPLMONUIPZUMLMOUMVVDLUYGOCNMMMMVXFVVDVVAXTVXQVVDLMVXFUUPAVWFVUTVVA
      VWLYCVWPVXPXQVLVVDLCMVXFAVWFVUTVWLWBUUOUUQLMVXTOOYBUURUUSUUTVVDVVHMUCMVXK
      UMUNPUCMVXNUMSVVMUCUYAUVAWPVXJUYHUYAUKYEVXJUYHSZVUFVXMVUINVYAVXLVUHUYARVX
      JUYHVUGUKYEYFUVBUVEVVDLMVXIVUJVXPVUJVXHUVFYGYNVWDUVCUVDALMVULVUBAVVAVRZVU
      BNOUDPZUXSUEPZCVUGUYOQZQZVUGUJQZUHPZVUHRPZUAULZOUXSUEPZVUKUAULZVULVYBVUAV
      YIUBUAONFOWLTVYBUVGVLVVPVYBWNVLAFWLTVVAAFJWQWBAUYNVSZCDUBUYNFUYGGAVVFVYMM
      UYNWIGDEUVHWPZAVYMBDABDEVWHHIUVIIXKZJACVWJFUYOQZVSKAVYPVWIAFDOUYBQZUGPZQZ
      OFUDPZUYBQZVYPVWIAVVFVVGOWATZVVQVYSWUASGVVKWUBAYOVLJDEOFYHWEAFVYRUYOAVYQU
      YNDUGAVWGVVGVYQUYNSZVWHVVKDEUVJYIZYFYJAVYTUXSUYBAOFVXOAYBVLAFJXSUVKYKYLUV
      LUVMZUVNUYMVUGSZUYSVYHUYTVUHRWUFUYQVYFUYRVYGUHWUFCUYPVYEUYMVUGUYOYPYJUYMV
      UGUJYPYMUYMVUGUYHUKUVOYMUVPVYBVYLVYKVYIUAULVYJVYBVYKVUKVYIUAVYBUYAVYKTZVR
      ZVUKUYFVUIRPUYFUYARPZVUHRPVYIWUHVUJVUIUYFRWUHVXBVUJVUISWUHUYAWUGVWTVYBUYA
      UXSUVQWJZXHZUYANNVUIUVRWPYFWUHUYFUYAVUHWUHAVUTVVCAVVAWUGUVSZWUGVUTVYBVYKU
      XTUYAONYQQZTVYKUXTWCZOWAWUMYOUVTUWAONUXSUWBVFZUWCZWJZVWDYIZWUHUYAWUJXGZWU
      HUYHVUGWUHUYGCAVVAWUGUWDAVWFVVAWUGVWLYCXNWUHVWTVXAWUJVXDWPZXOUWEWUHWUIVYH
      VUHRWUHUYDUYARPZUYEUHPZWVAVYGUYARPZUHPZWUIVYHWUHUYEWVCWVAUHWUHVUGOUDPZUJQ
      ZVYGWVERPZUYEWVCWUHVXAWVFWVGSWUTVUGUWOWPWUHWVEUYAUJWUHUYAOWUSVXOWUHYBVLZU
      WFZYKWUHWVEUYAVYGRWVIYFYLYFWUHAVUTWVBWUISWULWUQVVDUYDUYAUYEVVTVVDUYAVVMXS
      VWBVWCUWGYIWUHWVDUYDVYGUHPVYHWUHUYDVYGUYAWUHAVUTUYDMTWULWUQVVTYIWUHVYGWUH
      VXAVYGXETWUTVUGXFWPZXGWUSWUHVYGWVJXHWUKUWHWUHUYDVYFVYGUHWUHCUYCVYEWUHVUGV
      YRQZOVUGUDPZUYBQZVYEUYCWUHVVFVVGWUBVXAWVKWVMSAVVFVVAWUGGYCAVVGVVAWUGVVKYC
      WUBWUHYOVLWUTDEOVUGYHWEWUHVUGVYRUYOWUHVYQUYNDUGAWUCVVAWUGWUDYCYFYJWUHWVLU
      YAUYBWUHOUYAWVHWUSUWIYKUWJYJYRYNYLYRUWKUWLVYDVYKVYIUAVYCOUXSUEUWPUWQUWMUW
      NVYBVYKUXTVUKUAWUNVYBWUOVLWUHUYFVUJWURWUGVYBVUTVXGWUPAVUTVVAVXGVXHUWRYSXP
      VYBUYAUXTVYKUWSTZVRZVUKUYFNRPNWVOVUJNUYFRWVOVUFVUJNSWVNVYBVUTWUGXRZVRVUFU
      YAUXTVYKUWTVYBVUTWVPVUFVYBVUTVRWUGUYANVUTVXBWUGUXAVYBVUTVXBWUGVUTVXBVRZUY
      AOYQQZTUXSUYAYQQTZWUGWVQUYAXEWVRVUTVVHVXBVWTVVLVWTVVHVXBVRVXCUXBUXCUXDUXG
      VUTWVSVXBUYANUXSUXEWBUYAOUXSUXFYAUXHWJUXIUXQUXJVUFNVUIUXKWPYFWVOUYFWVNVYB
      VUTVVCUYAUXTVYKUXLAVUTVVCVVAVWDUXMYSUXNYNVYBNUXSVOUXOUXPYGYNAVUDUYKMUNALB
      CDVUDUAEUXSGHIVVSKVUDVDYTYFALVYMCDVUEUBUYNFGVYNVYOJWUEVUEVDYTUXR $.
  $}

  ${
    $d m n B $.  $d m n F $.  $d m n M $.  $d m n N $.  $d m n ph $.
    $d m n S $.
    dvntaylp.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvntaylp.f $e |- ( ph -> F : A --> CC ) $.
    dvntaylp.a $e |- ( ph -> A C_ S ) $.
    dvntaylp.m $e |- ( ph -> M e. NN0 ) $.
    dvntaylp.n $e |- ( ph -> N e. NN0 ) $.
    dvntaylp.b $e |- ( ph -> B e. dom ( ( S Dn F ) ` ( N + M ) ) ) $.
    $( The ` M ` -th derivative of the Taylor polynomial is the Taylor
       polynomial of the ` M ` -th derivative of the function.  (Contributed by
       Mario Carneiro, 1-Jan-2017.) $)
    dvntaylp $p |- ( ph -> ( ( CC Dn ( ( N + M ) ( S Tayl F ) B ) ) ` M ) =
                             ( N ( S Tayl ( ( S Dn F ) ` M ) ) B ) ) $=
      ( cc caddc co cfv cc0 wcel wceq vm ctayl cdvn cmin cfz cuz nn0uz syl6eleq
      vn cn0 eluzfz2b sylib cv wi c1 fveq2 oveq2d oveq2 oveq123d eqeq12d imbi2d
      eqidd wss cpm ssid a1i cmap mapsspm wf nn0addcld eqid taylpf elmap sylibr
      cnex sseldi syl2anc cr cpr recnprss syl cvv elpm2r syl22anc nn0cnd eqtr4d
      dvn0 subid1d cfzo wa cdv adantr elfzouz adantl syl6eleqr syl3anc cdm dvnf
      dvnp1 dvnbss sseqtrd sstrd fzofzp1 fznn0sub elfzofz dvnadd ax-1cn addassd
      nppcan2d eqtrd fveq2d pncan3d subcld add12d eqtr3d 3eqtr4d dmeqd eleqtrrd
      fdm dvtaylp oveq1d eqcomd oveqd 3eqtr3rd syl5ibr expcom a2d fzind2 subidd
      mpcom addid1d ) AFNGFOPZCDEUBPZPZUCPZQZGFFUDPZOPZCDFDEUCPZQZUBPZPZGCUUAPF
      RFUEPZSZAYPUUBTZAFRUFQZSZUUDAFUJUUFKUGUHRFUKULAUAUMZYOQZGFUUHUDPZOPZCDUUH
      YSQZUBPZPZTZUNARYOQZGFRUDPZOPZCDRYSQZUBPZPZTZUNZAUIUMZYOQZGFUVDUDPZOPZCDU
      VDYSQZUBPZPZTZUNAUVDUOOPZYOQZGFUVLUDPZOPZCDUVLYSQZUBPZPZTZUNAUUEUNUAUIFRF
      UUHRTZUUOUVBAUVTUUIUUPUUNUVAUUHRYOUPUVTUUKUURCCUUMUUTUVTUULUUSDUBUUHRYSUP
      UQUVTUUJUUQGOUUHRFUDURUQUVTCVBUSUTVAUUHUVDTZUUOUVKAUWAUUIUVEUUNUVJUUHUVDY
      OUPUWAUUKUVGCCUUMUVIUWAUULUVHDUBUUHUVDYSUPUQUWAUUJUVFGOUUHUVDFUDURUQUWACV
      BUSUTVAUUHUVLTZUUOUVSAUWBUUIUVMUUNUVRUUHUVLYOUPUWBUUKUVOCCUUMUVQUWBUULUVP
      DUBUUHUVLYSUPUQUWBUUJUVNGOUUHUVLFUDURUQUWBCVBUSUTVAUUHFTZUUOUUEAUWCUUIYPU
      UNUUBUUHFYOUPUWCUUKYRCCUUMUUAUWCUULYTDUBUUHFYSUPUQUWCUUJYQGOUUHFFUDURUQUW
      CCVBUSUTVAUVCUUGAUUPYNUVAANNVCZYNNNVDPZSZUUPYNTUWDANVEZVFANNVGPZUWEYNNNVH
      ANNYNVIYNUWHSABCDYNEYLHIJAGFLKVJMYNVKVLNNYNVOVOVMVNVPZNYNWGVQAUURYLCCUUTY
      MAUUSEDUBADNVCZENDVDPSZUUSETADVRNVSZSZUWJHDVTWAZANWBSZUWMBNEVIZBDVCZUWKUW
      OAVOVFHIJNDBEWBUWLWCWDZDEWGVQUQAUUQFGOAFAFKWEZWHUQACVBUSWFVFUVDRFWIPSZAUV
      KUVSAUWTUVKUVSUNUVKUVSAUWTWJZNUVEWKPZNUVJWKPZTUVEUVJNWKURUXAUVMUXBUVRUXCU
      XAUWDUWFUVDUJSZUVMUXBTUWDUXAUWGVFAUWFUWTUWIWLUXAUVDUUFUJUWTUVDUUFSAUVDRFW
      MWNUGWOZNYNUVDWSWPUXANUVOUOOPZCUVIPZWKPUVOCDDUVHWKPZUBPZPUXCUVRUXAUVHWQZC
      DUVHUVOAUWMUWTHWLZUXAUWMUWKUXDUXJNUVHVIUXKAUWKUWTUWRWLZUXEDEUVDWRWPUXAUXJ
      BDUXAUXJEWQZBUXAUWMUWKUXDUXJUXMVCUXKUXLUXEDEUVDWTWPAUXMBTZUWTAUWPUXNIBNEX
      SWAWLXAAUWQUWTJWLXBUXAGUVNAGUJSUWTLWLZUXAUVLUUCSZUVNUJSUWTUXPARFUVDXCWNUV
      LRFXDWAZVJUXACYLYSQZWQZUXFDUVHUCPZQZWQACUXSSUWTMWLUXAUYAUXRUXAUVGUXTQZUVD
      UVGOPZYSQZUYAUXRUXAUWMUWKUXDUVGUJSUYBUYDTUXKUXLUXEUXAGUVFUXOUXAUVDUUCSZUV
      FUJSUWTUYEAUVDRFXEWNUVDRFXDWAVJDEUVDUVGXFWDUXAUXFUVGUXTUXAUXFGUVNUOOPZOPU
      VGUXAGUVNUOAGNSUWTAGLWEZWLZUXAUVNUXQWEUONSUXAXGVFZXHUXAUYFUVFGOUXAFUVDUOA
      FNSUWTUWSWLZUXAUVDUXEWEZUYIXIUQXJZXKUXAYLUYCYSUXAGUVDUVFOPZOPYLUYCUXAUYMF
      GOUXAUVDFUYKUYJXLUQUXAGUVDUVFUYHUYKUXAFUVDUYJUYKXMXNXOXKXPXQXRXTUXAUXGUVJ
      NWKUXAUXFUVGCUVIUYLYAUQUXAUXIUVQUVOCUXAUVQUXIUXAUVPUXHDUBUXAUWJUWKUXDUVPU
      XHTAUWJUWTUWNWLUXLUXEDEUVDWSWPUQYBYCYDUTYEYFYGYHYJAYRGCUUAAYRGROPGAYQRGOA
      FUWSYIUQAGUYGYKXJYAXJ $.
  $}

  ${
    $d k B $.  $d k F $.  $d k M $.  $d k N $.  $d k ph $.  $d k S $.
    dvntaylp0.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvntaylp0.f $e |- ( ph -> F : A --> CC ) $.
    dvntaylp0.a $e |- ( ph -> A C_ S ) $.
    dvntaylp0.m $e |- ( ph -> M e. ( 0 ... N ) ) $.
    dvntaylp0.b $e |- ( ph -> B e. dom ( ( S Dn F ) ` N ) ) $.
    dvntaylp0.t $e |- T = ( N ( S Tayl F ) B ) $.
    $( The first ` N ` derivatives of the Taylor polynomial at ` B ` match the
       derivatives of the function from which it is derived.  (Contributed by
       Mario Carneiro, 1-Jan-2017.) $)
    dvntaylp0 $p |- ( ph -> ( ( ( CC Dn T ) ` M ) ` B ) =
                            ( ( ( S Dn F ) ` M ) ` B ) ) $=
      ( cc cdvn co cfv wcel cdm vk cmin ctayl caddc cc0 cfz cn0 elfz3nn0 nn0cnd
      syl elfznn0 npcand oveq1d oveq2d fveq1d fznn0sub fveq2d eleqtrrd dvntaylp
      syl6eqr dmeqd eqtr3d wceq cr cpr cpm wf cvv wss cnex elpm2r syl22anc dvnf
      a1i syl3anc dvnbss sseqtrd sstrd cpnf orcd dvnadd pncan3d eqtrd taylplem1
      fdm eqid tayl0 simprd ) ACGOEPQZRZRCHGUBQZCDGDFPQZRZUCQQZRZCWMRZACWJWNAGO
      WKGUDQZCDFUCQZQZPQZRWJWNAGWTWIAWSEOPAWSHCWRQEAWQHCWRAHGAHAGUEHUFQSZHUGSLG
      HUHUJUIZAGAXAGUGSZLGHUKUJZUIZULZUMNUTUNUOABCDFGWKIJKXDAXAWKUGSZLGUEHUPUJZ
      ACHWLRZTZWQWLRZTMAXKXIAWQHWLXFUQVAURUSVBUOACWNTSWOWPVCAWMTZCDWNUAWMWKIADV
      DOVEZSZFODVFQSZXCXLOWMVGIAOVHSZXNBOFVGZBDVIXOXPAVJVNIJKODBFVHXMVKVLZXDDFG
      VMVOZAXLBDAXLFTZBAXNXOXCXLXTVIIXRXDDFGVPVOAXQXTBVCJBOFWEUJVQKVRZAXGWKVSVC
      XHVTAXLCDUAWMWKIXSYAXHACXJWKDWMPQRZTMAYBXIAYBGWKUDQZWLRZXIAXNXOXCXGYBYDVC
      IXRXDXHDFGWKWAVLAYCHWLAGHXEXBWBUQWCVAURWDWNWFWGWHWC $.
  $}

  ${
    $d m n x y A $.  $d m n x y B $.  $d m n x y F $.  $d m n x y ph $.
    $d m n x y N $.  $d m n x y S $.  $d m n x y T $.
    taylthlem1.s $e |- ( ph -> S e. { RR , CC } ) $.
    taylthlem1.f $e |- ( ph -> F : A --> CC ) $.
    taylthlem1.a $e |- ( ph -> A C_ S ) $.
    taylthlem1.d $e |- ( ph -> dom ( ( S Dn F ) ` N ) = A ) $.
    taylthlem1.n $e |- ( ph -> N e. NN ) $.
    taylthlem1.b $e |- ( ph -> B e. A ) $.
    taylthlem1.t $e |- T = ( N ( S Tayl F ) B ) $.
    taylthlem1.r $e |- R = ( x e. ( A \ { B } ) |->
      ( ( ( F ` x ) - ( T ` x ) ) / ( ( x - B ) ^ N ) ) ) $.
    taylthlem1.i $e |- ( ( ph /\ ( n e. ( 1 ..^ N ) /\
      0 e. ( ( y e. ( A \ { B } ) |->
        ( ( ( ( ( S Dn F ) ` ( N - n ) ) ` y ) -
            ( ( ( CC Dn T ) ` ( N - n ) ) ` y ) ) /
          ( ( y - B ) ^ n ) ) ) limCC B ) ) ) ->
      0 e. ( ( x e. ( A \ { B } ) |->
        ( ( ( ( ( S Dn F ) ` ( N - ( n + 1 ) ) ) ` x ) -
            ( ( ( CC Dn T ) ` ( N - ( n + 1 ) ) ) ` x ) ) /
          ( ( x - B ) ^ ( n + 1 ) ) ) ) limCC B ) ) $.
    $( Lemma for ~ taylth .  This is the main part of Taylor's theorem, except
       for the induction step, which is supposed to be proven using
       L'H&ocirc;pital's rule.  However, since our proof of L'H&ocirc;pital
       assumes that ` S = RR ` , we can only do this part generically, and for
       ~ taylth itself we must restrict to ` RR ` .  (Contributed by Mario
       Carneiro, 1-Jan-2017.) $)
    taylthlem1 $p |- ( ph -> 0 e. ( R limCC B ) ) $=
      ( vm cc0 csn cdif cv cmin co cdvn cfv cc cexp cdiv cmpt climc c1 cfz wcel
      cn elfz1end sylib wi caddc wceq oveq2 fveq2d fveq1d oveq12d oveq1d eleq2d
      mpteq2dv imbi2d weq fveq2 oveq1 cbvmptv syl6eq cuz ccnfld ctopn crest cnt
      cdv wbr wa eqid fvmpt syl cn0 nnnn0d nn0uz syl6eleq eluzfz2b cdm eleqtrrd
      ovex dvntaylp0 oveq2d cr cpr cpm wf cvv wss cnex a1i elpm2r syl22anc dvnf
      syl3anc ffvelrnd subidd 3eqtrd wfun funmpt sylancr mpbid sseqtrd eqsstr3d
      cfzo eqssd feq2d ffvelrnda dvnp1 eqtr3d feqmptd ctayl syl2anc eqtrd dmeqd
      wb sselda taylpf dvntaylp feq1d mpbird syldan dvn0 syl6eqr ctopon subcld
      dmmpti syl6eleqr funbrfvb nnm1nn0 dvnbss fdm fzo0end elfzofz 3syl dvn2bss
      nncnd ax-1cn npcand recnprss 3eqtr3rd sstrd 1nn0 pncan3d syl6reqr addid2d
      dvn1 0nn0 cnfldtopon toponmax mp1i df-ss ssid mapsspm elmap sylibr sseldi
      cin cmap 3eqtr3d dvmptres3 ctop cuni resttopon topontop toponuni dvbssntr
      ntrss2 dvmptres2 breqd fmptd eldv simprd eldifi oveqan12rd subid1d eqtr2d
      dvmptsub sylan2 ssdifssd sseldd adantr exp1d mpteq2dva expr expcom fzind2
      a2d mpcom eleqtrd ) AUBBDEUCZUDZBUEZKKUFUGZGJUHUGZUIZUIZUXGUXHUJHUHUGZUIZ
      UIZUFUGZUXGEUFUGZKUKUGZULUGZUMZEUNUGZFEUNUGKUOKUPUGUQZAUBUXTUQZAKURUQZUYA
      PKUSUTAUBBUXFUXGKUAUEZUFUGZUXIUIZUIZUXGUYEUXLUIZUIZUFUGZUXPUYDUKUGZULUGZU
      MZEUNUGZUQZVAAUBBUXFUXGKUOUFUGZUXIUIZUIZUXGUYPUXLUIZUIZUFUGZUXPUOUKUGZULU
      GZUMZEUNUGZUQZVAZAUBCUXFCUEZKIUEZUFUGZUXIUIZUIZVUHVUJUXLUIZUIZUFUGZVUHEUF
      UGZVUIUKUGZULUGZUMZEUNUGZUQZVAAUBBUXFUXGKVUIUOVBUGZUFUGZUXIUIZUIZUXGVVCUX
      LUIZUIZUFUGZUXPVVBUKUGZULUGZUMZEUNUGZUQZVAAUYBVAUAIKUOKUYDUOVCZUYOVUFAVVN
      UYNVUEUBVVNUYMVUDEUNVVNBUXFUYLVUCVVNUYJVUAUYKVUBULVVNUYGUYRUYIUYTUFVVNUXG
      UYFUYQVVNUYEUYPUXIUYDUOKUFVDZVEVFVVNUXGUYHUYSVVNUYEUYPUXLVVOVEVFVGUYDUOUX
      PUKVDVGVJVHVIVKUAIVLZUYOVVAAVVPUYNVUTUBVVPUYMVUSEUNVVPUYMBUXFUXGVUKUIZUXG
      VUMUIZUFUGZUXPVUIUKUGZULUGZUMVUSVVPBUXFUYLVWAVVPUYJVVSUYKVVTULVVPUYGVVQUY
      IVVRUFVVPUXGUYFVUKVVPUYEVUJUXIUYDVUIKUFVDZVEVFVVPUXGUYHVUMVVPUYEVUJUXLVWB
      VEVFVGUYDVUIUXPUKVDVGVJBCUXFVWAVURBCVLZVVSVUOVVTVUQULVWCVVQVULVVRVUNUFUXG
      VUHVUKVMUXGVUHVUMVMVGVWCUXPVUPVUIUKUXGVUHEUFVNVHVGVOVPVHVIVKUYDVVBVCZUYOV
      VMAVWDUYNVVLUBVWDUYMVVKEUNVWDBUXFUYLVVJVWDUYJVVHUYKVVIULVWDUYGVVEUYIVVGUF
      VWDUXGUYFVVDVWDUYEVVCUXIUYDVVBKUFVDZVEVFVWDUXGUYHVVFVWDUYEVVCUXLVWEVEVFVG
      UYDVVBUXPUKVDVGVJVHVIVKUYDKVCZUYOUYBAVWFUYNUXTUBVWFUYMUXSEUNVWFBUXFUYLUXR
      VWFUYJUXOUYKUXQULVWFUYGUXKUYIUXNUFVWFUXGUYFUXJVWFUYEUXHUXIUYDKKUFVDZVEVFV
      WFUXGUYHUXMVWFUYEUXHUXLVWGVEVFVGUYDKUXPUKVDVGVJVHVIVKVUGKUOVQUIUQAUBBUXFU
      XGCDVUHUYQUIZVUHUYSUIZUFUGZUMZUIZEVWKUIZUFUGZUXPULUGZUMZEUNUGZVUEAEDVRVSU
      IZGVTUGZWAUIUIZUQZUBVWQUQZAEUBGVWKWBUGZWCZVXAVXBWDAVXDEUBCDVUHKUXIUIZUIZV
      UHKUXLUIZUIZUFUGZUMZWCZAEVXJUIZUBVCZVXKAVXLEVXEUIZEVXGUIZUFUGZVXNVXNUFUGU
      BAEDUQZVXLVXPVCQCEVXIVXPDVXJVUHEVCZVXFVXNVXHVXOUFVUHEVXEVMVUHEVXGVMVGVXJW
      EZVXNVXOUFWOWFWGAVXOVXNVXNUFADEGHJKKLMNAKUBVQUIZUQKUBKUPUGZUQAKWHVXTAKPWI
      ZWJWKUBKWLUTAEDVXEWMZQOWNZRWPWQAVXNAVYCUJEVXEAGWRUJWSZUQZJUJGWTUGZUQZKWHU
      QVYCUJVXEXAZLAUJXBUQZVYFDUJJXAZDGXCZVYHVYJAXDXEZLMNUJGDJXBVYEXFXGZVYBGJKX
      HXIZVYDXJXKXLAVXJXMEVXJWMZUQVXMVXKYJCDVXIXNAEDVYPQCDVXIVXJVXFVXHUFWOVXSUU
      AUUBEUBVXJUUCXOXPAVXCVXJEUBACVWHVXFVWIVXHGUJUJDLADUJVUHUYQAUYQWMZUJUYQXAZ
      DUJUYQXAZAVYFVYHUYPWHUQZVYRLVYNAUYCVYTPKUUDWGZGJUYPXHXIAVYQDUJUYQAVYQDAVY
      QJWMZDAVYFVYHVYTVYQWUBXCLVYNWUAGJUYPUUEXIAVYKWUBDVCMDUJJUUFWGXQADVYCVYQOA
      VYFVYHUYPVYAUQZVYCVYQXCLVYNAUYCUYPUBKXSUGUQWUCPKUUGUYPUBKUUHUUIZGJUYPKUUJ
      XIXRXTYAXPZYBZADUJVUHVXEAVYIDUJVXEXAZVYOAVYCDUJVXEOYAXPZYBAVXEGUYQWBUGZCD
      VXFUMGCDVWHUMZWBUGAUYPUOVBUGZUXIUIZVXEWUIAWUKKUXIAKUOAKPUUKZUOUJUQAUULXEZ
      UUMZVEZAGUJXCZVYHVYTWULWUIVCAVYFWUQLGUUNWGZVYNWUAGJUYPYCXIZYDACDUJVXEWUHY
      EAUYQWUJGWBACDUJUYQWUEYEWQUUOAVUHDUQZVUHUJUQZVWIUJUQZADUJVUHADGUJNWURUUPZ
      YKZAUJUJVUHUYSAUJUJUYSXAUJUJUOEGUYQYFUGUGZXAADEGWVEUYQUOLWUENUOWHUQAUUQXE
      ZAEVYCUOGUYQUHUGUIZWMVYDAWVGVXEAWVGWUIVXEAWUQUYQVYGUQZWVGWUIVCWURAVYJVYFV
      YSVYLWVHVYMLWUENUJGDUYQXBVYEXFXGGUYQUVAYGAWULWUIVXEWUSWUPYDZYHYIWNWVEWEYL
      AUJUJUYSWVEAUYSUYPUJUOUYPVBUGZEGJYFUGZUGZUHUGZUIWVEAUYPUXLWVMAHWVLUJUHAWV
      LKEWVKUGZHAWVJKEWVKAUOKWUNWUMUURZVHRUUSWQVFADEGJUYPUOLMNWUAWVFAEVYCWVJUXI
      UIZWMVYDAWVPVXEAWVJKUXIWVOVEYIWNYMYHYNYOZYBZYPZAWUTWVAVXHUJUQZWVDAUJUJVUH
      VXGAUJUJVXGXAUJUJUBEGVXEYFUGUGZXAADEGWWAVXEUBLWUHNUBWHUQAUVBXEZAEVYCUBGVX
      EUHUGUIZWMVYDAWWCVXEAWUQVXEVYGUQZWWCVXEVCWURAVYJVYFWUGVYLWWDVYMLWUHNUJGDV
      XEXBVYEXFXGGVXEYQYGYIWNWWAWEYLAUJUJVXGWWAAKUJUBKVBUGZEWVKUGZUHUGZUIVXGWWA
      AKWWGUXLAWWFHUJUHAWWFWVNHAWWEKEWVKAKWUMUUTZVHRYRWQVFADEGJKUBLMNVYBWWBAEVY
      CWWEUXIUIZWMVYDAWWIVXEAWWEKUXIWWHVEYIWNYMYDYNYOZYBZYPACVWIVXHGVWSVWRUJGDD
      LAVUHGUQZWVAWVBAGUJVUHWURYKZWVRYPAWWLWVAWVTWWMWWKYPACVWIVXHGVWRUJUJGVWRWE
      ZLVWRUJYSUIUQZUJVWRUQAVWRWWNUVCZUJVWRUVDUVEAWUQGUJUVLGVCWURGUJUVFUTWVRWWK
      AUJUYSWBUGZVXGUJCUJVWIUMZWBUGCUJVXHUMAWUKUXLUIZWWQVXGAUJUJXCZHUJUJWTUGZUQ
      ZVYTWWSWWQVCWWTAUJUVGZXEAUJUJUVMUGZWXAHUJUJUVHAUJUJHXAHWXDUQADEGHJKLMNVYB
      VYDRYLUJUJHXDXDUVIUVJUVKZWUAUJHUYPYCXIAWUKKUXLWUOVEYDAUYSWWRUJWBACUJUJUYS
      WVQYEWQACUJUJVXGWWJYEUVNUVONVWSWEZWWNAVWTDAVWSUVPUQZDVWSUVQZXCVWTDXCAVWSG
      YSUIUQZWXGAWWOWUQWXIWWPWURGVWRUJUVRXOZGVWSUVSWGADGWXHNAWXIGWXHVCWXJGVWSUV
      TWGXQDVWSWXHWXHWEUWBYGADWUIWMZVWTAWXKVYCDAWUIVXEWVIYIOYHADGUYQVWSVWRWURWU
      ENWXFWWNUWAXRXTUWCUWLUWDYOABDEUBGVWSVWKVWPVWRWXFWWNVWPWEWURACDVWJUJVWKAWU
      TWDVWHVWIWUFWVSYTVWKWEZUWENUWFXPUWGAVUDVWPEUNABUXFVUCVWOAUXGUXFUQZWDZVUAV
      WNVUBUXPULWXMAUXGDUQZVUAVWNVCUXGDUXEUWHAWXOWDZVWNVUAUBUFUGVUAWXOAVWLVUAVW
      MUBUFCUXGVWJVUADVWKCBVLVWHUYRVWIUYTUFVUHUXGUYQVMVUHUXGUYSVMVGWXLUYRUYTUFW
      OWFAVWMEUYQUIZEUYSUIZUFUGZWXQWXQUFUGUBAVXQVWMWXSVCQCEVWJWXSDVWKVXRVWHWXQV
      WIWXRUFVUHEUYQVMVUHEUYSVMVGWXLWXQWXRUFWOWFWGAWXRWXQWXQUFADEGHJUYPKLMNWUDV
      YDRWPWQAWXQADUJEUYQWUEQXJXKXLUWIWXPVUAWXPUYRUYTADUJUXGUYQWUEYBAWXOUXGUJUQ
      UYTUJUQADUJUXGWVCYKAUJUJUXGUYSWVQYBYPYTUWJUWKUWMWXNUXPWXNUXGEAUXFUJUXGADU
      JUXEWVCUWNYKAEUJUQWXMADUJEWVCQUWOUWPYTUWQVGUWRVHWNXEVUIUOKXSUGUQZAVVAVVMA
      WXTVVAVVMVAAWXTVVAVVMTUWSUWTUXBUXAUXCAUXSFEUNAUXSBUXFUXGJUIZUXGHUIZUFUGZU
      XQULUGZUMFABUXFUXRWYDAUXOWYCUXQULAUXKWYAUXNWYBUFAUXGUXJJAUXJUBUXIUIZJAUXH
      UBUXIAKWUMXKZVEAWUQVYHWYEJVCWURVYNGJYQYGYHVFAUXGUXMHAUXMUBUXLUIZHAUXHUBUX
      LWYFVEAWWTWXBWYGHVCWXCWXEUJHYQXOYHVFVGVHVJSYRVHUXD $.
  $}

  ${
    $d m x y A $.  $d k m x y B $.  $d k m x y F $.  $d x y M $.  $d m x y T $.
    $d k m x y N $.  $d k m x y ph $.
    taylth.f $e |- ( ph -> F : A --> RR ) $.
    taylth.a $e |- ( ph -> A C_ RR ) $.
    taylth.d $e |- ( ph -> dom ( ( RR Dn F ) ` N ) = A ) $.
    taylth.n $e |- ( ph -> N e. NN ) $.
    taylth.b $e |- ( ph -> B e. A ) $.
    taylth.t $e |- T = ( N ( RR Tayl F ) B ) $.
    ${
      taylthlem2.m $e |- ( ph -> M e. ( 1 ..^ N ) ) $.
      taylthlem2.i $e |- ( ph -> 0 e. ( ( x e. ( A \ { B } ) |->
        ( ( ( ( ( RR Dn F ) ` ( N - M ) ) ` x ) -
            ( ( ( CC Dn T ) ` ( N - M ) ) ` x ) ) /
          ( ( x - B ) ^ M ) ) ) limCC B ) ) $.
      $( Lemma for ~ taylth .  (Contributed by Mario Carneiro, 1-Jan-2017.) $)
      taylthlem2 $p |- ( ph -> 0 e. ( ( x e. ( A \ { B } ) |->
        ( ( ( ( ( RR Dn F ) ` ( N - ( M + 1 ) ) ) ` x ) -
            ( ( ( CC Dn T ) ` ( N - ( M + 1 ) ) ) ` x ) ) /
          ( ( x - B ) ^ ( M + 1 ) ) ) ) limCC B ) ) $=
        ( co cr cc wcel vy vk cc0 cv c1 caddc cmin cdvn cmpt cexp cdiv climc wa
        cfv cdm wss cn0 cfz cuz 1nn0 ax-mp syl sseldi fznn0sub2 elfznn0 syl3anc
        wf dvnfre cpm reex a1i cvv ax-resscn fss sylancl dvnbss sseqtrd dvn2bss
        cnex wceq eqsstr3d eqssd feq2d mpbid sselda adantl ccnfld nnnn0d sseldd
        ffvelrnda cres adantr ffvelrnd cn dvnply2 eqeltrrd syldan resubcld eqid
        simpr fmptd nn0addcld reexpcld crn retop uniretop sylancr ax-1cn fveq2d
        cdv nncnd dvnp1 eqtr3d dmeqd feqmptd oveq2d 3eqtr3rd plyf sylan2 ctopon
        recnd dvmptres3 dvmptres ovex syl6eq cmul subcld expcld eqtrd mpteq2dva
        oveq1 ccncf fveq2 oveq12d cnmptlimc oveq1d cima expne0d resmpt fvmpt wb
        csn cdif nn0uz eleqtri fzss1 cfzo fzofzp1 cpr prid1 elpm2r syl22anc fdm
        fvres cply csubrg cress cdr resubdrg simpli cdgr cle wbr eleqtrrd faccl
        cfa nndivred taylply2 plyreres elfzouz nnuz syl6eleqr cioo ctg cnt ctop
        simpld ntrss2 nppcan2d fzonnsub elfzofz ctopn tgioo2 isopn3 mpbird dvnf
        dvbssntr difss fvex recn cnfldtopon toponmax mp1i df-ss sylib ssid cmap
        cin mapsspm elmap sylibr dvmptsub dmmpti syl5sseqr addcld mulcld elfznn
        prid2 dvmptid 0cn dvmptc subid1i mpteq2i dvexp mpteq2dv dvmptco mulid1d
        pncand dvntaylp0 subidd ctx ccn subcn dvcn syl31anc cncfmptid cncfmpt1f
        plycn syl6ss cncfmpt2f 0expd wrex ssdifssd eldifsni subne0d nnzd necomd
        wne neneqd nrexdv df-ima eleq2i elrnmpti sylnibr nnne0d mulne0d imaeq1d
        bitri eleq2d syl6bb mtbird eldifi nn0zd divcld nnrecred cxp crest mp2an
        txtopon toponunii restid eqcomi limcresi oveq1i cncfmptc eqidd cop ccnp
        sseqtri opelxpi cncnpi limccnp2 mul02d fveq1d sylan9eq mulcomd divdiv1d
        mulcn divrecd 3eqtr2rd 3eltr3d lhop eleqtrd ) AUCBCDUUBZUUCZBUDZUACUAUD
        ZHGUEUFQZUGQZRFUHQZUNZUNZVWGVWISEUHQZUNZUNZUGQZUIZUNZVWFUACVWGDUGQZVWHU
        JQZUIZUNZUKQZUIZDULQBVWEVWFVWKUNZVWFVWNUNZUGQZVWFDUGQZVWHUJQZUKQZUIZDUL
        QABCDUCVWEVWQVXACJAUACVWPRVWQAVWGCTZUMZVWLVWOACRVWGVWKAVWKUOZRVWKVGZCRV
        WKVGZACRFVGZCRUPZVWIUQTZVXOIJAVWIUCHURQZTZVXSAVWHVXTTVYAAUEHURQZVXTVWHU
        EUCUSUNZTVYBVXTUPUEUQVYCUTUUDUUEUEUCHUUFVAZAGUEHUUGQTZVWHVYBTZOUEHGUUHV
        BZVCVWHHVDVBZVWIHVEVBZCFVWIVHVFAVXNCRVWKAVXNCAVXNFUOZCARRSUUIZTZFSRVIQT
        ZVXSVXNVYJUPVYLARSVJUUJZVKZASVLTZRVLTZCSFVGZVXRVYMVYPAVSVKVYQAVJVKAVXQR
        SUPZVYRIVMCRSFVNVOZJSRCFVLVLUUKUULZVYIRFVWIVPVFAVXQVYJCVTICRFUUMVBZVQAC
        HVWJUNUOZVXNKAVYLVYMVYAWUCVXNUPVYOWUAVYHRFVWIHVRVFWAWBWCWDZWJZAVXLVWGRT
        ZVWORTACRVWGJWEZAWUFUMZVWGVWNRWKZUNZVWORWUFWUJVWOVTAVWGRVWNUUNWFARRVWGW
        UIAVWNRUUOUNZTZRRWUIVGARWGUUPUNTZEWUKTZVXSWULWUMAWUMWGRUUQQUURTUUSUUTVK
        ZAWUNEUVAUNHUVBUVCACDRREUBFHVYOVYTJAHLWHADCWUCMKUVDZNWUOACRDJMWIZAUBUDZ
        VXTTZUMZDWURVWJUNZUNWURUVFUNZWUTWVAUOZRDWVAWUTVXQVXRWURUQTZWVCRWVAVGAVX
        QWUSIWLAVXRWUSJWLWUSWVDAWURHVEWFZCFWURVHVFWUTWUCWVCDWUTVYLVYMWUSWUCWVCU
        PVYLWUTVYNVKAVYMWUSWUAWLAWUSWTRFWURHVRVFADWUCTWUSWUPWLWIWMWUTWVDWVBWNTW
        VEWURUVEVBUVGUVHUVQZVYIREVWIWOVFZVWNUVIVBWJWPZWQZWRVWQWSZXAAUACVWTRVXAV
        XMVWSVWHVXMVWGDWUGADRTZVXLWUQWLWRVXMGUEAGUQTZVXLAGAGUEUSUNZWNAVYEGWVMTO
        GUEHUVJVBUVKUVLZWHZWLUEUQTZVXMUTVKXBXCVXAWSZXAACUVMXDUVNUNZTZCWVRUVOUNU
        NZCVTZAWVTCAWVRUVPTZVXRWVTCUPXEJCWVRRXFUVRXGACRVWKXJQZUOZWVTAHGUGQZVWJU
        NZUOZWWDCAWWFWWCAVWIUEUFQZVWJUNZWWFWWCAWWHWWEVWJAHGUEAHLXKAGWVNXKZUESTZ
        AXHVKZUVSZXIAVYSVYMVXSWWIWWCVTVYSAVMVKZWUAVYIRFVWIXLVFXMZXNAWWGCAWWGVYJ
        CAVYLVYMWWEUQTZWWGVYJUPVYOWUAAWWEAVYEWWEWNTOGUEHUVTVBWHZRFWWEVPVFWUBVQA
        CWUCWWGKAVYLVYMWWEVXTTZWUCWWGUPVYOWUAAGVXTTWWRAVYBVXTGVYDAVYEGVYBTOGUEH
        UWAVBVCGHVDVBRFWWEHVRVFWAWBZXMZACRVWKWVRWGUWBUNZWWNAVXPVYSCSVWKVGZWUDVM
        CRSVWKVNVOZJWXAWXAWSZUWCZWXDUWGWAWBAWWBVXRWVSWWAUUAXEJCWVRRXFUWDXGUWEZM
        VWEWSACVWERVWQXJQZUOZCVWDUWHZAWXHUACVWGWWFUNZVWGWWEVWMUNZUNZUGQZUIZUOCA
        WXGWXNAUAVWLWXJVWOWXLRSVLCVYOVXMVWLWUEYAACSVWGWWFAWWGSWWFVGZCSWWFVGAVYL
        VYMWWPWXOVYOWUAWWQRFWWEUWFVFAWWGCSWWFWWSWCWDZWJAWWFWWCUACWXJUIRUACVWLUI
        ZXJQWWOAUACRWWFAWWGRWWFVGZCRWWFVGAVXQVXRWWPWXRIJWWQCFWWEVHVFAWWGCRWWFWW
        SWCWDXOAVWKWXQRXJAUACRVWKWUDXOZXPXQVXMVWOWVIYAWXLVLTVXMVWGWXKUWIVKAUAVW
        OWXLRWVRWXASRCVYOWUHVWOWVHYAWUFAVWGSTZWXLSTVWGUWJZASSVWGWXKAWXKWUKTZSSW
        XKVGAWUMWUNWWPWYBWUOWVFWWQREWWEWOVFRWXKXRVBZWJZXSAUAVWOWXLRWXASSRWXDVYO
        WXASXTUNTZSWXATAWXAWXDUWKZSWXAUWLUWMZAVYSRSUWRRVTWWNRSUWNUWOZASSVWGVWNA
        WULSSVWNVGWVGRVWNXRVBZWJWYDAWXKSVWNXJQZUASWXLUISUASVWOUIZXJQAWWHVWMUNZW
        XKWYJAWWHWWEVWMWWMXIASSUPZESSVIQZTVXSWYLWYJVTWYMASUWPZVKZASSUWQQZWYNESS
        UWSASSEVGZEWYQTAWUNWYRWVFREXRVBSSEVSVSUWTUXAVCVYISEVWIXLVFXMAUASSWXKWYC
        XOAVWNWYKSXJAUASSVWNWYIXOXPXQYBJWXEWXDWXFYCUXBZXNUACWXMWXNWXJWXLUGYDWXN
        WSZUXCYEUXDACVWERVXAXJQZUOZWXIAXUBUACVWHVWSGUJQZYFQZUIZUOCAXUAXUEAUAVWT
        XUDRWVRWXASRCVYOWUFAWXTVWTSTZWYAAWXTUMZVWSVWHXUGVWGDAWXTWTZXUGDAWVKWXTW
        UQWLYAZYGZXUGGUEAWVLWXTWVOWLZWVPXUGUTVKXBYHZXSWUFAWXTXUDSTWYAXUGVWHXUCX
        UGGUEAGSTZWXTWWJWLWWKXUGXHVKZUXEXUGVWSGXUJXUKYHZUXFZXSAUAVWTXUDRWXASSRW
        XDVYOWYGWYHXULXUPASUASVWTUIXJQUASXUDUEYFQZUIUASXUDUIAUABVWSUEVWFVWHUJQZ
        VWHVWFGUJQZYFQZSSVWTXUDSVLSSSVYKTARSVSUXHVKZXVAXUJXUNAVWFSTZUMZVWFVWHAX
        VBWTAVWHUQTXVBAVWHAVYFVWHWNTZVYGVWHHUXGVBZWHWLYHXUTVLTXVCVWHXUSYFYDVKAS
        UASVWSUIXJQUASUEUCUGQZUIUASUEUIAUAVWGUEDUCSSSSXVAXUHXUNAUASXVAUXIXUIUCS
        TZXUGUXJVKAUADSXVAADWUQYAZUXKUXBUASXVFUEUEXHUXLUXMYEASBSXURUIXJQZBSVWHV
        WFVWHUEUGQZUJQZYFQZUIZBSXUTUIAXVDXVIXVMVTXVEBVWHUXNVBABSXVLXUTAXVKXUSVW
        HYFAXVJGVWFUJAGUEWWJWWLUXRXPXPUXOYIVWFVWSVWHUJYKVWFVWSVTXUSXUCVWHYFVWFV
        WSGUJYKXPUXPAUASXUQXUDXUGXUDXUPUXQYJYIYBJWXEWXDWXFYCZXNUACXUDXUEVWHXUCY
        FYDZXUEWSZUXCYEZUXDADVWKUNZDVWNUNZUGQZUCVWQDULQAXVTXVRXVRUGQUCAXVSXVRXV
        RUGACDREFVWIHVYOVYTJVYHWUPNUXSXPAXVRACSDVWKWXCMWMUXTYIAUACDSVWPXVTAUAVW
        LVWOUGWXACWXDUGWXAWXAUYAQZWXAUYBQZTAWXAWXDUYCVKAVWKWXQCSYLQZWXSAVYSWXBV
        XRWWDCVTVWKXWCTWWNWXCJWWTCRVWKUYDUYEWPAUAVWGVWNCAWULVWNSSYLQTWVGRVWNUYH
        VBACSUPZWYMUACVWGUIXWCTACRSJVMUYIZWYOUACSUYFVOUYGUYJMVWGDVTZVWLXVRVWOXV
        SUGVWGDVWKYMVWGDVWNYMYNYOWPADDUGQZVWHUJQZUCVXADULQAXWHUCVWHUJQUCAXWGUCV
        WHUJADXVHUXTYPAVWHXVEUYKYIAUACDSVWTXWHAVYSCSVXAVGVXRXUBCVTVXAXWCTWWNAUA
        CVWTSVXAAVXLWXTXUFACSVWGXWEWEXULWQWVQXAJXVQCRVXAUYDUYEMXWFVWSXWGVWHUJVW
        GDDUGYKYPYOWPAUCVWTVTZUAVWEUYLZUCVXAVWEYQZTZAXWIUAVWEAVWGVWETZUMZUCVWTX
        WNVWTUCXWNVWSVWHXWNVWGDAVWESVWGACSVWDXWEUYMWEZADSTXWMXVHWLZYGZXWNVWGDXW
        OXWPXWMVWGDUYRAVWGCDUYNWFUYOZXWNVWHAXVDXWMXVEWLZUYPYRUYQUYSUYTXWLUCVXAV
        WEWKZXDZTXWJXWKXXAUCVXAVWEVUAVUBUAVWEVWTUCXWTVWECUPZXWTUAVWEVWTUIVTWXIU
        ACVWEVWTYSVAVWSVWHUJYDVUCVUHVUDAUCXUAVWEYQZTZUCXUDVTZUAVWEUYLZAXXEUAVWE
        XWNUCXUDXWNXUDUCXWNVWHXUCXWNGUEAXUMXWMWWJWLWWKXWNXHVKUXEAXWMWXTXUCSTXWO
        XUOWQXWNVWHXWSVUEXWNVWSGXWQXWRXWNGAGWNTXWMWVNWLUYPYRVUFUYQUYSUYTAXXDUCX
        UEVWEWKZXDZTXXFAXXCXXHUCAXXCXUEVWEYQXXHAXUAXUEVWEXVNVUGXUEVWEVUAYEVUIUA
        VWEXUDUCXXGXXBXXGUAVWEXUDUIVTWXIUACVWEXUDYSVAXVOVUCVUJVUKAUCUEVWHUKQZYF
        QBVWEVWFWWFUNZVWFWXKUNZUGQZVXHGUJQZUKQZXXIYFQZUIZDULQUCBVWEVWFWXGUNZVWF
        XUAUNZUKQZUIZDULQABVWEDUCXXIXXNXXIYFXWAWXASSAVWFVWETZUMZXXLXXMXYBXXJXXK
        XYAAVWFCTZXXJSTVWFCVWDVULZACSVWFWWFWXPWJXSAXYAXVBXXKSTXYBVWFAVWERVWFACR
        VWDJUYMWEZYAZASSVWFWXKWYCWJWQYGZXYBXXMXYBVXHGXYBVWFDXYEAWVKXYAWUQWLZWRA
        WVLXYAWVOWLZXCYAZXYBVXHGXYBVWFDXYFXYBDXYHYAZYGXYBVWFDXYFXYKXYAVWFDUYRAV
        WFCDUYNWFUYOXYBGXYIVUMYRZVUNZAXXISTZXYAAXXIAVWHXVEVUOZYAZWLWYPWYPWXDXWA
        SSVUPZVUQQZXWAXWAXYQXTUNZTZXYRXWAVTWYEWYEXYTWYFWYFWXAWXASSVUSVURZXWAXYS
        XYQXYQXWAYUAVUTZVVAVAVVBPABCXXIUIZDULQZBVWEXXIUIZDULQZXXIYUDYUCVWEWKZDU
        LQYUFDVWEYUCVVCYUGYUEDULXXBYUGYUEVTWXIBCVWEXXIYSVAVVDVVIABCDRXXIXXIAXXI
        RTXWDVYSYUCCRYLQTXYOXWEWWNBXXICRVVEVFMVWFDVTXXIVVFYOVCAYFXWBTUCXXIVVGZX
        YQTZYFYUHXWAWXAVVHQUNTWXAWXDVVRAXVGXYNYUIUXJXYPUCXXISSVVJXGYUHYFXWAWXAX
        YQYUBVVKXGVVLAXXIXYPVVMAXXPXXTDULABVWEXXOXXSXYBXXSXXLXXMVWHYFQZUKQXXNVW
        HUKQXXOXYBXXQXXLXXRYUJUKAXYAXXQVWFWXNUNZXXLAVWFWXGWXNWYSVVNXYAXYCYUKXXL
        VTXYDUAVWFWXMXXLCWXNVWGVWFVTZWXJXXJWXLXXKUGVWGVWFWWFYMVWGVWFWXKYMYNWYTX
        XJXXKUGYDYTVBVVOXYBXXRVWHXXMYFQZYUJAXYAXXRVWFXUEUNZYUMAVWFXUAXUEXVNVVNX
        YAXYCYUNYUMVTXYDUAVWFXUDYUMCXUEYULXUCXXMVWHYFYULVWSVXHGUJVWGVWFDUGYKZYP
        XPXVPVWHXXMYFYDYTVBVVOXYBVWHXXMXYBVWHAXVDXYAXVEWLZXKZXYJVVPYIYNXYBXXLXX
        MVWHXYGXYJYUQXYLXYBVWHYUPVUEZVVQXYBXXNVWHXYMYUQYURVVSVVTYJYPVWAVWBAVXDV
        XKDULABVWEVXCVXJXYBVWRVXGVXBVXIUKXYBXYCVWRVXGVTXYAXYCAXYDWFZUAVWFVWPVXG
        CVWQYULVWLVXEVWOVXFUGVWGVWFVWKYMVWGVWFVWNYMYNWVJVXEVXFUGYDYTVBXYBXYCVXB
        VXIVTYUSUAVWFVWTVXICVXAYULVWSVXHVWHUJYUOYPWVQVXHVWHUJYDYTVBYNYJYPVWC $.
    $}

    taylth.r $e |- R = ( x e. ( A \ { B } ) |->
      ( ( ( F ` x ) - ( T ` x ) ) / ( ( x - B ) ^ N ) ) ) $.
    $( Taylor's theorem.  The Taylor polynomial of a ` N ` -times
       differentiable function is such that the error term goes to zero faster
       than ` ( x - B ) ^ N ` .  (Contributed by Mario Carneiro,
       1-Jan-2017.) $)
    taylth $p |- ( ph -> 0 e. ( R limCC B ) ) $=
      ( cr cc co cmin cfv vy vm cpr wcel prid1 a1i wf wss ax-resscn fss sylancl
      reex cv c1 cfzo cc0 csn cdif cdvn cexp cdiv cmpt climc wa adantr cdm wceq
      cn simprl simprr fveq2 oveq12d oveq1 oveq1d cbvmptv taylthlem2 taylthlem1
      oveq1i syl6eleq ) ABUACDEPFUBGHPPQUCUDAPQULUEUFACPGUGZPQUHCQGUGIUICPQGUJU
      KJKLMNOAUBUMZUNHUORUDZUPUACDUQURZUAUMZHWASRZPGUSRZTZTZWDWEQFUSRTZTZSRZWDD
      SRZWAUTRZVARZVBZDVCRZUDZVDZVDZBCDFGWAHAVTWRIVEACPUHWRJVEAHWFTVFCVGWRKVEAH
      VHUDWRLVEADCUDWRMVENAWBWQVIWSUPWPBWCBUMZWGTZWTWITZSRZWTDSRZWAUTRZVARZVBZD
      VCRAWBWQVJWOXGDVCUABWCWNXFWDWTVGZWKXCWMXEVAXHWHXAWJXBSWDWTWGVKWDWTWIVKVLX
      HWLXDWAUTWDWTDSVMVNVLVOVRVSVPVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                               Uniform convergence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ~~>u $.

  $( Extend class notation to include the uniform convergence predicate. $)
  culm $a class ~~>u $.

  ${
    $d f j k n s x y z S $.
    $( Define the uniform convergence of a sequence of functions.  Here
       ` F ( ~~>u `` S ) G ` if ` F ` is a sequence of functions
       ` F ( n ) , n e. NN ` defined on ` S ` and ` G ` is a function on
       ` S ` , and for every ` 0 < x ` there is a ` j ` such that the functions
       ` F ( k ) ` for ` j <_ k ` are all uniformly within ` x ` of ` G ` on
       the domain ` S ` .  Compare with ~ df-clim .  (Contributed by Mario
       Carneiro, 26-Feb-2015.) $)
    df-ulm $a |- ~~>u = ( s e. _V |-> { <. f , y >. | E. n e. ZZ
      ( f : ( ZZ>= ` n ) --> ( CC ^m s ) /\ y : s --> CC /\ A. x e. RR+
        E. j e. ( ZZ>= ` n ) A. k e. ( ZZ>= ` j ) A. z e. s
        ( abs ` ( ( ( f ` k ) ` z ) - ( y ` z ) ) ) < x ) } ) $.

    $( The uniform limit relation is a relation.  (Contributed by Mario
       Carneiro, 26-Feb-2015.) $)
    ulmrel $p |- Rel ( ~~>u ` S ) $=
      ( vn vs vf vy vz vk vx vj cv cuz cfv cc cmap co wf cmin cabs wral wrex cz
      clt wbr crp w3a cvv culm df-ulm relmptopab ) BJKLZMCJZNODJZPUKMEJZPFJZGJU
      LLLUNUMLQORLHJUBUCFUKSGIJKLSIUJTHUDSUEBUATCDEUFAUGHEFDIGBCUHUI $.
  $}

  $( Closure of the base set in a uniform limit.  (Contributed by Mario
     Carneiro, 26-Feb-2015.) $)
  ulmscl $p |- ( F ( ~~>u ` S ) G -> S e. _V ) $=
    ( culm cfv wbr cop wcel cvv df-br elfvex sylbi ) BCADEZFBCGZMHAIHBCMJNADKL
    $.

  ${
    $d f j k n x y z F $.  $d f j k n x y z G $.  $d f j k n s x y z S $.
    $d f n y V $.
    $( Express the predicate:  The sequence of functions ` F ` converges
       uniformly to ` G ` on ` S ` .  (Contributed by Mario Carneiro,
       26-Feb-2015.) $)
    ulmval $p |- ( S e. V -> ( F ( ~~>u ` S ) G <-> E. n e. ZZ
      ( F : ( ZZ>= ` n ) --> ( CC ^m S ) /\ G : S --> CC /\ A. x e. RR+
        E. j e. ( ZZ>= ` n ) A. k e. ( ZZ>= ` j ) A. z e. S
        ( abs ` ( ( ( F ` k ) ` z ) - ( G ` z ) ) ) < x ) ) ) $=
      ( vf vy wcel cvv wa cfv cv cc wf wral cz vs culm wbr cuz cmap co cmin clt
      cabs wrex crp w3a wi wrel ulmrel brrelex12 mpan a1i 3simpa fvex fex mpan2
      expcom anim12d syl5 rexlimdvw wb copab wceq elex cpm cxp wss simpr1 uzssz
      ovex zex elpm2r mpanl12 sylancl simpr2 simpl elmapg sylancr mpbird jca ex
      cnex ssopab2dv df-xp syl6sseqr xpex ssex oveq2 feq3 feq2 raleq rexralbidv
      syl ralbidv 3anbi123d rexbidv opabbidv df-ulm fvmptg syl2anc breqd fveq1d
      feq1d simpr oveq12d fveq2d breq1d eqid brabga sylan9bb pm5.21ndd ) CILZGM
      LZHMLZNZGHCUBOZUCZFPZUDOZQCUEUFZGRZCQHRZBPZEPZGOZOZYIHOZUGUFZUIOZAPZUHUCZ
      BCSZEDPUDOZSDYEUJZAUKSZULZFTUJZYCYAUMXRYBUNYCYACUOGHYBUPUQURXRUUBYAFTUUBY
      GYHNXRYAYGYHUUAUSXRYGXSYHXTYGXSUMXRYGYEMLXSYDUDUTYEYFMGVAVBURYHXRXTCQIHVA
      VCVDVEVFXRYAYCUUCVGXRYCGHYEYFJPZRZCQKPZRZYIYJUUDOZOZYIUUFOZUGUFZUIOZYPUHU
      CZBCSZEYSSDYEUJZAUKSZULZFTUJZJKVHZUCYAUUCXRYBUUSGHXRCMLUUSMLZYBUUSVICIVJX
      RUUSYFTVKUFZYFVLZVMUUTXRUUSUUDUVALZUUFYFLZNZJKVHUVBXRUURUVEJKXRUUQUVEFTXR
      UUQUVEXRUUQNZUVCUVDUVFUUEYETVMZUVCXRUUEUUGUUPVNYDVOYFMLTMLUUEUVGNUVCQCUEV
      PZVQYFTYEUUDMMVRVSVTUVFUVDUUGXRUUEUUGUUPWAUVFQMLXRUVDUUGVGWHXRUUQWBQCUUFM
      IWCWDWEWFWGVFWIJKUVAYFWJWKUUSUVBUVAYFYFTVKVPUVHWLWMWSUACYEQUAPZUEUFZUUDRZ
      UVIQUUFRZUUMBUVISZEYSSDYEUJZAUKSZULZFTUJZJKVHUUSMMUBUVICVIZUVQUURJKUVRUVP
      UUQFTUVRUVKUUEUVLUUGUVOUUPUVRUVJYFVIUVKUUEVGUVICQUEWNUVJYFYEUUDWOWSUVICQU
      UFWPUVRUVNUUOAUKUVRUVMUUNDEYEYSUUMBUVICWQWRWTXAXBXCAKBJDEFUAXDXEXFXGUURUU
      CJKGHUUSMMUUDGVIZUUFHVIZNZUUQUUBFTUWAUUEYGUUGYHUUPUUAUWAYEYFUUDGUVSUVTWBZ
      XIUWACQUUFHUVSUVTXJZXIUWAUUOYTAUKUWAUUNYRDEYEYSUWAUUMYQBCUWAUULYOYPUHUWAU
      UKYNUIUWAUUIYLUUJYMUGUWAYIUUHYKUWAYJUUDGUWBXHXHUWAYIUUFHUWCXHXKXLXMWTWRWT
      XAXBUUSXNXOXPWGXQ $.
  $}

  ${
    $d j k n x z F $.  $d j k n x z G $.  $d j k n x z S $.  $d n V $.
    $( Closure of a uniform limit of functions.  (Contributed by Mario
       Carneiro, 26-Feb-2015.) $)
    ulmcl $p |- ( F ( ~~>u ` S ) G -> G : S --> CC ) $=
      ( vn vz vk vx vj cfv wbr cv cuz cc co wf wral wrex cz cvv syl clt crp w3a
      culm cmap cmin cabs wcel wb ulmscl ulmval ibi simp2 rexlimivw ) BCAUDIJZD
      KLIZMAUENBOZAMCOZEKZFKBIIUSCIUFNUGIGKUAJEAPFHKLIPHUPQGUBPZUCZDRQZURUOVBUO
      ASUHUOVBUIABCUJGEAHFDBCSUKTULVAURDRUQURUTUMUNT $.

    $( Closure of a uniform limit of functions.  (Contributed by Mario
       Carneiro, 26-Feb-2015.) $)
    ulmf $p |- ( F ( ~~>u ` S ) G ->
      E. n e. ZZ F : ( ZZ>= ` n ) --> ( CC ^m S ) ) $=
      ( vz vk vx vj cfv wbr cv cuz cc co wf wral wrex cz cvv syl culm cmap cmin
      cabs clt crp w3a wcel wb ulmscl ulmval ibi simp1 reximi ) CDAUAIJZBKLIZMA
      UBNCOZAMDOZEKZFKCIIUSDIUCNUDIGKUEJEAPFHKLIPHUPQGUFPZUGZBRQZUQBRQUOVBUOASU
      HUOVBUIACDUJGEAHFBCDSUKTULVAUQBRUQURUTUMUNT $.

    $( Closure of a uniform limit of functions.  (Contributed by Mario
       Carneiro, 26-Feb-2015.) $)
    ulmpm $p |- ( F ( ~~>u ` S ) G -> F e. ( ( CC ^m S ) ^pm ZZ ) ) $=
      ( vn culm cfv wbr cv cuz cc cmap co wf cz wrex cpm wcel ulmf wss cvv ovex
      uzssz wa zex elpm2r mpanl12 mpan2 rexlimivw syl ) BCAEFGDHZIFZJAKLZBMZDNO
      BULNPLQZADBCRUMUNDNUMUKNSZUNUJUBULTQNTQUMUOUCUNJAKUAUDULNUKBTTUEUFUGUHUI
      $.

    $( Closure of a uniform limit of functions.  (Contributed by Mario
       Carneiro, 18-Mar-2015.) $)
    ulmf2 $p |- ( ( F Fn Z /\ F ( ~~>u ` S ) G ) -> F : Z --> ( CC ^m S ) ) $=
      ( wfn culm cfv wbr wa cdm cc cmap co wf cz cpm wcel ulmpm wss ovex adantl
      zex elpm2 simplbi syl wceq fndm adantr feq2d mpbid ) BDEZBCAFGHZIZBJZKALM
      ZBNZDUOBNULUPUKULBUOOPMQZUPABCRUQUPUNOSUOOBKALTUBUCUDUEUAUMUNDUOBUKUNDUFU
      LDBUGUHUIUJ $.
  $}

  ${
    $d j k n x z F $.  $d j k n x z G $.  $d j k n x z M $.  $d j k n x z ph $.
    $d j k n x A $.  $d n x B $.  $d j k x z C $.  $d j k n x z S $.  $d n V $.
    $d j n x Z $.
    ulm2.z $e |- Z = ( ZZ>= ` M ) $.
    ulm2.m $e |- ( ph -> M e. ZZ ) $.
    ulm2.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    ulm2.b $e |- ( ( ph /\ ( k e. Z /\ z e. S ) ) -> ( ( F ` k ) ` z ) = B ) $.
    ulm2.a $e |- ( ( ph /\ z e. S ) -> ( G ` z ) = A ) $.
    ${
      ulm2.g $e |- ( ph -> G : S --> CC ) $.
      ulm2.s $e |- ( ph -> S e. V ) $.
      $( Simplify ~ ulmval when ` F ` and ` G ` are known to be functions.
         (Contributed by Mario Carneiro, 26-Feb-2015.) $)
      ulm2 $p |- ( ph -> ( F ( ~~>u ` S ) G <-> A. x e. RR+ E. j e. Z
        A. k e. ( ZZ>= ` j ) A. z e. S ( abs ` ( B - A ) ) < x ) ) $=
        ( vn culm cfv wbr cv cuz cc cmap co wf cmin cabs clt wral wrex crp wceq
        w3a cz wa wcel ulmval syl 3anan12 cdm fdm sylan9req syl5eqr adantr uz11
        wb mpbid eqcomd fveq2 syl6eqr biimparc impbida anbi1d biantrurd simp-4l
        feq2d sylan simpr uzid syl6eleqr eqeltrd uztrn2 syl12anc oveq12d fveq2d
        sylancom breq1d ralbidva rexbidva ralbidv 3bitr3d syl5bb rexbidv 3bitrd
        pm5.32da rexeqdv ceqsrexv ) AIJFUBUCUDZUAUEZUFUCZUGFUHUIZIUJZFUGJUJZCUE
        ZHUEZIUCUCZXIJUCZUKUIZULUCZBUEZUMUDZCFUNZHGUEZUFUCZUNZGXEUOZBUPUNZURZUA
        USUOZXDKUQZEDUKUIZULUCZXOUMUDZCFUNZHXSUNZGXEUOZBUPUNZUTZUAUSUOZYJGMUOZB
        UPUNZAFLVAXCYDVKTBCFGHUAIJLVBVCAYCYMUAUSYCXHXGYBUTZUTZAYMXGXHYBVDAYQYEY
        BUTYRYMAXGYEYBAXGYEAXGUTZKXDYSKUFUCZXEUQZKXDUQZYSYTMXENAXGMIVEZXEAMXFIU
        JZUUCMUQPMXFIVFVCXEXFIVFVGVHYSKUSVAZUUAUUBVKAUUEXGOVIKXDVJVCVLVMAUUDYEX
        GPYEXGUUDYEXEMXFIYEXEYTMXDKUFVNNVOZWAVPWBVQVRAXHYQSVSAYEYBYLAYEUTZYAYKB
        UPUUGXTYJGXEUUGXRXEVAZUTZXQYIHXSUUIXJXSVAZUTZXPYHCFUUKXIFVAZUTZXNYGXOUM
        UUMXMYFULUUMXKEXLDUKUUMAXJMVAZUULXKEUQAYEUUHUUJUULVTZUUKUUNUULUUIXRMVAZ
        UUJUUNUUGXDMVAUUHUUPUUGXDKMAYEWCAKMVAYEAKYTMAUUEKYTVAOKWDVCNWEVIWFKXRXD
        MNWGWBKXJXRMNWGWBVIUUKUULWCQWHUUKUULAXLDUQUUORWKWIWJWLWMWMWNWOWTWPWQWRA
        UUEYNYPVKOYLYPUAKUSYEYKYOBUPYEYJGXEMUUFXAWOXBVCWS $.
    $}

    ulmi.u $e |- ( ph -> F ( ~~>u ` S ) G ) $.
    ulmi.c $e |- ( ph -> C e. RR+ ) $.
    $( The uniform limit property.  (Contributed by Mario Carneiro,
       27-Feb-2015.) $)
    ulmi $p |- ( ph ->
      E. j e. Z A. k e. ( ZZ>= ` j ) A. z e. S ( abs ` ( B - A ) ) < C ) $=
      ( wral vx crp wcel cmin co cabs cfv cv clt wbr cuz wrex culm cvv cc ulmcl
      wf syl ulmscl ulm2 mpbid wceq breq2 ralbidv rexralbidv rspcv sylc ) AEUBU
      CDCUDUEUFUGZUAUHZUIUJZBFTZHGUHUKUGZTGLULZUAUBTZVHEUIUJZBFTZHVLTGLULZSAIJF
      UMUGUJZVNRAUABCDFGHIJKUNLMNOPQAVRFUOJUQRFIJUPURAVRFUNUCRFIJUSURUTVAVMVQUA
      EUBVIEVBZVKVPGHLVLVSVJVOBFVIEVHUIVCVDVEVFVG $.
  $}

  ${
    $d j k x z A $.  $d j k x z F $.  $d j k x z G $.  $d j k x z ph $.
    $d j k x H $.  $d j k x z M $.  $d j k x z S $.  $d j k x Z $.
    ulmclm.z $e |- Z = ( ZZ>= ` M ) $.
    ulmclm.m $e |- ( ph -> M e. ZZ ) $.
    ulmclm.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    ulmclm.a $e |- ( ph -> A e. S ) $.
    ulmclm.h $e |- ( ph -> H e. W ) $.
    ulmclm.e $e |- ( ( ph /\ k e. Z ) -> ( ( F ` k ) ` A ) = ( H ` k ) ) $.
    ulmclm.u $e |- ( ph -> F ( ~~>u ` S ) G ) $.
    $( A uniform limit of functions converges pointwise.  (Contributed by Mario
       Carneiro, 27-Feb-2015.) $)
    ulmclm $p |- ( ph -> H ~~> ( G ` A ) ) $=
      ( vx vj cfv vz culm wbr cli cv cmin co cabs clt wral cuz wrex crp wcel wi
      wceq fveq2 oveq12d fveq2d breq1d rspcv syl ralimdv reximdv wa eqidd cc wf
      cvv ulmcl ulmscl ulm2 eqcomd ffvelrnd cmap ffvelrnda elmapi adantr clim2c
      3imtr4d mpd ) AEFCUBTUCZGBFTZUDUCZQAUAUEZDUEZETZTZWEFTZUFUGZUHTZRUEZUIUCZ
      UACUJZDSUEUKTZUJZSJULZRUMUJBWGTZWCUFUGZUHTZWLUIUCZDWOUJZSJULZRUMUJWBWDAWQ
      XCRUMAWPXBSJAWNXADWOABCUNZWNXAUONWMXAUABCWEBUPZWKWTWLUIXEWJWSUHXEWHWRWIWC
      UFWEBWGUQWEBFUQURUSUTVAVBVCVDVCARUAWIWHCSDEFHVIJKLMAWFJUNZWECUNZVEVEWHVFA
      XGVEWIVFAWBCVGFVHQCEFVJVBZAWBCVIUNQCEFVKVBVLARWCWRSDGHIJKLOAXFVEZWRWFGTPV
      MACVGBFXHNVNXICVGBWGXIWGVGCVOUGZUNCVGWGVHAJXJWFEMVPWGVGCVQVBAXDXFNVRVNVSV
      TWA $.
  $}

  ${
    $d j k r z F $.  $d j k r z G $.  $d j k r z M $.  $d j k r z ph $.
    $d j k r z N $.  $d j k r z S $.  $d j k r z W $.  $d j k r Z $.
    ulmres.z $e |- Z = ( ZZ>= ` M ) $.
    ulmres.w $e |- W = ( ZZ>= ` N ) $.
    ulmres.m $e |- ( ph -> N e. Z ) $.
    ulmres.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    $( A sequence of functions converges iff the tail of the sequence converges
       (for any finite cutoff).  (Contributed by Mario Carneiro,
       24-Mar-2015.) $)
    ulmres $p |- ( ph ->
      ( F ( ~~>u ` S ) G <-> ( F |` W ) ( ~~>u ` S ) G ) ) $=
      ( vz vk vr vj wcel wa cfv syl cvv cc wf culm wbr cres wi ulmscl ulmcl jca
      a1i wb cv cmin co cabs clt wral cuz crp cz syl6eleq adantr eluzel2 rexuz3
      wrex eluzelz bitr4d ralbidv cmap eqidd simprr simprl ulm2 wss uzss fssres
      3sstr4g syl2anc wceq fvres ad2antrl fveq1d 3bitr4d ex pm5.21ndd ) ABUAQZB
      UBDUCZRZCDBUDSZUEZCGUFZDWJUEZWKWIUGAWKWGWHBCDUHBCDUIUJUKWMWIUGAWMWGWHBWLD
      UHBWLDUIUJUKAWIWKWMULAWIRZMUMZNUMZCSZSZWODSZUNUOUPSOUMUQUEMBURZNPUMUSSURZ
      PHVFZOUTURXAPGVFZOUTURWKWMWNXBXCOUTWNXBXAPVAVFZXCWNEVAQZXBXDULWNFEUSSZQZX
      EAXGWIAFHXFKIVBVCZEFVDTZWTPNEHIVETWNFVAQZXCXDULWNXGXJXHEFVGTZWTPNFGJVETVH
      VIWNOMWSWRBPNCDEUAHIXIAHUBBVJUOZCUCZWILVCZWNWPHQWOBQZRRWRVKWNXORWSVKZAWGW
      HVLZAWGWHVMZVNWNOMWSWRBPNWLDFUAGJXKWNXMGHVOGXLWLUCXNWNFUSSZXFGHWNXGXSXFVO
      XHEFVPTJIVRHXLGCVQVSWNWPGQZXORRWOWPWLSZWQXTYAWQVTWNXOWPGCWAWBWCXPXQXRVNWD
      WEWF $.
  $}

  ${
    $d i j k m x z G $.  $d i j k m n x z ph $.  $d i j n x W $.  $d i k m Z $.
    $d i j k m n x z F $.  $d i j k m n x z K $.  $d i j k m n x z S $.
    $d j k m x z H $.  $d i j k m x z M $.
    ulmshft.z $e |- Z = ( ZZ>= ` M ) $.
    ulmshft.w $e |- W = ( ZZ>= ` ( M + K ) ) $.
    ulmshft.m $e |- ( ph -> M e. ZZ ) $.
    ulmshft.k $e |- ( ph -> K e. ZZ ) $.
    ulmshft.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    ulmshft.h $e |- ( ph -> H = ( n e. W |-> ( F ` ( n - K ) ) ) ) $.
    $( Lemma for ~ ulmshft .  (Contributed by Mario Carneiro, 24-Mar-2015.) $)
    ulmshftlem $p |- ( ph -> ( F ( ~~>u ` S ) G -> H ( ~~>u ` S ) G ) ) $=
      ( cfv wa cv wcel vz vk vx vj vm vi culm wbr cmin co cabs clt wral cuz crp
      wrex cz ad2antrr cc cmap eqidd simplr simpr ulmi caddc syl6eleq ad3antrrr
      wf eluzadd syl2anc syl6eleqr wi eluzelz adantr eluzsub syl3anc wceq fveq2
      fveq1d oveq1d fveq2d breq1d ralbidv rspcv ralrimdva raleqdv rspcev ee12an
      syl rexlimdva mpd ralrimiva zaddcld cmpt ffvelrnd eqid fmptd feq1d mpbird
      cvv oveq1 fvex fvmpt ad2antrl eqtrd ulmcl adantl ulmscl ulm2 ex ) ADEBUGQ
      ZUHZFEXKUHZAXLRZXMUASZUBSZGUIUJZDQZQZXOEQZUIUJZUKQZUCSZULUHZUABUMZUBUDSZU
      NQZUMZUDIUPZUCUOUMXNYIUCUOXNYCUOTZRZXOUESZDQZQZXTUIUJZUKQZYCULUHZUABUMZUE
      UFSZUNQZUMZUFJUPYIYKUAXTYNYCBUFUEDEHJKAHUQTZXLYJMURAJUSBUTUJZDVHZXLYJOURY
      KYLJTXOBTZRRYNVAYKUUERXTVAAXLYJVBXNYJVCVDYKUUAYIUFJYKYSJTZRZYSGVEUJZITUUA
      YEUBUUHUNQZUMZYIUUGUUHHGVEUJZUNQZIUUGYSHUNQZTZGUQTZUUHUULTUUGYSJUUMYKUUFV
      CKVFZAUUOXLYJUUFNVGGHYSVIVJLVKUUGUUAYEUBUUIUUGXPUUITZRZXQYTTZUUAYEVLUURYS
      UQTZUUOUUQUUSUUGUUTUUQUUGUUNUUTUUPHYSVMWIVNXNUUOYJUUFUUQAUUOXLNVNVGUUGUUQ
      VCGYSXPVOVPYRYEUEXQYTYLXQVQZYQYDUABUVAYPYBYCULUVAYOYAUKUVAYNXSXTUIUVAXOYM
      XRYLXQDVRVSVTWAWBWCWDWIWEYHUUJUDUUHIYFUUHVQYEUBYGUUIYFUUHUNVRWFWGWHWJWKWL
      XNUCUAXTXSBUDUBFEUUKWTILAUUKUQTXLAHGMNWMVNAIUUCFVHZXLAUVBIUUCCICSZGUIUJZD
      QZWNZVHACIUVEUUCUVFAUVCITZRZJUUCUVDDAUUDUVGOVNUVHUVDUUMJUVHUUBUUOUVCUULTU
      VDUUMTAUUBUVGMVNAUUOUVGNVNUVHUVCIUULAUVGVCLVFGHUVCVOVPKVKWOUVFWPZWQAIUUCF
      UVFPWRWSVNXNXPITZUUERZRZXOXPFQZXRUVLUVMXPUVFQZXRUVLXPFUVFAFUVFVQXLUVKPURV
      SUVJUVNXRVQXNUUECXPUVEXRIUVFUVCXPVQUVDXQDUVCXPGUIXAWAUVIXQDXBXCXDXEVSXNUU
      ERXTVAXLBUSEVHABDEXFXGXLBWTTABDEXHXGXIWSXJ $.

    $( A sequence of functions converges iff the shifted sequence converges.
       (Contributed by Mario Carneiro, 24-Mar-2015.) $)
    ulmshft $p |- ( ph -> ( F ( ~~>u ` S ) G <-> H ( ~~>u ` S ) G ) ) $=
      ( vm cfv co wcel culm wbr ulmshftlem cneg caddc eqid zaddcld znegcld cmap
      cuz cc wf cv cmin cmpt wa adantr simpr syl6eleq eluzsub syl3anc syl6eleqr
      cz ffvelrnd fmptd feq1d mpbird eluzelz zcnd subnegd fveq2d fveq1d eluzadd
      syl wceq syl2anc oveq1 fvmpt pncand eqtrd 3eqtrd mpteq2dva addassd negidd
      fvex cc0 oveq2d addid1d syl6eqr mpteq1d feqmptd 3eqtr4rd impbid ) ADEBUAR
      ZUBFEWNUBABCDEFGHIJKLMNOPUCABQFEDGUDZHGUESZWPWOUESZUJRZILWRUFAHGMNUGAGNUH
      ZAIUKBUISZFULIWTCICUMZGUNSZDRZUOZULACIXCWTXDAXAITZUPZJWTXBDAJWTDULXEOUQXF
      XBHUJRZJXFHVCTZGVCTZXAWPUJRZTXBXGTAXHXEMUQAXIXENUQXFXAIXJAXEURLUSGHXAUTVA
      KVBVDXDUFZVEAIWTFXDPVFVGAQJQUMZWOUNSZFRZUOQJXLDRZUOQWRXNUODAQJXNXOAXLJTZU
      PZXNXLGUESZFRXRXDRZXOXQXMXRFXQXLGXQXLXQXLXGTZXLVCTXQXLJXGAXPURKUSZHXLVHVN
      VIZAGUKTXPAGNVIZUQZVJVKXQXRFXDAFXDVOXPPUQVLXQXSXRGUNSZDRZXOXQXRITXSYFVOXQ
      XRXJIXQXTXIXRXJTYAAXIXPNUQGHXLVMVPLVBCXRXCYFIXDXAXRVOXBYEDXAXRGUNVQVKXKYE
      DWEVRVNXQYEXLDXQXLGYBYDVSVKVTWAWBAQWRJXNAWRXGJAWQHUJAWQHGWOUESZUESHWFUESH
      AHGWOAHMVIZYCAWOWSVIWCAYGWFHUEAGYCWDWGAHYHWHWAVKKWIWJAQJWTDOWKWLUCWM $.
  $}

  ${
    $d j k x z F $.  $d j k x z G $.  $d j k x z M $.  $d j k x z ph $.
    $d j k x z S $.  $d j x Z $.
    ulm0.z $e |- Z = ( ZZ>= ` M ) $.
    ulm0.m $e |- ( ph -> M e. ZZ ) $.
    ulm0.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    ulm0.g $e |- ( ph -> G : S --> CC ) $.
    $( Every function converges uniformly on the empty set.  (Contributed by
       Mario Carneiro, 3-Mar-2015.) $)
    ulm0 $p |- ( ( ph /\ S = (/) ) -> F ( ~~>u ` S ) G ) $=
      ( vz vk vx vj c0 wa cfv cv wral wcel wceq culm wbr cmin cabs clt cuz wrex
      co crp wne cz uzid syl syl6eleqr ne0i adantr ral0 simpr raleqdv ralrimivw
      mpbiri r19.2z syl2anc cvv cc cmap wf eqidd 0ex syl6eqel ulm2 mpbird ) ABO
      UAZPZCDBUBQUCKRZLRZCQQZVPDQZUDUIUEQMRUFUCZKBSZLNRUGQZSZNFUHZMUJSVOWDMUJVO
      FOUKZWCNFSWDAWEVNAEFTWEAEEUGQZFAEULTZEWFTHEUMUNGUOFEUPUNUQVOWCNFVOWALWBVO
      WAVTKOSVTKURVOVTKBOAVNUSZUTVBVAVAWCNFVCVDVAVOMKVSVRBNLCDEVEFGAWGVNHUQAFVF
      BVGUICVHVNIUQVOVQFTVPBTZPPVRVIVOWIPVSVIABVFDVHVNJUQVOBOVEWHVJVKVLVM $.
  $}

  ${
    $d i k n x F $.  $d k n x G $.  $d k n x H $.  $d k n x y z S $.
    $( An sequence of functions uniformly converges to at most one limit.
       (Contributed by Mario Carneiro, 5-Jul-2017.) $)
    ulmuni $p |- ( ( F ( ~~>u ` S ) G /\ F ( ~~>u ` S ) H ) -> G = H ) $=
      ( vx vn vi vk cfv wbr wa cc wf wfn ulmcl cv wcel cz wceq cvv culm ffn syl
      adantr adantl cuz cmap co wrex ulmf ad2antrr cmpt cli eqid simplr simpllr
      simpr fvex mptex fveq2 fveq1d fvmpt eqcomd simp-4l ulmclm simp-4r climuni
      a1i syl2anc ex rexlimdva mpd eqfnfvd ) BCAUAIZJZBDVNJZKZEACDVQALCMZCANVOV
      RVPABCOUDALCUBUCVQALDMZDANVPVSVOABDOUEALDUBUCVQEPZAQZKZFPZUFIZLAUGUHBMZFR
      UIZVTCIZVTDIZSZVOWFVPWAAFBCUJUKWBWEWIFRWBWCRQZKZWEWIWKWEKZGWDVTGPZBIZIZUL
      ZWGUMJWPWHUMJWIWLVTAHBCWPWCTWDWDUNZWBWJWEUOZWKWEUQZVQWAWJWEUPZWPTQWLGWDWO
      WCUFURUSVHZHPZWDQZVTXBBIZIZXBWPIZSWLXCXFXEGXBWOXEWDWPWMXBSVTWNXDWMXBBUTVA
      WPUNVTXDURVBVCUEZVOVPWAWJWEVDVEWLVTAHBDWPWCTWDWQWRWSWTXAXGVOVPWAWJWEVFVEW
      GWHWPVGVIVJVKVLVM $.

    $( Two ways to express that a function has a limit.  (The expression
       ` ( ( ~~>u `` S ) `` F ) ` is sometimes useful as a shorthand for "the
       unique limit of the function ` F ` ").  (Contributed by Mario Carneiro,
       5-Jul-2017.) $)
    ulmdm $p |- ( F e. dom ( ~~>u ` S ) <->
      F ( ~~>u ` S ) ( ( ~~>u ` S ) ` F ) ) $=
      ( vx vy vz culm cfv wfun cdm wcel wbr wb wrel cv wa weq wal ulmrel ulmuni
      wi ax-gen gen2 dffun2 mpbir2an funfvbrb ax-mp ) AFGZHZBUGIJBBUGGUGKLUHUGM
      CNZDNZUGKUIENZUGKODEPTZEQZDQCQARUMCDULEAUIUJUKSUAUBCDEUGUCUDBUGUEUF $.
  $}

  ${
    $d g j k m n p q r v w x y z F $.  $d g j k m n p q r v w x y z ph $.
    $d g j k m n p q r v w x y z S $.  $d g j k m n p q r v w x y z Z $.
    $d j k p q r w z M $.
    ulmcau.z $e |- Z = ( ZZ>= ` M ) $.
    ulmcau.m $e |- ( ph -> M e. ZZ ) $.
    ulmcau.s $e |- ( ph -> S e. V ) $.
    ulmcau.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    $( Lemma for ~ ulmcau and ~ ulmcau2 : show the equivalence of the four- and
       five-quantifier forms of the Cauchy convergence condition.  Compare
       ~ cau3 .  (Contributed by Mario Carneiro, 1-Mar-2015.) $)
    ulmcaulem $p |- ( ph -> ( A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j )
      A. z e. S ( abs ` ( ( ( F ` k ) ` z ) - ( ( F ` j ) ` z ) ) ) < x <->
      A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) A. m e. ( ZZ>= ` k )
      A. z e. S ( abs ` ( ( ( F ` k ) ` z ) - ( ( F ` m ) ` z ) ) ) < x ) ) $=
      ( cfv clt wral wcel cc vw cv cmin co cabs wbr cuz wrex wceq breq2 ralbidv
      crp rexralbidv cbvralv wa c2 cdiv rphalfcl rspcv syl adantl fveq1d oveq1d
      wi fveq2 fveq2d breq1d biimpi wss uzss ad2antlr ssralv r19.26 cmap adantr
      ad3antrrr uztrn2 adantll sylan ffvelrnd elmapi ffvelrnda ad2antrr abssubd
      wf biimpd cr ffvelrn syl2an anassrs rpre abs3lem syl22anc sylan2d syl5bir
      ralimdva expdimp an32s syld impancom com23 mpdi reximdva ralrimdva syl5bi
      ex cz eluzelz eleq2s uzid raleqbidv oveq2d ralbidva syl5bb sylibd ralimdv
      impbid ) ACUBZFUBZHPZPZXREUBZHPZPZUCUDZUEPZBUBZQUFZCDRZFYBUGPZRZEKUHZBULR
      ZYAXRGUBZHPZPZUCUDZUEPZYGQUFZCDRZGXSUGPZRZFYJRZEKUHZBULRZYMYFUAUBZQUFZCDR
      ZFYJREKUHZUAULRZAUUEYLUUIBUAULYGUUFUIZYIUUHEFKYJUUKYHUUGCDYGUUFYFQUJUKUMU
      NAUUJUUDBULAYGULSZUOZUUJYFYGUPUQUDZQUFZCDRZFYJRZEKUHZUUDUULUUJUURVDZAUULU
      UNULSUUSYGURUUIUURUAUUNULUUFUUNUIZUUHUUPEFKYJUUTUUGUUOCDUUFUUNYFQUJUKUMUS
      UTVAUUMUUQUUCEKUUMYBKSZUOZUUQYPYDUCUDZUEPZUUNQUFZCDRZGYJRZUUCUUQUVGUUPUVF
      FGYJXSYNUIZUUOUVECDUVHYFUVDUUNQUVHYEUVCUEUVHYAYPYDUCUVHXRXTYOXSYNHVEVBVCV
      FVGUKUNVHUVBUVGUUQUUCUVBUVGUUQUUCVDUVBUVGUOUUPUUBFYJUVBXSYJSZUVGUUPUUBVDU
      VBUVIUOZUUPUVGUUBUVJUUPUOZUVGUVFGUUARZUUBUVKUUAYJVIZUVGUVLVDUVIUVMUVBUUPY
      BXSVJVKUVFGUUAYJVLUTUVKUVFYTGUUAUVJYNUUASZUUPUVFYTVDUVJUVNUOZUUPUVFYTUUPU
      VFUOUUOUVEUOZCDRUVOYTUUOUVECDVMUVOUVPYSCDUVOXRDSZUOZUVEYDYPUCUDZUEPZUUNQU
      FZUUOYSUVRUVEUWAUVRUVDUVTUUNQUVRYPYDUVODTXRYOUVOYOTDVNUDZSDTYOWEUVOKUWBYN
      HUUMKUWBHWEZUVAUVIUVNAUWCUULOVOZVPUVJXSKSZUVNYNKSUVAUVIUWEUUMIXSYBKLVQZVR
      IYNXSKLVQVSVTYOTDWAUTWBZUVODTXRYCUVOYCUWBSZDTYCWEZUVBUWHUVIUVNUUMKUWBYBHU
      WDWBWCYCTDWAZUTWBZWDVGWFUVRYATSYPTSYDTSYGWGSZUUOUWAUOYSVDUVODTXRXTUVOXTUW
      BSZDTXTWEZUVJUWMUVNUUMUVAUVIUWMUUMUWCUWEUWMUVAUVIUOZUWDUWFKUWBXSHWHZWIWJV
      OXTTDWAZUTWBUWGUWKUVBUWLUVIUVNUVQUULUWLAUVAYGWKVKVPYAYPYDYGWLWMWNWPWOWQWR
      WPWSWTWRWPXFXAXBXCWSXDXEAUUDYLBULAUUCYKEKAUVAUOZUUCUVTYGQUFZCDRZGYJRZYKUW
      RYBYJSZUUCUXAVDUVAUXBAUVAYBXGSZUXBUXCYBIUGPKIYBXHLXIYBXJUTVAUUBUXAFYBYJXS
      YBUIZYTUWTGUUAYJXSYBUGVEUXDYSUWSCDUXDYRUVTYGQUXDYQUVSUEUXDYAYDYPUCUXDXRXT
      YCXSYBHVEVBVCVFVGUKXKUSUTUXAYDYAUCUDZUEPZYGQUFZCDRZFYJRUWRYKUWTUXHGFYJYNX
      SUIZUWSUXGCDUXIUVTUXFYGQUXIUVSUXEUEUXIYPYAYDUCUXIXRYOXTYNXSHVEVBXLVFVGUKU
      NUWRUXHYIFYJUWRUVIUOZUXGYHCDUXJUVQUOZUXFYFYGQUXKYDYAUXJDTXRYCUXJUWHUWIUWR
      UWHUVIAKUWBYBHOWBVOUWJUTWBUXJDTXRXTUXJUWMUWNAUVAUVIUWMAUWCUWEUWMUWOOUWFUW
      PWIWJUWQUTWBWDVGXMXMXNXOXCXPXQ $.

    $( A sequence of functions converges uniformly iff it is uniformly Cauchy,
       which is to say that for every ` 0 < x ` there is a ` j ` such that for
       all ` j <_ k ` the functions ` F ( k ) ` and ` F ( j ) ` are uniformly
       within ` x ` of each other on ` S ` .  This is the four-quantifier
       version, see ~ ulmcau2 for the more conventional five-quantifier
       version.  (Contributed by Mario Carneiro, 1-Mar-2015.) $)
    ulmcau $p |- ( ph -> ( F e. dom ( ~~>u ` S ) <->
      A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) A. z e. S
        ( abs ` ( ( ( F ` k ) ` z ) - ( ( F ` j ) ` z ) ) ) < x ) ) $=
      ( cfv wcel clt wral wa cc vg vy vn vw vq vr vp vm vv culm cv cmin co cabs
      cdm wbr cuz wrex crp wex eldmg c2 cdiv cz ad2antrr cmap wf eqidd rphalfcl
      ibi simplr adantl ulmi wi simpr syl6eleq eluzelz uzid fveq2 fveq1d oveq1d
      weq fveq2d breq1d ralbidv rspcv 4syl r19.26 ffvelrnda adantr elmapi ulmcl
      syl ad4antlr abssubd biimpd cr uztrn2 ffvelrn syl2an anassrs rpre abs3lem
      syl22anc sylan2d ancomsd ralimdva syl5bir expdimp an32s ex com23 reximdva
      mpdd mpd ralrimiva exlimdv syl5 cmpt breq2 rexbidv oveq12d cbvralv syl5bb
      cli wceq raleqbidv cbvrexv rspccva eqid sylan fvex fvmpt cvv fmptd climdm
      ralimdv sylib climcl ffvelrnd wrel ulmrel ulmcaulem biimpa ralcom raleqdv
      2ralbidv syl6bbr eleq2s ad2antlr reximdv adantll ralbidva rexbiia eqeltri
      impcom oveq2d bitri sylibr caucvg mpteq2dv eleq1d climi2 r19.29uz r19.2uz
      mptex ad5antr rexlimdva mpan2d sylan2 ulm2 mpbird releldm sylancr impbid
      a1i ) AGDUJOZUOZPZCUKZFUKZGOZOZUVTEUKZGOZOZULUMZUNOZBUKZQUPZCDRZFUWDUQOZR
      ZEJURZBUSRZUVSGUAUKZUVQUPZUAUTZAUWOUVSUWRUAGUVQUVRVAVJAUWQUWOUAAUWQUWOAUW
      QSZUWNBUSUWSUWIUSPZSZUWCUVTUWPOZULUMZUNOZUWIVBVCUMZQUPZCDRZFUWLRZEJURUWNU
      XACUXBUWCUXEDEFGUWPHJKAHVDPZUWQUWTLVEAJTDVFUMZGVGZUWQUWTNVEZUXAUWAJPZUVTD
      PZSSUWCVHUXAUXNSUXBVHAUWQUWTVKUWTUXEUSPUWSUWIVIVLVMUXAUXHUWMEJUXAUWDJPZSZ
      UXHUWFUXBULUMZUNOZUXEQUPZCDRZUWMUXPUWDHUQOZPUWDVDPUWDUWLPUXHUXTVNUXPUWDJU
      YAUXAUXOVOKVPHUWDVQUWDVRUXGUXTFUWDUWLFEWBZUXFUXSCDUYBUXDUXRUXEQUYBUXCUXQU
      NUYBUWCUWFUXBULUYBUVTUWBUWEUWAUWDGVSVTWAWCWDWEWFWGUXPUXTUXHUWMUXPUXTUXHUW
      MVNUXPUXTSUXGUWKFUWLUXPUWAUWLPZUXTUXGUWKVNUXPUYCSZUXTUXGUWKUXTUXGSUXSUXFS
      ZCDRUYDUWKUXSUXFCDWHUYDUYEUWJCDUYDUXNSZUXFUXSUWJUYFUXSUXBUWFULUMUNOZUXEQU
      PZUXFUWJUYFUXSUYHUYFUXRUYGUXEQUYFUWFUXBUYDDTUVTUWEUYDUWEUXJPZDTUWEVGUXPUY
      IUYCUXAJUXJUWDGUXLWIWJUWETDWKWMWIZUYDDTUVTUWPUWQDTUWPVGAUWTUXOUYCDGUWPWLW
      NWIZWOWDWPUYFUWCTPUWFTPUXBTPUWIWQPZUXFUYHSUWJVNUYDDTUVTUWBUYDUWBUXJPZDTUW
      BVGUXAUXOUYCUYMUXAUXKUXMUYMUXOUYCSZUXLHUWAUWDJKWRZJUXJUWAGWSWTXAUWBTDWKWM
      WIUYJUYKUWTUYLUWSUXOUYCUXNUWIXBWNUWCUWFUXBUWIXCXDXEXFXGXHXIXJXGXKXLXNXMXO
      XPXKXQXRAUWOUVSAUWOSZUVQUUAGUBDUCJUBUKZUCUKZGOZOZXSZYEOZXSZUVQUPZUVSDUUBU
      YPVUDUDUKZUEUKZGOZOZUCJVUEUYSOZXSZYEOZULUMUNOUFUKZQUPZUDDRZUEUGUKZUQOZRZU
      GJURZUFUSRUYPVURUFUSUYPVULUSPZSZVUHVUEUHUKZGOZOZULUMZUNOZVULVBVCUMZQUPZUH
      VUFUQOZRZUDDRZUEVUPRZUGJURZVURUYPUWCUVTVVBOZULUMZUNOZUWIQUPZCDRZUHUWAUQOZ
      RFUWLRZEJURZBUSRZVVFUSPZVVLVUSAUWOVWAABCDEFUHGHIJKLMNUUCUUDVULVIZVVTVVLBV
      VFUSUWIVVFYFZVVTVVOVVFQUPZCDRZUHVVRRZFUWLRZEJURVVLVWDVVSVWHEJVWDVVQVWFFUH
      UWLVVRVWDVVPVWECDUWIVVFVVOQXTWEUUGYAVVKVWHUGEJVVKVWGFVUPRUGEWBZVWHVVJVWGU
      EFVUPVVJVVGUDDRZUHVVHRUEFWBZVWGVVGUDUHDVVHUUEVWKVWJVWFUHVVHVVRVUFUWAUQVSV
      WJUVTVUGOZVVMULUMZUNOZVVFQUPZCDRVWKVWFVVGVWOUDCDUDCWBZVVEVWNVVFQVWPVVDVWM
      UNVWPVUHVWLVVCVVMULVUEUVTVUGVSVUEUVTVVBVSYBWCWDYCVWKVWOVWECDVWKVWNVVOVVFQ
      VWKVWMVVNUNVWKVWLUWCVVMULVWKUVTVUGUWBVUFUWAGVSVTWAWCWDWEYDYGYDYCVWIVWGFVU
      PUWLVUOUWDUQVSZUUFYDYHUUHYIWTVUTVVKVUQUGJVUTVUOJPZSVVJVUNUEVUPVUTVWRVUFVU
      PPZVVJVUNVNZVWRVWSSVUTVUFJPZVWTHVUFVUOJKWRVUTVXASZVVIVUMUDDVXBVUEDPZSZVVI
      VVCVUKULUMUNOVVFQUPZUHUIUKUQOZRUIVVHURZVUMVXDVUKVVCVVFUIUHVUJVUFVVHVVHYJZ
      VXAVUFVDPZVUTVXCVXIVUFUYAJHVUFVQKUUIUUJVUTVWBVXAVXCVUSVWBUYPVWCVLVEVXDVVA
      VVHPZSZVVAJPZVVAVUJOVVCYFVXDVXAVXJVXLVUTVXAVXCVKHVVAVUFJKWRYKZUCVVAVUIVVC
      JVUJUCUHWBVUEUYSVVBUYRVVAGVSVTVUJYJVUEVVBYLYMWMVXDVUJYEUOZPZVUJVUKYEUPZVX
      BVUAVXNPZUBDRZVXCVXOUYPVXRVUSVXAUYPVXQUBDUYPUYQDPZSZUFUGUEVUAHYNJKVXTJTVU
      FVUAVXTUCJUYTTVUAUYPUYRJPZVXSUYTTPUYPVYASZDTUYQUYSVYBUYSUXJPDTUYSVGUYPJUX
      JUYRGAUXKUWONWJZWIUYSTDWKWMWIXJVUAYJZYOWIVXTUYQUWBOZUYQUWEOZULUMZUNOZUWIQ
      UPZFUWLRZEJURZBUSRZVUFVUAOZVUOVUAOZULUMZUNOZVULQUPZUEVUPRZUGJURZUFUSRUWOV
      XSVYLAVXSUWOVYLVXSUWNVYKBUSVXSUWMVYJEJVXSUWKVYIFUWLUWJVYICUYQDCUBWBZUWHVY
      HUWIQVYTUWGVYGUNVYTUWCVYEUWFVYFULUVTUYQUWBVSUVTUYQUWEVSYBWCWDWFYQUUKYQUUP
      UULVYSVYKUFBUSVYSVYHVULQUPZFUWLRZEJURZUFBWBZVYKVYSUWAVUAOZUWDVUAOZULUMZUN
      OZVULQUPZFUWLRZEJURWUCVYRWUJUGEJVYRWUEVYNULUMZUNOZVULQUPZFVUPRVWIWUJVYQWU
      MUEFVUPVWKVYPWULVULQVWKVYOWUKUNVWKVYMWUEVYNULVUFUWAVUAVSWAWCWDYCVWIWUMWUI
      FVUPUWLVWQVWIWULWUHVULQVWIWUKWUGUNVWIVYNWUFWUEULVUOUWDVUAVSUUQWCWDYGYDYHW
      UJWUBEJUXOWUIWUAFUWLUYNWUHVYHVULQUYNWUGVYGUNUYNWUEVYEWUFVYFULUYNUXMWUEVYE
      YFUYOUCUWAUYTVYEJVUAUCFWBUYQUYSUWBUYRUWAGVSVTVYDUYQUWBYLYMWMUXOWUFVYFYFUY
      CUCUWDUYTVYFJVUAUCEWBUYQUYSUWEUYRUWDGVSVTVYDUYQUWEYLYMWJYBWCWDUUMUUNUURWU
      DWUBVYJEJWUDWUAVYIFUWLVULUWIVYHQXTWEYAYDYCUUSVUAYNPVXTUCJUYTJUYAYNKHUQYLU
      UOUVFUVPUUTZXPVEVXQVXOUBVUEDUBUDWBZVUAVUJVXNWUOUCJUYTVUIUYQVUEUYSVSUVAZUV
      BYIYKVUJYPYRZUVCVVIVXGSZVVGVXESZUHVVHURZVXDVUMWURWUSUHVXFRUIVVHURWUTVVGVX
      EUIUHVUFVVHVXHUVDWUSUIUHVUFVVHVXHUVEWMVXDWUSVUMUHVVHVXKVUHTPZVUKTPZVVCTPV
      ULWQPZWUSVUMVNVXDWVAVXJVXBDTVUEVUGVXBVUGUXJPDTVUGVGVUTJUXJVUFGAUXKUWOVUSN
      VEWIVUGTDWKWMWIWJVXDWVBVXJVXDVXPWVBWUQVUKVUJYSWMWJVXKDTVUEVVBVXKVVBUXJPDT
      VVBVGVXKJUXJVVAGAUXKUWOVUSVXAVXCVXJNUVGVXMYTVVBTDWKWMVXBVXCVXJVKYTVUSWVCU
      YPVXAVXCVXJVULXBWNVUHVUKVVCVULXCXDUVHXRUVIXGUVJXAXGXMXOXPUYPUFUDVUKVUHDUG
      UEGVUCHIJKAUXIUWOLWJVYCUYPVXAVXCSSVUHVHVXCVUEVUCOVUKYFUYPUBVUEVUBVUKDVUCW
      UOVUAVUJYEWUPWCVUCYJZVUJYEYLYMVLUYPUBDVUBTVUCVXTVUAVUBYEUPZVUBTPVXTVXQWVE
      WUNVUAYPYRVUBVUAYSWMWVDYOADIPUWOMWJUVKUVLGVUCUVQUVMUVNXKUVO $.

    $( A sequence of functions converges uniformly iff it is uniformly Cauchy,
       which is to say that for every ` 0 < x ` there is a ` j ` such that for
       all ` j <_ k , m ` the functions ` F ( k ) ` and ` F ( m ) ` are
       uniformly within ` x ` of each other on ` S ` .  (Contributed by Mario
       Carneiro, 1-Mar-2015.) $)
    ulmcau2 $p |- ( ph -> ( F e. dom ( ~~>u ` S ) <->
      A. x e. RR+ E. j e. Z A. k e. ( ZZ>= ` j ) A. m e. ( ZZ>= ` k )
      A. z e. S ( abs ` ( ( ( F ` k ) ` z ) - ( ( F ` m ) ` z ) ) ) < x ) ) $=
      ( cfv cv cmin co wral culm cdm wcel cabs clt wbr cuz crp ulmcau ulmcaulem
      wrex bitrd ) AHDUAPUBUCCQZFQZHPPZUMEQZHPPRSUDPBQZUEUFCDTFUPUGPZTEKUKBUHTU
      OUMGQHPPRSUDPUQUEUFCDTGUNUGPTFURTEKUKBUHTABCDEFHIJKLMNOUIABCDEFGHIJKLMNOU
      JUL $.
  $}

  ${
    $d j k m r z A $.  $d j k m r z G $.  $d j k m r z M $.  $d j k r x z T $.
    $d j k m r x z ph $.  $d j k m r x z S $.  $d j k m r x z Z $.
    ulmss.z $e |- Z = ( ZZ>= ` M ) $.
    ulmss.t $e |- ( ph -> T C_ S ) $.
    ulmss.a $e |- ( ( ph /\ x e. Z ) -> A e. W ) $.
    ulmss.u $e |- ( ph -> ( x e. Z |-> A ) ( ~~>u ` S ) G ) $.
    $( A uniform limit of functions is still a uniform limit if restricted to a
       subset.  (Contributed by Mario Carneiro, 3-Mar-2015.) $)
    ulmss $p |- ( ph -> ( x e. Z |-> ( A |` T ) ) ( ~~>u ` T ) ( G |` T ) ) $=
      ( vz vk cfv wral wcel wa cc vr vj vm cmpt culm wbr cres cmin cabs clt cuz
      cv co wrex crp wi uztrn2 wss adantr ssralv syl wceq wb fvres ad2antll cvv
      simprl adantrr resexg eqid fvmpt2 syl2anc 3eqtr4d ralrimivva nfv nffvmpt1
      fveq1d nfcv nffv nfral fveq2 eqeq12d ralbidv cbvral sylib r19.21bi fveq2d
      nfeq oveq1 breq1d ralimi sylibrd sylan2 anassrs ralimdva reximdva ralimdv
      ralbi 3syl cmap wf cz ulmf cdm dmmptss syl6eqssr uzid adantl ssel eluzel2
      fdm syl6 syl5com syl5 rexlimdva mpd wfn crn ralrimiva fnmpt frn rexlimivw
      eleq2s df-f eqidd ulmcl ulmscl ulm2 fmpt sylibr elmapi fssres cnex elmapg
      sylanbrc ssexd sylancr mpbird fmptd 3imtr4d ) ABICUDZFDUEPUFZBICEUGZUDZFE
      UGZEUEPUFZMANULZOULZUUAPZPZUUGFPZUHUMZUIPZUAULZUJUFZNDQZOUBULZUKPZQZUBIUN
      ZUAUOQUUGUUHUUDPZPZUUKUHUMZUIPZUUNUJUFZNEQZOUURQZUBIUNZUAUOQUUBUUFAUUTUVH
      UAUOAUUSUVGUBIAUUQIRZSUUPUVFOUURAUVIUUHUURRZUUPUVFUPZUVIUVJSAUUHIRZUVKGUU
      HUUQIJUQAUVLSZUUPUUONEQZUVFUVMEDURZUUPUVNUPAUVOUVLKUSUUONEDUTVAUVMUVBUUJV
      BZNEQZUVEUUOVCZNEQUVFUVNVCAUVQOIAUUGBULZUUDPZPZUUGUVSUUAPZPZVBZNEQZBIQUVQ
      OIQAUWDBNIEAUVSIRZUUGERZSSZUUGUUCPZUUGCPZUWAUWCUWGUWIUWJVBAUWFUUGECVDVEUW
      HUUGUVTUUCUWHUWFUUCVFRZUVTUUCVBAUWFUWGVGZUWHCHRZUWKAUWFUWMUWGLVHZCEHVIVAB
      IUUCVFUUDUUDVJZVKVLVQUWHUUGUWBCUWHUWFUWMUWBCVBUWLUWNBICHUUAUUAVJZVKVLVQVM
      VNUWEUVQBOIUWEOVOUVPBNEBEVRBUVBUUJBUUGUVABIUUCUUHVPBUUGVRZVSBUUGUUIBICUUH
      VPUWQVSWHVTUVSUUHVBZUWDUVPNEUWRUWAUVBUWCUUJUWRUUGUVTUVAUVSUUHUUDWAVQUWRUU
      GUWBUUIUVSUUHUUAWAVQWBWCWDWEWFUVPUVRNEUVPUVDUUMUUNUJUVPUVCUULUIUVBUUJUUKU
      HWIWGWJWKUVEUUONEWRWSWLWMWNWOWPWQAUANUUKUUJDUBOUUAFGVFIJAUCULZUKPZTDWTUMZ
      UUAXAZUCXBUNZGXBRZAUUBUXCMDUCUUAFXCVAZAUXBUXDUCXBUXBUWTIURZAUWSXBRZSZUXDU
      XBUWTUUAXDIUWTUXAUUAXKBICUUAUWPXEXFUXHUWSUWTRZUXFUXDUXGUXIAUWSXGXHUXFUXIU
      WSIRUXDUWTIUWSXIUXDUWSGUKPIGUWSXJJYCXLXMXNXOXPZAUUAIXQZUUAXRUXAURZIUXAUUA
      XAZAUWMBIQUXKAUWMBILXSBICUUAHUWPXTVAAUXCUXLUXEUXBUXLUCXBUWTUXAUUAYAYBVAIU
      XAUUAYDYOZAUVLUUGDRZSSUUJYEAUXOSUUKYEAUUBDTFXAZMDUUAFYFVAZAUUBDVFRMDUUAFY
      GVAZYHAUANUUKUVBEUBOUUDUUEGVFIJUXJABIUUCTEWTUMZUUDAUWFSZUUCUXSRZETUUCXAZU
      XTDTCXAZUVOUYBUXTCUXARZUYCAUYDBIAUXMUYDBIQUXNBIUXACUUAUWPYIYJWFCTDYKVAAUV
      OUWFKUSDTECYLVLUXTTVFREVFRZUYAUYBVCYMAUYEUWFAEDVFUXRKYPZUSTEUUCVFVFYNYQYR
      UWOYSAUVLUWGSSUVBYEUWGUUGUUEPUUKVBAUUGEFVDXHAUXPUVOETUUEXAUXQKDTEFYLVLUYF
      YHYTXP $.
  $}

  ${
    $d j k x z F $.  $d j k x y z G $.  $d j k x z ph $.  $d j k x y z S $.
    $d j k z M $.  $d j k x z Z $.
    ulmbdd.z $e |- Z = ( ZZ>= ` M ) $.
    ulmbdd.m $e |- ( ph -> M e. ZZ ) $.
    ulmbdd.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    ulmbdd.b $e |- ( ( ph /\ k e. Z ) ->
      E. x e. RR A. z e. S ( abs ` ( ( F ` k ) ` z ) ) <_ x ) $.
    ulmbdd.u $e |- ( ph -> F ( ~~>u ` S ) G ) $.
    $( A uniform limit of bounded functions is bounded.  (Contributed by Mario
       Carneiro, 27-Feb-2015.) $)
    ulmbdd $p |- ( ph -> E. x e. RR A. z e. S ( abs ` ( G ` z ) ) <_ x ) $=
      ( cfv c1 wbr cle cr wa vj vy cv cmin co cabs clt wral cuz wrex wcel eqidd
      crp 1rp a1i ulmi r19.2uz wi r19.26 caddc peano2re adantl cc wf culm ulmcl
      syl ad3antrrr simprl ffvelrnd abscld cmap simpllr elmapi readdcld pncan3d
      subcld adantr fveq2d abstrid eqbrtrrd 1re simprrl abssubd simprrr eqbrtrd
      simplr ltle sylancl le2addd letrd expr ralimdva wceq breq2 ralbidv rspcev
      mpd ee12an syl5bir exp3a rexlimdva cbvrexv syl6ib syl5 ) ACUCZEUCZFOZOZXF
      GOZUDUEUFOZPUGQZCDUHZEUAUCUIOUHUAIUJZXJUFOZBUCZRQZCDUHZBSUJZACXJXIPDUAEFG
      HIJKLAXGIUKZXFDUKZTTXIULAYATXJULNPUMUKAUNUOUPXNXMEIUJAXSXMUAEHIJUQAXMXSEI
      AXTTZXMXOUBUCZRQZCDUHZUBSUJZXSYBXIUFOZXPRQZCDUHZBSUJXMYFURZMYBYIYJBSYBXPS
      UKZTZYIXMYFYIXMTYHXLTZCDUHZYLYFYHXLCDUSYLXPPUTUEZSUKZYNXOYORQZCDUHZYFYKYP
      YBXPVAVBZYLYMYQCDYLYAYMYQYLYAYMTZTZXOYGXJXIUDUEZUFOZUTUEZYOUUAXJUUADVCXFG
      ADVCGVDZXTYKYTAFGDVEOQUUENDFGVFVGVHYLYAYMVIZVJZVKUUAYGUUCUUAXIUUADVCXFXHU
      UAXHVCDVLUEZUKDVCXHVDUUAIUUHXGFAIUUHFVDXTYKYTLVHAXTYKYTVMVJXHVCDVNVGUUFVJ
      ZVKZUUAUUBUUAXJXIUUGUUIVQZVKZVOYLYPYTYSVRUUAXIUUBUTUEZUFOXOUUDRUUAUUMXJUF
      UUAXIXJUUIUUGVPVSUUAXIUUBUUIUUKVTWAUUAYGUUCXPPUUJUULYBYKYTWGPSUKZUUAWBUOY
      LYAYHXLWCUUAUUCPUGQZUUCPRQZUUAUUCXKPUGUUAXJXIUUGUUIWDYLYAYHXLWEWFUUAUUCSU
      KUUNUUOUUPURUULWBUUCPWHWIWRWJWKWLWMYEYRUBYOSYCYOWNYDYQCDYCYOXORWOWPWQWSWT
      XAXBWRYEXRUBBSYCXPWNYDXQCDYCXPXORWOWPXCXDXBXEWR $.
  $}

  ${
    $d j k w z F $.  $d j k w x y z G $.  $d j k w x y z ph $.  $d j k w z Z $.
    $d j k w M $.  $d j k w x y z S $.
    ulmcn.z $e |- Z = ( ZZ>= ` M ) $.
    ulmcn.m $e |- ( ph -> M e. ZZ ) $.
    ulmcn.f $e |- ( ph -> F : Z --> ( S -cn-> CC ) ) $.
    ulmcn.u $e |- ( ph -> F ( ~~>u ` S ) G ) $.
    $( A uniform limit of continuous functions is continuous.  (Contributed by
       Mario Carneiro, 27-Feb-2015.) $)
    ulmcn $p |- ( ph -> G e. ( S -cn-> CC ) ) $=
      ( vw cc co wcel cfv clt wbr wi wa caddc vx vz vy vk vj ccncf wf cmin cabs
      cv wral crp wrex culm ulmcl syl c2 cdiv cuz cz adantr cmap wss cncff cnex
      cvv wb cncfrss ssexg sylancl elmapg sylancr ssriv eqidd rphalfcl ad2antll
      mpbird fss rphalfcld ulmi r19.2uz simplrl weq fveq2 oveq12d fveq2d breq1d
      rspcv ffvelrnda cncfi ad2antrr r19.26 cr simplr ffvelrnd elmapi ad3antrrr
      syl3anc subcld abscld ffvelrn sylancom rpred lt2add syl22anc recnd breq2d
      2halvesd readdcld rpre abs3difd addcomd breqtrd abssubd leadd2dd breqtrrd
      cle oveq1d addassd letrd lelttr mpand sylbid syld exp3a expdimp an32s imp
      expimpd ralimdva syl5bir reximdv mpd exp31 mpdd rexlimdva syl5 ralrimivva
      imim2d uzid syl6eleqr ssid elcncf2 mpbir2and ) ADBLUFMZNZBLDUGZKUJZUAUJZU
      HMUIOUBUJPQZUUHDOZUUIDOZUHMZUIOZUCUJZPQZRZKBUKZUBULUMZUCULUKUABUKZACDBUNO
      QZUUGJBCDUOUPZAUUSUAUCBULAUUIBNZUUOULNZSZSZUUHUDUJZCOZOZUUKUHMZUIOZUUOUQU
      RMZUQURMZPQZKBUKZUDUEUJUSOUKUEFUMZUUSUVFKUUKUVIUVMBUEUDCDEFGAEUTNZUVEHVAA
      FLBVBMZCUGZUVEAFUUECUGZUUEUVRVCUVSIUAUUEUVRUUIUUENZUUIUVRNZBLUUIUGZBLUUIV
      DUWALVFNZBVFNZUWBUWCVGVEUWABLVCZUWDUWEBLUUIVHVEBLVFVIVJLBUUIVFVFVKVLVQVMF
      UUEUVRCVRVJVAZUVFUVGFNZUUHBNZSSUVIVNUVFUWISUUKVNAUVAUVEJVAUVFUVLUVDUVLULN
      ZAUVCUUOVOVPZVSVTUVPUVOUDFUMUVFUUSUVOUEUDEFGWAUVFUVOUUSUDFUVFUWHSZUVOUUIU
      VHOZUULUHMZUIOZUVMPQZUUSUWLUVCUVOUWPRAUVCUVDUWHWBZUVNUWPKUUIBKUAWCZUVKUWO
      UVMPUWRUVJUWNUIUWRUVIUWMUUKUULUHUUHUUIUVHWDUUHUUIDWDWEWFWGWHUPUWLUVOUWPUU
      SUWLUVOSUWPSZUUJUVIUWMUHMZUIOZUVLPQZRZKBUKZUBULUMZUUSUWLUXEUVOUWPUWLUVHUU
      ENUVCUWJUXEUVFFUUEUVGCAUVTUVEIVAWIUWQUVFUWJUWHUWKVAZUBKBLUUIUVLUVHWJWRWKU
      WSUXDUURUBULUWLUWPUVOUXDUURRUWLUWPSZUVOUXDUURUVOUXDSUVNUXCSZKBUKUXGUURUVN
      UXCKBWLUXGUXHUUQKBUXGUWISZUVNUXCUUQUXIUVNSUXBUUPUUJUXIUVNUXBUUPRZUWLUWIUW
      PUVNUXJRUWLUWISZUWPUVNUXJUXKUWPUVNSZUWOUVKTMZUVMUVMTMZPQZUXJUXKUWOWMNUVKW
      MNUVMWMNZUXPUXLUXORUXKUWNUXKUWMUULUXKBLUUIUVHUXKUVHUVRNBLUVHUGZUXKFUVRUVG
      CUVFUVSUWHUWIUWGWKUVFUWHUWIWNWOUVHLBWPUPZUWLUVCUWIUWQVAZWOZUXKBLUUIDAUUGU
      VEUWHUWIUVBWQZUXSWOZWSWTZUXKUVJUXKUVIUUKUWLUWIUXQUVILNUXRBLUUHUVHXAXBZUWL
      UWIUUGUUKLNUYABLUUHDXAXBZWSWTZUXKUVMUXKUVLUWLUWJUWIUXFVAZVSXCZUYHUWOUVKUV
      MUVMXDXEUXKUXOUXMUVLPQZUXJUXKUXNUVLUXMPUXKUVLUXKUVLUXKUVLUYGXCZXFXHXGUXKU
      YIUXBUUPUXKUYIUXBSZUXMUXATMZUVLUVLTMZPQZUUPUXKUXMWMNUXAWMNUVLWMNZUYOUYKUY
      NRUXKUWOUVKUYCUYFXIZUXKUWTUXKUVIUWMUYDUXTWSWTZUYJUYJUXMUXAUVLUVLXDXEUXKUY
      NUYLUUOPQZUUPUXKUYMUUOUYLPUXKUUOUXKUUOUVFUUOWMNZUWHUWIUVDUYSAUVCUUOXJVPWK
      ZXFXHXGUXKUUNUYLXQQZUYRUUPUXKUUNUWOUUKUWMUHMZUIOZTMZUYLUXKUUMUXKUUKUULUYE
      UYBWSWTZUXKUWOVUCUYCUXKVUBUXKUUKUWMUYEUXTWSWTZXIUXKUXMUXAUYPUYQXIZUXKUUNV
      UCUWOTMVUDXQUXKUUKUULUWMUYEUYBUXTXKUXKVUCUWOUXKVUCVUFXFUXKUWOUYCXFZXLXMUX
      KVUDUWOUVKUXATMZTMUYLXQUXKVUCVUIUWOVUFUXKUVKUXAUYFUYQXIUYCUXKVUCUUKUVIUHM
      UIOZUXATMVUIXQUXKUUKUWMUVIUYEUXTUYDXKUXKVUJUVKUXATUXKUUKUVIUYEUYDXNXRXMXO
      UXKUWOUVKUXAVUHUXKUVKUYFXFUXKUXAUYQXFXSXPXTUXKUUNWMNUYLWMNUYSVUAUYRSUUPRV
      UEVUGUYTUUNUYLUUOYAWRYBYCYDYEYCYDYFYGYHYSYIYJYKYFYGYLYMYNYOYPYQYMYRAUWFLL
      VCUUFUUGUUTSVGAECOZUUENUWFAFUUEECIAEEUSOZFAUVQEVULNHEYTUPGUUAWOBLVUKVHUPL
      UUBUAUCUBKBLDUUCVJUUD $.
  $}

  ${
    $d j k m n s u v w x y z F $.  $d n r s u v w y z G $.  $d k m n w x y N $.
    $d k n y z C $.  $d j n r s u v w y z H $.  $d j k n x M $.  $d n w y ps $.
    $d j k m n r s u v w x y z ph $.  $d j k m n s u v w x y z S $.  $d y U $.
    $d m n x y R $.  $d j k m n r s u v w x y z X $.  $d k n y z Y $.
    $d j k m n s u v w x y z Z $.
    ulmdv.z $e |- Z = ( ZZ>= ` M ) $.
    ulmdv.s $e |- ( ph -> S e. { RR , CC } ) $.
    ulmdv.m $e |- ( ph -> M e. ZZ ) $.
    ulmdv.f $e |- ( ph -> F : Z --> ( CC ^m X ) ) $.
    ulmdv.g $e |- ( ph -> G : X --> CC ) $.
    ulmdv.l $e |- ( ( ph /\ z e. X ) ->
      ( k e. Z |-> ( ( F ` k ) ` z ) ) ~~> ( G ` z ) ) $.
    ulmdv.u $e |- ( ph ->
      ( k e. Z |-> ( S _D ( F ` k ) ) ) ( ~~>u ` X ) H ) $.
    ${
      ulmdvlem1.c $e |- ( ( ph /\ ps ) -> C e. X ) $.
      ulmdvlem1.r $e |- ( ( ph /\ ps ) -> R e. RR+ ) $.
      ulmdvlem1.u $e |- ( ( ph /\ ps ) -> U e. RR+ ) $.
      ulmdvlem1.v $e |- ( ( ph /\ ps ) -> W e. RR+ ) $.
      ulmdvlem1.l $e |- ( ( ph /\ ps ) -> U < W ) $.
      ulmdvlem1.b $e |- ( ( ph /\ ps ) ->
        ( C ( ball ` ( ( abs o. - ) |` ( S X. S ) ) ) U ) C_ X ) $.
      ulmdvlem1.a $e |- ( ( ph /\ ps ) -> ( abs ` ( Y - C ) ) < U ) $.
      ulmdvlem1.n $e |- ( ( ph /\ ps ) -> N e. Z ) $.
      ulmdvlem1.1 $e |- ( ( ph /\ ps ) -> A. m e. ( ZZ>= ` N )
        A. x e. X ( abs ` ( ( ( S _D ( F ` N ) ) ` x ) -
          ( ( S _D ( F ` m ) ) ` x ) ) ) < ( ( R / 2 ) / 2 ) ) $.
      ulmdvlem1.2 $e |- ( ( ph /\ ps ) ->
        ( abs ` ( ( ( S _D ( F ` N ) ) ` C ) - ( H ` C ) ) ) < ( R / 2 ) ) $.
      ulmdvlem1.y $e |- ( ( ph /\ ps ) -> Y e. X ) $.
      ulmdvlem1.3 $e |- ( ( ph /\ ps ) -> Y =/= C ) $.
      ulmdvlem1.4 $e |- ( ( ph /\ ps ) ->
      ( ( abs ` ( Y - C ) ) < W ->
        ( abs ` ( ( ( ( ( F ` N ) ` Y ) - ( ( F ` N ) ` C ) ) / ( Y - C ) ) -
          ( ( S _D ( F ` N ) ) ` C ) ) ) < ( ( R / 2 ) / 2 ) ) ) $.
      $( Lemma for ~ ulmdv .  (Contributed by Mario Carneiro, 3-Mar-2015.) $)
      ulmdvlem1 $p |- ( ( ph /\ ps ) -> ( abs `
        ( ( ( ( G ` Y ) - ( G ` C ) ) / ( Y - C ) ) - ( H ` C ) ) ) < R ) $=
        ( vn vy wa cfv cmin co cdiv cdv cc adantr ffvelrnd subcld cdm wceq cmap
        wf wcel cmpt fveq2 oveq2d eqid ovex fvmpt syl wfn wbr cvv wral eqeltrrd
        cv syl2anc elmapi cr sseldd divcld rpred cabs caddc c2 abscld rehalfcld
        wss clt cle oveq1d eqtrd fveq2d eqtr3d cmul cxp cuz cz mpteq2dv breq12d
        cli rspcv sylc fvex mptex a1i fveq1d adantl ffvelrnda eqeltrd climsubc1
        weq eqtr4d oveq12d recnd sylan syldan ffn ad2antrr fnfvof syl22anc cxmt
        eqbrtrd mpbird feqmptd breq1d rspccva culm rgenw fnmpt ulmf2 fdm dvbsss
        mp1i syl6eqssr cpr recnprss sstrd subne0d ulmcl readdcld abs3difd sub4d
        absdivd csn syl6eleq eluzelz ralrimiva eqeltri climsub climabs remulcld
        divsubdird eqimss2i climconst2 uztrn2 fvconst2 cof ulmscl ccom cres cbl
        ovresd cnmetdval cxr wb cnxmet xmetres2 sylancr rpxrd elbl3 crp syl3anc
        blcntr fmptd offval2 feq1d dvmptsub dmeqd dmmpti syl6eq sseqtr4d sselda
        jca fvmpt2 mpan2 sylan9eq dvmptcl abssubd ralbidv ltled dvlip2 eqbrtrrd
        mpdan 3brtr4d climle absrpcld ledivmul2d lttrd leltaddd breqtrd lelttrd
        mpd 2halvesd abs3lemd ) ABVBZRLVCZELVCZVDVEZREVDVEZVFVEZEMVCEGOKVCZVGVE
        ZVCZFUXSUYBUYCUXSUXTUYAUXSQVHRLAQVHLVOBUDVIZUQVJZUXSQVHELUYHUGVJZVKZUXS
        REUXSQVHRUXSQGVHUXSQUYFVLZGUXSQVHUYFVOZUYLQVMUXSUYFVHQVNVEZVPUYMUXSOISG
        IWIZKVCZVGVEZVQZVCZUYFUYNUXSOSVPZUYSUYFVMUNIOUYQUYFSUYRUYOOVMUYPUYEGVGU
        YOOKVRVSUYRVTZGUYEVGWAWBWCUXSSUYNOUYRASUYNUYRVOZBAUYRSWDZUYRMQUUAVCWEZV
        UBUYQWFVPZISWGVUCAVUEISGUYPVGWAUUBISUYQUYRWFVUAUUCUUGUFQUYRMSUUDWJZVIUN
        VJWHUYFVHQWKWCZQVHUYFUUEWCGUYEUUFUUHZAGVHXAZBAGWLVHUUIVPZVUIUAGUUJWCVIZ
        UUKZUQWMZUXSQVHEVULUGWMZVKZUXSREVUMVUNURUULZWNZUXSQVHEMAQVHMVOZBAVUDVUR
        UFQUYRMUUMWCVIUGVJUXSQVHEUYFVUGUGVJZUXSFUHWOZUXSUYDUYGVDVEZWPVCUYDRUYEV
        CZEUYEVCZVDVEZUYCVFVEZVDVEZWPVCZVVEUYGVDVEZWPVCZWQVEZFWRVFVEZUXSVVAUXSU
        YDUYGVUQVUSVKWSUXSVVGVVIUXSVVFUXSUYDVVEVUQUXSVVDUYCUXSVVBVVCUXSQVHRUYEU
        XSUYEUYNVPQVHUYEVOZUXSSUYNOKASUYNKVOBUCVIZUNVJUYEVHQWKWCZUQVJZUXSQVHEUY
        EVVNUGVJZVKZVUOVUPWNZVKWSZUXSVVHUXSVVEUYGVVRVUSVKWSZUUNUXSFVUTWTZUXSUYD
        UYGVVEVUQVUSVVRUUOUXSVVJVVKWRVFVEZVWBWQVEVVKXBUXSVVGVVIVWBVWBVVSVVTUXSV
        VKVWAWTZVWCUXSVVGUXTVVBVDVEZUYAVVCVDVEZVDVEZWPVCZUYCWPVCZVFVEZVWBXCUXSV
        WFUYCVFVEZWPVCVVGVWIUXSVWJVVFWPUXSVWJUYBVVDVDVEZUYCVFVEVVFUXSVWFVWKUYCV
        FUXSUXTVVBUYAVVCUYIVVOUYJVVPUUPXDUXSUYBVVDUYCUYKVVQVUOVUPUVFXEXFUXSVWFU
        YCUXSVWDVWEUXSUXTVVBUYIVVOVKUXSUYAVVCUYJVVPVKVKZVUOVUPUUQXGUXSVWIVWBXCW
        EVWGVWBVWHXHVEZXCWEUXSVWGVWMUTISRUYPVCZVVBVDVEZEUYPVCZVVCVDVEZVDVEZWPVC
        ZVQZSVWMUURXIZOOXJVCZVXBVTUXSONXJVCZVPOXKVPUXSOSVXCUNTUUSNOUUTWCUXSVWFU
        TISVWRVQZVWTNWFSTUXSVWDVWEUTISVWOVQZISVWQVQZVXDNWFSTANXKVPZBUBVIZUXSUXT
        VVBUTISVWNVQZVXENWFSTVXHUXSRQVPZISDWIZUYPVCZVQZVXKLVCZXNWEZDQWGZVXIUXTX
        NWEZUQAVXPBAVXODQUEUVAVIZVXOVXQDRQVXKRVMZVXMVXIVXNUXTXNVXSISVXLVWNVXKRU
        YPVRXLVXKRLVRXMXOXPVVOVXEWFVPUXSISVWOSVXCWFTNXJXQUVBZXRXSUXSUTWIZSVPZVB
        ZVYAVXIVCZRVYAKVCZVCZVHVYBVYDVYFVMUXSIVYAVWNVYFSVXIIUTYEZRUYPVYEUYOVYAK
        VRZXTZVXIVTRVYEXQWBYAZVYCQVHRVYEVYCVYEUYNVPQVHVYEVOZUXSSUYNVYAKVVMYBVYE
        VHQWKWCZUXSVXJVYBUQVIVJZYCVYCVYAVXEVCZVYFVVBVDVEZVYDVVBVDVEVYBVYNVYOVMU
        XSIVYAVWOVYOSVXEVYGVWNVYFVVBVDVYIXDZVXEVTVYFVVBVDWAWBYAZVYCVYDVYFVVBVDV
        YJXDYFYDVXDWFVPUXSISVWRVXTXRXSUXSUYAVVCUTISVWPVQZVXFNWFSTVXHUXSEQVPZVXP
        VYRUYAXNWEZUGVXRVXOVYTDEQVXKEVMZVXMVYRVXNUYAXNWUAISVXLVWPVXKEUYPVRXLVXK
        ELVRXMXOXPVVPVXFWFVPUXSISVWQVXTXRXSVYCVYAVYRVCZEVYEVCZVHVYBWUBWUCVMUXSI
        VYAVWPWUCSVYRVYGEUYPVYEVYHXTZVYRVTEVYEXQWBYAZVYCQVHEVYEVYLUXSVYSVYBUGVI
        VJZYCVYCVYAVXFVCZWUCVVCVDVEZWUBVVCVDVEVYBWUGWUHVMUXSIVYAVWQWUHSVXFVYGVW
        PWUCVVCVDWUDXDZVXFVTWUCVVCVDWAWBYAZVYCWUBWUCVVCVDWUEXDYFYDVYCVYNVYOVHVY
        QVYCVYFVVBVYMUXSVVBVHVPVYBVVOVIVKZYCVYCWUGWUHVHWUJVYCWUCVVCWUFUXSVVCVHV
        PVYBVVPVIVKZYCVYCVYAVXDVCZVYOWUHVDVEZVYNWUGVDVEVYBWUMWUNVMUXSIVYAVWRWUN
        SVXDVYGVWOVYOVWQWUHVDVYPWUIYGZVXDVTVYOWUHVDWAWBYAZVYCVYNVYOWUGWUHVDVYQW
        UJYGYFUVCVWTWFVPUXSISVWSVXTXRXSVXHVYCWUMWUNVHWUPVYCVYOWUHWUKWULVKZYCVYC
        VYAVWTVCZWUNWPVCZWUMWPVCVYBWURWUSVMZUXSIVYAVWSWUSSVWTVYGVWRWUNWPWUOXFVW
        TVTWUNWPXQWBZYAVYCWUMWUNWPWUPXFYFUVDUXSVWMVHVPVXGVXAVWMXNWEUXSVWMUXSVWB
        VWHVWCUXSUYCVUOWSZUVEZYHVXHVWMNSSVXCTUVGVXTUVHWJUXSVYAVXBVPZVBZWURWUSWL
        WVEVYBWUTUXSUYTWVDVYBUNNVYAOSTUVIYIZWVAWCZUXSWVDVYBWUSWLVPWVFVYCWUNWUQW
        SYJYCWVEVYAVXAVCZVWMWLWVEVYBWVHVWMVMWVFSVWMVYAVWBVWHXHWAUVJWCZUXSVWMWLV
        PWVDWVCVIYCWVEWUSVWMWURWVHXCWVERVYEUYEVDUVKVEZVCZEWVJVCZVDVEZWPVCZWUSVW
        MXCWVEWVMWUNWPWVEWVKVYOWVLWUHVDWVEVYEQWDZUYEQWDZQWFVPZVXJWVKVYOVMWVEVYK
        WVOUXSWVDVYBVYKWVFVYLYJZQVHVYEYKWCZWVEVVLWVPUXSVVLWVDVVNVIZQVHUYEYKWCZA
        WVQBWVDAVUDWVQUFQUYRMUVLWCYLZUXSVXJWVDUQVIQVDVYEUYEWFRYMYNWVEWVOWVPWVQV
        YSWVLWUHVMWVSWWAWWBUXSVYSWVDUGVIQVDVYEUYEWFEYMYNYGXFWVEREHWPVDUVMZGGXIU
        VNZUVOVCVEZVPZEWWEVPZVBWVNVWMXCWEWVEWWFWWGUXSWWFWVDUXSWWFREWWDVEZHXBWEZ
        UXSWWHVWHHXBUXSWWHREWWCVEZVWHUXSREWWCGUXSQGRVUHUQWMZUXSQGEVUHUGWMZUVPUX
        SRVHVPEVHVPWWJVWHVMVUMVUNREWWCWWCVTUVQWJXEUMYPUXSWWDGYOVCVPZHUVRVPZEGVP
        ZRGVPWWFWWIUVSUXSWWCVHYOVCVPVUIWWMUVTVUKWWCGVHUWAUWBZUXSHUIUWCZWWLWWKRW
        WDEHGUWDYNYQVIUXSWWGWVDUXSWWMWWOHUWEVPWWGWWPWWLUIWWDEHGUWGUWFVIUWQWVEVA
        EWWEHGWVJWWDVWBQREAVUJBWVDUAYLZWWDVTUXSQGXAWVDVUHVIWVEQVHWVJVOQVHVAQVAW
        IZVYEVCZWWSUYEVCZVDVEZVQZVOWVEVAQWXBVHWXCWVEWWSQVPZVBZWWTWXAWVEQVHWWSVY
        EWVRYBZWVEQVHWWSUYEWVTYBZVKZWXCVTUWHWVEQVHWVJWXCWVEVAQWWTWXAVDVYEUYEWFW
        FWFWWBWWTWFVPWXEWWSVYEXQXSWXAWFVPWXEWWSUYEXQXSWVEVAQVHVYEWVRYRZWVEVAQVH
        UYEWVTYRZUWIZUWJYQUXSWWOWVDWWLVIUXSWWNWVDWWQVIWWEVTWVEWWEQGWVJVGVEZVLZU
        XSWWEQXAWVDULVIZWVEWXMVAQWWSGVYEVGVEZVCZWWSUYFVCZVDVEZVQZVLQWVEWXLWXSWV
        EWXLGWXCVGVEWXSWVEWVJWXCGVGWXKVSWVEVAWWTWXPWXAWXQGWFWFQWWRWXFWXPWFVPWXE
        WWSWXOXQXSWVEWXOGVAQWWTVQZVGVEVAQWXPVQWVEVYEWXTGVGWXIVSWVEVAQVHWXOWVEWX
        OUYNVPQVHWXOVOWVEVYAUYRVCZWXOUYNWVEVYBWYAWXOVMWVFIVYAUYQWXOSUYRVYGUYPVY
        EGVGVYHVSVUAGVYEVGWAWBWCWVESUYNVYAUYRAVUBBWVDVUFYLWVFVJWHWXOVHQWKWCZYRX
        GWXGWXQWFVPWXEWWSUYFXQXSWVEUYFGVAQWXAVQZVGVEVAQWXQVQWVEUYEWYCGVGWXJVSWV
        EVAQVHUYFUXSUYMWVDVUGVIZYRXGUWKZXEZUWLVAQWXRWXSWXPWXQVDWAZWXSVTZUWMUWNU
        WOUXSVWBWLVPZWVDVWCVIWVEWWSWWEVPWXDWWSWXLVCZWPVCZVWBXCWEWVEWWEQWWSWXNUW
        PWXEWYKWXRWPVCZVWBXCWXEWYJWXRWPWVEWXDWYJWWSWXSVCZWXRWVEWWSWXLWXSWYFXTWX
        DWXRWFVPZWYMWXRVMWYGVAQWXRWFWXSWYHUWRUWSUWTXFWXEWYLVWBWXEWXRWVEVAWXBWXR
        GWFQWWRWXHWYNWXEWYGXSWYEUXAWSUXSWYIWVDWXDVWCYLWXEWYLWXQWXPVDVEZWPVCZVWB
        XBWXEWXPWXQWVEQVHWWSWXOWYBYBWVEQVHWWSUYFWYDYBUXBWVECWIZUYFVCZWYQWXOVCZV
        DVEZWPVCZVWBXBWEZCQWGZWXDWYPVWBXBWEZUXSWYRWYQGJWIZKVCZVGVEZVCZVDVEZWPVC
        ZVWBXBWEZCQWGZJVXBWGWVDXUCUOXULXUCJVYAVXBJUTYEZXUKXUBCQXUMXUJXUAVWBXBXU
        MXUIWYTWPXUMXUHWYSWYRVDXUMWYQXUGWXOXUMXUFVYEGVGXUEVYAKVRVSXTVSXFYSUXCYT
        YIXUBXUDCWWSQCVAYEZXUAWYPVWBXBXUNWYTWYOWPXUNWYRWXQWYSWXPVDWYQWWSUYFVRWY
        QWWSWXOVRYGXFYSYTYIYPUXDYPYJUXEUXGUXFWVGWVIUXHUXIUXSVWGVWBVWHUXSVWFVWLW
        SVWCUXSUYCVUOVUPUXJUXKYQYPUXSVWHPXBWEVVIVWBXBWEUXSVWHHPWVBUXSHUIWOUXSPU
        JWOUMUKUXLUSUXPUXMUXSVVKUXSVVKVWAYHUXQUXNUXOUPUXR $.
    $}

    $( Lemma for ~ ulmdv .  (Contributed by Mario Carneiro, 8-May-2015.) $)
    ulmdvlem2 $p |- ( ( ph /\ k e. Z ) -> dom ( S _D ( F ` k ) ) = X ) $=
      ( wcel cfv cc cv wa cdv co cmap cdm wceq cmpt wral wfn culm wbr cvv rgenw
      ovex eqid fnmpt mp1i ulmf2 syl2anc fmpt sylibr r19.21bi elmapi fdm 3syl
      wf ) ADUAZJRUBCVHESZUCUDZTIUEUDZRZITVJVGVJUFIUGAVLDJAJVKDJVJUHZVGZVLDJUIA
      VMJUJZVMGIUKSULVNVJUMRZDJUIVOAVPDJCVIUCUOUNDJVJVMUMVMUPZUQURQIVMGJUSUTDJV
      KVJVMVQVAVBVCVJTIVDITVJVEVF $.

    $( Lemma for ~ ulmdv .  (Contributed by Mario Carneiro, 8-May-2015.)
       (Proof shortened by Mario Carneiro, 28-Dec-2016.) $)
    ulmdvlem3 $p |- ( ( ph /\ z e. X ) -> z ( S _D G ) ( H ` z ) ) $=
      ( wcel wa cfv vy vv vu vr vx vn vm vj vs vw cv cdv wbr ccnfld ctopn crest
      co cnt csn cdif cmin cdiv cmpt climc wss wral cz uzid syl6eleqr ulmdvlem2
      cuz syl cdm cc cpr recnprss adantr cmap ffvelrnda elmapi dvbsss syl6eqssr
      cr wf eqid dvbssntr ralrimiva wceq biidd rspcv sylc cabs clt crp rphalfcl
      wi wrex c2 adantl sylancr cvv syl2anc mpbid uztrn2 weq fveq2 oveq2d fvmpt
      ovex fveq1d oveq12d fveq2d breq1d ralbidv ad2antrr fvex simplr simpllr wb
      ad3antrrr simprd dvlem fmptd ssdifssd sseldd ellimc3 oveq1d imbi2d cnxmet
      eldv cxmt ctop ctopon w3a anass cli simpld anassrs sylanb mpbir2and ulmcl
      eqsstr3d sselda wne culm wrel ulmrel releldm ulmscl wfn rgenw fnmpt ulmf2
      mp1i ulmcau2 ad2ant2lr simprr 2ralbidva rexbidva breq2 rexralbidv eqeltri
      2ralbidv mptex eqtr4d ulmclm climi2 rexanuz2 r19.2uz sylbir eqeltrrd 3syl
      a1i eleqtrrd wfun dvfg ffun funfvbrb 4syl sstrd oveq1 breqan12rd ralbidva
      fdm id rexbidv adantrr ccom cxp cres cmopn xmetres2 cuni cnfldtop resttop
      cbl cnfldtopon resttopon toponuni sseqtrd ntrss2 isopn3 cnfldtopn metrest
      eqssd mpbird eleqtrd simprl mopni3 syl31anc df-3an mpteq2dv breq12d sylan
      rspccva simprll simprlr simprr3 simplll simprr1 simprr2 eldifad ulmdvlem1
      simpr3 simpr1 simpr2 mpand sylan2br 3exp2 imp sylibrd ralimdva impr an32s
      expr reximdva mpd rexlimddv rexlimdvaa syl5 mp2and simpr ) ABUKZIRZSZVUCV
      UCGTZCFULUQUMVUCIUNUOTZCUPUQZURTTZRZVUFUAIVUCUSZUTZUAUKZFTZVUCFTZVAUQZVUM
      VUCVAUQZVBUQZVCZVUCVDUQRZAIVUIVUCAHJRZIVUIVEZDJVFVVBAHHVKTZJAHVGRZHVVCRMH
      VHVLKVIZAVVBDJADUKZJRZSZICVVFETZULUQZVMZVUIABCDEFGHIJKLMNOPQVJZVVHICVVIVU
      HVUGACVNVEZVVGACWCVNVOZRZVVMLCVPZVLZVQVVHVVIVNIVRUQZRIVNVVIWDAJVVRVVFENVS
      VVIVNIVTVLVVHIVVKCVVLCVVIWAWBZVUHWEZVUGWEZWFUUBWGVVBVVBDHJVVFHWHZVVBWIWJW
      KZUUCVUEVUTVUFVNRUBUKZVUCUUDZVWDVUCVAUQZWLTZUCUKZWMUMZSZVWDVUSTZVUFVAUQZW
      LTZUDUKZWMUMZWPZUBVULVFZUCWNWQZUDWNVFAIVNVUCGADJVVJVCZGIUUETZUMZIVNGWDQIV
      WSGUUAVLVSVUEVWRUDWNVUEVWNWNRZSZUEUKZCUFUKZETZULUQZTZVXDCUGUKZETZULUQZTZV
      AUQZWLTZVWNWRVBUQZWRVBUQZWMUMZUEIVFUGVXEVKTZVFZUFUHUKZVKTZVFUHJWQZVUCVXGT
      ZVUFVAUQWLTVXOWMUMZUFVYAVFUHJWQZVWRVXCVXPWNRZVXNUIUKZWMUMZUEIVFZUGVXRVFZU
      FVYAVFZUHJWQZUIWNVFZVYBVXCVXOWNRZVYFVXBVYNVUEVWNWOWSZVXOWOVLZAVYMVUDVXBAV
      XDVXEVWSTZTZVXDVXIVWSTZTZVAUQZWLTZVYGWMUMZUEIVFZUGVXRVFUFVYAVFZUHJWQZUIWN
      VFZVYMAVWSVWTVMRZWUGAVWTUUFVXAWUHIUUGQVWSGVWTUUHWTAUIUEIUHUFUGVWSHXAJKMAV
      XAIXARQIVWSGUUIVLAVWSJUUJZVXAJVVRVWSWDZVVJXARZDJVFWUIAWUKDJCVVIULXIUUKDJV
      VJVWSXAVWSWEZUULUUNQIVWSGJUUMXBZUUOXCAWUFVYLUIWNAWUEVYKUHJAVXTJRZSZWUDVYI
      UFUGVYAVXRWUOVXEVYARZVXIVXRRZSSZWUCVYHUEIWURWUBVXNVYGWMWURWUAVXMWLWURVYRV
      XHVYTVXLVAWURVXDVYQVXGWURVXEJRZVYQVXGWHZWUNWUPWUSAWUQHVXEVXTJKXDUUPZDVXEV
      VJVXGJVWSDUFXEZVVIVXFCULVVFVXEEXFXGZWULCVXFULXIXHZVLXJWURVXDVYSVXKWURVXIJ
      RZVYSVXKWHWURWUSWUQWVEWVAWUOWUPWUQUUQHVXIVXEJKXDXBDVXIVVJVXKJVWSDUGXEVVIV
      XJCULVVFVXIEXFXGWULCVXJULXIXHVLXJXKXLXMXNUURUUSXNXCXOVYLVYBUIVXPWNVYGVXPW
      HZVYJVXSUHUFJVYAWVFVYHVXQUGUEVXRIVYGVXPVXNWMUUTUVCUVAWJWKVXCVUFVYCVXOUHUF
      DJVUCVVJTZVCZHJKAVVDVUDVXBMXOZVYOWUSVXEWVHTZVYCWHVXCDVXEWVGVYCJWVHWVBVUCV
      VJVXGWVCXJWVHWEVUCVXGXPXHWSZVXCVUCIUFVWSGWVHHXAJKWVIAWUJVUDVXBWUMXOZAVUDV
      XBXQZWVHXARVXCDJWVGJVVCXAKHVKXPUVBUVDUVMVXCWUSSZVUCVYQTVYCWVJWVNVUCVYQVXG
      WUSWUTVXCWVDWSZXJWVKUVEAVXAVUDVXBQXOUVFUVGVYBVYESZVXSVYDSZUFJWQZVXCVWRWVP
      WVQUFVYAVFUHJWQWVRVXSVYDUHUFHJKUVHWVQUHUFHJKUVIUVJVXCWVQVWRUFJVXCWUSWVQSZ
      SZVWEVWGUJUKZWMUMZSZVWDVXFTZVUCVXFTZVAUQZVWFVBUQZVYCVAUQZWLTZVXPWMUMZWPZU
      BVULVFZVWRUJWNVXCWUSWWLUJWNWQZWVQWVNVYFWWCVWDUAVULVUMVXFTZWWEVAUQZVUQVBUQ
      ZVCZTZVYCVAUQZWLTZVYGWMUMZWPZUBVULVFZUJWNWQZUIWNVFZWWMVXCVYFWUSVYPVQWVNVY
      CVNRZWXEWVNVYCWWQVUCVDUQRZWXFWXESWVNVUJWXGWVNVUCVYCVXGUMZVUJWXGSWVNVUCVXG
      VMZRZWXHWVNVUCIWXIAVUDVXBWUSXRZWVNVXGVVRRIVNVXGWDWXIIWHWVNVYQVXGVVRWVOVXC
      JVVRVXEVWSWVLVSUVKVXGVNIVTIVNVXGUWDUVLUVNWVNVVOWXIVNVXGWDVXGUVOWXJWXHXSAV
      VOVUDVXBWUSLXTZCVXFUVPWXIVNVXGUVQVUCVXGUVRUVSXCWVNUAIVUCVYCCVUHVXFWWQVUGV
      VTVWAWWQWEZWVNVVOVVMWXLVVPVLWVNVXFVVRRIVNVXFWDVXCJVVRVXEEAJVVREWDVUDVXBNX
      OVSVXFVNIVTVLZAICVEZVUDVXBWUSAVVAWXODJVFWXOVVEAWXODJVVSWGWXOWXODHJVWBWXOW
      IWJWKZXTYJXCYAWVNUIUJUBVULVUCVYCWWQWVNUAVULWWPVNWWQWVNVUMVUCIVXFWXNVUEIVN
      VEVXBWUSVUEICVNAWXOVUDWXPVQZAVVMVUDVVQVQZUVTZXOZWXKYBWXMYCWVNIVNVUKWXTYDW
      VNIVNVUCWXTWXKYEYFXCYAWXDWWMUIVXPWNWVFWXCWWLUJWNWVFWXBWWKUBVULWVFVWDVULRZ
      SWXAWWJWWCWYAWVFWWTWWIVYGVXPWMWYAWWSWWHWLWYAWWRWWGVYCVAUAVWDWWPWWGVULWWQU
      AUBXEZWWOWWFVUQVWFVBWYBWWNWWDWWEVAVUMVWDVXFXFYGVUMVWDVUCVAUWAZXKWXMWWFVWF
      VBXIXHYGXLWVFUWEUWBYHUWCUWFWJWKUWGWVTWWAWNRZWWLSZSZVWHWWAWMUMZVUCVWHWLVAU
      WHZCCUWIUWJZUWPTUQIVEZSZUCWNWQZVWRWYFWYICYKTRZIWYIUWKTZRZVUDWYDWYLVUEWYMV
      XBWVSWYEVUEWYHVNYKTRZVVMWYMYIWXRWYHCVNUWLWTXTVUEWYOVXBWVSWYEAWYOVUDAIVUHW
      YNAIVUHRZVUIIWHZAVUIIAVUHYLRZIVUHUWMZVEZVUIIVEAVUGYLRVVOWYSVUGVWAUWNLCVUG
      VVNUWOWTZAICWYTWXPAVUHCYMTRZCWYTWHAVUGVNYMTRVVMXUCVUGVWAUWQVVQCVUGVNUWRWT
      CVUHUWSVLUWTZIVUHWYTWYTWEZUXAXBVWCUXEAWYSXUAWYQWYRXSXUBXUDIVUHWYTXUEUXBXB
      UXFAWYPVVMVUHWYNWHYIVVQWYHWYIVUGWYNVNCWYIWEVUGVWAUXCWYNWEZUXDWTUXGVQXTVXC
      VUDWVSWYEWVMXOWVTWYDWWLUXHUCIWYIVUCWWAWYNCXUFUXIUXJWYFWYKVWQUCWNWYFVWHWNR
      ZWYKVWQWVTXUGWYKSZWYEVWQWVTXUHSZWYDWWLVWQXUIWYDSZWWKVWPUBVULXUJWYASWWKVWJ
      VWDFTZVUOVAUQZVWFVBUQZVUFVAUQZWLTZVWNWMUMZWPZVWPXUJWYAWWKXUQWPXUJWYAWWKVW
      JXUPXUJWVTXUHWYDSZSWYAWWKVWJYNZXUPWVTXUHWYDYOWVTXURXUSXUPVXCWVSXURXUSSZXU
      PWVSXUTSVXCWUSWVQXUTYNZXUPWUSWVQXUTUXKVXCAVUDVXBSZSXVAXUPAVUDVXBYOAXVBXVA
      XUPAXVBXVASZUEUIVUCVWNCVWHDUGEFGHVXEWWAIVWDJKLMNOADJVUCVVITZVCZVUOYPUMZBI
      VFVYGIRDJVYGVVITZVCZVYGFTZYPUMZAXVFBIPWGXVFXVJBVYGIBUIXEZXVEXVHVUOXVIYPXV
      KDJXVDXVGVUCVYGVVIXFUXLVUCVYGFXFUXMUXOUXNQAVUDVXBXVAUXPAVUDVXBXVAUXQAXVCS
      ZXUTXUGWUSWVQXUTXVBAUXRZXUGWYKWYDXUSUXSVLXVLXUTWYDXVMXUHWYDXUSXQVLXVLWYGW
      YJXVLXUTWYKXVMXUGWYKWYDXUSXRVLZYQXVLWYGWYJXVNYAXVLVWEVWIXVLXUTVWJXVMXURWY
      AWWKVWJUYDVLZYAWUSWVQXUTXVBAUXTXVLVXSVYDWUSWVQXUTXVBAUYAZYQXVLVXSVYDXVPYA
      XVLVWDIVUKXVLXUTWYAXVMXURWYAWWKVWJUYEVLUYBXVLVWEVWIXVOYQZXVLVWEWWBWWJXVQX
      VLXUTWWKXVMXURWYAWWKVWJUYFVLUYGUYCYRYSUYHYRYRYSUYIUYJWYAVWPXUQXSXUJWYAVWO
      XUPVWJWYAVWMXUOVWNWMWYAVWLXUNWLWYAVWKXUMVUFVAUAVWDVURXUMVULVUSWYBVUPXULVU
      QVWFVBWYBVUNXUKVUOVAVUMVWDFXFYGWYCXKVUSWEZXULVWFVBXIXHYGXLXMYHWSUYKUYLUYM
      UYNUYOUYPUYQUYRUYSUYTVUAWGVUEUDUCUBVULVUCVUFVUSVUEUAVULVURVNVUSVUEVUMVUCI
      FAIVNFWDVUDOVQZWXSAVUDVUBZYBXVRYCVUEIVNVUKWXSYDVUEIVNVUCWXSXVTYEYFYTVUEUA
      IVUCVUFCVUHFVUSVUGVVTVWAXVRWXRXVSWXQYJYT $.

    $( If ` F ` is a sequence of differentiable functions on ` X ` which
       converge pointwise to ` G ` , and the derivatives of ` F ( n ) `
       converge uniformly to ` H ` , then ` G ` is differentiable with
       derivative ` H ` .  (Contributed by Mario Carneiro, 27-Feb-2015.) $)
    ulmdv $p |- ( ph -> ( S _D G ) = H ) $=
      ( cc wcel syl cdv co wf wfn cdm cr cpr dvfg wss recnprss wral cuz cz uzid
      cfv syl6eleqr cv wa ulmdvlem2 dvbsss syl6eqssr ralrimiva wceq biidd rspcv
      sylc dvbss wbr ulmdvlem3 vex fvex breldm ssrdv eqssd feq2d mpbid ffn cmpt
      ex culm ulmcl wfun ffun adantr funbrfv eqfnfvd ) ABICFUAUBZGAIRWGUCZWGIUD
      AWGUEZRWGUCZWHACUFRUGSZWJLCFUHTZAWIIRWGAWIIAICFAWKCRUILCUJTOAHJSICUIZDJUK
      WMAHHULUOZJAHUMSHWNSMHUNTKUPAWMDJADUQZJSURICWOEUOZUAUBZUECABCDEFGHIJKLMNO
      PQUSCWPUTVAVBWMWMDHJWOHVCWMVDVEVFVGABIWIABUQZISZWRWISZAWSURZWRWRGUOZWGVHZ
      WTABCDEFGHIJKLMNOPQVIZWRXBWGBVJWRGVKVLTVSVMVNVOVPIRWGVQTAIRGUCZGIUDADJWQV
      RZGIVTUOVHXEQIXFGWATIRGVQTXAWGWBZXCWRWGUOXBVCAXGWSAWJXGWLWIRWGWCTWDXDWRXB
      WGWEVFWF $.
  $}

  ${
    $d i j k n r x z F $.  $d i j k m n r x y z M $.  $d i j k m n r x y z N $.
    $d i j k m n r x y z ph $.  $d n x y z T $.  $d i j k m n r x y z Z $.
    $d i j k n r x y z S $.
    mtest.z $e |- Z = ( ZZ>= ` N ) $.
    mtest.n $e |- ( ph -> N e. ZZ ) $.
    mtest.s $e |- ( ph -> S e. V ) $.
    mtest.f $e |- ( ph -> F : Z --> ( CC ^m S ) ) $.
    mtest.m $e |- ( ph -> M e. W ) $.
    mtest.c $e |- ( ( ph /\ k e. Z ) -> ( M ` k ) e. RR ) $.
    mtest.l $e |- ( ( ph /\ ( k e. Z /\ z e. S ) ) ->
      ( abs ` ( ( F ` k ) ` z ) ) <_ ( M ` k ) ) $.
    mtest.d $e |- ( ph -> seq N ( + , M ) e. dom ~~> ) $.
    $( The Weierstrass M-test.  If ` F ` is a sequence of functions which are
       uniformly bounded by the convergent sequence ` M ( k ) ` , then the
       series generated by the sequence ` F ` converges uniformly.
       (Contributed by Mario Carneiro, 3-Mar-2015.) $)
    mtest $p |- ( ph -> seq N ( oF + , F ) e. dom ( ~~>u ` S ) ) $=
      ( wcel cc vi vj vr vn caddc cof cseq culm cfv cdm cv cmin co cabs clt wbr
      wral cuz wrex crp cz cli climcau syl2anc wa wi cle c1 cfz csu cmap wf wfn
      seqfn syl fneq2i sylibr cmpt elex adantr simpr syl6eleq syl6eleqr ffvelrn
      cvv elfzuz syl2an elmapi feqmptd wceq adantl fveq2 fveq1d eqid fvex fvmpt
      mpteq2dv eqtr4d seqof ffvelrnda an32s fmptd serf wb elmapg sylancr mpbird
      weq cnex eqeltrd ralrimiva ffnfv sylanbrc ad2antrr uztrn2 ffvelrnd simprl
      subcld abscld fzfid ssun2 adantlr syldan cr recnd fvmpt2 sylan9eq oveq12d
      mpan2 fsumser fsumsplit eqcomd fsumcl subaddd fveq2d eqidd letrd ralimdva
      cun cc0 simprr elfzuzb fzsplit syl5sseqr sselda fsumrecl resubcld eqeq12d
      serfre sylan2 rspccv cin c0 eluzelre ltp1d fzdisj 3eqtr2d fsumabs eqbrtrd
      sylc simpll anass1rs fsumle eqtr3d eqeltrrd 0re a1i absge0d fsumge0 eqtrd
      absidd breqtrrd simpllr rpred lelttr syl3anc mpand ralrimdva reximdva mpd
      anassrs ulmcau ) AUEUFZEGUGZCUHUIUJSBUKZUAUKZUWDUIZUIZUWEUBUKZUWDUIZUIZUL
      UMZUNUIZUCUKZUOUPZBCUQZUAUWIURUIZUQZUBJUSZUCUTUQZAUWFUEFGUGZUIZUWIUXAUIZU
      LUMZUNUIZUWNUOUPZUAUWQUQZUBJUSZUCUTUQZUWTAGVASZUXAVBUJSUXILRUCUBUAUXAGJKV
      CVDAUXHUWSUCUTAUWNUTSZVEZUXGUWRUBJUXLUWIJSZVEUXFUWPUAUWQUXLUXMUWFUWQSZUXF
      UWPVFUXLUXMUXNVEZVEZUXFUWOBCUXPUWECSZVEZUWMUXEVGUPZUXFUWOUXRUWMUWIVHUEUMZ
      UWFVIUMZUWEDUKZEUIZUIZUNUIZDVJZUXEUXRUWLUXRUWHUWKUXPCTUWEUWGUXPUWGTCVKUMZ
      SZCTUWGVLUXPJUYGUWFUWDAJUYGUWDVLZUXKUXOAUWDJVMZUYHUAJUQUYIAUWDGURUIZVMZUY
      JAUXJUYLLUWCEGVNVOJUYKUWDKVPVQAUYHUAJAUWFJSZVEZUWGBCUWFUEUDJUWEUDUKZEUIZU
      IZVRZGUGZUIZVRZUYGUYNDBCUEEUYRGUWFWEACWESZUYMACHSVUBMCHVSVOVTZUYNUWFJUYKA
      UYMWAKWBUYNUYBGUWFVIUMZSZVEZUYCBCUYDVRBCUYBUYRUIZVRVUFBCTUYCVUFUYCUYGSZCT
      UYCVLZUYNJUYGEVLZUYBJSZVUHVUEAVUJUYMNVTVUEUYBUYKJUYBGUWFWFKWCZJUYGUYBEWDZ
      WGUYCTCWHZVOWIVUFBCVUGUYDVUFVUKVUGUYDWJZVUEVUKUYNVULWKUDUYBUYQUYDJUYRUDDX
      HUWEUYPUYCUYOUYBEWLWMUYRWNZUWEUYCWOWPZVOWQWRWSZUYNVUAUYGSZCTVUAVLZUYNBCUY
      TTVUAAUXQUYMUYTTSAUXQVEZJTUWFUYSVVAUAUYRGJKAUXJUXQLVTVVAJTUWFUYRVVAUDJUYQ
      TUYRAUYOJSZUXQUYQTSAVVBVEZCTUWEUYPVVCUYPUYGSCTUYPVLAJUYGUYOENWTUYPTCWHVOW
      TXAVUPXBWTXCWTXAVUAWNZXBUYNTWESVUBVUSVUTXDXIVUCTCVUAWEWEXEXFXGXJXKUAJUYGU
      WDXLXMZXNZUXOUYMUXLGUWFUWIJKXOZWKZXPUWGTCWHVOWTUXPCTUWEUWJUXPUWJUYGSCTUWJ
      VLUXPJUYGUWIUWDVVFUXLUXMUXNXQZXPUWJTCWHVOWTXRXSZUXRUYAUYEDUXRUXTUWFXTZUXR
      UYBUYASZVEZUYDUXRVVLVUEUYDTSZUXPVVLVUEUXQUXPUYAVUDUYBUXPGUWIVIUMZUYAYSZUY
      AVUDUYAVVOYAUXPUWIVUDSZVUDVVPWJZUXPUWIUYKSZUXNVVQUXPUWIJUYKVVIKWBZUXLUXMU
      XNUUAUWIGUWFUUBXMUWIGUWFUUCVOZUUDUUEZYBZUXPVUEUXQVVNUXPVUEVEZCTUWEUYCVWDV
      UHVUIUXPVUJVUKVUHVUEAVUJUXKUXONXNZVULVUMWGVUNVOWTXAZYCZXSZUUFUXPUXEYDSZUX
      QUXPUXDUXPUXDUXPUXBUXCUXPJYDUWFUXAAJYDUXAVLUXKUXOADFGJKLPUUIXNZVVHXPUXPJY
      DUWIUXAVWJVVIXPUUGZYEXSVTZUXRUWMUYAUYDDVJZUNUIUYFVGUXRUWLVWMUNUXRUWLUYTUW
      IUYSUIZULUMVUDUYDDVJZVVOUYDDVJZULUMZVWMUXRUWHUYTUWKVWNULUXPUXQUWHUWEVUAUI
      ZUYTUXPUWEUWGVUAAUXOUWGVUAWJZUXKUXOAUYMVWSVVGVURUUJYBWMUXQUYTWESVWRUYTWJU
      WFUYSWOBCUYTWEVUAVVDYFYIYGUXPUXQUWKUWEBCVWNVRZUIZVWNUXPUWEUWJVWTUXPVWSUAJ
      UQZUXMUWJVWTWJZAVXBUXKUXOAVWSUAJVURXKXNVVIVWSVXCUAUWIJUAUBXHZUWGUWJVUAVWT
      UWFUWIUWDWLVXDBCUYTVWNUWFUWIUYSWLWQUUHUUKUUTWMUXQVWNWESVXAVWNWJUWIUYSWOBC
      VWNWEVWTVWTWNYFYIYGYHUXRVWOUYTVWPVWNULUXRUYDDUYRGUWFUXRVUEVEVUKVUOVUEVUKU
      XRVULWKVUQVOUXRUWFJUYKUXPUYMUXQVVHVTKWBVWFYJUXRUYDDUYRGUWIUXRUYBVVOSZVEVU
      KVUOVXEVUKUXRVXEUYBUYKJUYBGUWIWFKWCZWKVUQVOUXRUWIJUYKUXPUXMUXQVVIVTKWBUXP
      VXEUXQVVNUXPVXEVEZCTUWEUYCVXGVUHVUIUXPVUJVUKVUHVXEVWEVXFVUMWGVUNVOWTXAZYJ
      YHUXRVWQVWMWJVWPVWMUEUMZVWOWJUXRVWOVXIUXRVVOUYAUYDVUDDUXPVVOUYAUULUUMWJZU
      XQUXPUWIUXTUOUPVXJUXPUWIUXPVVSUWIYDSVVTGUWIUUNVOUUOGUWIUXTUWFUUPVOZVTUXPV
      VRUXQVWAVTUXRGUWFXTZVWFYKYLUXRVWOVWPVWMUXRVUDUYDDVXLVWFYMUXRVVOUYDDUXRGUW
      IXTVXHYMUXRUYAUYDDVVKVWGYMYNXGUUQYOUXRUYAUYDDVVKVWGUURUUSUXRUYFUYAUYBFUIZ
      DVJZUXEVGUXRUYAUYEVXMDVVKVWHUXPVVLVXMYDSZUXQUXPVVLVUEVXOVWBUXPAVUKVXOVUEA
      UXKUXOUVAZVULPWGZYCYBZUXRVVLVUKUYEVXMVGUPZVVMVUEVUKVWCVULVOUXPVUKUXQVXSUX
      LVUKUXQVEZVXSUXOAVXTVXSUXKQYBYBUVBYCZUVCUXRUXEVXNUNUIZVXNUXPUXEVYBWJUXQUX
      PUXDVXNUNUXPVUDVXMDVJZVVOVXMDVJZULUMZUXDVXNUXPVYCUXBVYDUXCULUXPVXMDFGUWFV
      WDVXMYPUXPUWFJUYKVVHKWBVWDVXMVXQYEZYJUXPVXMDFGUWIVXGVXMYPVVTVXGVXMUXPAVUK
      VXOVXEVXPVXFPWGYEZYJYHUXPVYEVXNWJVYDVXNUEUMZVYCWJUXPVYCVYHUXPVVOUYAVXMVUD
      DVXKVWAUXPGUWFXTZVYFYKYLUXPVYCVYDVXNUXPVUDVXMDVYIVYFYMUXPVVOVXMDUXPGUWIXT
      VYGYMUXPUYAVXMDUXPUXTUWFXTUXPVVLVUEVXMTSVWBVYFYCYMYNXGUVDZYOVTUXRVXNUXPVX
      NYDSUXQUXPUXDVXNYDVYJVWKUVEVTUXRUYAVXMDVVKVXRVVMYTUYEVXMYTYDSVVMUVFUVGVWH
      VXRVVMUYDVWGUVHVYAYQUVIUVKUVJUVLYQUXRUWMYDSVWIUWNYDSUXSUXFVEUWOVFVVJVWLUX
      RUWNAUXKUXOUXQUVMUVNUWMUXEUWNUVOUVPUVQUVRUWAYRUVSYRUVTAUCBCUBUAUWDGHJKLMV
      VEUWBXG $.

    mtest.t $e |- ( ph -> seq N ( oF + , F ) ( ~~>u ` S ) T ) $.
    $( Given the hypotheses of the Weierstrass M-test, the convergent function
       of the sequence is uniformly bounded.  (Contributed by Mario Carneiro,
       9-Jul-2017.) $)
    mtestbdd $p |- ( ph -> E. x e. RR A. z e. S ( abs ` ( T ` z ) ) <_ x ) $=
      ( vm vy vn vj cv caddc cseq cfv cabs cle wbr wral cr wrex cz wcel cli cdm
      cc wa recnd serf ffvelrnda ralrimiva climbdd syl3anc cof adantr co wf wfn
      cmap culm cuz seqfn syl fneq2i sylibr ulmf2 syl2anc simplrl cfz cmpt wceq
      csu weq fveq2 mpteq2dv seqeq3d fveq1d eqid fvmpt adantl ad3antrrr feqmptd
      fvex elmapi mpteq2dva eqtrd simplr syl6eleq elfzuz syl6eleqr ssriv anasss
      wss a1i seqof2 ffvelrnd fmptd sylan2 eqeltrrd fsumser fveq2d fzfid fsumcl
      3eqtr4d abscld fsumrecl fsumabs simp-4l fsumle leabsd eqidd simprr breq1d
      syl12anc rspccva sylan eqbrtrd letrd ralbidv rspcev ulmbdd rexlimddv
      breq2 ) AUBUFZUGHIUHZUIZUJUIZUCUFZUKULZUBLUMZCUFZEUIUJUIBUFZUKULCDUMBUNUO
      UCUNAIUPUQZYSURUSUQYTUTUQZUBLUMUUDUCUNUONTAUUHUBLALUTYRYSAFHILMNAFUFZLUQZ
      VAUUIHUIZRVBZVCVDVEUCUBYSILMVFVGAUUBUNUQZUUDVAZVAZBCDUDUGVHZGIUHZEILMAUUG
      UUNNVIALUTDVMVJZUUQVKZUUNAUUQLVLZUUQEDVNUIULZUUSAUUQIVOUIZVLZUUTAUUGUVCNU
      UPGIVPVQLUVBUUQMVRVSUADUUQELVTWAVIUUOUDUFZLUQZVAZUUMUUEUVDUUQUIZUIZUJUIZU
      UBUKULZCDUMZUVIUUFUKULZCDUMZBUNUOAUUMUUDUVEWBZUVFUVJCDUVFUUEDUQZVAZUVIIUV
      DWCVJZUUEUUIGUIZUIZFWFZUJUIZUUBUKUVPUVHUVTUJUVPUUEBDUVDUGUELUUFUEUFZGUIZU
      IZWDZIUHZUIZWDZUIZUVDUGUELUUEUWCUIZWDZIUHZUIZUVHUVTUVOUWIUWMWEUVFBUUEUWGU
      WMDUWHBCWGZUVDUWFUWLUWNUWEUWKUGIUWNUELUWDUWJUUFUUEUWCWHWIWJWKUWHWLUVDUWLW
      QWMWNUVPUUEUVGUWHUVPUVGUVDUUPUELBDUWDWDZWDZIUHZUIUWHUVPUVDUUQUWQUVPGUWPUU
      PIUVPGUELUWCWDUWPUVPUELUURGALUURGVKUUNUVEUVOPWOZWPUVPUELUWCUWOUVPUWBLUQZV
      AZBDUTUWCUWTUWCUURUQDUTUWCVKUVPLUURUWBGUWRVDUWCUTDWRVQZWPWSWTWJWKUVPUEBDL
      UGIUVDJUTUWDADJUQUUNUVEUVOOWOUVPUVDLUVBUUOUVEUVOXAMXBZUVQLXGUVPFUVQLUUIUV
      QUQZUUIUVBLUUIIUVDXCMXDZXEXHUVPUWSUUFDUQUWDUTUQUWTDUTUUFUWCUXAVDXFXIWTWKU
      VPUVSFUWKIUVDUVPUXCVAZUUJUUIUWKUIZUVSWEUXCUUJUVPUXDWNZUEUUIUWJUVSLUWKUEFW
      GUUEUWCUVRUWBUUIGWHWKUWKWLZUUEUVRWQWMVQZUXBUXEUXFUVSUTUXIUXCUVPUUJUXFUTUQ
      UXDUVPLUTUUIUWKUVPUELUWJUTUWKUWTDUTUUEUWCUXAUVFUVOUWSXAXJUXHXKVDXLXMZXNXR
      XOUVPUWAUVQUVSUJUIZFWFZUUBUVPUVTUVPUVQUVSFUVPIUVDXPZUXJXQXSUVPUVQUXKFUXMU
      XEUVSUXJXSZXTZUVFUUMUVOUVNVIZUVPUVQUVSFUXMUXJYAUVPUXLUVQUUKFWFZUUBUXOUVPU
      VQUUKFUXMUXEAUUJUUKUNUQAUUNUVEUVOUXCYBZUXGRWAZXTZUXPUVPUVQUXKUUKFUXMUXNUX
      SUXEAUUJUVOUXKUUKUKULUXRUXGUVFUVOUXCXASYHYCUVPUXQUXQUJUIZUUBUXTUVPUXQUVPU
      XQUXTVBXSUXPUVPUXQUXTYDUVPUYAUVDYSUIZUJUIZUUBUKUVPUXQUYBUJUVPUUKFHIUVDUXE
      UUKYEUXBUXEAUUJUUKUTUQUXRUXGUULWAXNXOUVFUYCUUBUKULZUVOUUOUUDUVEUYDAUUMUUD
      YFUUCUYDUBUVDLUBUDWGZUUAUYCUUBUKUYEYTUYBUJYRUVDYSWHXOYGYIYJVIYKYLYLYLYKVE
      UVMUVKBUUBUNBUCWGUVLUVJCDUUFUUBUVIUKYQYMYNWAAUVAUUNUAVIYOYP $.
  $}

  ${
    $d k n z F $.  $d n z G $.  $d k n z ph $.  $d k n z S $.  $d k n z Z $.
    $d n M $.
    mbfulm.z $e |- Z = ( ZZ>= ` M ) $.
    mbfulm.m $e |- ( ph -> M e. ZZ ) $.
    mbfulm.f $e |- ( ph -> F : Z --> MblFn ) $.
    mbfulm.u $e |- ( ph -> F ( ~~>u ` S ) G ) $.
    $( A uniform limit of measurable functions is measurable.  (This is just a
       corollary of the fact that a pointwise limit of measurable functions is
       measurable, see ~ mbflim .)  (Contributed by Mario Carneiro,
       18-Mar-2015.) $)
    mbfulm $p |- ( ph -> G e. MblFn ) $=
      ( vz vk cv cfv cmpt cmbf cc wf syl wcel culm wbr ulmcl feqmptd cvv adantr
      vn wa cz cmap wfn ffn ulmf2 syl2anc simpr cuz fvex eqeltri mptex a1i wceq
      co fveq2 fveq1d eqid fvmpt eqcomd adantl ulmclm ffvelrnda elmapi eqeltrrd
      anasss mbflim eqeltrd ) ADKBKMZDNZOPAKBQDACDBUANUBZBQDRJBCDUCSUDAKBVPLMZC
      NZNZVQLEQFGHAVPBTZUHZVPBUGCDLFWAOZEUEFGAEUITWBHUFAFQBUJVBZCRZWBACFUKZVRWF
      AFPCRWGIFPCULSJBCDFUMUNZUFAWBUOWDUETWCLFWAFEUPNUEGEUPUQURUSUTUGMZFTZVPWIC
      NZNZWIWDNZVAWCWJWMWLLWIWAWLFWDVSWIVAVPVTWKVSWICVCVDWDVEVPWKUQVFVGVHAVRWBJ
      UFVIAVSFTZUHZVTKBWAOPWOKBQVTWOVTWETBQVTRAFWEVSCWHVJVTQBVKSZUDAFPVSCIVJVLA
      WNWBWAQTWOBQVPVTWPVJVMVNVO $.
  $}

  ${
    $d j k n r x z F $.  $d j k n r x z G $.  $d j k n r x z ph $.
    $d j k n x z M $.  $d j k n r x z S $.  $d j k n r x z Z $.
    itgulm.z $e |- Z = ( ZZ>= ` M ) $.
    itgulm.m $e |- ( ph -> M e. ZZ ) $.
    itgulm.f $e |- ( ph -> F : Z --> L^1 ) $.
    itgulm.u $e |- ( ph -> F ( ~~>u ` S ) G ) $.
    itgulm.s $e |- ( ph -> ( vol ` S ) e. RR ) $.
    $( A uniform limit of integrable functions is integrable.  (Contributed by
       Mario Carneiro, 3-Mar-2015.) $)
    iblulm $p |- ( ph -> G e. L^1 ) $=
      ( vx vz cfv c1 cibl wcel cc wa cmbf vk vj vr cv cmin co cabs clt wbr wral
      cuz wrex wfn culm cmap wf ffn syl ulmf2 syl2anc eqidd crp 1rp a1i r19.2uz
      ulmi cmpt adantr feqmptd ffvelrnda elmapi adantrr nncand mpteq2dva eqtr4d
      ulmcl eqeltrrd subcld cdm cvol cr cle cof cvv ulmscl offval2 iblmbf ssriv
      wss fss sylancl mbfulm mbfsub wceq fmptd fdm fveq2d eqeltrd 1re wi abscld
      eqid ltle fveq2 oveq12d ovex fvmpt adantl breq1d sylibrd ralimdva raleqdv
      impr mpbird breq2 ralbidv rspcev sylancr bddibl syl3anc iblsub rexlimddv
      ) ALUDZUAUDZCNZNZYCDNZUEUFZUGNZOUHUIZLBUJZDPQUAFAYKUAUBUDUKNUJUBFULYKUAFU
      LALYGYFOBUBUACDEFGHACFUMZCDBUNNUIZFRBUOUFZCUPAFPCUPZYLIFPCUQURJBCDFUSUTZA
      YDFQZYCBQZSSYFVAAYRSYGVAJOVBQAVCVDVFYKUBUAEFGVEURAYQYKSZSZDMBMUDZYENZUUBU
      UADNZUEUFZUEUFZVGZPYTDMBUUCVGUUFYTMBRDABRDUPZYSAYMUUGJBCDVPURZVHZVIZYTMBU
      UEUUCYTUUABQSZUUBUUCYTBRUUAYEAYQBRYEUPZYKAYQSZYEYNQUULAFYNYDCYPVJYERBVKUR
      ZVLZVJZYTBRUUADUUIVJZVMVNVOYTMBUUBUUDRUUPYTYEMBUUBVGPYTMBRYEUUOVIZAYQYEPQ
      ZYKAFPYDCIVJVLZVQUUKUUBUUCUUPUUQVRZYTMBUUDVGZTQUVBVSZVTNZWAQYCUVBNZUGNZUC
      UDZWBUIZLUVCUJZUCWAULZUVBPQYTYEDUEWCUFUVBTYTMBUUBUUCUEYEDWDRRABWDQZYSAYMU
      VKJBCDWEURVHUUPUUQUURUUJWFYTYEDYTUUSYETQUUTYEWGURADTQYSABCDEFGHAYOPTWIFTC
      UPILPTYCWGWHFPTCWJWKJWLVHWMVQYTUVDBVTNZWAYTUVCBVTYTBRUVBUPUVCBWNYTMBUUDRU
      VBUVAUVBXBZWOBRUVBWPURZWQAUVLWAQYSKVHWRYTOWAQZUVFOWBUIZLUVCUJZUVJWSYTUVQU
      VPLBUJZAYQYKUVRUUMYJUVPLBUUMYRSZYJYIOWBUIZUVPUVSYIWAQUVOYJUVTWTUVSYHUVSYF
      YGUUMBRYCYEUUNVJUUMBRYCDAUUGYQUUHVHVJVRXAWSYIOXCWKUVSUVFYIOWBUVSUVEYHUGYR
      UVEYHWNUUMMYCUUDYHBUVBUUAYCWNUUBYFUUCYGUEUUAYCYEXDUUAYCDXDXEUVMYFYGUEXFXG
      XHWQXIXJXKXMYTUVPLUVCBUVNXLXNUVIUVQUCOWAUVGOWNUVHUVPLUVCUVGOUVFWBXOXPXQXR
      UCLUVBXSXTYAWRYB $.

    $( A uniform limit of integrals of integrable functions converges to the
       integral of the limit function.  (Contributed by Mario Carneiro,
       18-Mar-2015.) $)
    itgulm $p |- ( ph -> ( k e. Z |-> S. S ( ( F ` k ) ` x ) _d x )
        ~~> S. S ( G ` x ) _d x ) $=
      ( cfv wbr co clt wcel wa cc vn vr vj vz citg cmpt cli cmin cabs wral wrex
      cv cuz crp cvol c1 caddc cdiv cz adantr cmap wf wfn culm cibl ffn syl2anc
      syl ulmf2 eqidd simpr cr cc0 cle covol cdm wss wceq ulmcl fdm 3syl iblulm
      cmbf iblmbf mbfdm eqeltrrd ovolge0 mblvol breqtrrd ge0p1rpd rpdivcld ulmi
      mblss uztrn2 ffvelrnda elmapi adantllr adantlrr feqmptd ad2ant2r ad2antrr
      wi adantlr itgsub fveq2d subcld iblsub itgcl abscld itgrecl rpre ad2antlr
      iblabs itgabs rpred remulcld csn cxp fconstmpt iblconst syl3anc syl5eqelr
      cmul rpcnd simprr fveq2 oveq12d breq1d rspccva sylan ltled itgle itgconst
      weq breqtrd recnd mpbird eqbrtrrd lelttrd cvv rpne0d ltp1d peano2re rpgt0
      div23d wb ltmul2 syl112anc mpbid ltdivmul2d expr sylan2 ralimdva reximdva
      anassrs mpd ralrimiva fvex eqeltri mptex fveq1d itgeq2dv eqid itgex fvmpt
      a1i adantl clim2c ) ADHBCBULZDULZENZNZUEZUFZBCUVIFNZUEZUGOBCUVIUAULZENZNZ
      UEZUVPUHPZUINZUBULZQOZUAUCULZUMNZUJZUCHUKZUBUNUJAUWHUBUNAUWCUNRZSZUDULZUV
      RNZUWKFNZUHPZUINZUWCCUONZUPUQPZURPZQOZUDCUJZUAUWFUJZUCHUKUWHUWJUDUWMUWLUW
      RCUCUAEFGHIAGUSRUWIJUTAHTCVAPZEVBZUWIAEHVCZEFCVDNOZUXCAHVEEVBUXDKHVEEVFVH
      LCEFHVIVGZUTUWJUVQHRZUWKCRZSSUWLVJUWJUXHSUWMVJAUXEUWILUTUWJUWCUWQAUWIVKUW
      JUWPAUWPVLRZUWIMUTAVMUWPVNOUWIAVMCVONZUWPVNACUOVPZRZCVLVQVMUXJVNOAFVPZCUX
      KAUXECTFVBZUXMCVRLCEFVSZCTFVTWAAFVERFWCRUXMUXKRACEFGHIJKLMWBZFWDFWEWAWFZC
      WMCWGWAAUXLUWPUXJVRUXQCWHVHWIUTWJZWKZWLUWJUXAUWGUCHUWJUWEHRZSUWTUWDUAUWFU
      WJUXTUVQUWFRZUWTUWDXBZUXTUYASUWJUXGUYBGUVQUWEHIWNUWJUXGUWTUWDUWJUXGUWTSZS
      ZBCUVSUVOUHPZUEZUINZUWBUWCQUYDUYFUWAUIUYDBCUVSUVOTUWJUXGUVICRZUVSTRZUWTAU
      XGUYHUYIUWIAUXGSZCTUVIUVRUYJUVRUXBRCTUVRVBAHUXBUVQEUXFWOUVRTCWPVHZWOZWQWR
      ZAUXGBCUVSUFZVERUWIUWTUYJUVRUYNVEUYJBCTUVRUYKWSAHVEUVQEKWOWFZWTZUWJUYHUVO
      TRZUYCAUYHUYQUWIACTUVIFAUXEUXNLUXOVHZWOZXCXCZABCUVOUFZVERUWIUYCAFVUAVEABC
      TFUYRWSUXPWFZXAZXDXEUYDUYGBCUYEUINZUEZUWCUYDUYFUYDBCUYETUYDUYHSZUVSUVOUYM
      UYTXFZUYDBCUVSUVOTUYMUYPUYTVUCXGZXHXIUYDBCVUDVUFUYEVUGXIZUYDBCUYETVUGVUHX
      MZXJZUWIUWCVLRZAUYCUWCXKXLZUYDBCUYETVUGVUHXNUYDVUEUWRUWPYCPZUWCVUKUYDUWRU
      WPUYDUWRUWJUWRUNRUYCUXSUTZXOZAUXIUWIUYCMXAZXPVUMUYDVUEBCUWRUEZVUNVNUYDBCV
      UDUWRVUJUYDBCUWRUFCUWRXQXRZVEBCUWRXSUYDUXLUXIUWRTRZVUSVERAUXLUWIUYCUXQXAZ
      VUQUYDUWRVUOYDZCUWRXTYAYBVUIUYDUWRVLRUYHVUPUTZVUFVUDUWRVUIVVCUYDUWTUYHVUD
      UWRQOZUWJUXGUWTYEUWSVVDUDUVICUDBYNZUWOVUDUWRQVVEUWNUYEUIVVEUWLUVSUWMUVOUH
      UWKUVIUVRYFUWKUVIFYFYGXEYHYIYJYKYLUYDUXLUXIVUTVURVUNVRVVAVUQVVBBCUWRYMYAY
      OUYDUWCUWPYCPZUWQURPZVUNUWCQUYDUWCUWPUWQUYDUWCVUMYPUYDUWPVUQYPUYDUWQUWJUW
      QUNRUYCUXRUTZYDUYDUWQVVHUUAUUEUYDVVGUWCQOVVFUWCUWQYCPQOZUYDUWPUWQQOZVVIUY
      DUWPVUQUUBUYDUXIUWQVLRZVULVMUWCQOZVVJVVIUUFVUQUYDUXIVVKVUQUWPUUCVHVUMUWIV
      VLAUYCUWCUUDXLUWPUWQUWCUUGUUHUUIUYDVVFUWCUWQUYDUWCUWPVUMVUQXPVUMVVHUUJYQY
      RYSYSYRUUKUULUUOUUMUUNUUPUUQAUBUVPUVTUCUAUVNGYTHIJUVNYTRADHUVMHGUMNYTIGUM
      UURUUSUUTUVFUXGUVQUVNNUVTVRADUVQUVMUVTHUVNDUAYNZBCUVLUVSVVMUVLUVSVRUYHVVM
      UVIUVKUVRUVJUVQEYFUVAUTUVBUVNUVCBCUVSUVDUVEUVGABCUVOTUYSVUBXHUYJBCUVSTUYL
      UYOXHUVHYQ $.
  $}

  ${
    $d n y z A $.  $d k n x z ph $.  $d k n x y z S $.  $d k n x y z Z $.
    $d n y z B $.  $d n z M $.
    itgulm2.z $e |- Z = ( ZZ>= ` M ) $.
    itgulm2.m $e |- ( ph -> M e. ZZ ) $.
    itgulm2.c $e |- ( ( ph /\ k e. Z ) ->
      ( x e. S |-> A ) e. ( S -cn-> CC ) ) $.
    itgulm2.l $e |- ( ( ph /\ k e. Z ) -> ( x e. S |-> A ) e. L^1 ) $.
    itgulm2.u $e |- ( ph -> ( k e. Z |-> ( x e. S |-> A ) )
      ( ~~>u ` S ) ( x e. S |-> B ) ) $.
    itgulm2.s $e |- ( ph -> ( vol ` S ) e. RR ) $.
    $( A uniform limit of integrals of integrable functions converges to the
       integral of the limit function.  (Contributed by Mario Carneiro,
       18-Mar-2015.) $)
    itgulm2 $p |- ( ph -> ( ( x e. S |-> B ) e. L^1 /\
      ( k e. Z |-> S. S A _d x ) ~~> S. S B _d x ) ) $=
      ( vz wcel citg cfv nfcv cc vn cmpt cibl cli eqid fmptd iblulm cv nffvmpt1
      wbr itgulm nffv nfitg wceq fveq2 nfmpt1 nfmpt cbvitg fveq1d adantr syl5eq
      itgeq2dv cbvmpt wa simplr culm ulmscl mptexg 3syl ad2antrr fvmpt2 syl2anc
      cvv simpr wf wral cmap wfn ralrimivw fnmpt syl ulmf2 fmpt sylibr r19.21bi
      co elmapi eqtrd mpteq2dva ulmcl 3brtr3d jca ) ABEDUBZUCPFHBECQZUBZBEDQZUD
      UJAEFHBECUBZUBZWMGHIJAFHWQUCWRLWRUEZUFZMNUGAUAHOEOUHZUAUHZWRRZRZQZUBZOEXA
      WMRZQZWOWPUDAOEUAWRWMGHIJWTMNUKAXFFHBEBUHZFUHZWRRZRZQZUBWOUAFHXEXMOFEXDFE
      SFXAXCFHWQXBUIFXASULUMUAXMSXBXJUNZXEBEXIXCRZQXMOBEXDXOXAXIXCUOBXAXCBXBWRB
      FHWQBHSBECUPUQBXBSULBXASULOXOSURXNBEXOXLXNXOXLUNXIEPZXNXIXCXKXBXJWRUOUSUT
      VBVAVCAFHXMWNAXJHPZVDZBEXLCXRXPVDZXLXIWQRZCXSXIXKWQXSXQWQVMPZXKWQUNAXQXPV
      EAYAXQXPAWRWMEVFRUJZEVMPYAMEWRWMVGBECVMVHVIZVJFHWQVMWRWSVKVLUSXSXPCTPZXTC
      UNXRXPVNXRYDBEXRETWQVOZYDBEVPXRWQTEVQWFZPZYEAYGFHAHYFWRVOZYGFHVPAWRHVRZYB
      YHAYAFHVPYIAYAFHYCVSFHWQWRVMWSVTWAMEWRWMHWBVLFHYFWQWRWSWCWDWEWQTEWGWABETC
      WQWQUEZWCWDWEBECTWQYJVKVLWHVBWIVAAXHBEXIWMRZQWPOBEXGYKXAXIWMUOBEDXAUIOYKS
      URABEYKDAXPVDXPDTPZYKDUNAXPVNAYLBEAETWMVOZYLBEVPAYBYMMEWRWMWJWABETDWMWMUE
      ZWCWDWEBEDTWMYNVKVLVBVAWKWL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                               Power series
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d i k m n s x y A $.  $d j m s H $.  $d i j k m s ph $.  $d i k m s y X $.
    $d j k m r s y G $.  $d n y N $.  $d k y R $.  $d i j k m Y $.
    pser.g $e |- G = ( x e. CC |-> ( n e. NN0 |->
      ( ( A ` n ) x. ( x ^ n ) ) ) ) $.
    $( Value of the function ` G ` that gives the sequence of monomials of a
       power series.  (Contributed by Mario Carneiro, 26-Feb-2015.) $)
    pserval $p |- ( X e. CC ->
      ( G ` X ) = ( m e. NN0 |-> ( ( A ` m ) x. ( X ^ m ) ) ) ) $=
      ( vy cn0 cv cfv cexp co cmul cmpt cc wceq oveq1 oveq2d mpteq2dv oveq12d
      fveq2 oveq2 cbvmptv syl5eq eqtri nn0ex mptex fvmpt ) HFCICJZBKZHJZUJLMZNM
      ZOZCIUKFUJLMZNMZOPEULFQZCIUNUQURUMUPUKNULFUJLRSTEAPDIDJZBKZAJZUSLMZNMZOZO
      HPUOOGAHPVDUOVAULQZVDCIUKVAUJLMZNMZOUODCIVCVGUSUJQUTUKVBVFNUSUJBUBUSUJVAL
      UCUAUDVECIVGUNVEVFUMUKNVAULUJLRSTUEUDUFCIUQUGUHUI $.

    $( Value of the function ` G ` that gives the sequence of monomials of a
       power series.  (Contributed by Mario Carneiro, 26-Feb-2015.) $)
    pserval2 $p |- ( ( X e. CC /\ N e. NN0 ) ->
      ( ( G ` X ) ` N ) = ( ( A ` N ) x. ( X ^ N ) ) ) $=
      ( vy cc wcel cn0 cfv cv cexp co cmul cmpt pserval fveq1d wceq fveq2 oveq2
      oveq12d eqid ovex fvmpt sylan9eq ) FIJZEKJEFDLZLEHKHMZBLZFUJNOZPOZQZLEBLZ
      FENOZPOZUHEUIUNABHCDFGRSHEUMUQKUNUJETUKUOULUPPUJEBUAUJEFNUBUCUNUDUOUPPUEU
      FUG $.

    radcnv.a $e |- ( ph -> A : NN0 --> CC ) $.
    ${
      psergf.x $e |- ( ph -> X e. CC ) $.
      $( The sequence of terms in the infinite sequence defining a power series
         for fixed ` X ` .  (Contributed by Mario Carneiro, 26-Feb-2015.) $)
      psergf $p |- ( ph -> ( G ` X ) : NN0 --> CC ) $=
        ( vm cn0 cc wf wcel cfv wa cv cexp co cmul cmpt ffvelrn adantlr adantll
        expcl mulcld eqid fmptd wceq pserval adantl feq1d mpbird syl2anc ) AKLC
        MZFLNZKLFEOZMZHIUOUPPZURKLJKJQZCOZFUTRSZTSZUAZMUSJKVCLVDUSUTKNZPVAVBUOV
        EVALNUPKLUTCUBUCUPVEVBLNUOFUTUEUDUFVDUGUHUSKLUQVDUPUQVDUIUOBCJDEFGUJUKU
        LUMUN $.

      radcnvlem2.y $e |- ( ph -> Y e. CC ) $.
      radcnvlem2.a $e |- ( ph -> ( abs ` X ) < ( abs ` Y ) ) $.
      radcnvlem2.c $e |- ( ph ->
        seq 0 ( + , ( G ` Y ) ) e. dom ~~> ) $.
      ${
        radcnvlem1.h $e |- H = ( m e. NN0 |->
          ( m x. ( abs ` ( ( G ` X ) ` m ) ) ) ) $.
        $( Lemma for ~ radcnvlt1 , ~ radcnvle .  If ` X ` is a point closer to
           zero than ` Y ` and the power series converges at ` Y ` , then it
           converges absolutely at ` X ` , even if the terms in the sequence
           are multiplied by ` n ` .  (Contributed by Mario Carneiro,
           31-Mar-2015.) $)
        radcnvlem1 $p |- ( ph -> seq 0 ( + , H ) e. dom ~~> ) $=
          ( cfv co cmul wcel vk vj vi cv cexp cabs c1 clt wbr cuz wral cc0 cseq
          caddc cli cdm cn0 nn0uz cz 0z a1i crp 1rp cc wceq pserval2 sylan fvex
          cvv psergf ffvelrnda serf0 climi0 wa cdiv cmpt simprl cr nn0re adantl
          adantr wne 0re absge0d lelttrd gt0ne0d redivcld reexpcl remulcld eqid
          abscld fmptd wf recnd cle divge0 syl22anc absidd mulid1d breqtrrd 1re
          ltdivmul syl112anc mpbird eqbrtrd geomulcvg syl2anc ad2antrr ffvelrnd
          wb eluznn0 reexpcld nn0red nn0ge0d expcld mulcld expge0d simprr fveq2
          weq oveq2 oveq12d fveq2d breq1d rspccva ltle sylancl lemul1ad absmuld
          wi mul32d absexpd oveq2d 3eqtr3d mulid2d 3brtr3d eluzelz 3brtr4d ovex
          mpd expgt0 syl3anc lemuldiv mpbid expdivd lemul2ad mulge0d fvmpt2 syl
          id fvmpt cvgcmpce rexlimddv ) AUAUDZCQZIUUNUERZSRZUFQZUGUHUIZUAUBUDZU
          JQZUKZUNGULUMUOUPZTUBUQAUUQUGUBUAIFQZULUQURULUSTAUTVAZUGVBTAVCVAAIVDT
          ZUUNUQTUUNUVDQUUQVEMBCEFUUNIJVFVGAUAUVDULVIUQURUVEUVDVITAIFVHVAOAUQVD
          UUNUVDABCEFIJKMVJVKVLVMAUUTUQTZUVBVNZVNZUGDUCUQUCUDZHUFQZIUFQZVORZUVJ
          UERZSRZVPZGULUUTUQURAUVGUVBVQZUVIUQVRDUDZUVPUVIUCUQUVOVRUVPUVIUVJUQTZ
          VNUVJUVNUVSUVJVRTUVIUVJVSVTUVIUVMVRTZUVSUVNVRTUVIUVKUVLUVIHAHVDTZUVHL
          WAWKZUVIIAUVFUVHMWAWKZAUVLULWBZUVHAUVLAULUVKUVLULVRTAWCVAAHLWKZAIMWKZ
          AHLWDZNWEZWFZWAWGZUVMUVJWHVGWIUVPWJZWLVKUVIUVRUQTZVNUVRGQZUVIUQVRUVRG
          AUQVRGWMUVHADUQUVRUVRHFQZQZUFQZSRZVRGAUWLVNZUVRUWPUWLUVRVRTAUVRVSVTUW
          RUWOAUQVDUVRUWNABCEFHJKLVJZVKWKWIPWLWAVKWNAUNUVPULUMUVCTZUVHAUVMVDTUV
          MUFQZUGUHUIUWTAUVMAUVKUVLUWEUWFUWIWGZWNAUXAUVMUGUHAUVMUXBAUVKVRTZULUV
          KWOUIUVLVRTZULUVLUHUIZULUVMWOUIUWEUWGUWFUWHUVKUVLWPWQWRAUVMUGUHUIZUVK
          UVLUGSRZUHUIZAUVKUVLUXGUHNAUVLAUVLUWFWNWSWTAUXCUGVRTZUXDUXEUXFUXHXJUW
          EUXIAXAVAUWFUWHUVKUGUVLXBXCXDXEUVMUCUVPUWKXFXGWAUXIUVIXAVAUVIUVRUVATZ
          VNZUWQUFQZUGUVRUVMUVRUERZSRZSRZUWMUFQUGUVRUVPQZSRWOUXKUWQUXNUXLUXOWOU
          XKUWPUXMUVRUXKUWOUXKUQVDUVRUWNAUQVDUWNWMUVHUXJUWSXHUVIUVGUXJUWLUVQUVR
          UUTXKVGZXIZWKZUXKUVMUVRUVIUVTUXJUWJWAUXQXLZUXKUVRUXQXMZUXKUVRUXQXNZUX
          KUVRCQZHUVRUERZSRZUFQZUVKUVRUERZUVLUVRUERZVORZUWPUXMWOUXKUYFUYHSRZUYG
          WOUIZUYFUYIWOUIZUXKUYCIUVRUERZSRZUFQZUYGSRZUGUYGSRUYJUYGWOUXKUYOUGUYG
          UXKUYNUXKUYCUYMUXKUQVDUVRCAUQVDCWMUVHUXJKXHUXQXIZUXKIUVRAUVFUVHUXJMXH
          ZUXQXOZXPZWKZUXIUXKXAVAUXKUVKUVRUXKHAUWAUVHUXJLXHZWKZUXQXLZUXKUVKUVRV
          UCUXQUXKHVUBWDXQUXKUYOUGUHUIZUYOUGWOUIZUVIUVBUXJVUEAUVGUVBXRUUSVUEUAU
          VRUVAUADXTZUURUYOUGUHVUGUUQUYNUFVUGUUOUYCUUPUYMSUUNUVRCXSUUNUVRIUEYAY
          BYCYDYEVGUXKUYOVRTUXIVUEVUFYJVUAXAUYOUGYFYGYTYHUXKUYEUYMSRZUFQZUYFUYM
          UFQZSRUYPUYJUXKUYEUYMUXKUYCUYDUYQUXKHUVRVUBUXQXOZXPZUYSYIUXKUYNUYDSRZ
          UFQUYOUYDUFQZSRVUIUYPUXKUYNUYDUYTVUKYIUXKVUMVUHUFUXKUYCUYMUYDUYQUYSVU
          KYKYCUXKVUNUYGUYOSUXKHUVRVUBUXQYLYMYNUXKVUJUYHUYFSUXKIUVRUYRUXQYLYMYN
          UXKUYGUXKUYGVUDWNYOYPUXKUYFVRTUYGVRTUYHVRTULUYHUHUIZUYKUYLXJUXKUYEVUL
          WKVUDUXKUVLUVRUVIUXDUXJUWCWAZUXQXLUXKUXDUVRUSTZUXEVUOVUPUXJVUQUVIUUTU
          VRYQVTAUXEUVHUXJUWHXHUVLUVRUUAUUBUYFUYGUYHUUCXCUUDUXKUWOUYEUFUXKUWAUW
          LUWOUYEVEVUBUXQBCEFUVRHJVFXGYCUXKUVKUVLUVRUVIUVKVDTUXJUVIUVKUWBWNWAUV
          IUVLVDTUXJUVIUVLUWCWNWAAUWDUVHUXJUWIXHUXQUUEYRUUFUXKUWQUXKUVRUWPUYAUX
          SWIUXKUVRUWPUYAUXSUYBUXKUWOUXRWDUUGWRUXKUXNUXKUXNUXKUVRUXMUYAUXTWIWNY
          OYRUXKUWMUWQUFUXKUWLUWQVITUWMUWQVEUXQUVRUWPSYSDUQUWQVIGPUUHYGYCUXKUXP
          UXNUGSUXKUWLUXPUXNVEUXQUCUVRUVOUXNUQUVPUCDXTZUVJUVRUVNUXMSVURUUJUVJUV
          RUVMUEYAYBUWKUVRUXMSYSUUKUUIYMYRUULUUM $.
      $}

      $( Lemma for ~ radcnvlt1 , ~ radcnvle .  If ` X ` is a point closer to
         zero than ` Y ` and the power series converges at ` Y ` , then it
         converges absolutely at ` X ` .  (Contributed by Mario Carneiro,
         26-Feb-2015.) $)
      radcnvlem2 $p |- ( ph ->
        seq 0 ( + , ( abs o. ( G ` X ) ) ) e. dom ~~> ) $=
        ( c1 cn0 cfv cabs cmul wcel wceq vk vm cv co cmpt ccom cc0 nn0uz a1i wa
        1nn0 cr id fveq2 fveq2d oveq12d eqid ovex fvmpt adantl psergf ffvelrnda
        nn0re cc abscld remulcld eqeltrd fvco3 sylan cbvmptv radcnvlem1 1re cuz
        wf recnd cle cn elnnuz sylbir sylan2 wbr absge0d eluzle lemul1ad absidm
        nnnn0 syl mulid2d 3eqtr4d oveq2d eqtrd 3brtr4d cvgcmpce ) ANUAUBOUBUCZW
        NFEPZPZQPZRUDZUEZQWOUFZUGNOUHNOSAUKUIAUAUCZOSZUJZXAWSPZXAXAWOPZQPZRUDZU
        LXBXDXGTAUBXAWRXGOWSWNXATZWNXAWQXFRXHUMXHWPXEQWNXAWOUNUOUPZWSUQXAXFRURU
        SUTZXCXAXFXBXAULSZAXAVCUTZXCXEAOVDXAWOABCDEFHIJVAZVBZVEZVFZVGXCXAWTPZXF
        VDAOVDWOVNXBXQXFTXMOVDXAQWOVHVIZXCXFXOVOZVGABCUADEWSFGHIJKLMUBUAOWRXGXI
        VJVKNULSZAVLUIAXANVMPSZUJZNXFRUDZXGXQQPZNXDRUDZVPYBNXAXFXTYBVLUIYAAXBXK
        YAXAVQSXBXAVRXAWFVSZXLVTYAAXBXFULSYFXOVTYAAXBUGXFVPWAYFXCXEXNWBVTYANXAV
        PWAANXAWCUTWDYAAXBYDYCTYFXCXFQPZXFYDYCXCXEVDSYGXFTXNXEWEWGXCXQXFQXRUOXC
        XFXSWHWIVTYAAXBYEXGTYFXCYENXGRUDXGXCXDXGNRXJWJXCXGXCXGXPVOWHWKVTWLWM $.

      $( Lemma for ~ radcnvlt1 , ~ radcnvle .  If ` X ` is a point closer to
         zero than ` Y ` and the power series converges at ` Y ` , then it
         converges at ` X ` .  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
      radcnvlem3 $p |- ( ph -> seq 0 ( + , ( G ` X ) ) e. dom ~~> ) $=
        ( vk cabs cfv cc0 cn0 wcel cc ccom nn0uz cz 0z a1i wf wceq psergf fvco3
        cv sylan ffvelrnda radcnvlem2 abscvgcvg ) ANOFEPZUAZUOQRUBQUCSAUDUEARTU
        OUFNUJZRSUQUPPUQUOPOPUGABCDEFHIJUHZRTUQOUOUIUKARTUQUOURULABCDEFGHIJKLMU
        MUN $.
    $}

    $( Zero is always a convergent point for any power series.  (Contributed by
       Mario Carneiro, 26-Feb-2015.) $)
    radcnv0 $p |- ( ph ->
      0 e. { r e. RR | seq 0 ( + , ( G ` r ) ) e. dom ~~> } ) $=
      ( vk cc0 cr wcel caddc cfv a1i cn0 co cmul wceq cc cseq cli cv crab nn0uz
      cdm 0re csn cz 0z cfn snfi 0nn0 snssd wa cif ifid cexp 0cn pserval2 sylan
      wn adantr cn wo simpr elnn0 sylib ord elsn syl6ibr con1d imp 0expd oveq2d
      mul01d 3eqtrd ifeq2da syl5eqr sselda psergf syldan fsumcvg3 fveq2 seqeq3d
      ffvelrnda eleq1d elrab sylanbrc ) AJKLZMJENZJUAZUBUFZLZJMFUCZENZJUAZWMLZF
      KUDLWJAUGOAJUHZIUCZWKNZIWKJPUEJUILAUJOWSUKLAJULOAJPJPLAUMOUNZAWTPLZUOZXAW
      TWSLZXAXAUPXEXAJUPXEXAUQXDXEXAJXAXDXEVBZUOZXAWTCNZJWTURQZRQZXHJRQJXDXAXJS
      ZXFAJTLZXCXKXLAUSOZBCDEWTJGUTVAVCXGXIJXHRXGWTXDXFWTVDLZXDXNXEXDXNVBWTJSZX
      EXDXNXOXDXCXNXOVEAXCVFWTVGVHVIIJVJVKVLVMVNVOXGXHXDXHTLXFAPTWTCHWFVCVPVQVR
      VSAXEXCXATLAWSPWTXBVTAPTWTWKABCDEJGHXMWAWFWBWCWRWNFJKWOJSZWQWLWMXPWPWKMJW
      OJEWDWEWGWHWI $.

    radcnv.r $e |- R =
      sup ( { r e. RR | seq 0 ( + , ( G ` r ) ) e. dom ~~> } , RR* , < ) $.
    $( The radius of convergence ` R ` of an infinite series is a nonnegative
       extended real number.  (Contributed by Mario Carneiro, 26-Feb-2015.) $)
    radcnvcl $p |- ( ph -> R e. ( 0 [,] +oo ) ) $=
      ( cxr wcel cc0 cle wbr cpnf cicc co caddc cr cv cfv cseq cli cdm crab clt
      csup wss ssrab2 ressxr supxrcl syl5eqel radcnv0 supxrub sylancr syl6breqr
      sstri mp1i pnfge syl w3a wb 0xr pnfxr elicc1 mp2an syl3anbrc ) ADKLZMDNOZ
      DPNOZDMPQRLZADSGUAFUBMUCUDUELZGTUFZKUGUHZKJVNKUIZVOKLAVNTKVMGTUJUKURZVNUL
      USUMZAMVODNAVPMVNLMVONOVQABCEFGHIUNVNMUOUPJUQAVIVKVRDUTVAMKLPKLVLVIVJVKVB
      VCVDVEMPDVFVGVH $.

    ${
      radcnvlt.x $e |- ( ph -> X e. CC ) $.
      radcnvlt.a $e |- ( ph -> ( abs ` X ) < R ) $.
      ${
        radcnvlt1.h $e |- H = ( m e. NN0 |->
          ( m x. ( abs ` ( ( G ` X ) ` m ) ) ) ) $.
        $( If ` X ` is within the open disk of radius ` R ` centered at zero,
           then the infinite series converges absolutely at ` X ` , and also
           converges when the series is multiplied by ` n ` .  (Contributed by
           Mario Carneiro, 26-Feb-2015.) $)
        radcnvlt1 $p |- ( ph -> ( seq 0 ( + , H ) e. dom ~~> /\
          seq 0 ( + , ( abs o. ( G ` X ) ) ) e. dom ~~> ) ) $=
          ( vs cc0 wcel cr caddc cv cfv cseq cli cdm cabs cle wbr wn wa wrex wi
          ccom wral clt cxr wb ressxr abscld cpnf cicc iccssxr radcnvcl xrltnle
          sseldi co syl2anc mpbid crab csup breq1i wss ssrab2 supxrleub sylancr
          sstri syl5bb fveq2 seqeq3d eleq1d ralrab syl6bb mtbid rexanali sylibr
          weq ltnle sylan adantr cn0 cc wf ad2antrr simplr recnd simprr 0re a1i
          absge0d lelttrd absidd breqtrrd simprl radcnvlem1 radcnvlem2 jca expr
          ltled sylbird expimpd rexlimdva mpd ) AUAQUBZGUCZRUDZUEUFZSZXNIUGUCZU
          HUIZUJZUKZQTULZUAHRUDXQSZUAUGIGUCUNRUDXQSZUKZAXRXTUMQTUOZUJYCADXSUHUI
          ZYGAXSDUPUIZYHUJZOAXSUQSZDUQSYIYJURATUQXSUSAINUTZVFZARVAVBVGUQDRVAVCA
          BCDFGJKLMVDVFXSDVEVHVIAYHXTQUAJUBZGUCZRUDZXQSZJTVJZUOZYGYHYRUQUPVKZXS
          UHUIZAYSDYTXSUHMVLAYRUQVMYKUUAYSURYRTUQYQJTVNUSVQYMQYRXSVOVPVRYQXRXTQ
          JTJQWGZYPXPXQUUBYOXOUARYNXNGVSVTWAWBWCWDXRXTQTWEWFAYBYFQTAXNTSZUKZXRY
          AYFUUDXRUKYAXSXNUPUIZYFUUDUUEYAURZXRAXSTSUUCUUFYLXSXNWHWIWJUUDXRUUEYF
          UUDXRUUEUKZUKZYDYEUUHBCEFGHIXNKAWKWLCWMUUCUUGLWNZAIWLSUUCUUGNWNZUUHXN
          AUUCUUGWOZWPZUUHXSXNXNUGUCUPUUDXRUUEWQZUUHXNUUKUUHRXNRTSUUHWRWSZUUKUU
          HRXSXNUUNUUHIUUJUTUUKUUHIUUJWTUUMXAXIXBXCZUUDXRUUEXDZPXEUUHBCFGIXNKUU
          IUUJUULUUOUUPXFXGXHXJXKXLXM $.
      $}

      $( If ` X ` is within the open disk of radius ` R ` centered at zero,
         then the infinite series converges at ` X ` .  (Contributed by Mario
         Carneiro, 26-Feb-2015.) $)
      radcnvlt2 $p |- ( ph -> seq 0 ( + , ( G ` X ) ) e. dom ~~> ) $=
        ( vk vm cabs cfv cc0 cn0 wcel ccom nn0uz cz 0z a1i cc wf cv wceq psergf
        fvco3 sylan ffvelrnda caddc cmul co cmpt cseq cli cdm id fveq2d oveq12d
        fveq2 cbvmptv radcnvlt1 simprd abscvgcvg ) ANPGFQZUAZVIRSUBRUCTAUDUEASU
        FVIUGNUHZSTVKVJQVKVIQZPQZUIABCEFGIJLUJZSUFVKPVIUKULASUFVKVIVNUMAUNOSOUH
        ZVOVIQZPQZUOUPZUQZRURUSUTZTUNVJRURVTTABCDNEFVSGHIJKLMONSVRVKVMUOUPVOVKU
        IZVOVKVQVMUOWAVAWAVPVLPVOVKVIVDVBVCVEVFVGVH $.
    $}

    radcnvle.x $e |- ( ph -> X e. CC ) $.
    radcnvle.a $e |- ( ph -> seq 0 ( + , ( G ` X ) ) e. dom ~~> ) $.
    $( If ` X ` is a convergent point of the infinite series, then ` X ` is
       within the closed disk of radius ` R ` centered at zero.  Or, by
       contraposition, the series divergers at any point strictly more than
       ` R ` from the origin.  (Contributed by Mario Carneiro, 26-Feb-2015.) $)
    radcnvle $p |- ( ph -> ( abs ` X ) <_ R ) $=
      ( cle wbr cr wcel cxr cc0 adantr vy cabs cfv wn caddc co c2 cdiv wa simpr
      clt wb cmnf cpnf cicc iccssxr radcnvcl sseldi abscld w3a 0xr pnfxr elicc1
      mp2an sylib simp2d ge0gtmnf syl2anc wi ressxr xrltle xrre syl22anc avglt1
      mpd mpbid cv cseq cli cdm crab wss ssrab2 sstri readdcld rehalfcld cn0 cc
      csup wf recnd 0re a1i lelttrd ltled absidd avglt2 eqbrtrd radcnvlem3 wceq
      seqeq3d eleq1d cbvrabv elrab2 sylanbrc supxrub sylancr syl6breqr pm2.65da
      fveq2 lenltd xrlenlt mpbird ) AGUBUCZDNOZDXNUKOZUDZAXPDDXNUEUFZUGUHUFZUKO
      ZAXPUIZXPXTAXPUJZYADPQZXNPQZXPXTULYADRQZYDUMDUKOZDXNNOZYCAYEXPASUNUOUFZRD
      SUNUPABCDEFHIJKUQZURZTZAYDXPAGLUSZTZAYFXPAYESDNOZYFYJAYEYNDUNNOZADYHQZYEY
      NYOUTZYISRQUNRQYPYQULVAVBSUNDVCVDVEVFZDVGVHTYAXPYGYBYAYEXNRQZXPYGVIYKAYSX
      PAPRXNVJYLURZTDXNVKVHVODXNVLVMZYMDXNVNVHVPZYAXSDNOXTUDYAXSUEHVQZFUCZSVRZV
      SVTZQZHPWAZRUKWIZDNYAUUHRWBXSUUHQZXSUUINOUUHPRUUGHPWCVJWDYAXSPQUEXSFUCZSV
      RZUUFQZUUJYAXRYADXNUUAYMWEWFZYABCEFXSGIAWGWHCWJXPJTYAXSUUNWKAGWHQXPLTYAXS
      UBUCXSXNUKYAXSUUNYASXSSPQYAWLWMZUUNYASDXSUUOUUAUUNAYNXPYRTUUBWNWOWPYAXPXS
      XNUKOZYBYAYCYDXPUUPULUUAYMDXNWQVHVPWRAUEGFUCSVRUUFQXPMTWSUEUAVQZFUCZSVRZU
      UFQZUUMUAXSPUUHUUQXSWTZUUSUULUUFUVAUURUUKUESUUQXSFXJXAXBUUGUUTHUAPUUCUUQW
      TZUUEUUSUUFUVBUUDUURUESUUCUUQFXJXAXBXCXDXEUUHXSXFXGKXHYAXSDUUNUUAXKVPXIAY
      SYEXOXQULYTYJXNDXLVHXM $.
  $}

  ${
    $d k n x A $.  $d i k r G $.  $d k H $.  $d i k n r x X $.  $d i k ph $.
    dvradcnv.g $e |- G = ( x e. CC |-> ( n e. NN0 |->
      ( ( A ` n ) x. ( x ^ n ) ) ) ) $.
    dvradcnv.r $e |- R =
      sup ( { r e. RR | seq 0 ( + , ( G ` r ) ) e. dom ~~> } , RR* , < ) $.
    dvradcnv.h $e |- H = ( n e. NN0 |->
      ( ( ( n + 1 ) x. ( A ` ( n + 1 ) ) ) x. ( X ^ n ) ) ) $.
    dvradcnv.a $e |- ( ph -> A : NN0 --> CC ) $.
    dvradcnv.x $e |- ( ph -> X e. CC ) $.
    dvradcnv.l $e |- ( ph -> ( abs ` X ) < R ) $.
    $( The radius of convergence of the (formal) derivative ` H ` of the power
       series ` G ` is at least as large as the radius of convergence of
       ` G ` .  (In fact they are equal, but we don't have as much use for the
       negative side of this claim.)  (Contributed by Mario Carneiro,
       31-Mar-2015.) $)
    dvradcnv $p |- ( ph -> seq 0 ( + , H ) e. dom ~~> ) $=
      ( cc0 c1 co cmul wcel vk vi wceq cabs cfv cdiv cif cn0 cv cmpt cneg nn0uz
      cshi 1nn0 a1i wa caddc cexp cr cc ax-1cn nn0cn adantl nn0ex mptex sylancr
      shftval4 addcom fveq2d peano2nn0 id fveq2 oveq12d eqid fvmpt syl pserval2
      syl2an oveq2d eqtrd 3eqtrd nn0red wf ffvelrn expcl mulcld abscld remulcld
      ovex eqeltrd weq oveq1 oveq2 nn0cnd sylan cseq cli cdm wbr ccom radcnvlt1
      cbvmptv simpld climdm sylib cz wb 0z 1z znegcl ax-mp isershft mp2an seqex
      fvex breldm cuz cle neg1cn addid2i 0le1 1re le0neg2 mpbi eqbrtri mpbir2an
      eqeltri eluz1i eluzelz zcnd nn0re psergf recnd breq2d sylan2 adantr simpr
      crp 3brtr4d ad2antrr ffvelrnda fmptd eluzp1p1 oveq1i negidi fveq2i eqtr4i
      addcomli eqtri syl6eleqr iserex mpbid wn wne df-ne biimpri absrpcl ifclda
      rprecred cn elnnuz sylbir nn0ge0d absge0d mulge0d sylibr sylan9eqr mul01d
      nnnn0 abs00bd mulid2d mulassd absmuld absidd oveq1d eqle syl2anc rpreccld
      0expd rpcnd mul12d absdivd divassd cmin pncan sylancl nn0zd expm1d eqtr3d
      eqtr4d divrec2d 3eqtr3rd breqtrrd sylanl2 sylan2br ifbothda cvgcmpce
      rpne0d ) AHPUCZQQHUDUEZUFRZUGZUAUBUHUBUIZUXCHFUEZUEZUDUEZSRZUJZQUKZUMRZGP
      QUHULQUHTAUNUOAUAUIZUHTZUPZUXKUXJUEZUXKQUQRZUXOCUEZHUXOURRZSRZUDUEZSRZUSU
      XMUXNQUXKUQRZUXHUEZUXOUXHUEZUXTUXMQUTTZUXKUTTZUXNUYBUCZVAUXLUYEAUXKVBVCZQ
      UXKUXHUBUHUXGVDVEZVGZVFUXMUYAUXOUXHUXMUYDUYEUYAUXOUCZVAUYGQUXKVHZVFVIUXMU
      YCUXOUXOUXDUEZUDUEZSRZUXTUXMUXOUHTZUYCUYNUCUXLUYOAUXKVJZVCZUBUXOUXGUYNUHU
      XHUXCUXOUCZUXCUXOUXFUYMSUYRVKUYRUXEUYLUDUXCUXOUXDVLVIVMUXHVNZUXOUYMSWIVOV
      PUXMUYMUXSUXOSUXMUYLUXRUDAHUTTZUYOUYLUXRUCUXLNUYPBCEFUXOHJVQVRVIVSVTWAZUX
      MUXOUXSUXMUXOUYQWBZUXMUXRUXMUXPUXQAUHUTCWCUYOUXPUTTZUXLMUYPUHUTUXOCWDVRZA
      UYTUYOUXQUTTZUXLNUYPHUXOWEVRZWFZWGZWHZWJUXMUXKGUEZUXOUXPSRZHUXKURRZSRZUTU
      XLVUJVUMUCAEUXKEUIZQUQRZVUOCUEZSRZHVUNURRZSRVUMUHGEUAWKZVUQVUKVURVULSVUSV
      UOUXOVUPUXPSVUNUXKQUQWLZVUSVUOUXOCVUTVIVMVUNUXKHURWMVMLVUKVULSWIVOVCZUXMV
      UKVULUXMUXOUXPUXMUXOUYQWNZVUDWFZAUYTUXLVULUTTNHUXKWEWOZWFZWJAUQUXJPUXIUQR
      ZWPZWQWRZTZUQUXJPWPVVHTAVVGUQUXHPWPZWQUEZWQWSZVVIAVVJVVKWQWSZVVLAVVJVVHTZ
      VVMAVVNUQUDUXDWTPWPVVHTABCDUAEFUXHHIJMKNOUBUAUHUXGUXKUXKUXDUEZUDUEZSRUBUA
      WKZUXCUXKUXFVVPSVVQVKVVQUXEVVOUDUXCUXKUXDVLVIVMXBXAXCVVJXDXEPXFTZUXIXFTZV
      VMVVLXGXHQXFTVVSXIQXJXKZVVKUQUXHPUXIUYHXLXMXEVVGVVKWQUQUXJVVFXNVVJWQXOXPV
      PAUAUXJVVFPVVFXQUEZVWAVNPVWATZAVWBVVRVVFPXRWSXHVVFUXIPXRUXIXSXTZPQXRWSZUX
      IPXRWSZYAQUSTZVWDVWEXGYBQYCXKYDYEVVFPVVFUXIXFVWCVVTYGYHYFUOAUXKVWATZUPZUX
      NUYBUTVWHUYDUYEUYFVAVWGUYEAVWGUXKVVFUXKYIYJZVCUYIVFAUHUTUXHWCUYAUHTUYBUTT
      VWGAUBUHUXGUTUXHAUXCUHTZUPZUXGVWKUXCUXFVWJUXCUSTAUXCYKVCVWKUXEAUHUTUXCUXD
      ABCEFHJMNYLUUAWGWHYMUYSUUBVWGUYAUXOUHVWGUYDUYEUYJVAVWIUYKVFVWGUXOVVFQUQRZ
      XQUEZUHVVFUXKUUCUHPXQUEVWMULVWLPXQVWLUXIQUQRPVVFUXIQUQVWCUUDQUXIPVAXSQVAU
      UEUUHUUIUUFUUGUUJWJUHUTUYAUXHWDVRWJUUKUULAUWSQUXAUSVWFAUWSUPYBUOAUWSUUMZU
      PUWTAUYTHPUUNZUWTYRTZVWNNVWOVWNHPUUOZUUPHUUQZVRUUSUURAUXKQXQUETZUPZVUMUDU
      EZUXBUXTSRZVUJUDUEZUXBUXNSRZXRUWSVXAQUXTSRZXRWSVXAUXAUXTSRZXRWSZVXAVXBXRW
      SVWTQUXAQUXBUCVXEVXBVXAXRQUXBUXTSWLYNUXAUXBUCVXFVXBVXAXRUXAUXBUXTSWLYNVWT
      UWSUPZPUXTVXAVXEXRVWTPUXTXRWSZUWSVWSAUXLVXIVWSUXKUUTTZUXLUXKUVAZUXKUVIUVB
      ZUXMUXOUXSVUBVUHUXMUXOUYQUVCZUXMUXRVUGUVDUVEYOYPVXHVUMVXHVUMVUKPSRZPVXHVU
      LPVUKSUWSVWTVULPUXKURRPHPUXKURWLVWTUXKVWTVWSVXJAVWSYQVXKUVFUVSUVGVSVWTVXN
      PUCZUWSVWSAUXLVXOVXLUXMVUKVVCUVHYOYPVTUVJVWTVXEUXTUCZUWSVWSAUXLVXPVXLUXMU
      XTUXMUXTVUIYMUVKYOYPYSVWNVWTVWOVXGVWQVWSAUXLVWOVXGVXLUXMVWOUPZVXAUXOUXPVU
      LSRZUDUEZSRZVXFXRUXMVXAVXTXRWSZVWOUXMVXAUSTVXAVXTUCVYAUXMVUMVVEWGUXMVXAUX
      OVXRSRZUDUEUXOUDUEZVXSSRVXTUXMVUMVYBUDUXMUXOUXPVULVVBVUDVVDUVLVIUXMUXOVXR
      VVBUXMUXPVULVUDVVDWFUVMUXMVYCUXOVXSSUXMUXOVUBVXMUVNUVOWAVXAVXTUVPUVQYPVXQ
      VXFUXOUXAUXSSRZSRVXTVXQUXAUXOUXSVXQUXAUXMUYTVWOUXAYRTAUYTUXLNYPZUYTVWOUPU
      WTVWRUVRWOUVTUXMUXOUTTVWOVVBYPVXQUXSUXMUXSUSTVWOVUHYPYMZUWAVXQVYDVXSUXOSV
      XQUXRHUFRZUDUEUXSUWTUFRVXSVYDVXQUXRHUXMUXRUTTVWOVUGYPAUYTUXLVWONYTZUXMVWO
      YQZUWBVXQVYGVXRUDVXQVYGUXPUXQHUFRZSRVXRVXQUXPUXQHUXMVUCVWOVUDYPUXMVUEVWOV
      UFYPVYHVYIUWCVXQVULVYJUXPSVXQHUXOQUWDRZURRVULVYJVXQVYKUXKHURVXQUYEUYDVYKU
      XKUCUXMUYEVWOUYGYPVAUXKQUWEUWFVSVXQHUXOVYHVYIUXMUXOXFTVWOUXMUXOUYQUWGYPUW
      HUWIVSUWJVIVXQUXSUWTVYFVXQUWTAUWTUSTUXLVWOAHNWGYTYMVXQUWTUXMUYTVWOVWPVYEV
      WRWOUWRUWKUWLVSVTUWMUWNUWOUWPVWSAUXLVXCVXAUCVXLUXMVUJVUMUDVVAVIYOVWSAUXLV
      XDVXBUCVXLUXMUXNUXTUXBSVUAVSYOYSUWQ $.
  $}

  ${
    $d a j k m n r s w x y z A $.  $d f i j y H $.  $d i j k m s u v w y z M $.
    $d i j k m x y z B $.  $d i j k m r s w y z G $.  $d a f i j k m w y z S $.
    $d a f z F $.  $d a f i j k m w y z ph $.  $d u v w z R $.
    pserf.g $e |- G = ( x e. CC |-> ( n e. NN0 |->
      ( ( A ` n ) x. ( x ^ n ) ) ) ) $.
    pserf.f $e |- F = ( y e. S |-> sum_ j e. NN0 ( ( G ` y ) ` j ) ) $.
    pserf.a $e |- ( ph -> A : NN0 --> CC ) $.
    pserf.r $e |- R =
      sup ( { r e. RR | seq 0 ( + , ( G ` r ) ) e. dom ~~> } , RR* , < ) $.
    ${
      pserulm.h $e |- H = ( i e. NN0 |-> ( y e. S |->
        ( seq 0 ( + , ( G ` y ) ) ` i ) ) ) $.
      pserulm.m $e |- ( ph -> M e. RR ) $.
      pserulm.l $e |- ( ph -> M < R ) $.
      pserulm.y $e |- ( ph -> S C_ ( `' abs " ( 0 [,] M ) ) ) $.
      $( If ` S ` is a region contained in a circle of radius ` M < R ` , then
         the sequence of partial sums of the infinite series converges
         uniformly on ` S ` .  (Contributed by Mario Carneiro, 26-Feb-2015.) $)
      pserulm $p |- ( ph -> H ( ~~>u ` S ) F ) $=
        ( vm vw vk vz vf culm cfv wbr cc0 clt c0 wceq wa cabs ccnv cicc co cima
        wss adantr cxr wcel 0xr rexrd icc0 sylancr biimpar imaeq2d ima0 sseqtrd
        wb syl6eq ss0 syl cn0 nn0uz cz 0z a1i cv caddc cseq cmpt cc cmap wf cdm
        cnvimass cr absf fdmi sseqtri syl6ss sselda psergf ffvelrnda serf an32s
        eqid fmptd cvv cnex ssexg sylancl elmapg mpbird cle wfn simprd 0re cpnf
        eqidd syldan simpr adantl ad2antrr mptexg fveq1d cbvmptv syl5eq syl2anc
        weq fveq2 mpteq2dva fvex cexp cmul expcld absge0d absexpd eqtrd 3brtr4d
        abscld absmuld pserval2 fveq2d fvmpt2 simplr csu w3a ffn elpreima sylib
        elicc2 simp1d iccssxr radcnvcl sseldi simp3d xrlelttrd radcnvlt2 isumcl
        mp2b mpbid ulm0 cof cuz syl6eleq cfz mpteq2dv fvmptg seqof eqcomd seqfn
        elfznn0 ax-mp fneq2i mpbir dffn5 mpbi 3eqtr4g ccom fex mp2an coex recnd
        simprr sseldd simprl ffvelrnd wral ralrimiva breq1d rspcv sylc syl32anc
        fco leexp1a absid sylan oveq1d lemul2ad fvmpt ad2antll 3eqtrd fvco3 cli
        eqbrtrd oveq12d radcnvlt1 mtest eqeltrd wex eldmg ulmcl feqmptd adantlr
        id ibi seqex ad3antrrr ulmclm isumclim eqtr4d breqtrd exlimdv ltlecasei
        ex syl5 imp ) ALJFUHUIZUJZMUKAMUKULUJZFUMUNZUYDAUYEUOZFUMVAUYFUYGFUPUQZ
        UKMURUSZUTZUMAFUYJVAUYEUBVBUYGUYJUYHUMUTUMUYGUYIUMUYHAUYIUMUNZUYEAUKVCV
        DMVCVDZUYKUYEVMVEAMTVFZUKMVGVHVIVJUYHVKVNVLFVOVPAFLJUKVQVRUKVSVDZAVTWAA
        GVQCFGWBZWCCWBZKUIZUKWDZUIZWEZWFFWGUSZLAUYOVQVDZUOZUYTVUAVDZFWFUYTWHZVU
        CCFUYSWFUYTAUYPFVDZVUBUYSWFVDAVUFUOZVQWFUYOUYRVUGHUYQUKVQVRUYNVUGVTWAZV
        UGVQWFHWBZUYQVUGBDIKUYPOAVQWFDWHZVUFQVBZAFWFUYPAFUYJWFUBUYJUPWIWFUPUYIW
        JWFWKUPWLWMWNWOZWPZWQZWRZWSWRWTUYTXAZXBVUCWFXCVDZFXCVDZVUDVUEVMXDAVURVU
        BAFWFVAZVUQVURVULXDFWFXCXEXFZVBZWFFUYTXCXCXGVHXHSXBZACFVQVUIUYQUIZHUUAZ
        WFJVUGVVCHUYQUKVQVRVUHVUGVUIVQVDZUOVVCXNVUOVUGBDEIKUYPNOVUKRVUMVUGUYPUP
        UIZMEVUGVVFVUGVVFWKVDZUKVVFXIUJZVVFMXIUJZVUGVVFUYIVDZVVGVVHVVIUUBZVUGUY
        PWFVDZVVJVUGUYPUYJVDZVVLVVJUOZAFUYJUYPUBWPWFWKUPWHZUPWFXJVVMVVNVMWLWFWK
        UPUUCWFUYPUYIUPUUDUUOUUEXKVUGUKWKVDZMWKVDZVVJVVKVMXLAVVQVUFTVBUKMVVFUUF
        VHUUPZUUGVFAUYLVUFUYMVBAEVCVDVUFAUKXMURUSVCEUKXMUUHABDEIKNOQRUUIUUJVBVU
        GVVGVVHVVIVVRUUKZAMEULUJZVUFUAVBUULUUMUUNPXBUUQXOAUKMXIUJZLUYCWIZVDZUYD
        AVWAUOZLWCUURZUCVQUDFUCWBZUDWBZKUIZUIZWEZWEZUKWDZVWBALVWLUNVWAAGVQUYTWE
        GVQUYOVWLUIZWEZLVWLAGVQUYTVWMVUCVWMUYTVUCUECFWCVWKUYQUKUYOXCVVAVUCUYOVQ
        UKUUSUIZAVUBXPVRUUTVUCUEWBZUKUYOUVAUSVDZUOZVWPVQVDZCFVWPUYQUIZWEZXCVDZV
        WPVWKUIZVXAUNZVWQVWSVUCVWPUYOUVGXQVWRVURVXBAVURVUBVWQVUTXRCFVWTXCXSZVPU
        CVWPVWJVXAVQXCVWKUCUEYDZVWJCFVWFUYQUIZWEVXAUDCFVWIVXGUDCYDVWFVWHUYQVWGU
        YPKYEXTYAVXFCFVXGVWTVWFVWPUYQYEUVBYBVWKXAZUVCZYCUVDUVEYFSVWLVQXJZVWLVWN
        UNVXJVWLVWOXJZUYNVXKVTVWEVWKUKUVFUVHVQVWOVWLVRUVIUVJGVQVWLUVKUVLUVMVBVW
        DUFFUEVWKUPMKUIZUVNZUKXCXCVQVRUYNVWDVTWAAVURVWAVUTVBAVQVUAVWKWHVWAAUCVQ
        VWJVUAVWKAVWFVQVDZUOZVWJVUAVDZFWFVWJWHZVXOUDFVWIWFVWJAVWGFVDZVXNVWIWFVD
        AVXRUOZVQWFVWFVWHVXSBDIKVWGOAVUJVXRQVBAFWFVWGVULWPWQWRWTVWJXAXBVXOVUQVU
        RVXPVXQVMXDAVURVXNVUTVBWFFVWJXCXCXGVHXHVXHXBVBVXMXCVDVWDUPVXLVVOVUQUPXC
        VDWLXDWFWKXCUPUVOUVPMKYGUVQWAVWDVQWKVWPVXMVWDVVOVQWFVXLWHZVQWKVXMWHWLVW
        DBDIKMOAVUJVWAQVBZVWDMAVVQVWATVBUVRZWQZVQWFWKUPVXLUWIVHWRVWDVWSUFWBZFVD
        ZUOZUOZVWPDUIZVYDVWPYHUSZYIUSZUPUIZVYHMVWPYHUSZYIUSZUPUIZVYDVXCUIZUPUIV
        WPVXMUIZXIVYGVYHUPUIZVYIUPUIZYIUSVYQVYLUPUIZYIUSVYKVYNXIVYGVYRVYSVYQVYG
        VYIVYGVYDVWPVYGFWFVYDAVUSVWAVYFVULXRVWDVWSVYEUVSZUVTZVWDVWSVYEUWAZYJZYO
        VYGVYLVYGMVWPVWDMWFVDZVYFVYBVBZWUBYJZYOVYGVYHVYGVQWFVWPDAVUJVWAVYFQXRWU
        BUWBZYOVYGVYHWUGYKVYGVYDUPUIZVWPYHUSZVYLVYRVYSXIVYGWUHWKVDVVQVWSUKWUHXI
        UJWUHMXIUJZWUIVYLXIUJVYGVYDWUAYOAVVQVWAVYFTXRWUBVYGVYDWUAYKVYGVYEVVICFU
        WCZWUJVYTAWUKVWAVYFAVVICFVVSUWDXRVVIWUJCVYDFCUFYDZVVFWUHMXIUYPVYDUPYEUW
        EUWFUWGWUHMVWPUWJUWHVYGVYDVWPWUAWUBYLVYGVYSMUPUIZVWPYHUSVYLVYGMVWPWUEWU
        BYLVYGWUMMVWPYHVWDWUMMUNZVYFAVVQVWAWUNTMUWKUWLZVBUWMYMYNUWNVYGVYHVYIWUG
        WUCYPVYGVYHVYLWUGWUFYPYNVYGVYOVYJUPVYGVYOVYDVXAUIZVWPVYDKUIZUIZVYJVYGVY
        DVXCVXAVYGVWSVXBVXDWUBVYGVURVXBAVURVWAVYFVUTXRVXEVPVXIYCXTVYEWUPWURUNVW
        DVWSCVYDVWTWURFVXAWULVWPUYQWUQUYPVYDKYEXTVXAXAVWPWUQYGUWOUWPVYGVYDWFVDV
        WSWURVYJUNWUAWUBBDIKVWPVYDOYQYCUWQYRVYGVYPVWPVXLUIZUPUIZVYNVYGVXTVWSVYP
        WUTUNVWDVXTVYFVYCVBWUBVQWFVWPUPVXLUWRYCVYGWUSVYMUPVYGWUDVWSWUSVYMUNWUEW
        UBBDIKVWPMOYQYCYRYMYNVWDWCGVQUYOUYOVXLUIZUPUIZYIUSZWEZUKWDUWSWIZVDWCVXM
        UKWDWVEVDVWDBDEUCIKWVDMNOVYARVYBVWDWUMMEULWUOAVVTVWAUAVBUWTGUCVQWVCVWFV
        WFVXLUIZUPUIZYIUSGUCYDZUYOVWFWVBWVGYIWVHUXJWVHWVAWVFUPUYOVWFVXLYEYRUXAY
        AUXBXKUXCUXDAVWCUYDVWCLUGWBZUYCUJZUGUXEZAUYDVWCWVKUGLUYCVWBUXFUXKAWVJUY
        DUGAWVJUYDAWVJUOZLWVIJUYCAWVJXPWVLWVICFUYPWVIUIZWEZJWVLCFWFWVIWVJFWFWVI
        WHAFLWVIUXGXQUXHWVLJCFVVDWEWVNPWVLCFVVDWVMWVLVUFUOZVVCWVMHUYQUKVQVRUYNW
        VOVTWAZWVOVVEUOVVCXNWVOVQWFVUIUYQAVUFVQWFUYQWHWVJVUNUXIWRWVOUYPFGLWVIUY
        RUKXCVQVRWVPAVQVUALWHWVJVUFVVBXRWVLVUFXPUYRXCVDWVOWCUYQUKUXLWAWVOVUBUOZ
        UYPUYOLUIZUIUYPUYTUIZUYSWVQUYPWVRUYTWVQVUBUYTXCVDZWVRUYTUNWVOVUBXPWVQVU
        RWVTAVURWVJVUFVUBVUTUXMCFUYSXCXSVPGVQUYTXCLSYSYCXTWVQVUFUYSXCVDWVSUYSUN
        WVLVUFVUBYTUYOUYRYGCFUYSXCUYTVUPYSXFYMAWVJVUFYTUXNUXOYFYBUXPUXQUXTUXRUY
        AUYBXOTVVPAXLWAUXS $.

      $( Since by ~ pserulm the series converges uniformly, it is also
         continuous by ~ ulmcn .  (Contributed by Mario Carneiro,
         3-Mar-2015.) $)
      psercn2 $p |- ( ph -> F e. ( S -cn-> CC ) ) $=
        ( vk cc0 cn0 nn0uz cz wcel 0z a1i cv caddc cfv cseq cmpt cc ccncf co wa
        cres wss wceq cabs ccnv cicc cima cdm cnvimass absf fdmi sseqtri syl6ss
        adantr resmpt syl cfz cexp cmul csu simplr elfznn0 pserval2 syl2anc cuz
        cr adantl simpr syl6eleq ffvelrnda adantlr expcl adantll mulcld fsumser
        sylan2 mpteq2dva ccnfld ctopn ccn eqid ctopon cnfldtopon ffvelrn syl2an
        fzfid cnmptc expcn ctx mulcn cnmpt12f fsumcn cncfcn1 syl6eleqr eqeltrrd
        wf rescncf sylc fmptd pserulm ulmcn ) AFLJUDUEUFUDUGUHAUIUJAGUECFGUKZUL
        CUKZKUMZUDUNUMZUOZFUPUQURZLAYAUEUHZUSZCUPYDUOZFUTZYEYFYHFUPVAZYJYEVBAYK
        YGAFVCVDUDMVEURZVFZUPUBYMVCVGUPVCYLVHUPWEVCVIVJVKVLVMZCUPFYDVNVOYHYKYIU
        PUPUQURZUHYJYFUHYNYHCUPUDYAVPURZUCUKZDUMZYBYQVQURZVRURZUCVSZUOZYIYOYHCU
        PUUAYDYHYBUPUHZUSZYTUCYCUDYAUUDYQYPUHZUSUUCYQUEUHZYQYCUMYTVBYHUUCUUEVTU
        UEUUFUUDYQYAWAZWFBDIKYQYBOWBWCYHYAUDWDUMZUHUUCYHYAUEUUHAYGWGUFWHVMUUEUU
        DUUFYTUPUHUUGUUDUUFUSYRYSYHUUFYRUPUHZUUCYHUEUPYQDAUEUPDXOZYGQVMZWIWJUUC
        UUFYSUPUHYHYBYQWKWLWMWOWNWPYHUUBWQWRUMZUULWSURZYOYHCYPYTUCUULUULUPUULWT
        ZUULUPXAUMUHZYHUULUUNXBZUJYHUDYAXEYHUUEUSZCYRYSVRUULUULUULUULUPUUOUUQUU
        PUJZUUQCYRUULUULUPUPUURUURYHUUJUUFUUIUUEUUKUUGUEUPYQDXCXDXFUUQUUFCUPYSU
        OUUMUHUUEUUFYHUUGWFCUULYQUUNXGVOVRUULUULXHURUULWSURUHUUQUULUUNXIUJXJXKU
        ULUUNXLXMXNUPUPFYIXPXQXNSXRABCDEFGHIJKLMNOPQRSTUAUBXSXT $.
    $}

    ${
      psercn.s $e |- S = ( `' abs " ( 0 [,) R ) ) $.
      ${
        psercnlem2.i $e |- ( ( ph /\ a e. S ) ->
          ( M e. RR+ /\ ( abs ` a ) < M /\ M < R ) ) $.
        $( Lemma for ~ psercn .  (Contributed by Mario Carneiro,
           18-Mar-2015.) $)
        psercnlem2 $p |- ( ( ph /\ a e. S ) ->
          ( a e. ( 0 ( ball ` ( abs o. - ) ) M ) /\
            ( 0 ( ball ` ( abs o. - ) ) M ) C_ ( `' abs " ( 0 [,] M ) ) /\
            ( `' abs " ( 0 [,] M ) ) C_ S ) ) $=
          ( wcel vu vv vw vk vz cv wa cc0 cabs cmin ccom cbl cfv ccnv cicc cima
          co wss cico cdm cnvimass absf fdmi sseqtri eqsstri a1i sselda cle wbr
          cc cr clt abscld absge0d crp simp2d cxr w3a 0re simp1d elico2 sylancr
          wb rpxrd mpbir3and wfn ffn elpreima mp2b sylanbrc wceq eqid cnbl0 syl
          wf eleqtrd df-ico df-icc xrltle ixxssixx imass2 mp1i eqsstr3d iccssxr
          idd cpnf radcnvcl adantr sseldi simp3d xrlelttr ixxss2 syl6sseqr 3jca
          syl2anc ) AMUFZFTZUGZXPUHKUIUJUKZULUMUQZTXTUIUNZUHKUOUQZUPZURYCFURXRX
          PYAUHKUSUQZUPZXTXRXPVJTZXPUIUMZYDTZXPYETZAFVJXPFVJURAFYAUHEUSUQZUPZVJ
          RYKUIUTVJUIYJVAVJVKUIVBVCVDVEVFVGZXRYHYGVKTZUHYGVHVIZYGKVLVIZXRXPYLVM
          XRXPYLVNXRKVOTZYOKEVLVIZSVPXRUHVKTKVQTZYHYMYNYOVRWCVSXRKXRYPYOYQSVTWD
          ZUHKYGWAWBWEVJVKUIWOUIVJWFYIYFYHUGWCVBVJVKUIWGVJXPYDUIWHWIWJXRYRYEXTW
          KYSXSKXSWLWMWNZWPXRXTYEYCYTYDYBURYEYCURXRUAUBUCUDUHKUOVHVLVHVHUSUAUBU
          CWQZUAUBUCWRZUHVQTUDUFZVQTUGUHUUCVHVIXEUUCKWSWTYDYBYAXAXBXCXRYCYKFXRY
          BYJURZYCYKURXREVQTYQUUDXRUHXFUOUQZVQEUHXFXDAEUUETXQABDEHJLNPQXGXHXIXR
          YPYOYQSXJUAUBUCUEUHKEUOVHVLVHUSVLUUAUUBUEUFKEXKXLXOYBYJYAXAWNRXMXN $.
      $}

      psercn.m $e |- M = if ( R e. RR ,
        ( ( ( abs ` a ) + R ) / 2 ) , ( ( abs ` a ) + 1 ) ) $.
      $( Lemma for ~ psercn .  (Contributed by Mario Carneiro, 18-Mar-2015.) $)
      psercnlem1 $p |- ( ( ph /\ a e. S ) ->
        ( M e. RR+ /\ ( abs ` a ) < M /\ M < R ) ) $=
        ( clt cv wcel wa crp cabs cfv wbr cr caddc co c2 cdiv c1 cif cc wss cc0
        ccnv cico cima cdm cnvimass absf fdmi sseqtri eqsstri a1i sselda abscld
        readdcl sylan rehalfcld peano2re syl adantr ifclda syl5eqel 0re absge0d
        wn breq2 cle w3a simpr syl6eleq wf wfn wb ffn elpreima sylib simprd cxr
        mp2b cpnf cicc iccssxr radcnvcl sseldi elico2 mpbid simp3d avglt1 ltp1d
        sylancr syl6breqr lelttrd elrpd breq1 avglt2 rexrd xrlenlt syl2anc cmnf
        ifbothda wi 0xr pnfxr elicc1 simp2d ge0gtmnf xrre expr syl21anc sylbird
        mp2an con1d imp syl5eqbr 3jca ) AMUAZFUBZUCZKUDUBYKUEUFZKTUGKETUGYMKYMK
        EUHUBZYNEUIUJZUKULUJZYNUMUIUJZUNZUHSYMYOYQYRUHYMYOUCZYPYMYNUHUBZYOYPUHU
        BYMYKAFUOYKFUOUPAFUEURUQEUSUJZUTZUORUUCUEVAUOUEUUBVBUOUHUEVCVDVEVFVGVHZ
        VIZYNEVJVKVLYMYRUHUBZYOVTZYMUUAUUFUUEYNVMVNZVOVPVQZYMUQYNKUQUHUBZYMVRVG
        UUEUUIYMYKUUDVSYMYNYSKTYOYNYQTUGZYNYRTUGZYNYSTUGYMYQYRYQYSYNTWAYRYSYNTW
        AYTYNETUGZUUKYMUUMYOYMUUAUQYNWBUGZUUMYMYNUUBUBZUUAUUNUUMWCZYMYKUOUBZUUO
        YMYKUUCUBZUUQUUOUCZYMYKFUUCAYLWDRWEUOUHUEWFUEUOWGUURUUSWHVCUOUHUEWIUOYK
        UUBUEWJWNWKWLYMUUJEWMUBZUUOUUPWHVRYMUQWOWPUJZWMEUQWOWQAEUVAUBZYLABDEHJL
        NPQWRZVOWSZUQEYNWTXEXAXBVOZYMUUAYOUUMUUKWHUUEYNEXCVKXAYMUULUUGYMYNUUEXD
        VOXOSXFZXGXHUVFYMKYSETSYOYQETUGZYRETUGZYSETUGYMYQYRYQYSETXIYRYSETXIYTUU
        MUVGUVEYMUUAYOUUMUVGWHUUEYNEXJVKXAYMUUGUVHYMUVHYOYMUVHVTZEYRWBUGZYOYMUU
        TYRWMUBUVJUVIWHUVDYMYRUUHXKEYRXLXMYMUUTUUFXNETUGZUVJYOXPUVDUUHYMUUTUQEW
        BUGZUVKUVDAUVLYLAUUTUVLEWOWBUGZAUVBUUTUVLUVMWCZUVCUQWMUBWOWMUBUVBUVNWHX
        QXRUQWOEXSYFWKXTVOEYAXMUUTUUFUCUVKUVJYOEYRYBYCYDYEYGYHXOYIYJ $.

      $( An infinite series converges to a continuous function on the open disk
         of radius ` R ` , where ` R ` is the radius of convergence of the
         series.  (Contributed by Mario Carneiro, 4-Mar-2015.) $)
      psercn $p |- ( ph -> F e. ( S -cn-> CC ) ) $=
        ( cc vi vs vk ccnfld ctopn cfv crest co ccn ccncf wf ccnp wcel wral wfn
        cn0 csu cvv sumex rgenw fnmpt mp1i cc0 cabs cmin ccom cbl cres wceq clt
        cv wa wbr wss ccnv cico cima cdm cnvimass absf fdmi sseqtri eqsstri a1i
        cr sselda 0cn eqid cnmetdval sylancr abssub subid1d fveq2d 3eqtrd caddc
        c2 cdiv c1 cif breq2 cle w3a simpr syl6eleq wb ffn elpreima mp2b simprd
        sylib cxr cpnf cicc iccssxr radcnvcl adantr sseldi mpbid simp3d syl3anc
        0re syl cmpt syl5eq cseq weq fveq1d cbvmptv eqeltrrd ralrimiva sylanbrc
        fveq2 cuni ctop cncfcn eleqtrd restuni eleqtrrd mp2an ctopon wn eqbrtrd
        elico2 abscld avglt1 sylan ltp1d ifbothda syl6breqr cxmt crp psercnlem1
        cnxmet simp1d rpxrd elbl mpbir2and fvres psercnlem2 simp2d sstrd resmpt
        reseq1i seqeq3d mpteq2dv rpred psercn2 cncff ffvelrnd ffnfv syl6ss ssid
        eqeltrd cnfldtopon toponunii restid ax-mp eqcomi sylancl cncnpi syl2anc
        cnfldtop ssexi restabs oveq1d cnt resttop df-ss cnfldtopn blopn elrestr
        cnex cin isopn3i cnprest syl22anc mpbird resttopon cncnp syl6eleqr ) AI
        UDUEUFZFUGUHZUXAUIUHZFTUJUHZAFTIUKZIMVKZUXBUXAULUHUFUMZMFUNZIUXCUMZAIFU
        OZUXFIUFZTUMZMFUNUXEUPGVKCVKZJUFZUFZGUQZURUMZCFUNUXJAUXQCFUPUXOGUSUTCFU
        XPIUROVAVBAUXLMFAUXFFUMZVLZUXFIVCKVDVEVFZVGUFUHZVHZUFZUXKTUXSUXFUYAUMZU
        YCUXKVIUXSUYDUXFTUMZVCUXFUXTUHZKVJVMZAFTUXFFTVNZAFVDVOZVCEVPUHZVQZTRUYK
        VDVRTVDUYJVSTWEVDVTWAWBWCZWDWFZUXSUYFUXFVDUFZKVJUXSUYFVCUXFVEUHVDUFZUXF
        VCVEUHZVDUFZUYNUXSVCTUMZUYEUYFUYOVIWGUYMVCUXFUXTUXTWHWIWJUXSUYRUYEUYOUY
        QVIWGUYMVCUXFWKWJUXSUYPUXFVDUXSUXFUYMWLWMWNUXSUYNEWEUMZUYNEWOUHWPWQUHZU
        YNWRWOUHZWSZKVJUYSUYNUYTVJVMZUYNVUAVJVMZUYNVUBVJVMUXSUYTVUAUYTVUBUYNVJW
        TVUAVUBUYNVJWTUXSUYSVLUYNEVJVMZVUCUXSVUEUYSUXSUYNWEUMZVCUYNXAVMZVUEUXSU
        YNUYJUMZVUFVUGVUEXBZUXSUYEVUHUXSUXFUYKUMZUYEVUHVLZUXSUXFFUYKAUXRXCRXDTW
        EVDUKVDTUOVUJVUKXEVTTWEVDXFTUXFUYJVDXGXHXJXIUXSVCWEUMEXKUMVUHVUIXEYAUXS
        VCXLXMUHZXKEVCXLXNAEVULUMUXRABDEHJLNPQXOXPXQVCEUYNUUCWJXRXSXPUXSVUFUYSV
        UEVUCXEUXSUXFUYMUUDZUYNEUUEUUFXRUXSVUDUYSUUAUXSUYNVUMUUGXPUUHSUUIUUBUXS
        UXTTUUJUFUMZUYRKXKUMZUYDUYEUYGVLXEVUNUXSUUMWDZUYRUXSWGWDZUXSKUXSKUUKUMZ
        UYNKVJVMZKEVJVMZABCDEFGHIJKLMNOPQRSUULZUUNZUUOZUXFUXTVCKTUUPXTUUQZUXFUY
        AIUURYBUXSUYATUXFUYBUXSUYBUYATUJUHZUMUYATUYBUKUXSUYBCUYAUXPYCZVVEUXSUYB
        CFUXPYCZUYAVHZVVFIVVGUYAOUVCUXSUYAFVNZVVHVVFVIUXSUYAUYIVCKXMUHVQZFUXSUY
        DUYAVVJVNZVVJFVNZABCDEFGHIJKLMNOPQRVVAUUSZUUTZUXSUYDVVKVVLVVMXSUVAZCFUY
        AUXPUVBYBYDUXSBCDEUYAUAGHVVFJUBUPUCUYAUBVKZWOUCVKZJUFZVCYEZUFZYCZYCKLNV
        VFWHAUPTDUKUXRPXPQUBUAUPVWACUYAUAVKZWOUXNVCYEZUFZYCZUBUAYFZVWACUYAVVPVW
        CUFZYCVWEUCCUYAVVTVWGUCCYFZVVPVVSVWCVWHVVRUXNWOVCVVQUXMJYLUVDYGYHVWFCUY
        AVWGVWDVVPVWBVWCYLUVEYDYHUXSKVVBUVFUXSVURVUSVUTVVAXSVVNUVGUVMZUYATUYBUV
        HYBVVDUVIYIYJMFTIUVJYKZAUXGMFUXSUXGUYBUXFUXBUYAUGUHZUXAULUHZUFZUMZUXSUY
        BUXFUXAUYAUGUHZUXAULUHZUFZVWMUXSUYBVWOUXAUIUHZUMUXFVWOYMZUMUYBVWQUMUXSU
        YBVVEVWRVWIUXSUYATVNZTTVNZVVEVWRVIUXSUYAFTVVOUYLUVKZTUVLZUYATUXAVWOUXAU
        XAWHZVWOWHUXATUGUHZUXAUXAYNUMZVXEUXAVIUXAVXDUWBZUXAYNTTUXAUXAVXDUVNZUVO
        ZUVPUVQUVRZYOUVSYPUXSUXFUYAVWSVVDUXSVXFVWTUYAVWSVIVXGVXBUYAUXATVXIYQWJY
        PUXFUYBVWOUXAVWSVWSWHUVTUWAUXSUXFVWLVWPUXSVWKVWOUXAULUXSVXFVVIFURUMZVWK
        VWOVIVXFUXSVXGWDZVVOVXKUXSFTUWLUYLUWCZWDZUYAFUXAYNURUWDXTUWEYGYRUXSUXBY
        NUMZVVIUXFUYAUXBUWFUFUFZUMUXEUXGVWNXEVXOUXSVXFVXKVXOVXGVXMFUXAURUWGYSZW
        DVVOUXSUXFUYAVXPVVDUXSVXOUYAUXBUMVXPUYAVIVXQUXSUYAFUWMZUYAUXBUXSVVIVXRU
        YAVIVVOUYAFUWHXJUXSVXFVXKUYAUXAUMZVXRUXBUMVXLVXNUXSVUNUYRVUOVXSVUPVUQVV
        CUXTVCKUXATUXAVXDUWIUWJXTUYAFUXAYNURUWKXTYIUYAUXBUWNWJYRAUXEUXRVWJXPUYA
        UXFIUXBUXAFTVXFUYHFUXBYMVIVXGUYLFUXATVXIYQYSVXIUWOUWPUWQYJUXBFYTUFUMZUX
        ATYTUFUMZUXIUXEUXHVLXEVYAUYHVXTVXHUYLFUXATUWRYSVXHMIUXBUXAFTUWSYSYKUYHV
        XAUXDUXCVIUYLVXCFTUXAUXBUXAVXDUXBWHVXJYOYSUWT $.

      $( Lemma for ~ pserdv .  (Contributed by Mario Carneiro, 7-May-2015.) $)
      pserdvlem1 $p |- ( ( ph /\ a e. S ) ->
        ( ( ( ( abs ` a ) + M ) / 2 ) e. RR+ /\
          ( abs ` a ) < ( ( ( abs ` a ) + M ) / 2 ) /\
          ( ( ( abs ` a ) + M ) / 2 ) < R ) ) $=
        ( wcel cv wa cabs cfv caddc co c2 cdiv crp clt wbr cc wss ccnv cc0 cico
        cima cdm cnvimass cr absf fdmi sseqtri eqsstri sselda abscld psercnlem1
        a1i simp1d rpred readdcld 0re absge0d ltaddrpd lelttrd rphalfcld simp2d
        elrpd wb avglt1 syl2anc mpbid rehalfcld rexrd cxr cpnf iccssxr radcnvcl
        cicc sseldi adantr avglt2 simp3d xrlttrd 3jca ) AMUAZFTZUBZWPUCUDZKUEUF
        ZUGUHUFZUITWSXAUJUKZXAEUJUKWRWTWRWTWRWSKWRWPAFULWPFULUMAFUCUNUOEUPUFZUQ
        ZULRXDUCURULUCXCUSULUTUCVAVBVCVDVHVEZVFZWRKWRKUITZWSKUJUKZKEUJUKZABCDEF
        GHIJKLMNOPQRSVGZVIZVJZVKZWRUOWSWTUOUTTWRVLVHXFXMWRWPXEVMWRWSKXFXKVNVOVR
        VPWRXHXBWRXGXHXIXJVQZWRWSUTTZKUTTZXHXBVSXFXLWSKVTWAWBWRXAKEWRXAWRWTXMWC
        WDWRKXLWDAEWETWQAUOWFWIUFWEEUOWFWGABDEHJLNPQWHWJWKWRXHXAKUJUKZXNWRXOXPX
        HXQVSXFXLWSKWLWAWBWRXGXHXIXJWMWNWO $.

      $d i n A $.
      pserdv.b $e |- B =
        ( 0 ( ball ` ( abs o. - ) ) ( ( ( abs ` a ) + M ) / 2 ) ) $.
      $( Lemma for ~ pserdv .  (Contributed by Mario Carneiro, 7-May-2015.) $)
      pserdvlem2 $p |- ( ( ph /\ a e. S ) -> ( CC _D ( F |` B ) ) =
        ( y e. B |-> sum_ k e. NN0
          ( ( ( k + 1 ) x. ( A ` ( k + 1 ) ) ) x. ( y ^ k ) ) ) ) $=
        ( vz vm vi vw vs cv wcel wa cc cn0 cc0 cfz co cfv csu cmpt cres c1 cmul
        caddc cexp nn0uz cr cnex a1i cz 0z wf fzfid wss cabs cxr cnxmet 0cn crp
        cmin clt wbr simp1d rpxrd syl3anc syl5eqss adantr sselda psergf elfznn0
        ffvelrn syl2an fsumcl eqid fmptd cvv ovex elmap sylibr syl syl2anc cseq
        simp3d cli ad2antrr ffvelrnda wceq fveq2d eqtrd syl6eleq wb mpbid fveq2
        weq fveq1d sumeq2sdv fvmpt oveq2 mpteq2dv adantl ad2antlr cuz mpteq2dva
        mptex ax-mp cdv oveq2d ffvelrnd expcl mulcld cn crab csup oveq1 oveq12d
        cbvmptv peano2nn0 nn0cnd seqeq3d syl5eq eqtri eqeltrd cpr prid2 cmap c2
        ad3antrrr cdiv ccom cbl cxmt pserdvlem1 blssm eqeltri ccncf psercn ccnv
        cncff cicc cima psercnlem2 simp2d sstrd fssres eqidd rexrd cpnf iccssxr
        abscld radcnvcl cnmetdval sylancl subid1d simpr elbl3 syl22anc eqbrtrrd
        sseldi xrlttrd radcnvlt2 isumclim2 sumex breqtrrd sumeq1d fsumser seqfn
        3eqtrd wfn fneq2i mpbir dffn5 mpbi syl6eqr fvres 3brtr4d cif culm ctopn
        ccnfld crest ctop cnfldtop cnfldtopon toponunii restid eqcomi cnfldtopn
        blopn syl5eqel 3ad2ant1 3adant2 3ad2ant2 adantlr id syl2anr syldan c0ex
        ifex dvexp2 dvmptres dvmptcmul dvmptcl 3impa pserval2 dvmptfsum nnssnn0
        w3a resmpt cdm oveq1d mpteq2ia eqtr4i syl6eq cbvrabv supeq1i psercnlem1
        eleq1d cico cnvimass absf fdmi sseqtri eqsstri avglt2 cle rpge0d absidd
        rpred eqbrtrd dvradcnv radcnvle xrltletrd pserulm sumeq2dv breqtrd nnuz
        rpcnd nn0ex 1e0p1 fveq2i 1z sylan feq1d mpbird serf an32s elfznn nnne0d
        neneqd iffalse sumeq2i nnz nnnn0d nncnd nnm1nn0 fsumshftm oveq1i fzp1ss
        wn cdif eldif wo elfzuz2 elfzp12 ibi ord con1d imp sylbi difeq2i eleq2s
        iftrue eldifi mul01d fsumss 1m1e0 sumeq1i mul12d ax-1cn mulassd 3eqtr4d
        pncan 3eqtr3d eqtr4d ulmshft syl5eqbr 1nn0 ulmres ulmdv ) AOUHZGUIZUJZU
        CUKUDIULCEUMIUHZUNUOZUEUHZCUHZLUPZUPZUEUQZURZURZKEUSZCEULVXKUTVBUOZVYAD
        UPZVAUOZVXNVXKVCUOZVAUOZIUQZURZUMEULVDUKVEUKUUAUIZVXJVEUKVFUUBZVGUMVHUI
        ZVXJVIVGZVXJIULVXRUKEUUCUOZVXSVXJVXKULUIZUJZEUKVXRVJVXRVYLUIVYNCEVXQUKV
        XRVYNVXNEUIZUJZVXLVXPUEVYPUMVXKVKVYPULUKVXOVJVXMULUIZVXPUKUIVXMVXLUIVYP
        BDJLVXNPAULUKDVJZVXIVYMVYORUUEVYNEUKVXNVXJEUKVLZVYMVXJEUMVXHVMUPZMVBUOU
        UDUUFUOZVMVRUUGZUUHUPZUOZUKUBVXJWUBUKUUIUPUIZUMUKUIZWUAVNUIZWUDUKVLWUEV
        XJVOVGZWUFVXJVPVGZVXJWUAVXJWUAVQUIZVYTWUAVSVTZWUAFVSVTZABCDFGHJKLMNOPQR
        STUAUUJZWAZWBZWUBUMWUAUKUUKWCWDZWEWFWGVXMVXKWHULUKVXMVXOWIWJWKVXRWLWMUK
        EVXRVFEWUDWNUBUMWUAWUCWOUULZWPWQVXSWLZWMVXJGUKKVJZEGVLEUKVXTVJAWUSVXIAK
        GUKUUMUOUIWUSABCDFGHJKLMNOPQRSTUAUUNGUKKUUPWRWEVXJEVMUUOZUMWUAUUQUOUURZ
        GVXJEWUDWVAUBVXJVXHWUDUIZWUDWVAVLZWVAGVLZABCDFGHJKLWUANOPQRSTWUMUUSZUUT
        WDZVXJWVBWVCWVDWVEXAUVAZGUKEKUVBWSVXJUCUHZEUIZUJZVBWVHLUPZUMWTZWVHKUPZU
        DULWVHUDUHZVXSUPZUPZURZWVHVXTUPZXBWVJWVLULHUHZWVKUPZHUQZWVMXBWVJWVTHWVK
        UMULVDVYJWVJVIVGWVJWVSULUIZUJWVTUVCWVJULUKWVSWVKWVJBDJLWVHPAVYRVXIWVIRX
        CZVXJEUKWVHWUPWFZWGZXDWVJBDFJLWVHNPWWCSWWDWVJWVHVMUPZWUAFWVJWWFWVJWVHWW
        DUVGUVDVXJWUGWVIWUOWEZAFVNUIVXIWVIAUMUVEUUQUOZVNFUMUVEUVFZABDFJLNPRSUVH
        UVPXCWVJWVHUMWUBUOZWWFWUAVSWVJWWJWVHUMVRUOZVMUPZWWFWVJWVHUKUIZWUFWWJWWL
        XEWWDVPWVHUMWUBWUBWLUVIUVJWVJWWKWVHVMWVJWVHWWDUVKXFXGWVJWVHWUDUIZWWJWUA
        VSVTZWVJWVHEWUDVXJWVIUVLUBXHWVJWUEWUGWUFWWMWWNWWOXIWUEWVJVOVGWWGWUFWVJV
        PVGWWDWVHWUBUMWUAUKUVMUVNXJUVOVXJWULWVIVXJWUJWUKWULWUMXAWEUVQUVRUVSWVJW
        VHGUIWVMWWAXEVXJEGWVHWVGWFCWVHULWVSVXOUPZHUQWWAGKCUCXLZULWWPWVTHWWQWVSV
        XOWVKVXNWVHLXKZXMXNQULWVTHUVTXOWRUWAWVJWVQUDULWVNWVLUPZURZWVLWVJUDULWVP
        WWSWVJWVNULUIZUJZWVPWVHCEUMWVNUNUOZVXPUEUQZURZUPZWXCVXMWVKUPZUEUQZWWSWX
        BWVHWVOWXEWXAWVOWXEXEZWVJIWVNVXRWXEULVXSIUDXLZCEVXQWXDWXJVXLWXCVXPUEVXK
        WVNUMUNXPUWBXQWURCEWXDWUQYBXOZXRXMWVIWXFWXHXEVXJWXACWVHWXDWXHEWXEWWQWXC
        VXPWXGUEWWQVXMVXOWVKWWRXMXNWXEWLWXCWXGUEUVTXOXSWXBWXGUEWVKUMWVNWXBVXMWX
        CUIZUJWXGUVCWXBWVNULUMXTUPZWVJWXAUVLVDXHWXBULUKWVKVJZVYQWXGUKUIWXLWVJWX
        NWXAWWEWEVXMWVNWHZULUKVXMWVKWIWJUWCUWEYAWVLULUWFZWVLWWTXEWXPWVLWXMUWFZV
        YJWXQVIVBWVKUMUWDYCULWXMWVLVDUWGUWHUDULWVLUWIUWJUWKWVIWVRWVMXEVXJWVHEKU
        WLXRUWMVXJUDULUKWVOYDUOZURUDULCEWXCVXMDUPZVXMUMXEZUMVXMVXNVXMUTVRUOZVCU
        OZVAUOZUWNZVAUOZUEUQZURZURZVYGEUWOUPZVXJUDULWXRWYGVXJWXAUJZWXRUKWXEYDUO
        WYGWYJWVOWXEUKYDWXAWXIVXJWXKXRYEWYJCVXPWYEUKUEWXCUWQUWPUPZWYKEWYKUKUWRU
        OZWYKWYKUWSUIWYLWYKXEWYKWYKWLZUWTWYKUWSUKUKWYKWYKWYMUXAUXBUXCYCUXDZWYMV
        YHWYJVYIVGVXJEWYKUIZWXAVXJEWUDWYKUBVXJWUEWUFWUGWUDWYKUIWUHWUIWUOWUBUMWU
        AWYKUKWYKWYMUXEUXFWCUXGZWEWYJUMWVNVKWYJWXLVYOUYEZULUKVXMVXOWYQBDJLVXNPW
        YJWXLVYRVYOAVYRVXIWXARXCZUXHWYJVYOVXNUKUIZWXLWYJEUKVXNVXJVYSWXAWUPWEWFZ
        UXIWGWXLWYJVYQVYOWXOUXJYFWYJWXLVYOWYEUKUIZWYJWXLUJZCWXSVXNVXMVCUOZVAUOZ
        WYEUKWNEVYHXUBVYIVGZXUBVYOUJZWXSXUCXUBWXSUKUIZVYOWYJVYRVYQXUGWXLWYRWXOU
        LUKVXMDWIZWJZWEXUBVYOWYSXUCUKUIZWYJVYOWYSWXLWYTUXKZWYSWYSVYQXUJXUBWYSUX
        LWXLVYQWYJWXOXRZVXNVXMYGZUXMZUXNZYHWYEWNUIXUFWXSWYDVAWOVGXUBCXUCWYDWXSU
        KWNEXUEXUOWYDWNUIZXUFWXTUMWYCUXOVXMWYBVAWOUXPZVGXUBCXUCWYDUKWYKWYKWNUKE
        XUEXUNXUPXUBWYSUJXUQVGXUBVYQUKCUKXUCURYDUOCUKWYDURXEXULCVXMUXQWRVXJVYSW
        XAWXLWUPXCWYNWYMVXJWYOWXAWXLWYPXCUXRXUIUXSZUXTZUYAXUBUKCEVXPURZYDUOUKCE
        XUDURZYDUOCEWYEURXUBXUTXVAUKYDXUBCEVXPXUDXUFWYSVYQVXPXUDXEXUKWXLVYQWYJV
        YOWXOXSBDJLVXMVXNPUYBWSYAYEXURXGUYCXGYAVXJWYHVYGWYIVTWYHYIUSZVYGWYIVTVX
        JXVBUDYIWYGURZVYGWYIYIULVLXVBXVCXEUYDUDULYIWYGUYFYCVXJHULCEWVSVBVXNOUKU
        EULVXMUTVBUOZXVDDUPZVAUOZVXHVXMVCUOZVAUOZURZURZUPZUMWTZUPZURZURZVYGWYIV
        TXVCVYGWYIVTVXJXVOCEULVXKXVKUPZIUQZURZVYGWYIVXJBUCUDULWVNUTVBUOZXVSDUPZ
        VAUOZURZVBNUHZXVJUPZUMWTZXBUYGZUIZNVEYJZVNVSYKZEUDIJXVRXVJXVOWUAHOBUKXV
        IJULJUHZXWBUPZBUHZXWJVCUOZVAUOZURZOBXLZXVIUEULXVFXWLVXMVCUOZVAUOZURZXWO
        XWPUEULXVHXWRXWPXVGXWQXVFVAVXHXWLVXMVCYLYEXQXWSJULXWJUTVBUOZXWTDUPZVAUO
        ZXWMVAUOZURXWOUEJULXWRXXCUEJXLZXVFXXBXWQXWMVAXXDXVDXWTXVEXXAVAVXMXWJUTV
        BYLZXXDXVDXWTDXXEXFYMVXMXWJXWLVCXPYMYNJULXWNXXCXWJULUIXWKXXBXWMVAUDXWJX
        WAXXBULXWBUDJXLZXVSXWTXVTXXAVAWVNXWJUTVBYLZXXFXVSXWTDXXGXFYMXWBWLZXWTXX
        AVAWOXOUYHUYIUYJUYKYNZCUCEXVQULVXKWVHXVJUPZUPZIUQWWQULXVPXXKIWWQVXKXVKX
        XJVXNWVHXVJXKZXMXNYNVXJUDULXWAUKXWBWYJXVSXVTWYJXVSWXAXVSULUIVXJWVNYOXRZ
        YPWYJULUKXVSDWYRXXMYFYHXXHWMZVNXWHVBWVSXVJUPZUMWTZXWFUIZHVEYJVSXWGXXQNH
        VENHXLZXWEXXPXWFXXRXWDXXOVBUMXWCWVSXVJXKYQUYOUYLUYMZHUDULXVNUCEWVNVBXXJ
        UMWTZUPZURZHUDXLZXVNUCEWVSXXTUPZURXYBCUCEXVMXYDWWQWVSXVLXXTWWQXVKXXJVBU
        MXXLYQXMYNXYCUCEXYDXYAWVSWVNXXTXKXQYRYNVXJWUAWUNVUFVXJWUAMXWIWUOVXJMVXJ
        MVQUIZVYTMVSVTZMFVSVTZABCDFGHJKLMNOPQRSTUAUYNZWAZWBVXJWWHVNXWIWWIVXJBXW
        BXWIJXVJHXXIXXNXXSUVHUVPVXJXYFWUAMVSVTZVXJXYEXYFXYGXYHUUTVXJVYTVEUIMVEU
        IXYFXYJXIVXJVXHAGUKVXHGUKVLAGWUTUMFUYPUOZUURZUKTXYLVMUYGUKVMXYKUYQUKVEV
        MUYRUYSUYTVUAVGWFUVGVXJMXYIVUFZVYTMVUBWSXJVXJMVMUPZMXWIVUCVXJMXYMVXJMXY
        IVUDVUEZVXJBXWBXWIJXVJMHXXIXXNXXSVXJMXYIVUOZVXJVBMXVJUPZUMWTVBUEULXVFMV
        XMVCUOZVAUOZURZUMWTXWFVXJXYQXYTVBUMVXJMUKUIXYQXYTXEXYPUFMUEULXVFUFUHZVX
        MVCUOZVAUOZURZXYTUKXVJYUAMXEZUEULYUCXYSYUEYUBXYRXVFVAYUAMVXMVCYLYEXQOUF
        UKXVIYUDOUFXLZUEULXVHYUCYUFXVGYUBXVFVAVXHYUAVXMVCYLYEXQYNUEULXYSVUPYBXO
        WRYQVXJCDFUELXYTMUGLBUKJULXWJDUPZXWMVAUOZURZURCUKUEULXUDURZURPBCUKYUIYU
        JBCXLZYUIUEULWXSXWQVAUOZURYUJJUEULYUHYULJUEXLYUGWXSXWMXWQVAXWJVXMDXKXWJ
        VXMXWLVCXPYMYNYUKUEULYULXUDYUKXWQXUCWXSVAXWLVXNVXMVCYLYEXQYRYNYSFVBXWCL
        UPZUMWTZXWFUIZNVEYJZVNVSYKVBUGUHZLUPZUMWTZXWFUIZUGVEYJZVNVSYKSVNYUPYVAV
        SYUOYUTNUGVENUGXLZYUNYUSXWFYVBYUMYURVBUMXWCYUQLXKYQUYOUYLUYMYSXYTWLAVYR
        VXIRWEZXYPVXJXYNMFVSXYOVXJXYEXYFXYGXYHXAVUGVUHYTVUIUVOVUJWVFVUKVXJCEXVQ
        VYFVXJVYOUJZULXVPVYEIYVDVYMUJZXVPVXKUEULXVFXUCVAUOZURZUPZVYEYVEVXKXVKYV
        GYVDXVKYVGXEZVYMYVDWYSYVIVXJEUKVXNWUPWFZOVXNXVIYVGUKXVJOCXLZUEULXVHYVFY
        VKXVGXUCXVFVAVXHVXNVXMVCYLYEXQXVJWLUEULYVFVUPYBXOZWRZWEXMVYMYVHVYEXEZYV
        DUEVXKYVFVYEULYVGUEIXLZXVFVYCXUCVYDVAYVOXVDVYAXVEVYBVAVXMVXKUTVBYLZYVOX
        VDVYADYVPXFYMVXMVXKVXNVCXPYMYVGWLZVYCVYDVAWOXOZXRXGVULYAVUMVXJEUDXVOVYG
        XVCUTUMYIULVDYIUTXTUPUMUTVBUOZXTUPVUNUTYVSXTVUQVURYSVYKUTVHUIZVXJVUSVGV
        XJHULXVNVYLXVOVXJWWBUJZEUKXVNVJXVNVYLUIYWACEXVMUKXVNVXJVYOWWBXVMUKUIYVD
        ULUKWVSXVLYVDUDXVKUMULVDVYJYVDVIVGYVDULUKWVNXVKYVDULUKXVKVJULUKYVGVJYVD
        UEULYVFUKYVGYVDVYQUJZXVFXUCYWBXVDXVEVYQXVDUKUIYVDVYQXVDVXMYOZYPXRYVDVYR
        XVDULUIXVEUKUIVYQAVYRVXIVYORXCYWCULUKXVDDWIWJYHYVDWYSVYQXUJYVJXUMVUTYHY
        VQWMYVDULUKXVKYVGYVMVVAVVBXDVVCXDVVDXVNWLWMUKEXVNVFWUQWPWQXVOWLZWMVXJUD
        YIWYGWVNUTVRUOZXVOUPZVXJWVNYIUIZUJZWYGCEYWEXVLUPZURZYWFYWHCEWYFYWIYWHVY
        OUJZUTWVNUNUOZWYEUEUQZUTUTVRUOZYWEUNUOZVYBVYAVXNVYAUTVRUOZVCUOZVAUOZVAU
        OZIUQZWYFYWIYWKYWMYWLWXSWYCVAUOZUEUQYWTYWLWYEYXAUEVXMYWLUIZWYDWYCWXSVAY
        XBWXTVVQWYDWYCXEYXBVXMUMYXBVXMVXMWVNVVEZVVFVVGWXTUMWYCVVHWRYEZVVIYWKYXA
        YWSUEIUTUTWVNYVTYWKVUSVGZYXEYWGWVNVHUIVXJVYOWVNVVJXSYWKYXBUJZWXSWYCYWKV
        YRVYQXUGYXBVXJVYRYWGVYOYVCXCZYXBVXMYXCVVKXUHWJYXFVXMWYBYXFVXMYXBVXMYIUI
        ZYWKYXCXRVVLYWKWYSWYAULUIZWYBUKUIYXBVXJVYOWYSYWGYVJUXKZYXBYXHYXIYXCVXMV
        VMWRVXNWYAYGWJYHYHZVXMVYAXEZWXSVYBWYCYWRVAVXMVYADXKYXLVXMVYAWYBYWQVAYXL
        UXLYXLWYAYWPVXNVCVXMVYAUTVRYLYEYMYMVVNYRYWKYWLWXCWYEUEYWLWXCVLYWKYWLYVS
        WVNUNUOZWXCUTYVSWVNUNVUQVVOZVYJYXMWXCVLVIUMWVNVVPYCVUAVGYXFWYEYXAUKYXBW
        YEYXAXEYWKYXDXRYXKYTYWKVXMWXCYWLVVRZUIZUJZWYEWXSUMVAUOUMYXQWYDUMWXSVAYX
        QWXTWYDUMXEYXPWXTYWKWXTVXMWXCYXMVVRZYXOVXMYXRUIWXLVXMYXMUIZVVQZUJWXTVXM
        WXCYXMVVSWXLYXTWXTWXLWXTYXSWXLWXTYXSWXLWXTYXSVVTZWXLWVNWXMUIWXLYYAXIVXM
        UMWVNVWAVXMUMWVNVWBWRVWCVWDVWEVWFVWGYWLYXMWXCYXNVWHVWIXRWXTUMWYCVWJWRYE
        YXQWXSYWKVYRVYQXUGYXPYXGYXPWXLVYQVXMWXCYWLVWKWXOWRXUHWJVWLXGYWKUMWVNVKV
        WMYWKYWTUMYWEUNUOZYWSIUQYWIYWOYYBYWSIYWNUMYWEUNVWNVVOVWOYWKYWSIXVKUMYWE
        YWKVXKYYBUIZUJZYVHVYEXVPYWSYYDVYMYVNYYCVYMYWKVXKYWEWHZXRZYVRWRYYDVXKXVK
        YVGYYDWYSYVIYWKWYSYYCYXJWEYVLWRXMYYDVYBVYAVYDVAUOZVAUOVYAVYBVYDVAUOVAUO
        YWSVYEYYDVYBVYAVYDYYDULUKVYADYWKVYRYYCYXGWEYYDVYMVYAULUIYYFVXKYOWRZYFZY
        YDVYAYYHYPZYWKWYSVYMVYDUKUIYYCYXJYYEVXNVXKYGWJZVWPYYDYWRYYGVYBVAYYDYWQV
        YDVYAVAYYDYWPVXKVXNVCYYDVXKUKUIUTUKUIYWPVXKXEYYDVXKYYFYPVWQVXKUTVWTUVJY
        EZYEYEYYDVYAVYBVYDYYJYYIYYKVWRVWSVWSYWKYWEULWXMYWHYWEULUIZVYOYWGYYMVXJW
        VNVVMXRZWEVDXHYYDVYBYWRYYIYYDVYAYWQYYJYYDYWQVYDUKYYLYYKYTYHYHUWCYRVXAYA
        YWHYYMYWFYWJXEYYNHYWEXVNYWJULXVOWVSYWEXECEXVMYWIWVSYWEXVLXKXQYWDCEYWIWU
        QYBXOWRVXBYAVXCXJVXDVXJEWYHVYGUMUTYIULVDVUNUTULUIVXJVXEVGVXJUDULWYGVYLW
        YHWYJEUKWYGVJWYGVYLUIWYJCEWYFUKWYGWYJVYOUJZWXCWYEUEYYOUMWVNVKWYJWXLVYOX
        UAXUSVVDWKWYGWLWMUKEWYGVFWUQWPWQWYHWLWMVXFVVBVUGVXG $.

      $( The derivative of a power series on its region of convergence.
         (Contributed by Mario Carneiro, 31-Mar-2015.) $)
      pserdv $p |- ( ph -> ( CC _D F ) = ( y e. S |->
       sum_ k e. NN0 ( ( ( k + 1 ) x. ( A ` ( k + 1 ) ) ) x. ( y ^ k ) ) ) ) $=
        ( cc cdv co cn0 cv c1 caddc cfv cmul cexp csu cmpt cdm wf dvfcn wss a1i
        ssid ccncf wcel psercn cncff syl cabs ccnv cico cima cnvimass absf fdmi
        cc0 cr sseqtri eqsstri dvbss wa cres ccnfld ctopn wceq adantr cdiv cmin
        cnt c2 ccom cbl cxmt cxr cnxmet 0cn sselda abscld crp psercnlem1 simp1d
        clt wbr rpred readdcld 0re absge0d ltaddrpd elrpd rphalfcld rpxrd blssm
        lelttrd syl3anc syl5eqss eqid ctop cnfldtop cnfldtopon toponunii restid
        crest ax-mp eqcomi dvres syl22anc resss dmss cicc pserdvlem1 psercnlem2
        syl6eqss syl6eleqr pserdvlem2 dmeqd dmmptg sumex syl6eq oveq1 sumeq2sdv
        cvv weq oveq2d mprg eleqtrrd sseldd ssrdv eqssd feq2d feqmptd wfun ffun
        ex mpbii mp1i funssfv fveq1d fvmpt 3eqtrd mpteq2dva eqtrd cbvmptv ) AUC
        KUDUEZOGUFIUGZUHUIUEZUVBDUJUKUEZOUGZUVAULUEZUKUEZIUMZUNZCGUFUVCCUGZUVAU
        LUEZUKUEZIUMZUNAUUTOGUVDUUTUJZUNUVHAOGUCUUTAUUTUOZUCUUTUPZGUCUUTUPKUQZA
        UVNGUCUUTAUVNGAGUCKUCUCURZAUCUTZUSAKGUCVAUEVBGUCKUPZABCDFGHJKLMNOPQRSTU
        AVCGUCKVDVEZGUCURZAGVFVGZVMFVHUEZVIZUCTUWDVFUOUCVFUWCVJUCVNVFVKVLVOVPZU
        SZVQAOGUVNAUVDGVBZUVDUVNVBAUWGVRZUCKEVSUDUEZUOZUVNUVDUWHUWIUUTURZUWJUVN
        URUWHUWIUUTEVTWAUJZWFUJUJZVSZUUTUWHUVQUVSUWAEUCURUWIUWNWBUVQUWHUVRUSAUV
        SUWGUVTWCUWAUWHUWEUSUWHEVMUVDVFUJZMUIUEZWGWDUEZVFWEWHZWIUJUEZUCUBUWHUWR
        UCWJUJVBZVMUCVBZUWQWKVBUWSUCURUWTUWHWLUSUXAUWHWMUSUWHUWQUWHUWPUWHUWPUWH
        UWOMUWHUVDAGUCUVDUWFWNZWOZUWHMUWHMWPVBUWOMWSWTMFWSWTABCDFGHJKLMNOPQRSTU
        AWQWRZXAXBZUWHVMUWOUWPVMVNVBUWHXCUSUXCUXEUWHUVDUXBXDUWHUWOMUXCUXDXEXJXF
        XGXHUWRVMUWQUCXIXKXLGEUCUWLKUWLUWLXMZUWLUCXSUEZUWLUWLXNVBUXGUWLWBUWLUXF
        XOUWLXNUCUCUWLUWLUXFXPXQXRXTYAYBYCUUTUWMYDYIZUWIUUTYEVEUWHUVDEUWJUWHUVD
        UWSEUWHUVDUWSVBUWSUWBVMUWQYFUEVIZURUXIGURABCDFGHJKLUWQNOPQRSTABCDFGHJKL
        MNOPQRSTUAYGYHWRUBYJZUWHUWJCEUVLUNZUOZEUWHUWIUXKABCDEFGHIJKLMNOPQRSTUAU
        BYKZYLUVLYRVBZUXLEWBCECEUVLYRYMUXNUVIEVBUFUVKIYNUSUUAYOUUBZUUCUUJUUDUUE
        UUFUUKUUGAOGUVMUVGUWHUVMUVDUWIUJZUVDUXKUJZUVGUWHUUTUUHZUWKUVDUWJVBUVMUX
        PWBUVOUXRUWHUVPUVNUCUUTUUIUULUXHUXOUVDUUTUWIUUMXKUWHUVDUWIUXKUXMUUNUWHU
        VDEVBUXQUVGWBUXJCUVDUVLUVGEUXKCOYSZUFUVKUVFIUXSUVJUVEUVCUKUVIUVDUVAULYP
        YTYQUXKXMUFUVFIYNUUOVEUUPUUQUUROCGUVGUVLOCYSZUFUVFUVKIUXTUVEUVJUVCUKUVD
        UVIUVAULYPYTYQUUSYO $.

      $( The derivative of a power series on its region of convergence.
         (Contributed by Mario Carneiro, 31-Mar-2015.) $)
      pserdv2 $p |- ( ph -> ( CC _D F ) = ( y e. S |->
        sum_ k e. NN ( ( k x. ( A ` k ) ) x. ( y ^ ( k - 1 ) ) ) ) ) $=
        ( vm cc cdv co cn0 cv c1 caddc cfv cmul cexp csu cmpt cn cmin pserdv wa
        wcel cc0 nn0uz cuz nnuz 1e0p1 fveq2i eqtri wceq id fveq2 oveq12d oveq2d
        oveq1 cz 1z a1i 0z nncn adantl wf adantr ffvelrn syl2an mulcld wss cabs
        ccnv cico cima cdm cnvimass cr absf fdmi sseqtri eqsstri sselda nnm1nn0
        nnnn0 expcl isumshft ax-1cn nn0cn addcom sylancr fveq2d pncan2 sumeq2dv
        eqtr2d mpteq2dva eqtrd ) AUDKUEUFCGUGUCUHZUIUJUFZXMDUKZULUFZCUHZXLUMUFZ
        ULUFZUCUNZUOCGUPIUHZXTDUKZULUFZXPXTUIUQUFZUMUFZULUFZIUNZUOABCDEFGHUCJKL
        MNOPQRSTUAUBURACGXSYFAXPGUTZUSZYFUGUIXLUJUFZYIDUKZULUFZXPYIUIUQUFZUMUFZ
        ULUFZUCUNXSYHYEYNIUCUIVAUPUGVBUPUIVCUKVAUIUJUFZVCUKVDUIYOVCVEVFVGXTYIVH
        ZYBYKYDYMULYPXTYIYAYJULYPVIXTYIDVJVKYPYCYLXPUMXTYIUIUQVMVLVKUIVNUTYHVOV
        PVAVNUTYHVQVPYHXTUPUTZUSZYBYDYRXTYAYQXTUDUTYHXTVRVSYHUGUDDVTZXTUGUTYAUD
        UTYQAYSYGRWAXTWSUGUDXTDWBWCWDYHXPUDUTYCUGUTYDUDUTYQAGUDXPGUDWEAGWFWGVAF
        WHUFZWIZUDTUUAWFWJUDWFYTWKUDWLWFWMWNWOWPVPWQXTWRXPYCWTWCWDXAYHUGYNXRUCY
        HXLUGUTZUSZYKXOYMXQULUUCYIXMYJXNULUUCUIUDUTZXLUDUTZYIXMVHXBUUBUUEYHXLXC
        VSZUIXLXDXEZUUCYIXMDUUGXFVKUUCYLXLXPUMUUCUUDUUEYLXLVHXBUUFUIXLXGXEVLVKX
        HXIXJXK $.
    $}
  $}

  ${
    $d i j k m n w x y z M $.  $d i j k m n w x y z R $.  $d i j k n r x z X $.
    $d i j k m n r t v w x y z A $.  $d k n N $.  $d i j k m n r v w x y ph $.
    $d i j r w y F $.  $d i j k m n r w x y S $.
    abelth.1 $e |- ( ph -> A : NN0 --> CC ) $.
    abelth.2 $e |- ( ph -> seq 0 ( + , A ) e. dom ~~> ) $.
    $( Lemma for ~ abelth .  (Contributed by Mario Carneiro, 1-Apr-2015.) $)
    abelthlem1 $p |- ( ph -> 1 <_ sup ( { r e. RR | seq 0 ( + ,
      ( ( z e. CC |-> ( n e. NN0 |-> ( ( A ` n ) x. ( z ^ n ) ) ) ) ` r ) )
        e. dom ~~> } , RR* , < ) ) $=
      ( c1 cfv caddc cv cc cn0 cexp co cmul cmpt cc0 cseq wcel cabs cli cr crab
      cdm cxr clt csup cle abs1 eqid ax-1cn feqmptd ffvelrnda mulid1d mpteq2dva
      wa eqtr4d wceq oveq1 cz nn0z 1exp sylan9eq oveq2d nn0ex mptex fvmpt ax-mp
      a1i syl syl6eqr seqeq3d eqeltrrd radcnvle syl5eqbrr ) AHHUAIJEKBLDMDKZCIZ
      BKZVQNOZPOZQZQZIRSUBUEZTEUCUDUFUGUHZUIUJABCWEDWCHEWCUKZFWEUKHLTZAULVJAJCR
      SJHWCIZRSWDACWHJRACDMVRHPOZQZWHACDMVRQWJADMLCFUMADMWIVRAVQMTZUQVRAMLVQCFU
      NUOUPURWGWHWJUSULBHWBWJLWCVSHUSZDMWAWIWLWKUQVTHVRPWLWKVTHVQNOZHVSHVQNUTWK
      VQVATWMHUSVQVBVQVCVKVDVEUPWFDMWIVFVGVHVIVLVMGVNVOVP $.

    abelth.3 $e |- ( ph -> M e. RR ) $.
    abelth.4 $e |- ( ph -> 0 <_ M ) $.
    abelth.5 $e |- S = { z e. CC |
      ( abs ` ( 1 - z ) ) <_ ( M x. ( 1 - ( abs ` z ) ) ) } $.
    $( Lemma for ~ abelth .  The peculiar region ` S ` , known as a _Stolz
       angle_ , is a teardrop-shaped subset of the closed unit ball containing
       ` 1 ` .  Indeed, except for ` 1 ` itself, the rest of the Stolz angle is
       enclosed in the open unit ball.  (Contributed by Mario Carneiro,
       31-Mar-2015.) $)
    abelthlem2 $p |- ( ph -> ( 1 e. S /\
      ( S \ { 1 } ) C_ ( 0 ( ball ` ( abs o. - ) ) 1 ) ) ) $=
      ( wcel cc0 cle wbr c1 cmin co cc cmul clt cr csn cdif cabs cbl cfv wss wa
      ccom ax-1cn a1i 0le0 simpl recnd mul01d syl5breqr wceq oveq2 1m1e0 syl6eq
      cv abs00bd fveq2 abs1 oveq2d breq12d elrab2 sylanbrc cun crab w3a wo elsn
      wn wne necon3bbii simprll 0cn eqid cnmetdval sylancl subid1d fveq2d eqtrd
      wi simprlr subcl sylancr abscld simpll 1re resubcl remulcld lenltd adantr
      mpbid simprr necomd wb subeq0 necon3bid mpbird absgt0 syl eqbrtrd syl5eqr
      breq1d syl5ibcom necon3bd mpd caddc oveq2i abs2dif syl5eqbrr abssub letrd
      breqtrd addsubd subdid mulid1d oveq1d eqtr4d breqtrrd peano2re leaddsub2d
      lesubaddd adddird mulid2d 3brtr4d 0re simplr ltp1d lelttrd lemul2 leltned
      syl112anc cxmt cxr cnxmet crp 1rp rpxr ax-mp elbl3 expr 3impb syl5bi orrd
      mpanl12 elun sylibr rabssdv syl5eqss ssundif sylib jca syl2anc ) AEUAKZLE
      MNZODKZDOUBZUCLOUDPUIZUEUFQZUGZUHHIUURUUSUHZUUTUVDUVEORKZLELSQZMNZUUTUVFU
      VEUJUKUVELLUVGMULUVEEUVEEUURUUSUMUNZUOZUPOBVAZPQZUDUFZEOUVKUDUFZPQZSQZMNZ
      UVHBORDUVKOUQZUVMLUVPUVGMUVRUVLUVRUVLOOPQZLUVKOOPURUSUTVBUVRUVOLESUVRUVOU
      VSLUVRUVNOOPUVRUVNOUDUFZOUVKOUDVCVDUTVEUSUTVEVFJVGVHUVEDUVAUVCVIZUGUVDUVE
      DUVQBRVJUWAJUVEUVQBRUWAUVEUVKRKZUVQVKZUVKUVAKZUVKUVCKZVLUVKUWAKUWCUWDUWEU
      WDVNUVKOVOZUWCUWEUWDUVKOBOVMVPUVEUWBUVQUWFUWEWEUVEUWBUVQUHZUWFUWEUVEUWGUW
      FUHZUHZUWEUVKLUVBQZOTNZUWIUWJUVNOTUWIUWJUVKLPQZUDUFZUVNUWIUWBLRKZUWJUWMUQ
      UVEUWBUVQUWFVQZVRUVKLUVBUVBVSVTWAUWIUWLUVKUDUWIUVKUWOWBWCWDUWIUVNOTNOUVNV
      OZUWIUVPUVMTNZVNZUWPUWIUVQUWRUVEUWBUVQUWFWFZUWIUVMUVPUWIUVLUWIUVFUWBUVLRK
      ZUJUWOOUVKWGWHZWIZUWIEUVOUURUUSUWHWJZUWIOUAKZUVNUAKZUVOUAKWKUWIUVKUWOWIZO
      UVNWLWHWMZWNWPUWIUWQOUVNUWIUVGUVMTNOUVNUQZUWQUWIUVGLUVMTUVEUVGLUQUWHUVJWO
      UWIUVLLVOZLUVMTNZUWIUXIOUVKVOZUWIUVKOUVEUWGUWFWQWRUWIUVFUWBUXIUXKWSUJUWOU
      VFUWBUHUVLLOUVKOUVKWTXAWHXBUWIUWTUXIUXJWSUXAUVLXCXDWPXEUXHUVGUVPUVMTUXHLU
      VOESUXHLUVSUVOUSOUVNOPURXFVEXGXHXIXJUWIUVNOUXFUXDUWIWKUKZUWIUVNOMNZEOXKQZ
      UVNSQZUXNOSQZMNZUWIEUVNSQZUVNXKQZUXNUXOUXPMUWIUXSUXNMNUVNUXNUXRPQZMNUWIUV
      NUVPOXKQZUXTMUWIUVNOPQZUVPMNUVNUYAMNUWIUYBUVMUVPUWIUXEUXDUYBUAKUXFWKUVNOW
      LWAUXBUXGUWIUYBUVKOPQUDUFZUVMMUWIUYBUVNUVTPQZUYCMUVTOUVNPVDXLUWIUWBUVFUYD
      UYCMNUWOUJUVKOXMWAXNUWIUWBUVFUYCUVMUQUWOUJUVKOXOWAXQUWSXPUWIUVNOUVPUXFUXL
      UXGYFWPUWIUXTEUXRPQZOXKQUYAUWIEOUXRUVEERKUWHUVIWOZUVFUWIUJUKZUWIUXRUWIEUV
      NUXCUXFWMZUNXRUWIUVPUYEOXKUWIUVPEOSQZUXRPQUYEUWIEOUVNUYFUYGUWIUVNUXFUNZXS
      UWIUYIEUXRPUWIEUYFXTYAWDYAYBYCUWIUXRUVNUXNUYHUXFUWIUURUXNUAKZUXCEYDXDZYEX
      BUWIUXOUXROUVNSQZXKQUXSUWIEOUVNUYFUYGUYJYGUWIUYMUVNUXRXKUWIUVNUYJYHVEWDUW
      IUXNUWIUXNUYLUNXTYIUWIUXEUXDUYKLUXNTNUXMUXQWSUXFUXLUYLUWILEUXNLUAKUWIYJUK
      UXCUYLUURUUSUWHYKUWIEUXCYLYMUVNOUXNYNYPXBYOXBXEUWIUWNUWBUWEUWKWSZVRUWOUVB
      RYQUFKOYRKZUWNUWBUHUYNYSOYTKUYOUUAOUUBUUCUVKUVBLORUUDUUIWHXBUUEUUFUUGUUHU
      VKUVAUVCUUJUUKUULUUMDUVAUVCUUNUUOUUPUUQ $.

    $( Lemma for ~ abelth .  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    abelthlem3 $p |- ( ( ph /\ X e. S ) ->
      seq 0 ( + , ( n e. NN0 |-> ( ( A ` n ) x. ( X ^ n ) ) ) ) e. dom ~~> ) $=
      ( wcel c1 cc0 cfv co caddc cn0 cc vr csn cabs cmin ccom wo cexp cmul cmpt
      cbl cv cseq cli cdm wa cun cdif wss abelthlem2 simprd ssundif sylibr elun
      sselda sylib feqmptd ffvelrnda mulid1d mpteq2dva eqtr4d elsni oveq1d wceq
      nn0z 1exp syl sylan9eq oveq2d eqcomd seqeq3d adantr eqeltrrd cxmt cxr 0cn
      cnxmet 1re rexri blssm mp3an simpr sseldi oveq1 mpteq2dv eqid nn0ex mptex
      cz fvmpt cr crab clt csup wf abscld rexrd rexr mp1i cpnf iccssxr radcnvcl
      cnmetdval sylancl subid1d fveq2d eqtrd wbr wb elbl3 mpanl12 sylancr mpbid
      cicc eqbrtrrd cle abelthlem1 xrltletrd radcnvlt2 jaodan syldan ) AGDMZGNU
      BZMZGONUCUDUEZUJPQZMZUFZRESEUKZCPZGYRUGQZUHQZUIZOULZUMUNZMZAYKUOGYLYOUPZM
      YQADUUFGADYLUQYOURZDUUFURANDMUUGABCDFHIJKLUSUTDYLYOVAVBVDGYLYOVCVEAYMUUEY
      PAYMUOZRCOULZUUCUUDUUHCUUBROAYMCESYSNUHQZUIZUUBACESYSUIUUKAESTCHVFAESUUJY
      SAYRSMZUOYSASTYRCHVGVHVIVJYMUUBUUKYMESUUAUUJYMUULUOYTNYSUHYMUULYTNYRUGQZN
      YMGNYRUGGNVKVLUULYRWRMUUMNVMYRVNYRVOVPVQVRVIVSVQVTAUUIUUDMYMIWAWBAYPUOZRG
      BTESYSBUKZYRUGQZUHQZUIZUIZPZOULUUCUUDUUNUUTUUBROUUNGTMZUUTUUBVMUUNYOTGYNT
      WCPMZOTMZNWDMZYOTURWFWENWGWHZYNONTWIWJAYPWKZWLZBGUURUUBTUUSUUOGVMZESUUQUU
      AUVHUUPYTYSUHUUOGYRUGWMVRWNUUSWOZESUUAWPWQWSVPVTUUNBCRUAUKUUSPOULUUDMUAWT
      XAWDXBXCZEUUSGUAUVIASTCXDYPHWAZUVJWOZUVGUUNGUCPZNUVJUUNUVMUUNGUVGXEXFNWTM
      UVDUUNWGNXGXHUUNOXIYCQWDUVJOXIXJUUNBCUVJEUUSUAUVIUVKUVLXKWLUUNGOYNQZUVMNX
      BUUNUVNGOUDQZUCPZUVMUUNUVAUVCUVNUVPVMUVGWEGOYNYNWOXLXMUUNUVOGUCUUNGUVGXNX
      OXPUUNYPUVNNXBXQZUVFUUNUVCUVAYPUVQXRZWEUVGUVBUVDUVCUVAUOUVRWFUVEGYNONTXSX
      TYAYBYDANUVJYEXQYPABCEUAHIYFWAYGYHWBYIYJ $.

    abelth.6 $e |- F = ( x e. S |->
      sum_ n e. NN0 ( ( A ` n ) x. ( x ^ n ) ) ) $.
    $( Lemma for ~ abelth .  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    abelthlem4 $p |- ( ph -> F : S --> CC ) $=
      ( cn0 cfv co cmul cc wcel vm cv cexp csu wa cmpt cc0 nn0uz cz 0z a1i wceq
      fveq2 oveq2 oveq12d eqid ovex fvmpt adantl adantr ffvelrnda wss cmin cabs
      wf c1 cle crab ssrab2 eqsstri sselda expcl sylan mulcld abelthlem3 isumcl
      wbr fmptd ) ABEOFUBZDPZBUBZVSUCQZRQZFUDSGAWAETZUEZWCFUAOUAUBZDPZWAWFUCQZR
      QZUFZUGOUHUGUITWEUJUKVSOTZVSWJPWCULWEUAVSWIWCOWJWFVSULWGVTWHWBRWFVSDUMWFV
      SWAUCUNUOWJUPVTWBRUQURUSWEWKUEVTWBWEOSVSDAOSDVEWDIUTVAWEWASTWKWBSTAESWAES
      VBAEVFCUBZVCQVDPHVFWLVDPVCQRQVGVQZCSVHSMWMCSVIVJUKVKWAVSVLVMVNACDEUAHWAIJ
      KLMVOVPNVR $.

    ${
      abelth.7 $e |- ( ph -> seq 0 ( + , A ) ~~> 0 ) $.
      $( Lemma for ~ abelth .  (Contributed by Mario Carneiro, 1-Apr-2015.) $)
      abelthlem5 $p |- ( ( ph /\ X e. ( 0 ( ball ` ( abs o. - ) ) 1 ) ) ->
        seq 0 ( + , ( k e. NN0 |->
          ( ( seq 0 ( + , A ) ` k ) x. ( X ^ k ) ) ) ) e. dom ~~> ) $=
        ( c1 cfv wcel vm vj vi cc0 cabs cmin ccom cbl co wa cv cseq clt wbr cuz
        caddc wral cn0 cexp cmul cmpt cli cdm wrex nn0uz cz 0z a1i eqidd climi0
        crp 1rp adantr simprl cr wceq oveq2 eqid ovex fvmpt adantl cxmt cxr wss
        cc cnxmet 0cn rpxr ax-mp blssm mp3an simplr sseldi abscld reexpcl sylan
        eqeltrd weq fveq2 oveq12d wf ffvelrnda serf ad2antrr expcl mulcld recnd
        cdiv absidm syl cnmetdval sylancl subid1d fveq2d eqtrd wb elbl3 mpanl12
        sylancr mpbid eqbrtrrd eqbrtrd geolim climrel releldmi 1re cle ffvelrnd
        eluznn0 syldan absmuld absexpd oveq2d absge0d breqtrd simprr rspccva wi
        breq1d ltle mpd lemul1ad 3brtr4d cvgcmpce rexlimddv ) AJUDRUEUFUGZUHSUI
        ZTZUJZUAUKZUPDUDULZSZUESZRUMUNZUAUBUKZUOSZUQZUPFURFUKZUUKSZJUURUSUIZUTU
        IZVAZUDULVBVCZTUBURAUUQUBURVDUUHAUULRUBUAUUKUDURVEUDVFTAVGVHZRVKTZAVLVH
        AUUJURTUJUULVIQVJVMUUIUUOURTZUUQUJZUJZRUCGURJUESZGUKZUSUIZVAZUVBUDUUOUR
        VEUUIUVFUUQVNZUVHUCUKZURTZUJZUVNUVLSZUVIUVNUSUIZVOUVOUVQUVRVPZUVHGUVNUV
        KUVRURUVLUVJUVNUVIUSVQUVLVRUVIUVNUSVSVTZWAZUVHUVIVOTUVOUVRVOTZUVHJUVHUU
        GWEJUUFWEWBSTZUDWETZRWCTZUUGWEWDWFWGUVEUWEVLRWHWIZUUFUDRWEWJWKAUUHUVGWL
        ZWMZWNZUVIUVNWOWPZWQUVPUVNUVBSZUVNUUKSZJUVNUSUIZUTUIZWEUVOUWKUWNVPZUVHF
        UVNUVAUWNURUVBFUCWRUUSUWLUUTUWMUTUURUVNUUKWSUURUVNJUSVQWTUVBVRUWLUWMUTV
        SVTZWAUVPUWLUWMUVHURWEUVNUUKAURWEUUKXAZUUHUVGABDUDURVEUVDAURWEBUKDKXBXC
        XDZXBUVHJWETZUVOUWMWETZUWHJUVNXEWPZXFWQUVHUPUVLUDULZRRUVIUFUIXHUIZVBUNU
        XBUVCTUVHUVIUCUVLUVHUVIUWIXGUVHUVIUESZUVIRUMUVHUWSUXDUVIVPUWHJXIXJUVHJU
        DUUFUIZUVIRUMUVHUXEJUDUFUIZUESZUVIUVHUWSUWDUXEUXGVPUWHWGJUDUUFUUFVRXKXL
        UVHUXFJUEUVHJUWHXMXNXOUVHUUHUXERUMUNZUWGUVHUWDUWSUUHUXHXPZWGUWHUWCUWEUW
        DUWSUJUXIWFUWFJUUFUDRWEXQXRXSXTYAYBUWAYCUXBUXCVBYDYEXJRVOTZUVHYFVHUVHUV
        NUUPTZUJZUWNUESZRUVRUTUIZUWKUESRUVQUTUIYGUXLUXMUWLUESZUVRUTUIZUXNYGUXLU
        XMUXOUWMUESZUTUIUXPUXLUWLUWMUXLURWEUVNUUKUVHUWQUXKUWRVMUVHUVFUXKUVOUVMU
        VNUUOYIWPZYHZUVHUXKUVOUWTUXRUXAYJZYKUXLUXQUVRUXOUTUXLJUVNUVHUWSUXKUWHVM
        UXRYLZYMXOUXLUXORUVRUXLUWLUXSWNZUXJUXLYFVHUVHUXKUVOUWBUXRUWJYJUXLUDUXQU
        VRYGUXLUWMUXTYNUYAYOUXLUXORUMUNZUXORYGUNZUVHUUQUXKUYCUUIUVFUUQYPUUNUYCU
        AUVNUUPUAUCWRZUUMUXORUMUYEUULUWLUEUUJUVNUUKWSXNYSYQWPUXLUXOVOTUXJUYCUYD
        YRUYBYFUXORYTXLUUAUUBYBUXLUWKUWNUEUXLUVOUWOUXRUWPXJXNUXLUVQUVRRUTUXLUVO
        UVSUXRUVTXJYMUUCUUDUUE $.

      ${
        abelthlem6.1 $e |- ( ph -> X e. ( S \ { 1 } ) ) $.
        $( Lemma for ~ abelth .  (Contributed by Mario Carneiro,
           2-Apr-2015.) $)
        abelthlem6 $p |- ( ph -> ( F ` X ) =
          ( ( 1 - X ) x. sum_ n e. NN0
            ( ( seq 0 ( + , A ) ` n ) x. ( X ^ n ) ) ) ) $=
          ( cn0 co cc0 vk vi vm cfv cv cexp cmul csu c1 cmin cseq wcel wceq csn
          caddc eldifad oveq1 oveq2d sumeq2sdv sumex fvmpt syl cmpt nn0uz cz 0z
          a1i weq fveq2 oveq2 oveq12d eqid ovex adantl wa cc ffvelrnda cabs cle
          wbr crab ssrab2 eqsstri sseldi expcl mulcld cli cfz cvv serf ccom cbl
          sylan cdm cdif wss abelthlem2 simprd abelthlem5 mpdan isumclim2 seqex
          sseldd 0nn0 sumeq1d adantr elfznn0 ffvelrn syl2an fsumcl eqeltrd cshi
          fzfid wf peano2zd cuz cn nnuz 1e0p1 fveq2i eleq2i nnm1nn0 ax-1cn nncn
          eqtri nn0ex eqidd syl6eleq fsumser eqtr4d wb mp2an ax-mp syl6eq eqtrd
          3eqtr4d c0 simpr oveq1d subdird shftval sylancr expm1t mulcomd mul12d
          mptex nnnn0 sylan2br seqfeq isermulc2 1z isershft sylib eqbrtrrd seq1
          clim2ser2 clt cr 0re ltm1 peano2zm fzn mpbi sum0 mul02d syl5eq isumcl
          sylancl addid1d breqtrd fsumm1 eqtr3d pncan2d eqtr2d climsub breqtrrd
          simpl sersub mulid2d isumclim ) AIGUDZRFUEZDUDZIUWBUFSZUGSZFUHZUIIUJS
          RUWBUODTUKZUDZUWDUGSZFUHZUGSZAIEULUWAUWFUMAIEUIUNZQUPZBIRUWCBUEZUWBUF
          SZUGSZFUHUWFEGUWNIUMZRUWPUWEFUWQUWOUWDUWCUGUWNIUWBUFUQURUSORUWEFUTVAV
          BAUWEUWKFUARUAUEZDUDZIUWRUFSZUGSZVCZTRVDTVEULZAVFVGZUWBRULZUWBUXBUDZU
          WEUMAUAUWBUXAUWERUXBUAFVHZUWSUWCUWTUWDUGUWRUWBDVIUWRUWBIUFVJZVKUXBVLU
          WCUWDUGVMVAVNZAUXEVOZUWCUWDARVPUWBDJVQZAIVPULZUXEUWDVPULAEVPIEUICUEZU
          JSVRUDHUIUXMVRUDUJSUGSVSVTZCVPWAVPNUXNCVPWBWCUWMWDZIUWBWEWMZWFAUOUXBT
          UKZUWJIUWJUGSZUJSZUWKWGAUWJUXRUBUOUARUWRUWGUDZUWTUGSZVCZTUKZUOUARTUWR
          UIUJSZWHSZUCUEZDUDZUCUHZUWTUGSZVCZTUKZUXQTWIRVDUXDAUWIFUYBTRVDUXDUXEU
          WBUYBUDZUWIUMAUAUWBUYAUWIRUYBUXGUXTUWHUWTUWDUGUWRUWBUWGVIUXHVKUYBVLZU
          WHUWDUGVMVAVNZUXJUWHUWDARVPUWBUWGAFDTRVDUXDUXKWJZVQZUXPWFZAITUIVRUJWK
          WLUDSZULUYCWGWNULAEUWLWOZUYRIAUIEULUYSUYRWPACDEHJKLMNWQWRQXCABCDEUAFG
          HIJKLMNOPWSWTZXAZUXQWIULAUOUXBTXBVGAUYKUXRTUYKUDZUOSZUXRWGAUXRUBUYJTT
          RVDTRULZAXDVGAUBUEZRULZVOZVUEUYJUDZTVUEUIUJSZWHSZUYGUCUHZIVUEUFSZUGSZ
          VPVUFVUHVUMUMAUAVUEUYIVUMRUYJUAUBVHZUYHVUKUWTVULUGVUNUYEVUJUYGUCVUNUY
          DVUITWHUWRVUEUIUJUQURXEUWRVUEIUFVJZVKUYJVLZVUKVULUGVMVAVNVUGVUKVULVUG
          VUJUYGUCVUGTVUIXMVUGRVPDXNZUYFRULZUYGVPULZUYFVUJULAVUQVUFJXFUYFVUIXGR
          VPUYFDXHZXIXJAUXLVUFVULVPULUXOIVUEWEWMZWFXKZAUOUARIUYAUGSZVCZUIXLSZTU
          IUOSZUKZUOUYJVVFUKUXRWGAUOFVVEUYJVVFATUXDXOUWBVVFXPUDZULAUWBXQULZUWBV
          VEUDZUWBUYJUDZUMXQVVHUWBXQUIXPUDVVHXRUIVVFXPXSXTYEYAAVVIVOZUWBUIUJSZV
          VDUDZIVVMUWGUDZIVVMUFSZUGSZUGSZVVJVVKVVLVVMRULZVVNVVRUMVVIVVSAUWBYBZV
          NZUAVVMVVCVVRRVVDUWRVVMUMZUYAVVQIUGVWBUXTVVOUWTVVPUGUWRVVMUWGVIUWRVVM
          IUFVJVKURVVDVLZIVVQUGVMVAVBVVLUIVPULZUWBVPULZVVJVVNUMYCVVIVWEAUWBYDVN
          UIUWBVVDUARVVCYFUUFZUUAUUBVVLTVVMWHSZUYGUCUHZUWDUGSZVVOIVVPUGSZUGSVVK
          VVRVVLVWHVVOUWDVWJUGVVLUYGUCDTVVMVVLUYFVWGULZVOUYGYGVVLVVMRTXPUDZVWAV
          DYHVVLVUQVURVUSVWKAVUQVVIJXFUYFVVMXGZVUTXIYIVVLUWDVVPIUGSZVWJAUXLVVIU
          WDVWNUMUXOIUWBUUCWMVVLIVVPAUXLVVIUXOXFZAUXLVVSVVPVPULVVIUXOVVTIVVMWEX
          IZUUDYJVKVVLUXEVVKVWIUMZVVIUXEAUWBUUGVNUAUWBUYIVWIRUYJUXGUYHVWHUWTUWD
          UGUXGUYEVWGUYGUCUXGUYDVVMTWHUWRUWBUIUJUQURXEUXHVKVUPVWHUWDUGVMVAZVBVV
          LIVVOVVPVWOARVPUWGXNVVSVVOVPULVVIUYOVVTRVPVVMUWGXHXIVWPUUEYPYPUUHUUIA
          UOVVDTUKUXRWGVTZVVGUXRWGVTZAUWJIUBUYBVVDTRVDUXDUXOVUAVUGVUEUYBUDZVUEU
          WGUDZVULUGSZVPVUFVXAVXCUMAUAVUEUYAVXCRUYBVUNUXTVXBUWTVULUGUWRVUEUWGVI
          VUOVKZUYMVXBVULUGVMVAVNZVUGVXBVULARVPVUEUWGUYOVQVVAWFXKZVUGVUEVVDUDZI
          VXCUGSZIVXAUGSVUFVXGVXHUMAUAVUEVVCVXHRVVDVUNUYAVXCIUGVXDURVWCIVXCUGVM
          VAVNVUGVXAVXCIUGVXEURYJUUJUXCUIVEULVWSVWTYKVFUUKUXRUOVVDTUIVWFUULYLUU
          MUUNUUPAVUCUXRTUOSUXRAVUBTUXRUOAVUBTITUFSZUGSZTVUBTUYJUDZVXJUXCVUBVXK
          UMVFUOUYJTUUOYMVUDVXKVXJUMXDUATUYIVXJRUYJUWRTUMZUYHTUWTVXIUGVXLUYHYQU
          YGUCUHTVXLUYEYQUYGUCVXLUYETTUIUJSZWHSZYQVXLUYDVXMTWHUWRTUIUJUQURVXMTU
          UQVTZVXNYQUMZTUURULVXOUUSTUUTYMUXCVXMVEULZVXOVXPYKVFUXCVXQVFTUVAYMTVX
          MUVBYLUVCYNXEUYGUCUVDYNUWRTIUFVJVKVUPTVXIUGVMVAYMYEAVXIAUXLVUDVXIVPUL
          UXOXDITWEUVHUVEUVFURAUXRAIUWJUXOAUWIFUYBTRVDUXDUYNUYQUYTUVGZWFUVIYOUV
          JARVPVUEUYCAUBUYBTRVDUXDVXFWJVQARVPVUEUYKAUBUYJTRVDUXDVVBWJVQVUGFUYBU
          YJUXBTVUEVUGVUERVWLAVUFYRVDYHVUGAUXEUYLVPULUWBTVUEWHSULZAVUFUVQZUWBVU
          EXGZUXJUYLUWIVPUYNUYQXKXIVUGAUXEVVKVPULVXSVXTVYAUXJVVKVWIVPUXEVWQAVWR
          VNZUXJVWHUWDUXJVWGUYGUCUXJTVVMXMUXJVUQVURVUSVWKAVUQUXEJXFZVWMVUTXIXJZ
          UXPWFXKXIVUGAUXEUXFUYLVVKUJSZUMVXSVXTVYAUXJUWEUWIVWIUJSZUXFVYEUXJUWEU
          WHVWHUJSZUWDUGSVYFUXJUWCVYGUWDUGUXJVYGVWHUWCUOSZVWHUJSUWCUXJUWHVYHVWH
          UJUXJTUWBWHSZUYGUCUHUWHVYHUXJUYGUCDTUWBUXJUYFVYIULZVOUYGYGUXJUWBRVWLA
          UXEYRVDYHZUXJVUQVURVUSVYJVYCUYFUWBXGVUTXIZYIUXJUYGUWCUCTUWBVYKVYLUYFU
          WBDVIUVKUVLYSUXJVWHUWCVYDUXKUVMUVNYSUXJUWHVWHUWDUYPVYDUXPYTYOUXIUXJUY
          LUWIVVKVWIUJUYNVYBVKYPXIUVRUVOAUWKUIUWJUGSZUXRUJSUXSAUIIUWJVWDAYCVGUX
          OVXRYTAVYMUWJUXRUJAUWJVXRUVSYSYOUVPUVTYO $.

        $( Lemma for ~ abelth .  (Contributed by Mario Carneiro,
           8-May-2015.) $)
        abelthlem7a $p |- ( ph -> ( X e. CC /\
          ( abs ` ( 1 - X ) ) <_ ( M x. ( 1 - ( abs ` X ) ) ) ) ) $=
          ( c1 cmin co wcel cc cabs cfv cmul cle wbr wa csn eldifad wceq fveq2d
          cv oveq2 fveq2 oveq2d breq12d elrab2 sylib ) AIEUAIUBUARISTZUCUDZHRIU
          CUDZSTZUETZUFUGZUHAIERUIQUJRCUMZSTZUCUDZHRVFUCUDZSTZUETZUFUGVECIUBEVF
          IUKZVHVAVKVDUFVLVGUTUCVFIRSUNULVLVJVCHUEVLVIVBRSVFIUCUOUPUPUQNURUS $.

        abelthlem7.2 $e |- ( ph -> R e. RR+ ) $.
        abelthlem7.3 $e |- ( ph -> N e. NN0 ) $.
        abelthlem7.4 $e |- ( ph -> A. k e. ( ZZ>= ` N )
          ( abs ` ( seq 0 ( + , A ) ` k ) ) < R ) $.
        abelthlem7.5 $e |- ( ph -> ( abs ` ( 1 - X ) ) < ( R / ( sum_ n e.
          ( 0 ... ( N - 1 ) ) ( abs ` ( seq 0 ( + , A ) ` n ) ) + 1 ) ) ) $.
        $( Lemma for ~ abelth .  (Contributed by Mario Carneiro,
           2-Apr-2015.) $)
        abelthlem7 $p |- ( ph ->
          ( abs ` ( F ` X ) ) < ( ( M + 1 ) x. R ) ) $=
          ( cfv cabs c1 cmin co cc0 cfz caddc cseq cexp cmul csu cuz abelthlem4
          cv csn eldifad ffvelrnd abscld wcel ax-1cn cle wbr abelthlem7a simpld
          cc subcl sylancr fzfid cn0 elfznn0 wa nn0uz cz 0z a1i ffvelrnda expcl
          serf sylan mulcld sylan2 cmpt eqid wceq oveq2 fvmpt syl syldan simprd
          ovex cli eqeltrd mpbid cr peano2re rpred oveq2d 3eqtrd fveq2d eqbrtrd
          remulcld clt fsumrecl absmuld absge0d 1re adantr 0cn sylancl eqtrd wb
          crp exple1 syl31anc lemul2ad recnd letrd lelttrd ltled cdiv syl112anc
          mpbird absidm seqex breldm lemul1ad rerpdivcld isumclim2 eqtr4d rpcnd
          wne breqtrd rpne0d mulid2d mul12d fsumcl nn0zd eluznn0 fveq2 cdm ccom
          oveq12d cbl cdif wss abelthlem2 sseldd abelthlem5 mpdan adantl iserex
          isumcl readdcld abelthlem6 isumsplit adddid abstrid fsumabs cnmetdval
          reexpcl subid1d cxmt cxr cnxmet 1rp rpxr ax-mp elbl3 mpanl12 eqbrtrrd
          ltle mpd simpr absexp eqtr2d mulid1d 3brtr3d fsumle ltp1d 0re fsumge0
          wi ltmuldiv fvex uzid geolim2 expge0d breq1d rspccva 3brtr4d cvgcmpce
          wral isumrecl eldifsni necomd subeq0 necon3bid absrpcld iserabs difrp
          reexpcld isermulc2 isumle isumclim rpdivcld resubcl lemul2d lemuldivd
          mulcomd divassd ledivmul lemuldiv2d ltleaddd adddird addcomd breqtrrd
          div12d rpge0d posdif ) ALIUEZUFUEZUGLUHUIZUJKUGUHUIZUKUIZHUSZULDUJUMZ
          UEZLUYJUNUIZUOUIZHUPZUOUIZUFUEZUYGKUQUEZUYNHUPZUOUIZUFUEZULUIZJUGULUI
          ZEUOUIZAUYEAFVJLIABCDFHIJMNOPQRURALFUGUTZTVAVBVCAUYQVUAAUYPAUYGUYOAUG
          VJVDZLVJVDZUYGVJVDVEAVUGUYGUFUEZJUGLUFUEZUHUIZUOUIZVFVGZABCDFHIJLMNOP
          QRSTVHZVIZUGLVKVLZAUYIUYNHAUJUYHVMZUYJUYIVDZAUYJVNVDZUYNVJVDZUYJUYHVO
          ZAVURVPZUYLUYMAVNVJUYJUYKAHDUJVNVQUJVRVDAVSVTAVNVJUYJDMWAWCWAZAVUGVUR
          UYMVJVDVUNLUYJWBWDZWEZWFZUUAZWEZVCZAUYTAUYGUYSVUOAUYNHGVNGUSZUYKUEZLV
          VIUNUIZUOUIZWGZKUYRUYRWHZAKUBUUBZAUYJUYRVDZVPZVURUYJVVMUEZUYNWIZAKVNV
          DZVVPVURUBUYJKUUCWDZGUYJVVLUYNVNVVMVVIUYJWIZVVJUYLVVKUYMUOVVIUYJUYKUU
          DZVVIUYJLUNWJUUGZVVMWHUYLUYMUOWOWKZWLZAVVPVURVUSVWAVVDWMZAULVVMUJUMWP
          UUEZVDZULVVMKUMVWHVDALUJUGUFUHUUFZUUHUEUIZVDZVWIAFVUEUUIZVWKLAUGFVDVW
          MVWKUUJACDFJMNOPQUUKWNTUULZABCDFGHIJLMNOPQRSUUMUUNZAHVVMUJKVNVQUBVVAV
          VRUYNVJVURVVSAVWEUUOZVVDWQZUUPWRZUUQZWEZVCZUURAVUCEAJWSVDVUCWSVDOJWTW
          LAEUAXAZXFAUYFUYPUYTULUIZUFUEVUBVFAUYEVXCUFAUYEUYGVNUYNHUPZUOUIUYGUYO
          UYSULUIZUOUIVXCABCDFHIJLMNOPQRSTUUSAVXDVXEUYGUOAUYNHVVMUJKUYRVNVQVVNU
          BVWPVVDVWOUUTXBAUYGUYOUYSVUOVVFVWSUVAXCXDAUYPUYTVVGVWTUVBXEAVUBEJEUOU
          IZULUIZVUDXGAUYQVUAEVXFVVHVXAVXBAJEOVXBXFZAUYQVUHUYIUYLUFUEZHUPZUGULU
          IZUOUIZEVVHAVUHVXKAUYGVUOVCZAVXJWSVDVXKWSVDZAUYIVXIHVUPVUQAVURVXIWSVD
          ZVUTVVAUYLVVBVCZWFZXHZVXJWTWLZXFVXBAUYQVUHUYOUFUEZUOUIVXLVFAUYGUYOVUO
          VVFXIAVXTVXKVUHAUYOVVFVCZVXSVXMAUYGVUOXJAVXTVXKVYAVXSAVXTVXJVXKVYAVXR
          VXSAVXTUYIUYNUFUEZHUPVXJVYAAUYIVYBHVUPVUQAVURVYBWSVDVUTVVAUYNVVDVCWFZ
          XHVXRAUYIUYNHVUPVVEUVCAUYIVYBVXIHVUPVYCVXQVUQAVURVYBVXIVFVGVUTVVAVXIV
          UIUYJUNUIZUOUIZVXIUGUOUIVYBVXIVFVVAVYDUGVXIAVUIWSVDZVURVYDWSVDZALVUNV
          CZVUIUYJUVEWDZUGWSVDZVVAXKVTVXPVVAUYLVVBXJZVVAVYFUJVUIVFVGZVUIUGVFVGZ
          VURVYDUGVFVGAVYFVURVYHXLAVYLVURALVUNXJZXLAVYMVURAVUIUGXGVGZVYMALUJVWJ
          UIZVUIUGXGAVYPLUJUHUIZUFUEZVUIAVUGUJVJVDZVYPVYRWIVUNXMLUJVWJVWJWHUVDX
          NAVYQLUFALVUNUVFXDXOAVWLVYPUGXGVGZVWNAVYSVUGVWLVYTXPZXMVUNVWJVJUVGUEV
          DUGUVHVDZVYSVUGVPWUAUVIUGXQVDWUBUVJUGUVKUVLLVWJUJUGVJUVMUVNVLWRUVOZAV
          YFVYJVYOVYMUWGVYHXKVUIUGUVPXNUVQZXLAVURUVRVUIUYJXRXSXTVVAVYBVXIUYMUFU
          EZUOUIZVYEVVAUYLUYMVVBVVCXIZVVAWUEVYDVXIUOAVUGVURWUEVYDWIVUNLUYJUVSWD
          XBZUVTVVAVXIVVAVXIVXPYAUWAUWBWFUWCYBAVXJVXRUWDZYCYDXTXEAVXLEXGVGZVUHE
          VXKYEUIXGVGZUDAVUHWSVDEWSVDZVXNUJVXKXGVGWUJWUKXPVXMVXBVXSAUJVXJVXKUJW
          SVDAUWEVTVXRVXSAUYIVXIHVUPVXQVUQAVURUJVXIVFVGVUTVYKWFUWFWUIYCVUHEVXKU
          WHYFYGYCAVUAVUHUYSUFUEZUOUIZVXFVFAUYGUYSVUOVWSXIAWUNVXFVFVGWUMVXFVUHY
          EUIZVFVGAWUMUYRVYBHUPZWUOAUYSVWSVCZAVYBHGVNVVLUFUEZWGZKUYRVVNVVOVVQVU
          RUYJWUSUEZVYBWIVWAGUYJWURVYBVNWUSVWBVVLUYNUFVWDXDWUSWHUYNUFUWIWKWLZVV
          QUYNVWGVCZAEHGVNVUIVVIUNUIZWGZWUSKKUYRVVNAKVRVDKUYRVDVVOKUWJWLVVQUYJW
          VDUEZVYDWSVVQVURWVEVYDWIVWAGUYJWVCVYDVNWVDVVIUYJVUIUNWJZWVDWHVUIUYJUN
          WOWKWLZAVVPVURVYGVWAVYIWMZWQZVVQWUTVYBVJWVAVVQVYBWVBYAZWQAULWVDKUMZVU
          IKUNUIZVUJYEUIZWPVGWVKVWHVDAVUIHWVDKAVUIVYHYAAVUIUFUEZVUIUGXGAVUGWVNV
          UIWIVUNLYHWLWUCXEUBWVGUWKZWVKWVMWPULWVDKYIWVLVUJYEWOYJWLVXBVVQVYBEVYD
          UOUIZWUTUFUEZEWVEUOUIZVFVVQVYBVYEWVPVFAVVPVURVYBVYEWIVWAVVAVYBWUFVYEW
          UGWUHXOWMVVQVXIEVYDAVVPVURVXOVWAVXPWMZAWULVVPVXBXLZWVHVVQVUIUYJAVYFVV
          PVYHXLVWAAVYLVVPVYNXLUWLVVQVXIEWVSWVTAVVJUFUEZEXGVGZGUYRUWQVVPVXIEXGV
          GZUCWWBWWCGUYJUYRVWBWWAVXIEXGVWBVVJUYLUFVWCXDUWMUWNWDYDYKXEZVVQWVQVYB
          UFUEZVYBVVQWUTVYBUFWVAXDVVQVUSWWEVYBWIVWGUYNYHWLXOVVQWVEVYDEUOWVGXBZU
          WOUWPZUWRZAVXFVUHVXHAUYGVUOAUYGUJYPZUGLYPZALUGALVWMVDLUGYPTLFUGUWSWLU
          WTAVUFVUGWWIWWJXPVEVUNVUFVUGVPUYGUJUGLUGLUXAUXBVLYGUXCZYLZAUYSWUPHVVM
          WUSKUYRVVNAUYNHVVMKUYRVVNVVOVWFVWGVWRYMAVYBHWUSKUYRVVNVVOWVAWVJWWGYMV
          VOAVVPVURVVRVJVDVWAVWQWMVVQWUTVYBVVRUFUEWVAVVQVVRUYNUFVWFXDYNUXDAWUPE
          WVMUOUIZWUOWWHAEWVMVXBAWVLVUJAVUIKVYHUBUXFZAVYOVUJXQVDZWUCAVYFVYJVYOW
          WOXPVYHXKVUIUGUXEXNWRZYLXFZWWLAWUPUYRWVPHUPWWMVFAVYBWVPHWUSGVNEWVCUOU
          IZWGZKUYRVVNVVOWVAWVBVVQVURUYJWWSUEZWVPWIVWAGUYJWWRWVPVNWWSVWBWVCVYDE
          UOWVFXBWWSWHEVYDUOWOWKWLZVVQEVYDWVTWVHXFZWWDWWGAULWWSKUMZWWMWPVGWXCVW
          HVDAWVMEHWVDWWSKUYRVVNVVOAEUAYOZWVOVVQWVEWVIYAVVQWWTWVPWVRWXAWWFYNUXG
          ZWXCWWMWPULWWSKYIEWVMUOWOYJWLUXHAWVPWWMHWWSKUYRVVNVVOWXAVVQWVPWXBYAWX
          EUXIYQAWWMEVUJYEUIZWUOWWQAWXFAEVUJUAWWPUXJZXAZWWLAWWMWVLWXFUOUIZWXFVF
          AEWVLVUJWXDAWVLWWNYAAVUJWWPYOZAVUJWWPYRUYBAWXIUGWXFUOUIWXFVFAWVLUGWXF
          WWNVYJAXKVTWXHAWXFWXGUYCAVYFVYLVYMVVTWVLUGVFVGVYHVYNWUDUBVUIKXRXSYKAW
          XFAWXFWXGYOYSYQXEAWXFWUOVFVGZEVUJWUOUOUIZVFVGZAEVUJVXFUOUIZVUHYEUIZWX
          LVFAEVUHUOUIZWXNVFVGEWXOVFVGAWXPEVUKUOUIZWXNVFAVULWXPWXQVFVGAVUGVULVU
          MWNAVUHVUKEVXMAJVUJOAVYJVYFVUJWSVDZXKVYHUGVUIUXKVLZXFUAUXLWRAWXQJEVUJ
          UOUIZUOUIJVUJEUOUIZUOUIWXNAEJVUJWXDAJOYAZWXJYTAWXTWYAJUOAEVUJWXDWXJUX
          NXBAJVUJEWYBWXJWXDYTXCYQAEWXNVUHVXBAVUJVXFWXSVXHXFWWKUXMWRAVUJVXFVUHW
          XJAVXFVXHYAZAVUHVXMYAAVUHWWKYRUXOYQAWULWUOWSVDWXRUJVUJXGVGZWXKWXMXPVX
          BWWLWXSAVYOWYDWUCAVYFVYJVYOWYDXPVYHXKVUIUGUYDXNWREWUOVUJUXPYFYGYBYBYB
          AWUMVXFVUHWUQVXHWWKUXQYGXEUXRAVUDVXFUGEUOUIZULUIVXFEULUIVXGAJUGEWYBVU
          FAVEVTWXDUXSAWYEEVXFULAEWXDYSXBAVXFEWYCWXDUXTXCUYAYC $.
      $}

      $( Lemma for ~ abelth .  (Contributed by Mario Carneiro, 2-Apr-2015.) $)
      abelthlem8 $p |- ( ( ph /\ R e. RR+ ) -> E. w e. RR+ A. y e. S
    ( ( abs ` ( 1 - y ) ) < w -> ( abs ` ( ( F ` 1 ) - ( F ` y ) ) ) < R ) ) $=
        ( cc0 c1 vk vj vi vm crp wcel wa cv caddc cseq cfv cabs co cdiv clt wbr
        cuz wral cmin wi wrex cn0 nn0uz cz 0z id ge0p1rpd rpdivcl syl2anr eqidd
        a1i cli adantr climi0 cfz cr fzfid cc wf ffvelrnda serf elfznn0 ffvelrn
        csu syl2an abscld fsumrecl ad2antrr cle absge0d rpdivcld wceq cneg cmul
        fsumge0 csn cdif ccom cbl wss abelthlem2 simpld cexp nn0z 1exp sylan9eq
        oveq1 oveq2d sumeq2dv sumex fvmpt mulid1d eqcomd eqeltrd isumclim eqtrd
        syl oveq1d df-neg syl6eqr fveq2d absnegd adantlr ad2ant2r simplll fveq2
        abelthlem4 sylan9eqr abs00bd sylan simpllr rpgt0d eqbrtrd wne ad3antrrr
        cdm simprll simprr eldifsn weq sylanbrc simplrl simplrr cbvralv simprlr
        breq1d sylib oveq1i oveq2i syl6breq abelthlem7 rpcn adantl rpcnd rpne0d
        cbvsumv divcan2d breqtrd anassrs pm2.61dane expr ralrimiva breq2 imbi1d
        ralbidv rspcev syl2anc rexlimddv ) AGUEUFZUGZUAUHZUIFSUJZUKZULUKZGKTUIU
        MZUNUMZUOUPZUAUBUHZUQUKZURZTCUHZUSUMULUKZEUHZUOUPZTJUKZUWAJUKZUSUMZULUK
        ZGUOUPZUTZCHURZEUEVAZUBVBUVJUVMUVPUBUAUVLSVBVCSVDUFZUVJVEVKUVIUVIUVOUEU
        FZUVPUEUFZAUVIVFAKNOVGZGUVOVHVIZUVJUVKVBUFUGUVMVJAUVLSVLUPZUVIRVMVNUVJU
        VRVBUFZUVTUGZUGZUVPSUVRTUSUMZVOUMZUCUHZUVLUKZULUKZUCWDZTUIUMZUNUMZUEUFU
        WBUXIUOUPZUWIUTZCHURZUWLUXAUVPUXHUVJUWOUWTUWQVMUXAUXGAUXGVPUFUVIUWTAUXC
        UXFUCASUXBVQZAUXDUXCUFZUGZUXEAVBVRUVLVSUXDVBUFUXEVRUFUXNAEFSVBVCUWMAVEV
        KZAVBVRUWCFLVTWAUXDUXBWBVBVRUXDUVLWCWEZWFZWGWHASUXGWIUPUVIUWTAUXCUXFUCU
        XMUXRUXOUXEUXQWJWOWHVGWKUXAUXKCHUXAUWAHUFZUXJUWIUXAUXSUXJUGZUGZUWHUWFUL
        UKZGUOUVJUXSUWHUYBWLZUWTUXJAUXSUYCUVIAUXSUGZUWHUWFWMZULUKUYBUYDUWGUYEUL
        UYDUWGSUWFUSUMUYEUYDUWESUWFUSAUWESWLUXSAUWEVBIUHZFUKZTWNUMZIWDZSATHUFZU
        WEUYIWLAUYJHTWPWQZSTULUSWRWSUKUMWTADFHKLMNOPXAXBBTVBUYGBUHZUYFXCUMZWNUM
        ZIWDUYIHJUYLTWLZVBUYNUYHIUYOUYFVBUFZUGUYMTUYGWNUYOUYPUYMTUYFXCUMZTUYLTU
        YFXCXGUYPUYFVDUFUYQTWLUYFXDUYFXEXQXFXHXIQVBUYHIXJXKXQAUYHSIFSVBVCUXPAUY
        PUGZUYHUYGUYRUYGAVBVRUYFFLVTZXLZXMUYRUYHUYGVRUYTUYSXNRXOXPZVMXRUWFXSXTY
        AUYDUWFAHVRUWAJABDFHIJKLMNOPQYGVTYBXPYCYDUYAUYBGUOUPZUWATUYAUWATWLZUGUY
        BSGUOUYAAVUCUYBSWLAUVIUWTUXTYEAVUCUGUWFVUCAUWFUWESUWATJYFVUAYHYIYJUYASG
        UOUPVUCUYAGAUVIUWTUXTYKYLVMYMUXAUXTUWATYNZVUBUXAUXTVUDUGZUGZUYBUVOUVPWN
        UMZGUOVUFBDFUVPHUDIJKUVRUWAAVBVRFVSUVIUWTVUELYOAUVLVLYPUFUVIUWTVUEMYOAK
        VPUFUVIUWTVUENYOASKWIUPUVIUWTVUEOYOPQAUWRUVIUWTVUERYOVUFUXSVUDUWAUYKUFU
        XAUXSUXJVUDYQUXAUXTVUDYRUWAHTYSUUAUVJUWOUWTVUEUWQWHUVJUWSUVTVUEUUBVUFUV
        TUDUHZUVLUKZULUKZUVPUOUPZUDUVSURUVJUWSUVTVUEUUCUVQVUKUAUDUVSUAUDYTZUVNV
        UJUVPUOVULUVMVUIULUVKVUHUVLYFYAUUFUUDUUGVUFUWBUXIUVPUXCUYFUVLUKZULUKZIW
        DZTUIUMZUNUMUOUXAUXSUXJVUDUUEUXHVUPUVPUNUXGVUOTUIUXCUXFVUNUCIUCIYTUXEVU
        MULUXDUYFUVLYFYAUUPUUHUUIUUJUUKUVJVUGGWLUWTVUEUVJGUVOUVIGVRUFAGUULUUMUV
        JUVOAUWNUVIUWPVMZUUNUVJUVOVUQUUOUUQWHUURUUSUUTYMUVAUVBUWKUXLEUXIUEUWCUX
        IWLZUWJUXKCHVURUWDUXJUWIUWCUXIUWBUOUVCUVDUVEUVFUVGUVH $.
    $}

    $( Lemma for ~ abelth .  By adjusting the constant term, we can assume that
       the entire series converges to ` 0 ` .  (Contributed by Mario Carneiro,
       1-Apr-2015.) $)
    abelthlem9 $p |- ( ( ph /\ R e. RR+ ) -> E. w e. RR+ A. y e. S
    ( ( abs ` ( 1 - y ) ) < w -> ( abs ` ( ( F ` 1 ) - ( F ` y ) ) ) < R ) ) $=
      ( co cn0 cc0 vi vk vm crp wcel wa cmin cabs cfv clt wbr wceq csu cif cmpt
      c1 cv cexp cmul wi wral wrex cc wf 0nn0 a1i ffvelrn syl2an nn0uz cz eqidd
      ffvelrnda isumcl adantr subcld ifcl syl2anc eqid fmptd caddc cseq cli cdm
      0z 1e0p1 1z eqeltrri cn nnuz fveq2i eqtri eleq2i nnnn0 adantl eqeq1 fveq2
      cuz weq ifbieq2d ovex fvex fvmpt syl wn wne nnne0 neneqd iffalse sylan2br
      ifex eqtrd seqfeq isumclim2 clim2ser seq1 oveq2i eqbrtrd clim2ser2 syl5eq
      ax-mp breqtrd wss oveq1 nn0z 1exp sylan9eq oveq12d sumeq2dv sumex adantlr
      mulid1d oveq2d oveq1d cbvsumv breqtrrd isumclim oveq2 expcl sylan mulcld
      syl6breq iftrue sylancl npncan2 seqex c0ex breldm abelthlem8 wb cdif ccom
      csn cbl abelthlem2 simpld ad2antrr eqtr4d syl6eq subidd oveqan12rd ssrab2
      eqeltrd crab eqsstri sselda 3eqtr4d abelthlem3 sumeq2sdv exp0d abelthlem4
      cle npncand ffvelrnd nnncan2d fveq2d breq1d imbi2d ralbidva rexbidv mpbid
      ) AGUDUEZUFUPCUQZUGRUHUIEUQUJUKZUPBHSUAUQZUBSUBUQZTULZTFUIZSUCUQZFUIZUCUM
      ZUGRZUWEFUIZUNZUOZUIZBUQZUWDURRZUSRZUAUMZUOZUIZUWBUWTUIZUGRZUHUIZGUJUKZUT
      ZCHVAZEUDVBZUWCUPJUIZUWBJUIZUGRZUHUIZGUJUKZUTZCHVAZEUDVBZABCDEUWNGHUAUWTK
      AUBSUWMVCUWNAUWESUEZUFZUWKVCUEZUWLVCUEZUWMVCUEZUXRUWGUWJASVCFVDZTSUEZUWGV
      CUEZUXQLUYCUXQVEVFSVCTFVGZVHAUWJVCUEZUXQAUWIUCFTSVITVJUEZAWDVFZAUWHSUEUFZ
      UWIVKZASVCUWHFLVLZMVMZVNVOASVCUWEFLVLZUWFUWKUWLVCVPVQZUWNVRZVSZAVTUWNTWAZ
      TWBUKUYQWBWCUEAUYQUWJUWGUGRZTUYQUIZVTRZTWBAUYRUAUWNTTSVIUYCAVEVFZASVCUWDU
      WNUYPVLAVTUWNTUPVTRZWAVTFVUBWAZUYRWBAVTUAUWNFVUBVUBVJUEAUPVUBVJWEWFWGVFZU
      WDVUBWQUIZUEZAUWDWHUEZUWOUWDFUIZULWHVUEUWDWHUPWQUIVUEWIUPVUBWQWEWJWKWLZAV
      UGUFZUWOUWDTULZUWKVUHUNZVUHVUJUWDSUEZUWOVULULZVUGVUMAUWDWMWNZUBUWDUWMVULS
      UWNUBUAWRZUWFVUKUWLVUHUWKUWEUWDTWOUWEUWDFWPZWSZUYOVUKUWKVUHUWGUWJUGWTZUWD
      FXAXJXBZXCVUJVUKXDVULVUHULVUJUWDTVUGUWDTXEAUWDXFWNXGVUKUWKVUHXHXCZXKXIXLA
      VUCUWJTVTFTWAUIZUGRUYRWBAUWJUBFTTSVIVUAUYMAUWIUCFTSVIUYHUYJUYKMXMXNVVBUWG
      UWJUGUYGVVBUWGULWDVTFTXOXTXPUUAXQXRAUYTUYRUWKVTRZTUYSUWKUYRVTUYSTUWNUIZUW
      KUYGUYSVVDULWDVTUWNTXOXTUYCVVDUWKULVEUBTUWMUWKSUWNUWFUWKUWLUUBZUYOVUSXBXT
      WKXPAUYFUYDVVCTULUYLAUYBUYCUYDLVEUYEUUCZUWJUWGUUDVQXSYAZUYQTWBVTUWNTUUEUU
      FUUGXCNOPUWTVRZVVGUUHAUXHUXPUUIUWAAUXGUXOEUDAUXFUXNCHAUWBHUEZUFZUXEUXMUWC
      VVJUXDUXLGUJVVJUXCUXKUHVVJUXCUXIUWJUGRZUXJUWJUGRZUGRUXKVVJUXAVVKUXBVVLUGV
      VJUXASVULUPUSRZUAUMZVVKVVJUPHUEZUXAVVNULAVVOVVIAVVOHUPUULUUJTUPUHUGUUKUUM
      UIRYBADFHKLMNOPUUNUUOZVNZBUPUWSVVNHUWTUWPUPULZSUWRVVMUAVVRVUMUFUWOVULUWQU
      PUSVUMVUNVVRVUTWNVVRVUMUWQUPUWDURRZUPUWPUPUWDURYCVUMUWDVJUEVVSUPULUWDYDUW
      DYEXCYFYGYHVVHSVVMUAYIXBXCVVJVVMVVKUAUWNTSVIUYGVVJWDVFZVVJVUMUFZUWOVULVVM
      VUMVUNVVJVUTWNVWAVULVWAUXSVUHVCUEZVULVCUEAUXSVVIVUMAUWGUWJVVFUYLVOUUPAVUM
      VWBVVIASVCUWDFLVLYJZVUKUWKVUHVCVPVQZYKZUUQVWAVVMVULVCVWEVWDUVBAUYQVVKWBUK
      VVIAUYQTVVKWBVVGAVVKUWJUWJUGRTAUXIUWJUWJUGAUXISUWIUPUSRZUCUMZUWJAVVOUXIVW
      GULVVPBUPSIUQZFUIZUWPVWHURRZUSRZIUMZVWGHJVVRVWLSVWIUPUSRZIUMVWGVVRSVWKVWM
      IVVRVWHSUEZUFVWJUPVWIUSVVRVWNVWJUPVWHURRZUPUWPUPVWHURYCVWNVWHVJUEVWOUPULV
      WHYDVWHYEXCYFYLYHSVWMVWFIUCIUCWRVWIUWIUPUSVWHUWHFWPYMYNUURQSVWFUCYIXBXCAS
      VWFUWIUCUYIUWIUYKYKYHXKYMAUWJUYLUUSXKYOVNYPXKVVJUXBSVULUWBUWDURRZUSRZUAUM
      ZVVLVVIUXBVWRULABUWBUWSVWRHUWTBCWRZSUWRVWQUAVUMVWSUWOVULUWQVWPUSVUTUWPUWB
      UWDURYCZUUTYHVVHSVWQUAYIXBWNVVJVWQVVLUAUBSUWMUWBUWEURRZUSRZUOZTSVIVVTVUMU
      WDVXCUIZVWQULZVVJUBUWDVXBVWQSVXCVUPUWMVULVXAVWPUSVURUWEUWDUWBURYQZYGVXCVR
      ZVULVWPUSWTXBZWNVWAVULVWPVWDVVJUWBVCUEZVUMVWPVCUEAHVCUWBHVCYBAHUPDUQZUGRU
      HUIKUPVXJUHUIUGRUSRUVKUKZDVCUVCVCPVXKDVCUVAUVDVFUVEZUWBUWDYRYSZYTVVJVTVXC
      TWAZUXJUWGUGRZTVXNUIZVTRZVVLWBVVJVXOUAVXCTTSVIUYCVVJVEVFZVVJSVCUWDVXCVVJU
      BSVXBVCVXCVVJUXQUFZUWMVXAAUXQUYAVVIUYNYJVVJVXIUXQVXAVCUEVXLUWBUWEYRYSZYTV
      XGVSVLVVJVTVXCVUBWAZVTUBSUWLVXAUSRZUOZVUBWAZVXOWBAVYAVYDULVVIAVTUAVXCVYCV
      UBVUDVUFAVUGVXDUWDVYCUIZULVUIVUJVWQVUHVWPUSRZVXDVYEVUJVULVUHVWPUSVVAYMVUJ
      VUMVXEVUOVXHXCVUJVUMVYEVYFULZVUOUBUWDVYBVYFSVYCVUPUWLVUHVXAVWPUSVUQVXFYGV
      YCVRZVUHVWPUSWTXBZXCUVFXIXLVNVVJVYDUXJTVTVYCTWAZUIZUGRVXOWBVVJUXJUAVYCTTS
      VIVXRVVJSVCUWDVYCVVJUBSVYBVCVYCVXSUWLVXAAUXQUXTVVIUYMYJVXTYTVYHVSVLVVJVYJ
      SVYFUAUMZUXJWBVVJVYFUAVYCTSVIVVTVUMVYGVVJVYIWNVWAVUHVWPVWCVXMYTADFHUBKUWB
      LMNOPUVGXMVVIUXJVYLULABUWBVWLVYLHJVWSVWLSVUHUWQUSRZUAUMVYLSVWKVYMIUAIUAWR
      VWIVUHVWJUWQUSVWHUWDFWPVWHUWDUWPURYQYGYNVWSSVYMVYFUAVWSUWQVWPVUHUSVWTYLUV
      HXSQSVYFUAYIXBWNYOXNVVJVYKUWGUXJUGVVJVYKUWGUWBTURRZUSRZUWGVYKTVYCUIZVYOUY
      GVYKVYPULWDVTVYCTXOXTUYCVYPVYOULVEUBTVYBVYOSVYCUWFUWLUWGVXAVYNUSUWETFWPUW
      ETUWBURYQZYGVYHUWGVYNUSWTXBXTWKVVJVYOUWGUPUSRUWGVVJVYNUPUWGUSVVJUWBVXLUVI
      ZYLVVJUWGAUYDVVIVVFVNZYKXKXSYLYAXQXRVVJVXQVXOUWKVTRVVLVVJVXPUWKVXOVTVVJVX
      PUWKVYNUSRZUWKVXPTVXCUIZVYTUYGVXPWUAULWDVTVXCTXOXTUYCWUAVYTULVEUBTVXBVYTS
      VXCUWFUWMUWKVXAVYNUSVVEVYQYGVXGUWKVYNUSWTXBXTWKVVJVYTUWKUPUSRUWKVVJVYNUPU
      WKUSVYRYLVVJUWKVVJUWGUWJVYSAUYFVVIUYLVNZVOYKXKXSYLVVJUXJUWGUWJAHVCUWBJABD
      FHIJKLMNOPQUVJZVLZVYSWUBUVLXKYAYPXKYGVVJUXIUXJUWJVVJHVCUPJAHVCJVDVVIWUCVN
      VVQUVMWUDWUBUVNXKUVOUVPUVQUVRUVSVNUVT $.

    $( Abel's theorem.  If the power series ` sum_ n e. NN0 A ( n ) ( x ^ n ) `
       is convergent at ` 1 ` , then it is equal to the limit from "below",
       along a Stolz angle ` S ` (note that the ` M = 1 ` case of a Stolz angle
       is the real line ` [ 0 , 1 ] ` ).  (Continuity on ` S \ { 1 } ` follows
       more generally from ~ psercn .)  (Contributed by Mario Carneiro,
       2-Apr-2015.)  (Revised by Mario Carneiro, 8-Sep-2015.) $)
    abelth $p |- ( ph -> F e. ( S -cn-> CC ) ) $=
      ( cfv co cc wcel c1 cabs vy vw vr vt vj vv ccnfld ctopn crest ccncf wf cv
      ccn ccnp wral abelthlem4 wa wceq cmin ccom cxp cres clt wbr wi abelthlem9
      crp wrex csn cdif cc0 abelthlem2 simpld ad2antrr simpr ovresd ax-1cn cmul
      cbl wss crab ssrab2 eqsstri sseldi eqid cnmetdval sylancr breq1d ffvelrnd
      cle eqtrd adantr ffvelrnda syl2anc imbi12d ralbidva mpbird ralrimiva cxmt
      rexbidv wb cnxmet xmetres2 mp2an cmopn cnfldtopn metrest metcnp mpbir2and
      a1i syl3anc fveq2d eleqtrrd caddc cn0 cexp cmpt cdm cr cxr csu adantl a1d
      1re cpnf 0cn mpan mp3an absf resmpt ax-mp ctop toponunii cncfcn resttopon
      syl ctopon cvv syl6eleqr ccld wne eldifsn ccnv cseq csup cico cima simprd
      cli w3a abscl absge0 abelthlem1 rexrd rexr mp1i iccssxr radcnvcl xrltletr
      cicc mpan2d 3jcad abssub subid1 3eqtrd 0re elico2 3imtr4d imdistanda elbl
      rexri wfn ffn elpreima 3imtr4g ssrdv sstrd reseq1i difss eqtri syl6eqr c2
      mp2b cdiv cif cnvimass fdmi sseqtri sseli pserval2 sumeq2dv fveq2 oveq12d
      oveq2 cbvsumv syl6reqr mpteq2ia rescncf sylc eqeltrrd sstri ssid cnfldtop
      psercn cnfldtopon restid eqcomi syl6eleq cncnpi cnex ssexi restabs oveq1i
      fveq1i cnt resttop snssd cha cnfldhaus sncld restcldi mp3an12 cuni cldopn
      restuni isopn3 sylib biimpar cnprest syl22anc sylan2br anassrs pm2.61dane
      3syl eleq2d cncnp sylanbrc ) AGUGUHOZEUIPZUYRUMPZEQUJPZAEQGUKZGUAULZUYSUY
      RUNPZOZRZUAEUOZGUYTRZABCDEFGHIJKLMNUPZAVUFUAEAVUCERZUQZVUFVUCSVUKVUCSURZU
      QZGSVUDOZVUEAGVUNRZVUJVULAVUOVUBSVUCTUSUTZEEVAVBZPZUBULZVCVDZSGOZVUCGOZVU
      PPZUCULZVCVDZVEZUAEUOZUBVGVHZUCVGUOZVUIAVVHUCVGAVVDVGRZUQZVVHSVUCUSPTOZVU
      SVCVDZVVAVVBUSPTOZVVDVCVDZVEZUAEUOZUBVGVHABUACUBDVVDEFGHIJKLMNVFVVKVVGVVQ
      UBVGVVKVVFVVPUAEVVKVUJUQZVUTVVMVVEVVOVVRVURVVLVUSVCVVRVURSVUCVUPPZVVLVVRS
      VUCVUPEASERZVVJVUJAVVTESVIZVJZVKSVUPVSOPZVTZACDEHIJKLMVLZVMZVNZVVKVUJVOZV
      PVVRSQRZVUCQRVVSVVLURVQVVREQVUCESCULZUSPTOHSVWJTOUSPVRPWJVDZCQWAQMVWKCQWB
      WCZVWHWDSVUCVUPVUPWEZWFWGWKWHVVRVVCVVNVVDVCVVRVVAQRVVBQRVVCVVNURVVREQSGAV
      UBVVJVUJVUIVNVWGWIVVKEQVUCGAVUBVVJVUIWLWMVVAVVBVUPVWMWFWNWHWOWPWTWQWRAVUQ
      EWSORZVUPQWSORZVVTVUOVUBVVIUQXAVWNAVWOEQVTZVWNXBVWLVUPEQXCXDXJVWOAXBXJVWF
      UCUBUAVUQVUPSGUYSUYREQVWOVWPUYSVUQXEOZURXBVWLVUPVUQUYRVWQQEVUQWEUYRUYRWEZ
      XFZVWQWEXGXDVWSXHXKXIVNVUMVUCSVUDVUKVULVOXLXMAVUJVUCSUUAZVUFVUJVWTUQAVUCV
      WBRZVUFVUCESUUBAVXAUQZVUFGVWBVBZVUCUYSVWBUIPZUYRUNPZOZRZVXBVXCVUCUYRVWBUI
      PZUYRUNPZOZVXFVXBVXCVXHUYRUMPZRVXAVXCVXJRVXBVXCVWBQUJPZVXKAVXCVXLRVXAABTU
      UCVKXNVVDUDQFXOFULZDOZUDULVXMXPPVRPXQXQZOVKUUDUUIXRRUCXSWAXTVCUUEZUUFPZUU
      GZXOVXNBULZVXMXPPZVRPZFYAZXQZVWBVBZVXCVXLAVYDBVWBVYBXQZVXCAVWBVXRVTZVYDVY
      EURAVWBVWCVXRAVVTVWDVWEUUHAUBVWCVXRAVUSQRZVKVUSVUPPZSVCVDZUQZVYGVUSTOZVXQ
      RZUQZVUSVWCRZVUSVXRRZAVYGVYIVYLAVYGUQZVYKSVCVDZVYKXSRZVKVYKWJVDZVYKVXPVCV
      DZUUJZVYIVYLVYPVYQVYRVYSVYTVYPVYRVYQVYGVYRAVUSUUKYBZYCVYPVYSVYQVYGVYSAVUS
      UULYBYCVYPVYQSVXPWJVDZVYTAWUCVYGAUDDFUCIJUUMWLVYPVYKXTRSXTRZVXPXTRZVYQWUC
      UQVYTVEVYPVYKWUBUUNSXSRWUDVYPYDSUUOUUPAWUEVYGAVKYEUUTPXTVXPVKYEUUQAUDDVXP
      FVXOUCVXOWEZIVXPWEZUURWDWLZVYKSVXPUUSXKUVAUVBVYGVYIVYQXAAVYGVYHVYKSVCVYGV
      YHVKVUSUSPTOZVUSVKUSPZTOZVYKVKQRZVYGVYHWUIURYFVKVUSVUPVWMWFYGWULVYGWUIWUK
      URYFVKVUSUVCYGVYGWUJVUSTVUSUVDXLUVEWHYBVYPVKXSRWUEVYLWUAXAUVFWUHVKVXPVYKU
      VGWGUVHUVIVWOWULWUDVYNVYJXAXBYFSYDUVKVUSVUPVKSQUVJYHQXSTUKTQUVLVYOVYMXAYI
      QXSTUVMQVUSVXQTUVNUWCUVOUVPUVQZBVXRVWBVYBYJYPVXCBEVYBXQZVWBVBZVYEGWUNVWBN
      UVRVWBEVTZWUOVYEUREVWAUVSZBEVWBVYBYJYKUVTUWAAVYFVYCVXRQUJPRVYDVXLRWUMAUDB
      DVXPVXRUEFVYCVXOVXPXSRUFULTOZVXPXNPUWBUWDPWURSXNPUWEZUCUFWUFBVXRVYBXOUEUL
      ZVXSVXOOOZUEYAZVXSVXRRVXSQRZVYBWVBURVXRQVXSVXRTXRQTVXQUWFQXSTYIUWGUWHUWIW
      VCWVBXOWUTDOZVXSWUTXPPZVRPZUEYAVYBWVCXOWVAWVFUEUDDFVXOWUTVXSWUFUWJUWKXOVY
      AWVFFUEVXMWUTURVXNWVDVXTWVEVRVXMWUTDUWLVXMWUTVXSXPUWNUWMUWOUWPYPUWQIWUGVX
      RWEWUSWEUXDVXRQVWBVYCUWRUWSUWTWLVWBQVTZQQVTZVXLVXKURVWBEQWUQVWLUXAZQUXBZV
      WBQUYRVXHUYRVWRVXHWEUYRQUIPZUYRUYRYLRZWVKUYRURUYRVWRUXCZUYRYLQQUYRUYRVWRU
      XEZYMZUXFYKUXGZYNXDUXHAVXAVOVUCVXCVXHUYRVWBVWBVXHUYRQYQORZWVGVXHVWBYQORWV
      NWVIVWBUYRQYOXDYMUXIWNVUCVXEVXIVXDVXHUYRUNWVLWUPEYRRZVXDVXHURWVMWUQEQUXJV
      WLUXKZVWBEUYRYLYRUXLYHUXMUXNYSVXBUYSYLRZWUPVUCVWBUYSUXOOOZRZVUBVUFVXGXAWV
      TVXBWVLWVRWVTWVMWVSEUYRYRUXPXDZXJWUPVXBWUQXJAWWBVXAAWWAVWBVUCAVWBUYSRZWWA
      VWBURZAVWAEVTZVWAUYSYTORZWWDASEVWFUXQVWPVWAUYRYTORZWWFWWGVWLUYRUXRRVWIWWH
      UYRVWRUXSVQSUYRQWVOUXTXDEVWAUYRQWVOUYAUYBVWAUYSEWVLVWPEUYSUYCURWVMVWLEUYR
      QWVOUYEXDZUYDUYNWVTWUPWWDWWEXAWWCWUQVWBUYSEWWIUYFXDUYGUYOUYHAVUBVXAVUIWLV
      WBVUCGUYSUYREQWWIWVOUYIUYJWQUYKUYLUYMWRUYSEYQORZWVQVUHVUBVUGUQXAWVQVWPWWJ
      WVNVWLEUYRQYOXDWVNUAGUYSUYREQUYPXDUYQVWPWVHVUAUYTURVWLWVJEQUYRUYSUYRVWRUY
      SWEWVPYNXDYS $.
  $}

  ${
    $d n x z A $.  $d n x z ph $.
    abelth2.1 $e |- ( ph -> A : NN0 --> CC ) $.
    abelth2.2 $e |- ( ph -> seq 0 ( + , A ) e. dom ~~> ) $.
    abelth2.3 $e |- F = ( x e. ( 0 [,] 1 ) |->
      sum_ n e. NN0 ( ( A ` n ) x. ( x ^ n ) ) ) $.
    $( Abel's theorem, restricted to the ` [ 0 , 1 ] ` interval.  (Contributed
       by Mario Carneiro, 2-Apr-2015.) $)
    abelth2 $p |- ( ph -> F e. ( ( 0 [,] 1 ) -cn-> CC ) ) $=
      ( vz c1 co cmul cle wbr cc cc0 cr a1i wcel 1re cv cmin cabs cfv crab cexp
      cn0 csu cmpt cicc cres ccncf wss wceq unitssre ax-resscn sstri wa w3a 0re
      simpr elicc2i sylib simp1d resubcl sylancr leidd simp3d abssubge0d simp2d
      absidd oveq2d recnd mulid2d eqtrd 3brtr4d ssrabdv resmpt syl syl6eqr 0le1
      eqid abelth rescncf sylc eqeltrrd ) ABJIUAZUBKZUCUDZJJWGUCUDZUBKZLKZMNZIO
      UEZUGDUAZCUDBUAWOUFKLKDUHZUIZPJUJKZUKZEWROULKZAWSBWRWPUIZEAWRWNUMZWSXAUNA
      WMIOWRWROUMAWRQOUOUPUQRAWGWRSZURZWHWHWIWLMXDWHXDJQSZWGQSZWHQSTXDXFPWGMNZW
      GJMNZXDXCXFXGXHUSAXCVAPJWGUTTVBVCZVDZJWGVEVFZVGXDWGJXJXEXDTRXDXFXGXHXIVHV
      IXDWLJWHLKWHXDWKWHJLXDWJWGJUBXDWGXJXDXFXGXHXIVJVKVLVLXDWHXDWHXKVMVNVOVPVQ
      ZBWNWRWPVRVSHVTAXBWQWNOULKSWSWTSXLABICWNDWQJFGXEATRPJMNAWARWNWBWQWBWCWNOW
      RWQWDWEWF $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Basic trigonometry
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The exponential, sine, and cosine functions (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z $.
    $( The exponential function is continuous.  (Contributed by Paul Chapman,
       15-Sep-2007.)  (Revised by Mario Carneiro, 20-Jun-2015.) $)
    efcn $p |- exp e. ( CC -cn-> CC ) $=
      ( cc wss ce wf ccncf wcel ssid eff w3a cdv cdm wceq dvef feq1i mpbir fdmi
      co dvcn mpan2 mp3an ) AABZAACDZUACAAEQFZAGZHUDUAUBUAIACJQZKALUCAAUEAAUEDU
      BHAAUECMNOPAACRST $.
  $}

  ${
    $d x y $.
    $( Sine is continuous.  (Contributed by Paul Chapman, 28-Nov-2007.)
       (Revised by Mario Carneiro, 3-Sep-2014.) $)
    sincn $p |- sin e. ( CC -cn-> CC ) $=
      ( vx vy cc ci cv cmul co ce cfv cmin c2 cdiv cmpt wcel wtru a1i mulc1cncf
      eqid ax-icn mp1i csin cneg ccncf df-sin ccom wf wral ccnfld ctopn ctx ccn
      subcn efcn cncfmpt1f negcli cncfmpt2f cncff syl fmpt sylibr eqidd fmptcof
      oveq1 cc0 wne 2cn mulcli 2ne0 ine0 mulne0i divccncf mp2an cncfco eqeltrrd
      trud eqeltri ) UAACDAEZFGZHIZDUBZVQFGZHIZJGZKDFGZLGZMZCCUCGZAUDWFWGNOBCBE
      ZWDLGZMZACWCMZUEWFWGOABCCWCWIWEWKWJOCCWKUFZWCCNACUGOWKWGNWLOAVSWBJUHUIIZC
      WMRZJWMWMUJGWMUKGNOWMWNULPOAVRHCHWGNOUMPZDCNACVRMZWGNOSADWPWPRQTUNOAWAHCW
      OVTCNACWAMZWGNODSUOAVTWQWQRQTUNUPZCCWKUQURACCWCWKWKRUSUTOWKVAOWJVAWHWCWDL
      VCVBOCCCWKWJWRWJWGNZOWDCNWDVDVEWSKDVFSVGKDVFSVHVIVJBWDWJWJRVKVLPVMVNVOVP
      $.

    $( Cosine is continuous.  (Contributed by Paul Chapman, 28-Nov-2007.)
       (Revised by Mario Carneiro, 3-Sep-2014.) $)
    coscn $p |- cos e. ( CC -cn-> CC ) $=
      ( vx vy cc ci cv cmul co ce cfv caddc cdiv cmpt wcel wtru eqid a1i ax-icn
      c2 mulc1cncf mp1i ccos cneg ccncf df-cos ccom wral ccnfld ctopn ctx addcn
      wf ccn efcn cncfmpt1f negcli cncfmpt2f cncff syl fmpt eqidd oveq1 fmptcof
      sylibr cc0 wne 2cn 2ne0 divccncf mp2an cncfco eqeltrrd trud eqeltri ) UAA
      CDAEZFGZHIZDUBZVNFGZHIZJGZRKGZLZCCUCGZAUDWBWCMNBCBEZRKGZLZACVTLZUEWBWCNAB
      CCVTWEWAWGWFNCCWGUKZVTCMACUFNWGWCMWHNAVPVSJUGUHIZCWIOZJWIWIUIGWIULGMNWIWJ
      UJPNAVOHCHWCMNUMPZDCMACVOLZWCMNQADWLWLOSTUNNAVRHCWKVQCMACVRLZWCMNDQUOAVQW
      MWMOSTUNUPZCCWGUQURACCVTWGWGOUSVCNWGUTNWFUTWDVTRKVAVBNCCCWGWFWNWFWCMZNRCM
      RVDVEWOVFVGBRWFWFOVHVIPVJVKVLVM $.
  $}

  ${
    $d U x y $.
    $( Lemma for ~ reeff1o .  (Contributed by Paul Chapman, 18-Oct-2007.)
       (Revised by Mario Carneiro, 30-Apr-2014.) $)
    reeff1olem $p |- ( ( U e. RR /\ 1 < U ) -> E. x e. RR ( exp ` x ) = U ) $=
      ( vy cr wcel c1 clt wbr wa cc0 co wss cv ce cfv wceq wrex 0re adantr cc
      cioo cicc ioossicc iccssre mpan syl5ss a1i simpl 0lt1 wi 1re lttr mp3an12
      mpani imp ax-resscn syl6ss ccncf efcn ssel2 reefcld sylan ef0 simpr caddc
      syl5eqbr peano2re reefcl recnd ax-1cn addcom sylancl crp elrpd efgt1p syl
      ltp1 eqbrtrd lttrd jca ivth ssrexv sylc ) BDEZFBGHZIZJBUAKZDLAMNOBPZAWGQW
      HADQWFWGJBUBKZDJBUCWDWIDLZWEJDEZWDWJRJBUDUESZUFWFCJBTBNAWKWFRUGWDWEUHZWMW
      DWEJBGHZWDJFGHZWEWNUIWKFDEWDWOWEIWNUJRUKJFBULUMUNUOZWFWIDTWLUPUQNTTURKEWF
      USUGWFWJCMZWIEZWQNODEWLWJWRIWQWIDWQUTVAVBWFJNOZBGHBBNOZGHWFWSFBGVCWDWEVDV
      FWFBBFVEKZWTWMWDXADEWEBVGSWDWTDEWEBVHSWDBXAGHWEBVQSWFXAFBVEKZWTGWFBTEFTEX
      AXBPWFBWMVIVJBFVKVLWFBVMEXBWTGHWFBWMWPVNBVOVPVRVSVTWAWHAWGDWBWC $.
  $}

  ${
    $d x y z $.
    $( The real exponential function is one-to-one onto.  (Contributed by Paul
       Chapman, 18-Oct-2007.)  (Revised by Mario Carneiro, 10-Nov-2013.) $)
    reeff1o $p |- ( exp |` RR ) : RR -1-1-onto-> RR+ $=
      ( vx vy cr crp ce reeff1 wceq cv wcel cfv wrex c1 clt wbr wa wb cc eqeq1d
      cc0 syl vz cres wf1o wf1 wfo wfn crn wf f1f ffn mp2b wss frn w3o rpre 1re
      lttri4 sylancl cdiv co elrp sylbi cneg rpne0 rereccld reeff1olem sylan wi
      reclt1 eqcom wne rpcnne0 recn efcl efne0 rec11r syl2an efcan eqcomd negcl
      cmul ax-1cn divmul2 mp3an1 syl12anc mpbird adantl syl5bbr biimpd reximdva
      jca bitrd adantr mpd renegcl infm3lem rexxfr sylibr sylbid imp ef0 eqeq2i
      fveq2 ex 0re rspcev mpan eqcoms 3jaodan mpdan fvres rexbiia fvelrnb ax-mp
      sylbir ssriv eqssi df-fo mpbir2an df-f1o ) CDECUBZUCCDYAUDZCDYAUEZFYCYACU
      FZYAUGZDGYBCDYAUHZYDFCDYAUIZCDYAUJUKZYEDYBYFYEDULFYGCDYAUMUKUADYEUAHZDIZA
      HZYAJZYIGZACKZYIYEIZYJYKEJZYIGZACKZYNYJYILMNZYILGZLYIMNZUNZYRYJYICIZLCIUU
      BYIUOZUPYILUQURYJYSYRYTUUAYJYSYRYJYSLLYIUSUTZMNZYRYJUUCSYIMNOYSUUFPYIVAYI
      VIVBYJUUFYRYJUUFOZBHZVCZEJZYIGZBCKZYRUUGUUHEJZUUEGZBCKZUULYJUUECIUUFUUOYJ
      YIUUDYIVDVEBUUEVFVGYJUUOUULVHUUFYJUUNUUKBCYJUUHCIZOZUUNUUKUUNUUEUUMGZUUQU
      UKUUEUUMVJUUQUURLUUMUSUTZYIGZUUKYJYIQIYISVKOUUMQIZUUMSVKZOZUURUUTPUUPYIVL
      UUPUVAUVBUUPUUHQIZUVAUUHVMZUUHVNZTUUPUVDUVBUVEUUHVOZTWKYIUUMVPVQUUPUUTUUK
      PYJUUPUUSUUJYIUUPUVDUUSUUJGZUVEUVDUVHLUUMUUJWAUTZGZUVDUVILUUHVRVSUVDUUJQI
      ZUVAUVBUVHUVJPZUVDUUIQIUVKUUHVTUUIVNTUVFUVGLQIUVKUVCUVLWBLUUJUUMWCWDWEWFT
      RWGWLWHWIWJWMWNYQUUKABUUICCUUHWOABWPYKUUIGYPUUJYIYKUUIEXCRWQWRXDWSWTYTYRY
      JYTYISEJZGYRUVMLYIXAXBYRUVMYISCIUVMYIGZYRXEYQUVNASCYKSGYPUVMYIYKSEXCRXFXG
      XHXOWGYJUUCUUAYRUUDAYIVFVGXIXJYMYQACYKCIYLYPYIYKCEXKRXLWRYDYOYNPYHACYIYAX
      MXNWRXPXQCDYAXRXSCDYAXTXS $.
  $}

  ${
    $d x y $.
    $( The exponential function on the reals determines an isomorphism from
       reals onto positive reals.  (Contributed by Steve Rodriguez,
       25-Nov-2007.)  (Revised by Mario Carneiro, 11-Mar-2014.) $)
    reefiso $p |- ( exp |` RR ) Isom < , < ( RR , RR+ ) $=
      ( vx vy cr crp clt ce cres wiso wf1o cv wbr cfv wb wral reeff1o wcel eflt
      wa fvres breqan12d bitr4d rgen2a df-isom mpbir2an ) CDEEFCGZHCDUEIAJZBJZE
      KZUFUELZUGUELZEKZMZBCNACNOULABCUFCPZUGCPZRUHUFFLZUGFLZEKUKUFUGQUMUNUIUOUJ
      UPEUFCFSUGCFSTUAUBABCDEEUEUCUD $.
  $}

  ${
    $d x y $.
    $( The exponential function on the reals is a strictly convex function.
       (Contributed by Mario Carneiro, 20-Jun-2015.) $)
    efcvx $p |- ( ( ( A e. RR /\ B e. RR /\ A < B ) /\ T e. ( 0 (,) 1 ) ) ->
      ( exp ` ( ( T x. A ) + ( ( 1 - T ) x. B ) ) ) <
        ( ( T x. ( exp ` A ) ) + ( ( 1 - T ) x. ( exp ` B ) ) ) ) $=
      ( cr wcel clt c1 co cmul caddc ce cres cfv wf wss crp ax-resscn wceq syl
      cc wbr w3a cioo wa cmin cicc cima simpl1 simpl2 simpl3 ccncf wf1o reeff1o
      cc0 f1of ax-mp rpssre fss mp2an iccssre syl2anc fssres2 sylancr wb syl6ss
      efcn rescncf ee10 cncffvrn mpbird cdv reefiso a1i ioossre isores3 syl3anc
      wiso eqidd crn ctg cnt ssid ccnfld ctopn eqid tgioo2 dvres mpanl12 oveq2d
      resabs1 cpr cdm reex prid1 eff dvef dmeqi fdmi eqtri dvres3 mp4an reseq1i
      sseqtr4i iccntr reseq12d 3eqtr3d isoeq1 simpr dvcvx ax-1cn recnd ioossicc
      sseldi nncan oveq1d iirev lincmb01cmp syldan eqeltrrd fvres cxr cle rexrd
      ltled lbicc2 ubicc2 oveq12d 3brtr3d ) ADEZBDEZABFUAZUBZCUNGUCHZEZUDZCAIHZ
      GCUEHZBIHZJHZKABUFHZLZMZCAUUAMZIHZYQBUUAMZIHZJHYSKMZCAKMZIHZYQBKMZIHZJHFY
      OABYSCUUAKDLZABUCHZUGZYIYJYKYNUHZYIYJYKYNUIZYIYJYKYNUJZYOUUAYTDUKHEZYTDUU
      ANZYODDUULNZYTDOZUUSDPUULNZPDOUUTDPUULULUVBUMDPUULUOUPUQDPDUULURUSZYOYIYJ
      UVAUUOUUPABUTVAZDDYTKVBVCYODTOZUUAYTTUKHEZUURUUSVDQYOYTTOKTTUKHEUVFYOYTDT
      UVDQVEVFTTYTKVGVHYTTDUUAVIVCVJYOUUMUUNFFDUUAVKHZVQZUUMUUNFFUULUUMLZVQZYOD
      PFFUULVQZUUMDOZUUNUUNRUVJUVKYOVLVMUVLYOABVNVMYOUUNVRDPFFUULUUMUUNVOVPYOUV
      GUVIRUVHUVJVDYODUULYTLZVKHZDUULVKHZYTUCVSVTMZWAMMZLZUVGUVIYODDOZUVAUVNUVR
      RZDWBUVDUVEDTUULNZUVSUVAUDUVTQUUTUVEUWAUVCQDDTUULURUSDYTDUVPUULWCWDMZUWBW
      EZUWBUWCWFWGWHVCYOUVMUUADVKYOUVAUVMUUARUVDKYTDWJSWIYOUVOUULUVQUUMUVOUULRY
      OUVOTKVKHZDLZUULDDTWKETTKNTTODUWDWLZOUVOUWERDTWMWNWOTWBDTUWFQUWFKWLTUWDKW
      PWQTTKWOWRWSXCTDKWTXAUWDKDWPXBWSVMYOYIYJUVQUUMRUUOUUPABXDVAXEXFUUMUUNFFUV
      IUVGXGSVJYLYNXHZYSWEXIYOYSYTEUUBUUGRYOGYQUEHZAIHZYRJHZYSYTYOUWIYPYRJYOUWH
      CAIYOGTECTEUWHCRXJYOCYOYMDCUNGVNUWGXMXKGCXNVCXOXOYLYNYQUNGUFHZEZUWJYTEYOC
      UWKEUWLYOYMUWKCUNGXLUWGXMCXPSABYQXQXRXSYSYTKXTSYOUUDUUIUUFUUKJYOUUCUUHCIY
      OAYTEZUUCUUHRYOAYAEZBYAEZABYBUAZUWMYOAUUOYCZYOBUUPYCZYOABUUOUUPUUQYDZABYE
      VPAYTKXTSWIYOUUEUUJYQIYOBYTEZUUEUUJRYOUWNUWOUWPUWTUWQUWRUWSABYFVPBYTKXTSW
      IYGYH $.
  $}

  ${
    $d x y P $.  $d x y R $.
    reefgim.1 $e |- R = ( CCfld |`s RR ) $.
    reefgim.2 $e |- P = ( ( mulGrp ` CCfld ) |`s RR+ ) $.
    $( The exponential function is a group isomorphism from the group of reals
       under addition to the group of positive reals under multiplication.
       (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    reefgim $p |- ( exp |` RR ) e. ( R GrpIso P ) $=
      ( vx ce cr co wcel crp wtru caddc cmul ccnfld cfv wceq cress ax-mp cc cvv
      cres cgim cghm wf1o csubrg cbs cdr resubdrg simpli subrgbas cmgp cc0 cdif
      vy csn csubg eqid rpmsubg wss cnex difexg wne rpcn rpne0 eldifsn sylanbrc
      cv ssriv ressabs mp2an eqtr4i cplusg cnfldadd ressplusg cnfldmul mgpplusg
      subgbas crg cgrp subrgrng rnggrp mp1i subggrp wf reeff1o f1of recn syl2an
      wa efadd readdcl fvres syl oveqan12d 3eqtr4d adantl isghmd isgim mpbir2an
      trud ) FGUAZBAUBHIXABAUCHIZGJXAUDZXBKEUNLMBAXAGJGNUEOZIZGBUFOPXENGQHUGIUH
      UIZGNBCUJRZJNUKOZSULUOZUMZQHZUPOZIZJAUFOPXKXKUQURZJXKAAXHJQHZXKJQHZDXJTIZ
      JXJUSXPXOPSTIXQUTSXITVAREJXJEVGZJIXRSIZXRULVBXRXJIXRVCXRVDXRSULVEVFVHXJJX
      HTVIVJVKZVQRZXELBVLOPXFGLNBXDCVMVNRXMMAVLOPXNJMXHAXLDNMXHXHUQVOVPVNRBVRIZ
      BVSIKXEYBXFGNBCVTRBWAWBXMAVSIKXNJXKAXTWCWBXCGJXAWDKWEGJXAWFWBXRGIZUNVGZGI
      ZWIZXRYDLHZXAOZXRXAOZYDXAOZMHZPKYFYGFOZXRFOZYDFOZMHZYHYKYCXSYDSIYLYOPYEXR
      WGYDWGXRYDWJWHYFYGGIYHYLPXRYDWKYGGFWLWMYCYEYIYMYJYNMXRGFWLYDGFWLWNWOWPWQW
      TWEGJBAXAXGYAWRWS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Properties of pi = 3.14159...
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi .  (Contributed by Mario
       Carneiro, 9-May-2014.) $)
    pilem1 $p |- ( A e. ( RR+ i^i ( `' sin " { 0 } ) ) <->
                   ( A e. RR+ /\ ( sin ` A ) = 0 ) ) $=
      ( crp csin ccnv cc0 csn cima cin wcel wa cfv wceq elin rpcn biantrurd wfn
      cc wf wb sinf ffn fniniseg mp2b syl6rbbr pm5.32i bitri ) ABCDEFGZHIABIZAU
      GIZJUHACKELZJABUGMUHUIUJUHUJAQIZUJJZUIUHUKUJANOQQCRCQPUIULSTQQCUAQEACUBUC
      UDUEUF $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x ph $.
    pilem.1 $e |- ( ph -> A e. ( 2 (,) 4 ) ) $.
    pilem.2 $e |- ( ph -> B e. RR+ ) $.
    pilem.3 $e |- ( ph -> ( sin ` A ) = 0 ) $.
    pilem.4 $e |- ( ph -> ( sin ` B ) = 0 ) $.
    pilem.5 $e |- ( ph -> pi < A ) $.
    $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi .  (Contributed by Mario
       Carneiro, 12-Jun-2014.) $)
    pilem2 $p |- ( ph -> ( ( pi + A ) / 2 ) <_ B ) $=
      ( vx vy co c2 cle wbr cmul crp cc0 cr clt wcel cpi cdiv cmin csin csn cin
      caddc ccnv cima csup df-pi wss wral wrex inss1 rpssre sstri a1i 0re sseli
      rpge0d rgen wceq breq1 ralbidv rspcev mp2an cfv 2re rpred remulcl sylancr
      cv c4 cioo elioore syl resubcld 4re eliooord simprd 2t2e4 wne 2pos simpld
      wa c0 lttrd elrpd pilem1 sylanbrc ne0i infmrcl mp3an13 rpre adantl letric
      wn wo ord cioc ad2antlr rpgt0 simpr cxr w3a 0xr elioc2 syl3anbrc sin02gt0
      wb gt0ne0d ex necon4bd expimpd syl5bi ralrimiv infmrgelb syl31anc infmrlb
      syld mpbird syl3anc letrd pm3.2i lemul2 syl5eqbrr ltletrd posdifd ccos cc
      mpbid recnd sinsub oveq1d coscld mul02d eqtrd oveq2d syl6eq syl2anc sin2t
      mul01i mul01d oveq12d subidi syl5eqbr syl5eqel leaddsub readdcld ledivmul
      2cn 0cn ) AUABUGKZLUBKCMNZUUNLCOKZMNZAUUQUAUUPBUCKZMNZAUAPUDUHQUEUIZUFZRS
      UHUJZUURMUKAUVARULZIVMZJVMZMNZJUVAUMZIRUNZUURUVATZUVBUURMNUVCAUVAPRPUUTUO
      ZUPUQZURZUVHAQRTZQUVEMNZJUVAUMZUVHUSUVNJUVAUVEUVATUVEUVAPUVEUVJUTVAVBUVGU
      VOIQRUVDQVCUVFUVNJUVAUVDQUVEMVDVEVFVGZURZAUURPTUURUDVHZQVCUVIAUURAUUPBALR
      TZCRTZUUPRTZVIACEVJZLCVKVLZABLVNVOKTZBRTZDBLVNVPVQZVRABUUPSNQUURSNABVNUUP
      UWFVNRTAVSURUWCALBSNZBVNSNZAUWDUWGUWHWFDBLVNVTVQZWAAVNLLOKZUUPMWBALCMNZUW
      JUUPMNZALUVBCUVSAVIURZAUVAWGWCZUVBRTZABUVATZUWNABPTBUDVHZQVCUWPABUWFAQLBU
      VMAUSURUWMUWFQLSNZAWDURAUWGUWHUWIWEWHWIFBWJWKUVABWLVQZUVCUWNUVHUWOUVKUVPI
      JUVAWMWNVQZUWBALUVBMNZLUVDMNZIUVAUMZAUXBIUVAUVDUVATUVDPTZUVDUDVHZQVCZWFAU
      XBUVDWJAUXDUXFUXBAUXDWFZUXBUXEQUXGUXBWRUVDLMNZUXEQWCZUXGUXBUXHUXGUVSUVDRT
      ZUXBUXHWSVIUXDUXJAUVDWOZWPLUVDWQVLWTUXGUXHUXIUXGUXHWFZUXEUXLUVDQLXAKTZQUX
      ESNUXLUXJQUVDSNZUXHUXMUXDUXJAUXHUXKXBUXDUXNAUXHUVDXCXBUXGUXHXDQXETUVSUXMU
      XJUXNUXHXFXKXGVIQLUVDXHVGXIUVDXJVQXLXMYAXNXOXPXQAUVCUWNUVHUVSUXAUXCXKUVLU
      WSUVQUWMIJIUVALXRXSYBAUVCUVHCUVATZUVBCMNUVLUVQACPTCUDVHZQVCUXOEGCWJWKIJCU
      VAXTYCYDAUVSUVTUVSUWRWFZUWKUWLXKUWMUWBUXQAUVSUWRVIWDYEURZLCLYFYCYLYGYHABU
      UPUWFUWCYIYLWIAUVRUUPUDVHZBYJVHZOKZUUPYJVHZUWQOKZUCKZQAUUPYKTBYKTUVRUYDVC
      AUUPUWCYMZABUWFYMZUUPBYNUUAAUYDQQUCKQAUYAQUYCQUCAUYAQUXTOKQAUXSQUXTOAUXSL
      UXPCYJVHZOKZOKZQACYKTUXSUYIVCACUWBYMZCUUBVQAUYILQOKQAUYHQLOAUYHQUYGOKQAUX
      PQUYGOGYOAUYGACUYJYPYQYRYSLUULUUCYTYRYOAUXTABUYFYPYQYRAUYCUYBQOKQAUWQQUYB
      OFYSAUYBAUUPUYEYPUUDYRUUEQUUMUUFYTYRUURWJWKIJUURUVAXTYCUUGAUARTUWEUWAUUQU
      USXKAUAUVBRUKUWTUUHZUWFUWCUABUUPUUIYCYBAUUNRTUVTUXQUUOUUQXKAUABUYKUWFUUJU
      WBUXRUUNCLUUKYCYB $.
  $}

  ${
    $d x y z $.
    $( Lemma for ~ pire , ~ pigt2lt4 and ~ sinpi .  Existence part.
       (Contributed by Paul Chapman, 23-Jan-2008.)  (Proof shortened by Mario
       Carneiro, 18-Jun-2014.) $)
    pilem3 $p |- ( pi e. ( 2 (,) 4 ) /\ ( sin ` pi ) = 0 ) $=
      ( vy vz csin cfv cc0 wceq c2 c4 co cpi wcel wa wtru cc cr a1i clt wbr cle
      crp vx cv cioo wrex 2re 4re 0re 2lt4 cicc wss mp2an ax-resscn sstri ccncf
      iccssre sincn sseli resincld adantl sin4lt0 ccos sincos2sgn simpli pm3.2i
      ivth2 trud ccnv csn cima cin csup df-pi adantr 2pos eliooord simpld lttrd
      elioore elrpd simpr pilem1 sylanbrc wral inss1 rpssre rpge0d rgen ralbidv
      breq1 rspcev infmrlb mp3an12 syl5eqbr caddc cdiv wn simplll sylib simpllr
      syl simprd simplr pilem2 ralrimiva ne0i infmrcl mp3an13 syl5eqel readdcld
      c0 wne wb rehalfcld infmrgelb syl31anc mpbird syl6breqr ex ltnled addcomd
      recnd oveq1d breq1d avgle2 syl2anc bitr4d 3imtr3d pm2.18d mpbir2and simpl
      letri3d eqeltrd fveq2d eqtrd jca rexlimiva ax-mp ) UAUBZCDZEFZUAGHUCIZUDZ
      JUUAKZJCDZEFZLZUUBMAGHNECUAGOKZMUEPHOKZMUFPEOKZMUGPGHQRMUHPGHUIIZNUJMUUJO
      NUUGUUHUUJOUJUEUFGHUOUKZULUMPCNNUNIKMUPPAUBZUUJKZUULCDZOKMUUMUULUUJOUULUU
      KUQURUSHCDEQRZEGCDQRZLMUUOUUPUTUUPGVADEQRVBVCVDPVEVFYTUUFUAUUAYRUUAKZYTLZ
      UUCUUEUURJYRUUAUURJYRFJYRSRYRJSRZUURJTCVGEVHVIZVJZOQVGVKZYRSVLUURYRUVAKZU
      VBYRSRZUURYRTKYTUVCUURYRUUQYROKZYTYRGHVRVMZUUREGYRUUIUURUGPUUGUURUEPUVFEG
      QRUURVNPUUQGYRQRZYTUUQUVGYRHQRYRGHVOVPVMVQVSUUQYTVTZYRWAWBZUVAOUJZUULBUBZ
      SRZBUVAWCZAOUDZUVCUVDUVATOTUUTWDZWEUMZUUIEUVKSRZBUVAWCZUVNUGUVQBUVAUVKUVA
      KUVKUVATUVKUVOUQWFWGUVMUVRAEOUULEFUVLUVQBUVAUULEUVKSWIWHWJUKZABYRUVAWKWLW
      TWMUURUUSUURJYRQRZJYRWNIZGWOIZJSRZUUSWPUUSUURUVTUWCUURUVTLZUWBUVBJSUWDUWB
      UVBSRZUWBUULSRZAUVAWCZUWDUWFAUVAUWDUULUVAKZLZYRUULUUQYTUVTUWHWQUWIUULTKZU
      UNEFZUWIUWHUWJUWKLUWDUWHVTUULWAWRZVPUUQYTUVTUWHWSUWIUWJUWKUWLXAUURUVTUWHX
      BXCXDUWDUVJUVAXJXKZUVNUWBOKUWEUWGXLUVJUWDUVPPUURUWMUVTUURUVCUWMUVIUVAYRXE
      WTZVMUVNUWDUVSPUWDUWAUURUWAOKUVTUURJYRUURJUVBOVLUURUWMUVBOKZUWNUVJUWMUVNU
      WOUVPUVSABUVAXFXGWTXHZUVFXIVMXMABAUVAUWBXNXOXPVLXQXRUURJYRUWPUVFXSUURUWCY
      RJWNIZGWOIZJSRZUUSUURUWBUWRJSUURUWAUWQGWOUURJYRUURJUWPYAUURYRUVFYAXTYBYCU
      URUVEJOKUUSUWSXLUVFUWPYRJYDYEYFYGYHUURJYRUWPUVFYKYIZUUQYTYJYLUURUUDYSEUUR
      JYRCUWTYMUVHYNYOYPYQ $.
  $}

  $( ` pi ` is between 2 and 4.  (Contributed by Paul Chapman, 23-Jan-2008.)
     (Revised by Mario Carneiro, 9-May-2014.) $)
  pigt2lt4 $p |- ( 2 < pi /\ pi < 4 ) $=
    ( cpi c2 c4 cioo co wcel clt wbr wa csin cfv cc0 wceq pilem3 eliooord ax-mp
    simpli ) ABCDEFZBAGHACGHIRAJKLMNQABCOP $.

  $( The sine of ` pi ` is 0.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  sinpi $p |- ( sin ` pi ) = 0 $=
    ( cpi c2 c4 cioo co wcel csin cfv cc0 wceq pilem3 simpri ) ABCDEFAGHIJKL $.

  $( ` pi ` is a real number.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  pire $p |- pi e. RR $=
    ( cpi c2 c4 cioo co wcel cr csin cfv cc0 wceq pilem3 simpli elioore ax-mp )
    ABCDEFZAGFPAHIJKLMABCNO $.

  $( ` pi ` is positive.  (Contributed by Paul Chapman, 23-Jan-2008.)  (Revised
     by Mario Carneiro, 9-May-2014.) $)
  pipos $p |- 0 < pi $=
    ( cc0 c2 clt wbr cpi 2pos c4 pigt2lt4 simpli 0re 2re pire lttri mp2an ) ABC
    DBECDZAECDFOEGCDHIABEJKLMN $.

  $( Lemma for ~ sinhalfpi and ~ coshalfpi .  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  sinhalfpilem $p |- ( ( sin ` ( pi / 2 ) ) = 1 /\
                      ( cos ` ( pi / 2 ) ) = 0 ) $=
    ( cpi c2 co csin cfv c1 wceq cc0 clt wbr ax-mp cr wcel cle pire 2re c4 cmul
    mpbi cexp cdiv ccos cneg wn 0lt1 0re ltnsymi wb lt0neg1 mtbi cioc rehalfcli
    1re pipos 2pos divgt0ii 4re pigt2lt4 simpri ltleii wa pm3.2i ledivmul mp3an
    2t2e4 breq2i bitr2i cxr w3a 0xr elioc2 mp2an mpbir3an sin02gt0 breq2 mto wo
    mpbii caddc sq1 resincl gt0ne0ii neii 2ne0 recni 2cn divcan2i fveq2i eqtr3i
    cc sin2t sinpi sincl coscl mulcli mul0ori mtp-or oveq1i sq0 oveq2i sincossq
    eqtri sqcli addid1i 3eqtr2ri ax-1cn sqeqori ori mt3 ) ABUACZDEZFGZXJUBEZHGZ
    XLXKFUCZGZXPHXOIJZFHIJZXQHFIJXRUDUEHFUFUMUGKFLMXRXQUHUMFUIKUJXPHXKIJZXQXJHB
    UKCMZXSXTXJLMZHXJIJZXJBNJZAOULZABOPUNUOUPAQNJZYCAQOUQBAIJAQIJURUSUTYCABBRCZ
    NJZYEALMBLMZYHHBIJZVAYCYGUHOPYHYIPUOVBABBVCVDYFQANVEVFVGSHVHMYHXTYAYBYCVIUH
    VJPHBXJVKVLVMXJVNKZXKXOHIVOVRVPXLXPXKBTCZFBTCZGXLXPVQYLFYKHVSCZYKVTYKXMBTCZ
    VSCZYMFYNHYKVSYNHBTCHXMHBTXKHGZXNXKHXKYAXKLMYDXJWAKYJWBWCXKXMRCZHGZYPXNVQBH
    GZYRBHWDWCBYQRCZHGYSYRVQADEZYTHBXJRCZDEZUUAYTUUBADABAOWEWFWDWGWHXJWJMZUUCYT
    GXJYDWEZXJWKKWIWLWIBYQWFXKXMUUDXKWJMUUEXJWMKZUUDXMWJMUUEXJWNKZWOWPSWQXKXMUU
    FUUGWPSWQZWRWSXBWTUUDYOFGUUEXJXAKWIYKXKUUFXCXDXEXKFUUFXFXGSXHXIUUHVB $.

  $( ` pi / 2 ` is real.  (Contributed by David Moews, 28-Feb-2017.) $)
  halfpire $p |- ( pi / 2 ) e. RR
   $=
    ( cpi pire rehalfcli ) ABC $.

  $( The sine of ` pi / 2 ` is 1.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  sinhalfpi $p |- ( sin ` ( pi / 2 ) ) = 1 $=
    ( cpi c2 cdiv co csin cfv c1 wceq ccos cc0 sinhalfpilem simpli ) ABCDZEFGHM
    IFJHKL $.

  $( The cosine of ` pi / 2 ` is 0.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  coshalfpi $p |- ( cos ` ( pi / 2 ) ) = 0 $=
    ( cpi c2 cdiv co csin cfv c1 wceq ccos cc0 sinhalfpilem simpri ) ABCDZEFGHM
    IFJHKL $.

  $( The cosine of ` -u pi / 2 ` is zero.  (Contributed by David Moews,
     28-Feb-2017.) $)
  cosneghalfpi $p |- ( cos ` -u ( pi / 2 ) ) = 0
   $=
    ( cpi c2 cdiv co cneg ccos cfv cc0 cc wcel wceq halfpire recni cosneg ax-mp
    coshalfpi eqtri ) ABCDZEFGZRFGZHRIJSTKRLMRNOPQ $.

  $( The exponential of ` _i pi / 2 ` is ` _i ` .  (Contributed by Mario
     Carneiro, 9-May-2014.) $)
  efhalfpi $p |- ( exp ` ( _i x. ( pi / 2 ) ) ) = _i $=
    ( ci cpi c2 cdiv co cmul ce cfv ccos csin caddc cc wcel wceq pire recni cc0
    c1 ax-icn eqtri halfcl efival mp2b coshalfpi oveq2i mulid1i oveq12i addid2i
    sinhalfpi ) ABCDEZFEGHZUJIHZAUJJHZFEZKEZABLMUJLMUKUONBOPBUAUJUBUCUOQAKEAULQ
    UNAKUDUNARFEAUMRAFUIUEASUFTUGASUHTT $.

  $( The cosine of ` pi ` is ` -u 1 ` .  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  cospi $p |- ( cos ` pi ) = -u 1 $=
    ( c2 cpi cdiv co cmul ccos cfv cexp c1 cmin cneg cc wcel wceq pire 2cn 2ne0
    cc0 oveq1i eqtri recni divcli cos2t divcan2i fveq2i coshalfpi oveq2i mul01i
    ax-mp sq0 df-neg eqtr4i 3eqtr3i ) ABACDZEDZFGZAUNFGZAHDZEDZIJDZBFGIKZUNLMUP
    UTNBABOUAZPQUBUNUCUIUOBFBAVBPQUDUEUTRIJDVAUSRIJUSAREDRURRAEURRAHDRUQRAHUFSU
    JTUGAPUHTSIUKULUM $.

  $( The exponential of ` _i pi ` .  (Contributed by Paul Chapman,
     23-Jan-2008.)  (Revised by Mario Carneiro, 10-May-2014.) $)
  efipi $p |- ( exp ` ( _i x. pi ) ) = -u 1 $=
    ( ci cpi cmul co ce cfv ccos csin caddc c1 cneg wcel wceq pire recni efival
    cc ax-mp cc0 eqtri cospi sinpi oveq2i ax-icn mul01i oveq12i neg1cn addid1i
    ) ABCDEFZBGFZABHFZCDZIDZJKZBQLUIUMMBNOBPRUMUNSIDUNUJUNULSIUAULASCDSUKSACUBU
    CAUDUETUFUNUGUHTT $.

  $( Euler's identity.  (Contributed by Paul Chapman, 23-Jan-2008.)  (Revised
     by Mario Carneiro, 9-May-2014.) $)
  eulerid $p |- ( ( exp ` ( _i x. pi ) ) + 1 ) = 0 $=
    ( ci cpi cmul co ce cfv c1 caddc cneg cc0 efipi oveq1i ax-1cn neg1cn negidi
    addcomli eqtri ) ABCDEFZGHDGIZGHDJRSGHKLGSJMNGMOPQ $.

  $( The sine of ` 2 pi ` is 0.  (Contributed by Paul Chapman, 23-Jan-2008.) $)
  sin2pi $p |- ( sin ` ( 2 x. pi ) ) = 0 $=
    ( c2 cpi cmul co csin cfv ccos cc0 cc wcel wceq pire recni sin2t ax-mp cneg
    c1 sinpi cospi eqtri oveq12i neg1cn mul02i oveq2i 2cn mul01i ) ABCDEFZABEFZ
    BGFZCDZCDZHBIJUGUKKBLMBNOUKAHCDHUJHACUJHQPZCDHUHHUIULCRSUAULUBUCTUDAUEUFTT
    $.

  $( The cosine of ` 2 pi ` is 1.  (Contributed by Paul Chapman,
     23-Jan-2008.) $)
  cos2pi $p |- ( cos ` ( 2 x. pi ) ) = 1 $=
    ( c2 cpi cmul co ccos cexp c1 cmin cc wcel wceq pire recni cos2t ax-mp cneg
    cfv cospi oveq1i 3eqtri ax-1cn sqneg sq1 oveq2i 2cn mulid1i eqtri 2m1e1 ) A
    BCDEQZABEQZAFDZCDZGHDZAGHDGBIJUIUMKBLMBNOULAGHULAGCDAUKGACUKGPZAFDZGAFDZGUJ
    UNAFRSGIJUOUPKUAGUBOUCTUDAUEUFUGSUHT $.

  $( The exponential of ` 2 pi _i ` is ` 1 ` .  (Contributed by Mario Carneiro,
     9-May-2014.) $)
  ef2pi $p |- ( exp ` ( _i x. ( 2 x. pi ) ) ) = 1 $=
    ( ci c2 cpi cmul co ce cfv ccos csin caddc c1 cc wcel wceq 2cn recni mulcli
    pire cc0 eqtri efival cos2pi sin2pi oveq2i ax-icn mul01i oveq12i addid1i
    ax-mp ax-1cn ) ABCDEZDEFGZUKHGZAUKIGZDEZJEZKUKLMULUPNBCOCRPQUKUAUIUPKSJEKUM
    KUOSJUBUOASDESUNSADUCUDAUEUFTUGKUJUHTT $.

  $( The exponential of ` 2 K pi _i ` is ` 1 ` .  (Contributed by Mario
     Carneiro, 9-May-2014.) $)
  ef2kpi $p |- ( K e. ZZ -> ( exp ` ( ( _i x. ( 2 x. pi ) ) x. K ) ) = 1 ) $=
    ( cz wcel ci c2 cpi cmul co ce cfv cexp c1 cc wceq ax-icn pire recni mulcli
    2cn zcn mulcom sylancr fveq2d efexp mpan ef2pi oveq1i 1exp syl5eq 3eqtrd )
    ABCZDEFGHZGHZAGHZIJAUMGHZIJZUMIJZAKHZLUKUNUOIUKUMMCZAMCUNUONDULOEFSFPQRRZAT
    UMAUAUBUCUSUKUPURNUTUMAUDUEUKURLAKHLUQLAKUFUGAUHUIUJ $.

  $( The exponential function is periodic.  (Contributed by Paul Chapman,
     21-Apr-2008.)  (Proof shortened by Mario Carneiro, 10-May-2014.) $)
  efper $p |- ( ( A e. CC /\ K e. ZZ ) ->
           ( exp ` ( A + ( ( _i x. ( 2 x. pi ) ) x. K ) ) ) = ( exp ` A ) ) $=
    ( cc wcel cz wa ci c2 cpi cmul co caddc ce cfv wceq ax-icn 2cn pire mulcli
    c1 recni zcn mulcl sylancr efadd sylan2 ef2kpi efcl mulid1d sylan9eqr eqtrd
    oveq2d ) ACDZBEDZFAGHIJKZJKZBJKZLKMNZAMNZUQMNZJKZUSUNUMUQCDZURVAOUNUPCDBCDV
    BGUOPHIQIRUASSBUBUPBUCUDAUQUEUFUNUMVAUSTJKUSUNUTTUSJBUGULUMUSAUHUIUJUK $.

  ${
    sinperlem.1 $e |- ( A e. CC -> ( F ` A ) =
      ( ( ( exp ` ( _i x. A ) ) O ( exp ` ( -u _i x. A ) ) ) / D ) ) $.
    sinperlem.2 $e |- ( ( A + ( K x. ( 2 x. pi ) ) ) e. CC ->
      ( F ` ( A + ( K x. ( 2 x. pi ) ) ) ) =
        ( ( ( exp ` ( _i x. ( A + ( K x. ( 2 x. pi ) ) ) ) ) O
          ( exp ` ( -u _i x. ( A + ( K x. ( 2 x. pi ) ) ) ) ) ) / D ) ) $.
    $( Lemma for ~ sinper and ~ cosper .  (Contributed by Paul Chapman,
       23-Jan-2008.)  (Revised by Mario Carneiro, 10-May-2014.) $)
    sinperlem $p |- ( ( A e. CC /\ K e. ZZ ) ->
                 ( F ` ( A + ( K x. ( 2 x. pi ) ) ) ) = ( F ` A ) ) $=
      ( cc wcel ci cpi cmul co caddc ce cfv cneg wceq ax-icn eqtrd cz wa c2 zcn
      cdiv 2cn recni mulcli mulcl sylancl adddi mp3an1 sylan2 mul12 mp3an13 syl
      pire mulcom adantl oveq2d fveq2d mpan efper negcli negeqd mulneg1 sylancr
      sylan mulneg2 3eqtr4d znegcl syl2an oveq12d oveq1d addcl adantr ) AHIZDUA
      IZUBZJADUCKLMZLMZNMZLMZOPZJQZWBLMZOPZEMZBUEMZJALMZOPZWEALMZOPZEMZBUEMZWBC
      PZACPZVSWHWNBUEVSWDWKWGWMEVSWDWJJVTLMZDLMZNMZOPZWKVSWCWTOVSWCWJJWALMZNMZW
      TVRVQWAHIZWCXCRZVRDHIZVTHIZXDDUDZUCKUFKUQUGUHZDVTUIUJZJHIZVQXDXESJAWAUKUL
      UMVSXBWSWJNVRXBWSRVQVRXBDWRLMZWSVRXFXBXLRZXHXKXFXGXMSXIJDVTUNUOUPVRXFWRHI
      ZXLWSRXHJVTSXIUHZDWRURUJTZUSUTTVAVQWJHIZVRXAWKRXKVQXQSJAUIVBWJDVCVHTVSWGW
      LWRDQZLMZNMZOPZWMVSWFXTOVSWFWLWEWALMZNMZXTVRVQXDWFYCRZXJWEHIZVQXDYDJSVDZW
      EAWAUKULUMVSYBXSWLNVRYBXSRVQVRXBQZWSQZYBXSVRXBWSXPVEVRXKXDYBYGRSXJJWAVFVG
      VRXNXFXSYHRXOXHWRDVIVGVJUSUTTVAVQWLHIZXRUAIYAWMRVRYEVQYIYFWEAUIVBDVKWLXRV
      CVLTVMVNVSWBHIZWPWIRVRVQXDYJXJAWAVOUMGUPVQWQWORVRFVPVJ $.
  $}

  $( The sine function is periodic.  (Contributed by Paul Chapman,
     23-Jan-2008.)  (Revised by Mario Carneiro, 10-May-2014.) $)
  sinper $p |- ( ( A e. CC /\ K e. ZZ ) ->
                 ( sin ` ( A + ( K x. ( 2 x. pi ) ) ) ) = ( sin ` A ) ) $=
    ( c2 ci cmul co csin cmin sinval cpi caddc sinperlem ) ACDEFGBHAIABCJEFEFKF
    IL $.

  $( The cosine function is periodic.  (Contributed by Paul Chapman,
     23-Jan-2008.)  (Revised by Mario Carneiro, 10-May-2014.) $)
  cosper $p |- ( ( A e. CC /\ K e. ZZ ) ->
                 ( cos ` ( A + ( K x. ( 2 x. pi ) ) ) ) = ( cos ` A ) ) $=
    ( c2 ccos caddc cosval cpi cmul co sinperlem ) ACDBEAFABCGHIHIEIFJ $.

  $( If ` K ` is an integer, the sine of ` 2 K pi ` is 0.  (Contributed by Paul
     Chapman, 23-Jan-2008.)  (Revised by Mario Carneiro, 10-May-2014.) $)
  sin2kpi $p |- ( K e. ZZ -> ( sin ` ( K x. ( 2 x. pi ) ) ) = 0 ) $=
    ( cz wcel cc0 c2 cpi cmul co caddc csin cfv zcn 2cn pire recni mulcli mulcl
    cc sylancl addid2d fveq2d wceq 0cn sinper mpan sin0 syl6eq eqtr3d ) ABCZDAE
    FGHZGHZIHZJKZUKJKDUIULUKJUIUKUIARCUJRCUKRCALEFMFNOPAUJQSTUAUIUMDJKZDDRCUIUM
    UNUBUCDAUDUEUFUGUH $.

  $( If ` K ` is an integer, the cosine of ` 2 K pi ` is 1.  (Contributed by
     Paul Chapman, 23-Jan-2008.)  (Revised by Mario Carneiro, 10-May-2014.) $)
  cos2kpi $p |- ( K e. ZZ -> ( cos ` ( K x. ( 2 x. pi ) ) ) = 1 ) $=
    ( cz wcel cc0 c2 cpi cmul co caddc ccos cfv c1 cc zcn 2cn pire recni mulcli
    mulcl sylancl addid2d fveq2d wceq 0cn cosper mpan cos0 syl6eq eqtr3d ) ABCZ
    DAEFGHZGHZIHZJKZULJKLUJUMULJUJULUJAMCUKMCULMCANEFOFPQRAUKSTUAUBUJUNDJKZLDMC
    UJUNUOUCUDDAUEUFUGUHUI $.

  $( Sine of a number subtracted from ` 2 x. pi ` .  (Contributed by Paul
     Chapman, 15-Mar-2008.) $)
  sin2pim $p |- ( A e. CC ->
                ( sin ` ( ( 2 x. pi ) - A ) ) = -u ( sin ` A ) ) $=
    ( cc wcel cneg csin cfv c2 cpi cmul co cmin c1 caddc cz wceq sinper sylancl
    negcl 1z eqtr3d 2cn recni mulcli mulid2i oveq2i wa negsubdi negsubdi2 mpan2
    pire syl5eq fveq2d sinneg ) ABCZADZEFZGHIJZAKJZEFZAEFDUNUOLUQIJZMJZEFZUPUSU
    NUOBCLNCVBUPOARSUOLPQUNVAUREUNVAUOUQMJZURUTUQUOMUQGHUAHUJUBUCZUDUEUNUQBCZVC
    UROVDUNVEUFAUQKJDVCURAUQUGAUQUHTUIUKULTAUMT $.

  $( Cosine of a number subtracted from ` 2 x. pi ` .  (Contributed by Paul
     Chapman, 15-Mar-2008.) $)
  cos2pim $p |- ( A e. CC -> ( cos ` ( ( 2 x. pi ) - A ) ) = ( cos ` A ) ) $=
    ( cc wcel cneg ccos cfv c2 cpi cmul co cmin c1 caddc cz wceq cosper sylancl
    negcl 1z eqtr3d 2cn recni mulcli mulid2i oveq2i wa negsubdi negsubdi2 mpan2
    pire syl5eq fveq2d cosneg ) ABCZADZEFZGHIJZAKJZEFZAEFUNUOLUQIJZMJZEFZUPUSUN
    UOBCLNCVBUPOARSUOLPQUNVAUREUNVAUOUQMJZURUTUQUOMUQGHUAHUJUBUCZUDUEUNUQBCZVCU
    ROVDUNVEUFAUQKJDVCURAUQUGAUQUHTUIUKULTAUMT $.

  $( Sine of a number less ` pi ` .  (Contributed by Paul Chapman,
     15-Mar-2008.) $)
  sinmpi $p |- ( A e. CC -> ( sin ` ( A - pi ) ) = -u ( sin ` A ) ) $=
    ( cc wcel cpi cmin csin cfv ccos cmul cneg wceq pire recni sinsub mpan2 cc0
    co oveq2i eqtrd syl5eq c1 cospi sincl neg1cn mulcom mulm1 syl sinpi oveq12d
    coscl mul01d negcld subid1d ) ABCZADEQFGZAFGZDHGZIQZAHGZDFGZIQZEQZUPJZUNDBC
    UOVBKDLMADNOUNVBVCPEQVCUNURVCVAPEUNURUPUAJZIQZVCUQVDUPIUBRUNUPBCZVEVCKAUCZV
    FVEVDUPIQZVCVFVDBCVEVHKUDUPVDUEOUPUFSUGTUNVAUSPIQPUTPUSIUHRUNUSAUJUKTUIUNVC
    UNUPVGULUMSS $.

  $( Cosine of a number less ` pi ` .  (Contributed by Paul Chapman,
     15-Mar-2008.) $)
  cosmpi $p |- ( A e. CC -> ( cos ` ( A - pi ) ) = -u ( cos ` A ) ) $=
    ( cc wcel cpi cmin co ccos cfv cmul csin caddc cneg wceq recni mpan2 oveq2i
    pire cc0 eqtrd syl5eq cossub c1 cospi coscl neg1cn mulcom mulm1 sinpi sincl
    syl mul01d oveq12d negcld addid1d ) ABCZADEFGHZAGHZDGHZIFZAJHZDJHZIFZKFZUQL
    ZUODBCUPVCMDQNADUAOUOVCVDRKFVDUOUSVDVBRKUOUSUQUBLZIFZVDURVEUQIUCPUOUQBCZVFV
    DMAUDZVGVFVEUQIFZVDVGVEBCVFVIMUEUQVEUFOUQUGSUJTUOVBUTRIFRVARUTIUHPUOUTAUIUK
    TULUOVDUOUQVHUMUNSS $.

  $( Sine of a number plus ` pi ` .  (Contributed by NM, 10-Aug-2008.) $)
  sinppi $p |- ( A e. CC -> ( sin ` ( A + pi ) ) = -u ( sin ` A ) ) $=
    ( cc wcel cpi caddc co csin cfv ccos cmul cneg wceq pire recni sinadd mpan2
    cc0 oveq2i eqtrd syl5eq c1 cospi sincl neg1cn mulcom mulm1 syl sinpi mul01d
    coscl oveq12d negcld addid1d ) ABCZADEFGHZAGHZDIHZJFZAIHZDGHZJFZEFZUPKZUNDB
    CUOVBLDMNADOPUNVBVCQEFVCUNURVCVAQEUNURUPUAKZJFZVCUQVDUPJUBRUNUPBCZVEVCLAUCZ
    VFVEVDUPJFZVCVFVDBCVEVHLUDUPVDUEPUPUFSUGTUNVAUSQJFQUTQUSJUHRUNUSAUJUITUKUNV
    CUNUPVGULUMSS $.

  $( Cosine of a complex number plus ` pi ` .  (Contributed by NM,
     18-Aug-2008.) $)
  cosppi $p |- ( A e. CC -> ( cos ` ( A + pi ) ) = -u ( cos ` A ) ) $=
    ( cc wcel cpi caddc co ccos cfv cmul csin cmin cneg wceq recni mpan2 oveq2i
    pire cc0 eqtrd syl5eq cosadd c1 cospi coscl neg1cn mulcom mulm1 sinpi sincl
    syl mul01d oveq12d negcld subid1d ) ABCZADEFGHZAGHZDGHZIFZAJHZDJHZIFZKFZUQL
    ZUODBCUPVCMDQNADUAOUOVCVDRKFVDUOUSVDVBRKUOUSUQUBLZIFZVDURVEUQIUCPUOUQBCZVFV
    DMAUDZVGVFVEUQIFZVDVGVEBCVFVIMUEUQVEUFOUQUGSUJTUOVBUTRIFRVARUTIUHPUOUTAUIUK
    TULUOVDUOUQVHUMUNSS $.

  $( The exponential function of ` _i ` times a real number less ` pi ` .
     (Contributed by Paul Chapman, 15-Mar-2008.) $)
  efimpi $p |- ( A e. CC ->
                 ( exp ` ( _i x. ( A - pi ) ) ) = -u ( exp ` ( _i x. A ) ) ) $=
    ( cc wcel ci cpi cmin co cmul ce cfv ccos csin cneg wceq pire efival ax-icn
    caddc sylancr eqtr4d recni subcl mpan2 syl coscl sincl negdid cosmpi sinmpi
    mulcl oveq2d mulneg2 eqtrd oveq12d negeqd ) ABCZDAEFGZHGIJZAKJZDALJZHGZRGZM
    ZDAHGIJZMUPURUQKJZDUQLJZHGZRGZVCUPUQBCZURVHNUPEBCVIEOUAAEUBUCUQPUDUPVCUSMZV
    AMZRGVHUPUSVAAUEUPDBCZUTBCZVABCQAUFZDUTUJSUGUPVEVJVGVKRAUHUPVGDUTMZHGZVKUPV
    FVODHAUIUKUPVLVMVPVKNQVNDUTULSUMUNTTUPVDVBAPUOT $.

  $( The sine of ` pi / 2 ` plus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  sinhalfpip $p |- ( A e. CC -> ( sin ` ( ( pi / 2 ) + A ) ) = ( cos ` A ) ) $=
    ( cc wcel cpi c2 cdiv co caddc csin cfv ccos cmul cc0 wceq recni 2cn oveq1i
    pire c1 syl5eq 2ne0 divcli sinadd mpan sinhalfpi coscl mulid2d sincl mul02d
    coshalfpi oveq12d addid1d 3eqtrd ) ABCZDEFGZAHGIJZUOIJZAKJZLGZUOKJZAIJZLGZH
    GZURMHGURUOBCUNUPVCNDEDROPUAUBUOAUCUDUNUSURVBMHUNUSSURLGURUQSURLUEQUNURAUFZ
    UGTUNVBMVALGMUTMVALUJQUNVAAUHUITUKUNURVDULUM $.

  $( The sine of ` pi / 2 ` minus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  sinhalfpim $p |- ( A e. CC -> ( sin ` ( ( pi / 2 ) - A ) ) = ( cos ` A ) ) $=
    ( cc wcel cpi c2 cdiv co cmin csin cfv ccos cmul cc0 wceq pire recni 2cn c1
    oveq1i syl5eq 2ne0 divcli sinsub mpan sinhalfpi coscl mulid2d sincl oveq12d
    coshalfpi mul02d subid1d 3eqtrd ) ABCZDEFGZAHGIJZUOIJZAKJZLGZUOKJZAIJZLGZHG
    ZURMHGURUOBCUNUPVCNDEDOPQUAUBUOAUCUDUNUSURVBMHUNUSRURLGURUQRURLUESUNURAUFZU
    GTUNVBMVALGMUTMVALUJSUNVAAUHUKTUIUNURVDULUM $.

  $( The cosine of ` pi / 2 ` plus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  coshalfpip $p |- ( A e. CC ->
                     ( cos ` ( ( pi / 2 ) + A ) ) = -u ( sin ` A ) ) $=
    ( cc wcel cpi c2 cdiv co ccos cfv cmul csin cmin cc0 caddc coshalfpi oveq1i
    cneg syl5eq c1 wceq coscl mul02d sinhalfpi sincl mulid2d oveq12d pire recni
    2cn 2ne0 divcli cosadd mpan df-neg a1i 3eqtr4d ) ABCZDEFGZHIZAHIZJGZURKIZAK
    IZJGZLGZMVCLGZURANGHIZVCQZUQVAMVDVCLUQVAMUTJGMUSMUTJOPUQUTAUAUBRUQVDSVCJGVC
    VBSVCJUCPUQVCAUDUERUFURBCUQVGVETDEDUGUHUIUJUKURAULUMVHVFTUQVCUNUOUP $.

  $( The cosine of ` pi / 2 ` minus a number.  (Contributed by Paul Chapman,
     24-Jan-2008.) $)
  coshalfpim $p |- ( A e. CC -> ( cos ` ( ( pi / 2 ) - A ) ) = ( sin ` A ) ) $=
    ( cc wcel cpi c2 cdiv co cmin ccos cfv cmul csin caddc cc0 wceq pire oveq1i
    recni syl5eq c1 2cn 2ne0 divcli cossub mpan coshalfpi coscl sinhalfpi sincl
    mul02d mulid2d oveq12d addid2d 3eqtrd ) ABCZDEFGZAHGIJZUPIJZAIJZKGZUPLJZALJ
    ZKGZMGZNVBMGVBUPBCUOUQVDODEDPRUAUBUCUPAUDUEUOUTNVCVBMUOUTNUSKGNURNUSKUFQUOU
    SAUGUJSUOVCTVBKGVBVATVBKUHQUOVBAUIZUKSULUOVBVEUMUN $.

  $( Ptolemy's Theorem.  This theorem is named after the Greek astronomer and
     mathematician Ptolemy (Claudius Ptolemaeus).  This particular version is
     expressed using the sine function.  It is proved by expanding all the
     multiplication of sines to a product of cosines of differences using
     ~ sinmul , then using algebraic simplification to show that both sides are
     equal.  This formalization is based on the proof in "Trigonometry" by
     Gelfand and Saul.  (Contributed by David A. Wheeler, 31-May-2015.) $)
  ptolemy $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) /\
                    ( ( A + B ) + ( C + D ) ) = pi ) ->
           ( ( ( sin ` A ) x. ( sin ` B ) ) + ( ( sin ` C ) x. ( sin ` D ) ) )
           = ( ( sin ` ( B + C ) ) x. ( sin ` ( A + C ) ) ) ) $=
    ( cc wcel wa caddc co cpi wceq cmin ccos cfv c2 cdiv csin cneg syl 3adant3
    w3a addcl 3ad2ant2 coscld negnegd cc0 addid2 oveq1d 0cn a1i adantr pnpcan2d
    cmul simp3 oveq2d df-neg syl6eqr fveq2d cosmpi cosneg 3eqtr3d negeqd eqtr3d
    3eqtr3rd subcl adantl subnegd wne 3ad2ant1 subcld addcld 2ne0 pm3.2i divdir
    eqtrd 2cn syl3anc nppcan3d sinmul oveq12d simplr simpll simprl addass oveq1
    3jca 3ad2ant3 simpl simpr ppncan jca add4 syl2anc ad2ant2r ad2ant2lr addcom
    simp1 3eqtrd pire recni sylancr cosppi ancoms negsubdi2 3eqtr4d ) AEFZBEFZG
    ZCEFZDEFZGZABHIZCDHIZHIZJKZUAZABLIZMNZXLMNZLIZOPIZCDLIZMNZXMMNZLIZOPIZHIZXR
    YCHIZOPIZAQNBQNUMIZCQNDQNUMIZHIBCHIZQNACHIZQNUMIZXPYGYAYCXSHIZOPIZHIZYIXPYF
    YPYAHXPYEYOOPXPYEYCXSRZLIYOXPYDYRYCLXPYDRZRYDYRXPYDXPXMXKXHXMEFZXOCDUBZUCZU
    DUEXPYSXSXPXMJLIZMNZXLRZMNZYSXSXPUUCUUEMXPUUCUFXLLIZUUEXPUFXMHIZXNLIZXMXNLI
    ZUUGUUCXPYTUUIUUJKUUBYTUUHXMXNLXMUGUHSXPUFXLXMUFEFXPUIUJXHXKXLEFZXOXHUUKXKA
    BUBUKZTZUUBULXPXNJXMLXHXKXOUNUOVDXLUPUQURXPYTUUDYSKUUBXMUSSXPUUKUUFXSKUUMXL
    UTSVAVBVCUOXPYCXSXHXKYCEFXOXHXKGZYBXKYBEFZXHCDVEVFZUDZTZXPXLUUMUDZVGVOUHUOX
    PXTYOHIZOPIZYQYIXPXTEFYOEFOEFZOUFVHZGZUVAYQKXPXRXSXPXQXHXKXQEFZXOABVEZVIUDZ
    UUSVJXPYCXSUURUUSVKUVDXPUVBUVCVPVLVMUJXTYOOVNVQXPUUTYHOPXPXRXSYCUVGUUSUURVR
    UHVCVOXPYJYAYKYFHXHXKYJYAKXOABVSVIXKXHYKYFKXOCDVSUCVTXPYLYMLIZMNZYLYMHIZMNZ
    LIZOPIZBALIZMNZYCHIZOPIYNYIXPUVLUVPOPXPUVLUVOYCRZLIZUVPXPUVIUVOUVKUVQLXHXKU
    VIUVOKXOUUNUVHUVNMUUNBACXFXGXKWAXFXGXKWBXHXIXJWCULURTXPUVKYBJHIZMNZUVQXPUVJ
    UVSMXPUVJJYBHIZUVSXPXNYBHIZXLXMYBHIZHIZUWAUVJXPUUKYTUUOUAZUWBUWDKXHXKUWEXOU
    UNUUKYTUUOUULXKYTXHUUAVFUUPWFTXLXMYBWDSXOXHUWBUWAKXKXNJYBHWEWGXPUWDXLCCHIZH
    IZYMYLHIZUVJXPXIXJXIUAZUWDUWGKXKXHUWIXOXKXIXJXIXIXJWHZXIXJWIUWJWFUCUWIUWCUW
    FXLHCDCWJUOSXPXHXIXIGZUWGUWHKXHXKXOWQXKXHUWKXOXKXIXIUWJUWJWKUCABCCWLWMXPYME
    FZYLEFZGZUWHUVJKXHXKUWNXOUUNUWLUWMXFXIUWLXGXJACUBWNZXGXIUWMXFXJBCUBWOZWKTYM
    YLWPSWRVDXHXKUWAUVSKZXOUUNJEFUUOUWQJWSWTUUPJYBWPXATVOURXHXKUVTUVQKZXOUUNUUO
    UWRUUPYBXBSTVOVTXHXKUVRUVPKXOUUNUVOYCUUNUVNXHUVNEFZXKXGXFUWSBAVEXCUKUDUUQVG
    TVOUHXHXKYNUVMKZXOUUNUWMUWLUWTUWPUWOYLYMVSWMTXPYHUVPOPXPXRUVOYCHXHXKXRUVOKX
    OXHXQRZMNZXRUVOXHUVEUXBXRKUVFXQUTSXHUXAUVNMABXDURVCVIUHUHXEXE $.

  $( Lemma for ~ sincosq1sgn .  (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq1lem $p |- ( ( A e. RR /\ 0 < A /\ A < ( pi / 2 ) ) ->
                      0 < ( sin ` A ) ) $=
    ( cr wcel cc0 clt wbr cpi c2 cdiv co cle csin cfv wi halfpire c4 pire wa wb
    2re ltle mpan2 pigt2lt4 simpri ltleii cmul 2pos pm3.2i ledivmul mp3an 2t2e4
    4re breq2i bitri letr mp3an23 mpan2i syld adantr 3impia w3a cioc cxr elioc2
    mpbir 0xr mp2an sin02gt0 sylbir syld3an3 ) ABCZDAEFZAGHIJZEFZAHKFZDALMEFZVK
    VLVNVOVKVNVONVLVKVNAVMKFZVOVKVMBCZVNVQNOAVMUAUBVKVQVMHKFZVOVSGPKFZGPQULHGEF
    GPEFUCUDUEVSGHHUFJZKFZVTGBCHBCZWCDHEFZRVSWBSQTWCWDTUGUHGHHUIUJWAPGKUKUMUNVE
    VKVRWCVQVSRVONOTAVMHUOUPUQURUSUTVKVLVOVAZADHVBJCZVPDVCCWCWFWESVFTDHAVDVGAVH
    VIVJ $.

  $( The signs of the sine and cosine functions in the first quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq1sgn $p |- ( A e. ( 0 (,) ( pi / 2 ) ) ->
                      ( 0 < ( sin ` A ) /\ 0 < ( cos ` A ) ) ) $=
    ( cc0 cpi c2 cdiv co cioo wcel cr clt wbr csin cfv cxr halfpire sincosq1lem
    wa wb cmin syl6bb w3a ccos 0xr rexri elioo2 resubcl mpan syl3an1 3expib 0re
    mp2an ltsub13 mp3an12 recni subid1i breq2i ltsub23 mp3an13 subidi breq1i cc
    anbi12d ancom wceq recn sinhalfpim syl breq2d 3imtr3d 3impib jca sylbi ) AB
    CDEFZGFHZAIHZBAJKZAVMJKZUAZBALMJKZBAUBMZJKZQBNHVMNHVNVRRUCVMOUDBVMAUEUKVRVS
    WAAPVOVPVQWAVOBVMASFZJKZWBVMJKZQZBWBLMZJKZVPVQQZWAVOWCWDWGVOWBIHZWCWDWGVMIH
    ZVOWIOVMAUFUGWBPUHUIVOWEVQVPQWHVOWCVQWDVPVOWCAVMBSFZJKZVQBIHWJVOWCWLRUJOBVM
    AULUMWKVMAJVMVMOUNZUOUPTVOWDVMVMSFZAJKZVPWJVOWJWDWOROOVMAVMUQURWNBAJVMWMUSU
    TTVBVQVPVCTVOWFVTBJVOAVAHWFVTVDAVEAVFVGVHVIVJVKVL $.

  $( The signs of the sine and cosine functions in the second quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq2sgn $p |- ( A e. ( ( pi / 2 ) (,) pi ) ->
                      ( 0 < ( sin ` A ) /\ ( cos ` A ) < 0 ) ) $=
    ( cpi co cioo wcel cr clt wbr w3a cc0 csin cfv ccos wa wb halfpire pire cxr
    cc wceq c2 cdiv rexr elioo2 syl2an mp2an cmin resubcl mpan2 0xr sincosq1sgn
    cneg ax-mp sylbir syl3an1 3expib ltsub13 mp3an13 subid1d breq2d bitrd caddc
    recn ltsubadd mp3an23 recni 2halves breq2i syl6bb anbi12d resincld lt0neg2d
    0re anbi1d 3imtr3d pncan3 sylancr fveq2d recnd coshalfpip syl eqtr3d breq1d
    sinhalfpip sylibrd 3impib ancomd sylbi ) ABUAUBCZBDCEZAFEZWIAGHZABGHZIZJAKL
    ZGHZAMLZJGHZNWIFEZBFEZWJWNOZPQWSWIREZBREXAWTWIUCZBUCWIBAUDUEUFWNWRWPWKWLWMW
    RWPNZWKWLWMNZAWIUGCZKLZULZJGHZJXFMLZGHZNZXDWKJXFGHZXFWIGHZNJXGGHZXKNZXEXLWK
    XMXNXPWKXFFEZXMXNXPWKWSXQPAWIUHUIZXQXMXNIZXFJWIDCEZXPJREXBXTXSOUJWSXBPXCUMJ
    WIXFUDUFXFUKUNUOUPWKXMWLXNWMWKXMWIAJUGCZGHZWLJFEWKWSXMYBOVMPJAWIUQURWKYAAWI
    GWKAAVCZUSUTVAWKXNAWIWIVBCZGHZWMWKWSWSXNYEOPPAWIWIVDVEYDBAGBSEYDBTBQVFBVGUM
    VHVIVJWKXOXIXKWKXGWKXFXRVKVLVNVOWKWRXIWPXKWKWQXHJGWKWIXFVBCZMLZWQXHWKYFAMWK
    WISEASEYFATWIPVFYCWIAVPVQZVRWKXFSEZYGXHTWKXFXRVSZXFVTWAWBWCWKWOXJJGWKYFKLZW
    OXJWKYFAKYHVRWKYIYKXJTYJXFWDWAWBUTVJWEWFWGWH $.

  $( The signs of the sine and cosine functions in the third quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq3sgn $p |- ( A e. ( pi (,) ( 3 x. ( pi / 2 ) ) ) ->
                      ( ( sin ` A ) < 0 /\ ( cos ` A ) < 0 ) ) $=
    ( cpi c2 co cmul wcel cr clt wbr csin cfv ccos wa wb pire halfpire caddc cc
    cc0 wceq cdiv cioo w3a 3re remulcli cxr rexr elioo2 syl2an mp2an cmin recni
    c3 cneg 2halves ax-mp breq1i ltaddsub mp3an12 syl5bbr ltsubadd mp3an23 df-3
    c1 oveq1i 2cn adddiri 2ne0 divcan2i mulid2i oveq12i 3eqtrri syl6rbb anbi12d
    ax-1cn breq2i resubcl mpan2 sincosq2sgn ancom 3imtr3i syl3an1 3expib sylbid
    resincld lt0neg2d anbi2d sylibd recn pncan3 sylancr fveq2d recnd sinhalfpip
    syl eqtr3d breq1d coshalfpip sylibrd 3impib sylbi ) ABUMBCUADZEDZUBDFZAGFZB
    AHIZAXCHIZUCZAJKZSHIZALKZSHIZMZBGFZXCGFZXDXHNZOUMXBUDPUEXNBUFFZXCUFFXPXOBUG
    ZXCUGBXCAUHUIUJXEXFXGXMXEXFXGMZAXBUKDZLKZSHIZXTJKZUNZSHIZMZXMXEXSYBSYCHIZMZ
    YFXEXSXBXTHIZXTBHIZMYHXEXFYIXGYJXFXBXBQDZAHIZXEYIYKBAHBRFYKBTBOULZBUOUPUQXB
    GFZYNXEYLYINPPXBXBAURUSUTXEYJABXBQDZHIZXGXEYNXNYJYPNPOAXBBVAVBYOXCAHXCCVDQD
    ZXBEDCXBEDZVDXBEDZQDYOUMYQXBEVCVECVDXBVFVOXBPULZVGYRBYSXBQBCYMVFVHVIXBYTVJV
    KVLVPVMVNXEYIYJYHXEXTGFZYIYJYHXEYNUUAPAXBVQVRZXTXBBUBDFZYGYBMUUAYIYJUCZYHXT
    VSYNXNUUCUUDNZPOYNXBUFFXQUUEXNXBUGXRXBBXTUHUIUJYGYBVTWAWBWCWDXEYGYEYBXEYCXE
    XTUUBWEWFWGWHXEXJYBXLYEXEXIYASHXEXBXTQDZJKZXIYAXEUUFAJXEXBRFARFUUFATYTAWIXB
    AWJWKZWLXEXTRFZUUGYATXEXTUUBWMZXTWNWOWPWQXEXKYDSHXEUUFLKZXKYDXEUUFALUUHWLXE
    UUIUUKYDTUUJXTWRWOWPWQVNWSWTXA $.

  $( The signs of the sine and cosine functions in the fourth quadrant.
     (Contributed by Paul Chapman, 24-Jan-2008.) $)
  sincosq4sgn $p |- ( A e. ( ( 3 x. ( pi / 2 ) ) (,) ( 2 x. pi ) ) ->
                      ( ( sin ` A ) < 0 /\ 0 < ( cos ` A ) ) ) $=
    ( c3 cpi c2 co cmul wcel cr clt wbr csin cfv cc0 wa halfpire caddc c1 c4 cc
    ccos cdiv cioo w3a cxr wb 3re remulcli rexri 2re pire elioo2 cmin cneg df-3
    mp2an oveq1i 2cn ax-1cn recni adddiri 2ne0 divcan2i mulid2i oveq12i 3eqtrri
    breq1i ltaddsub mp3an12 syl5bbr ltsubadd mp3an23 df-4 oveq2i wne 4cn pm3.2i
    div12 mp3an 4d2e2 mulcomi eqtri breq2i syl6rbb anbi12d resubcl mpan2 sylbir
    wceq sincosq3sgn syl3an1 3expib sylbid resincld lt0neg1d anbi1d sylibd recn
    pncan3 sylancr fveq2d recnd coshalfpip syl eqtr3d breq2d sinhalfpip sylibrd
    breq1d 3impib ancomd sylbi ) ABCDUAEZFEZDCFEZUBEGZAHGZXMAIJZAXNIJZUCZAKLZMI
    JZMATLZIJZNXMUDGZXNUDGXOXSUEXMBXLUFOUGZUHZXNDCUIUJUGUHXMXNAUKUOXSYCYAXPXQXR
    YCYANZXPXQXRNZMAXLULEZKLZUMZIJZYITLZMIJZNZYGXPYHYJMIJZYNNZYOXPYHCYIIJZYIXMI
    JZNYQXPXQYRXRYSXQCXLPEZAIJZXPYRYTXMAIXMDQPEZXLFEDXLFEZQXLFEZPEYTBUUBXLFUNUP
    DQXLUQURXLOUSZUTUUCCUUDXLPCDCUJUSZUQVAVBXLUUEVCZVDVEVFCHGXLHGZXPUUAYRUEUJOC
    XLAVGVHVIXPYSAXMXLPEZIJZXRXPUUHXMHGYSUUJUEOYEAXLXMVJVKUUIXNAIUUIRXLFEZXNUUK
    BQPEZXLFEXMUUDPEUUIRUULXLFVLUPBQXLBUFUSURUUEUTUUDXLXMPUUGVMVEUUKCRDUAEZFEZX
    NRSGCSGDSGZDMVNZNUUKUUNWHVOUUFUUOUUPUQVAVPRCDVQVRUUNCDFEXNUUMDCFVSVMCDUUFUQ
    VTWAWAWAWBWCWDXPYRYSYQXPYIHGZYRYSYQXPUUHUUQOAXLWEWFZUUQYRYSUCZYICXMUBEGZYQC
    UDGYDUUTUUSUECUJUHYFCXMYIUKUOYIWIWGWJWKWLXPYPYLYNXPYJXPYIUURWMWNWOWPXPYCYLY
    AYNXPYBYKMIXPXLYIPEZTLZYBYKXPUVAATXPXLSGASGUVAAWHUUEAWQXLAWRWSZWTXPYISGZUVB
    YKWHXPYIUURXAZYIXBXCXDXEXPXTYMMIXPUVAKLZXTYMXPUVAAKUVCWTXPUVDUVFYMWHUVEYIXF
    XCXDXHWDXGXIXJXK $.


  $( Location of the zeroes of cosine in ` ( 0 [,] pi ) ` .  (Contributed by
     David Moews, 28-Feb-2017.) $)
  coseq00topi $p |- ( A e. ( 0 [,] pi ) -> ( ( cos ` A ) = 0 <->
                                             A = ( pi / 2 ) ) ) $=
    ( cc0 cpi co wcel ccos cfv wceq wa clt wbr cr w3a 0re pire a1i simplr simpr
    wne c1 cicc c2 cdiv w3o cle simpl elicc2i sylib rehalfcld lttri4d csin cioo
    simp1d ad2antrr wb rexri halfpire elioo2 mp2an syl3anbrc sincosq1sgn simprd
    cxr syl gt0ne0d cos0 fveq2d syl5reqr ax-1ne0 eqnetrd wo simp2d leloed mpbid
    adantr mpjaodan pm2.21ddne sincosq2sgn lt0ne0d syl6eq ax-1cn negne0i simp3d
    cneg cospi 3jaodan mpdan fveq2 coshalfpi adantl impbida ) ABCUADEZAFGZBHZAC
    UBUCDZHZWLWNIZAWOJKZWPWOAJKZUDWPWQAWOWQALEZBAUEKZACUEKZWQWLWTXAXBMWLWNUFBCA
    NOUGUHZUMZWQCCLEWQOPZUIUJWQWRWPWPWSWQWRIZWPWMBWLWNWRQXFBAJKZWMBSZBAHZXFXGIZ
    WMXJBAUKGJKZBWMJKZXJABWOULDEZXKXLIXJWTXGWRXMWQWTWRXGXDUNXFXGRWQWRXGQBVCEWOV
    CEZXMWTXGWRMUOBNUPWOUQUPZBWOAURUSUTAVAVDVBVEXFXIIZWMTBXPTBFGWMVFXPBAFXFXIRV
    GVHTBSXPVIPVJWQXGXIVKZWRWQXAXQWQWTXAXBXCVLWQBABLEWQNPXDVMVNVOVPVQWQWPRWQWSI
    ZWPWMBWLWNWSQXRACJKZXHACHZXRXSIZWMYAXKWMBJKZYAAWOCULDEZXKYBIYAWTWSXSYCWQWTW
    SXSXDUNWQWSXSQXRXSRXNCVCEYCWTWSXSMUOXOCOUPWOCAURUSUTAVRVDVBVSXRXTIZWMTWDZBY
    DWMCFGYEYDACFXRXTRVGWEVTYEBSYDTWAVIWBPVJWQXSXTVKZWSWQXBYFWQWTXAXBXCWCWQACXD
    XEVMVNVOVPVQWFWGWPWNWLWPWMWOFGBAWOFWHWIVTWJWK $.

  $( Location of the zeroes of cosine in ` ( -u pi (,] pi ) ` .  (Contributed
     by David Moews, 28-Feb-2017.) $)
  coseq0negpitopi $p |- ( A e. ( -u pi (,] pi ) ->
            ( ( cos ` A ) = 0 <-> A e. { ( pi / 2 ) , -u ( pi / 2 ) } ) ) $=
    ( cpi cneg co wcel ccos cfv cc0 wceq wa cr wbr cle pire renegcli 0re adantr
    wb syl mpbid cioc c2 cdiv cpr clt w3a simpl rexri elioc2 mp2an sylib simp1d
    cxr a1i recnd cosneg simplr eqtrd renegcld simpr le0neg1d simp2d ltnegcon1d
    cc cicc ltled syl3anbrc coseq00topi negcon1ad eqcomd halfpire prid2g eleq1a
    elicc2i wi mp2b simp3d prid1g lecasei wo elpri fveq2 coshalfpi cosneghalfpi
    syl6eq jaoi adantl impbida ) ABCZBUADEZAFGZHIZABUBUCDZWMCZUDZEZWJWLJZWPAHWQ
    AKEZWIAUELZABMLZWQWJWRWSWTUFZWJWLUGWIUMEBKEZWJXARWIBNOUHNWIBAUIUJUKZULZHKEW
    QPUNWQAHMLZJZAWNIZWPXFWNAXFAWMXFAWQWRXEXDQZUOXFACZFGZHIZXIWMIZXFXJWKHXFAVDE
    ZXJWKIWQXMXEWQAXDUOQAUPSWJWLXEUQURXFXIHBVEDZEZXKXLRXFXIKEZHXIMLZXIBMLZXOWQX
    PXEWQAXDUSZQXFXEXQWQXEUTXFAXHVATWQXRXEWQXIBXSXBWQNUNZWQBAXTXDWQWRWSWTXCVBVC
    VFQHBXIPNVNVGXIVHSTVIVJWNKEWNWOEXGWPVOWMVKOWMWNKVLWNWOAVMVPSWQHAMLZJZAWMIZW
    PYBWLYCWJWLYAUQYBAXNEZWLYCRYBWRYAWTYDWQWRYAXDQWQYAUTWQWTYAWQWRWSWTXCVQQHBAP
    NVNVGAVHSTWMKEWMWOEYCWPVOVKWMWNKVRWMWOAVMVPSVSWPWLWJWPYCXGVTWLAWMWNWAYCWLXG
    YCWKWMFGHAWMFWBWCWEXGWKWNFGHAWNFWBWDWEWFSWGWH $.


  $( Positive real closure of the tangent function.  (Contributed by Mario
     Carneiro, 29-Jul-2014.) $)
  tanrpcl $p |- ( A e. ( 0 (,) ( pi / 2 ) ) -> ( tan ` A ) e. RR+ ) $=
    ( cc0 cpi c2 cdiv cioo wcel ctan cfv csin ccos crp wne wceq elioore clt wbr
    co cc elrpd recnd recoscld sincosq1sgn simprd rpne0d tanval resincld simpld
    syl2anc rpdivcld eqeltrd ) ABCDERZFRGZAHIZAJIZAKIZERZLUMASGUPBMUNUQNUMAABUL
    OZUAUMUPUMUPUMAURUBUMBUOPQZBUPPQZAUCZUDTZUEAUFUIUMUOUPUMUOUMAURUGUMUSUTVAUH
    TVBUJUK $.

  $( The tangent function is greater than its argument on positive reals in its
     principal domain.  (Contributed by Mario Carneiro, 29-Jul-2014.) $)
  tangtx $p |- ( A e. ( 0 (,) ( pi / 2 ) ) -> A < ( tan ` A ) ) $=
    ( cc0 cpi c2 co wcel clt cmul wbr c1 cexp c3 cmin cr sylancr recnd cc caddc
    a1i wb cdiv cioo csin cfv elioore recoscld remulcld 1re cn rehalfcl resqcld
    ccos ctan syl 3nn nndivre sylancl resubcl 2re remulcl resincld 2cn wne 2ne0
    divcan2d fveq2d wceq cos2t eqtr3d cioc wa eliooord simpld 2pos divgt0d pire
    cle simprd pigt2lt4 simpri 2t2e4 breqtrri pm3.2i ltdivmul mp3an mpbir lttrd
    mp1i c4 mulid2i syl6breqr ltdivmul2 syl112anc mpbird ltled cxr elioc2 mp2an
    w3a 0xr syl3anbrc cos01bnd cos01gt0 wi 0re mpd lt2sqd mpbid ltmul2 ltsub1dd
    ltle eqbrtrd 3re 4re readdcl 3lt4 gt0ne0d sqgt0d 3pos ltmul1 mpbii ltsub2dd
    sq1 mulid2d oveq2d oveq12d oveq1d ax-1cn addcl subdid oveq1i syl5eq mulassd
    eqtrd 3eqtrd mulid1d eqtr4d df-3 breqtrrd cn0 binom2sub syl5reqr addsubassd
    addsubd 3eqtr4d adddid 2timesi addassd subcld pncan2 subcl subdird subadd4d
    mul12d sqvald addcomi eqtri adddird 3brtr4d mulgt0d oveq2i 2nn0 mulcomd 3cn
    expp1 3ne0 divassd 3eqtr3d sin01bnd 3nn0 reexpcl resubcld sin2t sincosq1sgn
    eqtr2d 3eqtr2rd ltmuldiv tanval syl2anc ) ABCDUAEZUBEFZAAUCUDZAULUDZUAEZAUM
    UDZGUWAAUWCHEZUWBGIZAUWDGIZUWAUWFAJADUAEZDKEZLUAEZMEZHEZJDUWKHEZMEZHEZUWBUW
    AAUWCABUVTUEZUWAAUWQUFZUGUWAUWMUWOUWAAUWLUWQUWAJNFZUWKNFZUWLNFUHUWAUWJNFLUI
    FZUWTUWAUWIUWAANFZUWINFZUWQAUJUNZUKZUOUWJLUPUQZJUWKUROZUGZUWAUWSUWNNFZUWONF
    ZUHUWADNFZUWTUXIUSUXFDUWKUTOZJUWNUROZUGZUWAAUWQVAZUWAUWFAUWLUWOHEZHEZUWPGUW
    AUWCUXPGIZUWFUXQGIZUWAUWCDUWLDKEZHEZJMEZUXPUWRUWAUYANFZUWSUYBNFUWAUXKUXTNFZ
    UYCUSUWAUWLUXGUKZDUXTUTOZUHUYAJURUQUWAUWLUWOUXGUXMUGZUWAUWCDUWIULUDZDKEZHEZ
    JMEZUYBGUWADUWIHEZULUDZUWCUYKUWAUYLAULUWAADUWAAUWQPZDQFUWAVBSZDBVCUWAVDSVEZ
    VFUWAUWIQFZUYMUYKVGUWAUWIUXDPZUWIVHUNVIUWAUYJUYAJUWAUXKUYINFZUYJNFUSUWAUYHU
    WAUWIUXDUFZUKZDUYIUTOUYFUWSUWAUHSZUWAUYIUXTGIZUYJUYAGIZUWAUYHUWLGIZVUCUWAUW
    OUYHGIZVUEUWAUWIBJVJEFZVUFVUEVKUWAUXCBUWIGIZUWIJVQIZVUGUXDUWAADUWQUXKUWAUSS
    ZUWABAGIZAUVTGIZABUVTVLZVMZBDGIZUWAVNSZVOZUWAUWIJUXDVUBUWAUWIJGIZAJDHEZGIZU
    WAADVUSGUWAAUVTDUWQCNFZUVTNFUWAVPCUJWHVUJUWAVUKVULVUMVRUVTDGIZUWAVVBCDDHEZG
    IZCWIVVCGDCGICWIGIVSVTWAWBVVAUXKUXKVUOVKVVBVVDTVPUSUXKVUOUSVNWCCDDWDWEWFSWG
    DVBWJWKUWAUXBUWSUXKVUOVURVUTTUWQVUBVUJVUPAJDWLWMWNWOBWPFUWSVUGUXCVUHVUIWSTW
    TUHBJUWIWQWRXAZUWIXBUNZVRZUWAUYHUWLUYTUXGUWABUYHGIZBUYHVQIZUWAVUGVVHVVEUWIX
    CUNZUWABNFZUYHNFZVVHVVIXDXEUYTBUYHXKOXFUWABUWLVVKUWAXESZUXGUWABUYHUWLVVMUYT
    UXGVVJVVGWGZWOXGXHUWAUYSUYDUXKVUOVUCVUDTVUAUYEVUJVUPUYIUXTDXIWMXHXJXLUWAJDU
    WKDKEZHEZREZWIUWKHEZMEZVVQLUWKHEZMEZUYBUXPGUWAVVTVVRVVQUWALNFZUWTVVTNFXMUXF
    LUWKUTOUWAWINFZUWTVVRNFXNUXFWIUWKUTOZUWAUWSVVPNFZVVQNFUHUWAUXKVVONFVWEUSUWA
    UWKUXFUKZDVVOUTOZJVVPXOOUWALWIGIZVVTVVRGIZXPUWAVWBVWCUWTBUWKGIVWHVWITVWBUWA
    XMSZVWCUWAXNSUXFUWAUWJLUXEVWJUWAUWIUXDUWAUWIVUQXQXRBLGIUWAXSSVOLWIUWKXTWMYA
    YBUWAUYBJVVSREZJMEZVVSUWAUYAVWKJMUWAUYADJVVOREZUWNMEZHEDVWMHEZDUWNHEZMEZVWK
    UWAUXTVWNDHUWAJDKEZDJUWKHEZHEZMEZVVOREZUWOVVOREUXTVWNUWAVXAUWOVVORUWAVWRJVW
    TUWNMVWRJVGUWAYCSUWAVWSUWKDHUWAUWKUWAUWKUXFPZYDZYEYFYGUWAJQFZUWKQFZUXTVXBVG
    YHVXCJUWKUUAOUWAJVVOUWNUWAJVUBPZUWAVVOVWFPZUWAUWNUXLPZUUDUUEYEUWADVWMUWNUYO
    UWAVXEVVOQFVWMQFYHVXHJVVOYIOVXIYJUWAVWQJVVQREZVVRMEVWKUWAVWOVXJVWPVVRMUWAVW
    ODJHEZVVPREZVXJUWADJVVOUYOVXGVXHUUFUWAVXLJJREZVVPREVXJVXKVXMVVPRJYHUUGYKUWA
    JJVVPVXGVXGUWAVVPVWGPZUUHYLYNUWAVVRVVCUWKHEVWPVVCWIUWKHWAYKUWADDUWKUYOUYOVX
    CYMUUBYFUWAJVVQVVRVXGUWAVXEVVPQFVVQQFYHVXNJVVPYIOZUWAVVRVWDPZUUCYNYOYGUWAVX
    EVVSQFVWLVVSVGYHUWAVVQVVRVXOVXPUUIJVVSUUJOYNUWAUXPUWLJHEZUWLUWNHEZMEUWLUWNV
    VPMEZMEZVWAUWAUWLJUWNUWAVXEVXFUWLQFYHVXCJUWKUUKOZVXGVXIYJUWAVXQUWLVXRVXSMUW
    AUWLVYAYPUWAVXRJUWNHEZUWKUWNHEZMEVXSUWAJUWKUWNVXGVXCVXIUULUWAVYBUWNVYCVVPMU
    WAUWNVXIYDUWAVYCDUWKUWKHEZHEVVPUWAUWKDUWKVXCUYOVXCUUNUWAVVOVYDDHUWAUWKVXCUU
    OYEYQYFYNYFUWAVXTVVQUWKUWNREZMEVWAUWAJUWKUWNVVPVXGVXCVXIVXNUUMUWAVVTVYEVVQM
    UWAVVTJDREZUWKHEZVYELVYFUWKHLDJREZVYFYRDJVBYHUUPUUQYKUWAVYGVWSUWNREVYEUWAJD
    UWKVXGUYOVXCUURUWAVWSUWKUWNRVXDYGYNYLYEYQYOUUSWGUWAUWCNFZUXPNFUXBVUKUXRUXST
    UWRUYGUWQVUNUWCUXPAXIWMXHUWAAUWLUWOUYNVYAUWAUWOUXMPYMYSUWAUWPUWMUYHHEZUWBUX
    NUWAUWMUYHUXHUYTUGUXOUWAVUFUWPVYJGIZUWAVUFVUEVVFVMUWAUXJVVLUWMNFZBUWMGIVUFV
    YKTUXMUYTUXHUWAAUWLUWQUXGVUNVVNUUTUWOUYHUWMXIWMXHUWAVYJDUWIUCUDZHEZUYHHEZUW
    BGUWAUWMVYNGIZVYJVYOGIZUWAUWMDUWIUWILKEZLUAEZMEZHEZVYNGUWAUYLUWLHEDUWIUWLHE
    ZHEUWMWUAUWADUWIUWLUYOUYRVYAYMUWAUYLAUWLHUYPYGUWAWUBVYTDHUWAWUBUWIJHEZUWIUW
    KHEZMEVYTUWAUWIJUWKUYRVXGVXCYJUWAWUCUWIWUDVYSMUWAUWIUYRYPUWAVYSUWIUWJHEZLUA
    EWUDUWAVYRWUELUAUWAVYRUWJUWIHEZWUEUWAVYRUWIVYHKEZWUFLVYHUWIKYRUVAUWAUYQDYTF
    WUGWUFVGUYRUVBUWIDUVEUQYLUWAUWJUWIUWAUWJUXEPZUYRUVCYNYGUWAUWIUWJLUYRWUHLQFU
    WAUVDSLBVCUWAUVFSUVGUVOYFYNYEUVHUWAVYTVYMGIZWUAVYNGIZUWAWUIVYMUWIGIZUWAVUGW
    UIWUKVKVVEUWIUVIUNVMUWAVYTNFVYMNFZUXKVUOWUIWUJTUWAUWIVYSUXDUWAVYRNFZUXAVYSN
    FUWAUXCLYTFWUMUXDUVJUWILUVKUQUOVYRLUPUQUVLUWAUWIUXDVAZVUJVUPVYTVYMDXIWMXHXL
    UWAVYLVYNNFZVVLVVHVYPVYQTUXHUWAUXKWULWUOUSWUNDVYMUTOUYTVVJUWMVYNUYHXTWMXHUW
    AVYODVYMUYHHEHEZUYLUCUDZUWBUWADVYMUYHUYOUWAVYMWUNPUWAUYHUYTPYMUWAUYQWUQWUPV
    GUYRUWIUVMUNUWAUYLAUCUYPVFUVPYSWGWGUWAUXBUWBNFVYIBUWCGIZUWGUWHTUWQUXOUWRUWA
    BUWBGIWURAUVNVRZAUWBUWCUVQWMXHUWAAQFUWCBVCUWEUWDVGUYNUWAUWCWUSXQAUVRUVSYS
    $.

  $( The tangent function is greater than or equal to its argument in absolute
     value.  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  tanabsge $p |- ( A e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ->
    ( abs ` A ) <_ ( abs ` ( tan ` A ) ) ) $=
    ( co cneg wcel cc0 clt wbr cabs cfv ctan cle cr wa adantr wb sylancr simprd
    0re syl fveq2d cpi c2 cdiv cioo wceq w3o elioore sylancl renegcld ccos csin
    lttri4 lt0neg1d biimpa eliooord simpld halfpire ltnegcon1 mpbid cxr w3a 0xr
    rexri elioo2 mp2an syl3anbrc sincosq1sgn gt0ne0d retancld tangtx ltled ltle
    wi imp absnidd recnd negnegd wne negcld tanneg syl2anc eqtr3d absnegd letrd
    cc a1i mpd absidd 3eqtrd 3brtr4d abs0 eqeltri leidi simpr tan0 syl6eq mpdan
    3jaodan ) AUAUBUCBZCZWSUDBDZAEFGZAEUEZEAFGZUFZAHIZAJIZHIZKGZXAALDZELDZXEAWT
    WSUGZRAEULUHXAXBXIXCXDXAXBMZACZXNJIZXFXHKXMXNXOXMAXAXJXBXLNZUIZXMXNXQXMXNUJ
    IZXMEXNUKIFGZEXRFGZXMXNEWSUDBZDZXSXTMXMXNLDZEXNFGZXNWSFGZYBXQXAXBYDXAAXLUMU
    NZXMWTAFGZYEXAYGXBXAYGAWSFGZAWTWSUOZUPNXMWSLDXJYGYEOUQXPWSAURPUSEUTDZWSUTDZ
    YBYCYDYEVAOVBWSUQVCZEWSXNVDVEVFZXNVGSQVHZVIZXMYBXNXOFGYMXNVJSVKZXMAXPXAXBAE
    KGZXAXJXKXBYQVMXLRAEVLUHVNVOXMXHXOCZHIXOHIXOXMXGYRHXMXNCZJIZXGYRXMYSAJXMAXA
    AWEDXBXAAXLVPNZVQTXMXNWEDXREVRYTYRUEXMAUUAVSYNXNVTWAWBTXMXOXMXOYOVPWCXMXOYO
    XMEXNXOXKXMRWFXQYOXMYDEXNKGZYFXMXKYCYDUUBVMRXQEXNVLPWGYPWDWHWIWJXAXCMZEHIZU
    UDXFXHKUUDUUDKGUUCUUDUUDELWKRWLWMWFUUCAEHXAXCWNZTUUCXGEHUUCXGEJIEUUCAEJUUET
    WOWPTWJXAXDMZAXGXFXHKUUFAXGXAXJXDXLNZUUFAUUGUUFAUJIZUUFEAUKIFGZEUUHFGZUUFAY
    ADZUUIUUJMUUFXJXDYHUUKUUGXAXDWNXAYHXDXAYGYHYIQNYJYKUUKXJXDYHVAOVBYLEWSAVDVE
    VFZAVGSQVHVIZUUFUUKAXGFGUULAVJSVKZUUFAUUGXAXDEAKGZXAXKXJXDUUOVMRXLEAVLPVNZW
    HUUFXGUUMUUFEAXGXKUUFRWFUUGUUMUUPUUNWDWHWJWRWQ $.

  $( The sine of a number strictly between ` 0 ` and ` pi ` is positive.
     (Contributed by Paul Chapman, 15-Mar-2008.) $)
  sinq12gt0 $p |- ( A e. ( 0 (,) pi ) -> 0 < ( sin ` A ) ) $=
    ( cc0 cpi co wcel cr clt wbr csin cfv wb pire c2 cdiv cmul 3ad2ant1 wa wceq
    syl cc cioo w3a cxr 0xr rexri elioo2 mp2an rehalfcl halfpos2 biimpa 3adant3
    ccos 2re 2pos pm3.2i ltdiv1 mp3an23 adantr biimp3a sincosq1lem syl3anc cmin
    resubcl mpan mpan2 bitrd ltsubpos recn wne recni 2cn 2ne0 divsubdir mp3an13
    posdif fveq2d recnd sinhalfpim breqtrd wi resincl recoscl jca axmulgt0 3syl
    eqtrd remulcl sylancr mpani syld mp2and divcan2 sin2t eqtr3d breqtrrd sylbi
    ) ABCUADEZAFEZBAGHZACGHZUBZBAIJZGHBUCECUCEWQXAKUDCLUEBCAUFUGXABMAMNDZIJZXCU
    LJZODZODZXBGXABXDGHZBXEGHZBXGGHZXAXCFEZBXCGHZXCCMNDZGHZXHWRWSXKWTAUHZPWRWSX
    LWTWRWSXLAUIUJUKWRWSWTXNWRWTXNKZWSWRCFEZMFEZBMGHZQZXPLXRXSUMUNUOZACMUPUQURU
    SXCUTVAXABCAVBDZMNDZIJZXEGXAYCFEZBYCGHZYCXMGHZBYDGHWRWSYEWTWRYBFEZYEXQWRYHL
    CAVCVDZYBUHSPWRWSWTYFWRWTYFKWSWRWTBYBGHZYFWRXQWTYJKLACVOVEWRYHYJYFKYIYBUISV
    FURUSWRWSYGWTWRWSYGWRWSYBCGHZYGWRXQWSYKKLACVGVEWRYHYKYGKZYIYHXQXTYLLYAYBCMU
    PUQSVFUJUKYCUTVAWRWSYDXERWTWRYDXMXCVBDZIJZXEWRYCYMIWRATEZYCYMRZAVHZCTEYOMTE
    ZMBVIZQYPCLVJYRYSVKVLUOCAMVMVNSVPWRXCTEZYNXERWRXCXOVQZXCVRSWFPVSWRWSXHXIQZX
    JVTWTWRUUBBXFGHZXJWRXKXDFEZXEFEZQZUUBUUCVTXOXKUUDUUEXCWAXCWBWCZXDXEWDWEWRXS
    UUCXJUNWRXRXFFEZXSUUCQXJVTUMWRXKUUFUUHXOUUGXDXEWGWEMXFWDWHWIWJPWKWRWSXBXGRW
    TWRMXCODZIJZXBXGWRUUIAIWRYOUUIARZYQYOYRYSUUKVKVLAMWLUQSVPWRYTUUJXGRUUAXCWMS
    WNPWOWP $.

  $( The sine of a number between ` 0 ` and ` pi ` is nonnegative.
     (Contributed by Mario Carneiro, 13-May-2014.) $)
  sinq12ge0 $p |- ( A e. ( 0 [,] pi ) -> 0 <_ ( sin ` A ) ) $=
    ( cc0 cpi co wcel clt wbr csin cfv cle wceq wi cr 0re pire cxr rexr sylancr
    wb 0le0 cicc elicc2i simp1bi w3a cioo elioo2 syl2an sinq12gt0 sylbir 3expib
    mp2an syl resincld ltle syld exp3a sin0 breqtrri fveq2 syl5breq a1d simp2bi
    wa a1i wo leloe mpbid mpjaod sinpi syl5breqr simp3bi sylancl ) ABCUADEZACFG
    ZBAHIZJGZACKZVMBAFGZVNVPLZBAKZVMVRVNVPVMVRVNVCZBVOFGZVPVMAMEZWAWBLVMWCBAJGZ
    ACJGZBCANOUBZUCZWCVRVNWBWCVRVNUDZABCUEDEZWBBMEZCMEZWIWHSZNOWJBPECPEWLWKBQCQ
    BCAUFUGUKAUHUIUJULVMWJVOMEWBVPLNVMAWGUMBVOUNRUOUPVTVSLVMVTVPVNVTBBHIZVOJBBW
    MJTUQURBAHUSUTVAVDVMWDVRVTVEZVMWCWDWEWFVBVMWJWCWDWNSNWGBAVFRVGVHVQVPLVMVQBC
    HIZVOJBBWOJTVIURACHUSVJVDVMWEVNVQVEZVMWCWDWEWFVKVMWCWKWEWPSWGOACVFVLVGVH $.

  $( The sine of a number strictly between ` pi ` and ` 2 x. pi ` is negative.
     (Contributed by NM, 17-Aug-2008.) $)
  sinq34lt0t $p |- ( A e. ( pi (,) ( 2 x. pi ) ) -> ( sin ` A ) < 0 ) $=
    ( cpi c2 cmul co cioo wcel csin cfv cc0 clt cneg cmin cr elioore caddc pire
    wbr wb syl wa 0re iooshf mpanr12 mpan2 recni addid2i eqcomi 2timesi oveq12i
    eleq2i syl6rbbr ibi sinq12gt0 cc wceq recnd sinmpi resincld lt0neg1d mpbird
    breqtrd ) ABCBDEZFEZGZAHIZJKRJVFLZKRVEJABMEZHIZVGKVEVHJBFEGZJVIKRVEVJVEANGZ
    VEVJSABVCOZVKVJAJBPEZBBPEZFEZGZVEVKBNGZVJVPSZQVKVQUAJNGVQVRUBQABJBUCUDUEVDV
    OABVMVCVNFVMBBBQUFZUGUHBVSUIUJUKULTUMVHUNTVEAUOGVIVGUPVEAVLUQAURTVBVEVFVEAV
    LUSUTVA $.

  $( The cosine of a number strictly between ` -u pi / 2 ` and ` pi / 2 ` is
     positive.  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  cosq14gt0 $p |- ( A e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ->
                    0 < ( cos ` A ) ) $=
    ( cpi co cioo wcel cc0 cmin cfv clt wbr cr halfpire cxr w3a wb rexri elioo2
    cc pire syl c2 cdiv cneg csin ccos elioore resubcl sylancr renegcli simp3bi
    mp2an posdif sylancl mpbid recni halfcl ax-mp negcli negsubi wceq subaddrii
    caddc 2halves eqtri simp2bi syl5eqbr ltsub23 mpbird 0xr syl3anbrc sinq12gt0
    mp3an13 recnd sinhalfpim breqtrd ) ABUAUBCZUCZVPDCEZFVPAGCZUDHZAUEHZIVRVSFB
    DCEZFVTIJVRVSKEZFVSIJZVSBIJZWBVRVPKEZAKEZWCLAVQVPUFZVPAUGUHVRAVPIJZWDVRWGVQ
    AIJZWIVQMEVPMEVRWGWJWINOVQVPLUIPVPLPVQVPAQUKZUJVRWGWFWIWDOWHLAVPULUMUNVRWEV
    PBGCZAIJZVRWLVQAIVPBVQBREZVPREBSUOZBUPUQZWOVPWPURBVQVBCBVPGCVPBVPWOWPUSBVPV
    PWOWPWPWNVPVPVBCBUTWOBVCUQVAVDVAVRWGWJWIWKVEVFVRWGWEWMOZWHWFWGBKEWQLSVPABVG
    VLTVHFMEBMEWBWCWDWENOVIBSPFBVSQUKVJVSVKTVRAREVTWAUTVRAWHVMAVNTVO $.

  $( The cosine of a number between ` -u pi / 2 ` and ` pi / 2 ` is
     nonnegative.  (Contributed by Mario Carneiro, 13-May-2014.) $)
  cosq14ge0 $p |- ( A e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ->
                    0 <_ ( cos ` A ) ) $=
    ( cpi co cicc wcel cc0 cfv cle wbr cr halfpire elicc2i sylancr wb mpbird cc
    cmin pire ax-mp syl c2 cdiv cneg csin ccos renegcli simp1bi resubcl simp3bi
    subge0 recni halfcl negcli caddc negsubi 2halves subaddrii simp2bi syl5eqbr
    wceq eqtri suble mp3an13 0re syl3anbrc sinq12ge0 recnd sinhalfpim breqtrd )
    ABUAUBCZUCZVJDCEZFVJAQCZUDGZAUEGZHVLVMFBDCEZFVNHIVLVMJEZFVMHIZVMBHIZVPVLVJJ
    EZAJEZVQKVLWAVKAHIZAVJHIZVKVJAVJKUFKLZUGZVJAUHMVLVRWCVLWAWBWCWDUIVLVTWAVRWC
    NKWEVJAUJMOVLVSVJBQCZAHIZVLWFVKAHVJBVKBPEZVJPEBRUKZBULSZWIVJWJUMBVKUNCBVJQC
    VJBVJWIWJUOBVJVJWIWJWJWHVJVJUNCBUTWIBUPSUQVAUQVLWAWBWCWDURUSVLWAVSWGNZWEVTW
    ABJEWKKRVJABVBVCTOFBVMVDRLVEVMVFTVLAPEVNVOUTVLAWEVGAVHTVI $.

  $( Complementarity of the sine and cosine functions in the first quadrant.
     (Contributed by Paul Chapman, 25-Jan-2008.) $)
  sincosq1eq $p |- ( ( A e. CC /\ B e. CC /\ ( A + B ) = 1 ) ->
           ( sin ` ( A x. ( pi / 2 ) ) ) = ( cos ` ( B x. ( pi / 2 ) ) ) ) $=
    ( cc wcel caddc co c1 wceq w3a cpi c2 cdiv cmul cmin ccos cfv mulcl 3adant3
    mpan2 eqtr3d csin pire recni 2cn 2ne0 divcli coshalfpim syl 3ad2ant1 adddir
    mp3an3 oveq1 mulid2i syl6eq 3ad2ant3 wb subadd mp3an1 syl2an mpbird fveq2d
    ) ACDZBCDZABEFZGHZIZJKLFZAVGMFZNFZOPZVHUAPZBVGMFZOPVBVCVJVKHZVEVBVHCDZVMVBV
    GCDZVNJKJUBUCUDUEUFZAVGQSZVHUGUHUIVFVIVLOVFVIVLHZVHVLEFZVGHZVFVDVGMFZVSVGVB
    VCWAVSHZVEVBVCVOWBVPABVGUJUKRVEVBWAVGHVCVEWAGVGMFVGVDGVGMULVGVPUMUNUOTVBVCV
    RVTUPZVEVBVNVLCDZWCVCVQVCVOWDVPBVGQSVOVNWDWCVPVGVHVLUQURUSRUTVAT $.

  $( The sine and cosine of ` pi / 4 ` .  (Contributed by Paul Chapman,
     25-Jan-2008.) $)
  sincos4thpi $p |- ( ( sin ` ( pi / 4 ) ) = ( 1 / ( sqr ` 2 ) ) /\
                      ( cos ` ( pi / 4 ) ) = ( 1 / ( sqr ` 2 ) ) ) $=
    ( cpi c4 cdiv co csin cfv c1 c2 csqr wceq cmul cc wcel 2ne0 recni ax-mp 4re
    cc0 wbr clt ccos caddc rereccli ax-1cn 2halves sincosq1eq mp3an oveq2i pire
    2re 2cn divmuldivi mulid2i 2t2e4 oveq12i eqtri fveq2i recidi oveq1i mulassi
    redivcli 3eqtr3i mulcli sin2t sinhalfpi 4pos gt0ne0ii resincl remulcli 2pos
    cr 0re ltleii msqge0i sqrmulii sqr1 3eqtr3ri wne wa cle sqrcli sqr2re sqr00
    wb mp2an necon3bii mpbir pm3.2i divmul2 cioc pipos divgt0ii pigt2lt4 simpri
    1re ltdiv1ii mpbi dividi breqtri cxr w3a 0xr elioc2 mpbir3an sqrmsqi eqtr2i
    sin01gt0 ) ABCDZEFZGHIFZCDZJXHUAFZXKJXKXIXIKDZIFZXIXKXNJZGXJXNKDZJZHXMKDZIF
    GIFXPGXRGIHGHCDZAHCDZKDZEFZYBKDZKDHYBYAUAFZKDZKDZXRGYCYEHKYBYDYBKXSLMZYGXSX
    SUBDGJZYBYDJXSHUJNUCOZYIGLMZYHUDGUEPXSXSUFUGZUHUHYCXMHKYBXIYBXIKYAXHEYAGAKD
    ZHHKDZCDXHGHAHUDUKAUIOZUKNNULYLAYMBCAYNUMUNUOUPZUQZYPUOUHHYAKDZEFZXTEFYFGYQ
    XTEHXSKDZXTKDGXTKDYQXTYSGXTKHUKNURUSHXSXTUKYIXTAHUIUJNVAOZUTXTYTUMVBUQYALMY
    RYFJXSXTYIYTVCYAVDPVEVBVBUQHXMUJXIXIXHVKMZXIVKMABUIQBQVFVGZVAZXHVHPZUUDVIZR
    HVLUJVJVMZXIUUDVNZVOVPVQYJXNLMXJLMZXJRVRZVSXOXQWDUDXNRXMVTSXNVKMUUGXMUUEWAP
    OUUHUUIXJWBOUUIHRVRNXJRHRHVKMRHVTSXJRJHRJWDUJUUFHWCWEWFWGWHGXNXJWIUGWGZRXIV
    TSXNXIJRXIVLUUDXHRGWJDMZRXITSUUKUUARXHTSZXHGVTSZUUCABUIQWKVFWLXHGUUCWOXHBBC
    DZGTABTSZXHUUNTSHATSUUOWMWNABBUIQQVFWPWQBBQOUUBWRWSVMRWTMGVKMUUKUUAUULUUMXA
    WDXBWORGXHXCWEXDXHXGPVMXIUUDXEPZXFXKXIXLXKXNXIUUJUUPUPYBYDXIXLYKYPYAXHUAYOU
    QVBXFWH $.

  $( The tangent of ` pi / 4 ` .  (Contributed by Mario Carneiro,
     5-Apr-2015.) $)
  tan4thpi $p |- ( tan ` ( pi / 4 ) ) = 1 $=
    ( cpi c4 cdiv co ctan cfv csin c1 c2 cc wcel cc0 wne wceq mp2an sincos4thpi
    cr recni 2re eqnetri ccos csqr pire 4nn nndivre simpri sqr2re cexp cle 2pos
    cn wbr ltleii resqrth 2ne0 wb sqne0 ax-mp mpbi recne0 tanval simpli oveq12i
    0re reccli dividi 3eqtri ) ABCDZEFZVHGFZVHUAFZCDZHIUBFZCDZVNCDHVHJKVKLMVIVL
    NVHAQKBUKKVHQKUCUDABUEORVKVNLVJVNNZVKVNNZPUFZVMJKZVMLMZVNLMVMUGRZVMIUHDZLMZ
    VSWAILIQKLIUIULWAINSLIVDSUJUMIUNOUOTVRWBVSUPVTVMUQURUSZVMUTOZTVHVAOVJVNVKVN
    CVOVPPVBVQVCVNVMVTWCVEWDVFVG $.

  $( The sine and cosine of ` pi / 6 ` .  (Contributed by Paul Chapman,
     25-Jan-2008.) $)
  sincos6thpi $p |- ( ( sin ` ( pi / 6 ) ) = ( 1 / 2 ) /\
                      ( cos ` ( pi / 6 ) ) = ( ( sqr ` 3 ) / 2 ) ) $=
    ( cpi c6 cdiv co cfv c1 c2 wceq c3 cmul 2cn cc wcel ax-mp cr 3cn cc0 clt c4
    wbr csin ccos csqr pire 6re 6pos gt0ne0ii recni sincl recoscl mulassi sin2t
    redivcli eqtr4i caddc 3ne0 divcli reccli df-3 oveq1i dividi ax-1cn 3eqtr3ri
    divdiri sincosq1eq mp3an 2ne0 divmuldivi 3t2e6 oveq2i divassi 3eqtri fveq2i
    eqtr3i mulid2i oveq12i eqtri wne wa wb mulcli cioo pipos divgt0ii 2lt6 2pos
    w3a 2re 3pm3.2i ltdiv2OLD mpan mpbi 0re cxr elioo2 syl2an mp2an sincosq1sgn
    rexr mpbir3an simpri pm3.2i mulcan2 divmuli mpbir eqcomi cexp 3pos sqrpclii
    3re sqdivi cle ltleii sqsqri sq2 sqrge0i divge0i sqrsqi cmin 4pos divsubdir
    4cn 4re 3p1e4 subadd2i sqcli sqrecii sincossq subaddrii ) ABCDZUAEZFGCDZHYJ
    UBEZIUCEZGCDZHYLYKYLYKHGYKJDZFHZYPYMJDZFYMJDZHZYQYRYMYSYRGYJJDZUAEZYMYRGYKY
    MJDJDZUUBGYKYMKYJLMZYKLMYJABUDUEBUEUFUGZUMZUHZYJUINZYMYJOMZYMOMUUFYJUJNZUHZ
    UKUUDUUBUUCHUUGYJULNUNFICDZAGCDZJDZUBEZUUBYMGICDZUUMJDZUAEZUUOUUBUUPLMUULLM
    UUPUULUODZFHUURUUOHGIKPUPUQIPUPURIICDGFUODZICDFUUSIUUTICUSUTIPUPVAGFIKVBPUP
    VDVCUUPUULVEVFUUQUUAUAUUQGAJDZIGJDZCDUVABCDUUAGIAGKPAUDUHZKUPVGVHUVBBUVACVI
    VJGABKUVCBUEUHUUEVKVLVMVNUUNYJUBUUNFAJDZUVBCDYJFIAGVBPUVCKUPVGVHUVDAUVBBCAU
    VCVOVIVPVQVMVNVQYMUUKVOUNYPLMFLMZYMLMZYMQVRZVSYTYQVTGYKKUUHWAVBUVFUVGUUKYMU
    UJQYKRTZQYMRTZYJQUUMWBDMZUVHUVIVSUVJUUIQYJRTZYJUUMRTZUUFABUDUEWCUFWDGBRTZUV
    LWEQGRTZQBRTZQARTZUVMUVLVTZWFUFWCGOMZBOMZAOMZWGUVNUVOUVPWGUVQUVRUVSUVTWHUEU
    DWIGBAWJWKVFWLQOMZUUMOMZUVJUUIUVKUVLWGVTZWMAGUDWHVGUMUWAQWNMUUMWNMUWCUWBQWS
    UUMWSQUUMYJWOWPWQWTYJWRNXAZUGXBYPFYMXCVFWLFGYKVBKUUHVGXDXEXFZYOGXGDZUCEZISC
    DZUCEZYOYMUWFUWHUCUWFYNGXGDZGGXGDZCDUWHYNGYNIXJXHXIZUHKVGXKUWJIUWKSCQIXLTZU
    WJIHQIWMXJXHXMZIXJXNNXOVPVQVMQYOXLTZUWGYOHQYNXLTZUVNUWOUWMUWPUWNIXJXPNWFYNG
    UWLWHXQWQYOYNGUWLWHVGUMXRNYMGXGDZUCEZUWIYMUWQUWHUCSSCDZFSCDZXSDZFUWTXSDUWHU
    WQUWSFUWTXSSYBSYCXTUGZVAUTSFXSDZSCDZUXAUWHSLMZUVEUXESQVRZVSUXDUXAHYBVBUXEUX
    FYBUXBXBSFSYAVFUXCISCUXCIHIFUODSHYDSFIYBVBPYEXEUTVNFUWTUWQVBSYBUXBURYMUUKYF
    YKGXGDZUWQUODZUWTUWQUODFUXGUWTUWQUOUXGYLGXGDFUWKCDUWTYKYLGXGUWEUTGKVGYGUWKS
    FCXOVJVLUTUUDUXHFHUUGYJYHNVNYIVCVMQYMXLTUWRYMHQYMWMUUJUWDXMYMUUJXRNVNVCXB
    $.

  $( The sine and cosine of ` pi / 3 ` .  (Contributed by Mario Carneiro,
     21-May-2016.) $)
  sincos3rdpi $p |- ( ( sin ` ( pi / 3 ) ) = ( ( sqr ` 3 ) / 2 ) /\
                      ( cos ` ( pi / 3 ) ) = ( 1 / 2 ) ) $=
    ( cpi c3 cdiv co csin cfv c2 wceq ccos c1 cmin c6 cmul 2cn reccli 3ne0 wcel
    3cn cc divreci csqr pire recni 2ne0 subdii caddc halfpm6th simpli 6nn nncni
    oveq2i nnne0i nncan mp2an eqtr3i fveq2i divcli coshalfpim ax-mp sincos6thpi
    oveq12i 3eqtr4i simpri 3eqtr3i sinhalfpim pm3.2i ) ABCDZEFZBUAFGCDZHVGIFZJG
    CDZHAGCDZVGKDZIFZALCDZIFZVHVIVMVOIAVKMDZAJBCDZMDZKDZAJLCDZMDZVMVOAVKVRKDZMD
    VTWBAVKVRAUBUCZGNUDOZBRPOUEWCWAAMVKVKWAKDZKDZWCWAWFVRVKKWFVRHVKWAUFDGBCDHUG
    UHUKVKSQWASQWGWAHWELLUIUJZLUIULZOVKWAUMUNUOUKUOVLVQVGVSKAGWDNUDTABWDRPTVAAL
    WDWHWITVBZUPVGSQZVNVHHABWDRPUQZVGURUSVOEFZVKHZVPVIHZUTVCVDVMEFZWMVJVKVMVOEW
    JUPWKWPVJHWLVGVEUSWNWOUTUHVDVF $.

  ${
    $d x y $.
    $( ` pi ` is greater or equal to 3.  This proof is based on the geometric
       observation that a hexagon of unit side length has perimeter 6, which is
       less than the unit-radius circumcircle, of perimeter ` 2 pi ` .  We
       translate this to algebra by looking at the function ` _e ^ ( _i x ) `
       as ` x ` goes from ` 0 ` to ` pi / 3 ` ; it moves at unit speed and
       travels distance ` 1 ` , hence ` 1 <_ pi / 3 ` .  (Contributed by Mario
       Carneiro, 21-May-2016.) $)
    pige3 $p |- 3 <_ pi $=
      ( vx c1 c3 cmul co cpi cle ci ce cfv cabs cc0 wtru wcel ax-mp cr a1i wceq
      cc ax-icn vy 3cn mulid2i wbr cdiv cneg cicc cv cmpt cmin tru cxr 0xr pire
      wa crp pipos elrpii 3re 3pos rpdivcl mp2an rpxr rpge0 lbicc2 mp3an ubicc2
      pm3.2i 0re 3ne0 redivcli ccncf efcn cres wss iccssre ax-resscn sstri mp1i
      resmpt cdv cdm ssid simpr mulcl sylancr eqid fmptd cpr cnex prid2 dvmptid
      ax-1cn dvmptcmul mulid1i mpteq2i syl6eq dmeqd elexi dvcn syl31anc rescncf
      dmmpti mpsyl eqeltrrd cncfmpt1f cioo crn ctg ccnfld ctopn reex prid1 recn
      efcl syl sylan2 sylancl ctopon cnfldtopon toponmax cin df-ss sylib adantl
      wf dvef eff feqmptd oveq2d 1re fveq2d fvmpt3i absefi mulcli eqtr3i fveq2i
      oveq2 c2 3brtr3i 3eqtr3a fveq2 dvmptres3 tgioo2 cnt iccntr dvmptres2 ovex
      dvmptco fveq1d oveq1d sylan9eq ioossre sselda recnd absmul oveq12d 3eqtrd
      absi 1le1 syl6eqbr dvlip mul01i ef0 fvex oveq12i recni negcli ccos cosval
      csin csqr sincos3rdpi simpri addcli 2cn 2ne0 div11i mpbi subaddrii 3eqtri
      caddc mulneg12 absnegi df-neg rprege0 absid mp2b oveq2i renegcli lemuldiv
      clt wb mpbir eqbrtrri ) BCDEZCFGCUBUCUWPFGUDZBFCUEEZGUDZHUWRUFZDEZIJZKJZB
      UWRDEZBUWRGLALUWRUGEZHAUHZDEZIJZUIZJZUWRUXIJZUJEZKJZBLUWRUJEZKJZDEZUXCUXD
      GMLUXENZUWRUXENZUOUXMUXPGUDUKUXQUXRLULNZUWRULNZLUWRGUDZUXQUMUWRUPNZUXTFUP
      NCUPNUYBFUNUQURCUSUTURFCVAVBZUWRVCOZUYBUYAUYCUWRVDOZLUWRVEVFZUXSUXTUYAUXR
      UMUYDUYELUWRVGVFZVHMUALUWRUXIBLUWRLPNZMVIQUWRPNZMFCUNUSVJVKZQZMAUXGIUXEIS
      SVLEZNMVMQMASUXGUIZUXEVNZAUXEUXGUIZUXESVLEZUXESVOZUYNUYORMUXEPSUYHUYIUXEP
      VOZVIUYJLUWRVPVBZVQVRZASUXEUXGVTVSUYQMUYMUYLNZUYNUYPNUYTMSSVOZSSUYMYFVUBS
      UYMWAEZWBZSRVUAVUBMSWCQZMASUXGSUYMMUXFSNZUOZHSNZVUFUXGSNZTMVUFWDZHUXFWEWF
      ZUYMWGWHVUEMVUDASHUIZWBSMVUCVULMVUCASHBDEZUIVULMAUXFBHSSSSPSWIZNMPSWJWKQZ
      VUJBSNVUGWMQMASVUOWLVUHMTQWNASVUMHHTWOWPWQZWRASHVULHSTWSVULWGXCWQSSUYMWTX
      ASSUXEUYMXBXDXEXFMPUXIWAEZWBALUWRXGEZUXHHDEZUIZWBVURMVUQVUTMAUXHVUSPXGXHX
      IJZXJXKJZSPVURUXEPVUNNMPSXLXMQZUXFPNZMVUFUXHSNZUXFXNZVUGVUIVVEVUKUXGXOXPZ
      XQVVDMVUFVUSSNZVVFVUGVVEVUHVVHVVGTUXHHWEXRZXQMAUXHVUSPVVBSSPVVBWGZVVCVVBS
      XSJNSVVBNMVVBVVJXTSVVBYAVSMPSVOZPSYBPRVVKMVQQPSYCYDVVGVVIMAUAUXGHUAUHZIJZ
      VVMSSUXHUXHSSSSVUOVUOVUKVUHVUGTQVVLSNZVVMSNMVVLXOYEZVVOVUPMSIWAEISUASVVMU
      IZWAEVVPYGMIVVPSWAMUASSISSIYFMYHQYIZYJVVQUUAVVLUXGIUUBZVVRUUIUUCUYRMUYSQV
      VBVVJUUDVVJMUYHUYIUXEVVAUUEJJVURRVIUYKLUWRUUFWFUUGZWRAVURVUSVUTUXHHDUUHZV
      UTWGZXCWQBPNZMYKQMVVLVURNZUOZVVLVUQJZKJZBBGVWDVWFHVVLDEZIJZHDEZKJZVWHKJZH
      KJZDEZBVWDVWEVWIKMVWCVWEVVLVUTJVWIMVVLVUQVUTVVSUUJAVVLVUSVWIVURVUTUXFVVLR
      ZUXHVWHHDVWNUXGVWGIUXFVVLHDYRYLUUKVWAVVTYMUULYLVWDVWHSNZVUHVWJVWMRVWDVWGS
      NZVWOVWDVUHVVNVWPTVWDVVLMVURPVVLVURPVOMLUWRUUMQUUNZUUOHVVLWEWFVWGXOXPTVWH
      HUUPXRVWDVWMBBDEBVWDVWKBVWLBDVWDVVLPNVWKBRVWQVVLYNXPVWLBRVWDUUSQUUQBWMWOW
      QUURUUTUVAUVBVBUXLUXBKUXLBHUWRDEZIJZUJEHUFZUWRDEZIJZUXBUXJBUXKVWSUJUXQUXJ
      BRUYFALUXHBUXEUXIUXFLRZUXHLIJBVXCUXGLIVXCUXGHLDELUXFLHDYRHTUVCWQYLUVDWQUX
      IWGZUXGIUVEZYMOUXRUXKVWSRUYGAUWRUXHVWSUXEUXIUXFUWRRUXGVWRIUXFUWRHDYRYLVXD
      VXEYMOUVFBVWSVXBWMVWRSNVWSSNHUWRTUWRUYJUVGZYOVWRXOOZVXASNVXBSNVWTUWRHTUVH
      VXFYOVXAXOOZVWSVXBUWBEZYSUEEZBYSUEEZRVXIBRUWRUVIJZVXJVXKUWRSNZVXLVXJRVXFU
      WRUVJOUWRUVKJCUVLJYSUEERVXLVXKRUVMUVNYPVXIBYSVWSVXBVXGVXHUVOWMUVPUVQUVRUV
      SUVTVXAUXAIVUHVXMVXAUXARTVXFHUWRUWCVBYQUWAYQUXOUWRBDUWRKJZUXOUWRUWTKJVXNU
      XOUWRVXFUWDUWTUXNKUWRUWEYQYPUYBUYIUYAUOVXNUWRRUYCUWRUWFUWRUWGUWHYPUWIYTUW
      TPNUXCBRUWRUYJUWJUWTYNOUWRVXFUCYTVWBFPNCPNZLCUWLUDZUOUWQUWSUWMYKUNVXOVXPU
      SUTVHBFCUWKVFUWNUWO $.
  $}

  $( The absolute value of sine has period ` pi ` .  (Contributed by NM,
     17-Aug-2008.) $)
  abssinper $p |- ( ( A e. CC /\ K e. ZZ )
      -> ( abs ` ( sin ` ( A + ( K x. pi ) ) ) ) = ( abs ` ( sin ` A ) ) ) $=
    ( cc wcel wa c2 co cpi cmul caddc csin cfv cabs wceq 2cn mp3an23 syl fveq2d
    c1 eqtrd cz cdiv zcn halfcl pire recni mulass cc0 wne divcan1 oveq1d eqtr3d
    2ne0 adantl oveq2d eqcomd adantr sinper adantlr cneg peano2cn mulcl sylancl
    cmin mulcli mp3an2 sylan2 ax-1cn adddir mulid2i oveq2i syl6req eqtr2d mpan2
    subadd23 pncan subcl sylan sinmpi ad2antrr sincl absnegd wo zeo mpjaodan )
    ACDZBUADZEZBFUBGZUADZABHIGZJGZKLZMLZAKLZMLZNBSJGZFUBGZUADZWHWJEZWMWOMWTWMAW
    IFHIGZIGZJGZKLZWOWHWMXDNWJWHXDWMWHXCWLKWHXBWKAJWGXBWKNZWFWGBCDZXEBUCZXFWIFI
    GZHIGZXBWKXFWICDZXIXBNZBUDXJFCDZHCDZXKOHUEUFZWIFHUGPQXFXHBHIXFXLFUHUIZXHBNO
    UMBFUJPUKULQUNUORUPUQWFWJXDWONWGAWIURUSTRWHWSEZWNWOUTZMLZWPXPWMXQMXPWMAHVDG
    ZWRXAIGZJGZKLZXQWHWMYBNWSWHWLYAKWGWFXFWLYANXGWFXFEZYAAXTHVDGZJGZWLXFWFXTCDZ
    YAYENZXFWRCDZXACDYFXFWQCDZYHBVAZWQUDQZFHOXNVEWRXAVBVCWFXMYFYGXNAHXTVOVFVGYC
    YDWKAJXFYDWKNWFXFYDWKHJGZHVDGZWKXFXTYLHVDXFYLWRFIGZHIGZXTXFYOWKSHIGZJGZYLXF
    YOWQHIGZYQXFYNWQHIXFYIYNWQNZYJYIXLXOYSOUMWQFUJPQUKXFSCDXMYRYQNVHXNBSHVIPTYP
    HWKJHXNVJVKVLXFYHYOXTNZYKYHXLXMYTOXNWRFHUGPQVMUKXFWKCDZXMYMWKNXFXMUUAXNBHVB
    VNXNWKHVPVCTUNUOVMVGRUQXPYBXSKLZXQWFWSYBUUBNZWGWFXSCDZWSUUCWFXMUUDXNAHVQVNX
    SWRURVRUSWFUUBXQNWGWSAVSVTTTRWFXRWPNWGWSWFWOAWAWBVTTWGWJWSWCWFBWDUNWE $.

  $( The sine of an integer multiple of ` pi ` is 0.  (Contributed by NM,
     11-Aug-2008.) $)
  sinkpi $p |- ( K e. ZZ -> ( sin ` ( K x. pi ) ) = 0 ) $=
    ( cz wcel cc0 cpi cmul co caddc csin cfv cc zcn recni mulcl sylancl addid2d
    pire fveq2d 0cn cabs addcl sylancr sincld wceq abssinper mpan fveq2i syl6eq
    sin0 abs0 eqtri abs00d eqtr3d ) ABCZDAEFGZHGZIJZUOIJDUNUPUOIUNUOUNAKCEKCUOK
    CZALEQMAENOZPRUNUQUNUPUNDKCZURUPKCSUSDUOUAUBUCUNUQTJZDIJZTJZDUTUNVAVCUDSDAU
    EUFVCDTJDVBDTUIUGUJUKUHULUM $.

  $( The absolute value of the cosine of an integer multiple of ` pi ` is 1.
     (Contributed by NM, 19-Aug-2008.) $)
  coskpi $p |- ( K e. ZZ -> ( abs ` ( cos ` ( K x. pi ) ) ) = 1 ) $=
    ( wcel cpi cmul co ccos cfv cabs c1 c2 cexp 2cn cc mp3an23 syl cr wb ax-1cn
    wceq mpbid cz caddc mulid1i df-2 eqtr2i cmin zcn recni mul12 fveq2d cos2kpi
    pire zre remulcl sylancl recnd cos2t 3eqtr3rd recoscld sqcld sylancr subadd
    mulcl syl5reqr cc0 wne 2ne0 pm3.2i mulcan sq1 syl6eqr 1re sqabs abs1 syl6eq
    wa ) AUABZACDEZFGZHGZIHGZIVQVSJKEZIJKEZSZVTWASZVQWBIWCVQJWBDEZJIDEZSZWBISZV
    QWGIIUBEZWFWGJWJJLUCUDUEVQWFIUFEZISZWJWFSZVQAJCDEDEZFGJVRDEZFGZIWKVQWNWOFVQ
    AMBZWNWOSZAUGWQJMBZCMBWRLCULUHAJCUINOUJAUKVQVRMBWPWKSVQVRVQAPBCPBVRPBAUMULA
    CUNUOZUPVRUQOURVQWFMBZWLWMQZVQWSWBMBZXALVQVSVQVSVQVRWTUSZUPUTZJWBVCVAXAIMBZ
    XFXBRRWFIIVBNOTVDVQXCWHWIQZXEXCXFWSJVEVFZVPXGRWSXHLVGVHWBIJVINOTVJVKVQVSPBI
    PBWDWEQXDVLVSIVMUOTVNVO $.

  $( A complex number whose sine is zero is an integer multiple of ` pi ` .
     (Contributed by NM, 17-Aug-2008.)  (Revised by Mario Carneiro,
     10-May-2014.) $)
  sineq0 $p |- ( A e. CC -> ( ( sin ` A ) = 0 <-> ( A / pi ) e. ZZ ) ) $=
    ( cc wcel csin cfv cc0 wceq cpi co cabs cmul caddc cr ci c2 ce c1 wb ax-icn
    wbr cdiv cz wa cmo clt wn cfl cneg cmin crp sinval eqeq1d mulcl mpan negcli
    efcl syl subcld wne mulcli 2ne0 ine0 mulne0i diveq0 mp3an23 subeq0ad 3bitrd
    oveq2 mul12 mp3an12 2timesd eqtrd fveq2d efadd syl2anc eqtr2d negidi oveq1i
    2cn adddir mul02 3eqtr3a ef0 syl6eq eqtr3d eqeq12d fveq2 syl6bi syl5 sylbid
    abs1 eqeq2i 2re mulre absefib bitr2d syl5bb sylibd pire pipos elrpii modval
    imp sylancl recni gt0ne0ii redivcl zcnd sylancr negsub syldan mulcom negeqd
    flcld mulneg1 eqtr4d oveq2d 3eqtr2d znegcld abssinper simpr abs0 cioo modcl
    3eqtrd modlt jca biantrurd w3a 0re cxr rexr elioo2 syl2an mp2an resincld wi
    cle mpd mpbid 3anan32 bitri syl6bbr sinq12gt0 elioore absidd breqtrrd recnd
    ltle abscld ltneOLD 3expia syld necon2bd wo modge0 leloe ord eqcomd divcan1
    mod0 sinkpi sylan9req impbida ) ABCZADEZFGZAHUAIZUBCZUVEUVGUCZAHUDIZFGZUVIU
    VJFUVKUVJFUVKUETZUFZFUVKGZUVJUVKDEZJEZFGUVNUVJUVQFJEZFUVJUVQAUVHUGEZUHZHKIZ
    LIZDEZJEZUVFJEZUVRUVJUVPUWCJUVJUVKUWBDUVJUVKAHUVSKIZUIIZAUWFUHZLIZUWBUVJAMC
    ZHUJCZUVKUWGGUVEUVGUWJUVEUVGNOAKIZKIZPEZJEZQJEZGZUWJUVEUVGNAKIZPEZNUHZAKIZP
    EZGZUWQUVEUVGUWSUXBUIIZONKIZUAIZFGZUXDFGZUXCUVEUVFUXFFAUKULUVEUXDBCZUXGUXHR
    ZUVEUWSUXBUVEUWRBCZUWSBCNBCZUVEUXKSNAUMUNZUWRUPUQZUVEUXABCZUXBBCUWTBCZUVEUX
    ONSUOZUWTAUMUNZUXAUPUQZURUXIUXEBCUXEFUSUXJONVSSUTONVSSVAVBVCUXDUXEVDVEUQUVE
    UWSUXBUXNUXSVFVGUXCUWSUWSKIZUWSUXBKIZGZUVEUWQUWSUXBUWSKVHUVEUYBUWNQGUWQUVEU
    XTUWNUYAQUVEUWNUWRUWRLIZPEZUXTUVEUWMUYCPUVEUWMOUWRKIZUYCUXLOBCZUVEUWMUYEGSV
    SNOAVIVJUVEUWRUXMVKVLVMUVEUXKUXKUYDUXTGUXMUXMUWRUWRVNVOVPUVEUWRUXALIZPEZUYA
    QUVEUXKUXOUYHUYAGUXMUXRUWRUXAVNVOUVEUYHFPEQUVEUYGFPUVENUWTLIZAKIZFAKIUYGFUY
    IFAKNSVQVRUXLUXPUVEUYJUYGGSUXQNUWTAVTVJAWAWBVMWCWDWEWFUWNQJWGWHWIWJUWQUWOQG
    ZUVEUWJUWPQUWOWKWLUVEUWJUWLMCZUYKUVEOMCOFUSUWJUYLRWMVAAOWNVEUVEUWLBCZUYLUYK
    RUYFUVEUYMVSOAUMUNUWLWOUQWPWQWRXCZHWSWTXAZAHXBXDUVEUVGUWFBCZUWIUWGGUVJHBCZU
    VSBCZUYPHWSXEZUVJUVSUVJUVHUVJUWJUVHMCZUYNUWJHMCZHFUSZUYTWSHWSWTXFZAHXGVEUQX
    NZXHZHUVSUMXIAUWFXJXKUVJUWHUWAALUVJUWHUVSHKIZUHZUWAUVJUWFVUFUVJUYQUYRUWFVUF
    GUYSVUEHUVSXLXIXMUVJUYRUYQUWAVUGGVUEUYSUVSHXOXDXPXQXRVMVMUVEUVGUVTUBCUWDUWE
    GUVJUVSVUDXSAUVTXTXKUVJUVFFJUVEUVGYAVMYEYBWDUVJUVMUVQFUVJUVMFUVQUETZUVQFUSZ
    UVJUVMUVKFHYCICZVUHUVJUVMUVKMCZUVKHUETZUCZUVMUCZVUJUVJVUMUVMUVJVUKVULUVJUWJ
    UWKVUKUYNUYOAHYDXDZUVJUWJUWKVULUYNUYOAHYFXDYGYHVUJVUKUVMVULYIZVUNFMCZVUAVUJ
    VUPRZYJWSVUQFYKCHYKCVURVUAFYLHYLFHUVKYMYNYOVUKUVMVULUUAUUBUUCVUJFUVPUVQUEUV
    KUUDZVUJUVPVUJUVKUVKFHUUEYPZVUJFUVPUETZFUVPYRTZVUSVUJVUQUVPMCVVAVVBYQYJVUTF
    UVPUUIXIYSUUFUUGWHUVJVUQUVQMCZVUHVUIYQYJUVJUVPUVJUVPUVJUVKVUOYPUUHUUJVUQVVC
    VUHVUIFUVQUUKUULXIUUMUUNYSUVJUVMUVOUVJFUVKYRTZUVMUVOUUOZUVJUWJUWKVVDUYNUYOA
    HUUPXDUVJVUQVUKVVDVVERYJVUOFUVKUUQXIYTUURYSUUSUVJUWJUWKUVLUVIRUYNUYOAHUVAXD
    YTUVEUVIUVFUVHHKIZDEFUVEVVFADUVEUYQVUBVVFAGUYSVUCAHUUTVEVMUVHUVBUVCUVD $.

  $( A complex number whose cosine is one is an integer multiple of ` 2 pi ` .
     (Contributed by Mario Carneiro, 12-May-2014.) $)
  coseq1 $p |- ( A e. CC -> ( ( cos ` A ) = 1 <->
                 ( A / ( 2 x. pi ) ) e. ZZ ) ) $=
    ( cc wcel ccos cfv c1 wceq c2 cdiv co cc0 cpi cz cmul cmin wne 2cn 2ne0 syl
    wb csin cexp divcan2 mp3an23 fveq2d halfcl eqtr3d eqeq1d sincld sqcld mulcl
    cos2tsin sylancr ax-1cn subsub23 mp3an13 eqcom 1m1e0 eqeq2i bitri syl6bb wo
    bitrd mul0or wn neii biorf ax-mp syl6bbr sqeq0 3bitrd sineq0 wa pm3.2i pire
    recni pipos gt0ne0ii divdiv1 eleq1d ) ABCZADEZFGZAHIJZUAEZKGZWDLIJZMCZAHLNJ
    IJZMCWAWCHWEHUBJZNJZKGZWJKGZWFWAWCFWKOJZFGZWLWAWBWNFWAHWDNJZDEZWBWNWAWPADWA
    HBCZHKPZWPAGQRAHUCUDUEWAWDBCZWQWNGAUFZWDULSUGUHWAWOFFOJZWKGZWLWAWKBCZWOXCTZ
    WAWRWJBCZXDQWAWEWAWDXAUIZUJZHWJUKUMFBCZXDXIXEUNUNFWKFUOUPSXCWKXBGWLXBWKUQXB
    KWKURUSUTVAVCWAWLHKGZWMVBZWMWAWRXFWLXKTQXHHWJVDUMXJVEWMXKTHKRVFXJWMVGVHVIWA
    WEBCWMWFTXGWEVJSVKWAWTWFWHTXAWDVLSWAWGWIMWAWRWSVMLBCZLKPZVMWGWIGWRWSQRVNXLX
    MLVOVPLVOVQVRVNAHLVSUDVTVK $.

  $( A complex number whose exponential is one is an integer multiple of
     ` 2 pi _i ` .  (Contributed by NM, 17-Aug-2008.)  (Revised by Mario
     Carneiro, 10-May-2014.) $)
  efeq1 $p |- ( A e. CC -> ( ( exp ` A ) = 1 <->
                ( A / ( _i x. ( 2 x. pi ) ) ) e. ZZ ) ) $=
    ( cc wcel c2 cdiv co ci cfv cc0 wceq cpi ce c1 cmul wne ax-icn mp3an23 cmin
    syl eqtrd csin cz wb halfcl ine0 divcl sineq0 sinval divcan2 fveq2d mulneg1
    cneg sylancr negeqd oveq12d oveq1d eqeq1d efcl negcld subcld mulcli mulne0i
    2cn 2ne0 diveq0 efne0 divsubdird efsub syl2anc caddc subnegd 2halves eqtr3d
    dividd diveq0ad ax-1cn subeq0 sylancl 3bitr3d 3bitrd wa divdiv32 pire recni
    pm3.2i pipos gt0ne0ii divdiv1 eleq1d ) ABCZADEFZGEFZUAHZIJZWLKEFZUBCZALHZMJ
    ZAGDKNFZNFEFZUBCWJWLBCZWNWPUCWJWKBCZXAAUDZXBGBCZGIOZXAPUEWKGUFQSZWLUGSWJWNW
    KLHZWKULZLHZRFZDGNFZEFZIJZXJIJZWRWJWMXLIWJWMGWLNFZLHZGULWLNFZLHZRFZXKEFZXLW
    JXAWMXTJXFWLUHSWJXSXJXKEWJXPXGXRXIRWJXOWKLWJXBXOWKJZXCXBXDXEYAPUEWKGUIQSZUJ
    WJXQXHLWJXQXOULZXHWJXDXAXQYCJPXFGWLUKUMWJXOWKYBUNTUJUOUPTUQWJXJBCZXMXNUCZWJ
    XGXIWJXBXGBCXCWKURSZWJXHBCZXIBCWJWKXCUSZXHURSZUTZYDXKBCXKIOYEDGVCPVADGVCPVD
    UEVBXJXKVEQSWJXJXIEFZIJWQMRFZIJZXNWRWJYKYLIWJYKXGXIEFZXIXIEFZRFYLWJXGXIXIYF
    YIYIWJYGXIIOYHXHVFSZVGWJYNWQYOMRWJWKXHRFZLHZYNWQWJXBYGYRYNJXCYHWKXHVHVIWJYQ
    ALWJYQWKWKVJFAWJWKWKXCXCVKAVLTUJVMWJXIYIYPVNUOTUQWJXJXIYJYIYPVOWJWQBCMBCYMW
    RUCAURVPWQMVQVRVSVTWJWOWTUBWJWOAGEFZDEFZKEFZWTWJWLYTKEWJDBCZDIOZWAZXDXEWAZW
    LYTJUUBUUCVCVDWEZXDXEPUEWEZADGWBQUPWJUUAYSWSEFZWTWJYSBCZUUAUUHJZWJXDXEUUIPU
    EAGUFQUUIUUDKBCZKIOZWAUUJUUFUUKUULKWCWDZKWCWFWGZWEYSDKWHQSWJUUEWSBCZWSIOZWA
    UUHWTJUUGUUOUUPDKVCUUMVADKVCUUMVDUUNVBWEAGWSWHQTTWIVS $.

  $( The cosine function has no zeroes within the vertical strip of the complex
     plane between real part ` -u pi / 2 ` and ` pi / 2 ` .  (Contributed by
     Mario Carneiro, 2-Apr-2015.) $)
  cosne0 $p |- ( ( A e. CC /\ ( Re ` A ) e.
    ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) -> ( cos ` A ) =/= 0 ) $=
    ( cc wcel cfv cpi ccos cmin cc0 wceq halfpire sylancr syl pire a1i eqeltrrd
    co cr clt wbr c1 cre c2 cdiv cneg cioo wa csin recni simpl nncan coshalfpim
    fveq2d subcl eqtr3d wne cz wn adantr pipos gt0ne0ii divcan1d adantl remulcl
    zre sylancl resubcl rered simplr caddc 0z elioore eliooord simprd wb posdif
    cmul mpbid divgt0d negcli negsubi 2halves ax-mp subaddrii syl5eqbr ltsub23d
    eqtri simpld mulid1i syl6breqr 1re ltdivmul syl112anc mpbird 1e0p1 syl6breq
    btwnnz syl3anc pm2.01da sineq0 necon3abid eqnetrd ) ABCZAUADZEUBUCPZUDZXDUE
    PZCZUFZAFDZXDAGPZUGDZHXHXDXJGPZFDZXIXKXHXLAFXHXDBCZXBXLAIZXDJUHZXBXGUIZXDAU
    JKZULXHXJBCZXMXKIXHXNXBXSXPXQXDAUMKZXJUKLUNXHXKHUOXJEUCPZUPCZUQZXHYBXHYBUFZ
    AXFCZYCYDXCAXFYDAYDXLAQXHXOYBXRURYDXDQCZXJQCZXLQCJYDYAEVPPZXJQXHYHXJIYBXHXJ
    EXTEBCZXHEMUHZNEHUOXHEMUSUTNVAURYDYAQCZEQCZYHQCYBYKXHYAVDVBMYAEVCVEOXDXJVFK
    OVGXBXGYBVHOYEHUPCZHYARSYAHTVIPZRSYCYMYEVJNYEXJEYEYFAQCZYGJAXEXDVKZXDAVFKZY
    LYEMNZYEAXDRSZHXJRSZYEXEARSZYSAXEXDVLZVMYEYOYFYSYTVNYPJAXDVOVEVQHERSZYEUSNZ
    VRYEYATYNRYEYATRSZXJETVPPZRSZYEXJEUUFRYEXDEAYFYEJNYRYPYEXDEGPXEARXDEXEXPYJX
    DXPVSEXEVIPEXDGPXDEXDYJXPVTEXDXDYJXPXPYIXDXDVIPEIYJEWAWBWCWFWCYEUUAYSUUBWGW
    DWEEYJWHWIYEYGTQCZYLUUCUUEUUGVNYQUUHYEWJNYRUUDXJTEWKWLWMWNWOHYAWPWQLWRXHYBX
    KHXHXSXKHIYBVNXTXJWSLWTWMXA $.

  ${
    cosord.1 $e |- ( ph -> A e. ( 0 [,] pi ) ) $.
    cosord.2 $e |- ( ph -> B e. ( 0 [,] pi ) ) $.
    cosord.3 $e |- ( ph -> A < B ) $.
    $( Lemma for ~ cosord .  (Contributed by Mario Carneiro, 10-May-2014.) $)
    cosordlem $p |- ( ph -> ( cos ` B ) < ( cos ` A ) ) $=
      ( cfv clt wbr co crp wcel c2 cr cc0 cle cpi w3a pire wb ccos cmin cdiv cc
      caddc csin cmul wceq cicc 0re elicc2i sylib simp1d recnd syl2anc 2re 2pos
      subcos elrpii readdcld resincld cioo a1i simp2d lelttrd addgtge0 syl22anc
      rehalfcld divgt0 mpanr12 ltadd2dd 2timesd breqtrrd ltdivmul mpbird simp3d
      wa syl112anc ltletrd cxr 0xr rexri elioo2 mp2an syl3anbrc sinq12gt0 elrpd
      resubcld posdifd mpbid rehalfcl mp1i subge02d letrd lediv1 pipos rphalflt
      syl rpmulcld rpmulcl sylancr eqeltrd recoscld difrp ) ACUAGZBUAGZHIZXFXEU
      BJZKLZAXHMCBUEJZMUCJZUFGZCBUBJZMUCJZUFGZUGJZUGJZKACUDLBUDLXHXQUHACACNLZOC
      PIZCQPIZACOQUIJZLXRXSXTREOQCUJSUKULZUMZUNZABABNLZOBPIZBQPIZABYALYEYFYGRDO
      QBUJSUKULZUMZUNCBURUOAMKLXPKLXQKLMUPUQUSAXLXOAXLAXKAXJACBYCYIUTZVHZVAAXKO
      QVBJZLZOXLHIAXKNLZOXKHIZXKQHIZYMYKAXJNLZOXJHIZYOYJAXRYEOCHIYFYRYCYIAOBCON
      LAUJVCYIYCAYEYFYGYHVDZFVEYSCBVFVGYQYRVQMNLZOMHIZYOUPUQXJMVIVJUOAXKCQYKYCQ
      NLZASVCZAXKCHIZXJMCUGJZHIZAXJCCUEJUUEHABCCYIYCYCFVKACYDVLVMAYQXRYTUUAUUDU
      UFTYJYCYTAUPVCZUUAAUQVCZXJCMVNVRVOAXRXSXTYBVPZVSOVTLZQVTLZYMYNYOYPRTWAQSW
      BZOQXKWCWDWEXKWFWRWGAXOAXNAXMACBYCYIWHZVHZVAAXNYLLZOXOHIAXNNLZOXNHIZXNQHI
      ZUUOUUNAXMNLZOXMHIZUUQUUMABCHIUUTFABCYIYCWIWJUUSUUTVQYTUUAUUQUPUQXMMVIVJU
      OAXNQMUCJZQUUNUUBUVANLASQWKWLUUCAXMQPIZXNUVAPIZAXMCQUUMYCUUCAYFXMCPIYSACB
      YCYIWMWJUUIWNAUUSUUBYTUUAUVBUVCTUUMUUCUUGUUHXMQMWOVRWJQKLUVAQHIAQSWPUSQWQ
      WLVEUUJUUKUUOUUPUUQUURRTWAUULOQXNWCWDWEXNWFWRWGWSMXPWTXAXBAXENLXFNLXGXITA
      CYCXCABYIXCXEXFXDUOVO $.
  $}

  $( Cosine is decreasing over the closed interval from ` 0 ` to ` pi ` .
     (Contributed by Paul Chapman, 16-Mar-2008.)  (Proof shortened by Mario
     Carneiro, 10-May-2014.) $)
  cosord $p |- ( ( A e. ( 0 [,] pi ) /\ B e. ( 0 [,] pi ) ) ->
                 ( A < B <-> ( cos ` B ) < ( cos ` A ) ) ) $=
    ( cc0 cpi wcel wa clt wbr ccos cfv simpll simplr simpr cosordlem ex wceq wo
    wn cr cle cicc co wi fveq2 eqcomd a1i orim12d con3d wb pire elicc2i simp1bi
    0re recoscl axlttri syl2anr syl2an 3imtr4d impbid ) ACDUAUBZEZBUTEZFZABGHZB
    IJZAIJZGHZVCVDVGVCVDFABVAVBVDKVAVBVDLVCVDMNOVCVEVFPZVFVEGHZQZRZABPZBAGHZQZR
    ZVGVDVCVNVJVCVLVHVMVIVLVHUCVCVLVFVEABIUDUEUFVCVMVIVCVMFBAVAVBVMLVAVBVMKVCVM
    MNOUGUHVAASEZBSEZVGVKUIZVBVAVPCATHADTHCDAUMUJUKULZVBVQCBTHBDTHCDBUMUJUKULZV
    QVESEVFSEVRVPBUNAUNVEVFUOUPUQVAVPVQVDVOUIVBVSVTABUOUQURUS $.

  $( Cosine is one-to-one over the closed interval from ` 0 ` to ` pi ` .
     (Contributed by Paul Chapman, 16-Mar-2008.)  (Proof shortened by Mario
     Carneiro, 10-May-2014.) $)
  cos11 $p |- ( ( A e. ( 0 [,] pi ) /\ B e. ( 0 [,] pi ) ) ->
                ( A = B <-> ( cos ` A ) = ( cos ` B ) ) ) $=
    ( cc0 cpi wcel wa clt wbr wn ccos cfv wceq wb cosord notbid cr cle 0re pire
    syl2an cicc co ancoms anbi12d syl5bb elicc2i simp1bi lttri3 recoscl 3bitr4d
    ancom ) ACDUAUBZEZBULEZFZABGHZIZBAGHZIZFZAJKZBJKZGHZIZVBVAGHZIZFZABLZVAVBLZ
    UTUSUQFUOVGUQUSUKUOUSVDUQVFUOURVCUNUMURVCMBANUCOUOUPVEABNOUDUEUMAPEZBPEZVHU
    TMUNUMVJCAQHADQHCDARSUFUGZUNVKCBQHBDQHCDBRSUFUGZABUHTUMVJVKVIVGMZUNVLVMVJVA
    PEVBPEVNVKAUIBUIVAVBUHTTUJ $.

  ${
    $d w x y z A $.  $d x y B $.
    $( Sine is increasing over the closed interval from ` -u ( pi / 2 ) ` to
       ` ( pi / 2 ) ` .  (Contributed by Mario Carneiro, 29-Jul-2014.) $)
    sinord $p |- ( ( A e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) /\
                     B e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ) ->
                   ( A < B <-> ( sin ` A ) < ( sin ` B ) ) ) $=
      ( vx cpi co cicc wcel clt wbr cmin cfv cr halfpire sseli cc0 wceq cle syl
      wb cc c2 cdiv cneg wa ccos csin wss renegcli iccssre ltsub2 mp3an3 syl2an
      mp2an eleq1d resubcl sylancr elicc2i simp3bi subge0 mpbird simp2bi lesub2
      oveq2 mp3an13 mpbid caddc recni subnegi pire 2halves ax-mp eqtri syl6breq
      cv 0re syl3anbrc vtoclga cosord syl2anr recnd coshalfpim breqan12d 3bitrd
      ) ADUAUBEZUCZWDFEZGZBWFGZUDABHIZWDBJEZWDAJEZHIZWKUEKZWJUEKZHIZAUFKZBUFKZH
      IWGALGZBLGZWIWLSZWHWFLAWELGZWDLGZWFLUGWDMUHZMWEWDUIUMZNZWFLBXDNZWRWSXBWTM
      ABWDUJUKULWHWJODFEZGZWKXGGZWLWOSWGWDCVNZJEZXGGZXHCBWFXJBPXKWJXGXJBWDJVCUN
      XJWFGZXKLGZOXKQIZXKDQIXLXMXBXJLGZXNMWFLXJXDNZWDXJUOUPXMXOXJWDQIZXMXPWEXJQ
      IZXRWEWDXJXCMUQZURXMXBXPXOXRSMXQWDXJUSUPUTXMXKWDWEJEZDQXMXSXKYAQIZXMXPXSX
      RXTVAXMXPXSYBSZXQXAXPXBYCXCMWEXJWDVBVDRVEYAWDWDVFEZDWDWDWDMVGZYEVHDTGYDDP
      DVIVGDVJVKVLVMODXKVOVIUQVPZVQXLXICAWFXJAPXKWKXGXJAWDJVCUNYFVQWJWKVRVSWGWH
      WMWPWNWQHWGATGWMWPPWGAXEVTAWARWHBTGWNWQPWHBXFVTBWARWBWC $.

    $( The cosine function is a bijection when restricted to its principal
       domain.  (Contributed by Mario Carneiro, 12-May-2014.) $)
    recosf1o $p |- ( cos |` ( 0 [,] pi ) ) :
                     ( 0 [,] pi ) -1-1-onto-> ( -u 1 [,] 1 ) $=
      ( vx vy vz cc0 cpi cicc co c1 ccos cv cfv wceq wral wcel mpbir2an a1i cle
      cc cr wbr cneg cres wf1o wf1 wfo wf wi wfn wss cosf ffn ax-mp 0re iccssre
      pire mp2an ax-resscn sstri fnssres fvres sseli cosbnd2 eqeltrd rgen ffnfv
      syl eqeqan12d cos11 biimprd sylbid rgen2a dff13 wrex 1re renegcli elicc2i
      wa simp1bi clt pipos ccncf coscn recoscld adantl simp2bi syl5eqbr simp3bi
      cospi cos0 syl6breqr jca ivthle2 eqcom eqeq1d syl5bb rexbiia sylibr dffo3
      df-f1o ) DEFGZHUAZHFGZIWTUBZUCWTXBXCUDZWTXBXCUEZXDWTXBXCUFZAJZXCKZBJZXCKZ
      LZXGXILZUGZBWTMAWTMXFXCWTUHZXHXBNZAWTMIRUHZWTRUIZXNRRIUFXPUJRRIUKULWTSRDS
      NZESNZWTSUIUMUODEUNUPZUQURZRWTIUSUPXOAWTXGWTNZXHXGIKZXBXGWTIUTZYBXGSNZYCX
      BNWTSXGXTVAXGVBVFVCVDAWTXBXCVEOZXMABWTYBXIWTNZVQZXKYCXIIKZLZXLYBYGXHYCXJY
      IYDXIWTIUTZVGYHXLYJXGXIVHVIVJVKABWTXBXCVLOXEXFXGXJLZBWTVMZAXBMYFYMAXBXGXB
      NZYIXGLZBWTVMYMYNCDERXGIBXRYNUMPXSYNUOPYNYEXAXGQTZXGHQTZXAHXGHVNVOVNVPZVR
      DEVSTYNVTPXQYNYAPIRRWAGNYNWBPCJZWTNZYSIKSNYNYTYSWTSYSXTVAWCWDYNEIKZXGQTXG
      DIKZQTYNUUAXAXGQWHYNYEYPYQYRWEWFYNXGHUUBQYNYEYPYQYRWGWIWJWKWLYLYOBWTYLXJX
      GLYGYOXGXJWMYGXJYIXGYKWNWOWPWQVDBAWTXBXCWROWTXBXCWSO $.

    $( The sine function is a bijection when restricted to its principal
       domain.  (Contributed by Mario Carneiro, 12-May-2014.) $)
    resinf1o $p |- ( sin |` ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ) :
                 ( -u ( pi / 2 ) [,] ( pi / 2 ) ) -1-1-onto-> ( -u 1 [,] 1 ) $=
      ( vx vy cpi co ccos cc0 cmin csin wtru wcel cr cle halfpire mp2an wb pire
      wbr cc wceq cfv c2 cdiv cneg cicc c1 cres cv cmpt ccom wf1o recosf1o eqid
      wss renegcli iccssre resubcl sylancr elicc2i simp3bi subge0 mpbird negcli
      sseli recni caddc negsubi 2halves ax-mp subaddrii eqtri simp2bi suble syl
      syl5eqbr mp3an12 mpbid syl3anbrc adantl simp1bi subnegi syl6breqr mp3an23
      0re lesub subidi wa ax-resscn sstri subsub23 mp3an1 syl2anr eqcom 3bitr4g
      f1o2d trud f1oco wfn wral wf cosf ffn fnssres fmpti fnfco eqfnfv ffvelrni
      sinf fvres oveq2 ovex fvmpt fveq2d coshalfpim 3eqtrd mpan 3eqtr4d mprgbir
      fvco3 f1oeq1 mpbi ) CUAUBDZUCZYAUDDZUEUCUEUDDZEFCUDDZUFZAYCYAAUGZGDZUHZUI
      ZUJZYCYDHYCUFZUJZYEYDYFUJYCYEYIUJZYKUKYNIABYCYEYHYABUGZGDZYIYIULZYGYCJZYH
      YEJZIYRYHKJZFYHLQZYHCLQZYSYRYAKJZYGKJZYTMYCKYGYBKJZUUCYCKUMYAMUNZMYBYAUON
      ZVCZYAYGUPUQYRUUAYGYALQZYRUUDYBYGLQZUUIYBYAYGUUFMURZUSYRUUCUUDUUAUUIOMUUH
      YAYGUTUQVAYRYACGDZYGLQZUUBYRUULYBYGLYACYBYAMVDZCPVDZYAUUNVBCYBVEDCYAGDYAC
      YAUUOUUNVFCYAYAUUOUUNUUNCRJYAYAVEDZCSUUOCVGVHZVIVJVIYRUUDUUJUUIUUKVKVNYRU
      UDUUMUUBOZUUHUUCCKJZUUDUURMPYACYGVLVOVMVPFCYHWCPURVQZVRYOYEJZYPYCJZIUVAYP
      KJZYBYPLQZYPYALQZUVBUVAUUCYOKJZUVCMUVAUVFFYOLQZYOCLQZFCYOWCPURZVSZYAYOUPU
      QUVAYOYAYBGDZLQZUVDUVAYOCUVKLUVAUVFUVGUVHUVIUSUVKUUPCYAYAUUNUUNVTUUQVJWAU
      VAUVFUVLUVDOZUVJUVFUUCUUEUVMMUUFYOYAYBWDWBVMVPUVAYAYAGDZYOLQZUVEUVAUVNFYO
      LYAUUNWEUVAUVFUVGUVHUVIVKVNUVAUVFUVOUVEOZUVJUUCUUCUVFUVPMMYAYAYOVLVOVMVPY
      BYAYPUUFMURVQVRIYRUVAWFZWFYPYGSZYHYOSZYGYPSYOYHSUVQUVRUVSOZIUVAYORJZYGRJZ
      UVTYRYERYOYEKRFKJUUSYEKUMWCPFCUONWGWHZVCYCRYGYCKRUUGWGWHZVCYARJUWAUWBUVTU
      UNYAYOYGWIWJWKVRYGYPWLYOYHWLWMWNWOYCYEYDYFYIWPNYJYLSZYKYMOUWEYOYJTZYOYLTZ
      SZBYCYJYCWQZYLYCWQZUWEUWHBYCWROYFYEWQZYCYEYIWSZUWIERWQZYERUMUWKRREWSUWMWT
      RREXAVHUWCRYEEXBNAYCYEYHYIYQUUTXCZYEYCYFYIXDNHRWQZYCRUMUWJRRHWSUWOXGRRHXA
      VHUWDRYCHXBNBYCYJYLXENYOYCJZYOYITZYFTZYOHTZUWFUWGUWPUWRUWQETZYPETZUWSUWPU
      WQYEJUWRUWTSYCYEYOYIUWNXFUWQYEEXHVMUWPUWQYPEAYOYHYPYCYIYGYOYAGXIYQYAYOGXJ
      XKXLUWPUWAUXAUWSSYCRYOUWDVCYOXMVMXNUWLUWPUWFUWRSUWNYCYEYOYFYIXRXOYOYCHXHX
      PXQYCYDYJYLXSVHXT $.

    $( The tangent function is strictly increasing on the nonnegative part of
       its principal domain.  (Lemma for ~ tanord .)  (Contributed by Mario
       Carneiro, 29-Jul-2014.) $)
    tanord1 $p |- ( ( A e. ( 0 [,) ( pi / 2 ) ) /\
    B e. ( 0 [,) ( pi / 2 ) ) ) -> ( A < B <-> ( tan ` A ) < ( tan ` B ) ) ) $=
      ( vx vy vz cc0 cpi co wcel clt wbr cfv wb cr cxr mp2an sseli cle 3ad2ant1
      ctan vw wtru c2 cdiv cico wa tru cv fveq2 wss halfpire rexri icossre ccos
      0re cneg cioo renegcli pire pipos 2pos divgt0ii lt0neg2 ax-mp mpbi df-ioo
      2re df-ico xrltletr ixxss1 cosq14gt0 syl gt0ne0d retancld adantl w3a csin
      resincld recoscld redivcld 3ad2ant2 wne cicc ioossicc sstri sinord syl2an
      wi biimp3a ltdiv1 syl112anc mpbid crp elrpii df-icc xrlttr xrltle 3adant2
      rphalflt syld ixxss2 cosord simp1 elico2 sylib simp2d simp3 lelttrd simp2
      a1i simp3d 0xr elioo2 syl3anbrc sincosq1sgn simprd simpld ltdiv2OLD lttrd
      syl33anc wceq cc recnd tanval syl2anc 3brtr4d 3expia ltord1 mpan ) UBAFGU
      CUDHZUEHZIBYKIUFABJKATLZBTLZJKMUGUBCDCUHZTLZDUHZTLZABYKYLYMYNYPTUIYNATUIY
      NBTUIFNIZYJOIZYKNUJUOYJUKULZFYJUMPZYNYKIZYONIUBUUBYNYKNYNUUAQZUUBYNUNLZUU
      BYNYJUPZYJUQHZIFUUDJKZYKUUFYNUUEOIUUEFJKZYKUUFUJUUEYJUKURULFYJJKZUUHGUCUS
      VGUTVAVBYJNIUUIUUHMUKYJVCVDVECDEUAUUEFYJUEJJRUQJCDEVFCDEVHZUUEFUAUHZVIVJP
      ZQYNVKVLZVMZVNVOUUBYPYKIZUFYNYPJKZYOYQJKZWHUBUUBUUOUUPUUQUUBUUOUUPVPZYNVQ
      LZUUDUDHZYPVQLZYPUNLZUDHZYOYQJUURUUTUVAUUDUDHZUVCUUBUUOUUTNIUUPUUBUUSUUDU
      UBYNUUCVRUUBYNUUCVSZUUNVTSUURUVAUUDUURYPUUOUUBYPNIZUUPYKNYPUUAQZWAZVRZUUB
      UUOUUDNIZUUPUVESZUUBUUOUUDFWBZUUPUUNSVTUURUVAUVBUVIUURYPUVHVSZUUOUUBUVBFW
      BZUUPUUOUVBUUOYPUUFIFUVBJKZYKUUFYPUULQYPVKVLVMWAZVTUURUUSUVAJKZUUTUVDJKZU
      UBUUOUUPUVQUUBYNUUEYJWCHZIYPUVSIUUPUVQMUUOYKUVSYNYKUUFUVSUULUUEYJWDWEZQYK
      UVSYPUVTQYNYPWFWGWIUURUUSNIUVANIZUVJUUGUVQUVRMUURYNUUBUUOYNNIZUUPUUCSZVRU
      VIUVKUUBUUOUUGUUPUUMSZUUSUVAUUDWJWKWLUURUVBUUDJKZUVDUVCJKZUUBUUOUUPUWEUUB
      YNFGWCHZIYPUWGIUUPUWEMUUOYKUWGYNGOIZYJGJKZYKUWGUJGUSULGWMIUWIGUSUTWNGWSVD
      CDEUAFYJGUERRJWCJCDEWOUUJUUKOIZYSUWHVPUUKYJJKUWIUFUUKGJKZUUKGRKZUUKYJGWPU
      WJUWHUWKUWLWHYSUUKGWQWRWTXAPZQYKUWGYPUWMQYNYPXBWGWIUURUVBNIUVJUWAUVOUUGFU
      VAJKZUWEUWFMUVMUVKUVIUURUWNUVOUURYPFYJUQHIZUWNUVOUFUURUVFFYPJKZYPYJJKZUWO
      UVHUURFYNYPYRUURUOXJUWCUVHUURUWBFYNRKZYNYJJKZUURUUBUWBUWRUWSVPZUUBUUOUUPX
      CYRYSUUBUWTMUOYTFYJYNXDPXEXFUUBUUOUUPXGXHUURUVFFYPRKZUWQUURUUOUVFUXAUWQVP
      ZUUBUUOUUPXIYRYSUUOUXBMUOYTFYJYPXDPXEXKFOIYSUWOUVFUWPUWQVPMXLYTFYJYPXMPXN
      YPXOVLZXPUWDUURUWNUVOUXCXQUVBUUDUVAXRXTWLXSUUBUUOYOUUTYAZUUPUUBYNYBIUVLUX
      DUUBYNUUCYCUUNYNYDYESUURYPYBIZUVNYQUVCYAUUOUUBUXEUUPUUOYPUVGYCWAUVPYPYDYE
      YFYGVOYHYI $.

    $( The tangent function is strictly increasing on its principal domain.
       (Contributed by Mario Carneiro, 4-Apr-2015.) $)
    tanord $p |- ( ( A e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) /\
                     B e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) ->
      ( A < B <-> ( tan ` A ) < ( tan ` B ) ) ) $=
      ( cneg wcel wa clt wbr ctan cfv wb cc0 syl2anc w3a adantr syl mpbid mp2an
      cr 0re syl3anbrc vx vy wtru cpi c2 cdiv co cioo tru fveq2 ioossre elioore
      cv cc cre ccos wne recnd rered id eqeltrd cosne0 retancld adantl 3ad2ant1
      wi negnegd fveq2d wceq negcld cosneg simpl1 eqnetrd tanneg eqtr3d adantrr
      renegcld a1i simp2 sseldi simpl2 simprl lt0neg1d eliooord simpld halfpire
      crp ltnegcon1 sylancr cxr 0xr rexri elioo2 tanrpcl rpgt0d lt0neg2d simprr
      simprd lttrd anassrs cle simpl3 ltnegd simpr le0neg1d elico2 simp3 ltletr
      cico syl3anc mpand imp ltle sylancl mpd tanord1 syldan breqtrrd ltlecasei
      adantlr eqbrtrd ltled letrd 3expia ltord1 mpan ) UCAUDUEUFUGZCZYGUHUGZDBY
      IDEABFGAHIZBHIZFGJUIUCUAUBUAUMZHIZUBUMZHIZABYIYJYKYLYNHUJYLAHUJYLBHUJYHYG
      UKZYLYIDZYMRDUCYQYLYLYHYGULZYQYLUNDZYLUOIZYIDYLUPIZKUQZYQYLYRURYQYTYLYIYQ
      YLYRUSYQUTVAYLVBLZVCVDYQYNYIDZEYLYNFGZYMYOFGZVFUCYQUUDUUEUUFYQUUDUUEMZUUF
      YLKUUGYLKFGZEZYMYLCZHIZCZYOFUUIUUJCZHIZYMUULUUIUUMYLHUUIYLUUIYLUUGYLRDZUU
      HYQUUDUUOUUEYRVEZNURZVGVHUUIUUJUNDUUJUPIZKUQZUUNUULVIUUIYLUUQVJUUIUURUUAK
      UUIYSUURUUAVIUUQYLVKOUUIYQUUBYQUUDUUEUUHVLUUCOVMZUUJVNLVOUUIUULYOFGZKYNUU
      GUUHKYNFGZUVAUUGUUHUVBEZEZUULKYOUVDUUKUVDUUJUVDYLUUGUUOUVCUUPNZVQZUUGUUHU
      USUVBUUTVPVCZVQKRDZUVDSVRUVDYNUUGYNRDZUVCUUGYIRYNYPYQUUDUUEVSVTZNZUVDUUDY
      NUPIZKUQZYQUUDUUEUVCWAZUUDYNUNDZYNUOIZYIDUVMUUDYNYNYHYGULZURUUDUVPYNYIUUD
      YNUVQUSUUDUTVAYNVBLZOVCUVDKUUKFGUULKFGUVDUUKUVDUUJKYGUHUGZDZUUKWGDUVDUUJR
      DZKUUJFGZUUJYGFGZUVTUVFUVDUUHUWBUUGUUHUVBWBUVDYLUVEWCPUVDYHYLFGZUWCUVDUWD
      YLYGFGZUVDYQUWDUWEEZYQUUDUUEUVCVLYLYHYGWDZOWEUVDYGRDZUUOUWDUWCJZWFUVEYGYL
      WHZWIPKWJDZYGWJDZUVTUWAUWBUWCMJWKYGWFWLZKYGUUJWMQTUUJWNOWOUVDUUKUVGWPPUVD
      YOUVDYNUVSDZYOWGDUVDUVIUVBYNYGFGZUWNUVKUUGUUHUVBWQUVDYHYNFGZUWOUVDUUDUWPU
      WOEZUVNYNYHYGWDZOWRUWKUWLUWNUVIUVBUWOMJWKUWMKYGYNWMQTYNWNOWOWSWTUUGYNKXAG
      ZUVAUUHUUGUWSEZUULYNCZHIZCZYOFUWTUXBUUKFGZUULUXCFGUWTUXAUUJFGZUXDUWTUUEUX
      EYQUUDUUEUWSXBUWTYLYNUUGUUOUWSUUPNZUUGUVIUWSUVJNZXCPUWTUXAKYGXIUGZDZUUJUX
      HDZUXEUXDJUWTUXARDZKUXAXAGZUXAYGFGZUXIUWTYNUXGVQZUWTUWSUXLUUGUWSXDUWTYNUX
      GXEPUWTUWPUXMUWTUWPUWOUWTUUDUWQYQUUDUUEUWSWAZUWROWEUWTUWHUVIUWPUXMJWFUXGY
      GYNWHWIPUVHUWLUXIUXKUXLUXMMJSUWMKYGUXAXFQTUWTUWAKUUJXAGZUWCUXJUWTYLUXFVQZ
      UWTYLKXAGZUXPUWTUUHUXRUUGUWSUUHUUGUUEUWSUUHYQUUDUUEXGUUGUUOUVIUVHUUEUWSEU
      UHVFUUPUVJUVHUUGSVRZYLYNKXHXJXKXLZUWTUUOUVHUUHUXRVFUXFSYLKXMXNXOUWTYLUXFX
      EPUWTUWDUWCUWTUWDUWEUWTYQUWFYQUUDUUEUWSVLUWGOWEUWTUWHUUOUWIWFUXFUWJWIPUVH
      UWLUXJUWAUXPUWCMJSUWMKYGUUJXFQTUXAUUJXPLPUWTUXBUUKUWTUXAUXNUWTUXAUPIZUVLK
      UWTUVOUYAUVLVIUWTYNUXGURZYNVKOUWTUUDUVMUXOUVROVMZVCUWTUUJUXQUUGUWSUUHUUSU
      XTUUTXQVCXCPUWTUXACZHIZYOUXCUWTUYDYNHUWTYNUYBVGVHUWTUXAUNDUYAKUQUYEUXCVIU
      WTYNUYBVJUYCUXAVNLVOXRXTUVHUUISVRUUIYIRYNYPYQUUDUUEUUHWAVTXSYAUUGKYLXAGZE
      ZUUEUUFYQUUDUUEUYFXBZUYGYLUXHDZYNUXHDZUUEUUFJUYGUUOUYFUWEUYIUUGUUOUYFUUPN
      ZUUGUYFXDZUYGUWDUWEUYGYQUWFYQUUDUUEUYFVLUWGOWRUVHUWLUYIUUOUYFUWEMJSUWMKYG
      YLXFQTUYGUVIKYNXAGZUWOUYJUYGYIRYNYPYQUUDUUEUYFWAZVTZUYGKYLYNUVHUYGSVRUYKU
      YOUYLUYGYLYNUYKUYOUYHYBYCUYGUWPUWOUYGUUDUWQUYNUWROWRUVHUWLUYJUVIUYMUWOMJS
      UWMKYGYNXFQTYLYNXPLPUUPUXSXSYDVDYEYF $.
  $}

  $( TODO - is there possibly a more direct proof which does not
     break into real/imaginary parts? $)
  $( The positivity of ` tan ( A ) ` extends to complex numbers with the same
     real part.  (Contributed by Mario Carneiro, 5-Apr-2015.) $)
  tanregt0 $p |- ( ( A e. CC /\ ( Re ` A ) e. ( 0 (,) ( pi / 2 ) ) ) ->
    0 < ( Re ` ( tan ` A ) ) ) $=
    ( cc wcel cre cfv cc0 c2 cdiv co c1 ci cim cmul cmin clt cneg wne wbr wceq
    cr cpi cioo wa ctan cabs cexp ccj caddc crp cz ax-1cn recl recnd ccos rered
    adantr cxr cle wss halfpire renegcli rexri pire pipos elrpii rphalfcl rpgt0
    0re mp2b lt0neg2 ax-mp mpbi ltleii iooss1 mp2an simpr sseldi eqeltrd cosne0
    wb syl2anc tancld ax-icn imcl mulcl rpcoshcl syl rpne0d mulcld subcl replim
    sylancr fveq2d syldan eqnetrrd tanaddlem syl22anc necomd necon3bid absrpcld
    mpbid subeq0 mpbird 2z rpexpcl sylancl rprecred cjcld addcld recld rpreccld
    rpgt0d retancld 1re retanhcl resqcld resubcl tanrpcl adantl absresq tanhbnd
    eliooord abslt abscld a1i mulgt0d oveq1i ine0 divcan2d oveq2d 3eqtrd syl5eq
    remul2d eqtr3d oveq12d eqtrd negeqd 3eqtr4d breqtrrd divrec2d 0le1 syl6breq
    absge0d lt2sqd sq1 eqbrtrrd posdif recjd re1 negcli negne0i divcld divneg2d
    resub renegcld eqeltrrd reim0d 3eqtr3rd mul01d subid1i syl6eq crred mulassd
    imre mulcom imcjd imsub df-neg eqtr4i immul2d imval remulcld negnegd sqvald
    im1 crimd remuld sqcld subdid tanadd syl23anc recval oveq1d div23d ) ABCZAD
    EZFUAGHIZUBIZCZUCZFJJUWFUDEZKALEZMIZUDEZMIZNIZUEEZGUFIZHIZUWPUGEZUWKUWNUHIZ
    MIZDEZMIZAUDEZDEZOUWJUWSUXCUWJUWRUWJUWQUICGUJCUWRUICUWJUWPUWJJBCZUWOBCZUWPB
    CZUKUWJUWKUWNUWJUWFUWJUWFUWEUWFTCUWIAULUPZUMZUWJUWFBCZUWFDEZUWGPZUWGUBIZCUW
    FUNEFQZUXKUWJUXMUWFUXOUWJUWFUXJUOUWJUWHUXOUWFUXNUQCUXNFURRUWHUXOUSUXNUWGUTV
    AZVBUXNFUXQVHFUWGORZUXNFORZUAUICUWGUICUXRUAVCVDVEUAVFUWGVGVIUWGTCUXRUXSVTUT
    UWGVJVKVLVMUXNFUWGVNVOUWEUWIVPVQZVRUWFVSWAZWBZUWJUWMUWJKBCZUWLBCUWMBCZWCUWJ
    UWLUWEUWLTCZUWIAWDUPZUMKUWLWEWLZUWJUWMUNEZUWJUYEUYHUICUYFUWLWFWGWHZWBZWIZJU
    WOWJWLZUWJUWPFQZJUWOQZUWJUWOJUWJUWFUWMUHIZUNEZFQZUWOJQZUWJAUNEZUYPFUWJAUYOU
    NUWEAUYOSUWIAWKUPZWMUWEUWIUWFUXOCUYSFQUXTAVSWNWOZUWJUXLUYDUXPUYHFQZUYQUYRVT
    UXKUYGUYAUYIUWFUWMWPWQXAWRUWJUXGUXHUYMUYNVTUKUYKUXGUXHUCUWPFJUWOJUWOXBWSWLX
    CZWTXDUWQGXEXFZXGZUWJUXBUWJUWTUXAUWJUWPUYLXHZUWJUWKUWNUYBUYJXIZWIZXJUWJUWSU
    WJUWRVUDXKXLUWJFUWKJUWNKHIZGUFIZNIZMIZUXCOUWJUWKVUKUWJUWFUXJUYAXMZUWJJTCZVU
    JTCZVUKTCXNUWJVUIUWJUYEVUITCZUYFUWLXOWGZXPZJVUJXQWLUWJUWKUWIUWKUICUWEUWFXRX
    SXLUWJVUJJORZFVUKORZUWJVUIUEEZGUFIZVUJJOUWJVUPVVBVUJSVUQVUIXTWGUWJVVBJGUFIZ
    JOUWJVVAJORZVVBVVCORUWJVVDJPZVUIORVUIJORUCZUWJVUIVVEJUBICZVVFUWJUYEVVGUYFUW
    LYAWGVUIVVEJYBWGUWJVUPVUNVVDVVFVTVUQXNVUIJYCXFXCUWJVVAJUWJVUIUWJVUIVUQUMZYD
    VUNUWJXNYEUWJVUIVVHUUCFJURRUWJUUAYEUUDXAUUEUUBUUFUWJVUOVUNVUSVUTVTVURXNVUJJ
    UUGXFXAYFUWJUWTDEZUXADEZMIZUWTLEZUXALEZMIZNIUWKJMIZUWKVUJMIZNIUXCVULUWJVVKV
    VOVVNVVPNUWJVVKJUWKMIZVVOUWJVVIJVVJUWKMUWJVVIUWPDEZJDEZUWODEZNIZJUWJUWPUYLU
    UHUWJUXGUXHVVRVWASUKUYKJUWOUUNWLUWJVWAJVVTNIZJVVSJVVTNUUIYGUWJVWBJFNIJUWJVV
    TFJNUWJVVTUWKUWNDEZMIUWKFMIFUWJUWKUWNVUMUYJYMUWJVWCFUWKMUWJUWNKPZHIZLEZVWDV
    WEMIZDEZFVWCUWJVWEBCVWFVWHSUWJUWNVWDUYJVWDBCUWJKWCUUJYEZVWDFQUWJKWCYHUUKYEZ
    UULVWEUVDWGUWJVWEUWJVUIPVWETUWJUWNKUYJUYCUWJWCYEZKFQUWJYHYEZUUMUWJVUIVUQUUO
    UUPUUQUWJVWGUWNDUWJUWNVWDUYJVWIVWJYIWMUURYJUWJUWKUYBUUSYKYJJUKUUTUVAYLYKUWJ
    UWKKVUIMIZUHIZDEVVJUWKUWJVWNUXADUWJVWMUWNUWKUHUWJUWNKUYJVWKVWLYIYJZWMUWJUWK
    VUIVUMVUQUVBYNYOUWJUXGUWKBCVVQVVOSUKUYBJUWKUVEWLYPUWJUWKVUIMIZVUIMIUWKVUIVU
    IMIZMIVVNVVPUWJUWKVUIVUIUYBVVHVVHUVCUWJVVLVWPVVMVUIMUWJVVLUWPLEZPVWPPZPVWPU
    WJUWPUYLUVFUWJVWRVWSUWJVWRJLEZUWOLEZNIZVWSUWJUXGUXHVWRVXBSUKUYKJUWOUVGWLUWJ
    VXBVXAPZVWSVXBFVXANIVXCVWTFVXANUVOYGVXAUVHUVIUWJVXAVWPUWJVXAUWKUWNLEZMIVWPU
    WJUWKUWNVUMUYJUVJUWJVXDVUIUWKMUWJVXDVUIDEZVUIUWJUWNBCVXDVXESUYJUWNUVKWGUWJV
    UIVUQUOYPYJYPYQYLYPYQUWJVWPUWJVWPUWJUWKVUIVUMVUQUVLUMUVMYKUWJVWNLEVVMVUIUWJ
    VWNUXALVWOWMUWJUWKVUIVUMVUQUVPYNYOUWJVUJVWQUWKMUWJVUIVVHUVNYJYRYOUWJUWTUXAV
    UFVUGUVQUWJUWKJVUJUYBUXGUWJUKYEUWJVUIVVHUVRUVSYRYSYFUWJUXFUWSUXBMIZDEUXDUWJ
    UXEVXFDUWJUXEUXBUWRHIZVXFUWJUXEUYOUDEZUXAUWPHIZVXGUWJAUYOUDUYTWMUWJUXLUYDUX
    PVUBUYQVXHVXISUXKUYGUYAUYIVUAUWFUWMUVTUWAUWJJUWPHIZUXAMIUWTUWRHIZUXAMIVXIVX
    GUWJVXJVXKUXAMUWJUXIUYMVXJVXKSUYLVUCUWPUWBWAUWCUWJUXAUWPVUGUYLVUCYTUWJUWTUX
    AUWRVUFVUGUWJUWRUWJUWQUWJUWPUYLYDXPUMZUWJUWRVUDWHZUWDYRYKUWJUXBUWRVUHVXLVXM
    YTYPWMUWJUWSUXBVUEVUHYMYPYS $.


  $( ` ( -u pi (,] pi ) ` is a subset of the reals.  (Contributed by David
     Moews, 28-Feb-2017.) $)
  negpitopissre $p |- ( -u pi (,] pi ) C_ RR $=
    ( cpi cneg cxr wcel cr cioc co wss pire renegcli rexri iocssre mp2an ) ABZC
    DAEDNAFGEHNAIJKINALM $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Mapping of the exponential function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.  $d B x $.  $d C x $.
    efgh.1 $e |- F = ( x e. CC |-> ( exp ` ( A x. x ) ) ) $.
    $( The exponential function of a scaled complex number is a group
       homomorphism from the group of complex numbers under addition to the set
       of complex numbers under multiplication.  (Contributed by Paul Chapman,
       25-Apr-2008.)  (Revised by Mario Carneiro, 11-May-2014.) $)
    efgh $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
                 ( F ` ( B + C ) ) = ( ( F ` B ) x. ( F ` C ) ) ) $=
      ( cc wcel caddc co cmul ce cfv fveq2d wceq mulcl 3adant1 oveq2 fvex fvmpt
      w3a adddi 3adant3 3adant2 efadd syl2anc eqtrd addcl syl oveqan12d 3eqtr4d
      cv ) BGHZCGHZDGHZUAZBCDIJZKJZLMZBCKJZLMZBDKJZLMZKJZUQEMZCEMZDEMZKJZUPUSUT
      VBIJZLMZVDUPURVILBCDUBNUPUTGHZVBGHZVJVDOUMUNVKUOBCPUCUMUOVLUNBDPUDUTVBUEU
      FUGUPUQGHZVEUSOUNUOVMUMCDUHQAUQBAULZKJZLMZUSGEVNUQOVOURLVNUQBKRNFURLSTUIU
      NUOVHVDOUMUNUOVFVAVGVCKACVPVAGEVNCOVOUTLVNCBKRNFUTLSTADVPVCGEVNDOVOVBLVND
      BKRNFVBLSTUJQUK $.
  $}

  ${
    $d y z $.  $d y A $.  $d y D $.
    efif1olem1.1 $e |- D = ( A (,] ( A + ( 2 x. pi ) ) ) $.
    $( Lemma for ~ efif1o .  (Contributed by Mario Carneiro, 13-May-2014.) $)
    efif1olem1 $p |- ( ( A e. RR /\ ( x e. D /\ y e. D ) ) ->
                         ( abs ` ( x - y ) ) < ( 2 x. pi ) ) $=
      ( cr wcel cv wa cmin co c2 cpi clt wbr caddc cle w3a readdcl sylancl cabs
      cfv cmul cioc simprr syl6eleq cxr wb rexr adantr 2re pire remulcli elioc2
      simpl syl2anc mpbid simp1d simprl simp3d simp2d ltadd1dd ltsubaddd mpbird
      a1i lelttrd absdifltd mpbir2and ) CFGZAHZDGZBHZDGZIZIZVJVLJKUAUBLMUCKZNOV
      LVPJKVJNOZVJVLVPPKZNOVOVQVLVJVPPKZNOVOVLCVPPKZVSVOVLFGZCVLNOZVLVTQOZVOVLC
      VTUDKZGZWAWBWCRZVOVLDWDVIVKVMUEEUFVOCUGGZVTFGZWEWFUHVIWGVNCUIUJZVOVIVPFGZ
      WHVIVNUOZLMUKULUMZCVPSTZCVTVLUNUPUQZURZWMVOVJFGZWJVSFGVOWPCVJNOZVJVTQOZVO
      VJWDGZWPWQWRRZVOVJDWDVIVKVMUSEUFVOWGWHWSWTUHWIWMCVTVJUNUPUQZURZWLVJVPSTVO
      WAWBWCWNUTVOCVJVPWKXBWJVOWLVEZVOWPWQWRXAVAVBVFVOVLVPVJWOXCXBVCVDVOVJVTVRX
      BWMVOWAWJVRFGWOWLVLVPSTVOWPWQWRXAUTVOCVLVPWKWOXCVOWAWBWCWNVAVBVFVOVJVLVPX
      BWOXCVGVH $.

    $( Lemma for ~ efif1o .  (Contributed by Mario Carneiro, 13-May-2014.) $)
    efif1olem2 $p |- ( ( A e. RR /\ z e. RR ) ->
                       E. y e. D ( ( z - y ) / ( 2 x. pi ) ) e. ZZ ) $=
      ( cr wcel c2 cpi cmul co caddc cmin cdiv cz wbr sylancl recnd cc oveq1d
      cv cmo wrex cioc clt cle simpl 2re pire remulcli readdcl crp resubcl 2pos
      wa pipos mulgt0ii elrpii modcl resubcld a1i ltadd2dd ltaddsubd cc0 modge0
      modlt mpbid subge02d cxr w3a wb adantr elioc2 syl2anc mpbir3and syl6eleqr
      rexr c1 cneg cfl cfv modval oveq2d wne gt0ne0ii redivcl mp3an23 syl flcld
      wceq zred remulcl sylancr subsubd recni simpr pnncand subsub4d negsubdi2d
      3eqtrd pncand negeqd eqtr3d neg1cn mulm1i mulcomli syl6eqr subdid 3eqtr2d
      addcl zcnd eqtr4d znegcl ax-mp zsubcl divcan3 eqtrd eqeltrd eleq1d rspcev
      1z oveq2 ) CFGZBUAZFGZUOZCHIJKZLKZCYDMKZYGUBKZMKZDGYDYKMKZYGNKZOGZYDAUAZM
      KZYGNKZOGZADUCYFYKCYHUDKZDYFYKYSGZYKFGZCYKUEPZYKYHUFPZYFYHYJYFYCYGFGZYHFG
      ZYCYEUGZHIUHUIUJZCYGUKQZYFYIFGZYGULGZYJFGCYDUMZYGUUGHIUHUIUNUPUQZURZYIYGU
      SQZUTYFCYJLKYHUEPUUBYFYJYGCUUNUUDYFUUGVAUUFYFUUIUUJYJYGUEPUUKUUMYIYGVFQVB
      YFCYJYHUUFUUNUUHVCVGYFVDYJUFPZUUCYFUUIUUJUUOUUKUUMYIYGVEQYFYHYJUUHUUNVHVG
      YFCVIGZUUEYTUUAUUBUUCVJVKYCUUPYECVQVLUUHCYHYKVMVNVOEVPYFYMVRVSZYIYGNKZVTW
      AZMKZOYFYMYGUUTJKZYGNKZUUTYFYLUVAYGNYFYLYDYGYDLKZYGUUSJKZLKZMKYDUVCMKZUVD
      MKZUVAYFYKUVEYDMYFYKYHYIUVDMKZMKYHYIMKZUVDLKUVEYFYJUVHYHMYFUUIUUJYJUVHWJU
      UKUUMYIYGWBQWCYFYHYIUVDYFYHUUHRYFYIUUKRYFUVDYFUUDUUSFGUVDFGUUGYFUUSYFUURY
      FUUIUURFGZUUKUUIUUDYGVDWDZUVJUUGYGUUGUULWEZYIYGWFWGWHWIZWKYGUUSWLWMRZWNYF
      UVIUVCUVDLYFCYGYDYFCUUFRYGSGZYFYGUUGWOZVAZYFYDYCYEWPRZWQTWTWCYFYDUVCUVDUV
      RYFUVOYDSGUVCSGUVPUVRYGYDXJWMZUVNWRYFUVGYGUUQJKZUVDMKUVAYFUVFUVTUVDMYFUVF
      YGVSZUVTYFUVCYDMKZVSUVFUWAYFUVCYDUVSUVRWSYFUWBYGYFYGYDUVQUVRXAXBXCUUQYGUW
      AXDUVPYGUVPXEXFXGTYFYGUUQUUSUVQUUQSGYFXDVAYFUUSUVMXKXHXLXITYFUUTSGZUVBUUT
      WJZYFUUTYFUUQOGZUUSOGUUTOGVROGUWEYAVRXMXNUVMUUQUUSXOWMZXKUWCUVOUVKUWDUVPU
      VLUUTYGXPWGWHXQUWFXRYRYNAYKDYOYKWJZYQYMOUWGYPYLYGNYOYKYDMYBTXSXTVN $.
  $}

  ${
    $d w x y z A $.  $d w x y C $.  $d x y F $.  $d w x y z ph $.  $d y z S $.
    $d w x y z D $.
    efif1o.1 $e |- F = ( w e. D |-> ( exp ` ( _i x. w ) ) ) $.
    efif1o.2 $e |- C = ( `' abs " { 1 } ) $.
    $( Lemma for ~ efif1o .  (Contributed by Mario Carneiro, 8-May-2015.) $)
    efif1olem3 $p |- ( ( ph /\ x e. C ) ->
      ( Im ` ( sqr ` x ) ) e. ( -u 1 [,] 1 ) ) $=
      ( wcel wa cfv cr c1 cle wbr co cc cabs wceq c2 cv csqr cim cneg cicc ccnv
      csn cima simpr syl6eleq wf wfn absf ffn fniniseg mp2b sylib simpld sqrcld
      wb imcld absimle syl cexp sqsqrd fveq2d cn0 absexp sylancl simprd 3eqtr3d
      2nn0 sq1 syl6eqr cc0 abscld absge0d 1re 0le1 sq11 mpanr12 syl2anc breqtrd
      mpbid absle renegcli elicc2i syl3anbrc ) ABUAZDIZJZWIUBKZUCKZLIZMUDZWMNOZ
      WMMNOZWMWOMUEPIWKWLWKWIWKWIQIZWIRKZMSZWKWIRUFMUGUHZIZWRWTJZWKWIDXAAWJUIHU
      JQLRUKRQULXBXCUTUMQLRUNQMWIRUOUPUQZURZUSZVAZWKWPWQWKWMRKZMNOZWPWQJZWKXHWL
      RKZMNWKWLQIZXHXKNOXFWLVBVCWKXKTVDPZMTVDPZSZXKMSZWKXMMXNWKWLTVDPZRKZWSXMMW
      KXQWIRWKWIXEVEVFWKXLTVGIXRXMSXFVLWLTVHVIWKWRWTXDVJVKVMVNWKXKLIZVOXKNOZXOX
      PUTZWKWLXFVPWKWLXFVQXSXTJMLIZVOMNOYAVRVSXKMVTWAWBWDWCWKWNYBXIXJUTXGVRWMMW
      EVIWDZURWKWPWQYCVJWOMWMMVRWFVRWGWH $.

    ${
      efif1olem4.3 $e |- ( ph -> D C_ RR ) $.
      efif1olem4.4 $e |- ( ( ph /\ ( x e. D /\ y e. D ) ) ->
                           ( abs ` ( x - y ) ) < ( 2 x. pi ) ) $.
      efif1olem4.5 $e |- ( ( ph /\ z e. RR ) ->
                           E. y e. D ( ( z - y ) / ( 2 x. pi ) ) e. ZZ ) $.
      efif1olem4.6 $e |- S = ( sin |` ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ) $.
      $( The exponential function of an imaginary number maps any interval of
         length ` 2 pi ` one-to-one onto the unit circle.  (Contributed by Paul
         Chapman, 16-Mar-2008.)  (Proof shortened by Mario Carneiro,
         13-May-2014.) $)
      efif1olem4 $p |- ( ph -> F : D -1-1-onto-> C ) $=
        ( cfv wceq ci co wcel wf1 wfo wf1o wf cv weq wi wral cmul ce wa cr cabs
        sselda ccnv c1 csn cima cc ax-icn recn mulcl sylancr efcl syl absefi wb
        wfn absf ffn ax-mp fniniseg sylanbrc syl6eleqr fmptd wss simplrl sseldd
        ad2antrr recnd simplrr cmin cpi cdiv cc0 subcld wne pire remulcli recni
        c2 2re 2pos pipos mulgt0ii gt0ne0ii divcl mp3an23 clt wbr absdiv ltleii
        cle 0re absid mp2an oveq2i adantr pm3.2i cn0 divcan5 a1i subdid syl2anc
        cz fveq2d simpr oveq2 fvex fvmpt 3eqtr3d efeq1 mpbid eqeltrrd wrex cneg
        3eqtrd cicc csin ralrimiva oveq1 oveq1d eleq1d caddc eqtrd cexp sylancl
        halfpire oveq12d sqcld syl6eq mulid1i syl6breqr abscld ltdivmul eqbrtrd
        1re mpbird efsub efne0 diveq1bd nn0abscl nn0lt10b abs00d diveq0 subeq0d
        ine0 ex ralrimivva dff13 csqr renegcli iccssre efif1olem3 cres resinf1o
        cim f1oeq1 mpbir f1ocnv f1of mp2b ffvelrni sseldi remulcl rexbidv rspcv
        sylc npcand efadd 2cn mul12 mp3an12 2z efexp ccos cre recoscld syl6eleq
        sylib simpld sqrcld recld cosq14ge0 sqrrege0d sqsqrd 2nn0 absexp simprd
        sincossq absvalsq2d 3eqtr2d fveq1i fvres syl5eq f1ocnvfv2 eqtr3d sincld
        coscld pncan2d pncand sq11d oveq2d efival replimd 3eqtr4d syl5ib bitr2d
        mulid2d eqeq12d adantl eqeq2d 3imtr4d reximdva mpd dffo3 df-f1o ) AGFIU
        AZGFIUBZGFIUCAGFIUDZBUEZIPZCUEZIPZQZBCUFZUGZCGUHBGUHUYHAEGREUEZUISZUJPZ
        FIAUYRGTUKUYRULTZUYTFTAGULUYRLUNVUAUYTUMUOUPUQURZFVUAUYTUSTZUYTUMPUPQZU
        YTVUBTZVUAUYSUSTZVUCVUARUSTZUYRUSTVUFUTUYRVARUYRVBVCUYSVDVEUYRVFUMUSVHZ
        VUEVUCVUDUKVGUSULUMUDVUHVIUSULUMVJVKZUSUPUYTUMVLVKVMKVNVEJVOZAUYQBCGGAU
        YKGTZUYMGTZUKZUKZUYOUYPVUNUYOUKZUYKUYMVUOUYKVUOGULUYKAGULVPZVUMUYOLVSZA
        VUKVULUYOVQZVRVTZVUOUYMVUOGULUYMVUQAVUKVULUYOWAZVRVTZVUOUYKUYMWBSZWKWCU
        ISZWDSZWEQZVVBWEQZVUOVVDVUOVVBUSTZVVDUSTZVUOUYKUYMVUSVVAWFZVVGVVCUSTZVV
        CWEWGZVVHVVCWKWCWLWHWIZWJZVVCVVLWKWCWLWHWMWNWOZWPZVVBVVCWQWRVEVUOVVDUMP
        ZUPWSWTZVVPWEQZVUOVVPVVBUMPZVVCWDSZUPWSVUOVVPVVSVVCUMPZWDSZVVTVUOVVGVVP
        VWBQZVVIVVGVVJVVKVWCVVMVVOVVBVVCXAWRVEVWAVVCVVSWDVVCULTZWEVVCXCWTVWAVVC
        QVVLWEVVCXDVVLVVNXBVVCXEXFXGUUAVUOVVTUPWSWTZVVSVVCUPUISZWSWTZVUOVVSVVCV
        WFWSVUNVVSVVCWSWTUYOMXHVVCVVMUUBUUCVUOVVSULTZVWEVWGVGZVUOVVBVVIUUDVWHUP
        ULTVWDWEVVCWSWTZUKVWIUUGVWDVWJVVLVVNXIVVSUPVVCUUEWRVEUUHUUFVUOVVPXJTZVV
        QVVRVGVUOVVDXOTVWKVUORVVBUISZRVVCUISZWDSZVVDXOVUOVVGVWNVVDQZVVIVVGVVJVV
        KUKZVUGRWEWGZUKZVWOVVJVVKVVMVVOXIZVUGVWQUTUUQXIZVVBVVCRXKWRVEVUOVWLUJPZ
        UPQZVWNXOTZVUOVXARUYKUISZRUYMUISZWBSZUJPZVXDUJPZVXEUJPZWDSZUPVUOVWLVXFU
        JVUORUYKUYMVUGVUOUTXLVUSVVAXMXPVUOVXDUSTZVXEUSTZVXGVXJQVUOVUGUYKUSTZVXK
        UTVUSRUYKVBVCVUOVUGUYMUSTZVXLUTVVARUYMVBZVCZVXDVXEUUIXNVUOVXHVXIVUOVXLV
        XIUSTZVXPVXEVDZVEVUOVXLVXIWEWGVXPVXEUUJVEVUOUYLUYNVXHVXIVUNUYOXQVUOVUKU
        YLVXHQVUREUYKUYTVXHGIEBUFUYSVXDUJUYRUYKRUIXRXPJVXDUJXSXTVEVUOVULUYNVXIQ
        ZVUTEUYMUYTVXIGIECUFUYSVXEUJUYRUYMRUIXRXPJVXEUJXSXTZVEYAUUKYGVUOVWLUSTZ
        VXBVXCVGVUOVUGVVGVYAUTVVIRVVBVBVCVWLYBVEYCYDVVDUULVEVVPUUMVEYCUUNVUOVVG
        VVEVVFVGZVVIVVGVVJVVKVYBVVMVVOVVBVVCUUOWRVEYCUUPUURUUSBCGFIUUTVMAUYJUYK
        UYNQZCGYEZBFUHUYIVUJAVYDBFAUYKFTZUKZWKUYKUVAPZUVGPZHUOZPZUISZUYMWBSZVVC
        WDSZXOTZCGYEZVYDVYFVYKULTZDUEZUYMWBSZVVCWDSZXOTZCGYEZDULUHZVYOVYFWKULTV
        YJULTVYPWLVYFWCWKWDSZYFZWUCYHSZULVYJWUDULTWUCULTWUEULVPWUCYRUVBYRWUDWUC
        UVCXFVYFVYHUPYFUPYHSZTZVYJWUETZABEFGIJKUVDZWUFWUEVYHVYIWUEWUFHUCZWUFWUE
        VYIUCWUFWUEVYIUDWUJWUEWUFYIWUEUVEZUCZUVFHWUKQWUJWULVGOWUEWUFHWUKUVHVKUV
        IZWUEWUFHUVJWUFWUEVYIUVKUVLUVMVEZUVNZWKVYJUVOVCZAWUBVYEAWUADULNYJXHWUAV
        YODVYKULVYQVYKQZVYTVYNCGWUQVYSVYMXOWUQVYRVYLVVCWDVYQVYKUYMWBYKYLYMUVPUV
        QUVRVYFVYNVYCCGVYFVULUKZRVYLUISZUJPZUPQZUYKVXIQZVYNVYCWVAWUTVXIUISZUPVX
        IUISZQWURWVBWUTUPVXIUIYKWURWVCUYKWVDVXIWURWUSVXEYNSZUJPZRVYKUISZUJPZWVC
        UYKWURWVEWVGUJWURWVEWVGVXEWBSZVXEYNSWVGWURWUSWVIVXEYNWURRVYKUYMVUGWURUT
        XLWURVYKVYFVYPVULWUPXHVTZWURUYMWURGULUYMAVUPVYEVULLVSVYFVULXQVRVTZXMYLW
        URWVGVXEWURVUGVYKUSTWVGUSTUTWVJRVYKVBVCWURVUGVXNVXLUTWVKVXOVCZUVSYOXPWU
        RWUSUSTZVXLWVFWVCQWURVUGVYLUSTZWVMUTWURVYKUYMWVJWVKWFZRVYLVBVCZWVLWUSVX
        EUVTXNVYFWVHUYKQVULVYFWVHRVYJUISZUJPZWKYPSZVYGWKYPSZUYKVYFWVHWKWVQUISZU
        JPZWVSVYFWVGWWAUJVYFVYJUSTZWVGWWAQZVYFVYJWUOVTZVUGWKUSTWWCWWDUTUWARWKVY
        JUWBUWCVEXPVYFWVQUSTZWKXOTWWBWVSQVYFVUGWWCWWFUTWWERVYJVBVCUWDWVQWKUWEYQ
        YOVYFWVRVYGWKYPVYFVYJUWFPZRVYJYIPZUISZYNSZVYGUWGPZRVYHUISZYNSWVRVYGVYFW
        WGWWKWWIWWLYNVYFWWGWWKVYFVYJWUOUWHVYFVYGVYFUYKVYFVXMUYKUMPZUPQZVYFUYKVU
        BTZVXMWWNUKZVYFUYKFVUBAVYEXQKUWIVUHWWOWWPVGVUIUSUPUYKUMVLVKUWJZUWKZUWLZ
        UWMZVYFWUHWEWWGXCWTWUNVYJUWNVEVYFUYKWWRUWOVYFWWHWKYPSZWWGWKYPSZYNSZWXAW
        BSWWKWKYPSZVYHWKYPSZYNSZWXEWBSWXBWXDVYFWXCWXFWXAWXEWBVYFWXCUPVYGUMPWKYP
        SZWXFVYFWWCWXCUPQWWEVYJUWTVEVYFWVTUMPZWWMWXGUPVYFWVTUYKUMVYFUYKWWRUWPZX
        PVYFVYGUSTWKXJTWXHWXGQWWSUWQVYGWKUWRYQVYFVXMWWNWWQUWSYAVYFVYGWWSUXAUXBV
        YFWWHVYHWKYPVYFVYJHPZWWHVYHVYFWXJVYJWUKPZWWHVYJHWUKOUXCVYFWUHWXKWWHQWUN
        VYJWUEYIUXDVEUXEVYFWUJWUGWXJVYHQWUMWUIWUEWUFVYHHUXFVCUXGZYLZYSVYFWXAWXB
        VYFWWHVYFVYJWWEUXHYTZVYFWWGVYFVYJWWEUXIYTUXJVYFWXDWXEVYFWWKVYFWWKWWTVTY
        TVYFWXAWXEUSWXMWXNYDUXKYAUXLVYFWWHVYHRUIWXLUXMYSVYFWWCWVRWWJQWWEVYJUXNV
        EVYFVYGWWSUXOUXPYLWXIYGXHYAWURVXIWURVXLVXQWVLVXRVEUXSUXTUXQWURWVAWUSVWM
        WDSZXOTZVYNWURWVMWVAWXPVGWVPWUSYBVEWURWXOVYMXOWURWVNWXOVYMQZWVOWVNVWPVW
        RWXQVWSVWTVYLVVCRXKWRVEYMUXRWURUYNVXIUYKVULVXSVYFVXTUYAUYBUYCUYDUYEYJCB
        GFIUYFVMGFIUYGVM $.
    $}

    efif1o.3 $e |- D = ( A (,] ( A + ( 2 x. pi ) ) ) $.
    $( The exponential function of an imaginary number maps any open-below,
       closed-above interval of length ` 2 pi ` one-to-one onto the unit
       circle.  (Contributed by Paul Chapman, 16-Mar-2008.)  (Revised by Mario
       Carneiro, 13-May-2014.) $)
    efif1o $p |- ( A e. RR -> F : D -1-1-onto-> C ) $=
      ( vx vy vz cr wcel csin cpi c2 cdiv co cneg wbr cicc cres cmul caddc cioc
      cv clt cle w3a cxr wb rexr 2re pire remulcli readdcl mpan2 elioc2 syl2anc
      simp1 syl6bi ssrdv syl5eqss efif1olem1 efif1olem2 eqid efif1olem4 ) BLMZI
      JKACDNOPQRZSVIUARUBZEFGVHDBBPOUCRZUDRZUERZLHVHIVMLVHIUFZVMMZVNLMZBVNUGTZV
      NVLUHTZUIZVPVHBUJMVLLMZVOVSUKBULVHVKLMVTPOUMUNUOBVKUPUQBVLVNURUSVPVQVRUTV
      AVBVCIJBDHVDJKBDHVEVJVFVG $.
  $}

  ${
    $d w x y z A $.  $d x y z C $.  $d x y z D $.  $d x y F $.  $d x y z ph $.
    $d y z S $.
    efifo.1 $e |- F = ( z e. RR |-> ( exp ` ( _i x. z ) ) ) $.
    efifo.2 $e |- C = ( `' abs " { 1 } ) $.
    $( The exponential function of an imaginary number maps the reals onto the
       unit circle.  (Contributed by Mario Carneiro, 13-May-2014.) $)
    efifo $p |- F : RR -onto-> C $=
      ( cr wfo wfn crn wceq ci co wcel cabs c1 cc ax-mp cc0 cioc eqtri wf cv ce
      cmul cfv ccnv csn cima ax-icn recn mulcl sylancr efcl syl absefi absf ffn
      wa wb fniniseg mp2b sylanbrc syl6eleqr fmpti wss frn cpi cres df-ima cmpt
      c2 reseq1i clt wbr cle cxr w3a 0xr 2re pire remulcli elioc2 mp2an simp1bi
      ssriv resmpt rneqi wf1o 0re eqid caddc recni addid2i oveq2i eqcomi efif1o
      f1ofo forn imassrn eqsstr3i eqssi df-fo mpbir2an ) FBCGCFHZCIZBJFBCUAZXDA
      FBKAUBZUDLZUCUEZCDXGFMZXINUFOUGUHZBXJXIPMZXINUEOJZXIXKMZXJXHPMZXLXJKPMXGP
      MXOUIXGUJKXGUKULXHUMUNXGUOPFNUANPHXNXLXMURUSUPPFNUQPOXINUTVAVBEVCVDZFBCUQ
      QXEBXFXEBVEXPFBCVFQBCRVKVGUDLZSLZUHZXEXSCXRVHZIZBCXRVIYAAXRXIVJZIZBXTYBXT
      AFXIVJZXRVHZYBCYDXRDVLXRFVEYEYBJAXRFXGXRMZXJRXGVMVNZXGXQVOVNZRVPMXQFMYFXJ
      YGYHVQUSVRVKVGVSVTWAZRXQXGWBWCWDWEAFXRXIWFQTWGXRBYBWHZXRBYBGYCBJRFMYJWIAR
      BXRYBYBWJERRXQWKLZSLXRYKXQRSXQXQYIWLWMWNWOWPQXRBYBWQXRBYBWRVATTCXRWSWTXAF
      BCXBXC $.
  $}

  ${
    $d w x y z D $.  $d x y z F $.  $d w x y z ph $.  $d x y S $.
    eff1olem.1 $e |- F = ( w e. D |-> ( exp ` ( _i x. w ) ) ) $.
    eff1olem.2 $e |- S = ( `' Im " D ) $.
    eff1olem.3 $e |- ( ph -> D C_ RR ) $.
    eff1olem.4 $e |- ( ( ph /\ ( x e. D /\ y e. D ) ) ->
                       ( abs ` ( x - y ) ) < ( 2 x. pi ) ) $.
    eff1olem.5 $e |- ( ( ph /\ z e. RR ) ->
                       E. y e. D ( ( z - y ) / ( 2 x. pi ) ) e. ZZ ) $.
    $( The exponential function maps the set ` S ` , of complex numbers with
       imaginary part in a real interval of length ` 2 x. pi ` , one-to-one
       onto the nonzero complex numbers.  (Contributed by Paul Chapman,
       16-Apr-2008.)  (Proof shortened by Mario Carneiro, 13-May-2014.) $)
    eff1olem $p |- ( ph -> ( exp |` S ) : S -1-1-onto-> ( CC \ { 0 } ) ) $=
      ( cc ce cfv cr co wceq wcel cc0 cdif cv cabs cres ccnv ci cdiv cmul caddc
      csn wss cmpt cim cima cdm cnvimass imf fdmi eqcomi 3sstr4i wf a1i feqmptd
      eff2 reseq1d resmpt eqtrd ax-mp sseli ffvelrni syl adantl crp wne eldifsn
      wa simpr sylib simpld simprd absrpcld wf1o reeff1o f1ocnv f1of mp2b recnd
      ax-icn adantr c1 csin cpi c2 cneg cicc eqid efif1olem4 3syl abscld divcld
      absne0d absdivd absidm oveq2d dividd 3eqtrd wfn wb absf fniniseg sylanbrc
      ffn ffvelrnd sseldd mulcl sylancr addcld crimd eqeltrd elpreima syl6eleqr
      efadd syl2anc fvres f1ocnvfv2 eqtr3d oveq2 cbvmptv eqtri fvex fvmpt fveq2
      fveq2d oveq12d eqeq2d syl5ibrcom eqtr4d f1ocnvfv1 efcl 3eqtrrd adantrl wi
      divcan2d replimd absef recld imcld divcan3d simprbi eleq2s 3eqtr4d syl2an
      cre efne0 id adantrr impbid f1o2d ) ACBGNUAUKUBZCUCZOPZBUCZUDPZOQUEZUFZPZ
      UGUVCUVDUHRZHUFZPZUIRZUJRZOGUEZGNULZUVMCGUVBUMZSUNUFFUOZUNUPZGNUNFUQJUVQN
      NQUNURUSUTVAZUVNUVMCNUVBUMZGUEUVOUVNOUVSGUVNCNUUTONUUTOVBUVNVEVCVDVFCNGUV
      BVGVHVIUVAGTZUVBUUTTZAUVTUVANTZUWAGNUVAUVRVJZNUUTUVAOVEVKVLVMAUVCUUTTZVQZ
      UVLUVPGUWEUVLNTZUVLUNPZFTZUVLUVPTZUWEUVGUVKUWEUVGUWEUVDVNTZUVGQTZUWEUVCUW
      EUVCNTZUVCUAVOZUWEUWDUWLUWMVQAUWDVRUVCNUAVPVSZVTZUWEUWLUWMUWNWAZWBZVNQUVD
      UVFQVNUVEWCZVNQUVFWCVNQUVFVBWDQVNUVEWEVNQUVFWFWGVKVLZWHZUWEUGNTZUVJNTUVKN
      TZWIUWEUVJUWEFQUVJAFQULUWDKWJUWEUDUFWKUKUOZFUVHUVIAUXCFUVIVBZUWDAFUXCHWCZ
      UXCFUVIWCUXDABCDEUXCFWLWMWNUHRZWOUXFWPRUEZHIUXCWQKLMUXGWQWRZFUXCHWEUXCFUV
      IWFWSWJUWEUVHNTZUVHUDPZWKSZUVHUXCTZUWEUVCUVDUWOUWEUVDUWEUVCUWOWTWHZUWEUVC
      UWOUWPXBZXAUWEUXJUVDUVDUDPZUHRUVDUVDUHRWKUWEUVCUVDUWOUXMUXNXCUWEUXOUVDUVD
      UHUWEUWLUXOUVDSUWOUVCXDVLXEUWEUVDUXMUXNXFXGNQUDVBUDNXHUXLUXIUXKVQXIXJNQUD
      XMNWKUVHUDXKWGXLZXNZXOZWHUGUVJXPXQZXRUWEUWGUVJFUWEUVGUVJUWSUXRXSUXQXTNQUN
      VBZUNNXHZUWIUWFUWHVQXIURNQUNXMZNUVLFUNYAWGXLJYBAUVTUWDVQVQZUVAUVLSZUVCUVB
      SZUYCUYEUYDUVCUVLOPZSZAUWDUYGUVTUWEUYFUVGOPZUVKOPZUIRZUVDUVHUIRUVCUWEUVGN
      TUXBUYFUYJSUWTUXSUVGUVKYCYDUWEUYHUVDUYIUVHUIUWEUVGUVEPZUYHUVDUWEUWKUYKUYH
      SUWSUVGQOYEVLUWEUWRUWJUYKUVDSWDUWQQVNUVDUVEYFXQYGUWEUVJHPZUYIUVHUWEUVJFTU
      YLUYISUXQDUVJUGDUCZUIRZOPZUYIFHUYMUVJSUYNUVKOUYMUVJUGUIYHYNHEFUGEUCZUIRZO
      PZUMDFUYOUMIEDFUYRUYOUYPUYMSUYQUYNOUYPUYMUGUIYHYNYIYJUVKOYKYLVLUWEUXEUXLU
      YLUVHSAUXEUWDUXHWJUXPFUXCUVHHYFYDYGYOUWEUVCUVDUWOUXMUXNUUDUUAUUBUYDUVBUYF
      UVCUVAUVLOYMYPYQAUVTUYEUYDUUCUWDAUVTVQZUYDUYEUVAUVBUDPZUVFPZUGUVBUYTUHRZU
      VIPZUIRZUJRZSUYSUVAUVAUUNPZUGUVAUNPZUIRZUJRZVUEUYSUVAUVTUWBAUWCVMZUUEZUYS
      VUAVUFVUDVUHUJUYSVUAVUFUVEPZUVFPZVUFUYSUYTVULUVFUYSUYTVUFOPZVULUYSUWBUYTV
      UNSVUJUVAUUFVLZUYSVUFQTZVULVUNSUYSUVAVUJUUGZVUFQOYEVLYRYNUYSUWRVUPVUMVUFS
      WDVUQQVNVUFUVEYSXQVHUYSVUCVUGUGUIUYSVUCVUGHPZUVIPZVUGUYSVUBVURUVIUYSVUNVU
      HOPZUIRZVUNUHRVUTVUBVURUYSVUTVUNUYSVUHNTZVUTNTUYSUXAVUGNTVVBWIUYSVUGUYSUV
      AVUJUUHWHUGVUGXPXQZVUHYTVLUYSVUFNTZVUNNTUYSVUFVUQWHZVUFYTVLUYSVVDVUNUAVOV
      VEVUFUUOVLUUIUYSUVBVVAUYTVUNUHUYSUVBVUIOPZVVAUYSUVAVUIOVUKYNUYSVVDVVBVVFV
      VASVVEVVCVUFVUHYCYDVHVUOYOUYSVUGFTZVURVUTSUVTVVGAVVGUVAUVPGUVAUVPTZUWBVVG
      UXTUYAVVHUWBVVGVQXIURUYBNUVAFUNYAWGUUJJUUKZVMEVUGUYRVUTFHUYPVUGSUYQVUHOUY
      PVUGUGUIYHYNIVUHOYKYLVLUULYNAUXEVVGVUSVUGSUVTUXHVVIFUXCVUGHYSUUMVHXEYOYRU
      YEUVLVUEUVAUYEUVGVUAUVKVUDUJUYEUVDUYTUVFUVCUVBUDYMZYNUYEUVJVUCUGUIUYEUVHV
      UBUVIUYEUVCUVBUVDUYTUHUYEUUPVVJYOYNXEYOYPYQUUQUURUUS $.
  $}

  ${
    $d w x y z S $.
    eff1o.1 $e |- S = ( `' Im " ( -u pi (,] pi ) ) $.
    $( The exponential function maps the set ` S ` , of complex numbers with
       imaginary part in the closed-above, open-below interval from ` -u pi `
       to ` pi ` one-to-one onto the nonzero complex numbers.  (Contributed by
       Paul Chapman, 16-Apr-2008.)  (Revised by Mario Carneiro,
       13-May-2014.) $)
    eff1o $p |- ( exp |` S ) : S -1-1-onto-> ( CC \ { 0 } ) $=
      ( vx vy vz vw cpi cneg cr wcel cc ce pire cioc co cmul caddc recni oveq2i
      cc0 csn cdif cres wf1o renegcli ci cfv cmpt eqid cxr rexr iocssre sylancl
      cv wss 2timesi addcli addcomi cmin negsubi wceq pncan mp2an eqtri 3eqtrri
      c2 efif1olem1 efif1olem2 eff1olem ax-mp ) GHZIJZAKTUAUBLAUCUDGMUEZVLCDEFV
      KGNOZAFVNUFFUNPOLUGUHZVOUIBVLVKUJJGIJVNIUOVKUKMVKGULUMCDVKVNGVKVFGPOZQOZV
      KNVQVKGGQOZQOVRVKQOZGVPVRVKQGGMRZUPSVKVRVKVMRGGVTVTUQZURVSVRGUSOZGVRGWAVT
      UTGKJZWCWBGVAVTVTGGVBVCVDVESZVGDEVKVNWDVHVIVJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        The natural logarithm on complex numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c log $.
  $c ^c $.

  $( Extend class notation with the natural logarithm function on complex
     numbers. $)
  clog $a class log $.

  $( Extend class notation with the complex power function. $)
  ccxp $a class ^c $.

  $( Define the natural logarithm function on complex numbers.  See
     ~ http://en.wikipedia.org/wiki/Natural_logarithm ("The natural logarithm
     function can also be defined as the inverse function of the exponential
     function").  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  df-log $a |- log = `' ( exp |` ( `' Im " ( -u pi (,] pi ) ) ) $.

  ${
    $d x y $.
    $( Define the power function on complex numbers.  Note that the value of
       this function when ` x = 0 ` and ` ( Re `` y ) <_ 0 , y =/= 0 ` should
       properly be undefined, but defining it by convention this way simplifies
       the domain.  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
    df-cxp $a |- ^c = ( x e. CC , y e. CC |->
      if ( x = 0 , if ( y = 0 , 1 , 0 ) , ( exp ` ( y x. ( log ` x ) ) ) ) ) $.
  $}

  $( The range of the natural logarithm function, also the principal domain of
     the exponential function.  This allows us to write the longer class
     expression as simply ` ran log ` .  (Contributed by Paul Chapman,
     21-Apr-2008.)  (Revised by Mario Carneiro, 13-May-2014.) $)
  logrn $p |- ran log = ( `' Im " ( -u pi (,] pi ) ) $=
    ( clog crn ce cim ccnv cpi cneg cioc co cima cres df-log rneqi cc0 csn cdif
    cc wf1o wfo wceq eqid eff1o f1ocnv ax-mp f1ofo forn mp2b eqtri ) ABCDEFGFHI
    JZKZEZBZUIAUKLMQNOPZUIUKRZUMUIUKSULUITUIUMUJRUNUIUIUAUBUIUMUJUCUDUMUIUKUEUM
    UIUKUFUGUH $.

  $( Write out the property ` A e. ran log ` explicitly.  (Contributed by Mario
     Carneiro, 1-Apr-2015.) $)
  ellogrn $p |- ( A e. ran log <->
    ( A e. CC /\ -u pi < ( Im ` A ) /\ ( Im ` A ) <_ pi ) ) $=
    ( cim ccnv cpi cneg cioc co cima wcel cc cfv clt wbr wa w3a cr 3anass bitri
    wb pire cle clog crn wf wfn imf elpreima mp2b imcl biantrurd renegcli rexri
    ffn cxr elioc2 mp2an syl6rbbr pm5.32i logrn eleq2i 3bitr4i ) ABCDEZDFGZHZIZ
    AJIZVBABKZLMZVGDUAMZNZNZAUBUCZIVFVHVIOVEVFVGVCIZNZVKJPBUDBJUEVEVNSUFJPBUMJA
    VCBUGUHVFVMVJVFVJVGPIZVJNZVMVFVOVJAUIUJVMVOVHVIOZVPVBUNIDPIVMVQSVBDTUKULTVB
    DVGUOUPVOVHVIQRUQURRVLVDAUSUTVFVHVIQVA $.

  $( The natural logarithm function in terms of the exponential function
     restricted to its principal domain.  (Contributed by Paul Chapman,
     21-Apr-2008.) $)
  dflog2 $p |- log = `' ( exp |` ran log ) $=
    ( clog ce cim ccnv cpi cneg cioc cima cres crn df-log reseq2i cnveqi eqtr4i
    co logrn ) ABCDEFEGOHZIZDBAJZIZDKTRSQBPLMN $.

  $( The range of the natural logarithm function includes the real numbers.
     (Contributed by Paul Chapman, 21-Apr-2008.)  (Proof shortened by Mario
     Carneiro, 1-Apr-2015.) $)
  relogrn $p |- ( A e. RR -> A e. ran log ) $=
    ( cr wcel cpi cneg cim cfv clt wbr cle clog crn recn cc0 pipos pire lt0neg2
    cc wb ax-mp mpbi reim0 syl5breqr 0re ltleii syl6eqbr ellogrn syl3anbrc ) AB
    CZARCDEZAFGZHIUKDJIAKLCAMUIUJNUKHNDHIZUJNHIZODBCULUMSPDQTUAAUBZUCUIUKNDJUNN
    DUDPOUEUFAUGUH $.

  $( The range of the natural logarithm function is a subset of the complex
     numbers.  (Contributed by Mario Carneiro, 13-May-2014.) $)
  logrncn $p |- ( A e. ran log -> A e. CC ) $=
    ( clog crn wcel cc cpi cneg cim cfv clt wbr cle ellogrn simp1bi ) ABCDAEDFG
    AHIZJKOFLKAMN $.

  $( The exponential function restricted to its principal domain maps
     one-to-one onto the nonzero complex numbers.  (Contributed by Paul
     Chapman, 21-Apr-2008.)  (Revised by Mario Carneiro, 13-May-2014.) $)
  eff1o2 $p |- ( exp |` ran log ) : ran log -1-1-onto-> ( CC \ { 0 } ) $=
    ( clog crn logrn eff1o ) ABCD $.

  $( The natural logarithm function maps the nonzero complex numbers one-to-one
     onto its range.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  logf1o $p |- log : ( CC \ { 0 } ) -1-1-onto-> ran log $=
    ( cc cc0 csn cdif clog wf1o ce cres ccnv eff1o2 f1ocnv ax-mp wceq wb dflog2
    crn f1oeq1 mpbir ) ABCDZEPZEFZSTGTHZIZFZTSUBFUDJTSUBKLEUCMUAUDNOSTEUCQLR $.

  $( The natural logarithm function on the positive reals in terms of the real
     exponential function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  dfrelog $p |- ( log |` RR+ ) = `' ( exp |` RR ) $=
    ( vx ce clog crn cres ccnv cr cima crp df-ima wceq relogrn ssriv ax-mp wfun
    wss cv wf1o mpbi dflog2 resabs1 rneqi wfn w3a reeff1o dff1o2 simp3i reseq2i
    3eqtri cnveqi cc cc0 csn cdif logf1o f1ofun funeqi funcnvres eqtr3i reseq1i
    3eqtr4ri ) BCDZEZFZVCGHZEZVDIEBGEZFZCIEVEIVDVEVCGEZDVGDZIVCGJVIVGGVBPVIVGKA
    GVBAQLMBGVBUANZUBVGGUCZVHOZVJIKZGIVGRVLVMVNUDUEGIVGUFSUGUIUHVIFZVHVFVIVGVKU
    JVDOZVOVFKCOZVPUKULUMUNZVBCRVQUOVRVBCUPNCVDTUQSGVCURNUSCVDITUTVA $.

  $( The natural logarithm function maps the positive reals one-to-one onto the
     real numbers.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  relogf1o $p |- ( log |` RR+ ) : RR+ -1-1-onto-> RR $=
    ( vx crp cr clog cres wf1o ce crn ccnv wfun cc0 csn cdif eff1o2 wceq f1oeq1
    cc wb mp2b mpbir wfo dff1o3 simprbi ax-mp reeff1o wss relogrn ssriv resabs1
    cv f1orescnv mp2an dflog2 reseq1 ) BCDBEZFZBCGDHZEZIZBEZFZUSJZCBURCEZFZVAUQ
    QKLMZURFZVBNVFUQVEURUAVBUQVEURUBUCUDVDCBGCEZFZUECUQUFVCVGOVDVHRACUQAUJUGUHG
    CUQUICBVCVGPSTBCURUKULDUSOUOUTOUPVARUMDUSBUNBCUOUTPST $.

  $( Closure of the natural logarithm function.  (Contributed by Paul Chapman,
     21-Apr-2008.) $)
  logrncl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( log ` A ) e. ran log ) $=
    ( cc wcel cc0 wne wa csn cdif clog cfv eldifsn wf1o wf logf1o f1of ffvelrni
    crn ax-mp sylbir ) ABCADEFABDGHZCAIJIQZCABDKTUAAITUAILTUAIMNTUAIORPS $.

  $( Closure of the natural logarithm function.  (Contributed by NM,
     21-Apr-2008.)  (Revised by Mario Carneiro, 23-Sep-2014.) $)
  logcl $p |- ( ( A e. CC /\ A =/= 0 ) -> ( log ` A ) e. CC ) $=
    ( cc wcel cc0 wne wa clog cfv crn logrncl logrncn syl ) ABCADEFAGHZGICMBCAJ
    MKL $.

  $( Closure of the imaginary part of the logarithm function.  (Contributed by
     Mario Carneiro, 23-Sep-2014.)  (Revised by Mario Carneiro, 1-Apr-2015.) $)
  logimcl $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( -u pi < ( Im ` ( log ` A ) ) /\ ( Im ` ( log ` A ) ) <_ pi ) ) $=
    ( cc wcel cc0 wne clog cfv cpi cneg cim clt wbr cle w3a crn logrncl ellogrn
    wa sylib 3simpc syl ) ABCADERZAFGZBCZHIUCJGZKLZUEHMLZNZUFUGRUBUCFOCUHAPUCQS
    UDUFUGTUA $.


  ${
    logcld.1 $e |- ( ph -> X e. CC ) $.
    logcld.2 $e |- ( ph -> X =/= 0 ) $.
    $( The logarithm of a nonzero complex number is a complex number.
       Deduction form of ~ logcl .  (Contributed by David Moews,
       28-Feb-2017.) $)
    logcld $p |- ( ph -> ( log ` X ) e. CC ) $=
      ( cc wcel cc0 wne clog cfv logcl syl2anc ) ABEFBGHBIJEFCDBKL $.
  $}

  ${
    logimcld.1 $e |- ( ph -> X e. CC ) $.
    logimcld.2 $e |- ( ph -> X =/= 0 ) $.
    $( The imaginary part of the logarithm is in ` ( -u pi (,] pi ) ` .
       Deduction form of ~ logimcl .  Compare ~ logimclad .  (Contributed by
       David Moews, 28-Feb-2017.) $)
    logimcld $p |- ( ph -> ( -u pi < ( Im ` ( log ` X ) ) /\
                                     ( Im ` ( log ` X ) ) <_ pi ) ) $=
      ( cc wcel cc0 wne cpi cneg clog cfv cim clt wbr cle wa logimcl syl2anc )
      ABEFBGHIJBKLMLZNOTIPOQCDBRS $.

    $( The imaginary part of the logarithm is in ` ( -u pi (,] pi ) ` .
       Alternate form of ~ logimcld .  (Contributed by David Moews,
       28-Feb-2017.) $)
    logimclad $p |- ( ph -> ( Im ` ( log ` X ) ) e. ( -u pi (,] pi ) ) $=
      ( clog cfv cim cr wcel cpi cneg clt wbr cle cioc co logcld imcld logimcld
      pire simpld simprd cxr w3a wb renegcli rexri elioc2 mp2an syl3anbrc ) ABE
      FZGFZHIZJKZULLMZULJNMZULUNJOPIZAUKABCDQRAUOUPABCDSZUAAUOUPURUBUNUCIJHIUQU
      MUOUPUDUEUNJTUFUGTUNJULUHUIUJ $.
  $}


  $( The imaginary part of the logarithm function has absolute value less than
     pi.  (Contributed by Mario Carneiro, 3-Jul-2017.) $)
  abslogimle $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( abs ` ( Im ` ( log ` A ) ) ) <_ pi ) $=
    ( cc wcel cc0 wne wa clog cfv cim cabs cpi cle wbr cneg pire renegcld logcl
    cr a1i imcld clt logimcl simpld ltled simprd absled mpbir2and ) ABCADEFZAGH
    ZIHZJHKLMKNZUJLMUJKLMZUHUKUJUHKKRCUHOSZPUHUIAQTZUHUKUJUAMZULAUBZUCUDUHUOULU
    PUEUHUJKUNUMUFUG $.

  $( The range of the natural logarithm is closed under addition with reals.
     (Contributed by Mario Carneiro, 3-Apr-2015.) $)
  logrnaddcl $p |- ( ( A e. ran log /\ B e. RR ) -> ( A + B ) e. ran log ) $=
    ( clog crn cr caddc co cc cpi cim cfv clt wbr cle syl2an ellogrn adantr cc0
    wcel wceq wa cneg logrncn recn addcl simp2bi imadd reim0 adantl imcld recnd
    oveq2d addid1d 3eqtrd breqtrrd simp3bi eqbrtrd syl3anbrc ) ACDZSZBESZUAZABF
    GZHSZIUBZVCJKZLMVFINMVCUSSUTAHSZBHSZVDVAAUCZBUDZABUEOVBVEAJKZVFLUTVEVKLMZVA
    UTVGVLVKINMZAPZUFQVBVFVKBJKZFGZVKRFGVKUTVGVHVFVPTVAVIVJABUGOVBVORVKFVAVORTU
    TBUHUIULVBVKVBVKVBAUTVGVAVIQUJUKUMUNZUOVBVFVKINVQUTVMVAUTVGVLVMVNUPQUQVCPUR
    $.

  $( Closure of the natural logarithm function on positive reals.  (Contributed
     by Steve Rodriguez, 25-Nov-2007.) $)
  relogcl $p |- ( A e. RR+ -> ( log ` A ) e. RR ) $=
    ( crp wcel clog cres cr fvres wf1o wf relogf1o f1of ax-mp ffvelrni eqeltrrd
    cfv ) ABCADBEZOADOFABDGBFAPBFPHBFPIJBFPKLMN $.

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  eflog $p |- ( ( A e. CC /\ A =/= 0 ) -> ( exp ` ( log ` A ) ) = A ) $=
    ( cc wcel cc0 wne wa clog cfv ce crn cres ccnv dflog2 fveq1i fveq2i logrncl
    wceq fvres syl csn cdif eldifsn wf1o eff1o2 f1ocnvfv2 mpan sylbir 3eqtr3a )
    ABCADEFZAGHZIGJZKZHZAULLZHZULHZUJIHZAUJUOULAGUNMNOUIUJUKCUMUQQAPUJUKIRSUIAB
    DTUAZCZUPAQZABDUBUKURULUCUSUTUDUKURAULUEUFUGUH $.

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  reeflog $p |- ( A e. RR+ -> ( exp ` ( log ` A ) ) = A ) $=
    ( crp wcel cc cc0 wne wa clog cfv ce wceq rpcnne0 eflog syl ) ABCADCAEFGAHI
    JIAKALAMN $.

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  logef $p |- ( A e. ran log -> ( log ` ( exp ` A ) ) = A ) $=
    ( clog crn wcel ce cres cfv ccnv dflog2 fveq1i fvres fveq2d cc cc0 csn cdif
    wf1o wceq eff1o2 f1ocnvfv1 mpan 3eqtr3a ) ABCZDZAEUCFZGZBGUFUEHZGZAEGZBGAUF
    BUGIJUDUFUIBAUCEKLUCMNOPZUEQUDUHARSUCUJAUETUAUB $.

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogef $p |- ( A e. RR -> ( log ` ( exp ` A ) ) = A ) $=
    ( cr wcel clog crn ce cfv wceq relogrn logef syl ) ABCADECAFGDGAHAIAJK $.

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Paul Chapman, 21-Apr-2008.) $)
  logeftb $p |- ( ( A e. CC /\ A =/= 0 /\ B e. ran log ) ->
                  ( ( log ` A ) = B <-> ( exp ` B ) = A ) ) $=
    ( cc wcel cc0 wne clog crn cfv wceq ce wb csn cdif eldifsn cres ccnv eqeq1d
    wa fvres adantr eff1o2 f1ocnvfvb mp3an1 bitr3d ancoms dflog2 fveq1i sylanbr
    wf1o eqeq1i syl6rbbr 3impa ) ACDZAEFZBGHZDZAGIZBJZBKIZAJZLZUNUOSACEMNZDZUQV
    BACEOVDUQSVAAKUPPZQZIZBJZUSUQVDVAVHLUQVDSBVEIZAJZVAVHUQVJVALVDUQVIUTABUPKTR
    UAUPVCVEUJUQVDVJVHLUBUPVCBAVEUCUDUEUFURVGBAGVFUGUHUKULUIUM $.

  $( Relationship between the natural logarithm function and the exponential
     function.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogeftb $p |- ( ( A e. RR+ /\ B e. RR ) ->
                    ( ( log ` A ) = B <-> ( exp ` B ) = A ) ) $=
    ( crp wcel cc cc0 wne wa clog crn cfv wceq ce wb cr rpcnne0 relogrn logeftb
    3expa syl2an ) ACDAEDZAFGZHBIJDZAIKBLBMKALNZBODAPBQUAUBUCUDABRST $.

  $( The natural logarithm of ` 1 ` .  One case of Property 1a of [Cohen]
     p. 301.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  log1 $p |- ( log ` 1 ) = 0 $=
    ( c1 clog cfv cc0 wceq ce ef0 crp wcel cr wb 1rp 0re relogeftb mp2an mpbir
    ) ABCDEZDFCAEZGAHIDJIQRKLMADNOP $.

  $( The natural logarithm of ` _e ` .  One case of Property 1b of [Cohen]
     p. 301.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  loge $p |- ( log ` _e ) = 1 $=
    ( ceu clog cfv c1 wceq ce df-e eqcomi crp wcel cr epr relogeftb mp2an mpbir
    wb 1re ) ABCDEZDFCZAEZASGHAIJDKJRTPLQADMNO $.

  $( The natural logarithm of a negative real number.  (Contributed by Mario
     Carneiro, 13-May-2014.)  (Revised by Mario Carneiro, 3-Apr-2015.) $)
  logneg $p |- ( A e. RR+ -> ( log ` -u A ) =
                 ( ( log ` A ) + ( _i x. pi ) ) ) $=
    ( wcel clog cfv ci cpi cmul co ce cneg cc wceq pire sylancl clt wbr cle cc0
    pipos cr crp caddc c1 relogcl recnd ax-icn recni mulcli efadd efipi reeflog
    oveq2i oveq1d syl5eq neg1cn mulcom mulm1d eqtrd 3eqtrd fveq2d crn cim addcl
    rpcn wb lt0neg2 ax-mp mpbi renegcli 0re lttri mp2an crim syl5breqr syl6eqbr
    leidi ellogrn syl3anbrc logef syl eqtr3d ) AUABZACDZEFGHZUBHZIDZCDZAJZCDWEW
    BWFWHCWBWFWCIDZWDIDZGHZAUCJZGHZWHWBWCKBZWDKBZWFWKLWBWCAUDZUEZEFUFFMUGUHZWCW
    DUINWBWKWIWLGHWMWJWLWIGUJULWBWIAWLGAUKUMUNWBWMWLAGHZWHWBAKBWLKBWMWSLAVDZUOA
    WLUPNWBAWTUQURUSUTWBWECVABZWGWELWBWEKBZFJZWEVBDZOPXDFQPXAWBWNWOXBWQWRWCWDVC
    NWBXCFXDOXCROPZRFOPZXCFOPXFXESFTBZXFXEVEMFVFVGVHSXCRFFMVIVJMVKVLWBWCTBXGXDF
    LWPMWCFVMNZVNWBXDFFQXHFMVPVOWEVQVRWEVSVTWA $.

  $( The natural logarithm of negative ` 1 ` .  (Contributed by Paul Chapman,
     21-Apr-2008.)  (Revised by Mario Carneiro, 13-May-2014.) $)
  logm1 $p |- ( log ` -u 1 ) = ( _i x. pi ) $=
    ( c1 cneg clog cfv ci cpi cmul co caddc cc0 crp wcel wceq logneg ax-mp log1
    1rp oveq1i ax-icn pire recni mulcli addid2i 3eqtri ) ABCDZACDZEFGHZIHZJUGIH
    UGAKLUEUHMQANOUFJUGIPRUGEFSFTUAUBUCUD $.

  $( If a number has imaginary part equal to ` pi ` , then it is on the
     negative real axis and vice-versa.  (Contributed by Mario Carneiro,
     23-Sep-2014.) $)
  lognegb $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( -u A e. RR+ <-> ( Im ` ( log ` A ) ) = pi ) ) $=
    ( cc wcel cneg crp clog cfv cim cpi wceq ci cmul co caddc fveq2d cr sylancl
    eqtrd ce recnd cc0 wne logneg relogcl pire crim negneg adantr eqeq1d syl5ib
    wa cre logcl replimd eflog recld ax-icn imcld mulcl sylancr syl2anc 3eqtr3d
    efadd oveq2 efipi syl6eq oveq2d eqeq2d syl5ibcom rpcnd neg1cn mulcom mulm1d
    c1 rpefcld negeqd negnegd eqeltrd negeq eleq1d syl5ibrcom syld impbid ) ABC
    ZAUAUBZUKZADZECZAFGZHGZIJZWHWGDZFGZHGZIJWFWKWHWNWGFGZKILMZNMZHGZIWHWMWQHWGU
    COWHWOPCIPCWRIJWGUDUEWOIUFQRWFWNWJIWFWMWIHWFWLAFWDWLAJWEAUGUHOOUIUJWFWKAWIU
    LGZSGZVNDZLMZJZWHWFAWTKWJLMZSGZLMZJWKXCWFWISGWSXDNMZSGZAXFWFWIXGSWFWIAUMZUN
    OAUOWFWSBCXDBCZXHXFJWFWSWFWIXIUPZTWFKBCWJBCXJUQWFWJWFWIXIURTKWJUSUTWSXDVCVA
    VBWKXFXBAWKXEXAWTLWKXEWPSGXAWKXDWPSWJIKLVDOVEVFVGVHVIWFWHXCXBDZECWFXLWTEWFX
    LWTDZDWTWFXBXMWFXBXAWTLMZXMWFWTBCXABCXBXNJWFWTWFWSXKVOZVJZVKWTXAVLQWFWTXPVM
    RVPWFWTXPVQRXOVRXCWGXLEAXBVSVTWAWBWC $.

  ${
    relogoprlem.1 $e |- ( ( ( log ` A ) e. CC /\ ( log ` B ) e. CC ) ->
                        ( exp ` ( ( log ` A ) F ( log ` B ) ) ) =
                        ( ( exp ` ( log ` A ) ) G ( exp ` ( log ` B ) ) ) ) $.
    relogoprlem.2 $e |- ( ( ( log ` A ) e. RR /\ ( log ` B ) e. RR ) ->
                          ( ( log ` A ) F ( log ` B ) ) e. RR ) $.
    $( Lemma for ~ relogmul and ~ relogdiv .  Remark of [Cohen] p. 301 ("The
       proof of Property 3 is quite similar to the proof given for Property
       2").  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
    relogoprlem $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
        ( log ` ( A G B ) ) = ( ( log ` A ) F ( log ` B ) ) ) $=
      ( crp wcel wa clog cfv ce co reeflog fveq2d cr wceq relogcl cc recn syl
      oveqan12d syl2an relogef eqtr3d ) AGHZBGHZIZAJKZLKZBJKZLKZDMZJKZABDMZJKUI
      UKCMZUHUMUOJUFUGUJAULBDANBNUBOUFUIPHZUKPHZUNUPQUGARBRUQURIZUPLKZJKZUNUPUQ
      UISHZUKSHZVAUNQURUITUKTVBVCIUTUMJEOUCUSUPPHVAUPQFUPUDUAUEUCUE $.
  $}

  $( The natural logarithm of the product of two positive real numbers is the
     sum of natural logarithms.  Property 2 of [Cohen] p. 301, restricted to
     natural logarithms.  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogmul $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
                    ( log ` ( A x. B ) ) = ( ( log ` A ) + ( log ` B ) ) ) $=
    ( caddc cmul clog cfv efadd readdcl relogoprlem ) ABCDAEFZBEFZGJKHI $.

  $( The natural logarithm of the quotient of two positive real numbers is the
     difference of natural logarithms.  Exercise 72(a) and Property 3 of
     [Cohen] p. 301, restricted to natural logarithms.  (Contributed by Steve
     Rodriguez, 25-Nov-2007.) $)
  relogdiv $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
                    ( log ` ( A / B ) ) = ( ( log ` A ) - ( log ` B ) ) ) $=
    ( cmin cdiv clog cfv efsub resubcl relogoprlem ) ABCDAEFZBEFZGJKHI $.

  $( Exponentiation of a nonzero complex number to an integer power.
     (Contributed by Paul Chapman, 21-Apr-2008.) $)
  explog $p |- ( ( A e. CC /\ A =/= 0 /\ N e. ZZ ) ->
                  ( A ^ N ) = ( exp ` ( N x. ( log ` A ) ) ) ) $=
    ( cc wcel cc0 wne cz w3a clog cfv cmul co ce cexp logcl 3adant3 simp3 efexp
    wceq syl2anc eflog oveq1d eqtr2d ) ACDZAEFZBGDZHZBAIJZKLMJZUHMJZBNLZABNLUGU
    HCDZUFUIUKSUDUEULUFAOPUDUEUFQUHBRTUGUJABNUDUEUJASUFAUAPUBUC $.

  $( Exponentiation of a positive real number to an integer power.
     (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  reexplog $p |- ( ( A e. RR+ /\ N e. ZZ ) ->
                    ( A ^ N ) = ( exp ` ( N x. ( log ` A ) ) ) ) $=
    ( crp wcel cz wa clog cfv cmul co ce cexp cc wceq relogcl recnd efexp sylan
    reeflog oveq1d adantr eqtr2d ) ACDZBEDZFBAGHZIJKHZUEKHZBLJZABLJZUCUEMDUDUFU
    HNUCUEAOPUEBQRUCUHUINUDUCUGABLASTUAUB $.

  $( The natural logarithm of positive ` A ` raised to an integer power.
     Property 4 of [Cohen] p. 301-302, restricted to natural logarithms and
     integer powers ` N ` .  (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
  relogexp $p |- ( ( A e. RR+ /\ N e. ZZ ) ->
                    ( log ` ( A ^ N ) ) = ( N x. ( log ` A ) ) ) $=
    ( crp wcel cz wa clog cfv cmul co ce cexp cc wceq relogcl recnd efexp sylan
    reeflog cr oveq1d adantr eqtrd fveq2d zre remulcl syl2anr relogef eqtr3d
    syl ) ACDZBEDZFZBAGHZIJZKHZGHZABLJZGHUOUMUPURGUMUPUNKHZBLJZURUKUNMDULUPUTNU
    KUNAOZPUNBQRUKUTURNULUKUSABLASUAUBUCUDUMUOTDZUQUONULBTDUNTDVBUKBUEVABUNUFUG
    UOUHUJUI $.

  $( Real part of a logarithm.  (Contributed by Mario Carneiro,
     15-Sep-2014.) $)
  relog $p |- ( ( A e. CC /\ A =/= 0 ) ->
                  ( Re ` ( log ` A ) ) = ( log ` ( abs ` A ) ) ) $=
    ( cc wcel cc0 wne wa clog cfv cre ce cabs cr wceq logcl recld relogef absef
    syl fveq2d eqtr3d eflog ) ABCADEFZAGHZIHZJHZGHZUDAKHZGHUBUDLCUFUDMUBUCANZOU
    DPRUBUEUGGUBUCJHZKHZUEUGUBUCBCUJUEMUHUCQRUBUIAKAUASTST $.

  $( The natural logarithm function on positive reals determines an isomorphism
     from the positive reals onto the reals.  (Contributed by Steve Rodriguez,
     25-Nov-2007.) $)
  relogiso $p |- ( log |` RR+ ) Isom < , < ( RR+ , RR ) $=
    ( crp cr clog cres wiso ce ccnv reefiso isocnv ax-mp wceq wb dfrelog isoeq1
    clt mpbir ) ABOOCADZEZABOOFBDZGZEZBAOOSEUAHBAOOSIJQTKRUALMABOOTQNJP $.

  ${
    reloggim.1 $e |- R = ( CCfld |`s RR ) $.
    reloggim.2 $e |- P = ( ( mulGrp ` CCfld ) |`s RR+ ) $.
    $( The natural logarithm is a group isomorphism from the group of positive
       reals under multiplication to the group of reals under addition.
       (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    reloggim $p |- ( log |` RR+ ) e. ( P GrpIso R ) $=
      ( clog crp cres ce cr ccnv cgim dfrelog wcel reefgim gimcnv ax-mp eqeltri
      co ) EFGHIGZJZABKRZLSBAKRMTUAMABCDNBASOPQ $.
  $}

  ${
    $d n x y A $.  $d n y B $.  $d k n N $.
    $( The natural logarithm function on positive reals is strictly monotonic.
       (Contributed by Steve Rodriguez, 25-Nov-2007.) $)
    logltb $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
                    ( A < B <-> ( log ` A ) < ( log ` B ) ) ) $=
      ( vx vy crp wcel wa clt wbr clog cres cv wb wral wceq fveq2 bibi12d fvres
      cfv cr wf1o wiso relogiso df-isom simpri breq1 breq1d breq2 breq2d rspc2v
      mpbi mpi breqan12d bitrd ) AEFZBEFZGZABHIZAJEKZSZBUSSZHIZAJSZBJSZHIUQCLZD
      LZHIZVEUSSZVFUSSZHIZMZDENCENZURVBMZETUSUAZVLETHHUSUBVNVLGUCCDETHHUSUDUKUE
      VKVMAVFHIZUTVIHIZMCDABEEVEAOZVGVOVJVPVEAVFHUFVQVHUTVIHVEAUSPUGQVFBOZVOURV
      PVBVFBAHUHVRVIVAUTHVFBUSPUIQUJULUOUPUTVCVAVDHAEJRBEJRUMUN $.

    $( The logarithm of a factorial can be expressed as a finite sum of logs.
       (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    logfac $p |- ( N e. NN0 ->
      ( log ` ( ! ` N ) ) = sum_ k e. ( 1 ... N ) ( log ` k ) ) $=
      ( vn wcel cn cc0 wceq cfa cfv clog c1 cfz co cv cmul cid caddc crp adantl
      c0 cn0 wo csu elnn0 cseq wa rpmulcl cvv vex fvi ax-mp elfznn syl5eqel cuz
      nnrpd elnnuz biimpi relogmul fveq2i seqhomo facnn fveq2d eqidd cr relogcl
      a1i syl recnd fsumser 3eqtr4d log1 sum0 eqtr4i fveq2 syl6eq oveq2 sumeq1d
      fac0 fz10 3eqtr4a jaoi sylbi ) BUADBEDZBFGZUBBHIZJIZKBLMZANZJIZAUCZGZBUDW
      CWKWDWCBOPKUEIZJIBQJKUEIWFWJWCACOQRPJJKBWHRDZCNZRDUFZWHWNOMZRDWCWHWNUGSWC
      WHWGDZUFZWHPIZWHRWHUHDWSWHGAUIWHUHUJUKZWRWHWQWHEDWCWHBULSUOZUMWCBKUNIDBUP
      UQZWOWPJIWIWNJIQMGWCWHWNURSWSJIWIGWRWSWHJWTUSVFUTWCWEWLJBVAVBWCWIAJKBWRWI
      VCXBWRWIWRWMWIVDDXAWHVEVGVHVIVJWDKJIZTWIAUCZWFWJXCFXDVKWIAVLVMWDWEKJWDWEF
      HIKBFHVNVRVOVBWDWGTWIAWDWGKFLMTBFKLVPVSVOVQVTWAWB $.

    $( Solve an equation involving an exponential.  (Contributed by Mario
       Carneiro, 23-Apr-2015.) $)
    eflogeq $p |- ( ( A e. CC /\ B e. CC /\ B =/= 0 ) -> ( ( exp ` A ) = B <->
      E. n e. ZZ A = ( ( log ` B ) + ( ( _i x. ( 2 x. pi ) ) x. n ) ) ) ) $=
      ( cc wcel cc0 wne ce cfv wceq clog ci c2 cpi cmul co caddc cz cdiv c1 w3a
      cv wrex cmin efcl efne0 logcld efsub mpdan eflog syl2anc oveq2d dividd wb
      3eqtrd subcl efeq1 syl mpbid ax-icn 2cn pire recni mulcli ine0 2ne0 pipos
      a1i gt0ne0ii mulne0i divcan2d pncan3 mpancom eqtr2d oveq2 eqeq2d 3ad2ant1
      rspcev fveq2 oveq1d rexbidv syl5ibcom wa logcl 3adant1 adantr zcn sylancr
      adantl ef2kpi oveqan12d simpl2 mulid1d eqeq1d syl5ibrcom rexlimdva impbid
      mulcl efadd ) ADEZBDEZBFGZUAZAHIZBJZABKIZLMNOPZOPZCUBZOPZQPZJZCRUCZXCAXDK
      IZXJQPZJZCRUCZXEXMWTXAXQXBWTAXNUDPZXHSPZREZAXNXHXSOPZQPZJZXQWTXRHIZTJZXTW
      TYDXDXNHIZSPZXDXDSPTWTXNDEZYDYGJWTXDAUEZAUFZUGZAXNUHUIWTYFXDXDSWTXDDEXDFG
      YFXDJYIYJXDUJUKULWTXDYIYJUMUOWTXRDEZYEXTUNWTYHYLYKAXNUPUIZXRUQURUSWTYBXNX
      RQPZAWTYAXRXNQWTXRXHYMXHDEZWTLXGUTMNVANVBVCZVDZVDZVHXHFGWTLXGUTYQVEMNVAYP
      VFNVBVGVIVJVJVHVKULYHWTYNAJYKXNAVLVMVNXPYCCXSRXIXSJZXOYBAYSXJYAXNQXIXSXHO
      VOULVPVRUKVQXEXPXLCRXEXOXKAXEXNXFXJQXDBKVSVTVPWAWBXCXLXECRXCXIREZWCZXEXLX
      KHIZBJUUAUUBXFHIZXJHIZOPZBTOPBUUAXFDEZXJDEZUUBUUEJXCUUFYTXAXBUUFWTBWDWEWF
      UUAYOXIDEZUUGYRYTUUHXCXIWGWIXHXIWRWHXFXJWSUKXCYTUUCBUUDTOXAXBUUCBJWTBUJWE
      XIWJWKUUABWTXAXBYTWLWMUOXLXDUUBBAXKHVSWNWOWPWQ $.
  $}

  $( Logarithm of a non-1 number is not zero and thus suitable as a divisor.
     (Contributed by Stefan O'Rear, 19-Sep-2014.) $)
  logne0 $p |- ( ( A e. RR+ /\ A =/= 1 ) -> ( log ` A ) =/= 0 ) $=
    ( crp wcel c1 wne wa clog cfv cc0 ce simpr wceq ef0 a1i neeqtrrd necomd 0re
    cr wb relogeftb syldan necon3bid mpbird ) ABCZADEZFZAGHZIEIJHZAEUFAUHUFADUH
    UDUEKUHDLUFMNOPUFUGIUHAUDUEIRCZUGILUHALSUIUFQNAITUAUBUC $.

  $( Natural logarithm preserves ` <_ ` .  (Contributed by Stefan O'Rear,
     19-Sep-2014.) $)
  logleb $p |- ( ( A e. RR+ /\ B e. RR+ ) ->
      ( A <_ B <-> ( log ` A ) <_ ( log ` B ) ) ) $=
    ( crp wcel wa clt wbr wn clog cfv cle wb logltb ancoms notbid cr rpre lenlt
    syl2an relogcl 3bitr4d ) ACDZBCDZEZBAFGZHZBIJZAIJZFGZHZABKGZUHUGKGZUDUEUIUC
    UBUEUILBAMNOUBAPDBPDUKUFLUCAQBQABRSUBUHPDUGPDULUJLUCATBTUHUGRSUA $.

  $( Closure of the logarithm function in the positive reals.  (Contributed by
     Mario Carneiro, 21-Sep-2014.) $)
  rplogcl $p |- ( ( A e. RR /\ 1 < A ) -> ( log ` A ) e. RR+ ) $=
    ( cr wcel c1 clt wbr wa clog cfv crp simpl cc0 0re a1i 1re 0lt1 simpr lttrd
    elrpd relogcl syl log1 wb 1rp logltb sylancr mpbid syl5eqbrr ) ABCZDAEFZGZA
    HIZUKAJCZULBCUKAUIUJKZUKLDALBCUKMNDBCUKONUNLDEFUKPNUIUJQZRSZATUAUKLDHIZULEU
    BUKUJUQULEFZUOUKDJCUMUJURUCUDUPDAUEUFUGUHS $.

  $( The logarithm of a number greater than 1 is nonnegative.  (Contributed by
     Mario Carneiro, 29-May-2016.) $)
  logge0 $p |- ( ( A e. RR /\ 1 <_ A ) -> 0 <_ ( log ` A ) ) $=
    ( cr wcel c1 cle wbr wa cc0 clog cfv log1 simpr crp wb rpgecl mp3an1 logleb
    1rp sylancr mpbid syl5eqbrr ) ABCZDAEFZGZHDIJZAIJZEKUDUCUEUFEFZUBUCLUDDMCZA
    MCZUCUGNRUHUBUCUIRDAOPDAQSTUA $.

  $( The natural logarithm distributes under conjugation away from the branch
     cut.  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  logcj $p |- ( ( A e. CC /\ ( Im ` A ) =/= 0 ) ->
    ( log ` ( * ` A ) ) = ( * ` ( log ` A ) ) ) $=
    ( cc wcel cim cfv cc0 wne ccj clog wceq sylan2 wb adantr cpi clt wbr cle cr
    cneg pire wa fveq2 im0 syl6eq necon3i logcl efcj syl eflog fveq2d eqtrd crn
    cjcl simpr cjne0 mpbid cjcld crp rpre renegcld negneg eleq1d syl5ib lognegb
    ce reim0b 3imtr3d necon3d mpd necomd imcld a1i logimcl simprd leltned ltneg
    mpbird sylancl imcjd breqtrrd wi renegcli sylancr lenegcon1 eqbrtrd ellogrn
    simpld ltle syl3anbrc logeftb syl3anc ) ABCZADEZFGZUAZAHEZIEAIEZHEZJZWRVEEZ
    WPJZWOWTWQVEEZHEZWPWOWQBCZWTXCJWNWLAFGZXDAFWMFAFJWMFDEFAFDUBUCUDUEZAUFKZWQU
    GUHWOXBAHWNWLXEXBAJXFAUIKUJUKWOWPBCZWPFGZWRIULCZWSXALWLXHWNAUMMWOXEXIWOWNXE
    WLWNUNZXFUHWLXEXILWNAUOMUPWOWRBCNSZWRDEZOPXMNQPXJWOWQXGUQWOXLWQDEZSZXMOWOXN
    NOPZXLXOOPZWOXPNXNGWOXNNWOWNXNNGXKWOXNNWMFWOASZURCZARCZXNNJZWMFJZXSXRSZRCWO
    XTXSXRXRUSUTWOYCARWLYCAJWNAVAMVBVCWNWLXEXSYALXFAVDKWLXTYBLWNAVFMVGVHVIVJWOX
    NNWOWQXGVKZNRCZWOTVLWOXLXNOPZXNNQPZWNWLXEYFYGUAXFAVMKZVNVOVQWOXNRCZYEXPXQLY
    DTXNNVPVRUPWOWQXGVSZVTWOXMXONQYJWOXLXNQPZXONQPZWOYFYKWOYFYGYHWGWOXLRCYIYFYK
    WANTWBYDXLXNWHWCVIWOYEYIYKYLLTYDNXNWDWCUPWEWRWFWIWPWRWJWKVQ $.

  $( The exponential of the "arg" function ` Im o. log ` .  (Contributed by
     Mario Carneiro, 25-Feb-2015.) $)
  efiarg $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( exp ` ( _i x. ( Im ` ( log ` A ) ) ) ) = ( A / ( abs ` A ) ) ) $=
    ( cc wcel cc0 wne wa clog cfv cre cmin co ce cdiv ci cim wceq recnd syl2anc
    fveq2d eflog cmul logcl recld efsub caddc replimd eqcomd ax-icn imcld mulcl
    cabs sylancr subaddd mpbird relog abscl adantr absrpcl rpne0d eqtrd oveq12d
    cr 3eqtr3d ) ABCZADEZFZAGHZVGIHZJKZLHZVGLHZVHLHZMKZNVGOHZUAKZLHAAUKHZMKVFVG
    BCVHBCVJVMPAUBZVFVHVFVGVQUCQZVGVHUDRVFVIVOLVFVIVOPVHVOUEKZVGPVFVGVSVFVGVQUF
    UGVFVGVHVOVQVRVFNBCVNBCVOBCUHVFVNVFVGVQUIQNVNUJULUMUNSVFVKAVLVPMATVFVLVPGHZ
    LHZVPVFVHVTLAUOSVFVPBCVPDEWAVPPVFVPVDVPVBCVEAUPUQQVFVPAURUSVPTRUTVAVC $.

  ${
    cosargd.1 $e |- ( ph -> X e. CC ) $.
    cosargd.2 $e |- ( ph -> X =/= 0 ) $.
    $( The cosine of the argument is the quotient of the real part and the
       absolute value.  Compare to ~ efiarg .  (Contributed by David Moews,
       28-Feb-2017.) $)
    cosargd $p |- ( ph -> ( cos ` ( Im ` ( log ` X ) ) ) =
                          ( ( Re ` X ) / ( abs ` X ) ) ) $=
      ( ccj cfv caddc co cdiv c2 recnd cc wcel a1i cc0 ci cmul ce wceq syl cabs
      clog cim ccos cre cjcld addcld abscld 2cn absne0d wne 2ne0 divdiv32d cneg
      logcld imcld cosval efiarg syl2anc ax-icn mulcld cjmuld cji cjred oveq12d
      eqtrd fveq2d 3eqtr3d cjdivd oveq2d 3eqtrd divdird eqtr4d oveq1d 3eqtr4d
      efcj reval ) ABBEFZGHZBUAFZIHZJIHZVSJIHZVTIHBUBFZUCFZUDFZBUEFZVTIHAVSVTJA
      BVRCABCUFZUGAVTABCUHZKZJLMAUINABCDUJZJOUKAULNUMAWFPWEQHZRFZPUNZWEQHZRFZGH
      ZJIHZWBAWELMWFWRSAWEAWDABCDUOUPZKZWEUQTAWQWAJIAWQBVTIHZVRVTIHZGHWAAWMXAWP
      XBGABLMZBOUKWMXASCDBURUSZAWPXAEFZVRVTEFZIHXBAWLEFZRFZWMEFZWPXEAWLLMXHXISA
      PWEPLMAUTNZWTVAWLVPTAXGWORAXGPEFZWEEFZQHWOAPWEXJWTVBAXKWNXLWEQXKWNSAVCNAW
      EWSVDVEVFVGAWMXAEXDVGVHABVTCWJWKVIAXFVTVRIAVTWIVDVJVKVEABVRVTCWHWJWKVLVMV
      NVFAWGWCVTIAXCWGWCSCBVQTVNVO $.

    $( The cosine of the argument is zero precisely on the imaginary axis.
       (Contributed by David Moews, 28-Feb-2017.) $)
    cosarg0d $p |- ( ph -> ( ( cos ` ( Im ` ( log ` X ) ) ) = 0 <->
                           ( Re ` X ) = 0 ) ) $=
      ( clog cfv cim ccos cc0 wceq cre cabs cdiv co cosargd eqeq1d recld abscld
      recnd absne0d diveq0ad bitrd ) ABEFGFHFZIJBKFZBLFZMNZIJUDIJAUCUFIABCDOPAU
      DUEAUDABCQSAUEABCRSABCDTUAUB $.
  $}

  $( Closure of the argument of a complex number with positive real part.
     (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  argregt0 $p |- ( ( A e. CC /\ 0 < ( Re ` A ) ) ->
    ( Im ` ( log ` A ) ) e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) $=
    ( wcel cc0 cre cfv clt wbr wa cr cpi wceq syl syldan ccos cmul cle halfpire
    co wb pire cc clog cim c2 cdiv cneg cioo wne recl gt0ne0 sylan fveq2 syl6eq
    re0 necon3i logcl imcld cabs coshalfpi ci ce simpr abscl adantr recnd simpl
    mul01d crp absrpcl rpne0d divcld remul2d divcan2d fveq2d eqtr3d 3brtr4d 0re
    a1i ltmul2d mpbird efiarg breqtrrd recosval cosneg eqeq1d syl5ibrcom absord
    recld mpjaod syl5eqbr cicc absge0d logimcl simpld renegcli ltle sylancr mpd
    simprd absle sylancl mpbir2and elicc2i syl3anbrc pipos elrpii rphalfcl mp2b
    wi rpge0 rphalflt ax-mp ltleii mpbir3an cosord abslt mpbid cxr rexri elioo2
    w3a mp2an ) AUABZCADEZFGZHZAUBEZUCEZIBZJUDUERZUFZYHFGZYHYJFGZYHYKYJUGRBZYFY
    GYCYEACUHZYGUABYFYDCUHZYOYCYDIBYEYPAUIYDUJUKACYDCACKYDCDECACDULUNUMUOLZAUPM
    UQZYFYLYMYFYHUREZYJFGZYLYMHZYFYTYJNEZYSNEZFGZYFUUBCUUCFUSYFCYHNEZUUCFYFCUTY
    HORVAEZDEZUUEFYFCAAUREZUERZDEZUUGFYFCUUJFGUUHCORZUUHUUJORZFGYFCYDUUKUULFYCY
    EVBYFUUHYFUUHYCUUHIBYEAVCVDZVEZVGYFUUHUUIORZDEUULYDYFUUHUUIUUMYFAUUHYCYEVFZ
    UUNYFUUHYCYEYOUUHVHBYQAVIMZVJZVKZVLYFUUOADYFAUUHUUPUUNUURVMVNVOVPYFCUUJUUHC
    IBYFVQVRYFUUIUUSWHUUQVSVTYFUUFUUIDYCYEYOUUFUUIKYQAWAMVNWBYFYIUUEUUGKYRYHWCL
    WBYFYSYHKZUUCUUEKZYSYHUFZKZUUTUVAXIYFYSYHNULVRYFUVAUVCUVBNEZUUEKZYFYHUABZUV
    EYFYHYRVEZYHWDLUVCUUCUVDUUEYSUVBNULWEWFYFYHYRWGWIWBWJYFYSCJWKRZBZYJUVHBZYTU
    UDSYFYSIBZCYSPGYSJPGZUVIYFUVFUVKUVGYHVCLYFYHUVGWLYFUVLJUFZYHPGZYHJPGZYFUVMY
    HFGZUVNYFUVPUVOYCYEYOUVPUVOHYQAWMMZWNYFUVMIBYIUVPUVNXIJTWOYRUVMYHWPWQWRYFUV
    PUVOUVQWSYFYIJIBUVLUVNUVOHSYRTYHJWTXAXBCJYSVQTXCXDUVJYJIBZCYJPGZYJJPGQJVHBZ
    YJVHBUVSJTXEXFZJXGYJXJXHYJJQTUVTYJJFGUWAJXKXLXMCJYJVQTXCXNYSYJXOXAVTYFYIUVR
    YTUUASYRQYHYJXPXAXQZWNYFYLYMUWBWSYKXRBYJXRBYNYIYLYMYASYKYJQWOXSYJQXSYKYJYHX
    TYBXD $.

  $( Closure of the argument of a complex number with nonnegative real part.
     (Contributed by Mario Carneiro, 2-Apr-2015.) $)
  argrege0 $p |- ( ( A e. CC /\ A =/= 0 /\ 0 <_ ( Re ` A ) ) ->
    ( Im ` ( log ` A ) ) e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ) $=
    ( cc wcel cc0 cre cfv cle wbr cr cpi co 3adant3 ccos cmul 0re wceq halfpire
    clt wb pire wne w3a clog cim c2 cdiv cneg cicc logcl imcld cabs wa ci simp3
    simp1 abscld recnd mul01d crp absrpcl rpne0d divcld remul2d divcan2d fveq2d
    eqtr3d 3brtr4d a1i recld lemul2d mpbird efiarg breqtrrd recosval syl elrpii
    ce pipos rphalfcl rpge0 mp2b rphalflt ax-mp ltleii elicc2i mpbir3an absge0d
    wn logimcl simpld wi renegcli ltle sylancr simprd absle mpbir2and syl3anbrc
    mpd sylancl cosord cosneg eqeq1d syl5ibrcom absord mpjaod coshalfpi breq12d
    fveq2 bitrd notbid lenlt recoscld 3bitr4d mpbid ) ABCZADUAZDAEFZGHZUBZAUCFZ
    UDFZICZJUEUFKZUGZYBGHZYBYDGHZYBYEYDUHKCXTYAXPXQYABCXSAUILUJZXTYFYGXTYBUKFZY
    DGHZYFYGULZXTYJDYBMFZGHZXTDUMYBNKVQFZEFZYLGXTDAAUKFZUFKZEFZYOGXTDYRGHYPDNKZ
    YPYRNKZGHXTDXRYSYTGXPXQXSUNXTYPXTYPXTAXPXQXSUOZUPZUQZURXTYPYQNKZEFYTXRXTYPY
    QUUBXTAYPUUAUUCXTYPXPXQYPUSCXSAUTLZVAZVBZVCXTUUDAEXTAYPUUAUUCUUFVDVEVFVGXTD
    YRYPDICZXTOVHXTYQUUGVIUUEVJVKXTYNYQEXPXQYNYQPXSAVLLVEVMXTYCYLYOPYHYBVNVOVMX
    TYDYIRHZWHZYLDRHZWHZYJYMXTUUIUUKXTUUIYIMFZYDMFZRHZUUKXTYDDJUHKZCZYIUUPCZUUI
    UUOSUUQYDICZDYDGHZYDJGHQJUSCZYDUSCUUTJTVRVPZJVSYDVTWAYDJQTUVAYDJRHUVBJWBWCW
    DDJYDOTWEWFXTYIICZDYIGHYIJGHZUURXTYBXTYBYHUQZUPZXTYBUVEWGXTUVDJUGZYBGHZYBJG
    HZXTUVGYBRHZUVHXTUVJUVIXPXQUVJUVIULXSAWILZWJXTUVGICYCUVJUVHWKJTWLYHUVGYBWMW
    NWSXTUVJUVIUVKWOXTYCJICUVDUVHUVIULSYHTYBJWPWTWQDJYIOTWEWRYDYIXAWNXTUUMYLUUN
    DRXTYIYBPZUUMYLPZYIYBUGZPZUVLUVMWKXTYIYBMXIVHXTUVMUVOUVNMFZYLPZXTYBBCUVQUVE
    YBXBVOUVOUUMUVPYLYIUVNMXIXCXDXTYBYHXEXFUUNDPXTXGVHXHXJXKXTUVCUUSYJUUJSUVFQY
    IYDXLWTXTUUHYLICYMUULSOXTYBYHXMDYLXLWNXNVKXTYCUUSYJYKSYHQYBYDWPWTXOZWJXTYFY
    GUVRWOYEYDYBYDQWLQWEWR $.

  $( Closure of the argument of a complex number with positive imaginary part.
     (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  argimgt0 $p |- ( ( A e. CC /\ 0 < ( Im ` A ) ) ->
    ( Im ` ( log ` A ) ) e. ( 0 (,) pi ) ) $=
    ( wcel cc0 cim cfv clt wbr cr cpi wne wceq syl syldan cneg cmul adantr pire
    co cle wb cc wa clog cioo gt0ne0 sylan fveq2 im0 syl6eq necon3i logcl imcld
    imcl csin ci ce cabs cdiv simpr abscl recnd mul01d simpl crp absrpcl rpne0d
    divcld immul2d divcan2d fveq2d eqtr3d 3brtr4d 0re a1i ltmul2d mpbird efiarg
    breqtrrd resinval resincld lt0neg2d mpbid caddc cicc readdcl sylancl df-neg
    wn cmin logimcl simpld wi renegcli ltle sylancr syl5eqbrr lesubaddd leadd1d
    biimpa recni addid2i syl6breq elicc2i syl3anbrc sinq12ge0 sinppi breqtrd ex
    mpd con3d renegcld 3imtr4d rpre negneg eleq1d syl5ib lognegb reim0b 3imtr3d
    ltnle necon3d necomd simprd leltned cxr w3a 0xr rexri elioo2 mp2an ) AUABZC
    ADEZFGZUBZAUCEZDEZHBZCYPFGZYPIFGZYPCIUDRBZYNYOYKYMACJZYOUABYNYLCJZUUAYKYLHB
    YMUUBAUMYLUEUFZACYLCACKYLCDECACDUGUHUIUJLZAUKMULZYNYPUNEZNZCFGZYRYNCUUFFGUU
    HYNCUOYPORUPEZDEZUUFFYNCAAUQEZURRZDEZUUJFYNCUUMFGUUKCORZUUKUUMORZFGYNCYLUUN
    UUOFYKYMUSYNUUKYNUUKYKUUKHBYMAUTPZVAZVBYNUUKUULORZDEUUOYLYNUUKUULUUPYNAUUKY
    KYMVCZUUQYNUUKYKYMUUAUUKVDBUUDAVEMZVFZVGZVHYNUURADYNAUUKUUSUUQUVAVIVJVKVLYN
    CUUMUUKCHBZYNVMVNZYNUULUVBULUUTVOVPYNUUIUULDYKYMUUAUUIUULKUUDAVQMVJVRYNYQUU
    FUUJKUUEYPVSLVRYNUUFYNYPUUEVTZWAWBYNCUUGSGZWHZYPCSGZWHZUUHYRYNUVHUVFYNUVHUV
    FYNUVHUBZCYPIWCRZUNEZUUGSUVJUVKCIWDRBZCUVLSGUVJUVKHBZCUVKSGZUVKISGUVMYNUVNU
    VHYNYQIHBZUVNUUEQYPIWEWFPYNUVOUVHYNCIWIRZYPSGUVOYNUVQINZYPSIWGYNUVRYPFGZUVR
    YPSGZYNUVSYPISGZYKYMUUAUVSUWAUBUUDAWJMZWKYNUVRHBYQUVSUVTWLIQWMUUEUVRYPWNWOX
    IWPYNCIYPUVDUVPYNQVNZUUEWQWBPUVJUVKCIWCRZISYNUVHUVKUWDSGYNYPCIUUEUVDUWCWRWS
    IIQWTXAXBCIUVKVMQXCXDUVKXELYNUVLUUGKZUVHYNYPUABUWEYNYPUUEVAYPXFLPXGXHXJYNUU
    GHBUVCUUHUVGTYNUUFUVEXKVMUUGCXTWFYNUVCYQYRUVITVMUUECYPXTWOXLXIYNYSIYPJYNYPI
    YNUUBYPIJUUCYNYPIYLCYNANZVDBZAHBZYPIKZYLCKZUWGUWFNZHBYNUWHUWGUWFUWFXMXKYNUW
    KAHYKUWKAKYMAXNPXOXPYKYMUUAUWGUWITUUDAXQMYKUWHUWJTYMAXRPXSYAXIYBYNYPIUUEUWC
    YNUVSUWAUWBYCYDVPCYEBIYEBYTYQYRYSYFTYGIQYHCIYPYIYJXD $.

  $( Closure of the argument of a complex number with negative imaginary part.
     (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  argimlt0 $p |- ( ( A e. CC /\ ( Im ` A ) < 0 ) ->
    ( Im ` ( log ` A ) ) e. ( -u pi (,) 0 ) ) $=
    ( cc wcel cim cfv cc0 clt wbr wa clog cr cpi cneg cioo co wne syldan adantr
    wceq syl simpr lt0ne0d fveq2 im0 syl6eq necon3i logcl imcld ccj logcj imcjd
    fveq2d eqtrd cjcl imcl lt0neg1d mpbid imcj breqtrrd argimgt0 syl2anc simprd
    eliooord eqbrtrrd pire ltnegcon1 sylancl simpld breqtrd mpbird cxr renegcli
    wb w3a rexri 0xr elioo2 mp2an syl3anbrc ) ABCZADEZFGHZIZAJEZDEZKCZLMZWEGHZW
    EFGHZWEWGFNOCZWCWDVTWBAFPZWDBCWCWAFPZWKWCWAVTWBUAZUBZAFWAFAFSWAFDEFAFDUCUDU
    EUFTAUGQZUHZWCWEMZLGHZWHWCAUIEZJEZDEZWQLGWCXAWDUIEZDEWQWCWTXBDVTWBWLWTXBSWN
    AUJQULWCWDWOUKUMZWCFXAGHZXALGHZWCXAFLNOCZXDXEIWCWSBCZFWSDEZGHXFVTXGWBAUNRWC
    FWAMZXHGWCWBFXIGHWMWCWAVTWAKCWBAUORUPUQVTXHXISWBAURRUSWSUTVAXAFLVCTZVBVDWCW
    FLKCWRWHVMWPVEWELVFVGUQWCWIFWQGHWCFXAWQGWCXDXEXJVHXCVIWCWEWPUPVJWGVKCFVKCWJ
    WFWHWIVNVMWGLVEVLVOVPWGFWEVQVRVS $.

  $( Multiplying a number by ` _i ` increases the logarithm of the number by
     ` _i pi / 2 ` .  (Contributed by Mario Carneiro, 4-Apr-2015.) $)
  logimul $p |- ( ( A e. CC /\ A =/= 0 /\ 0 <_ ( Re ` A ) ) ->
    ( log ` ( _i x. A ) ) = ( ( log ` A ) + ( _i x. ( pi / 2 ) ) ) ) $=
    ( cc wcel cfv cle wbr clog ci cpi co cmul caddc halfpire sylancl a1i clt cr
    wceq pire ax-mp cc0 wne cre w3a c2 cdiv ce logcl 3adant3 ax-icn recni efadd
    mulcli eflog efhalfpi oveq12d simp1 mulcom 3eqtrd fveq2d crn cneg cim addcl
    renegcli imcld readdcl logimcl simpld crp pipos elrpii rphalfcl lttrd imadd
    wa ltaddrp reim rere eqtr3i oveq2i syl6eq breqtrrd argrege0 elicc2i simp3bi
    cmin cicc syl 2halves subaddrii syl6breqr wb syl3anc mpbird eqbrtrd ellogrn
    leaddsub syl3anbrc logef eqtr3d ) ABCZAUAUBZUAAUCDEFZUDZAGDZHIUEUFJZKJZLJZU
    GDZGDZHAKJZGDXIXEXJXLGXEXJXFUGDZXHUGDZKJZAHKJZXLXEXFBCZXHBCZXJXORXBXCXQXDAU
    HUIZHXGUJXGMUKZUMZXFXHULNXEXMAXNHKXBXCXMARXDAUNUIXNHRXEUOOUPXEXBHBCXPXLRXBX
    CXDUQUJAHURNUSUTXEXIGVACZXKXIRXEXIBCZIVBZXIVCDZPFYEIEFYBXEXQXRYCXSYAXFXHVDN
    XEYDXFVCDZXGLJZYEPXEYDYFYGYDQCXEISVEOXEXFXSVFZXEYFQCZXGQCZYGQCYHMYFXGVGNXEY
    DYFPFZYFIEFZXBXCYKYLVPXDAVHUIVIXEYIXGVJCZYFYGPFYHIVJCYMISVKVLIVMTYFXGVQNVNX
    EYEYFXHVCDZLJZYGXEXQXRYEYORXSYAXFXHVONYNXGYFLXGUCDZYNXGXGBCYPYNRXTXGVRTYJYP
    XGRMXGVSTVTWAWBZWCXEYEYGIEYQXEYGIEFZYFIXGWGJZEFZXEYFXGYSEXEYFXGVBZXGWHJCZYF
    XGEFZAWDUUBYIUUAYFEFUUCUUAXGYFXGMVEMWEWFWIIXGXGISUKZXTXTIBCXGXGLJIRUUDIWJTW
    KWLXEYIYJIQCZYRYTWMYHYJXEMOUUEXESOYFXGIWRWNWOWPXIWQWSXIWTWIXA $.

  $( The logarithm of the negative of a number with positive imaginary part is
     ` _i pi ` less than the original.  (Compare ~ logneg .)  (Contributed by
     Mario Carneiro, 3-Apr-2015.) $)
  logneg2 $p |- ( ( A e. CC /\ 0 < ( Im ` A ) ) ->
    ( log ` -u A ) = ( ( log ` A ) - ( _i x. pi ) ) ) $=
    ( cc wcel cc0 cim cfv clt wbr clog cpi co cmin cneg cdiv c1 wceq cr sylancl
    pire cle wa ci cmul ce wne imcl gt0ne0 sylan fveq2 im0 syl6eq necon3i logcl
    syl syldan ax-icn recni mulcli efsub eflog efipi a1i oveq12d ax-1cn ax-1ne0
    divneg2 mp3an23 negeqd eqtr3d adantr 3eqtrd fveq2d crn subcl caddc argimgt0
    div1 eliooord simpld wb renegcli ltaddpos2 mpbid recnd negsub breqtrd imsub
    cioo cre reim ax-mp eqtr3i oveq2i breqtrrd resubcl 0re pipos ltleii subge02
    rere mpbii logimcl simprd letrd eqbrtrd ellogrn syl3anbrc logef ) ABCZDAEFZ
    GHZUAZAIFZUBJUCKZLKZUDFZIFZAMZIFXOXLXPXRIXLXPXMUDFZXNUDFZNKZAOMZNKZXRXLXMBC
    ZXNBCZXPYAPXIXKADUEZYDXLXJDUEZYFXIXJQCXKYGAUFXJUGUHADXJDADPXJDEFDADEUIUJUKU
    LUNZAUMUOZUBJUPJSUQZURZXMXNUSRXLXSAXTYBNXIXKYFXSAPYHAUTUOXTYBPXLVAVBVCXIYCX
    RPXKXIAONKZMZYCXRXIOBCODUEYMYCPVDVEAOVFVGXIYLAAVQVHVIVJVKVLXLXOIVMCZXQXOPXL
    XOBCZJMZXOEFZGHYQJTHYNXLYDYEYOYIYKXMXNVNRXLYPXMEFZJLKZYQGXLYPYRYPVOKZYSGXLD
    YRGHZYPYTGHZXLUUAYRJGHZXLYRDJWHKCUUAUUCUAAVPYRDJVRUNVSXLYRQCZYPQCUUAUUBVTXL
    YDUUDYIXMUFUNZJSWAYRYPWBRWCXLYRBCJBCZYTYSPXLYRUUEWDYJYRJWERWFXLYQYRXNEFZLKZ
    YSXLYDYEYQUUHPYIYKXMXNWGRUUGJYRLJWIFZUUGJUUFUUIUUGPYJJWJWKJQCZUUIJPSJWTWKWL
    WMUKZWNXLYQYSJTUUKXLYSYRJXLUUDUUJYSQCUUESYRJWORUUEUUJXLSVBXLDJTHZYSYRTHZDJW
    PSWQWRXLUUDUUJUULUUMVTUUESYRJWSRXAXLYPYRGHZYRJTHZXIXKYFUUNUUOUAYHAXBUOXCXDX
    EXOXFXGXOXHUNVI $.

  $( Generalization of ~ relogmul to a complex left argument.  (Contributed by
     Mario Carneiro, 9-Jul-2017.) $)
  logmul2 $p |- ( ( A e. CC /\ A =/= 0 /\ B e. RR+ ) ->
                    ( log ` ( A x. B ) ) = ( ( log ` A ) + ( log ` B ) ) ) $=
    ( cc wcel cc0 wne crp w3a clog caddc co ce cmul wceq logcl 3adant3 3ad2ant3
    cfv cr syl2anc relogcl recnd efadd eflog reeflog oveq12d fveq2d crn logrncl
    eqtrd logrnaddcl logef syl eqtr3d ) ACDZAEFZBGDZHZAIRZBIRZJKZLRZIRZABMKZIRV
    AURVBVDIURVBUSLRZUTLRZMKZVDURUSCDZUTCDVBVGNUOUPVHUQAOPURUTUQUOUTSDZUPBUAQZU
    BUSUTUCTURVEAVFBMUOUPVEANUQAUDPUQUOVFBNUPBUEQUFUJUGURVAIUHZDZVCVANURUSVKDZV
    IVLUOUPVMUQAUIPVJUSUTUKTVAULUMUN $.

  $( Generalization of ~ relogdiv to a complex left argument.  (Contributed by
     Mario Carneiro, 8-Jul-2017.) $)
  logdiv2 $p |- ( ( A e. CC /\ A =/= 0 /\ B e. RR+ ) ->
                    ( log ` ( A / B ) ) = ( ( log ` A ) - ( log ` B ) ) ) $=
    ( cc wcel cc0 wne crp w3a clog cfv cmin co cdiv wceq logcl 3adant3 3ad2ant3
    ce cr syl2anc relogcl recnd efsub eflog reeflog eqtrd fveq2d crn cneg caddc
    oveq12d negsubd logrncl renegcld logrnaddcl eqeltrrd logef syl eqtr3d ) ACD
    ZAEFZBGDZHZAIJZBIJZKLZRJZIJZABMLZIJVFVCVGVIIVCVGVDRJZVERJZMLZVIVCVDCDZVECDV
    GVLNUTVAVMVBAOPZVCVEVBUTVESDVABUAQZUBZVDVEUCTVCVJAVKBMUTVAVJANVBAUDPVBUTVKB
    NVABUEQUKUFUGVCVFIUHZDVHVFNVCVDVEUIZUJLZVFVQVCVDVEVNVPULVCVDVQDZVRSDVSVQDUT
    VAVTVBAUMPVCVEVOUNVDVRUOTUPVFUQURUS $.

  $( Bound on the magnitude of the complex logarithm function.  (Contributed by
     Mario Carneiro, 3-Jul-2017.) $)
  abslogle $p |- ( ( A e. CC /\ A =/= 0 ) ->
    ( abs ` ( log ` A ) ) <_ ( ( abs ` ( log ` ( abs ` A ) ) ) + pi ) ) $=
    ( cc wcel cc0 wne clog cfv cabs caddc co cpi abscld recnd readdcld a1i cmul
    cr ci fveq2d c1 cim logcl crp absrpcl relogcl syl imcld pire cre cle ax-icn
    recld mulcld abstrid replimd relog eqcomd absmuld absi oveq1i syl5eq eqtr2d
    wa mulid2d oveq12d 3brtr4d abslogimle leadd2dd letrd ) ABCADEVCZAFGZHGZAHGZ
    FGZHGZVKUAGZHGZIJZVOKIJVJVKAUBZLVJVOVQVJVNVJVNVJVMUCCVNQCAUDVMUEUFMLZVJVPVJ
    VPVJVKVSUGMZLZNVJVOKVTKQCVJUHOZNVJVKUIGZRVPPJZIJZHGWDHGZWEHGZIJVLVRUJVJWDWE
    VJWDVJVKVSULMVJRVPRBCVJUKOZWAUMUNVJVKWFHVJVKVSUOSVJVOWGVQWHIVJVNWDHVJWDVNAU
    PUQSVJWHRHGZVQPJZVQVJRVPWIWAURVJWKTVQPJVQWJTVQPUSUTVJVQVJVQWBMVDVAVBVEVFVJV
    QKVOWBWCVTAVGVHVI $.

  $( The basic relation between the "arg" function ` Im o. log ` and the
     arctangent.  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
  tanarg $p |- ( ( A e. CC /\ ( Re ` A ) =/= 0 ) ->
    ( tan ` ( Im ` ( log ` A ) ) ) = ( ( Im ` A ) / ( Re ` A ) ) ) $=
    ( cc wcel cfv cc0 wne c2 ci cmul co cmin caddc cdiv cexp wceq mulcl sylancr
    ax-icn oveq12d oveq2d cre wa clog cim ctan ce cabs fveq2 re0 syl6eq necon3i
    c1 logcl sylan2 imcld recnd sqcl adantr cr abscl sqcld absrpcl rpne0d sqne0
    crp wb mpbird divdird cz 2z efexp sylancl efiarg oveq1d simpl sqdivd dividd
    syl 3eqtrrd eqtr2d addcld cneg a1i 2cn recl imcl mulcld mul12d eqtrd adddid
    eqeltrd mulassd sqvald mulcom mul32d 3eqtr3d 3eqtr2d oveq1i syl5eqr mulcomd
    mulm1d negsubd subcld add4d replim binom2 syl2anc sqmul i2 3eqtrd absvalsq2
    ixi addsubassd 2timesd npcand 3eqtr4d subdird simpr eleq1 syl5ibrcom ee12an
    rimul necon3d eqnetrd subeq0ad mulcand bitrd necon3bid mulne0d oveq2 mul01i
    mpd 2ne0 divne0d tanval3 divsubdird divassd eqtr4d divcan7d pnpcand
    subsub4d divcan5d ) ABCZAUADZEFZUBZAUCDZUDDZUEDZGHUUHIJZIJUFDZULKJZHUUKULLJ
    ZIJZMJZAGNJZAUGDZGNJZKJZUURMJZHUUPUURLJZIJZUURMJZMJZAUDDZUUDMJZUUFUUHBCZUUM
    EFUUIUUOOUUFUUHUUFUUGUUEUUCAEFZUUGBCAEUUDEAEOUUDEUADEAEUAUHUIUJUKZAUMUNUOUP
    ZUUFUUMUVAUURMJZEUUFUVKUUPUURMJZUURUURMJZLJUUMUUFUUPUURUURUUCUUPBCUUEAUQURZ
    UUFUUQUUFUUQUUCUUQUSCUUEAUTURUPZVAZUVPUUFUUREFZUUQEFZUUFUUQUUEUUCUVHUUQVECU
    VIAVBUNVCZUUFUUQBCUVQUVRVFUVOUUQVDVRVGZVHUUFUVLUUKUVMULLUUFUUKUUJUFDZGNJZAU
    UQMJZGNJUVLUUFUUJBCZGVICUUKUWBOUUFHBCZUVGUWDRUVJHUUHPQVJUUJGVKVLUUFUWAUWCGN
    UUEUUCUVHUWAUWCOUVIAVMUNVNUUFAUUQUUCUUEVOUVOUVSVPVSZUUFUURUVPUVTVQZSVTZUUFU
    VAUURUUFUUPUURUVNUVPWAZUVPUUFUVBEFUVAEFUUFUVBGUUDHIJZIJZGUVEIJZKJZUUDIJZEUU
    FHGUUDGNJZIJZHGUUDUVEIJZIJZIJZLJZIJZUWKUUDIJZUWLUUDIJZKJZUVBUWNUUFUXAHUWPIJ
    ZHUWSIJZLJUXBUXCWBZLJUXDUUFHUWPUWSUWEUUFRWCZUUFGBCZUWOBCZUWPBCWDUUFUUDUUFUU
    DUUCUUDUSCZUUEAWEURZUPZVAZGUWOPQUUFUWSGUUDHUVEIJZIJZIJZBUUFUWSGHUWQIJZIJZUX
    QUUFHGUWQUXHUXIUUFWDWCZUUFUUDUVEUXMUUFUVEUUCUVEUSCZUUEAWFURZUPZWGWHZUUFUXRU
    XPGIUUFHUUDUVEUXHUXMUYCWHTZWIUUFUXIUXPBCUXQBCWDUUFUUDUXOUXMUUFUWEUVEBCZUXOB
    CZRUYCHUVEPQZWGGUXPPQZWKWJUUFUXBUXEUXGUXFLUUFUXBGUWJUUDIJZIJGHUWOIJZIJUXEUU
    FGUWJUUDUXTUUFUUDBCZUWEUWJBCZUXMRUUDHPVLZUXMWLUUFUYKUYJGIUUFUWOHIJZUUDUUDIJ
    ZHIJUYKUYJUUFUWOUYPHIUUFUUDUXMWMVNUUFUXJUWEUYOUYKOUXNRUWOHWNVLUUFUUDUUDHUXM
    UXMUXHWOWPTUUFGHUWOUXTUXHUXNWHWQUUFULWBZUXCIJZHHUXCIJZIJZUXGUXFUUFUYRHHIJZU
    XCIJUYTVUAUYQUXCIXLWRUUFHHUXCUXHUXHUUFUWLUUDUUFUXIUYFUWLBCWDUYCGUVEPQZUXMWG
    ZWLWSUUFUXCVUCXAUUFUYSUWSHIUUFUXCUWRHIUUFUXCGUVEUUDIJZIJUWRUUFGUVEUUDUXTUYC
    UXMWLUUFVUDUWQGIUUFUVEUUDUYCUXMWTTWITTWPSUUFUXBUXCUUFUWKUUDUUFUXIUYMUWKBCWD
    UYNGUWJPQZUXMWGVUCXBWQUUFUVAUWTHIUUFUWOUXQUVEGNJZKJZLJZUWOVUFLJZLJUWOUWOLJZ
    VUGVUFLJZLJUVAUWTUUFUWOVUGUWOVUFUXNUUFUXQVUFUYIUUFUVEUYCVAZXCZUXNVULXDUUFUU
    PVUHUURVUILUUFUUPUUDUXOLJZGNJZUWOUXQLJZVUFKJZVUHUUFAVUNGNUUCAVUNOUUEAXEURVN
    UUFVUOVUPUXOGNJZLJZVUPVUFWBZLJVUQUUFUYLUYGVUOVUSOUXMUYHUUDUXOXFXGUUFVURVUTV
    UPLUUFVURUYQVUFIJZVUTUUFVURHGNJZVUFIJZVVAUUFUWEUYFVURVVCORUYCHUVEXHQVVBUYQV
    UFIXIWRUJUUFVUFVULXAWITUUFVUPVUFUUFUWOUXQUXNUYIWAVULXBXJUUFUWOUXQVUFUXNUYIV
    ULXMXJZUUCUURVUIOUUEAXKURZSUUFUWPVUJUWSVUKLUUFUWOUXNXNUUFUXSUXQUWSVUKUYEUYD
    UUFUXQVUFUYIVULXOXPSXPTUUFUWKUWLUUDVUEVUBUXMXQXPZUUFUWMUUDUUFUWKUWLVUEVUBXC
    ZUXMUUFUWMEFUWJUVEFUUFUWJHUUDIJZUVEUUFUYLUWEUWJVVHOUXMRUUDHWNVLUUFUUEVVHUVE
    FUUCUUEXRZUUFVVHUVEUUDEUUFUXKVVHUVEOZVVHUSCZUUDEOUXLUUFVVKVVJUYAUYBVVHUVEUS
    XSXTUUDYBYAYCYLYDUUFUWMEUWJUVEUUFUWMEOUWKUWLOUWJUVEOUUFUWKUWLVUEVUBYEUUFUWJ
    UVEGUYNUYCUXTGEFUUFYMWCYFYGYHVGZVVIYIYDZUVAEUVBEUVAEOUVBHEIJEUVAEHIYJHRYKUJ
    UKVRUVTYNYDUUHYOXGUUFUULUUTUUNUVCMUUFUUTUVLUVMKJUULUUFUUPUURUURUVNUVPUVPUVT
    YPUUFUVLUUKUVMULKUWFUWGSVTUUFUUNHUVKIJUVCUUFUUMUVKHIUWHTUUFHUVAUURUXHUWIUVP
    UVTYQYRSUUFUVDUUSUVBMJUWMUVEIJZUWNMJUVFUUFUUSUVBUURUUFUUPUURUVNUVPXCUUFUWEU
    VABCUVBBCRUWIHUVAPQUVPVVMUVTYSUUFUUSVVNUVBUWNMUUFUUSVUHVUIKJVUGVUFKJZVVNUUF
    UUPVUHUURVUIKVVDVVESUUFUWOVUGVUFUXNVUMVULYTUUFVVOUXQVUFVUFLJZKJUXQGVUFIJZKJ
    ZVVNUUFUXQVUFVUFUYIVULVULUUAUUFVVQVVPUXQKUUFVUFVULXNTUUFVVRUWKUVEIJZUWLUVEI
    JZKJVVNUUFUXQVVSVVQVVTKUUFVVSGUWJUVEIJZIJUXQUUFGUWJUVEUXTUYNUYCWLUUFVWAUXPG
    IUUFUUDHUVEUXMUXHUYCWLTVTUUFVVQGUVEUVEIJZIJVVTUUFVUFVWBGIUUFUVEUYCWMTUUFGUV
    EUVEUXTUYCUYCWLYRSUUFUWKUWLUVEVUEVUBUYCXQYRWQXJVVFSUUFUVEUUDUWMUYCUXMVVGVVI
    VVLUUBXJXJ $.

  ${
    $d A x y $.  $d B y $.
    $( The ` log x / x ` function is strictly decreasing on the reals greater
       than ` _e ` .  (Contributed by Mario Carneiro, 14-Mar-2014.) $)
    logdivlti $p |- ( ( ( A e. RR /\ B e. RR /\ _e <_ A ) /\ A < B )
                      -> ( ( log ` B ) / B ) < ( ( log ` A ) / A ) ) $=
      ( cr wcel ceu cle wbr clt wa cfv co cmul cmin c1 crp cc0 syl 1re recnd wb
      w3a clog cdiv simpl2 simpl3 simpr simpl1 ere lelttr mp3an1 syl2anc mp2and
      epos 0re lttr mp3an12 mpani mpd elrpd rpdivcld relogcl rerpdivcld resubcl
      wi ltletr sylancl remulcld ce caddc wceq reeflog cc ax-1cn pncan3 sylancr
      eqtr4d mulid2d eqbrtrd ltmuldiv syl112anc mpbid difrp efgt1p eflt mulid1d
      a1i mpbird df-e breqtrrd syl5eqbrr posdif lemul2 eqbrtrrd ltletrd subdird
      efle relogdiv rpne0d div32d oveq12d eqtrd 3brtr3d ltsub1d ltdivmuld ) ACD
      ZBCDZEAFGZUAZABHGZIZBUBJZBUCKAUBJZAUCKZHGXKBXMLKZHGZXJXOXKXLMKZXNXLMKZHGX
      JBAUCKZUBJZXRNMKZXLLKZXPXQHXJXSXTYAXJXRODZXSCDZXJBAXJBXEXFXGXIUDZXJEBHGZP
      BHGZXJXGXIYEXEXFXGXIUEZXHXIUFZXJXEXFXGXIIYEVDZXEXFXGXIUGZYDECDZXEXFYIUHEA
      BUIUJUKULXJPEHGZYEYFUMXJXFYLYEIYFVDZYDPCDZYKXFYMUNUHPEBUOUPQUQURUSZXJAYJX
      JXGPAHGZYGXJYLXGYPUMXJXEYLXGIYPVDZYJYNYKXEYQUNUHPEAVEUPQUQURZUSZUTZXRVAQZ
      XJXRCDZNCDZXTCDZXJBAYDYSVBZRXRNVCVFZXJXTXLUUFXJAODZXLCDZYSAVAQZVGXJXSXTHG
      ZXSVHJZXTVHJZHGZXJUUKNXTVIKZUULHXJUUKXRUUNXJYBUUKXRVJYTXRVKQXJNVLDZXRVLDU
      UNXRVJVMXJXRUUESZNXRVNVOVPXJXTODZUUNUULHGXJNXRHGZUUQXJNALKZBHGZUURXJUUSAB
      HXJAXJAYJSZVQYHVRXJUUCXFXEYPUUTUURTUUCXJRWFZYDYJYRNBAVSVTWAZXJUUCUUBUURUU
      QTRUUENXRWBVOWAXTWCQVRXJYCUUDUUJUUMTUUAUUFXSXTWDUKWGXJXTNLKZXTYAFXJXTXJXT
      UUFSWEXJNXLFGZUVDYAFGZXJUVENVHJZXLVHJZFGZXJUVGEUVHFWHXJEAUVHFYGXJUUGUVHAV
      JYSAVKQWIWJXJUUCUUHUVEUVITRUUINXLWPVOWGXJUUCUUHUUDPXTHGZUVEUVFTUVBUUIUUFX
      JUURUVJUVCXJUUCUUBUURUVJTRUUENXRWKVOWANXLXTWLVTWAWMWNXJBODZUUGXSXPVJYOYSB
      AWQUKXJYAXRXLLKZNXLLKZMKXQXJXRNXLUUPUUOXJVMWFXJXLUUISZWOXJUVLXNUVMXLMXJBA
      XLXJBYDSUVAUVNXJAYSWRWSXJXLUVNVQWTXAXBXJXKXNXLXJUVKXKCDYOBVAQZXJBXMYDXJXL
      AUUIYSVBZVGUUIXCWGXJXKXMBUVOUVPYOXDWG $.

    $( The ` log x / x ` function is strictly decreasing on the reals greater
       than ` _e ` .  (Contributed by Mario Carneiro, 14-Mar-2014.) $)
    logdivlt $p |- ( ( ( A e. RR /\ _e <_ A ) /\ ( B e. RR /\ _e <_ B ) ) ->
                   ( A < B <-> ( ( log ` B ) / B ) < ( ( log ` A ) / A ) ) ) $=
      ( cr wcel ceu cle wbr wa clt clog cfv cdiv co wi logdivlti ex 3expa an32s
      w3a cc0 adantrr wo wn fveq2 id oveq12d eqcomd a1i ancoms orim12d con3d wb
      wceq crp simpl 0re ere ltletr mp3an12 mpani imp relogcl rerpdivcl mpancom
      epos elrpd syl axlttri syl2anr ad2ant2r 3imtr4d impbid ) ACDZEAFGZHZBCDZE
      BFGZHZHZABIGZBJKZBLMZAJKZALMZIGZVOVPVTWENZVQVMVPVNWFVMVPVNWFVMVPVNSVTWEAB
      OPQRUAVSWBWDUMZWDWBIGZUBZUCZABUMZBAIGZUBZUCZWEVTVSWMWIVSWKWGWLWHWKWGNVSWK
      WDWBWKWCWAABLABJUDWKUEUFUGUHVRVOWLWHNZVRVMWOVNVPVMVQWOVPVMVQWOVPVMVQSWLWH
      BAOPQRUAUIUJUKVRWBCDZWDCDZWEWJULVOVRBUNDZWPVRBVPVQUOVPVQTBIGZVPTEIGZVQWSV
      ETCDZECDZVPWTVQHWSNUPUQTEBURUSUTVAVFWACDWRWPBVBWABVCVDVGVOAUNDZWQVOAVMVNU
      OVMVNTAIGZVMWTVNXDVEXAXBVMWTVNHXDNUPUQTEAURUSUTVAVFWCCDXCWQAVBWCAVCVDVGWB
      WDVHVIVMVPVTWNULVNVQABVHVJVKVL $.

    $( The ` log x / x ` function is strictly decreasing on the reals greater
       than ` _e ` .  (Contributed by Mario Carneiro, 3-May-2016.) $)
    logdivle $p |- ( ( ( A e. RR /\ _e <_ A ) /\ ( B e. RR /\ _e <_ B ) ) ->
                 ( A <_ B <-> ( ( log ` B ) / B ) <_ ( ( log ` A ) / A ) ) ) $=
      ( cr wcel ceu cle wbr wa clt wn clog cfv cdiv co lenltd crp cc0 a1i elrpd
      ltletrd wb logdivlt ancoms notbid simpll simprl 0re ere simprr rerpdivcld
      epos relogcl syl simplr 3bitr4d ) ACDZEAFGZHZBCDZEBFGZHZHZBAIGZJAKLZAMNZB
      KLZBMNZIGZJABFGVGVEFGVBVCVHVAURVCVHUABAUBUCUDVBABUPUQVAUEZURUSUTUFZOVBVGV
      EVBVFBVBBPDVFCDVBBVJVBQEBQCDVBUGRZECDVBUHRZVJQEIGVBUKRZURUSUTUITSZBULUMVN
      UJVBVDAVBAPDVDCDVBAVIVBQEAVKVLVIVMUPUQVAUNTSZAULUMVOUJOUO $.
  $}

  ${
    relogcld.1 $e |- ( ph -> A e. RR+ ) $.
    $( Closure of the natural logarithm function.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    relogcld $p |- ( ph -> ( log ` A ) e. RR ) $=
      ( crp wcel clog cfv cr relogcl syl ) ABDEBFGHECBIJ $.

    $( Relationship between the natural logarithm function and the exponential
       function.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    reeflogd $p |- ( ph -> ( exp ` ( log ` A ) ) = A ) $=
      ( crp wcel clog cfv ce wceq reeflog syl ) ABDEBFGHGBICBJK $.

    relogmuld.2 $e |- ( ph -> B e. RR+ ) $.
    $( The natural logarithm of the product of two positive real numbers is the
       sum of natural logarithms.  Property 2 of [Cohen] p. 301, restricted to
       natural logarithms.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    relogmuld $p |- ( ph ->
                      ( log ` ( A x. B ) ) = ( ( log ` A ) + ( log ` B ) ) ) $=
      ( crp wcel cmul co clog cfv caddc wceq relogmul syl2anc ) ABFGCFGBCHIJKBJ
      KCJKLIMDEBCNO $.

    $( The natural logarithm of the quotient of two positive real numbers is
       the difference of natural logarithms.  Exercise 72(a) and Property 3 of
       [Cohen] p. 301, restricted to natural logarithms.  (Contributed by Mario
       Carneiro, 29-May-2016.) $)
    relogdivd $p |- ( ph ->
                      ( log ` ( A / B ) ) = ( ( log ` A ) - ( log ` B ) ) ) $=
      ( crp wcel cdiv co clog cfv cmin wceq relogdiv syl2anc ) ABFGCFGBCHIJKBJK
      CJKLIMDEBCNO $.

    $( Natural logarithm preserves ` <_ ` .  (Contributed by Mario Carneiro,
       29-May-2016.) $)
    logled $p |- ( ph -> ( A <_ B <-> ( log ` A ) <_ ( log ` B ) ) ) $=
      ( crp wcel cle wbr clog cfv wb logleb syl2anc ) ABFGCFGBCHIBJKCJKHILDEBCM
      N $.
  $}

  ${
    relogefd.1 $e |- ( ph -> A e. RR ) $.
    $( Relationship between the natural logarithm function and the exponential
       function.  (Contributed by Mario Carneiro, 29-May-2016.) $)
    relogefd $p |- ( ph -> ( log ` ( exp ` A ) ) = A ) $=
      ( cr wcel ce cfv clog wceq relogef syl ) ABDEBFGHGBICBJK $.

    ${
      rplogcld.2 $e |- ( ph -> 1 < A ) $.
      $( Closure of the logarithm function in the positive reals.  (Contributed
         by Mario Carneiro, 29-May-2016.) $)
      rplogcld $p |- ( ph -> ( log ` A ) e. RR+ ) $=
        ( cr wcel c1 clt wbr clog cfv crp rplogcl syl2anc ) ABEFGBHIBJKLFCDBMN
        $.
    $}

    ${
      logge0d.2 $e |- ( ph -> 1 <_ A ) $.
      $( The logarithm of a number greater than 1 is nonnegative.  (Contributed
         by Mario Carneiro, 29-May-2016.) $)
      logge0d $p |- ( ph -> 0 <_ ( log ` A ) ) $=
        ( cr wcel c1 cle wbr cc0 clog cfv logge0 syl2anc ) ABEFGBHIJBKLHICDBMN
        $.
    $}
  $}

  ${
    $d c m x y $.
    $( The inverse logarithm function converges to zero.  (Contributed by Mario
       Carneiro, 30-May-2016.) $)
    divlogrlim $p |- ( x e. ( 1 (,) +oo ) |-> ( 1 / ( log ` x ) ) ) ~~>r 0 $=
      ( vc vy c1 cpnf co cv cfv cdiv wbr clt wi wral crp wtru wcel rprecred a1i
      cr ad2antlr cioo clog cmpt crli cabs wrex wb cc elioore eliooord rplogcld
      cc0 simpld recnd rgen wss ioossre rlim0lt trud ce reefcld rpreccld rpge0d
      id absidd simpll simpr rpred ltled rpgecld reeflogd breqtrrd eflt syl2anc
      wa 1rp mpbird ltrec1d eqbrtrd ralrimiva wceq breq1 imbi1d ralbidv mprgbir
      ex rspcev ) ADEUAFZDAGZUBHZIFZUCULUDJZBGZWIKJZWKUEHZCGZKJZLZAWHMZBSUFZCNW
      LWTCNMUGOCBAWHWKWKUHPZAWHMOXAAWHWIWHPZWKXBWJXBWIWIDEUIZXBDWIKJZWIEKJWIDEU
      JUMZUKZQZUNUORWHSUPODEUQRURUSWPNPZDWPIFZUTHZSPXJWIKJZWQLZAWHMZWTXHXIXHWPX
      HVDQVAXHXLAWHXHXBVOZXKWQXNXKVOZWOWKWPKXOWKXBWKSPXHXKXGTXOWKXOWJXOWIXBWISP
      XHXKXCTZXBXDXHXKXETZUKVBVCVEXOWPWJXHXBXKVFZXBWJNPXHXKXFTZXOXIWJKJZXJWJUTH
      ZKJZXOXJWIYAKXNXKVGXOWIXOWIDXPDNPXOVPRZXODWIXODYCVHXPXQVIVJVKVLXOXISPWJSP
      XTYBUGXOWPXRQXOWJXSVHXIWJVMVNVQVRVSWFVTWSXMBXJSWMXJWAZWRXLAWHYDWNXKWQWMXJ
      WIKWBWCWDWGVNWE $.

    $( The logarithm function is not eventually bounded.  (Contributed by Mario
       Carneiro, 30-Apr-2016.)  (Proof shortened by Mario Carneiro,
       30-May-2016.) $)
    logno1 $p |- -. ( x e. RR+ |-> ( log ` x ) ) e. O(1) $=
      ( vy crp cv clog cfv cmpt co1 wcel c1 co wa cr adantl a1i 1re clt wbr cxr
      cpnf cioo elioore 1rp eliooord simpld ltled rpgecld ex ssrdv fveq2 eleq1i
      cbvmptv biimpi o1res2 wne csup wceq rexrd renepnfd ioopnfsup syl2anc cdiv
      cc0 crli divlogrlim rplogcld rpcnd rpne0d rlimno1 pm2.65i ) ACADZEFZGZHIZ
      BJTUAKZBDZEFZGHIVNBVOCVQVNBVOCVNVPVOIZVPCIVNVRLZVPJVRVPMIVNVPJTUBNZJCIVSU
      COVSJVPJMIZVSPOVTVSJVPQRZVPTQRZVRWBWCLVNVPJTUDNUEZUFUGUHUIVNBCVQGZHIVMWEH
      ABCVLVQVKVPEUJULUKUMUNVNBVOVQVNJSIJTUOVOSQUPTUQVNJWAVNPOZURVNJWFUSJUTVABV
      OJVQVBKGVCVDRVNBVEOVSVQVSVPVTWDVFZVGVSVQWGVHVIVJ $.
  $}

  $( The derivative of the real logarithm function.  (Contributed by Mario
     Carneiro, 24-Feb-2015.) $)
  dvrelog $p |- ( RR _D ( log |` RR+ ) ) = ( x e. RR+ |-> ( 1 / x ) ) $=
    ( cr crp cres cdv co ce c1 cdiv cfv wceq wtru ccncf wcel wss reeff1o cc a1i
    cdm eqtri clog ccnv cv cmpt dfrelog oveq2i wf1o f1of ax-mp rpssre fss mp2an
    wf ax-resscn efcn rescncf mp2 cncffvrn mpbir cpr reex prid1 ssid dvef dmeqi
    wb eff fdmi sseqtr4i dvres3 mp4an reseq1i cc0 crn 0nrp rneqi wfo f1ofo forn
    mp2b eleq2i mtbir dvcnvre trud fveq1i f1ocnvfv2 mpan syl5eq oveq2d mpteq2ia
    wn ) BUACDZEFBGBDZUBZEFZACHAUCZIFZUDZWLWNBEUEUFWOACHWPWNJZBWMEFZJZIFZUDZWRW
    OXCKLAWMBCWMBBMFNZLXDBBWMUMZBCWMUMZCBOXEBCWMUGZXFPBCWMUHUIZUJBCBWMUKULBQOZW
    MBQMFNZXDXEVFUNXIGQQMFNXJUNUOQQBGUPUQBQBWMURULUSRWTSZBKLXKWMSBWTWMWTQGEFZBD
    ZWMBBQUTNQQGUMQQOBXLSZOWTXMKBQVAVBVGQVCBQXNUNXNGSQXLGVDVEQQGVGVHTVIQBGVJVKX
    LGBVDVLTZVEBCWMXHVHTRVMWTVNZNZWKLXQVMCNVOXPCVMXPWMVNZCWTWMXOVPXGBCWMVQXRCKP
    BCWMVRBCWMVSVTTWAWBRXGLPRWCWDACXBWQWPCNZXAWPHIXSXAWSWMJZWPWSWTWMXOWEXGXSXTW
    PKPBCWPWMWFWGWHWIWJTT $.

  ${
    $( The real logarithm function is continuous.  (Contributed by Mario
       Carneiro, 17-Feb-2015.) $)
    relogcn $p |- ( log |` RR+ ) e. ( RR+ -cn-> RR ) $=
      ( vx clog crp cres cr ccncf co wcel wf wf1o relogf1o f1of ax-mp cc wss wb
      ax-resscn mp2an c1 cdiv fss rpssre w3a cdv cdm wceq cv ovex dvrelog mpan2
      dmmpti dvcn mp3an cncffvrn mpbir ) BCDZCEFGHZCEUPIZCEUPJURKCEUPLMZENOZUPC
      NFGHZUQURPQUTCNUPIZCEOZVAQURUTVBUSQCENUPUARUBUTVBVCUCEUPUDGZUECUFVAACSAUG
      ZTGVDSVETUHAUIUKCEUPULUJUMCNEUPUNRUO $.
  $}

  ${
    $d u w x y z D $.
    logcn.d $e |- D = ( CC \ ( -oo (,] 0 ) ) $.
    $( Elementhood in the "continuous domain" of the complex logarithm.
       (Contributed by Mario Carneiro, 18-Feb-2015.) $)
    ellogdm $p |- ( A e. D <-> ( A e. CC /\ ( A e. RR -> A e. RR+ ) ) ) $=
      ( wcel cc cmnf cc0 cioc co cdif wn wa cr crp wi clt wbr wb 0re 3bitri cle
      eleq2i eldif w3a cxr mnfxr elioc2 mp2an df-3an mnflt pm4.71i anbi1i lenlt
      mpan2 elrp baib notbid bitr4d pm5.32i bitr3i notbii iman bitr4i anbi2i )
      ABDAEFGHIZJZDAEDZAVEDZKZLVGAMDZANDZOZLBVFACUBAEVEUCVIVLVGVIVJVKKZLZKVLVHV
      NVHVJFAPQZAGUAQZUDZVJVOLZVPLZVNFUEDGMDZVHVQRUFSFGAUGUHVJVOVPUIVSVJVPLVNVJ
      VRVPVJVOAUJUKULVJVPVMVJVPGAPQZKZVMVJVTVPWBRSAGUMUNVJVKWAVKVJWAAUOUPUQURUS
      UTTVAVJVKVBVCVDT $.

    $( A number in the continuous domain of ` log ` is nonzero.  (Contributed
       by Mario Carneiro, 18-Feb-2015.) $)
    logdmn0 $p |- ( A e. D -> A =/= 0 ) $=
      ( wcel cc0 wceq crp 0nrp cr 0re cc ellogdm simprbi mpi mto eleq1 necon2ai
      wi mtbiri ) ABDZAEAEFTEBDZUAEGDZHUAEIDZUBJUAEKDUCUBREBCLMNOAEBPSQ $.

    $( A number in the continuous domain of ` log ` is not a strictly negative
       number.  (Contributed by Mario Carneiro, 18-Feb-2015.) $)
    logdmnrp $p |- ( A e. D -> -. -u A e. RR+ ) $=
      ( wcel cneg crp cmnf cc0 cioc co wn cc cdif cr clt wbr wb wi syl 0re rpre
      eldifn eleq2s wa cle ellogdm simplbi negreb syl5ib imp mnflt rpgt0 adantl
      lt0neg1d mpbird ltle sylancl mpd cxr mnfxr elioc2 mp2an syl3anbrc mtand
      w3a ) ABDZAEZFDZAGHIJZDZVJKALVIMBALVIUBCUCVFVHUDZANDZGAOPZAHUEPZVJVFVHVLV
      HVGNDZVFVLVGUAVFALDZVOVLQVFVPVLAFDRABCUFUGAUHSUIUJZVKVLVMVQAUKSVKAHOPZVNV
      KVRHVGOPZVHVSVFVGULUMVKAVQUNUOVKVLHNDZVRVNRVQTAHUPUQURGUSDVTVJVLVMVNVEQUT
      TGHAVAVBVCVD $.

    $( The continuity domain of ` log ` is a subset of the regular domain of
       ` log ` .  (Contributed by Mario Carneiro, 1-Mar-2015.) $)
    logdmss $p |- D C_ ( CC \ { 0 } ) $=
      ( vx cc cc0 csn cdif cv wcel wne ellogdm simplbi logdmn0 eldifsn sylanbrc
      cr crp wi ssriv ) CADEFGZCHZAIZUADIZUAEJUATIUBUCUAPIUAQIRUAABKLUAABMUADEN
      OS $.

    ${
      logcnlem.s $e |- S = if ( A e. RR+ , A , ( abs ` ( Im ` A ) ) ) $.
      logcnlem.t $e |- T = ( ( abs ` A ) x. ( R / ( 1 + R ) ) ) $.
      logcnlem.a $e |- ( ph -> A e. D ) $.
      logcnlem.r $e |- ( ph -> R e. RR+ ) $.
      $( Lemma for ~ logcn .  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
      logcnlem2 $p |- ( ph -> if ( S <_ T , S , T ) e. RR+ ) $=
        ( crp wcel cif cfv cabs syl cc0 c1 co cle wbr simpr wn wa cr cc ellogdm
        cim simplbi imcld adantr recnd wne wceq reim0b simprbi sylbird necon3bd
        wi imp absrpcld ifclda syl5eqel caddc cdiv cmul logdmn0 rpaddcl sylancr
        wb 1rp rpdivcld rpmulcld ifcl syl2anc ) AELMFLMEFUAUBZEFNLMAEBLMZBBUIOZ
        POZNLHAVRBVTLAVRUCAVRUDZUEZVSWBVSAVSUFMWAABABCMZBUGMZJWCWDBUFMZVRUTZBCG
        UHZUJQZUKULUMAWAVSRUNAVRVSRAVSRUOZWEVRAWDWEWIVKWHBUPQAWCWFJWCWDWFWGUQQU
        RUSVAVBVCVDAFBPOZDSDVETZVFTZVGTLIAWJWLABWHAWCBRUNJBCGVHQVBADWKKASLMDLMW
        KLMVLKSDVIVJVMVNVDVQEFLVOVP $.

      logcnlem.b $e |- ( ph -> B e. D ) $.
      logcnlem.l $e |- ( ph ->
        ( abs ` ( A - B ) ) < if ( S <_ T , S , T ) ) $.
      $( Lemma for ~ logcn .  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
      logcnlem3 $p |- ( ph ->
        ( -u pi < ( ( Im ` ( log ` B ) ) - ( Im ` ( log ` A ) ) ) /\
          ( ( Im ` ( log ` B ) ) - ( Im ` ( log ` A ) ) ) <_ pi ) ) $=
        ( clt wbr cc0 cr wcel adantr cpi cneg clog cfv cim cmin co cle wceq w3o
        cc crp wi ellogdm simplbi syl imcld 0re lttri4 sylancl wa pire renegcli
        a1i logdmn0 logcld resubcld logimcld simpld recnd subid1d cioo argimlt0
        sylan eliooord simprd ltsub2dd eqbrtrrd lttrd wb reim0b simprbi sylbird
        wne relogcld reim0d oveq2d eqtrd breqtrrd renegcld argimgt0 ltneg mpbid
        imp df-neg imsubd cabs subcld abscld absimle absled cif adantl syl5eqel
        rpre wn ifclda c1 caddc cdiv cmul rpred 1rp rpaddcl rerpdivcld remulcld
        sylancr ifcl syl2anc min1 ltletrd gt0ne0 syl5ib necon3ad iffalse syl5eq
        syldan ltle absidd breqtrd lelttrd ltsub2d mpbird ltsub1d 3jaodan mpdan
        syl5eqbr ltnri eqbrtrd ltled mtbiri necon2ai sylan2 ltnegcon2d ltsub1dd
        breq1 absnidd syl6breqr ltnegcon1 jca ) AUAUBZCUCUDZUEUDZBUCUDZUEUDZUFU
        GZOPZUUPUAUHPZABUEUDZQOPZUUSQUIZQUUSOPZUJZUUQAUUSRSZQRSZUVCABABDSZBUKSZ
        KUVFUVGBRSZBULSZUMZBDHUNZUOUPZUQZURUUSQUSUTZAUUTUUQUVAUVBAUUTVAZUUKUUMU
        UPUUKRSZUVOUAVBVCZVDAUUMRSZUUTAUULACACDSZCUKSZMUVSUVTCRSCULSUMCDHUNUOUP
        ZAUVSCQWDMCDHVEUPZVFUQZTZAUUPRSZUUTAUUMUUOUWCAUUNABUVLAUVFBQWDKBDHVEUPV
        FUQZVGZTZAUUKUUMOPZUUTAUWIUUMUAUHPZACUWAUWBVHZVIZTUVOUUMQUFUGZUUMUUPOUV
        OUUMAUUMUKSZUUTAUUMUWCVJZTVKUVOUUOQUUMAUUORSZUUTUWFTZUVEUVOURVDZUWDUVOU
        UKUUOOPZUUOQOPZUVOUUOUUKQVLUGZSZUWSUWTVAAUVGUUTUXBUVLBVMVNUUOUUKQVOUPZV
        PVQVRVSAUVAVAZUUKUUMUUPOAUWIUVAUWLTUXDUUPUWMUUMUXDUUOQUUMUFUXDUUNUXDBAU
        VAUVIAUVAUVHUVIAUVGUVHUVAVTUVLBWAUPZAUVFUVJKUVFUVGUVJUVKWBUPWCWNWEWFWGA
        UWMUUMUIUVAAUUMUWOVKTWHZWIAUVBVAZUUKUUOUBZUUPUVPUXGUVQVDAUXHRSUVBAUUOUW
        FWJTAUWEUVBUWGTZUXGUUOUAOPZUUKUXHOPZUXGQUUOOPZUXJUXGUUOQUAVLUGZSZUXLUXJ
        VAAUVGUVBUXNUVLBWKVNUUOQUAVOUPZVPAUXJUXKVTZUVBAUWPUARSZUXPUWFVBUUOUAWLU
        TTWMUXGUXHQUUOUFUGZUUPOUUOWOZUXGQUUMOPZUXRUUPOPZUXGUXTUUMUAOPZUXGUUMUXM
        SZUXTUYBVAUXGUVTQCUEUDZOPZUYCAUVTUVBUWATUXGUYEUUSUYDUFUGZUUSQUFUGZOPZUX
        GUYFUUSUYGOUXGBCUFUGZUEUDZUYFUUSOAUYJUYFUIZUVBABCUVLUWAWPZTUXGUYJUYIWQU
        DZUUSAUYJRSZUVBAUYIABCUVLUWAWRZUQZTAUYMRSZUVBAUYIUYOWSZTUXGBAUVGUVBUVLT
        UQZAUYJUYMUHPZUVBAUYMUBZUYJUHPZUYTAUYJWQUDUYMUHPZVUBUYTVAAUYIUKSVUCUYOU
        YIWTUPAUYJUYMUYPUYRXAWMZVPTUXGUYMFUUSOAUYMFOPZUVBAUYMFGUHPZFGXBZFUYRAFR
        SZGRSZVUGRSAFUVIBUUSWQUDZXBZRIAUVIBVUJRUVIUVHABXEZXCAVUJRSUVIXFZAUUSAUU
        SUVMVJZWSTXGXDZAGBWQUDZEXHEXIUGZXJUGZXKUGRJAVUPVURABUVLWSAEVUQAELXLAXHU
        LSEULSVUQULSXMLXHEXNXQXOXPXDZVUFFGRXRXSVUONAVUHVUIVUGFUHPVUOVUSFGXTXSYA
        ZTUXGFVUJUUSAUVBUUSQWDZFVUJUIZAUVDUVBVVAUVMUUSYBVNAVVAVAVUMVVBAVVAVUMAU
        VIUUSQUVIUVHAUVAVULUXEYCYDWNVUMFVUKVUJIUVIBVUJYEYFUPZYGUXGUUSUYSAUVBQUU
        SUHPZAUVEUVDUVBVVDUMURUVMQUUSYHXQWNYIWHYJYKVRUXGUUSAUUSUKSZUVBVUNTVKWIA
        UYEUYHVTUVBAQUYDUUSUVEAURVDZACUWAUQUVMYLTYMCWKXSUUMQUAVOUPZVIAUXTUYAVTU
        VBAQUUMUUOVVFUWCUWFYNTWMYQVSYOYPAUVCUURUVNAUUTUURUVAUVBUVOUUPUAUWHUXQUV
        OVBVDZUVOUUPUXHUAUWHUVOUUOUWQWJVVHUVOUUPUXRUXHOUVOUUMQUUOUWDUWRUWQUVOUW
        IUUMQOPZUVOUUMUXASZUWIVVIVAUVOUVTUYDQOPZVVJAUVTUUTUWATZUVOVVKUYGUYFOPUV
        OUYGUUSUYFOUVOUUSAVVEUUTVUNTVKUVOUUSUYJUYFOUVOUUSVUAUYJAUVDUUTUVMTZAVUA
        RSUUTAUYMUYRWJTAUYNUUTUYPTUVOUYMUUSAUYQUUTUYRTVVMUVOUYMFUUSUBZOAVUEUUTV
        UTTUVOFVUJVVNUUTAVVAVVBUUTUUSQUVAUUTQQOPQURYRUUSQQOUUFUUAUUBVVCUUCUVOUU
        SVVMAUUTUUSQUHPZAUVDUVEUUTVVOUMUVMURUUSQYHUTWNUUGWHYJUUDAVUBUUTAVUBUYTV
        UDVITYAAUYKUUTUYLTYJYSUVOUYDQUUSUVOCVVLUQUWRVVMYLYMCVMXSUUMUUKQVOUPVPUU
        EUXSUUHUVOUWSUXHUAOPZUVOUWSUWTUXCVIUVOUXQUWPUWSVVPVTVBUWQUAUUOUUIXQWMVS
        YTUXDUUPUUMUAUHUXFAUWJUVAAUWIUWJUWKVPTYSUXGUUPUAUXIUXQUXGVBVDZUXGUUPUUM
        UAUXIAUVRUVBUWCTZVVQUXGUUPUWMUUMOUXGQUUOUUMUVEUXGURVDAUWPUVBUWFTVVRUXGU
        XLUXJUXOVIVQUXGUUMAUWNUVBUWOTVKYJUXGUXTUYBVVGVPVSYTYOYPUUJ $.

      $( Lemma for ~ logcn .  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
      logcnlem4 $p |- ( ph ->
        ( abs ` ( ( Im ` ( log ` A ) ) - ( Im ` ( log ` B ) ) ) ) < R ) $=
        ( cfv co clt wcel wbr c1 clog cim cmin cabs cdiv cc crp ellogdm simplbi
        cr wi syl cc0 logdmn0 logcld imcld recnd abssubd imsubd wceq ce syl2anc
        wne efsub eflog oveq12d eqtrd crn wb divcld divne0d cpi cneg cle subcld
        logcnlem3 simpld breqtrrd simprd eqbrtrd ellogrn logeftb syl3anc mpbird
        syl3anbrc eqcomd fveq2d eqtr3d ctan abscld ccos c2 cioo cre 0re a1i 1re
        absrpcld rerpdivcld resubcl sylancr recld cmul caddc rpred 1rp remulcld
        rpaddcl syl5eqel cif wa rpre adantl wn adantr ifclda ltmin mpbid ax-1cn
        ltp1d addcom sylancl breqtrd mulid1d ledivmuld lemul2d syl5eqbr ltletrd
        ltdivmuld posdif divsubdird dividd oveq1d syl6eq absdivd gt0ne0d oveq2d
        ltled rpne0d lelttrd releabsd resub re1 oveq1i 3brtr3d subled cosq14gt0
        argregt0 retancld tanarg absidd 3eqtrd absimle imsub im1 oveq2i subid1d
        tanabsge 3eqtrrd eqtr4d 3brtr4d resubcld adddid divassd syl6eqr subdird
        ltmuldivd eqbrtrrd ltaddsubd lemul1d mulassd ltdivmul syl112anc ) ABUAO
        ZUBOZCUAOZUBOZUCPUDOZCBUEPZUAOZUBOZUDOZEQAUVRUVQUVOUCPZUDOUWBAUVOUVQAUV
        OAUVNABABDRZBUFRZKUWDUWEBUJRZBUGRZUKBDHUHUIULZAUWDBUMVCZKBDHUNULZUOZUPU
        QAUVQAUVPACACDRZCUFRZMUWLUWMCUJRCUGRUKCDHUHUIULZAUWLCUMVCZMCDHUNULZUOZU
        PUQURAUWCUWAUDAUVPUVNUCPZUBOZUWCUWAAUVPUVNUWQUWKUSZAUWRUVTUBAUVTUWRAUVT
        UWRUTZUWRVAOZUVSUTZAUXBUVPVAOZUVNVAOZUEPZUVSAUVPUFRUVNUFRUXBUXFUTUWQUWK
        UVPUVNVDVBAUXDCUXEBUEAUWMUWOUXDCUTUWNUWPCVEVBAUWEUWIUXEBUTUWHUWJBVEVBVF
        VGAUVSUFRZUVSUMVCUWRUAVHRZUXAUXCVIACBUWNUWHUWJVJZACBUWNUWHUWPUWJVKZAUWR
        UFRVLVMZUWSQSUWSVLVNSUXHAUVPUVNUWQUWKVOAUXKUWCUWSQAUXKUWCQSZUWCVLVNSZAB
        CDEFGHIJKLMNVPZVQUWTVRAUWSUWCVLVNUWTAUXLUXMUXNVSVTUWRWAWEUVSUWRWBWCWDWF
        WGWHWGVGAUWBUWAWIOZUDOZEAUWAAUWAAUVTAUVSUXIUXJUOUPZUQWJAUXOAUXOAUWAUXQA
        UWAWKOZAUWAVLWLUEPZVMUXSWMPRZUMUXRQSAUXGUMUVSWNOZQSZUXTUXIAUMTBCUCPZUDO
        ZBUDOZUEPZUCPZUYAUMUJRAWOWPZATUJRZUYFUJRZUYGUJRWQAUYDUYEAUYCABCUWHUWNVO
        ZWJZABUWHUWJWRZWSZTUYFWTXAAUVSUXIXBZAUYFTQSZUMUYGQSZAUYPUYDUYETXCPZQSAU
        YDUYEUYRQAUYDGUYEUYLAGUYEETEXDPZUEPZXCPZUJJAUYEUYTABUWHWJZAEUYSAELXEZAT
        UGREUGRUYSUGRXFLTEXHXAZWSZXGXIZVUBAUYDFQSZUYDGQSZAUYDFGVNSFGXJQSZVUGVUH
        XKZNAUYDUJRFUJRGUJRVUIVUJVIUYLAFUWGBBUBOZUDOZXJUJIAUWGBVULUJUWGUWFABXLX
        MAVULUJRUWGXNAVUKAVUKABUWHUPUQWJXOXPXIVUFUYDFGXQWCXRVSZAGVUAUYEVNJAVUAU
        YRUYEVNAUYTTVNSZVUAUYRVNSAVUNEUYSTXCPZVNSAEUYSVUOVNAEUYSVUCAUYSVUDXEZAE
        ETXDPZUYSQAEVUCXTAEUFRTUFRZVUQUYSUTAEVUCUQZXSETYAYBYCYRAUYSAUYSVUPUQZYD
        VRAETUYSVUCUYIAWQWPZVUDYEWDAUYTTUYEVUEVVAUYMYFXRAUYEAUYEVUBUQZYDZYCYGYH
        VVCVRAUYDTUYEUYLVVAUYMYIWDAUYJUYIUYPUYQVIUYNWQUYFTYJYBXRATUYAUYFVVAUYOU
        YNAUYCBUEPZWNOZVVDUDOTUYAUCPZUYFVNAVVDAUYCBUYKUWHUWJVJUUAAVVETWNOZUYAUC
        PZVVFAVVETUVSUCPZWNOZVVHAVVDVVIWNAVVDBBUEPZUVSUCPVVIABCBUWHUWNUWHUWJYKA
        VVKTUVSUCABUWHUWJYLZYMVGWGAVURUXGVVJVVHUTXSUXITUVSUUBXAVGVVGTUYAUCUUCUU
        DYNAUYCBUYKUWHUWJYOUUEUUFZYHZUVSUUHVBZUWAUUGULYPUUIUQWJVUCAUXTUWBUXPVNS
        VVOUWAUURULAUXPUVSUBOZUDOZUYAUEPZEQAUXPVVPUYAUEPZUDOVVQUYAUDOZUEPVVRAUX
        OVVSUDAUXGUYAUMVCUXOVVSUTUXIAUYAVVNYPZUVSUUJVBWGAVVPUYAAVVPAUVSUXIUPUQZ
        AUYAUYOUQZVWAYOAVVTUYAVVQUEAUYAUYOAUMUYAUYHUYOVVNYRUUKYQUULAVVREQSZVVQU
        YAEXCPZQSZAVVQUYFVWEAVVPVWBWJZUYNAUYAEUYOVUCXGZACBUCPZBUEPZUBOZUDOZVWJU
        DOZVVQUYFVNAVWJUFRVWLVWMVNSAVWIBACBUWNUWHVOZUWHUWJVJVWJUUMULAVVPVWKUDAV
        WKUVSTUCPZUBOZVVPUMUCPZVVPAVWJVWOUBAVWJUVSVVKUCPVWOACBBUWNUWHUWHUWJYKAV
        VKTUVSUCVVLYQVGWGAVWPVVPTUBOZUCPZVWQAUXGVURVWPVWSUTUXIXSUVSTUUNYBVWRUMV
        VPUCUUOUUPYNAVVPVWBUUQUUSWGAUYFVWIUDOZUYEUEPVWMAUYDVWTUYEUEABCUWHUWNURY
        MAVWIBVWNUWHUWJYOUUTUVAAUYFVWEQSUYDUYEVWEXCPZQSAUYDUYEUYDUCPZEXCPZVXAUY
        LAVXBEAUYEUYDVUBUYLUVBZVUCXGAUYEVWEVUBVWHXGAUYDUYEEXCPZUYDEXCPZUCPZVXCQ
        AUYDVXFXDPZVXEQSUYDVXGQSAUYDUYSXCPZVXHVXEQAVXIUYDTXCPZVXFXDPVXHAUYDTEAU
        YDUYLUQZVURAXSWPVUSUVCAVXJUYDVXFXDAUYDVXKYDYMVGAVXIVXEQSUYDVXEUYSUEPZQS
        AUYDGVXLQVUMAVXLVUAGAUYEEUYSVVBVUSVUTAUYSVUDYSUVDJUVEVRAUYDVXEUYSUYLAUY
        EEVUBVUCXGZVUDUVGWDUVHAUYDVXFVXEUYLAUYDEUYLVUCXGVXMUVIXRAUYEUYDEVVBVXKV
        USUVFVRAVXCUYEUYAXCPZEXCPZVXAVNAVXBVXNVNSZVXCVXOVNSAVXBUYEUEPZUYAVNSVXP
        AVXQUYGUYAVNAVXQUYEUYEUEPZUYFUCPUYGAUYEUYDUYEVVBVXKVVBAUYEUYMYSZYKAVXRT
        UYFUCAUYEVVBVXSYLYMVGVVMVTAVXBUYAUYEVXDUYOUYMYEXRAVXBVXNEVXDAUYEUYAVUBU
        YOXGLUVJXRAUYEUYAEVVBVWCVUSUVKYCYHAUYDVWEUYEUYLVWHUYMYIWDYTAVVQUJREUJRU
        YAUJRUYBVWDVWFVIVWGVUCUYOVVNVVQEUYAUVLUVMWDVTYTVT $.
    $}

    $( Lemma for ~ logcn .  (Contributed by Mario Carneiro, 18-Feb-2015.) $)
    logcnlem5 $p |- ( x e. D |-> ( Im ` ( log ` x ) ) ) e. ( D -cn-> RR ) $=
      ( cc cr cv clog cfv cim co wcel crp cabs wbr eqid wa cmin clt wceq fveq2d
      vy vz vw wss cmpt ccncf cmnf cc0 cioc cdif difss eqsstri ax-resscn cif c1
      caddc cdiv cmul wi ellogdm simplbi logdmn0 logcld imcld fmpti simpl simpr
      cle logcnlem2 simpll simprl simplr simprr logcnlem4 expr fveq2 fvex fvmpt
      ad2antrr ad2antlr oveq12d breq1d sylibrd elcncf1ii mp2an ) BDUDEDUDABAFZG
      HZIHZUEZBEUFJKBDUGUHUIJZUJDCDWJUKULUMUAUBUCBEWIUAFZLKWKWKIHMHUNZWKMHUBFZU
      OWMUPJUQJURJZVHNWLWNUNZABEWHWIWIOZWFBKZWGWQWFWQWFDKWFEKWFLKUSWFBCUTVAWFBC
      VBVCVDVEWKBKZWMLKZPWKBWMWLWNCWLOZWNOZWRWSVFWRWSVGVIWRUCFZBKZPZWSPZWKXBQJM
      HWORNZWKGHZIHZXBGHZIHZQJZMHZWMRNZWKWIHZXBWIHZQJZMHZWMRNXDWSXFXMXDWSXFPZPW
      KXBBWMWLWNCWTXAWRXCXRVJXDWSXFVKWRXCXRVLXDWSXFVMVNVOXEXQXLWMRXEXPXKMXEXNXH
      XOXJQWRXNXHSXCWSAWKWHXHBWIWFWKSWGXGIWFWKGVPTWPXGIVQVRVSXCXOXJSWRWSAXBWHXJ
      BWIWFXBSWGXIIWFXBGVPTWPXIIVQVRVTWATWBWCWDWE $.

    $( The logarithm function is continuous away from the branch cut at
       negative reals.  (Contributed by Mario Carneiro, 25-Feb-2015.) $)
    logcn $p |- ( log |` D ) e. ( D -cn-> CC ) $=
      ( vx clog cabs cfv crp ci co caddc cmpt cc ccncf wceq wss mp2an wcel wtru
      wf cr vy cres cv cim cmul wfn crn cc0 cdif wf1o logf1o f1of ax-mp logdmss
      csn fssres ffn dffn5 mpbi fvres wi ellogdm simplbi logdmn0 logcld replimd
      cre wne relog syl2anc absrpcld eqtr4d oveq1d 3eqtrd mpteq2ia eqtri ccnfld
      syl ctopn eqid ctx ccn addcn crest ctopon cnfldtopon ssriv resttopon absf
      feqmptd syl6eq wral eqeltrd rgen ffnfv mpbir2an wb rpssre ax-resscn sstri
      a1i abscncf rescncf cncffvrn mpbir syl6eqelr cncfcn syl6eleq ssid relogcn
      mp2 cncfss sselii ctop cnfldtop toponunii restid cnmpt11f syl6eleqr imcld
      eqcomi ccom recnd adantl eqidd fmptco logcnlem5 ax-icn mulc1cncf eqeltrrd
      oveq2 mp1i cncfco cncfmpt2f trud eqeltri ) DAUBZCACUCZEFZDGUBZFZHYRDFZUDF
      ZUEIZJIZKZALMIZYQCAYRYQFZKZUUFYQAUFZYQUUINADUGZYQSZUUJLUHUOUIZUUKDSZAUUMO
      UULUUMUUKDUJUUNUKUUMUUKDULUMABUNUUMUUKADUPPAUUKYQUQUMCAYQURUSCAUUHUUEYRAQ
      ZUUHUUBUUBVGFZUUDJIUUEYRADUTUUOUUBUUOYRUUOYRLQZYRTQYRGQVAYRABVBVCZYRABVDZ
      VEZVFUUOUUPUUAUUDJUUOUUPYSDFZUUAUUOUUQYRUHVHUUPUVANUURUUSYRVIVJUUOYSGQUUA
      UVANUUOYRUURUUSVKZYSGDUTVRVLVMVNVOVPUUFUUGQRCUUAUUDJVQVSFZAUVCVTZJUVCUVCW
      AIUVCWBIQRUVCUVDWCXARCAUUAKUVCAWDIZUVCWBIZUUGRCYSYTUVEUVCGWDIZUVCAUVEAWEF
      QZRUVCLWEFQALOZUVHUVCUVDWFZCALUURWGZAUVCLWHPXARCAYSKZAGMIZUVEUVGWBIZRUVLE
      AUBZUVMRUVOCAYRUVOFZKUVLRCATUVOATUVOSZRLTESUVIUVQWIUVKLTAEUPPZXAWJCAUVPYS
      YRAEUTZVOWKUVOUVMQZAGUVOSZUWAUVOAUFZUVPGQZCAWLUVQUWBUVRATUVOUQUMUWCCAUUOU
      VPYSGUVSUVBWMWNCAGUVOWOWPGLOZUVOATMIZQZUVTUWAWQGTLWRWSWTZUVIELTMIQUWFUVKX
      BLTAEXCXKATGUVOXDPXEXFUVIUWDUVMUVNNUVKUWGAGUVCUVEUVGUVDUVEVTZUVGVTZXGPXHR
      YTGLMIZUVGUVCWBIZYTUWJQRGTMIZUWJYTTLOZLLOZUWLUWJOWSLXIZGTLXLPXJXMXAUWDUWN
      UWJUWKNUWGUWOGLUVCUVGUVCUVDUWIUVCLWDIZUVCUVCXNQUWPUVCNUVCUVDXOUVCXNLLUVCU
      VJXPXQUMYAZXGPXHXRUVIUWNUUGUVFNUVKUWOALUVCUVEUVCUVDUWHUWQXGPXSRUALHUAUCZU
      EIZKZCAUUCKZYBCAUUDKUUGRCUAALUUCUWSUUDUXAUWTUUOUUCLQRUUOUUCUUOUUBUUTXTYCY
      DRUXAYERUWTYEUWRUUCHUEYKYFRALLUXAUWTUXAUUGQRUWEUUGUXAUWMUWNUWEUUGOWSUWOAT
      LXLPCABYGXMXAHLQUWTLLMIQRYHUAHUWTUWTVTYIYLYMYJYNYOYP $.

    $( Lemma for ~ dvlog .  (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    dvloglem $p |- ( log " D ) e. ( TopOpen ` CCfld ) $=
      ( vx clog cim cpi co cfv wss wcel wb cc cc0 wceq mp2an cr clt wbr wne wa
      vy vz vw cima ccnv cneg cioo ccnfld ctopn wfun cdm wral csn cdif crn wf1o
      cv logf1o f1ofun ax-mp logdmss sseqtr4i funimass4 ellogdm simplbi logdmn0
      f1odm crp wi logcld imcld cle logimcld simpld wn logdmnrp lognegb syl2anc
      necon3bbid mpbid necomd pire a1i simprd leltned mpbird cxr renegcli rexri
      w3a elioo2 syl3anbrc wf wfn imf ffn elpreima mp2b sylanbrc mprgbir df-ioo
      ce cioc df-ioc idd xrltle ixxssixx imass2 logrn sseli logef syl cmnf efcl
      adantr sylbi simprbi eliooord ltned fveq2d simpr mnfxr 0re sylib renegcld
      elioc2 simp1d efne0 simp3d lt0neg1d elrpd ex necon3ad syl6eleqr funfvima2
      eqtr3d mpd eldifd eqeltrrd ctop ssriv eqssi ctg ccn imcncf ssid ax-resscn
      ccncf eqid crest cnfldtopon toponunii restid eqcomi tgioo2 cncfcn eleqtri
      cnfldtop iooretop cnima eqeltri ) DAUDZEUEZFUFZFUGGZUDZUHUIHZUVBUVFUVBUVF
      IZCUQZDHZUVFJZCADUJZADUKZIZUVHUVKCAULKLMUMUNZDUOZDUPZUVLURUVOUVPDUSUTZAUV
      OUVMABVAUVQUVMUVONURUVOUVPDVGUTVBZCAUVFDVCOUVIAJZUVJLJZUVJEHZUVEJZUVKUVTU
      VIUVTUVILJZUVIPJUVIVHJVIUVIABVDVEZUVIABVFZVJZUVTUWBPJZUVDUWBQRZUWBFQRZUWC
      UVTUVJUWGVKZUVTUWIUWBFVLRZUVTUVIUWEUWFVMZVNUVTUWJFUWBSUVTUWBFUVTUVIUFVHJZ
      VOUWBFSUVIABVPUVTUWNUWBFUVTUWDUVIMSUWNUWBFNKUWEUWFUVIVQVRVSVTWAUVTUWBFUWK
      FPJUVTWBWCUVTUWIUWLUWMWDWEWFUVDWGJZFWGJUWCUWHUWIUWJWJKUVDFWBWHWIFWBWIUVDF
      UWBWKOWLLPEWMZELWNZUVKUWAUWCTKWOLPEWPZLUVJUVEEWQWRWSWTCUVFUVBUVIUVFJZUVIX
      BHZDHZUVIUVBUWSUVIUVPJUXAUVINZUVFUVPUVIUVFUVCUVDFXCGZUDZUVPUVEUXCIUVFUXDI
      CUAUBUCUVDFXCQQQVLUGCUAUBXACUAUBXDUWOUCUQZWGJTUVDUXEQRXEUXEFXFXGUVEUXCUVC
      XHUTXIVBXJUVIXKXLZUWSUWTAJZUXAUVBJZUWSUWTLXMMXCGZUNAUWSUWTLUXIUWSUWDUVIEH
      ZUVEJZTZUWTLJZUWPUWQUWSUXLKWOUWRLUVIUVEEWQWRZUWDUXMUXKUVIXNXOXPZUWSUXJFSU
      WTUXIJZVOUWSUXJFUWSUVIUWSUWDUXKUXNVEZVKUWSUVDUXJQRZUXJFQRZUWSUXKUXRUXSTUW
      SUWDUXKUXNXQUXJUVDFXRXLWDXSUWSUXPUXJFUWSUXPUXJFNUWSUXPTZUXAEHZUXJFUXTUXAU
      VIEUWSUXBUXPUXFXOXTUXTUWTUFZVHJZUYAFNZUXTUYBUXTUWTUXTUWTPJZXMUWTQRZUWTMVL
      RZUXTUXPUYEUYFUYGWJZUWSUXPYAXMWGJMPJZUXPUYHKYBYCXMMUWTYFOYDZYGZYEUXTUWTMQ
      RZMUYBQRUXTUYLMUWTSUXTUWTMUWSUWTMSZUXPUWSUWDUYMUXQUVIYHXLZXOWAUXTUWTMUYKU
      YIUXTYCWCUXTUYEUYFUYGUYJYIWEWFUXTUWTUYKYJVTYKUWSUYCUYDKZUXPUWSUXMUYMUYOUX
      OUYNUWTVQVRXOVTYPYLYMYQYRBYNUVLUVNUXGUXHVIUVRUVSAUWTDYOOXLYSUUAUUBEUVGUGU
      OUUCHZUUDGZJUVEUYPJUVFUVGJELPUUHGZUYQUUELLIPLIUYRUYQNLUUFUUGLPUVGUVGUYPUV
      GUUIZUVGLUUJGZUVGUVGYTJUYTUVGNUVGUYSUURUVGYTLLUVGUVGUYSUUKUULUUMUTUUNUVGU
      YSUUOUUPOUUQUVDFUUSUVEEUVGUYPUUTOUVA $.

    $( The "continuous domain" of ` log ` is an open set.  (Contributed by
       Mario Carneiro, 7-Apr-2015.) $)
    logdmopn $p |- D e. ( TopOpen ` CCfld ) $=
      ( cc cmnf cc0 cioc co cdif ccnfld ctopn cfv ccld wcel cr eqid recld2 cioo
      crest crn ax-mp ctg 0re iocmnfcld tgioo2 fveq2i restcldr mp2an cnfldtopon
      eleqtri toponunii cldopn eqeltri ) ACDEFGZHZIJKZBUMUOLKZMZUNUOMNUPMUMUONR
      GZLKZMUQUOUOOZPUMQSUAKZLKZUSENMUMVBMUBEUCTVAURLUOUTUDUEUINUMUOUFUGUMUOCCU
      OUOUTUHUJUKTUL $.

    $( The logarithm maps its continuous domain bijectively onto the set of
       numbers with imaginary part ` -u pi < Im ( z ) < pi ` .  The negative
       reals are mapped to the numbers with imaginary part equal to ` pi ` .
       (Contributed by Mario Carneiro, 2-May-2015.) $)
    logf1o2 $p |- ( log |` D ) : D -1-1-onto-> ( `' Im " ( -u pi (,) pi ) ) $=
      ( vx clog cim cpi co cc cc0 wceq wb cfv wcel cr clt wbr wne pire a1i c1
      cima cres wf1o ccnv cneg cioo csn cdif crn wf1 logf1o f1of1 ax-mp logdmss
      wss f1ores mp2an cv wfun cdm wral f1ofun f1of fdmi sseqtr4i funimass4 crp
      wf wi ellogdm simplbi logdmn0 logcld imcld cle logimcld simpld wn lognegb
      logdmnrp syl2anc necon3bbid necomd simprd leltned mpbird cxr w3a renegcli
      mpbid rexri elioo2 syl3anbrc wfn wa imf elpreima mp2b sylanbrc mprgbir ce
      ffn simpl eliooord adantl imcl adantr ltle sylancl mpd ellogrn logef efcl
      syl recnd recni pipos gt0ne0ii cdiv caddc cmul mulid1i syl6breqr ltdivmul
      syl112anc 1e0p1 syl6breq cz csin ccos ci recoscld resincld crimd ad2antrr
      1re sylancr redivcld eqeltrrd 0z cre efeul oveq1d ax-icn mulcl recl efne0
      addcld divcan3d eqtrd simpr reefcld reim0d eqtr3d sineq0 zleltp1 syl5eqbr
      cmin df-neg mulm1i ltmuldiv syl5eqbrr zlem1lt 0re letri3 mpbir2and reim0b
      diveq0d rpefcld ex funfvima2 sylbi ssriv eqssi f1oeq3 mpbi ) ADAUAZDAUBZU
      CZAEUDFUEZFUFGZUAZUVRUCZHIUGUHZDUIZDUJZAUWDUOUVSUWDUWEDUCZUWFUKUWDUWEDULU
      MABUNZUWDUWEADUPUQUVQUWBJUVSUWCKUVQUWBUVQUWBUOZCURZDLZUWBMZCADUSZADUTZUOZ
      UWIUWLCAVAKUWGUWMUKUWDUWEDVBUMZAUWDUWNUWHUWDUWEDUWGUWDUWEDVHUKUWDUWEDVCUM
      VDVEZCAUWBDVFUQUWJAMZUWKHMZUWKELZUWAMZUWLUWRUWJUWRUWJHMZUWJNMZUWJVGMVIUWJ
      ABVJVKZUWJABVLZVMZUWRUWTNMZUVTUWTOPZUWTFOPZUXAUWRUWKUXFVNZUWRUXHUWTFVOPZU
      WRUWJUXDUXEVPZVQUWRUXIFUWTQUWRUWTFUWRUWJUEVGMZVRUWTFQUWJABVTUWRUXMUWTFUWR
      UXBUWJIQUXMUWTFJKUXDUXEUWJVSWAWBWJWCUWRUWTFUXJFNMZUWRRSUWRUXHUXKUXLWDWEWF
      UVTWGMFWGMUXAUXGUXHUXIWHKUVTFRWIWKFRWKUVTFUWTWLUQWMHNEVHZEHWNZUWLUWSUXAWO
      KWPHNEXBZHUWKUWAEWQWRWSWTCUWBUVQUWJUWBMZUXBUWJELZUWAMZWOZUWJUVQMUXOUXPUXR
      UYAKWPUXQHUWJUWAEWQWRUYAUWJXALZDLZUWJUVQUYAUWJUWEMZUYCUWJJUYAUXBUVTUXSOPZ
      UXSFVOPZUYDUXBUXTXCUYAUYEUXSFOPZUXTUYEUYGWOUXBUXSUVTFXDXEZVQZUYAUYGUYFUYA
      UYEUYGUYHWDZUYAUXSNMZUXNUYGUYFVIUXBUYKUXTUWJXFXGZRUXSFXHXIXJUWJXKWMUWJXLX
      NUYAUYBAMZUYCUVQMZUYAUYBHMZUYBNMZUYBVGMZVIUYMUXBUYOUXTUWJXMXGUYAUYPUYQUYA
      UYPWOZUWJUYRUXCUXSIJZUYRUXSFUYRUXSUYAUYKUYPUYLXGZXOZFHMUYRFRXPZSFIQUYRFRX
      QXRSZUYRUXSFXSGZIJZVUDIVOPZIVUDVOPZUYRVUFVUDITXTGZOPZUYRVUDTVUHOUYRVUDTOP
      ZUXSFTYAGZOPZUYRUXSFVUKOUYAUYGUYPUYJXGFVUBYBYCUYRUYKTNMZUXNIFOPZVUJVULKUY
      TVUMUYRYPSUXNUYRRSZVUNUYRXQSZUXSTFYDYEWFYFYGUYRVUDYHMZIYHMZVUFVUIKUYRUXSY
      ILZIJZVUQUYRUXSYJLZYKVUSYAGZXTGZELVUSIUYRVVAVUSUYRUXSUYTYLZUYRUXSUYTYMZYN
      UYRVVCUYRUYBUWJUUALZXALZXSGZVVCNUYRVVHVVGVVCYAGZVVGXSGVVCUYRUYBVVIVVGXSUX
      BUYBVVIJUXTUYPUWJUUBYOUUCUYRVVCVVGUYRVVAVVBUYRVVAVVDXOUYRYKHMVUSHMVVBHMUU
      DUYRVUSVVEXOYKVUSUUEYQUUHUYRVVFHMZVVGHMUYRVVFUXBVVFNMUXTUYPUWJUUFYOZXOZVV
      FXMXNUYRVVJVVGIQVVLVVFUUGXNZUUIUUJUYRUYBVVGUYAUYPUUKUYRVVFVVKUULVVMYRYSUU
      MUUNUYRUXSHMVUTVUQKVUAUXSUUOXNWJZYTVUDIUUPXIWFUYRVUGITUURGZVUDOPZUYRVVOTU
      EZVUDOTUUSUYRVVQFYAGZUXSOPZVVQVUDOPZUYRVVRUVTUXSOFVUBUUTUYAUYEUYPUYIXGUUQ
      UYRVVQNMZUYKUXNVUNVVSVVTKVWAUYRTYPWISUYTVUOVUPVVQUXSFUVAYEWJUVBUYRVURVUQV
      UGVVPKYTVVNIVUDUVCYQWFUYRVUDNMINMVUEVUFVUGWOKUYRUXSFUYTVUOVUCYRUVDVUDIUVE
      XIUVFUVHUXBUXCUYSKUXTUYPUWJUVGYOWFUVIUVJUYBABVJWSUWMUWOUYMUYNVIUWPUWQAUYB
      DUVKUQXNYSUVLUVMUVNUVQUWBAUVRUVOUMUVP $.

    $( The derivative of the complex logarithm function.  (Contributed by Mario
       Carneiro, 25-Feb-2015.) $)
    dvlog $p |- ( CC _D ( log |` D ) ) = ( x e. D |-> ( 1 / x ) ) $=
      ( cc ce clog cres ccnv cdv cfv wceq wtru wcel ax-mp a1i wf1o cc0 wss cdm
      co cima c1 cv cdiv cmpt ccnfld ctopn eqid crest ctop cnfldtopon toponunii
      cnfldtop restid eqcomi cr cpr cnex prid2 logdmopn csn cdif crn wf1 logf1o
      f1of1 logdmss f1ores mp2an f1ocnv cim cpi cneg cioc df-log reseq1i cnveqi
      wb wfun eff cnvimass imf fdmi sseqtri fssres ffun funcnvres2 mp2b resabs1
      3eqtri imaeq1i reseq2i eqtr4i f1oeq1 mpbi ccncf wrel relres dfrel2 eqtr3i
      wf f1of mp1i imassrn logrncn ssriv sstri cncffvrn sylibr syl5eqel cin cnt
      logcn ssid dvres mp4an dvloglem reseq12i eqtri dmeqi dmres sseqtr4i df-ss
      dvef isopn3i wn wne neirr resss eqsstri rnss eff2 frn sseli eldifsn sylib
      wa simprd mto dvcnv trud oveq2i fveq1i f1ocnvfv2 syl5eq mpteq2ia 3eqtr3i
      mpan oveq2d ) DEFBUAZGZHZITZABUBAUCZUULJZDUUKITZJZUDTZUEZDFBGZITABUBUUNUD
      TZUEUUMUUSKLADUUKUFUGJZUVBUUJBUVBUHZUVBDUITZUVBUVBUJMZUVDUVBKUVBUVCUMZUVB
      UJDDUVBUVBUVCUKULUNNUOZDUPDUQMLUPDURUSOBUVBMLBCUTOUUJBUUKPZLUUJBUUTHZPZUV
      HBUUJUUTPZUVJDQVAVBZFVCZFVDZBUVLRUVKUVLUVMFPUVNVEUVLUVMFVFNBCVGUVLUVMBFVH
      VIZBUUJUUTVJNUVIUUKKUVJUVHVRUVIEEVKHVLVMVLVNTZUAZGZHZBUAZGZUUKUVIUVSBGZHZ
      UVRUVTGZUWAUUTUWBFUVSBVOVPVQUVQDUVRXAZUVRVSUWCUWDKDDEXAZUVQDRUWEVTUVQVKSD
      VKUVPWADUPVKWBWCWDDDUVQEWEVIZUVQDUVRWFBUVRWGWHUVTUVQRUWDUWAKUVTUVRSUVQUVR
      BWAUVQDUVRUWGWCWDEUVTUVQWINWJUUJUVTEFUVSBVOWKWLWMZUUJBUVIUUKWNNWOZOLUULUU
      TBUUJWPTZUVIHZUULUUTUVIUUKUWHVQUUTWQUWKUUTKFBWRUUTWSWOWTZLBUUJUUTXAZUUTUW
      JMZUVKUWMLUVOBUUJUUTXBXCUUJDRZUUTBDWPTMUWNUWMVRUUJUVMDFBXDAUVMDUUNXEXFXGZ
      BCXMBDUUJUUTXHVIXIXJUUPSZUUJKLUWQUUKSUUJESZXKZUUJUUPUUKUUPDEITZUUJUVBXLJJ
      ZGZUUKDDRZUWFUXCUWOUUPUXBKDXNZVTUXDUWPDUUJDUVBEUVBUVCUVGXOXPZUWTEUXAUUJYD
      UVEUUJUVBMUXAUUJKUVFBCXQUUJUVBYEVIXRXSZXTEUUJYAUUJUWRRUWSUUJKUUJDUWRUWPDD
      EVTWCYBUUJUWRYCWOWJOQUUPVCZMZYFLUXHQQYGZQYHUXHQDMZUXIUXHQUVLMUXJUXIYQUXGU
      VLQUXGEVCZUVLUUPERUXGUXKRUUPUWTEUUPUXBUWTUXEUWTUXAYIYJYDWDUUPEYKNDUVLEXAU
      XKUVLRYLDUVLEYMNXGYNQDQYOYPYRYSOYTUUAUULUUTDIUWLUUBABUURUVAUUNBMZUUQUUNUB
      UDUXLUUQUUOUUKJZUUNUUOUUPUUKUXFUUCUVHUXLUXMUUNKUWIUUJBUUNUUKUUDUUHUUEUUIU
      UFUUG $.
  $}

  ${
    $d x S $.
    dvlog2.s $e |- S = ( 1 ( ball ` ( abs o. - ) ) 1 ) $.
    $( Lemma for ~ dvlog2 .  (Contributed by Mario Carneiro, 1-Mar-2015.) $)
    dvlog2lem $p |- S C_ ( CC \ ( -oo (,] 0 ) ) $=
      ( vx cc cmnf cc0 co wcel c1 cmin cfv ax-1cn 1re sseli wbr cle cr 0re a1i
      wb cioc cdif cv cabs ccom cbl cxr wss cnxmet rexri blssm mp3an eqsstri wn
      cxmt clt subid1i mnfxr iocssre w3a elioc2 simp3bi lesub2dd syl5eqbrr wceq
      mp2an ax-resscn sstri eqid cnmetdval 0le1 letrd abssubge0d eqtrd breqtrrd
      sylancr cme cnmet metcl syl3anc lenlt mpbid syl22anc mtbird eleq2s eldifd
      elbl2 con2i ssriv ) CADEFUAGZUBCUCZAHWKDWJADWKAIIUDJUEZUFKGZDBWLDUOKHZIDH
      ZIUGHZWMDUHUILIMUJZWLIIDUKULUMNWKWJHZUNWKWMAWRWKWMHZWRWSIWKWLGZIUPOZWRIWT
      POZXAUNZWRIIWKJGZWTPWRIIFJGXDPILUQWRWKFIWJQWKEUGHZFQHZWJQUHURREFUSVFZNZXF
      WRRSZIQHZWRMSZWRWKQHZEWKUPOZWKFPOZXEXFWRXLXMXNUTTURREFWKVAVFVBZVCVDWRWTXD
      UDKZXDWRWOWKDHZWTXPVELWJDWKWJQDXGVGVHNZIWKWLWLVIVJVPWRWKIXHXKWRWKFIXHXIXK
      XOFIPOWRVKSVLVMVNVOWRXJWTQHZXBXCTMWRWLDVQKHZWOXQXSXTWRVRSWOWRLSZXRIWKWLDV
      SVTIWTWAVPWBWRWNWPWOXQWSXATWNWRUISWPWRWQSYAXRWKWLIIDWGWCWDWHBWEWFWI $.

    $( The derivative of the complex logarithm function on the open unit ball
       centered at ` 1 ` , a sometimes easier region to work with than the
       ` CC \ ( -oo , 0 ] ` of ~ dvlog .  (Contributed by Mario Carneiro,
       1-Mar-2015.) $)
    dvlog2 $p |- ( CC _D ( log |` S ) ) = ( x e. S |-> ( 1 / x ) ) $=
      ( cc clog cres cdv co cc0 cdif c1 cmpt cfv wss wceq ax-mp mp2an eqid wcel
      wf cmnf cioc cv cdiv ccnfld ctopn cnt ssid csn crn wf1o logf1o f1of ssriv
      logrncn fss logdmss fssres difss cabs cmin ccom cbl cxr cnxmet ax-1cn crp
      cxmt 1rp rpxr blssm mp3an crest ctop cnfldtop cnfldtopon toponunii restid
      eqsstri eqcomi dvres mp4an dvlog2lem resabs1 oveq2i dvlog cnfldtopn blopn
      eqeltri isopn3i reseq12i 3eqtr3i resmpt eqtri ) DEBFZGHZADUAIUBHZJZKAUCZU
      DHZLZBFZABWTLZDEWRFZBFZGHZDXDGHZBUEUFMZUGMMZFZWPXBDDNWRDXDTZWRDNBDNXFXJOD
      UHDIUIJZDETZWRXLNXKXLEUJZETZXNDNXMXLXNEUKXOULXLXNEUMPAXNDWSUOUNXLXNDEUPQW
      RWRRZUQXLDWREURQDWQUSBKKUTVAVBZVCMHZDCXQDVHMSZKDSZKVDSZXRDNVEVFKVGSYAVIKV
      JPZXQKKDVKVLVSWRBDXHXDXHXHRZXHDVMHZXHXHVNSZYDXHOXHYCVOZXHVNDDXHXHYCVPVQVR
      PVTWAWBXEWODGBWRNZXEWOOBCWCZEBWRWDPWEXGXAXIBAWRXPWFYEBXHSXIBOYFBXRXHCXSXT
      YAXRXHSVEVFYBXQKKXHDXHYCWGWHVLWIBXHWJQWKWLYGXBXCOYHAWRBWTWMPWN $.
  $}

  ${
    $d j k x y A $.  $d j k x y N $.
    $( The antiderivative of the logarithm.  (Contributed by Mario Carneiro,
       21-May-2016.) $)
    advlog $p |- ( RR _D ( x e. RR+ |-> ( x x. ( ( log ` x ) - 1 ) ) ) ) =
      ( x e. RR+ |-> ( log ` x ) ) $=
      ( cr crp clog cfv c1 co cmul cmpt cdv wtru caddc cc wcel a1i adantl recnd
      ax-1cn cc0 eqtrd cv cmin wceq cdiv cpr reex prid1 wa rpre cioo crn ccnfld
      ctg ctopn recn 1re dvmptid wss rpssre eqid tgioo2 ioorp iooretop eqeltrri
      cpnf dvmptres relogcl peano2rem syl rpreccl cres dvrelog wf1o wf relogf1o
      rpcnd f1of mp1i fvres mpteq2ia syl6eq oveq2d syl5reqr 0cn dvmptc dvmptsub
      feqmptd subid1d mpteq2dva mulid2d wne rpne0 recid2d oveq12d npcan sylancl
      dvmptmul trud ) BACAUAZWSDEZFUBGZHGIJGZACWTIZUCKXBACFXAHGZFWSUDGZWSHGZLGZ
      IXCKAWSFXAXEBMMCBBMUENKBMUFUGOZKWSCNZUHZWSXIWSBNZKWSUIPQZFMNZXJROZKAWSFBU
      JUKUMEZULUNEZBBCXHXKWSMNKWSUOPFBNKXKUHZUPOKABXHUQCBURKUSOZXPXPUTZVAZXSCXO
      NKSVEUJGCXOVBSVEVCVDOZVFXJXAXJWTBNZXABNXIYBKWSVGPZWTVHVIQZXJXEXIXECNKWSVJ
      PVPZKBACXAIJGACXESUBGZIACXEIZKAWTXEFSBMMCXHXJWTYCQZYEKYGBDCVKZJGBXCJGAVLK
      YIXCBJKYIACWSYIEZIXCKACBYICBYIVMCBYIVNKVOCBYIVQVRWGACYJWTWSCDVSVTWAWBWCXN
      SMNZXJWDOKAFSBXOXPMBCXHXMXQROYKXQWDOKAFBXHXMKROWEXRXTXSYAVFWFKACYFXEXJXEY
      EWHWITWQKACXGWTXJXGXAFLGZWTXJXDXAXFFLXJXAYDWJXJWSXLXIWSSWKKWSWLPWMWNXJWTM
      NXMYLWTUCYHRWTFWOWPTWITWR $.

    $( The antiderivative of a power of the logarithm.  (Set ` A = 1 ` and
       multiply by ` ( -u 1 ) ^ N x. N ! ` to get the antiderivative of
       ` log ( x ) ^ N ` itself.)  (Contributed by Mario Carneiro,
       22-May-2016.) $)
    advlogexp $p |- ( ( A e. RR+ /\ N e. NN0 ) ->
      ( RR _D ( x e. RR+ |-> ( x x. sum_ k e. ( 0 ... N )
        ( ( ( log ` ( A / x ) ) ^ k ) / ( ! ` k ) ) ) ) ) =
      ( x e. RR+ |-> ( ( ( log ` ( A / x ) ) ^ N ) / ( ! ` N ) ) ) ) $=
      ( crp wcel cr cc0 co cdiv cfv cexp cmul cmpt cdv c1 cc syl wceq a1i vj vy
      cn0 wa cfz clog cfa csu cfzo caddc cmin fzfid rpcn adantl rpdivcl adantlr
      cv relogcld elfznn0 reexpcl syl2an cn faccl nndivred fsummulc2 cuz simplr
      recnd nn0uz syl6eleq adantr mulcld oveq2 fveq2 fac0 syl6eq oveq12d oveq2d
      fsum1p exp0d oveq1d ax-1cn div1i mulid1d eqtrd cz 1z nn0z ad2antlr oveq1i
      0p1e1 wss 0z fzp1ss ax-mp eqsstr3i sseli sylan2 fsumshftm sumeq1i syl5eqr
      1m1e0 fzoval sumeq1d 3eqtr4d 3eqtrd mpteq2dva cpr reex prid1 cioo crn ctg
      ccnfld ctopn recn dvmptid rpssre eqid tgioo2 cpnf ioorp iooretop eqeltrri
      dvmptres sylancl an32s 3impa cneg negex expcl syl2anr nncnd nnne0d divcld
      cvv wne 0cn oveq1 negeqd fzofi elfzouz syl6eleqr peano2nn0 reexpcld subcl
      cfn fsumcl subcld cnex prid2 id simplll relogdivd relogcl ad2antrr dvmptc
      simpr rpreccld cres dvrelog wf1o wf relogf1o f1of fvres mpteq2ia syl5reqr
      mp1i feqmptd dvmptsub df-neg mpteq2i syl6eqr ovex nn0p1nn dvexp dvmptdivc
      nn0cnd pncan facp1 peano2cn mulcomd divcan5d dvmptco rpcnd mulneg2d rpne0
      divrecd dvmptmul mulid2d rerpdivcld mulneg1d divcan1d negsubd fsumtscopo2
      eqtr4d dvmptfsum dvmptadd pncan3 sylancr ) BEFZDUCFZUDZGAEAUQZHDUEIZBUXEJ
      IZUFKZCUQZLIZUXIUGKZJIZCUHMIZNZOIGAEUXEHDUIIZUXEUXHUAUQZPUJIZLIZUXQUGKZJI
      ZMIZUAUHZUJIZNZOIAEPUXHDLIZDUGKZJIZPUKIZUJIZNAEUYGNUXDUXNUYDGOUXDAEUXMUYC
      UXDUXEEFZUDZUXMUXFUXEUXLMIZCUHUXEUXHHLIZPJIZMIZHPUJIZDUEIZUYLCUHZUJIUYCUY
      KUXFUXLUXECUYKHDULUYJUXEQFZUXDUXEUMZUNZUYKUXIUXFFZUDZUXLVUCUXJUXKUYKUXHGF
      ZUXIUCFZUXJGFVUBUYKUXGUXBUYJUXGEFUXCBUXEUOUPURZUXIDUSZUXHUXIUTVAVUCVUEUXK
      VBFVUBVUEUYKVUGUNUXIVCRVDVHZVEUYKUYLUYOCHDUYKDUCHVFKZUXBUXCUYJVGZVIVJZVUC
      UXEUXLUYKUYSVUBVUAVKVUHVLZUXIHSZUXLUYNUXEMVUMUXJUYMUXKPJUXIHUXHLVMVUMUXKH
      UGKPUXIHUGVNVOVPVQZVRVSUYKUYOUXEUYRUYBUJUYKUYOUXEPMIUXEUYKUYNPUXEMUYKUYNP
      PJIPUYKUYMPPJUYKUXHUYKUXHVUFVHZVTWAPWBWCVPZVRUYKUXEVUAWDWEUYKPDUEIZUYLCUH
      ZPPUKIZDPUKIUEIZUYAUAUHUYRUYBUYKUYLUYACUAPPDPWFFUYKWGTZVVAUXCDWFFZUXBUYJD
      WHWIZUXIVUQFUYKVUBUYLQFVUQUXFUXIVUQUYQUXFUYPPDUEWKWJZHWFFUYQUXFWLWMHDWNWO
      WPWQVULWRUXIUXQSZUXLUXTUXEMVVEUXJUXRUXKUXSJUXIUXQUXHLVMUXIUXQUGVNVQZVRWSU
      YRVURSUYKUYQVUQUYLCVVDWTTUYKUXOVUTUYAUAUYKUXOVUSDUIIZVUTVUSHDUIXBWJUYKVVB
      VVGVUTSVVCVUSDXCRXAXDXEVQXFXGVRUXDAUXEPUYBUYHGQQEGGQXHZFZUXDGQXIXJZTZVUAP
      QFZUYKWBTUXDAUXEPGXKXLXMKZXNXOKZQGEVVKUXEGFZUYSUXDUXEXPUNVVLUXDVVOUDWBTUX
      DAGVVKXQEGWLZUXDXRTVVNVVNXSZXTZVVQEVVMFZUXDHYAXKIEVVMYBHYAYCYDZTZYEZUYKUX
      OUYAUAUXOUUGFZUYKHDUUAZTUYKUXPUXOFZUDZUXEUXTUYKUYSVWEVUAVKZVWFUXTVWFUXRUX
      SUYKVUDUXQUCFZUXRGFVWEVUFVWEUXPUCFZVWHVWEUXPVUIUCUXPHDUUBVIUUCZUXPUUDZRZU
      XHUXQUTVAVWFVWHUXSVBFZVWEVWHUYKVWLUNUXQVCZRVDVHZVLZUUHUYKUYGQFZVVLUYHQFUY
      KUYGUYKUYEUYFUYKUXHDVUFVUJUUEUXCUYFVBFUXBUYJDVCWIVDVHZWBUYGPUUFYFUXDGAEUY
      BNOIAEUXOUXTUXHUXPLIZUXPUGKZJIZUKIZUAUHZNAEUYHNUXDAUYAVXBGUAUXOVVMVVNEVVR
      VVQVVKVWAVWCUXDVWDTUXDVWEUYJUYAQFZUXDUYJVWEVXDVWPYGYHUXDVWEUYJVXBQFZUXDUY
      JVWEVXEVWFUXTVXAVWOVWFVXAVWFVWSVWTUYKVUDVWIVWSGFVWEVUFVWJUXHUXPUTVAVWFVWI
      VWTVBFZVWEVWIUYKVWJUNUXPVCZRVDZVHZUUIYGYHUXDVWEUDZGAEUYANOIAEPUXTMIZVXAUX
      EJIZYIZUXEMIZUJIZNAEVXBNVXJAUXEPUXTVXMGQYPEVVIVXJVVJTZUYJUYSVXJUYTUNZVVLV
      XJUYJUDZWBTUXDGAEUXENOIAEPNSVWEVWBVKUXDUYJVWEUXTQFVWOYGVXMYPFVXRVXLYJTVXJ
      GAEUXTNOIAEVXAPUXEJIZYIZMIZNAEVXMNVXJAUBUXHVXTUBUQZUXQLIZUXSJIZVYBUXPLIZV
      WTJIZGQUXTVXAYPQEQVXPQVVHFVXJGQUUJUUKTZUXDUYJUXHQFVWEVUOUPVXTYPFVXRVXSYJT
      VXJVYBQFZUDZVYCUXSVYHVYHVWHVYCQFVXJVYHUULZVXJVWIVWHVWEVWIUXDVWJUNZVWKRZVY
      BUXQYKYLZVXJUXSQFVYHVXJUXSVXJVWHVWMVYLVWNRZYMZVKVXJUXSHYQVYHVXJUXSVYNYNZV
      KYOVYIVYEVWTVYHVYHVWIVYEQFVXJVYJVYKVYBUXPYKYLZVXJVWTQFVYHVXJVWTVXJVWIVXFV
      YKVXGRYMVKZVYIVWTVYIVWIVXFVXJVWIVYHVYKVKZVXGRYNZYOVXJGAEUXHNZOIZAEHVXSUKI
      ZNZAEVXTNVXJWUBGAEBUFKZUXEUFKZUKIZNZOIWUDVXJWUAWUHGOVXJAEUXHWUGVXRBUXEUXB
      UXCVWEUYJUUMVXJUYJUURZUUNXGVRVXJAWUEHWUFVXSGQEEVXPVXJWUEQFZUYJVXJWUEUXBWU
      EGFUXCVWEBUUOUUPVHZVKHQFZVXRYRTVXJAWUEHGVVMVVNQGEVXPVXJWUJVVOWUKVKWULVXJV
      VOUDYRTVXJAWUEGVXPWUKUUQVVPVXJXRTVVRVVQVVSVXJVVTTYEVXRWUFVXRUXEWUIURVHVXR
      UXEWUIUUSZVXJAEVXSNGUFEUUTZOIGAEWUFNZOIAUVAVXJWUNWUOGOVXJWUNAEUXEWUNKZNWU
      OVXJAEGWUNEGWUNUVBEGWUNUVCVXJUVDEGWUNUVEUVIUVJAEWUPWUFUXEEUFUVFUVGVPVRUVH
      UVKWEAEVXTWUCVXSUVLUVMUVNVXJQUBQVYDNOIUBQUXQVYBUXQPUKIZLIZMIZUXSJIZNUBQVY
      FNVXJUBVYCWUSUXSQYPQVYGVYMWUSYPFVYIUXQWURMUVOTVXJUXQVBFZQUBQVYCNOIUBQWUSN
      SVXJVWIWVAVYKUXPUVPRZUBUXQUVQRVYOVYPUVRVXJUBQWUTVYFVYIWUTUXQVYEMIZUXQVWTM
      IZJIVYFVYIWUSWVCUXSWVDJVYIWURVYEUXQMVYIWUQUXPVYBLVYIUXPQFZVVLWUQUXPSVXJWV
      EVYHVXJUXPVYKUVSVKZWBUXPPUVTYFVRVRVYIUXSVWTUXQMIZWVDVYIVWIUXSWVGSVYSUXPUW
      ARVYIVWTUXQVYRVYIWVEUXQQFWVFUXPUWBRZUWCWEVQVYIVYEVWTUXQVYQVYRWVHVYTVXJUXQ
      HYQVYHVXJUXQWVBYNVKUWDWEXGWEVYBUXHSZVYCUXRUXSJVYBUXHUXQLYSWAWVIVYEVWSVWTJ
      VYBUXHUXPLYSWAUWEVXJAEVYAVXMVXRVYAVXAVXSMIZYIVXMVXRVXAVXSUXDUYJVWEVXAQFVX
      IYGZVXRVXSWUMUWFUWGVXRVXLWVJVXRVXAUXEWVKVXQUYJUXEHYQZVXJUXEUWHUNZUWIYTUWQ
      XGWEUWJVXJAEVXOVXBUXDUYJVWEVXOVXBSVWFVXOUXTVXAYIZUJIVXBVWFVXKUXTVXNWVNUJV
      WFUXTVWOUWKVWFVXNVXLUXEMIZYIWVNVWFVXLUXEVWFVXLVWFVXAUXEVXHUXDUYJVWEVGUWLV
      HVWGUWMVWFWVOVXAVWFVXAUXEVXIVWGUXDVWEUYJWVLWVMYGUWNYTWEVQVWFUXTVXAVWOVXIU
      WOWEYGXGWEUWRUXDAEVXCUYHUYKVXCUYGUYNUKIUYHUYKUXLVXAUXTUYNUACUYGHDUXIUXPSU
      XJVWSUXKVWTJUXIUXPUXHLVMUXIUXPUGVNVQVVFVUNUXIDSUXJUYEUXKUYFJUXIDUXHLVMUXI
      DUGVNVQVUKVUHUWPUYKUYNPUYGUKVUPVRWEXGWEUWSUXDAEUYIUYGUYKVVLVWQUYIUYGSWBVW
      RPUYGUWTUXAXGXF $.
  $}

  $( Lemma for ~ efopn .  (Contributed by Mario Carneiro, 23-Apr-2015.)
     (Revised by Mario Carneiro, 8-Sep-2015.) $)
  efopnlem1 $p |- ( ( ( R e. RR+ /\ R < pi ) /\
    A e. ( 0 ( ball ` ( abs o. - ) ) R ) ) -> ( abs ` ( Im ` A ) ) < pi ) $=
    ( crp wcel cpi clt wbr wa cc0 cabs cmin cfv co cc ad2antrr syl cr wb abscld
    cle ccom cbl cim ccnv cico cima simpr cxr wceq rpxr eqid cnbl0 eleqtrrd wfn
    wf absf ffn elpreima mp2b simplbi imcld recnd rpre pire a1i absimle simprbi
    w3a 0re elico2 sylancr mpbid simp3d lelttrd simplr lttrd ) BCDZBEFGZHZAIBJK
    UAZUBLMZDZHZAUCLZJLZBEWCWDWCWDWCAWCAJUDIBUEMZUFZDZANDZWCAWAWGVSWBUGWCBUHDZW
    GWAUIVQWJVRWBBUJOZVTBVTUKULPUMZWHWIAJLZWFDZNQJUOJNUNWHWIWNHRUPNQJUQNAWFJURU
    SZUTPZVAVBSZVQBQDVRWBBVCOZEQDWCVDVEWCWEWMBWQWCAWPSWRWCWIWEWMTGWPAVFPWCWMQDZ
    IWMTGZWMBFGZWCWNWSWTXAVHZWCWHWNWLWHWIWNWOVGPWCIQDWJWNXBRVIWKIBWMVJVKVLVMVNV
    QVRWBVOVP $.

  ${
    $d r w x y z J $.  $d x R $.  $d r x y z S $.
    efopn.j $e |- J = ( TopOpen ` CCfld ) $.
    $( Lemma for ~ efopn .  (Contributed by Mario Carneiro, 2-May-2015.) $)
    efopnlem2 $p |- ( ( R e. RR+ /\ R < pi ) ->
      ( exp " ( 0 ( ball ` ( abs o. - ) ) R ) ) e. J ) $=
      ( wcel cpi clt wbr wa ce cc0 cfv co cima cc wss clog cres ccnv cim wceq
      crp cabs cmin ccom cbl cmnf cioc cdif crest cneg csn crn wf1o wfun logf1o
      vx wfn f1orn simprbi funcnvres mp2b df-log cnveqi wrel relres dfrel2 mpbi
      eqtri reseq1i imassrn logrn sseqtri resabs1 ax-mp 3eqtri imaeq1i cioo cxr
      cv cxmt cnxmet a1i rpxr adantr blssm syl3anc sselda cr imcld efopnlem1 wb
      0cn abslt sylancl mpbid simpld simprd w3a renegcli rexri elioo2 syl3anbrc
      pire mp2an wf imf ffn elpreima sylanbrc ex ssrdv df-ima wfo logf1o2 f1ofo
      eqid forn syl6sseqr resima2 syl syl5eq ccn ccncf logcn ssid ctop cnfldtop
      difss cnfldtopon toponunii restid eqcomi cncfcn eleqtri cnfldtopn sylancr
      blopn cnima eqeltrrd ccnfld ctopn logdmopn eleqtrri restopn2 sylib ) AUAD
      ZAEFGZHZIJAUBUCUDZUEKLZMZBDZUUKNUFJUGLZUHZOZUUHUUKBUUNUILZDZUULUUOHZUUHPU
      UNQZRZUUJMZUUKUUPUUHUVAIPUUNMZQZUUJMZUUKUUTUVCUUJUUTPRZUVBQZISRZEUJZEUGLM
      ZQZUVBQZUVCNJUKUHZPULZPUMZUVEUNZUUTUVFTUOUVNPUVLUQUVOUVLPURUSUUNPUTVAUVEU
      VJUVBUVEUVJRZRZUVJPUVPVBVCUVJVDUVQUVJTIUVIVEUVJVFVGVHVIUVBUVIOUVKUVCTUVBU
      VMUVIPUUNVJVKVLIUVBUVIVMVNVOVPUUHUUJUVBOUVDUUKTUUHUUJUVGUVHEVQLZMZUVBUUHU
      PUUJUVSUUHUPVSZUUJDZUVTUVSDZUUHUWAHZUVTNDZUVTSKZUVRDZUWBUUHUUJNUVTUUHUUIN
      VTKDZJNDZAVRDZUUJNOUWGUUHWAWBZUWHUUHWLWBZUUFUWIUUGAWCWDZUUIJANWEWFWGZUWCU
      WEWHDZUVHUWEFGZUWEEFGZUWFUWCUVTUWMWIZUWCUWOUWPUWCUWEUBKEFGZUWOUWPHZUVTAWJ
      UWCUWNEWHDUWRUWSWKUWQXCUWEEWMWNWOZWPUWCUWOUWPUWTWQUVHVRDEVRDUWFUWNUWOUWPW
      RWKUVHEXCWSWTEXCWTUVHEUWEXAXDXBNWHSXESNUQUWBUWDUWFHWKXFNWHSXGNUVTUVRSXHVA
      XIXJXKUVBUUSULZUVSPUUNXLUUNUVSUUSUMUUNUVSUUSXMUXAUVSTUUNUUNXPZXNUUNUVSUUS
      XOUUNUVSUUSXQVAVHXRIUUJUVBXSXTYAUUHUUSUUPBYBLZDUUJBDZUVAUUPDUUSUUNNYCLZUX
      CUUNUXBYDUUNNONNOUXEUXCTNUUMYHNYEUUNNBUUPBCUUPXPBNUILZBBYFDZUXFBTBCYGZBYF
      NNBBCYIYJYKVNYLYMXDYNUUHUWGUWHUWIUXDUWJUWKUWLUUIJABNBCYOYQWFUUJUUSUUPBYRY
      PYSUXGUUNBDUUQUURWKUXHUUNYTUUAKBUUNUXBUUBCUUCUUNUUKBUUDXDUUEWP $.

    $( The exponential map is an open map.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    efopn $p |- ( S e. J -> ( exp " S ) e. J ) $=
      ( vz vy vw wcel ce wss wa wrex cfv cc clt cabs co cc0 wceq syl2anc wb cpi
      vx vr cv cima wral wbr cmin ccom cbl crp ctopon cnfldtopon toponss sselda
      mpan cxmt cnxmet w3a pipos elrpii cnfldtopn mopni3 mpan2 mp3an1 imass2 wi
      pire cdiv cmpt ccnv crab cin crn imassrn eff frn ax-mp sstri sseqin2 mpbi
      wf cxr rpxr blssm sylan2 ad2antrr simp-4l subcld subid1d fveq2d cnmetdval
      0cn sylancl 3eqtr4d simpr a1i simpllr adantr rpxrd elbl3 syl22anc eqbrtrd
      mpbid mpbird efsub fveq2 eqeq1d rspcev eqeq2d rexbidv syl5ibcom rexlimdva
      eqid oveq1 cmul eqcom simplr syl mp3an12 wne efne0 divmuld syl5bb pncan2d
      efcl caddc eqtr4d addcld efadd sylbid impbid wfn fvelimab sylancr 3bitr4d
      eqeq2 ffn rabbi2dva syl5eqr mptpreima syl6eqr ccn ccncf divccncf syl6eleq
      cncfcn1 efopnlem2 adantll cnima eqeltrd wfun cdm ffun syl6sseqr funfvima2
      blcntr fdmi mpd eleq2 sseq1 anbi12d expr syl5 sylc ralrimiva eleq1 anbi1d
      expimpd ralima ctop cnfldtop eltop2 sylibr ) ABGZDUDZEUDZGZUVQHAUEZIZJZEB
      KZDUVSUFZUVSBGZUVOUWCUBUDZHLZUVQGZUVTJZEBKZUBAUFZUVOUWIUBAUVOUWEAGZJUWEMG
      ZUCUDZUANUGZUWEUWMOUHUIZUJLZPZAIZJZUCUKKZUWIUVOAMUWEBMULLGUVOAMIZBCUMABMU
      NUPZUOUWOMUQLGZUVOUWKUWTURUXCUVOUWKUSUAUKGUWTUAVHUTVAUCAUWOUWEUABMBCVBVCV
      DVEUWLUWSUWIUCUKUWLUWMUKGZJZUWNUWRUWIUWRHUWQUEZUVSIZUXEUWNJZUWIUWQAHVFUXH
      UXFBGZUWFUXFGZUXGUWIVGUXHUXFDMUVPUWFVIPZVJZVKHQUWMUWPPZUEZUEZBUXHUXFUXKUX
      NGZDMVLZUXOUXHUXFMUXFVMZUXQUXFMIUXRUXFRUXFHVNZMHUWQVOMMHWBZUXSMIVPMMHVQVR
      VSUXFMVTWAUXHUXPDMUXFUXHUVPMGZJZUVQHLZUVPRZEUWQKZFUDZHLZUXKRZFUXMKZUVPUXF
      GZUXPUYBUYEUYIUYBUYDUYIEUWQUYBUVQUWQGZJZUYGUYCUWFVIPZRZFUXMKZUYDUYIUYLUVQ
      UWEUHPZUXMGZUYPHLZUYMRZUYOUYLUYQUYPQUWOPZUWMNUGZUYLUYTUVQUWEUWOPZUWMNUYLU
      YPQUHPZOLZUYPOLZUYTVUBUYLVUCUYPOUYLUYPUYLUVQUWEUYBUWQMUVQUXEUWQMIZUWNUYAU
      XDUWLUWMWCGZVUFUWMWDUXCUWLVUGVUFURUWOUWEUWMMWEVEWFZWGZUOZUWLUXDUWNUYAUYKW
      HZWIZWJWKUYLUYPMGZQMGZUYTVUDRVULWMUYPQUWOUWOXNZWLWNUYLUVQMGZUWLVUBVUERVUJ
      VUKUVQUWEUWOVUOWLSWOUYLUYKVUBUWMNUGZUYBUYKWPUYLUXCVUGUWLVUPUYKVUQTUXCUYLU
      RWQZUYLUWMUYBUXDUYKUWLUXDUWNUYAWRZWSWTZVUKVUJUVQUWOUWEUWMMXAXBXDXCUYLUXCV
      UGVUNVUMUYQVUATVURVUTVUNUYLWMWQVULUYPUWOQUWMMXAXBXEUYLVUPUWLUYSVUJVUKUVQU
      WEXFSUYNUYSFUYPUXMUYFUYPRUYGUYRUYMUYFUYPHXGXHXISUYDUYNUYHFUXMUYDUYMUXKUYG
      UYCUVPUWFVIXOXJXKXLXMUYBUYHUYEFUXMUYBUYFUXMGZJZUYHUWFUYGXPPZUVPRZUYEUYHUX
      KUYGRVVBVVDUYGUXKXQVVBUVPUWFUYGUXHUYAVVAXRVVBUWLUWFMGZUWLUXDUWNUYAVVAWHZU
      WEYFZXSVVBUYFMGZUYGMGUYBUXMMUYFUYBVUGUXMMIZUYBUWMVUSWTUXCVUNVUGVVIURWMUWO
      QUWMMWEXTXSZUOZUYFYFXSVVBUWLUWFQYAZVVFUWEYBZXSYCYDVVBUYCVVCRZEUWQKZVVDUYE
      VVBUWEUYFYGPZUWQGZVVPHLZVVCRZVVOVVBVVQVVPUWEUWOPZUWMNUGZVVBVVTUYFQUWOPZUW
      MNVVBVVPUWEUHPZOLZUYFQUHPZOLZVVTVWBVVBVWCVWEOVVBVWCUYFVWEVVBUWEUYFVVFVVKY
      EVVBUYFVVKWJYHWKVVBVVPMGZUWLVVTVWDRVVBUWEUYFVVFVVKYIZVVFVVPUWEUWOVUOWLSVV
      BVVHVUNVWBVWFRVVKWMUYFQUWOVUOWLWNWOVVBVVAVWBUWMNUGZUYBVVAWPVVBUXCVUGVUNVV
      HVVAVWITUXCVVBURWQZVVBUWMUYBUXDVVAVUSWSWTZVUNVVBWMWQVVKUYFUWOQUWMMXAXBXDX
      CVVBUXCVUGUWLVWGVVQVWATVWJVWKVVFVWHVVPUWOUWEUWMMXAXBXEVVBUWLVVHVVSVVFVVKU
      WEUYFYJSVVNVVSEVVPUWQUVQVVPRUYCVVRVVCUVQVVPHXGXHXISVVDVVNUYDEUWQVVCUVPUYC
      YQXKXLYKXMYLUYBHMYMZVUFUYJUYETUXTVWLVPMMHYRVRZVUIEMUWQUVPHYNYOUYBVWLVVIUX
      PUYITVWMVVJFMUXMUXKHYNYOYPYSYTDMUXKUXNUXLUXLXNZUUAUUBUXHUXLBBUUCPZGUXNBGZ
      UXOBGUXHUXLMMUUDPZVWOUXHVVEVVLUXLVWQGUWLVVEUXDUWNVVGWGUWLVVLUXDUWNVVMWGDU
      WFUXLVWNUUESBCUUGUUFUXDUWNVWPUWLUWMBCUUHUUIUXNUXLBBUUJSUUKUXEUXJUWNUXEUWE
      UWQGZUXJUXCUWLUXDVWRURUWOUWEUWMMUUQVEUXEHUULZUWQHUUMZIVWRUXJVGUXTVWSVPMMH
      UUNVRUXEUWQMVWTVUHMMHVPUURUUOUWQUWEHUUPYOUUSWSUXIUXJUXGUWIUWHUXJUXGJEUXFB
      UVQUXFRUWGUXJUVTUXGUVQUXFUWFUUTUVQUXFUVSUVAUVBXIUVCSUVDUVIXMUVEUVFUVOVWLU
      XAUWCUWJTVWMUXBUWBUWIDUBMAHUVPUWFRZUWAUWHEBVXAUVRUWGUVTUVPUWFUVQUVGUVHXKU
      VJYOXEBUVKGUWDUWCTBCUVLDEUVSBUVMVRUVN $.
  $}

  ${
    $d j k m n r x y z A $.  $d n S $.
    $( Lemma for ~ logtayl .  (Contributed by Mario Carneiro, 1-Apr-2015.) $)
    logtayllem $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) -> seq 0 ( + ,
      ( n e. NN0 |-> ( if ( n = 0 , 0 , ( 1 / n ) ) x. ( A ^ n ) ) ) )
        e. dom ~~> ) $=
      ( cc wcel cabs cfv c1 clt wbr cn0 cexp co cc0 wceq cdiv a1i cr adantl cle
      cmul vk wa cmpt cif nn0uz 1nn0 oveq2 eqid ovex fvmpt abscl adantr reexpcl
      cv sylan eqeltrd eqeq1 ifbieq2d oveq12d 0cn wne nn0cn df-ne biimpri reccl
      wn syl2an ifclda expcl adantlr mulcld caddc cseq cmin cli cdm recnd simpr
      absidm eqbrtrd geolim seqex breldm syl 1re cn elnnuz nnrecre nnnn0 sylan2
      cuz absmuld crp rpreccld rpge0d absidd simpl absexp eqtrd absge0d breqtrd
      nnrp nnge1 0lt1 nngt0 lerec syl22anc mpbid ax-1cn div1i syl6breq lemul1ad
      nnre nnne0 neneqd iffalse oveq1d fveq2d oveq2d 3brtr4d sylan2br cvgcmpce
      wb ) ACDZAEFZGHIZUBZGUABJYEBUNZKLZUCZBJYHMNZMGYHOLZUDZAYHKLZTLZUCZMGJUEGJ
      DYGUFPYGUAUNZJDZUBZYQYJFZYEYQKLZQYRYTUUANZYGBYQYIUUAJYJYHYQYEKUGYJUHYEYQK
      UIUJRZYGYEQDZYRUUAQDZYDUUDYFAUKULZYEYQUMUOZUPYSYQYPFZYQMNZMGYQOLZUDZAYQKL
      ZTLZCYRUUHUUMNZYGBYQYOUUMJYPYHYQNZYMUUKYNUULTUUOYKUUIYLUUJMYHYQMUQYHYQGOU
      GURYHYQAKUGUSYPUHUUKUULTUIUJRZYSUUKUULYSUUIMUUJCMCDYSUUIUBUTPYSYQCDZYQMVA
      ZUUJCDUUIVFZYRUUQYGYQVBRUURUUSYQMVCVDYQVEVGVHYDYRUULCDZYFAYQVIVJZVKUPYGVL
      YJMVMZGGYEVNLZOLZVOIUVBVOVPDYGYEUAYJYGYEUUFVQYGYEEFZYEGHYDUVEYENYFAVSULYD
      YFVRVTUUCWAUVBUVDVOVLYJMWBGUVCOUIWCWDGQDZYGWEPYQGWKFDYGYQWFDZUUHEFZGYTTLZ
      SIYQWGYGUVGUBZUUJUULTLZEFZGUUATLZUVHUVISUVJUVLUUJUUATLZUVMSUVJUVLUUJEFZUU
      LEFZTLUVNUVJUUJUULUVJUUJUVGUUJQDYGYQWHRZVQUVGYGYRUUTYQWIZUVAWJZWLUVJUVOUU
      JUVPUUATUVJUUJUVQUVJUUJUVJYQUVGYQWMDYGYQXBRWNWOWPYGYDYRUVPUUANUVGYDYFWQUV
      RAYQWRVGZUSWSUVJUUJGUUAUVQUVFUVJWEPZUVGYGYRUUEUVRUUGWJUVJMUVPUUASUVJUULUV
      SWTUVTXAUVJUUJGGOLZGSUVJGYQSIZUUJUWBSIZUVGUWCYGYQXCRUVJUVFMGHIZYQQDZMYQHI
      ZUWCUWDYCUWAUWEUVJXDPUVGUWFYGYQXMRUVGUWGYGYQXERGYQXFXGXHGXIXJXKXLVTUVJUUH
      UVKEUVJUUHUUMUVKUVGYGYRUUNUVRUUPWJUVJUUKUUJUULTUVJUUSUUKUUJNUVJYQMUVGUURY
      GYQXNRXOUUIMUUJXPWDXQWSXRUVJYTUUAGTUVGYGYRUUBUVRUUCWJXSXTYAYB $.

    $( The Taylor series for ` -u log ( 1 - A ) ` .  (Contributed by Mario
       Carneiro, 1-Apr-2015.) $)
    logtayl $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) -> seq 1 ( + ,
      ( k e. NN |-> ( ( A ^ k ) / k ) ) ) ~~> -u ( log ` ( 1 - A ) ) ) $=
      ( vn vy vj cc wcel cabs cfv c1 wa cn0 cc0 wceq cdiv co cexp cmul a1i wtru
      vr vx vm vz clt wbr caddc cv cif cmpt cseq cmin clog cneg cli cn nn0uz cz
      csu 0z weq eqeq1 oveq2 ifbieq2d oveq12d eqid fvmpt adantl 0cn wn wo simpr
      sylib ord con1d imp nnrecred recnd ifclda expcl adantlr mulcld logtayllem
      ovex cnmetdval sylancl adantr fveq2d eqtrd eqbrtrd cxr cnxmet ax-mp elbl3
      wb 1rp mpanl12 sylancr mpbird tru ax-1cn wss mp3an sseli wne eqbrtrrd syl
      fveq2 logcld fmptd cdm cr crab cle c2 rexrd eqcomd oveq1d mpteq2ia syl2an
      c0ex oveq1 oveq2d mpteq2dv nn0ex mptex mp1i wf fveq1d sumeq2dv sylan2 cdv
      mpbid cvv neg1cn syl6eq negeqd cuz eqtr4d cfz elnn0 isumclim2 ccom subid1
      cbl simpl cxmt crp rpxr blssm subcl abscld subid1d ibi gtned abs1 syl5eqr
      necon3i subeq0 necon3bid negcld ccnv csup cico absge0d peano2re rehalfcld
      cima cpnf cicc iccssxr ifex mpteq2i nn0cn df-ne biimpri reccl recn eleq1d
      seqeq3d rabbiia supeq1i sseldi 1re avglt1 0re lelttrd ltled absidd avglt2
      radcnvcl syl2anc eqeltrd radcnvle xrltletrd w3a elico2 mpbir3and wfn absf
      ffn elpreima mp2b sylanbrc wral ccncf cnvimass fdmi sseqtri eqtr2d psercn
      cncff fmpt sylibr r19.21bi cnex prid2 nncan elbl cmnf cioc cdif dvlog2lem
      eldifad logdmn0 ccnfld ctopn dvmptc dvmptid dvmptsub df-neg syl6eqr crest
      ctop cnfldtop cnfldtopon toponunii restid eqcomi cnfldtopn blopn dvmptres
      cpr cres dvlog2 crn csn wf1o logf1o f1of logdmss sstri fssres mp2an fvres
      feqmptd syl5reqr dvmptco dvmptneg reccld mulcom mulm1d negnegd dmeqd mprg
      dmmptg sumex cbvsumv pserdv2 ssriv nnnn0 nnne0 neneqd iffalse nncn recidd
      nnm1nn0 mulid2d nnuz 1e0p1 fveq2i eqtri 1z isumshft pncan2 sumeq2i 3eqtrd
      geoisum blcntr subid1i log1 neg0 eqeq1d simpll simplr expcld mul02d 0expd
      syl6eqel mul01d ifbothda eqimssi orci sumz dv11cn negex sumeq2sdv 3eqtr3d
      cfn breqtrrd seqex elnnuz sylbi addid2 1nn0 eleqtri ffvelrn elfz1eq 1m1e0
      oveq2i eleq2s 0nn0 iftrue syl5eq sylan9eqr seqid divrec2d sylan2br seqfeq
      id 3eqtr4d climeq ) AFGZAHIZJUEUFZKZUGBLBUHZMNZMJVYQOPZUIZAVYQQPZRPZUJZMU
      KZJAULPZUMIZUNZUOUFUGBUPWUAVYQOPZUJZJUKZWUGUOUFVYPWUDLCUHZMNZMJWUKOPZUIZA
      WUKQPZRPZCUSZWUGUOVYPWUPCWUCMLUQMURGZVYPUTSWUKLGZWUKWUCIZWUPNZVYPBWUKWUBW
      UPLWUCBCVAZVYTWUNWUAWUORWVBVYRWULVYSWUMMVYQWUKMVBVYQWUKJOVCVDVYQWUKAQVCZV
      EWUCVFZWUNWUORWDVGVHZVYPWUSKZWUNWUOWVFWULMWUMFMFGZWVFWULKVISWVFWULVJZKZWU
      MWVIWUKWVFWVHWUKUPGZWVFWVJWULWVFWVJWULWVFWUSWVJWULVKZVYPWUSVLWUKUUAZVMVNV
      OVPVQVRVSVYMWUSWUOFGZVYOAWUKVTWAZWBABWCUUBVYPAMJHULUUCZUUEIZPZGZWUGWUQNVY
      PWVRAMWVOPZJUEUFZVYPWVSVYNJUEVYPWVSAMULPZHIZVYNVYPVYMWVGWVSWWBNVYMVYOUUFZ
      VIAMWVOWVOVFZWEWFVYPWWAAHVYMWWAANVYOAUUDWGWHWIVYMVYOVLWJVYPWVGVYMWVRWVTWO
      ZVIWWCWVOFUUGIGZJWKGZWVGVYMKWWEWLJUUHGZWWGWPJUUIWMZAWVOMJFWNWQWRWSWVRADWV
      QJDUHZULPZUMIZUNZUJZIZADWVQLWUNWWJWUKQPZRPZCUSZUJZIZWUGWUQTWWOWWTNWVRWTTA
      WWNWWSTMMJWWNWWSWVQWVQVFWVGTVISWWGTWWISTDWVQWWMFWWNWWJWVQGZWWMFGTWXAWWLWX
      AWWKWXAJFGZWWJFGZWWKFGZXAWVQFWWJWWFWVGWWGWVQFXBZWLVIWWIWVOMJFUUJXCZXDZJWW
      JUUKZWRZWXAWWKMXEZJWWJXEZWXAJWWJHIZXEWXKWXAWXLJWXAWWJWXGUULZWXAWWJMWVOPZW
      XLJUEWXAWXNWWJMULPZHIZWXLWXAWXCWVGWXNWXPNWXGVIWWJMWVOWWDWEWFWXAWXOWWJHWXA
      WWJWXGUUMWHWIWXAWXNJUEUFZWXAWVGWXCWXAWXQWOZVIWXGWWFWWGWVGWXCKWXRWLWWIWWJW
      VOMJFWNWQWRUUNXFZUUOJWWJJWXLJWWJNJJHIWXLUUPJWWJHXHUUQUURXGWXAWXBWXCWXJWXK
      WOXAWXGWXBWXCKWWKMJWWJJWWJUUSUUTWRWSZXIZUVAVHWWNVFZXJTDWVQWWRFWWSWXATWWJH
      UVBMUGELEUHZMNZMJWYCOPZUIZUAUHZWYCQPZRPZUJZMUKZUOXKZGZUAXLXMZWKUEUVCZUVDP
      ZUVHZGZWWRFGZWXAWXCWXLWYPGZWYRWXGWXAWYTWXLXLGZMWXLXNUFZWXLWYOUEUFZWXMWXAW
      WJWXGUVEZWXAWXLWXLJUGPZXOOPZWYOWXAWXLWXMXPWXAXUFWXAXUEWXAXUAXUEXLGWXMWXLU
      VFXGUVGZXPTWYOWKGZWXAWTTMUVIUVJPWKWYOMUVIUVKTUBUCLUCUHZMNZMJXUIOPZUIZUJZW
      YOEUBFELWYFUBUHZWYCQPZRPZUJZUJZUAUBFXUQELWYCXUMIZXUORPZUJELXUPXUTWYCLGZWY
      FXUSXUORXVAXUSWYFUCWYCXULWYFLXUMUCEVAXUJWYDXUKWYEMXUIWYCMVBXUIWYCJOVCVDXU
      MVFZWYDMWYEYAJWYCOWDUVLVGXQXRXSUVMZTUCLXULFXUMTXUILGZKZXUJMXUKFWVGXVEXUJK
      VISXVEXUIFGZXUIMXEZXUKFGXUJVJZXVDXVFTXUIUVNZVHXVGXVHXUIMUVOUVPXUIUVQXTVSX
      VBXJZWKWYNUGWYGXURIZMUKZWYLGZUAXLXMUEWYMXVMUAXLWYGXLGZWYKXVLWYLXVNWYJXVKU
      GMXVNXVKWYJXVNWYGFGXVKWYJNWYGUVRUBWYGXUQWYJFXURUBUAVAZELXUPWYIXVOXUOWYHWY
      FRXUNWYGWYCQYBYCYDXURVFZELWYIYEYFVGXGXQUVTUVSUWAUWBZUWKUWCYGZWXAWXLJUEUFZ
      WXLXUFUEUFZWXSWXAXUAJXLGZXVSXVTWOWXMUWDWXLJUWEWFYMZWXAXUFHIZXUFWYOXNWXAXU
      FXUGWXAMXUFMXLGZWXAUWFSZXUGWXAMWXLXUFXWEWXMXUGXUDXWBUWGUWHUWIZWXAUBXUMWYO
      EXURXUFUAXVCTLFXUMYHWXAWTXVJYGXVQWXAXUFXUGVRZWXAUGXUFXURIZMUKUGELWYFXUFWY
      CQPZRPZUJZMUKZWYLWXAXWHXWKUGMWXAXUFFGZXWHXWKNXWGUBXUFXUQXWKFXURXUNXUFNZEL
      XUPXWJXWNXUOXWIWYFRXUNXUFWYCQYBYCYDXVPELXWJYEYFVGXGUVTWXAXWMXWCJUEUFXWLWY
      LGXWGWXAXWCXUFJUEXWFWXAXVSXUFJUEUFZWXSWXAXUAXWAXVSXWOWOWXMUWDWXLJUWJWFYMW
      JXUFEWCUWLUWMUWNXFUWOWXAXWDXUHWYTXUAXUBXUCUWPWOUWFXVRMWYOWXLUWQWRUWRFXLHY
      HHFUWSWYRWXCWYTKWOUWTFXLHUXAFWWJWYPHUXBUXCUXDZTWYSDWYQTWYQFDWYQWWRUJZYHZW
      YSDWYQUXETXWQWYQFUXFPGXWRTUBDXUMWYOWYQCEXWQXURWYOXLGUDUHHIZWYOUGPXOOPXWSJ
      UGPUIZUAUDXVCDWYQWWRLWUKWWJXURIZIZCUSZWYRWXCWWRXXCNWYQFWWJWYQHXKFHWYPUXGF
      XLHUWTUXHUXIXDWXCLWWQXXBCWXCWUSKZXXBWUKELWYFWWJWYCQPZRPZUJZIZWWQXXDWUKXXA
      XXGWXCXXAXXGNWUSUBWWJXUQXXGFXURUBDVAZELXUPXXFXXIXUOXXEWYFRXUNWWJWYCQYBYCY
      DXVPELXXFYEYFVGWGYIWUSXXHWWQNWXCEWUKXXFWWQLXXGECVAZWYFWUNXXEWWPRXXJWYDWUL
      WYEWUMMWYCWUKMVBWYCWUKJOVCVDWYCWUKWWJQVCVEXXGVFWUNWWPRWDVGVHUXJYJXGZXSXVJ
      XVQWYQVFZXWTVFZUXKWYQFXWQUXLXGDWYQFWWRXWQXWQVFUXMUXNUXOZYKWWSVFZXJTFWWNYL
      PZXKDWVQJWWKOPZUJZXKZWVQTXXPXXRTXXPDWVQXXQJUNZRPZUNZUJXXRTDWWLXYAFYNWVQFX
      LFVUCGTXLFUXPUXQSZWXAWWLFGTWYAVHXYAYNGTWXAKZXXQXXTRWDSTDUBWWKXXTXUNUMIZJX
      UNOPZFFWWLXXQFYNWVQJJWVPPZXYCXYCWXAWWKXYGGZTWXAWXDJWWKWVOPZJUEUFZXYHWXIWX
      AXYIWXLJUEWXAXYIJWWKULPZHIZWXLWXAWXBWXDXYIXYLNXAWXIJWWKWVOWWDWEWRWXAXYKWW
      JHWXAWXBWXCXYKWWJNXAWXGJWWJUXRWRWHWIWXSWJWWFWXBWWGXYHWXDXYJKWOWLXAWWIWWKW
      VOJJFUXSXCUXDVHXXTFGZXYDYOSXUNXYGGZXYEFGTXYNXUNXYNXUNFUXTMUYAPZXYGFXYOUYB
      ZXUNXYGXYGVFZUYCZXDZUYDXYNXUNXYPGXUNMXEXYSXUNXYPXYPVFZUYEXGXIVHXYFYNGTXYN
      KJXUNOWDSTDWWKXXTFUYFUYGIZYUAFFWVQXYCTWXCKZWXBWXCWXDXATWXCVLZWXHWRXYMYUBY
      OSTFDFWWKUJYLPDFMJULPZUJDFXXTUJTDJMWWJJFFFFXYCWXBYUBXASZWVGYUBVISTDJFXYCW
      XBTXASUYHYUCYUETDFXYCUYIUYJDFXXTYUDJUYKUVMUYLWXETWXFSYUAFUYMPZYUAYUAUYNGY
      UFYUANYUAYUAVFZUYOYUAUYNFFYUAYUAYUGUYPUYQUYRWMUYSZYUGWVQYUAGZTWWFWVGWWGYU
      IWLVIWWIWVOMJYUAFYUAYUGUYTVUAXCSZVUBTUBXYGXYFUJFUMXYGVUDZYLPFUBXYGXYEUJZY
      LPUBXYGXYQVUETYUKYULFYLTYUKUBXYGXUNYUKIZUJYULTUBXYGUMVUFZYUKXYGYUNYUKYHZT
      FMVUGUYBZYUNUMYHZXYGYUPXBYUOYUPYUNUMVUHYUQVUIYUPYUNUMVUJWMXYGXYPYUPXYRXYP
      XYTVUKVULYUPYUNXYGUMVUMVUNSVUPUBXYGYUMXYEXUNXYGUMVUOXSYPYCVUQXUNWWKUMXHXU
      NWWKJOVCVURVUSDWVQXYBXXQWXAXYBXXQUNZUNXXQWXAXYAYURWXAXYAXXTXXQRPZYURWXAXX
      QFGXYMXYAYUSNWXAWWKWXIWXTVUTZYOXXQXXTVVAWFWXAXXQYUTVVBWIYQWXAXXQYUTVVCWIX
      SYPZVVDXXQYNGZXXSWVQNDWVQDWVQXXQYNVVFYVBWXAJWWKOWDSVVEYPTXXPXXRFWWSYLPZYV
      ATYVCDWVQUPWUKWUKXUMIZRPZWWJWUKJULPZQPZRPZCUSZUJXXRTDWWRYVIFYUAYUAYNWYQWV
      QXYCXXNYVIYNGTWYRKUPYVHCVVGSTUBDXUMMXWSXWTUGPXOOPWVPPZWYOWYQBCEXWQXURXWTU
      AUDXVCDWYQWWRLVYQXXAIZBUSZWYRWWRXXCYVLXXKLXXBYVKCBWUKVYQXXAXHVVHYPXSXVJXV
      QXXLXXMYVJVFVVIWVQWYQXBTDWVQWYQXWPVVJSYUHYUGYUJVUBDWVQYVIXXQWXAYVIUPYVGCU
      SZLWWJXUIQPZUCUSZXXQWXAUPYVHYVGCWXAWVJKZYVHJYVGRPYVGYVPYVEJYVGRYVPYVEWUKW
      UMRPJYVPYVDWUMWUKRYVPYVDWUNWUMYVPWUSYVDWUNNWVJWUSWXAWUKVVKZVHUCWUKXULWUNL
      XUMUCCVAXUJWULXUKWUMMXUIWUKMVBXUIWUKJOVCVDXVBWULMWUMYAJWUKOWDUVLVGXGYVPWV
      HWUNWUMNZYVPWUKMWVJWUKMXEZWXAWUKVVLZVHZVVMWULMWUMVVNZXGWIYCYVPWUKWVJWUKFG
      ZWXAWUKVVOZVHYWAVVPWIXRYVPYVGWXAWXCYVFLGYVGFGWVJWXGWUKVVQWWJYVFVTXTZVVRWI
      YJWXAYVMLWWJJXUIUGPZJULPZQPZUCUSYVOWXAYVGYWHCUCJMUPLUQUPJYRIZMJUGPZYRIVVS
      JYWJYRVVTVWAVWBWUKYWFNYVFYWGWWJQWUKYWFJULYBYCJURGZWXAVWCSWURWXAUTSYWEVWDL
      YWHYVNUCXVDYWGXUIWWJQXVDWXBXVFYWGXUINXAXVIJXUIVWEWRYCVWFYPWXAWXCXVSYVOXXQ
      NWXGWXSWWJUCVWHUWLVWGXSYPYSMWVQGZTWWFWVGWWHYWLWLVIWPWVOMJFVWIXCZSTMWWNIZM
      MWWSIZYWLYWNMNTYWMDMWWMMWVQWWNWWJMNZWWMMUNMYWPWWLMYWPWWLJUMIMYWPWWKJUMYWP
      WWKJMULPJWWJMJULVCJXAVWJYPWHVWKYPYQVWLYPWYBYAVGYGYWLYWOMNTYWMDMWWRMWVQWWS
      YWPWWRLMCUSZMYWPLWWQMCWULMWWPRPZMNWUMWWPRPZMNWWQMNYWPWUSKZMWUMMWUNNYWRWWQ
      MMWUNWWPRYBVWMWUMWUNNYWSWWQMWUMWUNWWPRYBVWMYWTWULKZWWPYXAWWJWUKYXAWWJMFYW
      PWUSWULVWNVIVWSYWPWUSWULVWOVWPVWQYWTWVHKZYWSWUMMRPMYXBWWPMWUMRYXBWWPMWUKQ
      PMYXBWWJMWUKQYWPWUSWVHVWNXRYXBWUKYWTWVHWVJYWTWVJWULYWTWVJWULYWTWUSWVKYWPW
      USVLWVLVMVNVOVPZVWRWIYCYXBWUMYXBWUMYXBWUKYXCVQVRVWTWIVXAYJLMYRIZXBZLVXIGZ
      VKYWQMNYXEYXFLYXDUQVXBVXCLCMVXDWMYPXXOYAVGYGYSVXEYIYGDAWWMWUGWVQWWNWWJANZ
      WWLWUFYXGWWKWUEUMWWJAJULVCWHYQWYBWUFVXFVGDAWWRWUQWVQWWSYXGLWWQWUPCYXGWWPW
      UOWUNRWWJAWUKQYBYCVXGXXOLWUPCVVGVGVXHXGVXJVYPWUGCWUDWUJJYNYNUPVVSWUDYNGVY
      PUGWUCMVXKSWUJYNGVYPUGWUIJVXKSYWKVYPVWCSZWVJVYPWUKWUDIZWUKWUDYWIVUDZIZWUK
      WUJIWVJYXKYXIWVJWUKYWIGZYXKYXINWUKVXLZWUKYWIWUDVUOVXMXQVYPWUKYXJWUJVYPYXJ
      UGWUCJUKWUJVYPCUGFWUCMJMYWCMWUKUGPWUKNVYPWUKVXNVHWVGVYPVISJYXDGVYPJLYXDVX
      OUQVXPSVYPLFWUCYHJLGJWUCIFGVYPBLWUBFWUCVYPVYQLGZKZVYTWUAYXOVYRMVYSFWVGYXO
      VYRKVISYXOVYQFGZVYQMXEZVYSFGVYRVJZYXNYXPVYPVYQUVNVHYXQYXRVYQMUVOUVPVYQUVQ
      XTVSVYMYXNWUAFGVYOAVYQVTWAWBWVDXJVXOLFJWUCVXQWFWUKMJJULPZYTPZGZVYPWUTMWUC
      IZMYYAWUKMWUCWULWUKMMYTPYXTWUKMVXRYXSMMYTVXSVXTVYAWHVYPYYBMAMQPZRPZMMLGZY
      YBYYDNVYBBMWUBYYDLWUCVYRVYTMWUAYYCRVYRMVYSVYCVYQMAQVCVEWVDMYYCRWDVGWMVYPY
      YCVYPVYMYYEYYCFGWWCVYBAMVTWFVWQVYDVYEVYFVYPUGCWUCWUIJYXHYXLVYPWVJWUTWUKWU
      IIZNYXMVYPWVJKZWUPWUOWUKOPZWUTYYFYYGWUPWUMWUORPYYHYYGWUNWUMWUORYYGWVHYVRY
      YGWUKMWVJYVSVYPYVTVHZVVMYWBXGXRYYGWUOWUKWVJVYPWUSWVMYVQWVNYKWVJYWCVYPYWDV
      HYYIVYGYSWVJVYPWUSWVAYVQWVEYKWVJYYFYYHNVYPBWUKWUHYYHUPWUIWVBWUAWUOVYQWUKO
      WVCWVBVYJVEWUIVFWUOWUKOWDVGVHVYKVYHVYIWIYIVYEVYLYM $.

    $( The Taylor series for ` -u log ( 1 - A ) ` , as an infinite sum.
       (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    logtaylsum $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
      sum_ k e. NN ( ( A ^ k ) / k ) = -u ( log ` ( 1 - A ) ) ) $=
      ( vn cc wcel cabs cfv c1 clt wbr wa cv cexp co cdiv cmin clog wceq adantl
      cn cneg cmpt nnuz cz 1z a1i oveq2 oveq12d eqid ovex fvmpt cn0 simpl nnnn0
      id expcl syl2an nncn cc0 wne nnne0 divcld logtayl isumclim ) ADEZAFGHIJZK
      ZABLZMNZVHONZHAPNQGUABCTACLZMNZVKONZUBZHTUCHUDEVGUEUFVHTEZVHVNGVJRVGCVHVM
      VJTVNVKVHRZVLVIVKVHOVKVHAMUGVPUOUHVNUIVIVHOUJUKSVGVOKVIVHVGVEVHULEVIDEVOV
      EVFUMVHUNAVHUPUQVOVHDEVGVHURSVOVHUSUTVGVHVASVBACVCVD $.

    logtayl2.s $e |- S = ( 1 ( ball ` ( abs o. - ) ) 1 ) $.
    $( Power series expression for the logarithm.  (Contributed by Mario
       Carneiro, 31-Mar-2015.) $)
    logtayl2 $p |- ( A e. S -> seq 1 ( + ,
      ( k e. NN |-> ( ( ( -u 1 ^ ( k - 1 ) ) / k ) x. ( ( A - 1 ) ^ k ) ) ) )
      ~~> ( log ` A ) ) $=
      ( wcel cn c1 cneg cmin co cexp cdiv cmul cfv cc neg1cn ax-1cn wceq adantl
      a1i vn caddc cv cmpt cseq clog cli nnuz cz 1z cabs clt wbr ccom wa eleq2i
      cbl cxmt cxr cnxmet crp rpxr ax-mp elbl mp3an bitri simplbi subcl sylancr
      1rp eqid cnmetdval simprbi eqbrtrrd logtayl syl2anc fveq2d negeqd breqtrd
      wb nncan oveq2 id oveq12d ovex fvmpt cn0 nnnn0 expcl syl2an cc0 wne nnne0
      divcld eqeltrd divnegd mulm1d sylancl mulneg1d ax-1ne0 negne0i nnz expm1d
      divneg2d div1d 3eqtr2d oveq1d negsubdi2 eqtr2d adantr mulexp mp3an1 eqtrd
      nncn 3eqtr4d div23d oveq1 oveq2d isermulc2 cmnf cioc cdif dvlog2lem sseli
      nnm1nn0 logdmn0 syl logcld negcld negnegd ) ABEZUBCFGHZCUCZGIJZKJZYMLJZAG
      IJZYMKJZMJZUDZGUEYLAUFNZHZMJZUUAUGYKUUBYLUACFGAIJZYMKJZYMLJZUDZYTGFUHGUIE
      YKUJTYLOEZYKPTYKUBUUGGUEZGUUDIJZUFNZHZUUBUGYKUUDOEZUUDUKNZGULUMUUIUULUGUM
      YKGOEZAOEZUUMQYKUUPGAUKIUNZJZGULUMZYKAGGUUQUQNJZEZUUPUUSUOZBUUTADUPUUQOUR
      NEUUOGUSEZUVAUVBVTUTQGVAEUVCVJGVBVCAUUQGGOVDVEVFZVGZGAVHVIZYKUURUUNGULYKU
      UOUUPUURUUNRQUVEGAUUQUUQVKVLVIYKUUPUUSUVDVMVNUUDCVOVPYKUUKUUAYKUUJAUFYKUU
      OUUPUUJARQUVEGAWAVIVQVRVSYKUAUCZFEZUOZUVGUUGNZUUDUVGKJZUVGLJZOUVHUVJUVLRY
      KCUVGUUFUVLFUUGYMUVGRZUUEUVKYMUVGLYMUVGUUDKWBUVMWCZWDUUGVKUVKUVGLWEWFSZUV
      IUVKUVGYKUUMUVGWGEZUVKOEUVHUVFUVGWHZUUDUVGWIWJZUVHUVGOEYKUVGXNSZUVHUVGWKW
      LYKUVGWMSZWNZWOUVIYLUVGGIJZKJZUVGLJZYQUVGKJZMJZYLUVLMJZUVGYTNZYLUVJMJUVIU
      WGUWCUWEMJZUVGLJZUWFUVIUVLHUVKHZUVGLJUWGUWJUVIUVKUVGUVRUVSUVTWPUVIUVLUWAW
      QUVIUWIUWKUVGLUVIYLUVGKJZHZUWEMJUWLUWEMJZHUWIUWKUVIUWLUWEUVIUUHUVPUWLOEPU
      VHUVPYKUVQSYLUVGWIVIZYKYQOEZUVPUWEOEUVHYKUUPUUOUWPUVEQAGVHWRZUVQYQUVGWIWJ
      ZWSUVIUWCUWMUWEMUVIUWCUWLYLLJUWLGLJZHUWMUVIYLUVGUUHUVIPTYLWKWLUVIGQWTXATU
      VHUVGUIEYKUVGXBSXCUVIUWLGUWOUUOUVIQTGWKWLUVIWTTXDUVIUWSUWLUVIUWLUWOXEVRXF
      XGUVIUVKUWNUVIUVKYLYQMJZUVGKJZUWNYKUVKUXARUVHYKUUDUWTUVGKYKUWTYQHZUUDYKYQ
      UWQWQYKUUPUUOUXBUUDRUVEQAGXHWRXIXGXJYKUWPUVPUXAUWNRZUVHUWQUVQUUHUWPUVPUXC
      PYLYQUVGXKXLWJXMVRXOXGXOUVIUWCUWEUVGUVIUUHUWBWGEZUWCOEPUVHUXDYKUVGYESYLUW
      BWIVIUWRUVSUVTXPXIUVHUWHUWFRYKCUVGYSUWFFYTUVMYPUWDYRUWEMUVMYOUWCYMUVGLUVM
      YNUWBYLKYMUVGGIXQXRUVNWDYMUVGYQKWBWDYTVKUWDUWEMWEWFSUVIUVJUVLYLMUVOXRXOXS
      YKUUCUUBHUUAYKUUBYKUUAYKAUVEYKAOXTWKYAJYBZEAWKWLBUXEABDYCYDAUXEUXEVKYFYGY
      HZYIWQYKUUAUXFYJXMVS $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z T $.
    $( The natural logarithm function on the reals is a strictly concave
       function.  (Contributed by Mario Carneiro, 20-Jun-2015.) $)
    logccv $p |- ( ( ( A e. RR+ /\ B e. RR+ /\ A < B ) /\ T e. ( 0 (,) 1 ) ) ->
      ( ( T x. ( log ` A ) ) + ( ( 1 - T ) x. ( log ` B ) ) ) <
        ( log ` ( ( T x. A ) + ( ( 1 - T ) x. B ) ) ) ) $=
      ( vx crp wcel clt wbr cc0 c1 co wa clog cfv cmul cneg cr syl cc wceq cioo
      vy vz w3a cmin caddc cicc cv cmpt crn simpl1 rpred simpl2 simpl3 ccncf wf
      cdiv cpnf wss ltpnf cxr 0xr pnfxr iccssioo mpanl12 syl2anc ioorp syl6sseq
      rpgt0d sselda relogcld renegcld eqid fmptd wb ax-resscn cres resabs1 ssid
      cncfss mp2an relogcn sselii rescncf eqeltrrd fvres negeqd mpteq2ia eqcomi
      ee10 negfcncf cncffvrn sylancr mpbird cdv wiso wor wpo wfo wral ltso soss
      wi ioossre mp2 a1i ioossicc syl5ss rprecred frn sopo wfn negex dffn4 mpbi
      fnmpti adantrl adantrr ltnegd ltrecd oveq2 fvmpt breqan12d adantl 3bitr4d
      biimpd ralrimivva soisoi syl22anc ctg cvv recnd oveq2d oveq1d fveq2 rpxrd
      syl3anc mulneg2d eqtrd remulcld ccnfld ctopn cpr reex relogcl negcld ovex
      prid1 dvrelog wf1o relogf1o f1of mp1i syl6eq syl5reqr dvmptneg tgioo2 cnt
      feqmptd iccntr isoeq1 simpr dvcvx ax-1cn elioore nncan sseldi lincmb01cmp
      dvmptres2 iirev cle ltled lbicc2 ubicc2 1re resubcl oveq12d negdid eqtr4d
      syl31anc 3brtr3d readdcld sseldd ) AEFZBEFZABGHZUDZCIJUAKZFZLZCAMNZOKZJCU
      EKZBMNZOKZUFKZCAOKZUWMBOKZUFKZMNZGHUWTPZUWPPZGHUWJUWSDABUGKZDUHZMNZPZUIZN
      ZCAUXGNZOKZUWMBUXGNZOKZUFKZUXAUXBGUWJABUWSCUXGDABUAKZJUXDUQKZPZUIZUJZUWJA
      UWDUWEUWFUWIUKZULZUWJBUWDUWEUWFUWIUMZULZUWDUWEUWFUWIUNZUWJUXGUXCQUOKFZUXC
      QUXGUPZUWJDUXCUXFQUXGUWJUXDUXCFZLZUXEUYGUXDUWJUXCEUXDUWJUXCIURUAKZEUWJIAG
      HZBURGHZUXCUYHUSZUWJAUXSVIUWJBQFZUYJUYBBUTRIVAFURVAFUYIUYJLUYKVBVCIURABVD
      VEVFVGVHZVJVKVLUXGVMZVNUWJQSUSZUXGUXCSUOKZFZUYDUYEVOVPUWJMUXCVQZUYPFUYQUW
      JMEVQZUXCVQZUYRUYPUWJUXCEUSZUYTUYRTUYMMUXCEVRRUWJVUAUYSESUOKZFUYTUYPFUYME
      QUOKZVUBUYSUYOSSUSVUCVUBUSVPSVSEQSVTWAWBWCESUXCUYSWDWJWEDUXCUYRUXGDUXCUXD
      UYRNZPZUIUXGDUXCVUEUXFUYFVUDUXEUXDUXCMWFWGWHWIWKRUXCSQUXGWLWMWNUWJUXNUXRG
      GQUXGWOKZWPZUXNUXRGGUXQWPZUWJUXNGWQZUXRGWRZUXNUXRUXQWSZUBUHZUCUHZGHZVULUX
      QNZVUMUXQNZGHZXCZUCUXNWTUBUXNWTVUHVUIUWJUXNQUSQGWQZVUIABXDXAUXNQGXBXEXFUW
      JUXRGWQZVUJUWJUXRQUSZVUSVUTUWJUXNQUXQUPVVAUWJDUXNUXPQUXQUWJUXDUXNFLZUXOVV
      BUXDUWJUXNEUXDUWJUXNUXCEABXGUYMXHZVJXIVLUXQVMZVNUXNQUXQXJRXAUXRQGXBWJUXRG
      XKRVUKUWJUXQUXNXLVUKDUXNUXPUXQUXOXMZVVDXPUXNUXQXNXOXFUWJVURUBUCUXNUXNUWJV
      ULUXNFZVUMUXNFZLZLZVUNVUQVVIJVUMUQKZJVULUQKZGHVVKPZVVJPZGHZVUNVUQVVIVVJVV
      KVVIVUMUWJVVGVUMEFVVFUWJUXNEVUMVVCVJXQZXIVVIVULUWJVVFVULEFVVGUWJUXNEVULVV
      CVJXRZXIXSVVIVULVUMVVPVVOXTVVHVUQVVNVOUWJVVFVVGVUOVVLVUPVVMGDVULUXPVVLUXN
      UXQUXDVULTUXOVVKUXDVULJUQYAWGVVDVVKXMYBDVUMUXPVVMUXNUXQUXDVUMTUXOVVJUXDVU
      MJUQYAWGVVDVVJXMYBYCYDYEYFYGUBUCUXNUXRGGUXQYHYIUWJVUFUXQTVUGVUHVOUWJDUXFU
      XPQUAUJYJNZUUAUUBNZYKEUXNUXCQQSUUCFUWJQSUUDUUHXFZUWJUXDEFZLZUXEVWAUXEVVTU
      XEQFUWJUXDUUEYDYLZUUFUXPYKFVWAVVEXFUWJDUXEUXOQYKEVVSVWBUXOYKFVWAJUXDUQUUG
      XFUWJDEUXOUIQUYSWOKQDEUXEUIZWOKDUUIUWJUYSVWCQWOUWJUYSDEUXDUYSNZUIVWCUWJDE
      QUYSEQUYSUUJEQUYSUPUWJUUKEQUYSUULUUMUUSDEVWDUXEUXDEMWFWHUUNYMUUOUUPUYMVVR
      VVRVMZUUQVWEUWJAQFZUYLUXCVVQUURNNUXNTUXTUYBABUUTVFUVIUXNUXRGGUXQVUFUVARWN
      UWGUWIUVBZUWSVMUVCUWJUWSUXCFUXHUXATUWJJUWMUEKZAOKZUWRUFKZUWSUXCUWJVWIUWQU
      WRUFUWJVWHCAOUWJJSFCSFVWHCTUVDUWJCUWICQFZUWGCIJUVEYDZYLZJCUVFWMYNYNUWJVWF
      UYLUWFUWMIJUGKZFZVWJUXCFUXTUYBUYCUWJCVWNFVWOUWJUWHVWNCIJXGVWGUVGCUVJRABUW
      MUVHUVTWEZDUWSUXFUXAUXCUXGUXDUWSTUXEUWTUXDUWSMYOWGUYNUWTXMYBRUWJUXMUWLPZU
      WOPZUFKUXBUWJUXJVWQUXLVWRUFUWJUXJCUWKPZOKVWQUWJUXIVWSCOUWJAUXCFZUXIVWSTUW
      JAVAFZBVAFZABUVKHZVWTUWJAUXSYPZUWJBUYAYPZUWJABUXTUYBUYCUVLZABUVMYQDAUXFVW
      SUXCUXGUXDATUXEUWKUXDAMYOWGUYNUWKXMYBRYMUWJCUWKVWMUWJUWKUWJAUXSVKZYLYRYSU
      WJUXLUWMUWNPZOKVWRUWJUXKVXHUWMOUWJBUXCFZUXKVXHTUWJVXAVXBVXCVXIVXDVXEVXFAB
      UVNYQDBUXFVXHUXCUXGUXDBTUXEUWNUXDBMYOWGUYNUWNXMYBRYMUWJUWMUWNUWJUWMUWJJQF
      VWKUWMQFUVOVWLJCUVPWMZYLUWJUWNUWJBUYAVKZYLYRYSUVQUWJUWLUWOUWJUWLUWJCUWKVW
      LVXGYTZYLUWJUWOUWJUWMUWNVXJVXKYTZYLUVRUVSUWAUWJUWPUWTUWJUWLUWOVXLVXMUWBUW
      JUWSUWJUXCEUWSUYMVWPUWCVKXSWN $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( Value of the complex power function.  (Contributed by Mario Carneiro,
       2-Aug-2014.) $)
    cxpval $p |- ( ( A e. CC /\ B e. CC ) -> ( A ^c B ) =
      if ( A = 0 , if ( B = 0 , 1 , 0 ) , ( exp ` ( B x. ( log ` A ) ) ) ) ) $=
      ( vx vy cc cv cc0 wceq c1 cif clog cmul co ce ccxp wa simpl eqeq1d fveq2d
      cfv simpr ifbid oveq12d ifbieq12d df-cxp ax-1cn keepel elexi fvex ovmpt2a
      0cn ifex ) CDABEECFZGHZDFZGHZIGJZUOUMKTZLMZNTZJAGHZBGHZIGJZBAKTZLMZNTZJOU
      MAHZUOBHZPZUNVAUQUTVCVFVIUMAGVGVHQZRVIUPVBIGVIUOBGVGVHUAZRUBVIUSVENVIUOBU
      RVDLVKVIUMAKVJSUCSUDCDUEVAVCVFVCEVBIGEUFUKUGUHVENUIULUJ $.
  $}

  $( Value of the complex power function.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  cxpef $p |- ( ( A e. CC /\ A =/= 0 /\ B e. CC ) ->
      ( A ^c B ) = ( exp ` ( B x. ( log ` A ) ) ) ) $=
    ( cc wcel cc0 wne w3a ccxp co wceq c1 cif clog cmul ce cxpval 3adant2 simp2
    cfv wn neneqd iffalse syl eqtrd ) ACDZAEFZBCDZGZABHIZAEJZBEJKELZBAMSNIOSZLZ
    ULUEUGUIUMJUFABPQUHUJTUMULJUHAEUEUFUGRUAUJUKULUBUCUD $.

  $( Value of the complex power function when the first argument is zero.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  0cxp $p |- ( ( A e. CC /\ A =/= 0 ) -> ( 0 ^c A ) = 0 ) $=
    ( cc wcel cc0 wne ccxp co wceq c1 cif clog cfv cmul ce 0cn cxpval mpan eqid
    iftrue ax-mp syl6eq ifnefalse sylan9eq ) ABCZADEDAFGZADHIDJZDUDUEDDHZUFADKL
    MGNLZJZUFDBCUDUEUIHODAPQUGUIUFHDRUGUFUHSTUAADIDUBUC $.

  $( Relate the complex power function to the integer power function.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpexpz $p |- ( ( A e. CC /\ A =/= 0 /\ B e. ZZ ) ->
    ( A ^c B ) = ( A ^ B ) ) $=
    ( cc wcel cc0 wne cz w3a ccxp co clog cfv cmul cexp wceq zcn syl3an3 explog
    ce cxpef eqtr4d ) ACDZAEFZBGDZHABIJZBAKLMJSLZABNJUDUBUCBCDUEUFOBPABTQABRUA
    $.

  $( Relate the complex power function to the integer power function.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpexp $p |- ( ( A e. CC /\ B e. NN0 ) -> ( A ^c B ) = ( A ^ B ) ) $=
    ( cc wcel cn0 wa ccxp co cexp wceq cc0 wne c1 cif cfv 0cn ax-mp oveq2 oveq1
    iftrue wi cn wo elnn0 nncn nnne0 0cxp syl2anc 0exp eqtr4d clog cxpval mp2an
    cmul ce eqid 3eqtri exp0 eqtr4i 3eqtr4a sylbi eqeq12d syl5ibrcom adantl imp
    jaoi cz nn0z cxpexpz 3expa sylan2 an32s pm2.61dane ) ACDZBEDZFZABGHZABIHZJZ
    AKVPAKJZVSVOVTVSUAVNVOVSVTKBGHZKBIHZJZVOBUBDZBKJZUCWCBUDWDWCWEWDWAKWBWDBCDB
    KLWAKJBUEBUFBUGUHBUIUJWEKKGHZKKIHZWAWBWFMWGWFKKJZWHMKNZKKUKOUNHUOOZNZWIMKCD
    ZWLWFWKJPPKKULUMWHWKWIJKUPZWHWIWJTQWHWIMJWMWHMKTQUQWLWGMJPKURQUSBKKGRBKKIRU
    TVFVAVTVQWAVRWBAKBGSAKBISVBVCVDVEVNAKLZVOVSVOVNWNFBVGDZVSBVHVNWNWOVSABVIVJV
    KVLVM $.

  $( Logarithm of a complex power.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  logcxp $p |- ( ( A e. RR+ /\ B e. RR ) ->
    ( log ` ( A ^c B ) ) = ( B x. ( log ` A ) ) ) $=
    ( crp wcel cr wa ccxp co clog cfv cmul ce cc cc0 wne wceq rpcn adantr rpne0
    simpr recnd cxpef syl3anc fveq2d id relogcl remulcl syl2anr relogefd eqtrd
    ) ACDZBEDZFZABGHZIJBAIJZKHZLJZIJUPUMUNUQIUMAMDZANOZBMDUNUQPUKURULAQRUKUSULA
    SRUMBUKULTUAABUBUCUDUMUPULULUOEDUPEDUKULUEAUFBUOUGUHUIUJ $.

  $( Value of the complex power function when the second argument is zero.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxp0 $p |- ( A e. CC -> ( A ^c 0 ) = 1 ) $=
    ( cc wcel cc0 ccxp co cexp c1 cn0 wceq 0nn0 cxpexp mpan2 exp0 eqtrd ) ABCZA
    DEFZADGFZHPDICQRJKADLMANO $.

  $( Value of the complex power function at one.  (Contributed by Mario
     Carneiro, 2-Aug-2014.) $)
  cxp1 $p |- ( A e. CC -> ( A ^c 1 ) = A ) $=
    ( cc wcel c1 ccxp co cexp cn0 wceq 1nn0 cxpexp mpan2 exp1 eqtrd ) ABCZADEFZ
    ADGFZAODHCPQIJADKLAMN $.

  $( Value of the complex power function at one.  (Contributed by Mario
     Carneiro, 2-Aug-2014.) $)
  1cxp $p |- ( A e. CC -> ( 1 ^c A ) = 1 ) $=
    ( cc wcel c1 ccxp co clog cfv cmul ce cc0 wceq ax-1cn ax-1ne0 cxpef mp3an12
    wne log1 oveq2i mul01 syl5eq fveq2d ef0 syl6eq eqtrd ) ABCZDAEFZADGHZIFZJHZ
    DDBCDKQUFUGUJLMNDAOPUFUJKJHDUFUIKJUFUIAKIFKUHKAIRSATUAUBUCUDUE $.

  $( Write the exponential function as an exponent to the power ` _e ` .
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  ecxp $p |- ( A e. CC -> ( _e ^c A ) = ( exp ` A ) ) $=
    ( cc wcel ceu ccxp co clog cfv cmul ce cc0 wne wceq ere recni epos gt0ne0ii
    cxpef mp3an12 c1 loge oveq2i mulid1 syl5eq fveq2d eqtrd ) ABCZDAEFZADGHZIFZ
    JHZAJHDBCDKLUGUHUKMDNODNPQDARSUGUJAJUGUJATIFAUITAIUAUBAUCUDUEUF $.

  $( Closure of the complex power function.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  cxpcl $p |- ( ( A e. CC /\ B e. CC ) -> ( A ^c B ) e. CC ) $=
    ( cc wcel wa ccxp co cc0 wceq c1 cif clog cfv cmul cxpval ax-1cn 0cn keepel
    ce a1i wn wne df-ne id logcl mulcl syl2anr efcl syl sylan2br ifclda eqeltrd
    an32s ) ACDZBCDZEZABFGAHIZBHIZJHKZBALMZNGZSMZKCABOUPUQUSVBCUSCDUPUQEURJHCPQ
    RTUQUAUPAHUBZVBCDZAHUCUPVCEVACDZVDUNVCUOVEUOUOUTCDVEUNVCEUOUDAUEBUTUFUGUMVA
    UHUIUJUKUL $.

  $( Real closure of the complex power function.  (Contributed by Mario
     Carneiro, 2-Aug-2014.) $)
  recxpcl $p |- ( ( A e. RR /\ 0 <_ A /\ B e. RR ) -> ( A ^c B ) e. RR ) $=
    ( cr wcel cc0 cle wbr w3a ccxp co wceq c1 cif clog cfv cmul ce cc recn wa
    cxpval syl2an 3adant2 1re 0re keepel a1i wn wne df-ne simpl3 simpl1 ne0gt0d
    simpl2 simpr elrpd relogcld remulcld reefcld sylan2br ifclda eqeltrd ) ACDZ
    EAFGZBCDZHZABIJZAEKZBEKZLEMZBANOZPJZQOZMZCVCVEVGVNKZVDVCARDBRDVOVEASBSABUAU
    BUCVFVHVJVMCVJCDVFVHTVILECUDUEUFUGVHUHVFAEUIZVMCDAEUJVFVPTZVLVQBVKVCVDVEVPU
    KVQAVQAVCVDVEVPULZVQAVRVCVDVEVPUNVFVPUOUMUPUQURUSUTVAVB $.

  $( Positive real closure of the complex power function.  (Contributed by
     Mario Carneiro, 2-Aug-2014.) $)
  rpcxpcl $p |- ( ( A e. RR+ /\ B e. RR ) -> ( A ^c B ) e. RR+ ) $=
    ( crp wcel cr wa ccxp cc0 cle wbr rprege0 recxpcl 3expa sylan clog cfv cmul
    co clt cc ce relogcl remulcl syl2anr efgt0 syl wne wceq rpcnne0 recn syl2an
    id cxpef breqtrrd elrpd ) ACDZBEDZFZABGRZUPAEDZHAIJZFUQUSEDZAKUTVAUQVBABLMN
    URHBAOPZQRZUAPZUSSURVDEDZHVESJUQUQVCEDVFUPUQULAUBBVCUCUDVDUEUFUPATDZAHUGZFB
    TDZUSVEUHZUQAUIBUJVGVHVIVJABUMMUKUNUO $.

  $( Complex exponentiation is nonzero if its mantissa is nonzero.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpne0 $p |- ( ( A e. CC /\ A =/= 0 /\ B e. CC ) -> ( A ^c B ) =/= 0 ) $=
    ( cc wcel cc0 wne w3a ccxp co clog cfv cmul ce cxpef wa logcl mulcl syl2anr
    id 3impa efne0 syl eqnetrd ) ACDZAEFZBCDZGZABHIBAJKZLIZMKZEABNUGUICDZUJEFUD
    UEUFUKUFUFUHCDUKUDUEOUFSAPBUHQRTUIUAUBUC $.

  $( Complex exponentiation is zero iff the mantissa is zero and the exponent
     is nonzero.  (Contributed by Mario Carneiro, 23-Apr-2015.) $)
  cxpeq0 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A ^c B ) = 0 <->
    ( A = 0 /\ B =/= 0 ) ) ) $=
    ( cc wcel wa ccxp co cc0 wceq wne cxpne0 3com23 3expia necon4d ax-1ne0 cxp0
    c1 neeq1d mpbiri syl5ibrcom adantr oveq2 necon2d jcad wi 0cxp oveq1 expimpd
    eqeq1d ancomsd adantl impbid ) ACDZBCDZEZABFGZHIZAHIZBHJZEZUOUQURUSUOAHUPHU
    MUNAHJZUPHJZUMVAUNVBABKLMNUOBHUPHUOVBBHIZAHFGZHJZUMVEUNUMVEQHJOUMVDQHAPRSUA
    VCUPVDHBHAFUBRTUCUDUNUTUQUEUMUNUSURUQUNUSURUQUNUSEUQURHBFGZHIBUFURUPVFHAHBF
    UGUITUHUJUKUL $.

  $( Sum of exponents law for complex exponentiation.  Proposition 10-4.2(a) of
     [Gleason] p. 135.  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpadd $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ B e. CC /\ C e. CC ) ->
    ( A ^c ( B + C ) ) = ( ( A ^c B ) x. ( A ^c C ) ) ) $=
    ( cc wcel cc0 wne wa w3a caddc co clog cfv cmul ce ccxp wceq mulcld syl3anc
    cxpef simp2 simp3 logcl 3ad2ant1 adddird fveq2d efadd syl2anc simp1l simp1r
    eqtrd addcl 3adant1 oveq12d 3eqtr4d ) ADEZAFGZHZBDEZCDEZIZBCJKZALMZNKZOMZBV
    CNKZOMZCVCNKZOMZNKZAVBPKZABPKZACPKZNKVAVEVFVHJKZOMZVJVAVDVNOVABCVCURUSUTUAZ
    URUSUTUBZURUSVCDEUTAUCUDZUEUFVAVFDEVHDEVOVJQVABVCVPVRRVACVCVQVRRVFVHUGUHUKV
    AUPUQVBDEZVKVEQUPUQUSUTUIZUPUQUSUTUJZUSUTVSURBCULUMAVBTSVAVLVGVMVINVAUPUQUS
    VLVGQVTWAVPABTSVAUPUQUTVMVIQVTWAVQACTSUNUO $.

  $( Value of a nonzero complex number raised to a complex power plus one.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpp1 $p |- ( ( A e. CC /\ A =/= 0 /\ B e. CC ) ->
    ( A ^c ( B + 1 ) ) = ( ( A ^c B ) x. A ) ) $=
    ( cc wcel cc0 wne w3a c1 caddc co ccxp cmul wceq ax-1cn cxpadd mp3an3 3impa
    wa cxp1 3ad2ant1 oveq2d eqtrd ) ACDZAEFZBCDZGZABHIJKJZABKJZAHKJZLJZUHALJUCU
    DUEUGUJMZUCUDRUEHCDUKNABHOPQUFUIAUHLUCUDUIAMUEASTUAUB $.

  $( Value of a complex number raised to a negative power.  (Contributed by
     Mario Carneiro, 2-Aug-2014.) $)
  cxpneg $p |- ( ( A e. CC /\ A =/= 0 /\ B e. CC ) ->
    ( A ^c -u B ) = ( 1 / ( A ^c B ) ) ) $=
    ( cc wcel cc0 wne w3a ccxp co cneg cmul c1 simp1 simp3 negcld cxpcl syl2anc
    cdiv wceq eqtr3d cxpne0 divcan3d caddc negidd oveq2d simp2 cxpadd syl211anc
    cxp0 syl oveq1d ) ACDZAEFZBCDZGZABHIZABJZHIZKIZUPRIURLUPRIUOURUPUOULUQCDZUR
    CDULUMUNMZUOBULUMUNNZOZAUQPQUOULUNUPCDVAVBABPQABUAUBUOUSLUPRUOAEHIZUSLUOABU
    QUCIZHIZVDUSUOVEEAHUOBVBUDUEUOULUMUNUTVFUSSVAULUMUNUFVBVCABUQUGUHTUOULVDLSV
    AAUIUJTUKT $.

  $( Exponent subtraction law for complex exponentiation.  (Contributed by
     Mario Carneiro, 22-Sep-2014.) $)
  cxpsub $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ B e. CC /\ C e. CC ) ->
    ( A ^c ( B - C ) ) = ( ( A ^c B ) / ( A ^c C ) ) ) $=
    ( cc wcel cc0 wne wa cneg caddc co ccxp cmul cdiv wceq oveq2d syl3anc cxpcl
    w3a syl2anc cmin negcl cxpadd syl3an3 simp2 negsubd c1 simp1l simp1r cxpneg
    simp3 cxpne0 divrecd eqtr4d 3eqtr3d ) ADEZAFGZHZBDEZCDEZSZABCIZJKZLKZABLKZA
    VBLKZMKZABCUAKZLKVEACLKZNKZUTURUSVBDEVDVGOCUBABVBUCUDVAVCVHALVABCURUSUTUEZU
    RUSUTUKZUFPVAVGVEUGVINKZMKVJVAVFVMVEMVAUPUQUTVFVMOUPUQUSUTUHZUPUQUSUTUIZVLA
    CUJQPVAVEVIVAUPUSVEDEVNVKABRTVAUPUTVIDEVNVLACRTVAUPUQUTVIFGVNVOVLACULQUMUNU
    O $.

  $( Nonnegative exponentiation with a real exponent is nonnegative.
     (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpge0 $p |- ( ( A e. RR /\ 0 <_ A /\ B e. RR ) -> 0 <_ ( A ^c B ) ) $=
    ( cr wcel cc0 cle wbr ccxp co wa clt wceq wo wb 0re leloe mpan c1 syl5breqr
    cc adantr crp wi elrp rpcxpcl rpge0d ex sylbir impancom 0le1 0cn cxp0 ax-mp
    breqtrri simpr oveq2d wne 0le0 recn sylan pm2.61dane adantl oveq1 syl5ibcom
    0cxp breq2d jaod sylbid 3impia 3com23 ) ACDZBCDZEAFGZEABHIZFGZVKVLVMVOVKVLJ
    ZVMEAKGZEALZMZVOVKVMVSNZVLECDVKVTOEAPQUAVPVQVOVRVKVQVLVOVKVQJAUBDZVLVOUCAUD
    WAVLVOWAVLJVNABUEUFUGUHUIVPEEBHIZFGZVRVOVLWCVKVLWCBEVLBELZJZEEEHIZWBFERWFFU
    JETDWFRLUKEULUMUNWEBEEHVLWDUOUPSVLBEUQZJEEWBFURVLBTDWGWBELBUSBVEUTSVAVBVRWB
    VNEFEABHVCVFVDVGVHVIVJ $.

  ${
    mulcxp.1 $e |- ( ph -> A e. CC ) $.
    mulcxp.2 $e |- ( ph -> C e. CC ) $.
    $( Lemma for ~ mulcxp .  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
    mulcxplem $p |- ( ph -> ( 0 ^c C ) = ( ( A ^c C ) x. ( 0 ^c C ) ) ) $=
      ( cc0 ccxp co cmul wceq c1 oveq2 cc wcel 0cn ax-mp syl6eq oveq12d eqeq12d
      cxp0 wne wa cxpcl syl2anc adantr mul01d 0cxp sylan oveq2d 3eqtr4rd oveq1d
      syl 1t1e1 syl6req pm2.61ne ) AFCGHZBCGHZUPIHZJKBFGHZKIHZJCFCFJZUPKURUTVAU
      PFFGHZKCFFGLFMNVBKJOFTPQZVAUQUSUPKICFBGLVCRSACFUAZUBZUQFIHFURUPVEUQAUQMNZ
      VDABMNZCMNZVFDEBCUCUDUEUFVEUPFUQIAVHVDUPFJECUGUHZUIVIUJAUTKKIHKAUSKKIAVGU
      SKJDBTULUKUMUNUO $.
  $}

  $( Complex exponentiation of a product.  Proposition 10-4.2(c) of [Gleason]
     p. 135.  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  mulcxp $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) /\
    C e. CC ) -> ( ( A x. B ) ^c C ) = ( ( A ^c C ) x. ( B ^c C ) ) ) $=
    ( wcel cc0 wa cc cmul co ccxp wceq oveq1d eqtrd oveq1 wne cfv adantr mulcld
    clog ce cr cle wbr simp1l recnd mul01d simp3 mulcxplem oveq2 oveq2d eqeq12d
    w3a syl5ibrcom simp2l mul02d cxpcl syl2anc 0cn sylancr mulcomd a1dd simpl1r
    wi caddc simprl ne0gt0d elrpd simpl2r simprr relogmuld logcld adddid fveq2d
    efadd mulne0d cxpef syl3anc oveq12d 3eqtr4d exp32 pm2.61dne ) AUADZEAUBUCZF
    ZBUADZEBUBUCZFZCGDZULZABHIZCJIZACJIZBCJIZHIZKZBEWIWOBEKZAEHIZCJIZWLECJIZHIZ
    KWIWRWSWTWIWQECJWIAWIAWBWCWGWHUDZUEZUFLWIACXBWDWGWHUGZUHMWPWKWRWNWTWPWJWQCJ
    BEAHUILWPWMWSWLHBECJNUJUKUMWIBEOZWOVCAEWIAEKZWOXDWIWOXEEBHIZCJIZWSWMHIZKWIX
    GWSXHWIXFECJWIBWIBWDWEWFWHUNZUEZUOLWIWSWMWSHIXHWIBCXJXCUHWIWMWSWIBGDZWHWMGD
    XJXCBCUPUQWIEGDWHWSGDURXCECUPUSUTMMXEWKXGWNXHXEWJXFCJAEBHNLXEWLWSWMHAECJNLU
    KUMVAWIAEOZXDWOWIXLXDFZFZCWJSPZHIZTPZCASPZHIZTPZCBSPZHIZTPZHIZWKWNXNXQXSYBV
    DIZTPZYDXNXPYETXNXPCXRYAVDIZHIYEXNXOYGCHXNABXNAWIWBXMXAQZXNAYHWBWCWGWHXMVBW
    IXLXDVEZVFVGXNBWIWEXMXIQZXNBYJWEWFWDWHXMVHWIXLXDVIZVFVGVJUJXNCXRYAWIWHXMXCQ
    ZXNAWIAGDZXMXBQZYIVKZXNBWIXKXMXJQZYKVKZVLMVMXNXSGDYBGDYFYDKXNCXRYLYORXNCYAY
    LYQRXSYBVNUQMXNWJGDWJEOWHWKXQKXNABYNYPRXNABYNYPYIYKVOYLWJCVPVQXNWLXTWMYCHXN
    YMXLWHWLXTKYNYIYLACVPVQXNXKXDWHWMYCKYPYKYLBCVPVQVRVSVTWAWA $.

  $( Complex exponentiation of a reciprocal.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  cxprec $p |- ( ( A e. RR+ /\ B e. CC ) ->
                 ( ( 1 / A ) ^c B ) = ( 1 / ( A ^c B ) ) ) $=
    ( wcel cc wa ccxp co c1 cdiv cmul cxpcl sylan cc0 wne adantr syl3anc oveq1d
    cr cle eqtr3d crp rpreccl rpcnd rpcn rpne0 simpr cxpne0 divcan3d recidd wbr
    wceq rprege0 rprege0d mulcxp 1cxp syl ) AUACZBDCZEZABFGZHAIGZBFGZJGZUTIGVBH
    UTIGUSVBUTUQVADCURVBDCUQVAAUBZUCVABKLUQADCZURUTDCAUDZABKLUSVEAMNZURUTMNUQVE
    URVFOZUQVGURAUEOZUQURUFZABUGPUHUSVCHUTIUSHBFGZVCHUSAVAJGZBFGZVKVCUSVLHBFUSA
    VHVIUIQUSARCMASUJEZVARCMVASUJEZURVMVCUKUQVNURAULOUQVOURUQVAVDUMOVJAVABUNPTU
    SURVKHUKVJBUOUPTQT $.

  $( Complex exponentiation of a quotient.  (Contributed by Mario Carneiro,
     8-Sep-2014.) $)
  divcxp $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ B e. RR+ /\ C e. CC ) ->
                 ( ( A / B ) ^c C ) = ( ( A ^c C ) / ( B ^c C ) ) ) $=
    ( cr wcel cc0 cle wbr wa cc c1 cdiv co cmul ccxp wceq syl2anc divrecd cxpcl
    wne simp1l simp1r simp2 rpreccld rpred rpge0d simp3 mulcxp syl221anc cxprec
    crp w3a oveq2d eqtrd recnd rpcnd rpne0d oveq1d cxpne0 syl3anc 3eqtr4d ) ADE
    ZFAGHZIZBUKEZCJEZULZAKBLMZNMZCOMZACOMZKBCOMZLMZNMZABLMZCOMVKVLLMVGVJVKVHCOM
    ZNMZVNVGVBVCVHDEFVHGHVFVJVQPVBVCVEVFUAZVBVCVEVFUBVGVHVGBVDVEVFUCZUDZUEVGVHV
    TUFVDVEVFUGZAVHCUHUIVGVPVMVKNVGVEVFVPVMPVSWABCUJQUMUNVGVOVICOVGABVGAVRUOZVG
    BVSUPZVGBVSUQZRURVGVKVLVGAJEVFVKJEWBWAACSQVGBJEZVFVLJEWCWABCSQVGWEBFTVFVLFT
    WCWDWABCUSUTRVA $.

  $( Product of exponents law for complex exponentiation.  Proposition
     10-4.2(b) of [Gleason] p. 135.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  cxpmul $p |- ( ( A e. RR+ /\ B e. RR /\ C e. CC ) ->
                 ( A ^c ( B x. C ) ) = ( ( A ^c B ) ^c C ) ) $=
    ( wcel cr cc cmul co clog cfv ce ccxp recnd 3ad2ant1 cc0 wceq cxpef syl3anc
    wne fveq2d crp w3a simp3 simp2 relogcl mulassd mulcomd oveq1d rpcn remulcld
    rpne0 relogefd eqtrd oveq2d 3eqtr4d mulcld cxpcl syl2anc cxpne0 ) AUADZBEDZ
    CFDZUBZBCGHZAIJZGHZKJZCABLHZIJZGHZKJZAVDLHZVHCLHZVCVFVJKVCCBGHZVEGHCBVEGHZG
    HVFVJVCCBVEUTVAVBUCZVCBUTVAVBUDZMZVCVEUTVAVEEDVBAUENZMUFVCVDVNVEGVCBCVRVPUG
    UHVCVIVOCGVCVIVOKJZIJVOVCVHVTIVCAFDZAOSZBFDZVHVTPUTVAWAVBAUINZUTVAWBVBAUKNZ
    VRABQRTVCVOVCBVEVQVSUJULUMUNUOTVCWAWBVDFDVLVGPWDWEVCBCVRVPUPAVDQRVCVHFDZVHO
    SZVBVMVKPVCWAWCWFWDVRABUQURVCWAWBWCWGWDWEVRABUSRVPVHCQRUO $.

  ${
    $d k x A $.  $d k x B $.  $d x C $.
    $( Product of exponents law for complex exponentiation.  Variation on
       ~ cxpmul with more general conditions on ` A ` and ` B ` when ` C ` is
       an integer.  (Contributed by Mario Carneiro, 9-Aug-2014.) $)
    cxpmul2 $p |- ( ( A e. CC /\ B e. CC /\ C e. NN0 ) ->
                   ( A ^c ( B x. C ) ) = ( ( A ^c B ) ^ C ) ) $=
      ( cc wcel cmul co ccxp cexp wceq wa wi cc0 c1 oveq2 oveq2d eqeq12d adantr
      ad2antrr eqtrd vx vk cn0 cv caddc imbi2d mul01 adantl cxpcl exp0d 3eqtr4d
      cxp0 oveq1 ax-mp 1t1e1 eqtr4i simplr simpr oveq1d cn nn0p1nn nncnd mul02d
      0cn oveq12d nn0cn syl6eq 3eqtr4a simpll mulcld syl2anc mul01d 0cxp nnne0d
      wne mulne0d 3eqtr4rd pm2.61dane ax-1cn a1i adddid mulid1d syl211anc expp1
      cxpadd sylan syl5ibr expcom a2d nn0ind com12 3impia ) ADEZBDEZCUCEZABCFGZ
      HGZABHGZCIGZJZWOWMWNKZWTXAABUAUDZFGZHGZWRXBIGZJZLXAABMFGZHGZWRMIGZJZLXAAB
      UBUDZFGZHGZWRXKIGZJZLXAABXKNUEGZFGZHGZWRXPIGZJZLXAWTLUAUBCXBMJZXFXJXAYAXD
      XHXEXIYAXCXGAHXBMBFOPXBMWRIOQUFXBXKJZXFXOXAYBXDXMXEXNYBXCXLAHXBXKBFOPXBXK
      WRIOQUFXBXPJZXFXTXAYCXDXRXEXSYCXCXQAHXBXPBFOPXBXPWRIOQUFXBCJZXFWTXAYDXDWQ
      XEWSYDXCWPAHXBCBFOPXBCWRIOQUFXAAMHGZNXHXIWMYENJWNAULRXAXGMAHWNXGMJWMBUGUH
      PXAWRABUIZUJUKXKUCEZXAXOXTXAYGXOXTLXOXTXAYGKZXMWRFGZXNWRFGZJXMXNWRFUMYHXR
      YIXSYJYHXRYIJZAMYHAMJZKZYKBMYMBMJZKZMMHGZNNFGZXRYIYPNYQMDEYPNJVDMULUNZUOU
      PYOAMXQMHYHYLYNUQZYOXQMXPFGMYOBMXPFYMYNURZUSYOXPYHXPDEZYLYNYHXPYGXPUTEXAX
      KVAUHZVBZSVCTVEYOXMNWRNFYOXMYPNYOAMXLMHYSYOXLMXKFGMYOBMXKFYTUSYOXKYHXKDEZ
      YLYNYGUUDXAXKVFUHZSVCTVEYRVGYOWRYPNYOAMBMHYSYTVEYRVGVEVHYMBMVOZKZXMMFGMYI
      XRUUGXMUUGWMXLDEZXMDEYHWMYLUUFWMWNYGVIZSYHUUHYLUUFYHBXKWMWNYGUQZUUEVJZSAX
      LUIVKVLUUGWRMXMFUUGWRMBHGZMUUGAMBHYHYLUUFUQZUSUUGWNUUFUULMJYHWNYLUUFUUJSZ
      YMUUFURZBVMVKTPUUGXRMXQHGZMUUGAMXQHUUMUSUUGXQDEXQMVOUUPMJUUGBXPUUNYHUUAYL
      UUFUUCSZVJUUGBXPUUNUUQUUOYHXPMVOYLUUFYHXPUUBVNSVPXQVMVKTVQVRYHAMVOZKZXRAX
      LBUEGZHGZYIUUSXQUUTAHUUSXQXLBNFGZUEGUUTUUSBXKNYHWNUURUUJRZYHUUDUURUUERNDE
      UUSVSVTWAUUSUVBBXLUEUUSBUVCWBPTPUUSWMUURUUHWNUVAYIJYHWMUURUUIRYHUURURYHUU
      HUURUUKRUVCAXLBWEWCTVRXAWRDEYGXSYJJYFWRXKWDWFQWGWHWIWJWKWL $.
  $}

  ${
    $d k x A $.  $d k x B $.  $d x C $.
    $( The complex power function allows us to write n-th roots via the idiom
       ` A ^c ( 1 / N ) ` .  (Contributed by Mario Carneiro, 6-May-2015.) $)
    cxproot $p |- ( ( A e. CC /\ N e. NN ) ->
                   ( ( A ^c ( 1 / N ) ) ^ N ) = A ) $=
      ( cc wcel cn wa c1 cdiv cmul ccxp cexp nncn adantl cc0 wne recid2d oveq2d
      co nnne0 wceq simpl cr nnrecre recnd nnnn0 cxpmul2 syl3anc adantr 3eqtr3d
      cn0 cxp1 ) ACDZBEDZFZAGBHRZBIRZJRZAGJRZAUOJRBKRZAUNUPGAJUNBUMBCDULBLMUMBN
      OULBSMPQUNULUOCDBUJDZUQUSTULUMUAUNUOUMUOUBDULBUCMUDUMUTULBUEMAUOBUFUGULUR
      ATUMAUKUHUI $.
  $}

  $( Generalize ~ cxpmul2 to negative integers.  (Contributed by Mario
     Carneiro, 23-Apr-2015.) $)
  cxpmul2z $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ C e. ZZ ) ) ->
                 ( A ^c ( B x. C ) ) = ( ( A ^c B ) ^ C ) ) $=
    ( cc wcel cc0 wa cmul co ccxp cexp wceq cneg cxpmul2 c1 cdiv syl3anc oveq2d
    cn0 mulcld wne cz elznn0 3expia adantlr adantr simplll simplr simprr simprl
    cr wo wi recnd mulneg2d negeqd negnegd simpllr negcld cxpneg eqtr3d syl2anc
    eqtrd cxpcl expneg2 3eqtr4d expr jaod expimpd syl5bi impr ) ADEZAFUAZGZBDEZ
    CUBEZABCHIZJIZABJIZCKIZLZVPCUKEZCSEZCMZSEZULZGVNVOGZWACUCWGWBWFWAWGWBGWCWAW
    EWGWCWAUMZWBVLVOWHVMVLVOWCWAABCNUDUEUFWGWBWEWAWGWBWEGZGZOABWDHIZJIZPIZOVSWD
    KIZPIZVRVTWJWLWNOPWJVLVOWEWLWNLVLVMVOWIUGZVNVOWIUHZWGWBWEUIZABWDNQRWJAWKMZJ
    IZVRWMWJWSVQAJWJWSVQMZMVQWJWKXAWJBCWQWJCWGWBWEUJUNZUOUPWJVQWJBCWQXBTUQVCRWJ
    VLVMWKDEWTWMLWPVLVMVOWIURWJBWDWQWJCXBUSTAWKUTQVAWJVSDEZCDEWEVTWOLWJVLVOXCWP
    WQABVDVBXBWRVSCVEQVFVGVHVIVJVK $.

  $( Absolute value of a power, when the base is real.  (Contributed by Mario
     Carneiro, 15-Sep-2014.) $)
  abscxp $p |- ( ( A e. RR+ /\ B e. CC ) ->
                 ( abs ` ( A ^c B ) ) = ( A ^c ( Re ` B ) ) ) $=
    ( wcel cc cfv cmul co ce cabs cre ccxp wceq recnd adantr cr mulcomd 3eqtr4d
    fveq2d cxpef syl3anc crp wa clog simpr relogcl mulcld absef syl remul2 recl
    sylan adantl eqtrd cc0 wne rpcn rpne0 ) AUACZBDCZUBZBAUCEZFGZHEZIEZBJEZVAFG
    ZHEZABKGZIEAVEKGZUTVDVBJEZHEZVGUTVBDCVDVKLUTBVAURUSUDZURVADCUSURVAAUEZMNZUF
    VBUGUHUTVJVFHUTVABFGZJEZVAVEFGZVJVFURVAOCUSVPVQLVMVABUIUKUTVBVOJUTBVAVLVNPR
    UTVEVAUTVEUSVEOCURBUJULMZVNPQRUMUTVHVCIUTADCZAUNUOZUSVHVCLURVSUSAUPNZURVTUS
    AUQNZVLABSTRUTVSVTVEDCVIVGLWAWBVRAVESTQ $.

  $( Absolute value of a power, when the exponent is real.  (Contributed by
     Mario Carneiro, 15-Sep-2014.) $)
  abscxp2 $p |- ( ( A e. CC /\ B e. RR ) ->
                 ( abs ` ( A ^c B ) ) = ( ( abs ` A ) ^c B ) ) $=
    ( cc wcel cr wa ccxp co cabs cfv wceq cc0 cle wbr a1i simplr syl3anc fveq2d
    cmul ce 0re 0le0 recxpcl cxpge0 absidd simpr oveq1d abs00bd 3eqtr4d wne cre
    clog recnd logcl adantlr mulcld absef syl remul2d relog oveq2d eqtrd simpll
    cxpef abscld wb abs00 adantr necon3bid biimpar pm2.61dane ) ACDZBEDZFZABGHZ
    IJZAIJZBGHZKALVNALKZFZLBGHZIJWAVPVRVTWAVTLEDZLLMNZVMWAEDWBVTUAOZWCVTUBOZVLV
    MVSPZLBUCQVTWBWCVMLWAMNWDWEWFLBUDQUEVTVOWAIVTALBGVNVSUFZUGRVTVQLBGVTAWGUHUG
    UIVNALUJZFZBAULJZSHZTJZIJZBVQULJZSHZTJZVPVRWIWMWKUKJZTJZWPWIWKCDWMWRKWIBWJW
    IBVLVMWHPZUMZVLWHWJCDVMAUNUOZUPWKUQURWIWQWOTWIWQBWJUKJZSHWOWIBWJWSXAUSWIXBW
    NBSVLWHXBWNKVMAUTUOVAVBRVBWIVOWLIWIVLWHBCDZVOWLKVLVMWHVCZVNWHUFWTABVDQRWIVQ
    CDVQLUJZXCVRWPKWIVQWIAXDVEUMVNXEWHVNVQLALVLVQLKVSVFVMAVGVHVIVJWTVQBVDQUIVK
    $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 2-Aug-2014.) $)
  cxplt $p |- ( ( ( A e. RR /\ 1 < A ) /\ ( B e. RR /\ C e. RR ) ) ->
                ( B < C <-> ( A ^c B ) < ( A ^c C ) ) ) $=
    ( cr wcel c1 clt wbr wa cfv cmul co ce ccxp remulcld cc cc0 wceq recnd a1i
    clog simprl crp rplogcl adantr rpred simprr eflt syl2anc ltmul1d wne simpll
    wb 0re 1re 0lt1 simplr lttrd gt0ne0d cxpef syl3anc breq12d 3bitr4d ) ADEZFA
    GHZIZBDEZCDEZIZIZBAUAJZKLZCVKKLZGHZVLMJZVMMJZGHZBCGHABNLZACNLZGHVJVLDEVMDEV
    NVQUMVJBVKVFVGVHUBZVJVKVFVKUCEVIAUDUEZUFZOVJCVKVFVGVHUGZWBOVLVMUHUIVJBCVKVT
    WCWAUJVJVRVOVSVPGVJAPEZAQUKZBPEVRVORVJAVDVEVIULZSZVJAVJQFAQDEVJUNTFDEVJUOTW
    FQFGHVJUPTVDVEVIUQURUSZVJBVTSABUTVAVJWDWECPEVSVPRWGWHVJCWCSACUTVAVBVC $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 2-Aug-2014.) $)
  cxple $p |- ( ( ( A e. RR /\ 1 < A ) /\ ( B e. RR /\ C e. RR ) ) ->
                ( B <_ C <-> ( A ^c B ) <_ ( A ^c C ) ) ) $=
    ( cr wcel c1 clt wbr wa wn ccxp co cle wb cxplt ancom2s cc0 recxpcl syl3anc
    a1i notbid lenlt adantl simpll 0lt1 simplr lttrd ltled simprl simprr lenltd
    0re 1re 3bitr4d ) ADEZFAGHZIZBDEZCDEZIZIZCBGHZJZACKLZABKLZGHZJBCMHZVEVDMHVA
    VBVFUQUSURVBVFNACBOPUAUTVGVCNUQBCUBUCVAVEVDVAUOQAMHZURVEDEUOUPUTUDZVAQAQDEV
    AULTZVIVAQFAVJFDEVAUMTVIQFGHVAUETUOUPUTUFUGUHZUQURUSUIABRSVAUOVHUSVDDEVIVKU
    QURUSUJACRSUKUN $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 10-Sep-2014.) $)
  cxplea $p |- ( ( ( A e. RR /\ 1 <_ A ) /\ ( B e. RR /\ C e. RR ) /\
                   B <_ C ) -> ( A ^c B ) <_ ( A ^c C ) ) $=
    ( cr wcel c1 cle wbr wa w3a ccxp co wceq wb cc recnd 1cxp syl breq12d oveq1
    clt simpl3 simpl1l simpr simpl2 cxple syl21anc 1le1 simp2l simp2r syl5ibcom
    mpbid mpbiri imp wo 1re leloe mpan biimpa 3ad2ant1 mpjaodan ) ADEZFAGHZIZBD
    EZCDEZIZBCGHZJZFAUAHZABKLZACKLZGHZFAMZVIVJIZVHVMVDVGVHVJUBVOVBVJVGVHVMNVBVC
    VGVHVJUCVIVJUDVDVGVHVJUEABCUFUGULVIVNVMVIFBKLZFCKLZGHZVNVMVIVRFFGHUHVIVPFVQ
    FGVIBOEVPFMVIBVDVEVFVHUIPBQRVICOEVQFMVICVDVEVFVHUJPCQRSUMVNVPVKVQVLGFABKTFA
    CKTSUKUNVDVGVJVNUOZVHVBVCVSFDEVBVCVSNUPFAUQURUSUTVA $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 8-Sep-2014.) $)
  cxple2 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) /\
    C e. RR+ ) -> ( A <_ B <-> ( A ^c C ) <_ ( B ^c C ) ) ) $=
    ( cr wcel cc0 cle wbr wa crp ccxp co wb wceq adantr cfv ce 3ad2ant1 syl2anc
    3ad2ant2 w3a clt simpl1l simpr elrpd ad2antrr simp3 clog cmul rpred relogcl
    simp2l remulcld efle lemul2d reeflog breq12d 3bitr3rd wne recnd rpne0 cxpef
    cc rpre syl3anc 3bitr4d 0re simp1l ltnle sylancr biimpa rpcxpcl rpgt0 mpbid
    wn syl rpne0d 0cxp breq2d mtbird 2falsed breq2 bibi12d syl5ibcom imp simp2r
    oveq1 wo mpjaodan simpl2r eqbrtrrd oveq1d eqtr3d simpl2l cxpge0 2thd simp1r
    leloe ) ADEZFAGHZIZBDEZFBGHZIZCJEZUAZFAUBHZABGHZACKLZBCKLZGHZMZFANZXFXGIZFB
    UBHZXLFBNZXNXOIZAJEZBJEZXEXLXNXRXOXNAWSWTXDXEXGUCXFXGUDUEZOXQBXFXBXGXOXAXBX
    CXEULZUFXNXOUDUEXFXEXGXOXAXDXEUGZUFXRXSXEUAZCAUHPZUILZCBUHPZUILZGHZYEQPZYGQ
    PZGHZXHXKYCYEDEYGDEYHYKMYCCYDYCCXRXSXEUGZUJZXRXSYDDEZXEAUKRZUMYCCYFYMXSXRYF
    DEZXEBUKTZUMYEYGUNSYCYDYFGHZYDQPZYFQPZGHZYHXHYCYNYPYRUUAMYOYQYDYFUNSYCYDYFC
    YOYQYLUOYCYSAYTBGXRXSYSANXEAUPRXSXRYTBNXEBUPTUQURYCXIYIXJYJGYCAVCEAFUSZCVCE
    ZXIYINYCAXRXSWSXEAVDRUTXRXSUUBXEAVARYCCYMUTZACVBVEYCBVCEBFUSZUUCXJYJNYCBXSX
    RXBXEBVDTUTXSXRUUEXEBVATUUDBCVBVEUQVFVEXNXPXLXNAFGHZXIFCKLZGHZMXPXLXNUUFUUH
    XFXGUUFVOZXFFDEZWSXGUUIMVGWSWTXDXEVHZFAVIVJVKXNUUHXIFGHZXNXIJEZUULVOZXNXRCD
    EZUUMXTXFUUOXGXFCYBUJZOACVLSUUMFXIUBHZUUNXIVMUUMUUJXIDEUUQUUNMVGXIVDFXIVIVJ
    VNVPXNUUGFXIGXFUUGFNZXGXFUUCCFUSUURXFCUUPUTXFCYBVQCVRSZOVSVTWAXPUUFXHUUHXKF
    BAGWBXPUUGXJXIGFBCKWGVSWCWDWEXFXOXPWHZXGXFXCUUTXAXBXCXEWFXFUUJXBXCUUTMVGYAF
    BWRVJVNOWIXFXMIZXHXKUVAFABGXFXMUDZXBXCXAXEXMWJZWKUVAFXIXJGUVAUUGFXIXFUURXMU
    USOUVAFACKUVBWLWMUVAXBXCUUOFXJGHXBXCXAXEXMWNUVCXFUUOXMUUPOBCWOVEWKWPXFWTXGX
    MWHZWSWTXDXEWQXFUUJWSWTUVDMVGUUKFAWRVJVNWI $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 15-Sep-2014.) $)
  cxplt2 $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 <_ B ) /\
    C e. RR+ ) -> ( A < B <-> ( A ^c C ) < ( B ^c C ) ) ) $=
    ( cr wcel cc0 cle wbr wa crp w3a wn co clt wb cxple2 ltnled recxpcl syl3anc
    ccxp 3com12 notbid simp1l simp2l simp1r rpre 3ad2ant3 simp2r 3bitr4d ) ADEZ
    FAGHZIZBDEZFBGHZIZCJEZKZBAGHZLBCTMZACTMZGHZLABNHUTUSNHUQURVAUOULUPURVAOBACP
    UAUBUQABUJUKUOUPUCZULUMUNUPUDZQUQUTUSUQUJUKCDEZUTDEVBUJUKUOUPUEUPULVDUOCUFU
    GZACRSUQUMUNVDUSDEVCULUMUNUPUHVEBCRSQUI $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 15-Sep-2014.) $)
  cxple2a $p |- ( ( ( A e. RR /\ B e. RR /\ C e. RR ) /\
    ( 0 <_ A /\ 0 <_ C ) /\ A <_ B ) -> ( A ^c C ) <_ ( B ^c C ) ) $=
    ( cr wcel w3a cc0 cle wbr wa ccxp co wceq wb adantr 0re a1i mpbid c1 cc clt
    simpl3 crp simp11 simpl2l simp12 simp13 anim1i elrp sylibr cxple2 syl221anc
    letrd 1le1 recnd cxp0 syl oveq2 sylan9req 3brtr3d wo leloe sylancr mpjaodan
    simp2r ) ADEZBDEZCDEZFZGAHIZGCHIZJZABHIZFZGCUAIZACKLZBCKLZHIZGCMZVNVOJZVMVR
    VIVLVMVOUBZVTVFVJVGGBHICUCEZVMVRNVNVFVOVFVGVHVLVMUDZOZVJVKVIVMVOUEZVNVGVOVF
    VGVHVLVMUFZOZVTGABGDEZVTPQWDWGWEWAUMVTVHVOJWBVNVHVOVFVGVHVLVMUGZUHCUIUJABCU
    KULRVNVSJZSSVPVQHSSHIWJUNQVNVSSAGKLZVPVNATEWKSMVNAWCUOAUPUQGCAKURUSVNVSSBGK
    LZVQVNBTEWLSMVNBWFUOBUPUQGCBKURUSUTVNVKVOVSVAZVIVJVKVMVEVNWHVHVKWMNPWIGCVBV
    CRVD $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 2-May-2016.) $)
  cxplt3 $p |- ( ( ( A e. RR+ /\ A < 1 ) /\ ( B e. RR /\ C e. RR ) ) ->
                ( B < C <-> ( A ^c C ) < ( A ^c B ) ) ) $=
    ( crp wcel c1 clt wbr wa cr cdiv co ccxp wceq simpll cxprec syl2anc rpcxpcl
    cc recnd simprl simprr breq12d rprecred simplr reclt1d mpbid cxplt syl22anc
    wb ad2ant2rl ad2ant2r ltrecd 3bitr4d ) ADEZAFGHZIZBJEZCJEZIZIZFAKLZBMLZVBCM
    LZGHZFABMLZKLZFACMLZKLZGHBCGHZVHVFGHVAVCVGVDVIGVAUOBSEVCVGNUOUPUTOZVABUQURU
    SUAZTABPQVAUOCSEVDVINVKVACUQURUSUBZTACPQUCVAVBJEFVBGHZURUSVJVEUJVAAVKUDVAUP
    VNUOUPUTUEVAAVKUFUGVLVMVBBCUHUIVAVHVFUOUSVHDEUPURACRUKUOURVFDEUPUSABRULUMUN
    $.

  $( Ordering property for complex exponentiation.  (Contributed by Mario
     Carneiro, 2-May-2016.) $)
  cxple3 $p |- ( ( ( A e. RR+ /\ A < 1 ) /\ ( B e. RR /\ C e. RR ) ) ->
                ( B <_ C <-> ( A ^c C ) <_ ( A ^c B ) ) ) $=
    ( crp wcel c1 clt wbr wa cr wn ccxp co wb cxplt3 ancom2s lenlt rpcxpcl rpre
    cle notbid adantl ad2ant2rl ad2ant2r syl2an syl2anc 3bitr4d ) ADEZAFGHZIZBJ
    EZCJEZIZIZCBGHZKZABLMZACLMZGHZKZBCTHZURUQTHZUNUOUSUJULUKUOUSNACBOPUAUMVAUPN
    UJBCQUBUNURDEZUQDEZVBUTNZUHULVCUIUKACRUCUHUKVDUIULABRUDVCURJEUQJEVEVDURSUQS
    URUQQUEUFUG $.

  $( Lemma for ~ cxpsqr .  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
  cxpsqrlem $p |- ( ( ( A e. CC /\ A =/= 0 ) /\
    ( A ^c ( 1 / 2 ) ) = -u ( sqr ` A ) ) -> ( _i x. ( sqr ` A ) ) e. RR ) $=
    ( cc wcel cc0 c2 cdiv co cfv cneg wceq ci cmul sylancr cre syl cle wbr pire
    cpi cr wne wa c1 ccxp ax-icn sqrcl ad2antrr mulcl cim imval divcan3 mp3an23
    csqr ine0 fveq2d clog ce ccos 1re rehalfcli recni logcl recld reefcld imcld
    recoscld rpefcld rpge0d cicc immul2 recnd mulcom eqtrd clt logimcl renegcli
    simpld wi ltle mpd simprd elicc2i syl3anbrc halfgt0 elrpii 2cn divneg mp3an
    2ne0 divreci eqtr2i eqcomi iccdili eqeltrd cosq14ge0 csin caddc cxpef efeul
    mulge0d mp3an3 resincld addcld remul2d oveq2d 3eqtrd breqtrrd adantr renegd
    crred breqtrd le0neg1d mpbird sqrrege0 0re letri3 sylancl mpbir2and reim0bd
    simpr wb ) ABCZADUAZUBZAUCEFGZUDGZAUMHZIZJZUBZKYGLGZYJKBCZYGBCZYKBCZUEYBYMY
    CYIAUFUGZKYGUHMZYJYKUIHZYKKFGZNHZYGNHZDYJYNYQYSJYPYKUJOYJYRYGNYJYMYRYGJZYOY
    MYLKDUAUUAUEUNYGKUKULOUOYJYTDJZYTDPQZDYTPQZYJUUCDYTIZPQYJDYFNHZUUEPYDDUUFPQ
    YIYDDYEAUPHZLGZNHZUQHZUUHUIHZURHZLGZUUFPYDUUJUULYDUUIYDUUHYDYEBCZUUGBCZUUHB
    CZYEUCUSUTZVAZAVBZYEUUGUHMZVCZVDZYDUUKYDUUHUUTVEZVFZYDUUJYDUUIUVAVGVHYDUUKS
    EFGZIZUVEVIGZCDUULPQYDUUKUUGUIHZYELGZUVGYDUUKYEUVHLGZUVIYDYETCUUOUUKUVJJUUQ
    UUSYEUUGVJMYDUUNUVHBCUVJUVIJUURYDUVHYDUUGUUSVEZVKYEUVHVLMVMYDUVHSIZSVIGCZUV
    IUVGCYDUVHTCZUVLUVHPQZUVHSPQZUVMUVKYDUVLUVHVNQZUVOYDUVQUVPAVOZVQYDUVLTCUVNU
    VQUVOVRSRVPZUVKUVLUVHVSMVTYDUVQUVPUVRWAUVLSUVHUVSRWBWCUVLSUVFUVEYEUVHUVSRYE
    UUQWDWEUVFUVLEFGZUVLYELGSBCEBCEDUAUVFUVTJSRVAZWFWISEWGWHUVLEUVLUVSVAWFWIWJW
    KUVESYELGSEUWAWFWIWJWLWMOWNUUKWOOWTYDUUFUUJUULKUUKWPHZLGZWQGZLGZNHUUJUWDNHZ
    LGUUMYDYFUWENYDYFUUHUQHZUWEYBYCUUNYFUWGJUURAYEWRXAYDUUPUWGUWEJUUTUUHWSOVMUO
    YDUUJUWDUVBYDUULUWCYDUULUVDVKYDYLUWBBCUWCBCUEYDUWBYDUUKUVCXBZVKKUWBUHMXCXDY
    DUWFUULUUJLYDUULUWBUVDUWHXJXEXFXGXHYJUUFYHNHUUEYJYFYHNYDYIXTUOYJYGYOXIVMXKY
    JYTYJYGYOVCZXLXMYBUUDYCYIAXNUGYJYTTCDTCUUBUUCUUDUBYAUWIXOYTDXPXQXRXFXS $.

  $( The complex exponential function with exponent ` 1 / 2 ` exactly matches
     the complex square root function (the branch cut is in the same place for
     both functions), and thus serves as a suitable generalization to other
     ` n ` -th roots and irrational roots.  (Contributed by Mario Carneiro,
     2-Aug-2014.) $)
  cxpsqr $p |- ( A e. CC -> ( A ^c ( 1 / 2 ) ) = ( sqr ` A ) ) $=
    ( cc wcel c1 c2 co ccxp csqr cfv wceq cc0 wne cmul ce ci cpi caddc ad2antrr
    cexp adantr cdiv wi rehalfcli recni halfgt0 gt0ne0ii 0cxp mp2an sqr0 eqtr4i
    1re oveq1 fveq2 3eqtr4a a1i wa cneg crp cr ax-icn sqrcl sqmul sylancr sqrth
    clog i2 oveq12d mulm1 3eqtrd cxpsqrlem eqeltrrd clt negeq0 necon3bid biimpa
    resqcld eqnetrd sq0i necon3i syl sqgt0d elrpd logneg negneg fveq2d relogcld
    breqtrd recnd pire mulcli addcom sylancl 3eqtr3d oveq2d adddi mp3an12 eqtrd
    2ne0 divrec2 mp3an divassi eqtr3i oveq1i syl6eq divcli mulcl efadd efhalfpi
    negcl cxpef syl3anc ax-1cn 2halves ax-mp oveq2i syl5eq rpcxpcl rpcnd sqvald
    2cn cxp1 cxpadd syl211anc eqtr4d sqsqrd 3eqtr4d cle wbr wb rprege0d syl2anc
    rpsqrcld sq11 mpbid eqtr3d mp3an3 rpge0d sqrnegd ex wo mp3an23 cxpcl sqeqor
    3eqtr3a mpan2 syldan ord con1d pm2.61d pm2.61dne ) ABCZADEUAFZGFZAHIZJZAKAK
    JZUUOUBUUKUUPKUULGFZKHIZUUMUUNUUQKUURUULBCZUULKLUUQKJUULDUKUCZUDZUULUUTUEUF
    UULUGUHUIUJAKUULGULAKHUMUNUOUUKAKLZUUOUUKUVBUPZUUMUUNUQJZUUOUVCUVDUUOUVCUVD
    UPZUULAVEIZMFZNIZOAUQZHIZMFZUUMUUNUVEUVHOPEUAFZMFZUULUVIVEIZMFZQFZNIZUVMNIZ
    UVONIZMFZUVKUVEUVGUVPNUVEUVGUULOPMFZMFZUVOQFZUVPUVEUVGUULUWAUVNQFZMFZUWCUVE
    UVFUWDUULMUVEUVIUQZVEIZUVNUWAQFZUVFUWDUVEUVIURCZUWGUWHJUVEUVIUVEOUUNMFZESFZ
    UVIUSUVEUWKOESFZUUNESFZMFZDUQZAMFZUVIUVEOBCUUNBCZUWKUWNJUTUUKUWQUVBUVDAVAZR
    OUUNVBVCUVEUWLUWOUWMAMUWLUWOJUVEVFUOUUKUWMAJZUVBUVDAVDZRVGUUKUWPUVIJUVBUVDA
    VHRVIZUVEUWJAVJZVPVKZUVEKUWKUVIVLUVEUWJUXBUVEUWKKLUWJKLUVEUWKUVIKUXAUVCUVIK
    LZUVDUUKUVBUXDUUKAKUVIKAVMVNVOTZVQUWJKUWKKUWJVRVSVTWAUXAWGWBZUVIWCVTUVEUWFA
    VEUUKUWFAJUVBUVDAWDRZWEUVEUVNBCZUWABCZUWHUWDJUVEUVNUVEUVIUXFWFWHZOPUTPWIUDZ
    WJZUVNUWAWKWLWMWNUVEUXHUWEUWCJZUXJUUSUXIUXHUXMUVAUXLUULUWAUVNWOWPVTWQUWBUVM
    UVOQUWAEUAFZUWBUVMUXIEBCEKLUXNUWBJUXLXTWRUWAEWSWTOPEUTUXKXTWRXAXBXCXDWEUVEU
    VMBCUVOBCZUVQUVTJOUVLUTPEUXKXTWRXEWJUVEUUSUXHUXOUVAUXJUULUVNXFVCUVMUVOXGVCU
    VEUVROUVSUVJMUVROJUVEXHUOUVEUVIUULGFZUVSUVJUVEUVIBCZUXDUUSUXPUVSJUUKUXQUVBU
    VDAXIRZUXEUUSUVEUVAUOZUVIUULXJXKUVEUXPESFZUVJESFZJZUXPUVJJZUVEUVIUULUULQFZG
    FZUVIUXTUYAUVEUYEUVIDGFZUVIUYDDUVIGDBCUYDDJXLDXMXNZXOUVEUXQUYFUVIJUXRUVIYAV
    TXPUVEUXTUXPUXPMFZUYEUVEUXPUVEUXPUVEUWIUULUSCUXPURCUXFUUTUVIUULXQWLZXRXSUVE
    UXQUXDUUSUUSUYEUYHJUXRUXEUXSUXSUVIUULUULYBYCYDUVEUVIUXRYEYFUVEUXPUSCKUXPYGY
    HUPUVJUSCKUVJYGYHUPUYBUYCYIUVEUXPUYIYJUVEUVJUVEUVIUXFYLYJUXPUVJYMYKYNYOVGVI
    UVCUUMUVHJZUVDUUKUVBUUSUYJUVAAUULXJYPTUVEUWFHIUUNUVKUVEUWFAHUXGWEUVEUVIUXCU
    VEUVIUXFYQYRYOYFYSUVCUUOUVDUVCUUOUVDUUKUVBUUMESFZUWMJZUUOUVDYTZUVCUUMUUMMFZ
    AUYKUWMUVCAUYDGFZADGFZUYNAUYDDAGUYGXOUVCUUSUUSUYOUYNJUVAUVAAUULUULYBUUAUUKU
    YPAJUVBAYATUUDUUKUYKUYNJUVBUUKUUMUUKUUSUUMBCZUVAAUULUUBUUEZXSTUUKUWSUVBUWTT
    YFUUKUYLUYMUUKUYQUWQUYLUYMYIUYRUWRUUMUUNUUCYKVOUUFUUGUUHUUIYSUUJ $.

  $( Logarithm of a square root.  (Contributed by Mario Carneiro,
     5-May-2016.) $)
  logsqr $p |- ( A e. RR+ -> ( log ` ( sqr ` A ) ) = ( ( log ` A ) / 2 ) ) $=
    ( crp wcel clog cfv c2 cdiv co c1 cmul ccxp csqr wceq relogcl recnd cc0 wne
    cc 2ne0 syl 2cn divrec2 mp3an23 cr rereccli logcxp mpan2 rpcn cxpsqr fveq2d
    2re 3eqtr2rd ) ABCZADEZFGHZIFGHZUNJHZAUPKHZDEZALEZDEUMUNRCZUOUQMZUMUNANOVAF
    RCFPQVBUASUNFUBUCTUMUPUDCUSUQMFUKSUEAUPUFUGUMURUTDUMARCURUTMAUHAUITUJUL $.

  ${
    cxp0d.1 $e |- ( ph -> A e. CC ) $.
    $( Value of the complex power function when the second argument is zero.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    cxp0d $p |- ( ph -> ( A ^c 0 ) = 1 ) $=
      ( cc wcel cc0 ccxp co c1 wceq cxp0 syl ) ABDEBFGHIJCBKL $.

    $( Value of the complex power function at one.  (Contributed by Mario
       Carneiro, 30-May-2016.) $)
    cxp1d $p |- ( ph -> ( A ^c 1 ) = A ) $=
      ( cc wcel c1 ccxp co wceq cxp1 syl ) ABDEBFGHBICBJK $.

    $( Value of the complex power function at one.  (Contributed by Mario
       Carneiro, 30-May-2016.) $)
    1cxpd $p |- ( ph -> ( 1 ^c A ) = 1 ) $=
      ( cc wcel c1 ccxp co wceq 1cxp syl ) ABDEFBGHFICBJK $.

    ${
      cxpcld.2 $e |- ( ph -> B e. CC ) $.
      $( Closure of the complex power function.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxpcld $p |- ( ph -> ( A ^c B ) e. CC ) $=
        ( cc wcel ccxp co cxpcl syl2anc ) ABFGCFGBCHIFGDEBCJK $.

      cxpmul2d.4 $e |- ( ph -> C e. NN0 ) $.
      $( Product of exponents law for complex exponentiation.  Variation on
         ~ cxpmul with more general conditions on ` A ` and ` B ` when ` C ` is
         an integer.  (Contributed by Mario Carneiro, 30-May-2016.) $)
      cxpmul2d $p |- ( ph -> ( A ^c ( B x. C ) ) = ( ( A ^c B ) ^ C ) ) $=
        ( cc wcel cn0 cmul co ccxp cexp wceq cxpmul2 syl3anc ) ABHICHIDJIBCDKLM
        LBCMLDNLOEFGBCDPQ $.
    $}

    cxpefd.2 $e |- ( ph -> A =/= 0 ) $.
    $( Value of the complex power function when the first argument is zero.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    0cxpd $p |- ( ph -> ( 0 ^c A ) = 0 ) $=
      ( cc wcel cc0 wne ccxp co wceq 0cxp syl2anc ) ABEFBGHGBIJGKCDBLM $.

    ${
      cxpexpzd.3 $e |- ( ph -> B e. ZZ ) $.
      $( Relate the complex power function to the integer power function.
         (Contributed by Mario Carneiro, 30-May-2016.) $)
      cxpexpzd $p |- ( ph -> ( A ^c B ) = ( A ^ B ) ) $=
        ( cc wcel cc0 wne cz ccxp co cexp wceq cxpexpz syl3anc ) ABGHBIJCKHBCLM
        BCNMODEFBCPQ $.
    $}

    cxpefd.3 $e |- ( ph -> B e. CC ) $.
    $( Value of the complex power function.  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    cxpefd $p |- ( ph -> ( A ^c B ) = ( exp ` ( B x. ( log ` A ) ) ) ) $=
      ( cc wcel cc0 wne ccxp co clog cfv cmul ce wceq cxpef syl3anc ) ABGHBIJCG
      HBCKLCBMNOLPNQDEFBCRS $.

    $( Complex exponentiation is nonzero if its mantissa is nonzero.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    cxpne0d $p |- ( ph -> ( A ^c B ) =/= 0 ) $=
      ( cc wcel cc0 wne ccxp co cxpne0 syl3anc ) ABGHBIJCGHBCKLIJDEFBCMN $.

    $( Value of a nonzero complex number raised to a complex power plus one.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    cxpp1d $p |- ( ph -> ( A ^c ( B + 1 ) ) = ( ( A ^c B ) x. A ) ) $=
      ( cc wcel cc0 wne c1 caddc co ccxp cmul wceq cxpp1 syl3anc ) ABGHBIJCGHBC
      KLMNMBCNMBOMPDEFBCQR $.

    $( Value of a complex number raised to a negative power.  (Contributed by
       Mario Carneiro, 30-May-2016.) $)
    cxpnegd $p |- ( ph -> ( A ^c -u B ) = ( 1 / ( A ^c B ) ) ) $=
      ( cc wcel cc0 wne cneg ccxp co c1 cdiv wceq cxpneg syl3anc ) ABGHBIJCGHBC
      KLMNBCLMOMPDEFBCQR $.

    ${
      cxpmul2zd.4 $e |- ( ph -> C e. ZZ ) $.
      $( Generalize ~ cxpmul2 to negative integers.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxpmul2zd $p |- ( ph -> ( A ^c ( B x. C ) ) = ( ( A ^c B ) ^ C ) ) $=
        ( cc wcel cc0 wne cz cmul co ccxp cexp wceq cxpmul2z syl22anc ) ABIJBKL
        CIJDMJBCDNOPOBCPODQOREFGHBCDST $.
    $}

    cxpaddd.4 $e |- ( ph -> C e. CC ) $.
    $( Sum of exponents law for complex exponentiation.  Proposition 10-4.2(a)
       of [Gleason] p. 135.  (Contributed by Mario Carneiro, 30-May-2016.) $)
    cxpaddd $p |- ( ph ->
      ( A ^c ( B + C ) ) = ( ( A ^c B ) x. ( A ^c C ) ) ) $=
      ( cc wcel cc0 wne caddc co ccxp cmul wceq cxpadd syl211anc ) ABIJBKLCIJDI
      JBCDMNONBCONBDONPNQEFGHBCDRS $.

    $( Exponent subtraction law for complex exponentiation.  (Contributed by
       Mario Carneiro, 30-May-2016.) $)
    cxpsubd $p |- ( ph -> ( A ^c ( B - C ) ) = ( ( A ^c B ) / ( A ^c C ) ) ) $=
      ( cc wcel cc0 wne cmin co ccxp cdiv wceq cxpsub syl211anc ) ABIJBKLCIJDIJ
      BCDMNONBCONBDONPNQEFGHBCDRS $.
  $}

  ${
    recxpcld.1 $e |- ( ph -> A e. RR ) $.
    ${
      cxpltd.2 $e |- ( ph -> 1 < A ) $.
      cxpltd.3 $e |- ( ph -> B e. RR ) $.
      cxpltd.4 $e |- ( ph -> C e. RR ) $.
      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxpltd $p |- ( ph -> ( B < C <-> ( A ^c B ) < ( A ^c C ) ) ) $=
        ( cr wcel c1 clt wbr ccxp co wb cxplt syl22anc ) ABIJKBLMCIJDIJCDLMBCNO
        BDNOLMPEFGHBCDQR $.

      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxpled $p |- ( ph -> ( B <_ C <-> ( A ^c B ) <_ ( A ^c C ) ) ) $=
        ( cr wcel c1 clt wbr cle ccxp co wb cxple syl22anc ) ABIJKBLMCIJDIJCDNM
        BCOPBDOPNMQEFGHBCDRS $.
    $}

    ${
      cxplead.2 $e |- ( ph -> 1 <_ A ) $.
      cxplead.3 $e |- ( ph -> B e. RR ) $.
      cxplead.4 $e |- ( ph -> C e. RR ) $.
      cxplead.5 $e |- ( ph -> B <_ C ) $.
      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxplead $p |- ( ph -> ( A ^c B ) <_ ( A ^c C ) ) $=
        ( cr wcel c1 cle wbr ccxp co cxplea syl221anc ) ABJKLBMNCJKDJKCDMNBCOPB
        DOPMNEFGHIBCDQR $.
    $}

    recxpcld.2 $e |- ( ph -> 0 <_ A ) $.
    ${
      divcxpd.4 $e |- ( ph -> B e. RR+ ) $.
      divcxpd.5 $e |- ( ph -> C e. CC ) $.
      $( Complex exponentiation of a quotient.  (Contributed by Mario Carneiro,
         30-May-2016.) $)
      divcxpd $p |- ( ph ->
        ( ( A / B ) ^c C ) = ( ( A ^c C ) / ( B ^c C ) ) ) $=
        ( cr wcel cc0 cle wbr crp cc cdiv co ccxp wceq divcxp syl211anc ) ABIJK
        BLMCNJDOJBCPQDRQBDRQCDRQPQSEFGHBCDTUA $.
    $}

    recxpcld.3 $e |- ( ph -> B e. RR ) $.
    $( Positive real closure of the complex power function.  (Contributed by
       Mario Carneiro, 30-May-2016.) $)
    recxpcld $p |- ( ph -> ( A ^c B ) e. RR ) $=
      ( cr wcel cc0 cle wbr ccxp co recxpcl syl3anc ) ABGHIBJKCGHBCLMGHDEFBCNO
      $.

    $( Nonnegative exponentiation with a real exponent is nonnegative.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    cxpge0d $p |- ( ph -> 0 <_ ( A ^c B ) ) $=
      ( cr wcel cc0 cle wbr ccxp co cxpge0 syl3anc ) ABGHIBJKCGHIBCLMJKDEFBCNO
      $.

    ${
      cxple2ad.4 $e |- ( ph -> C e. RR ) $.
      cxple2ad.5 $e |- ( ph -> 0 <_ C ) $.
      cxple2ad.6 $e |- ( ph -> A <_ B ) $.
      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxple2ad $p |- ( ph -> ( A ^c C ) <_ ( B ^c C ) ) $=
        ( cr wcel cc0 cle wbr ccxp co cxple2a syl321anc ) ABKLCKLDKLMBNOMDNOBCN
        OBDPQCDPQNOEGHFIJBCDRS $.
    $}

    mulcxpd.4 $e |- ( ph -> 0 <_ B ) $.
    ${
      cxple2d.5 $e |- ( ph -> C e. RR+ ) $.
      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxplt2d $p |- ( ph -> ( A < B <-> ( A ^c C ) < ( B ^c C ) ) ) $=
        ( cr wcel cc0 cle wbr crp clt ccxp co wb cxplt2 syl221anc ) ABJKLBMNCJK
        LCMNDOKBCPNBDQRCDQRPNSEFGHIBCDTUA $.

      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxple2d $p |- ( ph -> ( A <_ B <-> ( A ^c C ) <_ ( B ^c C ) ) ) $=
        ( cr wcel cc0 cle wbr crp ccxp co wb cxple2 syl221anc ) ABJKLBMNCJKLCMN
        DOKBCMNBDPQCDPQMNREFGHIBCDST $.
    $}

    mulcxpd.5 $e |- ( ph -> C e. CC ) $.
    $( Complex exponentiation of a product.  Proposition 10-4.2(c) of [Gleason]
       p. 135.  (Contributed by Mario Carneiro, 30-May-2016.) $)
    mulcxpd $p |- ( ph ->
      ( ( A x. B ) ^c C ) = ( ( A ^c C ) x. ( B ^c C ) ) ) $=
      ( cr wcel cc0 cle wbr cc cmul co ccxp wceq mulcxp syl221anc ) ABJKLBMNCJK
      LCMNDOKBCPQDRQBDRQCDRQPQSEFGHIBCDTUA $.
  $}

  ${
    rpcxpcld.1 $e |- ( ph -> A e. RR+ ) $.
    ${
      cxprecd.2 $e |- ( ph -> B e. CC ) $.
      $( Complex exponentiation of a reciprocal.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxprecd $p |- ( ph -> ( ( 1 / A ) ^c B ) = ( 1 / ( A ^c B ) ) ) $=
        ( crp wcel cc c1 cdiv co ccxp wceq cxprec syl2anc ) ABFGCHGIBJKCLKIBCLK
        JKMDEBCNO $.
    $}

    rpcxpcld.2 $e |- ( ph -> B e. RR ) $.
    $( Positive real closure of the complex power function.  (Contributed by
       Mario Carneiro, 30-May-2016.) $)
    rpcxpcld $p |- ( ph -> ( A ^c B ) e. RR+ ) $=
      ( crp wcel cr ccxp co rpcxpcl syl2anc ) ABFGCHGBCIJFGDEBCKL $.

    $( Logarithm of a complex power.  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    logcxpd $p |- ( ph -> ( log ` ( A ^c B ) ) = ( B x. ( log ` A ) ) ) $=
      ( crp wcel cr ccxp co clog cfv cmul wceq logcxp syl2anc ) ABFGCHGBCIJKLCB
      KLMJNDEBCOP $.

    ${
      cxplt3d.3 $e |- ( ph -> A < 1 ) $.
      cxplt3d.4 $e |- ( ph -> C e. RR ) $.
      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxplt3d $p |- ( ph -> ( B < C <-> ( A ^c C ) < ( A ^c B ) ) ) $=
        ( crp wcel c1 clt wbr cr ccxp co wb cxplt3 syl22anc ) ABIJBKLMCNJDNJCDL
        MBDOPBCOPLMQEGFHBCDRS $.

      $( Ordering property for complex exponentiation.  (Contributed by Mario
         Carneiro, 30-May-2016.) $)
      cxple3d $p |- ( ph -> ( B <_ C <-> ( A ^c C ) <_ ( A ^c B ) ) ) $=
        ( crp wcel c1 clt wbr cr cle ccxp co wb cxple3 syl22anc ) ABIJBKLMCNJDN
        JCDOMBDPQBCPQOMREGFHBCDST $.
    $}

    cxpmuld.4 $e |- ( ph -> C e. CC ) $.
    $( Product of exponents law for complex exponentiation.  Proposition
       10-4.2(b) of [Gleason] p. 135.  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    cxpmuld $p |- ( ph -> ( A ^c ( B x. C ) ) = ( ( A ^c B ) ^c C ) ) $=
      ( crp wcel cr cc cmul co ccxp wceq cxpmul syl3anc ) ABHICJIDKIBCDLMNMBCNM
      DNMOEFGBCDPQ $.
  $}

  ${
    $d x y A $.
    $( The derivative of a complex power with respect to the first argument.
       (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    dvcxp1 $p |- ( A e. CC -> ( RR _D ( x e. RR+ |-> ( x ^c A ) ) ) =
      ( x e. RR+ |-> ( A x. ( x ^c ( A - 1 ) ) ) ) ) $=
      ( vy cc wcel cr crp clog cfv cmul co cmpt cdv cdiv ccxp a1i adantl oveq2d
      ce c1 cv cmin cvv cpr reex prid1 relogcl rpreccl recn wa mulcl syl sylan2
      efcl ovex cres dvrelog wf1o wf relogf1o f1of mp1i feqmptd mpteq2ia syl6eq
      fvres syl5reqr ccnfld ctopn eqid ctopon cnfldtopon toponmax wss ax-resscn
      cin wceq df-ss sylib prid2 simpl simpr ax-1cn dvmptid id dvmptcmul mulid1
      cnex mpteq2dv eqtrd eff eqcomd dvef fveq2 dvmptco dvmptres3 fveq2d oveq1d
      oveq2 rpcn cc0 rpne0 cxpefd mpteq2dva cxpsubd cxp1d cxpcld divrecd 3eqtrd
      wne rpcnd mul12d mulassd eqtr4d 3eqtr4d ) BDEZFAGBAUAZHIZJKZSIZLZMKAGXTBJ
      KZTXQNKZJKZLFAGXQBOKZLZMKAGBXQBTUBKOKZJKZLXPACXRYCBCUAZJKZSIZYKBJKZFFXTYB
      GUCGFFFDUDZEXPFDUEUFPZYNXQGEZXRFEXPXQUGQYOYCGEXPXQUHQZYIFEZXPYIDEZYKDEZYI
      UIXPYRUJZYJDEYSBYIUKZYJUNULZUMYLUCEZXPYQUJYKBJUOZPXPAGYCLFHGUPZMKFAGXRLZM
      KAUQXPUUEUUFFMXPUUEAGXQUUEIZLUUFXPAGFUUEGFUUEURGFUUEUSXPUTGFUUEVAVBVCAGUU
      GXRXQGHVFVDVERVGXPCYKYLFVHVIIZUCDFUUHVJZYNUUHDVKIEDUUHEXPUUHUUIVLDUUHVMVB
      XPFDVNZFDVPFVQUUJXPVOPFDVRVSUUBUUCYTUUDPXPCAYJBXQSIZUUKDDYKYKDDDDDYMEXPFD
      WHVTPZUULUUAXPYRWAXQDEZUUKDEXPXQUNQZUUNXPDCDYJLMKCDBTJKZLCDBLXPCYITBDDDUU
      LXPYRWBTDEZYTWCPXPCDUULWDXPWEWFXPCDUUOBBWGWIWJXPDADUUKLZMKZSUUQXPUURDSMKS
      XPUUQSDMXPSUUQXPADDSDDSUSXPWKPVCZWLRWMVEUUSWJXQYJSWNZUUTWOWPYIXRVQZYJXSSY
      IXRBJWSWQZUVAYKXTBJUVBWRWOXPYFYAFMXPAGYEXTXPYOUJZXQBYOUUMXPXQWTQZYOXQXAXJ
      XPXQXBQZXPYOWAZXCZXDRXPAGYHYDUVCYHBYEYCJKZJKZYEBJKZYCJKZYDUVCYGUVHBJUVCYG
      YEXQTOKZNKYEXQNKUVHUVCXQBTUVDUVEUVFUUPUVCWCPXEUVCUVLXQYENUVCXQUVDXFRUVCYE
      XQUVCXQBUVDUVFXGZUVDUVEXHXIRUVCUVIYEBYCJKJKUVKUVCBYEYCUVFUVMUVCYCYPXKZXLU
      VCYEBYCUVMUVFUVNXMXNUVCUVJYBYCJUVCYEXTBJUVGWRWRXIXDXO $.

    $( The derivative of a complex power with respect to the second argument.
       (Contributed by Mario Carneiro, 24-Feb-2015.) $)
    dvcxp2 $p |- ( A e. RR+ -> ( CC _D ( x e. CC |-> ( A ^c x ) ) ) =
      ( x e. CC |-> ( ( log ` A ) x. ( A ^c x ) ) ) ) $=
      ( vy wcel cc cv cfv cmul co ce cmpt cdv cr adantr recnd mulcomd mpteq2dva
      a1i c1 oveq2d crp clog ccxp cpr cnex prid2 wa simpr relogcl mulcld adantl
      efcl ax-1cn dvmptid dvmptcmul mulid1d 3eqtrd dvef wf feqmptd eqcomd fveq2
      eff 3eqtr4a dvmptco rpcn cc0 wne rpne0 cxpefd cxpcld oveq1d eqtrd 3eqtr4d
      ) BUADZEAEAFZBUBGZHIZJGZKZLIAEVSVQHIZKEAEBVPUCIZKZLIAEVQWBHIZKVOACVRVQCFZ
      JGZWFEEVSVSMEEEEMEUDDVOMEUEUFRZWGVOVPEDZUGZVPVQVOWHUHZWIVQVOVQMDWHBUIZNZO
      ZUJWLWEEDWFEDVOWEULUKZWNVOEAEVRKZLIEAEVQVPHIZKZLIAEVQSHIZKAEVQKVOWOWQELVO
      AEVRWPWIVPVQWJWMPQTVOAVPSVQEEEWGWJSEDWIUMRVOAEWGUNVOVQWKOUOVOAEWRVQWIVQWM
      UPQUQVOEJLIJECEWFKZLIWSURVOWSJELVOJWSVOCEEJEEJUSVOVCRUTVAZTWTVDWEVRJVBZXA
      VEVOWCVTELVOAEWBVSWIBVPVOBEDWHBVFNZVOBVGVHWHBVINWJVJZQTVOAEWDWAWIWDWBVQHI
      WAWIVQWBWMWIBVPXBWJVKPWIWBVSVQHXCVLVMQVN $.
  $}

  ${
    $( The derivative of the real square root function.  (Contributed by Mario
       Carneiro, 1-May-2016.) $)
    dvsqr $p |- ( RR _D ( x e. RR+ |-> ( sqr ` x ) ) ) =
      ( x e. RR+ |-> ( 1 / ( 2 x. ( sqr ` x ) ) ) ) $=
      ( cr crp c1 c2 cdiv co ccxp cmpt cdv cmin cmul wcel ax-1cn ax-mp mpteq2ia
      cc wceq cc0 a1i cv csqr cfv halfcl dvcxp1 rpcn cxpsqr oveq2i cneg addid1i
      syl caddc 2halves eqtr4i wb 0cn addsubeq4 mp4an mpbi df-neg rpne0 cxpnegd
      syl5eq oveq2d eqtrd wne wa 2cn pm3.2i rpsqrcl rpcnne0d divmuldiv syl22anc
      2ne0 1t1e1 oveq1i syl6eq 3eqtr3i ) BACAUAZDEFGZHGZIZJGZACVTVSVTDKGZHGZLGZ
      IZBACVSUBUCZIZJGACDEWHLGZFGZIVTQMZWCWGRDQMZWLNDUDOZAVTUEOWBWIBJACWAWHVSCM
      ZVSQMWAWHRVSUFZVSUGUKZPUHACWFWKWOWFVTDWHFGZLGZWKWOWEWRVTLWOWEDWAFGZWRWOWE
      VSVTUIZHGWTWDXAVSHWDSVTKGZXADSULGZVTVTULGZRZWDXBRZXCDXDDNUJWMXDDRNDUMOUNW
      MSQMWLWLXEXFUONUPWNWNDSVTVTUQURUSVTUTUNUHWOVSVTWPVSVAWLWOWNTVBVCWOWAWHDFW
      QVDVEVDWOWSDDLGZWJFGZWKWOWMWMEQMZESVFZVGZWHQMWHSVFVGWSXHRWMWONTZXLXKWOXIX
      JVHVNVITWOWHVSVJVKDDEWHVLVMXGDWJFVOVPVQVEPVR $.
  $}

  ${
    $d x y D $.  $d x y J $.  $d x y K $.
    cxpcn.d $e |- D = ( CC \ ( -oo (,] 0 ) ) $.
    cxpcn.j $e |- J = ( TopOpen ` CCfld ) $.
    cxpcn.k $e |- K = ( J |`t D ) $.
    $( Domain of continuity of the complex power function.  (Contributed by
       Mario Carneiro, 1-May-2016.) $)
    cxpcn $p |- ( x e. D , y e. CC |-> ( x ^c y ) ) e. ( ( K tX J ) Cn J ) $=
      ( cc co cmpt2 clog cfv cmul ce ccn wcel adantr wtru a1i cv ccxp ctx wa cr
      crp wi ellogdm simplbi cc0 wne logdmn0 cxpefd mpt2eq3ia ctopon cnfldtopon
      simpr crest wss ssriv resttopon sylancl syl5eqel cnmpt2nd cres wceq fvres
      cnmpt1st ccncf logcn ssid toponunii restid eqcomi cncfcn eleqtri cnmpt21f
      ax-mp mp2an syl5eqelr mulcn cnmpt22f efcn cncfcn1 trud eqeltri ) ABCIAUAZ
      BUAZUBJZKABCIWHWGLMZNJZOMZKZEDUCJDPJZABCIWIWLWGCQZWHIQZUDWGWHWOWGIQZWPWOW
      QWGUEQWGUFQUGWGCFUHUIZRWOWGUJUKWPWGCFULRWOWPUQUMUNWMWNQSABWKOEDDDCISEDCUR
      JZCUOMZHSDIUOMZQZCIUSZWSWTQXBSDGUPZTZACIWRUTZCDIVAVBVCZXESABWHWJNEDDDDCIX
      GXESABEDCIXGXEVDSABCIWJKABCIWGLCVEZMZKWNABCIXIWJWOXIWJVFWPWGCLVGRUNSABWGX
      HEDEDCIXGXESABEDCIXGXEVHXHEDPJZQSXHCIVIJZXJCFVJXCIIUSXKXJVFXFIVKCIDEDGHDI
      URJZDXBXLDVFXDDXAIIDXDVLVMVRVNVOVSVPTVQVTNDDUCJDPJQSDGWATWBODDPJZQSOIIVIJ
      XMWCDGWDVPTVQWEWF $.
  $}

  ${
    $d x y J $.
    cxpcn2.j $e |- J = ( TopOpen ` CCfld ) $.
    cxpcn2.k $e |- K = ( J |`t RR+ ) $.
    $( Continuity of the complex power function, when the base is real.
       (Contributed by Mario Carneiro, 1-May-2016.) $)
    cxpcn2 $p |- ( x e. RR+ , y e. CC |-> ( x ^c y ) )
        e. ( ( K tX J ) Cn J ) $=
      ( crp cc cv co cmpt2 ctx ccn wcel wtru crest ctopon cfv wss a1i ccxp cmnf
      cc0 cioc cdif wceq cnfldtopon cr wi rpcn ax-1 eqid ellogdm sylanbrc ssriv
      difss ssexi restabs mp3an eqtr4i resttopon sylancl toponunii restid ax-mp
      cvv cnex eqcomi ssid cxpcn cnmpt2res trud ) ABGHAIZBIUAJZKDCLJCMJNOABVNCH
      UBUCUDJZUEZPJZDCCCHVPGHDCGPJZVQGPJZFCHQRZNZGVPSZVPVFNVSVRUFCEUGZAGVPVMGNZ
      VMHNVMUHNZWDUIVMVPNVMUJWDWEUKVMVPVPULZUMUNUOZVPHVGHVOUPZUQGVPCVTVFURUSUTO
      WAVPHSVQVPQRNWAOWCTZWHVPCHVAVBWBOWGTCHPJZCWAWJCUFWCCVTHHCWCVCVDVEVHWIHHSO
      HVITABVPHVNKVQCLJCMJNOABVPCVQWFEVQULVJTVKVL $.
  $}

  ${
    $d a b d A $.  $d a b d E $.  $d d e u v x y z J $.  $d a b d e u v z K $.
    $d a b d e u v x y z D $.  $d a b d e u v z L $.  $d a b d T $.
    cxpcn3.d $e |- D = ( `' Re " RR+ ) $.
    cxpcn3.j $e |- J = ( TopOpen ` CCfld ) $.
    cxpcn3.k $e |- K = ( J |`t ( 0 [,) +oo ) ) $.
    cxpcn3.l $e |- L = ( J |`t D ) $.
    ${
      cxpcn3.u $e |- U = ( if ( ( Re ` A ) <_ 1 , ( Re ` A ) , 1 ) / 2 ) $.
      cxpcn3.t $e |- T =
        if ( U <_ ( E ^c ( 1 / U ) ) , U , ( E ^c ( 1 / U ) ) ) $.
      $( Lemma for ~ cxpcn3 .  (Contributed by Mario Carneiro, 2-May-2016.) $)
      cxpcn3lem $p |- ( ( A e. D /\ E e. RR+ ) ->
        E. d e. RR+ A. a e. ( 0 [,) +oo ) A. b e. D
          ( ( ( abs ` a ) < d /\ ( abs ` ( A - b ) ) < d ) ->
            ( abs ` ( a ^c b ) ) < E ) ) $=
        ( wcel clt wbr crp wa cv cabs cfv cmin co ccxp wi wral cc0 cpnf cico c1
        wrex cdiv cle cif cre c2 cc ccnv cima eleq2i cr wf wfn ref ffn elpreima
        wb mp2b bitri simprbi adantr 1rp ifcl rphalfcld syl5eqel simpr rpreccld
        sylancl rpred rpcxpcld syl2anc elrege0 wceq wo 0re a1i leloe sylan elrp
        w3a simp2l simp2r cdm cnvimass fdmi sseqtri eqsstri syl abscxp 3ad2ant1
        sseli recld simp1r simp1l simplbi rehalfcld 1re min1 2re 2pos syl112anc
        lediv1 mpbid syl5eqbr caddc recnd 2halvesd resubd subcld releabsd ltmin
        abscld simp3r syl6breq syl3anc simpld lelttrd ltletrd eqbrtrrd rprege0d
        eqbrtrd mpbird lttrd wne rpcnd breq2 ltsubadd2d ltadd1d simp3l rehalfcl
        absid mp1i min2 halflt1 cxplt3d cmul recid oveq2d cxpmuld cxp1d 3eqtr3d
        rpcnne0d simprd cxplt2 3expia anassrs sylan2br expr eleq2s rpne0d fveq2
        ralrimiva re0 syl6eq necon3i 0cxpd adantl abs00bd simpllr rpgt0d fveq2d
        oveq1 breq1d syl5ibcom ralrimdva sylbid expimpd syl5bi ralrimiv anbi12d
        a1dd jaod imbi1d 2ralbidv rspcev ) ABRZEUARZUBZCUARIUCZUDUEZCSTZAJUCZUF
        UGZUDUEZCSTZUBZUWMUWPUHUGZUDUEZESTZUIZJBUJZIUKULUMUGZUJZUWNKUCZSTZUWRUX
        HSTZUBZUXCUIZJBUJIUXFUJZKUAUOUWLCDEUNDUPUGZUHUGZUQTZDUXOURZUAQUWLDUARZU
        XOUARZUXQUARUWLDAUSUEZUNUQTZUXTUNURZUTUPUGZUAPUWLUYBUWLUXTUARZUNUARUYBU
        ARZUWJUYDUWKUWJAVARZUYDUWJAUSVBUAVCZRZUYFUYDUBZBUYGALVDVAVEUSVFZUSVAVGZ
        UYHUYIVKVHVAVEUSVIZVAAUAUSVJVLVMZVNVOVPUYAUXTUNUAVQWBZVRVSZUWLEUXNUWJUW
        KVTUWLUXNUWLDUYOWAWCWDZUXPDUXOUAVQWEVSUWLUXEIUXFUWMUXFRUWMVERZUKUWMUQTZ
        UBZUWLUXEUWMWFUWLUYQUYRUXEUWLUYQUBZUYRUKUWMSTZUKUWMWGZWHZUXEUWLUKVERZUY
        QUYRVUCVKVUDUWLWIWJUKUWMWKWLUYTVUAUXEVUBUWLUYQVUAUXEUYQVUAUBUWLUWMUARZU
        XEUWMWMUWLVUEUBUXDJBUWLVUEUWPBRZUXDUWLVUEVUFUBZUWTUXCUWLVUGUWTWNZUXBUWM
        UWPUSUEZUHUGZESVUHVUEUWPVARZUXBVUJWGUWLVUEVUFUWTWOZVUHVUFVUKUWLVUEVUFUW
        TWPBVAUWPBUYGVALUYGUSWQVAUSUAWRVAVEUSVHWSWTXAXEZXBZUWMUWPXCWEVUHVUJUWMD
        UHUGZEVUHVUJVUHUWMVUIVULVUHUWPVUNXFZWDWCVUHVUOVUHUWMDVULVUHDUWLVUGUXRUW
        TUYOXDZWCZWDZWCVUHEUWJUWKVUGUWTXGZWCVUHDVUISTVUJVUOSTVUHDUXTUTUPUGZVUIV
        URVUHUXTVUHAVUHUWJUYFUWJUWKVUGUWTXHUWJUYFUYDUYMXIXBZXFZXJZVUPVUHDUYCVVA
        UQPVUHUYBUXTUQTZUYCVVAUQTZVUHUXTVERZUNVERZVVEVVCXKUXTUNXLWBVUHUYBVERZVV
        GUTVERZUKUTSTZVVEVVFVKVUHUYBUWLVUGUYEUWTUYNXDWCZVVCVVJVUHXMWJZVVKVUHXNW
        JZUYBUXTUTXPXOXQXRZVUHVVAVUISTVVAVVAXSUGZVUIVVAXSUGZSTVUHVVPUXTVVQSVUHU
        XTVUHUXTVVCXTYAVUHUXTVUIUFUGZVVASTUXTVVQSTVUHUWQUSUEZVVRVVASVUHAUWPVVBV
        UNYBVUHVVSDVVAVUHUWQVUHAUWPVVBVUNYCZXFZVURVVDVUHVVSUWRDVWAVUHUWQVVTYFZV
        URVUHUWQVVTYDVUHUWRDSTZUWRUXOSTZVUHUWRUXQSTZVWCVWDUBZVUHUWRCUXQSUWLVUGU
        WOUWSYGQYHVUHUWRVERDVERZUXOVERZVWEVWFVKVWBVURVUHUXOUWLVUGUXSUWTUYPXDWCZ
        UWRDUXOYEYIXQYJYKVVOYLYMVUHUXTVUIVVAVVCVUPVVDUUAXQYOVUHVVAVUIVVAVVDVUPV
        VDUUBYPYKVUHUWMDVUIVULVURVUHUWMDUNVUHUWMVULWCZVURVVHVUHXKWJZVUHUWMDSTZU
        WMUXOSTZVUHUWMUXQSTZVWLVWMUBZVUHUWMCUXQSVUHUWNUWMCSVUHUYSUWNUWMWGVUHUWM
        VULYNUWMUUEXBUWLVUGUWOUWSUUCYMQYHVUHUYQVWGVWHVWNVWOVKVWJVURVWIUWMDUXOYE
        YIXQZYJVUHDUNUTUPUGZUNVURVVHVWQVERVUHXKUNUUDUUFVWKVUHDUYCVWQUQPVUHUYBUN
        UQTZUYCVWQUQTZVUHVVGVVHVWRVVCXKUXTUNUUGWBVUHVVIVVHVVJVVKVWRVWSVKVVLVWKV
        VMVVNUYBUNUTXPXOXQXRVWQUNSTVUHUUHWJYKYQVUPUUIXQVUHVUOESTZVUOUXNUHUGZUXO
        STZVUHVXAUWMUXOSVUHUWMDUXNUUJUGZUHUGUWMUNUHUGVXAUWMVUHVXCUNUWMUHVUHDVAR
        DUKYRUBVXCUNWGVUHDVUQUUPDUUKXBUULVUHUWMDUXNVULVURVUHUXNVUHDVUQWAZYSUUMV
        UHUWMVUHUWMVULYSUUNUUOVUHVWLVWMVWPUUQYOVUHVUOVERUKVUOUQTUBEVERUKEUQTUBU
        XNUARVWTVXBVKVUHVUOVUSYNVUHEVUTYNVXDVUOEUXNUURYIYPYQYOUUSUUTUVFUVAUVBUY
        TVUBUXDJBUYTVUFUBZVUBUXCUWTVXEUKUWPUHUGZUDUEZESTVUBUXCVXEVXGUKESVXEVXFV
        UFVXFUKWGUYTVUFUWPVUMVUFVUIUKYRUWPUKYRVUFVUIVUIUARZUWPUYGBUWPUYGRZVUKVX
        HUYJUYKVXIVUKVXHUBVKVHUYLVAUWPUAUSVJVLVNLUVCUVDUWPUKVUIUKUWPUKWGVUIUKUS
        UEUKUWPUKUSUVEUVGUVHUVIXBUVJUVKUVLVXEEUWJUWKUYQVUFUVMUVNYOVUBVXGUXBESVU
        BVXFUXAUDUKUWMUWPUHUVPUVOUVQUVRUWEUVSUWFUVTUWAUWBUWCUXMUXGKCUAUXHCWGZUX
        LUXDIJUXFBVXJUXKUWTUXCVXJUXIUWOUXJUWSUXHCUWNSYTUXHCUWRSYTUWDUWGUWHUWIWE
        $.
    $}

    $( Extend continuity of the complex power function to a base of zero, as
       long as the exponent has strictly positive real part.  (Contributed by
       Mario Carneiro, 2-May-2016.) $)
    cxpcn3 $p |- ( x e. ( 0 [,) +oo ) , y e. D |-> ( x ^c y ) )
        e. ( ( K tX L ) Cn J ) $=
      ( cc0 co wcel cc cfv wral mp2an crp wbr wceq vz vu vv va vd vb ve cpnf cv
      cico ccxp cmpt2 ctx ccn cxp wf ccnp cxr wss pnfxr icossre ax-resscn sstri
      cr 0re sseli cre ccnv cima cdm cnvimass ref fdmi rgen2 eqid mpbi cop cres
      wa clt crest ctopon cle elrege0 sylanbrc resttopon toponunii restid ax-mp
      a1i ssid simplbi adantr simpr eqeltri txtopon syl2anc cioo ctop cvv mp3an
      wb ovex eqtri mp4an oveq1i topontopi mpbird cabs cmin wi wrex c1 cif cdiv
      mpbir2an ovresd 0cn sseldi cnmetdval sylancr df-neg fveq2i absnegd 3eqtrd
      cneg syl5eqr breq1d eqtrd oveq12 ovmpt2a wne simprbi cxmt cnxmet xmetres2
      fveq2 sylancl cmopn metrest sseqtri eqsstri cxpcl syl2an fmpt2 cnfldtopon
      rpre rpge0 ssriv eqcomi cxpcn2 cnmpt2res simplr opelxp cncnpi resmpt2 crn
      elrpd ctg ioorp iooretop eqeltrri retop restopnb rerest eleqtrri toponmax
      w3a mpanl12 txrest restabs oveq12i fveq1i 3eltr4g cnt xpss1 txopn isopn3i
      mp1i syl6eleqr txunii cnprest syl22anc ccom c2 cxpcn3lem ralrimiva simprl
      0le0 simpl simprr anbi12d eleq2i wfn ffn elpreima bitri rpne0d re0 syl6eq
      necon3i syl 0cxpd adantl oveq12d cxpcld imbi12d 2ralbidva rexbidv ralbidv
      mp2b cnfldtopn txmetcnp syl32anc mpbir2and ad2antlr opeq1d fveq2d eleqtrd
      id wo leloe mpbid mpjaodan eleq2d ralxp mpbir cncnp ) ABKUHUJLZCAUIZBUIZU
      KLZULZEFUMLZDUNLMZUYICUOZNUYMUPZUYMUAUIZUYNDUQLZOZMZUAUYPPZUYLNMZBCPAUYIP
      UYQVUCABUYICUYJUYIMZUYJNMUYKNMVUCUYKCMUYINUYJUYIVDNKVDMZUHURMUYIVDUSZVEUT
      KUHVAQZVBVCZVFCNUYKCVGVHRVIZNGVUIVGVJNVGRVKNVDVGVLVMUUAUUBZVFUYJUYKUUCUUD
      VNABUYICUYLNUYMUYMVOZUUEVPZVUBUYMUBUIZUCUIZVQZUYSOZMZUCCPUBUYIPVUQUBUCUYI
      CVUMUYIMZVUNCMZVSZKVUMVTSZVUQKVUMTZVUTVVAVSZVUQUYMRCUOZVRZVUOUYNVVDWALZDU
      QLZOZMZVVCABRCUYLULZVUODRWALZFUMLZDUQLZOZVVEVVHVVCVVJVVLDUNLMVUOVVDMZVVJV
      VNMVVCABUYLVVKVVKDDFCRRNVVKRWALZVVKVVKRWBOZMZVVPVVKTDNWBOZMZRNUSVVRDHUUFZ
      RUYINARUYIUYJRMUYJVDMKUYJWCSVUDUYJUUGUYJUUHUYJWDWEUUIZVUHVCRDNWFQZVVKVVQR
      RVVKVWCWGWHWIUUJVVRVVCVWCWJRRUSZVVCRWKZWJJVVTVVCVWAWJCNUSZVVCVUJWJABRNUYL
      ULVVKDUMLDUNLMVVCABDVVKHVVKVOUUKWJUULVVCVUMRMVUSVVOVVCVUMVUTVUMVDMZVVAVUR
      VWGVUSVURVWGKVUMWCSZVUMWDZWLWMZWMVUTVVAWNUURVURVUSVVAUUMVUMVUNRCUUNWEZVUO
      VVJVVLDVVDVVDVVLVVRFCWBOZMZVVLVVDWBOMVWCFDCWALZVWLJVVTVWFVWNVWLMVWAVUJCDN
      WFQWOZVVKFRCWPQWGUUOWQRUYIUSZCCUSVVEVVJTVWBCWKABUYICRCUYLUUPQVUOVVGVVMVVF
      VVLDUQVVFERWALZFCWALZUMLZVVLEUYIWBOZMZVWMREMZCFMZVVFVWSTEDUYIWALZVWTIVVTU
      YINUSZVXDVWTMVWAVUHUYIDNWFQWOZVWORWRUUQUUSOZUYIWALZERVXGMZRVXHMZKUHWRLRVX
      GUUTKUHUVAUVBZVXIVWPVWDVXIVXJXBZVXKVWBVWEVXGWSMUYIWTMZVXIVWPVWDUVHVXLUVCK
      UHUJXCZUYIRRVXGWTUVDUVIXAVPEVXDVXHIVUFVXDVXHTVUGUYIVXGDHVXGVOUVEWIXDUVFZV
      WMVXCVWOCFUVGWIZRCEFVWTVWLEFUVJXEVWQVVKVWRFUMVWQVXDRWALZVVKEVXDRWAIXFVVTV
      WPVXMVXQVVKTVWAVWBVXNRUYIDVVSWTUVKXAXDVWMVWRFTVWOFVWLCCFVWOWGZWHWIUVLXDXF
      UVMUVNVVCUYNWSMZVVDUYPUSZVUOVVDUYNUVOOOZMUYQVUQVVIXBVXSVVCUYPUYNVXAVWMUYN
      UYPWBOMZVXFVWOEFUYICWPQZXGZWJVWPVXTVVCVWBRUYICUVPUVSVVCVUOVVDVYAVWKVXSVVD
      UYNMZVYAVVDTVYDVXAVWMVXBVXCVYEVXFVWOVXOVXPRCEFVWTVWLUVQXEVVDUYNUVRQUVTUYQ
      VVCVULWJVVDVUOUYMUYNDUYPNEFUYICUYIEVXFXGCFVWOXGUYIEVXFWGVXRUWANDVWAWGUWBU
      WCXHVUTVVBVSZUYMKVUNVQZUYSOZVUPVUSUYMVYHMZVURVVBVUSVYIUYQKUDUIZXIXJUWDZUY
      IUYIUOVRZLZUEUIZVTSZVUNUFUIZVYKCCUOVRZLZVYNVTSZVSZKVUNUYMLZVYJVYPUYMLZVYK
      LZUGUIZVTSZXKZUFCPUDUYIPZUERXLZUGRPZUYQVUSVULWJVUSWUIVYJXIOZVYNVTSZVUNVYP
      XJLXIOZVYNVTSZVSZVYJVYPUKLZXIOZWUDVTSZXKZUFCPUDUYIPZUERXLZUGRPVUSWUTUGRVU
      NCVUNVGOZXMWCSWVAXMXNUWEXOLZWUDXMWVBXOLUKLZWCSWVBWVCXNZWVBWUDDEFUDUFUEGHI
      JWVBVOWVDVOUWFUWGVUSWUHWUTUGRVUSWUGWUSUERVUSWUFWURUDUFUYICVUSVYJUYIMZVYPC
      MZVSZVSZVYTWUNWUEWUQWVHVYOWUKVYSWUMWVHVYMWUJVYNVTWVHVYMKVYJVYKLZKVYJXJLZX
      IOZWUJWVHKVYJVYKUYIKUYIMZWVHWVLVUEKKWCSVEUWIKWDXPZWJVUSWVEWVFUWHZXQWVHKNM
      ZVYJNMWVIWVKTXRWVHUYINVYJVUHWVNXSZKVYJVYKVYKVOZXTYAWVHWVKVYJYFZXIOWUJWVRW
      VJXIVYJYBYCWVHVYJWVPYDYGYEYHWVHVYRWULVYNVTWVHVYRVUNVYPVYKLZWULWVHVUNVYPVY
      KCVUSWVGUWJZVUSWVEWVFUWKZXQWVHVUNNMZVYPNMWVSWULTWVHCNVUNVUJWVTXSWVHCNVYPV
      UJWWAXSZVUNVYPVYKWVQXTWQYIYHUWLWVHWUCWUPWUDVTWVHWUCKWUOVYKLZKWUOXJLZXIOZW
      UPWVHWUAKWUBWUOVYKWVHWUAKVUNUKLZKWVHWVLVUSWUAWWGTWVMWVTABKVUNUYICUYLWWGUY
      MUYJKUYKVUNUKYJVUKKVUNUKXCYKYAVUSWWGKTWVGVUSVUNVUSWWBWVARMZVUSVUNVUIMZWWB
      WWHVSZCVUIVUNGUWMNVDVGUPVGNUWNWWIWWJXBVLNVDVGUWONVUNRVGUWPUXKUWQZWLVUSWVA
      KYLVUNKYLVUSWVAVUSWWBWWHWWKYMUWRVUNKWVAKVUNKTWVAKVGOKVUNKVGYQUWSUWTUXAUXB
      UXCWMYIWVGWUBWUOTVUSABVYJVYPUYICUYLWUOUYMUYJVYJUYKVYPUKYJVUKVYJVYPUKXCYKU
      XDUXEWVHWVOWUONMWWDWWFTXRWVHVYJVYPWVPWWCUXFZKWUOVYKWVQXTYAWVHWWFWUOYFZXIO
      WUPWWMWWEXIWUOYBYCWVHWUOWWLYDYGYEYHUXGUXHUXIUXJXHVUSVYLUYIYNOMZVYQCYNOMZV
      YKNYNOMZWVLVUSVYIUYQWUIVSXBVUSWWPVXEWWNWWPVUSYOWJZVUHVYKUYINYPYRVUSWWPVWF
      WWOWWQVUJVYKCNYPYRWWQWVLVUSWVMWJVUSUXTUGUEUFUDKVUNVYLVYQVYKUYMEFDUYICNEVX
      DVYLYSOZIWWPVXEVXDWWRTYOVUHVYKVYLDWWRNUYIVYLVODHUXLZWWRVOYTQXDFVWNVYQYSOZ
      JWWPVWFVWNWWTTYOVUJVYKVYQDWWTNCVYQVOWWSWWTVOYTQXDWWSUXMUXNUXOUXPVYFVYGVUO
      UYSVYFKVUMVUNVUTVVBWNUXQUXRUXSVUTVWHVVAVVBUYAZVURVWHVUSVURVWGVWHVWIYMWMVU
      TVUEVWGVWHWXAXBVEVWJKVUMUYBYAUYCUYDVNVUAVUQUAUBUCUYICUYRVUOTUYTVUPUYMUYRV
      UOUYSYQUYEUYFUYGVYBVVTUYOUYQVUBVSXBVYCVWAUAUYMUYNDUYPNUYHQXP $.
  $}

  ${
    $d x y z D $.
    $( Continuity of the real square root function.  (Contributed by Mario
       Carneiro, 2-May-2016.) $)
    resqrcn $p |- ( sqr |` ( 0 [,) +oo ) ) e. ( ( 0 [,) +oo ) -cn-> RR ) $=
      ( vx vy vz csqr co cv cfv cmpt cr wceq wtru cc wf a1i wss wcel c1 cre crp
      eqid cc0 cpnf cico cres ccncf feqmptd reseq1d cle wbr elrege0 recnd ssriv
      sqrf simplbi resmpt mp1i eqtrd trud wa resqrcl sylbi fmpti ax-resscn cdiv
      wb ccxp cxpsqr syl mpteq2ia ccnfld ctopn crest ccn ccnv ctopon cnfldtopon
      c2 cima resttopon sylancl cnmptid cdm cnvimass fdmi sseqtri ax-1cn halfcl
      ref ax-mp 1rp rphalfcl rpre rere eqeltri wfn ffn elpreima mpbir2an cnmptc
      mp2b cmpt2 ctx cxpcn3 oveq12 cnmpt12 toponunii restid eqcomi cncfcn mp2an
      ssid syl6eleqr syl5eqelr cncffvrn mpbir ) DUAUBUCEZUDZAXPAFZDGZHZXPIUEEZX
      QXTJKXQALXSHZXPUDZXTKDYBXPKALLDLLDMKUMNUFUGXPLOZYCXTJKAXPLXRXPPZXRYEXRIPZ
      UAXRUHUIZXRUJZUNUKZULZALXPXSUOUPUQURXTYAPZXPIXTMZAXPIXSXTXTTYEYFYGUSXSIPY
      HXRUTVAVBILOXTXPLUEEZPZYKYLVEVCYNKXTAXPXRQVQVDEZVFEZHZYMAXPYPXSYEXRLPYPXS
      JYIXRVGVHVIKYQVJVKGZXPVLEZYRVMEZYMKABCXRYOBFZCFZVFEZYPYSYSYRRVNSVRZVLEZYR
      XPXPUUDKYRLVOGZPZYDYSXPVOGPUUGKYRYRTZVPZNZYJXPYRLVSVTZKAYSXPUUKWAKAYOYSUU
      EXPUUDUUKKUUGUUDLOUUEUUDVOGPUUJUUDRWBLRSWCLIRWHWDWEUUDYRLVSVTZYOUUDPZKUUM
      YOLPZYORGZSPZQLPUUNWFQWGWIUUOYOSYOSPZYOIPUUOYOJQSPUUQWJQWKWIZYOWLYOWMWTUU
      RWNLIRMRLWOUUMUUNUUPUSVEWHLIRWPLYOSRWQWTWRNWSUUKUULBCXPUUDUUCXAYSUUEXBEYR
      VMEPKBCUUDYRYSUUEUUDTUUHYSTZUUETXCNUUAXRUUBYOVFXDXEYDLLOYMYTJYJLXKXPLYRYS
      YRUUHUUSYRLVLEZYRUUGUUTYRJUUIYRUUFLLYRUUIXFXGWIXHXIXJXLXMURXPLIXTXNXJXOWN
      $.

    sqrcn.d $e |- D = ( CC \ ( -oo (,] 0 ) ) $.
    $( Continuity of the square root function.  (Contributed by Mario Carneiro,
       2-May-2016.) $)
    sqrcn $p |- ( sqr |` D ) e. ( D -cn-> CC ) $=
      ( vx vy vz csqr cres cc co wcel wtru cv ccxp cmpt cfv a1i wss wceq mp1i
      c1 ccncf c2 cdiv wf sqrf feqmptd reseq1d cmnf cc0 cioc cdif difss eqsstri
      resmpt sseli adantl cxpsqr syl eqcomd mpteq2dva 3eqtrd ccnfld ctopn crest
      ccn ctopon eqid cnfldtopon resttopon sylancl cnmptid ax-1cn halfcl cnmptc
      cmpt2 ctx cxpcn oveq12 cnmpt12 toponunii restid ax-mp eqcomi cncfcn mp2an
      wa ssid syl6eleqr eqeltrd trud ) FAGZAHUAIZJKWKCACLZTUBUCIZMIZNZWLKWKCHWM
      FOZNZAGZCAWQNZWPKFWRAKCHHFHHFUDKUEPUFUGAHQZWSWTRKAHUHUIUJIZUKHBHXBULUMZCH
      AWQUNSKCAWQWOKWMAJZWFZWOWQXEWMHJZWOWQRXDXFKAHWMXCUOUPWMUQURUSUTVAKWPVBVCO
      ZAVDIZXGVEIZWLKCDEWMWNDLZELZMIZWOXHXHXGXGAAHKXGHVFOZJZXAXHAVFOJXNKXGXGVGZ
      VHZPZXCAXGHVIVJZKCXHAXRVKKCWNXHXGAHXRXQTHJWNHJKVLTVMSVNXRXQDEAHXLVOXHXGVP
      IXGVEIJKDEAXGXHBXOXHVGZVQPXJWMXKWNMVRVSXAHHQWLXIRXCHWGAHXGXHXGXOXSXGHVDIZ
      XGXNXTXGRXPXGXMHHXGXPVTWAWBWCWDWEWHWIWJ $.
  $}

  ${
    cxpaddlelem.1 $e |- ( ph -> A e. RR ) $.
    cxpaddlelem.2 $e |- ( ph -> 0 <_ A ) $.
    cxpaddlelem.3 $e |- ( ph -> A <_ 1 ) $.
    cxpaddlelem.4 $e |- ( ph -> B e. RR+ ) $.
    cxpaddlelem.5 $e |- ( ph -> B <_ 1 ) $.
    $( Lemma for ~ cxpaddle .  (Contributed by Mario Carneiro, 2-Aug-2014.) $)
    cxpaddlelem $p |- ( ph -> A <_ ( A ^c B ) ) $=
      ( cc0 wbr ccxp co cle wceq wa c1 cr wcel 1re adantr clt cmin cmul resubcl
      rpred sylancr recxpcld a1i w3a recxpcl cxpge0 jca syl3anc ad2antrr crp wb
      difrp sylancl biimpa cxple2d mpbid recnd 1cxpd breqtrd simpr oveq2d 1m1e0
      0le1 syl6eq cc cxp0d eqtrd 1le1 syl6eqbr wo leloe mpjaodan syl31anc caddc
      lemul1a ax-1cn npcan anim1i sylibr rpne0d cxpaddd 3eqtr3d mulid2d 3brtr3d
      elrp cxp1d cxpcld cxpge0d breq1 syl5ibcom imp 0re ) AIBUAJZBBCKLZMJZIBNZA
      WROZBPCUBLZKLZWSUCLZPWSUCLZBWSMXBXDQRZPQRZWSQRZIWSMJZOZXDPMJZXEXFMJAXGWRA
      BXCDEAXHCQRZXCQRSACGUEZPCUDUFZUGTXHXBSUHAXKWRABQRZIBMJZXMXKDEXNXPXQXMUIXI
      XJBCUJBCUKULUMTXBCPUAJZXLCPNZXBXROZXDPXCKLZPMXTBPMJZXDYAMJAYBWRXRFUNXTBPX
      CAXPWRXRDUNAXQWRXREUNXHXTSUHIPMJXTVHUHXBXRXCUORZAXRYCUPZWRAXMXHYDXNSCPUQU
      RTUSUTVAAYAPNWRXRAXCAXCXOVBZVCUNVDXBXSOZXDPPMYFXDBIKLPYFXCIBKYFXCPPUBLIYF
      CPPUBXBXSVEVFVGVIVFYFBXBBVJRZXSAYGWRABDVBZTZTVKVLVMVNAXRXSVOZWRACPMJZYJHA
      XMXHYKYJUPXNSCPVPURVATVQXDPWSVTVRXBBXCCVSLZKLBPKLZXEBXBYLPBKAYLPNZWRAPVJR
      CVJRZYNWAACXNVBZPCWBUFTVFXBBXCCYIXBBXBXPWROBUORAXPWRDWCBWJWDWEAXCVJRWRYET
      AYOWRYPTWFAYMBNWRABYHWKTWGAXFWSNWRAWSABCYHYPWLWHTWIAXAWTAXJXAWTABCDEXNWMI
      BWSMWNWOWPAXQWRXAVOZEAIQRXPXQYQUPWQDIBVPUFVAVQ $.
  $}

  ${
    cxpaddle.1 $e |- ( ph -> A e. RR ) $.
    cxpaddle.2 $e |- ( ph -> 0 <_ A ) $.
    cxpaddle.3 $e |- ( ph -> B e. RR ) $.
    cxpaddle.4 $e |- ( ph -> 0 <_ B ) $.
    cxpaddle.5 $e |- ( ph -> C e. RR+ ) $.
    cxpaddle.6 $e |- ( ph -> C <_ 1 ) $.
    $( Ordering property for complex exponentiation.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    cxpaddle $p |- ( ph ->
      ( ( A + B ) ^c C ) <_ ( ( A ^c C ) + ( B ^c C ) ) ) $=
      ( cc0 co wbr ccxp cle c1 cr wcel adantr recnd caddc wceq wa cmul readdcld
      clt addge0d rpred recxpcld mulid2d cdiv crp anim1i elrp sylibr rerpdivcld
      simpr divge0 syl22anc addge01d mpbid mulid1d breqtrrd wb 1re a1i ledivmul
      syl112anc mpbird cxpaddlelem le2addd rpne0d divdird dividd eqtr3d divcxpd
      addge02d oveq12d rpcxpcld eqtr4d 3brtr3d lemuldivd eqbrtrrd 0cxpd cxpge0d
      cc eqbrtrd oveq1 breq1d syl5ibcom imp wo 0re leloe sylancr mpjaodan ) AKB
      CUALZUFMZWQDNLZBDNLZCDNLZUALZOMZKWQUBZAWRUCZPWSUDLZWSXBOXEWSXEWSAWSQRWRAW
      QDABCEGUEZABCEGFHUGZADIUHZUISTZUJXEXFXBOMPXBWSUKLZOMXEBWQUKLZCWQUKLZUALZX
      LDNLZXMDNLZUALZPXKOXEXLXMXOXPXEBWQABQRZWRESZXEWQQRZWRUCWQULRAXTWRXGUMWQUN
      UOZUPZXECWQACQRZWRGSZYAUPZXEXLDYBXEXRKBOMZXTWRKXLOMXSAYFWRFSZAXTWRXGSZAWR
      UQZBWQURUSZADQRWRXISZUIXEXMDYEXEYCKCOMZXTWRKXMOMYDAYLWRHSZYHYICWQURUSZYKU
      IXEXLDYBYJXEXLPOMZBWQPUDLZOMZXEBWQYPOABWQOMZWRAYLYRHABCEGUTVASXEWQXEWQYHT
      ZVBZVCXEXRPQRZXTWRYOYQVDXSUUAXEVEVFZYHYIBPWQVGVHVIADULRWRISZADPOMWRJSZVJX
      EXMDYEYNXEXMPOMZCYPOMZXECWQYPOACWQOMZWRAYFUUGFACBGEVQVASYTVCXEYCUUAXTWRUU
      EUUFVDYDUUBYHYICPWQVGVHVIUUCUUDVJVKXEWQWQUKLXNPXEBCWQXEBXSTXECYDTYSXEWQYA
      VLZVMXEWQYSUUHVNVOXEXQWTWSUKLZXAWSUKLZUALXKXEXOUUIXPUUJUAXEBWQDXSYGYAADWF
      RWRADXITZSZVPXECWQDYDYMYAUULVPVRXEWTXAWSAWTWFRWRAWTABDEFXIUIZTSAXAWFRWRAX
      AACDGHXIUIZTSXJXEWSXEWQDYAYKVSZVLVMVTWAXEPXBWSUUBAXBQRWRAWTXAUUMUUNUESUUO
      WBVIWCAXDXCAKDNLZXBOMXDXCAUUPKXBOADUUKADIVLWDAWTXAUUMUUNABDEFXIWEACDGHXIW
      EUGWGXDUUPWSXBOKWQDNWHWIWJWKAKWQOMZWRXDWLZXHAKQRXTUUQUURVDWMXGKWQWNWOVAWP
      $.
  $}

  ${
    abscxpbnd.1 $e |- ( ph -> A e. CC ) $.
    abscxpbnd.2 $e |- ( ph -> B e. CC ) $.
    abscxpbnd.3 $e |- ( ph -> 0 <_ ( Re ` B ) ) $.
    abscxpbnd.4 $e |- ( ph -> M e. RR ) $.
    abscxpbnd.5 $e |- ( ph -> ( abs ` A ) <_ M ) $.
    $( Bound on the absolute value of a complex power.  (Contributed by Mario
       Carneiro, 15-Sep-2014.) $)
    abscxpbnd $p |- ( ph -> ( abs ` ( A ^c B ) ) <_
      ( ( M ^c ( Re ` B ) ) x. ( exp ` ( ( abs ` B ) x. pi ) ) ) ) $=
      ( co cabs cfv cpi cmul cle wbr cc0 c1 wcel adantr ccxp cre ce wceq wa a1i
      1le1 oveq12 adantll cc 0cn cxp0 ax-mp syl6eq fveq2d abs1 fveq2 re0 oveq2d
      recnd cxp0d sylan9eqr simpr abs00bd oveq1d recni mul02i ef0 oveq12d 1t1e1
      pire 3brtr4d wne simplr 0cxp sylan eqtrd cr abscld absge0d letrd recxpcld
      0re recld ad2antrr remulcl sylancl reefcld cxpge0d rpefcld rpge0d mulge0d
      eqbrtrd pm2.61dane cim clog cneg cxpefd logcl mulcld absef caddc remulcld
      imcld renegcld efadd syl2anc cmin negsubd mulneg2d remuld 3eqtr4d abs00ad
      syl relog necon3bid biimpar eqtr4d 3eqtr3d 3eqtrd cxple2ad leabsd absmuld
      lemul1ad breqtrd absimle absnegd clt logimcl simpld renegcli ltle sylancr
      wi mpd simprd wb absle mpbir2and lemul2ad efle mpbid ) ABCUAJZKLZDCUBLZUA
      JZCKLZMNJZUCLZNJZOPZBQABQUDZUEZUUKCQUUMCQUDZUEZRRUUDUUJORROPUUOUGUFUUOUUD
      RKLRUUOUUCRKUUOUUCQQUAJZRUULUUNUUCUUPUDABQCQUAUHUIQUJSUUPRUDUKQULUMUNUOUP
      UNUUOUUJRRNJRUUOUUFRUUIRNUUNUUMUUFDQUAJZRUUNUUEQDUAUUNUUEQUBLQCQUBUQURUNU
      SAUUQRUDUULADADHUTVATVBUUOUUIQUCLRUUOUUHQUCUUOUUHQMNJQUUOUUGQMNUUOCUUMUUN
      VCVDVEMMVKVFVGUNUOVHUNVIVJUNVLUUMCQVMZUEZUUDQUUJOUUSUUCUUSUUCQCUAJZQUUSBQ
      CUAAUULUURVNVEUUMCUJSZUURUUTQUDAUVAUULFTCVOVPVQVDUUSUUFUUIAUUFVRSZUULUURA
      DUUEHAQBKLZDQVRSAWCUFABEVSZHABEVTIWAZACFWDZWBZWEUUSUUHUUSUUGVRSZMVRSZUUHV
      RSZAUVHUULUURACFVSZWEVKUUGMWFZWGZWHAQUUFOPZUULUURADUUEHUVEUVFWIZWEUUSUUIU
      USUUHUVMWJWKWLWMWNABQVMZUEZUUDUVCUUEUAJZCWOLZBWPLZWOLZWQZNJZUCLZNJZUUJOUV
      QUUDCUVTNJZUCLZKLZUWFUBLZUCLZUWEUVQUUCUWGKUVQBCABUJSZUVPETZAUVPVCAUVAUVPF
      TZWRUOUVQUWFUJSUWHUWJUDUVQCUVTUWMAUWKUVPUVTUJSEBWSVPZWTUWFXAXNUVQUUEUVTUB
      LZNJZUWCXBJZUCLZUWPUCLZUWDNJZUWJUWEUVQUWPUJSUWCUJSUWRUWTUDUVQUWPUVQUUEUWO
      UVQCUWMWDZUVQUVTUWNWDXCUTZUVQUWCUVQUVSUWBUVQCUWMXDZUVQUWAUVQUVTUWNXDZXEZX
      CZUTUWPUWCXFXGUVQUWQUWIUCUVQUWPUVSUWANJZWQZXBJUWPUXGXHJUWQUWIUVQUWPUXGUXB
      UVQUXGUVQUVSUWAUXCUXDXCUTXIUVQUWCUXHUWPXBUVQUVSUWAUVQUVSUXCUTZUVQUWAUXDUT
      ZXJUSUVQCUVTUWMUWNXKXLUOUVQUWSUVRUWDNUVQUWSUUEUVCWPLZNJZUCLUVRUVQUWPUXLUC
      UVQUWOUXKUUENAUWKUVPUWOUXKUDEBXOVPUSUOUVQUVCUUEAUVCUJSUVPAUVCUVDUTTAUVCQV
      MUVPAUVCQBQABEXMXPXQUVQUUEUXAUTWRXRVEXSXTUVQUWEUUFUWDNJUUJUVQUVRUWDUVQUVC
      UUEUVQBUWLVSZUVQBUWLVTZUXAWBZUVQUWCUXFWHZXCUVQUUFUWDAUVBUVPUVGTZUXPXCUVQU
      UFUUIUXQAUUIVRSUVPAUUHAUVHUVIUVJUVKVKUVLWGZWHTZXCUVQUVRUUFUWDUXOUXQUXPUVQ
      UWDUVQUWCUXFWJWKUVQUVCDUUEUXMUXNADVRSUVPHTUXAAQUUEOPUVPGTAUVCDOPUVPITYAYD
      UVQUWDUUIUUFUXPUXSUXQAUVNUVPUVOTUVQUWCUUHOPZUWDUUIOPZUVQUWCUVSKLZUWBKLZNJ
      ZUUHUXFUVQUYBUYCUVQUVSUXIVSZUVQUWBUVQUWBUXEUTZVSZXCZAUVJUVPUXRTZUVQUWCUWC
      KLUYDOUVQUWCUXFYBUVQUVSUWBUXIUYFYCYEUVQUYDUUGUYCNJUUHUYHUVQUUGUYCUVQCUWMV
      SZUYGXCUYIUVQUYBUUGUYCUYEUYJUYGUVQUWBUYFVTUVQUVAUYBUUGOPUWMCYFXNYDUVQUYCM
      UUGUYGUVIUVQVKUFUYJUVQCUWMVTUVQUYCUWAKLZMOUVQUWAUXJYGUVQUYKMOPZMWQZUWAOPZ
      UWAMOPZUVQUYMUWAYHPZUYNUVQUYPUYOAUWKUVPUYPUYOUEEBYIVPZYJUVQUYMVRSUWAVRSZU
      YPUYNYNMVKYKUXDUYMUWAYLYMYOUVQUYPUYOUYQYPUVQUYRUVIUYLUYNUYOUEYQUXDVKUWAMY
      RWGYSWMYTWAWAUVQUWCVRSUVJUXTUYAYQUXFUYIUWCUUHUUAXGUUBYTWAWMWN $.
  $}

  ${
    $( Property of an ` N ` -th root of unity.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    root1id $p |- ( N e. NN -> ( ( -u 1 ^c ( 2 / N ) ) ^ N ) = 1 ) $=
      ( cn wcel c1 cneg c2 cdiv co cmul ccxp cexp cc neg1cn a1i cr nndivre mpan
      2re recnd wceq nnnn0 cxpmul2d 2cn nncn nnne0 divcan1d oveq2d cxpexp mp2an
      cn0 2nn0 ax-1cn sqneg ax-mp sq1 3eqtri syl6eq eqtr3d ) ABCZDEZFAGHZAIHZJH
      ZUTVAJHAKHDUSUTVAAUTLCZUSMNUSVAFOCUSVAOCRFAPQSAUAUBUSVCUTFJHZDUSVBFUTJUSF
      AFLCUSUCNAUDAUEUFUGVEUTFKHZDFKHZDVDFUJCVEVFTMUKUTFUHUIDLCVFVGTULDUMUNUOUP
      UQUR $.
  $}

  ${
    $( The only powers of an ` N ` -th root of unity that equal ` 1 ` are the
       multiples of ` N ` .  In other words, ` -u 1 ^c ( 2 / N ) ` has order
       ` N ` in the multiplicative group of nonzero complex numbers.  (In fact,
       these and their powers are the only elements of finite order in the
       complexes.)  (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    root1eq1 $p |- ( ( N e. NN /\ K e. ZZ ) ->
      ( ( ( -u 1 ^c ( 2 / N ) ) ^ K ) = 1 <-> N || K ) ) $=
      ( wcel cz c1 c2 cdiv co cexp wceq ci cpi cmul ce cfv cc ax-icn a1i adantr
      2cn cn wa cneg ccxp cdivides wbr cr 2re simpl nndivre sylancr recnd recni
      pire mulcli mulcld efexp sylancom zcn adantl nncn cc0 nnne0 div32d oveq1d
      wne divcld mulassd 3eqtr3d fveq2d clog neg1cn ax-1cn ax-1ne0 cxpefd logm1
      negne0i oveq2i fveq2i syl6eq 3eqtr4rd eqeq1d mulcl sylancl efeq1 syl 2ne0
      wb mul12i ine0 pipos gt0ne0ii mulne0i divcan4d syl5eq eleq1d nnz dvdsval2
      simpr syl3anc bitr4d 3bitrd ) BUACZADCZUBZEUCZFBGHZUDHZAIHZEJABGHZFKLMHZM
      HZMHZNOZEJZXMKFLMHMHZGHZDCZBAUEUFZXEXIXNEXEAXGXKMHZMHZNOZXTNOZAIHZXNXIXCX
      DXTPCYBYDJXEXGXKXEXGXEFUGCXCXGUGCUHXCXDUIFBUJUKULZXKPCXEKLQLUNUMZUOZRZUPX
      TAUQURXEXMYANXEXJFMHZXKMHAXGMHZXKMHXMYAXEYIYJXKMXEABFXDAPCXCAUSUTZXCBPCXD
      BVASZFPCXETRZXCBVBVFZXDBVCSZVDVEXEXJFXKXEABYKYLYOVGZYMYHVHXEAXGXKYKYEYHVH
      VIVJXEXHYCAIXEXHXGXFVKOZMHZNOYCXEXFXGXFPCXEVLRXFVBVFXEEVMVNVQRYEVOYRXTNYQ
      XKXGMVPVRVSVTVEWAWBXEXMPCZXOXRWHXEXJPCXLPCZYSYPFXKTYGUOZXJXLWCWDXMWEWFXEX
      RXJDCZXSXEXQXJDXEXQXMXLGHXJXPXLXMGKFLQTYFWIVRXEXJXLYPYTXEUUARXLVBVFXEFXKT
      YGWGKLQYFWJLUNWKWLWMWMRWNWOWPXEBDCZYNXDXSUUBWHXCUUCXDBWQSYOXCXDWSBAWRWTXA
      XB $.
  $}

  ${
    $( Within the ` N ` -th roots of unity, the conjugate of the ` K ` -th root
       is the ` N - K ` -th root.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    root1cj $p |- ( ( N e. NN /\ K e. ZZ ) ->
      ( * ` ( ( -u 1 ^c ( 2 / N ) ) ^ K ) ) =
            ( ( -u 1 ^c ( 2 / N ) ) ^ ( N - K ) ) ) $=
      ( wcel cz c1 c2 cdiv co ccxp cexp cfv cc neg1cn cr sylancr cc0 wne oveq1d
      wceq cabs cn wa cneg ccj 2re simpl nndivre recnd cxpcl a1i ax-1cn ax-1ne0
      cmin negne0i cxpne0d simpr adantr expsubd root1id expclzd expne0d syl2anc
      nnz recval absexpz syl3anc abscxp2 absnegi abs1 eqtri oveq1i syl6eq 1cxpd
      eqtrd 1exp adantl 3eqtrd sq1 oveq2d cjcld div1d 3eqtrrd ) BUACZADCZUBZEUC
      ZFBGHZIHZBAUMHJHWHBJHZWHAJHZGHEWJGHZWJUDKZWEWHBAWEWFLCZWGLCWHLCZMWEWGWEFN
      CWCWGNCZUEWCWDUFFBUGOZUHZWFWGUIOZWEWFWGWMWEMUJWFPQWEEUKULUNUJWQUOZWCWDUPZ
      WCBDCWDBVCUQURWEWIEWJGWCWIESWDBUSUQRWEWKWLWJTKZFJHZGHZWLEGHWLWEWJLCWJPQWK
      XCSWEWHAWRWSWTUTZWEWHAWRWSWTVAWJVDVBWEXBEWLGWEXBEFJHEWEXAEFJWEXAWHTKZAJHZ
      EAJHZEWEWNWHPQWDXAXFSWRWSWTWHAVEVFWEXEEAJWEXEEWGIHZEWEXEWFTKZWGIHZXHWEWMW
      OXEXJSMWPWFWGVGOXIEWGIXIETKEEUKVHVIVJVKVLWEWGWQVMVNRWDXGESWCAVOVPVQRVRVLV
      SWEWLWEWJXDVTWAVQWB $.
  $}

  ${
    $d m n A $.  $d m n B $.  $d m n N $.
    $( Solve an equation involving an ` N ` -th power.  The expression
       ` -u 1 ^c ( 2 / N ) = exp ( 2 pi _i / N ) ` is a way to write the
       primitive ` N ` -th root of unity with the smallest positive argument.
       (Contributed by Mario Carneiro, 23-Apr-2015.) $)
    cxpeq $p |- ( ( A e. CC /\ N e. NN /\ B e. CC ) -> ( ( A ^ N ) = B <->
      E. n e. ( 0 ... ( N - 1 ) ) A = ( ( B ^c ( 1 / N ) ) x.
        ( ( -u 1 ^c ( 2 / N ) ) ^ n ) ) ) ) $=
      ( cc wcel cexp co wceq c1 cdiv ccxp c2 cmul cc0 cfv syl adantr oveq1d ce
      vm cn w3a cneg cv cmin cfz wrex wi wa cuz simpl2 nnm1nn0 syl6eleq eluzfz1
      cn0 nn0uz neg1cn 2re simp2 nndivre sylancr recnd cxpcl 0nn0 expcl sylancl
      cr mul02d simprl simprr 0expd 3eqtr3d wne nncn nnne0 reccl recne0 syl2anc
      0cxpd eqtrd 3eqtr4rd oveq2 oveq2d eqeq2d rspcev expr clog ci cpi caddc cz
      simpl1 simpr nnzd explog syl3anc eqcomd nncnd logcld mulcld nnnn0d expcld
      wb expne0d eflogeq mpbid ax-icn 2cn pire recni mulcli adantl mulcl addcld
      zcn nnne0d ad2antrr divmuld fveq2 cmo reccld efadd divrec2d div23d mul12i
      divdird a1i oveq1i syl5eq 3eqtrd oveq12d cxpefd cxpcld nn0cnd 1exp eqeq1d
      rexlimdva oveq1 expmuld mul32d fveq2d ax-1cn ax-1ne0 negne0i logm1 oveq2i
      cxpmul2zd fveq2i syl6eq cxpne0d expclzd zmodcld nn0zd expsubd crp moddifz
      zre nnrpd expmulz syl22anc subcld divcan2d root1id eqtr3d diveq1d 3eqtr4d
      3eqtr3rd eflog eqeq12d zmodfz eqcom syl5bb ex sylbid syl5 sylbird rexbidv
      mpd syl5ibcom pm2.61dane nnrecre 3ad2ant2 elfznn0 mulexpd cxproot mulcomd
      simp3 syl2an elfzelz mulid1d syl5ibrcom impbid ) AEFZDUBFZBEFZUCZADGHZBIZ
      ABJDKHZLHZJUDZMDKHZLHZCUEZGHZNHZIZCODJUFHZUGHZUHZUWQUWSUXKUIAOUWQAOIZUWSU
      XKUWQUXLUWSUJZUJZOUXJFZAUXAUXDOGHZNHZIZUXKUXNUXIOUKPZFUXOUXNUXIUPUXSUXNUW
      OUXIUPFUWNUWOUWPUXMULZDUMQUQUNOUXIUOQUXNOUXPNHOUXQAUXNUXPUXNUXDEFZOUPFUXP
      EFUWQUYAUXMUWQUXBEFZUXCEFZUYAURUWQUXCUWQMVHFUWOUXCVHFUSUWNUWOUWPUTZMDVAVB
      VCZUXBUXCVDVBZRVEUXDOVFVGVIUXNUXAOUXPNUXNUXAOUWTLHZOUXNBOUWTLUXNUWRODGHBO
      UXNAODGUWQUXLUWSVJZSUWQUXLUWSVKUXNDUXTVLVMSUXNUWOUYGOIZUXTUWODEFZDOVNZUYI
      DVODVPUYJUYKUJUWTDVQDVRVTVSQWASUYHWBUXHUXRCOUXJUXEOIZUXGUXQAUYLUXFUXPUXAN
      UXEOUXDGWCWDWEWFVSWGUWQAOVNZUJZAUWRUWTLHZUXFNHZIZCUXJUHZUWSUXKUYNDAWHPZNH
      ZUWRWHPZWIMWJNHZNHZUAUEZNHZWKHZIZUAWLUHZUYRUYNUYTTPZUWRIZVUHUYNUWRVUIUYNU
      WNUYMDWLFZUWRVUIIUWNUWOUWPUYMWMZUWQUYMWNZUYNDUWNUWOUWPUYMULZWOZADWPWQWRUY
      NUYTEFUWREFZUWROVNZVUJVUHXDUYNDUYSUWQUYJUYMUWQDUYDWSRZUYNAVULVUMWTZXAUYNA
      DVULUYNDVUNXBXCZUYNADVULVUMVUOXEZUYTUWRUAXFWQXGUYNVUGUYRUAWLUYNVUDWLFZUJZ
      VUGVUFDKHZUYSIZUYRVVCVUFDUYSVVCVUAVUEUYNVUAEFVVBUYNUWRVUTVVAWTRZVVCVUCEFZ
      VUDEFZVUEEFWIVUBXHMWJXIWJXJXKZXLXLZVVBVVHUYNVUDXPXMZVUCVUDXNVBZXOUYNUYJVV
      BVURRZUYNUYSEFVVBVUSRUWQUYKUYMVVBUWQDUYDXQXRZXSVVEVVDTPZUYSTPZIZVVCUYRVVD
      UYSTXTVVCVVQUYOUXDVUDDYAHZGHZNHZAIZUYRVVCVVOVVTVVPAVVCUWTVUANHZUXCVUDNHZW
      IWJNHZNHZWKHZTPZVWBTPZVWETPZNHZVVOVVTVVCVWBEFVWEEFZVWGVWJIVVCUWTVUAVVCDVV
      MVVNYBZVVFXAVVCVWCEFVWDEFZVWKVVCUXCVUDUWQUYCUYMVVBUYEXRZVVKXAZWIWJXHVVIXL
      ZVWCVWDXNVGVWBVWEYCVSVVCVVDVWFTVVCVVDVUADKHZVUEDKHZWKHVWFVVCVUAVUEDVVFVVL
      VVMVVNYGVVCVWQVWBVWRVWEWKVVCVUADVVFVVMVVNYDVVCVWRVUCDKHZVUDNHUXCVWDNHZVUD
      NHVWEVVCVUCVUDDVVGVVCVVJYHVVKVVMVVNYEVVCVWSVWTVUDNVVCVWSMVWDNHZDKHVWTVUCV
      XADKWIMWJXHXIVVIYFYIVVCMVWDDMEFVVCXIYHVWMVVCVWPYHZVVMVVNYEYJSVVCUXCVWDVUD
      VWNVXBVVKUUAYKYLWAUUBVVCUYOVWHVVSVWINVVCUWRUWTUYNVUPVVBVUTRUYNVUQVVBVVARV
      WLYMVVCUXBVWCLHZUXDVUDGHZVWIVVSVVCUXBUXCVUDUYBVVCURYHZUXBOVNZVVCJUUCUUDUU
      EZYHZVWNUYNVVBWNZUUHVVCVXCVWCUXBWHPZNHZTPVWIVVCUXBVWCVXEVXHVWOYMVXKVWETVX
      JVWDVWCNUUFUUGUUIUUJVVCVXDVVSVVCUXDVUDVVCUXBUXCVXEVWNYNZUWQUXDOVNZUYMVVBU
      WQUXBUXCUYBUWQURYHVXFUWQVXGYHUYEUUKXRZVXIUULVVCUXDVVRVXLVVCVUDDVXIUYNUWOV
      VBVUNRZUUMZXCVVCUXDVVRVXLVXNVVCVVRVXPUUNZXEVVCUXDVUDVVRUFHZGHZVXDVVSKHJVV
      CUXDVUDVVRVXLVXNVXQVXIUUOVVCUXDDVXRDKHZNHZGHZUXDDGHZVXTGHZVXSJVVCUYAVXMVU
      KVXTWLFZVYBVYDIVXLVXNVVCDVXOWOVVCVUDVHFZDUUPFVYEVVBVYFUYNVUDUURXMVVCDVXOU
      USVUDDUUQVSZUXDDVXTUUTUVAVVCVYAVXRUXDGVVCVXRDVVCVUDVVRVVKVVCVVRVXPYOUVBVV
      MVVNUVCWDVVCVYDJVXTGHZJVVCVYCJVXTGVVCUWOVYCJIZVXODUVDZQSVVCVYEVYHJIVYGVXT
      YPQWAVMUVEUVFUVHYLUVGUYNVVPAIZVVBUYNUWNUYMVYKVULVUMAUVIVSRUVJVVCVVRUXJFZV
      WAUYRUIVVCVVBUWOVYLVXIVXOVUDDUVKVSVYLVWAUYRUYQVWACVVRUXJUYQUYPAIUXEVVRIZV
      WAAUYPUVLVYMUYPVVTAVYMUXFVVSUYONUXEVVRUXDGWCWDYQUVMWFUVNQUVOUVPUVQYRUVSUW
      SUYQUXHCUXJUWSUYPUXGAUWSUYOUXAUXFNUWRBUWTLYSSWEUVRUVTUWAUWQUXHUWSCUXJUWQU
      XEUXJFZUJZUWSUXHUXGDGHZBIVYOVYPUXADGHZUXFDGHZNHBJNHBVYOUXAUXFDUWQUXAEFVYN
      UWQBUWTUWNUWOUWPUWHZUWQUWTUWOUWNUWTVHFUWPDUWBUWCVCYNRUWQUYAUXEUPFZUXFEFVY
      NUYFUXEUXIUWDZUXDUXEVFUWIVYODUWQUWOVYNUYDRZXBZUWEVYOVYQBVYRJNVYOUWPUWOVYQ
      BIUWQUWPVYNVYSRZWUBBDUWFVSVYOVYRVYCUXEGHZJUXEGHZJVYOUXDUXEDNHZGHUXDDUXENH
      ZGHVYRWUEVYOWUGWUHUXDGVYOUXEDVYOUXEVYNVYTUWQWUAXMZYOVYODWUBWSUWGWDVYOUXDU
      XEDUWQUYAVYNUYFRZWUCWUIYTVYOUXDDUXEWUJWUIWUCYTVMVYOVYCJUXEGVYOUWOVYIWUBVY
      JQSVYOUXEWLFZWUFJIVYNWUKUWQUXEOUXIUWJXMUXEYPQYKYLVYOBWUDUWKYKUXHUWRVYPBAU
      XGDGYSYQUWLYRUWM $.
  $}

  ${
    $d x y A $.
    $( An upper bound on the logarithm.  (Contributed by Mario Carneiro,
       2-May-2016.) $)
    loglesqr $p |- ( ( A e. RR /\ 0 <_ A ) ->
        ( log ` ( A + 1 ) ) <_ ( sqr ` A ) ) $=
      ( vx vy cr wcel cc0 cle wbr c1 caddc co clog cfv csqr c2 a1i cmpt wceq cc
      crp wa cmin cdiv cmul 0re simpl cicc cres ccncf w3a elicc2 sylancr biimpa
      cv simp1d simp2d ge0p1rpd fvres syl mpteq2dva ccnfld ctopn ccn ctopon wss
      wb crest eqid cnfldtopon ex ssrdv ax-resscn syl6ss resttopon fmptd rpssre
      sstri ctx addcn ssid cncfmptid sylancl ax-1cn cncfmptc cncfmpt2f cncffvrn
      wf syl3anc mpbird cncfcn eleqtrd relogcn mp2an cnmpt11f eleqtrrd eqeltrrd
      eleqtri cioo crn ctg cpr reex prid1 simpr rpaddcl relogcld recnd rpreccld
      1rp cdv relogcl adantl rpreccl peano2re sselda dvmptid 0cn dvmptc addid1i
      dvmptadd syl6eq cpnf iooretop dvmptres fveq2 rpcnd mulid1d eqtrd clt cexp
      oveq2d rpred oveq12d mpbid cxr 0xr mp3an1 sylan oveq1 fveq2d tgioo2 ioorp
      mpteq2i eqeltrri dvrelog wf1o relogf1o f1of mp1i feqmptd mpteq2ia dvmptco
      syl5reqr oveq2 ioossicc sseli sylan2 eliooord elrpd cico elrege0 sylanbrc
      simpld resabs1 sqrf feqresmpt resqrcn rescncf ee10 sqrcld rpsqrcl rpmulcl
      2rp dvsqr 1re resubcl sqge0d sqsqrd sq1 binom2sub addsubd 3eqtr4d breqtrd
      rpcn subge0d lerecd syldan rexr lbicc2 0p1e1 log1 ge0p1rp resqrcl lesub1d
      ubicc2 sqr0 dvle ) ADEZFAGHZUAZAIJKZLMZANMZGHUXBFUBKUXCFUBKGHUWTBBUNZIJKZ
      LMZIUXEUCKZUXDNMZIOUXHUDKZUCKZFFUXBUXCFAFAFDEZUWTUEPZUWRUWSUFZUWTBFAUGKZU
      XELTUHZMZQZBUXNUXFQUXNDUIKZUWTBUXNUXPUXFUWTUXDUXNEZUAZUXETEZUXPUXFRUXTUXD
      UXTUXDDEZFUXDGHZUXDAGHZUWTUXSUYBUYCUYDUJZUWTUXKUWRUXSUYEVFUEUXMFAUXDUKULU
      MZUOZUXTUYBUYCUYDUYFUPZUQZUXETLURUSUTUWTUXQVAVBMZUXNVGKZUYJDVGKZVCKZUXRUW
      TBUXEUXOUYKUYJTVGKZUYLUXNUWTUYJSVDMEUXNSVEZUYKUXNVDMEUYJUYJVHZVIUWTUXNDSU
      WTBUXNDUWTUXSUYBUYGVJVKVLVMZUXNUYJSVNULUWTBUXNUXEQZUXNTUIKZUYKUYNVCKZUWTU
      YRUYSEZUXNTUYRWGZUWTBUXNUXETUYRUYIUYRVHVOUWTTSVEZUYRUXNSUIKZEVUAVUBVFTDSV
      PVLVQZUWTBUXDIJUYJUXNUYPJUYJUYJVRKUYJVCKEUWTUYJUYPVSPUWTUYOSSVEZBUXNUXDQV
      UDEUYQSVTZBUXNSWAWBUWTISEZUYOVUFBUXNIQVUDEVUHUWTWCPZUYQVUFUWTVUGPBIUXNSWD
      WHWEUXNSTUYRWFULWIUWTUYOVUCUYSUYTRUYQVUEUXNTUYJUYKUYNUYPUYKVHZUYNVHZWJWBW
      KUXOUYNUYLVCKZEUWTUXOTDUIKZVULWLVUCDSVEZVUMVULRVUEVLTDUYJUYNUYLUYPVUKUYLV
      HZWJWMWQPWNUWTUYOVUNUXRUYMRUYQVLUXNDUYJUYKUYLUYPVUJVUOWJWBWOWPUWTBUXFUXGD
      WRWSWTMZUYJTTFAWRKZDDSXAEUWTDSXBXCPZUWTUXDTEZUAZUXFVUTUXEVUTVUSITEUYAUWTV
      USXDXIUXDIXEWBZXFXGVUTUXEVVAXHZUWTDBTUXFQXJKBTUXGIUDKZQBTUXGQUWTBCUXEICUN
      ZLMZIVVDUCKZDDUXFUXGSTTTVURVURVVAVUHVUTWCPZUWTVVDTEZUAVVEVVHVVEDEUWTVVDXK
      XLXGVVHVVFTEUWTVVDXMXLUWTBUXEIDVUPUYJSDTVURUWTUYBUAZUXEUYBUXEDEUWTUXDXNXL
      XGVUHVVIWCPZUWTDBDUXEQXJKBDIFJKZQBDIQUWTBUXDIIFDSSDVURUWTDSUXDVUNUWTVLPXO
      VVJUWTBDVURXPVVJFSEVVIXQPUWTBIDVURVUIXRXTBDVVKIIWCXSUUCYATDVEUWTVPPUYJUYP
      UUAZUYPTVUPEUWTFYBWRKTVUPUUBFYBYCUUDPYDUWTCTVVFQDUXOXJKDCTVVEQZXJKCUUEUWT
      UXOVVMDXJUWTUXOCTVVDUXOMZQVVMUWTCTDUXOTDUXOUUFTDUXOWGUWTUUGTDUXOUUHUUIUUJ
      CTVVNVVEVVDTLURUUKYAYKUUMVVDUXELYEVVDUXEIUCUUNUULUWTBTVVCUXGVUTUXGVUTUXGV
      VBYFYGUTYHUWTBVUQTUWTUXDVUQEZVUSUWTVVOUAUXDVVOUWTUXSUYBVUQUXNUXDFAUUOUUPU
      YGUUQVVOFUXDYIHZUWTVVOVVPUXDAYIHUXDFAUURUVCXLUUSZVJVKZVVLUYPVUQVUPEUWTFAY
      CPZYDUWTNFYBUUTKZUHZUXNUHZBUXNUXHQZUXRUWTVWBNUXNUHZVWCUWTUXNVVTVEZVWBVWDR
      UWTBUXNVVTUWTUXSUXDVVTEZUXTUYBUYCVWFUYGUYHUXDUVAUVBVJVKZNUXNVVTUVDUSUWTBS
      SUXNNSSNWGUWTUVEPUYQUVFYHUWTVWEVWAVVTDUIKEVWBUXREVWGUVGVVTDUXNVWAUVHUVIWP
      UWTBUXHUXJDVUPUYJTTVUQVURVUTUXDVUSUXDSEUWTUXDUWDXLZUVJZVUTUXIVUTOTEUXHTEZ
      UXITEUVMVUSVWJUWTUXDUVKXLZOUXHUVLULZXHDBTUXHQXJKBTUXJQRUWTBUVNPVVRVVLUYPV
      VSYDUWTVVOVUSUXGUXJGHZVVQVUTUXIUXEGHZVWMVUTFUXEUXIUBKZGHVWNVUTFUXHIUBKZOY
      JKZVWOGVUTVWPVUTUXHDEIDEVWPDEVUTUXHVWKYLUVOUXHIUVPWBUVQVUTUXHOYJKZOUXHIUD
      KZUDKZUBKZIOYJKZJKZUXDUXIUBKZIJKVWQVWOVUTVXAVXDVXBIJVUTVWRUXDVWTUXIUBVUTU
      XDVWHUVRVUTVWSUXHOUDVUTUXHVWIYGYKYMVXBIRVUTUVSPYMVUTUXHSEVUHVWQVXCRVWIWCU
      XHIUVTWBVUTUXDIUXIVWHVVGVUTUXIVWLYFUWAUWBUWCVUTUXEUXIVUTUXEVVAYLVUTUXIVWL
      YLUWEYNVUTUXIUXEVWLVVAUWFYNUWGUWRAYOEZUWSFUXNEZAUWHZFYOEZVXEUWSVXFYPFAUWI
      YQYRUWRVXEUWSAUXNEZVXGVXHVXEUWSVXIYPFAUWOYQYRUWRUWSXDUXDFRZUXFILMFVXJUXEI
      LVXJUXEFIJKIUXDFIJYSUWJYAYTUWKYAVXJUXHFNMFUXDFNYEUWPYAUXDARUXEUXALUXDAIJY
      SYTUXDANYEUWQUWTUXBUXCFUWTUXAAUWLXFAUWMUXLUWNWI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Theorems of Pythagoras, isosceles triangles, and intersecting chords
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    ang.1 $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } ) |->
      ( Im ` ( log ` ( y / x ) ) ) ) $.
    $( Define the angle function, which takes two complex numbers, treated as
       vectors from the origin, and returns the angle between them, in the
       range ` ( - pi , pi ] ` .  To convert from the geometry notation,
       ` m A B C ` , the measure of the angle with legs ` A B ` , ` C B ` where
       ` C ` is more counterclockwise for positive angles, is represented by
       ` ( ( C - B ) F ( A - B ) ) ` .  (Contributed by Mario Carneiro,
       23-Sep-2014.) $)
    angval $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
      ( A F B ) = ( Im ` ( log ` ( B / A ) ) ) ) $=
      ( cc wcel cc0 wne wa co cdiv clog cfv cim wceq eldifsn cv fveq2d csn cdif
      oveq12 ancoms fvex ovmpt2a syl2anbr ) CGHCIJKCGIUAUBZHDUHHCDELDCMLZNOZPOZ
      QDGHDIJKCGIRDGIRABCDUHUHBSZASZMLZNOZPOUKEUMCQZULDQZKZUOUJPURUNUINUQUPUNUI
      QULDUMCMUCUDTTFUJPUEUFUG $.

    $( Cancel a constant multiplier in the angle function.  (Contributed by
       Mario Carneiro, 23-Sep-2014.) $)
    angcan $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) /\
      ( C e. CC /\ C =/= 0 ) ) ->
      ( ( C x. A ) F ( C x. B ) ) = ( A F B ) ) $=
      ( cc wcel cc0 wne wa cmul co cdiv clog cfv cim fveq2d wceq simp2l mulne0d
      simp1l simp3l simp1r simp3r divcan5d mulcld simp2r angval 3adant3 3eqtr4d
      w3a syl22anc ) CHIZCJKZLZDHIZDJKZLZEHIZEJKZLZUMZEDMNZECMNZONZPQZRQZDCONZP
      QZRQZVFVEFNZCDFNZVDVHVKRVDVGVJPVDDCEUQURUSVCUAZUOUPUTVCUCZUQUTVAVBUDZUOUP
      UTVCUEZUQUTVAVBUFZUGSSVDVFHIVFJKVEHIVEJKVMVITVDECVQVPUHVDECVQVPVSVRUBVDED
      VQVOUHVDEDVQVOVSUQURUSVCUIUBABVFVEFGUJUNUQUTVNVLTVCABCDFGUJUKUL $.

    $( Cancel a negative sign in the angle function.  (Contributed by Mario
       Carneiro, 23-Sep-2014.) $)
    angneg $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) ) ->
      ( -u A F -u B ) = ( A F B ) ) $=
      ( cc wcel cc0 wne wa c1 cneg cmul co wceq mulm1 ad2antrr ad2antrl oveq12d
      neg1cn ax-1cn ax-1ne0 negne0i pm3.2i angcan mp3an3 eqtr3d ) CGHZCIJZKZDGH
      ZDIJZKZKZLMZCNOZUPDNOZEOZCMZDMZEOCDEOZUOUQUTURVAEUIUQUTPUJUNCQRULURVAPUKU
      MDQSTUKUNUPGHZUPIJZKUSVBPVCVDUALUBUCUDUEABCDUPEFUFUGUH $.

    ${
      $d x y X $.  $d x y Y $.
      angvald.1 $e |- ( ph -> X e. CC ) $.
      angvald.2 $e |- ( ph -> X =/= 0 ) $.
      angvald.3 $e |- ( ph -> Y e. CC ) $.
      angvald.4 $e |- ( ph -> Y =/= 0 ) $.
      $( The (signed) angle between two vectors is the argument of their
         quotient.  Deduction form of ~ angval .  (Contributed by David Moews,
         28-Feb-2017.) $)
      angvald $p |- ( ph -> ( X F Y ) = ( Im ` ( log ` ( Y / X ) ) ) ) $=
        ( cc wcel cc0 wne co cdiv clog cfv cim wceq angval syl22anc ) AELMENOFL
        MFNOEFDPFEQPRSTSUAHIJKBCEFDGUBUC $.
    $}

    ${
      $d x y X $.  $d x y Y $.
      angcld.1 $e |- ( ph -> X e. CC ) $.
      angcld.2 $e |- ( ph -> X =/= 0 ) $.
      angcld.3 $e |- ( ph -> Y e. CC ) $.
      angcld.4 $e |- ( ph -> Y =/= 0 ) $.
      $( The (signed) angle between two vectors is in ` ( -u pi (,] pi ) ` .
         Deduction form.  (Contributed by David Moews, 28-Feb-2017.) $)
      angcld $p |- ( ph -> ( X F Y ) e. ( -u pi (,] pi ) ) $=
        ( co cdiv clog cfv cim cpi cneg cioc angvald divne0d logimclad eqeltrd
        divcld ) AEFDLFEMLZNOPOQRQSLABCDEFGHIJKTAUEAFEJHIUDAFEJHKIUAUBUC $.
    $}

    ${
      $d x y X $.  $d x y Y $.
      angrteqvd.1 $e |- ( ph -> X e. CC ) $.
      angrteqvd.2 $e |- ( ph -> X =/= 0 ) $.
      angrteqvd.3 $e |- ( ph -> Y e. CC ) $.
      angrteqvd.4 $e |- ( ph -> Y =/= 0 ) $.
      $( Two vectors are at a right angle iff their quotient is purely
         imaginary.  (Contributed by David Moews, 28-Feb-2017.) $)
      angrteqvd $p |- ( ph -> ( ( X F Y ) e. { ( pi / 2 ) , -u ( pi / 2 ) }
                                        <-> ( Re ` ( Y / X ) ) = 0 ) ) $=
        ( co cpi c2 cdiv cneg wcel cfv cc0 wceq cpr clog cim cre angvald eleq1d
        ccos cioc divcld divne0d logimclad coseq0negpitopi syl cosarg0d 3bitr2d
        wb ) AEFDLZMNOLZURPUAZQFEOLZUBRUCRZUSQZVAUGRSTZUTUDRSTAUQVAUSABCDEFGHIJ
        KUEUFAVAMPMUHLQVCVBUPAUTAFEJHIUIZAFEJHKIUJZUKVAULUMAUTVDVEUNUO $.
    $}

    ${
      $d x y X $.  $d x y Y $.
      cosangneg2d.1 $e |- ( ph -> X e. CC ) $.
      cosangneg2d.2 $e |- ( ph -> X =/= 0 ) $.
      cosangneg2d.3 $e |- ( ph -> Y e. CC ) $.
      cosangneg2d.4 $e |- ( ph -> Y =/= 0 ) $.
      $( The cosine of the angle between ` X ` and ` -u Y ` is the negative of
         that between ` X ` and ` Y ` .  If A, B and C are collinear points,
         this implies that the cosines of DBA and DBC sum to zero, i.e., that
         DBA and DBC are supplementary.  (Contributed by David Moews,
         28-Feb-2017.) $)
      cosangneg2d $p |- ( ph -> ( cos ` ( X F -u Y ) ) =
                                -u ( cos ` ( X F Y ) ) ) $=
        ( cdiv co cre cfv cabs cneg ccos divcld fveq2d recld recnd divne0d clog
        abscld absne0d divnegd cim angvald cosargd negeqd negcld negne0d renegd
        eqtrd eqtr3d absnegd oveq12d 3eqtrd 3eqtr4rd ) AFELMZNOZVAPOZLMZQVBQZVC
        LMZEFDMZROZQEFQZDMZROZAVBVCAVBAVAAFEJHISZUAUBAVCAVAVLUEUBAVAVLAFEJHKIUC
        ZUFUGAVHVDAVHVAUDOUHOZROVDAVGVNRABCDEFGHIJKUITAVAVLVMUJUOUKAVKVIELMZUDO
        UHOZROVONOZVOPOZLMVFAVJVPRABCDEVIGHIAFJULZAFJKUMZUITAVOAVIEVSHISAVIEVSH
        VTIUCUJAVQVEVRVCLAVAQZNOVQVEAWAVONAFEJHIUGZTAVAVLUNUPAWAPOVRVCAWAVOPWBT
        AVAVLUQUPURUSUT $.
    $}

    ${
      $d x y X $.  $d x y Y $.  $d x y Z $.
      angrtmuld.1 $e |- ( ph -> X e. CC ) $.
      angrtmuld.2 $e |- ( ph -> Y e. CC ) $.
      angrtmuld.3 $e |- ( ph -> Z e. CC ) $.
      angrtmuld.4 $e |- ( ph -> X =/= 0 ) $.
      angrtmuld.5 $e |- ( ph -> Y =/= 0 ) $.
      angrtmuld.6 $e |- ( ph -> Z =/= 0 ) $.
      angrtmuld.7 $e |- ( ph -> ( Z / Y ) e. RR ) $.
      $( Perpendicularity of two vectors does not change under rescaling the
         second.  (Contributed by David Moews, 28-Feb-2017.) $)
      angrtmuld $p |- ( ph -> ( ( X F Y ) e. { ( pi / 2 ) , -u ( pi / 2 ) }
                        <-> ( X F Z ) e. { ( pi / 2 ) , -u ( pi / 2 ) } ) ) $=
        ( cdiv co cre cc0 wceq cfv wo cpi c2 cneg cpr wcel wn wb divne0d neneqd
        biorf angrteqvd cmul dmdcan2d fveq2d divcld remul2d eqtr3d eqeq1d recld
        syl recnd mul0ord 3bitrd 3bitr4d ) AFEPQZRUAZSTZGFPQZSTZVIUBZEFDQUCUDPQ
        ZVMUEUFZUGEGDQVNUGZAVKUHVIVLUIAVJSAGFKJNMUJUKVKVIULVBABCDEFHILJMUMAVOGE
        PQZRUAZSTVJVHUNQZSTVLABCDEGHILKNUMAVQVRSAVJVGUNQZRUAVQVRAVSVPRAGFEKJIML
        UOUPAVJVGOAFEJILUQZURUSUTAVJVHAGFKJMUQAVHAVGVTVAVCVDVEVF $.
    $}

    ${
      ang180lem1.2 $e |- T = ( ( ( log ` ( 1 / ( 1 - A ) ) ) +
        ( log ` ( ( A - 1 ) / A ) ) ) + ( log ` A ) ) $.
      ang180lem1.3 $e |- N = ( ( ( T / _i ) / ( 2 x. pi ) ) - ( 1 / 2 ) ) $.
      $( Lemma for ~ ang180 .  Show that the "revolution number" ` N ` is an
         integer, using ~ efeq1 to show that since the product of the three
         arguments ` A , 1 / ( 1 - A ) , ( A - 1 ) / A ` is ` -u 1 ` , the sum
         of the logarithms must be an integer multiple of ` 2 pi _i ` away from
         ` pi _i = log ( -u 1 ) ` .  (Contributed by Mario Carneiro,
         23-Sep-2014.) $)
      ang180lem1 $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) ->
        ( N e. ZZ /\ ( T / _i ) e. RR ) ) $=
        ( cc wcel cc0 wne c1 ci cdiv co cpi cmul wceq w3a cz cr cmin c2 wa pire
        recni remulcli 2pos pipos mulgt0ii gt0ne0ii pm3.2i ax-icn divcan5 mp3an
        ine0 recdiv mp4an divcan4i oveq2i 3eqtr2i clog caddc ax-1cn simp1 subcl
        2re cfv sylancr necomd wb subeq0 necon3bid mpbird reccld recne0d logcld
        simp3 sylancl simp2 divcld divne0d addcld mulcli a1i mulne0i divsubdird
        syl5eqel divdiv1 syl3anc oveq1d syl5eq 3eqtr4a efsub efipi fveq2i efadd
        ce cneg syl2anc oveq12d mulcomd div2negd negsubdi2 oveq2d eqtr3d neg1cn
        eflog dmdcand 3eqtrd divcan1d ax-1ne0 negne0i dividi syl6eq eqtrd efeq1
        syl mpbid eqeltrrd oveq1i 1re rehalfcli npcan zred readdcl remulcl jca
        ) CJKZCLMZCNMZUAZFUBKDOPQZUCKYNDORSQZUDQZOUERSQZSQZPQZFUBYNDYSPQZYPYSPQ
        ZUDQUUANUEPQZUDQZYTFUUBUUCUUAUDUUBRYRPQZNYRRPQZPQZUUCRJKZYRJKZYRLMZUFZO
        JKZOLMZUFZUUBUUETRUGUHZUUIUUJYRUERVIUGUIZUHZYRUUPUERVIUGUJUKULUMZUNZUUL
        UUMUOURUNZRYROUPUQUUIUUJUUHRLMUUGUUETUUQUURUUORUGUKUMZYRRUSUTUUFUENPUER
        UEVIUHUUOUVAVAVBVCVBYNDYPYSYNDNNCUDQZPQZVDVJZCNUDQZCPQZVDVJZVEQZCVDVJZV
        EQZJHYNUVHUVIYNUVDUVGYNUVCYNUVBYNNJKZYKUVBJKVFYKYLYMVGZNCVHVKZYNUVBLMNC
        MYNCNYKYLYMVTZVLYNUVBLNCYNUVKYKUVBLTNCTVMVFUVLNCVNVKVOVPZVQZYNUVBUVMUVO
        VRZVSZYNUVFYNUVECYNYKUVKUVEJKUVLVFCNVHWAZUVLYKYLYMWBZWCZYNUVECUVSUVLYNU
        VELMYMUVNYNUVELCNYNYKUVKUVELTCNTVMUVLVFCNVNWAVOVPZUVTWDZVSZWEZYNCUVLUVT
        VSZWEWJZYPJKZYNORUOUUOWFZWGYSJKYNOYRUOUUQWFWGYSLMYNOYRUOUUQURUURWHWGWIY
        NFYOYRPQZUUCUDQZUUDIYNUWJUUAUUCUDYNDJKZUUNUUKUWJUUATUWGUUNYNUUTWGUUKYNU
        USWGDOYRWKWLWMWNWOYNYQWTVJZNTZYTUBKZYNUWMDWTVJZYPWTVJZPQZNYNUWLUWHUWMUW
        RTUWGUWIDYPWPWAYNUWRUWPNXAZPQZNUWQUWSUWPPWQVBYNUWTUWSUWSPQNYNUWPUWSUWSP
        YNUWPUVJWTVJZUWSDUVJWTHWRYNUXAUVHWTVJZUVIWTVJZSQZUWSCPQZCSQUWSYNUVHJKUV
        IJKUXAUXDTUWEUWFUVHUVIWSXBYNUXBUXEUXCCSYNUXBUVDWTVJZUVGWTVJZSQZUVCUVFSQ
        ZUXEYNUVDJKUVGJKUXBUXHTUVRUWDUVDUVGWSXBYNUXFUVCUXGUVFSYNUVCJKUVCLMUXFUV
        CTUVPUVQUVCXJXBYNUVFJKUVFLMUXGUVFTUWAUWCUVFXJXBXCYNUXIUVFUVCSQUVFUWSUVE
        PQZSQUXEYNUVCUVFUVPUWAXDYNUVCUXJUVFSYNUWSUVBXAZPQUVCUXJYNNUVBUVKYNVFWGU
        VMUVOXEYNUXKUVEUWSPYNUVKYKUXKUVETVFUVLNCXFVKXGXHXGYNUWSUVECUWSJKYNXIWGZ
        UVSUVLUWBUVTXKXLXLYNYKYLUXCCTUVLUVTCXJXBXCYNUWSCUXLUVLUVTXMXLWNWMUWSXIN
        VFXNXOXPXQWNXRYNYQJKZUWNUWOVMYNUWLUWHUXMUWGUWIDYPVHWAYQXSXTYAYBZYNUWJYR
        SQZYOUCYNYOYRYNDOUWGUULYNUOWGUUMYNURWGWCZUUIYNUUQWGZUUJYNUURWGZXMYNUWJU
        CKYRUCKUXOUCKYNFUUCVEQZUWJUCYNUXSUWKUUCVEQZUWJFUWKUUCVEIYCYNUWJJKUUCJKU
        XTUWJTYNYOYRUXPUXQUXRWCUUCNYDYEZUHUWJUUCYFWAWNYNFUCKUUCUCKUXSUCKYNFUXNY
        GUYAFUUCYHWAYBUUPUWJYRYIWAYBYJ $.

      $( Lemma for ~ ang180 .  Show that the revolution number ` N ` is
         strictly between ` -u 2 ` and ` 1 ` .  Both bounds are established by
         iterating using the bounds on the imaginary part of the logarithm,
         ~ logimcl , but the resulting bound gives only ` N <_ 1 ` for the
         upper bound.  The case ` N = 1 ` is not ruled out here, but it is in
         some sense an "edge case" that can only happen under very specific
         conditions; in particular we show that all the angle arguments
         ` A , 1 / ( 1 - A ) , ( A - 1 ) / A ` must lie on the negative real
         axis, which is a contradiction because clearly if ` A ` is negative
         then the other two are positive real.  (Contributed by Mario Carneiro,
         23-Sep-2014.) $)
      ang180lem2 $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) ->
        ( -u 2 < N /\ N < 1 ) ) $=
        ( wcel cc0 c1 c2 clt wbr co cpi caddc wceq a1i cc wne cneg ci cdiv cmul
        w3a cmin c3 2cn 1re rehalfcli recni negsubdii c4 4d2e2 oveq1i wa ax-1cn
        4cn 2ne0 pm3.2i divsubdir mp3an 3cn df-4 eqtr4i subaddrii eqtr3i negeqi
        addcomi 3re mulassi divcan1i 2re remulcli mulneg1i mulneg2i 3eqtr4i cim
        pire cfv clog cr renegcli simp1 subcl sylancr simp3 necomd wb necon3bid
        subeq0 mpbird reccld recne0d logcld sylancl simp2 divcld divne0d addcld
        imcld 3adant3 cle logimcld simpld lt2addd negcli 2timesi imaddd 3brtr4d
        logcl logimcl df-3 adddiri mulid2i oveq2i 3eqtri fveq2i syl5eq syl5eqel
        cre imval syl simprd eqtrd syl112anc mpbid syl6breqr le2addd eqtr3d crp
        syl5eqbr adantr recnd resubcl subge0 eqeltrrd relogcld ang180lem1 rered
        breqtrd 2pos pipos mulgt0ii ltmuldiv gt0ne0ii ltaddsubd subid1i eqnetri
        redivcld negsub 1rp oveq12d addsub4d ax-icn ine0 biimpar add20 syl22anc
        biimpa syldan eqcomd lognegb rpaddcl rpreccld negsubdi2 oveq1d div2negd
        cz rpdivcld readdcld reim0d oveq2d ex necon3d ltlen mpbir2and ltdivmul2
        mpi divdiri dividi syl6breq ltsubaddd jca ) CUAJZCKUBZCLUBZUGZMUCZFNOFL
        NOUWJUWKDUDUEPZMQUFPZUEPZLMUEPZUHPZFNUWJUWKUWORPZUWNNOUWKUWPNOUWJUWQUIM
        UEPZUCZUWNNMUWOUHPZUCUWQUWSMUWOUJUWOLUKULZUMUNUWTUWRUOMUEPZUWOUHPZUWTUW
        RUXBMUWOUHUPUQUOLUHPZMUEPZUXCUWRUOUAJLUAJZMUAJZMKUBZURUXEUXCSUTUSUXGUXH
        UJVAVBUOLMVCVDUXDUIMUEUOLUIUTUSVELUIRPUILRPUOLUIUSVEVKVFVGVHUQVIVIVJVIU
        WJUWSUWMUFPZUWLNOZUWSUWNNOZUWJUXIUIQUCZUFPZUWLNUWRUWMUFPZUCUIQUFPZUCUXI
        UXMUXNUXOUWRMUFPZQUFPUXNUXOUWRMQUWRUIVLULZUMZUJQWAUMZVMUXPUIQUFUIMVEUJV
        AVNUQVIZVJUWRUWMUXRUWMMQVOWAVPZUMZVQUIQVEUXSVRVSUWJUXMDVTWBZUWLNUWJMUXL
        UFPZUXLRPZLLCUHPZUEPZWCWBZCLUHPZCUEPZWCWBZRPZVTWBZCWCWBZVTWBZRPZUXMUYCN
        UWJUYDUXLUYMUYOUYDWDJUWJMUXLVOQWAWEZVPTUXLWDJUWJUYQTZUWJUYLUWJUYHUYKUWJ
        UYGUWJUYFUWJUXFUWGUYFUAJUSUWGUWHUWIWFZLCWGWHZUWJUYFKUBLCUBUWJCLUWGUWHUW
        IWIZWJUWJUYFKLCUWJUXFUWGUYFKSLCSWKUSUYSLCWMWHWLWNZWOZUWJUYFUYTVUBWPZWQZ
        UWJUYJUWJUYICUWJUWGUXFUYIUAJUYSUSCLWGWRZUYSUWGUWHUWIWSZWTZUWJUYICVUFUYS
        UWJUYIKUBUWIVUAUWJUYIKCLUWJUWGUXFUYIKSCLSWKUYSUSCLWMWRWLWNVUGXAZWQZXBZX
        CZUWJUYNUWGUWHUYNUAJUWICXMXDZXCZUWJUXLUXLRPZUYHVTWBZUYKVTWBZRPZUYDUYMNU
        WJUXLUXLVUPVUQUYRUYRUWJUYHVUEXCZUWJUYKVUJXCZUWJUXLVUPNOZVUPQXEOZUWJUYGV
        UCVUDXFZXGUWJUXLVUQNOZVUQQXEOZUWJUYJVUHVUIXFZXGXHUYDVUOSUWJUXLQUXSXIZXJ
        TUWJUYHUYKVUEVUJXKZXLUWJUXLUYONOZUYOQXEOZUWGUWHVVIVVJURUWICXNXDZXGXHUXM
        UYESUWJUXMMLRPZUXLUFPUYDLUXLUFPZRPUYEUIVVLUXLUFXOUQMLUXLUJUSVVGXPVVMUXL
        UYDRUXLVVGXQXRXSTUWJUYCUYLUYNRPZVTWBUYPDVVNVTHXTUWJUYLUYNVUKVUMXKYAZXLU
        WJUYCUWLYCWBZUWLUWJDUAJUYCVVPSUWJDVVNUAHUWJUYLUYNVUKVUMXBYBZDYDYEUWJUWL
        UWJFUVKJUWLWDJZABCDEFGHIUUAYFZUUBYGZUUCYNUWJUWSWDJZVVRUWMWDJZKUWMNOZUXJ
        UXKWKVWAUWJUWRUXQWETVVSVWBUWJUYATZVWCUWJMQVOWAUUDUUEUUFZTZUWSUWLUWMUUGY
        HYIYNUWJUWKUWOUWNUWKWDJUWJMVOWETUWOWDJUWJUXATZUWJUWLUWMVVSVWDUWMKUBUWJU
        WMUYAVWEUUHZTUULZUUIYIIYJUWJFUWPLNIUWJUWPLNOUWNLUWORPZNOUWJUWNUWRVWJNUW
        JUWNUWRNOZUWLUXNNOZUWJUWLUXOUXNNUWJUWLUXONOZUWLUXOXEOZUXOUWLUBZUWJUYPUW
        MQRPZUWLUXOXEUWJUYMUYOUWMQVULVUNVWDQWDJZUWJWATZUWJVURQQRPZUYMUWMXEUWJVU
        PVUQQQVUSVUTVWRVWRUWJVVAVVBVVCYFUWJVVDVVEVVFYFYKVVHUWMVWSSUWJQUXSXJTXLZ
        UWJVVIVVJVVKYFZYKUWJUYCUWLUYPVVTVVOYLZUXOVWPSUWJUXOVVLQUFPUWMLQUFPZRPVW
        PUIVVLQUFXOUQMLQUJUSUXSXPVXCQUWMRQUXSXQXRXSTZXLUWJUWMKUHPZKUBVWOVXEUWMK
        UWMUYBUUJVWHUUKUWJUXOUWLVXEKUWJUXOUWLSZVXEKSUWJVXFURZUWMUYMUHPZVXEKVXGU
        YMKUWMUHVXGUYLVXGUYHUYKVXGUYGVXGUYFVXGLCUCZRPZUYFYMUWJVXJUYFSZVXFUWJUXF
        UWGVXKUSUYSLCUUMWHYOVXGLYMJVXIYMJZVXJYMJUUNVXGVXLUYOQSZVXGQUYOVXGQUYOUH
        PZKSZQUYOSZVXGVXHKSZVXOUWJVXFVXHVXNRPZKSZVXQVXOURZVXGUXOUWLUHPZVXRKUWJV
        YAVXRSVXFUWJVYAVWPUYPUHPVXRUWJUXOVWPUWLUYPUHVXDVXBUUOUWJUWMQUYMUYOUWMUA
        JUWJUYBTQUAJZUWJUXSTUWJUYMVULYPUWJUYOVUNYPZUUPYGYOUWJVYAKSZVXFUWJUXOUAJ
        UWLUAJVYDVXFWKUXOUIQVLWAVPZUMUWJDUDVVQUDUAJUWJUUQTUDKUBUWJUURTWTUXOUWLW
        MWHUUSYLUWJVXSVXTUWJVXHWDJZKVXHXEOZVXNWDJZKVXNXEOZVXSVXTWKUWJVWBUYMWDJZ
        VYFUYAVULUWMUYMYQWHUWJVYGUYMUWMXEOZVWTUWJVWBVYJVYGVYKWKUYAVULUWMUYMYRWH
        WNUWJVWQUYOWDJZVYHWAVUNQUYOYQWHUWJVYIVVJVXAUWJVWQVYLVYIVVJWKWAVUNQUYOYR
        WHWNVXHVXNUUTUVAUVBUVCZYFVXGVYBUYOUAJZVXOVXPWKUXSUWJVYNVXFVYCYOQUYOWMWH
        YIUVDUWJVXLVXMWKZVXFUWGUWHVYOUWICUVEXDYOWNZLVXIUVFWHYSZUVGYTVXGUYJVXGUY
        FVXIUEPZUYJYMUWJVYRUYJSVXFUWJUYIUCZVXIUEPVYRUYJUWJVYSUYFVXIUEUWJUWGUXFV
        YSUYFSUYSUSCLUVHWRUVIUWJUYICVUFUYSVUGUVJYLYOVXGUYFVXIVYQVYPUVLYSYTUVMUV
        NUVOVXGVXQVXOVYMXGYLUVPUVQUWAUWJVVRUXOWDJVWMVWNVWOURWKVVSVYEUWLUXOUVRWR
        UVSUXTYJUWJVVRUWRWDJZVWBVWCVWKVWLWKVVSVYTUWJUXQTVWDVWFUWLUWRUWMUVTYHWNU
        WRVVLMUEPMMUEPZUWORPVWJUIVVLMUEXOUQMLMUJUSUJVAUWBWUALUWORMUJVAUWCUQXSUW
        DUWJUWNUWOLVWIVWGLWDJUWJUKTUWEWNYNUWF $.

      $( Lemma for ~ ang180 .  Since ~ ang180lem1 shows that ` N ` is an
         integer and ~ ang180lem2 shows that ` N ` is strictly between ` -u 2 `
         and ` 1 ` , it follows that ` N e. { -u 1 , 0 } ` , and these two
         cases correspond to the two possible values for ` T ` .  (Contributed
         by Mario Carneiro, 23-Sep-2014.) $)
      ang180lem3 $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) ->
        T e. { -u ( _i x. pi ) , ( _i x. pi ) } ) $=
        ( cc wcel cc0 c1 ci cpi cmul co wceq c2 a1i wne w3a cneg wo cpr clt wbr
        cdiv 2cn pire recni mulcli 2ne0 divreci divcan3i eqtr3i cmin ang180lem2
        wa cle caddc simprd 1e0p1 syl6breq cz ang180lem1 simpld zleltp1 sylancl
        wb mpbird adantr zlem1lt sylancr df-neg breq1i syl6bbr biimpar zred 0re
        cr 0z letri3 mpbir2and syl5eqr clog cfv ax-1cn simp1 subcl simp3 necomd
        subeq0 reccld recne0d logcld simp2 divcld divne0d addcld logcl syl5eqel
        necon3bid 3adant3 ax-icn pipos gt0ne0ii mulne0i rehalfcli mpbid divmuld
        ine0 syl5reqr eqcomd olcd mulneg1i mulcomi negeqi eqtri divcan1i oveq1i
        1re mulassi mulid2i negsubdii 1mhlfehlf simpr syl6eq oveq1d npcan eqtrd
        3eqtr3i divcan1d eqtr2d orcd df-2 negdi2 mp2an syl5eqbrr 1z ax-mp leloe
        znegcl renegcli mpjaodan cvv ovex eqeltri elpr sylibr ) CJKZCLUAZCMUAZU
        BZDNOPQZUCZRZDUUORZUDZDUUPUUOUEKUUNMUCZFUFUGZUUSUUTFRZUUNUVAUSZUURUUQUV
        CUUODUVCDNUHQZORUUODRUVCOSOPQZMSUHQZPQZUVDUVESUHQUVGOUVESSOUIOUJUKZULZU
        IUMUNOSUVHUIUMUOUPUVCUVDUVEUHQZUVFRZUVGUVDRUVCUVJUVFUQQZLRZUVKUVCUVLFLI
        UVCFLRZFLUTUGZLFUTUGZUUNUVOUVAUUNUVOFLMVAQZUFUGZUUNFMUVQUFUUNSUCZFUFUGZ
        FMUFUGZABCDEFGHIURZVBVCVDUUNFVEKZLVEKZUVOUVRVJUUNUWCUVDWAKABCDEFGHIVFVG
        ZWBFLVHVIVKVLUUNUVPUVAUUNUVPLMUQQZFUFUGZUVAUUNUWDUWCUVPUWGVJWBUWELFVMVN
        UUTUWFFUFMVOVPVQVRUVCFWAKZLWAKUVNUVOUVPUSVJUUNUWHUVAUUNFUWEVSZVLVTFLWCV
        IWDWEUVCUVJJKZUVFJKZUVMUVKVJUUNUWJUVAUUNUVDUVEUUNDNUUNDMMCUQQZUHQZWFWGZ
        CMUQQZCUHQZWFWGZVAQZCWFWGZVAQZJHUUNUWRUWSUUNUWNUWQUUNUWMUUNUWLUUNMJKZUU
        KUWLJKWHUUKUULUUMWIZMCWJVNZUUNUWLLUAMCUAUUNCMUUKUULUUMWKZWLUUNUWLLMCUUN
        UXAUUKUWLLRMCRVJWHUXBMCWMVNXCVKZWNUUNUWLUXCUXEWOWPUUNUWPUUNUWOCUUNUUKUX
        AUWOJKUXBWHCMWJVIZUXBUUKUULUUMWQZWRUUNUWOCUXFUXBUUNUWOLUAUUMUXDUUNUWOLC
        MUUNUUKUXAUWOLRCMRVJUXBWHCMWMVIXCVKUXGWSWPWTUUKUULUWSJKUUMCXAXDWTXBZNJK
        ZUUNXETZNLUAZUUNXLTZWRZUVEJKZUUNUVITZUVELUAZUUNSOUIUVHUMOUJXFXGXHZTZWRZ
        VLUVFMYBXIUKZUVJUVFWMVIXJUVCUVDUVEUVFUUNUVDJKUVAUXMVLUXNUVCUVITUWKUVCUX
        TTUXPUVCUXQTXKXJXMUVCDNOUUNDJKUVAUXHVLUXIUVCXETOJKUVCUVHTUXKUVCXLTXKXJX
        NXOUUNUVBUSZUUQUURUYAUUPUVDNPQZDUYAUUPOUCZNPQZUYBUYDONPQZUCUUPONUVHXEXP
        UYEUUOONUVHXEXQXRXSUYAUYCUVDNPUYAUYCUVJUVEPQZUVDUYAUYCUVFUCZUVEPQZUYFUY
        HUVFUVEPQZUCUYCUVFUVEUXTUVIXPUYIOUVFSPQZOPQMOPQUYIOUYJMOPMSWHUIUMXTYAUV
        FSOUXTUIUVHYCOUVHYDYLXRXSUYAUYGUVJUVEPUYAUYGUVLUVFVAQZUVJUYAUYGUUTUVFVA
        QZUYKMUVFUQQZUCUYLUYGMUVFWHUXTYEUYMUVFYFXRUPUYAUUTUVLUVFVAUYAUUTFUVLUUN
        UVBYGIYHYIWEUUNUYKUVJRZUVBUUNUWJUWKUYNUXSUXTUVJUVFYJVIVLYKYIWEUUNUYFUVD
        RUVBUUNUVDUVEUXMUXOUXRYMVLYKYIWEUUNUYBDRUVBUUNDNUXHUXJUXLYMVLYNYOUUNUUT
        FUTUGZUVAUVBUDZUUNUYOUUTMUQQZFUFUGZUUNUYQUVSFUFUVSMMVAQZUCZUYQSUYSYPXRU
        XAUXAUYTUYQRWHWHMMYQYRXSUUNUVTUWAUWBVGYSUUNUUTVEKZUWCUYOUYRVJMVEKVUAYTM
        UUCUUAUWEUUTFVMVNVKUUNUUTWAKUWHUYOUYPVJMYBUUDUWIUUTFUUBVNXJUUEDUUPUUODU
        WTUUFHUWRUWSVAUUGUUHUUIUUJ $.
    $}

    $( Lemma for ~ ang180 .  Reduce the statement to one variable.
       (Contributed by Mario Carneiro, 23-Sep-2014.) $)
    ang180lem4 $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) ->
      ( ( ( ( 1 - A ) F 1 ) + ( A F ( A - 1 ) ) ) +
        ( 1 F A ) ) e. { -u pi , pi } ) $=
      ( wcel cc0 wne c1 cmin co caddc cdiv clog cfv cim cpi cneg angvald wceq
      cc w3a cpr ax-1cn simp1 subcld simp3 necomd subne0d ax-1ne0 simp2 oveq12d
      a1i divcld recne0d logcld divne0d imaddd eqtr4d div1d fveq2d eqtrd addcld
      ci cmul c2 eqid ang180lem3 fveq2 ax-icn pire mulcli imnegi addid2i fveq2i
      recni 0re crimi eqtr3i negeqi eqtri syl6eq orim12i ovex elpr fvex 3imtr4i
      wo syl eqeltrd ) CUAFZCGHZCIHZUBZICJKZIDKZCCIJKZDKZLKZICDKZLKZIWOMKZNOZWQ
      CMKZNOZLKZCNOZLKZPOZQRZQUCZWNXAXFPOZXGPOZLKXIWNWSXLWTXMLWNWSXCPOZXEPOZLKX
      LWNWPXNWRXOLWNABDWOIEWNICIUAFWNUDUMZWKWLWMUEZUFZWNICXPXQWNCIWKWLWMUGZUHUI
      ZXPIGHWNUJUMZSWNABDCWQEXQWKWLWMUKZWNCIXQXPUFZWNCIXQXPXSUIZSULWNXCXEWNXBWN
      IWOXPXRXTUNWNWOXRXTUOUPZWNXDWNWQCYCXQYBUNWNWQCYCXQYDYBUQUPZURUSWNWTCIMKZN
      OZPOXMWNABDICEXPYAXQYBSWNYHXGPWNYGCNWNCXQUTVAVAVBULWNXFXGWNXCXEYEYFVCWNCX
      QYBUPURUSWNXHVDQVEKZRZYIUCFZXIXKFZABCXHDXHVDMKVFQVEKMKIVFMKJKZEXHVGYMVGVH
      XHYJTZXHYITZWHXIXJTZXIQTZWHYKYLYNYPYOYQYNXIYJPOZXJXHYJPVIYRYIPOZRXJYIVDQV
      JQVKVPVLZVMYSQGYILKZPOYSQUUAYIPYIYTVNVOGQVQVKVRVSZVTWAWBYOXIYSQXHYIPVIUUB
      WBWCXHYJYIXFXGLWDWEXIXJQXHPWFWEWGWIWJ $.

    $( Lemma for ~ ang180 :  Reduce the statement to two variables.
       (Contributed by Mario Carneiro, 23-Sep-2014.) $)
    ang180lem5 $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ ( B e. CC /\ B =/= 0 ) /\
      A =/= B ) -> ( ( ( ( A - B ) F A ) + ( B F ( B - A ) ) ) +
        ( A F B ) ) e. { -u pi , pi } ) $=
      ( cc wcel cc0 wne cmin co caddc cmul oveq12d wceq angcan syl222anc eqtr3d
      c1 wa w3a cdiv cpi cneg cpr simp1l ax-1cn a1i simp2l simp1r divcld subdid
      mulid1d divcan2d eqtrd subcld simp3 necomd divne1d subne0d ax-1ne0 simp2r
      divne0d ang180lem4 syl3anc eqeltrd ) CGHZCIJZUAZDGHZDIJZUAZCDJZUBZCDKLZCE
      LZDDCKLZELZMLZCDELZMLTDCUCLZKLZTELZWBWBTKLZELZMLZTWBELZMLZUDUEUDUFZVOVTWG
      WAWHMVOVQWDVSWFMVOCWCNLZCTNLZELZVQWDVOWKVPWLCEVOWKWLCWBNLZKLVPVOCTWBVHVIV
      MVNUGZTGHZVOUHUIZVODCVJVKVLVNUJZWOVHVIVMVNUKZULZUMVOWLCWNDKVOCWOUNZVODCWR
      WOWSUOZOUPXAOVOWCGHWCIJWPTIJZVHVIWMWDPVOTWBWQWTUQVOTWBWQWTVOWBTVODCWRWOWS
      VOCDVJVMVNURUSUTZUSVAWQXCVOVBUIZWOWSABWCTCEFQRSVOWNCWENLZELZVSWFVOWNDXFVR
      EXBVOXFWNWLKLVRVOCWBTWOWTWQUMVOWNDWLCKXBXAOUPOVOWBGHZWBIJZWEGHWEIJVHVIXGW
      FPWTVODCWRWOVJVKVLVNVCWSVDZVOWBTWTWQUQVOWBTWTWQXDVAWOWSABWBWECEFQRSOVOWLW
      NELZWAWHVOWLCWNDEXAXBOVOWPXCXHXIVHVIXKWHPWQXEWTXJWOWSABTWBCEFQRSOVOXHXIWB
      TJWIWJHWTXJXDABWBEFVEVFVG $.

    $( The sum of angles ` m A B C + m B C A + m C A B ` in a triangle adds up
       to either ` pi ` or ` -u pi ` , i.e. 180 degrees.  (The sign is due to
       the two possible orientations of vertex arrangement and our signed
       notion of angle).  (Contributed by Mario Carneiro, 23-Sep-2014.) $)
    ang180 $p |- ( ( ( A e. CC /\ B e. CC /\ C e. CC ) /\
      ( A =/= B /\ B =/= C /\ A =/= C ) ) ->
      ( ( ( ( C - B ) F ( A - B ) ) + ( ( A - C ) F ( B - C ) ) ) +
        ( ( B - A ) F ( C - A ) ) ) e. { -u pi , pi } ) $=
      ( cc wcel wne cmin co caddc cneg subcld necomd subne0d negsubdi2d oveq12d
      cc0 w3a cpi cpr wceq simpl3 simpl2 simpr2 simpl1 simpr1 syl22anc nnncan2d
      wa angneg eqtr4d eqtr3d simpr3 subneintr2d ang180lem5 syl221anc eqeltrd
      oveq1d ) CHIZDHIZEHIZUAZCDJZDEJZCEJZUAZULZEDKLZCDKLZFLZCEKLZDEKLZFLZMLZDC
      KLZECKLZFLZMLVRVSKLZVRFLZVSVSVRKLZFLZMLZVTMLZUBNUBUCZVJVQWEVTMVJVMWBVPWDM
      VJVKNZVLNZFLZVMWBVJVKHIVKTJVLHIVLTJWJVMUDVJEDVBVCVDVIUEZVBVCVDVIUFZOVJEDW
      KWLVJDEVEVFVGVHUGZPQVJCDVBVCVDVIUHZWLOVJCDWNWLVEVFVGVHUIZQABVKVLFGUMUJVJW
      HWAWIVRFVJWHVOWAVJEDWKWLRVJDECWLWKWNUKUNVJCDWNWLRSUOVJVNNZVONZFLZVPWDVJVN
      HIVNTJVOHIVOTJWRVPUDVJCEWNWKOVJCEWNWKVEVFVGVHUPZQVJDEWLWKOVJDEWLWKWMQABVN
      VOFGUMUJVJWPVSWQWCFVJCEWNWKRVJWQVKWCVJDEWLWKRVJEDCWKWLWNUKUNSUOSVAVJVRHIV
      RTJVSHIVSTJVRVSJWFWGIVJDCWLWNOVJDCWLWNVJCDWOPQVJECWKWNOVJECWKWNVJCEWSPQVJ
      DECWLWKWNWMUQABVRVSFGURUSUT $.
  $}

  ${
    lawcoslem1.1 $e |- ( ph -> U e. CC ) $.
    lawcoslem1.2 $e |- ( ph -> V e. CC ) $.
    lawcoslem1.3 $e |- ( ph -> U =/= 0 ) $.
    lawcoslem1.4 $e |- ( ph -> V =/= 0 ) $.
    $( Lemma for Law of Cosines ~ lawcos .  Here we prove the law for a point
       at the origin and two distinct points U and V, using an expanded version
       of the signed angle expression on the complex plane.  (Contributed by
       David A. Wheeler, 11-Jun-2015.) $)
    lawcoslem1 $p |- ( ph -> ( ( abs ` ( U - V ) ) ^ 2 ) =
                       ( ( ( ( abs ` U ) ^ 2 ) + ( ( abs ` V ) ^ 2 ) ) -
                         ( 2 x. ( ( ( abs ` U ) x. ( abs ` V ) ) x.
                             ( ( Re ` ( U / V ) ) / ( abs ` ( U / V ) ) ) ) ) )
        ) $=
      ( cmin co cabs cfv c2 cexp cmul cre cdiv cc oveq2d recnd eqtrd caddc wcel
      ccj sqabssub syl2anc absdivd abscld remulcld divcld recld absne0d divne0d
      wceq div12d divdiv2d sqvald oveq1d mul31d sqcld divcan4d 3eqtr2rd mulcomd
      eqtr4d resqcld remul2d c1 divrecd cc0 wne recval cjcld sqne0 syl divcan2d
      wb mpbird eqtr3d fveq2d ) ABCHIJKLMIZBJKZLMICJKZLMIZUAIZLBCUCKZNIZOKZNIZH
      IZWCLVTWANIZBCPIZOKZWJJKZPIZNIZNIZHIABQUBCQUBZVSWHUMDEBCUDUEAWGWOWCHAWFWN
      LNAWNWKWIVTWAPIZPIZNIZWKWBNIZWFAWNWIWKWQPIZNIWSAWMXAWINAWLWQWKPABCDEGUFRR
      AWIWKWQAWIAVTWAABDUGZACEUGZUHSZAWKAWJABCDEGUIZUJSZAVTWAAVTXBSZAWAXCSZACEG
      UKZUIAVTWAXGXHABDFUKZXIULUNTAWBWRWKNAWRWIWANIZVTPIWBVTNIZVTPIWBAWIVTWAXDX
      GXHXJXIUOAXLXKVTPAXLWAWANIZVTNIXKAWBXMVTNAWAXHUPUQAVTWAWAXGXHXHURVCUQAWBV
      TAWAXHUSZXGXJUTVARAWTWBWJNIZOKZWFAWTWBWKNIXPAWKWBXFXNVBAWBWJAWAXCVDXEVEVC
      AXOWEOABWBCPIZNIXOWEABWBCDXNEGUNAXQWDBNAXQWBVFCPIZNIZWDAWBCXNEGVGAXSWBWDW
      BPIZNIWDAXRXTWBNAWPCVHVIXRXTUMEGCVJUERAWDWBACEVKXNAWBVHVIZWAVHVIZXIAWAQUB
      YAYBVOXHWAVLVMVPVNTTRVQVRTVARRT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    lawcos.1 $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } ) |->
                        ( Im ` ( log ` ( y / x ) ) ) ) $.
    lawcos.2 $e |- X = ( abs ` ( B - C ) ) $.
    lawcos.3 $e |- Y = ( abs ` ( A - C ) ) $.
    lawcos.4 $e |- Z = ( abs ` ( A - B ) ) $.
    lawcos.5 $e |- O = ( ( B - C ) F ( A - C ) ) $.
    $( Law of Cosines.  Given three distinct points A, B, and C, prove a
       relationship between their segment lengths.  This theorem is expressed
       using the complex number plane as a plane, where ` F ` is the signed
       angle construct (as used in ~ ang180 ), ` X ` is the distance of line
       segment BC, ` Y ` is the distance of line segment AC, ` Z ` is the
       distance of line segment AB, and ` O ` is the distinguished (signed)
       angle m/_ BCA on the complex plane.  We translate triangle ABC to move C
       to the origin (C-C), B to U=(B-C), and A to V=(A-C), then use lemma
       ~ lawcoslem1 to prove this algebraically simpler case.  The metamath
       convention is to use a signed angle; in this case the sign doesn't
       matter because we use the cosine of the angle (see ~ cosneg ).  The
       Pythagorean Theorem ~ pythag is a special case of the law of cosines.
       The theorem's expression and approach were suggested by Mario Carneiro.
       (Contributed by David A. Wheeler, 12-Jun-2015.) $)
    lawcos $p |- ( ( ( A e. CC /\ B e. CC /\ C e. CC )
                  /\ ( A =/= C /\ B =/= C ) ) ->
                 ( Z ^ 2 ) = ( ( ( X ^ 2 ) + ( Y ^ 2 ) ) -
                             ( 2 x. ( ( X x. Y ) x. ( cos ` O ) ) ) ) ) $=
      ( co cfv c2 cexp cmul cc wcel w3a wne cmin cabs caddc cdiv cre ccos subcl
      3adant2 adantr 3adant1 cc0 subeq0 necon3bid bicomd biimpa adantrr adantrl
      wa wb lawcoslem1 wceq nnncan2 fveq2d syl6reqr oveq1d abscld recnd addcomd
      sqcld oveq1i oveq12i mulcomd ci clog cim ce fveq2i angvald syl5eq divne0d
      cr divcld logcld imcld recosval syl efiarg syl2anc absne0d redivd oveq12d
      eqtrd 3eqtrd oveq2d 3eqtr4d ) CUAUBZDUAUBZEUAUBZUCZCEUDZDEUDZVBZVBZCEUEPZ
      DEUEPZUEPZUFQZRSPZXHUFQZRSPZXIUFQZRSPZUGPZRXMXOTPZXHXIUHPZUIQXSUFQZUHPZTP
      ZTPZUEPJRSPZHRSPZIRSPZUGPZRHITPZGUJQZTPZTPZUEPXGXHXIXCXHUAUBZXFWTXBYLXACE
      UKULUMZXCXIUAUBZXFXAXBYNWTDEUKUNUMZXCXDXHUOUDZXEXCXDYPWTXBXDYPVCXAWTXBVBZ
      YPXDYQXHUOCECEUPUQURULUSUTZXCXEXIUOUDZXDXCXEYSXAXBXEYSVCWTXAXBVBZYSXEYTXI
      UODEDEUPUQURUNUSVAZVDXCYDXLVEXFXCJXKRSXCXKCDUEPZUFQJXCXJUUBUFCDEVFVGNVHVI
      UMXGYGXQYKYCUEXGXQXPXNUGPYGXGXNXPXGXMXGXMXGXHYMVJVKZVMXGXOXGXOXGXIYOVJVKZ
      VMVLYEXPYFXNUGHXORSLVNIXMRSMVNVOVHXGYJYBRTXGYHXRYIYATXGXRXOXMTPYHXGXMXOUU
      CUUDVPHXOIXMTLMVOVHXGYIVQXSVRQZVSQZTPVTQZUIQZXSXTUHPZUIQYAXGYIUUFUJQZUUHX
      GYIXIXHFPZUJQUUJGUUKUJOWAXGUUKUUFUJXGABFXIXHKYOUUAYMYRWBVGWCXGUUFWEUBUUJU
      UHVEXGUUEXGXSXGXHXIYMYOUUAWFZXGXHXIYMYOYRUUAWDZWGWHUUFWIWJWPXGUUGUUIUIXGX
      SUAUBXSUOUDUUGUUIVEUULUUMXSWKWLVGXGXTXSXGXSUULVJUULXGXSUULUUMWMWNWQWOWRWO
      WS $.

    $( Pythagorean Theorem.  Given three distinct points A, B, and C that form
       a right triangle (with the right angle at C), prove a relationship
       between their segment lengths.  This theorem is expressed using the
       complex number plane as a plane, where ` F ` is the signed angle
       construct (as used in ~ ang180 ), ` X ` is the distance of line segment
       BC, ` Y ` is the distance of line segment AC, ` Z ` is the distance of
       line segment AB (the hypotenuse), and ` O ` is the distinguished
       (signed) right angle m/_ BCA. We use the law of cosines ~ lawcos to
       prove this, along with simple trig facts like ~ coshalfpi and
       ~ cosneg .  (Contributed by David A. Wheeler, 13-Jun-2015.) $)
    pythag $p |- ( ( ( A e. CC /\ B e. CC /\ C e. CC )
                  /\ ( A =/= C /\ B =/= C )
                  /\ O e. { ( pi / 2 ) , -u ( pi / 2 ) } ) ->
                 ( Z ^ 2 ) = ( ( X ^ 2 ) + ( Y ^ 2 ) ) ) $=
      ( cc c2 co cmul cc0 wcel w3a wne wa cpi cdiv cneg cpr cexp caddc ccos cfv
      cmin wceq lawcos 3adant3 wo elpri fveq2 coshalfpi syl6eq cosneghalfpi syl
      jaoi 3ad2ant3 oveq2d subcl 3adant1 3ad2ant1 abscld recnd syl5eqel 3adant2
      cabs mulcld mul01d eqtrd 2cn mul01i sqcld addcld subid1d 3eqtrd ) CPUAZDP
      UAZEPUAZUBZCEUCDEUCUDZGUEQUFRZWIUGZUHUAZUBZJQUIRZHQUIRZIQUIRZUJRZQHISRZGU
      KULZSRZSRZUMRZWPTUMRWPWGWHWMXAUNWKABCDEFGHIJKLMNOUOUPWLWTTWPUMWLWTQTSRTWL
      WSTQSWLWSWQTSRTWLWRTWQSWKWGWRTUNZWHWKGWIUNZGWJUNZUQXBGWIWJURXCXBXDXCWRWIU
      KULTGWIUKUSUTVAXDWRWJUKULTGWJUKUSVBVAVDVCVEVFWLWQWLHIWLHDEUMRZVNULZPLWLXF
      WLXEWGWHXEPUAZWKWEWFXGWDDEVGVHVIVJVKVLZWLICEUMRZVNULZPMWLXJWLXIWGWHXIPUAZ
      WKWDWFXKWECEVGVMVIVJVKVLZVOVPVQVFQVRVSVAVFWLWPWLWNWOWLHXHVTWLIXLVTWAWBWC
      $.
  $}

  $( Symmetry of the natural logarithm range by negation.  Lemma for
     ~ logrec .  (Contributed by Saveliy Skresanov, 27-Dec-2016.) $)
  logreclem $p |- ( ( A e. ran log /\ -. ( Im ` A ) = pi ) ->
      -u A e. ran log ) $=
    ( wcel cim cpi wceq cneg wo wa cc clt wbr cle adantr cr wi pire biimpd sylc
    syl wb clog crn cfv wn w3a logrncn negcld ellogrn biimpi imcl leneg sylancl
    simp3d renegcli a1i renegcld leloed orcomd orcanai simp2d ltnegcon1 sylancr
    ltle imneg breq2d breq1d anbi12d mpbir2and 3anass sylanbrc sylibr orrd recn
    mpd ex anim12i neg11 eqcom syl6bb orbi1d mpbid ) AUAUBZBZACUCZDEZAFZWBBZWCD
    FZWDFZEZWGGWEWGGWCWJWGWCWJUDZWGWCWKHZWFIBZWHWFCUCZJKZWNDLKZUEZWGWLWMWOWPHZW
    QWLAWCAIBZWKAUFZMZUGWLWRWHWIJKZWIDLKZWCWJXBWCXBWJWCWSWHWILKZXBWJGZWTWCWSWDD
    LKZXDWTWCWSWHWDJKZXFWCWSXGXFUEAUHUIZUMWSWDNBZDNBZXFXDOAUJZPXIXJHXFXDWDDUKQU
    LRWSXDXEWSWHWIWHNBWSDPUNUOWSWDXKUPZUQQRURUSWLWIDJKZXCWCXMWKWCWSXGXMWTWCWSXG
    XFXHUTWSXJXIXGXMOPXKXJXIHXGXMDWDVAQVBRMWCXMXCOZWKWCWSXNWTWSWINBXJXNXLPWIDVC
    ULSMVNWLWOXBWPXCWLWSWOXBTXAWSWNWIWHJAVDZVESWLWSWPXCTXAWSWNWIDLXOVFSVGVHWMWO
    WPVIVJWFUHVKVOVLWCWJWEWGWCDIBZWDIBZHZWJWETWCWSXRWTWSXJXIXRPXKXJXPXIXQDVMWDV
    MVPVBSXRWJDWDEWEDWDVQDWDVRVSSVTWAUS $.

  $( Logarithm of a reciprocal changes sign.  (Contributed by Saveliy
     Skresanov, 28-Dec-2016.) $)
  logrec $p |- ( ( A e. CC /\ A =/= 0 /\ ( Im ` ( log ` A ) ) =/= pi ) ->
      ( log ` A ) = -u ( log ` ( 1 / A ) ) ) $=
    ( cc wcel cc0 wne clog cfv cim cpi ce c1 cdiv co cneg wceq wa eflog syl2anc
    syl crp w3a reccl recne0 eqcomd oveq2d recrec eqtr4d logcld 3eqtr4d 3adant3
    efneg fveq2d logrncl logef wn df-ne wb lognegb biimprd ax-1cn mp3an1 eleq1d
    crn divneg2 sylibd negcl adantr negeq0 necon3bid biimpa rpreccl syl5ib syld
    wi con3d 3impia syl3an3b logreclem sylan 3impa syld3an3 3eqtr3d ) ABCZADEZA
    FGZHGZIEZUAZWEJGZFGZKALMZFGZNZJGZFGZWEWMWHWIWNFWCWDWIWNOWGWCWDPZKWKLMZKWLJG
    ZLMZWIWNWPWKWRKLWPWRWKWPWKBCZWKDEZWRWKOAUBZAUCZWKQRUDUEWPWIAWQAQAUFUGWPWLBC
    WNWSOWPWKXBXCUHWLUKSUIUJULWHWEFVCZCZWJWEOWCWDXEWGAUMUJWEUNSWHWMXDCZWOWMOWCW
    DWGWLHGIOZUOZXFWGWCWDWFIOZUOZXHWFIUPWCWDXJXHWPXGXIWPXGANZTCZXIWPXGKXKLMZTCZ
    XLWPXGWKNZTCZXNWPXPXGWPWTXAXPXGUQXBXCWKURRUSWPXOXMTKBCWCWDXOXMOUTKAVDVAVBVE
    WPXKBCZXKDEZXNXLVNWCXQWDAVFVGWCWDXRWCADXKDAVHVIVJXNKXMLMZTCXQXRPZXLXMVKXTXS
    XKTXKUFVBVLRVMAURVEVOVPVQWCWDXHXFWPWLXDCZXHXFWPWTXAYAXBXCWKUMRWLVRVSVTWAWMU
    NSWB $.

  $( Lemma for ~ isosctr .  (Contributed by Saveliy Skresanov, 30-Dec-2016.) $)
  isosctrlem1 $p |- ( ( A e. CC /\ ( abs ` A ) = 1 /\ -. 1 = A ) ->
      ( Im ` ( log ` ( 1 - A ) ) ) =/= pi ) $=
    ( cc wcel cfv c1 wceq wn cmin co cpi ax-1cn mpan adantr cc0 3adant2 cle wbr
    cr wa cre cabs w3a clog subcl wb subeq0 notbid biimpar neneqad logcld imcld
    cim c2 cdiv clt 3ad2ant1 releabs breq2 adantl mpbid recl recnd subidd simpl
    wne recld 1re a1i simpr lesub1dd eqbrtrrd syldan re1 oveq1i syl6eq breqtrrd
    resub 3adant3 cneg argrege0 cxr halfpire renegcli rexri iccleub mp3an12 syl
    cicc syl3anc crp pire pipos elrpii rphalflt ax-mp jctir wi rehalfcld lelttr
    mpd ltned ) ABCZAUADZEFZEAFZGZUBZEAHIZUCDZULDZJXBXFXJRCZXDXBXFSZXIXLXHXBXHB
    CZXFEBCZXBXMKEAUDLZMXLXHNXBXHNFZGZXFXNXBXQXFUEKXNXBSZXPXEEAUFUGLUHUIZUJUKZO
    XGXJJUMUNIZPQZYAJUOQZSZXJJUOQZXGYBYCXGXMXHNVEZNXHTDZPQZYBXBXDXMXFXOUPXBXFYF
    XDXSOXBXDYHXFXBXDSZNEATDZHIZYGPXBXDYJEPQZNYKPQYIYJXCPQZYLXBYMXDAUQMXDYMYLUE
    XBXCEYJPURUSUTXBYLSZYJYJHIZNYKPXBYONFYLXBYJXBYJAVAVBVCMYNYJEYJYNAXBYLVDVFZE
    RCYNVGVHYPXBYLVIVJVKVLXBYGYKFZXDXNXBYQKXRYGETDZYJHIYKEAVQYREYJHVMVNVOLMVPVR
    XMYFYHUBXJYAVSZYAWHICZYBXHVTYSWACYAWACYTYBYSYAWBWCWDYAWBWDYSYAXJWEWFWGWIJWJ
    CYCJWKWLWMJWNWOWPXBXFYDYEWQZXDXLXKYARCJRCZUUAXTXLJUUBXLWKVHZWRUUCXJYAJWSWIO
    WTXA $.

  $( Lemma for ~ isosctr .  Corresponds to the case where one vertex is at 0,
     another at 1 and the third lies on the unit circle.  (Contributed by
     Saveliy Skresanov, 31-Dec-2016.) $)
  isosctrlem2 $p |- ( ( A e. CC /\ ( abs ` A ) = 1 /\ -. 1 = A ) ->
      ( Im ` ( log ` ( 1 - A ) ) ) =
      ( Im ` ( log ` ( -u A / ( 1 - A ) ) ) ) ) $=
    ( cc wcel cfv c1 wceq cmin co clog cim cneg cdiv cc0 wa a1i adantr eqeltrrd
    cr wne ccj cabs wn w3a caddc crp ax-1cn simpl1 negsubd 1rp simpl3 wo simpl2
    sub32d 1m1e0 oveq1i df-neg eqtr4i syl6eq simp1 subcld wb subeq0 mpan biimpd
    con3and neneqad 3adant2 recrecd div2negd negcld cjdivd cjnegd fveq2 ax-1ne0
    abs0 eqtr2 sylan2 id neneqd mp1i pm2.65da df-ne cmul c2 cexp oveq1 absvalsq
    adantl sq1 eqtr3d 3adant3 oveq1d cjcld simp3 eqtrd syl3an3br mpd3an3 eqcomd
    divcan3d negeqd cjsub 1re cjred oveq2d 3ad2ant2 simpl simpr divnegd syl2anc
    3eqtrd divcld reccld cjne0d eqnetrrd divcan5d subdid mulid1d recidd oveq12d
    divcan2d 3eqtr2d negnegd negsubdi2 reim0bd eqeltrd recne0d rereccld negrebd
    subcl resubcld absord eqeq1 orim12d sylc relogcld reim0d logcld imcld recnd
    fveq2d ord rpaddcld rpdivcld eqtr4d negne0d divne0d logcj sylan isosctrlem1
    mpd logrec syl3anc 3eqtr4rd 3eqtr3rd imnegd imcjd 3eqtr3d neg11d pm2.61dane
    cpi ) ABCZAUADZEFZEAFZUBZUCZEAGHZIDZJDZAKZUVGLHZIDZJDZFUVKJDZMUVFUVNMFZNZUV
    IMUVMUVPUVHUVPUVGUVPEUVJUDHUVGUEUVPEAEBCZUVPUFOZUVAUVCUVEUVOUGZUHUVPEUVJEUE
    CUVPUIOZUVPEUVJUEUVPUVEEUVJFZUVAUVCUVEUVOUJUVPUVDUWAUVPUVCUVBAFZUVBUVJFZUKU
    VDUWAUKUVAUVCUVEUVOULUVPAUVPAUVSUVPUVGEGHZUVJRUVPUWDEEGHZAGHZUVJUVPEAEUVRUV
    SUVRUMUWFMAGHUVJUWEMAGUNUOAUPUQURUVPUVGEUVPEEUVGLHZLHUVGRUVPUVGUVFUVGBCZUVO
    UVFEAUVQUVFUFOZUVAUVCUVEUSZUTZPUVFUVGMSZUVOUVAUVEUWLUVCUVAUVENUVGMUVAUVGMFZ
    UVDUVAUWMUVDUVQUVAUWMUVDVAUFEAVBVCVDVEVFVGZPVHUVPUWGUVPEKZUVGKZLHZUWGRUVFUW
    QUWGFUVOUVFEUVGUWIUWKUWNVIZPUVPUVKTDZUWQRUVFUWSUWQFUVOUVFUWSEALHZKZEUWTGHZL
    HZUWOAEGHZLHZUWQUVFUWSUVJTDZUVGTDZLHUXAUXGLHUXCUVFUVJUVGUVFAUWJVJZUWKUWNVKU
    VFUXFUXAUXGLUVFUXFATDZKUXAUVFAUWJVLUVFUXIUWTUVAUVCUXIUWTFUVEUVAUVCNZUWTUXIU
    VAUVCAMFZUBZUWTUXIFZUVCUXLUVAUVCUXKEMFZUXKUVCUVBMFUXNUXKUVBMUADMAMUAVMVOURU
    VBEMVPVQEMSZUXNUBUVCUXKNVNUXOEMUXOVRVSVTWAZWHUXLUVAUVCAMSZUXMAMWBUVAUVCUXQU
    CZUWTAUXIWCHZALHUXIUXREUXSALUVAUVCEUXSFUXQUXJUVBWDWEHZEUXSUVCUXTEFUVAUVCUXT
    EWDWEHEUVBEWDWEWFWIURWHUVAUXTUXSFUVCAWGPWJWKWLUXRUXIAUXRAUVAUVCUXQUSZWMUYAU
    VAUVCUXQWNWSWOWPWQWRZWKWTWOWLUVFUXGUXBUXALUVAUVCUXGUXBFUVEUXJUXGEUXIGHZUXBU
    VAUXGUYCFUVCUVAUXGETDZUXIGHZUYCUVQUVAUXGUYEFUFEAXAVCUVAUYDEUXIGUVAEERCZUVAX
    BOXCWLWOPUXJUXIUWTEGUYBXDWOWKZXDXJUVFUXCUWOALHZUXBLHZAUYHWCHZAUXBWCHZLHUXEU
    VFUVAUXQUXCUYIFUWJUVFAMUVCUVAUXLUVEUXPXEVFZUVAUXQNZUXAUYHUXBLUYMEAUVQUYMUFO
    UVAUXQXFUVAUXQXGXHWLXIUVFUYHUXBAUVFUWOAUVFEUWIVJZUWJUYLXKUVFEUWTUWIUVFAUWJU
    YLXLZUTUWJUVFUXGUXBMUYGUVFUVGUWKUWNXMXNUYLXOUVFUYJUWOUYKUXDLUVFUWOAUYNUWJUY
    LXTUVFUYKAEWCHZAUWTWCHZGHUXDUVFAEUWTUWJUWIUYOXPUVFUYPAUYQEGUVFAUWJXQUVFAUWJ
    UYLXRXSWOXSYAUVFUXDUWPUWOLUVFUVAUVQUXDUWPFUWJUWIUVAUVQNZUXDKZKUXDUWPUYRUXDA
    EYIYBUYRUYSUVGAEYCWTWJXIXDXJZPUVPUWSUVKRUVPUVKUVPUVKUVFUVKBCZUVOUVFUVJUVGUX
    HUWKUWNXKZPUVFUVOXGYDZXCVUCYEQQUVFUWGMSUVOUVFUVGUWKUWNYFZPYGQUYFUVPXBOYJQYH
    YKUVCUWBUVDUWCUWAUVCUWBUVDUVBEAYLVDUVCUWCUWAUVBEUVJYLVDYMYNUUAUUJUVTQZUUBQZ
    YOYPUVPUVLUVPUVKUVPUVJUVGVUEVUFUUCYOYPUUDUVFUVNMSZNZUVIUVMVUHUVIVUHUVHUVFUV
    HBCVUGUVFUVGUWKUWNYQPZYRYSVUHUVMVUHUVLVUHUVKUVFVUAVUGVUBPUVFUVKMSVUGUVFUVJU
    VGUXHUWKUVFAUWJUYLUUEUWNUUFPYQZYRYSVUHUVHKZJDUVLTDZJDUVIKUVMKVUHVUKVULJVUHU
    WSIDZUWQIDZVULVUKUVFVUMVUNFVUGUVFUWSUWQIUYTYTPUVFVUAVUGVUMVULFVUBUVKUUGUUHU
    VFVUNVUKFVUGUVFUWGIDZKZKVUOVUKVUNUVFVUOUVFUWGUVFUVGUWKUWNXLVUDYQYBUVFUVHVUP
    UVFUWHUWLUVIUUTSUVHVUPFUWKUWNAUUIUVGUUKUULWTUVFUWQUWGIUWRYTUUMPUUNYTVUHUVHV
    UIUUOVUHUVLVUJUUPUUQUURUUS $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    isosctrlem3.1 $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } ) |->
                        ( Im ` ( log ` ( y / x ) ) ) ) $.
    $( Lemma for ~ isosctr .  Corresponds to the case where one vertex is at
       0.  (Contributed by Saveliy Skresanov, 1-Jan-2017.) $)
    isosctrlem3 $p |- ( ( ( A e. CC /\ B e. CC ) /\
                         ( A =/= 0 /\ B =/= 0 /\ A =/= B ) /\
                         ( abs ` A ) = ( abs ` B ) )
                       -> ( -u A F ( B - A ) ) = ( ( A - B ) F -u B ) ) $=
      ( cc wcel cc0 wne cfv wceq cneg cmin co c1 cdiv clog cim cmul wa w3a cabs
      simp1l simp21 simp1r subcld simp23 subne0d angneg syl22anc negsubdi2d a1i
      oveq2d ax-1cn ax-1ne0 divcld necomd divne1d angvald div1d fveq2d wn simp3
      eqcomd oveq1d abscld recnd dividd 3eqtrd neneqd isosctrlem2 negcld simp22
      absdivd absne0d syl3anc divne0d negne0d eqtr4d mulid1d divcan2d syl222anc
      subdid oveq12d eqtrd angcan eqtr3d mulneg2d negeqd 3eqtr4d 3eqtr3d ) CGHZ
      DGHZUAZCIJZDIJZCDJZUBZCUCKZDUCKZLZUBZCMZCDNOZMZEOZCXEEOZXDDCNOZEOXEDMZEOZ
      XCWMWPXEGHXEIJXGXHLWMWNWSXBUDZWOWPWQWRXBUEZXCCDXLWMWNWSXBUFZUGXCCDXLXNWOW
      PWQWRXBUHZUIABCXEEFUJUKXCXFXIXDEXCCDXLXNULUNXCPPDCQOZNOZEOZXQXPMZEOZXHXKX
      CXRXQPQOZRKZSKXQRKZSKZXTXCABEPXQFPGHZXCUOUMZPIJZXCUPUMZXCPXPYFXCDCXNXLXMU
      QZUGZXCPXPYFYIXCXPPXCDCXNXLXMXCCDXOURUSURZUIZUTXCYBYCSXCYAXQRXCXQYJVAVBVB
      XCYDXSXQQORKSKZXTXCXPGHXPUCKZPLPXPLVCYDYMLYIXCYNXAWTQOWTWTQOPXCDCXNXLXMVO
      XCXAWTWTQXCWTXAWOWSXBVDVEVFXCWTXCWTXCCXLVGVHXCCXLXMVPVIVJXCPXPYKVKXPVLVQX
      CABEXQXSFYJYLXCXPYIVMZXCXPYIXCDCXNXLWOWPWQWRXBVNXMVRVSZUTVTVJXCCPTOZCXQTO
      ZEOZXHXRXCYQCYRXEEXCCXLWAZXCYRYQCXPTOZNOXEXCCPXPXLYFYIWDXCYQCUUADNYTXCDCX
      NXLXMWBZWEWFZWEXCYEYGXQGHZXQIJZWMWPYSXRLYFYHYJYLXLXMABPXQCEFWGWCWHXCYRCXS
      TOZEOZXKXTXCYRXEUUFXJEUUCXCUUFUUAMXJXCCXPXLYIWIXCUUADUUBWJWFWEXCUUDUUEXSG
      HXSIJWMWPUUGXTLYJYLYOYPXLXMABXQXSCEFWGWCWHWKWL $.

    $( Isosceles triangle theorem.  (Contributed by Saveliy Skresanov,
       1-Jan-2017.) $)
    isosctr $p |- ( ( ( A e. CC /\ B e. CC /\ C e. CC ) /\
                     ( A =/= C /\ B =/= C /\ A =/= B ) /\
                     ( abs ` ( A - C ) ) = ( abs ` ( B - C ) ) )
                 -> ( ( C - A ) F ( B - A ) ) = ( ( A - B ) F ( C - B ) ) ) $=
      ( cc wcel w3a wne cmin co cabs cfv wceq cneg cc0 subcld subne0d simp11 wb
      simp13 simp12 simp21 simp22 simp23 subcan2 3ad2ant1 necon3bid isosctrlem3
      mpbird simp3 syl231anc negsubdi2d nnncan2d oveq12d 3eqtr3d ) CHIZDHIZEHIZ
      JZCEKZDEKZCDKZJZCELMZNODELMZNOPZJZVGQZVHVGLMZFMZVGVHLMZVHQZFMZECLMZDCLMZF
      MCDLMZEDLMZFMVJVGHIVHHIVGRKVHRKVGVHKZVIVMVPPVJCEUSUTVAVFVIUAZUSUTVAVFVIUC
      ZSVJDEUSUTVAVFVIUDZWCSVJCEWBWCVBVCVDVEVIUETVJDEWDWCVBVCVDVEVIUFTVJWAVEVBV
      CVDVEVIUGVJVGVHCDVBVFVGVHPCDPUBVICDEUHUIUJULVBVFVIUMABVGVHFGUKUNVJVKVQVLV
      RFVJCEWBWCUOVJDCEWDWBWCUPUQVJVNVSVOVTFVJCDEWBWDWCUPVJDEWDWCUOUQUR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y E $.
    $d x y G $.
    ssscongptld.angdef $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } )
                             |-> ( Im ` ( log ` ( y / x ) ) ) ) $.
    ssscongptld.1 $e |- ( ph -> A e. CC ) $.
    ssscongptld.2 $e |- ( ph -> B e. CC ) $.
    ssscongptld.3 $e |- ( ph -> C e. CC ) $.
    ssscongptld.4 $e |- ( ph -> D e. CC ) $.
    ssscongptld.5 $e |- ( ph -> E e. CC ) $.
    ssscongptld.6 $e |- ( ph -> G e. CC ) $.
    ssscongptld.7 $e |- ( ph -> A =/= B ) $.
    ssscongptld.8 $e |- ( ph -> B =/= C ) $.
    ssscongptld.9 $e |- ( ph -> D =/= E ) $.
    ssscongptld.10 $e |- ( ph -> E =/= G ) $.
    ssscongptld.11 $e |- ( ph -> ( abs ` ( A - B ) ) = ( abs ` ( D - E ) ) ) $.
    ssscongptld.12 $e |- ( ph -> ( abs ` ( B - C ) ) = ( abs ` ( E - G ) ) ) $.
    ssscongptld.13 $e |- ( ph -> ( abs ` ( C - A ) ) = ( abs ` ( G - D ) ) ) $.
    $( If two triangles have equal sides, one angle in one triangle has the
       same cosine as the corresponding angle in the other triangle.  This is a
       partial form of the SSS congruence theorem.

       This theorem is proven by using ~ lawcos on both triangles to express
       one side in terms of the other two, and then equating these expressions
       and reducing this algebraically to get an equality of cosines of
       angles.  (Contributed by David Moews, 28-Feb-2017.) $)
    ssscongptld $p |- ( ph -> ( cos ` ( ( A - B ) F ( C - B ) ) ) =
                              ( cos ` ( ( D - E ) F ( G - E ) ) ) ) $=
      ( cmin co ccos cfv cabs cmul cpi cneg cc cr negpitopissre ax-resscn sstri
      subcld subne0d necomd angcld sseldi coscld abscld absne0d mulne0d abssubd
      cioc recnd mulcld 3eqtr4d oveq12d oveq1d c2 eqeltrd wcel 2cn a1i cc0 2ne0
      cexp caddc sqcld addcld wceq eqid lawcos syl32anc 3eqtr3d eqtr3d mulcanad
      wne subcand ) ADEUEUFZFEUEUFZIUFZUGUHZGHUEUFZJHUEUFZIUFZUGUHZWRUIUHZWSUIU
      HZUJUFZAWPAUKULUKVHUFZUMWPXEUNUMUOUPUQZABCIWNWOKADELMURADELMRUSAFENMURAFE
      NMAEFSUTZUSVAVBVCZAWTAXEUMWTXFABCIWRWSKAGHOPURZAGHOPTUSZAJHQPURZAJHQPAHJU
      AUTZUSZVAVBVCZAXBXCAXBAWRXIVDVIZAXCAWSXKVDVIZVJZAXBXCXOXPAWRXIXJVEAWSXKXM
      VEVFAWNUIUHZWOUIUHZUJUFZWQUJUFZXDWQUJUFXDXAUJUFZAXTXDWQUJAXRXBXSXCUJUBAEF
      UEUFUIUHHJUEUFUIUHXSXCUCAFENMVGAJHQPVGVKZVLVMAYAYBVNAXTWQAXRXSAXRXBUMUBXO
      VOAXSXCUMYCXPVOVJXHVJZAXDXAXQXNVJZVNUMVPAVQVRZVNVSWLAVTVRAXBVNWAUFZXCVNWA
      UFZWBUFZVNYAUJUFZVNYBUJUFZAYGYHAXBXOWCAXCXPWCWDAVNYAYFYDVJAVNYBYFYEVJAXRV
      NWAUFZXSVNWAUFZWBUFZYJUEUFZYIYJUEUFYIYKUEUFZAYNYIYJUEAYLYGYMYHWBAXRXBVNWA
      UBVMAXSXCVNWAYCVMVLVMAFDUEUFUIUHZVNWAUFZJGUEUFUIUHZVNWAUFZYOYPAYQYSVNWAUD
      VMAFUMVPDUMVPEUMVPFEWLDEWLYRYOWENLMXGRBCFDEIWPXRXSYQKXRWFXSWFYQWFWPWFWGWH
      AJUMVPGUMVPHUMVPJHWLGHWLYTYPWEQOPXLTBCJGHIWTXBXCYSKXBWFXCWFYSWFWTWFWGWHWI
      WJWMWKWJWK $.
  $}

  ${
    affineequiv.A $e |- ( ph -> A e. CC ) $.
    affineequiv.B $e |- ( ph -> B e. CC ) $.
    affineequiv.C $e |- ( ph -> C e. CC ) $.
    affineequiv.D $e |- ( ph -> D e. CC ) $.
    $( Equivalence between two ways of expressing ` B ` as an affine
       combination of ` A ` and ` C ` .  (Contributed by David Moews,
       28-Feb-2017.) $)
    affineequiv $p  |- ( ph -> ( B = ( ( D x. A ) + ( ( 1 - D ) x. C ) )
                             <-> ( C - B ) = ( D x. ( C - A ) ) ) ) $=
      ( cmul co c1 cmin caddc wceq cc0 mulcld subcld cc wcel subsubd eqtr2d a1i
      addcomd ax-1cn subdird mulid2d oveq1d eqtrd oveq2d pncan3d subdid oveq12d
      addsubassd eqtr3d 3eqtr4d eqeq2d addid1d eqeq1d 0cn addcand 3bitr2d eqcom
      syl6bb subeq0ad bitrd ) ACEBJKZLEMKDJKZNKZOZDCMKZEDBMKZJKZMKZPOZVKVMOAVJP
      VNOZVOAVJCCVNNKZOCPNKZVQOVPAVIVQCAVGDEDJKZMKZNKZDVSVGMKZMKZVIVQAWCVTVGNKW
      AADVSVGHAEDIHQZAEBIFQZUAAVTVGADVSHWDRWEUDUBAVHVTVGNAVHLDJKZVSMKVTALEDLSTA
      UEUCIHUFAWFDVSMADHUGUHUIUJACVKNKZVMMKVQWCACVKVMGADCHGRZAEVLIADBHFRQZUNAWG
      DVMWBMACDGHUKAEDBIHFULUMUOUPUQAVRCVQACGURUSACPVNGPSTAUTUCAVKVMWHWIRVAVBPV
      NVCVDAVKVMWHWIVEVF $.

    $( Equivalence between two ways of expressing ` B ` as an affine
       combination of ` A ` and ` C ` .  (Contributed by David Moews,
       28-Feb-2017.) $)
    affineequiv2 $p  |- ( ph -> ( B = ( ( D x. A ) + ( ( 1 - D ) x. C ) )
                              <-> ( B - A ) = ( ( 1 - D ) x. ( C - A ) ) ) ) $=
      ( cmul co c1 cmin caddc wceq affineequiv subcld mulcld subcanad nnncan1d
      cc wcel ax-1cn a1i subdird mulid2d oveq1d eqtr2d eqeq12d 3bitr2d ) ACEBJK
      LEMKZDJKNKODCMKZEDBMKZJKZOUMULMKZUMUNMKZOCBMKZUKUMJKZOABCDEFGHIPAUMULUNAD
      BHFQZADCHGQAEUMIUSRSAUOUQUPURADBCHFGTAURLUMJKZUNMKUPALEUMLUAUBAUCUDIUSUEA
      UTUMUNMAUMUSUFUGUHUIUJ $.
  $}


  ${
    angpieqvdlem.A $e |- ( ph -> A e. CC ) $.
    angpieqvdlem.B $e |- ( ph -> B e. CC ) $.
    angpieqvdlem.C $e |- ( ph -> C e. CC ) $.
    angpieqvdlem.AneB $e |- ( ph -> A =/= B ) $.
    angpieqvdlem.AneC $e |- ( ph -> A =/= C ) $.
    $( Equivalence used in the proof of ~ angpieqvd .  (Contributed by David
       Moews, 28-Feb-2017.) $)
    angpieqvdlem $p |- ( ph -> ( -u ( ( C - B ) / ( A - B ) ) e. RR+ <->
                               ( ( C - B ) / ( C - A ) ) e. ( 0 (,) 1 ) ) ) $=
      ( cmin co cdiv cneg crp wcel c1 subcld subne0d oveq1d eqtrd divcld negcld
      caddc cc0 cioo ax-1cn a1i necomd subneintr2d divne1d negned xov1plusxeqvd
      cc divnegd negsubdi2d dividd divsubdird negsubd 3eqtr4rd nnncan2d oveq12d
      divcan7d div2subd 3eqtrrd eleq1d bitr4d ) ADCJKZBCJKZLKZMZNOVJPVJUCKZLKZU
      DPUEKZOVGDBJKLKZVMOAVJAVIAVGVHADCGFQZABCEFQZABCEFHRZUAZUBAVIPVRPUMOAUFUGZ
      AVGVHVOVPVQADBCGEFABDIUHUIUJUKULAVNVLVMAVLCDJKZVHLKZBDJKZVHLKZLKVTWBLKVNA
      VJWAVKWCLAVJVGMZVHLKWAAVGVHVOVPVQUNAWDVTVHLADCGFUOSTAVKVHVGJKZVHLKZWCAVHV
      HLKZVIJKPVIJKWFVKAWGPVIJAVHVPVQUPSAVHVGVHVPVOVPVQUQAPVIVSVRURUSAWEWBVHLAB
      DCEGFUTSTVAAVTWBVHACDFGQABDEGQVPABDEGIRVQVBACDBDFGEGIVCVDVEVF $.
  $}

  ${
    angpieqvd.angdef $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } ) |->
                           ( Im ` ( log ` ( y / x ) ) ) ) $.

    $d x y A $.  $d x y B $.  $d x y C $.
    angpieqvd.A $e |- ( ph -> A e. CC ) $.
    angpieqvd.B $e |- ( ph -> B e. CC ) $.
    angpieqvd.C $e |- ( ph -> C e. CC ) $.
    angpieqvd.AneB $e |- ( ph -> A =/= B ) $.
    angpieqvd.BneC $e |- ( ph -> B =/= C ) $.
    $( Equivalence used in ~ angpieqvd .  (Contributed by David Moews,
       28-Feb-2017.) $)
    angpieqvdlem2 $p |- ( ph -> ( -u ( ( C - B ) / ( A - B ) ) e. RR+
                             <-> ( ( A - B ) F ( C - B ) ) = pi ) ) $=
      ( cmin co wcel cfv cpi wceq subcld cdiv cneg crp clog cim cc0 wne subne0d
      cc wb divcld necomd divne0d lognegb syl2anc angvald eqeq1d bitr4d ) AFENO
      ZDENOZUAOZUBUCPZVAUDQUEQZRSZUTUSGOZRSAVAUIPVAUFUGVBVDUJAUSUTAFEKJTZADEIJT
      ZADEIJLUHZUKAUSUTVFVGAFEKJAEFMULUHZVHUMVAUNUOAVEVCRABCGUTUSHVGVHVFVIUPUQU
      R $.

    $( If the angle at ABC is ` pi ` , then A is not equal to C. (Contributed
       by David Moews, 28-Feb-2017.) $)
    angpined $p |- ( ph -> ( ( ( A - B ) F ( C - B ) ) = pi -> A =/= C ) ) $=
      ( cmin co wceq crp wcel wne c1 cpi cdiv angpieqvdlem2 wa wn 1rp cr cc0 wb
      cneg 1re ax-1ne0 rpneg mp2an mpbi cc subcld adantr subne0d simpr diveq1bd
      oveq1d adantlr negeqd simplr eqeltrrd necon3bd mpi necom syl6ib sylbird
      ex ) ADENOZFENOZGOUAPVNVMUBOZUJZQRZDFSZABCDEFGHIJKLMUCAVQFDSZVRAVQVSAVQUD
      ZTUJZQRZUEZVSTQRZWCUFTUGRTUHSWDWCUIUKULTUMUNUOVTWBFDVTFDPZWBVTWEUDZVPWAQW
      FVOTAWEVOTPVQAWEUDZVNVMAVMUPRWEADEIJUQURAVMUHSWEADEIJLUSURWGFDENAWEUTVBVA
      VCVDAVQWEVEVFVLVGVHVLFDVIVJVK $.


    $d w F $.  $d w ph $.  $d w A $.  $d w B $.  $d w C $.

    $( The angle ABC is ` pi ` iff B is a nontrivial convex combination of A
       and C, i.e., iff B is in the interior of the segment AC. (Contributed by
       David Moews, 28-Feb-2017.) $)
    angpieqvd $p |- ( ph -> ( ( ( A - B ) F ( C - B ) ) = pi <->
                     E. w e. ( 0 (,) 1 ) B = ( ( w x. A ) +
                                               ( ( 1 - w ) x. C ) ) ) ) $=
      ( co wceq cmul wcel adantr 3ad2ant1 cmin cpi cv c1 caddc cc0 cioo wrex wa
      cdiv cneg crp angpieqvdlem2 biimpar cc angpined angpieqvdlem mpbid subcld
      wne necomd subne0d divcan1d eqcomd divcld affineequiv mpbird oveq1 oveq1d
      imp oveq2 oveq12d eqeq2d rspcev syl2anc ex cr simpr elioore recn 3syl w3a
      simp3 3adant3 eqnetrrd mulne0bbd divmul3d simp2 subne0ad 3expia rexlimdva
      eqeltrd sylbid impbid ) AEFUAOZGFUAOZHOUBPZFDUCZEQOZUDWRUAOZGQOZUEOZPZDUF
      UDUGOZUHZAWQXEAWQUIZWPGEUAOZUJOZXDRZFXHEQOZUDXHUAOZGQOZUEOZPZXEXFWPWOUJOU
      KULRZXIAXOWQABCEFGHIJKLMNUMUNXFEFGAEUORZWQJSZAFUORZWQKSZAGUORZWQLSZAEFUTZ
      WQMSAWQEGUTABCEFGHIJKLMNUPVJZUQURXFXNWPXHXGQOZPXFYDWPXFWPXGAWPUORZWQAGFLK
      USZSZAXGUORZWQAGELJUSZSZXFGEYAXQXFEGYCVAVBZVCVDXFEFGXHXQXSYAXFWPXGYGYJYKV
      EVFVGXCXNDXHXDWRXHPZXBXMFYLWSXJXAXLUEWRXHEQVHYLWTXKGQWRXHUDUAVKVIVLVMVNVO
      VPAXCWQDXDAWRXDRZUIZXCWPWRXGQOZPZWQYNEFGWRAXPYMJSAXRYMKSAXTYMLSYNYMWRVQRW
      RUORZAYMVRWRUFUDVSWRVTWAZVFAYMYPWQAYMYPWBZXOWQYSXOXIYSXHWRXDYSXHWRPYPAYMY
      PWCZYSWPWRXGAYMYEYPYFTAYMYQYPYRWDZAYMYHYPYITZYSWRXGUUAUUBYSWPYOUFYTAYMWPU
      FUTYPAGFLKAFGNVAVBTWEWFZWGVGAYMYPWHWLYSEFGAYMXPYPJTZAYMXRYPKTZAYMXTYPLTZA
      YMYBYPMTZYSGEYSGEUUFUUDUUCWIVAUQVGYSBCEFGHIUUDUUEUUFUUGAYMFGUTYPNTUMURWJW
      MWKWN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y M $.  $d x y Q $.
    chordthmlem.angdef $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } )
                             |-> ( Im ` ( log ` ( y / x ) ) ) ) $.
    chordthmlem.A $e |- ( ph -> A e. CC ) $.
    chordthmlem.B $e |- ( ph -> B e. CC ) $.
    chordthmlem.Q $e |- ( ph -> Q e. CC ) $.
    chordthmlem.M $e |- ( ph -> M = ( ( A + B ) / 2 ) ) $.
    chordthmlem.ABequidistQ $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                          ( abs ` ( B - Q ) ) ) $.
    chordthmlem.AneB $e |- ( ph -> A =/= B ) $.
    chordthmlem.QneM $e |- ( ph -> Q =/= M ) $.
    $( If M is the midpoint of AB and AQ = BQ, then QMB is a right angle.  The
       proof uses ~ ssscongptld to observe that, since AMQ and BMQ have equal
       sides, the angles QMB and QMA must be equal.  Since they are
       supplementary, both must be right.  (Contributed by David Moews,
       28-Feb-2017.) $)
    chordthmlem $p |- ( ph -> ( ( Q - M ) F ( B - M ) ) e.
                              { ( pi / 2 ) , -u ( pi / 2 ) } ) $=
      ( co cfv wceq c2 cmin ccos cc0 cpi cdiv cneg cpr wcel negpitopissre caddc
      cioc cr addcld halfcld eqeltrd subcld subne0d cmul oveq1d times2d 2cn a1i
      cc 2ne0 divcan1d 3eqtr3d addneintr2d eqnetrd neneqd oveq12 anidms neneqad
      nsyl necomd angcld sseldi recnd coscld negsubdi2d addsubeq4d mpbid eqtr4d
      wne oveq2d cosangneg2d addneintrd neeqtrrd cabs eqidd absnegd ssscongptld
      fveq2d 3eqtr3rd eqnegad wb coseq0negpitopi syl ) AFHUAQZEHUAQZGQZUBRZUCSZ
      WTUDTUEQZXCUFUGUHZAXAAWTAWTAUDUFUDUKQZULWTUIABCGWRWSIAFHLAHDEUJQZTUEQZVCM
      AXFADEJKUMZUNUOZUPZAFHLXIPUQZAEHKXIUPZAEHKXIAHEAHEAHHUJQZEEUJQZSZHESZAXMX
      NAXMXFXNAHTURQXGTURQXMXFAHXGTURMUSAHXIUTAXFTXHTVCUHAVAVBTUCWCAVDVBVEVFZAD
      EEJKKOVGVHVIXPXOHEHEUJVJVKVMVLZVNUQZVOZVPVQVRAWRWSUFZGQZUBRWRDHUAQZGQZUBR
      XAUFXAAYBYDUBAYAYCWRGAYAHEUAQZYCAEHKXIVSAXMXFSYCYESXQAHHDEXIXIJKVTWAZWBWD
      WLABCGWRWSIXJXKXLXSWEABCFHDFHGEILXIJLXIKPAHDAXMDDUJQZSZHDSZAXMYGAYGXMAYGX
      FXMADDEJJKOWFXQWGVNVIYIYHHDHDUJVJVKVMVLPXRAWRWHRWIAYCUFZWHRYCWHRHDUAQZWHR
      YEWHRAYCADHJXIUPWJAYJYKWHADHJXIVSWLAYCYEWHYFWLVFNWKWMWNAWTXEUHXBXDWOXTWTW
      PWQWA $.
  $}

  ${
    $d x y Q $.  $d x y P $.  $d x y M $.  $d x y B $.  $d x y A $.
    chordthmlem2.angdef $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } )
                              |-> ( Im ` ( log ` ( y / x ) ) ) ) $.
    chordthmlem2.A $e |- ( ph -> A e. CC ) $.
    chordthmlem2.B $e |- ( ph -> B e. CC ) $.
    chordthmlem2.Q $e |- ( ph -> Q e. CC ) $.
    chordthmlem2.X $e |- ( ph -> X e. RR ) $.
    chordthmlem2.M $e |- ( ph -> M = ( ( A + B ) / 2 ) ) $.
    chordthmlem2.P $e |- ( ph -> P = ( ( X x. A ) + ( ( 1 - X ) x. B ) ) ) $.
    chordthmlem2.ABequidistQ $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                           ( abs ` ( B - Q ) ) ) $.
    chordthmlem2.PneM $e |- ( ph -> P =/= M ) $.
    chordthmlem2.QneM $e |- ( ph -> Q =/= M ) $.
    $( If M is the midpoint of AB, AQ = BQ, and P is on the line AB, then QMP
       is a right angle.  This is proven by reduction to the special case
       ~ chordthmlem , where P = B, and using ~ angrtmuld to observe that QMP
       is right iff QMB is.  (Contributed by David Moews, 28-Feb-2017.) $)
    chordthmlem2 $p |- ( ph -> ( ( Q - M ) F ( P - M ) ) e.
                               { ( pi / 2 ) , -u ( pi / 2 ) } ) $=
      ( cmin co cpi c2 cdiv cneg cpr wcel c1 2re a1i cc0 2ne0 rereccld resubcld
      cr wne recnd subcld cmul subdird caddc 2cn divcan4d times2d oveq1d eqtr3d
      cc oveq12d addcld divsubdird pnpcan2d 3eqtr2d divrec2d wceq mulcld ax-1cn
      eqeltrd affineequiv halfcld nnncan1d 3eqtr2rd eqnetrrd mulne0bbd subne0ad
      eqtrd mpbid subne0d necomd chordthmlem recne0d mulne0d mulne0bad redivcld
      eqnetrd divcan5rd angrtmuld mpbird ) AGIUAUBZFIUAUBZHUBUCUDUEUBZXAUFUGZUH
      WSEIUAUBZHUBXBUHABCDEGHIKLMNPRAEDAEDMLAUIUDUEUBZJUAUBZEDUAUBZAXEAXDJAUDUD
      UPUHAUJUKUDULUQAUMUKZUNZOUOZURZAEDMLUSZAWTXEXFUTUBZULAXLXDXFUTUBZJXFUTUBZ
      UAUBXCEFUAUBZUAUBWTAXDJXFAXDXHURZAJOURZXKVAAXCXMXOXNUAAXCXFUDUEUBZXMAXCEE
      VBUBZUDUEUBZDEVBUBZUDUEUBZUAUBXSYAUAUBZUDUEUBXRAEXTIYBUAAEUDUTUBZUDUEUBEX
      TAEUDMUDVHUHAVCUKZXGVDAYDXSUDUEAEMVEVFVGPVIAXSYAUDAEEMMVJADELMVJZYEXGVKAY
      CXFUDUEAEDEMLMVLVFVMAXFUDXKYEXGVNWFZAFJDUTUBZUIJUAUBZEUTUBZVBUBZVOXOXNVOQ
      ADFEJLAFYKVHQAYHYJAJDXQLVPAYIEAUIJUIVHUHAVQUKXQUSMVPVJVRZMXQVSWGVIAEIFMAI
      YBVHPAYAYFVTVRZYLWAWBZAFIYLYMSWHZWCZWDZWEWITWJABCHWSWTXCKAGINYMUSAFIYLYMU
      SAEIMYMUSAGINYMTWHYOAXCXMULYGAXDXFXPXKAUDYEXGWKYQWLWOAXCWTUEUBZXDXEUEUBZU
      PAYRXMXLUEUBYSAXCXMWTXLUEYGYNVIAXDXEXFXPXJXKAXEXFXJXKYPWMZYQWPWFAXDXEXHXI
      YTWNVRWQWR $.
  $}

  ${
    $d x y Q $.  $d x y P $.  $d x y M $.  $d x y B $.  $d x y A $.
    chordthmlem3.A $e |- ( ph -> A e. CC ) $.
    chordthmlem3.B $e |- ( ph -> B e. CC ) $.
    chordthmlem3.Q $e |- ( ph -> Q e. CC ) $.
    chordthmlem3.X $e |- ( ph -> X e. RR ) $.
    chordthmlem3.M $e |- ( ph -> M = ( ( A + B ) / 2 ) ) $.
    chordthmlem3.P $e |- ( ph -> P = ( ( X x. A ) + ( ( 1 - X ) x. B ) ) ) $.
    chordthmlem3.ABequidistQ $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                           ( abs ` ( B - Q ) ) ) $.
    $( If M is the midpoint of AB, AQ = BQ, and P is on the line AB, then
       PQ<HTML><sup>2</sup></HTML> = QM<HTML><sup>2</sup></HTML> ` + `
       PM<HTML><sup>2</sup></HTML>.  This follows from ~ chordthmlem2 and the
       Pythagorean theorem ( ~ pythag ) in the case where P and Q are unequal
       to M. If either P or Q equals M, the result is trivial.  (Contributed
       by David Moews, 28-Feb-2017.) $)
    chordthmlem3 $p |- ( ph -> ( ( abs ` ( P - Q ) ) ^ 2 ) =
                                ( ( ( abs ` ( Q - M ) ) ^ 2 ) +
                                  ( ( abs ` ( P - M ) ) ^ 2 ) ) ) $=
      ( cmin co cabs cc wcel adantr vx vy cfv c2 cexp caddc wceq wa cdiv addcld
      cc0 halfcld eqeltrd subcld abscld recnd addid1d cmul c1 mulcld ax-1cn a1i
      sqcld simpr subeq0bd abs00bd oveq2d abssubd fveq2d eqtr3d oveq1d 3eqtr4rd
      sq0id addid2d wne csn cdif clog cim cmpt2 cpi cneg cpr simprl simprr eqid
      cv cr chordthmlem2 pythag syl321anc pm2.61da2ne ) ADEOPZQUCZUDUEPZEFOPZQU
      CZUDUEPZDFOPZQUCZUDUEPZUFPZUGZDFEFADFUGZUHZWRUKUFPWRXBWOXEWRAWRRSXDAWQAWQ
      AWPAEFJAFBCUFPZUDUIPZRLAXFABCHIUJULUMZUNUOUPVCTUQXEXAUKWRUFXEWTXEWSXEDFAD
      RSZXDADGBURPZUSGOPZCURPZUFPZRMAXJXLAGBAGKUPZHUTAXKCAUSGUSRSAVAVBXNUNIUTUJ
      UMZTZAXDVDZVEVFVMVGXEWNWQUDUEXEEDOPZQUCWNWQXEEDAERSZXDJTXPVHXEXRWPQXEDFEO
      XQVGVIVJVKVLAEFUGZUHZUKXAUFPXAXBWOYAXAAXARSXTAWTAWTAWSADFXOXHUNUOUPVCTVNY
      AWRUKXAUFYAWQYAWPYAEFAXSXTJTAXTVDZVEVFVMVKYAWNWTUDUEYAWMWSQYAEFDOYBVGVIVK
      VLADFVOZEFVOZUHZUHZXIXSFRSZYCYDWPWSUAUBRUKVPVQZYHUBWGUAWGUIPVRUCVSUCVTZPZ
      WAUDUIPZYKWBWCSXCAXIYEXOTAXSYEJTZAYGYEXHTAYCYDWDZAYCYDWEZYFUAUBBCDEYIFGYI
      WFZABRSYEHTACRSYEITYLAGWHSYEKTAFXGUGYELTADXMUGYEMTABEOPQUCCEOPQUCUGYENTYM
      YNWIUAUBDEFYIYJWQWTWNYOWQWFWTWFWNWFYJWFWJWKWL $.
  $}


  ${
    chordthmlem4.A $e |- ( ph -> A e. CC ) $.
    chordthmlem4.B $e |- ( ph -> B e. CC ) $.
    chordthmlem4.X $e |- ( ph -> X e. ( 0 [,] 1 ) ) $.
    chordthmlem4.M $e |- ( ph -> M = ( ( A + B ) / 2 ) ) $.
    chordthmlem4.P $e |- ( ph -> P = ( ( X x. A ) + ( ( 1 - X ) x. B ) ) ) $.
    $( If P is on the segment AB and M is the midpoint of AB, then PA ` x. `
       PB = BM<HTML><sup>2</sup></HTML> ` - ` PM<HTML><sup>2</sup></HTML>.
       If all lengths are reexpressed as fractions of AB, this reduces to the
       identity ` X x. ( 1 - X ) = ( 1 / 2 )`<HTML><sup>2</sup></HTML>
       ` - ( ( 1 / 2 ) - X )`<HTML><sup>2</sup></HTML>.  (Contributed by
       David Moews, 28-Feb-2017.) $)
    chordthmlem4 $p |- ( ph -> ( ( abs ` ( P - A ) ) x. ( abs ` ( P - B ) ) ) =
                                ( ( ( abs ` ( B - M ) ) ^ 2 ) -
                                  ( ( abs ` ( P - M ) ) ^ 2 ) ) ) $=
      ( cmin co cabs cfv cmul c1 c2 cexp wcel cr 1re a1i cicc unitssre resubcld
      sseldi recnd abscld subcld mul4d caddc wceq cc mulcld addcld affineequiv2
      cc0 eqeltrd mpbid fveq2d absmuld eqtrd abssubd affineequiv 3eqtrd oveq12d
      sqvald oveq2d 3eqtr4d cdiv halfcld sqcld subdird subsq syl2anc addsubassd
      rehalfcld 2halvesd oveq1d eqtr3d nncand eqtr2d cle wbr w3a elicc2i simp3d
      0re abssubge0d simp2d absidd absresq syl 2cn wne 2ne0 divcan4d divsubdird
      sylib times2d pnpcan2d 3eqtr2d divrec2d clt halfgt0 ltled sqmuld nnncan1d
      3eqtr2rd 3eqtr4rd eqtr4d ) ADBLMZNOZDCLMNOZPMZQFLMZNOZFNOZPMZCBLMZNOZRSMZ
      PMZCELMZNOZRSMZDELMZNOZRSMZLMZAXRYBPMZXSYBPMZPMXTYBYBPMZPMXPYDAXRYBXSYBAX
      RAXQAXQAQFQUATAUBUCZAURQUDMZUAFUEIUGZUFUHZUIUHAYBAYAACBHGUJZUIUHZAXSAFAFY
      QUHZUIUHYTUKAXNYLXOYMPAXNXQYAPMZNOYLAXMUUBNADFBPMZXQCPMZULMZUMZXMUUBUMKAB
      DCFGADUUEUNKAUUCUUDAFBUUAGUOAXQCYRHUOUPUSZHUUAUQUTVAAXQYAYRYSVBVCAXOCDLMZ
      NOFYAPMZNOYMADCUUGHVDAUUHUUINAUUFUUHUUIUMKABDCFGUUGHUUAVEUTZVAAFYAUUAYSVB
      VFVGAYCYNXTPAYBYTVHVIVJAQRVKMZRSMZUUKFLMZNOZRSMZLMZYCPMUULYCPMZUUOYCPMZLM
      YDYKAUULUUOYCAUUKAQAQYOUHZVLZVMAUUNAUUNAUUMAUUMAUUKFAQYOVRZYQUFZUHZUIUHZV
      MAYBYTVMVNAXTUUPYCPAXQFPMZUULUUMRSMZLMZXTUUPAUVGUUKUUMULMZUUKUUMLMZPMZUVE
      AUUKUNTUUMUNTUVGUVJUMUUTUVCUUKUUMVOVPAUVHXQUVIFPAUUKUUKULMZFLMUVHXQAUUKUU
      KFUUTUUTUUAVQAUVKQFLAQUUSVSVTWAAUUKFUUTUUAWBVGWCAXRXQXSFPAFQYQYOAFUATZURF
      WDWEZFQWDWEZAFYPTUVLUVMUVNWFIURQFWIUBWGWTZWHWJAFYQAUVLUVMUVNUVOWKWLVGAUUO
      UVFUULLAUUMUATUUOUVFUMUVBUUMWMWNVIVJVTAYGUUQYJUURLAYGUUKYBPMZRSMUUQAYFUVP
      RSAYFUUKYAPMZNOUUKNOZYBPMUVPAYEUVQNAYEYARVKMZUVQAYECCULMZRVKMZBCULMZRVKMZ
      LMUVTUWBLMZRVKMUVSACUWAEUWCLACRPMZRVKMCUWAACRHRUNTAWOUCZRURWPAWQUCZWRAUWE
      UVTRVKACHXAVTWAJVGAUVTUWBRACCHHUPABCGHUPZUWFUWGWSAUWDYARVKACBCHGHXBVTXCAY
      ARYSUWFUWGXDVCZVAAUUKYAUUTYSVBAUVRUUKYBPAUUKUVAAURUUKURUATAWIUCUVAURUUKXE
      WEAXFUCXGWLVTVFVTAUUKYBUUTYTXHVCAYJUUNYBPMZRSMUURAYIUWJRSAYIUUMYAPMZNOUWJ
      AYHUWKNAUWKUVQUUILMYEUUHLMYHAUUKFYAUUTUUAYSVNAYEUVQUUHUUILUWIUUJVGACEDHAE
      UWCUNJAUWBUWHVLUSUUGXIXJVAAUUMYAUVCYSVBVCVTAUUNYBUVDYTXHVCVGXKXL $.
  $}

  ${
    chordthmlem5.A $e |- ( ph -> A e. CC ) $.
    chordthmlem5.B $e |- ( ph -> B e. CC ) $.
    chordthmlem5.Q $e |- ( ph -> Q e. CC ) $.
    chordthmlem5.X $e |- ( ph -> X e. ( 0 [,] 1 ) ) $.
    chordthmlem5.P $e |- ( ph -> P = ( ( X x. A ) + ( ( 1 - X ) x. B ) ) ) $.
    chordthmlem5.ABequidistQ $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                           ( abs ` ( B - Q ) ) ) $.
    $( If P is on the segment AB and AQ = BQ, then PA ` x. ` PB =
       BQ<HTML><sup>2</sup></HTML> ` - ` PQ<HTML><sup>2</sup></HTML>.  This
       follows from two uses of ~ chordthmlem3 to show that
       PQ<HTML><sup>2</sup></HTML> = QM<HTML><sup>2</sup></HTML> ` + `
       PM<HTML><sup>2</sup></HTML> and BQ<HTML><sup>2</sup></HTML> =
       QM<HTML><sup>2</sup></HTML> ` + ` BM<HTML><sup>2</sup></HTML>, so
       BQ<HTML><sup>2</sup></HTML> ` - ` PQ<HTML><sup>2</sup></HTML> =
       (QM<HTML><sup>2</sup></HTML> ` + ` BM<HTML><sup>2</sup></HTML>) ` - `
       (QM<HTML><sup>2</sup></HTML> ` + ` PM<HTML><sup>2</sup></HTML>) =
       BM<HTML><sup>2</sup></HTML> ` - ` PM<HTML><sup>2</sup></HTML>,
       which equals PA ` x. ` PB by ~ chordthmlem4 .  (Contributed by David
       Moews, 28-Feb-2017.) $)
    chordthmlem5 $p |- ( ph -> ( ( abs ` ( P - A ) ) x. ( abs ` ( P - B ) ) ) =
                                ( ( ( abs ` ( B - Q ) ) ^ 2 ) -
                                  ( ( abs ` ( P - Q ) ) ^ 2 ) ) ) $=
      ( caddc co cmin cabs cfv cmul c1 cc0 c2 cdiv addcld halfcld subcld abscld
      cexp recnd sqcld cc cicc cr unitssre sseldi mulcld ax-1cn eqeltrd pnpcand
      wcel a1i eqidd mul02d subid1d oveq1d mulid2d eqtrd oveq12d addid2d eqtr2d
      0re chordthmlem3 chordthmlem4 3eqtr4rd ) AEBCMNZUAUBNZONZPQZUAUGNZCVOONZP
      QZUAUGNZMNZVRDVOONZPQZUAUGNZMNZONWAWEONCEONPQUAUGNZDEONPQUAUGNZONDBONPQDC
      ONPQRNAVRWAWEAVQAVQAVPAEVOIAVNABCGHUCUDZUEUFUHUIAVTAVTAVSACVOHWIUEUFUHUIA
      WDAWDAWCADVOADFBRNZSFONZCRNZMNUJKAWJWLAFBAFATSUKNULFUMJUNZUHZGUOAWKCASFSU
      JUSAUPUTZWNUEHUOUCUQWIUEUFUHUIURAWGWBWHWFOABCCEVOTGHITULUSAVJUTAVOVAZATBR
      NZSTONZCRNZMNTCMNCAWQTWSCMABGVBAWSSCRNCAWRSCRASWOVCVDACHVEVFVGACHVHVILVKA
      BCDEVOFGHIWMWPKLVKVGABCDVOFGHJWPKVLVM $.
  $}

  ${
    $d A v w x y $.  $d B v w x y $.  $d C v w x y $.  $d D v w x y $.
    $d F v w $.  $d ph v w $.  $d P v w x y $.
    chordthm.angdef $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } ) |->
                          ( Im ` ( log ` ( y / x ) ) ) ) $.
    chordthm.A $e |- ( ph -> A e. CC ) $.
    chordthm.B $e |- ( ph -> B e. CC ) $.
    chordthm.C $e |- ( ph -> C e. CC ) $.
    chordthm.D $e |- ( ph -> D e. CC ) $.
    chordthm.P $e |- ( ph -> P e. CC ) $.
    chordthm.AneP $e |- ( ph -> A =/= P ) $.
    chordthm.BneP $e |- ( ph -> B =/= P ) $.
    chordthm.CneP $e |- ( ph -> C =/= P ) $.
    chordthm.DneP $e |- ( ph -> D =/= P ) $.
    chordthm.APB $e |- ( ph -> ( ( A - P ) F ( B - P ) ) = pi ) $.
    chordthm.CPD $e |- ( ph -> ( ( C - P ) F ( D - P ) ) = pi ) $.
    chordthm.Q $e |- ( ph -> Q e. CC ) $.
    chordthm.ABcirc $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                  ( abs ` ( B - Q ) ) ) $.
    chordthm.ACcirc $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                  ( abs ` ( C - Q ) ) ) $.
    chordthm.ADcirc $e |- ( ph -> ( abs ` ( A - Q ) ) =
                                  ( abs ` ( D - Q ) ) ) $.
    $( The intersecting chords theorem.

       If points A, B, C, and D lie on a circle (with center Q, say), and
       the point P is on the interior of the segments AB and CD, then the two
       products of lengths PA ` x. ` PB and PC ` x. ` PD are equal.

       The Euclidean plane is identified with the complex plane, and the fact
       that P is on AB and on CD is expressed by the hypothesis that the angles
       APB and CPD are equal to ` pi ` .

       The result is proven by using ~ chordthmlem5 twice to show that PA
       ` x. ` PB and PC ` x. ` PD both equal BQ<HTML><sup>2</sup></HTML> ` - `
       PQ<HTML><sup>2</sup></HTML>.
       This is similar to the proof of the theorem given in Euclid's
       _Elements_, where it is Proposition III.35.  (Contributed by David
       Moews, 28-Feb-2017.) $)
    chordthm $p |- ( ph -> ( ( abs ` ( P - A ) ) x. ( abs ` ( P - B ) ) )
                         = ( ( abs ` ( P - C ) ) x. ( abs ` ( P - D ) ) ) ) $=
      ( vv vw cv cmul co cmin caddc wceq cabs cfv cc0 cioo cpi necomd angpieqvd
      c1 wrex mpbid wcel wa adantr c2 cexp ad2antrr eqtr3d oveq1d cicc ioossicc
      cc simprl sseldi simprr chordthmlem5 simplrl simplrr 3eqtr4d rexlimddv )
      AHUGUIZFUJUKVBWDULUKGUJUKUMUKUNZHDULUKUOUPHEULUKUOUPUJUKZHFULUKUOUPHGULUK
      UOUPUJUKZUNZUGUQVBURUKZAFHULUKGHULUKJUKUSUNWEUGWIVCUBABCUGFHGJKNPOSAGHTUT
      VAVDAWDWIVEZWEVFZVFZHUHUIZDUJUKVBWMULUKEUJUKUMUKUNZWHUHWIAWNUHWIVCZWKADHU
      LUKEHULUKJUKUSUNWOUAABCUHDHEJKLPMQAEHRUTVAVDVGWLWMWIVEZWNVFZVFZEIULUKUOUP
      ZVHVIUKZHIULUKUOUPVHVIUKZULUKGIULUKUOUPZVHVIUKZXAULUKWFWGWRWTXCXAULWRWSXB
      VHVIWRDIULUKUOUPZWSXBAXDWSUNWKWQUDVJZAXDXBUNWKWQUFVJZVKVLVLWRDEHIWMADVOVE
      WKWQLVJAEVOVEWKWQMVJAIVOVEWKWQUCVJZWRWIUQVBVMUKZWMUQVBVNZWLWPWNVPVQWLWPWN
      VRXEVSWRFGHIWDAFVOVEWKWQNVJAGVOVEWKWQOVJXGWRWIXHWDXIAWJWEWQVTVQAWJWEWQWAW
      RXDFIULUKUOUPZXBAXDXJUNWKWQUEVJXFVKVSWBWCWC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Solutions of quadratic, cubic, and quartic equations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    quad.a $e |- ( ph -> A e. CC ) $.
    quad.z $e |- ( ph -> A =/= 0 ) $.
    quad.b $e |- ( ph -> B e. CC ) $.
    quad.c $e |- ( ph -> C e. CC ) $.
    quad.x $e |- ( ph -> X e. CC ) $.
    ${
      quad2.d $e |- ( ph -> D e. CC ) $.
      quad2.2 $e |- ( ph ->
        ( D ^ 2 ) = ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) ) $.
      $( The quadratic equation, without specifying the particular branch ` D `
         to the square root.  (Contributed by Mario Carneiro, 23-Apr-2015.) $)
      quad2 $p |- ( ph -> ( ( ( A x. ( X ^ 2 ) ) + ( ( B x. X ) + C ) ) = 0 <->
        ( X = ( ( -u B + D ) / ( 2 x. A ) ) \/
          X = ( ( -u B - D ) / ( 2 x. A ) ) ) ) ) $=
        ( c2 co cmul caddc wceq cc wcel cexp cc0 cneg cmin wo 2cn mulcl sylancr
        cdiv mulcld addcld sqcld subeq0ad c4 0cn a1i 4cn wne 4nn nnne0i mulne0d
        mulcand addassd pnncand sqmuld sq2 sqvald oveq12d sqmul mulassd 3eqtr4d
        oveq1d 3eqtrrd adddid 2t2e4 oveq1i syl5eqr eqtrd mul32d oveq2d 3eqtr4rd
        3eqtr3d binom2 syl2anc addcomd mul01d eqeq12d bitr3d subnegd 3bitr4d wb
        eqeq1d negcld subcld sqeqor subaddd 2ne0 divmuld 3bitr4g bitr4d negsubd
        eqcom orbi12d 3bitrd ) ABFNUAOZPOZCFPOZDQOZQOZUBRZNBPOZFPOZCUCZUDOZNUAO
        ZENUAOZRZXNERZXNEUCZRZUEZFXMEQOZXKUIOZRZFXMEUDOZXKUIOZRZUEAXLCQOZNUAOZX
        PUDOZUBRZYIXPRXJXQAYIXPAYHAXLCAXKFANSTZBSTZXKSTUFGNBUGUHZKUJZIUKULAELUL
        UMAUNBPOZXIPOZYPUBPOZRXJYKAXIUBYPAXFXHABXEGAFKULZUJZAXGDACFIKUJZJUKZUKU
        BSTAUOUPAUNSTZYMYPSTUQGUNBUGUHZAUNBUUCAUQUPZGUNUBURAUNUSUTUPHVAVBAYQYJY
        RUBAYPXFPOZYPXHPOZQOZCNUAOZXLNUAOZNXLCPOZPOZQOZQOZUUIUNBDPOZPOZUDOZUDOZ
        YQYJAUUMUUPQOUUJUULUUPQOZQOUURUUHAUUJUULUUPAXLYOULZAYLUUKSTUULSTUFAXLCY
        OIUJNUUKUGUHZAUUCUUOSTUUPSTUQABDGJUJUNUUOUGUHZVCAUUIUUMUUPACIULZAUUJUUL
        UUTUVAUKZUVBVDAUUFUUJUUGUUSQAUUJXKNUAOZXEPOYPBPOZXEPOUUFAXKFYNKVEAUVEUV
        FXEPANNUAOZBNUAOZPOZUNBBPOZPOUVEUVFAUVGUNUVHUVJPUVGUNRAVFUPABGVGVHAYLYM
        UVEUVIRUFGNBVIUHAUNBBUUEGGVJVKVLAYPBXEUUDGYSVJVMAUUGYPXGPOZYPDPOZQOUUSA
        YPXGDUUDUUAJVNAUVKUULUVLUUPQAYPCPOZFPOZNXKCPOZFPOZPOZUVKUULAUVNNUVOPOZF
        POUVQAUVMUVRFPAUVMNXKPOZCPOUVRAYPUVSCPAYPNNPOZBPOUVSUVTUNBPVOVPANNBYLAU
        FUPZUWAGVJVQVLANXKCUWAYNIVJVRVLANUVOFUWAAXKCYNIUJKVJVRAYPCFUUDIKVJAUVPU
        UKNPAXKCFYNIKVSVTWBAUNBDUUEGJVJVHVRVHWAAYPXFXHUUDYTUUBVNAYIUUNXPUUQUDAY
        IUUMUUIQOZUUNAXLSTCSTYIUWBRYOIXLCWCWDAUUMUUIUVDUVCWEVRMVHVKAYPUUDWFWGWH
        AXOYIXPAXNYHNUAAXLCYOIWIVLWLWJAXNSTESTXQYAWKAXLXMYOACIWMZWNLXNEWOWDAXRY
        DXTYGAXRYBXLRZYDAXLXMEYOUWCLWPAYCFRXLYBRYDUWDAYBXKFAXMEUWCLUKYNKANBUWAG
        NUBURAWQUPHVAZWRFYCXBYBXLXBWSWTAXMXSQOZXLRYEXLRZXTYGAUWFYEXLAXMEUWCLXAW
        LAXLXMXSYOUWCAELWMWPAYFFRXLYERYGUWGAYEXKFAXMEUWCLWNYNKUWEWRFYFXBYEXLXBW
        SWJXCXD $.
    $}

    quad.d $e |- ( ph -> D = ( ( B ^ 2 ) - ( 4 x. ( A x. C ) ) ) ) $.
    $( The quadratic equation.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    quad $p |- ( ph -> ( ( ( A x. ( X ^ 2 ) ) + ( ( B x. X ) + C ) ) = 0 <->
      ( X = ( ( -u B + ( sqr ` D ) ) / ( 2 x. A ) ) \/
        X = ( ( -u B - ( sqr ` D ) ) / ( 2 x. A ) ) ) ) ) $=
      ( csqr c2 cexp co c4 cmul cc wcel cfv cmin sqcld 4cn mulcld mulcl sylancr
      subcld eqeltrd sqrcld sqsqrd eqtrd quad2 ) ABCDEMUAZFGHIJKAEAECNOPZQBDRPZ
      RPZUBPZSLAUOUQACIUCAQSTUPSTUQSTUDABDGJUEQUPUFUGUHUIZUJAUNNOPEURAEUSUKLULU
      M $.
  $}

  $( The cube roots of unity.  (Contributed by Mario Carneiro, 23-Apr-2015.) $)
  1cubrlem $p |-
      ( ( -u 1 ^c ( 2 / 3 ) ) = ( ( -u 1 + ( _i x. ( sqr ` 3 ) ) ) / 2 ) /\
  ( ( -u 1 ^c ( 2 / 3 ) ) ^ 2 ) = ( ( -u 1 - ( _i x. ( sqr ` 3 ) ) ) / 2 ) ) $=
    ( c1 c2 c3 cdiv co ci cfv cmul caddc wceq cpi cc wcel neg1cn cr c6 2cn 2ne0
    ax-mp ccj cneg ccxp csqr cexp cmin ce cc0 wne ax-1cn ax-1ne0 negne0i cn 2re
    clog nndivre mp2an recni cxpef mp3an logm1 oveq2i ax-icn pire mul12i fveq2i
    3nn eqtri ccos 6nn coshalfpip divrec2 nncni nnne0i oveq12i reccli halfpm6th
    csin adddiri simpri oveq1i 3eqtr2i sincos6thpi simpli negeqi divneg 3eqtr3i
    sinhalfpip cle wbr 3re nn0ge0i resqrcl divassi eqtr4i mulcli efival divdiri
    3nn0 3eqtr4i 3eqtri cz root1cj cxpcl exp1 addcli cjdivi cjaddi 1re renegcli
    1z cjre cjmuli cji mulneg1i negsubi 3m1e2 3eqtr3ri pm3.2i ) AUAZBCDEZUBEZXS
    FCUCGZHEZIEZBDEZJYABUDEZXSYCUEEZBDEZJYAXTXSUNGZHEZUFGZFXTKHEZHEZUFGZYEXSLMZ
    XSUGUHXTLMZYAYKJNAUIUJUKXTBOMZCULMZXTOMUMVFBCUOUPUQZXSXTURUSYJYMUFYJXTFKHEZ
    HEYMYIYTXTHUTVAXTFKYSVBKVCUQZVDVGVEYLVHGZFYLVQGZHEZIEZXSBDEZYCBDEZIEYNYEUUB
    UUFUUDUUGIKBDEZKPDEZIEZVHGZUUIVQGZUAZUUBUUFUUILMZUUKUUMJUUIKOMPULMUUIOMVCVI
    KPUOUPUQZUUIVJSUUJYLVHUUJABDEZKHEZAPDEZKHEZIEUUPUURIEZKHEYLUUHUUQUUIUUSIKLM
    ZBLMZBUGUHZUUHUUQJUUAQRKBVKUSUVAPLMPUGUHUUIUUSJUUAPVIVLZPVIVMZKPVKUSVNUUPUU
    RKBQRVOPUVDUVEVOUUAVRUUTXTKHUUPUURUEEACDEJUUTXTJVPVSVTWAZVEUUMUUPUAZUUFUULU
    UPUULUUPJZUUIVHGZYBBDEZJZWBWCWDALMUVBUVCUVGUUFJUIQRABWEUSVGWFUUDFUVJHEUUGUU
    CUVJFHUUJVQGZUVIUUCUVJUUNUVLUVIJUUOUUIWGSUUJYLVQUVFVEUVHUVKWBVSWFVAFYBBVBYB
    COMUGCWHWIYBOMZWJCWRWKCWLUPZUQZQRWMWNVNYLLMYNUUEJXTKYSUUAWOYLWPSXSYCBNFYBVB
    UVOWOZQRWQWSWTZYAAUDEZTGZYACAUEEZUDEZYHYFYRAXAMUVSUWAJVFXJACXBUPUVSYETGZYDT
    GZBTGZDEZYHUVRYETUVRYAYEYALMZUVRYAJYOYPUWFNYSXSXTXCUPYAXDSUVQVGVEUVCUWBUWEJ
    RYDBXSYCNUVPXEQXFSUWCYGUWDBDUWCXSTGZYCTGZIEXSYCUAZIEYGXSYCNUVPXGUWGXSUWHUWI
    IXSOMUWGXSJAXHXIXSXKSUWHFTGZYBTGZHEFUAZYBHEUWIFYBVBUVOXLUWJUWLUWKYBHXMUVMUW
    KYBJUVNYBXKSVNFYBVBUVOXNWTVNXSYCNUVPXOWTYQUWDBJUMBXKSVNWTUVTBYAUDXPVAXQXR
    $.

  ${
    $d n A $.
    1cubr.r $e |- R = { 1 ,
      ( ( -u 1 + ( _i x. ( sqr ` 3 ) ) ) / 2 ) ,
      ( ( -u 1 - ( _i x. ( sqr ` 3 ) ) ) / 2 ) } $.
    $( The cube roots of unity.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    1cubr $p |- ( A e. R <-> ( A e. CC /\ ( A ^ 3 ) = 1 ) ) $=
      ( vn wcel cc c3 cexp co c1 wceq cmul caddc ax-1cn ax-mp cc0 syl6eq oveq2d
      c2 cdiv wa cneg csqr cfv cmin ctp w3a wss neg1cn ax-icn 3cn mulcli addcli
      ci sqrcl halfcl subcli 3pm3.2i elexi ovex tpss mpbi eqsstri pm4.71ri ccxp
      sseli cv cfz wrex cn 3nn cxpeq mp3an23 w3o eltpg eleq2i 3m1e2 2cn addid2i
      wb eqtr4i oveq2i cz 0z fztp eqtri rexeqi 3ne0 reccli oveq1i eqeq2i rexbii
      1cxp oveq2 divcli cxpcl mp2an exp0 eqeq2d id exp1 mulid2i 1cubrlem simpli
      1t1e1 sqcli simpri rextp 3bitri 3bitr4g bitr4d pm5.32i bitr4i ) ABEZAFEZX
      NUAXOAGHIJKZUAXNXOBFABJJUBZUNGUCUDZLIZMIZSTIZXQXSUEIZSTIZUFZFCJFEZYAFEZYC
      FEZUGYDFUHYEYFYGNXTFEYFXQXSUIUNXRUJGFEXRFEUKGUOOULZUMXTUPOYBFEYGXQXSUIYHU
      QYBUPOURJYAYCFJFNUSXTSTUTYBSTUTVAVBVCVFVDXOXPXNXOXPAJJGTIZVEIZXQSGTIZVEIZ
      DVGZHIZLIZKZDPGJUEIZVHIZVIZXNXOGVJEYEXPYSVTVKNAJDGVLVMXOAYDEAJKZAYAKZAYCK
      ZVNZXNYSAJYAYCFVOBYDACVPYSYPDPPJMIZPSMIZUFZVIAJYNLIZKZDUUFVIUUCYPDYRUUFYR
      PUUEVHIZUUFYQUUEPVHYQSUUEVQSVRVSZWAWBPWCEUUIUUFKWDPWEOWFWGYPUUHDUUFYOUUGA
      YJJYNLYIFEYJJKGUKWHWIYIWMOWJWKWLUUHYTUUAUUBDPUUDUUEPWCWDUSPJMUTPSMUTYMPKZ
      UUGJAUUKUUGJJLIJUUKYNJJLUUKYNYLPHIZJYMPYLHWNYLFEZUULJKXQFEYKFEUUMUISGVRUK
      WHWOXQYKWPWQZYLWROQRXEQWSYMUUDKZUUGYAAUUOUUGJYLLIZYAUUOYNYLJLUUOYNYLJHIZY
      LUUOYMJYLHUUOYMUUDJUUOWTJNVSQRUUMUUQYLKUUNYLXAOQRUUPYLYAYLUUNXBYLYAKZYLSH
      IZYCKZXCXDWFQWSYMUUEKZUUGYCAUVAUUGJUUSLIZYCUVAYNUUSJLUVAYMSYLHUVAYMUUESUV
      AWTUUJQRRUVBUUSYCUUSYLUUNXFXBUURUUTXCXGWFQWSXHXIXJXKXLXM $.
  $}

  ${
    $d r u M $.  $d r u P $.  $d r u ph $.  $d r u Q $.  $d r u T $.  $d r U $.
    $d r u X $.
    dcubic.c $e |- ( ph -> P e. CC ) $.
    dcubic.d $e |- ( ph -> Q e. CC ) $.
    dcubic.x $e |- ( ph -> X e. CC ) $.
    dcubic.t $e |- ( ph -> T e. CC ) $.
    dcubic.3 $e |- ( ph -> ( T ^ 3 ) = ( G - N ) ) $.
    dcubic.g $e |- ( ph -> G e. CC ) $.
    dcubic.2 $e |- ( ph -> ( G ^ 2 ) = ( ( N ^ 2 ) + ( M ^ 3 ) ) ) $.
    dcubic.m $e |- ( ph -> M = ( P / 3 ) ) $.
    dcubic.n $e |- ( ph -> N = ( Q / 2 ) ) $.
    dcubic.0 $e |- ( ph -> T =/= 0 ) $.
    ${
      dcubic2.u $e |- ( ph -> U e. CC ) $.
      dcubic2.z $e |- ( ph -> U =/= 0 ) $.
      dcubic2.2 $e |- ( ph -> X = ( U - ( M / U ) ) ) $.
      $( Lemma for ~ dcubic1 and ~ dcubic2 : simplify the cubic equation under
         the substitution ` X = U - M / U ` .  (Contributed by Mario Carneiro,
         26-Apr-2015.) $)
      dcubic1lem $p |- ( ph -> ( ( ( X ^ 3 ) + ( ( P x. X ) + Q ) ) = 0 <->
        ( ( ( U ^ 3 ) ^ 2 ) + ( ( Q x. ( U ^ 3 ) ) - ( M ^ 3 ) ) ) = 0 ) ) $=
        ( c3 cexp co cmul caddc cc0 wceq c2 cmin cdiv cneg cc wcel 3nn0 sylancl
        cn0 expcl sqvald oveq1d cz 3nn nnzi a1i expne0d divcan4d eqtr2d 3cn wne
        3ne0 divcld eqeltrd negsubd eqtr4d mulcld negcld add42d mulneg2d negeqd
        eqtrd oveq2d eqtr3d adddid 3eqtrd addassd addcomd negidd addcld addid2d
        3eqtr3d divsubdird 3eqtr4d oveq12d binom3 syl2anc sqcld div12d divcan2d
        negsubdid mulassd sqneg syl 3eqtr2d cn cdivides wbr wn 2nn 1nn0 1nn 2cn
        mulid1i oveq1i 2p1e3 1lt2 ndvdsi oexpneg syl3anc expdivd subcld divdird
        c1 eqtri eqeq1d diveq0ad bitrd ) AIUCUDUEZBIUFUEZCUGUEZUGUEZUHUIEUCUDUE
        ZUJUDUEZCYLUFUEZGUCUDUEZUKUEZUGUEZYLULUEZUHUIYQUHUIAYKYRUHAYLBEUFUEZUMZ
        BGEULUEZUFUEZYOYLULUEZUMZUGUEZUGUEZYJUGUEZUGUEZYMYLULUEZYPYLULUEZUGUEYK
        YRAYLUUIUUGUUJUGAUUIYLYLUFUEZYLULUEYLAYMUUKYLULAYLAEUNUOZUCURUOZYLUNUOT
        UPEUCUSUQZUTVAAYLYLUUNUUNAEUCTUAUCVBUOAUCVCVDVEVFZVGVHACUUDUGUEZYNYLULU
        EZUUCUKUEZUUGUUJAUUPCUUCUKUEUURACUUCKAYOYLAGUNUOUUMYOUNUOAGBUCULUEZUNQA
        BUCJUCUNUOAVIVEZUCUHVJAVKVEZVLVMZUPGUCUSUQZUUNUUOVLZVNAUUQCUUCUKACYLKUU
        NUUOVGVAVOAYIUMZUUDUGUEZYJUGUEUVEYIUGUEZUUPUGUEZUUGUUPAUVEUUDYICAYIABIJ
        LVPZVQZAUUCUVDVQZUVIKVRAUVFUUFYJUGAUVFYTUUBUGUEZUUDUGUEUUFAUVEUVLUUDUGA
        UVEBEUMZUUAUGUEZUFUEZBUVMUFUEZUUBUGUEUVLABIUMZUFUEUVEUVOABIJLVSAUVQUVNB
        UFAUVQEUUAUKUEZUMUVNAIUVRUBVTAEUUATAGEUVBTUAVLZWTWAWBWCABUVMUUAJAETVQUV
        SWDAUVPYTUUBUGABEJTVSVAWEVAAYTUUBUUDAYSABEJTVPVQZABUUAJUVSVPZUVKWFWAVAA
        UVHUHUUPUGUEUUPAUVGUHUUPUGAUVGYIUVEUGUEUHAUVEYIUVJUVIWGAYIUVIWHWAVAAUUP
        ACUUDKUVKWIWJWAWKAYNYOYLACYLKUUNVPZUVCUUNUUOWLWMWNAYKYLUUFUGUEZYJUGUEUU
        HAYHUWCYJUGAYHYLYTUGUEZUUEUGUEZUWCAYHEUUAUMZUGUEZUCUDUEZYLUCEUJUDUEZUWF
        UFUEZUFUEZUGUEZUCEUWFUJUDUEZUFUEZUFUEZUWFUCUDUEZUGUEZUGUEZUWEAIUWGUCUDA
        IUVRUWGUBAEUUATUVSVNVOVAAUULUWFUNUOUWHUWRUITAUUAUVSVQEUWFWOWPAUWLUWDUWQ
        UUEUGAUWKYTYLUGAUWKUCGEUFUEZUMZUFUEUCUWSUFUEZUMYTAUWJUWTUCUFAUWJUWIUUAU
        FUEZUMUWTAUWIUUAAETWQZUVSVSAUXBUWSAUXBGUWIEULUEZUFUEUWSAUWIGEUXCUVBTUAW
        RAUXDEGUFAUXDEEUFUEZEULUEEAUWIUXEEULAETUTVAAEETTUAVGWAWBWAVTWAWBAUCUWSU
        UTAGEUVBTVPVSAUXAYSAUCGUFUEZEUFUEUXAYSAUCGEUUTUVBTXAAUXFBEUFAUXFUCUUSUF
        UEBAGUUSUCUFQWBABUCJUUTUVAWSWAZVAWCVTWEWBAUWOUUBUWPUUDUGAUWOUCGUUAUFUEZ
        UFUEUXFUUAUFUEUUBAUWNUXHUCUFAUWNEUUAUUAUFUEZUFUEEUUAUFUEZUUAUFUEUXHAUWM
        UXIEUFAUWMUUAUJUDUEZUXIAUUAUNUOZUWMUXKUIUVSUUAXBXCAUUAUVSUTWAWBAEUUAUUA
        TUVSUVSXAAUXJGUUAUFAGEUVBTUAWSVAXDWBAUCGUUAUUTUVBUVSXAAUXFBUUAUFUXGVAXD
        AUWPUUAUCUDUEZUMZUUDAUXLUCXEUOZUJUCXFXGXHZUWPUXNUIUVSUXOAVCVEUXPAUJUCYC
        YCXIXJXKUJYCUFUEZYCUGUEUJYCUGUEUCUXQUJYCUGUJXLXMXNXOYDXPXQVEUUAUCXRXSAU
        XMUUCAGEUCUVBTUAUUMAUPVEXTVTWAWNWNWEAYLYTUUEUUNUVTAUUBUUDUWAUVKWIZWFWAV
        AAYLUUFYJUUNAYTUUEUVTUXRWIAYICUVIKWIWFWAAYMYPYLAYLUUNWQZAYNYOUWBUVCYAZU
        UNUUOYBWMYEAYQYLAYMYPUXSUXTWIUUNUUOYFYG $.

      dcubic2.x $e |- ( ph -> ( ( X ^ 3 ) + ( ( P x. X ) + Q ) ) = 0 ) $.
      $( Reverse direction of ~ dcubic .  Given a solution ` U ` to the
         "substitution" quadratic equation ` X = U - M / U ` , show that ` X `
         is in the desired form.  (Contributed by Mario Carneiro,
         25-Apr-2015.) $)
      dcubic2 $p |- ( ph -> E. r e. CC ( ( r ^ 3 ) = 1 /\
        X = ( ( r x. T ) - ( M / ( r x. T ) ) ) ) ) $=
        ( c3 cexp co cmin wceq cv c1 cmul cdiv wa wrex caddc cneg divcld adantr
        cc wcel cn0 3nn0 a1i expdivd oveq1 oveq1d expcl sylancl cz nn0zi dividd
        expne0d eqtr3d eqtrd oveq2d oveq12d eqtr4d eqeq1d eqeq2d anbi12d rspcev
        sylan9eqr divcan1d syl12anc 3cn cc0 3ne0 eqeltrd negcld divnegd halfcld
        wne c2 subsq syl2anc sqcld pncan2d 3eqtrd negeqd addcld mulneg1d cn wbr
        cdivides wn 3nn 2nn 1nn0 1nn 2cn mulid1i oveq1i 2p1e3 eqtri 1lt2 ndvdsi
        oexpneg syl3anc div23d divcan4d eqcomd neg2subd divneg2d simpr eqnetrrd
        3eqtr4d mulne0d syl6eq wo mulid2d negsubd mpbid mulcl sylancr c4 oveq2i
        sqmul addcomd syl5eq 0exp neg0 necon3i negne0d ddcand mulcld dcubic1lem
        ax-mp syl ax-1cn ax-1ne0 sqcli subnegd 2ne0 divcan2d 4cn mulneg2 negeqi
        syl6eqr adddid 3eqtr4rd quad2 divdird eqtr2d divsubdird negdi2d orbi12d
        sq2 divcan3d mpjaodan ) AEUEUFUGZFHUHUGZUIZJUJZUEUFUGZUKUIZIUVNDULUGZGU
        VQUMUGZUHUGZUIZUNZJUTUOZUVKFHUPUGZUQZUIZAUVMUNZEDUMUGZUTVAZUWGUEUFUGZUK
        UIZIUWGDULUGZGUWKUMUGZUHUGZUIZUWBAUWHUVMAEDUANTURUSUWFUWIUVKDUEUFUGZUMU
        GZUKAUWIUWPUIUVMAEDUEUANTUEVBVAZAVCVDZVEUSUVMAUWPUVLUWOUMUGZUKUVKUVLUWO
        UMVFAUWOUWOUMUGUWSUKAUWOUVLUWOUMOVGAUWOADUTVAUWQUWOUTVAZNVCDUEVHVIZADUE
        NTUEVJVAAUEVCVKVDZVMZVLVNWCVOAUWNUVMAIEGEUMUGZUHUGZUWMUCAUWKEUWLUXDUHAE
        DUANTWDZAUWKEGUMUXFVPVQVRUSUWAUWJUWNUNJUWGUTUVNUWGUIZUVPUWJUVTUWNUXGUVO
        UWIUKUVNUWGUEUFVFVSUXGUVSUWMIUXGUVQUWKUVRUWLUHUVNUWGDULVFZUXGUVQUWKGUMU
        XHVPVQVTWAWBWEAUWEUNZUXDUQZDUMUGZUTVAZUXKUEUFUGZUKUIZIUXKDULUGZGUXOUMUG
        ZUHUGZUIZUWBAUXLUWEAUXJDAUXDAGEAGBUEUMUGUTRABUEKUEUTVAAWFVDUEWGWMAWHVDU
        RWIZUAUBURZWJZNTURUSUXIUXMUWDUVKUMUGZUKAUXMUYBUIUWEAUXMUXJUEUFUGZUWOUMU
        GUYBUWOULUGZUWOUMUGUYBAUXJDUEUYANTUWRVEAUYCUYDUWOUMAUYCGUQZEUMUGZUEUFUG
        UYEUEUFUGZUVKUMUGZUYDAUXJUYFUEUFAGEUXSUAUBWKVGAUYEEUEAGUXSWJUAUBUWRVEAU
        WDUWOULUGZUVKUMUGUYHUYDAUYIUYGUVKUMAUWCUWOULUGZUQZGUEUFUGZUQZUYIUYGAUYJ
        UYLAUYJFWNUFUGZHWNUFUGZUHUGZUYOUYLUPUGZUYOUHUGUYLAUYJUWCUVLULUGZUYPAUWO
        UVLUWCULOVPAFUTVAZHUTVAZUYPUYRUIPAHCWNUMUGZUTSACLWLWIZFHWOWPVRAUYNUYQUY
        OUHQVGAUYOUYLAHVUBWQZAGUTVAZUWQUYLUTVAZUXSVCGUEVHVIZWRWSWTZAUWCUWOAFHPV
        UBXAZUXAXBZAVUDUEXCVAZWNUEXEXDXFZUYGUYMUIUXSVUJAXGVDVUKAWNUEUKUKXHXIXJW
        NUKULUGZUKUPUGWNUKUPUGUEVULWNUKUPWNXKXLZXMXNXOXPXQVDGUEXRXSYGVGAUWDUWOU
        VKAUWCVUHWJZUXAAEUTVAUWQUVKUTVAUAVCEUEVHVIZAEUEUAUBUXBVMZXTVNWSVGAUYBUW
        OAUWDUVKVUNVUOVUPURUXAUXCYAWSUSUWEAUYBUVKUVKUMUGZUKUWEVUQUYBUVKUWDUVKUM
        VFYBAUVKVUOVUPVLWCVOUXIIUXJEUQZUHUGZUXQAIVUSUIUWEAIUXEVUSUCAUXDEUXTUAYC
        VRUSUXIUXOUXJUXPVURUHAUXOUXJUIUWEAUXJDUYANTWDZUSUXIUXPGGVURUMUGZUMUGVUR
        UXIUXOVVAGUMAUXOVVAUIUWEAUXOUXJVVAVUTAGEUXSUAUBYDVOUSVPUXIGVURAVUDUWEUX
        SUSAVURUTVAUWEAEUAWJUSUXIUYMWGWMGWGWMUXIUYIUYMWGAUYIUYMUIUWEAUYIUYKUYMV
        UIVUGVOUSUXIUWDUWOAUWDUTVAUWEVUNUSAUWTUWEUXAUSUXIUVKUWDWGAUWEYEAUVKWGWM
        UWEVUPUSYFAUWOWGWMUWEUXCUSYHYFGWGUYMWGGWGUIZUYMWGUQWGVVBUYLWGVVBUYLWGUE
        UFUGZWGGWGUEUFVFVUJVVCWGUIXGUEUUAUUHYIWTUUBYIUUCUUIAVURWGWMUWEAEUAUBUUD
        USUUEVOVQVRUWAUXNUXRUNJUXKUTUVNUXKUIZUVPUXNUVTUXRVVDUVOUXMUKUVNUXKUEUFV
        FVSVVDUVSUXQIVVDUVQUXOUVRUXPUHUVNUXKDULVFZVVDUVQUXOGUMVVEVPVQVTWAWBWEAU
        VKCUQZWNFULUGZUPUGZVULUMUGZUIZUVKVVFVVGUHUGZVULUMUGZUIZYJZUVMUWEYJAUKUV
        KWNUFUGZULUGZCUVKULUGZUYMUPUGZUPUGZWGUIVVNAVVSVVOVVQUYLUHUGZUPUGZWGAVVP
        VVOVVRVVTUPAVVOAUVKVUOWQYKAVVQUYLACUVKLVUOUUFVUFYLVQAIUEUFUGBIULUGCUPUG
        UPUGWGUIVWAWGUIUDABCDEFGHIKLMNOPQRSTUAUBUCUUGYMVOAUKCUYMVVGUVKUKUTVAAUU
        JVDUKWGWMAUUKVDLAUYLVUFWJZVUOAWNUTVAZUYSVVGUTVAXKPWNFYNYOZAVVGWNUFUGZWN
        WNUFUGZUYNULUGZVWFUYQULUGZCWNUFUGZYPUKUYMULUGZULUGZUHUGZAVWCUYSVWEVWGUI
        XKPWNFYRYOAUYNUYQVWFULQVPAVWFUYOULUGZVWFUYLULUGZUQZUHUGVWMVWNUPUGVWLVWH
        AVWMVWNAVWFUTVAZUYOUTVAVWMUTVAWNXKUULZVUCVWFUYOYNYOAVWPVUEVWNUTVAVWQVUF
        VWFUYLYNYOUUMAVWIVWMVWKVWOUHAWNHULUGZWNUFUGZVWIVWMAVWRCWNUFAVWRWNVUAULU
        GCAHVUAWNULSVPACWNLVWCAXKVDZWNWGWMAUUNVDZUUOVOVGAVWCUYTVWSVWMUIXKVUBWNH
        YRYOVNAVWKYPUYLULUGZUQZVWOAVWKYPUYMULUGZVXCAVWJUYMYPULAUYMVWBYKVPAYPUTV
        AVUEVXDVXCUIUUPVUFYPUYLUUQYOVOVWNVXBVWFYPUYLULUVHXMUURUUSVQAVWFUYOUYLVW
        PAVWQVDVUCVUFUUTUVAWSUVBYMAVVJUVMVVMUWEAVVIUVLUVKAVVIVVHWNUMUGZUVLVULWN
        VVHUMVUMYQAVXEVVFWNUMUGZVVGWNUMUGZUPUGHUQZFUPUGZUVLAVVFVVGWNACLWJZVWDVW
        TVXAUVCAVXFVXHVXGFUPAVXHVUAUQVXFAHVUASWTACWNLVWTVXAWKUVDZAFWNPVWTVXAUVI
        ZVQAVXIFVXHUPUGUVLAVXHFAHVUBWJPYSAFHPVUBYLVOWSYTVTAVVLUWDUVKAVVLVVKWNUM
        UGZUWDVULWNVVKUMVUMYQAVXFVXGUHUGVXHFUHUGZVXMUWDAVXFVXHVXGFUHVXKVXLVQAVV
        FVVGWNVXJVWDVWTVXAUVEAUWDHFUPUGZUQVXNAUWCVXOAFHPVUBYSWTAHFVUBPUVFVOYGYT
        VTUVGYMUVJ $.
    $}

    ${
      dcubic1.x $e |- ( ph -> X = ( T - ( M / T ) ) ) $.
      $( Forward direction of ~ dcubic : the claimed formula produces solutions
         to the cubic equation.  (Contributed by Mario Carneiro,
         25-Apr-2015.) $)
      dcubic1 $p |- ( ph -> ( ( X ^ 3 ) + ( ( P x. X ) + Q ) ) = 0 ) $=
        ( co c3 cexp cmul caddc cc0 wceq c2 cmin oveq1d cc wcel halfcld eqeltrd
        cdiv binom2sub syl2anc 2cn a1i mul12d oveq2d wne divcan2d eqtrd mulcomd
        2ne0 3eqtrd oveq12d sqcld cn0 3cn 3ne0 divcld 3nn0 expcl sylancl addcld
        mulcld addsubd 2timesd 3eqtr2d mulassd 3eqtr4d sylancr subsub4d npncan2
        add32d eqtr4d subdid sqvald mulcl dcubic1lem mpbird ) AHUAUBTBHUCTCUDTU
        DTUEUFDUAUBTZUGUBTZCWMUCTZFUAUBTZUHTZUDTZUEUFAWRUGGUGUBTZUCTZWPUDTZCEUC
        TZUHTZXBXAUHTZUDTZUEAWNXCWQXDUDAWNWSWPUDTZXBUHTZWSUDTZXFWSUDTZXBUHTXCAW
        NEGUHTZUGUBTZEUGUBTZUGEGUCTUCTZUHTZWSUDTZXHAWMXJUGUBMUIAEUJUKGUJUKXKXOU
        FNAGCUGUNTZUJQACJULUMZEGUOUPAXNXGWSUDAXLXFXMXBUHOAXMEUGGUCTZUCTECUCTXBA
        UGEGUGUJUKZAUQURZNXQUSAXRCEUCAXRUGXPUCTCAGXPUGUCQUTACUGJXTUGUEVAAVEURVB
        VCZUTAECNJVDVFVGUIVFAXFWSXBAWSWPAGXQVHZAFUJUKUAVIUKWPUJUKAFBUAUNTUJPABU
        AIUAUJUKAVJURUAUEVAAVKURVLUMVMFUAVNVOZVPYBACEJNVQZVRAXIXAXBUHAXIWSWSUDT
        ZWPUDTXAAWSWPWSYBYCYBWFAWTYEWPUDAWSYBVSUIWGUIVTAWQXBWTUHTZWPUHTXDAWOYFW
        PUHACXJUCTXBCGUCTZUHTWOYFACEGJNXQWHAWMXJCUCMUTAWTYGXBUHAWTUGGGUCTZUCTXR
        GUCTYGAWSYHUGUCAGXQWIUTAUGGGXTXQXQWAAXRCGUCYAUIVTUTWBUIAXBWTWPYDAXSWSUJ
        UKWTUJUKUQYBUGWSWJWCZYCWDVCVGAXAUJUKXBUJUKXEUEUFAWTWPYIYCVPYDXAXBWEUPVC
        ABCDDEFGHIJKLMNOPQRLRSWKWL $.
    $}

    $( Solutions to the depressed cubic, a special case of ~ cubic .  (The
       definitions of ` M , N , G , T ` here differ from ~ mcubic by scale
       factors of ` -u 9 ` , ` 5 4 ` , ` 5 4 ` and ` -u 2 7 ` respectively, to
       simplify the algebra and presentation.)  (Contributed by Mario Carneiro,
       26-Apr-2015.) $)
    dcubic $p |- ( ph -> ( ( ( X ^ 3 ) + ( ( P x. X ) + Q ) ) = 0 <->
      E. r e. CC ( ( r ^ 3 ) = 1 /\
        X = ( ( r x. T ) - ( M / ( r x. T ) ) ) ) ) ) $=
      ( cc0 vu c3 cexp co cmul caddc wceq cv c1 cdiv cmin wa cc wrex cdif c2 c4
      csn csqr cfv wn wne adantr wcel wi cz 3nn nnzi expne0i mp3an3 ex ad2antrr
      syl simprl oveq2d mul01d eqtrd oveq1d cn 0exp ax-mp syl6eq simplr 0cn a1i
      eqeltrd addcld addid2d 3eqtr3rd 2cn 2ne0 div0i 3cn 3ne0 divcld 4cn nnne0i
      sq0id 4nn sqcld mulcl sylancr simprr sqr00d syl6eqr mulcanad oveq12d 00id
      mul01i sqeq0d subidi necon3ad mpd oveq12 sqrcld halfaddsub syl2anc simpld
      syld jca eqeq1d wo adantl eqcom mulcld cneg ax-1ne0 negcld mulid2d eqeq2d
      orbi12d syl6bb risset wb halfcld eldifsn baib syl5bbr ad2antrl 3nn0 con3d
      simprd anbi12d eldifsni subaddd 3bitr4g subeq0ad adddird divcan1d addcomd
      syl5ib eldifi sqvald 3eqtrrd eqeq12d mulcan2d 3bitrd ax-1cn sqneg mulneg2
      subnegd eqtr2d quad negdid eqtr4d negsubd negnegd mulid1i 3bitr3d 3bitr2d
      mulneg1d r19.43 subcld neorian bitrd sylibrd imp syldan dcubic2 rexlimddv
      rexbidva cn0 mulexpd expcl sylancl 3eqtrd eqnetrd necon3i mulne0d dcubic1
      oveq1 rexlimdva impbid ) AHUBUCUDZBHUEUDZCUFUDZUFUDZTUGZIUHZUBUCUDZUIUGZH
      UWSDUEUDZFUXBUJUDUKUDUGZULZIUMUNZAUWRUXEAUWRULZHUAUHZFUXGUJUDZUKUDZUGZUXE
      UAUMTURZUOZAUWRHTUGZHUPUCUDZUQFUEUDZUFUDZUSUTZTUGZULZVAZUXJUAUXLUNZUXFDTV
      BZUXTAUYBUWRSVCUXFUYBDUBUCUDZTVBZUXTUXFDUMVDZUYBUYDVEAUYEUWRMVCUYEUYBUYDU
      YEUYBUBVFVDUYDUBVGVHDUBVIVJVKVMUXFUXSUYCTUXFUXSUYCTUGUXFUXSULZUYCEGUKUDZT
      AUYCUYGUGZUWRUXSNVLUYFUYGTTUKUDZTUYFETGTUKUYFEAEUMVDZUWRUXSOVLUYFEUPUCUDZ
      GUPUCUDZFUBUCUDZUFUDZTAUYKUYNUGZUWRUXSPVLUYFUYNTTUFUDZTUYFUYLTUYMTUFUYFGU
      YFGCUPUJUDZTAGUYQUGZUWRUXSRVLUYFUYQTUPUJUDTUYFCTUPUJUYFUWPTCUFUDTCUYFUWOT
      CUFUYFUWOBTUEUDTUYFHTBUEUXFUXMUXRVNZVOUYFBABUMVDZUWRUXSJVLVPVQZVRUYFUWQTU
      WPUFUDTUWPUYFUWNTUWPUFUYFUWNTUBUCUDZTUYFHTUBUCUYSVRUBVSVDVUBTUGVGUBVTWAZW
      BVRAUWRUXSWCUYFUWPUYFUWOCUYFUWOTUMVUATUMVDUYFWDWEZWFACUMVDZUWRUXSKVLZWGWH
      WIUYFCVUFWHWIVRUPWJWKWLWBVQZWRUYFUYMVUBTUYFFTUBUCUYFFTUQAFUMVDZUWRUXSAFBU
      BUJUDZUMQABUBJUBUMVDAWMWEUBTVBAWNWEWOWFZVLVUDUQUMVDZUYFWPWEUQTVBUYFUQWSWQ
      WEUYFUXOTUQTUEUDUYFUXPTUXOUFUDTUXOUYFUXNTUXOUFUYFHUYSWRVRUYFUXPAUXPUMVDUW
      RUXSAUXNUXOAHLWTZAVUKVUHUXOUMVDZWPVUJUQFXAXBZWGZVLUXFUXMUXRXCXDUYFUXOAVUM
      UWRUXSVUNVLWHWIUQWPXIXEXFVRVUCWBXGXHWBVQXJVUGXGTWDXKZWBVQVKXLXSXMAUXTUYAA
      UXTHUXQUFUDZUPUJUDZTUGHUXQUKUDZUPUJUDZTUGULZVAZUYAAVVAUXSVVAVURVUTUFUDZTU
      GZVURVUTUKUDZTUGZULAUXSVVAVVDVVFVVAVVCUYPTVURTVUTTUFXNXHWBVVAVVEUYITVURTV
      UTTUKXNVUPWBXTAVVDUXMVVFUXRAVVCHTAVVCHUGZVVEUXQUGZAHUMVDZUXQUMVDVVGVVHULL
      AUXPVUOXOZHUXQXPXQZXRYAAVVEUXQTAVVGVVHVVKUUBYAUUCUUKUUAAUYAUXGVURUGZUAUXL
      UNZUXGVUTUGZUAUXLUNZYBZVVBAUYAVVLVVNYBZUAUXLUNVVPAUXJVVQUAUXLAUXGUXLVDZUL
      ZUXJUXGUXHHUFUDZUGZUXGUPUCUDZHUXGUEUDZFUFUDZUKUDZTUGZVVQVVSUXIHUGVVTUXGUG
      UXJVWAVVSUXGUXHHVVRUXGUMVDZAUXGUMUXKUULZYCZVVSFUXGAVUHVVRVUJVCZVWIVVRUXGT
      VBZAUXGUMTUUDZYCZWOZAVVIVVRLVCZUUEHUXIYDUXGVVTYDUUFVVSVWFVWBVWDUGUXGUXGUE
      UDZVVTUXGUEUDZUGVWAVVSVWBVWDVVSUXGVWIWTZVVSVWCFVVSHUXGVWOVWIYEZVWJWGZUUGV
      VSVWBVWPVWDVWQVVSUXGVWIUUMVVSVWQUXHUXGUEUDZVWCUFUDFVWCUFUDVWDVVSUXHHUXGVW
      NVWOVWIUUHVVSVXAFVWCUFVVSFUXGVWJVWIVWMUUIVRVVSFVWCVWJVWSUUJUUNUUOVVSUXGVV
      TUXGVWIVVSUXHHVWNVWOWGVWIVWMUUPUUQVVSUIVWBUEUDZHYFZUXGUEUDZFYFZUFUDZUFUDZ
      TUGUXGVXCYFZUXQUFUDZUPUIUEUDZUJUDZUGZUXGVXHUXQUKUDZVXJUJUDZUGZYBVWFVVQVVS
      UIVXCVXEUXPUXGUIUMVDVVSUURWEUITVBZVVSYGWEAVXCUMVDVVRAHLYHVCAVXEUMVDVVRAFV
      UJYHVCZVWIVVSVXCUPUCUDZUQUIVXEUEUDZUEUDZUKUDUXNUXOYFZUKUDUXPVVSVXRUXNVXTV
      YAUKVVSVVIVXRUXNUGVWOHUUSVMVVSVXTUQVXEUEUDZVYAVVSVXSVXEUQUEVVSVXEVXQYIVOV
      VSVUKVUHVYBVYAUGWPVWJUQFUUTXBVQXGVVSUXNUXOAUXNUMVDVVRVULVCAVUMVVRVUNVCUVA
      UVBUVCVVSVXGVWETVVSVXGVWBVWDYFZUFUDVWEVVSVXBVWBVXFVYCUFVVSVWBVWRYIVVSVXFV
      WCYFZVXEUFUDVYCVVSVXDVYDVXEUFVVSHUXGVWOVWIUVKVRVVSVWCFVWSVWJUVDUVEXGVVSVW
      BVWDVWRVWTUVFVQYAVVSVXLVVLVXOVVNVVSVXKVURUXGVVSVXIVUQVXJUPUJVVSVXHHUXQUFV
      VSHVWOUVGZVRVXJUPUGVVSUPWJUVHWEZXGYJVVSVXNVUTUXGVVSVXMVUSVXJUPUJVVSVXHHUX
      QUKVYEVRVYFXGYJYKUVIUVJUWAVVLVVNUAUXLUVLYLAVVPVURTVBZVUTTVBZYBVVBAVVMVYGV
      VOVYHVVMVURUXLVDZAVYGUAVURUXLYMAVURUMVDZVYIVYGYNAVUQAHUXQLVVJWGYOVYIVYJVY
      GVURUMTYPYQVMYRVVOVUTUXLVDZAVYHUAVUTUXLYMAVUTUMVDZVYKVYHYNAVUSAHUXQLVVJUV
      MYOVYKVYLVYHVUTUMTYPYQVMYRYKVURTVUTTUVNYLUVOUVPUVQUVRUXFVVRUXJULZULBCDUXG
      EFGHIAUYTUWRVYMJVLAVUEUWRVYMKVLAVVIUWRVYMLVLAUYEUWRVYMMVLAUYHUWRVYMNVLAUY
      JUWRVYMOVLAUYOUWRVYMPVLAFVUIUGZUWRVYMQVLAUYRUWRVYMRVLAUYBUWRVYMSVLVVRVWGU
      XFUXJVWHYSVVRVWKUXFUXJVWLYSUXFVVRUXJXCAUWRVYMWCUVSUVTVKAUXDUWRIUMAUWSUMVD
      ZULZUXDUWRVYPUXDULZBCUXBEFGHAUYTVYOUXDJVLAVUEVYOUXDKVLAVVIVYOUXDLVLVYQUWS
      DAVYOUXDWCZAUYEVYOUXDMVLZYEVYQUXBUBUCUDUWTUYCUEUDUIUYCUEUDZUYGVYQUWSDUBVY
      RVYSUBUWBVDZVYQYTWEUWCVYQUWTUIUYCUEVYPUXAUXCVNZVRAVYTUYGUGVYOUXDAVYTUYCUY
      GAUYCAUYEWUAUYCUMVDMYTDUBUWDUWEYINVQVLUWFAUYJVYOUXDOVLAUYOVYOUXDPVLAVYNVY
      OUXDQVLAUYRVYOUXDRVLVYQUWSDVYRVYSVYQUWTTVBUWSTVBVYQUWTUITWUBVXPVYQYGWEUWG
      UWSTUWTTUWSTUGUWTVUBTUWSTUBUCUWKVUCWBUWHVMAUYBVYOUXDSVLUWIVYPUXAUXCXCUWJV
      KUWLUWM $.
  $}

  ${
    $d r B $.  $d r M $.  $d r N $.  $d r ph $.  $d r T $.  $d r X $.
    mcubic.b $e |- ( ph -> B e. CC ) $.
    mcubic.c $e |- ( ph -> C e. CC ) $.
    mcubic.d $e |- ( ph -> D e. CC ) $.
    mcubic.x $e |- ( ph -> X e. CC ) $.
    mcubic.t $e |- ( ph -> T e. CC ) $.
    mcubic.3 $e |- ( ph -> ( T ^ 3 ) = ( ( N + G ) / 2 ) ) $.
    mcubic.g $e |- ( ph -> G e. CC ) $.
    mcubic.2 $e |- ( ph -> ( G ^ 2 ) = ( ( N ^ 2 ) - ( 4 x. ( M ^ 3 ) ) ) ) $.
    mcubic.m $e |- ( ph -> M = ( ( B ^ 2 ) - ( 3 x. C ) ) ) $.
    mcubic.n $e |- ( ph -> N = ( ( ( 2 x. ( B ^ 3 ) ) -
      ( 9 x. ( B x. C ) ) ) + ( ; 2 7 x. D ) ) ) $.
    mcubic.0 $e |- ( ph -> T =/= 0 ) $.
    $( Solutions to a monic cubic equation, a special case of ~ cubic .
       (Contributed by Mario Carneiro, 24-Apr-2015.) $)
    mcubic $p |- ( ph -> ( ( ( ( X ^ 3 ) + ( B x. ( X ^ 2 ) ) ) +
      ( ( C x. X ) + D ) ) = 0 <-> E. r e. CC ( ( r ^ 3 ) = 1 /\ X =
       -u ( ( ( B + ( r x. T ) ) + ( M / ( r x. T ) ) ) / 3 ) ) ) ) $=
      ( c3 cdiv co caddc cexp cneg cmul c2 c7 cdc wceq cv c1 c9 cmin wa cc wrex
      cc0 sqcld wcel 3cn mulcl sylancr subcld eqeltrd a1i wne divcld negcld 2cn
      3ne0 cn0 3nn0 expcl sylancl 9nn nncni mulcld 7nn decnncl addcld nnne0i cn
      cdivides 3nn oveq1i 2p1e3 oexpneg syl3anc expdivd 3exp3 oveq12d divdiv32d
      2nn0 addcomd oveq1d divdird eqtrd 3eqtrd negeqd halfcld negdi2d sqdivd c4
      syl 4cn sqcli wb divassd oveq2i expmul mp3an 3eqtr3i syl6eq oveq2d eqtr4d
      divcan3d syl5eq divsubdird negsubd 3eqtr4d divdiv1d eqtr3d divne0d mul12d
      3t3e9 divcan2d mulcomd addassd negsubdi2d subdird 3eqtr2d 9t3e27 divcan5d
      sq2 syl5eqr eqeq1d adantr wbr 2nn 1nn0 1nn mulid1i eqtri 1lt2 ndvdsi 2ne0
      wn sqneg eqtr2d sqne0 mpbird mulcomi sq3 4nn eqnetri divnegd eqidd dcubic
      negne0d binom3 syl2anc adddid sqvali 3eqtr4a divmuldivd df-3 expp1 ax-1cn
      syl5req mulid2d mulcomli npncan3d eqeltrrd 3eqtr3d addsub4d pncan3d oveq1
      subaddrii 0exp ax-mp ax-1ne0 necomi eqnetrd necon2i simprl simprr mulne0d
      subnegd syl5bb subadd2d mulneg2d divcan7d div2negd eqeq2d 3bitrrd anassrs
      eqcom sylan2 pm5.32da rexbidva 3bitr3d ) AIBUBUCUDZUEUDZUBUFUDZGUBUCUDZUG
      ZUXFUHUDZHUIUJUKZUCUDZUEUDZUEUDZUTULJUMZUBUFUDZUNULZUXFUXOEUBUCUDZUGZUHUD
      ZGUOUCUDZUGZUXTUCUDZUPUDZULZUQZJURUSIUBUFUDZBIUIUFUDZUHUDZUEUDZCIUHUDZDUE
      UDZUEUDZUTULUXQIBUXOEUHUDZUEUDGUYNUCUDZUEUDZUBUCUDZUGZULZUQZJURUSAUXIUXLU
      XSFUXKUCUDZUIUCUDZUGZUYBUXLUIUCUDZUXFJAUXHAGUBAGBUIUFUDZUBCUHUDZUPUDZURSA
      VUEVUFABKVAZAUBURVBZCURVBVUFURVBVCLUBCVDVEZVFVGZVUIAVCVHZUBUTVIZAVMVHZVJZ
      VKZAHUXKAHUIBUBUFUDZUHUDZUOBCUHUDZUHUDZUPUDZUXKDUHUDZUEUDZURTAVVAVVBAVURV
      UTAUIURVBZVUQURVBZVURURVBVLABURVBZUBVNVBZVVEKVOBUBVPVQZUIVUQVDVEZAUOURVBZ
      VUSURVBVUTURVBUOVRVSZABCKLVTZUOVUSVDVEZVFZAUXKURVBZDURVBVVBURVBUXKUIUJWPW
      AWBZVSZMUXKDVDVEZWCVGZVVOAVVQVHZUXKUTVIZAUXKVVPWDVHZVJZAIUXENABUBKVULVUNV
      JZWCZAUXRAEUBOVULVUNVJZVKAUXSUBUFUDZUXRUBUFUDZUGZVUBVUDUEUDZUGVUCVUDUPUDA
      UXRURVBZUBWEVBZUIUBWFUUAUUJZVWGVWIULVWFVWLAWGVHZVWMAUIUBUNUNUUBUUCUUDUIUN
      UHUDZUNUEUDUIUNUEUDZUBVWOUIUNUEUIVLUUEWHWIUUFUUGUUHVHZUXRUBWJWKAVWHVWJAVW
      HEUBUFUDZUBUBUFUDZUCUDHFUEUDZUIUCUDZUXKUCUDZVWJAEUBUBOVULVUNVVGAVOVHZWLAV
      WRVXAVWSUXKUCPVWSUXKULAWMVHWNAVXBVWTUXKUCUDZUIUCUDVUAUXLUEUDZUIUCUDVWJAVW
      TUIUXKAHFVVSQWCVVDAVLVHZVVTUIUTVIAUUIVHZVWBWOAVXDVXEUIUCAVXDFHUEUDZUXKUCU
      DVXEAVWTVXHUXKUCAHFVVSQWQWRAFHUXKQVVSVVTVWBWSWTWRAVUAUXLUIAFUXKQVVTVWBVJZ
      VWCVXFVXGWSXAXAXBAVUBVUDAVUAVXIXCZAUXLVWCXCZXDXAAVUBVXJVKAVUCUIUFUDZVUBUI
      UFUDZVUAUIUFUDZUIUIUFUDZUCUDZVUDUIUFUDZUYBUBUFUDZUEUDZAVUBURVBVXLVXMULVXJ
      VUBUUKXGAVUAUIVXIVXFVXGXEAHUIUFUDZUXKUIUFUDZUCUDZXFGUBUFUDZUHUDZVYAUCUDZU
      PUDZVXOUCUDZVXQUYAUBUFUDZUGZUEUDZVXPVXSAVYBVXOUCUDZVYEVXOUCUDZUPUDVXQVYHU
      PUDVYGVYJAVYKVXQVYLVYHUPAVXQUXLUIUFUDZVXOUCUDVYKAUXLUIVWCVXFVXGXEAVYMVYBV
      XOUCAHUXKVVSVVTVWBXEWRUULAVYLXFVYHUHUDZVXOUCUDZVYHAVYEVYNVXOUCAVYEXFVYCVY
      AUCUDZUHUDVYNAXFVYCVYAXFURVBZAXHVHZAGURVBZVVGVYCURVBZVUKVOGUBVPVQZVYAURVB
      AUXKVVQXIVHZAVYAUTVIZVWAVWBAVVOWUCVWAXJVVTUXKUUMXGUUNZXKAVYHVYPXFUHAVYHVY
      CUOUBUFUDZUCUDVYPAGUOUBVUKVVJAVVKVHZUOUTVIAUOVRWDVHZVXCWLWUEVYAVYCUCUBUIU
      FUDZUBUFUDZVWSUIUFUDZWUEVYAUBUIUBUHUDZUFUDZUBUBUIUHUDZUFUDZWUIWUJWUKWUMUB
      UFUIUBVLVCUUOXLVUIUIVNVBZVVGWULWUIULVCWPVOUBUIUBXMXNVUIVVGWUOWUNWUJULVCVO
      WPUBUBUIXMXNXOWUHUOUBUFUUPWHVWSUXKUIUFWMWHXOXLXPXQXRWRAVYOVYNXFUCUDVYHVXO
      XFVYNUCYQXLAVYHXFAUYAURVBZVVGVYHURVBAGUOVUKWUFWUGVJZVOUYAUBVPVQZVYRXFUTVI
      AXFUUQWDZVHXSXTWTWNAVYBVYEVXOAVXTVYAAHVVSVAZWUBWUDVJAVYDVYAAVYQVYTVYDURVB
      XHWUAXFVYCVDVEZWUBWUDVJVXOURVBAUIVLXIVHVXOUTVIAVXOXFUTYQWUSUURVHYAAVXQVYH
      AVUDVXKVAWURYBYCAVXNVYFVXOUCAVXNFUIUFUDZVYAUCUDVXTVYDUPUDZVYAUCUDVYFAFUXK
      QVVTVWBXEAWVBWVCVYAUCRWRAVXTVYDVYAWUTWVAWUBWUDYAXAWRAVXRVYIVXQUEAWUPVWLVW
      MVXRVYIULWUQVWNVWQUYAUBWJWKXQYCXAAUXHUBUCUDZUGUYBUXIUBUCUDAWVDUYAAWVDGUBU
      BUHUDZUCUDUYAAGUBUBVUKVULVULVUNVUNYDWVEUOGUCYHXLXPZXBAUXHUBVUOVULVUNUUSYE
      AVUDUUTAUXRVWFAEUBOVULUAVUNYFUVBUVAAUXNUYMUTAUXNUYJUBIUXEUIUFUDZUHUDZUHUD
      ZUXEUBUFUDZUEUDZUEUDZUXMUEUDUYJWVKUXMUEUDZUEUDUYMAUXGWVLUXMUEAUXGUYGUBUYH
      UXEUHUDUHUDZUEUDZWVKUEUDZWVLAIURVBZUXEURVBZUXGWVPULNVWDIUXEUVCUVDAWVOUYJW
      VKUEAWVNUYIUYGUEAWVNUYHUBUXEUHUDZUHUDUYHBUHUDUYIAUBUYHUXEVULAINVAZVWDYGAW
      VSBUYHUHABUBKVULVUNYIXQAUYHBWVTKYJXAXQWRWTWRAUYJWVKUXMAUYGUYIAWVQVVGUYGUR
      VBNVOIUBVPVQABUYHKWVTVTWCAWVIWVJAUBWVHVULAIWVGNAUXEVWDVAZVTVTZAWVRVVGWVJU
      RVBVWDVOUXEUBVPVQZWCZAUXJUXLAUXIUXFVUPVWEVTVWCWCYKAWVMUYLUYJUEAWVMWVKUYLW
      VKUPUDZUEUDUYLAUXMWWEWVKUEAUXMUYKWVIUPUDZDWVJUPUDZUEUDZWWEAUXMUXIIUHUDZUX
      IUXEUHUDZUEUDZUXLUEUDWWIWWJUXLUEUDZUEUDWWHAUXJWWKUXLUEAUXIIUXEVUPNVWDUVEW
      RAWWIWWJUXLAUXIIVUPNVTAUXIUXEVUPVWDVTZVWCYKAWWIWWFWWLWWGUEAWWICVUEUBUCUDZ
      UPUDZIUHUDUYKWWNIUHUDZUPUDWWFAUXIWWOIUHAUXIWWNCUPUDZUGWWOAUXHWWQAUXHVUGUB
      UCUDWWNVUFUBUCUDZUPUDWWQAGVUGUBUCSWRAVUEVUFUBVUHVUJVULVUNYAAWWRCWWNUPACUB
      LVULVUNXSXQXAXBAWWNCAVUEUBVUHVULVUNVJZLYLWTZWRACWWNILWWSNYMAWWPWVIUYKUPAW
      WPIWWNUHUDIUBWVGUHUDZUHUDWVIAWWNIWWSNYJAWXAWWNIUHAWXAUBWWNUBUCUDZUHUDWWNA
      WVGWXBUBUHAVUEWUHUCUDVUEWVEUCUDWVGWXBWUHWVEVUEUCUBVCUVFXLABUBKVULVUNXEAVU
      EUBUBVUHVULVULVUNVUNYDUVGXQAWWNUBWWSVULVUNYIWTXQAIUBWVGNVULWWAYGYNXQXAAWW
      LVUSUBUCUDZVUQUOUCUDZUPUDZVURUXKUCUDZWXCUPUDZDUEUDZUEUDZDWVJUGZUEUDZWWGAW
      WJWXEUXLWXHUEAWWJWWOUXEUHUDCUXEUHUDZWWNUXEUHUDZUPUDWXEAUXIWWOUXEUHWWTWRAC
      WWNUXELWWSVWDYMAWXLWXCWXMWXDUPACBUHUDZUBUCUDWXLWXCACBUBLKVULVUNXKAWXNVUSU
      BUCACBLKYJWRYEAWXMVUEBUHUDZWVEUCUDWXDAVUEUBBUBVUHVULKVULVUNVUNUVHAWXOVUQW
      VEUOUCAVUQBVWPUFUDZWXOUBVWPBUFUVIXLAVVFWUOWXPWXOULKWPBUIUVJVQUVLWVEUOULAY
      HVHWNWTWNXAZAUXLVVCUXKUCUDVVAUXKUCUDZVVBUXKUCUDZUEUDWXHAHVVCUXKUCTWRAVVAV
      VBUXKVVNVVRVVTVWBWSAWXRWXGWXSDUEAWXRWXFVUTUXKUCUDZUPUDWXGAVURVUTUXKVVIVVM
      VVTVWBYAAWXTWXCWXFUPAWXTVUTUOUBUHUDZUCUDWXCWYAUXKVUTUCYOXLAVUSUBUOVVLVULW
      UFVUNWUGYPYRXQWTADUXKMVVTVWBXSWNXAWNAWXJDUEUDWXEWXGUEUDZDUEUDWXKWXIAWXJWY
      BDUEAWXDWXFUPUDZUGWXFWXDUPUDWXJWYBAWXDWXFAVUQUOVVHWUFWUGVJZAVURUXKVVIVVTV
      WBVJZYLAWVJWYCAWVJVUQVWSUCUDZUBVUQUHUDZUXKUCUDZWXFUPUDZWYCABUBUBKVULVUNVX
      CWLAWYFVUQUXKUCUDZWYIVWSUXKVUQUCWMXLAWYJWYGVURUPUDZUXKUCUDWYIAVUQWYKUXKUC
      AUBUIUPUDZVUQUHUDZVUQWYKAWYMUNVUQUHUDVUQWYLUNVUQUHUBUIUNVCVLUVKWIUWAWHAVU
      QVVHUVMXTAUBUIVUQVULVXFVVHYMYEWRAWYGVURUXKAVUIVVEWYGURVBVCVVHUBVUQVDVEVVI
      VVTVWBYAWTXTAWYHWXDWXFUPAWYHWYGUBUOUHUDZUCUDWXDWYNUXKWYGUCUOUBUXKVVKVCYOU
      VNXLAVUQUOUBVVHWUFVULWUGVUNYPYRWRXAXBAWXCWXDWXFAVUSUBVVLVULVUNVJZWYDWYEUV
      OYCWRAWXJDAWVJWWCVKMWQAWXEWXGDAWWJWXEURWXQWWMUVPAWXFWXCWYEWYOVFMYKUVQADWV
      JMWWCYBYNWNXAAUYKDWVIWVJACILNVTZMWWBWWCUVRXRXQAWVKUYLWWDAUYKDWYPMWCUVSWTX
      QXAYSAUYFUYTJURAUXOURVBZUQZUXQUYEUYSUXQWYRUXOUTVIZUYEUYSXJZUXOUTUXPUNUXOU
      TULZUXPUTUNXUAUXPUTUBUFUDZUTUXOUTUBUFUVTVWLXUBUTULWGUBUWBUWCXPUTUNVIXUAUN
      UTUWDUWEVHUWFUWGAWYQWYSWYTAWYQWYSUQZUQZUYSUYNUYOUEUDZUBUCUDZUGZUXEUPUDZIU
      LZUXFXUGULUYEUYSUYRIULXUDXUIIUYRUWTXUDUYRXUHIXUDUYRUXEXUGUPUDZUGXUHXUDUYQ
      XUJXUDBXUEUEUDZUBUCUDUXEXUFUEUDUYQXUJXUDBXUEUBAVVFXUCKYTZXUDUYNUYOXUDUXOE
      AWYQWYSUWHZAEURVBXUCOYTZVTZXUDGUYNAVYSXUCVUKYTZXUOXUDUXOEXUMXUNAWYQWYSUWI
      AEUTVIXUCUAYTUWJZVJZWCZVUIXUDVCVHZVUMXUDVMVHZWSXUDUYPXUKUBUCXUDBUYNUYOXUL
      XUOXURYKWRXUDUXEXUFAWVRXUCVWDYTZXUDXUEUBXUSXUTXVAVJZUWKYCXBXUDUXEXUGXVBXU
      DXUFXVCVKZYLWTYSUWLXUDXUGUXEIXVDXVBAWVQXUCNYTUWMXUDXUGUYDUXFXUDXUGUYNUBUC
      UDZUYOUBUCUDZUEUDZUGXVEUGZXVFUPUDUYDXUDXUFXVGXUDUYNUYOUBXUOXURXUTXVAWSXBX
      UDXVEXVFXUDUYNUBXUOXUTXVAVJZXUDUYOUBXURXUTXVAVJXDXUDXVHUXTXVFUYCUPXUDXVHU
      XOUXRUHUDZUGUXTXUDXVEXVJXUDUXOEUBXUMXUNXUTXVAXKXBXUDUXOUXRXUMAVWKXUCVWFYT
      UWNXRZXUDXVFUYAXVEUCUDZUYBXVHUCUDUYCXUDXVFUXHUYNUCUDWVDXVEUCUDZXVLXUDGUYN
      UBXUPXUOXUTXUQXVAWOXUDUXHUYNUBAUXHURVBXUCVUOYTXUOXUTXUQXVAUWOAXVMXVLULXUC
      AWVDUYAXVEUCWVFWRYTYNXUDUYAXVEAWUPXUCWUQYTXVIXUDUYNUBXUOXUTXUQXVAYFUWPXUD
      XVHUXTUYBUCXVKXQYNWNXAUWQUWRUWSUXAUXBUXCUXD $.
  $}

  ${
    $d r A $.  $d r B $.  $d r M $.  $d r N $.  $d r ph $.  $d r T $.
    $d r X $.
    cubic2.a $e |- ( ph -> A e. CC ) $.
    cubic2.z $e |- ( ph -> A =/= 0 ) $.
    cubic2.b $e |- ( ph -> B e. CC ) $.
    cubic2.c $e |- ( ph -> C e. CC ) $.
    cubic2.d $e |- ( ph -> D e. CC ) $.
    cubic2.x $e |- ( ph -> X e. CC ) $.
    cubic2.t $e |- ( ph -> T e. CC ) $.
    cubic2.3 $e |- ( ph -> ( T ^ 3 ) = ( ( N + G ) / 2 ) ) $.
    cubic2.g $e |- ( ph -> G e. CC ) $.
    cubic2.2 $e |- ( ph -> ( G ^ 2 ) = ( ( N ^ 2 ) - ( 4 x. ( M ^ 3 ) ) ) ) $.
    cubic2.m $e |- ( ph -> M = ( ( B ^ 2 ) - ( 3 x. ( A x. C ) ) ) ) $.
    cubic2.n $e |- ( ph -> N = ( ( ( 2 x. ( B ^ 3 ) ) -
      ( ( 9 x. A ) x. ( B x. C ) ) ) + ( ; 2 7 x. ( ( A ^ 2 ) x. D ) ) ) ) $.
    cubic2.0 $e |- ( ph -> T =/= 0 ) $.
    $( The solution to the general cubic equation, for arbitrary choices ` G `
       and ` T ` of the square and cube roots.  (Contributed by Mario Carneiro,
       23-Apr-2015.) $)
    cubic2 $p |- ( ph -> ( ( ( ( A x. ( X ^ 3 ) ) + ( B x. ( X ^ 2 ) ) ) +
      ( ( C x. X ) + D ) ) = 0 <-> E. r e. CC ( ( r ^ 3 ) = 1 /\ X =
       -u ( ( ( B + ( r x. T ) ) + ( M / ( r x. T ) ) ) / ( 3 x. A ) ) ) ) ) $=
      ( c3 cexp co cmul c2 caddc cc0 wceq cdiv cv c1 cneg wa wrex wcel cn0 3nn0
      expcl sylancl mulcld sqcld addcld diveq0ad divdird divcan3d oveq12d eqtrd
      cc div23d oveq1d eqeq1d bitr3d divcld a1i expdivd c9 cmin cdc 2cn sylancr
      c7 mulcl 9nn nncni subcld 2nn0 7nn decnncl eqeltrd wne 2ne0 nn0zi expne0d
      cz divdiv32d 3eqtrd c4 sqdivd 4cn 3cn sqne0 syl mpbird divsubdird mulcomi
      wb 2z oveq2i expmuld 3eqtr3a oveq2d divassd eqtr4d sqvald divcan5d eqtr2d
      3eqtr4d mulassd df-3 expp1 syl5eq mulcomd divmuldivd divne0d mcubic oveq1
      3eqtr4rd cn 3nn 0exp ax-mp syl6eq ax-1ne0 necomi adantr divdiv1d divcan7d
      eqnetrd necon2i simprl eqcomd simprr mulne0d 3eqtr3d mulcom negeqd eqeq2d
      3ne0 anassrs sylan2 pm5.32da rexbidva 3bitrd ) ABJUEUFUGZUHUGZCJUIUFUGZUH
      UGZUJUGZDJUHUGZEUJUGZUJUGZUKULZUURCBUMUGZUUTUHUGZUJUGZDBUMUGZJUHUGZEBUMUG
      ZUJUGZUJUGZUKULZKUNZUEUFUGZUOULZJUVGUVPFBUMUGZUHUGZUJUGZHBUIUFUGZUMUGZUVT
      UMUGZUJUGZUEUMUGZUPZULZUQZKVLURUVRJCUVPFUHUGZUJUGZHUWJUMUGZUJUGZUEBUHUGZU
      MUGZUPZULZUQZKVLURAUVEBUMUGZUKULUVFUVOAUVEBAUVBUVDAUUSUVAABUURLAJVLUSUEUT
      USZUURVLUSQVAJUEVBVCZVDZACUUTNAJQVEZVDZVFZAUVCEADJOQVDZPVFZVFLMVGAUWSUVNU
      KAUWSUVBBUMUGZUVDBUMUGZUJUGUVNAUVBUVDBUXEUXGLMVHAUXHUVIUXIUVMUJAUXHUUSBUM
      UGZUVABUMUGZUJUGUVIAUUSUVABUXBUXDLMVHAUXJUURUXKUVHUJAUURBUXALMVIACUUTBNUX
      CLMVMVJVKAUXIUVCBUMUGZUVLUJUGUVMAUVCEBUXFPLMVHAUXLUVKUVLUJADJBOQLMVMVNVKV
      JVKVOVPAUVGUVJUVLUVSGBUEUFUGZUMUGZUWCIUXMUMUGZJKACBNLMVQADBOLMVQAEBPLMVQQ
      AFBRLMVQAUVSUEUFUGFUEUFUGZUXMUMUGIGUJUGZUIUMUGZUXMUMUGZUXOUXNUJUGZUIUMUGZ
      AFBUERLMUWTAVAVRZVSAUXPUXRUXMUMSVNAUXSUXQUXMUMUGZUIUMUGUYAAUXQUIUXMAIGAIU
      ICUEUFUGZUHUGZVTBUHUGZCDUHUGZUHUGZWAUGZUIWEWBZUWBEUHUGZUHUGZUJUGZVLUCAUYI
      UYLAUYEUYHAUIVLUSZUYDVLUSZUYEVLUSWCACVLUSZUWTUYONVACUEVBVCZUIUYDWFWDZAUYF
      UYGAVTVLUSZBVLUSZUYFVLUSVTWGWHZLVTBWFWDACDNOVDZVDZWIZAUYJVLUSZUYKVLUSUYLV
      LUSUYJUIWEWJWKWLWHZAUWBEABLVEZPVDZUYJUYKWFWDZVFWMZTVFUYNAWCVRZAUYTUWTUXMV
      LUSZLVABUEVBVCZUIUKWNAWOVRABUELMUEWRUSAUEVAWPVRWQZWSAUYCUXTUIUMAIGUXMVUJT
      VUMVUNVHVNVKWTAGUXMTVUMVUNVQAUXNUIUFUGGUIUFUGZUXMUIUFUGZUMUGIUIUFUGZXAHUE
      UFUGZUHUGZWAUGZVUPUMUGZUXOUIUFUGZXAUWCUEUFUGZUHUGZWAUGZAGUXMTVUMVUNXBAVUO
      VUTVUPUMUAVNAVVAVUQVUPUMUGZVUSVUPUMUGZWAUGVVEAVUQVUSVUPAIVUJVEAXAVLUSZVUR
      VLUSZVUSVLUSXCAHVLUSZUWTVVIAHCUIUFUGZUEBDUHUGZUHUGZWAUGZVLUBAVVKVVMACNVEZ
      AUEVLUSZVVLVLUSVVMVLUSXDABDLOVDZUEVVLWFWDZWIWMZVAHUEVBVCZXAVURWFWDAUXMVUM
      VEZAVUPUKWNZUXMUKWNZVUNAVULVWBVWCXJVUMUXMXEXFXGZXHAVVBVVFVVDVVGWAAIUXMVUJ
      VUMVUNXBAVVDXAVURVUPUMUGZUHUGVVGAVVCVWEXAUHAVVCVURUWBUEUFUGZUMUGVWEAHUWBU
      EVVSVUGABUILMUIWRUSAXKVRWQZUYBVSAVWFVUPVURUMABUIUEUHUGZUFUGBUEUIUHUGZUFUG
      VWFVUPVWHVWIBUFUIUEWCXDXIXLABUIUELUYBUIUTUSZAWJVRZXMABUEUILVWKUYBXMXNXOVK
      XOAXAVURVUPVVHAXCVRVVTVWAVWDXPXQVJXQWTAVVNUWBUMUGVVKUWBUMUGZVVMUWBUMUGZWA
      UGUWCUVGUIUFUGZUEUVJUHUGZWAUGAVVKVVMUWBVVOVVRVUGVWGXHAHVVNUWBUMUBVNAVWNVW
      LVWOVWMWAACBNLMXBAVWOUEVVLUWBUMUGZUHUGVWMAUVJVWPUEUHAVWPVVLBBUHUGZUMUGUVJ
      AUWBVWQVVLUMABLXRZXOADBBOLLMMXSXTXOAUEVVLUWBVVPAXDVRVVQVUGVWGXPXQVJYAAUYM
      UXMUMUGUYIUXMUMUGZUYLUXMUMUGZUJUGUXOUIUVGUEUFUGZUHUGZVTUVGUVJUHUGZUHUGZWA
      UGZUYJUVLUHUGZUJUGAUYIUYLUXMVUDVUIVUMVUNVHAIUYMUXMUMUCVNAVXEVWSVXFVWTUJAV
      XEUYEUXMUMUGZUYHUXMUMUGZWAUGVWSAVXBVXGVXDVXHWAAVXBUIUYDUXMUMUGZUHUGVXGAVX
      AVXIUIUHACBUENLMUYBVSXOAUIUYDUXMVUKUYQVUMVUNXPXQAVTBUYGUHUGZUHUGZUXMUMUGV
      TVXJUXMUMUGZUHUGVXHVXDAVTVXJUXMUYSAVUAVRZABUYGLVUBVDVUMVUNXPAUYHVXKUXMUMA
      VTBUYGVXMLVUBYBVNAVXCVXLVTUHAVXJBUWBUHUGZUMUGUYGUWBUMUGZVXLVXCAUYGUWBBVUB
      VUGLVWGMXSAUXMVXNVXJUMAUXMUWBBUHUGZVXNAUXMBUIUOUJUGZUFUGZVXPUEVXQBUFYCXLA
      UYTVWJVXRVXPULLWJBUIYDVCYEZAUWBBVUGLYFVKXOAVXCUYGVWQUMUGVXOACBDBNLOLMMYGA
      UWBVWQUYGUMVWRXOXQYKXOYKVJAUYEUYHUXMUYRVUCVUMVUNXHXQAVXFUYJUYKUXMUMUGZUHU
      GVWTAUVLVXTUYJUHAVXTUYKVXPUMUGUVLAUXMVXPUYKUMVXSXOAEBUWBPLVUGMVWGXSXTXOAU
      YJUYKUXMVUEAVUFVRVUHVUMVUNXPXQVJYAAFBRLUDMYHYIAUWIUWRKVLAUVPVLUSZUQZUVRUW
      HUWQUVRVYBUVPUKWNZUWHUWQXJZUVPUKUVQUOUVPUKULZUVQUKUOVYEUVQUKUEUFUGZUKUVPU
      KUEUFYJUEYLUSVYFUKULYMUEYNYOYPUKUOWNVYEUOUKYQYRVRUUBUUCAVYAVYCVYDAVYAVYCU
      QZUQZUWGUWPJVYHUWFUWOVYHUWFUWMBUMUGZUEUMUGUWMBUEUHUGZUMUGUWOVYHUWEVYIUEUM
      VYHUWEUWKBUMUGZUWLBUMUGZUJUGVYIVYHUWAVYKUWDVYLUJVYHUWAUVGUWJBUMUGZUJUGVYK
      VYHUVTVYMUVGUJVYHVYMUVTVYHUVPFBAVYAVYCUUDZAFVLUSVYGRYSZAUYTVYGLYSZABUKWNV
      YGMYSZXPZUUEXOVYHCUWJBAUYPVYGNYSZVYHUVPFVYNVYOVDZVYPVYQVHXQVYHHBUMUGZBUMU
      GZVYMUMUGWUAUWJUMUGUWDVYLVYHWUAUWJBVYHHBAVVJVYGVVSYSZVYPVYQVQVYTVYPVYHUVP
      FVYNVYOAVYAVYCUUFAFUKWNVYGUDYSUUGZVYQUUAVYHWUBUWCVYMUVTUMVYHWUBHVWQUMUGUW
      CVYHHBBWUCVYPVYPVYQVYQYTVYHUWBVWQHUMVYHBVYPXRXOXQVYRVJVYHHBUWJWUCVYPVYTVY
      QWUDWSUUHVJVYHUWKUWLBVYHCUWJVYSVYTVFZVYHHUWJWUCVYTWUDVQZVYPVYQVHXQVNVYHUW
      MBUEVYHUWKUWLWUEWUFVFVYPVVPVYHXDVRVYQUEUKWNVYHUULVRYTVYHVYJUWNUWMUMVYHUYT
      VVPVYJUWNULVYPXDBUEUUIVCXOWTUUJUUKUUMUUNUUOUUPUUQ $.
  $}

  ${
    $d r A $.  $d r B $.  $d r M $.  $d r N $.  $d r ph $.  $d r T $.
    $d r X $.
    cubic.r $e |- R = { 1 ,
      ( ( -u 1 + ( _i x. ( sqr ` 3 ) ) ) / 2 ) ,
      ( ( -u 1 - ( _i x. ( sqr ` 3 ) ) ) / 2 ) } $.
    cubic.a $e |- ( ph -> A e. CC ) $.
    cubic.z $e |- ( ph -> A =/= 0 ) $.
    cubic.b $e |- ( ph -> B e. CC ) $.
    cubic.c $e |- ( ph -> C e. CC ) $.
    cubic.d $e |- ( ph -> D e. CC ) $.
    cubic.x $e |- ( ph -> X e. CC ) $.
    cubic.t $e |- ( ph -> T = ( ( ( N + ( sqr ` G ) ) / 2 ) ^c ( 1 / 3 ) ) ) $.
    cubic.g $e |- ( ph -> G = ( ( N ^ 2 ) - ( 4 x. ( M ^ 3 ) ) ) ) $.
    cubic.m $e |- ( ph -> M = ( ( B ^ 2 ) - ( 3 x. ( A x. C ) ) ) ) $.
    cubic.n $e |- ( ph -> N = ( ( ( 2 x. ( B ^ 3 ) ) -
      ( ( 9 x. A ) x. ( B x. C ) ) ) + ( ; 2 7 x. ( ( A ^ 2 ) x. D ) ) ) ) $.
    cubic.0 $e |- ( ph -> M =/= 0 ) $.
    $( The cubic equation, which gives the roots of an arbitrary
       (nondegenerate) cubic function.  Use ~ rextp to convert the existential
       quantifier to a triple disjunction.  (Contributed by Mario Carneiro,
       26-Apr-2015.) $)
    cubic $p |- ( ph -> ( ( ( ( A x. ( X ^ 3 ) ) + ( B x. ( X ^ 2 ) ) ) +
      ( ( C x. X ) + D ) ) = 0 <-> E. r e. R X =
       -u ( ( ( B + ( r x. T ) ) + ( M / ( r x. T ) ) ) / ( 3 x. A ) ) ) ) $=
      ( c3 cexp co cmul c2 caddc cc0 wceq cv c1 cdiv cneg wa wrex csqr cfv ccxp
      cc wcel c9 cmin c7 cdc 2cn cn0 3nn0 expcl sylancl mulcl sylancr 9nn nncni
      mulcld subcld 2nn0 7nn decnncl sqcld addcld eqeltrd c4 4cn sqrcld halfcld
      3cn reccli cxpcl oveq1d cn 3nn cxproot eqtrd sqsqrd a1i wne 4nn nnne0i cz
      nn0zi expne0d mulne0d oveq2d subsq syl2anc nncand 3eqtr3d 3netr4d necon3i
      3ne0 mul02d oveq1 divne0d cxpne0d eqnetrd cubic2 1cubr anbi1i anass bitri
      syl 2ne0 rexbii2 syl6bbr ) ABKUEUFUGUHUGCKUIUFUGUHUGUJUGDKUHUGEUJUGUJUGUK
      ULLUMZUEUFUGUNULZKCYHGUHUGZUJUGIYJUOUGUJUGUEBUHUGUOUGUPULZUQZLVBURYKLFURA
      BCDEGHUSUTZIJKLNOPQRSAGJYMUJUGZUIUOUGZUNUEUOUGZVAUGZVBTAYOVBVCZYPVBVCZYQV
      BVCAYNAJYMAJUICUEUFUGZUHUGZVDBUHUGZCDUHUGZUHUGZVEUGZUIVFVGZBUIUFUGZEUHUGZ
      UHUGZUJUGVBUCAUUEUUIAUUAUUDAUIVBVCZYTVBVCZUUAVBVCVHACVBVCUEVIVCZUUKPVJCUE
      VKVLUIYTVMVNAUUBUUCAVDVBVCBVBVCUUBVBVCVDVOVPNVDBVMVNACDPQVQVQVRAUUFVBVCUU
      HVBVCUUIVBVCUUFUIVFVSVTWAVPAUUGEABNWBRVQUUFUUHVMVNWCWDZAHAHJUIUFUGZWEIUEU
      FUGZUHUGZVEUGZVBUAAUUNUUPAJUUMWBZAWEVBVCZUUOVBVCZUUPVBVCWFAIVBVCUULUUTAIC
      UIUFUGZUEBDUHUGZUHUGZVEUGVBUBAUVAUVCACPWBAUEVBVCUVBVBVCUVCVBVCWIABDNQVQUE
      UVBVMVNVRWDZVJIUEVKVLZWEUUOVMVNZVRWDZWGZWCZWHZUEWIXMWJZYOYPWKVLWDAGUEUFUG
      YQUEUFUGZYOAGYQUEUFTWLAYRUEWMVCUVLYOULUVJWNYOUEWOVLWPUVHAYMUIUFUGZHUUQAHU
      VGWQUAWPZUBUCAGYQUKTAYOYPUVJAYNUIUVIUUJAVHWRAYNJYMVEUGZUHUGZUKUVOUHUGZWSY
      NUKWSAUUPUKUVPUVQAWEUUOUUSAWFWRUVEWEUKWSAWEWTXAWRAIUEUVDUDUEXBVCAUEVJXCWR
      XDXEAUUNUVMVEUGZUUNUUQVEUGUVPUUPAUVMUUQUUNVEUVNXFAJVBVCYMVBVCUVRUVPULUUMU
      VHJYMXGXHAUUNUUPUURUVFXIXJAUVOAJYMUUMUVHVRXNXKYNUKUVPUVQYNUKUVOUHXOXLYDUI
      UKWSAYEWRXPYSAUVKWRXQXRXSYKYLLFVBYHFVCZYKUQYHVBVCZYIUQZYKUQUVTYLUQUVSUWAY
      KYHFMXTYAUVTYIYKYBYCYFYG $.
  $}

  $( Work out a quartic binomial.  (You would think that by this point it would
     be faster to use ~ binom , but it turns out to be just as much work to put
     it into this form after clearing all the sums and calculating binomial
     coefficients.)  (Contributed by Mario Carneiro, 6-May-2015.) $)
  binom4 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) ^ 4 ) =
    ( ( ( A ^ 4 ) +
        ( 4 x. ( ( A ^ 3 ) x. B ) ) ) +
      ( ( 6 x. ( ( A ^ 2 ) x. ( B ^ 2 ) ) ) +
      ( ( 4 x. ( A x. ( B ^ 3 ) ) ) +
        ( B ^ 4 ) ) ) ) ) $=
    ( cc wcel caddc co c4 cexp c3 cmul c2 c1 sylancl 3cn addcld adddird mulassd
    eqtrd oveq2d oveq12d wa df-4 oveq2i cn0 wceq addcl 3nn0 expp1 syl5eq binom3
    oveq1d simpl expcl sqcld simpr mulcld mulcl sylancr adddid syl5req a1i df-3
    mul32d 2nn0 sqvald eqtr4d mulcomd 4nn0 addassd 3eqtrd oveq1i ax-1cn mulid2d
    c6 add4d 3p3e6 syl5eqr 3p1e4 addcomli ) ACDZBCDZUAZABEFZGHFZWCIHFZWCJFZAIHF
    ZIAKHFZBJFZJFZEFZIABKHFZJFZJFZBIHFZEFZEFZWCJFZAGHFZGWGBJFZJFZEFZVNWHWLJFZJF
    ZGAWOJFZJFZBGHFZEFZEFZEFZWBWDWCILEFZHFZWFGXKWCHUBUCWBWCCDIUDDZXLWFUEABUFUGW
    CIUHMUIWBWEWQWCJABUJUKWBWRWQAJFZWQBJFZEFWSIWTJFZEFZIXCJFZXEEFZEFZWTXRIXEJFZ
    XGEFZEFZEFZEFZXJWBWQABWBWKWPWBWGWJWBVTXMWGCDVTWAULZUGAIUMMZWBICDZWICDWJCDNW
    BWHBWBAYFUNZVTWAUOZUPZIWIUQURZOZWBWNWOWBYHWMCDWNCDNWBAWLYFWBBYJUNZUPZIWMUQU
    RZWBWAXMWOCDYJUGBIUMMZOZOYFYJUSWBXNXTXOYDEWBXNWKAJFZWPAJFZEFXTWBWKWPAYMYRYF
    PWBYSXQYTXSEWBYSWGAJFZWJAJFZEFXQWBWGWJAYGYLYFPWBUUAWSUUBXPEWBWSAXKHFZUUAGXK
    AHUBUCWBVTXMUUCUUAUEYFUGAIUHMUTWBUUBIWIAJFZJFXPWBIWIAYHWBNVAZYKYFQWBUUDWTIJ
    WBUUDWHAJFZBJFWTWBWHBAYIYJYFVCWBUUFWGBJWBWGAKLEFZHFZUUFIUUGAHVBUCWBVTKUDDZU
    UHUUFUEYFVDAKUHMUTUKRSRTRWBYTWNAJFZWOAJFZEFXSWBWNWOAYPYQYFPWBUUJXRUUKXEEWBU
    UJIWMAJFZJFXRWBIWMAUUEYOYFQWBUULXCIJWBUULAAJFZWLJFXCWBAWLAYFYNYFVCWBWHUUMWL
    JWBAYFVEUKVFSRWBWOAYQYFVGTRTRWBXOWKBJFZWPBJFZEFWTXREFZYBEFYDWBWKWPBYMYRYJPW
    BUUNUUPUUOYBEWBUUNWTWJBJFZEFUUPWBWGWJBYGYLYJPWBUUQXRWTEWBUUQIWIBJFZJFXRWBIW
    IBUUEYKYJQWBUURXCIJWBUURWHBBJFZJFXCWBWHBBYIYJYJQWBWLUUSWHJWBBYJVESVFSRSRWBU
    UOWNBJFZWOBJFZEFYBWBWNWOBYPYQYJPWBUUTYAUVAXGEWBUUTIWMBJFZJFYAWBIWMBUUEYOYJQ
    WBUVBXEIJWBUVBAWLBJFZJFXEWBAWLBYFYNYJQWBUVCWOAJWBWOBUUGHFZUVCIUUGBHVBUCWBWA
    UUIUVDUVCUEYJVDBKUHMUTSRSRWBXGBXKHFZUVAGXKBHUBUCWBWAXMUVEUVAUEYJUGBIUHMUTTR
    TWBWTXRYBWBWGBYGYJUPZWBYHXCCDXRCDNWBWHWLYIYNUPZIXCUQURZWBYAXGWBYHXECDYACDNW
    BAWOYFYQUPZIXEUQURZWBWAGUDDZXGCDYJVHBGUMMZOZVIVJTWBYEXQWTEFZXSYCEFZEFXJWBXQ
    XSWTYCWBWSXPWBVTUVKWSCDYFVHAGUMMZWBYHWTCDXPCDNUVFIWTUQURZOWBXRXEUVHUVIOUVFW
    BXRYBUVHUVMOVOWBUVNXBUVOXIEWBUVNWSXPWTEFZEFXBWBWSXPWTUVPUVQUVFVIWBXAUVRWSEW
    BXAXPLWTJFZEFZUVRWBXAXKWTJFUVTGXKWTJUBVKWBILWTUUELCDWBVLVAZUVFPUIWBUVSWTXPE
    WBWTUVFVMSRSVFWBUVOXRXREFZXEYBEFZEFXIWBXRXEXRYBUVHUVIUVHUVMVOWBXDUWBXHUWCEW
    BXDIIEFZXCJFUWBUWDVNXCJVPVKWBIIXCUUEUUEUVGPVQWBXHXEYAEFZXGEFUWCWBXFUWEXGEWB
    XFLXEJFZYAEFZUWEWBXFLIEFZXEJFUWGUWHGXEJILGNVLVRVSVKWBLIXEUWAUUEUVIPVQWBUWFX
    EYAEWBXEUVIVMUKRUKWBXEYAXGUVIUVJUVLVIRTVFTRVJVJ $.

  ${
    dquart.b $e |- ( ph -> B e. CC ) $.
    dquart.c $e |- ( ph -> C e. CC ) $.
    dquart.x $e |- ( ph -> X e. CC ) $.
    dquart.s $e |- ( ph -> S e. CC ) $.
    dquart.m $e |- ( ph -> M = ( ( 2 x. S ) ^ 2 ) ) $.
    dquart.m0 $e |- ( ph -> M =/= 0 ) $.
    dquart.i $e |- ( ph -> I e. CC ) $.
    dquart.i2 $e |- ( ph -> ( I ^ 2 ) =
      ( ( -u ( S ^ 2 ) - ( B / 2 ) ) + ( ( C / 4 ) / S ) ) ) $.
    $( Lemma for ~ dquart .  (Contributed by Mario Carneiro, 6-May-2015.) $)
    dquartlem1 $p |- ( ph ->
     ( ( ( ( X ^ 2 ) + ( ( M + B ) / 2 ) ) +
       ( ( ( ( M / 2 ) x. X ) - ( C / 4 ) ) / S ) ) = 0
       <-> ( X = ( -u S + I ) \/ X = ( -u S - I ) ) ) ) $=
      ( c2 co caddc cdiv cmul cexp c4 cmin cc0 wceq c1 cneg wo sqcld wcel mulcl
      cc 2cn sylancr eqeltrd addcld halfcld mulcld 4cn a1i nnne0i divcld subcld
      wne 4nn wa eqnetrrd wb sqne0 syl mpbid mulne0b mpbird simprd 2ne0 addassd
      diveq0ad oveq1d divdird divrec2d div23d sqvald oveq2d sqmul sqvali oveq1i
      divsubdird syl6eq mulassd 3eqtrd divcan3d eqtrd divcan4d addsub12d negcld
      3eqtr4d subsub4d 2timesd subnegd negdi2d eqtr3d eqeq1d bitr3d ax-1cn mp1i
      oveq12d halfcl ax-1ne0 divne0i pm3.2i divmuldiv syl22anc mulid2d divcan2d
      2t2e4 nncand eqtr2d quad2 recidi oveq2i syl5eq eqeq2d orbi12d 3bitrd
      div1d ) AGPUAQZFBRQZPSQZRQZFPSQZGTQZCUBSQZUCQZDSQZRQZUDUEZUFPSQZYFTQZDGTQ
      ZDPUAQZEPUAQZUCQZPSQZRQZRQZUDUEZGDUGZERQZPYQTQZSQZUEZGUUGEUCQZUUISQZUEZUH
      GUUHUEZGUULUEZUHAYOPSQZUDUEYPUUFAYOPAYIYNAYFYHAGJUIZAYGAFBAFPDTQZPUAQZULL
      AUUSAPULUJZDULUJZUUSULUJZUMKPDUKUNZUIUOZHUPUQZUPAYMDAYKYLAYJGAFUVEUQZJURZ
      ACUBIUBULUJAUSUTZUBUDVDAUBVEVAUTZVBZVCKAPUDVDZDUDVDZAUVLUVMVFZUUSUDVDZAUU
      TUDVDZUVOAFUUTUDLMVGAUVCUVPUVOVHUVDUUSVIVJVKAUVAUVBUVNUVOVHUMKPDVLUNVMVNZ
      VBZUPUVAAUMUTZUVLAVOUTZVQAUUQUUEUDAUUQYFYHYNRQZRQZPSQYFPSQZUWAPSQZRQUUEAY
      OUWBPSAYFYHYNUURUVFUVRVPVRAYFUWAPUURAYHYNUVFUVRUPUVSUVTVSAUWCYRUWDUUDRAYF
      PUURUVSUVTVTAUWDUUSGTQZYHYLDSQZUCQZRQZPSQUWEPSQZUWGPSQZRQUUDAUWAUWHPSAUWA
      YHUWEUWFUCQZRQUWHAYNUWKYHRAYNYKDSQZUWFUCQUWKAYKYLDUVHUVKKUVQWGAUWLUWEUWFU
      CAUWLYJDSQZGTQUWEAYJGDUVGJKUVQWAAUWMUUSGTAUWMUUSDTQZDSQUUSAYJUWNDSAPYTTQZ
      PDDTQZTQYJUWNAYTUWPPTADKWBWCAYJPUWOTQZPSQUWOAFUWQPSAFUUTPPTQZYTTQZUWQLAUU
      TPPUAQZYTTQZUWSAUVAUVBUUTUXAUEUMKPDWDUNUWTUWRYTTPUMWEWFWHAPPYTUVSUVSADKUI
      ZWIWJVRAUWOPAUVAYTULUJUWOULUJUMUXBPYTUKUNUVSUVTWKWLZAPDDUVSKKWIWPVRAUUSDU
      VDKUVQWMWLVRWLVRWLWCAYHUWEUWFUVFAUUSGUVDJURZAYLDUVKKUVQVBZWNWLVRAUWEUWGPU
      XDAYHUWFUVFUXEVCUVSUVTVSAUWIYSUWJUUCRAUWIPYSTQZPSQYSAUWEUXFPSAPDGUVSKJWIV
      RAYSPADGKJURUVSUVTWKWLAUWGUUBPSAYTYTUGZBPSQZUCQZUCQZUWFUCQYTUXIUWFRQZUCQU
      WGUUBAYTUXIUWFUXBAUXGUXHAYTUXBWOABHUQZVCUXEWQAYHUXJUWFUCAYHYTYTRQZUXHRQZY
      TYTUXHRQZRQZUXJAYHYJUXHRQUXNAFBPUVEHUVSUVTVSAYJUXMUXHRAYJUWOUXMUXCAYTUXBW
      RWLVRWLAYTYTUXHUXBUXBUXLVPAYTUXOUGZUCQUXPUXJAYTUXOUXBAYTUXHUXBUXLUPWSAUXQ
      UXIYTUCAYTUXHUXBUXLWTWCXAWJVRAUUAUXKYTUCOWCWPVRXFWJXFWJXBXCAYQDUUCEGUFULU
      JZYQULUJAXDUFXGXEYQUDVDAUFPXDUMXHVOXIUTKAUUBAYTUUAUXBAENUIZVCZUQJNAYTUBYQ
      UUCTQZTQZUCQYTUUBUCQUUAAUYBUUBYTUCAUYBUBUUBUBSQZTQUUBAUYAUYCUBTAUYAUFUUBT
      QZUWRSQZUYCAUXRUUBULUJUVAUVLVFZUYFUYAUYEUEUXRAXDUTUXTUYFAUVAUVLUMVOXJUTZU
      YGUFUUBPPXKXLAUYDUUBUWRUBSAUUBUXTXMUWRUBUEAXOUTXFWLWCAUUBUBUXTUVIUVJXNWLW
      CAYTUUAUXBUXSXPXQXRAUUKUUOUUNUUPAUUJUUHGAUUJUUHUFSQUUHUUIUFUUHSPUMVOXSZXT
      AUUHAUUGEADKWOZNUPYEYAYBAUUMUULGAUUMUULUFSQUULUUIUFUULSUYHXTAUULAUUGEUYIN
      VCYEYAYBYCYD $.

    dquart.d $e |- ( ph -> D e. CC ) $.
    dquart.3 $e |- ( ph -> ( ( ( M ^ 3 ) + ( ( 2 x. B ) x. ( M ^ 2 ) ) ) +
      ( ( ( ( B ^ 2 ) - ( 4 x. D ) ) x. M ) + -u ( C ^ 2 ) ) ) = 0 ) $.
    $( Lemma for ~ dquart .  (Contributed by Mario Carneiro, 6-May-2015.) $)
    dquartlem2 $p |- ( ph ->
      ( ( ( ( M + B ) / 2 ) ^ 2 ) - ( ( ( C ^ 2 ) / 4 ) / M ) ) = D ) $=
      ( co cmul caddc c2 cdiv cexp c4 cmin wcel 2cn mulcl sylancr sqcld eqeltrd
      cc addcld a1i cc0 wne 2ne0 sqdivd sq2 oveq2i syl6eq oveq1d 4cn 4nn nnne0i
      divcld subcld subdird div23d eqcomd oveq12d wceq c3 binom2 syl2anc mulcld
      divcan1d adddird c1 df-3 2nn0 expp1 sylancl syl5req mulassd mul32d eqtr3d
      cn0 sqvald oveq2d 3eqtr4d eqtrd 3eqtrd 3nn0 addsubassd eqtr4d cneg negcld
      expcl addassd negsubd 3eqtr3d subeq0d wb subsub23 syl3anc mpbid mulcan2ad
      divsubdird divcan3d ) AGBUASZUBUCSUBUDSZCUBUDSZUEUCSZGUCSZUFSXLUBUDSZUEUC
      SZXPUFSZDAXMXRXPUFAXMXQUBUBUDSZUCSXRAXLUBAGBAGUBETSZUBUDSUMMAYAAUBUMUGZEU
      MUGYAUMUGUHLUBEUIUJUKULZIUNZYBAUHUOZUBUPUQAURUOUSXTUEXQUCUTVAVBVCAXSDGAXR
      XPAXQUEAXLYDUKZUEUMUGZAVDUOZUEUPUQAUEVEVFUOZVGZAXOGAXNUEACJUKZYHYIVGZYCNV
      GZVHQYCNAXSGTSXRGTSZXPGTSZUFSXQGTSZUEUCSZXOUFSZDGTSZAXRXPGYJYMYCVIAYNYQYO
      XOUFAYQYNAXQGUEYFYCYHYIVJVKAXOGYLYCNVRVLAYPXNUFSZUEUCSUEYSTSZUEUCSYRYSAYT
      UUAUEUCAYTUEDTSZGTSZUUAAYPUUCUFSZXNVMZYTUUCVMZAUUDGVNUDSZUBBTSZGUBUDSZTSZ
      UASZBUBUDSZGTSZUASZUUCUFSZUUKUULUUBUFSZGTSZUASZXNAYPUUNUUCUFAYPUUIUBGBTSZ
      TSZUASZUULUASZGTSUVAGTSZUUMUASUUNAXQUVBGTAGUMUGZBUMUGZXQUVBVMYCIGBVOVPVCA
      UVAUULGAUUIUUTAGYCUKZAYBUUSUMUGUUTUMUGUHAGBYCIVQUBUUSUIUJZUNABIUKZYCVSAUV
      CUUKUUMUAAUVCUUIGTSZUUTGTSZUASUUKAUUIUUTGUVFUVGYCVSAUVIUUGUVJUUJUAAUUGGUB
      VTUASZUDSZUVIVNUVKGUDWAVAAUVDUBWIUGUVLUVIVMYCWBGUBWCWDWEAUUHGTSZGTSUUHGGT
      SZTSUVJUUJAUUHGGAYBUVEUUHUMUGUHIUBBUIUJZYCYCWFAUUTUVMGTAUBGTSBTSUUTUVMAUB
      GBYEYCIWFAUBGBYEYCIWGWHVCAUUIUVNUUHTAGYCWJWKWLVLWMVCWNVCAUUOUUKUUMUUCUFSZ
      UASUURAUUKUUMUUCAUUGUUJAUVDVNWIUGUUGUMUGYCWOGVNWTWDAUUHUUIUVOUVFVQUNZAUUL
      GUVHYCVQAUUBGAYGDUMUGUUBUMUGVDQUEDUIUJZYCVQZWPAUUQUVPUUKUAAUULUUBGUVHUVRY
      CVIWKWQAUURXNAUUKUUQUVQAUUPGAUULUUBUVHUVRVHYCVQZUNZYKAUURXNWRZUASUUKUUQUW
      BUASUASUURXNUFSUPAUUKUUQUWBUVQUVTAXNYKWSXAAUURXNUWAYKXBRXCXDWNAYPUMUGUUCU
      MUGXNUMUGUUEUUFXEAXQGYFYCVQZUVSYKYPUUCXNXFXGXHAUEDGYHQYCWFWMVCAYPXNUEUWCY
      KYHYIXJAYSUEADGQYCVQYHYIXKXCWNXIWM $.

    dquart.j $e |- ( ph -> J e. CC ) $.
    dquart.j2 $e |- ( ph -> ( J ^ 2 ) =
      ( ( -u ( S ^ 2 ) - ( B / 2 ) ) - ( ( C / 4 ) / S ) ) ) $.
    $( Solve a depressed quartic equation.  To eliminate ` S ` , which is the
       square root of a solution ` M ` to the resolvent cubic equation, apply
       ~ cubic or one of its variants.  (Contributed by Mario Carneiro,
       6-May-2015.) $)
    dquart $p |- ( ph ->
       ( ( ( ( X ^ 4 ) + ( B x. ( X ^ 2 ) ) ) + ( ( C x. X ) + D ) ) = 0 <->
         ( ( X = ( -u S + I ) \/ X = ( -u S - I ) ) \/
           ( X = ( S + J ) \/ X = ( S - J ) ) ) ) ) $=
      ( c4 cexp co c2 cmul caddc cc0 wceq cdiv cmin wo cneg cc wcel sqcld mulcl
      2cn sylancr eqeltrd addcld halfcld binom2 syl2anc oveq2i cn0 2nn0 expmuld
      2t2e4 a1i syl5reqr mul12d wne 2ne0 divcan2d oveq2d mulcomd adddird 3eqtrd
      eqtrd oveq12d 4nn0 sylancl mulcld add12d oveq1d addassd 4cn nnne0i divcld
      expcl 4nn subcld wa eqnetrrd sqne0 syl mpbid mulne0b mpbird simprd subdid
      wb divcan5d mulassd eqtr3d divassd syl5eqr sqdivd binom2sub sqmuld syl6eq
      divdird sq2 eqtr2d divsubdird div23d sqvald mul32d subsubd eqtr4d 3eqtr3d
      divcan3d pnncand negcld add4d negsubd dquartlem2 subsq mul0ord dquartlem1
      eqeq1d sqneg mulneg2 eqcomd negeqd divneg2d 3eqtr2d eqeq2d orbi12d 3bitrd
      negnegd 3bitr3d ) AIUBUCUDZBIUEUCUDZUFUDZUGUDZCIUFUDZDUGUDUGUDZUHUIUUEHBU
      GUDZUEUJUDZUGUDZHUEUJUDZIUFUDZCUBUJUDZUKUDZEUJUDZUGUDZUULUUQUKUDZUFUDZUHU
      IUURUHUIZUUSUHUIZULIEUMZFUGUDUIIUVCFUKUDUIULZIEGUGUDZUIZIEGUKUDZUIZULZULA
      UUIUUTUHAUULUEUCUDZUUQUEUCUDZUKUDZUUIUUTAUVLHUUEUFUDZUUGUUKUEUCUDZUGUDZUG
      UDZUVMUUHCUEUCUDZUBUJUDZHUJUDZUKUDZUKUDZUKUDUVOUVTUGUDZUUIAUVJUVPUVKUWAUK
      AUVJUUEUEUCUDZUEUUEUUKUFUDUFUDZUGUDZUVNUGUDZUVMUUGUGUDZUVNUGUDUVPAUUEUNUO
      UUKUNUOUVJUWFUIAILUPZAUUJAHBAHUEEUFUDZUEUCUDZUNNAUWIAUEUNUOZEUNUOZUWIUNUO
      ZURMUEEUQUSZUPUTZJVAZVBZUUEUUKVCVDAUWEUWGUVNUGAUWEUUDUVMUUFUGUDZUGUDUWGAU
      WCUUDUWDUWRUGAUUDIUEUEUFUDZUCUDUWCUWSUBIUCVIVEAIUEUELUEVFUOAVGVJZUWTVHVKA
      UWDUUEUEUUKUFUDZUFUDZUUJUUEUFUDZUWRAUEUUEUUKUWKAURVJZUWHUWQVLAUXBUUEUUJUF
      UDUXCAUXAUUJUUEUFAUUJUEUWPUXDUEUHVMZAVNVJZVOVPAUUEUUJUWHUWPVQVTAHBUUEUWOJ
      UWHVRVSWAAUUDUVMUUFAIUNUOUBVFUOUUDUNUOLWBIUBWKWCZAHUUEUWOUWHWDZABUUEJUWHW
      DZWEVTWFAUVMUUGUVNUXHAUUDUUFUXGUXIVAZAUUKUWQUPZWGVSAUVKHIUFUDZCUEUJUDZUKU
      DZUWIUJUDZUEUCUDUXNUEUCUDZUWJUJUDZUWAAUUQUXOUEUCAUEUUPUFUDZUWIUJUDUUQUXOA
      UUPEUEAUUNUUOAUUMIAHUWOVBZLWDZACUBKUBUNUOAWHVJZUBUHVMAUBWLWIVJZWJZWMZMUXD
      AUXEEUHVMZAUXEUYEWNZUWIUHVMZAUWJUHVMZUYGAHUWJUHNOWOAUWMUYHUYGXCUWNUWIWPWQ
      WRZAUWKUWLUYFUYGXCURMUEEWSUSWTXAZUXFXDAUXRUXNUWIUJAUXRUEUUNUFUDZUEUUOUFUD
      ZUKUDUXNAUEUUNUUOUXDUXTUYCXBAUYKUXLUYLUXMUKAUEUUMUFUDZIUFUDUYKUXLAUEUUMIU
      XDUXSLXEAUYMHIUFAHUEUWOUXDUXFVOWFXFAUECUFUDZUBUJUDZUYLUXMAUECUBUXDKUYAUYB
      XGAUYOUYNUWSUJUDUXMUWSUBUYNUJVIVEACUEUEKUXDUXDUXFUXFXDXHXFWAVTWFXFWFAUXNU
      WIAUXLUXMAHIUWOLWDZACKVBZWMUWNUYIXIAHUEUCUDZUUEUFUDZUXLCUFUDZUKUDZUVRUGUD
      ZHUJUDVUAHUJUDZUVSUGUDZUXQUWAAVUAUVRHAUYSUYTAUYRUUEAHUWOUPZUWHWDZAUXLCUYP
      KWDZWMAUVQUBACKUPUYAUYBWJZUWOOXMAVUBUXPHUWJUJAUXPUXLUEUCUDZUEUXLUXMUFUDUF
      UDZUKUDZUXMUEUCUDZUGUDZVUBAUXLUNUOUXMUNUOUXPVUMUIUYPUYQUXLUXMXJVDAVUKVUAV
      ULUVRUGAVUIUYSVUJUYTUKAHIUWOLXKAVUJUXLUEUXMUFUDZUFUDUYTAUEUXLUXMUXDUYPUYQ
      VLAVUNCUXLUFACUEKUXDUXFVOVPVTWAAVULUVQUEUEUCUDZUJUDUVRACUEKUXDUXFXIVUOUBU
      VQUJXNVEXLWAXONWAAVUDUVMUUHUKUDZUVSUGUDUWAAVUCVUPUVSUGAVUCUYSHUJUDZUYTHUJ
      UDZUKUDVUPAUYSUYTHVUFVUGUWOOXPAVUQUVMVURUUHUKAVUQUYRHUJUDZUUEUFUDUVMAUYRU
      UEHVUEUWHUWOOXQAVUSHUUEUFAVUSHHUFUDZHUJUDHAUYRVUTHUJAHUWOXRWFAHHUWOUWOOYC
      VTWFVTAVURHUUHUFUDZHUJUDUUHAUYTVVAHUJAUYTHCUFUDIUFUDVVAAHICUWOLKXSAHCIUWO
      KLXEVTWFAUUHHACIKLWDZUWOOYCVTWAVTWFAUVMUUHUVSUXHVVBAUVRHVUHUWOOWJZXTYAYBV
      SWAAUVMUVOUVTUXHAUUGUVNUXJUXKVAAUUHUVSVVBVVCWMYDAUVOUUHUVSUMZUGUDZUGUDUUG
      UUHUGUDZUVNVVDUGUDZUGUDZUWBUUIAUUGUVNUUHVVDUXJUXKVVBAUVSVVCYEYFAVVEUVTUVO
      UGAUUHUVSVVBVVCYGVPAVVHVVFDUGUDUUIAVVGDVVFUGAVVGUVNUVSUKUDDAUVNUVSUXKVVCY
      GABCDEFHIJKLMNOPQRSYHVTVPAUUGUUHDUXJVVBRWGVTYBVSAUULUNUOUUQUNUOUVLUUTUIAU
      UEUUKUWHUWQVAZAUUPEUYDMUYJWJZUULUUQYIVDXFYLAUURUUSAUULUUQVVIVVJVAAUULUUQV
      VIVVJWMYJAUVAUVDUVBUVIABCEFHIJKLMNOPQYKAUULUUPUVCUJUDZUGUDZUHUIIUVCUMZGUG
      UDZUIZIVVMGUKUDZUIZULUVBUVIABCUVCGHIJKLAEMYEAHUWIUMZUEUCUDZUEUVCUFUDZUEUC
      UDAHUWJVVSNAUWMVVSUWJUIUWNUWIYMWQYAAVVTVVRUEUCAUWKUWLVVTVVRUIURMUEEYNUSWF
      YAOTAGUEUCUDEUEUCUDZUMZBUEUJUDZUKUDZUUOEUJUDZUKUDVWDVWEUMZUGUDUVCUEUCUDZU
      MZVWCUKUDZUUOUVCUJUDZUGUDUAAVWDVWEAVWBVWCAVWAAEMUPYEABJVBWMAUUOEUYCMUYJWJ
      YGAVWDVWIVWFVWJUGAVWBVWHVWCUKAVWAVWGAVWGVWAAUWLVWGVWAUIMEYMWQYOYPWFAUUOEU
      YCMUYJYQWAYRYKAVVLUUSUHAUULUUQUMZUGUDVVLUUSAVWKVVKUULUGAUUPEUYDMUYJYQVPAU
      ULUUQVVIVVJYGXFYLAVVOUVFVVQUVHAVVNUVEIAVVMEGUGAEMUUBZWFYSAVVPUVGIAVVMEGUK
      VWLWFYSYTUUCYTUUA $.
  $}

  ${
    quart1.a $e |- ( ph -> A e. CC ) $.
    quart1.b $e |- ( ph -> B e. CC ) $.
    quart1.c $e |- ( ph -> C e. CC ) $.
    quart1.d $e |- ( ph -> D e. CC ) $.
    quart1.p $e |- ( ph -> P = ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) $.
    quart1.q $e |- ( ph -> Q =
      ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ) $.
    quart1.r $e |- ( ph -> R = ( ( D - ( ( C x. A ) / 4 ) ) +
 ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) $.
    $( Closure lemmas for ~ quart .  (Contributed by Mario Carneiro,
       7-May-2015.) $)
    quart1cl $p |- ( ph -> ( P e. CC /\ Q e. CC /\ R e. CC ) ) $=
      ( cc wcel c8 co c4 c3 cdiv c2 cexp cmul 3cn 8nn nncni nnne0i divcli sqcld
      cmin mulcl sylancr subcld eqeltrd caddc mulcld halfcld 3nn0 expcl sylancl
      cn0 a1i cc0 wne divcld addcld c1 c6 cdc c5 4cn 4nn 1nn0 decnncl 2nn0 5nn0
      6nn deccl 4nn0 3jca ) AFPQGPQHPQAFCUARUBSZBUCUDSZUESZULSPMACWEJAWCPQWDPQW
      EPQUARUFRUGUHZRUGUIZUJABIUKZWCWDUMUNUOUPAGDBCUESZUCUBSZULSZBUAUDSZRUBSZUQ
      SPNAWKWMADWJKAWIABCIJURUSUOAWLRABPQZUAVCQWLPQIUTBUAVAVBRPQAWFVDRVEVFAWGVD
      VGVHUPAHEDBUESZTUBSZULSZWDCUESZVIVJVKZUBSZUAUCVLVKZVJVKZUBSZBTUDSZUESZULS
      ZUQSPOAWQXFAEWPLAWOTADBKIURTPQAVMVDTVEVFATVNUIVDVGUOAWTXEAWRWSAWDCWHJURWS
      PQAWSVIVJVOVSVPZUHVDWSVEVFAWSXGUIVDVGAXCPQXDPQZXEPQUAXBUFXBXAVJUCVLVQVRVT
      VSVPZUHXBXIUIUJAWNTVCQXHIWABTVAVBXCXDUMUNUOVHUPWB $.

    quart1.x $e |- ( ph -> X e. CC ) $.
    quart1.y $e |- ( ph -> Y = ( X + ( A / 4 ) ) ) $.
    $( Lemma for ~ quart1 .  (Contributed by Mario Carneiro, 6-May-2015.) $)
    quart1lem $p |- ( ph -> D = ( ( ( ( A ^ 4 ) / ; ; 2 5 6 ) +
      ( P x. ( ( A / 4 ) ^ 2 ) ) ) + ( ( Q x. ( A / 4 ) ) + R ) ) ) $=
      ( co c4 cexp c2 c5 c6 cdiv cmul caddc cmin c8 c1 c3 mulcld halfcld subcld
      cdc cc wcel cn0 expcl sylancl 8nn nncni a1i cc0 wne nnne0i divcld 4cn 4nn
      3nn0 adddird oveq1d divassd sqvald mul32d eqtrd 2cn 4t2e8 mulcomli oveq2i
      syl6eqr 2ne0 divmuldivd eqtr4d oveq12d subdird df-4 syl5eq div23d 3eqtr4d
      wceq expp1 sqcld 4nn0 subadd23d addcomd 3eqtrd 1nn0 6nn decnncl 2nn0 5nn0
      deccl divcli sylancr addsubd addcld ppncand cneg add12d negsubdi2d oveq2d
      3cn mulcl addsub4d ax-1cn 2p1e3 addcomli syl5eqr mulid2d 3eqtr3d divcan2d
      oveq1i divdiv1d 4t4e16 syl6eq mulcli mulne0i mul32i 8t2e16 eqtr4i oveq12i
      2exp4 4p4e8 expadd mp3an 2exp8 3eqtr3i 3eqtr2d 3eqtr2i pnpcan2d addsub12d
      2timesd pncand sqdivd sqvali eqtri mulcomd mulassd 2p2e4 expaddd syl5eqel
      eqnetri negeqd 3eqtr3rd eqeltrd negsubd pncan3d eqtr2d ) ABUAUBTZUCUDUPZU
      EUPZUFTZFBUAUFTZUCUBTZUGTZUHTZGUVEUGTZHUHTZUHTUVHEUVHUITZUHTEAUVJUVKUVHUH
      AUVJUVAUJUFTZUAUFTZBUCUBTZCUGTZUJUFTZUITZDBUGTZUAUFTZUHTZEUVOUKUEUPZUFTZU
      LUVCUFTZUVAUGTZUITZUHTZUVSUITZUHTUVQUWFUHTZUVKAUVIUVTHUWGUHAUVIUVSUVPUITZ
      UVMUHTZUVSUVQUHTUVTADBCUGTZUCUFTZUITZBULUBTZUJUFTZUHTZUVEUGTUWMUVEUGTZUWO
      UVEUGTZUHTUVIUWJAUWMUWOUVEADUWLMAUWKABCKLUMZUNZUOAUWNUJABUQURZULUSURZUWNU
      QURKVKBULUTVAZUJUQURAUJVBVCZVDZUJVEVFAUJVBVGZVDZVHZABUAKUAUQURAVIVDZUAVEV
      FAUAVJVGVDZVHZVLAGUWPUVEUGPVMAUWIUWQUVMUWRUHAUWIDUVEUGTZUWLUVEUGTZUITUWQA
      UVSUXLUVPUXMUIADBUAMKUXIUXJVNAUVPUWKBUGTZUCUAUGTZUFTZUXMAUVPUXNUJUFTUXPAU
      VOUXNUJUFAUVOBBUGTZCUGTUXNAUVNUXQCUGABKVOVMABBCKKLVPVQVMUXOUJUXNUFUAUCUJV
      IVRVSVTWAWBAUWKUCBUAUWSUCUQURZAVRVDZKUXIUCVEVFAWCVDZUXJWDWEWFADUWLUVEMUWT
      UXKWGWEAUVMUWOBUGTZUAUFTUWRAUVLUYAUAUFAUVLUWNBUGTZUJUFTUYAAUVAUYBUJUFAUVA
      BULUKUHTZUBTZUYBUAUYCBUBWHWAAUXAUXBUYDUYBWLKVKBULWMVAWIVMAUWNBUJUXCKUXEUX
      GWJVQVMAUWOBUAUXHKUXIUXJVNVQWFWKAUVSUVPUVMAUVRUAADBMKUMUXIUXJVHZAUVOUJAUV
      NCABKWNZLUMZUXEUXGVHZAUVLUAAUVAUJAUXAUAUSURZUVAUQURZKWOBUAUTVAZUXEUXGVHZU
      XIUXJVHZWPAUVSUVQUYEAUVMUVPUYMUYHUOZWQWRAHEUVSUITUWEUHTUWGQAEUWEUVSNAUWBU
      WDAUVOUWAUYGUWAUQURAUWAUKUEWSWTXAZVCZVDZUWAVEVFAUWAUYOVGZVDZVHZAUWCUQURUY
      JUWDUQURULUVCXNUVCUVBUEUCUDXBXCXDWTXAZVCZUVCVUAVGZXEUYKUWCUVAXOXFZUOZUYEX
      GWEWFAUVQUVSUWFUYNUYEAEUWENVUEXHXIAUWHEUVQUWEUHTZUHTEUVHXJZUHTUVKAUVQEUWE
      UYNNVUEXKAVUFVUGEUHAUVPUWDUHTZUVMUWBUHTZUITZXJVUIVUHUITVUGVUFAVUHVUIAUVPU
      WDUYHVUDXHAUVMUWBUYMUYTXHXLAVUJUVHAVUJVUHUWBUVMUHTZUITUVPUWBUITZUWDUVMUIT
      ZUHTZUVHAVUIVUKVUHUIAUVMUWBUYMUYTWQXMAUVPUWDUWBUVMUYHVUDUYTUYMXPAUWBVUMUH
      TZUVDUWBULUVMUAUFTZUGTZUITZUHTZVUNUVHAVUOUWBUVDVUQUITZUHTVUSAVUMVUTUWBUHA
      VUMUVDUCUVDUGTZUHTZVUQVVAUHTZUITVUTAUWDVVBUVMVVCUIAULUVAUGTZUVCUFTULUVDUG
      TZUWDVVBAULUVAUVCULUQURZAXNVDZUYKUVCUQURAVUBVDZUVCVEVFAVUCVDZVNAULUVAUVCV
      VGUYKVVHVVIWJAVVEUKUVDUGTZVVAUHTZVVBAVVEUKUCUHTZUVDUGTVVKVVLULUVDUGUCUKUL
      VRXQXRXSYDAUKUCUVDUKUQURAXQVDZUXSAUVAUVCUYKVVHVVIVHZVLXTAVVJUVDVVAUHAUVDV
      VNYAVMVQYBAUAVUPUGTZVUQUKVUPUGTZUHTZUVMVVCAVVOUYCVUPUGTVVQUAUYCVUPUGWHYDA
      ULUKVUPVVGVVMAUVMUAUYMUXIUXJVHZVLWIAUVMUAUYMUXIUXJYCAVVPVVAVUQUHAVVPVUPUV
      LUWAUFTZVVAAVUPVVRYAAVUPUVLUAUAUGTZUFTVVSAUVLUAUAUYLUXIUXIUXJUXJYEVVTUWAU
      VLUFYFWAYGZAVVSUVAUJUWAUGTZUFTZUCVWCUCUFTZUGTVVAAUVAUJUWAUYKUXEUYQUXGUYSY
      EAVWCUCAUVAVWBUYKVWBUQURAUJUWAUXDUYPYHVDZVWBVEVFAUJUWAUXDUYPUXFUYRYIVDZVH
      UXSUXTYCAVWDUVDUCUGAVWDUVAVWBUCUGTZUFTUVDAUVAVWBUCUYKVWEUXSVWFUXTYEVWGUVC
      UVAUFVWGUJUCUGTZUWAUGTUCUAUBTZVWIUGTZUVCUJUWAUCUXDUYPVRYJVWIVWHVWIUWAUGVW
      IUWAVWHYNYKYLYNYMUCUAUAUHTZUBTZUCUJUBTVWJUVCVWKUJUCUBYOWAUXRUYIUYIVWLVWJW
      LVRWOWOUCUAUAYPYQYRYSUUAWAYGXMYTWRXMYBWFAUVDVUQVVAVVNAVVFVUPUQURVUQUQURXN
      VVRULVUPXOXFZAUXRUVDUQURVVAUQURVRVVNUCUVDXOXFUUBVQXMAUWBUVDVUQUYTVVNVWMUU
      CVQAVULUWBVUMUHAVULUWBUWBUHTZUWBUITUWBAUVPVWNUWBUIAUCUVPUCUFTZUGTUCUWBUGT
      UVPVWNAVWOUWBUCUGAVWOUVOVWHUFTUWBAUVOUJUCUYGUXEUXSUXGUXTYEVWHUWAUVOUFYKWA
      YGXMAUVPUCUYHUXSUXTYCAUWBUYTUUDYBVMAUWBUWBUYTUYTUUEVQVMAUVGVURUVDUHAUVGCU
      LUJUFTZUVNUGTZUITZUVFUGTCUVFUGTZVWQUVFUGTZUITVURAFVWRUVFUGOVMACVWQUVFLAVW
      PUQURZUVNUQURVWQUQURULUJXNUXDUXFXEZUYFVWPUVNXOXFZAUVEUXKWNZWGAVWSUWBVWTVU
      QUIAVWSCUVNUWAUFTZUGTCUVNUGTZUWAUFTUWBAUVFVXECUGAUVFUVNUAUCUBTZUFTZVXEABU
      AKUXIUXJUUFZVXGUWAUVNUFVXGVVTUWAUAVIUUGYFUUHZWAYGXMACUVNUWALUYFUYQUYSVNAV
      XFUVOUWAUFACUVNLUYFUUIVMYTAVWQVXHUGTZULUVLVXGUFTZUGTZVWTVUQAVWQUVNUGTZVXG
      UFTULUVLUGTZVXGUFTVXKVXMAVXNVXOVXGUFAVXNVWPUVNUVNUGTZUGTZVVDUJUFTZVXOAVWP
      UVNUVNVXAAVXBVDUYFUYFUUJAVXRVWPUVAUGTVXQAULUVAUJVVGUYKUXEUXGWJAUVAVXPVWPU
      GAUVABUCUCUHTZUBTVXPVXSUABUBUUKWAABUCUCKUCUSURAXBVDZVXTUULXTXMVQAULUVAUJV
      VGUYKUXEUXGVNYTVMAVWQUVNVXGVXCUYFAVXGUWAUQVXJUYQUUMZVXGVEVFAVXGUWAVEVXJUY
      RUUNVDZVNAULUVLVXGVVGUYLVYAVYBVNYBAUVFVXHVWQUGVXIXMAVUPVXLULUGAVUPVVSVXLV
      WAVXGUWAUVLUFVXJWAWBXMWKWFWRXMWKWRUUOAUVMUWBUVPUWDUYMUYTUYHVUDXPUUPXMAEUV
      HNAUVDUVGVVNAFUVFAFVWRUQOACVWQLVXCUOUUQVXDUMXHZUURWRWRXMAUVHEVYCNUUSUUT
      $.

    $( Depress a quartic equation.  (Contributed by Mario Carneiro,
       6-May-2015.) $)
    quart1 $p |- ( ph -> ( ( ( X ^ 4 ) + ( A x. ( X ^ 3 ) ) ) +
      ( ( B x. ( X ^ 2 ) ) + ( ( C x. X ) + D ) ) ) =
        ( ( ( Y ^ 4 ) + ( P x. ( Y ^ 2 ) ) ) + ( ( Q x. Y ) + R ) ) ) $=
      ( co c4 cexp c2 cmul caddc c3 c8 cdiv c5 cdc oveq1d wcel wceq 4cn a1i cc0
      c6 cc wne 4nn nnne0i divcld binom4 syl2anc cn0 3nn0 expcl mul12d divcan2d
      sylancl oveq2d mulcomd 3eqtrd 6nn nncni sqcld mulassd c1 3cn 2cn mulcomli
      3t2e6 8nn 8t2e16 oveq12i wa pm3.2i 2ne0 divcan5 mp3an eqtr3i 1nn0 decnncl
      oveq2i div12d syl5eqr divcli mulcom sylancr sqdivd sqvali 4t4e16 3eqtr4rd
      eqtri syl6eq 3eqtr4d mulcld df-3 2nn0 expp1 mp2an oveq1i expdivd divdiv1d
      3eqtri 3eqtr4a eqtr4d expmul 4t2e8 sq2 2exp8 oveq12d addcld mulcl halfcld
      4nn0 5nn0 deccl quart1cl addassd eqtrd adddid add4d adddird eqtr3d subcld
      cmin subdird divassd 3eqtr2d simp1d eqeltrd simp2d simp3d pncan3d 3eqtr3d
      binom2 2t2e4 syl5eq div23d addsub12d mulid2d 3m1e2 ax-1cn 3eqtr3a addcomd
      subsub2d ppncand npcand quart1lem 3eqtrrd ) AJUAUBTZFJUCUBTZUDTZUETZGJUDT
      ZHUETZUETIUAUBTZBIUFUBTZUDTZUETZUFUGUHTZBUCUBTZUDTZIUCUBTZUDTZBUFUBTZUGUH
      TZUCUHTZIUDTZBUAUBTZUCUIUJZUQUJZUHTZUETZUETZUVDUETZUETZUVGUETUVKUWGUVGUET
      ZUETUVKCUVOUDTZDIUDTZEUETZUETZUETAUVEUWHUVGUEAUVEUVKUWFUETZUVDUETUWHAUVBU
      WNUVDUEAUVBIBUAUHTZUETZUAUBTZUVHUAUVIUWOUDTUDTZUETZUQUVOUWOUCUBTZUDTZUDTZ
      UAIUWOUFUBTZUDTUDTZUWOUAUBTZUETZUETZUETZUWNAJUWPUAUBSUKAIURULZUWOURULZUWQ
      UXHUMRABUAKUAURULZAUNUOZUAUPUSAUAUTVAUOZVBZIUWOVCVDAUWSUVKUXGUWFUEAUWRUVJ
      UVHUEAUWRUVIUAUWOUDTZUDTUVIBUDTUVJAUAUVIUWOUXLAUXIUFVEULZUVIURULRVFIUFVGV
      JZUXNVHAUXOBUVIUDABUAKUXLUXMVIVKAUVIBUXQKVLVMVKAUXBUVPUXFUWEUEAUQUWTUDTZU
      VOUDTUQUWTUVOUDTZUDTUVPUXBAUQUWTUVOUQURULAUQVNVOUOZAUWOUXNVPZAIRVPZVQAUVN
      UXRUVOUDAUVMUVLUDTZUQUVMVRUQUJZUHTZUDTZUVNUXRAUYCUVMUQUYDUHTZUDTUYFUYGUVL
      UVMUDUCUFUDTZUCUGUDTZUHTZUYGUVLUYHUQUYIUYDUHUFUCUQVSVTWBWAUGUCUYDUGWCVOZV
      TWDWAWEUFURULZUGURULZUGUPUSZWFUCURULZUCUPUSZWFUYJUVLUMVSUYMUYNUYKUGWCVAZW
      GUYOUYPVTWHWGUFUGUCWIWJWKWNAUVMUQUYDABKVPZUXTUYDURULAUYDVRUQWLVNWMZVOUOZU
      YDUPUSAUYDUYSVAUOZWOWPAUVLURULZUVMURULZUVNUYCUMUFUGVSUYKUYQWQZUYRUVLUVMWR
      WSAUWTUYEUQUDAUWTUVMUAUCUBTZUHTUYEABUAKUXLUXMWTVUEUYDUVMUHVUEUAUAUDTUYDUA
      UNXAXBXDZWNXEVKXFUKAUXAUXSUQUDAUVOUWTUYBUYAVLVKXCAUXDUVTUXEUWDUEAUXDIUAUX
      CUDTZUDTVUGIUDTUVTAUAIUXCUXLRAUXJUXPUXCURULUXNVFUWOUFVGVJZVHAIVUGRAUAUXCU
      XLVUHXGVLAVUGUVSIUDAVUGUAUVQUYDUHTZUAUHTZUDTZUVSAUXCVUJUAUDAUVQUAUFUBTZUH
      TUVQUYDUAUDTZUHTUXCVUJVULVUMUVQUHVULUAUCVRUETZUBTZVUEUAUDTZVUMUFVUNUAUBXH
      WNUXKUCVEULZVUOVUPUMUNXIUAUCXJXKVUEUYDUAUDVUFXLXOWNABUAUFKUXLUXMUXPAVFUOX
      MAUVQUYDUAABURULZUXPUVQURULKVFBUFVGVJZUYTUXLVUAUXMXNXPVKAUVQUGUCUDTZUHTVU
      IUVSVUKVUTUYDUVQUHWDWNAUVQUGUCVUSUYMAUYKUOZUYOAVTUOZUYNAUYQUOZUYPAWHUOZXN
      AVUIUAAUVQUYDVUSUYTVUAVBUXLUXMVIXPXQUKVMAUXEUWAUAUAUBTZUHTUWDABUAUAKUXLUX
      MUAVEULZAYFUOXMVVEUWCUWAUHUCUGUBTZVVEUWCUCUCUBTZUAUBTZVVGVVEUCUCUAUDTZUBT
      ZVVIVVGUYOVUQVVFVVKVVIUMVTXIYFUCUCUAXRWJVVJUGUCUBUAUCUGUNVTXSWAWNWKVVHUAU
      AUBXTXLWKYAWKWNXEYBYBYBVMUKAUVKUWFUVDAUVHUVJAUXIVVFUVHURULRYFIUAVGVJABUVI
      KUXQXGYCZAUVPUWEAUVNUVOAVUBVUCUVNURULVUDUYRUVLUVMYDWSZUYBXGZAUVTUWDAUVSIA
      UVRAUVQUGVUSVVAVVCVBZYEZRXGZAUWAUWCAVURVVFUWAURULKYFBUAVGVJUWCURULAUWCUWB
      UQUCUIXIYGYHVNWMZVOUOUWCUPUSAUWCVVRVAUOVBZYCZYCZAFUVCAFURULZGURULZHURULZA
      BCDEFGHKLMNOPQYIZUUAZAJAJUWPURSAIUWORUXNYCUUBZVPXGZYJYKUKAUVKUWGUVGVVLAUW
      FUVDVWAVWHYCAUVFHAGJAVWBVWCVWDVWEUUCZVWGXGAVWBVWCVWDVWEUUDZYCZYJAUWIUWMUV
      KUEAUWIUWJUWEFUCIUWOUDTZUDTZUWTUETZUDTZUETZUETZUVGUETUWJVWPUVGUETZUETUWMA
      UWGVWQUVGUEAUWGUWFFUVOUDTZVWOUETZUETUVPVWSUETZVWPUETVWQAUVDVWTUWFUEAUVDFU
      VOVWNUETZUDTVWTAUVCVXBFUDAUVCUWPUCUBTZUVOVWMUETUWTUETZVXBAJUWPUCUBSUKAUXI
      UXJVXCVXDUMRUXNIUWOUUGVDAUVOVWMUWTUYBAUYOVWLURULVWMURULVTAIUWORUXNXGUCVWL
      YDWSZUYAYJVMVKAFUVOVWNVWFUYBAVWMUWTVXEUYAYCZYLYKVKAUVPUWEVWSVWOVVNVVTAFUV
      OVWFUYBXGAFVWNVWFVXFXGZYMAVXAUWJVWPUEAUVNFUETZUVOUDTVXAUWJAUVNFUVOVVMVWFU
      YBYNAVXHCUVOUDAVXHUVNCUVNYQTZUETCAFVXIUVNUEOVKAUVNCVVMLUUEYKUKYOUKVMUKAUW
      JVWPUVGACUVOLUYBXGAUWEVWOVVTVXGYCVWKYJAVWRUWLUWJUEABCUDTZUCUHTZUVRYQTZIUD
      TZUWDFUWTUDTZUETZUETZGIUDTZGUWOUDTZHUETZUETZUETVXMVXQUETZVXOVXSUETZUETVWR
      UWLAVXMVXOVXQVXSAVXLIAVXKUVRAVXJABCKLXGYEZVVOYPZRXGAUWDVXNVVSAFUWTVWFUYAX
      GZYCAGIVWIRXGZAVXRHAGUWOVWIUXNXGZVWJYCYMAVWPVXPUVGVXTUEAVWPUWEFVWMUDTZVXN
      UETZUETUVTVYHUETZVXOUETVXPAVWOVYIUWEUEAFVWMUWTVWFVXEUYAYLVKAUVTUWDVYHVXNV
      VQVVSAFVWMVWFVXEXGVYEYMAVYJVXMVXOUEAVYJUVTFBUCUHTZUDTZIUDTZUETUVSVYLUETZI
      UDTVXMAVYHVYMUVTUEAFIUCUWOUDTZUDTZUDTFVYKIUDTZUDTVYHVYMAVYPVYQFUDAVYPIVYK
      UDTVYQAVYOVYKIUDAUCVYKUCUHTZUDTVYOVYKAVYRUWOUCUDAVYRBUCUCUDTZUHTUWOABUCUC
      KVVBVVBVVDVVDXNVYSUABUHUUHWNXEVKAVYKUCABKYEZVVBVVDVIYOVKAIVYKRVYTVLYKVKAV
      WMVYPFUDAUCIUWOVVBRUXNVHVKAFVYKIVWFVYTRVQXFVKAUVSVYLIVVPAFVYKVWFVYTXGRYNA
      VYNVXLIUDAVYNUVSVXKUFUVSUDTZYQTZUETZVXLAVYLWUBUVSUEAVYLVXIVYKUDTCVYKUDTZU
      VNVYKUDTZYQTWUBAFVXIVYKUDOUKACUVNVYKLVVMVYTYRAWUDVXKWUEWUAYQACBUDTZUCUHTW
      UDVXKACBUCLKVVBVVDYSAWUFVXJUCUHACBLKVLUKYOAUVNBUDTZUCUHTUFUVRUDTZUCUHTWUE
      WUAAWUGWUHUCUHAWUGUFUVQUDTUGUHTZWUHAUVLUVQUDTUVLUVMBUDTZUDTWUIWUGAUVQWUJU
      VLUDAUVQBVUNUBTZWUJUFVUNBUBXHWNAVURVUQWUKWUJUMKXIBUCXJVJUUIVKAUFUVQUGUYLA
      VSUOZVUSVVAVVCUUJAUVLUVMBVUBAVUDUOUYRKVQXCAUFUVQUGWULVUSVVAVVCYSYKUKAUVNB
      UCVVMKVVBVVDYSAUFUVRUCWULVVOVVBVVDYSUUFYBVMVKAWUCVXKUVSWUAYQTUETVXKWUAUVS
      YQTZYQTVXLAUVSVXKWUAVVPVYCAUYLUVSURULWUAURULVSVVPUFUVSYDWSZUUKAVXKWUAUVSV
      YCWUNVVPUUQAWUMUVRVXKYQAWUAVRUVSUDTZYQTZWUMUVRAWUOUVSWUAYQAUVSVVPUULVKAUF
      VRYQTZUVSUDTUCUVSUDTWUPUVRWUQUCUVSUDUUMXLAUFVRUVSWULVRURULAUUNUOVVPYRAUVR
      UCVVOVVBVVDVIUUOYOVKYTYKUKYTUKVMAUVGVXQVXRUETZHUETVXTAUVFWURHUEAUVFGUWPUD
      TWURAJUWPGUDSVKAGIUWOVWIRUXNYLYKUKAVXQVXRHVYFVYGVWJYJYKYBAUWKVYAEVYBUEAVX
      LGUETZIUDTUWKVYAAWUSDIUDAWUSGVXLUETDVXKYQTZUVRUETZVXLUETZDAVXLGVYDVWIUUPA
      GWVAVXLUEPUKAWVBWUTVXKUETDAWUTUVRVXKADVXKMVYCYPVVOVYCUURADVXKMVYCUUSYKVMU
      KAVXLGIVYDVWIRYNYOABCDEFGHIJKLMNOPQRSUUTYBXFVKVMVKUVA $.
  $}

  ${
    quartlem1.p $e |- ( ph -> P e. CC ) $.
    quartlem1.q $e |- ( ph -> Q e. CC ) $.
    quartlem1.r $e |- ( ph -> R e. CC ) $.
    quartlem1.u $e |- ( ph -> U = ( ( P ^ 2 ) + ( ; 1 2 x. R ) ) ) $.
    quartlem1.v $e |- ( ph -> V = ( ( -u ( 2 x. ( P ^ 3 ) ) -
      ( ; 2 7 x. ( Q ^ 2 ) ) ) + ( ; 7 2 x. ( P x. R ) ) ) ) $.
    $( Lemma for ~ quart .  (Contributed by Mario Carneiro, 6-May-2015.) $)
    quartlem1 $p |- ( ph ->
     ( U = ( ( ( 2 x. P ) ^ 2 ) - ( 3 x. ( ( P ^ 2 ) - ( 4 x. R ) ) ) ) /\
       V = ( ( ( 2 x. ( ( 2 x. P ) ^ 3 ) ) - ( 9 x. ( ( 2 x. P ) x.
          ( ( P ^ 2 ) - ( 4 x. R ) ) ) ) ) + ( ; 2 7 x. -u ( Q ^ 2 ) ) ) ) ) $=
      ( c2 cmul co c3 c4 cmin cc wcel c8 cexp wceq c9 c7 cdc caddc c1 2cn sqmul
      cneg sylancr sq2 oveq1i syl6eq oveq1d 4cn a1i sqcld subdird eqtr4d ax-1cn
      3cn 3p1e4 subaddrii mulid2 syl5eq syl eqtr2d mulcl 1nn0 2nn decnncl nncni
      subsubd subdid 4t3e12 mulcomli mulassd syl5eqr oveq2d 3eqtr4d cn0 mulexpd
      3nn0 cu2 8nn expcl sylancl mul12d eqtrd 9nn mulcld df-3 oveq2i 2nn0 expp1
      mulcomd mul4d 4t2e8 oveq12d 9t8e72 negsubdi2d 8p1e9 mulid2d eqtr3d negeqd
      7nn0 3eqtrd 7nn mulneg2 negcld addsubd addcld negsubd jca ) AELBMNZLUANZO
      BLUANZPDMNZQNZMNZQNZUBFLXPOUANZMNZUCXPXTMNZMNZQNZLUDUEZCLUANZUJMNZUFNZUBA
      XRUGLUEZDMNZUFNZXQOXRMNZYMQNZQNZEYBAYNXQYOQNZYMUFNYQAXRYRYMUFAYRPOQNZXRMN
      ZXRAYRPXRMNZYOQNYTAXQUUAYOQAXQLLUANZXRMNZUUAALRSZBRSZXQUUCUBUHGLBUIUKUUBP
      XRMULUMUNUOAPOXRPRSZAUPUQZORSZAVBUQZABGURZUSUTAXRRSZYTXRUBUUJUUKYTUGXRMNX
      RYSUGXRMPOUGUPVBVAVCVDUMXRVEVFVGVHUOAXQYOYMAXPAUUDUUEXPRSUHGLBVIUKZURAUUH
      UUKYORSVBUUJOXRVIUKAYLRSDRSZYMRSYLUGLVJVKVLVMIYLDVIUKVNUTJAYAYPXQQAYAYOOX
      SMNZQNYPAOXRXSUUIUUJAUUFUUMXSRSUPIPDVIUKZVOAYMUUNYOQAYMOPMNZDMNUUNUUPYLDM
      POYLUPVBVPVQUMAOPDUUIUUGIVRVSVTUTVTWAAYKLBOUANZMNZUJZUDLUEZBDMNZMNZUFNZYH
      YIMNZUJZUFNZFAYGUVCYJUVEUFAYGTUURMNZUCUURMNZUVBQNZQNUVGUVHQNZUVBUFNUVCAYD
      UVGYFUVIQAYDLTUUQMNZMNUVGAYCUVKLMAYCLOUANZUUQMNUVKALBOUUDAUHUQZGOWBSZAWDU
      QWCUVLTUUQMWEUMUNVTALTUUQUVMTRSZATWFVMZUQZAUUEUVNUUQRSZGWDBOWGWHZWIWJAUCU
      URTUVAMNZQNZMNUVHUCUVTMNZQNYFUVIAUCUURUVTUCRSZAUCWKVMZUQZAUUDUVRUURRSZUHU
      VSLUUQVIUKZAUVOUVARSZUVTRSUVPABDGIWLZTUVAVIUKVOAYEUWAUCMAYEXPXRMNZXPXSMNZ
      QNUWAAXPXRXSUULUUJUUOVOAUWJUURUWKUVTQAUWJLBXRMNZMNUURALBXRUVMGUUJVRAUWLUU
      QLMAUWLXRBMNZUUQABXRGUUJWQAUUQBLUGUFNZUANZUWMOUWNBUAWMWNAUUELWBSUWOUWMUBG
      WOBLWPWHVFUTVTWJAUWKLPMNZUVAMNUVTALBPDUVMGUUGIWRUWPTUVAMPLTUPUHWSVQUMUNWT
      WJVTAUVBUWBUVHQAUVBUCTMNZUVAMNUWBUWQUUTUVAMXAUMAUCTUVAUWEUVQUWIVRVSVTWAWT
      AUVGUVHUVBAUVOUWFUVGRSUVPUWGTUURVIUKZAUWCUWFUVHRSUWDUWGUCUURVIUKZAUUTRSUW
      HUVBRSUUTUDLXGVKVLVMUWIUUTUVAVIUKZVNAUVJUUSUVBUFAUVHUVGQNZUJUVJUUSAUVHUVG
      UWSUWRXBAUXAUURAUCTQNZUURMNZUXAUURAUCTUURUWEUVQUWGUSAUXCUGUURMNUURUXBUGUU
      RMUCTUGUWDUVPVAXCVDUMAUURUWGXDVFXEXFXEUOXHAYHRSZYIRSZYJUVEUBYHLUDWOXIVLVM
      ZACHURZYHYIXJUKWTAUVCUVDQNUUSUVDQNUVBUFNUVFFAUUSUVBUVDAUURUWGXKZUWTAUXDUX
      EUVDRSUXFUXGYHYIVIUKZXLAUVCUVDAUUSUVBUXHUWTXMUXIXNKWAVHXO $.
  $}

  ${
    $d x M $.  $d x P $.  $d x ph $.  $d x T $.  $d x U $.  $d x V $.
    quart.a $e |- ( ph -> A e. CC ) $.
    quart.b $e |- ( ph -> B e. CC ) $.
    quart.c $e |- ( ph -> C e. CC ) $.
    quart.d $e |- ( ph -> D e. CC ) $.
    quart.x $e |- ( ph -> X e. CC ) $.
    quart.e $e |- ( ph -> E = -u ( A / 4 ) ) $.
    quart.p $e |- ( ph -> P = ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) $.
    quart.q $e |- ( ph -> Q =
      ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ) $.
    quart.r $e |- ( ph -> R = ( ( D - ( ( C x. A ) / 4 ) ) +
 ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) $.
    quart.u $e |- ( ph -> U = ( ( P ^ 2 ) + ( ; 1 2 x. R ) ) ) $.
    quart.v $e |- ( ph -> V = ( ( -u ( 2 x. ( P ^ 3 ) ) -
      ( ; 2 7 x. ( Q ^ 2 ) ) ) + ( ; 7 2 x. ( P x. R ) ) ) ) $.
    quart.w $e |- ( ph -> W =
      ( sqr ` ( ( V ^ 2 ) - ( 4 x. ( U ^ 3 ) ) ) ) ) $.
    $( Closure lemmas for ~ quart .  (Contributed by Mario Carneiro,
       7-May-2015.) $)
    quartlem2 $p |- ( ph -> ( U e. CC /\ V e. CC /\ W e. CC ) ) $=
      ( cc wcel c2 cexp co c1 cdc cmul caddc quart1cl simp1d sqcld 1nn0 decnncl
      2nn nncni simp3d mulcl sylancr addcld eqeltrd c3 cneg cmin 2cn 3nn0 expcl
      cn0 sylancl negcld 2nn0 7nn simp2d subcld 7nn0 mulcld csqr cfv 4cn sqrcld
      c7 c4 3jca ) AIUFUGZKUFUGLUFUGAIFUHUIUJZUKUHULZHUMUJZUNUJUFUCAWJWLAFAFUFU
      GZGUFUGZHUFUGZABCDEFGHNOPQTUAUBUOZUPZUQAWKUFUGWOWLUFUGWKUKUHURUTUSVAAWMWN
      WOWPVBZWKHVCVDVEVFZAKUHFVGUIUJZUMUJZVHZUHWFULZGUHUIUJZUMUJZVIUJZWFUHULZFH
      UMUJZUMUJZUNUJUFUDAXFXIAXBXEAXAAUHUFUGWTUFUGZXAUFUGVJAWMVGVMUGZXJWQVKFVGV
      LVNUHWTVCVDVOAXCUFUGXDUFUGXEUFUGXCUHWFVPVQUSVAAGAWMWNWOWPVRUQXCXDVCVDVSAX
      GUFUGXHUFUGXIUFUGXGWFUHVTUTUSVAAFHWQWRWAXGXHVCVDVEVFZALKUHUIUJZWGIVGUIUJZ
      UMUJZVIUJZWBWCUFUEAXPAXMXOAKXLUQAWGUFUGXNUFUGZXOUFUGWDAWIXKXQWSVKIVGVLVNW
      GXNVCVDVSWEVFWH $.

    quart.s $e |- ( ph -> S = ( ( sqr ` M ) / 2 ) ) $.
    quart.m $e |- ( ph -> M =
      -u ( ( ( ( 2 x. P ) + T ) + ( U / T ) ) / 3 ) ) $.
    quart.t $e |- ( ph -> T = ( ( ( V + W ) / 2 ) ^c ( 1 / 3 ) ) ) $.
    quart.t0 $e |- ( ph -> T =/= 0 ) $.
    $( Closure lemmas for ~ quart .  (Contributed by Mario Carneiro,
       7-May-2015.) $)
    quartlem3 $p |- ( ph -> ( S e. CC /\ M e. CC /\ T e. CC ) ) $=
      ( cc wcel csqr cfv c2 cdiv co cmul caddc cneg 2cn quart1cl simp1d sylancr
      c3 mulcl c1 ccxp quartlem2 simp2d simp3d addcld halfcld cn cr 3nn nnrecre
      ax-mp recni cxpcl sylancl eqeltrd divcld 3cn a1i cc0 wne 3ne0 negcld 3jca
      sqrcld ) AIUMUNMUMUNJUMUNAIMUOUPZUQURUSUMUIAWNAMAMUQFUTUSZJVAUSZKJURUSZVA
      USZVGURUSZVBUMUJAWSAWRVGAWPWQAWOJAUQUMUNFUMUNZWOUMUNVCAWTGUMUNHUMUNABCDEF
      GHQRSTUCUDUEVDVEUQFVHVFAJNOVAUSZUQURUSZVIVGURUSZVJUSZUMUKAXBUMUNXCUMUNXDU
      MUNAXAANOAKUMUNZNUMUNZOUMUNZABCDEFGHKLNOBQRSTQUBUCUDUEUFUGUHVKZVLAXEXFXGX
      HVMVNVOXCVGVPUNXCVQUNVRVGVSVTWAXBXCWBWCWDZVNAKJAXEXFXGXHVEXIULWEVNVGUMUNA
      WFWGVGWHWIAWJWGWEWKWDZWMVOWDXJXIWL $.

    quart.m0 $e |- ( ph -> M =/= 0 ) $.
    quart.i $e |- ( ph -> I =
      ( sqr ` ( ( -u ( S ^ 2 ) - ( P / 2 ) ) + ( ( Q / 4 ) / S ) ) ) ) $.
    quart.j $e |- ( ph -> J =
      ( sqr ` ( ( -u ( S ^ 2 ) - ( P / 2 ) ) - ( ( Q / 4 ) / S ) ) ) ) $.
    $( Closure lemmas for ~ quart .  (Contributed by Mario Carneiro,
       7-May-2015.) $)
    quartlem4 $p |- ( ph -> ( S =/= 0 /\ I e. CC /\ J e. CC ) ) $=
      ( cc0 wne cc wcel csqr cfv c2 cdiv quartlem3 simp2d sqrcld 2cn a1i sqsqrd
      co cexp eqnetrd wb sqne0 syl mpbid 2ne0 divne0d cneg cmin c4 caddc simp1d
      sqcld negcld quart1cl halfcld subcld 4cn 4nn nnne0i divcld addcld eqeltrd
      3jca ) AIURUSMUTVANUTVAAIOVBVCZVDVEVLURUKAWRVDAOAIUTVAZOUTVAZJUTVAZABCDEF
      GHIJKLOPQBSTUAUBSUDUEUFUGUHUIUJUKULUMUNVFZVGZVHZVDUTVAAVIVJAWRVDVMVLZURUS
      ZWRURUSZAXEOURAOXCVKUOVNAWRUTVAXFXGVOXDWRVPVQVRVDURUSAVSVJVTVNZAMIVDVMVLZ
      WAZFVDVEVLZWBVLZGWCVEVLZIVEVLZWDVLZVBVCUTUPAXOAXLXNAXJXKAXIAIAWSWTXAXBWEZ
      WFWGAFAFUTVAZGUTVAZHUTVAZABCDEFGHSTUAUBUEUFUGWHZWEWIWJZAXMIAGWCAXQXRXSXTV
      GWCUTVAAWKVJWCURUSAWCWLWMVJWNXPXHWNZWOVHWPANXLXNWBVLZVBVCUTUQAYCAXLXNYAYB
      WJVHWPWQ $.

    $( The quartic equation, writing out all roots using square and cube root
       functions so that only direct substitutions remain, and we can actually
       claim to have a "quartic equation".  Naturally, this theorem is
       ridiculously long (see ~ quartfull ) if all the substitutions are
       performed.  (Contributed by Mario Carneiro, 6-May-2015.) $)
    quart $p |- ( ph -> ( ( ( ( X ^ 4 ) + ( A x. ( X ^ 3 ) ) ) +
      ( ( B x. ( X ^ 2 ) ) + ( ( C x. X ) + D ) ) ) = 0 <->
       ( ( X = ( ( E - S ) + I ) \/ X = ( ( E - S ) - I ) ) \/
         ( X = ( ( E + S ) + J ) \/ X = ( ( E + S ) - J ) ) ) ) ) $=
      ( vx c4 cexp co c3 cmul caddc c2 cc0 wceq cmin cneg wo cdiv oveq2d cc 4cn
      wcel a1i wne 4nn nnne0i divcld eqtrd quart1 eqeq1d quart1cl simp1d simp2d
      subnegd negcld eqeltrd subcld quartlem3 csqr cfv sqrcld 2cn 2ne0 divcan2d
      oveq1d sqsqrd eqtr2d quartlem4 sqcld halfcld addcld simp3d cv wrex ax-1cn
      c1 wa cz 3nn nnzi 1exp mulid2d oveq12d negeqd eqtr4d oveq1 eqeq2d anbi12d
      mp1i rspcev syl12anc mulcl sylancr ccxp quartlem2 cxproot sylancl subaddd
      cn cn0 addassd eqtr3d bitr4d eqcom syl6bb addsubassd orbi12d expcl c9 cdc
      3nn0 c7 quartlem1 simpld simprd mcubic mpbird dquart negsubd 3bitrd ) ARU
      SUTVABRVBUTVAVCVAVDVACRVEUTVAVCVADRVCVAEVDVAVDVAVDVAZVFVGRLVHVAZUSUTVAFUU
      OVEUTVAVCVAVDVAGUUOVCVAHVDVAVDVAZVFVGUUOIVIZMVDVAZVGZUUOUUQMVHVAZVGZVJZUU
      OINVDVAZVGZUUOINVHVAZVGZVJZVJRLIVHVAZMVDVAZVGZRUVHMVHVAZVGZVJZRLIVDVAZNVD
      VAZVGZRUVNNVHVAZVGZVJZVJAUUNUUPVFABCDEFGHRUUOSTUAUBUEUFUGUCAUUORBUSVKVAZV
      IZVHVARUVTVDVAALUWARVHUDVLARUVTUCABUSSUSVMVOZAVNVPZUSVFVQAUSVRVSVPZVTZWGW
      AWBWCAFGHIMNOUUOAFVMVOZGVMVOZHVMVOZABCDEFGHSTUAUBUEUFUGWDZWEZAUWFUWGUWHUW
      IWFZARLUCALUWAVMUDAUVTUWEWHWIZWJAIVMVOZOVMVOZJVMVOZABCDEFGHIJKLOPQBSTUAUB
      SUDUEUFUGUHUIUJUKULUMUNWKZWEZAVEIVCVAZVEUTVAOWLWMZVEUTVAOAUWRUWSVEUTAUWRV
      EUWSVEVKVAZVCVAUWSAIUWTVEVCUKVLAUWSVEAOAUWMUWNUWOUWPWFZWNVEVMVOZAWOVPVEVF
      VQAWPVPWQWAWRAOUXAWSWTUOAIVFVQZMVMVOZNVMVOZABCDEFGHIJKLMNOPQBSTUAUBSUDUEU
      FUGUHUIUJUKULUMUNUOUPUQXAZWFZAMVEUTVAIVEUTVAZVIZFVEVKVAZVHVAZGUSVKVAZIVKV
      AZVDVAZWLWMZVEUTVAUXNAMUXOVEUTUPWRAUXNAUXKUXMAUXIUXJAUXHAIUWQXBWHAFUWJXCW
      JZAUXLIAGUSUWKUWCUWDVTUWQAUXCUXDUXEUXFWEVTZXDWSWAAUWFUWGUWHUWIXEZAOVBUTVA
      VEFVCVAZOVEUTVAVCVAVDVAFVEUTVAZUSHVCVAZVHVAZOVCVAGVEUTVAZVIZVDVAVDVAVFVGU
      RXFZVBUTVAZXIVGZOUXSUYEJVCVAZVDVAZKUYHVKVAZVDVAZVBVKVAZVIZVGZXJZURVMXGZAX
      IVMVOZXIVBUTVAZXIVGZOUXSXIJVCVAZVDVAZKUYTVKVAZVDVAZVBVKVAZVIZVGZUYPUYQAXH
      VPVBXKVOUYSAVBXLXMVBXNYBAOUXSJVDVAZKJVKVAZVDVAZVBVKVAZVIVUEULAVUDVUJAVUCV
      UIVBVKAVUAVUGVUBVUHVDAUYTJUXSVDAJAUWMUWNUWOUWPXEZXOZVLAUYTJKVKVULVLXPWRXQ
      XRUYOUYSVUFXJURXIVMUYEXIVGZUYGUYSUYNVUFVUMUYFUYRXIUYEXIVBUTXSWCVUMUYMVUEO
      VUMUYLVUDVUMUYKVUCVBVKVUMUYIVUAUYJVUBVDVUMUYHUYTUXSVDUYEXIJVCXSZVLVUMUYHU
      YTKVKVUNVLXPWRXQXTYAYCYDAUXSUYBUYDJQKPOURAUXBUWFUXSVMVOWOUWJVEFYEYFAUXTUY
      AAFUWJXBAUWBUWHUYAVMVOVNUXRUSHYEYFWJAUYCAGUWKXBWHUXAVUKAJVBUTVAPQVDVAZVEV
      KVAZXIVBVKVAYGVAZVBUTVAZVUPAJVUQVBUTUMWRAVUPVMVOVBYLVOVURVUPVGAVUOAPQAKVM
      VOZPVMVOZQVMVOZABCDEFGHKLPQBSTUAUBSUDUEUFUGUHUIUJYHZWFZAVUSVUTVVAVVBXEZXD
      XCXLVUPVBYIYJWAVVDAQVEUTVAPVEUTVAZUSKVBUTVAZVCVAZVHVAZWLWMZVEUTVAVVHAQVVI
      VEUTUJWRAVVHAVVEVVGAPVVCXBAUWBVVFVMVOZVVGVMVOVNAVUSVBYMVOVVJAVUSVUTVVAVVB
      WEUUDKVBUUAYJUSVVFYEYFWJWSWAAKUXSVEUTVAVBUYBVCVAVHVAVGZPVEUXSVBUTVAVCVAUU
      BUXSUYBVCVAVCVAVHVAVEUUEUUCUYDVCVAVDVAVGZAFGHKPUWJUWKUXRUHUIUUFZUUGAVVKVV
      LVVMUUHUNUUIUUJAUXCUXDUXEUXFXEZANVEUTVAUXKUXMVHVAZWLWMZVEUTVAVVOANVVPVEUT
      UQWRAVVOAUXKUXMUXPUXQWJWSWAUUKAUVBUVMUVGUVSAUUSUVJUVAUVLAUUSUVIRVGZUVJAUU
      SLUURVDVAZRVGVVQARLUURUCUWLAUUQMAIUWQWHZUXGXDYKAUVIVVRRALUUQVDVAZMVDVAUVI
      VVRAVVTUVHMVDALIUWLUWQUULZWRALUUQMUWLVVSUXGYNYOWCYPUVIRYQYRAUVAUVKRVGZUVL
      AUVALUUTVDVAZRVGVWBARLUUTUCUWLAUUQMVVSUXGWJYKAUVKVWCRAVVTMVHVAUVKVWCAVVTU
      VHMVHVWAWRALUUQMUWLVVSUXGYSYOWCYPUVKRYQYRYTAUVDUVPUVFUVRAUVDUVORVGZUVPAUV
      DLUVCVDVAZRVGVWDARLUVCUCUWLAINUWQVVNXDYKAUVOVWERALINUWLUWQVVNYNWCYPUVORYQ
      YRAUVFUVQRVGZUVRAUVFLUVEVDVAZRVGVWFARLUVEUCUWLAINUWQVVNWJYKAUVQVWGRALINUW
      LUWQVVNYSWCYPUVQRYQYRYTYTUUM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Inverse trigonometric functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c arcsin $. $( Arcsine function $)
  $c arccos $. $( Arccosine function $)
  $c arctan $. $( Arctangent function $)

  $( The arcsine function. $)
  casin $a class arcsin $.

  $( The arccosine function. $)
  cacos $a class arccos $.

  $( The arctangent function. $)
  catan $a class arctan $.

  ${
    $( Define the arcsine function.  Because ` sin ` is not a one-to-one
       function, the literal inverse ` ``' sin ` is not a function.  Rather
       than attempt to find the right domain on which to restrict ` sin ` in
       order to get a total function, we just define it in terms of ` log ` ,
       which we already know is total (except at ` 0 ` ).  There are branch
       points at ` -u 1 ` and ` 1 ` (at which the function is defined), and
       branch cuts along the real line not between ` -u 1 ` and ` 1 ` , which
       is to say ` ( -oo , -u 1 ) u. ( 1 , +oo ) ` .  (Contributed by Mario
       Carneiro, 31-Mar-2015.) $)
    df-asin $a |- arcsin = ( x e. CC |-> ( -u _i x. ( log `
      ( ( _i x. x ) + ( sqr ` ( 1 - ( x ^ 2 ) ) ) ) ) ) ) $.

    $( Define the arccosine function.  See also remarks for ~ df-asin .  Since
       we define ` arccos ` in terms of ` arcsin ` , it shares the same branch
       points and cuts, namely ` ( -oo , -u 1 ) u. ( 1 , +oo ) ` .
       (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    df-acos $a |- arccos = ( x e. CC |-> ( ( pi / 2 ) - ( arcsin ` x ) ) ) $.

    $( Define the arctangent function.  See also remarks for ~ df-asin .
       Unlike ` arcsin ` and ` arccos ` , this function is not defined
       everywhere, because ` tan ( z ) =/= +- _i ` for all ` z e. CC ` .  For
       all other ` z ` , there is a formula for ` arctan ( z ) ` in terms of
       ` log ` , and we take that as the definition.  Branch points are at
       ` +- _i ` ; branch cuts are on the pure imaginary axis not between
       ` -u _i ` and ` _i ` , which is to say
       ` { z e. CC | ( _i x. z ) e. ( -oo , -u 1 ) u. ( 1 , +oo ) } ` .
       (Contributed by Mario Carneiro, 31-Mar-2015.) $)
    df-atan $a |- arctan = ( x e. ( CC \ { -u _i , _i } ) |->
      ( ( _i / 2 ) x. ( ( log ` ( 1 - ( _i x. x ) ) ) -
                        ( log ` ( 1 + ( _i x. x ) ) ) ) ) ) $.
  $}

  $( The argument to the logarithm in ~ df-asin is always nonzero.
     (Contributed by Mario Carneiro, 31-Mar-2015.) $)
  asinlem $p |- ( A e. CC ->
    ( ( _i x. A ) + ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) =/= 0 ) $=
    ( cc wcel ci cmul co c1 cexp cmin cneg cc0 ax-icn mpan ax-1cn wne a1i eqtrd
    c2 wceq syl csqr cfv caddc mulcl sqcl sylancr sqrcld subnegd negcld ax-1ne0
    subcl necomi wb 0cn subcan2 necon3bid syl3anc mpbiri sqmul i2 oveq1i mulm1d
    syl5eq df-neg syl6eq sqneg sqsqrd 3netr4d oveq1 necon3i subne0d eqnetrrd
    w3a ) ABCZDAEFZGARHFZIFZUAUBZJZIFVOVRUCFKVNVOVRDBCZVNVOBCLDAUDMZVNVQVNGBCZV
    PBCZVQBCNAUEZGVPUKUFZUGZUHVNVOVSWAVNVRWFUIVNVORHFZVSRHFZOVOVSOVNKVPIFZVQWGW
    HVNWIVQOZKGOZGKUJULVNKBCZWBWCWJWKUMWLVNUNPWBVNNPWDWLWBWCVMWIVQKGKGVPUOUPUQU
    RVNWGVPJZWIVNWGDRHFZVPEFZWMVTVNWGWOSLDAUSMVNWOGJZVPEFWMWNWPVPEUTVAVNVPWDVBV
    CQVPVDVEVNWHVRRHFZVQVNVRBCWHWQSWFVRVFTVNVQWEVGQVHVOVSWGWHVOVSRHVIVJTVKVL $.

  $( The argument to the logarithm in ~ df-asin has the property that replacing
     ` A ` with ` -u A ` in the expression gives the reciprocal.  (Contributed
     by Mario Carneiro, 1-Apr-2015.) $)
  asinlem2 $p |- ( A e. CC ->
    ( ( ( _i x. A ) + ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) x.
      ( ( _i x. -u A ) + ( sqr ` ( 1 - ( -u A ^ 2 ) ) ) ) ) = 1 ) $=
    ( cc wcel ci cmul co c1 c2 cexp cmin csqr cfv caddc cneg ax-icn mpan ax-1cn
    sylancr wceq oveq12d mulcl subcl sqrcld addcomd mulneg2 sqneg oveq2d fveq2d
    sqcl negcld negsubd 3eqtrd sqsqrd sqmul i2 oveq1i mulm1d syl5eq eqtrd subsq
    syl2anc subnegd 3eqtr3d npcan ) ABCZDAEFZGAHIFZJFZKLZMFZDANZEFZGVKHIFZJFZKL
    ZMFZEFVIVFMFZVIVFJFZEFZVHVGMFZGVEVJVQVPVREVEVFVIDBCZVEVFBCZODAUAPZVEVHVEGBC
    ZVGBCZVHBCQAUIZGVGUBRZUCZUDVEVPVFNZVIMFVIWIMFVRVEVLWIVOVIMWAVEVLWISODAUEPVE
    VNVHKVEVMVGGJAUFUGUHTVEWIVIVEVFWCUJWHUDVEVIVFWHWCUKULTVEVIHIFZVFHIFZJFZVHVG
    NZJFVSVTVEWJVHWKWMJVEVHWGUMVEWKDHIFZVGEFZWMWAVEWKWOSODAUNPVEWOGNZVGEFWMWNWP
    VGEUOUPVEVGWFUQURUSTVEVIBCWBWLVSSWHWCVIVFUTVAVEVHVGWGWFVBVCVEWDWEVTGSQWFGVG
    VDRUL $.

  $( Lemma for ~ asinlem3 .  (Contributed by Mario Carneiro, 1-Apr-2015.) $)
  asinlem3a $p |- ( ( A e. CC /\ ( Im ` A ) <_ 0 ) ->
    0 <_ ( Re ` ( ( _i x. A ) + ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) ) ) $=
    ( cc wcel cim cfv cc0 cle wbr cneg c1 co cre caddc ci adantr sylancr ax-icn
    cmul mulcl wceq wa c2 cexp cmin csqr imcl renegcld ax-1cn sqcl subcl sqrcld
    recld le0neg1d biimpa sqrrege0d addge0d readdd negcli renegd negnegi oveq1i
    cr simpl mulneg1 syl5eqr fveq2d imre negeqd 3eqtr4d oveq1d eqtrd breqtrrd )
    ABCZADEZFGHZUAZFVNIZJAUBUCKZUDKZUEEZLEZMKZNARKZVTMKLEZGVPVQWAVPVNVMVNVBCVOA
    UFZOUGVPVTVPVSVPJBCVRBCZVSBCUHVMWFVOAUIOJVRUJPZUKZULVMVOFVQGHVMVNWEUMUNVPVS
    WGUOUPVPWDWCLEZWAMKWBVPWCVTVPNBCVMWCBCQVMVOVCZNASPWHUQVPWIVQWAMVPNIZARKZIZL
    EWLLEZIWIVQVPWLVPWKBCZVMWLBCNQURZWJWKASPUSVPWCWMLVPWCWKIZARKZWMWQNARNQUTVAV
    PWOVMWRWMTWPWJWKAVDPVEVFVPVNWNVMVNWNTVOAVGOVHVIVJVKVL $.

  $( The argument to the logarithm in ~ df-asin has nonnegative real part.
     (Contributed by Mario Carneiro, 1-Apr-2015.) $)
  asinlem3 $p |- ( A e. CC ->
    0 <_ ( Re ` ( ( _i x. A ) + ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) ) ) $=
    ( cc wcel cc0 ci cmul co c1 c2 cexp cmin cfv cre cle wbr cdiv adantr ax-1cn
    sylancr wceq csqr caddc cim cr 0re a1i imcl wa cneg ccj crp cz ax-icn negcl
    mulcl sqcld subcl sqrcld addcld wne asinlem syl absrpcld 2z rpexpcl sylancl
    cabs rprecred cjcld recld rpreccld rpge0d le0neg2d biimpa eqbrtrd asinlem3a
    imneg syl2anc recjd breqtrrd mulge0d recval asinlem2 eqcomd divmul3d mpbird
    simpl sqcl rpcnd rpne0d divrec2d 3eqtr3d fveq2d remul2d eqtrd lecasei ) ABC
    ZDEAFGZHAIJGZKGZUALZUBGZMLZNODAUCLZDUDCWQUEUFAUGZWQDXDNOZUHZDHEAUIZFGZHXHIJ
    GZKGZUALZUBGZVGLZIJGZPGZXMUJLZMLZFGZXCNXGXPXRXGXOXGXNUKCIULCXOUKCXGXMXGXIXL
    XGEBCZXHBCZXIBCUMWQYAXFAUNQZEXHUOSXGXKXGHBCZXJBCXKBCRXGXHYBUPHXJUQSURUSZXGY
    AXMDUTZYBXHVAVBZVCVDXNIVEVFZVHZXGXQXGXMYDVIZVJXGXPXGXOYGVKVLXGDXMMLZXRNXGYA
    XHUCLZDNODYJNOYBXGYKXDUIZDNWQYKYLTXFAVQQWQXFYLDNOWQXDXEVMVNVOXHVPVRXGXMYDVS
    VTWAXGXCXPXQFGZMLXSXGXBYMMXGHXMPGZXQXOPGZXBYMXGXMBCYEYNYOTYDYFXMWBVRXGYNXBT
    HXBXMFGZTXGYPHWQYPHTXFAWCQWDXGHXBXMYCXGRUFXGWRXAXGXTWQWRBCUMWQXFWGEAUOSXGWT
    XGYCWSBCZWTBCRWQYQXFAWHQHWSUQSURUSYDYFWEWFXGXQXOYIXGXOYGWIXGXOYGWJWKWLWMXGX
    PXQYHYIWNWOVTAVPWP $.

  $( Domain and range of the arcsin function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  asinf $p |- arcsin : CC --> CC $=
    ( vx cc ci cneg cv cmul co c1 c2 cexp cmin csqr cfv caddc clog casin ax-icn
    wcel mulcl sylancr df-asin negcli ax-1cn subcl sqrcld addcld asinlem logcld
    mpan sqcl fmpti ) ABBCDZCAEZFGZHUMIJGZKGZLMZNGZOMZFGZPAUAUMBRZULBRUSBRUTBRC
    QUBVAURVAUNUQCBRVAUNBRQCUMSUIVAUPVAHBRUOBRUPBRUCUMUJHUOUDTUEUFUMUGUHULUSSTU
    K $.

  $( Closure for the arcsin function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  asincl $p |- ( A e. CC -> ( arcsin ` A ) e. CC ) $=
    ( cc casin asinf ffvelrni ) BBACDE $.

  $( Domain and range of the arccos function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  acosf $p |- arccos : CC --> CC $=
    ( vx cc cpi c2 cdiv co casin cfv cmin cacos df-acos wcel recni halfcl ax-mp
    cv pire asincl subcl sylancr fmpti ) ABBCDEFZAPZGHZIFZJAKUCBLUBBLZUDBLUEBLC
    BLUFCQMCNOUCRUBUDSTUA $.

  $( Closure for the arccos function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  acoscl $p |- ( A e. CC -> ( arccos ` A ) e. CC ) $=
    ( cc cacos acosf ffvelrni ) BBACDE $.

  $( Since the property is a little lengthy, we abbreviate
     ` A e. CC /\ A =/= -u _i /\ A =/= _i ` as ` A e. dom arctan ` .  This is
     the necessary precondition for the definition of ` arctan ` to make
     sense.  (Contributed by Mario Carneiro, 31-Mar-2015.) $)
  atandm $p |- ( A e. dom arctan <->
    ( A e. CC /\ A =/= -u _i /\ A =/= _i ) ) $=
    ( vx cc ci cneg cpr cdif wcel wne wa catan cdm wn wceq co c1 cmul cmin clog
    cfv w3a eldif wo elprg notbid neanior syl6bbr pm5.32i bitri c2 cdiv cv ovex
    caddc df-atan dmmpti eleq2i 3anass 3bitr4i ) ACDEZDFZGZHZACHZAUTIZADIZJZJZA
    KLZHVDVEVFUAVCVDAVAHZMZJVHACVAUBVDVKVGVDVKAUTNADNUCZMVGVDVJVLAUTDCUDUEAUTAD
    UFUGUHUIVIVBABVBDUJUKOZPDBULQOZROSTPVNUNOSTROZQOKVMVOQUMBUOUPUQVDVEVFURUS
    $.

  $( This form of ~ atandm is a bit more useful for showing that the logarithms
     in ~ df-atan are well-defined.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  atandm2 $p |- ( A e. dom arctan <-> ( A e. CC /\
    ( 1 - ( _i x. A ) ) =/= 0 /\ ( 1 + ( _i x. A ) ) =/= 0 ) ) $=
    ( wcel cc ci cneg wne w3a c1 cmul co cmin cc0 caddc wa 3anass ax-1cn ax-icn
    wceq a1i bitrd catan cdm atandm wb mulcl subeq0 sylancr mulneg2i ixi negeqi
    mpan negnegi 3eqtri eqeq2i eqcom bitri syl6bbr negcli ine0 necon3bid addcom
    id mulcand subneg sylancl eqtr4d eqeq1d anbi12d pm5.32i bitr4i ) AUAUBBACBZ
    ADEZFZADFZGZVKHDAIJZKJZLFZHVPMJZLFZGZAUCWAVKVRVTNZNZVOVKVRVTOWCVKVMVNNZNVOV
    KWBWDVKVRVMVTVNVKVQLAVLVKVQLRZVPDVLIJZRZAVLRVKWEHVPRZWGVKHCBZVPCBZWEWHUDPDC
    BZVKWJQDAUEUKZHVPUFUGWGVPHRWHWFHVPWFDDIJZEHEZEHDDQQUHWMWNUIUJHPULUMUNVPHUOU
    PUQVKAVLDVKVBZVLCBVKDQURSWKVKQSZDLFVKUSSZVCTUTVKVSLADVKVSLRZVPWMRZADRVKWRVP
    WNRZWSVKWRVPWNKJZLRZWTVKVSXALVKVSVPHMJZXAVKWIWJVSXCRPWLHVPVAUGVKWJWIXAXCRWL
    PVPHVDVEVFVGVKWJWNCBXBWTUDWLHPURVPWNUFVETWMWNVPUIUNUQVKADDWOWPWPWQVCTUTVHVI
    VKVMVNOVJUPVJ $.

  $( A compact form of ~ atandm .  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  atandm3 $p |- ( A e. dom arctan <-> ( A e. CC /\ ( A ^ 2 ) =/= -u 1 ) ) $=
    ( cc wcel ci cneg wne w3a wa catan cdm c2 cexp co c1 3anass atandm wo wn wb
    wceq ax-icn sqeqor mpan2 i2 eqeq2i orcom 3bitr3g necon3abid neanior syl6bbr
    pm5.32i 3bitr4i ) ABCZADEZFZADFZGUMUOUPHZHAIJCUMAKLMZNEZFZHUMUOUPOAPUMUTUQU
    MUTAUNTZADTZQZRUQUMVCURUSUMURDKLMZTZVBVAQZURUSTVCUMDBCVEVFSUAADUBUCVDUSURUD
    UEVBVAUFUGUHAUNADUIUJUKUL $.

  $( A compact form of ~ atandm .  (Contributed by Mario Carneiro,
     3-Apr-2015.) $)
  atandm4 $p |- ( A e. dom arctan <->
    ( A e. CC /\ ( 1 + ( A ^ 2 ) ) =/= 0 ) ) $=
    ( catan cdm wcel cc c2 cexp co c1 cneg wne wa cc0 atandm3 cmin wceq sylancl
    caddc wb ax-1cn neg1cn subeq0 subneg addcom eqeq1d bitr3d necon3bid pm5.32i
    sqcl eqtrd bitri ) ABCDAEDZAFGHZIJZKZLULIUMRHZMKZLANULUOUQULUMUNUPMULUMUNOH
    ZMPZUMUNPZUPMPULUMEDZUNEDUSUTSAUIZUAUMUNUBQULURUPMULURUMIRHZUPULVAIEDZURVCP
    VBTUMIUCQULVAVDVCUPPVBTUMIUDQUJUEUFUGUHUK $.

  $( Domain and range of the arctan function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  atanf $p |- arctan : ( CC \ { -u _i , _i } ) --> CC $=
    ( vx cc ci cneg cpr co c1 cmul cmin clog cfv catan wcel ax-icn ax-1cn mulcl
    cc0 wne sylancr logcld cdif c2 cdiv cv caddc df-atan cdm ovex dmmpti eleq2i
    halfcl ax-mp atandm2 simp1bi subcl simp2bi addcl simp3bi subcld sylbir
    fmpti ) ABCDCEUAZBCUBUCFZGCAUDZHFZIFZJKZGVEUEFZJKZIFZHFZLAUFZVDVBMVDLUGZMZV
    KBMZVMVBVDAVBVKLVCVJHUHVLUIUJVNVCBMZVJBMVOCBMZVPNCUKULVNVGVIVNVFVNGBMZVEBMZ
    VFBMOVNVQVDBMZVSNVNVTVFQRZVHQRZVDUMZUNCVDPSZGVEUOSVNVTWAWBWCUPTVNVHVNVRVSVH
    BMOWDGVEUQSVNVTWAWBWCURTUSVCVJPSUTVA $.

  $( Closure for the arctan function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  atancl $p |- ( A e. dom arctan -> ( arctan ` A ) e. CC ) $=
    ( catan cfv cc wcel ci cneg cpr cdif cdm atanf ffvelrni fdmi eleq2s ) ABCDE
    ADFGFHIZBJODABKLODBKMN $.

  ${
    $d x A $.
    $( Value of the arcsin function.  (Contributed by Mario Carneiro,
       31-Mar-2015.) $)
    asinval $p |- ( A e. CC -> ( arcsin ` A ) = ( -u _i x. ( log `
      ( ( _i x. A ) + ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) ) ) ) $=
      ( vx ci cneg cv cmul co c1 c2 cexp cmin csqr cfv caddc clog cc casin wceq
      oveq2d fveq2d oveq2 oveq1 oveq12d df-asin ovex fvmpt ) BACDZCBEZFGZHUHIJG
      ZKGZLMZNGZOMZFGUGCAFGZHAIJGZKGZLMZNGZOMZFGPQUHARZUNUTUGFVAUMUSOVAUIUOULUR
      NUHACFUAVAUKUQLVAUJUPHKUHAIJUBSTUCTSBUDUGUTFUEUF $.

    $( Value of the arccos function.  (Contributed by Mario Carneiro,
       31-Mar-2015.) $)
    acosval $p |- ( A e. CC -> ( arccos ` A ) =
      ( ( pi / 2 ) - ( arcsin ` A ) ) ) $=
      ( vx cpi c2 cdiv co cv casin cmin cc cacos wceq fveq2 oveq2d df-acos ovex
      cfv fvmpt ) BACDEFZBGZHQZIFSAHQZIFJKTALUAUBSITAHMNBOSUBIPR $.

    $( Value of the arctan function.  (Contributed by Mario Carneiro,
       31-Mar-2015.) $)
    atanval $p |- ( A e. dom arctan -> ( arctan ` A ) =
      ( ( _i / 2 ) x. ( ( log ` ( 1 - ( _i x. A ) ) ) -
                        ( log ` ( 1 + ( _i x. A ) ) ) ) ) ) $=
      ( vx catan cfv ci c2 cdiv co c1 cmul cmin clog caddc wceq cneg cpr oveq2d
      cc cdif fveq2d cdm cv oveq2 oveq12d df-atan ovex fvmpt atanf fdmi eleq2s
      ) ACDEFGHZIEAJHZKHZLDZIULMHZLDZKHZJHZNAREOEPSZCUABAUKIEBUBZJHZKHZLDZIVAMH
      ZLDZKHZJHURUSCUTANZVFUQUKJVGVCUNVEUPKVGVBUMLVGVAULIKUTAEJUCZQTVGVDUOLVGVA
      ULIMVHQTUDQBUEUKUQJUFUGUSRCUHUIUJ $.
  $}

  $( A real number is in the domain of the arctangent function.  (Contributed
     by Mario Carneiro, 31-Mar-2015.) $)
  atanre $p |- ( A e. RR -> A e. dom arctan ) $=
    ( cr wcel cc c2 cexp co c1 cneg wne catan cdm recn 1re renegcli a1i cc0 0re
    clt wbr resqcl 0lt1 lt0neg2 ax-mp mpbi sqge0 ltletrd gtned atandm3 sylanbrc
    wb ) ABCZADCAEFGZHIZJAKLCAMULUNUMUNBCULHNOPZULUNQUMUOQBCULRPAUAUNQSTZULQHST
    ZUPUBHBCUQUPUKNHUCUDUEPAUFUGUHAUIUJ $.

  $( The arcsine function is odd.  (Contributed by Mario Carneiro,
     1-Apr-2015.) $)
  asinneg $p |- ( A e. CC -> ( arcsin ` -u A ) = -u ( arcsin ` A ) ) $=
    ( cc wcel ci cneg cmul co c1 cfv wceq sylancr cc0 wb cim cpi cr clt wbr cle
    pire c2 cexp cmin csqr caddc clog casin cdiv ax-icn mulcl mpan ax-1cn subcl
    ce sqrcld addcld asinlem logcld efneg syl wne eflog syl2anc oveq2d asinlem2
    sqcl a1i negcl sqcld divmuld mpbird 3eqtrd crn ccnv cioc cima negcld imnegd
    imcld renegcld cre renegd asinlem3 recld le0neg2d mpbid eqbrtrd 0re sylancl
    wn lenlt lognegb rpgt0 rpre rered breqtrrd syl6bir necon3bd necomd logimcld
    crp mpd simprd leltned ltneg simpld wi renegcli ltle lenegcon1 rexri elioc2
    cxr w3a mp2an syl3anbrc eqeltrd wf wfn imf ffn elpreima mp2b sylanbrc logrn
    wa syl6eleqr logeftb syl3anc negcli mulneg2 eqtrd asinval negeqd 3eqtr4d )
    ABCZDEZDAEZFGZHYRUAUBGZUCGZUDIZUEGZUFIZFGZYQDAFGZHAUAUBGZUCGZUDIZUEGZUFIZFG
    ZEZYRUGIZAUGIZEYPUUEYQUUKEZFGZUUMYPUUDUUPYQFYPUUDUUPJZUUPUNIZUUCJZYPUUSHUUK
    UNIZUHGZHUUJUHGZUUCYPUUKBCZUUSUVBJYPUUJYPUUFUUIDBCZYPUUFBCUIDAUJUKYPUUHYPHB
    CZUUGBCUUHBCULAVFHUUGUMKUOUPZAUQZURZUUKUSUTYPUVAUUJHUHYPUUJBCZUUJLVAZUVAUUJ
    JUVGUVHUUJVBVCVDYPUVCUUCJUUJUUCFGHJAVEYPHUUJUUCUVFYPULVGUVGYPYSUUBYPUVEYRBC
    ZYSBCUIAVHZDYRUJKYPUUAYPUVFYTBCUUABCULYPYRUVMVIHYTUMKUOUPZUVHVJVKVLYPUUCBCU
    UCLVAZUUPUFVMZCUURUUTMUVNYPUVLUVOUVMYRUQUTYPUUPNVNOEZOVOGZVPZUVPYPUUPBCZUUP
    NIZUVRCZUUPUVSCZYPUUKUVIVQYPUWAUUKNIZEZUVRYPUUKUVIVRYPUWEPCZUVQUWEQRZUWEOSR
    ZUWEUVRCZYPUWDYPUUKUVIVSZVTYPUWDOQRZUWGYPUWKOUWDVAYPUWDOYPLUUJEZWAIZQRZWJZU
    WDOVAYPUWMLSRZUWOYPUWMUUJWAIZEZLSYPUUJUVGWBYPLUWQSRUWRLSRAWCYPUWQYPUUJUVGWD
    WEWFWGYPUWMPCLPCUWPUWOMYPUWLYPUUJUVGVQWDWHUWMLWKWIWFYPUWNUWDOYPUWDOJZUWLXAC
    ZUWNYPUVJUVKUWTUWSMUVGUVHUUJWLVCUWTLUWLUWMQUWLWMUWTUWLUWLWNWOWPWQWRXBWSYPUW
    DOUWJOPCZYPTVGYPUVQUWDQRZUWDOSRZYPUUJUVGUVHWTZXCXDVKYPUWDPCZUXAUWKUWGMUWJTU
    WDOXEWIWFYPUVQUWDSRZUWHYPUXBUXFYPUXBUXCUXDXFYPUVQPCUXEUXBUXFXGOTXHZUWJUVQUW
    DXIKXBYPUXAUXEUXFUWHMTUWJOUWDXJKWFUVQXMCUXAUWIUWFUWGUWHXNMUVQUXGXKTUVQOUWEX
    LXOXPXQBPNXRNBXSUWCUVTUWBYFMXTBPNYABUUPUVRNYBYCYDYEYGUUCUUPYHYIVKVDYPYQBCUV
    DUUQUUMJDUIYJUVIYQUUKYKKYLYPUVLUUNUUEJUVMYRYMUTYPUUOUULAYMYNYO $.

  $( The negative symmetry relation of the arccosine.  (Contributed by Mario
     Carneiro, 2-Apr-2015.) $)
  acosneg $p |- ( A e. CC -> ( arccos ` -u A ) = ( pi - ( arccos ` A ) ) ) $=
    ( cc wcel cpi c2 cdiv co cneg casin cmin cacos caddc wceq pire ax-mp oveq2d
    cfv a1i 3eqtr4d acosval recni halfcl asincl sylancr asinneg subsubd 2halves
    subneg subaddrii oveq1i syl6eq negcl syl ) ABCZDEFGZAHZIQZJGZDUOAIQZJGZJGZU
    PKQZDAKQZJGUNUOUSHZJGZUOUSLGZURVAUNUOBCZUSBCVEVFMDBCZVGDNUAZDUBOZAUCZUOUSUH
    UDUNUQVDUOJAUEPUNVADUOJGZUSLGVFUNDUOUSVHUNVIRVGUNVJRVKUFVLUOUSLDUOUOVIVJVJV
    HUOUOLGDMVIDUGOUIUJUKSUNUPBCVBURMAULUPTUMUNVCUTDJATPS $.

  $( The exponential of the arcsine function.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  efiasin $p |- ( A e. CC -> ( exp ` ( _i x. ( arcsin ` A ) ) ) =
    ( ( _i x. A ) + ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) ) $=
    ( cc wcel ci casin cfv cmul co ce c1 c2 cexp cmin csqr clog cneg ax-icn a1i
    caddc ax-1cn asinval oveq2d negcli mulcl mpan sylancr sqrcld addcld asinlem
    sqcl subcl logcld mulassd mulneg2i ixi negeqi negnegi 3eqtri oveq1i mulid2d
    syl5eq 3eqtr2d fveq2d cc0 wne wceq eflog syl2anc eqtrd ) ABCZDAEFZGHZIFDAGH
    ZJAKLHZMHZNFZSHZOFZIFZVQVJVLVRIVJVLDDPZVRGHZGHDVTGHZVRGHZVRVJVKWADGAUAUBVJD
    VTVRDBCZVJQRVTBCVJDQUCRVJVQVJVMVPWDVJVMBCQDAUDUEVJVOVJJBCVNBCVOBCTAUJJVNUKU
    FUGUHZAUIZULZUMVJWCJVRGHVRWBJVRGWBDDGHZPJPZPJDDQQUNWHWIUOUPJTUQURUSVJVRWGUT
    VAVBVCVJVQBCVQVDVEVSVQVFWEWFVQVGVHVI $.

  $( The arcsine function is an inverse to ` sin ` .  This is the main property
     that justifies the notation ` arcsin ` or ` sin ^ -u 1 ` .  Because
     ` sin ` is not an injection, the other converse identity ~ asinsin is only
     true under limited circumstances.  (Contributed by Mario Carneiro,
     1-Apr-2015.) $)
  sinasin $p |- ( A e. CC -> ( sin ` ( arcsin ` A ) ) = A ) $=
    ( cc wcel cfv ci cmul co ce cneg cmin c2 wceq syl csqr caddc ax-icn sylancr
    c1 mulcl 2cn casin csin cdiv asincl sinval cexp mpan negcld ax-1cn pnpcan2d
    sqcl subcl sqrcld efiasin mulneg12 asinneg oveq2d eqtr4d fveq2d negcl sqneg
    mulneg2 oveq12d 3eqtrd 2timesd mulass mp3an12 subnegd 3eqtr4d negcli subcld
    efcl id mulcli a1i cc0 wne 2ne0 ine0 mulne0i divmul2d mpbird eqtrd ) ABCZAU
    ADZUBDZEWEFGZHDZEIZWEFGZHDZJGZKEFGZUCGZAWDWEBCZWFWNLAUDZWEUEMWDWNALWLWMAFGZ
    LWDEAFGZRAKUFGZJGZNDZOGZWRIZXAOGZJGWRXCJGZWLWQWDWRXCXAEBCZWDWRBCPEASUGZWDWR
    XGUHWDWTWDRBCWSBCWTBCUIAUKRWSULQUMUJWDWHXBWKXDJAUNWDWKEAIZUADZFGZHDZEXHFGZR
    XHKUFGZJGZNDZOGZXDWDWJXJHWDWJEWEIZFGZXJWDXFWOWJXRLPWPEWEUOQWDXIXQEFAUPUQURU
    SWDXHBCXKXPLAUTXHUNMWDXLXCXOXAOXFWDXLXCLPEAVBUGWDXNWTNWDXMWSRJAVAUQUSVCVDVC
    WDKWRFGZWRWROGWQXEWDWRXGVEKBCXFWDWQXSLTPKEAVFVGWDWRWRXGXGVHVIVIWDWLAWMWDWHW
    KWDWGBCZWHBCWDXFWOXTPWPEWESQWGVLMWDWJBCZWKBCWDWIBCWOYAEPVJWPWIWESQWJVLMVKWD
    VMWMBCWDKETPVNVOWMVPVQWDKETPVRVSVTVOWAWBWC $.

  $( The arccosine function is an inverse to ` cos ` .  (Contributed by Mario
     Carneiro, 1-Apr-2015.) $)
  cosacos $p |- ( A e. CC -> ( cos ` ( arccos ` A ) ) = A ) $=
    ( cc wcel cacos cfv ccos cpi c2 cdiv co casin cmin csin acosval fveq2d wceq
    asincl coshalfpim syl sinasin 3eqtrd ) ABCZADEZFEGHIJAKEZLJZFEZUDMEZAUBUCUE
    FANOUBUDBCUFUGPAQUDRSATUA $.

  $( Lemma for ~ asinsin .  (Contributed by Mario Carneiro, 2-Apr-2015.) $)
  asinsinlem $p |- ( ( A e. CC /\ ( Re ` A ) e.
    ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) ->
      0 < ( Re ` ( exp ` ( _i x. A ) ) ) ) $=
    ( cc wcel cre cfv co cneg cc0 ci cmul ce ccos clt ax-icn mulcl wbr syl wceq
    fveq2d c1 cpi c2 cdiv cioo wa simpl sylancr recld reefcld cr simpr halfpire
    wb renegcli rexri elioo2 mp2an sylib simp1d recoscld efgt0 cosq14gt0 adantl
    w3a cxr mulgt0d cim csin caddc efeul imcld recnd resincld addcld crred imre
    remul2d mulneg1i ixi negeqi ax-1cn negnegi 3eqtri oveq1i negcli a1i mulassd
    mulid2 adantr 3eqtr3a eqtrd oveq2d 3eqtrd breqtrrd ) ABCZADEZUAUBUCFZGZWQUD
    FCZUEZHIAJFZDEZKEZWPLEZJFZXAKEZDEZMWTXCXDWTXBWTXAWTIBCZWOXABCZNWOWSUFZIAOUG
    ZUHZUIZWTWPWTWPUJCZWRWPMPZWPWQMPZWTWSXNXOXPVDZWOWSUKWRVECWQVECWSXQUMWRWQULU
    NUOWQULUOWRWQWPUPUQURUSUTWTXBUJCHXCMPXLXBVAQWSHXDMPWOWPVBVCVFWTXGXCXAVGEZLE
    ZIXRVHEZJFZVIFZJFZDEXCYBDEZJFXEWTXFYCDWTXIXFYCRXKXAVJQSWTXCYBXMWTXSYAWTXSWT
    XRWTXAXKVKZUTZVLWTXHXTBCYABCNWTXTWTXRYEVMZVLIXTOUGVNVQWTYDXDXCJWTYDXSXDWTXS
    XTYFYGVOWTXRWPLWTXRIGZXAJFZDEZWPWTXIXRYJRXKXAVPQWTYIADWTYHIJFZAJFTAJFZYIAYK
    TAJYKIIJFZGTGZGTIINNVRYMYNVSVTTWAWBWCWDWTYHIAYHBCWTINWEWFXHWTNWFXJWGWOYLARW
    SAWHWIWJSWKSWKWLWMWN $.

  $( The arcsine function composed with ` sin ` is equal to the identity.  This
     plus ~ sinasin allow us to view ` sin ` and ` arcsin ` as inverse
     operations to each other.  For ease of use, we have not defined precisely
     the correct domain of correctness of this identity; in addition to the
     main region described here it is also true for _some_ points on the branch
     cuts, namely when ` A = ( pi / 2 ) - _i y ` for non-negative real ` y `
     and also symmetrically at ` A = _i y - ( pi / 2 ) ` .  In particular, when
     restricted to reals this identity extends to the closed interval
     ` [ -u ( pi / 2 ) , ( pi / 2 ) ] ` , not just the open interval (see
     ~ reasinsin ).  (Contributed by Mario Carneiro, 2-Apr-2015.) $)
  asinsin $p |- ( ( A e. CC /\ ( Re ` A ) e.
    ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) -> ( arcsin ` ( sin ` A ) ) = A ) $=
    ( cc wcel cre cfv cpi c2 co cneg ci cmul c1 cmin wceq adantr ax-icn sylancr
    caddc a1i clt cdiv cioo wa csin casin cexp csqr clog sincl asinval ce mulcl
    syl simpl efcl pncan3d subcld ax-1cn sqcld subcl binom2sub syl2anc ccos 2cn
    sqvald mul12d oveq12d coscl subsq sqmul oveq1i mulm1d syl5eq oveq2d subnegd
    eqtrd addcomd 3eqtrd efival 2timesd pnpcan2d subdid eqtr3d 3eqtr3d sincossq
    i2 3eqtr2d negsub cc0 cr 1re rehalfcli negcli addcld wbr halfgt0 asinsinlem
    recld negcl reneg wb recl pire renegcli iooneg mp3an12 biimpa recni negnegi
    oveq2i syl6eleq eqeltrd mulneg12 fveq2d breqtrrd addgt0d readdd mulgt0d wne
    cosval divrec2d remul2 oveq1d pncand eqsqr2d crn cim cle elioore adantl crp
    2ne0 pipos elrpii rphalflt ax-mp ltnegi mpbi eliooord lttrd simpld mulneg1i
    negeqi 3eqtri mulassd mulid2 3eqtr3a simprd ltled eqbrtrd ellogrn syl3anbrc
    imre ixi logef ) ABCZADEZFGUAHZIZUURUBHZCZUCZAUDEZUEEZJIZJUVCKHZLUVCGUFHZMH
    ZUGEZRHZUHEZKHZUVEJAKHZKHZAUVBUVCBCZUVDUVLNUUPUVOUVAAUIOZUVCUJUMUVBUVKUVMUV
    EKUVBUVMUKEZUHEZUVKUVMUVBUVQUVJUHUVBUVFUVQUVFMHZRHUVQUVJUVBUVFUVQUVBJBCZUVO
    UVFBCZPUVPJUVCULQZUVBUVMBCZUVQBCZUVBUVTUUPUWCPUUPUVAUNZJAULQZUVMUOUMZUPUVBU
    VSUVIUVFRUVBUVSUVHUVBUVQUVFUWGUWBUQUVBLBCZUVGBCZUVHBCURUVBUVCUVPUSZLUVGUTQU
    VBUVSGUFHZUVQGUFHZGUVQUVFKHKHZMHZUVFGUFHZRHZLUVGIZRHZUVHUVBUWDUWAUWKUWPNUWG
    UWBUVQUVFVAVBUVBUWNLUWOUWQRUVBUWNUVQUVQKHZUVQGUVFKHZKHZMHZUVGAVCEZGUFHZRHZL
    UVBUWLUWSUWMUXAMUVBUVQUWGVEUVBGUVQUVFGBCZUVBVDSZUWGUWBVFVGUVBUXDUWOMHZUXCUV
    FRHZUXCUVFMHZKHZUXEUXBUVBUXCBCZUWAUXHUXKNUUPUXLUVAAVHOZUWBUXCUVFVIVBUVBUXHU
    XDUWQMHUXDUVGRHUXEUVBUWOUWQUXDMUVBUWOJGUFHZUVGKHZUWQUVBUVTUVOUWOUXONPUVPJUV
    CVJQUVBUXOLIZUVGKHUWQUXNUXPUVGKWFVKUVBUVGUWJVLVMVPZVNUVBUXDUVGUVBUXCUXMUSZU
    WJVOUVBUXDUVGUXRUWJVQVRUVBUVQUVQUWTMHZKHUXKUXBUVBUVQUXIUXSUXJKUUPUVQUXINUVA
    AVSOZUVBUXSUXIUVFUVFRHZMHUXJUVBUVQUXIUWTUYAMUXTUVBUVFUWBVTVGUVBUXCUVFUVFUXM
    UWBUWBWAVPVGUVBUVQUVQUWTUWGUWGUVBUXFUWAUWTBCVDUWBGUVFULQWBWCWDUUPUXELNUVAAW
    EOWGUXQVGUVBUWHUWIUWRUVHNURUWJLUVGWHQVRUVBWIUXCDEZUVSDETUVBWILGUAHZUVQUVEAK
    HZUKEZRHZDEZKHZUYBTUVBUYCUYGUYCWJCZUVBLWKWLZSUVBUYFUVBUVQUYEUWGUVBUYDBCZUYE
    BCUVBUVEBCZUUPUYKJPWMZUWEUVEAULQUYDUOUMZWNZWRWIUYCTWOUVBWPSUVBWIUVQDEZUYEDE
    ZRHUYGTUVBUYPUYQUVBUVQUWGWRUVBUYEUYNWRAWQUVBWIJAIZKHZUKEZDEZUYQTUVBUYRBCZUY
    RDEZUUTCWIVUATWOUUPVUBUVAAWSOUVBVUCUUQIZUUTUUPVUCVUDNUVAAWTOUVBVUDUUSUUSIZU
    BHZUUTUUPUVAVUDVUFCZUUPUUQWJCZUVAVUGXAZAXBUUSWJCZUURWJCZVUHVUIUURFXCWLZXDZV
    ULUUSUURUUQXEXFUMXGVUEUURUUSUBUURUURVULXHXIXJXKXLUYRWQVBUVBUYEUYTDUVBUYDUYS
    UKUVBUVTUUPUYDUYSNPUWEJAXMQXNXNXOXPUVBUVQUYEUWGUYNXQXOXRUVBUYBUYCUYFKHZDEZU
    YHUVBUXCVUNDUVBUXCUYFGUAHZVUNUUPUXCVUPNUVAAXTOUVBUYFGUYOUXGGWIXSUVBYLSYAVPX
    NUVBUYIUYFBCVUOUYHNUYJUYOUYCUYFYBQVPXOUVBUVSUXCDUVBUVSUXIUVFMHUXCUVBUVQUXIU
    VFMUXTYCUVBUXCUVFUXMUWBYDVPXNXOYEVNWCXNUVBUVMUHYFCZUVRUVMNUVBUWCFIZUVMYGEZT
    WOVUSFYHWOVUQUWFUVBVURUUQVUSTUVBVURUUSUUQVURWJCUVBFXCXDSVUJUVBVUMSUVAVUHUUP
    UUQUUSUURYIYJZVURUUSTWOZUVBUURFTWOZVVAFYKCVVBFXCYMYNFYOYPZUURFVULXCYQYRSUVB
    UUSUUQTWOZUUQUURTWOZUVAVVDVVEUCUUPUUQUUSUURYSYJZUUAYTUVBVUSUVNDEZUUQUVBUWCV
    USVVGNUWFUVMUUMUMUVBUVNADUVBUVEJKHZAKHLAKHZUVNAVVHLAKVVHJJKHZIUXPILJJPPUUBV
    VJUXPUUNUUCLURXIUUDVKUVBUVEJAUYLUVBUYMSUVTUVBPSUWEUUEUUPVVIANUVAAUUFOUUGZXN
    VPZXOUVBVUSUUQFYHVVLUVBUUQFVUTFWJCUVBXCSZUVBUUQUURFVUTVUKUVBVULSVVMUVBVVDVV
    EVVFUUHVVBUVBVVCSYTUUIUUJUVMUUKUULUVMUUOUMWCVNVVKVR $.

  $( The arccosine function is an inverse to ` cos ` .  (Contributed by Mario
     Carneiro, 2-Apr-2015.) $)
  acoscos $p |- ( ( A e. CC /\ ( Re ` A ) e. ( 0 (,) pi ) ) ->
    ( arccos ` ( cos ` A ) ) = A ) $=
    ( cc wcel cre cfv cc0 cpi co ccos casin cmin wceq ax-mp sylancr halfpire cr
    syl clt wbr a1i cioo wa cacos c2 cdiv coscl adantr acosval csin pire halfcl
    recni simpl nncan fveq2d subcl coshalfpim eqtr3d cneg oveq1i syl6eq resubcl
    resub rere recl renegcli eliooord adantl simprd caddc subnegi 2halves eqtri
    syl6breqr ltsub13d simpld ltsubpos sylancl mpbid cxr w3a rexri elioo2 mp2an
    wb syl3anbrc eqeltrd asinsin syl2anc eqtr2d asincl subsub23 syl3anc eqtrd )
    ABCZADEZFGUAHCZUBZAIEZUCEZGUDUEHZWSJEZKHZAWRWSBCZWTXCLWOXDWQAUFUGZWSUHQWRXA
    AKHZXBLZXCALZWRXBXFUIEZJEZXFWRWSXIJWRXAXFKHZIEZWSXIWRXKAIWRXABCZWOXKALGBCZX
    MGUJULZGUKMZWOWQUMZXAAUNNUOWRXFBCZXLXILWRXMWOXRXPXQXAAUPNZXFUQQURUOWRXRXFDE
    ZXAUSZXAUAHZCXJXFLXSWRXTXAWPKHZYBWRXTXADEZWPKHZYCWRXMWOXTYELXAOULZXQXAAVCNY
    DXAWPKXAPCZYDXALOXAVDMUTVAWRYCPCZYAYCRSZYCXARSZYCYBCZWRYGWPPCZYHOWOYLWQAVEU
    GZXAWPVBNWRWPXAYAYMYGWROTYAPCWRXAOVFZTWRWPGXAYAKHZRWRFWPRSZWPGRSZWQYPYQUBWO
    WPFGVGVHZVIYOXAXAVJHZGXAXAYFYFVKXNYSGLXOGVLMVMVNVOWRYPYJWRYPYQYRVPWRYLYGYPY
    JWEYMOWPXAVQVRVSYAVTCXAVTCYKYHYIYJWAWEYAYNWBXAOWBYAXAYCWCWDWFWGXFWHWIWJWRXM
    WOXBBCZXGXHWEXMWRYFTXQWRXDYTXEWSWKQXAAXBWLWMVSWN $.

  $( The arcsine of ` 1 ` is ` pi / 2 ` .  (Contributed by Mario Carneiro,
     2-Apr-2015.) $)
  asin1 $p |- ( arcsin ` 1 ) = ( pi / 2 ) $=
    ( c1 cfv ci cneg cmul co cmin csqr caddc clog cpi wcel ax-mp cc0 ax-icn clt
    eqtri wbr halfpire pire casin cexp cdiv wceq ax-1cn asinval addid1i mulid1i
    c2 cc ce sq1 oveq2i 1m1e0 fveq2i oveq12i efhalfpi 3eqtr4i crn cim cle recni
    sqr0 mulcli pipos cr wb lt0neg2 mpbi crp elrpii rphalfcl rpgt0 renegcli 0re
    lttri mp2an addid2i crimi eqtr3i breqtrri rphalflt eqbrtri ellogrn mpbir3an
    ltleii logef mulneg1i negeqi negnegi 3eqtri oveq1i negcli mulassi mulid2i
    ixi ) AUABZCDZCAEFZAAUIUBFZGFZHBZIFZJBZEFZWRCKUIUCFZEFZEFZXFAUJLWQXEUDUEAUF
    MXDXGWREXDXGUKBZJBZXGXCXIJCNIFCXCXICOUGWSCXBNICOUHXBNHBNXANHXAAAGFNWTAAGULU
    MUNQUOVCQUPUQURUOXGJUSLZXJXGUDXKXGUJLKDZXGUTBZPRXMKVARCXFOXFSVBZVDZXLXFXMPX
    LNPRZNXFPRZXLXFPRNKPRZXPVEKVFLXRXPVGTKVHMVIXFVJLZXQKVJLZXSKTVEVKZKVLMXFVMMX
    LNXFKTVNVOSVPVQNXGIFZUTBXMXFYBXGUTXGXOVRUONXFVOSVSVTZWAXMXFKVAYCXFKSTXTXFKP
    RYAKWBMWFWCXGWDWEXGWGMQUMAXFEFZXHXFWRCEFZXFEFYDXHYEAXFEYECCEFZDADZDACCOOWHY
    FYGWPWIAUEWJWKWLWRCXFCOWMOXNWNVTXFXNWOVTWK $.

  $( The arcsine of ` 1 ` is ` pi / 2 ` .  (Contributed by Mario Carneiro,
     2-Apr-2015.) $)
  acos1 $p |- ( arccos ` 1 ) = 0 $=
    ( c1 cacos cfv cpi c2 cdiv co casin cmin cc0 wcel wceq ax-1cn acosval ax-mp
    cc asin1 oveq2i pire recni halfcl subidi 3eqtri ) ABCZDEFGZAHCZIGZUEUEIGJAP
    KUDUGLMANOUFUEUEIQRUEDPKUEPKDSTDUAOUBUC $.

  $( The arcsine function composed with ` sin ` is equal to the identity.
     (Contributed by Mario Carneiro, 2-Apr-2015.) $)
  reasinsin $p |- ( A e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ->
    ( arcsin ` ( sin ` A ) ) = A ) $=
    ( cpi co cneg wcel csin cfv casin wceq cxr wbr halfpire rexri cc0 clt ax-mp
    wo cc id c1 c2 cdiv cicc cioo cpr cun cle renegcli crp pire elrpii rphalfcl
    pipos rpgt0 cr wb lt0neg2 mpbi lttri mp2an ltleii prunioo mp3an eleq2i elun
    0re bitr3i elioore recnd rered eqeltrd asinsin syl2anc elpri ax-1cn asinneg
    cre asin1 negeqi eqtri fveq2 recni sinneg sinhalfpi syl6eq 3eqtr4a jaoi syl
    fveq2d sylbi ) ABUAUBCZDZWKUCCZEZAWLWKUDCZEZAWLWKUEZEZQZAFGZHGZAIZWNAWOWQUF
    ZEWSXCWMAWLJEWKJEWLWKUGKXCWMIWLWKLUHZMWKLMWLWKXDLWLNOKZNWKOKZWLWKOKXFXEWKUI
    EZXFBUIEXGBUJUMUKBULPWKUNPZWKUOEXFXEUPLWKUQPURXHWLNWKXDVFLUSUTVAWLWKVBVCVDA
    WOWQVEVGWPXBWRWPAREAVQGZWOEXBWPAAWLWKVHZVIWPXIAWOWPAXJVJWPSVKAVLVMWRAWLIZAW
    KIZQXBAWLWKVNXKXBXLXKTDZHGZWLXAAXNTHGZDZWLTREXNXPIVOTVPPXOWKVRVSVTXKWTXMHXK
    WTWLFGZXMAWLFWAXQWKFGZDZXMWKREXQXSIWKLWBWKWCPXRTWDVSVTWEWIXKSWFXLXOWKXAAVRX
    LWTTHXLWTXRTAWKFWAWDWEWIXLSWFWGWHWGWJ $.

  $( Relationship between sine and arcsine.  (Contributed by Mario Carneiro,
     2-Apr-2015.) $)
  asinsinb $p |- ( ( A e. CC /\ B e. CC /\
    ( Re ` B ) e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) ->
    ( ( arcsin ` A ) = B <-> ( sin ` B ) = A ) ) $=
    ( cc wcel cre cfv cpi c2 cdiv co cneg cioo w3a casin wceq csin fveq2 eqeq1d
    sinasin syl5ibcom 3ad2ant1 asinsin 3adant1 impbid ) ACDZBCDZBEFGHIJZKUGLJDZ
    MZANFZBOZBPFZAOZUIUJPFZAOZUKUMUEUFUOUHASUAUKUNULAUJBPQRTUIULNFZBOZUMUKUFUHU
    QUEBUBUCUMUPUJBULANQRTUD $.

  $( Relationship between sine and arcsine.  (Contributed by Mario Carneiro,
     2-Apr-2015.) $)
  acoscosb $p |- ( ( A e. CC /\ B e. CC /\ ( Re ` B ) e. ( 0 (,) pi ) ) ->
    ( ( arccos ` A ) = B <-> ( cos ` B ) = A ) ) $=
    ( cc wcel cre cfv cc0 cpi cioo co w3a cacos wceq ccos 3ad2ant1 fveq2 eqeq1d
    cosacos syl5ibcom acoscos 3adant1 impbid ) ACDZBCDZBEFGHIJDZKZALFZBMZBNFZAM
    ZUFUGNFZAMZUHUJUCUDULUEAROUHUKUIAUGBNPQSUFUILFZBMZUJUHUDUEUNUCBTUAUJUMUGBUI
    ALPQSUB $.

  $( The arcsine function has range within a vertical strip of the complex
     plane with real part between ` -u pi / 2 ` and ` pi / 2 ` .  (Contributed
     by Mario Carneiro, 2-Apr-2015.) $)
  asinbnd $p |- ( A e. CC ->
    ( Re ` ( arcsin ` A ) ) e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ) $=
    ( cc wcel casin cfv cre ci cmul co c1 c2 cexp cmin csqr caddc clog cim cneg
    cpi cc0 cdiv cicc asinval fveq2d wceq ax-icn mulcl mpan ax-1cn sqcl sylancr
    subcl sqrcld addcld asinlem logcld syl eqtr4d wne cle wbr asinlem3 argrege0
    imre syl3anc eqeltrd ) ABCZADEZFEZGAHIZJAKLIZMIZNEZOIZPEZQEZSKUAIZRVQUBIZVG
    VIGRVOHIZFEZVPVGVHVSFAUCUDVGVOBCVPVTUEVGVNVGVJVMGBCVGVJBCUFGAUGUHVGVLVGJBCV
    KBCVLBCUIAUJJVKULUKUMUNZAUOZUPVOVDUQURVGVNBCVNTUSTVNFEUTVAVPVRCWAWBAVBVNVCV
    EVF $.

  $( The arccosine function has range within a vertical strip of the complex
     plane with real part between ` 0 ` and ` pi ` .  (Contributed by Mario
     Carneiro, 2-Apr-2015.) $)
  acosbnd $p |- ( A e. CC -> ( Re ` ( arccos ` A ) ) e. ( 0 [,] pi ) ) $=
    ( cc wcel cfv cre cpi co cmin cc0 cicc wceq halfpire recni sylancr cr ax-mp
    cle wbr elicc2i pire cacos c2 cdiv casin acosval fveq2d asincl resub oveq1i
    rere syl6eq eqtrd recld resubcl w3a asinbnd renegcli sylib simp3d wb subge0
    mpbird a1i caddc negsubi 2halves subaddrii eqtri simp2d syl5eqbr subled 0re
    cneg syl3anbrc eqeltrd ) ABCZAUADZEDZFUBUCGZAUDDZEDZHGZIFJGZVPVRVSVTHGZEDZW
    BVPVQWDEAUEUFVPWEVSEDZWAHGZWBVPVSBCVTBCWEWGKVSLMZAUGZVSVTUHNWFVSWAHVSOCZWFV
    SKLVSUJPUIUKULVPWBOCZIWBQRZWBFQRWBWCCVPWJWAOCZWKLVPVTWIUMZVSWAUNNVPWLWAVSQR
    ZVPWMVSVMZWAQRZWOVPWAWPVSJGCWMWQWOUOAUPWPVSWAVSLUQZLSURZUSVPWJWMWLWOUTLWNVS
    WAVANVBVPVSFWAWJVPLVCFOCVPTVCWNVPVSFHGWPWAQVSFWPWHFTMZWPWRMFWPVDGFVSHGVSFVS
    WTWHVEFVSVSWTWHWHFBCVSVSVDGFKWTFVFPVGVHVGVPWMWQWOWSVIVJVKIFWBVLTSVNVO $.

  $( Bounds on the arcsine function.  (Contributed by Mario Carneiro,
     2-Apr-2015.) $)
  asinrebnd $p |- ( A e. ( -u 1 [,] 1 ) ->
    ( arcsin ` A ) e. ( -u ( pi / 2 ) [,] ( pi / 2 ) ) ) $=
    ( c1 cneg cicc co wcel casin cfv csin cpi cdiv cres ccnv wceq wf1o resinf1o
    c2 wf syl eqtr3d f1ocnv f1of mp2b ffvelrni fvres f1ocnvfv2 fveq2d reasinsin
    mpan eqeltrd ) ABCBDEZFZAGHZAIJQKEZCUNDEZLZMZHZUOULURIHZGHZUMURULUSAGULURUP
    HZUSAULURUOFZVAUSNUKUOAUQUOUKUPOZUKUOUQOUKUOUQRPUOUKUPUAUKUOUQUBUCUDZURUOIU
    ESVCULVAANPUOUKAUPUFUITUGULVBUTURNVDURUHSTVDUJ $.

  $( The arcsine function is real in its principal domain.  (Contributed by
     Mario Carneiro, 2-Apr-2015.) $)
  asinrecl $p |- ( A e. ( -u 1 [,] 1 ) -> ( arcsin ` A ) e. RR ) $=
    ( c1 cneg cicc co wcel cpi c2 cdiv cr casin cfv wss halfpire renegcli mp2an
    iccssre asinrebnd sseldi ) ABCBDEFGHIEZCZTDEZJAKLUAJFTJFUBJMTNONUATQPARS $.

  $( The arccosine function is real in its principal domain.  (Contributed by
     Mario Carneiro, 2-Apr-2015.) $)
  acosrecl $p |- ( A e. ( -u 1 [,] 1 ) -> ( arccos ` A ) e. RR ) $=
    ( c1 cneg cicc co wcel cacos cfv cpi c2 cdiv casin cmin cr cc wceq renegcli
    wss 1re iccssre mp2an sseli recnd acosval halfpire asinrecl resubcl sylancr
    syl eqeltrd ) ABCZBDEZFZAGHZIJKEZALHZMEZNUMAOFUNUQPUMAULNAUKNFBNFULNRBSQSUK
    BTUAUBUCAUDUIUMUONFUPNFUQNFUEAUFUOUPUGUHUJ $.

  $( The cosine of the arcsine of ` A ` is ` sqr ( 1 - A ^ 2 ) ` .
     (Contributed by Mario Carneiro, 2-Apr-2015.) $)
  cosasin $p |- ( A e. CC ->
    ( cos ` ( arcsin ` A ) ) = ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) $=
    ( cc wcel casin cfv ci cmul co ce cneg caddc c2 cdiv c1 cexp cmin csqr wceq
    ax-icn 3eqtrd ccos asincl cosval syl ax-1cn sqcl subcl sylancr sqrcld mulcl
    ppncand efiasin addcomd eqtrd mulneg12 asinneg oveq2d eqtr4d fveq2d mulneg2
    mpan negcl sqneg oveq12d negcld negsubd 2timesd 3eqtr4d oveq1d 2cn a1i 2ne0
    cc0 wne divcan3d ) ABCZADEZUAEZFVQGHIEZFJVQGHZIEZKHZLMHZLNALOHZPHZQEZGHZLMH
    WFVPVQBCZVRWCRAUBZVQUCUDVPWBWGLMVPWFFAGHZKHZWFWJPHZKHWFWFKHWBWGVPWFWJWFVPWE
    VPNBCWDBCWEBCUEAUFNWDUGUHUIZFBCZVPWJBCSFAUJVAZWMUKVPVSWKWAWLKVPVSWJWFKHWKAU
    LVPWJWFWOWMUMUNVPWAWJJZWFKHZWFWPKHWLVPWAFAJZDEZGHZIEZFWRGHZNWRLOHZPHZQEZKHZ
    WQVPVTWTIVPVTFVQJZGHZWTVPWNWHVTXHRSWIFVQUOUHVPWSXGFGAUPUQURUSVPWRBCXAXFRAVB
    WRULUDVPXBWPXEWFKWNVPXBWPRSFAUTVAVPXDWEQVPXCWDNPAVCUQUSVDTVPWPWFVPWJWOVEWMU
    MVPWFWJWMWOVFTVDVPWFWMVGVHVIVPWFLWMLBCVPVJVKLVMVNVPVLVKVOT $.

  $( The sine of the arccosine of ` A ` is ` sqr ( 1 - A ^ 2 ) ` .
     (Contributed by Mario Carneiro, 2-Apr-2015.) $)
  sinacos $p |- ( A e. CC ->
    ( sin ` ( arccos ` A ) ) = ( sqr ` ( 1 - ( A ^ 2 ) ) ) ) $=
    ( cc wcel cpi c2 cdiv co cacos cfv cmin ccos casin csin c1 cexp csqr oveq2d
    acosval wceq pire recni halfcl ax-mp asincl nncan sylancr fveq2d coshalfpim
    eqtrd acoscl syl cosasin 3eqtr3d ) ABCZDEFGZAHIZJGZKIZALIZKIUPMIZNAEOGJGPIU
    NUQUSKUNUQUOUOUSJGZJGZUSUNUPVAUOJARQUNUOBCZUSBCVBUSSDBCVCDTUADUBUCAUDUOUSUE
    UFUIUGUNUPBCURUTSAUJUPUHUKAULUM $.

  $( The domain of the arctangent function is closed under negatives.
     (Contributed by Mario Carneiro, 3-Apr-2015.) $)
  atandmneg $p |- ( A e. dom arctan -> -u A e. dom arctan ) $=
    ( catan cdm wcel cneg cc c2 cexp co c1 wne atandm3 simplbi negcld sqneg syl
    wceq simprbi eqnetrd sylanbrc ) ABCZDZAEZFDUCGHIZJEZKUCUADUBAUBAFDZAGHIZUEK
    ZALZMZNUBUDUGUEUBUFUDUGQUJAOPUBUFUHUIRSUCLT $.

  $( The arctangent function is odd.  (Contributed by Mario Carneiro,
     3-Apr-2015.) $)
  atanneg $p |- ( A e. dom arctan -> ( arctan ` -u A ) = -u ( arctan ` A ) ) $=
    ( catan wcel ci co c1 cneg cmul cmin clog cfv caddc wceq ax-icn cc0 sylancr
    cc oveq2d ax-1cn eqtrd cdm c2 cdiv wne atandm2 simp1bi mulneg2 mulcl subneg
    fveq2d negsub oveq12d subcl simp2bi logcld simp3bi negsubdi2d eqtr4d halfcl
    addcl ax-mp subcld atandmneg atanval syl negeqd 3eqtr4d ) ABUAZCZDUBUCEZFDA
    GZHEZIEZJKZFVLLEZJKZIEZHEZVJFDAHEZIEZJKZFVSLEZJKZIEZHEZGZVKBKZABKZGVIVRVJWD
    GZHEZWFVIVQWIVJHVIVQWCWAIEWIVIVNWCVPWAIVIVMWBJVIVMFVSGZIEZWBVIVLWKFIVIDQCZA
    QCZVLWKMNVIWNVTOUDZWBOUDZAUEZUFZDAUGPZRVIFQCZVSQCZWLWBMSVIWMWNXANWRDAUHPZFV
    SUIPTUJVIVOVTJVIVOFWKLEZVTVIVLWKFLWSRVIWTXAXCVTMSXBFVSUKPTUJULVIWAWCVIVTVIW
    TXAVTQCSXBFVSUMPVIWNWOWPWQUNUOZVIWBVIWTXAWBQCSXBFVSUTPVIWNWOWPWQUPUOZUQURRV
    IVJQCZWDQCWJWFMWMXFNDUSVAVIWAWCXDXEVBVJWDUGPTVIVKVHCWGVRMAVCVKVDVEVIWHWEAVD
    VFVG $.

  $( The arctangent of zero is zero.  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  atan0 $p |- ( arctan ` 0 ) = 0 $=
    ( cc0 catan cfv cneg wceq neg0 fveq2i cr wcel cdm 0re atanre atanneg eqtr3i
    mp2b cc atancl eqnegi mpbi ) ABCZTDZETAEADZBCZTUAUBABFGAHIZABJIZUCUAEKALZAM
    ONTUDUETPIKUFAQORS $.

  $( The arctangent function distributes under conjugation.  (Contributed by
     Mario Carneiro, 31-Mar-2015.) $)
  atandmcj $p |- ( A e. dom arctan -> ( * ` A ) e. dom arctan ) $=
    ( catan cdm wcel ccj cfv cc c2 cexp co c1 cneg wne atandm3 simplbi cn0 wceq
    cjcld 2nn0 cjexp sylancl sqcld cjcjd simprbi eqnetrd fveq2 cr renegcli cjre
    1re ax-mp syl6eq necon3i syl eqnetrrd sylanbrc ) ABCZDZAEFZGDUSHIJZKLZMUSUQ
    DURAURAGDZAHIJZVAMZANZOZRURVCEFZUTVAURVBHPDVGUTQVFSAHTUAURVGEFZVAMVGVAMURVH
    VCVAURVCURAVFUBUCURVBVDVEUDUEVGVAVHVAVGVAQVHVAEFZVAVGVAEUFVAUGDVIVAQKUJUHVA
    UIUKULUMUNUOUSNUP $.

  $( The arctangent function distributes under conjugation.  (The condition
     that ` Re ( A ) =/= 0 ` is necessary because the branch cuts are chosen so
     that the negative imaginary line "agrees with" neighboring values with
     negative real part, while the positive imaginary line agrees with values
     with positive real part.  This makes ~ atanneg true unconditionally but
     messes up conjugation symmetry, and it is impossible to have both in a
     single-valued function.  The claim is true on the imaginary line between
     ` -u 1 ` and ` 1 ` , though.)  (Contributed by Mario Carneiro,
     31-Mar-2015.) $)
  atancj $p |- ( ( A e. CC /\ ( Re ` A ) =/= 0 ) -> ( A e. dom arctan /\
    ( * ` ( arctan ` A ) ) = ( arctan ` ( * ` A ) ) ) ) $=
    ( cc wcel cfv cc0 wne ccj wceq ci cneg ax-icn c2 co c1 cmul cmin clog caddc
    ax-1cn sylancr cre wa catan cdm simpl simpr fveq2 renegi negeqi neg0 3eqtri
    rei syl6eq necon3i syl atandm syl3anbrc cdiv halfcl ax-mp mulcl w3a atandm2
    subcl sylib simp2d logcld addcl simp3d subcld cjmul 2cn cjdivi divneg mp3an
    2ne0 cji 2re cjre oveq12i eqtr4i oveq1i cjcld mulneg12 syl5eq cjsub syl2anc
    cim imsub reim adantr oveq2d eqtr4d df-neg im1 syl6eqr recl negne0d eqnetrd
    recnd logcj 1re mp1i cjcl mulneg1 eqtrd oveq12d subneg 3eqtrd fveq2d eqtr3d
    cr imadd addid2d 3eqtr2d negsub atandmcj simp3bi simp2bi negsubdi2d atanval
    cjadd negeqd 3eqtr4d jca ) ABCZAUADZEFZUBZAUCUDZCZAUCDZGDZAGDZUCDZHYIYFAIJZ
    FZAIFZYKYFYHUEZYIYHYQYFYHUFZAYPYGEAYPHYGYPUADZEAYPUAUGUUAIUADZJEJEIKUHUUBEU
    LUIUJUKUMUNUOYIYHYRYTAIYGEAIHYGUUBEAIUAUGULUMUNUOAUPUQZYIILURMZNIAOMZPMZQDZ
    NUUERMZQDZPMZOMZGDZUUDNIYNOMZPMZQDZNUUMRMZQDZPMZOMZYMYOYIUULUUDGDZUUJGDZOMZ
    UUDUVAJZOMZUUSYIUUDBCZUUJBCUULUVBHIBCZUVEKIUSUTZYIUUGUUIYIUUFYINBCZUUEBCZUU
    FBCZSYIUVFYFUVIKYSIAVATZNUUEVDTZYIYFUUFEFZUUHEFZYIYKYFUVMUVNVBUUCAVCVEZVFVG
    ZYIUUHYIUVHUVIUUHBCZSUVKNUUEVHTZYIYFUVMUVNUVOVIVGZVJZUUDUUJVKTYIUVBUUDJZUVA
    OMZUVDUUTUWAUVAOUUTIGDZLGDZURMZUWALEFZUUTUWEHVPILKVLVMUTUWAYPLURMZUWEUVFLBC
    UWFUWAUWGHKVLVPILVNVOUWCYPUWDLURVQLXLCUWDLHVRLVSUTVTWAWAWBYIUVEUVABCUWBUVDH
    UVGYIUUJUVTWCUUDUVAWDTWEYIUVCUURUUDOYIUVCUUQUUOPMZJUURYIUVAUWHYIUVAUUGGDZUU
    IGDZPMZUWHYIUUGBCUUIBCUVAUWKHUVPUVSUUGUUIWFWGYIUWIUUQUWJUUOPYIUUFGDZQDZUWIU
    UQYIUVJUUFWHDZEFUWMUWIHUVLYIUWNYGJZEYIUWNNWHDZYGPMZUWOYIUWNUWPUUEWHDZPMZUWQ
    YIUVHUVIUWNUWSHSUVKNUUEWITYIYGUWRUWPPYFYGUWRHYHAWJWKZWLWMUWOEYGPMUWQYGWNUWP
    EYGPWOWBWAWPYIYGYIYGYFYGXLCYHAWQWKWTZYTWRWSUUFXAWGYIUWLUUPQYIUWLNGDZUUEGDZP
    MZNUUMJZPMZUUPYIUVHUVIUWLUXDHSUVKNUUEWFTYIUXBNUXCUXEPNXLCUXBNHYIXBNVSXCZYIU
    XCUWCYNOMZUXEYIUVFYFUXCUXHHKYSIAVKTYIUXHYPYNOMZUXEUWCYPYNOVQWBYIUVFYNBCZUXI
    UXEHKYFUXJYHAXDWKZIYNXETWEXFZXGYIUVHUUMBCZUXFUUPHSYIUVFUXJUXMKUXKIYNVATZNUU
    MXHTXIXJXKYIUUHGDZQDZUWJUUOYIUVQUUHWHDZEFUXPUWJHUVRYIUXQYGEYIUXQUWPUWRRMZEY
    GRMZYGYIUVHUVIUXQUXRHSUVKNUUEXMTYIUXSEUWRRMUXRYIYGUWRERUWTWLUWPEUWRRWOWBWPY
    IYGUXAXNXOYTWSUUHXAWGYIUXOUUNQYIUXOUXBUXCRMZNUXERMZUUNYIUVHUVIUXOUXTHSUVKNU
    UEYBTYIUXBNUXCUXERUXGUXLXGYIUVHUXMUYAUUNHSUXNNUUMXPTXIXJXKXGXFYCYIUUQUUOYIU
    UPYIUVHUXMUUPBCSUXNNUUMVHTYIYNYJCZUUPEFZYIYKUYBUUCAXQUOZUYBUXJUUNEFZUYCYNVC
    ZXRUOVGYIUUNYIUVHUXMUUNBCSUXNNUUMVDTYIUYBUYEUYDUYBUXJUYEUYCUYFXSUOVGXTXFWLX
    IYIYLUUKGYIYKYLUUKHUUCAYAUOXJYIUYBYOUUSHUYDYNYAUOYDYE $.

  $( The arctangent function is real for all real inputs.  (Contributed by
     Mario Carneiro, 31-Mar-2015.) $)
  atanrecl $p |- ( A e. RR -> ( arctan ` A ) e. RR ) $=
    ( cr wcel catan cfv cc0 wceq wa simpr fveq2d atan0 0re eqeltri syl6eqel wne
    cdm cc atanre adantr ccj atancl syl simpl recnd rere eqnetrd atancj syl2anc
    cre simprd cjre eqtrd cjrebd pm2.61dane ) ABCZADEZBCAFUOAFGZHZUPFDEZBURAFDU
    OUQIJUSFBKLMNUOAFOZHZUPVAADPCZUPQCUOVBUTARSAUAUBVAUPTEZATEZDEZUPVAVBVCVEGZV
    AAQCAUIEZFOVBVFHVAAUOUTUCUDVAVGAFUOVGAGUTAUESUOUTIUFAUGUHUJVAVDADUOVDAGUTAU
    KSJULUMUN $.

  $( Value of the exponential of an artcangent.  (Contributed by Mario
     Carneiro, 2-Apr-2015.) $)
  efiatan $p |- ( A e. dom arctan ->
    ( exp ` ( _i x. ( arctan ` A ) ) ) =
    ( ( sqr ` ( 1 + ( _i x. A ) ) ) / ( sqr ` ( 1 - ( _i x. A ) ) ) ) ) $=
    ( wcel ci cfv cmul co ce c1 c2 cdiv cmin cc ax-icn ax-1cn cc0 mulcl sylancr
    wne cneg wceq catan cdm clog csqr atanval oveq2d a1i halfcl atandm2 simp1bi
    caddc mp1i subcl simp2bi logcld addcl simp3bi subcld mulassd 2cn 2ne0 mp3an
    divneg ixi oveq1i divassi 3eqtr2i reccli mulneg12 negsubdi2d subdid syl5eqr
    3eqtrd 3eqtr2d fveq2d efsub syl2anc ccxp cxpefd cxpsqr syl eqtr3d oveq12d )
    AUAUBBZCAUADZEFZGDHIJFZHCAEFZUKFZUCDZEFZWGHWHKFZUCDZEFZKFZGDZWKGDZWNGDZJFZW
    IUDDZWLUDDZJFWDWFWOGWDWFCCIJFZWMWJKFZEFZEFCXBEFZXCEFZWOWDWEXDCEAUEUFWDCXBXC
    CLBZWDMUGXGXBLBWDMCUHULWDWMWJWDWLWDHLBZWHLBZWLLBZNWDXGALBZXIMWDXKWLORZWIORZ
    AUIZUJCAPQZHWHUMQZWDXKXLXMXNUNZUOZWDWIWDXHXIWILBZNXOHWHUPQZWDXKXLXMXNUQZUOZ
    URZUSWDXFWGSZXCEFZWOYDXEXCEYDHSZIJFZCCEFZIJFXEXHILBIORYDYGTNUTVAHIVCVBYHYFI
    JVDVECCIMMUTVAVFVGVEWDYEWGXCSZEFZWGWJWMKFZEFWOWDWGLBZXCLBYEYJTIUTVAVHZYCWGX
    CVIQWDYIYKWGEWDWMWJXRYBVJUFWDWGWJWMYLWDYMUGZYBXRVKVMVLVNVOWDWKLBZWNLBZWPWST
    WDYLWJLBYOYMYBWGWJPQWDYLWMLBYPYMXRWGWMPQWKWNVPVQWDWQWTWRXAJWDWIWGVRFZWQWTWD
    WIWGXTYAYNVSWDXSYQWTTXTWIVTWAWBWDWLWGVRFZWRXAWDWLWGXPXQYNVSWDXJYRXATXPWLVTW
    AWBWCVM $.

  $( Lemma for ~ atanlogadd .  (Contributed by Mario Carneiro, 3-Apr-2015.) $)
  atanlogaddlem $p |- ( ( A e. dom arctan /\ 0 <_ ( Re ` A ) ) ->
    ( ( log ` ( 1 + ( _i x. A ) ) ) +
      ( log ` ( 1 - ( _i x. A ) ) ) ) e. ran log ) $=
    ( wcel cc0 cfv cle wbr clt c1 co caddc cr cc sylancr cpi cim adantr syl2anc
    wa a1i 1re catan cdm cre wceq wo cmul clog cmin crn 0re wne atandm2 simp1bi
    ci recld leloe biimpa cneg ax-1cn ax-icn mulcl addcl simp3bi logcld simp2bi
    wb subcl addcld pire renegcli imcld readdcld im1 oveq1i df-neg eqtr4i imsub
    cioo reim syl negeqd 3eqtr4a lt0neg2d eqbrtrd argimlt0 eliooord simpr imadd
    simpld oveq2d recnd addid2d syl5eq breqtrrd argimgt0 ltaddpos2d mpbid lttrd
    3eqtr2d imaddd simprd ltadd2dd addid1d breqtrd ltled ellogrn eqtr2d reim0bd
    syl3anbrc addcomd ad2antrr logrncl readdcl addge01 ltletrd elrpd logrnaddcl
    relogcld eqeltrd resubcl subid1i lesub2d syl5eqbrr lecasei jaodan syldan
    0lt1 ) AUAUBBZCAUCDZEFZCYIGFZCYIUDZUEZHUNAUFIZJIZUGDZHYNUHIZUGDZJIZUGUIZBZY
    HYJYMYHCKBZYIKBYJYMVFUJYHAYHALBZYQCUKZYOCUKZAULZUMZUOZCYIUPMUQYHYKUUAYLYHYK
    RZYSLBZNURZYSODZGFUULNEFUUAYHUUJYKYHYPYRYHYOYHHLBZYNLBZYOLBZUSYHUNLBUUCUUNU
    TUUGUNAVAMZHYNVBMZYHUUCUUDUUEUUFVCZVDZYHYQYHUUMUUNYQLBZUSUUPHYNVGMZYHUUCUUD
    UUEUUFVEZVDZVHPUUIUUKYPODZYRODZJIZUULGUUIUUKUVEUVFUUKKBUUINVIVJSUUIYRYHYRLB
    YKUVCPZVKZUUIUVDUVEUUIYPYHYPLBYKUUSPZVKZUVHVLZUUIUUKUVEGFZUVECGFZUUIUVEUUKC
    VRIBZUVLUVMRUUIUUTYQODZCGFUVNYHUUTYKUVAPUUIUVOYIURZCGUUIHODZYNODZUHIZUVRURZ
    UVOUVPUVSCUVRUHIUVTUVQCUVRUHVMVNUVRVOVPUUIUUMUUNUVOUVSUDUSYHUUNYKUUPPZHYNVQ
    MUUIYIUVRUUIUUCYIUVRUDZYHUUCYKUUGPZAVSZVTZWAWBYHYKUVPCGFYHYIUUHWCUQWDYQWEQU
    VEUUKCWFVTZWIUUICUVDGFZUVEUVFGFUUIUWGUVDNGFZUUIUVDCNVRIBZUWGUWHRUUIUUOCYOOD
    ZGFUWIYHUUOYKUUQPUUICYIUWJGYHYKWGUUIUWJUVQUVRJIZUVQYIJIZYIUUIUUMUUNUWJUWKUD
    USUWAHYNWHMUUIYIUVRUVQJUWEWJUUIUWLCYIJIYIUVQCYIJVMVNUUIYIUUIYIUUIAUWCUOWKWL
    WMWSWNYOWOQUVDCNWFVTZWIUUIUVDUVEUVJUVHWPWQWRUUIYPYRUVIUVGWTZWNUUIUULUVFNEUW
    NUUIUVFNUVKNKBUUIVISZUUIUVFUVDNUVKUVJUWOUUIUVFUVDCJIUVDGUUIUVECUVDUVHUUBUUI
    UJSUVJUUIUVLUVMUWFXAXBUUIUVDUUIUVDUVJWKXCXDUUIUWGUWHUWMXAWRXEWDYSXFXIYHYLRZ
    UUACYNUUBUWPUJSZUWPYNYHUUNYLUUPPUWPCYIUVRYHYLWGUWPUUCUWBYHUUCYLUUGPUWDVTXGX
    HZUWPCYNEFZRZYSYRYPJIZYTYHYSUXAUDYLUWSYHYPYRUUSUVCXJXKUWTYRYTBZYPKBUXAYTBYH
    UXBYLUWSYHUUTUUDUXBUVAUVBYQXLQXKUWTYOUWTYOUWTHKBZYNKBZYOKBTUWPUXDUWSUWRPHYN
    XMMZUWTCHYOUUBUWTUJSUXCUWTTSUXECHGFZUWTYGSUWPUWSHYOEFZUWPUXCUXDUWSUXGVFTUWR
    HYNXNMUQXOXPXRYRYPXQQXSUWPYNCEFZRZYPYTBZYRKBUUAYHUXJYLUXHYHUUOUUEUXJUUQUURY
    OXLQXKUXIYQUXIYQUXIUXCUXDYQKBTUWPUXDUXHUWRPHYNXTMZUXICHYQUUBUXIUJSUXCUXITSU
    XKUXFUXIYGSUXIHHCUHIZYQEHUSYAUWPUXHUXLYQEFUWPYNCHUWRUWQUXCUWPTSYBUQYCXOXPXR
    YPYRXQQYDYEYF $.

  $( The rule ` sqr ( z w ) = ( sqr z ) ( sqr w ) ` is not always true on the
     complexes, but it is true when the arguments of ` z ` and ` w ` sum to
     within the interval ` ( -u pi , pi ] ` , so there are some cases such as
     this one with ` z = 1 + _i A ` and ` w = 1 - _i A ` which are true
     unconditionally.  This result can also be stated
     as " ` sqr ( 1 + z ) + sqr ( 1 - z ) ` is analytic".  (Contributed by
     Mario Carneiro, 3-Apr-2015.) $)
  atanlogadd $p |- ( A e. dom arctan ->
    ( ( log ` ( 1 + ( _i x. A ) ) ) +
      ( log ` ( 1 - ( _i x. A ) ) ) ) e. ran log ) $=
    ( wcel c1 ci cmul co caddc clog cfv cmin cc0 cre cc cle cneg ax-1cn sylancr
    wbr wceq adantr catan cdm crn cr 0re a1i wne atandm2 recld atanlogaddlem wa
    simp1bi ax-icn mulcl addcl simp3bi logcld subcl simp2bi oveq2d negsub eqtrd
    addcomd mulneg2 fveq2d subneg oveq12d eqtr4d le0neg1d biimpa renegd syl2anc
    atandmneg breqtrrd eqeltrd lecasei ) AUAUBZBZCDAEFZGFZHIZCVSJFZHIZGFZHUCZBK
    ALIZKUDBVRUEUFVRAVRAMBZWBKUGZVTKUGZAUHZULZUIZAUJVRWFKNRZUKZWDCDAOZEFZGFZHIZ
    CWPJFZHIZGFZWEVRWDXASWMVRWDWCWAGFXAVRWAWCVRVTVRCMBZVSMBZVTMBPVRDMBZWGXCUMWK
    DAUNQZCVSUOQVRWGWHWIWJUPUQVRWBVRXBXCWBMBPXECVSURQVRWGWHWIWJUSUQVCVRWRWCWTWA
    GVRWQWBHVRWQCVSOZGFZWBVRWPXFCGVRXDWGWPXFSUMWKDAVDQZUTVRXBXCXGWBSPXECVSVAQVB
    VEVRWSVTHVRWSCXFJFZVTVRWPXFCJXHUTVRXBXCXIVTSPXECVSVFQVBVEVGVHTWNWOVQBZKWOLI
    ZNRXAWEBVRXJWMAVMTWNKWFOZXKNVRWMKXLNRVRWFWLVIVJVRXKXLSWMVRAWKVKTVNWOUJVLVOV
    P $.

  $( Lemma for ~ atanlogsub .  (Contributed by Mario Carneiro, 4-Apr-2015.) $)
  atanlogsublem $p |- ( ( A e. dom arctan /\ 0 < ( Re ` A ) ) ->
    ( Im ` ( ( log ` ( 1 + ( _i x. A ) ) ) -
             ( log ` ( 1 - ( _i x. A ) ) ) ) ) e. ( -u pi (,) pi ) ) $=
    ( wcel cc0 cre cfv clt wbr c1 ci co caddc clog cmin cim cpi cc wceq sylancl
    ax-icn cr catan cdm wa cmul cneg cioo c2 ax-1cn wne w3a simpl atandm2 sylib
    simp1d mulcl sylancr addcl simp3d logcld subcl simp2d imsubd a1i subdid ixi
    oveq2i subneg syl5eq addcom 3eqtrd fveq2d cle resub rei recld recnd subid1d
    cdiv eqtrd gt0ne0 sylancom eqnetrd fveq2 re0 syl6eq necon3i syl wi 0re ltle
    simpr mpd breqtrrd logimul syl3anc eqtr3d halfpire recni mulcli imadd ax-mp
    reim rere eqtr3i readd addid1d logneg2 syl2anc adddid negsub negsubdi2 pire
    negeqd oveq1d addsubassd 3eqtr3d subcli imsub mp2an oveq12i negsubi 2halves
    negcli subaddrii eqtri 3eqtri oveq12d imcld logimcld wb mpbid ltsubaddd imi
    ctan 3brtr4d tanarg argregt0 mpbird cxr rexri subnegi readdcl simpld simprd
    addsub4d resubcld renegcli renegcld leneg ltleaddd negsubd breqtrd peano2re
    syl5eqbrr peano2rem ltm1d ltdiv1 syl112anc tanord addid2d ltadd1dd syl6breq
    ltp1d lttrd addid2i elioo2 syl3anbrc eqeltrd ) AUAUBBZCADEZFGZUCZHIAUDJZKJZ
    LEZHUVMMJZLEZMJNEZAIMJZLEZNEZAIKJZLEZNEZMJZOKJZOUEZOUFJZUVLUVRUVONEZUVQNEZM
    JUWAOUGVRJZKJZUWDUWKUEZKJZMJZUWFUVLUVOUVQUVLUVNUVLHPBZUVMPBZUVNPBUHUVLIPBZA
    PBZUWQSUVLUWSUVPCUIZUVNCUIZUVLUVIUWSUWTUXAUJUVIUVKUKAULUMZUNZIAUOUPZHUVMUQU
    PUVLUWSUWTUXAUXBURUSUVLUVPUVLUWPUWQUVPPBUHUXDHUVMUTUPUVLUWSUWTUXAUXBVAUSVBU
    VLUWIUWLUWJUWNMUVLUWIUVTIUWKUDJZKJZNEZUWLUVLUVOUXFNUVLIUVSUDJZLEZUVOUXFUVLU
    XHUVNLUVLUXHUVMIIUDJZMJZUVMHKJZUVNUVLIAIUWRUVLSVCZUXCUXMVDUVLUXKUVMHUEZMJZU
    XLUXJUXNUVMMVEVFUVLUWQUWPUXOUXLQUXDUHUVMHVGRVHUVLUWQUWPUXLUVNQUXDUHUVMHVIRV
    JVKUVLUVSPBZUVSCUIZCUVSDEZVLGUXIUXFQUVLUWSUWRUXPUXCSAIUTRZUVLUXRCUIZUXQUVLU
    XRUVJCUVLUXRUVJIDEZMJZUVJUVLUWSUWRUXRUYBQUXCSAIVMRUVLUYBUVJCMJUVJUYACUVJMVN
    VFUVLUVJUVLUVJUVLAUXCVOZVPZVQVHVSZUVIUVKUVJTBZUVJCUIUYCUVJVTWAZWBZUVSCUXRCU
    VSCQUXRCDEZCUVSCDWCWDWEWFWGZUVLCUVJUXRVLUVLUVKCUVJVLGZUVIUVKWKZUVLCTBZUYFUV
    KUYKWHWIUYCCUVJWJUPWLZUYEWMUVSWNWOWPVKUVLUXGUWAUXENEZKJZUWLUVLUVTPBUXEPBZUX
    GUYPQUVLUVSUXSUYJUSZIUWKSUWKWQWRZWSZUVTUXEWTRUYOUWKUWAKUWKDEZUYOUWKUWKPBZVU
    AUYOQUYSUWKXBXAUWKTBVUAUWKQWQUWKXCXAXDZVFWEVSUVLUWJUWCUXEIOUDJZMJZKJZNEZUWN
    UVLUVQVUFNUVLIUWBUDJZUEZLEZVUHLEZVUDMJZUVQVUFUVLVUHPBZCVUHNEZFGVUJVULQUVLUW
    RUWBPBZVUMSUVLUWSUWRVUOUXCSAIUQRZIUWBUOUPUVLCUVJVUNFUYLUVLUWBDEZVUNUVJUVLVU
    OVUQVUNQVUPUWBXBWGUVLVUQUVJUYAKJZUVJUVLUWSUWRVUQVURQUXCSAIXERUVLVURUVJCKJUV
    JUYACUVJKVNVFUVLUVJUYDXFVHVSZWPWMVUHXGXHUVLVUIUVPLUVLVUIUVMHMJZUEZUVPUVLVUH
    VUTUVLVUHUVMUXJKJZVUTUVLIAIUXMUXCUXMXIUVLVVBUVMUXNKJZVUTUXJUXNUVMKVEVFUVLUW
    QUWPVVCVUTQUXDUHUVMHXJRVHVSXMUVLUWQUWPVVAUVPQUXDUHUVMHXKRVSVKUVLVULUWCUXEKJ
    ZVUDMJVUFUVLVUKVVDVUDMUVLVUOUWBCUIZCVUQVLGVUKVVDQVUPUVLVUQCUIZVVEUVLVUQUVJC
    VUSUYGWBZUWBCVUQCUWBCQVUQUYICUWBCDWCWDWEWFWGZUVLCUVJVUQVLUYNVUSWMUWBWNWOXNU
    VLUWCUXEVUDUVLUWBVUPVVHUSZUYQUVLUYTVCVUDPBZUVLIOSOXLWRZWSZVCXOVSXPVKUVLVUGU
    WDVUENEZKJZUWNUVLUWCPBVUEPBVUGVVNQVVIUXEVUDUYTVVLXQUWCVUEWTRVVMUWMUWDKVVMUY
    OVUDNEZMJZUWKOMJUWMUYQVVJVVMVVPQUYTVVLUXEVUDXRXSUYOUWKVVOOMVUCODEZVVOOOPBZV
    VQVVOQVVKOXBXAOTBZVVQOQXLOXCXAXDXTUWKOUWMUYSVVKUWKUYSYCZOUWMKJOUWKMJUWKOUWK
    VVKUYSYAOUWKUWKVVKUYSUYSVVRUWKUWKKJZOQVVKOYBXAZYDYEYDYFVFWEVSYGUVLUWOUWEUWK
    UWMMJZKJUWFUVLUWAUWKUWDUWMUVLUWAUVLUVTUYRYHZVPZVUBUVLUYSVCUVLUWDUVLUWCVVIYH
    ZVPZUWMPBUVLVVTVCUUEVWCOUWEKVWCVWAOUWKUWKUYSUYSUUAVWBYEVFWEVJUVLUWFTBZUWGUW
    FFGZUWFOFGZUWFUWHBZUVLUWETBVVSVWHUVLUWAUWDVWDVWFUUFZXLUWEOUUBRUVLUWGOMJZUWE
    FGVWIUVLVWMUWGUWGKJZUWEFUWGOUWGOXLUUGZWRVVKYAUVLVWNUWAUWDUEZKJUWEFUVLUWGUWG
    UWAVWPUWGTBUVLVWOVCZVWQVWDUVLUWDVWFUUHUVLUWGUWAFGUWAOVLGUVLUVSUXSUYJYIUUCUV
    LUWDOVLGZUWGVWPVLGZUVLUWGUWDFGVWRUVLUWBVUPVVHYIUUDUVLUWDTBVVSVWRVWSYJVWFXLU
    WDOUUIRYKUUJUVLUWAUWDVWEVWGUUKUULUUNUVLUWGOUWEVWQVVSUVLXLVCZVWLYLYKUVLUWFCO
    KJOFUVLUWECOVWLUYMUVLWIVCZVWTUVLUWECFGUWACUWDKJZFGUVLUWAUWDVXBFUVLUWAUWDFGZ
    UWAYNEZUWDYNEZFGZUVLUVSNEZUXRVRJZUWBNEZVUQVRJZVXDVXEFUVLANEZHMJZUVJVRJZVXKH
    KJZUVJVRJZVXHVXJFUVLVXLVXNFGZVXMVXOFGZUVLVXLVXKVXNUVLVXKTBZVXLTBZUVLAUXCYHZ
    VXKUUOWGZVXTUVLVXRVXNTBZVXTVXKUUMWGZUVLVXKVXTUUPUVLVXKVXTUVCUVDUVLVXSVYBUYF
    UVKVXPVXQYJVYAVYCUYCUYLVXLVXNUVJUUQUURYKUVLVXGVXLUXRUVJVRUVLVXGVXKINEZMJZVX
    LUVLUWSUWRVXGVYEQUXCSAIXRRVYDHVXKMYMVFWEUYEYGUVLVXIVXNVUQUVJVRUVLVXIVXKVYDK
    JZVXNUVLUWSUWRVXIVYFQUXCSAIWTRVYDHVXKKYMVFWEVUSYGYOUVLUXPUXTVXDVXHQUXSUYHUV
    SYPXHUVLVUOVVFVXEVXJQVUPVVGUWBYPXHYOUVLUWAUWMUWKUFJZBZUWDVYGBZVXCVXFYJUVLUX
    PCUXRFGVYHUXSUVLCUVJUXRFUYLUYEWMUVSYQXHUVLVUOCVUQFGVYIVUPUVLCUVJVUQFUYLVUSW
    MUWBYQXHUWAUWDUUSXHYRUVLUWDVWGUUTWMUVLUWAUWDCVWDVWFVXAYLYRUVAOVVKUVEUVBUWGY
    SBOYSBVWKVWHVWIVWJUJYJUWGVWOYTOXLYTUWGOUWFUVFXSUVGUVH $.

  $( A variation on ~ atanlogadd , to show that
     ` sqr ( 1 + _i z ) / sqr ( 1 - _i z ) = `
     ` sqr ( ( 1 + _i z ) / ( 1 - _i z ) ) ` under more limited conditions.
     (Contributed by Mario Carneiro, 4-Apr-2015.) $)
  atanlogsub $p |- ( ( A e. dom arctan /\ ( Re ` A ) =/= 0 ) ->
    ( ( log ` ( 1 + ( _i x. A ) ) ) -
      ( log ` ( 1 - ( _i x. A ) ) ) ) e. ran log ) $=
    ( wcel cfv cc0 c1 ci co caddc clog cmin cpi cneg cim clt wbr ax-1cn sylancr
    cc adantr cr catan cdm cre wne wa cmul cle crn ax-icn atandm2 simp1bi mulcl
    addcl simp3bi logcld subcl simp2bi subcld wo wb recld lttri2 sylancl biimpa
    cioo 0re wceq imnegd negsubdi2d mulneg2 oveq2d negsub fveq2d subneg oveq12d
    eqtr4d eqtr3d atandmneg lt0neg1d renegd breqtrrd atanlogsublem syl2anc pire
    eqtrd recni negnegi oveq2i syl6eleqr eqeltrd renegcli iooneg syl3anc mpbird
    a1i imcld jaodan syldan eliooord syl simpld simprd wi mpd ellogrn syl3anbrc
    ltle ) AUAUBZBZAUCCZDUDZUEZEFAUFGZHGZICZEXMJGZICZJGZRBZKLZXRMCZNOZYAKUGOZXR
    IUHBXIXSXKXIXOXQXIXNXIERBZXMRBZXNRBPXIFRBZARBZYEUIXIYGXPDUDZXNDUDZAUJZUKZFA
    ULQZEXMUMQXIYGYHYIYJUNUOZXIXPXIYDYEXPRBPYLEXMUPQXIYGYHYIYJUQUOZURZSZXLYBYAK
    NOZXLYAXTKVEGZBZYBYQUEXIXKXJDNOZDXJNOZUSZYSXIXKUUBXIXJTBDTBXKUUBUTXIAYKVAZV
    FXJDVBVCVDXIYTYSUUAXIYTUEZYSYALZXTXTLZVEGZBZUUDUUEEFALZUFGZHGZICZEUUJJGZICZ
    JGZMCZUUGXIUUEUUPVGYTXIXRLZMCUUEUUPXIXRYOVHXIUUQUUOMXIUUQXQXOJGUUOXIXOXQYMY
    NVIXIUULXQUUNXOJXIUUKXPIXIUUKEXMLZHGZXPXIUUJUUREHXIYFYGUUJUURVGUIYKFAVJQZVK
    XIYDYEUUSXPVGPYLEXMVLQWEVMXIUUMXNIXIUUMEUURJGZXNXIUUJUUREJUUTVKXIYDYEUVAXNV
    GPYLEXMVNQWEVMVOVPVMVQSUUDUUPYRUUGUUDUUIXHBZDUUIUCCZNOUUPYRBXIUVBYTAVRSUUDD
    XJLZUVCNXIYTDUVDNOXIXJUUCVSVDUUDAXIYGYTYKSVTWAUUIWBWCUUFKXTVEKKWDWFWGWHWIWJ
    UUDXTTBZKTBZYATBZYSUUHUTUVEUUDKWDWKWOUVFUUDWDWOUUDXRXIXSYTYOSWPXTKYAWLWMWNA
    WBWQWRYAXTKWSWTZXAXLYQYCXLYBYQUVHXBXLUVGUVFYQYCXCXLXRYPWPWDYAKXGVCXDXRXEXF
    $.

  $( Value of the exponential of an artcangent.  (Contributed by Mario
     Carneiro, 3-Apr-2015.) $)
  efiatan2 $p |- ( A e. dom arctan ->
    ( exp ` ( _i x. ( arctan ` A ) ) ) =
    ( ( 1 + ( _i x. A ) ) / ( sqr ` ( 1 + ( A ^ 2 ) ) ) ) ) $=
    ( wcel ci cfv cmul co ce c1 caddc cdiv ax-icn sylancr cmin cc0 wne wceq 2cn
    c2 cc a1i catan cdm cexp csqr atancl mulcl syl ax-1cn atandm2 simp1bi sqcld
    efcl addcl sqrcld atandm4 simprbi eqnetrd wb sqne0 mpbid divcan4d clog 2ne0
    sqsqrd reccli logcld efadd syl2anc simp3bi subdid atanval oveq2d cneg ax-mp
    mulassd halfcl mulassi mul12i divcan2i oveq2i ixi eqtri 3eqtri oveq1i subcl
    simp2bi subcld mulm1d syl5eq mulcli negsubdi2d 3eqtr3d subsubd oveq1d eqtrd
    2timesd pncand crn atanlogadd logef eflog oveq12d sq1 sqmul i2 subsq subneg
    3eqtrd fveq2d eqtr3d divcan3d divrec2d subaddd ccxp cxpefd cxpsqr ) AUAUBBZ
    CAUADZEFZGDZHARUCFZIFZUDDZEFZYCJFXTHCAEFZIFZYCJFXQXTYCXQXSSBZXTSBXQCSBZXRSB
    YGKAUEZCXRUFLZXSULUGXQYBXQHSBZYASBZYBSBZUHXQAXQASBZHYEMFZNOZYFNOZAUIZUJZUKZ
    HYAUMLZUNZXQYCRUCFZNOZYCNOZXQUUCYBNXQYBUUAVDXQYNYBNOAUOUPZUQXQYCSBUUDUUEURU
    UBYCUSUGUTVAXQYDYFYCJXQXTHRJFZYBVBDZEFZGDZEFZYFVBDZGDZYDYFXQXSUUIIFZGDZUUKU
    UMXQYGUUISBZUUOUUKPYJXQUUGSBZUUHSBUUPRQVCVEZXQYBUUAUUFVFZUUGUUHUFLZXSUUIVGV
    HXQUUNUULGXQUULXSMFZUUIPUUNUULPXQRUVAEFZRJFUUHRJFUVAUUIXQUVBUUHRJXQUVBRUULE
    FZRXSEFZMFUVCUULYOVBDZMFZMFZUUHXQRUULXSRSBZXQQTZXQYFXQYKYESBZYFSBZUHXQYHYNU
    VJKYSCAUFLZHYEUMLZXQYNYPYQYRVIZVFZYJVJXQUVDUVFUVCMXQRCEFZXREFUVPCRJFZUVEUUL
    MFZEFZEFZUVDUVFXQXRUVSUVPEAVKVLXQRCXRUVIYHXQKTYIVOXQUVPUVQEFZUVREFZUVRVMZUV
    TUVFXQUWBHVMZUVREFUWCUWAUWDUVREUWARCUVQEFEFCRUVQEFZEFZUWDRCUVQQKYHUVQSBZKCV
    PVNZVQRCUVQQKUWHVRUWFCCEFUWDUWECCECRKQVCVSVTWAWBWCWDXQUVRXQUVEUULXQYOXQYKUV
    JYOSBZUHUVLHYEWELZXQYNYPYQYRWFZVFZUVOWGZWHWIXQUVPUVQUVRUVPSBXQRCQKWJTUWGXQU
    WHTUWMVOXQUVEUULUWLUVOWKWLWLVLXQUVGUVCUULMFZUVEIFUULUVEIFZUUHXQUVCUULUVEXQU
    VHUULSBZUVCSBQUVORUULUFLUVOUWLWMXQUWNUULUVEIXQUWNUULUULIFZUULMFUULXQUVCUWQU
    ULMXQUULUVOWPWNXQUULUULUVOUVOWQWOWNXQUWOGDZVBDZUWOUUHXQUWOVBWRBUWSUWOPAWSUW
    OWTUGXQUWRYBVBXQUWRUUMUVEGDZEFZYFYOEFZYBXQUWPUVESBUWRUXAPUVOUWLUULUVEVGVHXQ
    UUMYFUWTYOEXQUVKYQUUMYFPUVMUVNYFXAVHZXQUWIYPUWTYOPUWJUWKYOXAVHXBXQHRUCFZYER
    UCFZMFZHYAVMZMFZUXBYBXQUXDHUXEUXGMUXDHPXQXCTXQUXECRUCFZYAEFZUXGXQYHYNUXEUXJ
    PKYSCAXDLXQUXJUWDYAEFUXGUXIUWDYAEXEWDXQYAYTWHWIWOXBXQYKUVJUXFUXBPUHUVLHYEXF
    LXQYKYLUXHYBPUHYTHYAXGLWLXHXIXJXHXHWNXQUVARXQUULXSUVOYJWGUVIRNOXQVCTZXKXQUU
    HRUUSUVIUXKXLWLXQUULXSUUIUVOYJUUTXMUTXIXJXQUUJYCXTEXQYBUUGXNFZUUJYCXQYBUUGU
    UAUUFUUQXQUURTXOXQYMUXLYCPUUAYBXPUGXJVLUXCWLWNXJ $.

  $( Value of the exponential of an artcangent.  (Contributed by Mario
     Carneiro, 2-Apr-2015.) $)
  2efiatan $p |- ( A e. dom arctan ->
    ( exp ` ( 2 x. ( _i x. ( arctan ` A ) ) ) ) =
    ( ( ( 2 x. _i ) / ( A + _i ) ) - 1 ) ) $=
    ( wcel c2 ci cfv cmul co ce c1 caddc cmin cc 2cn a1i ax-icn cc0 wne sylancr
    cdiv wceq catan cdm clog atanval oveq2d atancl mulassd halfcl ax-mp mulassi
    cneg mul12i 2ne0 divcan2i oveq2i eqtri 3eqtri oveq1i ax-1cn atandm2 simp1bi
    ixi mulcl subcl simp2bi logcld addcl subcld mulm1d syl5eq mulcli negsubdi2d
    simp3bi 3eqtr3d fveq2d efsub syl2anc eflog oveq12d mulid1d 3eqtr3a pnpcan2d
    negsub 3eqtr4d adddid 2timesd oveq1d subdid subneg eqtrd addcom 3eqtrd ine0
    divcan5d sylancl atandm wb negcli subeq0 necon3bid mpbird divsubdird dividd
    wa eqnetrrd ) AUAUBBZCDAUAEZFGFGZHEIDAFGZJGZUCEZIXIKGZUCEZKGZHEZXKHEZXMHEZS
    GZCDFGZADJGZSGZIKGZXFXHXNHXFXSXGFGXSDCSGZXMXKKGZFGZFGZXHXNXFXGYEXSFAUDUEXFC
    DXGCLBXFMNDLBZXFONZAUFUGXFXSYCFGZYDFGZYDUKZYFXNXFYJIUKZYDFGYKYIYLYDFYICDYCF
    GFGDCYCFGZFGZYLCDYCMOYGYCLBZODUHUIZUJCDYCMOYPULYNDDFGZYLYMDDFDCOMUMUNUOVBUP
    UQURXFYDXFXMXKXFXLXFILBZXILBZXLLBZUSXFYGALBZYSOXFUUAXLPQZXJPQZAUTZVAZDAVCRZ
    IXIVDRZXFUUAUUBUUCUUDVEZVFZXFXJXFYRYSXJLBZUSUUFIXIVGRZXFUUAUUBUUCUUDVMZVFZV
    HZVIVJXFXSYCYDXSLBXFCDMOVKNZYOXFYPNUUNUGXFXMXKUUIUUMVLVNVNVOXFXKLBXMLBXOXRT
    UUMUUIXKXMVPVQXFXRXJXLSGZYAXTXTSGZKGZYBXFXPXJXQXLSXFUUJUUCXPXJTUUKUULXJVRVQ
    XFYTUUBXQXLTUUGUUHXLVRVQVSXFDXJFGZDXLFGZSGXSXTKGZXTSGUUPUURXFUUSUVAUUTXTSXF
    DIFGZDXIFGZJGZDDJGZXTKGZUUSUVAXFDAUKZJGZDAKGZUVDUVFXFYGUUAUVHUVITOUUEDAWCRX
    FUVBDUVCUVGJXFDYHVTZXFYQAFGYLAFGUVCUVGYQYLAFVBURXFDDAYHYHUUEUGXFAUUEVIWAZVS
    XFDADYHUUEYHWBWDXFDIXIYHYRXFUSNZUUFWEXFXSUVEXTKXFDYHWFWGWDXFUUTUVBUVCKGZDAJ
    GZXTXFDIXIYHUVLUUFWHXFUVMDUVGKGZUVNXFUVBDUVCUVGKUVJUVKVSXFYGUUAUVOUVNTOUUED
    AWIRWJXFYGUUAUVNXTTOUUEDAWKRWLVSXFXJXLDUUKUUGYHUUHDPQXFWMNWNXFXSXTXTUUOXFUU
    AYGXTLBUUEOADVGWOZUVPXFADUKZKGZXTPXFUUAYGUVRXTTUUEOADWIWOXFUVRPQZAUVQQZXFUU
    AUVTADQAWPVEXFUUAUVQLBZUVSUVTWQUUEDOWRUUAUWAXDUVRPAUVQAUVQWSWTWOXAXEZXBVNXF
    UUQIYAKXFXTUVPUWBXCUEWLWL $.

  $( The arctangent function is an inverse to ` tan ` .  (Contributed by Mario
     Carneiro, 2-Apr-2015.) $)
  tanatan $p |- ( A e. dom arctan -> ( tan ` ( arctan ` A ) ) = A ) $=
    ( wcel c2 ci cmul co c1 cmin caddc cdiv cc cc0 wne wceq oveq1d ax-icn eqtrd
    2cn a1i sylancr catan cdm cfv ctan ce atancl 2efiatan mulcli atandm simp1bi
    addcl sylancl subneg simp2bi negcli subeq0 necon3bid mpbird eqnetrrd divcld
    cneg wb wa npcan 2ne0 ine0 mulne0i divne0d eqnetrd tanval3 syl2anc subsub4d
    ax-1cn df-2 oveq2i syl6eqr mulcl divsubdird mulneg12 negsub negcld 3eqtr3rd
    pncan2 oveq2d subdid 3eqtr2rd divcan4d eqtr4d mul12i mulm1i mulcomli 3eqtri
    3eqtr3d ixi oveq1i divassd syl5eqr oveq12d negne0i divcan7d divcan3d ) AUAU
    BBZAUAUCZUDUCZCDXCEFEFUEUCZGHFZDXEGIFZEFZJFZAXBXCKBXGLMXDXINAUFXBXGCDEFZADI
    FZJFZLXBXGXLGHFZGIFZXLXBXEXMGIAUGZOXBXLKBGKBZXNXLNXBXJXKXJKBXBCDRPUHSZXBAKB
    ZDKBZXKKBZXBXRADVAZMZADMZAUIZUJZPADUKULZXBAYAHFZXKLXBXRXSYGXKNYEPADUMULXBYG
    LMZYBXBXRYBYCYDUNXBXRYAKBZYHYBVBYEDPUOXRYIVCYGLAYAAYAUPUQULURUSZUTZVMXLGVDU
    LQZXBXJXKXQYFXJLMXBCDRPVEVFVGSYJVHVIXCVJVKXBXICVAZAEFZXKJFZYMXKJFZJFZAXBXFY
    OXHYPJXBXFXLCHFZYOXBXFXMGHFZYRXBXEXMGHXOOXBYSXLGGIFZHFYRXBXLGGYKXPXBVMSZUUA
    VLCYTXLHVNVOVPQXBXJCXKEFZHFZXKJFXLUUBXKJFZHFYOYRXBXJUUBXKXQXBCKBZXTUUBKBRYF
    CXKVQTYFYJVRXBUUCYNXKJXBYNCAVAZEFZCDXKHFZEFUUCXBUUEXRYNUUGNRYECAVSTXBUUHUUF
    CEXBDUUFIFZDHFZDAHFZDHFUUFUUHXBUUIUUKDHXBXSXRUUIUUKNPYEDAVTTOXBXSUUFKBUUJUU
    FNPXBAYEWADUUFWCTXBDADXSXBPSZYEUULVLWBWDXBCDXKUUEXBRSZUULYFWEWFOXBUUDCXLHXB
    CXKUUMYFYJWGWDWMWHXBXHDXLEFZYPXBXGXLDEYLWDXBYPDXJEFZXKJFUUNUUOYMXKJUUOCDDEF
    ZEFCGVAZEFYMDCDPRPWIUUPUUQCEWNVOUUQCYMGVMUORCRWJWKWLWOXBDXJXKUULXQYFYJWPWQW
    HWRXBYQYNYMJFAXBYNYMXKXBYMKBZXRYNKBCRUOZYEYMAVQTUURXBUUSSZYFYMLMXBCRVEWSSZY
    JWTXBAYMYEUUTUVAXAQQQ $.

  $( The tangent function has range contained in the domain of the arctangent.
     (Contributed by Mario Carneiro, 31-Mar-2015.) $)
  atandmtan $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
    ( tan ` A ) e. dom arctan ) $=
    ( cc wcel ccos cfv cc0 wne wa ctan c2 cexp co c1 cneg cdiv adantr eqtrd a1i
    sqcld eqnetrd catan cdm tancl tanval oveq1d sincl coscl simpr sqdivd negcld
    csin cmul cmin caddc subnegd wceq sincossq ax-1ne0 subne0ad mulm1d neeqtrrd
    neg1cn wb sqne0 syl biimpar divmul3d necon3bid mpbird atandm3 sylanbrc ) AB
    CZADEZFGZHZAIEZBCVPJKLZMNZGVPUAUBCAUCVOVQAUKEZJKLZVMJKLZOLZVRVOVQVSVMOLZJKL
    WBVOVPWCJKAUDUEVOVSVMVLVSBCVNAUFPZVLVMBCZVNAUGZPZVLVNUHUIQVOWBVRGVTVRWAULLZ
    GVOVTWANZWHVOVTWIVOVSWDSZVOWAVOVMWGSZUJVOVTWIUMLZMFVOWLVTWAUNLZMVOVTWAWJWKU
    OVLWMMUPVNAUQPQMFGVOURRTUSVOWAWKUTVAVOWBVRVTWHVOVTVRWAWJVRBCVOVBRWKVLWAFGZV
    NVLWEWNVNVCWFVMVDVEVFVGVHVITVPVJVK $.

  $( The cosine of an arctangent.  (Contributed by Mario Carneiro,
     3-Apr-2015.) $)
  cosatan $p |- ( A e. dom arctan ->
    ( cos ` ( arctan ` A ) ) = ( 1 / ( sqr ` ( 1 + ( A ^ 2 ) ) ) ) ) $=
    ( catan wcel cfv ci cmul co ce cneg caddc c2 cdiv c1 cc syl sylancr cc0 wne
    wceq ax-1cn cdm ccos cexp csqr atancl cosval cmin efiatan2 mulneg12 atanneg
    ax-icn oveq2d eqtr4d fveq2d atandmneg atandm4 simplbi mulneg2 mulcl oveq12d
    negsub eqtrd sqneg 3eqtrd addcl subcl sqcld sqrcld simprbi eqnetrd wb sqne0
    sqsqrd mpbid divdird a1i ppncand df-2 syl6eqr oveq1d 3eqtr2d 2ne0 divdiv32d
    2cn dividi oveq1i syl6eq ) ABUAZCZABDZUBDZEWJFGHDZEIWJFGZHDZJGZKLGZKMAKUCGZ
    JGZUDDZLGZKLGZMWSLGZWIWJNCZWKWPSAUEZWJUFOWIWOWTKLWIWOMEAFGZJGZWSLGZMXEUGGZW
    SLGZJGXFXHJGZWSLGWTWIWLXGWNXIJAUHWIWNEAIZBDZFGZHDZMEXKFGZJGZMXKKUCGZJGZUDDZ
    LGZXIWIWMXMHWIWMEWJIZFGZXMWIENCZXCWMYBSUKXDEWJUIPWIXLYAEFAUJULUMUNWIXKWHCXN
    XTSAUOXKUHOWIXPXHXSWSLWIXPMXEIZJGZXHWIXOYDMJWIYCANCZXOYDSUKWIYFWRQRZAUPZUQZ
    EAURPULWIMNCZXENCZYEXHSTWIYCYFYKUKYIEAUSPZMXEVAPVBWIXRWRUDWIXQWQMJWIYFXQWQS
    YIAVCOULUNUTVDUTWIXFXHWSWIYJYKXFNCTYLMXEVEPWIYJYKXHNCTYLMXEVFPWIWRWIYJWQNCW
    RNCTWIAYIVGMWQVEPZVHZWIWSKUCGZQRZWSQRZWIYOWRQWIWRYMVMWIYFYGYHVIVJWIWSNCYPYQ
    VKYNWSVLOVNZVOWIXJKWSLWIXJMMJGKWIMXEMYJWITVPZYLYSVQVRVSVTWAVTWIXAKKLGZWSLGX
    BWIKWSKKNCWIWDVPZYNUUAYRKQRWIWBVPWCYTMWSLKWDWBWEWFWGVD $.

  $( The arctangent function has range contained in the domain of the tangent.
     (Contributed by Mario Carneiro, 3-Apr-2015.) $)
  cosatanne0 $p |- ( A e. dom arctan -> ( cos ` ( arctan ` A ) ) =/= 0 ) $=
    ( catan cdm wcel cfv ccos c1 c2 cexp caddc csqr cdiv cc0 cosatan ax-1cn wne
    co cc atandm4 eqnetrd simplbi sqcld addcl sylancr sqrcld sqsqrd simprbi syl
    wb sqne0 mpbid recne0d ) ABCDZABEFEGGAHIQZJQZKEZLQMANUMUPUMUOUMGRDUNRDUORDO
    UMAUMARDZUOMPZASZUAUBGUNUCUDZUEZUMUPHIQZMPZUPMPZUMVBUOMUMUOUTUFUMUQURUSUGTU
    MUPRDVCVDUIVAUPUJUHUKULT $.

  $( The arctangent function is an inverse to ` tan ` .  (Contributed by Mario
     Carneiro, 5-Apr-2015.) $)
  atantan $p |- ( ( A e. CC /\ ( Re ` A ) e.
    ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) -> ( arctan ` ( tan ` A ) ) = A ) $=
    ( cc wcel cfv cpi c2 cdiv co cneg ci c1 cmul cc0 syl sylancr adantr clt wbr
    wceq cr cre cioo wa ctan catan cmin clog caddc ccos cosne0 atandmtan syldan
    cdm wne atanval ax-1cn ax-icn tancl mulcl addcl atandm2 sylib simp3d logcld
    w3a subcl simp2d negsubdi2d ce efsub syl2anc coscl sincl divdird dividd a1i
    csin divassd tanval oveq2d eqtr4d oveq12d eqtrd efival oveq1d eflog 3eqtr4d
    divsubdird negcl cosneg sinneg mulneg2 fveq2d negsubd 3eqtr3d efcl divcan7d
    simpl negcld efne0 subnegd 3eqtr2d 0re renegd recld simpr lt0neg1d eliooord
    sylancl mpbid simpld halfpire cxr 0xr elioo2 mp2an syl3anbrc eqeltrd mpbird
    tanregt0 1re ixi oveq1i mulm1d syl5eq mulassd eqtr3d cim syl5eqbrr relogcld
    wb simprd logef cle 2cn pire 2ne0 2re syl112anc 3eqtr3rd 2timesd crn lttri4
    w3o recl renegcld adantl ltnegcon1 rexri breqtrd lt0ne0d atanlogsub ioossre
    tanneg ine0 divcan3d eqeq1d biimpa reim0bd tanhbnd sseldi df-neg ltsubadd2d
    readdcl elrpd crp difrp resubcld relogrn gt0ne0d 3jaodan mpdan recni divneg
    reim mp3an renegcli 2pos ltdivmul immul2 breqtrrd remulcl ltmuldiv2 eqbrtrd
    ltled ellogrn negeqd halfcl mp1i divcan1i mul2neg mulid2 3eqtrd ) ABCZAUADZ
    EFGHZIZUWPUBHCZUCZAUDDZUEDZJFGHZKJUWTLHZUFHZUGDZKUXCUHHZUGDZUFHZLHZUXBFJALH
    ZLHZIZLHZAUWSUWTUEUMCZUXAUXISUWNUWRAUIDZMUNZUXNAUJZAUKULZUWTUONUWSUXHUXLUXB
    LUWSUXGUXEUFHZIUXHUXLUWSUXGUXEUWSUXFUWSKBCZUXCBCZUXFBCZUPUWSJBCZUWTBCZUYAUQ
    UWNUWRUXPUYDUXQAURULZJUWTUSOZKUXCUTOZUWSUYDUXDMUNZUXFMUNZUWSUXNUYDUYHUYIVEU
    XRUWTVAVBZVCZVDZUWSUXDUWSUXTUYAUXDBCZUPUYFKUXCVFOZUWSUYDUYHUYIUYJVGZVDZVHUW
    SUXSUXKUWSUXSVIDZUGDZUXKVIDZUGDZUXSUXKUWSUYQUYSUGUWSUYQUXGVIDZUXEVIDZGHZUXJ
    VIDZUXOGHZUXJIZVIDZUXOGHZGHZUYSUWSUXGBCUXEBCUYQVUCSUYLUYPUXGUXEVJVKUWSVUEVU
    AVUHVUBGUWSUXOJAVQDZLHZUHHZUXOGHZUXFVUEVUAUWSVUMUXOUXOGHZVUKUXOGHZUHHUXFUWS
    UXOVUKUXOUWNUXOBCUWRAVLPZUWSUYCVUJBCZVUKBCUQUWNVUQUWRAVMPZJVUJUSOZVUPUXQVNU
    WSVUNKVUOUXCUHUWSUXOVUPUXQVOZUWSVUOJVUJUXOGHZLHUXCUWSJVUJUXOUYCUWSUQVPZVURV
    UPUXQVRUWSUWTVVAJLUWNUWRUXPUWTVVASUXQAVSULVTWAZWBWCUWSVUDVULUXOGUWNVUDVULSU
    WRAWDPWEUWSUYBUYIVUAUXFSUYGUYKUXFWFVKWGUWSUXOVUKUFHZUXOGHZUXDVUHVUBUWSVVEVU
    NVUOUFHUXDUWSUXOVUKUXOVUPVUSVUPUXQWHUWSVUNKVUOUXCUFVUTVVCWBWCUWSVUGVVDUXOGU
    WSJAIZLHZVIDZUXOVUKIZUHHZVUGVVDUWSVVHVVFUIDZJVVFVQDZLHZUHHZVVJUWSVVFBCZVVHV
    VNSUWNVVOUWRAWIPZVVFWDNUWSVVKUXOVVMVVIUHUWNVVKUXOSUWRAWJPUWSVVMJVUJIZLHZVVI
    UWSVVLVVQJLUWNVVLVVQSUWRAWKPVTUWSUYCVUQVVRVVISUQVURJVUJWLOWCWBWCUWSVVGVUFVI
    UWSUYCUWNVVGVUFSUQUWNUWRWRZJAWLOZWMUWSUXOVUKVUPVUSWNWOWEUWSUYMUYHVUBUXDSUYN
    UYOUXDWFVKWGWBUWSVUIVUDVUGGHZUXJVUFUFHZVIDZUYSUWSVUDVUGUXOUWSUXJBCZVUDBCUWS
    UYCUWNVWDUQVVSJAUSOZUXJWPNUWSVUFBCZVUGBCUWSUXJVWEWSZVUFWPNVUPUWSVWFVUGMUNVW
    GVUFWTNUXQWQUWSVWDVWFVWCVWASVWEVWGUXJVUFVJVKUWSVWBUXKVIUWSVWBUXJUXJUHHUXKUW
    SUXJUXJVWEVWEXAUWSUXJVWEUUAWAWMXBXBWMUWSUXSUGUUBZCZUYRUXSSUWSUWOMQRZUWOMSZM
    UWOQRZUUDZVWIUWSUWOTCZMTCZVWMUWNVWNUWRAUUEPZXCUWOMUUCXIUWSVWJVWIVWKVWLUWSVW
    JUCZUXNUWTUADZMUNZVWIUWSUXNVWJUXRPVWQVWRVWQVWRMQRMVWRIZQRVWQMVVFUDDZUADZVWT
    QVWQVVOVVFUADZMUWPUBHZCMVXBQRUWSVVOVWJVVPPVWQVXCUWOIZVXDVWQAUWSUWNVWJVVSPZX
    DVWQVXETCZMVXEQRZVXEUWPQRZVXEVXDCZVWQUWOVWQAVXFXEZUUFVWQVWJVXHUWSVWJXFVWQUW
    OVXKXGXJVWQUWQUWOQRZVXIUWSVXLVWJUWSVXLUWOUWPQRZUWRVXLVXMUCUWNUWOUWQUWPXHUUG
    ZXKZPVWQUWPTCVWNVXLVXIYKXLVXKUWPUWOUUHOXJMXMCZUWPXMCZVXJVXGVXHVXIVEYKXNUWPX
    LUUIZMUWPVXEXOXPXQXRVVFXTVKVWQVXBUWTIZUADVWTVWQVXAVXSUAUWSVXAVXSSZVWJUWNUWR
    UXPVXTUXQAUUNULZPWMVWQUWTUWSUYDVWJUYEPXDWCUUJVWQVWRUWSVWRTCVWJUWSUWTUYEXEPX
    GXSUUKUWTUULZVKUWSVWKUCZUXSTCVWIVYCUXGUXEVYCUXFVYCUXFVYCKTCZUXCTCZUXFTCYAVY
    CKIZKUBHZTUXCVYFKUUMVYCUXCJUXJLHZUDDZJGHZVYGVYCJUXCLHZJGHUXCVYJVYCUXCJUWSUY
    AVWKUYFPUYCVYCUQVPZJMUNVYCUUOVPUUPVYCVYKVYIJGVYCJJLHZUWTLHZVXAVYKVYIVYCVYNV
    YFUWTLHZVXAVYMVYFUWTLYBYCVYCVYOVXSVXAVYCUWTUWSUYDVWKUYEPZYDUWSVXTVWKVYAPWAY
    EVYCJJUWTVYLVYLVYPYFVYCVVFVYHUDVYCVYMALHZVVFVYHVYCVYQVYFALHVVFVYMVYFALYBYCV
    YCAUWSUWNVWKVVSPZYDYEVYCJJAVYLVYLVYRYFYGWMWOWEYGVYCUXJTCVYJVYGCVYCUXJUWSVWD
    VWKVWEPUWSVWKUXJYHDZMSUWSUWOVYSMUWNUWOVYSSUWRAUVOPZUUQUURUUSUXJUUTNXRZUVAZK
    UXCUVDOVYCMKUFHZUXCQRMUXFQRVYCWUCVYFUXCQKUVBVYCVYFUXCQRZUXCKQRZVYCUXCVYGCWU
    DWUEUCWUAUXCVYFKXHNZXKYIVYCMKUXCVWOVYCXCVPVYDVYCYAVPWUBUVCXJUVEYJVYCUXDVYCW
    UEUXDUVFCZVYCWUDWUEWUFYLVYCVYEVYDWUEWUGYKWUBYAUXCKUVGXIXJYJUVHUXSUVINUWSVWL
    UCZUXNVWSVWIUWSUXNVWLUXRPWUHVWRWUHUWNUWOVXDCZMVWRQRUWSUWNVWLVVSPZWUHVWNVWLV
    XMWUIWUHAWUJXEUWSVWLXFUWSVXMVWLUWSVXLVXMVXNYLZPVXPVXQWUIVWNVWLVXMVEYKXNVXRM
    UWPUWOXOXPXQAXTVKUVJVYBVKUVKUVLUXSYMNUWSUXKVWHCZUYTUXKSUWSUXKBCZEIZUXKYHDZQ
    RWUOEYNRWULUWSFBCZVWDWUMYOVWEFUXJUSOUWSWUNFUWOLHZWUOQUWSWUNFGHZUWOQRZWUNWUQ
    QRZUWSWURUWQUWOQEBCWUPFMUNUWQWURSEYPUVMYOYQEFUVNUVPVXOYIUWSWUNTCZVWNFTCZMFQ
    RZWUSWUTYKWVAUWSEYPUVQVPVWPWVBUWSYRVPZWVCUWSUVRVPZWUNUWOFUVSYSXJUWSWUOFVYSL
    HZWUQUWSWVBVWDWUOWVFSYRVWEFUXJUVTOUWSUWOVYSFLVYTVTWAZUWAUWSWUOWUQEYNWVGUWSW
    UQEUWSWVBVWNWUQTCYRVWPFUWOUWBOETCZUWSYPVPZUWSWUQEQRZVXMWUKUWSVWNWVHWVBWVCWV
    JVXMYKVWPWVIWVDWVEUWOEFUWCYSXSUWEUWDUXKUWFXQUXKYMNWOUWGYGVTUWSUXBFLHZVUFLHZ
    UXBFVUFLHZLHAUXMUWSUXBFVUFUYCUXBBCUWSUQJUWHUWIWUPUWSYOVPVWGYFUWSWVLJVUFLHZA
    WVKJVUFLJFUQYOYQUWJYCUWSVYMVVFLHZJVVGLHAWVNUWSJJVVFVVBVVBVVPYFUWSWVOVYFVVFL
    HZAVYMVYFVVFLYBYCUWSWVPKALHZAUWSUXTUWNWVPWVQSUPVVSKAUWKOUWNWVQASUWRAUWLPWCY
    EUWSVVGVUFJLVVTVTYTYEUWSWVMUXLUXBLUWSWUPVWDWVMUXLSYOVWEFUXJWLOVTYTUWM $.

  $( Relationship between tangent and arctangent.  (Contributed by Mario
     Carneiro, 5-Apr-2015.) $)
  atantanb $p |- ( ( A e. dom arctan /\ B e. CC /\
      ( Re ` B ) e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) ->
    ( ( arctan ` A ) = B <-> ( tan ` B ) = A ) ) $=
    ( catan cdm wcel cc cre cfv cpi c2 cdiv co cneg cioo wceq ctan fveq2 eqeq1d
    w3a syl5ibcom tanatan 3ad2ant1 atantan 3adant1 impbid ) ACDEZBFEZBGHIJKLZMU
    HNLEZSZACHZBOZBPHZAOZUJUKPHZAOZULUNUFUGUPUIAUAUBULUOUMAUKBPQRTUJUMCHZBOZUNU
    LUGUIURUFBUCUDUNUQUKBUMACQRTUE $.

  $( Lemma for ~ atanbnd .  (Contributed by Mario Carneiro, 5-Apr-2015.) $)
  atanbndlem $p |- ( A e. RR+ ->
    ( arctan ` A ) e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) $=
    ( wcel cfv cr cpi c2 co cneg clt wbr syl cc cc0 wceq cmul c1 ci cre sylancr
    ax-icn crp catan cdiv cioo rpre atanrecl wne pire recni 2cn divneg mp3an wa
    2ne0 caddc clog cmin cim ax-1cn recnd mulcl addcl cdm atanre atandm2 simp3d
    w3a sylib logcld subcl simp2d subcld atanval oveq2d divcan2i oveq1i 2re a1i
    imre halfcl mulassd syl5eqr eqtr4d negsubdi2d mulneg12 fveq2d remulcl rered
    mp1i 3eqtr2rd rpgt0 breqtrrd atanlogsublem syl2anc eliooord simpld renegcli
    eqeltrd wb 2pos ltdivmul syl112anc mpbird syl5eqbr ltmuldiv2 mpbid halfpire
    simprd cxr rexri elioo2 mp2an syl3anbrc ) AUABZAUBCZDBZEFUCGZHZXOIJZXOXQIJZ
    XOXRXQUDGBZXNADBZXPAUEZAUFKZXNXREHZFUCGZXOIELBFLBFMUGXRYFNEUHUIUJUNEFUKULXN
    YFXOIJZYEFXOOGZIJZXNYIYHEIJZXNYHYEEUDGZBYIYJUMXNYHPQAOGZUOGZUPCZPYLUQGZUPCZ
    UQGZURCZYKXNYRQHYQOGZRCZYHRCYHXNYQLBZYRYTNXNYNYPXNYMXNPLBZYLLBZYMLBUSXNQLBZ
    ALBZUUCTXNAYCUTQAVASZPYLVBSXNUUEYOMUGZYMMUGZXNAUBVCBZUUEUUGUUHVGXNYBUUIYCAV
    DKZAVEVHZVFVIZXNYOXNUUBUUCYOLBUSUUFPYLVJSXNUUEUUGUUHUUKVKVIZVLZYQVSKXNYHYSR
    XNYHQYQHZOGZYSXNYHQYPYNUQGZOGZUUPXNYHFQFUCGZUUQOGZOGZUURXNXOUUTFOXNUUIXOUUT
    NUUJAVMKVNXNUURFUUSOGZUUQOGUVAUVBQUUQOQFTUJUNVOVPXNFUUSUUQXNFFDBZXNVQVRZUTU
    UDUUSLBXNTQVTWIXNYPYNUUMUULVLWAWBWCXNUUOUUQQOXNYNYPUULUUMWDVNWCXNUUDUUAYSUU
    PNTUUNQYQWESWCWFXNYHXNUVCXPYHDBVQYDFXOWGSWHWJXNUUIMARCZIJYRYKBUUJXNMAUVEIAW
    KXNAYCWHWLAWMWNWRYHYEEWOKZWPXNYEDBZXPUVCMFIJZYGYIWSUVGXNEUHWQVRYDUVDUVHXNWT
    VRZYEXOFXAXBXCXDXNYJXTXNYIYJUVFXHXNXPEDBZUVCUVHYJXTWSYDUVJXNUHVRUVDUVIXOEFX
    EXBXFXRXIBXQXIBYAXPXSXTVGWSXRXQXGWQXJXQXGXJXRXQXOXKXLXM $.

  $( The arctangent function is bounded by ` pi / 2 ` on the reals.
     (Contributed by Mario Carneiro, 5-Apr-2015.) $)
  atanbnd $p |- ( A e. RR ->
    ( arctan ` A ) e. ( -u ( pi / 2 ) (,) ( pi / 2 ) ) ) $=
    ( cr wcel cc0 clt wbr wceq catan cfv cpi co cneg cioo 0re wa adantr syl crp
    halfpire wb w3o cdiv lttri4 mpan2 cdm atanre atanneg renegcl lt0neg1 biimpa
    c2 elrpd atanbndlem eqeltrrd negnegi oveq2i syl6eleqr renegcli a1i atanrecl
    recni iooneg syl3anc mpbird simpr fveq2d atan0 syl6eq pipos elrpii rphalfcl
    pire rpgt0 mp2b lt0neg2 ax-mp mpbi cxr rexri elioo2 mp2an mpbir3an syl6eqel
    w3a elrp sylbir 3jaodan mpdan ) ABCZADEFZADGZDAEFZUAZAHIZJUKUBKZLZWOMKZCZWI
    DBCZWMNADUCUDWIWJWRWKWLWIWJOZWRWNLZWPWPLZMKZCZWTXAWQXCWTALZHIZXAWQWTAHUECZX
    FXAGWIXGWJAUFPAUGQWTXERCXFWQCWTXEWIXEBCWJAUHPWIWJDXEEFAUIUJULXEUMQUNXBWOWPM
    WOWOSVAUOUPUQWTWPBCZWOBCZWNBCZWRXDTXHWTWOSURZUSXIWTSUSWIXJWJAUTPWPWOWNVBVCV
    DWIWKOZWNDWQXLWNDHIDXLADHWIWKVEVFVGVHDWQCZWSWPDEFZDWOEFZNXOXNJRCWORCXOJVLVI
    VJJVKWOVMVNZXIXOXNTSWOVOVPVQXPWPVRCWOVRCXMWSXNXOWDTWPXKVSWOSVSWPWODVTWAWBWC
    WIWLOARCWRAWEAUMWFWGWH $.

  $( The arctangent function is strictly increasing.  (Contributed by Mario
     Carneiro, 5-Apr-2015.) $)
  atanord $p |- ( ( A e. RR /\ B e. RR ) ->
    ( A < B <-> ( arctan ` A ) < ( arctan ` B ) ) ) $=
    ( cr wcel wa catan cfv clt wbr ctan cpi c2 cdiv co cneg atanbnd wceq atanre
    tanatan syl cioo wb tanord syl2an cdm breqan12d bitr2d ) ACDZBCDZEAFGZBFGZH
    IZUJJGZUKJGZHIZABHIUHUJKLMNZOUPUANZDUKUQDULUOUBUIAPBPUJUKUCUDUHUIUMAUNBHUHA
    FUEZDUMAQARASTUIBURDUNBQBRBSTUFUG $.

  $( The arctangent of ` 1 ` is ` pi / 4 ` .  (Contributed by Mario Carneiro,
     2-Apr-2015.) $)
  atan1 $p |- ( arctan ` 1 ) = ( pi / 4 ) $=
    ( cpi c4 cdiv co cfv catan c1 cc wcel c2 wceq cr pire mp2an clt wbr cc0 crp
    ax-mp halfpire ctan tan4thpi fveq2i cre cneg cioo cn 4nn nndivre recni rere
    pipos elrpii rphalfcl rpgt0 wb lt0neg2 mpbi nnrp rpdivcl renegcli 0re lttri
    cmul wne 2cn 2ne0 pm3.2i divdiv1 mp3an 2t2e4 oveq2i eqtri rphalflt eqbrtrri
    wa cxr w3a rexri elioo2 mpbir3an eqeltri atantan eqtr3i ) ABCDZUAEZFEZGFEWE
    WFGFUBUCWEHIWEUDEZAJCDZUEZWIUFDZIWGWEKWEALIBUGIZWELIZMUHABUINZUJWHWEWKWMWHW
    EKWNWEUKSWEWKIZWMWJWEOPZWEWIOPZWNWJQOPZQWEOPZWPQWIOPZWRWIRIZWTARIZXAAMULUMZ
    AUNSZWIUOSWILIWTWRUPTWIUQSURWERIZWSXBBRIZXEXCWLXFUHBUSSABUTNWEUOSWJQWEWITVA
    ZVBWNVCNWIJCDZWEWIOXHAJJVDDZCDZWEAHIJHIZJQVEZVPZXMXHXJKAMUJXKXLVFVGVHZXNAJJ
    VIVJXIBACVKVLVMXAXHWIOPXDWIVNSVOWJVQIWIVQIWOWMWPWQVRUPWJXGVSWITVSWJWIWEVTNW
    AWBWEWCNWD $.

  $( A point in the open unit disk is in the domain of the arctangent.
     (Contributed by Mario Carneiro, 5-Apr-2015.) $)
  bndatandm $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) -> A e. dom arctan ) $=
    ( cc wcel cabs cfv c1 clt wbr wa c2 cexp co cneg wne adantr wceq cr a1i cc0
    cle catan cdm simpl sqcl abscld 2nn0 absexp sylancl simpr abscl absge0 0le1
    cn0 1re lt2sqd mpbid syl6breq eqbrtrd ltned fveq2 ax-1cn absnegi abs1 eqtri
    sq1 syl6eq necon3i syl atandm3 sylanbrc ) ABCZADEZFGHZIZVKAJKLZFMZNZAUAUBCV
    KVMUCZVNVODEZFNVQVNVSFVNVOVKVOBCVMAUDOUEVNVSVLJKLZFGVNVKJUMCVSVTPVRUFAJUGUH
    VNVTFJKLZFGVNVMVTWAGHVKVMUIVNVLFVKVLQCVMAUJOFQCVNUNRVKSVLTHVMAUKOSFTHVNULRU
    OUPVEUQURUSVOVPVSFVOVPPVSVPDEZFVOVPDUTWBFDEFFVAVBVCVDVFVGVHAVIVJ $.

  ${
    $d y A $.  $d x y D $.  $d x S $.
    atansopn.d $e |- D = ( CC \ ( -oo (,] 0 ) ) $.
    atansopn.s $e |- S = { y e. CC | ( 1 + ( y ^ 2 ) ) e. D } $.
    $( The "domain of continuity" of the arctangent.  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    atans $p |- ( A e. S <-> ( A e. CC /\ ( 1 + ( A ^ 2 ) ) e. D ) ) $=
      ( c1 cv c2 cexp co caddc wcel cc wceq oveq1 oveq2d eleq1d elrab2 ) GAHZIJ
      KZLKZCMGBIJKZLKZCMABNDTBOZUBUDCUEUAUCGLTBIJPQRFS $.

    $( It suffices to show that ` 1 - _i A ` and ` 1 + _i A ` are in the
       continuity domain of ` log ` to show that ` A ` is in the continuity
       domain of arctangent.  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    atans2 $p |- ( A e. S <-> ( A e. CC /\ ( 1 - ( _i x. A ) ) e. D /\
      ( 1 + ( _i x. A ) ) e. D ) ) $=
      ( cc wcel c1 c2 co ci cmul cmin cc0 wceq cr wbr cle a1i cexp caddc wa w3a
      cmnf cioc wn csqr cfv cneg sqcl adantr sqsqrd eqcomd sqrcld sqeqor syldan
      wo mpbid clt 1re negnegd fveq2d ax-1cn pncan2 sylancr simpr cxr mnfxr 0re
      elioc2 mp2an sylib simp1d resubcl sylancl eqeltrrd renegcld subneg simp3d
      wb 0le1 eqbrtrd suble0 letrd sqrnegd eqtr3d oveq2d resqrcld recnd mulassd
      ax-icn ixi oveq1i mulm1d syl5eq 3eqtr2d eqeltrd readdcld mnflt syl negsub
      eqtrd sq1 3brtr4d sqrge0d le2sqd mpbird syl3anbrc oveq2 eleq1d syl5ibrcom
      suble0d mulneg2 mulcl orim12d mpd orcomd sqmul mpan oveq12d subsq 3eqtr3d
      i2 2cn subsubd 2m1e1 2re remulcld 2pos lesub2dd syl5eqbrr breqtrd ltletrd
      syl112anc addcl eleq2i eldif bitri baib subid1i subsub4d syl5reqr impbida
      syl6eq lemul2 mul01d lemul1 mul02d jaodan notbid ioran cdif subcl anbi12d
      syl6bb 3bitr4d pm5.32i atans 3anass 3bitr4i ) BGHZIBJUAKZUBKZCHZUCUVBILBM
      KZNKZCHZIUVFUBKZCHZUCZUCBDHUVBUVHUVJUDUVBUVEUVKUVBUVDUEOUFKZHZUGZUVGUVLHZ
      UGZUVIUVLHZUGZUCZUVEUVKUVBUVNUVOUVQURZUGUVSUVBUVMUVTUVBUVMUVTUVBUVMUCZUVQ
      UVOUWABUVCUHUIZPZBUWBUJZPZURZUVQUVOURUWAUVCUWBJUAKZPZUWFUWAUWGUVCUWAUVCUV
      BUVCGHZUVMBUKZULZUMUNUVBUVMUWBGHZUWHUWFWAUWAUVCUWKUOZBUWBUPUQUSUWAUWCUVQU
      WEUVOUWAUVQUWCILUWBMKZUBKZUVLHZUWAUWOQHZUEUWOUTRZUWOOSRZUWPUWAIUWNIQHZUWA
      VATZUWAUWNUVCUJZUHUIZUJZQUWAUWNLLUXCMKZMKLLMKZUXCMKZUXDUWAUWBUXELMUWAUXBU
      JZUHUIUWBUXEUWAUXHUVCUHUWAUVCUWKVBVCUWAUXBUWAUVCUWAUVDINKZUVCQUWAIGHZUWIU
      XIUVCPVDUWKIUVCVEVFUWAUVDQHZUWTUXIQHUWAUXKUEUVDUTRZUVDOSRZUWAUVMUXKUXLUXM
      UDZUVBUVMVGUEVHHZOQHZUVMUXNWAVIVJUEOUVDVKVLVMZVNVAUVDIVOVPVQVRZUWAOIUXBUX
      PUWAVJTUXAUXROISRUWAWBTZUWAIUXBNKZOSRZIUXBSRZUWAUXTUVDOSUWAUXJUWIUXTUVDPZ
      VDUWKIUVCVSZVFUWAUXKUXLUXMUXQVTWCUWAUWTUXBQHUYAUYBWAVAUXRIUXBWDVFUSZWEZWF
      WGWHUWALLUXCLGHZUWAWLTZUYHUWAUXCUWAUXBUXRUYFWIZWJZWKUWAUXGIUJZUXCMKUXDUXF
      UYKUXCMWMWNUWAUXCUYJWOWPWQZUWAUXCUYIVRWRWSZUWAUWQUWRUYMUWOWTXAUWAUWOIUXCN
      KZOSUWAUWOIUXDUBKZUYNUWAUWNUXDIUBUYLWHUWAUXJUXCGHUYOUYNPVDUYJIUXCXBVFXCUW
      AUYNOSRIUXCSRZUWAUYPIJUAKZUXCJUAKZSRUWAIUXBUYQUYRSUYEUYQIPZUWAXDTUWAUXBUW
      AUXBUXRWJUMXEUWAIUXCUXAUYIUXSUWAUXBUXRUYFXFXGXHUWAIUXCUXAUYIXMXHWCUXOUXPU
      WPUWQUWRUWSUDWAVIVJUEOUWOVKVLXIZUWCUVIUWOUVLUWCUVFUWNIUBBUWBLMXJWHXKXLUWA
      UVOUWEILUWDMKZNKZUVLHUWAVUBUWOUVLUWAVUBIUWNUJZNKZUWOUWAVUAVUCINUWAUYGUWLV
      UAVUCPWLUWMLUWBXNVFWHUWAUXJUWNGHZVUDUWOPVDUWAUYGUWLVUEWLUWMLUWBXOVFIUWNVS
      VFXCUYTWRUWEUVGVUBUVLUWEUVFVUAINBUWDLMXJWHXKXLXPXQXRUVBUVTUCUVIUVGMKZUVDU
      VLUVBVUFUVDPUVTUVBUYQUVFJUAKZNKZUXTVUFUVDUVBUYQIVUGUXBNUYSUVBXDTUVBVUGLJU
      AKZUVCMKZUXBUYGUVBVUGVUJPWLLBXSXTUVBVUJUYKUVCMKUXBVUIUYKUVCMYDWNUVBUVCUWJ
      WOWPXCYAUVBUXJUVFGHZVUHVUFPVDUYGUVBVUKWLLBXOXTZIUVFYBVFUVBUXJUWIUYCVDUWJU
      YDVFYCULUVBUVOVUFUVLHZUVQUVBUVOUCZVUFQHZUEVUFUTRZVUFOSRZVUMVUNUVIUVGVUNJU
      VGNKZUVIQUVBVURUVIPUVOUVBVURJINKZUVFUBKUVIUVBJIUVFJGHUVBYETZUXJUVBVDTZVUL
      YFVUSIUVFUBYGWNUUEULZVUNJQHZUVGQHZVURQHYHVUNVVDUEUVGUTRZUVGOSRZVUNUVOVVDV
      VEVVFUDZUVBUVOVGUXOUXPUVOVVGWAVIVJUEOUVGVKVLVMZVNZJUVGVOVFVQZVVIYIZVUNVUO
      VUPVVKVUFWTZXAVUNVUFUVIOMKZOSVUNVVFVUFVVMSRZVUNVVDVVEVVFVVHVTZVUNVVDUXPUV
      IQHZOUVIUTRVVFVVNWAVVIUXPVUNVJTZVVJVUNOJUVIVVQVVCVUNYHTZVVJOJUTRZVUNYJTVU
      NJVURUVISVUNJJONKZVURSJYEUUAZVUNUVGOJVVIVVQVVRVVOYKYLVVBYMYNUVGOUVIUUFYOU
      SVUNUVIUVBUVIGHZUVOUVBUXJVUKVWBVDVULIUVFYPVFZULUUGYMUXOUXPVUMVUOVUPVUQUDW
      AVIVJUEOVUFVKVLZXIUVBUVQUCZVUOVUPVUQVUMVWEUVIUVGVWEVVPUEUVIUTRZUVIOSRZVWE
      UVQVVPVWFVWGUDZUVBUVQVGUXOUXPUVQVWHWAVIVJUEOUVIVKVLVMZVNZVWEJUVINKZUVGQUV
      BVWKUVGPUVQUVBUVGVUSUVFNKVWKVUSIUVFNYGWNUVBJIUVFVUTVVAVULUUBUUCULZVWEVVCV
      VPVWKQHYHVWJJUVIVOVFVQZYIZVWEVUOVUPVWNVVLXAVWEVUFOUVGMKZOSVWEVWGVUFVWOSRZ
      VWEVVPVWFVWGVWIVTZVWEVVPUXPVVDOUVGUTRVWGVWPWAVWJUXPVWEVJTZVWMVWEOJUVGVWRV
      VCVWEYHTZVWMVVSVWEYJTVWEJVWKUVGSVWEJVVTVWKSVWAVWEUVIOJVWJVWRVWSVWQYKYLVWL
      YMYNUVIOUVGUUHYOUSVWEUVGVWEUVGVWMWJUUIYMVWDXIUUJVQUUDUUKUVOUVQUULUUPUVBUV
      DGHZUVEUVNWAUVBUXJUWIVWTVDUWJIUVCYPVFUVEVWTUVNUVEUVDGUVLUUMZHVWTUVNUCCVXA
      UVDEYQUVDGUVLYRYSYTXAUVBUVHUVPUVJUVRUVBUVGGHZUVHUVPWAUVBUXJVUKVXBVDVULIUV
      FUUNVFUVHVXBUVPUVHUVGVXAHVXBUVPUCCVXAUVGEYQUVGGUVLYRYSYTXAUVBVWBUVJUVRWAV
      WCUVJVWBUVRUVJUVIVXAHVWBUVRUCCVXAUVIEYQUVIGUVLYRYSYTXAUUOUUQUURABCDEFUUSU
      VBUVHUVJUUTUVA $.

    $( The domain of continuity of the arctangent is an open set.  (Contributed
       by Mario Carneiro, 7-Apr-2015.) $)
    atansopn $p |- S e. ( TopOpen ` CCfld ) $=
      ( cc c1 cv c2 cexp co caddc cmpt ccnv cfv wcel eqid ccn wtru a1i cima cn0
      ccnfld ctopn crab mptpreima eqtr4i ctopon cnfldtopon ax-1cn 2nn0 mp1i ctx
      cnmptc expcn addcn cnmpt12f trud logdmopn cnima mp2an eqeltri ) CAFGAHIJK
      ZLKZMZNBUAZUCUDOZCVDBPAFUEVFEAFVDBVEVEQUFUGVEVGVGRKZPZBVGPVFVGPVISAGVCLVG
      VGVGVGFVGFUHOPSVGVGQZUITZSAGVGVGFFVKVKGFPSUJTUNIUBPAFVCMVHPSUKAVGIVJUOULL
      VGVGUMKVGRKPSVGVJUPTUQURBDUSBVEVGVGUTVAVB $.

    $( The domain of continuity of the arctangent is a subset of the actual
       domain of the arctangent.  (Contributed by Mario Carneiro,
       7-Apr-2015.) $)
    atansssdm $p |- S C_ dom arctan $=
      ( c1 cv c2 cexp co caddc wcel cc crab catan cdm wss wi rabss wa cc0 simpl
      wne logdmn0 adantl atandm4 sylanbrc ex mprgbir eqsstri ) CFAGZHIJKJZBLZAM
      NZOPZEUNUOQUMUKUOLZRAMUMAMUOSUKMLZUMUPUQUMTUQULUAUCZUPUQUMUBUMURUQULBDUDU
      EUKUFUGUHUIUJ $.

    $( The real number line is a subset of the domain of continuity of the
       arctangent.  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    ressatans $p |- RR C_ S $=
      ( cr c1 co wcel cc cmnf cc0 1re sylancr cle wbr clt 0re a1i wb cv c2 cexp
      caddc crab wss wral ax-resscn cioc cdif resqcl readdcl recnd 0lt1 addge01
      wn sqge0 mpbid ltletrd ltnle cxr w3a mnfxr elioc2 mp2an simp3bi syl6eleqr
      nsyl eldifd rgen ssrab mpbir2an sseqtr4i ) FGAUAZUBUCHZUDHZBIZAJUEZCFVRUF
      FJUFVQAFUGUHVQAFVNFIZVPJKLUIHZUJBVSVPJVTVSVPVSGFIZVOFIZVPFIZMVNUKZGVOULNZ
      UMVSVPLOPZVPVTIZVSLVPQPZWFUPZVSLGVPLFIZVSRSWAVSMSWELGQPVSUNSVSLVOOPZGVPOP
      ZVNUQVSWAWBWKWLTMWDGVOUONURUSVSWJWCWHWITRWELVPUTNURWGWCKVPQPZWFKVAIWJWGWC
      WMWFVBTVCRKLVPVDVEVFVHVIDVGVJVQAJFVKVLEVM $.

    $( The derivative of the arctangent.  (Contributed by Mario Carneiro,
       7-Apr-2015.) $)
    dvatan $p |- ( CC _D ( arctan |` S ) ) =
      ( x e. S |-> ( 1 / ( 1 + ( x ^ 2 ) ) ) ) $=
      ( cc co c1 cdiv cmpt wceq wtru ci cmul cmin wcel a1i ax-icn cc0 catan cdv
      cres cv c2 cexp caddc clog cfv cvv cr cpr cnex prid2 ax-1cn wne atansssdm
      wa cdm simpr sseldi atandm2 sylib simp1d mulcl sylancr subcl simp2d addcl
      w3a logcld simp3d subcld ovex cneg atans2 simp2bi adantl csn cdif logdmss
      negex crn wf1o logf1o f1of ax-mp ffvelrni logrncn 3syl ccnfld ctopn sylan
      wf 0cn dvmptc dvmptid dvmptcmul mulid1i mpteq2i syl6eq df-neg syl6eqr wss
      dvmptsub ctopon eqid mp2an ctop dvmptres oveq2d fveq2 dvmptco irec oveq2i
      oveq2 oveq1i syl5eq eqtrd oveq12d subneg 3eqtrd 3eqtr3d syl5eqr mpteq2dva
      ine0 addcom sylancl 3eqtr3rd oveq1d eqtr3d 2cn eqtri mulid1d wb necon3bid
      subeq0 mpbird divcan5d mp1i cnfldtopon atansopn cnfldtop toponunii restid
      toponss crest eqcomi fssres feqmptd fvres mpteq2ia syl6req dvlog recdiv2d
      reccld divrecd subdird mulid2i mul32d ixi mulm1d simp3bi dvmptadd addid2i
      divdiv2d divdird divcan3d negcli negsub div23d atandm4 simprbi divsubdird
      sqcld syl pnpcand divreci 2timesi negsubi 3eqtri i2 subsq atandm eqnetrrd
      mulcomd halfcl df-atan reseq1i atanf sseqtri resmpt divcan6 mp4an divassd
      fdmi 2ne0 divcli 3eqtr4d trud ) GUADUCZUBHZADIIAUDZUEUFHZUGHZJHZKZLMGADNU
      EJHZINUXCOHZPHZUHUIZIUXIUGHZUHUIZPHZOHZKZUBHADUXHUENJHZUXEJHZOHZKUXBUXGMA
      UXNUXRUXHGUJDGUKGULQMUKGUMUNRZMUXCDQZURZUXKUXMUYBUXJUYBIGQZUXIGQZUXJGQZUO
      UYBNGQZUXCGQZUYDSUYBUYGUXJTUPZUXLTUPZUYBUXCUAUSZQZUYGUYHUYIVJUYBDUYJUXCBC
      DEFUQZMUYAUTVAZUXCVBVCZVDZNUXCVEZVFZIUXIVGZVFZUYBUYGUYHUYIUYNVHZVKZUYBUXL
      UYBUYCUYDUXLGQZUOUYQIUXIVIZVFZUYBUYGUYHUYIUYNVLZVKZVMUXRUJQUYBUXQUXEJVNRM
      GADUXNKUBHADIUXCNUGHZJHZIUXCNPHZJHZPHZKADUXRKMAUXKVUHUXMVUJGUJUJDUXTVUAVU
      HUJQUYBIVUGJVNRMGADUXKKUBHADIUXJJHZNVOZOHZKADVUHKMABUXJVUMBUDZUHUIZIVUOJH
      ZGGUXKVULUJUJDCUXTUXTUYAUXJCQZMUYAUYGVURUXLCQZBUXCCDEFVPZVQVRVUMUJQZUYBNW
      BZRMVUOCQZURZVUOGTVSVTZQVUPUHWCZQVUPGQVVDCVVEVUOCEWAZMVVCUTVAVVEVVFVUOUHV
      VEVVFUHWDVVEVVFUHWNZWEVVEVVFUHWFWGZWHVUPWIWJZVUQUJQVVDIVUOJVNRZMAUXJVUMGW
      KWLUIZVVLUJGDUXTMUYGURZUYCUYDUYEUOMUYFUYGUYDUYFMSRZUYPWMZUYRVFVVAVVMVVBRM
      GAGUXJKUBHAGTNPHZKAGVUMKMAITUXINGGGGUXTUYCVVMUORZTGQVVMWORZMAIGUXTUYCMUOR
      WPZVVOUYFVVMSRZMGAGUXIKUBHAGNIOHZKAGNKZMAUXCINGGGUXTMUYGUTVVQMAGUXTWQVVNW
      RAGVWANNSWSWTXAZXEAGVUMVVPNXBWTXCDGXDZMVVLGXFUIQDVVLQZVWDVVLVVLXGZUUAZBCD
      EFUUBZDVVLGUUFXHRZVVLGUUGHZVVLVVLXIQVWJVVLLVVLVWFUUCVVLXIGGVVLVWGUUDUUEWG
      UUHZVWFVWEMVWHRZXJMGBCVUPKZUBHGUHCUCZUBHBCVUQKMVWMVWNGUBMVWNBCVUOVWNUIZKV
      WMMBCVVFVWNCVVFVWNWNZMVVHCVVEXDVWPVVIVVGVVEVVFCUHUUIXHRUUJBCVWOVUPVUOCUHU
      UKUULUUMXKBCEUUNXAZVUOUXJUHXLVUOUXJIJXPXMMADVUNVUHUYBVUNVULINJHZOHZVUHVWR
      VUMVULOXNXOUYBVULNJHIUXJNOHZJHVWSVUHUYBUXJNUYSUYFUYBSRZUYTNTUPZUYBYFRZUUO
      UYBVULNUYBUXJUYSUYTUUPVXAVXCUUQUYBVWTVUGIJUYBVWTNUXCUGHZVUGUYBVWTINOHZUXI
      NOHZPHNUXCVOZPHZVXDUYBIUXINUYCUYBUORZUYQVXAUURUYBVXENVXFVXGPVXENLUYBNSUUS
      RUYBVXFNNOHZUXCOHZVXGUYBNUXCNVXAUYOVXAUUTUYBVXKIVOZUXCOHVXGVXJVXLUXCOUVAX
      QUYBUXCUYOUVBXRXSXTUYBUYFUYGVXHVXDLSUYONUXCYAVFYBUYBUYFUYGVXDVUGLSUYONUXC
      YGVFXSXKYCYDYEXSVUFVUJUJQUYBIVUIJVNRMGADUXMKUBHADIUXLJHZNOHZKADVUJKMABUXL
      NVUPVUQGGUXMVXMGUJDCUXTUXTUYAVUSMUYAUYGVURVUSVUTUVCVRVXAVVJVVKMAUXLNGVVLV
      VLGGDUXTVVMUYCUYDVUBUOVVOVUCVFVVTMGAGUXLKUBHAGTNUGHZKVWBMAITUXINGGGGUXTVV
      QVVRVVSVVOVVTVWCUVDAGVXONNSUVEWTXAVWIVWKVWFVWLXJVWQVUOUXLUHXLVUOUXLIJXPXM
      MADVXNVUJUYBIUXLNJHZJHVXEUXLJHVUJVXNUYBIUXLNVXIVUDVXAVUEVXCUVFUYBVXPVUIIJ
      UYBVXPVWRUXINJHZUGHVUMUXCUGHZVUIUYBIUXINVXIUYQVXAVXCUVGUYBVWRVUMVXQUXCUGV
      WRVUMLUYBXNRUYBUXCNUYOVXAVXCUVHXTUYBVXRUXCVUMUGHZVUIUYBVUMGQZUYGVXRVXSLNS
      UVIZUYOVUMUXCYGVFUYBUYGUYFVXSVUILUYOSUXCNUVJYHZXSYBXKUYBINUXLVXIVXAVUDVUE
      UVKYIYEXSXEMADVUKUXRUYBVUIVUGPHZUXEJHVUIUXEJHZVUGUXEJHZPHUXRVUKUYBVUIVUGU
      XEUYBUYGUYFVUIGQUYOSUXCNVGYHZUYBUYGUYFVUGGQUYOSUXCNVIYHZUYBUYCUXDGQZUXEGQ
      UOUYBUXCUYOUVOZIUXDVIVFZUYBUYKUXETUPZUYMUYKUYGVYKUXCUVLUVMUVPZUVNUYBVYCUX
      QUXEJUYBVYCVUMNPHZUXQUYBVXSVUGPHVYCVYMUYBVXSVUIVUGPVYBYJUYBUXCVUMNUYOVXTU
      YBVYARVXAUVQYKUXQUEVUMOHZVUMVUMUGHVYMUXQUEVWROHVYNUENYLSYFUVRVWRVUMUEOXNX
      OYMVUMVYAUVSVUMNVYASUVTUWAXCYJUYBVYDVUHVYEVUJPUYBVUIIOHZVUIVUGOHZJHVYDVUH
      UYBVYOVUIVYPUXEJUYBVUIVYFYNUYBVYPVUGVUIOHZUXEUYBVUIVUGVYFVYGUWFUYBUXDNUEU
      FHZPHZUXDIUGHZVYQUXEUYBVYSUXDVXLPHZVYTVYRVXLUXDPUWBXOUYBVYHUYCWUAVYTLVYIU
      OUXDIYAYHXRUYBUYGUYFVYSVYQLUYOSUXCNUWCYHUYBVYHUYCVYTUXELVYIUOUXDIYGYHYCZX
      SXTUYBIVUGVUIVXIVYGVYFUYBUXCVUMPHZVUGTUYBUYGUYFWUCVUGLUYOSUXCNYAYHUYBWUCT
      UPZUXCVUMUPZUYBUYGWUEUXCNUPZUYBUYKUYGWUEWUFVJUYMUXCUWDVCZVHUYBUYGVXTWUDWU
      EYOUYOVYAUYGVXTURWUCTUXCVUMUXCVUMYQYPYHYRUWEZUYBVUITUPZWUFUYBUYGWUEWUFWUG
      VLUYBUYGUYFWUIWUFYOUYOSUYGUYFURVUITUXCNUXCNYQYPYHYRZYSYKUYBVUGIOHZVYQJHVY
      EVUJUYBWUKVUGVYQUXEJUYBVUGVYGYNWUBXTUYBIVUIVUGVXIVYFVYGWUJWUHYSYKXTYIYEXS
      UYFUXHGQZMSNUWGZYTWRMUXAUXPGUBUXAUXPLMUXAAGVUMNULVTZUXOKZDUCZUXPUAWUODAUW
      HUWIDWUNXDWUPUXPLDUYJWUNUYLWUNGUAUWJUWPUWKAWUNDUXOUWLWGYMRXKMADUXFUXSUYBU
      XFUXHUXQOHZUXEJHUXSWUQIUXEJUYFVXBUEGQUETUPWUQILSYFYLUWQNUEUWMUWNXQUYBUXHU
      XQUXEUYFWULUYBSWUMYTUXQGQUYBUENYLSYFUWRRVYJVYLUWOYDYEUWSUWT $.

    $( The arctangent is a continuous function.  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    atancn $p |- ( arctan |` S ) e. ( S -cn-> CC ) $=
      ( vx cc wss catan wf co wcel ci atanf cdm c1 cv c2 cexp caddc cpr sseqtri
      cres ccncf ssid cneg cdif atansssdm fdmi fssres mp2an crab ssrab2 eqsstri
      w3a cdv wceq cdiv ovex dvatan dmmpti dvcn mpan2 mp3an ) GGHZCGICUCZJZCGHZ
      VFCGUDKLZGUEGMUFMUAUGZGIJCVJHVGNCIOVJABCDEUHVJGINUIUBVJGCIUJUKCPAQRSKTKBL
      ZAGULGEVKAGUMUNVEVGVHUOGVFUPKZOCUQVIFCPPFQRSKTKZURKVLPVMURUSFABCDEUTVACGV
      FVBVCVD $.
  $}

  ${
    $d k m n A $.  $d m F $.
    atantayl.1 $e |- F = ( n e. NN |-> ( ( ( _i x.
      ( ( -u _i ^ n ) - ( _i ^ n ) ) ) / 2 ) x. ( ( A ^ n ) / n ) ) ) $.
    $( The Taylor series for ` arctan ( A ) ` .  (Contributed by Mario
       Carneiro, 1-Apr-2015.) $)
    atantayl $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
      seq 1 ( + , F ) ~~> ( arctan ` A ) ) $=
      ( cc wcel cfv c1 ci c2 cdiv co cmul cmin cexp ax-icn sylancr wceq oveq12d
      cn vm vk cabs clt wbr wa caddc cseq clog catan cli cneg cv cmpt cz 1z a1i
      nnuz halfcl mp1i cvv simpl mulcl negcld absnegd absmul absi oveq1i adantr
      cr abscl recnd mulid2d syl5eq 3eqtrd simpr eqbrtrd logtayl syl2anc ax-1cn
      subneg fveq2d negeqd breqtrd seqex eqbrtrrd oveq2 id eqid ovex adantl cn0
      fvmpt nnnn0 expcl syl2an nncn cc0 wne nnne0 divcld eqeltrd serf ffvelrnda
      cuz syl6eleq cfz elfznn eqtr4d sersub climsub addcl cdm bndatandm atandm2
      w3a sylib simp3d logcld subcl simp2d neg2subd subcld negcli div23d oveq1d
      2cn 2ne0 mulassd subdird mulneg1 mulexpd eqtr3d divassd divsubdird oveq2d
      3eqtr3d 3eqtr4d isermulc2 atanval syl breqtrrd ) AEFZAUCGZHUDUEZUFZUGCHUH
      IJKLZHIAMLZNLZUIGZHUUHUGLZUIGZNLZMLZAUJGZUKUUFUUMUUGUABTUUHULZBUMZOLZUUQK
      LZUUHUUQOLZUUQKLZNLZUNZCHTURHUOFUUFUPUQZIEFZUUGEFZUUFPIUSUTZUUFUGUVCHUHZU
      ULULZUUJULZNLUUMUKUUFUVIUVJUBUGBTUUSUNZHUHZUGBTUVAUNZHUHZUVHHVATURUVDUUFU
      VLHUUPNLZUIGZULZUVIUKUUFUUPEFZUUPUCGZHUDUEUVLUVQUKUEUUFUUHUUFUVEUUCUUHEFZ
      PUUCUUEVBZIAVCQZVDZUUFUVSUUDHUDUUFUVSUUHUCGZIUCGZUUDMLZUUDUUFUUHUWBVEZUUF
      UVEUUCUWDUWFRPUWAIAVFQUUFUWFHUUDMLUUDUWEHUUDMVGVHUUFUUDUUFUUDUUCUUDVJFUUE
      AVKVIVLVMVNVOUUCUUEVPVQZUUPBVRVSUUFUVPUULUUFUVOUUKUIUUFHEFZUVTUVOUUKRVTUW
      BHUUHWAQWBWCWDUVHVAFUUFUGUVCHWEUQUUFUVTUWDHUDUEUVNUVJUKUEUWBUUFUVSUWDHUDU
      WGUWHWFUUHBVRVSUUFTEUBUMZUVLUUFUAUVKHTURUVDUUFUAUMZTFZUFZUWKUVKGZUUPUWKOL
      ZUWKKLZEUWLUWNUWPRUUFBUWKUUSUWPTUVKUUQUWKRZUURUWOUUQUWKKUUQUWKUUPOWGUWQWH
      ZSZUVKWIUWOUWKKWJWMWKZUWMUWOUWKUUFUVRUWKWLFZUWOEFUWLUWCUWKWNZUUPUWKWOWPZU
      WLUWKEFUUFUWKWQWKZUWLUWKWRWSUUFUWKWTWKZXAZXBZXCXDUUFTEUWJUVNUUFUAUVMHTURU
      VDUWMUWKUVMGZUUHUWKOLZUWKKLZEUWLUXHUXJRUUFBUWKUVAUXJTUVMUWQUUTUXIUUQUWKKU
      UQUWKUUHOWGUWRSZUVMWIUXIUWKKWJWMWKZUWMUXIUWKUUFUVTUXAUXIEFUWLUWBUXBUUHUWK
      WOWPZUXDUXEXAZXBZXCXDUUFUWJTFZUFZUAUVKUVMUVCHUWJUXQUWJTHXEGUUFUXPVPURXFUX
      QUUFUWLUWNEFUWKHUWJXGLFZUUFUXPVBZUWKUWJXHZUXGWPUXQUUFUWLUXHEFUXRUXSUXTUXO
      WPUXQUUFUWLUWKUVCGZUWNUXHNLZRUXRUXSUXTUWMUYAUWPUXJNLZUYBUWLUYAUYCRUUFBUWK
      UVBUYCTUVCUWQUUSUWPUVAUXJNUWSUXKSUVCWIUWPUXJNWJWMWKZUWMUWNUWPUXHUXJNUWTUX
      LSXIWPXJXKUUFUULUUJUUFUUKUUFUWIUVTUUKEFVTUWBHUUHXLQUUFUUCUUIWRWSZUUKWRWSZ
      UUFAUJXMFZUUCUYEUYFXPAXNZAXOXQZXRXSUUFUUIUUFUWIUVTUUIEFVTUWBHUUHXTQUUFUUC
      UYEUYFUYIYAXSYBWDUWMUYAUYCEUYDUWMUWPUXJUXFUXNYCXBUWMIIULZUWKOLZIUWKOLZNLZ
      MLZJKLZAUWKOLZUWKKLZMLZUUGUYCMLZUWKCGZUUGUYAMLUWMUYRUUGUYMMLZUYQMLUUGUYMU
      YQMLZMLUYSUWMUYOVUAUYQMUWMIUYMJUVEUWMPUQZUWMUYKUYLUWMUYJEFZUXAUYKEFIPYDZU
      WLUXAUUFUXBWKZUYJUWKWOQZUWMUVEUXAUYLEFPVUFIUWKWOQZYCZJEFUWMYGUQJWRWSUWMYH
      UQYEYFUWMUUGUYMUYQUUFUVFUWLUVGVIVUIUWMUYPUWKUUFUUCUXAUYPEFUWLUWAUXBAUWKWO
      WPZUXDUXEXAYIUWMVUBUYCUUGMUWMUYMUYPMLZUWKKLUWOUXINLZUWKKLVUBUYCUWMVUKVULU
      WKKUWMVUKUYKUYPMLZUYLUYPMLZNLVULUWMUYKUYLUYPVUGVUHVUJYJUWMUWOVUMUXIVUNNUW
      MUYJAMLZUWKOLUWOVUMUWMVUOUUPUWKOUWMUVEUUCVUOUUPRPUUFUUCUWLUWAVIZIAYKQYFUW
      MUYJAUWKVUDUWMVUEUQVUPVUFYLYMUWMIAUWKVUCVUPVUFYLSXIYFUWMUYMUYPUWKVUIVUJUX
      DUXEYNUWMUWOUXIUWKUXCUXMUXDUXEYOYQYPVOUWLUYTUYRRUUFBUWKIUYJUUQOLZIUUQOLZN
      LZMLZJKLZAUUQOLZUUQKLZMLUYRTCUWQVVAUYOVVCUYQMUWQVUTUYNJKUWQVUSUYMIMUWQVUQ
      UYKVURUYLNUUQUWKUYJOWGUUQUWKIOWGSYPYFUWQVVBUYPUUQUWKKUUQUWKAOWGUWRSSDUYOU
      YQMWJWMWKUWMUYAUYCUUGMUYDYPYRYSUUFUYGUUOUUNRUYHAYTUUAUUB $.
  $}

  ${
    $d n A $.
    atantayl2.1 $e |- F = ( n e. NN |-> if ( 2 || n , 0 ,
      ( ( -u 1 ^ ( ( n - 1 ) / 2 ) ) x. ( ( A ^ n ) / n ) ) ) ) $.
    $( The Taylor series for ` arctan ( A ) ` .  (Contributed by Mario
       Carneiro, 1-Apr-2015.) $)
    atantayl2 $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
      seq 1 ( + , F ) ~~> ( arctan ` A ) ) $=
      ( cc wcel c1 caddc ci cexp co cmin cmul c2 cdiv cc0 wceq ax-icn a1i cz wa
      cabs cfv clt wbr cseq cn cneg cv cmpt catan cli cdivides cif eqeq1 negcli
      cn0 nnnn0 ad2antlr expcld sqneg ax-mp oveq1i wne ine0 negne0i 2z 2ne0 nnz
      adantl dvdsval2 syl3anc biimpa expmulz syl22anc 3eqtr4a nncn 2cn divcan2d
      wb oveq2d 3eqtr3d subeq0bd mul01i syl6eq oveq1d div0i nnne0 divcld mul02d
      simplll eqtr2d wn ax-1cn ax-1ne0 peano2cn divsubdird dividi df-2 pnpcan2d
      syl oveq2i syl5eq eqtr3d notbid zeo ord sylbid peano2zm eqeltrrd divcan3d
      wo imp expclzd 2timesd subcl sylancl expm1d eqtrd expcl divrec2d i2 eqtri
      sylancr irec negeqi divneg2 mp3an negnegi 3eqtr3i 3eqtr3g mulneg1 oveq12d
      mulcl negsubd subdid eqtr4d 3eqtrd ifbothda mpteq2dva seqeq3d atantayl
      eqid eqbrtrd ) AEFZAUBUCGUDUEZUAZHCGUFHBUGIIUHZBUIZJKZIUUIJKZLKZMKZNOKZAU
      UIJKZUUIOKZMKZUJZGUFAUKUCULUUGCUURHGUUGCBUGNUUIUMUEZPGUHZUUIGLKZNOKZJKZUU
      PMKZUNZUJUURDUUGBUGUVEUUQUUSPUUQQUVDUUQQUVEUUQQUUGUUIUGFZUAZPUVDPUVEUUQUO
      UVDUVEUUQUOUVGUUSUAZUUQPUUPMKPUVHUUNPUUPMUVHUUNPNOKPUVHUUMPNOUVHUUMIPMKPU
      VHUULPIMUVHUUJUUKUVHUUHUUIUUHEFZUVHIRUPZSZUVFUUIUQFZUUGUUSUUIURZUSZUTUVHU
      UHNUUINOKZMKZJKZIUVPJKZUUJUUKUVHUUHNJKZUVOJKZINJKZUVOJKZUVQUVRUVSUWAUVOJI
      EFZUVSUWAQRIVAVBZVCUVHUVIUUHPVDZNTFZUVOTFZUVQUVTQUVKUWEUVHIRVEVFZSUWFUVHV
      GSZUVGUUSUWGUVGUWFNPVDZUUITFZUUSUWGVTUWFUVGVGSUWJUVGVHSUVFUWKUUGUUIVIZVJZ
      NUUIVKVLZVMZUUHNUVOVNVOUVHUWCIPVDZUWFUWGUVRUWBQUWCUVHRSUWPUVHVESUWIUWOINU
      VOVNVOVPUVHUVPUUIUUHJUVHUUINUVFUUIEFZUUGUUSUUIVQZUSZNEFZUVHVRSUWJUVHVHSVS
      ZWAUVHUVPUUIIJUXAWAWBWCWAIRWDWEWFNVRVHWGWEWFUVHUUPUVHUUOUUIUVHAUUIUUEUUFU
      VFUUSWKUVNUTUWSUVFUUIPVDUUGUUSUUIWHUSWIWJWLUVGUUSWMZUAZUVCUUNUUPMUXCNUVCM
      KZNOKUVCUUNUXCUVCNUXCUUTUVBUUTEFUXCGWNUPSUUTPVDUXCGWNWOVFSUXCUUIGHKZNOKZG
      LKZUVBTUXCUXENLKZNOKZUXGUVBUXCUXIUXFNNOKZLKUXGUXCUXENNUXCUWQUXEEFUVFUWQUU
      GUXBUWRUSZUUIWPXAUWTUXCVRSZUXLUWJUXCVHSZWQUXJGUXFLNVRVHWRXBWEUXCUXHUVANOU
      XCUXHUXEGGHKZLKUVANUXNUXELWSXBUXCUUIGGUXKGEFZUXCWNSZUXPWTXCWFXDUXCUXFTFZU
      XGTFUVGUXBUXQUVGUXBUWGWMUXQUVGUUSUWGUWNXEUVGUWGUXQUVGUWKUWGUXQXLUWMUUIXFX
      AXGXHXMUXFXIXAXJZXNZUXLUXMXKUXCUXDUUMNOUXCUXDUVCUVCHKIUUJMKZIUUKMKZUHZHKZ
      UUMUXCUVCUXSXOUXCUVCUXTUVCUYBHUXCUVSUVBJKZGUUHOKZUUJMKZUVCUXTUXCUUHNUVBMK
      ZJKZUUJUUHOKZUYDUYFUXCUYHUUHUVAJKUYIUXCUYGUVAUUHJUXCUVANUXCUWQUXOUVAEFUXK
      WNUUIGXPXQUXLUXMVSZWAUXCUUHUUIUVIUXCUVJSZUWEUXCUWHSZUVFUWKUUGUXBUWLUSZXRX
      SUXCUVIUWEUWFUVBTFZUYHUYDQUYKUYLUWFUXCVGSZUXRUUHNUVBVNVOUXCUUJUUHUXCUVIUV
      LUUJEFZUVJUVFUVLUUGUXBUVMUSZUUHUUIXTYDZUYKUYLYAWBUVSUUTUVBJUVSUWAUUTUWDYB
      YCVCUYEIUUJMGIOKZUHZUUHUHUYEIUYSUUHYEYFUXOUWCUWPUYTUYEQWNRVEGIYGYHIRYIYJV
      CYKUXCUVCUUHUUKMKZUYBUXCUWAUVBJKZUYSUUKMKZUVCVUAUXCIUYGJKZUUKIOKZVUBVUCUX
      CVUDIUVAJKVUEUXCUYGUVAIJUYJWAUXCIUUIUWCUXCRSZUWPUXCVESZUYMXRXSUXCUWCUWPUW
      FUYNVUDVUBQVUFVUGUYOUXRINUVBVNVOUXCUUKIUXCUWCUVLUUKEFZRUYQIUUIXTYDZVUFVUG
      YAWBUWAUUTUVBJYBVCUYSUUHUUKMYEVCYKUXCUWCVUHVUAUYBQRVUIIUUKYLYDXSYMUXCUYCU
      XTUYALKUUMUXCUXTUYAUXCUWCUYPUXTEFRUYRIUUJYNYDUXCUWCVUHUYAEFRVUIIUUKYNYDYO
      UXCIUUJUUKVUFUYRVUIYPYQYRWFXDWFYSYTXCUUAABUURUURUUCUUBUUD $.
  $}

  ${
    $d k n A $.
    atantayl3.1 $e |- F = ( n e. NN0 |-> ( ( -u 1 ^ n ) x.
      ( ( A ^ ( ( 2 x. n ) + 1 ) ) / ( ( 2 x. n ) + 1 ) ) ) ) $.
    $( The Taylor series for ` arctan ( A ) ` .  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    atantayl3 $p |- ( ( A e. CC /\ ( abs ` A ) < 1 ) ->
      seq 0 ( + , F ) ~~> ( arctan ` A ) ) $=
      ( vk cc wcel c1 wbr caddc cc0 cseq cn0 c2 cmul co cmin cdiv cexp cmpt cfv
      cabs clt wa cneg catan cli wceq 2nn0 simpr nn0mulcl sylancr nn0cnd ax-1cn
      pncan sylancl oveq1d nn0cn adantl 2cn a1i wne 2ne0 divcan3d eqtr2d oveq2d
      cv mpteq2dva syl5eq seqeq3d cn cdivides cif atantayl2 neg1cn expcl simpll
      eqid peano2nn0 syl expcld nncnd nnne0d divcld mulcld eqeltrrd oveq1 oveq2
      nn0p1nn id oveq12d iserodd mpbird eqbrtrd ) AFGZAUBUAHUCIZUDZJCKLJBMHUEZN
      BVGZOPZHJPZHQPZNRPZSPZAXASPZXARPZOPZTZKLZAUFUAZUGWQCXHJKWQCBMWRWSSPZXFOPZ
      TXHDWQBMXLXGWQWSMGZUDZXKXDXFOXNWSXCWRSXNXCWTNRPWSXNXBWTNRXNWTFGHFGXBWTUHX
      NWTXNNMGXMWTMGZUIWQXMUJZNWSUKULZUMUNWTHUOUPUQXNWSNXMWSFGWQWSURUSNFGXNUTVA
      NKVBXNVCVAVDVEVFUQZVHVIVJWQXIXJUGIJEVKNEVGZVLIKWRXSHQPZNRPZSPZAXSSPZXSRPZ
      OPZVMTZHLXJUGIAEYFYFVRVNWQXJYEXGBEXNXLXGFXRXNXKXFXNWRFGXMXKFGVOXPWRWSVPUL
      XNXEXAXNAXAWOWPXMVQXNXOXAMGXQWTVSVTWAXNXAXNXOXAVKGXQWTWIVTZWBXNXAYGWCWDWE
      WFXSXAUHZYBXDYDXFOYHYAXCWRSYHXTXBNRXSXAHQWGUQVFYHYCXEXSXARXSXAASWHYHWJWKW
      KWLWMWN $.
  $}

  ${
    $d j k n x $.  $d n G $.  $d n N $.
    $( Lemma for ~ leibpi .  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    leibpilem1 $p |- ( ( N e. NN0 /\ ( -. N = 0 /\ -. 2 || N ) ) ->
      ( N e. NN /\ ( ( N - 1 ) / 2 ) e. NN0 ) ) $=
      ( vn cn0 wcel cc0 wceq wn c2 wbr wa c1 cmin co cdiv cz cle syl 2cn oveq1d
      cc cdivides cn wo elnn0 biimpi ord con1d imp adantrr cmul caddc wrex nn0z
      cv wb adantr odd2np1 zcn mulcl mpan ax-1cn pncan sylancl wne 2ne0 divcan3
      mp3an23 eqtrd eqeltrd oveq1 eleq1d syl5ibcom rexlimiv syl6bi impr nnm1nn0
      id cr clt nn0red nn0ge0d 2re a1i 2pos divge0 syl22anc elnn0z sylanbrc jca
      ) ACDZAEFZGZHAUAIGZJJZAUBDZAKLMZHNMZCDZWJWLWOWMWJWLWOWJWOWKWJWOWKWJWOWKUC
      AUDUEUFUGUHUIZWNWQODZEWQPIZWRWJWLWMWTWJWLJZWMHBUNZUJMZKUKMZAFZBOULZWTXBAO
      DZWMXGUOWJXHWLAUMUPBAUQQXFWTBOXCODZXEKLMZHNMZODXFWTXIXKXCOXIXCTDZXKXCFXCU
      RXLXKXDHNMZXCXLXJXDHNXLXDTDZKTDXJXDFHTDZXLXNRHXCUSUTVAXDKVBVCSXLXOHEVDXMX
      CFRVEXCHVFVGVHQXIVQVIXFXKWQOXFXJWPHNXEAKLVJSVKVLVMVNVOWNWPVRDEWPPIHVRDZEH
      VSIZXAWNWPWNWOWPCDWSAVPQZVTWNWPXRWAXPWNWBWCXQWNWDWCWPHWEWFWQWGWHWI $.

    leibpi.1 $e |- F = ( n e. NN0 |->
      ( ( -u 1 ^ n ) / ( ( 2 x. n ) + 1 ) ) ) $.
    ${
      leibpilem2.2 $e |- G = ( k e. NN0 |-> if ( ( k = 0 \/ 2 || k ) , 0 ,
        ( ( -u 1 ^ ( ( k - 1 ) / 2 ) ) / k ) ) ) $.
      leibpilem2.3 $e |- A e. _V $.
      $( The Leibniz formula for ` pi ` .  (Contributed by Mario Carneiro,
         7-Apr-2015.) $)
      leibpilem2 $p |- ( seq 0 ( + , F ) ~~> A <-> seq 0 ( + , G ) ~~> A ) $=
        ( caddc cc0 cli cn0 c1 c2 co cdiv wceq wcel cc wtru cseq cneg cmul cmin
        wbr cv cexp cmpt cn cdivides cif 2cn nn0cn mulcl sylancr ax-1cn sylancl
        pncan oveq1d wne 2ne0 divcan3 mp3an23 syl oveq2d mpteq2ia eqtr4i seqeq3
        eqtrd ax-mp breq1i wb cr 1re renegcli reexpcl nn0mulcl nn0p1nn nndivred
        mpan 2nn0 recnd eqeltrd adantl oveq1 id oveq12d iserodd trud cuz addid2
        cfv cres 0cn 1nn0 nn0uz eleqtri wo wa wn ioran leibpilem1 simprd simpld
        a1i sylan2b ifclda fmpti ffvelrni mp1i cfz simpr 1m1e0 syl6eleq elfz1eq
        oveq2i fveq2d 0nn0 iftrue orcs c0ex fvmpt syl6eq seqid cz 1z nnuz nnne0
        syl6eleqr neneqd biorf ifbid breq2 ifbieq2d eqid ovex ifex nnnn0 eqeq1
        cvv orbi12d 3eqtr4d seqfeq eqtr4d seqex climres mp2an bitr3i 3bitri ) I
        DJUAZAKUEICLMUBZNCUFZUCOZMIOZMUDOZNPOZUGOZUUNPOZUHZJUAZAKUEZIBUINBUFZUJ
        UEZJUUKUVBMUDOZNPOZUGOZUVBPOZUKZUHZMUAZAKUEZIEJUAZAKUEZUUJUUTAKDUUSQUUJ
        UUTQDCLUUKUULUGOZUUNPOZUHUUSFCLUURUVOUULLRZUUQUVNUUNPUVPUUPUULUUKUGUVPU
        UPUUMNPOZUULUVPUUOUUMNPUVPUUMSRZMSRUUOUUMQUVPNSRZUULSRZUVRULUULUMZNUULU
        NUOUPUUMMURUQUSUVPUVTUVQUULQZUWAUVTUVSNJUTUWBULVAUULNVBVCVDVIVEUSZVFVGI
        DUUSJVHVJVKUVAUVKVLTAUVGUURCBUVPUURSRTUVPUURUVOSUWCUVPUVOUVPUVNUUNUUKVM
        RZUVPUVNVMRMVNVOZUUKUULVPVTUVPUUMLRZUUNUIRNLRUVPUWFWANUULVQVTUUMVRVDVSW
        BWCWDUVBUUNQZUVFUUQUVBUUNPUWGUVEUUPUUKUGUWGUVDUUONPUVBUUNMUDWEUSVEUWGWF
        WGWHWIUVKUVLMWJWLZWMZAKUEZUVMUWIUVJAKUWIUVJQTUWIIEMUAUVJTCISEJMJUVTJUUL
        IOUULQTUULWKWDJSRZTWNXEMJWJWLZRTMLUWLWOWPWQXEMLRMEWLSRTWOLSMEBLSUVBJQZU
        VCWRZJUVGUKZEGUVBLRZUWNJUVGSUWKUWPUWNWSWNXEUWNWTUWPUWMWTUVCWTWSZUVGSRUW
        MUVCXAUWPUWQWSZUVGUWRUVFUVBUWRUWDUVELRZUVFVMRUWEUWRUVBUIRZUWSUVBXBZXCUU
        KUVEVPUOUWRUWTUWSUXAXDVSWBXFXGXHXIXJTUULJMMUDOZXKOZRZWSZUULEWLZJEWLZJUX
        EUULJEUXEUULJJXKOZRUULJQZUXEUULUXCUXHTUXDXLUXBJJXKXMXPXNUULJXOVDXQJLRUX
        GJQXRBJUWOJLEUWMUVCUWOJQUWNJUVGXSXTGYAYBVJYCYDTICUVIEMMYERZTYFXETUULUWH
        RZWSZUULUIRZUULUVIWLZUXFQUXLUULUWHUITUXKXLYGYIUXMNUULUJUEZJUUKUULMUDOZN
        POZUGOZUULPOZUKZUXIUXOWRZJUXSUKZUXNUXFUXMUXOUYAJUXSUXMUXIWTUXOUYAVLUXMU
        ULJUULYHYJUXIUXOYKVDYLBUULUVHUXTUIUVIUVBUULQZUVCUXOUVGUXSJUVBUULNUJYMZU
        YCUVFUXRUVBUULPUYCUVEUXQUUKUGUYCUVDUXPNPUVBUULMUDWEUSVEUYCWFWGZYNUVIYOU
        XOJUXSYAUXRUULPYPZYQYBUXMUVPUXFUYBQUULYRBUULUWOUYBLEUYCUWNUYAUVGUXSJUYC
        UWMUXIUVCUXOUVBUULJYSUYDUUAUYEYNGUYAJUXSYAUYFYQYBVDUUBVDUUCUUDWIVKUXJUV
        LYTRUWJUVMVLYFIEJUUEAUVLMYTUUFUUGUUHUUI $.
    $}

    $( The Leibniz formula for ` pi ` .  This proof depends on three main
       facts:  (1) the series ` F ` is convergent, because it is an alternating
       series ( ~ iseralt ).  (2) Using ~ leibpilem2 to rewrite the series as a
       power series, it is the ` x = 1 ` special case of the Taylor series for
       ` arctan ` ( ~ atantayl2 ).  (3) Although we cannot directly plug
       ` x = 1 ` into ~ atantayl2 , Abel's theorem ( ~ abelth2 ) says that the
       limit along any sequence converging to ` 1 ` , such as ` 1 - 1 / n ` ,
       of the power series converges to the power series extended to ` 1 ` ,
       and then since ` arctan ` is continuous at ` 1 ` ( ~ atancn ) we get the
       desired result.  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    leibpi $p |- seq 0 ( + , F ) ~~> ( pi / 4 ) $=
      ( vk vj caddc cc0 cdiv co wbr cn0 wceq c1 wtru cfv wcel a1i cc cn cmul vx
      cseq cpi c4 cli cv c2 cmin cexp cif cmpt csu nn0uz cz 0z wa eqidd 0cn 1re
      wn sylancr nndivred recnd sylan2b ifclda adantl eqid fmptd ffvelrnda 2nn0
      cr nn0mulcl sylan nn0p1nn syl nnrecred nn0red lep1d wb peano2re syl112anc
      cle clt mpbid nnred nngt0d lerec syl22anc oveq2 oveq1d ovex fvmpt 3brtr4d
      oveq2d weq cvv nnuz ax-1cn mp1i mptex eqeltrd nnre syl2anc breqtrrd nngt0
      1z rpreccld rpge0d expcl nnne0d oveq12d 3eqtr4d sylib leibpilem2 ccom crp
      catan mulid1d eqtr4d 1elunit climcncf oveq1 fmptco wral adantll c0ex ifex
      eqtrd fvmpt2 sylancl nfv nffvmpt1 nfcv nfeq fveq2 eqeq12d cbvral r19.21bi
      ax-mp wf cdivides wo cneg ioran renegcli leibpilem1 simprd reexpcl simpld
      cdm peano2nn0 nn0re 2re lemul2 leadd1dd divcnv nn0ex nnrecre nnnn0 sylan2
      2pos nn0addge1 2timesd letrd nnrpd climsqz2 neg1cn divrecd iseralt climdm
      nncnd fvex seqex breldm isumclim2 cicc abelth2 nnrp rpred ledivmul mpbird
      nnge1 0re elicc2i syl3anbrc climsubc2 subid1i syl6breq sumeq2sdv adantllr
      iirev nnex resubcl ad2antrr simplr reexpcld nn0cn ad2antlr div12d mulcomd
      ifeq2da mul02d ifeq1d ifsb syl6eqr simpr ralrimiva nfov mulcld 0nn0 0p1e1
      eqeltrrd seqeq1 cuz elnnuz nnne0 neneqd biorf bicomd ifbid mpan2 sylan2br
      rgen seqfeq cabs ltsubrp eqbrtrd atantayl2 syl5eqbr clim2ser2 seq1 iftrue
      abssubge0d orcs oveq2i atanrecl addid1d syl5eq breqtrd isumclim mpteq2dva
      eqtri nn0z 1exp sylan9eq trud ffvelrni sumeq2dv sumex cmnf cioc cdif crab
      3brtr3d ccncf atancn wss unitssre ressatans sstri fss sselii sseldi cncff
      cres feqmptd fvres mpteq2ia syl6eq atan1 climuni mpbir ) FBGUBUCUDHIZUEJF
      DKDUFZGLZUGVVNUUAJZUUBZGMUUCZVVNMUHIUGHIZUIIZVVNHIZUJZUKZGUBZVVMUEJZVWENV
      WDKEUFZVWCOZEULZVVMUENVWGEVWCGKUMGUNPZNUOQZNVWFKPZUPVWGUQNKRVWFVWCNDKVWBR
      VWCVVNKPZVWBRPNVWLVVQGVWARGRPZVWLVVQUPURQVVQUTZVWLVVOUTZVVPUTUPZVWARPZVVO
      VVPUUDZVWLVWPUPZVWAVWSVVTVVNVWSVVRVKPZVVSKPZVVTVKPZMUSUUEZVWSVVNSPZVXAVVN
      UUFZUUGZVVRVVSUUHZVAVWSVXDVXAVXEUUIZVBVCZVDVEVFVWCVGZVHZVINVWDFAKVVRAUFZU
      IIZUGVXLTIZMFIZHIZUKZGUBZUEOZUEJZVWDUEUUJZPNVXRVXSUEJZVXTNVXRVYAPVYBNDVXQ
      AKMVXOHIZUKZGKUMVWJNAKVYCVKVYDNVXLKPZUPZVXOVYFVXNKPZVXOSPNUGKPZVYEVYGVYHN
      VJQZUGVXLVLVMVXNVNVOVPVYDVGZVHNVWLUPZMUGVVNMFIZTIZMFIZHIZMUGVVNTIZMFIZHIZ
      VYLVYDOZVVNVYDOZWBVYKVYQVYNWBJZVYOVYRWBJZVYKVYPVYMMVYKVYPNVYHVWLVYPKPZVYI
      UGVVNVLZVMZVQVYKVYMVYKVYHVYLKPZVYMKPZVJVWLWUFNVVNUUKVFZUGVYLVLVAZVQMVKPZV
      YKUSQVYKVVNVYLWBJZVYPVYMWBJZVYKVVNVWLVVNVKPZNVVNUULVFZVRVYKWUMVYLVKPZUGVK
      PZGUGWCJZWUKWULVSWUNVYKWUMWUOWUNVVNVTVOWUPVYKUUMQWUQVYKUVAQVVNVYLUGUUNWAW
      DUUOVYKVYQVKPZGVYQWCJZVYNVKPGVYNWCJWUAWUBVSVYKVYQVYKWUCVYQSPZWUEVYPVNVOZW
      EVYKVYQWVAWFVYKVYNVYKWUGVYNSPWUIVYMVNVOZWEVYKVYNWVBWFVYQVYNWGWHWDVYKWUFVY
      SVYOLWUHAVYLVYCVYOKVYDVXLVYLLZVXOVYNMHWVCVXNVYMMFVXLVYLUGTWIWJWNVYJMVYNHW
      KWLVOVWLVYTVYRLZNAVVNVYCVYRKVYDADWOZVXOVYQMHWVEVXNVYPMFVXLVVNUGTWIWJZWNVY
      JMVYQHWKWLZVFZWMNGDASMVXLHIZUKZVYDMWPSWQMUNPZNXFQZMRPZWVJGUEJNWRMAUUPWSZV
      YDWPPNAKVYCUUQWTQNVXDUPZVVNWVJOZMVVNHIZVKVXDWVPWVQLNAVVNWVIWVQSWVJVXLVVNM
      HWIZWVJVGMVVNHWKWLZVFZVXDWVQVKPNVVNUURVFXAZWVOVYTVYRVKWVOVWLWVDVXDVWLNVVN
      UUSZVFZWVGVOZWVOVYQVXDNVWLWUTWWBWVAUUTZVPXAWVOVYRWVQVYTWVPWBWVOVVNVYQWBJZ
      VYRWVQWBJZWVOVVNVYPVYQVXDWUMNVVNXBVFZWVOVYPWVOVYHVWLWUCVJWWCWUDVAVQZWVOVY
      PVKPWURWWIVYPVTVOWVOVVNVVNVVNFIZVYPWBWVOWUMVWLVVNWWJWBJWWHWWCVVNVVNUVBXCW
      VOVVNWVOVVNWWHVCUVCXDWVOVYPWWIVRUVDWVOWUMGVVNWCJZWURWUSWWFWWGVSWWHVXDWWKN
      VVNXEVFWVOVYQWWEWEWVOVYQWWEWFVVNVYQWGWHWDWWDWVTWMWVOGVYRVYTWBWVOVYRWVOVYQ
      WVOVYQWWEUVEXGXHWWDXDUVFVYKVVRVVNUIIZVYQHIZWWLVYRTIVVNVXQOZWWLVYTTIVYKWWL
      VYQNVVRRPZVWLWWLRPWWONUVGQVVRVVNXIVMVYKVYQWVAUVKVYKVYQWVAXJUVHVWLWWNWWMLN
      AVVNVXPWWMKVXQWVEVXMWWLVXOVYQHVXLVVNVVRUIWIWVFXKVXQVGZWWLVYQHWKWLVFVYKVYT
      VYRWWLTWVHWNXLUVIVXRUVJXMVXSDAVXQVWCWWPVXJVXRUEUVLZXNXMVWDVXSUEFVWCGUVMWW
      QUVNVOZUVONASMWVIUHIZXQOZUKZVWHUEJWXAVVMUEJVWHVVMLNUAGMUVPIZKVWGUAUFZVWFU
      IIZTIZEULZUKZASWWSUKZXOZMWXGOZWXAVWHUENWXBRMWXGWXHMSWQWVLNUAVWCEWXGVXKWWR
      WXGVGZUVQNASWWSWXBWXHNVXLSPZUPZWVIWXBPZWWSWXBPWXMWVIVKPZGWVIWBJWVIMWBJZWX
      NWXMWVIWXMVXLWXLVXLXPPNVXLUVRVFXGZUVSZWXMWVIWXQXHWXMWXPMVXLMTIZWBJZWXMMVX
      LWXSWBWXLMVXLWBJNVXLUWBVFWXMVXLWXMVXLWXLVXLVKPZNVXLXBVFZVCXRXDWXMWUJWUJWY
      AGVXLWCJZWXPWXTVSWUJWXMUSQZWYDWYBWXLWYCNVXLXEVFMMVXLUVTWAUWAZGMWVIUWCUSUW
      DUWEWVIUWKVOZWXHVGZVHZNWXHMGUHIMUENGMDWVJWXHMWPSWQWVLWVNWVMNWRQWXHWPPNASW
      WSUWLWTQWVOWVPWWAVCVXDVVNWXHOZMWVPUHIZLNVXDWYIMWVQUHIZWYJAVVNWWSWYKSWXHWV
      EWVIWVQMUHWVRWNWYGMWVQUHWKWLVXDWVPWVQMUHWVSWNXSVFUWFMWRUWGUWHZMWXBPZNXTQY
      ANWXIASKVWGWWSVWFUIIZTIZEULZUKWXANAUASWXBWWSWXFWYPWXHWXGWYFNWXHUQZNWXGUQW
      XCWWSLZKWXEWYOEWYRWXDWYNVWGTWXCWWSVWFUIYBWNUWIYCNASWYPWWTWXMWYOWWTEDKVVQG
      VVTWWSVVNUIIZVVNHIZTIZUJZUKZGKUMVWIWXMUOQWXMVWFXUCOZWYOLZEKWXMVVNXUCOZVVN
      VWCOZWYSTIZLZDKYDXUEEKYDWXMXUIDKWXMVWLUPZXUBVWBWYSTIZXUFXUHXUJXUBVVQGWYST
      IZVWAWYSTIZUJZXUKXUJXUBVVQGXUMUJXUNXUJVVQXUAXUMGVWNXUJVWPXUAXUMLVWRXUJVWP
      UPZXUAWYSVWATIXUMXUOVVTWYSVVNNVWLVWPVVTRPWXLVYKVWPUPZVVTXUPVWTVXAVXBVXCVW
      LVWPVXANVXFYEVXGVAVCUWJZXUOWYSXUOWWSVVNWXMWWSVKPZVWLVWPWXMWUJWXOXURUSWXRM
      WVIUWMVAZUWNWXMVWLVWPUWOUWPZVCZVWLVVNRPWXMVWPVVNUWQUWRXUOVVNVWLVWPVXDWXMV
      XHYEZXJUWSXUOWYSVWAXVAVWLVWPVWQWXMVXIYEUWTYHVDUXAXUJVVQXULGXUMXUJWYSWXMWW
      SRPZVWLWYSRPWXMWWSXUSVCZWWSVVNXIVMUXBUXCXSVVQGVWAXUKXULXUMVWBGWYSTYBVWBVW
      AWYSTYBUXDUXEXUJVWLXUBWPPZXUFXUBLZWXMVWLUXFZVVQGXUAYFVVTWYTTWKZYGZDKXUBWP
      XUCXUCVGZYIZYJXUJXUGVWBWYSTXUJVWLVWBWPPXUGVWBLXVGVVQGVWAYFVVTVVNHWKYGDKVW
      BWPVWCVXJYIYJWJXLUXGXUIXUEDEKXUIEYKDXUDWYODKXUBVWFYLZDVWGWYNTDKVWBVWFYLDT
      YMDWYNYMUXHYNDEWOZXUFXUDXUHWYOVVNVWFXUCYOZXVMXUGVWGWYSWYNTVVNVWFVWCYOVVNV
      WFWWSUIWIXKYPYQXMYRZWXMVWKUPXUDWYORXVOWXMKRVWFXUCWXMDKXUBRXUCXUJVVQGXUARV
      WMXUJVVQUPURQVWNXUJVWPXUARPVWRXUOVVTWYTXUQXUOWYTXUOWYSVVNXUTXVBVBVCUXIVDV
      EXVJVHVIZUXLWXMFXUCGUBZWWTGXVQOZFIZWWTUEWXMWWTEXUCGGKUMGKPZWXMUXJQXVPWXMF
      XUCGMFIZUBZFXUCMUBZWWTUEXWAMLXWBXWCLUXKFXUCXWAMUXMYSWXMXWCFDSVVPGXUAUJZUK
      ZMUBZWWTUEWXMFEXUCXWEMWVKWXMXFQVWFMUXNOPWXMVWFSPXUDVWFXWEOZLZVWFUXOWXMXWH
      ESWXMXUFVVNXWEOZLZDSYDZXWHESYDXWKWXMXWJDSVXDXUBXWDXUFXWIVXDVVQVVPGXUAVXDV
      VPVVQVXDVWOVVPVVQVSVXDVVNGVVNUXPUXQVVOVVPUXRVOUXSUXTVXDVWLXVEXVFWWBXVIXVK
      YJVXDXWDWPPXWIXWDLVVPGXUAYFXVHYGDSXWDWPXWEXWEVGZYIUYAXLUYCQXWJXWHDESXWJEY
      KDXUDXWGXVLDSXWDVWFYLYNXVMXUFXUDXWIXWGXVNVVNVWFXWEYOYPYQXMYRUYBUYDWXMXVCW
      WSUYEOZMWCJXWFWWTUEJXVDWXMXWMWWSMWCWXMWVIMWXRWYDWYEUYMWXMWUJWVIXPPWWSMWCJ
      USWXQMWVIUYFVAUYGWWSDXWEXWLUYHXCUYGUYIUYJWXMXVSWWTGFIWWTXVRGWWTFXVRGXUCOZ
      GVWIXVRXWNLUOFXUCGUYKYSXVTXWNGLUXJDGXUBGKXUCVVOVVPXUBGLVVQGXUAUYLUYNXVJYF
      WLYSVUBUYOWXMWWTWXMWWTWXMXURWWTVKPXUSWWSUYPVOVCUYQUYRUYSUYTVUAYHWYMWXJVWH
      LNXTUAMWXFVWHWXBWXGWXCMLZKWXEVWGEXWOVWKUPZWXEVWGMTIZVWGXWPWXDMVWGTXWOVWKW
      XDMVWFUIIZMWXCMVWFUIYBVWKVWFUNPXWRMLVWFVUCVWFVUDVOVUEWNVWKXWQVWGLXWOVWKVW
      GKRVWFVWCKRVWCYTVXKVUFVUGXRVFYHVUHWXKKVWGEVUIWLWSVUNNXQMWXCUGUIIFIRVUJGVU
      KIVULZPUARVUMZVVEZWXHXOMXXAOZWXAVVMUENXWTRMXXAWXHMSWQWVLXXAXWTRVUOIPZNUAX
      WSXWTXWSVGZXWTVGZVUPZQNSWXBWXHYTWXBXWTVUQSXWTWXHYTWYHWXBVKXWTVURUAXWSXWTX
      XDXXEVUSZVUTZSWXBXWTWXHVVAYJWYLMXWTPZNVKXWTMXXGUSVVBZQYANADSXWTWWSVVNXQOZ
      WWTWXHXXAWXMWXBXWTWWSXXHWYFVVCWYQNXXADXWTVVNXXAOZUKDXWTXXKUKNDXWTRXXAXXCX
      WTRXXAYTNXXFXWTRXXAVVDWSVVFDXWTXXLXXKVVNXWTXQVVGVVHVVIVVNWWSXQYOYCNXXBMXQ
      OZVVMXXIXXBXXMLNXXJMXWTXQVVGWSVVJVVIVUNVWHVVMWXAVVKXCUYSVUFVVMDABVWCCVXJU
      CUDHWKXNVVL $.
  $}

  ${
    $d k n $.
    $( The Leibniz formula for ` pi ` .  This version of ~ leibpi looks nicer
       but does not assert that the series is convergent so is not as
       practically useful.  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    leibpisum $p |- sum_ n e. NN0 ( ( -u 1 ^ n ) / ( ( 2 x. n ) + 1 ) ) =
      ( pi / 4 ) $=
      ( vk cn0 c1 cv cexp co c2 cmul caddc cdiv wceq wtru cc0 wcel oveq2 adantl
      a1i cr mpan cneg csu cpi c4 cmpt nn0uz cz 0z cfv oveq1d oveq12d eqid ovex
      fvmpt cc 1re renegcli reexpcl cn 2nn0 nn0mulcl nn0p1nn syl nndivred recnd
      cseq cli wbr leibpi isumclim trud ) CDUAZAEZFGZHVMIGZDJGZKGZAUBUCUDKGZLMV
      QVRABCVLBEZFGZHVSIGZDJGZKGZUEZNCUFNUGOMUHRVMCOZVMWDUIVQLMBVMWCVQCWDVSVMLZ
      VTVNWBVPKVSVMVLFPWFWAVODJVSVMHIPUJUKWDULZVNVPKUMUNQWEVQUOOMWEVQWEVNVPVLSO
      WEVNSODUPUQVLVMURTWEVOCOZVPUSOHCOWEWHUTHVMVATVOVBVCVDVEQJWDNVFVRVGVHMBWDW
      GVIRVJVK $.
  $}

  ${
    $d k n $.  $d k F $.
    log2cnv.1 $e |- F = ( n e. NN0 |-> ( 2 /
      ( ( 3 x. ( ( 2 x. n ) + 1 ) ) x. ( 9 ^ n ) ) ) ) $.
    $( Using the Taylor series for ` arctan ( _i / 3 ) ` , produce a rapidly
       convergent series for ` log 2 ` .  (Contributed by Mario Carneiro,
       7-Apr-2015.) $)
    log2cnv $p |- seq 0 ( + , F ) ~~> ( log ` 2 ) $=
      ( caddc cc0 c2 ci cdiv co c3 cfv cmul c1 cexp wcel ax-icn 3cn wceq cmin
      cc vk cseq catan clog cli wbr wtru cn0 cneg cv cmpt nn0uz cz a1i 2cn ine0
      0z divcli cabs clt 3ne0 wne absdiv mp3an absi cr cle 3re 0re ltleii absid
      3pos mp2an oveq12i eqtri 1lt3 wb recgt1 mpbi eqbrtri eqid atantayl3 oveq2
      oveq1d oveq2d oveq12d ovex fvmpt 2nn0 nn0mulcl mpan peano2nn0 syl expdivd
      neg1cn expcl sylancr cn nnexpcl nncnd nnne0d divassd expp1 expmul mp3an12
      3nn i2 oveq1i syl6eq eqtrd mulassd id expaddd sqneg ax-mp 3eqtr3d mulid2i
      ax-1cn 3eqtr2d divdiv1d 3eqtrd divcld adantl c9 mulcom sylancl nnmulcl c4
      nnmulcld 3eqtri 3eqtr2i oveq2i 3eqtr2ri fveq2i wa pm3.2i crp rpdivcl 2ne0
      elrpii sq1 nn0cn 2timesd nn0z 1exp eqtr3d nn0p1nn mulcomd eqeltrd sq3 9nn
      mul32d dmdcand eqtr4d isermulc2 trud cdm bndatandm atanval divdiri dividi
      df-4 subnegi divneg divassi divsubdir 3m1e2 3eqtr3i negsubi 4pos relogdiv
      ixi 4re 2rp 4cn divcan7 4d2e2 logcl mulassi eqtr4i divcan6 mp4an breqtri
      ) DBEUBZFGHIZGJHIZUCKZLIZFUDKZUEUWDUWHUEUFUGUWGUWEUAAUHMUIZAUJZNIZUWFFUWK
      LIZMDIZNIZUWNHIZLIZUKZBEUHULEUMOUGUQUNUWETOZUGFGUOPUPURZUNDUWREUBUWGUEUFZ
      UGUWFTOZUWFUSKZMUTUFZUXAGJPQVAURZUXCMJHIZMUTUXCGUSKZJUSKZHIZUXFGTOZJTOZJE
      VBZUXCUXIRPQVAGJVCVDUXGMUXHJHVEJVFOZEJVGUFUXHJRVHEJVIVHVLVJJVKVMVNVOMJUTU
      FZUXFMUTUFZVPUXMEJUTUFUXNUXOVQVHVLJVRVMVSVTZUWFAUWRUWRWAZWBVMUNUAUJZUHOZU
      XRUWRKZTOUGUXSUXTGFUXRLIZMDIZJUYBNIZLIZHIZTUXSUXTUWJUXRNIZUWFUYBNIZUYBHIZ
      LIZGUYCUYBLIZHIZUYEAUXRUWQUYIUHUWRUWKUXRRZUWLUYFUWPUYHLUWKUXRUWJNWCUYLUWO
      UYGUWNUYBHUYLUWNUYBUWFNUYLUWMUYAMDUWKUXRFLWCWDZWEUYMWFWFUXQUYFUYHLWGWHZUX
      SUYFUYGLIZUYBHIZGUYCHIZUYBHIUYIUYKUXSUYOUYQUYBHUXSUYOUYFGUYBNIZUYCHIZLIZU
      YFUYRLIZUYCHIZUYQUXSUYGUYSUYFLUXSGJUYBUXJUXSPUNZUXKUXSQUNZUXLUXSVAUNUXSUY
      AUHOZUYBUHOZFUHOZUXSVUEWIFUXRWJWKZUYAWLWMZWNWEZUXSUYFUYRUYCUWJTOZUXSUYFTO
      WOUWJUXRWPWKZUXSUXJVUFUYRTOPVUIGUYBWPWQUXSUYCUXSJWROZVUFUYCWROXFVUIJUYBWS
      WQZWTZUXSUYCVUNXAZXBZUXSVUAGUYCHUXSVUAUYFUYFGLIZLIUYFUYFLIZGLIZGUXSUYRVUR
      UYFLUXSUYRGUYANIZGLIZVURUXSUXJVUEUYRVVBRPVUHGUYAXCWQUXSVVAUYFGLUXSVVAGFNI
      ZUXRNIZUYFUXJVUGUXSVVAVVDRPWIGFUXRXDXEVVCUWJUXRNXGXHXIWDXJWEUXSUYFUYFGVUL
      VULVUCXKUXSVUTMGLIGUXSVUSMGLUXSUWJUXRUXRDIZNIZVUSMUXSUWJUXRUXRVUKUXSWOUNU
      XSXLZVVGXMUXSUWJUYANIZMUXRNIZVVFMUXSVVHUWJFNIZUXRNIZVVIVUKVUGUXSVVHVVKRWO
      WIUWJFUXRXDXEVVJMUXRNVVJMFNIZMMTOZVVJVVLRXRMXNXOUUAVOXHXIUXSUYAVVEUWJNUXS
      UXRUXRUUBUUCWEUXSUXRUMOVVIMRUXRUUDUXRUUEWMXPUUFWDGPXQXIXSZWDXSWDUXSUYFUYG
      UYBVULUXSUXBVUFUYGTOUXEVUIUWFUYBWPWQUXSUYBUXSVUEUYBWROZVUHUYAUUGWMZWTZUXS
      UYBVVPXAZXBZUXSGUYCUYBVUCVUOVVQVUPVVRXTXPUXSUYJUYDGHUXSUYCUYBVUOVVQUUHWEY
      AUXSGUYDVUCUXSUYDUXSUYBUYCVVPVUNYIZWTUXSUYDVVTXAYBUUIYCUXSUXRBKZUWEUXTLIZ
      RUGUXSVWAFJUYBLIZYDUXRNIZLIZHIZVWBAUXRFJUWNLIZYDUWKNIZLIZHIVWFUHBUYLVWIVW
      EFHUYLVWGVWCVWHVWDLUYLUWNUYBJLUYMWEUWKUXRYDNWCWFWECFVWEHWGWHUXSVWBUWEGVWE
      HIZLIZVWJUWELIZVWFUXSUXTVWJUWELUXSUXTUYIGJVWDLIZUYBLIZHIZVWJUYNUXSUYPGVWM
      HIZUYBHIUYIVWOUXSUYOVWPUYBHUXSUYOUYTVUBVWPVUJVUQUXSVUAGUYCVWMHVVNUXSUYCJU
      YANIZJLIZVWDJLIZVWMUXSUXKVUEUYCVWRRQVUHJUYAXCWQUXSVWQVWDJLUXSVWQJFNIZUXRN
      IZVWDUXKVUGUXSVWQVXARQWIJFUXRXDXEVWTYDUXRNUUJXHXIWDUXSVWDTOUXKVWSVWMRUXSV
      WDYDWROUXSVWDWROZUUKYDUXRWSWKZWTZQVWDJYEYFYAWFXSWDVVSUXSGVWMUYBVUCUXSVWMU
      XSVUMVXBVWMWROXFVXCJVWDYGWQZWTVVQUXSVWMVXEXAVVRXTXPUXSVWNVWEGHUXSJVWDUYBV
      UDVXDVVQUULWEYAWEUXSVWJTOUWSVWLVWKRUXSGVWEVUCUXSVWEUXSVWCVWDUXSVUMVVOVWCW
      ROXFVVPJUYBYGWQVXCYIZWTZUXSVWEVXFXAZYBUWTVWJUWEYEYFUXSFGVWEFTOZUXSUOUNVUC
      VXGGEVBZUXSUPUNVXHUUMXSUUNYCUUOUUPUWHUWEGFHIZLIZUWILIZMUWILIUWIUWHUWEVXKU
      WILIZLIVXMUWGVXNUWELUWGVXKMGUWFLIZSIZUDKZMVXODIZUDKZSIZLIZVXNUWFUCUUQOZUW
      GVYARUXBUXDVYBUXEUXPUWFUURVMUWFUUSXOVXTUWIVXKLVXTYHJHIZUDKZFJHIZUDKZSIZVY
      CVYEHIZUDKZUWIVXQVYDVXSVYFSVXPVYCUDVYCMUXFDIZMUXFUIZSIVXPVYCJMDIZJHIJJHIZ
      UXFDIVYJYHVYLJHUVBXHJMJQXRQVAUUTVYMMUXFDJQVAUVAZXHYJMUXFXRMJXRQVAURZUVCVY
      KVXOMSVYKUWJJHIZGGLIZJHIVXOVVMUXKUXLVYKVYPRXRQVAMJUVDVDVYQUWJJHUVLXHGGJPP
      QVAUVEYKZYLYMYNVXRVYEUDVYEMUXFSIZMVYKDIVXRJMSIZJHIZVYMUXFSIZVYEVYSUXKVVMU
      XKUXLYOZWUAWUBRQXRUXKUXLQVAYPZJMJUVFVDVYTFJHUVGXHVYMMUXFSVYNXHUVHMUXFXRVY
      OUVIVYKVXOMDVYRYLYMYNVNVYCYQOZVYEYQOZVYIVYGRYHYQOJYQOZWUEYHUVMUVJYTJVHVLY
      TZYHJYRVMFYQOWUGWUFUVNWUHFJYRVMVYCVYEUVKVMVYHFUDVYHYHFHIZFYHTOVXIFEVBZYOW
      UCVYHWUIRUVOVXIWUJUOYSYPWUDYHFJUVPVDUVQVOYNYKYLVOYLUWEVXKUWIUWTGFPUOYSURV
      XIWUJUWITOUOYSFUVRVMZUVSUVTVXLMUWILVXIWUJUXJVXJVXLMRUOYSPUPFGUWAUWBXHUWIW
      UKXQYJUWC $.
  $}

  ${
    $d k n N $.
    $( Bound the error term in the series of ~ log2cnv .  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    log2tlbnd $p |- ( N e. NN0 -> ( ( log ` 2 ) - sum_ n e. ( 0 ... ( N - 1 ) )
      ( 2 / ( ( 3 x. ( ( 2 x. n ) + 1 ) ) x. ( 9 ^ n ) ) ) ) e. ( 0 [,]
       ( 3 / ( ( 4 x. ( ( 2 x. N ) + 1 ) ) x. ( 9 ^ N ) ) ) ) ) $=
      ( cn0 wcel c2 cc0 c1 co c3 cmul c9 cdiv c4 a1i cr cn sylancr wbr cc c8 vk
      clog cfv cmin cfz cv caddc cexp csu cuz cicc cmpt nn0uz cz 0z wceq oveq1d
      oveq2 oveq2d oveq12d eqid ovex fvmpt adantl wa 2re 3nn 2nn0 simpr nn0p1nn
      nn0mulcl syl nnmulcl 9nn nnexpcl nnmulcld nndivre recnd cseq cli isumclim
      log2cnv cdm seqex fvex breldm mp1i isumsplit eqtr3d elfznn0 sylan2 fsumcl
      fzfid nn0z eluznn0 syldan eqeltrd iserex mpbid isumrecl pncan2d eqtrd cle
      clt nn0ge0i nnred nngt0d divge0 9re recni wne nnne0i exprecd adantr nncnd
      id nnne0d divdiv1d nn0red wb lemul2 syl112anc 3re 0re mp2an oveq1i ax-1cn
      mpan eqtri eqtr3i divcli divne0i breqtrd eqtr4d 3cn 4cn 2cn 4nn 3ne0 2ne0
      syl22anc isumge0 divrecd 3eqtr2d eluzle nn0re 2pos leadd1dd lemul1 lediv2
      1re 3pos syl222anc rereccli cabs 9pos recgt0ii ltleii 1lt9 recgt1i simpri
      absid eqbrtri geolim2 dividi divsubdir mp3an df-9 8re pncan 8nn divdiv32d
      pm3.2i recdiv mp4an syl5eq 3eqtrd expcl isermulc2 isumle divdivdivi 3t3e9
      4t2e8 oveq12i oveq2i divcan2i divmuldivd mulassd 3eqtr4a elicc2 mpbir3and
      w3a ) BCDZEUBUCZFBGUDHZUEHZEIEAUFZJHZGUGHZJHZKUWQUHHZJHZLHZAUIZUDHZBUJUCZ
      UXCAUIZFIMEBJHZGUGHZJHZKBUHHZJHZLHZUKHZUWMUXEUXDUXGUGHZUXDUDHUXGUWMUWNUXO
      UXDUDUWMCUXCAUIUWNUXOUWMUXCUWNAUACEIEUAUFZJHZGUGHZJHZKUXPUHHZJHZLHZULZFCU
      MFUNDUWMUONUWQCDZUWQUYCUCZUXCUPZUWMUAUWQUYBUXCCUYCUXPUWQUPZUYAUXBELUYGUXS
      UWTUXTUXAJUYGUXRUWSIJUYGUXQUWRGUGUXPUWQEJURUQUSUXPUWQKUHURUTUSUYCVAZEUXBL
      VBVCZVDZUWMUYDVEZUXCUYKEODZUXBPDUXCODZVFUYKUWTUXAUYKIPDZUWSPDZUWTPDZVGUYK
      UWRCDZUYOUYKECDZUYDUYQVHUWMUYDVIZEUWQVKZQUWRVJVLZIUWSVMQZUYKKPDZUYDUXAPDZ
      VNUYSKUWQVOZQZVPZEUXBVQQZVRZUGUYCFVSZUWNVTRZUWMUAUYCUYHWBZNWAUWMUXCAUYCFB
      UXFCUMUXFVAZUWMXPZUYJVUIVUKVUJVTWCZDZUWMVULVUJUWNVTUGUYCFWDEUBWEWFWGZWHWI
      UQUWMUXDUXGUWMUWPUXCAUWMFUWOWMUWQUWPDUWMUYDUXCSDUWQUWOWJVUIWKWLUWMUXGUWMU
      XCAUYCBUXFVUMBWNZUWMUWQUXFDZVEZUYDUYFUWQBWOZUYIVLZUWMVUSUYDUYMVVAVUHWPZUW
      MVUPUGUYCBVSVUODVUQUWMAUYCFBCUMVUNUYKUYEUXCSUYJVUIWQWRWSZWTZVRXAXBUWMUXGU
      XNDZUXGODZFUXGXCRZUXGUXMXCRZVVEUWMUXCAUYCBUXFVUMVURVVBVVCVVDUWMVUSUYDFUXC
      XCRZVVAUYKUYLFEXCRZUXBODZFUXBXDRZVVJUYLUYKVFNZVVKUYKEVHXENUYKUXBVUGXFZUYK
      UXBVUGXGZEUXBXHUUAWPUUBUWMUXGUXFEIUXIJHZUXAJHZLHZAUIUXMXCUWMUXCVVSAUYCUAC
      EVVQLHZGKLHZUXPUHHZJHZULZBUXFVUMVURVVBVVCUWMVUSUYDUWQVWDUCZVVSUPVVAUYKVWE
      VVTVWAUWQUHHZJHZVVSUYDVWEVWGUPZUWMUAUWQVWCVWGCVWDUYGVWBVWFVVTJUXPUWQVWAUH
      URZUSVWDVAVVTVWFJVBVCZVDUYKVWGVVTGUXALHZJHVVTUXALHVVSUYKVWFVWKVVTJUYKKUWQ
      KSDZUYKKXIXJZNKFXKZUYKKVNXLZNUYDUWQUNDUWMUWQWNVDXMUSUYKVVTUXAUWMVVTSDUYDU
      WMVVTUWMUYLVVQPDZVVTODVFUWMUYNUXIPDZVWPVGUWMUXHCDZVWQUYRUWMVWRVHEBVKYHZUX
      HVJVLZIUXIVMQZEVVQVQQVRZXNUYKUXAVUFXOZUYKUXAVUFXQZUUCUYKEVVQUXAUYKEVVNVRU
      YKVVQUWMVWPUYDVXAXNZXOVXCUYKVVQVXEXQVXDXRUUDXBWPZUWMVUSUYDVVSODZVVAUYKUYL
      VVRPDZVXGVFUYKVVQUXAVXEVUFVPZEVVRVQQWPZVUTVVRUXBXCRZUXCVVSXCRZVUTVVQUWTXC
      RZVXKVUTUXIUWSXCRZVXMVUTUXHUWRGVUTUXHUWMVWRVUSVWSXNXSVUTUWRVUTUYRUYDUYQVH
      VVAUYTQXSGODVUTUUKNVUTBUWQXCRZUXHUWRXCRZVUSVXOUWMBUWQUUEVDVUTBODZUWQODUYL
      FEXDRZVXOVXPXTUWMVXQVUSBUUFXNVUTUWQVVAXSUYLVUTVFNZVXRVUTUUGNZBUWQEYAYBWSU
      UHVUTUXIODUWSODIODZFIXDRZVXNVXMXTVUTUXIUWMVWQVUSVWTXNXFVUTUWSUWMVUSUYDUYO
      VVAVUAWPXFVYAVUTYCNVYBVUTUULNUXIUWSIYAYBWSVUTVVQODUWTODUXAODFUXAXDRVXMVXK
      XTVUTVVQUWMVWPVUSVXAXNXFVUTUWTUWMVUSUYDUYPVVAVUBWPXFVUTUXAVUTVUCUYDVUDVNV
      VAVUEQZXFVUTUXAVYCXGVVQUWTUXAUUIYBWSVUTVVRODFVVRXDRVVLVVMUYLVXRVXKVXLXTVU
      TVVRUWMVUSUYDVXHVVAVXIWPZXFVUTVVRVYDXGUWMVUSUYDVVLVVAVVOWPUWMVUSUYDVVMVVA
      VVPWPVXSVXTVVRUXBEUUJUUMWSVVDUWMUGVWDBVSZVVTKTUXKJHLHZJHZVTRVYEVUODUWMVYF
      VVTAUACVWBULZVWDBUXFVUMVURVXBUWMUGVYHBVSVWABUHHZGVWAUDHZLHZVYFVTUWMVWAAVY
      HBVWASDZUWMVWAKXIVWOUUNZXJZNVWAUUOUCZGXDRUWMVYOVWAGXDVWAODFVWAXCRVYOVWAUP
      VYMFVWAYDVYMKXIUUPUUQUURVWAUVBYEFVWAXDRZVWAGXDRZKODGKXDRVYPVYQVEXIUUSKUUT
      YEUVAUVCNVUNVUTUYDUWQVYHUCZVWFUPVVAUAUWQVWBVWFCVYHVWIVYHVAVWAUWQUHVBVCVLZ
      UVDUWMVYKGUXKLHZTKLHZLHGWUALHZUXKLHZVYFUWMVYIVYTVYJWUALUWMKBVWLUWMVWMNZVW
      NUWMVWONVURXMVYJWUAUPUWMKKLHZVWAUDHZVYJWUAWUEGVWAUDKVWMVWOUVEYFKGUDHZKLHZ
      WUFWUAVWLGSDZVWLVWNVEWUHWUFUPVWMYGVWLVWNVWMVWOUVMKGKUVFUVGWUGTKLWUGTGUGHZ
      GUDHZTKWUJGUDUVHYFTSDZWUIWUKTUPTUVIXJZYGTGUVJYEYIYFYJYJNUTUWMGUXKWUAWUIUW
      MYGNUWMUXKVUCUWMUXKPDVNKBVOYHZXOZWUASDUWMTKWUMVWMVWOYKNUWMUXKWUNXQZWUAFXK
      UWMTKWUMVWMTUVKXLZVWOYLNUVLUWMWUCKTLHZUXKLHZVYFWUBWURUXKLWULTFXKZVWLVWNWU
      BWURUPWUMWUQVWMVWOTKUVNUVOYFUWMKTUXKWUDWULUWMWUMNWUOWUTUWMWUQNWUPXRZUVPUV
      QYMVUTVYRVWFSVYSVUTVYLUYDVWFSDVYNVVAVWAUWQUVRQWQVUTVWEVWGVVTVYRJHVUTUYDVW
      HVVAVWJVLVUTVYRVWFVVTJVYSUSYNUVSZVYEVYGVTUGVWDBWDVVTVYFJVBWFVLUVTUWMVVSUX
      MAVWDBUXFVUMVURVXFVUTVVSVXJVRUWMVYEVYGUXMVTWVBUWMEILHZWURJHZUXIUXKJHZLHZI
      MLHZWVELHZVYGUXMWVDWVGWVELWVCWVGWVCLHZJHWVDWVGWVIWURWVCJWVIIIJHZMEJHZLHWU
      RIMEIYOYPYQYOMYRXLZYSYTUWAWVJKWVKTLUWBUWCUWDYIUWEWVGWVCIMYOYPWVLYKEIYQYOY
      SYKZEIYQYOYTYSYLUWFYJYFUWMWVCUXILHZWUSJHVYGWVFUWMWVNVVTWUSVYFJUWMEIUXIESD
      UWMYQNISDUWMYONZUWMUXIVWTXOZIFXKUWMYSNUWMUXIVWTXQZXRWVAUTUWMWVCUXIWURUXKW
      VCSDUWMWVMNWVPWURSDUWMKTVWMWUMWUQYKNWUOWVQWUPUWGWIUWMUXMIMWVEJHZLHWVHUWMU
      XLWVRILUWMMUXIUXKMSDUWMYPNZWVPWUOUWHUSUWMIMWVEWVOWVSUWMWVEUWMUXIUXKVWTWUN
      VPZXOMFXKUWMWVLNUWMWVEWVTXQXRYNUWIYMWAYMUWMFODUXMODZVVFVVGVVHVVIUWLXTYDUW
      MVYAUXLPDWWAYCUWMUXJUXKUWMMPDVWQUXJPDYRVWTMUXIVMQWUNVPIUXLVQQFUXMUXGUWJQU
      WKWQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         The Birthday Problem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    log2ublem1.1 $e |- ( ( ( 3 ^ 7 ) x. ( 5 x. 7 ) ) x. A ) <_ B $.
    log2ublem1.2 $e |- A e. RR $.
    log2ublem1.3 $e |- D e. NN0 $.
    log2ublem1.4 $e |- E e. NN $.
    log2ublem1.5 $e |- B e. NN0 $.
    log2ublem1.6 $e |- F e. NN0 $.
    log2ublem1.7 $e |- C = ( A + ( D / E ) ) $.
    log2ublem1.8 $e |- ( B + F ) = G $.
    log2ublem1.9 $e |- ( ( ( 3 ^ 7 ) x. ( 5 x. 7 ) ) x. D ) <_ ( E x. F ) $.
    $( Lemma for ~ log2ub .  The proof of ~ log2ub , which is simply the
       evaluation of ~ log2tlbnd for ` N = 4 ` , takes the form of the addition
       of five fractions and showing this is less than another fraction.  We
       could just perform exact arithmetic on these fractions, get a large
       rational number, and just multiply everything to verify the claim, but
       as anyone who uses decimal numbers for this task knows, it is often
       better to pick a common denominator ` d ` (usually a large power of
       ` 10 ` ) and work with the closest approximations of the form ` n / d `
       for some integer ` n ` instead.  It turns out that for our purposes it
       is sufficient to take ` d = ( 3 ^ 7 ) x. 5 x. 7 ` , which is also nice
       because it shares many factors in common with the fractions in
       question.  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    log2ublem1 $p |- ( ( ( 3 ^ 7 ) x. ( 5 x. 7 ) ) x. C ) <_ G $=
      ( c7 co cmul wcel c3 cexp c5 cdiv caddc cle wbr cn cn0 7nn0 nnexpcl mp2an
      3nn 5nn 7nn nnmulcli nncni nn0cni nnne0i divassi cr cc0 wa 3nn0 nn0expcli
      clt wb nn0mulcli nn0rei nnrei nngt0i pm3.2i ledivmul mp3an mpbir eqbrtrri
      5nn0 remulcli nndivre le2addi oveq2i recni adddii eqtr2i 3brtr3i ) UAQUBR
      ZUCQSRZSRZASRZWHDEUDRZSRZUERZBFUERZWHCSRZGUFWIBUFUGWKFUFUGWLWMUFUGHWHDSRZ
      EUDRZWKFUFWHDEWHWFWGUAUHTQUITWFUHTUMUJUAQUKULUCQUNUOUPUPZUQZDJUREKUQEKUSU
      TWPFUFUGZWOEFSRUFUGZPWOVATFVATEVATZVBEVFUGZVCWSWTVGWOWHDWFWGUAQVDUJVEUCQV
      QUJVHVHJVHVIFMVIZXAXBEKVJEKVKVLWOFEVMVNVOVPWIWKBFWHAWHWQVJZIVRWHWJXDDVATE
      UHTWJVATDJVIKDEVSULZVRBLVIXCVTULWNWHAWJUERZSRWLCXFWHSNWAWHAWJWRAIWBWJXEWB
      WCWDOWE $.
  $}

  ${
    $d n K $.  $d n N $.
    log2ublem2.1 $e |- ( ( ( 3 ^ 7 ) x. ( 5 x. 7 ) ) x. sum_ n e. ( 0 ... K )
      ( 2 / ( ( 3 x. ( ( 2 x. n ) + 1 ) ) x. ( 9 ^ n ) ) ) ) <_ ( 2 x. B ) $.
    log2ublem2.2 $e |- B e. NN0 $.
    log2ublem2.3 $e |- F e. NN0 $.
    log2ublem2.4 $e |- N e. NN0 $.
    log2ublem2.5 $e |- ( N - 1 ) = K $.
    log2ublem2.6 $e |- ( B + F ) = G $.
    log2ublem2.7 $e |- M e. NN0 $.
    log2ublem2.8 $e |- ( M + N ) = 3 $.
    log2ublem2.9 $e |- ( ( 5 x. 7 ) x. ( 9 ^ M ) ) =
      ( ( ( 2 x. N ) + 1 ) x. F ) $.
    $( Lemma for ~ log2ub .  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    log2ublem2 $p |- ( ( ( 3 ^ 7 ) x. ( 5 x. 7 ) ) x. sum_ n e. ( 0 ... N )
      ( 2 / ( ( 3 x. ( ( 2 x. n ) + 1 ) ) x. ( 9 ^ n ) ) ) ) <_ ( 2 x. G ) $=
      ( co c2 c3 cmul cc0 cfz cv c1 caddc c9 cexp cdiv csu cr wcel fzfid wa cn0
      wtru elfznn0 adantl cn 2re 3nn 2nn0 nn0mulcl mpan nn0p1nn nnmulcl sylancr
      syl nnexpcl nnmulcld nndivre fsumrecl trud nn0mulcli ax-mp nnmulcli mp2an
      9nn cmin wceq cuz cfv nn0uz eleqtri a1i recnd oveq2 oveq1d oveq2d oveq12d
      cc fsumm1 oveq2i sumeq1i oveq1i eqtri 2cn nn0cni adddii eqtr3i c7 cle 7nn
      nnnn0i 5nn nnrei remulcli leidi nncni mulcomi addcomi expadd mp3an mul12i
      c5 3eqtri c6 df-7 3cn 6nn0 expp1 expmul sq3 3eqtr3i mulassi mul32i mulcli
      3t2e6 3eqtr4i breqtri log2ublem1 ) UAEUBQZRSRBUCZTQZUDUEQZTQZUFYLUGQZTQZU
      HQZBUIZRATQZUAGUBQZYRBUIZRSRGTQZUDUEQZTQZUFGUGQZTQZRCTQZRDTQZHYSUJUKUOYKY
      RBUOUAEULUOYLYKUKZUMYLUNUKZYRUJUKZUUJUUKUOYLEUPUQUUKRUJUKYQURUKUULUSUUKYO
      YPUUKSURUKZYNURUKZYOURUKUTUUKYMUNUKZUUNRUNUKZUUKUUOVARYLVBVCYMVDVGSYNVEVF
      UFURUKZUUKYPURUKVQUFYLVHVCVIRYQVJVFZVGVKVLVAUUEUUFSUUDUTUUCUNUKUUDURUKRGV
      AKVMUUCVDVNZVOUUQGUNUKZUUFURUKVQKUFGVHVPZVOZRAVAIVMRCVAJVMUUBUAGUDVRQZUBQ
      ZYRBUIZRUUGUHQZUEQZYSUVFUEQUUBUVGVSUOYRUVFBUAGGUAVTWAZUKUOGUNUVHKWBWCWDUO
      YLUUAUKZUMUUKYRWJUKUVIUUKUOYLGUPUQUUKYRUURWEVGYLGVSZYQUUGRUHUVJYOUUEYPUUF
      TUVJYNUUDSTUVJYMUUCUDUEYLGRTWFWGWHYLGUFUGWFWIWHWKVLUVEYSUVFUEUVDYKYRBUVCE
      UAUBLWLWMWNWORACUEQZTQYTUUHUEQUUIRACWPAIWQCJWQZWRUVKDRTMWLWSSWTUGQZXNWTTQ
      ZTQZRTQZUVPUUGUUHTQZXAUVPUVORUVOUVMUVNUUMWTUNUKUVMURUKUTWTXBXCSWTVHVPZXNW
      TXDXBVOZVOXEUSXFXGRUVOTQRUUGCTQZTQUVPUVQUVOUVTRTSUFSUGQZUVNTQZTQZSUUFUUDC
      TQZTQZTQZUVOUVTUWBUWESTUWBUUFUVNUFFUGQZTQZTQZUWEUWBUVNUWATQUVNUUFUWGTQZTQ
      UWIUWAUVNUWAUUQSUNUKZUWAURUKVQSUTXCZUFSVHVPXHZUVNUVSXHZXIUWAUWJUVNTUWAUFG
      FUEQZUGQZUWJSUWOUFUGFGUEQSUWOOFGFNWQGKWQXJWSWLUFWJUKUUTFUNUKZUWPUWJVSUFVQ
      XHKNUFGFXKXLWOWLUVNUUFUWGUWNUUFUVAXHZUWGUUQUWQUWGURUKVQNUFFVHVPXHXMXOUWHU
      WDUUFTPWLWOWLUVOSUWATQZUVNTQUWCUVMUWSUVNTUVMSXPUDUEQZUGQZUWASTQZUWSWTUWTS
      UGXQWLUXASXPUGQZSTQZUXBSWJUKZXPUNUKUXAUXDVSXRXSSXPXTVPUXCUWASTSRSTQZUGQZS
      RUGQZSUGQZUXCUWAUXEUUPUWKUXGUXIVSXRVAUWLSRSYAXLUXFXPSUGUXFSRTQXPRSWPXRXIY
      GWOWLUXHUFSUGYBWNYCWNWOUWASUWMXRXIXOWNSUWAUVNXRUWMUWNYDWOUVTSUUFTQZUUDTQZ
      CTQUXJUWDTQUWFUUGUXKCTSUUDUUFXRUUDUUSXHZUWRYEWNUXJUUDCSUUFXRUWRYFUXLUVLYD
      SUUFUWDXRUWRUUDCUXLUVLYFYDXOYHWLUVORUVMUVNUVMUVRXHUWNYFWPXIUUGRCUUGUVBXHW
      PUVLXMYHYIYJ $.
  $}

  ${
    $( Lemma for ~ log2ub .  In decimal, this is a proof that the first four
       terms of the series for ` log 2 ` is less than
       ` 5 3 0 5 6 / 7 6 5 4 5 ` .  (Contributed by Mario Carneiro,
       17-Apr-2015.) $)
    log2ublem3 $p |- ( ( ( 3 ^ 7 ) x. ( 5 x. 7 ) ) x. sum_ n e. ( 0 ... 3 )
      ( 2 / ( ( 3 x. ( ( 2 x. n ) + 1 ) ) x. ( 9 ^ n ) ) ) ) <_
       ; ; ; ; 5 3 0 5 6 $=
      ( c3 c7 co c5 cmul cc0 c2 c1 caddc c9 c6 cdc c4 eqtri 2nn0 5nn0 1nn0 eqid
      deccl cexp cfz cv cdiv csu c8 cle cmin 0le0 c0 clt wbr wceq wcel 0re ltm1
      cr ax-mp cz wb 0z peano2zm fzn mp2an mpbi sumeq1i sum0 oveq2i cc cn0 7nn0
      3cn expcl 5nn nncni 7nn mulcli mul01i 3brtr4i 0nn0 nn0cni addid2i addid1i
      2cn 3nn0 mulid2i oveq1i 0p1e1 nn0mulcli 9nn0 2p1e3 8nn0 1p1e2 exp1 9t9e81
      9nn numexpp1 8nn 9t8e72 mulcomli dec0h decmul1c 7t5e35 c10 addcomli dec10
      7p3e10 ax-1cn 3p1e4 4nn0 7t3e21 4p1e5 decaddi decmac 3t2e6 oveq12i 5t2e10
      decsuc decma2c 9t3e27 7p4e11 decaddci 9t5e45 decmul2c 3eqtr4ri log2ublem2
      6p1e7 1m1e0 6nn0 5p1e6 9p5e14 decadd 5p5e10 eqtr4i mulassi mulid1i 3eqtri
      4cn df-3 2t2e4 sqvali 3t3e9 mul12i 6p3e9 2m1e1 6p6e12 addcomi 9t7e63 df-5
      decaddc2 3m1e2 5p3e8 mulcomi exp0 df-7 3eqtr4i 00id 6t2e12 dec10p breqtri
      6nn 8t2e16 ) BCUADZECFDZFDZGBUBDHBHAUCZFDIJDFDKUVFUADFDUDDZAUEFDHHLMZEMZH
      MZUFMZFDEBMZGMZEMZLMUGUVJBMZAEUVKHGBUVHNMZLMZGMZALBMZUVOIIHHEMZEMZIMZEMZA
      KNMZEMZUVRGHIGAUWCUWCGIUHDZBGGGUVEGUWFUBDZUVGAUEZFDZHGFDZUGUIUWIUVEGFDGUW
      HGUVEFUWHUJUVGAUEGUWGUJUVGAUWFGUKULZUWGUJUMZGUQUNUWKUOGUPURGUSUNZUWFUSUNZ
      UWKUWLUTVAUWMUWNVAGVBURGUWFVCVDVEVFUVGAVGOVHUVEUVCUVDBVIUNCVJUNUVCVIUNVLV
      KBCVMVDECEVNVOZCVPVOZVQZVQVROHWDVRZVSVTUWBEUWAIUVTEHEPQTZQTZRTZQTZVTUWFSU
      WCUWCUXBWAZWBWEBVLWCIUWCFDUWCUWJIJDZUWCFDUVDKBUADZFDUWCUXCWFUXDIUWCFUXDGI
      JDZIUWJGIJUWRWGWHOWGCHMZKUWBEUVDBIMZUXEECQVKWIZCHVKPTZWJKUXGKMHBWJPWKUFIU
      XGKKGKHUADZWJWLRKUFIMZIHWJRWMKIUADZKFDKKFDZUXLUXMKKFKVIUNZUXMKUMKWPVOZKWN
      URZWGWOOWQWJVTUFKFDZGJDUXGGJDUXGUXRUXGGJKUFUXGUXPUFWRVOZWSWTWGUXGUXGUXJWA
      WCOIKFDKGKMKUXPWFKWJXAOXBWQQBIWERTCHBIUVDUWAICUXGUXHVKPWERUXGSUXHSUXIRVKB
      EIGCUVTEBUVDBCJDZWEQRVTCEBEMZUWPUWOXCWTZUXTXDIGMZCBXDUWPVLXGXEXFOVKQWEBCF
      DZIBJDZJDUYDNJDUVTUYENUYDJBINVLXHXIXEZVHHIEUYDNPRXJCBHIMUWPVLXKWTZNIEYRXH
      XLXEZXMOUVDGJDUYAGJDUYAUVDUYAGJUYBWGUYAUYABEWEQTWAWCOXNBEGIHCIIUVDIWEQVTR
      UYBIRXAZPRRBHFDZUXFJDLIJDZCUYJLUXFIJXOWHXPYGOIGIEHFDZRVTWHUYLXDUYCXQXFOZX
      RXNXSBEUXHEKNUVDWJWEQUYBQXJHCIBBKFDZNPVKXJKBHCMUXPVLXTWTZWKRYAYBKENEMUXPU
      WOYCWTXBYDYEYFUXBUWDEKNWJXJTZQTRYHUWBEUWDEUVQUWCUWEUXAQUYPQUWCSUWESUVPELU
      WBUWDJDUVHNHLPYITZXJTZQYJUWAIKNUVPEUWBUWDUWTRWJXJUWBSUWDSUVTENUVHUWAKUWSQ
      WJUWASHELUVTPQYJUVTSXRXJKEINMUXPUWOYKXEYBUYHYLXRYMUUJPWKUVDUXKFDUVDBUYNFD
      ZFDZBUWEFDZHIFDZIJDZUWEFDUXKUYSUVDFUXKBBFDZKFDZUYSUXKUXNVUEKUXPUUAVUDKKFU
      UBWGYNBBKVLVLUXPYOOVHUYTBUVDUYNFDZFDVUAUVDBUYNUWQVLBKVLUXPVQUUCVUFUWEBFHC
      UWDEUVDHNMZUYNUXIPVKUYOQHNPXJTBEHNHKNIUVDVUGWEQPXJUYBVUGSPXJRUYJHIJDZJDLB
      JDKUYJLVUHBJXOWKXPUUDOIGNUYLNRVTXJUYMNYRWBXMXNBEVUGECBUVDVKWEQUYBQWEHINUY
      DBPRWEUYGUYFXMUYBXBYDVHOBVUCUWEFBVUHVUCYSVUBHIJHWDYPWGYNWGYQYFUVQGUVPLUYR
      YITZVTTLBYIWETPUUEUVQGLBUVJBUVRUVSVUIVTYIWEUVRSUVSSUVPLHUVIUVQLUYRYIYIUVQ
      SUVHNEUVPUYQXJXLUVPSXRPUUFYBBVLWBZYLRIHJDVUHBIHXHWDUUGYSYNUVDUXMFDUVDKFDZ
      EUVSFDZHHFDZIJDZUVSFDUXMKUVDFUXQVHVUKECKFDZFDVULECKUWOUWPUXPYOVUOUVSEFKCU
      VSUXPUWPUUHWTVHOEVUNUVSFENIJDZVUNUUIVUMNIJYTWGZYNWGYQYFUVJBUVIHUVHEUYQQTZ
      PTZWETQWEUUKUVJBUFUVOEVUSWEQUVOSEBUFUWOVLUULXEXMVTVUJCEFDZIFDVUTUVDKGUADZ
      FDHBFDZIJDZEFDVUTCEUWPUWOVQYPUVDVUTVVAIFECUWOUWPUUMUXOVVAIUMUXPKUUNURXPVV
      CCEFVVCUYKCVVBLIJBHLVLWDXOWTWGUUOYNWGUUPYFUVJUFUVNLHIUVKPVUSWLUVKSYIRUVIH
      GIHUVMEGUVJIVURPVTRUVJSUYIPQVTUVHEGGHUVLGIUVIGGJDZUYQQVTVTUVISVVDGGGMUUQG
      VTXAOPVTRHLGIHEBIUVHUXFPYIVTRUVHSUXFIGIMWHUYIOPWERVUMUXFJDVUPEVUMNUXFIJYT
      WHXPXLOIHBHLFDRPWKLHIHMLUVAVOWDUURWTXRXSHEFDZGJDXDGJDUYCVVEXDGJEHXDUWOWDX
      QWTWGGUUSOXSVUNVUPEGEMVUQXLEQXAYQXSUFHILMUXSWDUVBWTYDUUT $.

    $( ` log 2 ` is less than ` 2 5 3 / 3 6 5 ` .  If written in decimal, this
       is because ` log 2 = ` 0.693147... is less than 253/365 = 0.693151... ,
       so this is a very tight bound, at five decimal places.  (Contributed by
       Mario Carneiro, 7-Apr-2015.) $)
    log2ub $p |- ( log ` 2 ) < ( ; ; 2 5 3 / ; ; 3 6 5 ) $=
      ( c2 cc0 c3 co cmul c1 caddc c4 c5 cdc c6 wcel eqtri 2nn0 3nn0 5nn0 deccl
      c7 1nn0 7nn0 vn clog cfv cfz cv c9 cexp cdiv csu cle wbr clt cmin cr cicc
      w3a df-4 oveq1i wceq 3cn ax-1cn pncan mp2an oveq2i sumeq1i 4nn0 log2tlbnd
      cc cn0 ax-mp eqeltrri cn nnmulcli 9nn nnexpcl nndivre mpbi wa 3nn sylancr
      wtru 0nn0 6nn0 6p1e7 decsuc 5nn 7nn nnrei 6nn declt nncni 7t5e35 mulcomli
      eqid c8 4cn 2cn 4t2e8 3brtr4i nngt0i mulcomi 3eqtr3i mp3an mulcli mulid1i
      wb nn0rei pm3.2i 8nn0 9nn0 5p1e6 addcomli decaddi decaddci nn0cni addid1i
      2p1e3 7t3e21 decmac mul02i dec0h 7t7e49 4p1e5 5t3e15 decma 5p2e7 decmul1c
      addid2i decmul2c 3t2e6 2t2e4 oveq12i 4p3e7 7t2e14 1p1e2 decma2c nn0mulcli
      decadd mulassi lelttri 0re 3re 4nn 1nn numnncl elicc2i simp3i crp relogcl
      2rp fzfid 2re elfznn0 nn0mulcl nn0p1nn syl nnmulcl nnmulcld fsumrecl trud
      adantl lesubadd2i log2ublem3 5lt6 8p1e9 9t4e36 ltleii lemul2i mul32i df-8
      expmul eqtr3i expp1 sq3 log2ublem1 readdcli lemuldiv2 1lt10 decltc 9p4e13
      6lt7 5p3e8 3p1e4 6p5e11 9p7e16 00id 3t3e9 3exp3 8nn 8p4e12 4p4e8 numexp2x
      6p2e8 9t3e27 numexpp1 7p3e10 decaddc2 2p2e4 5t2e10 dec10 7p6e13 decaddci2
      c10 8t2e16 6p4e10 8t5e40 8t3e24 7p4e11 mulid2i nn0expcli ltmul1ii 3brtr3i
      decnncl lt2mul2div mp4an ) AUBUCZBCUDDZACAUAUEZEDZFGDZEDZUFUXRUGDZEDZUHDZ
      UAUIZCHAHEDZFGDZEDZUFHUGDZEDZUHDZGDZUJUKZUYLAIJZCJZCKJZIJZUHDZULUKZUXPUYR
      ULUKUXPUYEUMDZUYKUJUKZUYMUYTUNLZBUYTUJUKZVUAUYTBUYKUODZLVUBVUCVUAUPUXPBHF
      UMDZUDDZUYDUAUIZUMDZUYTVUDVUGUYEUXPUMVUFUXQUYDUAVUECBUDVUECFGDZFUMDZCHVUI
      FUMUQURCVHLZFVHLVUJCUSUTVACFVBVCMVDVEVDHVILZVUHVUDLVFUAHVGVJVKBUYKUYTUUAC
      UNLUYJVLLUYKUNLUUBUYHUYIHUYGUUCHFANVFUUDUUEVMZUFVLLZVULUYIVLLVNVFUFHVOVCZ
      VMZCUYJVPVCZUUFVQUUGUXPUYEUYKAUUHLUXPUNLUUJAUUIVJZUYEUNLWAUXQUYDUAWABCUUK
      WAUXRUXQLZVRZAUNLUYCVLLUYDUNLUULVUTUYAUYBVUTCVLLZUXTVLLZUYAVLLVSVUTUXSVIL
      ZVVBVUTAVILZUXRVILZVVCNVUSVVEWAUXRCUUMUVAZAUXRUUNVTUXSUUOUUPCUXTUUQVTVUTV
      UNVVEUYBVLLVNVVFUFUXRVOVTUURAUYCVPVTUUSUUTZVUQUVBVQUYLICJZBJZIJZRJZCRUGDZ
      IREDZEDZUHDZUJUKZVVOUYRULUKZUYSVVNUYLEDVVKUJUKZVVPUYEVVJKJZUYLCUYJFVVKUAU
      VCVVGOVUPVVJKVVIIVVHBICPOQZWBQZPQZWCQSUYLWNVVJKRVVSVWBWCWDVVSWNWEUYIVVMED
      ZUYIUYHEDZVVNCEDZUYJFEDZUJVVMUYHUJUKZVWCVWDUJUKZVVMUYHVVMIRWFWGVMZWHZUYHV
      UMWHZCIJZUYPVVMUYHULCIKOPWIUVDWJRIVWLRWGWKZIWFWKZWLWMZUYHHUFEDUYPUYGUFHEU
      YGWOFGDUFUYFWOFGHAWOWPWQWRWMURUVEMVDUFHUYPUFVNWKZWPUVFWMMWSUVGBUYIULUKVWG
      VWHXFUYIVUOWTVVMUYHUYIVWJVWKUYIVUOWHUVHVJVQVWEVVLCEDZVVMEDVWCVVLVVMCVVLVV
      ARVILZVVLVLLVSTCRVOVCZWKZVVMVWIWKZUTUVIVWQUYIVVMECRFGDZUGDZCAUGDZHUGDZVWQ
      UYICUYFUGDZVXCVXEUYFVXBCUGHAEDWOUYFVXBWRHAWPWQXAUVJXBVDVUKVVDVULVXFVXEUSU
      TNVFCAHUVKXCUVLVUKVWRVXCVWQUSUTTCRUVMVCVXDUFHUGUVNURXBURMVWFVWDFEDVWDUYJV
      WDFEUYHUYIUYHVUMWKZUYIVUOWKZXAURVWDUYIUYHVXHVXGXDXEMWSUVOUYLUNLVVKUNLZVVN
      UNLZBVVNULUKZVRZVVRVVPXFUYEUYKVVGVUQUVPZVVKVVJRVWBTQZXGZVXJVXKVVNVVLVVMVW
      SVWIVMZWHVVNVXPWTXHZUYLVVKVVNUVQXCVQVVKUYQEDZUYOVVNEDZULUKZVVQVVKRCJZEDZI
      EDZUYOVVLEDZREDZIEDZVXRVXSULVYBVYEULUKVYCVYFULUKCWOJZRJZCJZFJZKJZFJVYJRJZ
      RJVYBVYEULVYKVYLFRVYJKVYIFVYHCVYGRCWOOXIQTQOQSQZWCQVYJRVYMTQZSTUVRVYJKRVY
      MWCWGUWAWJUVSRCVYKFVVKFIJZUFJZFJZRJZVYAVXNTOVYAWNZSVYQRVYPFVYOUFFISPQZXJQ
      ZSQZTQVVJRVYQRRVYJKIVVKVYRVWBTWUBTVVKWNZVYRWNTWCPVVIIVYPKRVYIFHVVJVYQIGDV
      WAPWUAWCVVJWNZVYPFKVYQIWUASPVYQWNIFKVWNVAXKXLXMTSVFVVHBFKJZCRVYHCBVVIVYPH
      GDVVTWBFKSWCQZOVVIWNZVYOUFCWUEVYPHVYTXJVFVYPWNFIKVYOSPXKVYOWNWEOUVTXNTOWB
      ICFKRVYGRAVVHWUEBGDPOSWCVVHWNZWUEWUEWUFXOXPTTNVVMFAGDZGDVVMCGDZVYGWUICVVM
      GAFCWQVAXQXLZVDCIWOVVMCOPOVWOUWBXMZMAFRCREDZKNSWCRCAFJZVWMUTXRWMZKFRKWIWK
      ZVAWDXLXMXSBREDZCGDBCGDZBCJZWUQBCGRVWMXTURWURCWUSCUTYHZCOYAMZMXSCIFHVVMKO
      PWCVWOUWCSKIFFJZWUPVWNUWDXLXNXSHUFKIRREDRVFXJTYBYCWCUWEXNXSVVJRVYRFCAVVKO
      VWBTWUCSNVVIIBACVYQRFVVJAVWAPWBNWUDANYAZOTSVVHBBFCVYPFBVVIBFGDZVVTWBWBSWU
      GWVDFBFJZFVAYHZFSYAZMZOSWBICBBCVYOUFVVHBBGDZPOWBWBWUHWVIBBBJUWFBWBYAMOICE
      DZBGDVYOBGDVYOWVJVYOBGYDURVYOVYOVYTXOXPMCCEDZBGDUFBGDUFWVKUFBGUWGURUFVWPX
      PMYEBCEDZFGDWVDWVEWVLBFGCUTXTURWVHMXSFIRWVJASPNYDYFXMXSXRYGYIIIJZCJZCJZFJ
      ZFVYLRRBVYDTWVOFWVNCWVMCIIPPQZOQZOQZSQSWUNWOJZRWVPFUYOFRJZRJZVVLUYNCAINPQ
      ZOQZWUNWOAFNSQZXIQTCWVTRJKROWCWDRAJZUFWVTRCACKUGDORATNQXJCWWFUFJARJZCKOOC
      AKUTWQYJWMZUWHARWWFUFWWGFWOJZWWGARNTQNTWWGWNZXJFWOSXIQARFWOARAAWWGWWINTSX
      IWWJWWIWNNNNAAEDZWUIGDHCGDRWWKHWUICGYKWUKYLYMMFHAARAEDWOSVFXIYNYONWOHFAJW
      OUWIWKZWPUWJXLXNXSARWWIUFRHWWGTNTWWJXJVFFHWOAREDZHSVFVFRAFHJVWMWQYNWMZUWK
      XMYBYGYIUWLTNRABACWUNWOWWFATNWBNWWFWNWVCORCEDZBGDWUNBGDWUNWWOWUNBGXRURWUN
      WUNWWEXOXPMACEDZAGDKAGDWOWWPKAGWWHURUWMMYEUWNYGUWOSWWARFRSTQZTQWUNWOWWARU
      YOWVOFABJZCJZWVTWWBWWEXIWWQTWVTWNWWBWNWWDSWWRCABNWBQZOQAFAAJZBUYOWVNCUYNW
      UNWWAWWSGDNSAANNQWBWUNWNFRWWRCWXAWWAWWSSTWWTOWWAWNWWSWNAFAFWWRGDNSYOBFABA
      FFWWRWBSNWBWVGWWRWNAWQYHZFVAXPYRWEUWPUWQWWDOWWCUYNCHRAWVMCFUYOWXAUYNGDWWC
      OVFTUYOWNZAAAIHRWXAUYNNNNPWXAWNUYNWNZUWRIARVWNWQYFXLYRNOSAIBIAIIFUYNHFGDZ
      NPWBPWXDWXEIBIJYCIPYAMNPSWWKWVDGDWXEIWWKHWVDFGYKWVFYLYCMFBIIAEDZISWBPWXFU
      XCFBJUWSUWTMIVWNYHXMXSCAEDZRGDKRGDFCJZWXGKRGYJURRKWXHVWMWUPUXAXLMXSUYOFED
      ZBGDUYOBGDUYOWXIUYOBGUYOUYOWWDXOZXEURUYOWXJXPMYPUYNCBRWOWWSFCUYORWWCOWBTW
      XCRTYAZXISOAIBCWOWWRCHUYNWURNPWBOWXDWVAXIOVFAWOEDZBHGDZGDWXLHGDWWRWXMHWXL
      GHWPYHVDFKAWXLHSWCVFWOAWUEWWLWQUXDWMYOUXEUXBMHBCIWOEDCVFWBOWOIHBJWWLVWNUX
      FWMWUTXMXSAHFCCWOEDRNVFTWOCAHJWWLUTUXGWMXQSRHWVBVWMWPUXHXLXNXSYPUYNCWWBFR
      AUYOTWWCOWXCSNAIBARWWARCUYNANPWBNWXDWVCTTOWWMWURGDWWMCGDWWAWURCWWMGWUTVDF
      HRWWMCSVFOWWNYMXMMCIRVVMAOPNVWOYFXMZXSWUOYGYITWBWVPREDZBGDVYLBGDVYLWXOVYL
      BGWVOFVYJRRBWVPTWVSSWVPWNTWBWVOREDZBGDVYJBGDVYJWXPVYJBGWVNCVYIFRAWVOTWVRO
      WVOWNSNWVMCBARVYHCAWVNAWVQOWBNWVNWNWVCTONIIBARVYGRCWVMBAGDZPPWBNWVMWNWXQA
      BAJWXBWVCMTTOVVMWURGDWUJVYGWURCVVMGWUTVDWULMWXNXSAFCWUMANSNWUOWUKXMXSWUOY
      GURVYJVYJVYMXOXPMFREDRBRJRVWMUXIWXKMZYGURVYLVYLVYNXOXPMWXRYGWSVYBVYEIVYBV
      VKVYAVXNRCTOQZYQXGVYEVYDRUYOVVLWWDCROTUXJYQTYQXGIWFWHIWFWTUXKVQVYCVVKVYAI
      EDZEDVXRVVKVYAIVVKVXNXOVYAWXSXOVWNYSWXTUYQVVKERCUYPIIFVYAPTOVYSPSCIKRIEDZ
      OPXKWLWEICVYOVWNUTYDWMYGVDMVYFVYDWYAEDZVXSVYDRIUYOVVLWXJVWTXDVWMVWNYSWYBV
      YDVVMEDVXSWYAVVMVYDERIVWMVWNXAVDUYOVVLVVMWXJVWTVXAYSMMUXLVXIUYQUNLZBUYQUL
      UKZVRUYOUNLZVXLVXTVVQXFVXOWYCWYDUYQUYPICKOWCQWFUXMZWHUYQWYFWTXHUYOWWDXGZV
      XQVVKUYQUYOVVNUXNUXOVQUYLVVOUYRVXMVXIVVNVLLVVOUNLVXOVXPVVKVVNVPVCWYEUYQVL
      LUYRUNLWYGWYFUYOUYQVPVCZYTVCUXPUYLUYRVURVXMWYHYTVC $.
  $}

  ${
    $d f k n K $.  $d f k n N $.
    birthday.s $e |- S = { f | f : ( 1 ... K ) --> ( 1 ... N ) } $.
    birthday.t $e |- T = { f | f : ( 1 ... K ) -1-1-> ( 1 ... N ) } $.
    $( Lemma for ~ birthday .  (Contributed by Mario Carneiro, 17-Apr-2015.) $)
    birthdaylem1 $p |- ( T C_ S /\ S e. Fin /\ ( N e. NN -> S =/= (/) ) ) $=
      ( cfn wcel c0 wne c1 cfz co cab wceq fzfi mp2an sylbi ovex wss cn wf1 f1f
      wi cv wf ss2abi 3sstr4i cmap mapvalg eqtr4i mapfi eqeltri elfz1end eqeq1i
      ne0i map0 simplbi necon3i syl 3pm3.2i ) BAUAAHIEUBIZAJKZUELDMNZLEMNZCUFZU
      CZCOVEVFVGUGZCOZBAVHVICVEVFVGUDUHGFUIAVFVEUJNZHAVJVKFVFHIZVEHIZVKVJPLEQZL
      DQZVFVEHHCUKRULZVLVMVKHIVNVOVFVEUMRUNVCVFJKZVDVCEVFIVQEUOVFEUQSAJVFJAJPVK
      JPZVFJPZAVKJVPUPVRVSVEJKVFVELEMTLDMTURUSSUTVAVB $.

    $( For general ` N ` and ` K ` , count the fraction of injective functions
       from ` 1 ... K ` to ` 1 ... N ` .  (Contributed by Mario Carneiro,
       7-May-2015.) $)
    birthdaylem2 $p |- ( ( N e. NN /\ K e. ( 0 ... N ) ) ->
      ( ( # ` T ) / ( # ` S ) ) =
      ( exp ` sum_ k e. ( 0 ... ( K - 1 ) ) ( log ` ( 1 - ( k / N ) ) ) ) ) $=
      ( vn wcel cc0 cfz co cfv cdiv cmin c1 ce wceq syl cn chash caddc clog csu
      wa cv cmul cfa cbc wf1 cab fveq2i cfn fzfi hashf1 mp2an eqtri cn0 elfznn0
      adantl hashfz1 fveq2d nnnn0 adantr oveq12d syl5eq faccl fznn0sub divcan2d
      nncnd nnne0d divcld bcval2 divdiv1d eqtr4d oveq2d cc elfznn nnrp relogcld
      fzfid recnd fsumcl efsub syl2anc clt wbr c0 nn0red ltp1d fzdisj fznn0sub2
      cin cun cle elfzle2 cuz cz simpr nnuz syl6eleq nnz ad2antrr elfz5 fzsplit
      wb mpbird syl6eq uneq1d uncom un0 oveq1d 1e0p1 syl6eqr eqtr2d elnn0 sylib
      fz10 wo mpjaodan fsumsplit nn0p1nn elfzuz uztrn2 syl2an pncan2d wne eflog
      logfac eqtr3d 3eqtr4d eqtrd cexp syl3anc nn0cnd crp ax-1cn a1i cen eqtr4i
      cmap wf mapvalg hashmap nncn nnne0 elfzelz explog mulcld relogdiv syl2anr
      syldan sumeq2dv nn0zd peano2zd oveq1 fsumrev subidd subsubd subcl sylancl
      rpdivcld nncand divsubdird dividd sumeq12rdv fsumsub fsumconst 1z sylancr
      fzen addcom pncan3d breqtrd hasheni 3eqtr3rd 3eqtr2d ) FUAJZEKFLMZJZUFZBU
      BNZAUBNZOMFEPMZQUCMZFLMZIUGZUDNZIUEZRNZEFUDNZUHMZRNZOMZUWJUWMPMZRNZKEQPMZ
      LMZQDUGZFOMZPMZUDNZDUEZRNUWBUWCUWKUWDUWNOUWBUWCEUINZFEUJMZUHMZUWKUWBUWCQE
      LMZUBNZUINZQFLMZUBNZUXIUJMZUHMZUXGUWCUXHUXKCUGZUKCULZUBNZUXNBUXPUBHUMUXHU
      NJZUXKUNJZUXQUXNSQEUOZQFUOZUXHUXKCUPUQURUWBUXJUXEUXMUXFUHUWBUXIEUIUWBEUSJ
      ZUXIESUWAUYBUVSEFUTVAZEVBTZVCUWBUXLFUXIEUJUVSUXLFSZUWAUVSFUSJZUYEFVDZFVBT
      VEZUYDVFVFVGUWBUXEFUINZUWEUINZOMZUXEOMZUHMUYKUXGUWKUWBUYKUXEUWBUYIUYJUWBU
      YIUWBUYFUYIUAJUVSUYFUWAUYGVEZFVHTZVKZUWBUYJUWBUWEUSJZUYJUAJUWAUYPUVSEKFVI
      VAZUWEVHTZVKZUWBUYJUYRVLZVMUWBUXEUWBUYBUXEUAJUYCEVHTZVKZUWBUXEVUAVLZVJUWB
      UXFUYLUXEUHUWBUXFUYIUYJUXEUHMOMZUYLUWAUXFVUDSUVSEFVNVAUWBUYIUYJUXEUYOUYSV
      UBUYTVUCVOVPVQUWBUXKUWIIUEZQUWELMZUWIIUEZPMZRNZVUERNZVUGRNZOMZUWKUYKUWBVU
      EVRJVUGVRJVUIVULSUWBUXKUWIIUWBQFWBZUWBUWHUXKJZUFUWHUAJZUWIVRJZVUNVUOUWBUW
      HFVSVAVUOUWIVUOUWHUWHVTZWAWCZTZWDUWBVUFUWIIUWBQUWEWBUWBUWHVUFJZUFVUOVUPVU
      TVUOUWBUWHUWEVSVAVURTWDZVUEVUGWEWFUWBUWJVUHRUWBVUHVUGUWJUCMZVUGPMUWJUWBVU
      EVVBVUGPUWBVUFUWGUWIUXKIUWBUWEUWFWGWHVUFUWGWNWISUWBUWEUWBUWEUYQWJWKQUWEUW
      FFWLTUWBUWEUAJZUXKVUFUWGWOZSZUWEKSZUWBVVCUFZUWEUXKJZVVEVVGVVHUWEFWPWHZUWB
      VVIVVCUWBUWEUVTJZVVIUWAVVJUVSEFWMVAUWEKFWQTVEVVGUWEQWRNZJFWSJZVVHVVIXGVVG
      UWEUAVVKUWBVVCWTXAXBUVSVVLUWAVVCFXCZXDUWEQFXEWFXHUWEQFXFTUWBVVFUFZVVDWIUW
      GWOZUXKVVNVUFWIUWGVVNVUFQKLMWIVVNUWEKQLUWBVVFWTZVQXSXIXJVVNVVOUWGUXKVVOUW
      GWIWOUWGWIUWGXKUWGXLURVVNUWFQFLVVNUWFKQUCMQVVNUWEKQUCVVPXMXNXOXMVGXPUWBUY
      PVVCVVFXTUYQUWEXQXRYAVUMVUSYBXMUWBVUGUWJVVAUWBUWGUWIIUWBUWFFWBZUWBUWHUWGJ
      ZUFZVUOVUPUWBUWFUAJZUWHUWFWRNJVUOVVRUWBUYPVVTUYQUWEYCTUWHUWFFYDQUWHUWFUAX
      AYEYFZVURTZWDZYGXPVCUWBUYIVUJUYJVUKOUWBUYIUDNZRNZUYIVUJUWBUYIVRJUYIKYHVWE
      UYISUYOUWBUYIUYNVLUYIYIWFUWBVWDVUERUWBUYFVWDVUESUYMIFYJTVCYKUWBUYJUDNZRNZ
      UYJVUKUWBUYJVRJUYJKYHVWGUYJSUYSUYTUYJYIWFUWBVWFVUGRUWBUYPVWFVUGSUYQIUWEYJ
      TVCYKVFYLYLYMUWBUWDFEYNMZUWNUWBUWDUXLUXIYNMZVWHUWDUXKUXHUUBMZUBNZVWIAVWJU
      BAUXHUXKUXOUUCCULZVWJGUXSUXRVWJVWLSUYAUXTUXKUXHUNUNCUUDUQUUAUMUXSUXRVWKVW
      ISUYAUXTUXKUXHUUEUQURUWBUXLFUXIEYNUYHUYDVFVGUWBFVRJZFKYHZEWSJZVWHUWNSUVSV
      WMUWAFUUFVEZUVSVWNUWAFUUGVEZUWAVWOUVSEKFUUHVAZFEUUIYOYMVFUWBUWJVRJUWMVRJU
      WQUWOSVWCUWBEUWLUWBEUYCYPZUWBUWLUWBFUVSFYQJZUWAFVTVEZWAWCZUUJUWJUWMWEWFUW
      BUWPUXDRUWBUWGUWHFOMZUDNZIUEZUWGUWIUWLPMZIUEZUXDUWPUWBUWGVXDVXFIUWBVVRVUO
      VXDVXFSZVWAVUOUWHYQJZVWTVXHUWBVUQVXAUWHFUUKUULUUMUUNUWBVXEFFPMZFUWFPMZLMZ
      FUWTPMZFOMZUDNZDUEUXDUWBVXDVXOIDFUWFFUVSVVLUWAVVMVEZUWBUWEUWBUWEUYQUUOZUU
      PVXPVVSVXDVVSVXCVVSUWHFVVSVUOVXIVWAVUQTUWBVWTVVRVXAVEUVCWAWCUWHVXMSVXCVXN
      UDUWHVXMFOUUQVCUURUWBVXLUWSVXOUXCDUWBVXJKVXKUWRLUWBFVWPUUSUWBFFUWRPMZPMVX
      KUWRUWBVXRUWFFPUWBFEQVWPVWSQVRJZUWBYRYSUUTVQUWBFUWRVWPUWBEVRJVXSUWRVRJVWS
      YREQUVAUVBUVDYKVFUWBUWTUWSJZUFZVXNUXBUDVYAVXNFFOMZUXAPMUXBVYAFUWTFUWBVWMV
      XTVWPVEZVYAUWTVXTUWTUSJUWBUWTUWRUTVAYPVYCUWBVWNVXTVWQVEZUVEVYAVYBQUXAPVYA
      FVYCVYDUVFXMYMVCUVGYMUWBVXGUWJUWGUWLIUEZPMUWPUWBUWGUWIUWLIVVQVWBUWBUWLVRJ
      ZVVRVXBVEUVHUWBVYEUWMUWJPUWBVYEUWGUBNZUWLUHMZUWMUWBUWGUNJVYFVYEVYHSVVQVXB
      UWGUWLIUVIWFUWBVYGEUWLUHUWBUXIVYGEUWBUXHUWGYTWHUXIVYGSUWBUXHQUWEUCMZEUWEU
      CMZLMZUWGYTUWBQWSJZVWOUWEWSJUXHVYKYTWHVYLUWBUVJYSVWRVXQUWEQEUVLYOUWBVYIUW
      FVYJFLUWBVXSUWEVRJVYIUWFSYRUWBUWEUYQYPQUWEUVMUVKUWBEFVWSVWPUVNVFUVOUXHUWG
      UVPTUYDYKXMYMVQYMUVQVCUVR $.

    $( For general ` N ` and ` K ` , upper-bound the fraction of injective
       functions from ` 1 ... K ` to ` 1 ... N ` .  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    birthdaylem3 $p |- ( ( K e. NN0 /\ N e. NN ) -> ( ( # ` T ) / ( # ` S ) )
        <_
      ( exp ` -u ( ( ( ( K ^ 2 ) - K ) / 2 ) / N ) ) ) $=
      ( vk wcel cfv cdiv co cle wbr clt cc0 c0 c1 wb cr cn0 cn wa chash c2 cexp
      cmin cneg ce cfz cv wf1 cab wceq wne cdom wn wex abn0 ovex bitr4i hashfz1
      brdom nnnn0 syl breqan12d fzfid hashdom syl2anc nn0re nnre syl2an 3bitr3d
      cfn lenlt syl5bb necon4abid biimpar syl5eq fveq2d hash0 syl6eq oveq1d wss
      wi birthdaylem1 simp3i ad2antlr simp2i hashnncl ax-mp sylibr nncnd nnne0d
      div0d adantr resqcld resubcld rehalfcld nndivre sylancom renegcld rpefcld
      eqtrd rpge0d eqbrtrd clog csu simplr simpr cz simpll nn0uz syl6eleq elfz5
      cuz nnz mpbird birthdaylem2 elfznn0 adantl nn0red peano2rem nnred elfzle2
      crp cmul ltm1d ltletrd lelttrd mulid1d breqtrrd nngt0d ltdivmul syl112anc
      1re a1i mpbid recnd efle nndivred difrp sylancl relogcld elfzle1 syl22anc
      divge0 eflegeo reefcld efgt0 rpregt0d lerec2 syl21anc reeflogd cc 3brtr4d
      fsumle fsumneg fsumdivc arisum2 eqtr3d negeqd breqtrd fsumrecl ltlecasei
      efneg nnne0 ) DUAIZEUBIZUCZBUDJZAUDJZKLZDUEUFLZDUGLZUEKLZEKLZUHZUIJZMNEDU
      VJEDONZUCZUVMPUVSMUWAUVMPUVLKLPUWAUVKPUVLKUWAUVKQUDJPUWABQUDUWABRDUJLZREU
      JLZCUKULZCUMZQGUVJUWEQUNUVTUVJUVTUWEQUWEQUOZUWBUWCUPNZUVJUVTUQZUWFUWDCURU
      WGUWDCUSUWBUWCCREUJUTVCVAUVJUWBUDJZUWCUDJZMNZDEMNZUWGUWHUVHUVIUWIDUWJEMDV
      BUVIEUAIUWJEUNEVDEVBVEVFUVJUWBVNIUWCVNIUWKUWGSUVJRDVGUVJREVGUWBUWCVNVHVIU
      VHDTIZETIZUWLUWHSUVIDVJZEVKZDEVOVLVMVPVQVRVSVTWAWBWCUWAUVLUWAUVLUWAAQUOZU
      VLUBIZUVIUWQUVHUVTBAWDZAVNIZUVIUWQWEZABCDEFGWFZWGWHUWTUWRUWQSUWSUWTUXAUXB
      WIAWJWKWLZWMUWAUVLUXCWNWOXDUWAUVSUWAUVRUVJUVRTIZUVTUVJUVQUVHUVIUVPTIUVQTI
      UVJUVOUVJUVNDUVJDUVHUWMUVIUWOWPZWQUXEWRWSUVPEWTXAXBZWPXCXEXFUVJUWLUCZUVMP
      DRUGLZUJLZRHUKZEKLZUGLZXGJZHXHZUIJZUVSMUXGUVIDPEUJLIZUVMUXOUNUVHUVIUWLXIZ
      UXGUXPUWLUVJUWLXJZUXGDPXPJZIEXKIZUXPUWLSUXGDUAUXSUVHUVIUWLXLZXMXNUVIUXTUV
      HUWLEXQWHDPEXOVIXRABCHDEFGXSVIUXGUXNUVRMNZUXOUVSMNZUXGUXNUXIUXKUHZHXHZUVR
      MUXGUXIUXMUYDHUXGPUXHVGZUXGUXJUXIIZUCZUXLUYHUXKRONZUXLYFIZUYHUYIUXJERYGLZ
      ONZUYHUXJEUYKOUYHUXJUXHEUYHUXJUYGUXJUAIUXGUXJUXHXTYAYBZUXGUXHTIZUYGUXGUWM
      UYNUXGDUYAYBZDYCVEZWPUYHEUXGUVIUYGUXQWPZYDZUYGUXJUXHMNUXGUXJPUXHYEYAUXGUX
      HEONUYGUXGUXHDEUYPUYOUXGEUXQYDUXGDUYOYHUXRYIWPYJUYHEUYHEUYQWMYKYLUYHUXJTI
      ZRTIZUWNPEONZUYIUYLSUYMUYTUYHYPYQUYRUYHEUYQYMZUXJREYNYOXRZUYHUXKTIZUYTUYI
      UYJSUYHUXJEUYMUYQUUAZYPUXKRUUBUUCYRZUUDZUYHUXKVUEXBZUYHUXMUYDMNZUXMUIJZUY
      DUIJZMNZUYHUXLRUXKUIJZKLZVUJVUKMUYHVUMRUXLKLMNZUXLVUNMNZUYHUXKVUEUYHUYSPU
      XJMNZUWNVUAPUXKMNUYMUYGVUQUXGUXJPUXHUUEYAUYRVUBUXJEUUGUUFVUCUUHUYHVUMTIPV
      UMONZUXLTIPUXLONUCVUOVUPSUYHUXKVUEUUIUYHVUDVURVUEUXKUUJVEUYHUXLVUFUUKVUMU
      XLUULUUMYRUYHUXLVUFUUNUYHUXKUUOIVUKVUNUNUYHUXKVUEYSZUXKUVFVEUUPUYHUXMTIUY
      DTIVUIVULSVUGVUHUXMUYDYTVIXRUUQUXGUYEUXIUXKHXHZUHUVRUXGUXIUXKHUYFVUSUURUX
      GVUTUVQUXGUXIUXJHXHZEKLVUTUVQUXGUXIUXJEHUYFUXGEUXQWMUYHUXJUYMYSUVIEPUOUVH
      UWLEUVGWHUUSUXGVVAUVPEKUXGUVHVVAUVPUNUYAHDUUTVEWCUVAUVBXDUVCUXGUXNTIUXDUY
      BUYCSUXGUXIUXMHUYFVUGUVDUVJUXDUWLUXFWPUXNUVRYTVIYRXFUVIUWNUVHUWPYAUXEUVE
      $.

    birthday.k $e |- K = ; 2 3 $.
    birthday.n $e |- N = ; ; 3 6 5 $.
    $( The Birthday Problem.  There is a more than even chance that out of 23
       people in a room, at least two of them have the same birthday.
       Mathematically, this is asserting that for ` K = 2 3 ` and
       ` N = 3 6 5 ` , fewer than half of the set of all functions from
       ` 1 ... K ` to ` 1 ... N ` are injective.  (Contributed by Mario
       Carneiro, 17-Apr-2015.) $)
    birthday $p |- ( ( # ` T ) / ( # ` S ) ) < ( 1 / 2 ) $=
      ( cdiv co c2 c1 clt wcel c3 cdc 2nn0 eqtri cr chash cfv cexp cmin cneg ce
      cle wbr cn0 cn 3nn0 deccl eqeltri c6 6nn0 decnncl birthdaylem3 mp2an clog
      5nn log2ub cmul nn0cni sqvali mulid1i eqcomi oveq12i ax-1cn subdii eqtr4i
      c5 oveq1i subcli 2cn 2ne0 divassi 1nn0 caddc 2p1e3 eqid decsuc wceq pncan
      cc cc0 0nn0 addid1i dec0h decmul2c divmuli mpbir decaddi breqtrri crp 2rp
      3p2e5 relogcl ax-mp 5nn0 nn0rei nndivre mpbi wb renegcli eflt recni efneg
      ltnegi reeflog oveq2i breqtri cfn wss wne birthdaylem1 simp2i simp1i ssfi
      c0 wi hashcl simp3i hashnncl reefcl 1re rehalfcli lelttri ) BUAUBZAUAUBZJ
      KZDLUCKZDUDKZLJKZEJKZUEZUFUBZUGUHZYPMLJKZNUHYJYRNUHDUIOEUJOZYQDLPQZUIHLPR
      UKULUMZEPUNQZVKQZUJIUUBVKPUNUKUOULUTUPUMZABCDEFGUQURYPLUSUBZUEZUFUBZYRNYO
      UUFNUHZYPUUGNUHZUUEYNNUHUUHUUELVKQZPQZUUCJKYNNVAYMUUKEUUCJYMDDMUDKZVBKZLJ
      KZUUKYLUUMLJYLDDVBKZDMVBKZUDKUUMYKUUODUUPUDDDUUAVCZVDUUPDDUUQVEZVFVGDDMUU
      QUUQVHVIVJVLUUNDUULLJKZVBKUUKDUULLUUQDMUUQVHVMVNVOVPMMUUJPDLUUSUUAVQVQUUS
      LLQZLJKZMMQZUULUUTLJUULUUTMVRKZMUDKZUUTDUVCMUDDYTUVCHLLPUUTRRVSUUTVTWAVJV
      LUUTWDOMWDOUVDUUTWBUUTLLRRULVCZVHUUTMWCURSVLUVAUVBWBLUVBVBKUUTWBMMLLLWEUV
      BRVQVQUVBVTRWFLMVBKZWEVRKLWEVRKLUVFLWEVRLVNVEZVLLVNWGSUVFLWELQUVGLRWHSWIU
      UTLUVBUVEVNUVBMMVQVQULVCVOWJWKSUKRLPVKUUPLRUKRUUPDYTUURHSZWPWLUVHWISSZIVG
      WMUUEYNLWNOZUUETOWOLWQWRZYMTOYSYNTOYMYMUUKUIUVIUUJPLVKRWSULUKULUMWTUUDYME
      XAURZXHXBYOTOZUUFTOUUHUUIXCYNUVLXDZUUEUVKXDYOUUFXEURXBUUGMUUEUFUBZJKZYRUU
      EWDOUUGUVPWBUUEUVKXFUUEXGWRUVOLMJUVJUVOLWBWOLXIWRXJSXKYJYPYRYHTOYIUJOZYJT
      OYHBXLOZYHUIOAXLOZBAXMZUVRUVTUVSYSAXSXNZXTZABCDEFGXOZXPZUVTUVSUWBUWCXQABX
      RURBYAWRWTUVQUWAYSUWAUUDUVTUVSUWBUWCYBWRUVSUVQUWAXCUWDAYCWRWKYHYIXAURUVMY
      PTOUVNYOYDWRMYEYFYGUR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Areas in R^2
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c area $.

  $( Area of regions in the complex plane. $)
  carea $a class area $.

  ${
    $d s t x $.
    $( Define the area of a subset of ` RR X. RR ` .  (Contributed by Mario
       Carneiro, 21-Jun-2015.) $)
    df-area $a |- area = ( s e. { t e. ~P ( RR X. RR ) |
      ( A. x e. RR ( t " { x } ) e. ( `' vol " RR ) /\
        ( x e. RR |-> ( vol ` ( t " { x } ) ) ) e. L^1 ) } |->
        S. RR ( vol ` ( s " { x } ) ) _d x ) $.
  $}

  ${
    $d s t x y A $.  $d s x S $.
    $( The domain of the area function is the set of finitely measurable
       subsets of ` RR X. RR ` .  (Contributed by Mario Carneiro,
       21-Jun-2015.) $)
    dmarea $p |- ( A e. dom area <-> ( A C_ ( RR X. RR ) /\
       A. x e. RR ( A " { x } ) e. ( `' vol " RR ) /\
        ( x e. RR |-> ( vol ` ( A " { x } ) ) ) e. L^1 ) ) $=
      ( vt vs carea cdm wcel cv csn cima cvol ccnv cr wral cfv cmpt cibl eleq1d
      wa reex cxp cpw crab wss w3a citg itgex df-area dmmpti eleq2i wceq imaeq1
      ralbidv fveq2d mpteq2dv anbi12d elrab elpw2 anbi1i 3anass bitr4i 3bitri
      xpex ) BEFZGBCHZAHIZJZKLMJZGZAMNZAMVGKOZPZQGZSZCMMUAZUBZUCZGBVPGZBVFJZVHG
      ZAMNZAMVSKOZPZQGZSZSZBVOUDZWAWDUEZVDVQBDVQAMDHVFJKOZUFEAMWIUGACDUHUIUJVNW
      ECBVPVEBUKZVJWAVMWDWJVIVTAMWJVGVSVHVEBVFULZRUMWJVLWCQWJAMVKWBWJVGVSKWKUNU
      ORUPUQWFWGWESWHVRWGWEBVOMMTTVCURUSWGWAWDUTVAVB $.

    $( The fibers of a measurable region are finitely meaurable subsets of
       ` RR ` .  (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    areambl $p |- ( ( S e. dom area /\ A e. RR ) ->
      ( ( S " { A } ) e. dom vol /\ ( vol ` ( S " { A } ) ) e. RR ) ) $=
      ( vx carea cdm wcel cr wa csn cima cvol ccnv cfv wral cxp wss cmpt dmarea
      cv cibl simp2bi wceq sneq imaeq2d eleq1d rspccva sylan cc0 cpnf co wf wfn
      cicc wb volf ffn elpreima mp2b sylib ) BDEFZAGFZHBAIZJZKLGJZFZVCKEZFVCKMG
      FHZUTBCSZIZJZVDFZCGNZVAVEUTBGGOPVLCGVJKMQTFCBRUAVKVECAGVHAUBZVJVCVDVMVIVB
      BVHAUCUDUEUFUGVFUHUIUMUJZKUKKVFULVEVGUNUOVFVNKUPVFVCGKUQURUS $.

    $( A measurable region is a subset of ` RR X. RR ` .  (Contributed by Mario
       Carneiro, 21-Jun-2015.) $)
    areass $p |- ( S e. dom area -> S C_ ( RR X. RR ) ) $=
      ( vx carea cdm wcel cr cxp wss cv csn cima cvol ccnv wral cfv cmpt dmarea
      cibl simp1bi ) ACDEAFFGHABIJKZLMFKEBFNBFTLOPREBAQS $.

    $( Rewrite ~ df-area self-referentially.  (Contributed by Mario Carneiro,
       21-Jun-2015.) $)
    dfarea $p |- area = ( s e. dom area |->
      S. RR ( vol ` ( s " { x } ) ) _d x ) $=
      ( vy carea cv csn cima cvol ccnv cr wcel wral cfv cmpt cibl cxp crab wceq
      wa cpw citg cdm df-area itgex dmmpti mpteq1 ax-mp eqtr4i ) DBCEAEFZGZHIJG
      KAJLAJUJHMNOKSCJJPTQZAJBEUIGHMZUAZNZBDUBZUMNZACBUCZUOUKRUPUNRBUKUMDAJULUD
      UQUEBUOUKUMUFUGUH $.

    $( Area meaurement is a function whose values are nonnegative reals.
       (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    areaf $p |- area : dom area --> ( 0 [,) +oo ) $=
      ( vs vx carea cdm cc0 cpnf cico co csn cima cvol cfv citg dfarea wcel cle
      cr cv wbr wss wa areambl simprd cxp ccnv wral cmpt dmarea simp3bi itgrecl
      cibl covol simpld mblss ovolge0 3syl wceq mblvol breqtrrd itgge0 sylanbrc
      syl elrege0 fmpti ) ACDZEFGHZBQARZBRZIJZKLZMZCBANVGVEOZVKQOEVKPSVKVFOVLBQ
      VJVLVHQOUAZVIKDOZVJQOZVHVGUBZUCZVLVGQQUDTVIKUEQJOBQUFBQVJUGUKOBVGUHUIZUJV
      LBQVJVRVQVMEVIULLZVJPVMVNVIQTEVSPSVMVNVOVPUMZVIUNVIUOUPVMVNVJVSUQVTVIURVB
      USUTVKVCVAVD $.

    $( The area of a measurable region is a real number.  (Contributed by Mario
       Carneiro, 21-Jun-2015.) $)
    areacl $p |- ( S e. dom area -> ( area ` S ) e. RR ) $=
      ( carea cdm wcel cfv cc0 cpnf cico co cr ffvelrni cle wbr elrege0 simplbi
      areaf syl ) ABCZDABEZFGHIZDZSJDZRTABPKUAUBFSLMSNOQ $.

    $( The area of a measurable region is greater than or equal to zero.
       (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    areage0 $p |- ( S e. dom area -> 0 <_ ( area ` S ) ) $=
      ( carea cdm wcel cfv cc0 cpnf cico cle wbr areaf ffvelrni elrege0 simprbi
      co cr syl ) ABCZDABEZFGHOZDZFSIJZRTABKLUASPDUBSMNQ $.

    $( The area of a measurable region is greater than or equal to zero.
       (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    areaval $p |- ( S e. dom area ->
        ( area ` S ) = S. RR ( vol ` ( S " { x } ) ) _d x ) $=
      ( vs cr cv csn cima cvol cfv citg carea wceq wcel wa simpl imaeq1d fveq2d
      cdm itgeq2dv dfarea itgex fvmpt ) CBADCEZAEZFZGZHIZJADBUEGZHIZJKRKUCBLZAD
      UGUIUJUDDMZNZUFUHHULUCBUEUJUKOPQSACTADUIUAUB $.
  $}

  $(
    areacirc.1 @e |- S = { <. x , y >. | ( ( x e. RR /\ y e. RR ) /\
       ( ( x ^ 2 ) + ( y ^ 2 ) ) <_ ( R ^ 2 ) ) } @.
    @( The area of a circle of radius ` R ` is ` pi x. R ^ 2 ` . @)
    areacirc @p |- ( ( R e. RR /\ 0 <_ R ) ->
        ( area ` S ) = ( pi x. ( R ^ 2 ) ) ) @=
      ? @.
      @( [1-Mar-2015] @)
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         More miscellaneous converging sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d r w x y z A $.  $d r t x y z B $.  $d r t x y z C $.  $d r t x y z ph $.
    $d r w z J $.  $d r w y z R $.  $d r t x z S $.
    rlimcnp.a $e |- ( ph -> A C_ ( 0 [,) +oo ) ) $.
    rlimcnp.0 $e |- ( ph -> 0 e. A ) $.
    rlimcnp.b $e |- ( ph -> B C_ RR+ ) $.
    rlimcnp.r $e |- ( ( ph /\ x e. A ) -> R e. CC ) $.
    rlimcnp.d $e |- ( ( ph /\ x e. RR+ ) -> ( x e. A <-> ( 1 / x ) e. B ) ) $.
    rlimcnp.c $e |- ( x = 0 -> R = C ) $.
    rlimcnp.s $e |- ( x = ( 1 / y ) -> R = S ) $.
    rlimcnp.j $e |- J = ( TopOpen ` CCfld ) $.
    rlimcnp.k $e |- K = ( J |`t A ) $.
    $( Relate a limit of a real-valued sequence at infinity to the continuity
       of the function ` S ( y ) = R ( 1 / y ) ` at zero.  (Contributed by
       Mario Carneiro, 1-Mar-2015.) $)
    rlimcnp $p |- ( ph -> ( ( y e. B |-> S ) ~~>r C <->
      ( x e. A |-> R ) e. ( ( K CnP J ) ` 0 ) ) ) $=
      ( cc0 vt vz vw vr cmpt crli wbr cabs cmin ccom cxp cres cmopn cfv ccnp co
      wcel cv clt wi wral crp wrex cc wf wa c1 cdiv rpreccl adantl wceq rpcnne0
      wb wne recrec syl eqcomd oveq2 eqeq2d rspcev syl2anc simpr breq1d ralbidv
      imbi1d rexxfrd adantr csn cdif cun simplr sselda adantlr cr elrp ralbidva
      ltrec1 syl2anb rpne0 recrecd eqeltrd ralrimiva eleq1 eleq1d bibi12d rspcv
      rpcn sylc mpbird rpne0d cpnf cxr wss 0re pnfxr mp2an sseldi oveq1d fveq2d
      cico cle imbi12d ad2antrr bitr4d eqtrd syl5eq nfv nffvmpt1 nfcv cnmetdval
      syl6ss eqid rpssre a1i cioo ssrexv ax-mp cxmt cnxmet sylancr sylanbrc w3a
      eldifsn eldifi icossre ssdifssd elico2 simp2bi ne0gt0d elrpd syldan mpbid
      eldifsni breq1 ralxfrd elsni subidd abs00bd ad2antlr eqbrtrd a1d biantrud
      rpgt0 ralunb syl6bbr undif1 snssd ssequn2 sylib raleqdv 3bitrd bitrd nfov
      rexbidva nfbr nfim oveq1 fveq2 cbvral ovresd sseldd subid1d 3eqtrd absidd
      ax-resscn fvmpt2 fvmptg oveq12d rexbidv fmptd biantrurd 3bitr2d 1re rlim3
      syl5bb 0xr 0lt1 df-ioo df-ico xrltletr ixxss1 ioorp sseqtri ltle ralimdva
      imim1d reximdva syl5 ralimdv sylbid ralimi rlim2lt syl5ibr impbid metcnp2
      xmetres2 cnfldtopn syl3anc 3bitr4d crest metrest fveq1d eleq2d ) ACEHUEFU
      FUGZBDGUEZTUHUIUJZDDUKULZUMUNZIUOUPZUNZUQZUYETJIUOUPZUNZUQAUAURZCURZUSUGZ
      HFUIUPZUHUNZUBURZUSUGZUTZCEVAZUAVBVCZUBVBVAZDVDUYEVEZUCURZTUYGUPZUDURZUSU
      GZVUFUYEUNZTUYEUNZUYFUPZUYSUSUGZUTZUCDVAZUDVBVCZUBVBVAZVFZUYDUYKAVUDBURZV
      UHUSUGZGFUIUPZUHUNZUYSUSUGZUTZBDVAZUDVBVCZUBVBVAVUQVURAVUCVVFUBVBAUYSVBUQ
      ZVFZVUCVGVUHVHUPZUYOUSUGZUYTUTZCEVAZUDVBVCZVVFAVUCVVMVMVVGAVUBVVLUAUDVVIV
      BVBVUHVBUQZVVIVBUQAVUHVIVJAUYNVBUQZVFZVGUYNVHUPZVBUQZUYNVGVVQVHUPZVKZUYNV
      VIVKZUDVBVCVVOVVRAUYNVIVJVVPVVSUYNVVPUYNVDUQUYNTVNVFZVVSUYNVKVVOVWBAUYNVL
      VJUYNVOVPVQVWAVVTUDVVQVBVUHVVQVKVVIVVSUYNVUHVVQVGVHVRVSVTWAAVWAVFZVUAVVKC
      EVWCUYPVVJUYTVWCUYNVVIUYOUSAVWAWBWCWEWDWFWGVVHVVLVVEUDVBVVHVVNVFZVVLVVDBD
      TWHZWIZVAZVVDBVWFVWEWJZVAZVVEVWDVVLVGUYOVHUPZVUHUSUGZUYTUTZCEVAZVWGAVVNVV
      LVWMVMVVGAVVNVFZVVKVWLCEVWNUYOEUQZVFZVVJVWKUYTVWPVVNUYOVBUQZVVJVWKVMZAVVN
      VWOWKAVWOVWQVVNAEVBUYOMWLZWMVVNVUHWNUQTVUHUSUGVFUYOWNUQZTUYOUSUGVFVWRVWQV
      UHWOUYOWOVUHUYOWQWRWAWEWPWMAVWGVWMVMVVGVVNAVVDVWLBCVWJVWFEAVWOVFZVWJDUQZV
      WJTVNVWJVWFUQVXAVXBVGVWJVHUPZEUQZVXAVXCUYOEVXAVWQVXCUYOVKVWSVWQUYOUYOXGUY
      OWSWTVPAVWOWBXAVXAVWJVBUQZVUSDUQZVGVUSVHUPZEUQZVMZBVBVAZVXBVXDVMZVXAVWQVX
      EVWSUYOVIVPZAVXJVWOAVXIBVBOXBWGVXIVXKBVWJVBVUSVWJVKZVXFVXBVXHVXDVUSVWJDXC
      VXMVXGVXCEVUSVWJVGVHVRXDXEXFXHXIZVXAVWJVXLXJVWJDTUUCUUAAVUSVWFUQZVFZVXHVU
      SVGVXGVHUPZVKZVXMCEVCVXPVXFVXHVXOVXFAVUSDVWEUUDVJAVXOVUSVBUQZVXIVXPVUSVXP
      TXKXTUPZWNVUSTWNUQZXKXLUQZVXTWNXMXNXOTXKUUEXPZAVWFVXTVUSADVXTVWEKUUFWLZXQ
      ZVXPVUSVYEVXPVUSVXTUQZTVUSYAUGZVYDVYFVUSWNUQZVYGVUSXKUSUGZVYAVYBVYFVYHVYG
      VYIUUBVMXNXOTXKVUSUUGXPUUHZVPVXOVUSTVNAVUSDTUUMVJUUIUUJZOUUKUULVXPVXQVUSV
      XPVXSVXQVUSVKVYKVXSVUSVUSXGVUSWSWTVPVQVXMVXRCVXGEUYOVXGVKVWJVXQVUSUYOVXGV
      GVHVRVSVTWAVXMVVDVWLVMAVXMVUTVWKVVCUYTVUSVWJVUHUSUUNVXMVVBUYRUYSUSVXMVVAU
      YQUHVXMGHFUIQXRXSWCYBVJUUOYCYDVWDVWGVWGVVDBVWEVAZVFVWIVWDVYLVWGVVHVYLVVNV
      VHVVDBVWEVVHVUSVWEUQZVFZVVCVUTVYNVVBTUYSUSVYNVVAVYNVVAFFUIUPZTVYNGFFUIVYN
      VUSTVKZGFVKVYMVYPVVHVUSTUUPVJPVPXRAVYOTVKVVGVYMAFATDUQZGVDUQZBDVAZFVDUQZL
      AVYRBDNXBZVYRVYTBTDVYPGFVDPXDXFXHZUUQYCYEUURVVGTUYSUSUGAVYMUYSUVCUUSUUTUV
      AXBWGUVBVVDBVWFVWEUVDUVEVWDVVDBVWHDVWDVWHDVWEWJZDDVWEUVFVWDVWEDXMWUCDVKVW
      DTDAVYQVVGVVNLYCUVGVWEDUVHUVIYFUVJUVKUVNUVLWPAVUPVVFUBVBAVUOVVEUDVBVUOVUS
      TUYGUPZVUHUSUGZVUSUYEUNZVUKUYFUPZUYSUSUGZUTZBDVAAVVEVUNWUIUCBDVUIVUMBVUIB
      YGBVULUYSUSBVUJVUKUYFBDGVUFYHBUYFYIBDGTYHUVMBUSYIBUYSYIUVOUVPWUIUCYGVUFVU
      SVKZVUIWUEVUMWUHWUJVUGWUDVUHUSVUFVUSTUYGUVQWCWUJVULWUGUYSUSWUJVUJWUFVUKUY
      FVUFVUSUYEUVRXRWCYBUVSAWUIVVDBDAVXFVFZWUEVUTWUHVVCWUKWUDVUSVUHUSWUKWUDVUS
      UHUNZVUSWUKWUDVUSTUYFUPZVUSTUIUPZUHUNZWULWUKVUSTUYFDAVXFWBZAVYQVXFLWGZUVT
      WUKVUSVDUQTVDUQWUMWUOVKADVDVUSADWNVDADVXTWNKVYCYKZUWEYKZWLZWUKDVDTADVDXMZ
      VXFWUSWGWUQUWAVUSTUYFUYFYLZYJWAWUKWUNVUSUHWUKVUSWUTUWBXSUWCWUKVUSADWNVUSW
      URWLWUKVYFVYGADVXTVUSKWLVYJVPUWDYEWCWUKWUGVVBUYSUSWUKWUGGFUYFUPZVVBWUKWUF
      GVUKFUYFWUKVXFVYRWUFGVKWUPNBDGVDUYEUYEYLZUWFWAWUKVYQVYTVUKFVKWUQAVYTVXFWU
      BWGZBTGFDVDUYEPWVDUWGWAUWHWUKVYRVYTWVCVVBVKNWVEGFUYFWVBYJWAYEWCYBWPUWOUWI
      WDAVUEVUQABDGVDUYENWVDUWJUWKUWLAUYDVUDAUYDUYNUYOYAUGZUYTUTZCEVAZUAVGXKXTU
      PZVCZUBVBVAVUDAUBUACEHFVGAHVDUQZCEVXAVXBVYSWVKVXNAVYSVWOWUAWGVYRWVKBVWJDV
      XMGHVDQXDXFXHXBZAEVBWNMYMYKZWUBVGWNUQAUWMYNUWNAWVJVUCUBVBWVJWVHUAVBVCZAVU
      CWVIVBXMWVJWVNUTWVITXKYOUPZVBTXLUQTVGUSUGWVIWVOXMUWPUWQBCUBUCTVGXKXTUSUSY
      AYOUSBCUBUWRBCUBUWSTVGVUFUWTUXAXPUXBUXCWVHUAWVIVBYPYQAWVHVUBUAVBVVPWVGVUA
      CEVVPVWOVFZUYPWVFUYTWVPUYNWNUQVWTUYPWVFUTWVPVBWNUYNYMAVVOVWOWKXQVVPEWNUYO
      AEWNXMVVOWVMWGWLUYNUYOUXDWAUXFUXEUXGUXHUXIUXJVUDUYDAVUBUAWNVCZUBVBVAVUCWV
      QUBVBVBWNXMVUCWVQUTYMVUBUAVBWNYPYQUXKAUBUACEHFWVLWVMWUBUXLUXMUXNAUYGDYRUN
      UQZUYFVDYRUNUQZVYQUYKVURVMAWVSWVAWVRYSWUSUYFDVDUXPYTWVSAYSYNLUBUDUCUYGUYF
      TUYEUYHIDVDUYHYLZIRUXQZUXOUXRUXSAUYMUYJUYEATUYLUYIAJUYHIUOAJIDUXTUPZUYHSA
      WVSWVAWWBUYHVKYSWUSUYFUYGIUYHVDDUYGYLWWAWVTUYAYTYFXRUYBUYCYD $.
  $}

  ${
    $d w x y z A $.  $d w x y B $.  $d w x y C $.  $d w x y ph $.  $d w y R $.
    $d x S $.
    rlimcnp2.a $e |- ( ph -> A C_ ( 0 [,) +oo ) ) $.
    rlimcnp2.0 $e |- ( ph -> 0 e. A ) $.
    rlimcnp2.b $e |- ( ph -> B C_ RR ) $.
    rlimcnp2.c $e |- ( ph -> C e. CC ) $.
    rlimcnp2.r $e |- ( ( ph /\ y e. B ) -> S e. CC ) $.
    rlimcnp2.d $e |- ( ( ph /\ y e. RR+ ) -> ( y e. B <-> ( 1 / y ) e. A ) ) $.
    rlimcnp2.s $e |- ( y = ( 1 / x ) -> S = R ) $.
    rlimcnp2.j $e |- J = ( TopOpen ` CCfld ) $.
    rlimcnp2.k $e |- K = ( J |`t A ) $.
    $( Relate a limit of a real-valued sequence at infinity to the continuity
       of the function ` S ( y ) = R ( 1 / y ) ` at zero.  (Contributed by
       Mario Carneiro, 1-Mar-2015.) $)
    rlimcnp2 $p |- ( ph -> ( ( y e. B |-> S ) ~~>r C <->
      ( x e. A |-> if ( x = 0 , C , R ) ) e. ( ( K CnP J ) ` 0 ) ) ) $=
      ( wcel vz vw cmpt crli wbr crp cin c1 cdiv cc0 wceq csb cif ccnp cfv cpnf
      cv co cico cres wss inss1 resmpt mp1i cioo cxr clt 0xr 0lt1 df-ioo df-ico
      cle xrltletr ixxss1 mp2an ioorp sseqtri sslin ax-mp eqtr4d resres 3eqtr4g
      wfn cc wf eqid fmptd ffn syl fnresdm reseq1d wrel cdm sseli frel syl6eqss
      sylan2 fdm relssres syl2anc 3eqtr3d breq1d cr 1re rlimresb syl5ss 3bitr4d
      a1i wa inss2 sselda rpreccld rpne0d neneqd iffalse oveq2 wne rpcnne0 3syl
      wn recrec sylan9eqr eqcomd csbied ad2antrr wb adantr mpbid csbeq1d adantl
      0re wral ralrimiva eleq1d rspcv sylc syl6bbr eqeq1 ifbieq2d nfcv eqtrd wo
      mpteq2dva w3a pnfxr elico2 sylib simp1d simp2d leloe sylancr eqcom syl6ib
      ord con1d imp elrpd simplr simpll rpreccl bibi12d bitr2d sylanbrc eqeltrd
      eleq1 elin eqeltrrd ifclda biantrud bitrd iftrue rlimcnp nfv nfcsb1v nfif
      csbeq1 csbeq1a cbvmpt eleq1i 3bitr2d ) ACEHUCZFUDUEZCEUFUGZHUCZFUDUEZCUWC
      UHCUQZUIURZUJUKZFBUWGGULZUMZUCZFUDUEZBDBUQZUJUKZFGUMZUCZUJJIUNURUOZTZAUWA
      UHUPUSURZUTZFUDUEUWDUWSUTZFUDUEUWBUWEAUWTUXAFUDAUWAEUTZUWSUTZUWDEUTZUWSUT
      ZUWTUXAAUWAEUWSUGZUTZUWDUXFUTZUXCUXEAUXGCUXFHUCZUXHUXFEVAUXGUXIUKAEUWSVBC
      EUXFHVCVDUXFUWCVAZUXHUXIUKAUWSUFVAUXJUWSUJUPVEURZUFUJVFTUJUHVGUEUWSUXKVAV
      HVIBCUAUBUJUHUPUSVGVGVLVEVGBCUAVJBCUAVKUJUHUBUQZVMVNVOVPVQUWSUFEVRVSCUWCU
      XFHVCVDVTUWAEUWSWAUWDEUWSWAWBAUXBUWAUWSAUWAEWCZUXBUWAUKAEWDUWAWEUXMACEHWD
      UWAOUWAWFWGZEWDUWAWHWIEUWAWJWIWKAUXDUWDUWSAUWDWLZUWDWMZEVAUXDUWDUKAUWCWDU
      WDWEZUXOACUWCHWDUWDUWFUWCTZAUWFETZHWDTUWCEUWFEUFVBZWNOWQZUWDWFWGZUWCWDUWD
      WOWIAUXPUWCEAUXQUXPUWCUKUYBUWCWDUWDWRWIUXTWPUWDEWSWTWKXAXBAEUHFUWAUXNMUHX
      CTAXDXHZXEAUWCUHFUWDUYBAUWCEXCUXTMXFUYCXEXGAUWKUWDFUDACUWCUWJHAUXRXIZUWJU
      WIHUYDUWHXTUWJUWIUKUYDUWGUJUYDUWGUYDUWFAUWCUFUWFUWCUFVAAEUFXJXHZXKZXLZXMX
      NUWHFUWIXOWIUYDBUWGGHUFUYGUYDUWMUWGUKZXIZHGUYIUWFUHUWMUIURZUKHGUKUYIUYJUW
      FUYHUYDUYJUHUWGUIURZUWFUWMUWGUHUIXPUYDUWFUFTUWFWDTUWFUJXQXIUYKUWFUKUYFUWF
      XRUWFYAXSYBYCQWIYCYDZUUAUUCXBAUWLUBDUXLUJUKZFBUXLGULZUMZUCZUWQTUWRAUBCDUW
      CFUYOUWJIJKLUYEAUXLDTZXIZUYMFUYNWDAFWDTUYQUYMNYEUYRUYMXTZXIZBUHUHUXLUIURZ
      UIURZGULZUYNWDUYTBVUBUXLGUYTUXLUFTZVUBUXLUKZUYTUXLUYRUXLXCTZUYSUYRVUFUJUX
      LVLUEZUXLUPVGUEZUYRUXLUJUPUSURZTZVUFVUGVUHUUDZADVUIUXLKXKUJXCTZUPVFTVUJVU
      KYFYKUUEUJUPUXLUUFVOUUGZUUHZYGUYRUYSUJUXLVGUEZUYRVUOUYMUYRVUOXTUJUXLUKZUY
      MUYRVUOVUPUYRVUGVUOVUPUUBZUYRVUFVUGVUHVUMUUIUYRVULVUFVUGVUQYFYKVUNUJUXLUU
      JUUKYHUUNUJUXLUULUUMUUOUUPUUQZVUDUXLWDTUXLUJXQXIVUEUXLXRUXLYAWIZWIYIUYTVU
      AUWCTZUWIWDTZCUWCYLZVUCWDTZUYTVUAETZVUAUFTZVUTUYTUYQVVDAUYQUYSUURUYTAVUDU
      YQVVDYFAUYQUYSUUSVURAVUDXIZVVDVUBDTZUYQVVFVVEUXSUWGDTZYFZCUFYLZVVDVVGYFZV
      UDVVEAUXLUUTYJZAVVJVUDAVVICUFPYMYGVVIVVKCVUAUFUWFVUAUKZUXSVVDVVHVVGUWFVUA
      EUVEVVMUWGVUBDUWFVUAUHUIXPZYNUVAYOYPVVFVUBUXLDVUDVUEAVUSYJYNUVBZWTYHUYTUX
      LVURXLVUAEUFUVFZUVCAVVBUYQUYSAVVACUWCUYDUWIHWDUYLUYAUVDYMYEVVAVVCCVUAUWCV
      VMUWIVUCWDVVMBUWGVUBGVVNYIYNYOYPUVGUVHVVFUYQVVDVVEXIZVUTVVFUYQVVDVVQVVOVV
      FVVEVVDVVLUVIUVJVVPYQUYMFUYNUVKUXLUWGUKUYMUWHUYNUWIFUXLUWGUJYRBUXLUWGGUVP
      YSRSUVLUWPUYPUWQBUBDUWOUYOUBUWOYTUYMBFUYNUYMBUVMBFYTBUXLGUVNUVOUWMUXLUKUW
      NUYMGUYNFUWMUXLUJYRBUXLGUVQYSUVRUVSYQUVT $.
  $}

  ${
    $d x y C $.  $d x y ph $.  $d y R $.  $d x S $.
    rlimcnp3.c $e |- ( ph -> C e. CC ) $.
    rlimcnp3.r $e |- ( ( ph /\ y e. RR+ ) -> S e. CC ) $.
    rlimcnp3.s $e |- ( y = ( 1 / x ) -> S = R ) $.
    rlimcnp3.j $e |- J = ( TopOpen ` CCfld ) $.
    rlimcnp3.k $e |- K = ( J |`t ( 0 [,) +oo ) ) $.
    $( Relate a limit of a real-valued sequence at infinity to the continuity
       of the function ` S ( y ) = R ( 1 / y ) ` at zero.  (Contributed by
       Mario Carneiro, 1-Mar-2015.) $)
    rlimcnp3 $p |- ( ph -> ( ( y e. RR+ |-> S ) ~~>r C <->
  ( x e. ( 0 [,) +oo ) |-> if ( x = 0 , C , R ) ) e. ( ( K CnP J ) ` 0 ) ) ) $=
      ( cc0 cpnf co crp a1i wcel cr cico wss ssid cxr clt wbr pnfxr ltpnf ax-mp
      0xr 0re lbico1 mp3an rpssre cv wa c1 cdiv simpr cle rpreccl adantl rpge0d
      rpred elrege0 sylanbrc 2thd rlimcnp2 ) ABCNOUAPZQDEFGHVIVIUBAVIUCRNVISZAN
      UDSOUDSNOUEUFZVJUJUGNTSVKUKNUHUINOULUMRQTUBAUNRIJACUOZQSZUPZVMUQVLURPZVIS
      ZAVMUSVNVOTSNVOUTUFVPVNVOVMVOQSAVLVAVBZVDVNVOVQVCVOVEVFVGKLMVH $.
  $}

  ${
    $d k r w x y B $.  $d r w y z J $.  $d k r w y z K $.  $d k r w x y z ph $.
    $d k r w x y z A $.  $d k r w x y z C $.  $d k r w y z R $.
    xrlimcnp.a $e |- ( ph -> A = ( B u. { +oo } ) ) $.
    xrlimcnp.b $e |- ( ph -> B C_ RR ) $.
    xrlimcnp.r $e |- ( ( ph /\ x e. A ) -> R e. CC ) $.
    xrlimcnp.c $e |- ( x = +oo -> R = C ) $.
    xrlimcnp.j $e |- J = ( TopOpen ` CCfld ) $.
    xrlimcnp.k $e |- K = ( ( ordTop ` <_ ) |`t A ) $.
    $( Relate a limit of a real-valued sequence at infinity to the continuity
       of the corresponding extended real function at ` +oo ` .  Since any
       ` ~~>r ` limit can be written in the form on the left side of the
       implication, this shows that real limits are a special case of
       topological continuity at a point.  (Contributed by Mario Carneiro,
       8-Sep-2015.) $)
    xrlimcnp $p |- ( ph -> ( ( x e. B |-> R ) ~~>r C <->
      ( x e. A |-> R ) e. ( ( K CnP J ) ` +oo ) ) ) $=
      ( cpnf wcel wa cc wss ad2antrr vy vz vr vk vw cmpt crli wbr ccnp co wf cv
      cfv cima wrex wi wral eqid fmptd adantr wceq csn cun ssun2 cxr pnfxr snid
      elexi sselii syl5eleqr ralrimiva eleq1d rspcv sylc syl2anc cabs cmin ccom
      fvmptg cbl crp cxmt cnxmet cnfldtopn mopni2 mp3an1 cle cr ssun1 syl5sseqr
      clt ssralv simprl simplr rlimi cioc cin cordt crest cvv letop a1i syl3anc
      ctop syl elin sylanbrc crab wb sylancl sselda ad3antrrr r19.21bi syl22anc
      rexrd syld breq1d bitrd simplrl eleq1 sylibr mpbird eqtri sylancr simplrr
      inss2 imaeq2 sseq1d anbi12d rexlimdvaa adantlr mpd syl5 ctopon adantl crn
      eleq2 sseldd adantrr ex ressxr syl6ss snssd unssd eqsstrd xrex iocpnfordt
      ssex elrestr syl6eleqr ltpnf ubioc1 ccnv w3a elioc1 simp2 ltle rpxr elbl3
      syl6bi cnmetdval biimprd imim12d ralimdva blcntr a1d imbi12d ralsn ralunb
      impr raleqdv ss2rab incom mptpreima 3sstr4g wfun cdm funmpt fdm funimass3
      dfin5 sstrd rspcev syl12anc expdimp letopon resttopon syl5eqel cnfldtopon
      sylbid iscnp mpbir2and blopn simpr eqeltrd vex inex1 eleq2i elrest syl5bb
      cnpimaex rexxfr2d mpbid inss1 sseli pnfnei sylan2 cres df-ima ax-mp rneqi
      resmpt sseq1i dfss3 bitri mpsyl ralrnmpt biimpd syl5bi mpbir3and pm5.74da
      simprr pnfge imim1d sylibd exp4a ralimdv2 imp an32s expr reximdva expimpd
      com23 impl rexlimdva rlim2lt impbida ) ABDFUFEUGUHZBCFUFZOHGUIUJUMPZAUYRQ
      ZUYTCRUYSUKZOUYSUMZUAULZPZOUBULZPZUYSVUFUNZVUDSZQZUBHUOZUPZUAGUQZAVUBUYRA
      BCFRUYSKUYSURZUSZUTVUAVULUAGVUAVUDGPZQZVUEEVUDPZVUKVUQVUCEVUDAVUCEVAZUYRV
      UPAOCPZERPZVUSAODOVBZVCZCVVBVVCOVVBDVDOOVEVFVHZVGVIIVJZAVUTFRPZBCUQZVVAVV
      EAVVFBCKVKZVVFVVABOCBULZOVAZFERLVLVMVNZBOFECRUYSLVUNVSVOZTVLVUAVUPVURVUKV
      UPVURQEUCULZVPVQVRZVTUMUJZVUDSZUCWAUOZVUAVUKVVNRWBUMPZVUPVURVVQWCUCVUDVVN
      EGRGMWDZWEWFVUAVVPVUKUCWAVUAVVMWAPZVVPQZQZUDULZVVIWGUHZFEVQUJVPUMZVVMWKUH
      ZUPZBDUQZUDWHUOZVUKVWBUDBDFEVVMRAVVFBDUQZUYRVWAADCSZVVGVWJAVVCDCDVVBWIIWJ
      ZVVHVVFBDCWLVNZTVUAVVTVVPWMAUYRVWAWNWOAVWAVWIVUKUPUYRAVWAQZVWHVUKUDWHVWNV
      WCWHPZVWHQZQZVWCOWPUJZCWQZHPOVWSPZUYSVWSUNZVUDSZVUKVWQVWSWGWRUMZCWSUJZHVW
      QVXCXDPZCWTPZVWRVXCPZVWSVXDPVXEVWQXAXBAVXFVWAVWPACVESZVXFACVVCVEIADVVBVEA
      DWHVEJUUAUUBZAOVEOVEPZAVFXBUUCUUDUUEZCVEUUFUUHXEZTVXGVWQVWCUUGXBVWRCVXCXD
      WTUUIXCNUUJVWQOVWRPZVUTVWTVWQVWCVEPZVXJVWCOWKUHZVXMVWQVWCVWNVWOVWHWMZXOVX
      JVWQVFXBVWQVWOVXOVXPVWCUUKXEVWCOUULXCAVUTVWAVWPVVETOVWRCXFXGVWQVXAVVOVUDV
      WQVXAVVOSZVWSUYSUUMVVOUNZSZVWQVVIVWRPZBCXHZFVVOPZBCXHZVWSVXRVWQVXTVYBUPZB
      CUQZVYAVYCSVWQVYEVYDBVVCUQZVWQVYDBDUQZVYDBVVBUQZVYFVWNVWOVWHVYGVWNVWOQZVW
      GVYDBDVYIVVIDPZQZVXTVWDVWFVYBVYKVXTVWCVVIWKUHZVWDVYKVXTVVIVEPZVYLVVIOWGUH
      ZUUNZVYLVYKVXNVXJVXTVYOXIZVYKVWCVWNVWOVYJWNZXOVFVWCOVVIUUOZXJVYMVYLVYNUUP
      UUTVYKVWOVVIWHPVYLVWDUPVYQVYIDWHVVIADWHSVWAVWOJTXKVWCVVIUUQVOXPVYKVYBVWFV
      YKVYBFEVVNUJZVVMWKUHZVWFVYKVVRVVMVEPZVVAVVFVYBVYTXIZVVRVYKWCXBVYKVVTWUAVW
      NVVTVWOVYJAVVTVVPWMTVVMUURZXEAVVAVWAVWOVYJVVKXLZVYIVVFBDAVWJVWAVWOVWMTXMZ
      FVVNEVVMRUUSZXNVYKVYSVWEVVMWKVYKVVFVVAVYSVWEVAZWUEWUDFEVVNVVNURUVAZVOXQXR
      UVBUVCUVDUVJVWQVXMEVVOPZUPZVYHVWQWUIVXMVWQVVRVVAVVTWUIVVRVWQWCXBAVVAVWAVW
      PVVKTAVVTVVPVWPXSVVNEVVMRUVEZXCUVFVYDWUJBOVVDVVJVXTVXMVYBWUIVVIOVWRXTVVJF
      EVVOLVLUVGUVHYAVYDBDVVBUVIXGVWQVYDBCVVCACVVCVAVWAVWPITUVKYBVXTVYBBCUVLYAV
      WSCVWRWQVYAVWRCUVMBCVWRUWAYCBCFVVOUYSVUNUVNUVOVWQUYSUVPVWSUYSUVQZSVXQVXSX
      IBCFUVRVWQCVWSWULVWRCYFVWQVUBWULCVAAVUBVWAVWPVUOTCRUYSUVSXEWJVWSVVOUYSUVT
      YDYBAVVTVVPVWPYEUWBVUJVWTVXBQUBVWSHVUFVWSVAZVUGVWTVUIVXBVUFVWSOYQWUMVUHVX
      AVUDVUFVWSUYSYGYHYIUWCUWDYJYKYLYJYMUWEUWJVKAUYTVUBVUMQXIZUYRAHCYNUMZPGRYN
      UMPZVUTWUNAHVXDWUONAVXCVEYNUMPVXHVXDWUOPUWFVXKCVXCVEUWGYDUWHWUPAGMUWIXBVV
      EUBUAOUYSHGCRUWKXCUTUWLAUYTQZUYRVYLVWFUPZBDUQZUDWHUOZUCWAUQZWUQWUTUCWAWUQ
      VVTQZOUEULZCWQZPZUYSWVDUNZVVOSZQZUEVXCUOZWUTWVBVUGVUHVVOSZQZUBHUOZWVIWVBU
      YTVVOGPZVUCVVOPWVLAUYTVVTWNWVBVVRVVAWUAWVMVVRWVBWCXBZAVVAUYTVVTVVKTZVVTWU
      AWUQWUCYOVVNEVVMGRVVSUWMXCWVBVUCEVVOAVUSUYTVVTVVLTWVBVVRVVAVVTWUIWVNWVOWU
      QVVTUWNWUKXCUWOUBVVOOUYSHGUXAXCWVBWVKWVHUBUEWVDHVXCWTWVDWTPWVBWVCVXCPZQWV
      CCUEUWPUWQXBVUFHPVUFVXDPZWVBVUFWVDVAZUEVXCUOZHVXDVUFNUWRWVBVXEVXFWVQWVSXI
      XAAVXFUYTVVTVXLTUEVUFCVXCXDWTUWSYDUWTWVRWVKWVHXIWVBWVRVUGWVEWVJWVGVUFWVDO
      YQWVRVUHWVFVVOVUFWVDUYSYGYHYIYOUXBUXCAVVTWVIWUTUPUYTAVVTQZWVHWUTUEVXCWVTW
      VPQWVEWVGWUTWVTWVPWVEWVGWUTUPZWVPWVEQVWRWVCSZUDWHUOZWVTWWAWVEWVPOWVCPWWCW
      VDWVCOWVCCUXDUXEUDWVCUXFUXGWVTWVGWWCWUTWVTWVGVYBBWVDUQZWWCWUTUPZWVGVUFVVO
      PZUBBWVDFUFZYPZUQZWVTWWDWVGWWHVVOSWWIWVFWWHVVOWVFUYSWVDUXHZYPWWHUYSWVDUXI
      WWJWWGWVDCSZWWJWWGVAWVCCYFZBCWVDFUXLUXJUXKYCUXMUBWWHVVOUXNUXOWVTWWIWWDWVT
      VVFBWVDUQZWWIWWDXIWWKWVTVVGWWMWWLAVVGVVTVVHUTVVFBWVDCWLUXPWWFVYBBUBWVDFWW
      GRWWGURVUFFVVOXTUXQXEUXRUXSWVTWWDWWEWVTWWDQZWWBWUSUDWHWWNVWOWWBWUSWVTVWOW
      WBQZWWDWUSWVTWWOQZWWDWUSWWPVYBWURBWVDDWWPVVIWVDPZVYBUPZVYJVYLVWFWWPWWRVYJ
      VYLQZVYBUPWWSVWFUPWWPWWSWWQVYBWWPWWSWWQWWPWWSQZVVIWVCPVVICPZWWQWWTVWRWVCV
      VIWVTVWOWWBWWSYEWWTVXTVYMVYLVYNWWTDVEVVIADVESVVTWWOWWSVXIXLWWPVYJVYLWMYRZ
      WWPVYJVYLUYBWWTVYMVYNWXBVVIUYCXEWWTVXNVXJVYPWWTVWCWVTVWOWWBWWSXSXOVFVYRXJ
      UXTYRWWPVYJWXAVYLWWPDCVVIAVWKVVTWWOVWLTXKYSVVIWVCCXFXGYTUYDWWPWWSVYBVWFWW
      TVYBVYTVWFWWTVVRWUAVVAVVFWUBVVRWWTWCXBWVTWUAWWOWWSVVTWUAAWUCYOTAVVAVVTWWO
      WWSVVKXLZWWPVYJVVFVYLWWPVVFBDAVWJVVTWWOVWMTXMYSZWUFXNWWTVYSVWEVVMWKWWTVVF
      VVAWUGWXDWXCWUHVOXQXRUYAUYEUYFUYGUYHUYIUYJUYKYTXPUYMYMUYNUYLUYOYKYLVKAUYR
      WVAXIUYTAUCUDBDFEVWMJVVKUYPUTYBUYQ $.
  $}

  ${
    $d k x y A $.  $d x S $.
    efrlim.1 $e |- S =
      ( 0 ( ball ` ( abs o. - ) ) ( 1 / ( ( abs ` A ) + 1 ) ) ) $.
    $( The limit of the sequence ` ( 1 + A / k ) ^ k ` is the exponential
       function.  This is often taken as an alternate definition of the
       exponential function (see also ~ dfef2 ).  (Contributed by Mario
       Carneiro, 1-Mar-2015.) $)
    efrlim $p |- ( A e. CC ->
      ( k e. RR+ |-> ( ( 1 + ( A / k ) ) ^c k ) ) ~~>r ( exp ` A ) ) $=
      ( vx vy cc wcel c1 cdiv co caddc cmpt ce cfv cc0 wceq cmul a1i clog ctopn
      crp cv ccxp crli wbr cpnf cico cif ccnfld crest ccnp cr cxr wss 0re pnfxr
      cres mp2an sstri sseli wa wn simpll ax-1cn simplr wne simpr neneqad eqtrd
      adantr oveq2d oveq1d ifeq2da mpteq2dva resmpt ax-mp cle ccom wb cabs cmin
      eqeq2 cnxmet 0cn syl lelttrd syl3anc syldan biimpa reccld ad2antrr syl6eq
      simpl fveq2d 3eqtr4d adantl addcl sylancr cdif eqid clt cnmetdval sylancl
      abscld eqbrtrd subid1d elbl3 syl22anc mpbid mpbird 1rp mp1i 3eqtrd divcld
      ifclda eqidd oveq2 fmptco oveq12d ifbieq2d ctopon cnmptc cnmptid cnmpt12f
      ccn id crn wf fmptd blcntr cncnpi syl2anc mp3an fvmpt fvres cnpco eqeltrd
      ovex cxpcld icossre ax-resscn ax-1ne0 divdiv2d mulcl div1d sylan2 syl6eqr
      0le0 elrege0 mpbir2an cbl cxmt abscl peano2re absge0 ltp1d elrpd rpreccld
      rpxrd blssm syl5eqss sselda mul0or jca sylan adantlr 1cxpd mul02d addid1i
      ef0 ifid iftrue jaodan mulid1 eqtr4d mulne0b syl6bb simprr neneqd iffalse
      wo df-ne csn cmnf cioc dvlog2lem logdmss pncan2 remulcld 1re absmul lep1d
      absge0d lemul1ad syl6eleq eqbrtrrd ltmuldiv2 syl112anc rpxr sseldi cxpefd
      eldifsni logcld mulcomd simprl dividd divdiv1d eqtr3d ex sylbird ifbothda
      div12d imp ifsb eqeq1 fveq2 oveq1 eqeq2i addcand syl5bbr cnfldtopon mulcn
      cuni ctx addcn cnmpt1res frn cnrest2 syl6eleqr resttopon toponuni eleqtrd
      difss cpr cnex prid2 wf1o logf1o f1of logrncn ssriv fss fssres w3a dvlog2
      cdv cdm dmmpti eleqtrri fveq1i div1i 1ex eqtr2i log1 eldifsn sylib eqtr2d
      logcl ifeq12d mpteq2ia dvcnp mpan2 mul01 syl5eleqr eqeltrrd ccncf cncfcn1
      efcn eleqtri cnmpt11f ffvelrnd toponunii ctop cnfldtop cnfldtopn syl5eqel
      cnt blopn isopn3i eleqtrrd efcl cnprest cnpresti rpcn rpne0 rlimcnp3 ) AG
      HZCUBIACUCZJKZLKZVWIUDKZMANOZUEUFEPUGUHKZEUCZPQZVWMIAIVWOJKZJKZLKZVWQUDKZ
      UIZMZPUJUAOZVWNUKKZVXCULKOZHVWHVXBEGVWPVWMIAVWORKZLKZVWQUDKZUIZMZVWNURZVX
      EVWHVXBEVWNVXIMZVXKVWHEVWNVXAVXIVWOVWNHVWHVWOGHZVXAVXIQVWNGVWOVWNUMGPUMHZ
      UGUNHVWNUMUOUPUQPUGUUAUSUUBUTZVAVWHVXMVBZVWPVWTVXHVWMVXPVWPVCZVBZVWSVXGVW
      QUDVXRVWRVXFILVXRVWRVXFIJKVXFVXRAIVWOVWHVXMVXQVDIGHZVXRVESVWHVXMVXQVFZIPV
      GVXRUUCSVXRVWOPVXPVXQVHVIZUUDVXRVXFVXPVXFGHZVXQAVWOUUEZVKZUUFVJVLVMVNUUGV
      OVWNGUOZVXKVXLQVXOEGVWNVXIVPVQUUHVWHVYEPVWNHZVXJPVXCVXCULKZOHZVXKVXEHVYEV
      WHVXOSVYFVWHVYFVXNPPVRUFUPUUIPUUJUUKSVWHVYHVXJBURZPVXCBUKKZVXCULKOZHZVWHV
      YIFGAFUCZRKZNOZMZEBVXFPQZIVXGTOZVXFJKZUIZMZVSZVYKVWHEBVXIMZEBVYQAIRKZNOZA
      VYSRKZNOZUIZMVYIWUBVWHEBVXIWUHVYQVXIWUEQZVXIWUGQZVXIWUHQVWHVWOBHZVBZWUEWU
      GWUEWUHVXIWCWUGWUHVXIWCWULVYQAPQZVWPUWBZWUIWULVYQWUNVWHWUKVXMVYQWUNVTVWHB
      GVWOVWHBPIAWAOZILKZJKZWAWBVSZUULOZKZGDVWHWURGUUMOHZPGHZWUQUNHZWUTGUOWVAVW
      HWDSZWVBVWHWESZVWHWUQVWHWUPVWHWUPVWHWUOUMHZWUPUMHZAUUNZWUOUUOZWFZVWHPWUOW
      UPVXNVWHUPSWVHWVJAUUPVWHWUOWVHUUQWGZUURUUSZUUTZWURPWUQGUVAWHUVBZUVCZAVWOU
      VDWIWJWULWUNVBZVXIVWMWUEWULWUMVXIVWMQZVWPWULWUMVBZVXIVWPVWMVWMUIVWMWVRVWP
      VXHVWMVWMWVRVXQVBZIVWQUDKIVXHVWMWVSVWQWULVXQVWQGHZWUMWULVXPVXQWVTWULVWHVX
      MVWHWUKWNWVOUVEVXRVWOVXTVYAWKZUVFUVGUVHWVSVXGIVWQUDWVSVXGIPLKZIWVSVXFPILW
      VSVXFPVWORKPWVSAPVWORWULWUMVXQVFZVMWVSVWOWULVXMWUMVXQWVOWLUVIVJVLIVEUVJZW
      MVMWVSVWMPNOIWVSAPNWWCWOUVKWMWPVNVWPVWMUVLWMVWPWVQWULVWPVWMVXHUVMWQUVNWVP
      WUDANVWHWUDAQWUKWUNAUVOWLWOUVPWIWULVYQVCZWUJWULWWEAPVGZVWOPVGZVBZWUJWULWW
      HVXFPVGZWWEVWHWUKVXMWWHWWIVTWVOAVWOUVQWIZVXFPUWCUVRWULWWHWUJWULWWHVBZVXIV
      XHVWQVYRRKZNOWUGWWKVXQVXIVXHQWWKVWOPWULWWFWWGUVSZUVTVWPVWMVXHUWAWFWWKVXGV
      WQWULVXGGHZWWHWULVXSVYBWWNVEVWHWUKVXMVYBWVOVYCWIZIVXFWRZWSZVKWULVXGPVGZWW
      HWULVXGGPUWDZWTZHWWRWULIIWUSKZWWTVXGWXAGUWEPUWFKWTZWWTWXAWXAXAZUWGWXBWXBX
      AUWHUTZWULVXGWXAHZVXGIWURKZIXBUFZWULWXFVXFWAOZIXBWULWXFVXGIWBKZWAOZWXHWUL
      WWNVXSWXFWXJQWWQVEVXGIWURWURXAZXCXDWULWXIVXFWAWULVXSVYBWXIVXFQVEWWOIVXFUW
      IWSZWOVJWULWXHWUPVWOWAOZRKZIWULVXFWWOXEWULWUPWXMVWHWVGWUKWVJVKWULVWOWVOXE
      ZUWJIUMHZWULUWKSZWULWXHWUOWXMRKZWXNVRVWHWUKVXMWXHWXRQWVOAVWOUWLWIWULWUOWU
      PWXMVWHWVFWUKWVHVKZWULWVFWVGWXSWVIWFZWXOWULVWOWVOUWNWULWUOWXSUWMUWOXFWULW
      XNIXBUFZWXMWUQXBUFZWULVWOPWURKZWXMWUQXBWULWYCVWOPWBKZWAOZWXMWULVXMWVBWYCW
      YEQWVOWEVWOPWURWXKXCXDWULWYDVWOWAWULVWOWVOXGWOVJWULVWOWUTHZWYCWUQXBUFZWUL
      VWOBWUTVWHWUKVHDUWPWULWVAWVCWVBVXMWYFWYGVTWVAWULWDSZVWHWVCWUKWVMVKWVBWULW
      ESZWVOVWOWURPWUQGXHXIXJUWQWULWXMUMHWXPWVGPWUPXBUFZWYAWYBVTWXOWXQWXTVWHWYJ
      WUKWVKVKWXMIWUPUWRUWSXKWGXFWULWVAIUNHZVXSWWNWXEWXGVTWYHIUBHZWYKWULXLIUWTX
      MVXSWULVESZWWQVXGWURIIGXHXIXKZUXAVXGGPUXCWFZVKWWKVWOWULVXMWWHWVOVKZWWMWKZ
      UXBWWKWWLWUFNWWKWWLVYRVWQRKVYRAVXFJKZRKWUFWWKVWQVYRWYQWULVYRGHZWWHWULVXGW
      WQWYOUXDZVKZUXEWWKVWQWYRVYRRWWKAAJKZVWOJKVWQWYRWWKXUBIVWOJWWKAVWHWUKWWHVD
      ZWULWWFWWGUXFZUXGVMWWKAAVWOXUCXUCWYPXUDWWMUXHUXIVLWWKVYRAVXFXUAXUCWULVYBW
      WHWWOVKWULWWHWWIWWJWJUXMXNWOXNUXJUXKUXNUXLVOVWHBGUOZVYIWUCQWVNEGBVXIVPWFV
      WHEFBGVYTVYOWUHWUAVYPWULVYQIVYSGVXSWULVYQVBVESWULWWEVBZVYRVXFWULWYSWWEWYT
      VKWULVYBWWEWWOVKXUFVXFPWULWWEVHVIXOXPZVWHWUAXQVWHVYPXQVYMVYTQZVYOAVYTRKZN
      OZWUHXUHVYNXUINVYMVYTARXRWOVYQIVYSXUJWUEWUGVYTIQXUIWUDNVYTIARXRWOVYTVYSQX
      UIWUFNVYTVYSARXRWOUXOWMXSWPVWHWUAVYKHVYPPWUAOZVYGOHZWUBVYKHVWHFWXAVYMIQZI
      VYMTOZVYMIWBKZJKZUIZMZEBVXGMZVSZWUAVYKVWHXUTEBVXGIQZIVYRWXIJKZUIZMWUAVWHE
      FBWXAVXGXUQXVCXUSXURWYNVWHXUSXQVWHXURXQVYMVXGQZXUMXVAXUPXVBIVYMVXGIUXPXVD
      XUNVYRXUOWXIJVYMVXGTUXQVYMVXGIWBUXRXTYAXSVWHEBXVCVYTWULXVAVYQXVBVYSIXVAVX
      GWWBQWULVYQWWBIVXGWWDUXSWULIVXFPWYMWWOWYIUXTUYAWULWXIVXFVYRJWXLVLYAVOVJVW
      HXUSPVYJVXCWXAUKKZULKOHZXURPXUSOZXVEVXCULKZOZHXUTVYKHVWHXUSVYJXVEYFKHZPVY
      JUYDZHXVFVWHXUSVYJVXCYFKHZXVJVWHEVXGVXCVYJVXCGBVYJXAVXCGYBOHZVWHVXCVXCXAZ
      UYBZSZWVNVWHEIVXFLVXCVXCVXCVXCGXVPVWHEIVXCVXCGGXVPXVPVXSVWHVESYCVWHEAVWOR
      VXCVXCVXCVXCGXVPVWHEAVXCVXCGGXVPXVPVWHYGZYCVWHEVXCGXVPYDRVXCVXCUYEKVXCYFK
      ZHVWHVXCXVNUYCSZYELXVRHVWHVXCXVNUYFSYEUYGVWHXVMXUSYHWXAUOZWXAGUOZXVLXVJVT
      XVPVWHBWXAXUSYIXVTVWHEBVXGWXAXUSWYNXUSXAZYJBWXAXUSUYHWFXWAVWHWXAWWTGWXDGW
      WSUYNUTZSWXAXUSVYJVXCGUYIWHXJVWHPBXVKVWHPWUTBVWHWVAWVBWUQUBHPWUTHWVDWVEWV
      LWURPWUQGYKWHDUYJZVWHVYJBYBOHZBXVKQVWHXVMXUEXWEXVOWVNBVXCGUYKWSBVYJUYLWFU
      YMPXUSVYJXVEXVKXVKXAYLYMVWHXURIXVHOZXVIGUMGUYOHZWXAGTWXAURZYIZXWAXURXWFHZ
      UMGUYPUYQWWTGTYIZWXAWWTUOXWIWWTTYHZTYIZXWLGUOXWKWWTXWLTUYRXWMUYSWWTXWLTUY
      TVQEXWLGVWOVUAVUBWWTXWLGTVUCUSWXDWWTGWXATVUDUSXWCXWGXWIXWAVUEIGXWHVUGKZVU
      HZHXWJIWXAXWOWVAVXSWYLIWXAHZWDVEXLWURIIGYKYNZFWXAIVYMJKZXWNIVYMJYSFWXAWXC
      VUFZVUIVUJFWXAIGXWHXURXVEVXCXVEXAXVNFWXAXUQXUMIXWNOZVYMXWHOZIXWHOZWBKZXUO
      JKZUIVYMWXAHZXUMIXWTXUPXXDIXWTQXXEXWTIFWXAXWRMZOZIIXWNXXFXWSVUKXWPXXGIQXW
      QFIXWRIWXAXXFXUMXWRIIJKIVYMIIJXRIVEVULWMXXFXAVUMYOVQVUNSXXEXUNXXCXUOJXXEX
      XCXUNPWBKXUNXXEXXAXUNXXBPWBVYMWXATYPXXEXXBITOZPXWPXXBXXHQXXEXWQIWXATYPXMV
      UOWMXTXXEXUNXXEVYMGHVYMPVGVBZXUNGHXXEVYMWWTHXXIWXAWWTVYMWXDVAVYMGPVUPVUQV
      YMVUSWFXGVURVMVUTVVAVVBVVCYNVWHXVGIXVHVWHXVGIAPRKZLKZIVWHPBHXVGXXKQXWDEPV
      XGXXKBXUSVWPVXFXXJILVWOPARXRVLXWBIXXJLYSYOWFVWHXXKWWBIVWHXXJPILAVVDVLWWDW
      MVJWOVVEPXUSXURVYJXVEVXCYQYMVVFVWHVYPVXCVXCYFKZHXUKGHXULVWHFVYNNVXCVXCVXC
      GXVPVWHFAVYMRVXCVXCVXCVXCGXVPVWHFAVXCVXCGGXVPXVPXVQYCVWHFVXCGXVPYDXVSYENX
      XLHVWHNGGVVGKXXLVVIVXCXVNVVHVVJSVVKVWHBGPWUAVWHEBVYTGWUAXUGWUAXAYJXWDVVLX
      UKVYPVXCVXCGGVXCXVOVVMZYLYMPWUAVYPVYJVXCVXCYQYMYRVWHVXCVVNHZXUEPBVXCVVROO
      ZHGGVXJYIVYHVYLVTXXNVWHVXCXVNVVOZSWVNVWHPBXXOXWDVWHXXNBVXCHXXOBQXXPVWHBWU
      TVXCDVWHWVAWVBWVCWUTVXCHWVDWVEWVMWURPWUQVXCGVXCXVNVVPVVSWHVVQBVXCVVTWSVWA
      VWHEGVXIGVXJVXPVWPVWMVXHGVWHVWMGHVXMVWPAVWBZWLVXRVXGVWQVXRVXSVYBWWNVEVYDW
      WPWSWWAYTXPVXJXAYJBPVXJVXCVXCGGXXMXXMVWCXIXKVWNPVXJVXCVXCGXXMVWDWHYRVWHEC
      VWMVWTVWLVXCVXDXXQVWHVWIUBHZVBZVWKVWIXXSVXSVWJGHVWKGHVEXXSAVWIVWHXXRWNXXR
      VWIGHVWHVWIVWEWQZXXRVWIPVGVWHVWIVWFWQXOIVWJWRWSXXTYTVWIVWQQZVWKVWSVWIVWQU
      DXYAVWJVWRILVWIVWQAJXRVLXYAYGXTXVNVXDXAVWGXK $.
  $}

  ${
    $d k x A $.  $d k F $.  $d k ph $.
    dfef2.1 $e |- ( ph -> F e. V ) $.
    dfef2.2 $e |- ( ph -> A e. CC ) $.
    dfef2.3 $e |- ( ( ph /\ k e. NN ) ->
                    ( F ` k ) = ( ( 1 + ( A / k ) ) ^ k ) ) $.
    $( The limit of the sequence ` ( 1 + A / k ) ^ k ` as ` k ` goes to ` +oo `
       is ` ( exp `` A ) ` .  This is another common definition of ` _e ` .
       (Contributed by Mario Carneiro, 1-Mar-2015.) $)
    dfef2 $p |- ( ph -> F ~~> ( exp ` A ) ) $=
      ( vx cn c1 cdiv co caddc cexp cfv cc wcel adantl a1i cv cmpt cli wbr crli
      ce ccxp wa cn0 wceq ax-1cn simpl cc0 wne nnne0 divcld addcl sylancr nnnn0
      nncn cxpexp syl2anc mpteq2dva crp wss nnrp cabs cmin ccom cbl eqid efrlim
      ssriv rlimres2 eqbrtrrd nnuz cz expcld fmptd rlimclim mpbid syl cvv mptex
      1z nnex oveq2 oveq2d id oveq12d ovex fvmpt eqtr4d climeq ) AIJKBIUAZLMZNM
      ZWOOMZUBZBUFPZUCUDZDWTUCUDABQRZXAGXBWSWTUEUDXAXBIJWQWOUGMZUBWSWTUEXBIJXCW
      RXBWOJRZUHZWQQRZWOUIRZXCWRUJXEKQRWPQRXFUKXEBWOXBXDULXDWOQRXBWOUTSXDWOUMUN
      XBWOUOSUPKWPUQURZXDXGXBWOUSSZWQWOVAVBVCXBIJVDXCWTJVDVEXBIJVDWOVFVMTBUMKBV
      GPKNMLMVGVHVIVJPMZIXJVKVLVNVOXBWTWSKJVPKVQRZXBWETXBIJWRQWSXEWQWOXHXIVRWSV
      KZVSVTWAWBAWTCWSDKWCEJVPWSWCRAIJWRWFWDTFXKAWETACUAZJRZUHXMWSPZKBXMLMZNMZX
      MOMZXMDPXNXOXRUJAIXMWRXRJWSWOXMUJZWQXQWOXMOXSWPXPKNWOXMBLWGWHXSWIWJXLXQXM
      OWKWLSHWMWNWA $.
  $}

  ${
    $d n x y A $.
    $( A power to a negative exponent goes to zero as the base becomes large.
       (Contributed by Mario Carneiro, 15-Sep-2014.)  (Revised by Mario
       Carneiro, 18-May-2016.) $)
    cxplim $p |- ( A e. RR+ -> ( n e. RR+ |-> ( 1 / ( n ^c A ) ) ) ~~>r 0 ) $=
      ( vy vx crp wcel c1 cv ccxp co cdiv cc0 wbr clt wral cr wa wne ad2antrr
      cc cmpt crli cabs cfv wi wrex cneg rpre adantl rpge0 renegcld adantr rpcn
      cle rpne0 negne0d rereccld recxpcld wceq rpcxpcld rpreccld rprege0d absid
      simprl syl simplr simprr rpreccl cxprecd ad2antlr cxpnegd ax-1cn divneg2d
      rpcnd a1i oveq2d 3eqtr2d cmul recidd cxpmuld cxp1d 3eqtr3d 3brtr4d rpge0d
      rpred cxplt2d mpbird ltrec1d eqbrtrd expr ralrimiva imbi1d ralbidv rspcev
      breq1 syl2anc id rpcxpcl syl2anr wss rpssre rlim0lt ) AEFZBEGBHZAIJZKJZUA
      LUBMCHZXDNMZXFUCUDZDHZNMZUEZBEOZCPUFZDEOXCXNDEXCXJEFZQZXJGAUGZKJZIJZPFXSX
      DNMZXKUEZBEOZXNXPXJXRXOXJPFXCXJUHUIXOLXJUNMXCXJUJUIXPXQXCXQPFXOXCAAUHZUKU
      LXCXQLRXOXCAAUMZAUOZUPULUQURXPYABEXPXDEFZXTXKXPYFXTQZQZXIXFXJNYHXFPFLXFUN
      MQXIXFUSYHXFYHXEYHXDAXPYFXTVDZXCAPFZXOYGYCSZUTZVAVBXFVCVEYHXJXEXCXOYGVFZY
      LYHGXJKJZXENMYNGAKJZIJZXEYOIJZNMYHXSXDYPYQNXPYFXTVGYHYPGXJYOIJKJXJYOUGZIJ
      XSYHXJYOYMYHYOXCYOEFXOYGAVHSZVNZVIYHXJYOXOXJTFXCYGXJUMVJXOXJLRXCYGXJUOVJY
      TVKYHYRXRXJIYHGAGTFYHVLVOXCATFXOYGYDSZXCALRXOYGYESZVMVPVQYHXDAYOVRJZIJXDG
      IJYQXDYHUUCGXDIYHAUUAUUBVSVPYHXDAYOYIYKYTVTYHXDYHXDYIVNWAWBWCYHYNXEYOYHYN
      XOYNEFXCYGXJVHVJZWEYHYNUUDWDYHXEYLWEYHXEYLWDYSWFWGWHWIWJWKXMYBCXSPXGXSUSZ
      XLYABEUUEXHXTXKXGXSXDNWOWLWMWNWPWKXCDCBEXFXCXFTFBEXCYFQZXFUUFXEYFYFYJXEEF
      XCYFWQYCXDAWRWSVAVNWKEPWTXCXAVOXBWG $.

    $( The inverse square root function converges to zero.  (Contributed by
       Mario Carneiro, 18-May-2016.) $)
    sqrlim $p |- ( n e. RR+ |-> ( 1 / ( sqr ` n ) ) ) ~~>r 0 $=
      ( crp c1 cv c2 cdiv ccxp cmpt csqr cfv cc0 crli wcel wceq rpcn cxpsqr syl
      co cc oveq2d mpteq2ia wbr 1rp rphalfcl cxplim mp2b eqbrtrri ) ABCADZCEFRZ
      GRZFRZHZABCUHIJZFRZHKLABUKUNUHBMZUJUMCFUOUHSMUJUMNUHOUHPQTUACBMUIBMULKLUB
      UCCUDUIAUEUFUG $.
  $}

  ${
    $d n x y A $.  $d x y B $.  $d n x y C $.  $d n x y ph $.
    rlimcxp.1 $e |- ( ( ph /\ n e. A ) -> B e. V ) $.
    rlimcxp.2 $e |- ( ph -> ( n e. A |-> B ) ~~>r 0 ) $.
    rlimcxp.3 $e |- ( ph -> C e. RR+ ) $.
    $( Any power to a positive exponent of a converging sequence also
       converges.  (Contributed by Mario Carneiro, 18-Sep-2014.) $)
    rlimcxp $p |- ( ph -> ( n e. A |-> ( B ^c C ) ) ~~>r 0 ) $=
      ( vy ccxp co cc0 wbr clt wral cr wcel cc adantr vx cmpt crli cle cabs cfv
      cv wi wrex crp wa cmin c1 cdiv cdm rlimf syl ralrimiva dmmptg feq2d mpbid
      wf wceq eqid fmpt sylibr simpr rprecred rpcxpcld rlimi rlimmptrcl adantlr
      abscld absge0d rpred rpge0d cxplt2d subid1d fveq2d breq1d abscxp2 syl2anc
      ad2antrr cmul rpcnd rpne0d recid2d oveq2d simplr cxpmuld 3eqtr3rd breq12d
      cxp1d 3bitr4d biimpd imim2d ralimdva reximdv cxpcld rlimss eqsstr3d rlim0
      mpd wss mpbird ) AEBCDKLZUBMUCNJUGEUGZUDNZXFUEUFZUAUGZONZUHZEBPZJQUIZUAUJ
      PAXNUAUJAXJUJRZUKZXHCMULLZUEUFZXJUMDUNLZKLZONZUHZEBPZJQUIXNXPJEBCMXTSACSR
      ZEBPZXOABSEBCUBZVBZYEAYFUOZSYFVBZYGAYFMUCNZYIHMYFUPUQAYHBSYFACFRZEBPYHBVC
      AYKEBGUREBCFUSUQZUTVAEBSCYFYFVDVEVFTXPXJXSAXOVGXPDADUJRZXOITVHZVIZAYJXOHT
      VJXPYCXMJQXPYBXLEBXPXGBRZUKZYAXKXHYQYAXKYQCUEUFZXTONYRDKLZXTDKLZONYAXKYQY
      RXTDYQCAYPYDXOABCMEFGHVKZVLZVMYQCUUBVNYQXTXPXTUJRYPYOTZVOYQXTUUCVPAYMXOYP
      IWCZVQYQXRYRXTOYQXQCUEYQCUUBVRVSVTYQXIYSXJYTOYQYDDQRXIYSVCUUBYQDUUDVOCDWA
      WBYQXJXSDWDLZKLXJUMKLYTXJYQUUEUMXJKYQDYQDUUDWEZYQDUUDWFWGWHYQXJXSDAXOYPWI
      ZXPXSQRYPYNTUUFWJYQXJYQXJUUGWEWMWKWLWNWOWPWQWRXCURAUAJEBXFAXFSREBAYPUKCDU
      UAADSRYPADIWETWSURABYHQYLAYJYHQXDHMYFWTUQXAXBXE $.
  $}

  ${
    $d m x y z A $.  $d m y z B $.  $d m x y z C $.  $d m x y z ph $.
    o1cxp.1 $e |- ( ph -> C e. CC ) $.
    o1cxp.2 $e |- ( ph -> 0 <_ ( Re ` C ) ) $.
    o1cxp.3 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    o1cxp.4 $e |- ( ph -> ( x e. A |-> B ) e. O(1) ) $.
    $( An eventually bounded function taken to a nonnegative power is
       eventually bounded.  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    o1cxp $p |- ( ph -> ( x e. A |-> ( B ^c C ) ) e. O(1) ) $=
      ( vz cle wbr cfv cr ccxp wcel cc wa cc0 vy vm cv cmpt cabs wi wral co co1
      wrex wf cdm o1f syl wceq ralrimiva dmmptg feq2d mpbid syl2anc cif cre cpi
      o1bdd cmul simpr eqid fvmpt2 oveq1d cvv ovex sylancl eqtr4d nffvmpt1 nfcv
      ce nfv nfov fveq2 eqeq12d cbvral sylib r19.21bi ad2ant2r fveq2d ffvelrnda
      nfeq ad2antrr simprr 0re ifcl adantr abscld max2 letrd abscxpbnd eqbrtrrd
      sylancr expr imim2d ralimdva wss o1mptrcl cxpcld fmptd o1dm eqsstr3d max1
      simprl recxpcld pire remulcl reefcld remulcld elo12r 3expia syl22anc syld
      recld rexlimdvva mpd ) AUAUCZKUCZLMZYCBCDUDZNZUENZUBUCZLMZUFZKCUGZUBOUJUA
      OUJZBCDEPUHZUDZUIQZAYEUIQZCRYEUKZYLJAYEULZRYEUKZYQAYPYSJYEUMUNAYRCRYEADFQ
      ZBCUGYRCUOAYTBCIUPBCDFUQUNZURUSZUAKCUBYEVDUTAYKYOUAUBOOAYBOQZYHOQZSZSZYKY
      DYCYNNZUENZTYHLMZYHTVAZEVBNZPUHZEUENZVCVEUHZVPNZVEUHZLMZUFZKCUGZYOUUFYJUU
      RKCUUFYCCQZSYIUUQYDUUFUUTYIUUQUUFUUTYISZSZYFEPUHZUENUUHUUPLUVBUVCUUGUEAUU
      TUVCUUGUOZUUEYIAUVDKCABUCZYENZEPUHZUVEYNNZUOZBCUGUVDKCUGAUVIBCAUVECQZSZUV
      GYMUVHUVKUVFDEPUVKUVJYTUVFDUOAUVJVFZIBCDFYEYEVGVHUTVIUVKUVJYMVJQUVHYMUOUV
      LDEPVKBCYMVJYNYNVGZVHVLVMUPUVIUVDBKCUVIKVQBUVCUUGBYFEPBCDYCVNBPVOBEVOVRBC
      YMYCVNWGUVEYCUOZUVGUVCUVHUUGUVNUVFYFEPUVEYCYEVSVIUVEYCYNVSVTWAWBWCWDWEUVB
      YFEUUJAUUTYFRQUUEYIACRYCYEUUBWFWDZAERQZUUEUVAGWHATUUKLMUUEUVAHWHUUFUUJOQZ
      UVAUUFUUDTOQZUVQAUUCUUDWIZWJUUIYHTOWKVLZWLZUVBYGYHUUJUVBYFUVOWMUUFUUDUVAU
      VSWLUWAUUFUUTYIWIUUFYHUUJLMZUVAUUFUVRUUDUWBWJUVSTYHWNWRWLWOWPWQWSWTXAUUFC
      RYNUKZCOXBZUUCUUPOQZUUSYOUFAUWCUUEABCYMRYNUVKDEABCDFIJXCAUVPUVJGWLXDUVMXE
      WLAUWDUUEACYROUUAAYPYROXBJYEXFUNXGWLAUUCUUDXIUUFUULUUOUUFUUJUUKUVTUUFUVRU
      UDTUUJLMWJUVSTYHXHWRUUFEAUVPUUEGWLZXSXJUUFUUNUUFUUMOQVCOQUUNOQUUFEUWFWMXK
      UUMVCXLVLXMXNUWCUWDSUUCUWESUUSYOKCYBYNUUPXOXPXQXRXTYA $.
  $}

  ${
    $d m n x y z A $.  $d n B $.
    $( A linear factor grows slower than any exponential with base greater than
       ` 1 ` .  (Contributed by Mario Carneiro, 15-Sep-2014.) $)
    cxp2limlem $p |- ( ( A e. RR /\ 1 < A ) ->
      ( n e. RR+ |-> ( n / ( A ^c n ) ) ) ~~>r 0 ) $=
      ( cr wcel c1 clt wbr crp c2 cexp co cdiv cc0 cc rpcnd rpred adantr rpne0d
      a1i cmul wa clog cfv cv ccxp 0re cmpt crli 2rp cz rplogcl rpexpcl sylancl
      2z rpdivcl sylancr divrcnv syl rerpdivcl sylan simpr simpl 1re 0lt1 lttrd
      elrpd rpcxpcl syl2an rpdivcld cle ce caddc rpmulcld resqcld rehalfcld 1rp
      rpre rpaddcl readdcld reefcld ltaddrp2d efgt1p2 adantl recnd 2cn wne 2ne0
      sqcld divdiv2d sqmuld oveq1d eqtr4d cxpefd 3brtr4d ltdiv2d mpbid divcan5d
      sqvald oveq2d rpne0 3eqtrd breqtrd ltled adantrr rpge0d rlimsqz2 ) ACDZEA
      FGZUAZBHIAUBUCZIJKZLKZBUDZLKZXMAXMUEKZLKZMMMCDXIUFSZXQXIXLNDZBHXNUGMUHGXI
      XLXIIHDXKHDZXLHDZUIXIXJHDZIUJDZXSAUKZUNXJIULUMZIXKUOUPZOZXLBUQURXIXLCDXMH
      DZXNCDXIXLYEPXLXMUSUTZXIYGUAZXPYIXMXOXIYGVAZXIAHDZXMCDZXOHDYGXIAXGXHVBZXI
      MEAXQECDXIVCSYMMEFGXIVDSXGXHVAVEVFZXMVQZAXMVGVHZVIZPZXIYGXPXNVJGMXMVJGZYI
      XPXNYRYHYIXPXMXMIJKZXLLKZLKZXNFYIUUAXOFGXPUUBFGYIXMXJTKZIJKZILKZUUCVKUCZU
      UAXOFYIUUEEUUCVLKZUUEVLKZUUFYIUUDYIUUCYIUUCYIXMXJYJXIYAYGYCQVMZPZVNVOZYIU
      UGUUEYIUUGYIEHDUUCHDZUUGHDVPUUIEUUCVRUPZPUUKVSYIUUCUUJVTYIUUEUUGUUKUUMWAY
      IUULUUHUUFFGUUIUUCWBURVEYIUUAYTXKTKZILKUUEYIYTIXKYIXMYIXMYGYLXIYOWCWDZWHZ
      INDYIWESYIXKXIXSYGYDQZOIMWFYIWGSYIXKUUQRWIYIUUDUUNILYIXMXJUUOXIXJNDYGXIXJ
      YCOQWJWKWLYIAXMXIANDYGXIAYMWDQYIAXIYKYGYNQRUUOWMWNYIUUAXOXMYIYTXLYIYGYBYT
      HDYJUNXMIULUMZXIXTYGYEQZVIYPYJWOWPYIUUBXMXLTKZYTLKUUTXMXMTKZLKXNYIXMYTXLU
      UOUUPXIXRYGYFQZYIYTUURRYIXLUUSRWIYIYTUVAUUTLYIXMUUOWRWSYIXLXMXMUVBUUOUUOY
      GXMMWFXIXMWTWCZUVCWQXAXBXCXDXIYGMXPVJGYSYIXPYQXEXDXF $.

    $( Any power grows slower than any exponential with base greater than
       ` 1 ` .  (Contributed by Mario Carneiro, 18-Sep-2014.) $)
    cxp2lim $p |- ( ( A e. RR /\ B e. RR /\ 1 < B ) ->
      ( n e. RR+ |-> ( ( n ^c A ) / ( B ^c n ) ) ) ~~>r 0 ) $=
      ( cr wcel clt wbr crp ccxp cdiv cmpt cc0 crli cle 1re a1i rpcxpcld adantr
      c1 co w3a cv cpnf cico cres wss wceq wa wb elicopnf ax-mp simplbi simprbi
      0re 0lt1 ltletrd elrpd ssriv resmpt rpre adantl rpge0 simpl2 simpl3 lttrd
      cif simp1 ifcl sylancl max1 sylancr rprecred cc recnd divcxpd cmul rpne0d
      recid2d oveq2d cxpmuld rpcnd cxp1d 3eqtr3d eqtrd mpteq2dva cvv ovex simp2
      mulcomd simp3 rpred 1cxpd 0le1 rpreccld cxplt2d mpbid eqbrtrrd cxp2limlem
      rpge0d syl2anc eqbrtrd rlimcxp rlimres2 simpr rpdivcld sylan2 simpl1 max2
      cxplead lediv1dd adantrr rlimsqz2 syl5eqbr fmptd rpssre rlimresb mpbird
      eqid ) ADEZBDEZSBFGZUAZCHCUBZAITZBYCITZJTZKZLMGYGSUCUDTZUEZLMGYBYICYHYFKZ
      LMYHHUFZYIYJUGCYHHYCYHEZYCYLYCDEZSYCNGZSDEZYLYMYNUHUIOSYCUJUKZULZYLLSYCLD
      EZYLUNPYOYLOPYQLSFGZYLUOPYLYMYNYPUMZUPUQZURZCHYHYFUSUKYBCYHYCSANGZASVFZIT
      ZYEJTZYFLLYRYBUNPZUUGYBCYHHUUFLYKYBUUBPYBCHYCYESUUDJTZITZJTZUUDITZKCHUUFK
      LMYBCHUUKUUFYBYCHEZUHZUUKUUEUUIUUDITZJTUUFUUMYCUUIUUDUULYMYBYCUTVAZUULLYC
      NGZYBYCVBVAUUMYEUUHUUMBYCUUMBXSXTYAUULVCZUUMLSBYRUUMUNPYOUUMOPUUQYSUUMUOP
      XSXTYAUULVDVEUQZUUOQZYBUUHDEUULYBUUDYBUUDYBXSYOUUDDEZXSXTYAVGZOUUCASDVHVI
      ZYBLSUUDUUGYOYBOPZUVBYSYBUOPZYBYOXSSUUDNGOUVASAVJVKUPUQZVLZRZQYBUUDVMEUUL
      YBUUDUVBVNRZVOUUMUUNYEUUEJUUMYEUUHUUDVPTZITYESITUUNYEUUMUVISYEIUUMUUDUVHU
      UMUUDYBUUDHEUULUVERVQVRVSUUMYEUUHUUDUUSUVGUVHVTUUMYEUUMYEUUSWAWBWCVSWDWEY
      BHUUJUUDCWFUUJWFEUUMYCUUIJWGPYBCHUUJKCHYCBUUHITZYCITZJTZKZLMYBCHUUJUVLUUM
      UUIUVKYCJUUMBYCUUHVPTZITBUUHYCVPTZITUUIUVKUUMUVNUVOBIUUMYCUUHUUMYCUUOVNZY
      BUUHVMEUULYBUUHUVFVNZRZWIVSUUMBYCUUHUURUUOUVRVTUUMBUUHYCUURUVGUVPVTWCVSWE
      YBUVJDESUVJFGUVMLMGYBUVJYBBUUHYBBXSXTYAWHZYBLSBUUGUVCUVSUVDXSXTYAWJZVEUQZ
      UVFQWKYBSUUHITZSUVJFYBUUHUVQWLYBYAUWBUVJFGUVTYBSBUUHUVCLSNGYBWMPUVSYBBUWA
      WSYBUUDUVEWNWOWPWQUVJCWRWTXAUVEXBWQXCYLYBUULUUFDEUUAUUMUUFUUMUUEYEUUMYCUU
      DYBUULXDZYBUUTUULUVBRQZUUSXEWKXFYBYLUHZYFYLYBUULYFHEUUAUUMYDYEUUMYCAUWCXS
      XTYAUULXGQZUUSXEZXFZWKYBYLYFUUFNGUUPUWEYDUUEYEUWEYDYLYBUULYDHEUUAUWFXFWKU
      WEUUEYLYBUULUUEHEUUAUWDXFWKYLYBUULYEHEUUAUUSXFUWEYCAUUDYLYMYBYQVAYLYNYBYT
      VAXSXTYAYLXGZYBUUTYLUVBRUWEYOXSAUUDNGOUWISAXHVKXIXJXKYBYLLYFNGUUPUWEYFUWH
      WSXKXLXMYBHSLYGYBCHYFVMYGUUMYFUWGWAYGXRXNHDUFYBXOPUVCXPXQ $.

    $( The logarithm grows slower than any positive power.  (Contributed by
       Mario Carneiro, 18-Sep-2014.) $)
    cxploglim $p |- ( A e. RR+ ->
      ( n e. RR+ |-> ( ( log ` n ) / ( n ^c A ) ) ) ~~>r 0 ) $=
      ( vm vz vx crp wcel cv ce cfv co cdiv wbr cr c1 clt cabs wi wral wa efgt1
      vy ccxp cmpt cc0 crli clog rpre reefcl syl cxp2limlem syl2anc wrex adantl
      cle cif 1re ifcl sylancl wb a1i adantr maxlt syl3anc simprrr wceq reeflog
      ad2antrl breqtrrd simplr simprrl rplogcld rpred eflt mpbird breq2 oveq12d
      id oveq2 fveq2d breq1d imbi12d rspcv mpid cmul ad2antrr relogefd rpcnd cc
      oveq2d rpcn mulcomd eqtrd recnd wne efne0 cxpefd rpne0 sylibd expr sylbid
      3eqtr4d com23 ralrimdva breq1 imbi1d ralbidv rspcev ralimdv simpr rpefcld
      ee12an rexlimdva rpcxpcld ralrimiva wss rpssre rlim0lt relogcl rerpdivcld
      rpdivcld 3imtr4d mpd ) AFGZCFCHZAIJZYEUCKZLKZUDUEUFMZBFBHZUGJZYJAUCKZLKZU
      DUEUFMZYDYFNGZOYFPMYIYDANGZYOAUHZAUIUJZAUAYFCUKULYDDHZYEPMZYHQJZEHZPMZRZC
      FSZDNUMZEFSUBHZYJPMZYMQJZUUBPMZRZBFSZUBNUMZEFSYIYNYDUUFUUMEFYDUUEUUMDNYDY
      SNGZTZOYSIJZUOMZUUPOUPZNGZUUEUURYJPMZUUJRZBFSZUUMUUOUUPNGZONGZUUSUUNUVCYD
      YSUIUNZUQUUQUUPONURUSUUOUUEUVABFUUOYJFGZTZUUTUUEUUJUVGUUTOYJPMZUUPYJPMZTZ
      UUEUUJRZUVGUVDUVCYJNGZUUTUVJUTUVDUVGUQVAUUOUVCUVFUVEVBUVFUVLUUOYJUHZUNOUU
      PYJVCVDUUOUVFUVJUVKUUOUVFUVJTZTZUUEYKYFYKUCKZLKZQJZUUBPMZUUJUVOUUEYSYKPMZ
      UVSUVOUVTUUPYKIJZPMZUVOUUPYJUWAPUUOUVFUVHUVIVEUVFUWAYJVFUUOUVJYJVGVHVIUVO
      UUNYKNGZUVTUWBUTYDUUNUVNVJUVOYKUVOYJUVFUVLUUOUVJUVMVHUUOUVFUVHUVIVKVLZVMY
      SYKVNULVOUVOYKFGUUEUVTUVSRZRUWDUUDUWECYKFYEYKVFZYTUVTUUCUVSYEYKYSPVPUWFUU
      AUVRUUBPUWFYHUVQQUWFYEYKYGUVPLUWFVRYEYKYFUCVSVQVTWAWBWCUJWDUVOUVRUUIUUBPU
      VOUVQYMQUVOUVPYLYKLUVOYKYFUGJZWEKZIJAYKWEKZIJUVPYLUVOUWHUWIIUVOUWHYKAWEKU
      WIUVOUWGAYKWEUVOAYDYPUUNUVNYQWFWGWJUVOYKAUVOYKUWDWHZYDAWIGZUUNUVNAWKWFZWL
      WMVTUVOYFYKUVOYFYDYOUUNUVNYRWFWNUVOUWKYFUEWOUWLAWPUJUWJWQUVOYJAUVFYJWIGUU
      OUVJYJWKVHUVFYJUEWOUUOUVJYJWRVHUWLWQXBWJVTWAWSWTXAXCXDUULUVBUBUURNUUGUURV
      FZUUKUVABFUWMUUHUUTUUJUUGUURYJPXEXFXGXHXLXMXIYDEDCFYHYDYHWIGCFYDYEFGZTZYH
      UWOYEYGYDUWNXJUWOYFYEUWOAYDYPUWNYQVBXKUWNYENGYDYEUHUNXNYAWHXOFNXPYDXQVAZX
      RYDEUBBFYMYDYMWIGBFYDUVFTZYMUWQYKYLUVFUWCYDYJXSUNUWQYJAYDUVFXJYDYPUVFYQVB
      XNXTWNXOUWPXRYBYC $.

    $( Every power of the logarithm grows slower than any positive power.
       (Contributed by Mario Carneiro, 20-May-2016.) $)
    cxploglim2 $p |- ( ( A e. CC /\ B e. RR+ ) -> ( n e. RR+ |->
      ( ( ( log ` n ) ^c A ) / ( n ^c B ) ) ) ~~>r 0 ) $=
      ( wcel crp wa cfv c1 cle wbr cdiv co ccxp cc0 c3 cr a1i clt cabs ceu clog
      cc cv cre cif 3re 0re recnd cvv ovex cmpt crli simpr recl adantr 1re ifcl
      sylancl 0lt1 max1 sylancr ltletrd elrpd rpdivcld cxploglim syl rlimmptrcl
      rlimcxp cxpcld relogcl adantl simpll rpre ad2antlr rpcxpcld rpne0d divcld
      rpcnd cmin adantrr abscld ad2antrl 1lt3 simprr rplogcld rerpdivcld abscxp
      rpred wceq syl2anc recld max2 loge ere c2 egt2lt3 simpri epr logltb mpbid
      wb syl5eqbrr cxpled eqbrtrd lediv1dd absdivd rprege0d absid oveq2d divcxp
      eqtrd syl3anc cxpmuld divcan1d eqtr3d 3brtr4d leabsd letrd subid1d fveq2d
      cmul rlimsqzlem ) AUBDZBEDZFZCECUCZUAGZYFBHAUDGZIJZYHHUEZKLZMLZKLZYJMLZYG
      AMLZYFBMLZKLZNNOOPDZYEUFQYENNPDYEUGQZUHYEEYMYJCUIYMUIDYEYFEDZFZYGYLKUJQZY
      EYKEDCEYMUKNULJYEBYJYCYDUMYEYJYEYHPDZHPDZYJPDZYCUUCYDAUNUOZUPYIYHHPUQURZY
      ENHYJYSUUDYEUPQUUGNHRJYEUSQYEUUDUUCHYJIJUPUUFHYHUTVAVBVCZVDYKCVEVFZUUHVHU
      UAYMYJYEEYMNCUIUUBUUIVGUUAYJYEUUEYTUUGUOUHVIZUUAYOYPUUAYGAUUAYGYTYGPDZYEY
      FVJZVKUHYCYDYTVLVIZUUAYPUUAYFBYEYTUMZYDBPDZYCYTBVMZVNVOZVRZUUAYPUUQVPZVQZ
      YEYTOYFIJZFZFZYQSGZYNSGZYQNVSLZSGYNNVSLZSGIUVCUVDYNUVEUVCYQYEYTYQUBDUVAUU
      TVTZWAUVCYNUVCYMYJUVCYGYLUVCYFYTYFPDYEUVAYFVMWBZUVCHOYFUUDUVCUPQYRUVCUFQZ
      UVIHORJUVCWCQYEYTUVAWDZVBWEZUVCYFYKYEYTYTUVAUUNVTZUVCBYJYDUUOYCUVBUUPVNZY
      EYJEDUVBUUHUOZWFZVOZVDYEUUEUVBUUGUOZVOWHZUVCYNYEYTYNUBDUVAUUJVTZWAUVCYOSG
      ZYPKLZYGYJMLZYPKLZUVDYNIUVCUWAUWCYPUVCYOYEYTYOUBDUVAUUMVTWAUVCUWCUVCYGYJU
      VLUVRVOWHYEYTYPEDUVAUUQVTZUVCUWAYGYHMLZUWCIUVCYGEDYCUWAUWFWIUVLYCYDUVBVLZ
      YGAWGWJUVCYHYJIJZUWFUWCIJUVCUUDUUCUWHUPUVCAUWGWKZHYHWLVAUVCYGYHYJYTUUKYEU
      VAUULWBUVCHTUAGZYGRWMUVCTYFRJZUWJYGRJZUVCTOYFTPDUVCWNQUVJUVITORJZUVCWOTRJ
      UWMWPWQQUVKVBUVCTEDYTUWKUWLXAWRUVMTYFWSVAWTXBUWIUVRXCWTXDXEUVCUVDUWAYPSGZ
      KLZUWBYEYTUVDUWOWIUVAUUAYOYPUUMUURUUSXFVTUVCUWNYPUWAKUVCYPPDNYPIJFUWNYPWI
      UVCYPUWEXGYPXHVFXIXKUVCYNUWCYLYJMLZKLZUWDUVCUUKNYGIJFYLEDYJUBDZYNUWQWIUVC
      YGUVLXGUVQYEUWRUVBYEYJUUGUHUOZYGYLYJXJXLUVCUWPYPUWCKUVCYFYKYJYALZMLUWPYPU
      VCYFYKYJUVMUVPUWSXMUVCUWTBYFMUVCBYJUVCBUVNUHUWSUVCYJUVOVPXNXIXOXIXKXPUVCY
      NUVSXQXRUVCUVFYQSUVCYQUVHXSXTUVCUVGYNSUVCYNUVTXSXTXPYB $.
  $}

  ${
    $d c d e x y $.  $d n x B $.  $d c e y z F $.  $d y z L $.  $d n y z ph $.
    $d a b c n x z A $.
    divsqrsum.2 $e |- F = ( x e. RR+ |->
       ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( 1 / ( sqr ` n ) ) -
         ( 2 x. ( sqr ` x ) ) ) ) $.
    $( Lemma for ~ divsqrsum and ~ divsqrsum2 .  (Contributed by Mario
       Carneiro, 18-May-2016.) $)
    divsqrsumlem $p |- ( F : RR+ --> RR /\ F e. dom ~~>r /\
      ( ( F ~~>r L /\ A e. RR+ ) ->
        ( abs ` ( ( F ` A ) - L ) ) <_ ( 1 / ( sqr ` A ) ) ) ) $=
      ( crp cr wcel wbr wa co c1 cdiv cle wtru cc0 c2 a1i cc crli cdm cmin cabs
      wf cfv csqr wi w3a cv cmul cn cpnf cioo ioorp eqcomi nnuz cz 1z 0re caddc
      1re 0nn0 nn0addge2i 2re rpsqrcl adantl rpred remulcl rprecred nnrp sylan2
      sylancr cmpt cdv cpr reex prid1 rpcnd 2rp rpmulcl rpreccld wceq dvsqr 2cn
      dvmptcmul ax-1cn rpcnne0d divass syl3anc rpcnne0 divcan5 eqtr3d mpteq2dva
      wne mp1i eqtrd fveq2 oveq2d simp3r wb simp2l rprege0d sqrle syl2anc mpbid
      simp2r rpsqrcld lerecd sqrlim dvfsumrlim3 simp1d trud simp2d rpge0 simp3d
      mpd3an3 3pm3.2i ) GHDUEZDUAUBIZDEUAJZBGIZKBDUFEUCLUDUFMBUGUFZNLZOJZUHXSPX
      SXTYAYBQBOJZUIYEUHZPARAUJZUGUFZUKLZMYINLZMCUJZUGUFZNLZQGQCYDDEMHBULQUMUNL
      GUOUPUQMURIPUSSQHIPUTSZMQMVALOJPMQVBVCVDSYOPYHGIZKZRHIYIHIYJHIVEYQYIYPYIG
      IZPYHVFVGZVHRYIVIVMYQYIYSVJZYHULIPYPYKHIYHVKYTVLPHAGYJVNVOLAGRMYJNLZUKLZV
      NAGYKVNZPAYIUUARHGGHHTVPIPHTVQVRSYQYIYSVSYQYJYQRGIZYRYJGIVTYSRYIWAVMZWBHA
      GYIVNVOLAGUUAVNWCPAWDSRTIZPWESWFPAGUUBYKYQRMUKLYJNLZUUBYKYQUUFMTIZYJTIYJQ
      WOKUUGUUBWCUUFYQWESUUHYQWGSZYQYJUUEWHRMYJWIWJYQUUHYITIYIQWOKUUFRQWOKZUUGY
      KWCUUIYQYIYSWHUUDUUJYQVTRWKWPMYIRWLWJWMWNWQYHYLWCYIYMMNYHYLUGWRWSPYPYLGIZ
      KZQYHOJZYHYLOJZKZUIZYIYMOJZYNYKOJUUPUUNUUQPUULUUMUUNWTUUPYHHIUUMKYLHIQYLO
      JKUUNUUQXAUUPYHPYPUUKUUOXBZXCUUPYLPYPUUKUUOXGZXCYHYLXDXEXFUUPYIYMUUPYHUUR
      XHUUPYLUUSXHXIXFFUUCQUAJPAXJSYHBWCYIYCMNYHBUGWRWSXKZXLXMXTPXSXTYGUUTXNXMY
      AYBYFYEYBYFYABXOVGYGPXSXTYGUUTXPXMXQXR $.

    $( The function ` F ` used in ~ divsqrsum is a real function.  (Contributed
       by Mario Carneiro, 12-May-2016.) $)
    divsqrsumf $p |- F : RR+ --> RR $=
      ( crp cr wf crli cdm wcel c1 wbr wa cfv cmin co cabs csqr cdiv cle simp1i
      wi divsqrsumlem ) EFCGCHIJCKHLKEJMKCNKOPQNKKRNSPTLUBAKBCKDUCUA $.

    $( The sum ` sum_ n <_ x ( 1 / sqr n ) ` is asymptotic to ` 2 sqr x + L `
       with a finite limit ` L ` .  (In fact, this limit is
       ` zeta ( 1 / 2 ) ~~ -u 1 . 4 6 ... ` .)  (Contributed by Mario Carneiro,
       9-May-2016.) $)
    divsqrsum $p |- F e. dom ~~>r $=
      ( crp cr wf crli cdm wcel c1 wbr wa cfv cmin co cabs csqr cdiv cle simp2i
      wi divsqrsumlem ) EFCGCHIJCKHLKEJMKCNKOPQNKKRNSPTLUBAKBCKDUCUA $.

    divsqrsum2.1 $e |- ( ph -> F ~~>r L ) $.
    $( A bound on the distance of the sum ` sum_ n <_ x ( 1 / sqr n ) ` from
       its asymptotic value ` 2 sqr x + L ` .  (Contributed by Mario Carneiro,
       18-May-2016.) $)
    divsqrsum2 $p |- ( ( ph /\ A e. RR+ ) ->
      ( abs ` ( ( F ` A ) - L ) ) <_ ( 1 / ( sqr ` A ) ) ) $=
      ( crli wbr crp wcel cfv cmin co cabs c1 csqr cdiv cle cr cdm divsqrsumlem
      wf wa wi simp3i sylan ) AEFIJZCKLZCEMFNOPMQCRMSOTJZHKUAEUDEIUBLUIUJUEUKUF
      BCDEFGUCUGUH $.

    $( The sum ` sum_ n <_ x ( 1 / sqr n ) ` has the asymptotic expansion
       ` 2 sqr x + L + O ( 1 / sqr x ) ` , for some ` L ` .  (Contributed by
       Mario Carneiro, 10-May-2016.) $)
    divsqrsumo1 $p |- ( ph ->
      ( y e. RR+ |-> ( ( ( F ` y ) - L ) x. ( sqr ` y ) ) ) e. O(1) ) $=
      ( crp cfv co cmul c1 cr a1i wcel wa cabs cle wbr cmin csqr wss divsqrsumf
      cv rpssre ffvelrni cxr csup cpnf wceq rpsup cmpt crli wf feqmptd eqbrtrrd
      clt adantl rlimrecl resubcl syl2anr recnd rpsqrcl mulcld absmuld rprege0d
      rpcnd 1re cc0 absid oveq2d eqtrd cdiv divsqrsum2 abscld lemuldivd eqbrtrd
      syl mpbird adantrr elo1d ) ACICUEZEJZFUAKZWCUBJZLKZMMINUCAUFOAWCIPZQZWEWF
      WIWEWHWDNPZFNPWENPAINWCEBDEGUDZUGZACIWDFIUHURUIUJUKAULOAECIWDUMFUNACINEIN
      EUOAWKOUPHUQWHWJAWLUSUTWDFVAVBVCZWIWFWHWFIPAWCVDUSZVHZVEMNPZAVIOZWQAWHWGR
      JZMSTMWCSTWIWRWERJZWFLKZMSWIWRWSWFRJZLKWTWIWEWFWMWOVFWIXAWFWSLWIWFNPVJWFS
      TQXAWFUKWIWFWNVGWFVKVSVLVMWIWTMSTWSMWFVNKSTABWCDEFGHVOWIWSMWFWIWEWMVPWPWI
      VIOWNVQVTVRWAWB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Inequality of arithmetic and geometric means
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y D $.  $d x y ph $.  $d x y X $.  $d x y Y $.
    cvxcl.1 $e |- ( ph -> D C_ RR ) $.
    cvxcl.2 $e |- ( ( ph /\ ( x e. D /\ y e. D ) ) -> ( x [,] y ) C_ D ) $.
    $( Closure of a 0-1 linear combination in a convex set.  (Contributed by
       Mario Carneiro, 21-Jun-2015.) $)
    cvxcl $p |- ( ( ph /\ ( X e. D /\ Y e. D /\ T e. ( 0 [,] 1 ) ) ) ->
      ( ( T x. X ) + ( ( 1 - T ) x. Y ) ) e. D ) $=
      ( wcel c1 cicc co wa wceq cmul caddc cr wss adantr cc0 w3a clt wbr simpr1
      w3o cmin sseldd simpr2 lttri4d cv wral ralrimivva ad2antrr wi oveq1 oveq2
      sseq1d rspc2v syl2anc cc ax-1cn unitssre simpr3 sseldi recnd nncan oveq1d
      mpd sylancr simpr simplr3 iirev syl lincmb01cmp syl31anc eqeltrrd sylancl
      pncan3 1re resubcl adddird mulid2d 3eqtr3d eqeltrd mulcld addcomd 3jaodan
      sylan9eqr mpdan ) AFDJZGDJZEUAKLMZJZUBZNZFGUCUDZFGOZGFUCUDZUFEFPMZKEUGMZG
      PMZQMZDJZWPFGWPDRFADRSWOHTZAWKWLWNUEZUHZWPDRGXEAWKWLWNUIZUHZUJWPWQXDWRWSW
      PWQNZFGLMZDXCXJBUKZCUKZLMZDSZCDULBDULZXKDSZAXPWOWQAXOBCDDIUMZUNWPXPXQUOZW
      QWPWKWLXSXFXHXOXQFXMLMZDSBCFGDDXLFOXNXTDXLFXMLUPURXMGOXTXKDXMGFLUQURUSUTT
      VIXJKXAUGMZFPMZXBQMZXCXKWPYCXCOWQWPYBWTXBQWPYAEFPWPKVAJZEVAJZYAEOVBWPEWPW
      MREVCAWKWLWNVDVEZVFZKEVGVJVHVHTXJFRJZGRJZWQXAWMJZYCXKJWPYHWQXGTWPYIWQXITW
      PWQVKXJWNYJWKWLWNAWQVLEVMVNFGXAVOVPVQUHWPWRNXCGDWRWPXCEGPMZXBQMZGWRWTYKXB
      QFGEPUQVHWPEXAQMZGPMKGPMYLGWPYMKGPWPYEYDYMKOYGVBEKVSVRVHWPEXAGYGWPXAWPKRJ
      ERJXARJVTYFKEWAVJVFZWPGXIVFZWBWPGYOWCWDWIWPWLWRXHTWEWPWSNZGFLMZDXCYPXPYQD
      SZAXPWOWSXRUNWPXPYRUOZWSWPWLWKYSXHXFXOYRGXMLMZDSBCGFDDXLGOXNYTDXLGXMLUPUR
      XMFOYTYQDXMFGLUQURUSUTTVIYPXCXBWTQMZYQWPXCUUAOWSWPWTXBWPEFYGWPFXGVFWFWPXA
      GYNYOWFWGTYPYIYHWSWNUUAYQJWPYIWSXITWPYHWSXGTWPWSVKWKWLWNAWSVLGFEVOVPWEUHW
      HWJ $.
  $}

  ${
    $d a b t x y D $.  $d a b t x y ph $.  $d a b t x y X $.  $d a b t x y Y $.
    $d t x y F $.  $d t T $.
    scvxcvx.1 $e |- ( ph -> D C_ RR ) $.
    scvxcvx.2 $e |- ( ph -> F : D --> RR ) $.
    scvxcvx.3 $e |- ( ( ph /\ ( a e. D /\ b e. D ) ) -> ( a [,] b ) C_ D ) $.
    scvxcvx.4 $e |- ( ( ph /\ ( x e. D /\ y e. D /\ x < y ) /\
      t e. ( 0 (,) 1 ) ) -> ( F ` ( ( t x. x ) + ( ( 1 - t ) x. y ) ) ) <
       ( ( t x. ( F ` x ) ) + ( ( 1 - t ) x. ( F ` y ) ) ) ) $.
    $( A strictly convex function is convex.  (Contributed by Mario Carneiro,
       20-Jun-2015.) $)
    scvxcvx $p |- ( ( ph /\ ( X e. D /\ Y e. D /\ T e. ( 0 [,] 1 ) ) ) ->
      ( F ` ( ( T x. X ) + ( ( 1 - T ) x. Y ) ) ) <_
       ( ( T x. ( F ` X ) ) + ( ( 1 - T ) x. ( F ` Y ) ) ) ) $=
      ( cc0 c1 co cmul caddc wcel cicc w3a wa cmin cfv cle wbr clt wceq wo cioo
      cpr w3o cr wss adantr simpr1 sseldd simpr2 lttri4d wral simprl jca simprr
      cv simpll breq1 oveq2 oveq1d fveq2d oveq2d breq12d ralbidv imbi2d imbi12d
      fveq2 breq2 3expia ralrimiv expcom vtocl2ga syl3c oveq1 oveq12d sylc orcd
      wi rspcv expr cc unitssre simpr3 sseldi recnd ax-1cn pncan3 sylancl subcl
      sylancr adddird mulid2d 3eqtr3d wf ffvelrnd eqtr4d eqeq12d syl5ibrcom olc
      syl6 1re elioore resubcl eliooord simprd posdif mpbid simpld ltsubpos cxr
      wb 0xr rexri elioo2 mp2an syl3anbrc ad2antrl nncan remulcld addcomd eqtrd
      3brtr3d 3jaod mpd ex addid2d mul02d 3eqtr4rd syl6eq addid1d elpri subid1i
      1m1e0 jaod syl56 cun 0le1 prunioo mp3an syl6eleqr elun sylib mpjaod cvxcl
      readdcld leloed mpbird ) AHEUAZIEUAZFPQUBRZUAZUCZUDZFHSRZQFUERZISRZTRZGUF
      ZFHGUFZSRZUVEIGUFZSRZTRZUGUHUVHUVMUIUHZUVHUVMUJZUKZUVCFPQULRZUAZUVPFPQUMZ
      UAZUVCUVRUVPUVCUVRUDZHIUIUHZHIUJZIHUIUHZUNUVPUWAHIUVCHUOUAUVRUVCEUOHAEUOU
      PUVBLUQZAUURUUSUVAURZUSZUQUVCIUOUAUVRUVCEUOIUWEAUURUUSUVAUTZUSZUQVAUWAUWB
      UVPUWCUWDUVCUVRUWBUVPUVCUVRUWBUDZUDZUVNUVOUWKUVRDVFZHSRZQUWLUERZISRZTRZGU
      FZUWLUVISRZUWNUVKSRZTRZUIUHZDUVQVBZUVNUVCUVRUWBVCUWKUURUUSUDUWBAUXBUWKUUR
      UUSUVCUURUWJUWFUQUVCUUSUWJUWHUQVDUVCUVRUWBVEAUVBUWJVGBVFZCVFZUIUHZAUWLUXC
      SRZUWNUXDSRZTRZGUFZUWLUXCGUFZSRZUWNUXDGUFZSRZTRZUIUHZDUVQVBZWHZWHZHUXDUIU
      HZAUWMUXGTRZGUFZUWRUXMTRZUIUHZDUVQVBZWHZWHUWBAUXBWHZWHBCHIEEUXCHUJZUXEUXS
      UXQUYEUXCHUXDUIVHUYGUXPUYDAUYGUXOUYCDUVQUYGUXIUYAUXNUYBUIUYGUXHUXTGUYGUXF
      UWMUXGTUXCHUWLSVIVJVKUYGUXKUWRUXMTUYGUXJUVIUWLSUXCHGVQVLVJVMVNVOVPUXDIUJZ
      UXSUWBUYEUYFUXDIHUIVRUYHUYDUXBAUYHUYCUXADUVQUYHUYAUWQUYBUWTUIUYHUXTUWPGUY
      HUXGUWOUWMTUXDIUWNSVIVLVKUYHUXMUWSUWRTUYHUXLUVKUWNSUXDIGVQVLVLVMVNVOVPUXC
      EUAZUXDEUAZUXEUXQAUYIUYJUXEUCZUXPAUYKUDUXODUVQAUYKUWLUVQUAUXOOVSVTWAVSZWB
      WCUXAUVNDFUVQUWLFUJZUWQUVHUWTUVMUIUYMUWPUVGGUYMUWMUVDUWOUVFTUWLFHSWDUYMUW
      NUVEISUWLFQUEVIZVJWEVKUYMUWRUVJUWSUVLTUWLFUVISWDUYMUWNUVEUVKSUYNVJWEVMWIW
      FWGWJUWAUWCUVOUVPUWAUVOUWCFISRZUVFTRZGUFZFUVKSRZUVLTRZUJZUVCUYTUVRUVCUYQU
      VKUYSUVCUYPIGUVCFUVETRZISRQISRZUYPIUVCVUAQISUVCFWKUAZQWKUAZVUAQUJUVCFUVCU
      UTUOFWLAUURUUSUVAWMZWNZWOZWPFQWQWRZVJUVCFUVEIVUGUVCVUDVUCUVEWKUAWPVUGQFWS
      WTZUVCIUWIWOZXAUVCIVUJXBZXCVKUVCVUAUVKSRQUVKSRZUYSUVKUVCVUAQUVKSVUHVJUVCF
      UVEUVKVUGVUIUVCUVKUVCEUOIGAEUOGXDUVBMUQZUWHXEZWOZXAUVCUVKVUOXBZXCXFUQUWCU
      VHUYQUVMUYSUWCUVGUYPGUWCUVDUYOUVFTHIFSVIVJVKUWCUVJUYRUVLTUWCUVIUVKFSHIGVQ
      VLVJXGXHUVOUVNXIZXJUVCUVRUWDUVPUVCUVRUWDUDZUDZUVNUVOVUSUVFQUVEUERZHSRZTRZ
      GUFZUVLVUTUVISRZTRZUVHUVMUIVUSUVEUVQUAZUWLISRZUWNHSRZTRZGUFZUWLUVKSRZUWNU
      VISRZTRZUIUHZDUVQVBZVVCVVEUIUHZUVRVVFUVCUWDUVRUVEUOUAZPUVEUIUHZUVEQUIUHZV
      VFUVRQUOUAZFUOUAZVVQXKFPQXLZQFXMZWTUVRFQUIUHZVVRUVRPFUIUHZVWDFPQXNZXOUVRV
      WAVVTVWDVVRYAVWBXKFQXPWRXQUVRVWEVVSUVRVWEVWDVWFXRUVRVWAVVTVWEVVSYAVWBXKFQ
      XSWRXQPXTUAZQXTUAZVVFVVQVVRVVSUCYAYBQXKYCZPQUVEYDYEYFYGVUSUUSUURUDUWDAVVO
      VUSUUSUURUVCUUSVURUWHUQUVCUURVURUWFUQVDUVCUVRUWDVEAUVBVURVGUXRIUXDUIUHZAV
      VGUXGTRZGUFZVVKUXMTRZUIUHZDUVQVBZWHZWHUWDAVVOWHZWHBCIHEEUXCIUJZUXEVWJUXQV
      WPUXCIUXDUIVHVWRUXPVWOAVWRUXOVWNDUVQVWRUXIVWLUXNVWMUIVWRUXHVWKGVWRUXFVVGU
      XGTUXCIUWLSVIVJVKVWRUXKVVKUXMTVWRUXJUVKUWLSUXCIGVQVLVJVMVNVOVPUXDHUJZVWJU
      WDVWPVWQUXDHIUIVRVWSVWOVVOAVWSVWNVVNDUVQVWSVWLVVJVWMVVMUIVWSVWKVVIGVWSUXG
      VVHVVGTUXDHUWNSVIVLVKVWSUXMVVLVVKTVWSUXLUVIUWNSUXDHGVQVLVLVMVNVOVPUYLWBWC
      VVNVVPDUVEUVQUWLUVEUJZVVJVVCVVMVVEUIVWTVVIVVBGVWTVVGUVFVVHVVATUWLUVEISWDV
      WTUWNVUTHSUWLUVEQUEVIZVJWEVKVWTVVKUVLVVLVVDTUWLUVEUVKSWDVWTUWNVUTUVISVXAV
      JWEVMWIWFVUSVVBUVGGUVCVVBUVGUJVURUVCVVBUVFUVDTRUVGUVCVVAUVDUVFTUVCVUTFHSU
      VCVUDVUCVUTFUJWPVUGQFYHWTZVJVLUVCUVFUVDUVCUVFUVCUVEIUVCVVTVWAVVQXKVUFVWCW
      TZUWIYIWOUVCUVDUVCFHVUFUWGYIWOYJYKUQVKUVCVVEUVMUJVURUVCVVEUVLUVJTRUVMUVCV
      VDUVJUVLTUVCVUTFUVISVXBVJVLUVCUVLUVJUVCUVLUVCUVEUVKVXCVUNYIZWOUVCUVJUVCFU
      VIVUFUVCEUOHGVUMUWFXEZYIZWOYJYKUQYLWGWJYMYNYOUVTFPUJZFQUJZUKUVCUVOUVPFPQU
      UAUVCVXGUVOVXHUVCUVOVXGPHSRZVUBTRZGUFZPUVISRZVULTRZUJUVCPUVKTRUVKVXMVXKUV
      CUVKVUOYPUVCVXLPVULUVKTUVCUVIUVCUVIVXEWOZYQVUPWEUVCVXJIGUVCVXJPITRIUVCVXI
      PVUBITUVCHUVCHUWGWOZYQVUKWEUVCIVUJYPYKVKYRVXGUVHVXKUVMVXMVXGUVGVXJGVXGUVD
      VXIUVFVUBTFPHSWDVXGUVEQISVXGUVEQPUERQFPQUEVIQWPUUBYSZVJWEVKVXGUVJVXLUVLVU
      LTFPUVISWDVXGUVEQUVKSVXPVJWEXGXHUVCUVOVXHQHSRZPISRZTRZGUFZQUVISRZPUVKSRZT
      RZUJUVCUVIPTRUVIVYCVXTUVCUVIVXNYTUVCVYAUVIVYBPTUVCUVIVXNXBUVCUVKVUOYQWEUV
      CVXSHGUVCVXSHPTRHUVCVXQHVXRPTUVCHVXOXBUVCIVUJYQWEUVCHVXOYTYKVKYRVXHUVHVXT
      UVMVYCVXHUVGVXSGVXHUVDVXQUVFVXRTFQHSWDVXHUVEPISVXHUVEQQUERPFQQUEVIUUCYSZV
      JWEVKVXHUVJVYAUVLVYBTFQUVISWDVXHUVEPUVKSVYDVJWEXGXHUUDVUQUUEUVCFUVQUVSUUF
      ZUAUVRUVTUKUVCFUUTVYEVUEVWGVWHPQUGUHVYEUUTUJYBVWIUUGPQUUHUUIUUJFUVQUVSUUK
      UULUUMUVCUVHUVMUVCEUOUVGGVUMAJKEFHILNUUNXEUVCUVJUVLVXFVXDUUOUUPUUQ $.
  $}

  ${
    $d a b c k t w x y A $.  $d a b c k t w x y D $.  $d a b c k t w x y ph $.
    $d a b c k t w x y F $.  $d a b c k t w x y T $.  $d a b c k t w x y X $.
    $d a b t x y z B $.  $d t x y L $.  $d a b t x y S $.
    jensen.1 $e |- ( ph -> D C_ RR ) $.
    jensen.2 $e |- ( ph -> F : D --> RR ) $.
    jensen.3 $e |- ( ( ph /\ ( a e. D /\ b e. D ) ) -> ( a [,] b ) C_ D ) $.
    jensen.4 $e |- ( ph -> A e. Fin ) $.
    jensen.5 $e |- ( ph -> T : A --> ( 0 [,) +oo ) ) $.
    jensen.6 $e |- ( ph -> X : A --> D ) $.
    jensen.7 $e |- ( ph -> 0 < ( CCfld gsum T ) ) $.
    jensen.8 $e |- ( ( ph /\ ( x e. D /\ y e. D /\ t e. ( 0 [,] 1 ) ) ) ->
      ( F ` ( ( t x. x ) + ( ( 1 - t ) x. y ) ) ) <_
       ( ( t x. ( F ` x ) ) + ( ( 1 - t ) x. ( F ` y ) ) ) ) $.
    ${
      jensenlem.1 $e |- ( ph -> -. z e. B ) $.
      jensenlem.2 $e |- ( ph -> ( B u. { z } ) C_ A ) $.
      jensenlem.s $e |- S = ( CCfld gsum ( T |` B ) ) $.
      jensenlem.l $e |- L = ( CCfld gsum ( T |` ( B u. { z } ) ) ) $.
      $( Lemma for ~ jensen .  (Contributed by Mario Carneiro, 4-Jun-2016.) $)
      jensenlem1 $p |- ( ph -> L = ( S + ( T ` z ) ) ) $=
        ( ccnfld cv csn cun cres cgsu cfv caddc cmpt cnfldbas cnfldadd crg wcel
        co cc ccmn cnrng rngcmn mp1i cfn wss unssad ssfi syl2anc wa cc0 cpnf cr
        cico cxr 0re pnfxr mp2an ax-resscn sstri sselda ffvelrnda syldan sseldi
        icossre unssbd vex snss sylibr ffvelrnd fveq2 gsumunsn feqresmpt oveq2d
        oveq1d 3eqtr4d oveq1i 3eqtr4g ) AUHJGDUIZUJZUKZULZUMVAZUHJGULZUMVAZXAJU
        NZUOVAZLIXHUOVAAUHBXCBUIZJUNZUPZUMVAUHBGXKUPZUMVAZXHUOVAXEXIAGVBUOBUHXA
        FXKXHUQURUHUSUTUHVCUTAVDUHVEVFAFVGUTGFVHGVGUTSAGXBFUEVIZFGVJVKAXJGUTZVL
        VMVNVPVAZVBXKXQVOVBVMVOUTVNVQUTXQVOVHVRVSVMVNWGVTWAWBZAXPXJFUTXKXQUTAGF
        XJXOWCAFXQXJJTWDWEWFAXBFVHXAFUTAGXBFUEWHXAFDWIWJWKZUDAXQVBXHXRAFXQXAJTX
        SWLWFXJXAJWMWNAXDXLUHUMABFXQXCJTUEWOWPAXGXNXHUOAXFXMUHUMABFXQGJTXOWOWPW
        QWRUGIXGXHUOUFWSWT $.

      jensenlem.3 $e |- ( ph -> S e. RR+ ) $.
      jensenlem.4 $e |- ( ph ->
        ( ( CCfld gsum ( ( T oF x. X ) |` B ) ) / S ) e. D ) $.
      jensenlem.5 $e |- ( ph ->
        ( F ` ( ( CCfld gsum ( ( T oF x. X ) |` B ) ) / S ) ) <_
        ( ( CCfld gsum ( ( T oF x. ( F o. X ) ) |` B ) ) / S ) ) $.
      $( Lemma for ~ jensen .  (Contributed by Mario Carneiro, 21-Jun-2015.) $)
      jensenlem2 $p |- ( ph ->
        ( ( ( CCfld gsum ( ( T oF x. X ) |` ( B u. { z } ) ) ) / L ) e. D /\
         ( F ` ( ( CCfld gsum ( ( T oF x. X ) |` ( B u. { z } ) ) ) / L ) ) <_
     ( ( CCfld gsum ( ( T oF x. ( F o. X ) ) |` ( B u. { z } ) ) ) / L ) ) ) $=
        ( ccnfld cmul cof co cv csn cun cres cgsu cdiv wcel cfv ccom cle wbr c1
        cmin caddc cr cfn cc0 cnfld0 crg cabel cnrng rngabl mp1i unssad syl2anc
        wss ssfi csubrg csubg cress cdr wf cpnf 0re fss off fisuppfi gsumsubgcl
        wa fssres recnd cc ffvelrnd sseldi sseldd mulcld readdcld eqeltrd mpbid
        syl breqtrrd divdird cmpt cnfldbas cnfldadd ffvelrnda syldan wceq fveq2
        a1i oveq12d gsumunsn feqmptd offval2 reseq1d resmpt eqtrd oveq2d oveq1d
        3eqtr4d dmdcand div23d eqtr4d w3a redivcld clt wb syl112anc remulcld wi
        1re oveq2 fveq2d breq12d imbi2d oveq1 resubdrg simpli subrgsubg remulcl
        adantl cico cxr pnfxr icossre mp2an sylancl inidm cdif ax-resscn unssbd
        cvv sstri snss sylibr jensenlem1 rpred elrege0 simplbi simprbi addge01d
        vex rpgt0d ltletrd gt0ne0d ccmn rngcmn sselda adantr divsubdird pncan2d
        rpne0d dividd 3eqtr3rd rpge0d divge0 syl22anc ledivmul mpbird syl3anbrc
        cicc mulid1d elicc2i 3jca cvxcl resubcl sylancr expcom vtocl3ga syl3anc
        mpdan fco pm2.43i breqtrd divgt0d lemul2 leadd1dd eqbrtrd letrd 3brtr4d
        fmptco jca ) AUKJMULUMZUNZGDUOZUPZUQZURZUSUNZLUTUNZHVAUXNKVBZUKJKMVCZUX
        GUNZUXKURZUSUNZLUTUNZVDVEAUXNILUTUNZUKUXHGURZUSUNZIUTUNZULUNZVFUYAVGUNZ
        UXIMVBZULUNZVHUNZHAUYCUXIJVBZUYGULUNZVHUNZLUTUNUYCLUTUNZUYKLUTUNZVHUNUX
        NUYIAUYCUYKLAUYCAGVIUYBUKVJVKVLUKVMVAZUKVNVAAVOUKVPVQZAFVJVAGFVTZGVJVAS
        AGUXJFUEVRZFGWAVSZVIUKWBVBVAZVIUKWCVBVAAUYTUKVIWDUNWEVAUUAUUBVIUKUUCVQZ
        AFVIUXHWFUYQGVIUYBWFABCFFFULVIVIVIJMVJVJBUOZVIVACUOZVIVAWMVUBVUCULUNVIV
        AAVUBVUCUUDUUEZAFVKWGUUFUNZJWFVUEVIVTZFVIJWFTVKVIVAZWGUUGVAVUFWHUUHVKWG
        UUIUUJZFVUEVIJWIUUKZAFHMWFZHVIVTZFVIMWFUAPFHVIMWIVSSSFUULZWJUYRFVIGUXHW
        NVSZAGVIUUPVKUPUUMZUYBUYSVUMWKWLWOZAUYJUYGAVUEWPUYJVUEVIWPVUHUUNUUQZAFV
        UEUXIJTAUXJFVTUXIFVAAGUXJFUEUUOUXIFDUVFUURUUSZWQZWRZAUYGAHVIUYGPAFHUXIM
        UAVUQWQZWSWOZWTZALALIUYJVHUNZVIABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUUTZAI
        UYJAIUHUVAZAUYJVUEVAZUYJVIVAZVURVVFVVGVKUYJVDVEZUYJUVBZUVCXDZXAXBZWOZAL
        AVKILVUGAWHXNVVEVVKAIUHUVGZAIVVCLVDAVVHIVVCVDVEAVVFVVHVURVVFVVGVVHVVIUV
        DXDAIUYJVVEVVJUVEXCVVDXEZUVHZUVIZXFAUXMUYLLUTAUKBUXKVUBJVBZVUBMVBZULUNZ
        XGZUSUNUKBGVVSXGZUSUNZUYKVHUNUXMUYLAGWPVHBUKUXIFVVSUYKXHXIUYOUKUVJVAAVO
        UKUVKVQZUYSAVUBGVAZWMZVVQVVRVWEVUEWPVVQVUPAVWDVUBFVAZVVQVUEVAAGFVUBUYRU
        VLZAFVUEVUBJTXJZXKWRVWEVVRVWEHVIVVRAVUKVWDPUVMAVWDVWFVVRHVAZVWGAFHVUBMU
        AXJZXKWSWOWTVUQUDVVBVUBUXIXLZVVQUYJVVRUYGULVUBUXIJXMZVUBUXIMXMZXOXPAUXL
        VVTUKUSAUXLBFVVSXGZUXKURZVVTAUXHVWNUXKABFVVQVVRULJMVJVUEHSVWHVWJABFVUEJ
        TXQZABFHMUAXQZXRZXSAUXKFVTZVWOVVTXLUEBFUXKVVSXTXDYAYBAUYCVWBUYKVHAUYBVW
        AUKUSAUYBVWNGURZVWAAUXHVWNGVWRXSAUYQVWTVWAXLUYRBFGVVSXTXDYAYBYCYDYCAUYE
        UYMUYHUYNVHAUYCILVUOAIVVEWOZVVLAIUHUVPZVVPYEAUYHUYJLUTUNZUYGULUNUYNAUYF
        VXCUYGULALIVGUNZLUTUNLLUTUNZUYAVGUNVXCUYFALILVVLVXAVVLVVPUVNAVXDUYJLUTA
        VXDVVCIVGUNUYJALVVCIVGVVDYCAIUYJVXAVUSUVOYAYCAVXEVFUYAVGALVVLVVPUVQYCUV
        RZYCAUYJUYGLVUSVVAVVLVVPYFYGXOYDZAUYDHVAZUYGHVAZUYAVKVFUWEUNZVAZYHUYIHV
        AAVXHVXIVXKUIVUTAUYAVIVAZVKUYAVDVEZUYAVFVDVEZVXKAILVVEVVKVVPYIZAIVIVAZV
        KIVDVELVIVAZVKLYJVEZVXMVVEAIUHUVSVVKVVOILUVTUWAAVXNILVFULUNZVDVEZAILVXS
        VDVVNALVVLUWFXEAVXPVFVIVAZVXQVXRVXNVXTYKVVEVYAAYOXNVVKVVOIVFLUWBYLUWCVK
        VFUYAWHYOUWGUWDZUWHANOHUYAUYDUYGPRUWIUWOZXBAUYIKVBZUYAUKUXQGURZUSUNZIUT
        UNZULUNZUYFUYGKVBZULUNZVHUNZUXOUXTVDAVYDUYAUYDKVBZULUNZUYJVYIULUNZLUTUN
        ZVHUNZVYKAHVIUYIKQVYCWQAVYMVYOAUYAVYLVXOAHVIUYDKQUIWQZYMZAVYNLAUYJVYIVV
        JAHVIUYGKQVUTWQZYMZVVKVVPYIXAAVYHVYJAUYAVYGVXOAVYFIAGVIVYEUKVJVKVLUYPUY
        SVUAAFVIUXQWFUYQGVIVYEWFABCFFFULVIVIVIJUXPVJVJVUDVUIAHVIKWFVUJFVIUXPWFQ
        UAFHVIKMUWPVSSSVULWJUYRFVIGUXQWNVSZAGVIVUNVYEUYSWUAWKWLZVVEVXBYIZYMZAUY
        FVYIAVYAVXLUYFVIVAYOVXOVFUYAUWJUWKVYSYMZXAAVYDVYMVYJVHUNZVYPVDAVYDWUFVD
        VEZAVXHVXIVXKAWUGYNZUIVUTVYBAEUOZVUBULUNZVFWUIVGUNZVUCULUNZVHUNZKVBZWUI
        VUBKVBZULUNZWUKVUCKVBZULUNZVHUNZVDVEZYNAWUIUYDULUNZWULVHUNZKVBZWUIVYLUL
        UNZWURVHUNZVDVEZYNAWVAWUKUYGULUNZVHUNZKVBZWVDWUKVYIULUNZVHUNZVDVEZYNWUH
        BCEUYDUYGUYAHHVXJVUBUYDXLZWUTWVFAWVMWUNWVCWUSWVEVDWVMWUMWVBKWVMWUJWVAWU
        LVHVUBUYDWUIULYPYCYQWVMWUPWVDWURVHWVMWUOVYLWUIULVUBUYDKXMYBYCYRYSVUCUYG
        XLZWVFWVLAWVNWVCWVIWVEWVKVDWVNWVBWVHKWVNWULWVGWVAVHVUCUYGWUKULYPYBYQWVN
        WURWVJWVDVHWVNWUQVYIWUKULVUCUYGKXMYBYBYRYSWUIUYAXLZWVLWUGAWVOWVIVYDWVKW
        UFVDWVOWVHUYIKWVOWVAUYEWVGUYHVHWUIUYAUYDULYTWVOWUKUYFUYGULWUIUYAVFVGYPZ
        YCXOYQWVOWVDVYMWVJVYJVHWUIUYAVYLULYTWVOWUKUYFVYIULWVPYCXOYRYSAVUBHVAVUC
        HVAWUIVXJVAYHWUTUCUWLUWMUWNUWQAVYJVYOVYMVHAVYJVXCVYIULUNZVYOAUYFVXCVYIU
        LVXFYCZAUYJVYILVUSAVYIVYSWOVVLVVPYFZYGZYBUWRAVYPWUFVYKVDAVYOVYJVYMVHAVY
        OWVQVYJWVSWVRYGYBAVYMVYHVYJVYRWUDWUEAVYLVYGVDVEZVYMVYHVDVEZUJAVYLVIVAVY
        GVIVAVXLVKUYAYJVEWWAWWBYKVYQWUCVXOAILVVEVVKVVMVVOUWSVYLVYGUYAUWTYLXCUXA
        UXBUXCAUXNUYIKVXGYQAVYFVYNVHUNZLUTUNVYFLUTUNZVYOVHUNUXTVYKAVYFVYNLAVYFW
        UBWOZAVYNVYTWOZVVLVVPXFAUXSWWCLUTAUKBUXKVVQVVRKVBZULUNZXGZUSUNUKBGWWHXG
        ZUSUNZVYNVHUNUXSWWCAGWPVHBUKUXIFWWHVYNXHXIVWCUYSAVWDVWFWWHWPVAVWGAVWFWM
        ZWWHWWLVVQWWGWWLVUEVIVVQVUHVWHWRAVWFVWIWWGVIVAVWJAHVIVVRKQXJXKZYMWOXKVU
        QUDWWFVWKVVQUYJWWGVYIULVWLVWKVVRUYGKVWMYQXOXPAUXRWWIUKUSAUXRBFWWHXGZUXK
        URZWWIAUXQWWNUXKABFVVQWWGULJUXPVJVUEVISVWHWWMVWPABCFHVVRWUQWWGMKVWJVWQA
        CHVIKQXQVUCVVRKXMUXEXRZXSAVWSWWOWWIXLUEBFUXKWWHXTXDYAYBAVYFWWKVYNVHAVYE
        WWJUKUSAVYEWWNGURZWWJAUXQWWNGWWPXSAUYQWWQWWJXLUYRBFGWWHXTXDYAYBYCYDYCAV
        YHWWDVYJVYOVHAVYFILWWEVXAVVLVXBVVPYEWVTXOYDUXDUXF $.
    $}

    $( Jensen's inequality, a finite extension of the definition of convexity
       (the last hypothesis).  (Contributed by Mario Carneiro, 21-Jun-2015.) $)
    jensen $p |- ( ph ->
      ( ( ( CCfld gsum ( T oF x. X ) ) / ( CCfld gsum T ) ) e. D /\
        ( F ` ( ( CCfld gsum ( T oF x. X ) ) / ( CCfld gsum T ) ) ) <_
         ( ( CCfld gsum ( T oF x. ( F o. X ) ) ) / ( CCfld gsum T ) ) ) ) $=
      ( co vw vk vc ccnfld cmul cof cgsu cdiv cv cfv ccom cle crab wcel wa cres
      wbr wss cc0 clt wfn wceq cpnf cico wf ffn syl fnresdm oveq2d breqtrrd cfn
      ssid wi c0 csn sseq1 reseq2 syl6eq cnfld0 anbi12d oveq12d rabbidv eleq12d
      breq2d imbi12d imbi2d 0re adantl a1i simprl simpr cr ad3antrrr cicc sylan
      wel c1 caddc adantr eqid cnrng mp1i ad2antrr ssfi syl2anc fssres cvv cdif
      elrege0 simplbi fveq2 breq1d elrab sylib simpld simprd embantd cc sylancl
      cnfldbas fss off ax-resscn ccnv cima fex offres imaeq1d fvres mpbid eqtrd
      cnveqd suppssof1 eqsstrd gsumpt fnfvof syl22anc 3eqtrd ffvelrnd divcan3d
      jctil cun res0 gsum0 ltnri pm2.21i impexp unssad simplll w3a cmin simpllr
      wn crg ccmn rngcmn csubmnd rege0subm fisuppfi gsumsubmcl elrpd jensenlem2
      simprr sylibr expr cmnd rngmnd ssun2 vex sselii remulcl ssriv inidm sstri
      snid eldifi difun2 difss eqsstri csu wral cmpt feqresmpt sselda ffvelrnda
      sseli syldan sseldi gsumfsum 3eqtrrd fsum00 r19.21bi sylan2 suppss syl6ss
      mul02 sseldd simplrr breqtrd gt0ne0d eqeltrd leidd fveq2d fco fnfco fvco3
      recnd 3brtr4d sylanbrc a1d wo simprbi wb leloe sylancr mpjaodan syl5bi ex
      com23 expcom a2d findcard2s mpcom mpd offn 3eltr3d ) AUDGIUEUFZTZUGTZUDGU
      GTZUHTZUAUIZHUJZUDGHIUKZUYGTZUGTZUYJUHTZULUQZUAFUMZUNUYKFUNUYKHUJZUYQULUQ
      ZUOAUDUYHEUPZUGTZUDGEUPZUGTZUHTZUYMUDUYOEUPZUGTZVUEUHTZULUQZUAFUMZUYKUYSA
      EEURZUSVUEUTUQZUOZVUFVUKUNZAVUMVULAUSUYJVUEUTRAVUDGUDUGAGEVAZVUDGVBAEUSVC
      VDTZGVEZVUPPEVUQGVFZVGZEGVHVGVIZVJEVLUUAEVKUNZAVUNVUOVMZOAJUIZEURZUSUDGVV
      DUPZUGTZUTUQZUOZUDUYHVVDUPZUGTZVVGUHTZUYMUDUYOVVDUPZUGTZVVGUHTZULUQZUAFUM
      ZUNZVMZVMAVNEURZUSUSUTUQZUOZUDUYHVNUPZUGTZUSUHTZUYMUDUYOVNUPZUGTZUSUHTZUL
      UQZUAFUMZUNZVMZVMAUBUIZEURZUSUDGVWMUPZUGTZUTUQZUOZUDUYHVWMUPZUGTZVWPUHTZU
      YMUDUYOVWMUPZUGTZVWPUHTZULUQZUAFUMZUNZVMZVMAVWMUCUIZVOZUUBZEURZUSUDGVXKUP
      ZUGTZUTUQZUOZUDUYHVXKUPZUGTZVXNUHTZUYMUDUYOVXKUPZUGTZVXNUHTZULUQZUAFUMZUN
      ZVMZVMAVVCVMJUBUCEVVDVNVBZVVSVWLAVYGVVIVWBVVRVWKVYGVVEVVTVVHVWAVVDVNEVPVY
      GVVGUSUSUTVYGVVGUDVNUGTUSVYGVVFVNUDUGVYGVVFGVNUPVNVVDVNGVQGUUCVRVIUDUSVSU
      UDVRZWDVTVYGVVLVWEVVQVWJVYGVVKVWDVVGUSUHVYGVVJVWCUDUGVVDVNUYHVQVIVYHWAVYG
      VVPVWIUAFVYGVVOVWHUYMULVYGVVNVWGVVGUSUHVYGVVMVWFUDUGVVDVNUYOVQVIVYHWAWDWB
      WCWEWFVVDVWMVBZVVSVXHAVYIVVIVWRVVRVXGVYIVVEVWNVVHVWQVVDVWMEVPVYIVVGVWPUSU
      TVYIVVFVWOUDUGVVDVWMGVQVIZWDVTVYIVVLVXAVVQVXFVYIVVKVWTVVGVWPUHVYIVVJVWSUD
      UGVVDVWMUYHVQVIVYJWAVYIVVPVXEUAFVYIVVOVXDUYMULVYIVVNVXCVVGVWPUHVYIVVMVXBU
      DUGVVDVWMUYOVQVIVYJWAWDWBWCWEWFVVDVXKVBZVVSVYFAVYKVVIVXPVVRVYEVYKVVEVXLVV
      HVXOVVDVXKEVPVYKVVGVXNUSUTVYKVVFVXMUDUGVVDVXKGVQVIZWDVTVYKVVLVXSVVQVYDVYK
      VVKVXRVVGVXNUHVYKVVJVXQUDUGVVDVXKUYHVQVIVYLWAVYKVVPVYCUAFVYKVVOVYBUYMULVY
      KVVNVYAVVGVXNUHVYKVVMVXTUDUGVVDVXKUYOVQVIVYLWAWDWBWCWEWFVVDEVBZVVSVVCAVYM
      VVIVUNVVRVUOVYMVVEVULVVHVUMVVDEEVPVYMVVGVUEUSUTVYMVVFVUDUDUGVVDEGVQVIZWDV
      TVYMVVLVUFVVQVUKVYMVVKVUCVVGVUEUHVYMVVJVUBUDUGVVDEUYHVQVIVYNWAVYMVVPVUJUA
      FVYMVVOVUIUYMULVYMVVNVUHVVGVUEUHVYMVVMVUGUDUGVVDEUYOVQVIVYNWAWDWBWCWEWFVW
      LAVWAVWKVVTVWAVWKUSWGUUEUUFWHWIVWMVKUNZUCUBWPUUMZUOAVXHVYFVYPAVXHVYFVMZVM
      VYOAVYPVYQAVYPUOZVXPVXHVYEVYRVXPVXHVYEVMVXHVWNVWQVXGVMZVMVYRVXPUOZVYEVWNV
      WQVXGUUGVYTVWNVYSVYEVYTVWMVXJEVYRVXLVXOWJZUUHZVYTVWQVYSVYEVMUSVWPVBZVYTVW
      QUOVWQVXGVYEVYTVWQWKVYTVWQVXGVYEVYTVWQVXGUOZUOZVXSFUNZVXSHUJZVYBULUQZUOVY
      EWUEBCUCDEVWMFVWPGHVXNIJKAFWLURZVYPVXPWUDLWMAFWLHVEZVYPVXPWUDMWMWUEAVVDFU
      NKUIZFUNUOVVDWUKWNTFURAVYPVXPWUDUUIZNWOWUEAVVBWULOVGWUEAVURWULPVGWUEAEFIV
      EZWULQVGAUSUYJUTUQVYPVXPWUDRWMWUEABUIZFUNCUIZFUNDUIZUSWQWNTUNUUJWUPWUNUET
      WQWUPUUKTZWUOUETWRTHUJWUPWUNHUJUETWUQWUOHUJUETWRTULUQWULSWOAVYPVXPWUDUULV
      YTVXLWUDWUAWSVWPWTVXNWTWUEVWPVYTVWPWLUNZWUDVYTVWPVUQUNZWURVYTVWMVUQVWOUDV
      KUSVSUDUUNUNZUDUUOUNVYTXAUDUUPXBVYTVVBVWNVYOAVVBVYPVXPOXCZWUBEVWMXDXEZVUQ
      UDUUQUJUNVYTUURWIVYTVURVWNVWMVUQVWOVEAVURVYPVXPPXCWUBEVUQVWMGXFXEZVYTVWMV
      UQXGUSVOXHZVWOWVBWVCUUSUUTZWUSWURUSVWPULUQZVWPXIZXJVGZWSVYTVWQVXGWJUVAWUE
      VXAFUNZVXAHUJZVXDULUQZWUEVXGWVIWVKUOVYTVWQVXGUVCVXEWVKUAVXAFUYLVXAVBUYMWV
      JVXDULUYLVXAHXKXLXMXNZXOWUEWVIWVKWVLXPUVBVYCWUHUAVXSFUYLVXSVBUYMWUGVYBULU
      YLVXSHXKXLXMZUVDUVEXQVYTWUCUOZVYEVYSWVNWUFWUHVYEWVNVXSVXIIUJZFWVNVXSVXIGU
      JZWVOUETZWVPUHTWVOWVNVXRWVQVXNWVPUHWVNVXRVXIVXQUJZVXIUYHUJZWVQWVNVXKXRVXQ
      UDVKVXIUSXTVSWUTUDUVFUNWVNXAUDUVGXBZVYTVXKVKUNZWUCVYTVVBVXLWWAWVAWUAEVXKX
      DXEWSZVXIVXKUNZWVNVXJVXKVXIVXJVWMUVHVXIUCUVIUVOUVJWIZWVNEXRUYHVEZVXLVXKXR
      VXQVEAWWEVYPVXPWUCAEWLUYHVEZWLXRURZWWEABCEEEUEWLWLWLGIVKVKWUNWLUNZWUOWLUN
      UOWUNWUOUETWLUNAWUNWUOUVKWHZAVURVUQWLUREWLGVEPBVUQWLWUNVUQUNWWHUSWUNULUQW
      UNXIXJUVLZEVUQWLGYAXSZAWUMWUIEWLIVEQLEFWLIYAXEOOEUVMZYBZYCEWLXRUYHYAXSWMV
      YTVXLWUCWUAWSZEXRVXKUYHXFXEWVNVXQYDZWVDYEVXMIVXKUPZUYGTZYDZWVDYEVXJWVNWWO
      WWRWVDWVNVXQWWQWVNGXGUNZIXGUNZVXQWWQVBWVNVURVVBWWSAVURVYPVXPWUCPWMZVYTVVB
      WUCWVAWSZEVUQVKGYFXEZWVNWUMVVBWWTAWUMVYPVXPWUCQWMZWXBEFVKIYFXEVXKUEGIXGXG
      YGXEYLYHWVNBVXMWWPVXKXRVXJUEXRVKUSUSWVNVXKXRBVXMVXJUSWVNEXRGVEZVXLVXKXRVX
      MVEWVNVURVUQXRURWXEWXAVUQWLXRWWJYCUVNZEVUQXRGYAXSZWWNEXRVXKGXFXEZWVNWUNVX
      KVXJXHZUNZUOZWUNVXMUJZWUNGUJZUSWXKWUNVXKUNZWXLWXMVBWXJWXNWVNWUNVXKVXJUVPW
      HWUNVXKGYIVGWXJWVNBUBWPZWXMUSVBZWXIVWMWUNWXIVWMVXJXHVWMVWMVXJUVQVWMVXJUVR
      UVSUWFWVNWXPBVWMWVNVWMWXMBUVTZUSVBWXPBVWMUWAWVNUSVWPUDBVWMWXMUWBZUGTWXQVY
      TWUCWKWVNVWOWXRUDUGWVNBEVUQVWMGWXAVYTVWNWUCWUBWSZUWCVIWVNVWMWXMBVYTVYOWUC
      WVBWSZWVNWXOUOZVUQXRWXMWXFWVNWXOWUNEUNWXMVUQUNZWVNVWMEWUNWXSUWDWVNEVUQWUN
      GWXAUWEUWGZUWHUWIUWJWVNVWMWXMBWXTWYAWXMWLUNZUSWXMULUQZWYAWYBWYDWYEUOWYCWX
      MXIXNZXOWYAWYDWYEWYFXPUWKYJUWLUWMYKUWNZWUNXRUNUSWUNUETUSVBWVNWUNUWPWHZWXH
      WVNEXRIVEZVXLVXKXRWWPVEWVNWUMFXRURWYIWXDWVNFWLXRAWUIVYPVXPWUCLWMYCUWOEFXR
      IYAXEZWWNEXRVXKIXFXEWWBYMYNYOWVNWWCWVRWVSVBWWDVXIVXKUYHYIVGWVNVUPIEVAZVVB
      VXIEUNZWVSWVQVBWVNVURVUPWXAVUSVGZWVNWUMWYKWXDEFIVFVGWXBWVNVXKEVXIWWNWWDUW
      QZEUEGIVKVXIYPYQYRWVNVXNVXIVXMUJZWVPWVNVXKXRVXMUDVKVXIUSXTVSWVTWWBWWDWXHW
      YGYOWVNWWCWYOWVPVBWWDVXIVXKGYIVGYKZWAWVNWVOWVPWVNEXRVXIIWYJWYNYSWVNEXRVXI
      GWXGWYNYSZWVNWVPWVNUSVXNWVPUTVYRVXLVXOWUCUWRWYPUWSUWTZYTYKZWVNEFVXIIWXDWY
      NYSZUXAWVNWVOHUJZXUAWUGVYBULWVNXUAWVNFWLWVOHAWUJVYPVXPWUCMWMWYTYSZUXBWVNV
      XSWVOHWYSUXCWVNVYBWVPXUAUETZWVPUHTXUAWVNVYAXUCVXNWVPUHWVNVYAVXIVXTUJZVXIU
      YOUJZXUCWVNVXKXRVXTUDVKVXIUSXTVSWVTWWBWWDWVNEXRUYOVEZVXLVXKXRVXTVEAXUFVYP
      VXPWUCAEWLUYOVEWWGXUFABCEEEUEWLWLWLGUYNVKVKWWIWWKAWUJWUMEWLUYNVEZMQEFWLHI
      UXDXEZOOWWLYBYCEWLXRUYOYAXSWMWWNEXRVXKUYOXFXEWVNVXTYDZWVDYEVXMUYNVXKUPZUY
      GTZYDZWVDYEVXJWVNXUIXULWVDWVNVXTXUKWVNWWSUYNXGUNZVXTXUKVBWXCWVNXUGVVBXUMA
      XUGVYPVXPWUCXUHWMZWXBEWLVKUYNYFXEVXKUEGUYNXGXGYGXEYLYHWVNBVXMXUJVXKXRVXJU
      EXRVKUSUSWYGWYHWXHWVNEXRUYNVEZVXLVXKXRXUJVEWVNXUGWWGXUOXUNYCEWLXRUYNYAXSW
      WNEXRVXKUYNXFXEWWBYMYNYOWVNWWCXUDXUEVBWWDVXIVXKUYOYIVGWVNXUEWVPVXIUYNUJZU
      ETZXUCWVNVUPUYNEVAZVVBWYLXUEXUQVBWYMAXURVYPVXPWUCAHFVAZWUMXURAWUJXUSMFWLH
      VFVGQFEHIUXEXEZWMWXBWYNEUEGUYNVKVXIYPYQWVNXUPXUAWVPUEWVNWUMWYLXUPXUAVBWXD
      WYNEFVXIHIUXFXEVIYKYRWYPWAWVNXUAWVPWVNXUAXUBUXGWYQWYRYTYKUXHWVMUXIUXJVYTW
      VFVWQWUCUXKZVYTWUSWVFWVEWUSWURWVFWVGUXLVGVYTUSWLUNWURWVFXVAUXMWGWVHUSVWPU
      XNUXOYJUXPXQUXQUXRUXSUXTWHUYAUYBUYCUYDAVUCUYIVUEUYJUHAVUBUYHUDUGAUYHEVAZV
      UBUYHVBAWWFXVBWWMEWLUYHVFVGEUYHVHVGVIVVAWAAVUJUYRUAFAVUIUYQUYMULAVUHUYPVU
      EUYJUHAVUGUYOUDUGAUYOEVAVUGUYOVBAEEUEEGUYNVKVKVUTXUTOOWWLUYEEUYOVHVGVIVVA
      WAWDWBUYFUYRVUAUAUYKFUYLUYKVBUYMUYTUYQULUYLUYKHXKXLXMXN $.
  $}

  ${
    $d a b k s u v w x y A $.  $d x y M $.  $d a b k s t u v w x y ph $.
    $d a b k s u v w x y F $.
    amgm.1 $e |- M = ( mulGrp ` CCfld ) $.
    ${
      amgm.2 $e |- ( ph -> A e. Fin ) $.
      amgm.3 $e |- ( ph -> A =/= (/) ) $.
      amgm.4 $e |- ( ph -> F : A --> RR+ ) $.
      $( Lemma for ~ amgm .  (Contributed by Mario Carneiro, 21-Jun-2015.) $)
      amgmlem $p |- ( ph -> ( ( M gsum F ) ^c ( 1 / ( # ` A ) ) ) <_
            ( ( CCfld gsum F ) / ( # ` A ) ) ) $=
        ( vk c1 cfv co cgsu clog cmul ccnfld cr cc0 wcel crp vx vw vu cdiv ccxp
        vv vs va vb vy vt chash ce cle wbr cneg cmpt cfn cnfld0 crg cabel cnrng
        cv rngabl csubrg csubg cress cdr resubdrg simpli subrgsubg wa ffvelrnda
        mp1i relogcld renegcld eqid fmptd cvv cdif fisuppfi gsumsubgcl recnd wb
        csn syl ccom csu gsumfsum negeqd feqmptd wf fvres fmptco oveq2d 3eqtr4d
        fveq2 csubmnd wceq wss oveq1i subgsubm ax-mp cnfldbas ccmn cmnd syl2anc
        cc rngmnd gsumsubm a1i fveq2d 3eqtrd divrec2d rpcnd eqtrd rpssre adantl
        nndivred cicc cpnf cioo ioorp eleq2i clt w3a caddc remulcld mpbid negex
        sseldi fvmpt mulneg2d oveq12d 3brtr4d cnfldadd cnfldmul gsummulc2 div1d
        offval2 cn c0 wne hashnncl mpbird nncnd nnne0d divnegd negnegd sumeq2dv
        cres fsumneg 3eqtr2rd wf1o relogf1o f1of mpteq2ia syl6eq rpmsubg cndrng
        cbs cmgp drngui unitsubm subsubm mp2b submbas c0g cnfld1 rngidval subm0
        mpbi ccrg cncrng crngmgp subcmn subrgrng cghm cmhm cgim reloggim gimghm
        submmnd ghmmhm gsummhm fco gsumsubmcl oveq1d fsumrpcl eqeltrd nnrpd cxp
        rpdivcld cof relogcl iccssioo2 syl2anbr syl6sseq cico nnrecred rpreccld
        rpge0d elrege0 sylanbrc fconst6g fconstmpt oveq2i cmg gsumconst syl3anc
        0lt1 nnzd cnfldmulg recidd syl5eq syl5breqr cmin logccv 3adant1 ioossre
        cz simp3 simp21 resubcl sylancr simp22 readdcld simp1 ioossicc syl13anc
        1re cvxcl ltnegd negdid eqtr4d scvxcvx jensen simprd adantr fss sylancl
        eqtr2d eqidd 3brtr3d lenegcon1d eqbrtrrd rpne0d cxpefd reeflogd eqcomd
        efle ) AJBULKZUDLZDCMLZNKZOLZUMKZPCMLZVULUDLZNKZUMKZVUNVUMUELVUSUNAVUPV
        UTUNUOZVUQVVAUNUOZAPIBIVCZCKZNKZUPZUQZMLZVULUDLZUPZVUPVUTUNAVVKVVIUPZVU
        LUDLVUOVULUDLVUPAVVIVULAVVIABQVVHPURRUSPUTSZPVASAVBPVDVNZFQPVEKSZQPVFKS
        ZAVVOPQVGLZVHSVIVJZQPVKVNZAIBVVGQVVHAVVDBSZVLZVVFVWAVVEABTVVDCHVMZVOZVP
        ZVVHVQVRZABQVSRWEZVTZVVHFVWEWAZWBZWCZAVULAVULUUASZBUUBUUCZGABURSZVWKVWL
        WDFBUUDWFUUEZUUFZAVULVWNUUGZUUHAVVLVUOVULUDAVVLPNTUUKZCWGZMLZVUNVWQKZVU
        OABVVGIWHZUPZPIBVVFUQZMLZVVLVWSAVXDBVVFIWHBVVGUPZIWHVXBABVVFIFVWAVVFVWC
        WCZWIABVXEVVFIVWAVVFVXFUUIUUJABVVGIFVWAVVGVWDWCZUULUUMAVVIVXAABVVGIFVXG
        WIWJAVWRVXCPMAIUABTVVEUAVCZNKZVVFCVWQVWBAIBTCHWKZAVWQUATVXHVWQKZUQUATVX
        IUQAUATQVWQTQVWQUUNTQVWQWLZAUUOTQVWQUUPVNZWKUATVXKVXIVXHTNWMUUQUURVXHVV
        ENWQWNWOWPAVVQVWRMLDTVGLZCMLZVWQKVWSVWTABTCVXNVVQVWQURJTDWRKZSZTVXNUVAK
        WSVXQTXHVWFVTZWTZTDVXRVGLZWRKSZVXQVXSVLZTVXTVFKSVYAVXTDPUVBKZVXRVGEXAUU
        STVXTXBXCVVMVXRVXPSVYAVYBWDVBPVXRDXHPRXDUSUUTUVCEUVDTVXRDVXTVXTVQUVEUVF
        UVLVJZTVXNDVXNVQZUVGXCVXQJVXNUVHKWSVYDTVXNDJVYEPJDEUVIUVJZUVKXCADXESZVX
        NXFSZVXNXESPUVMSVYGAUVNPDEUVOVNZVXQVYHAVYDTVXNDVYEUWCVNTDVXNVYEUVPXGVVQ
        UTSZVVQXFSAVVOVYJVVRQPVVQVVQVQZUVQXCVVQXIVNFVWQVXNVVQUVRLSZVWQVXNVVQUVS
        LSAVWQVXNVVQUVTLSVYLVXNVVQVYKDVYCTVGEXAUWAVXNVVQVWQUWBXCVXNVVQVWQUWDVNH
        ABTVSJWEVTCFHWAZUWEABQVWRPVVQURFAVVPQPWRKSVVSQPXBWFAVXLBTCWLZBQVWRWLVXM
        HBTQVWQCUWFXGVYKXJAVUNVXOVWQABTCDVXNURFVXQAVYDXKZHVYEXJXLWPAVUNTSVWTVUO
        WSABTCDURJVYFVYIFVYOHVYMUWGZVUNTNWMWFXMUWHAVUOVULAVUOAVUNVYPVOZWCVWOVWP
        XNXMAVUTVVJAVUSAVURVULAVURBVVEIWHZTAVURPIBVVEUQZMLZVYRACVYSPMVXJWOZABVV
        EIFVWAVVEVWBXOZWIXPABVVEIFGVWBUWIUWJAVULVWNUWKZUWMZVOZAVVIVULVWIVWNXSZA
        PBVUMWEUWLZCOUWNZLZMLZPWUGMLZUDLZUBTUBVCZNKZUPZUQZKZPWUGWUPCWGZWUHLZMLZ
        WUKUDLZVUTUPZVVJUNAWULTSWUQWVAUNUOAUCUFUGBTWUGWUPCUHUITQWTZAXQXKZAUBTWU
        OQWUPAWUMTSZVLWUNWVEWUNQSAWUMUWOXRVPWUPVQZVRZUHVCZTSZUIVCZTSZVLZWVHWVJX
        TLZTWTAWVLWVMRYAYBLZTWVIWVHWVNSWVJWVNSWVMWVNWTWVKWVNTWVHYCYDWVNTWVJYCYD
        RYAWVHWVJUWPUWQYCUWRXRZFAVUMRYAUWSLZSZBWVPWUGWLAVUMQSZRVUMUNUOWVQAVULVW
        NUWTZAVUMAVULWUCUXAUXBVUMUXCUXDBVUMWVPUXEWFHARJWUKYEUXKAWUKPIBVUMUQZMLZ
        JWUGWVTPMIBVUMUXFZUXGAWWAVULVUMPUXHKZLZVULVUMOLZJAPXFSZVWMVUMXHSZWWAWWD
        WSVVMWWFAVBPXIVNFAVUMWVSWCZBXHWWCIPVUMXDWWCVQUXIUXJAVULUYASWWGWWDWWEWSA
        VULVWNUXLWWHVULVUMUXMXGAVULVWOVWPUXNXMUXOZUXPAUAUJUKTUGVCWUPUCVCUFVCUHU
        IWVDWVGWVOAVXHTSZUJVCZTSZVXHWWKYEUOZYFZUKVCZRJYBLZSZYFZWWOVXHOLJWWOUXQL
        ZWWKOLYGLZNKZUPZWWOVXIOLZWWSWWKNKZOLZYGLZUPZWWTWUPKZWWOVXHWUPKZOLZWWSWW
        KWUPKZOLZYGLZYEWWRWXFWXAYEUOZWXBWXGYEUOWWNWWQWXNAVXHWWKWWOUXRUXSWWRWXFW
        XAWWRWXCWXEWWRWWOVXIWWRWWPQWWORJUXTAWWNWWQUYBZYKZWWRVXHAWWJWWLWWMWWQUYC
        ZVOZYHZWWRWWSWXDWWRJQSWWOQSWWSQSUYKWXPJWWOUYDUYEZWWRWWKAWWJWWLWWMWWQUYF
        ZVOZYHZUYGWWRWWTWWRAWWJWWLWWORJXTLZSWWTTSZAWWNWWQUYHWXQWYAWWRWWPWYDWWOR
        JUYIWXOYKAUHUITWWOVXHWWKWVDWVOUYLUYJZVOUYMYIWWRWYEWXHWXBWSWYFUBWWTWUOWX
        BTWUPWUMWWTWSWUNWXAWUMWWTNWQWJWVFWXAYJYLWFWWRWXMWXCUPZWXEUPZYGLWXGWWRWX
        JWYGWXLWYHYGWWRWXJWWOVXIUPZOLWYGWWRWXIWYIWWOOWWRWWJWXIWYIWSWXQUBVXHWUOW
        YITWUPWUMVXHWSWUNVXIWUMVXHNWQWJWVFVXIYJYLWFWOWWRWWOVXIWWRWWOWXPWCWWRVXI
        WXRWCYMXPWWRWXLWWSWXDUPZOLWYHWWRWXKWYJWWSOWWRWWLWXKWYJWSWYAUBWWKWUOWYJT
        WUPWUMWWKWSWUNWXDWUMWWKNWQWJWVFWXDYJYLWFWOWWRWWSWXDWWRWWSWXTWCWWRWXDWYB
        WCYMXPYNWWRWXCWXEWWRWXCWXSWCWWRWXEWYCWCUYNUYOYOUYPUYQUYRAWUQVUSWUPKZWVB
        AWULVUSWUPAWULVUSJUDLVUSAWUJVUSWUKJUDAWUJPIBVUMVVEOLUQZMLVUMVYTOLZVUSAW
        UIWYLPMAIBVUMVVEOWUGCURQTFAWVRVVTWVSUYSZVWBWUGWVTWSAWWBXKZVXJYTWOABXHYG
        POIURVVEVUMRXDUSYPYQVVMAVBXKZFWWHWUBABXHVWGVYSFAIBVVEXHVYSWUBVYSVQVRWAY
        RAVUSVUMVUROLWYMAVURVULAVURABQCPURRUSVVNFVVSAVYNWVCBQCWLHXQBTQCUYTVUAAB
        TVWGCFHWAWBZWCVWOVWPXNAVURVYTVUMOWUAWOVUBXMWWIYNAVUSAVUSAVURVULWYQVWNXS
        WCYSXPXLAVUSTSWYKWVBWSWUDUBVUSWUOWVBTWUPWUMVUSWSWUNVUTWUMVUSNWQWJWVFVUT
        YJYLWFXPAWVAVVJJUDLVVJAWUTVVJWUKJUDAPIBVUMVVGOLUQZMLVUMVVIOLWUTVVJABXHY
        GPOIURVVGVUMRXDUSYPYQWYPFWWHVXGVWHYRAWUSWYRPMAIBVUMVVGOWUGWURURQVSFWYNV
        VGVSSVWAVVFYJXKWYOAIUBBTVVEWUOVVGCWUPVWBVXJAWUPVUCWUMVVEWSWUNVVFWUMVVEN
        WQWJWNYTWOAVVIVULVWJVWOVWPXNWPWWIYNAVVJAVVJWUFWCYSXPVUDVUEVUFAVUPQSVUTQ
        SVVBVVCWDAVUMVUOWVSVYQYHWUEVUPVUTVUKXGYIAVUNVUMAVUNVYPXOAVUNVYPVUGWWHVU
        HAVVAVUSAVUSWUDVUIVUJYO $.
    $}

    $( Inequality of arithmetic and geometric means.  Here ` ( M gsum F ) `
       calculates the group sum within the multiplicative monoid of the complex
       numbers (or in other words, it multiplies the elements
       ` F ( x ) , x e. A ` together), and ` ( CCfld gsum F ) ` calculates the
       group sum in the additive group (i.e. the sum of the elements).
       (Contributed by Mario Carneiro, 20-Jun-2015.) $)
    amgm $p |- ( ( A e. Fin /\ A =/= (/) /\ F : A --> ( 0 [,) +oo ) ) ->
        ( ( M gsum F ) ^c ( 1 / ( # ` A ) ) ) <_
          ( ( CCfld gsum F ) / ( # ` A ) ) ) $=
      ( vx vy cfn wcel cc0 co wceq cgsu c1 ccnfld cle wbr wa cmul cc cr c0 cpnf
      wne cico wf w3a cv cfv wrex chash cdiv ccxp csn cres cdif cnfldbas mgpbas
      cnfld1 rngidval cnfldmul mgpplusg ccrg ccmn cncrng mp1i simpl1 wss simpl3
      crngmgp cxr 0re pnfxr icossre mp2an ax-resscn fss sylancl cvv cin disjdif
      sstri fisuppfi a1i cun undif2 simprl snssd ssequn1 syl5req gsumsplit cmpt
      sylib feqresmpt oveq2d cmnd crg cnrng rngmgp ffvelrnd fveq2 gsumsn simprr
      syl3anc 3eqtrd oveq1d diffi difss fssres gsumcl mul02d cn simpl2 hashnncl
      syl wb mpbird nncnd nnne0d reccld recne0d 0cxpd clt cnfld0 rngcmn csubmnd
      eqtrd rege0subm gsumsubmcl elrege0 nnred nngt0d divge0 eqbrtrd rexlimdvaa
      syl12anc wn wral ralnex wfn crp ffn ffvelrn 3ad2antl3 simprd simpld leloe
      sylancr mpbid ord eqcom syl6ib con1d elrp baib sylibrd ralimdva imp ffnfv
      wo sylanbrc amgmlem ex syl5bir pm2.61d ) AGHZAUAUCZAIUBUDJZBUEZUFZEUGZBUH
      ZIKZEAUIZCBLJZMAUJUHZUKJZULJZNBLJZUVOUKJZOPZUVIUVLUVTEAUVIUVJAHZUVLQZQZUV
      QIUVSOUWCUVQIUVPULJIUWCUVNIUVPULUWCUVNCBUVJUMZUNZLJZCBAUWDUOZUNZLJZRJIUWI
      RJIUWCASUWDUWGRBCGMSNCDUPUQZNMCDURUSZNRCDUTVANVBHCVCHUWCVDNCDVIVEZUVEUVFU
      VHUWBVFZUWCUVHUVGSVGASBUEZUVEUVFUVHUWBVHZUVGTSITHZUBVJHUVGTVGVKVLIUBVMVNV
      OWAAUVGSBVPVQZUWCAUVGVRMUMUOZBUWMUWOWBUWDUWGVSUAKUWCUWDAVTWCUWCUWDUWGWDUW
      DAWDZAUWDAWEUWCUWDAVGUWSAKUWCUVJAUVIUWAUVLWFZWGZUWDAWHWLWIWJUWCUWFIUWIRUW
      CUWFCFUWDFUGZBUHZWKZLJZUVKIUWCUWEUXDCLUWCFAUVGUWDBUWOUXAWMWNUWCCWOHZUWAUV
      KSHUXEUVKKNWPHZUXFUWCWQNCDWRVEUWTUWCASUVJBUWQUWTWSUXCSUVKFCUVJAUWJUXBUVJB
      WTXAXCUVIUWAUVLXBXDXEUWCUWIUWCUWGSUWHCGMUWJUWKUWLUWCUVEUWGGHUWMAUWDXFXNZU
      WCUWNUWGAVGUWGSUWHUEUWQAUWDXGASUWGBXHVQZUWCUWGSUWRUWHUXHUXIWBXIXJXDXEUWCU
      VPUWCUVOUWCUVOUWCUVOXKHZUVFUVEUVFUVHUWBXLUWCUVEUXJUVFXOUWMAXMXNXPZXQZUWCU
      VOUXKXRZXSUWCUVOUXLUXMXTYAYFUWCUVRTHIUVROPQZUVOTHIUVOYBPIUVSOPUWCUVRUVGHU
      XNUWCAUVGBNGIYCUXGNVCHUWCWQNYDVEUWMUVGNYEUHHUWCYGWCUWOUWCAUVGVRIUMUOBUWMU
      WOWBYHUVRYIWLUWCUVOUXKYJUWCUVOUXKYKUVRUVOYLYOYMYNUVMYPUVLYPZEAYQZUVIUVTUV
      LEAYRUVIUXPUVTUVIUXPQZABCDUVEUVFUVHUXPVFUVEUVFUVHUXPXLUXQBAYSZUVKYTHZEAYQ
      ZAYTBUEUXQUVHUXRUVEUVFUVHUXPVHAUVGBUUAXNUVIUXPUXTUVIUXOUXSEAUVIUWAQZUXOIU
      VKYBPZUXSUYAUYBUVLUYAUYBYPIUVKKZUVLUYAUYBUYCUYAIUVKOPZUYBUYCUUSZUYAUVKTHZ
      UYDUYAUVKUVGHZUYFUYDQUVHUVEUWAUYGUVFAUVGUVJBUUBUUCUVKYIWLZUUDUYAUWPUYFUYD
      UYEXOVKUYAUYFUYDUYHUUEZIUVKUUFUUGUUHUUIIUVKUUJUUKUULUYAUYFUXSUYBXOUYIUXSU
      YFUYBUVKUUMUUNXNUUOUUPUUQEAYTBUURUUTUVAUVBUVCUVD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Euler-Mascheroni constant
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c gamma $. $( Euler-Mascheroni constant (small letter gamma) $)

  $( The Euler-Mascheroni constant.  (The label abbreviates
     Euler-Mascheroni.) $)
  cem $a class gamma $.

  ${
    $( Define the Euler-Macheroni constant, ` gamma = ` 0.577... .  This is the
       limit of the series ` sum_ k e. ( 1 ... m ) ( 1 / k ) - ( log `` m ) ` ,
       with a proof that the limit exists in ~ emcl .  (Contributed by Mario
       Carneiro, 11-Jul-2014.) $)
    df-em $a |- gamma = sum_ k e. NN
      ( ( 1 / k ) - ( log ` ( 1 + ( 1 / k ) ) ) ) $.
  $}

  ${
    $( Bound on the difference of logs.  (Contributed by Mario Carneiro,
       23-May-2016.) $)
    logdifbnd $p |- ( A e. RR+ ->
      ( ( log ` ( A + 1 ) ) - ( log ` A ) ) <_ ( 1 / A ) ) $=
      ( crp wcel c1 cdiv co caddc clog cfv cmin cle rpcn 1rp rpaddcl wbr ce syl
      rpred cr relogcl cc ax-1cn rpne0 divdird dividd oveq1d eqtr2d fveq2d wceq
      a1i mpan2 relogdiv mpancom eqtrd rpreccl sylancr reefcld clt efgt1p ltled
      reeflogd eqbrtrd wb resubcld eqeltrd efle syl2anc mpbird eqbrtrrd ) ABCZD
      DAEFZGFZHIZADGFZHIZAHIZJFZVKKVJVMVNAEFZHIZVQVJVLVRHVJVRAAEFZVKGFVLVJADAAL
      ZDUACVJUBUJWAAUCZUDVJVTDVKGVJAWAWBUEUFUGUHVNBCZVJVSVQUIVJDBCZWCMADNUKZVNA
      ULUMUNZVJVMVKKOZVMPIZVKPIZKOZVJWHVLWIKVJVLVJWDVKBCZVLBCMAUOZDVKNUPZVAVJVL
      WIVJVLWMRVJVKVJVKWLRZUQVJWKVLWIUROWLVKUSQUTVBVJVMSCVKSCWGWJVCVJVMVQSWFVJV
      OVPVJWCVOSCWEVNTQATVDVEWNVMVKVFVGVHVI $.

    $( Lower bound on the difference of logs.  (Contributed by Mario Carneiro,
       3-Jul-2017.) $)
    logdiflbnd $p |- ( A e. RR+ ->
      ( 1 / ( A + 1 ) ) <_ ( ( log ` ( A + 1 ) ) - ( log ` A ) ) ) $=
      ( crp wcel c1 caddc co cdiv cfv clog cmin cle wbr rpre rpge0 ge0p1rpd a1i
      ce clt recnd oveq1d rprecred 1re cc0 0le1 divge0d cmul ltaddrp2d readdcld
      mulid1d breqtrrd ltdivmuld mpbird eflegeo rpne0d divsubdird pncand dividd
      cr id 3eqtr3rd oveq2d rpne0 recdivd eqtrd breqtrd rpefcld rpdivcld logled
      mpbid relogefd relogdivd 3brtr3d ) ABCZDADEFZGFZQHZIHZVNAGFZIHZVOVNIHAIHJ
      FKVMVPVRKLVQVSKLVMVPDDVOJFZGFZVRKVMVOVMVNVMAAMZANOZUAZVMDVNDURCVMUBPZWCUC
      DKLVMUDPUEVMVODRLDVNDUFFZRLVMDVNWFRVMDAWEVMUSZUGVMVNVMVNVMADWBWEUHSZUIUJV
      MDDVNWEWEWCUKULUMVMWADAVNGFZGFVRVMVTWIDGVMVNDJFZVNGFVNVNGFZVOJFWIVTVMVNDV
      NWHVMDWESZWHVMVNWCUNZUOVMWJAVNGVMADVMAWBSZWLUPTVMWKDVOJVMVNWHWMUQTUTVAVMA
      VNWNWHAVBWMVCVDVEVMVPVRVMVOWDVFVMVNAWCWGVGVHVIVMVOWDVJVMVNAWCWGVKVL $.
  $}

  ${
    $d i k x F $.  $d i k x G $.  $d k m H $.  $d m n N $.  $d k m n x T $.
    emcl.1 $e |- F = ( n e. NN |->
      ( sum_ m e. ( 1 ... n ) ( 1 / m ) - ( log ` n ) ) ) $.
    emcl.2 $e |- G = ( n e. NN |->
      ( sum_ m e. ( 1 ... n ) ( 1 / m ) - ( log ` ( n + 1 ) ) ) ) $.
    $( Lemma for ~ emcl .  The series ` F ` and ` G ` are sequences of real
       numbers that approach ` gamma ` from above and below, respectively.
       (Contributed by Mario Carneiro, 11-Jul-2014.) $)
    emcllem1 $p |- ( F : NN --> RR /\ G : NN --> RR ) $=
      ( cn cr wf c1 cv cfz co clog cfv cmin wcel relogcld resubcld fmpti csu wa
      cdiv fzfid elfznn adantl nnrecred fsumrecl caddc peano2nn nnrpd pm3.2i
      nnrp ) GHCIGHDIBGHJBKZLMZJAKZUCMZAUAZUNNOZPMCEUNGQZURUSUTUOUQAUTJUNUDUTUP
      UOQZUBUPVAUPGQUTUPUNUEUFUGUHZUTUNUNUMRSTBGHURUNJUIMZNOZPMDFUTURVDVBUTVCUT
      VCUNUJUKRSTUL $.

    $( Lemma for ~ emcl . ` F ` is increasing, and ` G ` is decreasing.
       (Contributed by Mario Carneiro, 11-Jul-2014.) $)
    emcllem2 $p |- ( N e. NN -> ( ( F ` ( N + 1 ) ) <_ ( F ` N ) /\
                     ( G ` N ) <_ ( G ` ( N + 1 ) ) ) ) $=
      ( cn wcel c1 caddc co cfv cle wbr cdiv clog cmin clt cr peano2nn nnrecred
      cfz cv csu nnrpd relogcld nnrp resubcld fzfid wa elfznn fsumrecl rpreccld
      adantl ce rpge0d ax-1cn div1i crp 1re ltaddrp sylancr cc wceq nncn addcom
      breqtrd syl5eqbr cc0 wb nnred nngt0d ltrec1 mpanl12 syl2anc mpbid eflegeo
      0lt1 recnd nnne0 nnne0d recdivd divsubdird sylancl oveq1d dividd 3eqtr3rd
      a1i pncan oveq2d rpdivcld reeflogd 3eqtr4d relogdivd efle mpbird leadd2dd
      eqeltrd cuz id syl6eleq oveq2 fsump1 addsub12d 3brtr4d lesubadd2d sumeq1d
      nnuz fveq2 oveq12d ovex fvmpt logdifbnd subadd23d leaddsub syl3anc fveq2d
      syl oveq1 jca ) EHIZEJKLZCMZECMZNOEDMZYCDMZNOYBJYCUCLZJAUDZPLZAUEZYCQMZRL
      ZJEUCLZYJAUEZEQMZRLZYDYENYBYMYQNOYKYLYQKLZNOYBYOJYCPLZKLZYOYLYPRLZKLYKYRN
      YBYSUUAYOYBYCEUAZUBZYBYLYPYBYCYBYCUUBUFZUGZYBEEUHZUGZUIZYBYNYJAYBJEUJYBYI
      YNIZUKYIUUIYIHIZYBYIEULUOUBUMZYBYSYCEPLZQMZUUANYBYSUUMNOZYSUPMZUUMUPMZNOZ
      YBUUOJJYSRLZPLZUUPNYBYSUUCYBYSYBYCUUDUNUQYBJJPLZYCSOZYSJSOZYBUUTJYCSJURUS
      YBJJEKLZYCSYBJTIZEUTIJUVCSOVAUUFJEVBVCYBJVDIZEVDIZUVCYCVEUREVFZJEVGVCVHVI
      YBYCTIZVJYCSOZUVAUVBVKZYBYCUUBVLZYBYCUUBVMUVDVJJSOUVHUVIUKUVJVAVSJYCVNVOV
      PVQVRYBJEYCPLZPLUULUUSUUPYBEYCUVGYBYCUVKVTZEWAYBYCUUBWBZWCYBUURUVLJPYBYCJ
      RLZYCPLYCYCPLZYSRLUVLUURYBYCJYCUVMUVEYBURWIUVMUVNWDYBUVOEYCPYBUVFUVEUVOEV
      EUVGUREJWJWEWFYBUVPJYSRYBYCUVMUVNWGWFWHWKYBUULYBYCEUUDUUFWLWMWNVHYBYSTIUU
      MTIUUNUUQVKUUCYBUUMUUATYBYCEUUDUUFWOZUUHWSYSUUMWPVPWQUVQVHWRYBYJYSAJEYBEH
      JWTMYBXAXIXBYBYIYHIZUKZYJUVSYIUVRUUJYBYIYCULUOUBZVTYIYCJPXCXDZYBYLYOYPYBY
      LUUEVTZYBYOUUKVTZYBYPUUGVTXEXFYBYKYLYQYBYHYJAYBJYCUJUVTUMZUUEYBYOYPUUKUUG
      UIXGWQYBYCHIZYDYMVEUUBBYCJBUDZUCLZYJAUEZUWFQMZRLZYMHCUWFYCVEZUWHYKUWIYLRU
      WKUWGYHYJAUWFYCJUCXCXHZUWFYCQXJXKFYKYLRXLXMXSBEUWJYQHCUWFEVEZUWHYOUWIYPRU
      WMUWGYNYJAUWFEJUCXCXHZUWFEQXJXKFYOYPRXLXMXFYBYOYLRLZYKYCJKLZQMZRLZYFYGNYB
      UWOUWQKLZYKNOZUWOUWRNOZYBYOUWQYLRLZKLYTUWSYKNYBUXBYSYOYBUWQYLYBUWPYBUWPYB
      UWEUWPHIUUBYCUAXSUFUGZUUEUIUUCUUKYBYCUTIUXBYSNOUUDYCXNXSWRYBYOYLUWQUWCUWB
      YBUWQUXCVTXOUWAXFYBUWOTIUWQTIYKTIUWTUXAVKYBYOYLUUKUUEUIUXCUWDUWOUWQYKXPXQ
      VQBEUWHUWFJKLZQMZRLZUWOHDUWMUWHYOUXEYLRUWNUWMUXDYCQUWFEJKXTXRXKGYOYLRXLXM
      YBUWEYGUWRVEUUBBYCUXFUWRHDUWKUWHYKUXEUWQRUWLUWKUXDUWPQUWFYCJKXTXRXKGYKUWQ
      RXLXMXSXFYA $.

    emcl.3 $e |- H = ( n e. NN |-> ( log ` ( 1 + ( 1 / n ) ) ) ) $.
    $( Lemma for ~ emcl .  The function ` H ` is the difference between ` F `
       and ` G ` .  (Contributed by Mario Carneiro, 11-Jul-2014.) $)
    emcllem3 $p |- ( N e. NN -> ( H ` N ) = ( ( F ` N ) - ( G ` N ) ) ) $=
      ( cn wcel c1 cdiv co caddc clog cfv cfz cmin fveq2d cv csu peano2nn nnrpd
      nnrp relogdivd nncn cc ax-1cn nnne0 divdird dividd oveq1d eqtr2d fzfid wa
      a1i elfznn adantl nnrecred fsumrecl recnd relogcld nnncan1d 3eqtr4d oveq2
      wceq oveq2d fvex fvmpt sumeq1d fveq2 oveq12d ovex oveq1 ) FJKZLLFMNZONZPQ
      ZLFRNZLAUAZMNZAUBZFPQZSNZWCFLONZPQZSNZSNZFEQFCQZFDQZSNVPWFFMNZPQWGWDSNVSW
      IVPWFFVPWFFUCUDZFUEZUFVPVRWLPVPWLFFMNZVQONVRVPFLFFUGZLUHKVPUIUQWPFUJZUKVP
      WOLVQOVPFWPWQULUMUNTVPWCWDWGVPWCVPVTWBAVPLFUOVPWAVTKZUPWAWRWAJKVPWAFURUSU
      TVAVBVPWDVPFWNVCVBVPWGVPWFWMVCVBVDVEBFLLBUAZMNZONZPQVSJEWSFVGZXAVRPXBWTVQ
      LOWSFLMVFVHTIVRPVIVJVPWJWEWKWHSBFLWSRNZWBAUBZWSPQZSNWEJCXBXDWCXEWDSXBXCVT
      WBAWSFLRVFVKZWSFPVLVMGWCWDSVNVJBFXDWSLONZPQZSNWHJDXBXDWCXHWGSXFXBXGWFPWSF
      LOVOTVMHWCWGSVNVJVMVE $.

    $( Lemma for ~ emcl .  The difference between series ` F ` and ` G ` tends
       to zero.  (Contributed by Mario Carneiro, 11-Jul-2014.) $)
    emcllem4 $p |- H ~~> 0 $=
      ( wbr wtru cn c1 cdiv co wcel clog cfv adantl crp clt cc0 cli cv cmpt cvv
      nnuz cz 1z a1i cc ax-1cn divcnv mp1i caddc nnex mptex eqeltri wa cr oveq2
      wceq eqid ovex fvmpt nnrecre eqeltrd oveq2d fveq2d fvex 1rp nnrp rpreccld
      rpaddcl sylancr rpred 1re ltaddrp rplogcld cle relogcld ce efgt1p rpefcld
      syl wb logltb syl2anc mpbid relogefd breqtrd 3brtr4d rpge0d climsqz2 trud
      ltled ) EUAUBIJUAABKLBUCZMNZUDZELUEKUFLUGOJUHUILUJOWRUAUBIJUKLBULUMEUEOJE
      BKLWQUNNZPQZUDUEHBKWTUOUPUQUIJAUCZKOZURZXAWRQZLXAMNZUSXBXDXEVAJBXAWQXEKWR
      WPXALMUTZWRVBLXAMVCVDRZXBXEUSOJXAVERZVFXCXAEQZXCXILXEUNNZPQZSXBXIXKVAJBXA
      WTXKKEWPXAVAZWSXJPXLWQXELUNXFVGVHHXJPVIVDRZXCXJXCXJXCLSOXESOZXJSOZVJXCXAX
      BXASOJXAVKRVLZLXEVMVNZVOXCLUSOXNLXJTIVPXPLXEVQVNVRVFZVOXCXKXEXIXDVSXCXKXE
      XCXJXQVTXHXCXKXEWAQZPQZXETXCXJXSTIZXKXTTIZXCXNYAXPXEWBWDXCXOXSSOYAYBWEXQX
      CXEXHWCXJXSWFWGWHXCXEXHWIWJWOXMXGWKXCXIXRWLWMWN $.

    emcl.4 $e |- T = ( n e. NN |->
                       ( ( 1 / n ) - ( log ` ( 1 + ( 1 / n ) ) ) ) ) $.
    $( Lemma for ~ emcl .  The partial sums of the series ` T ` , which is used
       in the definition ~ df-em , is in fact the same as ` G ` .  (Contributed
       by Mario Carneiro, 11-Jul-2014.) $)
    emcllem5 $p |- G = seq 1 ( + , T ) $=
      ( cn c1 co cdiv caddc clog cfv cmin wcel recnd vx cv cfz csu cmpt cseq wa
      elfznn adantl nncnd cc ax-1cn nnne0d divdird dividd oveq1d eqtrd peano2nn
      a1i fveq2d syl nnrpd relogdivd eqtr3d sumeq2dv nnz nnuz syl6eleq relogcld
      fveq2 cuz fsumtscop2 cc0 log1 oveq2i subid1d syl5eq 3eqtrd fzfid nnrecred
      oveq2d crp rpreccld rpaddcl sylancr fsumsub wceq oveq2 oveq12d ovex fvmpt
      1rp id resubcld fsumser mpteq2ia wfn cz 1z seqfn ax-mp fneq2i mpbir dffn5
      mpbi 3eqtr4i ) CKLCUBZUCMZLBUBZNMZBUDZXGLOMZPQZRMZUECKXGOALUFZQZUEZEXOCKX
      NXPXGKSZXKXHLXJOMZPQZBUDZRMZXNXPXRYAXMXKRXRYAXHXILOMZPQZXIPQZRMZBUDXMLPQZ
      RMZXMXRXHXTYFBXRXIXHSZUGZYCXINMZPQXTYFYJYKXSPYJYKXIXINMZXJOMXSYJXILXIYJXI
      YIXIKSZXRXIXGUHUIZUJZLUKSYJULUSYOYJXIYNUMZUNYJYLLXJOYJXIYOYPUOUPUQUTYJYCX
      IYJYCYJYMYCKSYNXIURVAVBYJXIYNVBZVCVDVEXRUAUBZPQZYEYDYGBUAXMLXGYRXIPVJYRYC
      PVJYRLPVJYRXLPVJXGVFXRXLKLVKQZXGURZVGVHXRYRLXLUCMSZUGZYSUUCYRUUCYRUUBYRKS
      XRYRXLUHUIVBVITVLXRYHXMVMRMXMYGVMXMRVNVOXRXMXRXMXRXLXRXLUUAVBVITVPVQVRWAX
      RXHXJXTRMZBUDYBXPXRXHXJXTBXRLXGVSYJXJYJXIYNVTZTYJXTYJXSYJLWBSXJWBSXSWBSWL
      YJXIYQWCLXJWDWEVIZTWFXRUUDBALXGYJYMXIAQUUDWGYNCXILXGNMZLUUGOMZPQZRMUUDKAX
      GXIWGZUUGXJUUIXTRXGXILNWHZUUJUUHXSPUUJUUGXJLOUUKWAUTWIJXJXTRWJWKVAXRXGKYT
      XRWMVGVHYJUUDYJXJXTUUEUUFWNTWOVDVDWPHXOKWQZXOXQWGUULXOYTWQZLWRSUUMWSOALWT
      XAKYTXOVGXBXCCKXOXDXEXF $.

    $( Lemma for ~ emcl .  By the previous lemmas, ` F ` and ` G ` must
       approach a common limit, which is ` gamma ` by definition.  (Contributed
       by Mario Carneiro, 11-Jul-2014.) $)
    emcllem6 $p |- ( F ~~> gamma /\ G ~~> gamma ) $=
      ( vk wbr wtru co c1 cn wcel cfv cr cle vx cem cli cc0 caddc cvv cz 1z a1i
      nnuz cseq cv cdiv clog cmin csu wceq weq oveq2 oveq2d fveq2d oveq12d ovex
      adantl wa nnrecre crp 1rp nnrp rpreccld rpaddcl sylancr relogcld resubcld
      fvmpt recnd crn clt csup emcllem5 wf emcllem1 simpri emcllem2 simprd wral
      cdm wrex 1nn simpli ffvelrni ax-mp fvex emcllem3 readdcl ltaddrp rplogcld
      eqtr3d 1re eqeltrrd rpge0d subge0d mpbid fveq2 breq1d leidi simpld wi syl
      peano2nn syl3anc mpand nnind letrd ralrimiva breq2 ralbidv rspcev climsup
      letr syl5eqbrr climrel releldmi isumclim2 df-em 3brtr4g cmpt nnex eqeltri
      cfz mptex emcllem4 eqeltrd pncan3d eqtr2d climadd cc trud climcl addid1i
      syl6breq pm3.2i ) DUBUCLZEUBUCLZUUCMDUBUDUENUBUCMUBUDKEFDOUFPUJOUGQMUHUIZ
      MUEAOUKZPOKULZUMNZOUUHUENZUNRZUONZKUPEUBUCMUUKKAOPUJUUEUUGPQZUUGARUUKUQMC
      UUGOCULZUMNZOUUNUENZUNRZUONUUKPACKURZUUNUUHUUPUUJUOUUMUUGOUMUSZUUQUUOUUIU
      NUUQUUNUUHOUEUURUTVAZVBJUUHUUJUOVCVOVDMUULVEZUUKUUTUUHUUJUULUUHSQZMUUGVFV
      DZUUTUUIUUTOVGQUUHVGQZUUIVGQVHUULUVCMUULUUGUUGVIVJVDZOUUHVKVLVMVNVPMUUFEV
      QSVRVSZUCLUUFUCWGQMUUFEUVEUCABCDEFGHIJVTZMUAKEOPUJUUEPSEWAZMPSDWAZUVGBCDE
      GHWBZWCZUIUULUUGERZUUGOUENZERTLZMUULUVLDRZUUGDRZTLZUVMBCDEUUGGHWDZWEVDMOD
      RZSQZUVKUVRTLZKPWFZUVKUAULZTLZKPWFZUASWHOPQUVSWIPSODUVHUVGUVIWJZWKWLZMUVT
      KPUUTUVKUVOUVRUULUVKSQMPSUUGEUVJWKVDZUULUVOSQZMPSUUGDUWEWKZVDZUVSUUTUWFUI
      UUTUDUVOUVKUONZTLUVKUVOTLUUTUWKUUTUUJUWKVGUUTUUGFRZUUJUWKUULUWLUUJUQMCUUG
      UUPUUJPFUUSIUUIUNWMVOVDUULUWLUWKUQMBCDEFUUGGHIWNVDZWRUUTUUIUUTOSQZUVAUUIS
      QWSUVBOUUHWOVLUUTUWNUVCOUUIVRLWSUVDOUUHWPVLWQWTXAUUTUVOUVKUWJUWGXBXCUULUV
      OUVRTLZMUWBDRZUVRTLUVRUVRTLUWOUVNUVRTLZUWOUAKUUGUWBOUQUWPUVRUVRTUWBODXDXE
      UAKURUWPUVOUVRTUWBUUGDXDXEZUWBUVLUQUWPUVNUVRTUWBUVLDXDXEUWRUVRUWFXFUULUVP
      UWOUWQUULUVPUVMUVQXGUULUVNSQZUWHUVSUVPUWOVEUWQXHUULUVLPQUWSUUGXJPSUVLDUWE
      WKXIUWIUVSUULUWFUIUVNUVOUVRXTXKXLXMVDXNXOUWDUWAUAUVRSUWBUVRUQUWCUVTKPUWBU
      VRUVKTXPXQXRVLXSYAUUFUVEUCYBYCXIYDUVFKYEYFZDUFQMDCPOUUMYJNOBULUMNBUPUUMUN
      RUONZYGUFGCPUXAYHYKYIUIFUDUCLMBCDEFGHIYLUIUUTUVKUWGVPZUUTUWLUUTUWLUWKSUWM
      UUTUVOUVKUWJUWGVNYMVPUUTUVKUWLUENUVKUWKUENUVOUUTUWLUWKUVKUEUWMUTUUTUVKUVO
      UXBUUTUVOUWJVPYNYOYPUBUUDUBYQQUUDUWTYRZUBEYSWLYTUUAYRUXCUUB $.

    $( Lemma for ~ emcl and ~ harmonicbnd .  Derive bounds on ` gamma ` as
       ` F ( 1 ) ` and ` G ( 1 ) ` .  (Contributed by Mario Carneiro,
       11-Jul-2014.)  (Revised by Mario Carneiro, 9-Apr-2016.) $)
    emcllem7 $p |- ( gamma e. ( ( 1 - ( log ` 2 ) ) [,] 1 ) /\
                     F : NN --> ( gamma [,] 1 ) /\
                     G : NN --> ( ( 1 - ( log ` 2 ) ) [,] gamma ) ) $=
      ( cem c1 cfv co wcel cn wtru cr cle wbr vk vi vx c2 clog cmin cicc wf w3a
      nnuz cz 1z a1i cli emcllem6 simpri emcllem1 ffvelrni adantl climrecl wral
      cv 1nn wa simpr caddc emcllem2 simprd climub ralrimiva wceq fveq2 cfz csu
      cdiv oveq2 sumeq1d cc ax-1cn div1i syl6eq fsum1 mp2an df-2 syl6eqr fveq2d
      oveq1 oveq12d 1re crp 2rp relogcl ax-mp elexi fvmpt breq1d rspcva sylancr
      resubcli cneg cc0 cmpt negeqd eqid negex cvv simpli 0cn nnex mptex df-neg
      recnd climsubc2 adantr renegcld eqeltrd adantlr simpld peano2nn syl mpbid
      lenegd 3brtr4d eqbrtrrd syl6breqr trud mpbird log1 subid1i breq2d elicc2i
      wb leneg syl3anbrc wfn ffn mp1i elfznn ffnfv sylanbrc syl6eleq syl5eqbrr
      cuz monoord2 syl6breq monoord 3jca ) KLUDUEMZUFNZLUGNOZPKLUGNZDUHZPUUIKUG
      NZEUHZUIQUUJUULUUNQKROZUUIKSTZKLSTZUUJQKUAELPUJLUKOZQULUMZEKUNTZQDKUNTZUU
      TABCDEFGHIJUOZUPZUMUAVBZPOZUVDEMZROZQPRUVDEPRDUHZPREUHZBCDEGHUQZUPZURZUSU
      TZQLPOZUBVBZEMZKSTZUBPVAUUPVCQUVQUBPQUVOPOZVDZKUAELUVOPUJQUVRVEZUUTUVSUVC
      UMUVEUVGUVSUVLUSUVEUVFUVDLVFNZEMSTZUVSUVEUWADMZUVDDMZSTZUWBBCDEUVDGHVGZVH
      ZUSVIZVJUVQUUPUBLPUVOLVKZUVPUUIKSUWIUVPLEMZUUIUVOLEVLUVNUWJUUIVKVCCLLCVBZ
      VMNZLBVBZVONZBVNZUWKLVFNZUEMZUFNUUIPEUWKLVKZUWOLUWQUUHUFUWRUWOLLVMNZUWNBV
      NZLUWRUWLUWSUWNBUWKLLVMVPVQUURLVROUWTLVKULVSUWNLBLUWMLVKUWNLLVONLUWMLLVOV
      PLVSVTWAWBWCWAZUWRUWPUDUEUWRUWPLLVFNUDUWKLLVFWGWDWEWFWHHUUIRLUUHWIUDWJOUU
      HROWKUDWLWMWSZWNWOWMZWAWPWQWRQUVNKUVODMZSTZUBPVAUUQVCQUXEUBPUVSUXEUXDWTZK
      WTZSTZUVSUXFXAKUFNZUXGSUVSUVOUCPUCVBZDMZWTZXBZMZUXFUXISUVRUXNUXFVKQUCUVOU
      XLUXFPUXMUXJUVOVKUXKUXDUXJUVODVLXCUXMXDZUXDXEWOUSUVSUXIUAUXMLUVOPUJUVTQUX
      MUXIUNTUVRQKXAUADUXMLXFPUJUUSUVAQUVAUUTUVBXGUMXAVROQXHUMUXMXFOQUCPUXLXIXJ
      UMQUVEVDZUWDUVEUWDROZQPRUVDDUVHUVIUVJXGZURZUSZXLUXPUVDUXMMZUWDWTZXAUWDUFN
      UVEUYAUYBVKQUCUVDUXLUYBPUXMUXJUVDVKUXKUWDUXJUVDDVLXCUXOUWDXEWOUSZUWDXKWAX
      MXNQUVEUYAROUVRUXPUYAUYBRUYCUXPUWDUXTXOXPXQQUVEUYAUWAUXMMZSTUVRUXPUYBUWCW
      TZUYAUYDSUXPUWEUYBUYESTUVEUWEQUVEUWEUWBUWFXRZUSUXPUWCUWDUXPUWAPOZUWCROUVE
      UYGQUVDXSUSZPRUWADUXRURXTUXTYBYAUYCUXPUYGUYDUYEVKUYHUCUWAUXLUYEPUXMUXJUWA
      VKUXKUWCUXJUWADVLXCUXOUWCXEWOXTYCXQVIYDKXKYEUVSUUOUXDROZUXEUXHYLUUOUVMYFZ
      UVRUYIQPRUVODUXRURUSZKUXDYMWRYGZVJUXEUUQUBLPUWIUXDLKSUWIUXDLDMZLUVOLDVLUV
      NUYMLVKVCCLUWOUWKUEMZUFNZLPDUWRUYOLXAUFNLUWRUWOLUYNXAUFUXAUWRUYNLUEMXAUWK
      LUEVLYHWAWHLVSYIWAGLRWIWNWOWMZWAYJWQWRUUILKUXBWIYKYNQDPYOZUXDUUKOZUBPVAUU
      LUVHUYQQUXRPRDYPYQQUYRUBPUVSUYIUXEUXDLSTUYRUYKUYLUVSUXDUYMLSUVSUADLUVOUVS
      UVOPLUUCMUVTUJUUAZUVSUVDLUVOVMNOZVDZUVEUXQUYTUVEUVSUVDUVOYRUSZUXSXTUVSUVD
      LUVOLUFNZVMNOZVDZUVEUWEVUDUVEUVSUVDVUCYRUSZUYFXTUUDUYPUUEKLUXDUYJWIYKYNVJ
      UBPUUKDYSYTQEPYOZUVPUUMOZUBPVAUUNUVIVUGQUVKPREYPYQQVUHUBPUVSUVPROZUUIUVPS
      TUVQVUHUVRVUIQPRUVOEUVKURUSUVSUUIUWJUVPSUXCUVSUAELUVOUYSVUAUVEUVGVUBUVLXT
      VUEUVEUWBVUFUWGXTUUFUUBUWHUUIKUVPUXBUYJYKYNVJUBPUUMEYSYTUUGYF $.
  $}

  ${
    $d k m n N $.
    $( Closure and bounds for the Euler-Macheroni constant.  (Contributed by
       Mario Carneiro, 11-Jul-2014.) $)
    emcl $p |- gamma e. ( ( 1 - ( log ` 2 ) ) [,] 1 ) $=
      ( vn vm vk cem c1 c2 clog cfv cmin co cicc wcel cn cv cfz cdiv cmpt caddc
      wf eqid csu weq oveq2 oveq2d fveq2d oveq12d cbvmptv emcllem7 simp1i ) DEF
      GHIJZEKJLMDEKJAMEANZOJEBNPJBUAZUKGHIJQZSMUJDKJAMULUKERJGHIJQZSCMECNZPJZEU
      PRJZGHZIJZQBAUMUNAMEEUKPJZRJZGHZQZUMTUNTVCTCAMUSUTVBIJCAUBZUPUTURVBIUOUKE
      PUCZVDUQVAGVDUPUTERVEUDUEUFUGUHUI $.

    $( A bound on the harmonic series, as compared to the natural logarithm.
       (Contributed by Mario Carneiro, 9-Apr-2016.) $)
    harmonicbnd $p |- ( N e. NN ->
      ( sum_ m e. ( 1 ... N ) ( 1 / m ) - ( log ` N ) ) e. ( gamma [,] 1 ) ) $=
      ( vn vk c1 cv cfz co cdiv csu clog cfv cmin cem cicc wcel cmpt caddc eqid
      cn wceq oveq2 sumeq1d fveq2 oveq12d eleq1d wral wf oveq2d fveq2d emcllem7
      c2 cbvmptv simp2i fmpt mpbir vtoclri ) ECFZGHZEAFIHZAJZURKLZMHZNEOHZPZEBG
      HZUTAJZBKLZMHZVDPCBTURBUAZVCVIVDVJVAVGVBVHMVJUSVFUTAURBEGUBUCURBKUDUEUFVE
      CTUGTVDCTVCQZUHZNEULKLMHZEOHPVLTVMNOHCTVAURERHKLMHQZUHDTEDFZIHZEVPRHZKLZM
      HZQACVKVNCTEEURIHZRHZKLZQZVKSZVNSWCSDCTVSVTWBMHVOURUAZVPVTVRWBMVOUREIUBZW
      EVQWAKWEVPVTERWFUIUJUEUMUKUNCTVDVCVKWDUOUPUQ $.

    $( A bound on the harmonic series, as compared to the natural logarithm.
       (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    harmonicbnd2 $p |- ( N e. NN -> ( sum_ m e. ( 1 ... N ) ( 1 / m ) -
      ( log ` ( N + 1 ) ) ) e. ( ( 1 - ( log ` 2 ) ) [,] gamma ) ) $=
      ( vn vk c1 cv cfz co cdiv csu caddc clog cfv cmin cem cicc wcel cmpt eqid
      cn c2 wceq oveq2 sumeq1d oveq1 fveq2d oveq12d eleq1d wral oveq2d emcllem7
      wf cbvmptv simp3i fmpt mpbir vtoclri ) ECFZGHZEAFIHZAJZUREKHZLMZNHZEUALMN
      HZOPHZQZEBGHZUTAJZBEKHZLMZNHZVFQCBTURBUBZVDVLVFVMVAVIVCVKNVMUSVHUTAURBEGU
      CUDVMVBVJLURBEKUEUFUGUHVGCTUITVFCTVDRZULZOVEEPHQTOEPHCTVAURLMNHRZULVODTED
      FZIHZEVRKHZLMZNHZRACVPVNCTEEURIHZKHZLMZRZVPSVNSZWESDCTWAWBWDNHVQURUBZVRWB
      VTWDNVQUREIUCZWGVSWCLWGVRWBEKWHUJUFUGUMUKUNCTVFVDVNWFUOUPUQ $.
  $}

  $( The Euler-Macheroni constant is a real number.  (Contributed by Mario
     Carneiro, 11-Jul-2014.) $)
  emre $p |- gamma e. RR $=
    ( c1 c2 clog cfv cmin co cicc cr cem wss 1re crp 2rp relogcl ax-mp resubcli
    wcel iccssre mp2an emcl sselii ) ABCDZEFZAGFZHIUCHQAHQUDHJAUBKBLQUBHQMBNOPK
    UCARSTUA $.

  $( The Euler-Macheroni constant is positive.  (Contributed by Mario Carneiro,
     11-Jul-2014.) $)
  emgt0 $p |- 0 < gamma $=
    ( cc0 c1 c2 clog cfv cmin co clt wbr cem cle ce ceu c3 wcel 2rp ax-mp mp2an
    cr 1re egt2lt3 simpli crp wceq reeflog df-e eqcomi 3brtr4i wb relogcl mpbir
    eflt posdifi mpbi cicc emcl resubcli elicc2i simp2bi 0re emre ltletri ) ABC
    DEZFGZHIZVDJKIZAJHIVCBHIZVEVGVCLEZBLEZHIZCMVHVIHCMHIMNHIUAUBCUCOZVHCUDPCUEQ
    MVIUFUGUHVCSOZBSOVGVJUIVKVLPCUJQZTVCBULRUKVCBVMTUMUNJVDBUOGOZVFUPVNJSOVFJBK
    IVDBJBVCTVMUQZTURUSQAVDJUTVOVAVBR $.

  ${
    $d m A $.  $d m N $.
    $( A bound on the harmonic series, as compared to the natural logarithm.
       (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    harmonicbnd3 $p |- ( N e. NN0 -> ( sum_ m e. ( 1 ... N ) ( 1 / m ) -
      ( log ` ( N + 1 ) ) ) e. ( 0 [,] gamma ) ) $=
      ( wcel cc0 c1 cfz co caddc clog cfv cmin cem c2 cr cle wbr 0re ceu syl6eq
      emre cn0 cn wceq wo cv cdiv csu cicc elnn0 wss 2re ere clt egt2lt3 simpli
      c3 ltleii crp wb 2rp epr logleb mp2an mpbi loge breqtri 1re relogcl ax-mp
      subge0i mpbir leidi iccss mp4an harmonicbnd2 sseldi c0 oveq2 fz10 sumeq1d
      sum0 oveq1 0p1e1 fveq2d log1 oveq12d 0cn subidi elicc2i mpbir3an syl6eqel
      emgt0 jaoi sylbi ) BUACBUBCZBDUCZUDEBFGZEAUEUFGZAUGZBEHGZIJZKGZDLUHGZCZBU
      IWOXDWPWOEMIJZKGZLUHGZXCXBDNCZLNCDXFOPZLLOPXGXCUJQTXIXEEOPXERIJZEOMROPZXE
      XJOPZMRUKULMRUMPRUPUMPUNUOUQMURCZRURCXKXLUSUTVAMRVBVCVDVEVFEXEVGXMXENCUTM
      VHVIVJVKLTVLDLXFLVMVNABVOVPWPXBDXCWPXBDDKGDWPWSDXADKWPWSVQWRAUGDWPWQVQWRA
      WPWQEDFGVQBDEFVRVSSVTWRAWASWPXAEIJDWPWTEIWPWTDEHGEBDEHWBWCSWDWESWFDWGWHSD
      XCCXHDDOPDLOPQDQVLDLQTWLUQDLDQTWIWJWKWMWN $.

    $( A bound on the harmonic series, as compared to the natural logarithm.
       (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    harmoniclbnd $p |- ( A e. RR+ ->
      ( log ` A ) <_ sum_ m e. ( 1 ... ( |_ ` A ) ) ( 1 / m ) ) $=
      ( crp wcel cfv cfl c1 caddc co relogcl cr cn cc0 cle wbr wa syl mpbid cem
      clog cfz cv cdiv csu rprege0 flge0nn0 nn0p1nn nnrpd fzfid elfznn nnrecred
      cn0 adantl fsumrecl rpre fllep1 id logled cmin cicc harmonicbnd3 0re emre
      elicc2i simp2bi subge0d letrd ) ACDZATEZAFEZGHIZTEZGVJUAIZGBUBZUCIZBUDZAJ
      VHVKCDVLKDVHVKVHVJULDZVKLDVHAKDZMANOPVQAUEAUFQZVJUGQUHZVKJQZVHVMVOBVHGVJU
      IVHVNVMDZPVNWBVNLDVHVNVJUJUMUKUNZVHAVKNOZVIVLNOVHVRWDAUOAUPQVHAVKVHUQVTUR
      RVHMVPVLUSIZNOZVLVPNOVHWEMSUTIDZWFVHVQWGVSBVJVAQWGWEKDWFWESNOMSWEVBVCVDVE
      QVHVPVLWCWAVFRVG $.

    $( A bound on the harmonic series, as compared to the natural logarithm.
       (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    harmonicubnd $p |- ( ( A e. RR /\ 1 <_ A ) ->
      sum_ m e. ( 1 ... ( |_ ` A ) ) ( 1 / m ) <_ ( ( log ` A ) + 1 ) ) $=
      ( cr wcel c1 cle wbr wa cfv co caddc cn relogcld peano2re syl cc0 a1i 1re
      clog cem cfl cfz cv cdiv csu fzfid elfznn nnrecred fsumrecl flge1nn nnrpd
      simpl 0re clt 0lt1 simpr ltletrd elrpd cmin cicc harmonicbnd emre elicc2i
      adantl simp3bi lesubadd2d mpbid flle adantr logled leadd1dd letrd ) ACDZE
      AFGZHZEAUAIZUBJZEBUCZUDJZBUEZVPSIZEKJZASIZEKJZVOVQVSBVOEVPUFVOVRVQDZHVRWE
      VRLDVOVRVPUGVDUHUIZVOWACDWBCDVOVPVOVPAUJZUKZMZWANOVOWCCDWDCDVOAVOAVMVNULZ
      VOPEAPCDVOUMQECDVORQZWJPEUNGVOUOQVMVNUPUQURZMZWCNOVOVTWAUSJZEFGZVTWBFGVOW
      NTEUTJDZWOVOVPLDWPWGBVPVAOWPWNCDTWNFGWOTEWNVBRVCVEOVOVTWAEWFWIWKVFVGVOWAW
      CEWIWMWKVOVPAFGZWAWCFGVMWQVNAVHVIVOVPAWHWLVJVGVKVL $.

    $( The asymptotic behavior of
       ` sum_ m <_ A , 1 / m = log A + gamma + O ( 1 / A ) ` .  (Contributed by
       Mario Carneiro, 14-May-2016.) $)
    harmonicbnd4 $p |- ( A e. RR+ -> ( abs `
      ( sum_ m e. ( 1 ... ( |_ ` A ) ) ( 1 / m ) -
        ( ( log ` A ) + gamma ) ) ) <_ ( 1 / A ) ) $=
      ( crp wcel c1 cfv cfz co cdiv cem caddc cle wa recnd cr wbr cc0 syl mpbid
      cmin cfl csu clog cabs fzfid elfznn adantl nnrecred fsumrecl relogcl emre
      cv a1i subsub4d fveq2d rpreccl rpred resubcl sylancr cn0 rprege0 flge0nn0
      cn nn0p1nn nnrpd resubcld cicc harmonicbnd 1re elicc2i simp2bi fllep1 clt
      rpre rpregt0 nnred nngt0d lerec syl12anc le2subd sub32d cuz nnuz syl6eleq
      wb oveq2 fsumm1 cc wceq nn0cnd ax-1cn pncan sylancl oveq2d sumeq1d oveq1d
      eqtrd pncand breqtrd logleb mpdan lesub2dd letrd readdcld id relogdivd ce
      rerpdivcl mpancom reefcld rpcnne0 divdir syl3anc reflcl cmul flle mulid1d
      wne rpcn breqtrrd ledivmul mpbird leadd1dd eqbrtrd efgt1p rpdivcl rpefcld
      ltled logled relogefd lesubadd2d harmonicbnd3 simp3bi lesubaddd absdifled
      eqbrtrrd 0re mpbir2and ) ACDZEAUAFZGHZEBULZIHZBUBZAUCFZTHZJTHZUDFZUUDUUEJ
      KHTHZUDFEAIHZLYSUUGUUIUDYSUUDUUEJYSUUDYSUUAUUCBYSEYTUEYSUUBUUADZMUUBUUKUU
      BVCDZYSUUBYTUFUGUHUIZNZYSUUEAUJZNZYSJJODZYSUKUMZNUNUOYSUUHUUJLPJUUJTHZUUF
      LPUUFJUUJKHLPZYSUUSUUDYTEKHZUCFZTHZUUFYSUUQUUJODUUSODUKYSUUJAUPZUQZJUUJUR
      USYSUUDUVBUUMYSUVACDZUVBODYSUVAYSYTUTDZUVAVCDZYSAODZQALPMUVGAVAAVBRZYTVDR
      ZVEZUVAUJRZVFZYSUUDUUEUUMUUOVFZYSUUSEUVAGHZUUCBUBZUVBTHZEUVAIHZTHZUVCLYSJ
      UVSUVRUUJUURYSUVAUVKUHZYSUVQUVBYSUVPUUCBYSEUVAUEYSUUBUVPDZMZUUBUWBUULYSUU
      BUVAUFUGUHZUIZUVMVFUVEYSUVRJEVGHDZJUVRLPZYSUVHUWFUVKBUVAVHRUWFUVRODUWGUVR
      ELPJEUVRUKVIVJVKRYSAUVALPZUVSUUJLPZYSUVIUWHAVNZAVLRZYSUVIQAVMPMZUVAODZQUV
      AVMPUWHUWIWEAVOZYSUVAUVKVPZYSUVAUVKVQAUVAVRVSSVTYSUVTUVQUVSTHZUVBTHUVCYSU
      VQUVBUVSYSUVQUWENYSUVBUVMNYSUVSUWANZWAYSUWPUUDUVBTYSUWPUUDUVSKHZUVSTHUUDY
      SUVQUWRUVSTYSUVQEUVAETHZGHZUUCBUBZUVSKHUWRYSUUCUVSBEUVAYSUVAVCEWBFUVKWCWD
      UWCUUCUWDNUUBUVAEIWFWGYSUXAUUDUVSKYSUWTUUAUUCBYSUWSYTEGYSYTWHDZEWHDZUWSYT
      WIYSYTUVJWJZWKYTEWLWMWNWOWPWQWPYSUUDUVSUUNUWQWRWQWPWQWSYSUUEUVBUUDUUOUVMU
      UMYSUWHUUEUVBLPZUWKYSUVFUWHUXEWEUVLAUVAWTXASXBXCYSUUFUUJTHZJLPUUTYSUXFUVC
      JYSUUFUUJUVOUVEVFUVNUURYSUXFUUDUUEUUJKHZTHUVCLYSUUDUUEUUJUUNUUPYSUUJUVENU
      NYSUVBUXGUUDUVMYSUUEUUJUUOUVEXDUUMYSUVBUUETHZUUJLPUVBUXGLPYSUVAAIHZUCFZUX
      HUUJLYSUVAAUVLYSXEXFYSUXJUUJXGFZUCFZUUJLYSUXIUXKLPUXJUXLLPYSUXIEUUJKHZUXK
      UWMYSUXIODUWOUVAAXHXIYSEUUJEODZYSVIUMZUVEXDZYSUUJUVEXJZYSUXIYTAIHZUUJKHZU
      XMLYSUXBUXCAWHDAQXRMUXIUXSWIUXDUXCYSWKUMAXKYTEAXLXMYSUXREUUJYTODZYSUXRODY
      SUVIUXTUWJAXNRZYTAXHXIUXOUVEYSUXRELPZYTAEXOHZLPZYSYTAUYCLYSUVIYTALPUWJAXP
      RYSAAXSXQXTYSUXTUXNUWLUYBUYDWEUYAUXOUWNYTEAYAXMYBYCYDYSUXMUXKUXPUXQYSUUJC
      DUXMUXKVMPUVDUUJYERYHXCYSUXIUXKUVFYSUXICDUVLUVAAYFXIYSUUJUVEYGYISYSUUJUVE
      YJWSYPYSUVBUUEUUJUVMUUOUVEYKSXBYDYSUVCQJVGHDZUVCJLPZYSUVGUYEUVJBYTYLRUYEU
      VCODQUVCLPUYFQJUVCYQUKVJYMRXCYSUUFUUJJUVOUVEUURYNSYSUUFJUUJUVOUURUVEYOYRY
      P $.
  $}

  ${
    $d n A $.  $d n ph $.  $d n R $.  $d n T $.
    fsumharmonic.a $e |- ( ph -> A e. RR+ ) $.
    fsumharmonic.t $e |- ( ph -> ( T e. RR /\ 1 <_ T ) ) $.
    fsumharmonic.r $e |- ( ph -> ( R e. RR /\ 0 <_ R ) ) $.
    fsumharmonic.b $e |- ( ( ph /\ n e. ( 1 ... ( |_ ` A ) ) ) -> B e. CC ) $.
    fsumharmonic.c $e |- ( ( ph /\ n e. ( 1 ... ( |_ ` A ) ) ) -> C e. RR ) $.
    fsumharmonic.0 $e |- ( ( ph /\ n e. ( 1 ... ( |_ ` A ) ) ) -> 0 <_ C ) $.
    fsumharmonic.1 $e |- ( ( ( ph /\ n e. ( 1 ... ( |_ ` A ) ) ) /\
      T <_ ( A / n ) ) -> ( abs ` B ) <_ ( C x. n ) ) $.
    fsumharmonic.2 $e |- ( ( ( ph /\
     n e. ( 1 ... ( |_ ` A ) ) ) /\ ( A / n ) < T ) -> ( abs ` B ) <_ R ) $.
    $( Bound a finite sum based on the harmonic series, where the "strong"
       bound ` C ` only applies asymptotically, and there is a "weak" bound
       ` R ` for the remaining values.  (Contributed by Mario Carneiro,
       18-May-2016.) $)
    fsumharmonic $p |- ( ph ->
     ( abs ` sum_ n e. ( 1 ... ( |_ ` A ) ) ( B / n ) ) <_
       ( sum_ n e. ( 1 ... ( |_ ` A ) ) C + ( R x. ( ( log ` T ) + 1 ) ) ) ) $=
      ( c1 co wcel cle wbr cfl cfv cfz cv cdiv cabs clog caddc cmul fzfid wa cn
      csu elfznn adantl nncnd nnne0d divcld fsumcl abscld nndivred fsumrecl cc0
      cr simpld 0re a1i 1re clt simprd ltletrd elrpd relogcld readdcld remulcld
      0lt1 fsumabs absdivd wceq nnrpd rprege0d absid syl eqtrd sumeq2dv breqtrd
      oveq2d cin cn0 rpdivcld flge0nn0 nn0red ltp1d fzdisj cuz cun nn0p1nn nnuz
      c0 syl6eleq rpred jca rpregt0d lediv2 syl211anc mpbid recnd div1d flword2
      wb syl3anc fzsplit2 syl2anc fsumsplit ssun1 syl5sseqr sselda syldan ssun2
      fznnfl simplbda adantr lemuldiv2 lemuldivd bitr3d wi ex mpd cc ledivmul2d
      mpbird fsumle fsumless letrd nnrecred crp wn cmin rpge0d sylancl eqeltrrd
      divrecd noel elin eleq2d mtbiri imnan sylibr con2d imp baibd syl2an bitrd
      syl5bbr mtbid ltnled lediv1dd fsummulc2 breqtrrd pncan2d resubcld adantlr
      oveq1d rpreccld simpr 0p1e1 syl6breqr flbi mpbir2and fz10 syl6eq syl6eqss
      cz 0z 0ss suble0d logge0d 0le1 addge0d harmonicubnd harmoniclbnd peano2re
      le2sub syl22anc mp2and pnncand relogdivd ax-1cn addcom ltlecasei eqbrtrrd
      sylan 3eqtr4d lemul2a syl31anc le2addd eqbrtrd ) APBUAUBZUCQZCGUDZUEQZGUM
      ZUFUBZUWSCUFUBZUWTUEQZGUMZUWSDGUMZEFUGUBZPUHQZUIQZUHQZAUXBAUWSUXAGAPUWRUJ
      ZAUWTUWSRZUKZCUWTKUXNUWTUXMUWTULRZAUWTUWRUNZUOZUPZUXNUWTUXQUQZURZUSUTAUWS
      UXEGUXLUXNUXDUWTUXNCKUTZUXQVAZVBAUXGUXJAUWSDGUXLLVBZAEUXIAEVDRZVCESTZJVEZ
      AUXHPAFAFAFVDRZPFSTZIVEZAVCPFVCVDRZAVFVGPVDRZAVHVGZUYIVCPVITZAVPVGZAUYGUY
      HIVJZVKZVLZVMZUYLVNZVOZVNAUXCUWSUXAUFUBZGUMUXFSAUWSUXAGUXLUXTVQAUWSVUAUXE
      GUXNVUAUXDUWTUFUBZUEQUXEUXNCUWTKUXRUXSVRUXNVUBUWTUXDUEUXNUWTVDRZVCUWTSTUK
      VUBUWTVSUXNUWTUXNUWTUXQVTZWAUWTWBWCWGWDWEWFAUXFPBFUEQZUAUBZUCQZUXEGUMZVUF
      PUHQZUWRUCQZUXEGUMZUHQUXKSAVUGVUJUXEUWSGAVUFVUIVITVUGVUJWHZWSVSAVUFAVUFAV
      UEVDRZVCVUESTUKVUFWIRZAVUEABFHUYQWJZWAVUEWKWCZWLWMPVUFVUIUWRWNWCZAVUIPWOU
      BZRUWRVUFWOUBRZUWSVUGVUJWPZVSAVUIULVURAVUNVUIULRVUPVUFWQWCWRWTAVUMBVDRZVU
      EBSTVUSAVUEVUOXAZABHXAZAVUEBPUEQZBSAUYHVUEVVDSTZUYOAUYKUYMUYGVCFVITZUKZVV
      AVCBVITUKUYHVVEXJUYLUYNAUYGVVFUYIUYPXBZABHXCPFBXDXEXFABABVVCXGXHWFVUEBXIX
      KVUFPUWRXLXMZUXLUXNUXEUYBXGXNAVUHVUKUXGUXJAVUGUXEGAPVUFUJZAUWTVUGRZUXMUXE
      VDRZAVUGUWSUWTAVUTVUGUWSVUGVUJXOVVIXPZXQZUYBXRZVBZAVUJUXEGAVUIUWRUJZAUWTV
      UJRZUXMVVLAVUJUWSUWTAVUTVUJUWSVUJVUGXSVVIXPXQZUYBXRZVBZUYCUYTAVUHVUGDGUMU
      XGVVPAVUGDGVVJAVVKUXMDVDRVVNLXRZVBUYCAVUGUXEDGVVJVVOVWBAVVKUKZUXEDSTUXDDU
      WTUIQSTZVWCFBUWTUEQZSTZVWDVWCUWTVUESTZVWFAVVKUXOVWGAVUMVVKUXOVWGUKXJVVBUW
      TVUEXTZWCYAAVVKUXMVWGVWFXJVVNUXNFUWTUIQBSTZVWGVWFUXNVUCVVAVVGVWIVWGXJUXNU
      WTVUDXAAVVAUXMVVCYBZAVVGUXMVVHYBUWTBFYCXKUXNFBUWTAUYGUXMUYIYBVWJVUDYDYEZX
      RXFAVVKUXMVWFVWDYFVVNUXNVWFVWDNYGXRYHVWCUXDDUWTVWCCAVVKUXMCYIRVVNKXRUTVWB
      VWCUWTVWCUXMUXOVVNUXPWCZVTZYJYKYLAUWSDVUGGUXLLMVVMYMYNAVUKEVUJPUWTUEQZGUM
      ZUIQZUXJVWAAEVWOUYFAVUJVWNGVVQAVVRUKZUWTVWQUXMUXOVVSUXPWCZYOZVBZVOUYTAVUK
      VUJEVWNUIQZGUMVWPSAVUJUXEVXAGVVQVVTVWQEUWTUEQZVXAVDVWQEUWTVWQEAUYDVVRUYFY
      BZXGVWQUWTVWRUPVWQUWTVWRUQUUBZVWQEUWTVXCVWRVAUUAVWQUXEVXBVXASVWQUXDEUWTAV
      VRUXMUXDVDRVVSUYAXRVXCAVVRUXMUWTYPRZVVSVUDXRVWQVWEFVITZUXDESTZVWQVXFVWFYQ
      VWQVVKVWFAVVRVVKYQAVVKVVRAVVKVVRUKZYQVVKVVRYQYFAVXHUWTWSRZUWTUUCVXHUWTVUL
      RAVXIUWTVUGVUJUUDAVULWSUWTVUQUUEUUNUUFVVKVVRUUGUUHUUIUUJAVVRUXMVVKVWFXJVV
      SUXNVVKVWGVWFAVUMUXOVVKVWGXJUXMVVBUXPVUMVVKUXOVWGVWHUUKUULVWKUUMXRUUOVWQV
      WEFVWQBUWTAVVAVVRVVCYBVWRVAAUYGVVRUYIYBUUPYKAVVRUXMVXFVXGYFVVSUXNVXFVXGOY
      GXRYHUUQVXDWFYLAVUJVWNEGVVQAEUYFXGVWQVWNVWSXGUURUUSAVWOVDRUXIVDRZUYDUYEUK
      VWOUXISTVWPUXJSTVWTUYSJAUWSVWNGUMZVUGVWNGUMZYRQZVWOUXISAVXMVXLVWOUHQZVXLY
      RQVWOAVXKVXNVXLYRAVUGVUJVWNUWSGVUQVVIUXLUXNVWNUXNUWTUXQYOZXGXNUVCAVXLVWOA
      VXLAVUGVWNGVVJVWCUWTVWLYOVBZXGAVWOVWTXGUUTWDAVXMUXISTBPABPVITZUKZVXMVCUXI
      VXRVXKVXLAVXKVDRZVXQAUWSVWNGUXLVXOVBZYBZAVXLVDRZVXQVXPYBZUVAUYJVXRVFVGAVX
      JVXQUYSYBVXRVXMVCSTVXKVXLSTVXRVUGVWNUWSGVXRPVUFUJVXRVVKUKZVWNVYDUWTAVVKVX
      EVXQVWMUVBUVDZXAVYDVWNVYEYSVXRUWSWSVUGVXRUWSPVCUCQWSVXRUWRVCPUCVXRUWRVCVS
      ZVCBSTZBVCPUHQZVITZVXRBABYPRVXQHYBYSVXRBPVYHVIAVXQUVEUVFUVGVXRVVAVCUVMRVY
      FVYGVYIUKXJAVVAVXQVVCYBUVNBVCUVHYTUVIWGUVJUVKVUGUVOUVLYMVXRVXKVXLVYAVYCUV
      PYKAVCUXISTVXQAUXHPUYRUYLAFUYIUYOUVQVCPSTAUVRVGUVSYBYNAPBSTZUKZVXMBUGUBZP
      UHQZVUEUGUBZYRQZUXISVYKVXKVYMSTZVYNVXLSTZVXMVYOSTZAVVAVYJVYPVVCBGUVTUWLAV
      YQVYJAVUEYPRVYQVUOVUEGUWAWCYBAVYPVYQUKVYRYFZVYJAVXSVYBVYMVDRZVYNVDRVYSVXT
      VXPAVYLVDRVYTABHVMZVYLUWBWCAVUEVUOVMVXKVXLVYMVYNUWCUWDYBUWEAVYOUXIVSVYJAV
      YMVYLUXHYRQZYRQPUXHUHQZVYOUXIAVYLPUXHAVYLWUAXGAPUYLXGAUXHUYRXGZUWFAVYNWUB
      VYMYRABFHUYQUWGWGAUXHYIRPYIRUXIWUCVSWUDUWHUXHPUWIYTUWMYBWFVVCUYLUWJUWKVWO
      UXIEUWNUWOYNUWPUWQYN $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                     Basic number theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                              Wilson's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The only elements that are equal to their own inverses in the
     multiplicative group of nonzero elements in ` ZZ / P ZZ ` are ` 1 ` and
     ` -u 1 == P - 1 ` .  (Note that from ~ prmdiveq ,
     ` ( N ^ ( P - 2 ) ) mod P ` is the modular inverse of ` N ` in
     ` ZZ / P ZZ ` .  (Contributed by Mario Carneiro, 24-Jan-2015.) $)
  wilthlem1 $p |- ( ( P e. Prime /\ N e. ( 1 ... ( P - 1 ) ) ) ->
    ( N = ( ( N ^ ( P - 2 ) ) mod P ) <-> ( N = 1 \/ N = ( P - 1 ) ) ) ) $=
    ( wcel c1 cmin co cfz c2 cmo wceq cdivides wbr caddc cmul cc0 cz cc syl3anc
    syl wb cprime wa cexp wo elfzelz adantl peano2zm zcnd peano2zd ax-1cn subsq
    mulcomd sylancl sqvald sq1 a1i oveq12d 3eqtr2d breq2d 1e0p1 oveq1i 0z ax-mp
    wss fzp1ss eqsstri simpr sseldi biantrurd bitrd simpl euclemma wn fzm1ndvds
    cn prmnn sylan eqid prmdiveq 3bitr3rd 1z moddvds cr crp cle clt nnred nnrpd
    elfznn nnnn0d nn0ge0d elfzle2 zltlem1 syl2anr mpbird modid syl22anc cuz cfv
    prmz prmuz2 eluz2b2 simprbi 1mod syl2anc eqeq12d cneg znegcld nncnd mulid2d
    bitr3d oveq2d neg1cn addcom sylancr negsub 3eqtrd oveq1d renegcli peano2rem
    1re modcyc cn0 nnm1nn0 ltm1d 3eqtr3d subneg orbi12d ) AUACZBDADEFZGFZCZUBZB
    BAHEFUCFAIFZJZABDEFZKLZABDMFZKLZUDZBDJZBYJJZUDYMAYPYRNFZKLZBOYJGFZCZABBNFZD
    EFZKLZUBZYTYOYMUUDUUIUUJYMUUCUUHAKYMUUCYRYPNFZBHUCFZDHUCFZEFZUUHYMYPYRYMYPY
    MBPCZYPPCZYLUUOYIBDYJUEZUFZBUGSZUHYMYRYMBUURUIZUHULYMBQCZDQCZUUNUUKJYMBUURU
    HZUJBDUKUMYMUULUUGUUMDEYMBUVCUNUUMDJYMUOUPUQURUSYMUUFUUIYMYKUUEBYKODMFZYJGF
    ZUUEDUVDYJGUTVAOPCUVEUUEVDVBOYJVEVCVFYIYLVGVHVIVJYMYIUUPYRPCUUDYTTYIYLVKZUU
    SUUTAYPYRVLRYMYIUUOABKLVMZUUJYOTUVFUURYIAVOCZYLUVGAVPZABVNVQBAYNBYNVRVSRVTY
    MYQUUAYSUUBYMBAIFZDAIFZJZYQUUAYMUVHUUODPCZUVLYQTYMYIUVHUVFUVISZUURUVMYMWAUP
    ZBDAWBRYMUVJBUVKDYMBWCCAWDCZOBWELBAWFLZUVJBJYMBYLBVOCYIBYJWIUFZWGYMAUVNWHZY
    MBYMBUVRWJWKYMUVQBYJWELZYLUVTYIBDYJWLUFYLUUOAPCUVQUVTTYIUUQAWTBAWMWNWOBAWPW
    QZYMAWCCZDAWFLZUVKDJYMAUVNWGZYMAHWRWSCZUWCYMYIUWEUVFAXASUWEUVHUWCAXBXCSAXDX
    EXFXKYMUVJDXGZAIFZJZABUWFEFZKLZUUBYSYMUVHUUOUWFPCUWHUWJTUVNUURYMDUVOXHBUWFA
    WBRYMUVJBUWGYJUWAYMUWFDANFZMFZAIFZYJAIFZUWGYJYMUWLYJAIYMUWLUWFAMFZAUWFMFZYJ
    YMUWKAUWFMYMAYMAUVNXIZXJXLYMUWFQCAQCZUWOUWPJXMUWQUWFAXNXOYMUWRUVBUWPYJJUWQU
    JADXPUMXQXRYMUWFWCCZUVPUVMUWMUWGJUWSYMDYAXSUPUVSUVOUWFADYBRYMYJWCCZUVPOYJWE
    LYJAWFLUWNYJJYMUWBUWTUWDAXTSUVSYMYJYMUVHYJYCCUVNAYDSWKYMAUWDYEYJAWPWQYFXFYM
    UWIYRAKYMUVAUVBUWIYRJUVCUJBDYGUMUSVTYHVJ $.

  ${
    $d s t x y A $.  $d k s t w x y z P $.  $d w x y z ph $.  $d s w x y z S $.
    $d s t w x y z T $.
    wilthlem.t $e |- T = ( mulGrp ` CCfld ) $.
    wilthlem.a $e |- A = { x e. ~P ( 1 ... ( P - 1 ) ) | ( ( P - 1 ) e. x /\
      A. y e. x ( ( y ^ ( P - 2 ) ) mod P ) e. x ) } $.
    ${
      wilthlem2.p $e |- ( ph -> P e. Prime ) $.
      wilthlem2.s $e |- ( ph -> S e. A ) $.
      wilthlem2.r $e |- ( ph -> A. s e. A ( s C. S ->
        ( ( T gsum ( _I |` s ) ) mod P ) = ( -u 1 mod P ) ) ) $.
      $( Lemma for ~ wilth : induction step.  The "hand proof" version of this
         theorem works by writing out the list of all numbers from ` 1 ` to
         ` P - 1 ` in pairs such that a number is paired with its inverse.
         Every number has a unique inverse different from itself except ` 1 `
         and ` P - 1 ` , and so each pair multiplies to ` 1 ` , and ` 1 ` and
         ` P - 1 == -u 1 ` multiply to ` -u 1 ` , so the full product is equal
         to ` -u 1 ` .  Here we make this precise by doing the product pair by
         pair.

         The induction hypothesis says that every subset ` S ` of
         ` 1 ... ( P - 1 ) ` that is closed under inverse (i.e. all pairs are
         matched up) and contains ` P - 1 ` multiplies to ` -u 1 mod P ` .
         Given such a set, we take out one element ` z =/= P - 1 ` .  If there
         are no such elements, then ` S = { P - 1 } ` which forms the base
         case.  Otherwise, ` S \ { z , z ^ -u 1 } ` is also closed under
         inverse and contains ` P - 1 ` , so the induction hypothesis says that
         this equals ` -u 1 ` ; and the remaining two elements are either equal
         to each other, in which case ~ wilthlem1 gives that ` z = 1 ` or
         ` P - 1 ` , and we've already excluded the second case, so the product
         gives ` 1 ` ; or ` z =/= z ^ -u 1 ` and their product is ` 1 ` .  In
         either case the accumulated product is unaffected.  (Contributed by
         Mario Carneiro, 24-Jan-2015.) $)
      wilthlem2 $p |- ( ph ->
        ( ( T gsum ( _I |` S ) ) mod P ) = ( -u 1 mod P ) ) $=
        ( c1 co cmo wceq wcel cc cz vz vw cmin csn wss cid cres cgsu wa cv cmpt
        simpr cexp wral cfz eleq2 raleqbi1dv anbi12d elrab2 sylib simprd simpld
        adantr reseq2d mptresid oveq2d oveq1d caddc cn syl nncnd ax-1cn sylancl
        cmul ccnfld mp1i cn0 nn0cnd id gsumsn syl3anc mulid2d 3eqtr4d cr 1re 1z
        a1i eqtrd ex wn cpr cdif ax-mp wf wf1o f1oi f1of syl6ss fss sylancr cfn
        ssfi cin cun oveq1 rspcv syl2anc resabs1 oveq2i cfv fisuppfi gsumsubmcl
        c0 ssdifssd sseldd wo syl5eq wne sylnib ovex eqcom bitri orcom cdivides
        wbr fzm1ndvds eqid elfznn zcnd wpss sylibr cc0 mulcld prmdivdiv eqeq12d
        wb wi syl5ibr sylanbrc elpr cneg c2 cpw snssd eqssd cprime prmnn negsub
        syl6eqr neg1cn addcom eqtr3d cmnd crg cnrng rngmgp nnm1nn0 cnfldbas crp
        mgpbas renegcli nnrpd modcyc wex cnfld1 rngidval cnfldmul mgpplusg ccmn
        nss ccrg cncrng crngmgp elfzelz ssriv zsscn ccnv cvv cima fzfi cnvimass
        elpwid dmresi sseqtri disjdif undif2 simprl eleq1d sylc ssequn1 syl5req
        cdm prssi gsumsplit difss oveq12d csubrg csubmnd zsubrg subrgsubm sstrd
        prfi zred dfsn2 orcd biimpar syldan preq2d 3eqtr3d df-pr reseq2i eqtr4i
        wilthlem1 snfi elsni adantl eqeltrd adantlr simprr biorf 3bitr4g bitr4d
        elsn necon3abid biimpa gsumunsn prmdiv nnmulcld nnzd moddvds pm2.61dane
        elsnc mpbird modmul1 syl221anc elpw2 nn0uz syl6eleq eluzfz2 prmz zsubcl
        dvdsmul1 subdird subsubd subdid mulid1d breqtrrd prmdiveq mpbi2and mtod
        cuz pncan sylnibr eldifd eldifi r19.21bi sylan2 sselda eqeq2d syl5ibcom
        ioran eldif orim12d vex 3imtr4g con3d impr sylan2b ralrimiva dfss1 prnz
        jca eqnetrd disj4 necon2abii psseq1 reseq2 eqeq1d imbi12d syl3c exlimdv
        3eqtrd syl5bi pm2.61d ) AFENUCOZUDZUEZGUFFUGZUHOZEPOZNUUAZEPOZQZAVWGVWM
        AVWGUIZVWJGUAVWFUAUJZUKZUHOZEPOZVWLVWNVWIVWQEPVWNVWHVWPGUHVWNVWHUFVWFUG
        VWPVWNFVWFUFVWNFVWFAVWGULAVWFFUEVWGAVWEFAVWEFRZCUJZEUUBUCOZUMOZEPOZFRZC
        FUNZAFNVWEUOOZUUCZRZVWSVXEUIZAFDRZVXHVXIUILVWEBUJZRZVXCVXKRZCVXKUNZUIZV
        XIBFVXGDVXKFQVXLVWSVXNVXEVXKFVWEUPVXMVXDCVXKFVXKFVXCUPUQURJUSUTZVAZVBZU
        UDVCUUEVDUAVWFVEUUIVFVGAVWRVWLQVWGAVWRVWKNEVNOZVHOZEPOZVWLAVWQVXTEPAVWE
        VWKEVHOZVWQVXTAEVWKVHOZVWEVYBAESRZNSRZVYCVWEQAEAEUUFRZEVIRZKEUUGVJZVKZV
        LENUUHVMAVYDVWKSRVYCVYBQVYIUUJEVWKUUKVMUULAGUUMRZVWESRZVYKVWQVWEQVOUUNR
        VYJAUUOVOGIUUPVPZAVWEAVYGVWEVQRZVYHEUUQZVJVRZVYOVWOSVWEUAGVWESSVOGIUURU
        UTZVWOVWEQZVSVTWAAVXSEVWKVHAEVYIWBVFWCVGAVWKWDRZEUUSRZNTRZVYAVWLQVYRANW
        EUVAWGAEVYHUVBZVYTAWFWGVWKENUVCWAWHVCWHWIVWGWJVWOFRZVWOVWFRZWJZUIZUAUVD
        AVWMUAFVWFUVJAWUEVWMUAAWUEVWMAWUEUIZVWJGUFVWOVWOVXAUMOZEPOZWKZUGZUHOZGU
        FFWUIWLZUGZUHOZVNOZEPOZNWUNVNOZEPOZVWLWUFVWIWUOEPWUFVWIGVWHWUIUGZUHOZGV
        WHWULUGZUHOZVNOWUOWUFFSWUIWULVNVWHGDNVYPVONGIUVEUVFZVOVNGIUVGUVHZGUVIRZ
        WUFVOUVKRWVEUVLVOGIUVMWMZWGZAVXJWUELVCAFSVWHWNZWUEAFFVWHWNZFSUEZWVHFFVW
        HWOWVIFWPFFVWHWQWMAFTSAFVXFTAFVXFAVXHVXIVXPVBUWBZUAVXFTVWONVWEUVNZUVOWR
        ZUVPWRZFFSVWHWSWTVCAVWHUVQUVRNUDWLZUVSZXARZWUEAFXARZWVPFUEWVQAVXFXARZFV
        XFUEZWVRNVWEUVTZWVKVXFFXBWTWVPVWHUWLFVWHWVOUWAFUWCUWDFWVPXBVMVCWUIWULXC
        XMQWUFWUIFUWEWGWUFWUIWULXDWUIFXDZFWUIFUWFWUFWUIFUEZWWBFQWUFWUBWUHFRZWWC
        AWUBWUDUWGZWUFWUBVXEWWDWWEAVXEWUEAVWSVXEVXQVAVCZVXDWWDCVWOFVWTVWOQZVXCW
        UHFWWGVXBWUGEPVWTVWOVXAUMXEVGUWHXFUWIZVWOWUHFUWMXGZWUIFUWJUTUWKUWNWUFWU
        TWUKWVBWUNVNWUFWUSWUJGUHWUFWWCWUSWUJQWWIUFWUIFXHVJVFWVBWUNQWUFWVAWUMGUH
        WULFUEWVAWUMQFWUIUWOUFWULFXHWMXIWGUWPWHVGWUFWUKWDRNWDRZWUNTRVYSWUKEPOZN
        EPOZQZWUPWURQWUFWUKWUFWUITWUJGXANWVCWVGWUIXARWUFVWOWUHUXBWGZTVOUWQXJRTG
        UWRXJRWUFUWSTVOGIUWTVPZWUFWUIWUIWUJWNZWUITUEWUITWUJWNWUIWUIWUJWOWWPWUIW
        PWUIWUIWUJWQWMWUFWUIFTWWIAFTUEWUEWVMVCZUXAWUIWUITWUJWSWTZWUFWUITWVOWUJW
        WNWWRXKXLUXCWWJWUFWEWGWUFWULTWUMGXANWVCWVGWUFWVSWULVXFUEZWULXARWWAWUFFV
        XFWUIAWVTWUEWVKVCZXNZVXFWULXBWTZWWOWUFWULWULWUMWNZWULTUEWULTWUMWNWULWUL
        WUMWOWXCWULWPWULWULWUMWQWMWUFFTWUIWWQXNWULWULTWUMWSWTZWUFWULTWVOWUMWXBW
        XDXKXLZAVYSWUEWUAVCWUFWWMVWONWUFVWONQZUIZWUKNEPWXGGUBVWOUDZUBUJZUKZUHOZ
        VWOWUKNWUFWXKVWOQZWXFWUFVYJVWOSRZWXMWXLAVYJWUEVYLVCWUFFSVWOAWVJWUEWVNVC
        ZWWEXOZWXOWXISVWOUBGVWOSVYPWXIVWOQZVSVTWAZVCWXGWXJWUJGUHWXGWXJUFWXHUGWU
        JUBWXHVEWXGWXHWUIUFWXGWXHVWOVWOWKWUIVWOUXDWXGVWOWUHVWOWUFWXFWXFVYQXPZVW
        OWUHQZWXGWXFVYQWUFWXFULZUXEWUFWXSWXRWUFVYFVWOVXFRZWXSWXRYPAVYFWUEKVCZWU
        FFVXFVWOWWTWWEXOZEVWOUXMXGZUXFUXGUXHXQVDXQVFWXTUXIVGWUFVWONXRZUIZWWKVWO
        WUHVNOZEPOZWWLWYFWUKWYGEPWYFWUKWXKWUHVNOZWYGWYFWUKGUBWXHWUHUDXDZWXIUKZU
        HOWYIWUJWYKGUHWUJUFWYJUGWYKWUIWYJUFVWOWUHUXJUXKUBWYJVEUXLXIWYFWXHSVNUBG
        WUHSWXIWUHVYPWVDWVEWYFWVFWGWXHXARWYFVWOUXNWGWUFWXIWXHRZWXISRWYEWUFWYLUI
        WXIVWOSWYLWXPWUFWXIVWOUXOUXPWUFWXMWYLWXOVCUXQUXRWUFWUHSRWYEWUFFSWUHWXNW
        WHXOVCZWUFWYEWUHWXHRZWJWUFWYNVWONWUFWXFVYQWXFXPZWYNWUFVYQWJWXFWYOYPWUFW
        UCVYQAWUBWUDUXSZUAVWEUYCZXSVYQWXFUXTVJWUFWXSWXRWYNWYOWYDWYNWUHVWOQWXSWU
        HVWOWUGEPXTUYLWUHVWOYAYBVYQWXFYCUYAUYBUYDUYEWYMWXIWUHQVSUYFXQWYFWXKVWOW
        UHVNWUFWXLWYEWXQVCVGWHVGWUFWYHWWLQZWYEWUFWYREWYGNUCOYDYEZWUFWUHVXFRZWYS
        WUFVYFVWOTRZEVWOYDYEWJZWYTWYSUIWYBWUFWYAXUAWYCWVLVJWUFVYGWYAXUBAVYGWUEV
        YHVCZWYCEVWOYFXGVWOEWUHWUHYGZUYGWAVAWUFVYGWYGTRVYTWYRWYSYPXUCWUFWYGWUFV
        WOWUHWUFWYAVWOVIRWYCVWOVWEYHVJWUFWYTWUHVIRWUFFVXFWUHWWTWWHXOWUHVWEYHVJU
        YHUYIVYTWUFWFWGWYGNEUYJWAUYMVCWHUYKWUKNWUNEUYNUYOWUFWURWUNEPOZVWLWUFWUQ
        WUNEPWUFWUNWUFWUNWXEYIWBVGWUFWULDRZHUJZFYJZGUFXUGUGZUHOZEPOZVWLQZYQZHDU
        NZWULFYJZXUEVWLQZWUFWULVXGRZVWEWULRZVXCWULRZCWULUNZUIZXUFWUFWWSXUQWXAWU
        LVXFNVWEUOXTUYPYKWUFXURXUTWUFVWEFWUIAVWSWUEVXRVCZWUFVWEVWOQZVWEWUHQZXPZ
        VWEWUIRWUFXVCWJXVDWJXVEWJWUFWUCXVCWYPWUCVYQXVCWYQVWOVWEYAYBXSZWUFXVDXVC
        XVFXVDXVCWUFVWEVXAUMOZEPOZWUHVXAUMOZEPOZQXVDXVGXVIEPVWEWUHVXAUMXEVGWUFV
        WEXVHVWOXVJWUFVWEYLVWEUOORZEVWEVWEVNOZNUCOZYDYEZVWEXVHQZWUFVWEYLVUKXJZR
        XVKWUFVWEVQXVPWUFVYGVYMXUCVYNVJZUYQUYRYLVWEUYSVJWUFEEVWENUCOZVNOZXVMYDW
        UFETRZXVRTRZEXVSYDYEWUFVYFXVTWYBEUYTVJWUFVWETRZVYTXWAWUFFTVWEWWQXVBXOZW
        FVWENVUAVMZEXVRVUBXGWUFXVMXVSNVHOZNUCOZXVSWUFXVLXWENUCWUFXVLEVWEVNOZNVW
        EVNOZUCOZXWEWUFENVWEWUFEXUCVKZVYEWUFVLWGZWUFVWEXVQVRZVUCWUFXWGVWEUCOXWG
        EUCOZNVHOXWIXWEWUFXWGENWUFEVWEXWJXWLYMXWJXWKVUDWUFXWHVWEXWGUCWUFVWEXWLW
        BVFWUFXVSXWMNVHWUFXVSXWGENVNOZUCOXWMWUFEVWENXWJXWLXWKVUEWUFXWNEXWGUCWUF
        EXWJVUFVFWHVGWCWHVGWUFXVSSRVYEXWFXVSQWUFEXVRXWJWUFXVRXWDYIYMVLXVSNVULVM
        WHVUGWUFVYFXWBEVWEYDYEWJZXVKXVNUIXVOYPWYBXWCWUFVYGVWEVXFRXWOXUCWUFFVXFV
        WEWWTXVBXOEVWEYFXGVWEEXVHVWEXVHYGVUHWAVUIWUFVYFWYAVWOXVJQZWYBWYCVWOEWUH
        XUDYNXGZYOYRVUJXVCXVDVVAYSVWEVWOWUHENUCXTYTVUMVUNWUFXUSCWULWUFVWTWULRZU
        IVXCFWUIXWRWUFVWTFRZVXDVWTFWUIVUOWUFVXDCFWWFVUPVUQXWRWUFXWSVWTWUIRZWJZU
        IVXCWUIRZWJZVWTFWUIVVBWUFXWSXXAXXCWUFXWSUIZXXBXWTXXDVXCVWOQZVXCWUHQZXPV
        WTWUHQZWWGXPZXXBXWTXXDXXEXXGXXFWWGXXDVWTVXCVXAUMOZEPOZQZXXEXXGXXDVYFVWT
        VXFRXXKWUFVYFXWSWYBVCWUFFVXFVWTWWTVURVWTEVXCVXCYGYNXGZXXEXXJWUHVWTXXEXX
        IWUGEPVXCVWOVXAUMXEVGVUSVUTXXFWWGXXDXXJXVJQXXFXXIXVIEPVXCWUHVXAUMXEVGXX
        DVWTXXJVWOXVJXXLWUFXWPXWSXWQVCYOYRVVCVXCVWOWUHVXBEPXTYTXWTWWGXXGXPXXHVW
        TVWOWUHCVVDYTWWGXXGYCYBVVEVVFVVGVVHVUNVVIVVLVXOXVABWULVXGDVXKWULQVXLXUR
        VXNXUTVXKWULVWEUPVXMXUSCVXKWULVXKWULVXCUPUQURJUSYSAXUNWUEMVCWUFFWUIXCZX
        MXRXUOWUFXXMWUIXMWUFWWCXXMWUIQWWIWUIFVVJUTWUIXMXRWUFVWOWUHUAVVDVVKWGVVM
        XUOXXMXMFWUIVVNVVOYKXUMXUOXUPYQHWULDXUGWULQZXUHXUOXULXUPXUGWULFVVPXXNXU
        KXUEVWLXXNXUJWUNEPXXNXUIWUMGUHXUGWULUFVVQVFVGVVRVVSXFVVTWHVWBWIVWAVWCVW
        D $.
    $}

    $( Lemma for ~ wilth .  Here we round out the argument of ~ wilthlem2 with
       the final step of the induction.  The induction argument shows that
       every subset of ` 1 ... ( P - 1 ) ` that is closed under inverse and
       contains ` P - 1 ` multiplies to ` -u 1 mod P ` , and clearly
       ` 1 ... ( P - 1 ) ` itself is such a set.  Thus, the product of all the
       elements is ` -u 1 ` , and all that is left is to translate the group
       sum notation (which we used for its unordered summing capabilities) into
       an ordered sequence to match the definition of the factorial.
       (Contributed by Mario Carneiro, 24-Jan-2015.) $)
    wilthlem3 $p |- ( P e. Prime -> P || ( ( ! ` ( P - 1 ) ) + 1 ) ) $=
      ( vs wcel cid c1 cmin co cfv cmo wceq cz wi ccnfld cc vt cprime cres cgsu
      vk cfz cneg cfa caddc cdivides wbr cv c2 cexp wral cuz prmuz2 uz2m1nn syl
      cn nnuz syl6eleq eluzfz2 wa wn simpl elfzelz adantl prmnn fzm1ndvds sylan
      cmul eqid prmdiv syl3anc ralrimiva cpw ovex pwid eleq2 raleqbi1dv anbi12d
      simpld elrab2 mpbiran sylanbrc cfn fzfi eleq1 reseq2 oveq2d oveq1d eqeq1d
      imbi12d imbi2d wal bi2.04 pm2.27 com34 syl5bi alimdv df-ral syl6ibr com12
      wpss w3a simp1 simp3 simp2 wilthlem2 3exp sylcom a1i findcard3 mpd cnfld1
      wb rngidval ccrg ccmn cncrng crngmgp mp1i csubrg csubmnd zsubrg subrgsubm
      ax-mp wf wss wf1o f1oi f1of ssriv fss mp2an cvv cseq ccnv cima gsumsubmcl
      csn cdif fisuppfi 1z znegcl moddvds mpbid ccom fcoi1 fveq1i fvres seqfveq
      syl5eq ccntz cnfldbas mgpbas cnfldmul mgpplusg cmnd cnrng rngmgp cntzcmnf
      crg zsscn wf1 f1of1 crn cdm cnvimass dmresi sseqtri rnresi sseqtr4i facnn
      gsumval3 3eqtr4d nnm1nn0 faccl nncnd ax-1cn subneg sylancl eqtrd breqtrd
      cn0 ) DUBIZDEJKDKLMZUFMZUCZUDMZKUGZLMZUWHUHNZKUIMZUJUWGUWKDOMZUWLDOMZPZDU
      WMUJUKZUWGUWICIZUWRUWGUWHUWIIZBULZDUMLMUNMDOMZUWIIZBUWIUOZUWTUWGUWHKUPNZI
      UXAUWGUWHUTUXFUWGDUMUPNIUWHUTIZDUQDURUSZVAVBZKUWHVCUSUWGUXDBUWIUWGUXBUWII
      ZVDZUXDDUXBUXCVLMKLMUJUKZUXKUWGUXBQIZDUXBUJUKVEZUXDUXLVDUWGUXJVFUXJUXMUWG
      UXBKUWHVGZVHUWGDUTIZUXJUXNDVIZDUXBVJVKUXBDUXCUXCVMVNVOWCVPUWTUWIUWIVQZIUX
      AUXEVDZUWIKUWHUFVRVSUWHAULZIZUXCUXTIZBUXTUOZVDUXSAUWIUXRCUXTUWIPUYAUXAUYC
      UXEUXTUWIUWHVTUYBUXDBUXTUWIUXTUWIUXCVTWAWBGWDWEWFUWIWGIZUWGUWTUWRRZRZKUWH
      WHZUWGHULZCIZEJUYHUCZUDMZDOMZUWQPZRZRZUWGUAULZCIZEJUYPUCZUDMZDOMZUWQPZRZR
      ZUYFHUAUWIUYHUYPPZUYNVUBUWGVUDUYIUYQUYMVUAUYHUYPCWIVUDUYLUYTUWQVUDUYKUYSD
      OVUDUYJUYREUDUYHUYPJWJWKWLWMWNWOUYHUWIPZUYNUYEUWGVUEUYIUWTUYMUWRUYHUWICWI
      VUEUYLUWPUWQVUEUYKUWKDOVUEUYJUWJEUDUYHUWIJWJWKWLWMWNWOUYHUYPXEZUYORZHWPZV
      UCRUYPWGIVUHUWGVUFUYMRZHCUOZVUBUWGVUHVUJUWGVUHUYIVUIRZHWPVUJUWGVUGVUKHVUG
      UWGVUFUYNRZRZUWGVUKVUFUWGUYNWQUWGVUMVUFUYIUYMUWGVULWRWSWTXAVUIHCXBXCXDUWG
      VUJUYQVUAUWGVUJUYQXFABCDUYPEHFGUWGVUJUYQXGUWGVUJUYQXHUWGVUJUYQXIXJXKXLXMX
      NYHXOUWGUXPUWKQIUWLQIZUWRUWSXQUXQUWGUWIQUWJEWGKSKEFXPXRZSXSIEXTIUWGYASEFY
      BYCZUYDUWGUYGXMZQSYDNIQEYENIUWGYFQSEFYGYCUWIQUWJYIZUWGUWIUWIUWJYIZUWIQYJV
      URUWIUWIUWJYKZVUSUWIYLZUWIUWIUWJYMYHZBUWIQUXOYNUWIUWIQUWJYOYPZXMZUWGUWIQY
      QKUUBUUCZUWJVUQVVDUUDUUAKQIVUNUWGUUEKUUFYCUWKUWLDUUGVOUUHUWGUWMUWNUWLLMZU
      WOUWGUWKUWNUWLLUWGUWHVLUWJUWJUUIZKYRNUWHVLJKYRNZUWKUWNUWGVLUEVVGJKUWHUXIU
      EULZUWIIZVVIVVGNZVVIJNZPUWGVVJVVKVVIUWJNVVLVVIVVGUWJVUSVVGUWJPVVBUWIUWIUW
      JUUJYHUUKVVIUWIJUULUUNVHUUMUWGUWITVLUWJEUWJUWHWGVVGYSVVEYTZKEUUONZTSEFUUP
      UUQZVUOSVLEFUURUUSVVNVMZSUVDIEUUTIUWGUVASEFUVBYCVUQUWITUWJYIZUWGVURQTYJVV
      QVVCUVEUWIQTUWJYOYPXMZUWGUWITUWJEVVNVVOVVPVUPVVRUVCUXHVUTUWIUWIUWJUVFUWGV
      VAUWIUWIUWJUVGYCUWJYSVVEYTZUWJUVHZYJUWGVVSUWIVVTVVSUWJUVIUWIUWJVVEUVJUWIU
      VKUVLUWIUVMUVNXMVVMVMUVPUWGUXGUWNVVHPUXHUWHUVOUSUVQWLUWGUWNTIKTIVVFUWOPUW
      GUWNUWGUWHUWFIZUWNUTIUWGUXPVWAUXQDUVRUSUWHUVSUSUVTUWAUWNKUWBUWCUWDUWE $.
  $}

  ${
    $d n x y z N $.
    $( Wilson's theorem.  A number is prime iff it is greater or equal to ` 2 `
       and ` ( N - 1 ) ! ` is congruent to ` -u 1 ` , ` mod N ` , or
       alternatively if ` N ` divides ` ( N - 1 ) ! + 1 ` .  In this part of
       the proof we show the relatively simple reverse implication; see
       ~ wilthlem3 for the forward implication.  (Contributed by Mario
       Carneiro, 24-Jan-2015.)  (Proof shortened by Fan Zheng, 16-Jun-2016.) $)
    wilth $p |- ( N e. Prime <-> ( N e. ( ZZ>= ` 2 ) /\
      N || ( ( ! ` ( N - 1 ) ) + 1 ) ) ) $=
      ( vx vy vz vn wcel c2 cfv c1 co cdivides wbr wa cv cexp cmo wral cn nnzd
      cz cprime cuz cmin cfa caddc prmuz2 cfz crab ccnfld cmgp eqid eleq2 oveq1
      cpw weq oveq1d eleq1d cbvralv raleqbi1dv syl5bb anbi12d cbvrabv wilthlem3
      jca wn simpl elfzuz adantl clt eluz2b2 simplbi elfzuz3 dvdsfac syl2anc wi
      syl cn0 ad2antrr nnm1nn0 3syl simprbi ndvdsp1 syl3anc mpd simplr peano2zd
      faccl dvdstr mpan2d mtod ralrimiva isprm3 sylanbrc impbii ) AUAFZAGUBHZFZ
      AAIUCJZUDHZIUEJZKLZMZWOWQXAAUFBCWRDNZFZENZAGUCJZOJZAPJZXCFZEXCQZMZDIWRUGJ
      UNZUHAUIUJHZXMUKXKWRBNZFZCNZXFOJZAPJZXNFZCXNQZMDBXLDBUOZXDXOXJXTXCXNWRULX
      JXRXCFZCXCQYAXTXIYBECXCECUOZXHXRXCYCXGXQAPXEXPXFOUMUPUQURYBXSCXCXNXCXNXRU
      LUSUTVAVBVCVDXBWQXEAKLZVEZEGWRUGJZQWOWQXAVFXBYEEYFXBXEYFFZMZYDXEWTKLZYHXE
      WSKLZYIVEZYHXERFZWRXEUBHFZYJYHXEWPFZYLYGYNXBXEGWRVGVHZYNYLIXEVILZXEVJZVKV
      PZYGYMXBXEGWRVLVHXEWRVMVNYHWSTFYLYPYJYKVOYHWSYHARFZWRVQFWSRFWQYSXAYGWQYSI
      AVILAVJVKVRZAVSWRWGVTSZYRYHYNYPYOYNYLYPYQWAVPXEWSWBWCWDYHYDXAYIWQXAYGWEYH
      XETFATFWTTFYDXAMYIVOYHXEYRSYHAYTSYHWSUUAWFXEAWTWHWCWIWJWKEAWLWMWN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The Fundamental Theorem of Algebra
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n r s x A $.  $d s x z D $.  $d r E $.  $d k n K $.  $d k n r s x N $.
    $d k n r s w x y z F $.  $d s x z J $.  $d k s w x y z ph $.  $d s x y R $.
    $d k s S $.  $d k r x T $.  $d r x U $.  $d k n r s w x y z X $.
    ftalem.1 $e |- A = ( coeff ` F ) $.
    ftalem.2 $e |- N = ( deg ` F ) $.
    ftalem.3 $e |- ( ph -> F e. ( Poly ` S ) ) $.
    ftalem.4 $e |- ( ph -> N e. NN ) $.
    ${
      ftalem1.5 $e |- ( ph -> E e. RR+ ) $.
      ftalem1.6 $e |- T =
        ( sum_ k e. ( 0 ... ( N - 1 ) ) ( abs ` ( A ` k ) ) / E ) $.
      $( Lemma for ~ fta :  "growth lemma".  There exists some ` r ` such that
         ` F ` is arbitrarily close in proportion to its dominant term.
         (Contributed by Mario Carneiro, 14-Sep-2014.) $)
      ftalem1 $p |- ( ph -> E. r e. RR A. x e. CC ( r < ( abs ` x ) ->
        ( abs ` ( ( F ` x ) - ( ( A ` N ) x. ( x ^ N ) ) ) ) <
          ( E x. ( ( abs ` x ) ^ N ) ) ) ) $=
        ( c1 wbr wcel co cle cif cr cv cabs cfv clt cexp cmul cmin wi wral wrex
        cc cc0 cfz csu cdiv fzfid wa cn0 wf coef3 elfznn0 ffvelrn syl2an abscld
        cply syl fsumrecl rerpdivcld syl5eqel 1re ifcl caddc wceq adantr simprl
        sylancl coeid2 syl2anc cuz nnnn0d nn0uz sylan expcl mulcld sylan2 fveq2
        syl6eleq oveq2 fsumm1 eqtrd oveq1d fsumcl ffvelrnd expcld pncand fveq2d
        oveq12d rpred reexpcld remulcld fsumabs nnm1nn0 adantlr absmuld absge0d
        crp cn absexp max1 sylancr simprr lelttrd ltled elfzuz3 adantl leexp2ad
        a1i eqbrtrd lemul2ad fsumle fsummulc1 breqtrrd max2 syl5eqbrr ltdivmuld
        recnd mpbid wb cz nn0zd 0re 0lt1 lttrd expgt0 syl3anc ltmul1 syl112anc
        expm1t mulcomd oveq2d mulassd eqtr4d expr ralrimiva breq1 imbi1d rspcev
        ralbidv ) AQEUARZEQUBZUCSZUUMBUDZUEUFZUGRZUUOHUFZICUFZUUOIUHTZUITZUJTZU
        EUFZGUUPIUHTZUITZUGRZUKZBUNULZJUDZUUPUGRZUVFUKZBUNULZJUCUMAEUCSZQUCSZUU
        NAEUOIQUJTZUPTZFUDZCUFZUEUFZFUQZGURTZUCPAUVTGAUVPUVSFAUOUVOUSAUVQUVPSZU
        TUVRAVAUNCVBZUVQVASZUVRUNSZUWBAHDVHUFSZUWCMCDHKVCVIZUVQUVOVDZVAUNUVQCVE
        ZVFVGZVJZOVKVLZVMUULEQUCVNVSZAUVGBUNAUUOUNSZUUQUVFAUWNUUQUTZUTZUVCUVPUV
        RUUOUVQUHTZUITZFUQZUEUFZUVEUGUWPUVBUWSUEUWPUVBUWSUVAVOTZUVAUJTUWSUWPUUR
        UXAUVAUJUWPUURUOIUPTZUWRFUQZUXAUWPUWFUWNUURUXCVPAUWFUWOMVQAUWNUUQVRZCDF
        HIUUOKLVTWAUWPUWRUVAFUOIUWPIVAUOWBUFAIVASUWOAINWCVQZWDWJUVQUXBSUWPUWDUW
        RUNSZUVQIVDUWPUWDUTZUVRUWQUWPUWCUWDUWEAUWCUWOUWGVQZUWIWEZUWPUWNUWDUWQUN
        SZUXDUUOUVQWFWEZWGZWHUVQIVPUVRUUSUWQUUTUIUVQICWIUVQIUUOUHWKWTWLWMWNUWPU
        WSUVAUWPUVPUWRFUWPUOUVOUSZUWBUWPUWDUXFUWHUXLWHZWOZUWPUUSUUTUWPVAUNICUXH
        UXEWPUWPUUOIUXDUXEWQWGWRWMWSUWPUWTUVPUWRUEUFZFUQZUVEUWPUWSUXOVGUWPUVPUX
        PFUXMUWPUWBUTZUWRUXNVGZVJZUWPGUVDUWPGAGXISUWOOVQZXAZUWPUUPIUWPUUOUXDVGZ
        UXEXBXCZUWPUVPUWRFUXMUXNXDUWPUXQUVTUUPUVOUHTZUITZUVEUXTUWPUVTUYEAUVTUCS
        ZUWOUWKVQZUWPUUPUVOUYCUWPIXJSZUVOVASAUYIUWONVQZIXEVIZXBZXCUYDUWPUXQUVPU
        VSUYEUITZFUQUYFUAUWPUVPUXPUYMFUXMUXSUXRUVSUYEAUWBUVSUCSUWOUWJXFZUWPUYEU
        CSZUWBUYLVQZXCUXRUXPUVSUWQUEUFZUITZUYMUAUWBUWPUWDUXPUYRVPUWHUXGUVRUWQUX
        IUXKXGWHUXRUYQUYEUVSUXRUWQUWBUWPUWDUXJUWHUXKWHVGUYPUYNUXRUVRUWBUWPUWDUW
        EUWHUXIWHXHUXRUYQUUPUVQUHTZUYEUAUWPUWNUWDUYQUYSVPUWBUXDUWHUUOUVQXKVFUXR
        UUPUVQUVOUWPUUPUCSZUWBUYCVQUWPQUUPUARUWBUWPQUUPUVNUWPVMXTZUYCUWPQUUMUUP
        VUAAUUNUWOUWMVQZUYCAQUUMUARZUWOAUVNUVMVUCVMUWLQEXLXMVQAUWNUUQXNZXOZXPVQ
        UWBUVOUVQWBUFSUWPUVQUOUVOXQXRXSYAYBYAYCUWPUVPUVSUYEFUXMUWPUYEUYLYIZUXRU
        VSUYNYIYDYEUWPUYFGUUPUITZUYEUITZUVEUGUWPUVTVUGUGRZUYFVUHUGRZUWPUWAUUPUG
        RVUIUWPUWAEUUPUGPUWPEUUMUUPAUVMUWOUWLVQVUBUYCAEUUMUARZUWOAUVNUVMVUKVMUW
        LQEYFXMVQVUDXOYGUWPUVTUUPGUYHUYCUYAYHYJUWPUYGVUGUCSUYOUOUYEUGRZVUIVUJYK
        UYHUWPGUUPUYBUYCXCUYLUWPUYTUVOYLSUOUUPUGRVULUYCUWPUVOUYKYMUWPUOQUUPUOUC
        SUWPYNXTVUAUYCUOQUGRUWPYOXTVUEYPUUPUVOYQYRUVTVUGUYEYSYTYJUWPUVEGUUPUYEU
        ITZUITVUHUWPUVDVUMGUIUWPUVDUYEUUPUITZVUMUWPUUPUNSUYIUVDVUNVPUWPUUPUYCYI
        ZUYJUUPIUUAWAUWPUYEUUPVUFVUOUUBWMUUCUWPGUUPUYEUWPGUYBYIVUOVUFUUDUUEYEXO
        XOYAUUFUUGUVLUVHJUUMUCUVIUUMVPZUVKUVGBUNVUPUVJUUQUVFUVIUUMUUPUGUUHUUIUU
        KUUJWA $.
    $}

    ${
      ftalem2.5 $e |- U =
        if ( if ( 1 <_ s , s , 1 ) <_ T , T , if ( 1 <_ s , s , 1 ) ) $.
      ftalem2.6 $e |- T =
        ( ( abs ` ( F ` 0 ) ) / ( ( abs ` ( A ` N ) ) / 2 ) ) $.
      $( Lemma for ~ fta .  There exists some ` r ` such that ` F ` has
         magnitude greater than ` F ( 0 ) ` outside the closed ball B(0,r).
         (Contributed by Mario Carneiro, 14-Sep-2014.) $)
      ftalem2 $p |- ( ph -> E. r e. RR+ A. x e. CC
        ( r < ( abs ` x ) -> ( abs ` ( F ` 0 ) ) < ( abs ` ( F ` x ) ) ) ) $=
        ( cfv wbr co wcel vn vk cv cabs clt cexp cmul cmin c2 cdiv wi wral wrex
        cc cr cc0 crp c1 cfz csu cn0 cply wf coef3 syl nnnn0d ffvelrnd wne wceq
        nnne0d c0p dgreq0 cdgr fveq2 syl6eq syl5eq syl6bir necon3d mpd absrpcld
        dgr0 rphalfcld fveq2d cbvsumv oveq1i ftalem1 wa cle cif ffvelrn sylancl
        plyf 0cn abscld rerpdivcld syl5eqel simpr 1re ifcl syl2anc 0re a1i 0lt1
        adantr max1 sylancr syl6breqr letrd ltletrd elrpd adantl lelttr syl3anc
        max2 abscl mpand imim1d ad2antrr simprl expcld mulcld rehalfcld ltsub2d
        subcld absmuld absexpd oveq2d eqtrd oveq1d adantrr reexpcld 2ne0 div23d
        recnd 2cn breq2d lelttrd mpbid cn syld 2halvesd pncand 3bitr3d abs2difd
        caddc eqtr3d breq1d abssubd nncand 3brtr3d resubcld ltletr mpan2d rpred
        sylbid remulcld eqeltrrd simprr syl5eqbrr ltdivmuld exp1d nnuz syl6eleq
        ltled cuz leexp2ad eqbrtrrd lemul2d breqtrrd lttr expr a2d breq1 imbi1d
        ralimdva ralbidv rspcev ee12an rexlimdva ) AIUCZBUCZUDQZUERZUWAGQZHCQZU
        WAHUFSZUGSZUHSZUDQZUWEUDQZUIUJSZUWBHUFSZUGSZUERZUKZBUNULZIUOUMJUCZUWBUE
        RZUPGQZUDQZUWDUDQZUERZUKZBUNULZJUQUMZABCDUPHURUHSUSSZUAUCZCQZUDQZUAUTZU
        WKUJSUBUWKGHIKLMNAUWJAUWEAVAUNHCAGDVBQTZVAUNCVCMCDGKVDVEAHNVFZVGZAHUPVH
        UWEUPVHAHNVJAUWEUPHUPAUXKUWEUPVIZHUPVIZUKMUXKUXNGVKVIZUXOCDGHLKVLUXPHGV
        MQZUPLUXPUXQVKVMQUPGVKVMVNWAVOVPVQVEVRVSVTWBZUXJUXFUBUCZCQZUDQZUBUTUWKU
        JUXFUXIUYAUAUBUXGUXSVIUXHUXTUDUXGUXSCVNWCWDWEWFAUWPUXEIUOAUVTUOTZWGZFUQ
        TUWPFUWBUERZUXBUKZBUNULZUXEUYCFUYCFURUVTWHRZUVTURWIZEWHRZEUYHWIZUOOUYCE
        UOTZUYHUOTZUYJUOTAUYKUYBAEUWTUWKUJSZUOPAUWTUWKAUWSAUNUNGVCZUPUNTUWSUNTA
        UXKUYNMDGWLVEZWMUNUNUPGWJWKWNZUXRWOWPXDZUYCUYBURUOTZUYLAUYBWQZWRUYGUVTU
        RUOWSWKZUYIEUYHUOWSWTWPZUYCUPURFUPUOTUYCXAXBUYRUYCWRXBZVUAUPURUERUYCXCX
        BUYCURUYHFVUBUYTVUAUYCUYRUYBURUYHWHRWRUYSURUVTXEXFUYCUYHUYJFWHUYCUYLUYK
        UYHUYJWHRUYTUYQUYHEXEWTOXGZXHZXIXJUYCUWOUYEBUNUYCUWAUNTZWGZUWOUYDUWNUKU
        YEVUFUYDUWCUWNVUFUVTFWHRZUYDUWCUYCVUGVUEUYCUVTUYHFUYSUYTVUAUYCUYRUYBUVT
        UYHWHRWRUYSURUVTXNXFVUCXHXDVUFUYBFUOTZUWBUOTZVUGUYDWGUWCUKUYCUYBVUEUYSX
        DUYCVUHVUEVUAXDVUEVUIUYCUWAXOXKZUVTFUWBXLXMXPXQVUFUYDUWNUXBUYCVUEUYDUWN
        UXBUKUYCVUEUYDWGZWGZUWNUWGUDQZUIUJSZUXAUERZUXBVULUWNVUNVUMUWIUHSZUERZVU
        OVULUWIVUNUERVUMVUNUHSZVUPUERUWNVUQVULUWIVUNVUMVULUWHVULUWDUWGVULUNUNUW
        AGAUYNUYBVUKUYOXRUYCVUEUYDXSZVGZVULUWEUWFAUWEUNTUYBVUKUXMXRZVULUWAHVUSA
        HVATUYBVUKUXLXRZXTZYAZYDWNZVULVUMVULUWGVVDWNZYBZVVFYCVULVUNUWMUWIUEVULV
        UNUWJUWLUGSZUIUJSUWMVULVUMVVHUIUJVULVUMUWJUWFUDQZUGSVVHVULUWEUWFVVAVVCY
        EVULVVIUWLUWJUGVULUWAHVUSVVBYFYGYHYIVULUWJUWLUIVULUWJVULUWEVVAWNYNVULUW
        LVULUWBHUYCVUEVUIUYDVUJYJZVVBYKZYNUIUNTVULYOXBUIUPVHVULYLXBYMYHZYPVULVU
        RVUNVUPUEVULVUNVUNUUESZVUNUHSVURVUNVULVVMVUMVUNUHVULVUMVULVUMVVFYNUUAYI
        VULVUNVUNVULVUNVVGYNZVVNUUBUUFUUGUUCVULVUQVUPUXAWHRZVUOVULVUMUWGUWDUHSZ
        UDQZUHSUWGVVPUHSZUDQVUPUXAWHVULUWGVVPVVDVULUWGUWDVVDVUTYDUUDVULVVQUWIVU
        MUHVULUWGUWDVVDVUTUUHYGVULVVRUWDUDVULUWGUWDVVDVUTUUIWCUUJVULVUNUOTZVUPU
        OTUXAUOTZVUQVVOWGVUOUKVVGVULVUMUWIVVFVVEUUKVULUWDVUTWNZVUNVUPUXAUULXMUU
        MUUOVULUWTVUNUERZVUOUXBVULUWTUWMVUNUEVULUWTUWKUWBUGSZUWMAUWTUOTZUYBVUKU
        YPXRZVULUWKUWBVULUWKAUWKUQTUYBVUKUXRXRZUUNVVJUUPVULVUNUWMUOVVLVVGUUQVUL
        UYMUWBUERUWTVWCUERVULUYMEUWBUEPVULEFUWBUYCUYKVUKUYQXDUYCVUHVUKVUAXDZVVJ
        UYCEFWHRVUKUYCEUYJFWHUYCUYLUYKEUYJWHRUYTUYQUYHEXNWTOXGXDUYCVUEUYDUURZYQ
        UUSVULUWTUWBUWKVWEVVJVWFUUTYRVULUWBUWLWHRVWCUWMWHRVULUWBURUFSUWBUWLWHVU
        LUWBVULUWBVVJYNUVAVULUWBURHVVJVULURUWBUYRVULWRXBZVVJVULURFUWBVWIVWGVVJU
        YCURFWHRVUKVUDXDVWHYQUVDVULHYSURUVEQAHYSTUYBVUKNXRUVBUVCUVFUVGVULUWBUWL
        UWKVVJVVKVWFUVHYRXIVVLUVIVULVWDVVSVVTVWBVUOWGUXBUKVWEVVGVWAUWTVUNUXAUVJ
        XMXPYTUVKUVLYTUVOUXDUYFJFUQUWQFVIZUXCUYEBUNVWJUWRUYDUXBUWQFUWBUEUVMUVNU
        VPUVQUVRUVSVS $.
    $}

    ${
      ftalem3.5 $e |- D = { y e. CC | ( abs ` y ) <_ R } $.
      ftalem3.6 $e |- J = ( TopOpen ` CCfld ) $.
      ftalem3.7 $e |- ( ph -> R e. RR+ ) $.
      ftalem3.8 $e |- ( ph -> A. x e. CC
        ( R < ( abs ` x ) -> ( abs ` ( F ` 0 ) ) < ( abs ` ( F ` x ) ) ) ) $.
      $( Lemma for ~ fta .  There exists a global minimum of the function
         ` abs o. F ` .  The proof uses a circle of radius ` r ` where ` r ` is
         the value coming from ~ ftalem1 ; since this is a compact set, the
         minimum on this disk is achieved, and this must then be the global
         minimum.  (Contributed by Mario Carneiro, 14-Sep-2014.) $)
      ftalem3 $p |- ( ph -> E. z e. CC A. x e. CC
        ( abs ` ( F ` z ) ) <_ ( abs ` ( F ` x ) ) ) $=
        ( cc vs cv cfv cabs cle wbr wral wrex wss crab ssrab2 eqsstri ccom cres
        crest co cioo crn ctopon wcel cnfldtopon resttopon mp2an toponunii eqid
        ctg ccld cr ccmp cmin cxmt cc0 cxr cnxmet a1i rpxrd cnfldtopn cnmetdval
        wceq mpan cneg df-neg fveq2i absneg syl5eqr eqtrd breq1d rabbiia eqtr4i
        0cn blcld syl3anc rpred fveq2 elrab2 simprbi rgen breq2 ralbidv sylancl
        rspcev wa wb cnheibor ax-mp sylanbrc ccn ccncf plycn syl abscncf cncfco
        cply ssid ax-resscn ctop cnfldtop restid eqcomi tgioo2 cncfcn cnrest c0
        syl6eleq wne rpge0d abs0 syl6eq fvres simplr sseldi fvco3 syl2anc simpr
        ad2antrr wi abscld ffvelrnd clt cun ne0i evth2 ad2antlr wf plyf breq12d
        adantl ralbidva rexbidva mpbid ssrexv cdif adantr fveq2d breq2d ffvelrn
        mpsyl rspcv eldifad wn eldifbd baib mtbid ltnled mpbird rsp syl3c ltled
        letr mpan2d ralrimdva syld ancld ralunb undif2 mpbi eqtri raleqi bitr3i
        ssequn1 syl6ib reximdva mpd ) ADUBZIUCZUDUCZBUBZIUCZUDUCZUEUFZBFUGZDTUH
        ZUWJBTUGZDTUHFTUIZAUWKDFUHZUWLFCUBZUDUCZGUEUFZCTUJZTPUWRCTUKULZAUWDUDIU
        MZFUNZUCZUWGUXBUCZUEUFZBFUGZDFUHUWOADBUXBJFUOUPZUQURVFUCZFFUXGJTUSUCUTU
        WNUXGFUSUCUTJQVAZUWTFJTVBVCVDUXHVEAFJVGUCUTZUWGUDUCZUAUBZUEUFZBFUGZUAVH
        UHZUXGVIUTZAUDVJUMZTVKUCUTZVLTUTZGVMUTUXJUXRAVNVOUXSAWJVOZAGRVPCUXQVLGF
        JTJQVQFUWSVLUWPUXQUPZGUEUFZCTUJPUYBUWRCTUWPTUTZUYAUWQGUEUYCUYAVLUWPVJUP
        ZUDUCZUWQUXSUYCUYAUYEVSWJVLUWPUXQUXQVEVRVTUYCUYEUWPWAZUDUCUWQUYFUYDUDUW
        PWBWCUWPWDWEWFWGWHWIWKWLAGVHUTZUXKGUEUFZBFUGZUXOAGRWMZUYHBFUWGFUTZUWGTU
        TZUYHUWRUYHCUWGTFUWPUWGVSUWQUXKGUEUWPUWGUDWNWGPWOZWPWQUXNUYIUAGVHUXLGVS
        UXMUYHBFUXLGUXKUEWRWSXAWTUWNUXPUXJUXOXBXCUWTBUXGJFUAQUXGVEXDXEXFAUXAJUX
        HXGUPZUTUWNUXBUXGUXHXGUPUTAUXATVHXHUPZUYNATTVHIUDAIHXMUCUTZITTXHUPUTNHI
        XIXJUDUYOUTAXKVOXLTTUIVHTUIUYOUYNVSTXNXOTVHJJUXHQJTUOUPZJJXPUTUYQJVSJQX
        QJXPTTJUXIVDZXRXEXSJQXTYAVCYDUWTFUXAJUXHTUYRYBWTAVLFUTZFYCYEAUXSVLGUEUF
        ZUYSUXTAGRYFUWRUYTCVLTFUWPVLVSZUWQVLGUEVUAUWQVLUDUCVLUWPVLUDWNYGYHWGPWO
        XFZFVLUUAXJUUBAUXFUWKDFAUWDFUTZXBZUXEUWJBFVUDUYKXBZUXCUWFUXDUWIUEVUEUXC
        UWDUXAUCZUWFVUCUXCVUFVSAUYKUWDFUXAYIUUCVUETTIUUDZUWDTUTZVUFUWFVSAVUGVUC
        UYKAUYPVUGNHIUUEXJZYOZVUEFTUWDUWTAVUCUYKYJYKTTUWDUDIYLYMWFVUEUXDUWGUXAU
        CZUWIUYKUXDVUKVSVUDUWGFUXAYIUUGVUEVUGUYLVUKUWIVSVUJVUEFTUWGUWTVUDUYKYNY
        KTTUWGUDIYLYMWFUUFUUHUUIUUJUWKDFTUUKUUQAUWKUWMDTAVUHXBZUWKUWKUWJBTFUULZ
        UGZXBZUWMVULUWKVUNVULUWKUWFVLIUCZUDUCZUEUFZVUNVULUYSUWKVURYPAUYSVUHVUBU
        UMUWJVURBVLFUWGVLVSZUWIVUQUWFUEVUSUWHVUPUDUWGVLIWNUUNUUOUURXJVULVURUWJB
        VUMVULUWGVUMUTZXBZVURVUQUWIUEUFZUWJVVAVUQUWIVVAVUPVVAVUGUXSVUPTUTAVUGVU
        HVUTVUIYOZWJTTVLIUUPWTYQZVVAUWHVVATTUWGIVVCVVAUWGTFVULVUTYNZUUSZYRYQZVV
        AGUXKYSUFZVUQUWIYSUFZYPZBTUGZUYLVVHVVIAVVKVUHVUTSYOVVFVVAVVHUYHUUTVVAUY
        KUYHVVAUWGTFVVEUVAVVAUYLUYKUYHXCVVFUYKUYLUYHUYMUVBXJUVCVVAGUXKAUYGVUHVU
        TUYJYOVVAUWGVVFYQUVDUVEVVJBTUVFUVGUVHVVAUWFVHUTVUQVHUTUWIVHUTVURVVBXBUW
        JYPVVAUWEVVATTUWDIVVCAVUHVUTYJYRYQVVDVVGUWFVUQUWIUVIWLUVJUVKUVLUVMVUOUW
        JBFVUMYTZUGUWMUWJBFVUMUVNUWJBVVLTVVLFTYTZTFTUVOUWNVVMTVSUWTFTUVTUVPUVQU
        VRUVSUWAUWBUWC $.
    $}

    ${
      ftalem4.5 $e |- ( ph -> ( F ` 0 ) =/= 0 ) $.
      ftalem4.6 $e |- K = sup ( { n e. NN | ( A ` n ) =/= 0 } , RR , `' < ) $.
      ftalem4.7 $e |- T = ( -u ( ( F ` 0 ) / ( A ` K ) ) ^c ( 1 / K ) ) $.
      ftalem4.8 $e |- U = ( ( abs ` ( F ` 0 ) ) /
      ( sum_ k e. ( ( K + 1 ) ... N )
        ( abs ` ( ( A ` k ) x. ( T ^ k ) ) ) + 1 ) ) $.
      ftalem4.9 $e |- X = if ( 1 <_ U , 1 , U ) $.
      $( Lemma for ~ fta :  Closure of the auxiliary variables for ~ ftalem5 .
         (Contributed by Mario Carneiro, 20-Sep-2014.) $)
      ftalem4 $p |- ( ph -> ( ( K e. NN /\ ( A ` K ) =/= 0 ) /\
        ( T e. CC /\ U e. RR+ /\ X e. RR+ ) ) ) $=
        ( cn wcel cfv cc0 wne wa cc crp w3a cv crab cr clt ccnv csup c1 cuz wss
        c0 ssrab2 nnuz sseqtri nnne0d wceq c0p cply wb dgreq0 cdgr fveq2 syl6eq
        syl syl5eq syl6bir necon3d mpd neeq1d elrab sylanbrc infmssuzcl sylancr
        dgr0 ne0i syl5eqel sylib cdiv co cneg ccxp plyf 0cn ffvelrn sylancl cn0
        coef3 simpld nnnn0d ffvelrnd simprd divcld negcld nnrecred recnd cxpcld
        wf cabs caddc cfz cexp cmul csu absrpcld fzfid peano2nn0 elfzuz eluznn0
        syl2an ffvelrnda syldan mulcld abscld fsumrecl absge0d fsumge0 ge0p1rpd
        expcl sylan rpdivcld cle wbr cif 1rp ifcl 3jca jca ) AIUAUBZIBUCZUDUEZU
        FZDUGUBZEUHUBZKUHUBZUIAIGUJZBUCZUDUEZGUAUKZUBYSAIUUFULUMUNUOZUUFQAUUFUP
        UQUCZURUUFUSUEZUUGUUFUBUUFUAUUHUUEGUAUTVAVBAJUUFUBZUUIAJUAUBJBUCZUDUEZU
        UJOAJUDUEUULAJOVCAUUKUDJUDAUUKUDVDZHVEVDZJUDVDAHCVFUCUBZUUNUUMVGNBCHJML
        VHVLUUNJHVIUCZUDMUUNUUPVEVIUCUDHVEVIVJWBVKVMVNVOVPUUEUULGJUAUUCJVDUUDUU
        KUDUUCJBVJVQVRVSUUFJWCVLUUFUPVTWAWDUUEYRGIUAUUCIVDUUDYQUDUUCIBVJVQVRWEZ
        AYTUUAUUBADUDHUCZYQWFWGZWHZUPIWFWGZWIWGUGRAUUTUVAAUUSAUURYQAUGUGHXEZUDU
        GUBUURUGUBAUUOUVBNCHWJVLWKUGUGUDHWLWMZAWNUGIBAUUOWNUGBXENBCHLWOVLZAIAYP
        YRUUQWPZWQZWRAYPYRUUQWSWTXAAUVAAIUVEXBXCXDWDZAEUURXFUCZIUPXGWGZJXHWGZFU
        JZBUCZDUVKXIWGZXJWGZXFUCZFXKZUPXGWGZWFWGUHSAUVHUVQAUURUVCPXLAUVPAUVJUVO
        FAUVIJXMZAUVKUVJUBZUFZUVNUVTUVLUVMAUVSUVKWNUBZUVLUGUBAUVIWNUBZUVKUVIUQU
        CUBUWAUVSAIWNUBUWBUVFIXNVLUVKUVIJXOUVKUVIXPXQZAWNUGUVKBUVDXRXSAUVSUWAUV
        MUGUBZUWCAYTUWAUWDUVGDUVKYFYGXSXTZYAZYBAUVJUVOFUVRUWFUVTUVNUWEYCYDYEYHW
        DZAKUPEYIYJZUPEYKZUHTAUPUHUBUUAUWIUHUBYLUWGUWHUPEUHYMWAWDYNYO $.

      $( Lemma for ~ fta :  Main proof.  We have already shifted the minimum
         found in ~ ftalem3 to zero by a change of variables, and now we show
         that the minimum value is zero.  Expanding in a series about the
         minimum value, let ` K ` be the lowest term in the polynomial that is
         nonzero, and let ` T ` be a ` K ` -th root of
         ` -u F ( 0 ) / A ( K ) ` .  Then an evaluation of ` F ( T X ) ` where
         ` X ` is a sufficiently small positive number yields ` F ( 0 ) ` for
         the first term and ` -u F ( 0 ) x. X ^ K ` for the ` K ` -th term, and
         all higher terms are bounded because ` X ` is small.  Thus,
         ` abs ( F ( T X ) ) <_ abs ( F ( 0 ) ) ( 1 - X ^ K ) `
         ` < abs ( F ( 0 ) ) ` , in contradiction to our choice of ` F ( 0 ) `
         as the minimum.  (Contributed by Mario Carneiro, 14-Sep-2014.) $)
      ftalem5 $p |- ( ph -> E. x e. CC
        ( abs ` ( F ` x ) ) < ( abs ` ( F ` 0 ) ) ) $=
        ( cmul co cc wcel cfv cabs cc0 clt wbr cv wrex crp cn wne wa w3a simprd
        rpred recnd mulcld cexp c1 caddc cfz csu wf syl ffvelrnd abscld ffvelrn
        cmin simpld nnnn0d reexpcld remulcld fzfid cn0 cuz syl2an syldan adantr
        sylan expcld fsumcl cle elfznn0 expcl wceq syl2anc nnred ltp1d wss nnuz
        c0 cr nnne0d c0p wb cdgr fveq2 syl6eq syl5eq neeq1d infmssuzle syl5eqbr
        sylancr syl6eleq mpbird eqtrd fveq2d cneg oveq12d mulid1d oveq1i elfznn
        cz adantl lelttrd oveq1d mulexpd oveq2d mulassd eqtr4d cdiv ccxp negcld
        wn 3eqtrd a1i subdid 3eqtr4d 1re absmuld rpge0d absidd fsumrecl eqbrtrd
        oveq2 ltmul1dd ftalem4 simp1d simp3d cply plyf sylancl peano2nn0 elfzuz
        0cn resubcld eluznn0 coef3 readdcld abstrid coeid2 cin fzdisj crab ccnv
        cun csup ssrab2 sseqtri dgreq0 syl6bir necon3d mpd elrab sylanbrc nn0uz
        dgr0 elfz5 fzsplit fsumsplit coefv0 eqcomd exp0d sumeq1i fsumm1 syl5eqr
        nnzd 1e0p1 peano2rem elfzle2 ltm1d ltnled mpbid mpan nsyl elrab3 mul02d
        necon2bbid sumeq2dv cfn wo fzfi olci sumz ax-mp recid2d divcld nnrecred
        cxpmul2d cxp1d 3eqtr3d mulneg2d divcan2d negeqd mulneg1d addid2d fsum1p
        ax-1cn negsubd resubcl cif simp2d min1 syl31anc 3eqtrrd 3brtr4d fsumabs
        exple1 subge0 elfzelz rpexpcl absge0d leexp2rd lemul2ad fsumle breqtrrd
        fsummulc1 expp1d mulcomd nnssz ne0i infmssuzcl syl5eqel sseldi rpexpcld
        peano2re min2 syl6breq 0re fsumge0 lemuldiv2 syl112anc ltletrd ltsub2dd
        sstri ltaddsubd breq1d rspcev ) AELUBUCZUDUEZVUMIUFZUGUFZUHIUFZUGUFZUIU
        JZBUKZIUFZUGUFZVURUIUJZBUDULAELAEUDUEZFUMUEZLUMUEZAJUNUEZJCUFZUHUOZUPZV
        VDVVEVVFUQZACDEFGHIJKLMNOPQRSTUAUUAZURZUUBZALALAVVDVVEVVFVVMUUCZUSZUTZV
        AZAVUPVURVURLJVBUCZUBUCZVLUCZJVCVDUCZKVEUCZGUKZCUFZVUMVWDVBUCZUBUCZGVFZ
        UGUFZVDUCZVURAVUOAUDUDVUMIAIDUUDUFUEZUDUDIVGZODIUUEVHZVVRVIVJAVWAVWIAVU
        RVVTAVUQAVWLUHUDUEVUQUDUEVWMUUIUDUDUHIVKUUFZVJZAVURVVSVWOALJVVPAJAVVGVV
        IAVVJVVKVVLVMZVMZVNZVOZVPZUUJZAVWHAVWCVWGGAVWBKVQZAVWDVWCUEZUPZVWEVWFAV
        XCVWDVRUEZVWEUDUEZAVWBVRUEZVWDVWBVSUFUEZVXEVXCAJVRUEZVXGVWRJUUGVHZVWDVW
        BKUUHZVWDVWBUUKVTZAVRUDCVGZVXEVXFAVWKVXMOCDIMUULVHZVRUDVWDCVKZWCWAZVXDV
        UMVWDAVUNVXCVVRWBVXLWDVAZWEZVJZUUMVWOAUHJVEUCZVWGGVFZVWHVDUCZUGUFVYAUGU
        FZVWIVDUCVUPVWJWFAVYAVWHAVXTVWGGAUHJVQAVWDVXTUEZUPVWEVWFAVXMVXEVXFVYDVX
        NVWDJWGZVXOVTAVUNVXEVWFUDUEZVYDVVRVYEVUMVWDWHZVTVAZWEVXRUUNAVUOVYBUGAVU
        OUHKVEUCZVWGGVFZVYBAVWKVUNVUOVYJWIOVVRCDGIKVUMMNUUOWJAVXTVWCVWGVYIGAJVW
        BUIUJVXTVWCUUPWOWIAJAJVWQWKZWLUHJVWBKUUQVHAJVYIUEZVYIVXTVWCUUTWIAVYLJKW
        FUJZAJHUKZCUFZUHUOZHUNUURZWPUIUUSUVAZKWFRAVYQVCVSUFZWMZKVYQUEZVYRKWFUJV
        YQUNVYSVYPHUNUVBZWNUVCZAKUNUEKCUFZUHUOZWUAPAKUHUOWUEAKPWQAWUDUHKUHAWUDU
        HWIZIWRWIZKUHWIAVWKWUGWUFWSOCDIKNMUVDVHWUGKIWTUFZUHNWUGWUHWRWTUFUHIWRWT
        XAUVKXBXCUVEUVFUVGVYPWUEHKUNVYNKWIVYOWUDUHVYNKCXAXDUVHUVIZKVYQVCXEXGXFA
        JUHVSUFZUEKXQUEVYLVYMWSAJVRWUJVWRUVJXHZAKPUWAJUHKUVLWJXIJUHKUVMVHAUHKVQ
        AVWDVYIUEZUPVWEVWFAVXMVXEVXFWULVXNVWDKWGZVXOVTAVUNVXEVYFWULVVRWUMVYGVTV
        AUVNXJXKAVWAVYCVWIVDAVYCVUQVCVVSVLUCZUBUCZUGUFVURWUNUGUFZUBUCZVWAAVYAWU
        OUGAUHCUFZVUMUHVBUCZUBUCZUHVCVDUCZJVEUCZVWGGVFZVDUCVUQVUQVVSUBUCZXLZVDU
        CZVYAWUOAWUTVUQWVCWVEVDAWUTVUQVCUBUCZVUQAWURVUQWUSVCUBAVUQWURAVWKVUQWUR
        WIOCDIMUVOVHUVPAVUMVVRUVQXMAVUQVWNXNZXJAWVCVCJVCVLUCZVEUCZVWGGVFZVVHVUM
        JVBUCZUBUCZVDUCZUHWVEVDUCWVEAWVCVCJVEUCZVWGGVFWVNWVOWVBVWGGVCWVAJVEUWBX
        OUVRAVWGWVMGVCJAJUNVYSVWQWNXHAVWDWVOUEZUPVWEVWFAVXMVXEVXFWVPVXNWVPVWDVW
        DJXPVNZVXOVTAVUNVXEVYFWVPVVRWVQVYGVTVAVWDJWIVWEVVHVWFWVLUBVWDJCXAVWDJVU
        MVBYSXMUVSUVTAWVKUHWVMWVEVDAWVKWVJUHGVFZUHAWVJVWGUHGAVWDWVJUEZUPZVWGUHV
        WFUBUCUHWVTVWEUHVWFUBWVTVWEUHWIVWDVYQUEZYHWVTJVWDWFUJZWWAWVTVWDJUIUJWWB
        YHWVTVWDWVIJWVTVWDWVSVWDUNUEZAVWDWVIXPZXRZWKZWVTJWPUEZWVIWPUEAWWGWVSVYK
        WBZJUWCVHWWHWVSVWDWVIWFUJAVWDVCWVIUWDXRWVTJWWHUWEXSWVTVWDJWWFWWHUWFUWGV
        YTWWAWWBWUCVYTWWAUPJVYRVWDWFRVWDVYQVCXEXFUWHUWIWVTWWAVWEUHWVTWWCWWAVWEU
        HUOZWSWWEVYPWWIHVWDUNVYNVWDWIVYOVWEUHVYNVWDCXAXDUWJVHUWLXIXTWVTVWFAVUNV
        XEVYFWVSVVRWVSVWDWWDVNVYGVTUWKXJUWMWVJVYSWMZWVJUWNUEZUWOWVRUHWIWWKWWJVC
        WVIUWPUWQWVJGVCUWRUWSXBAWVMVVHEJVBUCZUBUCZVVSUBUCZVUQXLZVVSUBUCWVEAWVMV
        VHWWLVVSUBUCZUBUCWWNAWVLWWPVVHUBAELJVVNVVQVWRYAYBAVVHWWLVVSAVRUDJCVXNVW
        RVIZAEJVVNVWRWDAVVSVWSUTZYCYDAWWMWWOVVSUBAWWMVVHVUQVVHYEUCZXLZUBUCVVHWW
        SUBUCZXLWWOAWWLWWTVVHUBAWWLWWTVCJYEUCZYFUCZJVBUCZWWTEWXCJVBSXOAWWTWXBJU
        BUCZYFUCWWTVCYFUCWXDWWTAWXEVCWWTYFAJAJVYKUTAJVWQWQUWTYBAWWTWXBJAWWSAVUQ
        VVHVWNWWQAVVGVVIVWPURZUXAZYGZAWXBAJVWQUXBUTVWRUXCAWWTWXHUXDUXEXCYBAVVHW
        WSWWQWXGUXFAWXAVUQAVUQVVHVWNWWQWXFUXGUXHYIXTAVUQVVSVWNWWRUXIYIXMAWVEAWV
        DAVUQVVSVWNWWRVAZYGUXJYIXMAVWGWUTGUHJWUKVYHVWDUHWIVWEWURVWFWUSUBVWDUHCX
        AVWDUHVUMVBYSXMUXKAWVGWVDVLUCVUQWVDVLUCWUOWVFAWVGVUQWVDVLWVHXTAVUQVCVVS
        VWNVCUDUEAUXLYJZWWRYKAVUQWVDVWNWXIUXMYLYLXKAVUQWUNVWNAWUNAVCWPUEZVVSWPU
        EZWUNWPUEYMVWSVCVVSUXNXGZUTYNAWUQVURWUNUBUCVURVCUBUCZVVTVLUCVWAAWUPWUNV
        URUBAWUNWXMAUHWUNWFUJZVVSVCWFUJZALWPUEZUHLWFUJZLVCWFUJZVXIWXPVVPALVVOYO
        ZALVCFWFUJVCFUXOZVCWFUAAWXKFWPUEZWYAVCWFUJYMAFAVVDVVEVVFVVMUXPUSZVCFUXQ
        XGXFZVWRLJUYBUXRAWXKWXLWXOWXPWSYMVWSVCVVSUYCXGXIYPYBAVURVCVVSAVURVWOUTZ
        WXJWWRYKAWXNVURVVTVLAVURWYEXNXTYIUXSXTUXTAVWJVURUIUJVWAVURVWIVLUCUIUJAV
        WIVVTVURVXSVWTVWOAVWIVWCVWGUGUFZGVFZVVTVXSAVWCWYFGVXBVXDVWGVXQVJZYQZVWT
        AVWCVWGGVXBVXQUYAAWYGVWCVWEEVWDVBUCZUBUCZUGUFZGVFZLVWBVBUCZUBUCZVVTWYIA
        WYMWYNAVWCWYLGVXBVXDWYKVXDVWEWYJVXPAVXCVXEWYJUDUEZVXLAVVDVXEWYPVVNEVWDW
        HWCWAZVAZVJZYQZALVWBVVPVXJVOZVPVWTAWYGVWCWYLWYNUBUCZGVFWYOWFAVWCWYFXUBG
        VXBWYHVXDWYLWYNWYSAWYNWPUEVXCXUAWBZVPVXDWYFWYLLVWDVBUCZUBUCZXUBWFVXDWYF
        WYKXUDUBUCZUGUFWYLXUDUGUFZUBUCXUEVXDVWGXUFUGVXDVWGVWEWYJXUDUBUCZUBUCXUF
        VXDVWFXUHVWEUBVXDELVWDAVVDVXCVVNWBALUDUEVXCVVQWBVXLYAYBVXDVWEWYJXUDVXPW
        YQVXDXUDVXDLVWDAWXQVXCVVPWBZVXLVOZUTZYCYDXKVXDWYKXUDWYRXUKYNVXDXUGXUDWY
        LUBVXDXUDXUJVXDXUDAVVFVWDXQUEXUDUMUEVXCVVOVWDVWBKUYDLVWDUYEVTYOYPYBYIVX
        DXUDWYNWYLXUJXUCWYSVXDWYKWYRUYFZVXDLVWBVWDXUIAVXGVXCVXJWBVXCVXHAVXKXRAW
        XRVXCWXTWBAWXSVXCWYDWBUYGUYHYRUYIAVWCWYLWYNGVXBAWYNXUAUTVXDWYLWYSUTUYKU
        YJAWYOWYMLUBUCZVVSUBUCZVVTUIAWYOWYMLVVSUBUCZUBUCXUNAWYNXUOWYMUBAWYNVVSL
        UBUCXUOALJVVQVWRUYLAVVSLWWRVVQUYMXJYBAWYMLVVSAWYMWYTUTVVQWWRYCYDAXUMVUR
        VVSAWYMLWYTVVPVPZVWOALJVVOAVYQXQJVYQUNXQWUBUYNVUIAJVYRVYQRAVYTVYQWOUOZV
        YRVYQUEWUCAWUAXUQWUIVYQKUYOVHVYQVCUYPXGUYQUYRUYSAXUMWYMVCVDUCZLUBUCZVUR
        XUPAXURLAWYMWPUEXURWPUEZWYTWYMUYTVHZVVPVPVWOAWYMXURLWYTXVAVVOAWYMWYTWLZ
        YTAXUSVURWFUJZLVURXURYEUCZWFUJZALFXVDWFALWYAFWFUAAWXKWYBWYAFWFUJYMWYCVC
        FVUAXGXFTVUBAWXQVURWPUEXUTUHXURUIUJXVCXVEWSVVPVWOXVAAUHWYMXURUHWPUEAVUC
        YJWYTXVAAVWCWYLGVXBWYSXULVUDXVBXSLVURXURVUEVUFXIVUGYTYRXSXSVUHAVWAVWIVU
        RVXAVXSVWOVUJXIXSVVCVUSBVUMUDVUTVUMWIZVVBVUPVURUIXVFVVAVUOUGVUTVUMIXAXK
        VUKVULWJ $.
    $}

    ${
      ftalem6.5 $e |- ( ph -> ( F ` 0 ) =/= 0 ) $.
      $( Lemma for ~ fta :  Discharge the auxiliary variables in ~ ftalem5 .
         (Contributed by Mario Carneiro, 20-Sep-2014.) $)
      ftalem6 $p |- ( ph -> E. x e. CC
        ( abs ` ( F ` x ) ) < ( abs ` ( F ` 0 ) ) ) $=
        ( vk vr vs vn cc0 cfv cv co c1 wne cn crab clt ccnv csup cdiv cneg ccxp
        cr cabs caddc cfz cexp csu cle wbr cif weq fveq2 neeq1d cbvrabv supeq1i
        cmul eqid oveq2 oveq12d fveq2d cbvsumv oveq1i oveq2i ftalem5 ) ABCDPEQZ
        LRZCQZPUAZLUBUCZUJUDUEZUFZCQUGSUHTVSUGSUISZVMUKQZVSTULSFUMSZMRZCQZVTWCU
        NSZVDSZUKQZMUOZTULSZUGSZNOEVSFTWJUPUQTWJURZGHIJKUJVQORZCQZPUAZOUBUCVRVP
        WNLOUBLOUSVOWMPVNWLCUTVAVBVCVTVEWIWBNRZCQZVTWOUNSZVDSZUKQZNUOZTULSWAUGW
        HWTTULWBWGWSMNMNUSZWFWRUKXAWDWPWEWQVDWCWOCUTWCWOVTUNVFVGVHVIVJVKWKVEVL
        $.
    $}

    ${
      ftalem7.5 $e |- ( ph -> X e. CC ) $.
      ftalem7.6 $e |- ( ph -> ( F ` X ) =/= 0 ) $.
      $( Lemma for ~ fta .  Shift the minimum away from zero by a change of
         variables.  (Contributed by Mario Carneiro, 14-Sep-2014.) $)
      ftalem7 $p |- ( ph -> -. A. x e. CC
        ( abs ` ( F ` X ) ) <_ ( abs ` ( F ` x ) ) ) $=
        ( vz cfv cabs cc co wcel wceq vy vw cv cle wbr wrex wral caddc cmpt cc0
        wn clt ccoe cdgr eqid cidp cneg csn cxp cmin cof ccom cply simpr adantr
        wa addcld cvv cnex a1i negcld cid cres df-idp mptresid eqtr4i fconstmpt
        offval2 id subneg syl2anr mpteq2dva eqtrd plyf syl feqmptd fveq2 fmptco
        wf plyssc sseldi ccnv cima w3a plyremlem simp1d addcl adantl cmul mulcl
        c1 plyco eqeltrrd fveq2d dgrco simp2d 1nn syl6eqel nnmulcld eqeltrd 0cn
        cn oveq1 fvex fvmpt ax-mp addid2d syl5eq eqnetrd ftalem6 breq12d abscld
        ffvelrnd ltnled biimpd breq2d notbid rspcev ee12an rexlimdva mpd rexnal
        cr bitrd sylib ) AGEOZPOZBUCZEOZPOZUDUEZUKZBQUFZUUABQUGUKAUAUCZNQNUCZGU
        HRZEOZUIZOZPOZUJUUHOZPOZULUEZUAQUFUUCAUAUUHUMOZQUUHUUHUNOZUUNUOUUOUOAEU
        PQGUQZURZUSZUTVARZVBZUUHQVCOZANUAQQUUFUUDEOUUGUUSEAUUEQSZVFUUEGAUVBVDZA
        GQSZUVBLVEVGAUUSNQUUEUUPUTRZUINQUUFUIANQUUEUUPUTUPUURVHQQQVHSAVIVJUVCAU
        UPQSZUVBAGLVKZVEUPNQUUEUIZTAUPVLQVMUVHVNNQVOVPVJUURNQUUPUITANQUUPVQVJVR
        ANQUVEUUFUVBUVBUVDUVEUUFTAUVBVSLUUEGVTWAWBWCAUAQQEAEDVCOZSQQEWIZJDEWDWE
        ZWFUUDUUFEWGWHZANUBQEUUSAUVIUVAEDWJJWKZAUUSUVASZUUSUNOZXATZUUSWLUJURWMU
        UQTZAUVFUVNUVPUVQWNUVGUUPUUSUUSUOWOWEZWPZUVBUBUCZQSVFZUUEUVTUHRQSAUUEUV
        TWQWRUWAUUEUVTWSRQSAUUEUVTWTWRXBXCAUUTUNOZUUOXLAUUTUUHUNUVLXDAUWBFUVOWS
        RXLAQEUUSFUVOIUVOUOUVMUVSXEAFUVOKAUVOXAXLAUVNUVPUVQUVRXFXGXHXIXJXCAUUKY
        PUJAUUKUJGUHRZEOZYPUJQSUUKUWDTXKNUJUUGUWDQUUHUUEUJTUUFUWCEUUEUJGUHXMXDU
        UHUOZUWCEXNXOXPAUWCGEAGLXQXDXRZMXSXTAUUMUUCUAQAUUDQSZVFZUUDGUHRZQSZUUMY
        QUWIEOZPOZUDUEZUKZUUCUWGUWGUVDUWJAUWGVSLUUDGWQWAZUWHUUMUWNUWHUUMUWLYQUL
        UEUWNUWHUUJUWLUULYQULUWHUUIUWKPUWGUUIUWKTANUUDUUGUWKQUUHUUEUUDTUUFUWIEU
        UEUUDGUHXMXDUWEUWIEXNXOWRXDUWHUUKYPPAUUKYPTUWGUWFVEXDYAUWHUWLYQUWHUWKUW
        HQQUWIEAUVJUWGUVKVEUWOYCYBAYQYMSUWGAYPAQQGEUVKLYCYBVEYDYNYEUUBUWNBUWIQY
        RUWITZUUAUWMUWPYTUWLYQUDUWPYSUWKPYRUWIEWGXDYFYGYHYIYJYKUUABQYLYO $.
    $}
  $}

  ${
    $d r s x y z F $.  $d r s x y z S $.
    $( The Fundamental Theorem of Algebra.  Any polynomial with positive degree
       (i.e. non-constant) has a root.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    fta $p |- ( ( F e. ( Poly ` S ) /\ ( deg ` F ) e. NN ) ->
      E. z e. CC ( F ` z ) = 0 ) $=
      ( vx vr vy vs cfv wcel wa cv cabs cle wbr cc wral wrex cc0 clt eqid cn wi
      cply cdgr wceq crp ccoe c2 cdiv co c1 cif simpl simpr ftalem2 crab ccnfld
      ctopn simpll simplr simprl simprr breq2d fveq2d imbi12d cbvralv rexlimddv
      fveq2 sylib ftalem3 wne wn ftalem7 expr necon4ad reximdva mpd ) CBUCHIZCU
      DHZUAIZJZAKZCHZLHDKZCHZLHZMNDOPZAOQZWCRUEZAOQWAEKZFKZLHZSNZRCHLHZWKCHZLHZ
      SNZUBZFOPZWHEUFWAFCUGHZBWNVSWTHLHUHUIUJUIUJZUKGKZMNXBUKULZXAMNXAXCULZCVSG
      EWTTZVSTZVRVTUMVRVTUNXDTXATUOWAWJUFIZWSJZJZDGAWTXBLHWJMNGOUPZWJBCUQURHZVS
      XEXFVRVTXHUSVRVTXHUTXJTXKTWAXGWSVAXIWSWJWDLHZSNZWNWFSNZUBZDOPWAXGWSVBWRXO
      FDOWKWDUEZWMXMWQXNXPWLXLWJSWKWDLVHVCXPWPWFWNSXPWOWELWKWDCVHVDVCVEVFVIVJVG
      WAWGWIAOWAWBOIZJWGWCRWAXQWCRVKZWGVLWAXQXRJZJDWTBCVSWBXEXFVRVTXSUSVRVTXSUT
      WAXQXRVAWAXQXRVBVMVNVOVPVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The Basel problem (&zeta;(2) = &pi;<sup>2</sup>/6)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k m t A $.  $d j k m n t x y M $.  $d j k m n t x N $.  $d k n x P $.
    $d k m x y T $.
    basel.n $e |- N = ( ( 2 x. M ) + 1 ) $.
    $( Lemma for ~ basel .  Closure of the sequence of roots.  (Contributed by
       Mario Carneiro, 30-Jul-2014.) $)
    basellem1 $p |- ( ( M e. NN /\ K e. ( 1 ... M ) ) ->
      ( ( K x. pi ) / N ) e. ( 0 (,) ( pi / 2 ) ) ) $=
      ( cn wcel c1 co wa cpi cmul cr cc0 clt wbr c2 crp pire sylancl nnred cdiv
      cfz cioo elfznn nnrpd pipos elrpii rpmulcl 2nn nnmulcl peano2nnd syl5eqel
      caddc mpan rpdivcl syl2anr rpred rpgt0d adantl adantr syl5eqelr cle nncnd
      cc wceq 2cn mulcom elfzle2 wb nnre 2re 2pos pm3.2i lemul2 syl3anc eqbrtrd
      a1i mpbid ltp1d lelttrd syl6breqr remulcl nngt0d ltdiv2OLD syl33anc recni
      wne 2ne0 nnne0d divcan5 syl112anc breqtrd cxr w3a 0xr rehalfcl rexr mp2an
      mp2b elioo2 syl3anbrc ) BEFZAGBUBHFZIZAJKHZCUAHZLFZMXFNOZXFJPUAHZNOZXFMXI
      UCHFZXDXFXCXEQFZCQFXFQFXBXCAQFJQFXLXCAABUDZUEJRUFUGAJUHSZXBCXBCPBKHZGUMHZ
      EDXBXOPEFZXBXOEFZUIPBUJUNZUKULZUEXECUOUPZUQXDXFYAURXDXFXEAPKHZUAHZXINXDYB
      CNOZXFYCNOZXDYBXPCNXDYBXOXPXDYBXDAEFZXQYBEFXCYFXBXMUSZUIAPUJSZTZXDXOXBXRX
      CXSUTTZXDXPCLDXDCXBCEFXCXTUTZTZVAXDYBPAKHZXOVBXDAVDFZPVDFZYBYMVEXDAYGVCZV
      FAPVGSXDABVBOZYMXOVBOZXCYQXBAGBVHUSXDALFZBLFZPLFZMPNOZIZYQYRVIXDAYGTZXBYT
      XCBVJUTUUCXDUUAUUBVKVLVMVQABPVNVOVRVPXDXOYJVSVTDWAXDYBLFCLFXELFZMYBNOMCNO
      MXENOYDYEVIYIYLXDYSJLFZUUEUUDRAJWBSXDYBYHWCXDCYKWCXDXEXCXLXBXNUSURYBCXEWD
      WEVRXDJVDFZYOPMWGZIZYNAMWGYCXIVEUUGXDJRWFVQUUIXDYOUUHVFWHVMVQYPXDAYGWIJPA
      WJWKWLMWMFXIWMFZXKXGXHXJWNVIWOUUFXILFUUJRJWPXIWQWSMXIXFWTWRXA $.

    basel.p $e |- P = ( t e. CC |-> sum_ j e. ( 0 ... M )
      ( ( ( N _C ( 2 x. j ) ) x. ( -u 1 ^ ( M - j ) ) ) x. ( t ^ j ) ) ) $.
    $( Lemma for ~ basel .  Show that ` P ` is a polynomial of degree ` M ` ,
       and compute its coefficient function.  (Contributed by Mario Carneiro,
       30-Jul-2014.) $)
    basellem2 $p |- ( M e. NN -> ( P e. ( Poly ` CC ) /\ ( deg ` P ) = M /\
      ( coeff ` P ) = ( n e. NN0 |->
        ( ( N _C ( 2 x. n ) ) x. ( -u 1 ^ ( M - n ) ) ) ) ) ) $=
      ( wcel cc wceq cn0 c2 cmul co c1 cc0 cz caddc wbr cn cply cfv cdgr cv cbc
      ccoe cneg cmin cexp cmpt cfz csu wss ssid a1i nnnn0 elfznn0 oveq2 oveq12d
      wa oveq2d eqid ovex fvmpt syl adantl wf 2nn nnmulcl mpan peano2nnd nnnn0d
      syl5eqel 2z nn0z zmulcl sylancr bccl syl2an nn0cnd nnz zsubcl wne ax-1ne0
      neg1cn ax-1cn negne0i expclz mp3an12 mulcld fmptd ffvelrn eqeltrrd elplyd
      cuz cima csn cle wi wral wn cr nnre nn0re ltnle ad2antlr ad2antrr 2timesi
      clt wb oveq2i 2cn nncn adddid oveq1i nncnd addassd syl5eq 3eqtr4a zltp1le
      wo biimpa peano2re 2pos pm3.2i lemul2 syl3anc mpbid eqbrtrrd nnzd syl2anc
      2re mpbird olcd bcval4 oveq1d adantr mul02d 3eqtrd sylbird plyco0 sumeq2i
      ex necon1ad ralrimiva mpteq2i eqtr4i subidd exp0 ax-mp syl6eq nnred lep1d
      syl6breqr nn0uz syl6eleq elfz5 bccl2 mulid1d nnne0d eqnetrd dgreq coeeq
      3jca ) EUAIZBJUBUCZIBUDUCEKBUGUCDLFMDUEZNOZUFOZPUHZEUVHUIOZUJOZNOZUKZKUVF
      BAJQEULOZFMCUEZNOZUFOZUVKEUVQUIOZUJOZNOZAUEUVQUJOZNOZCUMZUKZUVGHUVFAUWBJC
      EJJUNUVFJUOUPEUQZUVFUVQUVPIZVAUVQUVOUCZUWBJUWHUWIUWBKZUVFUWHUVQLIZUWJUVQE
      URZDUVQUVNUWBLUVOUVHUVQKZUVJUVSUVMUWANUWMUVIUVRFUFUVHUVQMNUSVBUWMUVLUVTUV
      KUJUVHUVQEUIUSVBUTUVOVCZUVSUWANVDVEZVFZVGUVFLJUVOVHZUWKUWIJIUWHUVFDLUVNJU
      VOUVFUVHLIZVAZUVJUVMUWSUVJUVFFLIZUVIRIZUVJLIUWRUVFFUVFFMENOZPSOZUAGUVFUXB
      MUAIUVFUXBUAIZVIMEVJVKZVLVNZVMZUWRMRIZUVHRIZUXAVOUVHVPZMUVHVQVRUVIFVSVTWA
      UWSUVLRIZUVMJIZUVFERIZUXIUXKUWREWBZUXJEUVHWCVTUVKJIZUVKQWDZUXKUXLWFPWGWEW
      HZUVKUVLWIWJVFWKUWNWLZUWLLJUVQUVOWMVTWNWOVNZUVFAUVOJCBEUXSUWGUXRUVFUVOEPS
      OZWPUCWQQWRKZUWIQWDUVQEWSTZWTZCLXAZUVFUYCCLUVFUWKVAZUYBUWIQUYEUYBXBZEUVQX
      JTZUWIQKZUVFEXCIZUVQXCIZUYGUYFXKUWKEXDZUVQXEZEUVQXFVTUYEUYGUYHUYEUYGVAZUW
      IUWBQUWANOQUWKUWJUVFUYGUWOXGUYMUVSQUWANUYMUWTUVRRIZUVRQXJTZFUVRXJTZYBUVSQ
      KUVFUWTUWKUYGUXGXHUYMUXHUVQRIZUYNVOUWKUYQUVFUYGUVQVPZXGMUVQVQVRZUYMUYPUYO
      UYMUYPFPSOZUVRWSTZUYMMUXTNOZUYTUVRWSUYMUXBMPNOZSOUXBPPSOZSOZVUBUYTVUCVUDU
      XBSPWGXIXLUYMMEPMJIUYMXMUPUVFEJIUWKUYGEXNZXHPJIUYMWGUPZXOUYMUYTUXCPSOVUEF
      UXCPSGXPUYMUXBPPUYMUXBUVFUXDUWKUYGUXEXHXQVUGVUGXRXSXTUYMUXTUVQWSTZVUBUVRW
      STZUYEUYGVUHUVFUXMUYQUYGVUHXKUWKUXNUYREUVQYAVTYCUYMUXTXCIZUYJMXCIZQMXJTZV
      AZVUHVUIXKUYMUYIVUJUVFUYIUWKUYGUYKXHEYDVFUWKUYJUVFUYGUYLXGVUMUYMVUKVULYMY
      EYFUPUXTUVQMYGYHYIYJUYMFRIZUYNUYPVUAXKUVFVUNUWKUYGUVFFUXFYKZXHUYSFUVRYAYL
      YNYOUVRFYPYHYQUYMUWAUYEUWAJIZUYGUYEUVTRIZVUPUVFUXMUYQVUQUWKUXNUYREUVQWCVT
      UXOUXPVUQVUPWFUXQUVKUVTWIWJVFYRYSYTUUDUUAUUEUUFUVFELIZUWQUYAUYDXKUWGUXRUV
      OCEUUBYLYNZBAJUVPUWIUWCNOZCUMZUKZKUVFBUWFVVBHAJVVAUWEUVPVUTUWDCUWHUWIUWBU
      WCNUWPYQUUCUUGUUHUPZUVFEUVOUCZFUXBUFOZQUVFVVDVVEUVKEEUIOZUJOZNOZVVEPNOVVE
      UVFVURVVDVVHKUWGDEUVNVVHLUVOUVHEKZUVJVVEUVMVVGNVVIUVIUXBFUFUVHEMNUSVBVVIU
      VLVVFUVKUJUVHEEUIUSVBUTUWNVVEVVGNVDVEVFUVFVVGPVVENUVFVVGUVKQUJOZPUVFVVFQU
      VKUJUVFEVUFUUIVBUXOVVJPKWFUVKUUJUUKUULVBUVFVVEUVFVVEUVFUXBQFULOIZVVEUAIUV
      FVVKUXBFWSTZUVFUXBUXCFWSUVFUXBUVFUXBUXEUUMUUNGUUOUVFUXBQWPUCZIVUNVVKVVLXK
      UVFUXBLVVMUVFUXBUXEVMUUPUUQVUOUXBQFUURYLYNUXBFUUSVFZXQUUTYTUVFVVEVVNUVAUV
      BUVCUVFAUVOJCBEUXSUWGUXRVUSVVCUVDUVE $.

    $( Lemma for ~ basel .  Using the binomial theorem and de Moivre's formula,
       we have the identity ` _e ^ _i N x / ( sin x ) ^ n = `
       ` sum_ m e. ( 0 ... N ) ( N _C m ) ( _i ^ m ) ( cot x ) ^ ( N - m ) ` ,
       so taking imaginary parts yields ` sin ( N x ) / ( sin x ) ^ N = `
       ` sum_ j e. ( 0 ... M ) ( N _C 2 j ) ( -u 1 ) ^ ( M - j ) `
       ` ( cot x ) ^ ( -u 2 j ) = P ( ( cot x ) ^ 2 ) ` , where
       ` N = 2 M + 1 ` .  (Contributed by Mario Carneiro, 30-Jul-2014.) $)
    basellem3 $p |- ( ( M e. NN /\ A e. ( 0 (,) ( pi / 2 ) ) ) ->
      ( P ` ( ( tan ` A ) ^ -u 2 ) ) =
        ( ( sin ` ( N x. A ) ) / ( ( sin ` A ) ^ N ) ) ) $=
      ( wcel cc0 c2 co c1 cmin cexp ci cmul caddc cc wceq vm vk cn cdiv cioo wa
      cpi cfz cv cbc ctan cfv csu cim ccos csin cn0 crp tanrpcl adantl rpreccld
      rpcnd ax-icn a1i 2nn sylancr syl3anc cr recoscld recnd resincld mulcl clt
      cneg wbr gt0ne0d divdird wne syl2anc oveq2d oveq12d eqtrd oveq1d cz nnred
      3eqtr3d remulcld rpne0d 3eqtrd eqtr3d fveq2d oveq2 fzfid cle 2nn0 elfznn0
      nn0mulcl nn0red adantr wb ad2antrr 2re 2pos pm3.2i mpbid mpbird syl nncnd
      ex 2cn elfzelz zcnd ad2antrl simprr 2ne0 ovex fvmpt reexpcl syl2an mulcld
      fznn0sub sylan2 wo i2 oveq1i nn0ge0 divge0 mpanr12 nn0cnd eqeltrrd ax-1cn
      nn0re expr syl5eq nncand nn0zd sylancl mulassd 3eqtr4d rerpdivcld nnmulcl
      simpl peano2nnd syl5eqel nnnn0d elioore addcld sincosq1sgn simpld expdivd
      binom simprd tanval recdivd divcan4d nnzd demoivre elrpd rpexpcld divassd
      eqtr2d cmpt crn wf1 wf1o elfzle2 nnre lemul2 lep1d syl6breqr cuz syl6eleq
      letrd nn0uz elfz5 ssriv sseldi subcanad mulcan bitrd dom2lem f1f1orn eqid
      fznn0sub2 wf wss f1f frn sselda bccl2 rprecred expcl syldan imcld fsumf1o
      cdif eldifi wn zeo elnn0z sylanbrc expmul mp3an12 divcan2 mp3an23 syl5eqr
      eldif renegcli peano2re subge02d ltp1d lelttrd mulid1i df-2 eqtr2i oveq2i
      1re addassd nncn 3eqtr4a breqtrd peano2zd zred ltdivmul pnpcan2d peano2cn
      adddid divsubdir divcan3d zsubcld eqeltrd zleltp1 elfz mpbir2and divcan2d
      nnz 0z wfn ffn fnfvelrn orim12d mpd orcomd ord impr sylan2b reim0d fsumss
      bccl 2z znegcl ax-mp rpexpcl addid2d mul12d bccmpl expneg mulneg1 exprecd
      rpred expmulz syl22anc 3eqtr2d addsubd subdid eqtr4d expp1 expmuld syl6eq
      mulcom mulcomd 3eqtr2rd crim sumeq2dv fsumim oveq1 sumeq2sdv sumex crimd
      0re ) EUCIZBJUGKUDLZUELIZUFZJFUHLZFUAUIZUJLZMBUKULZUDLZFVWFNLZOLZPVWFOLZQ
      LZQLZUAUMZUNULZFBQLZUOULZBUPULZFOLZUDLZPVWQUPULZVWTUDLZQLZRLZUNULVWHKVNZO
      LZCULZVXCVWDVWOVXEUNVWDVWIPRLZFOLZVWOVXEVWDVWISIPSIZFUQIZVXJVWOTVWDVWIVWD
      VWHVWCVWHURIZVWABUSUTZVAVBVXKVWDVCVDZVWDFVWDFKEQLZMRLZUCGVWDVXPVWDKUCIVWA
      VXPUCIZVEVWAVWCUUBKEUUAVFZUUCUUDZUUEZVWIPUAFUUKVGVWDVXJVWRPVXBQLZRLZVWTUD
      LZVXAVYBVWTUDLZRLVXEVWDBUOULZPVWSQLZRLZVWSUDLZFOLVYHFOLZVWTUDLVXJVYDVWDVY
      HVWSFVWDVYFVYGVWDVYFVWDBVWCBVHIVWABJVWBUUFUTZVIVJZVWDVXKVWSSIVYGSIVCVWDVW
      SVWDBVYKVKZVJZPVWSVLVFZUUGVYNVWDVWSVWDJVWSVMVOZJVYFVMVOZVWCVYPVYQUFVWABUU
      HUTZUUIZVPZVYAUUJVWDVYIVXIFOVWDVYIVYFVWSUDLZVYGVWSUDLZRLVXIVWDVYFVYGVWSVY
      LVYOVYNVYTVQVWDWUAVWIWUBPRVWDVWIMVWSVYFUDLZUDLWUAVWDVWHWUCMUDVWDBSIZVYFJV
      RVWHWUCTVWDBVYKVJZVWDVYFVWDVYPVYQVYRUULVPZBUUMVSVTVWDVWSVYFVYNVYLVYTWUFUU
      NUVAVWDPVWSVXOVYNVYTUUOWAWBWCVWDVYJVYCVWTUDVWDWUDFWDIZVYJVYCTWUEVWDFVXTUU
      PZBFUUQVSWCWFVWDVWRVYBVWTVWDVWRVWDVWQVWDFBVWDFVXTWEZVYKWGZVIZVJVWDVXKVXBS
      IVYBSIVCVWDVXBVWDVWQWUJVKZVJZPVXBVLVFVWDVWTVWDVWSFVWDVWSVYMVYSUURWUHUUSZV
      BZVWDVWTWUNWHZVQVWDVYEVXDVXARVWDPVXBVWTVXOWUMWUOWUPUUTVTWIWJWKVWDVWEVWNUN
      ULZUAUMZJEUHLZFKDUIZQLZUJLZMVNZEWUTNLZOLZQLZVXGWUTOLZQLZDUMZVWPVXHVWDUBWU
      SFKUBUIZQLZNLZUVBZUVCZWUQUAUMWUSFFWVANLZUJLZVWIFWVONLZOLZPWVOOLZQLZQLZUNU
      LZDUMWURWVIVWDWVNWUQWUSWWBUADWVMWVOVWFWVOTZVWNWWAUNWWCVWGWVPVWMWVTQVWFWVO
      FUJWLWWCVWKWVRVWLWVSQWWCVWJWVQVWIOVWFWVOFNWLVTVWFWVOPOWLWAWAWKVWDJEWMVWDW
      USVWEWVMUVDZWUSWVNWVMUVEVWDUBUAWUSVWEWVLFKVWFQLZNLZVWDWVJWUSIZWVLVWEIZVWD
      WWGUFZWVKVWEIZWWHWWIWWJWVKFWNVOZWWIWVKVXPFWWIWVKWWIKUQIZWVJUQIZWVKUQIWOWW
      GWWMVWDWVJEWPUTZKWVJWQVFZWRVWDVXPVHIWWGVWDVXPVXSWEWSZVWDFVHIZWWGWUIWSWWIW
      VJEWNVOZWVKVXPWNVOZWWGWWRVWDWVJJEUVFUTWWIWVJVHIEVHIZKVHIZJKVMVOZUFZWWRWWS
      WTWWIWVJWWNWRVWAWWTVWCWWGEUVGXAWXCWWIWXAWXBXBXCXDZVDWVJEKUVHVGXEWWIVXPVXQ
      FWNWWIVXPWWPUVIGUVJUVMWWIWVKJUVKULZIWUGWWJWWKWTWWIWVKUQWXEWWOUVNUVLVWDWUG
      WWGWUHWSWVKJFUVOVSXFWVKFUWDXGXIVWDWWGVWFWUSIZUFZWVLWWFTZWVJVWFTZWTVWDWXGU
      FZWXHWVKWWETZWXIWXJFWVKWWEVWDFSIZWXGVWDFVXTXHZWSWXJKSIZWVJSIZWVKSIXJWWGWX
      OVWDWXFWWGWVJWVJJEXKXLZXMZKWVJVLVFWXJWXNVWFSIZWWESIXJWXJWUSSVWFUBWUSSWXPU
      VPVWDWWGWXFXNUVQZKVWFVLVFUVRWXJWXOWXRWXNKJVRZUFZWXKWXIWTWXQWXSWYAWXJWXNWX
      TXJXOXDZVDWVJVWFKUVSVGUVTXIUWAZWUSVWEWVMUWBXGWUTWUSIZWUTWVMULWVOTVWDUBWUT
      WVLWVOWUSWVMWVJWUTTWVKWVAFNWVJWUTKQWLVTWVMUWCZFWVANXPXQUTVWDVWFWVNIZUFZWU
      QWYGVWNVWDWYFVWFVWEIZVWNSIVWDWVNVWEVWFVWDWUSVWEWVMUWEZWVNVWEUWFVWDWWDWYIW
      YCWUSVWEWVMUWGXGZWUSVWEWVMUWHXGZUWIVWDWYHUFZVWGVWMWYLVWGWYHVWGUCIVWDVWFFU
      WJUTZXHWYLVWKVWLWYLVWKVWDVWIVHIVWJUQIZVWKVHIZWYHVWDVWHVXNUWKVWFJFYAZVWIVW
      JXRXSZVJWYLVXKVWFUQIZVWLSIVCWYHWYRVWDVWFFWPZUTPVWFUWLVFXTXTZUWMUWNVJZUWOV
      WDWVNVWEWUQUAWYKXUAVWDVWFVWEWVNUWPIZUFZVWNXUCVWGVWMXUBVWDWYHVWGVHIVWFVWEW
      VNUWQZWYLVWGWYMWEYBXUCVWKVWLXUBVWDWYHWYOXUDWYQYBXUBVWDWYHWYFUWRZUFVWLVHIZ
      VWFVWEWVNUXGVWDWYHXUEXUFWYLWYFXUFWYLXUFWYFWYLVWFKUDLZWDIZVWFMRLZKUDLZWDIZ
      YCZXUFWYFYCWYLVWFWDIZXULWYHXUMVWDVWFJFXKUTVWFUWSXGWYLXUHXUFXUKWYFVWDWYHXU
      HXUFVWDWYHXUHUFUFZWVCXUGOLZVWLVHXUNXUOPKOLZXUGOLZVWLXUPWVCXUGOYDYEXUNPKXU
      GQLZOLZXUQVWLXUNXUGUQIZXUSXUQTZXUNXUHJXUGWNVOZXUTVWDWYHXUHXNXUNWYRXVBWYHW
      YRVWDXUHWYSXMZWYRVWFVHIZJVWFWNVOZXVBVWFYLVWFYFZXVDXVEUFWXAWXBXVBXBXCVWFKY
      GYHVSXGXUGUWTUXAZVXKWWLXUTXVAVCWOPKXUGUXBUXCXGXUNXURVWFPOXUNWXRXURVWFTZXU
      NVWFXVCYIWXRWXNWXTXVHXJXOVWFKUXDUXEXGVTWJUXFXUNWVCVHIZXUTXUOVHIMUXQUXHZXV
      GWVCXUGXRVFYJYMVWDWYHXUKWYFVWDWYHXUKUFZUFZVWJKUDLZWVMULZVWFWVNXVLXVNFKXVM
      QLZNLZFVWJNLVWFXVLXVMWUSIZXVNXVPTXVLXVQJXVMWNVOZXVMEWNVOZXVLWYNXVRWYHWYNV
      WDXUKWYPXMZWYNVWJVHIZJVWJWNVOZXVRVWJYLVWJYFXWAXWBUFWXAWXBXVRXBXCVWJKYGYHV
      SXGXVLXVSXVMEMRLZVMVOZXVLXWDVWJKXWCQLZVMVOZXVLVWJFMRLZXWEVMXVLVWJFXWGXVLV
      WJXVTWRZVWDWWQXVKWUIWSZXVLWWQXWGVHIXWIFUXIXGXVLXVEVWJFWNVOXVLWYRXVEWYHWYR
      VWDXUKWYSXMZXVFXGXVLFVWFXWIXVLVWFXWJWRUXJXEXVLFXWIUXKUXLXVLVXPMMRLZRLZVXP
      KMQLZRLXWGXWEXWKXWMVXPRXWMKXWKKXJUXMUXNUXOUXPXVLXWGVXQMRLXWLFVXQMRGYEXVLV
      XPMMVWDVXPSIXVKVWDVXPVXSXHWSMSIZXVLYKVDZXWOUXRYNXVLKEMWXNXVLXJVDZVWAESIZV
      WCXVKEUXSZXAXWOUYGUXTZUYAXVLXWAXWCVHIWXCXWDXWFWTXWHXVLXWCXVLEVWAEWDIZVWCX
      VKEUYPXAZUYBZUYCWXCXVLWXDVDVWJXWCKUYDVGXFXVLXVMWDIZXWTXVSXWDWTXVLXVMXWCXU
      JNLZWDXVLXVMXWEXUINLZKUDLZXWEKUDLZXUJNLZXXDXVLVWJXXEKUDXVLXWGXUINLVWJXXEX
      VLFVWFMVWDWXLXVKWXMWSZXVLVWFXWJYIZXWOUYEXVLXWGXWEXUINXWSWCWJWCXVLXWESIZXU
      ISIZWYAXXFXXHTXVLWXNXWCSIXXKXJXVLXWCXXBXLZKXWCVLVFXVLWXRXXLXXJVWFUYFXGWYA
      XVLWYBVDXWEXUIKUYHVGXVLXXGXWCXUJNXVLXWCKXXMXWPWXTXVLXOVDZUYIWCWIXVLXWCXUJ
      XXBVWDWYHXUKXNUYJUYKZXXAXVMEUYLVSXFXVLXXCJWDIZXWTXVQXVRXVSUFWTXXOXXPXVLUY
      QVDXXAXVMJEUYMVGUYNZUBXVMWVLXVPWUSWVMWVJXVMTWVKXVOFNWVJXVMKQWLVTWYEFXVONX
      PXQXGXVLXVOVWJFNXVLVWJKXVLVWJXVTYIXWPXXNUYOVTXVLFVWFXXIXXJYOWIXVLWVMWUSUY
      RZXVQXVNWVNIVWDXXRXVKVWDWYIXXRWYJWUSVWEWVMUYSXGWSXXQWUSXVMWVMUYTVSYJYMVUA
      VUBVUCVUDVUEVUFWGWGVUGVWDJFWMZVUHVWDWUSWWBWVHDVWDWYDUFZJPWVHQLZRLZUNULZWW
      BWVHXXTXYBWWAUNXXTXYBXYAWVBPWVEWVGQLZQLZQLZWWAXXTXYAXXTVXKWVHSIXYASIVCXXT
      WVHXXTWVFWVGXXTWVBWVEXXTWVBXXTVXLWVAWDIZWVBUQIVWDVXLWYDVYAWSZXXTWVAXXTWWL
      WUTUQIZWVAUQIZWOWYDXYIVWDWUTEWPZUTZKWUTWQVFZYPZWVAFVUIVSZWRXXTXVIWVDUQIZW
      VEVHIXVJWYDXYPVWDWUTJEYAUTZWVCWVDXRVFZWGVWDVXGVHIXYIWVGVHIWYDVWDVXGVWDVXM
      VXFWDIZVXGURIVXNKWDIXYSVUJKVUKVULZVWHVXFVUMYQZVUTXYKVXGWUTXRXSZWGZVJPWVHV
      LVFVUNXXTXYAPWVBXYDQLZQLXYFXXTWVHYUDPQXXTWVBWVEWVGXXTWVBXYOYIZXXTWVEXYRVJ
      ZXXTWVGYUBVJZYRVTXXTPWVBXYDVXKXXTVCVDZYUEXXTWVEWVGYUFYUGXTVUOWBXXTWVBWVPX
      YEWVTQXXTVXLXYGWVBWVPTXYHXYNWVAFVUPVSXXTWVTWVGPWVEQLZQLYUIWVGQLXYEXXTWVRW
      VGWVSYUIQXXTWVRVWIWVAOLZVWHVXFWUTQLZOLZWVGXXTWVQWVAVWIOXXTFWVAVWDWXLWYDWX
      MWSXXTWVAXYMYIZYOVTXXTVWHWVAVNZOLZMVWHWVAOLUDLZYULYUJXXTVWHSIZXYJYUOYUPTX
      XTVWHVWDVXMWYDVXNWSZVBZXYMVWHWVAVUQVSXXTYUKYUNVWHOXXTWXNWUTSIYUKYUNTXJXXT
      WUTXYLYIZKWUTVURVFVTXXTVWHWVAYUSXXTVWHYURWHZXYNVUSYSXXTYUQVWHJVRXYSWUTWDI
      YULWVGTYUSYVAXYSXXTXYTVDXXTWUTXYLYPVWHVXFWUTVVAVVBVVCXXTWVSWVEPQLZYUIXXTW
      VSPKWVDQLZMRLZOLZPYVCOLZPQLZYVBXXTWVOYVDPOXXTWVOVXQWVANLZYVDFVXQWVANGYEXX
      TYVHVXPWVANLZMRLYVDXXTVXPMWVAXXTVXPVWDVXRWYDVXSWSXHXWNXXTYKVDYUMVVDXXTYVC
      YVIMRXXTKEWUTWXNXXTXJVDVWAXWQVWCWYDXWRXAYUTVVEWCVVFYNVTXXTVXKYVCUQIZYVEYV
      GTVCXXTWWLXYPYVJWOXYQKWVDWQVFPYVCVVGVFXXTYVFWVEPQXXTYVFXUPWVDOLWVEXXTPKWV
      DYUHXYQWWLXXTWOVDVVHXUPWVCWVDOYDYEVVIWCWIXXTWVESIZVXKYVBYUITYUFVCWVEPVVJY
      QWBWAXXTYUIWVGXXTVXKYVKYUISIVCYUFPWVEVLVFYUGVVKXXTPWVEWVGYUHYUFYUGYRVVLWA
      WIWKXXTJVHIWVHVHIXYCWVHTVVTYUCJWVHVVMVFWJVVNWFVWDVWEVWNUAXXSWYTVVOVWDVXGS
      IVXHWVITVWDVXGYUAVBAVXGWUSWVFAUIZWUTOLZQLZDUMWVISCYVLVXGTZWUSYVNWVHDYVOYV
      MWVGWVFQYVLVXGWUTOVVPVTVVQHWUSWVHDVVRXQXGYSVWDVXAVXCVWDVWRVWTWUKWUNYTVWDV
      XBVWTWULWUNYTVVSWF $.

    basel.t $e |- T = ( n e. ( 1 ... M ) |->
      ( ( tan ` ( ( n x. pi ) / N ) ) ^ -u 2 ) ) $.
    $( Lemma for ~ basel .  By ~ basellem3 , the expression
       ` P ( ( cot x ) ^ 2 ) = sin ( N x ) / ( sin x ) ^ N ` goes to zero
       whenever ` x = n pi / N ` for some ` n e. ( 1 ... M ) ` , so this
       function enumerates ` M ` distinct roots of a degree- ` M ` polynomial,
       which must therefore be all the roots by ~ fta1 .  (Contributed by Mario
       Carneiro, 28-Jul-2014.) $)
    basellem4 $p |- ( M e. NN ->
      T : ( 1 ... M ) -1-1-onto-> ( `' P " { 0 } ) ) $=
      ( wcel co cc0 cfv wceq cpi c2 wa cr wbr vx vy vk vm cfz ccnv csn cima wf1
      cn c1 wf1o wf cv weq wi wral cmul cdiv ctan cneg cexp cc crp cz basellem1
      cioo tanrpcl syl znegcl ax-mp rpexpcl sylancl rpcnd csin basellem3 syldan
      2z elfzelz adantl zred pire remulcl recnd caddc 2nn nnmulcl mpan syl5eqel
      adantr nncnd nnne0d divcan2d fveq2d sinkpi eqtrd oveq1d nndivred resincld
      peano2nnd nnnn0d expcld clt ccos sincosq1sgn simpld gt0ne0d expne0d div0d
      nnzd 3eqtrd wfn wb cply cn0 fmptd fveq2 sseli ad2antrl ad2antll a1i pipos
      cdgr syl112anc mpbid cle halfpire sseldi syl2anc rprege0 oveq1 ovex fvmpt
      2nn0 expneg cfn cdom chash c0p wne ccoe cbc cmin cmpt basellem2 plyf 3syl
      simp1d ffn fniniseg mpbir2and ssriv rpred ffvelrnda simplr ad2antrr nnred
      ltmul1 nngt0d ltdiv1 cxr wss renegcli rexri elrpii rphalfcl rpge0 le0neg2
      mp2b mpbi iooss1 mp2an ad2ant2rl tanord lt2sq syl2an ltrecd 3brtr4d an32s
      ad2ant2r ex eqord2 biimprd ralrimivva dff13 sylanbrc simp2d nnne0 eqnetrd
      cen dgr0 syl6eq necon3i eqid fta1 f1domg sylc simprd nnnn0 hashfz1 eqtr4d
      breqtrd fzfid hashdom sbth f1finf1o ) FUJKZUKFUELZBUFMUGUHZCUIZUXHUXICULZ
      UXGUXHUXICUMUAUNZCNZUBUNZCNZOZUAUBUOZUPZUBUXHUQUAUXHUQUXJUXGEUXHEUNZPURLZ
      GUSLZUTNZQVAZVBLZUXICUXGUXSUXHKZRZUYDUXIKZUYDVCKZUYDBNZMOZUYFUYDUYFUYBVDK
      ZUYCVEKZUYDVDKUYFUYAMPQUSLZVGLZKZUYKUXSFGHVFZUYAVHVIQVEKZUYLVRQVJVKUYBUYC
      VLVMZVNUYFUYIGUYAURLZVONZUYAVONZGVBLZUSLZMVUBUSLMUXGUYEUYOUYIVUCOUYPAUYAB
      DFGHIVPVQUYFUYTMVUBUSUYFUYTUXTVONZMUYFUYSUXTVOUYFUXTGUYFUXTUYFUXSSKPSKZUX
      TSKUYFUXSUYEUXSVEKZUXGUXSUKFVSZVTZWAWBUXSPWCVMZWDUYFGUXGGUJKZUYEUXGGQFURL
      ZUKWELUJHUXGVUKQUJKUXGVUKUJKWFQFWGWHWTWIZWJZWKUYFGVUMWLWMWNUYFVUFVUDMOVUH
      UXSWOVIWPWQUYFVUBUYFVUAGUYFVUAUYFUYAUYFUXTGVUIVUMWRWSWDZUYFGVUMXAXBUYFVUA
      GVUNUYFVUAUYFMVUAXCTZMUYAXDNXCTZUYFUYOVUOVUPRUYPUYAXEVIXFXGUYFGVUMXJXHXIX
      KUYFBVCXLZUYGUYHUYJRXMUXGVUQUYEUXGBVCXNNKZVCVCBUMVUQUXGVURBYCNZFOZBUUANEX
      OGQUXSURLUUBLUKVAFUXSUUCLVBLURLUUDOZABDEFGHIUUEZUUHZVCBUUFVCVCBUUIUUGWJVC
      MUYDBUUJVIUUKJXPUXGUXRUAUBUXHUXHUXGUXLUXHKUXNUXHKRRUXQUXPUXGUCUDUCUNZCNZU
      DUNZCNZUXLUXNUXHUXMUXOVVDVVFCXQVVDUXLCXQVVDUXNCXQEUXHSUYEUXSVUGWAUULZUXGU
      XHSVVDCUXGEUXHUYDSCUYFUYDUYRUUMJXPUUNUXGVVDUXHKZVVFUXHKZRZRVVDVVFXCTZVVGV
      VEXCTZUXGVVLVVKVVMUXGVVLRZVVKRZUKVVFPURLZGUSLZUTNZQVBLZUSLZUKVVDPURLZGUSL
      ZUTNZQVBLZUSLZVVGVVEXCVVOVWDVVSXCTZVVTVWEXCTVVOVWCVVRXCTZVWFVVOVWBVVQXCTZ
      VWGVVOVWAVVPXCTZVWHVVOVVLVWIUXGVVLVVKUUOVVOVVDSKZVVFSKZVUEMPXCTZVVLVWIXMV
      VIVWJVVNVVJUXHSVVDVVHXRXSZVVJVWKVVNVVIUXHSVVFVVHXRXTZVUEVVOWBYAVWLVVOYBYA
      VVDVVFPUURYDYEVVOVWASKZVVPSKZGSKMGXCTVWIVWHXMVVOVWJVUEVWOVWMWBVVDPWCVMVVO
      VWKVUEVWPVWNWBVVFPWCVMVVOGUXGVUJVVLVVKVULUUPZUUQVVOGVWQUUSVWAVVPGUUTYDYEV
      VOVWBUYMVAZUYMVGLZKVVQVWSKVWHVWGXMVVOUYNVWSVWBVWRUVAKVWRMYFTZUYNVWSUVBVWR
      UYMYGUVCUVDMUYMYFTZVWTPVDKUYMVDKVXAPWBYBUVEPUVFUYMUVGUVIUYMSKVXAVWTXMYGUY
      MUVHVKUVJVWRMUYMUVKUVLZUXGVVIVWBUYNKZVVLVVJVVDFGHVFUVTZYHVVOUYNVWSVVQVXBU
      XGVVJVVQUYNKZVVLVVIVVFFGHVFUVMZYHVWBVVQUVNYIYEVVOVWCVDKZVVRVDKZVWGVWFXMZV
      VOVXCVXGVXDVWBVHVIZVVOVXEVXHVXFVVQVHVIZVXGVWCSKMVWCYFTRVVRSKMVVRYFTRVXIVX
      HVWCYJVVRYJVWCVVRUVOUVPYIYEVVOVWDVVSVVOVXGUYQVWDVDKVXJVRVWCQVLVMVVOVXHUYQ
      VVSVDKVXKVRVVRQVLVMUVQYEVVOVVGVVRUYCVBLZVVTVVJVVGVXLOVVNVVIEVVFUYDVXLUXHC
      EUDUOZUYBVVRUYCVBVXMUYAVVQUTVXMUXTVVPGUSUXSVVFPURYKWQWNWQJVVRUYCVBYLYMXTV
      VOVVRVCKQXOKZVXLVVTOVVOVVRVXKVNYNVVRQYOVMWPVVOVVEVWCUYCVBLZVWEVVIVVEVXOOV
      VNVVJEVVDUYDVXOUXHCEUCUOZUYBVWCUYCVBVXPUYAVWBUTVXPUXTVWAGUSUXSVVDPURYKWQW
      NWQJVWCUYCVBYLYMXSVVOVWCVCKVXNVXOVWEOVVOVWCVXJVNYNVWCQYOVMWPUVRUVSUWAUWBU
      WCUWDUAUBUXHUXICUWEUWFZUXGUXHUXIUWJTZUXIYPKZUXJUXKXMUXGUXHUXIYQTZUXIUXHYQ
      TZVXRUXGVXSUXJVXTUXGVXSUXIYRNZVUSYFTZUXGVURBYSYTZVXSVYCRVVCUXGVUSMYTVYDUX
      GVUSFMUXGVURVUTVVAVVBUWGZFUWHUWIBYSVUSMBYSOVUSYSYCNMBYSYCXQUWKUWLUWMVIUXI
      VCBUXIUWNUWOYIZXFZVXQUXHUXIYPCUWPUWQUXGVYBUXHYRNZYFTZVYAUXGVYBVUSVYHYFUXG
      VXSVYCVYFUWRUXGVUSFVYHVYEUXGFXOKVYHFOFUWSFUWTVIUXAUXBUXGVXSUXHYPKVYIVYAXM
      VYGUXGUKFUXCUXIUXHYPUXDYIYEUXHUXIUXEYIVYGUXHUXICUXFYIYE $.

    $( Lemma for ~ basel .  Using ~ vieta1 , we can calculate the sum of the
       roots of ` P ` as the quotient of the top two coefficients, and since
       the function ` T ` enumerates the roots, we are left with an equation
       that sums the ` cot ^ 2 ` function at the ` M ` different roots.
       (Contributed by Mario Carneiro, 29-Jul-2014.) $)
    basellem5 $p |- ( M e. NN -> sum_ k e. ( 1 ... M )
      ( ( tan ` ( ( k x. pi ) / N ) ) ^ -u 2 ) =
      ( ( ( 2 x. M ) x. ( ( 2 x. M ) - 1 ) ) / 6 ) ) $=
      ( wcel c1 cmin co cdiv cmul c2 cc wceq vx cn ccnv cc0 csn cima cv csu cfv
      cdgr ccoe cneg cfz cpi ctan cexp eqid cply cn0 cbc basellem2 simp1d chash
      c6 cmpt simp2d nnnn0 hashfz1 syl cen wbr wf1o basellem4 ovex f1oen cfn wb
      fzfid cle c0p wne wa nnne0 eqnetrd fveq2 dgr0 syl6eq necon3i fta1 syl2anc
      simpld hashen mpbird 3eqtr2rd id eqeltrd vieta1 oveq1 oveq1d fveq2d fvmpt
      adantl cdm cnvimass plyf fdm fveq12d nnm1nn0 oveq2 oveq2d oveq12d sylancl
      wf ax-1cn neg1cn ax-mp caddc 2nn sylancr 3eqtrd nn0uz nnred nnuz syl6eleq
      cz cuz elfz5 bccl2 nncnd eqtrd nnne0d c3 bcm1k a1i nncni cr nndivre recnd
      6nn 3eqtr3d 3syl syl5sseq sselda fsumf1o simp3d nncn nncan exp1 peano2nnd
      nnmulcl mpan syl5eqel nnnn0d 2z peano2zm zmulcl bccl nn0cnd mulcom mulm1d
      nnz negcld subidd exp0 wss 1nn0 eleqtri fzss1 lep1d syl6breqr nnzd sseldi
      mulid1d divnegd negeqd negnegd pnncand df-2 3eqtr4g 2nn0 syl6eqel 2timesd
      oveq1i nn0sub addsubd nn0nnaddcl mpancom 2timesi subsub4d 3eqtr4a subsubd
      eqcomi oveq2i subdid syl6eqr 3re 2re mulassd 3cn divmuldivd 3t2e6 mulcomd
      df-3 6re nnmulcld eqeltrrd nn0red clt ltm1d eqbrtrrd ltled letrd divcan3d
      recdivd nnne0i recdiv mpanl12 ) GUBLZBUCUDUEZUFZUAUGZUAUHBUJUIZMNOZBUKUIZ
      UIZUYBUYDUIZPOULZMGUMOZEUGZUNQOZHPOZUOUIZRULZUPOZEUHRGQOZUYOMNOZQOZVDPOZU
      XRUAUYDUXTSBUYBUYDUQUYBUQUXTUQZUXRBSURUILZUYBGTZUYDFUSHRFUGZQOZUTOZMULZGV
      UBNOZUPOZQOZVEZTZABDFGHIJVAZVBZUXRUYBGUYHVCUIZUXTVCUIZUXRUYTVUAVUJVUKVFZU
      XRGUSLZVUMGTGVGZGVHVIUXRVUMVUNTZUYHUXTVJVKZUXRUYHUXTCVLVUSABCDFGHIJKVMZUY
      HUXTCMGUMVNVOVIUXRUYHVPLUXTVPLZVURVUSVQUXRMGVRZUXRVVAVUNUYBVSVKZUXRUYTBVT
      WAZVVAVVCWBVULUXRUYBUDWAVVDUXRUYBGUDVUOGWCWDBVTUYBUDBVTTUYBVTUJUIUDBVTUJW
      EWFWGWHVIUXTSBUYSWIWJWKUYHUXTWLWJWMWNUXRUYBGUBVUOUXRWOWPWQUXRUXTUYAUYHUYN
      UAECUYNUYAUYNTWOVVBVUTUYIUYHLUYICUIUYNTUXRFUYIVUBUNQOZHPOZUOUIZUYMUPOUYNU
      YHCVUBUYITZVVGUYLUYMUPVVHVVFUYKUOVVHVVEUYJHPVUBUYIUNQWRWSWTWSKUYLUYMUPVNX
      AXBUXRUXTSUYAUXRBXCZUXTSBUXSXDUXRUYTSSBXMVVISTVULSBXESSBXFUUAUUBUUCUUDUXR
      UYGUYEULZUYFPOHRGMNOZQOZUTOZHUYOUTOZPOZUYRUXRUYEUYFUXRUYEVVMULZSUXRUYEVVK
      VUIUIZVVMVUEGVVKNOZUPOZQOZVVPUXRUYCVVKUYDVUIUXRUYTVUAVUJVUKUUEZUXRUYBGMNV
      UOWSXGUXRVVKUSLZVVQVVTTGXHZFVVKVUHVVTUSVUIVUBVVKTZVUDVVMVUGVVSQVWDVUCVVLH
      UTVUBVVKRQXIXJVWDVUFVVRVUEUPVUBVVKGNXIXJXKVUIUQZVVMVVSQVNXAVIUXRVVTVVMVUE
      QOZVUEVVMQOZVVPUXRVVSVUEVVMQUXRVVSVUEMUPOZVUEUXRVVRMVUEUPUXRGSLMSLZVVRMTG
      UUFZXNGMUUGXLXJVUESLZVWHVUETXOVUEUUHXPWGXJUXRVVMSLVWKVWFVWGTUXRVVMUXRHUSL
      ZVVLYELZVVMUSLUXRHUXRHUYOMXQOZUBIUXRUYORUBLUXRUYOUBLZXRRGUUJUUKZUUIUULZUU
      MZUXRRYELVVKYELZVWMUUNUXRGYELVWSGUVAGUUOVIRVVKUUPXSVVLHUUQWJUURZXOVVMVUEU
      USXLUXRVVMVWTUUTXTXTZUXRVVMVWTUVBWPUXRUYFVVNSUXRUYFGVUIUIZVVNVUEGGNOZUPOZ
      QOZVVNUXRUYBGUYDVUIVWAVUOXGUXRVUPVXBVXETVUQFGVUHVXEUSVUIVUBGTZVUDVVNVUGVX
      DQVXFVUCUYOHUTVUBGRQXIXJVXFVUFVXCVUEUPVUBGGNXIXJXKVWEVVNVXDQVNXAVIUXRVXEV
      VNMQOVVNUXRVXDMVVNQUXRVXDVUEUDUPOZMUXRVXCUDVUEUPUXRGVWJUVCXJVWKVXGMTXOVUE
      UVDXPWGXJUXRVVNUXRVVNUXRUYOUDHUMOZLVVNUBLUXRMHUMOZVXHUYOMUDYFUIZLVXIVXHUV
      EMUSVXJUVFYAUVGMUDHUVHXPUXRUYOVXILZUYOHVSVKZUXRUYOVWNHVSUXRUYOUXRUYOVWPYB
      UVIIUVJUXRUYOMYFUIZLHYELZVXKVXLVQUXRUYOUBVXMVWPYCYDUXRHVWQUVKZUYOMHYGWJWM
      ZUVLUYOHYHVIZYIZUVMYJXTZVXRWPUXRUYFVVNUDVXSUXRVVNVXQYKZWDUVNUXRVVJVVMUYFV
      VNPUXRVVJVVPULVVMUXRUYEVVPVXAUVOUXRVVMVWTUVPYJVXSXKUXRMVVNVVMPOZPOMVDUYQP
      OZPOZVVOUYRUXRVYAVYBMPUXRVYAVVMVYBQOZVVMPOVYBUXRVVNVYDVVMPUXRVVNVVMYLUYPP
      OZRUYOPOZQOZQOZVYDUXRVVNHUYPUTOZHUYPNOZUYOPOZQOZVVMVYEQOZVYFQOVYHUXRVXKVV
      NVYLTVXPUYOHYMVIUXRVYIVYMVYKVYFQUXRVYIHUYPMNOZUTOZHVYNNOZUYPPOZQOZVYMUXRU
      YPVXILZVYIVYRTUXRVYSUYPHVSVKZUXRVYTVYJUSLZUXRVYJRUSUXRVWNUYPNOMMXQOZVYJRU
      XRUYOMMUXRUYOVWPYIZVWIUXRXNYNZWUDUVQHVWNUYPNIUWCUVRUVSZUVTUWAUXRUYPUSLZVW
      LVYTWUAVQUXRVWOWUFVWPUYOXHVIVWRUYPHUWDWJWMZUXRUYPVXMLVXNVYSVYTVQUXRUYPUBV
      XMUXRUYPVVKGXQOZUBUXRUYPGGXQOZMNOWUHUXRUYOWUIMNUXRGVWJUWBWSUXRGGMVWJVWJWU
      DUWEYJVWBUXRWUHUBLVWCVVKGUWFUWGWPZYCYDVXOUYPMHYGWJWMUYPHYMVIUXRVYOVVMVYQV
      YEQUXRVYNVVLHUTUXRUYOWUBNOUYORMQOZNOVYNVVLWUBWUKUYONWUKWUBMXNUWHUWLUWMUXR
      UYOMMWUCWUDWUDUWIUXRRGMRSLUXRRXRYOYNZVWJWUDUWNUWJZXJUXRVYPYLUYPPUXRVYPVYJ
      MXQOZYLUXRHUYPMUXRHVWQYIUXRUYPWUJYIZWUDUWKUXRWUNRMXQOYLUXRVYJRMXQWUEWSUXC
      UWOYJWSXKYJUXRVYJRUYOPWUEWSXKUXRVVMVYEVYFVWTUXRVYEUXRYLYPLUYPUBLZVYEYPLUW
      PWUJYLUYPYQXSYRUXRVYFUXRRYPLVWOVYFYPLUWQVWPRUYOYQXSYRUWRXTUXRVYGVYBVVMQUX
      RVYGYLRQOZUYPUYOQOZPOVYBUXRYLUYPRUYOYLSLUXRUWSYNWUOWULWUCUXRUYPWUJYKUXRUY
      OVWPYKUWTUXRWUQVDWURUYQPWUQVDTUXRUXAYNUXRUYPUYOWUOWUCUXBXKYJXJYJWSUXRVYBV
      VMUXRVYBUXRVDYPLUYQUBLVYBYPLUXDUXRUYOUYPVWPWUJUXEZVDUYQYQXSYRVWTUXRVVMUXR
      VVLVXHLZVVMUBLUXRWUTVVLHVSVKZUXRVVLUYPHUXRVVLUXRVYNVVLUSWUMUXRWUPVYNUSLWU
      JUYPXHVIUXFZUXGZUXRUYPWUJYBZUXRHVWQYBUXRVVLUYPWVCWVDUXRVYNVVLUYPUXHWUMUXR
      UYPWVDUXIUXJUXKWUGUXLUXRVVLVXJLVXNWUTWVAVQUXRVVLUSVXJWVBYAYDVXOVVLUDHYGWJ
      WMVVLHYHVIYKZUXMYJXJUXRVVNVVMVXRVWTVXTWVEUXNUXRUYQSLZUYQUDWAZVYCUYRTZUXRU
      YQWUSYIUXRUYQWUSYKVDSLVDUDWAWVFWVGWBWVHVDYSYOVDYSUXOVDUYQUXPUXQWJYTXTYT
      $.
  $}

  ${
    $d k n x y F $.  $d k x y z G $.  $d k x y z H $.  $d j k n x M $.
    $d k x y A $.  $d k n y J $.  $d k x y K $.  $d j k n x N $.
    basel.g $e |- G = ( n e. NN |-> ( 1 / ( ( 2 x. n ) + 1 ) ) ) $.
    $( Lemma for ~ basel .  The function ` G ` goes to zero because it is
       bounded by ` 1 / n ` .  (Contributed by Mario Carneiro, 28-Jul-2014.) $)
    basellem6 $p |- G ~~> 0 $=
      ( cc0 wbr wtru cn c1 cdiv co cvv wcel a1i c2 cmul caddc wceq adantl cle
      cr vk cli cv cmpt nnuz cz 1z cc ax-1cn divcnv mp1i nnex mptex eqeltri cfv
      oveq2 eqid ovex fvmpt nnrecre eqeltrd oveq1d oveq2d 2nn nnmulcl peano2nnd
      wa sylan nnrecred nnre nnred cn0 nnnn0 nn0addge1 syl2anc 2timesd breqtrrd
      recnd lep1d letrd clt wb nngt0 nngt0d lerec syl22anc mpbid nnrpd rpreccld
      3brtr4d rpge0d climsqz2 trud ) BDUBEFDUAAGHAUCZIJZUDZBHKGUEHUFLFUGMHUHLWP
      DUBEFUIHAUJUKBKLFBAGHNWNOJZHPJZIJZUDKCAGWSULUMUNMFUAUCZGLZVGZWTWPUOZHWTIJ
      ZTXAXCXDQFAWTWOXDGWPWNWTHIUPWPUQHWTIURUSRZXAXDTLFWTUTRVAXBWTBUOZHNWTOJZHP
      JZIJZTXAXFXIQFAWTWSXIGBWNWTQZWRXHHIXJWQXGHPWNWTNOUPVBVCCHXHIURUSRZXBXHXBX
      GFNGLZXAXGGLXLFVDMNWTVEVHZVFZVIVAXBXIXDXFXCSXBWTXHSEZXIXDSEZXBWTXGXHXAWTT
      LZFWTVJRZXBXGXMVKZXBXHXNVKZXBWTWTWTPJZXGSXBXQWTVLLZWTYASEXRXAYBFWTVMRWTWT
      VNVOXBWTXBWTXRVRVPVQXBXGXSVSVTXBXQDWTWAEZXHTLDXHWAEXOXPWBXRXAYCFWTWCRXTXB
      XHXNWDWTXHWEWFWGXKXEWJXBDXIXFSXBXIXBXHXBXHXNWHWIWKXKVQWLWM $.

    ${
      basellem7.2 $e |- A e. CC $.
      $( Lemma for ~ basel .  The function ` 1 + A x. G ` for any fixed ` A `
         goes to ` 1 ` .  (Contributed by Mario Carneiro, 28-Jul-2014.) $)
      basellem7 $p |- ( ( NN X. { 1 } ) oF +
        ( ( NN X. { A } ) oF x. G ) ) ~~> 1 $=
        ( cn c1 cmul co caddc cc0 cli wbr wtru cvv wcel a1i cc cfv wf vk vx csn
        vy cxp cof nnuz cz 1z ax-1cn eqimss2i nnex climconst2 sylancr basellem6
        cuz ovex cv wss elexi fconst snssd fss ffvelrnda c2 cdiv wa 2nn nnmulcl
        sylan peano2nnd nnrecred recnd fmptd wfn ffn inidm eqidd climmul mul01i
        syl ofval syl6breq 1ex mulcl adantl off climadd trud addid1i breqtri )
        FGUCZUEZFAUCZUEZCHUFZIZJUFZIZGKJIZGLWSWTLMNGKUAWMWQWSGOFUGGUHPZNUIQZNGR
        PZXAWMGLMUJXBGGFFGUPSUGUKZULUMUNWSOPNWMWQWRUQQNWQAKHIKLNAKUAWOCWQGOFUGX
        BNARPZXAWOALMEXBAGFXDULUMUNWQOPNWOCWPUQQCKLMNBCDUOQNFRUAURZWONFWNWOTWNR
        USFRWOTZFAAREUTVANARXENEQVBFWNRWOVCUNZVDNFRXFCNBFGVEBURZHIZGJIZVFIZRCNX
        IFPZVGZXLXNXKXNXJNVEFPZXMXJFPXONVHQVEXIVIVJVKVLVMDVNZVDNFFXFWOSZXFCSZHF
        WOCOOXFNXGWOFVOXHFRWOVPWANFRCTCFVOXPFRCVPWAFOPNULQZXSFVQZNXFFPVGZXQVRYA
        XRVRWBVSAEVTWCNFRXFWMNFWLWMTZWLRUSFRWMTFGWDVAZNGRXCNUJQVBFWLRWMVCUNVDNF
        RXFWQNUBUDFFFHRRRWOCOOUBURZRPUDURZRPVGYDYEHIRPNYDYEWEWFXHXPXSXSXTWGZVDN
        FFXFWMSZXFWQSZJFWMWQOOXFNYBWMFVOYBNYCQFWLWMVPWANFRWQTWQFVOYFFRWQVPWAXSX
        SXTYAYGVRYAYHVRWBWHWIGUJWJWK $.
    $}

    basel.f $e |- F = seq 1 ( + , ( n e. NN |-> ( n ^ -u 2 ) ) ) $.
    basel.h $e |- H = ( ( NN X. { ( ( pi ^ 2 ) / 6 ) } ) oF x.
                        ( ( NN X. { 1 } ) oF - G ) ) $.
    basel.j $e |- J = ( H oF x.
      ( ( NN X. { 1 } ) oF + ( ( NN X. { -u 2 } ) oF x. G ) ) ) $.
    basel.k $e |- K = ( H oF x. ( ( NN X. { 1 } ) oF + G ) ) $.
    ${
      basellem8.n $e |- N = ( ( 2 x. M ) + 1 ) $.
      $( Lemma for ~ basel .  The function ` F ` of partial sums of the inverse
         squares is bounded below by ` J ` and above by ` K ` , obtained by
         summing the inequality ` cot ^ 2 x <_ 1 / x ^ 2 <_ `
         ` csc ^ 2 x = cot ^ 2 x + 1 ` over the ` M ` roots of the polynomial
         ` P ` , and applying the identity ~ basellem5 .  (Contributed by Mario
         Carneiro, 29-Jul-2014.) $)
      basellem8 $p |- ( M e. NN ->
        ( ( J ` M ) <_ ( F ` M ) /\ ( F ` M ) <_ ( K ` M ) ) ) $=
        ( wcel c1 co cdiv c2 cmul vk vx vj cn cfv cle wbr cfz cexp cv ctan cneg
        cpi csu wa cr pire caddc sylancr resqcld adantr cc0 crp rpred rpne0d cz
        syl 2z a1i reexpclzd remulcld nnne0d cn0 wceq recnd 2nn0 expneg sylancl
        cc oveq2d sqcld rpexpcl divrecd eqtr4d 2cn oveq2i nncnd oveq1d nncn wne
        recni jca eqtrd 3eqtr4d clt simpld elrpd rpge0d mpbid eqbrtrd fsumle c6
        ltled cmin syl6eqr oveq12d csn cxp cof cmpt wtru cvv ovex 6re fconstmpt
        offval2 syl5eq eqtri fvmpt divcld ax-1cn mulassd oveq1i dividd 3eqtr3rd
        trud divdird df-2 mulcld divmuldiv syl22anc sqdivd divmuldivd fsummulc2
        pncan eqid 3eqtrd 3brtr4d gt0ne0d c3 2nn nnmulcl mpan peano2nnd nndivre
        fzfid syl5eqel basellem1 tanrpcl znegcl ax-mp elfznn adantl nnred nnrpd
        negnegi expnegd syl5reqr expclzd expne0d divrec2d divass syl3anc sqmuld
        cioo nnne0 elioore tangtx eliooord lt2sqd lediv23d oveq2 resqcli nnne0i
        6nn redivcli 1z negcli subcl divsubdird negsub oveq12i pnpcan2d nnsqcld
        nnex mulcom pm3.2i sqvald cbc basellem5 cseq oveq1 cuz id nnuz syl6eleq
        fsumser fveq1i syl6reqr csin resincld ccos sincosq1sgn sinltx wi le2sqd
        0re mpd breqtrrd lemuldiv2d lemuldivd bitr3d peano2cn recoscld sincossq
        ltle eqtr2d simprd tanval syl2anc mpbird recdivd 3eqtrrd 3eqtr3d addcom
        wb sqne0 sumeq2dv fsumadd chash cfn fsumconst nnnn0 hashfz1 mulid1d 3cn
        adddid df-3 mp2an 3eqtri subadd23d addassd 3eqtr4a mul32d 3t2e6 mulcomi
        eqtr3i mulcl divcan3d ) GUDOZGEUEZGBUEZUFUGVULGFUEZUFUGVUJPGUHQZUMHRQZS
        UIQZUAUJZUMTQHRQZUKUEZSULZUIQZTQZUAUNZVUNVUQVUTUIQZUAUNZVUKVULUFVUJVUNV
        VBVVDUAVUJPGUUFZVUJVUQVUNOZUOZVUPVVAVUJVUPUPOVVGVUJVUOVUJUMUPOHUDOVUOUP
        OUQVUJHSGTQZPURQZUDNVUJVVISUDOVUJVVIUDOUUASGUUBUUCZUUDUUGZUMHUUEUSZUTVA
        ZVVHVUSVUTVVHVUSVVHVURVBUMSRQZUVEQOZVUSVCOZVUQGHNUUHZVURUUIVGZVDZVVHVUS
        VVSVEVUTVFOZVVHSVFOZVWAVHSUUJUUKZVIZVJZVKVVHVUQVUTVVHVUQVVGVUQUDOZVUJVU
        QGUULUUMZUUNVVHVUQVWGVLZVWDVJZVVHVVBVUPVUSSUIQZRQZVVDUFVVHVVBVUPPVWJRQZ
        TQVWKVVHVVAVWLVUPTVVHVUSVSOSVMOZVVAVWLVNVVHVUSVVTVOVPVUSSVQVRZVTVVHVUPV
        WJVUJVUPVSOVVGVUJVUOVUJVUOVVMVOZWAZVAZVVHVWJVVHVWJVVHVVQVWBVWJVCOVVSVHV
        USSWBVRZVDZVOVVHVWJVWRVEWCWDVVHVUPVVDVWJVVNVVHVUQVCOVWAVVDVCOVVHVUQVWGU
        UOVWCVUQVUTWBVRZVWRVVHVUPVVDRQZVURSUIQZVWJUFVVHPVVDRQZVUPTQVUQSUIQZVUPT
        QZVXAVXBVVHVXCVXDVUPTVVHVXDVUQVUTULZUIQVXCVXFSVUQUISWEUUPWFVVHVUQVUTVVH
        VUQVWGWGZVWHVWDUUQUURWHVVHVUPVVDVWQVVHVWFVVDVSOVWGVWFVUQVUTVUQWIVUQUVFV
        WAVWFVWCVIUUSVGZVVHVUQVUTVXGVWHVWDUUTUVAVVHVXBVUQVUOTQZSUIQVXEVVHVURVXI
        SUIVVHVUQVSOUMVSOZHVSOZHVBWJZUOZVURVXIVNVXGVXJVVHUMUQWKZVIVUJVXMVVGVUJV
        XKVXLVUJHVVLWGZVUJHVVLVLZWLVAVUQUMHUVBUVCWHVVHVUQVUOVXGVUJVUOVSOVVGVWOV
        AUVDWMWNZVVHVXBVWJVVHVURVVHVVPVURUPOVVRVURVBVVOUVGVGZUTVWSVVHVURVUSWOUG
        ZVXBVWJWOUGVVHVVPVXSVVRVURUVHVGVVHVURVUSVXRVVTVVHVURVVHVURVXRVVHVBVURWO
        UGZVURVVOWOUGZVVHVVPVXTVYAUOVVRVURVBVVOUVIVGWPWQZWRZVVHVUSVVSWRUVJWSXCW
        TUVKWTXAVUJVUKUMSUIQZXBRQZPPHRQZXDQZTQZPVUTVYFTQZURQZTQZVUPVUNVVAUAUNZT
        QZVVCAGVYEPPSAUJZTQZPURQZRQZXDQZTQZPVUTVYQTQZURQZTQZVYKUDEVYNGVNZVYSVYH
        WUAVYJTWUCVYRVYGVYETWUCVYQVYFPXDWUCVYPHPRWUCVYPVVJHWUCVYOVVIPURVYNGSTUV
        LWHNXEVTZVTVTZWUCVYTVYIPURWUCVYQVYFVUTTWUDVTVTXFEDUDPXGXHZUDVUTXGXHZCTX
        IZQZURXIZQZWUHQZAUDWUBXJZLWULWUMVNXKAUDVYSWUATDWUKXLXLXLUDXLOXKUWEVIZVY
        SXLOXKVYNUDOUOZVYEVYRTXMVIZWUAXLOWUOPVYTURXMVIXKDUDVYEXGXHZWUFCXDXIQZWU
        HQAUDVYSXJKXKAUDVYEVYRTWUQWURXLUPXLWUNVYEUPOWUOVYDXBUMUQUVMZXNXBUVOUVNZ
        UVPZVIVYRXLOWUOPVYQXDXMVIWUQAUDVYEXJVNXKAUDVYEXOVIXKAUDPVYQXDWUFCXLVFXL
        WUNPVFOWUOUVQVIZVYQXLOWUOPVYPRXMVIZWUFAUDPXJVNXKAUDPXOVIZCAUDVYQXJVNXKI
        VIZXPXPXQZXKAUDPVYTURWUFWUIXLVFXLWUNWVBVYTXLOWUOVUTVYQTXMVIWVDXKAUDVUTV
        YQTWUGCXLVSXLWUNVUTVSOZWUOSWEUVRZVIWVCWUGAUDVUTXJVNXKAUDVUTXOVIWVEXPXPX
        PYFXRVYHVYJTXMXSVUJVYKVUPVVIVVIPXDQZTQZXBRQZTQZVYMVUJVYEVVIHRQZTQZWVIHR
        QZTQVYEWVMWVOTQZTQZVYKWVLVUJVYEWVMWVOVYEVSOVUJVYEWVAWKVIZVUJVVIHVUJVVIV
        VKWGZVXOVXPXTZVUJWVIHVUJVVIVSOZPVSOZWVIVSOWVSYAVVIPUVSVRZVXOVXPXTYBVUJV
        YHWVNVYJWVOTVUJVYGWVMVYETVUJHPXDQZHRQHHRQZVYFXDQWVMVYGVUJHPHVXOWWBVUJYA
        VIZVXOVXPUVTVUJWWDVVIHRVUJWWDVVJPXDQZVVIHVVJPXDNYCVUJWWAWWBWWGVVIVNWVSY
        AVVIPYOVRXQWHVUJWWEPVYFXDVUJHVXOVXPYDZWHYEVTZVUJHVUTURQZHRQWWEVUTHRQZUR
        QWVOVYJVUJHVUTHVXOWVGVUJWVHVIZVXOVXPYGVUJWWJWVIHRVUJWWJHSXDQZWVIVUJVXKS
        VSOZWWJWWMVNVXOWEHSUWAVRVUJWWMVVJPPURQZXDQWVIHVVJSWWOXDNYHUWBVUJVVIPPWV
        SWWFWWFUWCXQWMWHVUJWWEPWWKVYIURWWHVUJVUTHWWLVXOVXPWCXFYEXFVUJVYDHSUIQZR
        QZWVKTQZVYEWVJWWPRQZTQZWVLWVQVUJVYDWVJTQZWWPXBTQZRQZWXAXBWWPTQZRQZWWRWW
        TVUJWXBWXDWXARVUJWWPVSOZXBVSOZWXBWXDVNVUJWWPVUJHVVLUWDZWGZXBXNWKZWWPXBU
        WFVRZVTVUJVYDVSOZWVJVSOZWXFWWPVBWJZUOZWXGXBVBWJZUOZWWRWXCVNWXLVUJVYDWUS
        WKVIZVUJVVIWVIWVSWWCYIZVUJWXFWXNWXIVUJWWPWXHVLWLZWXQVUJWXGWXPWXJWUTUWGV
        IZVYDWVJWWPXBYJYKVUJWXLWXMWXQWXOWWTWXEVNWXRWXSWYAWXTVYDWVJXBWWPYJYKWNVU
        JVUPWWQWVKTVUJUMHVXJVUJVXNVIVXOVXPYLZWHVUJWVPWWSVYETVUJWVPWVJHHTQZRQWWS
        VUJVVIHWVIHWVSVXOWWCVXOVXPVXPYMVUJWWPWYCWVJRVUJHVXOUWHZVTWDVTWNWNVUJVYL
        WVKVUPTUBUBVSVBGUHQHSUCUJZTQUWIQPULGWYEXDQUIQTQUBUJWYEUIQTQUCUNXJZAVUNV
        YNUMTQHRQUKUEVUTUIQXJZUCUAAGHNWYFYPWYGYPUWJZVTWDVUJVUNVVAVUPUAVVFVWPVVH
        VVAVWEVOZYNYQVUJVVEGURAUDVYNVUTUIQZXJZPUWKZUEVULVUJVVDUAWYKPGVVHVWFVUQW
        YKUEVVDVNVWGAVUQWYJVVDUDWYKVYNVUQVUTUIUWLWYKYPVUQVUTUIXMXSVGVUJGUDPUWMU
        EVUJUWNUWOUWPVXHUWQGBWYLJUWRUWSZYRVUJVVEVUNVUPVURUWTUEZVUTUIQZTQZUAUNZV
        ULVUMUFVUJVUNVVDWYPUAVVFVWIVVHVUPWYOVVNVVHWYNVUTVVHVURVXRUXAZVVHWYNVVHV
        BWYNWOUGZVBVURUXBUEZWOUGZVVHVVPWYSXUAUOVVRVURUXCVGZWPZYSVWDVJZVKVVHVVDV
        UPWYNSUIQZRQZWYPUFVVHXUEVXAUFUGZVVDXUFUFUGZVVHXUEVXBVXAUFVVHWYNVURUFUGX
        UEVXBUFUGVVHWYNVURWYRVXRVVHVURVCOWYNVURWOUGVYBVURUXDVGXCVVHWYNVURWYRVXR
        VVHWYSVBWYNUFUGZXUCVVHVBUPOWYNUPOWYSXUIUXEUXGWYRVBWYNUXPUSUXHVYCUXFWSVX
        QUXIVVHVVDXUETQVUPUFUGXUGXUHVVHXUEVUPVVDVVHWYNWYRUTZVVNVWTUXJVVHVVDVUPX
        UEVWIVVNVVHWYNVCOVWBXUEVCOVVHWYNWYRXUCWQVHWYNSWBVRZUXKUXLWSVVHWYPVUPPXU
        ERQZTQXUFVVHWYOXULVUPTVVHWYNVSOVWMWYOXULVNVVHWYNWYRVOZVPWYNSVQVRZVTVVHV
        UPXUEVWQVVHXUEXUJVOZVVHXUEXUKVEZWCWDUXIXAWYMVUJVUMVYHPVYFURQZTQZVUPVUNW
        YOUAUNZTQZWYQAGVYSPVYQURQZTQZXURUDFWUCVYSVYHXVAXUQTWUEWUCVYQVYFPURWUDVT
        XFFDWUFCWUJQZWUHQZAUDXVBXJZMXVDXVEVNXKAUDVYSXVATDXVCXLXLXLWUNWUPXVAXLOW
        UOPVYQURXMVIWVFXKAUDPVYQURWUFCXLVFXLWUNWVBWVCWVDWVEXPXPYFXRVYHXUQTXMXSV
        UJWVNHPURQZHRQZTQVYEWVMXVGTQZTQZXURXUTVUJVYEWVMXVGWVRWVTVUJXVFHVUJVXKXV
        FVSOVXOHUXMVGZVXOVXPXTYBVUJVYHWVNXUQXVGTWWIVUJXVGWWEVYFURQXUQVUJHPHVXOW
        WFVXOVXPYGVUJWWEPVYFURWWHWHUXQXFVUJWWQVVIXVFTQZXBRQZTQZVYEXVKWWPRQZTQZX
        UTXVIVUJVYDXVKTQZWXBRQZXVPWXDRQZXVMXVOVUJWXBWXDXVPRWXKVTVUJWXLXVKVSOZWX
        OWXQXVMXVQVNWXRVUJVVIXVFWVSXVJYIZWXTWYAVYDXVKWWPXBYJYKVUJWXLXVSWXQWXOXV
        OXVRVNWXRXVTWYAWXTVYDXVKXBWWPYJYKWNVUJVUPWWQXUSXVLTWYBVUJXUSWVKGURQZXVL
        VUJXUSVUNVVAPURQZUAUNVYLVUNPUAUNZURQXWAVUJVUNWYOXWBUAVVHWYOXULPVVAURQZX
        WBXUNVVHXUEWYTSUIQZURQZXUERQXUEXUERQZXWEXUERQZURQXULXWDVVHXUEXWEXUEXUOV
        VHWYTVVHWYTVVHVURVXRUXNVOZWAZXUOXUPYGVVHXWFPXUERVVHVURVSOZXWFPVNVVHVURV
        XRVOZVURUXOVGWHVVHXWGPXWHVVAURVVHXUEXUOXUPYDVVHVVAVWLPXUEXWERQZRQXWHVWN
        VVHVWJXWMPRVVHVWJWYNWYTRQZSUIQXWMVVHVUSXWNSUIVVHXWKWYTVBWJZVUSXWNVNXWLV
        VHWYTVVHWYSXUAXUBUXRYSZVURUXSUXTWHVVHWYNWYTXUMXWIXWPYLWMVTVVHXUEXWEXUOX
        WJXUPVVHXWEVBWJZXWOXWPVVHWYTVSOXWQXWOUYFXWIWYTUYGVGUYAUYBUYCXFUYDVVHWWB
        VVAVSOXWDXWBVNYAWYIPVVAUYEUSYQUYHVUJVUNVVAPUAVVFWYIWWBVVHYAVIUYIVUJVYLW
        VKXWCGURWYHVUJXWCVUNUYJUEZPTQZGPTQGVUJVUNUYKOWWBXWCXWSVNVVFYAVUNPUAUYLV
        RVUJXWRGPTVUJGVMOXWRGVNGUYMGUYNVGWHVUJGGWIZUYOYQXFYQVUJXVLWVJXBGTQZURQZ
        XBRQWVKXXAXBRQZURQXWAVUJXVKXXBXBRVUJVVIWVIYTURQZTQWVJVVIYTTQZURQXVKXXBV
        UJVVIWVIYTWVSWWCYTVSOVUJUYPVIZUYQVUJXXDXVFVVITVUJXXDVVJPURQZXVFVUJVVIYT
        PXDQZURQVVIWWOURQXXDXXGXXHWWOVVIURXXHSPURQZPXDQZSWWOYTXXIPXDUYRYCWWNWWB
        XXJSVNWEYASPYOUYSYHUYTWFVUJVVIPYTWVSWWFXXFVUAVUJVVIPPWVSWWFWWFVUBVUCHVV
        JPURNYCXEVTVUJXXEXXAWVJURVUJXXESYTTQZGTQXXAVUJSGYTWWNVUJWEVIXWTXXFVUDXB
        XXKGTYTSTQXBXXKVUEYTSUYPWEVUFVUGYCXEVTUYDWHVUJWVJXXAXBWXSVUJWXGGVSOXXAV
        SOWXJXWTXBGVUHUSWXGVUJWXJVIZWXPVUJWUTVIZYGVUJXXCGWVKURVUJGXBXWTXXLXXMVU
        IVTYQWDXFVUJXVHXVNVYETVUJXVHXVKWYCRQXVNVUJVVIHXVFHWVSVXOXVJVXOVXPVXPYMV
        UJWWPWYCXVKRWYDVTWDVTWNWNVUJVUNWYOVUPUAVVFVWPVVHWYOXUDVOYNYQYRWL $.
    $}

    $( Lemma for ~ basel .  Since by ~ basellem8 ` F ` is bounded by two
       expressions that tend to ` pi ^ 2 / 6 ` , ` F ` must also go to
       ` pi ^ 2 / 6 ` by the squeeze theorem ~ climsqz .  But the series ` F `
       is exactly the partial sums of ` k ^ -u 2 ` , so it follows that this is
       also the value of the infinite sum ` sum_ k e. NN ( k ^ -u 2 ) ` .
       (Contributed by Mario Carneiro, 28-Jul-2014.) $)
    basellem9 $p |- sum_ k e. NN ( k ^ -u 2 ) = ( ( pi ^ 2 ) / 6 ) $=
      ( cn co wtru c1 wcel cr cmul cvv vx vy vz cv c2 cneg cexp csu cpi c6 cdiv
      wceq cmpt nnuz cz 1z a1i cfv oveq1 eqid ovex fvmpt adantl wa nnne0 znegcl
      nnre 2z ax-mp reexpclzd fmptd ffvelrnda eqeltrrd recnd cc0 caddc cseq cli
      cmin cof wf serfre sylibr csn cxp remulcl wss fconst pire resqcli 6re 6nn
      feq1i nnne0i redivcli snssd fss sylancr resubcl 1ex 1re 2nn nnmulcl sylan
      peano2nnd nnrecred nnex inidm off elexi feqmptd offval2 3eqtr4d cc c3 wbr
      recn recni climconst2 ax-resscn sylancl basellem7 wfn fnconstg offn eqidd
      ffn syl climmul syl6breq syl5eqbr 3cn 3re mul01i 2cn ax-1cn ofc1 eqbrtrrd
      ofval cle readdcl zrei npcand mpteq2dva w3a syl3an caofdi oveq12i syl6eqr
      cuz eqimss2i ofnegsub syl3anc syl6eqbrr mulid1i basellem6 mulid2d mulneg1
      subdi neg1cn negeqd mulcl negnegd eqtr2d oveq12d negsubd eqtrd df-3 eqtri
      addcomi oveq1i adddird syl5eq pnpcand 3eqtr4rd basellem8 lesub1dd 3brtr4d
      simprd simpld subge0d breqtrrd climsqz2 climadd addid2i 3brtr3g isumclim
      mpbird trud ) MAUDZUEUFZUGNZAUHUIUEUGNZUJUKNZULOUWLUWNABMBUDZUWKUGNZUMZPM
      UNPUOQZOUPUQZUWJMQZUWJUWQURZUWLULOBUWJUWPUWLMUWQUWOUWJUWKUGUSUWQUTZUWJUWK
      UGVAVBVCZOUWTVDZUWLUXDUXAUWLRUXCOMRUWJUWQOBMUWPRUWQUWOMQZUWPRQOUXEUWOUWKU
      WOVGUWOVEUWKUOQZUXEUEUOQUXFVHUEVFVIZUQVJVCUXBVKVLZVMVNOCVOUWNVPNZVPUWQPVQ
      ZUWNVROCFVSVTZNZFVPVTZNZCUXIVROBMUWOCURZUWOFURZVSNZUXPVPNZUMBMUXOUMUXNCOB
      MUXRUXOOUXEVDZUXOUXPUXSUXOOMRUWOCOMRUXJWAMRCWAZOAUWQPMUNUWSUXHWBMRCUXJIWM
      WCZVLZVNUXSUXPOMRUWOFOMREMPWDZWEZMUWKWDZWEZDSVTZNZUXMNZUYGNZWAMRFWAZOUAUB
      MMMSRRREUYITTUAUDZRQZUBUDZRQZVDZUYLUYNSNZRQOUYLUYNWFVCZOMRMUWNWDZWEZUYDDU
      XKNZUYGNZWAMREWAZOUAUBMMMSRRRUYTVUATTUYROMUYSUYTWAUYSRWGMRUYTWAZMUWNUWMUJ
      UKVAWHOUWNRUWNRQOUWMUJUIWIWJWKUJWLWNWOZUQWPMUYSRUYTWQWRZOUAUBMMMVSRRRUYDD
      TTUYPUYLUYNVSNRQOUYLUYNWSVCZOMUYCUYDWAUYCRWGMRUYDWAZMPWTWHOPRPRQOXAUQZWPM
      UYCRUYDWQWRZOBMPUEUWOSNZPVPNZUKNRDUXSVULUXSVUKOUEMQZUXEVUKMQVUMOXBUQUEUWO
      XCXDXEXFHVKZMTQZOXGUQZVUPMXHZXIZVUPVUPVUQXIMREVUBJWMWCZOUAUBMMMVPRRRUYDUY
      HTTUYPUYLUYNVPNRQOUYLUYNUUAVCZVUJOUAUBMMMSRRRUYFDTTUYROMUYEUYFWAUYERWGMRU
      YFWAMUWKUWKUOUXGXJWHOUWKRUWKRQZOUWKUXGUUBZUQZWPMUYERUYFWQWRVUNVUPVUPVUQXI
      VUPVUPVUQXIZVUPVUPVUQXIMRFUYJKWMWCZVLZVNUUCUUDOBMUXQUXPVPUXLFTTRVUPUXQTQU
      XSUXOUXPVSVAUQVVFOBMUXOUXPVSCFTRRVUPUYBVVFOBMRCUYAXKZOBMRFVVEXKZXLVVHXLVV
      GXMOVOUWNAUXLFUXNPTMUNUWSOVOAGFUXKNZUXLPTMUNUWSOEUYDDUXMNZUYIUXKNZUYGNZVV
      IVOVROVVLEVVJUYGNZUYJUXKNVVIOUAUBUCMVSRSEVVJUYIRVSTVUPVUSOUAUBMMMVPRRRUYD
      DTTVUTVUJVUNVUPVUPVUQXIZVVDUYMUYOUCUDZRQZUUEUYLUYNVVOVSNSNUYQUYLVVOSNVSNU
      LZOUYMUYLXNQUYOUYNXNQVVPVVOXNQVVQUYLXQUYNXQVVOXQUYLUYNVVOUUSUUFVCUUGGVVMF
      UYJUXKLKUUHUUIOVVLUWNVOSNVOVROUWNVOAEMXOWDZWEZDUYGNZVVLPTMUNUWSOEVUBUWNVR
      JOVUBUWNPSNZUWNVROUWNPAUYTVUAVUBPTMUNUWSOUWNXNQUWRUYTUWNVRXPUWNVUEXRZUWSU
      WNPMMPUUJURUNUUKZXGXSWRVUBTQOUYTVUAUYGVAUQOVUAUYDMPUFZWDWEDUYGNUXMNZPVROV
      UOMXNUYDWAZMXNDWAZVWEVUAULVUPOVUHRXNWGZVWFVUJXTMRXNUYDWQYAOMRDWAZVWHVWGVU
      NXTMRXNDWQYAMUYDDTUULUUMVWDBDHUUTYBUUNUXDUWJUYTURZOMRUWJUYTVUFVLVNUXDUWJV
      UAURZOMRUWJVUAVURVLVNOMMVWJVWKSMUYTVUATTUWJOVUDUYTMYCVUFMRUYTYGYHOMMVSMUY
      DDTTOUWRUYDMYCUWSMPUOYDYHZOVWIDMYCVUNMRDYGYHZVUPVUPVUQYEVUPVUPVUQUXDVWJYF
      UXDVWKYFYSYIUWNVWBUUOZYJYKZVVLTQOEVVKUYGVAUQOVVTXOVOSNVOVROXOVOAVVSDVVTPT
      MUNUWSOXOXNQUWRVVSXOVRXPYLUWSXOPMVWCXGXSWRVVTTQOVVSDUYGVAUQDVOVRXPOBDHUUP
      UQUXDUWJVVSURZOMRUWJVVSOMVVRVVSWAVVRRWGMRVVSWAZMXOXORYMXJWHOXORXORQOYMUQZ
      WPMVVRRVVSWQWRZVLVNUXDUWJDURZOMRUWJDVUNVLZVNZOMMVWPVWTSMVVSDTTUWJOVWQVVSM
      YCVWSMRVVSYGYHVWMVUPVUPVUQUXDVWPYFUXDVWTYFZYSYIXOYLYNYJUXDUWJEURZOMRUWJEV
      USVLVNZUXDUWJVVTURZOMRUWJVVTOUAUBMMMSRRRVVSDTTUYRVWSVUNVUPVUPVUQXIVLVNOMM
      VXDVXFSMEVVKTTUWJOVUCEMYCVUSMREYGYHZOMRVVKWAVVKMYCOUAUBMMMVSRRRVVJUYITTVU
      GVVNVVDVUPVUPVUQXIMRVVKYGYHVUPVUPVUQUXDVXDYFZUXDPVWTVPNZPUWKVWTSNZVPNZVSN
      ZXOVWTSNZUWJVVKURVXFUXDPVWTSNZUEVWTSNZVPNZVWTVXJVSNZVXMVXLUXDVXPVWTVXJUFZ
      VPNVXQUXDVXNVWTVXOVXRVPUXDVWTVXBUUQUXDVXRVXOUFZUFVXOUXDVXJVXSUXDUEXNQZVWT
      XNQZVXJVXSULYOVXBUEVWTUURWRUVAUXDVXOUXDVXTVYAVXOXNQYOVXBUEVWTUVBWRUVCUVDU
      VEUXDVWTVXJVXBUXDVXJUXDVVAVWTRQVXJRQVVBVXAUWKVWTWFWRVNZUVFUVGUXDVXMPUEVPN
      ZVWTSNVXPXOVYCVWTSXOUEPVPNVYCUVHUEPYOYPUVJUVIUVKUXDPUEVWTPXNQUXDYPUQZVXTU
      XDYOUQVXBUVLUVMUXDPVWTVXJVYDVXBVYBUVNUVOOMMVXIVXKVSMVVJUYITTUWJOMMVPMUYDD
      TTVWLVWMVUPVUPVUQYEOMMVPMUYDUYHTTVWLOMMSMUYFDTTOUXFUYFMYCUXFOUXGUQMUWKUOY
      DYHVWMVUPVUPVUQYEZVUPVUPVUQYEZVUPVUPVUQOMPVWTVPDTRUWJVUPVUIVWMVXCYQOMPVXJ
      VPUYHTRUWJVUPVUIVYEOMUWKVWTSDTRUWJVUPVVCVWMVXCYQYQYSOMXOVWTSDTRUWJVUPVWRV
      WMVXCYQXMYSYIUWNVWBYNYJYRUXLTQOCFUXKVAUQOMRUWJVVIOUAUBMMMVSRRRGFTTVUGOMRV
      VMWAMRGWAZOUAUBMMMSRRREVVJTTUYRVUSVVNVUPVUPVUQXIMRGVVMLWMWCZVVEVUPVUPVUQX
      IVLOMRUWJUXLOUAUBMMMVSRRRCFTTVUGUYAVVEVUPVUPVUQXIZVLZUXDUWJCURZUWJFURZVSN
      ZUWJGURZVYLVSNUWJUXLURZUWJVVIURYTUXDVYKVYNVYLOMRUWJCUYAVLZOMRUWJGVYHVLOMR
      UWJFVVEVLZUXDVYLVYKYTXPZVYKVYNYTXPZUWTVYRVYSVDOBCDEFGUWJUEUWJSNPVPNZHIJKL
      VYTUTUVPVCZUVSUVQOMMVYKVYLVSMCFTTUWJOUXTCMYCUYAMRCYGYHOUYKFMYCVVEMRFYGYHZ
      VUPVUPVUQUXDVYKYFUXDVYLYFZYSZOMMVYNVYLVSMGFTTUWJOVYGGMYCVYHMRGYGYHWUBVUPV
      UPVUQUXDVYNYFWUCYSUVRUXDVOVYMVYOYTUXDVOVYMYTXPVYRUXDVYRVYSWUAUVTUXDVYKVYL
      VYPVYQUWAUWHWUDUWBUWCUXNTQOUXLFUXMVAUQOFUYJUWNVRKOUYJVWAUWNVROUWNPAEUYIUY
      JPTMUNUWSVWOUYJTQOEUYIUYGVAUQUYIPVRXPOUWKBDHUWKVVBXRYBUQVXEUXDUWJUYIURZOM
      RUWJUYIVVDVLVNOMMVXDWUESMEUYITTUWJVXGVYFVUPVUPVUQVXHUXDWUEYFYSYIVWNYJYKUX
      DVYOVYJVNUXDVYLVYQVNOMMVYOVYLVPMUXLFTTUWJOMRUXLWAUXLMYCVYIMRUXLYGYHWUBVUP
      VUPVUQUXDVYOYFWUCYSUWDYRIUWNVWBUWEUWFUWGUWI $.
  $}

  ${
    $d k m n $.
    $( The sum of the inverse squares is ` pi ^ 2 / 6 ` .  This is commonly
       known as the Basel problem, with the first known proof attributed to
       Euler.  See ~ http://en.wikipedia.org/wiki/Basel_problem .  This
       particular proof approach is due to Cauchy (1821).  (Contributed by
       Mario Carneiro, 30-Jul-2014.) $)
    basel $p |- sum_ k e. NN ( k ^ -u 2 ) = ( ( pi ^ 2 ) / 6 ) $=
      ( vn vm caddc cn cv c2 cexp co cmpt c1 cseq cmul cdiv csn cxp cof cbvmptv
      wceq eqid cneg cpi cmin oveq2 oveq1d oveq2d oveq1 seqeq3 ax-mp basellem9
      c6 ) ABDCECFZGUAZHIZJZKLZCEKGULMIZKDIZNIZJZEUBGHIUKNIOPEKOPZUTUCQIMQZIZVC
      VAEUMOPUTVBIDQZIVBIZVCVAUTVDIVBIZCBEUSKGBFZMIZKDIZNIULVGSZURVIKNVJUQVHKDU
      LVGGMUDUEUFRUOBEVGUMHIZJZSUPDVLKLSCBEUNVKULVGUMHUGRDUOVLKUHUIVCTVETVFTUJ
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Number-theoretical functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c theta $.
  $c Lam $.
  $c psi $.
  $c ppi $.
  $c mmu $.
  $c sigma $.

  $( Extend class notation with the first Chebyshev function. $)
  ccht $a class theta $.

  $( Extend class notation with the von Mangoldt function. $)
  cvma $a class Lam $.

  $( Extend class notation with the second Chebyshev function. $)
  cchp $a class psi $.

  $( Extend class notation with the prime Pi function. $)
  cppi $a class ppi $.

  $( Extend class notation with the M&ouml;bius function. $)
  cmu $a class mmu $.

  $( Extend class notation with the divisor function. $)
  csgm $a class sigma $.

  ${
    $d k n p s x $.
    $( Define the first Chebyshev function, which adds up the logarithms of all
       primes less than ` x ` .  The symbol used to represent this function is
       sometimes the variant greek letter theta shown here and sometimes the
       greek letter psi, &psi;; however, this notation can also refer to the
       second Chebyshev function, which adds up the logarithms of prime powers
       instead.  See ~ https://en.wikipedia.org/wiki/Chebyshev_function for a
       discussion of the two functions.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    df-cht $a |- theta = ( x e. RR |->
      sum_ p e. ( ( 0 [,] x ) i^i Prime ) ( log ` p ) ) $.

    $( Define the von Mangoldt function, which gives the logarithm of the prime
       at a prime power, and is zero elsewhere.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    df-vma $a |- Lam = ( x e. NN |-> [_ { p e. Prime | p || x } / s ]_
      if ( ( # ` s ) = 1 , ( log ` U. s ) , 0 ) ) $.

    $( Define the second Chebyshev function, which adds up the logarithms of
       the primes corresponding to the prime powers less than ` x ` .
       (Contributed by Mario Carneiro, 7-Apr-2016.) $)
    df-chp $a |- psi = ( x e. RR |->
      sum_ n e. ( 1 ... ( |_ ` x ) ) ( Lam ` n ) ) $.

    $( Define the prime &pi; function, which counts the number of primes less
       than or equal to ` x ` .  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    df-ppi $a |- ppi = ( x e. RR |-> ( # ` ( ( 0 [,] x ) i^i Prime ) ) ) $.

    $( Define the M&ouml;bius function, which is zero for non-squarefree
       numbers and is ` -u 1 ` or ` 1 ` for squarefree numbers according as to
       the number of prime divisors of the number is even or odd.  (Contributed
       by Mario Carneiro, 22-Sep-2014.) $)
    df-mu $a |- mmu = ( x e. NN |-> if ( E. p e. Prime ( p ^ 2 ) || x , 0 ,
      ( -u 1 ^ ( # ` { p e. Prime | p || x } ) ) ) ) $.

    $( Define the divisor function, which counts the number of divisors of
       ` n ` , to the power ` x ` .  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    df-sgm $a |- sigma = ( x e. CC , n e. NN |->
       sum_ k e. { p e. NN | p || n } ( k ^c x ) ) $.
  $}

  ${
    $d k x y z A $.  $d x y z B $.  $d k y z ph $.
    efnnfsumcl.1 $e |- ( ph -> A e. Fin ) $.
    efnnfsumcl.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
    efnnfsumcl.3 $e |- ( ( ph /\ k e. A ) -> ( exp ` B ) e. NN ) $.
    $( Finite sum closure in the log-integers.  (Contributed by Mario Carneiro,
       7-Apr-2016.) $)
    efnnfsumcl $p |- ( ph -> ( exp ` sum_ k e. A B ) e. NN ) $=
      ( vx cv ce cfv cn wcel cr wa wceq fveq2 eleq1d elrab cc0 vy vz csu cc wss
      crab ssrab2 ax-resscn sstri a1i caddc co simpll readdcld cmul recnd efadd
      simprl syl2anc nnmulcl ad2ant2l eqeltrd sylanbrc syl2anb adantl c1 syl6eq
      0re 1nn ef0 mpbir2an fsumcllem simprbi syl ) ABCDUCZHIZJKZLMZHNUFZMZVOJKZ
      LMZAUAUBBCVSDVSUDUEAVSNUDVRHNUGUHUIUJUAIZVSMZUBIZVSMZOWCWEUKULZVSMZAWDWCN
      MZWCJKZLMZOZWENMZWEJKZLMZOZWHWFVRWKHWCNVPWCPVQWJLVPWCJQRSVRWOHWENVPWEPVQW
      NLVPWEJQRSWLWPOZWGNMWGJKZLMZWHWQWCWEWIWKWPUMZWLWMWOURZUNWQWRWJWNUOULZLWQW
      CUDMWEUDMWRXBPWQWCWTUPWQWEXAUPWCWEUQUSWKWOXBLMWIWMWJWNUTVAVBVRWSHWGNVPWGP
      VQWRLVPWGJQRSVCVDVEEADIBMOCNMCJKZLMZCVSMFGVRXDHCNVPCPVQXCLVPCJQRSVCTVSMZA
      XETNMVFLMZVHVIVRXFHTNVPTPZVQVFLXGVQTJKVFVPTJQVJVGRSVKUJVLVTVONMWBVRWBHVON
      VPVOPVQWALVPVOJQRSVMVN $.
  $}

  ${
    $d k n p q s x y z A $.  $d p K $.  $d p x M $.  $d p N $.  $d s x S $.
    $d k n p x y z B $.  $d p P $.
    $( The set of primes less than ` A ` expressed using a finite set of
       integers.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    ppisval $p |- ( A e. RR ->
      ( ( 0 [,] A ) i^i Prime ) = ( ( 2 ... ( |_ ` A ) ) i^i Prime ) ) $=
      ( vx cr wcel cc0 co cprime cin c2 cfv cuz sseldi syl cz cle wbr inss1 0re
      cicc wss cfl cfz cv wa inss2 simpr prmuz2 prmz adantr w3a wb simpl elicc2
      flcl sylancr mpbid simp3d flge syldan eluz2 syl3anbrc elfzuzb sylanbrc ex
      elin ssrdv wceq 2z fzval2 a1i 2re 2pos ltleii flle iccss syl22anc eqsstrd
      id syl5ss ssrin eqssd ) ACDZEASFZGHZIAUAJZUBFZGHZWBBWDWGWBBUCZWDDZWHWGDZW
      BWIUDZWHWFDZWHGDZWJWKWHIKJDZWEWHKJDZWLWKWMWNWKWDGWHWCGUEWBWIUFZLZWHUGMWKW
      HNDZWENDZWHWEOPZWOWKWMWRWQWHUHMZWBWSWIAUNZUIWKWHAOPZWTWKWHCDZEWHOPZXCWKWH
      WCDZXDXEXCUJZWKWDWCWHWCGQWPLWKECDZWBXFXGUKRWBWIULEAWHUMUOUPUQWBWIWRXCWTUK
      XAAWHURUSUPWHWEUTVAWHIWEVBVCWQWHWFGVEVCVDVFWBWFWCTWGWDTWBWFIWESFZNHZWCWBI
      NDWSWFXJVGVHXBIWEVIUOWBXJXIWCXINQWBXHWBEIOPZWEAOPXIWCTXHWBRVJWBVRXKWBEIRV
      KVLVMVJAVNEAIWEVOVPVSVQWFWCGVTMWA $.

    $( The set of primes less than ` A ` expressed using a finite set of
       integers.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    ppisval2 $p |- ( ( A e. RR /\ 2 e. ( ZZ>= ` M ) ) ->
      ( ( 0 [,] A ) i^i Prime ) = ( ( M ... ( |_ ` A ) ) i^i Prime ) ) $=
      ( vx cr wcel c2 cuz cfv cc0 cicc cprime cin cfl cfz wss syl elin sylanbrc
      wa co wceq ppisval adantr fzss1 adantl ssrin cv simpr sylib simprd prmuz2
      simpld elfzuz3 elfzuzb ex ssrdv eqssd eqtrd ) ADEZFBGHEZSZIAJTKLZFAMHZNTZ
      KLZBVCNTZKLZUSVBVEUAUTAUBUCVAVEVGVAVDVFOZVEVGOUTVHUSFBVCUDUEVDVFKUFPVACVG
      VEVACUGZVGEZVIVEEZVAVJSZVIVDEZVIKEZVKVLVIFGHEZVCVIGHEZVMVLVNVOVLVIVFEZVNV
      LVJVQVNSVAVJUHVIVFKQUIZUJZVIUKPVLVQVPVLVQVNVRULVIBVCUMPVIFVCUNRVSVIVDKQRU
      OUPUQUR $.

    $( The set of primes less than ` A ` is a finite set.  (Contributed by
       Mario Carneiro, 15-Sep-2014.) $)
    ppifi $p |- ( A e. RR -> ( ( 0 [,] A ) i^i Prime ) e. Fin ) $=
      ( cr wcel cc0 cicc co cprime cin c2 cfl cfv cfz cfn ppisval wss fzfi ssfi
      inss1 mp2an syl6eqel ) ABCDAEFGHIAJKZLFZGHZMANUBMCUCUBOUCMCIUAPUBGRUBUCQS
      T $.

    $( The set of divisors of a number is a subset of a finite set.
       (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    sgmss $p |- ( A e. NN -> { p e. NN | p || A } C_ ( 1 ... A ) ) $=
      ( cn wcel cv cdivides wbr c1 cfz co wi wral crab wss wa cle cz nnz id wb
      dvdsle syl2anr ibar adantl adantr fznn syl bitr4d sylibd ralrimiva sylibr
      rabss ) ACDZBEZAFGZUNHAIJZDZKZBCLUOBCMUPNUMURBCUMUNCDZOZUOUNAPGZUQUSUNQDU
      MUOVAKUMUNRUMSUNAUAUBUTVAUSVAOZUQUSVAVBTUMUSVAUCUDUTAQDZUQVBTUMVCUSARUEUN
      AUFUGUHUIUJUOBCUPULUK $.

    $( The set of prime divisors of a number is a finite set.  (Contributed by
       Mario Carneiro, 7-Apr-2016.) $)
    prmdvdsfi $p |- ( A e. NN -> { p e. Prime | p || A } e. Fin ) $=
      ( cn wcel c1 cfz co cfn cv cdivides wbr cprime crab wss fzfi prmnn rabss2
      ssriv ax-mp sgmss syl5ss ssfi sylancr ) ACDZEAFGZHDBIZAJKZBLMZUENUHHDEAOU
      DUHUGBCMZUELCNUHUINBLCUFPRUGBLCQSABTUAUEUHUBUC $.

    $( Domain and range of the Chebyshev function.  (Contributed by Mario
       Carneiro, 15-Sep-2014.) $)
    chtf $p |- theta : RR --> RR $=
      ( vx vp cr cc0 cv cicc co cprime cin clog cfv csu ccht df-cht ppifi wa cn
      wcel inss2 simpr sseldi prmnn syl nnrpd relogcld fsumrecl fmpti ) ACCDAEZ
      FGZHIZBEZJKZBLMABNUHCRZUJULBUHOUMUKUJRZPZUKUOUKUOUKHRUKQRUOUJHUKUIHSUMUNT
      UAUKUBUCUDUEUFUG $.

    $( Real closure of the Chebyshev function.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    chtcl $p |- ( A e. RR -> ( theta ` A ) e. RR ) $=
      ( cr ccht chtf ffvelrni ) BBACDE $.

    $( Value of the Chebyshev function.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    chtval $p |- ( A e. RR -> ( theta ` A ) =
      sum_ p e. ( ( 0 [,] A ) i^i Prime ) ( log ` p ) ) $=
      ( vx cc0 cv cicc co cprime cin clog cfv cr ccht wceq oveq2 ineq1d sumeq1d
      csu df-cht sumex fvmpt ) CADCEZFGZHIZBEJKZBRDAFGZHIZUEBRLMUBANZUDUGUEBUHU
      CUFHUBADFOPQCBSUGUEBTUA $.

    $( The Chebyshev function is closed in the log-integers.  (Contributed by
       Mario Carneiro, 22-Sep-2014.)  (Revised by Mario Carneiro,
       7-Apr-2016.) $)
    efchtcl $p |- ( A e. RR -> ( exp ` ( theta ` A ) ) e. NN ) $=
      ( vp cr wcel ccht cfv ce cc0 cicc co cprime cin cv clog csu chtval fveq2d
      cn ppifi eqeltrd wa inss2 simpr sseldi prmnn relogcld reeflogd efnnfsumcl
      syl nnrpd ) ACDZAEFZGFHAIJZKLZBMZNFZBOZGFRUKULUQGABPQUKUNUPBASUKUOUNDZUAZ
      UOUSUOUSUOKDUORDUSUNKUOUMKUBUKURUCUDUOUEUIZUJZUFUSUPGFUORUSUOVAUGUTTUHT
      $.

    $( The Chebyshev function is always positive.  (Contributed by Mario
       Carneiro, 15-Sep-2014.) $)
    chtge0 $p |- ( A e. RR -> 0 <_ ( theta ` A ) ) $=
      ( vp cr wcel cc0 cicc co cprime cin cv clog cfv csu ccht cle ppifi wa clt
      cn c1 wbr c2 cuz inss2 simpr sseldi prmuz2 syl eluz2b2 sylib simpld nnrpd
      relogcld nnred simprd rplogcld rpge0d fsumge0 chtval breqtrrd ) ACDZEEAFG
      ZHIZBJZKLZBMANLOVAVCVEBAPVAVDVCDZQZVDVGVDVGVDSDZTVDRUAZVGVDUBUCLDZVHVIQVG
      VDHDVJVGVCHVDVBHUDVAVFUEUFVDUGUHVDUIUJZUKZULUMVGVEVGVDVGVDVLUNVGVHVIVKUOU
      PUQURABUSUT $.

    ${
      vmaval.1 $e |- S = { p e. Prime | p || A } $.
      $( Value of the von Mangoldt function.  (Contributed by Mario Carneiro,
         7-Apr-2016.) $)
      vmaval $p |- ( A e. NN ->
        ( Lam ` A ) = if ( ( # ` S ) = 1 , ( log ` U. S ) , 0 ) ) $=
        ( vx vs cv cdivides wbr cprime crab chash cfv c1 wceq cuni clog cc0 cif
        cn csb cvma cvv wcel nnex prmnn ssriv ssexi rabex wa id rabbidv syl6eqr
        breq2 sylan9eqr fveq2d eqeq1d unieqd eqidd ifbieq12d csbied df-vma fvex
        a1i c0ex ifex fvmpt ) EAFCGZEGZHIZCJKZFGZLMZNOZVLPZQMZRSZUABLMZNOZBPZQM
        ZRSZTUBVIAOZFVKVQWBUCVKUCUDWCVJCJJTUECJTVHUFUGUHUIVDWCVLVKOZUJZVNVSVPRW
        ARWEVMVRNWEVLBLWDWCVLVKBWDUKWCVKVHAHIZCJKBWCVJWFCJVIAVHHUNULDUMUOZUPUQW
        EVOVTQWEVLBWGURUPWERUSUTVAEFCVBVSWARVTQVCVEVFVG $.
    $}

    $( Two ways to say that ` A ` is a prime power.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    isppw $p |- ( A e. NN ->
      ( ( Lam ` A ) =/= 0 <-> E! p e. Prime p || A ) ) $=
      ( cn wcel cvma cfv cc0 wne cv wbr cprime chash c1 wceq c1o cfn wb syl cvv
      c2 cdivides crab cuni clog cif wreu vmaval neeq1d cen reuen1 hash1 eqeq2i
      eqid wa prmdvdsfi com 1onn nnfi hashen sylancl syl5bbr biimpar iftrue cuz
      ax-mp cr csn simpr en1b sylib ssrab2 syl6eqssr uniexg adantr snssg mpbird
      wss prmuz2 eluzelre clt eluz2b2 simprbi rplogcld eqnetrd iffalse necon1ai
      rpne0d ex syl5ib impbid syl5bb bitr4d ) ACDZAEFZGHBIAUAJZBKUBZLFZMNZWPUCZ
      UDFZGUEZGHZWOBKUFZWMWNXAGAWPBWPUMUGUHXCWPOUIJZWMXBWOBKUJWMXDXBWMXDXBWMXDU
      NZXAWTGXEWRXAWTNWMWRXDWRWQOLFZNZWMXDXFMWQUKULWMWPPDZOPDZXGXDQABUOZOUPDXIU
      QOURVEWPOUSUTVAZVBWRWTGVCRXEWTXEWSXEWSTVDFDZWSVFDXEWSKDZXLXEXMWSVGZKVQZXE
      XNWPKXEXDWPXNNWMXDVHWPVIVJWOBKVKVLXEWSSDZXMXOQWMXPXDWMXHXPXJWPPVMRVNWSKSV
      ORVPWSVRRZTWSVSRXEXLMWSVTJZXQXLWSCDXRWSWAWBRWCWGWDWHXBWRWMXDWRXAGWRWTGWEW
      FXKWIWJWKWL $.

    $( Two ways to say that ` A ` is a prime power.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    isppw2 $p |- ( A e. NN ->
      ( ( Lam ` A ) =/= 0 <-> E. p e. Prime E. k e. NN A = ( p ^ k ) ) ) $=
      ( vq cn wcel cc0 cv cdivides wbr cprime cexp co wceq wb wa syl2anc mpbird
      wrex cpc cvma cfv wreu isppw wral reu6 equid breq1 equequ1 bibi12d rspcva
      wne adantll mpbiri simplr simpll pcelnn oveq1d cz simpllr cn0 pccl ancoms
      simpr ad2antrr nn0zd pcid eqtr4d wn simprr notbid biimpar simplrl simplll
      pceq0 wi simprl adantr prmdvdsexpr syl3anc con3and prmnn adantl pm2.61dan
      nnexpcld expr ralimdva imp nnnn0 nnnn0d pc11 eqeq2d rspcev ex prmdvdsexpb
      oveq2 3coml ralrimiva bibi1d ralbidv syl5ibrcom rexlimdva impbid rexbidva
      3expa breq2 syl5bb bitrd ) AEFZAUAUBGULDHZAIJZDKUCZACHZBHZLMZNZBESZCKSZAD
      UDXLXKXJXMNZOZDKUEZCKSXIXRXKDCKUFXIYAXQCKXIXMKFZPZYAXQYCYAXQYCYAPZXMATMZE
      FZAXMYELMZNZXQYDYFXMAIJZYDYIXMXMNZCUGYBYAYIYJOZXIXTYKDXMKXSXKYIXSYJXJXMAI
      UHDCCUIUJUKUMUNYDYBXIYFYIOXIYBYAUOXIYBYAUPXMAUQQRYDYHXJATMZXJYGTMZNZDKUEZ
      YCYAYOYCXTYNDKYCXJKFZXTYNYCYPXTPZPZXSYNYRXSPZYLXMYGTMZYMYSYLYEYTYSXJXMATY
      RXSVDZURYSYBYEUSFYTYENXIYBYQXSUTYSYEYCYEVAFZYQXSYBXIUUBXMAVBVCZVEVFYEXMVG
      QVHYSXJXMYGTUUAURVHYRXSVIZPZYLGYMUUEYLGNZXKVIZYRUUGUUDYRXKXSYCYPXTVJVKVLU
      UEYPXIUUFUUGOYCYPXTUUDVMZXIYBYQUUDVNXJAVOQRUUEYMGNZXJYGIJZVIZYRUUJXSYRYPY
      BUUBUUJXSVPYCYPXTVQXIYBYQUOYCUUBYQUUCVRXJXMYEVSVTWAUUEYPYGEFZUUIUUKOUUHYC
      UULYQUUDYCXMYEYBXMEFXIXMWBWCUUCWEZVEXJYGVOQRVHWDWFWGWHYDAVAFZYGVAFYHYOOXI
      UUNYBYAAWIVEYDYGYCUULYAUUMVRWJAYGDWKQRXPYHBYEEXNYENXOYGAXNYEXMLWPWLWMQWNY
      CXPYABEYCXNEFZPYAXPXJXOIJZXSOZDKUEZYBUUOUURXIYBUUOPUUQDKYBUUOYPUUQYPYBUUO
      UUQXJXMXNWOWQXEWRUMXPXTUUQDKXPXKUUPXSAXOXJIXFWSWTXAXBXCXDXGXH $.

    $( Value of the von Mangoldt function at a prime power.  (Contributed by
       Mario Carneiro, 7-Apr-2016.) $)
    vmappw $p |- ( ( P e. Prime /\ K e. NN ) ->
      ( Lam ` ( P ^ K ) ) = ( log ` P ) ) $=
      ( vp cprime wcel cn wa cfv cdivides wbr chash c1 wceq cuni cc0 syl fveq2d
      clog adantr eqtrd cexp co cvma cv crab cif cn0 prmnn nnnn0 nnexpcl syl2an
      vmaval csn cab df-rab wi w3a prmdvdsexpb biimpd 3coml 3expa expimpd simpl
      eqid cz iddvdsexp sylan jca eleq1 breq1 anbi12d syl5ibrcom impbid syl6bbr
      prmz elsn abbi1dv syl5eq hashsng iftrue unieqd unisng 3eqtrd ) ADEZBFEZGZ
      ABUAUBZUCHZCUDZWGIJZCDUEZKHZLMZWKNZRHZOUFZWOARHWFWGFEZWHWPMWDAFEBUGEWQWEA
      UHBUIABUJUKWGWKCWKVDULPWFWMWPWOMWFWLAUMZKHZLWFWKWRKWFWKWIDEZWJGZCUNWRWJCD
      UOWFXACWRWFXAWIAMZWIWREWFXAXBWFWTWJXBWDWEWTWJXBUPZWTWDWEXCWTWDWEUQWJXBWIA
      BURUSUTVAVBWFXAXBWDAWGIJZGWFWDXDWDWEVCWDAVEEWEXDAVOABVFVGVHXBWTWDWJXDWIAD
      VIWIAWGIVJVKVLVMCAVPVNVQVRZQWDWSLMWEADVSSTWMWOOVTPWFWNARWFWNWRNZAWFWKWRXE
      WAWDXFAMWEADWBSTQWC $.

    $( Value of the von Mangoldt function at a prime.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    vmaprm $p |- ( P e. Prime -> ( Lam ` P ) = ( log ` P ) ) $=
      ( cprime wcel c1 cexp co cvma cfv clog prmnn nncnd exp1d fveq2d cn vmappw
      wceq 1nn mpan2 eqtr3d ) ABCZADEFZGHZAGHAIHZTUAAGTATAAJKLMTDNCUBUCPQADORS
      $.

    $( Closure for the von Mangoldt function.  (Contributed by Mario Carneiro,
       7-Apr-2016.) $)
    vmacl $p |- ( A e. NN -> ( Lam ` A ) e. RR ) $=
      ( vp vk cn wcel cvma cfv cr cc0 eleq1 wne cv cexp wceq wrex cprime isppw2
      co wa clog vmappw prmnn nnrpd relogcld eqeltrd fveq2 syl5ibrcom rexlimivv
      adantr eleq1d syl6bi imp 0re a1i pm2.61ne ) ADEZAFGZHEZIHEZUQIUQIHJUPUQIK
      ZURUPUTABLZCLZMRZNZCDOBPOURACBQVDURBCPDVAPEZVBDEZSZURVDVCFGZHEVGVHVATGZHV
      AVBUAVEVIHEVFVEVAVEVAVAUBUCUDUIUEVDUQVHHAVCFUFUJUGUHUKULUSUPUMUNUO $.

    $( Functionality of the von Mangoldt function.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    vmaf $p |- Lam : NN --> RR $=
      ( vx vn vs vp cn cr cvma wf wtru cv cdivides wbr cprime cfv wceq clog cc0
      cvv wcel a1i crab chash c1 cuni cif csb fvex c0ex ifex csbex df-vma vmacl
      wa cmpt adantl fmpt2d trud ) EFGHIABECDJAJZKLDMUAZCJZUBNUCOZUTUDZPNZQUEZU
      FZFGRVERSIURESUMCUSVDVAVCQVBPUGUHUIUJTGAEVEUNOIACDUKTBJZESVFGNFSIVFULUOUP
      UQ $.

    $( The von Mangoldt is closed in the log-integers.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    efvmacl $p |- ( A e. NN -> ( exp ` ( Lam ` A ) ) e. NN ) $=
      ( vp vk cn wcel cvma cfv ce c1 cc0 wceq fveq2 ef0 syl6eq eleq1d cv cprime
      wrex fveq2d eqeltrd wne cexp co isppw2 vmappw prmnn nnrpd reeflogd adantr
      wa clog syl5ibrcom rexlimivv syl6bi imp 1nn a1i pm2.61ne ) ADEZAFGZHGZDEZ
      IDEZUTJUTJKZVAIDVDVAJHGIUTJHLMNOUSUTJUAZVBUSVEABPZCPZUBUCZKZCDRBQRVBACBUD
      VIVBBCQDVFQEZVGDEZUJZVBVIVHFGZHGZDEVLVNVFUKGZHGZDVLVMVOHVFVGUESVJVPDEVKVJ
      VPVFDVJVFVJVFVFUFZUGUHVQTUITVIVAVNDVIUTVMHAVHFLSOULUMUNUOVCUSUPUQUR $.

    $( The von Mangoldt function is nonnegative.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    vmage0 $p |- ( A e. NN -> 0 <_ ( Lam ` A ) ) $=
      ( cn wcel cc0 cvma cfv cle wbr ce c1 ef0 efvmacl nnge1d syl5eqbr cr vmacl
      wb 0re efle sylancr mpbird ) ABCZDAEFZGHZDIFZUCIFZGHZUBUEJUFGKUBUFALMNUBD
      OCUCOCUDUGQRAPDUCSTUA $.

    $( Value of the second Chebyshev function, or summary von Mangoldt
       function.  (Contributed by Mario Carneiro, 7-Apr-2016.) $)
    chpval $p |- ( A e. RR ->
      ( psi ` A ) = sum_ n e. ( 1 ... ( |_ ` A ) ) ( Lam ` n ) ) $=
      ( vx c1 cv cfl cfv cfz co cvma csu cr cchp wceq fveq2 oveq2d df-chp sumex
      sumeq1d fvmpt ) CADCEZFGZHIZBEJGZBKDAFGZHIZUDBKLMUAANZUCUFUDBUGUBUEDHUAAF
      OPSCBQUFUDBRT $.

    $( Functionality of the second Chebyshev function.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    chpf $p |- psi : RR --> RR $=
      ( vx vn cr c1 cv cfl cfv cfz co cvma csu cchp df-chp wcel fzfid wa elfznn
      cn adantl vmacl syl fsumrecl fmpti ) ACCDAEZFGZHIZBEZJGZBKLABMUDCNZUFUHBU
      IDUEOUIUGUFNZPUGRNZUHCNUJUKUIUGUEQSUGTUAUBUC $.

    $( Closure for the second Chebyshev function.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    chpcl $p |- ( A e. RR -> ( psi ` A ) e. RR ) $=
      ( cr cchp chpf ffvelrni ) BBACDE $.

    $( The second Chebyshev function is closed in the log-integers.
       (Contributed by Mario Carneiro, 7-Apr-2016.) $)
    efchpcl $p |- ( A e. RR -> ( exp ` ( psi ` A ) ) e. NN ) $=
      ( vn cr wcel cchp cfv ce c1 cfl cfz co cv cvma csu cn chpval fveq2d fzfid
      wa syl elfznn adantl vmacl efvmacl efnnfsumcl eqeltrd ) ACDZAEFZGFHAIFZJK
      ZBLZMFZBNZGFOUGUHUMGABPQUGUJULBUGHUIRUGUKUJDZSZUKODZULCDUNUPUGUKUIUAUBZUK
      UCTUOUPULGFODUQUKUDTUEUF $.

    $( The second Chebyshev function is nonnegative.  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    chpge0 $p |- ( A e. RR -> 0 <_ ( psi ` A ) ) $=
      ( cr wcel cc0 cchp cfv cle wbr ce c1 ef0 efchpcl nnge1d syl5eqbr wb chpcl
      0re efle sylancr mpbird ) ABCZDAEFZGHZDIFZUBIFZGHZUAUDJUEGKUAUEALMNUADBCU
      BBCUCUFOQAPDUBRST $.

    $( Value of the prime pi function.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    ppival $p |- ( A e. RR ->
      ( ppi ` A ) = ( # ` ( ( 0 [,] A ) i^i Prime ) ) ) $=
      ( vx cc0 cv cicc co cprime cin chash cfv cr cppi wceq oveq2 ineq1d fveq2d
      df-ppi fvex fvmpt ) BACBDZEFZGHZIJCAEFZGHZIJKLTAMZUBUDIUEUAUCGTACENOPBQUD
      IRS $.

    $( Value of the prime pi function.  (Contributed by Mario Carneiro,
       18-Sep-2014.) $)
    ppival2 $p |- ( A e. ZZ ->
      ( ppi ` A ) = ( # ` ( ( 2 ... A ) i^i Prime ) ) ) $=
      ( cz wcel cppi cfv cc0 cicc co cprime cin chash c2 cfz cr wceq zre ppival
      syl cfl eqtrd ppisval flid oveq2d ineq1d fveq2d ) ABCZADEZFAGHIJZKEZLAMHZ
      IJZKEUFANCZUGUIOAPZAQRUFUHUKKUFUHLASEZMHZIJZUKUFULUHUPOUMAUARUFUOUJIUFUNA
      LMAUBUCUDTUET $.

    $( Value of the prime pi function.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    ppival2g $p |- ( ( A e. ZZ /\ 2 e. ( ZZ>= ` M ) ) ->
      ( ppi ` A ) = ( # ` ( ( M ... A ) i^i Prime ) ) ) $=
      ( cz wcel c2 cuz cfv wa cppi cc0 cicc co cprime cin chash cfz wceq adantr
      cr eqtrd zre ppival syl cfl ppisval2 sylan flid oveq2d ineq1d fveq2d ) AC
      DZEBFGDZHZAIGZJAKLMNZOGZBAPLZMNZOGUMASDZUNUPQUKUSULAUAZRAUBUCUMUOUROUMUOB
      AUDGZPLZMNZURUKUSULUOVCQUTABUEUFUKVCURQULUKVBUQMUKVAABPAUGUHUIRTUJT $.

    $( Domain and range of the prime pi function.  (Contributed by Mario
       Carneiro, 15-Sep-2014.) $)
    ppif $p |- ppi : RR --> NN0 $=
      ( vx cr cn0 cc0 cv cicc co cprime cin chash cppi df-ppi wcel ppifi hashcl
      cfv cfn syl fmpti ) ABCDAEZFGHIZJPZKALTBMUAQMUBCMTNUAORS $.

    $( Real closure of the prime pi function.  (Contributed by Mario Carneiro,
       15-Sep-2014.) $)
    ppicl $p |- ( A e. RR -> ( ppi ` A ) e. NN0 ) $=
      ( cr cn0 cppi ppif ffvelrni ) BCADEF $.

    $( The value of the M&ouml;bius function.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    muval $p |- ( A e. NN -> ( mmu ` A ) = if ( E. p e. Prime ( p ^ 2 ) || A ,
      0 , ( -u 1 ^ ( # ` { p e. Prime | p || A } ) ) ) ) $=
      ( vx cv c2 cexp co cdivides wbr cprime wrex cc0 c1 cneg crab chash cfv cn
      cif breq2 cmu wceq rexbidv rabbidv fveq2d oveq2d ifbieq2d df-mu c0ex ovex
      ifex fvmpt ) CABDZEFGZCDZHIZBJKZLMNZUMUOHIZBJOZPQZFGZSUNAHIZBJKZLURUMAHIZ
      BJOZPQZFGZSRUAUOAUBZUQVDVBVHLVIUPVCBJUOAUNHTUCVIVAVGURFVIUTVFPVIUSVEBJUOA
      UMHTUDUEUFUGCBUHVDLVHUIURVGFUJUKUL $.

    $( The value of the M&ouml;bius function at a non-squarefree number.
       (Contributed by Mario Carneiro, 21-Sep-2014.) $)
    muval1 $p |- ( ( A e. NN /\ P e. ( ZZ>= ` 2 ) /\ ( P ^ 2 ) || A ) ->
      ( mmu ` A ) = 0 ) $=
      ( vp cn wcel c2 cfv cexp co cdivides wbr cprime wrex c1 wceq wa adantl cz
      cc0 zsqcl cuz w3a cmu cv cneg crab chash muval 3ad2ant1 exprmfct 3ad2ant2
      cif wb prmnn simpl2 eluz2b2 sylib simpld dvdssqlem syl2anc simpl3 wi prmz
      clt eluzelz 3syl simpl1 nnzd dvdstr syl3anc mpan2d sylbid reximdva iftrue
      syl mpd eqtrd ) ADEZBFUAGEZBFHIZAJKZUBZAUCGZCUDZFHIZAJKZCLMZSNUEWDAJKCLUF
      UGGHIZULZSVRVSWCWIOWAACUHUIWBWGWISOWBWDBJKZCLMZWGVSVRWKWABCUJUKWBWJWFCLWB
      WDLEZPZWJWEVTJKZWFWMWDDEZBDEZWJWNUMWLWOWBWDUNQWMWPNBVDKZWMVSWPWQPVRVSWAWL
      UOZBUPUQURWDBUSUTWMWNWAWFVRVSWAWLVAWMWEREZVTREZAREWNWAPWFVBWMWDREZWSWLXAW
      BWDVCQWDTVOWMVSBREWTWRFBVEBTVFWMAVRVSWAWLVGVHWEVTAVIVJVKVLVMVPWGSWHVNVOVQ
      $.

    $( The value of the M&ouml;bius function at a squarefree number.
       (Contributed by Mario Carneiro, 3-Oct-2014.) $)
    muval2 $p |- ( ( A e. NN /\ ( mmu ` A ) =/= 0 ) ->
        ( mmu ` A ) = ( -u 1 ^ ( # ` { p e. Prime | p || A } ) ) ) $=
      ( cn wcel cmu cfv cc0 wne c1 cneg cv cdivides cprime crab cexp co wceq wo
      wbr eqeq1d chash wn df-ne wrex cif ifeqor muval orbi12d mpbiri ord syl5bi
      c2 imp ) ACDZAEFZGHZUOIJBKZALSBMNUAFOPZQZUPUOGQZUBUNUSUOGUCUNUTUSUNUTUSRU
      QULOPALSBMUDZGURUEZGQZVBURQZRVAGURUFUNUTVCUSVDUNUOVBGABUGZTUNUOVBURVETUHU
      IUJUKUM $.

    $( Two ways to say that a number is not squarefree.  (Contributed by Mario
       Carneiro, 3-Oct-2014.) $)
    isnsqf $p |- ( A e. NN ->
      ( ( mmu ` A ) = 0 <-> E. p e. Prime ( p ^ 2 ) || A ) ) $=
      ( cn wcel cmu cfv cc0 wceq cv c2 cexp co cdivides wbr cprime wrex wne syl
      c1 neeq1d wn cneg crab chash cif cz cfn cn0 prmdvdsfi hashcl nn0zd neg1cn
      ax-1ne0 negne0i expne0i mp3an12 iffalse syl5ibrcom muval sylibrd necon4bd
      cc ax-1cn iftrue eqeq1d syl5ibr impbid ) ACDZAEFZGHZBIZJKLAMNBOPZVHVLVIGV
      HVLUAZVLGSUBZVKAMNBOUCZUDFZKLZUEZGQZVIGQVHVSVMVQGQZVHVPUFDZVTVHVPVHVOUGDV
      PUHDABUIVOUJRUKVNVBDVNGQWAVTULSVCUMUNVNVPUOUPRVMVRVQGVLGVQUQTURVHVIVRGABU
      SZTUTVAVLVJVHVRGHVLGVQVDVHVIVRGWBVEVFVG $.

    $( Two ways to say that a number is squarefree.  (Contributed by Mario
       Carneiro, 3-Oct-2014.) $)
    issqf $p |- ( A e. NN ->
      ( ( mmu ` A ) =/= 0 <-> A. p e. Prime ( p pCnt A ) <_ 1 ) ) $=
      ( cn wcel cmu cfv cc0 c2 co wbr cprime wn c1 cle wral cn0 sylancr syl5bbr
      wb cr wne cv cexp cdivides wrex cpc isnsqf necon3abid ralnex wa clt caddc
      1nn0 pccl ancoms nn0ltp1le 1re nn0red ltnle df-2 breq1i cz id nnz pcdvdsb
      2nn0 mp3an3 syl2anr 3bitr3d con1bid ralbidva bitrd ) ACDZAEFZGUABUBZHUCIA
      UDJZBKUEZLZVOAUFIZMNJZBKOZVMVQVNGABUGUHVRVPLZBKOVMWAVPBKUIVMWBVTBKVMVOKDZ
      UJZVTVPWDMVSUKJZMMULIZVSNJZVTLZVPWDMPDVSPDZWEWGSUMWCVMWIVOAUNUOZMVSUPQWDM
      TDVSTDWEWHSUQWDVSWJURMVSUSQWGHVSNJZWDVPHWFVSNUTVAWCWCAVBDZWKVPSZVMWCVCAVD
      WCWLHPDWMVFHVOAVEVGVHRVIVJVKRVL $.

    $( The prime count of a squarefree number is at most 1.  (Contributed by
       Mario Carneiro, 1-Jul-2015.) $)
    sqfpc $p |- ( ( A e. NN /\ ( mmu ` A ) =/= 0 /\ P e. Prime ) ->
        ( P pCnt A ) <_ 1 ) $=
      ( vp cn wcel cmu cfv cc0 wne cprime cpc co c1 cle wbr wa cv wral wi issqf
      biimpa wceq oveq1 breq1d rspccv syl 3impia ) ADEZAFGHIZBJEZBAKLZMNOZUHUIP
      CQZAKLZMNOZCJRZUJULSUHUIUPACTUAUOULCBJUMBUBUNUKMNUMBAKUCUDUEUFUG $.

    $( A divisor of a squarefree number is squarefree.  (Contributed by Mario
       Carneiro, 1-Jul-2015.) $)
    dvdssqf $p |- ( ( A e. NN /\ B e. NN /\ B || A ) ->
       ( ( mmu ` A ) =/= 0 -> ( mmu ` B ) =/= 0 ) ) $=
      ( vp cn wcel cdivides wbr w3a cmu cfv cc0 cv cprime wrex wceq nnzd isnsqf
      wa cz wb c2 cexp co simpl3 wi prmz adantl zsqcl syl simpl2 simpl1 syl3anc
      dvdstr mpan2d reximdva 3ad2ant2 3ad2ant1 3imtr4d necon3d ) ADEZBDEZBAFGZH
      ZBIJZKAIJZKVCCLZUAUBUCZBFGZCMNZVGAFGZCMNZVDKOZVEKOZVCVHVJCMVCVFMEZRZVHVBV
      JUTVAVBVNUDVOVGSEZBSEASEVHVBRVJUEVOVFSEZVPVNVQVCVFUFUGVFUHUIVOBUTVAVBVNUJ
      PVOAUTVAVBVNUKPVGBAUMULUNUOVAUTVLVITVBBCQUPUTVAVMVKTVBACQUQURUS $.

    $( A squarefree number is completely determined by the set of its prime
       divisors.  (Contributed by Mario Carneiro, 1-Jul-2015.) $)
    sqf11 $p |- ( ( ( A e. NN /\ ( mmu ` A ) =/= 0 ) /\
      ( B e. NN /\ ( mmu ` B ) =/= 0 ) ) -> ( A = B <->
        A. p e. Prime ( p || A <-> p || B ) ) ) $=
      ( cn wcel cmu cfv cc0 wne wa wceq cpc co cprime wbr wb cn0 wo c1 syl2anr
      cv wral cdivides nnnn0 pc11 syl2an ad2ant2r eleq1 dfbi3 cle simpll adantr
      simpllr simpr sqfpc syl3anc nnle1eq1 syl5ibcom simplrr anim12d eqtr3 syl6
      wn simprl id pccl elnn0 sylib jaod syl5bi impbid2 pcelnn bibi12d ralbidva
      ord bitrd ) ADEZAFGHIZJZBDEZBFGHIZJZJZABKZCUAZALMZWEBLMZKZCNUBZWEAUCOZWEB
      UCOZPZCNUBVQVTWDWIPZVRWAVQAQEBQEWMVTAUDBUDABCUEUFUGWCWHWLCNWCWENEZJZWHWFD
      EZWGDEZPZWLWOWHWRWFWGDUHWRWPWQJZWPVCZWQVCZJZRWOWHWPWQUIWOWSWHXBWOWSWFSKZW
      GSKZJWHWOWPXCWQXDWOWFSUJOZWPXCWOVQVRWNXEWCVQWNVQVRWBUKZULVQVRWBWNUMWCWNUN
      ZAWEUOUPWFUQURWOWGSUJOZWQXDWOVTWAWNXHWCVTWNVSVTWAVDZULVSVTWAWNUSXGBWEUOUP
      WGUQURUTWFWGSVAVBWOXBWFHKZWGHKZJWHWOWTXJXAXKWOWPXJWOWFQEZWPXJRWNWNVQXLWCW
      NVEZXFWEAVFTWFVGVHVOWOWQXKWOWGQEZWQXKRWNWNVTXNWCXMXIWEBVFTWGVGVHVOUTWFWGH
      VAVBVIVJVKWOWPWJWQWKWNWNVQWPWJPWCXMXFWEAVLTWNWNVTWQWKPWCXMXIWEBVLTVMVPVNV
      P $.

    $( The M&ouml;bius function is a function into the integers.  (Contributed
       by Mario Carneiro, 22-Sep-2014.) $)
    muf $p |- mmu : NN --> ZZ $=
      ( vx vp cn cz cv c2 cexp co cdivides wbr cprime wrex cc0 c1 cneg crab cfv
      chash wcel sylancr cif cmu df-mu 0z cn0 znegcl ax-mp cfn prmdvdsfi hashcl
      1z syl zexpcl ifcl fmpti ) ACDBEZFGHAEZIJBKLZMNOZUPUQIJBKPZRQZGHZUAZUBABU
      CUQCSZMDSVBDSZVCDSUDVDUSDSZVAUESZVENDSVFUKNUFUGVDUTUHSVGUQBUIUTUJULUSVAUM
      TURMVBDUNTUO $.

    $( Closure of the M&ouml;bius function.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    mucl $p |- ( A e. NN -> ( mmu ` A ) e. ZZ ) $=
      ( cn cz cmu muf ffvelrni ) BCADEF $.

    $( The value of the divisor function.  (Contributed by Mario Carneiro,
       22-Sep-2014.)  (Revised by Mario Carneiro, 21-Jun-2015.) $)
    sgmval $p |- ( ( A e. CC /\ B e. NN ) ->
      ( A sigma B ) = sum_ k e. { p e. NN | p || B } ( k ^c A ) ) $=
      ( vx vn cc cn cv cdivides wbr crab ccxp co csu csgm wceq wa simpr breq2d
      rabbidv wcel simpll oveq2d sumeq12dv df-sgm sumex ovmpt2a ) EFABGHDIZFIZJ
      KZDHLZCIZEIZMNZCOUIBJKZDHLZUMAMNZCOPUNAQZUJBQZRZULUQUOURCVAUKUPDHVAUJBUIJ
      USUTSTUAVAUMULUBZRUNAUMMUSUTVBUCUDUEECFDUFUQURCUGUH $.

    $( The value of the divisor function.  (Contributed by Mario Carneiro,
       21-Jun-2015.) $)
    sgmval2 $p |- ( ( A e. ZZ /\ B e. NN ) ->
      ( A sigma B ) = sum_ k e. { p e. NN | p || B } ( k ^ A ) ) $=
      ( cz wcel cn wa csgm co cv cdivides wbr crab ccxp csu cexp cc wceq zcn
      sgmval sylan ssrab2 simpr sseldi nncnd nnne0d simpll cxpexpzd sumeq2dv
      eqtrd ) AEFZBGFZHZABIJZDKBLMZDGNZCKZAOJZCPZUQURAQJZCPULARFUMUOUTSATABCDUA
      UBUNUQUSVACUNURUQFZHZURAVCURVCUQGURUPDGUCUNVBUDUEZUFVCURVDUGULUMVBUHUIUJU
      K $.

    $( The value of the sum-of-divisors function, usually denoted
       &sigma;<SUB>0</SUB>(<i>n</i>).  (Contributed by Mario Carneiro,
       21-Jun-2015.) $)
    0sgm $p |- ( A e. NN -> ( 0 sigma A ) = ( # ` { p e. NN | p || A } ) ) $=
      ( vk cn wcel cc0 csgm co cv cdivides wbr crab cexp csu chash c1 cmul wceq
      cfv cfn cz 0z sgmval2 mpan elrabi nncnd exp0d sumeq2i cfz wss fzfid sgmss
      cc ssfi syl2anc ax-1cn fsumconst sylancl syl5eq cn0 hashcl nn0cnd mulid1d
      syl 3eqtrd ) ADEZFAGHZBIAJKZBDLZCIZFMHZCNZVIOSZPQHZVMFUAEVFVGVLRUBFACBUCU
      DVFVLVIPCNZVNVIVKPCVJVIEZVJVPVJVHBVJDUEUFUGUHVFVITEZPUMEVOVNRVFPAUIHZTEVI
      VRUJVQVFPAUKABULVRVIUNUOZUPVIPCUQURUSVFVMVFVMVFVQVMUTEVSVIVAVDVBVCVE $.

    $( The divisor function is a function into the complex numbers.
       (Contributed by Mario Carneiro, 22-Sep-2014.)  (Revised by Mario
       Carneiro, 21-Jun-2015.) $)
    sgmf $p |- sigma : ( CC X. NN ) --> CC $=
      ( vp vn vk vx cv cdivides wbr cn crab ccxp co csu cc wcel wral csgm wf c1
      cxp cfn wa cfz fzfid sgmss adantl ssfi syl2anc elrabi nncnd simpl syl2anr
      wss cxpcl fsumcl rgen2 df-sgm fmpt2 mpbi ) AEBEZFGZAHIZCEZDEZJKZCLZMNZBHO
      DMOMHSMPQVFDBMHVCMNZUSHNZUAZVAVDCVIRUSUBKZTNVAVJULZVATNVIRUSUCVHVKVGUSAUD
      UEVJVAUFUGVBVANZVBMNVGVDMNVIVLVBUTAVBHUHUIVGVHUJVBVCUMUKUNUODBMHVEMPDCBAU
      PUQUR $.

    $( Closure of the divisor function.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    sgmcl $p |- ( ( A e. CC /\ B e. NN ) -> ( A sigma B ) e. CC ) $=
      ( cc cn csgm sgmf fovcl ) ABCCDEFG $.

    $( Closure of the divisor function.  (Contributed by Mario Carneiro,
       21-Jun-2015.) $)
    sgmnncl $p |- ( ( A e. NN0 /\ B e. NN ) -> ( A sigma B ) e. NN ) $=
      ( vp vk cn0 wcel cn wa csgm co cv cdivides wbr crab cexp csu cz c1 adantl
      cfn wceq nn0z sgmval2 sylan cc0 clt cfz wss fzfid sgmss ssfi elrabi simpl
      syl2anc nnexpcl syl2anr nnzd fsumzcl wne wrex nnz iddvds syl breq1 rspcev
      c0 mpdan rabn0 sylibr nnrpd fsumrpcl rpgt0d elnnz sylanbrc eqeltrd ) AEFZ
      BGFZHZABIJZCKZBLMZCGNZDKZAOJZDPZGVPAQFVQVSWEUAAUBABDCUCUDVRWEQFUEWEUFMWEG
      FVRWBWDDVRRBUGJZTFWBWFUHZWBTFVRRBUIVQWGVPBCUJSWFWBUKUNZVRWCWBFZHZWDWIWCGF
      VPWDGFVRWACWCGULVPVQUMWCAUOUPZUQURVRWEVRWBWDDWHVQWBVFUSZVPVQWACGUTZWLVQBB
      LMZWMVQBQFWNBVABVBVCWAWNCBGVTBBLVDVEVGWACGVHVISWJWDWKVJVKVLWEVMVNVO $.

    $( The M&ouml;bius function takes on values in magnitude at most ` 1 ` .
       (Together with ~ mucl , this implies that it takes a value in
       ` { -u 1 , 0 , 1 } ` for every natural number.)  (Contributed by Mario
       Carneiro, 22-Sep-2014.) $)
    mule1 $p |- ( A e. NN -> ( abs ` ( mmu ` A ) ) <_ 1 ) $=
      ( vp wcel cexp co cdivides wbr cprime cfv cabs c1 cle cc0 sylan9eq fveq2d
      wa syl6eqbr wceq syl eqtrd cn cv c2 wrex cmu cneg crab chash muval iftrue
      cif abs0 eqbrtri wn iffalse cc cn0 neg1cn prmdvdsfi hashcl absexp sylancr
      0le1 cfn ax-1cn absnegi abs1 eqtri oveq1i cz 1exp syl5eq adantr pm2.61dan
      nn0zd 1le1 ) AUACZBUBZUCDEAFGBHUDZAUEIZJIZKLGVQVSPZWAMJIZKLWBVTMJVQVSVTVS
      MKUFZVRAFGBHUGZUHIZDEZUKZMABUIZVSMWGUJNOWCMKLULVCUMQVQVSUNZPZWAKKLWKWAWGJ
      IZKWKVTWGJVQWJVTWHWGWIVSMWGUONOVQWLKRWJVQWLWDJIZWFDEZKVQWDUPCWFUQCZWLWNRU
      RVQWEVDCWOABUSWEUTSZWDWFVAVBVQWNKWFDEZKWMKWFDWMKJIKKVEVFVGVHVIVQWFVJCWQKR
      VQWFWPVOWFVKSVLTVMTVPQVN $.

    $( The Chebyshev function does not change off the integers.  (Contributed
       by Mario Carneiro, 22-Sep-2014.) $)
    chtfl $p |- ( A e. RR -> ( theta ` ( |_ ` A ) ) = ( theta ` A ) ) $=
      ( vp cr wcel cc0 cfl cfv cicc co cprime cin csu ccht cfz wceq ppisval syl
      c2 3eqtr4d chtval cv clog flidm oveq2d ineq1d reflcl sumeq1d ) ACDZEAFGZH
      IJKZBUAUBGZBLZEAHIJKZUKBLUIMGZAMGUHUJUMUKBUHRUIFGZNIZJKZRUINIZJKUJUMUHUPU
      RJUHUOUIRNAUCUDUEUHUICDZUJUQOAUFZUIPQAPSUGUHUSUNULOUTUIBTQABTS $.

    $( The second Chebyshev function does not change off the integers.
       (Contributed by Mario Carneiro, 9-Apr-2016.) $)
    chpfl $p |- ( A e. RR -> ( psi ` ( |_ ` A ) ) = ( psi ` A ) ) $=
      ( vx cr wcel c1 cfl cfv cfz co cv cvma csu cchp flidm oveq2d sumeq1d wceq
      reflcl chpval syl 3eqtr4d ) ACDZEAFGZFGZHIZBJKGZBLZEUCHIZUFBLUCMGZAMGUBUE
      UHUFBUBUDUCEHANOPUBUCCDUIUGQARUCBSTABSUA $.

    $( The prime pi function at a prime.  (Contributed by Mario Carneiro,
       19-Sep-2014.) $)
    ppiprm $p |- ( ( A e. ZZ /\ ( A + 1 ) e. Prime ) ->
      ( ppi ` ( A + 1 ) ) = ( ( ppi ` A ) + 1 ) ) $=
      ( cz wcel c1 caddc co cprime wa c2 cfz cin cun chash cfv cppi wceq adantr
      syl cuz cn csn cfn wn wss fzfid inss1 ssfi sylancl cle wbr clt cr peano2z
      zre ltp1d zred ltnled mpbid sseli elfzle2 nsyl cvv ovex hashunsng syl2anc
      wi ax-mp ppival2 cmin 2z cc zcn ax-1cn pncan prmuz2 uz2m1nn eqeltrrd nnuz
      adantl 2m1e1 fveq2i eqtr4i fzsuc2 sylancr ineq1d indir syl6eq simpr snssd
      syl6eleq df-ss sylib uneq2d eqtrd fveq2d oveq1d 3eqtr4d ) ABCZADEFZGCZHZI
      AJFZGKZWSUAZLZMNZXCMNZDEFZWSONZAONZDEFXAXCUBCZWSXCCZUCZXFXHPZXAXBUBCXCXBU
      DXKXAIAUEXBGUFZXBXCUGUHXAWSAUIUJZXLXAAWSUKUJXPUCXAAWRAULCWTAUNQZUOXAAWSXQ
      XAWSWRWSBCZWTAUMQZUPUQURXLWSXBCXPXCXBWSXOUSWSIAUTRVAWSVBCXKXMHXNVFADEVCXC
      WSVBVDVGVEXAXIIWSJFZGKZMNZXFXAXRXIYBPXSWSVHRXAYAXEMXAYAXCXDGKZLZXEXAYAXBX
      DLZGKYDXAXTYEGXAIBCAIDVIFZSNZCXTYEPVJXAATYGXAWSDVIFZATXAAVKCZDVKCYHAPWRYI
      WTAVLQVMADVNUHXAWSISNCZYHTCWTYJWRWSVOVSWSVPRVQTDSNYGVRYFDSVTWAWBWJIAWCWDW
      EXBXDGWFWGXAYCXDXCXAXDGUDYCXDPXAWSGWRWTWHWIXDGWKWLWMWNWOWNXAXJXGDEWRXJXGP
      WTAVHQWPWQ $.

    $( The prime pi function at a non-prime.  (Contributed by Mario Carneiro,
       19-Sep-2014.) $)
    ppinprm $p |- ( ( A e. ZZ /\ -. ( A + 1 ) e. Prime ) ->
      ( ppi ` ( A + 1 ) ) = ( ppi ` A ) ) $=
      ( vx cz wcel c1 co cprime wn wa c2 cfz cin chash cfv cppi sseldi cuz wceq
      cn adantr caddc cv csn inss2 simprr simprl nelne2 syl2anc elsn necon3bbii
      wne sylibr cun wo inss1 cmin 2z cc zcn pncan sylancl elfzuz2 uz2m1nn 3syl
      ax-1cn eqeltrrd 2m1e1 fveq2i eqtr4i syl6eleq fzsuc2 sylancr eleqtrd sylib
      nnuz elun ord mt3d elin sylanbrc expr ssrdv wss uzid peano2uz fzss2 ssrin
      4syl eqssd fveq2d peano2z ppival2 syl 3eqtr4d ) ACDZAEUAFZGDHZIZJWPKFZGLZ
      MNZJAKFZGLZMNZWPONZAONZWRWTXCMWRWTXCWRBWTXCWOWQBUBZWTDZXGXCDZWOWQXHIZIZXG
      XBDZXGGDZXIXKXLXGWPUCZDZXKXGWPUKZXOHXKXMWQXPXKWTGXGWSGUDWOWQXHUEZPZWOWQXH
      UFXGWPGUGUHXOXGWPBWPUIUJULXKXLXOXKXGXBXNUMZDXLXOUNXKXGWSXSXKWTWSXGWSGUOXQ
      PZXKJCDAJEUPFZQNZDWSXSRUQXKASYBXKWPEUPFZASXKAURDZEURDYCARWOYDXJAUSTVEAEUT
      VAXKXGWSDWPJQNDYCSDXTXGJWPVBWPVCVDVFSEQNYBVOYAEQVGVHVIVJJAVKVLVMXGXBXNVPV
      NVQVRXRXGXBGVSVTWAWBWRAAQNZDZWPYEDXBWSWCXCWTWCWOYFWQAWDTAAWEAJWPWFXBWSGWG
      WHWIWJWRWPCDZXEXARWOYGWQAWKTWPWLWMWOXFXDRWQAWLTWN $.

    $( The Chebyshev function at a prime.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    chtprm $p |- ( ( A e. ZZ /\ ( A + 1 ) e. Prime ) ->
      ( theta ` ( A + 1 ) ) = ( ( theta ` A ) + ( log ` ( A + 1 ) ) ) ) $=
      ( vp cz wcel c1 caddc co cprime cfv c2 cfz cin clog csu wceq adantr eqtrd
      syl cuz cn wa ccht cv csn cc0 cicc cr peano2z zre chtval cfl ppisval flid
      oveq2d ineq1d sumeq1d wn c0 cle wbr ltp1d ltnled mpbid inss1 elfzle2 nsyl
      clt sseli disjsn sylibr cun cmin 2z cc ax-1cn pncan sylancl prmuz2 adantl
      zcn uz2m1nn eqeltrrd nnuz 2m1e1 fveq2i eqtr4i fzsuc2 sylancr indir syl6eq
      syl6eleq wss simpr snssd df-ss sylib uneq2d fzfid ssfi inss2 sseldi prmnn
      nnrpd relogcld recnd fsumsplit eqtr2d fveq2 sumsn syl2anc oveq12d 3eqtrd
      cfn ) ACDZAEFGZHDZUAZXOUBIZJXOKGZHLZBUCZMIZBNZJAKGZHLZYBBNZXOUDZYBBNZFGAU
      BIZXOMIZFGXQXRUEXOUFGHLZYBBNZYCXQXOUGDZXRYLOXQXOCDZYMXNYNXPAUHPZXOUIRZXOB
      UJRXQYKXTYBBXQYKJXOUKIZKGZHLZXTXQYMYKYSOYPXOULRXQYRXSHXQYQXOJKXQYNYQXOOYO
      XOUMRUNUOQUPQXQYEYGYBXTBXQXOYEDZUQYEYGLUROXQXOAUSUTZYTXQAXOVGUTUUAUQXQAXN
      AUGDZXPAUIPZVAXQAXOUUCYPVBVCYTXOYDDUUAYEYDXOYDHVDVHXOJAVERVFYEXOVIVJXQXTY
      EYGHLZVKZYEYGVKXQXTYDYGVKZHLUUEXQXSUUFHXQJCDAJEVLGZSIZDXSUUFOVMXQATUUHXQX
      OEVLGZATXQAVNDZEVNDUUIAOXNUUJXPAVTPVOAEVPVQXQXOJSIDZUUITDXPUUKXNXOVRVSXOW
      ARWBTESIUUHWCUUGESWDWEWFWKJAWGWHUOYDYGHWIWJXQUUDYGYEXQYGHWLUUDYGOXQXOHXNX
      PWMWNYGHWOWPWQQXQXSXMDXTXSWLXTXMDXQJXOWRXSHVDXSXTWSVQXQYAXTDZUAZYBUUMYAUU
      MYAUUMYAHDYATDUUMXTHYAXSHWTXQUULWMXAYAXBRXCXDXEXFXQYFYIYHYJFXQYIUEAUFGHLZ
      YBBNZYFXQUUBYIUUOOUUCABUJRXQUUNYEYBBXQUUNJAUKIZKGZHLZYEXQUUBUUNUUROUUCAUL
      RXQUUQYDHXQUUPAJKXNUUPAOXPAUMPUNUOQUPXGXQXOTDZYJVNDYHYJOXPUUSXNXOXBVSZXQY
      JXQXOXQXOUUTXCXDXEYBYJBXOTYAXOMXHXIXJXKXL $.

    $( The Chebyshev function at a non-prime.  (Contributed by Mario Carneiro,
       19-Sep-2014.) $)
    chtnprm $p |- ( ( A e. ZZ /\ -. ( A + 1 ) e. Prime ) ->
      ( theta ` ( A + 1 ) ) = ( theta ` A ) ) $=
      ( vp vx cz wcel c1 co cprime wa cin cfv c2 cfz cuz wceq cn adantr 3eqtr4d
      3syl syl caddc wn cc0 cicc clog csu ccht cfl csn wne simprr sseldi simprl
      cv inss2 nelne2 syl2anc elsn necon3bbii sylibr wo inss1 cmin 2z cc ax-1cn
      cun zcn pncan sylancl elfzuz2 uz2m1nn eqeltrrd nnuz 2m1e1 fveq2i syl6eleq
      eqtr4i fzsuc2 sylancr eleqtrd elun sylib ord mt3d elin sylanbrc ssrdv wss
      expr uzid peano2uz fzss2 ssrin 4syl eqssd peano2z flid oveq2d cr peano2re
      ineq1d zre ppisval sumeq1d chtval ) ADEZAFUAGZHEUBZIZUCXHUDGHJZBUNUEKZBUF
      ZUCAUDGHJZXLBUFZXHUGKZAUGKZXJXKXNXLBXJLXHUHKZMGZHJZLAUHKZMGZHJZXKXNXJLXHM
      GZHJZLAMGZHJZXTYCXJYEYGXJCYEYGXGXICUNZYEEZYHYGEZXGXIYIIZIZYHYFEZYHHEZYJYL
      YMYHXHUIZEZYLYHXHUJZYPUBYLYNXIYQYLYEHYHYDHUOXGXIYIUKZULZXGXIYIUMYHXHHUPUQ
      YPYHXHCXHURUSUTYLYMYPYLYHYFYOVGZEYMYPVAYLYHYDYTYLYEYDYHYDHVBYRULZYLLDEALF
      VCGZNKZEYDYTOVDYLAPUUCYLXHFVCGZAPYLAVEEZFVEEUUDAOXGUUEYKAVHQVFAFVIVJYLYHY
      DEXHLNKEUUDPEUUAYHLXHVKXHVLSVMPFNKUUCVNUUBFNVOVPVRVQLAVSVTWAYHYFYOWBWCWDW
      EYSYHYFHWFWGWJWHXJAANKZEZXHUUFEYFYDWIYGYEWIXGUUGXIAWKQAAWLALXHWMYFYDHWNWO
      WPXJXSYDHXJXRXHLMXJXHDEZXRXHOXGUUHXIAWQQXHWRTWSXBXJYBYFHXJYAALMXGYAAOXIAW
      RQWSXBRXJAWTEZXHWTEZXKXTOXGUUIXIAXCQZAXAZXHXDSXJUUIXNYCOUUKAXDTRXEXJUUIUU
      JXPXMOUUKUULXHBXFSXJUUIXQXOOUUKABXFTR $.

    $( The second Chebyshev function at a successor.  (Contributed by Mario
       Carneiro, 11-Apr-2016.) $)
    chpp1 $p |- ( A e. NN0 ->
      ( psi ` ( A + 1 ) ) = ( ( psi ` A ) + ( Lam ` ( A + 1 ) ) ) ) $=
      ( vn wcel c1 caddc co cfz cvma cfv csu cchp cn cr syl wceq chpval cz flid
      cfl oveq2d cn0 cv cmin nn0p1nn nnuz syl6eleq wa elfznn adantl vmacl recnd
      cuz fveq2 fsumm1 nn0re peano2re 3syl nn0z peano2zd sumeq1d eqtrd cc nn0cn
      ax-1cn pncan sylancl eqtr4d oveq1d 3eqtr4d ) AUACZDADEFZGFZBUBZHIZBJZDVKD
      UCFZGFZVNBJZVKHIZEFVKKIZAKIZVSEFVJVNVSBDVKVJVKLDULIAUDUEUFVJVMVLCZUGZVNWC
      VMLCZVNMCWBWDVJVMVKUHUIVMUJNUKVMVKHUMUNVJVTDVKSIZGFZVNBJZVOVJAMCZVKMCVTWG
      OAUOZAUPVKBPUQVJWFVLVNBVJWEVKDGVJVKQCWEVKOVJAAURZUSVKRNTUTVAVJWAVRVSEVJWA
      DASIZGFZVNBJZVRVJWHWAWMOWIABPNVJWLVQVNBVJWKVPDGVJWKAVPVJAQCWKAOWJARNVJAVB
      CDVBCVPAOAVCVDADVEVFVGTUTVAVHVI $.

    $( The Chebyshev function is weakly increasing.  (Contributed by Mario
       Carneiro, 22-Sep-2014.) $)
    chtwordi $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
      ( theta ` A ) <_ ( theta ` B ) ) $=
      ( vp cr wcel cle wbr cc0 cicc co cprime cin cfv csu ccht syl wss a1i wceq
      wa w3a cv clog cfn simp2 ppifi cn c1 clt c2 cuz inss2 simpr sseldi prmuz2
      eluz2b2 sylib simpld nnred simprd rplogcld rpred rpge0d 0re 0le0 syl22anc
      simp3 iccss ssrin fsumless chtval 3ad2ant1 3brtr4d ) ADEZBDEZABFGZUAZHAIJ
      ZKLZCUBZUCMZCNZHBIJZKLZWACNZAOMZBOMZFVQWDWAVSCVQVOWDUDEVNVOVPUEZBUFPVQVTW
      DEZTZWAWJVTWJVTWJVTUGEZUHVTUIGZWJVTUJUKMEZWKWLTWJVTKEWMWJWDKVTWCKULVQWIUM
      UNVTUOPVTUPUQZURUSWJWKWLWNUTVAZVBWJWAWOVCVQVRWCQZVSWDQVQHDEZVOHHFGZVPWPWQ
      VQVDRWHWRVQVERVNVOVPVGHBHAVHVFVRWCKVIPVJVNVOWFWBSVPACVKVLVQVOWGWESWHBCVKP
      VM $.

    $( The second Chebyshev function is weakly increasing.  (Contributed by
       Mario Carneiro, 9-Apr-2016.) $)
    chpwordi $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
      ( psi ` A ) <_ ( psi ` B ) ) $=
      ( vn cr wcel cle wbr w3a c1 cfl cfv cfz co cvma csu cchp syl wceq chpval
      cv fzfid wa elfznn adantl vmacl cc0 vmage0 cuz wss flword2 fzss2 fsumless
      cn 3ad2ant1 3ad2ant2 3brtr4d ) ADEZBDEZABFGZHZIAJKZLMZCTZNKZCOZIBJKZLMZVD
      COZAPKZBPKZFUTVGVDVBCUTIVFUAUTVCVGEZUBZVCUMEZVDDEVKVMUTVCVFUCUDZVCUEQVLVM
      UFVDFGVNVCUGQUTVFVAUHKEVBVGUIABUJVAIVFUKQULUQURVIVERUSACSUNURUQVJVHRUSBCS
      UOUP $.

    $( The difference of the Chebyshev function at two points sums the
       logarithms of the primes in an interval.  (Contributed by Mario
       Carneiro, 22-Sep-2014.) $)
    chtdif $p |- ( N e. ( ZZ>= ` M ) -> ( ( theta ` N ) - ( theta ` M ) ) =
      sum_ p e. ( ( ( M + 1 ) ... N ) i^i Prime ) ( log ` p ) ) $=
      ( cfv wcel co c2 wbr cfz cprime cin csu wceq syl sylancl ineq1d eqtrd cfn
      cz c0 cuz ccht cmin cle cif cv clog c1 caddc cc0 cicc eluzelre chtval cfl
      cr eluzel2 2z ifcl a1i zred min2 eluz2 syl3anbrc ppisval2 syl2anc eluzelz
      2re flid oveq2d sumeq1d clt ltp1d fzdisj inindir incom eqtri 3eqtr3g min1
      in0 cun id elfzuzb sylanbrc fzsplit indir syl6eq wss fzfid inss1 wa inss2
      ssfi simpr sseldi prmnn nnrpd relogcld recnd fsumsplit oveq12d fzfi mp2an
      cn cc ssun1 syl5sseqr sselda syldan fsumcl ssun2 pncan2d ) BAUADEZBUBDZAU
      BDZUCFAGUDHZAGUEZAIFZJKZCUFZUGDZCLZAUHUIFZBIFZJKZXTCLZUIFZYAUCFYEXLXMYFXN
      YAUCXLXMUJBUKFJKZXTCLZYFXLBUOEZXMYHMABULZBCUMNXLYHXPBIFZJKZXTCLYFXLYGYLXT
      CXLYGXPBUNDZIFZJKZYLXLYIGXPUADZEZYGYOMYJXLXPSEZGSEZXPGUDHZYQXLASEZYSYRABU
      PZUQXOAGSUROZYSXLUQUSXLAUOEZGUOEZYTXLAUUBUTZVGAGVAOXPGVBVCZBXPVDVEXLYNYKJ
      XLYMBXPIXLBSEYMBMABVFBVHNVIPQVJXLXRYDXTYLCXLXQYCKZJKTJKZXRYDKTXLUUHTJXLAY
      BVKHUUHTMXLAUUFVLXPAYBBVMNPXQYCJVNUUIJTKTTJVOJVSVPVQXLYLXQYCVTZJKXRYDVTZX
      LYKUUJJXLAYKEZYKUUJMXLAYPEZXLUULXLYRUUAXPAUDHZUUMUUCUUBXLUUDUUEUUNUUFVGAG
      VROXPAVBVCXLWAAXPBWBWCAXPBWDNPXQYCJWEWFZXLYKREYLYKWGYLREXLXPBWHYKJWIYKYLW
      LOXLXSYLEZWJZXTUUQXSUUQXSUUQXSJEXSXCEUUQYLJXSYKJWKXLUUPWMWNXSWONWPWQWRZWS
      QQXLXNUJAUKFJKZXTCLZYAXLUUDXNUUTMUUFACUMNXLUUSXRXTCXLUUSXPAUNDZIFZJKZXRXL
      UUDYQUUSUVCMUUFUUGAXPVDVEXLUVBXQJXLUVAAXPIXLUUAUVAAMUUBAVHNVIPQVJQWTXLYAY
      EXLXRXTCXRREZXLXQREXRXQWGUVDXPAXAXQJWIXQXRWLXBUSXLXSXREUUPXTXDEZXLXRYLXSX
      LUUKXRYLXRYDXEUUOXFXGUURXHXIXLYDXTCYDREZXLYCREYDYCWGUVFYBBXAYCJWIYCYDWLXB
      USXLXSYDEUUPUVEXLYDYLXSXLUUKYDYLYDXRXJUUOXFXGUURXHXIXKQ $.

    $( The exponentiated Chebyshev function forms a divisibility chain between
       any two points.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    efchtdvds $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
      ( exp ` ( theta ` A ) ) || ( exp ` ( theta ` B ) ) ) $=
      ( vx vp cr wcel ccht cfv ce co cn cc wceq recnd cprime fveq2 eleq1d elrab
      wa cc0 vy vz cle wbr w3a cdivides cdiv cmin chtcl 3ad2ant2 3ad2ant1 efsub
      cz syl2anc cv crab cfl c1 caddc cfz cin clog csu chtfl oveq12d cuz chtdif
      flword2 syl eqtr3d wss ssrab2 ax-resscn sstri simpll simprl readdcld cmul
      a1i efadd nnmulcl ad2ant2l eqeltrd sylanbrc syl2anb adantl cfn fzfid ssfi
      inss1 sylancl inss2 simpr sseldi prmnn nnrpd relogcld reeflogd 0re syl6eq
      1nn ef0 mpbir2an fsumcllem simprbi eqeltrrd wne wb efchtcl nnne0d syl3anc
      nnzd dvdsval2 mpbird ) AEFZBEFZABUCUDZUEZAGHZIHZBGHZIHZUFUDZYBXTUGJZUMFZX
      RYDXRYAXSUHJZIHZYDKXRYALFXSLFYGYDMXRYAXPXOYAEFXQBUIUJNXRXSXOXPXSEFXQAUIUK
      NYAXSULUNXRYFCUOZIHZKFZCEUPZFZYGKFZXRYFAUQHZURUSJZBUQHZUTJZOVAZDUOZVBHZDV
      CZYKXRYPGHZYNGHZUHJZYFUUAXRUUBYAUUCXSUHXPXOUUBYAMXQBVDUJXOXPUUCXSMXQAVDUK
      VEXRYPYNVFHFUUDUUAMABVHYNYPDVGVIVJXRUAUBYRYTYKDYKLVKXRYKELYJCEVLVMVNVSUAU
      OZYKFZUBUOZYKFZSUUEUUGUSJZYKFZXRUUFUUEEFZUUEIHZKFZSZUUGEFZUUGIHZKFZSZUUJU
      UHYJUUMCUUEEYHUUEMYIUULKYHUUEIPQRYJUUQCUUGEYHUUGMYIUUPKYHUUGIPQRUUNUURSZU
      UIEFUUIIHZKFZUUJUUSUUEUUGUUKUUMUURVOZUUNUUOUUQVPZVQUUSUUTUULUUPVRJZKUUSUU
      ELFUUGLFUUTUVDMUUSUUEUVBNUUSUUGUVCNUUEUUGVTUNUUMUUQUVDKFUUKUUOUULUUPWAWBW
      CYJUVACUUIEYHUUIMYIUUTKYHUUIIPQRWDWEWFXRYQWGFYRYQVKYRWGFXRYOYPWHYQOWJYQYR
      WIWKXRYSYRFZSZYTEFYTIHZKFZYTYKFUVFYSUVFYSUVFYSOFYSKFUVFYROYSYQOWLXRUVEWMW
      NYSWOVIZWPZWQUVFUVGYSKUVFYSUVJWRUVIWCYJUVHCYTEYHYTMYIUVGKYHYTIPQRWDTYKFZX
      RUVKTEFURKFZWSXAYJUVLCTEYHTMZYIURKUVMYITIHURYHTIPXBWTQRXCVSXDWCYLYFEFYMYJ
      YMCYFEYHYFMYIYGKYHYFIPQRXEVIXFXLXRXTUMFXTTXGYBUMFYCYEXHXRXTXOXPXTKFXQAXIU
      KZXLXRXTUVNXJXRYBXPXOYBKFXQBXIUJXLXTYBXMXKXN $.
  $}

  $( The prime pi function does not change off the integers.  (Contributed by
     Mario Carneiro, 18-Sep-2014.) $)
  ppifl $p |- ( A e. RR -> ( ppi ` ( |_ ` A ) ) = ( ppi ` A ) ) $=
    ( cr wcel cc0 cicc co cprime cin chash cfv c2 cfl cfz ppisval fveq2d ppival
    cppi cz wceq flcl ppival2 syl 3eqtr4rd ) ABCZDAEFGHZIJKALJZMFGHZIJZAQJUFQJZ
    UDUEUGIANOAPUDUFRCUIUHSATUFUAUBUC $.

  $( The prime pi function cannot locally increase faster than the identity
     function.  (Contributed by Mario Carneiro, 21-Sep-2014.) $)
  ppip1le $p |- ( A e. RR -> ( ppi ` ( A + 1 ) ) <_ ( ( ppi ` A ) + 1 ) ) $=
    ( cr wcel cfl cfv c1 caddc co cppi cle cz wa wceq cn0 peano2re adantr ppicl
    syl nn0red ppifl wbr flcl cprime zre ppiprm eqle syl2anc wn ppinprm eqbrtrd
    lep1d pm2.61dan 1z fladdz mpan2 fveq2d eqtr3d oveq1d 3brtr3d ) ABCZADEZFGHZ
    IEZVAIEZFGHZAFGHZIEZAIEZFGHJUTVAKCZVCVEJUAZAUBVIVBUCCZVJVIVKLZVCBCVCVEMVJVL
    VCVLVBBCZVCNCVIVMVKVIVABCZVMVAUDZVAORPVBQRSVAUEVCVEUFUGVIVKUHZLZVCVDVEJVAUI
    VQVDVIVDBCVPVIVDVIVNVDNCVOVAQRSPUKUJULRUTVFDEZIEZVCVGUTVRVBIUTFKCVRVBMUMAFU
    NUOUPUTVFBCVSVGMAOVFTRUQUTVDVHFGATURUS $.

  $( The prime pi function is weakly increasing.  (Contributed by Mario
     Carneiro, 19-Sep-2014.) $)
  ppiwordi $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
    ( ppi ` A ) <_ ( ppi ` B ) ) $=
    ( cr wcel cle wbr cc0 cicc cprime cin chash cfv cppi cfn wss ppifi 3ad2ant1
    co syl a1i w3a cdom simp2 0re 0le0 simp3 iccss syl22anc ssdomg sylc hashdom
    ssrin wb syl2anc mpbird wceq ppival 3brtr4d ) ACDZBCDZABEFZUAZGAHRZIJZKLZGB
    HRZIJZKLZAMLZBMLZEVBVEVHEFZVDVGUBFZVBVGNDZVDVGOZVLVBUTVMUSUTVAUCZBPSZVBVCVF
    OZVNVBGCDZUTGGEFZVAVQVRVBUDTVOVSVBUETUSUTVAUFGBGAUGUHVCVFIULSVDVGNUIUJVBVDN
    DZVMVKVLUMUSUTVTVAAPQVPVDVGNUKUNUOUSUTVIVEUPVAAUQQVBUTVJVHUPVOBUQSUR $.

  $( The difference of the prime pi function at two points counts the number of
     primes in an interval.  (Contributed by Mario Carneiro, 21-Sep-2014.) $)
  ppidif $p |- ( N e. ( ZZ>= ` M ) -> ( ( ppi ` N ) - ( ppi ` M ) ) =
    ( # ` ( ( ( M + 1 ) ... N ) i^i Prime ) ) ) $=
    ( cfv wcel cmin co c2 cle wbr cfz cprime cin chash cz wceq sylancl c0 mp2an
    syl cfn cuz cppi cif c1 caddc cun eluzelz eluzel2 2z ifcl a1i zred 2re min2
    cr eluz2 syl3anbrc ppival2g syl2anc min1 id elfzuzb sylanbrc fzsplit ineq1d
    indir syl6eq fveq2d clt ltp1d fzdisj inindir incom eqtri 3eqtr3g fzfi inss1
    in0 wss ssfi hashun mp3an12 3eqtrd oveq12d cn0 hashcl ax-mp nn0cni pncan2
    cc ) BAUACDZBUBCZAUBCZEFAGHIZAGUCZAJFZKLZMCZAUDUEFZBJFZKLZMCZUEFZWREFZXBWKW
    LXCWMWREWKWLWOBJFZKLZMCZWQXAUFZMCZXCWKBNDGWOUACZDZWLXGOABUGWKWONDZGNDZWOGHI
    ZXKWKANDZXMXLABUHZUIWNAGNUJPZXMWKUIUKWKAUODZGUODZXNWKAXPULZUMAGUNPWOGUPUQZB
    WOURUSWKXFXHMWKXFWPWTUFZKLXHWKXEYBKWKAXEDZXEYBOWKAXJDZWKYCWKXLXOWOAHIZYDXQX
    PWKXRXSYEXTUMAGUTPWOAUPUQWKVAAWOBVBVCAWOBVDSVEWPWTKVFVGVHWKWQXALZQOZXIXCOZW
    KWPWTLZKLQKLZYFQWKYIQKWKAWSVIIYIQOWKAXTVJWOAWSBVKSVEWPWTKVLYJKQLQQKVMKVRVNV
    OWQTDZXATDZYGYHWPTDWQWPVSYKWOAVPWPKVQWPWQVTRZWTTDXAWTVSYLWSBVPWTKVQWTXAVTRZ
    WQXAWAWBSWCWKXOXKWMWROXPYAAWOURUSWDWRWJDXBWJDXDXBOWRYKWRWEDYMWQWFWGWHXBYLXB
    WEDYNXAWFWGWHWRXBWIRVG $.

  $( The prime pi function at ` 1 ` .  (Contributed by Mario Carneiro,
     21-Sep-2014.) $)
  ppi1 $p |- ( ppi ` 1 ) = 0 $=
    ( c1 cppi cfv c2 cfz co cprime cin chash c0 cc0 cz wcel wceq 1z ppival2 clt
    ax-mp wbr 3eqtri 1lt2 wb 2z fzn mp2an mpbi ineq1i incom in0 fveq2i hash0 )
    ABCZDAEFZGHZICZJICKALMZULUONOAPRUNJIUNJGHGJHJUMJGADQSZUMJNZUADLMUPUQURUBUCO
    DAUDUEUFUGJGUHGUITUJUKT $.

  $( The Chebyshev function at ` 1 ` .  (Contributed by Mario Carneiro,
     22-Sep-2014.) $)
  cht1 $p |- ( theta ` 1 ) = 0 $=
    ( vp c1 ccht cfv cc0 co cprime cin csu c0 wcel 1re ax-mp c2 cfz cz 1z eqtri
    wceq 3eqtri cicc cv clog cr chtval cfl ppisval flid oveq2i clt wbr 1lt2 fzn
    wb 2z mp2an mpbi ineq1i incom in0 sumeq1i sum0 ) BCDZEBUAFGHZAUBUCDZAIZJVEA
    IEBUDKZVCVFSLBAUEMVDJVEAVDNBUFDZOFZGHZJVGVDVJSLBUGMVJJGHGJHJVIJGVINBOFZJVHB
    NOBPKZVHBSQBUHMUIBNUJUKZVKJSZULNPKVLVMVNUNUOQNBUMUPUQRURJGUSGUTTRVAVEAVBT
    $.

  ${
    $d p k $.
    $( The von Mangoldt function at ` 1 ` .  (Contributed by Mario Carneiro,
       9-Apr-2016.) $)
    vma1 $p |- ( Lam ` 1 ) = 0 $=
      ( vp vk c1 cv cexp co wceq cn wrex cprime wn cvma cfv cc0 wcel wa 1re a1i
      cr cuz clt wbr c2 prmuz2 adantr eluz2b2 sylib simpld nnred nnnn0 reexpcld
      cn0 adantl simprd cle nncnd exp1d nnge1d simpr syl6eleq leexp2ad eqbrtrrd
      nnuz ltletrd ltned neneqd nrexdv nrex wne wb isppw2 ax-mp necon1bbii mpbi
      1nn ) CADZBDZEFZGZBHIZAJIZKCLMZNGVTAJVPJOZVSBHWCVQHOZPZCVRWECVRCSOWEQRZWE
      CVPVRWFWEVPWEVPHOZCVPUAUBZWEVPUCTMOZWGWHPWCWIWDVPUDUEVPUFUGZUHZUIZWEVPVQW
      LWDVQULOWCVQUJUMUKWEWGWHWJUNWEVPCEFVPVRUOWEVPWEVPWKUPUQWEVPCVQWLWEVPWKURW
      EVQHCTMWCWDUSVCUTVAVBVDVEVFVGVHWAWBNCHOWBNVIWAVJVOCBAVKVLVMVN $.

    $( The second Chebyshev function at ` 1 ` .  (Contributed by Mario
       Carneiro, 9-Apr-2016.) $)
    chp1 $p |- ( psi ` 1 ) = 0 $=
      ( vx c1 cchp cfv cfl cfz co cv cvma csu cc0 cr wcel wceq 1re chpval ax-mp
      elfz1eq fveq2d vma1 syl6eq cz flid oveq2i eleq2s sumeq2i cuz wss cfn fzfi
      1z wo olci sumz 3eqtri ) BCDZBBEDZFGZAHZIDZAJZURKAJZKBLMUPVANOBAPQURUTKAU
      TKNUSBBFGZURUSVCMZUTBIDKVDUSBIUSBRSTUAUQBBFBUBMUQBNUKBUCQUDUEUFURBUGDUHZU
      RUIMZULVBKNVFVEBUQUJUMURABUNQUO $.

    ppi1i.m $e |- M e. NN0 $.
    ppi1i.n $e |- N = ( M + 1 ) $.
    ppi1i.p $e |- ( ppi ` M ) = K $.
    ${
      ppi1i.1 $e |- N e. Prime $.
      $( Inference form of ~ ppiprm .  (Contributed by Mario Carneiro,
         21-Sep-2014.) $)
      ppi1i $p |- ( ppi ` N ) = ( K + 1 ) $=
        ( cppi cfv c1 caddc co fveq2i cz wcel cprime wceq nn0zi eqeltrri ppiprm
        mp2an oveq1i 3eqtri ) CHIBJKLZHIZBHIZJKLZAJKLCUDHEMBNOUDPOUEUGQBDRCUDPE
        GSBTUAUFAJKFUBUC $.
    $}

    ${
      ppi2i.1 $e |- -. N e. Prime $.
      $( Inference form of ~ ppinprm .  (Contributed by Mario Carneiro,
         21-Sep-2014.) $)
      ppi2i $p |- ( ppi ` N ) = K $=
        ( cppi cfv c1 caddc co fveq2i cz wcel cprime wn wceq nn0zi eleq1i mp2an
        mtbi ppinprm 3eqtri ) CHIBJKLZHIZBHIZACUEHEMBNOUEPOZQUFUGRBDSCPOUHGCUEP
        ETUBBUCUAFUD $.
    $}
  $}

  $( The prime pi function at ` 2 ` .  (Contributed by Mario Carneiro,
     21-Sep-2014.) $)
  ppi2 $p |- ( ppi ` 2 ) = 1 $=
    ( c2 cppi cfv cc0 c1 caddc co 1nn0 df-2 ppi1 2prm ppi1i 1e0p1 eqtr4i ) ABCD
    EFGEDEAHIJKLMN $.

  $( The prime pi function at ` 3 ` .  (Contributed by Mario Carneiro,
     21-Sep-2014.) $)
  ppi3 $p |- ( ppi ` 3 ) = 2 $=
    ( c3 cppi cfv c1 caddc co c2 2nn0 df-3 ppi2 3prm ppi1i df-2 eqtr4i ) ABCDDE
    FGDGAHIJKLMN $.

  $( The Chebyshev function at ` 2 ` .  (Contributed by Mario Carneiro,
     22-Sep-2014.) $)
  cht2 $p |- ( theta ` 2 ) = ( log ` 2 ) $=
    ( c2 ccht c1 caddc co clog df-2 fveq2i cz wcel cprime wceq 1z 2prm eqeltrri
    cfv chtprm mp2an cc0 cht1 eqcomi oveq12i crp cr relogcl ax-mp recni addid2i
    2rp eqtr3i 3eqtri ) ABPCCDEZBPZCBPZULFPZDEZAFPZAULBGHCIJULKJUMUPLMAULKGNOCQ
    RSUQDEUPUQSUNUQUODUNSTUAAULFGHUBUQUQAUCJUQUDJUIAUEUFUGUHUJUK $.

  $( The Chebyshev function at ` 3 ` .  (Contributed by Mario Carneiro,
     22-Sep-2014.) $)
  cht3 $p |- ( theta ` 3 ) = ( log ` 6 ) $=
    ( c3 ccht cfv c2 c1 caddc co clog c6 df-3 fveq2i cz wcel cprime 2z eqeltrri
    wceq 3prm mp2an crp chtprm cmul 2rp 3re 3pos elrpii relogmul 3t2e6 mulcomli
    3cn 2cn cht2 eqcomi oveq12i 3eqtr3ri 3eqtri ) ABCDEFGZBCZDBCZUQHCZFGZIHCZAU
    QBJKDLMUQNMURVAQOAUQNJRPDUASDAUBGZHCZDHCZAHCZFGZVBVADTMATMVDVGQUCAUDUEUFDAU
    GSVCIHADIUJUKUHUIKVEUSVFUTFUSVEULUMAUQHJKUNUOUP $.

  $( Closure of the prime pi function in the positive integers.  (Contributed
     by Mario Carneiro, 21-Sep-2014.) $)
  ppinncl $p |- ( ( A e. RR /\ 2 <_ A ) -> ( ppi ` A ) e. NN ) $=
    ( cr wcel c2 cle wbr wa cppi cfv cz c1 cn0 ppicl adantr nn0zd ppi2 ppiwordi
    cn 2re mp3an1 syl5eqbrr elnnz1 sylanbrc ) ABCZDAEFZGZAHIZJCKUGEFUGRCUFUGUDU
    GLCUEAMNOUFKDHIZUGEPDBCUDUEUHUGEFSDAQTUAUGUBUC $.

  $( Closure of the Chebyshev function in the positive reals.  (Contributed by
     Mario Carneiro, 22-Sep-2014.) $)
  chtrpcl $p |- ( ( A e. RR /\ 2 <_ A ) -> ( theta ` A ) e. RR+ ) $=
    ( cr wcel c2 cle wbr wa ccht cfv chtcl adantr cc0 clog 0re a1i crp clt mp1i
    c1 2re 1lt2 rplogcl mp2an rpre rpgt0 cht2 chtwordi mp3an1 syl5eqbrr ltletrd
    elrpd ) ABCZDAEFZGZAHIZULUOBCUMAJKZUNLDMIZUOLBCUNNOUQPCZUQBCUNDBCZSDQFURTUA
    DUBUCZUQUDRUPURLUQQFUNUTUQUERUNUQDHIZUOEUFUSULUMVAUOEFTDAUGUHUIUJUK $.

  $( The prime pi function is zero iff its argument is less than ` 2 ` .
     (Contributed by Mario Carneiro, 22-Sep-2014.) $)
  ppieq0 $p |- ( A e. RR -> ( ( ppi ` A ) = 0 <-> A < 2 ) ) $=
    ( cr wcel cppi cfv cc0 wceq c2 clt wbr wn cle wne wb wa ex c1 adantr a1i cz
    2re lenlt mpan ppinncl nnne0d sylbird necon4bd cfl reflcl 1re caddc co fllt
    2z mpan2 biimpa df-2 syl6breq flcl 1z zleltp1 sylancl mpbird ppiwordi ppifl
    syl3anc ppi1 3brtr3d cn0 ppicl nn0le0eq0 syl mpbid impbid ) ABCZADEZFGZAHIJ
    ZVOVRVPFVOVRKZHALJZVPFMZHBCVOVTVSNUAHAUBUCVOVTWAVOVTOVPAUDUEPUFUGVOVRVQVOVR
    OZVPFLJZVQWBAUHEZDEZQDEZVPFLWBWDBCZQBCZWDQLJZWEWFLJVOWGVRAUIRWHWBUJSWBWIWDQ
    QUKULZIJZWBWDHWJIVOVRWDHIJZVOHTCVRWLNUNAHUMUOUPUQURWBWDTCZQTCWIWKNVOWMVRAUS
    RUTWDQVAVBVCWDQVDVFVOWEVPGVRAVERWFFGWBVGSVHWBVPVICZWCVQNVOWNVRAVJRVPVKVLVMP
    VN $.

  $( The prime pi function is strictly less than the identity.  (Contributed by
     Mario Carneiro, 22-Sep-2014.) $)
  ppiltx $p |- ( A e. RR+ -> ( ppi ` A ) < A ) $=
    ( wcel cfv cn cppi clt wbr cc0 wceq wa cr cn0 syl adantr c2 cfz co cfn cle
    c1 crp cfl rpre ppicl nn0red reflcl cprime cin chash csdm wpss fzfi wss wne
    inss1 cuz 2nn nnuz eleqtri fzss1 mp1i wn simpr syl6eleq eluzfz1 1lt2 ltnlei
    1re 2re mpbi elfzle1 mto nelne1 sylancl necomd df-pss sylanbrc sspsstr php3
    sylancr wb ssfi mp2an hashsdom sylibr cz flcld ppival2 ppifl rpge0 flge0nn0
    eqtr3d syl2anc hashfz1 3brtr3d flle ltletrd fveq2d 2pos ppieq0 ax-mp syl6eq
    0re mpbir rpgt0 eqbrtrd wo elnn0 sylib mpjaodan ) AUABZAUBCZDBZAECZAFGXLHIZ
    XKXMJZXNXLAXKXNKBXMXKXNXKAKBZXNLBAUCZAUDMUENXKXLKBZXMXKXQXSXRAUFMNXKXQXMXRN
    ZXPOXLPQZUGUHZUICZTXLPQZUICZXNXLFXPYBYDUJGZYCYEFGZXPYDRBZYBYDUKZYFTXLULZXPY
    BYAUMZYAYDUKZYIYAUGUOZXPYAYDUMZYAYDUNYLOTUPCZBYNXPODYOUQURUSOTXLUTVAXPYDYAX
    PTYDBZTYABZVBYDYAUNXPXLYOBYPXPXLDYOXKXMVCURVDTXLVEMYQOTSGZTOFGYRVBVFTOVHVIV
    GVJTOXLVKVLTYDYAVMVNVOYAYDVPVQYBYAYDVRVTYDYBVSVTYBRBZYHYGYFWAYARBYKYSOXLULY
    MYAYBWBWCYJYBYDWDWCWEXKYCXNIXMXKXLECZYCXNXKXLWFBYTYCIXKAXRWGXLWHMXKXQYTXNIZ
    XRAWIMZWLNXKYEXLIZXMXKXLLBZUUCXKXQHASGUUDXRAWJAWKWMZXLWNMNWOXPXQXLASGXTAWPM
    WQXKXOJZXNHAFUUFYTXNHXKUUAXOUUBNUUFYTHECZHUUFXLHEXKXOVCWRUUGHIZHOFGZWSHKBUU
    HUUIWAXCHWTXAXDXBWLXKHAFGXOAXENXFXKUUDXMXOXGUUEXLXHXIXJ $.

  ${
    $d k n p $.  $d k p A $.  $d k F $.
    prmorcht.1 $e |- F = ( n e. NN |-> if ( n e. Prime , n , 1 ) ) $.
    $( Relate the primorial (product of the first ` n ` primes) to the
       Chebyshev function.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    prmorcht $p |- ( A e. NN ->
      ( exp ` ( theta ` A ) ) = ( seq 1 ( x. , F ) ` A ) ) $=
      ( vk cn wcel cfv ce cprime clog cc0 cif c1 co csu wceq syl eqtrd cc caddc
      vp ccht cv cmpt cseq cmul cfz cin cicc cr nnre chtval cfl c2 cuz 2nn nnuz
      eleqtri ppisval2 sylancl cz nnz flid oveq2d ineq1d sumeq1d wss wral inss1
      sseli wa elfznn adantl nnrpd relogcld recnd sylan2 ralrimiva wo fzfi olci
      cfn sumss2 mpan2 sylancr elin baibr ifbid sumeq2i syl6eqr eleq1 ifbieq12d
      fveq2 eqidd eqid fvex elexi ifex fvmpt elnnuz biimpi fsumser fveq2d addcl
      0cn ifcl eqeltrd efadd 1nn reeflogd fvif ifeq2 ax-mp eqtri id vex 3eqtr4d
      log1 seqhomo ) AFGZAUCHZIHAUABFBUDZJGZYCKHZLMZUEZNUFHZIHAUGCNUFHYAYBYHIYA
      YBNAUHOZEUDZJGZYJKHZLMZEPZYHYAYBYIYJYIJUIZGZYLLMZEPZYNYAYBLAUJOJUIZYLEPZY
      RYAAUKGZYBYTQAULZAEUMRYAYTYOYLEPZYRYAYSYOYLEYAYSNAUNHZUHOZJUIZYOYAUUAUONU
      PHZGYSUUFQUUBUOFUUGUQURUSANUTVAYAUUEYIJYAUUDANUHYAAVBGUUDAQAVCAVDRVEVFSVG
      YAYOYIVHZYLTGZEYOVIZUUCYRQZYIJVJZYAUUIEYOYPYAYJYIGZUUIYOYIYJUULVKYAUUMVLZ
      YLUUNYJUUNYJUUMYJFGZYAYJAVMVNZVOVPVQZVRVSUUHUUJVLYIUUGVHZYIWCGZVTUUKUUSUU
      RNAWAWBYOYIYLENWDWEWFSSYIYMYQEUUMYKYPYLLYPUUMYKYJYIJWGWHWIWJWKYAYMEYGNAUU
      NUUOYJYGHZYMQUUPBYJYFYMFYGYCYJQZYDYKYELYLLYCYJJWLZYCYJKWNUVALWOWMYGWPYKYL
      LYJKWQLTXFWRWSWTRZYAAUUGGAXAXBZUUNUUILTGYMTGUUQXFYKYLLTXGVAZXCSXDYAEUBUAU
      GTYGCINAYJTGUBUDZTGVLZYJUVFUAOZTGYAYJUVFXEVNUUNUUTYMTUVCUVEXHUVDUVGUVHIHY
      JIHUVFIHUGOQYAYJUVFXIVNUUNYKYJNMZKHZIHUVIUUTIHYJCHZUUNUVIUUNUVIUUNUUONFGU
      VIFGUUPXJYKYJNFXGVAVOXKUUNUUTUVJIUUNUUTYMUVJUVCUVJYKYLNKHZMZYMYKYJNKXLUVL
      LQUVMYMQXSYKUVLLYLXMXNXOWKXDUUNUUOUVKUVIQUUPBYJYDYCNMUVIFCUVAYDYKYCNYJNUV
      BUVAXPUVANWOWMDYKYJNEXQNFXJWRWSWTRXRXTS $.
  $}

  ${
    $d p A $.  $d p B $.
    $( Lemma for ~ mumul .  A multiple of a non-squarefree number is
       non-squarefree.  (Contributed by Mario Carneiro, 3-Oct-2014.) $)
    mumullem1 $p |- ( ( ( A e. NN /\ B e. NN ) /\ ( mmu ` A ) = 0 ) ->
      ( mmu ` ( A x. B ) ) = 0 ) $=
      ( vp cn wcel wa cmu cfv cc0 wceq co cdivides wbr cprime cz syl nnz isnsqf
      wrex wb cmul cv c2 cexp wi prmz adantl zsqcl ad2antrr ad2antlr dvdsmultr1
      syl3anc reximdva adantr nnmulcl 3imtr4d imp ) ADEZBDEZFZAGHIJZABUAKZGHIJZ
      UTCUBZUCUDKZALMZCNSZVEVBLMZCNSZVAVCUTVFVHCNUTVDNEZFZVEOEZAOEZBOEZVFVHUEVK
      VDOEZVLVJVOUTVDUFUGVDUHPURVMUSVJAQUIUSVNURVJBQUJVEABUKULUMURVAVGTUSACRUNU
      TVBDEVCVITABUOVBCRPUPUQ $.

    $( Lemma for ~ mumul .  The product of two coprime squarefree numbers is
       squarefree.  (Contributed by Mario Carneiro, 3-Oct-2014.) $)
    mumullem2 $p |- ( ( ( A e. NN /\ B e. NN /\ ( A gcd B ) = 1 ) /\
      ( ( mmu ` A ) =/= 0 /\ ( mmu ` B ) =/= 0 ) ) ->
      ( mmu ` ( A x. B ) ) =/= 0 ) $=
      ( vp wcel co c1 wceq cc0 wne wa cpc cle wbr cprime wral cr 1re cc sylancr
      wb cn cgcd w3a cmu cfv cmul cv r19.26 caddc wi simpr simpl1 nn0red simpl2
      pccld a1i le2add syl22anc cmin wn ax-1ne0 cif simpl3 oveq2d cz nnzd pcgcd
      syl3anc pc1 adantl 3eqtr3d ifid ifeq12 syl5eqr eqeq1d syl5ibrcom necon3ad
      mpi ax-1cn recnd subeq0 anbi12d mtbird adantr eqcom readdcli recni syl6bb
      nn0addcld addsub4d bitr3d subge0 resubcl add20 an4s syl2anc sylbird bitrd
      imp syl5bb necon3abid mpbird jcad clt nnz nnne0 jca syl pcmul breq1d 1nn0
      ex nn0leltp1 sylancl ltlen 3bitrd sylibrd ralimdva syl5bir issqf bi2anan9
      cn0 3adant3 nnmulcl 3imtr4d ) AUADZBUADZABUBEZFGZUCZAUDUEHIZBUDUEHIZJZABU
      FEZUDUEHIZYJCUGZAKEZFLMZCNOZYPBKEZFLMZCNOZJZYPYNKEZFLMZCNOZYMYOUUCYRUUAJZ
      CNOYJUUFYRUUACNUHYJUUGUUECNYJYPNDZJZUUGYQYTUIEZFFUIEZLMZUUKUUJIZJZUUEUUIU
      UGUULUUMUUIYQPDZYTPDZFPDZUUQUUGUULUJUUIYQUUIYPAYJUUHUKZYFYGYIUUHULZUOZUMZ
      UUIYTUUIYPBUURYFYGYIUUHUNZUOZUMZUUQUUIQUPZUVEYQYTFFUQURUUIUUGUUMUUIUUGJZU
      UMFYQUSEZHGZFYTUSEZHGZJZUTZUUIUVLUUGUUIUVKFYQGZFYTGZJZUUIFHIUVOUTVAUUIUVO
      FHUUIFHGUVOYQYTLMZYQYTVBZHGUUIYPYHKEZYPFKEZUVQHUUIYHFYPKYFYGYIUUHVCVDUUIU
      UHAVEDZBVEDZUVRUVQGUURUUIAUUSVFUUIBUVBVFABYPVGVHUUHUVSHGYJYPVIVJVKUVOFUVQ
      HUVOFUVPFFVBUVQUVPFVLUVPFYQFYTVMVNVOVPVQVRUUIUVHUVMUVJUVNUUIFRDZYQRDUVHUV
      MTVSUUIYQUVAVTZFYQWASUUIUWBYTRDUVJUVNTVSUUIYTUVDVTZFYTWASWBWCWDUVFUVKUUKU
      UJUUKUUJGZUUJUUKGZUVFUVKUUKUUJWEZUVFUWFUVGUVIUIEZHGZUVKUUIUWFUWITUUGUUIUU
      KUUJUSEZHGZUWFUWIUUIUWKUWEUWFUUIUUKRDUUJRDUWKUWETUUKFFQQWFZWGUUIUUJUUIUUJ
      UUIYQYTUUTUVCWIZUMZVTUUKUUJWASUWGWHUUIUWJUWHHUUIFFYQYTUUIFUVEVTZUWOUWCUWD
      WJVOWKWDUUIUUGUWIUVKTZUUIUUGHUVGLMZHUVILMZJZUWPUUIUWQYRUWRUUAUUIUUQUUOUWQ
      YRTQUVAFYQWLSUUIUUQUUPUWRUUATQUVDFYTWLSWBUUIUVGPDZUVIPDZUWSUWPUJUUIUUQUUO
      UWTQUVAFYQWMSUUIUUQUUPUXAQUVDFYTWMSUWTUXAJUWSUWPUWTUWQUXAUWRUWPUVGUVIWNWO
      XLWPWQWSWRWTXAXBXLXCUUIUUEUUJFLMZUUJUUKXDMZUUNUUIUUDUUJFLUUIUUHUVTAHIZJZU
      WABHIZJZUUDUUJGUURUUIYFUXEUUSYFUVTUXDAXEAXFXGXHUUIYGUXGUVBYGUWAUXFBXEBXFX
      GXHABYPXIVHXJUUIUUJYBDFYBDUXBUXCTUWMXKUUJFXMXNUUIUUJPDUUKPDUXCUUNTUWNUWLU
      UJUUKXOXNXPXQXRXSYFYGYMUUCTYIYFYKYSYGYLUUBACXTBCXTYAYCYJYNUADZYOUUFTYFYGU
      XHYIABYDYCYNCXTXHYEWS $.

    $( The M&ouml;bius function is a multiplicative function.  This is one of
       the primary interests of the M&ouml;bius function as an arithmetic
       function.  (Contributed by Mario Carneiro, 3-Oct-2014.) $)
    mumul $p |- ( ( A e. NN /\ B e. NN /\ ( A gcd B ) = 1 ) ->
      ( mmu ` ( A x. B ) ) = ( ( mmu ` A ) x. ( mmu ` B ) ) ) $=
      ( vp cn wcel co c1 wceq cmul cmu cfv cc0 syl cdivides wbr cprime crab wss
      wa cz cgcd w3a simpl2 mucl zcnd mul02d oveq1d mumullem1 3adantl3 3eqtr4rd
      simpr simpl1 mul01d oveq2d nncn mulcom syl2an fveq2d adantr ancom1s eqtrd
      cc wne cneg chash cexp nnmulcld mumullem2 muval2 syl2anc caddc neg1cn a1i
      cv cfn cn0 fzfi prmnn ssriv rabss2 ax-mp sgmss syl5ss ssfi sylancr hashcl
      cfz expaddd cun wo wb adantlr euclemma syl3anc rabbidva unrab syl6eqr cin
      nnzd c0 inrab wn wral nprmdvds1 adantl prmz dvdsgcd simpll3 breq2d sylibd
      wi ralrimiva rabeq0 sylibr syl5eq hashun simprl simprr eqtr4d pm2.61da2ne
      mtod oveq12d ) ADEZBDEZABUAFZGHZUBZABIFZJKZAJKZBJKZIFZHYJLYKLYGYJLHZSZLYK
      IFLYLYIYNYKYNYKYNYDYKTEYCYDYFYMUCBUDMUEUFYNYJLYKIYGYMUKUGYCYDYMYILHZYFABU
      HUIUJYGYKLHZSZYJLIFLYLYIYQYJYQYJYQYCYJTEYCYDYFYPULAUDMUEUMYQYKLYJIYGYPUKU
      NYCYDYPYOYFYCYDSZYPSYIBAIFZJKZLYRYIYTHYPYRYHYSJYCAVBEBVBEYHYSHYDAUOBUOABU
      PUQURUSYDYCYPYTLHBAUHUTVAUIUJYGYJLVCZYKLVCZSZSZYIGVDZCVNZYHNOZCPQZVEKZVFF
      ZYLUUDYHDEYILVCYIUUJHUUDABYCYDYFUUCULZYCYDYFUUCUCZVGABVHYHCVIVJUUDUUEUUFA
      NOZCPQZVEKZUUFBNOZCPQZVEKZVKFZVFFUUEUUOVFFZUUEUURVFFZIFUUJYLUUDUUEUUOUURU
      UEVBEUUDVLVMUUDUUQVOEZUURVPEUUDGBWGFZVOEUUQUVCRUVBGBVQUUDUUQUUPCDQZUVCPDR
      ZUUQUVDRCPDUUFVRVSZUUPCPDVTWAUUDYDUVDUVCRUULBCWBMWCUVCUUQWDWEZUUQWFMUUDUU
      NVOEZUUOVPEUUDGAWGFZVOEUUNUVIRUVHGAVQUUDUUNUUMCDQZUVIUVEUUNUVJRUVFUUMCPDV
      TWAUUDYCUVJUVIRUUKACWBMWCUVIUUNWDWEZUUNWFMWHUUDUUIUUSUUEVFUUDUUIUUNUUQWIZ
      VEKZUUSUUDUUHUVLVEUUDUUHUUMUUPWJZCPQUVLUUDUUGUVNCPUUDUUFPEZSZUVOATEZBTEZU
      UGUVNWKUUDUVOUKYGUVOUVQUUCYGUVOSZAYCYDYFUVOULWSWLZYGUVOUVRUUCUVSBYCYDYFUV
      OUCWSWLZUUFABWMWNWOUUMUUPCPWPWQURUUDUVHUVBUUNUUQWRZWTHUVMUUSHUVKUVGUUDUWB
      UUMUUPSZCPQZWTUUMUUPCPXAUUDUWCXBZCPXCUWDWTHUUDUWECPUVPUWCUUFGNOZUVOUWFXBU
      UDUUFXDXEUVPUWCUUFYENOZUWFUVPUUFTEZUVQUVRUWCUWGXKUVOUWHUUDUUFXFXEUVTUWAUU
      FABXGWNUVPYEGUUFNYCYDYFUUCUVOXHXIXJYAXLUWCCPXMXNXOUUNUUQXPWNVAUNUUDYJUUTY
      KUVAIUUDYCUUAYJUUTHUUKYGUUAUUBXQACVIVJUUDYDUUBYKUVAHUULYGUUAUUBXRBCVIVJYB
      UJXSXT $.
  $}

  ${
    $d k n p q x y z G $.  $d n p q x z N $.  $d n p z S $.
    sqff1o.1 $e |- S = { x e. NN | ( ( mmu ` x ) =/= 0 /\ x || N ) } $.
    sqff1o.2 $e |- F = ( n e. S |-> { p e. Prime | p || n } ) $.
    sqff1o.3 $e |- G = ( n e. NN |-> ( p e. Prime |-> ( p pCnt n ) ) ) $.
    $( There is a bijection from the squarefree divisors of a number ` N ` to
       the powerset of the prime divisors of ` N ` .  Among other things, this
       implies that a number has ` 2 ^ k ` squarefree divisors where ` k ` is
       the number of prime divisors, and a squarefree number has ` 2 ^ k `
       divisors (because all divisors of a squarefree number are squarefree).
       The inverse function to ` F ` takes the product of all the primes in
       some subset of prime divisors of ` N ` .  (Contributed by Mario
       Carneiro, 1-Jul-2015.) $)
    sqff1o $p |- ( N e. NN -> F : S -1-1-onto-> ~P { p e. Prime | p || N } ) $=
      ( cn wcel wbr cprime c1 cc0 wa cn0 wceq cle vz vk vy vq cdivides crab cpw
      wel cif cmpt ccnv cfv wss cmu wne weq fveq2 neeq1d anbi12d elrab2 simprbi
      cv breq1 simprd ad2antlr cz prmz adantl simplr sylib simpld nnzd ad2antrr
      wi nnz dvdstr syl3anc mpan2d ss2rabdv nnex prmnn ssriv ssexi rabex sylibr
      elpw cima cfn cmap co wf wral 1nn0 0nn0 keepel rgenw eqid fmpt mpbi nn0ex
      a1i elmap cfz fzfi wfn wb ffn elpreima elequ1 ifbid elexi fvmpt eleq1d wn
      mp2b iffalse syl ax-mp adantr syl5ss sylancr elrab sylanbrc wf1o cpc ovex
      eqtr3d ralrimiva issqf mpbird pcelnn syl2anc simpr cvv cc biantrurd wo id
      adantrr bitrd biimpa sylbi 0nnn mtbiri con4i elpwi sgmss sstrd ssfi cnveq
      rabss2 imaeq1d 1arith f1ocnv f1of ffvelrni f1ocnvfv2 1arithlem1 sylan9req
      fveq1d 1le1 0le1 keephyp syl6eqbrr iftrue sselda simpll nnge1d eqbrtrd ex
      oveq1 pcge0 breq1d syl5ibrcom pm2.61d eqbrtrrd pc2dvds jca eqcom ad2antrl
      simplbi mptex fvmpt2 sylancl eqeq1d adantrl f1ocnvfvb csn cpr 0cn ax-1ne0
      ax-1cn necomi pw2f1olem ssrab2 sspwb simprr sseldi syl2anr elnn0 r19.21bi
      pccl orcomd mpbid nnle1eq1 syl5ibcom orim2d mpd elpr fmptd prex mptiniseg
      3bitr4d 1nn syl6eqel impbid2 rabbidva syl5eq eqeq2d 3bitr3d syl5bb f1o2d
      ) FKLZCUABGVBZFUEMZGNUFZUGZUYDCVBZUEMZGNUFZUBNUBUAUHZOPUIZUJZEUKZULZDIUYC
      UYHBLZQZUYJUYFUMUYJUYGLUYQUYIUYEGNUYQUYDNLZQZUYIUYHFUEMZUYEUYPUYTUYCUYRUY
      PUYHUNULZPUOZUYTUYPUYHKLZVUBUYTQZAVBZUNULZPUOZVUEFUEMZQZVUDAUYHKBACUPZVUG
      VUBVUHUYTVUJVUFVUAPVUEUYHUNUQURVUEUYHFUEVCUSHUTZVAZVDVEUYSUYDVFLZUYHVFLFV
      FLZUYIUYTQUYEVNUYRVUMUYQUYDVGVHUYSUYHUYSVUCVUDUYSUYPVUCVUDQUYCUYPUYRVIVUK
      VJVKZVLUYCVUNUYPUYRFVOZVMUYDUYHFVPVQVRVSUYJUYFUYIGNNKVTGNKUYDWAWBZWCZWDWF
      WEUYCUAVBZUYGLZQZUYOKLZUYOUNULZPUOZUYOFUEMZQZUYOBLVVAUYMUCVBZUKZKWGZWHLZU
      CRNWIWJZUFZLZVVBVVAUYMVVKLZUYMUKZKWGZWHLZVVMVVANRUYMWKZVVNVVRVVAUYLRLZUBN
      WLVVRVVSUBNUYKOPRWMWNWOWPUBNRUYLUYMUYMWQZWRWSZXARNUYMWTVURXBWEVVAOFXCWJZW
      HLVVPVWBUMVVQOFXDVVAVVPVUSVWBAVVPVUSVUEVVPLZAUAUHZOPUIZKLZVWDVWCVUENLZVUE
      UYMULZKLZQZVWFVVRUYMNXEVWCVWJXFVWANRUYMXGNVUEKUYMXHXOVWGVWIVWFVWGVWHVWEKU
      BVUEUYLVWENUYMUBAUPUYKVWDOPUBAUAXIXJVVTVWERVWDOPRWMWNWOXKXLXMUUAUUBVWDVWF
      VWDXNZVWFPKLUUCVWKVWEPKVWDOPXPXMUUDUUEXQWBVVAVUSUYFVWBVUTVUSUYFUMUYCVUSUY
      FUUFVHZVVAUYFUYEGKUFZVWBNKUMUYFVWMUMVUQUYEGNKUUKXRUYCVWMVWBUMVUTFGUUGXSXT
      UUHXTVWBVVPUUIYAVVJVVQUCUYMVVKVVGUYMSZVVIVVPWHVWNVVHVVOKVVGUYMUUJUULXMYBY
      CZVVLKUYMUYNKVVLEYDZVVLKUYNYDVVLKUYNWKVVLUCCEGJVVLWQUUMZKVVLEUUNVVLKUYNUU
      OXOUUPXQZVVAVVDVVEVVAVVDUDVBZUYOYEWJZOTMZUDNWLZVVAVXAUDNVVAVWSNLZQZVWTUDU
      AUHZOPUIZOTVXDVWSGNUYDUYOYEWJZUJZULZVXFVWTVVAVXCVXIVWSUYMULVXFVVAVWSUYMVX
      HVVAUYOEULZUYMVXHVVAVWPVVMVXJUYMSVWQVWOKVVLUYMEUUQYAVVAVVBVXJVXHSVWRCEUYO
      GJUURXQYGUUTUBVWSUYLVXFNUYMUBUDUPUYKVXEOPUBUDUAXIXJVVTVXFRVXEOPRWMWNWOXKX
      LUUSVXCVXIVWTSVVAGVWSVXGVWTNVXHUYDVWSUYOYEUVKVXHWQVWSUYOYEYFXLVHYGZVXEOOT
      MPOTMVXFOTMOPOVXFOTVCPVXFOTVCUVAUVBUVCUVDYHVVAVVBVVDVXBXFVWRUYOUDYIXQYJVV
      AVVEVWTVWSFYEWJZTMZUDNWLZVVAVXMUDNVXDVXFVWTVXLTVXKVXDVXEVXFVXLTMZVVAVXEVX
      OVNVXCVVAVXEVXOVVAVXEQZVXFOVXLTVXEVXFOSVVAVXEOPUVEVHVXPVXLVXPVXLKLZVWSFUE
      MZVXPVXCVXRVXPVWSUYFLVXCVXRQVVAVUSUYFVWSVWLUVFUYEVXRGVWSNUYDVWSFUEVCYBVJZ
      VDVXPVXCUYCVXQVXRXFVXPVXCVXRVXSVKUYCVUTVXEUVGVWSFYKYLYJUVHUVIUVJXSVXDVXOV
      XEXNZPVXLTMZVXDVXCVUNVYAVVAVXCYMUYCVUNVUTVXCVUPVMVWSFUVLYLVXTVXFPVXLTVXEO
      PXPUVMUVNUVOUVPYHVVAUYOVFLVUNVVEVXNXFVVAUYOVWRVLUYCVUNVUTVUPXSUYOFUDUVQYL
      YJUVRVUIVVFAUYOKBVUEUYOSZVUGVVDVUHVVEVYBVUFVVCPVUEUYOUNUQURVUEUYOFUEVCUSH
      UTYCUYHUYOSUYOUYHSZUYCUYPVUTQQZVUSUYJSZUYHUYOUVSVYDUYHEULZUYMSZGNUYDUYHYE
      WJZUJZUYMSZVYCVYEVYDVYFVYIUYMVYDVUCVYIYNLVYFVYISUYPVUCUYCVUTUYPVUCVUDVUKU
      WAZUVTZGNVYHVURUWBCKVYIYNEJUWCUWDUWEVYDVWPVUCVVMVYGVYCXFVWPVYDVWQXAVYLUYC
      VUTVVMUYPVWOUWFKVVLUYHUYMEUWGVQVYDVYJVUSVYIUKOUWHWGZSZVYEVYDVUSNUGZLZVYJQ
      VYIPOUWIZNWIWJLZVYNQVYJVYNVYDUBNPOVUSVYIYNYONYNLVYDVURXAPYOLVYDUWJXAOYOLV
      YDUWLXAPOUOVYDOPUWKUWMXAUWNVYDVYPVYJVYDUYGVYOVUSUYFNUMUYGVYOUMUYEGNUWOUYF
      NUWPWSUYCUYPVUTUWQUWRYPVYDVYRVYNVYDNVYQVYIWKZVYRUYCUYPVYSVUTUYQGNVYHVYQVY
      IUYSVYHPSZVYHOSZYQZVYHVYQLUYSVYTVYHKLZYQWUBUYSWUCVYTUYSVYHRLZWUCVYTYQUYRU
      YRVUCWUDUYQUYRYRUYPVUCUYCVYKVHZUYDUYHUXBUWSVYHUWTVJUXCUYSWUCWUAVYTUYSVYHO
      TMZWUCWUAUYQWUFGNUYQVUBWUFGNWLZUYPVUBUYCUYPVUBUYTVULVKVHUYQVUCVUBWUGXFWUE
      UYHGYIXQUXDUXAVYHUXEUXFZUXGUXHVYHPOUYDUYHYEYFUXIWEVYIWQZUXJYSVYQNVYIPOUXK
      VURXBWEYPUXMVYDVYMUYJVUSVYDVYMWUAGNUFZUYJORLVYMWUJSWMGNVYHOVYIRWUIUXLXRUY
      CUYPWUJUYJSVUTUYQWUAUYIGNUYSWUAWUCUYIUYSWUAWUCWUAVYHOKWUAYRUXNUXOWUHUXPUY
      SUYRVUCWUCUYIXFUYQUYRYMVUOUYDUYHYKYLYTUXQYSUXRUXSYTUXTUYAUYB $.
  $}

  ${
    $d x A $.  $d x N $.
    $( The complement of a divisor of ` N ` is also a divisor of ` N ` .
       (Contributed by Mario Carneiro, 2-Jul-2015.) $)
    dvdsdivcl $p |- ( ( N e. NN /\ A e. { x e. NN | x || N } ) ->
        ( N / A ) e. { x e. NN | x || N } ) $=
      ( cn wcel cv cdivides wbr co cz cc0 clt breq1 elrab adantl nnz syl adantr
      nngt0 sylanbrc crab wa cdiv simprbi wne wb elrabi nnne0d dvdsval2 syl3anc
      mpbid cr nnre nnred divgt0d elnnz cmul wceq cc divcan2d dvds0lem syl31anc
      nncn nncnd ) CDEZBAFZCGHZADUAZEZUBZCBUCIZDEZVKCGHZVKVHEVJVKJEZKVKLHVLVJBC
      GHZVNVIVOVEVIBDEZVOVGVOABDVFBCGMNUDOVJBJEZBKUECJEZVOVNUFVJVPVQVIVPVEVGABD
      UGOZBPQZVJBVSUHZVEVRVICPRZBCUIUJUKZVJCBVECULEVICUMRVJBVSUNVEKCLHVICSRVJVP
      KBLHVSBSQUOVKUPTVJVQVNVRBVKUQICURVMVTWCWBVJCBVECUSEVICVCRVJBVSVDWAUTBVKCV
      AVBVGVMAVKDVFVKCGMNT $.
  $}

  ${
    $d y z A $.  $d x y z N $.
    dvdsflip.a $e |- A = { x e. NN | x || N } $.
    dvdsflip.f $e |- F = ( y e. A |-> ( N / y ) ) $.
    $( An involution of the divisors of a number.  (Contributed by Stefan
       O'Rear, 12-Sep-2015.)  (Proof shortened by Mario Carneiro,
       13-May-2016.) $)
    dvdsflip $p |- ( N e. NN -> F : A -1-1-onto-> A ) $=
      ( vz cn wcel cv cdiv co wa eleq2i dvdsdivcl sylan2b wceq cc nncn cdivides
      wbr crab syl6eleqr wb ssrab2 eqsstri sseli anim12i cmul ad2antrl ad2antll
      adantr cc0 wne nnne0 divmul3d divmul2d bitr4d sylan2 eqcom 3bitr4g f1o2d
      ) EIJZBHCCEBKZLMZEHKZLMZDGVDVECJZNVFAKEUAUBZAIUCZCVIVDVEVKJVFVKJCVKVEFOAV
      EEPQFUDVDVGCJZNVHVKCVLVDVGVKJVHVKJCVKVGFOAVGEPQFUDVDVIVLNZNVHVERZVFVGRZVE
      VHRVGVFRVMVDVEIJZVGIJZNZVNVOUEVIVPVLVQCIVECVKIFVJAIUFUGZUHCIVGVSUHUIVDVRN
      ZVNEVEVGUJMRVOVTEVEVGVDESJVRETUMZVPVESJVDVQVETUKZVQVGSJVDVPVGTULZVQVGUNUO
      VDVPVGUPULUQVTEVGVEWAWCWBVPVEUNUOVDVQVEUPUKURUSUTVEVHVAVGVFVAVBVC $.
  $}

  ${
    $d j k m n x N $.  $d j k m n ph $.
    fsumdvdsdiag.1 $e |- ( ph -> N e. NN ) $.
    $( A "diagonal commutation" of divisor sums analogous to ~ fsum0diag .
       (Contributed by Mario Carneiro, 2-Jul-2015.)  (Revised by Mario
       Carneiro, 8-Apr-2016.) $)
    fsumdvdsdiaglem $p |- ( ph ->
    ( ( j e. { x e. NN | x || N } /\ k e. { x e. NN | x || ( N / j ) } ) ->
      ( k e. { x e. NN | x || N } /\ j e. { x e. NN | x || ( N / k ) } ) ) ) $=
      ( cv cdivides wbr cn crab wcel co wa elrabi breq1 elrab cz nnzd cmul cdiv
      ad2antll simprbi adantr simprl dvdsdivcl syl2anc wi dvdstr syl3anc mp2and
      syl sylanbrc ad2antrl wb nnne0d dvdsmulcr syl112anc mpbird nncnd divcan1d
      cc0 wne divcan2d eqtr4d breqtrd ssrab2 sseldi dvdscmulr mpbid jca ex ) AC
      GZBGZEHIZBJKZLZDGZVNEVMUAMZHIZBJKLZNZVRVPLZVMVNEVRUAMZHIZBJKLZNAWBNZWCWFW
      GVRJLZVREHIZWCWAWHAVQVTBVRJOUBZWGVRVSHIZVSEHIZWIWAWKAVQWAWHWKVTWKBVRJVNVR
      VSHPQUCUBZWGVSVPLZWLWGEJLZVQWNAWOWBFUDZAVQWAUEBVMEUFUGZWNVSJLZWLVOWLBVSJV
      NVSEHPQUCULWGVRRLZVSRLZERLWKWLNWIUHWGVRWJSZWGVSWGWNWRWQVOBVSJOULSZWGEWPSV
      RVSEUIUJUKVOWIBVRJVNVREHPQUMZWGVMJLZVMWDHIZWFVQXDAWAVOBVMJOUNZWGVRVMTMZVR
      WDTMZHIZXEWGXGVSVMTMZXHHWGXGXJHIZWKWMWGWSWTVMRLZVMVBVCXKWKUOXAXBWGVMXFSZW
      GVMXFUPZVMVRVSUQURUSWGXJEXHWGEVMWGEWPUTZWGVMXFUTXNVAWGEVRXOWGVRWJUTWGVRWJ
      UPZVDVEVFWGXLWDRLWSVRVBVCXIXEUOXMWGWDWGVPJWDVOBJVGWGWOWCWDVPLWPXCBVREUFUG
      VHSXAXPVRVMWDVIURVJWEXEBVMJVNVMWDHPQUMVKVL $.

    fsumdvdsdiag.2 $e |- ( ( ph /\ ( j e. { x e. NN | x || N } /\
      k e. { x e. NN | x || ( N / j ) } ) ) -> A e. CC ) $.
    $( A "diagonal commutation" of divisor sums analogous to ~ fsum0diag .
       (Contributed by Mario Carneiro, 2-Jul-2015.)  (Revised by Mario
       Carneiro, 8-Apr-2016.) $)
    fsumdvdsdiag $p |- ( ph ->
   sum_ j e. { x e. NN | x || N } sum_ k e. { x e. NN | x || ( N / j ) } A =
   sum_ k e. { x e. NN | x || N } sum_ j e. { x e. NN | x || ( N / k ) } A ) $=
      ( cv cdivides wbr cn crab cdiv co c1 cfz cfn wcel wa wss fzfid sgmss ssfi
      syl syl2anc ssrab2 dvdsdivcl sylan sseldi fsumdvdsdiaglem impbid fsumcom2
      ) ABIZFJKZBLMZUNFDIZNOZJKBLMZUPUNFEIZNOJKBLMZDECAPFQOZRSUPVBUAZUPRSAPFUBA
      FLSZVCGFBUCUEVBUPUDUFZVEAUQUPSZTZPURQOZRSUSVHUAZUSRSVGPURUBVGURLSVIVGUPLU
      RUOBLUGAVDVFURUPSGBUQFUHUIUJURBUCUEVHUSUDUFAVFUTUSSTUTUPSUQVASTABDEFGUKAB
      EDFGUKULHUM $.
  $}

  ${
    $d m u v z A $.  $d j B $.  $d j k m u v x z N $.  $d j k m u v ph $.
    fsumdvdscom.1 $e |- ( ph -> N e. NN ) $.
    fsumdvdscom.2 $e |- ( j = ( k x. m ) -> A = B ) $.
    fsumdvdscom.3 $e |- ( ( ph /\ ( j e. { x e. NN | x || N } /\
      k e. { x e. NN | x || j } ) ) -> A e. CC ) $.
    $( A double commutation of divisor sums based on ~ fsumdvdsdiag .  Note
       that ` A ` depends on both ` j ` and ` k ` .  (Contributed by Mario
       Carneiro, 13-May-2016.) $)
    fsumdvdscom $p |- ( ph ->
   sum_ j e. { x e. NN | x || N } sum_ k e. { x e. NN | x || j } A =
   sum_ k e. { x e. NN | x || N } sum_ m e. { x e. NN | x || ( N / k ) } B ) $=
      ( vu cn csu cdiv co wceq wcel syl wa vv vz cdivides wbr crab nfcv nfcsb1v
      cv csb nfsum breq2 rabbidv csbeq1a adantr sumeq12dv cbvsumi csbeq1 c1 cfz
      cmpt cfn wss fzfid sgmss ssfi syl2anc wf1o eqid dvdsflip cfv ovex fvmpt3i
      oveq2 adantl ssrab2 simpr sseldi cc wral ralrimivva nfel1 nfral raleqbidv
      nfv eleq1d cbvral sylib r19.21bi fsumcl dvdsdivcl sylan rspcv sylc anasss
      fsumf1o fsumdvdsdiag csbeq1d fsumdvdsdiaglem ex syld impl cvv a1i cc0 wne
      cmul nncn nnne0 jca ad2antrr simpld elrabi divdiv1 syl3anc oveq2d nnmulcl
      syl2an ddcan eqtrd eqeq2d biimpa csbied sumeq2dv 3eqtrd syl5eq ) ABUHZHUC
      UDZBMUEZYFEUHZUCUDZBMUEZCFNZENYHYFLUHZUCUDZBMUEZEYMCUIZFNZLNZYHYFHFUHZOPZ
      UCUDZBMUEZDGNZFNZYHYLYQELLYLUFEYOYPFEYOUFZEYMCUGZUJYIYMQZYKYOCYPFUUGYJYNB
      MYIYMYFUCUKULZUUGCYPQYSYKREYMCUMZUNUOUPAYRYHYFHUAUHZOPZUCUDZBMUEZEUUKCUIZ
      FNZUANYHUUBUUNUANZFNUUDAYHYQYHUUOLUAUBYHHUBUHZOPZUTZUUKYMUUKQZYOUUMYPUUNF
      UUTYNUULBMYMUUKYFUCUKULZUUTYPUUNQYSYOREYMUUKCUQZUNUOAURHUSPZVARYHUVCVBZYH
      VARAURHVCAHMRZUVDIHBVDSUVCYHVEVFAUVEYHYHUUSVGIBUBYHUUSHYHVHUUSVHZVISUUJYH
      RZUUJUUSVJUUKQAUBUUJUURUUKYHUUSUUQUUJHOVMUVFHUUQOVKVLVNAYMYHRZTZYOYPFUVIU
      RYMUSPZVARYOUVJVBZYOVARUVIURYMVCUVIYMMRUVKUVIYHMYMYGBMVOZAUVHVPVQYMBVDSUV
      JYOVEVFUVIYPVRRZFYOAUVMFYOVSZLYHACVRRZFYKVSZEYHVSUVNLYHVSZAUVOEFYHYKKVTUV
      PUVNELYHUVPLWDUVMEFYOUUEEYPVRUUFWAWBUUGUVOUVMFYKYOUUHUUGCYPVRUUIWEWCWFWGZ
      WHWHWIWOABUUNUAFHIAUVGYSUUMRZUUNVRRZAUVGTZUVTFUUMUWAUUKYHRZUVQUVTFUUMVSZA
      UVEUVGUWBIBUUJHWJWKAUVQUVGUVRUNUVNUWCLUUKYHUUTUVMUVTFYOUUMUVAUUTYPUUNVRUV
      BWEWCWLWMWHWNZWPAYHUUPUUCFAYSYHRZTZUUPUUBEHYTGUHZOPZOPZCUIZGNUUCUWFUUBUUN
      UUBUWJUAGUBUUBYTUUQOPZUTZUWHUUJUWHQEUUKUWICUUJUWHHOVMWQUWFURYTUSPZVARUUBU
      WMVBZUUBVARUWFURYTVCUWFYTMRZUWNAUVEUWEUWOIUVEUWETYHMYTUVLBYSHWJVQWKZYTBVD
      SUWMUUBVEVFUWFUWOUUBUUBUWLVGUWPBUBUUBUWLYTUUBVHUWLVHZVISUWGUUBRZUWGUWLVJU
      WHQUWFUBUWGUWKUWHUUBUWLUUQUWGYTOVMUWQYTUUQOVKVLVNAUWEUUJUUBRZUVTAUWEUWSTU
      VGUVSTZUVTABFUAHIWRAUWTUVTUWDWSWTXAWOUWFUUBUWJDGUWFUWRTZEUWICDXBUWIXBRUXA
      HUWHOVKXCUXAYIUWIQZTYIYSUWGXFPZQZCDQUXAUXBUXDUXAUWIUXCYIUXAUWIHHUXCOPZOPZ
      UXCUXAUWHUXEHOUXAHVRRZYSVRRZYSXDXEZTZUWGVRRZUWGXDXEZTZUWHUXEQUXAUXGHXDXEZ
      AUXGUXNTZUWEUWRAUVEUXOIUVEUXGUXNHXGHXHXISXJZXKUXAYSMRZUXJUWFUXQUWRUWEUXQA
      YGBYSMXLVNZUNUXQUXHUXIYSXGYSXHXISUXAUWGMRZUXMUWRUXSUWFUUABUWGMXLZVNUXSUXK
      UXLUWGXGUWGXHXISHYSUWGXMXNXOUXAUXOUXCVRRZUXCXDXEZTZUXFUXCQUXPUXAUXCMRZUYC
      UWFUXQUXSUYDUWRUXRUXTYSUWGXPXQUYDUYAUYBUXCXGUXCXHXISHUXCXRVFXSXTYAJSYBYCX
      SYCYDYE $.
  $}

  ${
    $d m n x A $.  $d m n x P $.
    dvdsppwf1o.f $e |- F = ( n e. ( 0 ... A ) |-> ( P ^ n ) ) $.
    $( A bijection from the divisors of a prime power to the integers less than
       the prime count.  (Contributed by Mario Carneiro, 5-May-2016.) $)
    dvdsppwf1o $p |- ( ( P e. Prime /\ A e. NN0 ) ->
      F : ( 0 ... A ) -1-1-onto-> { x e. NN | x || ( P ^ A ) } ) $=
      ( wcel cn0 wa cc0 co cexp cdivides wbr cn cpc syl2an cz adantl wceq vm cv
      cprime cfz crab prmnn adantr elfznn0 nnexpcl cuz cfv prmz elfzuz3 dvdsexp
      ad2antrr syl3anc breq1 elrab sylanbrc cle simpl elrabi pccl simplr zexpcl
      nnzd syl2anc simprbi pcdvdstr syl13anc pcidlem breqtrd wb fznn0 mpbir2and
      wrex oveq2 breq2d rspcev pcprmpw2 mpbid adantrl eqeq2d syl5ibrcom elfzelz
      syl pcid eqcomd adantrr impbid f1o2d ) CUCGZBHGZIZDUAJBUDKZAUBZCBLKZMNZAO
      UEZCDUBZLKZCUAUBZPKZEFWNWTWOGZIZXAOGZXAWQMNZXAWSGWNCOGZWTHGZXFXDWLXHWMCUF
      UGWTBUHZCWTUIQXECRGZXIBWTUJUKGZXGWLXKWMXDCULZUOXDXIWNXJSXDXLWNWTJBUMSCWTB
      UNUPWRXGAXAOWPXAWQMUQURUSWNXBWSGZIZXCWOGZXCHGZXCBUTNZWNWLXBOGZXQXNWLWMVAZ
      WRAXBOVBZCXBVCQXOXCCWQPKZBUTXOWLXBRGWQRGZXBWQMNZXCYBUTNWNWLXNXTUGXOXBXNXS
      WNYASVFXOXKWMYCWLXKWMXNXMUOWLWMXNVDZCBVEVGXNYDWNXNXSYDWRYDAXBOWPXBWQMUQUR
      VHSZXBWQCVIVJWNYBBTXNBCVKUGVLXOWMXPXQXRIVMYEXCBVNWFVOWNXDXNIIZWTXCTZXBXAT
      ZYGYIYHXBCXCLKZTZWNXNYKXDXOXBXAMNZDHVPZYKXOWMYDYMYEYFYLYDDBHWTBTXAWQXBMWT
      BCLVQVRVSVGWNWLXSYMYKVMXNXTYAXBCDVTQWAWBYHXAYJXBWTXCCLVQWCWDYGYHYIWTCXAPK
      ZTZWNXDYOXNXEYNWTWNWLWTRGYNWTTXDXTWTJBWEWTCWGQWHWIYIXCYNWTXBXACPVQWCWDWJW
      K $.
  $}

  ${
    $d m n x A $.  $d m n x N $.  $d m n ph $.
    dvdsflf1o.1 $e |- ( ph -> A e. RR ) $.
    dvdsflf1o.2 $e |- ( ph -> N e. NN ) $.
    dvdsflf1o.f $e |- F = ( n e. ( 1 ... ( |_ ` ( A / N ) ) ) |->
      ( N x. n ) ) $.
    $( A bijection from the numbers less than ` N / A ` to the multiples of
       ` A ` less than ` N ` .  Useful for some sum manipulations.
       (Contributed by Mario Carneiro, 3-May-2016.) $)
    dvdsflf1o $p |- ( ph -> F : ( 1 ... ( |_ ` ( A / N ) ) )
        -1-1-onto-> { x e. ( 1 ... ( |_ ` A ) ) | N || x } ) $=
      ( co cdivides wbr wcel wa cn cle cr wb syl adantr vm c1 cdiv cfl cfv crab
      cfz cv cmul elfznn nnmulcl syl2an nndivred fznnfl simplbda cc0 clt adantl
      nnred nngt0d lemuldiv2 syl112anc mpbird cz nnzd elfzelz zmulcl flge mpbid
      syl2anc flcld fznn mpbir2and dvdsmul1 breq2 elrab sylanbrc simprbi elrabi
      nndivdvds sylan2 lediv1 cc nncnd adantrl adantrr wne nnne0d divmuld eqcom
      wceq 3bitr4g f1o2d ) ADUAUBCFUCJZUDUEZUGJZFBUHZKLZBUBCUDUEZUGJZUFZFDUHZUI
      JZUAUHZFUCJZEIAXBWPMZNZXCWTMZFXCKLZXCXAMXGXHXCOMZXCWSPLZAFOMZXBOMZXJXFHXB
      WOUJZFXBUKULXGXCCPLZXKXGXOXBWNPLZAXFXMXPAWNQMZXFXMXPNRACFGHUMZXBWNUNSUOXG
      XBQMCQMZFQMZUPFUQLZXOXPRXGXBXFXMAXNURZUSAXSXFGTZAXTXFAFHUSZTAYAXFAFHUTZTX
      BCFVAVBVCXGXSXCVDMZXOXKRYCAFVDMZXBVDMZYFXFAFHVEZXBUBWOVFZFXBVGULCXCVHVJVI
      XGWSVDMZXHXJXKNRAYKXFACGVKTXCWSVLSVMAYGYHXIXFYIYJFXBVNULWRXIBXCWTWQXCFKVO
      VPVQAXDXAMZNZXEWPMZXEOMZXEWNPLZYMFXDKLZYOYLYQAYLXDWTMZYQWRYQBXDWTWQXDFKVO
      VPVRURYMXDOMZXLYQYORYMYRYSYLYRAWRBXDWTVSZURXDWSUJSZAXLYLHTXDFVTVJVIYMXDCP
      LZYPYLAYRUUBYTAYRYSUUBAXSYRYSUUBNRGXDCUNSUOWAYMXDQMXSXTYAUUBYPRYMXDUUAUSA
      XSYLGTAXTYLYDTAYAYLYETXDCFWBVBVIYMXQYNYOYPNRAXQYLXRTXEWNUNSVMAXFYLNZNZXEX
      BWKXCXDWKXBXEWKXDXCWKUUDXDFXBAYLXDWCMXFYMXDUUAWDWEAFWCMUUCAFHWDTAXFXBWCMY
      LXGXBYBWDWFAFUPWGUUCAFHWHTWIXBXEWJXDXCWJWLWM $.
  $}

  ${
    $d d m n x y A $.  $d m B $.  $d n C $.  $d d m n y ph $.
    dvdsflsumcom.1 $e |- ( n = ( d x. m ) -> B = C ) $.
    dvdsflsumcom.2 $e |- ( ph -> A e. RR ) $.
    dvdsflsumcom.3 $e |- ( ( ph /\ ( n e. ( 1 ... ( |_ ` A ) ) /\
      d e. { x e. NN | x || n } ) ) -> B e. CC ) $.
    $( A sum commutation from ` sum_ n <_ A , sum_ d || n , B ( n , d ) ` to
       ` sum_ d <_ A , sum_ m <_ A / d , B ( n , d m ) ` .  (Contributed by
       Mario Carneiro, 4-May-2016.) $)
    dvdsflsumcom $p |- ( ph ->
   sum_ n e. ( 1 ... ( |_ ` A ) ) sum_ d e. { x e. NN | x || n } B =
   sum_ d e. ( 1 ... ( |_ ` A ) ) sum_ m e. ( 1 ... ( |_ ` ( A / d ) ) ) C ) $=
      ( vy c1 co cv cdivides wbr csu wcel wa cfl cfv cfz cn crab cdiv fzfid cfn
      wss elfznn adantl sgmss syl ssfi syl2anc cr nnre ad2antrl adantr ad2antrr
      cle nnred cz wi nnz dvdsle syl2anr impr wb fznnfl simplbda letrd pm4.71rd
      ex ancom an32 bitri syl6bb anbi1d bitr4d pm5.32da an12 breq1 elrab anbi2i
      breq2 3bitr4g fsumcom2 cmul cmpt simprbda eqid dvdsflf1o wceq oveq2 fvmpt
      ovex cc biimpar syldan anassrs fsumf1o sumeq2dv eqtrd ) AMCUAUBZUCNZBOZGO
      ZPQZBUDUEZDHRGRXFHOZXGPQZBXFUEZDGRZHRXFMCXKUFNUAUBZUCNZEFRZHRAXFXJXFXMGHD
      AMXEUGZXRAXHXFSZTZMXHUCNZUHSXJYAUIZXJUHSXTMXHUGXTXHUDSZYBXSYCAXHXEUJUKZXH
      BULUMYAXJUNUOAXSXKUDSZXKXHPQZTZTZXKXFSZXSYFTZTZXSXKXJSZTZYIXHXMSZTZAYHXSY
      IYFTZTYKAXSYGYPXTYGYEXKCVAQZTZYFTZYPXTYGYQYGTZYSXTYGYQXTYGYQXTYGTZXKXHCYE
      XKUPSXTYFXKUQURUUAXHXTYCYGYDUSVBACUPSZXSYGJUTXTYEYFXKXHVAQZYEXKVCSYCYFUUC
      VDXTXKVEYDXKXHVFVGVHXTXHCVAQZYGAXSYCUUDAUUBXSYCUUDTVIJXHCVJUMVKUSVLVNVMYT
      YGYQTYSYQYGVOYEYFYQVPVQVRXTYIYRYFAYIYRVIZXSAUUBUUEJXKCVJUMZUSVSVTWAXSYIYF
      WBVRYLYGXSXIYFBXKUDXGXKXHPWCWDWEYNYJYIXLYFBXHXFXGXHXKPWFWDWEWGZKWHAXFXNXQ
      HAYITZXMDXPEGFLXPXKLOZWINZWJZXKFOZWINZIUUHMXOUGUUHBCLUUKXKAUUBYIJUSAYIYEY
      QUUFWKUUKWLZWMUULXPSUULUUKUBUUMWNUUHLUULUUJUUMXPUUKUUIUULXKWIWOUUNXKUULWI
      WQWPUKAYIYNDWRSZAYOYMUUOAYMYOUUGWSKWTXAXBXCXD $.
  $}

  ${
    $d m n A $.  $d m n ph $.
    fsumfldivdiag.1 $e |- ( ph -> A e. RR ) $.
    $( Lemma for ~ fsumfldivdiag .  (Contributed by Mario Carneiro,
       10-May-2016.) $)
    fsumfldivdiaglem $p |- ( ph ->
      ( ( n e. ( 1 ... ( |_ ` A ) ) /\ m e. ( 1 ... ( |_ ` ( A / n ) ) ) ) ->
      ( m e. ( 1 ... ( |_ ` A ) ) /\ n e. ( 1 ... ( |_ ` ( A / m ) ) ) ) ) ) $=
      ( c1 cfl cfv co wcel wa cle wbr cr wb fznnfl syl mpbid cc0 syl112anc cdiv
      cv cfz cn simprr adantr simprl simpld nndivred nnred simprd recnd mulid2d
      cmul nnge1d clt 1re a1i nnmulcld nngt0d lemuldiv2 mpbird ltletrd eqbrtrrd
      0re lemul1 ledivmul letrd mpbir2and lemuldiv jca ex ) ADUBZFBGHUCIZJZCUBZ
      FBVMUAIZGHUCIJZKZVPVNJZVMFBVPUAIZGHUCIJZKAVSKZVTWBWCVTVPUDJZVPBLMZWCWDVPV
      QLMZWCVRWDWFKZAVOVRUEWCVQNJVRWGOWCBVMABNJZVSEUFZWCVMUDJZVMBLMZWCVOWJWKKZA
      VOVRUGWCWHVOWLOWIVMBPQRUHZUIZVPVQPQRZUHZWCVPVQBWCVPWPUJZWNWIWCWDWFWOUKZWC
      VQBLMZBVMBUNIZLMZWCFBUNIZBWTLWCBWCBWIULUMWCFVMLMZXBWTLMZWCVMWMUOWCFNJZVMN
      JZWHSBUPMXCXDOXEWCUQURWCVMWMUJZWIWCSVMVPUNIZBSNJWCVEURWCXHWCVMVPWMWPUSZUJ
      WIWCXHXIUTWCXHBLMZWFWRWCVPNJZWHXFSVMUPMZXJWFOWQWIXGWCVMWMUTZVPBVMVATVBZVC
      FVMBVFTRVDWCWHWHXFXLWSXAOWIWIXGXMBBVMVGTVBVHWCWHVTWDWEKOWIVPBPQVIWCWBWJVM
      WALMZWMWCXJXOXNWCXFWHXKSVPUPMXJXOOXGWIWQWCVPWPUTVMBVPVJTRWCWANJWBWJXOKOWC
      BVPWIWPUIVMWAPQVIVKVL $.

    fsumfldivdiag.2 $e |- ( ( ph /\ ( n e. ( 1 ... ( |_ ` A ) ) /\
      m e. ( 1 ... ( |_ ` ( A / n ) ) ) ) ) -> B e. CC ) $.
    $( The right-hand side of ~ dvdsflsumcom is commutative in the variables,
       because it can be written as the manifestly symmetric sum over those
       ` <. m , n >. ` such that ` m x. n <_ A ` .  (Contributed by Mario
       Carneiro, 4-May-2016.) $)
    fsumfldivdiag $p |- ( ph ->
   sum_ n e. ( 1 ... ( |_ ` A ) ) sum_ m e. ( 1 ... ( |_ ` ( A / n ) ) ) B =
   sum_ m e. ( 1 ... ( |_ ` A ) ) sum_ n e. ( 1 ... ( |_ ` ( A / m ) ) ) B ) $=
      ( c1 cfl cfv cfz co cv cdiv fzfid wcel fsumfldivdiaglem impbid fsumcom2
      wa ) AHBIJZKLZHBEMZNLIJZKLZUBHBDMZNLIJKLZEDCAHUAOZUHAUCUBPZTHUDOAUIUFUEPT
      UFUBPUCUGPTABDEFQABEDFQRGS $.
  $}

  ${
    $d k m A $.  $d j k m n F $.  $d j k m n p q s w x z N $.  $d j k m ph $.
    $d k B $.  $d m C $.
    $( The sum of the M&ouml;bius function over the divisors of ` N ` gives one
       if ` N = 1 ` , but otherwise always sums to zero.  This makes the
       M&ouml;bius function useful for inverting divisor sums; see also
       ~ muinv .  (Contributed by Mario Carneiro, 2-Jul-2015.) $)
    musum $p |- ( N e. NN ->
      sum_ k e. { n e. NN | n || N } ( mmu ` k ) = if ( N = 1 , 1 , 0 ) ) $=
      ( vp vx vz vs cn wcel cfv cc0 cdivides wa c1 cprime cexp co wceq syl cfn
      vm vq cv cmu wne wbr crab csu cneg chash cif weq fveq2 neeq1d breq1 elrab
      anbi12d muval2 adantrr sylbi adantl sumeq2dv wi simpr a1i ss2rabdv ssrab2
      cz sseldi mucl zcnd cdif difrab pm3.21 necon1bd imp ss2rabi eqsstri sseli
      wn eqeq1d simprbi cfz wss fzfid sgmss ssfi syl2anc fsumss cpw cmpt oveq2d
      cpc eqid oveq1 cbvmptv oveq2 mpteq2dv syl5eq breq2 rabbidv zex prmz ssriv
      sqff1o ssexi rabex fvmpt cn0 neg1cn prmdvdsfi elpwi syl2an hashcl sylancr
      expcl fsumf1o ciun adantr pwfi sylib sylancl wral wdisj simprr ralrimivva
      cc invdisj fsumiun wrex cle wb mpbird eqeq2 sylibr cmul c0 syl6eq 3eqtr3d
      cuz cdom ssdomg hashdom nn0uz syl6eleq nn0zd elfz5 eqidd rspcev ralrimiva
      sylc rabid2 iunrab syl6reqr sumeq1d cbc elfznn0 fsumconst elfzelz 3eqtr4d
      hashbc oveq1d caddc ax-1cn negidi oveq1i binom1p syl5eqr nprmdvds1 breq2d
      notbid syl5ibr ralrimiv rabeq0 fveq2d hash0 exp0 ax-mp c2 eluz2b3 biimpri
      0cn df-ne sylan2br exprmfct rabn0 hashnncl 0expd ifbothda 3eqtr2d eqtr3d
      ) CHIZBUCZUDJZKUEZUWMCLUFZMZBHUGZAUCZUDJZAUHUWRNUIZDUCZUWSLUFZDOUGZUJJZPQ
      ZAUHZUWPBHUGZUWTAUHCNRZNKUKZUWLUWRUWTUXFAUWSUWRIZUWTUXFRZUWLUXKUWSHIZUWTK
      UEZUWSCLUFZMZMUXLUWQUXPBUWSHBAULZUWOUXNUWPUXOUXQUWNUWTKUWMUWSUDUMZUNUWMUW
      SCLUOUQUPUXMUXNUXLUXOUWSDURUSUTVAVBUWLUWRUXHUWTAUWLUWQUWPBHUWQUWPVCUWLUWM
      HIZMUWOUWPVDVEVFZUWLUXKMZUWTUYAUXMUWTVHIUYAUWRHUWSUWQBHVGUWLUXKVDVIUWSVJS
      VKUWSUXHUWRVLZIZUWTKRZUWLUYCUWSUWNKRZBHUGZIZUYDUYBUYFUWSUYBUWPUWQVTZMZBHU
      GUYFUWPUWQBHVMUYIUYEBHUYIUYEVCUXSUWPUYHUYEUWPUWQUWNKUWPUWOVNVOVPVEVQVRVSU
      YGUXMUYDUYEUYDBUWSHUXQUWNUWTKUXRWAUPWBSVAUWLNCWCQZTIUXHUYJWDUXHTIZUWLNCWE
      CBWFUYJUXHWGWHZWIUWLUXBCLUFZDOUGZWJZUXAEUCZUJJZPQZEUHZUXGUXJUWLUYOUYRUWRU
      XFEAUAUWRUXBUAUCZLUFZDOUGZWKZUXDUYPUXDRUYQUXEUXAPUYPUXDUJUMWLUWLUYKUWRUXH
      WDUWRTIUYLUXTUXHUWRWGWHBUWRUAVUCEHUBOUBUCZUYPWMQZWKZWKCDUWRWNVUCWNZEUAHVU
      FDOUXBUYTWMQZWKZEUAULZVUFDOUXBUYPWMQZWKVUIUBDOVUEVUKVUDUXBUYPWMWOWPVUJDOV
      UKVUHUYPUYTUXBWMWQWRWSWPXEUXKUWSVUCJUXDRUWLUAUWSVUBUXDUWRVUCUAAULVUAUXCDO
      UYTUWSUXBLWTXAVUGUXCDOOVHXBDOVHUXBXCXDXFXGXHVAUWLUYPUYOIZMZUXAYGIZUYQXIIZ
      UYRYGIZXJVUMUYPTIZVUOUWLUYNTIZUYPUYNWDZVUQVULCDXKZUYPUYNXLZUYNUYPWGZXMUYP
      XNZSUXAUYQXPZXOXQUWLFKUYNUJJZWCQZGUCZUJJZFUCZRZGUYOUGZXRZUYREUHVVFVVKUYRE
      UHZFUHZUYSUXJUWLFVVFVVKUYREUWLKVVEWEUWLVVIVVFIZMZUYOTIZVVKUYOWDVVKTIZVVPV
      URVVQUWLVURVVOVUTXSUYNXTYAVVJGUYOVGZUYOVVKWGYBZUWLUYQVVIRZEVVKYCFVVFYCFVV
      FVVKYDUWLVWAFEVVFVVKUWLVVOUYPVVKIZMZMZVWBVWAUWLVVOVWBYEZVWBVULVWAVVJVWAGU
      YPUYOGEULVVHUYQVVIVVGUYPUJUMWAUPWBZSYFFEVVFVVKUYQYHSVWDVUNVUOVUPXJVWDVUQV
      UOVWDVURVUSVUQUWLVURVWCVUTXSVWDVULVUSVWDVVKUYOUYPVVSVWEVIVVASVVBWHVVCSVVD
      XOYIUWLVVLUYOUYREUWLUYOVVJFVVFYJZGUYOUGZVVLUWLVWGGUYOYCUYOVWHRUWLVWGGUYOU
      WLVVGUYOIZMZVVHVVFIZVVHVVHRZVWGVWJVWKVVHVVEYKUFZVWJVWMVVGUYNUUAUFZVWJVURV
      VGUYNWDZVWNUWLVURVWIVUTXSZVWIVWOUWLVVGUYNXLZVAVVGUYNTUUBUUKVWJVVGTIZVURVW
      MVWNYLUWLVURVWOVWRVWIVUTVWQUYNVVGWGXMZVWPVVGUYNTUUCWHYMVWJVVHKYTJZIVVEVHI
      VWKVWMYLVWJVVHXIVWTVWJVWRVVHXIIVWSVVGXNSUUDUUEVWJVVEUWLVVEXIIZVWIUWLVURVX
      AVUTUYNXNSZXSUUFVVHKVVEUUGWHYMVWJVVHUUHVVJVWLFVVHVVFVVIVVHVVHYNUUIWHUUJVW
      GGUYOUULYOVVJFGVVFUYOUUMUUNUUOUWLVVNVVFVVEVVIUUPQZUXAVVIPQZYPQZFUHZKVVEPQ
      ZUXJUWLVVFVVMVXEFVVPVVKVXDEUHZVVKUJJZVXDYPQZVVMVXEVVPVVRVXDYGIZVXHVXJRVVT
      VVPVUNVVIXIIZVXKXJVVOVXLUWLVVIVVEUUQVAUXAVVIXPXOVVKVXDEUURWHVVPVVKUYRVXDE
      VVPVWBMUYQVVIUXAPVWBVWAVVPVWFVAWLVBVVPVXCVXIVXDYPUWLVURVVIVHIVXCVXIRVVOVU
      TVVIKVVEUUSGUYNVVIUVAXMUVBUUTVBUWLVXGNUXAUVCQZVVEPQZVXFVXMKVVEPNUVDUVEUVF
      UWLVUNVXAVXNVXFRXJVXBUXAFVVEUVGXOUVHUXIVXGNRVXGKRVXGUXJRUWLNKNUXJVXGYNKUX
      JVXGYNUWLUXIMZVXGKKPQZNVXOVVEKKPVXOVVEYQUJJKVXOUYNYQUJVXOUYMVTZDOYCUYNYQR
      VXOVXQDOUXBOIVXQVXOUXBNLUFZVTUXBUVIVXOUYMVXRVXOCNUXBLUWLUXIVDUVJUVKUVLUVM
      UYMDOUVNYOUVOUVPYRWLKYGIVXPNRUWBKUVQUVRYRUWLUXIVTZMZVVEVXTVVEHIZUYNYQUEZV
      XTUYMDOYJZVYBVXTCUVSYTJIZVYCVXSUWLCNUEZVYDCNUWCVYDUWLVYEMCUVTUWAUWDCDUWES
      UYMDOUWFYOVXTVURVYAVYBYLUWLVURVXSVUTXSUYNUWGSYMUWHUWIUWJYSUWKYS $.

    ${
      musumsum.1 $e |- ( m = 1 -> B = C ) $.
      musumsum.2 $e |- ( ph -> A e. Fin ) $.
      musumsum.3 $e |- ( ph -> A C_ NN ) $.
      musumsum.4 $e |- ( ph -> 1 e. A ) $.
      musumsum.5 $e |- ( ( ph /\ m e. A ) -> B e. CC ) $.
      $( Evaluate a collapsing sum over the M&ouml;bius function.  (Contributed
         by Mario Carneiro, 4-May-2016.) $)
      musumsum $p |- ( ph -> sum_ m e. A
        sum_ k e. { n e. NN | n || m } ( ( mmu ` k ) x. B ) = C ) $=
        ( cn cmul co csu c1 wcel cc0 wceq cv cdivides wbr cmu cfv csn wa sselda
        crab cif musum syl oveq1d cfz cfn fzfid sgmss ssfi syl2anc cc cz elrabi
        wss mucl zcnd adantl fsummulc1 ifsb wb elsn bicomi a1i mulid2 ifbieq12d
        oveq1 mul02 syl5eq 3eqtr3d sumeq2dv wral wo snssd syldan ralrimiva olcd
        cuz sumss2 syl21anc eleq1d rspcv sylc sumsn 3eqtr2d ) ABGUAFUAZUBUCZGMU
        IZEUAZUDUEZCNOEPZFPBWNQUFZRZCSUJZFPZWTCFPZDABWSXBFAWNBRZUGZWPWREPZCNOWN
        QTZQSUJZCNOZWSXBXFXGXICNXFWNMRZXGXITABMWNJUHZEGWNUKULUMXFWPWRCEXFQWNUNO
        ZUORWPXMVCZWPUORXFQWNUPXFXKXNXLWNGUQULXMWPURUSLWQWPRZWRUTRXFXOWRXOWQMRW
        RVARWOGWQMVBWQVDULVEVFVGXFXJXHQCNOZSCNOZUJZXBXHQSXJXPXQXIQCNVOXISCNVOVH
        XFCUTRZXRXBTLXSXHXAXPXQCSXHXAVIXSXAXHFQVJVKVLCVMCVPVNULVQVRVSAWTBVCXSFW
        TVTBQWFUEVCZBUORZWAXDXCTAQBKWBZAXSFWTAXAXEXSAWTBWNYBUHLWCWDAYAXTIWEWTBC
        FQWGWHAQBRZDUTRZXDDTKAYCXSFBVTYDKAXSFBLWDXSYDFQBXHCDUTHWIWJWKCDFQBHWLUS
        WM $.
    $}

    muinv.1 $e |- ( ph -> F : NN --> CC ) $.
    muinv.2 $e |- ( ph -> G =
      ( n e. NN |-> sum_ k e. { x e. NN | x || n } ( F ` k ) ) ) $.
    $( The M&ouml;bius inversion formula.  If ` G ( n ) = sum_ k || n F ( k ) `
       for every ` n e. NN ` , then ` F ( n ) = sum_ k || n `
       ` mmu ( k ) G ( n / k ) = sum_ k || n mmu ( n / k ) G ( k ) ` , i.e. the
       M&ouml;bius function is the Dirichlet convolution inverse of the
       constant function ` 1 ` .  (Contributed by Mario Carneiro,
       2-Jul-2015.) $)
    muinv $p |- ( ph -> F = ( m e. NN |-> sum_ j e. { x e. NN | x || m }
      ( ( mmu ` j ) x. ( G ` ( m / j ) ) ) ) ) $=
      ( cn cdivides co cmul csu cc wcel wa cc0 c1 cv cfv cmpt wbr crab cmu cdiv
      feqmptd wceq ad2antrr fveq1d cz clt breq1 elrab simprbi adantl wne elrabi
      wb nnzd nnne0d nnz ad2antlr dvdsval2 syl3anc mpbid cr nnre jca syl divgt0
      nngt0 syl2anc elnnz sylanbrc breq2 rabbidv sumeq1d eqid sumex fvmpt eqtrd
      oveq2d cfz cfn wss fzfid sgmss ssfi mucl zcnd wf ffvelrn syl2an fsummulc2
      simpr adantrr anasss mulcld fsumdvdsdiag cif csn ssrab2 dvdsdivcl adantll
      sumeq2dv sseldi musum oveq1d adantr fsummulc1 oveq1 ifsb nncnd ax-1cn a1i
      nncn divmuld mulid1d eqeq1d bitrd mulid2d mul02d ifbieq12d syl5eq 3eqtr3d
      iddvds snssd sselda syldan 0cn ifcl sylancl cdif wn neneqd iffalse fsumss
      eldifsni ffvelrnda iftrue fveq2 sumsn 3eqtr2d 3eqtrd mpteq2dva eqtr4d ) A
      GEKEUAZGUBZUCEKBUAZUUILUDZBKUEZCUAZUFUBZUUIUUNUGMZHUBZNMZCOZUCAEKPGIUHAEK
      UUSUUJAUUIKQZRZUUSUUMUUKUUPLUDZBKUEZUUODUAZGUBZNMZDOZCOUUMUUKUUIUVDUGMZLU
      DZBKUEZUVFCOZDOZUUJUVAUUMUURUVGCUVAUUNUUMQZRZUURUUOUVCUVEDOZNMUVGUVNUUQUV
      OUUONUVNUUQUUPFKUUKFUAZLUDZBKUEZUVEDOZUCZUBZUVOUVNUUPHUVTAHUVTUIUUTUVMJUJ
      UKUVNUUPKQZUWAUVOUIUVNUUPULQZSUUPUMUDZUWBUVNUUNUUILUDZUWCUVMUWEUVAUVMUUNK
      QZUWEUULUWEBUUNKUUKUUNUUILUNUOUPUQUVNUUNULQUUNSURUUIULQZUWEUWCUTUVNUUNUVM
      UWFUVAUULBUUNKUSUQZVAUVNUUNUWHVBUUTUWGAUVMUUIVCVDUUNUUIVEVFVGUVNUUIVHQZSU
      UIUMUDZRZUUNVHQZSUUNUMUDZRZUWDUUTUWKAUVMUUTUWIUWJUUIVIUUIVMVJVDUVNUWFUWNU
      WHUWFUWLUWMUUNVIUUNVMVJVKUUIUUNVLVNUUPVOVPZFUUPUVSUVOKUVTUVPUUPUIZUVRUVCU
      VEDUWPUVQUVBBKUVPUUPUUKLVQVRVSUVTVTUVCUVEDWAWBVKWCWDUVNUVCUVEUUODUVNTUUPW
      EMZWFQUVCUWQWGZUVCWFQUVNTUUPWHUVNUWBUWRUWOUUPBWIVKUWQUVCWJVNUVNUUOUVNUWFU
      UOULQZUWHUUNWKZVKWLZUVNKPGWMZUVDKQZUVEPQZUVDUVCQZAUXBUUTUVMIUJUVBBUVDKUSK
      PUVDGWNZWOZWPWCXGUVABUVFCDUUIAUUTWQZUVAUVMUXERRUUOUVEUVAUVMUUOPQUXEUXAWRU
      VAUVMUXEUXDUXGWSWTXAUVAUVLUUMUVDUUIUIZUVESXBZDOUUIXCZUXJDOZUUJUVAUUMUVKUX
      JDUVAUVDUUMQZRZUVJUUOCOZUVENMUVHTUIZTSXBZUVENMZUVKUXJUXNUXOUXQUVENUXNUVHK
      QZUXOUXQUIUXNUUMKUVHUULBKXDUUTUXMUVHUUMQABUVDUUIXEXFXHZCBUVHXIVKXJUXNUVJU
      UOUVECUXNTUVHWEMZWFQUVJUYAWGZUVJWFQUXNTUVHWHUXNUXSUYBUXTUVHBWIVKUYAUVJWJV
      NUVAUXBUXCUXDUXMAUXBUUTIXKUULBUVDKUSZUXFWOZUXNUUNUVJQZRZUUOUYFUWFUWSUYFUV
      JKUUNUVIBKXDUXNUYEWQXHUWTVKWLXLUXNUXRUXPTUVENMZSUVENMZXBUXJUXPTSUXRUYGUYH
      UXQTUVENXMUXQSUVENXMXNUXNUXPUXIUYGUYHUVESUXNUXPUVDTNMZUUIUIUXIUXNUUIUVDTU
      UTUUIPQAUXMUUIXRVDUXNUVDUXMUXCUVAUYCUQZXOZTPQUXNXPXQUXNUVDUYJVBXSUXNUYIUV
      DUUIUXNUVDUYKXTYAYBUXNUVEUYDYCUXNUVEUYDYDYEYFYGXGUVAUXKUUMUXJDUVAUUIUUMUV
      AUUTUUIUUILUDZUUIUUMQUXHUVAUWGUYLUVAUUIUXHVAUUIYHVKUULUYLBUUIKUUKUUIUUILU
      NUOVPYIZUVAUVDUXKQZRUXDSPQUXJPQUVAUYNUXMUXDUVAUXKUUMUVDUYMYJUYDYKYLUXIUVE
      SPYMYNUVAUVDUUMUXKYOQZRZUXIYPUXJSUIUYPUVDUUIUYOUVDUUIURUVAUVDUUMUUIYTUQYQ
      UXIUVESYRVKUVATUUIWEMZWFQUUMUYQWGZUUMWFQUVATUUIWHUUTUYRAUUIBWIUQUYQUUMWJV
      NYSUVAUUTUUJPQUXLUUJUIUXHAKPUUIGIUUAUXJUUJDUUIKUXIUXJUVEUUJUXIUVESUUBUVDU
      UIGUUCWCUUDVNUUEUUFUUGUUH $.
  $}

  ${
    $d k A $.  $d i z D $.  $d u x M $.  $d u x N $.  $d i j k m n u v w z X $.
    $d j B $.  $d j k w z C $.  $d i j k m n u v w z Y $.  $d i j u w z Z $.
    $d i j k m n w x z $.  $d i j k m n w z ph $.
    dvdsmulf1o.1 $e |- ( ph -> M e. NN ) $.
    dvdsmulf1o.2 $e |- ( ph -> N e. NN ) $.
    dvdsmulf1o.3 $e |- ( ph -> ( M gcd N ) = 1 ) $.
    dvdsmulf1o.x $e |- X = { x e. NN | x || M } $.
    dvdsmulf1o.y $e |- Y = { x e. NN | x || N } $.
    dvdsmulf1o.z $e |- Z = { x e. NN | x || ( M x. N ) } $.
    $( If ` M ` and ` N ` are two coprime integers, multiplication forms a
       bijection from the set of pairs ` <. j , k >. ` where ` j || M ` and
       ` k || N ` , to the set of divisors of ` M x. N ` .  (Contributed by
       Mario Carneiro, 2-Jul-2015.) $)
    dvdsmulf1o $p |- ( ph ->
        ( x. |` ( X X. Y ) ) : ( X X. Y ) -1-1-onto-> Z ) $=
      ( cmul wceq co wcel cn cdivides wbr vu vv vi vj vm vn vw cxp cres wf1 wfo
      wf1o wf cv cfv wi wral wfn cc wss ax-mulf ffn ax-mp ssrab2 eqsstri nnsscn
      crab sstri xpss12 mp2an fnssres a1i wa ovres adantl breq1 elrab2 ad2antrl
      simplbi ad2antll nnmulcld simprbi cz nnzd adantr dvdscmul syl3anc zmulcld
      dvdsmulc dvdstr syl2and mp2and sylanbrc eqeltrd ralrimivva cop cn0 nnnn0d
      ffnov simprll syl c1 dvdsmul1 syl2anc simprr sseldi simprlr nncnd mulcomd
      cgcd eqtrd breqtrd gcdcom ad2antrr rpdvds syl32anc eqtr3d dvdseq syl22anc
      coprmdvds nnne0d oveq1d eqtr4d mulcanad fvres fveq2 df-ov syl6eqr imbi12d
      eqeq2d ralxp cc0 wn wne simpr necon3ai gcdn0cl syl21anc gcddvds simprd wb
      opeq12d expr eqeqan12d imbi1d ralbidva eqeq2 eqeq1d eqeq1 2ralbidv syl5bb
      ralbiia bitri sylibr dff13 wrex opelxpi rpmulgcd2 syl31anc syl6eq syl2anr
      gcdeq mpbird 3eqtr2rd rspcev ralrimiva dffo3 df-f1o ) AEFUHZGNUVIUIZUJZUV
      IGUVJUKZUVIGUVJULAUVIGUVJUMZUAUNZUVJUOZUBUNZUVJUOZOZUVNUVPOZUPZUBUVIUQZUA
      UVIUQZUVKAUVJUVIURZUCUNZUDUNZUVJPZGQZUDFUQUCEUQUVMUWCANUSUSUHZURZUVIUWHUT
      ZUWCUWHUSNUMUWIVAUWHUSNVBVCEUSUTFUSUTUWJERUSEBUNZCSTZBRVGRKUWLBRVDVEVFVHZ
      FRUSFUWKDSTZBRVGRLUWNBRVDVEVFVHEUSFUSVIVJUWHUVINVKVJVLAUWGUCUDEFAUWDEQZUW
      EFQZVMZVMZUWFUWDUWENPZGUWQUWFUWSOAUWDUWEEFNVNVOUWRUWSRQUWSCDNPZSTZUWSGQUW
      RUWDUWEUWOUWDRQZAUWPUWOUXBUWDCSTZUWLUXCBUWDREUWKUWDCSVPKVQZVSVRZUWPUWERQZ
      AUWOUWPUXFUWEDSTZUWNUXGBUWERFUWKUWEDSVPLVQZVSVTZWAZUWRUXGUXCUXAUWPUXGAUWO
      UWPUXFUXGUXHWBVTZUWOUXCAUWPUWOUXBUXCUXDWBVRZUWRUXGUWSUWDDNPZSTZUXCUXMUWTS
      TZUXAUWRUWEWCQZDWCQZUWDWCQZUXGUXNUPUWRUWEUXIWDUWRDADRQZUWQIWEWDZUWRUWDUXE
      WDZUWDUWEDWFWGUWRUXRCWCQZUXQUXCUXOUPUYAUWRCACRQZUWQHWEWDZUXTDUWDCWIWGUWRU
      WSWCQUXMWCQUWTWCQUXNUXOVMUXAUPUWRUWSUXJWDUWRUWDDUYAUXTWHUWRCDUYDUXTWHUWSU
      XMUWTWJWGWKWLUWKUWTSTZUXABUWSRGUWKUWSUWTSVPMVQWMWNWOUCUDEFGUVJWSWMZAUWSUE
      UNZUFUNZNPZOZUWDUWEWPZUYGUYHWPZOZUPZUFFUQUEEUQZUDFUQUCEUQZUWBAUYOUCUDEFUW
      RUYNUEUFEFUWRUYGEQZUYHFQZVMZUYJUYMUWRUYSUYJVMZVMZUWDUYGUWEUYHVUAUWDWQQUYG
      WQQUWDUYGSTZUYGUWDSTZUWDUYGOVUAUWDUWRUXBUYTUXEWEZWRVUAUYGVUAUYQUYGRQZUWRU
      YQUYRUYJWTZUYQVUEUYGCSTZUWLVUGBUYGREUWKUYGCSVPKVQZVSXAZWRVUAUWDUYHUYGNPZS
      TZUWDUYHXJPXBOZVUBVUAUWDUWSVUJSVUAUXRUXPUWDUWSSTVUAUWDVUDWDZVUAUWEUWRUXFU
      YTUXIWEZWDZUWDUWEXCXDVUAUWSUYIVUJUWRUYSUYJXEZVUAUYGUYHVUAEUSUYGUWMVUFXFVU
      AUYHVUAUYRUYHRQZUWRUYQUYRUYJXGZUYRVUQUYHDSTZUWNVUSBUYHRFUWKUYHDSVPLVQZVSX
      AZXHZXIXKXLVUAUXRUYHWCQZUXQUWDDXJPZXBOVUSVULVUMVUAUYHVVAWDZUWRUXQUYTUXTWE
      ZVUAVVDDUWDXJPZXBVUAUXRUXQVVDVVGOVUMVVFUWDDXMXDVUAUXQUXRUYBDCXJPZXBOZUXCV
      VGXBOVVFVUMUWRUYBUYTUYDWEZAVVIUWQUYTAVVHCDXJPZXBAUXQUYBVVHVVKOADIWDACHWDD
      CXMXDJXKXNZUWRUXCUYTUXLWEDUWDCXOXPXKVUAUYRVUSVURUYRVUQVUSVUTWBXAUWDUYHDXO
      XPVUAUXRVVCUYGWCQZVUKVULVMVUBUPVUMVVEVUAUYGVUIWDZUWDUYHUYGXTWGWLVUAUYGUWE
      UWDNPZSTZUYGUWEXJPXBOZVUCVUAUYGUYIVVOSVUAVVMVVCUYGUYISTVVNVVEUYGUYHXCXDVU
      AUWSUYIVVOVUPVUAUWDUWEVUAUWDVUDXHZVUAUWEVUNXHZXIXQXLVUAVVMUXPUXQUYGDXJPZX
      BOUXGVVQVVNVUOVVFVUAVVTDUYGXJPZXBVUAVVMUXQVVTVWAOVVNVVFUYGDXMXDVUAUXQVVMU
      YBVVIVUGVWAXBOVVFVVNVVJVVLVUAUYQVUGVUFUYQVUEVUGVUHWBXADUYGCXOXPXKUWRUXGUY
      TUXKWEUYGUWEDXOXPVUAVVMUXPUXRVVPVVQVMVUCUPVVNVUOVUMUYGUWEUWDXTWGWLUWDUYGX
      RXSZVUAUWEUYHUWDVVSVVBVVRVUAUWDVUDYAVUAUWSUYIUWDUYHNPVUPVUAUWDUYGUYHNVWBY
      BYCYDUUBUUCWOWOUWBUVNNUOZUVPNUOZOZUVSUPZUBUVIUQZUAUVIUQUYPUWAVWGUAUVIUVNU
      VIQZUVTVWFUBUVIVWHUVPUVIQZVMUVRVWEUVSVWHVWIUVOVWCUVQVWDUVNUVINYEUVPUVINYE
      UUDUUEUUFUULVWGUYOUAUCUDEFVWGVWCUYIOZUVNUYLOZUPZUFFUQUEEUQUVNUYKOZUYOVWFV
      WLUBUEUFEFUVPUYLOZVWEVWJUVSVWKVWNVWDUYIVWCVWNVWDUYLNUOUYIUVPUYLNYFUYGUYHN
      YGYHYJUVPUYLUVNUUGYIYKVWMVWLUYNUEUFEFVWMVWJUYJVWKUYMVWMVWCUWSUYIVWMVWCUYK
      NUOUWSUVNUYKNYFUWDUWENYGYHUUHUVNUYKUYLUUIYIUUJUUKYKUUMUUNUAUBUVIGUVJUUOWM
      AUVMUGUNZUVOOZUAUVIUUPZUGGUQUVLUYFAVWQUGGAVWOGQZVMZVWOCXJPZVWODXJPZWPZUVI
      QZVWOVXBUVJUOZOZVWQVWSVWTEQZVXAFQZVXCVWSVWTRQZVWTCSTZVXFVWSVWOWCQZUYBVWOY
      LOZCYLOZVMZYMZVXHVWSVWOVWRVWORQZAVWRVXOVWOUWTSTZUYEVXPBVWORGUWKVWOUWTSVPM
      VQZVSZVOWDZVWSCAUYCVWRHWEZWDZVWSCYLYNVXNVWSCVXTYAVXMCYLVXKVXLYOYPXAVWOCYQ
      YRVWSVWTVWOSTZVXIVWSVXJUYBVYBVXIVMVXSVYAVWOCYSXDYTUWLVXIBVWTREUWKVWTCSVPK
      VQWMVWSVXARQZVXADSTZVXGVWSVXJUXQVXKDYLOZVMZYMZVYCVXSVWSDAUXSVWRIWEZWDZVWS
      DYLYNVYGVWSDVYHYAVYFDYLVXKVYEYOYPXAVWODYQYRVWSVXAVWOSTZVYDVWSVXJUXQVYJVYD
      VMVXSVYIVWODYSXDYTUWNVYDBVXARFUWKVXADSVPLVQWMVWTVXAEFUUQXDZVWSVXDVXBNUOZV
      WOUWTXJPZVWOVWSVXCVXDVYLOVYKVXBUVINYEXAVWSVYMVWTVXANPZVYLVWSVXJUYBUXQVVKX
      BOZVYMVYNOVXSVYAVYIAVYOVWRJWEVWOCDUURUUSVWTVXANYGUUTVWSVYMVWOOZVXPVWRVXPA
      VWRVXOVXPVXQWBVOVWRVXOUWTRQVYPVXPUUAAVXRACDHIWAVWOUWTUVBUVAUVCUVDVWPVXEUA
      VXBUVIUVNVXBOUVOVXDVWOUVNVXBUVJYFYJUVEXDUVFUAUGUVIGUVJUVGWMUVIGUVJUVHWM
      $.

    fsumdvdsmul.4 $e |- ( ( ph /\ j e. X ) -> A e. CC ) $.
    fsumdvdsmul.5 $e |- ( ( ph /\ k e. Y ) -> B e. CC ) $.
    fsumdvdsmul.6 $e |- ( ( ph /\ ( j e. X /\ k e. Y ) ) -> ( A x. B ) = D ) $.
    fsumdvdsmul.7 $e |- ( i = ( j x. k ) -> C = D ) $.
    $( Product of two divisor sums.  (This is also the main part of the proof
       that " ` sum_ k || N F ( k ) ` is a multiplicative function if ` F `
       is".)  (Contributed by Mario Carneiro, 2-Jul-2015.) $)
    fsumdvdsmul $p |- ( ph -> ( sum_ j e. X A x. sum_ k e. Y B ) =
      sum_ i e. Z C ) $=
      ( vz vw csu cmul co c1 cfz cfn wcel wss fzfid cv cdivides wbr cn crab syl
      sgmss syl5eqss ssfi syl2anc fsumcl fsummulc1 wa cc adantlr fsummulc2 wceq
      adantr anassrs sumeq2dv eqtrd cxp cfv csb cop fveq2 df-ov syl6eqr csbeq1d
      ovex csbief syl6eq adantrr adantrl mulcld eqeltrrd fsumxp nfcsb1v csbeq1a
      nfcv cbvsumi cres csbeq1 dvdsmulf1o fvres adantl ralrimivva eleq1d sylibr
      xpfi wral ralxp cima wfn wb ax-mulf ffn ax-mp ssrab2 eqsstri nnsscn sstri
      wf xpss12 mp2an ralima crn df-ima wf1o wfo f1ofo forn 3syl syl5eq raleqdv
      syl5bbr mpbid r19.21bi fsumf1o eqtr4d 3eqtrd ) ALCHUGMDIUGZUHUILCYQUHUIZH
      UGLMFIUGZHUGZNEGUGZALCYQHAUJJUKUIZULUMLUUBUNLULUMZAUJJUOALBUPZJUQURZBUSUT
      ZUUBRAJUSUMUUFUUBUNOJBVBVAVCUUBLVDVEZAMDIAUJKUKUIZULUMMUUHUNMULUMZAUJKUOA
      MUUDKUQURZBUSUTZUUHSAKUSUMUUKUUHUNPKBVBVAVCUUHMVDVEZUBVFUAVGALYRYSHAHUPZL
      UMZVHZYRMCDUHUIZIUGYSUUOMDCIAUUIUUNUULVMUAAIUPZMUMZDVIUMZUUNUBVJVKUUOMUUP
      FIAUUNUURUUPFVLUCVNVOVPVOAYTLMVQZGUEUPZUHVRZEVSZUEUGZUUAAUELMFUVCHIUVAUUM
      UUQVTZVLZUVCGUUMUUQUHUIZEVSFUVFGUVBUVGEUVFUVBUVEUHVRUVGUVAUVEUHWAUUMUUQUH
      WBWCWDGUVGEFUUMUUQUHWEGFWOUDWFWGZUUGUULAUUNUURVHVHZUUPFVIUCUVICDAUUNCVIUM
      UURUAWHAUURUUSUUNUBWIWJWKZWLAUUANGUFUPZEVSZUFUGUVDNEUVLGUFUFEWOGUVKEWMGUV
      KEWNWPANUVLUUTUVCUFUEUHUUTWQZUVBGUVKUVBEWRZAUUCUUIUUTULUMUUGUULLMXEVEABJK
      LMNOPQRSTWSZUVAUUTUMUVAUVMVRUVBVLAUVAUUTUHWTXAAUVLVIUMZUFNAUVCVIUMZUEUUTX
      FZUVPUFNXFZAFVIUMZIMXFHLXFUVRAUVTHILMUVJXBUVQUVTUEHILMUVFUVCFVIUVHXCXGXDU
      VRUVPUFUHUUTXHZXFZAUVSUHVIVIVQZXIZUUTUWCUNZUWBUVRXJUWCVIUHXRUWDXKUWCVIUHX
      LXMLVIUNMVIUNUWELUSVILUUFUSRUUEBUSXNXOXPXQMUSVIMUUKUSSUUJBUSXNXOXPXQLVIMV
      IXSXTUVPUVQUFUEUWCUUTUHUVKUVBVLUVLUVCVIUVNXCYAXTAUVPUFUWANAUWAUVMYBZNUHUU
      TYCAUUTNUVMYDUUTNUVMYEUWFNVLUVOUUTNUVMYFUUTNUVMYGYHYIYJYKYLYMYNYIYOYP $.
  $}

  ${
    $d i j k n x A $.  $d i j k x M $.  $d i j k n x N $.  $d i k n x P $.
    $d n x K $.
    $( The value of the divisor function at a prime power.  (Contributed by
       Mario Carneiro, 17-May-2016.) $)
    sgmppw $p |- ( ( A e. CC /\ P e. Prime /\ N e. NN0 ) ->
      ( A sigma ( P ^ N ) ) = sum_ k e. ( 0 ... N ) ( ( P ^c A ) ^ k ) ) $=
      ( vx vn vi cc wcel cn0 cexp co cv cn ccxp csu cc0 wceq syl2anc adantl w3a
      cprime csgm cdivides wbr crab cfz simp1 simp2 prmnn simp3 nnexpcld sgmval
      cmpt oveq1 fzfid wf1o eqid dvdsppwf1o oveq2 ovex fvmpt elrabi nncnd cxpcl
      syl cfv syl2anr fsumf1o wa cmul elfznn0 nn0cnd adantr oveq2d nnrpd nn0red
      mulcomd cxpmuld cxpexp oveq1d eqtrd cxpmul2d 3eqtr3d sumeq2dv 3eqtrd ) AH
      IZBUBIZDJIZUAZABDKLZUCLZEMWKUDUEZENUFZFMZAOLZFPZQDUGLZBCMZKLZAOLZCPWRBAOL
      WSKLZCPWJWGWKNIWLWQRWGWHWIUHZWJBDWJWHBNIZWGWHWIUIZBUJVFZWGWHWIUKZULAWKFEU
      MSWJWNWPWRXAFCGWRBGMZKLZUNZWTWOWTAOUOWJQDUPWJWHWIWRWNXJUQXEXGEDBGXJXJURZU
      SSWSWRIZWSXJVGWTRWJGWSXIWTWRXJXHWSBKUTXKBWSKVAVBTWOWNIZWOHIWGWPHIWJXMWOWM
      EWONVCVDXCWOAVEVHVIWJWRXAXBCWJXLVJZBWSAVKLZOLZBAWSVKLZOLXAXBXNXOXQBOXNWSA
      XNWSXLWSJIZWJWSDVLTZVMWJWGXLXCVNZVRVOXNXPBWSOLZAOLXAXNBWSAXNBWJXDXLXFVNZV
      PXNWSXSVQXTVSXNYAWTAOXNBHIXRYAWTRXNBYBVDZXSBWSVTSWAWBXNBAWSYCXTXSWCWDWEWF
      $.

    $( A prime power ` P ^ K ` has ` K + 1 ` divisors.  (Contributed by Mario
       Carneiro, 17-May-2016.) $)
    0sgmppw $p |- ( ( P e. Prime /\ K e. NN0 ) ->
      ( 0 sigma ( P ^ K ) ) = ( K + 1 ) ) $=
      ( vx vn wcel cn0 cc0 cexp co chash cfv c1 caddc cv wbr wceq syl cfn cvv
      cn cprime wa csgm cfz cmin cdivides crab prmnn nnexpcl 0sgm cen cmpt wf1o
      sylan fzfid nnex rabex a1i eqid dvdsppwf1o f1oen2g syl3anc hasheni eqtr4d
      cuz simpr nn0uz syl6eleq hashfz cc nn0cn adantl subid1d oveq1d 3eqtrd ) A
      UAEZBFEZUBZGABHIZUCIZGBUDIZJKZBGUEIZLMIZBLMIVRVTCNVSUFOZCTUGZJKZWBVRVSTEZ
      VTWGPVPATEVQWHAUHABUIUNVSCUJQVRWAWFUKOZWBWGPVRWAREWFSEZWAWFDWAADNHIULZUMW
      IVRGBUOWJVRWECTUPUQURCBADWKWKUSUTWAWFWKRSVAVBWAWFVCQVDVRBGVEKZEWBWDPVRBFW
      LVPVQVFVGVHGBVIQVRWCBLMVRBVQBVJEVPBVKVLVMVNVO $.

    $( The sum of divisors for a prime is ` P + 1 ` because the only divisors
       are ` 1 ` and ` P ` .  (Contributed by Mario Carneiro, 17-May-2016.) $)
    1sgmprm $p |- ( P e. Prime -> ( 1 sigma P ) = ( P + 1 ) ) $=
      ( vk cprime wcel c1 cexp csgm cc0 cfz ccxp csu caddc cn0 wceq ax-1cn 1nn0
      co cc oveq2 eqtrd cv sgmppw mp3an13 prmnn nncnd exp1d oveq2d adantr cxp1d
      wa oveq1d sumeq2dv cmin 1m1e0 oveq2i sumeq1i cz 0z exp0d syl6eqel sylancr
      fsum1 syl5eq oveq12d cuz cfv a1i nn0uz elfznn0 expcl syl2an fsumm1 addcom
      syl6eleq sylancl 3eqtr4d 3eqtr3d ) ACDZEAEFQZGQZHEIQZAEJQZBUAZFQZBKZEAGQA
      ELQZERDZVREMDZVTWENOPEABEUBUCVRVSAEGVRAVRAAUDUEZUFZUGVRWEWAAWCFQZBKZWFVRW
      AWDWKBVRWCWADZUJZWBAWCFWNAVRARDZWMWIUHUIUKULVRHEEUMQZIQZWKBKZVSLQEALQZWLW
      FVRWREVSALVRWRHHIQZWKBKZEWQWTWKBWPHHIUNUOUPVRXAAHFQZEVRHUQDXBRDXAXBNURVRX
      BERVRAWIUSZOUTWKXBBHWCHAFSVBVAXCTVCWJVDVRWKVSBHEVREMHVEVFWHVRPVGVHVNVRWOW
      CMDWKRDWMWIWCEVIAWCVJVKWCEAFSVLVRWOWGWFWSNWIOAEVMVOVPTVQ $.

    $( The sum of the divisors of ` 2 ^ ( N - 1 ) ` .  (Contributed by Mario
       Carneiro, 17-May-2016.) $)
    1sgm2ppw $p |- ( N e. NN ->
      ( 1 sigma ( 2 ^ ( N - 1 ) ) ) = ( ( 2 ^ N ) - 1 ) ) $=
      ( vk cn wcel c1 c2 cmin co cexp cc0 csu cdiv cn0 wceq ax-1cn a1i 2cn cneg
      cc wne csgm cfz ccxp cprime 2prm nnm1nn0 sgmppw syl3anc cxp1 mp1i sumeq2i
      cv oveq1d 1ne2 necomi nnnn0 geoser syl5eq 2nn nnexpcl sylancr nncnd subcl
      sylancl ax-1ne0 div2negd negsubdi2 caddc df-neg 0cn mp3an addid1i oveq12i
      pnpcan 1p1e2 3eqtr2i oveq12d div1d 3eqtr3d 3eqtrd ) ACDZEFAEGHZIHUAHZJWBU
      BHZFEUCHZBULZIHZBKZEFAIHZGHZEFGHZLHZWIEGHZWAESDZFUDDZWBMDWCWHNWNWAOPZWOWA
      UEPAUFEFBWBUGUHWAWHWDFWFIHZBKWLWDWGWQBWFWDDZWEFWFIFSDZWEFNWRQFUIUJUMUKWAF
      BAWSWAQPFETWAEFUNUOPAUPZUQURWAWMRZERZLHWMELHWLWMWAWMEWAWISDZWNWMSDWAWIWAF
      CDAMDWICDUSWTFAUTVAVBZOWIEVCVDZWPEJTWAVEPVFWAXAWJXBWKLWAXCWNXAWJNXDOWIEVG
      VDXBWKNWAXBJEGHZEJVHHZEEVHHZGHZWKEVIWNJSDWNXIXFNOVJOEJEVNVKXGEXHFGEOVLVOV
      MVPPVQWAWMXEVRVSVT $.

    $( The divisor function for fixed parameter ` A ` is a multiplicative
       function.  (Contributed by Mario Carneiro, 2-Jul-2015.) $)
    sgmmul $p |- ( ( A e. CC /\ ( M e. NN /\ N e. NN /\ ( M gcd N ) = 1 ) ) ->
      ( A sigma ( M x. N ) ) = ( ( A sigma M ) x. ( A sigma N ) ) ) $=
      ( vx vj vk vi wcel cn co wceq wa cv cdivides wbr crab ccxp csu cmul csgm
      cc cgcd c1 w3a simpr1 simpr2 simpr3 eqid ssrab2 simpr sseldi nncnd simpll
      cxpcld adantrr nnred nnnn0d nn0ge0d adantrl mulcxpd eqcomd sgmval oveq12d
      oveq1 fsumdvdsmul syldan nnmulcld 3eqtr4rd ) AUAHZBIHZCIHZBCUBJUCKZUDZLZD
      MZBNOZDIPZEMZAQJZERZVOCNOZDIPZFMZAQJZFRZSJVOBCSJZNODIPZGMZAQJZGRZABTJZACT
      JZSJAWFTJZVNDVSWDWIVRWCSJZAQJZGEFBCVQWBWGVIVJVKVLUEZVIVJVKVLUFZVIVJVKVLUG
      VQUHWBUHWGUHVNVRVQHZLZVRAWSVRWSVQIVRVPDIUIVNWRUJUKZULVIVMWRUMUNVNWCWBHZLZ
      WCAXBWCXBWBIWCWADIUIVNXAUJUKZULVIVMXAUMUNVNWRXALZLZWOVSWDSJXEVRWCAXEVRVNW
      RVRIHXAWTUOZUPXEVRXEVRXFUQURXEWCVNXAWCIHWRXCUSZUPXEWCXEWCXGUQURVIVMXDUMUT
      VAWHWNAQVDVEVNWKVTWLWESVIVMVJWKVTKWPABEDVBVFVIVMVKWLWEKWQACFDVBVFVCVIVMWF
      IHWMWJKVNBCWPWQVGAWFGDVBVFVH $.
  $}

  ${
    ppiublem1.1 $e |- ( N <_ 6 /\ ( ( P e. Prime /\ 4 <_ P ) ->
      ( ( P mod 6 ) e. ( N ... 5 ) -> ( P mod 6 ) e. { 1 , 5 } ) ) ) $.
    ppiublem1.2 $e |- M e. NN0 $.
    ppiublem1.3 $e |- N = ( M + 1 ) $.
    ppiublem1.4 $e |- ( 2 || M \/ 3 || M \/ M e. { 1 , 5 } ) $.
    $( Lemma for ~ ppiub .  (Contributed by Mario Carneiro, 12-Mar-2014.) $)
    ppiublem1 $p |- ( M <_ 6 /\ ( ( P e. Prime /\ 4 <_ P ) ->
      ( ( P mod 6 ) e. ( M ... 5 ) -> ( P mod 6 ) e. { 1 , 5 } ) ) ) $=
      ( c6 cle wbr wcel c4 co c5 c1 wi wb c2 cdivides c3 cprime wa caddc simpli
      cmo cfz cpr df-6 3brtr3i nn0rei 5re leadd1i mpbir 5lt6 ltleii letri mp2an
      1re 6re wceq wo cuz cfv cz nn0zi 5nn nnzi eluz2 mpbir3an elfzp12 w3o prmz
      ax-mp adantr cn 2nn 6nn w3a cmul 3nn dvdsmul2 3t2e6 breqtri dvdsmod mpan2
      2z mp3an12 syl uzid simpl dvdsprm sylancr bitrd simpr breq2 syl5ibrcom wn
      clt 2lt4 2re 4re ltnlei mpbi pm2.21i syl6 sylbid syl5ibcom com3r dvdsmul1
      imbi1d df-3 peano2uz eqeltri 3lt4 3re eleq1a oveq1i eleq2i simpri syl5bir
      a1d 3jaoi jaod syl5bi pm3.2i ) BHIJZAUAKZLAIJZUBZAHUEMZBNUFMKZYJONUGZKZPP
      BNIJZNHIJYFYNBOUCMZNOUCMZIJCHYOYPICHIJZYIYJCNUFMZKZYMPPZDUDFUHUIBNOBEUJZU
      KURULUMZNHUKUSUNUOBNHUUAUKUSUPUQYKYJBUTZYJYONUFMZKZVAZYIYMNBVBVCKZYKUUFQU
      UGBVDKNVDKYNBEVENVFVGUUBBNVHVIYJBNVJVMYIUUCYMUUERBSJZTBSJZBYLKZVKYIUUCYMP
      ZPZGUUHUULUUIUUJYIUUCUUHYMYIRYJSJZYMPUUCUUHYMPYIUUMRAUTZYMYIUUMRASJZUUNYI
      AVDKZUUMUUOQZYGUUPYHAVLVNZRVOKZHVOKZUUPUUQVPVQUUSUUTUUPVRRHSJUUQRTRVSMZHS
      TVDKZRVDKZRUVASJTVTVGZWFTRWAUQWBWCRAHWDWEWGWHYIRRVBVCZKZYGUUOUUNQUVCUVFWF
      RWIVMZYGYHWJZARWKWLWMYIUUNLRIJZYMYIUVIUUNYHYGYHWNZRALIWOWPUVIYMRLWRJUVIWQ
      WSRLWTXAXBXCXDXEXFUUCUUMUUHYMYJBRSWOXJXGXHYIUUCUUIYMYITYJSJZYMPUUCUUIYMPY
      IUVKTAUTZYMYIUVKTASJZUVLYIUUPUVKUVMQZUURTVOKZUUTUUPUVNVTVQUVOUUTUUPVRTHSJ
      UVNTUVAHSUVBUVCTUVASJUVDWFTRXIUQWBWCTAHWDWEWGWHYITUVEKYGUVMUVLQTROUCMZUVE
      XKUVFUVPUVEKUVGRRXLVMXMUVHATWKWLWMYIUVLLTIJZYMYIUVQUVLYHUVJTALIWOWPUVQYMT
      LWRJUVQWQXNTLXOXAXBXCXDXEXFUUCUVKUUIYMYJBTSWOXJXGXHUUJUUKYIBYLYJXPYAYBVMU
      UEYSYIYMYRUUDYJCYONUFFXQXRYQYTDXSXTYCYDYE $.
  $}

  $( A prime greater than ` 3 ` does not divide ` 2 ` or ` 3 ` , so its residue
     ` mod 6 ` is ` 1 ` or ` 5 ` .  (Contributed by Mario Carneiro,
     12-Mar-2014.) $)
  ppiublem2 $p |- ( ( P e. Prime /\ 4 <_ P ) -> ( P mod 6 ) e. { 1 , 5 } ) $=
    ( wcel c4 cle wbr c6 co cc0 c5 cfz c1 cz 5nn wi c2 c3 cdivides ppiublem1 2z
    cmin cprime wa cmo cpr cn prmz adantr zmodfz sylancl caddc df-6 oveq1i wceq
    6nn cc nncni ax-1cn pncan mp2an eqtri oveq2i syl6eleq leidi c0 noel pm2.21i
    6re clt 5lt6 wb nnzi fzn mpbi eleq2s a1i pm3.2i 5nn0 elexi 3mix3i 4nn0 df-5
    prid2 cmul dvdsmul1 2t2e4 breqtri 3mix1i 3nn0 df-4 iddvds ax-mp 3mix2i 2nn0
    3nn df-3 1nn0 df-2 1ex prid1 0nn0 1e0p1 dvds0 simpri mpd ) AUABZCADEZUBZAFU
    CGZHIJGZBZXHKIUDZBZXGXHHFKTGZJGZXIXGALBZFUEBXHXNBXEXOXFAUFUGUNAFUHUIXMIHJXM
    IKUJGZKTGZIFXPKTUKULIUOBKUOBXQIUMIMUPUQIKURUSUTVAVBHFDEXGXJXLNNAHKAKOAOPAPC
    ACIAIFFFDEXGXHFIJGZBXLNZNFVGVCXSXGXLXHVDXRXHVDBXLXHVEVFIFVHEZXRVDUMZVIFLBIL
    BXTYAVJFUNVKIMVKFIVLUSVMVNVOVPVQUKIXKBOIQEPIQEKIIUEMVRWBVSRVTWAOCQEPCQECXKB
    OOOWCGZCQOLBZYCOYBQESSOOWDUSWEWFWGRWHWIPPQEZOPQEPXKBPLBYDPWNVKPWJWKWLRWMWOO
    OQEZPOQEOXKBYCYESOWJWKWGRWPWQKXKBOKQEPKQEKIWRWSVSRWTXAOHQEZPHQEHXKBYCYFSOXB
    WKWGRXCXD $.

  ${
    $d k N $.
    $( An upper bound on the Gauss prime ` pi ` function, which counts the
       number of primes less than ` N ` .  (Contributed by Mario Carneiro,
       13-Mar-2014.) $)
    ppiub $p |- ( ( N e. RR /\ 0 <_ N ) ->
                  ( ppi ` N ) <_ ( ( N / 3 ) + 2 ) ) $=
      ( vk cr wcel cc0 cle wbr cfv c3 cdiv co c2 caddc a1i cmin c6 c1 c5 wceq
      wb wa cppi 3re simpl cmo c4 cfl cfz crab chash adantr 2re resubcl sylancl
      cfn wss ssrab2 ssfi mp2an ax-mp 3nn nndivre mpan2 cprime cin ppi3 oveq12d
      cn cuz cz nnzi syl df-4 oveq1i fveq2i mpbir reflcl peano2rem 6nn peano2re
      5re flle 1re lesub1dd clt 6re lediv1 syl112anc mpbid letrd rabbiia eqtr4i
      c0 wne eqtri mp3an cdivides modid mp4an eqeq2i 1z moddvds mp3an13 syl5bbr
      6pos cc 3cn ax-1cn pncan hashdvds syl5eq 2cn 0re nnne0i 2nn nngt0i ltleii
      cmul nncni pm3.2i breqtri flbi mpbir2an oveq2i flcld zcnd 5nn cneg eqtr3i
      eqtrd mpbi addcomi mpanr12 syl2anc oveq1d sylancr mp3an23 3eqtr3d adantlr
      recnd cv cpr ppicl nn0red fzfi hashcl nn0rei ppifl flcl flge biimpa eluz2
      cn0 syl3anbrc ppidif ineq1i syl6eqr eqtr3d cdom dfin5 wi ppiublem2 expcom
      elfzle1 ss2rabi eqsstri ssdomg inss1 hashdom syl6eqbr leadd1dd le2addd wo
      mp2 cun ovex elpr unrab inrab wn rabeq0 1lt5 ltneii eqtr2 necon3ai hashun
      mprgbir crp nnrp 0le1 1lt6 syl6eleqr df-3 redivcli divgt0ii 2lt6 breqtrri
      elfzelz 4nn mulid1i ltdivmul 1e0p1 subid1d negsubdi2i 3p2e5 pncan2 negeqi
      0z 5lt6 3eqtr2i divneg lenegi ltnegi negidi neg1cn renegcli znegcl subneg
      neg0 2timesd df-6 addsub4 mulcl divsubdir 3t2e6 3ne0 dividi divdir mp3an3
      mulcomi divcan5 npcan addassd 3brtr4d lesubaddd ad2antrr readdcl ppiwordi
      mp3an2 syl6breq 3pos divge0 addge02 lecasei ) ACDZEAFGZUAZAUBHZAIJKZLMKZF
      GZIAICDZVUGUCNVUEVUFUDVUEIAFGZVUKVUFVUEVUMUAZVUHLOKZVUIFGVUKVUNVUOBUUAZPU
      EKZQRUUBDZBUFAUGHZUHKZUIZUJHZVUIVUNVUHCDZLCDZVUOCDVUEVVCVUMVUEVUHAUUCUUDZ
      UKZULVUHLUMUNVVBCDVUNVVBVVAUODZVVBUUMDVUTUODZVVAVUTUPVVGUFVUSUUEZVURBVUTU
      QVUTVVAURUSZVVAUUFUTUUGNVUEVUICDZVUMVUEIVHDVVKVAAIVBVCZUKZVUNVUOVUTVDVEZU
      JHZVVBFVUNVUSUBHZIUBHZOKZVUOVVOVUNVVPVUHVVQLOVUEVVPVUHSVUMAUUHUKVVQLSVUNV
      FNVGVUNVVRIQMKZVUSUHKZVDVEZUJHZVVOVUNVUSIVIHZDZVVRVWBSVUNIVJDZVUSVJDZIVUS
      FGZVWDVWEVUNIVAVKZNVUEVWFVUMAUUIUKVUEVUMVWGVUEVWEVUMVWGTVWHAIUUJVCUUKIVUS
      UULUUNZIVUSUUOVLVVNVWAUJVUTVVTVDUFVVSVUSUHVMVNUUPVOUUQUURVVOVVBFGZVVNVVAU
      USGZVVGVVNVVAUPVWKVVJVVNVUPVDDZBVUTUIVVABVUTVDUUTVWLVURBVUTVUPVUTDZUFVUPF
      GZVWLVURUVAVUPUFVUSUVDVWLVWNVURVUPUVBUVCVLUVEUVFVVNVVAUOUVGUVNVVNUODZVVGV
      WJVWKTVVHVVNVUTUPVWOVVIVUTVDUVHVUTVVNURUSVVJVVNVVAUOUVIUSVPUVJVUNVUSQOKZP
      JKZUGHZVUSROKZPJKZUGHZQMKZMKZAQOKZPJKZAROKZPJKZQMKZMKZVVBVUIFVUNVWRVXBVXE
      VXHVUNVWQCDZVWRCDVUNVWPCDZPVHDZVXJVUNVUSCDZVXKVUEVXMVUMAVQUKZVUSVRVLZVSVW
      PPVBUNZVWQVQVLZVUNVXACDZVXBCDVUNVWTCDZVXRVUNVWSCDZVXLVXSVUNVXMRCDZVXTVXNW
      AVUSRUMUNZVSVWSPVBUNZVWTVQVLZVXAVTVLVUNVXDCDZVXLVXECDVUEVYEVUMAVRUKZVSVXD
      PVBUNZVUNVXGCDZVXHCDVUNVXFCDZVXLVYHVUNVUEVYAVYIVUEVUMUDZWAARUMUNZVSVXFPVB
      UNZVXGVTVLVUNVWRVWQVXEVXQVXPVYGVUNVXJVWRVWQFGVXPVWQWBVLVUNVWPVXDFGZVWQVXE
      FGZVUNVUSAQVXNVYJQCDZVUNWCNZVUEVUSAFGVUMAWBUKZWDVUNVXKVYEPCDZEPWEGZVYMVYN
      TVXOVYFVYRVUNWFNZVYSVUNXENZVWPVXDPWGWHWIWJVUNVXAVXGQVYDVYLVYPVUNVXAVWTVXG
      VYDVYCVYLVUNVXSVXAVWTFGVYCVWTWBVLVUNVWSVXFFGZVWTVXGFGZVUNVUSARVXNVYJVYAVU
      NWANVYQWDVUNVXTVYIVYRVYSWUBWUCTVYBVYKVYTWUAVWSVXFPWGWHWIWJUVKUVLVUNVVBVUQ
      QSZBVUTUIZUJHZVUQRSZBVUTUIZUJHZMKZVXCVVBWUEWUHUVOZUJHZWUJVVAWUKUJVVAWUDWU
      GUVMZBVUTUIWUKVURWUMBVUTVURWUMTVWMVUQQRVUPPUEUVPUVQNWKWUDWUGBVUTUVRWLVOWU
      EUODZWUHUODZWUEWUHVEZWMSWULWUJSVVHWUEVUTUPWUNVVIWUDBVUTUQVUTWUEURUSVVHWUH
      VUTUPWUOVVIWUGBVUTUQVUTWUHURUSWUPWUDWUGUAZBVUTUIZWMWUDWUGBVUTUVSWURWMSWUQ
      UVTZBVUTWUQBVUTUWAWUSVWMQRWNWUSQRWCUWBUWCWUQQRVUQQRUWDUWEUTNUWGWOWUEWUHUW
      FWPWOVUNWUFVWRWUIVXBMVUNWUFVWRUFQOKZQOKZPJKZUGHZOKZVWRVUNWUFPVUPQOKWQGZBV
      UTUIZUJHWVDWUEWVFUJWUDWVEBVUTVWMVUPVJDZWUDWVETVUPUFVUSUWRZWUDVUQQPUEKZSZW
      VGWVEWVIQVUQVYOPUWHDZEQFGQPWEGWVIQSWCVXLWVKVSPUWIUTZUWJUWKQPWRWSWTVXLWVGQ
      VJDZWVJWVETVSXAVUPQPXBXCXDVLWKVOVUNBUFVUSQPVXLVUNVSNZUFVJDVUNUFUWSVKNZVUN
      VUSVWCWUTVIHVWIWUTIVIWUTVVSQOKZIUFVVSQOVMVNIXFDZQXFDZWVPISXGXHIQXIUSWOZVO
      UWLZWVMVUNXANXJXKVUNWVDVWREOKVWRWVCEVWROWVCLPJKZUGHZEWVBWWAUGWVALPJWVALQM
      KZQOKZLWUTWWCQOWUTIWWCWVSUWMWOVNLXFDZWVRWWDLSXLXHLQXIUSWOVNVOWWBESZEWWAFG
      ZWWAEQMKZWEGZEWWAXMLPULWFPVSXNZUWNZLPULWFLXOXPXEUWOZXQWWAQWWHWEWWAQWEGZLP
      QXRKZWEGZLPWWNWEUWPPPVSXSZUWTUWQVVDVYOVYRVYSUAWWMWWOTULWCVYRVYSWFXEXTLQPU
      XAWPVPZUXBYAWWACDEVJDWWFWWGWWIUATWWKUXHWWAEYBUSYCWOYDVUNVWRVUNVWRVUNVWQVX
      PYEYFUXCXKYJVUNWUIVXAWUTROKZPJKZUGHZOKZVXBVUNWUIPVUPROKWQGZBVUTUIZUJHWXAW
      UHWXCUJWUGWXBBVUTVWMWVGWUGWXBTWVHWUGVUQRPUEKZSZWVGWXBWXDRVUQVYAWVKERFGRPW
      EGWXDRSWAWVLERXMWARYGXPXQUXIRPWRWSWTVXLWVGRVJDZWXEWXBTVSRYGVKZVUPRPXBXCXD
      VLWKVOVUNBUFVUSRPWVNWVOWVTWXFVUNWXGNXJXKVUNWXAVXAQYHZOKZVXBWWTWXHVXAOWWTW
      WAYHZUGHZWXHWWSWXJUGWWSLYHZPJKZWXJWWRWXLPJWWRIROKRIOKZYHWXLWUTIROWVSVNRIR
      YGXSZXGUXDWXNLILMKZIOKZWXNLWXPRIOUXEVNWVQWWEWXQLSXGXLILUXFUSYIUXGUXJVNWWE
      PXFDZPEWNZWXJWXMSXLWWPWWJLPUXKWPWLVOWXKWXHSZWXHWXJFGZWXJWXHQMKZWEGZWWAQFG
      WYAWWAQWWKWCWWQXQWWAQWWKWCUXLYKWXJEYHZWYBWEEWWAWEGWXJWYDWEGWWLEWWAXMWWKUX
      MYKWYDQWXHMKZWYBWYDEWYEUXSQXHUXNWLWXHQUXOXHYLWLYAWXJCDWXHVJDZWXTWYAWYCUAT
      WWAWWKUXPWVMWYFXAQUXQUTWXJWXHYBUSYCWOYDVUNVXAXFDWVRWXIVXBSVUNVXAVUNVWTVYC
      YEYFXHVXAQUXRUNXKYJVGXKVUNVUIQOKZQMKZVXEVXGMKZQMKVUIVXIVUNWYGWYIQMVUNLAXR
      KZPOKZPJKZVXDVXFMKZPJKZWYGWYIVUNWYKWYMPJVUNWYKAAMKZQRMKZOKZWYMVUNWYJWYOPW
      YPOVUNAVUNAVYJYTZUXTPWYPSVUNPRQMKWYPUYARQWXOXHYLWONVGVUNAXFDZWYSWYQWYMSZW
      YRWYRWYSWYSUAWVRRXFDWYTXHWXOAAQRUYBYMYNYJYOVUNWYLWYJPJKZPPJKZOKZWYGVUNWYJ
      XFDZWYLXUCSZVUNWWEWYSXUDXLWYRLAUYCYPXUDWXRWXRWXSUAZXUEWWPWXRWXSWWPWWJXTZW
      YJPPUYDYQVLVUNXUAVUIXUBQOVUNXUAWYJLIXRKZJKZVUIPXUHWYJJILXRKPXUHUYEILXGXLU
      YJYIYDVUNWYSXUIVUISZWYRWYSWVQIEWNZUAWWELEWNZUAXUJWVQXUKXGUYFXTWWEXULXLLXO
      XNXTAILUYKYQVLXKXUBQSVUNPWWPWWJUYGNVGYJVUNVXDXFDZVXFXFDZWYNWYISZVUNVXDVYF
      YTVUNVXFVYKYTXUMXUNXUFXUOXUGVXDVXFPUYHUYIYNYRYOVUNVUIXFDWVRWYHVUISVUNVUIV
      VMYTXHVUIQUYLUNVUNVXEVXGQVUNVXEVYGYTVUNVXGVYLYTWVRVUNXHNUYMYRUYNWJVUNVUHL
      VUIVVFVVDVUNULNVVMUYOWIYSVUGAIFGZUAZVUHLVUJVUEVVCVUFXUPVVEUYPVVDXUQULNXUQ
      VVKVVDVUJCDVUEVVKVUFXUPVVLUYPZULVUILUYQUNXUQVUHVVQLFVUEXUPVUHVVQFGZVUFVUE
      VULXUPXUSUCAIUYRUYSYSVFUYTXUQEVUIFGZLVUJFGZVUGXUTXUPVUGVULEIWEGXUTUCVUAAI
      VUBYMUKXUQVVDVVKXUTXVATULXURLVUIVUCYPWIWJVUD $.
  $}

  ${
    $d k n p A $.  $d k n p x N $.
    $( The von Mangoldt function is less than the natural log.  (Contributed by
       Mario Carneiro, 7-Apr-2016.) $)
    vmalelog $p |- ( A e. NN -> ( Lam ` A ) <_ ( log ` A ) ) $=
      ( vp vk cn wcel cvma cfv clog cle wbr cc0 cv co wceq cprime adantr adantl
      wrex crp c1 breq1 cexp isppw2 wa cmul prmnn nnrpd relogcld cr nnre nnge1d
      wne log1 wb 1rp logleb sylancr mpbid syl5eqbrr nnge1 lemulge12d vmappw cz
      nnz relogexp syl2an 3brtr4d fveq2 breq12d syl5ibrcom rexlimivv syl6bi imp
      nnrp pm2.61ne ) ADEZAFGZAHGZIJZKVRIJVQKVQKVRIUAVPVQKULZVSVPVTABLZCLZUBMZN
      ZCDRBORVSACBUCWDVSBCODWAOEZWBDEZUDZVSWDWCFGZWCHGZIJWGWAHGZWBWJUEMZWHWIIWG
      WJWBWGWAWEWASEZWFWEWAWAUFZUGZPZUHWFWBUIEWEWBUJQWGKTHGZWJIUMWGTWAIJZWPWJIJ
      ZWGWAWEWADEWFWMPUKWGTSEZWLWQWRUNUOWOTWAUPUQURUSWFTWBIJWEWBUTQVAWAWBVBWEWL
      WBVCEWIWKNWFWNWBVDWAWBVEVFVGWDVQWHVRWIIAWCFVHAWCHVHVIVJVKVLVMVPKWPVRIUMVP
      TAIJZWPVRIJZAUTVPWSASEWTXAUNUOAVNTAUPUQURUSVO $.

    $( The first Chebyshev function is less than the second.  (Contributed by
       Mario Carneiro, 7-Apr-2016.) $)
    chtlepsi $p |- ( A e. RR -> ( theta ` A ) <_ ( psi ` A ) ) $=
      ( vn cr wcel cc0 cicc co cprime cin cv cvma cfv csu c1 cfz cle wa cn syl
      c2 cfl ccht cchp fzfid elfznn adantl vmacl wbr vmage0 ppisval cuz wss 2nn
      inss1 nnuz eleqtri fzss1 mp1i syl5ss eqsstrd clog chtval wceq inss2 simpr
      fsumless sseldi vmaprm sumeq2dv eqtr4d chpval 3brtr4d ) ACDZEAFGZHIZBJZKL
      ZBMZNAUALZOGZVQBMAUBLZAUCLPVMVTVQVOBVMNVSUDVMVPVTDZQZVPRDZVQCDWBWDVMVPVSU
      EUFZVPUGSWCWDEVQPUHWEVPUISVMVOTVSOGZHIZVTAUJVMWGWFVTWFHUNTNUKLZDWFVTULVMT
      RWHUMUOUPTNVSUQURUSUTVFVMWAVOVPVALZBMVRABVBVMVOVQWIBVMVPVODZQZVPHDVQWIVCW
      KVOHVPVNHVDVMWJVEVGVPVHSVIVJABVKVL $.

    $( Closure of the second Chebyshev function in the positive reals.
       (Contributed by Mario Carneiro, 8-Apr-2016.) $)
    chprpcl $p |- ( ( A e. RR /\ 2 <_ A ) -> ( psi ` A ) e. RR+ ) $=
      ( cr wcel c2 cle wbr cchp cfv ccht chpcl adantr chtrpcl chtlepsi rpgecld
      wa ) ABCZDAEFZOAGHZAIHZPRBCQAJKALPSREFQAMKN $.

    $( The second Chebyshev function is zero iff its argument is less than
       ` 2 ` .  (Contributed by Mario Carneiro, 9-Apr-2016.) $)
    chpeq0 $p |- ( A e. RR -> ( ( psi ` A ) = 0 <-> A < 2 ) ) $=
      ( cr wcel cchp cfv cc0 wceq c2 clt wbr wn cle wb wa ex adantr a1i sylancl
      c1 cz wne 2re lenlt mpan chprpcl rpne0d sylbird necon4bd cfl reflcl caddc
      1re co 2z fllt mpan2 biimpa df-2 syl6breq flcl 1z zleltp1 mpbird chpwordi
      syl3anc chpfl chp1 3brtr3d chpge0 chpcl 0re letri3 mpbir2and impbid ) ABC
      ZADEZFGZAHIJZVOVRVPFVOVRKZHALJZVPFUAZHBCVOVTVSMUBHAUCUDVOVTWAVOVTNVPAUEUF
      OUGUHVOVRVQVOVRNZVQVPFLJZFVPLJZWBAUIEZDEZSDEZVPFLWBWEBCZSBCZWESLJZWFWGLJV
      OWHVRAUJPWIWBULQWBWJWESSUKUMZIJZWBWEHWKIVOVRWEHIJZVOHTCVRWMMUNAHUOUPUQURU
      SWBWETCZSTCWJWLMVOWNVRAUTPVAWESVBRVCWESVDVEVOWFVPGVRAVFPWGFGWBVGQVHVOWDVR
      AVIPWBVPBCZFBCVQWCWDNMVOWOVRAVJPVKVPFVLRVMOVN $.

    $( The first Chebyshev function is zero iff its argument is less than
       ` 2 ` .  (Contributed by Mario Carneiro, 9-Apr-2016.) $)
    chteq0 $p |- ( A e. RR -> ( ( theta ` A ) = 0 <-> A < 2 ) ) $=
      ( cr wcel ccht cfv cc0 wceq c2 clt wbr wn cle wne wb 2re lenlt mpan wa ex
      adantr chtrpcl rpne0d sylbird necon4bd cchp chpeq0 biimpar breqtrd chtge0
      chtlepsi chtcl 0re letri3 sylancl mpbir2and impbid ) ABCZADEZFGZAHIJZUQUT
      URFUQUTKZHALJZURFMZHBCUQVBVANOHAPQUQVBVCUQVBRURAUAUBSUCUDUQUTUSUQUTRZUSUR
      FLJZFURLJZVDURAUEEZFLUQURVGLJUTAUJTUQVGFGUTAUFUGUHUQVFUTAUITVDURBCZFBCUSV
      EVFRNUQVHUTAUKTULURFUMUNUOSUP $.

    $( Upper bound on the ` theta ` function.  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    chtleppi $p |- ( A e. RR+ ->
      ( theta ` A ) <_ ( ( ppi ` A ) x. ( log ` A ) ) ) $=
      ( vp wcel cc0 co cprime clog cfv csu cmul cle cr syl sseldi adantr wbr ce
      wb wceq 3brtr4d crp cicc cin cv ccht cppi rpre ppifi wa inss2 simpr prmnn
      cfn cn nnrpd relogcld relogcl w3a 0re elicc2 sylancr biimpa syldan simp3d
      inss1 reeflogd reeflog efle syl2anc mpbird fsumle chtval ppival oveq1d cc
      chash recnd fsumconst eqtr4d ) AUACZDAUBEZFUCZBUDZGHZBIZWBAGHZBIZAUEHZAUF
      HZWFJEZKVTWBWDWFBVTALCZWBUMCZAUGZAUHMZVTWCWBCZUIZWCWPWCWPWCFCWCUNCWPWBFWC
      WAFUJVTWOUKZNWCULMUOZUPZVTWFLCZWOAUQZOZWPWDWFKPZWDQHZWFQHZKPZWPWCAXDXEKWP
      WCLCZDWCKPZWCAKPZVTWOWCWACZXGXHXIURZWPWBWAWCWAFVEWQNVTXJXKVTDLCWKXJXKRUSW
      MDAWCUTVAVBVCVDWPWCWRVFVTXEASWOAVGOTWPWDLCWTXCXFRWSXBWDWFVHVIVJVKVTWKWHWE
      SWMABVLMVTWJWBVPHZWFJEZWGVTWIXLWFJVTWKWIXLSWMAVMMVNVTWLWFVOCWGXMSWNVTWFXA
      VQWBWFBVRVIVST $.

    $( Lemma for ~ chtub .  (Contributed by Mario Carneiro, 13-Mar-2014.) $)
    chtublem $p |- ( N e. NN -> ( theta ` ( ( 2 x. N ) - 1 ) ) <_
                ( ( theta ` N ) + ( ( log ` 4 ) x. ( N - 1 ) ) ) ) $=
      ( cn wcel c2 cmul co c1 cmin cfv caddc cr syl cc0 cn0 cle wbr cc wceq cpc
      adantr vp vn vk ccht cbc clog 2nn nnmulcl mpan nnred peano2rem chtcl nnre
      cfz nnnn0 2m1e1 oveq2i nncnd 2cn ax-1cn subsub mp3an23 nncn subdi mp3an13
      mulid1i syl6eq oveq1d eqtr4d syl5eqr 2nn0 nnm1nn0 sylancr nn0p1nn eqeltrd
      c4 nn0mulcl 1re a1i leadd2dd 2timesd breqtrrd syl3anc readdcld 4re nn0red
      wb ce cdivides cv cprime wa cif iftrue adantl wi breq2d syl5ibrcom wn cfa
      cuz cz nnzd eluz syl2anr mpbird syl2anc faccl iffalse nn0cnd eqtrd fveq2d
      cdiv oveq2d wne nnz nnne0 jca nnmulcld pcmul 3eqtrd pceq0 pm2.61d nn0ge0d
      mtod 1nn0 cmpt prmorcht cexp ralrimiva pcmpt efchtcl 3brtr4d efle csu wss
      recnd eqeltrrd oveq2 mulcom nnge1 leaddsub mpbid elfz2nn0 syl3anbrc bccl2
      nnrpd relogcld crp 4pos elrpii relogcl ax-mp remulcl wral simpr nn0addge1
      pccld prmnn ad2antlr simprl prmz dvdsfac id pcelnn nnge1d ad2antll bcval2
      addid2d addsubassd pncan2d simprr prmfac1 3expia simpld dvdsmultr1 facnn2
      pcdiv sylan sylibrd oveq12d 00id pccl subid1d expr eqbrtrd ex 0nn0 keepel
      nn0addcl breq1d cseq eqid exp1d ifeq1d mpteq2ia eqcomi eqidd simpl dvdsle
      pc2dvds mpd efadd reeflogd fzfid elfzelz bccl syl2an nn0uz syl6eleq fzss1
      fzss2 sstrd fsumless bccmpl npcand peano2uz sselda syldan fsumm1 3eqtr4rd
      nn0zd fsum1 uzid binom11 expp1 expmuld sq2 oveq1i 3brtr3d clt reexpcl 2re
      2pos pm3.2i lemul1 recni reexplog letrd ) ABCZDAEFZGHFZUDIZAUDIZVUBAUEFZU
      FIZJFZVUDVPUFIZAGHFZEFZJFUYTVUBKCZVUCKCZUYTVUAKCZVUKUYTVUADBCUYTVUABCUGDA
      UHUIZUJZVUAUKLZVUBULLZUYTVUDVUFUYTAKCZVUDKCAUMZAULLZUYTVUEUYTVUEUYTAMVUBU
      NFZCZVUEBCZUYTANCZVUBNCZAVUBOPZVVBAUOZUYTVUBBCZVVEUYTVUBDVUIEFZGJFZBUYTVU
      BVUADGHFZHFZVVJVVKGVUAHUPUQUYTVVLVUADHFZGJFZVVJUYTVUAQCZVVLVVNRZUYTVUAVUN
      URVVODQCZGQCZVVPUSUTVUADGVAVBLUYTVVIVVMGJUYTVVIVUADGEFZHFZVVMUYTAQCZVVIVV
      TRZAVCZVVQVWAVVRVWBUSUTDAGVDVELVVSDVUAHDUSVFUQVGVHVIVJZUYTVVINCZVVJBCUYTD
      NCZVUINCZVWEVKAVLZDVUIVQVMZVVIVNLVOZVUBUOLZUYTAGJFZVUAOPZVVFUYTVWLAAJFZVU
      AOUYTGAAGKCZUYTVRVSZVUSVUSAUUAVTUYTAVWCWAZWBUYTVURVWOVUMVWMVVFWGVUSVWPVUO
      AGVUAUUBWCUUCZAVUBUUDUUEZAVUBUUFLZUUGZUUHZWDZUYTVUDVUJVUTUYTVUHKCZVUIKCVU
      JKCZVPUUICZVXDVPWEUUJUUKZVPUULUUMZUYTVUIVWHWFVUHVUIUUNVMZWDUYTVUCVUGOPZVU
      CWHIZVUGWHIZOPZUYTVXKVUDWHIZVUEEFZVXLOUYTVXKVXOWIPZVXKVXOOPZUYTVXPUAWJZVX
      KSFZVXRVXOSFZOPZUAWKUUOZUYTVYAUAWKUYTVXRWKCZWLZVXRVUBOPZGMWMZVXRAOPZGMWMZ
      VXRVUESFZJFZVXSVXTOVYDVYEVYFVYJOPZVYDVYEVYKVYDVYEWLZVYFGVYJOVYEVYFGRVYDVY
      EGMWNWOVYLVYGGVYJOPZVYDVYGVYMWPVYEVYDVYMVYGGGVYIJFZOPZVYDVWOVYINCZVYOVRVY
      DVXRVUEUYTVYCUUPZUYTVVCVYCVWTTZUURZGVYIUUQVMVYGVYJVYNGOVYGVYHGVYIJVYGGMWN
      VHWQWRTVYDVYEVYGWSZVYMVYDVYEVYTWLZWLZGVXRVUBWTIZSFZVYJOWUBWUDWUBWUDBCZVXR
      WUCWIPZWUBVXRBCZVUBVXRXAICZWUFVYCWUGUYTWUAVXRUUSUUTWUBWUHVYEVYDVYEVYTUVAV
      YDWUHVYEWGZWUAVYCVXRXBCZVUBXBCZWUIUYTVXRUVBZUYTVUBVWJXCZVXRVUBXDXETXFVXRV
      UBUVCXGVYDWUEWUFWGZWUAVYCVYCWUCBCZWUNUYTVYCUVDZUYTVVEWUOVWKVUBXHLZVXRWUCU
      VEXETXFUVFWUBVYJMVYIJFZVYIWUDVYTVYJWURRVYDVYEVYTVYHMVYIJVYGGMXIVHUVGVYDWU
      RVYIRWUAVYDVYIVYDVYIVYSXJUVITWUBVYIWUDVXRVUIWTIZSFZVXRAWTIZSFZJFZHFZWUDMH
      FZWUDVYDVYIWVDRWUAVYDVYIVXRWUCWUSWVAEFZXMFZSFZWUDVXRWVFSFZHFZWVDVYDVUEWVG
      VXRSUYTVUEWVGRVYCUYTVUEWUCVUBAHFZWTIZWVAEFZXMFZWVGUYTVVBVUEWVNRVWSAVUBUVH
      LUYTWVMWVFWUCXMUYTWVLWUSWVAEUYTWVKVUIWTUYTWVKAVUIJFZAHFVUIUYTVUBWVOAHUYTV
      UBVWNGHFWVOUYTVUAVWNGHVWQVHUYTAAGVWCVWCVVRUYTUTVSZUVJXKVHUYTAVUIVWCUYTVUI
      VWHXJZUVKXKZXLVHXNXKTXNVYDVYCWUCXBCZWUCMXOZWLZWVFBCZWVHWVJRVYQUYTWWAVYCUY
      TWUOWWAWUQWUOWVSWVTWUCXPWUCXQXRLTUYTWWBVYCUYTWUSWVAUYTVWGWUSBCZVWHVUIXHLZ
      UYTVVDWVABCZVVGAXHLZXSTWUCWVFVXRUVRWCVYDWVIWVCWUDHVYDVYCWUSXBCZWUSMXOZWLZ
      WVAXBCZWVAMXOZWLZWVIWVCRVYQUYTWWIVYCUYTWWCWWIWWDWWCWWGWWHWUSXPWUSXQXRLTZU
      YTWWLVYCUYTWWEWWLWWFWWEWWJWWKWVAXPWVAXQXRLTWUSWVAVXRXTWCXNYATWUBWVCMWUDHW
      UBWVCMMJFMWUBWUTMWVBMJWUBWUTMRZVXRWUSWIPZWSZWUBWWOVXRWVAWIPZWUBWWQVYGVYDV
      YEVYTUVLVYDWWQVYGWPZWUAUYTVVDVYCWWRVVGVVDVYCWWQVYGVXRAUVMUVNUVSTYEZVYDWWO
      WWQWPWUAVYDWWOVXRWUSAEFZWIPZWWQVYDWUJWWGAXBCZWWOWXAWPVYCWUJUYTWULWOVYDWWG
      WWHWWMUVOUYTWXBVYCAXPZTVXRWUSAUVPWCVYDWVAWWTVXRWIUYTWVAWWTRVYCAUVQTWQUVTT
      YEVYDWWNWWPWGZWUAVYCVYCWWCWXDUYTWUPWWDVXRWUSYBXETXFWUBWVBMRZWWQWSZWWSVYDW
      XEWXFWGZWUAVYCVYCWWEWXGUYTWUPWWFVXRWVAYBXETXFUWAUWBVGXNVYDWVEWUDRWUAVYDWU
      DVYDWUDVYCVYCWUOWUDNCUYTWUPWUQVXRWUCUWCXEXJUWDTYAYAWBUWEYCUWFUWGVYDVYKVYE
      WSZMVYJOPVYDVYJVYDVYHNCVYPVYJNCVYGGMNYFUWHUWIVYSVYHVYIUWJVMYDWXHVYFMVYJOV
      YEGMXIUWKWRYCVYDVXSVXRVUBEUBBUBWJZWKCZWXIGWMZYGZGUWLZIZSFZVYFUYTVXSWXORVY
      CUYTVXKWXNVXRSUYTVVHVXKWXNRVWJVUBUBWXLWXLUWMZYHLXNTVYDGGVXRUBWXLVUBUBBWXJ
      WXIGYIFZGWMZYGWXLUBBWXRWXKWXIBCZWXJWXQWXIGWXSWXIWXIVCUWNUWOUWPUWQZVYDGNCZ
      UBWKWYAVYDWXJWLYFVSYJZUYTVVHVYCVWJTVYQWXIVXRRGUWRZYKXKVYDVXTVXRVXNSFZVYIJ
      FZVYJVYDVYCVXNXBCZVXNMXOZWLZVUEXBCZVUEMXOZWLZVXTWYERVYQVYDVXNBCZWYHUYTWYL
      VYCUYTVURWYLVUSAYLLZTWYLWYFWYGVXNXPVXNXQXRLVYDVVCWYKVYRVVCWYIWYJVUEXPVUEX
      QXRLVXNVUEVXRXTWCVYDWYDVYHVYIJVYDWYDVXRAWXMIZSFZVYHUYTWYDWYORVYCUYTVXNWYN
      VXRSAUBWXLWXPYHXNTVYDGGVXRUBWXLAWXTWYBUYTVYCUWSVYQWYCYKXKVHXKYMYJUYTVXKXB
      CZVXOXBCVXPVYBWGUYTVXKUYTVUKVXKBCVUPVUBYLLXCZUYTVXOUYTVXNVUEWYMVWTXSZXCVX
      KVXOUAUXAXGXFUYTWYPVXOBCVXPVXQWPWYQWYRVXKVXOUWTXGUXBUYTVXLVXNVUFWHIZEFZVX
      OUYTVUDQCVUFQCVXLWYTRUYTVUDVUTYQUYTVUFVXBYQVUDVUFUXCXGUYTWYSVUEVXNEUYTVUE
      VXAUXDZXNXKWBUYTVULVUGKCVXJVXMWGVUQVXCVUCVUGYNXGXFUYTVUFVUJVUDVXBVXIVUTUY
      TVUFVUJOPZWYSVUJWHIZOPZUYTVUEVPVUIYIFZWYSXUCOUYTVUEXUEOPZVUEDEFZXUEDEFZOP
      ZUYTDVUEEFZDVUBYIFZXUGXUHOUYTVUIAUNFZVUBUCWJZUEFZUCYOZVVAXUNUCYOZXUJXUKOU
      YTVVAXUNXULUCUYTMVUBUXEUYTXUMVVACZWLZXUNUYTVVEXUMXBCXUNNCXUQVWKXUMMVUBUXF
      XUMVUBUXGUXHZWFXURXUNXUSYDUYTXULMAUNFZVVAUYTVUIMXAIZCXULXUTYPUYTVUINXVAVW
      HUXIUXJVUIMAUXKLUYTVUBAXAICZXUTVVAYPUYTXVBVVFVWRUYTWXBWUKXVBVVFWGWXCWUMAV
      UBXDXGXFAMVUBUXLLUXMZUXNUYTVUIVUIUNFXUNUCYOZVUEJFVUEVUEJFXUOXUJUYTXVDVUEV
      UEJUYTXVDVUBVUIUEFZVUEUYTVUIXBCZXVEQCXVDXVERUYTVUIVWHUYBZUYTVUEXVEQUYTVUE
      VUBWVKUEFZXVEUYTVVEWXBVUEXVHRVWKWXCAVUBUXOXGUYTWVKVUIVUBUEWVRXNXKZUYTVUEV
      WTURZYRXUNXVEUCVUIXUMVUIVUBUEYSUYCXGXVIVIVHUYTXUNVUEUCVUIAUYTVUIGJFZAVUIX
      AIZUYTAGVWCWVPUXPUYTVUIXVLCZXVKXVLCUYTXVFXVMXVGVUIUYDLVUIVUIUXQLYRUYTXUMX
      ULCXUQXUNQCUYTXULVVAXUMXVCUXRXURXUNXUSXJUXSXUMAVUBUEYSUXTUYTVUEXVJWAUYAUY
      TVVEXUKXUPRVWKUCVUBUYELYMUYTVVQVUEQCXUJXUGRUSXVJDVUEYTVMUYTXUKDVVJYIFZDVV
      IYIFZDEFZXUHUYTVUBVVJDYIVWDXNUYTVVQVWEXVNXVPRUSVWIDVVIUYFVMUYTXVOXUEDEUYT
      XVODDYIFZVUIYIFXUEUYTDDVUIVVQUYTUSVSVWHVWFUYTVKVSUYGXVQVPVUIYIUYHUYIVGVHY
      AUYJUYTVUEKCXUEKCZDKCZMDUYKPZWLZXUFXUIWGUYTVUEVWTUJUYTVPKCVWGXVRWEVWHVPVU
      IUYLVMXWAUYTXVSXVTUYMUYNUYOVSVUEXUEDUYPWCXFXUAUYTXUCVUIVUHEFZWHIZXUEUYTVU
      JXWBWHUYTVUHQCVUIQCVUJXWBRVUHVXHUYQWVQVUHVUIYTVMXLUYTVXFXVFXUEXWCRVXGXVGV
      PVUIUYRVMVIYMUYTVUFKCVXEXUBXUDWGVXBVXIVUFVUJYNXGXFVTUYS $.

    $( An upper bound on the Chebyshev function.  (Contributed by Mario
       Carneiro, 13-Mar-2014.)  (Revised 22-Sep-2014.) $)
    chtub $p |- ( ( N e. RR /\ 2 < N ) ->
                    ( theta ` N ) < ( ( log ` 2 ) x. ( ( 2 x. N ) - 3 ) ) ) $=
      ( vk cr wcel c2 clt wbr cfv wceq ccht cmul co c3 cmin c1 caddc adantr a1i
      cle syl vx vn cfl clog cuz fveq2 cc0 crp 2re 1lt2 rplogcl mp2an elrp mpbi
      wa simpli recni mulid1i cht2 syl6reqr chtfl sylan9eqr c4 2t2e4 df-4 eqtri
      eqtr4i simplr wb ltmul2 syl3anc syl5eqbrr 3re 1re remulcl sylancr resubcl
      mpbid sylancl eqbrtrrd chtcl ad2antrr df-3 fveq2i cfz cv wral eluzfz2 3nn
      simpr oveq2 raleqdv c6 c8 elrpii fveq2d syl6eq oveq2d oveq1d oveq1i pncan
      3cn cc cexp 2rp ax-mp mulcomi cz relogexp cdiv wi 2cn 2ne0 eluzle eluzelz
      2z zltp1le mp3an13 syl5eqbr ltle recnd breq12d rspcv ax-1cn adddi mp3an23
      eqtrd oveq2i subsub3 breq2d zred zmulcl syl5eq cn syld wn imp wo mpjaodan
      lemul2 simpl 2pos pm3.2i ltaddsub2d syl6eleqr nnzi 6lt8 6re 6pos 8re 8pos
      reflcl logltb elfz1eq cht3 2timesi relogcl cu2 3brtr4d rgen dividi mpbird
      csn eluzelre ltdiv1 rehalfcld ltadd1 peano2z adantl mpd leadd2dd 2halvesd
      df-2 breqtrd mp3an2 syl2anr mpbir2and wne divcan2 oveq12d 2p1e3 subaddrii
      elfz syl5reqr peano2rem ltadd1d adddid zcnd 2timesd addsubd eqtr3d 3bitrd
      3eqtr2rd elfzuz nnuz uztrn2 chtublem addsubass sq2 3eqtr3i mulassd 3eqtrd
      2m1e1 3brtr3d peano2uz readdcld lelttr mpand sylbid ltp1d ltsub1dd mpan2d
      lttr cprime cdivides dvdsval2 mp3an12 2lt3 breq2 mtbii nsyl3 uzid dvdsprm
      ltnlei mtbird con2d sylbird chtnprm syl2anc breq1d sylibrd zeo ovex ralsn
      syl6ibr ancld ralun fzsuc syl5ibr uzind4i sylc flle lesub1dd ltletrd flcl
      ex cun mpan flge mpan2 sylibd eluz2 syl3anbrc uzp1 ) ACDZEAFGZUOZAUCHZEIZ
      AJHZEUDHZEAKLZMNLZKLZFGVUREOPLZUEHZDZVUQVUSUOZVVAOKLZVUTVVDFVUSVUQVVIVURJ
      HZVUTVUSVVJEJHZVVIVUREJUFVVIVVAVVKVVAVVAVVACDZUGVVAFGZVVAUHDZVVLVVMUOZECD
      ZOEFGVVNUIUJEUKULVVAUMUNZUPZUQURUSVGUTVUOVVJVUTIZVUPAVAQZVBVVHOVVCFGZVVIV
      VDFGZVVHMOPLZVVBFGVWAVVHVWCEEKLZVVBFVWDVCVWCVDVEVFVVHVUPVWDVVBFGZVUOVUPVU
      SVHVVHVVPVUOVVPUGEFGZUOZVUPVWEVIVVPVVHUIRVUQVUOVUSVUOVUPUUAZQVWGVVHVVPVWF
      UIUUBUUCZREAEVJVKVRVLVVHMOVVBMCDZVVHVMROCDZVVHVNRZVUQVVBCDZVUSVUQVVPVUOVW
      MUIVWHEAVOVPZQUUDVRVVHVWKVVCCDZVVOVWAVWBVIVWLVUQVWOVUSVUQVWMVWJVWOVWNVMVV
      BMVQVSZQVVOVVHVVQROVVCVVAVJVKVRVTVUQVVGUOZVUTVVAEVURKLZMNLZKLZVVDVUOVUTCD
      VUPVVGAWAWBVWQVVLVWSCDZVWTCDVVRVWQVWRCDZVWJVXAVWQVVPVURCDZVXBUIVUOVXCVUPV
      VGAUULWBZEVURVOVPZVMVWRMVQVSZVVAVWSVOVPVWQVVLVWOVVDCDVVRVUQVWOVVGVWPQZVVA
      VVCVOVPVWQVVJVUTVWTFVUQVVSVVGVVTQVWQVURMUEHZDZVVJVWTFGZVWQVURVVFVXHVUQVVG
      WJMVVEUEWCWDUUEVXIVURMVURWELZDBWFZJHZVVAEVXLKLZMNLZKLZFGZBVXKWGZVXJMVURWH
      VXQBMUAWFZWELZWGVXQBMMWELZWGVXQBMUBWFZWELZWGZVXQBMVYBOPLZWELZWGZVXRUAUBMV
      URMWIUUFZVXSMIVXQBVXTVYAVXSMMWEWKWLVXSVYBIVXQBVXTVYCVXSVYBMWEWKWLVXSVYEIV
      XQBVXTVYFVXSVYEMWEWKWLVXSVURIVXQBVXTVXKVXSVURMWEWKWLVXQBVYAVXLVYADZWMUDHZ
      WNUDHZVXMVXPFVYJVYKFGZVYIWMWNFGZVYLUUGWMUHDWNUHDVYMVYLVIWMUUHUUIWOWNUUJUU
      KWOWMWNUUMULUNRVYIVXMMJHVYJVYIVXLMJVXLMUUNZWPUUOWQVYIVXPVVAMKLZVYKVYIVXOM
      VVAKVYIVXOEMKLZMNLZMVYIVXNVYPMNVYIVXLMEKVYNWRWSVYQMMPLZMNLZMVYPVYRMNMXBUU
      PWTMXCDZVYTVYSMIXBXBMMXAULVFWQWRVYOEMXDLZUDHZVYKVYOMVVAKLZWUBVVAMVVAEUHDZ
      VVLXEEUUQXFZUQZXBXGWUDMXHDZWUBWUCIXEVYHEMXIULVGWUAWNUDUURWDVFWQUUSUUTVYBV
      XHDZVYDVYDVXQBVYEUVCZWGZUOZVYGWUHVYDWUJWUHVYDVYEJHZVVAEVYEKLZMNLZKLZFGZWU
      JWUHVYBEXJLZXHDZVYDWUPXKVYEEXJLXHDZWUHWURUOZVYDWUQOPLZJHZVVAEWVAKLZMNLZKL
      ZFGZWUPWUTWVAVYCDZVYDWVFXKWUTWVGMWVASGZWVAVYBSGZWUTMVVEWVASWCWUTEWVAFGZVV
      EWVASGZWUHWVJWURWUHEOOPLZWVAFUVMWUHOWUQFGZWVLWVAFGZWUHOEEXJLZWUQFEXLXMUVA
      WUHEVYBFGZWVOWUQFGZWUHWVPVVEVYBSGZWUHVVEMVYBSWCMVYBXNVLWUHEXHDZVYBXHDZWVP
      WVRVIXPMVYBXOZEVYBXQVPUVBWUHVYBCDZWVPWVQVIZMVYBUVDZVVPWWBVWGWWCUIVWIEVYBE
      UVEXRTVRVLZWUHWUQCDZWVMWVNVIZWUHVYBWWDUVFZVWKWWFVWKWWGVNVNOWUQOUVGXRTVRXS
      QWUTWVSWVAXHDZWVJWVKVIXPWURWWIWUHWUQUVHZUVIZEWVAXQVPVRXSWUHWVIWURWUHWVAWU
      QWUQPLVYBSWUHOWUQWUQVWKWUHVNRWWHWWHWUHWVMOWUQSGZWWEWUHVWKWWFWVMWWLXKVNWWH
      OWUQXTVPUVJUVKWUHVYBWUHVYBWWDYAZUVLUVNQWURWWIWVTWVGWVHWVIUOVIZWUHWWJWWAWW
      IWUGWVTWWNVYHWVAMVYBUWCUVOUVPUVQZVXQWVFBWVAVYCVXLWVAIZVXMWVBVXPWVEFVXLWVA
      JUFWWPVXOWVDVVAKWWPVXNWVCMNVXLWVAEKWKWSWRYBYCTWUTWVFWVBVVAVYBKLZPLZWUOFGZ
      WUPWUTWVFWVBVVAVYBONLZKLZFGWWRWXAWWQPLZFGWWSWUTWVEWXAWVBFWUTWVDWWTVVAKWUT
      WVDVYBEPLZMNLZWWTWUTWVCWXCMNWUTWVCEWUQKLZEOKLZPLZWXCWUTWUQXCDZWVCWXGIZWUH
      WXHWURWUHWUQWWHYAQZEXCDZWXHOXCDZWXIXLYDEWUQOYEXRTWUTWXEVYBWXFEPWUTVYBXCDZ
      WXEVYBIZWUHWXMWURWWMQZWXMWXKEUGUVRZWXNXLXMVYBEUVSYFTZWXFEIWUTEXLURZRUVTYG
      ZWSWUTWWTVYBMENLZNLZWXDWXTOVYBNMEOXBXLYDUWAUWBZYHWUTWXMWYAWXDIZWXOWXMVYTW
      XKWYCXBXLVYBMEYIYFTUWDYGWRYJWUTWVBWXAWWQWUTWVACDWVBCDWUTWVAWWKYKWVAWATZWU
      TVVLWWTCDZWXACDWUEWUTWWBWYEWUHWWBWURWWDQZVYBUWETZVVAWWTVOVPWUTVVLWWBWWQCD
      WUEWYFVVAVYBVOVPZUWFWUTWXBWUOWWRFWUTVVAWWTVYBPLZKLWXBWUOWUTVVAWWTVYBVVAXC
      DWUTWUFRZWUTWWTWYGYAWXOUWGWUTWYIWUNVVAKWUTWUNEVYBKLZEPLZMNLZWYKWXTNLZWYIW
      UTWUMWYLMNWUTWUMWYKWXFPLZWYLWUTWXMWUMWYOIZWXOWXKWXMWXLWYPXLYDEVYBOYEXRTWX
      FEWYKPWXRYHWQWSWUTWYKXCDZWYNWYMIZWUHWYQWURWUHWYKWUHWVSWVTWYKXHDXPWWAEVYBY
      LVPZUWHQWYQVYTWXKWYRXBXLWYKMEYIYFTWUTWYNWYKONLZWYIWXTOWYKNWYBYHWUTWYTVYBV
      YBPLZONLWYIWUTWYKXUAONWUTVYBWXOUWIWSWUTVYBVYBOWXOWXOWXLWUTYDRUWJYGYMUWMWR
      UWKYJUWLWUTWULWWRSGZWWSWUPWUTWVCONLZJHZWVBVCUDHZWVAONLZKLZPLZWULWWRSWUTWV
      AYNDZXUDXUHSGWUTMYNDWVAVXHDZXUIWIWUTWVGXUJWWOWVAMVYBUWNTOWVAMYNUWOUWPVPWV
      AUWQTWUTXUCVYEJWUTXUCWXCONLZVYEWUTWVCWXCONWXSWSWUTXUKVYBEONLZPLZVYEWUTWXM
      XUKXUMIZWXOWXMWXKWXLXUNXLYDVYBEOUWRYFTXULOVYBPUXCYHWQYGWPWUTXUGWWQWVBPWUT
      XUGXUEWUQKLZVVAWXEKLZWWQWUTXUFWUQXUEKWUTWXHWXLXUFWUQIWXJYDWUQOXAVSWRWUTXU
      OVVAEKLZWUQKLXUPXUEXUQWUQKEEXDLZUDHZEVVAKLZXUEXUQWUDWVSXUSXUTIXEXPEEXIULX
      URVCUDUWSWDEVVAXLWUFXGUWTWTWUTVVAEWUQWYJWXKWUTXLRWXJUXAYMWUTWXEVYBVVAKWXQ
      WRUXBWRUXDWUTWULCDZWWRCDWUOCDZXUBWWSUOWUPXKWUTVYECDZXVAWUHXVCWURWUHVYEWUH
      VYEVXHDZVYEXHDZMVYBUXEZMVYEXOTZYKZQVYEWATWUTWVBWWQWYDWYHUXFWUTVVLWUNCDZXV
      BWUEWUHXVIWURWUHWUMCDVWJXVIWUHWUMWUHWVSXVEWUMXHDXPXVGEVYEYLVPYKZVMWUMMVQV
      SZQVVAWUNVOZVPWULWWRWUOUXGVKUXHUXIYOWUHWUSUOZVYDVYBJHZVVAWYKMNLZKLZFGZWUP
      WUHVYDXVQXKZWUSWUHVYBVYCDXVRMVYBWHVXQXVQBVYBVYCVXLVYBIZVXMXVNVXPXVPFVXLVY
      BJUFXVSVXOXVOVVAKXVSVXNWYKMNVXLVYBEKWKWSWRYBYCTQXVMXVQXVNWUOFGZWUPWUHXVQX
      VTXKWUSWUHXVQXVPWUOFGZXVTWUHXVOWUNFGZXWAWUHWYKWUMMWUHWYKWYSYKZXVJVWJWUHVM
      RWUHVYBVYEFGZWYKWUMFGZWUHVYBWWDUXJWUHWWBXVCVWGXWDXWEVIWWDXVHVWGWUHVWIRVYB
      VYEEVJVKVRUXKWUHXVOCDZXVIVVOXWBXWAVIWUHWYKCDVWJXWFXWCVMWYKMVQVSZXVKVVOWUH
      VVQRXVOWUNVVAVJVKVRWUHXVNCDZXVPCDZXVBXVQXWAUOXVTXKWUHWWBXWHWWDVYBWATWUHVV
      LXWFXWIWUEXWGVVAXVOVOVPWUHVVLXVIXVBWUEXVKXVLVPXVNXVPWUOUXMVKUXLQXVMWULXVN
      WUOFXVMWVTVYEUXNDZYPZWULXVNIWUHWVTWUSWWAQWUHWUSXWKWUHWUSEVYEUXOGZXWKWUHXV
      EXWLWUSVIZXVGWVSWXPXVEXWMXPXMEVYEUXPUXQTWUHXWJXWLWUHXWJXWLYPWUHXWJUOZXWLE
      VYEIZWUHXWOYPXWJXWOMVYESGZWUHXWOMESGZXWPEMFGXWQYPUXREMUIVMUYDUNEVYEMSUXSU
      XTWUHXVDXWPXVFMVYEXNTUYAQXWNEEUEHZDZXWJXWLXWOVIWVSXWSXPEUYBXFWUHXWJWJVYEE
      UYCVPUYEVUFUYFUYGYQVYBUYHUYIUYJUYKYOWUHWVTWURWUSYRWWAVYBUYLTYSVXQWUPBVYEV
      YBOPUYMVXLVYEIZVXMWULVXPWUOFVXLVYEJUFXWTVXOWUNVVAKXWTVXNWUMMNVXLVYEEKWKWS
      WRYBUYNUYOUYPWUKVYGWUHVXQBVYCWUIVUGZWGVXQBVYCWUIUYQWUHVXQBVYFXXAMVYBUYRWL
      UYSYOUYTVXQVXJBVURVXKVXLVURIZVXMVVJVXPVWTFVXLVURJUFXXBVXOVWSVVAKXXBVXNVWR
      MNVXLVUREKWKWSWRYBYCVUATVTVWQVWSVVCSGZVWTVVDSGZVWQVWRVVBMVXEVUQVWMVVGVWNQ
      VWJVWQVMRVWQVURASGZVWRVVBSGZVUOXXEVUPVVGAVUBWBVWQVXCVUOVWGXXEXXFVIVXDVUQV
      UOVVGVWHQVWGVWQVWIRVURAEYTVKVRVUCVWQVXAVWOVVOXXCXXDVIVXFVXGVVOVWQVVQRVWSV
      VCVVAYTVKVRVUDVUQVURXWRDZVUSVVGYRVUQWVSVURXHDZEVURSGZXXGWVSVUQXPRVUOXXHVU
      PAVUEQVUOVUPXXIVUOVUPEASGZXXIVVPVUOVUPXXJXKUIEAXTVUHVUOWVSXXJXXIVIXPAEVUI
      VUJVUKYQEVURVULVUMEVURVUNTYS $.
  $}

  ${
    $d a k p x z A $.  $d x z C $.  $d a b k x y z K $.  $d a b k p x y z ph $.
    $d k p y z B $.  $d a b k p x y z P $.
    fsumvma.1 $e |- ( x = ( p ^ k ) -> B = C ) $.
    fsumvma.2 $e |- ( ph -> A e. Fin ) $.
    fsumvma.3 $e |- ( ph -> A C_ NN ) $.
    fsumvma.4 $e |- ( ph -> P e. Fin ) $.
    fsumvma.5 $e |- ( ph -> ( ( p e. P /\ k e. K ) <->
      ( ( p e. Prime /\ k e. NN ) /\ ( p ^ k ) e. A ) ) ) $.
    fsumvma.6 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    fsumvma.7 $e |- ( ( ph /\ ( x e. A /\ ( Lam ` x ) = 0 ) ) -> B = 0 ) $.
    $( Rewrite a sum over the von Mangoldt function as a sum over prime
       powers.  (Contributed by Mario Carneiro, 15-Apr-2016.) $)
    fsumvma $p |- ( ph -> sum_ x e. A B = sum_ p e. P sum_ k e. K C ) $=
      ( cexp wcel wa cn vz va vy csu csn cxp ciun cfv csb cmpt crn cop wceq cvv
      vb cv fvex a1i co fveq2 df-ov syl6eqr eqeq2d biimpa syl csbied cfn adantr
      wf1 cprime biimpd impl simprd ex weq wb simpld adantrr ssrdv adantrl eqid
      sselda prmexpb baibd mpan2 syl22anc dom2lem f1fi syl2anc cc wral simplbda
      ralrimiva eleq1d rspcv sylc fsum2d nfcv nfcsb1v csbeq1a cbvsumi snfi xpfi
      csbeq1 sylancr iunfi wf1o a1ii wex eliunxp opelxp sylibr eleq1 syl5ibrcom
      simprbda impancom expimpd exlimdvv syl5bi sseld anim12d c1st c2nd 1st2nd2
      fveq2d eqeqan12d xp1st xp2nd jca an4s syl2an xpopth imp cc0 wrex pm5.32da
      syldan ancom 3bitr4g r2ex 3bitrd syl6 f1f1orn fvmpt adantl wf fmptd nfel1
      wss frn rspc mpan9 fsumf1o syl5eq cdif eldif cvma elrnmpti rexiunxp bitri
      wne simpr simplr eqeltrrd rbaibd adantlr 2exbidv isppw2 bitr4d necon2bbid
      wn syl5bb sylbird fsumss 3eqtr2rd ) AFHEGUDIUDIFIUPZUEZHUFZUGZBUAUPZQUHZD
      UIZUAUDZUBUVSUBUPZQUHZUJZUKZDBUDZCDBUDAUAFHEUWBIGUVTUVPGUPZULZUMZBUWADEUN
      UWAUNRUWKUVTQUQZURUWKBUPZUWAUMZSUWMUVPUWIQUSZUMZDEUMUWKUWNUWPUWKUWAUWOUWM
      UWKUWAUWJQUHZUWOUVTUWJQUTUVPUWIQVAZVBVCVDJVEVFMAUVPFRZSZCVGRZHCGHUWOUJZVI
      HVGRZAUXAUWSKVHUWTGUAHCUWOUVPUVTQUSZUWTUWIHRZUWOCRZUWTUXESZUVPVJRZUWITRZS
      ZUXFAUWSUXEUXJUXFSZAUWSUXESZUXKNVKVLZVMVNUWTUXEUVTHRZSZUWOUXDUMZGUAVOZVPZ
      UWTUXOSUXHUXHUXIUVTTRZUXRUWTUXEUXHUXNUXGUXHUXIUXGUXJUXFUXMVQZVQVRZUYAUWTU
      XEUXIUXNUXGUXHUXIUXTVMZVRUWTUXNUXSUXEUWTHTUVTUWTGHTUWTUXEUXIUYBVNVSWBVTUX
      HUXHSUXIUXSSSZIIVOZUXRUVPWAUYCUXPUYDUXQUVPUVPUWIUVTWCWDWEWFVNWGHCUXBWHWIZ
      AUXLSZUXFDWJRZBCWKZEWJRZAUXLUXJUXFNWLZAUYHUXLAUYGBCOWMZVHUYGUYIBUWOCUWPDE
      WJJWNWOWPWQAUWHUWGBUCUPZDUIZUCUDUWCUWGDUYMBUCUCDWRBUYLDWSZBUYLDWTZXAAUWGU
      YMUVSUWBUCUAUWFUWABUYLUWADXDAFVGRUVRVGRZIFWKUVSVGRMAUYPIFUWTUVQVGRUXCUYPU
      VPXBUYEUVQHXCXEWMIFUVRXFWIAUVSUNUWFVIUVSUWGUWFXGAUBUOUVSUNUWEUOUPZQUHZAUW
      DUVSRZUWEUNRUWDQUQZXHAUYSUYQUVSRZSUWDVJTUFZRZUYQVUBRZSZUWEUYRUMZUBUOVOZVP
      AUYSVUCVUAVUDUYSUWDUWJUMZUXLSZGXIIXIZAVUCIGFHUWDXJZAVUIVUCIGAVUHUXLVUCAUX
      LVUHVUCUYFVUCVUHUWJVUBRZUYFUXJVULAUXLUXJUXFNXOUVPUWIVJTXKXLUWDUWJVUBXMXNX
      PXQXRXSZAUVSVUBUYQAUBUVSVUBVUMVSXTYAVUEVUFUWDYBUHZUWDYCUHZQUSZUYQYBUHZUYQ
      YCUHZQUSZUMZVUNVUQUMVUOVURUMSZVUGVUCVUDUWEVUPUYRVUSVUCUWEVUNVUOULZQUHVUPV
      UCUWDVVBQUWDVJTYDYEVUNVUOQVAVBVUDUYRVUQVURULZQUHVUSVUDUYQVVCQUYQVJTYDYEVU
      QVURQVAVBYFVUCVUNVJRZVUOTRZSVUQVJRZVURTRZSVUTVVAVPZVUDVUCVVDVVEUWDVJTYGUW
      DVJTYHYIVUDVVFVVGUYQVJTYGUYQVJTYHYIVVDVVFVVEVVGVVHVUNVUQVUOVURWCYJYKUWDUY
      QVJTVJTYLUUAUUBWGUVSUNUWFUUCVEUVTUVSRUVTUWFUHUWAUMAUBUVTUWEUWAUVSUWFUWDUV
      TQUTUWFWAZUWLUUDUUEAUYLUWGRUYLCRZUYMWJRZAUWGCUYLAUVSCUWFUUFUWGCUUIAUBUVSU
      WECUWFAUYSUWECRZUYSVUJAVVLVUKAVUIVVLIGAVUHUXLVVLAUXLVUHVVLUYFVVLVUHUXFUYJ
      VUHUWEUWOCVUHUWEUWQUWOUWDUWJQUTUWRVBZWNXNXPXQXRXSYMVVIUUGUVSCUWFUUJVEZWBA
      UYHVVJVVKUYKUYGVVKBUYLCBUYMWJUYNUUHBUCVODUYMWJUYOWNUUKUULYQUUMUUNAUWGCDBV
      VNAUWMUWGRZUWMCRZUYGAUWGCUWMVVNWBOYQAUWMCUWGUUORZDYNUMZVVQVVPVVOUVKZSZAVV
      RUWMCUWGUUPAVVTVVPUWMUUQUHZYNUMZSZVVRAVVPVWBVVSAVVPSZVVOVWAYNVVOUWPGHYOIF
      YOZVWDVWAYNUVAZVVOUWMUWEUMZUBUVSYOVWEUBUVSUWEUWMUWFVVIUYTUURVWGUWPUBIGFHV
      UHUWEUWOUWMVVMVCUUSUUTVWDVWEUWPGTYOIVJYOZVWFVWDUXLUWPSZGXIIXIUXJUWPSZGXII
      XIVWEVWHVWDVWIVWJIGVWDUWPUXLSUWPUXJSVWIVWJVWDUWPUXLUXJVWDUWPUXFUXLUXJVPZV
      WDUWPSUWMUWOCVWDUWPUVBAVVPUWPUVCUVDAUXFVWKVVPAUXLUXJUXFNUVEUVFYQYPUXLUWPY
      RUXJUWPYRYSUVGUWPIGFHYTUWPIGVJTYTYSVWDUWMTRVWFVWHVPACTUWMLWBUWMGIUVHVEUVI
      UVLUVJYPAVWCVVRPVNUVMXSYMKUVNUVO $.
  $}

  ${
    $d a k p x z A $.  $d x z C $.  $d a b k x y z K $.  $d a b k p x y z ph $.
    $d k p y z B $.  $d a b k p x y z P $.
    fsumvma2.1 $e |- ( x = ( p ^ k ) -> B = C ) $.
    fsumvma2.2 $e |- ( ph -> A e. RR ) $.
    fsumvma2.3 $e |- ( ( ph /\ x e. ( 1 ... ( |_ ` A ) ) ) -> B e. CC ) $.
    fsumvma2.4 $e |- ( ( ph /\ ( x e. ( 1 ... ( |_ ` A ) ) /\
      ( Lam ` x ) = 0 ) ) -> B = 0 ) $.
    $( Apply ~ fsumvma for the common case of all numbers less than a real
       number ` A ` .  (Contributed by Mario Carneiro, 30-Apr-2016.) $)
    fsumvma2 $p |- ( ph -> sum_ x e. ( 1 ... ( |_ ` A ) ) B =
      sum_ p e. ( ( 0 [,] A ) i^i Prime )
        sum_ k e. ( 1 ... ( |_ ` ( ( log ` A ) / ( log ` p ) ) ) ) C ) $=
      ( c1 cfv co cn wcel wa cle wbr wb cfl cfz cc0 cicc cprime clog cdiv fzfid
      cin cv wss elfznn ssriv a1i cr cfn syl cexp elin simprbi anim12i pm4.71ri
      ppifi adantr prmnn ad2antrl cn0 nnnn0 ad2antll nnexpcld nnzd flge syl2anc
      cz cmul crp wceq simplrl nnrpd simplrr relogexp breq1d 0re nngt0d nn0ge0d
      nnred w3a elicc2 df-3an syl6bb baibd syl22anc biimpa ltletrd relogcld cuz
      elrpd c2 prmuz2 eluzelre clt eluz2b2 rplogcld lemuldivd rerpdivcld 3bitrd
      3syl logled simprr nnuz syl6eleq flcld elfz5 3bitr4d pm5.32da nncnd exp1d
      nnge1d leexp2ad eqbrtrrd letr syl3anc mpand sylibrd pm4.71rd rbaib anbi1d
      wi 3bitr4rd syl5bb fsumvma ) ABLCUAMZUBNZDEUCCUDNZUEUIZFLCUFMZGUJZUFMZUGN
      ZUAMZUBNZGHALYLUHYMOUKABYMOBUJYLULUMUNACUOPZYOUPPICVCUQYQYOPZFUJZUUAPZQZY
      QUEPZUUDOPZQZUUFQAUUIYQUUDURNZYMPZQUUFUUIUUCUUGUUEUUHUUCYQYNPZUUGYQYNUEUS
      ZUTUUDYTULVAVBAUUIUUFUUKAUUIQZUUJCRSZUUJYLRSZUUFUUKUUNUUBUUJVNPUUOUUPTAUU
      BUUIIVDZUUNUUJUUNYQUUDUUGYQOPZAUUHYQVEZVFZUUHUUDVGPAUUGUUDVHVIVJZVKCUUJVL
      VMUUNUULUUOQUULUUEQUUOUUFUUNUULUUOUUEUUNUULQZUUJUFMZYPRSZUUDYTRSZUUOUUEUV
      BUVDUUDYRVONZYPRSUUDYSRSZUVEUVBUVCUVFYPRUVBYQVPPUUDVNPZUVCUVFVQUVBYQUVBUU
      GUURAUUGUUHUULVRZUUSUQZVSUVBUUDAUUGUUHUULVTZVKZYQUUDWAVMWBUVBUUDYPYRUVBUU
      DUVKWFUVBCUVBCUUNUUBUULUUQVDZUVBUCYQCUCUOPZUVBWCUNUUNYQUOPZUULUUNYQUUTWFZ
      VDUVMUVBYQUVJWDUUNUULYQCRSZUUNUVNUUBUVOUCYQRSZUULUVQTUVNUUNWCUNUUQUVPUUNY
      QUUNUURYQVGPUUTYQVHUQWEUVNUUBQZUULUVOUVRQZUVQUVSUULUVOUVRUVQWGUVTUVQQUCCY
      QWHUVOUVRUVQWIWJWKWLZWMWNWQZWOZUVBUUGYQWRWPMPZYRVPPUVIYQWSUWDYQWRYQWTUWDU
      URLYQXASYQXBUTXCXGZXDUVBYSUOPUVHUVGUVETUVBYPYRUWCUWEXEZUVLYSUUDVLVMXFUVBU
      UJCUVBUUJUUNUUJOPUULUVAVDVSUWBXHUVBUUDLWPMZPZYTVNPUUEUVETUUNUWHUULUUNUUDO
      UWGAUUGUUHXIXJXKZVDUVBYSUWFXLUUDLYTXMVMXNXOUUNUUOUULUUNUUOUVQUULUUNYQUUJR
      SZUUOUVQUUNYQLURNYQUUJRUUNYQUUNYQUUTXPXQUUNYQLUUDUVPUUNYQUUTXRUWIXSXTUUNU
      VOUUJUOPUUBUWJUUOQUVQYHUVPUUNUUJUVAWFUUQYQUUJCYAYBYCUWAYDYEUUNUUCUULUUEUU
      GUUCUULTAUUHUUCUULUUGUUMYFVFYGYIUUNUUJUWGPYLVNPUUKUUPTUUNUUJOUWGUVAXJXKUU
      NCUUQXLUUJLYLXMVMXNXOYJJKYK $.
  $}

  ${
    $d m n p A $.
    $( The logarithmic analogue of ~ pcprod .  The sum of the logarithms of the
       primes dividing ` A ` multiplied by their powers yields the logarithm of
       ` A ` .  (Contributed by Mario Carneiro, 15-Apr-2016.) $)
    pclogsum $p |- ( A e. NN -> sum_ p e. ( ( 1 ... A ) i^i Prime )
      ( ( p pCnt A ) x. ( log ` p ) ) = ( log ` A ) ) $=
      ( vn cn wcel c1 co cv cprime cpc cexp clog cfv cc0 cif csu cmul wceq crp
      wa vm cfz cin elin baib ifbid fvif log1 ifeq2 ax-mp eqtri syl6eqr sumeq2i
      wss cc wral inss1 simpr sseldi elfznn inss2 simpl pccld nnexpcld relogcld
      syl nnrpd recnd ralrimiva cuz cfn wo fzfi olci sumss2 mpan2 sylancr nn0zd
      cz relogexp syl2anc sumeq2dv eqtr3d caddc cmpt cseq adantl eleq1 id oveq1
      oveq12d eqidd ifbieq12d fveq2d eqid fvmpt elnnuz biimpi adantr simpll 1nn
      fvex wn a1i ifclda fsumser rpmulcl ovex 1ex ifex eqeltrd relogmul seqhomo
      eqtr4d pcprod 3eqtr2d 3eqtr3a ) ADEZFAUBGZBHZXSIUCZEZXTXTAJGZKGZLMZNOZBPZ
      XSXTIEZYDFOZLMZBPZYAYCXTLMZQGZBPZALMZXSYFYJBXTXSEZYFYHYENOZYJYPYBYHYENYBY
      PYHXTXSIUDUEUFYJYHYEFLMZOZYQYHYDFLUGYRNRYSYQRUHYHYRNYEUIUJUKULUMXRYAYEBPZ
      YGYNXRYAXSUNZYEUOEZBYAUPZYTYGRZXSIUQZXRUUBBYAXRYBTZYEUUFYDUUFYDUUFXTYCUUF
      YPXTDEZUUFYAXSXTUUEXRYBURZUSXTAUTZVFZUUFXTAUUFYAIXTXSIVAUUHUSXRYBVBVCZVDV
      GVEVHVIUUAUUCTXSFVJMZUNZXSVKEZVLUUDUUNUUMFAVMVNYAXSYEBFVOVPVQXRYAYEYMBUUF
      XTSEZYCVSEYEYMRUUFXTUUJVGUUFYCUUKVRXTYCVTWAWBWCXRYKAWDCDCHZIEZUUPUUPAJGZK
      GZFOZLMZWEZFWFMAQCDUUTWEZFWFMZLMYOXRYJBUVBFAXRYPTZUUGXTUVBMZYJRYPUUGXRUUI
      WGZCXTUVAYJDUVBUUPXTRZUUTYILUVHUUQYHUUSFYDFUUPXTIWHUVHUUPXTUURYCKUVHWIUUP
      XTAJWJWKUVHFWLWMZWNUVBWOYILXBWPVFZXRAUULEAWQWRZUVEYJUVEYIUVEYIUVEYHYDFDUV
      EYHTZXTYCUVEUUGYHUVGWSUVLXTAUVEYHURXRYPYHWTVCVDFDEUVEYHXCTXAXDXEVGZVEVHXF
      XRBUAQWDSUVCUVBLFAUUOUAHZSETZXTUVNQGZSEXRXTUVNXGWGUVEXTUVCMZYISUVEUUGUVQY
      IRUVGCXTUUTYIDUVCUVIUVCWOZYHYDFXTYCKXHXIXJWPVFZUVMXKUVKUVOUVPLMYLUVNLMWDG
      RXRXTUVNXLWGUVEUVQLMYJUVFUVEUVQYILUVSWNUVJXNXMXRUVDALCUVCAUVRXOWNXPXQ $.
  $}

  ${
    $d d k m n p x A $.
    $( The sum of the von Mangoldt function over the divisors of ` n ` .
       Equation 9.2.4 of [Shapiro], p. 328.  (Contributed by Mario Carneiro,
       15-Apr-2016.) $)
    vmasum $p |- ( A e. NN ->
      sum_ n e. { x e. NN | x || A } ( Lam ` n ) = ( log ` A ) ) $=
      ( vp vk cn cv cdivides wbr cfv csu c1 co cprime cfn syl2anc wa syl adantl
      wcel crab cvma cfz cin cpc cexp clog cmul fveq2 wss fzfid ssfi ssrab2 a1i
      sgmss inss1 sylancl cle cz wb cn0 pccl ancoms nn0zd fznn anbi2d an12 prmz
      iddvdsexp sylan wi ad2antlr prmnn nnexpcl syl2an nnzd nnz ad2antrr dvdstr
      nnnn0 syl3anc mpand simpll dvdsle syld baibd pm4.71rd breq1 elrab3 simplr
      sylibrd pcdvdsb 3bitr4rd pm5.32da syl5bb bitrd elin anbi1i 3bitri 3bitr4g
      anass cr sselda vmacl recnd cc0 wceq simprr fsumvma simprbi elfznn vmappw
      chash sumeq2dv cc nnrpd relogcld fsumconst sylan2 hashfz1 oveq1d pclogsum
      3eqtrd ) BFTZAGZBHIZAFUAZCGZUBJZCKLBUCMZNUDZLDGZBUEMZUCMZYLEGZUFMZUBJZEKZ
      DKYKYMYLUGJZUHMZDKBUGJYDCYGYIYQYKEYNDYHYPUBUIYDYJOTZYGYJUJYGOTYDLBUKZBAUO
      YJYGULPYGFUJYDYFAFUMUNZYDUUAYKYJUJYKOTUUBYJNUPYJYKULUQYDYLNTZYLYJTZYOYNTZ
      QZQZUUDYOFTZYPYGTZQZQYLYKTZUUFQZUUDUUIQUUJQYDUUDUUGUUKYDUUDQZUUGUUEUUIYOY
      MURIZQZQZUUKUUNUUFUUPUUEUUNYMUSTUUFUUPUTUUNYMUUDYDYMVATZYLBVBVCZVDYOYMVER
      VFUUQUUIUUEUUOQZQUUNUUKUUEUUIUUOVGUUNUUIUUTUUJUUNUUIQZYPBHIZUUEUVBQUUJUUT
      UVAUVBUUEUVAUVBYLBURIZUUEUVAUVBYLBHIZUVCUVAYLYPHIZUVBUVDUUNYLUSTZUUIUVEUU
      DUVFYDYLVHZSYLYOVIVJUVAUVFYPUSTBUSTZUVEUVBQUVDVKUUDUVFYDUUIUVGVLZUVAYPUUN
      YLFTZYOVATZYPFTZUUIUUDUVJYDYLVMZSYOVTZYLYOVNVOZVPYDUVHUUDUUIBVQVRZYLYPBVS
      WAWBUVAUVFYDUVDUVCVKUVIYDUUDUUIWCYLBWDPWEUVAUVHUVJUUEUVCUTUVPUUDUVJYDUUIU
      VMVLUVHUUEUVJUVCYLBVEWFPWKWGUVAUVLUUJUVBUTUVOYFUVBAYPFYEYPBHWHWIRUVAUUOUV
      BUUEUVAUUDUVHUVKUUOUVBUTYDUUDUUIWJUVPUUIUVKUUNUVNSYOYLBWLWAVFWMWNWOWPWNUU
      MUUEUUDQZUUFQUUEUUDUUFQQUUHUULUVQUUFYLYJNWQZWRUUEUUDUUFXAUUEUUDUUFVGWSUUD
      UUIUUJXAWTYDYHYGTZQZYIUVTYHFTYIXBTYDYGFYHUUCXCYHXDRXEYDUVSYIXFXGXHXIYDYKY
      RYTDYDUULQZYRYNYSEKZYNXMJZYSUHMZYTUWAYNYQYSEUWAUUFQUUDUUIYQYSXGUULUUDYDUU
      FUULUUEUUDUVRXJZVLUUFUUIUWAYOYMXKSYLYOXLPXNUWAYNOTYSXOTUWBUWDXGUWALYMUKUW
      AYSUWAYLUWAYLUULUVJYDUULUUDUVJUWEUVMRSXPXQXEYNYSEXRPUWAUWCYMYSUHUWAUURUWC
      YMXGUULYDUUDUURUWEUUSXSYMXTRYAYCXNBDYBYC $.

    $( Another expression for the logarithm of a factorial, in terms of the von
       Mangoldt function.  Equation 9.2.7 of [Shapiro], p. 329.  (Contributed
       by Mario Carneiro, 15-Apr-2016.)  (Revised by Mario Carneiro,
       3-May-2016.) $)
    logfac2 $p |- ( ( A e. RR /\ 0 <_ A ) ->
      ( log ` ( ! ` ( |_ ` A ) ) ) = sum_ k e. ( 1 ... ( |_ ` A ) )
        ( ( Lam ` k ) x. ( |_ ` ( A / k ) ) ) ) $=
      ( vn vx cr wcel cle wbr wa cfv c1 co cv csu cmul wceq syl cdivides cn cfn
      vm cc0 cfl cfa clog cfz cvma cdiv cn0 flge0nn0 logfac crab fzfid wss ssfi
      ssrab2 sylancl cz wb flcl adantr fznn anbi1d nnre ad2antlr ad2antrl nnred
      elfznn reflcl ad3antrrr simprr wi nnz dvdsle syl2anc mpd elfzle2 pm4.71rd
      letrd expl an12 anass bitri 3bitr4g bitr4d breq2 elrab anbi2i breq1 vmacl
      cc adantl recnd adantrr fsumcom2 fsumconst cen cmpt wf1o simpll dvdsflf1o
      chash f1oeng hasheni simpl nndivre syl2an clt nngt0 divge0 sylan2 hashfz1
      eqid jca eqtr3d oveq1d zcnd mulcomd 3eqtrd sumeq2dv vmasum 3eqtr3d eqtr4d
      flcld ) AEFZUBAGHZIZAUCJZUDJUEJZKYHUFLZCMZUEJZCNZYJBMZUGJZAYNUHLZUCJZOLZB
      NZYGYHUIFYIYMPAUJCYHUKQYGYJYNDMZRHZDYJULZYOCNZBNYJYTYKRHZDSULZYOBNZCNYSYM
      YGYJUUBYJUUEBCYOYGKYHUMZUUGYGYNYJFZIZYJTFUUBYJUNUUBTFZUUIKYHUMUUADYJUPYJU
      UBUOUQZYGUUHYKYJFZYNYKRHZIZIZUULYNSFZUUMIZIZUUHYKUUBFZIUULYNUUEFZIYGUUOUU
      PYNYHGHZIZUUNIZUURYGUUHUVBUUNYGYHURFZUUHUVBUSYEUVDYFAUTVAYNYHVBQVCYGUUPUU
      NIZUVAUVEIZUURUVCYGUVEUVAYGUUPUUNUVAYGUUPIZUUNIZYNYKYHUUPYNEFZYGUUNYNVDZV
      EUVHYKUULYKSFZUVGUUMYKYHVHZVFZVGYEYHEFYFUUPUUNAVIVJUVHUUMYNYKGHZUVGUULUUM
      VKUVHYNURFZUVKUUMUVNVLUUPUVOYGUUNYNVMVEUVMYNYKVNVOVPUULYKYHGHUVGUUMYKKYHV
      QVFVSVTVRUULUUPUUMWAUVCUUPUVAUUNIIUVFUUPUVAUUNWBUUPUVAUUNWAWCWDWEUUSUUNUU
      HUUAUUMDYKYJYTYKYNRWFWGWHUUTUUQUULUUDUUMDYNSYTYNYKRWIWGWHWDYGUUHYOWKFZUUS
      UUIYOUUIUUPYOEFUUHUUPYGYNYHVHZWLZYNWJQWMZWNWOYGYJUUCYRBUUIUUCUUBXBJZYOOLZ
      YQYOOLYRUUIUUJUVPUUCUWAPUUKUVSUUBYOCWPVOUUIUVTYQYOOUUIKYQUFLZXBJZUVTYQUUI
      UWBUUBWQHZUWCUVTPUUIUWBTFUWBUUBUAUWBYNUAMOLWRZWSUWDUUIKYQUMUUIDAUAUWEYNYE
      YFUUHWTUVRUWEXMXAUWBUUBTUWEXCVOUWBUUBXDQUUIYQUIFZUWCYQPUUIYPEFZUBYPGHZUWF
      YGYEUUPUWGUUHYEYFXEUVQAYNXFXGZUUHYGUVIUBYNXHHZIZUWHUUHUUPUWKUVQUUPUVIUWJU
      VJYNXIXNQAYNXJXKYPUJVOYQXLQXOXPUUIYQYOUUIYQUUIYPUWIYDXQUVSXRXSXTYGYJUUFYL
      CYGUULIUVKUUFYLPUULUVKYGUVLWLDYKBYAQXTYBYC $.

    $( Express the second Chebyshev function directly as a sum over the primes
       less than ` A ` (instead of indirectly through the von Mangoldt
       function).  (Contributed by Mario Carneiro, 8-Apr-2016.) $)
    chpval2 $p |- ( A e. RR -> ( psi ` A ) = sum_ p e. ( ( 0 [,] A ) i^i
      Prime ) ( ( log ` p ) x. ( |_ ` ( ( log ` A ) / ( log ` p ) ) ) ) ) $=
      ( vn vk cr wcel cfv c1 cfz co cv csu cc0 cprime cmul wceq c2 clt wbr a1i
      cchp cfl cvma cicc cin clog cdiv cexp chpval fveq2 id wa cn elfznn adantl
      vmacl syl recnd simprr fsumvma2 inss2 simpr sseldi vmappw syl2an sumeq2dv
      chash cfn cc fzfid cuz crp prmuz2 eluzelre eluz2b2 simprbi rplogcld rpcnd
      fsumconst syl2anc cn0 cle ppisval inss1 syl6eqss sselda elfzuz2 simpl 0re
      3syl 2re 2pos eluzle cz wb 2z flge mpan2 syl5ibr imp ltletrd elrpd syldan
      relogcld rerpdivcld 1lt2 rplogcl rpdivcld rpge0d flge0nn0 hashfz1 mulcomd
      1re oveq1d nn0cnd 3eqtrd eqtrd ) AEFZAUAGHAUBGZIJZCKZUCGZCLMAUDJZNUEZHAUF
      GZBKZUFGZUGJZUBGZIJZYFDKZUHJZUCGZDLZBLYDYGYIOJZBLACUIXRCAYBYMDBYAYLUCUJXR
      UKXRYAXTFZULZYBYQYAUMFZYBEFYPYRXRYAXSUNUOYAUPUQURXRYPYBMPUSUTXRYDYNYOBXRY
      FYDFZULZYNYJYGDLZYOYTYJYMYGDYTYFNFZYKUMFYMYGPYKYJFYTYDNYFYCNVAXRYSVBVCZYK
      YIUNYFYKVDVEVFYTUUAYJVGGZYGOJZYIYGOJYOYTYJVHFYGVIFUUAUUEPYTHYIVJYTYGYTUUB
      YFQVKGZFZYGVLFUUCYFVMUUGYFQYFVNUUGYFUMFHYFRSYFVOVPVQWJZVRZYJYGDVSVTYTUUDY
      IYGOYTYIWAFZUUDYIPYTYHEFMYHWBSUUJYTYEYGYTAXRYSXSUUFFZAVLFYTYFQXSIJZFUUKXR
      YDUULYFXRYDUULNUEUULAWCUULNWDWEWFYFQXSWGUQZXRUUKULZAXRUUKWHZUUNMQAMEFUUNW
      ITQEFUUNWKTZUUOMQRSUUNWLTXRUUKQAWBSZUUKUUQXRQXSWBSZQXSWMXRQWNFUUQUURWOWPA
      QWQWRWSWTZXAXBXCXDUUHXEYTYHYTYEYGXRYSHARSZYEVLFXRYSUUKUUTUUMUUNHQAHEFUUNX
      MTUUPUUOHQRSUUNXFTUUSXAXCAXGXCUUHXHXIYHXJVTZYIXKUQXNYTYIYGYTYIUVAXOUUIXLX
      PXQVFXP $.

    $( The second Chebyshev function is the sum of the theta function at
       arguments quickly approaching zero.  (This is usually stated as an
       infinite sum, but after a certain point, the terms are all zero, and it
       is easier for us to use an explicit finite sum.)  (Contributed by Mario
       Carneiro, 7-Apr-2016.) $)
    chpchtsum $p |- ( A e. RR -> ( psi ` A ) =
      sum_ k e. ( 1 ... ( |_ ` A ) ) ( theta ` ( A ^c ( 1 / k ) ) ) ) $=
      ( vp cr wcel cc0 co cprime cfv cmul csu c1 ccxp wa syl syl2anc cle wbr wb
      a1i cicc cin cv clog cdiv cfl cfz cchp ccht chash cfn cc wceq fzfid inss2
      simpr sseldi prmnn nnrpd relogcld recnd fsumconst cn0 simpl 1re nnred cuz
      cn clt prmuz2 eluz2b2 simprbi w3a inss1 0re elicc2 sylancr simp3d ltletrd
      mpbid rplogcld rpdivcld rpred rpge0d flge0nn0 hashfz1 oveq1d zcnd mulcomd
      c2 flcld 3eqtrrd sumeq2dv chpval2 0lt1 elfzuz2 eluzle adantl flge sylancl
      cz 1z mpbird sylan2 ltled elfznn nnrecred recxpcld ppifi wi sseli anim12i
      chtval wss sselda nngt0d adantrd jcad anim12ci cexp elin simprll biantrud
      ex nnnn0d nn0ge0d df-3an syl6bb baibd syl22anc bitr3d syl5bb 3bitrd elfz5
      anbi12d nncnd letr syl3anc mpand pm4.71rd simprr elrpd rerpdivcld simprlr
      nnzd nnexpcld logled crp relogexp breq1d lemuldivd nnuz syl6eleq 3bitr4rd
      bitr4d cxpge0d cxple2d cxpexp nnne0d recid2d oveq2d cxpmuld cxp1d 3eqtr3d
      breq12d bernneq3 exp1d leexp2ad eqbrtrrd 3bitr2rd bitrd pm5.21ndd adantrr
      nnge1d fsumcom2 eqtr4d 3eqtr4d ) ADEZFAUAGZHUBZCUCZUDIZAUDIZUWBUEGZUFIZJG
      ZCKUVTLUWEUGGZUWBBKZCKZAUHILAUFIZUGGZALBUCZUEGZMGZUIIZBKZUVRUVTUWFUWHCUVR
      UWAUVTEZNZUWHUWGUJIZUWBJGZUWEUWBJGUWFUWRUWGUKEUWBULEZUWHUWTUMUWRLUWEUNZUW
      RUWBUWRUWAUWRUWAUWRUWAHEZUWAVHEZUWRUVTHUWAUVSHUOZUVRUWQUPZUQZUWAURZOZUSUT
      VAZUWGUWBBVBPUWRUWSUWEUWBJUWRUWEVCEZUWSUWEUMUWRUWDDEZFUWDQRUXKUWRUWDUWRUW
      CUWBUWRAUVRUWQVDZUWRLUWAALDEZUWRVETUWRUWAUXIVFZUXMUWRUWAWJVGIEZLUWAVIRZUW
      RUXCUXPUXGUWAVJZOUXPUXDUXQUWAVKVLZOZUWRUWADEZFUWAQRZUWAAQRZUWRUWAUVSEZUYA
      UYBUYCVMZUWRUVTUVSUWAUVSHVNUXFUQUWRFDEZUVRUYDUYESVOUXMFAUWAVPZVQVTVRZVSWA
      UWRUWAUXOUXTWAWBZWCZUWRUWDUYIWDUWDWEPUWEWFOWGUWRUWEUWBUWRUWEUWRUWDUYJWKWH
      UXJWIWLWMACWNUVRUWPUWKFUWNUAGZHUBZUWBCKZBKUWIUVRUWKUWOUYMBUVRUWLUWKEZNZUW
      NDEZUWOUYMUMUYOAUWMUVRUYNVDZUYOFAUYFUYOVOTZUYQUYOFLAUYRUXNUYOVETUYQFLVIRU
      YOWOTUYNUVRUWJLVGIZEZLAQRZUWLLUWJWPUVRUYTNZVUALUWJQRZUYTVUCUVRLUWJWQWRVUB
      UVRLXAEVUAVUCSUVRUYTVDXBALWSWTXCXDVSZXEUYOUWLUYNUWLVHEZUVRUWLUWJXFZWRXGXH
      UWNCXMOWMUVRUVTUWGUWKUYLCBUWBAXIUVRLUWJUNUXBUVRUXCVUENZFAVIRZNZUWQUWLUWGE
      ZNZUYNUWAUYLEZNZUVRVUKVUGVUHVUKVUGXJUVRUWQUXCVUJVUEUVTHUWAUXEXKUWLUWEXFXL
      TUVRUWQVUHVUJUVRUWQVUHUWRFUWAAUYFUWRVOTUWRUWAUWRUXCUXDUVRUVTHUWAUVTHXNUVR
      UXETXOUXHOZVFUXMUWRUWAVUNXPUYHVSYDXQXRUVRVUMVUGVUHVUMVUGXJUVRUYNVUEVULUXC
      VUFUYLHUWAUYKHUOXKXSTUVRUYNVUHVULUVRUYNVUHVUDYDXQXRUVRVUIVUKVUMSUVRVUINZV
      UKUYCUWAUWLXTGZAQRZNZVUMVUOUWQUYCVUJVUQUWQUYDUXCNZVUOUYCUWAUVSHYAVUOUYDVU
      SUYCVUOUXCUYDUVRUXCVUEVUHYBZYCVUOUYFUVRUYAUYBUYDUYCSUYFVUOVOTZUVRVUIVDZVU
      OUWAVUOUXCUXDVUTUXHOZVFZVUOUWAVUOUWAVVCYEYFZUYFUVRNZUYDUYAUYBNZUYCVVFUYDU
      YEVVGUYCNUYGUYAUYBUYCYGYHYIYJYKYLVUOUWLUWDQRZUWLUWEQRZVUQVUJVUOUXLUWLXAEZ
      VVHVVISVUOUWCUWBVUOAVUOAVVBUVRVUGVUHUUAUUBZUTZVUOUWAVVDVUOUXPUXQVUOUXCUXP
      VUTUXROZUXSOWAZUUCZVUOUWLUVRUXCVUEVUHUUDZUUEZUWDUWLWSPVUOVUQVUPUDIZUWCQRU
      WLUWBJGZUWCQRVVHVUOVUPAVUOVUPVUOUWAUWLVVCVUOUWLVVPYEZUUFZUSVVKUUGVUOVVRVV
      SUWCQVUOUWAUUHEVVJVVRVVSUMVUOUWAVVCUSVVQUWAUWLUUIPUUJVUOUWLUWCUWBVUOUWLVV
      PVFZVVLVVNUUKYMVUOUWLUYSEZUWEXAEVUJVVISVUOUWLVHUYSVVPUULUUMZVUOUWDVVOWKUW
      LLUWEYNPUUNYOVUOVUMUWLAQRZVUQNVUQVURVUOUYNVWEVULVUQVUOUYNUWLUWJQRZVWEVUOV
      WCUWJXAEUYNVWFSVWDVUOAVVBWKUWLLUWJYNPVUOUVRVVJVWEVWFSVVBVVQAUWLWSPUUOVULU
      WAUYKEZUXCNZVUOVUQUWAUYKHYAVUOVWHUWAUWNQRZUWAUWLMGZUWNUWLMGZQRVUQVUOVWGVW
      HVWIVUOUXCVWGVUTYCVUOUYFUYPUYAUYBVWGVWISVVAVUOAUWMVVBVUOAVVKWDZVUOUWLVVPX
      GZXHZVVDVVEUYFUYPNZVWGVVGVWIVWOVWGUYAUYBVWIVMVVGVWINFUWNUWAVPUYAUYBVWIYGY
      HYIYJYKVUOUWAUWNUWLVVDVVEVWNVUOAUWMVVBVWLVWMUUPVUOUWLVVPUSUUQVUOVWJVUPVWK
      AQVUOUWAULEUWLVCEZVWJVUPUMVUOUWAVVCYPZVVTUWAUWLUURPVUOAUWMUWLJGZMGALMGVWK
      AVUOVWRLAMVUOUWLVUOUWLVVPYPZVUOUWLVVPUUSUUTUVAVUOAUWMUWLVVKVWMVWSUVBVUOAV
      UOAVVBVAUVCUVDUVEYMYLYOVUOVUQVWEVUOUWLVUPQRZVUQVWEVUOUWLVUPVWBVUOVUPVWAVF
      ZVUOUXPVWPUWLVUPVIRVVMVVTUWAUWLUVFPXEVUOUWLDEVUPDEZUVRVWTVUQNVWEXJVWBVXAV
      VBUWLVUPAYQYRYSYTVUOVUQUYCVUOUWAVUPQRZVUQUYCVUOUWALXTGUWAVUPQVUOUWAVWQUVG
      VUOUWALUWLVVDVUOUWAVVCUVNVWDUVHUVIVUOUYAVXBUVRVXCVUQNUYCXJVVDVXAVVBUWAVUP
      AYQYRYSYTUVJUVKYDUVLUVRUWQUXAVUJUXJUVMUVOUVPUVQ $.

    $( An upper bound on the second Chebyshev function.  (Contributed by Mario
       Carneiro, 8-Apr-2016.) $)
    chpub $p |- ( ( A e. RR /\ 1 <_ A ) -> ( psi ` A ) <_
      ( ( theta ` A ) + ( ( sqr ` A ) x. ( log ` A ) ) ) ) $=
      ( vp cr wcel c1 cle wbr wa cfv co cmul cc0 cprime adantr a1i clt syl wceq
      c2 sylan2 cchp ccht cmin csqr clog caddc cin csu chpcl chtcl resubcld cfn
      cicc simpl 0re 0lt1 simpr ltletrd elrpd rpge0d resqrcld ppifi cv relogcld
      1re crp fsumrecl remulcld cdiv cfl cn inss2 sseldi prmnn nnrpd cuz prmuz2
      nnred eluz2b2 simprbi rplogcld rerpdivcld recnd fsumsub wss 0le0 lemul2ad
      reflcl sqsqrd mulid1d eqtr4d sqvald 3brtr4d sqrge0d le2sqd iccss syl22anc
      cexp mpbird ssrin cc sselda syldan cdif eldifi mulid2d w3a elicc2 sylancr
      inss1 wb mpbid simp3d logled eqbrtrd lemuldivd eldifn adantl rbaib df-3an
      wn elin syl6bb baibd bitrd ltnled lt2sqd eqbrtrrd nnsqcld syl2anc sylancl
      mtbid cz breqtrd eqtrd flle letrd chash cn0 cfz logltb 2z ltdivmul2d df-2
      relogexp syl6breq 1z mpbir2and oveq2d oveq1d subidd fsumss chpval2 chtval
      2re flbi oveq12d 3eqtr4rd subge02d lemuldiv2d fsumle hashcl nn0red logge0
      fsumconst cdom fzfid ppisval 2nn nnuz eleqtri fzss1 syl5ss eqsstrd ssdomg
      mp1i sylc hashdom flge0nn0 hashfz1 lemul1ad lesubadd2d ) ACDZEAFGZHZAUAIZ
      AUBIZUCJZAUDIZAUEIZKJZFGUWFUWGUWKUFJFGUWEUWHLUWIUMJZMUGZUWJBUHZUWKUWEUWFU
      WGUWCUWFCDUWDAUINZUWCUWGCDUWDAUJNZUKUWEUWMUWJBUWEUWICDZUWMULDZUWEAUWCUWDU
      NZUWEAUWEAUWSUWELEALCDZUWEUOOZECDZUWEVEOZUWSLEPGUWEUPOUWCUWDUQZURUSZUTZVA
      ZUWIVBQZUWEBVCZUWMDZHZAUWEAVFDZUXJUXENVDZVGUWEUWIUWJUXGUWEAUXEVDZVHZUWEUW
      HUWMUXIUEIZUWJUXPVIJZVJIZKJZUXPUCJZBUHZUWNFUWELAUMJZMUGZUXTBUHUYCUXSBUHZU
      YCUXPBUHZUCJUYAUWHUWEUYCUXSUXPBUWCUYCULDUWDAVBNZUWEUXIUYCDZHZUXSUYHUXPUXR
      UYHUXIUYHUXIUYHUXIMDZUXIVKDZUYHUYCMUXIUYBMVLUWEUYGUQZVMZUXIVNZQZVOZVDZUYH
      UXQCDZUXRCDZUYHUWJUXPUWEUWJCDZUYGUXNNUYHUXIUYHUXIUYNVRUYHUXISVPIDZEUXIPGZ
      UYHUYIUYTUYLUXIVQQUYTUYJVUAUXIVSVTQWAZWBZUXQWHQZVHZWCUYHUXPUYPWCZWDUWEUWM
      UYCUXTBUWEUWLUYBWEZUWMUYCWEUWEUWTUWCLLFGZUWIAFGZVUGUXAUWSVUHUWEWFOUWEVUIU
      WISWRJZASWRJZFGUWEAEKJZAAKJVUJVUKFUWEEAAUXCUWSUWSUXFUXDWGUWEVUJAVULUWEAUW
      EAUWSWCZWIUWEAVUMWJWKUWEAVUMWLWMUWEUWIAUXGUWSUWEAUWSUXFWNZUXFWOWSLALUWIWP
      WQUWLUYBMWTQZUWEUXJUYGUXTXADUWEUWMUYCUXIVUOXBZUYHUXTUYHUXSUXPVUEUYPUKZWCX
      CUWEUXIUYCUWMXDDZHZUXTUXPUXPUCJLVUSUXSUXPUXPUCVUSUXSUXPEKJUXPVUSUXREUXPKV
      USUXRERZEUXQFGZUXQEEUFJZPGZVUSEUXPKJZUWJFGVVAVUSVVDUXPUWJFVUSUXPVURUWEUYG
      UXPXADUXIUYCUWMXEZVUFTZXFVUSUXIAFGZUXPUWJFGVURUWEUYGVVGVVEUYHUXICDZLUXIFG
      ZVVGUYHUXIUYBDZVVHVVIVVGXGZUYHUYCUYBUXIUYBMXJUYKVMUYHUWTUWCVVJVVKXKUOUWEU
      WCUYGUWSNLAUXIXHXIXLXMTVUSUXIAVURUWEUYGUXIVFDZVVEUYOTZUWEUXLVURUXENZXNXLX
      OVUSEUWJUXPUXBVUSVEOUWEUYSVURUXNNZVURUWEUYGUXPVFDZVVEVUBTZXPXLVUSUXQSVVBP
      VUSUXQSPGUWJSUXPKJZPGVUSUWJUXISWRJZUEIZVVRPVUSAVVSPGZUWJVVTPGZVUSVUJAVVSP
      VUSAVUSAUWEUWCVURUWSNWCWIVUSUWIUXIPGZVUJVVSPGVUSVWCUXIUWIFGZYAVUSUXJVWDVU
      RUXJYAUWEUXIUYCUWMXQXRVUSUXJUXIUWLDZVWDVUSUYIUXJVWEXKVURUWEUYGUYIVVEUYLTU
      XJVWEUYIUXIUWLMYBXSQVUSUWTUWQVVHVVIVWEVWDXKUWTVUSUOOUWEUWQVURUXGNZVUSUXIV
      URUWEUYGUYJVVEUYNTZVRZVUSUXIVVMUTZUWTUWQHZVWEVVHVVIHZVWDVWJVWEVVHVVIVWDXG
      VWKVWDHLUWIUXIXHVVHVVIVWDXTYCYDWQYEYLVUSUWIUXIVWFVWHYFWSVUSUWIUXIVWFVWHUW
      ELUWIFGZVURVUNNVWIYGXLYHVUSUXLVVSVFDVWAVWBXKVVNVUSVVSVUSUXIVWGYIVOAVVSUUA
      YJXLVUSVVLSYMDVVTVVRRVVMUUBUXISUUEYKYNVUSUWJSUXPVVOSCDVUSUUOOVVQUUCWSUUDU
      UFVUSUYQEYMDVUTVVAVVCHXKVURUWEUYGUYQVVEVUCTUUGUXQEUUPYKUUHUUIVUSUXPVVFWJY
      OUUJVUSUXPVVFUUKYOUYFUULUWEUWFUYDUWGUYEUCUWCUWFUYDRUWDABUUMNUWCUWGUYERUWD
      ABUUNNUUQUURUWEUWMUXTUWJBUXHUWEUXJUYGUXTCDVUPVUQXCZUXMUXKUXTUXSUWJVWMUWEU
      XJUYGUXSCDVUPVUEXCZUXMUXKLUXPFGUXTUXSFGUXKUXPUWEUXJUYGVVPVUPVUBXCZUTUXKUX
      SUXPVWNUXKUXIUXKUXIUXKUYIUYJUXKUWMMUXIUWLMVLUWEUXJUQVMUYMQVOVDUUSXLUXKUXS
      UWJFGUXRUXQFGZUXKUYQVWPUWEUXJUYGUYQVUPVUCXCUXQYPQUXKUXRUWJUXPUWEUXJUYGUYR
      VUPVUDXCUXMVWOUUTWSYQUVAXOUWEUWNUWMYRIZUWJKJZUWKFUWEUWRUWJXADUWNVWRRUXHUW
      EUWJUXNWCUWMUWJBUVEYJUWEVWQUWIUWJUWEVWQUWEUWRVWQYSDUXHUWMUVBQUVCZUXGUXNAU
      VDUWEVWQUWIVJIZUWIVWSUWEUWQVWTCDUXGUWIWHQUXGUWEVWQEVWTYTJZYRIZVWTFUWEVWQV
      XBFGZUWMVXAUVFGZUWEVXAULDZUWMVXAWEVXDUWEEVWTUVGZUWEUWMSVWTYTJZMUGZVXAUWEU
      WQUWMVXHRUXGUWIUVHQUWEVXHVXGVXAVXGMXJSEVPIZDVXGVXAWEUWESVKVXIUVIUVJUVKSEV
      WTUVLUVPUVMUVNUWMVXAULUVOUVQUWEUWRVXEVXCVXDXKUXHVXFUWMVXAULUVRYJWSUWEVWTY
      SDZVXBVWTRUWEUWQVWLVXJUXGVUNUWIUVSYJVWTUVTQYNUWEUWQVWTUWIFGUXGUWIYPQYQUWA
      XOYQUWEUWFUWGUWKUWOUWPUXOUWBXL $.

    $( A simple upper bound on the logarithm of a factorial.  (Contributed by
       Mario Carneiro, 16-Apr-2016.) $)
    logfacubnd $p |- ( ( A e. RR+ /\ 1 <_ A ) ->
      ( log ` ( ! ` ( |_ ` A ) ) ) <_ ( A x. ( log ` A ) ) ) $=
      ( crp wcel c1 cle wbr wa cfv clog cmul co cn cr syl nnrpd relogcld adantr
      remulcld mpbid cc0 cfl cfa rpre flge1nn sylan nnnn0d faccl reflcl relogcl
      cn0 cexp facubnd nnexpcld logled wceq nnzd relogexp syl2anc breqtrd simpl
      cz flle wi rprege0d log1 nnge1d 1rp logleb sylancr syl5eqbrr jca lemul12a
      wb syl22anc mp2and letrd ) ABCZDAEFZGZAUAHZUBHZIHZVTVTIHZJKZAAIHZJKZVSWAV
      SWAVSVTUJCZWALCVSVTVQAMCZVRVTLCAUCZAUDUEZUFZVTUGNOZPVSVTWCVSWHVTMCZVQWHVR
      WIQZAUHNVSVTVSVTWJOZPZRVSAWEWNVQWEMCZVRAUIQZRVSWBVTVTUKKZIHZWDEVSWAWSEFZW
      BWTEFVSWGXAWKVTULNVSWAWSWLVSWSVSVTVTWJWKUMOUNSVSVTBCZVTVACWTWDUOWOVSVTWJU
      PVTVTUQURUSVSVTAEFZWCWEEFZWDWFEFZVSWHXCWNAVBNZVSXCXDXFVSVTAWOVQVRUTUNSVSW
      MTVTEFGWHWCMCZTWCEFZGWQXCXDGXEVCVSVTWOVDWNVSXGXHWPVSTDIHZWCEVEVSDVTEFZXIW
      CEFZVSVTWJVFVSDBCXBXJXKVMVGWODVTVHVISVJVKWRVTAWCWEVLVNVOVP $.

    $( A lower bound on the logarithm of a factorial.  (Contributed by Mario
       Carneiro, 16-Apr-2016.) $)
    logfaclbnd $p |- ( A e. RR+ -> ( A x. ( ( log ` A ) - 2 ) )
       <_ ( log ` ( ! ` ( |_ ` A ) ) ) ) $=
      ( vn vd wcel cfv cmin co cmul cle caddc recnd cc wbr c1 cfz csu wa cr syl
      wceq crp clog cfl cfa rpcn times2d oveq2d relogcl 2cn a1i subdid remulcld
      c2 rpre subsub4d 3eqtr4d cv cdiv resubcld fzfid cn elfznn adantl nnrecred
      fsumrecl cn0 rprege0 flge0nn0 faccl relogcld readdcld reflcl harmoniclbnd
      cc0 nnrpd clt wb rpregt0 lemul2 syl3anc mpbid flle le2subd remulcl syl2an
      peano2rem adantr peano2re fllep1 lesub1dd rpreccld lemul1d subdird nnne0d
      nnred nncnd recidd eqtr2d cfn fsumconst syl2anc cuz elfzuz3 hashfz ax-1cn
      chash addsubd eqtr4d oveq1d eqtrd 3brtr4d sylancl hashfz1 mulid1d 3eqtrrd
      fsumle fsummulc2 oveq12d fsumsub eqid uztrn2 biantrurd wss ad2antll sseld
      uzss pm4.71rd bitr3d pm5.32da an4 3bitr4g elfzuzb anbi12i anasss fsumcom2
      ancom letrd cz nnz flid sumeq1d nnre harmonicubnd eqbrtrrd fsumadd logfac
      nnge1 breqtrd leadd2dd lesubaddd mpbird eqbrtrd ) AUADZAAUBEZUMFGHGZAUUNH
      GZAFGZAFGZAUCEZUDEZUBEZIUUMUUPAUMHGZFGUUPAAJGZFGUUOUURUUMUVBUVCUUPFUUMAAU
      EZUFUGUUMAUUNUMUVDUUMUUNAUHZKUMLDUUMUIUJUKUUMUUPAAUUMUUPUUMAUUNAUNZUVEULZ
      KUVDUVDUOUPUUMUURUVAIMUUQUVAAJGZIMUUMUUQNUUSOGZNBUQZOGZNCUQZURGZCPZBPZUVH
      UUMUUPAUVGUVFUSZUUMUVIUVNBUUMNUUSUTZUUMUVJUVIDZQZUVKUVMCUVSNUVJUTZUVSUVLU
      VKDZQZUVLUWAUVLVADZUVSUVLUVJVBVCVDZVEZVEZUUMUVAAUUMUUTUUMUUTUUMUUSVFDZUUT
      VADUUMARDZVNAIMQUWGAVGAVHSZUUSVISVOVJZUVFVKZUUMUUQAUVIUVMCPZHGZUUSFGZUVOU
      VPUUMUWMUUSUUMAUWLUVFUUMUVIUVMCUVQUUMUVLUVIDZQZUVLUWOUWCUUMUVLUUSVBZVCZVD
      ZVEZULZUUMUWHUUSRDZUVFAVLZSZUSUWFUUMUUPUUSUWMAUVGUXDUXAUVFUUMUUNUWLIMZUUP
      UWMIMZACVMUUMUUNRDUWLRDUWHVNAVPMQUXEUXFVQUVEUWTAVRUUNUWLAVSVTWAUUMUWHUUSA
      IMUVFAWBSZWCUUMUVIAUVMHGZNFGZCPZUVIUVLUUSOGZUVMBPZCPUWNUVOIUUMUVIUXIUXLCU
      VQUWPUXHRDZUXIRDUUMUWHUVMRDZUXMUWOUVFUWOUVLUWQVDAUVMWDWEZUXHWFSUWPUXKUVMB
      UWPUVLUUSUTZUWPUXNUVJUXKDZUWSWGVEUWPAUVLFGZUVMHGZUUSNJGZUVLFGZUVMHGZUXIUX
      LIUWPUXRUYAIMUXSUYBIMUWPAUXTUVLUUMUWHUWOUVFWGZUWPUXBUXTRDUWPUWHUXBUYCUXCS
      UUSWHSZUWPUVLUWRWOZUUMAUXTIMZUWOUUMUWHUYFUVFAWISWGWJUWPUXRUYAUVMUWPAUVLUY
      CUYEUSUWPUXTUVLUYDUYEUSUWPUVLUWPUVLUWRVOWKWLWAUWPUXSUXHUVLUVMHGZFGUXIUWPA
      UVLUVMUUMALDUWOUVDWGUWPUVLUWRWPZUWPUVMUWSKZWMUWPUYGNUXHFUWPUVLUYHUWPUVLUW
      RWNWQUGWRUWPUXLUXKXFEZUVMHGZUYBUWPUXKWSDUVMLDZUXLUYKTUXPUYIUXKUVMBWTXAUWP
      UYJUYAUVMHUWPUYJUUSUVLFGNJGZUYAUWPUUSUVLXBEZDZUYJUYMTUWOUYOUUMUVLNUUSXCVC
      UVLUUSXDSUWPUUSNUVLUUMUUSLDUWOUUMUUSUXDKZWGNLDZUWPXEUJZUYHXGXHXIXJXKXPUUM
      UWNUVIUXHCPZUVINCPZFGUXJUUMUWMUYSUUSUYTFUUMUVIUVMACUVQUVDUYIXQUUMUYTUVIXF
      EZNHGZUUSNHGZUUSUUMUVIWSDZUYQUYTVUBTUVQXEUVINCWTXLUUMVUAUUSNHUUMUWGVUAUUS
      TUWIUUSXMSXIZUUMUUSUYPXNZXOXRUUMUVIUXHNCUVQUWPUXHUXOKUYRXSXHUUMUVIUVKUVIU
      XKBCUVMUVQUVQUVTUUMUVJNXBEZDZUUSUVJXBEZDZQZUVLVUGDZUVJUYNDZQZQZVULUYOQZVU
      MVUJQZQZUVRUWAQUWOUXQQUUMVUNVUKQVUNUYOVUJQZQVUOVURUUMVUNVUKVUSUUMVUNQZVUJ
      VUKVUSVUTVUHVUJVUNVUHUUMNUVJUVLVUGVUGXTYAVCYBVUTVUJUYOVUTVUIUYNUUSVUMVUIU
      YNYCUUMVULUVLUVJYFYDYEYGYHYIVUKVUNYPVULUYOVUMVUJYJYKUVRVUKUWAVUNUVJNUUSYL
      UVLNUVJYLYMUWOVUPUXQVUQUVLNUUSYLUVJUVLUUSYLYMYKUUMUVRUWAUYLUWBUVMUWDKYNYO
      XKYQUUMUVOUVAUUSJGZUVHUWFUUMUVAUUSUWJUXDVKUWKUUMUVOUVIUVJUBEZNJGZBPZVVAIU
      UMUVIUVNVVCBUVQUWEUVSVVBRDVVCRDUVSUVJUVSUVJUVRUVJVADZUUMUVJUUSVBVCZVOVJZV
      VBWHSUVSVVEUVNVVCIMVVFVVENUVJUCEZOGZUVMCPZUVNVVCIVVEVVIUVKUVMCVVEVVHUVJNO
      VVEUVJYRDVVHUVJTUVJYSUVJYTSUGUUAVVEUVJRDNUVJIMVVJVVCIMUVJUUBUVJUUGUVJCUUC
      XAUUDSXPUUMVVDUVIVVBBPZUVINBPZJGVVAUUMUVIVVBNBUVQUVSVVBVVGKUYQUVSXEUJUUEU
      UMUVAVVKUUSVVLJUUMUWGUVAVVKTUWIBUUSUUFSUUMVVLVUBVUCUUSUUMVUDUYQVVLVUBTUVQ
      XEUVINBWTXLVUEVUFXOXRXHUUHUUMUUSAUVAUXDUVFUWJUXGUUIYQYQUUMUUQAUVAUVPUVFUW
      JUUJUUKUUL $.
  $}

  ${
    $d n x A $.  $d k n x y N $.
    $( Show the stronger statement ` log ( x ! ) = x log x - x + O ( log x ) `
       alluded to in ~ logfacrlim .  (Contributed by Mario Carneiro,
       20-May-2016.) $)
    logfacbnd3 $p |- ( ( A e. RR+ /\ 1 <_ A ) ->
      ( abs ` ( ( log ` ( ! ` ( |_ ` A ) ) ) - ( A x. ( ( log ` A ) - 1 ) ) ) )
        <_ ( ( log ` A ) + 1 ) ) $=
      ( vx vn crp wcel c1 cle wbr wa cfv clog cmin co cc0 syl wceq fveq2 syl6eq
      cr a1i cfl cfa cmul cabs caddc cn0 cn simpl rprege0d flge0nn0 faccl nnrpd
      relogcl rpre adantr peano2rem remulcld resubcld recnd abscld ax-1cn subcl
      cc sylancl abs1 oveq2i abs2dif syl5eqbrr cv cfz csu oveq2d sumeq1d oveq1d
      cmpt id oveq12d eqid ovex fvmpt3i logfac eqtr4d 1rp cz 1z flid ax-mp log1
      0cn fsum1 mp2an subcli mulid2i nncan mp1i fveq2d cpnf cioo ioorp nnuz 1re
      eqcomi cxr pnfxr 1nn0 nn0addge1i 0re adantl nnrp sylan2 cdv advlog simp32
      w3a wb logleb 3ad2ant2 mpbid simprr simprl sylancr 1le1 simpr rexrd pnfge
      dvfsum2 eqbrtrrd letrd lesubaddd ) ADEZFAGHZIZAUAJZUBJZKJZAAKJZFLMZUCMZLM
      ZUDJZFLMZYPGHYTYPFUEMGHYLUUAYSFLMZUDJZYPYLYTSEUUASEYLYSYLYSYLYOYRYLYNDEYO
      SEYLYNYLYMUFEZYNUGEYLASEZNAGHIUUDYLAYJYKUHZUIAUJOZYMUKOULYNUMOYLAYQYJUUEY
      KAUNUOZYLYPSEZYQSEYJUUIYKAUMUOZYPUPOUQURUSZUTZYTUPOYLUUBYLYSVCEZFVCEZUUBV
      CEUUKVAYSFVBVDUTUUJYLUUAYTFUDJZLMZUUCGUUOFYTLVEVFYLUUMUUNUUPUUCGHUUKVAYSF
      VGVDVHYLABDFBVIZUAJZVJMZCVIZKJZCVKZUUQUUQKJZFLMZUCMZLMZVOZJZFUVGJZLMZUDJU
      UCYPGYLUVJUUBUDYLUVHYSUVIFLYLUVHFYMVJMZUVACVKZYRLMZYSYJUVHUVMPYKBAUVFUVMD
      UVGUUQAPZUVBUVLUVEYRLUVNUUSUVKUVACUVNUURYMFVJUUQAUAQVLVMUVNUUQAUVDYQUCUVN
      VPUVNUVCYPFLUUQAKQZVNVQVQUVGVRZUVBUVELVSZVTUOYLYOUVLYRLYLUUDYOUVLPUUGCYMW
      AOVNWBFDEZUVIFPYLWCBFUVFFDUVGUUQFPZUVFNNFLMZLMZFUVSUVBNUVEUVTLUVSUVBFFVJM
      ZUVACVKZNUVSUUSUWBUVACUVSUURFFVJUVSUURFUAJZFUUQFUAQFWDEZUWDFPWEFWFWGRVLVM
      UWENVCEZUWCNPWEWIUVANCFUUTFPUVAFKJZNUUTFKQWHRWJWKRUVSUVEFUVTUCMUVTUVSUUQF
      UVDUVTUCUVSVPUVSUVCNFLUVSUVCUWGNUUQFKQWHRVNVQUVTNFWIVAWLWMRVQUWFUUNUWAFPW
      IVANFWNWKRUVPUVQVTWOVQWPYLBUVEUVCUVAFDNWQCYPUVGFSFAUGNWQWRMDWSXBWTUWEYLWE
      TFSEYLXATZWQXCEYLXDTFFFUEMGHYLFFXAXEXFTNSEYLXGTYLUUQDEZIZUUQUVDUWIUUQSEYL
      UUQUNXHUWJUVCSEZUVDSEUWIUWKYLUUQUMXHZUVCUPOUQUWLUUQUGEYLUWIUWKUUQXIUWLXJS
      BDUVEVOXKMBDUVCVOPYLBXLTUUQUUTKQYLUWIUUTDEIZFUUQGHZUUQUUTGHZUUTWQGHZXNZXN
      UWOUVCUVAGHZYLUWMUWNUWOUWPXMUWMYLUWOUWRXOUWQUUQUUTXPXQXRUVPYLUWIUWNIIZNUW
      GUVCGWHUWSUWNUWGUVCGHZYLUWIUWNXSUWSUVRUWIUWNUWTXOWCYLUWIUWNXTFUUQXPYAXRVH
      UVRYLWCTUUFFFGHYLYBTYJYKYCYLAXCEAWQGHYLAUUHYDAYEOUVOYFYGYHYLYTFYPUULUWHUU
      JYIXR $.

    $( Combine the estimates ~ logfacubnd and ~ logfaclbnd , to get
       ` log ( x ! ) = x log x + O ( x ) ` .  Equation 9.2.9 of [Shapiro],
       p. 329.  This is a weak form of the even stronger statement,
       ` log ( x ! ) = x log x - x + O ( log x ) ` .  (Contributed by Mario
       Carneiro, 16-Apr-2016.)  (Revised by Mario Carneiro, 21-May-2016.) $)
    logfacrlim $p |- ( x e. RR+ |->
      ( ( log ` x ) - ( ( log ` ( ! ` ( |_ ` x ) ) ) / x ) ) ) ~~>r 1 $=
      ( crp cfv cdiv co cmin cmpt c1 crli wbr wtru cc0 cr wcel cc ax-1cn wa cle
      cabs adantrr cv clog cfl cfa caddc 1re a1i wne wceq relogcl recnd rpcnne0
      adantl divdir syl3anc mpteq2dva simpr rerpdivcld rpreccl rpred ccxp cxp1d
      simpld oveq2d 1rp mp1i eqbrtrrd divrcnv rlimadd eqbrtrd syl6breq peano2re
      cxploglim 00id syl cn rprege0 flge0nn0 faccl 3syl nnrpd subcld logfacbnd3
      cn0 cmul clt wb ad2antrl subcl sylancl mulcld abscld rpregt0 lediv1 mpbid
      simprd divcan3d oveq1d sub32d fveq2d absdivd abssubd absid oveq12d 3eqtrd
      divsubdir 3eqtr4rd subid1d log1 simprr logleb syl5eqbrr ge0p1rpd rpdivcld
      sylancr eqtrd 3brtr4d rlimsqzlem trud ) ABAUAZUBCZXTUCCZUDCZUBCZXTDEZFEZG
      HIJKABYAHUEEZXTDEZYFLHHHMNKUFUGHONZKPUGKABYHGZLLUEEZLIKYJABYAXTDEZHXTDEZU
      EEZGYKIKABYHYNKXTBNZQZYAONZYIXTONZXTLUHZQZYHYNUIYPYAYOYAMNZKXTUJUMZUKZYIY
      PPUGYOYTKXTULZUMZYAHXTUNUOUPKABYLYMLLMYPYAXTUUBKYOUQZURYPYMYOYMBNKXTUSUMU
      TKABYAXTHVAEZDEZGZABYLGLIKABUUHYLYPUUGXTYADYPXTYPYRYSUUEVCVBVDUPHBNZUUILI
      JKVEHAVMVFVGYIABYMGLIJKPHAVHVFVIVJVNVKYPYHYPYGXTYPUUAYGMNZUUBYAVLZVOUUFUR
      UKZYPYAYEUUCYPYEYPYDXTYPYCBNYDMNYPYCYPXTMNZLXTRJQZYBWDNYCVPNYOUUOKXTVQZUM
      XTVRYBVSVTWAYCUJVOZUUFURUKZWBKYOHXTRJZQZQZYDXTYAHFEZWEEZFEZSCZXTDEZYHYFHF
      EZSCZYHLFEZSCZRUVAUVEYGRJZUVFYHRJZUUTUVKKXTWCUMUVAUVEMNUUKUUNLXTWFJQZUVKU
      VLWGUVAUVDUVAYDUVCKYOYDONZUUSYPYDUUQUKTZUVAXTUVBUVAYRYSYOYTKUUSUUDWHZVCZU
      VAYQYIUVBONKYOYQUUSUUCTZPYAHWIWJZWKZWBWLUVAUUAUUKKYOUUAUUSUUBTZUULVOYOUVM
      KUUSXTWMWHUVEYGXTWNUOWOUVAUVHUVCYDFEZXTDEZSCUWBSCZXTSCZDEUVFUVAUVGUWCSUVA
      UVCXTDEZYEFEZUVBYEFEUWCUVGUVAUWFUVBYEFUVAUVBXTUVSUVQUVAYRYSUVPWPZWQWRUVAU
      VCONUVNYTUWCUWGUIUVTUVOUVPUVCYDXTXFUOUVAYAYEHUVRKYOYEONUUSUURTYIUVAPUGWSX
      GWTUVAUWBXTUVAUVCYDUVTUVOWBUVQUWHXAUVAUWDUVEUWEXTDUVAUVCYDUVTUVOXBUVAUUOU
      WEXTUIYOUUOKUUSUUPWHXTXCVOXDXEUVAUVJYHSCZYHUVAUVIYHSUVAYHKYOYHONUUSUUMTXH
      WTUVAYHBNYHMNLYHRJQUWIYHUIUVAYGXTUVAYAUWAUVALHUBCZYARXIUVAUUSUWJYARJZKYOU
      USXJUVAUUJYOUUSUWKWGVEKYOYOUUSUUFTZHXTXKXOWOXLXMUWLXNYHVQYHXCVTXPXQXRXS
      $.

    $( The sum ` sum_ n <_ x , log ^ N ( x / n ) ` has the asymptotic expansion
       ` ( N ! ) x + o ( x ) ` .  (More precisely, the omitted term has order
       ` O ( log ^ N ( x ) / x ) ` .)  (Contributed by Mario Carneiro,
       22-May-2016.) $)
    logexprlim $p |- ( N e. NN0 -> ( x e. RR+ |->
      ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( log ` ( x / n ) ) ^ N ) / x ) )
        ~~>r ( ! ` N ) ) $=
      ( vk wcel crp c1 cfv co cdiv cc0 cmul cmin cmpt cr wa wbr wceq cc cle cn0
      vy cfl cfz clog cexp csu cfa caddc crli fzfid simpr elfznn rpdivcl syl2an
      cv nnrpd relogcld simpll reexpcld fsumrecl relogcl reexpcl syl2anr adantr
      id cn faccl nnred adantl elfznn0 syl nndivred remulcld resubcld rerpdivcl
      rerpdivcld sylancom nncnd simpl oveq2d oveq1d mpteq2dva breq1d ccxp recnd
      1re a1i cxpexp rpcn oveq12d 1rp mulcld subcld wne simprd cabs adantrr cdv
      abscld 1z nnne0d eqtrd oveq2 fveq2d w3a rpdivcld log1 rpcnd mulid2d rpred
      eqbrtrd lemuldivd mpbid wb logleb sylancr syl5eqbrr 3ad2antr1 cvv sumeq1d
      ad2antrl syl6eq sumeq2dv 0cn ax-mp ax-1cn cdif ovex fvmptd 3eqtrd 3brtr3d
      div0d divsubdir syl3anc wss rpssre rlimconst breqtrd syl6breq cxp1d nn0cn
      cxploglim2 sylancl eqbrtrrd vtoclga rpcnne0 simpld divcld cpnf cioo ioorp
      csb eqcomi nnuz cz 1nn0 nn0addge1i 0re rpre simprl sylan nnrp sylan2 reex
      cpr prid1 advlogexp syl2anc dvmptcmul divcan2d rpxrd simp2r simp2l simp1l
      simp1rl simp33 simp32 lediv2d logled leexp1a syl32anc eqid simpr3 expge0d
      simpr1 simprr leidd dvfsumlem4 expcld fsumcl sub32d eqidd divid sylan9eqr
      1le1 csn cuz nn0uz syl6eleq eluzfz1 snssd elsni exp0 fveq2 div1i syl6eqel
      fac0 eldifi eldifsni eldifsn sylanbrc syl6eleqr 0expd fsumss eqtr4d sumsn
      dfn2 mp2an mulid1d div1d eqeltrd subdird divcan1d 3eqtr4d absmuld rprege0
      flid fsum1 absid csbied leabsd letrd subid1d breqtrrd rlimsqzlem fsumdivc
      divass rpcnne0d divdiv32 anasss an32s rlimdiv fsumrlim cfn fzfi olci sumz
      wo rlimmul mul01d rlimsub subidi rlimadd npcand addid1d ) CUAEZAFGAUPZUCH
      ZUDIZVURBUPZJIZUEHZCUFIZBUGZVURUEHZCUFIZCUHHZKCUDIZVVFDUPZUFIZVVJUHHZJIZD
      UGZLIZMIZMIZVURJIZVVPVURJIZUIIZNVVHKUIIAFVVEVURJIZNVVHUJVUQAFVVRVVSVVHKOV
      UQVURFEZPZVVQVURVWCVVEVVPVWCVUTVVDBVWCGVUSUKVWCVVAVUTEZPZVVCCVWEVVBVWCVWB
      VVAFEZVVBFEZVWDVUQVWBULZVWDVVAVVAVUSUMUQZVURVVAUNZUOURVUQVWBVWDUSUTVAZVWC
      VVGVVOVWBVVFOEZVUQVVGOEZVUQVURVBZVUQVFVVFCVCVDZVWCVVHVVNVWCVVHVUQVVHVGEZV
      WBCVHZVEVIZVWCVVIVVMDVWCKCUKZVWCVVJVVIEZPZVVKVVLVWCVWLVVJUAEZVVKOEZVWTVWB
      VWLVUQVWNVJVVJCVKZVVFVVJVCZUOZVXAVXBVVLVGEZVWTVXBVWCVXDVJVVJVHZVLZVMZVAZV
      NZVOZVOVWHVQVUQVWBVVPOEVVSOEVXMVVPVURVPVRZVUQAFVVGVURJIZVVRKVVHGGOEZVUQWG
      WHVUQVVHVWQVSZAFVVKVURJIZNZKUJQZAFVXONZKUJQDCUAVVJCRZVXSVYAKUJVYBAFVXRVXO
      VYBVWBPZVVKVVGVURJVYCVVJCVVFUFVYBVWBVTWAWBWCWDVXBAFVVFVVJWEIZVURGWEIZJIZN
      ZVXSKUJVXBAFVYFVXRVXBVWBPZVYDVVKVYEVURJVWBVVFSEVXBVYDVVKRVXBVWBVVFVWNWFVX
      BVFVVFVVJWIVDVYHVURVWBVURSEZVXBVURWJVJUUAWKWCVXBVVJSEGFEZVYGKUJQVVJUUBWLV
      VJGAUUCUUDUUEZUUFZVWCVXOVUQVWBVWMVXOOEZVWOVVGVURVPVRZWFZVWCVVQVURVWCVVEVV
      PVWCVVEVWKWFZVWCVVGVVOVWCVVGVWOWFZVWCVVHVVNVUQVVHSEZVWBVXQVEZVWCVVNVXKWFZ
      WMZWNZWNZVWCVYIVURKWOZVWBVYIWUDPZVUQVURUUGZVJZUUHZVWCVYIWUDWUGWPZUUIZVUQV
      WBGVURTQZPZPZVVRVVHMIZWQHZVXOWQHZVXOKMIZWQHTWUMWUOVXOWUPWUMWUNWUMVVRVVHVU
      QVWBVVRSEWUKWUJWRZWUMVVHVUQVWPWULVWQVEZVSZWNZWTZVUQVWBVYMWUKVYNWRZWUMVXOW
      UMVXOWVCWFWTWUMWUOVURLIZVVGTQWUOVXOTQWUMVURUBFGUBUPZUCHZUDIZVVDBUGZVVHWVE
      VVIVURWVEJIZUEHZVVJUFIZVVLJIZDUGZLIZLIZMIZNZHZGWVQHZMIZWQHZUBGWVJCUFIZUUM
      WVDVVGTWUMUBWVOWWBVVDGFKVURBWVQGOGVURVGKUUJUUKIFUULUUNUUOGUUPEZWUMXAWHVXP
      WUMWGWHGGGUIITQWUMGGWGUUQUURWHKOEWUMUUSWHWUMWVEFEZPZVVHWVNWWEVVHWUMVWPWWD
      WUSVEZVIWWEWVEWVMWWDWVEOEWUMWVEUUTVJWWEVVIWVLDWWEKCUKWWEVWTPZWVKVVLWWEWVJ
      OEZVXBWVKOEVWTWWEWVIWUMVWBWWDWVIFEZVUQVWBWUKUVAZVURWVEUNUVBZURZVXDWVJVVJV
      CUOWWGVXBVXGVWTVXBWWEVXDVJVXHVLVMVAVNZVNWWEWVJCWWLVUQWULWWDUSUTZWVEVGEWUM
      WWDWWBOEWVEUVCWWNUVDWUMOUBFWVONWSIUBFVVHWWBVVHJIZLIZNUBFWWBNWUMUBWVNWWOVV
      HOOFOOSUVFEWUMOSUVEUVGWHWWEWVNWWMWFWWEWWBVVHWWNWWFVMWUMVWBVUQOUBFWVNNWSIU
      BFWWONRWWJVUQWULVTZUBVURDCUVHUVIWUTUVJWUMUBFWWPWWBWWEWWBVVHWWEWWBWWNWFWUM
      VYRWWDWUTVEWUMVVHKWOWWDWUMVVHWUSXBVEUVKWCXCWVEVVARZWVJVVCCUFWWRWVIVVBUEWV
      EVVAVURJXDXEWBWUMVURWWJUVLWUMWWDVWFPZGWVETQZWVEVVATQZVVAVURTQZXFZXFZVVCOE
      WWHVUQKVVCTQVVCWVJTQZVVDWWBTQWXDVVBWXDVURVVAVWBWUKVUQWWSWXCUVPZWUMWWDVWFW
      XCUVMZXGZURWXDWVIWXDVURWVEWXFWUMWWDVWFWXCUVNZXGZURVUQWULWWSWXCUVOWXDKGUEH
      ZVVCTXHWXDGVVBTQZWXKVVCTQZWXDGVVALIZVURTQWXLWXDWXNVVAVURTWXDVVAWXDVVAWXGX
      IXJWUMWWSWWTWXAWXBUVQXLWXDGVURVVAVXPWXDWGWHWXDVURWXFXKWXGXMXNWXDVYJVWGWXL
      WXMXOWLWXHGVVBXPXQXNXRWXDVVBWVITQZWXEWXDWXAWXOWUMWWSWWTWXAWXBUVRWXDWVEVVA
      VURWXIWXGWXFUVSXNWXDVVBWVIWXHWXJUVTXNVVCWVJCUWAUWBWVQUWCWUMWWDWWTWVEVURTQ
      ZXFZPZWVJCWXRWVIWUMWWTWWDWWIWXPWWKXSZURVUQWULWXQUSWXRKWXKWVJTXHWXRGWVITQZ
      WXKWVJTQZWXRGWVELIZVURTQWXTWXRWYBWVEVURTWXRWVEWUMWWTWWDWVESEZWXPWWDWYCWUM
      WVEWJVJXSXJWUMWWDWWTWXPUWDXLWXRGVURWVEVXPWXRWGWHWUMVUROEZWXQWUMVURWWJXKZV
      EWUMWWDWWTWXPUWFXMXNWXRVYJWWIWXTWYAXOWLWXSGWVIXPXQXNXRUWEVYJWUMWLWHZWWJGG
      TQWUMUWPWHVUQVWBWUKUWGWUMVURWYEUWHUWIWUMWWAWUNVURLIZWQHWUOVURWQHZLIWVDWUM
      WVTWYGWQWUMVVEVVHVURLIZMIZVVPMIVVQWYIMIZWVTWYGWUMVVEWYIVVPWUMVVEWUMVUTVVD
      BWUMGVUSUKWUMVWDPZVVCCWYLVVBWUMVWBVWFVWGVWDWWJVWIVWJUOURVUQWULVWDUSUTVAWF
      WUMVVHVURWUTWUMVURWWJXIZWMWUMVVGVVOWUMVVFCWUMVVFVWBVWLVUQWUKVWNYBZWFWWQUW
      JZWUMVVHVVNWUTWUMVVIVVMDWUMKCUKWUMVWTPZVVMWYPVVKVVLWUMVWLVXBVXCVWTWYNVXDV
      XEUOWYPVXBVXGVWTVXBWUMVXDVJVXHVLVMWFUWKZWMWNUWLWUMWVRWYJWVSVVPMWUMUBVURWV
      PWYJFWVQXTWUMWVQUWMZWUMWVEVURRZPZWVHVVEWVOWYIMWYTWVGVUTVVDBWYTWVFVUSGUDWY
      TWVEVURUCWUMWYSULZXEWAYAWYTWVNVURVVHLWYTWVNVURGLIZVURWYTWVEVURWVMGLXUAWYT
      WVMKUWQZKVVJUFIZVVLJIZDUGZGWYTWVMVVIXUEDUGXUFWYTVVIWVLXUEDWYTVWTPZWVKXUDV
      VLJXUGWVJKVVJUFXUGWVJWXKKXUGWVIGUEWYTWVIGRVWTWYSWUMWVIVURVURJIZGWVEVURVUR
      JXDWUMWUEXUHGRVWBWUEVUQWUKWUFYBZVURUWNVLUWOVEXEXHYCWBWBYDWYTXUCVVIXUEDWYT
      KVVIWUMKVVIEZWYSWUMCKUWRHZEXUJWUMCUAXUKWWQUWSUWTKCUXAVLVEUXBWYTVVJXUCEZPZ
      XUEGSXUMVVJKRZXUEGRXULXUNWYTVVJKUXCVJXUNXUEGGJIGXUNXUDGVVLGJXUNXUDKKUFIZG
      VVJKKUFXDKSEZXUOGRYEKUXDYFYCXUNVVLKUHHGVVJKUHUXEUXHYCWKGYGUXFYCZVLYGUXGWY
      TVVJVVIXUCYHEZPZXUEKVVLJIZKXUSXUDKVVLJXUSVVJXUSVVJUAXUCYHZVGXUSVXBVVJKWOZ
      VVJXVAEXUSVWTVXBXURVWTWYTVVJVVIXUCUXIVJVXDVLZXURXVBWYTVVJVVIKUXJVJVVJUAKU
      XKUXLUXRUXMUXNWBXUSVVLXUSVVLXUSVXBVXGXVCVXHVLZVSXUSVVLXVDXBYMXCWYTKCUKUXO
      UXPXUPGSEZXUFGRYEYGXUEGDKSXUQUXQUXSYCWKWUMXUBVURRWYSWUMVURWYMUXTVEXCWAWKW
      WJWYJXTEWUMVVEWYIMYIWHYJWUMUBGWVPVVPFWVQXTWYRWUMWVEGRZPZWVHVVGWVOVVOMXVGW
      VHGGUDIZVVDBUGZVURGJIZUEHZCUFIZVVGXVGWVGXVHVVDBXVGWVFGGUDXVGWVFGUCHZGXVGW
      VEGUCWUMXVFULZXEWWCXVMGRXAGUYHYFYCWAYAXVGWWCXVLSEXVIXVLRXAXVGXVLVVGSXVGXV
      KVVFCUFXVGXVJVURUEWUMXVJVURRXVFWUMVURWYMUYAVEZXEWBZWUMVVGSEZXVFWYOVEUYBVV
      DXVLBGVVAGRZVVCXVKCUFXVRVVBXVJUEVVAGVURJXDXEWBUYIXQXVPYKXVGWVNVVNVVHLXVGW
      VNGVVNLIVVNXVGWVEGWVMVVNLXVNXVGVVIWVLVVMDXVGVWTPZWVKVVKVVLJXVSWVJVVFVVJUF
      XVGWVJVVFRVWTXVGWVIVURUEXVGWVIXVJVURXVGWVEGVURJXVNWAXVOXCXEZVEWBWBYDWKXVG
      VVNWUMVVNSEZXVFWYQVEXJXCWAWKWYFVVPXTEWUMVVGVVOMYIWHYJWKWUMWYGVVRVURLIZWYI
      MIWYKWUMVVRVVHVURWURWUTWYMUYCWUMXWBVVQWYIMWUMVVQVURVUQVWBVVQSEWUKWUCWRWYM
      WUMVYIWUDXUIWPUYDWBXCUYEXEWUMWUNVURWVAWYMUYFWUMWYHVURWUOLWUMWYDKVURTQPZWY
      HVURRVWBXWCVUQWUKVURUYGYBVURUYJVLWAYKWUMUBGWWBVVGSXVEWUMYGWHXVGWVJVVFCUFX
      VTWBUYKYLWUMWUOVVGVURWVBVUQVWBVWMWUKVWOWRWWJXMXNWUMVXOWVCUYLUYMWUMWUQVXOW
      QWUMVXOVUQVWBVXOSEWUKVYOWRUYNXEUYOUYPVUQAFVVSNAFVXOVVOVURJIZMIZNZKUJVUQAF
      VVSXWEVWCXVQVVOSEWUEVVSXWERVYQWUAWUGVVGVVOVURYNYOWCVUQXWFKKMIKUJVUQAFVXOX
      WDKKOVYNVUQVWBVVOOEXWDOEVXLVVOVURVPVRVYLVUQAFXWDNAFVVHVVIVXRVVLJIZDUGZLIZ
      NZKUJVUQAFXWDXWIVWCXWDVVHVVNVURJIZLIZXWIVWCVYRXWAWUEXWDXWLRVYSVYTWUGVVHVV
      NVURUYRYOVWCXWKXWHVVHLVWCXWKVVIVVMVURJIZDUGXWHVWCVVIVVMVURDVWSWUHVXAVVMVX
      JWFWUIUYQVWCVVIXWMXWGDVXAVVKSEVVLSEZVVLKWOZPWUEXWMXWGRVXAVVKVXFWFVXAVVLVX
      AVVLVXIUQUYSVWCWUEVWTWUGVEVVKVVLVURUYTYOYDXCWAXCWCVUQXWJVVHKLIKUJVUQAFVVH
      XWHVVHKOVWRVWCVVIXWGDVWSVXAVXRVVLVXAVVKVURVXFVWCVWBVWTVWHVEVQZVXIVMZVAVUQ
      FOYPZVYRAFVVHNVVHUJQYQVXQAFVVHYRXQVUQAFXWHNVVIKDUGZKUJVUQAFVVIXWGKDOXWRVU
      QYQWHVUQKCUKVUQVWBVWTXWGOEXWQVUAVUQVWTPZAFXWGNXUTKUJXWTAFVXRVVLKVVLOVUQVW
      BVWTVXROEXWPVUBXWTVVLOEVWBXWTVVLXWTVXBVXGVWTVXBVUQVXDVJZVXHVLZVIVEXWTVXBV
      XTXXAVYKVLXWTXWRXWNAFVVLNVVLUJQYQXWTVVLXXBVSZAFVVLYRXQXWTVVLXXBXBZXWTXWOV
      WBXXDVEVUCXWTVVLXXCXXDYMYSVUDVVIXUKYPZVVIVUEEZVUIXWSKRXXFXXEKCVUFVUGVVIDK
      VUHYFYTVUJVUQVVHVXQVUKYSXLVULKYEVUMYTXLVUNVUQAFVVTVWAVWCVVTVWAVVSMIZVVSUI
      IVWAVWCVVRXXGVVSUIVWCVVESEVVPSEWUEVVRXXGRVYPWUBWUGVVEVVPVURYNYOWBVWCVWAVV
      SVWCVWAVWCVVEVURVWKVWHVQWFVWCVVSVXNWFVUOXCWCVUQVVHVXQVUPYL $.

    $( Write out ~ logfacrlim as a sum of logs.  (Contributed by Mario
       Carneiro, 18-May-2016.)  (Revised by Mario Carneiro, 22-May-2016.) $)
    logfacrlim2 $p |- ( x e. RR+ |->
      sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( log ` ( x / n ) ) / x ) ) ~~>r 1 $=
      ( crp c1 cv cfl cfv cfz co cdiv clog cexp csu cmpt cfa crli cn0 wcel 1nn0
      wbr logexprlim ax-mp wa elfznn nnrpd sylan2 relogcld recnd exp1d sumeq2dv
      rpdivcl oveq1d fzfid rpcn rpne0 fsumdivc eqtrd mpteq2ia fac1 3brtr3i ) AC
      DAEZFGZHIZVABEZJIZKGZDLIZBMZVAJIZNZDOGZACVCVFVAJIBMZNDPDQRVJVKPTSABDUAUBA
      CVIVLVACRZVIVCVFBMZVAJIVLVMVHVNVAJVMVCVGVFBVMVDVCRZUCZVFVPVFVPVEVOVMVDCRV
      ECRVOVDVDVBUDUEVAVDUKUFUGUHZUIUJULVMVCVFVABVMDVBUMVAUNVQVAUOUPUQURUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Perfect Number Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n P $.
    $( A Mersenne prime is a prime number of the form ` 2 ^ P - 1 ` .  This
       theorem shows that the ` P ` in this expression is necessarily also
       prime.  (Contributed by Mario Carneiro, 17-May-2016.) $)
    mersenne $p |- ( ( P e. ZZ /\ ( ( 2 ^ P ) - 1 ) e. Prime ) ->
      P e. Prime ) $=
      ( vk vn cz wcel c2 cexp co c1 cmin wbr clt cn syl a1i sylanbrc cdiv mpbid
      cr cc0 cprime wa cuz cfv cv cdivides wn cfz wral simpl caddc 2nn0 numexp1
      df-2 eqtri prmuz2 adantl eluz2b2 simprbi 1re 2re 2ne0 reexpclzd ltaddsubd
      wne mpbird syl5eqbr 1lt2 ltexp2d eluz2b1 cmul simpllr prmnn nncnd cn0 2nn
      1z elfzuz ad2antlr simplbi nnnn0d nnexpcl sylancr nnzd peano2zm recnd 0re
      zred 0lt1 elfzelz syl5eqbrr nnred lttrd elnnz nnne0d divcan2d eqeltrd csu
      cneg cc wceq wb ax-1cn sylancl necon3bid simpr ad2antrr nndivdvds syl2anc
      subeq0 geoser negsubdi2 oveq2d expmuld eqtr3d eqtrd oveq12d 3eqtr2d fzfid
      div2negd elfznn0 zexpcl syl2an fsumzcl eqeltrrd mulid2d cle w3a 2z biimpa
      elfzm11 simp3d adantr ltsub1dd ltmuldiv syl112anc nprm pm2.65da ralrimiva
      eqbrtrd isprm3 ) ADEZFAGHZIJHZUAEZUBZAFUCUDZEZBUEZAUFKZUGZBFAIJHZUHHZUIAU
      AEUUFUUBIALKZUUHUUBUUEUJZUUFUUNFIGHZUUCLKUUFUUPIIUKHZUUCLUUPFUUQFULUMUNUO
      ZUUFUUQUUCLKIUUDLKZUUFUUDUUGEZUUSUUEUUTUUBUUDUPUQUUTUUDMEZUUSUUDURUSNUUFI
      IUUCISEZUUFUTOZUVCUUFFAFSEZUUFVAOZFTVEUUFVBOUUOVCZVDVFVGUUFFIAUVEIDEZUUFV
      QOUUOIFLKZUUFVHOVIVFAVJPZUUFUUKBUUMUUFUUIUUMEZUBZUUJFUUIGHZIJHZUUDUVMQHZV
      KHZUAEZUVKUUJUBZUVOUUDUAUVQUUDUVMUVQUUDUVQUUEUVAUUBUUEUVJUUJVLZUUDVMNZVNZ
      UVQUVMUVQUVMUVQUVLDEZUVMDEZUVQUVLUVQFMEUUIVOEUVLMEVPUVQUUIUVQUUIUUGEZUUIM
      EZUVJUWCUUFUUJUUIFUULVRVSZUWCUWDIUUILKZUUIURZVTNZWAZFUUIWBWCZWDZUVLWENZWH
      ZWFZUVQUVMUVQUWBTUVMLKZUVMMEZUWLUVQTIUVMTSEUVQWGOUVBUVQUTOZUWMTILKUVQWIOU
      VQUUQUVLLKIUVMLKZUVQUUQUUPUVLLUURUVQUWFUUPUVLLKUVQUWCUWFUWEUWCUWDUWFUWGUS
      NUVQFIUUIUVDUVQVAOZUVGUVQVQOUVJUUIDEZUUFUUJUUIFUULWJVSZUVHUVQVHOZVIRWKUVQ
      IIUVLUWQUWQUVQUVLUWJWLZVDRZWMZUVMWNPZWOZWPUVRWQUVQUVMUUGEZUVNUUGEZUVPUGUV
      QUWPUWRUXHUXFUXDUVMURPUVQUVNDEIUVNLKZUXIUVQTAUUIQHZIJHZUHHZUVLCUEZGHZCWRZ
      UVNDUVQUXPIUVLUXKGHZJHZIUVLJHZQHUUDWSZUVMWSZQHUVNUVQUVLCUXKUVQUVLUWJVNZUV
      QUVMTVEUVLIVEUXGUVQUVMTUVLIUVQUVLWTEZIWTEZUVMTXAUVLIXAXBUYBXCUVLIXJXDXERU
      VQUXKUVQUUJUXKMEZUVKUUJXFUVQAMEZUWDUUJUYEXBUUFUYFUVJUUJUUFUUHUYFUVIUUHUYF
      UUNAURVTNXGZUWHAUUIXHXIRWAZXKUVQUXTUXRUYAUXSQUVQUXTIUUCJHZUXRUVQUUCWTEUYD
      UXTUYIXAUVQUUCUUFUUCSEUVJUUJUVFXGZWFXCUUCIXLXDUVQUUCUXQIJUVQFUUIUXKVKHZGH
      UUCUXQUVQUYKAFGUVQAUUIUVQAUYGVNUVQUUIUWHVNUVQUUIUWHWOWPXMUVQFUUIUXKUVQFUW
      SWFUYHUWIXNXOXMXPUVQUYCUYDUYAUXSXAUYBXCUVLIXLXDXQUVQUUDUVMUVTUWNUXGXTXRUV
      QUXMUXOCUVQTUXLXSUVQUWAUXNVOEUXODEUXNUXMEUWKUXNUXLYAUVLUXNYBYCYDYEUVQIUVM
      VKHZUUDLKZUXJUVQUYLUVMUUDLUVQUVMUWNYFUVQUVLUUCIUXCUYJUWQUVQUUIALKZUVLUUCL
      KUVKUYNUUJUVKUWTFUUIYGKZUYNUUFUVJUWTUYOUYNYHZUUFFDEUUBUVJUYPXBYIUUOUUIFAY
      KWCYJYLYMUVQFUUIAUWSUXAUUFUUBUVJUUJUUOXGUXBVIRYNYTUVQUVBUUDSEUVMSEUWOUYMU
      XJXBUWQUVQUUDUVSWLUWMUXEIUUDUVMYOYPRUVNVJPUVMUVNYQXIYRYSBAUUAP $.

    $( Euclid's contribution to the Euclid-Euler theorem.  A number of the form
       ` 2 ^ ( p - 1 ) x. ( 2 ^ p - 1 ) ` is a perfect number.  (Contributed by
       Mario Carneiro, 17-May-2016.) $)
    perfect1 $p |- ( ( P e. ZZ /\ ( ( 2 ^ P ) - 1 ) e. Prime ) ->
      ( 1 sigma ( ( 2 ^ ( P - 1 ) ) x. ( ( 2 ^ P ) - 1 ) ) ) =
        ( ( 2 ^ P ) x. ( ( 2 ^ P ) - 1 ) ) ) $=
      ( cz wcel c2 cexp co cmin cprime csgm cmul wceq syl adantl sylancr ax-1cn
      c1 cn cc cdivides wbr wa mersenne prmnn 1sgm2ppw caddc 1sgmprm cn0 nnnn0d
      2nn nnexpcl nncnd npcan sylancl oveq12d cgcd a1i nnm1nn0 nnzd prmz gcdcom
      eqtrd syl2anc wn iddvds clt wi cuz prmuz2 eluz2b2 simprbi ndvdsp1 syl3anc
      cfv mpd 2z dvdsmultr1 2cn expm1t eqtr2d breq2d sylibd mtod wb simpr coprm
      mpbid sgmmul syl13anc subcl mulcomd 3eqtr4d ) ABCZDAEFZPGFZHCZUAZPDAPGFZE
      FZIFZPWNIFZJFZWNWMJFPWRWNJFIFZWMWNJFWPWSWNWTWMJWPAQCZWSWNKWPAHCXCAUBAUCLZ
      AUDLWPWTWNPUEFZWMWOWTXEKWLWNUFMWPWMRCZPRCZXEWMKWPWMWPDQCZAUGCWMQCUIWPAXDU
      HDAUJNUKZOWMPULUMZVAUNWPXGWRQCZWNQCZWRWNUOFZPKXBXAKXGWPOUPWPXHWQUGCZXKUIW
      PXCXNXDAUQLDWQUJNZWOXLWLWNUCMZWPXMWNWRUOFZPWPWRBCZWNBCZXMXQKWPWRXOURZWOXS
      WLWNUSMZWRWNUTVBWPWNWRSTZVCZXQPKZWPYBWNXESTZWPWNWNSTZYEVCZWPXSYFYAWNVDLWP
      XSXLPWNVETZYFYGVFYAXPWPWNDVGVMCZYHWOYIWLWNVHMYIXLYHWNVIVJLWNWNVKVLVNWPYBW
      NWRDJFZSTZYEWPXSXRDBCZYBYKVFYAXTYLWPVOUPWNWRDVPVLWPYJXEWNSWPXEWMYJXJWPDRC
      XCWMYJKVQXDDAVRNVSVTWAWBWPWOXRYCYDWCWLWOWDXTWNWRWEVBWFVAPWRWNWGWHWPWMWNXI
      WPXFXGWNRCXIOWMPWIUMWJWK $.
  $}

  ${
    $d k n x A $.  $d k n x B $.  $d k n x ph $.
    perfectlem.1 $e |- ( ph -> A e. NN ) $.
    perfectlem.2 $e |- ( ph -> B e. NN ) $.
    perfectlem.3 $e |- ( ph -> -. 2 || B ) $.
    perfectlem.4 $e |- ( ph ->
      ( 1 sigma ( ( 2 ^ A ) x. B ) ) = ( 2 x. ( ( 2 ^ A ) x. B ) ) ) $.
    $( Lemma for ~ perfect .  (Contributed by Mario Carneiro, 7-Jun-2016.) $)
    perfectlem1 $p |- ( ph -> ( ( 2 ^ ( A + 1 ) ) e. NN /\
                        ( ( 2 ^ ( A + 1 ) ) - 1 ) e. NN /\
                ( B / ( ( 2 ^ ( A + 1 ) ) - 1 ) ) e. NN ) ) $=
      ( c2 c1 co cn wcel sylancr wbr a1i wb cdivides cmul wceq cz cexp cmin cn0
      caddc cdiv 2nn nnnn0d peano2nn0 syl nnexpcl clt 2re peano2nnd 1lt2 expgt1
      syl3anc nnsub mpbid cgcd csgm nnzd peano2zm 1nn0 sgmnncl dvdsmul1 syl2anc
      cr 1nn cc 2cn expp1 nncnd mulcom sylancl eqtrd oveq1d mulassd ax-1cn 2prm
      wn cprime coprm wi 2z rpexp1i mpd sgmmul syl13anc oveq2d 1sgm2ppw 3eqtr3d
      pncan eqtr3d 3eqtrd breqtrrd gcdcom iddvdsexp wa nprmdvds1 ax-mp w3a 3jca
      1z dvdssub2 sylan mtbiri ex mt2d coprmdvds mp2and nndivdvds ) AHBIUDJZUAJ
      ZKLZXMIUBJZKLZCXOUEJKLZAHKLZXLUCLZXNUFABUCLZXSABDUGZBUHUIZHXLUJMZAIXMUKNZ
      XPAHVGLZXLKLZIHUKNZYDYEAULOABDUMZYGAUNOHXLUOUPAIKLXNYDXPPVHYCIXMUQMURZAXO
      CQNZXQAXOXMCRJZQNZXOXMUSJZISZYJAXOXOICUTJZRJZYKQAXOTLZYOTLXOYPQNAXMTLZYQA
      XMYCVAZXMVBUIZAYOAIUCLCKLZYOKLVCEICVDMVAXOYOVEVFAYKHHBUAJZRJZCRJHUUBCRJZR
      JZYPAXMUUCCRAXMUUBHRJZUUCAHVILZXTXMUUFSVJYAHBVKMAUUBVILUUGUUFUUCSAUUBAXRX
      TUUBKLZUFYAHBUJMZVLZVJUUBHVMVNVOVPAHUUBCUUGAVJOUUJACEVLVQAIUUDUTJZIUUBUTJ
      ZYORJZUUEYPAIVILZUUHUUAUUBCUSJISZUUKUUMSUUNAVROUUIEAHCUSJISZUUOAHCQNVTZUU
      PFAHWALZCTLZUUQUUPPVSACEVAZHCWBMURAHTLZUUSXTUUPUUOWCUVAAWDOZUUTYAHCBWEUPW
      FIUUBCWGWHGAUULXOYORAIHXLIUBJZUAJZUTJZUULXOAUVDUUBIUTAUVCBHUAABVILUUNUVCB
      SABDVLVRBIWLVNWIWIAYFUVEXOSYHXLWJUIWMVPWKWNWOAYMXMXOUSJZIAYQYRYMUVFSYTYSX
      OXMWPVFAHXOUSJISZUVFISZAHXOQNZVTZUVGAUVIHXMQNZAUVAYFUVKWDYHHXLWQMAUVIUVKV
      TAUVIWRUVKHIQNZUURUVLVTVSHWSWTAUVAYRITLZXAUVIUVKUVLPAUVAYRUVMUVBYSUVMAXCO
      XBHXMIXDXEXFXGXHAUURYQUVJUVGPVSYTHXOWBMURAUVAYQXSUVGUVHWCUVBYTYBHXOXLWEUP
      WFVOAYQYRUUSYLYNWRYJWCYTYSUUTXOXMCXIUPXJAUUAXPYJXQPEYICXOXKVFURXB $.

    $( Lemma for ~ perfect .  (Contributed by Mario Carneiro, 17-May-2016.) $)
    perfectlem2 $p |- ( ph ->
      ( B e. Prime /\ B = ( ( 2 ^ ( A + 1 ) ) - 1 ) ) ) $=
      ( vk wcel c2 c1 caddc co wceq cdivides wbr cn clt a1i cmul vn cprime cexp
      vx cmin cuz cfv cv wo wi wral cdiv cr 1re perfectlem1 simp3d nnred nnge1d
      cc 2cn exp1 ax-mp df-2 eqtri cz 2re peano2nnd nnzd 1lt2 crp nnrpd ltaddrp
      1z sylancr ax-1cn nncnd addcom breqtrd mpbid cc0 syl syl3anc sylanbrc cle
      wb wa wn ctp csu cfn wss syl2anc ad2antrr sselda nnnn0d nn0ge0d csn df-tp
      cun unssd syl5eqss w3o eltpi breq1 syl5ibrcom 3jaod syl5 ssrabdv fsumless
      imp cin c0 simpr disjsn sylibr tpfi fsumsplit id sumsn oveq12d wne mulcld
      gtned oveq2d oveq1d divcan3d 3eqtr3d csgm cn0 sylancl cgcd 3brtr3d ltnled
      eqtrd mpd necomd 1nn eqeq1 adantr jca syl32anc syl5eqbrr simp1d ltaddsubd
      ltexp2a peano2rem expgt1 posdif nngt0d ltdiv2OLD syl33anc lelttrd eluz2b2
      0lt1 div1d cpr crab fzfid sgmss ssfi ssrab2 prssi simplrl simp2d dvdsmul2
      cfz snssd nnne0d divcan2d iddvds simplrr incom disjsn2 syl5eqr df-pr prfi
      divdird subdird mulid2d pncan3d divassd 3eqtr4d ccxp expp1 nnexpcl mulcom
      2nn mulassd coprm 2z rpexp1i sgmmul syl13anc pncan 1sgm2ppw eqtr3d 3eqtrd
      2prm 1nn0 sgmnncl sgmval sseldi cxp1d sumeq2dv remulcld ltaddrpd readdcld
      3eqtrrd condan elpri expr ralrimiva 1dvds orbi12d imbi12d rspcv syl3c ord
      necon1ad eqeq2d orbi1d imbi2d mpbird isprm2 ltp1d peano2re snssi diveq1ad
      ralbidv mp1i necon3bid biimpar neanior sylib 1ex elpr sylnibr ex necon1bd
      ) ACUBIZCJBKLMZUCMZKUEMZNZACJUFUGIZUAUHZCOPZVUFKNZVUFCNZUIZUJZUAQUKZUYTAC
      QIZKCRPVUEEAKCVUCULMZCKUMIZAUNSZAVUNAVUBQIZVUCQIZVUNQIZABCDEFGUOZUPZUQZAC
      EUQZAVUNVVAURAVUNCKULMZCRAKVUCRPZVUNVVDRPZAKKLMZVUBRPVVEAVVGJKUCMZVUBRVVH
      JVVGJUSIZVVHJNUTJVAVBVCVDAJUMIZKVEIZVUAVEIKJRPZKVUARPVVHVUBRPVVJAVFSZVVKA
      VMSAVUAABDVGZVHVVLAVISZAKKBLMZVUARAVUOBVJIKVVPRPUNABDVKKBVLVNAKUSIZBUSIZV
      VPVUANVOABDVPZKBVQVNVRJKVUAUUEUUAUUBAKKVUBVUPVUPAVUBAVUQVURVUSVUTUUCZUQZU
      UDVSAVUOVUCUMIZCUMIVTKRPZVTVUCRPZVTCRPVVEVVFWEVUPAVUBUMIZVWBVWAVUBUUFWAVV
      CVWCAUUNSAKVUBRPZVWDAVVJVUAQIZVVLVWFVVMVVNVVOJVUAUUGWBAVUOVWEVWFVWDWEUNVW
      AKVUBUUHVNVSACEUUIKVUCCUUJUUKVSACACEVPZUUOVRZUULZCUUMWCAVULVUGVUFVUNNZVUI
      UIZUJZUAQUKZAVWMUAQAVUFQIZVUGVWLAVWOVUGWFZWFZVUFVUNCUUPZIZVWLVWQVWSVUBVUN
      TMZVUFLMZVWTWDPZVWQVWSWGZWFZVUNCVUFWHZHUHZHWIZUDUHZCOPZUDQUUQZVXFHWIZVXAV
      WTWDVXDVXJVXFVXEHAVXJWJIZVWPVXCAKCUVFMZWJIVXJVXMWKZVXLAKCUURAVUMVXNECUDUU
      SWAVXMVXJUUTWLZWMVXDVXFVXJIZWFZVXFVXDVXJQVXFVXJQWKVXDVXIUDQUVAZSWNZUQVXQV
      XFVXQVXFVXSWOWPVXDVXIUDQVXEVXDVXEVWRVUFWQZWSZQVUNCVUFWRZVXDVWRVXTQAVWRQWK
      ZVWPVXCAVUSVUMVYCVVAEVUNCQUVBWLZWMVXDVUFQAVWOVUGVXCUVCZUVGWTXAZVXDVXHVXEI
      ZVXIVYGVXHVUNNZVXHCNZVXHVUFNZXBVXDVXIVXHVUNCVUFXCVXDVYHVXIVYIVYJAVYHVXIUJ
      VWPVXCAVXIVYHVUNCOPAVUNVUCVUNTMZCOAVUCVEIVUNVEIVUNVYKOPAVUCAVUQVURVUSVUTU
      VDZVHAVUNVVAVHVUCVUNUVEWLACVUCVWHAVUCVYLVPZAVUCVYLUVHZUVIVRVXHVUNCOXDXEZW
      MAVYIVXIUJVWPVXCAVXIVYICCOPZACVEIZVYPACEVHZCUVJWAVXHCCOXDXEZWMVXDVXIVYJVU
      GAVWOVUGVXCUVKVXHVUFCOXDXEXFXGXJXHXIVXDVXGVWRVXFHWIZVXTVXFHWIZLMVXAVXDVWR
      VXTVXFVXEHVXDVXCVWRVXTXKXLNVWQVXCXMVWRVUFXNXOVXEVYANVXDVYBSVXEWJIVXDVUNCV
      UFXPSVXDVXFVXEIWFVXFVXDVXEQVXFVYFWNVPXQVXDVYTVWTWUAVUFLAVYTVWTNVWPVXCAVUN
      WQZVXFHWIZCWQZVXFHWIZLMVUNCLMZVYTVWTAWUCVUNWUECLAVUSVUNUSIWUCVUNNVVAAVUNV
      VAVPVXFVUNHVUNQVXFVUNNXRXSWLAVUMCUSIWUECNEVWHVXFCHCQVXFCNXRXSWLXTAWUBWUDV
      XFVWRHAWUBWUDXKWUDWUBXKZXLWUDWUBUVLACVUNYAWUGXLNAVUNCVVBVWIYCCVUNUVMWAUVN
      VWRWUBWUDWSNAVUNCUVOSVWRWJIAVUNCUVPSAVXFVWRIWFVXFAVWRQVXFVYDWNVPXQACVUCCT
      MZLMZVUCULMZVUNWUHVUCULMZLMVWTWUFACWUHVUCVWHAVUCCVYMVWHYBVYMVYNUVQAWUJVUB
      CTMZVUCULMZVWTAWUIWULVUCULAWUICWULCUEMZLMWULAWUHWUNCLAWUHWULKCTMZUEMWUNAV
      UBKCAVUBVVTVPZVVQAVOSZVWHUVRAWUOCWULUEACVWHUVSYDYNYDACWULVWHAVUBCWUPVWHYB
      UVTYNYEAVUBCVUCWUPVWHVYMVYNUWAZYNAWUKCVUNLACVUCVWHVYMVYNYFYDYGUWBZWMVXDVU
      FUSIZWUTWUAVUFNVXDVUFVYEVPZWVAVXFVUFHVUFUSVXFVUFNXRXSWLXTYNAVXKVWTNZVWPVX
      CAVWTKCYHMZVXJVXFKUWCMZHWIZVXKAWUMVUCWVCTMZVUCULMVWTWVCAWULWVFVUCULAWULJJ
      BUCMZTMZCTMJWVGCTMZTMZWVFAVUBWVHCTAVUBWVGJTMZWVHAVVIBYIIZVUBWVKNUTABDWOZJ
      BUWDVNAWVGUSIVVIWVKWVHNAWVGAJQIWVLWVGQIZUWGWVMJBUWEVNZVPZUTWVGJUWFYJYNYEA
      JWVGCVVIAUTSWVPVWHUWHAKWVIYHMZKWVGYHMZWVCTMZWVJWVFAVVQWVNVUMWVGCYKMKNZWVQ
      WVSNWUQWVOEAJCYKMKNZWVTAJCOPWGZWWAFAJUBIVYQWWBWWAWEUWRVYRJCUWIVNVSAJVEIZV
      YQWVLWWAWVTUJWWCAUWJSVYRWVMJCBUWKWBYOKWVGCUWLUWMGAWVRVUCWVCTAKJVUAKUEMZUC
      MZYHMZWVRVUCAWWEWVGKYHAWWDBJUCAVVRVVQWWDBNVVSVOBKUWNYJYDYDAVWGWWFVUCNVVNV
      UAUWOWAUWPYEYGUWQYEWURAWVCVUCAWVCAKYIIVUMWVCQIUWSEKCUWTVNVPVYMVYNYFYGAVVQ
      VUMWVCWVENVOEKCHUDUXAVNAVXJWVDVXFHAVXPWFZVXFWWGVXFWWGVXJQVXFVXRAVXPXMUXBZ
      VPUXCUXDUXHZWMYLVXDVWTVXARPVXBWGVXDVWTVUFAVWTUMIZVWPVXCAVUBVUNVWAVVBUXEZW
      MZVXDVUFVYEVKUXFVXDVWTVXAWWLVXDVWTVUFWWLVXDVUFVYEUQUXGYMVSUXIVUFVUNCUXJWA
      UXKUXLZAVUKVWMUAQAVUJVWLVUGAVUHVWKVUIAKVUNVUFAKCYAZKVUNNZACKAKCVUPVWJYCYP
      ZAWWOKCAWWOKCNZAKQIZVWNKCOPZWWOWWQUIZWWRAYQSWWMAVYQWWSVYRCUXMWAZVWMWWSWWT
      UJUAKQVUHVUGWWSVWLWWTVUFKCOXDVUHVWKWWOVUIWWQVUFKVUNYRVUFKCYRUXNUXOUXPUXQU
      XRUXSYOUXTUYAUYBUYIUYCUACUYDWCAVWTKLMZVWTWDPZWGZVUDAVWTWXBRPWXDAVWTWWKUYE
      AVWTWXBWWKAWWJWXBUMIWWKVWTUYFWAYMVSAWXCCVUCACVUCYAZWXCAWXEWFZVUNCKWHZVXFH
      WIZVXKWXBVWTWDAWXHVXKWDPWXEAVXJVXFWXGHVXOWWGVXFWWHUQWWGVXFWWGVXFWWHWOWPAV
      XIUDQWXGAWXGVWRKWQZWSZQVUNCKWRZAVWRWXIQVYDWWRWXIQWKAYQKQUYGUYJWTXAZAVXHWX
      GIZVXIWXMVYHVYIVXHKNZXBAVXIVXHVUNCKXCAVYHVXIVYIWXNVYOVYSAVXIWXNWWSWXAVXHK
      COXDXEXFXGXJXHXIYSWXFWXHVYTWXIVXFHWIZLMZWXBWXFVWRWXIVXFWXGHWXFKVWRIZWGVWR
      WXIXKXLNWXFWWTWXQWXFKVUNYAZWWNWFWWTWGWXFWXRWWNWXFVUNKAVUNKYAWXEAVUNKCVUCA
      CVUCVWHVYMVYNUYHUYKUYLYPAWWNWXEWWPYSYTKVUNKCUYMUYNKVUNCUYOUYPUYQVWRKXNXOW
      XGWXJNWXFWXKSWXGWJIWXFVUNCKXPSWXFVXFWXGIWFVXFWXFWXGQVXFAWXGQWKWXEWXLYSWNV
      PXQAWXPWXBNWXEAVYTVWTWXOKLWUSAVVQVVQWXOKNWUQVOVXFKHKUSVXFKNXRXSYJXTYSYNAW
      VBWXEWWIYSYLUYRUYSYOYT $.
  $}

  ${
    $d p N $.
    $( The Euclid-Euler theorem, or Perfect Number theorem.  A positive even
       integer ` N ` is a perfect number (that is, its divisor sum is ` 2 N ` )
       if and only if it is of the form ` 2 ^ ( p - 1 ) x. ( 2 ^ p - 1 ) ` ,
       where ` 2 ^ p - 1 ` is prime (a Mersenne prime).  (It follows from this
       that ` p ` is also prime.)  (Contributed by Mario Carneiro,
       17-May-2016.) $)
    perfect $p |- ( ( N e. NN /\ 2 || N ) -> ( ( 1 sigma N ) = ( 2 x. N ) <->
      E. p e. ZZ ( ( ( 2 ^ p ) - 1 ) e. Prime /\
        N = ( ( 2 ^ ( p - 1 ) ) x. ( ( 2 ^ p ) - 1 ) ) ) ) ) $=
      ( cn wcel c2 cdivides wa c1 csgm co cmul wceq cexp cmin cprime cz sylancr
      cc oveq2d 2cn wbr cv wrex cpc caddc simplr 2prm simpll pcelnn mpbird nnzd
      wb peano2zd cdiv pcdvds cn0 2nn nnnn0d nnexpcl nndivdvds syl2anc mpbid wn
      pcndvds2 simpr ad2antrr nnne0d divcan2d 3eqtr4d perfectlem2 simprd simpld
      nncn nncnd ax-1cn pncan sylancl eqcomd oveq12d eqtr3d oveq2 oveq1d eleq1d
      eqeltrrd oveq1 eqeq2d anbi12d rspcev syl12anc perfect1 mersenne prmnn syl
      ex expm1t nnm1nn0 expcl mulcom eqtrd a1i adantl mulassd 3eqtrd syl5ibrcom
      eqeq12d impr rexlimiva impbid1 ) ACDZEAFUAZGZHAIJZEAKJZLZEBUBZMJZHNJZODZA
      EXOHNJZMJZXQKJZLZGZBPUCZXKXNYDXKXNGZEAUDJZHUEJZPDEYGMJZHNJZODZAEYGHNJZMJZ
      YIKJZLZYDYEYFYEYFYEYFCDZXJXIXJXNUFYEEODZXIYOXJULUGXIXJXNUHZEAUIQUJZUKUMYE
      AEYFMJZUNJZYIOYEYTODZYTYILZYEYFYTYRYEYSAFUAZYTCDZYEYPXIUUCUGYQEAUOQYEXIYS
      CDZUUCUUDULYQYEECDYFUPDUUEUQYEYFYRUREYFUSQZAYSUTVAVBYEYPXIEYTFUAVCUGYQEAV
      DQYEXLXMHYSYTKJZIJEUUGKJXKXNVEYEUUGAHIYEAYSXIARDXJXNAVMVFYEYSUUFVNYEYSUUF
      VGVHZSYEUUGAEKUUHSVIVJZVKZYEUUAUUBUUIVLWDYEUUGAYMUUHYEYSYLYTYIKYEYFYKEMYE
      YKYFYEYFRDHRDYKYFLYEYFYRVNVOYFHVPVQVRSUUJVSVTYCYJYNGBYGPXOYGLZXRYJYBYNUUK
      XQYIOUUKXPYHHNXOYGEMWAWBZWCUUKYAYMAUUKXTYLXQYIKUUKXSYKEMXOYGHNWESUULVSWFW
      GWHWIWNYCXNBPXOPDZXRYBXNUUMXRGZXNYBHYAIJZEYAKJZLUUNUUOXPXQKJEXTKJZXQKJUUP
      XOWJUUNXPUUQXQKUUNXPXTEKJZUUQUUNERDZXOCDZXPUURLTUUNXOODUUTXOWKXOWLWMZEXOW
      OQUUNXTRDZUUSUURUUQLUUNUUSXSUPDZUVBTUUNUUTUVCUVAXOWPWMEXSWQQZTXTEWRVQWSWB
      UUNEXTXQUUSUUNTWTUVDUUNXQXRXQCDUUMXQWLXAVNXBXCYBXLUUOXMUUPAYAHIWAAYAEKWAX
      EXDXFXGXH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Characters of Z/nZ
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c DChr $.

  $( Extend class notation with the group of Dirichlet characters. $)
  cdchr $a class DChr $.

  ${
    $d k A $.  $d k x y z B $.  $d b n z D $.  $d b n x z N $.  $d k x y z U $.
    $d k C $.  $d k E $.  $d b k n x y z ph $.  $d x y z X $.  $d k x y z Z $.
    $d k Y $.
    $( The group of Dirichlet characters ` mod n ` is the set of monoid
       homomorphisms from ` ZZ / n ZZ ` to the multiplicative monoid of the
       complexes, equipped with the group operation of pointwise
       multiplication.  (Contributed by Mario Carneiro, 18-Apr-2016.) $)
    df-dchr $a |- DChr = ( n e. NN |-> [_ ( Z/nZ ` n ) / z ]_
      [_ { x e. ( ( mulGrp ` z ) MndHom ( mulGrp ` CCfld ) ) |
          ( ( ( Base ` z ) \ ( Unit ` z ) ) X. { 0 } ) C_ x } / b ]_
      { <. ( Base ` ndx ) , b >. ,
        <. ( +g ` ndx ) , ( oF x. |` ( b X. b ) ) >. } ) $.

    dchrval.g $e |- G = ( DChr ` N ) $.
    dchrval.z $e |- Z = ( Z/nZ ` N ) $.
    dchrval.b $e |- B = ( Base ` Z ) $.
    dchrval.u $e |- U = ( Unit ` Z ) $.
    dchrval.n $e |- ( ph -> N e. NN ) $.
    ${
      dchrval.d $e |- ( ph -> D = { x e. ( ( mulGrp ` Z )
        MndHom ( mulGrp ` CCfld ) ) | ( ( B \ U ) X. { 0 } ) C_ x } ) $.
      $( Value of the group of Dirichlet characters.  (Contributed by Mario
         Carneiro, 18-Apr-2016.) $)
      dchrval $p |- ( ph -> G = { <. ( Base ` ndx ) , D >. ,
          <. ( +g ` ndx ) , ( oF x. |` ( D X. D ) ) >. } ) $=
        ( vn vz vb cfv cvv wceq cnx cbs cop cplusg cmul cof cxp cres cpr cv czn
        cdchr cui cdif cc0 csn wss cmgp ccnfld cmhm co crab csb cn cmpt df-dchr
        a1i wa wcel fvex ovex rabex ad2antrr simpr fveq2d eqeq2d biimpar oveq1d
        syl6reqr syl6eqr difeq12d xpeq1d sseq1d rabeqbidv eqtr4d opeq2d xpeq12d
        reseq2d preq12d csbied prex fvmptd syl5eq ) AFGULRUAUBRZDUCZUAUDRZUEUFZ
        DDUGZUHZUCZUIZIAOGPOUJZUKRZQPUJZUBRZXDUMRZUNZUOUPZUGZBUJZUQZBXDURRZUSUR
        RZUTVAZVBZWNQUJZUCZWPWQXPXPUGZUHZUCZUIZVCZVCZXAVDULSULOVDYCVETABPOQVFVG
        AXBGTZVHZPXCYBXASXCSVIYEXBUKVJVGYEXDXCTZVHZQXOYAXASXOSVIYGXKBXNXLXMUTVK
        VLVGYGXPXOTZVHZXQWOXTWTYIXPDWNYGXPDTYHYGDXOXPYGDCEUNZXHUGZXJUQZBHURRZXM
        UTVAZVBZXOADYOTYDYFNVMYGXKYLBXNYNYGXLYMXMUTYGXDHURYEXDHTYFYEHXCXDYEXCGU
        KRHYEXBGUKAYDVNVOJVSVPVQZVOVRYGXIYKXJYGXGYJXHYGXECXFEYGXEHUBRCYGXDHUBYP
        VOKVTYGXFHUMREYGXDHUMYPVOLVTWAWBWCWDWEVPVQZWFYIXSWSWPYIXRWRWQYIXPDXPDYQ
        YQWGWHWFWIWJWJMXASVIAWOWTWKVGWLWM $.
    $}

    dchrbas.b $e |- D = ( Base ` G ) $.
    $( Base set of the group of Dirichlet characters.  (Contributed by Mario
       Carneiro, 18-Apr-2016.) $)
    dchrbas $p |- ( ph -> D = { x e. ( ( mulGrp ` Z )
        MndHom ( mulGrp ` CCfld ) ) | ( ( B \ U ) X. { 0 } ) C_ x } ) $=
      ( cbs cfv cnx cxp cmgp cmhm cdif cc0 csn cv wss ccnfld co crab cop cplusg
      cmul cof cres cpr eqidd dchrval fveq2d wcel wceq ovex rabex grpbase ax-mp
      cvv eqid 3eqtr4g ) AFOPQOPCEUAUBUCRBUDUEZBHSPZUFSPZTUGZUHZUIQUJPUKULVKVKR
      UMZUIUNZOPZDVKAFVMOABCVKEFGHIJKLMAVKUOUPUQNVKVDURVKVNUSVGBVJVHVITUTVAVKVL
      VMVDVMVEVBVCVF $.

    $( A Dirichlet character is a monoid homomorphism from the multiplicative
       monoid on ` Z/nZ ` to the multiplicative monoid of ` CC ` , which is
       zero off the group of units of ` Z/nZ ` .  (Contributed by Mario
       Carneiro, 18-Apr-2016.) $)
    dchrelbas $p |- ( ph -> ( X e. D <-> ( X e. ( ( mulGrp ` Z )
        MndHom ( mulGrp ` CCfld ) ) /\ ( ( B \ U ) X. { 0 } ) C_ X ) ) ) $=
      ( vx wcel cdif wss cmgp cfv cc0 csn cxp cv ccnfld cmhm co crab wa dchrbas
      eleq2d sseq2 elrab syl6bb ) AGCPGBDQUAUBUCZOUDZRZOHSTUESTUFUGZUHZPGURPUOG
      RZUIACUSGAOBCDEFHIJKLMNUJUKUQUTOGURUPGUOULUMUN $.

    $( A Dirichlet character is a monoid homomorphism from the multiplicative
       monoid on ` Z/nZ ` to the multiplicative monoid of ` CC ` , which is
       zero off the group of units of ` Z/nZ ` .  (Contributed by Mario
       Carneiro, 18-Apr-2016.) $)
    dchrelbas2 $p |- ( ph -> ( X e. D <-> ( X e. ( ( mulGrp ` Z ) MndHom
      ( mulGrp ` CCfld ) ) /\ A. x e. B ( ( X ` x ) =/= 0 -> x e. U ) ) ) ) $=
      ( wcel cfv cc0 wi cc cmgp ccnfld cmhm co cdif csn cxp wss wa cv dchrelbas
      wne wral cres wceq wfun wf eqid mgpbas cnfldbas mhmf adantl ffun funssres
      cdm syl sylan simpr resss syl6eqssr impbida 0cn fconst6g mp1i fdm reseq2d
      eqeq1d bitrd wfn wb difss fssres sylancl ffn eqfnfv syl2anc c0ex fvconst2
      fvres eqeq12d ralbiia wn eldif imbi1i impexp bitr4i imbi2i 3bitri ralbii2
      con1b df-ne bitri syl6bb pm5.32da ) AHDPHIUAQZUBUAQZUCUDPZCEUEZRUFUGZHUHZ
      UIXGBUJZHQZRULZXKEPZSZBCUMZUIACDEFGHIJKLMNOUKAXGXJXPAXGUIZXJHXHUNZXIUOZXP
      XQXJHXIVEZUNZXIUOZXSXQXJYBXQHUPZXJYBXQCTHUQZYCXGYDACTXEXFHCIXEXEURLUSTUBX
      FXFURUTUSVAVBZCTHVCVFHXIVDVGXQYBUIXIYAHXQYBVHHXTVIVJVKXQYAXRXIXQXTXHHXQXH
      TXIUQZXTXHUORTPYFXQVLXHRTVMVNZXHTXIVOVFVPVQVRXQXSXKXRQZXKXIQZUOZBXHUMZXPX
      QXRXHVSZXIXHVSZXSYKVTXQXHTXRUQZYLXQYDXHCUHYNYECEWACTXHHWBWCXHTXRWDVFXQYFY
      MYGXHTXIWDVFBXHXRXIWEWFYKXLRUOZBXHUMXPYJYOBXHXKXHPZYHXLYIRXKXHHWIXHRXKWGW
      HWJWKYOXOBXHCYPYOSXKCPZXNWLZUIZYOSYQYRYOSZSYQXOSYPYSYOXKCEWMWNYQYRYOWOYTX
      OYQYTYOWLZXNSXOXNYOWTXMUUAXNXLRXAWNWPWQWRWSXBXCVRXDVR $.

    $( A Dirichlet character is a monoid homomorphism from the multiplicative
       monoid on ` Z/nZ ` to the multiplicative monoid of ` CC ` , which is
       zero off the group of units of ` Z/nZ ` .  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    dchrelbas3 $p |- ( ph -> ( X e. D <-> ( X : B --> CC /\ ( A. x e. U
        A. y e. U ( X ` ( x ( .r ` Z ) y ) ) = ( ( X ` x ) x. ( X ` y ) ) /\
        ( X ` ( 1r ` Z ) ) = 1 /\
        A. x e. B ( ( X ` x ) =/= 0 -> x e. U ) ) ) ) ) $=
      ( wcel cfv cc0 wa vz cmgp ccnfld cmhm co cv wi wral cc wf cmulr cmul wceq
      wne cur c1 w3a dchrelbas2 wb fveq2 neeq1d eleq1 imbi12d cbvralv cmnd ccrg
      crg cn0 nnnn0d zncrng syl crngrng eqid rngmgp cnrng ax-mp mgpbas cnfldbas
      mgpplusg cnfldmul rngidval cnfld1 ismhm baib sylancl adantr wal adantl wn
      biimt ad3antrrr simprl simprr rngcl syl3anc simpllr rspcv sylc unitmulclb
      sylibd necon1bd wo anim12d con3and neanior con2bii sylibr simplr ffvelrnd
      imp mul0ord mpbird eqtr4d 2thd pm2.61dan pm5.74da unitcl anim12i pm4.71ri
      imbi1i impexp bitri syl6bbr 2albidv r2al 3bitr4g adantrr pm5.32da 3anan32
      a1d an31 bitrd sylan2br ancom df-3an anbi2i an13 ) AIEQIJUBRZUCUBRZUDUEQZ
      BUFZIRZSUNZUUAFQZUGZBDUHZTZDUIIUJZUUACUFZJUKRZUEZIRZUUBUUIIRZULUEZUMZCFUH
      BFUHZJUORZIRUPUMZUUFUQZTZABDEFGHIJKLMNOPURAUUFYTTUUFUUPUURTZUUHTZTZUUGUUT
      AUUFYTUVBUUFAUAUFZIRZSUNZUVDFQZUGZUADUHZYTUVBUSUVHUUEUABDUVDUUAUMZUVFUUCU
      VGUUDUVJUVEUUBSUVDUUAIUTVAUVDUUAFVBVCZVDAUVITZYTUUHUUOCDUHBDUHZUURUQZUVBA
      YTUVNUSZUVIAYRVEQZYSVEQZUVOAJVGQZUVPAJVFQZUVRAHVHQUVSAHOVIHJLVJVKZJVLVKZJ
      YRYRVMZVNVKUCVGQUVQVOUCYSYSVMZVNVPYTUVPUVQTUVNBCDUIUUJULYRYSIUPUUQDJYRUWB
      MVQUIUCYSUWCVRVQJUUJYRUWBUUJVMZVSUCULYSUWCVTVSJUUQYRUWBUUQVMWAUCUPYSUWCWB
      WAWCWDWEWFUVLUUHUURTZUVMTUWEUUPTUVNUVBUVLUWEUVMUUPUVLUUHUVMUUPUSUURUVLUUH
      TZUUADQZUUIDQZTZUUOUGZCWGBWGUUDUUIFQZTZUUOUGZCWGBWGUVMUUPUWFUWJUWMBCUWFUW
      JUWIUWMUGZUWMUWFUWIUUOUWMUWFUWITZUWLUUOUWMUSZUWLUWPUWOUWLUUOWJWHUWOUWLWIZ
      TZUUOUWMUWRUULSUUNUWOUWQUULSUMUWOUWLUULSUWOUULSUNZUUKFQZUWLUWOUUKDQZUVIUW
      SUWTUGZUWOUVRUWGUWHUXAAUVRUVIUUHUWIUWAWKUWFUWGUWHWLZUWFUWGUWHWMZDJUUJUUAU
      UIMUWDWNWOAUVIUUHUWIWPZUVHUXBUAUUKDUVDUUKUMZUVFUWSUVGUWTUXFUVEUULSUVDUUKI
      UTVAUVDUUKFVBVCWQWRUWOUVSUWGUWHUWTUWLUSAUVSUVIUUHUWIUVTWKUXCUXDDJUUJFUUAU
      UINUWDMWSWOWTXAXJUWRUUNSUMZUUBSUMUUMSUMXBZUWRUUCUUMSUNZTZWIUXHUWOUXJUWLUW
      OUUCUUDUXIUWKUWOUWGUVIUUEUXCUXEUVHUUEUAUUADUVKWQWRUWOUWHUVIUXIUWKUGZUXDUX
      EUVHUXKUAUUIDUVDUUIUMZUVFUXIUVGUWKUXLUVEUUMSUVDUUIIUTVAUVDUUIFVBVCWQWRXCX
      DUXJUXHUUBSUUMSXEXFXGUWOUXGUXHUSUWQUWOUUBUUMUWODUIUUAIUVLUUHUWIXHZUXCXIUW
      ODUIUUIIUXMUXDXIXKWFXLXMZUWRUUOUWLUXNYJXNXOXPUWMUWIUWLTZUUOUGUWNUWLUXOUUO
      UWLUWIUUDUWGUWKUWHDJFUUAMNXQDJFUUIMNXQXRXSXTUWIUWLUUOYAYBYCYDUUOBCDDYEUUO
      BCFFYEYFYGYHUUHUVMUURYIUUPUURUUHYKYFYLYMYHYTUUFYNUUTUUHUVAUUFTZTUVCUUSUXP
      UUHUUPUURUUFYOYPUUHUVAUUFYQYBYFYL $.

    dchrelbasd.1 $e |- ( k = x -> X = A ) $.
    dchrelbasd.2 $e |- ( k = y -> X = C ) $.
    dchrelbasd.3 $e |- ( k = ( x ( .r ` Z ) y ) -> X = E ) $.
    dchrelbasd.4 $e |- ( k = ( 1r ` Z ) -> X = Y ) $.
    dchrelbasd.5 $e |- ( ( ph /\ k e. U ) -> X e. CC ) $.
    dchrelbasd.6 $e |- ( ( ph /\ ( x e. U /\ y e. U ) ) -> E = ( A x. C ) ) $.
    dchrelbasd.7 $e |- ( ph -> Y = 1 ) $.
    $( A Dirichlet character is a monoid homomorphism from the multiplicative
       monoid on ` Z/nZ ` to the multiplicative monoid of ` CC ` , which is
       zero off the group of units of ` Z/nZ ` .  (Contributed by Mario
       Carneiro, 28-Apr-2016.) $)
    dchrelbasd $p |- ( ph -> ( k e. B |-> if ( k e. U , X , 0 ) ) e. D ) $=
      ( cv wcel cc0 cif cmpt cc wf cmulr cfv co cmul wceq wral cur c1 wne wi wa
      w3a adantlr wn 0cn a1i ifclda eqid fmptd crg cn0 ccrg nnnn0d crngrng 3syl
      zncrng unitmulcl 3expb sylan iftrue syl eqtrd unitss sseldi adantr eleq1d
      ralrimiva rspcv sylc eqeltrd eleq1 eqidd ifbieq12d fvmptg simprl ad2antrl
      syl2anc simprr ad2antll oveq12d 3eqtr4d 1unit ax-1cn syl6eqel simpr mpan9
      ralrimivva neeq1d iffalse necon1ai syl6bi 3jca dchrelbas3 mpbir2and ) AIE
      IUIZHUJZMUKULZUMZGUJEUNYCUOBUIZCUIZOUPUQZURZYCUQZYDYCUQZYEYCUQZUSURZUTZCH
      VABHVAZOVBUQZYCUQZVCUTZYIUKVDZYDHUJZVEZBEVAZVGAIEYBUNYCAXTEUJZVFZYAMUKUNA
      YAMUNUJZUUAUFVHUKUNUJZUUBYAVIVFVJVKVLYCVMZVNAYMYPYTAYLBCHHAYRYEHUJZVFZVFZ
      YGHUJZJUKULZDFUSURZYHYKUUHUUJJUUKUUHUUIUUJJUTAOVOUJZUUGUUIALVPUJOVQUJUULA
      LTVRLOQWAOVSVTZUULYRUUFUUIOYFHYDYESYFVMWBWCWDZUUIJUKWEWFZUGWGUUHYGEUJUUJU
      NUJYHUUJUTUUHHEYGEOHRSWHZUUNWIUUHUUJJUNUUOUUHUUIUUCIHVAZJUNUJZUUNAUUQUUGA
      UUCIHUFWLZWJZUUCUURIYGHXTYGUTZMJUNUDWKWMWNWOIYGYBUUJEUNYCUVAYAUUIMUKJUKXT
      YGHWPUDUVAUKWQWRUUEWSXBUUHYIDYJFUSUUHYIYRDUKULZDUUHYDEUJZUVBUNUJZYIUVBUTZ
      UUHHEYDUUPAYRUUFWTZWIUUHUVBDUNYRUVBDUTAUUFYRDUKWEXAZUUHYRUUQDUNUJZUVFUUTU
      UCUVHIYDHXTYDUTZMDUNUBWKWMZWNWOIYDYBUVBEUNYCUVIYAYRMUKDUKXTYDHWPUBUVIUKWQ
      WRUUEWSZXBUVGWGUUHYJUUFFUKULZFUUHYEEUJUVLUNUJYJUVLUTUUHHEYEUUPAYRUUFXCZWI
      UUHUVLFUNUUFUVLFUTAYRUUFFUKWEXDZUUHUUFUUQFUNUJZUVMUUTUUCUVOIYEHXTYEUTZMFU
      NUCWKWMWNWOIYEYBUVLEUNYCUVPYAUUFMUKFUKXTYEHWPUCUVPUKWQWRUUEWSXBUVNWGXEXFX
      LAYOYNHUJZNUKULZVCAYNEUJUVRUNUJYOUVRUTAHEYNUUPAUULUVQUUMOHYNSYNVMXGWFZWIA
      UVRVCUNAUVRNVCAUVQUVRNUTUVSUVQNUKWEWFUHWGZXHXIIYNYBUVREUNYCXTYNUTZYAUVQMU
      KNUKXTYNHWPUEUWAUKWQWRUUEWSXBUVTWGAYSBEAUVCVFZYQUVBUKVDYRUWBYIUVBUKUWBUVC
      UVDUVEAUVCXJUWBYRDUKUNAYRUVHUVCAUUQYRUVHUUSUVJXKVHUUDUWBYRVIVFVJVKVLUVKXB
      XMYRUVBUKYRDUKXNXOXPWLXQABCEGHKLYCOPQRSTUAXRXS $.
  $}

  ${
    $d b n x z $.
    dchrrcl.g $e |- G = ( DChr ` N ) $.
    dchrrcl.b $e |- D = ( Base ` G ) $.
    $( Reverse closure for a Dirichlet character.  (Contributed by Mario
       Carneiro, 12-May-2016.) $)
    dchrrcl $p |- ( X e. D -> N e. NN ) $=
      ( vn vz vb vx wcel cdchr cn cv cfv cbs cxp cmgp cnx c0 cdm czn cui ccnfld
      cdif cc0 csn wss cmhm co crab cop cplusg cmul cof cpr csb df-dchr dmmptss
      cres wceq n0i wn ndmfv syl5eq fveq2 base0 3eqtr4g syl nsyl2 sseldi ) DAKZ
      LUAZMCGMHGNUBOIHNZPOVNUCOUEUFUGQJNUHJVNROUDROUIUJUKSPOINZULSUMOUNUOVOVOQU
      TULUPUQUQLJHGIURUSVLATVAZCVMKZADVBVQVCZBTVAZVPVRBCLOTECLVDVEVSBPOTPOATBTP
      VFFVGVHVIVJVK $.
  $}

  ${
    $d n x y .1. $.  $d k x y B $.  $d n x y K $.  $d x y L $.  $d k n x y U $.
    $d x A $.  $d k x y N $.  $d k x y ph $.  $d k n x y X $.  $d k n x y Z $.
    $d x D $.  $d x y Y $.
    dchrmhm.g $e |- G = ( DChr ` N ) $.
    dchrmhm.z $e |- Z = ( Z/nZ ` N ) $.
    dchrmhm.b $e |- D = ( Base ` G ) $.
    $( A Dirichlet character is a monoid homomorphism.  (Contributed by Mario
       Carneiro, 19-Apr-2016.) $)
    dchrmhm $p |- D C_ ( ( mulGrp ` Z ) MndHom ( mulGrp ` CCfld ) ) $=
      ( vx cmgp cfv ccnfld cmhm co cv wcel cbs cui cdif cc0 eqid csn cxp wss wa
      dchrrcl dchrelbas ibi simpld ssriv ) HADIJKIJLMZHNZAOZUKUJOZDPJZDQJZRSUAU
      BUKUCZULUMUPUDULUNAUOBCUKDEFUNTUOTABCUKEGUEGUFUGUHUI $.

    ${
      dchrf.b $e |- B = ( Base ` Z ) $.
      dchrf.x $e |- ( ph -> X e. D ) $.
      $( A Dirichlet character is a function.  (Contributed by Mario Carneiro,
         18-Apr-2016.) $)
      dchrf $p |- ( ph -> X : B --> CC ) $=
        ( vx vy cv cfv co wceq wral wcel cc wf cmulr cmul cui cur c1 cc0 wne wi
        w3a wa eqid cn dchrrcl syl dchrelbas3 mpbid simpld ) ABUAFUBZMOZNOZGUCP
        QFPVAFPZVBFPUDQRNGUEPZSMVDSGUFPFPUGRVCUHUIVAVDTUJMBSUKZAFCTZUTVEULLAMNB
        CVDDEFGHIKVDUMAVFEUNTLCDEFHJUOUPJUQURUS $.
    $}

    ${
      dchrelbas4.l $e |- L = ( ZRHom ` Z ) $.
      $( A Dirichlet character is a monoid homomorphism from the multiplicative
         monoid on ` Z/nZ ` to the multiplicative monoid of ` CC ` , which is
         zero off the group of units of ` Z/nZ ` .  (Contributed by Mario
         Carneiro, 18-Apr-2016.) $)
      dchrelbas4 $p |- ( X e. D <-> ( N e. NN /\
          X e. ( ( mulGrp ` Z ) MndHom ( mulGrp ` CCfld ) ) /\
          A. x e. ZZ ( 1 < ( x gcd N ) -> ( X ` ( L ` x ) ) = 0 ) ) ) $=
        ( vy wcel cfv c1 cc0 wceq wi cz wa cn cmgp ccnfld cmhm co cgcd clt wral
        cv wbr w3a dchrrcl wne cui cbs eqid id dchrelbas2 cn0 wfo nnnn0 znzrhfo
        wb adantr fveq2 neeq1d eleq1 imbi12d cbvfo wn df-ne a1i znunit sylan cr
        3syl 1re simpr simpll nnzd nnne0 necon3ai gcdn0cl syl21anc nnred nnge1d
        leltned necon2bbid bitrd con34b syl6bbr ralbidva bitr3d pm5.32da 3anass
        biadan2 bitr4i ) FBMZEUAMZFGUBNUCUBNUDUEMZOAUIZEUFUEZUGUJZXADNZFNZPQZRZ
        ASUHZTZTWSWTXHUKWRWSXIBCEFHJULWSWRWTLUIZFNZPUMZXJGUNNZMZRZLGUONZUHZTXIW
        SLXPBXMCEFGHIXPUPZXMUPZWSUQJURWSWTXQXHWSWTTZXEPUMZXDXMMZRZASUHZXQXHXTEU
        SMZSXPDUTYDXQVCWSYEWTEVAVDZXPDEGIXRKVBYCXOALSXPDXDXJQZYAXLYBXNYGXEXKPXD
        XJFVEVFXDXJXMVGVHVIVPXTYCXGASXTXASMZTZYCXFVJZXCVJZRXGYIYAYJYBYKYAYJVCYI
        XEPVKVLYIYBXBOQZYKXTYEYHYBYLVCYFXAXMDEGIXSKVMVNYIXCXBOYIOXBOVOMYIVQVLYI
        XBYIYHESMXAPQZEPQZTZVJZXBUAMXTYHVRYIEWSWTYHVSZVTYIWSEPUMYPYQEWAYOEPYMYN
        VRWBVPXAEWCWDZWEYIXBYRWFWGWHWIVHXCXFWJWKWLWMWNWIWPWSWTXHWOWQ $.

      dchrzrh1.x $e |- ( ph -> X e. D ) $.
      $( Value of a Dirichlet character at one.  (Contributed by Mario
         Carneiro, 4-May-2016.) $)
      dchrzrh1 $p |- ( ph -> ( X ` ( L ` 1 ) ) = 1 ) $=
        ( c1 cfv wcel wceq syl eqid cmgp ccnfld cur cn0 ccrg crg dchrrcl nnnn0d
        cn zncrng crngrng zrh1 4syl fveq2d cmhm co dchrmhm sseldi rngidval mhm0
        cnfld1 eqtrd ) AMDNZFNGUANZFNZMAVAVBFAEUBOGUCOGUDOVAVBPAEAFBOEUGOLBCEFH
        JUEQUFEGIUHGUIGVBDKVBRZUJUKULAFGSNZTSNZUMUNZOVCMPABVGFBCEGHIJUOLUPVEVFF
        MVBGVBVEVERVDUQTMVFVFRUSUQURQUT $.

      dchrzrh1.a $e |- ( ph -> A e. ZZ ) $.
      $( A Dirichlet character takes values in the complexes.  (Contributed by
         Mario Carneiro, 12-May-2016.) $)
      dchrzrhcl $p |- ( ph -> ( X ` ( L ` A ) ) e. CC ) $=
        ( cbs cfv cz wcel 3syl ffvelrnd cc eqid dchrf cn0 wf cn dchrrcl znzrhfo
        wfo nnnn0 fof ) AHOPZUABEPGAULCDFGHIJKULUBZMUCAQULBEAFUDRZQULEUIQULEUEA
        GCRFUFRUNMCDFGIKUGFUJSULEFHJUMLUHQULEUKSNTT $.

      dchrzrh1.c $e |- ( ph -> C e. ZZ ) $.
      $( A Dirichlet character is completely multiplicative.  (Contributed by
         Mario Carneiro, 4-May-2016.) $)
      dchrzrhmul $p |- ( ph -> ( X ` ( L ` ( A x. C ) ) ) =
        ( ( X ` ( L ` A ) ) x. ( X ` ( L ` C ) ) ) ) $=
        ( cmul cfv cz wcel cmulr ccnfld cress crh wceq crg ccrg cn0 dchrrcl syl
        co cn nnnn0d zncrng crngrng eqid zrhrhm wss cbs zsscn cnfldbas ressbas2
        ax-mp cvv zex cnfldmul ressmulr rhmmul syl3anc fveq2d cmgp cmhm dchrmhm
        cc sseldi wf rhmf ffvelrnd mgpbas mgpplusg mhmlin eqtrd ) ABCQUKFRZHRBF
        RZCFRZIUARZUKZHRZWDHRWEHRQUKZAWCWGHAFUBSUCUKZIUDUKTZBSTCSTWCWGUEAIUFTZW
        KAIUGTZWLAGUHTWMAGAHDTGULTNDEGHJLUIUJUMGIKUNUJIUOUJIFWJWJUPZMUQUJZOPBCW
        JIQWFFSSVNURSWJUSRUEUTSVNWJUBWNVAVBVCZSVDTQWJUARUEVESUBWJQVDWNVFVGVCWFU
        PZVHVIVJAHIVKRZUBVKRZVLUKZTWDIUSRZTWEXATWHWIUEADWTHDEGIJKLVMNVOASXABFAW
        KSXAFVPWOSXAWJIFWPXAUPZVQUJZOVRASXACFXCPVRXAWFQWRWSHWDWEXAIWRWRUPZXBVSI
        WFWRXDWQVTUBQWSWSUPVFVTWAVIWB $.
    $}

    ${
      dchrmul.t $e |- .x. = ( +g ` G ) $.
      ${
        dchrplusg.n $e |- ( ph -> N e. NN ) $.
        $( Group operation on the group of Dirichlet characters.  (Contributed
           by Mario Carneiro, 18-Apr-2016.) $)
        dchrplusg $p |- ( ph -> .x. = ( oF x. |` ( D X. D ) ) ) $=
          ( vx cplusg cfv cnx cbs cop cmul eqid cvv cof cxp cpr dchrbas dchrval
          cres fveq2d wcel wceq fvex eqeltri xpex ofexg grpplusg mp2b 3eqtr4g
          cui ) ADMNOPNBQOMNRUABBUBZUFZQUCZMNZCUSADUTMALFPNZBFUQNZDEFGHVBSZVCSZ
          KALVBBVCDEFGHVDVEKIUDUEUGJURTUHUSTUHUSVAUIBBBDPNTIDPUJUKZVFULURRTUMBU
          SUTTUTSUNUOUP $.
      $}

      dchrmul.x $e |- ( ph -> X e. D ) $.
      dchrmul.y $e |- ( ph -> Y e. D ) $.
      $( Group operation on the group of Dirichlet characters.  (Contributed by
         Mario Carneiro, 18-Apr-2016.) $)
      dchrmul $p |- ( ph -> ( X .x. Y ) = ( X oF x. Y ) ) $=
        ( co cmul cof cxp cres wcel dchrrcl syl dchrplusg oveqd ofmresval eqtrd
        cn ) AFGCOFGPQZBBRSZOFGUHOACUIFGABCDEHIJKLAFBTEUGTMBDEFIKUAUBUCUDABBPFG
        MNUEUF $.

      $( Closure of the group operation on Dirichlet characters.  (Contributed
         by Mario Carneiro, 18-Apr-2016.) $)
      dchrmulcl $p |- ( ph -> ( X .x. Y ) e. D ) $=
        ( vx co cmul wcel cfv cc vy cof dchrmul cbs wf cv cmulr wceq cui cur c1
        wral cc0 wne wi w3a cvv wa mulcl adantl eqid dchrf a1i inidm off unitcl
        fvex anim12i cmgp ccnfld cmhm cn dchrrcl dchrelbas2 mpbid simpld mgpbas
        syl mgpplusg mhmlin 3expb sylan oveq12d ffvelrnda adantrr simpr ffvelrn
        cnfldmul syl2an mul4d wfn ffn adantr crg cn0 ccrg nnnn0d zncrng crngrng
        eqtrd 3syl rngcl fnfvof syl22anc simprr 3eqtr4d sylan2 rngidcl rngidval
        ralrimivva cnfld1 syl6eq neeq1d mulne0bd bitr4d simprd r19.21bi adantrd
        mhm0 1t1e1 sylbid ralrimiva 3jca dchrelbas3 mpbir2and eqeltrd ) AFGCPFG
        QUBPZBABCDEFGHIJKLMNUCAYGBRHUDSZTYGUEOUFZUAUFZHUGSZPZYGSZYIYGSZYJYGSZQP
        ZUHZUAHUISZULOYRULZHUJSZYGSZUKUHZYNUMUNZYIYRRZUOZOYHULZUPAOUAYHYHYHQTTT
        FGUQUQYITRYJTRURYIYJQPTRAYIYJUSUTAYHBDEFHIJKYHVAZMVBZAYHBDEGHIJKUUGNVBZ
        YHUQRZAHUDVGZVCZUULYHVDVEAYSUUBUUFAYQOUAYRYRUUDYJYRRZURAYIYHRZYJYHRZURZ
        YQUUDUUNUUMUUOYHHYRYIUUGYRVAZVFYHHYRYJUUGUUQVFVHAUUPURZYLFSZYLGSZQPZYIF
        SZYIGSZQPZYJFSZYJGSZQPZQPZYMYPUURUVAUVBUVEQPZUVCUVFQPZQPUVHUURUUSUVIUUT
        UVJQAFHVISZVJVISZVKPZRZUUPUUSUVIUHZAUVNUVBUMUNZUUDUOZOYHULZAFBRZUVNUVRU
        RMAOYHBYRDEFHIJUUGUUQAUVSEVLRMBDEFIKVMVRZKVNVOZVPZUVNUUNUUOUVOYHYKQUVKU
        VLFYIYJYHHUVKUVKVAZUUGVQZHYKUVKUWCYKVAZVSZVJQUVLUVLVAZWHVSZVTWAWBAGUVMR
        ZUUPUUTUVJUHZAUWIUVCUMUNZUUDUOOYHULZAGBRUWIUWLURNAOYHBYRDEGHIJUUGUUQUVT
        KVNVOVPZUWIUUNUUOUWJYHYKQUVKUVLGYIYJUWDUWFUWHVTWAWBWCUURUVBUVEUVCUVFAUU
        NUVBTRUUOAYHTYIFUUHWDZWEAYHTFUEZUUOUVETRUUPUUHUUNUUOWFZYHTYJFWGWIAUUNUV
        CTRUUOAYHTYIGUUIWDZWEAYHTGUEZUUOUVFTRUUPUUIUWPYHTYJGWGWIWJWTUURFYHWKZGY
        HWKZUUJYLYHRZYMUVAUHAUWSUUPAUWOUWSUUHYHTFWLVRZWMZAUWTUUPAUWRUWTUUIYHTGW
        LVRZWMZUUJUURUUKVCZAHWNRZUUPUXAAEWORHWPRUXGAEUVTWQEHJWRHWSXAZUXGUUNUUOU
        XAYHHYKYIYJUUGUWEXBWAWBYHQFGUQYLXCXDUURYNUVDYOUVGQAUUNYNUVDUHZUUOAUUNUR
        ZUWSUWTUUJUUNUXIAUWSUUNUXBWMAUWTUUNUXDWMUUJUXJUUKVCAUUNWFYHQFGUQYIXCXDZ
        WEUURUWSUWTUUJUUOYOUVGUHUXCUXEUXFAUUNUUOXEYHQFGUQYJXCXDWCXFXGXJAUUAYTFS
        ZYTGSZQPZUKAUWSUWTUUJYTYHRZUUAUXNUHUXBUXDUULAUXGUXOUXHYHHYTUUGYTVAZXHVR
        YHQFGUQYTXCXDAUXNUKUKQPUKAUXLUKUXMUKQAUVNUXLUKUHUWBUVKUVLFUKYTHYTUVKUWC
        UXPXIZVJUKUVLUWGXKXIZXSVRAUWIUXMUKUHUWMUVKUVLGUKYTUXQUXRXSVRWCXTXLWTAUU
        EOYHUXJUUCUVPUWKURZUUDUXJUUCUVDUMUNUXSUXJYNUVDUMUXKXMUXJUVBUVCUWNUWQXNX
        OUXJUVPUUDUWKAUVQOYHAUVNUVRUWAXPXQXRYAYBYCAOUAYHBYRDEYGHIJUUGUUQUVTKYDY
        EYF $.
    $}

    dchrn0.b $e |- B = ( Base ` Z ) $.
    dchrn0.u $e |- U = ( Unit ` Z ) $.
    ${
      dchrn0.x $e |- ( ph -> X e. D ) $.
      dchrn0.a $e |- ( ph -> A e. B ) $.
      $( A Dirichlet character is nonzero on the units of ` Z/nZ ` .
         (Contributed by Mario Carneiro, 18-Apr-2016.) $)
      dchrn0 $p |- ( ph -> ( ( X ` A ) =/= 0 <-> A e. U ) ) $=
        ( cfv cc0 wcel c1 vx wne cv wi wral cmgp ccnfld cmhm dchrrcl dchrelbas2
        co wa syl mpbid simprd wceq fveq2 neeq1d eleq1 imbi12d rspcv sylc cinvr
        cn imp cmul ax-1ne0 a1i cmulr cur crg cn0 ccrg nnnn0d crngrng 3syl eqid
        zncrng unitrinv fveq2d simpld adantr rnginvcl mgpplusg cnfldmul syl3anc
        sylan mgpbas mhmlin rngidval cnfld1 mhm0 3eqtr3d cnfldbas mhmf ffvelrnd
        cc wf mul02d 3netr4d oveq1 necon3i impbida ) ABHQZRUBZBESZAXEXFABCSZUAU
        CZHQZRUBZXHESZUDZUACUEZXEXFUDZPAHIUFQZUGUFQZUHUKSZXMAHDSZXQXMULOAUACDEF
        GHIJKMNAXRGVDSODFGHJLUIUMZLUJUNZUOXLXNUABCXHBUPZXJXEXKXFYAXIXDRXHBHUQUR
        XHBEUSUTVAVBVEAXFULZXDBIVCQZQZHQZVFUKZRYEVFUKZUBXEYBTRYFYGTRUBYBVGVHYBB
        YDIVIQZUKZHQZIVJQZHQZYFTYBYIYKHAIVKSZXFYIYKUPAGVLSIVMSYMAGXSVNGIKVRIVOV
        PZIYHEYKYCBNYCVQZYHVQZYKVQZVSWGVTYBXQXGYDCSZYJYFUPAXQXFAXQXMXTWAWBZAXGX
        FPWBAYMXFYRYNCIEYCBNYOMWCWGZCYHVFXOXPHBYDCIXOXOVQZMWHZIYHXOUUAYPWDUGVFX
        PXPVQZWEWDWIWFYBXQYLTUPYSXOXPHTYKIYKXOUUAYQWJUGTXPUUCWKWJWLUMWMYBYEYBCW
        QYDHYBXQCWQHWRYSCWQXOXPHUUBWQUGXPUUCWNWHWOUMYTWPWSWTXDRYFYGXDRYEVFXAXBU
        MXC $.
    $}

    dchr1cl.o $e |- .1. = ( k e. B |-> if ( k e. U , 1 , 0 ) ) $.
    ${
      dchr1cl.n $e |- ( ph -> N e. NN ) $.
      $( Closure of the principal Dirichlet character.  (Contributed by Mario
         Carneiro, 18-Apr-2016.) $)
      dchr1cl $p |- ( ph -> .1. e. D ) $=
        ( wcel c1 wceq eqidd vx vy cv cc0 cif cmulr cfv co cur cc wa ax-1cn a1i
        cmpt cmul 1t1e1 eqcomi dchrelbasd syl5eqel ) AEFBFUCZDQZRUDUEUNCOAUAUBR
        BRCDFRGHRRIJKMNPLUTUAUCZSRTUTUBUCZSRTUTVBVCIUFUGUHSRTUTIUIUGSRTRUJQAVAU
        KULUMRRRUOUHZSAVBDQVCDQUKUKVDRUPUQUMARTURUS $.
    $}

    dchrmulid2.t $e |- .x. = ( +g ` G ) $.
    dchrmulid2.x $e |- ( ph -> X e. D ) $.
    $( Left identity for the principal Dirichlet character.  (Contributed by
       Mario Carneiro, 18-Apr-2016.) $)
    dchrmulid2 $p |- ( ph -> ( .1. .x. X ) = X ) $=
      ( cc0 co cmul cof wcel cn dchrrcl syl dchr1cl dchrmul cv c1 cif cmpt wceq
      cfv wa oveq1 eqeq1d cc dchrf ffvelrnda adantr mulid2d 0cn mul02i wne cmgp
      wn ccnfld cmhm wral dchrelbas2 mpbid simprd r19.21bi necon1bd imp 3eqtr4a
      oveq2d ifbothda mpteq2dva cvv cbs fvex eqeltri a1i ax-1cn feqmptd offval2
      wi keepel 3eqtr4d eqtrd ) AFJDUAFJUBUCUAZJACDHIFJKLMNRABCEFGHIKLMNOPQAJCU
      DZIUEUDSCHIJLNUFUGZUHSUIAGBGUJZEUDZUKTULZWQJUOZUBUAZUMGBWTUMWNJAGBXAWTWRU
      KWTUBUAZWTUNTWTUBUAZWTUNXAWTUNAWQBUDUPZUKTUKWSUNXBXAWTUKWSWTUBUQURTWSUNXC
      XAWTTWSWTUBUQURXDWRUPWTXDWTUSUDWRABUSWQJABCHIJKLMNOSUTZVAZVBVCXDWRVHZUPZT
      TUBUATXCWTTVDVEXHWTTTUBXDXGWTTUNXDWRWTTAWTTVFWRWJZGBAJKVGUOVIVGUOVJUAUDZX
      IGBVKZAWOXJXKUPSAGBCEHIJKLMOPWPNVLVMVNVOVPVQZVSXLVRVTWAAGBWSWTUBFJWBUSUSB
      WBUDABKWCUOWBOKWCWDWEWFWSUSUDXDWRUKTUSWGVDWKWFXFFGBWSUMUNAQWFAGBUSJXEWHZW
      IXMWLWM $.

    dchrinvcl.n $e |- K = ( k e. B |->
      if ( k e. U , ( 1 / ( X ` k ) ) , 0 ) ) $.
    $( Closure of the group inverse operation on Dirichlet characters.
       (Contributed by Mario Carneiro, 19-Apr-2016.) $)
    dchrinvcl $p |- ( ph -> ( K e. D /\ ( K .x. X ) = .1. ) ) $=
      ( vx vy wcel co wceq cv c1 cfv cdiv cc0 cif cmpt cmulr cur cn dchrrcl syl
      fveq2 oveq2d wa cc wf dchrf unitss sseli ffvelrn syl2an wne adantr adantl
      simpr dchrn0 mpbird reccld cmul 1t1e1 eqcomi a1i cmgp ccnfld cmhm dchrmhm
      sseldi simprl simprr eqid mgpbas mgpplusg cnfldmul mhmlin syl3anc oveq12d
      ax-1cn ffvelrnd divmuldivd eqtr4d rngidval cnfld1 div1i syl6eq dchrelbasd
      mhm0 syl5eqel cof dchrmul cvv fvex eqeltri ovex c0ex ifex feqmptd offval2
      cbs ffvelrnda oveq1 biimpar recid2d ifeq1da mul02d ifeq2d eqtrd mpteq2dva
      ifsb syl5eq syl6reqr jca ) AICUDIKDUEZFUFAIGBGUGZEUDZUHYJKUIZUJUEZUKULZUM
      ZCUAAUBUCUHUBUGZKUIZUJUEZBUHUCUGZKUIZUJUEZCEGUHYPYSLUNUIZUEZKUIZUJUEZHJYM
      UHLUOUIZKUIZUJUEZLMNPQAKCUDZJUPUDTCHJKMOUQUROYJYPUFYLYQUHUJYJYPKUSUTYJYSU
      FYLYTUHUJYJYSKUSUTYJUUCUFYLUUDUHUJYJUUCKUSUTYJUUFUFYLUUGUHUJYJUUFKUSUTAYK
      VAZYLABVBKVCZYJBUDZYLVBUDZYKABCHJKLMNOPTVDZEBYJBLEPQVEZVFZBVBYJKVGVHUUJYL
      UKVIZYKAYKVLUUJYJBCEHJKLMNOPQAUUIYKTVJYKUULAUUPVKVMVNVOAYPEUDZYSEUDZVAZVA
      ZUUEUHUHVPUEZYQYTVPUEZUJUEYRUUAVPUEUVAUHUVBUUDUVCUJUHUVBUFUVAUVBUHVQVRVSU
      VAKLVTUIZWAVTUIZWBUEZUDZYPBUDYSBUDUUDUVCUFUVACUVFKCHJLMNOWCZAUUIUUTTVJZWD
      UVAEBYPUUOAUURUUSWEZWDZUVAEBYSUUOAUURUUSWFZWDZBUUBVPUVDUVEKYPYSBLUVDUVDWG
      ZPWHLUUBUVDUVNUUBWGWIWAVPUVEUVEWGZWJWIWKWLWMUVAUHYQUHYTUHVBUDUVAWNVSZUVAB
      VBYPKAUUKUUTUUNVJZUVKWOUVPUVABVBYSKUVQUVMWOUVAYQUKVIUURUVJUVAYPBCEHJKLMNO
      PQUVIUVKVMVNUVAYTUKVIUUSUVLUVAYSBCEHJKLMNOPQUVIUVMVMVNWPWQAUUHUHUHUJUEUHA
      UUGUHUHUJAUVGUUGUHUFACUVFKUVHTWDUVDUVEKUHUUFLUUFUVDUVNUUFWGWRWAUHUVEUVOWS
      WRXCURUTUHWNWTXAXBXDZAYIIKVPXEUEZFACDHJIKLMNOSUVRTXFAUVSGBYNYLVPUEZUMZFAG
      BYNYLVPIKXGXGVBBXGUDABLXOUIXGPLXOXHXIVSYNXGUDAUULVAZYKYMUKUHYLUJXJXKXLVSA
      BVBYJKUUNXPZIYOUFAUAVSAGBVBKUUNXMXNAUWAGBYKUHUKULZUMFAGBUVTUWDUWBUVTYKYMY
      LVPUEZUKYLVPUEZULZUWDYKYMUKUVTUWEUWFYNYMYLVPXQYNUKYLVPXQYEUWBUWGYKUHUWFUL
      UWDUWBYKUWEUHUWFUWBYKVAYLUWBUUMYKUWCVJUWBUUQYKUWBYJBCEHJKLMNOPQAUUIUULTVJ
      AUULVLVMXRXSXTUWBYKUWFUKUHUWBYLUWCYAYBYCYFYDRYGWQYCYH $.
  $}

  ${
    $d f x D $.  $d a b c k x y z G $.  $d a b c f k x y z N $.
    dchrabl.g $e |- G = ( DChr ` N ) $.
    $( The set of Dirichlet characters is an Abelian group.  (Contributed by
       Mario Carneiro, 19-Apr-2016.) $)
    dchrabl $p |- ( N e. NN -> G e. Abel ) $=
      ( vx vy vk va vb wcel cbs cfv cv co w3a eqid wa cmul cc cvv dchrmul vz vc
      cn cplusg eqidd czn cui c1 cdiv cc0 cif cmpt simp2 dchrmulcl cof fvex a1i
      simp3 wf 3adant3r3 simpr3 wceq mulass adantl caofass simpr1 simpr2 oveq1d
      dchrf oveq2d 3eqtr4d id dchr1cl dchrmulid2 dchrinvcl simpld simprd isgrpd
      simpr mulcom caofcom isabld ) BUCIZDEAJKZAUDKZAWCWDUEZWCWEUEZWCDEUAWDWEAF
      BUFKZJKZFLZWHUGKZIZUHWJDLZKUIMUJUKULZFWIWLUHUJUKULZWFWGWCWMWDIZELZWDIZNZW
      DWEABWMWQWHCWHOZWDOZWEOZWCWPWRUMZWCWPWRURZUNZWCWPWRUALZWDIZNPZWMWQWEMZXFQ
      UOZMZWMWQXFWEMZXJMZXIXFWEMWMXLWEMXHWMWQXJMZXFXJMWMWQXFXJMZXJMXKXMXHGHUBWI
      QQRQWMWQXFQSWISIZXHWHJUPZUQWCWPWRWIRWMUSXGWSWIWDABWMWHCWTXAWIOZXCVIZUTWCW
      PWRWIRWQUSXGWSWIWDABWQWHCWTXAXRXDVIZUTXHWIWDABXFWHCWTXAXRWCWPWRXGVAZVIGLZ
      RIZHLZRIZUBLZRINYBYDQMZYFQMYBYDYFQMQMVBXHYBYDYFVCVDVEXHXIXNXFXJXHWDWEABWM
      WQWHCWTXAXBWCWPWRXGVFZWCWPWRXGVGZTVHXHXLXOWMXJXHWDWEABWQXFWHCWTXAXBYIYATV
      JVKXHWDWEABXIXFWHCWTXAXBWCWPWRXIWDIXGXEUTYATXHWDWEABWMXLWHCWTXAXBYHXHWDWE
      ABWQXFWHCWTXAXBYIYAUNTVKWCWIWDWKWOFABWHCWTXAXRWKOZWOOZWCVLVMWCWPPZWIWDWEW
      KWOFABWMWHCWTXAXRYJYKXBWCWPVSZVNYLWNWDIZWNWMWEMWOVBZYLWIWDWEWKWOFAWNBWMWH
      CWTXAXRYJYKXBYMWNOVOZVPYLYNYOYPVQVRWSXNWQWMXJMXIWQWMWEMWSGHWIQRWMWQSXPWSX
      QUQXSXTYCYEPYGYDYBQMVBWSYBYDVTVDWAWSWDWEABWMWQWHCWTXAXBXCXDTWSWDWEABWQWMW
      HCWTXAXBXDXCTVKWB $.

    dchrfi.b $e |- D = ( Base ` G ) $.
    $( The group of Dirichlet characters is a finite group.  (Contributed by
       Mario Carneiro, 19-Apr-2016.) $)
    dchrfi $p |- ( N e. NN -> D e. Fin ) $=
      ( vz wcel cc0 cfv cexp co c1 cmin wceq cc cfn wa cvv eqid syl vf vx cn cv
      csn cphi crab cun czn cbs cmap wss snfi cmpt cdgr cle wbr c0p wne cxp cof
      chash cply cnex a1i ovex ax-1cn eqidd fconstmpt offval2 ssid phicl nnnn0d
      cn0 plypow syl3anc plyconst plysubcl sylancl eqeltrrd 0cn ax-1ne0 negne0i
      mp2an 0expd oveq1d oveq1 fvmpt ax-mp df-neg 3eqtr4g neeq1d mpbiri sylancr
      cneg ne0p ccnv cima mptiniseg eqcomi fta1 syl2anc simpld unfi znfi wf wfn
      mapfi wral simpr dchrf ffn wo wn df-ne fvex elsnc xchbinxr ffvelrn syl2an
      simpl ccnfld cmg cur dchrmhm simplr sseldi ad2antrr simprl mgpbas mhmmulg
      cmgp cmhm cui cdivides wb sylibr mpbid rngidval sylanbrc c0g cod cgrp crg
      cress ccrg nnnn0 zncrng crngrng unitgrp znunithash eqeltrd hashclb simprr
      dchrn0 unitgrpbas oddvds2 breqtrd cz nnzd csubmnd unitsubm submmulg subm0
      oddvds 3eqtr4d fveq2d eqtr3d cnfld1 mhm0 3eqtr3d 1m1e0 syl6eq eqeq1d expr
      cnfldexp elrab syl5bir orrd elun ralrimiva ffnfv ex elmapg sylibrd ssrdv
      ssfi ) CUCGZHUEZFUDZCUFIZJKZLMKZHNZFOUGZUHZCUIIZUJIZUKKZPGZAUWSULAPGUWHUW
      PPGZUWRPGZUWTUWHUWIPGUWOPGZUXAHUMUWHUXCUWOVBIFOUWMUNZUOIUPUQZUWHUXDOVCIZG
      UXDURUSZUXCUXEQUWHFOUWLUNZOLUEUTZMVAKZUXDUXFUWHFOUWLLMUXHUXIRROORGUWHVDVE
      UWLRGUWHUWJOGQZUWJUWKJVFVELOGZUXKVGVEUWHUXHVHUXIFOLUNNUWHFOLVIVEVJUWHUXHU
      XFGZUXIUXFGZUXJUXFGUWHOOULZUXLUWKVNGZUXMUXOUWHOVKZVEUXLUWHVGVEUWHUWKCVLZV
      MZFOUWKVOVPUXOUXLUXNUXQVGLOVQWDOUXHUXIVRVSVTUWHHOGZHUXDIZHUSZUXGWAUWHUYBL
      WOZHUSLVGWBWCUWHUYAUYCHUWHHUWKJKZLMKZHLMKUYAUYCUWHUYDHLMUWHUWKUXRWEWFUXTU
      YAUYENWAFHUWMUYEOUXDUWJHNUWLUYDLMUWJHUWKJWGWFUXDSZUYDLMVFWHWILWJWKWLWMHUX
      DWPWNUWOOUXDUXDWQUWIWRZUWOUXTUYGUWONWAFOUWMHUXDOUYFWSWIWTXAXBXCUWIUWOXDWN
      ZUWRCUWQUWQSZUWRSZXEZUWPUWRXHXBUWHUAAUWSUWHUAUDZAGZUWRUWPUYLXFZUYLUWSGZUW
      HUYMUYNUWHUYMQZUYLUWRXGZUBUDZUYLIZUWPGZUBUWRXIUYNUYPUWROUYLXFZUYQUYPUWRAB
      CUYLUWQDUYIEUYJUWHUYMXJXKZUWROUYLXLTUYPUYTUBUWRUYPUYRUWRGZQZUYSUWIGZUYSUW
      OGZXMUYTVUDVUEVUFVUEXNUYSHUSZVUDVUFVUGUYSHNVUEUYSHXOUYSHUYRUYLXPXQXRUYPVU
      CVUGVUFUYPVUCVUGQZQZUYSOGZUYSUWKJKZLMKZHNZVUFUYPVUAVUCVUJVUHVUBVUCVUGYAUW
      ROUYRUYLXSXTZVUIVULLLMKHVUIVUKLLMVUIUWKUYSYBYLIZYCIZKZUWQYDIZUYLIZVUKLVUI
      UWKUYRUWQYLIZYCIZKZUYLIZVUQVUSVUIUYLVUTVUOYMKZGZUXPVUCVVCVUQNVUIAVVDUYLAB
      CUWQDUYIEYEUWHUYMVUHYFZYGZUWHUXPUYMVUHUXSYHZUYPVUCVUGYIZUWRVVAVUPUYLVUTVU
      OUWKUYRUWRUWQVUTVUTSZUYJYJVVASZVUPSYKVPVUIVVBVURUYLVUIUWKUYRVUTUWQYNIZUUE
      KZYCIZKZVVMUUAIZVVBVURVUIUYRVVMUUBIZIZUWKYOUQZVVOVVPNZVUIVVRVVLVBIZUWKYOV
      UIVVMUUCGZVVLPGZUYRVVLGZVVRVWAYOUQVUIUWQUUDGZVWBUWHVWEUYMVUHUWHUWQUUFGZVW
      EUWHCVNGVWFCUUGCUWQUYIUUHTUWQUUITYHZUWQVVLVVMVVLSZVVMSZUUJTZUWHVWCUYMVUHU
      WHVWAVNGZVWCUWHVWAUWKVNVVLCUWQUYIVWHUUKZUXSUULVVLRGVWCVWKYPUWQYNXPVVLRUUM
      WIYQYHVUIVUGVWDUYPVUCVUGUUNVUIUYRUWRAVVLBCUYLUWQDUYIEUYJVWHVVFVVIUUOYRZUY
      RVVMVVQVVLUWQVVLVVMVWHVWIUUPZVVQSZUUQVPUWHVWAUWKNUYMVUHVWLYHUURVUIVWBVWDU
      WKUUSGVVSVVTYPVWJVWMVUIUWKUWHUWKUCGUYMVUHUXRYHUUTUYRVVNVVMUWKVVQVVLVVPVWN
      VWOVVNSZVVPSUVEVPYRVUIVVLVUTUVAIGZUXPVWDVVBVVONVUIVWEVWQVWGUWQVVLVUTVWHVV
      JUVBTZVVHVWMVVLVVAVVNVUTVVMUWKUYRVVKVWIVWPUVCVPVUIVWQVURVVPNVWRVVLVVMVUTV
      URVWIUWQVURVUTVVJVURSYSZUVDTUVFUVGUVHVUIVUJUXPVUQVUKNVUNVVHUYSUWKUVPXBVUI
      VVEVUSLNVVGVUTVUOUYLLVURVWSYBLVUOVUOSUVIYSUVJTUVKWFUVLUVMUWNVUMFUYSOUWJUY
      SNZUWMVULHVWTUWLVUKLMUWJUYSUWKJWGWFUVNUVQYTUVOUVRUVSUYSUWIUWOUVTYQUWAUBUW
      RUWPUYLUWBYTUWCUWHUXAUXBUYOUYNYPUYHUYKUWPUWRUYLPPUWDXBUWEUWFUWSAUWGXB $.
  $}

  ${
    $d x ph $.  $d x U $.  $d x X $.
    dchrghm.g $e |- G = ( DChr ` N ) $.
    dchrghm.z $e |- Z = ( Z/nZ ` N ) $.
    dchrghm.b $e |- D = ( Base ` G ) $.
    dchrghm.u $e |- U = ( Unit ` Z ) $.
    dchrghm.h $e |- H = ( ( mulGrp ` Z ) |`s U ) $.
    dchrghm.m $e |- M = ( ( mulGrp ` CCfld ) |`s ( CC \ { 0 } ) ) $.
    dchrghm.x $e |- ( ph -> X e. D ) $.
    $( A Dirichlet character restricted to the unit group of ` Z/nZ ` is a
       group homomorphism into the multiplicative group of nonzero complex
       numbers.  (Contributed by Mario Carneiro, 21-Apr-2016.) $)
    dchrghm $p |- ( ph -> ( X |` U ) e. ( H GrpHom M ) ) $=
      ( cfv wcel syl cc vx cres cmhm co cghm ccnfld cmgp csubmnd dchrmhm sseldi
      crg ccrg cn0 cn dchrrcl nnnn0d zncrng crngrng unitsubm resmhm syl2anc cc0
      eqid csn cdif crn wss wb cnrng cnfldbas cnfld0 cndrng drngui ax-mp df-ima
      cima cv wral wa wne cbs wf dchrf unitss sseli ffvelrn syl2an simpr adantr
      adantl dchrn0 eldifsn sylanbrc ralrimiva wfun cdm ffun wceq fdm syl5sseqr
      mpbird funimass4 syl5eqssr resmhm2b sylancr mpbid unitgrp cnmgpabl ablgrp
      cgrp cabel ghmmhmb sylancl eleqtrrd ) AHCUBZEFUCUDZEFUEUDZAXOEUFUGQZUCUDR
      ZXOXPRZAHIUGQZXRUCUDZRCYAUHQRZXSABYBHBDGIJKLUIPUJAIUKRZYCAIULRZYDAGUMRYEA
      GAHBRZGUNRPBDGHJLUOSUPGIKUQSIURSZICYAMYAVCUSSYAXREHCNUTVAATVBVDVEZXRUHQRZ
      XOVFZYHVGXSXTVHUFUKRYIVIUFYHXRTUFVBVJVKVLVMXRVCUSVNAYJHCVPZYHHCVOAYKYHVGZ
      UAVQZHQZYHRZUACVRZAYOUACAYMCRZVSZYNTRZYNVBVTZYOAIWAQZTHWBZYMUUARZYSYQAUUA
      BDGHIJKLUUAVCZPWCZCUUAYMUUAICUUDMWDZWEZUUATYMHWFWGYRYTYQAYQWHYRYMUUABCDGH
      IJKLUUDMAYFYQPWIYQUUCAUUGWJWKXAYNTVBWLWMWNAHWOZCHWPZVGYLYPVHAUUBUUHUUEUUA
      THWQSAUUACUUIUUFAUUBUUIUUAWRUUEUUATHWSSWTUACYHHXBVAXAXCEXRFXOYHOXDXEXFAEX
      JRZFXJRZXQXPWRAYDUUJYGICEMNXGSFXKRUUKFOXHFXIVNEFXLXMXN $.
  $}

  ${
    $d k A $.  $d k x N $.  $d k x ph $.  $d k x U $.  $d k x Z $.
    dchr1.g $e |- G = ( DChr ` N ) $.
    dchr1.z $e |- Z = ( Z/nZ ` N ) $.
    dchr1.o $e |- .1. = ( 0g ` G ) $.
    dchr1.u $e |- U = ( Unit ` Z ) $.
    dchr1.n $e |- ( ph -> N e. NN ) $.
    dchr1.a $e |- ( ph -> A e. U ) $.
    $( Value of the principal Dirichlet character.  (Contributed by Mario
       Carneiro, 28-Apr-2016.) $)
    dchr1 $p |- ( ph -> ( .1. ` A ) = 1 ) $=
      ( vk vx wcel c1 cc0 wceq eqid cv cif cbs cfv cc cmpt cplusg dchr1cl eleq1
      co ifbid cbvmptv dchrmulid2 cn cabel cgrp wa dchrabl ablgrp isgrpid2 4syl
      mpbi2and simpr adantr eqeltrd iftrue syl unitss sseldi ax-1cn a1i fvmptd
      wb ) ANBNUAZCPZQRUBZQGUCUDZDUEANVQVPUFZEUCUDZPZVRVREUGUDZUJVRSZDVRSZAVQVS
      CVRNEFGHIVSTZVQTZKVRTLUHZAVQVSWACVROEFVRGHIWDWEKNOVQVPOUAZCPZQRUBVNWGSVOW
      HQRVNWGCUIUKULWATZWFUMAFUNPEUOPEUPPVTWBUQWCVMLEFHUREUSVSWAEDVRWDWIJUTVAVB
      AVNBSZUQZVOVPQSWKVNBCAWJVCABCPWJMVDVEVOQRVFVGACVQBVQGCWEKVHMVIQUEPAVJVKVL
      $.
  $}

  ${
    $d k x ph $.  $d k x U $.  $d k x X $.  $d k Y $.  $d k Z $.
    dchrresb.g $e |- G = ( DChr ` N ) $.
    dchrresb.z $e |- Z = ( Z/nZ ` N ) $.
    dchrresb.b $e |- D = ( Base ` G ) $.
    dchrresb.u $e |- U = ( Unit ` Z ) $.
    dchrresb.x $e |- ( ph -> X e. D ) $.
    dchrresb.Y $e |- ( ph -> Y e. D ) $.
    $( A Dirichlet character is determined by its values on the unit group.
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    dchreq $p |- ( ph -> ( X = Y <-> A. k e. U ( X ` k ) = ( Y ` k ) ) ) $=
      ( wceq wral wa wcel cc0 cv cfv cbs cdif wfn wb cc wf dchrf ffn syl eqfnfv
      eqid syl2anc cun wss unitss undif mpbi raleqi ralunb bitr3i syl6bb wn wne
      eldif adantr simpr dchrn0 biimpd necon1bd impr sylan2b ralrimiva biantrud
      eqtr4d bitr4d ) AGHPZDUAZGUBZVSHUBZPZDCQZWBDIUCUBZCUDZQZRZWCAVRWBDWDQZWGA
      GWDUEZHWDUEZVRWHUFAWDUGGUHWIAWDBEFGIJKLWDUMZNUIWDUGGUJUKAWDUGHUHWJAWDBEFH
      IJKLWKOUIWDUGHUJUKDWDGHULUNWHWBDCWEUOZQWGWBDWLWDCWDUPWLWDPWDICWKMUQCWDURU
      SUTWBDCWEVAVBVCAWFWCAWBDWEAVSWESZRVTTWAWMAVSWDSZVSCSZVDZRZVTTPZVSWDCVFZAW
      NWPWRAWNRZWOVTTWTVTTVEWOWTVSWDBCEFGIJKLWKMAGBSWNNVGAWNVHZVIVJVKVLVMWMAWQW
      ATPZWSAWNWPXBWTWOWATWTWATVEWOWTVSWDBCEFHIJKLWKMAHBSWNOVGXAVIVJVKVLVMVPVNV
      OVQ $.

    $( A Dirichlet character is determined by its values on the unit group.
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    dchrresb $p |- ( ph -> ( ( X |` U ) = ( Y |` U ) <-> X = Y ) ) $=
      ( vk cres wceq cfv wfn cc cv wral cbs wb wf eqid dchrf ffn syl wss unitss
      wa fvreseq mpan2 syl2anc dchreq bitr4d ) AFCPGCPQZOUAZFRUSGRQOCUBZFGQAFHU
      CRZSZGVASZURUTUDZAVATFUEVBAVABDEFHIJKVAUFZMUGVATFUHUIAVATGUEVCAVABDEGHIJK
      VENUGVATGUHUIVBVCULCVAUJVDVAHCVELUKOVACFGUMUNUOABCODEFGHIJKLMNUPUQ $.
  $}

  ${
    $d x G $.  $d x y N $.  $d x y ph $.  $d x y X $.
    dchrabs.g $e |- G = ( DChr ` N ) $.
    dchrabs.d $e |- D = ( Base ` G ) $.
    dchrabs.x $e |- ( ph -> X e. D ) $.
    ${
      dchrabs.z $e |- Z = ( Z/nZ ` N ) $.
      dchrabs.u $e |- U = ( Unit ` Z ) $.
      dchrabs.a $e |- ( ph -> A e. U ) $.
      $( A Dirichlet character takes values on the unit circle.  (Contributed
         by Mario Carneiro, 28-Apr-2016.) $)
      dchrabs $p |- ( ph -> ( abs ` ( X ` A ) ) = 1 ) $=
        ( cfv c1 co eqid wcel wceq cabs ccxp chash cdiv cbs dchrf unitss sseldi
        cmul cc ffvelrnd cc0 wne dchrn0 mpbird absrpcld cfn cn0 cn dchrrcl znfi
        wss 3syl ssfi sylancl hashcl syl nn0red recnd c0 hashnncl nnne0d reccld
        ne0i wb cxpmuld recidd oveq2d cexp abscld cxpexp syl2anc absexpd ccnfld
        cmgp cmg cur csn cdif cress cres csubmnd crg cnrng cnfld0 cndrng drngui
        cnfldbas unitsubm mp1i eldifsn sylanbrc syl3anc cghm dchrghm unitgrpbas
        submmulg cz nn0zd ghmmulg c0g cod cdivides wbr cgrp ccrg nnnn0d crngrng
        zncrng unitgrp oddvds2 oddvds mpbid unitgrpid eqtr4d fveq2d fvres 1unit
        3eqtr3d 3eqtr2d cnfldexp cmhm dchrmhm rngidval cnfld1 mhm0 syl6eq cxp1d
        abs1 oveq1d 1cxpd ) ABGOZUAOZPUBQZPPDUCOZUDQZUBQZUUCPAUUCUUEUUFUIQZUBQU
        UCUUEUBQZUUFUBQUUDUUGAUUCUUEUUFAUUBAHUEOZUJBGAUUJCEFGHILJUUJRZKUFADUUJB
        UUJHDUUKMUGZNUHZUKZAUUBULUMZBDSZNABUUJCDEFGHILJUUKMKUUMUNUOZUPAUUEADUQS
        ZUUEURSZAUUJUQSZDUUJVBUURAGCSZFUSSZUUTKCEFGIJUTZUUJFHLUUKVAVCUULUUJDVDV
        EZDVFVGZVHZAUUEAUUEUVFVIZAUUEAUUEUSSZDVJUMZAUUPUVINDBVNVGAUURUVHUVIVOUV
        DDVKVGUOVLZVMZVPAUUHPUUCUBAUUEUVGUVJVQVRAUUIPUUFUBAUUIUUCUUEVSQZUUBUUEV
        SQZUAOZPAUUCUJSUUSUUIUVLTAUUCAUUBUUNVTVIZUVEUUCUUEWAWBAUUBUUEUUNUVEWCAU
        VNPUAOPAUVMPUAAUUEUUBWDWEOZWFOZQZHWGOZGOZUVMPAUVRUUEUUBUVPUJULWHWIZWJQZ
        WFOZQZUVSGDWKZOZUVTAUWAUVPWLOSZUUSUUBUWASZUVRUWDTWDWMSUWGAWNWDUWAUVPUJW
        DULWRWOWPWQUVPRZWSWTUVEAUUBUJSZUUOUWHUUNUUQUUBUJULXAXBUWAUVQUWCUVPUWBUU
        EUUBUVQRUWBRZUWCRZXGXCAUUEBHWEOZDWJQZWFOZQZUWEOZUUEBUWEOZUWCQZUWFUWDAUW
        EUWNUWBXDQSUUEXHSZUUPUWQUWSTACDEUWNUWBFGHILJMUWNRZUWKKXEAUUEUVEXIZNDUWO
        UWCUWEUWNUWBUUEBHDUWNMUXAXFZUWORZUWLXJXCAUWPUVSUWEAUWPUWNXKOZUVSABUWNXL
        OZOUUEXMXNZUWPUXETZAUWNXOSZUURUUPUXGAHWMSZUXIAFURSHXPSUXJAFAUVAUVBKUVCV
        GXQFHLXSHXRVCZHDUWNMUXAXTVGZUVDNBUWNUXFDUXCUXFRZYAXCAUXIUUPUWTUXGUXHVOU
        XLNUXBBUWOUWNUUEUXFDUXEUXCUXMUXDUXERYBXCYCAUXJUVSUXETUXKHDUVSUWNMUXAUVS
        RZYDVGYEYFAUWRUUBUUEUWCAUUPUWRUUBTNBDGYGVGVRYIAUXJUVSDSUWFUVTTUXKHDUVSM
        UXNYHUVSDGYGVCYJAUWJUUSUVRUVMTUUNUVEUUBUUEYKWBAGUWMUVPYLQZSUVTPTACUXOGC
        EFHILJYMKUHUWMUVPGPUVSHUVSUWMUWMRUXNYNWDPUVPUWIYOYNYPVGYIYFYSYQYJYTYIAU
        UCUVOYRAUUFUVKUUAYI $.
    $}

    dchrinv.i $e |- I = ( invg ` G ) $.
    $( The inverse of a Dirichlet character is the conjugate (which is also the
       multiplicative inverse, because the values of ` X ` are unimodular).
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    dchrinv $p |- ( ph -> ( I ` X ) = ( * o. X ) ) $=
      ( vx cfv ccj wceq co wcel cmul cc c1 cc0 vy ccom cplusg c0g cv czn cui wa
      wral cof cbs wf cmulr cur wne wi w3a cjf dchrf fco sylancr cn dchrrcl syl
      eqid dchrelbas3 simprd simp1d r19.21bi anasss fveq2d adantr unitss simprl
      mpbid sseldi ffvelrnd simprr cjmuld eqtrd crg cn0 ccrg nnnn0d zncrng 3syl
      crngrng rngcl syl3anc fvco3 syl2anc oveq12d 3eqtr4d ralrimivva rngidcl cr
      simp2d 1re cjre ax-mp syl6eq simp3d sylan cj0 eqcomi eqeq12d wb ffvelrnda
      a1i cj11 sylancl bitrd necon3bid imbi1d ralbidva mpbird mpbir2and dchrmul
      0cn 3jca fveq1d cabs c2 cexp sseli sylan2 oveq2d absvalsqd dchrabs oveq1d
      simpr sq1 3eqtr2d wfn cvv ffn fvex adantl fnfvof syl22anc dchr1 ralrimiva
      dchrmulcl cgrp cabel dchrabl ablgrp grpidcl dchreq grpinvid1 ) AFDLMFUBZN
      ZFUUKCUCLZOZCUDLZNZAUUPKUEZUUNLZUUQUUOLZNZKEUFLZUGLZUIAUUTKUVBAUUQUVBPZUH
      ZUURUUQFUUKQUJOZLZUUSUVDUUQUUNUVEAUUNUVENUVCABUUMCEFUUKUVAGUVAVEZHUUMVEZI
      AUUKBPZUVAUKLZRUUKULZUUQUAUEZUVAUMLZOZUUKLZUUQUUKLZUVLUUKLZQOZNZUAUVBUIKU
      VBUIZUVAUNLZUUKLZSNZUVPTUOZUVCUPZKUVJUIZUQARRMULUVJRFULZUVKURAUVJBCEFUVAG
      UVGHUVJVEZIUSZUVJRRMFUTVAZAUVTUWCUWFAUVSKUAUVBUVBAUVCUVLUVBPZUHZUHZUVNFLZ
      MLZUUQFLZMLZUVLFLZMLZQOZUVOUVRUWMUWOUWPUWRQOZMLUWTUWMUWNUXAMAUVCUWKUWNUXA
      NZUVDUXBUAUVBAUXBUAUVBUIZKUVBAUXCKUVBUIZUWAFLZSNZUWPTUOZUVCUPZKUVJUIZAUWG
      UXDUXFUXIUQZAFBPZUWGUXJUHIAKUAUVJBUVBCEFUVAGUVGUWHUVBVEZAUXKEVBPZIBCEFGHV
      CVDZHVFVOVGZVHVIVIVJVKUWMUWPUWRUWMUVJRUUQFAUWGUWLUWIVLZUWMUVBUVJUUQUVJUVA
      UVBUWHUXLVMZAUVCUWKVNVPZVQUWMUVJRUVLFUXPUWMUVBUVJUVLUXQAUVCUWKVRVPZVQVSVT
      UWMUWGUVNUVJPZUVOUWONUXPUWMUVAWAPZUUQUVJPZUVLUVJPZUXTAUYAUWLAEWBPUVAWCPUY
      AAEUXNWDEUVAUVGWEUVAWGWFZVLUXRUXSUVJUVAUVMUUQUVLUWHUVMVEWHWIUVJRUVNMFWJWK
      UWMUVPUWQUVQUWSQUWMUWGUYBUVPUWQNZUXPUXRUVJRUUQMFWJZWKUWMUWGUYCUVQUWSNUXPU
      XSUVJRUVLMFWJWKWLWMWNAUWBUXEMLZSAUWGUWAUVJPZUWBUYGNUWIAUYAUYHUYDUVJUVAUWA
      UWHUWAVEWOVDUVJRUWAMFWJWKAUYGSMLZSAUXESMAUXDUXFUXIUXOWQVKSWPPUYISNWRSWSWT
      XAVTAUWFUXIAUXDUXFUXIUXOXBAUWEUXHKUVJAUYBUHZUWDUXGUVCUYJUVPTUWPTUYJUVPTNU
      WQTMLZNZUWPTNZUYJUVPUWQTUYKAUWGUYBUYEUWIUYFXCZTUYKNUYJUYKTXDXEXIXFUYJUWPR
      PZTRPUYLUYMXGAUVJRUUQFUWIXHZXSUWPTXJXKXLXMXNXOXPXTAKUAUVJBUVBCEUUKUVAGUVG
      UWHUXLUXNHVFXQZXRVLYAUVDUWPUVPQOZSUVFUUSUVDUYRUWPUWQQOUWPYBLZYCYDOZSUVDUV
      PUWQUWPQUVCAUYBUYEUVBUVJUUQUXQYEZUYNYFYGUVDUWPUVCAUYBUYOVUAUYPYFYHUVDUYTS
      YCYDOSUVDUYSSYCYDUVDUUQBUVBCEFUVAGHAUXKUVCIVLUVGUXLAUVCYKZYIYJYLXAYMUVDFU
      VJYNZUUKUVJYNZUVJYOPZUYBUVFUYRNUVDUWGVUCAUWGUVCUWIVLUVJRFYPVDAVUDUVCAUVKV
      UDUWJUVJRUUKYPVDVLVUEUVDUVAUKYQXIUVCUYBAVUAYRUVJQFUUKYOUUQYSYTUVDUUQUVBUU
      OCEUVAGUVGUUOVEZUXLAUXMUVCUXNVLVUBUUAWMVTUUBABUVBKCEUUNUUOUVAGUVGHUXLABUU
      MCEFUUKUVAGUVGHUVHIUYQUUCACUUDPZUUOBPAUXMCUUEPVUGUXNCEGUUFCUUGWFZBCUUOHVU
      FUUHVDUUIXPAVUGUXKUVIUULUUPXGVUHIUYQBUUMCDFUUKUUOHUVHVUFJUUJWIXP $.
  $}

  ${
    dchrabs2.g $e |- G = ( DChr ` N ) $.
    dchrabs2.d $e |- D = ( Base ` G ) $.
    dchrabs2.z $e |- Z = ( Z/nZ ` N ) $.
    dchrabs2.b $e |- B = ( Base ` Z ) $.
    dchrabs2.x $e |- ( ph -> X e. D ) $.
    dchrabs2.a $e |- ( ph -> A e. B ) $.
    $( A Dirichlet character takes values inside the unit circle.  (Contributed
       by Mario Carneiro, 3-May-2016.) $)
    dchrabs2 $p |- ( ph -> ( abs ` ( X ` A ) ) <_ 1 ) $=
      ( cfv c1 cle cc0 wa syl6eqbr cabs wbr wceq simpr abs00bd 0le1 wcel adantr
      wne cui eqid dchrn0 biimpa dchrabs 1le1 pm2.61dane ) ABGOZUAOZPQUBUQRAUQR
      UCZSZURRPQUTUQAUSUDUEUFTAUQRUIZSZURPPQVBBDHUJOZEFGHIJAGDUGVAMUHKVCUKZAVAB
      VCUGABCDVCEFGHIKJLVDMNULUMUNUOTUP $.
  $}

  ${
    $d x .1. $.  $d x B $.  $d x ph $.
    dchr1re.g $e |- G = ( DChr ` N ) $.
    dchr1re.z $e |- Z = ( Z/nZ ` N ) $.
    dchr1re.o $e |- .1. = ( 0g ` G ) $.
    dchr1re.b $e |- B = ( Base ` Z ) $.
    dchr1re.n $e |- ( ph -> N e. NN ) $.
    $( The principal Dirichlet character is a real character.  (Contributed by
       Mario Carneiro, 2-May-2016.) $)
    dchr1re $p |- ( ph -> .1. : B --> RR ) $=
      ( vx cfv cr wcel wf cc eqid wa cc0 wfn cv wral cbs cn cgrp dchrabl ablgrp
      cabel grpidcl 4syl dchrf ffn syl wceq simpr 0re syl6eqel wne cui ad2antrr
      c1 adantr dchrn0 biimpa dchr1 1re pm2.61dane ralrimiva ffnfv sylanbrc ) A
      CBUAZLUBZCMZNOZLBUCBNCPABQCPVLABDUDMZDECFGHVPRZJAEUEOZDUIODUFOCVPOZKDEGUG
      DUHVPDCVQIUJUKZULBQCUMUNAVOLBAVMBOZSZVOVNTWBVNTUOZSVNTNWBWCUPUQURWBVNTUSZ
      SZVNVBNWEVMFUTMZCDEFGHIWFRZAVRWAWDKVAWBWDVMWFOWBVMBVPWFDECFGHVQJWGAVSWAVT
      VCAWAUPVDVEVFVGURVHVILBNCVJVK $.
  $}

  ${
    $d a b h k m n x .1. $.  $d a b h k m n u v w x A $.  $d a b h k m u v I $.
    $d v x y B $.  $d h m u C $.  $d x G $.  $d a h i k m n u x H $.  $d x N $.
    $d a b h i k m n u v x W $.  $d a b h k m n u v x .x. $.  $d a b v x y X $.
    $d a b h m u v P $.  $d a h i k m n u x S $.  $d a b h k m n u v w x y Z $.
    $d a w x D $.  $d h m M $.  $d a b h i k m n v w x y ph $.  $d h m u T $.
    $d a b h m u v x y U $.
    dchrpt.g $e |- G = ( DChr ` N ) $.
    dchrpt.z $e |- Z = ( Z/nZ ` N ) $.
    dchrpt.d $e |- D = ( Base ` G ) $.
    dchrpt.b $e |- B = ( Base ` Z ) $.
    dchrpt.1 $e |- .1. = ( 1r ` Z ) $.
    dchrpt.n $e |- ( ph -> N e. NN ) $.
    dchrpt.n1 $e |- ( ph -> A =/= .1. ) $.
    ${
      dchrpt.u $e |- U = ( Unit ` Z ) $.
      dchrpt.h $e |- H = ( ( mulGrp ` Z ) |`s U ) $.
      dchrpt.m $e |- .x. = ( .g ` H ) $.
      dchrpt.s $e |- S = ( k e. dom W |->
        ran ( n e. ZZ |-> ( n .x. ( W ` k ) ) ) ) $.
      dchrpt.au $e |- ( ph -> A e. U ) $.
      dchrpt.w $e |- ( ph -> W e. Word U ) $.
      dchrpt.2 $e |- ( ph -> H dom DProd S ) $.
      dchrpt.3 $e |- ( ph -> ( H DProd S ) = U ) $.
      ${
        dchrpt.p $e |- P = ( H dProj S ) $.
        dchrpt.o $e |- O = ( od ` H ) $.
        dchrpt.t $e |- T = ( -u 1 ^c ( 2 / ( O ` ( W ` I ) ) ) ) $.
        dchrpt.i $e |- ( ph -> I e. dom W ) $.
        dchrpt.4 $e |- ( ph -> ( ( P ` I ) ` A ) =/= .1. ) $.
        dchrpt.5 $e |- X = ( u e. U |-> ( iota h E. m e. ZZ
          ( ( ( P ` I ) ` u ) = ( m .x. ( W ` I ) ) /\ h = ( T ^ m ) ) ) ) $.
        $( Lemma for ~ dchrpt .  (Contributed by Mario Carneiro,
           28-Apr-2016.) $)
        dchrptlem1 $p |- ( ( ( ph /\ C e. U ) /\ ( M e. ZZ /\
      ( ( P ` I ) ` C ) = ( M .x. ( W ` I ) ) ) ) -> ( X ` C ) = ( T ^ M ) ) $=
          ( wcel wa cz cfv co wceq cv cexp wrex cio fveq2 eqeq1d anbi1d rexbidv
          iotabidv iotaex fvmpt3i ad2antlr cvv ovex simpr simpllr simprd eqtr3d
          wb wi simp-4l simplr simpld cmin cdivides wbr cgrp ccrg nnnn0d zncrng
          cn0 crg crngrng unitgrp 4syl adantr cc0 chash cfzo cword wrdf syl cdm
          wf fdm eleqtrd ffvelrnd simprl simprr c0g unitgrpbas odcong syl112anc
          eqid cmul cc wne c1 c2 neg1cn cr cn cfn sylancr a1i zcnd eqtrd eqeq2d
          caddc cneg cdiv ccxp 2re wss znfi ssfi sylancl odcl2 syl3anc ad2antrr
          unitss nndivre syl5eqel ax-1cn ax-1ne0 negne0i cxpne0d neeq1i expaddz
          recnd cxpcl sylibr zsubcl syl22anc npcand oveq2d oveq1i syl2an syl5eq
          root1eq1 biimpar oveq1d expclzd mulid2d 3eqtr3d ex sylbird mpd biimpd
          expimpd rexlimdva oveq1 oveq2 anbi12d rspcev expr adantl impbid iota5
          syl12anc mpan2 ) AEKVGZVHZTVIVGZESGVJZVJZTSUCVJZJVKZVLZVHZVHZEUDVJZUW
          ROVMZUWSJVKZVLZMVMZIUXEVNVKZVLZVHZOVIVOZMVPZITVNVKZUWNUXDUXMVLAUXBBEB
          VMZUWQVJZUXFVLZUXJVHZOVIVOZMVPUXMKUDUXOEVLZUXSUXLMUXTUXRUXKOVIUXTUXQU
          XGUXJUXTUXPUWRUXFUXOEUWQVQVRVSVTWAVFUXSMWBWCWDUXCUXNWEVGZUXMUXNVLITVN
          WFUXCUXLMUXNWEUXCUXLUXHUXNVLZWKUYAUXCUXLUYBUXCUXKUYBOVIUXCUXEVIVGZVHZ
          UXGUXJUYBUYDUXGVHZUXJUYBUYEUXIUXNUXHUYEUXFUWTVLZUXIUXNVLZUYEUWRUXFUWT
          UYDUXGWGUYEUWPUXAUWOUXBUYCUXGWHZWIWJUYEAUYCUWPUYFUYGWLAUWNUXBUYCUXGWM
          UXCUYCUXGWNUYEUWPUXAUYHWOAUYCUWPVHZVHZUYFUWSUBVJZUXETWPVKZWQWRZUYGUYJ
          RWSVGZUWSKVGZUYCUWPUYMUYFWKAUYNUYIAUAXCVGUEWTVGUEXDVGUYNAUAUKXAUAUEUG
          XBUEXEUEKRUMUNXFXGZXHAUYOUYIAXIUCXJVJXKVKZKSUCAUCKXLVGUYQKUCXPZURKUCX
          MXNZASUCXOZUYQVDAUYRUYTUYQVLUYSUYQKUCXQXNXRXSZXHAUYCUWPXTZAUYCUWPYAZU
          WSJRUXETUBKRYBVJZUEKRUMUNYCZVBUOVUDYFYDYEUYJUYMUYGUYJUYMVHZIUYLTUUAVK
          ZVNVKZIUYLVNVKZUXNYGVKZUXIUXNVUFIYHVGIXIYIZUYLVIVGZUWPVUHVUJVLVUFIYJU
          UBZYKUYKUUCVKZUUDVKZYHVCVUFVUMYHVGZVUNYHVGVUOYHVGYLVUFVUNVUFYKYMVGUYK
          YNVGZVUNYMVGUUEAVUQUYIUYMAUYNKYOVGZUYOVUQUYPADYOVGZKDUUFVURAUAYNVGVUS
          UKDUAUEUGUIUUGXNDUEKUIUMUUMDKUUHUUIVUAUWSRUBKVUEVBUUJUUKZUULYKUYKUUNY
          PUVBZVUMVUNUVCYPUUOZVUFVUOXIYIVUKVUFVUMVUNVUPVUFYLYQVUMXIYIVUFYJUUPUU
          QUURYQVVAUUSIVUOXIVCUUTUVDZUYIVULAUYMUXETUVEZWDUYJUWPUYMVUCXHZIUYLTUV
          AUVFVUFVUGUXEIVNVUFUXETVUFUXEUYJUYCUYMVUBXHYRVUFTVVEYRUVGUVHVUFVUJYJU
          XNYGVKUXNVUFVUIYJUXNYGVUFVUIVUOUYLVNVKZYJIVUOUYLVNVCUVIUYJVVFYJVLZUYM
          AVUQVULVVGUYMWKUYIVUTVVDUYLUYKUVLUVJUVMUVKUVNVUFUXNVUFITVVBVVCVVEUVOU
          VPYSUVQUVRUVSUWLUVTYTUWAUWBUWCUXBUYBUXLWLUWOUWPUXAUYBUXLUXKUXAUYBVHOT
          VIUXETVLZUXGUXAUXJUYBVVHUXFUWTUWRUXETUWSJUWDYTVVHUXIUXNUXHUXETIVNUWEY
          TUWFUWGUWHUWIUWJXHUWKUWMYS $.

        $( Lemma for ~ dchrpt .  (Contributed by Mario Carneiro,
           28-Apr-2016.) $)
        dchrptlem2 $p |- ( ph -> E. x e. D ( x ` A ) =/= 1 ) $=
          ( vv vy va vb cv wcel cfv cc0 cif cmpt c1 wne wrex cmulr co cur fveq2
          wa wceq cc cz crn cdprd wf cdm zex mptex rnex dmmpti dpjf feq2d mpbid
          a1i adantr oveq1 oveq2d fvmpt3i syl eleqtrd eqid ovex cexp dchrptlem1
          syl5eq c2 neg1cn cr cn cfn syl3anc sylancr ad2antrr simprl weq eqeq1d
          cmul rexbidv rspcv sylc syl22anc oveq12d cghm cress cvv eqeltri ax-mp
          simprr syl6eq cui fvex 3eqtr4d eqtrd wb syl2anc eqnetrd cbvmptv rneqd
          ffvelrnda mpteq2dv elrnmpti sylib cneg cdiv ccxp 2re cgrp ccrg nnnn0d
          crg cn0 zncrng crngrng 3syl unitgrp wss znfi unitss ssfi sylancl cfzo
          chash cword wrdf fdm ffvelrnd unitgrpbas odcl2 nndivre recnd syl5eqel
          cxpcl ax-1cn ax-1ne0 negne0i cxpne0d neeq1i expclzd eqeltrd rexlimddv
          sylibr ralrimiva eqeq2d cbvrexv syl6bb reeanv simprll simprlr expaddz
          wral caddc simpll unitmulcl zaddcld simprrl dpjghm cmgp ressid oveq1d
          simprrr cplusg mgpplusg ressplusg mulgdir syl13anc rexlimdvva syl5bir
          ghmlin expr mp2and id 1unit 0z c0g ghmid unitgrpid fveq2d mulg0 exp0d
          dchrelbasd sseldi eleq1 ifbieq12d c0ex ifex iftrue wi oveq1i cdivides
          eqidd wbr oddvds root1eq1 eqeq12d 3bitr4d necon3bid mpbird rexlimdvaa
          mpdan mpd fveq1 neeq1d rspcev ) AVFEVFVJZKVKZVUHUCVLZVMVNZVOZFVKDVULV
          LZVPVQZDBVJZVLZVPVQZBFVRABVGVUOUCVLZEVGVJZUCVLZFKVFVUOVUSUDVSVLZVTZUC
          VLZQTVUJUDWAVLZUCVLZUDUEUFUHULUJUGVUHVUOUCWBVUHVUSUCWBVUHVVBUCWBVUHVV
          DUCWBAVUIWCZVUHSGVLZVLZVHVJZSUBVLZJVTZWDZVUJWEVKVHWFVVFVVHVHWFVVKVOZW
          GZVKVVLVHWFVRZVVFVVHSHVLZVVNAKVVPVUHVVGARHWHVTZVVPVVGWIKVVPVVGWIAGHRU
          BWJZSURHWJVVRWDANVVRPWFPVJZNVJZUBVLZJVTZVOZWGZHVWCPWFVWBWKWLWMZUOWNWR
          ZUTVCWOAVVQKVVPVVGUSWPWQUUCVVFSVVRVKZVVPVVNWDAVWGVUIVCWSNSVWDVVNVVRHV
          VTSWDZVWCVVMVWHVWCVHWFVVIVWAJVTZVOVVMPVHWFVWBVWIVVSVVIVWAJWTUUAVWHVHW
          FVWIVVKVWHVWAVVJVVIJVVTSUBWBXAUUDXIUUBUOVWEXBXCXDVHWFVVKVVHVVMVVMXEVV
          IVVJJXFUUEUUFZVVFVVIWFVKZVVLWCZWCZVUJIVVIXGVTZWEACDEVUHFGHIJKLMNOPQRS
          VVITUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEXHVWMIVVIAIWEVK
          ZVUIVWLAIVPUUGZXJVVJUAVLZUUHVTZUUIVTZWEVBAVWPWEVKZVWRWEVKVWSWEVKXKAVW
          RAXJXLVKVWQXMVKZVWRXLVKUUJARUUKVKZKXNVKZVVJKVKZVXAAUDUUNVKZVXBATUUOVK
          UDUULVKVXEATUJUUMTUDUFUUPUDUUQUURZUDKRULUMUUSXCZAEXNVKZKEUUTVXCATXMVK
          VXHUJETUDUFUHUVAXCEUDKUHULUVBZEKUVCUVDAVMUBUVFVLUVEVTZKSUBAUBKUVGVKVX
          JKUBWIZUQKUBUVHXCZASVVRVXJVCAVXKVVRVXJWDVXLVXJKUBUVIXCXDUVJZVVJRUAKUD
          KRULUMUVKZVAUVLXOZXJVWQUVMXPUVNZVWPVWRUVPXPUVOZXQAIVMVQZVUIVWLAVWSVMV
          QVXRAVWPVWRVWTAXKWRVWPVMVQAVPUVQUVRUVSWRVXPUVTIVWSVMVBUWAUWEZXQVVFVWK
          VVLXRUWBUWCUWDAVUOKVKZVUSKVKZWCZWCZVUOVVGVLZVVKWDZVHWFVRZVUSVVGVLZVIV
          JZVVJJVTZWDZVIWFVRZVVCVURVUTYAVTZWDZVYCVXTVVOVFKUWNZVYFAVXTVYAXRZAVYN
          VYBAVVOVFKVWJUWFZWSZVVOVYFVFVUOKVFBXSZVVLVYEVHWFVYRVVHVYDVVKVUHVUOVVG
          WBXTYBYCYDVYCVYAVYNVYKAVXTVYAYLZVYQVVOVYKVFVUSKVFVGXSZVVOVYGVVKWDZVHW
          FVRVYKVYTVVLWUAVHWFVYTVVHVYGVVKVUHVUSVVGWBXTYBWUAVYJVHVIWFVHVIXSVVKVY
          IVYGVVIVYHVVJJWTUWGUWHUWIYCYDVYFVYKWCVYEVYJWCZVIWFVRVHWFVRVYCVYMVYEVY
          JVHVIWFWFUWJVYCWUBVYMVHVIWFWFVYCVWKVYHWFVKZWCZWUBVYMVYCWUDWUBWCZWCZIV
          VIVYHUWOVTZXGVTZVWNIVYHXGVTZYAVTZVVCVYLWUFVWOVXRVWKWUCWUHWUJWDAVWOVYB
          WUEVXQXQAVXRVYBWUEVXSXQVYCVWKWUCWUBUWKZVYCVWKWUCWUBUWLZIVVIVYHUWMYEWU
          FAVVBKVKZWUGWFVKVVBVVGVLZWUGVVJJVTZWDVVCWUHWDAVYBWUEUWPZWUFVXEVXTVYAW
          UMAVXEVYBWUEVXFXQVYCVXTWUEVYOWSZVYCVYAWUEVYSWSZUDVVAKVUOVUSULVVAXEZUW
          QXOWUFVVIVYHWUKWULUWRWUFVYDVYGVVAVTZVVKVYIVVAVTZWUNWUOWUFVYDVVKVYGVYI
          VVAVYCWUDVYEVYJUWSZVYCWUDVYEVYJUXDZYFWUFVVGRRYGVTZVKZVXTVYAWUNWUTWDAW
          VEVYBWUEAVVGRVVQYHVTZRYGVTWVDAGHRVVRSURVWFUTVCUWTAWVFRRYGAWVFRKYHVTZR
          AVVQKRYHUSXARYIVKWVGRWDRUDUXAVLZKYHVTYIUMWVHKYHXFYJKRYIVXNUXBYKYMUXCX
          DZXQWUQWURVVAVVARRVUOVVGVUSKVXNKYIVKVVARUXEVLWDKUDYNVLYIULUDYNYOYJKVV
          AWVHRYIUMUDVVAWVHWVHXEWUSUXFUXGYKZWVJUXLXOWUFVXBVWKWUCVXDWUOWVAWDAVXB
          VYBWUEVXGXQWUKWULAVXDVYBWUEVXMXQKVVAJRVVIVYHVVJVXNUNWVJUXHUXIYPACDEVV
          BFGHIJKLMNOPQRSWUGTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVE
          XHYEWUFVURVWNVUTWUIYAWUFAVXTVWKVYEVURVWNWDWUPWUQWUKWVBACDEVUOFGHIJKLM
          NOPQRSVVITUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEXHYEWUFAV
          YAWUCVYJVUTWUIWDWUPWURWULWVCACDEVUSFGHIJKLMNOPQRSVYHTUAUBUCUDUEUFUGUH
          UIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEXHYEYFYPUXMUXJUXKUXNAVVEIVMXGVTZVPA
          AVVDKVKZVMWFVKZVVDVVGVLZVMVVJJVTZWDVVEWVKWDAUXOAVXEWVLVXFUDKVVDULVVDX
          EZUXPXCWVMAUXQWRARUXRVLZVVGVLZWVQWVNWVOAWVEWVRWVQWDWVIRRVVGWVQWVQWVQX
          EZWVSUXSXCAVVDWVQVVGAVXEVVDWVQWDVXFUDKVVDRULUMWVPUXTXCZUYAAVXDWVOWVQW
          DVXMKJRVVJWVQVXNWVSUNUYBXCYPACDEVVDFGHIJKLMNOPQRSVMTUAUBUCUDUEUFUGUHU
          IUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEXHYEAIVXQUYCYQUYDAVUMDUCVLZVPAVUMDKV
          KZWWAVMVNZWWAADEVKVUMWWCWDAKEDVXIUPUYEVFDVUKWWCEVULVUHDWDZVUIWWBVUJVM
          WWAVMVUHDKUYFVUHDUCWBWWDVMUYNUYGVULXEVUIVUJVMVUHUCYOUYHUYIXBXCAWWBWWC
          WWAWDUPWWBWWAVMUYJXCYQADVVGVLZVVKWDZVHWFVRZWWAVPVQZAWWBVYNWWGUPVYPVVO
          WWGVFDKWWDVVLWWFVHWFWWDVVHWWEVVKVUHDVVGWBXTYBYCYDAWWBWWGWWHUYKUPAWWBW
          CZWWFWWHVHWFWWIVWKWWFWCZWCZWWAVWSVVIXGVTZVPWWKWWAVWNWWLACDEDFGHIJKLMN
          OPQRSVVITUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEXHIVWSVVIX
          GVBUYLYMWWKWWLVPVQWWELVQZAWWMWWBWWJVDXQWWKWWLVPWWELWWKVWQVVIUYMUYOZVV
          KWVQWDZWWLVPWDZWWELWDWWKVXBVXDVWKWWNWWOYRAVXBWWBWWJVXGXQAVXDWWBWWJVXM
          XQWWIVWKWWFXRZVVJJRVVIUAKWVQVXNVAUNWVSUYPXOWWKVXAVWKWWPWWNYRAVXAWWBWW
          JVXOXQWWQVVIVWQUYQYSWWKWWEVVKLWVQWWIVWKWWFYLALWVQWDWWBWWJALVVDWVQUIWV
          TXIXQUYRUYSUYTVUAYTVUBVUCVUDYTVUQVUNBVULFVUOVULWDVUPVUMVPDVUOVULVUEVU
          FVUGYS $.
      $}

      $( Lemma for ~ dchrpt .  (Contributed by Mario Carneiro, 28-Apr-2016.) $)
      dchrptlem3 $p |- ( ph -> E. x e. D ( x ` A ) =/= 1 ) $=
        ( va vh vi vu vm cv cdpj co cfv wceq wn cdm wrex wne wral cmpt cgsu c0g
        c1 cmnd wcel cvv cgrp crg ccrg cn0 nnnn0d zncrng crngrng unitgrp grpmnd
        syl cword dmexg eqid syl2anc unitgrpid mpteq2dv oveq2d 3eqtr4d neeqtrrd
        gsumz ccnv csn cdif cima cfn cixp crab cz crn zex mptex rnex dmmpti a1i
        cdprd eleqtrrd wa adantr csubg dprdf2 ffvelrnda subg0cl eqeltrd c0 0fin
        wss suppss2 ssfi dprdwd dpjeq necon3abid mpbid rexnal sylibr df-ne cneg
        sylancr c2 cod cdiv ccxp cexp cio cn wbr simprl simprr expr syl5bir mpd
        dchrptlem2 rexlimdva ) ACULUQZMFURUSZUTZUTZIVAZVBZULOVCZVDZCBUQUTVJVEBE
        VDZAUUJULUULVFZVBZUUMACMULUULIVGZVHUSZVEUUPACIUURUCAMULUULMVIUTZVGZVHUS
        ZUUSUURIAMVKVLZUULVMVLZUVAUUSVAAMVNVLZUVBAPVOVLZUVDAPVPVLZUVEANVQVLUVFA
        NUBVRNPRVSWCPVTWCZPHMUDUEWAWCMWBWCAOHWDZVLZUVCUIOUVHWEWCUULULMVMUUSUUSW
        FZWMWGAUUQUUTMVHAULUULIUUSAUVEIUUSVAZUVGPHIMUDUEUAWHWCZWIWJUVLWKWLAUUOC
        UURAULCIUUGFUMUNMUULUMUQZWNVMUUSWOWPZWQWRVLUMUNUULUNUQFUTWSWTZUUSUJFVCU
        ULVAAJUULKXAKUQJUQOUTGUSZVGZXBFUVQKXAUVPXCXDXEUGXFXGZUUGWFZACHMFXHUSZUH
        UKXIUVJUVOWFZAULIFUMUNMUULUVOUUSUWAUJUVRAUUFUULVLZXJZIUUSUUFFUTZAUVKUWB
        UVLXKUWCUWDMXLUTZVLUUSUWDVLAUULUWEUUFFAFMUULUJUVRXMXNUWDMUUSUVJXOWCXPAX
        QWRVLUUQWNUVNWQZXQXSUWFWRVLXRAUULIULXQUUSAUVKUUFUULXQWPVLUVLXKXTXQUWFYA
        YJYBYCYDYEUUJULUULYFYGAUUKUUNULUULUUKUUIIVEZUWCUUNUUIIYHAUWBUWGUUNAUWBU
        WGXJZXJBUOCDEUUGFVJYIYKUUFOUTZMYLUTZUTYMUSYNUSZGHIUMJUPKLMUUFNUWJOUOHUO
        UQUUHUTUPUQZUWIGUSVAUVMUWKUWLYOUSVAXJUPXAVDUMYPVGZPQRSTUAANYQVLUWHUBXKA
        CIVEUWHUCXKUDUEUFUGACHVLUWHUHXKAUVIUWHUIXKAMFXHVCYRUWHUJXKAUVTHVAUWHUKX
        KUVSUWJWFUWKWFAUWBUWGYSAUWBUWGYTUWMWFUUDUUAUUBUUEUUC $.
    $}

    dchrpt.a $e |- ( ph -> A e. B ) $.
    $( For any element other than 1, there is a Dirichlet character that is not
       one at the given element.  (Contributed by Mario Carneiro,
       28-Apr-2016.) $)
    dchrpt $p |- ( ph -> E. x e. D ( x ` A ) =/= 1 ) $=
      ( cfv wcel cv vw vu vk vn va vb cui c1 wne wrex wa cdm cmgp cress co ccyg
      cpgp crn cin csubg crab cz cmg cmpt wf cdprd wbr wceq w3a eqid unitgrpbas
      cword cabel cn0 ccrg nnnn0d zncrng unitabl 3syl adantr cfn cn znfi unitss
      wss syl ssfi sylancl ablfac2 ad3antrrr oveq1 fveq2 oveq2d mpteq2dv syl5eq
      cbvmptv simpllr simplr simprl simprr dchrptlem3 3adantr1 ex rexlimdva mpd
      rneqd wn c0g cgrp dchrabl ablgrp grpidcl ax-1ne0 necomi dchrn0 necon1bbid
      4syl cc0 biimpa neeq1d mpbiri fveq1 rspcev syl2anc pm2.61dan ) ACIUGRZSZC
      BTZRZUHUIZBEUJZAYGUKZUATZULZIUMRYFUNUOZUBTUNUOUPUQURUSSUBYOUTRVAZUCYNUDVB
      UDTZUCTZYMRZYOVCRZUOZVDZURZVDZVEZYOUUDVFULVGZYOUUDVFUOYFVHZVIZUAYFVLZUJYK
      YLUAYFYPUUDYTUCUDYOUBIYFYOYFVJZYOVJZVKYPVJAYOVMSZYGAHVNSIVOSUULAHOVPHIKVQ
      IYFYOUUJUUKVRVSVTAYFWASZYGADWASZYFDWEUUMAHWBSZUUNODHIKMWCWFDIYFMUUJWDDYFW
      GWHVTYTVJZUUDVJWIYLUUHYKUAUUIYLYMUUISZUKZUUHYKUURUUFUUGYKUUEUURUUFUUGUKZU
      KBCDEUUDYTYFFUEUFGYOHYMIJKLMNAUUOYGUUQUUSOWJACFUIYGUUQUUSPWJUUJUUKUUPUCUE
      YNUUCUFVBUFTZUETZYMRZYTUOZVDZURYRUVAVHZUUBUVDUVEUUBUFVBUUTYSYTUOZVDUVDUDU
      FVBUUAUVFYQUUTYSYTWKWPUVEUFVBUVFUVCUVEYSUVBUUTYTYRUVAYMWLWMWNWOXFWPAYGUUQ
      UUSWQYLUUQUUSWRUURUUFUUGWSUURUUFUUGWTXAXBXCXDXEAYGXGZUKZGXHRZESZCUVIRZUHU
      IZYKAUVJUVGAUUOGVMSGXISUVJOGHJXJGXKEGUVILUVIVJXLXQZVTUVHUVLXRUHUIUHXRXMXN
      UVHUVKXRUHAUVGUVKXRVHAYGUVKXRACDEYFGHUVIIJKLMUUJUVMQXOXPXSXTYAYJUVLBUVIEY
      HUVIVHYIUVKUHCYHUVIYBXTYCYDYE $.
  $}

  ${
    $d a k .1. $.  $d a B $.  $d a k x ph $.  $d a b c k x U $.  $d a k x X $.
    $d a b c k x Z $.
    dchrsum.g $e |- G = ( DChr ` N ) $.
    dchrsum.z $e |- Z = ( Z/nZ ` N ) $.
    dchrsum.d $e |- D = ( Base ` G ) $.
    dchrsum.1 $e |- .1. = ( 0g ` G ) $.
    dchrsum.x $e |- ( ph -> X e. D ) $.
    ${
      dchrsum2.u $e |- U = ( Unit ` Z ) $.
      $( An orthogonality relation for Dirichlet characters: the sum of all the
         values of a Dirichlet character ` X ` is ` 0 ` if ` X ` is
         non-principal and ` phi ( n ) ` otherwise.  Part of Theorem 6.5.1 of
         [Shapiro] p. 230.  (Contributed by Mario Carneiro, 28-Apr-2016.) $)
      dchrsum2 $p |- ( ph ->
        sum_ a e. U ( X ` a ) = if ( X = .1. , ( phi ` N ) , 0 ) ) $=
        ( wceq cfv c1 wcel co vk vx vb vc cv csu cphi cc0 cif eqeq2 wa fveq1 cn
        dchrrcl syl adantr simpr dchr1 sylan9eqr an32s sumeq2dv cmul cfn cc cn0
        chash znunithash phicld nnnn0d eqeltrd cvv wb cui eqeltri hashclb ax-mp
        fvex sylibr ax-1cn fsumconst sylancl oveq1d nncnd mulid1d eqtrd wn wrex
        3eqtrd wral cabel cgrp dchrabl ablgrp grpidcl 4syl dchreq notbid rexnal
        syl6bbr wne df-ne neeq2d cmin wf eqid dchrf unitss sseli ffvelrn syl2an
        cbs adantlr fsumcl simprl sseldi ffvelrnd subcl simprr subeq0 necon3bid
        0cn mpbird cmulr oveq2 fveq2d cbvsumv cmgp ccnfld cmhm dchrmhm ad2antrr
        a1i adantl mgpbas mgpplusg cnfldmul mhmlin syl3anc cmpt sylbid wf1o crg
        syl5eq fveq2 cress ccrg crngrng unitgrp unitgrpbas ressplusg grplactf1o
        zncrng cplusg syl2anc grplactval sylan fsumf1o 3eqtr4rd mulid2d oveq12d
        fsummulc2 subidd subdird mul01d 3eqtr4d mulcanad expr syl5bir rexlimdva
        imp ifbothda ) GDPZCIUEZGQZIUFZFUGQZPUVOUHPZUVOUVLUVPUHUIZPAUVPUHUVPUVR
        UVOUJUHUVRUVOUJAUVLUKZUVOCRIUFZUVPUVSCUVNRIAUVMCSZUVLUVNRPUVLAUWAUKZUVN
        UVMDQRUVMGDULUWBUVMCDEFHJKMOAFUMSZUWAAGBSUWCNBEFGJLUNUOZUPAUWAUQURUSUTV
        AAUVTUVPPUVLAUVTCVFQZRVBTZUVPRVBTUVPACVCSZRVDSZUVTUWFPAUWEVESZUWGAUWEUV
        PVEAUWCUWEUVPPUWDCFHKOVGUOZAUVPAFUWDVHZVIVJCVKSZUWGUWIVLCHVMQVKOHVMVQVN
        ZCVKVOVPVRZVSCRIVTWAAUWEUVPRVBUWJWBAUVPAUVPUWKWCWDWHUPWEAUVLWFZUVQAUWOU
        AUEZGQZUWPDQZPZWFZUACWGZUVQAUWOUWSUACWIZWFUXAAUVLUXBABCUAEFGDHJKLONAUWC
        EWJSEWKSDBSUWDEFJWLEWMBEDLMWNWOWPWQUWSUACWRWSAUWTUVQUACUWTUWQUWRWTZAUWP
        CSZUKZUVQUWQUWRXAUXEUXCUWQRWTZUVQUXEUWRRUWQUXEUWPCDEFHJKMOAUWCUXDUWDUPA
        UXDUQURXBAUXDUXFUVQAUXDUXFUKZUKZUVOUHUWQRXCTZUXHCUVNIAUWGUXGUWNUPZAUWAU
        VNVDSZUXGAHXKQZVDGXDZUVMUXLSZUXKUWAAUXLBEFGHJKLUXLXEZNXFZCUXLUVMUXLHCUX
        OOXGZXHZUXLVDUVMGXIXJXLZXMZUHVDSUXHYAYLUXHUWQVDSZUWHUXIVDSUXHUXLVDUWPGA
        UXMUXGUXPUPUXHCUXLUWPUXQAUXDUXFXNZXOZXPZVSUWQRXQWAZUXHUXIUHWTUXFAUXDUXF
        XRUXHUXIUHUWQRUXHUYAUWHUXIUHPUWQRPVLUYDVSUWQRXSWAXTYBUXHUWQUVOVBTZRUVOV
        BTZXCTZUHUXIUVOVBTUXIUHVBTUXHUYHUVOUVOXCTUHUXHUYFUVOUYGUVOXCUXHCUWPUBUE
        ZHYCQZTZGQZUBUFZCUWQUVNVBTZIUFZUVOUYFUXHUYMCUWPUVMUYJTZGQZIUFUYOCUYLUYQ
        UBIUYIUVMPUYKUYPGUYIUVMUWPUYJYDYEYFUXHCUYQUYNIUXHUWAUKGHYGQZYHYGQZYITZS
        ZUWPUXLSZUXNUYQUYNPAVUAUXGUWAABUYTGBEFHJKLYJNXOYKUXHVUBUWAUYCUPUWAUXNUX
        HUXRYMUXLUYJVBUYRUYSGUWPUVMUXLHUYRUYRXEZUXOYNHUYJUYRVUCUYJXEYOZYHVBUYSU
        YSXEYPYOYQYRVAUUCUXHCUVNCUYLIUBUWPUCCUDCUCUEUDUEUYJTYSYSZQZUYKUVMUYKGUU
        DUXJUXHUYRCUUETZWKSZUXDCCVUFUUAAVUHUXGAFVESHUUFSHUUBSVUHAFUWDVIFHKUULHU
        UGHCVUGOVUGXEZUUHWOUPUYBUWPUYJUCVUEVUGCUDVUEXEZHCVUGOVUIUUIZUWLUYJVUGUU
        MQPUWMCUYJUYRVUGVKVUIVUDUUJVPUUKUUNUXHUXDUYICSUYIVUFQUYKPUYBUWPUYIUYJUC
        VUEVUGCUDVUJVUKUUOUUPUXSUUQUXHCUVNUWQIUXJUYDUXSUVAUURUXHUVOUXTUUSUUTUXH
        UVOUXTUVBWEUXHUWQRUVOUYDUWHUXHVSYLUXTUVCUXHUXIUYEUVDUVEUVFUVGYTUVHUVIYT
        UVJUVK $.
    $}

    dchrsum.b $e |- B = ( Base ` Z ) $.
    $( An orthogonality relation for Dirichlet characters: the sum of all the
       values of a Dirichlet character ` X ` is ` 0 ` if ` X ` is non-principal
       and ` phi ( n ) ` otherwise.  Part of Theorem 6.5.1 of [Shapiro]
       p. 230.  (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    dchrsum $p |- ( ph ->
      sum_ a e. B ( X ` a ) = if ( X = .1. , ( phi ` N ) , 0 ) ) $=
      ( cfv csu cc0 cc wcel cui cv wceq cphi cif wss eqid unitss wf dchrf sseli
      a1i ffvelrn syl2an cdif wn wa eldif wne adantr simpr dchrn0 necon1bd impr
      biimpd sylan2b cn cfn dchrrcl znfi 3syl fsumss dchrsum2 eqtr3d ) AHUAPZIU
      BZGPZIQBVQIQGDUCFUDPRUEAVOBVQIVOBUFABHVOOVOUGZUHZULABSGUIVPBTZVQSTVPVOTZA
      BCEFGHJKLONUJVOBVPVSUKBSVPGUMUNVPBVOUOTAVTWAUPZUQVQRUCZVPBVOURAVTWBWCAVTU
      QZWAVQRWDVQRUSWAWDVPBCVOEFGHJKLOVRAGCTZVTNUTAVTVAVBVEVCVDVFAWEFVGTBVHTNCE
      FGJLVIBFHKOVJVKVLACVODEFGHIJKLMNVRVMVN $.
  $}

  ${
    $d x y z .1. $.  $d x y z A $.  $d y B $.  $d a b x y z D $.  $d a x y N $.
    $d a b x y z G $.  $d x y z ph $.  $d y Z $.
    sumdchr.g $e |- G = ( DChr ` N ) $.
    sumdchr.d $e |- D = ( Base ` G ) $.
    ${
      sumdchr2.z $e |- Z = ( Z/nZ ` N ) $.
      sumdchr2.1 $e |- .1. = ( 1r ` Z ) $.
      sumdchr2.b $e |- B = ( Base ` Z ) $.
      sumdchr2.n $e |- ( ph -> N e. NN ) $.
      sumdchr2.x $e |- ( ph -> A e. B ) $.
      $( Lemma for ~ sumdchr .  (Contributed by Mario Carneiro,
         28-Apr-2016.) $)
      sumdchr2 $p |- ( ph ->
        sum_ x e. D ( x ` A ) = if ( A = .1. , ( # ` D ) , 0 ) ) $=
        ( wceq c1 wcel co vy vz va vb cv cfv csu chash cc0 cif eqeq2 fveq2 cmgp
        wa ccnfld cmhm dchrmhm simpr sseldi eqid rngidval cnfld1 mhm0 sylan9eqr
        syl an32s sumeq2dv cfn cc cn dchrfi ax-1cn fsumconst sylancl cn0 hashcl
        cmul 3syl nn0cnd mulid1d eqtrd adantr wn wne df-ne dchrpt cmin ffvelrnd
        dchrf fsumcl 0cn a1i simprl subcl simprr subeq0 necon3bid mpbird cplusg
        wb oveq2 fveq1d cbvsumv cof dchrmul wfn cvv ffn cbs fvex eqeltri fnfvof
        wf syl22anc syl5eq cmpt fveq1 cgrp wf1o cabel dchrabl ablgrp grplactf1o
        syl2anc sylan fsumf1o fsummulc2 3eqtr4rd mulid2d oveq12d subidd subdird
        grplactval mul01d 3eqtr4d mulcanad rexlimddv sylan2br ifbothda ) CFQZEC
        BUEZUFZBUGZEUHUFZQUUCUIQZUUCYTUUDUIUJZQAUUDUIUUDUUFUUCUKUIUUFUUCUKAYTUN
        ZUUCERBUGZUUDUUGEUUBRBAUUAESZYTUUBRQYTAUUIUNZUUBFUUAUFZRCFUUAULUUJUUAIU
        MUFZUOUMUFZUPTZSUUKRQUUJEUUNUUAEGHIJLKUQAUUIURUSUULUUMUUARFIFUULUULUTMV
        AUORUUMUUMUTVBVAVCVEVDVFVGAUUHUUDQYTAUUHUUDRVQTZUUDAEVHSZRVISZUUHUUOQAH
        VJSZUUPOEGHJKVKZVEVLERBVMVNAUUDAUUDAUURUUPUUDVOSOUUSEVPVRVSVTWAWBWAYTWC
        ACFWDZUUECFWEAUUTUNZCUAUEZUFZRWDZUUEUAEUVAUACDEFGHIJLKNMAUURUUTOWBZAUUT
        URACDSZUUTPWBZWFUVAUVBESZUVDUNZUNZUUCUIUVCRWGTZUVJEUUBBUVJUURUUPUVAUURU
        VIUVEWBZUUSVEZUVJUUIUNZDVICUUAUVNDEGHUUAIJLKNUVJUUIURZWIZUVJUVFUUIUVAUV
        FUVIUVGWBZWBZWHZWJZUIVISUVJWKWLUVJUVCVISZUUQUVKVISUVJDVICUVBUVJDEGHUVBI
        JLKNUVAUVHUVDWMZWIZUVQWHZVLUVCRWNVNZUVJUVKUIWDUVDUVAUVHUVDWOUVJUVKUIUVC
        RUVJUWAUUQUVKUIQUVCRQWTUWDVLUVCRWPVNWQWRUVJUVCUUCVQTZRUUCVQTZWGTZUIUVKU
        UCVQTUVKUIVQTUVJUWHUUCUUCWGTUIUVJUWFUUCUWGUUCWGUVJECUVBUBUEZGWSUFZTZUFZ
        UBUGZEUVCUUBVQTZBUGZUUCUWFUVJUWMECUVBUUAUWJTZUFZBUGUWOEUWLUWQUBBUWIUUAQ
        CUWKUWPUWIUUAUVBUWJXAXBXCUVJEUWQUWNBUVNUWQCUVBUUAVQXDTZUFZUWNUVNCUWPUWR
        UVNEUWJGHUVBUUAIJLKUWJUTZUVJUVHUUIUWBWBUVOXEXBUVNUVBDXFZUUADXFZDXGSZUVF
        UWSUWNQUVNDVIUVBXMZUXAUVJUXDUUIUWCWBDVIUVBXHVEUVNDVIUUAXMUXBUVPDVIUUAXH
        VEUXCUVNDIXIUFXGNIXIXJXKWLUVRDVQUVBUUAXGCXLXNWAVGXOUVJEUUBEUWLBUBUVBUCE
        UDEUCUEUDUEUWJTXPXPZUFZUWKCUUAUWKXQUVMUVJGXRSZUVHEEUXFXSUVJUURGXTSUXGUV
        LGHJYAGYBVRUWBUVBUWJUCUXEGEUDUXEUTZKUWTYCYDUVJUVHUWIESUWIUXFUFUWKQUWBUV
        BUWIUWJUCUXEGEUDUXHKYMYEUVSYFUVJEUUBUVCBUVMUWDUVSYGYHUVJUUCUVTYIYJUVJUU
        CUVTYKWAUVJUVCRUUCUWDUUQUVJVLWLUVTYLUVJUVKUWEYNYOYPYQYRYS $.
    $}

    $( There are exactly ` phi ( N ) ` Dirichlet characters modulo ` N ` .
       Part of Theorem 6.5.1 of [Shapiro] p. 230.  (Contributed by Mario
       Carneiro, 28-Apr-2016.) $)
    dchrhash $p |- ( N e. NN -> ( # ` D ) = ( phi ` N ) ) $=
      ( va vx wcel cfv csn csu cv cc0 cif eqid wa cc wceq simpr wss czn cur c0g
      cn chash cphi cbs znfi dchrfi simprr dchrf simprl ffvelrnd simpl sumdchr2
      fsumcom wb elsn ifbi mp1i eqtr4d sumeq2dv dchrsum 3eqtr3d wral cuz cfn wo
      cn0 ccrg crg nnnn0 zncrng crngrng rngidcl 4syl snssd nn0cn 3syl ralrimivw
      hashcl olcd sumss2 syl21anc cabel cgrp dchrabl ablgrp grpidcl phicl nncnd
      3eqtr4d eqidd sumsn syl2anc ) CUDHZCUAIZUBIZJZAUEIZFKZBUCIZJZCUFIZGKZWTXD
      WPWQUGIZFLZWSHZWTMNZFKZAGLZXCHZXDMNZGKZXAXEWPXFAXGXKIZGKZFKAXFXOFKZGKXJXN
      WPXFAXOFGXFCWQWQOZXFOZUHZABCDEUIZWPXGXFHZXKAHZPPZXFQXGXKYDXFABCXKWQDXREXS
      WPYBYCUJUKWPYBYCULUMUPWPXFXPXIFWPYBPZXPXGWRRZWTMNZXIYEGXGXFAWRBCWQDEXRWRO
      ZXSWPYBUNWPYBSUOXHYFUQXIYGRYEFWRURXHYFWTMUSUTVAVBWPAXQXMGWPYCPZXQXKXBRZXD
      MNZXMYIXFAXBBCXKWQFDXREXBOZWPYCSXSVCXLYJUQXMYKRYIGXBURXLYJXDMUSUTVAVBVDWP
      WSXFTWTQHZFWSVEXFMVFIZTZXFVGHZVHXAXJRWPWRXFWPCVIHWQVJHWQVKHWRXFHZCVLCWQXR
      VMWQVNXFWQWRXSYHVOVPZVQWPYMFWSWPAVGHZWTVIHYMYAAWAWTVRVSZVTWPYPYOXTWBWSXFW
      TFMWCWDWPXCATXDQHZGXCVEAYNTZYSVHXEXNRWPXBAWPBWEHBWFHXBAHZBCDWGBWHABXBEYLW
      IVSZVQWPUUAGXCWPXDCWJWKZVTWPYSUUBYAWBXCAXDGMWCWDWLWPYQYMXAWTRYRYTWTWTFWRX
      FYFWTWMWNWOWPUUCUUAXEXDRUUDUUEXDXDGXBAYJXDWMWNWOVD $.

    sumdchr.z $e |- Z = ( Z/nZ ` N ) $.
    sumdchr.1 $e |- .1. = ( 1r ` Z ) $.
    sumdchr.b $e |- B = ( Base ` Z ) $.
    sumdchr.n $e |- ( ph -> N e. NN ) $.
    sumdchr.a $e |- ( ph -> A e. B ) $.
    $( An orthogonality relation for Dirichlet characters: the sum of
       ` x ( A ) ` for fixed ` A ` and all ` x ` is ` 0 ` if ` A = 1 ` and
       ` phi ( n ) ` otherwise.  Theorem 6.5.1 of [Shapiro] p. 230.
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    sumdchr $p |- ( ph ->
      sum_ x e. D ( x ` A ) = if ( A = .1. , ( phi ` N ) , 0 ) ) $=
      ( cfv wceq cc0 cif cv csu chash cphi sumdchr2 cn wcel dchrhash syl ifeq1d
      eqtrd ) AECBUAQBUBCFRZEUCQZSTULHUDQZSTABCDEFGHIJKLMNOPUEAULUMUNSAHUFUGUMU
      NROEGHJKUHUIUJUK $.
  $}

  ${
    $d a B $.  $d a G $.  $d a ph $.  $d a X $.  $d a Y $.  $d a Z $.
    dchr2sum.g $e |- G = ( DChr ` N ) $.
    dchr2sum.z $e |- Z = ( Z/nZ ` N ) $.
    dchr2sum.d $e |- D = ( Base ` G ) $.
    dchr2sum.b $e |- B = ( Base ` Z ) $.
    dchr2sum.x $e |- ( ph -> X e. D ) $.
    dchr2sum.y $e |- ( ph -> Y e. D ) $.
    $( An orthogonality relation for Dirichlet characters: the sum of
       ` X ( a ) x. * Y ( a ) ` over all ` a ` is nonzero only when
       ` X = Y ` .  Part of Theorem 6.5.2 of [Shapiro] p. 232.  (Contributed by
       Mario Carneiro, 28-Apr-2016.) $)
    dchr2sum $p |- ( ph -> sum_ a e. B ( ( X ` a ) x. ( * ` ( Y ` a ) ) ) =
      if ( X = Y , ( phi ` N ) , 0 ) ) $=
      ( cfv co wceq wcel cc cv csg csu c0g cphi cc0 cif cmul eqid cgrp cn cabel
      ccj dchrrcl syl dchrabl ablgrp grpsubcl syl3anc dchrsum wa cminusg cplusg
      3syl cof adantr grpsubval syl2anc grpinvcl dchrmul eqtrd fveq1d wfn dchrf
      cvv wf ffn cbs fvex eqeltri a1i simpr fnfvof syl22anc ccom dchrinv oveq2d
      fvco3 3eqtrd sumeq2dv wb grpsubeq0 ifbid 3eqtr3d ) ABIUAZFGDUBPZQZPZIUCWQ
      DUDPZRZEUEPZUFUGBWOFPZWOGPUMPZUHQZIUCFGRZXAUFUGABCWSDEWQHIJKLWSUIZADUJSZF
      CSZGCSZWQCSAEUKSZDULSZXGAXHXJNCDEFJLUNUOZDEJUPZDUQZVDZNOCDWPFGLWPUIZURUSM
      UTABWRXDIAWOBSZVAZWRWOFGDVBPZPZUHVEQZPZXBWOXTPZUHQZXDXRWOWQYAXRWQFXTDVCPZ
      QZYAXRXHXIWQYFRAXHXQNVFZAXIXQOVFZCYEDXSWPFGLYEUIZXSUIZXPVGVHXRCYEDEFXTHJK
      LYIYGXRXGXIXTCSXRXJXKXGAXJXQXLVFXMXNVDYHCDXSGLYJVIVHZVJVKVLXRFBVMZXTBVMZB
      VOSZXQYBYDRXRBTFVPYLXRBCDEFHJKLMYGVNBTFVQUOXRBTXTVPYMXRBCDEXTHJKLMYKVNBTX
      TVQUOYNXRBHVRPVOMHVRVSVTWAAXQWBZBUHFXTVOWOWCWDXRYCXCXBUHXRYCWOUMGWEZPZXCX
      RWOXTYPXRCDXSEGJLYHYJWFVLXRBTGVPXQYQXCRXRBCDEGHJKLMYHVNYOBTWOUMGWHVHVKWGW
      IWJAWTXEXAUFAXGXHXIWTXEWKXONOCDWPFGWSLXFXPWLUSWMWN $.
  $}

  ${
    $d x A $.  $d x C $.  $d x D $.  $d x G $.  $d x N $.  $d x ph $.
    $d x Z $.
    sum2dchr.g $e |- G = ( DChr ` N ) $.
    sum2dchr.d $e |- D = ( Base ` G ) $.
    sum2dchr.z $e |- Z = ( Z/nZ ` N ) $.
    sum2dchr.b $e |- B = ( Base ` Z ) $.
    sum2dchr.u $e |- U = ( Unit ` Z ) $.
    sum2dchr.n $e |- ( ph -> N e. NN ) $.
    sum2dchr.a $e |- ( ph -> A e. B ) $.
    sum2dchr.c $e |- ( ph -> C e. U ) $.
    $( An orthogonality relation for Dirichlet characters: the sum of
       ` x ( A ) ` for fixed ` A ` and all ` x ` is ` 0 ` if ` A = 1 ` and
       ` phi ( n ) ` otherwise.  Part of Theorem 6.5.2 of [Shapiro] p. 232.
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    sum2dchr $p |- ( ph -> sum_ x e. D ( ( x ` A ) x. ( * ` ( x ` C ) ) ) =
      if ( A = C , ( phi ` N ) , 0 ) ) $=
      ( cfv co cdvr csu cur wceq cphi cc0 cif ccj cmul eqid crg wcel cn0 nnnn0d
      cv ccrg zncrng crngrng 3syl dvrcl syl3anc sumdchr wa cinvr dvrval syl2anc
      cmulr adantr fveq2d cmgp ccnfld cmhm simpr sseldi unitss unitinvcl mgpbas
      dchrmhm mgpplusg cnfldmul mhmlin cres cc csn cdif cghm dchrghm unitgrpbas
      cress invrfval cnfldbas cnfld0 cndrng drngui ghminv fvres syl c1 cdiv wne
      dchrf ffvelrnd dchrn0 mpbird cnfldinv cabs cexp recval dchrabs oveq1d sq1
      c2 syl6eq oveq2d cjcld div1d 3eqtrd 3eqtr3d sumeq2dv wb dvreq1 ifbid ) AF
      CEJUASZTZBUOZSZBUBYDJUCSZUDZIUESZUFUGFCYESZEYESZUHSZUITZBUBCEUDZYIUFUGABY
      DDFYGHIJKLMYGUJZNPAJUKULZCDULZEGULZYDDULAIUMULJUPULYPAIPUNIJMUQJURUSZQRDY
      CJGCENOYCUJZUTVAVBAFYFYMBAYEFULZVCZYFCEJVDSZSZJVGSZTZYESZYJUUDYESZUITZYMU
      UBYDUUFYEAYDUUFUDZUUAAYQYRUUJQRDYCJUUEGUUCCENUUEUJZOUUCUJZYTVEVFVHVIUUBYE
      JVJSZVKVJSZVLTZULYQUUDDULUUGUUIUDUUBFUUOYEFHIJKMLVRAUUAVMZVNAYQUUAQVHUUBG
      DUUDDJGNOVOZAUUDGULZUUAAYPYRUURYSRJGUUCEOUULVPVFVHZVNDUUEUIUUMUUNYECUUDDJ
      UUMUUMUJZNVQJUUEUUMUUTUUKVSVKUIUUNUUNUJVTVSWAVAUUBUUHYLYJUIUUBUUDYEGWBZSZ
      EUVASZVKVDSZSZUUHYLUUBUVAUUMGWITZUUNWCUFWDWEZWITZWFTULYRUVBUVEUDUUBFGHUVF
      UVHIYEJKMLOUVFUJZUVHUJZUUPWGAYRUUARVHZGUVFUVHUVAUUCUVDEJGUVFOUVIWHJGUVFUU
      COUVIUULWJVKUVGUVHUVDWCVKUFWKWLWMWNUVJUVDUJWJWOVFUUBUURUVBUUHUDUUSUUDGYEW
      PWQUUBUVEYKUVDSZWRYKWSTZYLUUBUVCYKUVDUUBYRUVCYKUDUVKEGYEWPWQVIUUBYKWCULZY
      KUFWTZUVLUVMUDUUBDWCEYEUUBDFHIYEJKMLNUUPXAUUBGDEUUQUVKVNZXBZUUBUVOYRUVKUU
      BEDFGHIYEJKMLNOUUPUVPXCXDZYKXEVFUUBUVMYLYKXFSZXLXGTZWSTZYLWRWSTYLUUBUVNUV
      OUVMUWAUDUVQUVRYKXHVFUUBUVTWRYLWSUUBUVTWRXLXGTWRUUBUVSWRXLXGUUBEFGHIYEJKL
      UUPMOUVKXIXJXKXMXNUUBYLUUBYKUVQXOXPXQXQXRXNXQXSAYHYNYIUFAYPYQYRYHYNXTYSQR
      DYCJGYGCENOYTYOYAVAYBXR $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                       Bertrand's postulate
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Value of the central binomial coefficient.  (Contributed by Mario
     Carneiro, 13-Mar-2014.) $)
  bcctr $p |- ( N e. NN0 -> ( ( 2 x. N ) _C N ) = ( ( ! ` ( 2 x. N ) ) /
                ( ( ! ` N ) x. ( ! ` N ) ) ) ) $=
    ( cn0 wcel c2 cmul co cbc cfa cfv cmin cdiv cc0 cfz wceq fzctr bcval2 caddc
    syl oveq1d eqtrd nn0cn 2timesd pncand fveq2d oveq2d ) ABCZDAEFZAGFZUGHIZUGA
    JFZHIZAHIZEFZKFZUIULULEFZKFUFALUGMFCUHUNNAOAUGPRUFUMUOUIKUFUKULULEUFUJAHUFU
    JAAQFZAJFAUFUGUPAJUFAAUAZUBSUFAAUQUQUCTUDSUET $.

  ${
    $d k N $.  $d k P $.
    $( Prime count of a central binomial coefficient.  (Contributed by Mario
       Carneiro, 12-Mar-2014.) $)
    pcbcctr $p |- ( ( N e. NN /\ P e. Prime ) ->
      ( P pCnt ( ( 2 x. N ) _C N ) ) = sum_ k e. ( 1 ... ( 2 x. N ) )
        ( ( |_ ` ( ( 2 x. N ) / ( P ^ k ) ) ) -
          ( 2 x. ( |_ ` ( N / ( P ^ k ) ) ) ) ) ) $=
      ( cn wcel wa c2 cmul co cfz cdiv cfl cfv cmin caddc csu adantr cn0 oveq1d
      wceq cprime cbc cpc c1 cv cexp cc0 2nn nnmulcl mpan nnnn0 fzctr syl simpr
      pcbc syl3anc nncn 2timesd pncand eqtrd fveq2d ad2antrr nnre adantl elfznn
      cr prmnn nnnn0d nnexpcl syl2an nndivred flcld zcnd eqtr4d oveq2d sumeq2dv
      ) CDEZAUAEZFZAGCHIZCUBIUCIZUDVTJIZVTABUEZUFIZKILMZVTCNIZWDKIZLMZCWDKIZLMZ
      OIZNIZBPZWBWEGWJHIZNIZBPVSVTDEZCUGVTJIEZVRWAWMTVQWPVRGDEVQWPUHGCUIUJQVQWQ
      VRVQCREWQCUKCULUMQVQVRUNABCVTUOUPVSWBWLWOBVSWCWBEZFZWKWNWENWSWKWJWJOIZWNV
      QWKWTTVRWRVQWHWJWJOVQWGWILVQWFCWDKVQWFCCOIZCNICVQVTXACNVQCCUQZURSVQCCXBXB
      USUTSVASVBWSWJWSWJWSWIWSCWDVQCVFEVRWRCVCVBVSADEZWCREWDDEWRVRXCVQAVGVDWRWC
      WCVTVEVHAWCVIVJVKVLVMURVNVOVPUT $.
  $}

  ${
    $d k x A $.  $d k x N $.  $d x B $.
    $( The binomial coefficient is monotone in its second argument, up to the
       midway point.  (Contributed by Mario Carneiro, 5-Mar-2014.) $)
    bcmono $p |- ( ( N e. NN0 /\ B e. ( ZZ>= ` A ) /\ B <_ ( N / 2 ) ) ->
                     ( N _C A ) <_ ( N _C B ) ) $=
      ( cn0 wcel c2 cdiv co cle wbr cc0 cbc wa wi c1 wceq 3ad2ant1 cr syl cmul
      vx vk cuz cfv w3a clt simpl2 simpl1 eluzel2 3ad2ant2 anim1i elnn0z sylibr
      cz simpl3 caddc breq1 oveq2 breq2d imbi12d imbi2d nn0red leidd a1d expcom
      cv bccl adantrd eluzelz zred lep1d peano2re nn0re rehalfcld syl3anc mpand
      letr imim1d eluznn0 cfa cn nn0p1nn nnnn0d readdcld leadd1dd nncnd 2timesd
      cmin simp3 2re 2pos pm3.2i a1i lemuldiv2 mpbird eqbrtrrd letrd leaddsub2d
      wb mpbid nnre nngt0 jca nn0z zsubcld jctir nn0ge0 1re 1lt2 ltleii syl2anc
      lemulge12 ledivmul elnnz1 sylanbrc crp nnm1nn0 3syl nnmulcld nnrp rpdivcl
      faccl syl2an rpregt0d lediv2 facnn2 eqtr4d oveq2d mpbir2and bcval2 nnne0d
      elfz divdiv1d 3eqtr4d cc nn0cn nn0ge0d syld a2d wo oveq1d zcnd mul32d cfz
      0z ax-1cn subsub4d eqcomd fveq2d oveq12d mulassd nnzd 3brtr4d 3exp 3impia
      facp1 3coml simp2 3ad2ant3 exp3acom23 3expib uzind4 3imp syl121anc adantr
      peano2zd orc adantl bcval4 eqbrtrd 0re lelttric sylancr mpjaodan ) CDEZBA
      UCUDZEZBCFGHZIJZUEZKAIJZCALHZCBLHZIJZAKUFJZUVTUWAMZUVQUVOADEZUVSUWDUVOUVQ
      UVSUWAUGUVOUVQUVSUWAUHUWFAUNEZUWAMUWGUVTUWHUWAUVQUVOUWHUVSABUIUJZUKAULUMU
      VOUVQUVSUWAUOUVQUVOUWGMZUVSUWDUWJUAVFZUVRIJZUWBCUWKLHZIJZNZNUWJAUVRIJZUWB
      UWBIJZNZNUWJUBVFZUVRIJZUWBCUWSLHZIJZNZNUWJUWSOUPHZUVRIJZUWBCUXDLHZIJZNZNU
      WJUVSUWDNZNUAUBABUWKAPZUWOUWRUWJUXJUWLUWPUWNUWQUWKAUVRIUQUXJUWMUWBUWBIUWK
      ACLURUSUTVAUWKUWSPZUWOUXCUWJUXKUWLUWTUWNUXBUWKUWSUVRIUQUXKUWMUXAUWBIUWKUW
      SCLURUSUTVAUWKUXDPZUWOUXHUWJUXLUWLUXEUWNUXGUWKUXDUVRIUQUXLUWMUXFUWBIUWKUX
      DCLURUSUTVAUWKBPZUWOUXIUWJUXMUWLUVSUWNUWDUWKBUVRIUQUXMUWMUWCUWBIUWKBCLURU
      SUTVAUWHUVOUWRUWGUVOUWHUWRUVOUWHMZUWQUWPUXNUWBUXNUWBACVGZVBVCVDVEVHUWSUVP
      EZUWJUXCUXHUXPUVOUWGUXCUXHNUXPUVOUWGUEZUXCUXEUXBNUXHUXQUXEUWTUXBUXQUWSUXD
      IJZUXEUWTUXQUWSUXQUWSUXPUVOUWSUNEZUWGAUWSVIQZVJZVKUXQUWSREZUXDREZUVRREUXR
      UXEMUWTNUYAUXQUYBUYCUYAUWSVLSUXQCUVOUXPCREZUWGCVMZUJVNUWSUXDUVRVQVOVPVRUX
      QUXEUXBUXGUXQUXEUXAUXFIJZUXBUXGNUWGUXPUVOUXEUYFNZUWGUXPUVOUYGUWGUXPMUWSDE
      ZUVOUYGNUWSAVSUYHUVOUXEUYFUYHUVOUXEUEZCVTUDZCUWSWHHZOWHHZVTUDZUWSVTUDZTHZ
      GHZUYKGHZUYPUXDGHZUXAUXFIUYIUXDUYKIJZUYQUYRIJZUYIUWSUXDUPHZCIJUYSUYIVUAUX
      DUXDUPHZCUYIUWSUXDUYHUVOUYBUXEUWSVMQZUYIUXDUYIUXDUYHUVOUXDWAEZUXEUWSWBQZW
      CZVBZWDUYIUXDUXDVUGVUGWDUVOUYHUYDUXEUYEUJZUYIUWSUXDUXDVUCVUGVUGUYIUWSVUCV
      KZWEUYIFUXDTHZVUBCIUYIUXDUYIUXDVUEWFZWGUYIVUJCIJZUXEUYHUVOUXEWIZUYIUYCUYD
      FREZKFUFJZMZVULUXEWSVUGVUHVUPUYIVUNVUOWJWKWLWMZUXDCFWNVOWOWPWQUYIUWSUXDCV
      UCVUGVUHWRWTUYIUYCKUXDUFJZMZUYKREZKUYKUFJZMZUYPREKUYPUFJMUYSUYTWSUYIVUDVU
      SVUEVUDUYCVURUXDXAUXDXBXCSUYIUYKWAEZVVBUYIUYKUNEOUYKIJZVVCUYICUWSUVOUYHCU
      NEZUXECXDUJZUYHUVOUXSUXEUWSXDQZXEZUYIUXDCIJZVVDUYIUXDUVRCVUGUYICVUHVNVUHV
      UMUYIUVRCIJZCFCTHIJZUYIUYDVUNMKCIJZOFIJZMVVKUYIUYDVUNVUHWJXFUYIVVLVVMUVOU
      YHVVLUXECXGUJOFXHWJXIXJXFCFXLXKUYIUYDUYDVUPVVJVVKWSVUHVUHVUQCCFXMVOWOWQZU
      YIUWSOCVUCOREUYIXHWMVUHWRWTUYKXNXOZVVCVUTVVAUYKXAUYKXBXCSUYIUYPUYIUYJWAEZ
      UYOWAEZUYPXPEZUVOUYHVVPUXECYBUJZUYIUYMUYNUYIVVCUYLDEUYMWAEVVOUYKXQUYLYBXR
      ZUYHUVOUYNWAEUXEUWSYBQZXSZVVPUYJXPEUYOXPEVVRVVQUYJXTUYOXTUYJUYOYAYCXKYDUX
      DUYKUYPYEVOWTUYIUYJUYKVTUDZUYNTHZGHZUYJUYOUYKTHZGHUXAUYQUYIVWDVWFUYJGUYIV
      WDUYMUYKTHZUYNTHVWFUYIVWCVWGUYNTUYIVVCVWCVWGPVVOUYKYFSUUAUYIUYMUYNUYKUYIU
      YMVVTWFZUYIUYNVWAWFZUYIUYKVVHUUBZUUCYGYHUYIUWSKCUUDHZEZUXAVWEPUYIVWLKUWSI
      JZUWSCIJZUYHUVOVWMUXEUWSXGQUYIUWSUXDCVUCVUGVUHVUIVVNWQUYIUXSKUNEZVVEVWLVW
      MVWNMWSVVGVWOUYIUUEWMZVVFUWSKCYLVOYIUWSCYJSUYIUYJUYOUYKUYIUYJVVSWFZUYIUYO
      VWBWFZVWJUYIUYOVWBYKZUYIUYKVVOYKYMYNUYIUYJCUXDWHHZVTUDZUXDVTUDZTHZGHZUYJU
      YOUXDTHZGHUXFUYRUYIVXCVXEUYJGUYIVXCUYMUYNUXDTHZTHVXEUYIVXAUYMVXBVXFTUYIVW
      TUYLVTUYIUYLVWTUYICUWSOUVOUYHCYOEUXECYPUJUYHUVOUWSYOEUXEUWSYPQOYOEUYIUUFW
      MUUGUUHUUIUYHUVOVXBVXFPUXEUWSUUPQUUJUYIUYMUYNUXDVWHVWIVUKUUKYGYHUYIUXDVWK
      EZUXFVXDPUYIVXGKUXDIJZVVIUYIUXDVUFYQVVNUYIUXDUNEZVWOVVEVXGVXHVVIMWSUYIUXD
      VUEUULVWPVVFUXDKCYLVOYIUXDCYJSUYIUYJUYOUXDVWQVWRVUKVWSUYIUXDVUEYKYMYNUUMU
      UNSUUOUUQUXQUXBUYFUXGUXQUWBREUXAREUXFREUXBUYFMUXGNUXQUWBUXQUVOUWHUWBDEUXP
      UVOUWGUURZUWGUXPUWHUVOAXDUUSUXOXKVBUXQUXAUXQUVOUXSUXADEVXJUXTUWSCVGXKVBUX
      QUXFUXQUVOVXIUXFDEVXJUXQUWSUXTUVFUXDCVGXKVBUWBUXAUXFVQVOUUTYRYSYRUVAYSUVB
      UVCUVDUVTUWEMZUWBKUWCIVXKUVOUWHUWECAUFJZYTZUWBKPUVOUVQUVSUWEUHZUVTUWHUWEU
      WIUVEUWEVXMUVTUWEVXLUVGUVHACUVIVOVXKUWCVXKUVOBUNEZUWCDEVXNVXKUVQVXOUVOUVQ
      UVSUWEUGABVISBCVGXKYQUVJUVTKREAREUWAUWEYTUVKUVTAUWIVJKAUVLUVMUVN $.
  $}

  $( The binomial coefficient takes its maximum value at the center.
     (Contributed by Mario Carneiro, 5-Mar-2014.) $)
  bcmax $p |- ( ( N e. NN0 /\ K e. ZZ ) ->
                   ( ( 2 x. N ) _C K ) <_ ( ( 2 x. N ) _C N ) ) $=
    ( cn0 wcel cz wa cuz cfv c2 co cbc cle wbr 2nn0 simpll sylancr simpr cc syl
    syl2anc cmul cdiv nn0mulcl nn0re leidd wceq nn0cn cc0 wne 2cn 2ne0 breqtrrd
    divcan3 mp3an23 bcmono syl3anc cmin simplr bccmpl caddc nn0red 2timesd zred
    recnd eluzle adantl leadd2dd eqbrtrd lesubaddd mpbird wb nn0zd zsubcld eluz
    wo nn0z adantr uztric mpjaodan ) BCDZAEDZFZBAGHDZIBUAJZAKJZWDBKJZLMZABGHDZW
    BWCFZWDCDZWCBWDIUBJZLMZWGWIICDZVTWJNVTWAWCOZIBUCZPWBWCQWIVTWLWNVTBBWKLVTBBU
    DUEVTBRDZWKBUFZBUGWPIRDIUHUIWQUJUKBIUMUNSULZSABWDUOUPWBWHFZWEWDWDAUQJZKJZWF
    LWSWJWAWEXAUFWSWMVTWJNVTWAWHOZWOPZVTWAWHURZAWDUSTWSWJBWTGHDZWLXAWFLMXCWSXEW
    TBLMZWSXFWDBAUTJZLMWSWDBBUTJXGLWSBWSBWSBXBVAZVDVBWSBABXHWSAXDVCZXHWHBALMWBB
    AVEVFVGVHWSWDABWSWDXCVAXIXHVIVJWSWTEDBEDZXEXFVKWSWDAWSWDXCVLXDVMWSBXBVLWTBV
    NTVJWSVTWLXBWRSWTBWDUOUPVHWBWAXJWCWHVOVTWAQVTXJWABVPVQABVRTVS $.

  $( Ratio of two central binomial coefficients.  (Contributed by Mario
     Carneiro, 10-Mar-2014.) $)
  bcp1ctr $p |- ( N e. NN0 -> ( ( 2 x. ( N + 1 ) ) _C ( N + 1 ) ) =
    ( ( ( 2 x. N ) _C N ) x. ( 2 x. ( ( ( 2 x. N ) + 1 ) / ( N + 1 ) ) ) ) ) $=
    ( cn0 wcel c2 c1 caddc co cmul cbc cmin cdiv wceq ax-1cn syl oveq1d syl2anc
    cc eqtr4d eqtrd oveq2d 2cn mulid1i df-2 eqtri oveq2i nn0cn mp3an13 nn0mulcl
    adddi 2nn0 mpan nn0cnd addass mp3an23 3eqtr4a peano2nn0 nn0p1nn nnzd bcpasc
    cz nn0z bccl a1i nn0red nndivred recnd mul12d addsubd 2timesd pncand eqtr2d
    cc0 cfz fzctr bcp1n bccmpl addassd nncnd pncan sylancl oveq12d ) ABCZDAEFGZ
    HGZWCIGZDAHGZEFGZWCIGZWGWCEJGZIGZFGZWFAIGZDWGWCKGZHGHGZWBWEWGEFGZWCIGZWKWBW
    DWOWCIWBWFDEHGZFGZWFEEFGZFGZWDWOWQWSWFFWQDWSDUAUBUCUDUEWBAQCZWDWRLZAUFZDQCZ
    XAEQCZXBUAMDAEUIUGNWBWFQCZWOWTLZWBWFDBCWBWFBCZUJDAUHUKZULZXFXEXEXGMMWFEEUMU
    NNUOOWBWGBCZWCUTCZWKWPLWBXHXKXIWFUPNZWBWCAUQZURZWCWGUSPRWBWNDWGAIGZHGZWKWBW
    NDWLWMHGZHGXQWBWLDWMWBWLWBXHAUTCZWLBCXIAVAZAWFVBPULXDWBUAVCWBWMWBWGWCWBWGXM
    VDXNVEVFVGWBXRXPDHWBXRWLWGWGAJGZKGZHGZXPWBWMYBWLHWBWCYAWGKWBYAWFAJGZEFGWCWB
    WFEAXJXEWBMVCZXCVHWBYDAEFWBYDAAFGZAJGAWBWFYFAJWBAXCVIZOWBAAXCXCVJSOVKTTWBAV
    LWFVMGCXPYCLAVNAWFVONRTSWBWKXPXPFGXQWBWHXPWJXPFWBWHWGWGWCJGZIGZXPWBXKXLWHYI
    LXMXOWCWGVPPWBYHAWGIWBYHAWCFGZWCJGAWBWGYJWCJWBWGYFEFGYJWBWFYFEFYGOWBAAEXCXC
    YEVQSOWBAWCXCWBWCXNVRVJSTSWBWIAWGIWBXAXEWIALXCMAEVSVTTWAWBXPWBXPWBXKXSXPBCX
    MXTAWGVBPULVIRRR $.

  ${
    $d n x N $.
    $( A bound on the binomial coefficient.  (Contributed by Mario Carneiro,
       11-Mar-2014.) $)
    bclbnd $p |- ( N e. ( ZZ>= ` 4 ) ->
                    ( ( 4 ^ N ) / N ) < ( ( 2 x. N ) _C N ) ) $=
      ( c4 cexp co cdiv c2 cmul cbc clt c1 caddc wceq c6 c7 cc0 c3 wcel cn0 2cn
      oveq12i vx vn cv wbr 4nn nnzi oveq2 id oveq12d breq12d cdc 6nn0 7nn0 4nn0
      0nn0 4lt10 6lt7 decltc cmin cc 2nn0 3nn0 expmul mp3an eqcomi 3p1e4 ax-1cn
      sq2 4cn subadd2i mpbir eqtr4i 3t2e6 mulcomli oveq2i 2exp6 eqtri cz nnne0i
      3cn wne expm1 3eqtr3ri c10 df-4 bcp1ctr ax-mp c5 df-3 df-2 1nn0 nn0mulcli
      1e0p1 bcn0 mul01i oveq1i div1i mulid1i mulid2i 3eqtri 2ne0 divcan2i 2t2e4
      df-5 5nn nncni 3ne0 divassi 6nn 2nn nnmulcli pm3.2i div12 divmuli mulassi
      wa 5t2e10 cn wi mpan nnexpcl sylancr nnrpd rpdivcld rpred nnmulcl syl2anc
      nnnn0d bccl nn0red crp syl cr 2re a1i nncnd oveq1d mulassd div23d rpcnd
      df-7 10nn 7nn divcli mulcli 3eqtr3i dec0u 3brtr4i cuz cfv nnuz nnnn0 nnrp
      uztrn2 nnz 2rp peano2nnd peano2nn rpmulcl ltmul1d breq2d sylancl rpreccld
      bitr4d ltaddrp nncn nnne0 divdird divcan4d eqtr2d breqtrd ltmul2dd syl6eq
      expp1 eqtr4d eqtrd divmul24d 3eqtr3rd 3brtr4d remulcld nn0mulcl nnzd lttr
      nnne0d syl3anc mpand sylbid uzind4i ) BUAUCZCDZUWIEDZFUWIGDZUWIHDZIUDBBCD
      ZBEDZFBGDZBHDZIUDBUBUCZCDZUWREDZFUWRGDZUWRHDZIUDZBUWRJKDZCDZUXDEDZFUXDGDZ
      UXDHDZIUDZBACDZAEDZFAGDZAHDZIUDUAUBBABUEUFZUWIBLZUWKUWOUWMUWQIUXOUWJUWNUW
      IBEUWIBBCUGUXOUHZUIUXOUWLUWPUWIBHUWIBFGUGUXPUIUJUWIUWRLZUWKUWTUWMUXBIUXQU
      WJUWSUWIUWREUWIUWRBCUGUXQUHZUIUXQUWLUXAUWIUWRHUWIUWRFGUGUXRUIUJUWIUXDLZUW
      KUXFUWMUXHIUXSUWJUXEUWIUXDEUWIUXDBCUGUXSUHZUIUXSUWLUXGUWIUXDHUWIUXDFGUGUX
      TUIUJUWIALZUWKUXKUWMUXMIUYAUWJUXJUWIAEUWIABCUGUYAUHZUIUYAUWLUXLUWIAHUWIAF
      GUGUYBUIUJMBUKZNOUKZUWOUWQIMNBOULUMUNUOUPUQURFFPGDZCDZBBJUSDZCDZUYCUWOUYF
      FFCDZPCDZUYHFUTQZFRQZPRQZUYFUYJLSVAVBFFPVCVDBUYIUYGPCUYIBVHVEUYGPLPJKDZBL
      VFBJPVIVGVTVJVKTVLUYFFMCDUYCUYEMFCPFMVTSVMVNZVOVPVQBUTQZBOWABVRQUYHUWOLVI
      BUEVSZUXNBBWBVDWCUWQWDFGDZFNBEDZGDZGDZWDNGDZUYDUWQFUYNGDZUYNHDZUYEPHDZFUY
      EJKDZUYNEDZGDZGDZVUAUWPVUCBUYNHBUYNFGWEVOWETUYMVUDVUILVBPWFWGVUEUYRVUHUYT
      GVUEFFJKDZGDZVUJHDZMFWHGDZPEDZGDZUYRUYEVUKPVUJHPVUJFGWIVOWITVULFFGDZFHDZF
      VUPJKDZVUJEDZGDZGDZVUOUYLVULVVALVAFWFWGVUQMVUTVUNGVUQFJJKDZGDZVVBHDZFJGDZ
      JHDZFVVEJKDZVVBEDZGDZGDZMVUPVVCFVVBHFVVBFGWJVOWJTJRQVVDVVJLWKJWFWGVVJUYEM
      VVFFVVIPGVVFFOJKDZGDZVVKHDZFOGDZOHDZFVVNJKDZVVKEDZGDZGDZFVVEVVLJVVKHJVVKF
      GWMVOWMTORQVVMVVSLUOOWFWGVVSJFGDFVVOJVVRFGVVNRQVVOJLFOVAUOWLVVNWNWGVVRVVE
      FVVQJFGVVQJJEDJVVPJVVKJEVVPVVKJVVNOJKFSWOWPWMVLJVVKWMVETJVGWQVQVOFSWRZVQT
      FSWSVQWTVVIFPFEDZGDPVVHVWAFGVVGPVVBFEVVGVUJPVVEFJKVVTWPWIVLFVVBWJVETVOPFV
      TSXAXBVQTUYOVQWTVUTFWHPEDZGDVUNVUSVWBFGVURWHVUJPEVURBJKDWHVUPBJKXCWPXDVLP
      VUJWIVETVOFWHPSWHXEXFZVTXGXHVLTVQVUOVUMMPEDZGDZUYRMUTQVUMUTQPUTQZPOWAZXPV
      UOVWELMXIXFZVUMFWHXJXEXKXFVWFVWGVTXGXLMVUMPXMVDVUMWDVWDFGWHFWDVWCSXQVNVWD
      FLPFGDMLVMMPFVWHVTSXGXNVKTVQWTVUGUYSFGVUFNUYNBEVUFMJKDNUYEMJKUYOWPUUAVLVF
      TVOTWTVUAWDFUYTGDZGDVUBWDFUYTWDUUBXFSFUYSSNBNUUCXFZVIUYQUUDZUUEXOVWINWDGV
      UPUYSGDBUYSGDVWINVUPBUYSGXCWPFFUYSSSVWKXONBVWJVIUYQXBUUFVOVQNUMUUGWTUUHUW
      RBUUIUUJQZUWRXRQZUXCUXIXSBXRQZVWLVWMUEJUWRBXRUUKUUNXTVWMUXCUWTFUXAJKDZUXD
      EDZGDZGDZUXHIUDZUXIVWMUXCVWRUXBVWQGDZIUDVWSVWMUWTUXBVWQVWMUWTVWMUWSUWRVWM
      UWSVWMVWNUWRRQZUWSXRQZUEUWRUULZBUWRYAYBZYCUWRUUMZYDZYEZVWMUXBVWMUXARQUWRV
      RQUXBRQVWMUXAFXRQZVWMUXAXRQXJFUWRYFXTZYHUWRUUOUWRUXAYIYGYJVWMFYKQVWPYKQVW
      QYKQUUPVWMVWOUXDVWMVWOVWMUXAVXIUUQZYCZVWMUXDUWRUURZYCZYDZFVWPUUSYBZUUTVWM
      UXHVWTVWRIVWMVXAUXHVWTLVXCUWRWFYLUVAUVDVWMUXFVWRIUDZVWSUXIVWMUWSFGDZUXDED
      ZFGDZVXRVWOUWREDZGDZUXFVWRIVWMFVXTVXRFYMQZVWMYNYOVWMVXTVWMVWOUWRVXKVXEYDY
      EVWMVXQUXDVWMVXQVWMVXBVXHVXQXRQVXDXJUWSFYFUVBZYCVXMYDVWMFFJUWREDZKDZVXTIV
      WMVYBVYDYKQFVYEIUDYNVWMUWRVXEUVCFVYDUVEYBVWMVXTUXAUWREDZVYDKDVYEVWMUXAJUW
      RVWMUXAVXIYPJUTQVWMVGYOUWRUVFZUWRUVGZUVHVWMVYFFVYDKVWMFUWRUYKVWMSYOZVYGVY
      HUVIYQUVJUVKUVLVWMUXFVXQFGDZUXDEDVXSVWMUXEVYJUXDEVWMUXEUWSBGDZVYJVWMUYPVX
      AUXEVYKLVIVXCBUWRUVNYBVWMVYJUWSVUPGDVYKVWMUWSFFVWMUWSVXDYPZVYIVYIYRVUPBUW
      SGXCVOUVMUVOYQVWMVXQFUXDVWMVXQVYCYPZVYIVWMUXDVXLYPZVWMUXDVXLUWDZYSUVPVWMV
      XQUWREDZVWPGDUWTFGDZVWPGDVYAVWRVWMVYPVYQVWPGVWMUWSFUWRVYLVYIVYGVYHYSYQVWM
      VXQUWRVWOUXDVYMVYGVWMVWOVXJYPVYNVYHVYOUVQVWMUWTFVWPVWMUWTVXFYTVYIVWMVWPVX
      NYTYRUVRUVSVWMUXFYMQVWRYMQUXHYMQVXPVWSXPUXIXSVWMUXFVWMUXEUXDVWMUXEVWMVWNU
      XDRQZUXEXRQUEVWMUXDVXLYHZBUXDYAYBYCVXMYDYEVWMUWTVWQVXGVWMVWQVXOYEUVTVWMUX
      HVWMUXGRQZUXDVRQUXHRQVWMUYLVYRVYTVAVYSFUXDUWAYBVWMUXDVXLUWBUXDUXGYIYGYJUX
      FVWRUXHUWCUWEUWFUWGYLUWH $.
  $}

  ${
    $d k x y N $.  $d k x P $.  $d k y S $.
    $( Convert a bound on a power to a bound on the exponent.  (Contributed by
       Mario Carneiro, 11-Mar-2014.) $)
    efexple $p |- ( ( ( A e. RR /\ 1 < A ) /\ N e. ZZ /\ B e. RR+ ) ->
        ( ( A ^ N ) <_ B <-> N <_ ( |_ ` ( ( log ` B ) / ( log ` A ) ) ) ) ) $=
      ( cr wcel c1 clt wbr wa crp co cle clog cfv ce wceq cc0 3ad2ant1 3ad2ant3
      syl2anc cz w3a cexp cmul cdiv cfl simpl 0lt1 wi 0re 1re mp3an12 mpani imp
      elrpd simp2 reexplog reeflog eqcomd breq12d wb zre 3ad2ant2 rplogcl rpred
      lttr remulcld relogcl efle lemuldivd rerpdivcld flge bitrd 3bitr2d ) ADEZ
      FAGHZIZCUAEZBJEZUBZACUCKZBLHCAMNZUDKZONZBMNZONZLHZWCWELHZCWEWBUEKZUFNLHZV
      TWAWDBWFLVTAJEZVRWAWDPVQVRWKVSVQAVOVPUGVOVPQAGHZVOQFGHZVPWLUHQDEFDEVOWMVP
      IWLUIUJUKQFAVFULUMUNUORVQVRVSUPZACUQTVTWFBVSVQWFBPVRBURSUSUTVTWCDEWEDEZWH
      WGVAVTCWBVRVQCDEVSCVBVCZVTWBVQVRWBJEVSAVDRZVEVGVSVQWOVRBVHSZWCWEVITVTWHCW
      ILHZWJVTCWEWBWPWRWQVJVTWIDEVRWSWJVAVTWEWBWRWQVKWNWICVLTVMVN $.
  $}

  ${
    $d p N $.  $d p P $.
    bpos1.1 $e |- ( E. p e. Prime ( N < p /\ p <_ ( 2 x. N ) ) -> ph ) $.
    bpos1.2 $e |- ( N e. ( ZZ>= ` P ) -> ph ) $.
    bpos1.3 $e |- P e. Prime $.
    bpos1.4 $e |- A e. NN0 $.
    bpos1.5 $e |- ( A x. 2 ) = B $.
    bpos1.6 $e |- A < P $.
    bpos1.7 $e |- ( P < B \/ P = B ) $.
    $( Lemma for ~ bpos1 .  (Contributed by Mario Carneiro, 12-Mar-2014.) $)
    bpos1lem $p |- ( N e. ( ZZ>= ` A ) -> ph ) $=
      ( wcel cle wbr clt sylancr c2 cr cuz cfv cz wb cprime cn prmnn ax-mp nnzi
      eluzelz eluz syl6bir wa cv cmul co nnrei a1i nn0rei 2re remulcli eqeltrri
      wrex eluzelre remulcl wceq wo leloei mpbir nn0cni 2cn mulcomli eluzle cc0
      2pos pm3.2i lemul2 mp3an13 syl mpbid syl5eqbrr letrd anim2i breq2 anbi12d
      breq1 rspcev expcom lelttric mpjaod ) EBUAUBNZDEOPZAEDQPZWKWLEDUAUBNZAWKD
      UCNEUCNWNWLUDDDUENZDUFNIDUGUHZUIBEUJDEUKRHULWMWKAWMWKUMZEFUNZQPZWRSEUOUPZ
      OPZUMZFUEVCZAWQWOWMDWTOPZUMZXCIWKXDWMWKDCWTDTNZWKDWPUQZURCTNWKBSUOUPCTKBS
      BJUSZUTVAVBZURWKSTNZETNZWTTNUTBEVDZSEVERDCOPZWKXMDCQPDCVFVGMDCXGXIVHVIURW
      KCSBUOUPZWTOBSCBJVJVKKVLWKBEOPZXNWTOPZBEVMWKXKXOXPUDZXLBTNXKXJVNSQPZUMXQX
      HXJXRUTVOVPBESVQVRVSVTWAWBWCXBXEFDUEWRDVFWSWMXAXDWRDEQWDWRDWTOWFWEWGRGVSW
      HWKXFXKWLWMVGXGXLDEWIRWJ $.
  $}

  ${
    $d p N $.
    $( Bertrand's postulate, checked numerically for ` N <_ 6 4 ` , using the
       prime sequence ` 2 , 3 , 5 , 7 , 1 3 , 2 3 , 4 3 , 8 3 ` .  (Contributed
       by Mario Carneiro, 12-Mar-2014.)  (Proof shortened by Mario Carneiro,
       20-Apr-2015.) $)
    bpos1 $p |- ( ( N e. NN /\ N <_ ; 6 4 ) ->
                  E. p e. Prime ( N < p /\ p <_ ( 2 x. N ) ) ) $=
      ( c6 c4 cdc wbr clt c2 co c1 c3 c8 4nn0 3nn0 cc0 2nn0 caddc wceq bpos1lem
      orci cn wcel cle cv cmul wa cprime wrex cuz cfv wi elnnuz c5 c10 c7 wn cr
      ax-1 6nn0 deccl nn0rei a1i 8nn0 eluzelre 4lt10 6lt8 decltc eluzle ltletrd
      wb ltnle sylancr mpbid pm2.21d 83prm eqid 0nn0 4t2e8 oveq1i nncni addid1i
      8nn eqtri 3t2e6 dec0h decmul1c 3lt10 4lt8 6nn 3lt6 declt 43prm 2t2e4 2lt4
      4nn 23prm 1nn0 mulid2i 1lt2 13prm 7nn0 7t2e14 7lt10 declti 3lt4 7prm 5nn0
      2cn 1nn 5t2e10 5lt7 5prm 3lt5 5lt6 3prm 2lt3 2prm olci sylbi imp ) AUAUBZ
      ACDEZUCFZABUDZGFYDHAUEIUCFUFBUGUHZYAAJUIUJUBYCYEUKZAULYFJHHABYEYCURZYFHDK
      ABYGYFKCUMABYGYFUMUNUOABYGYFUOJDEZJKEZABYGYFYIHCEZHKEZABYGYFYKDCEZDKEZABY
      GYFYMLCEZLKEZABYGAYOUIUJUBZYCYEYPYBAGFZYCUPZYPYBYOAYBUQUBZYPYBCDUSMUTVAZV
      BYOUQUBYPYOLKVCNUTVAVBYOAVDZYBYOGFYPCLDKUSVCMNVEVFVGVBYOAVHVIYPYSAUQUBYQY
      RVJYTUUAYBAVKVLVMVNVODKMNUTDKLCHOYMPMNYMVPUSVQDHUEIZOQILOQILUUBLOQVRVSLLW
      BVTWAWCKHUEICOCEWDCUSWEWCZWFDLKKMVCNNWGWHVGYOYNGFYOYNRLKCVCNWIWJWKTSWLHKP
      NUTHKDCHOYKPPNYKVPUSVQHHUEIZOQIDOQIDUUDDOQWMVSDDWOVTWAWCUUCWFHDKKPMNNWGWN
      VGYMYLGFYMYLRDKCMNWIWJWKTSWPJKWQNUTJKHCHOYIPWQNYIVPUSVQJHUEIZOQIHOQIHUUEH
      OQHXHWRZVSHXHWAWCUUCWFJHKKWQPNNWGWSVGYKYJGFYKYJRHKCPNWIWJWKTSWTXAXBJKUOXI
      NXAXCXDYIYHGFYIYHRJKDWQNWOXEWKTSXFXGXJXKUOUNGFUOUNRXCTSXLNWDXMUMCGFUMCRXN
      TSXOPWMXPKDGFKDRXETSXQWQUUFWSHHRHHGFHVPXRSXSXT $.
  $}

  ${
    $d k N $.  $d k P $.
    $( An upper bound on the prime powers dividing a central binomial
       coefficient.  (Contributed by Mario Carneiro, 9-Mar-2014.) $)
    bposlem1 $p |- ( ( N e. NN /\ P e. Prime ) ->
                      ( P ^ ( P pCnt ( ( 2 x. N ) _C N ) ) ) <_ ( 2 x. N ) ) $=
      ( wcel wa c2 cmul co cle wbr cfv c1 cmin cc0 syl2anc cz cr a1i clt adantr
      wb vk cn cprime cbc cpc cexp clog cdiv cfl cfz cv csu cif crp 2nn nnmulcl
      fzfid mpan ad2antrr ad2antlr elfznn adantl nnnn0d nnexpcld rpdivcl syl2an
      prmnn nnrp rpred flcld 2z simpll zmulcl sylancr zsubcld zred keepel caddc
      1re 0re resubcld 2re syl lesub1dd resubcl sylancl flltp1 ltsubaddd mpbird
      flle remulcl 2pos pm3.2i ltmul2 mp3an3 mpbid ltsub2dd cc 2cn nncnd nnne0d
      nncn divassd recnd ax-1cn subdid mulid1i oveq2i syl6eq oveq12d wceq nncan
      eqtrd breqtrd 1z breq2d wn nnred cuz efexple syl3anc nnzd rplogcld rpge0d
      nnrpd adantrr ltdivmul syl112anc bitrd impr syl6breqr 0z mpbir2and eqcomd
      0p1e1 flbi ce cn0 3brtr4d 3syl lelttrd syl6breq zleltp1 iftrue syl5ibrcom
      df-2 nnge1d biantrurd prmuz2 eluz2b1 simprbi jca elfzelz 1lt2 nnre ltleii
      lemul2a syl31anc syl5eqbrr ltletrd rpdivcld 3bitr4rd notbid ltnled bitr4d
      nnge1 elfz nngt0d mulid1d biimprd ltaddrp2d 2timesd breqtrrd lttr sylibrd
      wi mpand oveq2d mul01i subidi 0le0 syl6eqbr sylbid iffalse mpbidi pm2.61d
      0cn expr fsumle pcbcctr chash cfn wss bernneq3 reeflogd reexplog relogcld
      ltled remulcld efle ledivmul2d letrd eluz fzss2 sumhash rprege0d flge0nn0
      hashfz1 eqtr2d simpr nnnn0 fzctr bccl2 pccld nn0zd syl211anc ) BUBCZAUCCZ
      DZAAEBFGZBUDGZUEGZUFGUXTHIZUYBUXTUGJZAUGJZUHGZUIJZHIZUXSKUXTUJGZUXTAUAUKZ
      UFGZUHGZUIJZEBUYKUHGZUIJZFGZLGZUAULUYIUYJKUYGUJGZCZKMUMZUAULZUYBUYGHUXSUY
      IUYQUYTUAUXSKUXTUQZUXSUYJUYICZDZUYQVUDUYMUYPVUDUYLVUDUYLVUDUXTUBCZUYKUBCZ
      UYLUNCZUXQVUEUXRVUCEUBCUXQVUEUOEBUPURZUSVUDAUYJUXRAUBCZUXQVUCAVGZUTVUDUYJ
      VUCUYJUBCUXSUYJUXTVAVBZVCVDZVUEUXTUNCZUYKUNCZVUGVUFUXTVHUYKVHZUXTUYKVEVFN
      ZVIZVJZVUDEOCUYOOCUYPOCVKVUDUYNVUDUYNVUDUXQVUFUYNUNCZUXQUXRVUCVLVULUXQBUN
      CVUNVUSVUFBVHZVUOBUYKVEVFNZVIZVJZEUYOVMVNZVOZVPZUYTPCVUDUYSKMPVSVTVQQVUDU
      YSUYQUYTHIZVUDVVGUYSUYQKHIZVUDVVHUYQKKVRGZRIZVUDUYQEVVIRVUDUYQUYLUYPLGZEV
      VFVUDUYLUYPVUQVUDUYPVVDVPZWAEPCZVUDWBQVUDUYMUYLUYPVUDUYMVURVPVUQVVLVUDUYL
      PCZUYMUYLHIVUQUYLWJWCWDVUDVVKUYLEUYNKLGZFGZLGZERVUDVVPUYPUYLVUDVVMVVOPCZV
      VPPCWBVUDUYNPCZKPCZVVRVVBVSUYNKWEWFZEVVOWKVNVVLVUQVUDVVOUYORIZVVPUYPRIZVU
      DVWBUYNUYOKVRGRIZVUDVVSVWDVVBUYNWGWCVUDUYNKUYOVVBVVTVUDVSQZVUDUYOVVCVPZWH
      WIVUDVVRUYOPCZVWBVWCTZVWAVWFVVRVWGVVMMERIZDVWHVVMVWIWBWLWMVVOUYOEWNWONWPW
      QVUDVVQEUYNFGZVWJELGZLGZEVUDUYLVWJVVPVWKLVUDEBUYKEWRCZVUDWSQZUXQBWRCUXRVU
      CBXBZUSVUDUYKVULWTZVUDUYKVULXAXCVUDVVPVWJEKFGZLGVWKVUDEUYNKVWNVUDUYNVVBXD
      KWRCVUDXEQXFVWQEVWJLEWSXGZXHXIXJVUDVWJWRCVWMVWLEXKVUDVWJVUDVVMVVSVWJPCWBV
      VBEUYNWKVNXDWSVWJEXLWFXMXNUUAUUFUUBVUDUYQOCKOCZVVHVVJTVVEXOUYQKUUCWFWIUYS
      UYTKUYQHUYSKMUUDXPUUEUYSXQZUYQMHIZVVGVUDVUDVWTUXTUYKRIZVXAVUDVWTUYKUXTHIZ
      XQVXBVUDUYSVXCVUDUYJUYGHIZKUYJHIZVXDDZVXCUYSVUDVXEVXDVUDUYJVUKUUGUUHVUDAP
      CZKARIZDZUYJOCZVUMVXCVXDTUXSVXIVUCUXSVXGVXHUXSAUXRVUIUXQVUJVBZXRZUXSAEXSJ
      CZVXHUXRVXMUXQAUUIVBZVXMAOCVXHAUUJUUKWCZUULSVUCVXJUXSUYJKUXTUUMVBUXSVUMVU
      CUXSUXTUXQVUEUXRVUHSZYEZSAUXTUYJXTYAVUDVXJVWSUYGOCZUYSVXFTVUDUYJVUKYBVWSV
      UDXOQUXSVXRVUCUXSUYFUXSUYFUXSUYDUYEUXSUXTUXSUXTVXPXRZUXSKEUXTVVTUXSVSQZVV
      MUXSWBQVXSKERIUXSUUNQUXSEVWQUXTHVWRUXSVVTBPCZVVMMEHIZDZKBHIZVWQUXTHIVXTUX
      QVYAUXRBUUOZSVYCUXSVVMVYBWBMEVTWBWLUUPWMQUXQVYDUXRBUVFSKBEUUQUURUUSUUTYCU
      XSAVXLVXOYCZUVAZVIZVJZSUYJKUYGUVGYAUVBUVCVUDUXTUYKUXSUXTPCZVUCVXSSZVUDUYK
      VULXRZUVDUVEUXSVUCVXBVXAUXSVUCVXBDDZUYQMMHVYMUYQMMLGMVYMUYMMUYPMLVYMUYMMX
      KZMUYLHIZUYLMKVRGZRIZUXSVUCVYOVXBVUDUYLVUPYDYFVYMUYLKVYPRUXSVUCVXBUYLKRIZ
      VUDVYRVXBVUDVYRUXTUYKKFGZRIZVXBVUDVYJVVTUYKPCZMUYKRIZVYRVYTTVYKVWEVYLVUDU
      YKVULUVHZUXTKUYKYGYHVUDVYSUYKUXTRVUDUYKVWPUVIZXPYIUVJYJYOYKVYMVVNMOCZVYNV
      YOVYQDTUXSVUCVVNVXBVUQYFYLUYLMYPWFYMVYMUYPEMFGMVYMUYOMEFVYMUYOMXKZMUYNHIZ
      UYNVYPRIZUXSVUCWUGVXBVUDUYNVVAYDYFVYMUYNKVYPRUXSVUCVXBUYNKRIZVUDVXBBUYKRI
      ZWUIVUDBUXTRIZVXBWUJUXQWUKUXRVUCUXQBBBVRGUXTRUXQBBVYEVUTUVKUXQBVWOUVLUVMU
      SVUDVYAVYJWUAWUKVXBDWUJUVPUXQVYAUXRVUCVYEUSZVYKVYLBUXTUYKUVNYAUVQVUDWUIBV
      YSRIZWUJVUDVYAVVTWUAWUBWUIWUMTWULVWEVYLWUCBKUYKYGYHVUDVYSUYKBRWUDXPYIUVOY
      JYOYKVYMVVSWUEWUFWUGWUHDTUXSVUCVVSVXBVVBYFYLUYNMYPWFYMUVREWSUVSXIXJMUWGUV
      TXIUWAUWBUWHUWCVWTMUYTUYQHVWTUYTMUYSKMUWDYNXPUWEUWFUWIAUABUWJUXSVUAUYRUWK
      JZUYGUXSUYIUWLCUYRUYIUWMZVUAWUNXKVUBUXSUXTUYGXSJCZWUOUXSWUPUYGUXTHIZUXSUY
      GUYFUXTUXSUYGVYIVPVYHVXSUXSUYFPCZUYGUYFHIVYHUYFWJWCUXSUYFUXTHIUYDUXTUYEFG
      ZHIZUXSWUTUYDYQJZWUSYQJZHIZUXSUXTAUXTUFGZWVAWVBHUXSUXTWVDVXSUXSWVDUXSAUXT
      VXKUXSUXTVXPVCZVDXRUXSVXMUXTYRCUXTWVDRIVXNWVEAUXTUWNNUWRUXSUXTVXQUWOUXSWV
      DWVBUXSAUNCUXTOCZWVDWVBXKUXSAVXKYEUXSUXTVXPYBZAUXTUWPNYNYSUXSUYDPCWUSPCWU
      TWVCTUXSUXTVXQUWQZUXSUXTUYEVXSUXSUYEVYFVIUWSUYDWUSUWTNWIUXSUYDUXTUYEWVHVX
      SVYFUXAWIUXBUXSVXRWVFWUPWUQTVYIWVGUYGUXTUXCNWIUYGKUXTUXDWCUYRUYIUAUXENUXS
      WURMUYFHIDUYGYRCWUNUYGXKUXSUYFVYGUXFUYFUXGUYGUXHYTUXIYSUXSVXGVXHUYBOCVUMU
      YCUYHTVXLVXOUXSUYBUXSAUYAUXQUXRUXJUXQUYAUBCZUXRUXQBYRCBMUXTUJGCWVIBUXKBUX
      LBUXTUXMYTSUXNUXOVXQAUXTUYBXTUXPWI $.
  $}

  ${
    $d k N $.  $d k P $.  $d k ph $.
    bposlem2.1 $e |- ( ph -> N e. NN ) $.
    bposlem2.2 $e |- ( ph -> P e. Prime ) $.
    bposlem2.3 $e |- ( ph -> 2 < P ) $.
    bposlem2.4 $e |- ( ph -> ( ( 2 x. N ) / 3 ) < P ) $.
    bposlem2.5 $e |- ( ph -> P <_ N ) $.
    $( There are no odd primes in the range ` ( 2 N / 3 , N ] ` dividing the
       ` N ` -th central binomial coefficient.  (Contributed by Mario Carneiro,
       12-Mar-2014.) $)
    bposlem2 $p |- ( ph -> ( P pCnt ( ( 2 x. N ) _C N ) ) = 0 ) $=
      ( c2 cmul co c1 cc0 wcel cle wbr clt cr c3 adantr vk cbc cpc cv cexp cdiv
      cfz cfl cfv cmin csu cn cprime wceq pcbcctr syl2anc cuz wo elnn1uz2 sylib
      elfznn wa oveq2 prmnn syl nncnd exp1d sylan9eqr oveq2d fveq2d 2cn mulid1i
      caddc mulid2d eqbrtrd wb 1re a1i nnred nngt0d lemuldiv syl112anc nndivred
      mpbid 2re 2pos pm3.2i lemul2 mp3an13 syl5eqbrr cc nnne0d divassd breqtrrd
      2nn nnmulcl sylancr 3pos ltdiv23 mp3an2 syl12anc df-3 syl6breq cz 2z flbi
      3re sylancl mpbir2and eqtrd c4 remulcl 4re eqbrtrrd lttrd 2t2e4 syl6breqr
      3lt4 ltmul2 mp3an23 mpbird 1z syl6eq oveq12d subidi crp nnrpd cn0 eluznn0
      df-2 2nn0 mpan nnexpcl syl2an rpdivcld rpge0d ltdivmuld 1e0p1 rpred 0z
      ltdivmul mp3an3 remulcld nnltp1le lemul1 mp3an1 sqvald nnge1d simpr letrd
      syl5eqbr leexp2ad ltletrd mulid1d ltaddrpd 2timesd mul01i jaodan sumeq2dv
      0cn sylan2 cfn fzfid wss sumz olcs ) ABICJKZCUBKUCKZLUVGUGKZUVGBUAUDZUEKZ
      UFKZUHUIZICUVKUFKZUHUIZJKZUJKZUAUKZMACULNZBUMNZUVHUVRUNDEBUACUOUPAUVRUVIM
      UAUKZMAUVIUVQMUAUVJUVINZAUVJLUNZUVJIUQUINZURZUVQMUNZUWBUVJULNUWEUVJUVGVAU
      VJUSUTAUWCUWFUWDAUWCVBZUVQIIUJKMUWGUVMIUVPIUJUWGUVMUVGBUFKZUHUIZIUWGUVLUW
      HUHUWGUVKBUVGUFUWCAUVKBLUEKBUVJLBUEVCABABAUVTBULNZEBVDVEZVFZVGVHZVIVJAUWI
      IUNZUWCAUWNIUWHOPZUWHILVMKZQPZAIICBUFKZJKZUWHOAIILJKZUWSOIVKVLZALUWROPZUW
      TUWSOPZALBJKZCOPZUXBAUXDBCOABUWLVNHVOALRNZCRNZBRNZMBQPZUXEUXBVPUXFAVQVRAC
      DVSZABUWKVSZABUWKVTZLCBWAWBWDZAUWRRNZUXBUXCVPZACBUXJUWKWCZUXFUXNIRNZMIQPZ
      VBZUXOVQUXQUXRWEWFWGZLUWRIWHWIVEWDWJAICBIWKNAVKVRACDVFZUWLABUWKWLWMZWNAUW
      HSUWPQAUVGSUFKBQPZUWHSQPZGAUVGRNZUXHUXIUYCUYDVPZAUVGAIULNZUVSUVGULNWODICW
      PWQZVSZUXKUXLUYESRNZMSQPZVBZUXHUXIVBZUYFUYJUYKXGWRWGZUVGSBWSWTXAWDZXBXCAU
      WHRNIXDNUWNUWOUWQVBVPAUVGBUYIUWKWCXEUWHIXFXHXITXJUWGUVPUWTIUWGUVOLIJUWGUV
      OUWRUHUIZLUWGUVNUWRUHUWGUVKBCUFUWMVIVJAUYPLUNZUWCAUYQUXBUWRLLVMKZQPZUXMAU
      WRIUYRQAUWRIQPZUWSIIJKZQPZAUWSXKVUAQAUWSSXKAUXQUXNUWSRNWEUXPIUWRXLWQUYJAX
      GVRXKRNAXMVRAUWHUWSSQUYBUYOXNSXKQPAXRVRXOXPXQAUXNUYTVUBVPZUXPUXNUXQUXSVUC
      WEUXTUWRIIXSXTVEYAYJXCAUXNLXDNUYQUXBUYSVBVPUXPYBUWRLXFXHXITXJVIUXAYCYDIVK
      YEYCAUWDVBZUVQMMUJKMVUDUVMMUVPMUJVUDUVMMUNZMUVLOPZUVLMLVMKZQPZVUDUVLVUDUV
      GUVKAUVGYFNUWDAUVGUYHYGTVUDUVKAUWJUVJYHNZUVKULNUWDUWKIYHNUWDVUIYKUVJIYIYL
      BUVJYMYNZYGZYOZYPVUDUVLLVUGQVUDUVLLQPUVGUVKLJKZQPVUDUVGUVKVUMQVUDUVGSBJKZ
      UVKAUYEUWDUYITZAVUNRNZUWDAUYJUXHVUPXGUXKSBXLWQTZVUDUVKVUJVSZAUVGVUNQPZUWD
      AUYCVUSGAUYEUXHUYCVUSVPZUYIUXKUYEUXHUYLVUTUYNUVGBSUUAUUBUPWDTVUDVUNBBJKZU
      VKVUQAVVARNUWDABBUXKUXKUUCTVURAVUNVVAOPZUWDASBOPZVVBASUWPBOXBAIBQPZUWPBOP
      ZFAUYGUWJVVDVVEVPWOUWKIBUUDWQWDUUKAUXHUXHUXIVVCVVBVPZUXKUXKUXLUYJUXHUYMVV
      FXGSBBUUEUUFXAWDTVUDBIUEKZVVAUVKOAVVGVVAUNUWDABUWLUUGTVUDBIUVJAUXHUWDUXKT
      ALBOPUWDABUWKUUHTAUWDUUIUULXNUUJUUMZVUDUVKVUDUVKVUJVFUUNZWNVUDUVGLUVKVUOU
      XFVUDVQVRZVUKYQYAYRXCVUDUVLRNMXDNZVUEVUFVUHVBVPVUDUVLVULYSYTUVLMXFXHXIVUD
      UVPIMJKMVUDUVOMIJVUDUVOMUNZMUVNOPZUVNVUGQPZVUDUVNVUDCUVKACYFNUWDACDYGZTVU
      KYOZYPVUDUVNLVUGQVUDUVNLQPCVUMQPVUDCUVKVUMQVUDCUVGUVKAUXGUWDUXJTZVUOVURAC
      UVGQPUWDACCCVMKUVGQACCUXJVVOUUOACUYAUUPWNTVVHXOVVIWNVUDCLUVKVVQVVJVUKYQYA
      YRXCVUDUVNRNVVKVVLVVMVVNVBVPVUDUVNVVPYSYTUVNMXFXHXIVIIVKUUQYCYDMUUTYEYCUU
      RUVAUUSAUVIUVBNZUWAMUNZALUVGUVCUVILUQUIUVDVVRVVSUVIUALUVEUVFVEXJXJ $.
  $}

  ${
    $d k p x F $.  $d k p x G $.  $d n p K $.  $d p x M $.  $d k n p x N $.
    $d k n p x ph $.
    bpos.1 $e |- ( ph -> N e. ( ZZ>= ` 5 ) ) $.
    bpos.2 $e |- ( ph -> -. E. p e. Prime ( N < p /\ p <_ ( 2 x. N ) ) ) $.
    bpos.3 $e |- F = ( n e. NN |->
            if ( n e. Prime , ( n ^ ( n pCnt ( ( 2 x. N ) _C N ) ) ) , 1 ) ) $.
    bpos.4 $e |- K = ( |_ ` ( ( 2 x. N ) / 3 ) ) $.
    $( Lemma for ~ bpos .  Since the binomial coefficient does not have any
       primes in the range ` ( 2 N / 3 , N ] ` or ` ( 2 N , +oo ) ` by
       ~ bposlem2 and ~ prmfac1 , respectively, and it does not have any in the
       range ` ( N , 2 N ] ` by hypothesis, the product of the primes up
       through ` 2 N / 3 ` must be sufficient to compose the whole binomial
       coefficient.  (Contributed by Mario Carneiro, 13-Mar-2014.) $)
    bposlem3 $p |- ( ph -> ( seq 1 ( x. , F ) ` K ) = ( ( 2 x. N ) _C N ) ) $=
      ( c2 co wcel wa cle wbr cc0 cn c5 c3 cmul c1 cseq cfv cbc wceq cpc cprime
      cv wral cif cn0 simpr cfz cuz nnuz uztrn2 sylancr nnnn0d fzctr bccl2 3syl
      5nn adantr pccld ralrimiva cz cdiv cfl cr 2nn nnmulcl 3nn nndivre sylancl
      nnred flcld syl5eqel 3re a1i 5re 3lt5 ltleii eluzle syl letrd wb clt 2pos
      2re pm3.2i lemul2 mp3an13 3pos lemuldiv 2z flge syl6breqr eluz1i sylanbrc
      mpbid eluz2b2 simplbi oveq1 pcmpt iftrue adantl iffalse zred ltnle syl2an
      wn prmz biimpar ad2antrr simplr ad2antlr simprl lelttrd syl5eqbrr syl2anc
      fllt mpbird simprr bposlem2 expr wrex rspe adantll pm2.21dd cdivides nnzd
      wi cfa faccl nnmulcld nncnd eqtrd syl2anr wf dvdsmul1 bcctr oveq1d nnne0d
      divcan1d breqtrd dvdstr syl3anc mpan2d prmfac1 3expia sylan syld con3d id
      pceq0 sylibrd pm2.61d ex wo mpjaod syldan eqtr4d pm2.61dan pcmptcl simprd
      lelttric ffvelrnd pc11 ) ADUACUBUCZUDZKEUALZEUELZUFZFUIZUVKUGLZUVOUVMUGLZ
      UFZFUHUJZAUVRFUHAUVOUHMZNZUVPUVODOPZUVQQUKZUVQUWABUIZUVMUGLZUVQUVOBCDIAUW
      EULMZBUHUJUVTAUWFBUHAUWDUHMZNUWDUVMAUWGUMAUVMRMZUWGAEULMZEQUVLUNLMUWHAEAS
      RMESUOUDMZERMZVCGUBESRUPUQURZUSZEUTEUVLVAVBZVDVEVFZVDADRMZUVTADKUOUDMZUWP
      ADVGMKDOPZUWQADUVLTVHLZVIUDZVGJAUWSAUVLVJMZTRMUWSVJMZAUVLAKRMUWKUVLRMVKUW
      LKEVLURZVPZVMUVLTVNVOZVQVRZAKUWTDOAKUWSOPZKUWTOPZAKTUALUVLOPZUXGATEOPZUXI
      ATSETVJMZAVSVTSVJMAWAVTAEUWLVPZTSOPATSVSWAWBWCVTAUWJSEOPGSEWDWEWFAEVJMZUX
      JUXIWGZUXLUXKUXMKVJMZQKWHPZNUXNVSUXOUXPWJWIWKTEKWLWMWEXAAUXAUXIUXGWGZUXDU
      XOUXAUXKQTWHPZNUXQWJUXKUXRVSWNWKKUVLTWOWMWEXAAUXBKVGMUXGUXHWGUXEWPUWSKWQV
      OXAJWRZKDWPWSWTUWQUWPUBDWHPDXBXCWEZVDAUVTUMUWDUVOUVMUGXDXEUWAUWBUWCUVQUFZ
      UWBUYAUWAUWBUVQQXFXGUWAUWBXLZNUWCQUVQUYBUWCQUFUWAUWBUVQQXHXGUWAUYBDUVOWHP
      ZUVQQUFZUWAUYCUYBADVJMZUVOVJMZUYCUYBWGUVTADUXFXIZUVTUVOUVOXMZXIZDUVOXJXKX
      NUWAUYCNUVOEOPZUYDEUVOWHPZUWAUYCUYJUYDUWAUYCUYJNZNZUVOEAUWKUVTUYLUWLXOAUV
      TUYLXPUYMKDUVOUXOUYMWJVTAUYEUVTUYLUYGXOUYMUVOUVTUVOVGMZAUYLUYHXQZXIAUWRUV
      TUYLUXSXOUWAUYCUYJXRZXSUYMUWSUVOWHPZUWTUVOWHPZUYMUWTDUVOWHJUYPXTUYMUXBUYN
      UYQUYRWGAUXBUVTUYLUXEXOUYOUWSUVOYBYAYCUWAUYCUYJYDYEYFUWAUYKUYDYMUYCUWAUYK
      UYDUWAUYKNUVOUVLOPZUYDUWAUYKUYSUYDUWAUYKUYSNZNUYTFUHYGZUYDUVTUYTVUAAUYTFU
      HYHYIAVUAXLUVTUYTHXOYJYFUWAUYSXLZUYDYMUYKUWAVUBUVOUVMYKPZXLZUYDUWAVUCUYSU
      WAVUCUVOUVLYNUDZYKPZUYSUWAVUCUVMVUEYKPZVUFAVUGUVTAUVMUVMEYNUDZVUHUALZUALZ
      VUEYKAUVMVGMZVUIVGMUVMVUJYKPAUVMUWNYLZAVUIAVUHVUHAUWIVUHRMUWMEYOWEZVUMYPZ
      YLUVMVUIUUAYAAVUJVUEVUIVHLZVUIUALVUEAUVMVUOVUIUAAUWIUVMVUOUFUWMEUUBWEUUCA
      VUEVUIAVUEAUVLULMZVUERMAUVLUXCUSZUVLYOWEZYQAVUIVUNYQAVUIVUNUUDUUEYRUUFVDU
      WAUYNVUKVUEVGMZVUCVUGNVUFYMUVTUYNAUYHXGAVUKUVTVULVDAVUSUVTAVUEVURYLVDUVOU
      VMVUEUUGUUHUUIAVUPUVTVUFUYSYMVUQVUPUVTVUFUYSUVOUVLUUJUUKUULUUMUUNUVTUVTUW
      HUYDVUDWGAUVTUUOUWNUVOUVMUUPYSUUQVDUURUUSVDUWAUYJUYKUUTZUYCUVTUYFUXMVUTAU
      YIUXLUVOEUVGYSVDUVAUVBUVCUVDYRVFAUVKULMUVMULMUVNUVSWGAUVKARRDUVJARRCYTRRU
      VJYTAUWEBCIUWOUVEUVFUXTUVHUSAUVMUWNUSUVKUVMFUVIYAYC $.

    bpos.5 $e |- M = ( |_ ` ( sqr ` ( 2 x. N ) ) ) $.
    $( Lemma for ~ bpos .  (Contributed by Mario Carneiro, 13-Mar-2014.) $)
    bposlem4 $p |- ( ph -> M e. ( 3 ... K ) ) $=
      ( c2 c3 wcel cle wbr c5 c9 cr cmul co csqr cfv cfl cdiv cfz cuz cz cn 2nn
      5nn c1 nnuz uztrn2 sylancr nnmulcl nnred nnrpd rpge0d resqrcld flcld sqr9
      c10 9re 10re caddc lep1 ax-mp df-10 breqtrri nncni 5t2e10 mulcomli eluzle
      a1i 2cn syl wb cc0 clt 5re 2re 2pos pm3.2i lemul2 mp3an13 mpbid syl5eqbrr
      wa letrd 0re 9pos ltleii rprege0d sqrle nnzi flge sylancl eluz1i sylanbrc
      3nn nndivre sqrgt0d syl112anc wceq remsqsqr syl2anc breqtrd 3pos lemuldiv
      3re syl3anc flword2 elfzuzb oveq2i 3eltr4g ) AMFUAUBZUCUDZUEUDZNXRNUFUBZU
      EUDZUGUBZENDUGUBAXTNUHUDOZYBXTUHUDOZXTYCOAXTUIONXTPQZYDAXSAXRAXRAMUJOFUJO
      ZXRUJOUKARUJOFRUHUDOZYGULHUMFRUJUNUOUPZMFUQUPZURZAXRAXRYJUSZUTZVAZVBANXSP
      QZYFANSUCUDZXSPVCASXRPQZYPXSPQZASVDXRSTOZAVEVPVDTOAVFVPYKSVDPQASSUMVGUBZV
      DPYSSYTPQVESVHVIVJVKVPAVDMRUAUBZXRPRMVDRULVLVQVMVNARFPQZUUAXRPQZAYHUUBHRF
      VOVRAFTOZUUBUUCVSZAFYIURRTOUUDMTOZVTMWAQZWJUUEWBUUFUUGWCWDWERFMWFWGVRWHWI
      WKAYSVTSPQZWJXRTOZVTXRPQZWJYQYRVSYSUUHVEVTSWLVEWMWNWEAXRYLWOSXRWPUPWHWIZA
      XSTOZNUIOYOYFVSYNNXBWQZXSNWRWSWHNXTUUMWTXAAUULYATOZXSYAPQZYEYNAUUINUJOUUN
      YKXBXRNXCWSAXSNUAUBZXRPQZUUOAUUPXSXSUAUBZXRPAYOUUPUURPQZUUKANTOZUULUULVTX
      SWAQYOUUSVSUUTAXLVPYNYNAXRYLXDNXSXSWFXEWHAUUIUUJUURXRXFYKYMXRXGXHXIAUULUU
      IUUTVTNWAQZWJZUUQUUOVSYNYKUVBAUUTUVAXLXJWEVPXSXRNXKXMWHXSYAXNXMXTNYBXOXAL
      DYBNUGKXPXQ $.

    $( Lemma for ~ bpos .  Bound the product of all small primes in the
       binomial coefficient.  (Contributed by Mario Carneiro, 15-Mar-2014.) $)
    bposlem5 $p |- ( ph -> ( seq 1 ( x. , F ) ` M ) <_
                    ( ( 2 x. N ) ^c ( ( ( sqr ` ( 2 x. N ) ) / 3 ) + 2 ) ) ) $=
      ( c1 c2 co cn wcel cle wbr cr vx vk cmul cseq cfv cppi cexp csqr c3 caddc
      cdiv ccxp wf cv cbc cpc cn0 cprime id cc0 cfz cuz 5nn nnuz uztrn2 sylancr
      c5 nnnn0d fzctr bccl2 3syl syl2anr ralrimiva pcmptcl simprd 3nn cfl cz 2z
      pccl nnzd zmulcl zred 2nn nnmulcl nnrpd rpge0d resqrcld flcld c9 sqr9 c10
      9re a1i ax-mp 2cn syl wb nnred clt wa 2re pm3.2i lemul2 mp3an13 syl5eqbrr
      mpbid letrd jca sylancl eluz1i sylanbrc ppicl nnexpcld nndivre readdcl wi
      wceq fveq2 oveq2d breq12d imbi2d cif wn eleq1 iffalse 1ex adantr ad2antrr
      fvmpt nngt0 syl3anc adantl sylan sylan9eq eqbrtrd ffvelrn syl2an syl2anc
      nnre 10re lep1 df-10 breqtrri nncni 5t2e10 mulcomli eluzle 5re 0re ltleii
      2pos 9pos sqrle nnzi flge syl5eqel ffvelrnd recxpcld ppi1 syl6eq seq1 1nn
      1nprm mtbiri eqtri 1le1 eqbrtri exp0d syl5breqr ffvelrnda ad2antlr lemul1
      1z nnz ppiprm cc expp1d eqtrd breq2d bitr4d simpr syl6eleq seqp1 peano2nn
      zcnd oveq1 eqidd ifbieq12d ovex ifex iftrue bposlem1 simpld nnmulcld letr
      oveq12d mpand sylbid nncnd mulid1d 3eqtrd ppinprm biimprd pm2.61dan nnind
      expcom a2d mpcom cxpexp nn0red nn0ge0d ppiub syl5eqbr 3re lediv1 leadd1dd
      flle 3pos mulid1i nnge1d 1re eluz2b1 simprbi cxpled eqbrtrrd ) AEUCCMUDZU
      EZNFUCOZEUFUEZUGOZUYIUYIUHUEZUIUKOZNUJOZULOZAUYHAPPEUYGAPPCUMZPPUYGUMZABU
      NZUYIFUOOZUPOZBCJAUYTUQQZBURUYRURQZVUBUYSPQZVUAAVUBUSAFUQQFUTUYIVAOQVUCAF
      AVGPQFVGVBUEQZFPQZVCHMFVGPVDVEVFZVHFVIFUYIVJVKUYRUYSVTVLVMVNZVOZAUIPQZEUI
      VBUEZQEPQZVPAEUYLVQUEZVUJLAVULVRQUIVULRSZVULVUJQAUYLAUYIAUYIANVRQFVRQUYIV
      RQZVSAFVUFWANFWBVFZWCZAUYIAUYIANPQVUEUYIPQZWDVUFNFWEVFZWFWGZWHZWIAUIUYLRS
      ZVUMAUIWJUHUEZUYLRWKAWJUYIRSZVVBUYLRSZAWJWLUYIWJTQZAWMWNWLTQAUUAWNVUPWJWL
      RSAWJWJMUJOZWLRVVEWJVVFRSWMWJUUBWOUUCUUDWNAWLNVGUCOZUYIRVGNWLVGVCUUEWPUUF
      UUGAVGFRSZVVGUYIRSZAVUDVVHHVGFUUHWQAFTQZVVHVVIWRZAFVUFWSZVGTQVVJNTQZUTNWT
      SZXAZVVKUUIVVMVVNXBUULXCZVGFNXDXEWQXGXFXHAVVEUTWJRSZXAUYITQZUTUYIRSZXAVVC
      VVDWRVVEVVQWMUTWJUUJWMUUMUUKXCAVVRVVSVUPVUSXIWJUYIUUNVFXGXFAUYLTQZUIVRQVV
      AVUMWRVUTUIVPUUOZUYLUIUUPXJXGUIVULVWAXKXLUUQMEUIPVDVEVFZUURWSAUYKAUYIUYJV
      URAETQZUYJUQQZAEVWBWSZEXMWQZXNWSAUYIUYNVUPVUSAUYMTQZVVMUYNTQAVVTVUIVWGVUT
      VPUYLUIXOXJZXBUYMNXPXJZUUSVUKAUYHUYKRSZVWBAUAUNZUYGUEZUYIVWKUFUEZUGOZRSZX
      QAMUYGUEZUYIUTUGOZRSZXQAUBUNZUYGUEZUYIVWSUFUEZUGOZRSZXQAVWSMUJOZUYGUEZUYI
      VXDUFUEZUGOZRSZXQAVWJXQUAUBEVWKMXRZVWOVWRAVXIVWLVWPVWNVWQRVWKMUYGXSVXIVWM
      UTUYIUGVXIVWMMUFUEUTVWKMUFXSUUTUVAXTYAYBVWKVWSXRZVWOVXCAVXJVWLVWTVWNVXBRV
      WKVWSUYGXSVXJVWMVXAUYIUGVWKVWSUFXSXTYAYBVWKVXDXRZVWOVXHAVXKVWLVXEVWNVXGRV
      WKVXDUYGXSVXKVWMVXFUYIUGVWKVXDUFXSXTYAYBVWKEXRZVWOVWJAVXLVWLUYHVWNUYKRVWK
      EUYGXSVXLVWMUYJUYIUGVWKEUFXSXTYAYBAVWPMVWQRVWPMMRVWPMCUEZMMVRQVWPVXMXRUVN
      UCCMUVBWOMPQVXMMXRUVCBMVUBUYRUYTUGOZMYCZMPCUYRMXRZVUBYDVXOMXRVXPVUBMURQUV
      DUYRMURYEUVEVUBVXNMYFWQJYGYJWOUVFUVGUVHAUYIAUYIVUOUWFZUVIUVJVWSPQZAVXCVXH
      AVXRVXCVXHXQZAVXRXAZVXDURQZVXSVXTVYAXAZVXCVWTUYIUCOZVXGRSZVXHVYBVXCVYCVXB
      UYIUCOZRSZVYDVYBVWTTQZVXBTQVVRUTUYIWTSZXAZVXCVYFWRVXTVYGVYAVXTVWTAPPVWSUY
      GVUHUVKZWSYHVYBVXBVYBUYIVXAAVUQVXRVYAVURYIVYBVWSTQZVXAUQQVXRVYKAVYAVWSYTU
      VLVWSXMWQZXNWSAVYIVXRVYAAVUQVYIVURVUQVVRVYHUYIYTUYIYKXIWQYIVWTVXBUYIUVMYL
      VYBVXGVYEVYCRVYBVXGUYIVXAMUJOZUGOVYEVYBVXFVYMUYIUGVXTVWSVRQZVYAVXFVYMXRVX
      RVYNAVWSUVOYMZVWSUVPYNXTVYBUYIVXAAUYIUVQQZVXRVYAVXQYIVYLUVRUVSUVTUWAVYBVX
      EVYCRSZVYDVXHVYBVXEVWTVXDCUEZUCOZVYCRVXTVXEVYSXRZVYAVXTVWSMVBUEZQVYTVXTVW
      SPWUAAVXRUWBVDUWCUCCMVWSUWDWQZYHVYBVYRUYIRSZVYSVYCRSZVYBVYRVXDVXDUYSUPOZU
      GOZUYIRVXTVYAVYRVYAWUFMYCZWUFVXTVXDPQZVYRWUGXRVXRWUHAVWSUWEZYMZBVXDVXOWUG
      PCUYRVXDXRZVUBVYAVXNMWUFMUYRVXDURYEWUKUYRVXDUYTWUEUGWUKUSUYRVXDUYSUPUWGUW
      QWUKMUWHUWIJVYAWUFMVXDWUEUGUWJYGUWKYJWQZVYAWUFMUWLYOVXTVUEVYAWUFUYIRSAVUE
      VXRVUFYHVXDFUWMYNYPVYBVYRTQZVVRVYGUTVWTWTSZXAZWUCWUDWRVXTWUMVYAVXTVYRAUYP
      WUHVYRPQVXRAUYPUYQVUGUWNWUIPPVXDCYQYRWSYHAVVRVXRVYAVUPYIVXTWUOVYAVXTVWTPQ
      ZWUOVYJWUPVYGWUNVWTYTVWTYKXIWQYHVYRUYIVWTXDYLXGYPVXTVYQVYDXAVXHXQZVYAVXTV
      XETQVYCTQVXGTQWUQVXTVXEAUYQWUHVXEPQVXRVUHWUIPPVXDUYGYQYRWSVXTVYCVXTVWTUYI
      VYJAVUQVXRVURYHZUWOWSVXTVXGVXTUYIVXFWURVXTVXDTQVXFUQQVXTVXDWUJWSVXDXMWQXN
      WSVXEVYCVXGUWPYLYHUWRUWSVXTVYAYDZXAZVXHVXCWUTVXEVWTVXGVXBRWUTVXEVYSVWTMUC
      OVWTVXTVYTWUSWUBYHWUTVYRMVWTUCVXTWUSVYRWUGMWULVYAWUFMYFYOXTWUTVWTWUTVWTVX
      TWUPWUSVYJYHUWTUXAUXBWUTVXFVXAUYIUGVXTVYNWUSVXFVXAXRVYOVWSUXCYNXTYAUXDUXE
      UXGUXHUXFUXIAUYIUYJULOZUYKUYORAVYPVWDWVAUYKXRVXQVWFUYIUYJUXJYSAUYJUYNRSWV
      AUYORSAUYJEUIUKOZNUJOZUYNAUYJVWFUXKZAWVBTQZVVMWVCTQAVWCVUIWVEVWEVPEUIXOXJ
      ZXBWVBNXPXJVWIAVWCUTERSUYJWVCRSVWEAEAEVWBVHUXLEUXMYSAWVBUYMNWVFVWHVVMAXBW
      NAEUYLRSZWVBUYMRSZAEVULUYLRLAVVTVULUYLRSVUTUYLUXRWQUXNAVWCVVTUITQZUTUIWTS
      ZXAZWVGWVHWRVWEVUTWVKAWVIWVJUXOUXSXCWNEUYLUIUXPYLXGUXQXHAUYIUYJUYNVUPAUYI
      NVBUEQZMUYIWTSZAVUNNUYIRSWVLVUOANNMUCOZUYIRNWPUXTAMFRSZWVNUYIRSZAFVUFUYAA
      VVJWVOWVPWRZVVLMTQVVJVVOWVQUYBVVPMFNXDXEWQXGXFNUYIVSXKXLWVLVUNWVMUYIUYCUY
      DWQWVDVWIUYEXGUYFXH $.

    $( Lemma for ~ bpos .  By using the various bounds at our disposal, arrive
       at an inequality that is false for ` N ` large enough.  (Contributed by
       Mario Carneiro, 14-Mar-2014.) $)
    bposlem6 $p |- ( ph -> ( ( 4 ^ N ) / N ) <
      ( ( ( 2 x. N ) ^c ( ( ( sqr ` ( 2 x. N ) ) / 3 ) + 2 ) ) x.
        ( 2 ^c ( ( ( 4 x. N ) / 3 ) - 5 ) ) ) ) $=
      ( co c2 c3 cn wcel cr clt wbr c4 cexp cdiv cmul cfv caddc ccxp c5 cn0 4nn
      cmin cuz 5nn c1 uztrn2 sylancr nnred cc0 cfz syl nnmulcl nnrpd rpge0d 3nn
      nnuz nndivre sylancl 2re rpred crp 2rp rpcxpcl remulcld cz nnzi eqid cseq
      5re wf cv cpc cprime pccl syl2anr ralrimiva ffvelrnd cfl zsubcl zred ccht
      id 2z ce cdivides wne wb nnne0d syl2anc dvdsval2 syl3anc mpbid cle eluzle
      nnzd efchtcl wral wa wn cif syl2an adantl adantr wceq a1i 3imtr4d 3brtr4d
      wi iftrue iffalse pcmpt2 cmpt prmorcht oveq2d eqtrd mpbird nngt0d 4re 6re
      c6 clog ax-mp eqtri 3re chtcl ltletrd 4pos cc zcnd 2cn pm3.2i csqr nnnn0d
      cbc nnexpcl nndivred fzctr 2nn resqrcld readdcl rpcxpcld resubcl peano2uz
      bccl2 df-5 uzid mp2b eqeltri bclbnd simprd bposlem4 elfzuz flcld syl5eqel
      pcmptcl zmulcl bposlem3 elfzuz3 pcmptdvds uztrn eluzelre efchtdvds breq1i
      prmz fllt syl6bbr ltnle bitrd bposlem1 sylan resqcld lelttr mpand resqrth
      reexpcld breq1d prmuz2 eluz2b1 simprbi ltexp2d df-2 breq2i syl6ib sqrge0d
      nn0zd lt2sqd 1z zleltp1 sylbird imp adantrl 0le0 breq12d mpbiri pm2.61dan
      prmnn simpr oveq1 oveq12d nncn exp1d ifeq1d mpteq2ia eqcomi eqidd pc2dvds
      1nn0 divgt0d elnnz sylanbrc dvdsle 4lt6 cht3 fveq2i 6pos reeflog chtwordi
      elrpii efle syl5eqbrr ltdiv2OLD syl33anc 2lt3 letrd chtub relogcl remulcl
      mpd reexplog recni mulcom fveq2d breqtrrd 3p2e5 oveq1i pncan mp2an eqtr3i
      eflt 3cn oveq2i nncni subsub mp3an23 syl5eqr 2ne0 cxpexpz mp3an12 mp3an13
      cxpadd 3eqtr3d 2nn0 cxpexp sq2 breqtrd ltdivmul2 lttrd lelttrd nnre nngt0
      syl6eq ltdivmul eqbrtrrd bposlem5 lemul1d flle syl5eqbr 2pos lemul2 nncnd
      jca 3ne0 divass 2t2e4 mulass syl5reqr oveq1d eqtr3d lesub1dd 1lt2 lemul2d
      cxpled ) AUAFUBMZFUCMZNFUDMZFUUCMZVWNVWNUUAUEZOUCMZNUFMZUGMZNUAFUDMZOUCMZ
      UHUKMZUGMZUDMZAVWLFAVWLAUAPQZFUIQZVWLPQUJAFAUHPQFUHULUEQZFPQZUMHUNFUHPVEU
      OUPZUUBZUAFUUDUPUQVXIUUEAVWOAFURVWNUSMQZVWOPQZAVXFVXKVXJFUUFUTFVWNUUMUTZU
      QZAVWSVXCAVWSAVWNVWRAVWNANPQVXHVWNPQUUGVXINFVAUPZVBZAVWQRQZNRQZVWRRQAVWPR
      QZOPQZVXQAVWNAVWNVXOUQZAVWNVXPVCZUUHZVDVWPOVFVGVHVWQNUUIVGUUJZVIZAVXCANVJ
      QZVXBRQZVXCVJQVKAVXARQZUHRQZVYGAVWTRQVXTVYHAVWTAVXEVXHVWTPQUJVXIUAFVAUPUQ
      VDVWTOVFVGZVRVXAUHUUKVGZNVXBVLUPVIZVMZAFUAULUEZQZVWMVWOSTAUHVYNQVXGVYOUHU
      AUNUFMZVYNUUNUAVNQUAVYNQVYPVYNQUAUJVOUAUUOUAUAUULUUPUUQHUAFUHVYNVYNVPUOUP
      FUURUTAVWOEUDCUNVQZUEZNNDUDMZUHUKMZUGMZUDMZVXDVXNAVYRWUAAVYRAPPEVYQAPPCVS
      PPVYQVSABVTZVWOWAMZBCJAWUDUIQZBWBWUCWBQZWUFVXLWUEAWUFWKVXMWUCVWOWCWDWEZUV
      DUUSZAVXTEOULUEZQZEPQZVDAEODUSMQZWUJABCDEFGHIJKLUUTZEODUVAUTZUNEOPVEUOUPZ
      WFZUQZAWUAAVYFVYTRQWUAVJQVKAVYTAVYSVNQZUHVNQVYTVNQANVNQZDVNQWURWLADVWNOUC
      MZWGUEZVNKAWUTAVWNRQZVXTWUTRQZVYAVDVWNOVFVGZUVBUVCZNDUVEUPZUHUMVOVYSUHWHV
      GZWIZNVYTVLUPZVIZVMZVYMADVYQUEZVWOWUBSABCDFGHIJKUVFAWVLVYRUCMZWUASTZWVLWU
      BSTZAWVMDWJUEZWMUEZEWJUEZWMUEZUCMZWUAAWVMAVYRWVLWNTZWVMVNQZAWUDBCDEJWUGWU
      OAWULDEULUEQZWUMEODUVGUTZUVHAVYRVNQVYRURWOWVLVNQWWAWWBWPAVYRWUPXDAVYRWUPW
      QAWVLAPPDVYQWUHAVXTDWUIQZDPQZVDAWWCWUJWWEWWDWUNEDOUVIWRUNDOPVEUOUPZWFZXDV
      YRWVLWSWTXAZWIAWVTAWVSWVQWNTZWVTVNQZAERQZDRQZEDXBTZWWJAEWUOUQZAWWCWWMWWDE
      DUVJUTZAWWCWWNWWDEDXCUTZEDUVKWTAWVSVNQWVSURWOWVQVNQWWJWWKWPAWVSAWWLWVSPQW
      WOEXEUTZXDAWVSWWRWQAWVQAWWMWVQPQWWPDXEUTZXDWVSWVQWSWTXAZWIZWVJAWVMWVTWNTZ
      WVMWVTXBTZAWXBGVTZWVMWAMZWXDWVTWAMZXBTZGWBXFZAWXGGWBAWXDWBQZXGZWXDDXBTZWX
      DEXBTXHZXGZWXDVWOWAMZURXIZWXMUNURXIZWXEWXFXBWXJWXMWXOWXPXBTZWXJWXMXGWXNUN
      WXOWXPXBWXJWXLWXNUNXBTZWXKWXJWXLWXRWXJWXLVWPWXDSTZWXRWXJWXSEWXDSTZWXLWXJW
      XSVWPWGUEZWXDSTZWXTAVXSWXDVNQZWXSWYBWPWXIVYCWXDUVMZVWPWXDUVNXJEWYAWXDSLUV
      LUVOAWWLWXDRQZWXTWXLWPWXIWWOWXIWXDWYDWIZEWXDUVPXJUVQWXJVWPNUBMZWXDNUBMZST
      ZWXNUNUNUFMZSTZWXSWXRWXJWYIWXNNSTZWYKWXJVWNWYHSTZWXDWXNUBMZWYHSTZWYIWYLWX
      JWYNVWNXBTZWYMWYOAVXHWXIWYPVXIWXDFUVRUVSWXJWYNRQWVBWYHRQWYPWYMXGWYOXQWXJW
      XDWXNWXIWYEAWYFXKZWXIWXIVXLWXNUIQAWXIWKVXMWXDVWOWCWDZUWDAWVBWXIVYAXLWXJWX
      DWYQUVTWYNVWNWYHUWAWTUWBAWYIWYMWPWXIAWYGVWNWYHSAWVBURVWNXBTWYGVWNXMVYAVYB
      VWNUWCWRUWEXLWXJWXDWXNNWYQWXJWXNWYRUWNZWUSWXJWLXNWXIUNWXDSTZAWXIWXDNULUEQ
      ZWYTWXDUWFXUAWYCWYTWXDUWGUWHUTXKUWIXONWYJWXNSUWJUWKUWLWXJVWPWXDAVXSWXIVYC
      XLWYQAURVWPXBTWXIAVWNVYAVYBUWMXLWXIURWXDXBTAWXIWXDWXIWXDWXDUXEVBVCXKUWOWX
      JWXNVNQUNVNQWXRWYKWPWYSUWPWXNUNUWQVGXOUWRUWSUWTWXMWXOWXNXMWXJWXMWXNURXRXK
      WXMWXPUNXMWXJWXMUNURXRXKXPWXMXHZWXQWXJXUBWXQURURXBTUXAXUBWXOURWXPURXBWXMW
      XNURXSWXMUNURXSUXBUXCXKUXDWXJWUDWXNWXDBCDEJAWUEBWBXFWXIWUGXLAWUKWXIWUOXLZ
      AWXIUXFZWUCWXDVWOWAUXGAWWCWXIWWDXLZXTWXJWXFWXDDUDBPWUFWUCUNXIZYAZUNVQZUEZ
      EXUHUEZUCMZWAMWXPWXJWVTXUKWXDWAAWVTXUKXMWXIAWVQXUIWVSXUJUCAWWFWVQXUIXMWWG
      DBXUGXUGVPZYBUTAWUKWVSXUJXMWUOEBXUGXULYBUTUXHXLYCWXJUNUNWXDBXUGDEBPWUFWUC
      UNUBMZUNXIZYAXUGBPXUNXUFWUCPQZWUFXUMWUCUNXUOWUCWUCUXIUXJUXKUXLUXMAUNUIQZB
      WBXFWXIAXUPBWBXUPAWUFXGUXPXNWEXLXUCXUDWUCWXDXMUNUXNXUEXTYDXPWEAWWBWWKWXBW
      XHWPWWIWWTWVMWVTGUXOWRYEAWWBWVTPQZWXBWXCXQWWIAWWKURWVTSTXUQWWTAWVQWVSAWVQ
      WWSUQZAWVSWWRUQZAWVQWWSYFZAWVSWWRYFZUXQWVTUXRUXSWVMWVTUXTWRUYQAWVTWVQUAUC
      MZWUAWXAAWVQRQZVXEXVBRQXURUJWVQUAVFVGWVJAUAWVSSTZWVTXVBSTZAUAYIWVSUARQZAY
      GXNZYIRQAYHXNXUSUAYISTAUYAXNAYIOWJUEZWMUEZWVSXBXVIYIYJUEZWMUEZYIXVHXVJWMU
      YBUYCYIVJQXVKYIXMYIYHUYDUYGYIUYEYKYLAXVHWVRXBTZXVIWVSXBTZAORQZWWLOEXBTZXV
      LXVNAYMXNZWWOAWUJXVOWUNOEXCUTZOEUYFWTAXVHRQZWVRRQZXVLXVMWPXVNXVRYMOYNYKAW
      WLXVSWWOEYNUTXVHWVRUYHUPXAUYIYOAXVFWVSRQXVCURUASTZURWVSSTURWVQSTXVDXVEWPX
      VGXUSXURXVTAYPXNXVAXUTUAWVSWVQUYJUYKXAAXVBWUASTZWVQWUAUAUDMZSTZAWVQNVYSOU
      KMZUBMZXWBSAWVQNYJUEZXWDUDMZWMUEZXWESAWVPXWGSTZWVQXWHSTZAWWMNDSTXWIWWPANO
      DVXRAVHXNZXVPWWPNOSTAUYLXNAOEDXVPWWOWWPXVQWWQUYMYODUYNWRAWVPRQZXWGRQZXWIX
      WJWPAWWMXWLWWPDYNUTAXWFRQZXWDRQXWMVYFXWNVKNUYOYKZAXWDAWUROVNQXWDVNQZWVFOV
      DVOVYSOWHVGZWIXWFXWDUYPUPWVPXWGVUHWRXAAXWEXWDXWFUDMZWMUEZXWHAVYFXWPXWEXWS
      XMVKXWQNXWDUYRUPAXWRXWGWMAXWDYQQXWFYQQXWRXWGXMAXWDXWQYRXWFXWOUYSXWDXWFUYT
      VGVUAYDVUBAXWEWUANNUGMZUDMZXWBANXWDUGMZNVYTNUFMZUGMZXWEXXAAXWDXXCNUGAXWDV
      YSUHNUKMZUKMZXXCXXEOVYSUKONUFMZNUKMZXXEOXXGUHNUKVUCVUDOYQQZNYQQZXXHOXMVUI
      YSONVUEVUFVUGVUJAVYSYQQZXXFXXCXMZAVYSWVFYRXXKUHYQQXXJXXLUHUMVUKYSVYSUHNVU
      LVUMUTVUNYCAXWPXXBXWEXMZXWQXXJNURWOZXWPXXMYSVUONXWDVUPVUQUTAVYTYQQZXXDXXA
      XMZAVYTWVGYRXXJXXNXGXXOXXJXXPXXJXXNYSVUOYTYSNVYTNVUSVURUTVUTXWTUAWUAUDXWT
      NNUBMZUAXXJNUIQXWTXXQXMYSVVANNVVBVUFVVCYLVUJVVJVVDAXVCWUARQZXVFXVTXGZXWAX
      WCWPXURWVJXXSAXVFXVTYGYPYTXNWVQWUAUAVVEWTYEVVFVVGAWVLRQXXRVYRRQZURVYRSTZX
      GZWVNWVOWPAWVLWWHUQWVJAVYRPQZXYBWUPXYCXXTXYAVYRVVHVYRVVIVVTUTWVLWUAVYRVVK
      WTXAVVLAWUBVWSWUAUDMZVXDWVKAVWSWUAVYEWVJVMVYMAVYRVWSXBTWUBXYDXBTABCDEFGHI
      JKLVVMAVYRVWSWUAWUQVYEWVIVVNXAAWUAVXCXBTZXYDVXDXBTAVYTVXBXBTXYEAVYSVXAUHA
      VYSWVFWIVYJVYIAVRXNAVYSNWUTUDMZVXAXBADWUTXBTZVYSXYFXBTZADWVAWUTXBKAWVCWVA
      WUTXBTWVDWUTVVOUTVVPAWWMWVCVXRURNSTZXGZXYGXYHWPADWVEWIWVDXYJAVXRXYIVHVVQY
      TXNDWUTNVVRWTXAANVWNUDMZOUCMZXYFVXAAVWNYQQZXYLXYFXMZAVWNVXOVVSXXJXYMXXIOU
      RWOZXGXYNYSXXIXYOVUIVWAYTNVWNOVWBVURUTAXYKVWTOUCAVWTNNUDMZFUDMZXYKXYPUAFU
      DVWCVUDAFYQQZXYQXYKXMZAFVXIVVSXXJXXJXYRXYSYSYSNNFVWDVUQUTVWEVWFVWGVVDVWHA
      NVYTVXBXWKUNNSTAVWIXNWVHVYKVWKXAAWUAVXCVWSWVJVYLVYDVWJXAUYMYOVVF $.
  $}

  ${
    bposlem7.1 $e |- F = ( n e. NN |->
                           ( ( ( ( sqr ` 2 ) x. ( G ` ( sqr ` n ) ) ) +
                               ( ( 9 / 4 ) x. ( G ` ( n / 2 ) ) ) ) +
                             ( ( log ` 2 ) / ( sqr ` ( 2 x. n ) ) ) ) ) $.
    bposlem7.2 $e |- G = ( x e. RR+ |-> ( ( log ` x ) / x ) ) $.
    ${
      $d n A $.  $d n B $.  $d n G $.  $d x A $.  $d x B $.
      bposlem7.3 $e |- ( ph -> A e. NN ) $.
      bposlem7.4 $e |- ( ph -> B e. NN ) $.
      bposlem7.5 $e |- ( ph -> ( _e ^ 2 ) <_ A ) $.
      bposlem7.6 $e |- ( ph -> ( _e ^ 2 ) <_ B ) $.
      $( Lemma for ~ bpos .  The function ` F ` is decreasing.  (Contributed by
         Mario Carneiro, 13-Mar-2014.) $)
      bposlem7 $p |- ( ph -> ( A < B -> ( F ` B ) < ( F ` A ) ) ) $=
        ( clt wbr c2 co crp wcel cr csqr cfv cmul c9 c4 cdiv caddc clog wa cexp
        wceq nnrpd rpsqrcld cv fveq2 id oveq12d fvmpt syl breq12d ceu cle rpred
        ovex wb cc0 rprege0d resqrth breqtrrd rpge0d ere 0re epos le2sq mpanl12
        ltleii syl2anc mpbird logdivlt syl22anc lt2sqd 3bitr2rd relogcl mpancom
        rerpdivcl fmpti ffvelrni rpsqrcl mp1i ltmul2d 3bitr3d biimpd nnred 2pos
        2rp 2re pm3.2i a1i ltdiv1 syl3anc rphalfcld remulcli resqcli c3 egt2lt3
        simpli lemul2i ax-mp recni sqvali breqtrri letrd lemuldiv mp3an13 mpbid
        mpbi bitrd cn 9nn 4nn nnrp rpdivcl syl2an mp2an 3bitr2d jcad wi remulcl
        sqr2re sylancr lt2add syld rpmulcl rprege0 readdcld fveq2d oveq2d oveq1
        9re oveq2 nnne0i redivcli ltmul2 lt2sq bitr2d c1 rplogcl ltdiv2d 3bitrd
        4re 1lt2 rpre sylibrd ) ACDNOZPUAUBZDUAUBZGUBZUCQZUDUEUFQZDPUFQZGUBZUCQ
        ZUGQZPUHUBZPDUCQZUAUBZUFQZUGQZUUOCUAUBZGUBZUCQZUUSCPUFQZGUBZUCQZUGQZUVD
        PCUCQZUAUBZUFQZUGQZNOZDFUBZCFUBZNOAUUNUVCUVONOZUVGUVRNOZUIZUVTAUUNUWCUW
        DAUUNUURUVKNOZUVBUVNNOZUIZUWCAUUNUWFUWGAUUNUWFAUVIPUJQZUUPPUJQZNOZUUQUV
        JNOZUUNUWFAUWLUUPUHUBZUUPUFQZUVIUHUBZUVIUFQZNOZUVIUUPNOZUWKAUUQUWNUVJUW
        PNAUUPRSZUUQUWNUKADADKULZUMZBUUPBUNZUHUBZUXBUFQZUWNRGUXBUUPUKZUXCUWMUXB
        UUPUFUXBUUPUHUOUXEUPUQIUWMUUPUFVDURUSAUVIRSZUVJUWPUKACACJULZUMZBUVIUXDU
        WPRGUXBUVIUKZUXCUWOUXBUVIUFUXBUVIUHUOUXIUPUQIUWOUVIUFVDURUSUTAUVITSZVAU
        VIVBOZUUPTSZVAUUPVBOZUWRUWQVEAUVIUXHVCZAUXKVAPUJQZUWIVBOZAUXOCUWIVBLACT
        SZVFCVBOUIUWICUKACUXGVGCVHUSZVIAUXJVFUVIVBOZUXKUXPVEZUXNAUVIUXHVJZVATSZ
        VFVAVBOZUXJUXSUIUXTVKVFVAVLVKVMVPZVAUVIVNVOVQVRAUUPUXAVCZAUXMUXOUWJVBOZ
        AUXODUWJVBMADTSZVFDVBOUIUWJDUKADUWTVGDVHUSZVIAUXLVFUUPVBOZUXMUYFVEZUYEA
        UUPUXAVJZUYBUYCUXLUYIUIUYJVKUYDVAUUPVNVOVQVRUVIUUPVSVTAUVIUUPUXNUYEUYAU
        YKWAWBAUWICUWJDNUXRUYHUTAUUQUVJUUOAUWSUUQTSZUXARTUUPGBRTUXDGIUXCTSUXBRS
        UXDTSUXBWCUXCUXBWEWDWFZWGUSZAUXFUVJTSZUXHRTUVIGUYMWGUSZPRSZUUORSAWOPWHW
        IWJWKWLAUUNUWGAUUNUUTUHUBZUUTUFQZUVLUHUBZUVLUFQZNOZUVAUVMNOUWGAUUNUVLUU
        TNOZVUBAUXQUYGPTSZVFPNOZUIZUUNVUCVEACJWMZADKWMZVUFAVUDVUEWPWNWQZWRZCDPW
        SWTAUVLTSVAUVLVBOZUUTTSVAUUTVBOZVUCVUBVEAUVLACUXGXAZVCAVAPUCQZCVBOZVUKA
        VUNUXOCVUNTSAVAPVKWPXBWRZUXOTSAVAVKXCWRZVUGVUNUXOVBOAVUNVAVAUCQZUXOVBPV
        AVBOZVUNVURVBOZPVAWPVKPVANOVAXDNOXEXFVPVFVANOVUSVUTVEVMPVAVAWPVKVKXGXHX
        PVAVAVKXIXJXKWRZLXLAUXQVUOVUKVEZVUGUYBUXQVUFVVBVKVUIVACPXMXNUSXOAUUTADU
        WTXAZVCAVUNDVBOZVULAVUNUXODVUPVUQVUHVVAMXLAUYGVVDVULVEZVUHUYBUYGVUFVVEV
        KVUIVADPXMXNUSXOUVLUUTVSVTXQAUVAUYSUVMVUANAUUTRSZUVAUYSUKVVCBUUTUXDUYSR
        GUXBUUTUKZUXCUYRUXBUUTUFUXBUUTUHUOVVGUPUQIUYRUUTUFVDURUSAUVLRSZUVMVUAUK
        VUMBUVLUXDVUARGUXBUVLUKZUXCUYTUXBUVLUFUXBUVLUHUOVVIUPUQIUYTUVLUFVDURUSU
        TAUVAUVMUUSAVVFUVATSZVVCRTUUTGUYMWGUSZAVVHUVMTSZVUMRTUVLGUYMWGUSZUUSRSZ
        AUDXRSZUEXRSZVVNXSXTVVOUDRSUERSVVNVVPUDYAUEYAUDUEYBYCYDWRWJYEWLYFAUURTS
        ZUVBTSZUVKTSZUVNTSZUWHUWCYGAUUOTSZUYLVVQYIUYNUUOUUQYHYJZAUUSTSZVVJVVRUD
        UEYSUUJUEXTUUAUUBZVVKUUSUVAYHYJZAVWAUYOVVSYIUYPUUOUVJYHYJZAVWCVVLVVTVWD
        VVMUUSUVMYHYJZUURUVBUVKUVNYKVTYLAUUNUWDAUUNUVPUVENOZUVQUVFNOZUWDAUXQUYG
        VUFUUNVWHVEVUGVUHVUJCDPUUCWTAVWIUVQPUJQZUVFPUJQZNOZVWHAUVQRSZUVFRSZVWIV
        WLVEZAUVPAUYQCRSUVPRSWOUXGPCYMYJZUMZAUVEAUYQDRSUVERSWOUWTPDYMYJZUMZVWMU
        VQTSVFUVQVBOUIUVFTSVFUVFVBOUIVWOVWNUVQYNUVFYNUVQUVFUUDYCVQAVWJUVPVWKUVE
        NAUVPTSVFUVPVBOUIVWJUVPUKAUVPVWPVGUVPVHUSAUVETSVFUVEVBOUIVWKUVEUKAUVEVW
        RVGUVEVHUSUTUUEAUVQUVFUVDVWQVWSUVDRSZAVUDUUFPNOVWTWPUUKPUUGYDZWRUUHUUIW
        LYFAUVCTSUVGTSZUVOTSUVRTSZUWEUVTYGAUURUVBVWBVWEYOAUVDTSZVWNVXBVWTVXDVXA
        UVDUULXHZVWSUVDUVFWEYJAUVKUVNVWFVWGYOAVXDVWMVXCVXEVWQUVDUVQWEYJUVCUVGUV
        OUVRYKVTYLAUWAUVHUWBUVSNADXRSUWAUVHUKKEDUUOEUNZUAUBZGUBZUCQZUUSVXFPUFQZ
        GUBZUCQZUGQZUVDPVXFUCQZUAUBZUFQZUGQZUVHXRFVXFDUKZVXMUVCVXPUVGUGVXRVXIUU
        RVXLUVBUGVXRVXHUUQUUOUCVXRVXGUUPGVXFDUAUOYPYQVXRVXKUVAUUSUCVXRVXJUUTGVX
        FDPUFYRYPYQUQVXRVXOUVFUVDUFVXRVXNUVEUAVXFDPUCYTYPYQUQHUVCUVGUGVDURUSACX
        RSUWBUVSUKJECVXQUVSXRFVXFCUKZVXMUVOVXPUVRUGVXSVXIUVKVXLUVNUGVXSVXHUVJUU
        OUCVXSVXGUVIGVXFCUAUOYPYQVXSVXKUVMUUSUCVXSVXJUVLGVXFCPUFYRYPYQUQVXSVXOU
        VQUVDUFVXSVXNUVPUAVXFCPUCYTYPYQUQHUVOUVRUGVDURUSUTUUM $.
    $}

    $( Lemma for ~ bpos .  Evaluate ` F ( 6 4 ) ` and show it is less than
       ` log 2 ` .  (Contributed by Mario Carneiro, 14-Mar-2014.) $)
    bposlem8 $p |- ( ( F ` ; 6 4 ) e. RR /\ ( F ` ; 6 4 ) < ( log ` 2 ) ) $=
      ( c4 wcel c2 clt wbr c3 cdiv co c5 cmul caddc c1 c8 wceq c6 cdc clog csqr
      cfv cr c9 cexp cn 4nn fveq2 8nn nncni eqtri fveq2i cc0 cle 0re 8re ltleii
      cv 8pos ax-mp eqtr3i syl6eq fveq2d crp nnrp cu2 cz 3nn0 relogexp mp2an id
      2rp oveq12d 3cn mp2b recni nnne0i div23i ovex fvmpt oveq2d sqr2re mulassi
      2nn divcli 4cn 2re oveq2i 4t2e8 3eqtri cc mulcli rpmulcl rpne0 wa divcan5
      wne mp3an1 mp4an eqtr4i 3eqtr3ri oveq1i df-6 cn0 2cn 5nn0 3eqtr3i nnexpcl
      expp1 2ne0 5nn syl6eqr adddiri nnrei nngt0i 3re 4re redivcli 9re remulcli
      mp3an 5re readdcli c7 ax-1cn divdiri mulcomli oveq12i cmin c10 3brtr4i wb
      4nn0 7re mpbir mpbi 1re decnncl sqvali 8t8e64 sqrsqi nn0zi relogcl mul12i
      6nn0 2pos remsqsqr rpsqrcl divdiv1 divassi oveq1 2exp6 divcan4i 9nn oveq2
      nnzi sqrmulii sylancr divrec2 mulcomi recdiv2 addcli rereccli eqeltri 6nn
      reccli add32i df-7 3t2e6 3eqtr4ri divdiv32i 9nn0 0nn0 9lt10 decltc 7t7e49
      4lt5 mul4i 5t2e10 dec0u 7pos rpge0 rpre lt2msqi ltdivmul mp3an12 ltdiv1ii
      7nn rpgt0 divsubdir 5p3e8 dividi 5lt8 ltadd2i df-9 mulid2i adddii mulid1i
      pncan 6re nnmulcli divmuldivi df-4 4p3e7 5p2e7 addcomi 3eqtr2i expadd sq2
      2nn0 ltsub2 eqbrtrri resubcli lttri ltaddsubi eqbrtri 1lt2 rplogcl eqcomi
      ltmul1ii pm3.2i ) UAGUBZCUEZUFHUYFIUCUEZJKUYFLGMNZIUDUEZMNZUGGMNZOIOUHNZM
      NZPNZQNZRSMNZUYIMNZQNZUYGPNZUFUYEUIHUYFUYSTUAGUUHUJUUAZBUYEUYIBVAZUDUEZDU
      EZPNZUYKVUAIMNZDUEZPNZQNZUYGIVUAPNZUDUEZMNZQNZUYSUICVUAUYETZVULUYOUYGPNZU
      YQUYGPNZQNUYSVUMVUHVUNVUKVUOQVUMVUHUYJUYGPNZUYNUYGPNZQNVUNVUMVUDVUPVUGVUQ
      QVUMVUDUYILSMNZUYGPNZPNZVUPVUMVUCVUSUYIPVUMVUCSDUEZVUSVUMVUBSDVUMVUBUYEUD
      UEZSVUAUYEUDUKSIUHNZUDUEZVVBSVVCUYEUDVVCSSPNUYESSULUMZUUBUUCUNUOUPSUQKVVD
      STUPSURUSVBUTSUSUUDVCVDZVEVFSUIHZSVGHZVVAVUSTULSVHZASAVAZUCUEZVVJMNZVUSVG
      DVVJSTZVVLLUYGPNZSMNVUSVVMVVKVVNVVJSMVVMVVKSUCUEZVVNVVJSUCUKILUHNZUCUEZVV
      OVVNVVPSUCVIUOIVGHZLVJHVVQVVNTVOLVKUUEILVLVMVDVEVVMVNVPLUYGSVQUYGIUIHZVVR
      UYGUFHWGIVHZIUUFVRZVSZVVESULVTZWAVEFVURUYGPWBWCVRVEWDUYIVURPNZUYGPNVUTVUP
      UYIVURUYGUYIWEVSZLSVQVVEVWCWHVWBWFVWDUYJUYGPUYILPNZUYIGUYIPNZPNZMNZVWFSMN
      UYJVWDVWHSVWFMVWHGUYIUYIPNZPNGIPNSUYIGUYIVWEWIVWEUUGVWJIGPIUFHZUPIUQKVWJI
      TWJUPIURWJUUIUTZIUUJVMZWKWLWMWKVWILVWGMNZUYJVWGWNHZVWGUPWTZUYIWNHZUYIUPWT
      ZVWIVWNTZGUYIWIVWEWOVWGVGHZVWPGVGHZUYIVGHZVWTGUIHVXAUJGVHVCVVSVVRVXBWGVVT
      IUUKZVRZGUYIWPVMVWGWQVCVWEVVRVXBVWRVOVXCUYIWQVRZLWNHZVWOVWPWRVWQVWRWRZVWS
      VQLVWGUYIWSXAXBGWNHZGUPWTZVWQVWRUYJVWNTZWIGUJVTZVWEVXEVXFVXHVXIWRZVXGVXJV
      QLGUYIUULXAXBXCUYILSVWEVQVVEVWCUUMXDXEVDVEVUMVUGUYKUYMUYGPNZPNVUQVUMVUFVX
      MUYKPVUMVUFUYLDUEZVXMVUMVUEUYLDVUMVUEUYEIMNZUYLVUAUYEIMUUNVXOUYLIPNZIMNUY
      LUYEVXPIMIUAUHNIORQNZUHNZUYEVXPUAVXQIUHXFWKUUOIWNHZOXGHZVXRVXPTXHXIIOXLVM
      XJXEUYLIUYLVVSVXTUYLUIHZWGXIIOXKVMZUMZXHXMUUPUNVEVFVYAUYLVGHVXNVXMTVYBUYL
      VHAUYLVVLVXMVGDVVJUYLTZVVLOUYGPNZUYLMNVXMVYDVVKVYEVVJUYLMVYDVVKUYLUCUEZVY
      EVVJUYLUCUKVVROVJHVYFVYETVOOXNUUSIOVLVMVEVYDVNVPOUYGUYLOXNUMZVWBVYCUYLVYB
      VTZWAVEFUYMUYGPWBWCVRVEWDUYKUYMUYGUGGUGUUQUMZWIVXKWHZOUYLVYGVYCVYHWHZVWBW
      FXOVPUYJUYNUYGUYHUYILGVQWIVXKWHZVWEVXEWHZUYKUYMVYJVYKWOZVWBXPXOVUMVUKUYGU
      YISPNZMNZVUOVUMVUJVYOUYGMVUMVUJIUYEPNZUDUEZVYOVUMVUIVYQUDVUAUYEIPUURVFVYR
      UYIVVBPNVYOIUYEWJUYEUYTXQZVWLUPUYEURVYSUYEUYTXRUTUUTVVBSUYIPVVFWKUNVEWDVY
      PRVYOMNZUYGPNZVUOUYGWNHVYOWNHVYOUPWTZVYPWUATVWBUYISVWEVVEWOVVGVYOVGHZWUBU
      LVVGVXBVVHWUCVXDVVIUYISWPUVAVYOWQVRUYGVYOUVBYDVYTUYQUYGPVYTRSUYIPNZMNZUYQ
      VYOWUDRMUYISVWEVVEUVCWKSWNHZSUPWTZVWQVWRUYQWUETVVEVWCVWEVXESUYIUVDXBXCXEU
      NVEVPUYOUYQUYGUYJUYNVYMVYNUVEUYPUYISVVEVWCUVIZVWEVXEWHZVWBXPXOEUYRUYGPWBW
      CVCZUYRUYGUYOUYQUYJUYNUYHUYILGXSXTVXKYAWEVXEYAUYKUYMUGGYBXTVXKYAOUYLYEUYL
      VYBXQZVYHYAYCZYFUYPUYISUSVWCUVFWEVXEYAYFZVWAYCUVGUYSRUYGPNZUYFUYGJUYRRJKU
      YSWUNJKUYRYGUYIMNZSMNZUYNQNZRJUYRUYJUYQQNZUYNQNWUQUYJUYNUYQVYMVYNWUIUVJWU
      RWUPUYNQUYHUYPQNZUYIMNYGSMNZUYIMNWURWUPWUSWUTUYIMUARQNZSMNUASMNZUYPQNWUTW
      USUARSUAUVHUMYHVVEVWCYIYGWVASMUVKXEUYHWVBUYPQILPNZIGPNZMNZUYHWVBVXHVXIVXS
      IUPWTZWVEUYHTZWIVXKXHXMVXFVXLVXSWVFWRWVGVQLGIWSXAXBWVCUAWVDSMLIUAVQXHUVLY
      JZGISWIXHWLYJYKVDXEUVMXEUYHUYPUYIVYLWUHVWEVXEYIYGSUYIYGUWKUMVVEVWEVWCVXEU
      VNXJXEUNWUQRJKWUPRUYNYLNZJKZWUPOSMNZJKZWVKWVIJKWVJWUOOJKZWVLWVMYGUYIOPNZJ
      KZWVOYGYGPNZWVNWVNPNZJKZGUGUBOUPUBZWVPWVQJGOUGUPYPXIUVOUVPUVQUVTUVRUVSVWJ
      OOPNZPNIWVTPNZWVQWVSVWJIWVTPVWMXEUYIUYIOOVWEVWEVYGVYGUWAIOPNZOPNYMOPNWWAW
      VSWWBYMOPOIYMVYGXHUWBYJXEIOOXHVYGVYGWFOXIUWCXJXJYNUPYGUQKUPWVNUQKZWVOWVRY
      OUPYGURYQUWDUTWVNVGHZWWCVXBOVGHZWWDVXDOUIHWWEXNOVHVCUYIOWPVMZWVNUWEVCYGWV
      NYQWWDWVNUFHWWFWVNUWFVCUWGVMYRUYIUFHZUPUYIJKZWVMWVOYOZWEVVRVXBWWHVOVXCUYI
      UWLVRYGUFHOUFHWWGWWHWRWWIYQYEYGOUYIUWHUWIVMYRWUOOSYGUYIYQWEVXEYAZYEUSVBUW
      JYSRVURYLNZWVKWVIJSLYLNZSMNZSSMNZVURYLNZWVKWWKWUFWUGWWMWWOTZVVEVWCWUFVXFW
      UFWUGWRZWWPVVEVQSLSUWMUWIVMWWLOSMOLQNZLYLNZWWLOWWRSLYLUWNXEOWNHVXFWWSOTVY
      GVQOLUXBVMVDXEWWNRVURYLSVVEVWCUWOXEXDUYNVURJKZWWKWVIJKZUGOPNZGUYLPNZMNZSU
      APNZWXCMNZUYNVURJWXBWXEJKWXDWXFJKSOPNZOQNZWXGSQNZWXBWXEJOSJKWXHWXIJKUWPOS
      WXGYEUSSOUSYEYCUWQYSWXBSRQNZOPNWXGROPNZQNWXHUGWXJOPUWRXESROVVEYHVYGXPWXKO
      WXGQOVYGUWSWKWMWXESVXQPNWXGSRPNZQNWXIUAVXQSPXFWKSORVVEVYGYHUWTWXLSWXGQSVV
      EUXAWKWMYNWXBWXEWXCUGOYBYEYCSUAUSUXCYCGUYLXTWUKYCWXCGUYLUJVYBUXDXRUWJYSUG
      GOUYLVYIWIVYGVYCVXKVYHUXEIGUHNZLPNZWXMSPNZMNZVURWXFWUFWUGWXMWNHZWXMUPWTZW
      XPVURTZVVEVWCWXMVVSGXGHZWXMUIHWGYPIGXKVMZUMWXMWYAVTVXFWWQWXQWXRWRWXSVQLSW
      XMWSXAXBWXNWXEWXOWXCMWXNSIPNZLPNSWVCPNWXEWXMWYBLPWXMILRQNZUHNZVVPIPNZWYBG
      WYCIUHUXFWKVXSLXGHZWYDWYETXHVKILXLVMVVPSIPVIXEWMXESILVVEXHVQWFWVCUASPWVHW
      KWMWXMVVPPNZIIUHNZUYLPNZWXOWXCIGLQNZUHNZIIOQNZUHNZWYGWYIWYJWYLIUHWYJYGOIQ
      NWYLUXGUXHOIVYGXHUXIUXJWKVXSWXTWYFWYKWYGTXHYPVKIGLUXKYDVXSIXGHVXTWYMWYITX
      HUXMXIIIOUXKYDXJVVPSWXMPVIWKWYHGUYLPUXLXEXJYKVDYNUYNUFHVURUFHRUFHWWTWXAYO
      WULLSXSUSVWCYAYTUYNVURRUXNYDYSUXOWUPWVKWVIWUOSWWJUSVWCYAZOSYEUSVWCYARUYNY
      TWULUXPUXQVMWUPUYNRWYNWULYTUXRYRUXSUYRRUYGWUMYTVWAUYGVGHZUPUYGJKVWKRIJKWY
      OWJUXTIUYAVMUYGUWLVCUYCYSWUJWUNUYGUYGVWBUWSUYBYNUYD $.

    $d n q N $.  $d n G $.  $d n q ph $.  $d p q N $.  $d x N $.
    bposlem9.3 $e |- ( ph -> N e. NN ) $.
    bposlem9.4 $e |- ( ph -> ; 6 4 < N ) $.
    bposlem9.5 $e |- ( ph -> -. E. p e. Prime ( N < p /\ p <_ ( 2 x. N ) ) ) $.
    $( Lemma for ~ bpos .  Derive a contradiction.  (Contributed by Mario
       Carneiro, 14-Mar-2014.) $)
    bposlem9 $p |- ( ph -> ps ) $=
      ( wcel c2 co c3 cr cmul caddc vq cfv c6 c4 clt wbr cn 4nn a1i ceu cexp c8
      cle ere 8re mp2an ltleii cc0 wb 0re mp4an recni sylancr clog wa csqr cdiv
      mpd c9 wceq cv fveq2 fveq2d oveq2d oveq12d ovex fvmpt syl sqr2re rpsqrcld
      crp id relogcld rerpdivcld eqeltrd remulcl 4re readdcld 2rp relogcl ax-mp
      cmin c5 nnrp sylancl resubcld 3nn nndivre 2re ce ccxp cprime cfl 6nn 4nn0
      c1 cz lttrd nnzi 5nn wrex eqid recnd syl2anc eqtr4d rpcnd rpne0d wne 2ne0
      cc 2cn oveq1d eqtrd oveq1i nncni 3cn pm3.2i mp3an13 eqtr3i eqtr3d 3eqtr4d
      3ne0 adddid mulcl 3eqtrd mulassd divcan2d addassd mulcld remsqsqr decnncl
      cdc 6nn0 egt2lt3 simpri 3lt8 3re lttri epos 8pos le2sq mpbi sqvali 8t8e64
      eqtri breqtri resqcli nnrei nnred wi letrd bposlem7 bposlem8 simpld oveq1
      ltle oveq2 nnrpd nnne0i redivcli rphalfcld rpmulcl rerpdivcl simprd rpge0
      9re rpre resqrcld readdcl remulcld 5re resubcl cbc cpc cif cmpt nnzd df-5
      4lt10 declti zltp1le mpbid syl5eqbr eluz1i sylanbrc breq2 anbi12d cbvrexv
      breq1 sylnib bposlem6 reexplog reeflogd eqcomd efsub cxpefd cxpef mp3an12
      efadd 3brtr3d eflt mpbird ltsub1dd mulcom mulass mp3an23 2timesi relogmul
      cuz 2t2e4 fveq2i 3eqtr2i oveq2i syl6eq 4p2e6 syl5eqr div23 3t2e6 divcan3i
      adddir divdir 3eqtr3d rpdivcl pncan2d subdird nnncan2d adddird addsubassd
      mp3an3 mulcli nnncan1d subdiri pncan2 df-3 ax-1cn syl5eq mulid2d relogdiv
      3p2e5 subdi divmuldivi 3t3e9 oveq12i eqtr2i divcli mpanr12 divcan6 divcld
      div12 npncan3d remulcli subcl rpge0d div23d rprege0d sqrmul mul4d 2timesd
      mul4 2pos relogmuld addcld addcomd 3eqtr4rd addcl 3brtr4d ltmul2d ltnsymd
      pm2.21dd ) AGEUBZUCUDUUBZEUBZUEUFZBAVWAGUEUFZVWCLACVWAGDEFIJVWAUGNAUCUDUU
      CUHUUAZUIKUJOUKPZVWAUMUFAVWFULOUKPZVWAUMUJULUMUFZVWFVWGUMUFZUJULUNUOUJQUE
      UFZQULUEUFUJULUEUFOUJUEUFVWJUUDUUEUUFUJQULUNUUGUOUUHUPUQUJRNURUJUMUFULRNU
      RULUMUFVWHVWIUSUNURUJUTUNUUIUQUOURULUTUOUUJUQUJULUUKVAUULVWGULULSPVWAULUL
      UOVBUUMUUNUUOUUPUIZAVWFVWAGVWFRNAUJUNUUQUIVWARNZAVWAVWEUURZUIZAGKUUSZVWKA
      VWDVWAGUMUFZLAVWLGRNZVWDVWPUUTVWMVWOVWAGUVFVCVHUVAUVBVHAVWBVVTAVWBRNZVWBO
      VDUBZUEUFZVWRVWTVEACDEFIJUVCUIZUVDZAVVTOVFUBZGVFUBZFUBZSPZVIUDVGPZGOVGPZF
      UBZSPZTPZVWSOGSPZVFUBZVGPZTPZRAGUGNVVTVXOVJKDGVXCDVKZVFUBZFUBZSPZVXGVXPOV
      GPZFUBZSPZTPZVWSOVXPSPZVFUBZVGPZTPVXOUGEVXPGVJZVYCVXKVYFVXNTVYGVXSVXFVYBV
      XJTVYGVXRVXEVXCSVYGVXQVXDFVXPGVFVLVMVNVYGVYAVXIVXGSVYGVXTVXHFVXPGOVGUVEVM
      VNVOVYGVYEVXMVWSVGVYGVYDVXLVFVXPGOSUVGVMVNVOIVXKVXNTVPVQVRZAVXKVXNAVXFVXJ
      AVXCRNVXERNVXFRNVSAVXEVXDVDUBZVXDVGPZRAVXDWANVXEVYJVJAGAGKUVHZVTZCVXDCVKZ
      VDUBZVYMVGPZVYJWAFVYMVXDVJZVYNVYIVYMVXDVGVYMVXDVDVLVYPWBVOJVYIVXDVGVPVQVR
      ZAVYIVXDAVXDVYLWCZVYLWDWEZVXCVXEWFVCZAVXGRNVXIRNVXJRNVIUDUVPWGUDUHUVIUVJZ
      AVXIVXHVDUBZVXHVGPZRAVXHWANVXIWUCVJAGVYKUVKZCVXHVYOWUCWAFVYMVXHVJZVYNWUBV
      YMVXHVGVYMVXHVDVLWUEWBVOJWUBVXHVGVPVQVRZAWUBVXHAVXHWUDWCZWUDWDWEZVXGVXIWF
      VCZWHZAVWSRNZVXMWANVXNRNOWANZWUKWIOWJWKZAVXLAWULGWANZVXLWANZWIVYKOGUVLVCZ
      VTZVWSVXMUVMVCZWHWEZAVWBVWSVVTVXBWUKAWUMUIZWUSAVWRVWTVXAUVNAVWSVVTUEUFVXL
      QVGPZVWSSPZWVAVVTSPZUEUFAGUDVDUBZSPZGVDUBZWLPZUDGSPZQVGPZVWSSPZWVFWLPZWLP
      ZVXMQVGPZOTPZVXLVDUBZSPZWVIWMWLPZVWSSPZTPZWVKWLPZWVBWVCUEAWVGWVSWVKAWVEWV
      FAVWQWVDRNZWVERNVWOUDWANZWWAUDUGNWWBUHUDWNWKZUDWJWKGWVDWFWOZAGVYKWCZWPZAW
      VPWVRAWVNWVOAWVMRNZORNZWVNRNAVXMRNZQUGNZWWGAWUOWWIWUPWUOVXLVXLUVQVXLUVOUV
      RVRZWQVXMQWRWOZWSWVMOUVSWOZAVXLWUPWCZUVTZAWVQRNZWUKWVRRNAWVIRNZWMRNWWPAWV
      HRNZWWJWWQAUDRNZVWQWWRWGVWOUDGWFVCZWQWVHQWRWOZUWAWVIWMUWBWOZWUMWVQVWSWFWO
      ZWHZAWVJWVFAWWQWUKWVJRNWXAWUMWVIVWSWFWOZWWEWPZAWVGWVSUEUFZWVGWTUBZWVSWTUB
      ZUEUFZAUDGUKPZGVGPZVXLWVNXAPZOWVQXAPZSPZWXHWXIUEADDUGVXPXBNVXPVXPVXLGUWCP
      UWDPUKPXFUWEUWFZWVAXCUBZVXMXCUBZGUAAGXGNZWMGUMUFGWMUXSUBNAGKUWGZAWMUDXFTP
      ZGUMUWHAUDGUEUFZWYAGUMUFZAUDVWAGWWSAWGUIVWNVWOUDVWAUEUFAUCUDUDXDXEXEUWIUW
      JUILXHAUDXGNWXSWYBWYCUSUDUHXIWXTUDGUWKVCUWLUWMWMGWMXJXIUWNUWOAGHVKZUEUFZW
      YDVXLUMUFZVEZHXBXKGUAVKZUEUFZWYHVXLUMUFZVEZUAXBXKMWYGWYKHUAXBWYDWYHVJWYEW
      YIWYFWYJWYDWYHGUEUWPWYDWYHVXLUMUWSUWQUWRUWTWXPXLWXQXLWXRXLUXAAWXLWVEWTUBZ
      WVFWTUBZVGPZWXHAWXKWYLGWYMVGAWWBWXSWXKWYLVJWWCWXTUDGUXBVCAWYMGAGVYKUXCUXD
      VOAWVEXTNWVFXTNZWXHWYNVJAWVEWWDXMZAWVFWWEXMZWVEWVFUXEXNXOAWXOWVPWTUBZWVRW
      TUBZSPZWXIAWXMWYRWXNWYSSAVXLWVNAVXLWUPXPAVXLWUPXQAWVNWWMXMUXFAWVQXTNZWXNW
      YSVJZAWVQWXBXMOXTNZOURXRZXUAXUBYAXSOWVQUXGUXHVRVOAWVPXTNWVRXTNWXIWYTVJAWV
      PWWOXMZAWVRWXCXMZWVPWVRUXIXNXOUXJAWVGRNWVSRNWXGWXJUSWWFWXDWVGWVSUXKXNUXLU
      XMAVXLVWSSPZWVJWLPZWVEWVJWLPWVBWVLAXUGWVEWVJWLAXUGGOSPZVWSSPZWVEAVXLXUIVW
      SSAXUCGXTNZVXLXUIVJYAAGVWOXMZOGUXNVCYBAXUJGOVWSSPZSPZWVEAXUKXUJXUNVJZXULX
      UKXUCVWSXTNZXUOYAVWSWUMVBZGOVWSUXOUXPVRXUMWVDGSXUMVWSVWSTPZOOSPZVDUBZWVDV
      WSXUQUXQWULWULXUTXURVJWIWIOOUXRUPXUSUDVDUXTUYAUYBUYCUYDYCYBAVXLWVIWLPZVWS
      SPWVBXUHAXVAWVAVWSSAXVAWVIWVATPZWVIWLPWVAAVXLXVBWVIWLAUCGSPZQVGPZWVHVXLTP
      ZQVGPZVXLXVBAXVCXVEQVGAXVCUDOTPZGSPZXVEXVGUCGSUYEYDAXUKXVHXVEVJZXULUDXTNX
      UCXUKXVIUDUHYEYAUDOGUYJUXHVRUYFYBAXVDUCQVGPZGSPZVXLAXUKXVDXVKVJZXULUCXTNX
      UKQXTNZQURXRZVEZXVLUCXDYEXVMXVNYFYLYGZUCGQUYGYHVRXVJOGSQOSPZQVGPXVJOXVQUC
      QVGUYHYDOQYAYFYLUYIYIYDUYDAWVHXTNZVXLXTNZXVFXVBVJZAWVHWWTXMAVXLAWWHVWQVXL
      RNZWSVWOOGWFVCZXMZXVRXVSXVOXVTXVPWVHVXLQUYKUYSXNUYLYBAWVIWVAAWVIWXAXMZAWV
      AAWUOQWANZWVAWANWUPWWJXWEWQQWNWKVXLQUYMWOZXPZUYNYCYBAVXLWVIVWSXWCXWDAVWSW
      UTXMZUYOYJAWVEWVJWVFWYPAWVJWXEXMZWYQUYPYKAWVPWVRWVKWLPZTPWVMWVOSPZXUMOWVF
      SPZTPZTPZWVFWMVWSSPZWLPZTPZWVTWVCAWVPXWNXWJXWPTAWVPXWKOWVOSPZTPXWNAWVMOWV
      OAWVMWWLXMZXUCAYAUIZAWVOWWNXMZUYQAXWRXWMXWKTAXWROVWSWVFTPZSPXWMAWVOXXBOSA
      WULWUNWVOXXBVJWIVYKOGUXRVCZVNAOVWSWVFXWTXWHWYQYMYCVNYCAXWJWVJXWOWLPZWVKWL
      PXWPAWVRXXDWVKWLAWVIWMVWSXWDWMXTNAWMXJYEZUIXWHUYOYBAWVJXWOWVFXWIXWOXTNZAW
      MVWSXXEXUQUYTZUIZWYQVUAYCVOAWVPWVRWVKXUEXUFAWVKWXFXMUYRAXWKWVAVXJSPZTPZXW
      KXWMXWPTPZTPWVCXWQAXXIXXKXWKTAXWOQVWSSPZWLPZQWVFSPZXWOWLPZTPZXUMXWLXWPTPZ
      TPXXIXXKAXXMXUMXXOXXQTXXMXUMVJAWMQWLPZVWSSPXXMXUMWMQVWSXXEYFXUQVUBXXROVWS
      SQOTPZQWLPZXXROXXSWMQWLVUIYDXVMXUCXXTOVJYFYAQOVUCUPYIYDYIUIAXXOXWLWVFTPZX
      WOWLPXXQAXXNXYAXWOWLAXXNXWLXFWVFSPZTPZXYAAXXNOXFTPZWVFSPXYCQXYDWVFSVUDYDA
      OXFWVFXWTXFXTNAVUEUIWYQUYQVUFAXYBWVFXWLTAWVFWYQVUGVNYCYBAXWLWVFXWOAXUCWYO
      XWLXTNZYAWYQOWVFYNVCZWYQXXHUYRYCVOAQWUBSPZXXNXXLWLPZXXIXXPAXYGQWVFVWSWLPZ
      SPZXYHAWUBXYIQSAWUNWULWUBXYIVJVYKWIGOVUHWOVNAWYOXYJXYHVJZWYQXVMWYOXUPXYKY
      FXUQQWVFVWSVUJYHVRYCAWVAVXGSPZVXISPQVXHSPZWUCSPZXXIXYGAXYLXYMVXIWUCSAXYLO
      QVGPZGSPZQOVGPZXYQSPZSPZXYOXYQSPZGXYQSPZSPZXYMAWVAXYPVXGXYRSAXUKWVAXYPVJZ
      XULXUCXUKXVOYUCYAXVPOGQUYGYHVRVXGXYRVJAXYRQQSPZXUSVGPVXGQOQOYFYAYFYAXSXSV
      UKYUDVIXUSUDVGVULUXTVUMVUNUIVOAXYOXTNZXUKXYSYUBVJZOQYAYFYLVUOXULYUEXUKVEX
      YQXTNZYUGYUFQOYFYAXSVUOZYUHXYOGXYQXYQVVIVUPVCAYUBYUAXYMAYUBXFYUASPYUAXYTX
      FYUASXUCXUDXVMXVNXYTXFVJYAXSYFYLOQVUQVAYDAYUAAXUKYUGYUAXTNXULYUHGXYQYNWOV
      UGVUFAXUKYUAXYMVJZXULXUKXVMXUCXUDVEYUIYFXUCXUDYAXSYGGQOVUSUXPVRYCYOWUFVOA
      WVAVXGVXIXWGVXGXTNAVXGWUAVBUIAVXIWUHXMYPAXYNQVXHWUCSPZSPXYGAQVXHWUCXVMAYF
      UIZAVXHWUDXPZAWUBVXHAWUBWUGXMZYULAVXHWUDXQZVURYPAYUJWUBQSAWUBVXHYUMYULYUN
      YQVNYCUYLAXWOXXLXXNXXHXXLXTNAQVWSYFXUQUYTUIAXVMWYOXXNXTNYFWYQQWVFYNVCVUTY
      KAXUMXWLXWPXUMXTNZAXUMOVWSWSWUMVVAVBZUIXYFAWYOXXFXWPXTNWYQXXGWVFXWOVVBWOZ
      YRYKVNAWVMVWSSPZWVMWVFSPZTPZXXITPYURYUSXXITPZTPZXXJWVCAYURYUSXXIAWVMXTNXU
      PYURXTNXWSXUQWVMVWSYNWOZAWVMWVFXWSWYQYSZAWVAVXJXWGAVXJWUIXMZYSZYRAXWKYUTX
      XITAXWKWVMXXBSPYUTAWVOXXBWVMSXXCVNAWVMVWSWVFXWSXWHWYQYMYCYBAWVCWVAVXKSPZW
      VAVXNSPZTPZYVAYURTPYVBAWVCWVAVXOSPYVIAVVTVXOWVASVYHVNAWVAVXKVXNXWGAVXKWUJ
      XMAVXNWURXMZYMYCAYVGYVAYVHYURTAYVGWVAVXFSPZXXITPYVAAWVAVXFVXJXWGAVXFVYTXM
      ZYVEYMAYVKYUSXXITAYVKWVMVXMSPZVXFSPWVMVXMVXFSPZSPYUSAWVAYVMVXFSAVXMVXMSPZ
      QVGPWVAYVMAYVOVXLQVGAXWAURVXLUMUFYVOVXLVJXWBAVXLWUPVVCVXLYTXNYBAVXMVXMQAV
      XMWWKXMZYVPYUKXVNAYLUIVVDYJZYBAWVMVXMVXFXWSYVPYVLYPAYVNWVFWVMSAYVNVXCVXDS
      PZVXFSPVXCVXCSPZVXDVXESPZSPZWVFAVXMYVRVXFSAWWHUROUMUFZVEVWQURGUMUFVEZVXMY
      VRVJWWHYWBWSUROUTWSVVJUQZYGAGVYKVVEZOGVVFVCYBAVXCVXDVXCVXEVXCXTNAVXCVSVBU
      IZAVXDVYLXPZYWFAVXEVYSXMVVGAYWAOVYISPVYIVYITPZWVFAYVSOYVTVYISYVSOVJZAWWHY
      WBYWIWSYWDOYTUPUIAYVTVXDVYJSPVYIAVXEVYJVXDSVYQVNAVYIVXDAVYIVYRXMZYWGAVXDV
      YLXQYQYCVOAVYIYWJVVHAVXDVXDSPZVDUBYWHWVFAVXDVXDVYLVYLVVKAYWKGVDAYWCYWKGVJ
      YWEGYTVRVMYJYOYOVNYOYBYCAYVHYVMVXNSPWVMVXMVXNSPZSPYURAWVAYVMVXNSYVQYBAWVM
      VXMVXNXWSYVPYVJYPAYWLVWSWVMSAVWSVXMXWHYVPAVXMWUQXQYQVNYOVOAYVAYURAYUSXXIY
      VDYVFVVLYVCVVMYOVVNAXWKXWMXWPAWVMWVOXWSXXAYSAYUOXYEXWMXTNYUPXYFXUMXWLVVOV
      CYUQYRYKVVNVVPAVWSVVTWVAWUTWUSXWFVVQUXLXHVVRVVS $.
  $}

  ${
    $d n p N $.  $d n x N $.
    $( Bertrand's postulate: there is a prime between ` N ` and ` 2 N ` for
       every positive integer ` N ` .  This proof follows Erd&#337;s's method,
       for the most part, but with some refinements due to Shigenori Tochiori
       to save us some calculations of large primes.  See
       ~ http://en.wikipedia.org/wiki/Proof_of_Bertrand%27s_postulate for an
       overview of the proof strategy.  (Contributed by Mario Carneiro,
       14-Mar-2014.) $)
    bpos $p |- ( N e. NN -> E. p e. Prime ( N < p /\ p <_ ( 2 x. N ) ) ) $=
      ( vx vn cn wcel c6 c4 cle wbr cv clt c2 cmul co wa csqr cfv clog cdiv cdc
      cprime wrex bpos1 wn crp cmpt caddc simpll simplr simpr bposlem9 pm2.18da
      c9 eqid cr wo nnre 6nn0 4nn0 deccl nn0rei lelttric sylancl mpjaodan ) AEF
      ZAGHUAZIJZABKZLJVIMANOIJPBUBUCZVGALJZABUDVFVKPZVJVLVJUEZPVJCDDEMQRDKZQRCU
      FCKZSRVOTOUGZRNOUNHTOVNMTOVPRNOUHOMSRMVNNOQRTOUHOUGZVPABVQUOVPUOVFVKVMUIV
      FVKVMUJVLVMUKULUMVFAUPFVGUPFVHVKUQAURVGGHUSUTVAVBAVGVCVDVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Legendre symbol
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c /L $.

  $( Extend class notation with the Legendre symbol function. $)
  clgs $a class /L $.

  ${
    $d a m n $.
    $( Define the Legendre symbol (actually the Kronecker symbol, which extends
       the Legendre symbol to all integers).  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    df-lgs $a |- /L = ( a e. ZZ , n e. ZZ |-> if ( n = 0 ,
      if ( ( a ^ 2 ) = 1 , 1 , 0 ) , ( if ( ( n < 0 /\ a < 0 ) , -u 1 , 1 ) x.
      ( seq 1 ( x. , ( m e. NN |-> if ( m e. Prime ,
        ( if ( m = 2 , if ( 2 || a , 0 , if ( ( a mod 8 ) e. { 1 , 7 } ,
          1 , -u 1 ) ) , ( ( ( ( a ^ ( ( m - 1 ) / 2 ) ) + 1 ) mod m ) - 1 ) )
            ^ ( m pCnt n ) ) , 1 ) ) ) ` ( abs ` n ) ) ) ) ) $.
  $}

  ${
    $( When ` a ` is coprime to the prime ` p ` , ` a ^ ( ( p - 1 ) / 2 ) ` is
       equivalent ` mod p ` to ` 1 ` or ` -u 1 ` , and so adding ` 1 ` makes it
       equivalent to ` 0 ` or ` 2 ` .  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgslem1 $p |- ( ( A e. ZZ /\ P e. ( Prime \ { 2 } ) /\ -. P || A ) ->
      ( ( ( A ^ ( ( P - 1 ) / 2 ) ) + 1 ) mod P ) e. { 0 , 2 } ) $=
      ( cz wcel cprime c2 cdivides wbr c1 cmin co cexp cmo cc0 wceq syl syl2anc
      wb cn0 a1i csn cdif wn w3a cdiv caddc wo cpr cmul cphi cfv cn cgcd eldifi
      3ad2ant2 prmnn simp1 prmz gcdcom simp3 coprm mpbid eulerth syl3anc phiprm
      eqtrd nnm1nn0 eqeltrd zexpcl 1z moddvds nn0cnd cc 2cn wne divcan1d eqtr4d
      2ne0 oveq2d zcnd oddprm nnnn0d expmuld oveq1d oveq2i syl6eqr ax-1cn subsq
      sq1 sylancl breqtrd peano2zd peano2zm euclemma dvdsval3 2z cr crp cle clt
      2re nnrpd nn0ge0i cuz prmuz2 eluzle eldifsni nnred ltlend mpbir2and modid
      2nn0 syl22anc eqeq2d df-2 pnpcan2d syl5eq breq2d orbi12d ovex elpr sylibr
      3bitr3rd ) ACDZBEFUAZUBDZBAGHUCZUDZABIJKZFUEKZLKZIUFKZBMKZNOZYMFOZUGZYMNF
      UHDYHBYLGHZBYKIJKZGHZUGZYPYHBYLYRUIKZGHZYTYHBABUJUKZLKZIJKZUUAGYHUUDBMKIB
      MKOZBUUEGHZYHBULDZYDABUMKZIOUUFYHBEDZUUHYFYDUUJYGBEYEUNUOZBUPPZYDYFYGUQZY
      HUUIBAUMKZIYHYDBCDZUUIUUNOUUMYHUUJUUOUUKBURPABUSQYHYGUUNIOZYDYFYGUTYHUUJY
      DYGUUPRUUKUUMBAVAQVBVFABVCVDYHUUHUUDCDZICDZUUFUUGRUULYHYDUUCSDUUQUUMYHUUC
      YISYHUUJUUCYIOUUKBVEPZYHUUHYISDUULBVGPZVHAUUCVIQUURYHVJTUUDIBVKVDVBYHUUEY
      KFLKZIFLKZJKZUUAYHUUEUVAIJKUVCYHUUDUVAIJYHUUDAYJFUIKZLKUVAYHUUCUVDALYHUUC
      YIUVDUUSYHYIFYHYIUUTVLFVMDYHVNTFNVOYHVRTVPVQVSYHAYJFYHAUUMVTFSDYHXLTYHYJY
      FYDYJULDYGBWAUOWBZWCVFWDUVBIUVAJWIWEWFYHYKVMDIVMDZUVCUUAOYHYKYHYDYJSDYKCD
      ZUUMUVEAYJVIQZVTZWGYKIWHWJVFWKYHUUJYLCDZYRCDZUUBYTRUUKYHYKUVHWLZYHUVGUVKU
      VHYKWMPBYLYRWNVDVBYHYQYNYSYOYHUUHUVJYQYNRUULUVLBYLWOQYHYMFBMKZOZBYLFJKZGH
      ZYOYSYHUUHUVJFCDZUVNUVPRUULUVLUVQYHWPTYLFBVKVDYHUVMFYMYHFWQDZBWRDNFWSHZFB
      WTHZUVMFOUVRYHXATZYHBUULXBUVSYHFXLXCTYHUVTFBWSHZBFVOZYHBFXDUKDZUWBYHUUJUW
      DUUKBXEPFBXFPYFYDUWCYGBEFXGUOYHFBUWAYHBUULXHXIXJFBXKXMXNYHUVOYRBGYHUVOYLI
      IUFKZJKYRFUWEYLJXOWEYHYKIIUVIUVFYHWGTZUWFXPXQXRYCXSVBYMNFYLBMXTYAYB $.

    lgslem2.z $e |- Z = { x e. ZZ | ( abs ` x ) <_ 1 } $.
    $( The set ` Z ` of all integers with absolute value at most ` 1 ` contains
       ` { -u 1 , 0 , 1 } ` .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgslem2 $p |- ( -u 1 e. Z /\ 0 e. Z /\ 1 e. Z ) $=
      ( c1 wcel cc0 cz cle wbr 1z 1le1 cabs cfv wceq fveq2 syl6eq breq1d elrab2
      abs1 mpbir2an cneg znegcl ax-mp cv ax-1cn absnegi eqtri 0le1 abs0 3pm3.2i
      0z ) DUAZBEZFBEZDBEZUMULGEZDDHIZDGEZUPJDUBUCKAUDZLMZDHIZUQAULGBUSULNZUTDD
      HVBUTULLMZDUSULLOVCDLMZDDUEUFSUGPQCRTUNFGEFDHIZUKUHVAVEAFGBUSFNZUTFDHVFUT
      FLMFUSFLOUIPQCRTUOURUQJKVAUQADGBUSDNZUTDDHVGUTVDDUSDLOSPQCRTUJ $.

    $d x A $.  $d x B $.
    $( The set ` Z ` of all integers with absolute value at most ` 1 ` is
       closed under multiplication.  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgslem3 $p |- ( ( A e. Z /\ B e. Z ) -> ( A x. B ) e. Z ) $=
      ( cz wcel cabs cfv c1 cle wbr wa cmul co wceq cr jca fveq2 breq1d zcn cc0
      zmulcl ad2ant2r cc absmul syl2an abscl absge0 syl adantr 1re a1i lemul12a
      wi adantl syl22anc imp an4s 1t1e1 syl6breq eqbrtrd elrab2 anbi12i 3imtr4i
      cv ) BFGZBHIZJKLZMZCFGZCHIZJKLZMZMZBCNOZFGZVPHIZJKLZMBDGZCDGZMVPDGVOVQVSV
      GVKVQVIVMBCUCUDVOVRVHVLNOZJKVGVKVRWBPZVIVMVGBUEGZCUEGZWCVKBUAZCUAZBCUFUGU
      DVOWBJJNOZJKVGVKVIVMWBWHKLZVGVKMZVIVMMZWIWJVHQGZUBVHKLZMZJQGZVLQGZUBVLKLZ
      MZWOWKWIUOVGWNVKVGWDWNWFWDWLWMBUHBUIRUJUKWOWJULUMZVKWRVGVKWEWRWGWEWPWQCUH
      CUIRUJUPWSVHJVLJUNUQURUSUTVAVBRVTVJWAVNAVFZHIZJKLZVIABFDWTBPXAVHJKWTBHSTE
      VCXBVMACFDWTCPXAVLJKWTCHSTEVCVDXBVSAVPFDWTVPPXAVRJKWTVPHSTEVCVE $.

    $( The function ` F ` is closed in integers with absolute value less than
       ` 1 ` (namely ` { -u 1 , 0 , 1 } ` although this representation is less
       useful to us).  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgslem4 $p |- ( ( A e. ZZ /\ P e. ( Prime \ { 2 } ) ) ->
      ( ( ( ( A ^ ( ( P - 1 ) / 2 ) ) + 1 ) mod P ) - 1 ) e. Z ) $=
      ( cz wcel cprime c2 wa c1 cmin co cmo cc0 cr wceq syl2anc a1i syl6eqel cn
      csn cdif cdivides wbr cdiv cexp caddc crp cn0 simpll oddprm nnnn0d zexpcl
      ad2antlr 0re 1re clt cuz cfv eldifi prmuz2 syl eluz2b2 sylib simpld nnrpd
      zred 0z simpr wb dvdsval3 mpbid 0mod eqtr4d modexp syl221anc 0expd oveq1d
      eqtrd modadd1 0p1e1 oveq1i syl6eq nnred simprd 1mod 1m1e0 lgslem2 eqeltri
      cneg simp2i wn w3a cpr wo elpri oveq1 df-neg simp1i eqeltrri 2m1e1 simp3i
      lgslem1 jaoi 3syl 3expa pm2.61dan ) BFGZCHIUBZUCGZJZCBUDUEZBCKLMIUFMZUGMZ
      KUHMCNMZKLMZDGZXLXMJZXQKKLMZDXSXPKKLXSXPKCNMZKXSXPOKUHMZCNMZYAXSXOPGOPGZK
      PGZCUIGZXOCNMZOCNMZQXPYCQXSXOXSXIXNUJGZXOFGXIXKXMUKZXSXNXKXNUAGXIXMCULUOZ
      UMZBXNUNRVHYDXSUPSYEXSUQSXSCXSCUAGZKCURUEZXSCIUSUTGZYMYNJXSCHGZYOXKYPXIXM
      CHXJVAUOCVBVCCVDVEZVFZVGZXSYGOXNUGMZCNMZYHXSXIOFGZYIYFBCNMZYHQYGUUAQYJUUB
      XSVISYLYSXSUUCOYHXSXMUUCOQZXLXMVJXSYMXIXMUUDVKYRYJCBVLRVMXSYFYHOQYSCVNVCV
      OBOXNCVPVQXSYTOCNXSXNYKVRVSVTXOOKCWAVQYBKCNWBWCWDXSCPGYNYAKQXSCYRWEXSYMYN
      YQWFCWGRVTVSXTODWHKWKZDGZODGZKDGZADEWIZWLWJTXIXKXMWMZXRXIXKUUJWNXPOIWOGXP
      OQZXPIQZWPXRBCXDXPOIWQUUKXRUULUUKXQOKLMZDXPOKLWRUUEUUMDKWSUUFUUGUUHUUIWTX
      ATUULXQIKLMZDXPIKLWRUUNKDXBUUFUUGUUHUUIXCWJTXEXFXGXH $.
  $}

  ${
    $d a b m n x y z A $.  $d a m x y z F $.  $d n x M $.  $d a m n x y z N $.
    $d a b n y z Z $.
    lgsval.1 $e |- F = ( n e. NN |-> if ( n e. Prime ,
        ( if ( n = 2 , if ( 2 || A , 0 , if ( ( A mod 8 ) e. { 1 , 7 } ,
          1 , -u 1 ) ) , ( ( ( ( A ^ ( ( n - 1 ) / 2 ) ) + 1 ) mod n ) - 1 ) )
            ^ ( n pCnt N ) ) , 1 ) ) $.
    $( Value of the Legendre symbol at an arbitrary integer.  (Contributed by
       Mario Carneiro, 4-Feb-2015.) $)
    lgsval $p |- ( ( A e. ZZ /\ N e. ZZ ) -> ( A /L N ) = if ( N = 0 ,
      if ( ( A ^ 2 ) = 1 , 1 , 0 ) , ( if ( ( N < 0 /\ A < 0 ) , -u 1 , 1 ) x.
      ( seq 1 ( x. , F ) ` ( abs ` N ) ) ) ) ) $=
      ( va cc0 wceq c2 cexp co c1 cif clt wbr cfv cmul cmo cmin oveq1d vm cz cv
      wa cneg cabs cn cprime wcel cdivides c8 cpr cdiv caddc cpc cmpt cseq clgs
      c7 simpr eqeq1d simpl ifbid breq1d anbi12d breq2d eleq1d ifbieq2d ifeq12d
      oveq2d oveq12d ifeq1d syl6eqr seqeq3d fveq2d fveq12d ifbieq12d df-lgs cn0
      mpteq2dv 1nn0 0nn0 keepel elexi ovex ifex ovmpt2a ) FUAADUBUBUAUCZGHZFUCZ
      IJKZLHZLGMZWHGNOZWJGNOZUDZLUEZLMZWHUFPZQBUGBUCZUHUIZWTIHZIWJUJOZGWJUKRKZL
      USULZUIZLWQMZMZWJWTLSKIUMKZJKZLUNKZWTRKZLSKZMZWTWHUOKZJKZLMZUPZLUQZPZQKZM
      DGHZAIJKZLHZLGMZDGNOZAGNOZUDZWQLMZDUFPZQCLUQZPZQKZMURWJAHZWHDHZUDZWIYBWMY
      AYEYMYPWHDGYNYOUTZVAYPWLYDLGYPWKYCLYPWJAIJYNYOVBZTVAVCYPWRYIXTYLQYPWPYHWQ
      LYPWNYFWOYGYPWHDGNYQVDYPWJAGNYRVDVEVCYPWSYJXSYKYPXRCQLYPXRBUGXAXBIAUJOZGA
      UKRKZXEUIZLWQMZMZAXIJKZLUNKZWTRKZLSKZMZWTDUOKZJKZLMZUPCYPBUGXQUUKYPXAXPUU
      JLYPXNUUHXOUUIJYPXBXHUUCXMUUGYPXCYSXGUUBGYPWJAIUJYRVFYPXFUUALWQYPXDYTXEYP
      WJAUKRYRTVGVCVHYPXLUUFLSYPXKUUEWTRYPXJUUDLUNYPWJAXIJYRTTTTVIYPWHDWTUOYQVJ
      VKVLVTEVMVNYPWHDUFYQVOVPVKVQBUAFVRYBYEYMYEVSYDLGVSWAWBWCWDYIYLQWEWFWG $.

    $( Value of the function ` F ` which defines the Legendre symbol at the
       primes.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsfval $p |- ( M e. NN -> ( F ` M ) = if (
  M e. Prime , ( if ( M = 2 , if ( 2 || A , 0 , if ( ( A mod 8 ) e. { 1 , 7 } ,
          1 , -u 1 ) ) , ( ( ( ( A ^ ( ( M - 1 ) / 2 ) ) + 1 ) mod M ) - 1 ) )
            ^ ( M pCnt N ) ) , 1 ) ) $=
      ( cprime wcel c2 wceq cmo co c1 cif cmin cdiv cexp caddc cpc oveq1d cv c8
      cdivides wbr cc0 c7 cpr cneg cn eleq1 eqeq1 oveq1 oveq2d oveq12d ifbieq2d
      id eqidd ifbieq12d ovex 1ex ifex fvmpt ) BDBUAZGHZVCIJZIAUCUDUEAUBKLMUFUG
      HMMUHNNZAVCMOLZIPLZQLZMRLZVCKLZMOLZNZVCESLZQLZMNDGHZDIJZVFADMOLZIPLZQLZMR
      LZDKLZMOLZNZDESLZQLZMNUICVCDJZVDVPVOMWFMVCDGUJWGVMWDVNWEQWGVEVQVLWCVFVCDI
      UKWGVKWBMOWGVJWAVCDKWGVIVTMRWGVHVSAQWGVGVRIPVCDMOULTUMTWGUPUNTUOVCDESULUN
      WGMUQURFVPWFMWDWEQUSUTVAVB $.

    ${
      lgsfcl2.z $e |- Z = { x e. ZZ | ( abs ` x ) <_ 1 } $.
      $( The function ` F ` is closed in integers with absolute value less than
         ` 1 ` (namely ` { -u 1 , 0 , 1 } ` although this representation is
         less useful to us).  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
      lgsfcl2 $p |- ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> F : NN --> Z ) $=
        ( cz wcel cc0 cv c2 wceq wbr co c1 wa cle cabs va vb cn cprime cdivides
        wne w3a c8 cmo c7 cpr cneg cif cmin cdiv cexp caddc cpc cn0 0z 0le1 cfv
        fveq2 abs0 syl6eq breq1d elrab2 mpbir2an 1le1 abs1 znegcl ax-mp absnegi
        1z ax-1cn eqtri keepel a1i wn cdif simpl1 ad2antrr simplr simpr neneqad
        csn eldifsn sylanbrc lgslem4 syl2anc ifclda simpll2 simpll3 syl12anc cc
        pczcl crab ssrab2 eqsstri zsscn sstri lgslem3 expcllem fmptd ) BIJZEIJZ
        EKUFZUGZCUCCLZUDJZXIMNZMBUEOZKBUHUIPQUJUKJZQQULZUMZUMZBXIQUNPMUOPUPPQUQ
        PXIUIPQUNPZUMZXIEURPZUPPZQUMFDXHXIUCJZRZXJXTQFYBXJRZXRFJXSUSJZXTFJYCXKX
        PXQFXPFJYCXKRXLKXOFKFJKIJKQSOZUTVAALZTVBZQSOZYEAKIFYFKNZYGKQSYIYGKTVBKY
        FKTVCVDVEVFHVGVHXMQXNFQFJZQIJZQQSOZVNVIYHYLAQIFYFQNZYGQQSYMYGQTVBZQYFQT
        VCVJVEVFHVGVHZXNFJXNIJZYLYKYPVNQVKVLVIYHYLAXNIFYFXNNZYGQQSYQYGXNTVBZQYF
        XNTVCYRYNQQVOVMVJVPVEVFHVGVHVQVQVRYCXKVSZRZXEXIUDMWFVTJZXQFJYBXEXJYSXEX
        FXGYAWAWBYTXJXIMUFUUAYBXJYSWCYTXIMYCYSWDWEXIUDMWGWHABXIFHWIWJWKYCXJXFXG
        YDYBXJWDXEXFXGYAXJWLXEXFXGYAXJWMXIEWPWNUAUBXRXSFFIWOFYHAIWQIHYHAIWRWSWT
        XAAUALUBLFHXBYOXCWJYJYBXJVSRYOVRWKGXD $.

      $( The Legendre symbol is an element of ` Z ` .  (Contributed by Mario
         Carneiro, 4-Feb-2015.) $)
      lgscllem $p |- ( ( A e. ZZ /\ N e. ZZ ) -> ( A /L N ) e. Z ) $=
        ( vy vz cz wcel wa co cc0 c1 cif cfv cmul cn clgs wceq c2 cexp clt cneg
        wbr cabs cseq lgsval lgslem2 simp3i simp2i keepel a1i wn simp1i cuz wne
        simplr simpr neneqad nnabscl syl2anc nnuz syl6eleq wf cfz df-ne lgsfcl2
        cv sylan2br elfznn ffvelrn syl2an lgslem3 adantl sylancr ifclda eqeltrd
        3expa seqcl ) BKLZEKLZMZBEUANEOUBZBUCUDNPUBZPOQZEOUEUGBOUEUGMZPUFZPQZEU
        HRZSDPUIRZSNZQFBCDEGUJWEWFWHWNFWHFLWEWFMWGPOFWJFLZOFLZPFLZAFHUKZULZWOWP
        WQWRUMUNUOWEWFUPZMZWKFLWMFLWNFLWIWJPFWOWPWQWRUQWSUNXAIJSFDPWLXAWLTPURRX
        AWDEOUSZWLTLWCWDWTUTXAEOWEWTVAVBEVCVDVEVFXATFDVGZIVKZTLXDDRFLXDPWLVHNLW
        TWEXBXCEOVIWCWDXBXCABCDEFGHVJWAVLXDWLVMTFXDDVNVOXDFLJVKZFLMXDXESNFLXAAX
        DXEFHVPVQWBAWKWMFHVPVRVSVT $.
    $}

    $( Closure of the function ` F ` which defines the Legendre symbol at the
       primes.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsfcl $p |- ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> F : NN --> ZZ ) $=
      ( vx cz wcel cc0 wne w3a cn cv cabs cfv c1 cle wbr crab wf lgsfcl2 ssrab2
      wss eqid fss sylancl ) AGHDGHDIJKLFMNOPQRZFGSZCTUHGUCLGCTFABCDUHEUHUDUAUG
      FGUBLUHGCUEUF $.

    $( The function ` F ` has magnitude less or equal to ` 1 ` .  (Contributed
       by Mario Carneiro, 4-Feb-2015.) $)
    lgsfle1 $p |- ( ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) /\ M e. NN ) ->
      ( abs ` ( F ` M ) ) <_ 1 ) $=
      ( vx cz wcel cc0 wne w3a cn wa cfv cv cabs c1 cle wbr crab eqid ffvelrnda
      lgsfcl2 wceq fveq2 breq1d elrab simprbi syl ) AHIEHIEJKLZDMINDCOZGPZQOZRS
      TZGHUAZIZULQOZRSTZUKMUPDCGABCEUPFUPUBUDUCUQULHIUSUOUSGULHUMULUEUNURRSUMUL
      QUFUGUHUIUJ $.

    $( Lemma for ~ lgsval2 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsval2lem $p |- ( ( A e. ZZ /\ N e. Prime ) -> ( A /L N ) =
      if ( N = 2 , if ( 2 || A , 0 , if ( ( A mod 8 ) e. { 1 , 7 } ,
      1 , -u 1 ) ) , ( ( ( ( A ^ ( ( N - 1 ) / 2 ) ) + 1 ) mod N ) - 1 ) ) ) $=
      ( cz wcel cprime wa co cc0 wceq c2 cexp c1 cif wbr cfv cmul syl clgs cneg
      vx clt cabs cseq cdivides c8 cmo c7 cmin cdiv caddc prmz lgsval sylan2 wn
      cpr cn prmnn adantl nnne0d neneqd iffalse cle nnnn0d nn0ge0d cr 0re nnred
      wb lenlt sylancr mpbid intnanrd absidd fveq2d cuz 1z prmuz2 df-2 syl6eleq
      fveq2i seqm1 1t1e1 a1i uz2m1nn nnuz cv cfz cpc lgsfval elfzelz zred ltm1d
      elfznn elfzle2 lenltd pm2.65i eleq1 mtbiri con2i ad2antlr simpllr dvdsprm
      peano2rem syl2anc mtbird simpr ad2antrr pceq0 mpbird oveq2d znegcl keepel
      cc 0z ax-mp cn0 simpl csn cdif wne simplr neneqad eldifsn sylanbrc oddprm
      zexpcl peano2zd zmodcld nn0zd peano2zm ifclda eqtrd oveq1d 3eqtrd oveq12d
      zcnd exp1d adantlr exp0d ifeq1da syl6eq seqid3 wf lgsfcl syl3anc ffvelrnd
      ifid mulid2d iftrue nncnd pcid eqtr3d wral ralrimiva eqeq1 oveq1 ifbieq2d
      sylancl id eleq1d rspcv sylc ) AFGZDHGZIZADUAJZDKLZAMNJOLOKPZDKUDQZAKUDQZ
      IZOUBZOPZDUERZSCOUFZRZSJZPZUVTDMLZMAUGQZKAUHUIJOUJURGZOUVOPZPZADOUKJZMULJ
      ZNJZOUMJZDUIJZOUKJZPZUVGUVFDFGZUVIUWALDUNZABCDEUOUPUVHUVJUQUWAUVTLUVHDKUV
      HDUVGDUSGZUVFDUTVAZVBZVCUVJUVKUVTVDTUVHUVTODCRZSJZUWSUWMUVHUVPOUVSUWSSUVH
      UVNUQUVPOLUVHUVLUVMUVHKDVEQZUVLUQZUVHDUVHDUWQVFVGZUVHKVHGDVHGZUXAUXBVKVIU
      VHDUWQVJZKDVLVMVNVOUVNUVOOVDTUVHUVSDUVRRZUWSUVHUVQDUVRUVHDUXEUXCVPVQUVHUX
      FUWGUVRRZUWSSJZUWTUWSUVHOFGZDOOUMJZVRRZGUXFUXHLVSUVHDMVRRZUXKUVGDUXLGZUVF
      DVTVAZMUXJVRWAWCWBSCODWDVMUVHUXGOUWSSUVHUCSCOUWGOOOSJOLUVHWEWFUVHUWGUSOVR
      RUVHUXMUWGUSGUXNDWGTWHWBUVHUCWIZOUWGWJJZGZIZUXOCRZUXOHGZUXOMLZUWFAUXOOUKJ
      ZMULJZNJZOUMJZUXOUIJZOUKJZPZUXODWKJZNJZOPZOUXRUXOUSGZUXSUYKLUXQUYLUVHUXOU
      WGWPVAABCUXODEWLTUXRUYKUXTOOPOUXRUXTUYJOOUXRUXTIZUYJUYHKNJOUYMUYIKUYHNUYM
      UYIKLZUXODUGQZUQZUYMUYOUXODLZUXQUYQUQUVHUXTUYQUXQUYQUXQDUXPGZUYRUWGDUDQZU
      YRDUYRDDOUWGWMWNZWOUYRDUWGVEQUYSUQDOUWGWQUYRDUWGUYTUYRUXDUWGVHGUYTDXFTWRV
      NWSUXODUXPWTXAXBXCUYMUXOUXLGZUVGUYOUYQVKUXTVUAUXRUXOVTVAUVFUVGUXQUXTXDDUX
      OXEXGXHUYMUXTUWPUYNUYPVKUXRUXTXIUVHUWPUXQUXTUWQXJUXODXKXGXLXMUYMUYHUVHUXT
      UYHXPGZUXQUVHUXTIZUYHVUCUYAUWFUYGFUWFFGVUCUYAIUWCKUWEFXQUWDOUVOFVSUXIUVOF
      GVSOXNXRXOXOWFVUCUYAUQZIZUYFFGUYGFGVUEUYFVUEUYEUXOVUEUYDVUEUVFUYCXSGUYDFG
      UVHUVFUXTVUDUVFUVGXTZXJVUEUYCVUEUXOHMYAYBGZUYCUSGVUEUXTUXOMYCVUGUVHUXTVUD
      YDVUEUXOMVUCVUDXIYEUXOHMYFYGUXOYHTVFAUYCYIXGYJUXTUYLUVHVUDUXOUTXCYKYLUYFY
      MTYNYSZUUAUUBYOUUCUXTOUUJUUDYOUUEYPUVHUWSUVHUWSUVHUSFDCUVHUVFUWNDKYCUSFCU
      UFVUFUVGUWNUVFUWOVAUWRABCDEUUGUUHUWQUUIYSUUKZYQYOYRVUIUVHUWSUVGUWMDDWKJZN
      JZOPZVUKUWMUVHUWPUWSVULLUWQABCDDEWLTUVGVULVUKLUVFUVGVUKOUULVAUVHVUKUWMONJ
      UWMUVHVUJOUWMNUVHDDONJZWKJZVUJOUVHVUMDDWKUVHDUVHDUWQUUMYTXMUVHUVGUXIVUNOL
      UVFUVGXIZVSODUUNUVAUUOXMUVHUWMUVHUVGVUBUCHUUPUWMXPGZVUOUVHVUBUCHVUHUUQVUB
      VUPUCDHUYQUYHUWMXPUYQUYAUWBUYGUWLUWFUXODMUURUYQUYFUWKOUKUYQUYEUWJUXODUIUY
      QUYDUWIOUMUYQUYCUWHANUYQUYBUWGMULUXODOUKUUSYPXMYPUYQUVBYRYPUUTUVCUVDUVEYT
      YOYQYQYQ $.

    $( Lemma for ~ lgsval4 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsval4lem $p |- ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> F = ( n e. NN |->
      if ( n e. Prime , ( ( A /L n ) ^ ( n pCnt N ) ) , 1 ) ) ) $=
      ( vm cz wcel cc0 cn cv co cexp c1 cif cmpt c2 wceq cmo cmin clgs cdivides
      wne w3a cprime cpc wbr c8 c7 cneg cdiv caddc wa eqid lgsval2lem 3ad2antl1
      cpr oveq1d ifeq1da mpteq2dv syl6reqr ) AGHZDGHZDIUCZUDZBJBKZUEHZAVFUALZVF
      DUFLZMLZNOZPBJVGVFQRQAUBUGIAUHSLNUIUQHNNUJOOZAVFNTLQUKLMLNULLVFSLNTLOZVIM
      LZNOZPCVEBJVKVOVEVGVJVNNVEVGUMVHVMVIMVBVCVGVHVMRVDAFFJFKZUEHVPQRVLAVPNTLQ
      UKLMLNULLVPSLNTLOVPVFUFLMLNOPZVFVQUNUOUPURUSUTEVA $.
  $}

  ${
    $d n x A $.  $d n x N $.  $d n Z $.
    lgscl2.z $e |- Z = { x e. ZZ | ( abs ` x ) <_ 1 } $.
    $( The Legendre symbol is an integer with absolute value less or equal to
       ` 1 ` .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgscl2 $p |- ( ( A e. ZZ /\ N e. ZZ ) -> ( A /L N ) e. Z ) $=
      ( vn cn cv cprime wcel c2 wceq cdivides wbr cmo co c1 cif cmin cexp c8 c7
      cc0 cpr cneg cdiv caddc cpc cmpt eqid lgscllem ) ABFFGFHZIJULKLKBMNUCBUAO
      PQUBUDJQQUERRBULQSPKUFPTPQUGPULOPQSPRULCUHPTPQRUIZCDUMUJEUK $.
  $}

  ${
    $d n x y A $.  $d x y F $.  $d n x y N $.  $d n P $.
    $( The Legendre symbol when the second argument is zero.  (Contributed by
       Mario Carneiro, 4-Feb-2015.) $)
    lgs0 $p |- ( A e. ZZ -> ( A /L 0 ) = if ( ( A ^ 2 ) = 1 , 1 , 0 ) ) $=
      ( vn cz wcel cc0 clgs co wceq c2 cexp c1 cif clt wbr wa cfv cmul cmo cmin
      eqid cneg cabs cn cv cprime cdivides c8 c7 cpr cdiv caddc cpc cmpt lgsval
      cseq 0z mpan2 iftrue ax-mp syl6eq ) ACDZAEFGZEEHZAIJGKHKELZEEMNAEMNOKUAZK
      LEUBPQBUCBUDZUEDVFIHIAUFNEAUGRGKUHUIDKVELLAVFKSGIUJGJGKUKGVFRGKSGLVFEULGJ
      GKLUMZKUOPQGZLZVDVAECDVBVIHUPABVGEVGTUNUQVCVIVDHETVCVDVHURUSUT $.

    $( The Legendre symbol is an integer.  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgscl $p |- ( ( A e. ZZ /\ N e. ZZ ) -> ( A /L N ) e. ZZ ) $=
      ( vx cz wcel wa cv cabs cfv c1 cle crab clgs co ssrab2 eqid lgscl2 sseldi
      wbr ) ADEBDEFCGHIJKSZCDLZDABMNTCDOCABUAUAPQR $.

    $( The Legendre symbol has absolute value less or equal to ` 1 ` .
       Together with ~ lgscl this implies that it takes values in
       ` { -u 1 , 0 , 1 } ` .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsle1 $p |- ( ( A e. ZZ /\ N e. ZZ ) -> ( abs ` ( A /L N ) ) <_ 1 ) $=
      ( vx cz wcel wa clgs co cv cabs cfv cle wbr crab eqid lgscl2 fveq2 breq1d
      c1 wceq elrab simprbi syl ) ADEBDEFABGHZCIZJKZSLMZCDNZEZUDJKZSLMZCABUHUHO
      PUIUDDEUKUGUKCUDDUEUDTUFUJSLUEUDJQRUAUBUC $.

    $( The Legendre symbol at a prime (this is the traditional domain of the
       Legendre symbol, except for the addition of prime ` 2 ` ).  (Contributed
       by Mario Carneiro, 4-Feb-2015.) $)
    lgsval2 $p |- ( ( A e. ZZ /\ P e. Prime ) -> ( A /L P ) = if ( P = 2 ,
      if ( 2 || A , 0 , if ( ( A mod 8 ) e. { 1 , 7 } , 1 , -u 1 ) ) ,
        ( ( ( ( A ^ ( ( P - 1 ) / 2 ) ) + 1 ) mod P ) - 1 ) ) ) $=
      ( vn cn cv cprime wcel c2 wceq cdivides wbr cc0 c8 cmo co c1 c7 cmin cexp
      cif cpr cneg cdiv caddc cpc cmpt eqid lgsval2lem ) ACCDCEZFGUIHIHAJKLAMNO
      PQUAGPPUBTTAUIPROHUCOSOPUDOUINOPROTUIBUEOSOPTUFZBUJUGUH $.

    $( The Legendre symbol at ` 2 ` .  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgs2 $p |- ( A e. ZZ -> ( A /L 2 ) = if ( 2 || A , 0 ,
      if ( ( A mod 8 ) e. { 1 , 7 } , 1 , -u 1 ) ) ) $=
      ( cz wcel c2 clgs co wceq cdivides wbr cc0 c8 cmo c1 c7 cpr cneg cif cmin
      cdiv cexp caddc cprime 2prm lgsval2 mpan2 eqid iftrue ax-mp syl6eq ) ABCZ
      ADEFZDDGZDAHIJAKLFMNOCMMPQQZADMRFDSFTFMUAFDLFMRFZQZUMUJDUBCUKUOGUCADUDUEU
      LUOUMGDUFULUMUNUGUHUI $.

    $( The Legendre symbol at an odd prime (this is the traditional domain of
       the Legendre symbol).  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsval3 $p |- ( ( A e. ZZ /\ P e. ( Prime \ { 2 } ) ) -> ( A /L P ) =
        ( ( ( ( A ^ ( ( P - 1 ) / 2 ) ) + 1 ) mod P ) - 1 ) ) $=
      ( cprime c2 csn cdif wcel cz wne wa clgs co cmin cdiv cexp caddc cmo wceq
      c1 cif eldifsn cdivides wbr cc0 c8 c7 cpr cneg lgsval2 ifnefalse sylan9eq
      anasss sylan2b ) BCDEFGAHGZBCGZBDIZJABKLZABSMLDNLOLSPLBQLSMLZRZBCDUAUNUOU
      PUSUNUOJUPUQBDRDAUBUCUDAUEQLSUFUGGSSUHTTZURTURABUIBDUTURUJUKULUM $.

    $( The Legendre symbol is equivalent to ` a ^ ( ( p - 1 ) / 2 ) ` ,
       ` mod p ` .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsvalmod $p |- ( ( A e. ZZ /\ P e. ( Prime \ { 2 } ) ) ->
      ( ( A /L P ) mod P ) = ( ( A ^ ( ( P - 1 ) / 2 ) ) mod P ) ) $=
      ( cz wcel cprime c2 co c1 caddc cmo cmin cr syl recnd ax-1cn oveq1d eqtrd
      wceq cc sylancl csn cdif clgs cneg cdiv cexp crp eldifi adantl prmz lgscl
      wa syldan zred peano2re cn0 oddprm nnnn0d zexpcl 1re renegcli prmnn nnrpd
      cn lgsval3 eqcomd modcld subadd2d mpbid modabs2 syl2anc modadd1 syl221anc
      a1i negsub pncan 3eqtr3d ) ACDZBEFUAZUBDZULZABUCGZHIGZHUDZIGZBJGZABHKGFUE
      GZUFGZHIGZWDIGZBJGZWBBJGWHBJGWAWCLDZWILDZWDLDZBUGDZWCBJGZWIBJGZRWFWKRWAWB
      LDWLWAWBVRVTBCDZWBCDWABEDZWRVTWSVRBEVSUHUIZBUJMABUKUMUNZWBUOMZWAWHLDWMWAW
      HVRVTWGUPDWHCDWAWGVTWGVDDVRBUQUIURAWGUSUMUNZWHUOMZWNWAHUTVAVNWABWAWSBVDDW
      TBVBMVCZWAWPWQBJGZWQWAWCWQBJWAWQHKGZWBRWCWQRWAWBXGABVEVFWAWQHWBWAWQWAWIBX
      DXEVGNHSDZWAOVNWAWBXANZVHVIPWAWMWOXFWQRXDXEWIBVJVKQWCWIWDBVLVMWAWEWBBJWAW
      EWCHKGZWBWAWCSDXHWEXJRWAWCXBNOWCHVOTWAWBSDXHXJWBRXIOWBHVPTQPWAWJWHBJWAWJW
      IHKGZWHWAWISDXHWJXKRWAWIXDNOWIHVOTWAWHSDXHXKWHRWAWHXCNOWHHVPTQPVQ $.

    lgsval4.1 $e |- F = ( n e. NN |->
      if ( n e. Prime , ( ( A /L n ) ^ ( n pCnt N ) ) , 1 ) ) $.
    $( Restate ~ lgsval for nonzero ` N ` , where the function ` F ` has been
       abbreviated into a self-referential expression taking the value of
       ` /L ` on the primes as given.  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgsval4 $p |- ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> ( A /L N ) =
      ( if ( ( N < 0 /\ A < 0 ) , -u 1 , 1 ) x.
        ( seq 1 ( x. , F ) ` ( abs ` N ) ) ) ) $=
      ( cz wcel cc0 clgs co wceq c2 cexp c1 cif clt wbr cfv cmul cn wne wa cneg
      w3a cabs cv cprime cdivides c8 cmo cpr cmin cdiv caddc cpc cmpt cseq eqid
      c7 lgsval 3adant3 wn neneqd iffalse syl lgsval4lem syl6eqr seqeq3d fveq1d
      simp3 oveq2d 3eqtrd ) AFGZDFGZDHUAZUDZADIJZDHKZALMJNKNHOZDHPQAHPQUBNUCZNO
      ZDUERZSBTBUFZUGGZWCLKLAUHQHAUIUJJNUSUKGNVTOOAWCNULJLUMJMJNUNJWCUJJNULJOWC
      DUOJZMJNOUPZNUQZRZSJZOZWIWAWBSCNUQZRZSJVMVNVQWJKVOABWFDWFURZUTVAVPVRVBWJW
      IKVPDHVMVNVOVJVCVRVSWIVDVEVPWHWLWASVPWBWGWKVPWFCSNVPWFBTWDAWCIJWEMJNOUPCA
      BWFDWMVFEVGVHVIVKVL $.

    $( Closure of the function ` F ` which defines the Legendre symbol at the
       primes.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsfcl3 $p |- ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> F : NN --> ZZ ) $=
      ( cz wcel cc0 wne w3a cn c2 cmo co c1 cif cmin cexp cmpt wf wceq cdivides
      cv cprime wbr c8 c7 cpr cneg cdiv cpc eqid lgsfcl clgs lgsval4lem syl6eqr
      caddc feq1d mpbid ) AFGDFGDHIJZKFBKBUCZUDGZVALUALAUBUEHAUFMNOUGUHGOOUIPPA
      VAOQNLUJNRNOUQNVAMNOQNPVADUKNZRNOPSZTKFCTABVDDVDULZUMUTKFVDCUTVDBKVBAVAUN
      NVCRNOPSCABVDDVEUOEUPURUS $.

    $( Same as ~ lgsval4 for positive ` N ` .  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgsval4a $p |- ( ( A e. ZZ /\ N e. NN ) ->
      ( A /L N ) = ( seq 1 ( x. , F ) ` N ) ) $=
      ( vx vy cz wcel cn wa co cc0 clt wbr c1 cfv cmul wceq adantl clgs cif wne
      cneg cabs cseq simpl nnz nnne0 lgsval4 syl3anc wn nngt0 cr wi nnre ltnsym
      0re sylancr mpd intnanrd iffalse syl cn0 nnnn0 nn0ge0d absidd oveq12d cuz
      fveq2d simpr nnuz syl6eleq wf cv cfz lgsfcl3 elfznn ffvelrn syl2an zmulcl
      seqcl zcnd mulid2d 3eqtrd ) AHIZDJIZKZADUALZDMNOZAMNOZKZPUDZPUBZDUEQZRCPU
      FZQZRLZPDWPQZRLWSWHWFDHIZDMUCZWIWRSWFWGUGZWGWTWFDUHTZWGXAWFDUITZABCDEUJUK
      WHWNPWQWSRWHWLULWNPSWHWJWKWHMDNOZWJULZWGXEWFDUMTWHMUNIDUNIZXEXFUOURWGXGWF
      DUPTZMDUQUSUTVAWLWMPVBVCWHWODWPWHDXHWHDWGDVDIWFDVETVFVGVJVHWHWSWHWSWHFGRH
      CPDWHDJPVIQWFWGVKVLVMWHJHCVNZFVOZJIXJCQHIXJPDVPLIWHWFWTXAXIXBXCXDABCDEVQU
      KXJDVRJHXJCVSVTXJHIGVOZHIKXJXKRLHIWHXJXKWATWBWCWDWE $.
  $}

  ${
    $d k n x y z B $.  $d k x F $.  $d k n x y z M $.  $d x P $.  $d k x ph $.
    $d k n p x y z A $.  $d k n p x y z N $.
    $( The Legendre symbol is either even or odd under negation with respect to
       the second parameter according to the sign of the first.  (Contributed
       by Mario Carneiro, 4-Feb-2015.) $)
    lgsneg $p |- ( ( A e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> ( A /L -u N ) =
      ( if ( A < 0 , -u 1 , 1 ) x. ( A /L N ) ) ) $=
      ( vn cz wcel cc0 wne cneg wbr wa c1 cif cfv cmul cn co wceq ax-1cn wn cc
      vx vy w3a clt cabs cv cprime clgs cpc cexp cmpt cseq iftrue adantl oveq1d
      oveq2 neg1cn mulm1i negnegi eqtri syl6eq ifsb simpr biantrud ifbid oveq2d
      cle cr wb simpl2 0re ltlen sylancl simpl3 necomd bitr4d le0neg1d renegcld
      zred lenlt sylancr 3bitrd ifnot 3eqtr3a 1t1e1 iffalse intnand syl oveq12d
      3eqtrd 3eqtr4a pm2.61dan eqcomd cq pcneg syl2anc ifeq1da mpteq2dv seqeq3d
      zcn 3ad2ant2 absnegd fveq12d keepel a1i cuz nnabscl 3adant1 nnuz syl6eleq
      zq cfz eqid lgsfcl3 elfznn ffvelrn syl2an zmulcl seqcl zcnd mulassd eqtrd
      wf simp1 znegcl simp3 negne0d lgsval4 syl3anc 3eqtr4d ) ADEZBDEZBFGZUCZBH
      ZFUDIZAFUDIZJZKHZKLZYOUEMZNCOCUFZUGEZAUUBUHPZUUBYOUIPZUJPZKLZUKZKULZMZNPZ
      YQYSKLZBFUDIZYQJZYSKLZBUEMZNCOUUCUUDUUBBUIPZUJPZKLZUKZKULZMZNPZNPZAYOUHPZ
      UULABUHPZNPYNUUKUULUUONPZUVBNPUVDYNYTUVGUUJUVBNYNUVGYTYNYQUVGYTQYNYQJZUVG
      YSUUONPZYPYSKLZYTUVHUULYSUUONYQUULYSQYNYQYSKUMUNUOUVHYSUUMYSKLZNPZUUMKYSL
      ZUVIUVJUUMYSKUVLKYSUVKYSQUVLYSYSNPZKUVKYSYSNUPUVNYSHKYSUQURKRUSUTVAUVKKQU
      VLYSKNPYSUVKKYSNUPKRURVAVBUVHUVKUUOYSNUVHUUMUUNYSKUVHYQUUMYNYQVCZVDVEVFUV
      HUVMYPSZKYSLUVJUVHUUMUVPKYSUVHUUMBFVGIZFYOVGIZUVPUVHUUMUVQFBGZJZUVQUVHBVH
      EFVHEZUUMUVTVIUVHBYKYLYMYQVJVSZVKBFVLVMUVHUVSUVQUVHBFYKYLYMYQVNVOVDVPUVHB
      UWBVQUVHUWAYOVHEUVRUVPVIVKUVHBUWBVRFYOVTWAWBVEYPKYSWCVAWDUVHYPYRYSKUVHYQY
      PUVOVDVEWJYNYQSZJZKKNPKUVGYTWEUWDUULKUUOKNUWCUULKQYNYQYSKWFUNUWDUUNSUUOKQ
      UWDYQUUMYNUWCVCZWGUUNYSKWFWHWIUWDYRSYTKQUWDYQYPUWEWGYRYSKWFWHWKWLWMYNUUAU
      UPUUIUVAYNUUHUUTNKYNCOUUGUUSYNUUCUUFUURKYNUUCJZUUEUUQUUDUJUWFUUCBWNEZUUEU
      UQQYNUUCVCUWFYLUWGYKYLYMUUCVJBXKWHBUUBWOWPVFWQWRWSYNBYLYKBTEYMBWTXAZXBXCW
      IYNUULUUOUVBUULTEYNYQYSKTUQRXDXEUUOTEYNUUNYSKTUQRXDXEYNUVBYNUAUBNDUUTKUUP
      YNUUPOKXFMYLYMUUPOEYKBXGXHXIXJYNODUUTYCUAUFZOEUWIUUTMDEUWIKUUPXLPEACUUTBU
      UTXMZXNUWIUUPXOODUWIUUTXPXQUWIDEUBUFZDEJUWIUWKNPDEYNUWIUWKXRUNXSXTYAYBYNY
      KYODEZYOFGUVEUUKQYKYLYMYDYLYKUWLYMBYEXAYNBUWHYKYLYMYFYGACUUHYOUUHXMYHYIYN
      UVFUVCUULNACUUTBUWJYHVFYJ $.

    $( The Legendre symbol for nonnegative first parameter is unchanged by
       negation of the second.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsneg1 $p |- ( ( A e. NN0 /\ N e. ZZ ) -> ( A /L -u N ) = ( A /L N ) ) $=
      ( cn0 wcel cz wa cneg clgs co wceq cc0 simpr negeqd 3eqtr4a oveq2d wne c1
      neg0 cmul 3ad2ant1 w3a clt wbr cif nn0z lgsneg syl3an1 wn nn0nlt0 iffalse
      syl oveq1d simp2 lgscl syl2anc zcnd mulid2d 3eqtrd 3expa pm2.61dane ) ACD
      ZBEDZFZABGZHIZABHIZJZBKVCBKJZFZVDBAHVIKGKVDBRVIBKVCVHLZMVJNOVAVBBKPZVGVAV
      BVKUAZVEAKUBUCZQGZQUDZVFSIZQVFSIVFVAAEDZVBVKVEVPJAUEZABUFUGVLVOQVFSVLVMUH
      ZVOQJVAVBVSVKAUITVMVNQUJUKULVLVFVLVFVLVQVBVFEDVAVBVQVKVRTVAVBVKUMABUNUOUP
      UQURUSUT $.

    $( The Legendre (Jacobi) symbol is preserved under reduction ` mod n ` when
       ` n ` is odd.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsmod $p |- ( ( A e. ZZ /\ N e. NN /\ -. 2 || N ) ->
      ( ( A mod N ) /L N ) = ( A /L N ) ) $=
      ( vn cz wcel cn c2 cdivides wbr cmo co clgs cexp c1 wceq cmin syl2anc cc0
      wa cr wn w3a cmul cprime cpc cif cmpt cseq cfv cdiv caddc crp cn0 3adant3
      cv zmodcl nn0zd ad2antrr cdif simpr adantr simpl3 breq1 notbid syl5ibrcom
      csn wne necon2ad imp eldifsn sylanbrc oddprm syl nnnn0d zexpcl zred prmnn
      simpll1 1re ad2antlr nnrpd simp2 modabs2 wb moddvds syl3anc mpbid wi prmz
      nnzd zsubcld dvdstr mp2and mpbird modexp syl221anc modadd1 oveq1d lgsval3
      a1i 3eqtr4d lgscl zcnd exp0d eqtr4d pceq0 biimpar oveq2d ifeq1da mpteq2dv
      pm2.61dan seqeq3d fveq1d eqid lgsval4a ) ADEZBFEZGBHIZUAZUBZBUCCFCUOZUDEZ
      ABJKZYALKZYABUEKZMKZNUFZUGZNUHZUIZBUCCFYBAYALKZYEMKZNUFZUGZNUHZUIZYCBLKZA
      BLKZXTBYIYOXTYHYNUCNXTCFYGYMXTYBYFYLNXTYBSZYABHIZYFYLOYSYTSZYDYKYEMUUAYCY
      ANPKGUJKZMKZNUKKYAJKZNPKZAUUBMKZNUKKYAJKZNPKZYDYKUUAUUDUUGNPUUAUUCTEUUFTE
      NTEZYAULEZUUCYAJKUUFYAJKOZUUDUUGOUUAUUCUUAYCDEZUUBUMEZUUCDEXTUULYBYTXTYCX
      PXQYCUMEXSABUPUNUQZURZUUAUUBUUAYAUDGVFUSEZUUBFEUUAYBYAGVGZUUPYSYBYTXTYBUT
      ZVAYSYTUUQYSYTYAGYSYTUAZYAGOZXSXPXQXSYBVBUUTYTXRYAGBHVCVDVEVHVIYAUDGVJVKZ
      YAVLVMVNZYCUUBVOQVPUUAUUFUUAXPUUMUUFDEXPXQXSYBYTVRZUVBAUUBVOQVPUUIUUAVSWT
      UUAYAYBYAFEZXTYTYAVQVTZWAZUUAUULXPUUMUUJYCYAJKAYAJKOZUUKUUOUVCUVBUVFUUAUV
      GYAYCAPKZHIZUUAYTBUVHHIZUVIYSYTUTUUAYCBJKYCOZUVJUUAATEBULEUVKUUAAUVCVPUUA
      BXTXQYBYTXPXQXSWBZURZWAABWCQUUAXQUULXPUVKUVJWDUVMUUOUVCYCABWEWFWGUUAYADEZ
      BDEUVHDEYTUVJSUVIWHYBUVNXTYTYAWIZVTUUABUVMWJUUAYCAUUOUVCWKYABUVHWLWFWMUUA
      UVDUULXPUVGUVIWDUVEUUOUVCYCAYAWEWFWNYCAUUBYAWOWPUUCUUFNYAWQWPWRUUAUULUUPY
      DUUEOUUOUVAYCYAWSQUUAXPUUPYKUUHOUVCUVAAYAWSQXAWRYSUUSSZYDRMKZYKRMKZYFYLUV
      PUVQNUVRUVPYDUVPYDUVPUULUVNYDDEXTUULYBUUSUUNURYBUVNXTUUSUVOVTZYCYAXBQXCXD
      UVPYKUVPYKUVPXPUVNYKDEXPXQXSYBUUSVRUVSAYAXBQXCXDXEUVPYERYDMYSYEROZUUSYSYB
      XQUVTUUSWDUURXTXQYBUVLVAYABXFQXGZXHUVPYERYKMUWAXHXAXKXIXJXLXMXTUULXQYQYJO
      UUNUVLYCCYHBYHXNXOQXPXQYRYPOXSACYNBYNXNXOUNXA $.

    $( Lemma for ~ lgsdi and ~ lgsdir : the sign part of the Legendre symbol is
       multiplicative.  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdilem $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ N e. ZZ ) /\
                     ( A =/= 0 /\ B =/= 0 ) ) ->
      if ( ( N < 0 /\ ( A x. B ) < 0 ) , -u 1 , 1 ) =
      ( if ( ( N < 0 /\ A < 0 ) , -u 1 , 1 ) x.
        if ( ( N < 0 /\ B < 0 ) , -u 1 , 1 ) ) ) $=
      ( wcel cc0 wa clt wbr cmul co c1 cneg cif wceq wn cr wb 0re adantr ifbid
      cz w3a wne cle simplrr biantrud simpl2 zred ltlen sylancr simpl1 renegcld
      recnd mul01d mulneg1d breq12d a1i lt0neg1d biimpa ltmul2 remulcld 3bitr4d
      3bitr2rd lenlt bitrd oveq2 neg1cn mulm1i ax-1cn negnegi eqtri syl6eq ifsb
      syl112anc ifnot eqtr4i syl6eqr iftrue adantl oveq1d eqtr4d iffalse keepel
      cc mulid2i biimpar simplrl breq2d syl5eq eqtr2d pm2.61dan simpr biantrurd
      ne0gt0d oveq12d 3eqtr3d intnanrd syl 1t1e1 ) AUADZBUADZCUADZUBZAEUCZBEUCZ
      FZFZCEGHZXHABIJZEGHZFZKLZKMZXHAEGHZFZXLKMZXHBEGHZFZXLKMZIJZNXGXHFZXJXLKMZ
      XNXLKMZXQXLKMZIJZXMXTXGYBYENZXHXGXNYFXGXNFZYBXLYDIJZYEYGYBXQOZXLKMZYHYGXJ
      YIXLKYGXJEBUDHZYIYGYKYKXEFZEBGHZXJYGXEYKXCXDXEXNUEUFYGEPDZBPDZYMYLQRXGYOX
      NXGBWTXAXBXFUGUHZSZEBUIUJYGALZEIJZYRBIJZGHZEXILZGHYMXJYGYSEYTUUBGYGYRYGYR
      YGAXGAPDZXNXGAWTXAXBXFUKUHZSZULZUMUNYGABYGAUUEUMYGBYQUMUOUPYGYNYOYRPDEYRG
      HZYMUUAQYNYGRUQYQUUFXGXNUUGXGAUUDURUSEBYRUTVNYGXIXGXIPDXNXGABUUDYPVASURVB
      VCYGYNYOYKYIQRYQEBVDUJVETYHXQKXLMYJXQXLKYHKXLYDXLNYHXLXLIJZKYDXLXLIVFUUHX
      LLKXLVGVHKVIVJVKVLYDKNYHXLKIJXLYDKXLIVFKVIVHVLVMXQXLKVOVPVQYGYCXLYDIXNYCX
      LNXGXNXLKVRVSVTWAXGXNOZFZYEKYDIJZYBUUJYCKYDIUUIYCKNXGXNXLKWBVSVTUUJUUKYDY
      BYDXQXLKWDVGVIWCWEUUJXQXJXLKUUJXQXIAEIJZGHZXJUUJYOYNUUCEAGHXQUUMQXGYOUUIY
      PSYNUUJRUQXGUUCUUIUUDSZUUJAUUNXGEAUDHZUUIXGYNUUCUUOUUIQRUUDEAVDUJWFXCXDXE
      UUIWGWNBEAUTVNUUJUULEXIGUUJAUUJAUUNUMUNWHVETWIWJWKSYAXJXKXLKYAXHXJXGXHWLZ
      WMTYAYCXPYDXSIYAXNXOXLKYAXHXNUUPWMTYAXQXRXLKYAXHXQUUPWMTWOWPXGXHOZFZXMKKI
      JZXTUURXMKUUSUURXKOXMKNUURXHXJXGUUQWLZWQXKXLKWBWRWSVQUURXPKXSKIUURXOOXPKN
      UURXHXNUUTWQXOXLKWBWRUURXROXSKNUURXHXQUUTWQXRXLKWBWRWOWAWK $.

    $( Lemma for ~ lgsdir2 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdir2lem1 $p |- ( ( ( 1 mod 8 ) = 1 /\ ( -u 1 mod 8 ) = 7 ) /\
      ( ( 3 mod 8 ) = 3 /\ ( -u 3 mod 8 ) = 5 ) ) $=
      ( c1 c8 cmo co wceq c7 c3 c5 cr wcel cc0 cle wbr modid mp4an caddc ax-1cn
      clt eqtri 3cn cneg wa crp 1re 8re 8pos elrpii 0le1 1lt8 cmul recni oveq2i
      mulid2i negcli cmin negsubi 7nn nncni addcomi df-8 eqtr4i addcomli oveq1i
      subaddrii cz renegcli 1z modcyc mp3an 7re 7pos ltleii 7lt8 3eqtr3i pm3.2i
      0re 3re 3pos 3lt8 5nn 5p3e8 5re 5pos 5lt8 ) ABCDAEZAUAZBCDZFEZUBGBCDGEZGU
      AZBCDZHEZUBWEWHAIJBUCJZKALMABRMWEUDBUEUFUGZUHUIABNOWFABUJDZPDZBCDZFBCDZWG
      FWPFBCWPWFBPDFWOBWFPBBUEUKZUMZULBWFFWSAQUNBWFPDBAUODFBAWSQUPBAFWSQFUQURZA
      FPDFAPDBAFQXAUSUTVAVDSVBSVCWFIJWMAVEJZWQWGEAUDVFWNVGWFBAVHVIFIJWMKFLMFBRM
      WRFEVJWNKFVPVJVKVLVMFBNOVNVOWIWLGIJWMKGLMGBRMWIVQWNKGVPVQVRVLVSGBNOWJWOPD
      ZBCDZHBCDZWKHXCHBCXCWJBPDHWOBWJPWTULBWJHWSGTUNBWJPDBGUODHBGWSTUPBGHWSTHVT
      URZHGBXFTWAVBVDSVBSVCWJIJWMXBXDWKEGVQVFWNVGWJBAVHVIHIJWMKHLMHBRMXEHEWBWNK
      HVPWBWCVLWDHBNOVNVOVO $.

    ${
      lgsdir2lem2.1 $e |- ( K e. ZZ /\ 2 || ( K + 1 ) /\
        ( ( A e. ZZ /\ -. 2 || A ) ->
          ( ( A mod 8 ) e. ( 0 ... K ) -> ( A mod 8 ) e. S ) ) ) $.
      lgsdir2lem2.2 $e |- M = ( K + 1 ) $.
      lgsdir2lem2.3 $e |- N = ( M + 1 ) $.
      lgsdir2lem2.4 $e |- N e. S $.
      $( Lemma for ~ lgsdir2 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
      lgsdir2lem2 $p |- ( N e. ZZ /\ 2 || ( N + 1 ) /\
        ( ( A e. ZZ /\ -. 2 || A ) ->
          ( ( A mod 8 ) e. ( 0 ... N ) -> ( A mod 8 ) e. S ) ) ) $=
        ( cz wcel c2 c1 caddc co cdivides wbr cc0 cfz ax-1cn wn wa c8 wi simp1i
        cmo peano2z ax-mp eqeltri simp2i wb 2z dvdsadd mp2an mpbi addcomi eqtri
        cc zcn oveq1i df-2 add32i eqtr4i 2cn addassi breqtrri cmin wceq cuz cfv
        wo elfzuz2 fzm1 syl subaddrii oveq2i eleq2s eqcomi eleq2i simp3i syl5bi
        ibi cn 2nn 8nn w3a cmul 4nn nnzi dvdsmul2 4t2e8 breqtri dvdsmod mp3an12
        c4 mpan2 notbid biimpar id syl5breqr nsyl pm2.21d jaod eleq1 mpbiri a1i
        syl5 3pm3.2i ) EJKZLEMNOZPQAJKZLAPQZUAZUBZAUCUFOZRESOKZXOBKZUDUDEDMNOZJ
        HDJKZXRJKDCMNOZJGCJKZXTJKZYALXTPQZXNXORCSOZKZXQUDUDZFUEZCUGUHZUIZDUGUHU
        IZLLXTNOZXJPYCLYKPQZYAYCYFFUJZLJKZYBYCYLUKULYHLXTUMUNUOXJLCNOZMNOYKEYOM
        NEMCNOZMNOZYOEXRYQHDYPMNDXTYPGCMYACURKYGCUSUHZTUPUQZUTUQYOMMNOZCNOYQLYT
        CNVAUTMCMTYRTVBVCVCUTLCMVDYRTVEUQVFXPXOREMVGOZSOZKZXOEVHZVKZXNXQXPUUEXP
        ERVIVJZKXPUUEUKXOREVLXOREVMVNWBXNUUCXQUUDUUCXORDMVGOZSOZKZXODVHZVKZXNXQ
        UUKXORDSOZUUBXOUULKZUUKUUMDUUFKUUMUUKUKXORDVLXORDVMVNWBUUADRSEMDXIEURKY
        JEUSUHTXSDURKYIDUSUHZMDNOXREMDTUUNUPHVCVOVPVQXNUUIXQUUJUUIYEXNXQUUHYDXO
        UUGCRSDMCUUNTYRDYPYSVRVOVPVSYAYCYFFVTWAXNUUJXQXNLXOPQZUUJXKUUOUAXMXKUUO
        XLLWCKZUCWCKZXKUUOXLUKZWDWEUUPUUQXKWFLUCPQUURLWOLWGOZUCPWOJKYNLUUSPQWOW
        HWIULWOLWJUNWKWLLAUCWMWPWNWQWRUUJLDXOPLXTDPYMGVFUUJWSWTXAXBXCXGUUDXQUDX
        NUUDXQEBKIXOEBXDXEXFXCXGXH $.
    $}

    $( Lemma for ~ lgsdir2 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdir2lem3 $p |- ( ( A e. ZZ /\ -. 2 || A ) ->
      ( A mod 8 ) e. ( { 1 , 7 } u. { 3 , 5 } ) ) $=
      ( cz wcel c2 cdivides wbr c8 co cc0 c7 c1 c3 c5 cn ax-1cn caddc wi sselii
      cfz lgsdir2lem2 wn wa cmo cpr cun cmin simpl 8nn zmodfz sylancl nncni 7nn
      addcomi df-8 eqtr4i subaddrii oveq2i syl6eleq c6 c4 1z znegcl ax-mp dvds0
      cneg 2z negidi neg1cn eqtr3i breqtri c0 noel pm2.21i clt wceq 0lt1 cr 1re
      wb lt0neg2 mpbi 0z fzn mp2an eleq2s a1i 3pm3.2i 1e0p1 ssun1 1ex df-2 df-3
      prid1 ssun2 3nn elexi df-4 df-5 5nn prid2 df-6 df-7 simp3i mpd ) ABCZDAEF
      UAZUBZAGUCHZIJSHZCZXHKJUDZLMUDZUEZCZXGXHIGKUFHZSHZXIXGXEGNCXHXPCXEXFUGUHA
      GUIUJXOJISGKJGUHUKOJULUKZKJPHJKPHZGKJOXQUMUNUOUPUQURJBCDXREFXGXJXNQQAXMMU
      SJAXMLUTMAXMKDLAXMKVEZIKXSBCZDXSKPHZEFXGXHIXSSHZCXNQZQKBCXTVAKVBVCZDIYAED
      BCDIEFVFDVDVCKXSPHIYAKOVGKXSOVHUMVIZVJYCXGXNXHVKYBXHVKCXNXHVLVMXSIVNFZYBV
      KVOZIKVNFZYFVPKVQCYHYFVSVRKVTVCWAIBCXTYFYGVSWBYDIXSWCWDWAWEWFWGYEWHXKXMKX
      KXLWIZKJWJWMRTWKWLXLXMLXLXKWNZLMLNWOWPWMRTWQWRXLXMMYJLMMNWSWPWTRTXAXBXKXM
      JYIKJJNULWPWTRTXCXD $.

    $( Lemma for ~ lgsdir2 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdir2lem4 $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( A mod 8 ) e. { 1 , 7 } )
    -> ( ( ( A x. B ) mod 8 ) e. { 1 , 7 } <-> ( B mod 8 ) e. { 1 , 7 } ) ) $=
      ( c8 cmo co c1 c7 wcel cz wa wceq wo cmul cr a1i simpr cneg oveq1d eleq1d
      syl6eqr vx cpr wb ovex elpr crp zre ad2antrr 1re simplr 8pos elrpii c3 c5
      8re lgsdir2lem1 simpli modmul1 syl221anc cc zcn ad2antlr mulid2d renegcli
      eqtrd simpri mulm1d wi znegcl oveq1 negeq imbi12d neg1cn mulcom mpan2 syl
      cv mulm1 adantr 1z ax-mp eqtr3d mulid2i oveq1i eqtri syl6eq mulm1i ax-1cn
      ex negnegi orim12d orcom bitri 3imtr4g vtoclga sylibd impbid bitrd jaodan
      negnegd sylan2b ) ACDEZFGUBZHAIHZBIHZJZXBFKZXBGKZLABMECDEZXCHZBCDEZXCHZUC
      ZXBFGACDUDUEXFXGXMXHXFXGJZXIXKXCXNXIFBMEZCDEZXKXNANHZFNHZXECUFHZXBFCDEZKX
      IXPKXDXQXEXGAUGZUHXRXNUIOXDXEXGUJXSXNCUOUKULZOXNXBFXTXFXGPXTFKZFQZCDEZGKZ
      YCYFJUMCDEUMKUMQCDEUNKJUPUQZUQZTAFBCURUSXNXOBCDXNBXEBUTHZXDXGBVAZVBVCRVES
      XFXHJZXJBQZCDEZXCHZXLYKXIYMXCYKXIYDBMEZCDEZYMYKXQYDNHZXEXSXBYEKXIYPKXDXQX
      EXHYAUHYQYKFUIVDZOXDXEXHUJXSYKYBOYKXBGYEXFXHPYCYFYGVFZTAYDBCURUSYKYOYLCDY
      KBXEYIXDXHYJVBVGRVESXEYNXLUCXDXHXEYNXLXEYNYLQZCDEZXCHZXLXEYLIHYNUUBVHZBVI
      UAVQZCDEZXCHZUUDQZCDEZXCHZVHZUUCUAYLIUUDYLKZUUFYNUUIUUBUUKUUEYMXCUUDYLCDV
      JSUUKUUHUUAXCUUKUUGYTCDUUDYLVKRSVLUUDIHZUUEFKZUUEGKZLUUHGKZUUHFKZLZUUFUUI
      UULUUMUUOUUNUUPUULUUMUUOUULUUMJZUUHFYDMEZCDEZGUURUUDYDMEZCDEZUUHUUTUURUVA
      UUGCDUULUVAUUGKZUUMUULUUDUTHZUVCUUDVAUVDUVAYDUUDMEZUUGUVDYDUTHUVAUVEKVMUU
      DYDVNVOUUDVRVEVPZVSRUURUUDNHZXRYDIHZXSUUEXTKUVBUUTKUULUVGUUMUUDUGZVSXRUUR
      UIOUVHUURFIHUVHVTFVIWAZOXSUURYBOUURUUEFXTUULUUMPYHTUUDFYDCURUSWBUUTYEGUUS
      YDCDYDVMWCWDYSWEWFWIUULUUNUUPUULUUNJZUUHYDYDMEZCDEZFUVKUVBUUHUVMUVKUVAUUG
      CDUULUVCUUNUVFVSRUVKUVGYQUVHXSUUEYEKUVBUVMKUULUVGUUNUVIVSYQUVKYROUVHUVKUV
      JOXSUVKYBOUVKUUEGYEUULUUNPYSTUUDYDYDCURUSWBUVMXTFUVLFCDUVLYDQFYDVMWGFWHWJ
      WEWDYHWEWFWIWKUUEFGUUDCDUDUEUUIUUPUUOLUUQUUHFGUUGCDUDUEUUPUUOWLWMWNZWOVPX
      EUUAXKXCXEYTBCDXEBYJWTRSWPUUJXLYNVHUABIUUDBKZUUFXLUUIYNUVOUUEXKXCUUDBCDVJ
      SUVOUUHYMXCUVOUUGYLCDUUDBVKRSVLUVNWOWQVBWRWSXA $.

    $( Lemma for ~ lgsdir2 .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdir2lem5 $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\
      ( ( A mod 8 ) e. { 3 , 5 } /\ ( B mod 8 ) e. { 3 , 5 } ) ) ->
        ( ( A x. B ) mod 8 ) e. { 1 , 7 } ) $=
      ( cz wcel wa c8 cmo co c3 c5 cmul c1 c7 wceq a1i syl6eqr modmul12d oveq1i
      3cn wtru cpr cneg ovex elpr anbi12i simpll 3nn nnzi simplr crp 8re elrpii
      wo 8pos simprl lgsdir2lem1 simpri simpli simprr orcd znegcl mp1i mulneg1i
      ex syl6eq olcd mulneg2i mul2negi ccased syl5bi sylibr caddc c9 df-9 recni
      imp ax-1cn addcomi eqtri 3t3e9 mulid2i oveq2i 3eqtr4i cr 1re modcyc mp3an
      1z nnmulcli eqidd trud mulcli mulm1i 3eqtr3i preq12i syl6eleq ) ACDZBCDZE
      ZAFGHZIJUAZDZBFGHZXADZEZEZABKHZFGHZIIKHZFGHZXIUBZFGHZUAZLMUAXFXHXJNZXHXLN
      ZUMZXHXMDWSXEXPXEWTINZWTJNZUMZXCINZXCJNZUMZEWSXPXBXSXDYBWTIJAFGUCUDXCIJBF
      GUCUDUEWSXQXTXRYAXPWSXQXTEZXPWSYCEZXNXOYDAIBIFWQWRYCUFICDZYDIUGUHZOZWQWRY
      CUIYGFUJDZYDFUKUNULZOYDWTIIFGHZWSXQXTUOYJINZIUBZFGHZJNZLFGHZLNZLUBZFGHZMN
      ZEZYKYNEZUPUQZURZPYDXCIYJWSXQXTUSUUCPQUTVDWSXRXTEZXPWSUUDEZXOXNUUEXHYLIKH
      ZFGHXLUUEAYLBIFWQWRUUDUFYEYLCDZUUEYFIVAZVBWQWRUUDUIYEUUEYFOYHUUEYIOUUEWTJ
      YMWSXRXTUOYKYNUUBUQZPUUEXCIYJWSXRXTUSUUCPQUUFXKFGIISSVCRVEVFVDWSXQYAEZXPW
      SUUJEZXOXNUUKXHIYLKHZFGHXLUUKAIBYLFWQWRUUJUFYEUUKYFOWQWRUUJUIYEUUGUUKYFUU
      HVBYHUUKYIOUUKWTIYJWSXQYAUOUUCPUUKXCJYMWSXQYAUSUUIPQUULXKFGIISSVGRVEVFVDW
      SXRYAEZXPWSUUMEZXNXOUUNXHYLYLKHZFGHXJUUNAYLBYLFWQWRUUMUFYEUUGUUNYFUUHVBZW
      QWRUUMUIUUPYHUUNYIOUUNWTJYMWSXRYAUOUUIPUUNXCJYMWSXRYAUSUUIPQUUOXIFGIISSVH
      RVEUTVDVIVJVPXHXJXLXGFGUCUDVKXJLXLMXJYOLXJLLFKHZVLHZFGHZYOXIUURFGVMLFVLHZ
      XIUURVMFLVLHUUTVNFLFUKVOZVQVRVSVTUUQFLVLFUVAWAWBWCRLWDDYHLCDZUUSYONWEYIWH
      LFLWFWGVSZYPYSYTUUAUPURZURVSXLYRMYQXIKHZFGHZYQLKHZFGHZXLYRUVFUVHNTYQYQXIL
      FUVBYQCDTWHLVAVBZUVIXICDTXIIIUGUGWIUHOUVBTWHOYHTYIOTYRWJXJYONTUVCOQWKUVEX
      KFGXIIISSWLWMRUVGYQFGLVQWMRWNYPYSUVDUQVSWOWP $.

    $( The Legendre symbol is completely multiplicative at ` 2 ` .
       (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdir2 $p |- ( ( A e. ZZ /\ B e. ZZ ) ->
      ( ( A x. B ) /L 2 ) = ( ( A /L 2 ) x. ( B /L 2 ) ) ) $=
      ( wcel wa c2 cc0 c8 cmo co c1 cif cmul wceq iftrue adantl 3eqtr4a iffalse
      cc syl wn cz cdivides wbr c7 cneg clgs ax-1cn neg1cn keepel mul02i oveq1d
      cpr 0cn wi 2z dvdsmultr1 mp3an1 imp mul01i dvdsmultr2 mulid2i lgsdir2lem4
      oveq2d wb adantlr ifbid mulid1i zcn mulcom syl2an ad2antrr eleq1d ancom1s
      bitrd mulm1i negnegi eqtri oveqan12d c3 c5 cun lgsdir2lem3 ad2ant2r sylib
      elun orcanai ad2ant2l anim12dan lgsdir2lem5 syldan pm2.61ddan cprime 2prm
      wo ioran euclemma notbid biimpar sylan2br 3eqtr4d lgs2 zmulcl 3eqtr4rd )
      AUACZBUACZDZEAUBUCZFAGHIZJUDULZCZJJUEZKZKZEBUBUCZFBGHIZXICZJXKKZKZLIZEABL
      IZUBUCZFXTGHIZXICZJXKKZKZAEUFIZBEUFIZLIXTEUFIZXFXGXNXSYEMXFXGDZFXRLIFXSYE
      XRXNFXQRUMXPJXKRUGUHUIZUIUJYIXMFXRLXGXMFMXFXGFXLNOUKYIYAYEFMZXFXGYAEUACZX
      DXEXGYAUNUOEABUPUQURYAFYDNZSPXFXNDZXMFLIFXSYEXMXGFXLRUMXJJXKRUGUHUIZUIUSY
      NXRFXMLXNXRFMXFXNFXQNOVCYNYAYKXFXNYAYLXDXEXNYAUNUOEABUTUQURYMSPXFXGTZXNTZ
      DZDZXLXQLIZYDXSYEYSXJXPYTYDMYSXJDZJXQLIXQYTYDXQYJVAUUAXLJXQLXJXLJMYSXJJXK
      NOUKUUAYCXPJXKXFXJYCXPVDYRABVBVEVFPYSXPDZXLJLIXLYTYDXLYOVGUUBXQJXLLXPXQJM
      YSXPJXKNOVCUUBYCXJJXKUUBYCBALIZGHIZXICZXJUUBYBUUDXIUUBXTUUCGHXFXTUUCMZYRX
      PXDARCBRCUUFXEAVHBVHABVIVJVKUKVLXFXPUUEXJVDZYRXEXDXPUUGBAVBVMVEVNVFPYSXJT
      ZXPTZDZDZXKXKLIZJYTYDUULXKUEJXKUHVOJUGVPVQUUJYTUULMYSUUHUUIXLXKXQXKLXJJXK
      QXPJXKQVROUUKYCYDJMYSUUJXHVSVTULZCZXOUUMCZDZYCYSUUHUUNUUIUUOYSXJUUNYSXHXI
      UUMWAZCZXJUUNWNXDYPUURXEYQAWBWCXHXIUUMWEWDWFYSXPUUOYSXOUUQCZXPUUOWNXEYQUU
      SXDYPBWBWGXOXIUUMWEWDWFWHXFUUPYCYRABWIVEWJYCJXKNSPWKYRXSYTMXFYPYQXMXLXRXQ
      LXGFXLQXNFXQQVROYSYATZYEYDMYRXFXGXNWNZTZUUTXGXNWOXFUUTUVBXFYAUVAEWLCXDXEY
      AUVAVDWMEABWPUQWQWRWSYAFYDQSWTWKXDXEYFXMYGXRLAXABXAVRXFXTUACYHYEMABXBXTXA
      SXC $.

    $( The Legendre symbol is completely multiplicative at the primes.
       (Contributed by Mario Carneiro, 4-Feb-2015.) $)
    lgsdirprm $p |- ( ( A e. ZZ /\ B e. ZZ /\ P e. Prime ) ->
      ( ( A x. B ) /L P ) = ( ( A /L P ) x. ( B /L P ) ) ) $=
      ( vx cz wcel cmul co clgs wceq c2 syl2anc syl zcnd cabs cmo cr cle wbr c1
      cprime w3a simpl1 simpl2 lgsdir2 simpr oveq2d oveq12d 3eqtr4d wne zmulcld
      wa simpl3 prmz lgscl subcld cfv cc0 crp clt abscld cn prmnn nnrpd absge0d
      cmin 2re a1i nnred caddc readdcld abs2dif2d lgsle1 cv crab lgscl2 lgslem3
      1re eqid fveq2 breq1d elrab simprbi le2addd syl6breqr letrd prmuz2 eluzle
      df-2 3syl wb ltlen sylancr mpbir2and lelttrd modid syl22anc cdivides cdiv
      cuz cexp csn cdif eldifsn sylanbrc oddprm nnnn0d mulexpd cn0 zexpcl eqtrd
      mulcomd oveq1d lgsvalmod modmul1 syl221anc moddvds syl3anc mpbid dvdsabsb
      zred zsubcld nn0abscl nn0zd dvdsval3 eqtr3d abs00d subeq0d pm2.61dane ) A
      EFZBEFZCUAFZUBZABGHZCIHZACIHZBCIHZGHZJCKYMCKJZULZYNKIHZAKIHZBKIHZGHZYOYRY
      TYJYKUUAUUDJYJYKYLYSUCYJYKYLYSUDABUELYTCKYNIYMYSUFZUGYTYPUUBYQUUCGYTCKAIU
      UEUGYTCKBIUUEUGUHUIYMCKUJZULZYOYRUUGYOUUGYNEFZCEFZYOEFZUUGABYJYKYLUUFUCZY
      JYKYLUUFUDZUKZUUGYLUUIYJYKYLUUFUMZCUNMZYNCUOLZNZUUGYRUUGYPYQUUGYJUUIYPEFU
      UKUUOACUOLZUUGYKUUIYQEFZUULUUOBCUOLZUKZNZUUGYOYRVFHZUUGYOYRUUQUVBUPZUUGUV
      COUQZCPHZUVEURUUGUVEQFCUSFZURUVERSUVECUTSUVFUVEJUUGUVCUVDVAZUUGCUUGYLCVBF
      ZUUNCVCMZVDZUUGUVCUVDVEUUGUVEKCUVHKQFZUUGVGVHZUUGCUVJVIZUUGUVEYOOUQZYROUQ
      ZVJHZKUVHUUGUVOUVPUUGYOUUQVAZUUGYRUVBVAZVKUVMUUGYOYRUUQUVBVLUUGUVQTTVJHKR
      UUGUVOUVPTTUVRUVSTQFUUGVRVHZUVTUUGUUHUUIUVOTRSUUMUUOYNCVMLUUGYRDVNZOUQZTR
      SZDEVOZFZUVPTRSZUUGYPUWDFZYQUWDFZUWEUUGYJUUIUWGUUKUUODACUWDUWDVSZVPLUUGYK
      UUIUWHUULUUODBCUWDUWIVPLDYPYQUWDUWIVQLUWEYREFZUWFUWCUWFDYREUWAYRJUWBUVPTR
      UWAYROVTWAWBWCMWDWIWEWFUUGKCUTSZKCRSZUUFUUGYLCKWTUQFUWLUUNCWGKCWHWJYMUUFU
      FZUUGUVLCQFUWKUWLUUFULWKVGUVNKCWLWMWNWOUVECWPWQUUGCUVEWRSZUVFURJZUUGCUVCW
      RSZUWNUUGYOCPHZYRCPHZJZUWPUUGYNCTVFHKWSHZXAHZCPHZBUWTXAHZAUWTXAHZGHZCPHZU
      WQUWRUUGUXAUXECPUUGUXAUXDUXCGHUXEUUGABUWTUUGAUUKNUUGBUULNUUGUWTUUGCUAKXBX
      CFZUWTVBFUUGYLUUFUXGUUNUWMCUAKXDXEZCXFMXGZXHUUGUXDUXCUUGUXDUUGYJUWTXIFZUX
      DEFZUUKUXIAUWTXJLZNZUUGUXCUUGYKUXJUXCEFUULUXIBUWTXJLZNXLXKXMUUGUUHUXGUWQU
      XBJUUMUXHYNCXNLUUGUWRUXDYQGHZCPHZUXFUUGYPQFUXDQFUUSUVGYPCPHUXDCPHJZUWRUXP
      JUUGYPUURYAUUGUXDUXLYAUUTUVKUUGYJUXGUXQUUKUXHACXNLYPUXDYQCXOXPUUGUXPYQUXD
      GHZCPHZUXFUUGUXOUXRCPUUGUXDYQUXMUUGYQUUTNXLXMUUGYQQFUXCQFUXKUVGYQCPHUXCCP
      HJZUXSUXFJUUGYQUUTYAUUGUXCUXNYAUXLUVKUUGYKUXGUXTUULUXHBCXNLYQUXCUXDCXOXPX
      KXKUIUUGUVIUUJUWJUWSUWPWKUVJUUPUVAYOYRCXQXRXSUUGUUIUVCEFZUWPUWNWKUUOUUGYO
      YRUUPUVAYBZCUVCXTLXSUUGUVIUVEEFUWNUWOWKUVJUUGUVEUUGUYAUVEXIFUYBUVCYCMYDCU
      VEYELXSYFYGYHYI $.

    $( The Legendre symbol is completely multiplicative in its left argument.
       Together with ~ lgsqr this implies that the product of two quadratic
       residues or nonresidues is a residue, and the product of a residue and a
       nonresidue is a nonresidue.  (Contributed by Mario Carneiro,
       4-Feb-2015.) $)
    lgsdir $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ N e. ZZ ) /\
                     ( A =/= 0 /\ B =/= 0 ) ) ->
      ( ( A x. B ) /L N ) = ( ( A /L N ) x. ( B /L N ) ) ) $=
      ( vn cz wcel cc0 wa cmul co clgs wceq cexp c1 cif cc adantl wbr adantr cn
      vx vy vz vk w3a wne ax-1cn 0cn keepel mulid2i iftrue oveq1d zcnd ad2antrr
      c2 simpl1 simpl2 sqmuld simpr sqcld mulid2d 3eqtrd eqeq1d ifbid wn mul02i
      3eqtr4a iffalse cdivides dvdsmul1 syl2anc wb dvdssq mpbid breq2 syl5ibcom
      zmulcld cle wi simprl neneqd sqeq0 syl mtbird cn0 zsqcl2 elnn0 sylib mt3d
      wo ord nnzd 1nn dvdsle sylancl nnge1d jctird cr nnred letri3 sylibrd syld
      1re con3and pm2.61dan oveq2 lgs0 sylan9eqr oveq12d 3eqtr4rd clt cneg cabs
      cfv cv cprime cpc cmpt cseq lgsdilem mulcl mulcom wf eqid lgsfcl3 syl3anc
      ffvelrn syl2an lgscl eqtrd 3eqtr4d ifbieq12d ovex 1ex ifex lgsval4 neg1cn
      fvmpt a1i seqcl mulass cuz simpl3 nnabscl sylan nnuz syl6eleq cfz simpll1
      simpll3 elfznn simpll2 lgsdirprm prmz pczcl syl12anc mulexpd 1t1e1 eqcomi
      eleq1 oveq1 eqidd seqcaopr mul4d pm2.61dane ) AEFZBEFZCEFZUEZAGUFZBGUFZHZ
      HZABIJZCKJZACKJZBCKJZIJZLCGUVMCGLZHZAUOMJZNLZNGOZBUOMJZNLZNGOZIJZUVNUOMJZ
      NLZNGOZUVRUVOUVTUWBUWGUWJLUVTUWBHZNUWFIJUWFUWGUWJUWFUWENGPUGUHUIZUJUWKUWC
      NUWFIUWBUWCNLUVTUWBNGUKQULUWKUWIUWENGUWKUWHUWDNUWKUWHUWAUWDIJNUWDIJUWDUWK
      ABUVMAPFZUVSUWBUVMAUVFUVGUVHUVLUPZUMZUNUVMBPFUVSUWBUVMBUVFUVGUVHUVLUQZUMZ
      UNURUWKUWANUWDIUVTUWBUSULUWKUWDUVMUWDPFUVSUWBUVMBUWQUTUNVAVBVCVDVGUVTUWBV
      EZHZGUWFIJGUWGUWJUWFUWLVFUWSUWCGUWFIUWRUWCGLUVTUWBNGVHQULUWSUWIVEUWJGLUVT
      UWIUWBUVTUWIUWANVIRZUWBUVTUWAUWHVIRZUWIUWTUVMUXAUVSUVMAUVNVIRZUXAUVMUVFUV
      GUXBUWNUWPABVJVKUVMUVFUVNEFZUXBUXAVLUWNUVMABUWNUWPVQZAUVNVMVKVNSUWHNUWAVI
      VOVPUVTUWTUWANVRRZNUWAVRRZHZUWBUVTUWTUXEUXFUVTUWAEFNTFUWTUXEVSUVTUWAUVMUW
      ATFZUVSUVMUXHUWAGLZUVMUXIAGLZUVMAGUVIUVJUVKVTWAUVMUWMUXIUXJVLUWOAWBWCWDUV
      MUXHUXIUVMUWAWEFZUXHUXIWJUVMUVFUXKUWNAWFWCUWAWGWHWKWISZWLWMUWANWNWOUVTUWA
      UXLWPWQUVTUWAWRFNWRFUWBUXGVLUVTUWAUXLWSXCUWANWTWOXAXBXDUWINGVHWCVGXEUVTUV
      PUWCUVQUWFIUVSUVMUVPAGKJZUWCCGAKXFUVMUVFUXMUWCLUWNAXGWCXHUVSUVMUVQBGKJZUW
      FCGBKXFUVMUVGUXNUWFLUWPBXGWCXHXIUVSUVMUVOUVNGKJZUWJCGUVNKXFUVMUXCUXOUWJLU
      XDUVNXGWCXHXJUVMCGUFZHZCGXKRZUVNGXKRHNXLZNOZCXMXNZIDTDXOZXPFZUVNUYBKJZUYB
      CXQJZMJZNOZXRZNXSXNZIJZUXRAGXKRHZUXSNOZUXRBGXKRHZUXSNOZIJZUYAIDTUYCAUYBKJ
      ZUYEMJZNOZXRZNXSXNZUYAIDTUYCBUYBKJZUYEMJZNOZXRZNXSXNZIJZIJZUVOUVRUXQUXTUY
      OUYIVUFIUVMUXTUYOLUXPABCXTSUXQUAUBUCIPUDUYSVUDUYHNUYAUAXOZPFZUBXOZPFZHZVU
      HVUJIJZPFUXQVUHVUJYAQVULVUMVUJVUHIJLUXQVUHVUJYBQVUIVUKUCXOZPFUEVUMVUNIJVU
      HVUJVUNIJIJLUXQVUHVUJVUNUUAQUXQUYATNUUBXNUVMUVHUXPUYATFUVFUVGUVHUVLUUCCUU
      DUUEUUFUUGZUXQUDXOZNUYAUUHJFZHZVUPUYSXNZUXQTEUYSYCZVUPTFZVUSEFVUQUXQUVFUV
      HUXPVUTUVFUVGUVHUVLUXPUUIZUVFUVGUVHUVLUXPUUJZUVMUXPUSZADUYSCUYSYDZYEYFVUP
      UYAUUKZTEVUPUYSYGYHUMZVURVUPVUDXNZUXQTEVUDYCZVVAVVHEFVUQUXQUVGUVHUXPVVIUV
      FUVGUVHUVLUXPUULZVVCVVDBDVUDCVUDYDZYEYFVVFTEVUPVUDYGYHUMZVURVUPXPFZUVNVUP
      KJZVUPCXQJZMJZNOZVVMAVUPKJZVVOMJZNOZVVMBVUPKJZVVOMJZNOZIJZVUPUYHXNZVUSVVH
      IJUXQVVQVWDLZVUQUXQVVMVWFUXQVVMHZVVPVVSVWBIJZVVQVWDVWGVVPVVRVWAIJZVVOMJVW
      HVWGVVNVWIVVOMVWGUVFUVGVVMVVNVWILUXQUVFVVMVVBSUXQUVGVVMVVJSUXQVVMUSZABVUP
      UUMYFULVWGVVRVWAVVOVWGVVRUXQUVFVUPEFZVVREFVVMVVBVUPUUNZAVUPYIYHUMVWGVWAUX
      QUVGVWKVWAEFVVMVVJVWLBVUPYIYHUMVWGVVMUVHUXPVVOWEFVWJUXQUVHVVMVVCSUXQUXPVV
      MVVDSVUPCUUOUUPUUQYJVVMVVQVVPLUXQVVMVVPNUKQVVMVWDVWHLUXQVVMVVTVVSVWCVWBIV
      VMVVSNUKVVMVWBNUKXIQYKVVMVEZVWFUXQVWMNNNIJZVVQVWDVWNNUURUUSVVMVVPNVHVWMVV
      TNVWCNIVVMVVSNVHVVMVWBNVHXIVGQXESVURVVAVWEVVQLVUQVVAUXQVVFQZDVUPUYGVVQTUY
      HUYBVUPLZUYCVVMUYFNVVPNUYBVUPXPUUTZVWPUYDVVNUYEVVOMUYBVUPUVNKXFUYBVUPCXQU
      VAZXIVWPNUVBZYLUYHYDZVVMVVPNVVNVVOMYMYNYOYRWCVURVUSVVTVVHVWCIVURVVAVUSVVT
      LVWODVUPUYRVVTTUYSVWPUYCVVMUYQNVVSNVWQVWPUYPVVRUYEVVOMUYBVUPAKXFVWRXIVWSY
      LVVEVVMVVSNVVRVVOMYMYNYOYRWCVURVVAVVHVWCLVWODVUPVUCVWCTVUDVWPUYCVVMVUBNVW
      BNVWQVWPVUAVWAUYEVVOMUYBVUPBKXFVWRXIVWSYLVVKVVMVWBNVWAVVOMYMYNYOYRWCXIYKU
      VCXIUXQUXCUVHUXPUVOUYJLUVMUXCUXPUXDSVVCVVDUVNDUYHCVWTYPYFUXQUVRUYLUYTIJZU
      YNVUEIJZIJVUGUXQUVPVXAUVQVXBIUXQUVFUVHUXPUVPVXALVVBVVCVVDADUYSCVVEYPYFUXQ
      UVGUVHUXPUVQVXBLVVJVVCVVDBDVUDCVVKYPYFXIUXQUYLUYTUYNVUEUYLPFUXQUYKUXSNPYQ
      UGUIYSUXQUDUAIPUYSNUYAVUOVVGVUPPFVUIHVUPVUHIJPFUXQVUPVUHYAQZYTUYNPFUXQUYM
      UXSNPYQUGUIYSUXQUDUAIPVUDNUYAVUOVVLVXCYTUVDYJYKUVE $.

    ${
      lgsdilem2.1 $e |- ( ph -> A e. ZZ ) $.
      lgsdilem2.2 $e |- ( ph -> M e. ZZ ) $.
      lgsdilem2.3 $e |- ( ph -> N e. ZZ ) $.
      lgsdilem2.4 $e |- ( ph -> M =/= 0 ) $.
      lgsdilem2.5 $e |- ( ph -> N =/= 0 ) $.
      lgsdilem2.6 $e |- F = ( n e. NN |-> if ( n e. Prime ,
        ( ( A /L n ) ^ ( n pCnt M ) ) , 1 ) ) $.
      $( Lemma for ~ lgsdi .  (Contributed by Mario Carneiro, 4-Feb-2015.) $)
      lgsdilem2 $p |- ( ph -> ( seq 1 ( x. , F ) ` ( abs ` M ) ) =
        ( seq 1 ( x. , F ) ` ( abs ` ( M x. N ) ) ) ) $=
        ( cfv c1 co wcel cn cz cc0 syl2anc vk vx cmul cc cabs mulid1 adantl cuz
        wceq wne nnabscl nnuz syl6eleq cle wbr nnzd zmulcld zcnd mulne0d abscld
        cv absge0d nnge1d lemulge11d absmuld breqtrrd eluz2 syl3anbrc cfz wa wf
        lgsfcl3 syl3anc elfznn ffvelrn syl2an mulcl seqcl caddc cprime clgs cpc
        cexp cif peano2nnd elfzuz uztrn2 eleq1 oveq2 oveq1 eqidd ifbieq12d ovex
        oveq12d 1ex ifex fvmpt syl cq simpr ad2antrr pcabs cdivides clt elfzle1
        zq wn wb elfzelz zltp1le mpbird cr adantr zred ltnled mpbid prmz dvdsle
        mtod pceq0 eqtr3d oveq2d lgscl exp0d eqtrd ifeq1da ifid syl6eq seqid2
        wi ) AUAUCUDDEUEMZNEFUCOZUEMZNUAVAZUDPZYNNUCOYNUIAYNUFUGAYKQNUHMAERPZES
        UJZYKQPZHJEUKZTZULUMZAYKRPZYMRPYKYMUNUOYMYKUHMPAYKYTUPZAYMAYLRPYLSUJYMQ
        PAEFHIUQAEFAEHURZAFIURZJKUSYLUKTUPAYKYKFUEMZUCOYMUNAYKUUFAEUUDUTZAFUUEU
        TAEUUDVBAUUFAFRPFSUJUUFQPIKFUKTVCVDAEFUUDUUEVEVFYKYMVGVHAUAUBUCUDDNYKUU
        AAYNNYKVIOPZVJYNDMZAQRDVKZYNQPZUUIRPUUHABRPZYPYQUUJGHJBCDELVLVMYNYKVNQR
        YNDVOVPURYOUBVAZUDPVJYNUUMUCOUDPAYNUUMVQUGVRAYNYKNVSOZYMVIOPZVJZUUIYNVT
        PZBYNWAOZYNEWBOZWCOZNWDZNUUPUUKUUIUVAUIAUUNQPYNUUNUHMPUUKUUOAYKYTWEYNUU
        NYMWFNYNUUNQULWGVPCYNCVAZVTPZBUVBWAOZUVBEWBOZWCOZNWDUVAQDUVBYNUIZUVCUUQ
        UVFNUUTNUVBYNVTWHUVGUVDUURUVEUUSWCUVBYNBWAWIUVBYNEWBWJWNUVGNWKWLLUUQUUT
        NUURUUSWCWMWOWPWQWRUUPUVAUUQNNWDNUUPUUQUUTNNUUPUUQVJZUUTUURSWCONUVHUUSS
        UURWCUVHYNYKWBOZUUSSUVHUUQEWSPZUVIUUSUIUUPUUQWTZUVHYPUVJAYPUUOUUQHXAZEX
        FWREYNXBTUVHUVISUIZYNYKXCUOZXGZUVHUVNYNYKUNUOZUUPUVPXGZUUQUUPYKYNXDUOZU
        VQUUPUVRUUNYNUNUOZUUOUVSAYNUUNYMXEUGAUUBYNRPZUVRUVSXHUUOUUCYNUUNYMXIZYK
        YNXJVPXKUUPYKYNAYKXLPUUOUUGXMUUPYNUUOUVTAUWAUGXNXOXPXMUVHUVTYRUVNUVPYJU
        UQUVTUUPYNXQUGZUVHYPYQYRUVLAYQUUOUUQJXAYSTZYNYKXRTXSUVHUUQYRUVMUVOXHUVK
        UWCYNYKXTTXKYAYBUVHUURUVHUURUVHUULUVTUURRPAUULUUOUUQGXAUWBBYNYCTURYDYEY
        FUUQNYGYHYEYI $.
    $}

    $( The Legendre symbol is completely multiplicative in its right argument.
       (Contributed by Mario Carneiro, 5-Feb-2015.) $)
    lgsdi $p |- ( ( ( A e. ZZ /\ M e. ZZ /\ N e. ZZ ) /\
                    ( M =/= 0 /\ N =/= 0 ) ) ->
      ( A /L ( M x. N ) ) = ( ( A /L M ) x. ( A /L N ) ) ) $=
      ( vn cz wcel cc0 wa cmul co c1 cif cfv cn cpc cexp wceq cc adantl oveq12d
      vx vy vz vk w3a wne clt wbr cneg cabs cv cprime clgs cmpt 3anrot lgsdilem
      cseq sylanb wb ancom ax-mp oveq12i 3eqtr4g mulcl mulcom mulass cuz simpl2
      ifbi simpl3 zmulcld zcnd simprl mulne0d nnabscl syl2anc nnuz syl6eleq cfz
      simprr wf simpl1 eqid lgsfcl3 syl3anc elfznn ffvelrn caddc simpr ad2antrr
      syl2an pcmul syl122anc oveq2d prmz lgscl cn0 pczcl syl12anc expaddd eqtrd
      iftrue 3eqtr4rd 1t1e1 iffalse pm2.61dan eleq1 oveq2 oveq1 eqidd ifbieq12d
      3eqtr4a ovex 1ex ifex fvmpt syl seqcaopr lgsdilem2 mulcomd fveq2d lgsval4
      wn eqtr4d neg1cn ax-1cn keepel a1i seqcl mul4d 3eqtr4d ) AEFZBEFZCEFZUEZB
      GUFZCGUFZHZHZBCIJZGUGUHZAGUGUHZHZKUIZKLZYTUJMZIDNDUKZULFZAUUGUMJZUUGYTOJZ
      PJZKLZUNZKUQMZIJZBGUGUHZUUBHZUUDKLZCGUGUHZUUBHZUUDKLZIJZBUJMZIDNUUHUUIUUG
      BOJZPJZKLZUNZKUQZMZCUJMZIDNUUHUUIUUGCOJZPJZKLZUNZKUQZMZIJZIJZAYTUMJZABUMJ
      ZACUMJZIJZYSUUEUVBUUNUVQIYSUUBUUAHZUUDKLZUUBUUPHZUUDKLZUUBUUSHZUUDKLZIJZU
      UEUVBYOYMYNYLUEYRUWDUWIQYLYMYNUOBCAUPURUUCUWCUSUUEUWDQUUAUUBUTUUCUWCUUDKV
      IVAUURUWFUVAUWHIUUQUWEUSUURUWFQUUPUUBUTUUQUWEUUDKVIVAUUTUWGUSUVAUWHQUUSUU
      BUTUUTUWGUUDKVIVAVBVCYSUUNUUFUVHMZUUFUVOMZIJUVQYSUAUBUCIRUDUVGUVNUUMKUUFU
      AUKZRFZUBUKZRFZHZUWLUWNIJZRFYSUWLUWNVDSUWPUWQUWNUWLIJQYSUWLUWNVESUWMUWOUC
      UKZRFUEUWQUWRIJUWLUWNUWRIJIJQYSUWLUWNUWRVFSYSUUFNKVGMZYSYTEFZYTGUFZUUFNFY
      SBCYLYMYNYRVHZYLYMYNYRVJZVKZYSBCYSBUXBVLZYSCUXCVLZYOYPYQVMZYOYPYQVTZVNZYT
      VOVPVQVRYSUDUKZKUUFVSJFZHZUXJUVGMZYSNEUVGWAZUXJNFZUXMEFZUXKYSYLYMYPUXNYLY
      MYNYRWBZUXBUXGADUVGBUVGWCZWDWEZUXJUUFWFZNEUXJUVGWGZWKVLUXLUXJUVNMZYSNEUVN
      WAZUXOUYBEFZUXKYSYLYNYQUYCUXQUXCUXHADUVNCUVNWCZWDWEZUXTNEUXJUVNWGZWKVLUXL
      UXJULFZAUXJUMJZUXJBOJZPJZKLZUYHUYIUXJCOJZPJZKLZIJZUYHUYIUXJYTOJZPJZKLZUXM
      UYBIJZUXJUUMMZUXLUYHUYPUYSQZUXLUYHHZUYRUYKUYNIJZUYSUYPVUCUYRUYIUYJUYMWHJZ
      PJVUDVUCUYQVUEUYIPVUCUYHYMYPYNYQUYQVUEQUXLUYHWIZYSYMUXKUYHUXBWJZYSYPUXKUY
      HUXGWJZYSYNUXKUYHUXCWJZYSYQUXKUYHUXHWJZBCUXJWLWMWNVUCUYIUYJUYMVUCUYIVUCYL
      UXJEFZUYIEFYSYLUXKUYHUXQWJUYHVUKUXLUXJWOSAUXJWPVPVLVUCUYHYNYQUYMWQFVUFVUI
      VUJUXJCWRWSVUCUYHYMYPUYJWQFVUFVUGVUHUXJBWRWSWTXAUYHUYSUYRQUXLUYHUYRKXBSUY
      HUYPVUDQUXLUYHUYLUYKUYOUYNIUYHUYKKXBUYHUYNKXBTSXCUYHYCZVUBUXLVULKKIJKUYPU
      YSXDVULUYLKUYOKIUYHUYKKXEUYHUYNKXETUYHUYRKXEXLSXFUXLUXOUYTUYPQUXKUXOYSUXT
      SZUXOUXMUYLUYBUYOIDUXJUVFUYLNUVGUUGUXJQZUUHUYHUVEKUYKKUUGUXJULXGZVUNUUIUY
      IUVDUYJPUUGUXJAUMXHZUUGUXJBOXITVUNKXJZXKUXRUYHUYKKUYIUYJPXMXNXOXPDUXJUVMU
      YONUVNVUNUUHUYHUVLKUYNKVUOVUNUUIUYIUVKUYMPVUPUUGUXJCOXITVUQXKUYEUYHUYNKUY
      IUYMPXMXNXOXPTXQUXLUXOVUAUYSQVUMDUXJUULUYSNUUMVUNUUHUYHUUKKUYRKVUOVUNUUIU
      YIUUJUYQPVUPUUGUXJYTOXITVUQXKUUMWCZUYHUYRKUYIUYQPXMXNXOXPXQXCXRYSUVIUWJUV
      PUWKIYSADUVGBCUXQUXBUXCUXGUXHUXRXSYSUVPCBIJZUJMZUVOMUWKYSADUVNCBUXQUXCUXB
      UXHUXGUYEXSYSUUFVUTUVOYSYTVUSUJYSBCUXEUXFXTYAYAYDTYDTYSYLUWTUXAUVSUUOQUXQ
      UXDUXIADUUMYTVURYBWEYSUWBUURUVIIJZUVAUVPIJZIJUVRYSUVTVVAUWAVVBIYSYLYMYPUV
      TVVAQUXQUXBUXGADUVGBUXRYBWEYSYLYNYQUWAVVBQUXQUXCUXHADUVNCUYEYBWETYSUURUVI
      UVAUVPUURRFYSUUQUUDKRYEYFYGYHYSUDUAIRUVGKUVCYSUVCNUWSYSYMYPUVCNFUXBUXGBVO
      VPVQVRYSUXJKUVCVSJFZHUXMYSUXNUXOUXPVVCUXSUXJUVCWFUYAWKVLUXJRFUWMHUXJUWLIJ
      RFYSUXJUWLVDSZYIUVARFYSUUTUUDKRYEYFYGYHYSUDUAIRUVNKUVJYSUVJNUWSYSYNYQUVJN
      FUXCUXHCVOVPVQVRYSUXJKUVJVSJFZHUYBYSUYCUXOUYDVVEUYFUXJUVJWFUYGWKVLVVDYIYJ
      XAYK $.

    $( The Legendre symbol is nonzero (and hence equal to ` 1 ` or ` -u 1 ` )
       precisely when the arguments are coprime.  (Contributed by Mario
       Carneiro, 5-Feb-2015.) $)
    lgsne0 $p |- ( ( A e. ZZ /\ N e. ZZ ) ->
      ( ( A /L N ) =/= 0 <-> ( A gcd N ) = 1 ) ) $=
      ( cz wcel wa co cc0 wne c1 wceq c2 cexp syl syl2anc adantr cn cc cdivides
      wbr cmo vn vk vx vp vy clgs cgcd wb cif cabs cfv iffalse necon1ai ax-1ne0
      iftrue a1i eqnetrd impbii cr zre ad2antrr absresq sq1 eqeq12d cle absge0d
      recnd abscld 1re oveq2 sylan9eqr neeq1d eqeq1d w3a clt cmul cv cprime cpc
      neeq1 ax-1cn keephyp cuz nnabscl nnuz syl6eleq zcnd mulcl adantl seqcl wn
      simpr ad2antrl dvdsgcdb syl3anc mpbird simprd dvdsabsb mpbid wi mpd prmnn
      prmz eleq1 oveq1 oveq12d eqidd ifbieq12d ovex ifex fvmpt eqtrd cmin caddc
      1ex cdiv simpll1 eldifsn sylanbrc crp oddprm nnnn0d zexpcl nnrpd dvdsval3
      cn0 0mod syl221anc 0expd oveq1d syl6eq pm2.61dane pcabs simplr breq2d imp
      sylibr notbid gcdabs elrab 0le1 sq11 mpanr12 bitr3d syl5bb gcdid0 3bitr4d
      lgs0 cneg cmpt cseq lgsval4 negne0i biantrur neg1cn keepel 3adant1 cfz wf
      eqid lgsfcl3 elfznn ffvelrn syl2an mulne0bd syl5rbb necon3ai sylan2 3impa
      gcdn0cl eluz2b3 exprmfct sylbir adantlr mul02 simprr simpl1 simpl2 dvdsle
      wrex mul01 nnzd elfz5 c8 cpr lgs2 simpld eqbrtrrd csn cdif simprl lgsval3
      c7 zred 0re eqtr4d modexp modadd1 0p1e1 oveq1i nnred prmuz2 eluz2b2 sylib
      0z 1mod 1m1e0 cq pcelnn eqeltrrd 3eqtrd seqz rexlimdvaa syl5 necon1d crab
      zq mpand lgscl nprmdvds1 simpll2 bitrd mtbird imnan con2d breq1 syl5ibcom
      dvdsgcd mpan2d absexpd dvds0 breq2 necon3bd simpll3 rplpwr 3eqtr3d sylibd
      syl5ibrcom mtod necon3bbid lgsvalmod 3netr4d necon3i pczcl syl12anc nn0zd
      expclz expne0i 3bitr2rd biimpar oveq2d mpbir2an syl6eqel pm2.61dan ifclda
      pceq0 exp0d eqeltrd ad2ant2r mulne0 jca syl2anb simprbi ex impbid 3bitrd
      3expa ) ACDZBCDZEZABUFFZGHZABUGFZIJZUHZBGVVJBGJZEZAKLFZIJZIGUIZGHZAUJUKZI
      JZVVLVVNVWAVVSVVQVWCVWAVVSVVSVVTGVVSIGULUMVVSVVTIGVVSIGUOIGHZVVSUNUPUQURV
      VQVWBKLFZIKLFZJZVVSVWCVVQVWEVVRVWFIVVQAUSDZVWEVVRJVVHVWHVVIVVPAUTVAZAVBMV
      WFIJVVQVCUPVDVVQVWBUSDZGVWBVESZVWGVWCUHZVVQAVVQAVWIVGZVHVVQAVWMVFVWJVWKEI
      USDZGIVESVWLVIUUAVWBIUUBUUCNUUDUUEVVQVVKVVTGVVPVVJVVKAGUFFZVVTBGAUFVJVVHV
      WOVVTJVVIAUUHOVKVLVVQVVMVWBIVVPVVJVVMAGUGFZVWBBGAUGVJVVHVWPVWBJVVIAUUFOVK
      VMUUGVVHVVIBGHZVVOVVHVVIVWQVNZVVLBGVOSAGVOSEZIUUIZIUIZBUJUKZVPUAPUAVQZVRD
      ZAVXCUFFZVXCBVSFZLFZIUIZUUJZIUUKUKZVPFZGHZVXJGHZVVNVWRVVKVXKGAUAVXIBVXIUU
      TZUULVLVXMVXAGHZVXMEVWRVXLVXOVXMVWSVWTGHZVWDVXOVWTIVWTVXAGVTIVXAGVTIWAUNU
      UMZUNWBUUNVWRVXAVXJVXAQDVWRVWSVWTIQUUOWAUUPUPVWRUBUCVPQVXIIVXBVWRVXBPIWCU
      KZVVIVWQVXBPDZVVHBWDZUUQZWEWFZVWRUBVQZIVXBUURFZDZEVYCVXIUKZVWRPCVXIUUSVYC
      PDZVYFCDVYEAUAVXIBVXNUVAVYCVXBUVBZPCVYCVXIUVCUVDWGZVYCQDZUCVQZQDEZVYCVYKV
      PFQDZVWRVYCVYKWHZWIWJUVEUVFVWRVXMVVNVWRVVMIVXJGVWRVVMPDZVVMIHZVXJGJZVVHVV
      IVWQVYOVWQVVJAGJZVVPEZWKVYOVYSBGVYRVVPWLUVGABUVJUVHUVIVYOVYPEZUDVQZVVMRSZ
      UDVRUVTZVWRVYQVYTVVMKWCUKZDWUCVVMUVKVVMUDUVLUVMVWRWUBVYQUDVRVWRWUAVRDZWUB
      EZEZUBUCVPQVXIWUAIVXBPGVYLVYMWUGVYNWIVWRVYEVYFQDWUFVYIUVNVYJGVYCVPFGJWUGV
      YCUVOWIVYJVYCGVPFGJWUGVYCUWAWIWUGWUAVYDDZWUAVXBVESZWUGWUAVXBRSZWUIWUGWUAB
      RSZWUJWUGWUAARSZWUKWUGWULWUKEZWUBVWRWUEWUBUVPWUGWUACDZVVHVVIWUMWUBUHWUEWU
      NVWRWUBWUAXCWMZVVHVVIVWQWUFUVQZVVHVVIVWQWUFUVRZWUAABWNWOWPZWQWUGWUNVVIWUK
      WUJUHWUOWUQWUABWRNWSZWUGWUNVXSWUJWUIWTWUOVWRVXSWUFVYAOZWUAVXBUVSNXAWUGWUA
      VXRDVXBCDWUHWUIUHWUGWUAPVXRWUEWUAPDZVWRWUBWUAXBZWMZWEWFWUGVXBWUTUWBWUAIVX
      BUWCNWPWUTWUGWUAVXIUKZWUEAWUAUFFZWUABVSFZLFZIUIZWVGGWUGWVAWVDWVHJWVCUAWUA
      VXHWVHPVXIVXCWUAJZVXDWUEVXGIWVGIVXCWUAVRXDWVIVXEWVEVXFWVFLVXCWUAAUFVJVXCW
      UABVSXEXFWVIIXGXHVXNWUEWVGIWVEWVFLXIXOXJXKMWUEWVHWVGJVWRWUBWUEWVGIUOWMWUG
      WVGGWVFLFGWUGWVEGWVFLWUGWVEGJWUAKWUGWUAKJZEZWVEKARSZGAUWDTFIUWMUWEDZIVWTU
      IZUIZGWVJWUGWVEAKUFFZWVOWUAKAUFVJWUGVVHWVPWVOJZWUPAUWFZMVKWVKWVLWVOGJWVKW
      UAKARWUGWVJWLWUGWULWVJWUGWULWUKWURUWGZOUWHWVLGWVNUOMXLWUGWUAKHZEZWVEAWUAI
      XMFKXPFZLFZIXNFWUATFZIXMFZGWWAVVHWUAVRKUWIUWJZDZWVEWWEJVVHVVIVWQWUFWVTXQZ
      WWAWUEWVTWWGWUGWUEWVTVWRWUEWUBUWKZOZWUGWVTWLWUAVRKXRXSZAWUAUWLNWWAWWEIIXM
      FGWWAWWDIIXMWWAWWDIWUATFZIWWAWWDGIXNFZWUATFZWWLWWAWWCUSDGUSDZVWNWUAXTDZWW
      CWUATFZGWUATFZJWWDWWNJWWAWWCWWAVVHWWBYFDZWWCCDWWHWWAWWBWWAWWGWWBPDWWKWUAY
      AMZYBZAWWBYCNUWNWWOWWAUWOUPVWNWWAVIUPWWAWUAWWAWUEWVAWWJWVBMZYDZWWAWWQGWWB
      LFZWUATFZWWRWWAVVHGCDZWWSWWPAWUATFZWWRJWWQWXEJWWHWXFWWAUXEUPWXAWXCWWAWXGG
      WWRWWAWULWXGGJZWUGWULWVTWVSOWWAWVAVVHWULWXHUHWXBWWHWUAAYENWSWWAWWPWWRGJWX
      CWUAYGMUWPAGWWBWUAUWQYHWWAWXDGWUATWWAWWBWWTYIYJXLWWCGIWUAUWRYHWWMIWUATUWS
      UWTYKWWAWUAUSDIWUAVOSZWWLIJWWAWUAWXBUXAWWAWVAWXIWWAWUAWUDDZWVAWXIEWWAWUEW
      XJWWJWUAUXBMWUAUXCUXDWQWUAUXFNXLYJUXGYKXLYLYJWUGWVFWUGWUAVXBVSFZWVFPWUGWU
      EBUXHDZWXKWVFJWWIWUGVVIWXLWUQBUXQZMBWUAYMNWUGWXKPDZWUJWUSWUGWUEVXSWXNWUJU
      HWWIWUTWUAVXBUXINWPUXJYIXLUXKUXLUXMUXNUXRUXOVWRVVNVXMVWRVVNEZVXJVYKGHZUCQ
      UXPZDZVXMWXOUBUEVPWXQVXIIVXBVWRVXBVXRDVVNVYBOWXOVYEEZVYFVYCVRDZAVYCUFFZVY
      CBVSFZLFZIUIZWXQWXSVYGVYFWYDJVYEVYGWXOVYHWIUAVYCVXHWYDPVXIVXCVYCJZVXDWXTV
      XGIWYCIVXCVYCVRXDWYEVXEWYAVXFWYBLVXCVYCAUFVJVXCVYCBVSXEXFWYEIXGXHVXNWXTWY
      CIWYAWYBLXIXOXJXKMWXOWYDWXQDVYEWXOWXTWYCIWXQWXOWXTEZVYCBRSZWYCWXQDZWYFWYG
      EZWYAQDZWYAGHZWYBCDZWYHWYFWYJWYGWYFWYAWYFVVHVYCCDZWYACDVVHVVIVWQVVNWXTXQZ
      WXTWYMWXOVYCXCZWIZAVYCUXSNWGZOWYIWYKVYCKWYIVYCKJZEZWYAWVNGWYSWYAWVOWVNWYR
      WYIWYAWVPWVOVYCKAUFVJWYIVVHWVQWYFVVHWYGWYNOZWVRMVKWYSWVLWKZWVOWVNJWYIWYRX
      UAWYIVYCARSZWKZWYRXUAWYFWYGXUCWYFXUBWYGWYFXUBWYGEZWKXUBWYGWKZWTWYFXUDVYCI
      RSZWXTXUFWKZWXOVYCUXTZWIWYFXUDVYCVVMRSZXUFWYFWYMVVHVVIXUDXUIUHWYPWYNVVHVV
      IVWQVVNWXTUYAZVYCABWNWOWYFVVMIVYCRVWRVVNWXTYNZYOUYBUYCXUBWYGUYDYQUYEYPZWY
      RXUBWVLVYCKARUYFYRUYGYPWVLGWVNULMXLWVNGHZWYSWVMVWDVXPXUMIVWTIWVNGVTVWTWVN
      GVTUNVXQWBUPUQWYIVYCKHZEZWYAVYCTFZGVYCTFZHWYKXUOAVYCIXMFKXPFZLFZVYCTFZGXU
      PXUQXUOVYCXUSRSZWKXUTGHXUOXVAXUFXUOWXTXUGWYFWXTWYGXUNWXOWXTWLZVAZXUHMXUOX
      VAVYCXUSBUGFZRSZXUFXUOXVAWYGXVEWYFWYGXUNYNXUOWYMXUSCDZVVIXVAWYGEXVEWTXUOW
      XTWYMXVCWYOMZXUOVVHXURYFDXVFWYIVVHXUNWYTOZXUOXURXUOVYCWWFDZXURPDZXUOWXTXU
      NXVIXVCWYIXUNWLVYCVRKXRXSZVYCYAMZYBZAXURYCNZWYFVVIWYGXUNXUJVAZVYCXUSBUYHW
      OUYIXUOXVDIVYCRXUOXUSUJUKZVXBUGFZVWBXURLFZVXBUGFZXVDIXUOXVPXVRVXBUGXUOAXU
      RXUOAXVHWGXVMUYJYJXUOXVFVVIXVQXVDJXVNXVOXUSBYSNXUOVWBVXBUGFZIJZXVSIJZXUOX
      VTVVMIXUOVVHVVIXVTVVMJXVHXVOABYSNWYFVVNWYGXUNXUKVAXLXUOVWBPDZVXSXVJXWAXWB
      WTXUOVVHAGHZXWCXVHXUOXUCXWDWYIXUCXUNXULOXUOXUBAGXUOXUBVYRVYCGRSZXUOWYMXWE
      XVGVYCUYKMAGVYCRUYLUYRUYMXAAWDNWYFVXSWYGXUNWYFVVIVWQVXSXUJVVHVVIVWQVVNWXT
      UYNZVXTNZVAXVLVWBVXBXURUYOWOXAUYPYOUYQUYSXUOXVAXUTGXUOVYGXVFXVAXUTGJUHWYF
      VYGWYGXUNWXTVYGWXOVYCXBWIVAZXVNVYCXUSYENUYTWSXUOVVHXVIXUPXUTJXVHXVKAVYCVU
      ANXUOVYCXTDXUQGJXUOVYCXWHYDVYCYGMVUBWYAGXUPXUQWYAGVYCTXEVUCMYLWYFWYLWYGWY
      FWYBWYFWXTVVIVWQWYBYFDXVBXUJXWFVYCBVUDVUEVUFOWYJWYKWYLVNWYCQDWYCGHZWYHWYA
      WYBVUGWYAWYBVUHWXPXWIUCWYCQVYKWYCGVTYTXSWOWYFXUEEZWYCIWXQXWJWYCWYAGLFIXWJ
      WYBGWYALWYFWYBGJZXUEWYFXUEVYCVXBRSZWKZVYCVXBVSFZGJZXWKWYFWYGXWLWYFWYMVVIW
      YGXWLUHWYPXUJVYCBWRNYRWYFWXTVXSXWOXWMUHXVBXWGVYCVXBVUPNWYFXWNWYBGWYFWXTWX
      LXWNWYBJXVBWYFVVIWXLXUJWXMMBVYCYMNVMVUIVUJVUKXWJWYAWYFWYJXUEWYQOVUQXLIWXQ
      DZIQDVWDWAUNWXPVWDUCIQVYKIGVTYTVULZVUMVUNXWPWXOWXTWKEXWQUPVUOOVURVYCWXQDZ
      UEVQZWXQDZEZVYCXWSVPFZWXQDZWXOXXAXXBQDZXXBGHZEZXXCXWRVYJVYCGHZEZXWSQDZXWS
      GHZEZXXFXWTWXPXXGUCVYCQVYKVYCGVTYTWXPXXJUCXWSQVYKXWSGVTYTXXHXXKEXXDXXEVYJ
      XXIXXDXXGXXJVYCXWSWHVUSVYCXWSVUTVVAVVBWXPXXEUCXXBQVYKXXBGVTYTYQWIWJWXRVXJ
      QDVXMWXPVXMUCVXJQVYKVXJGVTYTVVCMVVDVVEVVFVVGYL $.

    $( The Legendre symbol is nonzero (and hence equal to ` 1 ` or ` -u 1 ` )
       precisely when the arguments are coprime.  (Contributed by Mario
       Carneiro, 5-Feb-2015.) $)
    lgsabs1 $p |- ( ( A e. ZZ /\ N e. ZZ ) ->
      ( ( abs ` ( A /L N ) ) = 1 <-> ( A gcd N ) = 1 ) ) $=
      ( cz wcel wa clgs co cabs cfv c1 wceq cle wbr cgcd cr lgscl cc0 wne syl
      wb abscld 1re letri3 sylancl lgsle1 biantrurd cn nnne0 cn0 nn0abscl elnn0
      zcnd wo sylib ord necon1ad impbid2 elnnnn0c baib cc abs00 necon3bid bitrd
      lgsne0 3bitr3d 3bitr2d ) ACDBCDEZABFGZHIZJKZVIJLMZJVILMZEZVLABNGJKZVGVIOD
      JODVJVMTVGVHVGVHABPZULZUAUBVIJUCUDVGVKVLABUEUFVGVIUGDZVIQRZVLVNVGVQVRVIUH
      VGVQVIQVGVQVIQKZVGVIUIDZVQVSUMVGVHCDVTVOVHUJSZVIUKUNUOUPUQVGVTVQVLTWAVQVT
      VLVIURUSSVGVRVHQRZVNVGVHUTDZVRWBTVPWCVIQVHQVHVAVBSABVDVCVEVF $.

    $( The Legendre symbol at a square is equal to ` 1 ` .  Together with
       ~ lgsmod this implies that the Legendre symbol takes value ` 1 ` at
       every quadratic residue.  (Contributed by Mario Carneiro,
       5-Feb-2015.) $)
    lgssq $p |- ( ( A e. NN /\ N e. ZZ /\ ( A gcd N ) = 1 ) ->
                  ( ( A ^ 2 ) /L N ) = 1 ) $=
      ( cn wcel cz cgcd co c1 wceq w3a cmul clgs c2 cc0 wne nnz 3ad2ant1 sqvald
      cexp oveq1d simp2 nnne0 lgsdir syl32anc cc nncn cabs cfv cr lgscl syl2anc
      zred absresq syl lgsabs1 sylan biimp3ar sq1 syl6eq zcnd 3eqtr3d 3eqtr4d
      wb ) ACDZBEDZABFGHIZJZAAKGZBLGZABLGZVJKGZAMSGZBLGHVGAEDZVMVEANOZVNVIVKIVD
      VEVMVFAPZQZVPVDVEVFUAZVDVEVNVFAUBQZVRAABUCUDVGVLVHBLVGAVDVEAUEDVFAUFQRTVG
      VJUGUHZMSGZVJMSGZHVKVGVJUIDVTWAIVGVJVGVMVEVJEDVPVQABUJUKZULVJUMUNVGVTHMSG
      HVGVSHMSVDVEVSHIZVFVDVMVEWCVFVCVOABUOUPUQTURUSVGVJVGVJWBUTRVAVB $.

    $( The Legendre symbol at a square is equal to ` 1 ` .  (Contributed by
       Mario Carneiro, 5-Feb-2015.) $)
    lgssq2 $p |- ( ( A e. ZZ /\ N e. NN /\ ( A gcd N ) = 1 ) ->
                   ( A /L ( N ^ 2 ) ) = 1 ) $=
      ( cz wcel cn cgcd co c1 wceq w3a cmul clgs c2 cexp cc0 wne simp1 3ad2ant2
      nnz sqvald nnne0 lgsdi syl32anc cc nncn oveq2d cabs cr lgscl syl2anc zred
      cfv absresq syl wb lgsabs1 sylan2 biimp3ar oveq1d sq1 syl6eq zcnd 3eqtr3d
      3eqtr4d ) ACDZBEDZABFGHIZJZABBKGZLGZABLGZVKKGZABMNGZLGHVHVEBCDZVNBOPZVOVJ
      VLIVEVFVGQZVFVEVNVGBSZRZVRVFVEVOVGBUARZVSABBUBUCVHVMVIALVHBVFVEBUDDVGBUER
      TUFVHVKUGULZMNGZVKMNGZHVLVHVKUHDWAWBIVHVKVHVEVNVKCDVPVRABUIUJZUKVKUMUNVHW
      AHMNGHVHVTHMNVEVFVTHIZVGVFVEVNWDVGUOVQABUPUQURUSUTVAVHVKVHVKWCVBTVCVD $.
  $}

  $( The Legendre symbol at ` 1 ` .  (Contributed by Mario Carneiro,
     28-Apr-2016.) $)
  1lgs $p |- ( N e. ZZ -> ( 1 /L N ) = 1 ) $=
    ( cz wcel c1 clgs co c2 cexp sq1 oveq1i cgcd wceq cn 1nn lgssq mp3an1 mpdan
    1gcd syl5eqr ) ABCZDAEFDGHFZAEFZDUADAEIJTDAKFDLZUBDLZARDMCTUCUDNDAOPQS $.

  $( The Legendre symbol at ` 1 ` .  (Contributed by Mario Carneiro,
     28-Apr-2016.) $)
  lgs1 $p |- ( A e. ZZ -> ( A /L 1 ) = 1 ) $=
    ( cz wcel c1 clgs co c2 cexp sq1 oveq2i cgcd wceq gcd1 cn 1nn lgssq2 mp3an2
    mpdan syl5eqr ) ABCZADEFADGHFZEFZDUADAEIJTADKFDLZUBDLZAMTDNCUCUDOADPQRS $.

  ${
    $d x A $.  $d x B $.  $d x M $.  $d x N $.
    $( Variation on ~ lgsdir valid for all ` A , B ` but only for positive
       ` N ` .  (The exact location of the failure of this law is for
       ` A = 0 ` , ` B < 0 ` , ` N = -u 1 ` in which case ` ( 0 /L -u 1 ) = 1 `
       but ` ( B /L -u 1 ) = -u 1 ` .)  (Contributed by Mario Carneiro,
       28-Apr-2016.) $)
    lgsdirnn0 $p |- ( ( A e. ZZ /\ B e. ZZ /\ N e. NN0 ) ->
      ( ( A x. B ) /L N ) = ( ( A /L N ) x. ( B /L N ) ) ) $=
      ( vx cz wcel cmul co clgs wceq cc0 wa cc lgscl zcnd adantr sylancr oveq1d
      c1 0z cn0 w3a cv wral simp2 nn0z syl2anr mul01d simpr oveq2d 3eqtr4rd wne
      id cgcd lgsne0 gcdcom nn0gcdid0 eqtrd eqeq1d lgs1 adantl oveq2 syl5ibrcom
      wb sylbid imp ad2antrr mulid2d eqtr2d pm2.61dane ralrimiva 3ad2ant3 oveq1
      eqeq2d rspcv syl2anc mulcomd eqtr4d zcn 3ad2ant2 mul02d sylan9eqr 3eqtr4d
      sylc simp1 lgsdir syl3anl3 pm2.61da2ne ) AEFZBEFZCUAFZUBZABGHZCIHZACIHZBC
      IHZGHZJZAKBKWLAKJZLZKCIHZXAWPGHZWNWQWTXAWPXAGHZXBWLXAXCJZWSWLWJXADUCZCIHZ
      XAGHZJZDEUDZXDWIWJWKUEZWKWIXIWJWKXHDEWKXEEFZLZXHXAKXLXAKJZLZXFKGHKXGXAXNX
      FXLXFMFXMXLXFXKXKCEFZXFEFWKXKUMCUFZXECNUGOPUHXNXAKXFGXLXMUIZUJXQUKXLXAKUL
      ZLZXGSXAGHXAXSXFSXAGXLXRXFSJZXLXRKCUNHZSJZXTXLKEFZXOXRYBVDTWKXOXKXPPZKCUO
      QXLYBCSJZXTXLYACSXLYACKUNHZCXLYCXOYAYFJTYDKCUPQWKYFCJXKCUQPURUSXLXTYEXESI
      HZSJZXKYHWKXEUTVAYEXFYGSCSXEIVBUSVCVEVEVFRXSXAXSXAXSYCXOXAEFZTWKXOXKXRXPV
      GKCNZQOVHVIVJVKVLZXHXDDBEXEBJZXGXCXAYLXFWPXAGXEBCIVMRVNVOWDPWTXAWPWLXAMFW
      SWLXAWLYCXOYITWKWIXOWJXPVLZYJQOPWLWPMFWSWLWPWLWJXOWPEFXJYMBCNVPOPVQVRWTWM
      KCIWSWLWMKBGHKAKBGVMWLBWJWIBMFWKBVSVTWAWBRWTWOXAWPGWTAKCIWLWSUIRRWCWLBKJZ
      LZXAWOXAGHZWNWQWLXAYPJZYNWLWIXIYQWIWJWKWEZYKXHYQDAEXEAJZXGYPXAYSXFWOXAGXE
      ACIVMRVNVOWDPYOWMKCIYNWLWMAKGHKBKAGVBWLAWLAYROUHWBRYOWPXAWOGYOBKCIWLYNUIR
      UJWCWKWIWJXOAKULBKULLWRXPABCWFWGWH $.

    $( Variation on ~ lgsdi valid for all ` M , N ` but only for positive
       ` A ` .  (The exact location of the failure of this law is for
       ` A = -u 1 ` , ` M = 0 ` , and some ` N ` in which case
       ` ( -u 1 /L 0 ) = 1 ` but ` ( -u 1 /L N ) = -u 1 ` when ` -u 1 ` is not
       a quadratic residue mod ` N ` .)  (Contributed by Mario Carneiro,
       28-Apr-2016.) $)
    lgsdinn0 $p |- ( ( A e. NN0 /\ M e. ZZ /\ N e. ZZ ) ->
      ( A /L ( M x. N ) ) = ( ( A /L M ) x. ( A /L N ) ) ) $=
      ( vx wcel cz cmul co clgs wceq cc0 wa adantr oveq1d lgscl zcnd wne oveq2d
      c1 cc cn0 w3a cv wral simp3 c2 cexp sq1 eqeq2i wb cr cle wbr nn0re nn0ge0
      1re 0le1 sq11 mpanr12 syl2anc syl5bbr biimpa 1lgs ad2antlr eqtrd ad2antrr
      nn0z sylancl mulid2d eqtr2d sylan mul01d lgs0 ifnefalse sylan9eq 3eqtr4rd
      0z cif syl pm2.61dane ralrimiva 3ad2ant1 oveq2 eqeq2d sylc mulcomd eqtr4d
      rspcv oveq1 mul02d sylan9eqr simpr 3eqtr4d simp2 syl3anl1 pm2.61da2ne
      lgsdi ) AUAEZBFEZCFEZUBZABCGHZIHZABIHZACIHZGHZJZBKCKXABKJZLZAKIHZXJXEGHZX
      CXFXIXJXEXJGHZXKXAXJXLJZXHXAWTXJADUCZIHZXJGHZJZDFUDZXMWRWSWTUEZWRWSXRWTWR
      XQDFWRXNFEZLZXQAUFUGHZSYAYBSJZLZXPSXJGHXJYDXOSXJGYDXOSXNIHZSYDASXNIYAYCAS
      JZYCYBSUFUGHZJZYAYFYGSYBUHUIWRYHYFUJZXTWRAUKEZKAULUMZYIAUNAUOYJYKLSUKEKSU
      LUMYIUPUQASURUSUTMVAVBNXTYESJWRYCXNVCVDVENYDXJYDXJYDAFEZKFEZXJFEZWRYLXTYC
      AVGZVFVQAKOZVHPVIVJYAYBSQZLZXOKGHKXPXJYRXOYAXOTEYQYAXOWRYLXTXOFEYOAXNOVKP
      MVLYRXJKXOGYAYQXJYCSKVRZKYAYLXJYSJWRYLXTYOMAVMVSYBSSKVNVOZRYTVPVTWAWBZXQX
      MDCFXNCJZXPXLXJUUBXOXEXJGXNCAIWCNWDWHWEMXIXJXEXAXJTEXHXAXJXAYLYMYNWRWSYLW
      TYOWBZVQYPVHPMXAXETEXHXAXEXAYLWTXEFEUUCXSACOUTPMWFWGXIXBKAIXHXAXBKCGHKBKC
      GWIXACXACXSPWJWKRXIXDXJXEGXIBKAIXAXHWLRNWMXACKJZLZXJXDXJGHZXCXFXAXJUUFJZU
      UDXAWSXRUUGWRWSWTWNZUUAXQUUGDBFXNBJZXPUUFXJUUIXOXDXJGXNBAIWCNWDWHWEMUUEXB
      KAIUUDXAXBBKGHKCKBGWCXABXABUUHPVLWKRUUEXEXJXDGUUECKAIXAUUDWLRRWMWRYLWSWTB
      KQCKQLXGYOABCWQWOWP $.
  $}

  ${
    $d x A $.  $d x z G $.  $d y O $.  $d x y z P $.  $d x y z ph $.  $d y T $.
    $d x y L $.  $d x y Y $.
    lgsqr.y $e |- Y = ( Z/nZ ` P ) $.
    lgsqr.s $e |- S = ( Poly1 ` Y ) $.
    lgsqr.b $e |- B = ( Base ` S ) $.
    lgsqr.d $e |- D = ( deg1 ` Y ) $.
    lgsqr.o $e |- O = ( eval1 ` Y ) $.
    lgsqr.e $e |- .^ = ( .g ` ( mulGrp ` S ) ) $.
    lgsqr.x $e |- X = ( var1 ` Y ) $.
    lgsqr.m $e |- .- = ( -g ` S ) $.
    lgsqr.u $e |- .1. = ( 1r ` S ) $.
    lgsqr.t $e |- T = ( ( ( ( P - 1 ) / 2 ) .^ X ) .- .1. ) $.
    lgsqr.l $e |- L = ( ZRHom ` Y ) $.
    lgsqr.1 $e |- ( ph -> P e. ( Prime \ { 2 } ) ) $.
    ${
      lgsqrlem1.3 $e |- ( ph -> A e. ZZ ) $.
      lgsqrlem1.4 $e |- ( ph ->
        ( ( A ^ ( ( P - 1 ) / 2 ) ) mod P ) = ( 1 mod P ) ) $.
      $( Lemma for ~ lgsqr .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
      lgsqrlem1 $p |- ( ph -> ( ( O ` T ) ` ( L ` A ) ) = ( 0g ` Y ) ) $=
        ( cfv cur csg co c0g c1 cmin c2 cdiv fveq2i fveq1i wcel wceq eqid cidom
        cbs cfield cprime csn eldifad znfld syl fldidom cdomn isidom simplbi cz
        ccrg ccnfld cress crh wf crg crngrng zrhrhm csubrg zsubrg subrgbas rhmf
        ax-mp ffvelrnd cmgp cmg wa evl1vard cdif cn oddprm nnnn0d evl1expd cmhm
        cn0 cnrng mgpress mp2an rhmmhm mgpbas mhmmulg syl3anc csubmnd subrgsubm
        cexp mp1i submmulg zcnd cnfldexp syl2anc eqtr3d fveq2d cdivides wbr cmo
        cc wb prmnn zexpcl a1i moddvds mpbid zndvds mpbird cnfld1 subrg1 3eqtrd
        1z rhm1 eqeq2d anbi2d cascl rngidcl evl1scad ply1scl1 evl1subd grpsubid
        eleq1d fveq1d eqeq1d anbi12d simprd syl5eq cgrp rnggrp eqtrd ) ABJUIZGL
        UIZUIZNUJUIZUUONUKUIZULZNUMUIZAUUNUULEUNUOULUPUQULZMIULZHKULZLUIZUIZUUQ
        UULUUMUVBGUVALUDURUSAUVACUTUVCUUQVAANVDUIZUUPFNCUUTKHLUUOUUOUULSPUVDVBZ
        QANVCUTZNVPUTZANVEUTZUVFAEVFUTZUVHAEVFUPVGZUFVHZENOVIVJNVKVJUVFUVGNVLUT
        NVMVNVJZAVOUVDBJAJVQVOVRULZNVSULUTZVOUVDJVTANWAUTZUVNAUVGUVOUVLNWBVJZNJ
        UVMUVMVBZUEWCVJZVOUVDUVMNJVOVQWDUIZUTZVOUVMVDUIVAWEVOVQUVMUVQWFWHZUVEWG
        VJUGWIZAUUTCUTZUULUUTLUIUIZUUSUULNWJUIZWKUIZULZVAZWLUWCUWDUUOVAZWLAUVDF
        NICUWFMUUSLUULUULSPUVEQUVLUWBAUVDFNCLMUULSUAUVEPQUVLUWBWMTUWFVBZAUUSAEV
        FUVJWNUTUUSWOUTUFEWPVJWQZWRAUWHUWIUWCAUWGUUOUWDAUUSBVQWJUIZVOVRULZWKUIZ
        ULZJUIZUWGUUOAJUWMUWEWSULUTZUUSWTUTZBVOUTZUWPUWGVAAUVNUWQUVRUVMNJUWMUWE
        VQWAUTUVTUWMUVMWJUIVAXAWEVOVQUVMUWLWAUVSUVQUWLVBZXBXCZUWEVBXDVJUWKUGVOU
        WNUWFJUWMUWEUUSBVOUVMUWMUXAUWAXEUWNVBZUWJXFXGAUWPBUUSXJULZJUIZUNJUIZUUO
        AUWOUXCJAUUSBUWLWKUIZULZUWOUXCAVOUWLXHUIUTZUWRUWSUXGUWOVAUVTUXHAWEVOVQU
        WLUWTXIXKUWKUGVOUXFUWNUWLUWMUUSBUXFVBUWMVBUXBXLXGABYAUTUWRUXGUXCVAABUGX
        MUWKBUUSXNXOXPXQAUXDUXEVAZEUXCUNUOULXRXSZAUXCEXTULUNEXTULVAZUXJUHAEWOUT
        ZUXCVOUTZUNVOUTZUXKUXJYBAUVIUXLUVKEYCVJZAUWSUWRUXMUGUWKBUUSYDXOZUXNAYMY
        EZUXCUNEYFXGYGAEWTUTUXMUXNUXIUXJYBAEUXOWQUXPUXQUXCUNJENOUEYHXGYIAUVNUXE
        UUOVAUVRUVMNUNJUUOUVTUNUVMUJUIVAWEVOVQUVMUNUVQYJYKWHUUOVBZYNVJYLXPYOYPY
        GAUUOFYQUIZUIZCUTZUULUXTLUIZUIZUUOVAZWLHCUTZUULHLUIZUIZUUOVAZWLAUXSUVDF
        NCLUUOUULSPUVEUXSVBZQUVLAUVOUUOUVDUTZUVPUVDNUUOUVEUXRYRVJZUWBYSAUYAUYEU
        YDUYHAUXTHCAUVOUXTHVAUVPUXSFNUUOHPUYIUXRUCYTVJZUUCAUYCUYGUUOAUULUYBUYFA
        UXTHLUYLXQUUDUUEUUFYGUBUUPVBZUUAUUGUUHANUUIUTZUYJUUQUURVAAUVOUYNUVPNUUJ
        VJUYKUVDNUUPUUOUURUVEUURVBUYMUUBXOUUK $.
    $}

    lgsqr.g $e |- G = ( y e. ( 1 ... ( ( P - 1 ) / 2 ) ) |->
      ( L ` ( y ^ 2 ) ) ) $.
    $( Lemma for ~ lgsqr .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    lgsqrlem2 $p |- ( ph -> G : ( 1 ... ( ( P - 1 ) / 2 ) )
         -1-1-> ( `' ( O ` T ) " { ( 0g ` Y ) } ) ) $=
      ( vx vz c1 cmin co c2 cdiv cfz cfv ccnv c0g csn cima wf wceq weq wral wf1
      cv wi cexp wcel wa cbs cz ccnfld cress crh crg ccrg cfield cprime eldifad
      cidom znfld fldidom cdomn isidom simplbi crngrng eqid rhmf adantr elfzelz
      syl adantl zsqcl ffvelrnd cmo cmul cn elfznn nncnd cn0 nnnn0d cr nnred cc
      a1i cc0 cgcd nnzd syl2anc cdivides wbr wn cle clt elfzle2 crp nnrpd ltm1d
      lelttrd ltnled mpbid dvdsle wb eqtrd syl3anc cvv caddc oveq1 fveq2d fvmpt
      fvex ad2antrl ad2antll eqeq12d nn0ge0d modid syl22anc sylbid zrhrhm ax-mp
      csubrg zsubrg subrgbas cdif cphi oddprm expmuld prmnn peano2rem recnd 2cn
      2nn0 wne divcan2d phiprm eqtr4d oveq2d eqtr3d oveq1d gcdcom rehalfcld cuz
      2ne0 uz2m1nn rphalflt lttrd mtod coprm eulerth lgsqrlem1 wfn cpws evl1rhm
      prmuz2 cgrp ply1rng rnggrp cmgp cmnd rngmgp vr1cl mgpbas rngidcl grpsubcl
      mulgnn0cl syl5eqel pwselbas fniniseg mpbir2and fmptd zndvds breq2d 3bitrd
      ffn wo zaddcld zsubcld euclemma nnaddcld le2addd 2halvesd breqtrd pm2.21d
      subsq syld moddvds bitr3d biimpd jaod ralrimivva dff13 sylanbrc ) AUKEUKU
      LUMZUNUOUMZUPUMZGMUQZUROUSUQZUTVAZJVBUIVGZJUQZUJVGZJUQZVCZUIUJVDZVHZUJUXQ
      VEUIUXQVEUXQUXTJVFABUXQBVGZUNVIUMZKUQZUXTJAUYHUXQVJZVKZUYJUXTVJZUYJOVLUQZ
      VJZUYJUXRUQUXSVCZUYLVMUYNUYIKAVMUYNKVBZUYKAKVNVMVOUMZOVPUMVJZUYQAOVQVJZUY
      SAOVRVJZUYTAOWBVJZVUAAOVSVJZVUBAEVTVJZVUCAEVTUNUTZUGWAZEOPWCWMZOWDWMVUBVU
      AOWEVJOWFWGWMZOWHWMZOKUYRUYRWIZUFUUAWMVMUYNUYROKVMVNUUCUQVJVMUYRVLUQVCUUD
      VMVNUYRVUJUUEUUBUYNWIZWJWMWKUYLUYHVMVJZUYIVMVJUYKVULAUYHUKUXPWLWNZUYHWOWM
      ZWPUYLUYICDEFGHIKLMNOPQRSTUAUBUCUDUEUFAEVTVUEUUFVJZUYKUGWKVUNUYLUYIUXPVIU
      MZEWQUMUYHEUUGUQZVIUMZEWQUMZUKEWQUMZUYLVUPVUREWQUYLUYHUNUXPWRUMZVIUMVUPVU
      RUYLUYHUNUXPUYLUYHUYKUYHWSVJZAUYHUXPWTWNZXAAUXPXBVJZUYKAUXPAVUOUXPWSVJUGE
      UUHWMXCZWKUNXBVJUYLUUNXGUUIUYLVVAVUQUYHVIAVVAVUQVCUYKAVVAUXOVUQAUXOUNAUXO
      AEXDVJZUXOXDVJZAEAVUDEWSVJZVUFEUUJZWMZXEZEUUKZWMZUULZUNXFVJAUUMXGUNXHUUOA
      UVEXGUUPAVUDVUQUXOVCVUFEUUQWMUURWKUUSUUTUVAUYLVVHVULUYHEXIUMZUKVCVUSVUTVC
      UYLVUDVVHAVUDUYKVUFWKZVVIWMVUMUYLVVOEUYHXIUMZUKUYLVULEVMVJZVVOVVQVCVUMAVV
      RUYKAEVVJXJWKZUYHEUVBXKUYLEUYHXLXMZXNZVVQUKVCZUYLVVTEUYHXOXMZUYLUYHEXPXMV
      WCXNUYLUYHUXPEUYLUYHVVCXEZAUXPXDVJZUYKAUXOVVMUVCZWKAVVFUYKVVKWKZUYKUYHUXP
      XOXMAUYHUKUXPXQWNAUXPEXPXMZUYKAUXPUXOEVWFVVMVVKAUXOXRVJUXPUXOXPXMAUXOAEUN
      UVDUQVJZUXOWSVJAVUDVWIVUFEUVPWMEUVFWMXSUXOUVGWMAEVVKXTUVHZWKYAUYLUYHEVWDV
      WGYBYCUYLVVRVVBVVTVWCVHVVSVVCEUYHYDXKUVIUYLVUDVULVWAVWBYEVVPVUMEUYHUVJXKY
      CYFUYHEUVKYGYFUVLUYLUXRUYNUVMZUYMUYOUYPVKYEAVWKUYKAUYNUYNUXRVBVWKAUYNOUYN
      OUYNUVNUMZVLUQZVSUXRVWLYHVWLWIZVUKVWMWIZVUGUYNYHVJAOVLYMXGACVWMGMAMFVWLVP
      UMVJZCVWMMVBAVUAVWPVUHUYNFOVWLMTQVWNVUKUVOWMCVWMFVWLMRVWOWJWMAGUXPNIUMZHL
      UMZCUEAFUVQVJZVWQCVJZHCVJZVWRCVJAFVQVJZVWSAUYTVXBVUIFOQUVRWMZFUVSWMAFUVTU
      QZUWAVJZVVDNCVJZVWTAVXBVXEVXCFVXDVXDWIZUWBWMVVEAUYTVXFVUICFONUBQRUWCWMCIV
      XDUXPNCFVXDVXGRUWDUAUWGYGAVXBVXAVXCCFHRUDUWEWMCFLVWQHRUCUWFYGUWHWPUWIUYNU
      YNUXRUWPWMWKUYNUXSUYJUXRUWJWMUWKUHUWLAUYGUIUJUXQUXQAUYAUXQVJZUYCUXQVJZVKZ
      VKZUYEEUYAUYCYIUMZUYAUYCULUMZWRUMZXLXMZUYFVXKUYEUYAUNVIUMZKUQZUYCUNVIUMZK
      UQZVCZEVXPVXRULUMZXLXMZVXOVXKUYBVXQUYDVXSVXHUYBVXQVCAVXIBUYAUYJVXQUXQJBUI
      VDUYIVXPKUYHUYAUNVIYJYKUHVXPKYMYLYNVXIUYDVXSVCAVXHBUYCUYJVXSUXQJBUJVDUYIV
      XRKUYHUYCUNVIYJYKUHVXRKYMYLYOYPVXKEXBVJZVXPVMVJZVXRVMVJZVXTVYBYEAVYCVXJAE
      VVJXCWKVXKUYAVMVJZVYDVXHVYFAVXIUYAUKUXPWLYNZUYAWOWMVXKUYCVMVJZVYEVXIVYHAV
      XHUYCUKUXPWLYOZUYCWOWMVXPVXRKEOPUFUWMYGVXKVYAVXNEXLVXKUYAXFVJUYCXFVJVYAVX
      NVCVXKUYAVXHUYAWSVJAVXIUYAUXPWTYNZXAVXKUYCVXIUYCWSVJAVXHUYCUXPWTYOZXAUYAU
      YCUXFXKUWNUWOVXKVXOEVXLXLXMZEVXMXLXMZUWQZUYFVXKVUDVXLVMVJVXMVMVJVXOVYNYEA
      VUDVXJVUFWKZVXKUYAUYCVYGVYIUWRVXKUYAUYCVYGVYIUWSEVXLVXMUWTYGVXKVYLUYFVYMV
      XKVYLEVXLXOXMZUYFVXKVVRVXLWSVJVYLVYPVHVXKEVXKVUDVVHVYOVVIWMZXJVXKUYAUYCVY
      JVYKUXAZEVXLYDXKVXKVYPUYFVXKVXLEXPXMVYPXNVXKVXLUXOEVXKVXLVYRXEZVXKVVFVVGV
      XKEVYQXEZVVLWMVYTVXKVXLUXPUXPYIUMUXOXOVXKUYAUYCUXPUXPVXKUYAVYJXEZVXKUYCVY
      KXEZAVWEVXJVWFWKZWUCVXHUYAUXPXOXMAVXIUYAUKUXPXQYNZVXIUYCUXPXOXMAVXHUYCUKU
      XPXQYOZUXBVXKUXOAUXOXFVJVXJVVNWKUXCUXDVXKEVYTXTYAVXKVXLEVYSVYTYBYCUXEUXGV
      XKVYMUYFVXKUYAEWQUMZUYCEWQUMZVCZVYMUYFVXKVVHVYFVYHWUHVYMYEVYQVYGVYIUYAUYC
      EUXHYGVXKWUFUYAWUGUYCVXKUYAXDVJEXRVJZXHUYAXOXMUYAEXPXMWUFUYAVCWUAVXKEVYQX
      SZVXKUYAVXKUYAVYJXCYQVXKUYAUXPEWUAWUCVYTWUDAVWHVXJVWJWKZYAUYAEYRYSVXKUYCX
      DVJWUIXHUYCXOXMUYCEXPXMWUGUYCVCWUBWUJVXKUYCVXKUYCVYKXCYQVXKUYCUXPEWUBWUCV
      YTWUEWUKYAUYCEYRYSYPUXIUXJUXKYTYTUXLUIUJUXQUXTJUXMUXN $.

    lgsqr.3 $e |- ( ph -> A e. ZZ ) $.
    lgsqr.4 $e |- ( ph -> ( A /L P ) = 1 ) $.
    $( Lemma for ~ lgsqr .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    lgsqrlem3 $p |- ( ph -> ( L ` A ) e. ( `' ( O ` T ) " { ( 0g ` Y ) } ) ) $=
      ( cfv ccnv c0g csn cima wcel cbs wceq cz ccnfld cress co crh wf crg cidom
      ccrg cfield cprime eldifad znfld syl fldidom cdomn isidom simplbi crngrng
      eqid zrhrhm csubrg zsubrg subrgbas ax-mp rhmf ffvelrnd clgs cmo cmin cdiv
      c2 c1 cexp cdif lgsvalmod syl2anc oveq1d eqtr3d lgsqrlem1 wfn wa cpws cvv
      wb fvex a1i evl1rhm cgrp ply1rng rnggrp cmgp cmnd rngmgp cn oddprm nnnn0d
      cn0 vr1cl mgpbas mulgnn0cl syl3anc rngidcl grpsubcl syl5eqel pwselbas ffn
      fniniseg mpbir2and ) ACLULZHNULZUMPUNULZUOUPUQZYIPURULZUQZYIYJULYKUSZAUTY
      MCLALVAUTVBVCZPVDVCUQZUTYMLVEAPVFUQZYQAPVHUQZYRAPVGUQZYSAPVIUQZYTAFVJUQUU
      AAFVJWKUOZUHVKFPQVLVMZPVNVMYTYSPVOUQPVPVQVMZPVRVMZPLYPYPVSZUGVTVMUTYMYPPL
      UTVAWAULUQUTYPURULUSWBUTVAYPUUFWCWDYMVSZWEVMUJWFACDEFGHIJLMNOPQRSTUAUBUCU
      DUEUFUGUHUJACFWGVCZFWHVCZCFWLWIVCWKWJVCZWMVCFWHVCZWLFWHVCACUTUQFVJUUBWNUQ
      ZUUIUUKUSUJUHCFWOWPAUUHWLFWHUKWQWRWSAYJYMWTZYLYNYOXAXDAYMYMYJVEUUMAYMPYMP
      YMXBVCZURULZVIYJUUNXCUUNVSZUUGUUOVSZUUCYMXCUQAPURXEXFADUUOHNANGUUNVDVCUQZ
      DUUONVEAYSUURUUDYMGPUUNNUARUUPUUGXGVMDUUOGUUNNSUUQWEVMAHUUJOJVCZIMVCZDUFA
      GXHUQZUUSDUQZIDUQZUUTDUQAGVFUQZUVAAYRUVDUUEGPRXIVMZGXJVMAGXKULZXLUQZUUJXQ
      UQODUQZUVBAUVDUVGUVEGUVFUVFVSZXMVMAUUJAUULUUJXNUQUHFXOVMXPAYRUVHUUEDGPOUC
      RSXRVMDJUVFUUJODGUVFUVISXSUBXTYAAUVDUVCUVEDGISUEYBVMDGMUUSISUDYCYAYDWFYEY
      MYMYJYFVMYMYKYIYJYGVMYH $.

    $( Lemma for ~ lgsqr .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    lgsqrlem4 $p |- ( ph -> E. x e. ZZ P || ( ( x ^ 2 ) - A ) ) $=
      ( cfv ccnv cz wcel c2 cexp co cmin cdivides wbr cv wrex cdiv cfz c0g cima
      c1 csn wf1o wf wf1 lgsqrlem2 cen cfn wb cdom cvv cnvex imaexg ax-mp f1dom
      fvex syl chash cle eqid cfield cidom cprime eldifad fldidom cgrp crg ccrg
      znfld cdomn isidom simplbi crngrng ply1rng rnggrp cmgp cmnd cn0 rngmgp cn
      cdif oddprm nnnn0d mgpbas mulgnn0cl syl3anc rngidcl grpsubcl syl5eqel wne
      vr1cl fveq2i cc0 clt nngt0d cur cascl ply1scl1 fveq2d cbs simprbi domnnzr
      wceq cnzr nzrnz deg1scl eqtr3d deg1pw syl2anc mpbid oveq1 cmpt deg1nn0clb
      3brtr4d deg1sub syl5eq eqtrd eqeltrd mpbird fta1g breqtrd hashfz1 hashbnd
      breqtrrd a1i hashdom sbth f1finf1o f1ocnv f1of lgsqrlem3 ffvelrnd elfzelz
      fzfid 3syl cbvmptv eqtri fvmpt f1ocnvfv2 prmnn zsqcl zndvds oveq1d breq2d
      rspcev ) ADMUMZLUNZUMZUOUPZGUVPUQURUSZDUTUSZVAVBZGBVCZUQURUSZDUTUSZVAVBZB
      UOVDAUVPVIGVIUTUSUQVEUSZVFUSZUPZUVQAIOUMZUNZQVGUMZVJZVHZUWFUVNUVOAUWFUWLL
      VKZUWLUWFUVOVKUWLUWFUVOVLAUWFUWLLVMZUWMACEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUH
      UIUJVNZAUWFUWLVOVBZUWLVPUPZUWNUWMVQAUWFUWLVRVBZUWLUWFVRVBZUWPAUWNUWRUWOUW
      FUWLLUWIVSUPUWLVSUPZUWHIOWDVTUWIUWKVSWAWBZWCWEAUWLWFUMZUWFWFUMZWGVBZUWSAU
      XBUWEUXCWGAUXBIFUMZUWEWGAEFHQIOUWJHVGUMZSTUAUBUWJWHZUXFWHZAQWIUPZQWJUPZAG
      WKUPZUXIAGWKUQVJZUIWLZGQRWQWEQWMWEZAIUWEPKUSZJNUSZEUGAHWNUPZUXOEUPZJEUPZU
      XPEUPAHWOUPZUXQAQWOUPZUXTAQWPUPZUYAAUXJUYBUXNUXJUYBQWRUPZQWSZWTWEQXAWEZHQ
      SXBWEZHXCWEAHXDUMZXEUPZUWEXFUPZPEUPZUXRAUXTUYHUYFHUYGUYGWHZXGWEAUWEAGWKUX
      LXIUPUWEXHUPUIGXJWEZXKZAUYAUYJUYEEHQPUDSTXSWEEKUYGUWEPEHUYGUYKTXLUCXMXNZA
      UXTUXSUYFEHJTUFXOWEZEHNUXOJTUEXPXNXQZAIUXFXRZUXEXFUPZAUXEUWEXFAUXEUXOFUMZ
      UWEAUXEUXPFUMUYSIUXPFUGXTAEFQUXOJNHSUAUYETUEUYNUYOAYAUWEJFUMZUYSYBAUWEUYL
      YCAQYDUMZHYEUMZUMZFUMZUYTYAAVUCJFAUYAVUCJYKUYEVUBHQVUAJSVUBWHZVUAWHZUFYFW
      EYGAUYAVUAQYHUMZUPZVUAUWJXRZVUDYAYKUYEAUYAVUHUYEVUGQVUAVUGWHZVUFXOWEAQYLU
      PZVUIAUXJVUKUXNUXJUYCVUKUXJUYBUYCUYDYIQYJWEWEZQVUAUWJVUFUXGYMWEVUBFHQVUAV
      UGUWJUASVUJVUEUXGYNXNYOAVUKUYIUYSUWEYKVULUYMFHQKUWEUYGPUASUDUYKUCYPYQZUUB
      UUCUUDVUMUUEZUYMUUFAUYAIEUPUYQUYRVQUYEUYPEFHQIUXFUASUXHTUUAYQUUGUUHVUNUUI
      ZAUYIUXCUWEYKUYMUWEUUJWEUULAUWQUWFVPUPUXDUWSVQAUWTUYIUXBUWEWGVBUWQUWTAUXA
      UUMUYMVUOUWLUWEVSUUKXNZAVIUWEUVBUWLUWFVPUUNYQYRUWFUWLUUOYQVUPUWFUWLLUUPYQ
      YRZUWFUWLLUUQUWLUWFUVOUURUVCACDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUU
      SZUUTZUVPVIUWEUVAWEZAUVRMUMZUVNYKZUVTAUVPLUMZVVAUVNAUWGVVCVVAYKVUSBUVPUWB
      MUMZVVAUWFLUWAUVPYKZUWBUVRMUWAUVPUQURYSZYGLCUWFCVCZUQURUSZMUMZYTBUWFVVDYT
      UJCBUWFVVIVVDVVGUWAYKVVHUWBMVVGUWAUQURYSYGUVDUVEUVRMWDUVFWEAUWMUVNUWLUPVV
      CUVNYKVUQVURUWFUWLUVNLUVGYQYOAGXFUPUVRUOUPZDUOUPVVBUVTVQAGAUXKGXHUPUXMGUV
      HWEXKAUVQVVJVUTUVPUVIWEUKUVRDMGQRUHUVJXNYRUWDUVTBUVPUOVVEUWCUVSGVAVVEUWBU
      VRDUTVVFUVKUVLUVMYQ $.
  $}

  ${
    $d x y A $.  $d x y P $.
    $( Lemma for ~ lgsqr .  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    lgsqrlem5 $p |- ( ( A e. ZZ /\ P e. ( Prime \ { 2 } ) /\
        ( A /L P ) = 1 ) -> E. x e. ZZ P || ( ( x ^ 2 ) - A ) ) $=
      ( vy cz wcel cprime c2 csn cdif clgs co c1 wceq w3a czn cfv cpl1 cbs eqid
      cdg1 cmin cdiv cv1 cmgp cmg cur csg cfz cv cexp czrh cmpt ce1 simp2 simp1
      simp3 lgsqrlem4 ) BEFZCGHIJFZBCKLMNZOADBCPQZRQZSQZVBUAQZCVCCMUBLHUCLZVBUD
      QZVCUEQUFQZLVCUGQZVCUHQZLZVIVHDMVFUILDUJHUKLVBULQZQUMZVLVJVBUNQZVGVBVBTVC
      TVDTVETVNTVHTVGTVJTVITVKTVLTUSUTVAUOVMTUSUTVAUPUSUTVAUQUR $.
  $}

  ${
    $d x A $.  $d x P $.
    $( The Legendre symbol for odd primes is ` 1 ` iff the number is not a
       multiple of the prime (in which case it is ` 0 ` , see ~ lgsne0 ) and
       the number is a quadratic residue ` mod P ` (it is ` -u 1 ` for
       nonresidues by the process of elimination from ~ lgsabs1 ).  Given our
       definition of the Legendre symbol, this theorem is equivalent to Euler's
       criterion.  (Contributed by Mario Carneiro, 15-Jun-2015.) $)
    lgsqr $p |- ( ( A e. ZZ /\ P e. ( Prime \ { 2 } ) ) -> ( ( A /L P ) = 1 <->
      ( -. P || A /\ E. x e. ZZ P || ( ( x ^ 2 ) - A ) ) ) ) $=
      ( cz wcel cprime c2 wa clgs wceq cdivides wbr cc0 wne syl syl2anc syl3anc
      co c1 wb csn cdif wn cexp cmin wrex cgcd eldifi adantl prmz gcdcom eqeq1d
      simpl coprm lgsne0 3bitr4d necon4bbid necomi neeq1 mpbiri syl6bi necon2bd
      cv ax-1ne0 lgsqrlem5 3expia jcad cabs cfv cr simprl absresq oveq1d simplr
      zred cn ad3antlr zsqcl simplll simprr dvdssub2 syl31anc mtbird prmdvdsexp
      2nn a1i mtbid dvds0 breq2 syl5ibrcom necon3bd nnabscl nnzd dvdsabsb mpbid
      mpd eqtrd lgssq cmo prmnn moddvds mpbird eldifsni necomd cuz uzid dvdsprm
      2z necon3bbid sylancr lgsmod 3eqtr3d 3eqtr3rd rexlimdvaa expimpd impbid
      ax-mp ) BDEZCFGUAZUBEZHZBCIRZSJZCBKLZUCZCAVCZGUDRZBUERKLZADUFZHYAYCYEYIYA
      YDYBSYAYDYBMJZYBSNZYAYDYBMYACBUGRZSJZBCUGRZSJZYEYBMNZYAYLYNSYACDEZXRYLYNJ
      YACFEZYQXTYRXRCFXSUHZUIZCUJZOZXRXTUMZCBUKPULYAYRXRYEYMTYTUUCCBUNPYAXRYQYP
      YOTUUCUUBBCUOPUPUQYJYKMSNSMVDURYBMSUSUTVAVBXRXTYCYIABCVEVFVGYAYEYIYCYAYEH
      ZYHYCADUUDYFDEZYHHZHZYFVHVIZGUDRZCIRZYGCIRZSYBUUGUUIYGCIUUGYFVJEUUIYGJUUG
      YFUUDUUEYHVKZVOYFVLOVMUUGUUHVPEZYQUUHCUGRZSJUUJSJUUGUUEYFMNZUUMUULUUGCYFK
      LZUCUUOUUGCYGKLZUUPUUGUUQYDYAYEUUFVNUUGYQYGDEZXRYHUUQYDTUUGYRYQXTYRXRYEUU
      FYSVQZUUAOZUUGUUEUURUULYFVROZXRXTYEUUFVSZUUDUUEYHVTZCYGBWAWBWCUUGYRUUEGVP
      EZUUQUUPTUUSUULUVDUUGWEWFYFCGWDQWGZUUGUUPYFMUUGUUPYFMJCMKLZUUGYQUVFUUTCWH
      OYFMCKWIWJWKWPYFWLPZUUTUUGUUNCUUHUGRZSUUGUUHDEZYQUUNUVHJUUGUUHUVGWMZUUTUU
      HCUKPUUGCUUHKLZUCZUVHSJZUUGUUPUVKUVEUUGYQUUEUUPUVKTUUTUULCYFWNPWGUUGYRUVI
      UVLUVMTUUSUVJCUUHUNPWOWQUUHCWRQUUGYGCWSRZCIRZBCWSRZCIRZUUKYBUUGUVNUVPCIUU
      GUVNUVPJZYHUVCUUGCVPEZUURXRUVRYHTUUGYRUVSUUSCWTOZUVAUVBYGBCXAQXBVMUUGUURU
      VSGCKLZUCZUVOUUKJUVAUVTUUGUWBGCNZUUGCGXTCGNXRYEUUFCFGXCVQXDUUGGGXEVIEZYRU
      WBUWCTGDEUWDXHGXFXQUUSUWDYRHUWAGCCGXGXIXJXBZYGCXKQUUGXRUVSUWBUVQYBJUVBUVT
      UWEBCXKQXLXMXNXOXP $.
  $}

  ${
    $d a b x y B $.  $d a b h m y L $.  $d a b h m x y N $.  $d a b x y X $.
    $d h m y A $.  $d a b x y Z $.
    lgsdchr.g $e |- G = ( DChr ` N ) $.
    lgsdchr.z $e |- Z = ( Z/nZ ` N ) $.
    lgsdchr.d $e |- D = ( Base ` G ) $.
    lgsdchr.b $e |- B = ( Base ` Z ) $.
    lgsdchr.l $e |- L = ( ZRHom ` Z ) $.
    lgsdchr.x $e |- X = ( y e. B |-> ( iota h E. m e. ZZ
      ( y = ( L ` m ) /\ h = ( m /L N ) ) ) ) $.
    $( The Legendre symbol function ` X ( m ) = ( m /L N ) ` , where ` N ` is
       an odd positive number, is a Dirichlet character modulo ` N ` .
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    lgsdchrval $p |- ( ( ( N e. NN /\ -. 2 || N ) /\ A e. ZZ ) ->
      ( X ` ( L ` A ) ) = ( A /L N ) ) $=
      ( wa cz wceq cn wcel c2 cdivides wbr wn cfv cv clgs co wrex cio cn0 nnnn0
      wfo wf adantr znzrhfo 3syl ffvelrnda eqeq1 anbi1d rexbidv iotabidv iotaex
      fof fvmpt3i syl cvv ovex wb cmo cmin simprr simplll simplr simprl syl3anc
      zndvds mpbid moddvds mpbird oveq1d simpllr lgsmod 3eqtr3d biimprd anassrs
      wi eqeq2d expimpd rexlimdva fveq2 eqcomd biantrurd oveq1 bitr3d rspcev ex
      adantl impbid iota5 mpan2 eqtrd ) IUAUBZUCIUDUEUFZRZBSUBZRZBHUGZJUGZXJFUH
      ZHUGZTZEUHZXLIUIUJZTZRZFSUKZEULZBIUIUJZXIXJCUBXKXTTXGSCBHXGIUMUBZSCHUOSCH
      UPXEYBXFIUNZUQCHIKMOPURSCHVFUSUTAXJAUHZXMTZXQRZFSUKZEULXTCJYDXJTZYGXSEYHY
      FXRFSYHYEXNXQYDXJXMVAVBVCVDQYGEVEVGVHXIYAVIUBZXTYATBIUIVJXIXSEYAVIXIXSXOY
      ATZVKYIXIXSYJXIXRYJFSXIXLSUBZRXNXQYJXIYKXNXQYJWIXIYKXNRZRZYJXQYMYAXPXOYMB
      IVLUJZIUIUJZXLIVLUJZIUIUJZYAXPYMYNYPIUIYMYNYPTZIBXLVMUJUDUEZYMXNYSXIYKXNV
      NYMYBXHYKXNYSVKYMXEYBXEXFXHYLVOZYCVHXGXHYLVPZXIYKXNVQZBXLHIKMPVSVRVTYMXEX
      HYKYRYSVKYTUUAUUBBXLIWAVRWBWCYMXHXEXFYOYATUUAYTXEXFXHYLWDZBIWEVRYMYKXEXFY
      QXPTUUBYTUUCXLIWEVRWFWJWGWHWKWLXHYJXSWIXGXHYJXSXRYJFBSXLBTZXQXRYJUUDXNXQU
      UDXMXJXLBHWMWNWOUUDXPYAXOXLBIUIWPWJWQWRWSWTXAUQXBXCXD $.

    $( The Legendre symbol function ` X ( m ) = ( m /L N ) ` , where ` N ` is
       an odd positive number, is a real Dirichlet character modulo ` N ` .
       (Contributed by Mario Carneiro, 28-Apr-2016.) $)
    lgsdchr $p |- ( ( N e. NN /\ -. 2 || N ) -> ( X e. D /\ X : B --> RR ) ) $=
      ( wcel cfv wceq cz vx va vb cn c2 cdivides wbr wn wa cr wf cc cv cmulr co
      cmul cui wral cur c1 cc0 wne wi w3a wss clgs wrex cio cvv iotaex a1i cmpt
      wfo cn0 nnnn0 adantr znzrhfo foelrn sylan lgsdchrval simpr ad2antrr lgscl
      syl nnz syl2anc zred eqeltrd fveq2 eleq1d syl5ibrcom rexlimdva imp syldan
      fmpt2d ax-resscn sylancl unitss anim12dan reeanv adantrr simprr lgsdirnn0
      fss eqid syl3anc ccnfld cress crh crg ccrg zncrng crngrng zrhrhm cnfldbas
      zsscn ressbas2 ax-mp cnfldmul ressmulr rhmmul fveq2d zmulcl sylan2 eqtr3d
      cbs adantrl oveq12d 3eqtr4d oveq12 oveqan12d rexlimdvva ralrimivva ssralv
      zex eqeq12d syl5bir ralimdv wb neeq1d syld mpsyl zrh1 1lgs 3eqtr3d lgsne0
      mpan2 cgcd biimpd znunit 3imtr4d eleq1 imbi12d ralrimiva simpl dchrelbas3
      1z 3jca mpbir2and jca ) HUDQZUEHUFUGUHZUIZICQZBUJIUKZUVCUVDBULIUKZUAUMZAU
      MZJUNRZUOZIRZUVGIRZUVHIRZUPUOZSZAJUQRZURZUAUVPURZJUSRZIRZUTSZUVLVAVBZUVGU
      VPQZVCZUABURZVDUVCUVEUJULVEUVFUVCAUABUVHEUMZGRSDUMUWFHVFUOSUIETVGZDVHZUJI
      VIUWHVIQUVCUVHBQZUIUWGDVJVKIABUWHVLSUVCPVKUVCUVGBQZUVGUBUMZGRZSZUBTVGZUVL
      UJQZUVCTBGVMZUWJUWNUVCHVNQZUWPUVAUWQUVBHVOVPZBGHJLNOVQWDZUBTBUVGGVRVSZUVC
      UWNUWOUVCUWMUWOUBTUVCUWKTQZUIZUWOUWMUWLIRZUJQUXBUXCUWKHVFUOZUJAUWKBCDEFGH
      IJKLMNOPVTZUXBUXDUXBUXAHTQZUXDTQUVCUXAWAZUVAUXFUVBUXAHWEZWBZUWKHWCWFWGWHU
      WMUVLUXCUJUVGUWLIWIZWJWKWLWMWNWOZWPBUJULIXDWQUVCUVRUWAUWEUVPBVEZUVCUVOABU
      RZUABURZUVRBJUVPNUVPXEZWRUVCUVOUAABBUVCUWJUWIUIUWNUVHUCUMZGRZSZUCTVGZUIZU
      VOUVCUWJUWNUWIUXSUWTUVCUWPUWIUXSUWSUCTBUVHGVRVSWSUVCUXTUVOUXTUWMUXRUIZUCT
      VGUBTVGUVCUVOUWMUXRUBUCTTWTUVCUYAUVOUBUCTTUVCUXAUXPTQZUIZUIZUVOUYAUWLUXQU
      VIUOZIRZUXCUXQIRZUPUOZSUYDUWKUXPUPUOZHVFUOZUXDUXPHVFUOZUPUOZUYFUYHUYDUXAU
      YBUWQUYJUYLSUVCUXAUXAUYBUXGXAZUVCUXAUYBXBZUVCUWQUYCUWRVPUWKUXPHXCXFUYDUYI
      GRZIRZUYFUYJUYDUYOUYEIUYDGXGTXHUOZJXIUOQZUXAUYBUYOUYESUYDJXJQZUYRUVCUYSUY
      CUVCJXKQZUYSUVCUWQUYTUWRHJLXLWDJXMWDZVPJGUYQUYQXEZOXNWDUYMUYNUWKUXPUYQJUP
      UVIGTTULVETUYQYFRSXPTULUYQXGVUBXOXQXRTVIQUPUYQUNRSYOTXGUYQUPVIVUBXSXTXRUV
      IXEYAXFYBUYCUVCUYITQUYPUYJSUWKUXPYCAUYIBCDEFGHIJKLMNOPVTYDYEUYDUXCUXDUYGU
      YKUPUVCUXAUXCUXDSUYBUXEXAUVCUYBUYGUYKSUXAAUXPBCDEFGHIJKLMNOPVTYGYHYIUYAUV
      KUYFUVNUYHUYAUVJUYEIUVGUWLUVHUXQUVIYJYBUWMUXRUVLUXCUVMUYGUPUXJUVHUXQIWIYK
      YPWKYLYQWMWNYMUXLUXNUVQUABURUVRUXLUXMUVQUABUVOAUVPBYNYRUVQUAUVPBYNUUAUUBU
      VCUTGRZIRZUTHVFUOZUVTUTUVCUTTQVUDVUESUUQAUTBCDEFGHIJKLMNOPVTUUGUVCVUCUVSI
      UVCUYSVUCUVSSVUAJUVSGOUVSXEUUCWDYBUVCUXFVUEUTSUVAUXFUVBUXHVPHUUDWDUUEUVCU
      WDUABUVCUWJUWNUWDUWTUVCUWNUWDUVCUWMUWDUBTUXBUWDUWMUXCVAVBZUWLUVPQZVCUXBUX
      DVAVBZUWKHUUHUOUTSZVUFVUGUXBVUHVUIUXBUXAUXFVUHVUIYSUXGUXIUWKHUUFWFUUIUXBU
      XCUXDVAUXEYTUVCUWQUXAVUGVUIYSUWRUWKUVPGHJLUXOOUUJVSUUKUWMUWBVUFUWCVUGUWMU
      VLUXCVAUXJYTUVGUWLUVPUULUUMWKWLWMWNUUNUURUVCUAABCUVPFHIJKLNUXOUVAUVBUUOMU
      UPUUSUXKUUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Quadratic reciprocity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k x G $.  $d k x L $.  $d k n u v w x y z P $.  $d k n u v w x y z ph $.
    $d n u v w y z M $.  $d u w x y z N $.  $d k u w x y z Q $.  $d k x Y $.
    $d k R $.  $d n u v x z S $.
    lgseisen.1 $e |- ( ph -> P e. ( Prime \ { 2 } ) ) $.
    lgseisen.2 $e |- ( ph -> Q e. ( Prime \ { 2 } ) ) $.
    lgseisen.3 $e |- ( ph -> P =/= Q ) $.
    ${
      lgseisen.4 $e |- R = ( ( Q x. ( 2 x. x ) ) mod P ) $.
      lgseisen.5 $e |- M = ( x e. ( 1 ... ( ( P - 1 ) / 2 ) ) |->
        ( ( ( ( -u 1 ^ R ) x. R ) mod P ) / 2 ) ) $.
      $( Lemma for ~ lgseisen .  If ` R ( u ) = ( Q x. u ) mod P ` and
         ` M ( u ) = ( -u 1 ^ R ( u ) ) x. R ( u ) ` , then for any even
         ` 1 <_ u <_ P - 1 ` , ` M ( u ) ` is also an even integer
         ` 1 <_ M ( u ) <_ P - 1 ` .  To simplify these statements, we divide
         all the even numbers by ` 2 ` , so that it becomes the statement that
         ` M ( x / 2 ) = ( -u 1 ^ R ( x / 2 ) ) x. R ( x / 2 ) / 2 ` is an
         integer between ` 1 ` and ` ( P - 1 ) / 2 ` .  (Contributed by Mario
         Carneiro, 17-Jun-2015.) $)
      lgseisenlem1 $p |- ( ph ->
        M : ( 1 ... ( ( P - 1 ) / 2 ) ) --> ( 1 ... ( ( P - 1 ) / 2 ) ) ) $=
        ( c1 co c2 cmul wcel wbr cz cc0 a1i cmin cdiv cfz cneg cexp cmo cle clt
        cv wa cn caddc cc wne wceq neg1cn ax-1cn ax-1ne0 negne0i simpr syl22anc
        2z expmulz cn0 cprime csn cdif adantr eldifad syl elfzelz adantl zmulcl
        prmz sylancr zmulcld prmnn syl2anc syl5eqel elfznn0 nn0zd zcnd 2cn 2ne0
        zmodfz divcan2d oveq2d sqneg ax-mp sq1 eqtri oveq1i 1exp syl5eq 3eqtr3d
        oveq1d mulid2d eqtrd crp nn0red nnrpd nn0ge0d zred modlt syl5eqbr modid
        cr eqeltrd nncnd renegcld recnd addcomd negsubd 3eqtr2d nnred mpbird wn
        syl3anc cdivides 2nn elfznn elfzle2 wb cuz cfv 3syl syl112anc mpbir2and
        fzm1ndvds wi mtod dvdsval3 mtbid wo ord peano2zd peano2cn oveq2i dividi
        mpbid 1z modcyc resubcld ltled subge0d nnmulcl prmuz2 uz2m1nn lemuldiv2
        2re 2pos peano2zm fznn cgcd prmrp coprmdvds mpan2d eqeq1i sylnibr nn0uz
        nnnn0d syl6eleq elfzp12 mpd syl6eleqr ltsubrpd dvdsval2 biimpar ndvdsp1
        1e0p1 1lt2 mt2d oexpneg negeqd mulm1d pnpcan2d 3eqtr4d divsubdird 2m1e1
        syl6req divdird syl6eq oddprm nnzd zsubcld zeo mpjaodan m1expcl divneg2
        subadd23d mp3an negeqi eqtr3i exprecd syl5eqr expne0d recidd dvdsmultr2
        mulassd breq2d mtbird elnn0 sylib nngt0d divgt0d sylanbrc nnge1d lediv1
        mt3d elnnz elfz fmptd ) ABLCLUAMZNUBMZUCMZLUDZEUEMZEOMZCUFMZNUBMZUXOFAB
        UIZUXOPZUJZUXTUXOPZLUXTUGQZUXTUXNUGQZUYCUXTUYCUXTRPZSUXTUHQUXTUKPUYCENU
        BMZRPZUYGELULMZNUBMZRPZUYCUYIUJZUXTUYHRUYMUXSENUBUYMUXSECUFMZEUYMUXRECU
        FUYMUXRLEOMZEUYMUXQLEOUYMUXPNUYHOMZUEMZUXPNUEMZUYHUEMZUXQLUYMUXPUMPZUXP
        SUNZNRPZUYIUYQUYSUOUYTUYMUPTVUAUYMLUQURUSZTVUBUYMVBTUYCUYIUTZUXPNUYHVCV
        AUYMUYPEUXPUEUYMENUYCEUMPZUYIUYCEUYCEUYCESUXMUCMZPZEVDPUYCEDNUYAOMZOMZC
        UFMZVUFJUYCVUIRPZCUKPZVUJVUFPUYCDVUHUYCDVEPZDRPZUYCDVENVFZADVEVUOVGZPUY
        BHVHVIZDVNVJZUYCVUBUYARPZVUHRPZVBUYBVUSAUYALUXNVKVLNUYAVMVOZVPZUYCCVEPZ
        VULUYCCVEVUOACVUPPZUYBGVHZVIZCVQVJZVUICWEVRVSZEUXMVTVJZWAZWBZVHZNUMPZUY
        MWCTNSUNZUYMWDTWFWGUYMUYSLUYHUEMZLUYRLUYHUEUYRLNUEMZLLUMPZUYRVVPUOUQLWH
        WIWJWKWLUYIVVOLUOUYCUYHWMVLWNWOWPUYMEVVLWQWRWPUYCUYNEUOZUYIUYCEXGPCWSPZ
        SEUGQECUHQVVRUYCEVVIWTZUYCCVVGXAZUYCEVVIXBUYCEVUJCUHJUYCVUIXGPVVSVUJCUH
        QUYCVUIVVBXCVWAVUICXDVRXEZECXFVAVHWRWPVUDXHUYCUYLUJZUXTCLULMZNUBMZUYKUA
        MZRVWCUXTVWDUYJUAMZNUBMVWFVWCUXSVWGNUBVWCEUDZCUFMZCEUAMZUXSVWGUYCVWIVWJ
        UOUYLUYCVWHLCOMZULMZCUFMZVWJCUFMZVWIVWJUYCVWLVWJCUFUYCVWLVWHCULMCVWHULM
        VWJUYCVWKCVWHULUYCCUYCCVVGXIZWQWGUYCCVWHVWOUYCVWHUYCEVVTXJZXKXLUYCCEVWO
        VVKXMXNWPUYCVWHXGPVVSLRPZVWMVWIUOVWPVWAVWQUYCUUATZVWHCLUUBXRUYCVWJXGPVV
        SSVWJUGQZVWJCUHQVWNVWJUOUYCCEUYCCVVGXOZVVTUUCVWAUYCVWSECUGQUYCECVVTVWTV
        WBUUDUYCCEVWTVVTUUEXPUYCCEVWTUYCEUYCELUXMUCMZPZEUKPZUYCESLULMZUXMUCMZVX
        AUYCESUOZXQEVXEPZUYCVUJSUOZVXFUYCCVUIXSQZVXHUYCVXICVUHXSQZUYCVULVUHVXAP
        ZVXJXQVVGUYCVXKVUHUKPZVUHUXMUGQZUYCNUKPZUYAUKPZVXLXTUYBVXOAUYAUXNYAVLZN
        UYAUUFVOUYCVXMUYAUXNUGQZUYBVXQAUYALUXNYBVLUYCUYAXGPUXMXGPZNXGPZSNUHQZVX
        MVXQYCUYCUYAVXPXOUYCUXMUYCVVCCNYDYEPUXMUKPVVFCUUGCUUHYFZXOZVXSUYCUUJTZV
        XTUYCUUKTZUYAUXMNUUIYGXPUYCCRPZUXMRPVXKVXLVXMUJYCUYCVVCVYEVVFCVNVJZCUUL
        VUHUXMUUMYFYHCVUHYIVRUYCVXICDUUNMLUOZVXJUYCVYGCDUNZAVYHUYBIVHUYCVVCVUMV
        YGVYHYCVVFVUQCDUUOVRXPUYCVYEVUNVUTVXIVYGUJVXJYJVYFVURVVACDVUHUUPXRUUQYK
        UYCVULVUKVXIVXHYCVVGVVBCVUIYLVRYMEVUJSJUURUUSUYCVXFVXGUYCVUGVXFVXGYNZVV
        HUYCUXMSYDYEZPVUGVYIYCUYCUXMVDVYJUYCUXMVYAUVAUUTUVBESUXMUVCVJYTYOUVDLVX
        DUXMUCUVJWLUVEZEUXMYAVJZXAUVFVWJCXFVAWOVHVWCUXRVWHCUFVWCUXRUXPEOMVWHVWC
        UXQUXPEOVWCUXQLEUEMZUDZUXPVWCVVQVXCNEXSQZXQUXQVYNUOVVQVWCUQTZUYCVXCUYLV
        YLVHVWCVYONUYJXSQZUYCVYQUYLUYCVUBVVNUYJRPVYQUYLYCVUBUYCVBTVVNUYCWDTUYCE
        VVJYPNUYJUVGXRUVHVWCERPZVXNLNUHQZVYOVYQXQYJUYCVYRUYLVVJVHZVXNVWCXTTVYSV
        WCUVKTNEUVIXRUVLLEUVMXRVWCVYMLVWCVYRVYMLUOVYTEWMVJUVNWRWPVWCEUYCVUEUYLV
        VKVHZUVOWRWPVWCCELUYCCUMPZUYLVWOVHZWUAVYPUVPUVQWPVWCVWDUYJNVWCWUBVWDUMP
        WUCCYQVJVWCVUEUYJUMPWUAEYQVJVVMVWCWCTZVVNVWCWDTZUVRWRVWCVWEUYKVWCVWEUXN
        LULMZRVWCVWEUXMNULMZNUBMZWUFVWCVWDWUGNUBVWCWUGCNLUAMZULMVWDVWCCLNWUCVYP
        WUDUWJWUILCULUVSYRUVTWPVWCWUHUXNNNUBMZULMWUFVWCUXMNNUYCUXMUMPUYLUYCUXMV
        YAXIVHWUDWUDWUEUWAWUJLUXNULNWCWDYSYRUWBWRVWCUXNUYCUXNRPZUYLUYCUXNUYCVVD
        UXNUKPVVECUWCVJUWDZVHYPXHUYCUYLUTUWEXHUYCVYRUYIUYLYNVVJEUWFVJUWGZUYCUXS
        NUYCUXSUYCUXSVUFPZUXSVDPZUYCUXRRPZVULWUNUYCUXQEUYCVYRUXQRPZVVJEUWHVJZVV
        JVPZVVGUXRCWEVRZUXSUXMVTVJZWTZVYCUYCUXSUYCUXSUKPZUXSSUOZUYCCUXRXSQZWVDU
        YCWVECUXQUXROMZXSQZUYCWVGCEXSQZUYCVULVXBWVHXQVVGVYKCEYIVRUYCWVFECXSUYCU
        XQUXQOMZEOMUYOWVFEUYCWVILEOUYCWVIUXQLUXQUBMZOMLUYCUXQWVJUXQOUYCUXQLUXPU
        BMZEUEMWVJWVKUXPEUELLUBMZUDZWVKUXPVVQVVQLSUNWVMWVKUOUQUQURLLUWIUWKWVLLL
        UQURYSUWLUWMWLUYCUXPEUYTUYCUPTZVUAUYCVUCTZVVJUWNUWOWGUYCUXQUYCUXQWURWBZ
        UYCUXPEWVNWVOVVJUWPUWQWRWPUYCUXQUXQEWVPWVPVVKUWSUYCEVVKWQWOUWTUXAUYCVYE
        WUQWUPWVEWVGYJVYFWURWUSCUXQUXRUWRXRYKUYCVULWUPWVEWVDYCVVGWUSCUXRYLVRYMU
        YCWVCWVDUYCWUOWVCWVDYNWVAUXSUXBUXCYOUXIUXDVYDUXEUXTUXJUXFUXGUYCUXSUXMUG
        QZUYFUYCWUNWVQWUTUXSSUXMYBVJUYCUXSXGPVXRVXSVXTWVQUYFYCWVBVYBVYCVYDUXSUX
        MNUXHYGYTUYCUYGVWQWUKUYDUYEUYFUJYCWUMVWRWULUXTLUXNUXKXRYHKUXL $.

      lgseisen.6 $e |- S = ( ( Q x. ( 2 x. y ) ) mod P ) $.
      $( Lemma for ~ lgseisen .  The function ` M ` is an injection (and hence
         a bijection by the pigeonhole principle).  (Contributed by Mario
         Carneiro, 17-Jun-2015.) $)
      lgseisenlem2 $p |- ( ph -> M : ( 1 ... ( ( P - 1 ) / 2 ) )
                         -1-1-onto-> ( 1 ... ( ( P - 1 ) / 2 ) ) ) $=
        ( c1 co c2 wcel cmul cmo vz cmin cdiv cfz wf1 wf1o wf cfv wceq weq wral
        cv wi lgseisenlem1 wa cneg cexp oveq2d oveq1d oveq12d ovex ad2antrl cvv
        oveq2 ad2antll eqeq12d cc cc0 wne wb cn0 cprime adantr eldifad prmz syl
        cz 2z elfzelz zmulcl sylancr zmulcld cn zmodcld syl5eqel m1expcl nn0cnd
        nn0zd syl112anc eqidd oveq1i cr zred modabs2 syl2anc modmul12d cdivides
        a1i syl5eq moddvds syl3anc zcnd subdid mul12d eqtrd breq2d prmrp mpbird
        wbr coprmdvds mpan2d caddc mulassd ax-1cn ax-1ne0 mulid2d eqeq2d elfznn
        cgcd cle nnred elfzle2 3syl sylbid eqeq1d imbi1d syl5ibrcom clt nnmulcl
        oveq1 2nn nnnn0d nn0ge0d lemuldiv2 zltlem1 modid syl22anc nfcv nffv nfv
        3eqtr4g fvmpt fvmpt2 mpan2 csn cdif prmnn 2cn 2ne0 div11 crp dvdsmultr2
        nnrpd zsubcld neg1cn expaddd eqtr2d divneg2 mp3an negeqi eqtr3i negne0i
        div1i exprecd syl5eqr expne0d recidd 3eqtr3d mulm1d znegcld wn nnaddcld
        eqcom syl5bb oddprm le2addd peano2rem recnd 2halvesd peano2zm mpbir2and
        breqtrd fznn fzm1ndvds eldifsni 2prm sylancl nnzd subnegd adddid eqtr4d
        mtod mtbird pm2.21d 2re 2pos biimpd cpr nn0addcld m1expcl2 elpri mpjaod
        wo 1z znegcl ax-mp zexpcl mulcand 3imtr3d 3syld sylbird ralrimivva cmpt
        nfmpt1 nfcxfr fveq2 equequ2 imbi12d cbvral ralbii sylibr dff13 sylanbrc
        nfeq nfim cen cfn enref fzfi f1finf1o mp2an sylib ) AODOUBPZQUCPZUDPZUY
        OHUEZUYOUYOHUFZAUYOUYOHUGCULZHUHZUAULZHUHZUIZCUAUJZUMZUAUYOUKZCUYOUKZUY
        PABDEFHIJKLMUNAUYSBULZHUHZUIZCBUJZUMZBUYOUKZCUYOUKVUFAVUKCBUYOUYOAUYRUY
        ORZVUGUYORZUOZUOZVUIOUPZGUQPZGSPZDTPZQUCPZVUQFUQPZFSPZDTPZQUCPZUIZVUJVU
        PUYSVVAVUHVVEVUMUYSVVAUIAVUNBUYRVVEVVAUYOHBCUJZVVDVUTQUCVVGVVCVUSDTVVGV
        VBVURFGSVVGFGVUQUQVVGEQVUGSPZSPZDTPZEQUYRSPZSPZDTPZFGVVGVVIVVLDTVVGVVHV
        VKESVUGUYRQSVDURUSLNUUAZURVVNUTUSUSMVUTQUCVAUUBVBVUNVUHVVEUIZAVUMVUNVVE
        VCRVVOVVDQUCVABUYOVVEVCHMUUCUUDVEVFVUPVVFVUTVVDUIZVUJVUPVUTVGRVVDVGRQVG
        RZQVHVIZVVFVVPVJVUPVUTVUPVUSDVUPVURGVUPGVQRVURVQRVUPGVUPGVVMVKNVUPVVLDV
        UPEVVKVUPEVLRZEVQRZVUPEVLQUUEZAEVLVWAUUFZRVUOJVMVNZEVOVPZVUPQVQRZUYRVQR
        ZVVKVQRZVRVUMVWFAVUNUYROUYNVSVBZQUYRVTWAZWBZVUPDVLRZDWCRZVUPDVLVWAADVWB
        RZVUOIVMZVNZDUUGVPZWDWEZWHZGWFVPZVWRWBVWPWDWGVUPVVDVUPVVCDVUPVVBFVUPFVQ
        RVVBVQRZVUPFVUPFVVJVKLVUPVVIDVUPEVVHVWDVUPVWEVUGVQRZVVHVQRZVRVUNVXAAVUM
        VUGOUYNVSVEZQVUGVTWAZWBZVWPWDWEZWHZFWFVPZVXGWBVWPWDWGVVQVUPUUHWRZVVRVUP
        UUIWRZVUTVVDQUUJWIVUPVVPVURVVLSPZDTPZVVBVVISPZDTPZUIZVUJVUPVUTVXLVVDVXN
        VUPVURVURGVVLDVWSVWSVWRVWJVUPDVWPUUMZVUPVURDTPWJVUPGDTPVVMDTPZVVMGVVMDT
        NWKVUPVVLWLRDUUKRZVXQVVMUIVUPVVLVWJWMVXPVVLDWNWOWSWPVUPVVBVVBFVVIDVXHVX
        HVXGVXEVXPVUPVVBDTPWJVUPFDTPVVJDTPZVVJFVVJDTLWKVUPVVIWLRVXRVXSVVJUIVUPV
        VIVXEWMVXPVVIDWNWOWSWPVFVUPVXODVXKVXMUBPZWQXIZVUJVUPVWLVXKVQRVXMVQRVXOV
        YAVJVWPVUPVURVVLVWSVWJWBVUPVVBVVIVXHVXEWBVXKVXMDWTXAVUPVYADEVURVVKSPZVV
        BVVHSPZUBPZSPZWQXIZVUJVUPVYEVXTDWQVUPVYEEVYBSPZEVYCSPZUBPVXTVUPEVYBVYCV
        UPEVWDXBZVUPVYBVUPVURVVKVWSVWIWBZXBZVUPVYCVUPVVBVVHVXHVXDWBZXBZXCVUPVYG
        VXKVYHVXMUBVUPEVURVVKVYIVUPVURVWSXBZVUPVVKVWIXBZXDVUPEVVBVVHVYIVUPVVBVX
        HXBZVUPVVHVXDXBZXDUTXEXFVUPVYFDVYDWQXIZDVVBVYDSPZWQXIZVUJVUPVYFDEXSPOUI
        ZVYRVUPWUADEVIZAWUBVUOKVMVUPVWKVVSWUAWUBVJVWOVWCDEXGWOXHVUPDVQRZVVTVYDV
        QRZVYFWUAUOVYRUMVUPVWKWUCVWODVOVPZVWDVUPVYBVYCVYJVYLUUNZDEVYDXJXAXKVUPW
        UCVWTWUDVYRVYTUMWUEVXHWUFDVVBVYDUULXAVUPVYTDVUQFGXLPZUQPZVVKSPZVVHUBPZW
        QXIZVUJVUPVYSWUJDWQVUPVYSVVBVYBSPZVVBVYCSPZUBPWUJVUPVVBVYBVYCVYPVYKVYMX
        CVUPWULWUIWUMVVHUBVUPWUIVVBVURSPZVVKSPWULVUPWUHWUNVVKSVUPVUQFGVUQVGRVUP
        UUOWRZVWQVXFUUPUSVUPVVBVURVVKVYPVYNVYOXMUUQVUPVVBVVBSPZVVHSPOVVHSPWUMVV
        HVUPWUPOVVHSVUPWUPVVBOVVBUCPZSPOVUPVVBWUQVVBSVUPVVBOVUQUCPZFUQPWUQWURVU
        QFUQOOUCPZUPZWURVUQOVGRZWVAOVHVIWUTWURUIXNXNXOOOUURUUSWUSOOXNUVCUUTUVAW
        KVUPVUQFWUOVUQVHVIVUPOXNXOUVBWRZVXGUVDUVEURVUPVVBVYPVUPVUQFWUOWVBVXGUVF
        UVGXEUSVUPVVBVVBVVHVYPVYPVYQXMVUPVVHVYQXPUVHUTXEXFVUPWUIDTPZVVHDTPZUIZV
        VKVVHUIZWUKVUJVUPWUHVUQUIZWVEWVFUMZWUHOUIZVUPWVHWVGVUQVVKSPZDTPZWVDUIZW
        VFUMVUPWVLWVDVVKUPZDTPZUIZWVFWVLWVDWVKUIVUPWVOWVKWVDUVMVUPWVKWVNWVDVUPW
        VJWVMDTVUPVVKVYOUVIUSXQUVNVUPWVODVVHWVMUBPZWQXIZWVFVUPVWLVXBWVMVQRWVOWV
        QVJVWPVXDVUPVVKVWIUVJVVHWVMDWTXAVUPWVQWVFVUPWVQDQVUGUYRXLPZSPZWQXIZVUPW
        VTDWVRWQXIZVUPVWLWVROUYMUDPRZWWAUVKVWPVUPWWBWVRWCRZWVRUYMXTXIZVUPVUGUYR
        VUNVUGWCRZAVUMVUGUYNXRVEZVUMUYRWCRZAVUNUYRUYNXRVBZUVLZVUPWVRUYNUYNXLPUY
        MXTVUPVUGUYRUYNUYNVUPVUGWWFYAZVUPUYRVWHWMZVUPUYNVUPVWMUYNWCRVWNDUVOVPYA
        ZWWLVUNVUGUYNXTXIZAVUMVUGOUYNYBVEZVUMUYRUYNXTXIZAVUNUYROUYNYBVBZUVPVUPU
        YMVUPUYMVUPDWLRUYMWLRZVUPDVWPYADUVQVPZUVRUVSUWBVUPWUCUYMVQRWWBWWCWWDUOV
        JWUEDUVTWVRUYMUWCYCUWADWVRUWDWOVUPWVTDQXSPOUIZWWAVUPWWSDQVIZVUPVWMWWTVW
        NDVLQUWEVPVUPVWKQVLRWWSWWTVJVWOUWFDQXGUWGXHVUPWUCVWEWVRVQRWVTWWSUOWWAUM
        WUEVWEVUPVRWRVUPWVRWWIUWHDQWVRXJXAXKUWLVUPWVPWVSDWQVUPWVPVVHVVKXLPWVSVU
        PVVHVVKVYQVYOUWIVUPQVUGUYRVXIVUPVUGVXCXBZVUPUYRVWHXBZUWJUWKXFUWMUWNYDYD
        WVGWVEWVLWVFWVGWVCWVKWVDWVGWUIWVJDTWUHVUQVVKSYJUSYEYFYGVUPWVHWVIOVVKSPZ
        DTPZWVDUIZWVFUMVUPWXEWVFVUPWXDVVKWVDVVHVUPWXDVVKDTPZVVKVUPWXCVVKDTVUPVV
        KVYOXPUSVUPVVKWLRVXRVHVVKXTXIVVKDYHXIZWXFVVKUIVUPVVKVWIWMVXPVUPVVKVUPVV
        KVUPQWCRZWWGVVKWCRYKWWHQUYRYIWAYLYMVUPWXGVVKUYMXTXIZVUPWXIWWOWWPVUPUYRW
        LRWWQQWLRZVHQYHXIZWXIWWOVJWWKWWRWXJVUPUWOWRZWXKVUPUWPWRZUYRUYMQYNWIXHVU
        PVWGWUCWXGWXIVJVWIWUEVVKDYOWOXHVVKDYPYQXEVUPVVHWLRVXRVHVVHXTXIVVHDYHXIZ
        WVDVVHUIVUPVVHVXDWMVXPVUPVVHVUPVVHVUPWXHWWEVVHWCRYKWWFQVUGYIWAYLYMVUPWX
        NVVHUYMXTXIZVUPWXOWWMWWNVUPVUGWLRWWQWXJWXKWXOWWMVJWWJWWRWXLWXMVUGUYMQYN
        WIXHVUPVXBWUCWXNWXOVJVXDWUEVVHDYOWOXHVVHDYPYQVFUWQWVIWVEWXEWVFWVIWVCWXD
        WVDWVIWUIWXCDTWUHOVVKSYJUSYEYFYGVUPWUGVQRWUHVUQOUWRRWVGWVIUXCVUPWUGVUPF
        GVXFVWQUWSZWHWUGUWTWUHVUQOUXAYCUXBVUPVWLWUIVQRVXBWVEWUKVJVWPVUPWUHVVKVU
        PVUQVQRZWUGVKRWUHVQROVQRWXQUXDOUXEUXFWXPVUQWUGUXGWAVWIWBVXDWUIVVHDWTXAV
        UPUYRVUGQWXBWXAVXIVXJUXHUXIYDUXJUXKYDYDYDYDUXLVUEVULCUYOVUDVUKUABUYOVUB
        VUCBBUYSVUABUYRHBHBUYOVVEUXMMBUYOVVEUXNUXOZBUYRYRYSBUYTHWXRBUYTYRYSUYDV
        UCBYTUYEVUKUAYTUABUJZVUBVUIVUCVUJWXSVUAVUHUYSUYTVUGHUXPXQUABCUXQUXRUXSU
        XTUYACUAUYOUYOHUYBUYCUYOUYOUYFXIUYOUYGRUYPUYQVJUYOOUYNUDVAUYHOUYNUYIUYO
        UYOHUYJUYKUYL $.

      lgseisen.7 $e |- Y = ( Z/nZ ` P ) $.
      lgseisen.8 $e |- G = ( mulGrp ` Y ) $.
      lgseisen.9 $e |- L = ( ZRHom ` Y ) $.
      $( Lemma for ~ lgseisen .  (Contributed by Mario Carneiro,
         17-Jun-2015.) $)
      lgseisenlem3 $p |- ( ph -> ( G gsum ( x e. ( 1 ... ( ( P - 1 ) / 2 ) )
          |-> ( L ` ( ( -u 1 ^ R ) x. Q ) ) ) ) = ( 1r ` Y ) ) $=
        ( vk c1 cmin co c2 cdiv cfz cmul cfv cmpt cgsu cdvr cneg cexp cmulr cur
        cv cof ccom cmo wceq fveq2d cbvmptv oveq2i cbs cfn c0g eqid mgpbas ccrg
        oveq2 wcel ccmn cfield cprime csn eldifad znfld syl cdr simprbi crngmgp
        isfld fzfid cz wf ccnfld cress crh crngrng zrhrhm csubrg subrgbas ax-mp
        crg zsubrg rhmf 2z elfzelz sylancr fmptd ccnv cima wss mptpreima ssrab2
        crab eqsstri ssfi sylancl a1i eqidd oveq2d wa cn0 adantr prmz cn adantl
        zmulcld zmodcld nn0zd cc0 wne cdivides wbr cr zred modabs2 syl2anc zcnd
        oveq1d wb syl3anc mpbird 3eqtrd ffvelrnd cle nnred mpbir2and zmulcl cvv
        ffvelrn syl2an cdif lgseisenlem2 gsumf1o syl5eqr wral lgseisenlem1 fmpt
        sylibr fmptcof 2nn elfznn nnmulcl nnzd prmnn syl5eqel m1expcl nn0cnd cc
        2cn 2ne0 divcan2d nnrpd oveq1i syl5eq modmul12d mulassd 3eqtr4d moddvds
        mpbid nnnn0d zndvds cnfldmul ressmulr rhmmul mpteq2dva offval2 mgpplusg
        crp eqtr4d fisuppfi gsumadd cui csubmnd unitsubm elfzle2 clt cuz prmuz2
        eqtrd uz2m1nn 3syl 2re 2pos lemuldiv2 syl112anc peano2zm fznn fzm1ndvds
        wn zndvds0 necon3abid simplbi drngunit gsumsubmcl dvrid gsumcl 3eqtr3rd
        dvrcan3 ) AHBUBDUBUCUDZUEUFUDZUGUDZUEBUQZUHUDZIUIZUJZUKUDZUXTKULUIZUDZH
        BUXOUBUMFUNUDZEUHUDZIUIZUJZUKUDZUXTKUOUIZUDZUXTUYAUDZKUPUIZUYGAUXTUYIUX
        TUYAAUXTHUYFUXSUYHURUDZUKUDZUYIAUXTHUAUXOUEUAUQZUHUDZIUIZUJZJUSZUKUDZHB
        UXOUEUYCFUHUDZDUTUDZUEUFUDZUHUDZIUIZUJZUKUDUYMAUXTHUYQUKUDUYSUYQUXSHUKU
        ABUXOUYPUXRUYNUXPVAUYOUXQIUYNUXPUEUHVKVBVCVDAUXOKVEUIZUXOUYQHJVFHVGUIZV
        UFKHSVUFVHZVIZVUGVHZAKVJVLZHVMVLAKVNVLZVUKADVOVLZVULADVOUEVPZLVQZDKRVRV
        SZVULKVTVLZVUKKWCZWAVSZKHSWBVSZAUBUXNWDZAUAUXOUYPVUFUYQAWEVUFIWFZUYOWEV
        LZUYPVUFVLUYNUXOVLZAIWGWEWHUDZKWIUDVLZVVBAKWOVLZVVFAVUKVVGVUSKWJVSZKIVV
        EVVEVHZTWKVSZWEVUFVVEKIWEWGWLUIZVLZWEVVEVEUIVAWPWEWGVVEVVIWMWNZVUHWQVSZ
        VVDUEWEVLUYNWEVLVVCWRUYNUBUXNWSUEUYNUUAWTWEVUFUYOIUUCUUDUYQVHZXAAUXOVFV
        LZUYQXBUUBVUGVPUUEZXCZUXOXDVVRVFVLVVAVVRUYPVVQVLZUAUXOXGUXOUAUXOUYPVVQU
        YQVVOXEVVSUAUXOXFXHUXOVVRXIXJABCDEFGJLMNOPQUUFUUGUUHAUYRVUEHUKABUAUXOUX
        OVUBUYPVUDJUYQAUXOUXOJWFVUBUXOVLBUXOUUIABDEFJLMNOPUUJBUXOUXOVUBJPUUKUUL
        JBUXOVUBUJVAAPXKAUYQXLUYNVUBVAUYOVUCIUYNVUBUEUHVKVBUUMXMAVUEUYLHUKAVUEB
        UXOUYEUXRUYHUDZUJUYLABUXOVUDVVTAUXPUXOVLZXNZVUDVUAIUIZUYDUXQUHUDZIUIZVV
        TVWBVUCVUAIVWBVUAUEVWBVUAVWBUYTDVWBUYCFVWBFWEVLUYCWEVLVWBFVWBFEUXQUHUDZ
        DUTUDZXOOVWBVWFDVWBEUXQVWBEVOVLZEWEVLAVWHVWAAEVOVUNMVQXPEXQVSZVWBUXQVWB
        UEXRVLUXPXRVLZUXQXRVLZUUNVWAVWJAUXPUXNUUOXSZUEUXPUUPWTZUUQZXTZVWBVUMDXR
        VLZAVUMVWAVUOXPZDUURZVSZYAUUSYBZFUUTVSZVWTXTZVWSYAZUVAUEUVBVLVWBUVCXKUE
        YCYDVWBUVDXKUVEVBVWBVWCVWEVAZDVUAVWDUCUDYEYFZVWBVUADUTUDZVWDDUTUDZVAZVX
        EVWBVUAUYCVWFUHUDZDUTUDVXFVXGVWBUYCUYCFVWFDVXAVXAVWTVWOVWBDVWSUVFZVWBUY
        CDUTUDXLVWBFDUTUDVWGDUTUDZVWGFVWGDUTOUVGVWBVWFYGVLDUWBVLZVXKVWGVAVWBVWF
        VWOYHVXJVWFDYIYJUVHUVIVWBUYTYGVLVXLVXFVUAVAVWBUYTVXBYHVXJUYTDYIYJVWBVWD
        VXIDUTVWBUYCEUXQVWBUYCVXAYKVWBEVWIYKVWBUXQVWNYKUVJYLUVKVWBVWPVUAWEVLZVW
        DWEVLZVXHVXEYMAVWPVWAAVUMVWPVUOVWRVSXPVWBVUAVXCYBZVWBUYDUXQVWBUYCEVXAVW
        IXTZVWNXTZVUAVWDDUVLYNUVMVWBDXOVLZVXMVXNVXDVXEYMVWBDVWSUVNZVXOVXQVUAVWD
        IDKRTUVOYNYOVWBVVFUYDWEVLUXQWEVLZVWEVVTVAAVVFVWAVVJXPVXPVWNUYDUXQVVEKUH
        UYHIWEVVMVVLUHVVEUOUIVAWPWEWGVVEUHVVKVVIUVPUVQWNUYHVHZUVRYNYPUVSABUXOUY
        EUXRUYHUYFUXSVFVUFVUFVVAVWBWEVUFUYDIAVVBVWAVVNXPZVXPYQZVWBWEVUFUXQIVYBV
        WNYQZAUYFXLAUXSXLUVTUWCXMYPAUXOVUFUYHUYFHUXSVFVUGVUIVUJKUYHHSVYAUWAVUTV
        VAABUXOUYEVUFUYFVYCUYFVHZXAZABUXOUXRVUFUXSVYDUXSVHZXAZAVVPUYFXBVVQXCZUX
        OXDVYIVFVLVVAVYIUYEVVQVLZBUXOXGUXOBUXOUYEVVQUYFVYEXEVYJBUXOXFXHUXOVYIXI
        XJZAUXOVUFVVQUXSVVAVYHUWDZUWEUWMYLAVVGUXTKUWFUIZVLZUYBUYKVAVVHAUXOVYMUX
        SHVFVUGVUJVUTVVAAVVGVYMHUWGUIVLVVHKVYMHVYMVHZSUWHVSABUXOUXRVYMUXSVWBUXR
        VYMVLZUXRVUFVLZUXRKVGUIZYDZVYDVWBVYSDUXQYEYFZUXCZVWBVWPUXQUBUXMUGUDVLZW
        UAVWSVWBWUBVWKUXQUXMYRYFZVWMVWBWUCUXPUXNYRYFZVWAWUDAUXPUBUXNUWIXSVWBUXP
        YGVLUXMYGVLUEYGVLZYCUEUWJYFZWUCWUDYMVWBUXPVWLYSVWBUXMVWBVUMDUEUWKUIVLUX
        MXRVLVWQDUWLDUWNUWOYSWUEVWBUWPXKWUFVWBUWQXKUXPUXMUEUWRUWSYOVWBUXMWEVLZW
        UBVWKWUCXNYMVWBDWEVLZWUGVWBVUMWUHVWQDXQVSDUWTVSUXQUXMUXAVSYTDUXQUXBYJVW
        BVYTUXRVYRVWBVXRVXTUXRVYRVAVYTYMVXSVWNUXQIDKVYRRTVYRVHZUXDYJUXEYOVWBVUQ
        VYPVYQVYSXNYMAVUQVWAAVULVUQVUPVULVUQVUKVURUXFVSXPVUFKVYMUXRVYRVUHVYOWUI
        UXGVSYTVYGXAVYLUXHZUYAKVYMUYKUXTVYOUYAVHZUYKVHUXIYJAVVGUYGVUFVLVYNUYJUY
        GVAVVHAUXOVUFUYFHVFVUGVUIVUJVUTVVAVYFVYKUXJWUJVUFUYAKUYHVYMUYGUXTVUHVYO
        WUKVYAUXLYNUXK $.

      $( Lemma for ~ lgseisen .  The function ` M ` is an injection (and hence
         a bijection by the pigeonhole principle).  (Contributed by Mario
         Carneiro, 18-Jun-2015.) $)
      lgseisenlem4 $p |- ( ph -> ( ( Q ^ ( ( P - 1 ) / 2 ) ) mod P ) =
        ( ( -u 1 ^ sum_ x e. ( 1 ... ( ( P - 1 ) / 2 ) )
          ( |_ ` ( ( Q / P ) x. ( 2 x. x ) ) ) ) mod P ) ) $=
        ( vk c1 cmin co c2 cdiv cexp cmo cneg cfz cv cmul cfl cfv wceq cdivides
        csu wbr cmpt cgsu ccnfld cz cress cfn cc0 wcel zsubrg eqid ax-mp cnfld0
        cbs c0g ccmn crg mp1i cprime csn eldifad cmhm m1expcl adantl eqidd cmgp
        syl wf cnrng mp2an cc cdif csubmnd wne neg1cn ax-1cn wb sylancr syl2anc
        wss fmptd cr cn prmnn nnred adantr nnmulcl ccnv cvv cima crab mptpreima
        ssrab2 eqsstri ssfi sylancl oveq2 fveq2d cmulr mgpbas ffvelrnd cn0 prmz
        nnzd zmulcld zexpcl syl3anc caddc syl5eq zcnd nncnd oveq2d eqtrd 3eqtrd
        a1i syl22anc wn 1exp oveq1d nnnn0d 3eqtr3d eqtr3d cmg subrgbas subrgrng
        csubrg subrg0 cabel rngabl mp2b ablcmn cmnd ccrg cfield znfld cdr isfld
        simprbi crngmgp cmnmnd fzfid ccom crh crngrng zrhrhm rhmf feqmptd fveq2
        fmptco mgpress rhmmhm cghm ax-1ne0 expghm ghmmhm cnfldbas cndrng drngui
        negne0i unitsubm resmhm2 crn subrgsubm resmhm2b mpbii mhmco eqeltrrd wa
        frn nndivred 2nn elfznn remulcld flcld gsummhm2 cur cof mgpplusg znegcl
        1z zmodcld syl5eqel gsumadd offval2 cnfldmul ressmulr rhmmul zred nnrpd
        crp modval nnne0d div23d pncan3d mul12d expaddz expmulz eldifsni necomd
        2cn nn0zd neneqd cuz 2z uzid dvdsprm mtbird oexpneg negeqd 2nn0 expmuld
        syl2an sqneg sq1 oveq1i mulassd mulid2d mpteq2dva lgseisenlem3 3eqtr3rd
        eqtri gsumcl rngridm gsumconst oddprm hashfz1 mhmmulg submmulg cnfldexp
        chash csubg subrgsubg subgsubm gsumsubm gsumfsum fsumzcl zndvds moddvds
        mpbid mpbird ) AEDUBUCUDUEUFUDZUGUDZDUHUDUBUIZUBVURUJUDZEDUFUDZUEBUKZUL
        UDZULUDZUMUNZBUQZUGUDZDUHUDUOZDVUSVVHUCUDUPURZAVUSIUNZVVHIUNZUOZVVJAHBV
        VAVUTVVFUGUDZIUNZUSZUTUDZVUTVAVBVCUDZBVVAVVFUSZUTUDZUGUDZIUNZVVKVVLAUAV
        VAVBVUTUAUKZUGUDZIUNZVVOBVWBVVRHVDVVFVEVBVAUUCUNZVFZVBVVRVKUNUOVGVBVAVV
        RVVRVHZUUAVIZVWGVEVVRVLUNUOVGVBVAVVRVEVWHVJUUDVIVVRUUEVFZVVRVMVFAVWGVVR
        VNVFVWJVGVBVAVVRVWHUUBVVRUUFUUGVVRUUHVOAHVMVFZHUUIVFZAKUUJVFZVWKAKUUKVF
        ZVWMADVPVFZVWNADVPUEVQZLVRZDKRUULWDVWNKUUMVFVWMKUUNUUOWDZKHSUUPWDZHUUQW
        DZAUBVURUURZAIUAVBVWDUSZUUSZUAVBVWEUSVVRHVSUDZAUABVBVBVWDVVCIUNVWEVXBIV
        WCVBVFVWDVBVFAVWCVTWAZAVXBWBABVBKVKUNZIAIVVRKUUTUDVFZVBVXFIWEZAKVNVFZVX
        GAVWMVXIVWRKUVAWDZKIVVRVWHTUVBWDZVBVXFVVRKIVWIVXFVHZUVCWDZUVDVVCVWDIUVE
        UVFAIVAWCUNZVBVCUDZHVSUDVFZVXBVVRVXOVSUDVFZVXCVXDVFAVXGVXPVXKVVRKIVXOHV
        AVNVFZVWGVXOVVRWCUNUOWFVGVBVAVVRVXNVNVWFVWHVXNVHZUVGWGZSUVHWDZAVXBVVRVX
        NVSUDVFZVXQVXBVVRVXNWHVEVQZWIZVCUDZVSUDVFZVYDVXNWJUNZVFZVYBVXBVVRVYEUVI
        UDVFZVYFVUTWHVFZVUTVEWKZVYIWLUBWMUVJUVPZUAVUTVYEVXNVVRVWHVXSVYEVHZUVKWG
        VVRVYEVXBUVLVIVXRVYHWFVAVYDVXNWHVAVEUVMVJUVNUVOVXSUVQVIVVRVXNVYEVXBVYDV
        YMUVRWGAVBVYGVFZVXBUVSVBWQZVYBVXQWNVWGVYNVGVBVAVXNVXSUVTVIZAVBVBVXBWEVY
        OAUAVBVWDVBVXBVXEVXBVHWRVBVBVXBUWFWDVVRVXNVXOVXBVBVXOVHZUWAWOUWBVVRVXOH
        IVXBUWCWPUWDAVVCVVAVFZUWEZVVEVYSVVBVVDAVVBWSVFVYRAEDAEAEVPVFZEWTVFZAEVP
        VWPMVRZEXAWDZXBAVWODWTVFZVWQDXAZWDZUWGXCVYSVVDVYSUEWTVFVVCWTVFZVVDWTVFU
        WHVYRWUGAVVCVURUWIZWAZUEVVCXDWOZXBUWJUWKZAVVAVDVFZVVSXEXFVYCWIZXGZVVAWQ
        WUNVDVFVXAWUNVVFWUMVFZBVVAXHVVABVVAVVFWUMVVSVVSVHZXIWUOBVVAXJXKVVAWUNXL
        XMVWCVVFUOVWDVVNIVWCVVFVUTUGXNXOVWCVVTUOVWDVWAIVWCVVTVUTUGXNXOUWLAVVQKU
        WMUNZKXPUNZUDZHBVVAEIUNZUSZUTUDZVVQVVKAHVVPBVVAVUTFUGUDZEULUDZIUNZUSZWU
        RUWNUDZUTUDVVQHWVFUTUDZWURUDWVBWUSAVVAVXFWURVVPHWVFVDHVLUNZVXFKHSVXLXQZ
        WVIVHZKWURHSWURVHZUWOVWSVXAABVVAVVOVXFVVPVYSVBVXFVVNIAVXHVYRVXMXCZVYSVV
        FVBVFZVVNVBVFZWUKVVFVTWDZXRZVVPVHZWRZABVVAWVEVXFWVFVYSVBVXFWVDIWVMVYSWV
        CEVYSVUTVBVFZFXSVFWVCVBVFUBVBVFWVTUWQUBUWPVIVYSFEVVDULUDZDUHUDZXSOVYSWW
        ADVYSEVVDVYSVYTEVBVFZAVYTVYRWUBXCEXTZWDZVYSVVDWUJYAYBZVYSVWOWUDAVWOVYRV
        WQXCZWUEWDZUWRUWSZVUTFYCWOZWWEYBZXRZWVFVHZWRAWULVVPXEXFWVIVQWIZXGZVVAWQ
        WWOVDVFVXAWWOVVOWWNVFZBVVAXHVVABVVAVVOWWNVVPWVRXIWWPBVVAXJXKVVAWWOXLXMZ
        AWULWVFXEWWNXGZVVAWQWWRVDVFVXAWWRWVEWWNVFZBVVAXHVVABVVAWVEWWNWVFWWMXIWW
        SBVVAXJXKVVAWWRXLXMUWTAWVGWVAHUTAWVGBVVAVVOWVEWURUDZUSWVAABVVAVVOWVEWUR
        VVPWVFVDVXFVXFVXAWVQWWLAVVPWBAWVFWBUXAABVVAWWTWUTVYSVVNWVDULUDZIUNZWWTW
        UTVYSVXGWVOWVDVBVFWXBWWTUOAVXGVYRVXKXCWVPWWKVVNWVDVVRKULWURIVBVWIVWGULV
        VRXPUNUOVGVBVAVVRULVWFVWHUXBUXCVIWVLUXDYDVYSWXAEIVYSVVNWVCULUDZEULUDUBE
        ULUDWXAEVYSWXCUBEULVYSVUTDVVFULUDZFYEUDZUGUDZVUTUEEVVCULUDZULUDZUGUDZWX
        CUBVYSWXEWXHVUTUGVYSWXEWXDWWAWXDUCUDZYEUDWWAWXHVYSFWXJWXDYEVYSFWWADWWAD
        UFUDZUMUNZULUDZUCUDZWXJVYSFWWBWXNOVYSWWAWSVFDUXGVFWWBWXNUOVYSWWAWWFUXEV
        YSDWWHUXFWWADUXHWPYFVYSWXMWXDWWAUCVYSWXLVVFDULVYSWXKVVEUMVYSEVVDDVYSEWW
        EYGZVYSVVDWUJYHVYSDWWHYHVYSDWWHUXIUXJXOYIYIYJYIVYSWXDWWAVYSWXDVYSDVVFVY
        SVWODVBVFZWWGDXTWDZWUKYBZYGVYSWWAWWFYGUXKVYSEUEVVCWXOUEWHVFVYSUXQYLVYSV
        VCWUIYHUXLYKYIVYSWXFVUTWXDUGUDZWVCULUDZWXCVYSVYJVYKWXDVBVFFVBVFWXFWXTUO
        VYJVYSWLYLZVYKVYSVYLYLZWXRVYSFWWIUXRVUTWXDFUXMYMVYSWXSVVNWVCULVYSWXSVUT
        DUGUDZVVFUGUDZVVNVYSVYJVYKWXPWVNWXSWYDUOWYAWYBWXQWUKVUTDVVFUXNYMVYSWYCV
        UTVVFUGVYSWYCUBDUGUDZUIZVUTVYSUBWHVFZWUDUEDUPURZYNWYCWYFUOWYGVYSWMYLWWH
        VYSWYHUEDUOZAWYIYNVYRAUEDADUEADVPVWPWIVFZDUEWKLDVPUEUXOWDUXPUXSXCVYSUEU
        EUXTUNVFZVWOWYHWYIWNUEVBVFWYKUYAUEUYBVIWWGDUEUYCWOUYDUBDUYEYDVYSWYEUBVY
        SWXPWYEUBUOWXQDYOWDUYFYJYPYJYPYJVYSWXIVUTUEUGUDZWXGUGUDZUBVYSVUTUEWXGWY
        AVYSWXGAWUAWUGWXGWTVFVYRWUCWUHEVVCXDUYIZYQUEXSVFVYSUYGYLUYHVYSWYMUBWXGU
        GUDZUBWYLUBWXGUGWYLUBUEUGUDZUBWYGWYLWYPUOWMUBUYJVIUYKUYRUYLVYSWXGVBVFWY
        OUBUOVYSWXGWYNYAWXGYOWDYFYJYRYPVYSVVNWVCEVYSVVNWVPYGVYSWVCWWJYGWXOUYMVY
        SEWXOUYNYRXOYSUYOYJYIAWVHWUQVVQWURABCDEFGHIJKLMNOPQRSTUYPYIUYQAVXIVVQVX
        FVFWUSVVQUOVXJAVVAVXFVVPHVDWVIWVJWVKVWSVXAWVSWWQUYSVXFKWURWUQVVQVXLWVLW
        UQVHUYTWPAWVBVVAVUGUNZWUTHYTUNZUDZVURWUTWYRUDZVVKAVWLWULWUTVXFVFWVBWYSU
        OVWTVXAAVBVXFEIVXMAVYTWWCWUBWWDWDZXRVVAVXFWYRBHWUTWVJWYRVHZVUAYDAWYQVUR
        WUTWYRAVURXSVFZWYQVURUOAVURAWYJVURWTVFLDVUBWDYQZVURVUCWDYPAVUREVXOYTUNZ
        UDZIUNZWYTVVKAVXPXUCWWCXUGWYTUOVYAXUDXUAVBXUEWYRIVXOHVUREVBVVRVXOVXTVWI
        XQXUEVHZXUBVUDYDAXUFVUSIAVUREVXNYTUNZUDZXUFVUSAVYNXUCWWCXUJXUFUOVYNAVYP
        YLXUDXUAVBXUIXUEVXNVXOVUREXUIVHVYQXUHVUEYDAEWHVFXUCXUJVUSUOAEXUAYGXUDEV
        URVUFWPYSXOYSYKYRAVWAVVHIAVVTVVGVUTUGAVAVVSUTUDVVTVVGAVVAVBVVSVAVVRVDVX
        AVBVAVUHUNVFZVBVAWJUNVFAVWGXUKVGVBVAVUIVIVBVAVUJVOABVVAVVFVBVVSWUKWUPWR
        VWHVUKAVVAVVFBVXAVYSVVFWUKYGVULYSYIXOYRADXSVFVUSVBVFZVVHVBVFZVVMVVJWNAD
        WUFYQAWWCXUCXULXUAXUDEVURYCWPZAVVGVBVFXUMAVVAVVFBVXAWUKVUMVVGVTWDZVUSVV
        HIDKRTVUNYDVUPAWUDXULXUMVVIVVJWNWUFXUNXUOVUSVVHDVUOYDVUQ $.
    $}

    $( Eisenstein's lemma, an expression for ` ( P /L Q ) ` when ` P , Q ` are
       distinct odd primes.  (Contributed by Mario Carneiro, 18-Jun-2015.) $)
    lgseisen $p |- ( ph -> ( Q /L P ) =
        ( -u 1 ^ sum_ x e. ( 1 ... ( ( P - 1 ) / 2 ) )
          ( |_ ` ( ( Q / P ) x. ( 2 x. x ) ) ) ) ) $=
      ( co c1 c2 cexp cmo cmul cfv wcel wceq syl cr cle wbr clgs cmin cdiv cneg
      vy caddc cfz cv cfl csu cz cprime csn cdif eldifad lgsval3 syl2anc crp cn
      prmz prmnn oddprm nnnn0d nnexpcld 1re renegcli a1i cc0 wne ax-1cn ax-1ne0
      nnred negne0i fzfid wa nndivred adantr 2re elfznn adantl remulcl remulcld
      sylancr flcld fsumzcl reexpclzd nnrpd cmgp czrh cmpt lgseisenlem4 modadd1
      czn eqid syl221anc peano2re df-neg cabs cc neg1cn absexpz syl3anc absnegi
      clt abs1 eqtri oveq1i 1exp syl5eq eqtrd 1le1 syl6eqbr absle sylancl mpbid
      wb simpld syl5eqbrr 0re lesubaddd peano2rem simprd eldifsni prmuz2 eluzle
      df-2 cuz 3syl leltned mpbird ltaddsubd lelttrd modid syl22anc recnd pncan
      oveq1d ) ADCUAHZDCIUBHZJUCHZKHZIUFHCLHZIUBHZIUDZIYTUGHZDCUCHZJBUHZMHZMHZU
      INZBUJZKHZADUKOZCULJUMZUNOZYRUUCPADULOZUUMADULUUNFUOZDUTQEDCUPUQAUUCUULIU
      FHZIUBHZUULAUUBUURIUBAUUBUURCLHZUURAUUAROUULROZIROZCUROZUUACLHUULCLHPUUBU
      UTPAUUAADYTAUUPDUSOUUQDVAQZAYTAUUOYTUSOECVBQVCVDVLAUUDUUKUUDROAIVEVFVGUUD
      VHVIZAIVJVKVMVGZAUUEUUJBAIYTVNAUUGUUEOZVOZUUIUVHUUFUUHAUUFROUVGADCADUVDVL
      ACULOZCUSOACULUUNEUOZCVAQZVPVQUVHJROZUUGROUUHROVRUVHUUGUVGUUGUSOAUUGYTVSV
      TVLJUUGWAWCWBWDWEZWFZUVBAVEVGZACUVKWGZABUECDDUUHMHCLHZDJUEUHMHMHCLHZCWMNZ
      WHNZUVSWINZBUUEUUDUVQKHUVQMHCLHJUCHWJZUVSEFGUVQWNUWBWNUVRWNUVSWNUVTWNUWAW
      NWKUUAUULICWLWOAUURROZUVCVHUURSTZUURCXDTZUUTUURPAUVAUWCUVNUULWPQUVPAVHIUB
      HZUULSTUWDAUWFUUDUULSIWQAUUDUULSTZUULISTZAUULWRNZISTZUWGUWHVOZAUWIIISAUWI
      UUDWRNZUUKKHZIAUUDWSOZUVEUUKUKOZUWIUWMPUWNAWTVGUVFUVMUUDUUKXAXBAUWMIUUKKH
      ZIUWLIUUKKUWLIWRNIIVJXCXEXFXGAUWOUWPIPUVMUUKXHQXIXJXKXLAUVAUVBUWJUWKXPUVN
      VEUULIXMXNXOZXQXRAVHIUULVHROAXSVGUVOUVNXTXOAUWEUULYSXDTAUULIYSUVNUVOACROY
      SROACUVKVLZCYAQAUWGUWHUWQYBAIIUFHZCXDTIYSXDTAUWSJCXDYFAJCXDTCJVIZAUUOUWTE
      CULJYCQAJCUVLAVRVGUWRAUVICJYGNOJCSTUVJCYDJCYEYHYIYJXRAIICUVOUVOUWRYKXOYLA
      UULICUVNUVOUWRYKYJUURCYMYNXJYQAUULWSOIWSOUUSUULPAUULUVNYOVJUULIYPXNXJXJ
      $.

    $d x M $.  $d y S $.
    lgsquad.4 $e |- M = ( ( P - 1 ) / 2 ) $.
    lgsquad.5 $e |- N = ( ( Q - 1 ) / 2 ) $.
    lgsquad.6 $e |- S = { <. x , y >. |
  ( ( x e. ( 1 ... M ) /\ y e. ( 1 ... N ) ) /\ ( y x. P ) < ( x x. Q ) ) } $.
    $( Lemma for ~ lgsquad .  Count the members of ` S ` with odd coordinates.
       (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    lgsquadlem1 $p |- ( ph -> ( -u 1 ^
        sum_ u e. ( ( ( |_ ` ( M / 2 ) ) + 1 ) ... M )
          ( |_ ` ( ( Q / P ) x. ( 2 x. u ) ) ) ) =
        ( -u 1 ^ ( # ` { z e. S | -. 2 || ( 1st ` z ) } ) ) ) $=
      ( c2 co wbr wcel vv vn cneg cdiv cfl cfv caddc cfz cmul csu cexp cdivides
      c1 cv c1st wn crab chash cc neg1cn a1i cc0 wne ax-1cn ax-1ne0 fzfid wa cr
      cprime csn cn eldifi prmnn 3syl nnred adantr cz 2z elfzelz adantl sylancr
      zmulcl zred remulcld flcld fsumzcl cn0 cfn wss cxp syl2anc sylancl ssrab2
      clt ssfi hashcl syl nn0zd wceq oveq1i syl5eq oveq2d cmin wral elrab nncnd
      eqeq1d adantrr zcnd nncand eqtrd oveq1d 2cn 2ne0 wrex ad2antrr cuz mtbird
      wb ax-mp breq2d wi zsubcld syl3anc cle rehalfcld zltp1le mpbird syl112anc
      nnzd mpbid recnd pncan2d eqtr3d sub32d bitri nngt0d 3eqtrd eqbrtrd fznn
      negne0i cdif nndivred expclzd copab opabssxp eqsstri expcl expne0d recidd
      xpfi div1i negeqi divneg2 mp3an exprecd ciun wdisj fveq2 simprbi ad2antll
      eqtr3i divcan3d ralrimivva invdisj hashiun iunrab eldifsni necomd dvdsprm
      neneqd uzid adantlr npcand dvdsmul1 dvds2add mpan2d mtod breq2 syl5ibrcom
      notbid rexlimdva simpr sseldi xp1st odd2np1 oddprm syl5eqel reflcl simprl
      flle zre ad2antrl simprr eqeltrd elfzle2 2pos ltmuldiv2 2halvesd ltsub13d
      2re breqtrd lelttrd mul01i mulcl elfznn nnm1nn0 eqeltrrd nn0ge0d syl5eqbr
      zcn pncan 0re lemul2 subge02d peano2zd mpbir2and peano2cn subsub4d subdid
      elfz oveq2i peano2zm divcan2d eqtr2d 3eqtr3d 3eqtr3rd oveq2 eqeq2d rspcev
      rexlimdvaa sylbid impbid rabbidva fveq2d wrel relopabi relss relxp eleq2i
      mp2 cop opabid anass lesub mulcomd nnne0d divcan1d mul32d 3eqtr2d oveq12d
      nnre subdird 3eqtr4d resubcld ltmul1 ltsub13 3bitr2d zsubcl syl2an 3bitrd
      nnz fllt peano2rem 3bitr4d anbi2d 2nn nnmulcl 2timesd ltm1d ltdiv1 div32d
      ltled peano2re flltp1 elfzle1 ltletrd ltdivmul syl5eqbrr zlem1lt ledivmul
      lemuldiv div23d flge subled letr pm4.71rd bitr4d pm5.32da syl5bb syl6breq
      letrd lemuldiv2 posdifd elnnz sylanbrc oveq12i ltsub23d biantrurd anbi12d
      bitr3d vex op1std ancom opelxp elsn 3bitr4g eqrelrdv cen xpsnen2g hasheni
      anbi1i ltmul2 ltdivmul2 eqbrtrrd zltlem1 breqtrrd eluz2 syl3anbrc hashfz1
      uznn0sub sumeq2dv fsumsub pncan3d fsumconst nn0cnd mul12d zmulcld expmulz
      syl22anc sqneg sq1 eqtri 1exp expaddz mulcan2ad ) AUMUCZIQUDRZUEUFZUMUGRZ
      IUHRZGFUDRZQEUNZUIRZUIRZUEUFZEUJZUKRZVYQQDUNZUOUFZULSZUPZDHUQZURUFZUKRZWU
      OAVYQWUGVYQUSTZAUTVAZVYQVBVCZAUMVDVEUUAVAZAWUAWUFEAVYTIVFZAWUCWUATZVGZWUE
      WVBWUBWUDAWUBVHTWVAAGFAGAGVIQVJZUUBZTZGVITGVKTZLGVIWVCVLGVMVNZVOZAFWVDTZF
      VITZFVKTZKFVIWVCVLZFVMZVNZUUCVPZWVBWUDWVBQVQTZWUCVQTZWUDVQTZVRWVAWVQAWUCV
      YTIVSZVTZQWUCWBWAZWCZWDZWEZWFZUUDAWUPWUNWGTZWUOUSTUTAWUMWHTZWWFAHWHTZWUMH
      WIWWGAUMIUHRZUMJUHRZWJZWHTZHWWKWIWWHAWWIWHTWWJWHTWWLAUMIVFAUMJVFWWIWWJUUK
      WKHBUNZWWITZCUNZWWJTZVGZWWOFUIRZWWMGUIRZWNSZVGZBCUUEZWWKPWWTBCWWIWWJUUFUU
      GZWWKHWOWLZWULDHWMHWUMWOWLWUMWPWQZVYQWUNUUHWAZWXFAVYQWUNWUQWUSAWUNWXEWRZU
      UIZAWUOWUOUIRZVYQWUGWUNUGRZUKRZWUHWUOUIRZAWUOUMWUOUDRZUIRUMWXIWXKAWUOWXFW
      XHUUJAWUOWXMWUOUIAWUOUMVYQUDRZWUNUKRWXMVYQWXNWUNUKUMUMUDRZUCZVYQWXNWXOUMU
      MVDUULUUMUMUSTZWXQUMVBVCWXPWXNWSVDVDVEUMUMUUNUUOUVBWTAVYQWUNWUQWUSWXGUUPX
      AXBAWXKVYQQWUAURUFZJUIRZUIRZUKRZVYQQUKRZWXSUKRZUMAWXJWXTVYQUKAWXJWUGWUAQJ
      UIRZEUJZWUGXCRZUGRWYEWXTAWUNWYFWUGUGAWUAWYDWUFXCRZEUJZWUNWYFAEWUAWUJFWUDX
      CRZWSZDHUQZUUQZURUFWUAWYKURUFZEUJWUNWYHAEWUAWYKWUTWVBWWHWYKHWIZWYKWHTAWWH
      WVAWXDVPWYJDHWMZHWYKWOWLAFUAUNZUOUFZXCRZQUDRZWUCWSZUAWYKXDEWUAXDEWUAWYKUU
      RAWYTEUAWUAWYKAWVAWYPWYKTZVGVGZWYSWUDQUDRWUCXUBWYRWUDQUDXUBWYRFWYIXCRWUDX
      UBWYQWYIFXCXUAWYQWYIWSZAWVAXUAWYPHTXUCWYJXUCDWYPHWUIWYPWSWUJWYQWYIWUIWYPU
      OUUSXGXEUUTUVAXBXUBFWUDAWVAFUSTXUAWVBFAWVKWVAWVNVPZXFZXHAWVAWUDUSTXUAWVBW
      UDWWAXIZXHXJXKXLXUBWUCQAWVAWUCUSTXUAWVBWUCWVTXIXHQUSTZXUBXMVAQVBVCZXUBXNV
      AUVCXKUVDEUAWUAWYKWYSUVEWQUVFAWYLWUMURAWYLWYJEWUAXOZDHUQWUMWYJEDWUAHUVGAX
      UIWULDHAWUIHTZVGZXUIWULXUKWYJWULEWUAXUKWVAVGZWULWYJQWYIULSZUPXULXUMQWYIWU
      DUGRZULSZXULXUOQFULSZXULXUPQFWSZAXUQUPXUJWVAAQFAFQAWVIFQVCKFVIQUVHWQUVIUV
      KXPXULQQXQUFTZWVJXUPXUQXSWVPXURVRQUVLXTAWVJXUJWVAAWVIWVJKWVLWQZXPFQUVJWAX
      RXULXUNFQULXULFWUDXULFAWVKXUJWVAWVNXPZXFXULWUDAWVAWVRXUJWWAUVMZXIUVNYAXRX
      ULXUMQWUDULSZXUOXULWVPWVQXVBVRWVAWVQXUKWVSVTQWUCUVOWAXULWVPWYIVQTZWVRXUMX
      VBVGXUOYBWVPXULVRVAXULFWUDXULFXUTYJXVAYCXVAQWYIWUDUVPYDUVQUVRWYJWUKXUMWUJ
      WYIQULUVSUWAUVTUWBXUKWULQUBUNZUIRZUMUGRZWUJWSZUBVQXOZXUIXUKWUJWWITZWUJVQT
      WULXVHXSXUKWUIWWKTXVIXUKHWWKWUIWXCAXUJUWCUWDWUIWWIWWJUWEWQZWUJUMIVSUBWUJU
      WFVNXUKXVGXUIUBVQXUKXVDVQTZXVGVGZVGZIXVDXCRZWUATZWUJFQXVNUIRZXCRZWSZXUIXV
      MXVOVYTXVNYESZXVNIYESZXVMVYSXVNWNSZXVSXVMVYSVYRXVNXVMVYRVHTZVYSVHTZXVMIAI
      VHTZXUJXVLAIAIFUMXCRZQUDRZVKNAWVIXWFVKTKFUWGWQUWHZVOZXPZYFZVYRUWIZWQXWJXV
      MXVNXVMIXVDXVMIAIVKTZXUJXVLXWGXPYJZXUKXVKXVGUWJZYCZWCXVMXWBVYSVYRYESXWJVY
      RUWKWQXVMXVDIVYRXVKXVDVHTZXUKXVGXVDUWLUWMZXWIXWJXVMXVDVYRIVYRXCRZWNXVMXVE
      IWNSZXVDVYRWNSZXVMXWSXVFIYESZXVMXVFWWITZXXAXVMXVFWUJWWIXUKXVKXVGUWNZXUKXV
      IXVLXVJVPUWOZXVFUMIUWPWQXVMXVEVQTZIVQTZXWSXXAXSXVMWVPXVKXXEVRXWNQXVDWBWAX
      WMXVEIYGWKYHXVMXWPXWDQVHTZVBQWNSZXWSXWTXSXWQXWIXXGXVMUXAVAZXXHXVMUWQVAZXV
      DIQUWRYIYKXVMVYRVYRUGRZVYRXCRVYRXWRXVMVYRVYRXVMVYRXWJYLZXXLYMXVMXXKIVYRXC
      XVMIAIUSTZXUJXVLAIXWGXFZXPZUWSXLYNUXBUWTUXCXVMVYSVQTXVNVQTZXWAXVSXSXVMVYR
      XWJWEZXWOVYSXVNYGWKYKXVMVBXVDYESZXVTXVMXXRQVBUIRZXVEYESZXVMXXSVBXVEYEQXMU
      XDXVMXVEXVMXVFUMXCRZXVEWGXVMXVEUSTZWXQXYAXVEWSXVMXUGXVDUSTZXYBXMXVKXYCXUK
      XVGXVDUXKUWMZQXVDUXEWAZVDXVEUMUXLWLXVMXXBXVFVKTXYAWGTXXDXVFIUXFXVFUXGVNUX
      HUXIUXJXVMVBVHTZXWPXXGXXHXXRXXTXSXYFXVMUXMVAXWQXXIXXJVBXVDQUXNYIYHXVMIXVD
      XWIXWQUXOYKXVMXXPVYTVQTXXFXVOXVSXVTVGXSXWOXVMVYSXXQUXPXWMXVNVYTIUYAYDUXQX
      VMFFXVFXCRZXCRXVFXVQWUJXVMFXVFXVMFXVMWVJWVKAWVJXUJXVLXUSXPWVMWQXFZXVMXYBX
      VFUSTXYEXVEUXRWQXJXVMXYGXVPFXCXVMFXVEXCRUMXCRXWEXVEXCRZXYGXVPXVMFXVEUMXYH
      XYEWXQXVMVDVAZYOXVMFXVEUMXYHXYEXYJUXSXVMXVPQIUIRZXVEXCRXYIXVMQIXVDXUGXVMX
      MVAZXXOXYDUXTXVMXYKXWEXVEXCXVMXYKQXWFUIRXWEIXWFQUINUYBXVMXWEQXVMXWEXVMFVQ
      TZXWEVQTZAXYMXUJXVLAFWVNYJZXPFUYCZWQXIXYLXUHXVMXNVAUYDXAXLUYEUYFXBXXCUYGW
      YJXVREXVNWUAWUCXVNWSZWYIXVQWUJXYQWUDXVPFXCWUCXVNQUIUYHXBUYIUYJWKUYKUYLUYM
      UYNXAUYOAWUAWYMWYGEWVBWYMWYIVJZUMWYGUHRZWJZURUFZXYSURUFZWYGWVBWYKXYTURWVB
      BCWYKXYTWYNHUYPWYKUYPWYOWXABCHPUYQWYKHUYRVUAXYRXYSUYSWVBWWMWYIWSZWWMWWOVU
      BZHTZVGZYUCWWOXYSTZVGZYUDWYKTZYUDXYTTZWVBYUCYUEYUGYUEWXAWVBYUCVGZYUGYUEYU
      DWXBTWXAHWXBYUDPUYTWXABCVUCYPYUKWWOVKTZWWOJYESZVGZWWRWYIGUIRZWNSZVGZYULWW
      OWYGYESZVGZWXAYUGYUQYULYUMYUPVGZVGZYUKYUSYULYUMYUPVUDWVBYVAYUSXSYUCWVBYUL
      YUTYURWVBYULVGZYUTYUMYURVGYURYVBYUPYURYUMYVBWUFUMUGRZGWWOXCRZYESZWWOGYVCX
      CRZYESZYUPYURYVBYVCVHTZGVHTZWWOVHTZYVEYVGXSWVBYVHYULWVBYVCWVBWUFWWDUXPWCV
      PAYVIWVAYULWVHXPZYULYVJWVBWWOVULVTZYVCGWWOVUEYDYVBYUPWUEYVDWNSZWUFYVDWNSZ
      YVEYVBYUPWWRGWUEXCRZFUIRZWNSZWWOYVOWNSZYVMYVBYUOYVPWWRWNWVBYUOYVPWSYULWVB
      FGUIRZWUDGUIRZXCRGFUIRZWUEFUIRZXCRYUOYVPWVBYVSYWAYVTYWBXCWVBFGXUEWVBGAYVI
      WVAWVHVPZYLZVUFWVBYVTGWUDUIRZWUBFUIRZWUDUIRYWBWVBWUDGXUFYWDVUFWVBYWFGWUDU
      IWVBGFYWDXUEWVBFXUDVUGZVUHXLWVBWUBFWUDWVBWUBWVOYLXUEXUFVUIVUJVUKWVBFWUDGX
      UEXUFYWDVUMWVBGWUEFYWDWVBWUEWWCYLXUEVUMVUNVPYAYVBYVJYVOVHTFVHTZVBFWNSZYVR
      YVQXSYVLYVBGWUEYVKWVBWUEVHTZYULWWCVPZVUOYVBFWVBWVKYULXUDVPZVOYVBFYWLYQWWO
      YVOFVUPYIYVBYVJYVIYWJYVRYVMXSYVLYVKYWKWWOGWUEVUQYDVURYVBYWJYVDVQTZYVMYVNX
      SYWKWVBGVQTZWWOVQTYWMYULWVBGAWVFWVAWVGVPZYJZWWOVVBGWWOVUSVUTZWUEYVDVVCWKY
      VBWUFVQTZYWMYVNYVEXSWVBYWRYULWWDVPYWQWUFYVDYGWKVVAYVBWYGYVFWWOYEWVBWYGYVF
      WSYULWVBWYGGUMXCRZWUFXCRGWUFXCRUMXCRYVFWVBWYDYWSWUFXCWVBWYDQYWSQUDRZUIRYW
      SJYWTQUIOUYBWVBYWSQWVBYWSWVBYVIYWSVHTZYWCGVVDWQZYLXUGWVBXMVAZXUHWVBXNVAZU
      YDXAZXLWVBGUMWUFYWDWXQWVBVDVAZWVBWUFWWDXIZYOWVBGWUFUMYWDYXGYXFUXSYRVPYAVV
      EVVFYVBYURYUMYVBYURWYGJYESZYUMWVBYXHYULWVBWYDJWUFWVBWYDAWYDVKTZWVAAQVKTJV
      KTZYXIVVGAJYWTVKOAWVEYWTVKTLGUWGWQUWHZQJVVHWAZVPZVOWVBJAYXJWVAYXKVPVOZWVB
      WUFWWDWCWVBWYDJXCRZJWUFYEWVBYXOJJUGRZJXCRJWVBWYDYXPJXCWVBJAJUSTWVAAJYXKXF
      ZVPZVVIXLWVBJJYXRYXRYMXKWVBJWUEYESZJWUFYESZWVBJGQUDRZWUEYXNWVBGYWCYFZWWCW
      VBJYYAYXNYYBWVBJYWTYYAWNOWVBYWSGWNSZYWTYYAWNSZWVBGYWCVVJWVBYXAYVIXXGXXHYY
      CYYDXSYXBYWCXXGWVBUXAVAZXXHWVBUWQVAZYWSGQVVKYIYKUXJVVMWVBYYAYWEFUDRZWUEYE
      WVBYYAFUIRZYWEYESZYYAYYGYESZWVBYYHGFQUDRZUIRZYWEYEWVBGQFYWDYXCXUEYXDVVLWV
      BYYKWUDYESZYYLYWEYESZWVBYYMFQWUDUIRZYESZWVBYYPXWEYYOWNSZWVBXWFWUDWNSZYYQW
      VBXWFIWUDWNNWVBVYRWUCWNSZIWUDWNSZWVBVYRVYTWUCWVBIAXWDWVAXWHVPZYFZWVBXWBXW
      CVYTVHTUUUBXWKVYSVVNVNWVBWUCWVTWCZWVBXWBVYRVYTWNSUUUBVYRVVOWQWVAVYTWUCYES
      AWUCVYTIVVPVTVVQWVBXWDWUCVHTZXXGXXHYYSYYTXSUUUAUUUCYYEYYFIWUCQVVRYIYKZVVS
      WVBXWEVHTZWUDVHTZXXGXXHYYRYYQXSWVBYWHUUUFWVBFXUDVOZFVVDWQZWWBYYEYYFXWEWUD
      QVVRYIYKWVBXYMYYOVQTZYYPYYQXSAXYMWVAXYOVPZWVBWVPWVRUUUJVRWWAQWUDWBWAFYYOV
      VTWKYHWVBYWHUUUGXXGXXHYYMYYPXSUUUHWWBYYEYYFFWUDQVWAYIYHWVBYYKVHTUUUGYVIVB
      GWNSZYYMYYNXSWVBFUUUHYFWWBYWCWVBGYWOYQZYYKWUDGUXNYIYKYSWVBYYAVHTYWEVHTZYW
      HYWIYYIYYJXSYYBWVBGWUDYWCWWBWDZUUUHWVBFXUDYQZYYAYWEFVWBYIYKWVBGWUDFYWDXUF
      XUEYWGVWCZUXBVWLWVBYWJJVQTZYXSYXTXSWWCAUUURWVAAJYXKYJZVPWUEJVWDWKYKYSVWEV
      PYVBYVJWYGVHTJVHTYURYXHVGYUMYBYVLYVBWYGWVBWYGVQTZYULWVBWYDWUFWVBWYDYXMYJZ
      WWDYCZVPWCYVBJAYXJWVAYULYXKXPVOWWOWYGJVWFYDUVQVWGVWHVWIVPVWJYUKWWQYUNWWTY
      UPYUKWWPWWQYUNYUKWWNWWPYUKWWMWYIWWIWVBYUCUWCZWVBWYIWWITZYUCWVBUUVDWYIVKTZ
      WYIIYESZWVBXVCVBWYIWNSZUUVEWVBFWUDUUUKWWAYCZWVBWUDFWNSZUUVGWVBWUDXWEFWWBU
      UUIUUUHWVBWUDXWEYESZWUCXWFYESZWVBWUCIXWFYEWVAWUCIYESAWUCVYTIUWPVTNVWKWVBU
      UUDUUUFXXGXXHUUVJUUVKXSUUUCUUUIYYEYYFWUCXWEQVWMYIYHWVBFUUUHVVJUXCZWVBWUDF
      WWBUUUHVWNYKWYIVWOVWPWVBUUVFWYIUMXCRZIWNSZWVBUUVMXWEWUDXCRIWNWVBFWUDUMXUE
      XUFYXFYOWVBXWEIWUDUUUIUUUAWWBWVBXWEIXCRZIWUDWNWVBIIUGRZIXCRUUVOIWVBUUVPXW
      EIXCWVBUUVPXWFXWFUGRXWEIXWFIXWFUGNNVWQWVBXWEWVBXWEWVBXYMXYNWVBFXUDYJXYPWQ
      XIUWSXAXLWVBIIAXXMWVAXXNVPZUUVQYMYNUUUEYSVWRYSWVBXVCXXFUUVFUUVNXSUUVHWVBI
      AXWLWVAXWGVPYJZWYIIVVTWKYHWVBXXFUUVDUUVEUUVFVGXSUUVRWYIIYTWQUXQVPUWOVWSYU
      KUUURWWPYUNXSAUUURWVAYUCUUUSXPWWOJYTWQVXAYUKWWSYUOWWRWNYUKWWMWYIGUIUUVCXL
      YAVWTYUKUUUTYUGYUSXSWVBUUUTYUCUUVBVPWWOWYGYTWQVVEVWJVWIYUIYUEYUCVGYUFWYJY
      UCDYUDHWUIYUDWSWUJWWMWYIWWMWWOWUIBVXBCVXBVXCXGXEYUEYUCVXDYPYUJWWMXYRTZYUG
      VGYUHWWMWWOXYRXYSVXEUUVSYUCYUGBWYIVXFVXLYPVXGVXHUYOWVBXYTXYSVXISZYUAYUBWS
      WVBXVCXYSWHTUUVTUUVHWVBUMWYGVFWYIXYSVQWHVXJWKXYTXYSVXKWQWVBWYDWUFXQUFTZWY
      GWGTYUBWYGWSWVBYWRWYDVQTWUFWYDYESUUWAWWDUUVAWVBWUFYWSWYDYEWVBWUFGWNSZWUFY
      WSYESZWVBWUEGWNSZUUWBWVBYYGWUEGWNUUUQWVBYYGGWNSZYWEYWAWNSZWVBUUVIUUWFUUVL
      WVBUUUGYWHYVIUUULUUVIUUWFXSWWBUUUHYWCUUUMWUDFGVXMYIYKWVBUUUNYVIYWHYWIUUWE
      UUWFXSUUUOYWCUUUHUUUPYWEGFVXNYIYHVXOWVBYWJYWNUUWDUUWBXSWWCYWPWUEGVVCWKYKW
      VBYWRYWNUUWBUUWCXSWWDYWPWUFGVXPWKYKYXEVXQWUFWYDVXRVXSWUFWYDVYAWYGVXTVNYRV
      YBUYGAWUAWYDWUFEWUTAWYDUSTZWVAAWYDYXLXFZVPYXGVYCYNXBAWUGWYEAWUGWWEXIAWYEA
      WUAWYDEWUTUUVAWFXIVYDAWYEWXRWYDUIRZWXTAWUAWHTZUUWGWYEUUWIWSWUTUUWHWUAWYDE
      VYEWKAWXRQJAWXRAUUWJWXRWGTWUTWUAWPWQZVYFXUGAXMVAYXQVYGXKYRXBAWUPWURWVPWXS
      VQTZWYAWYCWSWUQWUSWVPAVRVAAWXRJAWXRUUWKWRUUUSVYHZVYQQWXSVYIVYJAWYCUMWXSUK
      RZUMWYBUMWXSUKWYBUMQUKRZUMWXQWYBUUWOWSVDUMVYKXTVYLVYMWTAUUWLUUWNUMWSUUWMW
      XSVYNWQXAYRVUNAWUPWURWUGVQTWUNVQTWXKWXLWSWUQWUSWWEWXGVYQWUGWUNVYOVYJUYEVY
      P $.

    $( Lemma for ~ lgsquad .  Count the members of ` S ` with even coordinates,
       and combine with ~ lgsquadlem1 to get the total count of lattice points
       in ` S ` (up to parity).  (Contributed by Mario Carneiro,
       18-Jun-2015.) $)
    lgsquadlem2 $p |- ( ph -> ( Q /L P ) = ( -u 1 ^ ( # ` S ) ) ) $=
      ( co c1 c2 clt wbr wcel vu vz vv cmin cdiv cfz cv cmul cfl cfv cexp caddc
      csu chash oveq2i cin c0 cn cprime csn oddprm syl syl5eqel nnred rehalfcld
      flcld cc0 wo cun cn0 cle cr nnrpd rpge0d flge0nn0 syl2anc crp rphalflt cz
      wceq wb nnzd mpbid syl6eleq syl6eq oveq1 0p1e1 oveq1d fzfid eldifad prmnn
      cuz wa adantr elfznn adantl sylancr remulcld oveq2d c1st cdivides crab wn
      cc a1i syl5sseqr sselda syldan fsumnn0cl expaddd cfn wss cxp ssfi sylancl
      ssrab2 hashcl wrel bitri wne simpr ad2antrr nnmulcld elfzle2 elfzelz flge
      mpbird 2re 2pos syl112anc peano2rem syl5eqbr wi syl3anc mpan2d nngt0d 2cn
      nncnd wral wrex clgs cneg sumeq1i cdif zred ltp1d fzdisj rphalfcld nnnn0d
      lgseisen fllt ltled elfz2nn0 syl3anbrc nn0uz elfzp12 oveq2 fz10 un0 uncom
      uneq12d eqtr3i syl6reqr fzsplit oveq1i jaoi nndivred 2nn nnmulcl rpdivcld
      eleq2s rpmulcld nn0cnd fsumsplit syl5eqr neg1cn ssun2 ssun1 xpfi opabssxp
      copab eqsstri cen xpsnen2g hasheni relopabi relss mp2 relxp eleq2i opabid
      ciun anass ltlend lemuldiv2 ltm1d ltdiv1 lelttrd lttrd ltnled prmz dvdsle
      cop mtod cgcd prmrp coprmdvds dvdsmul2 breq2 syl5ibrcom necon3bd biantrud
      nnz mpd bitr4d nnre lemuldiv nnne0d div23d breq2d 3bitrd ltmul2 w3a div23
      2ne0 divass eqtr3d breqtrd ltmul1 sylibrd recnd divsubdird syl6eqr ax-1cn
      nncan halflt1 syl6eqbr eqbrtrrd 1re ltsubadd2d peano2re nnleltp1 pm4.71rd
      lttr syld syl2an 3bitr3d pm5.32da syl5bb nnuz elfz5 biantrurd fznn bitr3d
      eqeltrd mulcomd sylan9eqr anbi12d 3bitr4d op1std eqeq2d eqcom elrab ancom
      syl6bb opelxp elsn anbi1i 3bitr4g eqrelrdv eqcomd fveq2d hashfz1 3eqtr3rd
      sumeq2dv wdisj fveq2 simprbi ad2antll adantrr divcan3d ralrimivva invdisj
      vex hashiun iunrab zcn mulcom eqeq1d rexbidva anim1i reximi2 simprr xp1st
      sseldi eqbrtrd zre ad2antrl simprl mul01i 0re elnnz sylanbrc jca reximdv2
      ex impbid2 divides rabbidva syl5eq 3eqtr2d lgsquadlem1 eqtr4d unrab exmid
      2z oveq12d rgenw rabid2 mpbir eqtr4i fveq2i inrab pm3.24 ralrimivw rabeq0
      sylibr hashun syl5reqr 3eqtrd ) AEDUUAOPUUBZPDPUDOZQUEOZUFOZEDUEOZQUAUGZU
      HOZUHOZUIUJZUAUMZUKOVYKPGQUEOZUIUJZUFOZVYSUAUMZWUBPULOZGUFOZVYSUAUMZULOZU
      KOZVYKFUNUJZUKOZAUADEIJKUUJAVYTWUHVYKUKAVYTPGUFOZVYSUAUMWUHWULVYNVYSUAGVY
      MPUFLUOUUCAWUCWUFVYSWULUAAWUBWUERSWUCWUFUPUQVTAWUBAWUBAWUAAGAGAGVYMURLADU
      SQUTZUUDZTVYMURTIDVAVBVCZVDZVEZVFZUUEZUUFPWUBWUEGUUGVBAWUBVGVTZWUBVGPULOZ
      GUFOZTZVHZWULWUCWUFVIZVTZAWUBVGGUFOTZWVDAWUBVJTZGVJTWUBGVKSWVGAWUAVLTZVGW
      UAVKSWVHWUQAWUAAGAGWUOVMZUUHVNWUAVOVPAGWUOUUIZAWUBGWUSWUPAWUAGRSZWUBGRSZA
      GVQTWVLWVJGVRVBAWVIGVSTZWVLWVMWAWUQAGWUOWBZWUAGUUKVPWCUULWUBGUUMUUNAGVGWL
      UJZTWVGWVDWAAGVJWVPWVKUUOWDWUBVGGUUPVBWCWUTWVFWVCWUTWVEUQWULVIZWULWUTWUCU
      QWUFWULWUTWUCPVGUFOUQWUBVGPUFUUQUURWEWUTWUEPGUFWUTWUEWVAPWUBVGPULWFWGWEWH
      UVAWULUQVIWULWVQWULUUSWULUQUUTUVBUVCWVFWUBWULWVBWUBPGUVDWVAPGUFWGUVEUVKUV
      FVBZAPGWIZAVYPWULTZWMZVYSWWAVYRVLTZVGVYRVKSVYSVJTZWWAVYOVYQAVYOVLTWVTAEDA
      EAEUSTZEURTZAEUSWUMJWJZEWKVBZVDADUSTZDURTZADUSWUMIWJZDWKVBZUVGWNWWAVYQWWA
      QURTVYPURTZVYQURTZUVHWVTWWLAVYPGWOWPQVYPUVIWQZVDWRZWWAVYRWWAVYOVYQAVYOVQT
      WVTAEDAEWWGVMADWWKVMUVJWNWWAVYQWWNVMUVLVNVYRVOVPZUVMUVNUVOWSAWUIVYKWUDUKO
      ZVYKWUGUKOZUHOZVYKQUBUGZWTUJZXASZUBFXBZUNUJZWXBXCZUBFXBZUNUJZULOZUKOZWUKA
      VYKWUDWUGVYKXDTAUVPXEZAWUFVYSUAAWUEGWIAVYPWUFTWVTWWCAWUFWULVYPAWVEWUFWULW
      UFWUCUVQWVRXFXGWWPXHXIAWUCVYSUAAPWUBWIZAVYPWUCTZWVTWWCAWUCWULVYPAWVEWUCWU
      LWUCWUFUVRWVRXFXGZWWPXHZXIXJAWXIVYKWXDUKOZVYKWXGUKOZUHOWWSAVYKWXDWXGWXJAW
      XFXKTZWXGVJTAFXKTZWXFFXLWXQAWULPHUFOZXMZXKTZFWXTXLWXRAWULXKTWXSXKTWYAWVSA
      PHWIWULWXSUVSVPFBUGZWULTZCUGZWXSTZWMZWYDDUHOZWYBEUHOZRSZWMZBCUWAZWXTNWYIB
      CWULWXSUVTUWBZWXTFXNXOZWXEUBFXPFWXFXNXOZWXFXQVBAWXCXKTZWXDVJTAWXRWXCFXLWY
      OWYMWXBUBFXPFWXCXNXOZWXCXQVBXJAWWQWXOWWRWXPUHAWUDWXDVYKUKAWUDWUCVYQWXAVTZ
      UBFXBZUNUJZUAUMUAWUCWYRUWLZUNUJWXDAWUCVYSWYSUAAWXLWMZVYQUTZPVYSUFOZXMZUNU
      JZXUCUNUJZWYSVYSXUAXUDXUCUWCSZXUEXUFVTXUAWWMXUCXKTXUGAWXLWVTWWMWXMWWNXHZX
      UAPVYSWIVYQXUCURXKUWDVPXUDXUCUWEVBXUAXUDWYRUNXUAWYRXUDXUABCWYRXUDWYRFXLZF
      XRWYRXRWYQUBFXPZWYJBCFNUWFWYRFUWGUWHXUBXUCUWIXUAWYBVYQVTZWYBWYDUXCZFTZWMZ
      XUKWYDXUCTZWMZXULWYRTZXULXUDTZXUAXUKXUMXUOXUMWYJXUAXUKWMZXUOXUMXULWYKTWYJ
      FWYKXULNUWJWYJBCUWKXSXUSWYDURTZWYDHVKSZWMZWYGEVYQUHOZRSZWMZXUTWYDVYSVKSZW
      MZWYJXUOXUAXVEXVGWAXUKXVEXUTXVAXVDWMZWMXUAXVGXUTXVAXVDUWMXUAXUTXVHXVFXUAX
      UTWMZXVDWYDVYRVKSZXVHXVFXVIXVDWYGXVCVKSZWYDXVCDUEOZVKSZXVJXVIXVDXVKXVCWYG
      XTZWMXVKXVIWYGXVCXVIWYGXVIWYDDXUAXUTYAZAWWIWXLXUTWWKYBZYCVDZXVIXVCXUAXVCU
      RTXUTXUAEVYQAWWEWXLWWGWNZXUHYCWNVDZUWNXVIXVNXVKXVIDXVCXASZXCXVNXVIXVTDVYQ
      XASZXVIXWADVYQVKSZXVIVYQDRSXWBXCXVIVYQDQUEOZDXVIVYQXUAWWMXUTXUHWNZVDZXVID
      XVIDXVPVDZVEZXWFXVIVYQGXWCXWEXUAGVLTZXUTAXWHWXLWUPWNZWNXWGXUAVYQGVKSZXUTX
      UAXWJVYPWUAVKSZXUAXWKVYPWUBVKSZWXLXWLAVYPPWUBYDWPXUAWVIVYPVSTZXWKXWLWAZXU
      AGXWIVEWXLXWMAVYPPWUBYEZWPWUAVYPYFZVPYGXUAVYPVLTZXWHQVLTZVGQRSZXWJXWKWAZX
      UAVYPWXLWWLAVYPWUBWOWPZVDXWIXWRXUAYHXEXWSXUAYIXEVYPGQUWOZYJYGZWNXVIGVYMXW
      CRLXVIVYLDRSZVYMXWCRSZXVIDXWFUWPXVIVYLVLTZDVLTZXWRXWSXXDXXEWAXVIXXGXXFXWF
      DYKVBXWFXWRXVIYHXEXWSXVIYIXEVYLDQUWQYJWCYLUWRZXVIDVQTXWCDRSXVIDXVPVMDVRVB
      UWSXVIVYQDXWEXWFUWTWCXVIDVSTZWWMXWAXWBYMXVIWWHXXIAWWHWXLXUTWWJYBDUXAVBZXW
      DDVYQUXBVPUXDXVIXVTDEUXEOPVTZXWAAXXKWXLXUTAXXKDEXTZKAWWHWWDXXKXXLWAWWJWWF
      DEUXFVPYGYBXVIXXIEVSTZVYQVSTXVTXXKWMXWAYMXXJXVIWWDXXMAWWDWXLXUTWWFYBEUXAV
      BXVIVYQXWDWBDEVYQUXGYNYOUXDXVIXVTXVCWYGXVIXVTXVCWYGVTDWYGXASZXVIWYDVSTZXX
      IXXNXUTXXOXUAWYDUXMZWPXXJWYDDUXHVPXVCWYGDXAUXIUXJUXKUXNUXLUXOXVIWYDVLTZXV
      CVLTZXXGVGDRSZXVKXVMWAXUTXXQXUAWYDUXPWPZXVSXWFXVIDXVPYPZWYDXVCDUXQYJXVIXV
      LVYRWYDVKXVIEVYQDXVIEXUAWWEXUTXVRWNZYRZXVIVYQXWDYRXVIDXVPYRZXVIDXVPUXRUXS
      UXTUYAXVIXVDXVAXVIXVDWYDHPULOZRSZXVAXVIXVDWYDEQUEOZRSZXYFXVIXVDWYGXYGDUHO
      ZRSZXYHXVIXVDXVCXYIRSZXYJXVIXVCEXWCUHOZXYIRXVIVYQXWCRSZXVCXYLRSZXXHXVIVYQ
      VLTXWCVLTEVLTZVGERSXYMXYNWAXWEXWGXVIEXYBVDZXVIEXYBYPVYQXWCEUYBYJWCXVIEXDT
      ZDXDTZQXDTZQVGXTZXYLXYIVTXYCXYDXYSXVIYQXEZXYTXVIUYEXEZXYQXYRXYSXYTWMUYCED
      UHOQUEOXYLXYIEDQUYFEDQUYDUYGYJUYHXVIWYGVLTXXRXYIVLTXVDXYKWMXYJYMXVQXVSXVI
      XYGDXVIEXYPVEZXWFWRWYGXVCXYIVUDYNYOXVIXXQXYGVLTZXXGXXSXYHXYJWAXXTYUCXWFXY
      AWYDXYGDUYIYJUYJXVIXYHXYGXYERSZXYFXVIXYGHUDOZPRSYUEXVIEEPUDOZUDOZQUEOZYUF
      PRXVIYUIXYGYUGQUEOZUDOYUFXVIEYUGQXYCXVIYUGXVIXYOYUGVLTXYPEYKVBUYKYUAYUBUY
      LHYUJXYGUDMUOUYMXVIYUIPQUEOPRXVIYUHPQUEXVIXYQPXDTYUHPVTXYCUYNEPUYOXOWHUYP
      UYQUYRXVIXYGHPYUCXVIHAHURTZWXLXUTAHYUJURMAEWUNTYUJURTJEVAVBVCZYBZVDZPVLTX
      VIUYSXEUYTWCXVIXXQYUDXYEVLTZXYHYUEWMXYFYMXXTYUCXVIHVLTYUOYUNHVUAVBWYDXYGX
      YEVUDYNYOVUEXVIXUTYUKXVAXYFWAXVOYUMWYDHVUBVPUYJVUCXUAWWBXXOXVJXVFWAXUTAWX
      LWVTWWBWXMWWOXHZXXPVYRWYDYFVUFVUGVUHVUIWNXUSWYFXVBWYIXVDXUSWYEWYFXVBXUSWY
      CWYEXUSWYBVYQWULXUAXUKYAXUAVYQWULTZXUKXUAYUQXWJXXCXUAVYQPWLUJZTWVNYUQXWJW
      AXUAVYQURYURXUHVUJWDAWVNWXLWVOWNVYQPGVUKVPYGWNVUOVULXUSHVSTZWYEXVBWAAYUSW
      XLXUKAHYULWBYBWYDHVUMVBVUNXUSWYHXVCWYGRXUKXUAWYHVYQEUHOXVCWYBVYQEUHWFXUAV
      YQEXUAVYQXUHYRXUAEXVRYRVUPVUQUXTVURXUAXUOXVGWAZXUKXUAVYSVSTYUTXUAVYRYUPVF
      WYDVYSVUMVBWNVUSVUIVUHXUQXUMXUKWMXUNWYQXUKUBXULFWWTXULVTZWYQVYQWYBVTXUKYV
      AWXAWYBVYQWYBWYDWWTBVWDCVWDVUTVVAVYQWYBVVBVVEVVCXUMXUKVVDXSXURWYBXUBTZXUO
      WMXUPWYBWYDXUBXUCVVFYVBXUKXUOBVYQVVGVVHXSVVIVVJVVKVVLXUAWWCXUFVYSVTWXNVYS
      VVMVBVVNVVOAUAWUCWYRWXKXUAWXRXUIWYRXKTAWXRWXLWYMWNXUJFWYRXNXOAUCUGZWTUJZQ
      UEOZVYPVTZUCWYRYSUAWUCYSUAWUCWYRVVPAYVFUAUCWUCWYRAWXLYVCWYRTZWMWMZVYQQUEO
      YVEVYPYVHVYQYVDQUEYVGVYQYVDVTZAWXLYVGYVCFTYVIWYQYVIUBYVCFWWTYVCVTWXAYVDVY
      QWWTYVCWTVVQVVAVVCVVRVVSWHYVHVYPQAWXLVYPXDTZYVGXUAVYPXXAYRVVTXYSYVHYQXEXY
      TYVHUYEXEVWAUYGVWBUAUCWUCWYRYVEVWCVBVWEAWYTWXCUNAWYTWYQUAWUCYTZUBFXBWXCWY
      QUAUBWUCFVWFAYVKWXBUBFAWWTFTZWMZWYQUAVSYTZVYPQUHOZWXAVTZUAVSYTZYVKWXBYVMW
      YQYVPUAVSYVMXWMWMZVYQYVOWXAYVRXYSYVJVYQYVOVTYQXWMYVJYVMVYPVWGWPQVYPVWHWQV
      WIVWJYVMYVKYVNWYQWYQUAWUCVSWXLXWMWYQXWOVWKVWLYVMWYQWYQUAVSWUCYVMXWMWYQWMZ
      WXLWYQWMYVMYVSWMZWXLWYQYVTWXLXWLYVTXWKXWLYVTXWJXWKYVTVYQWXAGVKYVMXWMWYQVW
      MZYVTWXAWULTZWXAGVKSYVMYWBYVSYVMWWTWXTTYWBYVMFWXTWWTWYLAYVLYAVWOWWTWULWXS
      VWNVBZWNZWXAPGYDVBVWPYVTXWQXWHXWRXWSXWTXWMXWQYVMWYQVYPVWQVWRZAXWHYVLYVSWU
      PYBXWRYVTYHXEZXWSYVTYIXEZXXBYJWCYVTWVIXWMXWNAWVIYVLYVSWUQYBYVMXWMWYQVWSZX
      WPVPWCYVTVYPYURTWUBVSTZWXLXWLWAYVTVYPURYURYVTXWMVGVYPRSZWWLYWHYVTYWJQVGUH
      OZVYQRSZYVTYWKVGVYQRQYQVWTYVTVYQYVTVYQWXAURYWAYVTYWBWXAURTYWDWXAGWOVBVUOY
      PYLYVTVGVLTZXWQXWRXWSYWJYWLWAYWMYVTVXAXEYWEYWFYWGVGVYPQUYBYJYGVYPVXBVXCVU
      JWDAYWIYVLYVSWURYBVYPPWUBVUKVPYGYWAVXDVXFVXEVXGYVMQVSTWXAVSTZWXBYVQWAVXPY
      VMYWBYWNYWCWXAPGYEVBUAQWXAVXHWQVUSVXIVXJVVLVXKWSABCUBUADEFGHIJKLMNVXLVXQV
      XMAWXHWUJVYKUKAWUJWXCWXFVIZUNUJZWXHYWOFUNYWOWXBWXEVHZUBFXBZFWXBWXEUBFVXNF
      YWRVTYWQUBFYSYWQUBFWXBVXOVXRYWQUBFVXSVXTVYAVYBAWYOWXQWXCWXFUPZUQVTYWPWXHV
      TWYPWYNAYWSWXBWXEWMZUBFXBZUQWXBWXEUBFVYCAYWTXCZUBFYSYXAUQVTAYXBUBFYXBAWXB
      VYDXEVYEYWTUBFVYFVYGVXJWXCWXFVYHYNVYIWSVXKVYJ $.

    $( Lemma for ~ lgsquad .  (Contributed by Mario Carneiro, 18-Jun-2015.) $)
    lgsquadlem3 $p |- ( ph ->
      ( ( P /L Q ) x. ( Q /L P ) ) = ( -u 1 ^ ( M x. N ) ) ) $=
      ( co cmul c1 wcel wa syl vw vz clgs cneg cfz clt wbr copab chash cfv cexp
      cv caddc necomd weq wb eleq1 bi2anan9 ancom syl6bb oveq1 breqan12d ancoms
      anbi12d cbvopabv lgsquadlem2 cen wceq ccnv wrel cfn relopab cxp wss fzfid
      xpfi syl2anc opabssxp ssfi sylancl cnven sylancr cnvopab syl6breq hasheni
      oveq2d eqtr4d oveq12d cc neg1cn a1i cn0 eqsstri hashcl expaddd cun wo wne
      cdivides wn cn cmin cprime c2 csn eldifad adantr prmnn cuz cz cdiv oddprm
      cle cdif syl5eqel nnzd prmz peano2zm zred crp wi elfzelz ad2antll syl3anc
      nnred nncnd elfznn ad2antrl nnmulcld ex opabbii 3eqtr4i c0 cr sylib nexdv
      cin wex nnnn0d hashfz1 prmuz2 uz2m1nn nnrpd rphalflt syl5eqbr ltled eluz2
      syl3anbrc fzss2 simprr sseldd fzm1ndvds cgcd mpbird coprmdvds mpan2d mtod
      prmrp mulcomd breq2d mtbid dvdsmul2 breq2 syl5ibcom necon3bd mpd pm4.71rd
      lttri2d mpbid syl6rbb opabbidv unopab uneq2i 3eqtr4g fveq2d inopab ineq2i
      df-xp anandi ltnsym2 imnan opabn0 necon1bbii syl5eq hashun hashxp 3eqtr3d
      andi eqtrd 3eqtr2d ) ADEUCOZEDUCOZPOQUDZBULZQGUEOZRZCULZQHUEOZRZSZUWNEPOZ
      UWQDPOZUFUGZSZBCUHZUIUJZUKOZUWMFUIUJZUKOZPOUWMUXFUXHUMOZUKOUWMGHPOZUKOAUW
      KUXGUWLUXIPAUWKUWMUXDCBUHZUIUJZUKOUXGAUAUBEDUXLHGJIADEKUNZMLUXDUAULZUWRRZ
      UBULZUWORZSZUXQEPOZUXODPOZUFUGZSZCBUAUBBUBUOZCUAUOZUXDUYCUPUYDUYESZUWTUXS
      UXCUYBUYFUWTUXRUXPSUXSUYDUWPUXRUYEUWSUXPUWNUXQUWOUQUWQUXOUWRUQURUXRUXPUSU
      TUYDUYEUXAUXTUXBUYAUFUWNUXQEPVAUWQUXODPVAVBVDVCVEVFAUXFUXMUWMUKAUXEUXLVGU
      GUXFUXMVHAUXEUXEVIZUXLVGAUXEVJUXEVKRZUXEUYGVGUGUXDBCVLAUWOUWRVMZVKRZUXEUY
      IVNUYHAUWOVKRZUWRVKRZUYJAQGVOZAQHVOZUWOUWRVPVQZUXCBCUWOUWRVRUYIUXEVSVTZUX
      EVKWAWBUXDBCWCWDUXEUXLWETWFWGABCDEFGHIJKLMNVFWHAUWMUXFUXHUWMWIRAWJWKAFVKR
      ZUXHWLRAUYJFUYIVNUYQUYOFUWTUXBUXAUFUGZSZBCUHZUYINUYRBCUWOUWRVRWMUYIFVSVTZ
      FWNTAUYHUXFWLRUYPUXEWNTWOAUXJUXKUWMUKAUXEFWPZUIUJZUYIUIUJZUXJUXKAVUBUYIUI
      AUWTUXCUYRWQZSZBCUHZUWTBCUHVUBUYIAVUFUWTBCAUWTVUEUWTSVUFAUWTVUEAUWTVUEAUW
      TSZUXAUXBWRZVUEVUHEUXBWSUGZWTVUIVUHEDUWQPOZWSUGZVUJVUHVULEUWQWSUGZVUHEXAR
      ZUWQQEQXBOZUEOZRVUMWTVUHEXCRZVUNAVUQUWTAEXCXDXEZJXFXGZEXHTZVUHUWRVUPUWQVU
      HVUOHXIUJRZUWRVUPVNVUHHXJRVUOXJRZHVUOXMUGVVAVUHHAHXARUWTAHVUOXDXKOZXAMAEX
      CVURXNZRVVCXARJEXLTXOZXGZXPVUHEXJRZVVBVUHVUQVVGVUSEXQTZEXRTZVUHHVUOVUHHVV
      FYEVUHVUOVVIXSVUHHVVCVUOUFMVUHVUOXTRVVCVUOUFUGVUHVUOVUHEXDXIUJRZVUOXARVUH
      VUQVVJVUSEUUATEUUBTUUCVUOUUDTUUEUUFHVUOUUGUUHHQVUOUUITAUWPUWSUUJUUKEUWQUU
      LVQVUHVULEDUUMOQVHZVUMVUHVVKEDWRZAVVLUWTUXNXGVUHVUQDXCRZVVKVVLUPVUSAVVMUW
      TADXCVURIXFXGZEDUURVQUUNVUHVVGDXJRZUWQXJRZVULVVKSVUMYAVVHVUHVVMVVOVVNDXQT
      UWSVVPAUWPUWQQHYBYCEDUWQUUOYDUUPUUQVUHVUKUXBEWSVUHDUWQVUHDVUHVVMDXARVVNDX
      HTZYFVUHUWQUWSUWQXARAUWPUWQHYGYCZYFUUSUUTUVAVUHVUJUXAUXBVUHEUXAWSUGZUXAUX
      BVHVUJVUHUWNXJRZVVGVVSUWPVVTAUWSUWNQGYBYHVVHUWNEUVBVQUXAUXBEWSUVCUVDUVEUV
      FVUHUXAUXBVUHUXAVUHUWNEUWPUWNXARAUWSUWNGYGYHVUTYIYEZVUHUXBVUHUWQDVVRVVQYI
      YEZUVHUVIYJUVGVUEUWTUSUVJUVKUXEUYTWPUXDUYSWQZBCUHVUBVUGUXDUYSBCUVLFUYTUXE
      NUVMVUFVWCBCUWTUXCUYRUWHYKYLBCUWOUWRUVRUVNUVOAUYHUYQUXEFYQZYMVHVUCUXJVHUY
      PVUAAVWDUWTUXCUYRSZSZBCUHZYMUXEUYTYQUXDUYSSZBCUHVWDVWGUXDUYSBCUVPFUYTUXEN
      UVQVWFVWHBCUWTUXCUYRUVSYKYLAVWFCYRZBYRZWTVWGYMVHAVWIBAVWFCAUWTVWEWTZYAVWF
      WTAUWTVWKVUHUXAYNRUXBYNRVWKVWAVWBUXAUXBUVTVQYJUWTVWEUWAYOYPYPVWJVWGYMVWFB
      CUWBUWCYOUWDUXEFUWEYDAVUDUWOUIUJZUWRUIUJZPOZUXKAUYKUYLVUDVWNVHUYMUYNUWOUW
      RUWFVQAVWLGVWMHPAGWLRVWLGVHAGAGDQXBOXDXKOZXALADVVDRVWOXARIDXLTXOYSGYTTAHW
      LRVWMHVHAHVVEYSHYTTWHUWIUWGWFUWJ $.
  $}

  ${
    $d w x y z P $.  $d w x y z Q $.
    $( The Law of Quadratic Reciprocity.  If ` P ` and ` Q ` are distinct odd
       primes, then the product of the Legendre symbols ` ( P /L Q ) ` and
       ` ( Q /L P ) ` is the parity of
       ` ( ( P - 1 ) / 2 ) x. ( ( Q - 1 ) / 2 ) ` .  This uses Eisenstein's
       proof, which also has a nice geometric interpretation - see
       ~ https://en.wikipedia.org/wiki/Proofs_of_quadratic_reciprocity .
       (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    lgsquad $p |- ( ( P e. ( Prime \ { 2 } ) /\ Q e. ( Prime \ { 2 } )
      /\ P =/= Q ) -> ( ( P /L Q ) x. ( Q /L P ) ) =
        ( -u 1 ^ ( ( ( P - 1 ) / 2 ) x. ( ( Q - 1 ) / 2 ) ) ) ) $=
      ( vz vw vx vy c2 wcel cv c1 cmin co cdiv cfz wa cmul clt wbr eqid weq csn
      cprime cdif wne copab simp1 simp2 simp3 eleq1 bi2anan9 breqan12rd anbi12d
      w3a oveq1 cbvopabv lgsquadlem3 ) AUBGUAUCZHZBUQHZABUDZUMCDABEIZJAJKLGMLZN
      LZHZFIZJBJKLGMLZNLZHZOZVEAPLZVABPLZQRZOZEFUEVBVFURUSUTUFURUSUTUGURUSUTUHV
      BSVFSVMCIZVCHZDIZVGHZOZVPAPLZVNBPLZQRZOEFCDECTZFDTZOVIVRVLWAWBVDVOWCVHVQV
      AVNVCUIVEVPVGUIUJWCWBVJVSVKVTQVEVPAPUNVAVNBPUNUKULUOUP $.
  $}

  ${
    $d m M $.  $d m n x y N $.  $d m n x y ph $.
    lgsquad2.1 $e |- ( ph -> M e. NN ) $.
    lgsquad2.2 $e |- ( ph -> -. 2 || M ) $.
    lgsquad2.3 $e |- ( ph -> N e. NN ) $.
    lgsquad2.4 $e |- ( ph -> -. 2 || N ) $.
    lgsquad2.5 $e |- ( ph -> ( M gcd N ) = 1 ) $.
    ${
      lgsquad2lem1.a $e |- ( ph -> A e. NN ) $.
      lgsquad2lem1.b $e |- ( ph -> B e. NN ) $.
      lgsquad2lem1.m $e |- ( ph -> ( A x. B ) = M ) $.
      lgsquad2lem1.1 $e |- ( ph -> ( ( A /L N ) x. ( N /L A ) ) =
           ( -u 1 ^ ( ( ( A - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) $.
      lgsquad2lem1.2 $e |- ( ph -> ( ( B /L N ) x. ( N /L B ) ) =
           ( -u 1 ^ ( ( ( B - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) $.
      $( Lemma for ~ lgsquad2 .  (Contributed by Mario Carneiro,
         19-Jun-2015.) $)
      lgsquad2lem1 $p |- ( ph -> ( ( M /L N ) x. ( N /L M ) ) =
           ( -u 1 ^ ( ( ( M - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) $=
        ( c1 co c2 cmul wcel cneg cmin cdiv cexp caddc clgs cc wceq nnzd ax-1cn
        zcnd npcan sylancl oveq12d cz peano2zm syl muladdd 1t1e1 oveq2d mulid1d
        a1i eqtrd eqtr3d oveq1d mulcld addcl addcld addsubd 3eqtrd 2cn cc0 2ne0
        pncan wne divdird divassd divcan2d cdivides wn dvdsmul1 syl2anc breqtrd
        wbr wa wi 2z dvdstr syl3anc mpan2d mtod cprime 2prm nprmdvds1 mp1i omoe
        1z syl22anc wb dvdsval2 dvdsmul2 mulassd 3eqtr2d zmulcld zaddcld neg1cn
        mpbid adddird ax-1ne0 negne0i expaddz sqneg ax-mp sq1 eqtri oveq1i 1exp
        expmulz syl5eq expclzd mulid2d eqtr4d lgscl mul4d nnne0d syl32anc lgsdi
        lgsdir 3eqtr2rd ) APUAZDPUBQZRUCQZEPUBQZRUCQZSQZUDQZYJBPUBQZRUCQZYNSQZC
        PUBQZRUCQZYNSQZUEQZUDQZBEUFQZEBUFQZSQZCEUFQZECUFQZSQZSQZDEUFQZEDUFQZSQZ
        AYPYJRYRUUASQZYNSQZSQZYRUUAUEQZYNSQZUEQZUDQZPYJUUSUDQZSQZUUDAYOUUTYJUDA
        YORUUOSQZUURUEQZYNSQUVDYNSQZUUSUEQUUTAYLUVEYNSAYLYQYTSQZYQYTUEQZUEQZRUC
        QUVGRUCQZUVHRUCQZUEQUVEAYKUVIRUCAYKUVGPUEQZUVHUEQZPUBQUVLPUBQZUVHUEQUVI
        ADUVMPUBABCSQZDUVMMAYQPUEQZYTPUEQZSQZUVOUVMAUVPBUVQCSABUGTPUGTZUVPBUHAB
        ABKUIZUKUJBPULUMACUGTUVSUVQCUHACACLUIZUKUJCPULUMUNAUVRUVGPPSQZUEQZYQPSQ
        ZYTPSQZUEQZUEQUVMAYQPYTPAYQABUOTZYQUOTZUVTBUPUQZUKZUVSAUJVBZAYTACUOTZYT
        UOTZUWACUPUQZUKZUWKURAUWCUVLUWFUVHUEAUWBPUVGUEUWBPUHAUSVBUTAUWDYQUWEYTU
        EAYQUWJVAAYTUWOVAUNUNVCVDVDVEAUVLUVHPAUVGUGTZUVSUVLUGTAYQYTUWJUWOVFZUJU
        VGPVGUMAYQYTUWJUWOVHZUWKVIAUVNUVGUVHUEAUWPUVSUVNUVGUHUWQUJUVGPVNUMVEVJV
        EAUVGUVHRUWQUWRRUGTAVKVBZRVLVOZAVMVBZVPAUVJUVDUVKUURUEAUVJYQUUASQRYRSQZ
        UUASQUVDAYQYTRUWJUWOUWSUXAVQAUXBYQUUASAYQRUWJUWSUXAVRVEARYRUUAUWSAYRARY
        QVSWDZYRUOTZAUWGRBVSWDZVTPUOTZRPVSWDVTZUXCUVTAUXERDVSWDZGAUXEBDVSWDZUXH
        ABUVODVSAUWGUWLBUVOVSWDUVTUWABCWAWBMWCARUOTZUWGDUOTZUXEUXIWEUXHWFUXJAWG
        VBZUVTADFUIZRBDWHWIWJWKUXFAWQVBZRWLTUXGAWMRWNWOZBPWPWRAUXJUWTUWHUXCUXDW
        SUXLUXAUWIRYQWTWIXGZUKZAUUAARYTVSWDZUUAUOTZAUWLRCVSWDZVTUXFUXGUXRUWAAUX
        TUXHGAUXTCDVSWDZUXHACUVODVSAUWGUWLCUVOVSWDUVTUWABCXAWBMWCAUXJUWLUXKUXTU
        YAWEUXHWFUXLUWAUXMRCDWHWIWJWKUXNUXOCPWPWRAUXJUWTUWMUXRUXSWSUXLUXAUWNRYT
        WTWIXGZUKZXBXCAYQYTRUWJUWOUWSUXAVPUNVJVEAUVDUURYNAUVDARUUOUXLAYRUUAUXPU
        YBXDZXDUKAUURAYRUUAUXPUYBXEZUKAYNARYMVSWDZYNUOTZAEUOTZREVSWDVTUXFUXGUYF
        AEHUIZIUXNUXOEPWPWRAUXJUWTYMUOTZUYFUYGWSUXLUXAAUYHUYJUYIEUPUQRYMWTWIXGZ
        UKZXHAUVFUUQUUSUEARUUOYNUWSAUUOUYDUKUYLXBVEVJUTAUVAYJUUQUDQZUVBSQZUVCAY
        JUGTZYJVLVOZUUQUOTUUSUOTUVAUYNUHUYOAXFVBZUYPAPUJXIXJVBZARUUPUXLAUUOYNUY
        DUYKXDZXDAUURYNUYEUYKXDZYJUUQUUSXKWRAUYMPUVBSAUYMYJRUDQZUUPUDQZPAUYOUYP
        UXJUUPUOTZUYMVUBUHUYQUYRUXLUYSYJRUUPXRWRAVUBPUUPUDQZPVUAPUUPUDVUAPRUDQZ
        PUVSVUAVUEUHUJPXLXMXNXOXPAVUCVUDPUHUYSUUPXQUQXSVCVEVCAUVCUVBUUDAUVBAYJU
        USUYQUYRUYTXTYAAUUSUUCYJUDAYRUUAYNUXQUYCUYLXHUTVCVJAUUKYJYSUDQZYJUUBUDQ
        ZSQZUUDAUUGVUFUUJVUGSNOUNAUYOUYPYSUOTUUBUOTUUDVUHUHUYQUYRAYRYNUXPUYKXDA
        UUAYNUYBUYKXDYJYSUUBXKWRYBAUUEUUHSQZUUFUUISQZSQUUKUUNAUUEUUHUUFUUIAUUEA
        UWGUYHUUEUOTUVTUYIBEYCWBUKAUUHAUWLUYHUUHUOTUWAUYICEYCWBUKAUUFAUYHUWGUUF
        UOTUYIUVTEBYCWBUKAUUIAUYHUWLUUIUOTUYIUWAECYCWBUKYDAVUIUULVUJUUMSAUVOEUF
        QZVUIUULAUWGUWLUYHBVLVOZCVLVOZVUKVUIUHUVTUWAUYIABKYEZACLYEZBCEYHYFAUVOD
        EUFMVEVDAEUVOUFQZVUJUUMAUYHUWGUWLVULVUMVUPVUJUHUYIUVTUWAVUNVUOEBCYGYFAU
        VODEUFMUTVDUNVDYI $.
    $}

    ${
      lgsquad2lem2.f $e |- ( ( ph /\
        ( m e. ( Prime \ { 2 } ) /\ ( m gcd N ) = 1 ) ) ->
        ( ( m /L N ) x. ( N /L m ) ) =
           ( -u 1 ^ ( ( ( m - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) $.
      lgsquad2lem2.s $e |- ( ps <->
        A. x e. ( 1 ... k ) ( ( x gcd ( 2 x. N ) ) = 1 ->
        ( ( x /L N ) x. ( N /L x ) ) =
          ( -u 1 ^ ( ( ( x - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) ) $.
      $( Lemma for ~ lgsquad2 .  (Contributed by Mario Carneiro,
         19-Jun-2015.) $)
      lgsquad2lem2 $p |- ( ph -> ( ( M /L N ) x. ( N /L M ) ) =
           ( -u 1 ^ ( ( ( M - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) $=
        ( c2 cmul co c1 wceq clgs vy cgcd cneg cmin cdiv cexp wcel 2nn a1i nnzd
        cn cz 2z gcdcom sylancl cdivides wbr wn cprime 2prm coprm sylancr mpbid
        wb eqtrd rpmulgcd syl31anc wi cc0 oveq1 oveq2 oveq12d syl6eq oveq1d 2cn
        cv 1m1e0 div0i oveq2d eqeq12d imbi2d weq eqeq1d imbi12d 1t1e1 cc neg1cn
        2ne0 exp0 ax-mp eqtr4i sq1 oveq1i 1nn 1gcd lgssq syl3anc syl5eqr oveq2i
        syl gcd1 lgssq2 cn0 nnm1nn0 nn0cnd halfcld mul02d 3eqtr4a a1d wa simprl
        csn cdif wne prmz ad2antrl adantr zmulcl simprr dvdsmul1 syl32anc prmrp
        rpdvds eldifsn sylanbrc prmnn eqtr3d jca syldan exp32 com12 clt eluz2b2
        simplbi ad2antrr eluzelz adantrr dvdsmul2 syl2anc mpd cuz jcab nnmulcld
        simplrl simplrr nprmdvds1 anim12i ad2antlr dvdsgcd mpan2d breq2d sylibd
        cfv simpr eqidd simpld simprrl simprd simprrr lgsquad2lem1 com23 expcom
        mtoi a2d syl5bir prmind mpcom ) AFOGPQZUBQZRSZFGTQZGFTQZPQZRUCZFRUDQZOU
        EQZGRUDQZOUEQZPQZUFQZSZAUVIFGUBQZRAFUKUGZOUKUGZGUKUGZFOUBQZRSUVIUWBSHUW
        DAUHUIJAUWFOFUBQZRAFULUGZOULUGZUWFUWGSAFHUJZUMFOUNUOAOFUPUQURZUWGRSZIAO
        USUGZUWHUWKUWLVDUTUWJOFVAVBVCVEFOGVFVGLVEUWCAUVJUWAVHZHAEVPZUVHUBQZRSZU
        WOGTQZGUWOTQZPQZUVNUWORUDQZOUEQZUVRPQZUFQZSZVHZVHAUWQRGTQZGRTQZPQZUVNVI
        UVRPQZUFQZSZVHZVHACVPZUVHUBQZRSZUXNGTQZGUXNTQZPQZUVNUXNRUDQZOUEQZUVRPQZ
        UFQZSZVHZVHZAUAVPZUVHUBQZRSZUYGGTQZGUYGTQZPQZUVNUYGRUDQZOUEQZUVRPQZUFQZ
        SZVHZVHZAUXNUYGPQZUVHUBQZRSZUYTGTQZGUYTTQZPQZUVNUYTRUDQZOUEQZUVRPQZUFQZ
        SZVHZVHZAUWNVHECUAFUWORSZUXFUXMAVUMUXEUXLUWQVUMUWTUXIUXDUXKVUMUWRUXGUWS
        UXHPUWORGTVJUWORGTVKVLVUMUXCUXJUVNUFVUMUXBVIUVRPVUMUXBVIOUEQVIVUMUXAVIO
        UEVUMUXARRUDQVIUWORRUDVJVQVMVNOVOWHVRVMVNVSVTWAWAECWBZUXFUYEAVUNUWQUXPU
        XEUYDVUNUWPUXORUWOUXNUVHUBVJWCVUNUWTUXSUXDUYCVUNUWRUXQUWSUXRPUWOUXNGTVJ
        UWOUXNGTVKVLVUNUXCUYBUVNUFVUNUXBUYAUVRPVUNUXAUXTOUEUWOUXNRUDVJVNVNVSVTW
        DWAEUAWBZUXFUYRAVUOUWQUYIUXEUYQVUOUWPUYHRUWOUYGUVHUBVJWCVUOUWTUYLUXDUYP
        VUOUWRUYJUWSUYKPUWOUYGGTVJUWOUYGGTVKVLVUOUXCUYOUVNUFVUOUXBUYNUVRPVUOUXA
        UYMOUEUWOUYGRUDVJVNVNVSVTWDWAUWOUYTSZUXFVUKAVUPUWQVUBUXEVUJVUPUWPVUARUW
        OUYTUVHUBVJWCVUPUWTVUEUXDVUIVUPUWRVUCUWSVUDPUWOUYTGTVJUWOUYTGTVKVLVUPUX
        CVUHUVNUFVUPUXBVUGUVRPVUPUXAVUFOUEUWOUYTRUDVJVNVNVSVTWDWAUWOFSZUXFUWNAV
        UQUWQUVJUXEUWAVUQUWPUVIRUWOFUVHUBVJWCVUQUWTUVMUXDUVTVUQUWRUVKUWSUVLPUWO
        FGTVJUWOFGTVKVLVUQUXCUVSUVNUFVUQUXBUVPUVRPVUQUXAUVOOUEUWOFRUDVJVNVNVSVT
        WDWAAUXLUWQARRPQZUVNVIUFQZUXIUXKVURRVUSWEUVNWFUGVUSRSWGUVNWIWJWKAUXGRUX
        HRPAUXGROUFQZGTQZRVUTRGTWLWMARUKUGZGULUGZRGUBQRSZVVARSVVBAWNUIZAGJUJZAV
        VCVVDVVFGWOWTRGWPWQWRAUXHGVUTTQZRVUTRGTWLWSAVVCVVBGRUBQRSZVVGRSVVFVVEAV
        VCVVHVVFGXAWTGRXBWQWRVLAUXJVIUVNUFAUVRAUVQAUVQAUWEUVQXCUGJGXDWTXEXFXGVS
        XHXIAUWOUSUGZUXFAVVIUWQUXEAVVIUWQXJZUWOUSOXLXMUGZUWOGUBQZRSZXJUXEAVVJXJ
        ZVVKVVMVVNVVIUWOOXNZVVKAVVIUWQXKZVVNUWOOUBQRSZVVOVVNUWOULUGZUWIUVHULUGZ
        UWQOUVHUPUQZVVQVVIVVRAUWQUWOXOXPUWIVVNUMUIVVNUWIVVCVVSUMVVNGAUWEVVJJXQZ
        UJZOGXRZVBAVVIUWQXSZVVNUWIVVCVVTUMVWBOGXTZVBUWOOUVHYCYAZVVNVVIUWMVVQVVO
        VDVVPUTUWOOYBUOVCUWOUSOYDYEVVNUWPVVLRVVNUWOUKUGZUWDUWEVVQUWPVVLSVVIVWGA
        UWQUWOYFXPUWDVVNUHUIVWAVWFUWOOGVFVGVWDYGYHMYIYJYKUYFUYSXJAUYEUYRXJZVHUX
        NOUUAUUMZUGZUYGVWIUGZXJZVULAUYEUYRUUBVWLAVWHVUKAVWLVWHVUKVHAVWLXJZVUBVW
        HVUJVWMVUBVWHVUJVWMVUBVWHXJZXJZUXNUYGUYTGVWOUXNUYGVWOVWJUXNUKUGZAVWJVWK
        VWNUUDVWJVWPRUXNYLUQUXNYMYNWTZVWOVWKUYGUKUGZAVWJVWKVWNUUEVWKVWRRUYGYLUQ
        UYGYMYNWTZUUCVWMVUBOUYTUPUQZURVWHVWMVUBXJZVWTORUPUQZUWMVXBURUTOUUFWJVXA
        VWTOVUAUPUQZVXBVXAVWTVVTVXCVXAUWIVVCVVTUMAVVCVWLVUBVVFYOZVWEVBVXAUWIUYT
        ULUGZVVSVWTVVTXJVXCVHUWIVXAUMUIVXAUXNULUGZUYGULUGZXJZVXEVWLVXHAVUBVWJVX
        FVWKVXGOUXNYPOUYGYPUUGUUHZUXNUYGXRWTZVXAUWIVVCVVSUMVXDVWCVBZOUYTUVHUUIW
        QUUJVXAVUAROUPVWMVUBUUNZUUKUULUVCYQAUWEVWLVWNJYOAOGUPUQURVWLVWNKYOVWMVU
        BUYTGUBQRSZVWHVXAVXEVVCVVSVUBGUVHUPUQZVXMVXJVXDVXKVXLVXAUWIVVCVXNUMVXDO
        GYRVBUYTGUVHYCYAYQVWQVWSVWOUYTUUOVWOUXPUYDVWMVUBUXPVWHVXAUXOUVHUXNUBQZR
        VXAVXFVVSUXOVXOSVXAVXFVXGVXIUUPZVXKUXNUVHUNYSVXAVVSVXFVXEUVHUYTUBQZRSZU
        XNUYTUPUQZVXORSVXKVXPVXJVXAVXQVUARVXAVVSVXEVXQVUASVXKVXJUVHUYTUNYSVXLVE
        ZVXAVXHVXSVXIUXNUYGXTWTUVHUXNUYTYCYAVEYQVWMVUBUYEUYRUUQYTVWOUYIUYQVWMVU
        BUYIVWHVXAUYHUVHUYGUBQZRVXAVXGVVSUYHVYASVXAVXFVXGVXIUURZVXKUYGUVHUNYSVX
        AVVSVXGVXEVXRUYGUYTUPUQZVYARSVXKVYBVXJVXTVXAVXHVYCVXIUXNUYGYRWTUVHUYGUY
        TYCYAVEYQVWMVUBUYEUYRUUSYTUUTYJUVAUVBUVDUVEUVFUVGYT $.
    $}

    $( Extend ~ lgsquad to coprime odd integers (the domain of the Jacobi
       symbol).  (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    lgsquad2 $p |- ( ph -> ( ( M /L N ) x. ( N /L M ) ) =
         ( -u 1 ^ ( ( ( M - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) ) $=
      ( vx c2 cmul co cgcd c1 wceq clgs cexp cprime wcel cc vy vm vn cv cneg wi
      cmin cdiv cfz wral csn cdif wa cn adantr cdivides wbr simprl eldifi prmnn
      wn syl wne eldifsni necomd neneqd cuz wb cz 2z uzid ax-mp dvdsprm sylancr
      mtbird nnzd gcdcom syl2anc simprr eqtrd prmrp syl2anr biimpd impr lgsquad
      cfv syl3anc biid lgsquad2lem2 lgscl zcn mulcom syl2an nncnd subcl sylancl
      ax-1cn halfcld mulcomd oveq2d 3eqtr4d ) AIUDZJCKLMLNOXBCPLCXBPLKLNUEZXBNU
      GLJUHLZCNUGLZJUHLZKLQLOUFINUAUDUILZUJZIUAUBBCDEFGHAUBUDZRJUKZULZSZXICMLZN
      OZUMZUMZCXIPLZXICPLZKLZXCXFXINUGLZJUHLZKLZQLXRXQKLZXCYAXFKLZQLXPXBJXIKLML
      NOXBXIPLXIXBPLKLXCXDYAKLQLOUFIXGUJZIUAUCCXIACUNSXOFUOZAJCUPUQVAXOGUOXPXIR
      SZXIUNSXPXLYGAXLXNURZXIRXJUSVBZXIUTVBZXPJXIUPUQZJXIOZXPJXIXPXIJXPXLXIJVCY
      HXIRJVDVBVEVFXPJJVGWFSZYGYKYLVHJVISYMVJJVKVLYIXIJVMVNVOXPCXIMLZXMNXPCVISZ
      XIVISZYNXMOXPCYFVPZXPXIYJVPZCXIVQVRAXLXNVSVTXPUCUDZXKSZYSXIMLNOZUMZUMYTXL
      YSXIVCZYSXIPLXIYSPLKLXCYSNUGLJUHLYAKLQLOXPYTUUAURXPXLUUBYHUOXPYTUUAUUCXPY
      TUMUUAUUCYTYSRSYGUUAUUCVHXPYSRXJUSYIYSXIWAWBWCWDYSXIWEWGYEWHWIXPXRVISZXQV
      ISZYCXSOZXPYPYOUUDYRYQXICWJVRXPYOYPUUEYQYRCXIWJVRUUDXRTSXQTSUUFUUEXRWKXQW
      KXRXQWLWMVRXPYDYBXCQXPYAXFXPXTXPXITSNTSZXTTSXPXIYJWNWQXINWOWPWRXPXEXPCTSU
      UGXETSXPCYFWNWQCNWOWPWRWSWTXAXHWHWI $.
  $}

  $( Extend ~ lgsquad2 to integers which share a factor.  (Contributed by Mario
     Carneiro, 19-Jun-2015.) $)
  lgsquad3 $p |- ( ( ( M e. NN /\ -. 2 || M ) /\ ( N e. NN /\ -. 2 || N ) ) ->
       ( M /L N ) =
   ( ( -u 1 ^ ( ( ( M - 1 ) / 2 ) x. ( ( N - 1 ) / 2 ) ) ) x. ( N /L M ) ) ) $=
    ( wcel c2 cdivides wbr wn wa co c1 wceq cmul cexp cz syl syl2anc eqtr4d cc0
    wb a1i cn cgcd clgs cneg cmin cdiv cabs cfv cr simplrl ad3antrrr lgscl zred
    nnz absresq gcdcom simpr eqtrd lgsabs1 mpbird oveq1d sq1 syl6eq zcnd sqvald
    3eqtr3d oveq2d mulassd mulid1d simplll simpllr lgsquad2 necon1bbid ad2ant2r
    simplrr lgsne0 syl2an biimpa cc neg1cn wne ax-1cn ax-1ne0 negne0i 1z cprime
    2prm nprmdvds1 mp1i omoe syl22anc 2z peano2zm dvdsval2 syl3anc mpbid adantr
    2ne0 ad2antlr zmulcld expclzd mul01d eqeq1d bitrd syl2anr pm2.61dan ) AUACZ
    DAEFGZHZBUACZDBEFGZHZHZABUBIZJKZABUCIZJUDZAJUEIZDUFIZBJUEIZDUFIZLIZMIZBAUCI
    ZLIZKXMXOHZXPJLIZXPYDLIZYDLIZXPYEYFYGXPYDYDLIZLIYIYFJYJXPLYFYDUGUHZDMIZYDDM
    IZJYJYFYDUICYLYMKYFYDYFBNCZANCZYDNCYFXJYNXIXJXKXOUJZBUNZOZXGYOXHXLXOAUNZUKZ
    BAULPZUMYDUOOYFYLJDMIJYFYKJDMYFYKJKZBAUBIZJKZYFUUCXNJYFYNYOUUCXNKYRYTBAUPZP
    XMXOUQZURYFYNYOUUBUUDSYRYTBAUSPUTVAVBVCYFYDYFYDUUAVDZVEVFVGYFXPYDYDYFXPYFYO
    YNXPNCYTYRABULPVDZUUGUUGVHQYFXPUUHVIYFYHYCYDLYFABXGXHXLXOVJXGXHXLXOVKYPXIXJ
    XKXOVOUUFVLVAVFXMXOGZHZXPYCRLIZYEUUJXPRUUKXMUUIXPRKZXGXJUUIUULSZXHXKXGYOYNU
    UMXJYSYQYOYNHXOXPRABVPVMVQVNVRUUJYCUUJXQYBXQVSCUUJVTTXQRWAUUJJWBWCWDTUUJXSY
    AUUJDXREFZXSNCZUUJYOXHJNCZDJEFGZUUNXGYOXHXLUUIYSUKZXGXHXLUUIVKUUPUUJWETZDWF
    CUUQUUJWGDWHWIZAJWJWKUUJDNCZDRWAZXRNCZUUNUUOSUVAUUJWLTZUVBUUJWRTZUUJYOUVCUU
    RAWMODXRWNWOWPUUJDXTEFZYANCZUUJYNXKUUPUUQUVFXLYNXIUUIXJYNXKYQWQWSZXIXJXKUUI
    VOUUSUUTBJWJWKUUJUVAUVBXTNCZUVFUVGSUVDUVEUUJYNUVIUVHBWMODXTWNWOWPWTXAXBQUUJ
    YDRYCLXMUUIYDRKZXGXJUUIUVJSXHXKXGXJHXOYDRXJYNYOYDRWAZXOSXGYQYSYNYOHZUVKUUDX
    OBAVPUVLUUCXNJUUEXCXDXEVMVNVRVGQXF $.

  $( The first supplement to the law of quadratic reciprocity.  Negative one is
     a square mod an odd prime ` P ` iff ` P == 1 ` mod 4.  (Contributed by
     Mario Carneiro, 19-Jun-2015.) $)
  m1lgs $p |- ( P e. ( Prime \ { 2 } ) ->
      ( ( -u 1 /L P ) = 1 <-> ( P mod 4 ) = 1 ) ) $=
    ( cprime c2 wcel c1 co wceq c4 cmo cmin cdiv cexp caddc cdivides wbr cz syl
    ax-1cn a1i cc0 csn cdif cneg clgs cn0 1z znegcl ax-mp oddprm nnnn0d sylancr
    zexpcl peano2zd cn eldifi prmnn zmodcld nn0cnd cc subaddd crp cle clt nnrpd
    2re 0re 2pos ltleii wne eldifsni nnred cuz cfv prmuz2 eluzle leltned mpbird
    cr modid syl22anc df-2 syl6eq eqeq1d wn wa neneqd wb dvdsprm sylancl mtbird
    2prm adantr simpr oexpneg syl3anc nnzd negeqd oveq1d neg1cn negidi addcomli
    1exp eqtrd oveq2d 2cn subid1i breq2d ex con4d 2z moddvds 4nn nnne0i nnm1nn0
    nnzi nn0zd dvdsval2 cmul 2ne0 divdiv1d oveq2i eleq1d bitr4d 3imtr4d ax-1ne0
    2t2e4 negne0i biimpa expmulz nncnd divcan2d sqneg sq1 oveq1i syl5eq 3eqtr3d
    eqtri syl6reqr impbid 3bitr2d lgsval3 mpan prmz 3bitr4d 1re nnrp 0le1 mp4an
    1lt4 eqeq2i syl6bb ) ABCUAZUBDZEUCZAUDFZEGZAHIFZEHIFZGZUUQEGUUMUUNAEJFZCKFZ
    LFZEMFZAIFZEJFZEGZHUUTNOZUUPUUSUUMUVFEEMFZUVDGCAIFZUVDGZUVGUUMUVDEEUUMUVDUU
    MUVCAUUMUVBUUMUUNPDZUVAUEDUVBPDEPDZUVKUFEUGUHZUUMUVAAUIZUJUUNUVAULUKUMZUUMA
    BDZAUNDZABUULUOZAUPQZUQUREUSDZUUMRSZUWAUTUUMUVIUVHUVDUUMUVICUVHUUMCVRDZAVAD
    TCVBOZCAVCOZUVICGUWBUUMVESZUUMAUVSVDUWCUUMTCVFVEVGVHSUUMUWDACVIABCVJZUUMCAU
    WEUUMAUVSVKUUMACVLVMDZCAVBOUUMUVPUWGUVRAVNQZCAVOQVPVQCAVSVTWAWBWCUUMUVJUVGU
    UMACUVCJFZNOZCUVANOZUVJUVGUUMUWKUWJUUMUWKWDZUWJWDUUMUWLWEZUWJACNOZUUMUWNWDU
    WLUUMUWNACGZUUMACUWFWFUUMUWGCBDUWNUWOWGUWHWKCAWHWIWJWLUWMUWICANUWMUWICTJFCU
    WMUVCTCJUWMUVCUUNEMFTUWMUVBUUNEMUWMUVBEUVALFZUCZUUNUWMUVTUVAUNDZUWLUVBUWQGU
    VTUWMRSUUMUWRUWLUVNWLZUUMUWLWMEUVAWNWOUWMUWPEUWMUVAPDZUWPEGUWMUVAUWSWPUVAXB
    QWQXCWREUUNTRWSERWTXAWBXDCXEXFWBXGWJXHXIUUMUVQCPDZUVCPDUVJUWJWGUVSUXAUUMXJS
    ZUVOCUVCAXKWOUUMUVGUVACKFZPDZUWKUUMUVGUUTHKFZPDZUXDUUMHPDZHTVIZUUTPDUVGUXFW
    GUXGUUMHXLXOSUXHUUMHXLXMSUUMUUTUUMUVQUUTUEDUVSAXNQZXPHUUTXQWOUUMUXCUXEPUUMU
    XCUUTCCXRFZKFUXEUUMUUTCCUUMUUTUXIURCUSDUUMXESZUXKCTVIZUUMXSSZUXMXTUXJHUUTKY
    FYAWBYBYCZUUMUXAUXLUWTUWKUXDWGUXBUXMUUMUVAUVNWPCUVAXQWOYCYDUUMUVGUVJUUMUVGW
    EZCUVCAIUXOUVCUVHCUXOUVBEEMUXOUUNCUXCXRFZLFZUUNCLFZUXCLFZUVBEUXOUUNUSDZUUNT
    VIZUXAUXDUXQUXSGUXTUXOWSSUYAUXOERYEYGSUXAUXOXJSUUMUVGUXDUXNYHZUUNCUXCYIVTUX
    OUXPUVAUUNLUUMUXPUVAGUVGUUMUVACUUMUVAUVNYJUXKUXMYKWLXDUXOUXSEUXCLFZEUXREUXC
    LUXRECLFZEUVTUXRUYDGREYLUHYMYQYNUXOUXDUYCEGUYBUXCXBQYOYPWRWAYRWRXHYSYTUUMUU
    OUVEEUVKUUMUUOUVEGUVMUUNAUUAUUBWCUUMHUNDZAPDZUVLUUSUVGWGUYEUUMXLSUUMUVPUYFU
    VRAUUCQUVLUUMUFSAEHXKWOUUDUUREUUQEVRDHVADZTEVBOEHVCOUUREGUUEUYEUYGXLHUUFUHU
    UGUUIEHVSUUHUUJUUK $.

  $(
  @( The second supplement to the law of quadratic reciprocity.  Two
     is a square mod a prime ` P ` iff ` P == +- 1 ` mod 8. This theorem
     justifies our definition of ` ( N /L 2 ) ` ( ~ lgs2 ) to some degree, by
     demanding that reciprocity extend to the case ` Q = 2 ` .
     ( Contributed by Mario Carneiro, 19-Jun-2015.) @)
  2lgs @p |- ( P e. Prime ->
      ( ( 2 /L P ) = 1 <-> ( P mod 8 ) e. { 1 , 7 } ) ) @=
    ? @.
    @( [19-Jun-2015] @)
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  All primes 4n+1 are the sum of two squares
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b n p q w x y z $.  $d a m x y z A $.  $d x C $.  $d p q u v x y ph $.
    $d a b m p x y B $.  $d a b p u v x y z M $.  $d a b m n p q u v x y z S $.
    $d x D $.  $d a p x y z E $.  $d p q u v x y z N $.  $d a b m n x y Y $.
    $d a p x y z F $.  $d n p q x y P $.
    2sq.1 $e |- S = ran ( w e. Z[i] |-> ( ( abs ` w ) ^ 2 ) ) $.
    $( Lemma for ~ 2sq .  (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    2sqlem1 $p |- ( A e. S <-> E. x e. Z[i] A = ( ( abs ` x ) ^ 2 ) ) $=
      ( wcel cgz cv cabs cfv c2 cexp co cmpt crn wceq wrex eleq2i fveq2 oveq1d
      cbvmptv ovex elrnmpti bitri ) CDFCBGBHZIJZKLMZNZOZFCAHZIJZKLMZPAGQDUICERA
      GULCUHBAGUGULUEUJPUFUKKLUEUJISTUAUKKLUBUCUD $.

    $( Lemma for ~ 2sq .  (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    2sqlem2 $p |- ( A e. S <-> E. x e. ZZ E. y e. ZZ
      A = ( ( x ^ 2 ) + ( y ^ 2 ) ) ) $=
      ( vz wcel cv c2 cexp co caddc wceq cz wrex cfv cgz cc oveq1d cabs 2sqlem1
      cre cim elgz simp2bi simp3bi gzcn absvalsq2d oveq1 eqeq2d rspc2ev syl3anc
      oveq2d eqeq1 2rexbidv syl5ibrcom rexlimiv sylbi wa cmul gzreim zcn ax-icn
      ci mulcl sylancr addcl syl2an zre crre crim oveq12d eqtr2d rspcev syl2anc
      cr fveq2 sylibr eleq1 rexlimivv impbii ) DEHZDAIZJKLZBIZJKLZMLZNZBOPAOPZW
      CDGIZUAQZJKLZNZGRPWJGCDEFUBWNWJGRWKRHZWJWNWMWHNZBOPAOPZWOWKUCQZOHZWKUDQZO
      HZWMWRJKLZWTJKLZMLZNZWQWOWKSHZWSXAWKUEZUFWOXFWSXAXGUGWOWKWKUHUIWPXEWMXBWG
      MLZNABWRWTOOWDWRNZWHXHWMXIWEXBWGMWDWRJKUJTUKWFWTNZXHXDWMXJWGXCXBMWFWTJKUJ
      UNUKULUMWNWIWPABOODWMWHUOUPUQURUSWIWCABOOWDOHZWFOHZUTZWCWIWHEHZXMWHWMNZGR
      PZXNXMWDVEWFVALZMLZRHWHXRUAQZJKLZNZXPWDWFVBXMXTXRUCQZJKLZXRUDQZJKLZMLWHXM
      XRXKWDSHXQSHZXRSHXLWDVCXLVESHWFSHYFVDWFVCVEWFVFVGWDXQVHVIUIXMYCWEYEWGMXMY
      BWDJKXKWDVQHZWFVQHZYBWDNXLWDVJZWFVJZWDWFVKVITXMYDWFJKXKYGYHYDWFNXLYIYJWDW
      FVLVITVMVNXOYAGXRRWKXRNZWMXTWHYKWLXSJKWKXRUAVRTUKVOVPGCWHEFUBVSDWHEVTUQWA
      WB $.

    $( Fibonacci's identity (actually due to Diophantus).  The product of two
       sums of two squares is also a sum of two squares.  We can take advantage
       of Gaussian integers here to trivialize the proof.  (Contributed by
       Mario Carneiro, 19-Jun-2015.) $)
    mul2sq $p |- ( ( A e. S /\ B e. S ) -> ( A x. B ) e. S ) $=
      ( vx vy vz wcel cv cabs cfv c2 cexp co wceq cgz wrex cmul cc 2sqlem1 gzcn
      reeanv absmul syl2an oveq1d abscld recnd sqmul eqtr2d fveq2 eqeq2d rspcev
      gzmulcl syl2anc sylibr oveq12 eleq1d syl5ibrcom rexlimivv sylbir syl2anb
      wa ) BDIBFJZKLZMNOZPZFQRZCGJZKLZMNOZPZGQRZBCSOZDIZCDIFABDEUAGACDEUAVHVMVC
      VGVLVCZGQRFQRVOVGVLFGQQUCVPVOFGQQVDQIZVIQIZVCZVOVPVFVKSOZDIZVSVTHJZKLZMNO
      ZPZHQRZWAVSVDVISOZQIVTWGKLZMNOZPZWFVDVIUNVSWIVEVJSOZMNOZVTVSWHWKMNVQVDTIV
      ITIWHWKPVRVDUBZVIUBZVDVIUDUEUFVQVETIVJTIWLVTPVRVQVEVQVDWMUGUHVRVJVRVIWNUG
      UHVEVJUIUEUJWEWJHWGQWBWGPZWDWIVTWOWCWHMNWBWGKUKUFULUMUOHAVTDEUAUPVPVNVTDB
      VFCVKSUQURUSUTVAVB $.

    ${
      2sqlem5.1 $e |- ( ph -> N e. NN ) $.
      2sqlem5.2 $e |- ( ph -> P e. Prime ) $.
      ${
        2sqlem4.3 $e |- ( ph -> A e. ZZ ) $.
        2sqlem4.4 $e |- ( ph -> B e. ZZ ) $.
        2sqlem4.5 $e |- ( ph -> C e. ZZ ) $.
        2sqlem4.6 $e |- ( ph -> D e. ZZ ) $.
        2sqlem4.7 $e |- ( ph -> ( N x. P ) = ( ( A ^ 2 ) + ( B ^ 2 ) ) ) $.
        2sqlem4.8 $e |- ( ph -> P = ( ( C ^ 2 ) + ( D ^ 2 ) ) ) $.
        ${
          2sqlem4.9 $e |- ( ph -> P || ( ( C x. B ) + ( A x. D ) ) ) $.
          $( Lemma for ~ 2sqlem5 .  (Contributed by Mario Carneiro,
             20-Jun-2015.) $)
          2sqlem3 $p |- ( ph -> N e. S ) $=
            ( co vx cv cabs cfv c2 cexp wceq cgz wrex wcel ci cmul caddc cc cre
            cdiv cz cim gzreim syl2anc gzmulcl syl cprime cn prmnn nncnd nnne0d
            gzcn divcld nnred redivd cdivides wbr prmz dvdsmul2 sqvald breqtrrd
            zsqcl wa wi zmulcld dvdstr syl3anc mp2and abscld recnd sqmuld crred
            nnzd oveq1d crimd oveq12d absvalsq2d 3eqtr4d mulassd 3eqtrd absmuld
            zred oveq2d elgz simp2bi zcnd simp3bi addcomd eqtrd breqtrd mulcomd
            mulcld immuld 2nn a1i prmdvdsexp mpbird dvdsadd2b syl112anc cc0 wne
            mpbid eqeltrd imdivd syl3anbrc absdivd nnnn0d nn0ge0d absidd sqdivd
            wb dvdsval2 nnsqcld divcan4d 3eqtrrd eqeq2d rspcev 2sqlem1 sylibr
            fveq2 ) AIUAUBZUCUDZUEUFTZUGZUAUHUIZIHUJACUKDULTUMTZEUKFULTUMTZULTZ
            GUPTZUHUJZIUUEUCUDZUEUFTZUGZUUAAUUEUNUJUUEUOUDZUQUJUUEURUDZUQUJUUFA
            UUDGAUUDUHUJZUUDUNUJZAUUBUHUJZUUCUHUJZUULACUQUJDUQUJUUNMNCDUSUTZAEU
            QUJFUQUJUUOOPEFUSUTZUUBUUCVAUTZUUDVHVBZAGAGVCUJZGVDUJLGVEVBZVFZAGUV
            AVGZVIAUUJUUDUOUDZGUPTZUQAGUUDAGUVAVJZUUSUVCVKAGUVDVLVMZUVEUQUJZAGU
            VDUEUFTZVLVMZUVGAUVJGUUDURUDZUEUFTZUVIUMTZVLVMZAGUUDUCUDZUEUFTZUVMV
            LAGIGUEUFTZULTZUVPVLAGUVQVLVMZUVQUVRVLVMZGUVRVLVMZAGGGULTZUVQVLAGUQ
            UJZUWCGUWBVLVMAUUTUWCLGVNVBZUWDGGVOUTAGUVBVPZVQAIUQUJUVQUQUJZUVTAIK
            WIZAUWCUWFUWDGVRVBZIUVQVOUTAUWCUWFUVRUQUJUVSUVTVSUWAVTUWDUWHAIUVQUW
            GUWHWAGUVQUVRWBWCWDAUUBUCUDZUUCUCUDZULTZUEUFTZIUWBULTZUVPUVRAUWLUWI
            UEUFTZUWJUEUFTZULTIGULTZGULTUWMAUWIUWJAUWIAUUBAUUNUUBUNUJUUPUUBVHVB
            ZWEWFAUWJAUUCAUUOUUCUNUJUUQUUCVHVBZWEWFWGAUWNUWPUWOGULAUUBUOUDZUEUF
            TZUUBURUDZUEUFTZUMTCUEUFTZDUEUFTZUMTUWNUWPAUWTUXCUXBUXDUMAUWSCUEUFA
            CDACMWRZADNWRZWHZWJAUXADUEUFACDUXEUXFWKZWJWLAUUBUWQWMQWNAUUCUOUDZUE
            UFTZUUCURUDZUEUFTZUMTEUEUFTZFUEUFTZUMTUWOGAUXJUXMUXLUXNUMAUXIEUEUFA
            EFAEOWRZAFPWRZWHZWJAUXKFUEUFAEFUXOUXPWKZWJWLAUUCUWRWMRWNWLAIGGAIKVF
            ZUVBUVBWOWPAUVOUWKUEUFAUUBUUCUWQUWRWQWJAUVQUWBIULUWEWSWNZVQAUVPUVIU
            VLUMTUVMAUUDUUSWMAUVIUVLAUVIAUVDUQUJZUVIUQUJZAUULUYAUURUULUUMUYAUVK
            UQUJZUUDWTZXAVBZUVDVRVBZXBAUVLAUYCUVLUQUJZAUULUYCUURUULUUMUYAUYCUYD
            XCVBZUVKVRVBZXBXDXEXFAUWCUYBUYGGUVLVLVMZUVJUVNYGUWDUYFUYIAUYJGUVKVL
            VMZAGCFULTZDEULTZUMTZUVKVLAGEDULTZUYLUMTZUYNVLSAUYPUYLUYOUMTUYNAUYO
            UYLAEDAEOXBZADNXBZXHACFACMXBAFPXBXHXDAUYOUYMUYLUMAEDUYQUYRXGWSXEXFA
            UVKUWSUXKULTZUXAUXIULTZUMTUYNAUUBUUCUWQUWRXIAUYSUYLUYTUYMUMAUWSCUXK
            FULUXGUXRWLAUXADUXIEULUXHUXQWLWLXEVQZAUUTUYCUEVDUJZUYJUYKYGLUYHVUBA
            XJXKZUVKGUEXLWCXMGUVIUVLXNXOXMAUUTUYAVUBUVJUVGYGLUYEVUCUVDGUEXLWCXR
            AUWCGXPXQZUYAUVGUVHYGUWDUVCUYEGUVDYHWCXRXSAUUKUVKGUPTZUQAGUUDUVFUUS
            UVCXTAUYKVUEUQUJZVUAAUWCVUDUYCUYKVUFYGUWDUVCUYHGUVKYHWCXRXSUUEWTYAA
            UUHUVOGUPTZUEUFTUVPUVQUPTZIAUUGVUGUEUFAUUGUVOGUCUDZUPTVUGAUUDGUUSUV
            BUVCYBAVUIGUVOUPAGUVFAGAGUVAYCYDYEWSXEWJAUVOGAUVOAUUDUUSWEWFUVBUVCY
            FAVUHUVRUVQUPTIAUVPUVRUVQUPUXTWJAIUVQUXSAUVQAGUVAYIZVFAUVQVUJVGYJXE
            YKYTUUIUAUUEUHYQUUEUGZYSUUHIVUKYRUUGUEUFYQUUEUCYPWJYLYMUTUABIHJYNYO
            $.
        $}

        $( Lemma for ~ 2sqlem5 .  (Contributed by Mario Carneiro,
           20-Jun-2015.) $)
        2sqlem4 $p |- ( ph -> N e. S ) $=
          ( cmul co caddc cdivides wbr wcel cmin wa cn adantr cprime cz c2 cexp
          wceq simpr 2sqlem3 cneg znegcld zcnd sqneg syl oveq1d eqtr4d mulneg1d
          cc oveq2d zmulcld negsubd eqtrd breq2d biimpar wo prmz zsqcl dvdsmul1
          nnzd zsubcld syl2anc sqcld pnpcand sqmuld oveq12d adddid nncnd eqtr3d
          mulcomd mul12d adddird subdid subsq breqtrd wb zaddcld euclemma mpbid
          syl3anc mpjaodan ) AGEDSTZCFSTZUATZUBUCZIHUDGWQWRUETZUBUCZAWTUFBCDEFG
          HIJAIUGUDZWTKUHAGUIUDZWTLUHACUJUDZWTMUHADUJUDZWTNUHAEUJUDZWTOUHAFUJUD
          ZWTPUHAIGSTZCUKULTZDUKULTZUATZUMWTQUHAGEUKULTZFUKULTZUATZUMZWTRUHAWTU
          NUOAXBUFBCUPZDEFGHIJAXCXBKUHAXDXBLUHAXQUJUDXBACMUQUHAXFXBNUHAXGXBOUHA
          XHXBPUHAXIXQUKULTZXKUATZUMXBAXIXLXSQAXRXJXKUAACVDUDXRXJUMACMURZCUSUTV
          AVBUHAXPXBRUHAGWQXQFSTZUATZUBUCXBAYBXAGUBAYBWQWRUPZUATXAAYAYCWQUAACFX
          TAFPURZVCVEAWQWRAWQAEDONVFZURZAWRACFMPVFZURZVGVHVIVJUOAGWSXASTZUBUCZW
          TXBVKZAGGXMISTZXJUETZSTZYIUBAGUJUDZYMUJUDGYNUBUCAXDYOLGVLUTZAYLXJAXMI
          AXGXMUJUDOEVMUTZAIKVOVFZAXEXJUJUDMCVMUTZVPGYMVNVQAWQUKULTZWRUKULTZUET
          ZYNYIAECSTZUKULTZYTUATZUUDUUAUATZUETZUUBYNAUUDYTUUAAUUCAUUCAECOMVFURV
          RAWQYFVRAWRYHVRVSAUUGGYLSTZGXJSTZUETYNAUUEUUHUUFUUIUEAUUEXMXLSTZUUHAU
          UEXMXJSTZXMXKSTZUATUUJAUUDUUKYTUULUAAECAEOURZXTVTZAEDUUMADNURZVTWAAXM
          XJXKAEUUMVRZAXJYSURZADUUOVRWBVBAUUJXMGISTZSTUUHAXLUURXMSAXIXLUURQAIGA
          IKWCZAGYPURZWEWDVEAXMGIUUPUUTUUSWFVHVHAUUFXOXJSTZUUIAUUFUUKXNXJSTZUAT
          UVAAUUDUUKUUAUVBUAUUNAUUAXJXNSTUVBACFXTYDVTAXJXNUUQAFYDVRZWEVHWAAXMXN
          XJAXMYQURUVCUUQWGVBAGXOXJSRVAVBWAAGYLXJUUTAYLYRURUUQWHVBWDAWQVDUDWRVD
          UDUUBYIUMYFYHWQWRWIVQWDWJAXDWSUJUDXAUJUDYJYKWKLAWQWRYEYGWLAWQWRYEYGVP
          GWSXAWMWOWNWP $.
      $}

      2sqlem5.3 $e |- ( ph -> ( N x. P ) e. S ) $.
      2sqlem5.4 $e |- ( ph -> P e. S ) $.
      $( Lemma for ~ 2sq .  If a number that is a sum of two squares is
         divisible by a prime that is a sum of two squares, then the quotient
         is a sum of two squares.  (Contributed by Mario Carneiro,
         20-Jun-2015.) $)
      2sqlem5 $p |- ( ph -> N e. S ) $=
        ( vp vq vx vy cv co cz wrex wcel wa cexp caddc wceq cmul 2sqlem2 reeanv
        c2 sylib cprime simplrr simprlr simplrl simprll simprrr simprrl 2sqlem4
        cn ad2antrr expr rexlimdvva syl5bir mp2and ) ACKOZUGUAPLOZUGUAPUBPUCZLQ
        RZKQRZECUDPZMOZUGUAPNOZUGUAPUBPUCZNQRZMQRZEDSZACDSVGJKLBCDFUEUHAVHDSVMI
        MNBVHDFUEUHVGVMTVFVLTZMQRKQRAVNVFVLKMQQUFAVOVNKMQQVOVEVKTZNQRLQRAVCQSZV
        IQSZTZTZVNVEVKLNQQUFVTVPVNLNQQVTVDQSZVJQSZTZVPVNVTWCVPTZTBVIVJVCVDCDEFA
        EUQSVSWDGURACUISVSWDHURAVQVRWDUJVTWAWBVPUKAVQVRWDULVTWAWBVPUMVTWCVEVKUN
        VTWCVEVKUOUPUSUTVAUTVAVB $.
    $}

    ${
      2sqlem6.1 $e |- ( ph -> A e. NN ) $.
      2sqlem6.2 $e |- ( ph -> B e. NN ) $.
      2sqlem6.3 $e |- ( ph -> A. p e. Prime ( p || B -> p e. S ) ) $.
      2sqlem6.4 $e |- ( ph -> ( A x. B ) e. S ) $.
      $( Lemma for ~ 2sq .  If a number that is a sum of two squares is
         divisible by a number whose prime divisors are all sums of two
         squares, then the quotient is a sum of two squares.  (Contributed by
         Mario Carneiro, 20-Jun-2015.) $)
      2sqlem6 $p |- ( ph -> A e. S ) $=
        ( vm cn wcel cmul wi wral cdivides cprime wa vx vy vz vn cv co wbr wceq
        breq2 imbi1d ralbidv oveq2 eleq1d imbi12d nncn mulid1d biimpd a1i breq1
        c1 rgen eleq1 rspcv prmz iddvds syl simprl simpll simprr simplr 2sqlem5
        cz expr ralrimiva ex embantd syld c2 cuz prth wo simpr eluzelz ad2antrr
        wb ad2antlr euclemma syl3anc jaob syl6bb ralbidva r19.26 biimpa cbvralv
        cfv oveq1 adantl uzssz zsscn sstri sseldi w3a mulass eqtr3d clt eluz2b2
        cc mul32 simplbi nnmulcld sylbird imim1d ralimdva sylan2b expimpd com23
        sylc syl5 prmind syl3c ) ACMNLUEZDOUFZENZYAENZPZLMQZCDOUFZENZCENZHADMNF
        UEZDRUGZYJENZPZFSQZYFIJYJUAUEZRUGZYLPZFSQZYAYOOUFZENZYDPZLMQZPYJUTRUGZY
        LPZFSQZYAUTOUFZENZYDPZLMQZPYJUBUEZRUGZYLPZFSQZYAUUJOUFZENZYDPZLMQZPZYJU
        CUEZRUGZYLPZFSQZYAUUSOUFZENZYDPZLMQZPZYJUUJUUSOUFZRUGZYLPZFSQZYAUVHOUFZ
        ENZYDPZLMQZPZYNYFPUAUBUCDYOUTUHZYRUUEUUBUUIUVQYQUUDFSUVQYPUUCYLYOUTYJRU
        IUJUKUVQUUAUUHLMUVQYTUUGYDUVQYSUUFEYOUTYAOULUMUJUKUNYOUUJUHZYRUUMUUBUUQ
        UVRYQUULFSUVRYPUUKYLYOUUJYJRUIUJUKUVRUUAUUPLMUVRYTUUOYDUVRYSUUNEYOUUJYA
        OULUMUJUKUNYOUUSUHZYRUVBUUBUVFUVSYQUVAFSUVSYPUUTYLYOUUSYJRUIUJUKUVSUUAU
        VELMUVSYTUVDYDUVSYSUVCEYOUUSYAOULUMUJUKUNYOUVHUHZYRUVKUUBUVOUVTYQUVJFSU
        VTYPUVIYLYOUVHYJRUIUJUKUVTUUAUVNLMUVTYTUVMYDUVTYSUVLEYOUVHYAOULUMUJUKUN
        YODUHZYRYNUUBYFUWAYQYMFSUWAYPYKYLYODYJRUIUJUKUWAUUAYELMUWAYTYCYDUWAYSYB
        EYODYAOULUMUJUKUNUUIUUEUUHLMYAMNZUUGYDUWBUUFYAEUWBYAYAUOZUPUMUQVAURYOSN
        ZYRYOYORUGZYOENZPZUUBYQUWGFYOSYJYOUHYPUWEYLUWFYJYOYORUSYJYOEVBUNVCUWDUW
        EUWFUUBUWDYOVLNUWEYOVDYOVEVFUWDUWFUUBUWDUWFTZUUALMUWHUWBYTYDUWHUWBYTTZT
        BYOEYAGUWHUWBYTVGUWDUWFUWIVHUWHUWBYTVIUWDUWFUWIVJVKVMVNVOVPVQUURUVGTUUM
        UVBTZUUQUVFTZPZUUJVRVSWOZNZUUSUWMNZTZUVPUUMUUQUVBUVFVTUWPUVKUWLUVOUWPUV
        KUWLUVOPUWPUVKTZUWJUWKUVOUWPUVKUWJUWPUVKUULUVATZFSQUWJUWPUVJUWRFSUWPYJS
        NZTZUVJUUKUUTWAZYLPUWRUWTUVIUXAYLUWTUWSUUJVLNZUUSVLNZUVIUXAWEUWPUWSWBUW
        NUXBUWOUWSVRUUJWCWDUWOUXCUWNUWSVRUUSWCWFYJUUJUUSWGWHUJUUKYLUUTWIWJWKUUL
        UVAFSWLWJWMUWQUUQUVFUVOUUQUWQUDUEZUUJOUFZENZUXDENZPZUDMQZUVFUVOPUUPUXHL
        UDMYAUXDUHZUUOUXFYDUXGUXJUUNUXEEYAUXDUUJOWPUMYAUXDEVBUNWNUWQUXITZUVEUVN
        LMUXKUWBTZUVMUVDYDUXLUVMUVCUUJOUFZENZUVDUXLUXMUVLEUXLYAXGNZUUJXGNZUUSXG
        NZUXMUVLUHUWBUXOUXKUWCWQUXLUWMXGUUJUWMVLXGVRWRWSWTZUWQUWNUXIUWBUWNUWOUV
        KVHWDXAUXLUWMXGUUSUXRUWQUWOUXIUWBUWNUWOUVKVJWDZXAUXOUXPUXQXBUUNUUSOUFUX
        MUVLYAUUJUUSXHYAUUJUUSXCXDWHUMUXLUVCMNUXIUXNUVDPZUXLYAUUSUXKUWBWBUXLUWO
        UUSMNZUXSUWOUYAUTUUSXEUGUUSXFXIVFXJUWQUXIUWBVJUXHUXTUDUVCMUXDUVCUHZUXFU
        XNUXGUVDUYBUXEUXMEUXDUVCUUJOWPUMUXDUVCEVBUNVCXQXKXLXMXNXOVPVOXPXRXSXQKY
        EYHYIPLCMYACUHZYCYHYDYIUYCYBYGEYACDOWPUMYACEVBUNVCXT $.
    $}

    2sqlem7.2 $e |- Y = { z | E. x e. ZZ E. y e. ZZ ( ( x gcd y ) = 1 /\
      z = ( ( x ^ 2 ) + ( y ^ 2 ) ) ) } $.
    $( Lemma for ~ 2sq .  (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    2sqlem7 $p |- Y C_ ( S i^i NN ) $=
      ( cv co c1 wceq wa cz wrex cn wcel cc0 wb cn0 cgcd c2 caddc cab cin simpr
      cexp reximi 2sqlem2 sylibr wn wne ax-1ne0 gcdeq0 adantr eqeq1d necon3bbid
      bitr3d mpbiri cr cle wbr zsqcl2 ad2antrr nn0red nn0ge0d ad2antlr syl22anc
      add20 cc zcn sqeq0 bi2anan9 syl2anc bitrd mtbird wo nn0addcl syl2an elnn0
      sylib mt3d eleq1 syl5ibrcom expimpd rexlimivv elin sylanbrc abssi eqsstri
      ord ) FAIZBIZUAJZKLZCIZWLUBUGJZWMUBUGJZUCJZLZMZBNOZANOZCUDEPUEZHXCCXDXCWP
      EQZWPPQZWPXDQXCWTBNOZANOXEXBXGANXAWTBNWOWTUFUHUHABDWPEGUIUJXAXFABNNWLNQZW
      MNQZMZWOWTXFXJWOMZXFWTWSPQZXKXLWSRLZXKXMWLRLZWMRLZMZXKXPUKKRULUMXKXPKRXKW
      NRLZXPKRLXJXQXPSWOWLWMUNUOXKWNKRXJWOUFUPURUQUSXKXMWQRLZWRRLZMZXPXKWQUTQRW
      QVAVBWRUTQRWRVAVBXMXTSXKWQXHWQTQZXIWOWLVCZVDZVEXKWQYCVFXKWRXIWRTQZXHWOWMV
      CZVGZVEXKWRYFVFWQWRVIVHXKWLVJQZWMVJQZXTXPSXHYGXIWOWLVKVDXIYHXHWOWMVKVGYGX
      RXNYHXSXOWLVLWMVLVMVNVOVPXKXLXMXKWSTQZXLXMVQXJYIWOXHYAYDYIXIYBYEWQWRVRVSU
      OWSVTWAWKWBWPWSPWCWDWEWFWPEPWGWHWIWJ $.

    ${
      2sqlem9.5 $e |- ( ph -> A. b e. ( 1 ... ( M - 1 ) )
        A. a e. Y ( b || a -> b e. S ) ) $.
      2sqlem9.7 $e |- ( ph -> M || N ) $.
      ${
        2sqlem8.n $e |- ( ph -> N e. NN ) $.
        2sqlem8.m $e |- ( ph -> M e. ( ZZ>= ` 2 ) ) $.
        2sqlem8.1 $e |- ( ph -> A e. ZZ ) $.
        2sqlem8.2 $e |- ( ph -> B e. ZZ ) $.
        2sqlem8.3 $e |- ( ph -> ( A gcd B ) = 1 ) $.
        2sqlem8.4 $e |- ( ph -> N = ( ( A ^ 2 ) + ( B ^ 2 ) ) ) $.
        2sqlem8.c $e |- C = ( ( ( A + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
        2sqlem8.d $e |- D = ( ( ( B + ( M / 2 ) ) mod M ) - ( M / 2 ) ) $.
        $( Lemma for ~ 2sqlem8 .  (Contributed by Mario Carneiro,
           4-Jun-2016.) $)
        2sqlem8a $p |- ( ph -> ( C gcd D ) e. NN ) $=
          ( cz wcel cc0 wceq wa wn cgcd co cn cmin cdiv c1 wne c2 cuz cfv sylib
          eluz2b3 simpld 4sqlem5 cexp simprd cle cdivides simpr 4sqlem9 eluzelz
          wbr ex wb syl dvdssq syl2anc sylibrd wi ax-1ne0 eqnetrd neneqd gcdeq0
          a1i mtbid dvdslegcd syl31anc syl2and breq2d nnle1eq1 bitrd sylibd mpd
          necon3ad cc zcnd sqeq0 anbi12d gcdn0cl syl21anc ) AHUHUIZIUHUIZHUJUKZ
          IUJUKZULZUMHIUNUOUPUIAXDFHUQUOKURUOUHUIAFHKUBAKUPUIZKUSUTZAKVAVBVCUIZ
          XIXJULUAKVEVDZVFZUFVGVFZAXEGIUQUOKURUOUHUIAGIKUCXMUGVGVFZAHVAVHUOUJUK
          ZIVAVHUOUJUKZULZXHAXJXRUMAXIXJXLVIAXRKUSAXRKFGUNUOZVJVOZKUSUKZAXPKFVK
          VOZXQKGVKVOZXTAXPKVAVHUOZFVAVHUOVKVOZYBAXPYEAXPFHKUBXMUFAXPVLVMVPAKUH
          UIZFUHUIZYBYEVQAXKYFUAVAKVNVRZUBKFVSVTWAAXQYDGVAVHUOVKVOZYCAXQYIAXQGI
          KUCXMUGAXQVLVMVPAYFGUHUIZYCYIVQYHUCKGVSVTWAAYFYGYJFUJUKGUJUKULZUMYBYC
          ULXTWBYHUBUCAXSUJUKZYKAXSUJAXSUSUJUDUSUJUTAWCWGWDWEAYGYJYLYKVQUBUCFGW
          FVTWHKFGWIWJWKAXTKUSVJVOZYAAXSUSKVJUDWLAXIYMYAVQXMKWMVRWNWOWQWPAXPXFX
          QXGAHWRUIXPXFVQAHXNWSHWTVRAIWRUIXQXGVQAIXOWSIWTVRXAWHHIXBXC $.

        2sqlem8.e $e |- E = ( C / ( C gcd D ) ) $.
        2sqlem8.f $e |- F = ( D / ( C gcd D ) ) $.
        $( Lemma for ~ 2sq .  (Contributed by Mario Carneiro, 20-Jun-2015.) $)
        2sqlem8 $p |- ( ph -> M e. S ) $=
          ( vp c2 cexp co caddc cdiv cn wcel c1 wne cuz wa eluz2b3 sylib simpld
          cfv cz cc0 clt wbr cdivides cgcd cmul wceq cmin wb nnzd 4sqlem5 zsqcl
          4sqlem8 wi zsubcld syl3anc mp2and oveq1d zcnd eqtrd breqtrrd dvdssub2
          syl syl31anc mpbid cn0 zsqcl2 nn0cnd gcddvds nnne0d dvdsval2 syl5eqel
          syl2anc simprd sqmuld oveq2i divcan2d syl5eq eqtr3d oveq12d cle nn0zd
          gcdcld dvdstr mpbird a1i breqtrd mpd nn0red readdcld nnred sstri wrex
          wn cv oveq1 eqeq1d eqeq2d anbi12d syl112anc sseldi nngt0d cprime wral
          ad2antrl adantr zred cr rehalfcld nnsqcld 4sqlem7 letrd adddid gcdcom
          eluzelz zaddcld dvds2add addsub4d ax-1ne0 eqnetrd neneqd gcdeq0 mtbid
          2sqlem8a dvdslegcd simpr necon3ai gcdn0cl syl21anc nnle1eq1 nn0addcld
          2nn rplpwr coprmdvds cin 2sqlem7 inss2 ax-1cn mulid1d mulgcd 3eqtr2rd
          mulcanad eqidd oveq2 oveq2d rspc2ev ovex eqeq1 anbi2d 2rexbidv sylibr
          cc elab2 divgt0d elnnz sylanbrc cfz prmnn peano2zm simprr prmz dvdsle
          1re nn0ge0d lemul1ad mulid2d 3brtr3d le2addd recnd 2halvesd crp nnrpd
          nnge1d rphalflt lelttrd sqvald ltdivmul fznn mpbir2and dvdsmul2 breq1
          zltlem1 jca eleq1 imbi12d breq2 imbi1d rspc2v syl3c ralrimiva eqeltrd
          expr inss1 2sqlem6 ) AEMKUMUNUOZLUMUNUOZUPUOZMUQUOZJULRAMURUSZMUTVAZA
          MUMVBVGUSZUYGUYHVCUCMVDVEVFZAUYFVHUSZVIUYFVJVKUYFURUSZAMUYEVLVKZUYKAM
          HIVMUOZUMUNUOZUYEVNUOZVLVKZMUYOVMUOZUTVOZUYMAMHUMUNUOZIUMUNUOZUPUOZUY
          PVLAMNVLVKZMVUBVLVKZUAAMVHUSZNVHUSVUBVHUSMNVUBVPUOZVLVKVUCVUDVQAUYIVU
          EUCUMMUUCWKZANUBVRAUYTVUAAHVHUSZUYTVHUSAVUHFHVPUOZMUQUOVHUSZAFHMUDUYJ
          UHVSZVFZHVTWKZAIVHUSZVUAVHUSAVUNGIVPUOZMUQUOVHUSZAGIMUEUYJUIVSZVFZIVT
          WKZUUDAMFUMUNUOZUYTVPUOZGUMUNUOZVUAVPUOZUPUOZVUFVLAMVVAVLVKZMVVCVLVKZ
          MVVDVLVKZAFHMUDUYJUHWAAGIMUEUYJUIWAAVUEVVAVHUSVVCVHUSVVEVVFVCVVGWBVUG
          AVUTUYTAFVHUSZVUTVHUSUDFVTWKZVUMWCAVVBVUAAGVHUSZVVBVHUSUEGVTWKZVUSWCM
          VVAVVCUUEWDWEAVUFVUTVVBUPUOZVUBVPUOVVDANVVLVUBVPUGWFAVUTVVBUYTVUAAVUT
          VVIWGAVVBVVKWGAUYTVUMWGAVUAVUSWGUUFWHWIMNVUBWJWLWMAUYPUYOUYCVNUOZUYOU
          YDVNUOZUPUOVUBAUYOUYCUYDAUYOAUYNVHUSZUYOWNUSAUYNABCDEFGHIJMNOPQRSTUAU
          BUCUDUEUFUGUHUIUULZVRZUYNWOWKWPAUYCAKVHUSZUYCWNUSAKHUYNUQUOZVHUJAUYNH
          VLVKZVVSVHUSZAVVTUYNIVLVKZAVUHVUNVVTVWBVCVULVURHIWQXAZVFZAVVOUYNVIVAZ
          VUHVVTVWAVQVVQAUYNVVPWRZVULUYNHWSWDWMWTZKWOWKZWPAUYDALVHUSZUYDWNUSALI
          UYNUQUOZVHUKAVWBVWJVHUSZAVVTVWBVWCXBZAVVOVWEVUNVWBVWKVQVVQVWFVURUYNIW
          SWDWMWTZLWOWKZWPUUAAVVMUYTVVNVUAUPAUYNKVNUOZUMUNUOVVMUYTAUYNKAUYNVVQW
          GZAKVWGWGXCAVWOHUMUNAVWOUYNVVSVNUOHKVVSUYNVNUJXDAHUYNAHVULWGVWPVWFXEX
          FZWFXGAUYNLVNUOZUMUNUOVVNVUAAUYNLVWPALVWMWGXCAVWRIUMUNAVWRUYNVWJVNUOI
          LVWJUYNVNUKXDAIUYNAIVURWGVWPVWFXEXFZWFXGXHWHZWIAUYRUYOMVMUOZUTAVUEUYO
          VHUSZUYRVXAVOVUGAVVOVXBVVQUYNVTWKZMUYOUUBXAAUYNMVMUOZUTVOZVXAUTVOZAVX
          DUTXIVKZVXEAVXDFGVMUOZUTXIAVXDFVLVKZVXDGVLVKZVXDVXHXIVKZAVXIVXDHVLVKZ
          AVXDUYNVLVKZVVTVXLAVXMVXDMVLVKZAVVOVUEVXMVXNVCVVQVUGUYNMWQXAZVFZVWDAV
          XDVHUSZVVOVUHVXMVVTVCVXLWBAVXDAUYNMVVQVUGXKXJZVVQVULVXDUYNHXLWDWEAVXQ
          VVHVUHVXDVUIVLVKZVXIVXLVQVXRUDVULAVXNMVUIVLVKZVXSAVXMVXNVXOXBZAVXTVUJ
          AVUHVUJVUKXBAVUEMVIVAZVUIVHUSZVXTVUJVQVUGAMUYJWRZAFHUDVULWCZMVUIWSWDX
          MAVXQVUEVYCVXNVXTVCVXSWBVXRVUGVYEVXDMVUIXLWDWEVXDFHWJWLXMAVXJVXDIVLVK
          ZAVXMVWBVYFVXPVWLAVXQVVOVUNVXMVWBVCVYFWBVXRVVQVURVXDUYNIXLWDWEAVXQVVJ
          VUNVXDVUOVLVKZVXJVYFVQVXRUEVURAVXNMVUOVLVKZVYGVYAAVYHVUPAVUNVUPVUQXBA
          VUEVYBVUOVHUSZVYHVUPVQVUGVYDAGIUEVURWCZMVUOWSWDXMAVXQVUEVYIVXNVYHVCVY
          GWBVXRVUGVYJVXDMVUOXLWDWEVXDGIWJWLXMAVXQVVHVVJFVIVOGVIVOVCZYBVXIVXJVC
          VXKWBVXRUDUEAVXHVIVOZVYKAVXHVIAVXHUTVIUFUTVIVAAUUGXNUUHUUIAVVHVVJVYLV
          YKVQUDUEFGUUJXAUUKVXDFGUUMWLWEUFXOAVXDURUSZVXGVXEVQAVVOVUEUYNVIVOZMVI
          VOZVCZYBZVYMVVQVUGAVYBVYQVYDVYPMVIVYNVYOUUNUUOWKUYNMUUPUUQVXDUURWKWMA
          UYNURUSUYGUMURUSZVXEVXFWBVVPUYJVYRAUUTXNUYNMUMUVAWDXPWHAVUEVXBUYEVHUS
          ZUYQUYSVCUYMWBVUGVXCAUYEAUYCUYDVWHVWNUUSZXJZMUYOUYEUVBWDWEAVUEVYBVYSU
          YMUYKVQVUGVYDWUAMUYEWSWDWMZAUYEMAUYCUYDAUYCVWHXQAUYDVWNXQXRZAMUYJXSZA
          UYEAOURUYEOJURUVCZURBCDEJORSUVDZJURUVEXTABYCZCYCZVMUOZUTVOZUYEWUGUMUN
          UOZWUHUMUNUOZUPUOZVOZVCZCVHYABVHYAZUYEOUSZAVVRVWIKLVMUOZUTVOZUYEUYEVO
          ZWUPVWGVWMAWURUTUYNAWURAKLVWGVWMXKWPUTUVTUSAUVFXNVWPVWFAUYNUTVNUOUYNV
          WOVWRVMUOZUYNWURVNUOZAUYNVWPUVGAVWOHVWRIVMVWQVWSXHAUYNWNUSVVRVWIWVAWV
          BVOAHIVULVURXKVWGVWMUYNKLUVHWDUVIUVJAUYEUVKWUOWUSWUTVCKWUHVMUOZUTVOZU
          YEUYCWULUPUOZVOZVCBCKLVHVHWUGKVOZWUJWVDWUNWVFWVGWUIWVCUTWUGKWUHVMYDYE
          WVGWUMWVEUYEWVGWUKUYCWULUPWUGKUMUNYDWFYFYGWUHLVOZWVDWUSWVFWUTWVHWVCWU
          RUTWUHLKVMUVLYEWVHWVEUYEUYEWVHWULUYDUYCUPWUHLUMUNYDUVMYFYGUVNYHWUJDYC
          ZWUMVOZVCZCVHYABVHYAWUPDUYEOUYCUYDUPUVOWVIUYEVOZWVKWUOBCVHVHWVLWVJWUN
          WUJWVIUYEWUMUVPUVQUVRSUWAUVSZYIYJAMUYJYJZUWBUYFUWCUWDZAULYCZUYFVLVKZW
          VPJUSZWBULYKAWVPYKUSZWVQWVRAWVSWVQVCZVCZWVPUTMUTVPUOZUWEUOZUSZWUQVCQY
          CZPYCZVLVKZWWEJUSZWBZPOYLQWWCYLZWVPUYEVLVKZWVRWWAWWDWUQWWAWWDWVPURUSZ
          WVPWWBXIVKZWVSWWLAWVQWVPUWFYMZWWAWVPUYFWWBWWAWVPWWNXSWWAUYFAUYKWVTWUB
          YNZYOAWWBYPUSWVTAWWBAVUEWWBVHUSZVUGMUWGWKZYOYNWWAWVQWVPUYFXIVKZAWVSWV
          QUWHZWWAWVPVHUSZUYLWVQWWRWBWVSWWTAWVQWVPUWIYMZAUYLWVTWVOYNWVPUYFUWJXA
          XPAUYFWWBXIVKZWVTAUYFMVJVKZWXBAWXCUYEMMVNUOZVJVKZAUYEMUMUNUOZWXDVJAUY
          EWXFUMUQUOZWXFWUCAWXFAWXFAVUEWXFVHUSVUGMVTWKYOZYQZWXHAUYEVUBWXGWUCAUY
          TVUAAUYTVUMYOZAVUAVUSYOZXRWXIAUTUYEVNUOUYPUYEVUBXIAUTUYOUYEUTYPUSAUWK
          XNAUYOAUYNVVPYRZXSWUCAUYEVYTUWLAUYOWXLUXAUWMAUYEAUYEVYTWPZUWNVWTUWOAV
          UBWXGUMUQUOZWXNUPUOWXGXIAUYTVUAWXNWXNWXJWXKAWXGWXIYQZWXOAFHMUDUYJUHYS
          AGIMUEUYJUIYSUWPAWXGAWXGWXIUWQUWRXOYTAWXFUWSUSWXGWXFVJVKAWXFAMUYJYRUW
          TWXFUXBWKUXCAMAMVUGWGZUXDXOAUYEYPUSMYPUSZWXQVIMVJVKWXCWXEVQWUCWUDWUDW
          VNUYEMMUXEYHXMAUYKVUEWXCWXBVQWUBVUGUYFMUXJXAWMYNYTWWAWWPWWDWWLWWMVCVQ
          AWWPWVTWWQYNWVPWWBUXFWKUXGAWUQWVTWVMYNUXKAWWJWVTTYNWWAWVQUYFUYEVLVKZW
          WKWWSAWXRWVTAUYFMUYFVNUOZUYEVLAVUEUYKUYFWXSVLVKVUGWUBMUYFUXHXAAUYEMWX
          MWXPVYDXEZXOYNWWAWWTUYKVYSWVQWXRVCWWKWBWXAWWOAVYSWVTWUAYNWVPUYFUYEXLW
          DWEWWIWWKWVRWBWVPWWFVLVKZWVRWBQPWVPUYEWWCOWWEWVPVOWWGWYAWWHWVRWWEWVPW
          WFVLUXIWWEWVPJUXLUXMWWFUYEVOWYAWWKWVRWWFUYEWVPVLUXNUXOUXPUXQUXTUXRAWX
          SUYEJWXTAOJUYEOWUEJWUFJURUYAXTWVMYIUXSUYB $.
      $}

      2sqlem9.6 $e |- ( ph -> M e. NN ) $.
      2sqlem9.4 $e |- ( ph -> N e. Y ) $.
      $( Lemma for ~ 2sq .  (Contributed by Mario Carneiro, 19-Jun-2015.) $)
      2sqlem9 $p |- ( ph -> M e. S ) $=
        ( co c1 cz vu vv cv cgcd wceq c2 cexp caddc wa wrex wcel eqeq1 2rexbidv
        anbi2d oveq1 eqeq1d oveq1d eqeq2d anbi12d oveq2d cbvrex2v syl6bb elab2g
        oveq2 ibi syl simpr cabs cfv cgz zgz ax-mp sq1 eqcomi fveq2 abs1 syl6eq
        rspcev mp2an 2sqlem1 mpbir syl6eqel wne cdiv cmo cmin cdivides wbr wral
        1z wi cfz ad2antrr cn cin 2sqlem7 inss2 sstri sseldi cuz simprr eluz2b3
        sylanbrc simplrl simplrr simprll simprlr 2sqlem8 anassrs pm2.61dane mpd
        eqid ex rexlimdvva ) AUAUCZUBUCZUDRZSUEZHXOUFUGRZXPUFUGRZUHRZUEZUIZUBTU
        JUATUJZGFUKZAHIUKZYDQYFYDBUCZCUCZUDRZSUEZDUCZYGUFUGRZYHUFUGRZUHRZUEZUIZ
        CTUJBTUJZYDDHIIYKHUEZYQYJHYNUEZUIZCTUJBTUJYDYRYPYTBCTTYRYOYSYJYKHYNULUN
        UMYTYCXOYHUDRZSUEZHXSYMUHRZUEZUIBCUAUBTTYGXOUEZYJUUBYSUUDUUEYIUUASYGXOY
        HUDUOUPUUEYNUUCHUUEYLXSYMUHYGXOUFUGUOUQURUSYHXPUEZUUBXRUUDYBUUFUUAXQSYH
        XPXOUDVDUPUUFUUCYAHUUFYMXTXSUHYHXPUFUGUOUTURUSVAVBMVCVEVFAYCYEUAUBTTAXO
        TUKZXPTUKZUIZUIZYCYEUUJYCUIZYEGSUUKGSUEZUIGSFUUKUULVGSFUKSYGVHVIZUFUGRZ
        UEZBVJUJZSVJUKZSSUFUGRZUEZUUPSTUKUUQWJSVKVLUURSVMVNUUOUUSBSVJYGSUEZUUNU
        URSUUTUUMSUFUGUUTUUMSVHVISYGSVHVOVPVQUQURVRVSBESFLVTWAWBUUJYCGSWCZYEUUJ
        YCUVAUIZUIZBCDEXOXPXOGUFWDRZUHRGWERUVDWFRZXPUVDUHRGWERUVDWFRZFUVEUVEUVF
        UDRZWDRZUVFUVGWDRZGHIJKLMAKUCZJUCWGWHUVJFUKWKJIWIKSGSWFRWLRWIUUIUVBNWMA
        GHWGWHUUIUVBOWMAHWNUKUUIUVBAIWNHIFWNWOWNBCDEFILMWPFWNWQWRQWSWMUVCGWNUKZ
        UVAGUFWTVIUKAUVKUUIUVBPWMUUJYCUVAXAGXBXCAUUGUUHUVBXDAUUGUUHUVBXEUUJXRYB
        UVAXFUUJXRYBUVAXGUVEXLUVFXLUVHXLUVIXLXHXIXJXMXNXK $.
    $}

    $( Lemma for ~ 2sq .  Every factor of a "proper" sum of two squares (where
       the summands are coprime) is a sum of two squares.  (Contributed by
       Mario Carneiro, 19-Jun-2015.) $)
    2sqlem10 $p |- ( ( A e. Y /\ B e. NN /\ B || A ) -> B e. S ) $=
      ( va vb wcel cdivides wral c1 cfz co wceq raleqdv vm vn cn cv wi elfz1end
      wbr biimpi caddc oveq2 elfz1eq cabs cfv c2 cexp cgz wrex cz zgz ax-mp sq1
      1z eqcomi fveq2 abs1 syl6eq oveq1d eqeq2d rspcev mp2an mpbir syl6eqel a1d
      2sqlem1 ralrimivw rgen csn wa cmin simplr cc nncn ad2antrr ax-1cn sylancl
      pncan oveq2d mpbird simprr peano2nn simprl 2sqlem9 ralrimiva breq2 imbi1d
      expr cbvralv syl6ibr ovex breq1 eleq1 imbi12d ralbidv ralsn ancld cun cuz
      ex elnnuz fzsuc sylbi ralunb syl6bb sylibrd nnind rspcv sylc syl5 3imp )
      EHMZFUCMZFENUGZFGMZYAFKUDZNUGZYCUEZKHOZXTYBYCUEZYAFPFQRZMZLUDZYDNUGZYKGMZ
      UEZKHOZLYIOZYGYAYJFUFUHYOLPUAUDZQRZOYOLPPQRZOYOLPUBUDZQRZOZYOLPYTPUIRZQRZ
      OZYPUAUBFYQPSYOLYRYSYQPPQUJTYQYTSYOLYRUUAYQYTPQUJTYQUUCSYOLYRUUDYQUUCPQUJ
      TYQFSYOLYRYIYQFPQUJTYOLYSYKYSMZYNKHUUFYMYLUUFYKPGYKPUKPGMPAUDZULUMZUNUORZ
      SZAUPUQZPUPMZPPUNUORZSZUUKPURMUULVBPUSUTUUMPVAVCUUJUUNAPUPUUGPSZUUIUUMPUU
      OUUHPUNUOUUOUUHPULUMPUUGPULVDVEVFVGVHVIVJADPGIVNVKVLVMVOVPYTUCMZUUBUUBYOL
      UUCVQZOZVRZUUEUUPUUBUURUUPUUBUUCYDNUGZUUCGMZUEZKHOZUURUUPUUBUUCYQNUGZUVAU
      EZUAHOZUVCUUPUUBUVFUUPUUBVRZUVEUAHUVGYQHMZUVDUVAUVGUVHUVDVRZVRZABCDGUUCYQ
      HKLIJUVJYOLPUUCPVSRZQRZOUUBUUPUUBUVIVTUVJYOLUVLUUAUVJUVKYTPQUVJYTWAMZPWAM
      UVKYTSUUPUVMUUBUVIYTWBWCWDYTPWFWEWGTWHUVGUVHUVDWIUUPUUCUCMUUBUVIYTWJWCUVG
      UVHUVDWKWLWPWMXHUVBUVEKUAHYDYQSUUTUVDUVAYDYQUUCNWNWOWQWRYOUVCLUUCYTPUIWSY
      KUUCSZYNUVBKHUVNYLUUTYMUVAYKUUCYDNWTYKUUCGXAXBXCXDWRXEUUPUUEYOLUUAUUQXFZO
      UUSUUPYOLUUDUVOUUPYTPXGUMMUUDUVOSYTXIPYTXJXKTYOLUUAUUQXLXMXNXOYOYGLFYIYKF
      SZYNYFKHUVPYLYEYMYCYKFYDNWTYKFGXAXBXCXPXQYFYHKEHYDESYEYBYCYDEFNWNWOXPXRXS
      $.

    $( Lemma for ~ 2sq .  (Contributed by Mario Carneiro, 19-Jun-2015.) $)
    2sqlem11 $p |- ( ( P e. Prime /\ ( P mod 4 ) = 1 ) -> P e. S ) $=
      ( wcel c4 co c1 wceq wa c2 cexp wbr cz caddc vn cprime cneg cmin cdivides
      cmo cv wn wrex clgs simpr csn cdif wb wne simpl 1ne2 necomi oveq1 crp cc0
      cr cle clt 2re 4re 4pos elrpii 2pos ltleii 2lt4 modid mp4an syl6eq neeq1d
      0re mpbiri necon2i syl eldifsn sylanbrc m1lgs mpbird znegcl ax-mp sylancr
      1z lgsqr mpbid simprd cgcd simprl a1i ad2antrl eqidd eqeq1d oveq1d eqeq2d
      cn gcd1 anbi12d oveq2 oveq2d rspc2ev syl112anc ovex eqeq1 anbi2d 2rexbidv
      sq1 elab2 sylibr prmnn ad2antrr simprr zcnd ax-1cn subneg sylancl breqtrd
      cc sqcld 2sqlem10 syl3anc rexlimddv ) EUBJZEKUFLZMNZOZEUAUGZPQLZMUCZUDLZU
      ERZEFJZUASYIEYLUERUHZYNUASUIZYIYLEUJLMNZYPYQOZYIYRYHYFYHUKZYIEUBPULUMJZYR
      YHUNYIYFEPUOZUUAYFYHUPYIYHUUBYTEPYGMEPNZYGMUOPMUOMPUQURUUCYGPMUUCYGPKUFLZ
      PEPKUFUSPVBJKUTJVAPVCRPKVDRUUDPNVEKVFVGVHVAPVPVEVIVJVKPKVLVMVNVOVQVRVSEUB
      PVTWAZEWBVSWCYIYLSJZUUAYRYSUNMSJZUUFWGMWDWEUUEUAYLEWHWFWIWJYIYJSJZYNOZOZY
      KMTLZGJZEWSJZEUUKUERYOUUJAUGZBUGZWKLZMNZUUKUUNPQLZUUOPQLZTLZNZOZBSUIASUIZ
      UULUUJUUHUUGYJMWKLZMNZUUKUUKNZUVCYIUUHYNWLZUUGUUJWGWMUUHUVEYIYNYJWTWNUUJU
      UKWOUVBUVEUVFOYJUUOWKLZMNZUUKYKUUSTLZNZOABYJMSSUUNYJNZUUQUVIUVAUVKUVLUUPU
      VHMUUNYJUUOWKUSWPUVLUUTUVJUUKUVLUURYKUUSTUUNYJPQUSWQWRXAUUOMNZUVIUVEUVKUV
      FUVMUVHUVDMUUOMYJWKXBWPUVMUVJUUKUUKUVMUUSMYKTUVMUUSMPQLMUUOMPQUSXJVNXCWRX
      AXDXEUUQCUGZUUTNZOZBSUIASUIUVCCUUKGYKMTXFUVNUUKNZUVPUVBABSSUVQUVOUVAUUQUV
      NUUKUUTXGXHXIIXKXLYFUUMYHUUIEXMXNUUJEYMUUKUEYIUUHYNXOUUJYKYAJMYAJYMUUKNUU
      JYJUUJYJUVGXPYBXQYKMXRXSXTABCDUUKEFGHIYCYDYE $.
  $}

  ${
    $d a b w x y z P $.
    $( All primes of the form ` 4 k + 1 ` are sums of two squares.
       (Contributed by Mario Carneiro, 20-Jun-2015.) $)
    2sq $p |- ( ( P e. Prime /\ ( P mod 4 ) = 1 ) ->
        E. x e. ZZ E. y e. ZZ P = ( ( x ^ 2 ) + ( y ^ 2 ) ) ) $=
      ( vw vz va vb wcel co c1 wceq wa cv c2 cexp caddc cz wrex cgcd oveq1 cabs
      cprime c4 cmo cgz cfv cmpt crn cab eqid eqeq1d oveq1d eqeq2d oveq2 oveq2d
      anbi12d cbvrex2v abbii 2sqlem11 2sqlem2 sylib ) CUBHCUCUDIJKLCDUEDMUAUFNO
      IUGUHZHCAMZNOIZBMZNOIZPIZKBQRAQRABEDCVBFMZGMZSIZJKZEMZVHNOIZVINOIZPIZKZLZ
      GQRFQRZEUIVBUJZVRVCVESIZJKZVLVGKZLZBQRAQREVQWCVCVISIZJKZVLVDVNPIZKZLFGABQ
      QVHVCKZVKWEVPWGWHVJWDJVHVCVISTUKWHVOWFVLWHVMVDVNPVHVCNOTULUMUPVIVEKZWEWAW
      GWBWIWDVTJVIVEVCSUNUKWIWFVGVLWIVNVFVDPVIVENOTUOUMUPUQURUSABDCVBVSUTVA $.
  $}

  ${
    $d x B $.  $d x P $.  $d x X $.
    2sqb.1 $e |- ( ph -> ( P e. Prime /\ P =/= 2 ) ) $.
    2sqb.2 $e |- ( ph -> ( X e. ZZ /\ Y e. ZZ ) ) $.
    2sqb.3 $e |- ( ph -> P = ( ( X ^ 2 ) + ( Y ^ 2 ) ) ) $.
    2sqb.4 $e |- ( ph -> A e. ZZ ) $.
    2sqb.5 $e |- ( ph -> B e. ZZ ) $.
    2sqb.6 $e |- ( ph -> ( P gcd Y ) = ( ( P x. A ) + ( Y x. B ) ) ) $.
    $( The converse to ~ 2sq .  (Contributed by Mario Carneiro,
       20-Jun-2015.) $)
    2sqblem $p |- ( ph -> ( P mod 4 ) = 1 ) $=
      ( c1 co cdivides wbr c2 cz wcel syl vx cneg clgs wceq c4 cmo wn cexp cmin
      cv wrex cprime simpld nprmdvds1 wb prmz 1z dvdsnegb sylancl mtbid zmulcld
      wne cmul caddc zsqcl dvdsmul1 syl2anc simprd peano2zm peano2zd addcomd cc
      ax-1cn a1i ppncand adddird oveq1d sqmuld oveq12d 3eqtr4rd 3eqtrd breqtrrd
      zcnd mpbid negsubdi2 sylancr cgcd cabs cfv cle cr zred absresq resqcld cn
      clt prmnn nnred cn0 zsqcl2 nn0addge2 exp1d 2z prmuz2 eluz2b2 simprbi 1lt2
      cuz ltexp2a syl32anc lelttrd eqbrtrd abscld absge0d nnnn0d nn0ge0d lt2sqd
      eqbrtrrd mpbird ltnled wi sqnprm abs00ad eqeltrrd oveq2d eleq1d syl5ibcom
      cc0 sq0i addid1d sylibd sylbid mtod wo nn0abscl elnn0 sylib ord eqtr3d wa
      mt3d dvdsle dvdsabsb mtbird coprm pncand eqtrd dvdsmultr2 syl3anc mpd sq1
      negeqd oveq2i subsq syl5eqr dvdsadd2b syl112anc subneg breq2d rspcev cdif
      oveq1 csn znegcl ax-mp eldifsn sylibr lgsqr mpbir2and m1lgs ) AMUBZDUCNMU
      DZDUEUFNMUDZAUVLDUVKOPZUGZDUAUJZQUHNZUVKUINZOPZUARUKZADMOPZUVNADULSZUWAUG
      AUWBDQVBZGUMZDUNTADRSZMRSZUWAUVNUOAUWBUWEUWDDUPTZUQDMURUSUTAECVCNZRSZDUWH
      QUHNZUVKUINZOPZUVTAECAERSZFRSZHUMZKVAZADUWJMVDNZUWKOADUWQOPZDFCVCNZQUHNZM
      UINZUWQVDNZOPZADDCQUHNZVCNZUXBOAUWEUXDRSZDUXEOPUWGACRSUXFKCVETZDUXDVFVGAU
      XBUWQUXAVDNUWJUWTVDNZUXEAUXAUWQAUXAAUWTRSZUXARSZAUWSRSZUXIAFCAUWMUWNHVHZK
      VAZUWSVETZUWTVITZWCAUWQAUWJAUWIUWJRSUWPUWHVETZVJZWCVKAUWJMUWTAUWJUXPWCZMV
      LSZAVMVNAUWTUXNWCVOAEQUHNZFQUHNZVDNZUXDVCNUXTUXDVCNZUYAUXDVCNZVDNUXEUXHAU
      XTUYAUXDAUXTAUWMUXTRSUWOEVETWCZAUYAAUWNUYARSUXLFVETWCAUXDUXGWCVPADUYBUXDV
      CIVQAUWJUYCUWTUYDVDAECAEUWOWCACKWCZVRAFCAFUXLWCZUYFVRVSVTWAWBAUWEUWQRSUXJ
      DUXAOPUWRUXCUOUWGUXQUXOADUWSMVDNZUWSMUINZVCNZUXAOADUYIOPZDUYJOPZADDBVCNZU
      BZUYIOADUYMOPZDUYNOPZAUWEBRSUYOUWGJDBVFVGAUWEUYMRSUYOUYPUOUWGADBUWGJVAZDU
      YMURVGWDAMUWSUINZUBZUYIUYNAUXSUWSVLSZUYSUYIUDVMAUWSUXMWCZMUWSWEWFAUYRUYMA
      UYRUYMUWSVDNZUWSUINUYMAMVUBUWSUIADFWGNZMVUBADFOPZUGZVUCMUDZAVUDDFWHWIZOPZ
      AVUHDVUGWJPZAVUGDWPPZVUIUGAVUJVUGQUHNZDQUHNZWPPAVUKUYAVULWPAFWKSVUKUYAUDA
      FUXLWLZFWMTAUYADVULAFVUMWNZADAUWBDWOSZUWDDWQTZWRZADVUQWNAUYAUYBDWJAUYAWKS
      UXTWSSZUYAUYBWJPVUNAUWMVURUWOEWTTUYAUXTXAVGIWBADMUHNZDVULWPADADUWGWCXBADW
      KSUWFQRSZMDWPPZMQWPPZVUSVULWPPVUQUWFAUQVNVUTAXCVNADQXHWISZVVAAUWBVVCUWDDX
      DTVVCVUOVVADXEXFTVVBAXGVNDMQXIXJXRXKXLAVUGDAFUYGXMZVUQAFUYGXNADADVUPXOXPX
      QXSAVUGDVVDADUWGWLXTWDAUWEVUGWOSZVUHVUIYAUWGAVVEVUGYHUDZAVVFUXTULSZAUWMVV
      GUGUWOEYBTAVVFFYHUDZVVGAFUYGYCAVVHUXTYHVDNZULSZVVGAUYBULSVVHVVJADUYBULIUW
      DYDVVHUYBVVIULVVHUYAYHUXTVDFYIYEYFYGAVVIUXTULAUXTUYEYJYFYKYLYMAVVEVVFAVUG
      WSSZVVEVVFYNAUWNVVKUXLFYOTVUGYPYQYRUUADVUGUUBVGYMAUWEUWNVUDVUHUOUWGUXLDFU
      UCVGUUDAUWBUWNVUEVUFUOUWDUXLDFUUEVGWDLYSVQAUYMUWSAUYMUYQWCVUAUUFUUGUULYSW
      BAUWEUYHRSUYIRSZUYKUYLYAUWGAUWSUXMVJAUXKVVLUXMUWSVITDUYHUYIUUHUUIUUJAUXAU
      WTMQUHNZUINZUYJVVMMUWTUIUUKUUMAUYTUXSVVNUYJUDVUAVMUWSMUUNUSUUOWBDUWQUXAUU
      PUUQXSAUWJVLSUXSUWKUWQUDUXRVMUWJMUURUSWBUVSUWLUAUWHRUVPUWHUDZUVRUWKDOVVOU
      VQUWJUVKUIUVPUWHQUHUVBVQUUSUUTVGAUVKRSZDULQUVCUVASZUVLUVOUVTYTUOUWFVVPUQM
      UVDUVEAUWBUWCYTVVQGDULQUVFUVGZUAUVKDUVHWFUVIAVVQUVLUVMUOVVRDUVJTWD $.
  $}

  ${
    $d a b x y P $.
    $( The converse to ~ 2sq .  (Contributed by Mario Carneiro,
       20-Jun-2015.) $)
    2sqb $p |- ( P e. Prime ->
      ( E. x e. ZZ E. y e. ZZ P = ( ( x ^ 2 ) + ( y ^ 2 ) ) <->
        ( P = 2 \/ ( P mod 4 ) = 1 ) ) ) $=
      ( va vb wcel cv c2 cexp co caddc wceq cz wrex c1 wa rexlimdvva 1z syl6eq
      cmul cprime c4 cmo wo wn df-ne cgcd prmz ad3antrrr simplrr bezout syl2anc
      wne simplll simpllr simplr simprll simprlr simprr 2sqblem mpd ex impancom
      expr syl5bir orrd oveq1 oveq1d eqeq2d oveq2d 1p1e2 rspc2ev mp3an12 adantl
      sq1 2sq jaodan impbida ) CUAFZCAGZHIJZBGZHIJZKJZLZBMNAMNZCHLZCUBUCJOLZUDV
      SWFPZWGWHWGUECHUMZWIWHCHUFVSWJWFWHVSWJPZWEWHABMMWKVTMFZWBMFZPZPZWEWHWOWEP
      ZCWBUGJCDGZTJWBEGZTJKJLZEMNDMNZWHWPCMFZWMWTVSXAWJWNWECUHUIWKWLWMWEUJDECWB
      UKULWPWSWHDEMMWPWQMFZWRMFZPZWSWHWPXDWSPZPWQWRCVTWBWKWNWEXEUNWKWNWEXEUOWOW
      EXEUPWPXBXCWSUQWPXBXCWSURWPXDWSUSUTVDQVAVBQVCVEVFVSWGWFWHWGWFVSOMFZXFWGWF
      RRWEWGCOWCKJZLABOOMMVTOLZWDXGCXHWAOWCKXHWAOHIJZOVTOHIVGVOSVHVIWBOLZXGHCXJ
      XGOOKJHXJWCOOKXJWCXIOWBOHIVGVOSVJVKSVIVLVMVNABCVPVQVR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Chebyshev's Weak Prime Number Theorem, Dirichlet's Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k K $.  $d k m n N $.
    chebbnd1lem1.1 $e |- K = if ( ( 2 x. N ) <_ ( ( 2 x. N ) _C N ) ,
      ( 2 x. N ) , ( ( 2 x. N ) _C N ) ) $.
    $( Lemma for ~ chebbnd1 : show a lower bound on ` ppi ( x ) ` at even
       integers using similar techniques to those used to prove ~ bpos .  (Note
       that the expression ` K ` is actually equal to ` 2 x. N ` , but proving
       that is not necessary for the proof, and it's too much work.)  The key
       to the proof is ~ bposlem1 , which shows that each term in the expansion
       ` ( ( 2 x. N ) _C N ) = prod_ p e. Prime `
       ` ( p ^ ( p pCnt ( ( 2 x. N ) _C N ) ) ) ` is at most ` 2 x. N ` , so
       that the sum really only has nonzero elements up to ` 2 x. N ` , and
       since each term is at most ` 2 x. N ` , after taking logs we get the
       inequality ` ppi ( 2 x. N ) x. log ( 2 x. N ) <_ `
       ` log ( ( 2 x. N ) _C N ) ` , and ~ bclbnd finishes the proof.
       (Contributed by Mario Carneiro, 22-Sep-2014.)  (Revised by Mario
       Carneiro, 15-Apr-2016.) $)
    chebbnd1lem1 $p |- ( N e. ( ZZ>= ` 4 ) -> ( log ` ( ( 4 ^ N ) / N ) ) <
      ( ( ppi ` ( 2 x. N ) ) x. ( log ` ( 2 x. N ) ) ) ) $=
      ( vk c4 cfv wcel co clog c2 cmul cn c1 syl cr wbr syl2anc cle cprime wa
      cuz cexp cdiv cbc cppi cn0 nnuz uztrn2 mpan nnnn0d nnexpcl nnrpd rpdivcld
      4nn sylancr relogcld cc0 cfz fzctr bccl2 cz 2z eluzelz zmulcl zred nn0red
      ppicl 2nn nnmulcl remulcld clt bclbnd crp logltb mpbid cif syl5eqel nnred
      wb ifcl cin cpc csu cfn fzfid inss1 ssfi sylancl nnzd min2 syl5eqbr eluz2
      cv syl3anbrc fzss2 ssrin sselda simpr sseldi elfznn inss2 adantr nnexpcld
      pccld syldan ce elin simprbi bposlem1 syl2an reeflogd 3brtr4d efle mpbird
      wss fsumle cc recnd cdif wn wceq eldifn adantl eldifad nncnd exp1d nnge1d
      adantrr simprr syl6eleq leexp2ad eqbrtrrd letrd elfzle2 syl3anc mpbir2and
      lemin a1i 2re ltletrd syl6breqr fznn sylanbrc expr wo elnn0 sylib ord mpd
      mtod oveq2d exp0d eqtrd fveq2d log1 syl6eq fsumss nn0zd relogexp sumeq2dv
      pclogsum 3eqtrd fsumconst eleqtri ppival2g oveq1d eqtr4d 3brtr3d ppiwordi
      chash min1 1re 1lt2 2cn mulid1i eluzelre pm3.2i lemul2 syl5eqbrr rplogcld
      2pos lemul1d ) BEUAFGZEBUBHZBUCHZIFZJBKHZBUDHZIFZUWGUEFZUWGIFZKHZUWCUWEUW
      CUWDBUWCUWDUWCELGZBUFGZUWDLGUNUWCBUWMUWCBLGZUNMBELUGUHUIZUJZEBUKUOULUWCBU
      WPULUMZUPUWCUWHUWCUWHUWCBUQUWGURHGZUWHLGZUWCUWNUWSUWQBUSNBUWGUTNZULZUPZUW
      CUWJUWKUWCUWJUWCUWGOGZUWJUFGUWCUWGUWCJVAGBVAGUWGVAGVBEBVCJBVDUOVEZUWGVGNV
      FZUWCUWGUWCUWGUWCJLGUWOUWGLGZVHUWPJBVIUOZULZUPZVJZUWCUWEUWHVKPZUWFUWIVKPZ
      BVLUWCUWEVMGUWHVMGUXLUXMVSUWRUXBUWEUWHVNQVOUWCUWIAUEFZUWKKHZUWLUXCUWCUXNU
      WKUWCUXNUWCAOGZUXNUFGUWCAUWCAUWGUWHRPZUWGUWHVPZLCUWCUXGUWTUXRLGUXHUXAUXQU
      WGUWHLVTQVQZVRZAVGNVFZUXJVJUXKUWCMAURHZSWAZDWMZUYDUWHWBHZUBHZIFZDWCZUYCUW
      KDWCZUWIUXORUWCUYCUYGUWKDUWCUYBWDGUYCUYBXOUYCWDGZUWCMAWEUYBSWFUYBUYCWGWHZ
      UWCUYDUYCGZUYDMUWHURHZSWAZGZUYGOGZUWCUYCUYNUYDUWCUYBUYMXOZUYCUYNXOUWCUWHA
      UAFGZUYQUWCAVAGZUWHVAGAUWHRPUYRUWCAUXSWIZUWCUWHUXAWIUWCAUXRUWHRCUWCUXDUWH
      OGZUXRUWHRPUXEUWCUWHUXAVRZUWGUWHWJQWKAUWHWLWNAMUWHWONUYBUYMSWPNZWQZUWCUYO
      TZUYFVUEUYFVUEUYDUYEVUEUYDUYMGZUYDLGZVUEUYNUYMUYDUYMSWFZUWCUYOWRZWSUYDUWH
      WTZNZVUEUYDUWHVUEUYNSUYDUYMSXAZVUIWSUWCUWTUYOUXAXBXDZXCZULZUPZXEZUWCUWKOG
      ZUYLUXJXBZUWCUYLTZUYGUWKRPZUYGXFFZUWKXFFZRPZVUTUYFUWGVVBVVCRUWCUWOUYDSGZU
      YFUWGRPZUYLUWPUYLUYDUYBGZVVEUYDUYBSXGZXHUYDBXIZXJVUTUYFUWCUYLUYOUYFVMGVUD
      VUOXEXKVUTUWGUWCUWGVMGUYLUXIXBXKXLVUTUYPVURVVAVVDVSVUQVUSUYGUWKXMQXNXPUWC
      UYHUYNUYGDWCUYNUYEUYDIFKHZDWCZUWIUWCUYCUYNUYGDVUCUWCUYLUYOUYGXQGVUDVUEUYG
      VUPXRXEUWCUYDUYNUYCXSGZTZUYGMIFUQVVMUYFMIVVMUYFUYDUQUBHMVVMUYEUQUYDUBVVMU
      YELGZXTUYEUQYAZVVMVVNUYLVVLUYLXTUWCUYDUYNUYCYBYCUWCVVLVVNUYLUWCVVLVVNTZTZ
      VVGVVEUYLVVQVVGVUGUYDARPZUWCVVLVUGVVNVVMVUFVUGVVMUYNUYMUYDVUHVVMUYDUYNUYC
      UWCVVLWRYDZWSZVUJNZYHZVVQUYDUXRARVVQUYDUXRRPZUYDUWGRPZUYDUWHRPZVVQUYDUYFU
      WGVVQUYDVWBVRZUWCVVLUYFOGVVNVVMUYFUWCVVLUYOUYFLGVVSVUNXEVRYHUWCUXDVVPUXEX
      BZVVQUYDMUBHUYDUYFRVVQUYDVVQUYDVWBYEYFVVQUYDMUYEVWFVVQUYDVWBYGVVQUYELMUAF
      ZUWCVVLVVNYIUGYJYKYLVVQUWOVVEVVFUWCUWOVVPUWPXBUWCVVLVVEVVNVVMUYNSUYDVULVV
      SWSYHZVVIQYMUWCVVLVWEVVNVVMVUFVWEVVTUYDMUWHYNNYHVVQUYDOGUXDVUAVWCVWDVWETV
      SVWFVWGUWCVUAVVPVUBXBUYDUWGUWHYQYOYPCUUAVVQUYSVVGVUGVVRTVSVVQAUWCALGVVPUX
      SXBWIUYDAUUBNYPVWIVVHUUCUUDUUJVVMVVNVVOVVMUYEUFGZVVNVVOUUEUWCVVLUYOVWJVVS
      VUMXEUYEUUFUUGUUHUUIUUKVVMUYDVVMUYDVWAYEUULUUMUUNUUOUUPUWCUYMWDGUYNUYMXOU
      YNWDGUWCMUWHWEVUHUYMUYNWGWHUUQUWCUYNUYGVVJDVUEUYDVMGUYEVAGUYGVVJYAVUEUYDV
      UKULVUEUYEVUMUURUYDUYEUUSQUUTUWCUWTVVKUWIYAUXAUWHDUVANUVBUWCUYIUYCUVJFZUW
      KKHZUXOUWCUYJUWKXQGUYIVWLYAUYKUWCUWKUXJXRUYCUWKDUVCQUWCUXNVWKUWKKUWCUYSJV
      WHGUXNVWKYAUYTJLVWHVHUGUVDAMUVEWHUVFUVGUVHUWCUXNUWJRPZUXOUWLRPUWCUXPUXDAU
      WGRPVWMUXTUXEUWCAUXRUWGRCUWCUXDVUAUXRUWGRPUXEVUBUWGUWHUVKQWKAUWGUVIYOUWCU
      XNUWJUWKUYAUXFUWCUWGUXEUWCMJUWGMOGZUWCUVLYRZJOGZUWCYSYRUXEMJVKPUWCUVMYRUW
      CJJMKHZUWGRJUVNUVOUWCMBRPZVWQUWGRPZUWCBUWPYGUWCVWNBOGVWPUQJVKPZTZVWRVWSVS
      VWOEBUVPVXAUWCVWPVWTYSUWAUVQYRMBJUVRYOVOUVSYTUVTUWBVOYMYT $.
  $}

  ${
    chebbnd1lem2.1 $e |- M = ( |_ ` ( N / 2 ) ) $.
    $( Lemma for ~ chebbnd1 :  Show that ` log ( N ) / N ` does not change too
       much between ` N ` and ` M = |_ ( N / 2 ) ` .  (Contributed by Mario
       Carneiro, 22-Sep-2014.) $)
    chebbnd1lem2 $p |- ( ( N e. RR /\ 8 <_ N ) ->
      ( ( log ` ( 2 x. M ) ) / ( 2 x. M ) ) < ( 2 x. ( ( log ` N ) / N ) ) ) $=
      ( cr wcel c8 cle wbr c2 cmul co cfv cdiv crp c4 a1i cc0 clt c1 ceu wa 2rp
      clog cn cuz 4nn cz nnzi cfl rehalfcl adantr flcld syl5eqel 4t2e8 syl5eqbr
      simpr wb 4re simpl 2re 2pos lemuldiv syl112anc mpbid flge syl6breqr eluz2
      sylancl syl3anbrc nnuz uztrn2 sylancr rpmulcl relogcld rerpdivcld 0re 8re
      nnrpd 8pos ltletrd elrpd rphalfcld remulcl caddc zred peano2re syl flltp1
      oveq1i 1re nnge1d leadd2dd recnd 2timesd breqtrrd ere egt2lt3 simpri 3lt4
      c3 3re lttri mp2an ltled lttrd logdivlt syl22anc rphalflt logltb ltdiv1dd
      syl2anc rpne0d wne 2ne0 divdiv2d mulcomd oveq1d divassd 3eqtrd breqtrd )
      BDEZFBGHZUAZIAJKZUCLZYDMKZBIMKZUCLZYGMKZIBUCLZBMKZJKZYCYEYDYCYDYCINEANEYD
      NEUBYCAYCOUDEAOUELEZAUDEUFYCOUGEZAUGEOAGHYMYNYCOUFUHZPYCAYGUILZUGCYCYGYAY
      GDEZYBBUJUKZULUMZYCOYPAGYCOYGGHZOYPGHZYCOIJKZBGHZYTYCUUBFBGUNYAYBUPZUOYCO
      DEZYAIDEZQIRHZUUCYTUQUUEYCURPZYAYBUSZUUFYCUTPZUUGYCVAPOBIVBVCVDZYCYQYNYTU
      UAUQYRYOYGOVEVHVDCVFOAVGVISAOUDVJVKVLZVRIAVMVLZVNUUMVOYCYHYGYCYGYCBYCBUUI
      YCQFBQDEYCVPPFDEYCVQPUUIQFRHYCVSPUUDVTWAZWBZVNZUUOVOYCUUFYKDEYLDEUTYCYJBY
      CBUUNVNZUUNVOIYKWCVLYCYGYDRHZYFYIRHZYCYGASWDKZYDYRYCADEZUUTDEYCAYSWEZAWFW
      GYCUUFUVAYDDEZUTUVBIAWCVLZYCYGYPSWDKZUUTRYCYQYGUVERHYRYGWHWGAYPSWDCWIVFYC
      UUTAAWDKYDGYCSAASDEYCWJPUVBUVBYCAUULWKWLYCAYCAUVBWMWNWOVTZYCYQTYGGHUVCTYD
      GHUURUUSUQYRYCTYGTDEYCWPPZYRYCTOYGUVGUUHYRTORHZYCTWTRHZWTORHUVHITRHUVIWQW
      RWSTWTOWPXAURXBXCPUUKVTZXDUVDYCTYDUVGUVDYCTYGYDUVGYRUVDUVJUVFXEXDYGYDXFXG
      VDYCYIYJYGMKZYLRYCYHYJYGUUPUUQUUOYCYGBRHZYHYJRHZYCBNEZUVLUUNBXHWGYCYGNEUV
      NUVLUVMUQUUOUUNYGBXIXKVDXJYCUVKYJIJKZBMKIYJJKZBMKYLYCYJBIYCYJUUQWMZYCBUUI
      WMZYCIUUJWMZYCBUUNXLZIQXMYCXNPXOYCUVOUVPBMYCYJIUVQUVSXPXQYCIYJBUVSUVQUVRU
      VTXRXSXTXE $.

    $( Lemma for ~ chebbnd1 : get a lower bound on
       ` ppi ( N ) / ( N / log ( N ) ) ` that is independent of ` N ` .
       (Contributed by Mario Carneiro, 21-Sep-2014.) $)
    chebbnd1lem3 $p |- ( ( N e. RR /\ 8 <_ N ) ->
      ( ( ( log ` 2 ) - ( 1 / ( 2 x. _e ) ) ) / 2 ) <
      ( ( ppi ` N ) x. ( ( log ` N ) / N ) ) ) $=
      ( cr wcel cle wbr c2 clog cfv c1 ceu cmul co cdiv a1i clt c4 cc0 wb c8 wa
      cmin cppi crp 2rp relogcl 1re 2re ere remulcli mulgt0ii gt0ne0ii redivcli
      ax-mp 2pos epos resubcli 2ne0 cn 8re simpl 2lt8 ltleii simpr letrd syldan
      ppinncl nnred cz rehalfcl adantr flcld syl5eqel zred remulcl sylancr 1lt2
      cfl 2cn mulid1i cuz 4nn nnzi 4t2e8 syl5eqbr lemuldiv syl112anc mpbid flge
      4re sylancl syl6breqr eluz2 syl3anbrc nnuz uztrn2 nnge1d lemul2 syl5eqbrr
      ltletrd rplogcld rpred 2nn nnmulcl nndivred remulcld syl elrpd rerpdivcld
      0re 8pos relogcld syl2anc cexp 4pos elrpii rpexpcl rpdivcld epr rerpdivcl
      nnrpd c3 egt2lt3 simpri 3lt4 3re lttri oveq1i nngt0d mpbird recnd breqtrd
      syl3anc cc recni rpcnd wceq wne lttrd mp2an ltled leidi logdivlt syl6breq
      mpanl12 loge pm3.2i lt2mul2div syl22anc mulid2d ltmuldiv ltsub2dd subdird
      jca mulcomd 2z zmulcl relogexp nnnn0d cn0 2nn0 expmuld sq2 syl6eq 3eqtr2d
      fveq2d divrec2d divcan5d oveq12d eqtrd relogdivd 3brtr4d cbc chebbnd1lem1
      eqtr3d cif eqid ltmuldivd rpcnne0d divass flle lemuldiv2 ppiwordi lemul1d
      ltdiv1 chebbnd1lem2 ltmul2 mul12d ltdivmul ) BDEZUABFGZUBZHIJZKHLMNZONZUC
      NZHONZBUDJZHAMNZIJZUWTONZMNZHONZUWSBIJZBONZMNZUWRDEUWMUWQHUWNUWPHUEEZUWND
      EUFHUGUOZKUWOUHHLUIUJUKZUWOUXJHLUIUJUPUQULUMZUNZURZUIUSUNPUWMUXCDEZUXDDEU
      WMUWSUXBUWMUWSUWKUWLHBFGUWSUTEUWMHUABHDEZUWMUIPZUADEUWMVAPZUWKUWLVBZHUAFG
      UWMHUAUIVAVCVDPUWKUWLVEZVFBVHVGZVIZUWMUXAUWTUWMUXAUWMUWTUWMUXOADEZUWTDEZU
      IUWMAUWMABHONZVSJZVJCUWMUYDUWKUYDDEZUWLBVKVLZVMVNZVOZHAVPVQZUWMKHUWTKDEZU
      WMUHPZUXPUYJKHQGUWMVRPUWMHHKMNZUWTFHVTWAUWMKAFGZUYMUWTFGZUWMAUWMRUTEARWBJ
      EZAUTEZWCUWMRVJEZAVJEZRAFGUYPUYRUWMRWCWDZPUYHUWMRUYEAFUWMRUYDFGZRUYEFGZUW
      MRHMNZBFGZVUAUWMVUCUABFWEUXSWFUWMRDEZUWKUXOSHQGZVUDVUATVUEUWMWKPZUXRUXPVU
      FUWMUPPZRBHWGWHWIUWMUYFUYRVUAVUBTUYGUYTUYDRWJWLWICWMZRAWNWOZKARUTWPWQVQZW
      RUWMUYKUYBUXOVUFUYNUYOTUYLUYIUXPVUHKAHWSWHWIWTZXAXBZXCZUWMHUTEUYQUWTUTEXD
      VUKHAXEVQZXFZXGZUXCVKXHUWMUWSUXFUYAUWMUXEBUWMBUWMBUXRUWMSUABSDEUWMXKPUXQU
      XRSUAQGUWMXLPUXSXAXIZXMVURXJZXGZUWMUWQUXCQGZUWRUXDQGZUWMUWQUWTUDJZUXBMNZU
      XCUWQDEZUWMUXMPZUWMVVCUXBUWMVVCUWMUYCHUWTFGVVCUTEUYJVULUWTVHXNVIZVUPXGVUQ
      UWMUWQVVCUXAMNZUWTONZVVDQUWMUWQUWTMNZVVHQGUWQVVIQGUWMVVJRAXONZAONZIJZVVHU
      WMVVEUYCVVJDEUXMUYJUWQUWTVPVQUWMVVLUWMVVKAUWMRUEEUYSVVKUEERWKXPXQUYHRAXRV
      QZUWMAVUKYBZXSXMUWMVVCUXAVVGVUNXGZUWMVVKIJZALONZUCNZVVQAIJZUCNVVJVVMQUWMV
      VTVVRVVQUWMAVVOXMZUWMUYBLUEEVVRDEUYIXTALYAWLUWMVVKVVNXMUWMVVTLMNZAQGZVVTV
      VRQGZUWMVWBKAMNZAQUWMVWBVWEQGZVVTAONZKLONZQGZUWMVWGLIJZLONZVWHQUWMLAQGZVW
      GVWKQGZUWMLRALDEZUWMUJPZVUGUYILRQGZUWMLYCQGZYCRQGVWPHLQGVWQYDYEYFLYCRUJYG
      WKYHUUAPVUIXAZUWMUYBLAFGZVWLVWMTZUYIUWMLAVWOUYIVWRUUBVWNLLFGUYBVWSUBVWTUJ
      LUJUUCLAUUDUUFXNWIVWJKLOUUGYIUUEUWMVVTDEZVWNSLQGZUBZUYKUYBSAQGZUBVWFVWITV
      WAVXCUWMVWNVXBUJUQUUHPZUYLUWMUYBVXDUYIUWMAVUKYJUUOVVTLKAUUIUUJYKUWMAUWMAU
      YIYLZUUKYMUWMVXAUYBVXCVWCVWDTVWAUYIVXEVVTALUULYNWIUUMUWMVVJUWNUWTMNZUWPUW
      TMNZUCNVVSUWMUWNUWPUWTUWNYOEUWMUWNUXIYPPZUWPYOEUWMUWPUXLYPPUWMUWTUWMUWTVU
      OYBZYQZUUNUWMVXGVVQVXHVVRUCUWMVXGUWTUWNMNZHUWTXONZIJZVVQUWMUWNUWTVXIVXKUU
      PUWMUXHUWTVJEZVXNVXLYRUFUWMHVJEUYSVXOUUQUYHHAUURVQHUWTUUSVQUWMVXMVVKIUWMV
      XMHHXONZAXONVVKUWMHHAHYOEUWMVTPZUWMAVUKUUTHUVAEUWMUVBPUVCVXPRAXOUVDYIUVEU
      VGUVFUWMUWTUWOONVXHVVRUWMUWTUWOVXKUWOYOEUWMUWOUXJYPPUWOSYSUWMUXKPUVHUWMAL
      HVXFLYOEUWMLUJYPPVXQLSYSUWMLUJUQUMPHSYSUWMUSPUVIUVPUVJUVKUWMVVKAVVNVVOUVL
      UVMUWMUYPVVMVVHQGVUJUWTUWTAUVNNZFGUWTVXRUVQZAVXSUVRUVOXHYTUWMUWQVVHUWTVVF
      VVPVXJUVSWIUWMVVCYOEUXAYOEUWTYOEUWTSYSUBVVIVVDYRUWMVVCVVGYLUWMUXAVUMYQUWM
      UWTVXJUVTVVCUXAUWTUWAYNYMUWMVVCUWSFGZVVDUXCFGUWMUYCUWKUWTBFGZVXTUYJUXRUWM
      VYAAUYDFGZUWMAUYEUYDFCUWMUYFUYEUYDFGUYGUYDUWBXHWFUWMUYBUWKUXOVUFVYAVYBTUY
      IUXRUXPVUHABHUWCWHYKUWTBUWDYNUWMVVCUWSUXBVVGUYAUWMUXAUWTVUMVXJXSUWEWIXAUW
      MVVEUXNUXOVUFVVAVVBTVVFVUQUXPVUHUWQUXCHUWFWHWIUWMUXDUXGQGZUXCHUXGMNZQGZUW
      MUXCUWSHUXFMNZMNZVYDQUWMUXBVYFQGZUXCVYGQGZABCUWGUWMUXBDEVYFDEZUWSDESUWSQG
      VYHVYITVUPUWMUXOUXFDEVYJUIVUSHUXFVPVQUYAUWMUWSUXTYJUXBVYFUWSUWHWHWIUWMUWS
      HUXFUWMUWSUYAYLVXQUWMUXFVUSYLUWIYMUWMUXNUXGDEUXOVUFVYCVYETVUQVUTUXPVUHUXC
      UXGHUWJWHYKYT $.
  $}

  $( The Chebyshev bound:  The function ` ppi ( x ) ` is eventually lower
     bounded by a positive constant times ` x / log ( x ) ` .  Alternatively
     stated, the function ` ( x / log ( x ) ) / ppi ( x ) ` is eventually
     bounded.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
  chebbnd1 $p |- ( x e. ( 2 [,) +oo ) |->
    ( ( x / ( log ` x ) ) / ( ppi ` x ) ) ) e. O(1) $=
    ( c2 co clog cfv cdiv wcel wtru c1 ceu cmul cr 2re mp2an a1i wbr wa cc0 clt
    c4 cpnf cico cv cppi cmpt co1 c8 cmin wss cxr pnfxr icossre cc cle elicopnf
    wb ax-mp simplbi 0re 1re 0lt1 simprbi ltletrd lttrd elrpd rplogcld rpdivcld
    1lt2 ppinncl sylbi nnrpd rpcnd adantl 8re crp 2rp relogcl ere remulcli 2pos
    cn epos mulgt0ii gt0ne0ii rereccli resubcli recni mulid1i c3 egt2lt3 simpli
    lttri ltmul2i mpbi eqbrtrri ltrecii simpri 3lt4 3re 4pos elrpii logltb loge
    4re epr cexp sq2 fveq2i cz 2z relogexp eqtr3i 3brtr3i pm3.2i ltdivmul mp3an
    wceq mpbir rehalfcli posdifi rerpdivcl cabs rpre absidd syl adantr cfl eqid
    rpge0 chebbnd1lem3 sylan wne 2ne0 recdiv mp4an nncnd rpne0d nnne0d rpcnne0d
    recdivd divrecd syl2anc oveq2d 3eqtrd 3brtr4d divgt0ii ltrec mpanr12 mpbird
    elrp wi rpred ltle sylancl mpd eqbrtrd elo1d trud ) ABUAUBCZAUCZUUTDEZFCZUU
    TUDEZFCZUEUFGHAUUSUVDUGBBDEZIBJKCZFCZUHCZFCZUUSLUIZHBLGZUAUJGUVJMUKBUAULNOU
    UTUUSGZUVDUMGHUVLUVDUVLUVBUVCUVLUUTUVAUVLUUTUVLUUTLGZBUUTUNPZUVKUVLUVMUVNQZ
    UPMBUUTUOUQZURZUVLRIUUTRLGUVLUSOILGZUVLUTOZUVQRISPUVLVAOUVLIBUUTUVSUVKUVLMO
    UVQIBSPZUVLVHOUVLUVMUVNUVPVBVCZVDVEZUVLUUTUVQUWAVFZVGZUVLUVCUVLUVOUVCWAGUVP
    UUTVIVJZVKVGZVLVMUGLGHVNOUVILGZHUVKUVHVOGUWGMUVHUVEUVGBVOGZUVELGZVPBVQUQZUV
    FBJMVRVSZUVFUWKBJMVRVTWBWCZWDWEZWFZUVGUVESPZRUVHSPUVGIBFCZSPZUWPUVESPZUWOBU
    VFSPUWQBIKCZBUVFSBBMWGZWHIJSPZUWSUVFSPZUVTBJSPZUXAVHUXCJWISPZWJWKIBJUTMVRWL
    NRBSPZUXAUXBUPVTIJBUTVRMWMUQWNWOBUVFMUWKVTUWLWPWNUWRIBUVEKCZSPZJDEZTDEZIUXF
    SJTSPZUXHUXISPZUXDWITSPUXJUXCUXDWJWQWRJWITVRWSXDWLNJVOGTVOGUXJUXKUPXETXDWTX
    AJTXBNWNXCBBXFCZDEZUXIUXFUXLTDXGXHUWHBXIGUXMUXFXQVPXJBBXKNXLXMUVRUWIUVKUXEQ
    UWRUXGUPUTUWJUVKUXEMVTXNIUVEBXOXPXRUVGUWPUVEUWMIUTXSUWJWLNUVGUVEUWMUWJXTWNZ
    XABUVHYANZOUVLUGUUTUNPZQZUVDYBEZUVIUNPHUXQUXRUVDUVIUNUVLUXRUVDXQZUXPUVLUVDV
    OGZUXSUWFUXTUVDUVDYCUVDYIYDYEYFUXQUVDUVISPZUVDUVIUNPZUXQUYAIUVIFCZIUVDFCZSP
    ZUXQUVHBFCZUVCUVAUUTFCZKCZUYCUYDSUVLUVMUXPUYFUYHSPUVQUUTBFCYGEZUUTUYIYHYJYK
    UYCUYFXQZUXQBUMGBRYLUVHUMGUVHRYLUYJUWTYMUVHUWNWGUVHUWNUXNWDBUVHYNYOOUVLUYDU
    YHXQUXPUVLUYDUVCUVBFCUVCIUVBFCZKCUYHUVLUVBUVCUVLUVBUWDVLZUVLUVCUWEYPZUVLUVB
    UWDYQZUVLUVCUWEYRYTUVLUVCUVBUYMUYLUYNUUAUVLUYKUYGUVCKUVLUUTUMGUUTRYLQUVAUMG
    UVARYLQUYKUYGXQUVLUUTUWBYSUVLUVAUWCYSUUTUVAYNUUBUUCUUDYFUUEUXQUXTUYAUYEUPZU
    VLUXTUXPUWFYFZUXTUVDLGZRUVDSPQZUYOUVDUUJUYRUWGRUVISPUYOUXOBUVHMUWNVTUXNUUFU
    VDUVIUUGUUHVJYEUUIUXQUYQUWGUYAUYBUUKUXQUVDUYPUULUXOUVDUVIUUMUUNUUOUUPVMUUQU
    UR $.

  ${
    $d p x z A $.  $d p N $.  $d p x z ph $.
    chtppilim.1 $e |- ( ph -> A e. RR+ ) $.
    chtppilim.2 $e |- ( ph -> A < 1 ) $.
    ${
      chtppilim.3 $e |- ( ph -> N e. ( 2 [,) +oo ) ) $.
      chtppilim.4 $e |- ( ph -> ( ( N ^c A ) / ( ppi ` N ) ) < ( 1 - A ) ) $.
      $( Lemma for ~ chtppilim .  (Contributed by Mario Carneiro,
         22-Sep-2014.) $)
      chtppilimlem1 $p |- ( ph ->
        ( ( A ^ 2 ) x. ( ( ppi ` N ) x. ( log ` N ) ) ) < ( theta ` N ) ) $=
        ( vp c2 co cfv cmul clt cr wcel cle wbr syl c1 cprime cexp rpred sqvald
        cppi clog ccht recnd oveq1d cpnf cico wa wb elicopnf ax-mp sylib simpld
        cn0 2re ppicl nn0red cc0 0re a1i 2pos simprd elrpd relogcld mul4d eqtrd
        ltletrd ccxp cmin remulcld rpcxpcld resubcld 1re 1lt2 rplogcld rpmulcld
        chtcl cdiv cn ppinncl nndivred ltsub13d cc wne nnrpd rpcnne0d divsubdir
        wceq divid breqtrrd ltmuldivd mpbird crp ppiltx ltsub2dd lttrd ltmul1dd
        syl3anc cfl caddc cfz cin cv csu cfn wss fzfid inss1 ssfi sylancl inss2
        simpr sseldi prmnn fsumrecl chash fsumconst syl2anc ppifl oveq12d ltled
        cuz wi ltle mpd cxplead cxp1d breqtrd flword2 ppidif eqtr3d adantr 3syl
        ce letrd rpge0d nnuz eqtr4d reflcl peano2re fllep1 rpne0d cxpefd eqcomd
        elfzle1 reeflogd 3brtr4d fsumle eqbrtrrd eluz2b2 nnred flge0nn0 nn0p1nn
        efle prmuz2 syl6eleq fzss1 ssrin fsumless cicc eleqtri ppisval2 sumeq1d
        chtval 2nn eqbrtrd ) ABIUAJZCUDKZCUEKZLJZLJZBUVKLJZBUVLLJZLJZCUFKZMAUVN
        BBLJZUVMLJUVQAUVJUVSUVMLABABABDUBZUGZUCUHABBUVKUVLUWAUWAAUVKAUVKACNOZUV
        KUQOAUWBICPQZACIUIUJJOZUWBUWCUKZFINOZUWDUWEULURICUMUNUOZUPZCUSRUTZUGZAU
        VLACACUWHAVAICVANOAVBVCUWFAURVCZUWHVAIMQAVDVCAUWBUWCUWGVEZVJVFZVGZUGVHV
        IAUVQUVKCBVKJZUDKZVLJZUVPLJZUVRAUVOUVPABUVKUVTUWIVMZABUVLUVTUWNVMZVMAUW
        QUVPAUVKUWPUWIAUWPAUWONOZUWPUQOAUWOACBUWMUVTVNZUBZUWOUSRUTZVOZUWTVMZAUW
        BUVRNOUWHCVTRZAUVOUWQUVPUWSUXEABUVLDACUWHASICSNOZAVPVCZUWKUWHSIMQAVQVCU
        WLVJZVRVSAUVOUVKUWOVLJZUWQUWSAUVKUWOUWIUXCVOZUXEAUVOUXKMQBUXKUVKWAJZMQA
        BSUWOUVKWAJZVLJZUXMMAUXNSBAUWOUVKUXCAUWEUVKWBOUWGCWCRZWDUXIUVTGWEAUXMUV
        KUVKWAJZUXNVLJZUXOAUVKWFOZUWOWFOUXSUVKVAWGUKZUXMUXRWKUWJAUWOUXCUGAUVKAU
        VKUXPWHZWIZUVKUWOUVKWJXAAUXQSUXNVLAUXTUXQSWKUYBUVKWLRUHVIWMABUXKUVKUVTU
        XLUYAWNWOAUWPUWOUVKUXDUXCUWIAUWOWPOUWPUWOMQUXBUWOWQRWRWSWTAUWRUWOXBKZSX
        CJZCXBKZXDJZTXEZHXFZUEKZHXGZUVRUXFAUYGUYIHAUYFXHOUYGUYFXIUYGXHOZAUYDUYE
        XJUYFTXKZUYFUYGXLXMZAUYHUYGOZUKZUYHUYOUYHTOZUYHWPOUYOUYGTUYHUYFTXNAUYNX
        OZXPUYPUYHUYHXQWHRZVGZXRUXGAUYGUVPHXGZUWRUYJPAUYTUYGXSKZUVPLJZUWRAUYKUV
        PWFOUYTVUBWKUYMAUVPUWTUGUYGUVPHXTYAAUWQVUAUVPLAUYEUDKZUYCUDKZVLJZUWQVUA
        AVUCUVKVUDUWPVLAUWBVUCUVKWKUWHCYBRAUXAVUDUWPWKUXCUWOYBRYCAUYEUYCYEKOZVU
        EVUAWKAUXAUWBUWOCPQVUFUXCUWHAUWOCSVKJCPACBSUWHASCUXIUWHUXJYDUVTUXIABSMQ
        ZBSPQZEABNOUXHVUGVUHYFUVTVPBSYGXMYHYIACACUWHUGZYJYKUWOCYLXAUYCUYEYMRYNU
        HUUAAUYGUVPUYIHUYMAUVPNOZUYNUWTYOZUYSUYOUVPUYIPQZUVPYQKZUYIYQKZPQZUYOUW
        OUYHVUMVUNPUYOUWOUYDUYHAUXAUYNUXCYOAUYDNOZUYNAUXAUYCNOVUPUXCUWOUUBUYCUU
        CYPYOUYOUYHUYRUBAUWOUYDPQZUYNAUXAVUQUXCUWOUUDRYOUYOUYHUYFOUYDUYHPQUYOUY
        GUYFUYHUYLUYQXPUYHUYDUYEUUHRYRAVUMUWOWKUYNAUWOVUMACBVUIACUWMUUEUWAUUFUU
        GYOUYOUYHUYRUUIUUJUYOVUJUYINOVULVUOULVUKUYSUVPUYIUUQYAWOUUKUULAUYJSUYEX
        DJZTXEZUYIHXGZUVRPAVUSUYIUYGHAVURXHOVUSVURXIVUSXHOASUYEXJVURTXKVURVUSXL
        XMAUYHVUSOZUKZUYIVVBUYHVVBUYHVVBUYHWBOZSUYHMQZVVBUYHIYEKOZVVCVVDUKVVBUY
        PVVEVVBVUSTUYHVURTXNAVVAXOXPUYHUURRUYHUUMUOZUPUUNVVBVVCVVDVVFVEVRZUBVVB
        UYIVVGYSAUYDSYEKZOUYFVURXIUYGVUSXIAUYDWBVVHAUYCUQOZUYDWBOAUXAVAUWOPQVVI
        UXCAUWOUXBYSUWOUUOYAUYCUUPRYTUUSUYDSUYEUUTUYFVURTUVAYPUVBAUVRVACUVCJTXE
        ZUYIHXGZVUTAUWBUVRVVKWKUWHCHUVGRAVVJVUSUYIHAUWBIVVHOVVJVUSWKUWHIWBVVHUV
        HYTUVDCSUVEXMUVFVIWMYRVJUVI $.
    $}

    $( Lemma for ~ chtppilim .  (Contributed by Mario Carneiro,
       22-Sep-2014.) $)
    chtppilimlem2 $p |- ( ph -> E. z e. RR A. x e. ( 2 [,) +oo ) ( z <_ x ->
      ( ( A ^ 2 ) x. ( ( ppi ` x ) x. ( log ` x ) ) ) < ( theta ` x ) ) ) $=
      ( wbr co cdiv cc0 c1 clt c2 cr cmul crp wcel wa a1i cc cle ccxp cppi cmin
      cv cfv cabs wi cpnf cico wral wrex cexp clog ccht simpr wb elicopnf ax-mp
      2re sylib simpld 0re 2pos simprd ltletrd elrpd adantr rpcxpcld cn ppinncl
      rpred syl nnrpd rpdivcld ralrimiva 1re difrp sylancl mpbid cmpt crli ovex
      cof cvv 1lt2 rplogcld eqidd offval2 wne wceq rpcnd rpcnne0d div23 syl3anc
      recnd dmdcan mulcomd ax-1cn cxpsub sylancr oveq2d eqtr3d oveq1d mpteq2dva
      nncan cxp1d 3eqtr4d eqtrd co1 chebbnd1 ssrdv cxploglim rlimres2 o1rlimmul
      ex eqbrtrrd rlimi fveq2d rpge0d absidd breq1d simprl simprr chtppilimlem1
      subid1d expr sylbid imim2d ralimdva reximdv mpd ) ACUEBUEZUAGZYMDUBHZYMUC
      UFZIHZJUDHZUGUFZKDUDHZLGZUHZBMUIUJHZUKZCNULYNDMUMHYPYMUNUFZOHOHYMUOUFLGZU
      HZBUUCUKZCNULACBUUCYQJYTPAYQPQBUUCAYMUUCQZRZYOYPUUJYMDUUJYMUUJYMNQZMYMUAG
      ZUUJUUIUUKUULRZAUUIUPMNQZUUIUUMUQUTMYMURUSVAZVBZUUJJMYMJNQUUJVCSUUNUUJUTS
      ZUUPJMLGUUJVDSUUJUUKUULUUOVEZVFVGZADNQZUUIADEVLZVHZVIUUJYPUUJUUMYPVJQUUOY
      MVKVMVNZVOZVPADKLGZYTPQZFAUUTKNQZUVEUVFUQUVAVQDKVRVSVTZABUUCYMUUEIHZYPIHZ
      WAZBUUCUUEYMYTUBHZIHZWAZOWDHZBUUCYQWAZJWBAUVOBUUCUVJUVMOHZWAUVPABUUCUVJUV
      MOUVKUVNWEPPUUCWEQAMUIUJWCSUUJUVIYPUUJYMUUEUUSUUJYMUUPUUJKMYMUVGUUJVQSUUQ
      UUPKMLGUUJWFSUURVFWGZVOZUVCVOUUJUUEUVLUVRUUJYMYTUUSUUJYTAUVFUUIUVHVHZVLVI
      ZVOZAUVKWHAUVNWHWIABUUCUVQYQUUJUVIUVMOHZYPIHZUVQYQUUJUVITQUVMTQYPTQYPJWJR
      UWDUVQWKUUJUVIUVSWLZUUJUVMUWBWLZUUJYPUVCWMUVIUVMYPWNWOUUJUWCYOYPIUUJUVMUV
      IOHZYMUVLIHZUWCYOUUJUUETQUUEJWJRUVLTQUVLJWJRYMTQZUWGUWHWKUUJUUEUVRWMUUJUV
      LUWAWMUUJYMUUPWPZUUEUVLYMWQWOUUJUVIUVMUWEUWFWRUUJYMKUBHZUVLIHZYOUWHUUJYMK
      YTUDHZUBHZUWLYOUUJUWIYMJWJRKTQZYTTQUWNUWLWKUUJYMUUSWMUWOUUJWSSUUJYTUVTWLY
      MKYTWTWOUUJUWMDYMUBUUJUWODTQUWMDWKWSUUJDUVBWPKDXFXAXBXCUUJUWKYMUVLIUUJYMU
      WJXGXDXCXHXDXCXEXIAUVKXJQUVNJWBGUVOJWBGBXKABUUCPUVMJABUUCPAUUIYMPQUUSXPXL
      AUVFBPUVMWAJWBGUVHYTBXMVMXNUVKUVNXOXAXQXRAUUDUUHCNAUUBUUGBUUCUUJUUAUUFYNU
      UJUUAYQYTLGZUUFUUJYSYQYTLUUJYSYQUGUFYQUUJYRYQUGUUJYQUUJYQUVDWLYFXSUUJYQUU
      JYQUVDVLUUJYQUVDXTYAXIYBAUUIUWPUUFAUUIUWPRZRDYMADPQUWQEVHAUVEUWQFVHAUUIUW
      PYCAUUIUWPYDYEYGYHYIYJYKYL $.
  $}

  ${
    $d x y z $.
    $( The ` theta ` function is asymptotic to ` ppi ( x ) log ( x ) ` , so it
       is sufficient to prove ` theta ( x ) / x ~~>r 1 ` to establish the PNT.
       (Contributed by Mario Carneiro, 22-Sep-2014.) $)
    chtppilim $p |- ( x e. ( 2 [,) +oo ) |->
      ( ( theta ` x ) / ( ( ppi ` x ) x. ( log ` x ) ) ) ) ~~>r 1 $=
      ( vz vy c2 co cfv cmul c1 wbr wtru cle clt cr crp wcel 1re cc0 a1i adantl
      wa cpnf cico cv ccht cppi clog cdiv cmpt crli cmin cabs wi wral wrex csqr
      cif cexp rehalfcli rpre resubcl sylancr ifcl halfgt0 max2 sylancl ltletrd
      elrpd rpsqrcld halflt1 ltsubrp mpan breq1 ifboth rpge0d 0le1 sqrltd mpbid
      0re sqr1 syl6breq chtppilimlem2 adantr max1 wb 2re elicopnf ax-mp simplbi
      chtcl syl cn ppinncl sylbi nnrpd 1lt2 rplogcld rpmulcld rerpdivcld lelttr
      simprbi syl3anc mpand wceq recnd sqsqrd oveq1d breq1d rpregt0d bitrd 2pos
      ltmuldiv chtleppi rpcnd mulid1d breqtrrd ledivmuld mpbird ltsub23 3imtr4d
      abssuble0d imim2d ralimdva reximdv mpd rgen cc ralrimiva wss ssriv ax-1cn
      rlim2 mpbiri trud ) ADUAUBEZAUCZUDFZYOUEFZYOUFFZGEZUGEZUHHUIIZJUUABUCYOKI
      ZYTHUJEUKFZCUCZLIZULZAYNUMZBMUNZCNUMUUHCNUUDNOZUUBHUUDUJEZHDUGEZKIZUUKUUJ
      UPZUOFZDUQEZYSGEZYPLIZULZAYNUMZBMUNUUHUUIABUUNUUIUUMUUIUUMUUIUUKMOZUUJMOZ
      UUMMOZHPURZUUIHMOZUUDMOZUVAPUUDUSZHUUDUTVAZUULUUKUUJMVBVAZUUIQUUKUUMQMOZU
      UIVRRUUTUUIUVCRUVHQUUKLIUUIVCRUUIUVAUUTUUKUUMKIUVGUVCUUJUUKVDVEVFVGZVHUUI
      UUNHUOFZHLUUIUUMHLIZUUNUVKLIUUIUUKHLIZUUJHLIZUVLVIUVDUUIUVNPHUUDVJVKUULUV
      MUVNUVLUUKUUJUUKUUMHLVLUUJUUMHLVLVMVAUUIUUMHUVHUUIUUMUVJVNUVDUUIPRQHKIUUI
      VORVPVQVSVTWAUUIUUSUUGBMUUIUURUUFAYNUUIYOYNOZTZUUQUUEUUBUVPUUMYTLIZUUJYTL
      IZUUQUUEUVPUUJUUMKIZUVQUVRUVPUVAUUTUVSUUIUVAUVOUVGWBZUVCUUJUUKWCVEUVPUVAU
      VBYTMOZUVSUVQTUVRULUVTUUIUVBUVOUVHWBZUVOUWAUUIUVOYPYSUVOYOMOZYPMOZUVOUWCD
      YOKIZDMOZUVOUWCUWETZWDWEDYOWFWGZWHZYOWIWJZUVOYQYRUVOYQUVOUWGYQWKOUWHYOWLW
      MWNUVOYOUWIUVOHDYOUVDUVOPRZUWFUVOWERZUWIHDLIUVOWORUVOUWCUWEUWHWTZVFWPWQZW
      RZSZUUJUUMYTWSXAXBUVPUUQUUMYSGEZYPLIZUVQUVPUUPUWQYPLUVPUUOUUMYSGUUIUUOUUM
      XCUVOUUIUUMUUIUUMUVHXDXEWBXFXGUVPUVBUWDYSMOQYSLITZUWRUVQWDUWBUVOUWDUUIUWJ
      SUVOUWSUUIUVOYSUWNXHSUUMYPYSXKXAXIUVPUUEHYTUJEZUUDLIZUVRUVOUUEUXAWDUUIUVO
      UUCUWTUUDLUVOYTHUWOUWKUVOYTHKIYPYSHGEZKIUVOYPYSUXBKUVOYONOYPYSKIUVOYOUWIU
      VOQDYOUVIUVOVRRUWLUWIQDLIUVOXJRUWMVFVGYOXLWJUVOYSUVOYSUWNXMXNXOUVOYPHYSUW
      JUWKUWNXPXQXTXGSUVPUVDUWAUVEUXAUVRWDUVDUVPPRUWPUUIUVEUVOUVFWBHYTUUDXRXAXI
      XSYAYBYCYDYEJCBAYNYTHJYTYFOZAYNUVOUXCJUVOYTUWOXDSYGYNMYHJAYNMUWIYIRHYFOJY
      JRYKYLYM $.
  $}

  $( The ` theta ` function is upper bounded by a linear term.  Corollary of
     ~ chtub .  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
  chto1ub $p |- ( x e. RR+ |-> ( ( theta ` x ) / x ) ) e. O(1) $=
    ( crp cfv co wcel wtru c3 c2 cmul cr a1i cc 3re 2re cle wbr cc0 clt adantr
    wa cv ccht cdiv cmpt co1 clog wss rpssre rpre chtcl rerpdivcl mpancom recnd
    syl adantl 2rp relogcl ax-mp remulcli chtge0 rpregt0 divge0 syl21anc absidd
    cabs wceq cmin remulcl sylancr resubcl sylancl simpr ltletrd syl2anc elrpii
    2lt3 chtub 3pos ltsubrp wb 1lt2 rplogcl mp2an elrp mpbi syl3anc mpbid lttrd
    ltmul2 recni 2cn mulassd breqtrrd ltdivmul2 mpbird ltled eqbrtrd elo1d trud
    c1 ) ABAUAZUBCZXAUCDZUDUEEFABXCGHUFCZHIDZBJUGFUHKXABEZXCLEFXFXCXBJEZXFXCJEZ
    XFXAJEZXGXAUIZXAUJUNZXBXAUKULZUMUOGJEZFMKXEJEZFXDHHBEXDJEZUPHUQURZNUSZKXFGX
    AOPZTZXCVECZXEOPFXSXTXCXEOXFXTXCVFXRXFXCXLXFXGQXBOPZXIQXARPTZQXCOPXKXFXIYAX
    JXAUTUNXAVAZXBXAVBVCVDSXSXCXEXFXHXRXLSXNXSXQKZXSXCXERPZXBXEXAIDZRPZXSXBXDHX
    AIDZIDZYFRXSXBXDYHGVGDZIDZYIXFXGXRXKSZXSXOYJJEZYKJEXPXSYHJEZXMYMXSHJEZXIYNN
    XFXIXRXJSZHXAVHVIZMYHGVJVKZXDYJVHVIXSXOYNYIJEXPYQXDYHVHVIXSXIHXARPXBYKRPYPX
    SHGXAYOXSNKXMXSMKYPHGRPXSVPKXFXRVLVMXAVQVNXSYJYHRPZYKYIRPZXSYNGBEYSYQGMVRVO
    YHGVSVKXSYMYNXOQXDRPTZYSYTVTYRYQUUAXSXDBEZUUAYOWTHRPUUBNWAHWBWCXDWDWEKYJYHX
    DWIWFWGWHXSXDHXAXDLEXSXDXPWJKHLEXSWKKXFXALEXRXFXAXJUMSWLWMXSXGXNYBYEYGVTYLY
    DXFYBXRYCSXBXEXAWNWFWOWPWQUOWRWS $.

  $( The Chebyshev bound, part 2:  The function ` ppi ( x ) ` is eventually
     upper bounded by a positive constant times ` x / log ( x ) ` .
     Alternatively stated, the function ` ppi ( x ) / ( x / log ( x ) ) ` is
     eventually bounded.  (Contributed by Mario Carneiro, 22-Sep-2014.) $)
  chebbnd2 $p |- ( x e. ( 2 [,) +oo ) |->
    ( ( ppi ` x ) / ( x / ( log ` x ) ) ) ) e. O(1) $=
    ( c2 cpnf co cdiv cmpt co1 wcel wtru c1 cmul cvv a1i wa cc cc0 wne wbr crp
    cr cico cv cppi cfv clog ccht cof ovex eqidd wceq cle simpr wb 2re elicopnf
    ax-mp sylib chtrpcl syl rpcnne0d cn ppinncl nnrpd simpld 1re simprd ltletrd
    clt 1lt2 rplogcld rpmulcld recdiv syl2anc mpteq2dva offval2 0re elrpd rpcnd
    2pos dmdcan syl3anc divdiv2 eqtr4d eqtrd ssrdv chto1ub o1res2 crli rpdivcld
    ex ax-1cn wss pnfxr icossre mp2an rlimconst chtppilim ax-1ne0 rpne0d rlimo1
    cxr rlimdiv o1mul eqeltrrd trud ) ABCUADZAUBZUCUDZXGXGUEUDZEDEDZFZGHIAXFXGU
    FUDZXGEDZFZAXFJXLXHXIKDZEDZEDZFZKUGDZXKGIXSAXFXMXOXLEDZKDZFXKIAXFXMXTKXNXRL
    LLXFLHIBCUAUHMXMLHIXGXFHZNZXLXGEUHMXTLHYCXOXLEUHMIXNUIIAXFXQXTYCXLOHXLPQNZX
    OOHZXOPQNXQXTUJYCXLYCXGTHZBXGUKRZNZXLSHYCYBYHIYBULBTHZYBYHUMUNBXGUOUPUQZXGU
    RUSZUTZYCXOYCXHXIYCXHYCYHXHVAHYJXGVBUSVCZYCXGYCYFYGYJVDZYCJBXGJTHYCVEMYIYCU
    NMZYNJBVHRYCVIMYCYFYGYJVFZVGVJZVKZUTXLXOVLVMVNVOIAXFYAXJYCYAXOXGEDZXJYCYDXG
    OHXGPQNZYEYAYSUJYLYCXGYCXGYNYCPBXGPTHYCVPMYOYNPBVHRYCVSMYPVGVQZUTZYCXOYRVRX
    LXGXOVTWAYCXHOHYTXIOHXIPQNXJYSUJYCXHYMVRUUBYCXIYQUTXHXGXIWBWAWCVNWDIXNGHXRG
    HZXSGHIAXFSXMIAXFSIYBXGSHUUAWJWEASXMFGHIAWFMWGIXRJJEDZWHRUUCIAXFJXPJJOJOHZY
    CWKMYCXPYCXLXOYKYRWIZVRAXFJFJWHRZIXFTWLZUUEUUGYICXAHUUHUNWMBCWNWOWKAXFJWPWO
    MAXFXPFJWHRIAWQMJPQIWRMYCXPUUFWSXBUUDXRWTUSXNXRXCVMXDXE $.

  $( The ` theta ` function is lower bounded by a linear term.  Corollary of
     ~ chebbnd1 .  (Contributed by Mario Carneiro, 8-Apr-2016.) $)
  chto1lb $p |- ( x e. ( 2 [,) +oo ) |-> ( x / ( theta ` x ) ) ) e. O(1) $=
    ( c2 co cfv cdiv cmpt co1 wcel wtru c1 cmul cc a1i wbr cc0 crp rpcnd adantl
    cr rpne0d cpnf cico cv ccht clog cppi cof cvv ovex cle wa wb elicopnf ax-mp
    2re biimpi simpld 0re clt 2pos ltletrd elrpd ppinncl nnrpd syl 1re rplogcld
    simprd 1lt2 rpmulcld rpdivcld chtrpcl wceq divdiv1d mulcomd oveq2d mpteq2ia
    recnd eqtrd recdivd offval2 dmdcan2d syl6eq chebbnd1 ax-1cn ssriv rlimconst
    crli wss mp2an chtppilim ax-1ne0 rlimdiv rlimo1 o1mul sylancr eqeltrrd trud
    wne ) ABUAUBCZAUCZXAUDDZECZFZGHIAWTXAXAUEDZECXAUFDZECZFZAWTJXBXFXEKCZECZECZ
    FZKUGCZXDGIXMAWTXAXIECZXIXBECZKCZFXDIAWTXNXOKXHXLUHLLWTUHHIBUAUBUIMXAWTHZXN
    LHIXQXNXQXAXIXQXAXQXASHZBXAUJNZXQXRXSUKZBSHZXQXTULUOBXAUMUNUPZUQZXQOBXAOSHX
    QURMYAXQUOMZYCOBUSNXQUTMXQXRXSYBVHZVAVBXQXFXEXQXTXFPHYBXTXFXAVCVDVEZXQXAYCX
    QJBXAJSHXQVFMYDYCJBUSNXQVIMYEVAVGZVJZVKQRXQXOLHIXQXOXQXIXBYHXQXTXBPHYBXAVLV
    EZVKQRXHAWTXNFVMIAWTXGXNXQXGXAXEXFKCZECXNXQXAXEXFXQXAYCVRZXQXEYGQZXQXFYFQZX
    QXEYGTXQXFYFTVNXQYJXIXAEXQXEXFYLYMVOVPVSVQMXLAWTXOFVMIAWTXKXOXQXBXIXQXBYIQZ
    XQXIYHQZXQXBYITZXQXIYHTZVTVQMWAAWTXPXCXQXAXIXBYKYOYNYQYPWBVQWCIXHGHXLGHZXMG
    HAWDIXLJJECZWHNYRIAWTJXJJJLJLHZIXQUKZWEMUUAXJXQXJPHIXQXBXIYIYHVKZRQAWTJFJWH
    NZIWTSWIYTUUCAWTSYCWFWEAWTJWGWJMAWTXJFJWHNIAWKMJOWSIWLMXQXJOWSIXQXJUUBTRWMY
    SXLWNVEXHXLWOWPWQWR $.

  ${
    $d x y z $.
    $( The ` psi ` and ` theta ` functions are asymptotic to each other, so is
       sufficient to prove either ` theta ( x ) / x ~~>r 1 ` or
       ` psi ( x ) / x ~~>r 1 ` to establish the PNT. (Contributed by Mario
       Carneiro, 8-Apr-2016.) $)
    chpchtlim $p |- ( x e. ( 2 [,) +oo ) |->
      ( ( psi ` x ) / ( theta ` x ) ) ) ~~>r 1 $=
      ( c2 co cdiv cmpt c1 crli wbr wtru cmul caddc cr wcel a1i cc0 cle cc wceq
      crp syl cpnf cico cv cchp cfv ccht csqr clog 1re wa wb 2re elicopnf ax-mp
      simplbi adantl 0re 2pos simprbi ltletrd rpge0d resqrcld relogcld remulcld
      clt elrpd chtrpcl syl2anc rerpdivcld wss ssriv rlimconst sylancr ccxp cof
      recnd cvv ovex eqidd cxpsqr oveq2d wne rpsqrcld rpcnne0d divcan5 remsqsqr
      syl3anc 3eqtr2d mpteq2dva offval2 rpne0d dmdcan syl211anc co1 chto1lb 1rp
      eqtrd rphalfcl cxploglim rlimres2 eqbrtrrd rlimadd ax-1cn addid1i readdcl
      o1rlimmul syl6breq chpcl chtcl 1lt2 ltleii letrd chpub rpcnd divdir divid
      lediv1dd oveq1d breqtrd adantrr mulid2d chtlepsi lemuldivd mpbid rlimsqz2
      eqbrtrd trud ) ABUAUBCZAUCZUDUEZYIUFUEZDCZEFGHIAYHFYIUGUEZYIUHUEZJCZYKDCZ
      KCZYLFFFLMZIUINZYSIAYHYQEFOKCFGIAYHFYPFOLYRIYIYHMZUJZUINZUUAYOYKUUAYMYNUU
      AYIYTYILMZIYTUUCBYIPHZBLMZYTUUCUUDUJUKULBYIUMUNZUOZUPZUUAYIYTYISMIYTYIUUG
      YTOBYIOLMYTUQNUUEYTULNUUGOBVEHYTURNYTUUCUUDUUFUSZUTVFZUPZVAZVBUUAYIUUKVCZ
      VDZUUAUUCUUDYKSMUUHYTUUDIUUIUPZYIVGVHZVIZIYHLVJFQMAYHFEFGHAYHLUUGVKIFYSVP
      AYHFVLVMIAYHYIYKDCZEZAYHYNYIFBDCZVNCZDCZEZJVOCZAYHYPEZOGIUVDAYHUURYOYIDCZ
      JCZEUVEIAYHUURUVFJUUSUVCVQLVQYHVQMIBUAUBVRNUUAYIYKUUHUUPVIUVFVQMUUAYOYIDV
      RNIUUSVSIAYHUVBUVFUUAUVBYNYMDCZYOYMYMJCZDCZUVFUUAUVAYMYNDUUAYIQMZUVAYMRUU
      AYIUUHVPZYIVTTWAUUAYNQMYMQMYMOWBUJZUVMUVJUVHRUUAYNUUMVPUUAYMUUAYIUUKWCWDZ
      UVNYNYMYMWEWGUUAUVIYIYODUUAUUCOYIPHUVIYIRUUHUULYIWFVHWAWHWIWJIAYHUVGYPUUA
      UVKYIOWBYKQMZYKOWBUJZYOQMZUVGYPRUVLUUAYIUUKWKUUAYKUUPWDZUUAYOUUNVPZYIYKYO
      WLWMWIWQIUUSWNMUVCOGHUVDOGHAWOIAYHSUVBOYHSVJIAYHSUUJVKNASUVBEOGHZIUUTSMZU
      VTFSMUWAWPFWRUNUUTAWSUNNWTUUSUVCXFVMXAXBFXCXDXGUUAYRYPLMYQLMUIUUQFYPXEVMU
      UAYJYKUUAUUCYJLMUUHYIXHTZUUPVIIYTYLYQPHFYIPHZUUAYLYKYOKCZYKDCZYQPUUAYJUWD
      YKUWBUUAYKLMZYOLMUWDLMUUAUUCUWFUUHYIXITUUNYKYOXEVHUUPUUAUUCUWCYJUWDPHUUHU
      UAFBYIUUBUUEUUAULNUUHFBPHUUAFBUIULXJXKNUUOXLYIXMVHXQUUAUWEYKYKDCZYPKCZYQU
      UAUVOUVQUVPUWEUWHRUUAYKUUPXNZUVSUVRYKYOYKXOWGUUAUWGFYPKUUAUVPUWGFRUVRYKXP
      TXRWQXSXTIYTFYLPHZUWCUUAFYKJCZYJPHUWJUUAUWKYKYJPUUAYKUWIYAUUAUUCYKYJPHUUH
      YIYBTYFUUAFYJYKUUBUWBUUPYCYDXTYEYG $.
  $}

  $( The ` psi ` function is upper bounded by a linear term.  (Contributed by
     Mario Carneiro, 16-Apr-2016.) $)
  chpo1ub $p |- ( x e. RR+ |-> ( ( psi ` x ) / x ) ) e. O(1) $=
    ( crp cfv cdiv co cmpt co1 wcel wtru c2 cmul cc cc0 wa wbr 2re a1i cvv ovex
    cr cv cchp cpnf cico cres ccht cof wceq wne wb elicopnf ax-mp chtrpcl sylbi
    cle rpcnne0d simplbi 0re 2pos simprbi ltletrd elrpd rpre chpcl recnd dmdcan
    clt syl syl3anc adantl mpteq2dva eqidd offval2 resmpt mp1i 3eqtr4rd chto1ub
    wss ssriv o1res2 c1 crli chpchtlim rlimo1 sylancl eqeltrd rerpdivcl mpancom
    o1mul eqid fmptd rpssre o1resb mpbird trud ) ABAUAZUBCZWPDEZFZGHZIWTWSJUCUD
    EZUEZGHIXBAXAWPUFCZWPDEZFZAXAWQXCDEZFZKUGEZGIAXAXDXFKEZFAXAWRFZXHXBIAXAXIWR
    WPXAHZXIWRUHZIXKXCLHXCMUINWPLHWPMUINWQLHZXLXKXCXKWPTHZJWPUOOZNZXCBHJTHZXKXP
    UJPJWPUKULZWPUMUNUPXKWPXKWPXKXNXOXRUQZXKMJWPMTHXKURQXQXKPQXSMJVGOXKUSQXKXNX
    OXRUTVAVBZUPXKWPBHZXMXTYAWQYAXNWQTHZWPVCWPVDVHZVEVHXCWPWQVFVIVJVKIAXAXDXFKX
    EXGRRRXARHIJUCUDSQXDRHIXKNZXCWPDSQXFRHYDWQXCDSQIXEVLIXGVLVMXABVRZXBXJUHIAXA
    BXTVSZABXAWRVNVOVPIXEGHXGGHZXHGHIAXABXDYEIYFQABXDFGHIAVQQVTXGWAWBOYGAWCWAXG
    WDULXEXGWIWEWFIBJWSIABWRLWSYAWRLHIYAWRYBYAWRTHYCWQWPWGWHVEVJWSWJWKBTVRIWLQX
    QIPQWMWNWO $.

  ${
    $d c n x y $.
    $( The ` psi ` function is upper bounded by a linear term.  (Contributed by
       Mario Carneiro, 31-May-2016.) $)
    chpo1ubb $p |- E. c e. RR+ A. x e. RR+ ( psi ` x ) <_ ( c x. x ) $=
      ( cv cdiv co cle wbr crp wtru c1 c2 cr a1i wcel wa simpr rpred syl adantr
      cc0 vy cchp cfv wral wrex cmul wss rpssre 1re rerpdivcld cmpt co1 chpo1ub
      chpcl o1lo1d ad2antrl rehalfcld clt wb chpeq0 biimpar oveq1d rpcnd rpne0d
      wceq ad2ant2r 2rp simprll chpge0 divge0d eqbrtrd ad2antrr simprr chpwordi
      div0d ltled syl3anc lediv12ad ltlecasei lo1bddrp trud ledivmul2d ralbidva
      2re simpl rexbiia mpbi ) ACZUBUCZWHDEZBCZFGZAHUDZBHUEZWIWKWHUFEFGZAHUDZBH
      UEWNIAUAHWJJBUACZUBUCZKDEZHLUGIUHMJLNIUIMIWHHNZOZWIWHXAWHLNZWILNZXAWHIWTP
      ZQZWHUNZRZXDUJZIAHWJXHAHWJUKULNIAUMMUOIWQLNZJWQFGZOZOWRXIWRLNZIXJWQUNUPZU
      QXAXKWHWQURGZOZOZWJWSFGWHKXPWHKURGZOZWJTWHDEZWSFXRWITWHDXPWITVEZXQXPXBXTX
      QUSXAXBXOXESZWHUTRVAVBXPXSWSFGXQXPXSTWSFXPWHXPWHXAWTXOXDSZVCXPWHYBVDVOXPW
      RKIXKXLWTXNXMVFZKHNZXPVGMXPXITWRFGXAXIXJXNVHZWQVIRVJVKSVKXPKWHFGZOZWIWRKW
      HXAXCXOYFXGVLXPXLYFYCSYDYGVGMXPXBYFYASZYGXBTWIFGYHWHVIRYGXBXIWHWQFGZWIWRF
      GYHXPXIYFYESXPYIYFXPWHWQYAYEXAXKXNVMVPSWHWQVNVQXPYFPVRYAKLNXPWDMVSVTWAWMW
      PBHWKHNZWLWOAHYJWTOZWIWKWHYKXBXCYKWHYJWTPZQXFRYKWKYJWTWEQYLWBWCWFWG $.

    $( The sum of the von Mangoldt function over ` n ` is asymptotic to
       ` log x + O(1) ` .  Equation 9.2.13 of [Shapiro], p. 331.  (Contributed
       by Mario Carneiro, 16-Apr-2016.) $)
    vmadivsum $p |- ( x e. RR+ |->
      ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( Lam ` n ) / n ) -
        ( log ` x ) ) ) e. O(1) $=
      ( crp c1 cfv co cdiv cmin wtru cvv wcel cr a1i syl recnd cc0 cle wbr cmul
      cc cv cfl cfz cvma csu cfa clog cmpt cof co1 wceq reex rpssre ssexi eqidd
      wa ovex offval2 trud fzfid cn elfznn adantl nndivred fsumrecl relogcl cn0
      vmacl rprege0 flge0nn0 faccl relogcld rerpdivcl mpancom nnncan2d mpteq2ia
      3syl nnrpd eqtri cchp 1re chpo1ub rpre chpcl subcld cabs remulcld nndivre
      adantr syl2an reflcl resubcld vmage0 fracle1 lemul2ad subdid rpcn rpcnne0
      wne w3a div23 divass eqtr3d syl3anc oveq1d eqtr4d mulid1d 3brtr3d logfac2
      fsumle fsummulc1 oveq12d fsumsub chpval 3brtr4d wb lediv1 mpbid divsubdir
      rpregt0 rpne0 divcan4d eqtr2d fveq2d flle subge0d mulge0d breqtrd fsumge0
      mpbird breqtrrd divge0 syl21anc absidd eqtrd chpge0 ad2antrl o1le crli
      clt logfacrlim rlimo1 ax-mp o1sub mp2an eqeltrri ) ACDAUAZUBEZUCFZBUAZUDE
      ZUUJGFZBUEZUUHUFEZUGEZUUGGFZHFZUHZACUUGUGEZUUPHFZUHZHUIFZACUUMUUSHFZUHZUJ
      UVBACUUQUUTHFZUHZUVDUVBUVFUKIACUUQUUTHUURUVAJJJCJKICLULUMUNMUUQJKIUUGCKZU
      PZUUMUUPHUQMUUTJKUVHUUSUUPHUQMIUURUOIUVAUOURUSACUVEUVCUVGUUMUUSUUPUVGUUMU
      VGUUIUULBUVGDUUHUTZUVGUUJUUIKZUPZUUKUUJUVKUUJVAKZUUKLKUVJUVLUVGUUJUUHVBZV
      CZUUJVHNZUVNVDZVEZOZUVGUUSUUGVFOUVGUUPUUOLKUVGUUPLKUVGUUNUVGUUNUVGUUGLKZP
      UUGQRUPZUUHVGKUUNVAKUUGVIZUUGVJUUHVKVQVRVLZUUOUUGVMVNOZVOVPVSUURUJKZUVAUJ
      KZUVBUJKUWDIACUUGVTEZUUGGFZUUQDTDLKZIWAMACUWGUHUJKIAWBMUVGUWGTKIUVGUWGUWF
      LKZUVGUWGLKUVGUVSUWIUUGWCZUUGWDNZUWFUUGVMVNZOVCUVGUUQTKIUVGUUMUUPUVRUWCWE
      VCUVGUUQWFEZUWGWFEZQRIDUUGQRUVGUUMUUGSFZUUOHFZUUGGFZUWGUWMUWNQUVGUWPUWFQR
      ZUWQUWGQRZUVGUUIUULUUGSFZUUKUUGUUJGFZUBEZSFZHFZBUEZUUIUUKBUEZUWPUWFQUVGUU
      IUXDUUKBUVIUVKUWTUXCUVKUULUUGUVPUVGUVSUVJUWJWIWGZUVKUUKUXBUVOUVKUXALKZUXB
      LKUVGUVSUVLUXHUVJUWJUVMUUGUUJWHWJZUXAWKNZWGZWLZUVOUVKUUKUXAUXBHFZSFZUUKDS
      FUXDUUKQUVKUXMDUUKUVKUXAUXBUXIUXJWLZUWHUVKWAMUVOUVKUVLPUUKQRUVNUUJWMNZUVK
      UXHUXMDQRUXIUXAWNNWOUVKUXNUUKUXASFZUXCHFUXDUVKUUKUXAUXBUVKUUKUVOOZUVKUXAU
      XIOUVKUXBUXJOWPUVKUWTUXQUXCHUVKUUKTKZUUGTKZUUJTKUUJPWSUPZUWTUXQUKUXRUVGUX
      TUVJUUGWQZWIUVKUUJCKUYAUVKUUJUVNVRUUJWRNUXSUXTUYAWTUUKUUGSFUUJGFUWTUXQUUK
      UUGUUJXAUUKUUGUUJXBXCXDXEXFZUVKUUKUXRXGXHXJUVGUWPUUIUWTBUEZUUIUXCBUEZHFUX
      EUVGUWOUYDUUOUYEHUVGUUIUULUUGBUVIUYBUVKUULUVPOXKUVGUVTUUOUYEUKUWAUUGBXINX
      LUVGUUIUWTUXCBUVIUVKUWTUXGOUVKUXCUXKOXMXFZUVGUVSUWFUXFUKUWJUUGBXNNXOUVGUW
      PLKZUWIUVSPUUGYTRUPZUWRUWSXPUVGUWOUUOUVGUUMUUGUVQUWJWGZUWBWLZUWKUUGXTZUWP
      UWFUUGXQXDXRUVGUWMUWQWFEUWQUVGUUQUWQWFUVGUWQUWOUUGGFZUUPHFZUUQUVGUWOTKUUO
      TKUXTUUGPWSUPUWQUYMUKUVGUWOUYIOUVGUUOUWBOUUGWRUWOUUOUUGXSXDUVGUYLUUMUUPHU
      VGUUMUUGUVRUYBUUGYAYBXEYCYDUVGUWQUYGUVGUWQLKUYJUWPUUGVMVNUVGUYGPUWPQRUYHP
      UWQQRUYJUVGPUXEUWPQUVGUUIUXDBUVIUXLUVKPUXNUXDQUVKUUKUXMUVOUXOUXPUVKPUXMQR
      UXBUXAQRZUVKUXHUYNUXIUXAYENUVKUXAUXBUXIUXJYFYJYGUYCYHYIUYFYKUYKUWPUUGYLYM
      YNYOUVGUWGUWLUVGUWIPUWFQRZUYHPUWGQRUWKUVGUVSUYOUWJUUGYPNUYKUWFUUGYLYMYNXO
      YQYRUSUVADYSRUWEAUUADUVAUUBUUCUURUVAUUDUUEUUF $.

    $( Give a total bound on the von Mangoldt sum.  (Contributed by Mario
       Carneiro, 30-May-2016.) $)
    vmadivsumb $p |- E. c e. RR+ A. x e. ( 1 [,) +oo ) ( abs `
      ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( Lam ` n ) / n ) -
        ( log ` x ) ) ) <_ c $=
      ( c1 cv cfv co cle wbr crp wtru caddc cr wa a1i syl relogcld recnd adantr
      wcel vy cfl cfz cvma cdiv csu clog cmin cabs cpnf cico wral wrex elicopnf
      wb 1re mp1i simprbda 1rp simplbda rpgecld ex ssrdv rpssre syl6ss fzfid cn
      elfznn adantl nndivred fsumrecl resubcld cmpt co1 vmadivsum o1res2 simprl
      vmacl simprr readdcld clt abscld ad2ant2r abs2dif2d nnrpd divge0d fsumge0
      cc0 vmage0 absidd logge0d oveq12d breqtrd cuz wss simprll flword2 syl3anc
      ltled fzss2 fsumless logled mpbid le2addd letrd o1bddrp trud ) DAEZUBFZUC
      GZBEZUDFZXKUEGZBUFZXHUGFZUHGZUIFZCEHIADUJUKGZULCJUMKAUAXRXPDCDUAEZUBFZUCG
      ZXMBUFZXSUGFZLGZKXRJMKAXRJKXHXRTZXHJTZKYENZXHDKYEXHMTZDXHHIZDMTZYEYHYINUO
      KUPDXHUNUQZURZDJTZYGUSOKYEYHYIYKUTZVAZVBVCZVDVEYJKUPOYGXPYGXNXOYGXJXMBYGD
      XIVFZYGXKXJTZNZXLXKYSXKVGTZXLMTZYRYTYGXKXIVHVIZXKVRZPZUUBVJZVKZYGXHYOQZVL
      ZRKAXRJXPYPAJXPVMVNTKABVOOVPKXSMTZDXSHIZNZNZYBYCUULYAXMBUULDXTVFUULXKYATZ
      NZXLXKUUNYTUUAUUMYTUULXKXTVHZVIZUUCPUUPVJVKZUULXSUULXSDKUUIUUJVQYMUULUSOK
      UUIUUJVSVAZQVTZYGUUKXHXSWAIZNZNZXQXNXOLGZYDUVBXPUVBXPYGXPMTUVAUUHSRWBUVBX
      NXOYGXNMTUVAUUFSZUVBXHYGYFUVAYOSZQZVTKUUKYDMTYEUUTUUSWCUVBXQXNUIFZXOUIFZL
      GUVCHUVBXNXOUVBXNUVDRUVBXOUVFRWDUVBUVGXNUVHXOLUVBXNUVDYGWHXNHIUVAYGXJXMBY
      QUUEYSXLXKUUDYSXKUUBWEYSYTWHXLHIZUUBXKWIZPWFWGSWJUVBXOYGXOMTUVAUUGSUVBXHY
      GYHUVAYLSZYGYIUVAYNSWKWJWLWMUVBXNXOYBYCUVDUVFKUUKYBMTYEUUTUUQWCUVBXSKUUKX
      SJTYEUUTUURWCQUVBYAXMXJBUVBDXTVFUVBUUMNZXLXKUVLYTUUAUUMYTUVBUUOVIZUUCPZUV
      MVJUVLXLXKUVNUVLXKUVMWEUVLYTUVIUVMUVJPWFUVBXTXIWNFTZXJYAWOUVBYHUUIXHXSHIZ
      UVOUVKYGUUIUUJUUTWPZUVBXHXSUVKUVQYGUUKUUTVSWSZXHXSWQWRXIDXTWTPXAUVBUVPXOY
      CHIUVRUVBXHXSUVEUVBXSXHUVQUVEUVRVAXBXCXDXEXFXG $.
  $}

  ${
    $d k n p A $.
    $( Lemma for ~ rplogsum .  (Contributed by Mario Carneiro, 2-May-2016.) $)
    rplogsumlem1 $p |- ( A e. NN -> sum_ n e. ( 2 ... A )
      ( ( log ` n ) / ( n x. ( n - 1 ) ) ) <_ 2 ) $=
      ( wcel c2 co cfv c1 cmin cmul cdiv csqr wbr cr 2re cle cc wceq fveq2d cc0
      oveq2d vk cn cfz clog csu fzfid cuz elfzuz clt eluz2b2 simplbi syl adantl
      cv nnrpd relogcld uz2m1nn nnmulcld nndivred fsumrecl crp rpsqrcld sylancr
      rerpdivcl resubcld a1i rpred nnred peano2rem remulcld caddc nncnd sylancl
      ax-1cn npcan rpge0d loglesqr syl2anc eqbrtrrd readdcld lem1d sqrled mpbid
      wa remulcl subge0d mpbird leadd2dd rpcnd times2d breqtrrd lemul1ad sqsqrd
      subcl oveq12d subsq nncan 3eqtr3d 2cn mulassd 3brtr3d 1re lemul1d mulid2d
      recnd mul32d remsqsqr mul4d eqtr3d wne rpcnne0d divsubdiv syl22anc subdid
      mulcomd eqtr4d mulcld rpmulcld rerpdivcld rpne0d divcan2d 3eqtrd letrd wb
      cexp nngt0d ledivmul syl112anc fsumle oveq1 2m1e1 sqr1 div1i nnz eluzp1p1
      syl6eq nnuz eleq2s df-2 pncan fveq2i syl6eleqr fsumtscop sumeq2dv rpdivcl
      nncn 2rp nnrp subge02 eqbrtrd ) AUBCZDAUCEZBUNZUDFZUUMUUMGHEZIEZJEZBUEUUL
      DUUOKFZJEZDUUMKFZJEZHEZBUEZDUUKUULUUQBUUKDAUFZUUKUUMUULCZWDZUUNUUPUVFUUMU
      VFUUMUVEUUMUBCZUUKUVEUUMDUGFZCZUVGUUMDAUHZUVIUVGGUUMUILUUMUJUKULUMZUOZUPZ
      UVFUUMUUOUVKUVFUVIUUOUBCUVEUVIUUKUVJUMUUMUQULZURZUSZUTUUKUULUVBBUVDUVFUUS
      UVAUVFDMCZUURVACUUSMCNUVFUUOUVFUUOUVNUOZVBZDUURVDVCUVFUVQUUTVACUVAMCNUVFU
      UMUVLVBZDUUTVDVCVEZUTUVQUUKNVFUUKUULUUQUVBBUVDUVPUWAUVFUUQUVBOLZUUNUUPUVB
      IEZOLZUVFUUNUURUWCUVMUVFUURUVSVGZUVFUUPUVBUVFUUMUUOUVFUUMUVKVHZUVFUUMMCZU
      UOMCZUWFUUMVIULZVJZUWAVJUVFUUOGVKEZUDFZUUNUUROUVFUWKUUMUDUVFUUMPCZGPCZUWK
      UUMQUVFUUMUVKVLZVNUUMGVOVMRUVFUWHSUUOOLZUWLUUROLUWIUVFUUOUVRVPZUUOVQVRVSU
      VFUURUUTUURIEZDUUTUURHEZIEZIEZUWCOUVFGUURIEZUUTUWTIEZUURIEZUURUXAOUVFGUXC
      OLUXBUXDOLUVFUUTUURVKEZUWSIEZUUTDIEZUWSIEGUXCOUVFUXEUXGUWSUVFUUTUURUVFUUT
      UVTVGZUWEVTUVFUUTMCUVQUXGMCUXHNUUTDWEVMUVFUUTUURUXHUWEVEZUVFSUWSOLUURUUTO
      LZUVFUUOUUMOLUXJUVFUUMUWFWAUVFUUOUUMUWIUWQUWFUVFUUMUVLVPZWBWCZUVFUUTUURUX
      HUWEWFWGUVFUXEUUTUUTVKEUXGOUVFUURUUTUUTUWEUXHUXHUXLWHUVFUUTUVFUUTUVTWIZWJ
      WKWLUVFUUTDYEEZUURDYEEZHEZUUMUUOHEZUXFGUVFUXNUUMUXOUUOHUVFUUMUWOWMUVFUUOU
      VFUWMUWNUUOPCUWOVNUUMGWNVMWMWOUVFUUTPCZUURPCZUXPUXFQUXMUVFUURUVSWIZUUTUUR
      WPVRUVFUWMUWNUXQGQUWOVNUUMGWQVMWRUVFUUTDUWSUXMDPCZUVFWSVFZUVFUWSUXIXEWTXA
      UVFGUXCUURGMCUVFXBVFUVFUUTUWTUXHUVFUVQUWSMCUWTMCNUXIDUWSWEVCZVJUVSXCWCUVF
      UURUXTXDUVFUUTUWTUURUXMUVFUWTUYCXEZUXTXFXAUVFUWCUWRUWRIEZUWTUWRJEZIEUWRUW
      RUYFIEZIEUXAUVFUUPUYEUVBUYFIUVFUUTUUTIEZUURUURIEZIEUUPUYEUVFUYHUUMUYIUUOI
      UVFUWGSUUMOLUYHUUMQUWFUXKUUMXGVRUVFUWHUWPUYIUUOQUWIUWQUUOXGVRWOUVFUUTUUTU
      URUURUXMUXMUXTUXTXHXIUVFUVBDUUTIEDUURIEHEZUURUUTIEZJEZUYFUVFUYAUYAUXSUURS
      XJWDUXRUUTSXJWDUVBUYLQUYBUYBUVFUURUVSXKUVFUUTUVTXKDDUURUUTXLXMUVFUWTUYJUW
      RUYKJUVFDUUTUURUYBUXMUXTXNUVFUUTUURUXMUXTXOWOXPWOUVFUWRUWRUYFUVFUUTUURUXM
      UXTXQZUYMUVFUYFUVFUWTUWRUYCUVFUUTUURUVTUVSXRZXSXEWTUVFUYGUWTUWRIUVFUWTUWR
      UYDUYMUVFUWRUYNXTYATYBWKYCUVFUUNMCUVBMCUUPMCSUUPUILUWBUWDYDUVMUWAUWJUVFUU
      PUVOYFUUNUVBUUPYGYHWGYIUUKUVCDDAKFZJEZHEZDOUUKUULUUSDUUMGVKEZGHEZKFZJEZHE
      ZBUEDDAGVKEZGHEZKFZJEZHEUVCUYQUUKDUAUNZGHEZKFZJEZUUSVUADBUAVUFDAVUGUUMQZV
      UIUURDJVUKVUHUUOKVUGUUMGHYJRTVUGUYRQZVUIUYTDJVULVUHUYSKVUGUYRGHYJRTVUGDQZ
      VUJDGJEDVUMVUIGDJVUMVUIGKFGVUMVUHGKVUMVUHDGHEGVUGDGHYJYKYPRYLYPTDWSYMYPVU
      GVUCQZVUIVUEDJVUNVUHVUDKVUGVUCGHYJRTAYNUUKVUCGGVKEZUGFZUVHVUCVUPCAGUGFUBG
      AYOYQYRDVUOUGYSUUAUUBUUKVUGDVUCUCECZWDZVUJVURUVQVUIVACVUJMCNVURVUHVURVUHV
      UQVUHUBCZUUKVUQVUGUVHCVUSVUGDVUCUHVUGUQULUMUOVBDVUIVDVCXEUUCUUKUULVUBUVBB
      UVFVUAUVAUUSHUVFUYTUUTDJUVFUYSUUMKUVFUWMUWNUYSUUMQUWOVNUUMGYTVMRTTUUDUUKV
      UFUYPDHUUKVUEUYODJUUKVUDAKUUKAPCUWNVUDAQAUUFVNAGYTVMRTTWRUUKSUYPOLZUYQDOL
      ZUUKUYPUUKDVACUYOVACUYPVACUUGUUKAAUUHVBDUYOUUEVCZVPUUKUVQUYPMCVUTVVAYDNUU
      KUYPVVBVGDUYPUUIVCWCUUJYC $.

    $( Lemma for ~ rplogsum .  Equation 9.2.14 of [Shapiro], p. 331.
       (Contributed by Mario Carneiro, 2-May-2016.) $)
    rplogsumlem2 $p |- ( A e. ZZ -> sum_ n e. ( 1 ... A )
      ( ( ( Lam ` n ) - if ( n e. Prime , ( log ` n ) , 0 ) ) / n ) <_ 2 ) $=
      ( vp vk wcel c1 co cfv cprime cc0 cmin cdiv c2 cle wceq wa syl wbr cmul
      cr cz cfz cv cvma clog cif csu cicc cin cfl cexp flid sumeq1d fveq2 eleq1
      oveq2d eqidd ifbieq12d oveq12d id zre cn elfznn adantl vmacl relogcld 0re
      nnrpd ifcl sylancl resubcld nndivred recnd simprr wn crp vmaprm prmnn cuz
      nnred clt prmuz2 eluz2b2 simprbi rplogcld eqeltrd rpne0d necon2bi iffalse
      ad2antll 0cn subidi syl6eq oveq1d cc wne ad2antrl rpcnne0d eqtrd fsumvma2
      div0 eqtr3d caddc cfn wss fzfid sseldi adantr abscld wb sylancr letrd cn0
      cabs syl2anc mpbird nnnn0d anassrs fsumrecl nnmulcld a1i elrpd rerpdivcld
      rpcnd mpbid eqbrtrd 1re fveq2d elfzuz simplbi eleq2s syl2an sylan2 rpge0d
      nncnd nnrecred syl3anc nnne0d divrecd eqtr4d inss2 simpr zcn peano2re w3a
      inss1 sseli elicc2 syl5ib simp3d leabsd lep1d nn0abscl nn0p1nn nnzd elfz5
      imp ex ssrdv simprl vmappw adantrr nnexpcl uz2m1nn nngt0d ltletrd mulid2d
      ssfi 2re logled lemuldivd flge1nn nnuz syl6eleq oveq2 eleq1d fsum1p exp1d
      iftrue subidd 1p1e2 oveq1i cq nnq expnprm subid1d sumeq12dv nnnn0 addid2d
      3eqtrd rpreccld flcld peano2zd rpexpcld resqcld peano2nnd reexpcld dmdcan
      subge02d divsubdir divid divdiv1 sqvald 3eqtr3d breqtrrd resubcl ledivmul
      recgt1 posdif syl112anc lemul2d nnz exprecd sumeq2dv expcl fsummulc2 cfzo
      fzval3 2nn0 eluzp1p1 df-2 fveq2i syl6eleqr geoserg 3eqtr2d 3brtr4d fsumle
      ltned rpdivcld rpred fsumless rplogsumlem1 ) AUAEZFAUBGZBUCZUDHZUYOIEZUYO
      UEHZJUFZKGZUYOLGZBUGZJAUHGZIUIZFAUEHZCUCZUEHZLGZUJHZUBGZVUFDUCZUKGZUDHZVU
      LIEZVULUEHZJUFZKGZVULLGZDUGZCUGZMNUYMFAUJHZUBGZVUABUGVUBVUTUYMVVBUYNVUABU
      YMVVAAFUBAULUPUMUYMBAVUAVURDCUYOVULOZUYTVUQUYOVULLVVCUYPVUMUYSVUPKUYOVULU
      DUNVVCUYQVUNUYRJVUOJUYOVULIUOUYOVULUEUNVVCJUQURUSVVCUTUSAVAZUYMUYOVVBEZPZ
      VUAVVFUYTUYOVVFUYPUYSVVFUYOVBEZUYPTEVVEVVGUYMUYOVVAVCZVDZUYOVEQVVFUYRTEJT
      EZUYSTEVVFUYOVVFUYOVVIVHVFVGUYQUYRJTVIVJVKVVIVLVMUYMVVEUYPJOZPPZVUAJUYOLG
      ZJVVLUYTJUYOLVVLUYTJJKGJVVLUYPJUYSJKUYMVVEVVKVNVVLUYQVOZUYSJOVVKVVNUYMVVE
      UYQUYPJUYQUYPUYQUYPUYRVPUYOVQUYQUYOUYQUYOUYOVRVTUYQUYOMVSHZEZFUYOWARZUYOW
      BVVPVVGVVQUYOWCWDQWEWFWGWHWJUYQUYRJWIQUSJWKWLWMWNVVLUYOWOEUYOJWPPVVMJOVVL
      UYOVVLUYOVVEVVGUYMVVKVVHWQVHWRUYOXAQWSWTXBUYMVUTVUDVUGVUFVUFFKGZSGZLGZCUG
      ZMUYMVUDVUSCUYMMAXNHZFXCGZUBGZXDEVUDVWDXEVUDXDEUYMMVWCXFZUYMCVUDVWDUYMVUF
      VUDEZVUFVWDEZUYMVWFPZVWGVUFVWCNRZVWHVUFAVWCVWHVUFVWHVUFIEZVUFVBEZVWHVUDIV
      UFVUCIUUAZUYMVWFUUBXGZVUFVRQZVTZUYMATEZVWFVVDXHZUYMVWCTEZVWFUYMVWBTEVWRUY
      MAAUUCZXIVWBUUDQXHZVWHVUFTEZJVUFNRZVUFANRZUYMVWFVXAVXBVXCUUEZVWFVUFVUCEZU
      YMVXDVUDVUCVUFVUCIUUFUUGUYMVVJVWPVXEVXDXJVGVVDJAVUFUUHXKUUIUUQUUJZVWHAVWB
      VWCVWQVWHAUYMAWOEVWFVWSXHXIZVWTVWHAVWQUUKVWHVWBVXGUULXLXLVWHVUFVVOEZVWCUA
      EZVWGVWIXJVWHVWJVXHVWMVUFWBZQZUYMVXIVWFUYMVWCUYMVWBXMEVWCVBEZAUUMVWBUUNQZ
      UUOXHVUFMVWCUUPXOXPUURUUSZVWDVUDUVHXOZVWHVUJVURDVWHFVUIXFUYMVWFVUKVUJEZVU
      RTEUYMVWFVXPPPZVUQVULVXQVUMVUPVXQVUMVUGTVXQVWJVUKVBEZVUMVUGOZVXQVUDIVUFVW
      LUYMVWFVXPUUTXGVXPVXRUYMVWFVUKVUIVCWJZVUFVUKUVAZXOVXQVUFVXQVUFUYMVWFVWKVX
      PVWNUVBZVHVFWFVXQVUOTEVVJVUPTEVXQVULVXQVULVXQVWKVUKXMEZVULVBEZVYBVXQVUKVX
      TXQVUFVUKUVCZXOZVHVFVGVUNVUOJTVIVJVKVYFVLZXRXSZXSUYMVUDVVTCVXOVWHVUGVVSVW
      HVUFVWHVUFVWNVHZVFZVWHVUFVVRVWNVWHVXHVVRVBEZVXKVUFUVDZQZXTZVLZXSZMTEUYMUV
      IYAZUYMVUDVUSVVTCVXOVYHVYOVWHVUSMVUIUBGZVUGVULLGZDUGZVVTNVWHVUSVUFFUKGZUD
      HZWUAIEZWUAUEHZJUFZKGZWUALGZFFXCGZVUIUBGZVURDUGZXCGJVYTXCGVYTVWHVURWUGDFV
      UIVWHVUIVBFVSHZVWHVUHTEFVUHNRZVUIVBEVWHVUEVUGVWHAVWHAVWQVWHJVUFAVVJVWHVGY
      AVWOVWQVWHVUFVWNUVEZVXFUVFYBZVFZVWHVUFVWOVWHVWJFVUFWARZVWMVWJVXHWUPVXJVXH
      VWKWUPVUFWCZWDZQQZWEZYCZVWHFVUGSGZVUENRWULVWHWVBVUGVUENVWHVUGVWHVUGWUTYDZ
      UVGVWHVXCVUGVUENRVXFVWHVUFAVYIWUNUVJYEYFVWHFVUEVUGFTEZVWHYGYAZWUOWUTUVKYE
      VUHUVLXOZUVMUVNZUYMVWFVXPVURWOEVXQVURVYGVMXRVUKFOZVUQWUFVULWUALWVHVUMWUBV
      UPWUEKWVHVULWUAUDVUKFVUFUKUVOZYHWVHVUNWUCVUOJWUDJWVHVULWUAIWVIUVPWVHVULWU
      AUEWVIYHWVHJUQURUSWVIUSUVQVWHWUGJWUJVYTXCVWHWUGJVUFLGZJVWHWUFJWUAVUFLVWHW
      UFVUGVUGKGJVWHWUBVUGWUEVUGKVWHWUBVUFUDHZVUGVWHWUAVUFUDVWHVUFVWHVUFVWNYOZU
      VRZYHVWHVWJWVKVUGOVWMVUFVQQWSVWHWUEWUDVUGVWHWUCWUEWUDOVWHWUAVUFIWVMVWMWFW
      UCWUDJUVSQVWHWUAVUFUEWVMYHWSUSVWHVUGWVCUVTWSWVMUSVWHVUFWOEZVUFJWPPZWVJJOV
      WHVUFVYIWRZVUFXAQWSVWHWUIVYRVURVYSDWUIVYROVWHWUHMVUIUBUWAUWBZYAVWHVUKWUIE
      ZPZVUQVUGVULLWVSVUQVUGJKGZVUGWVSVUMVUGVUPJKVWHVWJVXRVXSWVRVWMVXRVUKVYRWUI
      VUKVYREZVUKVVOEZVXRVUKMVUIYIZWWBVXRFVUKWARVUKWCYJQZWVQYKVYAYLWVSVUNVOZVUP
      JOWVSVUFUWCEZWWBWWEWVSVWKWWFVWHVWKWVRVWNXHVUFUWDQWVRWWBVWHWWBVUKVYRWUIWWC
      WVQYKVDVUFVUKUWEXOVUNVUOJWIQUSVWHWVTVUGOWVRVWHVUGWVCUWFXHWSWNUWGUSVWHVYTV
      WHVYTVWHVYRVYSDVWHMVUIXFZWWAVWHVXRVYSTEWWDVWHVXRPZVUGVULVWHVUGTEVXRVYJXHV
      WHVWKVYCVYDVXRVWNVUKUWHVYEYLZVLYMXSVMUWIUWJVWHVUGFVUFLGZMUKGZWWJVUIFXCGZU
      KGZKGZFWWJKGZLGZSGZVUGFVVSLGZSGZVYTVVTNVWHWWPWWRNRZWWQWWSNRVWHWWTWWNWWOWW
      RSGZNRZVWHWWNWWKWXANVWHJWWMNRWWNWWKNRVWHWWMVWHWWJWWLVWHVUFVYIUWKZVWHVUIVW
      HVUHWVAUWLZUWMUWNYNVWHWWKWWMVWHWWJVWHVUFVWNYPZUWOZVWHWWJWWLWXEVWHWWLVWHVU
      IWVFUWPXQUWQZUWSYEVWHVVRVUFLGZWWJVVRLGZSGZWWJVUFLGZWXAWWKVWHVVRWOEVVRJWPP
      ZWVOWWJWOEZWXJWXKOVWHVVRVWHVVRVYMVHWRZWVPVWHWWJWXCYDZVVRVUFWWJUWRYQVWHWXH
      WWOWXIWWRSVWHWXHVUFVUFLGZWWJKGZWWOVWHWVNFWOEZWVOWXHWXQOWVLVWHFWVEVMZWVPVU
      FFVUFUWTYQVWHWXPFWWJKVWHWVOWXPFOWVPVUFUXAQWNWSVWHWXRWVOWXLWXIWWROWXSWVPWX
      NFVUFVVRUXBYQUSVWHWXKWWJWWJSGWWKVWHWWJVUFWXOWVLVWHVUFVWNYRYSVWHWWJWXOUXCY
      TUXDUXEVWHWWNTEWWRTEWWOTEZJWWOWARZWWTWXBXJVWHWWKWWMWXFWXGVKZVWHVVSVYNYPZV
      WHWVDWWJTEZWXTYGWXEFWWJUXFXKZVWHWWJFWARZWYAVWHWUPWYFWUSVWHVXAJVUFWARWUPWY
      FXJVWOWUMVUFUXHXOYEZVWHWYDWVDWYFWYAXJWXEYGWWJFUXIVJYEZWWNWWRWWOUXGUXJXPVW
      HWWPWWRVUGVWHWWNWWOWYBVWHWWOWYEWYHYBYCWYCWUTUXKYEVWHVYTVYRVUGWWJVUKUKGZSG
      ZDUGVUGVYRWYIDUGZSGWWQVWHVYRVYSWYJDWWAVWHVXRVYSWYJOWWDWWHVYSVUGFVULLGZSGW
      YJWWHVUGVULVWHVUGWOEVXRWVCXHWWHVULWWIYOWWHVULWWIYRYSWWHWYIWYLVUGSWWHVUFVU
      KVWHWVNVXRWVLXHWWHVUFVWHVWKVXRVWNXHYRVXRVUKUAEVWHVUKUXLVDUXMUPYTYMUXNVWHV
      YRWYIVUGDWWGWVCVWHWXMVYCWYIWOEWWAWXOWWAVUKWWDXQWWJVUKUXOYLUXPVWHWYKWWPVUG
      SVWHWYKMWWLUXQGZWYIDUGWWPVWHVYRWYMWYIDVWHVUIUAEVYRWYMOWXDMVUIUXRQUMVWHWWJ
      DMWWLWXOVWHWWJFWXEWYGUYHMXMEVWHUXSYAVWHWWLWUHVSHZVVOVWHVUIWUKEWWLWYNEWVGF
      VUIUXTQMWUHVSUYAUYBUYCUYDWSUPUYEVWHVUGVVSWVCVWHVVSVYNYOVWHVVSVYNYRYSUYFYF
      UYGUYMVWAVWDVVTCUGZMVYPUYMVWDVVTCVWEUYMVWGPZVVTWYPVUGVVSWYPVUFWYPVUFVWGVW
      KUYMVWGVXHVWKVUFMVWCYIZVXHVWKWUPWUQYJQVDZVTWYPVXHWUPVWGVXHUYMWYQVDZWURQWE
      WYPVVSWYPVUFVVRWYRWYPVXHVYKWYSVYLQXTVHUYIZUYJZXSVYQUYMVWDVVTVUDCVWEXUAWYP
      VVTWYTYNVXNUYKUYMVXLWYOMNRVXMVWCCUYLQXLXLYF $.
  $}

  ${
    $( Lemma for ~ dchrisum0lem1 .  (Contributed by Mario Carneiro,
       7-Jun-2016.) $)
    dchrisum0lem1a $p |- ( ( ( ph /\ X e. RR+ ) /\ D e. ( 1 ... ( |_ ` X ) ) )
      -> ( X <_ ( ( X ^ 2 ) / D ) /\
           ( |_ ` ( ( X ^ 2 ) / D ) ) e. ( ZZ>= ` ( |_ ` X ) ) ) ) $=
      ( crp wcel wa c1 cfl cfv cfz co c2 cexp cle wbr cmul adantl adantr rpred
      cr cuz cn elfznn nnred cc0 clt simpr rpregt0d simpld rpge0d wb fznnfl syl
      cdiv simplbda lemul2ad wceq cc rpcn sqvald breqtrrd cz 2z rpexpcl sylancl
      nnrpd lemuldivd mpbid nndivre syl2an flword2 syl3anc jca ) ACDEZFZBGCHIZJ
      KEZFZCCLMKZBUNKZNOZVTHIVPUAIEZVRCBPKZVSNOWAVRWCCCPKZVSNVRBCCVRBVQBUBEZVOB
      VPUCZQZUDVRCTEZUECUFOZVOWHWIFVQVOCAVNUGZUHRUIZWKVRCVOVNVQWJRUJVOVQWEBCNOZ
      VOWHVQWEWLFUKVOCWJSBCULUMUOUPVOVSWDUQVQVOCVNCUREACUSQUTRVAVRCVSBWKVOVSTEZ
      VQVOVSVOVNLVBEVSDEWJVCCLVDVESZRVRBWGVFVGVHZVRWHVTTEZWAWBWKVOWMWEWPVQWNWFV
      SBVIVJWOCVTVKVLVM $.
  $}

  ${ $( $n b m q v F $n a b q y ph $n n A $n x B $)
    $d k m n u w x y z $.  $d c f i j k m n p t x y z .1. $.  $d d m n x y C $.
    $d c d e i j k n p r t u x y z F $.  $d i k n u x z I $.  $d i k n u x J $.
    $d a b c d f i j k m p q t v x y z A $.  $d d m x y E $.  $d k m r y K $.
    $d f G $.  $d c f i j k m n p q r t u x y z N $.  $d b i k m n q v x y P $.
    $d c d e f i j k m n p r t u x z ph $.  $d d m ps $.  $d d m n p r x y T $.
    $d c d i k m n u x z R $.  $d c d k m n r t x y S $.  $d k m n p u x z U $.
    $d b c i j k m n q r v y z B $.  $d c f t x z W $.  $d f k m n p x y z Z $.
    $d c f i j k m n t x y z D $.  $d a b c d f i j k m n p r t u v x y z L $.
    $d c i j k m n r u x z M $.  $d a b c d i j k m n r t u v x y z X $.
    rpvmasum.z $e |- Z = ( Z/nZ ` N ) $.
    rpvmasum.l $e |- L = ( ZRHom ` Z ) $.
    rpvmasum.a $e |- ( ph -> N e. NN ) $.
    ${
      rpvmasum.g $e |- G = ( DChr ` N ) $.
      rpvmasum.d $e |- D = ( Base ` G ) $.
      rpvmasum.1 $e |- .1. = ( 0g ` G ) $.
      $( Lemma for ~ rpvmasum .  Calculate the "trivial case" estimate
         ` sum_ n <_ x ( .1. ( n ) Lam ( n ) / n ) = log x + O(1) ` , where
         ` .1. ( x ) ` is the principal Dirichlet character.  Equation 9.4.7 of
         [Shapiro], p. 376.  (Contributed by Mario Carneiro, 2-May-2016.) $)
      rpvmasumlem $p |- ( ph -> ( x e. RR+ |-> ( sum_ n e. ( 1 ... ( |_ ` x ) )
  ( ( .1. ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) - ( log ` x ) ) ) e. O(1) ) $=
        ( c1 co wcel cle cc0 vq vp crp cfl cfv cfz cvma cdiv csu clog cmin cmpt
        vk cv cmul co1 cvv cc cr rpssre a1i wa fzfid cn elfznn adantl vmacl syl
        nndivred recnd fsumcl adantr 1re wf eqid cz cn0 nnnn0d elfzelz ffvelrnd
        resubcl sylancr remulcld eqidd wceq ax-1cn oveq1d sumeq2dv eqtr3d eqtrd
        mulid2d cdivides wbr cprime crab wss cfn nnrpd relogcld sylan2 fsumrecl
        cuz simpr 0re syl6eqel wne ad3antrrr ad2antrr adantlr dchrn0 pm2.61dane
        biimpa dchr1 0le1 syl6eqbr leidi wb mpbird vmage0 nnred nngt0d syl22anc
        clt divge0 syl2anc sseli cexp fveq2 oveq2d ad2antrl simprr nncnd nnne0d
        oveq12d ad2antll nnzd anassrs mpbid syl3anc nnrecred reex ssexi relogcl
        cof subcld cbs dchr1re wfo znzrhfo 3syl ffvelrn offval2 fsumsub subdird
        syl2an sub32d nncan 3eqtr3rd mpteq2dva vmadivsum prmdvdsfi elrabi prmnn
        fof c2 prmuz2 uz2m1nn cabs cui cabel cgrp dchrabl ablgrp grpidcl subge0
        4syl mulge0d absidd cicc cin inss2 rabss2 mp1i ssfi ssrab2 sstri fveq2d
        fsumge0 id rpre div0d ad2ant2r mul01d fsumvma2 nnexpcld wn breq1 notbid
        cdif notrab elrab2 cgcd simplrr simplrl coprm prmz rpexp1i mpd adantlrr
        wi znunit 1m1e0 syl6eq mul02d wo olcd sumz sylanr1 sylan2b ppifi fsumss
        caddc rpreccld eluz2b2 simprbi rplogcld rerpdivcld flcld peano2zd rpred
        eqtr4d rpexpcld resubcld rpdivcld divrecd simprl vmappw eqcomd eqeltrrd
        exprecd syl5breqr subge02 lemul1ad breqtrd fsumle fsummulc2 cfzo fzval3
        reexpcld sumeq1d recgt1 1nn0 log1 1rp logleb syl5eqbrr divge0d flge0nn0
        ltned nn0p1nn nnuz syl6eleq geoserg exp1d divsubdir divid eqtr2d 3eqtrd
        rpcnne0d rpge0d subge02d dmdcan breqtrrd lemul2d letrd eqbrtrd fsumless
        ledivmuld elo1d o1sub ) ABUCPBUNZUDUEZUFQZEUNZUGUEZVWDUHQZEUIZVWAUJUEZU
        KQZULZBUCVWCPVWDGUEZDUEZUKQZVWFUOQZEUIZULZUKUUDQZBUCVWCVWLVWFUOQZEUIZVW
        HUKQZULZUPAVWQBUCVWIVWOUKQZULVXAABUCVWIVWOUKVWJVWPUQURURUCUQRAUCUSUUAUT
        UUBVAAVWAUCRZVBZVWGVWHAVWGURRVXCAVWCVWFEAPVWBVCZAVWDVWCRZVBZVWFVXGVWEVW
        DVXGVWDVDRZVWEUSRZVXFVXHAVWDVWBVEZVFZVWDVGVHZVXKVIZVJZVKVLZVXDVWHVXCVWH
        USRAVWAUUCVFVJZUUEAVWOURRVXCAVWCVWNEVXEVXGVWNVXGVWMVWFVXGPUSRZVWLUSRZVW
        MUSRZVMVXGIUUFUEZUSVWKDAVXTUSDVNZVXFAVXTDFHIMJOVXTVOZLUUGZVLAVPVXTGVNZV
        WDVPRVWKVXTRZVXFAHVQRZVPVXTGUUHVYDAHLVRVXTGHIJVYBKUUIVPVXTGUVDUUJZVWDPV
        WBVSVPVXTVWDGUUKUUOZVTZPVWLWAZWBZVXMWCVJZVKVLZAVWJWDAVWPWDUULABUCVXBVWT
        VXDVXBVWGVWOUKQZVWHUKQZVWTVXDVWGVWHVWOVXOVXPVYMUUPAVYOVWTWEVXCAVYNVWSVW
        HUKAVWCVWFVWNUKQZEUIVYNVWSAVWCVWFVWNEVXEVXNVYLUUMAVWCVYPVWREVXGPVWMUKQZ
        VWFUOQPVWFUOQZVWNUKQVWRVYPVXGPVWMVWFPURRZVXGWFVAVXGVWMVYKVJZVXNUUNVXGVY
        QVWLVWFUOVXGVYSVWLURRVYQVWLWEWFVXGVWLVYIVJPVWLUUQWBWGVXGVYRVWFVWNUKVXGV
        WFVXNWKWGUURWHWIWGVLWJUUSWJAVWJUPRVWPUPRVWQUPRBEUUTABUCVWOPUAUNZHWLWMZU
        AWNWOZUBUNZUJUEZWUDPUKQZUHQZUBUIZUCUSWPAUTVAVYMVXQAVMVAAWUCWUGUBAHVDRZW
        UCWQRZLHUAUVAVHZWUDWUCRZAWUDWNRZWUGUSRZWUBUAWUDWNUVBZAWUMVBZWUEWUFWUPWU
        DWUPWUDWUMWUDVDRZAWUDUVCZVFWRWSZWUPWUDUVEXBUERZWUFVDRZWUMWUTAWUDUVFZVFW
        UDUVGZVHVIZWTZXAZAVXCPVWASWMZVBZVBZVWOUVHUEVWOWUHSWVIVWOWVIVWCVWNEWVIPV
        WBVCZWVIVXFVBZVWMVWFWVKVXQVXRVXSVMWVKVXRVWLTWVKVWLTWEZVBZVWLTUSWVKWVLXC
        ZXDXEWVKVWLTXFZVBZVWLPUSWVPVWKIUVIUEZDFHIMJOWVQVOZAWUIWVHVXFWVOLXGWVKWV
        OVWKWVQRWVKVWKVXTCWVQFHDIMJNVYBWVRADCRZWVHVXFAWUIFUVJRFUVKRWVSLFHMUVLFU
        VMCFDNOUVNUVPZXHAVXFVYEWVHVYHXIXJXLXMZVMXEXKZVYJWBZAVXFVWFUSRWVHVXMXIZW
        CZXAZWVIVWCVWNEWVJWWEWVKVWMVWFWWCWWDWVKTVWMSWMZVWLPSWMZWVKWWHVWLTWVMVWL
        TPSWVNXNXOWVPVWLPPSWWAPVMXPXOXKWVKVXQVXRWWGWWHXQVMWWBPVWLUVOWBXRWVKVXIT
        VWESWMZVWDUSRTVWDYCWMTVWFSWMAVXFVXIWVHVXLXIWVKVXHWWIVXFVXHWVIVXJVFZVWDX
        SVHWVKVWDWWJXTWVKVWDWWJYAVWEVWDYDYBUVQUWHUVRWVIVWOWUBUATVWAUVSQZWNUVTZW
        OZWUGUBUIZWUHWWFWVIWWMWUGUBWVIWUJWWMWUCWPZWWMWQRAWUJWVHWUKVLZWWLWNWPWWO
        WVIWWKWNUWAZWUBUAWWLWNUWBUWCZWUCWWMUWDYEZWUDWWMRZWVIWUMWUNWWMWNWUDWWMWW
        LWNWUBUAWWLUWEZWWQUWFYFZAWUMWUNWVHWVDXIZWTZXAAWUHUSRWVHWVFVLWVIVWOWWMPV
        WHWUEUHQZUDUEZUFQZPWUDUMUNZYGQZGUEZDUEZUKQZWXIUGUEZWXIUHQZUOQZUMUIZUBUI
        ZWWNSWVIVWOWWLWXPUBUIWXQWVIEVWAVWNWXOUMUBVWDWXIWEZVWMWXLVWFWXNUOWXRVWLW
        XKPUKWXRVWKWXJDVWDWXIGYHUWGYIWXRVWEWXMVWDWXIUHVWDWXIUGYHWXRUWIYNYNVXCVW
        AUSRZAWVGVWAUWJYJZAVXFVWNURRWVHVYLXIWVIVXFVWETWEZVBVBZVWNVWMTUOQTWYBVWF
        TVWMUOWYBVWFTVWDUHQTWYBVWETVWDUHWVIVXFWYAYKWGWYBVWDWYBVWDVXFVXHWVIWYAVX
        JYJZYLWYBVWDWYCYMUWKWJYIWYBVWMAVXFVWMURRWVHWYAVYTUWLUWMWJUWNWVIWWMWWLWX
        PUBWWMWWLWPWVIWXAVAWWTWVIWUMWXPURRWXBWVIWUMVBZWXGWXOUMWYDPWXFVCZWYDWXHW
        XGRZVBWXOWVIWUMWYFWXOUSRWVIWUMWYFVBZVBZWXLWXNWYHVXQWXKUSRZWXLUSRVMWYHVX
        TUSWXJDAVYAWVHWYGVYCXHWYHVPVXTWXIGAVYDWVHWYGVYGXHWYHWXIWYHWUDWXHWUMWUQW
        VIWYFWURYJZWYHWXHWYFWXHVDRZWVIWUMWXHWXFVEZYOZVRZUWOZYPZVTZVTZPWXKWAWBZW
        YHWXMWXIWYHWXIVDRZWXMUSRZWYOWXIVGVHZWYOVIZWCYQZVJVKWTWUDWWLWWMUWSZRWVIW
        UDWWLRZWUDHWLWMZUWPZVBWXPTWEZWUBUWPXUHUAWUDWWLXUEWUAWUDWEWUBXUGWUAWUDHW
        LUWQUWRWUBUAWWLUWTUXAXUFWVIWUMXUHXUIWWLWNWUDWWQYFWVIWUMXUHVBZVBZWXPWXGT
        UMUIZTXUKWXGWXOTUMXUKWYFVBZWXOTWXNUOQTXUMWXLTWXNUOXUMWXLPPUKQTXUMWXKPPU
        KXUMWXJWVQDFHIMJOWVRAWUIWVHXUJWYFLXGZXUMWXJWVQRZWXIHUXBQPWEZXUMWUDHUXBQ
        PWEZXUPXUMXUHXUQWVIWUMXUHWYFUXCXUMWUMHVPRZXUHXUQXQWVIWUMXUHWYFUXDZXUMHX
        UNYPZWUDHUXEYEYRXUMWUDVPRZXURWXHVQRXUQXUPUXJXUMWUMXVAXUSWUDUXFVHXUTXUMW
        XHWYFWYKXUKWYLVFVRWUDHWXHUXGYSUXHXUMVYFWXIVPRZXUOXUPXQXUMHXUNVRWVIWUMWY
        FXVBXUHWVIWUMWYFXVBWYPYQUXIWXIWVQGHIJWVRKUXKYEXRXMYIUXLUXMWGXUMWXNWVIWU
        MWYFWXNURRZXUHWVIWUMWYFXVCWYHWXNXUCVJZYQUXIUXNWJWHXUKWXGPXBUEZWPZWXGWQR
        ZUXOXULTWEXUKXVGXVFXUKPWXFVCUXPWXGUMPUXQVHWJUXRUXSWVIWXSWWLWQRWXTVWAUXT
        VHUYAUYKWVIWWMWXPWUGUBWWSWWTWVIWUMWXPUSRWXBWYDWXGWXOUMWYEXUDXAZWTWXDWWT
        WVIWUMWXPWUGSWMWXBWYDWXPWUEPWUDUHQZXVIWXFPUYBQZYGQZUKQZWUFWUDUHQZUHQZUO
        QZWUGXVHWYDWUEXVNAWUMWUEUSRWVHWUSXIZWYDXVLXVMWYDXVIXVKWYDWUDWUMWUQWVIWU
        RVFZYTZWYDXVKWYDXVIXVJWYDWUDWYDWUDXVQWRZUYCWYDWXFWYDWXEWYDVWHWUEWYDVWAA
        VXCWVGWUMUXDWSZWYDWUDWYDWUDXVQXTZWYDWUTPWUDYCWMZWUMWUTWVIWVBVFZWUTWUQXW
        BWUDUYDUYEVHZUYFZUYGZUYHZUYIUYLZUYJZUYMZWYDWUFWUDWYDWUFWYDWUTWVAXWCWVCV
        HZWRZXVSUYNZUYGZWCWXCWYDWXPWXGWUEXVIWXHYGQZUOQZUMUIZXVOSWYDWXGWXOXWPUMW
        YEXUDWVIWUMWYFXWPUSRWYHWXNXWPUSWYHWXNWXMPWXIUHQZUOQXWPWYHWXMWXIWYHWXMXU
        BVJWYHWXIWYOYLWYHWXIWYOYMUYOWYHWXMWUEXWRXWOUOWYHWUMWYKWXMWUEWEWVIWUMWYF
        UYPWYMWUDWXHUYQYEWYHXWOXWRWYHWUDWXHWYHWUDWYJYLWYHWUDWYJYMWYFWXHVPRWVIWU
        MWXHPWXFVSYOUYTUYRYNWJZXUCUYSYQWVIWUMWYFWXOXWPSWMWYHWXOPWXNUOQZXWPSWYHW
        XLPWXNWYSVXQWYHVMVAXUCWYHXUATWXMSWMZWXIUSRTWXIYCWMTWXNSWMXUBWYHWYTXXAWY
        OWXIXSVHWYHWXIWYOXTWYHWXIWYOYAWXMWXIYDYBWYHTWXKSWMZWXLPSWMZWYHXXBWXKTWY
        HWXKTWEZVBTTWXKSTXDXPWYHXXDXCVUAWYHWXKTXFZVBZTPWXKSXNXXFWXJWVQDFHIMJOWV
        RAWUIWVHWYGXXELXGWYHXXEXUOWYHWXJVXTCWVQFHDIMJNVYBWVRAWVSWVHWYGWVTXHWYQX
        JXLXMVUAXKWYHVXQWYIXXBXXCXQVMWYRPWXKVUBWBYRVUCWYHXWTWXNXWPWYHWXNXVDWKXW
        SWJVUDYQVUEWYDWUEWXGXWOUMUIZUOQXWQXVOWYDWXGXWOWUEUMWYEWYDWUEXVPVJZWVIWU
        MWYFXWOURRWYHXWOWYHXVIWXHWYHWUDWYJYTWYNVUIVJYQVUFWYDXXGXVNWUEUOWYDXXGPX
        VJVUGQZXWOUMUIXVIPYGQZXVKUKQZPXVIUKQZUHQXVNWYDWXGXXIXWOUMWYDWXFVPRWXGXX
        IWEXWGPWXFVUHVHVUJWYDXVIUMPXVJWYDXVIXVRVJZWYDXVIPXVRWYDXWBXVIPYCWMZXWDW
        YDWUDUSRTWUDYCWMXWBXXNXQXWAWYDWUDXVQYAWUDVUKYEYRVUSPVQRWYDVULVAWYDXVJVD
        XVEWYDWXFVQRZXVJVDRWYDWXEUSRTWXESWMXXOXWFWYDVWHWUEXVTXWEWVITVWHSWMWUMWV
        ITPUJUEZVWHSVUMWVIWVGXXPVWHSWMZAVXCWVGYKWVIPUCRVXCWVGXXQXQVUNAVXCWVGUYP
        PVWAVUOWBYRVUPVLVUQWXEVURYEWXFVUTVHVVAVVBVVCWYDXXKXVLXXLXVMUHWYDXXJXVIX
        VKUKWYDXVIXXMVVDWGWYDXVMWUDWUDUHQZXVIUKQZXXLWYDWUDURRZVYSXXTWUDTXFVBZXV
        MXXSWEWYDWUDXVQYLVYSWYDWFVAZWYDWUDXVSVVIZWUDPWUDVVEYSWYDXXRPXVIUKWYDXYA
        XXRPWEXYCWUDVVFVHWGVVGYNVVHYIWIVUDWYDXVOWUEPWUFUHQZUOQZWUGSWYDXVNXYDSWM
        ZXVOXYESWMWYDXYFXVLXVMXYDUOQZSWMWYDXVLXVIXYGSWYDTXVKSWMXVLXVISWMWYDXVKX
        WHVVJWYDXVIXVKXVRXWIVVKYRWYDWUFURRWUFTXFVBXYAVYSXYGXVIWEWYDWUFXWLVVIXYC
        XYBWUFWUDPVVLYSVVMWYDXVLXYDXVMXWJWYDWUFXWKYTZXWMVVRXRWYDXVNXYDWUEXWNXYH
        XWEVVNYRWYDWUEWUFXXHWYDWUFXWKYLWYDWUFXWKYMUYOVVMVVOWTVUEVVPWVIWUCWUGWWM
        UBWWPAWULWUNWVHWVEXIWULWVIWUMTWUGSWMWUOWYDWUGWYDWUEWUFXWEXWLUYNVVJWTWWR
        VVQVVOVVPVVSVWJVWPVVTWBUYS $.

      dchrisum.b $e |- ( ph -> X e. D ) $.
      dchrisum.n1 $e |- ( ph -> X =/= .1. ) $.
      ${
        $d m F $.
        dchrisum.2 $e |- ( n = x -> A = B ) $.
        dchrisum.3 $e |- ( ph -> M e. NN ) $.
        dchrisum.4 $e |- ( ( ph /\ n e. RR+ ) -> A e. RR ) $.
        dchrisum.5 $e |- ( ( ph /\ ( n e. RR+ /\ x e. RR+ ) /\
          ( M <_ n /\ n <_ x ) ) -> B <_ A ) $.
        dchrisum.6 $e |- ( ph -> ( n e. RR+ |-> A ) ~~>r 0 ) $.
        dchrisum.7 $e |- F = ( n e. NN |-> ( ( X ` ( L ` n ) ) x. A ) ) $.
        $( Lemma for ~ dchrisum .  Lemma 9.4.1 of [Shapiro], p. 377.
           (Contributed by Mario Carneiro, 2-May-2016.) $)
        dchrisumlema $p |- ( ph -> ( ( I e. RR+ -> [_ I / n ]_ A e. RR ) /\
          ( I e. ( M [,) +oo ) -> 0 <_ [_ I / n ]_ A ) ) ) $=
          ( vi crp wcel csb cr wi cpnf cico co cc0 cle wbr wral ralrimiva nfel1
          nfcsb1v cv wceq csbeq1a eleq1d rspc syl5com wa cmpt cfl cfv caddc cuz
          c1 csn cxp eqid wb nnred elicopnf syl simprbda flcld peano2zd cn nnuz
          cli cz 1z a1i cdm nnrp ssriv fmptd fdm syl5sseqr rlimclim1 adantr 0re
          wf cc clt nngt0d simplbda ltletrd elrpd sylc recnd climconst2 syl2anc
          ssid fvex cn0 rpge0d flge0nn0 nn0p1nn uztrn2 sylan nnrpd ad2antrr weq
          fvmpts eqeltrd fvconst2g 3expia ralrimivva nfcv nfbr nfim nfral breq2
          nfv breq1 imbi12d jca cvv anbi12d breq2d ralbidv reflcl peano2re 3syl
          fllep1 eluzle adantl letrd anbi2d equtr2 equcoms csbied eqcomd breq1d
          vex rspcv syl3c 3brtr4d climle ex ) AJUKULZGJCUMZUNULZUOJLUPUQURULZUS
          UVDUTVAZUOACUNULZGUKVBZUVCUVEAUVHGUKUFVCZUVHUVEGJUKGUVDUNGJCVEZVDGVFZ
          JVGZCUVDUNGJCVHZVIVJZVKAUVFUVGAUVFVLZUSUVDUJGUKCVMZJVNVOZVRVPURZVQVOZ
          UVDVSVTZUVSUVTUVTWAUVPUVRUVPJAUVFJUNULZLJUTVAZALUNULZUVFUWBUWCVLWBALU
          EWCZLJWDWEZWFZWGWHZAUVQUSWKVAUVFAUSUVQVRWIWJVRWLULAWMWNUHAUKWIUVQWOZU
          JWIUKUJVFZWPWQAUKUNUVQXDUWIUKVGAGUKCUNUVQUFUVQWAZWRUKUNUVQWSWEWTXAXBU
          VPUVDXEULUVSWLULUWAUVDWKVAUVPUVDUVPUVCUVIUVEUVPJUWGUVPUSLJUSUNULUVPXC
          WNAUWDUVFUWEXBUWGAUSLXFVAUVFALUEXGXBAUVFUWBUWCUWFXHZXIXJZAUVIUVFUVJXB
          UVOXKZXLUWHUVDUVSUVTUVTXOUVSVQXPXMXNUVPUWJUVTULZVLZUWJUVQVOZGUWJCUMZU
          NUWPUWJUKULZUWRUNULZUWQUWRVGUWPUWJUVPUVSWIULZUWOUWJWIULUVPUVRXQULZUXA
          UVPUWBUSJUTVAUXBUWGUVPJUWMXRJXSXNUVRXTWEVRUWJUVSWIWJYAYBZYCZUWPUWSUVI
          UWTUXDAUVIUVFUWOUVJYDUVHUWTGUWJUKGUWRUNGUWJCVEVDGUJYEZCUWRUNGUWJCVHVI
          VJXKZGUWJCUKUVQUNUWKYFXNZUXFYGUWPUWJUWAVOZUVDUNUVPUVEUWOUXHUVDVGUWNUV
          TUVDUWJUNYHYBZUVPUVEUWOUWNXBYGUWPUWRUVDUWQUXHUTUWPUWSUWCJBVFZUTVAZVLZ
          DUVDUTVAZUOZBUKVBZUWCJUWJUTVAZVLZUWRUVDUTVAZUXDUWPUVCLUVLUTVAZUVLUXJU
          TVAZVLZDCUTVAZUOZBUKVBZGUKVBZUXOUVPUVCUWOUWMXBAUYEUVFUWOAUYCGBUKUKAUV
          LUKULUXJUKULVLUYAUYBUGYIYJYDUYDUXOGJUKUXNGBUKGUKYKUXLUXMGUXLGYPGDUVDU
          TGDYKGUTYKUVKYLYMYNUVMUYCUXNBUKUVMUYAUXLUYBUXMUVMUXSUWCUXTUXKUVLJLUTY
          OUVLJUXJUTYQUUAUVMCUVDDUTUVNUUBYRUUCVJXKUWPUWCUXPUVPUWCUWOUWLXBUWPJUV
          SUWJUVPUWBUWOUWGXBZUWPUWBUVRUNULUVSUNULUYFJUUDUVRUUEUUFUWPUWJUXCWCUVP
          JUVSUTVAZUWOUVPUWBUYGUWGJUUGWEXBUWOUVSUWJUTVAUVPUVSUWJUUHUUIUUJYSUXNU
          XQUXRUOBUWJUKBUJYEZUXLUXQUXMUXRUYHUXKUXPUWCUXJUWJJUTYOUUKUYHDUWRUVDUT
          UYHUWRDUYHGUWJCDYTUWJYTULUYHUJUUQWNUYHUXEVLBGYECDVGZBGUJUULUYIGBUDUUM
          WEUUNUUOUUPYRUURUUSUXGUXIUUTUVAUVBYS $.

        ${
          dchrisum.9 $e |- ( ph -> R e. RR ) $.
          dchrisum.10 $e |- ( ph -> A. u e. ( 0 ..^ N )
            ( abs ` sum_ n e. ( 0 ..^ u ) ( X ` ( L ` n ) ) ) <_ R ) $.
          $( Lemma for ~ dchrisum .  Lemma 9.4.1 of [Shapiro], p. 377.
             (Contributed by Mario Carneiro, 2-May-2016.) $)
          dchrisumlem1 $p |- ( ( ph /\ U e. NN0 ) ->
            ( abs ` sum_ n e. ( 0 ..^ U ) ( X ` ( L ` n ) ) ) <_ R ) $=
            ( vk vm vi cn0 wcel wa cc0 cfzo co cv cfv csu cabs cmo cle cdiv cfl
            cmul caddc cin c0 wceq fzodisj a1i cfz cun wbr nnnn0d adantr adantl
            cr nn0re cn nndivred nnrpd nn0ge0 divge0d syl2anc syl mpbird wb cfn
            fzosplit fzofi ad2antrr cz elfzoelz dchrzrhcl fsumsplit wi c1 oveq2
            oveq2d sumeq1d eqeq1d imbi2d weq nncnd syl6eq syl2an nnzd cc ax-1cn
            eqtrd wral cmin nn0z zaddcl fveq2 fveq2d fzoval zcnd pncan2d oveq1d
            nn0cn oveq12d cdivides syl2anr ralrimiva eqeq12d rspcv sylc cif wne
            ifnefalse eqid 3eqtrd flge0nn0 nn0mulcld lemuldiv2d fznn0 mpbir2and
            flle reflcl mul01d fzo0 sum0 oveq1 lep1d clt peano2re nngt0d lemul2
            nnred syl112anc mpbid nn0mulcl sylan nn0uz syl6eleq nn0p1nn nnmulcl
            cuz elfz5 recnd adddid mulid1d peano2zm ad3antrrr elfzelz fsumshftm
            nn0zd subidd sub32d eqtr4d 3eqtr4d dvdsmul1 breqtrrd zndvds syl3anc
            sumeq2dv cbvsumv cbs cres nnne0d syl6eqel wf1o ccnfld cress reseq1i
            czrh znf1o fvres dchrf ffvelrnda fsumf1o cphi dchrsum 3eqtr3rd 00id
            syl6req expcom a2d nn0ind impcom syldan modval nn0cnd eqtr2d zmodcl
            syl5ibr crp pncan3d rspc2va syl21anc fsumcl addid2d zmodfzo eqbrtrd
            breq1d ) AHUQURZUSZUTHVAVBZJVCZMVDZPVDZJVEZVFVDUTHOVGVBZVAVBZUYIJVE
            ZVFVDZGVHUYEUYJUYMVFUYEUYJUTOHOVIVBZVJVDZVKVBZVAVBZUYIJVEZUYQHVAVBZ
            UYIJVEZVLVBUTUYMVLVBUYMUYEUYRUYTUYIUYFJUYRUYTVMVNVOUYEUTUYQHVPVQUYE
            UYQUTHVRVBURZUYFUYRUYTVSVOUYEVUBUYQUQURZUYQHVHVTZUYEOUYPAOUQURZUYDA
            OTWAZWBUYEUYOWDURZUTUYOVHVTUYPUQURZUYEHOUYDHWDURZAHWEWCZAOWFURZUYDT
            WBZWGZUYEHOVUJUYEOVULWHZUYDUTHVHVTAHWIWCWJUYOUUAWKZUUBZUYEVUDUYPUYO
            VHVTZUYEVUGVUQVUMUYOUUFWLUYEUYPHOUYEVUGUYPWDURVUMUYOUUGWLVUJVUNUUCW
            MUYDVUBVUCVUDUSWNAUYQHUUDWCUUEUTHUYQWPWLUYFWOURUYEUTHWQVQUYEUYGUYFU
            RZUSUYGFLMOPQUARUBSAPFURZUYDVURUDWRVURUYGWSURZUYEUYGUTHWTWCXAXBUYEU
            YSUTVUAUYMVLAUYDVUHUYSUTVOZVUOVUHAVVAAUTOUNVCZVKVBZVAVBZUYIJVEZUTVO
            ZXCAUTOUTVKVBZVAVBZUYIJVEZUTVOZXCAUTOUOVCZVKVBZVAVBZUYIJVEZUTVOZXCA
            UTOVVKXDVLVBZVKVBZVAVBZUYIJVEZUTVOZXCAVVAXCUNUOUYPVVBUTVOZVVFVVJAVW
            AVVEVVIUTVWAVVDVVHUYIJVWAVVCVVGUTVAVVBUTOVKXEXFXGXHXIUNUOXJZVVFVVOA
            VWBVVEVVNUTVWBVVDVVMUYIJVWBVVCVVLUTVAVVBVVKOVKXEXFXGXHXIVVBVVPVOZVV
            FVVTAVWCVVEVVSUTVWCVVDVVRUYIJVWCVVCVVQUTVAVVBVVPOVKXEXFXGXHXIVVBUYP
            VOZVVFVVAAVWDVVEUYSUTVWDVVDUYRUYIJVWDVVCUYQUTVAVVBUYPOVKXEXFXGXHXIA
            VVIVNUYIJVEUTAVVHVNUYIJAVVHUTUTVAVBVNAVVGUTUTVAAOAOTXKUUHXFUTUUIXLX
            GUYIJUUJXLVVKUQURZAVVOVVTAVWEVVOVVTXCVVOVVTAVWEUSZVVNVVLVVQVAVBZUYI
            JVEZVLVBZUTVWHVLVBZVOVVNUTVWHVLUUKVWFVVSVWIUTVWJVWFVVMVWGUYIVVRJVVM
            VWGVMVNVOVWFUTVVLVVQVPVQVWFVVLUTVVQVRVBURZVVRVVMVWGVSVOVWFVWKVVLVVQ
            VHVTZVWFVVKVVPVHVTZVWLVWFVVKVWEVVKWDURZAVVKWEWCZUULVWFVWNVVPWDURZOW
            DURUTOUUMVTVWMVWLWNVWOVWFVWNVWPVWOVVKUUNWLVWFOAVUKVWETWBZUUQVWFOVWQ
            UUOVVKVVPOUUPUURUUSVWFVVLUTUVFVDZURVVQWSURVWKVWLWNVWFVVLUQVWRAVUEVW
            EVVLUQURVUFOVVKUUTUVAZUVBUVCVWFVVQAVUKVVPWFURVVQWFURVWETVVKUVDOVVPU
            VEXMXNVVLUTVVQUVGWKWMUTVVQVVLWPWLVVRWOURVWFUTVVQWQVQVWFUYGVVRURZUSU
            YGFLMOPQUARUBSAVUSVWEVWTUDWRVWTVUTVWFUYGUTVVQWTWCXAXBVWFVWJUTUTVLVB
            UTVWFVWHUTUTVLVWFVWHVVLVVLOVLVBZVAVBZUYIJVEZUTOVAVBZUYIJVEZUTVWFVWG
            VXBUYIJVWFVVQVXAVVLVAVWFVVQVVLOXDVKVBZVLVBVXAVWFOVVKXDVWFOVWQXKZVWF
            VVKVWOUVHXDXOURZVWFXPVQUVIVWFVXFOVVLVLVWFOVXGUVJXFXQXFXGVWFVUEVVLVV
            LVVBVLVBZVAVBZUYIJVEZUTVVBVAVBZUYIJVEZVOZUNUQXRZVXCVXEVOZVWFOVWQWAZ
            VWFVXNUNUQVWFVVBUQURZUSZVXKVXLUPVCZVVLVLVBZMVDZPVDZUPVEZVXMVXSVVLVX
            IXDXSVBZVRVBZUYIJVEVVLVVLXSVBZVYEVVLXSVBZVRVBZVYCUPVEVXKVYDVXSUYIVY
            CJUPVVLVVLVYEVWFVVLWSURZVXRVWFVVLVWSUVOZWBZVYLVXSVXIWSURZVYEWSURVWF
            VYJVVBWSURZVYMVXRVYKVVBXTZVVLVVBYAXMZVXIUVKWLVXSUYGVYFURZUSUYGFLMOP
            QUARUBSAVUSVWEVXRVYQUDUVLVYQVUTVXSUYGVVLVYEUVMWCXAUYGVYAVOUYHVYBPUY
            GVYAMYBYCUVNVXSVXJVYFUYIJVXSVYMVXJVYFVOVYPVVLVXIYDWLXGVXSVXLVYIVYCU
            PVXSVXLUTVVBXDXSVBZVRVBZVYIVXSVYNVXLVYSVOVXRVYNVWFVYOWCUTVVBYDWLVXS
            VYGUTVYHVYRVRVXSVVLVXSVVLVYLYEZUVPVXSVYHVXIVVLXSVBZXDXSVBVYRVXSVXIX
            DVVLVXSVXIVYPYEVXHVXSXPVQVYTUVQVXSWUAVVBXDXSVXSVVLVVBVYTVXRVVBXOURV
            WFVVBYHWCYFYGXQYIUVRXGUVSVXSVYDVXLVXTMVDZPVDZUPVEVXMVXSVXLVYCWUCUPV
            XSVXTVXLURZUSZVYBWUBPWUEVYBWUBVOZOVYAVXTXSVBZYJVTZWUEOVVLWUGYJVWFOV
            VLYJVTZVXRWUDAOWSURVVKWSURWUIVWEAOTXNVVKXTOVVKUVTXMWRWUEVXTVVLWUEVX
            TWUDVXTWSURZVXSVXTUTVVBWTZWCZYEVXSVVLXOURWUDVYTWBYFUWAWUEVUEVYAWSUR
            ZWUJWUFWUHWNVWFVUEVXRWUDVXQWRWUDWUJVYJWUMVXSWUKVYLVXTVVLYAYKWULVYAV
            XTMOQRSUWBUWCWMYCUWDVXLWUCUYIUPJUPJXJWUBUYHPVXTUYGMYBYCUWEXLXQYLZVX
            NVXPUNOUQVVBOVOZVXKVXCVXMVXEWUOVXJVXBUYIJWUOVXIVXAVVLVAVVBOVVLVLXEX
            FXGWUOVXLVXDUYIJVVBOUTVAXEXGYMYNYOAVXEUTVOVWEAQUWFVDZVVBPVDZUNVEZOU
            TVOWSVXDYPZUYIJVEUTVXEAWUPWUQWUSUYIUNJMWUSUWGZUYHVVBUYHPYBAWUSVXDWO
            AOUTYQWUSVXDVOAOTUWHOUTWSVXDYRWLZUTOWQUWIAVUEWUSWUPWUTUWJVUFWUPWUTO
            WUSQUWKWSUWLVBZWVBYSRWUPYSZMQUWNVDWUSSUWMWUSYSUWOWLUYGWUSURUYGWUTVD
            UYHVOAUYGWUSMUWPWCAWUPXOVVBPAWUPFLOPQUARUBWVCUDUWQUWRUWSAWURPIVOOUW
            TVDZUTYPZUTAWUPFILOPQUNUARUBUCUDWVCUXAAPIYQWVEUTVOUEPIWVDUTYRWLXQAW
            USVXDUYIJWVAXGUXBWBYTXFUXCUXDYMUXNUXEUXFUXGUXHUXIUYEVUAUYQUYQUYKVLV
            BZVAVBZUYIJVEZUYMUYEUYTWVGUYIJUYEHWVFUYQVAUYEWVFUYQHUYQXSVBZVLVBHUY
            EUYKWVIUYQVLUYEVUIOUXOURUYKWVIVOVUJVUNHOUXJWKXFUYEUYQHUYEUYQVUPUXKU
            YDHXOURAHYHWCUXPUXLXFXGUYEVUHUYKUQURZVXOUOUQXRZWVHUYMVOZVUOUYDHWSUR
            ZVUKWVJAHXTZTHOUXMYKAWVKUYDAVXOUOUQWUNYLWBVXNWVLUYQUYQVVBVLVBZVAVBZ
            UYIJVEZVXMVOUOUNUYPUYKUQUQVVKUYPVOZVXKWVQVXMWVRVXJWVPUYIJWVRVVLUYQV
            XIWVOVAVVKUYPOVKXEZWVRVVLUYQVVBVLWVSYGYIXGXHVVBUYKVOZWVQWVHVXMUYMWV
            TWVPWVGUYIJWVTWVOWVFUYQVAVVBUYKUYQVLXEXFXGWVTVXLUYLUYIJVVBUYKUTVAXE
            XGYMUXQUXRXQYIUYEUYMUYEUYLUYIJUYLWOURUYEUTUYKWQVQUYEUYGUYLURZUSUYGF
            LMOPQUARUBSAVUSUYDWWAUDWRWWAVUTUYEUYGUTUYKWTWCXAUXSUXTYTYCUYEUYKVXD
            URZUTCVCZVAVBZUYIJVEZVFVDZGVHVTZCVXDXRZUYNGVHVTZUYDWVMVUKWWBAWVNTHO
            UYAYKAWWHUYDUMWBWWGWWICUYKVXDWWCUYKVOZWWFUYNGVHWWJWWEUYMVFWWJWWDUYL
            UYIJWWCUYKUTVAXEXGYCUYCYNYOUYB $.

          ${
            dchrisumlem2.1 $e |- ( ph -> U e. RR+ ) $.
            dchrisumlem2.2 $e |- ( ph -> M <_ U ) $.
            dchrisumlem2.3 $e |- ( ph -> U <_ ( I + 1 ) ) $.
            dchrisumlem2.4 $e |- ( ph -> I e. NN ) $.
            dchrisumlem2.5 $e |- ( ph -> J e. ( ZZ>= ` I ) ) $.
            $( Lemma for ~ dchrisum .  Lemma 9.4.1 of [Shapiro], p. 377.
               (Contributed by Mario Carneiro, 2-May-2016.) $)
            dchrisumlem2 $p |- ( ph ->
            ( abs ` ( ( seq 1 ( + , F ) ` J ) - ( seq 1 ( + , F ) ` I ) ) ) <_
                ( ( 2 x. R ) x. [_ U / n ]_ A ) ) $=
              ( vi vk caddc c1 cfv cmin co cabs cfzo cv csb cmul csu c2 cle cfz
              wceq a1i wcel cuz cn peano2nnd nnuz syl6eleq syl fzofi cc elfzouz
              cfn wa adantr cz adantl cr crp cc0 wbr dchrisumlema mulcld sylan2
              wi recnd sumeq1d oveq1d nfcv nfcsb1v fveq2d csbeq1a syl2anc uztrn
              eqtr3d fsumcl syldan abscld remulcld wral ralrimiva csbeq1 eleq1d
              weq rspcv sylc rspc nnrpd mpd elfzoelz readdcld cn0 eqtrd eqbrtrd
              oveq2 jca absmuld letrd nnnn0d dchrisumlem1 lemul2ad imbi12d cvv
              breq2 cseq cin c0 fzodisj cun eluzp1p1 elfzuzb sylanbrc syl6eleqr
              fzosplit nnz dchrzrhcl nnrp cpnf cico simpld imp fsumsplit fzval3
              syl5 eluzelz 3syl nnzd 3eqtr4d elfznn simpr fveq2 oveq12d fsumser
              nfov fvmptf fzfid ssun2 syl5sseqr sselda pncan2d 2re nfel1 subcld
              peano2nn impcom syl2an mulcomd nnnn0 nn0uz elfzelz adantlr eqtr2d
              resubcld fzosump1 oveq2d sumeq2dv elfzuz uztrn2 rspccva fsumparts
              sylan abs2dif2d fsumtscopo fsumrecl eqeltrrd eluzelre wb elicopnf
              eluzle nnred mpbir2and ex peano2zd syl3anbrc sseldd simprd absidd
              ssrdv rpred eluz2 le2addd adddird breqtrrd fsumabs syl2anr 3expia
              mpdan ralrimivva nfv nfbr nfim nfral breq1 anbi12d breq2d ralbidv
              lep1d anbi2d ovex equcoms csbied eqcomd breq1d abssuble0d subge0d
              eqtr3 syl3c mpbird fsumle breqtrd 2timesd ppncand addcomd 3eqtr2d
              fsummulc1 2cn mul32d 3eqtr3d 2nn0 nn0ge0 mp1i 0re absge0d mulge0d
              ) ANVCKVDUUAZVEZMVVAVEZVFVGZVHVEMVDVCVGZNVDVCVGZVIVGZVAVJZOVEZRVE
              ZJVVHDVKZVLVGZVAVMZVHVEZVNGVLVGZJHDVKZVLVGZVOAVVDVVMVHAVDMVPVGZVV
              LVAVMZVVMVCVGZVVSVFVGVVDVVMAVVTVVBVVSVVCVFAVDNVPVGZVVLVAVMZVVTVVB
              AVDVVFVIVGZVVLVAVMVDVVEVIVGZVVLVAVMZVVMVCVGVWBVVTAVWDVVGVVLVWCVAV
              WDVVGUUBUUCVQAVDVVEVVFUUDVRAVVEVDVVFVPVGVSZVWCVWDVVGUUEZVQAVVEVDV
              TVEZVSVVFVVEVTVEZVSZVWFAVVEWAVWHAMUSWBZWCWDANMVTVEVSZVWJUTMNUUFWE
              ZVVEVDVVFUUGUUHVDVVFVVEUUJWEZVWCWIVSAVDVVFWFVRVVHVWCVSZAVVHWAVSZV
              VLWGVSZVWOVVHVWHWAVVHVDVVFWHWCUUIZAVWPWJZVVJVVKVWSVVHFLOQRSUCTUDU
              AARFVSZVWPUFWKVWPVVHWLVSAVVHUUKWMUULZVWSVVKAVWPVVKWNVSZVWPVVHWOVS
              ZAVXBVVHUUMAVXCVXBXAVVHPUUNUUOVGZVSZWPVVKVOWQXAABDEFIJKLVVHOPQRST
              UAUBUCUDUEUFUGUHUIUJUKULUMWRUUPUUTUUQZXBZWSZWTZUURAVWAVWCVVLVAAVW
              LNWLVSVWAVWCVQUTMNUVAVDNUUSUVBXCAVVSVWEVVMVCAVVRVWDVVLVAAMWLVSVVR
              VWDVQAMUSUVCZVDMUUSWEXCXDUVDAVVLVAKVDNVVHVWAVSZAVWPVVHKVEVVLVQZVV
              HNUVEZVWSVWPVWQVXLAVWPUVFVXHJVVHJVJZOVEZRVEZDVLVGVVLWAKWGJVVHXEJV
              VJVVKVLJVVJXEJVLXEJVVHDXFZUVJJVAXTZVXPVVJDVVKVLVXRVXOVVIRVXNVVHOU
              VGXGZJVVHDXHZUVHUMUVKXIZWTAVWLMVWHVSNVWHVSUTAMWAVWHUSWCWDZMNVDXJX
              IZVXKAVWPVWQVXMVXHWTUVIXKAVVLVAKVDMVVHVVRVSZAVWPVXLVVHMUVEZVYAWTV
              YBVYDAVWPVWQVYEVXHWTZUVIUVHAVVSVVMAVVRVVLVAAVDMUVLVYFXLAVVGVVLVAV
              VGWIVSAVVEVVFWFVRZAVVHVVGVSZVWOVWQAVVGVWCVVHAVWGVVGVWCVVGVWDUVMVW
              NUVNUVOZVXIXMXLZUVPXKXGAVVNVVOJVVEDVKZVLVGZVVQAVVMVYJXNZAVVOVYKAV
              NGVNWNVSAUVQVRZUNXOZAVVEWAVSZVXBVAWAXPVYKWNVSZVWKAVXBVAWAVXFXQVXB
              VYQVAVVEWAVVHVVEVQVVKVYKWNJVVHVVEDXRXSYAYBZXOZAVVOVVPVYOAHWOVSZDW
              NVSZJWOXPZVVPWNVSZUPAWUAJWOUJXQZWUAWUCJHWOJVVPWNJHDXFZUVRVXNHVQZD
              VVPWNJHDXHZXSYCYBZXOAVVNJVVFDVKZWPVVFVIVGZVXPJVMZVLVGZVYKWPVVEVIV
              GZVXPJVMZVLVGZVFVGZVHVEZVVGJVVHVDVCVGZDVKZVVKVFVGZWPWURVIVGZVXPJV
              MZVLVGZVAVMZVHVEZVCVGZVYLVYMAWUQWVEAWUPAWULWUOAWUIWUKAWUIAVVFWOVS
              ZWUIWNVSZAVVFANANVWHWAVYCWCUUIWBZYDAWVGWVHXAZVVFVXDVSZWPWUIVOWQZX
              AZABDEFIJKLVVFOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMWRZUUPYEZXBZAWUJVXP
              JWUJWIVSAWPVVFWFVRVXNWUJVSAVXNWLVSZVXPWGVSZVXNWPVVFYFAWVQWJVXNFLO
              QRSUCTUDUAAVWTWVQUFWKAWVQUVFUULZWTXLZWSZAVYKWUNAVYKVYRXBZAWUMVXPJ
              WUMWIVSAWPVVEWFVRVXNWUMVSAWVQWVRVXNWPVVEYFWVSWTXLZWSZUVSZXNZAWVDA
              VVGWVCVAVYGAVYHVWPWVCWGVSAVYHWJZVWOVWPVYIVWRWEZVWSWUTWVBVWSWUTVWS
              WUSVVKAWUBWURWOVSZWUSWNVSZVWPWUDVWPWURVVHUVTYDZWWIWUBWWJWUAWWJJWU
              RWOJWUSWNJWURDXFUVRVXNWURVQZDWUSWNJWURDXHXSYCUWAUWBZVXFUWIXBZAWVB
              WGVSZVWPAWVAVXPJWVAWIVSAWPWURWFVRVXNWVAVSAWVQWVRVXNWPWURYFWVSWTXL
              ZWKWSXMZXLZXNZYGVYSAVVNWUPWVDVFVGZVHVEWVFVOAVVMWWTVHAVVMVVGVVKWVB
              WPVVHVIVGZVXPJVMZVFVGZVLVGZVAVMWWTAVVGVVLWXDVAAVYHVWPVVLWXDVQWWHV
              WSVVLVVKVVJVLVGWXDVWSVVJVVKVXAVXGUWCVWSVVJWXCVVKVLVWSWXCWXBVVJVCV
              GZWXBVFVGVVJVWSWVBWXEWXBVFVWSVXPVVJJWPVVHVWSVVHYHWPVTVEVWPVVHYHVS
              AVVHUWDWMUWEWDVXNWPVVHVPVGVSVWSWVQWVRVXNWPVVHUWFAWVQWVRVWPWVSUWGZ
              WTVXSUWJXDVWSWXBVVJVWSWXAVXPJWXAWIVSVWSWPVVHWFVRVXNWXAVSVWSWVQWVR
              VXNWPVVHYFWXFWTXLVXAUVPUWHUWKYIXMUWLAJVBVJZDVKZVVKWUSVYKVAVBWUIVV
              EVVFWPWXGVIVGZVXPJVMZWXBWVBWUNWUKVBVAXTZWXHVVKVQWXJWXBVQJWXGVVHDX
              RZWXKWXIWXAVXPJWXGVVHWPVIYKXCYLWXGWURVQZWXHWUSVQWXJWVBVQJWXGWURDX
              RZWXMWXIWVAVXPJWXGWURWPVIYKXCYLWXGVVEVQZWXHVYKVQWXJWUNVQJWXGVVEDX
              RZWXOWXIWUMVXPJWXGVVEWPVIYKXCYLWXGVVFVQZWXHWUIVQWXJWUKVQJWXGVVFDX
              RZWXQWXIWUJVXPJWXGVVFWPVIYKXCYLVWMAWXGVVEVVFVPVGVSZWXGWAVSZWXHWGV
              SZAVYPWXGVWIVSWXTWXSVWKWXGVVEVVFUWMVDWXGVVEWAWCUWNUWBAVVKWGVSZVAW
              AXPWXTWYAAWYBVAWAVXGXQWYBWYAVAWXGWAVAVBXTVVKWXHWGJVVHWXGDXRXSUWOU
              WQXMZAWXJWGVSWXSAWXIVXPJWXIWIVSAWPWXGWFVRVXNWXIVSAWVQWVRVXNWPWXGY
              FWVSWTXLWKUWPYIXGAWUPWVDWWEWWRUWRYJAWVFWUIVYKVCVGZGVLVGZVYKWUIVFV
              GZGVLVGZVCVGZVYLVOAWUQWVEWYEWYGWWFWWSAWYDGAWUIVYKWVOVYRYGZUNXOZAW
              YFGAVVGVVKWUSVFVGZVAVMZWYFWNAWXHVVKWUSVYKVAVBWUIVVEVVFWXLWXNWXPWX
              RVWMWYCUWSZAVVGWYKVAVYGWWGVVKWUSAVYHVWPVXBWWHVXFXMZAVYHVWPWWJWWHW
              WMXMZUWIZUWTUXAZUNXOZAWUQWULVHVEZWUOVHVEZVCVGZWYEWWFAWYSWYTAWULWW
              AXNZAWUOWWDXNZYGWYJAWULWUOWWAWWDUWRAXUAWUIGVLVGZVYKGVLVGZVCVGWYEV
              OAWYSWYTXUDXUEXUBXUCAWUIGWVOUNXOAVYKGVYRUNXOAWYSWUIWUKVHVEZVLVGZX
              UDVOAWYSWUIVHVEZXUFVLVGXUGAWUIWUKWVPWVTYMAXUHWUIXUFVLAWUIWVOAWVKW
              VLAPVTVEZVXDVVFAVAXUIVXDAVVHXUIVSZVXEAXUJWJZVXEVVHWNVSZPVVHVOWQZX
              UJXULAPVVHUXBWMZXUJXUMAPVVHUXEWMZXUKPWNVSZVXEXULXUMWJUXCAXUPXUJAP
              UIUXFZWKPVVHUXDWEUXGUXHUXNZAVWJVVEXUIVSZVVFXUIVSVWMAPWLVSVVEWLVSP
              VVEVOWQXUSAPUIUVCAMVXJUXIAPHVVEXUQAHUPUXOAVVEVWKUXFUQURYNPVVEUXPU
              XJZVVEVVFPXJXIUXKAWVJWVMWVNUXLYEZUXMXDYIAXUFGWUIAWUKWVTXNZUNWVOXV
              AAVVFYHVSXUFGVOWQAVVFWVIYOABCDEFGVVFIJKLOPQRSTUAUBUCUDUEUFUGUHUIU
              JUKULUMUNUOYPUYCZYQYJAWYTVYKWUNVHVEZVLVGZXUEVOAWYTVYKVHVEZXVDVLVG
              XVEAVYKWUNWWBWWCYMAXVFVYKXVDVLAVYKVYRAVVEVXDVSZWPVYKVOWQZAXUIVXDV
              VEXURXUTUXKAVVEWOVSZVYQXAXVGXVHXAABDEFIJKLVVEOPQRSTUAUBUCUDUEUFUG
              UHUIUJUKULUMWRUXLYEZUXMXDYIAXVDGVYKAWUNWWCXNUNVYRXVJAVVEYHVSXVDGV
              OWQAVVEVWKYOABCDEFGVVEIJKLOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOYPU
              YCYQYJUXQAWUIVYKGWVPWWBAGUNXBZUXRUXSYNAWVEVVGWVCVHVEZVAVMZWYGWWSA
              VVGXVLVAVYGWWGWVCWWQXNZUWTWYRAVVGWVCVAVYGWWQUXTAXVMVVGWYKGVLVGZVA
              VMZWYGVOAVVGXVLXVOVAVYGXVNWWGWYKGWYPAGWNVSVYHUNWKZXOWWGXVLWYKWVBV
              HVEZVLVGZXVOVOWWGXVLWUTVHVEZXVRVLVGXVSWWGWUTWVBAVYHVWPWUTWGVSWWHW
              WNXMAWWOVYHWWPWKZYMWWGXVTWYKXVRVLWWGWUSVVKWYOWYNAVYHXUJWUSVVKVOWQ
              ZVYHVVHVWIVSXUSXUJAVVHVVEVVFWHXUTVVEVVHPXJUYAXUKWWIXUMVVHBVJZVOWQ
              ZWJZEVVKVOWQZXAZBWOXPZXUMVVHWURVOWQZWJZXWBXUKVWPWWIAPWAVSXUJVWPUI
              VDVVHPWAWCUWNUWQZWWKWEXUKVXCPVXNVOWQZVXNXWCVOWQZWJZEDVOWQZXAZBWOX
              PZJWOXPZXWHXUKVVHXWKYDAXWRXUJAXWPJBWOWOAVXNWOVSXWCWOVSWJXWNXWOUKU
              YBUYDZWKXWQXWHJVVHWOXWGJBWOJWOXEZXWEXWFJXWEJUYEJEVVKVOJEXEZJVOXEZ
              VXQUYFUYGUYHVXRXWPXWGBWOVXRXWNXWEXWOXWFVXRXWLXUMXWMXWDVXNVVHPVOYT
              VXNVVHXWCVOUYIUYJVXRDVVKEVOVXTUYKYRUYLYCYBXUKXUMXWIXUOXUKVVHXUNUY
              MYLXWGXWJXWBXABWURWOXWCWURVQZXWEXWJXWFXWBXXCXWDXWIXUMXWCWURVVHVOY
              TUYNXXCEWUSVVKVOXXCWUSEXXCJWURDEYSWURYSVSXXCVVHVDVCUYOVRXXCWWLWJB
              JXTZDEVQZXWCVXNWURVUBXXEJBUHUYPZWEUYQUYRUYSYRYAVUCXMZUYTXDYIWWGXV
              RGWYKWWGWVBXWAXNXVQWYPWWGWPWYKVOWQXWBXXGWWGVVKWUSWYNWYOVUAVUDAVYH
              WURYHVSXVRGVOWQWWGWURWWGVVHWWHWBYOABCDEFGWURIJKLOPQRSTUAUBUCUDUEU
              FUGUHUIUJUKULUMUNUOYPXMYQYJVUEAWYLGVLVGXVPWYGAVVGWYKGVAVYGXVKWWGW
              YKWYPXBVUKAWYLWYFGVLWYMXDXKVUFYNUXQAVNVYKVLVGZGVLVGWYDWYFVCVGZGVL
              VGVYLWYHAXXHXXIGVLAXXHVYKVYKVCVGVYKWUIVCVGZWYFVCVGXXIAVYKWWBVUGAV
              YKWUIVYKWWBWVPWWBVUHAXXJWYDWYFVCAVYKWUIWWBWVPVUIXDVUJXDAVNVYKGVNW
              GVSAVULVRWWBXVKVUMAWYDWYFGAWYDWYIXBAWYFWYQXBXVKUXRVUNUXSYNAVYKVVP
              VVOVYRWUHVYOAVNGVYNUNVNYHVSWPVNVOWQAVUOVNVUPVUQAWPXUFGWPWNVSAVURV
              RXVBUNAWUKWVTVUSXVCYNVUTAXVIPHVOWQZHXWCVOWQZWJZEVVPVOWQZXAZBWOXPZ
              XXKHVVEVOWQZWJZVYKVVPVOWQZAVVEVWKYDAVYTXWRXXPUPXWSXWQXXPJHWOXXOJB
              WOXWTXXMXXNJXXMJUYEJEVVPVOXXAXXBWUEUYFUYGUYHWUFXWPXXOBWOWUFXWNXXM
              XWOXXNWUFXWLXXKXWMXXLVXNHPVOYTVXNHXWCVOUYIUYJWUFDVVPEVOWUGUYKYRUY
              LYCYBAXXKXXQUQURYLXXOXXRXXSXABVVEWOXWCVVEVQZXXMXXRXXNXXSXXTXXLXXQ
              XXKXWCVVEHVOYTUYNXXTEVYKVVPVOXXTVYKEXXTJVVEDEYSVVEYSVSXXTMVDVCUYO
              VRXXTVXNVVEVQWJXXDXXEXWCVXNVVEVUBXXFWEUYQUYRUYSYRYAVUCYQYNYJ $.
          $}

          $( Lemma for ~ dchrisum .  Lemma 9.4.1 of [Shapiro], p. 377.
             (Contributed by Mario Carneiro, 2-May-2016.) $)
          dchrisumlem3 $p |- ( ph -> E. t E. c e. ( 0 [,) +oo )
          ( seq 1 ( + , F ) ~~> t /\ A. x e. ( M [,) +oo ) ( abs `
            ( ( seq 1 ( + , F ) ` ( |_ ` x ) ) - t ) ) <_ ( c x. B ) ) ) $=
            ( ve vj vk vi vm caddc c1 cv cli wbr wex cfl cfv cmin cabs cmul cle
            co cpnf cico wral wa cc0 wrex wcel cvv cn nnuz cc 1z a1i wceq simpr
            csb adantr cr crp ralrimiva nfcsb1v nfel1 csbeq1a eleq1d rspc recnd
            weq nfcv nfov fveq2 fveq2d syl2anc eqeltrd clt cuz c2 wi 2re csu c0
            cfzo syl6eq breq1d sylc cmpt 0re sylan ltletrd elrpd adantlr oveq1d
            syl ad2antrr sylancom wb elicopnf syl3an1 mpd eqtrd remulcld lelttr
            syl3anc mpand ffvelrnd subcld oveq2d eqid nnex cseq cdm nnzd impcom
            cz dchrzrhcl nnrp syl2an mulcld oveq12d serf ffvelrnda cdiv remulcl
            fvmptf id sylancr lbfzo0 oveq2 fzo0 sumeq1d sum0 abs00bd rspcv 2nn0
            sylibr nn0ge0i mulge0 mpanl12 ge0p1rpd rpdivcl crli rlimi cif nnred
            syl2anr ifcl nngt0d max1 nfv nffv nfbr nfim breq2 imbi12d mpbir2and
            max2 wne r19.21bi simpll dchrisumlema simprd absidd rpre ltmuldiv2d
            subid1d ad2antlr bitr4d rpred lep1d sylbid 1re nnge1d letrd flge1nn
            lemul1ad 3adant1r fllep1 dchrisumlem2 wf ad3antrrr uztrn2 ralrimdva
            adantllr abscld raleqbidv rspcev ee12an syld rexlimdva seqex caucvg
            embantd eldm sylib elrege0 sylanbrc csn cxp cxr wss icossre sylancl
            pnfxr sselda flcld simplr simplbda mptex fvmpt3i climsubc2 fvconst2
            ovex eqtr4d climabs mpan9 syldan eqimss2i climconst2 simplll reflcl
            fvex peano2re 3syl flltp1 ltled abssubd 3brtr4d climle oveq1 breq2d
            ralbidv vex equequ2 biimpa csbied breq12d cbvralv syl6bbr ex eximdv
            r19.42v ) AUTKVAUUAZDVBZVCVDZDVEZVVOBVBZVFVGZVVMVGZVVNVHVLZVIVGZRVB
            ZFVJVLZVKVDZBNVMVNVLZVOZVPRVQVMVNVLZVRZDVEAVVMVCUUBVSVVPAUOUPUQVVMV
            AVTWAWBAWAWCUQVBZVVMAURKVAWAWBVAUUEVSZAWDWEAURVBZWAVSZVPZVWKKVGZVWK
            MVGZPVGZJVWKEWHZVJVLZWCVWMVWLVWRWCVSVWNVWRWFAVWLWGZVWMVWPVWQVWMVWKG
            LMOPQUBSUCTAPGVSZVWLUEWIVWMVWKVWSUUCUUFVWMVWQAEWJVSZJWKVOZVWKWKVSZV
            WQWJVSZVWLAVXAJWKUIWLZVWKUUGVXCVXBVXDVXAVXDJVWKWKJVWQWJJVWKEWMZWNJU
            RWSZEVWQWJJVWKEWOZWPWQUUDUUHWRUUIZJVWKJVBZMVGZPVGZEVJVLVWRWAKWCJVWK
            WTJVWPVWQVJJVWPWTJVJWTVXFXAVXGVXLVWPEVWQVJVXGVXKVWOPVXJVWKMXBXCVXHU
            UJULUUOXDVXIXEUUKZUULAVWIVVMVGZUPVBZVVMVGZVHVLZVIVGZUOVBZXFVDZUQVXO
            XGVGZVOZUPWAVRZUOWKAVXSWKVSZVPZUSVBZVXJVKVDZEVQVHVLZVIVGZVXSXHHVJVL
            ZVAUTVLZUUMVLZXFVDZXIZJWKVOZUSWJVRVYCVYEUSJWKEVQVYLWCAEWCVSZJWKVOVY
            DAVYPJWKAVXJWKVSZVPEUIWRWLWIVYDVYDVYKWKVSZVYLWKVSAVYDUUPAVYJAXHWJVS
            ZHWJVSZVYJWJVSZXJUMXHHUUNUUQZAVYTVQHVKVDZVQVYJVKVDZUMAVQVQOXMVLZVSZ
            VQCVBZXMVLZVXLJXKZVIVGZHVKVDZCWUEVOZWUCAOWAVSZWUFUAOUURUVFUNWUKWUCC
            VQWUEWUGVQWFZWUJVQHVKWUNWUIWUNWUIXLVXLJXKVQWUNWUHXLVXLJWUNWUHVQVQXM
            VLXLWUGVQVQXMUUSVQUUTXNUVAVXLJUVBXNUVCXOUVDXPVYSVQXHVKVDVYTWUCVPWUD
            XJXHUVEUVGXHHUVHUVIXDZUVJZVXSVYKUVKUVPAJWKEXQVQUVLVDZVYDUKWIUVMVYEV
            YOVYCUSWJVYEVYFWJVSZVPZVYOVYFNVYFVKVDZVYFNUVNZVKVDZJWVAEWHZVQVHVLZV
            IVGZVYLXFVDZXIZVYCWUSWVAWKVSZVYOWVGXIAWURWVHVYDAWURVPZWVAWVIWURNWJV
            SZWVAWJVSZAWURWGAWVJWURANUHUVOZWIZWUTVYFNWJUVQXDZWVIVQNWVAVQWJVSZWV
            IXRWEWVMWVNAVQNXFVDZWURANUHUVRZWIAWVJWURNWVAVKVDZWVLNVYFUVSZXSZXTYA
            ZYBZVYNWVGJWVAWKWVBWVFJWVBJUVTJWVEVYLXFJWVDVIJVIWTJWVCVQVHJWVAEWMZJ
            VHWTJVQWTXAUWAJXFWTJVYLWTUWBUWCVXJWVAWFZVYGWVBVYMWVFVXJWVAVYFVKUWDW
            WDVYIWVEVYLXFWWDVYHWVDVIWWDEWVCVQVHJWVAEWOZYCXCXOUWEWQYDWUSWVBWVFVY
            CVYEWURWVJWVBAWVJVYDWURWVLYEZNVYFUWGYFWUSWVFVYJWVCVJVLZVXSXFVDZVYCW
            USWVFVYKWVCVJVLZVXSXFVDZWWHWUSWVFWVCVYLXFVDWWJWUSWVEWVCVYLXFWUSWVEW
            VCVIVGWVCWUSWVDWVCVIWUSWVCWUSWVCWUSWVHVXBWVCWJVSZWWBAVXBVYDWURVXEYE
            ZVXAWWKJWVAWKJWVCWJWWCWNWWDEWVCWJWWEWPWQXPZWRUWPXCWUSWVCWWMWUSWVAVW
            EVSZVQWVCVKVDZWUSWWNWVKWVRAWURWVKVYDWVNYBVYEWURWVJWVRWWFWVSYFWUSWVJ
            WWNWVKWVRVPYGWWFNWVAYHYDUWFWUSWVHWWKXIWWNWWOXIWUSBEFGIJKLWVAMNOPQST
            AWUMVYDWURUAYEUBUCUDAVWTVYDWURUEYEAPIUWHZVYDWURUFYEUGANWAVSZVYDWURU
            HYEWUSVXAJWKWWLUWIWUSAVYQVVQWKVSVPZNVXJVKVDVXJVVQVKVDVPZFEVKVDZAVYD
            WURUWJUJYIAWUQVYDWURUKYEULUWKUWLYJZUWMYKXOWUSWVCVXSVYKWWMVYDVXSWJVS
            ZAWURVXSUWNUWQZAVYRVYDWURWUPYEZUWOUWRWUSWWGWWIVKVDZWWJWWHWUSVYJVYKW
            VCAWUAVYDWURWUBYEZWUSVYKWXDUWSZWWMWXAWUSVYJWXFUWTUXFWUSWWGWJVSZWWIW
            JVSWXBWXEWWJVPWWHXIWUSVYJWVCWXFWWMYLZWUSVYKWVCWXGWWMYLWXCWWGWWIVXSY
            MYNYOUXAWUSWVAVFVGZWAVSZWWHVXNWXJVVMVGZVHVLZVIVGZVXSXFVDZUQWXJXGVGZ
            VOZVYCAWURWXKVYDWVIWVKVAWVAVKVDWXKWVNWVIVANWVAVAWJVSZWVIUXBWEWVMWVN
            WVINAWWQWURUHWIUXCWVTUXDWVAUXEXDZYBZWUSWWHWXOUQWXPWUSVWIWXPVSZVPZWX
            NWWGVKVDZWWHWXOAWURWYAWYCVYDWVIWYAVPZBCEFGHWVAIJKLWXJVWIMNOPQSTAWUM
            WURWYAUAYEUBUCUDAVWTWURWYAUEYEAWWPWURWYAUFYEUGAWWQWURWYAUHYEWVIVYQV
            XAWYAAVYQVXAWURUIYBYBWVIWWRWWSWWTWYAAWWRWWSWWTWURUJUXGUXGAWUQWURWYA
            UKYEULAVYTWURWYAUMYEAWULWURWYAUNYEWVIWVHWYAWWAWIWVIWVRWYAWVTWIWYDWV
            KWVAWXJVAUTVLVKVDWVIWVKWYAWVNWIWVAUXHYDWVIWXKWYAWXSWIWVIWYAWGUXIUXN
            WYBWXNWJVSWXHWXBWYCWWHVPWXOXIWYBWXMWYBVXNWXLWYBWAWCVWIVVMAWAWCVVMUX
            JZVYDWURWYAVXMUXKZWUSWXKWYAVWIWAVSWXTVAVWIWXJWAWBUXLXSYPWYBWAWCWXJV
            VMWYFWUSWXKWYAWXTWIYPYQUXOWUSWXHWYAWXIWIWUSWXBWYAWXCWIWXNWWGVXSYMYN
            YOUXMVYBWXQUPWXJWAVXOWXJWFZVXTWXOUQVYAWXPVXOWXJXGXBWYGVXRWXNVXSXFWY
            GVXQWXMVIWYGVXPWXLVXNVHVXOWXJVVMXBYRXCXOUXPUXQUXRUXSUYCUXSUXTYJWLVV
            MVTVSAUTKVAUYAZWEUYBDVVMVCWYHUYDUYEAVVOVWHDAVVOVWHAVVOVPZVVOVWFRVWG
            VRZVWHAVVOWGWYIVYJVWGVSZVYFVFVGZVVMVGZVVNVHVLZVIVGZVYJJVYFEWHZVJVLZ
            VKVDZUSVWEVOZWYJAWYKVVOAWUAWUDWYKWUBWUOVYJUYFUYGWIWYIWYRUSVWEWYIVYF
            VWEVSZVPZWYOWYQURUQWAWYMVXNVHVLZVIVGZXQZWAWYQUYHUYIZWYLWYLXGVGZXUFY
            SZXUAVYFAWYTWURVVOAVWEWJVYFAWVJVMUYJVSVWEWJUYKWVLUYNNVMUYLUYMUYOZYB
            ZUYPZXUAWYNURUQWAXUBXQZXUDWYLVTXUFXUGXUAVVNWYMURVVMXUKWYLVTXUFXUGXU
            JAVVOWYTUYQXUAWAWCWYLVVMAWYEVVOWYTVXMYEZXUAWURVAVYFVKVDWYLWAVSZXUIX
            UAVANVYFWXRXUAUXBWEAWVJVVOWYTWVLYEXUIXUANAWWQVVOWYTUHYEZUXCAWYTWUTV
            VOAWYTWURWUTAWVJWYTWURWUTVPYGWVLNVYFYHYDUYRZYBZUXDVYFUXEXDZYPZXUKVT
            VSXUAUQWAXUBYTUYSWEXUAVWKXUFVSZVPZWAWCVWKVVMXUAWYEXUSXULWIXUAXUMXUS
            VWLXUQVAVWKWYLWAWBUXLXSZYPZXUTVWLVWKXUKVGZWYMVWKVVMVGZVHVLZWFXVAUQV
            WKXUBXVEWAXUKUQURWSZVXNXVDWYMVHVWIVWKVVMXBYRZXUKYSWYMVXNVHVUCUYTYDZ
            VUAXUDVTVSXUAUQWAXUCYTUYSWEXUJXUTXVCVWKWAWYMUYHUYIVGZXVDVHVLZWCXUTX
            VCXVEXVJXVHXUTXVIWYMXVDVHXUTVWLXVIWYMWFXVAWAWYMVWKWYLVVMVULVUBYDZYC
            VUDXUTXVIXVDXUTXVIWYMWCXVKXUAWYMWCVSXUSXURWIZXEXVBYQXEXUTVWKXUDVGZX
            VEVIVGZXVCVIVGXUTVWLXVMXVNWFXVAUQVWKXUCXVNWAXUDXVFXUBXVEVIXVGXCXUDY
            SXUBVIVULUYTYDZXUTXVCXVEVIXVHXCVUDVUEXUAWYQWCVSVWJXUEWYQVCVDXUAWYQX
            UAVYJWYPAWUAVVOWYTWUBYEAWYTWYPWJVSZVVOAWYTVYFWKVSZXVPAWYTVPZVYFXUHX
            VRVQNVYFWVOXVRXRWEAWVJWYTWVLWIXUHAWVPWYTWVQWIXUOXTYAZAVXBXVQXVPVXEV
            XAXVPJVYFWKJWYPWJJVYFEWMWNJUSWSZEWYPWJJVYFEWOWPWQVUFVUGYBYLZWRWDWYQ
            VAWAWAVAXGVGWBVUHYTVUIUYMXUTXVMXVNWJXVOXUTXVEXUTWYMXVDXVLXVBYQUXOXE
            XUTVWKXUEVGZWYQWJXUTVWLXWBWYQWFXVAWAWYQVWKVYJWYPVJVUCVUBYDZXUAWYQWJ
            VSXUSXWAWIXEXUTXVDWYMVHVLVIVGZWYQXVMXWBVKXUTBCEFGHVYFIJKLWYLVWKMNOP
            QSTXUTAWUMAVVOWYTXUSVUJZUAYDUBUCUDXUTAVWTXWEUEYDXUTAWWPXWEUFYDUGXUA
            WWQXUSXUNWIXUTAVYQVXAXWEUIXSXUTAWWRWWSWWTXWEUJYIXUTAWUQXWEUKYDULXUT
            AVYTXWEUMYDXUTAWULXWEUNYDXUAXVQXUSAWYTXVQVVOXVSYBWIXUAWUTXUSXUPWIXU
            TVYFWYLVAUTVLZXUAWURXUSXUIWIZXUTWURWYLWJVSXWFWJVSXWGVYFVUKWYLVUMVUN
            XUTWURVYFXWFXFVDXWGVYFVUOYDVUPXUAXUMXUSXUQWIXUAXUSWGUXIXUTXVMXVNXWD
            XVOXUTWYMXVDXVLXVBVUQYKXWCVURVUSWLVWFWYSRVYJVWGVWBVYJWFZVWFVWAVYJFV
            JVLZVKVDZBVWEVOWYSXWHVWDXWJBVWEXWHVWCXWIVWAVKVWBVYJFVJVUTVVAVVBWYRX
            WJUSBVWEUSBWSZWYOVWAWYQXWIVKXWKWYNVVTVIXWKWYMVVSVVNVHXWKWYLVVRVVMVY
            FVVQVFXBXCYCXCXWKWYPFVYJVJXWKJVYFEFVTVYFVTVSXWKUSVVCWEXWKXVTVPJBWSZ
            EFWFXWKXVTXWLUSBJVVDVVEUGYDVVFYRVVGVVHVVIUXQXDVVOVWFRVWGVVLUYGVVJVV
            KYJ $.
        $}

        $( If ` n e. [ M , +oo ) |-> A ( n ) ` is a positive decreasing
           function approaching zero, then the infinite sum
           ` sum_ n , X ( n ) A ( n ) ` is convergent, with the partial sum
           ` sum_ n <_ x , X ( n ) A ( n ) ` within ` O ( A ( M ) ) ` of the
           limit ` T ` .  Lemma 9.4.1 of [Shapiro], p. 377.  (Contributed by
           Mario Carneiro, 2-May-2016.) $)
        dchrisum $p |- ( ph -> E. t E. c e. ( 0 [,) +oo )
          ( seq 1 ( + , F ) ~~> t /\ A. x e. ( M [,) +oo ) ( abs `
            ( ( seq 1 ( + , F ) ` ( |_ ` x ) ) - t ) ) <_ ( c x. B ) ) ) $=
          ( vu vm vr vi cc0 cv cfzo co cfv csu cabs cle wbr wral caddc cseq cli
          c1 cfl cmin cmul cpnf cico wa wrex wex cr cfn wcel fzofi a1i elfzoelz
          adantr cz adantl dchrzrhcl fsumcl abscld ralrimivw sylancr cn wne crp
          fimaxre3 adantlr 3adant1r cmpt simprl simprr weq fveq2 fveq2d cbvsumv
          crli oveq2 sumeq1d syl5eq breq1d cbvralv sylib dchrisumlem3 rexlimddv
          ) AUOUKUPZUQURZULUPZKUSZNUSZULUTZVAUSZUMUPZVBVCZUKUOMUQURZVDZVEIVHVFZ
          CUPZVGVCBUPZVIUSYDUSYEVJURVAUSPUPEVKURVBVCBLVLVMURVDVNPUOVLVMURVOCVPU
          MVQAYBVRVSXSVQVSZUKYBVDYCUMVQVOUOMVTAYGUKYBAXRAXNXQULXNVRVSAUOXMVTWAA
          XOXNVSZVNXOFJKMNOTQUARANFVSZYHUCWCYHXOWDVSAXOUOXMWBWEWFWGWHWIUMUKYBXS
          WNWJAXTVQVSZYCVNZVNZBUNCDEFXTGHIJKLMNOPQRAMWKVSYKSWCTUAUBAYIYKUCWCANG
          WLYKUDWCUEALWKVSYKUFWCAHUPZWMVSZDVQVSYKUGWOAYNYFWMVSVNLYMVBVCYMYFVBVC
          VNEDVBVCYKUHWPAHWMDWQUOXDVCYKUIWCUJAYJYCWRYLYCUOUNUPZUQURZYMKUSZNUSZH
          UTZVAUSZXTVBVCZUNYBVDAYJYCWSYAUUAUKUNYBUKUNWTZXSYTXTVBUUBXRYSVAUUBXRX
          NYRHUTYSXNXQYRULHULHWTXPYQNXOYMKXAXBXCUUBXNYPYRHXMYOUOUQXEXFXGXBXHXIX
          JXKXL $.
      $}

      ${
        $d m F $.
        dchrisumn0.f $e |- F = ( a e. NN |-> ( ( X ` ( L ` a ) ) / a ) ) $.
        $( Lemma for ~ dchrmusum and ~ dchrisumn0 .  Apply ~ dchrisum for the
           function ` 1 / y ` .  (Contributed by Mario Carneiro,
           4-May-2016.) $)
        dchrmusumlema $p |- ( ph -> E. t E. c e. ( 0 [,) +oo )
     ( seq 1 ( + , F ) ~~> t /\ A. y e. ( 1 [,) +oo ) ( abs `
        ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - t ) ) <_ ( c / y ) ) ) $=
          ( vx vn caddc c1 cseq cv cli wbr cfl cfv cmin cabs cdiv cle cpnf cico
          co wral wa cc0 wrex wex cn cmul cmpt oveq2 1nn a1i crp rpreccl adantl
          wcel rpred w3a simp3r wb clt rpregt0 lerec syl2an 3ad2ant2 mpbid crli
          cr ax-1cn divrcnv mp1i weq fveq2 fveq2d oveq12d cbvmptv dchrisum wceq
          cc adantr cz nnz dchrzrhcl nncn nnne0 divrecd mpteq2dva eqtri 3eqtr4g
          wne id seqeq3d breq1d oveq1d breq12d cbvralv ad2antrr elrege0 simplbi
          fveq1d recnd ad2antlr 1re elicopnf ax-mp 0lt1 simprbi ltletrd gt0ne0d
          0re ralbidva syl5bb anbi12d rexbidva exbidv mpbird ) AUEFUFUGZCUHZUIU
          JZBUHZUKULZYOULZYPUMUSZUNULZMUHZYRUOUSZUPUJZBUFUQURUSZUTZVAZMVBUQURUS
          ZVCZCVDUELVELUHZHULZJULZUFUUKUOUSZVFUSZVGZUFUGZYPUIUJZUCUHZUKULZUUQUL
          ZYPUMUSZUNULZUUCUFUUSUOUSZVFUSZUPUJZUCUUFUTZVAZMUUIVCZCVDAUCCUFUDUHZU
          OUSZUVDDEUDUUPGHUFIJKMNOPQRSTUAUVJUUSUFUOVHUFVEVNAVIVJAUVJVKVNZVAUVKU
          VLUVKVKVNAUVJVLVMVOAUVLUUSVKVNZVAZUFUVJUPUJZUVJUUSUPUJZVAZVPUVPUVDUVK
          UPUJZAUVNUVOUVPVQUVNAUVPUVRVRZUVQUVLUVJWFVNVBUVJVSUJVAUUSWFVNZVBUUSVS
          UJVAUVSUVMUVJVTUUSVTUVJUUSWAWBWCWDUFWQVNUDVKUVKVGVBWEUJAWGUFUDWHWILUD
          VEUUOUVJHULZJULZUVKVFUSZLUDWJZUUMUWBUUNUVKVFUWDUULUWAJUUKUVJHWKWLZUUK
          UVJUFUOVHWMWNZWOAUUJUVICAUUHUVHMUUIAUUCUUIVNZVAZYQUURUUGUVGUWHYOUUQYP
          UIUWHFUUPUEUFAFUUPWPUWGAUDVEUWBUVJUOUSZVGZUDVEUWCVGFUUPAUDVEUWIUWCAUV
          JVEVNZVAZUWBUVJUWLUVJDGHIJKQNROAJDVNUWKTWRUWKUVJWSVNAUVJWTVMXAUWKUVJW
          QVNAUVJXBVMUWKUVJVBXHAUVJXCVMXDXEFLVEUUMUUKUOUSZVGUWJUBLUDVEUWMUWIUWD
          UUMUWBUUKUVJUOUWEUWDXIWMWNXFUWFXGZWRXJXKUUGUUTYOULZYPUMUSZUNULZUUCUUS
          UOUSZUPUJZUCUUFUTUWHUVGUUEUWSBUCUUFBUCWJZUUBUWQUUDUWRUPUWTUUAUWPUNUWT
          YTUWOYPUMUWTYSUUTYOYRUUSUKWKWLXLWLYRUUSUUCUOVHXMXNUWHUWSUVFUCUUFUWHUU
          SUUFVNZVAZUWQUVCUWRUVEUPAUWQUVCWPUWGUXAAUWPUVBUNAUWOUVAYPUMAUUTYOUUQA
          FUUPUEUFUWNXJXRXLWLXOUXBUUCUUSUWGUUCWQVNAUXAUWGUUCUWGUUCWFVNVBUUCUPUJ
          UUCXPXQXSXTUXBUUSUXAUVTUWHUXAUVTUFUUSUPUJZUFWFVNZUXAUVTUXCVAVRYAUFUUS
          YBYCZXQVMZXSUXBUUSUXBVBUFUUSVBWFVNUXBYHVJUXDUXBYAVJUXFVBUFVSUJUXBYDVJ
          UXAUXCUWHUXAUVTUXCUXEYEVMYFYGXDXMYIYJYKYLYMYN $.

        dchrisumn0.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
        dchrisumn0.t $e |- ( ph -> seq 1 ( + , F ) ~~> T ) $.
        dchrisumn0.1 $e |- ( ph -> A. y e. ( 1 [,) +oo )
          ( abs ` ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - T ) ) <_
            ( C / y ) ) $.
        $( The sum of the M&ouml;bius function multiplied by a non-principal
           Dirichlet character, divided by ` n ` , is bounded, provided that
           ` T =/= 0 ` .  Lemma 9.4.2 of [Shapiro], p. 380.  (Contributed by
           Mario Carneiro, 4-May-2016.) $)
        dchrmusum2 $p |- ( ph ->
          ( x e. RR+ |-> ( sum_ d e. ( 1 ... ( |_ ` x ) )
            ( ( X ` ( L ` d ) ) x. ( ( mmu ` d ) / d ) ) x. T ) ) e. O(1) ) $=
          ( vm vn crp c1 cmpt co1 wcel cv cfl cfv cfz co cmu cdiv csu cr wss cc
          cmul rpssre ax-1cn o1const mp2an a1i wa fzfid ad2antrr elfzelz adantl
          cz dchrzrhcl elfznn mucl zred nndivre mpancom syl recnd mulcld fsumcl
          caddc cseq cli wbr climcl adantr cmin 1re cc0 cpnf cico cabs adantlrr
          cn cle wf nnuz divcld wceq fveq2 fveq2d id oveq12d rpred syl2an nncnd
          wne mulid2d eqbrtrd mpbid flge1nn syl2anc sumeq2dv oveq1d nnne0d zcnd
          oveq2d 3eqtr2d syl6eleq abscld remulcld rerpdivcld absge0d cn0 nnnn0d
          wb eqtrd lemul12ad absmuld 3brtr4d syl3anc breqtrd letrd subcl simpld
          sylancr elrege0 sylib 1z nnz nncn nnne0 cbvmptv eqtri fmptd ffvelrnda
          serf simprl fznnfl simplbda nnrpd lemuldivd ffvelrnd fsumsub cdivides
          subdid ad3antrrr ad2antlr dchrzrhmul divmuldivd eqtr4d mulassd div12d
          crab simpll fsummulc2 ovex fvmpt cuz fsumser 3eqtr2rd elrabi ad2antll
          ssriv sselda adantrr dvdsflsumcom simprr musumsum div1i syl6eq eqtr2d
          eluzfz1 dchrzrh1 3eqtr4rd subcld fsumrecl fsumabs reflcl nnrecred cbs
          fsummulc1 eqid wfo znzrhfo fof 3syl ffvelrn dchrabs2 absdivd rprege0d
          absid mule1 lediv1dd wral elicopnf ax-mp sylanbrc oveq2 breq12d rspcv
          eqcomd sylc rpcnne0 ad2antrl syl112anc div23 divcan4d divrec2d eqtr3d
          divdiv2 fsumle chash hashfz1 cfn divass 3eqtr4d flle lemul1a syl31anc
          fsumconst ledivmuld mpbird elo1d o1dif ) ABUJUKULUMUNZBUJUKBUOZUPUQZU
          RUSZOUOZJUQZLUQZVUGUTUQZVUGVAUSZVFUSZOVBZFVFUSZULUMUNVUCAUJVCVDZUKVEU
          NZVUCVGVHBUJUKVIVJVKABUJUKVUNVUPAVUDUJUNZVLZVHVKVURVUMFVURVUFVULOVURU
          KVUEVMVURVUGVUFUNZVLZVUIVUKVUTVUGEIJKLMSPTQALEUNZVUQVUSUBVNVUSVUGVQUN
          ZVURVUGUKVUEVOZVPVRZVUTVUKVUTVUGXAUNZVUKVCUNZVUSVVEVURVUGVUEVSZVPVUJV
          CUNVVEVVFVVEVUJVUGVTZWAVUJVUGWBWCWDWEZWFZWGAFVEUNZVUQAWHHUKWIZFWJWKVV
          KUFFVVLWLWDZWMWFZABUJUKVUNWNUSZUKDVUOAVGVKVURVUPVUNVEUNVVOVEUNVHVVNUK
          VUNUUAUUCUKVCUNZAWOVKADVCUNZWPDXBWKZADWPWQWRUSUNVVQVVRVLZUEDUUDUUEZUU
          BZAVUQUKVUDXBWKZVLZVLZVVOWSUQVUFVULVUDVUGVAUSZUPUQZVVLUQZFWNUSZVFUSZO
          VBZWSUQZDXBVWDVVOVWJWSVWDVUFVULVWGVFUSZVULFVFUSZWNUSZOVBVUFVWLOVBZVUF
          VWMOVBZWNUSVWJVVOVWDVUFVWLVWMOVWDUKVUEVMZVWDVUSVLZVULVWGAVUQVUSVULVEU
          NVWBVVJWTZVWRXAVEVWFVVLAXAVEVVLXCVWCVUSAUHHUKXAXDUKVQUNAUUFVKAXAVEUHU
          OZHAUHXAVWTJUQZLUQZVWTVAUSZVEHAVWTXAUNZVLZVXBVWTVXEVWTEIJKLMSPTQAVVAV
          XDUBWMVXDVWTVQUNZAVWTUUGVPVRVXDVWTVEUNAVWTUUHVPVXDVWTWPXNAVWTUUIVPXEZ
          HNXANUOZJUQZLUQZVXHVAUSZULUHXAVXCULUDNUHXAVXKVXCVXHVWTXFZVXJVXBVXHVWT
          VAVXLVXIVXALVXHVWTJXGXHVXLXIXJZUUJUUKUULUUMUUNVNVWRVWEVCUNZUKVWEXBWKZ
          VWFXAUNVWDVUDVCUNZVVEVXNVUSVWDVUDAVUQVWBUUOZXKZVVGVUDVUGWBXLZVWRUKVUG
          VFUSZVUDXBWKVXOVWRVXTVUGVUDXBVWRVUGVWRVUGVUSVVEVWDVVGVPZXMZXOVWDVUSVV
          EVUGVUDXBWKZVWDVXPVUSVVEVYCVLYMVXRVUGVUDUUPWDUUQXPVWRUKVUDVUGVVPVWRWO
          VKZVWDVXPVUSVXRWMVWRVUGVYAUURZUUSXQZVWEXRXSZUUTZWFVWRVULFVWSAVVKVWCVU
          SVVMVNZWFUVAVWDVUFVWIVWNOVWRVULVWGFVWSVYHVYIUVCXTVWDUKVWOVUNVWPWNVWDV
          WOUKJUQZLUQZUKVAUSZUKVWDVWOVUFUKVWFURUSZVUJVUGVWTVFUSZJUQZLUQZVYNVAUS
          ZVFUSZUHVBZOVBVUFCUOZUIUOZUVBWKZCXAUVKZVUJWUAJUQZLUQZWUAVAUSZVFUSZOVB
          UIVBVYLVWDVUFVWLVYSOVWRVYSVYMVULVXCVFUSZUHVBVULVYMVXCUHVBZVFUSVWLVWRV
          YMVYRWUHUHVWRVWTVYMUNZVLZVYRVUJVUIVUGVAUSZVXCVFUSZVFUSVUJWULVFUSZVXCV
          FUSWUHWUKVYQWUMVUJVFWUKVYQVUIVXBVFUSZVYNVAUSWUMWUKVYPWUOVYNVAWUKVUGVW
          TEIJKLMSPTQAVVAVWCVUSWUJUBUVDZVUSVVBVWDWUJVVCUVEWUJVXFVWRVWTUKVWFVOVP
          ZUVFYAWUKVUIVUGVXBVWTVWRVUIVEUNZWUJAVUQVUSWURVWBVVDWTZWMZVWRVUGVEUNZW
          UJVYBWMZWUKVWTEIJKLMSPTQWUPWUQVRZWUKVWTWUJVXDVWRVWTVWFVSZVPZXMZVWRVUG
          WPXNZWUJVWRVUGVYAYBZWMZWUKVWTWVEYBZUVGUVHYDWUKVUJWULVXCVWRVUJVEUNWUJV
          WRVUJVWRVVEVUJVQUNZVYAVVHWDYCZWMZWUKVUIVUGWUTWVBWVIXEWUKVXBVWTWVCWVFW
          VJXEUVIWUKWUNVULVXCVFWUKVUJVUIVUGWVMWUTWVBWVIUVJYAYEXTVWRVYMVXCVULUHV
          WRUKVWFVMVWSVWRAVXDVXCVEUNWUJAVWCVUSUVLWVDVXGXLZUVMVWRWUIVWGVULVFVWRV
          XCUHHUKVWFWUKVXDVWTHUQVXCXFWVENVWTVXKVXCXAHVXMUDVXBVWTVAUVNUVOWDVWRVW
          FXAUKUVPUQZVYGXDYFWVNUVQYDUVRXTVWDCVUDWUGVYRUHUIOWUAVYNXFZWUFVYQVUJVF
          WVPWUEVYPWUAVYNVAWVPWUDVYOLWUAVYNJXGXHWVPXIXJYDVXRVWDWUAVUFUNZVUGWUCU
          NZVLVLZVUJWUFWVSVUJWVSVVEWVKWVRVVEVWDWVQWUBCVUGXAUVSUVTVVHWDYCVWDWVQW
          UFVEUNWVRVWDWVQVLZWUEWUAWVTWUAEIJKLMSPTQAVVAVWCWVQUBVNWVQWUAVQUNVWDWU
          AUKVUEVOVPVRWVTWUAVWDVUFXAWUAVUFXAVDVWDOVUFXAVVGUWAVKZUWBZXMWVTWUAWWB
          YBXEZUWCWFUWDVWDVUFWUFVYLOUICWUAUKXFZWUEVYKWUAUKVAWWDWUDVYJLWUAUKJXGX
          HWWDXIXJVWQWWAVWDVUEWVOUNUKVUFUNVWDVUEXAWVOVWDVXPVWBVUEXAUNVXRAVUQVWB
          UWEVUDXRXSZXDYFUKVUEUWJWDWWCUWFYEVWDVYLUKUKVAUSUKVWDVYKUKUKVAAVYKUKXF
          VWCAEIJKLMSPTQUBUWKWMYAUKVHUWGUWHUWIVWDVUFVULFOVWQAVVKVWCVVMWMVWSUWSX
          JUWLXHVWDVWKVUFVWIWSUQZOVBZDVWDVWJVWDVUFVWIOVWQVWRVULVWHVWSVWRVWGFVYH
          VYIUWMZWFZWGYGVWDVUFWWFOVWQVWRVWIWWIYGZUWNZAVVQVWCVWAWMZVWDVUFVWIOVWQ
          WWIUWOVWDWWGVUEDVFUSZVUDVAUSZDWWKVWDWWMVUDVWDVUEDVWDVXPVUEVCUNZVXRVUD
          UWPWDZWWLYHZVXQYIWWLVWDWWGVUFDVUDVAUSZOVBZWWNXBVWDVUFWWFWWROVWQWWJVWD
          WWRVCUNVUSVWDDVUDWWLVXQYIZWMZVWRVULWSUQZVWHWSUQZVFUSUKVUGVAUSZWWRVUGV
          FUSZVFUSZWWFWWRXBVWRWXBWXDWXCWXEVWRVULVWSYGVWRVUGVYAUWQZVWRVWHWWHYGVW
          RWWRVUGWXAVWRVUGVYEXKYHVWRVULVWSYJVWRVWHWWHYJVWRVUIWSUQZVUKWSUQZVFUSU
          KWXDVFUSZWXBWXDXBVWRWXHUKWXIWXDVWRVUIWUSYGVYDVWRVUKAVUQVUSVUKVEUNVWBV
          VIWTZYGWXGVWRVUIWUSYJVWRVUKWXKYJVWRVUHMUWRUQZEIKLMSTPWXLUWTZAVVAVWCVU
          SUBVNVWDVQWXLJXCZVVBVUHWXLUNVUSAWXNVWCAKYKUNVQWXLJUXAWXNAKRYLWXLJKMPW
          XMQUXBVQWXLJUXCUXDWMVVCVQWXLVUGJUXEXLUXFVWRWXIVUJWSUQZVUGVAUSZWXDXBVW
          RWXIWXOVUGWSUQZVAUSWXPVWRVUJVUGWVLVYBWVHUXGVWRWXQVUGWXOVAVWRVUGVCUNWP
          VUGXBWKVLWXQVUGXFVWRVUGVYEUXHVUGUXIWDYDYNVWRWXOUKVUGVWRVUJWVLYGVYDVYE
          VWRVVEWXOUKXBWKVYAVUGUXJWDUXKXPYOVWRVUIVUKWUSWXKYPVWRWXJWXDVWRWXDVWRW
          XDWXGWEXOUXSYQVWRWXCDVWEVAUSZWXEXBVWRVWEUKWQWRUSZUNZVYTUPUQZVVLUQZFWN
          USZWSUQZDVYTVAUSZXBWKZCWXSUXLZWXCWXRXBWKZVWRVXNVXOWXTVXSVYFVVPWXTVXNV
          XOVLYMWOUKVWEUXMUXNUXOAWYGVWCVUSUGVNWYFWYHCVWEWXSVYTVWEXFZWYDWXCWYEWX
          RXBWYIWYCVWHWSWYIWYBVWGFWNWYIWYAVWFVVLVYTVWEUPXGXHYAXHVYTVWEDVAUXPUXQ
          UXRUXTVWRWXRDVUGVFUSVUDVAUSZWXEVWRDVEUNZVUDVEUNVUDWPXNVLZWVAWVGWXRWYJ
          XFVWDWYKVUSVWDDWWLWEZWMZVWDWYLVUSVUQWYLAVWBVUDUYAUYBZWMZVYBWVHDVUDVUG
          UYHUYCVWRWYKWVAWYLWYJWXEXFWYNVYBWYPDVUGVUDUYDYRYNYSYOVWRVULVWHVWSWWHY
          PVWRWXEVUGVAUSWWRWXFVWRWWRVUGVWDWWRVEUNZVUSVWDWWRWWTWEZWMZVYBWVHUYEVW
          RWXEVUGVWRWWRVUGWYSVYBWFVYBWVHUYFUYGYQUYIVWDVUFUYJUQZWWRVFUSZVUEWWRVF
          USZWWSWWNVWDWYTVUEWWRVFVWDVUEYKUNWYTVUEXFVWDVUEWWEYLVUEUYKWDYAVWDVUFU
          YLUNWYQWWSXUAXFVWQWYRVUFWWROUYRXSVWDVUEVEUNWYKWYLWWNXUBXFVWDVUEWWEXMW
          YMWYOVUEDVUDUYMYRUYNYSVWDWWNDXBWKWWMVUDDVFUSXBWKZVWDWWOVXPVVSVUEVUDXB
          WKZXUCWWPVXRAVVSVWCVVTWMVWDVXPXUDVXRVUDUYOWDVUEVUDDUYPUYQVWDWWMDVUDWW
          QWWLVXQUYSUYTYTYTXPVUAVUBXQ $.
      $}

      ${
        $d n A $.
        dchrvmasum.a $e |- ( ph -> A e. RR+ ) $.
        $( An alternative expression for a Dirichlet-weighted von Mangoldt sum
           in terms of the M&ouml;bius function.  Equation 9.4.11 of [Shapiro],
           p. 377.  (Contributed by Mario Carneiro, 3-May-2016.) $)
        dchrvmasumlem1 $p |- ( ph -> sum_ n e. ( 1 ... ( |_ ` A ) )
            ( ( X ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) =
          sum_ d e. ( 1 ... ( |_ ` A ) )
            ( ( ( X ` ( L ` d ) ) x. ( ( mmu ` d ) / d ) ) x.
            sum_ m e. ( 1 ... ( |_ ` ( A / d ) ) )
              ( ( X ` ( L ` m ) ) x. ( ( log ` m ) / m ) ) ) ) $=
          ( vx vi c1 cfl cfv cfz co cv cdivides wbr crab cmu cdiv clog cmul csu
          cn cvma wceq fveq2 fveq2d oveq2 oveq1 oveq12d rpred wcel wa cc adantr
          elfzelz adantl dchrzrhcl adantrr elrabi ad2antll mucl syl zred elfznn
          cz ad2antrl nndivred recnd rpdivcld relogcld mulcld dvdsflsumcom cmpt
          nnrpd cr wf wss vmaf a1i ax-resscn fss sylancl vmasum mpteq2dva muinv
          eqcomd fveq1d cvv sumex fvmpt2 sylan9eq breq1 elrab simprbi nndivdvds
          eqid syl2an mpbid fvex fvmpt oveq2d sumeq2dv eqtrd oveq1d fzfid sgmss
          wb cfn ssfi syl2anc nncnd zcnd anassrs nnne0d fsumdivc cc0 wne div23d
          3eqtrd fsummulc2 cle fznnfl simprbda rpcnne0d ad2antrr mul4d ad2antlr
          dchrzrhmul crp rpmulcld div23 syl3anc divmuldiv syl22anc rpcnd rpne0d
          divcan3d 3eqtr4rd eqtr4d 3eqtr4d ) AUDBUEUFZUGUHZUBUIZFUIZUJUKZUBURUL
          ZUUTHUFZJUFZLUIZUMUFZUUTUNUHZUUTUVEUNUHZUOUFZUPUHZUPUHZLUQZFUQUURUDBU
          VEUNUHUEUFZUGUHZUVEEUIZUPUHZHUFZJUFZUVFUVPUNUHZUVPUVEUNUHZUOUFZUPUHZU
          PUHZEUQZLUQUURUVDUUTUSUFZUUTUNUHZUPUHZFUQUURUVEHUFJUFZUVFUVEUNUHZUPUH
          ZUVNUVOHUFJUFZUVOUOUFZUVOUNUHZUPUHZEUQUPUHZLUQAUBBUVKUWCEFLUUTUVPUTZU
          VDUVRUVJUWBUPUWPUVCUVQJUUTUVPHVAVBUWPUVGUVSUVIUWAUPUUTUVPUVFUNVCUWPUV
          HUVTUOUUTUVPUVEUNVDVBVEVEABUAVFZAUUTUURVGZUVEUVBVGZVHVHZUVDUVJAUWRUVD
          VIVGUWSAUWRVHZUUTCGHIJKPMQNAJCVGZUWRSVJUWRUUTWAVGAUUTUDUUQVKVLVMZVNUW
          TUVGUVIUWTUVGUWTUVFUUTUWTUVFUWTUVEURVGZUVFWAVGZUWSUXDAUWRUVAUBUVEURVO
          ZVPZUVEVQZVRZVSUWRUUTURVGZAUWSUUTUUQVTZWBZWCWDUWTUVIUWTUVHUWTUUTUVEUW
          TUUTUXLWJUWTUVEUXGWJWEWFWDZWGZWGWHAUURUWGUVLFUXAUWGUVDUVBUVJLUQZUPUHU
          VLUXAUWFUXOUVDUPUXAUWFUVBUVFUVIUPUHZLUQZUUTUNUHUVBUXPUUTUNUHZLUQUXOUX
          AUWEUXQUUTUNUXAUWEUVBUVFUVHEURUWLWIZUFZUPUHZLUQZUXQAUWRUWEUUTFURUYBWI
          ZUFZUYBAUUTUSUYCAUBLUCFEUSUXSAURWKUSWLZWKVIWMURVIUSWLUYEAWNWOWPURWKVI
          USWQWRAEURUWLUUSUVOUJUKUBURULUCUIUSUFUCUQZAUVOURVGZVHUYFUWLUYGUYFUWLU
          TAUBUVOUCWSVLXBWTXAXCUWRUXJUYBXDVGUYDUYBUTUXKUVBUYALXEFURUYBXDUYCUYCX
          LXFWRXGUXAUVBUYAUXPLUXAUWSVHZUXTUVIUVFUPUYHUVHURVGZUXTUVIUTUYHUVEUUTU
          JUKZUYIUWSUYJUXAUWSUXDUYJUVAUYJUBUVEURUUSUVEUUTUJXHXIXJVLUXAUXJUXDUYJ
          UYIYCUWSUWRUXJAUXKVLZUXFUUTUVEXKXMXNEUVHUWLUVIURUXSUVOUVHUOVAUXSXLUVH
          UOXOXPVRXQXRXSXTUXAUVBUXPUUTLUXAUDUUTUGUHZYDVGUVBUYLWMZUVBYDVGUXAUDUU
          TYAUXAUXJUYMUYKUUTUBYBVRUYLUVBYEYFZUXAUUTUYKYGZUYHUVFUVIAUWRUWSUVFVIV
          GZUWTUVFUXIYHYIAUWRUWSUVIVIVGUXMYIZWGUXAUUTUYKYJZYKUXAUVBUXRUVJLUYHUV
          FUVIUUTUYHUVFUYHUXDUXEUWSUXDUXAUXFVLUXHVRYHUYQUXAUUTVIVGUWSUYOVJUXAUU
          TYLYMUWSUYRVJYNXRYOXQUXAUVBUVJUVDLUYNUXCAUWRUWSUVJVIVGUXNYIYPXSXRAUUR
          UWOUWDLAUVEUURVGZVHZUWOUVNUWJUWNUPUHZEUQUWDUYTUVNUWNUWJEUYTUDUVMYAUYT
          UWHUWIUYTUVECGHIJKPMQNAUXBUYSSVJUYSUVEWAVGZAUVEUDUUQVKZVLVMZUYTUWIUYT
          UVFUVEUYTUVFUYTUXDUXEAUYSUXDUVEBYQUKZABWKVGUYSUXDVUEVHYCUWQUVEBYRVRYS
          ZUXHVRVSZVUFWCWDZWGUYTUVOUVNVGZVHZUWKUWMVUJUVOCGHIJKPMQNAUXBUYSVUISUU
          AZVUIUVOWAVGUYTUVOUDUVMVKVLZVMZVUJUWMVUJUWLUVOVUJUVOVUJUVOVUIUYGUYTUV
          OUVMVTVLZWJZWFZVUNWCWDZWGYPUYTUVNVUAUWCEVUJVUAUWHUWKUPUHZUWIUWMUPUHZU
          PUHUWCVUJUWHUWIUWKUWMUYTUWHVIVGVUIVUDVJUYTUWIVIVGVUIVUHVJVUMVUQUUBVUJ
          UVRVURUWBVUSUPVUJUVEUVOCGHIJKPMQNVUKUYSVUBAVUIVUCUUCVULUUDVUJUVFUWLUP
          UHUVPUNUHZUVSUWLUPUHZVUSUWBVUJUYPUWLVIVGZUVPVIVGUVPYLYMVHVUTVVAUTVUJU
          VFUYTUVFWKVGVUIVUGVJWDZVUJUWLVUPWDZVUJUVPVUJUVEUVOUYTUVEUUEVGVUIUYTUV
          EVUFWJVJZVUOUUFYTUVFUWLUVPUUGUUHVUJUYPVVBUVEVIVGUVEYLYMVHUVOVIVGUVOYL
          YMVHVUSVUTUTVVCVVDVUJUVEVVEYTVUJUVOVUOYTUVFUWLUVEUVOUUIUUJVUJUWAUWLUV
          SUPVUJUVTUVOUOVUJUVOUVEVUJUVOVUNYGVUJUVEVVEUUKVUJUVEVVEUULUUMVBXQUUNV
          EUUOXRXSXRUUP $.

        dchrvmasum2.2 $e |- ( ph -> 1 <_ A ) $.
        $( Give an expression for ` log x ` remarkably similar to
           ` sum_ n <_ x ( X ( n ) Lam ( n ) / n ) ` given in
           ~ dchrvmasumlem1 .  Part of Lemma 9.4.3 of [Shapiro], p. 380.
           (Contributed by Mario Carneiro, 4-May-2016.) $)
        dchrvmasum2lem $p |- ( ph -> ( log ` A ) =
          sum_ d e. ( 1 ... ( |_ ` A ) )
            ( ( ( X ` ( L ` d ) ) x. ( ( mmu ` d ) / d ) ) x.
            sum_ m e. ( 1 ... ( |_ ` ( A / d ) ) )
            ( ( X ` ( L ` m ) ) x. ( ( log ` ( ( A / d ) / m ) ) / m ) ) ) ) $=
          ( vx vn c1 cfl cfv cfz co cv cdivides wbr crab cmu cdiv clog cmul csu
          cn wceq fveq2 fveq2d id oveq12d oveq2 oveq2d rpred wa elrabi ad2antll
          wcel cz mucl syl zcnd cc adantr elfzelz adantl dchrzrhcl elfznn nncnd
          nnne0d divcld nnrpd rpdivcl syl2an relogcld recnd mulcld dvdsflsumcom
          crp adantrr fzfid wss ssriv a1i cuz cle flge1nn syl2anc nnuz syl6eleq
          cr eluzfz1 musumsum dchrzrh1 oveq1d ax-1cn div1i syl6eq rpcnd mulid2d
          div1d 3eqtrrd wb fznnfl simprbda zred nndivred ad2antrr fsummulc2 cc0
          wne rpcnne0d div12 syl3anc rpne0d mul4d ad2antlr dchrzrhmul divmuldiv
          mulassd syl22anc eqtr4d divdiv1 eqcomd mulcomd eqtrd 3eqtr4d sumeq2dv
          ) AUDBUEUFZUGUHZUBUIUCUIZUJUKZUBURULZKUIZUMUFZUUCGUFZIUFZUUCUNUHZBUUC
          UNUHZUOUFZUPUHZUPUHZKUQUCUQZUUBUDBUUFUNUHZUEUFZUGUHZUUGUUFEUIZUPUHZGU
          FZIUFZUUTUNUHZBUUTUNUHZUOUFZUPUHZUPUHZEUQZKUQBUOUFZUUBUUFGUFIUFZUUGUU
          FUNUHZUPUHZUURUUSGUFIUFZUUPUUSUNUHZUOUFZUUSUNUHZUPUHZEUQUPUHZKUQAUBBU
          UNUVGEUCKUUCUUTUSZUUMUVFUUGUPUVSUUJUVCUULUVEUPUVSUUIUVBUUCUUTUNUVSUUH
          UVAIUUCUUTGUTVAUVSVBVCUVSUUKUVDUOUUCUUTBUNVDVAVCVEABTVFZAUUCUUBVJZUUF
          UUEVJZVGVGZUUGUUMUWCUUGUWCUUFURVJZUUGVKVJZUWBUWDAUWAUUDUBUUFURVHVIUUF
          VLZVMVNAUWAUUMVOVJUWBAUWAVGZUUJUULUWGUUIUUCUWGUUCCFGHIJOLPMAICVJZUWAR
          VPUWAUUCVKVJAUUCUDUUAVQVRVSUWGUUCUWAUUCURVJAUUCUUAVTZVRZWAUWGUUCUWJWB
          WCUWGUULUWGUUKABWKVJZUUCWKVJUUKWKVJUWATUWAUUCUWIWDBUUCWEWFWGWHWIZWLWI
          WJAUUOUDGUFZIUFZUDUNUHZBUDUNUHZUOUFZUPUHZUDUVIUPUHUVIAUUBUUMUWRKUCUBU
          UCUDUSZUUJUWOUULUWQUPUWSUUIUWNUUCUDUNUWSUUHUWMIUUCUDGUTVAUWSVBVCUWSUU
          KUWPUOUUCUDBUNVDVAVCAUDUUAWMUUBURWNAUCUUBURUWIWOWPAUUAUDWQUFZVJUDUUBV
          JAUUAURUWTABXCVJZUDBWRUKUUAURVJUVTUABWSWTXAXBUDUUAXDVMUWLXEAUWOUDUWQU
          VIUPAUWOUDUDUNUHUDAUWNUDUDUNACFGHIJOLPMRXFXGUDXHXIXJAUWPBUOABABTXKZXM
          VAVCAUVIAUVIABTWGWHXLXNAUUBUVRUVHKAUUFUUBVJZVGZUVRUURUVLUVQUPUHZEUQUV
          HUXDUURUVQUVLEUXDUDUUQWMUXDUVJUVKUXDUUFCFGHIJOLPMAUWHUXCRVPUXCUUFVKVJ
          ZAUUFUDUUAVQZVRVSZUXDUVKUXDUUGUUFUXDUUGUXDUWDUWEAUXCUWDUUFBWRUKZAUXAU
          XCUWDUXIVGXOUVTUUFBXPVMXQZUWFVMXRZUXJXSWHWIUXDUUSUURVJZVGZUVMUVPUXMUU
          SCFGHIJOLPMAUWHUXCUXLRXTZUXLUUSVKVJUXDUUSUDUUQVQVRZVSZUXMUVPUXMUVOUUS
          UXMUVNUXDUUPWKVJZUUSWKVJUVNWKVJUXLAUWKUUFWKVJZUXQUXCTUXCUUFUUFUUAVTWD
          BUUFWEWFUXLUUSUUSUUQVTZWDUUPUUSWEWFWGZUXLUUSURVJUXDUXSVRZXSWHWIYAUXDU
          URUXEUVGEUXMUXEUUGUVJUUFUNUHZUPUHZUVOUVMUUSUNUHZUPUHZUPUHZUVGUXMUVLUY
          CUVQUYEUPUXMUVJVOVJZUUGVOVJUUFVOVJUUFYBYCVGZUVLUYCUSUXDUYGUXLUXHVPZUX
          MUUGUXDUUGXCVJUXLUXKVPWHZUXMUUFUXDUXRUXLUXDUUFUXJWDVPZYDZUVJUUGUUFYEY
          FUXMUVMVOVJZUVOVOVJUUSVOVJUUSYBYCVGZUVQUYEUSUXPUXMUVOUXTWHZUXMUUSUXMU
          USUYAWDYDZUVMUVOUUSYEYFVCUXMUUGUVOUPUHUYBUYDUPUHZUPUHUUGUVOUYQUPUHZUP
          UHUYFUVGUXMUUGUVOUYQUYJUYOUXMUYBUYDUXMUVJUUFUYIUXMUUFUYKXKUXMUUFUYKYG
          WCZUXMUVMUUSUXPUXMUUSUYAWAUXMUUSUYAWBWCZWIZYLUXMUUGUYBUVOUYDUYJUYSUYO
          UYTYHUXMUVFUYRUUGUPUXMUVFUYQUVOUPUHUYRUXMUVCUYQUVEUVOUPUXMUVCUVJUVMUP
          UHZUUTUNUHZUYQUXMUVBVUBUUTUNUXMUUFUUSCFGHIJOLPMUXNUXCUXFAUXLUXGYIUXOY
          JXGUXMUYGUYMUYHUYNUYQVUCUSUYIUXPUYLUYPUVJUVMUUFUUSYKYMYNUXMUVDUVNUOUX
          MUVNUVDUXMBVOVJZUYHUYNUVNUVDUSAVUDUXCUXLUXBXTUYLUYPBUUFUUSYOYFYPVAVCU
          XMUYQUVOVUAUYOYQYRVEYSYRYTYRYTYS $.

        $( Combine the results of ~ dchrvmasumlem1 and ~ dchrvmasum2lem inside
           a conditional.  (Contributed by Mario Carneiro, 4-May-2016.) $)
        dchrvmasum2if $p |- ( ph -> ( sum_ n e. ( 1 ... ( |_ ` A ) )
              ( ( X ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) +
            if ( ps , ( log ` A ) , 0 ) ) =
          sum_ d e. ( 1 ... ( |_ ` A ) )
            ( ( ( X ` ( L ` d ) ) x. ( ( mmu ` d ) / d ) ) x.
            sum_ m e. ( 1 ... ( |_ ` ( A / d ) ) ) ( ( X ` ( L ` m ) ) x.
              ( ( log ` if ( ps , ( A / d ) , m ) ) / m ) ) ) ) $=
          ( c1 cfl cfv cfz co cv cvma cdiv cmul csu clog cc0 cif caddc cmu wceq
          wa fzfid wcel adantr cz elfzelz adantl dchrzrhcl cn cr elfznn nndivre
          mucl zred mpancom syl recnd mulcld nnrpd relogcld nndivred fsumcl crp
          rpdivcl syl2an fsumadd cmin relogdivd oveq2d cc pncan3d eqtr2d oveq1d
          rpdivcld nnne0d divdird adddid sumeq2dv dchrvmasumlem1 dchrvmasum2lem
          nncnd eqtrd oveq12d 3eqtr4rd iftrue fveq2d sumeq2sdv 3eqtr4d wn vmacl
          addid1d iffalse eqcomd sylan9eqr pm2.61dan ) ABUDCUEUFZUGUHZGUIZIUFKU
          FZXQUJUFZXQUKUHZULUHZGUMZBCUNUFZUOUPZUQUHZXPMUIZIUFKUFZYFURUFZYFUKUHZ
          ULUHZUDCYFUKUHZUEUFZUGUHZFUIZIUFKUFZBYKYNUPZUNUFZYNUKUHZULUHZFUMZULUH
          ZMUMZUSABUTYBYCUQUHZXPYJYMYOYKUNUFZYNUKUHZULUHZFUMZULUHZMUMZYEUUBAUUC
          UUIUSBAXPYJYMYOYNUNUFZYNUKUHZULUHZFUMZULUHZYJYMYOYKYNUKUHZUNUFZYNUKUH
          ZULUHZFUMZULUHZUQUHZMUMXPUUNMUMZXPUUTMUMZUQUHUUIUUCAXPUUNUUTMAUDXOVAZ
          AYFXPVBZUTZYJUUMUVFYGYIUVFYFDHIJKLQNROAKDVBZUVETVCZUVEYFVDVBAYFUDXOVE
          VFVGUVFYIUVFYFVHVBZYIVIVBZUVEUVIAYFXOVJZVFYHVIVBUVIUVJUVIYHYFVLVMYHYF
          VKVNVOVPVQZUVFYMUULFUVFUDYLVAZUVFYNYMVBZUTZYOUUKUVOYNDHIJKLQNROUVFUVG
          UVNUVHVCUVNYNVDVBUVFYNUDYLVEVFVGZUVOUUKUVOUUJYNUVOYNUVOYNUVNYNVHVBUVF
          YNYLVJVFZVRZVSZUVQVTVPZVQZWAZVQUVFYJUUSUVLUVFYMUURFUVMUVOYOUUQUVPUVOU
          UQUVOUUPYNUVOUUOUVOYKYNUVFYKWBVBZUVNACWBVBYFWBVBUWCUVEUBUVEYFUVKVRCYF
          WCWDZVCZUVRWMVSZUVQVTVPZVQZWAZVQWEAXPUUHUVAMUVFUUHYJUUMUUSUQUHZULUHUV
          AUVFUUGUWJYJULUVFUUGYMUULUURUQUHZFUMUWJUVFYMUUFUWKFUVOUUFYOUUKUUQUQUH
          ZULUHUWKUVOUUEUWLYOULUVOUUEUUJUUPUQUHZYNUKUHUWLUVOUUDUWMYNUKUVOUWMUUJ
          UUDUUJWFUHZUQUHUUDUVOUUPUWNUUJUQUVOYKYNUWEUVRWGWHUVOUUJUUDUVOUUJUVSVP
          ZUVFUUDWIVBUVNUVFUUDUVFYKUWDVSVPVCWJWKWLUVOUUJUUPYNUWOUVOUUPUWFVPUVOY
          NUVQWTUVOYNUVQWNWOXAWHUVOYOUUKUUQUVPUVTUWGWPXAWQUVFYMUULUURFUVMUWAUWH
          WEXAWHUVFYJUUMUUSUVLUWBUWIWPXAWQAYBUVBYCUVCUQACDEFGHIJKLMNOPQRSTUAUBW
          RZACDEFHIJKLMNOPQRSTUAUBUCWSXBXCVCBYEUUCUSABYDYCYBUQBYCUOXDWHVFBUUBUU
          IUSABXPUUAUUHMBYTUUGYJULBYMYSUUFFBYRUUEYOULBYQUUDYNUKBYPYKUNBYKYNXDXE
          WLWHXFWHXFVFXGABXHZUTZYBUOUQUHYBYEUUBUWRYBAYBWIVBUWQAXPYAGUVDAXQXPVBZ
          UTZXRXTUWTXQDHIJKLQNROAUVGUWSTVCUWSXQVDVBAXQUDXOVEVFVGUWTXQVHVBZXTWIV
          BUWSUXAAXQXOVJVFUXAXTXSVIVBUXAXTVIVBXQXIXSXQVKVNVPVOVQWAVCXJUWRYDUOYB
          UQUWQYDUOUSABYCUOXKVFWHUWQAUUBUVBYBUWQXPUUAUUNMUWQYTUUMYJULUWQYMYSUUL
          FUWQYRUUKYOULUWQYQUUJYNUKUWQYPYNUNBYKYNXKXEWLWHXFWHXFAYBUVBUWPXLXMXGX
          N $.
      $}

      ${
        dchrvmasum.f $e |- ( ( ph /\ m e. RR+ ) -> F e. CC ) $.
        dchrvmasum.g $e |- ( m = ( x / d ) -> F = K ) $.
        dchrvmasum.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
        dchrvmasum.t $e |- ( ph -> T e. CC ) $.
        dchrvmasum.1 $e |- ( ( ph /\ m e. ( 3 [,) +oo ) ) ->
          ( abs ` ( F - T ) ) <_ ( C x. ( ( log ` m ) / m ) ) ) $.
        dchrvmasum.r $e |- ( ph -> R e. RR ) $.
        dchrvmasum.2 $e |- ( ph ->
          A. m e. ( 1 [,) 3 ) ( abs ` ( F - T ) ) <_ R ) $.
        $( Lemma for ~ dchrvmasum .  (Contributed by Mario Carneiro,
           4-May-2016.) $)
        dchrvmasumlem2 $p |- ( ph -> ( x e. RR+ |->
    sum_ d e. ( 1 ... ( |_ ` x ) ) ( ( abs ` ( K - T ) ) / d ) ) e. O(1) ) $=
          ( crp c1 cv cfl cfv cfz co cdiv clog csu cmul c3 caddc cmin cabs wcel
          cr 1re a1i wa cc0 cle wbr cpnf cico elrege0 sylib simpld adantr fzfid
          simpr elfznn nnrpd rpdivcl syl2an syl rerpdivcld fsumrecl remulcld cn
          relogcl 3nn nnrp mp2b readdcli remulcl sylancl wss cc cmpt co1 rpssre
          recnd o1const sylancr crli logfacrlim2 rlimo1 mp1i ralrimiva ad2antrr
          wral wceq rspcv sylc subcld abscld absge0d 3re 1lt3 cxr clt rexri 0re
          adantl w3a elico2 mp2an sylan2 letrd eqbrtrd ad2antlr mpbid ad3antrrr
          wb oveq1d oveq2d wne syl3anc o1mul2 readdcld nndivred divge0d fsumge0
          o1add2 eleq1d absidd eqeltrd ltleii jctir lbico1 simp1bi 0lt1 simp2bi
          mp3an ltletrd elrpd r19.21bi biidd mpsyl jca log1 mulid2d rpre fznnfl
          nncnd simplbda lemuldivd 1rp logled syl5eqbrr rpregt0 divge0 syl21anc
          mulge0 syl12anc absidm nndivre elicopnf ax-mp sylanbrc fveq2d oveq12d
          fveq2 id breq12d rpcnne0 rpcnne0d divdiv2 div23 eqtrd mulassd breqtrd
          eqtr4d syl3anbrc breq1d fsumharmonic fsummulc2 breqtrrd adantrr o1le
          leabsd ) ABULCUMBUNZUOUPZUQURZUXDPUNZUSURZUTUPZUXDUSURZPVAZVBURZEVCUT
          UPZUMVDURZVBURZVDURZUXFKFVEURZVFUPZUXGUSURZPVAZUMVHUMVHVGZAVIVJABULUX
          LUXOVHAUXDULVGZVKZCUXKACVHVGZUYBAUYDVLCVMVNZACVLVOVPURVGUYDUYEVKZUGCV
          QVRZVSZVTZUYCUXFUXJPUYCUMUXEWAZUYCUXGUXFVGZVKZUXIUXDUYLUXHULVGZUXIVHV
          GZUYCUYBUXGULVGUYMUYKAUYBWBZUYKUXGUXGUXEWCZWDUXDUXGWEWFZUXHWLWGZUYCUY
          BUYKUYOVTWHZWIZWJZAUXOVHVGZUYBAEVHVGZUXNVHVGVUBUJUXMUMVCWKVGVCULVGUXM
          VHVGWMVCWNVCWLWOVIWPEUXNWQWRZVTZABULCUXKVHUYIUYTAULVHWSZCWTVGZBULCXAX
          BVGXCACUYHXDZBULCXEXFBULUXKXAZUMXGVNVUIXBVGABPXHUMVUIXIXJUUAAVUFUXOWT
          VGBULUXOXAXBVGXCAUXOVUDXDBULUXOXEXFUUFUYCUXLUXOVUAVUEUUBZUYCUXTUYCUXF
          UXSPUYJUYLUXRUXGUYLUXQUYLKFUYLUYMIWTVGZHULXMZKWTVGZUYQAVULUYBUYKAVUKH
          ULUEXKXLVUKVUMHUXHULHUNZUXHXNZIKWTUFUUGXOXPAFWTVGZUYBUYKUHXLXQZXRZUYK
          UXGWKVGZUYCUYPYFZUUCZWIZXDAUYBUXTVFUPZUXPVFUPZVMVNUMUXDVMVNUYCVVCUXPV
          VDUYCVVCUXTVHUYCUXTVVBUYCUXFUXSPUYJVVAUYLUXRUXGVURUYLUXGVUTWDZUYLUXQV
          UQXSUUDUUEUUHVVBUUIVUJUYCUXPUYCUXPVUJXDXRUYCVVCUXFCUXJVBURZPVAZUXOVDU
          RUXPVMUYCUXDUXRVVFEVCPUYOUYCVCVHVGZUMVCVMVNVVHUYCXTVJUMVCVIXTYAUUJUUK
          UYCVUCVLEVMVNZAVUCUYBUJVTAVVIUYBUMUMVCVPURZVGZAVVIHVVJXMVVIUMYBVGVCYB
          VGZUMVCYCVNVVKUMVIYDVCXTYDZYAUMVCUULUUPAVVIHVVJAVUNVVJVGZVKZVLIFVEURZ
          VFUPZEVLVHVGZVVOYEVJVVNAVUNULVGZVVQVHVGVVNVUNVVNVUNVHVGZUMVUNVMVNZVUN
          VCYCVNZUYAVVLVVNVVTVWAVWBYGYPVIVVMUMVCVUNYHYIZUUMZVVNVLUMVUNVVRVVNYEV
          JUYAVVNVIVJVWDVLUMYCVNVVNUUNVJVVNVVTVWAVWBVWCUUOUUQUURZAVVSVKZVVPVWFI
          FUEAVUPVVSUHVTXQZXRYJAVUCVVNUJVTVVNAVVSVLVVQVMVNVWEVWFVVPVWGXSYJAVVQE
          VMVNZHVVJUKUUSYKXKVVIVVIHUMVVJVUNUMXNVVIUUTXOUVAVTUVBUYLUXRVURXDUYLCU
          XJAUYDUYBUYKUYHXLUYSWJUYLUYFUXJVHVGVLUXJVMVNZVLVVFVMVNAUYFUYBUYKUYGXL
          UYSUYLUYNVLUXIVMVNUXDVHVGZVLUXDYCVNVKZVWIUYRUYLVLUMUTUPZUXIVMUVCUYLUM
          UXHVMVNZVWLUXIVMVNUYLUMUXGVBURZUXDVMVNVWMUYLVWNUXGUXDVMUYLUXGUYLUXGVU
          TUVGZUVDUYCUYKVUSUXGUXDVMVNZUYCVWJUYKVUSVWPVKYPUYBVWJAUXDUVEZYFZUXGUX
          DUVFWGUVHYLUYLUMUXDUXGUYAUYLVIVJUYBVWJAUYKVWQYMVVEUVIYNZUYLUMUXHUMULV
          GUYLUVJVJUYQUVKYNUVLUYBVWKAUYKUXDUVMYMUXIUXDUVNUVOCUXJUVPUVQUYLVCUXHV
          MVNZVKZUXRVFUPZUXRVVFUXGVBURZVMUYLVXBUXRXNZVWTUYLUXQWTVGVXDVUQUXQUVRW
          GZVTVXAUXRCUXIUXHUSURZVBURZVXCVMVXAUXHVCVOVPURZVGZVVQCVUNUTUPZVUNUSUR
          ZVBURZVMVNZHVXHXMZUXRVXGVMVNZVXAUXHVHVGZVWTVXIUYLVXPVWTUYCVWJVUSVXPUY
          KVWRUYPUXDUXGUVSWFZVTUYLVWTWBVVHVXIVXPVWTVKYPXTVCUXHUVTUWAUWBAVXNUYBU
          YKVWTAVXMHVXHUIXKYOVXMVXOHUXHVXHVUOVVQUXRVXLVXGVMVUOVVPUXQVFVUOIKFVEU
          FYQUWCZVUOVXKVXFCVBVUOVXJUXIVUNUXHUSVUNUXHUTUWEVUOUWFUWDYRUWGXOXPUYLV
          XGVXCXNVWTUYLVXGCUXJUXGVBURZVBURVXCUYLVXFVXSCVBUYLVXFUXIUXGVBURUXDUSU
          RZVXSUYLUXIWTVGZUXDWTVGUXDVLYSVKZUXGWTVGZUXGVLYSVKVXFVXTXNUYLUXIUYRXD
          ZUYBVYBAUYKUXDUWHYMZUYLUXGVVEUWIUXIUXDUXGUWJYTUYLVYAVYCVYBVXTVXSXNVYD
          VWOVYEUXIUXGUXDUWKYTUWLYRUYLCUXJUXGAVUGUYBUYKVUHXLUYLUXJUYSXDZVWOUWMU
          WOVTUWNYLUYLUXHVCYCVNZVKZVXBUXREVMUYLVXDVYGVXEVTVYHUXHVVJVGZVWHHVVJXM
          ZUXREVMVNZVYHVXPVWMVYGVYIUYLVXPVYGVXQVTUYLVWMVYGVWSVTUYLVYGWBUYAVVLVY
          IVXPVWMVYGYGYPVIVVMUMVCUXHYHYIUWPAVYJUYBUYKVYGUKYOVWHVYKHUXHVVJVUOVVQ
          UXREVMVXRUWQXOXPYLUWRUYCUXLVVGUXOVDUYCUXFUXJCPUYJAVUGUYBVUHVTVYFUWSYQ
          UWTUYCUXPVUJUXCYKUXAUXB $.

        $( Lemma for ~ dchrvmasum .  (Contributed by Mario Carneiro,
           3-May-2016.) $)
        dchrvmasumlem3 $p |- ( ph -> ( x e. RR+ |->
          sum_ d e. ( 1 ... ( |_ ` x ) ) ( ( ( X ` ( L ` d ) ) x.
            ( ( mmu ` d ) / d ) ) x. ( K - T ) ) ) e. O(1) ) $=
          ( crp c1 cv cfl cfv cfz co cmin cabs cdiv csu cmu cmul dchrvmasumlem2
          cr wcel 1re a1i wa fzfid cc wral simpr elfznn nnrpd rpdivcl ralrimiva
          syl2an ad2antrr wceq eleq1d subcld abscld cn adantl nndivred fsumrecl
          rspcv sylc cz elfzelz dchrzrhcl mucl syl zred recnd mulcld fsumcl cle
          wbr fsumabs nnrecred absge0d absmuld cbs eqid wfo cn0 nnnn0d ffvelrnd
          wf znzrhfo fof dchrabs2 nncnd nnne0d absdivd cc0 rprege0d absid eqtrd
          oveq2d mule1 lediv1dd eqbrtrd mulid2d breqtrd lemul1ad 3brtr4d fsumle
          lemul12ad divrec2d letrd leabsd adantrr o1le ) ABULUMBUNZUOUPZUQURZKF
          USURZUTUPZPUNZVAURZPVBZYTUUCLUPZNUPZUUCVCUPZUUCVAURZVDURZUUAVDURZPVBZ
          UMVFUMVFVGZAVHVIABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVEAYRULVGZV
          JZYTUUDPUUOUMYSVKZUUOUUCYTVGZVJZUUBUUCUURUUAUURKFUURYRUUCVAURZULVGZIV
          LVGZHULVMZKVLVGZUUOUUNUUCULVGUUTUUQAUUNVNUUQUUCUUCYSVOZVPYRUUCVQVSAUV
          BUUNUUQAUVAHULUEVRVTUVAUVCHUUSULHUNUUSWAIKVLUFWBWIWJAFVLVGUUNUUQUHVTW
          CZWDZUUQUUCWEVGZUUOUVDWFZWGZWHZUUOYTUUKPUUPUURUUJUUAUURUUGUUIUURUUCDJ
          LMNOTQUARANDVGUUNUUQUCVTZUUQUUCWKVGUUOUUCUMYSWLWFZWMZUURUUIUURUUHUUCU
          URUUHUURUVGUUHWKVGUVHUUCWNWOWPZUVHWGWQZWRZUVEWRZWSZAUUNUULUTUPZUUEUTU
          PZWTXAUMYRWTXAUUOUVSUUEUVTUUOUULUVRWDZUVJUUOUUEUUOUUEUVJWQWDUUOUVSYTU
          UKUTUPZPVBUUEUWAUUOYTUWBPUUPUURUUKUVQWDZWHUVJUUOYTUUKPUUPUVQXBUUOYTUW
          BUUDPUUPUWCUVIUURUUJUTUPZUUBVDURUMUUCVAURZUUBVDURUWBUUDWTUURUWDUWEUUB
          UURUUJUVPWDUURUUCUVHXCZUVFUURUUAUVEXDUURUWDUUGUTUPZUUIUTUPZVDURZUWEWT
          UURUUGUUIUVMUVOXEUURUWIUMUWEVDURUWEWTUURUWGUMUWHUWEUURUUGUVMWDUUMUURV
          HVIZUURUUIUVOWDUWFUURUUGUVMXDUURUUIUVOXDUURUUFOXFUPZDJMNOTUAQUWKXGZUV
          KUURWKUWKUUCLAWKUWKLXLZUUNUUQAWKUWKLXHZUWMAMXIVGUWNAMSXJUWKLMOQUWLRXM
          WOWKUWKLXNWOVTUVLXKXOUURUWHUUHUTUPZUUCVAURZUWEWTUURUWHUWOUUCUTUPZVAUR
          UWPUURUUHUUCUURUUHUVNWQZUURUUCUVHXPZUURUUCUVHXQZXRUURUWQUUCUWOVAUURUU
          CVFVGXSUUCWTXAVJUWQUUCWAUURUUCUURUUCUVHVPZXTUUCYAWOYCYBUURUWOUMUUCUUR
          UUHUWRWDUWJUXAUURUVGUWOUMWTXAUVHUUCYDWOYEYFYLUURUWEUURUWEUWFWQYGYHYFY
          IUURUUJUUAUVPUVEXEUURUUBUUCUURUUBUVFWQUWSUWTYMYJYKYNUUOUUEUVJYOYNYPYQ
          $.
      $}

      ${
        dchrvmasumlema.f $e |- F = ( a e. NN |->
          ( ( X ` ( L ` a ) ) x. ( ( log ` a ) / a ) ) ) $.
        $( Lemma for ~ dchrvmasum and ~ dchrvmasumif .  Apply ~ dchrisum for
           the function ` log ( y ) / y ` , which is decreasing above ` _e `
           (or above 3, the nearest integer bound).  (Contributed by Mario
           Carneiro, 5-May-2016.) $)
        dchrvmasumlema $p |- ( ph -> E. t E. c e. ( 0 [,) +oo )
     ( seq 1 ( + , F ) ~~> t /\ A. y e. ( 3 [,) +oo ) ( abs `
        ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - t ) ) <_
          ( c x. ( ( log ` y ) / y ) ) ) ) $=
          ( vx vn caddc c1 cseq cv cli wbr cfl cfv cmin cabs clog cdiv cmul cle
          co c3 cpnf cico wral wa cc0 wrex wex weq fveq2 id oveq12d cn wcel 3nn
          a1i crp cr relogcl rerpdivcl mpancom adantl w3a simp3r ceu simp2l ere
          wb rpred 3re clt egt2lt3 simpri ltleii simp3l letrd logdivle syl22anc
          simp2r mpbid cmpt ccxp crli rpcn cxp1d oveq2d mpteq2ia cxploglim mp1i
          c2 1rp syl5eqbrr fveq2d cbvmptv eqtri dchrisum oveq1d breq12d cbvralv
          anbi2i rexbii exbii sylib ) AUEFUFUGZCUHZUIUJZUCUHZUKULZYCULZYDUMUSZU
          NULZMUHZYFUOULZYFUPUSZUQUSZURUJZUCUTVAVBUSZVCZVDZMVEVAVBUSZVFZCVGYEBU
          HZUKULZYCULZYDUMUSZUNULZYKUUAUOULZUUAUPUSZUQUSZURUJZBYPVCZVDZMYSVFZCV
          GAUCCUDUHZUOULZUUMUPUSZYMDEUDFGHUTIJKMNOPQRSTUAUDUCVHZUUNYLUUMYFUPUUM
          YFUOVIUUPVJVKUTVLVMAVNVOUUMVPVMZUUOVQVMZAUUNVQVMUUQUURUUMVRUUNUUMVSVT
          WAAUUQYFVPVMZVDZUTUUMURUJZUUMYFURUJZVDZWBZUVBYMUUOURUJZAUUTUVAUVBWCZU
          VDUUMVQVMWDUUMURUJYFVQVMWDYFURUJUVBUVEWGUVDUUMAUUQUUSUVCWEWHZUVDWDUTU
          UMWDVQVMUVDWFVOZUTVQVMUVDWIVOUVGWDUTURUJUVDWDUTWFWIXIWDWJUJWDUTWJUJWK
          WLWMVOAUUTUVAUVBWNWOZUVDYFAUUQUUSUVCWRWHZUVDWDUUMYFUVHUVGUVJUVIUVFWOU
          UMYFWPWQWSAUDVPUUOWTUDVPUUNUUMUFXAUSZUPUSZWTZVEXBUDVPUVLUUOUUQUVKUUMU
          UNUPUUQUUMUUMXCXDXEXFUFVPVMUVMVEXBUJAXJUFUDXGXHXKFLVLLUHZHULZJULZUVNU
          OULZUVNUPUSZUQUSZWTUDVLUUMHULZJULZUUOUQUSZWTUBLUDVLUVSUWBLUDVHZUVPUWA
          UVRUUOUQUWCUVOUVTJUVNUUMHVIXLUWCUVQUUNUVNUUMUPUVNUUMUOVIUWCVJVKVKXMXN
          XOYTUULCYRUUKMYSYQUUJYEYOUUIUCBYPUCBVHZYJUUEYNUUHURUWDYIUUDUNUWDYHUUC
          YDUMUWDYGUUBYCYFUUAUKVIXLXPXLUWDYMUUGYKUQUWDYLUUFYFUUAUPYFUUAUOVIUWDV
          JVKXEXQXRXSXTYAYB $.
      $}

      $d m F $.
      dchrvmasumif.f $e |- F = ( a e. NN |->
        ( ( X ` ( L ` a ) ) / a ) ) $.
      dchrvmasumif.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
      dchrvmasumif.s $e |- ( ph -> seq 1 ( + , F ) ~~> S ) $.
      dchrvmasumif.1 $e |- ( ph -> A. y e. ( 1 [,) +oo )
        ( abs ` ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - S ) ) <_ ( C / y ) ) $.
      ${
        dchrvmasumif.g $e |- K = ( a e. NN |->
          ( ( X ` ( L ` a ) ) x. ( ( log ` a ) / a ) ) ) $.
        dchrvmasumif.e $e |- ( ph -> E e. ( 0 [,) +oo ) ) $.
        dchrvmasumif.t $e |- ( ph -> seq 1 ( + , K ) ~~> T ) $.
        dchrvmasumif.2 $e |- ( ph -> A. y e. ( 3 [,) +oo )
          ( abs ` ( ( seq 1 ( + , K ) ` ( |_ ` y ) ) - T ) ) <_
            ( E x. ( ( log ` y ) / y ) ) ) $.
        $( Lemma for ~ dchrvmasumif .  (Contributed by Mario Carneiro,
           5-May-2016.) $)
        dchrvmasumiflem1 $p |- ( ph -> ( x e. RR+ |->
          sum_ d e. ( 1 ... ( |_ ` x ) )
            ( ( ( X ` ( L ` d ) ) x. ( ( mmu ` d ) / d ) ) x.
            ( sum_ k e. ( 1 ... ( |_ ` ( x / d ) ) )
                ( ( X ` ( L ` k ) ) x.
                  ( ( log ` if ( S = 0 , ( x / d ) , k ) ) / k ) ) -
                if ( S = 0 , 0 , T ) ) ) ) e. O(1) ) $=
          ( vm cc0 wceq cif c1 c2 cfz co cv cfv cabs c3 clog cdiv csu caddc cfl
          cmul crp wcel wa fzfid cn simpl elfznn adantr adantl dchrzrhcl syl2an
          cc cz nnrpd relogcld nndivred recnd mulcld fveq2 oveq2d fveq2d oveq1d
          ifcl cpnf cico cseq wbr syl sylancr cmin cle nnuz a1i wne divcld cmpt
          cr wf weq oveq12d cbvmptv eqtri fmptd ffvelrn sylan ad2antrr elicopnf
          id wb 3re 1re letrd syl2anc ffvelrnd abscld sylan9eqr iftrue ad2antlr
          clt jca adantlr eqtrd ifnefalse fsumrecl readdcld sylancl mpbid simpr
          nnz fsumcl ifeq1 sumeq12rdv wn ifclda 0cn climcl nncn nnne0 serf mp1i
          cli 1z simprbda 1lt3 ltleii simplbda flge1nn 0re 3pos ltletrd elrege0
          elrpd simplbi logge0d oveq2 subid1d wral ax-mp sylanbrc breq12d rspcv
          rerpdivcl sylc eqbrtrrd lemul2a syl31anc nncnd nnne0d div12d sumeq2dv
          relogcl fvmpt eqeltrrd fsummulc2 3eqtr4d cuz syl6eleq fsumser absmuld
          absidd 3eqtrd rpcnne0 div12 syl3anc 3brtr4d rspccva eqcomd pm2.61dane
          ovex nnrp elfzelz elrpii nndivre remulcld cxr w3a rexri mp2an simp1bi
          elico2 0lt1 simp2bi subcld abs2dif2d fsumabs absge0d flcld 2z simp3bi
          wss nnzi fllt df-3 syl6breq rpre zleltp1 mpbird eluz2 syl3anbrc fzss2
          3nn fsumless log1 elfzle1 ifboth 1rp logleb syl5eqbrr rpregt0d divge0
          breq2 syl21anc eqeltrd nnred elfzle2 2lt3 lelttrd breq1 wi rpred ltle
          2re mpd lediv1d eqbrtrd fsumle leadd1d ralrimiva dchrvmasumlem3 ) ABF
          UQURZDJUSZEUTVAVBVCZIVDZNVEZPVEZVFVEZVGVHVEZVVFVIVCZVMVCZIVJZVVCUQGUS
          ZVFVEZVKVCZVVNHUPUTUPVDZVLVEZVBVCZVVHVVCVVQVVFUSZVHVEZVVFVIVCZVMVCZIV
          JZLUTBVDSVDVIVCZVLVEZVBVCZVVHVVCVWEVVFUSZVHVEZVVFVIVCZVMVCZIVJNOPQSTU
          AUBUCUDUEUFUGAVVQVNVOZVPZVVSVWCIVWMUTVVRVQZVWMVVFVVSVOZVPZVVHVWBVWMAV
          VFVRVOZVVHWEVOZVWOAVWLVSVVFVVRVTZAVWQVPZVVFELNOPQUCTUDUAAPEVOZVWQUFWA
          VWQVVFWFVOZAVVFUUBWBWCZWDZVWPVWBVWPVWAVVFVWPVVTVWMVWLVVFVNVOZVVTVNVOZ
          VWOAVWLUUAZVWOVVFVWSWGVVCVVQVVFVNWPZWDWHVWOVWQVWMVWSWBZWIWJWKZUUCZVVQ
          VWEURZVVSVWGVWCVWKIVXLVVRVWFUTVBVVQVWEVLWLWMVXLVWCVWKURVVFVWGVOVXLVWB
          VWJVVHVMVXLVWAVWIVVFVIVXLVVTVWHVHVVCVVQVWEVVFUUDWNWOWMWAUUEAVVCDJUQWQ
          WRVCZADVXMVOZVVCUIWAAJVXMVOVVCUUFUMWAUUGAUQWEVOGWEVOZVVNWEVOZUUHAVKMU
          TWSZGUUNWTVXOUNGVXQUUIXAVVCUQGWEWPXBZAVVQVGWQWRVCZVOZVPZVWDVVNXCVCZVF
          VEZVVDVVQVHVEZVVQVIVCZVMVCZXDWTFUQVYAVVCVPZVYDVVRVKKUTWSZVEZVFVEZVMVC
          ZVYDDVVQVIVCZVMVCZVYCVYFXDVYGVYJXJVOVYLXJVOZVYDXJVOZUQVYDXDWTZVPZVYJV
          YLXDWTVYKVYMXDWTVYGVYIVYGVRWEVVRVYHAVRWEVYHXKZVXTVVCAIKUTVRXEUTWFVOAU
          UOXFAVRWEKXKZVWQVVFKVEZWEVOZAIVRVVHVVFVIVCZWEKVWTVVHVVFVXCVWQVVFWEVOA
          VVFUUJWBZVWQVVFUQXGAVVFUUKWBZXHZKRVRRVDZNVEZPVEZWUFVIVCZXIIVRWUBXIUHR
          IVRWUIWUBRIXLZWUHVVHWUFVVFVIWUJWUGVVGPWUFVVFNWLWNZWUJYAZXMZXNXOXPZVRW
          EVVFKXQZXRUULZXSVYAVVRVRVOZVVCVYAVVQXJVOZUTVVQXDWTZWUQAVXTWURVGVVQXDW
          TZVGXJVOZVXTWURWUTVPYBAYCVGVVQXTUUMZUUPZVYAUTVGVVQUTXJVOZVYAYDXFWVAVY
          AYCXFZWVCUTVGXDWTVYAUTVGYDYCUUQUURXFAVXTWURWUTWVBUUSZYEZVVQUUTYFZWAYG
          ZYHVYAVYNVVCVYAVWMVYNVYAAVWLAVXTVSZVYAVVQWVCVYAUQVGVVQUQXJVOZVYAUVAXF
          WVEWVCUQVGYLWTVYAUVBXFWVFUVCUVEZYMZADXJVOZVWLVYNAVXNWVNUIVXNWVNUQDXDW
          TDUVDUVFXAZDVVQUVOXRXAWAVYAVYQVVCVYAVYOVYPVYAVVQWVLWHZVYAVVQWVCWVGUVG
          ZYMWAVYGVYIFXCVCZVFVEZVYJVYLXDVYGWVRVYIVFVVCVYAWVRVYIUQXCVCVYIFUQVYIX
          CUVHVYAVYIVYAVRWEVVRVYHAVYRVXTWUPWAWVHYGUVIYIWNVYAWVSVYLXDWTZVVCVYAVV
          QUTWQWRVCZVOZCVDZVLVEZVYHVEZFXCVCZVFVEZDWWCVIVCZXDWTZCWWAUVJZWVTVYAWU
          RWUSWWBWVCWVGWVDWWBWURWUSVPYBYDUTVVQXTUVKUVLAWWJVXTUKWAWWIWVTCVVQWWAC
          UPXLZWWGWVSWWHVYLXDWWKWWFWVRVFWWKWWEVYIFXCWWKWWDVVRVYHWWCVVQVLWLZWNWO
          WNWWCVVQDVIUVHUVMUVNUVPWAUVQVYJVYLVYDUVRUVSVYGVYCVYDVYIVMVCZVFVEVYDVF
          VEZVYJVMVCZVYKVYGVYBWWMVFVYGVYBVYDVVSWUBIVJZVMVCZWWMVYAVWMVVCVYBWWQUR
          WVMVWMVVCVPZVWDVVSVYDWUBVMVCZIVJZVYBWWQWWRVVSVWCWWSIWWRVWOVPZVWCVVHVY
          DVVFVIVCZVMVCWWSWXAVWBWXBVVHVMVVCVWBWXBURVWMVWOVVCVWAVYDVVFVIVVCVVTVV
          QVHVVCVVQVVFYJWNWOYKWMWXAVVHVYDVVFVWMVWOVWRVVCVXDYNVWMVYDWEVOZVVCVWOV
          WMVYDVWLVYOAVVQUWDZWBWJZXSWXAVVFVWOVWQWWRVWSWBZUVTWXAVVFWXFUWAUWBYOUW
          CVVCVWMVYBVWDUQXCVCVWDVVCVVNUQVWDXCVVCUQGYJWMVWMVWDVXKUVIYIVWMWWQWWTU
          RVVCVWMVVSWUBVYDIVWNWXEVWPVYTWUBWEVWPVWQVYTWUBURZVXIRVVFWUIWUBVRKWUMU
          HVVHVVFVIUXBUWEXAZVWMVYSVWQWUAVWOAVYSVWLWUNWAVWSWUOWDUWFUWGWAUWHXRVYG
          WWPVYIVYDVMVYAWWPVYIURVVCVYAWUBIKUTVVRVYAVWMVWOWXGWVMWXHXRVYAVVRVRUTU
          WIVEZWVHXEUWJZVYAAVWQWUBWEVOVWOWVJVWSWUEWDUWKWAWMYOWNVYGVYDVYIVYAVWMV
          VCWXCWVMWWRVYDVWLVYOAVVCWXDYKWJZXRWVIUWLVYAWWOVYKURVVCVYAWWNVYDVYJVMV
          YAVYDWVPWVQUWMWOWAUWNVYAVWMVVCVYFVYMURWVMWWRVYFDVYEVMVCZVYMWWRVVDDVYE
          VMVVCVVDDURVWMVVCDJYJWBWOWWRDWEVOZWXCVVQWEVOVVQUQXGVPZWXLVYMURAWXMVWL
          VVCADWVOWJXSWXKVWLWXNAVVCVVQUWOYKDVYDVVQUWPUWQYOXRUWRVYAFUQXGZVPZVVRV
          XQVEZGXCVCZVFVEZJVYEVMVCZVYCVYFXDVYAWXSWXTXDWTZWXOAWWDVXQVEZGXCVCZVFV
          EZJWWCVHVEZWWCVIVCZVMVCZXDWTZCVXSUVJVXTWYAUOWYHWYACVVQVXSWWKWYDWXSWYG
          WXTXDWWKWYCWXRVFWWKWYBWXQGXCWWKWWDVVRVXQWWLWNWOWNWWKWYFVYEJVMWWKWYEVY
          DWWCVVQVIWWCVVQVHWLWWKYAXMWMUVMUWSXRWAWXPVYBWXRVFWXPVWDWXQVVNGXCWXPVW
          CIMUTVVRVWOWXPVVFMVEZVVHVVFVHVEZVVFVIVCZVMVCZVWCVWOVWQWYIWYLURVWSRVVF
          WUHWUFVHVEZWUFVIVCZVMVCZWYLVRMWUJWUHVVHWYNWYKVMWUKWUJWYMWYJWUFVVFVIWU
          FVVFVHWLWULXMXMZULVVHWYKVMUXBUWEXAWXPVWCWYLWXOVWCWYLURVYAWXOVWBWYKVVH
          VMWXOVWAWYJVVFVIWXOVVTVVFVHFUQVVQVVFYPWNWOWMWBUWTYIZVYAVVRWXIVOWXOWXJ
          WAWXPVWOVPWYIVWCWEWYQWXPVRWEMXKZVWQWYIWEVOVWOAWYRVXTWXOAIVRWYLWEMVWTV
          VHWYKVXCVWTWYJVVFVWTWYJVWTVVFVWQVXEAVVFUXCWBWHWJWUCWUDXHWKMRVRWYOXIIV
          RWYLXIULRIVRWYOWYLWYPXNXOXPXSVWSVRWEVVFMXQWDUWFUWKWXOVVNGURVYAFUQUQGY
          PWBXMWNWXPVVDJVYEVMWXOVVDJURVYAFUQDJYPWBWOUWRUXAAVVMVVOAVVEVVLIAUTVAV
          QAVVFVVEVOZVPZVVIVVKWYTVVHWYTVVFELNOPQUCTUDUAAVXAWYSUFWAWYSVXBAVVFUTV
          AUXDWBWCZYHZWYTVVJXJVOZVWQVVKXJVOZVGVNVOZXUCVGYCUVBUXEZVGUWDUVKZWYSVW
          QAVVFVAVTZWBVVJVVFUXFXBZUXGZYQZAVVNVXRYHZYRAVYCVVPXDWTUPUTVGWRVCZAVVQ
          XUMVOZVPZVYCVWDVFVEZVVOVKVCZVVPXUOVYBXUOVWMVYBWEVOXUOAVWLAXUNVSXUOVVQ
          XUNWURAXUNWURWUSVVQVGYLWTZWVDVGUXHVOXUNWURWUSXURUXIYBYDVGYCUXJUTVGVVQ
          UXMUXKZUXLWBZXUOUQUTVVQWVKXUOUVAXFWVDXUOYDXFXUTUQUTYLWTXUOUXNXFXUNWUS
          AXUNWURWUSXURXUSUXOWBZUVCUVEYMZVWMVWDVVNVXKAVXPVWLVXRWAZUXPXAYHXUOXUP
          VVOXUOVWDXUOVWMVWDWEVOXVBVXKXAYHZAVVOXJVOXUNXULWAZYRXUOVVMVVOAVVMXJVO
          ZXUNXUKWAZXVEYRXUOVWMVYCXUQXDWTXVBVWMVWDVVNVXKXVCUXQXAXUOXUPVVMXDWTZX
          UQVVPXDWTZXUOXUPVVSVWCVFVEZIVJZVVMXVDXUOVWMXVKXJVOXVBVWMVVSXVJIVWNVWP
          VWCVXJYHYQXAZXVGXUOVWMXUPXVKXDWTXVBVWMVVSVWCIVWNVXJUXRXAXUOXVKVVEXVJI
          VJZVVMXVLXUOVWMXVMXJVOXVBVWMVVEXVJIVWMUTVAVQVWMWYSVPZVWCXVNVVHVWBAWYS
          VWRVWLXUAYNZXVNVWBXVNVWAVVFXVNVVTXVNVWLVXEVXFVWMVWLWYSVXGWAXVNVVFWYSV
          WQVWMXUHWBZWGZVXHYFZWHZXVPWIZWJZWKZYHYQXAXVGXUOVVEXVJVVSIXUOUTVAVQZXU
          OWYSVPZVWCXUOVWMWYSVWCWEVOXVBXWBXRZYHZXWDVWCXWEUXSXUOVAVVRUWIVEVOZVVS
          VVEUYCXUOVVRWFVOZVAWFVOZVVRVAXDWTZXWGXUOVVQXUTUXTXWIXUOUYAXFXUOXWJVVR
          VAUTVKVCZYLWTZXUOVVRVGXWKYLXUOXURVVRVGYLWTZXUNXURAXUNWURWUSXURXUSUYBZ
          WBXUOWURVGWFVOXURXWMYBXUTVGUYNUYDVVQVGUYEYSYTUYFUYGXUOVWMXWJXWLYBZXVB
          VWMXWHXWIXWOVWMVVQVWLWURAVVQUYHWBUXTUYAVVRVAUYIYSXAUYJVVRVAUYKUYLVVRU
          TVAUYMXAUYOXUOVVEXVJVVLIXWCXWFAWYSVVLXJVOXUNXUJYNXWDXVJVVIVWBVFVEZVMV
          CZVVLXDXUOVWMWYSXVJXWQURXVBXVNVVHVWBXVOXWAUWLXRXWDXWPXJVOXUDVVIXJVOZU
          QVVIXDWTZVPZXWPVVKXDWTXWQVVLXDWTXWDXWPVWBXJXWDVWBXUOVWMWYSVWBXJVOXVBX
          VTXRZXWDVWAXJVOZUQVWAXDWTVVFXJVOUQVVFYLWTVPZUQVWBXDWTXUOVWMWYSXXBXVBX
          VSXRXWDUQUTVHVEZVWAXDUYPXWDUTVVTXDWTZXXDVWAXDWTZXUOWUSUTVVFXDWTZXXEWY
          SXVAVVFUTVAUYQVVCWUSXXGXXEVVQVVFVVQVVTUTXDVUDVVFVVTUTXDVUDUYRWDXUOVWM
          WYSXXEXXFYBZXVBXVNUTVNVOVXFXXHUYSXVRUTVVTUYTXBXRYTVUAXUOVWMWYSXXCXVBX
          VNVVFXVQVUBXRVWAVVFVUCVUEUWMZXXAVUFAWYSXUDXUNXUIYNXUOVWMWYSXWTXVBXVNX
          WRXWSAWYSXWRVWLXUBYNXVNVVHXVOUXSYMXRXWDXWPVWBVVKXDXXIXWDVWAVVJXDWTZVW
          BVVKXDWTZXWDVVTVGXDWTZXXJXWDVVTVGYLWTZXXLXWDXURVVFVGYLWTZXXMXUNXURAWY
          SXWNYKXUOVWMWYSXXNXVBXVNVVFVAVGXVNVVFXVPVUGVAXJVOXVNVUOXFWVAXVNYCXFWY
          SVVFVAXDWTVWMVVFUTVAVUHWBVAVGYLWTXVNVUIXFVUJXRVVCXURXXNXXMVVQVVFVVQVV
          TVGYLVUKVVFVVTVGYLVUKUYRYFXUOVWMWYSXXMXXLVULZXVBXVNVVTXJVOWVAXXOXVNVV
          TXVRVUMYCVVTVGVUNYSXRVUPXUOVWMWYSXXLXXJYBZXVBXVNVXFXUEXXPXVRXUFVVTVGU
          YTYSXRYTXUOVWMWYSXXJXXKYBXVBXVNVWAVVJVVFXVSXUCXVNXUGXFXVQVUQXRYTVURXW
          PVVKVVIUVRUVSVURVUSYEYEXUOVWMXVHXVIYBXVBVWMXUPVVMVVOVWMVWDVXKYHAXVFVW
          LXUKWAVWMVVNXVCYHVUTXAYTYEVVAVVB $.

        $( Lemma for ~ dchrvmasum .  (Contributed by Mario Carneiro,
           5-May-2016.) $)
        dchrvmasumiflem2 $p |- ( ph -> ( x e. RR+ |->
          ( sum_ n e. ( 1 ... ( |_ ` x ) )
              ( ( X ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) +
            if ( S = 0 , ( log ` x ) , 0 ) ) ) e. O(1) ) $=
          ( vd vk crp c1 cv cfl cfv cfz co cmu cdiv cmul cc0 wceq cif clog cvma
          csu caddc cc cr wcel 1re a1i cmpt wa fzfid ad2antrr cz elfzelz adantl
          co1 dchrzrhcl cn elfznn mucl syl zred nndivred mulcld fsumcl cseq cli
          recnd wbr climcl adantr 0cn wn wne df-ne simpr divcld sylan2br ifclda
          dchrmusum2 rpssre o1const sylancr o1mul2 rpdivcl syl2an ifcl relogcld
          nnrpd cmin subdid sumeq2dv fsumsub mulassd oveq2 ifsb mul01d divcan2d
          ifeq1d ifeq2da eqtrd syl5eq oveq2d fsummulc1 3eqtrrd 3eqtrd mpteq2dva
          wss cle cabs dchrvmasumiflem1 eqeltrrd mpbird nndivre mpancom relogcl
          o1dif vmacl sylancl addcld abscld adantrr simprl simprr dchrvmasum2if
          fveq2d eqle syl2anc o1le ) ABUQURBUSZUTVAZVBVCZUOUSZNVAPVAZUVCVDVAZUV
          CVEVCZVFVCZURUUTUVCVEVCZUTVAZVBVCZUPUSZNVAPVAZFVGVHZUVHUVKVIZVJVAZUVK
          VEVCZVFVCZUPVLZVFVCZUOVLZUVBIUSZNVAPVAZUWAVKVAZUWAVEVCZVFVCZIVLZUVMUU
          TVJVAZVGVIZVMVCZURVNURVOVPAVQVRABUQUVTVSWFVPBUQUVBUVGUOVLZFVFVCZUVMVG
          GFVEVCZVIZVFVCZVSWFVPABUQUWKUWMVNAUUTUQVPZVTZUWJFUWPUVBUVGUOUWPURUVAW
          AZUWPUVCUVBVPZVTZUVDUVFUWSUVCELNOPQUBSUCTAPEVPZUWOUWRUEWBZUWRUVCWCVPU
          WPUVCURUVAWDWEWGUWSUVFUWSUVEUVCUWSUVEUWSUVCWHVPZUVEWCVPUWRUXBUWPUVCUV
          AWIZWEZUVCWJWKWLUXDWMWRWNZWOZAFVNVPZUWOAVMKURWPZFWQWSUXGUIFUXHWTWKZXA
          ZWNZAUWMVNVPZUWOAUVMVGUWLVNVGVNVPZAUVMVTXBVRUVMXCZAFVGXDZUWLVNVPFVGXE
          ZAUXOVTZGFAGVNVPZUXOAVMMURWPZGWQWSUXRUMGUXSWTWKZXAZAUXGUXOUXIXAZAUXOX
          FZXGXHXIZXAZABCDEFHKLNOPQRUOSTUAUBUCUDUEUFUGUHUIUJXJAUQVOYRUXLBUQUWMV
          SWFVPXKUYDBUQUWMXLXMXNABUQUVTUWNUWPUVBUVSUOUWQUWSUVGUVRUXEUWSUVJUVQUP
          UWSURUVIWAUWSUVKUVJVPZVTZUVLUVPUYGUVKELNOPQUBSUCTUWSUWTUYFUXAXAUYFUVK
          WCVPUWSUVKURUVIWDWEWGUYGUVPUYGUVOUVKUYGUVNUWSUVHUQVPZUVKUQVPUVNUQVPUY
          FUWPUWOUVCUQVPUYHUWRAUWOXFUWRUVCUXCXSUUTUVCXOXPUYFUVKUVKUVIWIZXSUVMUV
          HUVKUQXQXPXRUYFUVKWHVPUWSUYIWEWMWRWNWOZWNZWOZUWPUWKUWMUXKUYEWNABUQUVB
          UVGUVRUVMVGGVIZXTVCVFVCZUOVLZVSBUQUVTUWNXTVCZVSWFABUQUYOUYPUWPUYOUVBU
          VSUVGUYMVFVCZXTVCZUOVLUVTUVBUYQUOVLZXTVCUYPUWPUVBUYNUYRUOUWSUVGUVRUYM
          UXEUYJUWSUXMUXRUYMVNVPZXBAUXRUWOUWRUXTWBUVMVGGVNXQZXMZYAYBUWPUVBUVSUY
          QUOUWQUYKUWSUVGUYMUXEVUBWNYCUWPUYSUWNUVTXTUWPUWNUWJFUWMVFVCZVFVCUWJUY
          MVFVCUYSUWPUWJFUWMUXFUXJUYEYDUWPVUCUYMUWJVFAVUCUYMVHUWOAVUCUVMFVGVFVC
          ZFUWLVFVCZVIZUYMUVMVGUWLVUCVUDVUEUWMVGFVFYEUWMUWLFVFYEYFAVUFUVMVGVUEV
          IUYMAUVMVUDVGVUEAFUXIYGYIAUVMVUEGVGUXNAUXOVUEGVHUXPUXQGFUYAUYBUYCYHXH
          YJYKYLXAYMUWPUVBUVGUYMUOUWQAUYTUWOAUXMUXRUYTXBUXTVUAXMXAUXEYNYOYMYPYQ
          ABCDEFGHUPJKLMNOPQRUOSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUUAUUBUUGUUCUYLUWP
          UWFUWHUWPUVBUWEIUWQUWPUWAUVBVPZVTZUWBUWDVUHUWAELNOPQUBSUCTAUWTUWOVUGU
          EWBVUGUWAWCVPUWPUWAURUVAWDWEWGVUHUWDVUHUWAWHVPZUWDVOVPZVUGVUIUWPUWAUV
          AWIWEUWCVOVPVUIVUJUWAUUHUWCUWAUUDUUEWKWRWNWOUWPUWGVNVPUXMUWHVNVPUWPUW
          GUWOUWGVOVPAUUTUUFWEWRXBUVMUWGVGVNXQUUIUUJZAUWOURUUTYSWSZVTZVTZUWIYTV
          AZVOVPZVUOUVTYTVAZVHVUOVUQYSWSAUWOVUPVULUWPUWIVUKUUKUULVUNUWIUVTYTVUN
          UVMUUTEHUPILNOPQUOSTAOWHVPVUMUAXAUBUCUDAUWTVUMUEXAAPHXDVUMUFXAAUWOVUL
          UUMAUWOVULUUNUUOUUPVUOVUQUUQUURUUS $.
      $}

      $( An asymptotic approximation for the sum of ` X ( n ) Lam ( n ) / n `
         conditional on the value of the infinite sum ` S ` .  (We will later
         show that the case ` S = 0 ` is impossible, and hence establish
         ~ dchrvmasum .)  (Contributed by Mario Carneiro, 5-May-2016.) $)
      dchrvmasumif $p |- ( ph -> ( x e. RR+ |->
        ( sum_ n e. ( 1 ... ( |_ ` x ) )
            ( ( X ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) +
          if ( S = 0 , ( log ` x ) , 0 ) ) ) e. O(1) ) $=
        ( vt vc caddc cn cv cfv clog cdiv co cmul cmpt c1 cseq cli wbr cfl cmin
        cabs cle cpnf cico wral cc0 wrex wex crp cfz cvma csu wceq cif co1 wcel
        c3 wa dchrvmasumlema adantr wne simprl simprrl simprrr dchrvmasumiflem2
        eqid rexlimdvaa exlimdv mpd ) AUJOUKOULZKUMMUMWNUNUMWNUOUPUQUPURZUSUTZU
        HULZVAVBZCULZVCUMZWPUMWQVDUPVEUMUIULZWSUNUMWSUOUPUQUPVFVBCWAVGVHUPVIZWB
        ZUIVJVGVHUPZVKZUHVLBVMUSBULZVCUMVNUPHULZKUMMUMXGVOUMXGUOUPUQUPHVPFVJVQX
        FUNUMVJVRUJUPURVSVTZACUHEGWOJKLMNOUIPQRSTUAUBUCWOWJZWCAXEXHUHAXCXHUIXDA
        XAXDVTZXCWBZWBBCDEFWQGHXAIJWOKLMNOPQALUKVTXKRWDSTUAAMEVTXKUBWDAMGWEXKUC
        WDUDADXDVTXKUEWDAUJIUSUTZFVAVBXKUFWDAWTXLUMFVDUPVEUMDWSUOUPVFVBCUSVGVHU
        PVIXKUGWDXIAXJXCWFAXJWRXBWGAXJWRXBWHWIWKWLWM $.

      dchrvmaeq0.w $e |- W = { y e. ( D \ { .1. } ) |
        sum_ m e. NN ( ( y ` ( L ` m ) ) / m ) = 0 } $.
      $( The set ` W ` is the collection of all non-principal Dirichlet
         characters such that the sum ` sum_ n e. NN , X ( n ) / n ` is equal
         to zero.  (Contributed by Mario Carneiro, 5-May-2016.) $)
      dchrvmaeq0 $p |- ( ph -> ( X e. W <-> S = 0 ) ) $=
        ( wcel cn cv cfv cdiv co csu cc0 wceq csn wb wne eldifsn sylanbrc fveq1
        cdif oveq1d sumeq2sdv eqeq1d elrab2 baib syl c1 nnuz cz 1z fveq2 fveq2d
        a1i id oveq12d ovex fvmpt adantl wa adantr nnz dchrzrhcl cc nncn divcld
        nnne0 isumclim bitrd ) AMLUIZUJGUKZJULZMULZWNUMUNZGUOZUPUQZEUPUQAMDFURV
        DZUIZWMWSUSAMDUIZMFUTXAUBUCMDFVAVBWMXAWSUJWOBUKZULZWNUMUNZGUOZUPUQWSBMW
        TLXCMUQZXFWRUPXGUJXEWQGXGXDWPWNUMWOXCMVCVEVFVGUHVHVIVJAWREUPAWQEGHVKUJV
        LVKVMUIAVNVQWNUJUIZWNHULWQUQAOWNOUKZJULZMULZXIUMUNWQUJHXIWNUQZXKWPXIWNU
        MXLXJWOMXIWNJVOVPXLVRVSUDWPWNUMVTWAWBAXHWCZWPWNXMWNDIJKMNSPTQAXBXHUBWDX
        HWNVMUIAWNWEWBWFXHWNWGUIAWNWHWBXHWNUPUTAWNWJWBWIUFWKVGWL $.
    $}

    ${
      rpvmasum2.g $e |- G = ( DChr ` N ) $.
      rpvmasum2.d $e |- D = ( Base ` G ) $.
      rpvmasum2.1 $e |- .1. = ( 0g ` G ) $.
      ${
        dchrisum0f.f $e |- F = ( b e. NN |->
          sum_ v e. { q e. NN | q || b } ( X ` ( L ` v ) ) ) $.
        $( Value of the function ` F ` , the divisor sum of a Dirichlet
           character.  (Contributed by Mario Carneiro, 5-May-2016.) $)
        dchrisum0fval $p |- ( A e. NN -> ( F ` A ) =
          sum_ t e. { q e. NN | q || A } ( X ` ( L ` t ) ) ) $=
          ( cv cdivides wbr cn crab cfv wceq breq2 rabbidv sumeq1d fveq2 fveq2d
          csu cbvsumv syl6eq sumex fvmpt ) NDMUBZNUBZUCUDZMUEUFZBUBZIUGZKUGZBUN
          ZUSDUCUDZMUEUFZCUBZIUGZKUGZCUNZUEGUTDUHZVFVHVEBUNVLVMVBVHVEBVMVAVGMUE
          UTDUSUCUIUJUKVHVEVKBCVCVIUHVDVJKVCVIIULUMUOUPUAVHVKCUQUR $.

        dchrisum0f.x $e |- ( ph -> X e. D ) $.
        ${
          dchrisum0fmul.a $e |- ( ph -> A e. NN ) $.
          dchrisum0fmul.b $e |- ( ph -> B e. NN ) $.
          dchrisum0fmul.m $e |- ( ph -> ( A gcd B ) = 1 ) $.
          $( The function ` F ` , the divisor sum of a Dirichlet character, is
             a multiplicative function (but not completely multiplicative).
             Equation 9.4.27 of [Shapiro], p. 382.  (Contributed by Mario
             Carneiro, 5-May-2016.) $)
          dchrisum0fmul $p |- ( ph ->
            ( F ` ( A x. B ) ) = ( ( F ` A ) x. ( F ` B ) ) ) $=
            ( vj vk vi cv cdivides wbr cn crab cfv csu cmul co eqid wcel adantr
            wa cz elrabi nnzd adantl dchrzrhcl anim12i simprl simprr dchrzrhmul
            wceq eqcomd sylan2 fveq2 fsumdvdsmul dchrisum0fval oveq12d nnmulcld
            fveq2d syl 3eqtr4rd ) AMUIZCUJUKZMULUMZUFUIZIUNKUNZUFUOZWBDUJUKZMUL
            UMZUGUIZIUNKUNZUGUOZUPUQWBCDUPUQZUJUKMULUMZUHUIZIUNZKUNZUHUOZCGUNZD
            GUNZUPUQWMGUNZAMWFWKWQWEWJUPUQZIUNZKUNZUHUFUGCDWDWIWNUCUDUEWDURWIUR
            WNURAWEWDUSZVAWEEHIJKLROSPAKEUSZXEUBUTXEWEVBUSZAXEWEWCMWEULVCVDZVEV
            FAWJWIUSZVAWJEHIJKLROSPAXFXIUBUTXIWJVBUSZAXIWJWHMWJULVCVDZVEVFXEXIV
            AAXGXJVAZWFWKUPUQZXDVKXEXGXIXJXHXKVGAXLVAZXDXMXNWEWJEHIJKLROSPAXFXL
            UBUTAXGXJVHAXGXJVIVJVLVMWOXBVKWPXCKWOXBIVNVSVOAWSWGWTWLUPACULUSWSWG
            VKUCABUFCEFGHIJKLMNOPQRSTUAVPVTADULUSWTWLVKUDABUGDEFGHIJKLMNOPQRSTU
            AVPVTVQAWMULUSXAWRVKACDUCUDVRABUHWMEFGHIJKLMNOPQRSTUAVPVTWA $.
        $}

        dchrisum0flb.r $e |- ( ph -> X : ( Base ` Z ) --> RR ) $.
        $( The function ` F ` is a real function.  (Contributed by Mario
           Carneiro, 5-May-2016.) $)
        dchrisum0ff $p |- ( ph -> F : NN --> RR ) $=
          ( vn vm cn cv cdivides wbr crab cfv csu cr wa c1 cfz co cfn wss fzfid
          wcel sgmss adantl ssfi syl2anc cbs wf ad2antrr cz cn0 wfo nnnn0d eqid
          znzrhfo 3syl adantr elrabi nnzd ffvelrn syl2an ffvelrnd fsumrecl cmpt
          fof weq breq2 rabbidv sumeq1d fveq2 fveq2d cbvsumv syl6eq eqtri fmptd
          cbvmptv ) AUBUDKUEZUBUEZUFUGZKUDUHZUCUEZGUIZIUIZUCUJZUKEAWOUDUSZULZWQ
          WTUCXCUMWOUNUOZUPUSWQXDUQZWQUPUSXCUMWOURXBXEAWOKUTVAXDWQVBVCXCWRWQUSZ
          ULJVDUIZUKWSIAXGUKIVEXBXFUAVFXCVGXGGVEZWRVGUSWSXGUSXFAXHXBAHVHUSVGXGG
          VIXHAHOVJXGGHJMXGVKNVLVGXGGWBVMVNXFWRWPKWRUDVOVPVGXGWRGVQVRVSVTELUDWN
          LUEZUFUGZKUDUHZBUEZGUIZIUIZBUJZWAUBUDXAWASLUBUDXOXALUBWCZXOWQXNBUJXAX
          PXKWQXNBXPXJWPKUDXIWOWNUFWDWEWFWQXNWTBUCBUCWCXMWSIXLWRGWGWHWIWJWMWKWL
          $.

        ${
          dchrisum0flblem1.1 $e |- ( ph -> P e. Prime ) $.
          dchrisum0flblem1.2 $e |- ( ph -> A e. NN0 ) $.
          $( Lemma for ~ dchrisum0flb .  Base case, prime power.  (Contributed
             by Mario Carneiro, 5-May-2016.) $)
          dchrisum0flblem1 $p |- ( ph ->
            if ( ( sqr ` ( P ^ A ) ) e. NN , 1 , 0 ) <_ ( F ` ( P ^ A ) ) ) $=
            ( vi vk cexp co csqr cfv cn wcel c1 cc0 cif cfz cv csu cle wbr wceq
            wa cr 1re a1i wn 0re ifclda fzfid cn0 cbs cz wf nnnn0d eqid znzrhfo
            wfo 3syl syl ffvelrnd syl2an adantr breq1 wne nn0uz syl6eleq mpbird
            wb cmul simpr oveq1d 1exp sumeq2dv cc ax-1cn sylancl nncnd breqtrrd
            3eqtrd letrd cmin cdiv oveq1 breq1d resubcl sylancr recnd ad3antrrr
            3eqtr4d cneg neg1cn ad2antrr c2 cpc oveq2d adantl nn0zd syl2anc mpd
            cabs eqtr3d pm2.61dane abscld leabsd eqbrtrd clt fveq2d cmgp ccnfld
            mpbid cmg cress zsubrg cvv syl3anc cnfldexp cmhm mgpbas mhmmulg fof
            cprime prmz elfznn0 reexpcl fsumrecl 1le1 0le1 keephyp chash c0 cuz
            sylibr cfn hashnncl nnge1d elfzelz sylan9eq fsumconst mulid1d caddc
            fzn0 leidd mulid2d nn0p1nn 0expd expp1 prmnn nnexpcld sqsqrd cq nnq
            nnne0 2z pcexp syl121anc pcid 3eqtr3rd pccld 2nn0 expmuld sqneg sq1
            ax-mp eqtri oveq1i syl5eq mulid2i syl6eq negnegd cui dchrn0 dchrabs
            eqtrd biimpa syl5ibcom necon3ad absord ord negeqd 3brtr4d peano2nn0
            eqeq1 mul02d reexpcld absexpd absge0d dchrabs2 exple1 subge0 keepel
            syl31anc ifbothda necomd posdif lemuldiv syl112anc cfzo fzval3 0nn0
            leltned sumeq1d geoserg exp0d cdivides crab dchrisum0fval cmpt wf1o
            fveq2 dvdsppwf1o ovex fvmpt3i elrabi ffvelrn fsumf1o csubmnd csubrg
            oveq2 nnzd subrgsubm mp1i cnfldex zex mgpress mp2an eqcomi submmulg
            crg crh ccrg zncrng crngrng zrhrhm rhmmhm subrgsubg subgbas dchrmhm
            csubg mp2b sseldi ) AECUHUIZUJUKZULUMZUNUOUPZUOCUQUIZEIUKZKUKZUFURZ
            UHUIZUFUSZVVBGUKZUTAVVEVVKUTVAVVHUNAVVHUNVBZVCZVVEUNVVKVVNVVDUNUOVD
            UNVDUMZVVNVVDVCVEVFUOVDUMVVNVVDVGZVCVHVFVIVVOVVNVEVFAVVKVDUMVVMAVVF
            VVJUFAUOCVJZAVVHVDUMZVVIVKUMZVVJVDUMVVIVVFUMZALVLUKZVDVVGKUCAVMVWAE
            IAJVKUMZVMVWAIVRVMVWAIVNZAJQVOZVWAIJLOVWAVPZPVQVMVWAIUUAVSZAEUUBUMZ
            EVMUMZUDEUUCVTZWAZWAZVVICUUDZVVHVVIUUEWBUUFWCVVEUNUTVAZVVNVVDUNUNUT
            VAUOUNUTVAVWMUNUOUNVVEUNUTWDUOVVEUNUTWDUUGUUHUUIVFVVNUNVVFUUJUKZVVK
            UTVVNVWNAVWNULUMZVVMAVWOVVFUUKWEZACUOUULUKZUMVWPACVKVWQUEWFWGUOCUVB
            UUMAVVFUUNUMZVWOVWPWIVVQVVFUUOVTWHWCZUUPVVNVVKVVFUNUFUSZVWNUNWJUIZV
            WNVVNVVFVVJUNUFVVNVVTVVJUNVVIUHUIZUNVVNVVHUNVVIUHAVVMWKWLVVTVVIVMUM
            VXBUNVBVVIUOCUUQVVIWMVTUURWNVVNVWRUNWOUMZVWTVXAVBVVNUOCVJWPVVFUNUFU
            USWQVVNVWNVVNVWNVWSWRUUTWTWSXAAVVHUNWEZVCZVVEUNVVHCUNUVAUIZUHUIZXBU
            IZUNVVHXBUIZXCUIZVVKUTVXEVVEVXIWJUIZVXHUTVAZVVEVXJUTVAZVVDUNVXIWJUI
            ZVXHUTVAUOVXIWJUIZVXHUTVAZVXLVXEUNUOUNVVEVBVXNVXKVXHUTUNVVEVXIWJXDX
            EUOVVEVBVXOVXKVXHUTUOVVEVXIWJXDXEVXEVVDVCZVXIVXIVXNVXHUTVXQVXIVXEVX
            IVDUMZVVDVXEVVOVVRVXRVEAVVRVXDVWKWCZUNVVHXFXGZWCUVCVXQVXIVXEVXIWOUM
            VVDVXEVXIVXTXHZWCUVDVXQVXGVVHUNXBVXQVXGVVHVBVVHUOVXQVVHUOVBZVCZUOVX
            FUHUIUOVXGVVHVYCVXFAVXFULUMZVXDVVDVYBACVKUMZVYDUECUVEVTXIUVFVYCVVHU
            OVXFUHVXQVYBWKZWLVYFXJVXQVVHUOWEZVCZUNXKZVXFUHUIZVYIVXGVVHVXQVYJVYI
            VBVYGVXQVYJVYICUHUIZVYIWJUIZVYIVXQVYIWOUMZVYEVYJVYLVBXLAVYEVXDVVDUE
            XMZVYICUVGXGVXQVYLUNVYIWJUIVYIVXQVYKUNVYIWJVXQVYKVYIXNEVVCXOUIZWJUI
            ZUHUIVYIXNUHUIZVYOUHUIZUNVXQCVYPVYIUHVXQEVVCXNUHUIZXOUIZEVVBXOUIZVY
            PCVXQVYSVVBEXOVXQVVBAVVBWOUMVXDVVDAVVBAECAVWGEULUMUDEUVHVTZUEUVIZWR
            XMUVJXPVXQVWGVVCUVKUMZVVCUOWEZXNVMUMZVYTVYPVBAVWGVXDVVDUDXMZVVDWUDV
            XEVVCUVLXQVVDWUEVXEVVCUVMXQWUFVXQUVNVFVVCEXNUVOUVPVXQVWGCVMUMZWUACV
            BWUGVXQCVYNXRCEUVQXSUVRXPVXQVYIXNVYOVYMVXQXLVFVXQEVVCWUGVXEVVDWKUVS
            ZXNVKUMVXQUVTVFUWAVXQVYRUNVYOUHUIZUNVYQUNVYOUHVYQUNXNUHUIZUNVXCVYQW
            UKVBWPUNUWBUWDUWCUWEUWFVXQVYOVMUMWUJUNVBVXQVYOWUIXRVYOWMVTUWGWTWLVY
            IXLUWHUWIUWNWCVYHVVHVYIVXFUHVYHVVHXKZXKVVHVYIVYHVVHVXEVVHWOUMZVVDVY
            GAWUMVXDAVVHVWKXHZWCZXMUWJVYHWULUNVYHVVHYAUKZWULUNVYHWUPVVHVBZVGZWU
            PWULVBZVYHVXDWURVXEVXDVVDVYGAVXDWKZXMVYHWUQVVHUNVYHWUPUNVBWUQVVMVYH
            VVGDLUWKUKZHJKLRSAKDUMVXDVVDVYGUBXIOWVAVPZVXQVYGVVGWVAUMZAVYGWVCWIV
            XDVVDAVVGVWADWVAHJKLROSVWEWVBUBVWJUWLXMUWOUWMZWUPVVHUNUXCUWPUWQXTVY
            HWUQWUSVYHVVHVXEVVRVVDVYGVXSXMUWRUWSXTWVDYBUWTYBZWLWVEXJYCXPUXAVXEV
            XPVVPVXEVXOUOVXHUTVXEVXIVYAUXDVXEUOVXHUTVAZVXGUNUTVAZVXEVXGVXGYAUKZ
            UNAVXGVDUMZVXDAVVHVXFVWKAVYEVXFVKUMZUECUXBVTZUXEWCZVXEVXGVXEVXGWVLX
            HYDVVOVXEVEVFZVXEVXGWVLYEVXEWVHWUPVXFUHUIZUNUTVXEVVHVXFWUOAWVJVXDWV
            KWCZUXFVXEWUPVDUMUOWUPUTVAWUPUNUTVAZWVJWVNUNUTVAVXEVVHWUOYDZVXEVVHW
            UOUXGAWVPVXDAVVGVWADHJKLRSOVWEUBVWJUXHWCZWVOWUPVXFUXIUXLYFXAVXEVVOW
            VIWVFWVGWIVEWVLUNVXGUXJXGWHYFWCUXMVXEVVEVDUMZVXHVDUMZVXRUOVXIYGVAZV
            XLVXMWIWVSVXEVVDUNUOVDVEVHUXKVFVXEVVOWVIWVTVEWVLUNVXGXFXGVXTVXEVVHU
            NYGVAZWWAVXEWWBUNVVHWEVXEVVHUNWUTUXNVXEVVHUNVXSWVMVXEVVHWUPUNVXSWVQ
            WVMVXEVVHVXSYEWVRXAUYAWHVXEVVRVVOWWBWWAWIVXSVEVVHUNUXOWQYKVVEVXHVXI
            UXPUXQYKVXEVVKUOVXFUXRUIZVVJUFUSVVHUOUHUIZVXGXBUIZVXIXCUIVXJVXEVVFW
            WCVVJUFAVVFWWCVBZVXDAWUHWWFACUEXRUOCUXSVTWCUYBVXEVVHUFUOVXFWUOWUTUO
            VKUMVXEUXTVFAVXFVWQUMVXDAVXFVKVWQWVKWFWGWCUYCVXEWWEVXHVXIXCVXEWWDUN
            VXGXBVXEVVHWUOUYDWLWLWTWSYCAVVLMURVVBUYEVAZMULUYFZUGURZIUKZKUKZUGUS
            ZVVFEVVIUHUIZIUKZKUKZUFUSVVKAVVBULUMVVLWWLVBWUCABUGVVBDFGHIJKLMNOPQ
            RSTUAUYGVTAWWHWWKVVFWWOUGUFNVVFENURZUHUIZUYHZWWMWWIWWMVBWWJWWNKWWIW
            WMIUYJYHVVQAVWGVYEVVFWWHWWRUYIUDUEMCENWWRWWRVPZUYKXSVVTVVIWWRUKWWMV
            BANVVIWWQWWMVVFWWRWWPVVIEUHUYSWWSEWWPUHUYLUYMXQAWWIWWHUMZVCZWWKWXAV
            WAVDWWJKAVWAVDKVNWWTUCWCAVWCWWIVMUMWWJVWAUMWWTVWFWWTWWIWWGMWWIULUYN
            UYTVMVWAWWIIUYOWBWAXHUYPAVVFWWOVVJUFAVVTVCZWWOVVIVVGLYIUKZYLUKZUIZK
            UKZVVIVVHYJYIUKZYLUKZUIZVVJWXBWWNWXEKWXBVVIEYJVMYMUIZYIUKZYLUKZUIZI
            UKZWWNWXEWXBWXMWWMIWXBVVIEWXHUIZWXMWWMWXBVMWXGUYQUKUMZVVSVWHWXOWXMV
            BVMYJUYRUKUMZWXPWXBYNVMYJWXGWXGVPZVUAVUBVVTVVSAVWLXQZAVWHVVTVWIWCZV
            MWXHWXLWXGWXKVVIEWXHVPZWXGVMYMUIZWXKYJYOUMVMYOUMWYBWXKVBVUCVUDVMYJW
            XJWXGYOYOWXJVPZWXRVUEVUFVUGWXLVPZVUHYPAEWOUMVVSWXOWWMVBVVTAEWUBWRVW
            LEVVIYQWBYBYHWXBIWXKWXCYRUIUMZVVSVWHWXNWXEVBAWYEVVTALVUIUMZIWXJLVUJ
            UIUMWYEAVWBLVUKUMWYFVWDJLOVULLVUMVSLIWXJWYCPVUNWXJLIWXKWXCWXKVPZWXC
            VPZVUOVSWCWXSWXTVMWXLWXDIWXKWXCVVIEVMWXJWXKWYGWXQVMYJVUSUKUMVMWXJVL
            UKVBYNVMYJVUPVMYJWXJWYCVUQVUTYSWYDWXDVPZYTYPYBYHWXBKWXCWXGYRUIZUMZV
            VSVVGVWAUMZWXFWXIVBAWYKVVTADWYJKDHJLROSVURUBVVAWCWXSAWYLVVTVWJWCVWA
            WXDWXHKWXCWXGVVIVVGVWALWXCWYHVWEYSWYIWYAYTYPAWUMVVSWXIVVJVBVVTWUNVW
            LVVHVVIYQWBWTWNWTWS $.
        $}

        ${
          dchrisum0flb.1 $e |- ( ph -> A e. ( ZZ>= ` 2 ) ) $.
          dchrisum0flb.2 $e |- ( ph -> P e. Prime ) $.
          dchrisum0flb.3 $e |- ( ph -> P || A ) $.
          dchrisum0flb.4 $e |- ( ph -> A. y e. ( 1 ..^ A )
            if ( ( sqr ` y ) e. NN , 1 , 0 ) <_ ( F ` y ) ) $.
          $( Lemma for ~ dchrisum0flb .  Induction over relatively prime
             factors, with the prime power case handled in dchrisum0flblem1 .
             (Contributed by Mario Carneiro, 5-May-2016.) $)
          dchrisum0flblem2 $p |- ( ph ->
            if ( ( sqr ` A ) e. NN , 1 , 0 ) <_ ( F ` A ) ) $=
            ( csqr cfv cn wcel c1 cc0 cif cpc co cexp cdiv cmul cle breq1 1t1e1
            wbr wa c2 cprime cq wne cz adantr nnq adantl nnne0 2z a1i syl121anc
            wceq pcexp cc cuz clt eluz2b2 simplbi syl nncnd sqsqrd oveq2d simpr
            2cn pccld nn0cnd mulcomd 3eqtr3rd cn0 2nn0 expmuld eqtr3d fveq2d cr
            prmnn nnexpcld nnrpd rprege0d sqrsq eqeltrd iftrue dchrisum0flblem1
            eqtrd eqbrtrrd cdivides pcdvds syl2anc wb nndivdvds nnzd crp sqrdiv
            mpbid nnz znq zsqrelqelz sqrgt0d elnnz nnred syl3anc 1re fveq2 0le1
            nngt0d wi ffvelrnd wn 0re keepel breq2 0le0 keephyp letrd cgcd cfzo
            sylanbrc cv wral nnuz pcelnn mpbird prmuz2 simprbi 3syl expgt1 0lt1
            syl6eleq ltdiv2OLD syl33anc breqtrd elfzo2 syl3anbrc eleq1d breq12d
            div1d ifbid rspcv sylc pm3.2i dchrisum0ff lemul12a mp2and syl5eqbrr
            syl22anc mulge0d ifbothda nnne0d divcan2d pcndvds2 prmz rpexp1i mpd
            coprm dchrisum0fmul breqtrrd ) ADUIUJZUKULZUMUNUOZFFDUPUQZURUQZHUJZ
            DUWFUSUQZHUJZUTUQZDHUJZVAUWCUMUWJVAVDUNUWJVAVDZUWDUWJVAVDAUMUNUMUWD
            UWJVAVBUNUWDUWJVAVBAUWCVEZUMUMUMUTUQZUWJVAVCUWMUMUWGVAVDZUMUWIVAVDZ
            UWNUWJVAVDZUWMUWFUIUJZUKULZUMUNUOZUMUWGVAUWMUWSUWTUMVRUWMUWRFFUWBUP
            UQZURUQZUKUWMUWRUXBVFURUQZUIUJZUXBUWMUWFUXCUIUWMFUXAVFUTUQZURUQUWFU
            XCUWMUXEUWEFURUWMFUWBVFURUQZUPUQZVFUXAUTUQZUWEUXEUWMFVGULZUWBVHULZU
            WBUNVIZVFVJULZUXGUXHVRAUXIUWCUFVKZUWCUXJAUWBVLVMUWCUXKAUWBVNVMUXLUW
            MVOVPUWBFVFVSVQUWMUXFDFUPUWMDADVTULUWCADADVFWAUJZULZDUKULZUEUXOUXPU
            MDWBVDDWCWDWEZWFZVKWGWHUWMVFUXAVFVTULUWMWJVPUWMUXAUWMFUWBUXMAUWCWIW
            KZWLWMWNWHUWMFUXAVFUWMFUWMUXIFUKULZUXMFXAZWEZWFVFWOULUWMWPVPUXSWQWR
            WSUWMUXBWTULUNUXBVAVDVEUXDUXBVRUWMUXBUWMUXBUWMFUXAUYBUXSXBZXCXDUXBX
            EWEXIUYCXFZUWSUMUNXGWEAUWTUWGVAVDUWCACUWEEFGHIJKLMNOPQRSTUAUBUCUDUF
            AFDUFUXQWKZXHZVKXJUWMUWHUIUJZUKULZUMUNUOZUMUWIVAUWMUYHUYIUMVRUWMUYG
            VJULZUNUYGWBVDUYHUWMUWHVJULZUYGVHULUYJAUYKUWCAUWHAUWFDXKVDZUWHUKULZ
            AUXIUXPUYLUFUXQFDXLXMAUXPUWFUKULZUYLUYMXNUXQAFUWEAUXIUXTUFUYAWEZUYE
            XBZDUWFXOXMXSZXPZVKUWMUYGUWBUWRUSUQZVHUWMDWTULZUNDVAVDVEUWFXQULUYGU
            YSVRUWMDUWMDAUXPUWCUXQVKXCXDUWMUWFAUYNUWCUYPVKXCDUWFXRXMUWMUWBVJULZ
            UWSUYSVHULUWCVUAAUWBXTVMUYDUWBUWRYAXMXFUWHYBXMUWMUWHUWMUWHAUYMUWCUY
            QVKXCYCUYGYDUUBUYHUMUNXGWEAUYIUWIVAVDZUWCAUWHUMDUUAUQZULZBUUCZUIUJZ
            UKULZUMUNUOZVUEHUJZVAVDZBVUCUUDVUBAUWHUMWAUJZULDVJULUWHDWBVDVUDAUWH
            UKVUKUYQUUEUUMADUXQXPAUWHDUMUSUQZDWBAUMUWFWBVDZUWHVULWBVDZAFWTULUWE
            UKULZUMFWBVDZVUMAFUYOYEAVUOFDXKVDZUGAUXIUXPVUOVUQXNUFUXQFDUUFXMUUGA
            UXIFUXNULZVUPUFFUUHVURUXTVUPFWCUUIUUJFUWEUUKYFAUMWTULZUWFWTULUYTUNU
            MWBVDZUNUWFWBVDUNDWBVDVUMVUNXNVUSAYGVPAUWFUYPYEADUXQYEVUTAUULVPAUWF
            UYPYJADUXQYJUMUWFDUUNUUOXSADUXRUVAUUPUWHUMDUUQUURUHVUJVUBBUWHVUCVUE
            UWHVRZVUHUYIVUIUWIVAVVAVUGUYHUMUNVVAVUFUYGUKVUEUWHUIYHUUSUVBVUEUWHH
            YHUUTUVCUVDZVKXJUWMVUSUNUMVAVDZVEZUWGWTULZVVDUWIWTULZUWOUWPVEUWQYKV
            VDUWMVUSVVCYGYIUVEVPZAVVEUWCAUKWTUWFHACEGHIJKLMNOPQRSTUAUBUCUDUVFZU
            YPYLZVKVVGAVVFUWCAUKWTUWHHVVHUYQYLZVKUMUWGUMUWIUVGUVJUVHUVIAUWLUWCY
            MAUWGUWIVVIVVJAUNUWTUWGUNWTULAYNVPZUWTWTULAUWSUMUNWTYGYNYOVPVVIUNUW
            TVAVDZAUWSVVCUNUNVAVDZVVLUMUNUMUWTUNVAYPUNUWTUNVAYPYIYQYRVPUYFYSAUN
            UYIUWIVVKUYIWTULAUYHUMUNWTYGYNYOVPVVJUNUYIVAVDZAUYHVVCVVMVVNUMUNUMU
            YIUNVAYPUNUYIUNVAYPYIYQYRVPVVBYSUVKVKUVLAUWFUWHUTUQZHUJUWKUWJAVVODH
            ADUWFUXRAUWFUYPWFAUWFUYPUVMUVNWSACUWFUWHEGHIJKLMNOPQRSTUAUBUCUYPUYQ
            AFUWHYTUQUMVRZUWFUWHYTUQUMVRZAFUWHXKVDYMZVVPAUXIUXPVVRUFUXQFDUVOXMA
            UXIUYKVVRVVPXNUFUYRFUWHUVSXMXSAFVJULZUYKUWEWOULVVPVVQYKAUXIVVSUFFUV
            PWEUYRUYEFUWHUWEUVQYFUVRUVTWRUWA $.
        $}

        ${
          dchrisum0flb.a $e |- ( ph -> A e. NN ) $.
          $( The divisor sum of a real Dirichlet character, is lower bounded by
             zero everywhere and one at the squares.  Equation 9.4.29 of
             [Shapiro], p. 382.  (Contributed by Mario Carneiro,
             5-May-2016.) $)
          dchrisum0flb $p |- ( ph ->
            if ( ( sqr ` A ) e. NN , 1 , 0 ) <_ ( F ` A ) ) $=
            ( vy vk vi vp c1 cfz co wcel csqr cfv cc0 cif cle wbr wral cuz nnuz
            cv cn syl6eleq eluzfz2 wi caddc wceq oveq2 raleqdv imbi2d c2 cprime
            syl cexp 2prm a1i cn0 0nn0 dchrisum0flblem1 elfz1eq numexp0 syl6eqr
            2nn0 fveq2d eleq1d ifbid breq12d biimprcd ralrimiv wa cdivides wrex
            csn adantrr eluzp1p1 df-2 fveq2i syl6eleqr exprmfct ad2antrr cbs cr
            simpr wf adantr simprl simprr cfzo simplrr simplrl dchrisum0flblem2
            nnzd fzval3 mpbid rexlimddv ovex fveq2 ralsn sylibr ancld cun fzsuc
            cz expr ralunb syl6bb sylibrd expcom a2d nnind mpcom rspcv sylc ) A
            CUHCUIUJZUKZUDVAZULUMZVBUKZUHUNUOZYPFUMZUPUQZUDYNURZCULUMZVBUKZUHUN
            UOZCFUMZUPUQZACUHUSUMZUKYOACVBUUHUCUTVCUHCVDVMCVBUKAUUBUCAUUAUDUHUE
            VAZUIUJZURZVEAUUAUDUHUHUIUJZURZVEAUUAUDUHUFVAZUIUJZURZVEAUUAUDUHUUN
            UHVFUJZUIUJZURZVEAUUBVEUEUFCUUIUHVGZUUKUUMAUUTUUAUDUUJUULUUIUHUHUIV
            HVIVJUUIUUNVGZUUKUUPAUVAUUAUDUUJUUOUUIUUNUHUIVHVIVJUUIUUQVGZUUKUUSA
            UVBUUAUDUUJUURUUIUUQUHUIVHVIVJUUICVGZUUKUUBAUVCUUAUDUUJYNUUICUHUIVH
            VIVJAVKUNVNUJZULUMZVBUKZUHUNUOZUVDFUMZUPUQZUUMABUNDVKEFGHIJKLMNOPQR
            STUAUBVKVLUKAVOVPUNVQUKAVRVPVSUVIUUAUDUULYPUULUKZUUAUVIUVJYSUVGYTUV
            HUPUVJYRUVFUHUNUVJYQUVEVBUVJYPUVDULUVJYPUHUVDYPUHVTVKWCWAWBZWDWEWFU
            VJYPUVDFUVKWDWGWHWIVMUUNVBUKZAUUPUUSAUVLUUPUUSVEAUVLWJZUUPUUPUUAUDU
            UQWMZURZWJZUUSUVMUUPUVOAUVLUUPUVOAUVLUUPWJZWJZUUQULUMZVBUKZUHUNUOZU
            UQFUMZUPUQZUVOUVRUGVAZUUQWKUQZUWCUGVLUVRUUQVKUSUMZUKZUWEUGVLWLUVRUU
            QUHUHVFUJZUSUMZUWFUVRUUNUUHUKZUUQUWIUKAUVLUWJUUPUVMUUNVBUUHAUVLXCUT
            VCZWNUHUUNWOVMVKUWHUSWPWQWRZUUQUGWSVMUVRUWDVLUKZUWEWJZWJZUDBUUQDUWD
            EFGHIJKLMNOAIVBUKUVQUWNPWTQRSTAJDUKUVQUWNUAWTAKXAUMXBJXDUVQUWNUBWTU
            VRUWGUWNUWLXEUVRUWMUWEXFUVRUWMUWEXGUWOUUPUUAUDUHUUQXHUJZURAUVLUUPUW
            NXIUWOUUAUDUUOUWPUWOUUNYCUKUUOUWPVGUWOUUNAUVLUUPUWNXJXLUHUUNXMVMVIX
            NXKXOUUAUWCUDUUQUUNUHVFXPYPUUQVGZYSUWAYTUWBUPUWQYRUVTUHUNUWQYQUVSVB
            YPUUQULXQWEWFYPUUQFXQWGXRXSYDXTUVMUUSUUAUDUUOUVNYAZURUVPUVMUUAUDUUR
            UWRUVMUWJUURUWRVGUWKUHUUNYBVMVIUUAUDUUOUVNYEYFYGYHYIYJYKUUAUUGUDCYN
            YPCVGZYSUUEYTUUFUPUWSYRUUDUHUNUWSYQUUCVBYPCULXQWEWFYPCFXQWGYLYM $.
        $}

        dchrisum0fno1.a $e |- ( ph -> ( x e. RR+ |->
      sum_ k e. ( 1 ... ( |_ ` x ) ) ( ( F ` k ) / ( sqr ` k ) ) ) e. O(1) ) $.
        $( The sum ` sum_ k <_ x , F ( x ) / sqr k ` is divergent (i.e. not
           eventually bounded).  Equation 9.4.30 of [Shapiro], p. 383.
           (Contributed by Mario Carneiro, 5-May-2016.) $)
        dchrisum0fno1 $p |- -. ph $=
          ( vi vm crp cv clog cfv cmpt co1 wcel logno1 c2 cdiv co wa cr relogcl
          cmul adantl recnd cc 2cn a1i cc0 wne divcan2d mpteq2dva rehalfcld wss
          2ne0 rpssre o1const mp2an cfl cfz csqr csu cvv 1re sumex cle wbr cabs
          c1 adantrr clt ad2antrl simprr wb 1rp simprl logleb sylancr syl5eqbrr
          log1 mpbid 2pos divge0 syl22anc absidd fzfid cn wf dchrisum0ff adantr
          2re elfznn ffvelrn syl2an nnrpd rpsqrcld rerpdivcld fsumrecl wceq syl
          abscld eqbrtrrd cexp rprege0d sqrsq eqeltrd fveq2 oveq1d oveq2d rpred
          sumeq2dv fznnfl simplbda syl2anc sqsqrd oveq1 eqeltrrd eqtrd ad2antrr
          mpbir2and wn letrd nnrecred logsqr rpsqrcl harmoniclbnd cif wrex eqid
          crn ovex elrnmpti eleq1d syl5ibrcom rexlimdva syl5bi imp wf1o nnsqcld
          iftrue wf1 le2sq breqtrd ex sq11 dom2lem f1f1orn fvmpt3i f1f frn 3syl
          sselda 0re keepel rerpdivcl syldan fsumf1o cdif eldif nncnd elrnmpt1s
          wi sqrle expr impr sylan2b iffalse eldifi sylan2 rpcnne0d div0 fsumss
          con3d 3eqtr3d dchrisum0flb lediv1dd fsumle leabsd eqbrtrd o1le o1mul2
          cbs mto ) ABUGBUHZUIUJZUKZULUMBUNABUGUOUXCUOUPUQZVAUQZUKUXDULABUGUXFU
          XCAUXBUGUMZURZUXCUOUXHUXCUXGUXCUSUMZAUXBUTZVBZVCUOVDUMZUXHVEVFZUOVGVH
          UXHVMVFVIVJABUGUOUXEVDUXMUXHUXEUXHUXCUXKVKZVCZBUGUOUKULUMZAUGUSVLUXLU
          XPVNVEBUGUOVOVPVFABUGWGUXBVQUJZVRUQZFUHZGUJZUXSVSUJZUPUQZFVTZUXEWGWAW
          GUSUMAWBVFUDUYCWAUMUXHUXRUYBFWCVFUXOAUXGWGUXBWDWEZURZURZUXEWFUJUXEUYC
          WFUJZWDUYFUXEAUXGUXEUSUMUYDUXNWHZUYFUXIVGUXCWDWEUOUSUMZVGUOWIWEZVGUXE
          WDWEUXGUXIAUYDUXJWJUYFVGWGUIUJZUXCWDWRUYFUYDUYKUXCWDWEZAUXGUYDWKUYFWG
          UGUMUXGUYDUYLWLWMAUXGUYDWNZWGUXBWOWPWSWQUYIUYFXIVFUYJUYFWTVFUXCUOXAXB
          XCUYFUXEUYCUYGUYHUYFUXRUYBFUYFWGUXQXDZUYFUXSUXRUMZURZUXTUYAUYFXEUSGXF
          ZUXSXEUMZUXTUSUMUYOAUYQUYEACDEGHIJKLMNOPQRSTUAUBUCXGXHUXSUXQXJZXEUSUX
          SGXKXLZUYPUXSUYPUXSUYOUYRUYFUYSVBZXMXNZXOZXPZUYFUYCUYFUYCVUDVCXSUYFUX
          EWGUXBVSUJZVQUJZVRUQZWGUEUHZUPUQZUEVTZUYCUYHUYFVUGVUIUEUYFWGVUFXDZUYF
          VUHVUGUMZURZVUHVULVUHXEUMUYFVUHVUFXJZVBZUUAXPVUDUYFVUEUIUJZUXEVUJWDUX
          GVUPUXEXQAUYDUXBUUBWJUYFVUEUGUMZVUPVUJWDWEUXGVUQAUYDUXBUUCWJZVUEUEUUD
          XRXTUYFUXRUYAXEUMZWGVGUUEZUYAUPUQZFVTZVUJUYCWDUYFUFVUGUFUHZUOYAUQZUKZ
          UUHZVVAFVTZVUGWGVUHUOYAUQZVSUJZUPUQZUEVTZVVBVUJUYFVVGVVFWGUYAUPUQZFVT
          VVKUYFVVFVVAVVLFUYFUXSVVFUMZURZVUTWGUYAUPVVNVUSVUTWGXQUYFVVMVUSVVMUXS
          VVDXQZUFVUGUUFUYFVUSUFVUGVVDUXSVVEVVEUUGZVVCUOYAUUIZUUJUYFVVOVUSUFVUG
          UYFVVCVUGUMZURZVUSVVOVVDVSUJZXEUMVVSVVTVVCXEVVSVVCUSUMVGVVCWDWEURZVVT
          VVCXQVVSVVCVVSVVCVVRVVCXEUMZUYFVVCVUFXJZVBZXMYBZVVCYCXRVWDYDVVOUYAVVT
          XEUXSVVDVSYEUUKUULUUMUUNUUOVUSWGVGUURXRYFZYIUYFVVFVVLVUGVVJFUEVVEVVHU
          XSVVHXQUYAVVIWGUPUXSVVHVSYEYGVUKUYFVUGUXRVVEUUSZVUGVVFVVEUUPUYFUFUEVU
          GUXRVVDVVHUYFVVRVVDUXRUMZVVSVWHVVDXEUMZVVDUXBWDWEZVVSVVCVWDUUQVVSVVDV
          UEUOYAUQZUXBWDVVSVVCVUEWDWEZVVDVWKWDWEZUYFVVRVWBVWLUYFVUEUSUMZVVRVWBV
          WLURWLUYFVUEVURYHVVCVUEYJXRYKVVSVWAVWNVGVUEWDWEURVWLVWMWLVWEVVSVUEUYF
          VUQVVRVURXHYBVVCVUEUUTYLWSVVSUXBVVSUXBUYFUXBUSUMZVVRUYFUXBUYMYHZXHZVC
          YMUVAVVSVWOVWHVWIVWJURWLVWQVVDUXBYJXRYRUVBVVRVULURVVDVVHXQVVCVUHXQWLZ
          UVTUYFVVRVWAVUHUSUMVGVUHWDWEURZVWRVULVVRVVCVVRVVCVWCXMYBVULVUHVULVUHV
          UNXMYBVVCVUHUVCXLVFUVDZVUGUXRVVEUVEXRVULVUHVVEUJVVHXQUYFUFVUHVVDVVHVU
          GVVEVVCVUHUOYAYNVVPVVQUVFVBVVNVVAVVLVDVWFUYFVVMUYOVVAVDUMUYFVVFUXRUXS
          UYFVWGVUGUXRVVEXFVVFUXRVLVWTVUGUXRVVEUVGVUGUXRVVEUVHUVIZUVJUYPVVAUYPV
          UTUSUMZUYAUGUMZVVAUSUMVUSWGVGUSWBUVKUVLZVUBVUTUYAUVMWPZVCUVNZYOUVOYPU
          YFVVFUXRVVAFVXAVXFUYFUXSUXRVVFUVPUMZURZVVAVGUYAUPUQZVGVXHVUTVGUYAUPVX
          HVUSYSZVUTVGXQVXGUYFUYOVVMYSZURVXJUXSUXRVVFUVQUYFUYOVXKVXJUYPVUSVVMUY
          FUYOVUSVVMUYFUYOVUSURZURZUYAUOYAUQZUXSVVFVXMUXSVXMUXSUYOUYRUYFVUSUYSW
          JZUVRYMZVXMUYAVUGUMZVXNXEUMVXNVVFUMVXMVXQVUSUYAVUEWDWEZUYFUYOVUSWKVXM
          UXSUXBWDWEZVXRUYFUYOVXSVUSUYFUYOUYRVXSUYFVWOUYOUYRVXSURWLVWPUXSUXBYJX
          RYKWHVXMUXSUSUMVGUXSWDWEURVWOVGUXBWDWEURVXSVXRWLVXMUXSVXMUXSVXOXMYBVX
          MUXBUYFUXGVXLUYMXHYBUXSUXBUWAYLWSVXMVWNVXQVUSVXRURWLVXMVUEUYFVUQVXLVU
          RXHYHUYAVUEYJXRYRVXMVXNUXSXEVXPVXOYDUFVUGVVDVXNUYAVVEXEVVPVVCUYAUOYAY
          NUVSYLYOUWBUWKUWCUWDVUSWGVGUWEXRYFVXHUYAVDUMUYAVGVHURVXIVGXQVXHUYAVXG
          UYFUYOVXCUXSUXRVVFUWFVUBUWGUWHUYAUWIXRYPUYNUWJUYFVUGVVJVUIUEVUMVVIVUH
          WGUPVUMVWSVVIVUHXQVUMVUHVUMVUHVUOXMYBVUHYCXRYGYIUWLUYFUXRVVAUYBFUYNVX
          EVUCUYPVUTUXTUYAVXBUYPVXDVFUYTVUBUYPCUXSDEGHIJKLMNOPAJXEUMUYEUYOQYQRS
          TUAAKDUMUYEUYOUBYQALUWTUJUSKXFUYEUYOUCYQVUAUWMUWNUWOXTYTUYFUYCVUDUWPY
          TUWQUWRUWSYOUXA $.
      $}

      rpvmasum2.w $e |- W = { y e. ( D \ { .1. } ) |
        sum_ m e. NN ( ( y ` ( L ` m ) ) / m ) = 0 } $.
      ${
        $d n A $.
        rpvmasum2.u $e |- U = ( Unit ` Z ) $.
        rpvmasum2.b $e |- ( ph -> A e. U ) $.
        rpvmasum2.t $e |- T = ( `' L " { A } ) $.
        rpvmasum2.z1 $e |- ( ( ph /\ f e. W ) -> A = ( 1r ` Z ) ) $.
        $( A partial result along the lines of ~ rpvmasum .  The sum of the von
           Mangoldt function over those integers ` n == A ` (mod ` N ` ) is
           asymptotic to ` ( 1 - M ) ( log x / phi ( x ) ) + O(1) ` , where
           ` M ` is the number of non-principal Dirichlet characters with
           ` sum_ n e. NN , X ( n ) / n = 0 ` .  Our goal is to show this set
           is empty.  Equation 9.4.3 of [Shapiro], p. 375.  (Contributed by
           Mario Carneiro, 5-May-2016.) $)
        rpvmasum2 $p |- ( ph -> ( x e. RR+ |-> ( ( ( phi ` N ) x.
      sum_ n e. ( ( 1 ... ( |_ ` x ) ) i^i T ) ( ( Lam ` n ) / n ) ) -
            ( ( log ` x ) x. ( 1 - ( # ` W ) ) ) ) ) e. O(1) ) $=
          ( va vt vc crp cv cfv ccj c1 cfl cdiv cmul csu wceq wcel cneg cc0 cif
          co cmin cmpt cin co1 wa cn cfn adantr syl fzfid simpr sseldi ffvelrnd
          cc cjcld adantlr wf cz cn0 syl2an anasss adantl recnd mulcld anass1rs
          cr fsumcl ax-1cn neg1cn 0cn keepel mulcl sylancl subdid fsummulc2 a1i
          eqid oveq2 ifsb fveq1 ad2antrr sylan9eqr fveq2d syl6eq oveq1d ifeq1da
          cmgp ccnfld rngidval eqtrd mul01d syl5eq oveq2d oveq12d sumeq2dv ssfi
          wss syldan wral wo sumss2 syl21anc wb csn oveq1 3eqtr3d eqtr3d 3eqtrd
          olcd caddc mulid1d eqeltrd negeq mpteq2dva an32s cvma clog cphi chash
          cfz dchrfi cbs unitss adantrl wfo nnnn0d znzrhfo 3syl elfzelz ffvelrn
          dchrf elfznn vmacl nndivred adantrr relogcl fsumsub mul12d dchr1 cjre
          fof 1re ax-mp 1t1e1 wn wne df-ne cur simplll cmhm dchrmhm cnfld1 mhm0
          sylan mulid2i ifeq2d sylan2br inss1 phicld nncnd sselda cuz ralrimiva
          ifeq2da elin baib ccnv cima eleq2i wfn ffn baibd syl5bb bitr2d mul02d
          fniniseg ifbieq2d fsummulc1 sum2dchr w3a mulass mul12 syl3anc syl5eqr
          fsumcom cdif cabel cgrp dchrabl ablgrp grpidcl iftrue syl2anc eldifsn
          4syl sumsn ifnefalse ad2antll neg0 syl6eqr mulneg2 sylan2b diffi crab
          fsumneg ssrab2 eqsstri difss fsumconst ralrimivw hashcl nn0cnd negeqd
          sstri negsubd c0 disjdif undif2 snssd ssequn1 sylib syl5req fsumsplit
          cun 3eqtr4rd 3eqtr4d rpssre subcld o1const sylancr sumeq2sdv sylan9eq
          rpvmasumlem mulcom ifeq12d 3eqtr4g ifcl subnegd cseq cli wbr cabs cle
          mulm1d cpnf cico wrex wex simplr dchrmusumlema simprl simprrl simprrr
          dchrvmaeq0 mpteq2dv dchrvmasumif rexlimdvaa exlimdv pm2.61dane o1mul2
          ifbi mpd fsumo1 eqeltrrd ) ABUKEDIULZUMZUNUMZUOBULZUPUMZUUEVEZKULZMUM
          ZVWJUMZVWPUUAUMZVWPUQVEZURVEZKUSZVWMUUBUMZVWJHUTZUOVWJOVAZUOVBZVCVDZV
          DZURVEZVFVEZURVEZIUSZVGBUKNUUCUMZVWOFVHZVWTKUSURVEZVXCUOOUUDUMZVFVEUR
          VEZVFVEZVGVIABUKVXLVXRAVWMUKVAZVJZEVWOVWLVXAURVEZKUSZVXIVFVEZIUSEVYBI
          USZEVXIIUSZVFVEVXLVXRVXTEVYBVXIIVXTNVKVAZEVLVAZAVYFVXSSVMZELNTUAUUFZV
          NZVXTVWJEVAZVJZVWOVYAKVYLUOVWNVOZVXTVWPVWOVAZVYKVYAVSVAVXTVYNVYKVJVJZ
          VWLVXAVXTVYKVWLVSVAZVYNAVYKVYPVXSAVYKVJZVWKVYQPUUGUMZVSDVWJVYQVYRELNV
          WJPTQUAVYRXBZAVYKVPUUPZADVYRVAVYKAGVYRDVYRPGVYSUDUUHUEVQVMVRZVTZWAZUU
          IVYOVWRVWTVXTVYNVYKVWRVSVAZVXTVYNVJZVYKVJZVYRVSVWQVWJVXTVYKVYRVSVWJWB
          ZVYNAVYKWUGVXSVYTWAWAWUEVWQVYRVAZVYKVXTWCVYRMWBZVWPWCVAZWUHVYNAWUIVXS
          ANWDVAWCVYRMUUJWUIANSUUKVYRMNPQVYSRUULWCVYRMUVFUUMVMZVWPUOVWNUUNZWCVY
          RVWPMUUOWEZVMVRZWFVXTVYNVWTVSVAZVYKWUEVWTWUEVWSVWPWUEVWPVKVAZVWSWKVAV
          YNWUPVXTVWPVWNUUQWGZVWPUURVNWUQUUSWHZUUTWIZWIZWJWLVYLVXCVSVAZVXHVSVAZ
          VXIVSVAVXTWVAVYKVXTVXCVXSVXCWKVAAVWMUVAZWGWHZVMZVXDUOVXGVSWMVXEVXFVCV
          SWNWOWPWPZVXCVXHWQWRZUVBVXTEVXKVYCIVYLVXKVWLVXBURVEZVWLVXIURVEZVFVEVY
          CVYLVWLVXBVXIWUCVYLVWOVXAKVYMVXTVYNVYKVXAVSVAWUSWJZWLZWVGWSVYLWVHVYBW
          VIVXIVFVYLVWOVXAVWLKVYMWUCWVJWTVYLWVIVXCVWLVXHURVEZURVEVXIVYLVWLVXCVX
          HWUCWVEWVBVYLWVFXAUVCVYLWVLVXHVXCURVYLWVLVXDVWLUOURVEZVWLVXGURVEZVDZV
          XHVXDUOVXGWVLWVMWVNVXHUOVWLURXCVXHVXGVWLURXCXDVYLWVOVXDUOWVNVDVXHVYLV
          XDWVMUOWVNVYLVXDVJZWVMUOUOURVEUOWVPVWLUOUOURWVPVWLUOUNUMZUOWVPVWKUOUN
          VXDVYLVWKDHUMUODVWJHXEVYLDGHLNPTQUBUDAVYFVXSVYKSXFADGVAZVXSVYKUEXFUVD
          XGXHUOWKVAWVQUOUTUVGUOUVEUVHZXIXJUVIXIXKVYLVXDWVNVXGUOVXDUVJVYLVWJHUV
          KZWVNVXGUTVWJHUVLVYLWVTVJZWVNVXEVWLVXFURVEZVWLVCURVEZVDZVXGVXEVXFVCWV
          NWWBWWCVXGVXFVWLURXCVXGVCVWLURXCXDWWAWWDVXEVXFWWCVDVXGWWAVXEWWBVXFWWC
          WWAVXEVJZWWBUOVXFURVEVXFWWEVWLUOVXFURWWEVWLWVQUOWWEVWKUOUNWWEVWKPUVMU
          MZVWJUMZUOWWAAVXEVWKWWGUTAVXSVYKWVTUVNAVXEVJDWWFVWJUGXHUVSVYLWWGUOUTZ
          WVTVXEVYLVWJPXLUMZXMXLUMZUVOVEZVAWWHVYLEWWKVWJELNPTQUAUVPVXTVYKVPVQWW
          IWWJVWJUOWWFPWWFWWIWWIXBWWFXBXNXMUOWWJWWJXBUVQXNUVRVNXFXOXHWVSXIXJVXF
          WNUVTXIXKWWAVXEWWCVCVXFWWAVWLVYLVYPWVTWUCVMXPUWAXOXQUWBUWIXOXQXRXOXSX
          OXTVXTVXOVYDVXQVYEVFVXTVXOVWOEVYAIUSZKUSZVYDVXTVXOVXNVXMVWTURVEZKUSZV
          WOVWPVXNVAZWWNVCVDZKUSZWWMVXTVXNVWTVXMKVXTVWOVLVAZVXNVWOYBZVXNVLVAVXT
          UOVWNVOZVWOFUWCZVWOVXNYAWRVXTVXMVXTNVYHUWDUWEZVXTWWPVYNWUOVXTVXNVWOVW
          PWWTVXTWXBXAZUWFZWURYCWTVXTWWTWWNVSVAZKVXNYDVWOUOUWGUMZYBZWWSYEWWOWWR
          UTWXDVXTWXFKVXNVXTWWPVYNWXFWXEWUEVXMVWTVXTVXMVSVAVYNWXCVMWURWIYCUWHVX
          TWWSWXHWXAYNVXNVWOWWNKUOYFYGVXTVWOWWQWWLKWUEVWQDUTZWWNVCVWTURVEZVDZWW
          QWWLWUEWXIWWPWXJVCWWNWUEWWPVWPFVAZWXIVYNWWPWXLYHVXTWWPVYNWXLVWPVWOFUW
          JUWKWGWXLVWPMUWLDYIUWMZVAZWUEWXIFWXMVWPUFUWNVXTMWCUWOZWUJWXNWXIYHVYNV
          XTWUIWXOWUKWCVYRMUWPVNWULWXOWXNWUJWXIWCDVWPMUXAUWQWEUWRUWSWUEVWTWURUW
          TUXBWUEWXKWXIVXMVCVDZVWTURVEZWWLWXIVXMVCWXQWWNWXJWXPVXMVWTURYJWXPVCVW
          TURYJXDWUEEVWRVWLURVEZIUSZVWTURVEEWXRVWTURVEZIUSWXQWWLWUEEWXRVWTIWUEV
          YFVYGAVYFVXSVYNSXFZVYIVNWURWUFVWRVWLWUNVXTVYKVYPVYNWUCWAZWIUXCWUEWXSW
          XPVWTURWUEIVWQVYRDEGLNPTUAQVYSUDWYAWUMAWVRVXSVYNUEXFUXDXJWUEEWXTVYAIW
          UFWUDVYPWUOWXTVYAUTWUNWYBWUEWUOVYKWURVMWUDVYPWUOUXEWXTVWRVWLVWTURVEUR
          VEVYAVWRVWLVWTUXFVWRVWLVWTUXGXOUXHXTYKUXIYLXTYMVXTVWOEVYAKIWXAVYJWUTU
          XJXOVXTHYIZVXIIUSZEWYCUXKZVXIIUSZYOVEZVXCUOURVEZVXCVXPURVEZVFVEZVYEVX
          QVXTWYGWYHWYIVBZYOVEWYJVXTWYDWYHWYFWYKYOVXTHEVAZWYHVSVAWYDWYHUTVXTVYF
          LUXLVALUXMVAWYLVYHLNTUXNLUXOELHUAUBUXPUXTZVXTWYHVXCVSVXTVXCWVDYPWVDYQ
          ZVXIWYHIHEVXDVXHUOVXCURVXDUOVXGUXQXRZUYAUXRVXTWYFWYEVXCVXEUOVCVDZURVE
          ZVBZIUSWYEWYQIUSZVBWYKVXTWYEVXIWYRIVWJWYEVAZVXTVYKWVTVJZVXIWYRUTVWJEH
          UXSVXTXUAVJZVXIVXCWYPVBZURVEZWYRXUBVXHXUCVXCURXUBVXHVXGXUCWVTVXHVXGUT
          VXTVYKVWJHUOVXGUYBZUYCVXEUOVCXUCVXFVCWYPUOYRWYPVCUTXUCVCVBZVCWYPVCYRU
          YDXIXDUYEXRXUBWVAWYPVSVAZXUDWYRUTVXTWVAXUAWVDVMVXEUOVCVSWMWOWPZVXCWYP
          UYFWRXOUYGXTVXTWYEWYQIVXTVYGWYEVLVAZVYJEWYCUYHVNZVXTWYTVJZWVAXUGWYQVS
          VAVXTWVAWYTWVDVMXUHVXCWYPWQWRUYJVXTWYSWYIVXTVXCWYEWYPIUSZURVEWYSWYIVX
          TWYEWYPVXCIXUJWVDXUGXUKXUHXAWTVXTXULVXPVXCURVXTOUOIUSZVXPUOURVEZXULVX
          PVXTOVLVAZUOVSVAZXUMXUNUTVXTVYGOEYBXUOVYJOWYEEOVKJULZMUMCULZUMXUQUQVE
          JUSVCUTZCWYEUYIWYEUCXUSCWYEUYKUYLZEWYCUYMUYSEOYAWRZWMOUOIUYNWRVXTOWYE
          YBZXUPIOYDWYEWXGYBZXUIYEXUMXULUTXVBVXTXUTXAVXTXUPIOXUPVXTWMXAZUYOVXTX
          UIXVCXUJYNOWYEUOIUOYFYGVXTVXPVXTVXPVXTXUOVXPWDVAXVAOUYPVNUYQZYPYKXRYL
          UYRYMXSVXTWYHWYIWYNVXTVXCVXPWVDXVEWIUYTXOVXTWYCWYEVXIEIWYCWYEVHVUAUTV
          XTWYCEVUBXAVXTWYCWYEVUIWYCEVUIZEWYCEVUCVXTWYCEYBXVFEUTVXTHEWYMVUDWYCE
          VUEVUFVUGVYJWVGVUHVXTVXCUOVXPWVDXVDXVEWSVUJXSVUKYSABUKEVXKIVSUKWKYBZA
          VULXAAVYFVYGSVYIVNAVXSVYKVXKVSVAVYLVWLVXJVYLVWKAVYKVWKVSVAVXSWUAWAVTV
          YLVXBVXIWVKWVGVUMZWIWFVYQBUKVWLVXJVSVYQVYPVXSWUBVMAVXSVYKVXJVSVAXVHYT
          VYQXVGVYPBUKVWLVGVIVAVULWUBBUKVWLVUNVUOVYQBUKVXJVGZVIVAVWJHVYQVXDVJZX
          VIBUKVWOVWQHUMZVWTURVEZKUSZVXCVFVEZVGZVIXVJBUKVXJXVNXVJVXSVXJXVMWYHVF
          VEZXVNVXDVXJXVPUTVYQVXDVXBXVMVXIWYHVFVXDVWOVXAXVLKVXDVWRXVKVWTURVWQVW
          JHXEXJVUPWYOXSWGVXSWYHVXCXVMVFVXSVXCVXSVXCWVCWHYPXRVUQYSAXVOVIVAVYKVX
          DABEHKLMNPQRSTUAUBVURXFYQVYQWVTVJZXVIBUKVXBVXEVXCVCVDZYOVEZVGZVIXVQBU
          KVXJXVSVYQVXSWVTVXJXVSUTWVTVYQVXSVJZVXJVXBVXCVXGURVEZVFVEZXVSWVTVXIXW
          BVXBVFWVTVXHVXGVXCURXUEXRXRXWAXWCVXBXVRVBZVFVEXVSXWAXWBXWDVXBVFXWAVXE
          VXCVXFURVEZVXCVCURVEZVDVXEVXCVBZVCVDXWBXWDXWAVXEXWEXWGXWFVCXWAXWEVXFV
          XCURVEZXWGXWAWVAVXFVSVAXWEXWHUTAVXSWVAVYKWVDWAZWNVXCVXFVUSWRXWAVXCXWI
          VVIXOXWAVXCXWIXPVUTVXEVXFVCXWBXWEXWFVXGVXFVXCURXCVXGVCVXCURXCXDVXEVXC
          VCXWDXWGVCXVRVXCYRXVRVCUTXWDXUFVCXVRVCYRUYDXIXDVVAXRXWAVXBXVRAVXSVYKV
          XBVSVAWVKYTXWAWVAVCVSVAXVRVSVAXWIWOVXEVXCVCVSVVBWRVVCXOXGYTYSXVQYOUHV
          KUHULZMUMVWJUMXWJUQVEVGZUOVVDZUIULZVVEVVFZXURUPUMXWLUMXWMVFVEVVGUMUJU
          LZXURUQVEVVHVVFCUOVVJVVKVEYDZVJZUJVCVVJVVKVEZVVLZUIVVMXVTVIVAZXVQCUIE
          HXWKLMNVWJPUHUJQRAVYFVYKWVTSXFTUAUBAVYKWVTVVNZVYQWVTVPXWKXBZVVOXVQXWS
          XWTUIXVQXWQXWTUJXWRXVQXWOXWRVAZXWQVJZVJZXVTBUKVXBXWMVCUTZVXCVCVDZYOVE
          ZVGZVIXXEVXEXXFYHZXVTXXIUTXXECXWOEXWMHJXWKLMNOVWJPUHQRVYQVYFWVTXXDAVY
          FVYKSVMXFZTUAUBXVQVYKXXDXXAVMZVYQWVTXXDVVNZXXBXVQXXCXWQVVPZXVQXXCXWNX
          WPVVQZXVQXXCXWNXWPVVRZUCVVSXXJBUKXVSXXHXXJXVRXXGVXBYOVXEXXFVXCVCVWFXR
          VVTVNXXEBCXWOEXWMHKXWKLMNVWJPUHQRXXKTUAUBXXLXXMXXBXXNXXOXXPVWAYQVWBVW
          CVWGYQVWDVWEVWHVWI $.
      $}

      dchrisum0.b $e |- ( ph -> X e. W ) $.
      $( Suppose ` X ` is a non-principal Dirichlet character with
         ` sum_ n e. NN , X ( n ) / n = 0 ` .  Then ` X ` is a real character.
         Part of Lemma 9.4.4 of [Shapiro], p. 382.  (Contributed by Mario
         Carneiro, 5-May-2016.) $)
      dchrisum0re $p |- ( ph -> X : ( Base ` Z ) --> RR ) $=
        ( wcel vx vn vf vk va vt vc cbs cfv wfn cv cr wral wf cc eqid cdif cdiv
        csn cn co csu cc0 wceq crab ssrab2 eqsstri sseldi eldifad syl ffvelrnda
        dchrf wa ccj fvco3 crp clog cmpt co1 wne c1 cfl cfz cmul chash cmin 1re
        a1i cn0 nnnn0d adantr nn0red cfn wss fzfid ssfi sylancl elfznn remulcld
        adantl sylancr resubcld recnd cle wbr caddc ad2ant2r c2 2re ad2antrr wb
        cabs simprl mpbid syl2anc mpbird sylanbrc nnuz weq fveq2 fveq2d oveq12d
        cz id fvmpt oveq2d syl2an oveq1d cjcld divcld eqeltrd cseq cli cvv cpnf
        cico fsumser nnred letrd absidd ffn ccom sylan wn logno1 cphi ccnv cima
        cur cin cvma cui ccrg zncrng crngrng 1unit eqidd rpvmasum2 phicld inss1
        sseli sylan2 vmacl nndivre mpancom fsumrecl relogcl dchrfi difss hashcl
        crg sstri resubcl adantlr ad2antrl readdcld 0re simprr logleb syl5eqbrr
        log1 1rp cpr simplr cminusg dchrinv cgrp cabel ablgrp grpinvcl eqeltrrd
        dchrabl eldifsni grpidcl grpinv11 necon3bid grpinvid 3netr3d eldifsn 1z
        fvex nnre cjred wfo znzrhfo fof nnz ffvelrn ffvelrnd nncn nnne0 3eqtr4d
        cjdivd wrex dchrmusumlema simprrl simprrr dchrvmaeq0 breqtrd rexlimdvaa
        eqtrd wex exlimdv mpd seqex ovex serf simpl cuz simpr syl6eleq 3eqtr3rd
        fsumcj climcj cj0 syl6breq isumclim fveq1 sumeq2sdv eqeq1d hashprg cdom
        elrab2 ssdomg sylc hashdomi eqbrtrrd suble0 lemul2ad df-2 oveq1i ax-1cn
        prssi addsubassd syl5eq adantrr adddid mulid1d 3eqtrd mul01d clt vmage0
        3brtr3d nn0ge0d nngt0d divge0 syl22anc fsumge0 mulge0d leaddsub syl3anc
        3brtr4d o1le ex necon1bd mpi fveq1d eqtr3d cjrebd ralrimiva ffnfv ) AJK
        UHUIZUJZUAUKZJUIZULTZUAVWBUMVWBULJUNAVWBUOJUNZVWCAVWBCFHJKOLPVWBUPZAJCD
        USZAICVWIUQZJIUTEUKZGUIZBUKZUIZVWKURVAZEVBZVCVDZBVWJVEVWJRVWQBVWJVFVGZS
        VHZVIZVLZVWBUOJUUAVJAVWFUAVWBAVWDVWBTZVMZVWEAVWBUOVWDJVXAVKVXCVWDVNJUUB
        ZUIZVWEVNUIZVWEAVWGVXBVXEVXFVDVXAVWBUOVWDVNJVOUUCVXCVWDVXDJAVXDJVDZVXBA
        UAVPVWDVQUIZVRVSTZUUDVXGUAUUEAVXIVXDJAVXDJVTZVXIAVXJVMZUAVPHUUFUIZWAVWD
        WBUIZWCVAZGUUGKUUIUIZUSUUHZUUJZUBUKZUUKUIZVXRURVAZUBVBZWDVAZVXHWAIWEUIZ
        WFVAZWDVAZWFVAZVXHWAUOWAULTZVXKWGWHAUAVPVYFVRVSTVXJAUABVXOCVXPKUULUIZDU
        CEUBFGHIKLMNOPQRVYHUPZAKUVKTZVXOVYHTAKUUMTZVYJAHWITZVYKAHNWJZHKLUUNVJKU
        UOVJKVYHVXOVYIVXOUPUUPVJVXPUPAUCUKITVMVXOUUQUURWKAVWDVPTZVYFUOTVXJAVYNV
        MZVYFVYOVYBVYEVYOVXLVYAVYOVXLAVXLWITZVYNAVXLAHNUUSZWJZWKWLVYOVXQVXTUBVY
        OVXNWMTVXQVXNWNVXQWMTVYOWAVXMWOVXNVXPUUTZVXNVXQWPWQZVYOVXRVXQTZVMZVXRUT
        TZVXTULTZWUAVYOVXRVXNTZWUCVXQVXNVXRVYSUVAWUEWUCVYOVXRVXMWRWTUVBZVXSULTZ
        WUCWUDVXRUVCZVXSVXRUVDUVEVJZUVFZWSZVYOVXHVYDVYNVXHULTZAVWDUVGZWTAVYDULT
        ZVYNAVYGVYCULTZWUNWGAVYCAIWMTZVYCWITACWMTZICWNWUPAHUTTZWUQNCFHOPUVHVJIV
        WJCVWRCVWIUVIUVLCIWPWQZIUVJVJWLZWAVYCUVMXAZWKWSZXBZXCUVNVXKVYNVMVXHVYNW
        ULVXKWUMWTXCZVXKVYNWAVWDXDXEZVMZVMZVXHVYFVXHXLUIVYFXLUIXDWVGVXHVYEXFVAZ
        VYBXDXEZVXHVYFXDXEZWVGWVHVCVYBWVGVXHVYEVYNWULVXKWVEWUMUVOZAVYNVYEULTZVX
        JWVEWVBXGZUVPVCULTWVGUVQWHZAVYNVYBULTZVXJWVEWUKXGZWVGVXHXHVYCWFVAZWDVAZ
        VXHVCWDVAWVHVCXDWVGWVQVCVXHWVGXHVYCXHULTZWVGXIWHAWUOVXJWVFWUTXJZXBWVNWV
        KWVGVCWAVQUIZVXHXDUWAWVGWVEWWAVXHXDXEZVXKVYNWVEUVRWVGWAVPTVYNWVEWWBXKUW
        BVXKVYNWVEXMWAVWDUVSXAXNUVTZWVGWVQVCXDXEZXHVYCXDXEZWVGVXDJUWCZWEUIZXHVY
        CXDWVGVXJWWGXHVDZAVXJWVFUWDWVGVXDITZJITZVXJWWHXKAWWIVXJWVFAVXDVWJTZUTVW
        LVXDUIZVWKURVAZEVBZVCVDZWWIAVXDCTVXDDVTWWKAJFUWEUIZUIZVXDCACFWWPHJOPVWT
        WWPUPZUWFZAFUWGTZJCTZWWQCTAFUWHTZWWTAWURWXBNFHOUWLVJFUWIVJZVWTCFWWPJPWW
        RUWJXOUWKAWWQDWWPUIZVXDDAWWQWXDVTJDVTZAJVWJTWXEVWSJCDUWMVJZAWWQWXDJDACF
        WWPJDPWWRWXCVWTAWWTDCTWXCCFDPQUWNVJUWOUWPXPWWSAWWTWXDDVDWXCFWWPDQWWRUWQ
        VJUWRVXDCDUWSXQAWWMVCEUBUTVXRGUIZJUIZVXRURVAZVNUIZVRZWAUTXRWAYCTAUWTWHZ
        AVWKUTTZVMZVWKWXKUIZVWLJUIZVWKURVAZVNUIZWWMWXMWXOWXRVDZAUBVWKWXJWXRUTWX
        KUBEXSZWXIWXQVNWXTWXHWXPVXRVWKURWXTWXGVWLJVXRVWKGXTYAWXTYDYBYAWXKUPWXQV
        NUXAYEWTZWXNWXPVNUIZVWKVNUIZURVAWYBVWKURVAZWXRWWMWXNWYCVWKWYBURWXNVWKWX
        MVWKULTAVWKUXBWTUXCYFWXNWXPVWKWXNVWBUOVWLJAVWGWXMVXAWKZAYCVWBGUNZVWKYCT
        VWLVWBTZWXMAYCVWBGUXDZWYFAVYLWYHVYMVWBGHKLVWHMUXEVJYCVWBGUXFVJVWKUXGYCV
        WBVWKGUXHYGZUXIZWXMVWKUOTAVWKUXJWTZWXMVWKVCVTAVWKUXKWTZUXMWXNWWLWYBVWKU
        RWXNVWGWYGWWLWYBVDWYEWYIVWBUOVWLVNJVOXOYHZUXLUYAWXNWWMWYDUOWYMWXNWYBVWK
        WXNWXPWYJYIWYKWYLYJYKAXFWXKWAYLZVCVNUIVCYMAVCUDXFUEUTUEUKZGUIZJUIZWYOUR
        VAZVRZWAYLZWYNWAYNUTXRAWYTUFUKZYMXEZVWMWBUIWYTUIXUAWFVAXLUIUGUKZVWMURVA
        XDXEBWAYOYPVAUMZVMZUGVCYOYPVAZUXNZUFUYBWYTVCYMXEZABUFCDWYSFGHJKUEUGLMNO
        PQVWTWXFWYSUPZUXOAXUGXUHUFAXUEXUHUGXUFAXUCXUFTZXUEVMZVMZWYTXUAVCYMAXUJX
        UBXUDUXPZXULWWJXUAVCVDAWWJXUKSWKXULBXUCCXUADEWYSFGHIJKUELMAWURXUKNWKOPQ
        AWXAXUKVWTWKAWXEXUKWXFWKXUIAXUJXUEXMXUMAXUJXUBXUDUXQRUXRXNUXSUXTUYCUYDW
        YNYNTAXFWXKWAUYEWHWXLAUTUOUDUKZWYTAEWYSWAUTXRWXLWXNVWKWYSUIZWXQUOWXMXUO
        WXQVDZAUEVWKWYRWXQUTWYSUEEXSZWYQWXPWYOVWKURXUQWYPVWLJWYOVWKGXTYAXUQYDYB
        XUIWXPVWKURUYFYEWTZWXNWXPVWKWYJWYKWYLYJZYKUYGVKAXUNUTTZVMZWAXUNWCVAZWXQ
        EVBZVNUIXVBWXREVBXUNWYTUIZVNUIXUNWYNUIXVAXVBWXQEXVAWAXUNWOXVAAWXMWXQUOT
        VWKXVBTZAXUTUYHZVWKXUNWRZXUSYGZUYMXVAXVCXVDVNXVAWXQEWYSWAXUNXVAAWXMXUPX
        VEXVFXVGXURYGXVAXUNUTWAUYIUIAXUTUYJXRUYKZXVHYQYAXVAWXREWXKWAXUNXVAAWXMW
        XSXVEXVFXVGWYAYGXVIXVAAWXMWXRUOTXVEXVFXVGWXNWXQXUSYIYGYQUYLUYNUYOUYPUYQ
        VWQWWOBVXDVWJIVWMVXDVDZVWPWWNVCXVJUTVWOWWMEXVJVWNWWLVWKURVWLVWMVXDUYRYH
        UYSUYTRVUCXQXJZAWWJVXJWVFSXJZVXDJIVUAXOXNWVGWWFIVUBXEZWWGVYCXDXEWVGWUPW
        WFIWNZXVMAWUPVXJWVFWUSXJWVGWWIWWJXVNXVKXVLVXDJIVUMXOWWFIWMVUDVUEWWFIVUF
        VJVUGWVGWVSWUOWWDWWEXKXIWVTXHVYCVUHXAXPVUIWVGWVRVXHWAVYDXFVAZWDVAVXHWAW
        DVAZVYEXFVAWVHWVGWVQXVOVXHWDWVGWVQWAWAXFVAZVYCWFVAXVOXHXVQVYCWFVUJVUKWV
        GWAWAVYCWAUOTWVGVULWHZXVRWVGVYCWVTXCVUNVUOYFWVGVXHWAVYDVXKVYNVXHUOTWVEW
        VDVUPZXVRWVGVYDAWUNVXJWVFWVAXJXCVUQWVGXVPVXHVYEXFWVGVXHXVSVURYHVUSWVGVX
        HXVSVUTVVCWVGVXLVYAAVXLULTVXJWVFAVXLVYQYRXJAVYNVYAULTVXJWVEWUJXGWVGVXLA
        VYPVXJWVFVYRXJVVDAVYNVCVYAXDXEVXJWVEVYOVXQVXTUBVYTWUIWUBWUGVCVXSXDXEZVX
        RULTVCVXRVVAXEVCVXTXDXEWUBWUCWUGWUFWUHVJWUBWUCXVTWUFVXRVVBVJWUBVXRWUFYR
        WUBVXRWUFVVEVXSVXRVVFVVGVVHXGVVIYSWVGWULWVLWVOWVIWVJXKWVKWVMWVPVXHVYEVY
        BVVJVVKXNZWVGVXHWVKWWCYTWVGVYFAVYNVYFULTVXJWVEWVCXGZWVGVCVXHVYFWVNWVKXW
        BWWCXWAYSYTVVLVVMVVNVVOVVPWKVVQVVRVVSVVTUAVWBULJVWAXQ $.

      ${
        $d m F $.
        dchrisum0lem1.f $e |- F = ( a e. NN |->
          ( ( X ` ( L ` a ) ) / ( sqr ` a ) ) ) $.
        $( Lemma for ~ dchrisum0 .  Apply ~ dchrisum for the function
           ` 1 / sqr y ` .  (Contributed by Mario Carneiro, 10-May-2016.) $)
        dchrisum0lema $p |- ( ph -> E. t E. c e. ( 0 [,) +oo )
          ( seq 1 ( + , F ) ~~> t /\ A. y e. ( 1 [,) +oo ) ( abs `
            ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - t ) )
              <_ ( c / ( sqr ` y ) ) ) ) $=
          ( vx vn caddc c1 cseq cv cli wbr cfl cfv cmin cabs csqr cdiv cle cpnf
          co cico wral wa cc0 wrex wex cmul cmpt csn cdif csu wceq crab eqsstri
          cn ssrab2 sseldi eldifad wcel wne eldifsni syl weq oveq2d 1nn a1i crp
          fveq2 rpsqrcl adantl rprecred w3a simp3r cr wb simp2l rprege0d simp2r
          sqrle syl2anc mpbid rpsqrcld lerecd crli sqrlim fveq2d oveq12d adantr
          cbvmptv dchrisum cz nnz dchrzrhcl simpr nnrpd rpcnd divrecd mpteq2dva
          rpne0d 3eqtr4g seqeq3d breq1d oveq1d breq12d cbvralv ad2antrr elrege0
          eqtri fveq1d simplbi ad2antlr recnd 1re elicopnf 0re clt 0lt1 simprbi
          ax-mp ltletrd elrpd ralbidva syl5bb anbi12d rexbidva exbidv mpbird )
          AUGGUHUIZCUJZUKULZBUJZUMUNZUUIUNZUUJUOVAZUPUNZOUJZUULUQUNZURVAZUSULZB
          UHUTVBVAZVCZVDZOVEUTVBVAZVFZCVGUGNVPNUJZIUNZLUNZUHUVFUQUNZURVAZVHVAZV
          IZUHUIZUUJUKULZUEUJZUMUNZUVMUNZUUJUOVAZUPUNZUUQUHUVOUQUNZURVAZVHVAZUS
          ULZUEUVAVCZVDZOUVDVFZCVGAUECUHUFUJZUQUNZURVAZUWADEUFUVLHIUHJLMOPQRSTU
          AALDEVJZAKDUWJVKZLKVPFUJZIUNUULUNUWLURVAFVLVEVMZBUWKVNUWKUBUWMBUWKVQV
          OUCVRZVSZALUWKVTLEWAUWNLDEWBWCUFUEWDUWHUVTUHURUWGUVOUQWIWEUHVPVTAWFWG
          AUWGWHVTZVDUWHUWPUWHWHVTAUWGWJWKWLAUWPUVOWHVTZVDZUHUWGUSULZUWGUVOUSUL
          ZVDZWMZUWHUVTUSULZUWAUWIUSULUXBUWTUXCAUWRUWSUWTWNUXBUWGWOVTVEUWGUSULV
          DUVOWOVTZVEUVOUSULVDUWTUXCWPUXBUWGAUWPUWQUXAWQZWRUXBUVOAUWPUWQUXAWSZW
          RUWGUVOWTXAXBUXBUWHUVTUXBUWGUXEXCUXBUVOUXFXCXDXBUFWHUWIVIVEXEULAUFXFW
          GNUFVPUVKUWGIUNZLUNZUWIVHVAZNUFWDZUVHUXHUVJUWIVHUXJUVGUXGLUVFUWGIWIXG
          ZUXJUVIUWHUHURUVFUWGUQWIZWEXHXJZXKAUVEUWFCAUVCUWEOUVDAUUQUVDVTZVDZUUK
          UVNUVBUWDAUUKUVNWPUXNAUUIUVMUUJUKAGUVLUGUHAUFVPUXHUWHURVAZVIZUFVPUXIV
          IGUVLAUFVPUXPUXIAUWGVPVTZVDZUXHUWHUXSUWGDHIJLMSPTQALDVTUXRUWOXIUXRUWG
          XLVTAUWGXMWKXNUXSUWHUXSUWGUXSUWGAUXRXOXPXCZXQUXSUWHUXTXTXRXSGNVPUVHUV
          IURVAZVIUXQUDNUFVPUYAUXPUXJUVHUXHUVIUWHURUXKUXLXHXJYIUXMYAZYBYCXIUVBU
          VPUUIUNZUUJUOVAZUPUNZUUQUVTURVAZUSULZUEUVAVCUXOUWDUUTUYGBUEUVABUEWDZU
          UPUYEUUSUYFUSUYHUUOUYDUPUYHUUNUYCUUJUOUYHUUMUVPUUIUULUVOUMWIXGYDXGUYH
          UURUVTUUQURUULUVOUQWIWEYEYFUXOUYGUWCUEUVAUXOUVOUVAVTZVDZUYEUVSUYFUWBU
          SUYJUYDUVRUPUYJUYCUVQUUJUOUYJUVPUUIUVMUYJGUVLUGUHAGUVLVMUXNUYIUYBYGYB
          YJYDXGUYJUUQUVTUYJUUQUXNUUQWOVTZAUYIUXNUYKVEUUQUSULUUQYHYKYLYMUYJUVTU
          YJUVOUYJUVOUYIUXDUXOUYIUXDUHUVOUSULZUHWOVTZUYIUXDUYLVDWPYNUHUVOYOYTZY
          KWKZUYJVEUHUVOVEWOVTUYJYPWGUYMUYJYNWGUYOVEUHYQULUYJYRWGUYIUYLUXOUYIUX
          DUYLUYNYSWKUUAUUBXCZXQUYJUVTUYPXTXRYEUUCUUDUUEUUFUUGUUH $.

        dchrisum0.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
        dchrisum0.s $e |- ( ph -> seq 1 ( + , F ) ~~> S ) $.
        dchrisum0.1 $e |- ( ph -> A. y e. ( 1 [,) +oo )
          ( abs ` ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - S ) ) <_
            ( C / ( sqr ` y ) ) ) $.
        $( Lemma for ~ dchrisum0lem1 .  (Contributed by Mario Carneiro,
           7-Jun-2016.) $)
        dchrisum0lem1b $p |- ( ( ( ph /\ x e. RR+ ) /\
          d e. ( 1 ... ( |_ ` x ) ) ) -> ( abs `
            sum_ m e. ( ( ( |_ ` x ) + 1 ) ... ( |_ ` ( ( x ^ 2 ) / d ) ) )
              ( ( X ` ( L ` m ) ) / ( sqr ` m ) ) ) <_
            ( ( 2 x. C ) / ( sqr ` x ) ) ) $=
          ( cv crp wcel wa c1 cfl cfv cfz co caddc cexp cdiv csqr csu cabs cseq
          c2 cmin cmul fzfid cc cun ssun2 cuz wceq cn cn0 cr cc0 simpr rprege0d
          cle wbr flge0nn0 nn0p1nn adantr nnuz syl6eleq dchrisum0lem1a fzsplit2
          syl simprd syl2anc syl5sseqr sselda csn cdif crab ssrab2 cz dchrzrhcl
          adantl elfznn nnrpd rpsqrcld rpne0d divcld syldan abscld a1i cmpt weq
          rpcnd fveq2 fveq2d oveq12d ad2antrr rpregt0d simpld wb rpred ffvelrnd
          clt letrd subcld cpnf cico rerpdivcld fsumser eqtr3d eqbrtrd elicopnf
          1re ax-mp sylanbrc oveq1d oveq2d breq12d rspcv sylc recnd eqsstri nnz
          sseldi eldifad ad3antrrr elfzelz fsumcl wf 1z cbvmptv eqtri ffvelrnda
          nnrp fmptd serf nnge1d fznnfl simplbda flge1nn uztrn2 climcl readdcld
          nnred cli elrege0 sylib remulcl sylancr ssun1 fvmpt3i eqeltrd pncan2d
          2re ovex cin c0 reflcl ltp1d fzdisj fsumsplit abs3difd simplr rpexpcl
          2z sylancl rpdivcld wral nndivre sqrle mpbid lediv2a syl31anc abssubd
          syl2an le2addd wne 2cn rpcnne0d divass syl3anc 2timesd eqtrd breqtrrd
          ) ABUJZUKULZUMZQUJZUNUXDUOUPZUQURZULZUMZUXHUNUSURZUXDVFUTURZUXGVAURZU
          OUPZUQURZHUJZKUPZNUPZUXQVBUPZVAURZHVCZVDUPZUXOUSIUNVEZUPZFVGURZVDUPZF
          UXHUYDUPZVGURZVDUPZUSURZVFDVHURZUXDVBUPZVAURZUXKUYBUXKUXPUYAHUXKUXLUX
          OVIUXKUXQUXPULUXQUNUXOUQURZULZUYAVJULZUXKUXPUYOUXQUXKUXIUXPVKZUXPUYOU
          XPUXIVLUXKUXLUNVMUPZULUXOUXHVMUPULZUYOUYRVNUXKUXLVOUYSUXFUXLVOULZUXJU
          XFUXHVPULZVUAUXFUXDVQULZVRUXDWAWBUMZVUBUXFUXDAUXEVSZVTUXDWCWJUXHWDWJW
          EWFWGUXKUXDUXNWAWBZUYTAUXGUXDWHZWKZUXHUNUXOWIWLZWMWNUXKUYPUMZUXSUXTVU
          JUXQEJKLNOUARUBSANEULZUXEUXJUYPANEGWOZAMEVULWPZNMVOUXRCUJZUPUXQVAURHV
          CVRVNZCVUMWQVUMUDVUOCVUMWRUUAUEUUCUUDZUUEUYPUXQWSULZUXKUXQUNUXOUUFXAW
          TVUJUXTVUJUXQVUJUXQUYPUXQVOULZUXKUXQUXOXBXAZXCXDZXLVUJUXTVUTXEXFZXGUU
          GZXHUXKUYGUYJUXKUYFUXKUYEFUXKVOVJUXOUYDAVOVJUYDUUHUXEUXJAHIUNVOWFUNWS
          ULAUUIXIAVOVJUXQIAHVOUYAVJIAVURUMZUXSUXTVVCUXQEJKLNOUARUBSAVUKVURVUPW
          EVURVUQAUXQUUBXAWTVVCUXTVVCUXQVURUXQUKULAUXQUUMXAXDZXLVVCUXTVVDXEXFIP
          VOPUJZKUPZNUPZVVEVBUPZVAURZXJHVOUYAXJUFPHVOVVIUYAPHXKZVVGUXSVVHUXTVAV
          VJVVFUXRNVVEUXQKXMXNVVEUXQVBXMXOZUUJUUKUUNUULUUOXPZUXKUXHVOULZUYTUXOV
          OULUXKVUCUNUXDWAWBZVVMUXKVUCVRUXDYBWBZUXFVUCVVOUMUXJUXFUXDVUEXQWEXRZU
          XKUNUXGUXDUNVQULZUXKYLXIZUXKUXGUXJUXGVOULZUXFUXGUXHXBZXAZUVCVVPUXKUXG
          VWAUUPUXFUXJVVSUXGUXDWAWBZUXFVUCUXJVVSVWBUMXSUXFUXDVUEXTUXGUXDUUQWJUU
          RYCZUXDUUSWLZVUHUNUXOUXHVOWFUUTWLZYAZAFVJULZUXEUXJAUYDFUVDWBVWGUHFUYD
          UVAWJXPZYDXHZUXKUYIUXKFUYHVWHUXKVOVJUXHUYDVVLVWDYAZYDXHZUVBUXFUYNVQUL
          UXJUXFUYLUYMAUYLVQULZUXEAVFVQULDVQULZVWLUVMAVWMVRDWAWBZADVRYEYFURULVW
          MVWNUMZUGDUVEUVFZXRZVFDUVGUVHWEUXFUXDVUEXDZYGWEUXKUYCUYEUYHVGURZVDUPU
          YKWAUXKUYBVWSVDUXKUXIUYAHVCZUYBUSURZVWTVGURUYBVWSUXKVWTUYBUXKVWTUYHVJ
          UXKUYAHIUNUXHUXKUXQUXIULZUYPUXQIUPUYAVNZUXKUXIUYOUXQUXKUYRUXIUYOUXIUX
          PUVIVUIWMWNZVUJVURVXCVUSPUXQVVIUYAVOIVVKUFVVGVVHVAUVNUVJWJZXGUXKUXHVO
          UYSVWDWFWGUXKVXBUYPUYQVXDVVAXGYHZVWJUVKVVBUVLUXKVXAUYEVWTUYHVGUXKUYOU
          YAHVCVXAUYEUXKUXIUXPUYAUYOHUXKUXHUXLYBWBUXIUXPUVOUVPVNUXKUXHUXKVUCUXH
          VQULVVPUXDUVQWJUVRUNUXHUXLUXOUVSWJVUIUXKUNUXOVIVVAUVTUXKUYAHIUNUXOVXE
          UXKUXOVOUYSVWEWFWGVVAYHYIVXFXOYIXNUXKUYEUYHFVWFVWJVWHUWAYJUXKUYKDUYMV
          AURZVXGUSURZUYNWAUXKUYGUYJVXGVXGVWIVWKUXKDUYMAVWMUXEUXJVWQXPZUXKUXDAU
          XEUXJUWBZXDZYGZVXLUXKUYGDUXNVBUPZVAURZVXGVWIUXKDVXMVXIUXKUXNUXKUXMUXG
          UXFUXMUKULZUXJUXFUXEVFWSULVXOVUEUWDUXDVFUWCUWEZWEUXKUXGVWAXCUWFZXDZYG
          VXLUXKUXNUNYEYFURZULZVUNUOUPZUYDUPZFVGURZVDUPZDVUNVBUPZVAURZWAWBZCVXS
          UWGZUYGVXNWAWBZUXKUXNVQULZUNUXNWAWBZVXTUXFUXMVQULVVSVYJUXJUXFUXMVXPXT
          VVTUXMUXGUWHUWNZUXKUNUXDUXNVVRVVPVYLVWCUXKVUFUYTVUGXRZYCVVQVXTVYJVYKU
          MXSYLUNUXNYKYMYNAVYHUXEUXJUIXPZVYGVYICUXNVXSVUNUXNVNZVYDUYGVYFVXNWAVY
          OVYCUYFVDVYOVYBUYEFVGVYOVYAUXOUYDVUNUXNUOXMXNYOXNVYOVYEVXMDVAVUNUXNVB
          XMYPYQYRYSUXKUYMVQULVRUYMYBWBUMVXMVQULVRVXMYBWBUMVWOUYMVXMWAWBZVXNVXG
          WAWBUXKUYMVXKXQUXKVXMVXRXQAVWOUXEUXJVWPXPUXKVUFVYPVYMUXKVUDVYJVRUXNWA
          WBUMVUFVYPXSUXKUXDVXJVTUXKUXNVXQVTUXDUXNUWIWLUWJUYMVXMDUWKUWLYCUXKUYJ
          UYHFVGURZVDUPZVXGWAUXKFUYHVWHVWJUWMUXKUXDVXSULZVYHVYRVXGWAWBZUXKVUCVV
          NVYSVVPVWCVVQVYSVUCVVNUMXSYLUNUXDYKYMYNVYNVYGVYTCUXDVXSCBXKZVYDVYRVYF
          VXGWAWUAVYCVYQVDWUAVYBUYHFVGWUAVYAUXHUYDVUNUXDUOXMXNYOXNWUAVYEUYMDVAV
          UNUXDVBXMYPYQYRYSYJUWOUXKUYNVFVXGVHURZVXHUXKVFVJULZDVJULZUYMVJULUYMVR
          UWPUMZUYNWUBVNWUCUXKUWQXIUXFWUDUXJUXFDAVWMUXEVWQWEYTWEUXFWUEUXJUXFUYM
          VWRUWRWEVFDUYMUWSUWTUXKVXGUXKVXGVXLYTUXAUXBUXCYC $.

        $( Lemma for ~ dchrisum0 .  (Contributed by Mario Carneiro,
           12-May-2016.)  (Revised by Mario Carneiro, 7-Jun-2016.) $)
        dchrisum0lem1 $p |- ( ph -> ( x e. RR+ |->
          sum_ m e. ( ( ( |_ ` x ) + 1 ) ... ( |_ ` ( x ^ 2 ) ) )
            sum_ d e. ( 1 ... ( |_ ` ( ( x ^ 2 ) / m ) ) )
           ( ( ( X ` ( L ` m ) ) / ( sqr ` m ) ) / ( sqr ` d ) ) ) e. O(1) ) $=
          ( crp c1 cv cfl cfv cfz co caddc c2 cexp cdiv csqr csu cmpt co1 fzfid
          wcel wa cn cuz wi elfznn elfzuz anim12i a1i anim12ci cle cmul eluzelz
          wb wbr cz ad2antll zred cr simpr 2z rpexpcl rpred adantr cc0 rprege0d
          nnrpd 3syl nnuz syl2anc wceq adantl letrd mpbid eqbrtrd ad2antrl letr
          syl syl3anc mpan2d pm4.71rd clt 1re rpregt0d recnd fznnfl baibd flcld
          elfz5 flge bitr4d anbi12d simprd rpsqrcld rpne0d divcld simpld syldan
          cc rpcnd mpteq2dva 2cn sylancr rprecred fsumrecl oveq1d oveq2d rpssre
          2re remulcl crli remulcld fsumcl cabs abscld sylancl simprl lemuldivd
          nnred cn0 flge0nn0 simprr uztrn2 lemuldiv2d bitr3d rpcn sqvald simplr
          nn0p1nn reflcl peano2re fllep1 eluzle lemul1d ledivmuld nnre nndivred
          mpbird sylbid nnge1 pm3.2i lediv2 div1d breqtrd simpl nndivre sylbird
          syl2an 3bitr3d 3bitr4d ex pm5.21ndd cun ssun2 syl6eleq dchrisum0lem1a
          0lt1 fzsplit2 syl5sseqr sselda csn cdif ssrab2 eqsstri sseldi eldifad
          crab ad3antrrr elfzelz dchrzrhcl rpcnne0d anasss fsumcom2 cmin subcld
          wne mulcl cpnf cico elrege0 sylib rerpdivcld adddird pncan3d divcan2d
          mulassd eqtrd 3eqtr3d mulcld wss o1const eqid divsqrsum rlimdmo1 mp1i
          divrecd rlimconst sqrlim rlimmul rlimo1 o1mul2 o1add2 eqeltrd fsumabs
          cdm dchrisum0lem1b lediv1dd absdivd fsumdivc fveq2d 3eqtr3rd divrec2d
          absid 3brtr3d fsumle fsummulc1 breqtrrd leabsd adantrr o1le eqeltrrd
          ) ABUJUKBULZUMUNZUOUPZVUHUKUQUPZVUGURUSUPZQULZUTUPZUMUNZUOUPZHULZKUNZ
          NUNZVUPVAUNZUTUPZVULVAUNZUTUPZHVBZQVBZVCBUJVUJVUKUMUNZUOUPZUKVUKVUPUT
          UPZUMUNZUOUPZVVBQVBHVBZVCVDABUJVVDVVJAVUGUJVFZVGZVUIVUOVVFVVIQHVVBVVL
          UKVUHVEZVVLVUJVVEVEVVLVULVUIVFZVGZVUJVUNVEZVVLVULVHVFZVUPVUJVIUNVFZVG
          ZVVNVUPVUOVFZVGZVUPVVFVFZVULVVIVFZVGZVWAVVSVJVVLVVNVVQVVTVVRVULVUHVKZ
          VUPVUJVUNVLVMVNVWDVVSVJVVLVWBVVRVWCVVQVUPVUJVVEVLVULVVHVKVOVNVVLVVSVW
          AVWDVSVVLVVSVGZVULVUGVPVTZVUPVUMVPVTZVGZVUPVUKVPVTZVULVVGVPVTZVGZVWAV
          WDVWFVWHVWKVWIVWLVWFVUPVULVQUPVUKVPVTVWHVWKVWFVUPVUKVULVWFVUPVVRVUPWA
          VFZVVLVVQVUJVUPVRWBZWCZVVLVUKWDVFZVVSVVLVUKVVLVVKURWAVFVUKUJVFZAVVKWE
          ZWFVUGURWGUUAZWHZWIZVWFVULVVLVVQVVRUUBZWLZUUCVWFVULVUKVUPVWFVULVXBUUD
          VXAVWFVUPVWFVUJVHVFZVVRVUPVHVFZVVLVXDVVSVVLVUGWDVFZWJVUGVPVTVGVUHUUEV
          FVXDVVLVUGVWRWKVUGUUFVUHUUNWMZWIVVLVVQVVRUUGZUKVUPVUJVHWNUUHWOZWLZUUI
          UUJZVWFVWHVWGVWFVWHVWKVWGVXKVWFVWKVVGVUGVPVTZVWGVWFVXLVUKVUPVUGVQUPZV
          PVTVWFVUKVUGVUGVQUPZVXMVPVVLVUKVXNWPVVSVVLVUGVVKVUGYDVFAVUGUUKWQUULWI
          VWFVUGVUPVPVTVXNVXMVPVTVWFVUGVUJVUPVWFVUGAVVKVVSUUMZWHZVWFVXFVUHWDVFV
          UJWDVFVXPVUGUUOVUHUUPWMVWOVWFVXFVUGVUJVPVTVXPVUGUUQXCVVRVUJVUPVPVTVVL
          VVQVUJVUPUURWBWRVWFVUGVUPVUGVXPVWOVXOUUSWSWTVWFVUKVUGVUPVXAVXPVXJUUTU
          VCVWFVULWDVFZVVGWDVFZVXFVWKVXLVGVWGVJVVQVXQVVLVVRVULUVAXAVWFVUKVUPVXA
          VXIUVBZVXPVULVVGVUGXBXDXEUVDXFVWFVWKVWJVWFVWKVWHVWJVXKVWFVWHVUMVUKVPV
          TZVWJVWFVUMVUKUKUTUPZVUKVPVWFUKVULVPVTZVUMVYAVPVTZVVQVYBVVLVVRVULUVEX
          AVWFUKWDVFZWJUKXGVTZVGZVXQWJVULXGVTVGVWPWJVUKXGVTVGVYBVYCVSVYFVWFVYDV
          YEXHUWBUVFVNVWFVULVXCXIVWFVUKVVLVWQVVSVWSWIXIUKVULVUKUVGXDWSVWFVUKVWF
          VUKVXAXJUVHUVIVWFVUPWDVFVUMWDVFZVWPVWHVXTVGVWJVJVWOVVLVWPVVQVYGVVSVWT
          VVQVVRUVJVUKVULUVKUVMZVXAVUPVUMVUKXBXDXEUVLXFUVNVWFVVNVWGVVTVWHVWFVXF
          VVQVVNVWGVSVXPVXBVXFVVNVVQVWGVULVUGXKXLWOVWFVVTVUPVUNVPVTZVWHVWFVVRVU
          NWAVFVVTVYIVSVXHVWFVUMVYHXMVUPVUJVUNXNWOVWFVYGVWMVWHVYIVSVYHVWNVUMVUP
          XOWOXPXQVWFVWBVWJVWCVWKVWFVWBVUPVVEVPVTZVWJVWFVVRVVEWAVFVWBVYJVSVXHVW
          FVUKVXAXMVUPVUJVVEXNWOVWFVWPVWMVWJVYJVSVXAVWNVUKVUPXOWOXPVWFVXRVVQVWC
          VWKVSVXSVXBVXRVWCVVQVWKVULVVGXKXLWOXQUVOUVPUVQVVLVVNVVTVVBYDVFZVVOVVT
          VUPUKVUNUOUPZVFZVYKVVOVUOVYLVUPVVOVUIVUOUVRZVUOVYLVUOVUIUVSVVOVUJUKVI
          UNZVFVUNVUHVIUNVFZVYLVYNWPVVOVUJVHVYOVVLVXDVVNVXGWIWNUVTVVOVUGVUMVPVT
          VYPAVULVUGUWAXRVUHUKVUNUWCWOUWDUWEZVVOVYMVGZVUTVVAVYRVURVUSVYRVUPEJKL
          NOUARUBSANEVFVVKVVNVYMANEGUWFZAMEVYSUWGZNMVHVUQCULUNVUPUTUPHVBWJWPZCV
          YTUWLVYTUDWUACVYTUWHUWIUEUWJUWKUWMVYMVWMVVOVUPUKVUNUWNWQUWOVYRVUSVYRV
          UPVYRVUPVYMVXEVVOVUPVUNVKWQWLXSZYEVYRVUSWUBXTYAZVYRVVAYDVFZVVAWJUXAZV
          VOWUDWUEVGVYMVVOVVAVVOVULVVOVULVVNVVQVVLVWEWQWLXSZUWPWIZYBVYRWUDWUEWU
          GXRYAYCZUWQUWRYFABUJVUIUKVVAUTUPZQVBZURDVQUPZVUGVAUNZUTUPZVQUPZVVDUKW
          DVYDAXHVNABUJWUNVCBUJURWUKVQUPZWUJURWULVQUPZUWSUPZWUMVQUPZUQUPZVCVDAB
          UJWUNWUSVVLWUPWUQUQUPZWUMVQUPWUPWUMVQUPZWURUQUPWUNWUSVVLWUPWUQWUMVVLU
          RYDVFZWULYDVFWUPYDVFYGVVLWULVVLVUGVWRXSZYEZURWULUXBYHZVVLWUJWUPVVLWUJ
          VVLVUIWUIQVVMVVOVVAWUFYIZYJZXJZWVEUWTZVVLWUMVVLWUKWULAWUKWDVFZVVKAURW
          DVFZDWDVFZWVJYNAWVLWJDVPVTZADWJUXCUXDUPVFWVLWVMVGUGDUXEUXFYBURDYOYHZW
          IZWVCUXGZXJZUXHVVLWUTWUJWUMVQVVLWUPWUJWVEWVHUXIYKVVLWVAWUOWURUQVVLWVA
          URWULWUMVQUPZVQUPWUOVVLURWULWUMWVBVVLYGVNWVDWVQUXKVVLWVRWUKURVQVVLWUK
          WULVVLWUKWVOXJZWVDVVLWULWVCXTZUXJYLUXLYKUXMYFABUJWUOWURYDAWUOYDVFZVVK
          AWUOAWVKWVJWUOWDVFYNWVNURWUKYOYHXJZWIVVLWUQWUMWVIWVQUXNAUJWDUXOZWWABU
          JWUOVCVDVFYMWWBBUJWUOUXPYHABUJWUQWUMYDWVIWVQBUJWUQVCZYPUYJVFWWDVDVFAB
          QWWDWWDUXQUXRWWDUXSUXTABUJWUMVCZWUKWJVQUPZYPVTWWEVDVFAWWEBUJWUKUKWULU
          TUPZVQUPZVCWWFYPABUJWUMWWHVVLWUKWULWVSWVDWVTUYAYFABUJWUKWWGWUKWJWDWVO
          VVLWULWVCYIAWWCWUKYDVFBUJWUKVCWUKYPVTYMAWUKWVNXJBUJWUKUYBYHBUJWWGVCWJ
          YPVTABUYCVNUYDWTWWFWWEUYEXCUYFUYGUYHVVLWUJWUMWVGWVPYQZVVLVUIVVCQVVMVV
          OVUOVVBHVVPWUHYRZYRZAVVKVVDYSUNZWUNYSUNZVPVTUKVUGVPVTVVLWWLWUNWWMVVLV
          VDWWKYTZWWIVVLWUNVVLWUNWWIXJYTVVLWWLVUIVVCYSUNZQVBZWUNWWNVVLVUIWWOQVV
          MVVOVVCWWJYTZYJWWIVVLVUIVVCQVVMWWJUYIVVLWWPVUIWUIWUMVQUPZQVBWUNVPVVLV
          UIWWOWWRQVVMWWQVVOWUIWUMWVFVVLWUMWDVFVVNWVPWIZYQVVOVUOVUTHVBZYSUNZVVA
          UTUPZWUMVVAUTUPWWOWWRVPVVOWXAWUMVVAVVOWWTVVOVUOVUTHVVPVVOVVTVYMVUTYDV
          FVYQWUCYCZYRZYTWWSWUFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUYKUYLVVOW
          WTVVAUTUPZYSUNWXAVVAYSUNZUTUPWWOWXBVVOWWTVVAWXDVVOVVAWUFYEZVVOVVAWUFX
          TZUYMVVOWXEVVCYSVVOVUOVUTVVAHVVPWXGWXCWXHUYNUYOVVOWXFVVAWXAUTVVOVVAWD
          VFWJVVAVPVTVGWXFVVAWPVVOVVAWUFWKVVAUYRXCYLUYPVVOWUMVVAVVLWUMYDVFVVNWV
          QWIWXGWXHUYQUYSUYTVVLVUIWUIWUMQVVMWVQVVOWUIWVFXJVUAVUBWRVVLWUNWWIVUCW
          RVUDVUEVUF $.

        ${
          dchrisum0lem2.h $e |- H = ( y e. RR+ |->
            ( sum_ d e. ( 1 ... ( |_ ` y ) ) ( 1 / ( sqr ` d ) ) -
              ( 2 x. ( sqr ` y ) ) ) ) $.
          dchrisum0lem2.u $e |- ( ph -> H ~~>r U ) $.
          $( Lemma for ~ dchrisum0 .  (Contributed by Mario Carneiro,
             12-May-2016.) $)
          dchrisum0lem2a $p |- ( ph -> ( x e. RR+ |->
            sum_ m e. ( 1 ... ( |_ ` x ) )
              ( ( ( X ` ( L ` m ) ) / ( sqr ` m ) ) x.
                ( H ` ( ( x ^ 2 ) / m ) ) ) ) e. O(1) ) $=
            ( vz vw crp c1 cv cfl cfv cfz csqr cdiv cexp cmul csu cmpt co1 wcel
            co c2 cc wa fzfid cn simpl elfznn csn cdif wceq crab ssrab2 eqsstri
            sseldi eldifad adantr cz adantl rpsqrcld rpcnd rpne0d syl2an fsumcl
            cc0 nnz crli wbr syl cpnf cico wss cioo clt cle ax-mp fveq2 sylanl2
            cr 1re nnuz mpteq2dva rpssre a1i fmptd ffvelrnda eqid mpbird mulcld
            wb cmin ad2antrr oveq2d 3eqtr4d cabs abscld simpld rprecred absge0d
            recnd rprege0d cn0 3syl ad2antlr oveq1d wne syl2anc breqtrd syl3anc
            eqtrd letrd dchrzrhcl nnrp divcld rlimcl cres caddc cseq cxr df-ioo
            0lt1 df-ico xrltletr ixxss1 mp2an ioorp sseqtri resmpt sseli fveq2d
            0xr oveq12d ovex fvmpt3i cuz elicopnf flge1nn sylbi syl6eleq syl5eq
            fsumser syl5ss 1z cli cbvmptv eqtri serf feqmptd eqbrtrrd climrlim2
            simprbi rlimo1 eqeltrd o1resb o1const sylancr simpr rpexpcl sylancl
            o1mul2 2z nnrpd rpdivcl divsqrsumf ffvelrni fsumsub subdid sumeq2dv
            fsummulc1 subcld fsumrecl fsumabs reflcl rerpdivcld simplr rpdivcld
            rprege0 absdivd absid cbs wf wfo nnnn0d znzrhfo fof elfzelz ffvelrn
            dchrabs2 lediv1dd eqbrtrd divsqrsum2 sqrdiv rpcnne0 rpcnne0d recdiv
            mpdan lemul12ad absmuld ax-1cn dmdcan mulcomd eqtr3d 3brtr4d fsumle
            sqrsq reccl chash flge0nn0 hashfz1 cfn rpreccld simprd divrecd flle
            fsumconst mulid1d breqtrrd rpregt0 ledivmul adantrr elo1d eqeltrrd
            o1dif ) ABUPUQBURZUSUTZVAVJZIURZMUTZPUTZVUPVBUTZVCVJZVUMVKVDVJZVUPV
            CVJZLUTZVEVJZIVFZVGVHVIBUPVUOVUTIVFZGVEVJZVGVHVIABUPVVFGVLAVUMUPVIZ
            VMZVUOVUTIVVIUQVUNVNZVVIAVUPVOVIZVUTVLVIZVUPVUOVIZAVVHVPZVUPVUNVQZA
            VVKVMZVURVUSVVPVUPEKMNPQUCTUDUAAPEVIZVVKAPEHVRZAOEVVRVSZPOVOVUQCURU
            TVUPVCVJIVFWNVTZCVVSWAVVSUFVVTCVVSWBWCUGWDWEZWFVVKVUPWGVIZAVUPWOWHU
            UAZVVPVUSVVPVUPVVKVUPUPVIZAVUPUUBWHWIZWJVVPVUSVWEWKUUCZWLZWMZAGVLVI
            ZVVHALGWPWQZVWIUMGLUUDZWRZWFZABUPVVFVGZVHVIVWNUQWSWTVJZUUEZVHVIAVWP
            BVWOVUNUUFJUQUUGZUTZVGZVHAVWPBVWOVVFVGZVWSVWOUPXAVWPVWTVTVWOWNWSXBV
            JZUPWNUUHVIWNUQXCWQVWOVXAXAUUTUUJBCUNUOWNUQWSWTXCXCXDXBXCBCUNUUIBCU
            NUUKWNUQUOURUULUUMUUNUUOUUPZBUPVWOVVFUUQXEABVWOVVFVWRAVUMVWOVIZVMZV
            UTIJUQVUNVXCAVVHVVMVUPJUTVUTVTZVWOUPVUMVXBUURZVVIVVMVMZVVKVXEVVMVVK
            VVIVVOWHRVUPRURZMUTZPUTZVXHVBUTZVCVJZVUTVOJVXHVUPVTZVXJVURVXKVUSVCV
            XMVXIVUQPVXHVUPMXFUUSVXHVUPVBXFUVAZUHVXJVXKVCUVBUVCWRXGVXDVUNVOUQUV
            DUTVXCVUNVOVIZAVXCVUMXHVIZUQVUMXDWQZVMZVXOUQXHVIZVXCVXRXSXIUQVUMUVE
            XEZVUMUVFUVGWHXJUVHVXCAVVHVVMVVLVXFVWGXGUVJXKUVIAVWSFWPWQVWSVHVIABV
            WOVUPVWQUTZVWRFIUQVOXJVUPVUNVWQXFAVWOUPXHVXBUPXHXAZAXLXMZUVKUQWGVIA
            UVLXMZAVWQIVOVYAVGFUVMAIVOVLVWQAIJUQVOXJVYDAVOVLVUPJAIVOVUTVLJVWFJR
            VOVXLVGIVOVUTVGUHRIVOVXLVUTVXNUVNUVOXNXOUVPZUVQUJUVRAVOVLVUPVWQVYEX
            OVXCVXQAVXCVXPVXQVXTUVTWHUVSFVWSUWAWRUWBAUPUQVWNABUPVVFVLVWNVWHVWNX
            PXNVYCVXSAXIXMZUWCXQAVYBVWIBUPGVGVHVIXLVWLBUPGUWDUWEUWIABUPVVEVVGVV
            IVUOVVDIVVJVXGVUTVVCVWGVXGVVCVXGVVBUPVIZVVCXHVIVVIVVAUPVIZVWDVYGVVM
            VVIVVHVKWGVIVYHAVVHUWFZUWJVUMVKUWGUWHZVVMVUPVVOUWKZVVAVUPUWLWLZUPXH
            VVBLCSLULUWMUWNWRYIZXRZWMVVIVVFGVWHVWMXRABUPVUOVUTVVCGXTVJZVEVJZIVF
            ZVGBUPVVEVVGXTVJZVGVHABUPVYQVYRVVIVUOVVDVUTGVEVJZXTVJZIVFVVEVUOVYSI
            VFZXTVJVYQVYRVVIVUOVVDVYSIVVJVYNVXGVUTGVWGVXGVWJVWIAVWJVVHVVMUMYAZV
            WKWRZXRUWOVVIVUOVYPVYTIVXGVUTVVCGVWGVYMWUCUWPUWQVVIVVGWUAVVEXTVVIVU
            OVUTGIVVJVWMVWGUWRYBYCXKABUPVYQUQUQVYCVVIVUOVYPIVVJVXGVUTVYOVWGVXGV
            VCGVYMWUCUWSZXRZWMZVYFVYFAVVHVYQYDUTZUQXDWQVXQVVIWUGVUOVYPYDUTZIVFZ
            UQVVIVYQWUFYEVVIVUOWUHIVVJVXGVYPWUEYEZUWTZVXSVVIXIXMZVVIVUOVYPIVVJW
            UEUXAVVIWUIVUNVUMVCVJZUQWUKVVIVUNVUMVVIVXPVUNXHVIZVVIVXPWNVUMXDWQZV
            VHVXPWUOVMZAVUMUXFZWHZYFZVUMUXBWRZVYIUXCWULVVIWUIVUOUQVUMVCVJZIVFZW
            UMXDVVIVUOWUHWVAIVVJWUJVXGVUMAVVHVVMUXDZYGVXGVUTYDUTZVYOYDUTZVEVJUQ
            VUSVCVJZVUSVUMVCVJZVEVJZWUHWVAXDVXGWVDWVFWVEWVGVXGVUTVWGYEVXGVUSVVM
            VUSUPVIVVIVVMVUPVYKWIWHZYGVXGVYOWUDYEVXGUPXHWVGXLVXGVUSVUMWVIWVCUXE
            ZWDVXGVUTVWGYHVXGVYOWUDYHVXGWVDVURYDUTZVUSVCVJZWVFXDVXGWVDWVKVUSYDU
            TZVCVJWVLVXGVURVUSVVIAVVKVURVLVIVVMVVNVVOVWCWLZVXGVUSWVIWJVXGVUSWVI
            WKUXGVXGWVMVUSWVKVCVXGVUSXHVIWNVUSXDWQVMWVMVUSVTVXGVUSWVIYJVUSUXHWR
            YBYSVXGWVKUQVUSVXGVURWVNYEVXSVXGXIXMWVIVXGVUQQUXIUTZEKNPQUCUDTWVOXP
            ZAVVQVVHVVMVWAYAVVIWGWVOMUXJZVWBVUQWVOVIVVMAWVQVVHANYKVIWGWVOMUXKWV
            QANUBUXLWVOMNQTWVPUAUXMWGWVOMUXNYLWFVUPUQVUNUXOWGWVOVUPMUXPWLUXQUXR
            UXSVXGWVEUQVVBVBUTZVCVJZWVGXDVXGVYGWVEWVSXDWQVYLVXGCVVBSLGULWUBUXTU
            YEVXGWVSUQVUMVUSVCVJZVCVJZWVGVXGWVRWVTUQVCVXGWVRVVAVBUTZVUSVCVJZWVT
            VVIVVAXHVIWNVVAXDWQVMVWDWVRWWCVTVVMVVIVVAVYJYJVYKVVAVUPUYAWLVXGWWBV
            UMVUSVCVXGWUPWWBVUMVTVVHWUPAVVMWUQYMVUMUYNWRYNYSYBVXGVUMVLVIZVUMWNY
            OZVMZVUSVLVIVUSWNYOVMZWWAWVGVTVVHWWFAVVMVUMUYBZYMZVXGVUSWVIUYCZVUMV
            USUYDYPYSYQUYFVXGVUTVYOVWGWUDUYGVXGWVGWVFVEVJZWVAWVHVXGWWGWWFUQVLVI
            ZWWKWVAVTWWJWWIWWLVXGUYHXMVUSVUMUQUYIYRVXGWVGWVFVXGWVGWVJWJVXGWWGWV
            FVLVIWWJVUSUYOWRUYJUYKUYLUYMVVIVUOUYPUTZWVAVEVJZVUNWVAVEVJWVBWUMVVI
            WWMVUNWVAVEVVIWUPVUNYKVIWWMVUNVTWURVUMUYQVUNUYRYLYNVVIVUOUYSVIWVAVL
            VIWVBWWNVTVVJVVIWVAVVIVUMVYIUYTWJVUOWVAIVUDYPVVIVUNVUMVVIVUNWUTYIVV
            IWWDWWEVVHWWFAWWHWHZYFVVIWWDWWEWWOVUAVUBYCYQVVIWUMUQXDWQZVUNVUMUQVE
            VJZXDWQZVVIVUNVUMWWQXDVVIVXPVUNVUMXDWQWUSVUMVUCWRVVIVUMVVIVUMWUSYIV
            UEVUFVVIWUNVXSVXPWNVUMXCWQVMZWWPWWRXSWUTWULVVHWWSAVUMVUGWHVUNUQVUMV
            UHYRXQYTYTVUIVUJVUKVULXQ $.

          dchrisum0lem2.k $e |- K = ( a e. NN |->
            ( ( X ` ( L ` a ) ) / a ) ) $.
          dchrisum0lem2.e $e |- ( ph -> E e. ( 0 [,) +oo ) ) $.
          dchrisum0lem2.t $e |- ( ph -> seq 1 ( + , K ) ~~> T ) $.
          dchrisum0lem2.3 $e |- ( ph -> A. y e. ( 1 [,) +oo )
           ( abs ` ( ( seq 1 ( + , K ) ` ( |_ ` y ) ) - T ) ) <_ ( E / y ) ) $.
          $( Lemma for ~ dchrisum0 .  (Contributed by Mario Carneiro,
             12-May-2016.) $)
          dchrisum0lem2 $p |- ( ph -> ( x e. RR+ |->
            sum_ m e. ( 1 ... ( |_ ` x ) )
              sum_ d e. ( 1 ... ( |_ ` ( ( x ^ 2 ) / m ) ) )
           ( ( ( X ` ( L ` m ) ) / ( sqr ` m ) ) / ( sqr ` d ) ) ) e. O(1) ) $=
            ( crp c1 cv cfl cfv cfz co c2 cexp cdiv csqr csu cmpt co1 wcel cmul
            cc wa 2cn a1i rpcn adantl fzfid csn cdif cn cc0 wceq ssrab2 eqsstri
            sseldi eldifad ad2antrr cz elfzelz elfznn nnrpd rpcnd rpne0d divcld
            crab fsumcl mulcld cr rpssre 1re cpnf cico cle wbr syl oveq1d eqtrd
            cabs adantrr cmin weq fveq2 fveq2d oveq12d fvmpt3i adantlrr syl2anc
            ovex wne adantr wb eqbrtrd syl3anc mpbird rpsqrcld sylancr rpcnne0d
            mulcl oveq2d sumeq2dv fsummulc2 eqtr4d 3eqtr4d rprege0d wss o1const
            dchrzrhcl mp2an elrege0 simplbi absmuld rprege0 absid caddc subid1d
            cseq id cuz clt rpregt0 ad2antrl simpld simprr flge1nn nnuz fsumser
            syl6eleq eldifsni dchrvmaeq0 mpbid eqcomd wral elicopnf ax-mp oveq2
            eqtr3d sylanbrc breq12d rspcv sylc abscld lemuldiv2 elo1d 2re simpr
            o1mul2 2z rpexpcl sylancl rpdivcl rpred remulcl recnd fsumsub reccl
            syl2an subdid sumeq1d divrecd mulassd div12d remsqsqr eqtr2d sqrdiv
            divdiv1 ad2antlr sqrsq divass 3eqtr3d dchrisum0lem2a eqeltrrd o1dif
            mpteq2dva ) ABVAVBBVCZVDVEZVFVGZVBUXJVHVIVGZJVCZVJVGZVDVEZVFVGZUXNP
            VEZSVEZUXNVKVEZVJVGZUBVCZVKVEZVJVGZUBVLZJVLZVMVNVOBVAVHUXJUXLUXSUXN
            VJVGZJVLZVPVGZVPVGZVMVNVOABVAVHUYIVQVHVQVOZAUXJVAVOZVRZVSVTZUYMUXJU
            YHUYLUXJVQVOZAUXJWAWBZUYMUXLUYGJUYMVBUXKWCZUYMUXNUXLVOZVRZUXSUXNUYS
            UXNEMPQSTUFUCUGUDASEVOUYLUYRASEIWDZAREUYTWEZSRWFUXRCVCZVEUXNVJVGJVL
            WGWHZCVUAXAVUAUIVUCCVUAWIWJUJWKZWLZWMUYRUXNWNVOUYMUXNVBUXKWOWBUUCZU
            YSUXNUYRUXNVAVOZUYMUYRUXNUXNUXKWPZWQZWBZWRUYSUXNVUJWSWTZXBZXCZBVAVH
            VMVNVOZAVAXDUUAZUYKVUNXEVSBVAVHUUBUUDVTABVAUYIVBKVUOAXEVTVUMVBXDVOZ
            AXFVTAKWGXGXHVGVOZKXDVOZURVUQVURWGKXIXJKUUEUUFXKZAUYLVBUXJXIXJZVRZV
            RZUYIXNVEZUXJUYHXNVEZVPVGZKXIAUYLVVCVVEWHVUTUYMVVCUXJXNVEZVVDVPVGVV
            EUYMUXJUYHUYPVULUUGUYMVVFUXJVVDVPUYMUXJXDVOZWGUXJXIXJVRZVVFUXJWHUYL
            VVHAUXJUUHZWBUXJUUIXKXLXMXOVVBVVEKXIXJZVVDKUXJVJVGZXIXJZVVBVVDUXKUU
            JOVBUULZVEZGXPVGZXNVEZVVKXIVVBUYHVVOXNVVBUYHWGXPVGUYHVVOVVBUYHAUYLU
            YHVQVOVUTVULXOZUUKVVBUYHVVNWGGXPVVBUYGJOVBUXKAUYLUYRUXNOVEUYGWHZVUT
            UYSUXNWFVOZVVRUYRVVSUYMVUHWBUAUXNUAVCZPVEZSVEZVVTVJVGUYGWFOUAJXQZVW
            BUXSVVTUXNVJVWCVWAUXRSVVTUXNPXRXSVWCUUMXTUQVWBVVTVJYDYAXKYBVVBUXKWF
            VBUUNVEVVBVVGVUTUXKWFVOVVBVVGWGUXJUUOXJZUYLVVGVWDVRZAVUTUXJUUPUUQZU
            URZAUYLVUTUUSZUXJUUTYCUVAUVCAUYLUYRUYGVQVOVUTVUKYBUVBVVBGWGAGWGWHZV
            VAASRVOVWIUJACKEGIJOMPQRSTUAUCUDUEUFUGUHVUEASVUAVOSIYEVUDSEIUVDXKUQ
            URUSUTUIUVEUVFYFUVGXTUVLXSVVBUXJVBXGXHVGZVOZVUBVDVEZVVMVEZGXPVGZXNV
            EZKVUBVJVGZXIXJZCVWJUVHZVVPVVKXIXJZVVBVVGVUTVWKVWGVWHVUPVWKVVGVUTVR
            YGXFVBUXJUVIUVJUVMAVWRVVAUTYFVWQVWSCUXJVWJCBXQZVWOVVPVWPVVKXIVWTVWN
            VVOXNVWTVWMVVNGXPVWTVWLUXKVVMVUBUXJVDXRXSXLXSVUBUXJKVJUVKUVNUVOUVPY
            HVVBVVDXDVOVURVWEVVJVVLYGVVBUYHVVQUVQAVURVVAVUSYFVWFVVDKUXJUVRYIYJY
            HUVSUWBABVAUYFUYJUYMUXLUYEJUYQUYSUXQUYDUBUYSVBUXPWCZUYSUYBUXQVOZVRZ
            UYAUYCUYSUYAVQVOVXBUYSUXSUXTVUFUYSUXTUYSUXNVUJYKZWRZUYSUXTVXDWSZWTZ
            YFZVXCUYCVXCUYBVXCUYBVXBUYBWFVOUYSUYBUXPWPWBWQYKZWRZVXCUYCVXIWSZWTX
            BZXBUYMUYKUYIVQVOUYJVQVOVSVUMVHUYIYNYLABVAUXLUYAUXONVEZVPVGZJVLZVMB
            VAUYFUYJXPVGZVMVNABVAVXOVXPUYMUXLUYEUYAVHUXOVKVEZVPVGZVPVGZXPVGZJVL
            UYFUXLVXSJVLZXPVGVXOVXPUYMUXLUYEVXSJUYQVXLUYSUYAVXRVXGUYSVXRUYSVHXD
            VOVXQXDVOVXRXDVOUVTUYSVXQUYSUXOUYMUXMVAVOZVUGUXOVAVOZUYRUYMUYLVHWNV
            OVYBAUYLUWAUWCUXJVHUWDUWEZVUIUXMUXNUWFUWLZYKUWGVHVXQUWHYLUWIZXCUWJU
            YMUXLVXNVXTJUYSUYAUXQVBUYCVJVGZUBVLZVXRXPVGZVPVGUYAVYHVPVGZVXSXPVGV
            XNVXTUYSUYAVYHVXRVXGUYSUXQVYGUBVXAVXCUYCVQVOUYCWGYEVRVYGVQVOVXCUYCV
            XIYMUYCUWKXKZXBVYFUWMUYSVXMVYIUYAVPUYSVYCVXMVYIWHVYECUXOVBVWLVFVGZV
            YGUBVLZVHVUBVKVEZVPVGZXPVGVYIVANVUBUXOWHZVYMVYHVYOVXRXPVYPVYLUXQVYG
            UBVYPVWLUXPVBVFVUBUXOVDXRYOUWNVYPVYNVXQVHVPVUBUXOVKXRYOXTUOVYMVYOXP
            YDYAXKYOUYSUYEVYJVXSXPUYSUYEUXQUYAVYGVPVGZUBVLVYJUYSUXQUYDVYQUBVXCU
            YAUYCVXHVXJVXKUWOYPUYSUXQVYGUYAUBVXAVXGVYKYQYRXLYSYPUYMUYJVYAUYFXPU
            YMVHUXJVPVGZUYHVPVGUXLVYRUYGVPVGZJVLUYJVYAUYMUXLUYGVYRJUYQUYMUYKUYO
            VYRVQVOZVSUYPVHUXJYNYLZVUKYQUYMVHUXJUYHUYNUYPVULUWPUYMUXLVYSVXSJUYS
            VYRUYAUXTVJVGZVPVGUYAVYRUXTVJVGZVPVGVYSVXSUYSVYRUYAUXTUYMVYTUYRWUAY
            FVXGVXEVXFUWQUYSUYGWUBVYRVPUYSWUBUXSUXTUXTVPVGZVJVGZUYGUYSUXSVQVOUX
            TVQVOUXTWGYEVRZWUFWUBWUEWHVUFUYSUXTVXDYMZWUGUXSUXTUXTUXAYIUYSWUDUXN
            UXSVJUYSUXNXDVOWGUXNXIXJVRWUDUXNWHUYSUXNVUJYTUXNUWRXKYOUWSYOUYSVXRW
            UCUYAVPUYSVXRVHUXJUXTVJVGZVPVGZWUCUYSVXQWUHVHVPUYSVXQUXMVKVEZUXTVJV
            GZWUHUYSUXMXDVOWGUXMXIXJVRVUGVXQWUKWHUYSUXMUYMVYBUYRVYDYFYTVUJUXMUX
            NUWTYCUYSWUJUXJUXTVJUYSVVHWUJUXJWHUYLVVHAUYRVVIUXBUXJUXCXKXLXMYOUYS
            UYKUYOWUFWUCWUIWHUYKUYSVSVTUYMUYOUYRUYPYFWUGVHUXJUXTUXDYIYRYOYSYPUX
            EYOYSUXIABCDEFHIJLMNPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUXFUXGUXHY
            J $.
        $}

        $( Lemma for ~ dchrisum0 .  (Contributed by Mario Carneiro,
           12-May-2016.) $)
        dchrisum0lem3 $p |- ( ph -> ( x e. RR+ |->
          sum_ m e. ( 1 ... ( |_ ` ( x ^ 2 ) ) )
            sum_ d e. ( 1 ... ( |_ ` ( ( x ^ 2 ) / m ) ) )
              ( ( X ` ( L ` m ) ) / ( sqr ` ( m x. d ) ) ) ) e. O(1) ) $=
          ( vt vc crp c1 cv cfl cfv cfz co c2 cexp cdiv csqr csu caddc cmul cvv
          cr wcel 1re a1i wa sumex cn cmpt cseq cli wbr cmin cabs cle cpnf cico
          wral cc0 wrex wex co1 csn cdif wceq ssrab2 eqsstri difss sstri sseldi
          crab wne eldifsni syl eqid dchrmusumlema crli adantr cdm divsqrsum cc
          wf wss divsqrsumf ax-resscn fss mp2an cxr clt csup rpsup rlimdm mpbii
          simprl simprrl simprrr dchrisum0lem2 rexlimdvaa exlimdv mpd cz adantl
          fzfid elfznn nnrpd rpsqrcld adantrr rprege0d syl2anc rpcnne0d syl3anc
          fsumcl sumeq2dv rpred cuz dchrisum0lem1 o1add2 ovex elfzelz dchrzrhcl
          ad2antrr rpmulcl syl2an rpcnd rpne0d divcld abscld sqrmul divdiv1 cin
          oveq2d eqtr4d simpr reflcl ltp1d fzdisj cun cn0 flge0nn0 nn0p1nn 3syl
          c0 nnuz syl6eleq 2z rpexpcl sylancl recnd mulid1d wb rpregt0 ad2antrl
          simprr eqbrtrrd breqtrrd flword2 fzsplit2 eqeltrrd adantlrr fsumsplit
          lemul2 mpbid sqvald eqtrd fveq2d eqle o1le ) ABULUMBUNZUOUPZUQURZUMUW
          MUSUTURZHUNZVAURUOUPZUQURZUWQKUPZNUPZUWQVBUPZVAURQUNZVBUPZVAURZQVCZHV
          CZUWNUMVDURZUWPUOUPZUQURZUXFHVCZVDURZUMUXIUQURZUWSUXAUWQUXCVEURZVBUPZ
          VAURZQVCZHVCZUMVFUMVGVHZAVIVJABULUXGUXKVFUXGVFVHAUWMULVHZVKZUWOUXFHVL
          VJUXKVFVHUYAUXJUXFHVLVJAVDPVMPUNZKUPNUPUYBVAURVNZUMVOZUJUNZVPVQZCUNZU
          OUPZUYDUPUYEVRURVSUPUKUNZUYGVAURVTVQCUMWAWBURZWCZVKZUKWDWAWBURZWEZUJW
          FBULUXGVNWGVHZACUJEGUYCJKLNOPUKRSTUAUBUCAMENMEGWHZWIZEMVMUWTUYGUPUWQV
          AURHVCWDWJZCUYQWPUYQUDUYRCUYQWKWLZEUYPWMWNUEWOZANUYQVHNGWQAMUYQNUYSUE
          WONEGWRWSUYCWTZXAAUYNUYOUJAUYLUYOUKUYMAUYIUYMVHZUYLVKZVKBCDEFUYECULUM
          UYHUQURUMUXDVAURQVCUSUYGVBUPZVEURVRURVNZXBUPZGHUYIIJVUEUYCKLMNOPQRSAL
          VMVHVUCTXCUAUBUCUDANMVHVUCUEXCUFADUYMVHVUCUGXCAVDIUMVOZFVPVQVUCUHXCAU
          YHVUGUPFVRURVSUPDVUDVAURVTVQCUYJWCVUCUIXCVUEWTZAVUEVUFXBVQZVUCAVUEXBX
          DVHVUICQVUEVUHXEAULVUEULXFVUEXGZAULVGVUEXGVGXFXHVUJCQVUEVUHXIXJULVGXF
          VUEXKXLVJULXMXNXOWAWJAXPVJXQXRXCVUAAVUBUYLXSAVUBUYFUYKXTAVUBUYFUYKYAY
          BYCYDYEABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUUAUUBUXLVFVHUYAUXGUXKVD
          UUCVJUYAUXMUXQHUYAUMUXIYHUYAUWQUXMVHZVKZUWSUXPQVULUMUWRYHVULUXCUWSVHZ
          VKZUXAUXOVULUXAXFVHZVUMVULUWQEJKLNOUARUBSANEVHUXTVUKUYTUUFVUKUWQYFVHU
          YAUWQUMUXIUUDYGUUEXCZVUNUXOVUNUXNVULUWQULVHUXCULVHUXNULVHVUMVULUWQVUK
          UWQVMVHZUYAUWQUXIYIYGZYJVUMUXCUXCUWRYIZYJUWQUXCUUGUUHYKZUUIVUNUXOVUTU
          UJUUKYQZYQZAUXTUMUWMVTVQZVKVKZUXRVSUPZVGVHZVVEUXLVSUPZWJVVEVVGVTVQAUX
          TVVFVVCUYAUXRVVBUULYLVVDUXRUXLVSVVDUXRUXMUXFHVCZUXLAUXTUXRVVHWJVVCUYA
          UXMUXQUXFHVULUWSUXPUXEQVUNUXPUXAUXBUXDVEURZVAURZUXEVUNUXOVVIUXAVAVUNU
          WQVGVHWDUWQVTVQVKUXCVGVHWDUXCVTVQVKUXOVVIWJVUNUWQVUNUWQVULVUQVUMVURXC
          YJZYMVUNUXCVUNUXCVUMUXCVMVHVULVUSYGYJZYMUWQUXCUUMYNUUPVUNVUOUXBXFVHUX
          BWDWQVKUXDXFVHUXDWDWQVKUXEVVJWJVUPVUNUXBVUNUWQVVKYKYOVUNUXDVUNUXCVVLY
          KYOUXAUXBUXDUUNYPUUQYRZYRYLVVDUWOUXJUXFUXMHAUXTUWOUXJUUOUVGWJZVVCUYAU
          WNUXHXNVQVVNUYAUWNUYAUWMVGVHZUWNVGVHUYAUWMAUXTUURZYSZUWMUUSWSUUTUMUWN
          UXHUXIUVAWSYLVVDUXHUMYTUPZVHZUXIUWNYTUPVHZUXMUWOUXJUVBWJAUXTVVSVVCUYA
          UXHVMVVRUYAVVOWDUWMVTVQVKUWNUVCVHUXHVMVHUYAUWMVVPYMUWMUVDUWNUVEUVFUVH
          UVIYLVVDVVOUWPVGVHUWMUWPVTVQVVTAUXTVVOVVCVVQYLZVVDUWPAUXTUWPULVHZVVCU
          YAUXTUSYFVHVWBVVPUVJUWMUSUVKUVLYLYSVVDUWMUWMUWMVEURZUWPVTVVDUWMUMVEUR
          ZUWMVWCVTVVDUWMVVDUWMVWAUVMZUVNVVDVVCVWDVWCVTVQZAUXTVVCUVRVVDUXSVVOVV
          OWDUWMXNVQVKZVVCVWFUVOUXSVVDVIVJVWAUXTVWGAVVCUWMUVPUVQUMUWMUWMUWFYPUW
          GUVSVVDUWMVWEUWHUVTUWMUWPUWAYPUWNUMUXIUWBYNVVDUMUXIYHAUXTVUKUXFXFVHVV
          CVULUXQUXFXFVVMVVAUWCUWDUWEUWIUWJVVEVVGUWKYNUWL $.
      $}

      $( The sum ` sum_ n e. NN , X ( n ) / n ` is nonzero for all
         non-principal Dirichlet characters (i.e. the assumption ` X e. W ` is
         contradictory).  This is the key result that allows us to eliminate
         the conditionals from ~ dchrmusum2 and ~ dchrvmasumif .  Lemma 9.4.4
         of [Shapiro], p. 382.  (Contributed by Mario Carneiro,
         12-May-2016.) $)
      dchrisum0 $p |- -. ph $=
        ( co vx vk vb vi vz vd vc vt va cdivides wbr crab cfv csu cmpt eqid csn
        cn cdif cdiv cc0 wceq ssrab2 eqsstri difss sstri sseldi dchrisum0re crp
        cv c1 cfl cfz csqr c2 cexp cmul ccom co1 wcel wa fveq2 oveq2d cr adantl
        rpre cc ad3antrrr cz elrabi nnzd dchrzrhcl elfznn nnrpd rpsqrcld adantr
        rpcnd wne rpne0d divcld anasss dvdsflsumcom dchrisum0fval syl cfn fzfid
        oveq1d wss sgmss syl2anc fsumdivc eqtrd sumeq2dv rprege0 resqrth fveq2d
        ssfi cle sumeq1d sumeq12dv 3eqtr4d mpteq2dva rpsqrcl eqidd oveq1 fmptco
        eqtr4d cdm wf caddc cseq cli cpnf cico wral wrex a1i wi 0re simpr sumex
        cmin cabs dchrisum0lema simprl simprrl simprrr dchrisum0lem3 rexlimdvaa
        wex exlimdv mpd o1f dmmpti feq2i rpssre resqcl simplr ad2antrl breqtrrd
        sylib simplrr rpred ad2ant2r sqrge0 le2sqd letrd lecasei expr ralrimiva
        mpbird breq1 imbi1d ralbidv rspcev o1compt eqeltrd dchrisum0fno1 ) AUAB
        CDUBUCURUDVJZUCVJUJUKUDURULBVJZGUMJUMBUNUOZFGHJKUDUCLMNOPQUWAUPZAICJICD
        UQZUSZCIUREVJZGUMZUVTUMUWEUTTEUNVAVBZBUWDULUWDRUWGBUWDVCVDCUWCVEVFSVGZA
        BCDEFGHIJKLMNOPQRSVHAUAVIVKUAVJZVLUMZVMTZUBVJZUWAUMZUWLVNUMZUTTZUBUNZUO
        ZUEVIVKUEVJZVOVPTZVLUMZVMTZVKUWSUWEUTTZVLUMZVMTZUWFJUMZUWEUFVJVQTZVNUMZ
        UTTZUFUNZEUNZUOZUAVIUWIVNUMZUOZVRZVSAUWQUAVIVKUXLVOVPTZVLUMZVMTZVKUXOUW
        EUTTZVLUMZVMTZUXHUFUNZEUNZUOUXNAUAVIUWPUYBAUWIVIVTZWAZUWKUVSUWLUJUKZUDU
        RULZUXEUWNUTTZEUNZUBUNUWKVKUWIUWEUTTZVLUMZVMTZUXHUFUNZEUNUWPUYBUYDUDUWI
        UYGUXHUFUBEUWLUXFVBUWNUXGUXEUTUWLUXFVNWBWCUYCUWIWDVTZAUWIWFWEUYDUWLUWKV
        TZUWEUYFVTZUYGWGVTUYDUYNWAZUYOWAZUXEUWNUYQUWECFGHJKOLPMAJCVTUYCUYNUYOUW
        HWHUYOUWEWIVTUYPUYOUWEUYEUDUWEURWJWKWEWLZUYPUWNWGVTUYOUYPUWNUYPUWLUYPUW
        LUYNUWLURVTZUYDUWLUWJWMWEZWNWOZWQZWPUYPUWNVAWRUYOUYPUWNVUAWSZWPWTXAXBUY
        DUWKUWOUYHUBUYPUWOUYFUXEEUNZUWNUTTUYHUYPUWMVUDUWNUTUYPUYSUWMVUDVBUYTABE
        UWLCDUWAFGHJKUDUCLMNOPQUWBXCXDXGUYPUYFUXEUWNEUYPVKUWLVMTZXEVTUYFVUEXHZU
        YFXEVTUYPVKUWLXFUYPUYSVUFUYTUWLUDXIXDVUEUYFXQXJVUBUYRVUCXKXLXMUYDUXQUWK
        UYAUYLEUYDUXPUWJVKVMUYDUXOUWIVLUYDUYMVAUWIXRUKWAZUXOUWIVBZUYCVUGAUWIXNZ
        WEUWIXOZXDZXPWCUYDUYAUYLVBUWEUXQVTUYDUXTUYKUXHUFUYDUXSUYJVKVMUYDUXRUYIV
        LUYDUXOUWIUWEUTVUKXGXPWCXSWPXTYAYBAUAUEVIVIUXLUXJUYBUXMUXKUYCUXLVIVTAUW
        IYCWEZAUXMYDAUXKYDUWRUXLVBZUXAUXQUXIUYAEVUMUWTUXPVKVMVUMUWSUXOVLUWRUXLV
        OVPYEZXPWCVUMUXIUYAVBUWEUXAVTVUMUXDUXTUXHUFVUMUXCUXSVKVMVUMUXBUXRVLVUMU
        WSUXOUWEUTVUNXGXPWCXSWPXTYFYGAUGUAVIVIUXLUHUXKAUXKYHZWGUXKYIZVIWGUXKYIA
        UXKVSVTZVUPAYJUIURUIVJZGUMJUMVURVNUMUTTUOZVKYKZUHVJZYLUKZUVTVLUMVUTUMVV
        AUUBTUUCUMUGVJZUVTVNUMUTTXRUKBVKYMYNTYOZWAZUGVAYMYNTZYPZUHUUJVUQABUHCDE
        VUSFGHIJKUIUGLMNOPQRSVUSUPZUUDAVVGVUQUHAVVEVUQUGVVFAVVCVVFVTZVVEWAZWAUE
        BVVCCVVADEVUSFGHIJKUIUFLMAHURVTVVJNWPOPQRAJIVTVVJSWPVVHAVVIVVEUUEAVVIVV
        BVVDUUFAVVIVVBVVDUUGUUHUUIUUKUULZUXKUUMXDVUOVIWGUXKUEVIUXJUXKUXAUXIEUUA
        UXKUPUUNUUOUVAVVKVULVIWDXHAUUPYQAVVAWDVTZWAZVVAVOVPTZWDVTZVVNUWIXRUKZVV
        AUXLXRUKZYRZUAVIYOZVVCUWIXRUKZVVQYRZUAVIYOZUGWDYPVVLVVOAVVAUUQWEVVMVVRU
        AVIVVMUYCVVPVVQVVMUYCVVPWAZWAZVVQVAVVAVAWDVTZVWDYSYQAVVLVWCUURZVWDVAVVA
        XRUKZWAZVVQVVNUXOXRUKVWHVVNUWIUXOXRVVMUYCVVPVWGUVBVWHVUGVUHVWDVUGVWGUYC
        VUGVVMVVPVUIUUSZWPVUJXDUUTVWHVVAUXLVWDVVLVWGVWFWPVWDUXLWDVTZVWGAUYCVWJV
        VLVVPUYDUXLVULUVCUVDZWPVWDVWGYTVWDVAUXLXRUKZVWGVWDVUGVWLVWIUWIUVEXDZWPU
        VFUVKVWDVVAVAXRUKZWAZVVAVAUXLVWDVVLVWNVWFWPVWEVWOYSYQVWDVWJVWNVWKWPVWDV
        WNYTVWDVWLVWNVWMWPUVGUVHUVIUVJVWBVVSUGVVNWDVVCVVNVBZVWAVVRUAVIVWPVVTVVP
        VVQVVCVVNUWIXRUVLUVMUVNUVOXJUVPUVQUVR $.
    $}

    ${
      dchrmusum.g $e |- G = ( DChr ` N ) $.
      dchrmusum.d $e |- D = ( Base ` G ) $.
      dchrmusum.1 $e |- .1. = ( 0g ` G ) $.
      dchrmusum.b $e |- ( ph -> X e. D ) $.
      dchrmusum.n1 $e |- ( ph -> X =/= .1. ) $.
      ${
        $d m F $.
        dchrmusum.f $e |- F = ( a e. NN |->
          ( ( X ` ( L ` a ) ) / a ) ) $.
        dchrmusum.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
        dchrmusum.t $e |- ( ph -> seq 1 ( + , F ) ~~> T ) $.
        dchrmusum.2 $e |- ( ph -> A. y e. ( 1 [,) +oo )
          ( abs ` ( ( seq 1 ( + , F ) ` ( |_ ` y ) ) - T ) ) <_ ( C / y ) ) $.
        $( The sum ` sum_ n e. NN , X ( n ) / n ` is nonzero for all
           non-principal Dirichlet characters (i.e. the assumption ` X e. W `
           is contradictory).  This is the key result that allows us to
           eliminate the conditionals from ~ dchrmusum2 and ~ dchrvmasumif .
           Lemma 9.4.4 of [Shapiro], p. 382.  (Contributed by Mario Carneiro,
           12-May-2016.) $)
        dchrisumn0 $p |- ( ph -> T =/= 0 ) $=
          ( vm cc0 wceq wa cn cv cfv cdiv co csu csn cdif crab wcel adantr eqid
          dchrvmaeq0 biimpar dchrisum0 imnani neneqad ) AEUGAEUGUHZAVGUIBDFUFHI
          JUJUFUKZIULBUKULVHUMUNUFUOUGUHBDFUPUQURZKLNOAJUJUSVGPUTQRSVIVAZAKVIUS
          VGABCDEFUFGHIJVIKLMNOPQRSTUAUBUCUDUEVJVBVCVDVEVF $.

        $( The sum of the M&ouml;bius function multiplied by a non-principal
           Dirichlet character, divided by ` n ` , is bounded.  Equation 9.4.16
           of [Shapiro], p. 379.  (Contributed by Mario Carneiro,
           12-May-2016.) $)
        dchrmusumlem $p |- ( ph -> ( x e. RR+ |->
          sum_ n e. ( 1 ... ( |_ ` x ) )
            ( ( X ` ( L ` n ) ) x. ( ( mmu ` n ) / n ) ) ) e. O(1) ) $=
          ( crp c1 cv cfl cfv cfz co cmu cdiv cmul csu cmpt wcel fzfid ad2antrr
          co1 wa cz elfzelz adantl dchrzrhcl cn elfznn mucl zred nndivred recnd
          syl mulcld fsumcl caddc cseq cli wbr climcl adantr cc0 wne dchrisumn0
          cc divrecd divcan4d eqtr3d mpteq2dva reccld dchrmusum2 cr wss o1const
          rpssre sylancr o1mul2 eqeltrrd ) ABUHUIBUJZUKULZUMUNZHUJZKULMULZXDUOU
          LZXDUPUNZUQUNZHURZFUQUNZUIFUPUNZUQUNZUSBUHXIUSVCABUHXLXIAXAUHUTZVDZXJ
          FUPUNXLXIXNXJFXNXIFXNXCXHHXNUIXBVAXNXDXCUTZVDZXEXGXPXDEJKLMNSPTQAMEUT
          XMXOUBVBXOXDVEUTXNXDUIXBVFVGVHXPXGXPXFXDXPXFXPXDVIUTZXFVEUTXOXQXNXDXB
          VJVGZXDVKVOVLXRVMVNVPVQZAFWGUTZXMAVRIUIVSZFVTWAXTUFFYAWBVOZWCZVPZYCAF
          WDWEXMACDEFGIJKLMNOPQRSTUAUBUCUDUEUFUGWFZWCZWHXNXIFXSYCYFWIWJWKABUHXJ
          XKWGYDAXKWGUTZXMAFYBYEWLZWCABCDEFGIJKLMNOHPQRSTUAUBUCUDUEUFUGWMAUHWNW
          OYGBUHXKUSVCUTWQYHBUHXKWPWRWSWT $.

        $( The sum of the M&ouml;bius function multiplied by a non-principal
           Dirichlet character, divided by ` n ` , is bounded.  Equation 9.4.16
           of [Shapiro], p. 379.  (Contributed by Mario Carneiro,
           12-May-2016.) $)
        dchrvmasumlem $p |- ( ph -> ( x e. RR+ |->
          sum_ n e. ( 1 ... ( |_ ` x ) )
            ( ( X ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) ) e. O(1) ) $=
          ( crp c1 cv cfl cfv cfz co cvma cdiv cmul csu cc0 wceq clog cif caddc
          cmpt co1 wa wne dchrisumn0 adantr ifnefalse syl oveq2d fzfid ad2antrr
          cz elfzelz adantl dchrzrhcl cn cr elfznn vmacl nndivre mpancom mulcld
          wcel recnd fsumcl addid1d eqtrd mpteq2dva dchrvmasumif eqeltrrd ) ABU
          HUIBUJZUKULZUMUNZHUJZKULMULZWQUOULZWQUPUNZUQUNZHURZFUSUTWNVAULZUSVBZV
          CUNZVDBUHXBVDVEABUHXEXBAWNUHWFZVFZXEXBUSVCUNXBXGXDUSXBVCXGFUSVGZXDUSU
          TAXHXFACDEFGIJKLMNOPQRSTUAUBUCUDUEUFUGVHVIFUSXCUSVJVKVLXGXBXGWPXAHXGU
          IWOVMXGWQWPWFZVFZWRWTXJWQEJKLMNSPTQAMEWFXFXIUBVNXIWQVOWFXGWQUIWOVPVQV
          RXJWTXJWQVSWFZWTVTWFZXIXKXGWQWOWAVQWSVTWFXKXLWQWBWSWQWCWDVKWGWEWHWIWJ
          WKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGWLWM $.
      $}

      $( The sum of the M&ouml;bius function multiplied by a non-principal
         Dirichlet character, divided by ` n ` , is bounded.  Equation 9.4.16
         of [Shapiro], p. 379.  (Contributed by Mario Carneiro,
         12-May-2016.) $)
      dchrmusum $p |- ( ph -> ( x e. RR+ |-> sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( X ` ( L ` n ) ) x. ( ( mmu ` n ) / n ) ) ) e. O(1) ) $=
        ( cfv co va vt vy vc caddc cn cv cdiv cmpt c1 cseq cli wbr cfl cmin cle
        cabs cpnf cico wral cc0 wrex wex crp cfz cmu cmul csu co1 dchrmusumlema
        wa wcel eqid adantr wne simprrl simprrr dchrmusumlem rexlimdvaa exlimdv
        simprl mpd ) AUEUAUFUAUGZGSISWCUHTUIZUJUKZUBUGZULUMZUCUGZUNSWESWFUOTUQS
        UDUGZWHUHTUPUMUCUJURUSTUTZVKZUDVAURUSTZVBZUBVCBVDUJBUGUNSVETEUGZGSISWNV
        FSWNUHTVGTEVHUIVIVLZAUCUBCDWDFGHIJUAUDKLMNOPQRWDVMZVJAWMWOUBAWKWOUDWLAW
        IWLVLZWKVKZVKBUCWICWFDEWDFGHIJUAKLAHUFVLWRMVNNOPAICVLWRQVNAIDVOWRRVNWPA
        WQWKWAAWQWGWJVPAWQWGWJVQVRVSVTWB $.

      $( The sum of the von Mangoldt function multiplied by a non-principal
         Dirichlet character, divided by ` n ` , is bounded.  Equation 9.4.8 of
         [Shapiro], p. 376.  (Contributed by Mario Carneiro, 12-May-2016.) $)
      dchrvmasum $p |- ( ph -> ( x e. RR+ |-> sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( X ` ( L ` n ) ) x. ( ( Lam ` n ) / n ) ) ) e. O(1) ) $=
        ( cfv co va vt vy vc caddc cn cv cdiv cmpt c1 cseq cli wbr cfl cmin cle
        cabs cpnf cico wral wa cc0 wrex wex crp cfz cvma cmul csu co1 wcel eqid
        dchrmusumlema adantr wne simprl simprrl simprrr rexlimdvaa exlimdv mpd
        dchrvmasumlem ) AUEUAUFUAUGZGSISWCUHTUIZUJUKZUBUGZULUMZUCUGZUNSWESWFUOT
        UQSUDUGZWHUHTUPUMUCUJURUSTUTZVAZUDVBURUSTZVCZUBVDBVEUJBUGUNSVFTEUGZGSIS
        WNVGSWNUHTVHTEVIUIVJVKZAUCUBCDWDFGHIJUAUDKLMNOPQRWDVLZVMAWMWOUBAWKWOUDW
        LAWIWLVKZWKVAZVABUCWICWFDEWDFGHIJUAKLAHUFVKWRMVNNOPAICVKWRQVNAIDVOWRRVN
        WPAWQWKVPAWQWGWJVQAWQWGWJVRWBVSVTWA $.
    $}

    $d n A $.
    rpvmasum.u $e |- U = ( Unit ` Z ) $.
    rpvmasum.b $e |- ( ph -> A e. U ) $.
    rpvmasum.t $e |- T = ( `' L " { A } ) $.
    $( The sum of the von Mangoldt function over those integers ` n == A ` (mod
       ` N ` ) is asymptotic to ` log x / phi ( x ) + O(1) ` .  Equation 9.4.3
       of [Shapiro], p. 375.  (Contributed by Mario Carneiro, 2-May-2016.)
       (Proof shortened by Mario Carneiro, 26-May-2016.) $)
    rpvmasum $p |- ( ph -> ( x e. RR+ |-> ( ( ( phi ` N ) x.
  sum_ n e. ( ( 1 ... ( |_ ` x ) ) i^i T ) ( ( Lam ` n ) / n ) ) -
        ( log ` x ) ) ) e. O(1) ) $=
      ( cfv c1 co cc0 cmin vm vy vf crp cphi cv cfl cfz cin cvma cdiv cmul clog
      csu cn wceq cdchr cbs c0g csn cdif crab chash cmpt wcel wa c0 adantr eqid
      co1 wb fveq2 fveq2d id oveq12d cbvsumv eqeq1i a1i rabbiia simpr dchrisum0
      imnani eq0rdv hash0 syl6eq oveq2d ax-1cn subid1i cr relogcl recnd mulid1d
      adantl eqtrd mpteq2dva cur pm2.21i rpvmasum2 eqeltrrd ) ABUDHUEPQBUFZUGPU
      HRDUIFUFZUJPXAUKRFUNULRZWTUMPZQUOUAUFZGPZUBUFZPZXDUKRZUAUNZSUPZUBHUQPZURP
      ZXKUSPZUTVAZVBZVCPZTRZULRZTRZVDBUDXBXCTRZVDVJABUDXSXTAWTUDVEZVFZXRXCXBTYB
      XRXCQULRXCYBXQQXCULAXQQUPYAAXQQSTRQAXPSQTAXPVGVCPSAXOVGVCAUCXOAUCUFZXOVEZ
      AYDVFZUBXLXMFXKGHXOYCIJKAHUOVEYDLVHXKVIZXLVIZXMVIZXJUOXAGPZXFPZXAUKRZFUNZ
      SUPZUBXNXJYMVKXFXNVEXIYLSUOXHYKUAFXDXAUPZXGYJXDXAUKYNXEYIXFXDXAGVLVMYNVNV
      OVPVQVRVSAYDVTWAZWBWCVMWDWEWFQWGWHWEVHWFYBXCYBXCYAXCWIVEAWTWJWMWKWLWNWFWO
      ABUBCXLDEXMUCUAFXKGHXOIJKLYFYGYHXOVIMNOYECIWPPUPYOWQWRWS $.

    $( The sum of ` log p / p ` over the primes ` p == A ` (mod ` N ` ) is
       asymptotic to ` log x / phi ( x ) + O(1) ` .  Equation 9.4.3 of
       [Shapiro], p. 375.  (Contributed by Mario Carneiro, 16-Apr-2016.) $)
    rplogsum $p |- ( ph -> ( x e. RR+ |-> ( ( ( phi ` N ) x.
 sum_ p e. ( ( 1 ... ( |_ ` x ) ) i^i ( Prime i^i T ) ) ( ( log ` p ) / p ) ) -
        ( log ` x ) ) ) e. O(1) ) $=
      ( crp co wcel syl cc0 cphi cfv c1 cv cfl cfz cin cvma cdiv cmul clog cmin
      csu cmpt co1 cprime rpvmasum wa cn phicld adantr nncnd cfn wss fzfid ssfi
      inss1 sylancl cr simpr sseldi elfznn vmacl nndivre mpancom fsumrecl recnd
      mulcld relogcl adantl subcld nnrp relogcld rerpdivcld cif subdid wceq wne
      cc ifcl rpcnne0d divsubdir syl3anc sumeq2dv fsumsub inss2 sslin mp1i cdif
      0re eldif incom ineq2i inass eqtr4i elin2 simplbi2 con3and iffalse oveq1d
      sylbi eldifi sylan2 div0 eqtrd fsumss sstri iftrue eqtr3d oveq2d nnncan2d
      3eqtrd 3eqtr4d mpteq2dva resubcld rpssre o1const sylancr a1i 1re 2re cabs
      wn c2 cle wbr breq1 vmaprm eqcomd eqle syl2anc vmage0 ifbothda subge0d cz
      mpbird divge0d fsumge0 absidd fsumless flcld rplogsumlem2 eqbrtrd adantrr
      sselda letrd elo1d o1mul2 eqeltrrd o1dif mpbid ) ABPGUAUBZUCBUDZUEUBZUFQZ
      DUGZIUDZUHUBZUVGUIQZIUMZUJQZUVCUKUBZULQZUNUORBPUVBUVEUPDUGZUGZUVGUKUBZUVG
      UIQZIUMZUJQZUVLULQZUNUORABCDEIFGHJKLMNOUQABPUVMUVTAUVCPRZURZUVKUVLUWBUVBU
      VJUWBUVBAUVBUSRUWAAGLUTZVAVBZUWBUVJUWBUVFUVIIUWBUVEVCRZUVFUVEVDZUVFVCRUWB
      UCUVDVEZUVEDVGZUVEUVFVFVHZUWBUVGUVFRZURZUVGUSRZUVIVIRZUWKUVGUVERZUWLUWKUV
      FUVEUVGUWHUWBUWJVJVKUVGUVDVLZSZUVHVIRUWLUWMUVGVMZUVHUVGVNVOZSVPVQZVRZUWBU
      VLUWAUVLVIRAUVCVSVTVQZWAUWBUVSUVLUWBUVBUVRUWDUWBUVRUWBUVOUVQIUWBUWEUVOUVE
      VDUVOVCRUWGUVEUVNVGZUVEUVOVFVHUWBUVGUVORZURZUWLUVQVIRUXDUWNUWLUXDUVOUVEUV
      GUXBUWBUXCVJZVKUWOSZUWLUVPUVGUWLUVGUVGWBZWCZUXGWDSVPVQZVRZUXAWAABPUVBUVFU
      VHUVGUPRZUVPTWEZULQZUVGUIQZIUMZUJQZUNBPUVMUVTULQZUNUOABPUXPUXQUWBUVBUVJUV
      RULQZUJQUVKUVSULQUXPUXQUWBUVBUVJUVRUWDUWSUXIWFUWBUXOUXRUVBUJUWBUXOUVFUVIU
      XLUVGUIQZULQZIUMUVJUVFUXSIUMZULQUXRUWBUVFUXNUXTIUWKUWLUXNUXTWGZUWPUWLUVHW
      IRUXLWIRUVGWIRUVGTWHURZUYBUWLUVHUWQVQUWLUXLUWLUVPVIRZTVIRUXLVIRUXHWTUXKUV
      PTVIWJVHZVQUWLUVGUXGWKZUVHUXLUVGWLWMSWNUWBUVFUVIUXSIUWIUWKUWLUVIWIRUWPUWL
      UVIUWRVQSUWKUWLUXSWIRZUWPUWLUXSUWLUXLUVGUYEUXGWDVQZSWOUWBUYAUVRUVJULUWBUV
      OUXSIUMUYAUVRUWBUVOUVFUXSIUVNDVDUVOUVFVDUWBUPDWPUVNDUVEWQWRUXDUWLUYGUXFUY
      HSUWBUVGUVFUVOWSRZURZUXSTUVGUIQZTUYJUXLTUVGUIUYJUXKYMZUXLTWGUYIUYLUWBUYIU
      WJUXCYMURUYLUVGUVFUVOXAUWJUXKUXCUXCUWJUXKUVGUVFUPUVOUVOUVEDUPUGZUGUVFUPUG
      UVNUYMUVEUPDXBXCUVEDUPXDXEXFXGXHXKVTUXKUVPTXISXJUYJUWLUYKTWGZUYIUWBUWJUWL
      UVGUVFUVOXLUWPXMUWLUYCUYNUYFUVGXNSSXOUWIXPUWBUVOUXSUVQIUXDUXLUVPUVGUIUXDU
      XKUXLUVPWGUXDUVOUPUVGUVOUVNUPUVEUVNWPUPDVGXQUXEVKUXKUVPTXRSXJWNXSXTYBXTUW
      BUVKUVSUVLUWTUXJUXAYAYCYDABPUVBUXOWIUWDUWBUXOUWBUVFUXNIUWIUWKUWLUXNVIRZUW
      PUWLUXMUVGUWLUVHUXLUWQUYEYEZUXGWDZSZVPZVQZAPVIVDZUVBWIRBPUVBUNUORYFAUVBUW
      CVBBPUVBYGYHABPUXOUCYNVUAAYFYIZUYTUCVIRAYJYIYNVIRZAYKYIAUWAUXOYLUBZYNYOYP
      UCUVCYOYPUWBVUDUXOYNYOUWBUXOUYSUWBUVFUXNIUWIUYRUWKUWLTUXNYOYPZUWPUWLUXMUV
      GUYPUXGUWLTUXMYOYPUXLUVHYOYPZUXKUVPUVHYOYPZTUVHYOYPZVUFUWLUVPTUVPUXLUVHYO
      YQTUXLUVHYOYQUWLUXKURZUYDUVPUVHWGVUGUWLUYDUXKUXHVAVUIUVHUVPUXKUVHUVPWGUWL
      UVGYRVTYSUVPUVHYTUUAUWLVUHUYLUVGUUBVAUUCUWLUVHUXLUWQUYEUUDUUFUUGZSUUHUUIU
      WBUXOUVEUXNIUMZYNUYSUWBUVEUXNIUWGUWBUWNURZUWLUYOUWNUWLUWBUWOVTZUYQSZVPVUC
      UWBYKYIUWBUVEUXNUVFIUWGVUNVULUWLVUEVUMVUJSUWFUWBUWHYIUUJUWBUVDUUERVUKYNYO
      YPUWBUVCAPVIUVCVUBUUOUUKUVDIUULSUUPUUMUUNUUQUURUUSUUTUVA $.

    $( Dirichlet's theorem: there are infinitely many primes in any arithmetic
       progression coprime to ` N ` .  Theorem 9.4.1 of [Shapiro], p. 375.
       (Contributed by Mario Carneiro, 30-Apr-2016.)  (Proof shortened by Mario
       Carneiro, 26-May-2016.) $)
    dirith2 $p |- ( ph -> ( Prime i^i T ) ~~ NN ) $=
      ( vx vn cn wbr wcel crp cr vp cprime cin cdom csdm cen cvv wss nnex inss1
      wn cv prmnn ssriv sstri ssdomg mp2 a1i cfn clog cfv cmpt co1 logno1 wa c1
      cphi cfl cfz co cdiv csu cmul adantr nnred simpr inss2 ssfi sylancl sseli
      phicld sseldi nnrpd relogcl syl nndivred sylan2 fsumrecl cc recnd o1const
      rpssre sylancr clo1 1re cle cc0 log1 nnge1d wb 1rp logleb mpbid syl5eqbrr
      divge0d fsumless ello1d fsumge0 o1lo12 mpbird o1mul2 remulcld adantl cmin
      0re rplogsum o1dif ex mtoi com nnenom sdomentr mpan2 isfinite2 nsyl bren2
      sylanbrc ) AUBCUCZPUDQZYHPUEQZUKYHPUFQYIAPUGRYHPUHYIUIYHUBPUBCUJUAUBPUAUL
      UMUNUOZYHPUGUPUQURAYHUSRZYJAYLNSNULZUTVAZVBVCRZNVDAYLYOAYLVEZNSFVGVAZVFYM
      VHVAVIVJZYHUCZOULZUTVAZYTVKVJZOVLZVMVJZVBVCRYOYPNSYQUUCTYPYQTRYMSRZYPYQYP
      FAFPRYLJVNWAVOZVNYPUUCTRUUEYPYSUUBOYPYLYSYHUHZYSUSRAYLVPZYRYHVQZYHYSVRVSZ
      YTYSRZYPYTYHRZUUBTRYSYHYTUUIVTZYPUULVEZUUAYTUUNYTSRZUUATRUUNYTUUNYHPYTYKY
      PUULVPWBZWCZYTWDWEZUUPWFZWGZWHZVNZYPSTUHZYQWIRNSYQVBVCRWLYPYQUUFWJNSYQWKW
      MYPNSUUCVBZVCRUVDWNRYPNSUUCVFYHUUBOVLZUVCYPWLURUVBVFTRYPWOURYPYHUUBOUUHUU
      SWHYPUUCUVEWPQUUEVFYMWPQVEYPYHUUBYSOUUHUUSUUNUUAYTUURUUQUUNWQVFUTVAZUUAWP
      WRUUNVFYTWPQZUVFUUAWPQZUUNYTUUPWSUUNVFSRUUOUVGUVHWTXAUUQVFYTXBWMXCXDXEZUU
      GYPUUIURXFVNXGYPNSUUCWQUVBWQTRYPXOURYPWQUUCWPQUUEYPYSUUBOUUJUUTUUKYPUULWQ
      UUBWPQUUMUVIWGXHVNXIXJXKYPNSUUDYNYPUUDWIRUUEYPUUDYPYQUUCUUFUVAXLWJVNYPUUE
      VEYNUUEYNTRYPYMWDXMWJANSUUDYNXNVJVBVCRYLANBCDEFGOHIJKLMXPVNXQXCXRXSYJYHXT
      UEQZYLYJPXTUFQUVJYAYHPXTYBYCYHYDWEYEYHPYFYG $.
  $}

  ${
    $d p A $.  $d p N $.
    $( Dirichlet's theorem: there are infinitely many primes in any arithmetic
       progression coprime to ` N ` .  Theorem 9.4.1 of [Shapiro], p. 375.  See
       ~ http://metamath-blog.blogspot.com/2016/05/dirichlets-theorem.html for
       an informal exposition.  (Contributed by Mario Carneiro,
       12-May-2016.) $)
    dirith $p |- ( ( N e. NN /\ A e. ZZ /\ ( A gcd N ) = 1 ) ->
      { p e. Prime | N || ( p - A ) } ~~ NN ) $=
      ( cn wcel cz cgcd co c1 wceq w3a cprime czn cfv czrh ccnv wb eqid syl2anc
      adantr csn cima cin cv cmin cdivides wbr crab cen wa wfn cn0 simp1 nnnn0d
      cbs wfo znzrhfo fofn 3syl prmz adantl fniniseg baibd simp2 zndvds syl3anc
      bitrd rabbi2dva cui simp3 znunit mpbird dirith2 eqbrtrrd ) BDEZAFEZABGHIJ
      ZKZLBMNZONZPAVTNZUAUBZUCBCUDZAUEHUFUGZCLUHDUIVRWDCLWBVRWCLEZUJZWCWBEZWCVT
      NWAJZWDWFVTFUKZWCFEZWGWHQWFBULEZFVSUONZVTUPWIVRWKWEVRBVOVPVQUMZUNZTZWLVTB
      VSVSRZWLRVTRZUQFWLVTURUSWEWJVRWCUTVAZWIWGWJWHFWAWCVTVBVCSWFWKWJVPWHWDQWOW
      RVRVPWEVOVPVQVDZTWCAVTBVSWPWQVEVFVGVHVRWAWBVSVINZVTBVSWPWQWMWTRZVRWAWTEZV
      QVOVPVQVJVRWKVPXBVQQWNWSAWTVTBVSWPXAWQVKSVLWBRVMVN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          The Prime Number Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k m n x y $.
    $( Asymptotic formula for ` sum_ n <_ x , mmu ( n ) / n = O(1) ` .
       Equation 10.2.1 of [Shapiro], p. 405.  (Contributed by Mario Carneiro,
       14-May-2016.) $)
    mudivsum $p |- ( x e. RR+ |-> sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( mmu ` n ) / n ) ) e. O(1) $=
      ( crp c1 cfv co cdiv csu wcel wtru cmul caddc cr a1i cc syl cle wbr wceq
      wa vk vy vm cfl cfz cmu cmpt co1 cmin cvv 1re cof reex rpssre ssexi fzfid
      cv rpre elfznn nndivre syl2an recnd reflcl subcld adantl mucl zcnd mulcld
      cn cz fsumcl rpcn rpne0 divcld ovex eqidd offval2 wss cabs adantr cc0 wne
      absdivd rprege0 absid oveq2d eqtrd abscld adantlr fsumrecl fsumabs sselda
      ssriv absmuld absge0d simpl nnrpd rpdivcl flle abssubge0d fracle1 eqbrtrd
      sseldi mule1 lemul12ad 1t1e1 syl6breq fsumle cfn ax-1cn fsumconst syl2anc
      chash flge1nn sylan nnnn0d hashfz1 oveq1d mulid1d 3eqtrd breqtrd breqtrrd
      cn0 letrd ledivmuld mpbird elo1d crli divrcnv ax-mp rlimo1 o1add eqeltrrd
      mp1i rpcnne0 w3a eqtr3d syl3anc 3eqtr3d sumeq2dv fsummulc2 fsumadd npcand
      zred nndivred div23 divass cdivides crab ssrab2 simprr dvdsflsumcom 3impb
      adddird 2sumeq2dv cuz nnuz syl6eleq eluzfz1 musumsum flge0nn0 4syl divdir
      3eqtr3rd divcan3d fveq2d eqle o1le trud ) ACDAUQZUDEZUEFZBUQZUFEZUVMGFZBH
      ZUGUHIJACUVLUVJUVMGFZUVQUDEZUIFZUVNKFZBHZUVJGFZDUVJGFZLFZUVPDUJDMIZJUKNZJ
      ACUWBUGZACUWCUGZLULFZACUWDUGUHJACUWBUWCLUWGUWHUJOUJCUJIJCMUMUNUONUVJCIZUW
      BOIJUWJUWAUVJUWJUVLUVTBUWJDUVKUPZUWJUVMUVLIZTZUVSUVNUWMUVQUVRUWMUVQUWJUVJ
      MIZUVMVIIZUVQMIZUWLUVJURZUVMUVKUSZUVJUVMUTVAZVBZUWMUVRUWMUWPUVRMIZUWSUVQV
      CZPVBZVDZUWMUVNUWMUWOUVNVJIZUWLUWOUWJUWRVEZUVMVFZPZVGZVHZVKZUVJVLZUVJVMZV
      NVEZUWCUJIJUWJTZDUVJGVONJUWGVPJUWHVPVQJUWGUHIUWHUHIZUWIUHIJACUWBDDCMVRJUN
      NUXNUWFUWFUWJDUVJQRZTZUWBVSEZDQRJUXRUXSUWAVSEZUVJGFZDQUXRUXSUXTUVJVSEZGFU
      YAUXRUWAUVJUWJUWAOIZUXQUXKVTZUWJUVJOIZUXQUXLVTZUWJUVJWAWBZUXQUXMVTZWCUXRU
      YBUVJUXTGUWJUYBUVJSZUXQUWJUWNWAUVJQRTUYIUVJWDUVJWEPVTWFWGUXRUYADQRUXTUVJD
      KFZQRUXRUXTUVJUYJQUXRUXTUVLUVTVSEZBHZUVJUXRUWAUYDWHZUXRUVLUYKBUXRDUVKUPZU
      XRUWLTZUVTUWJUWLUVTOIUXQUXJWIZWHZWJZUWJUWNUXQUWQVTZUXRUVLUVTBUYNUYPWKUXRU
      YLUVKUVJUYRUXRUWNUVKMIUYSUVJVCPZUYSUXRUYLUVLDBHZUVKQUXRUVLUYKDBUYNUYQUWEU
      YOUKNZUYOUYKUVSVSEZUVNVSEZKFZDQUYOUVSUVNUWJUWLUVSOIUXQUXDWIZUYOUVNUYOUWOU
      XEUXRUVLVIUVMUVLVIVRUXRUAUVLVIUAUQZUVKUSWMNZWLZUXGPVGZWNUYOVUEDDKFDQUYOVU
      CDVUDDUYOUVSVUFWHVUBUYOUVNVUJWHVUBUYOUVSVUFWOUYOUVNVUJWOUYOVUCUVSDQUYOUVR
      UVQUYOUWPUXAUYOCMUVQUNUXRUWJUVMCIZUVQCIZUWLUWJUXQWPZUWLUVMUWRWQUVJUVMWRVA
      ZXCZUXBPVUOUYOUWPUVRUVQQRVUOUVQWSPWTUYOUWPUVSDQRVUOUVQXAPXBUYOUWOVUDDQRVU
      IUVMXDPXEXFXGXBXHUXRVUAUVLXMEZDKFZUVKDKFUVKUXRUVLXIIDOIZVUAVUQSUYNVURUXRX
      JNZUVLDBXKXLUXRVUPUVKDKUXRUVKYCIVUPUVKSUXRUVKUWJUWNUXQUVKVIIUWQUVJXNXOZXP
      UVKXQPXRUXRUVKUXRUVKUYTVBXSXTYAUXRUWNUVKUVJQRUYSUVJWSPYDYDUXRUVJUYFXSYBUX
      RUXTDUVJUYMUWEUXRUKNVUMYEYFXBVEYGUWHWAYHRZUXPJVURVVAXJDAYIYJWAUWHYKYNUWGU
      WHYLXLYMUWDUJIUXOUWBUWCLVONUWJUVPOIZJUWJUVLUVOBUWKUWMUVOUWMUVNUVMUWMUVNUX
      HUUDUXFUUEVBZVKZVEUXRUVPVSEZUWDVSEZQRZJUXRVVEMIVVEVVFSVVGUXRUVPUWJVVBUXQV
      VDVTZWHUXRUVPUWDVSUXRUVJUVPKFZUVJGFUWADLFZUVJGFZUVPUWDUXRVVIVVJUVJGUXRVVI
      UVLUVJUVOKFZBHZVVJUXRUVLUVOUVJBUYNUYFUWJUWLUVOOIUXQVVCWIUUAUXRUVLUVTUVRUV
      NKFZLFZBHUWAUVLVVNBHZLFVVMVVJUXRUVLUVTVVNBUYNUYPUWJUWLVVNOIUXQUWMUVRUVNUX
      CUXIVHWIUUBUXRUVLVVOVVLBUYOUVSUVRLFZUVNKFUVQUVNKFZVVOVVLUYOVVQUVQUVNKUYOU
      VQUVRUWJUWLUVQOIUXQUWTWIUWJUWLUVROIUXQUXCWIZUUCXRUYOUVSUVRUVNVUFVVSVUJUUN
      UYOUYEUVNOIZUVMOIUVMWAWBTZVVRVVLSUXRUYEUWLUYFVTVUJUYOVUKVWAUYOUVMVUIWQUVM
      YOPUYEVVTVWAYPUVJUVNKFUVMGFVVRVVLUVJUVNUVMUUFUVJUVNUVMUUGYQYRYSYTUXRVVPDU
      WALUXRUVLUBUQVUGUUHRZUBVIUUIZUVNBHUAHZUVLDUVRUEFZUVNUCHZBHDVVPUXRUBUVJUVN
      UVNUCUABVUGUVMUCUQKFSUVNVPUYSUXRVUGUVLIZUVMVWCIZTTZUVNVWIUWOUXEVWIVWCVIUV
      MVWBUBVIUUJUXRVWGVWHUUKXCUXGPVGZUULUXRUVLVWCUVNDKFZBHUAHVWDDUXRUVLVWCVWKU
      VNUABUXRVWGVWHYPUVNUXRVWGVWHVVTVWJUUMXSUUOUXRUVLDDBUAUBVUGDSDVPUYNVUHUXRU
      VKDUUPEZIDUVLIUXRUVKVIVWLVUTUUQUURDUVKUUSPVURUXRVWGTXJNUUTYQUXRUVLVWFVVNB
      UYOVWFVWEXMEZUVNKFZVVNUYOVWEXIIVVTVWFVWNSUYODUVRUPVUJVWEUVNUCXKXLUYOVWMUV
      RUVNKUYOVULUWPWAUVQQRTUVRYCIVWMUVRSVUNUVQWDUVQUVAUVRXQUVBXRWGYTUVDWFYSWGX
      RUXRUVPUVJVVHUYFUYHUVEUXRUYCVURUYEUYGTZVVKUWDSUYDVUSUWJVWOUXQUVJYOVTUWADU
      VJUVCYRYSUVFVVEVVFUVGXLVEUVHUVI $.

    $( Lemma for ~ mulogsum .  (Contributed by Mario Carneiro, 14-May-2016.) $)
    mulogsumlem $p |- ( x e. RR+ |-> sum_ n e. ( 1 ... ( |_ ` x ) )
      ( ( ( mmu ` n ) / n ) x.
        ( sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) ) ( 1 / m ) -
          ( log ` ( x / n ) ) ) ) ) e. O(1) $=
      ( crp c1 cfv co cdiv csu cmin cmul wcel wtru cem cc wa syl a1i cle wbr cv
      cfl cfz cmu clog cmpt co1 fzfid cn elfznn adantl mucl zred nndivred recnd
      cz fsumcl emre recni mudivsum cr wss rpssre o1const mp2an o1mul2 nnrecred
      fsumrecl rpdivcl sylan2 relogcld resubcld remulcld sylancl nnrecre subcld
      nnrpd mulcl caddc mulcld subsub4d oveq2d subdid eqtr3d sumeq2dv fsummulc1
      fsumsub 3eqtr4d mpteq2ia addcld 1re cabs fsumabs cc0 cn0 rprege0 flge0nn0
      abscld nn0red rerpdivcl mpancom rpreccl adantr rpred syl2anr nncnd nnne0d
      id absge0d absdivd wceq absid eqtrd lediv1dd eqbrtrd harmonicbnd4 rpcnne0
      mule1 wne recdiv syl2anc breqtrd lemul12ad absmuld ax-1cn syl3anc mulcomd
      dmdcan rpcnd 3brtr4d fsumle chash oveq1d cfn fsumconst nn0cnd rpcn mpbird
      hashfz1 letrd rpne0 divrecd rpre flle mulid1d breqtrrd clt reflcl rpregt0
      wb ledivmul ad2antrl elo1d syl5eqelr o1dif trud ) ADEAUAZUBFZUCGZCUAZUDFZ
      UUTHGZEUUQUUTHGZUBFZUCGZEBUAZHGZBIZUVCUEFZJGZKGZCIZUFUGLZMUVMADUUSUVBCIZN
      KGZUFUGLMADUVNNOUUQDLZUVNOLZMUVPUUSUVBCUVPEUURUHZUVPUUTUUSLZPZUVBUVTUVAUU
      TUVTUVAUVTUUTUILZUVAUPLUVSUWAUVPUUTUURUJZUKZUUTULQUMZUWCUNZUOZUQZUKNOLZMU
      VPPNURUSZRADUVNUFUGLMACUTRADNUFUGLZMDVAVBZUWHUWJVCUWIADNVDVERVFMADUVLUVOU
      VPUVLOLMUVPUVLUVPUUSUVKCUVRUVTUVBUVJUWEUVTUVHUVIUVTUVEUVGBUVTEUVDUHZUVTUV
      FUVELZPZUVFUWMUVFUILZUVTUVFUVDUJUKZVGVHUVTUVCUVSUVPUUTDLZUVCDLZUVSUUTUWBV
      QZUUQUUTVIVJZVKZVLVMVHUOUKUVPUVOOLZMUVPUVQUWHUXBUWGUWIUVNNVRVNUKMADUVLUVO
      JGZUFADUUSUVBUVHUVINVSGZJGZKGZCIZUFUGADUXGUXCUVPUUSUVKUVBNKGZJGZCIUVLUUSU
      XHCIZJGUXGUXCUVPUUSUVKUXHCUVRUVTUVBUVJUWFUVTUVHUVIUVTUVEUVGBUWLUWNUWOUVGO
      LUWPUWOUVGUVFVOUOQUQZUVTUVIUXAUOZVPZVTUVTUVBOLUWHUXHOLUWFUWIUVBNVRVNWGUVP
      UUSUXFUXICUVTUVBUVJNJGZKGUXFUXIUVTUXNUXEUVBKUVTUVHUVINUXKUXLUWHUVTUWIRZWA
      WBUVTUVBUVJNUWFUXMUXOWCWDWEUVPUVOUXJUVLJUVPUUSUVBNCUVRUWHUVPUWIRUWFWFWBWH
      WIMADUXGEEUWKMVCRUVPUXGOLMUVPUUSUXFCUVRUVTUVBUXEUWFUVTUVHUXDUXKUVTUVINUXL
      UXOWJVPZVTZUQZUKEVALZMWKRZUXTUVPUXGWLFZESTMEUUQSTUVPUYAUUSUXFWLFZCIZEUVPU
      XGUXRWRUVPUUSUYBCUVRUVTUXFUXQWRZVHZUXSUVPWKRZUVPUUSUXFCUVRUXQWMUVPUYCUURU
      UQHGZEUYEUURVALZUVPUYGVALUVPUURUVPUUQVALZWNUUQSTPUURWOLZUUQWPUUQWQQZWSUUR
      UUQWTXAUYFUVPUYCUUSEUUQHGZCIZUYGSUVPUUSUYBUYLCUVRUYDUVTUYLUVPUYLDLUVSUUQX
      BZXCXDUVTUVBWLFZUXEWLFZKGEUUTHGZUUTUUQHGZKGZUYBUYLSUVTUYOUYQUYPUYRUVTUVBU
      WFWRUVTUUTUWCVGZUVTUXEUXPWRUVTUYRUVSUWQUVPUYRDLUVPUWSUVPXHUUTUUQVIXEZXDUV
      TUVBUWFXIUVTUXEUXPXIUVTUYOUVAWLFZUUTHGZUYQSUVTUYOVUBUUTWLFZHGVUCUVTUVAUUT
      UVTUVAUWDUOZUVTUUTUWCXFUVTUUTUWCXGXJUVTVUDUUTVUBHUVTUUTVALWNUUTSTPZVUDUUT
      XKUVTUWQVUFUVTUUTUWCVQZUUTWPQUUTXLQWBXMUVTVUBEUUTUVTUVAVUEWRUXSUVTWKRVUGU
      VTUWAVUBESTUWCUUTXRQXNXOUVTUYPEUVCHGZUYRSUVTUWRUYPVUHSTUWTUVCBXPQUVTUUQOL
      UUQWNXSPZUUTOLUUTWNXSPZVUHUYRXKUVPVUIUVSUUQXQXCZUVTUWQVUJVUGUUTXQQZUUQUUT
      XTYAYBYCUVTUVBUXEUWFUXPYDUVTUYRUYQKGZUYLUYSUVTVUJVUIEOLZVUMUYLXKVULVUKVUN
      UVTYERUUTUUQEYHYFUVTUYRUYQUVTUYRVUAYIUVTUYQUYTUOYGWDYJYKUVPUUSYLFZUYLKGZU
      URUYLKGUYMUYGUVPVUOUURUYLKUVPUYJVUOUURXKUYKUURYSQYMUVPUUSYNLUYLOLUYMVUPXK
      UVRUVPUYLUYNYIUUSUYLCYOYAUVPUURUUQUVPUURUYKYPUUQYQZUUQUUAUUBWHYBUVPUYGEST
      ZUURUUQEKGZSTZUVPUURUUQVUSSUVPUYIUURUUQSTUUQUUCZUUQUUDQUVPUUQVUQUUEUUFUVP
      UYHUXSUYIWNUUQUUGTPVURVUTUUJUVPUYIUYHVVAUUQUUHQUYFUUQUUIUUREUUQUUKYFYRYTY
      TUULUUMUUNUUOYRUUP $.

    $( Asymptotic formula for
       ` sum_ n <_ x , ( mmu ( n ) / n ) log ( x / n ) = O(1) ` .  Equation
       10.2.6 of [Shapiro], p. 406.  (Contributed by Mario Carneiro,
       14-May-2016.) $)
    mulogsum $p |- ( x e. RR+ |-> sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( mmu ` n ) / n ) x. ( log ` ( x / n ) ) ) ) e. O(1) $=
      ( vm vk vy crp c1 cv cfv co cdiv cmul csu wcel wtru cc wa a1i cn adantl
      cfl cfz cmu clog cmpt co1 cr wss rpssre ax-1cn o1const mp2an fzfid elfznn
      cz mucl zred nndivred nnrpd rpdivcl sylan2 relogcld remulcld recnd fsumcl
      syl cmin mulogsumlem cvv sumex o1mptrcl subcld 1re cle wbr wceq ssriv cc0
      sselda rpcnne0d reccl simpl syl2an subdid sumeq2dv mulcld adantlr fsumsub
      cdivides crab oveq2 oveq2d rpre adantr ssrab2 simprr sseldi zcnd nnrecred
      wne adantrr dvdsflsumcom div1i syl6eq flge1nn sylan nnuz syl6eleq eluzfz1
      cuz musumsum divdiv1 syl3anc nncnd nnne0d divrecd nnmulcl 3eqtr3rd eqtr4d
      fsummulc2 oveq1d 3eqtrd o1eq mpbii o1dif trud ) AFGAHZUAIZUBJZBHZUCIZYJKJ
      ZYGYJKJZUDIZLJZBMZUEUFNZOAFGUEUFNZYQFUGUHGPNZYRUIUJAFGUKULOAFGYPYSOYGFNZQ
      ZUJRZYTYPPNOYTYIYOBYTGYHUMYTYJYINZQZYOUUDYLYNUUDYKYJUUDYKUUDYJSNZYKUONZUU
      CUUEYTYJYHUNZTZYJUPZVFUQUUHURUUDYMUUCYTYJFNZYMFNZUUCYJUUGUSZYGYJUTZVAVBVC
      VDZVETZOAFYIYLGYMUAIZUBJZGCHZKJZCMZYNVGJLJZBMZUEUFNZAFGYPVGJZUEUFNACBVHZO
      AFUVBUVDGOAFUVBVIUVBVINUUAYIUVABVJRUVCOUVERVKUUAGYPUUBUUOVLGUGNOVMRYTGYGV
      NVOZQZUVBUVDVPOUVGUVBYIYLUUTLJZYOVGJZBMYIUVHBMZYPVGJUVDUVGYIUVAUVIBUVGUUC
      QZYLUUTYNUVKYLUVKYKYJUVKYKUVKUUEUUFUVGYISYJYISUHUVGDYISDHZYHUNZVQRZVSZUUI
      VFZUQUVOURVDZUVKUUQUUSCUVKGUUPUMZUVKUURUUQNZQZUURPNUURVRWTQZUUSPNUVTUURUV
      TUURUVSUURSNZUVKUURUUPUNZTZUSVTZUURWAVFZVEZUVKYNUVKYMUVGYTUUJUUKUUCYTUVFW
      BUULUUMWCVBVDWDWEUVGYIUVHYOBUVGGYHUMZUVKYLUUTUVQUWGWFYTUUCYOPNUVFUUNWGWHU
      VGUVJGYPVGUVGYIEHUVLWIVOZESWJZYKGUVLKJZLJZBMDMYIUUQYKGYJUURLJZKJZLJZCMZBM
      GUVJUVGEYGUWLUWOCDBUVLUWMVPUWKUWNYKLUVLUWMGKWKWLYTYGUGNZUVFYGWMZWNUVGUVLY
      INZYJUWJNZQQZYKUWKUXAYKUXAUUEUUFUXAUWJSYJUWIESWOUVGUWSUWTWPWQUUIVFWRUVGUW
      SUWKPNUWTUVGUWSQZUWKUXBUVLUWSUVLSNUVGUVMTWSVDZXAWFXBUVGYIUWKGBDEUVLGVPUWK
      GGKJGUVLGGKWKGUJXCXDUWHUVNUVGYHGXJIZNGYINUVGYHSUXDYTUWQUVFYHSNUWRYGXEXFXG
      XHGYHXIVFUXCXKUVGYIUWPUVHBUVKUWPUUQYLUUSLJZCMUVHUVKUUQUWOUXECUVTYLUURKJZY
      KUWMKJZUXEUWOUVTYKPNZYJPNYJVRWTQUWAUXFUXGVPUVKUXHUVSUVKYKUVPWRWNZUVTYJUVT
      YJUVKUUEUVSUVOWNUSVTUWEYKYJUURXLXMUVTYLUURUVKYLPNUVSUVQWNUVTUURUWDXNUVTUU
      RUWDXOXPUVTYKUWMUXIUVTUWMUVKUUEUWBUWMSNUVSUVOUWCYJUURXQWCZXNUVTUWMUXJXOXP
      XRWEUVKUUQUUSYLCUVRUVQUWFXTXSWEXRYAYBTYCYDYEYDYF $.
  $}

  ${
    $d i k m n x y A $.  $d x F $.  $d n x L $.  $d k m n x ph $.  $d n x R $.
    logdivsum.1 $e |- F = ( y e. RR+ |->
      ( sum_ i e. ( 1 ... ( |_ ` y ) ) ( ( log ` i ) / i ) -
        ( ( ( log ` y ) ^ 2 ) / 2 ) ) ) $.
    $( Asymptotic analysis of
       ` sum_ n <_ x , log n / n = ( log x ) ^ 2 / 2 + L + O ( log x / x ) ` .
       (Contributed by Mario Carneiro, 18-May-2016.) $)
    logdivsum $p |- ( F : RR+ --> RR /\ F e. dom ~~>r /\
      ( ( F ~~>r L /\ A e. RR+ /\ _e <_ A ) ->
        ( abs ` ( ( F ` A ) - L ) ) <_ ( ( log ` A ) / A ) ) ) $=
      ( vx crp cr wcel wbr ceu co cdiv wtru c2 c1 a1i cmpt cc crli cdm cle cmin
      wf w3a cfv cabs clog wi cv cexp cc0 cn cpnf cioo ioorp eqcomi nnuz cz ere
      1z caddc 0re epos ltleii wb addge02 mp2an sylib wa relogcl adantl resqcld
      1re rehalfcld rerpdivcl mpancom nnrp sylan2 cdv cmul cvv reex prid1 prid2
      cpr cnex recnd ovex sqcl halfcld simpr cres dvrelog wf1o relogf1o feqmptd
      f1of mp1i fvres mpteq2ia syl6eq oveq2d syl5reqr wceq 2nn dvexp 2m1e1 exp1
      oveq2i syl5eq mpteq2dva eqtrd 2cn wne 2ne0 dvmptdivc divcan3 oveq1 oveq1d
      mp3an23 id dvmptco rpne0 divrecd eqtr4d fveq2 oveq12d simp3r simp2l rpred
      rpcn simp3l simp2r letrd logdivle syl22anc mpbid ccxp cxp1d 1rp cxploglim
      syl5eqbrr dvfsumrlim3 trud ) HIDUEDUAUBJDEUAKBHJLBUCKUFBDUGEUDMUHUGBUIUGZ
      BNMZUCKUJUFOAAUKZUIUGZPULMZPNMZUUJUUINMZCUKZUIUGZUUNNMZLHUMCUUHDEQIBUNUMU
      OUPMHUQURUSQUTJOVBRLIJZOVAROUMLUCKZQLQVCMUCKZUUROUMLVDVAVEVFRQIJUUQUURUUS
      VGVOVAQLVHVIVJUMIJOVDROUUIHJZVKZUUKUVAUUJUUTUUJIJZOUUIVLZVMZVNVPUUTUUMIJZ
      OUVBUUTUVEUVCUUJUUIVQVRVMZUUIUNJOUUTUVEUUIVSUVFVTOIAHUULSWAMAHUUJQUUINMZW
      BMZSAHUUMSZOAGUUJUVGGUKZPULMZPNMZUVJITUULUUJWCTHTIITWGZJOITWDWERTUVMJOITW
      HWFRZUVAUUJUVDWIZUVGWCJUVAQUUINWJROUVJTJZVKZUVKUVPUVKTJOUVJWKVMZWLOUVPWMO
      AHUVGSIUIHWNZWAMIAHUUJSZWAMAWOOUVSUVTIWAOUVSAHUUIUVSUGZSUVTOAHIUVSHIUVSWP
      HIUVSUEOWQHIUVSWSWTWRAHUWAUUJUUIHUIXAXBXCXDXEOTGTUVLSWAMGTPUVJWBMZPNMZSGT
      UVJSOGUVKUWBPTWCTUVNUVRUWBWCJUVQPUVJWBWJROTGTUVKSWAMZGTPUVJPQUDMZULMZWBMZ
      SZGTUWBSPUNJUWDUWHXFOXGGPXHWTOGTUWGUWBUVQUWFUVJPWBUVQUWFUVJQULMZUVJUWEQUV
      JULXIXKUVPUWIUVJXFOUVJXJVMXLXDXMXNPTJZOXORPUMXPZOXQRXROGTUWCUVJUVPUWCUVJX
      FZOUVPUWJUWKUWLXOXQUVJPXSYBVMXMXNUVJUUJXFZUVKUUKPNUVJUUJPULXTYAUWMYCYDOAH
      UUMUVHUVAUUJUUIUVOUUTUUITJOUUIYMZVMUUTUUIUMXPOUUIYEVMYFXMYGUUIUUNXFZUUJUU
      OUUIUUNNUUIUUNUIYHUWOYCYIOUUTUUNHJZVKZLUUIUCKZUUIUUNUCKZVKZUFZUWSUUPUUMUC
      KZOUWQUWRUWSYJZUXAUUIIJUWRUUNIJLUUNUCKUWSUXBVGUXAUUIOUUTUWPUWTYKYLZOUWQUW
      RUWSYNZUXAUUNOUUTUWPUWTYOYLZUXALUUIUUNUUQUXAVARUXDUXFUXEUXCYPUUIUUNYQYRYS
      FOUVIAHUUJUUIQYTMZNMZSZUMUAAHUXHUUMUUTUXGUUIUUJNUUTUUIUWNUUAXDXBQHJUXIUMU
      AKOUUBQAUUCWTUUDUUIBXFZUUJUUGUUIBNUUIBUIYHUXJYCYIUUEUUF $.

    mulog2sumlem.1 $e |- ( ph -> F ~~>r L ) $.
    ${
      mulog2sumlem1.2 $e |- ( ph -> A e. RR+ ) $.
      mulog2sumlem1.3 $e |- ( ph -> _e <_ A ) $.
      $( Asymptotic formula for
         ` sum_ n <_ x , log ( x / n ) / n = ( 1 / 2 ) log ^ 2 ( x ) + `
         ` gamma x. log x - L + O ( log x / x ) ` , with explicit constants.
         Equation 10.2.7 of [Shapiro], p. 407.  (Contributed by Mario Carneiro,
         18-May-2016.) $)
      mulog2sumlem1 $p |- ( ph ->
       ( abs ` ( sum_ m e. ( 1 ... ( |_ ` A ) ) ( ( log ` ( A / m ) ) / m ) -
         ( ( ( ( log ` A ) ^ 2 ) / 2 ) + ( ( gamma x. ( log ` A ) ) - L ) ) ) )
         <_ ( 2 x. ( ( log ` A ) / A ) ) ) $=
        ( cfv co cdiv cmul cmin caddc wcel cr recnd vx c1 cfl cfz clog csu cexp
        cv c2 cem cabs fzfid wa crp elfznn nnrpd rpdivcl syl2an relogcld adantl
        nndivred fsumrecl resqcld rehalfcld emre remulcl sylancr csup cpnf wceq
        cn cxr clt rpsup a1i cmpt crli wf cdm wbr ceu cle w3a logdivsum feqmptd
        wi simp1i eqbrtrrd ffvelrni rlimrecl resubcld readdcld abscld rerpdivcl
        fsumcl readdcl sylancl mulcld subcld addcld 2re rerpdivcld relogdiv cc0
        oveq1d cc wne adantr rpcnne0d divsubdir syl3anc sumeq2dv fsumsub pncand
        eqtrd recni adddid 2halvesd sqvald add32d 3eqtr2d mulcom oveq2d eqeltrd
        3eqtr4rd addsubassd subsub4d 3eqtr3d oveq12d sub4d fveq2d abs2dif2d syl
        wb mpbid rpcnd rpne0d divrecd eqtr4d fveq2 eqbrtrd harmonicbnd4 0re 1re
        nnrecred rprecred 0lt1 epr logleb syl5eqbrr ltletrd syl112anc fsummulc2
        loge lemul2 subdid absmuld absidd 3eqtrd 3brtr4d cbvsumv sumeq1d syl5eq
        ltled id ovex fvmpt simp3i le2addd 2timesd breqtrrd letrd ) AUBCUCLZUDM
        ZCEUHZNMZUELZUVONMZEUFZCUELZUIUGMZUINMZUJUVTOMZGPMZQMZPMZUKLZUVNUVTUVON
        MZEUFZUVTUVTUJQMZOMZPMZUKLZUVNUVOUELZUVONMZEUFZUWBGQMZPMZUKLZQMZUIUVTCN
        MZOMZAUWFAUWFAUVSUWEAUVNUVREAUBUVMULZAUVOUVNRZUMZUVQUVOUXEUVPACUNRZUVOU
        NRZUVPUNRUXDJUXDUVOUVOUVMUOZUPZCUVOUQURUSUXDUVOVKRAUXHUTZVAVBAUWBUWDAUW
        AAUVTACJUSZVCZVDZAUWCGAUJSRZUVTSRZUWCSRVEUXKUJUVTVFVGAUAUNUAUHZFLZGUNVL
        VMVHVIVJAVNVOAFUAUNUXQVPGVQAUAUNSFUNSFVRZAUXRFVQVSRZFGVQVTZUXFWACWBVTZW
        CCFLZGPMZUKLZUXAWBVTZWFZBCDFGHWDZWGZVOWEIWHUXPUNRUXQSRAUNSUXPFUYHWIUTWJ
        ZWKWLWKTWMAUWMUWSAUWLAUWIUWKAUVNUWHEUXCUXEUWHAUXOUXGUWHSRUXDUXKUXIUVTUV
        OWNURTZWOZAUVTUWJAUVTUXKTZAUWJAUXOUXNUWJSRUXKVEUVTUJWPWQZTZWRZWSZWMZAUW
        RAUWPUWQAUVNUWOEUXCUXEUWOUXEUWNUVOUXEUVOUXEUVOUXJUPZUSZUXJVATZWOZAUWBGA
        UWBUXMTZAGUYITZWTZWSZWMZWLAUISRUXASRUXBSRXAAUVTCUXKJXBZUIUXAVFVGAUWGUWL
        UWRPMZUKLUWTWBAUWFVUHUKAUWFUWIUWPPMZUWKUWQPMZPMVUHAUVSVUIUWEVUJPAUVSUVN
        UWHUWOPMZEUFVUIAUVNUVRVUKEUXEUVRUVTUWNPMZUVONMZVUKUXEUVQVULUVONAUXFUXGU
        VQVULVJUXDJUXICUVOXCURXEUXEUVTXFRZUWNXFRUVOXFRUVOXDXGUMVUMVUKVJAVUNUXDU
        YLXHZUXEUWNUYSTUXEUVOUYRXIUVTUWNUVOXJXKXOXLAUVNUWHUWOEUXCUYJUYTXMXOAUWB
        UWCQMZGPMUWKUWBPMZGPMUWEVUJAVUPVUQGPAUWBUVTUJOMZQMZUWBQMZUWBPMVUSVUQVUP
        AVUSUWBAVUSAUWBVURUXMAUXOUXNVURSRUXKVEUVTUJVFWQZWLTVUBXNAUWKVUTUWBPAUWK
        UVTUVTOMZVURQMUWBUWBQMZVURQMVUTAUVTUVTUJUYLUYLUJXFRZAUJVEXPZVOXQAVVCVVB
        VURQAVVCUWAVVBAUWAAUWAUXLTXRAUVTUYLXSXOXEAUWBUWBVURVUBVUBAVURVVATZXTYAX
        EAUWCVURUWBQAVVDVUNUWCVURVJVVEUYLUJUVTYBVGZYCYEXEAUWBUWCGVUBAUWCVURXFVV
        GVVFYDVUCYFAUWKUWBGUYOVUBVUCYGYHYIAUWIUWPUWKUWQUYKVUAUYOVUDYJXOYKAUWLUW
        RUYPVUEYLUUAAUWTUXAUXAQMUXBWBAUWMUWSUXAUXAUYQVUFVUGVUGAUVTUVNUBUVONMZEU
        FZUWJPMZUKLZOMZUVTUBCNMZOMZUWMUXAWBAVVKVVMWBVTZVVLVVNWBVTZAUXFVVOJCEUUB
        YMAVVKSRVVMSRUXOXDUVTVMVTVVOVVPYNAVVJAVVJAVVIUWJAUVNVVHEUXCUXEUVOUXJUUE
        ZVBUYMWKTWMACJUUFUXKAXDUBUVTXDSRAUUCVOZUBSRAUUDVOUXKXDUBVMVTAUUGVOAUBWA
        UELZUVTWBUUNAUYAVVSUVTWBVTZKAWAUNRUXFUYAVVTYNUUHJWACUUIVGYOUUJUUKZVVKVV
        MUVTUUOUULYOAUWMUVTVVJOMZUKLUVTUKLZVVKOMVVLAUWLVWBUKAUWLUVTVVIOMZUWKPMV
        WBAUWIVWDUWKPAUWIUVNUVTVVHOMZEUFVWDAUVNUWHVWEEUXEUVTUVOVUOUXEUVOUYRYPUX
        EUVOUYRYQYRXLAUVNVVHUVTEUXCUYLUXEVVHVVQTZUUMYSXEAUVTVVIUWJUYLAUVNVVHEUX
        CVWFWOZUYNUUPYSYKAUVTVVJUYLAVVIUWJVWGUYNWSUUQAVWCUVTVVKOAUVTUXKAXDUVTVV
        RUXKVWAUVDUURXEUUSAUVTCUYLACJYPACJYQYRUUTAUYDUWSUXAWBAUYCUWRUKAUYCUWPUW
        BPMZGPMUWRAUYBVWHGPAUXFUYBVWHVJJBCUBBUHZUCLZUDMZDUHZUELZVWLNMZDUFZVWIUE
        LZUIUGMZUINMZPMVWHUNFVWICVJZVWOUWPVWRUWBPVWSVWOVWKUWOEUFUWPVWKVWNUWODEV
        WLUVOVJZVWMUWNVWLUVONVWLUVOUEYTVWTUVEYIUVAVWSVWKUVNUWOEVWSVWJUVMUBUDVWI
        CUCYTYCUVBUVCVWSVWQUWAUINVWSVWPUVTUIUGVWICUEYTXEXEYIHUWPUWBPUVFUVGYMXEA
        UWPUWBGVUAVUBVUCYGXOYKAUXTUXFUYAUYEIJKUXRUXSUYFUYGUVHXKWHUVIAUXAAUXAVUG
        TUVJUVKUVL $.
    $}

    ${
      mulog2sumlem2.t $e |- T = ( ( ( ( log ` ( x / n ) ) ^ 2 ) / 2 ) +
        ( ( gamma x. ( log ` ( x / n ) ) ) - L ) ) $.
      mulog2sumlem2.r $e |- R = ( ( ( 1 / 2 ) + ( gamma + ( abs ` L ) ) ) +
        sum_ m e. ( 1 ... 2 ) ( ( log ` ( _e / m ) ) / m ) ) $.
      $( Lemma for ~ mulog2sum .  (Contributed by Mario Carneiro,
         19-May-2016.) $)
      mulog2sumlem2 $p |- ( ph -> ( x e. RR+ |->
        ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( ( mmu ` n ) / n ) x. T )
          - ( log ` x ) ) ) e. O(1) ) $=
        ( c2 c1 co wcel wbr cle vk crp cv cfl cfv cfz cdiv clog cmul caddc cmin
        csu cr 1re a1i wa 2re fzfid simpr elfznn nnrpd syl2an relogcld fsumrecl
        rpdivcl remulcl sylancr cem cabs ceu emre crli cc syl abscld readdcl cn
        epr adantl nndivred readdcld syl5eqel sylancl adantr wss co1 rpssre 2cn
        cmpt o1const mp1i cz zred cexp subcld mulcld fsumcl adantrr wceq sylan2
        recnd nncnd eqtrd sumeq2dv fsummulc2 cc0 wne jca syl3anc rpcnne0 fveq2d
        div23 divdiv1 oveq12d oveq2d oveq2 id rpred ere clt ltleii addge0d log1
        c3 1rp mulid2d letrd eqbrtrd mpbid wb logleb syl5eqbrr divge0 ad3antrrr
        syl21anc absidd syl6breq lediv1 sylan adantlr 2ne0 rereccli logfacrlim2
        cmu simplr rerpdivcld rlimcl rlimo1 o1mul2 o1add2 mucl halfcld ad2antrr
        addcld relogcl zcnd nnrp nnne0d div23d subdid fsumsub cdivides crab w3a
        sqcld divass eqtr3d rpre mulcomd ssrab2 simprr sseldi ad2antrl remulcld
        dvdsflsumcom eqtr4d ssriv cuz flge1nn syl2anc syl6eleq eluzfz1 adantlrr
        nnuz sselda musumsum rpcnd div1d oveq1d 3eqtrd 1lt2 egt2lt3 lttri mp2an
        simpli jctir rphalfcl ax-mp rpge0 0re absge0d elfzle2 lemuldivd divge0d
        fsumge0 syl6breqr 2pos fznnfl simplbda rpregt0 ad2antlr mulge0d absmuld
        emgt0 mule1 lemul1ad breqtrd mulog2sumlem1 abssubd oveq2i fveq2i syl6eq
        mulassd divdiv2 3brtr4d abs2dif2d syl5eqelr abstrid rehalfcld sqge0d wi
        resqcld pm3.2i ltle imp loge le2sqd sq1 lemul2 mulid1i leadd1dd le2addd
        0le1 recni syl5eqbr rpregt0d lemuldiv flcld 2z 3re simpri 3nn nnzi fllt
        lttrd zleltp1 mpbird eluz2 syl3anbrc fzss2 simplll syldan logled fsumle
        df-3 fsumless fsumharmonic df-2 oveq1i eqtr4i breqtrrd eqbrtrrd leabsd
        o1le ) ABUBOPBUCZUDUEZUFQZVVOHUCZUGQZUHUEZVVOUGQZHULZUIQZDOUIQZUJQZVVQV
        VRUUDUEZVVRUGQZEUIQZHULZVVOUHUEZUKQZPUMPUMRZAUNUOABUBVWCVWDUMAVVOUBRZUP
        ZOUMRZVWBUMRVWCUMRUQVWNVVQVWAHVWNPVVPURZVWNVVRVVQRZUPZVVTVVOVWRVVSVWNVW
        MVVRUBRVVSUBRZVWQAVWMUSZVWQVVRVVRVVPUTZVAVVOVVRVEVBZVCZAVWMVWQUUEUUFZVD
        ZOVWBVFVGZAVWDUMRZVWMADUMRZVWOVXGADPOUGQZVHJVIUEZUJQZUJQZPOUFQZVJGUCZUG
        QZUHUEZVXNUGQZGULZUJQZUMNAVXLVXRAVXIUMRZVXKUMRZVXLUMRZOUQUUAUUBZAVHUMRZ
        VXJUMRVYAVKAJAIJVLSZJVMRZLJIUUGVNZVOZVHVXJVPVGZVXIVXKVPVGZAVXMVXQGAPOUR
        ZAVXNVXMRZUPZVXPVXNVYMVXOVYMVJUBRZVXNUBRZVXOUBRZVRVYMVXNVYLVXNVQRZAVXNO
        UTZVSZVAZVJVXNVEVGZVCZVYSVTZVDZWAWBZUQDOVFWCZWDZABUBOVWBUMVWOVWNUQUOVXE
        AUBUMWEZOVMRZBUBOWIWFRWGWUIAWHUOBUBOWJVGBUBVWBWIZPVLSWUJWFRABHUUCPWUJUU
        HWKUUIAWUHVWDVMRBUBVWDWIWFRWGAVWDWUFXABUBVWDWJVGUUJVWNVWCVWDVXFWUGWAZVW
        NVWIVWJVWNVVQVWHHVWPVWRVWGEVWRVWGVWRVWFVVRVWRVWFVWRVVRVQRZVWFWLRZVWQWUL
        VWNVXAVSZVVRUUKZVNZWMWUNVTXAZVWREVVTOWNQZOUGQZVHVVTUIQZJUKQZUJQZVMMVWRW
        USWVAVWRWURVWRVVTVWRVVTVXCXAZUVEUULZVWRWUTJVWRWUTVWRVYDVVTUMRZWUTUMRZVK
        VXCVHVVTVFVGZXAZAVYFVWMVWQVYGUUMZWOZUUNWBZWPZWQVWNVWJVWMVWJUMRAVVOUUOVS
        XAZWOZAVWMPVVOTSZUPUPZVWKVIUEZVWEVWEVIUEZAVWMWVQUMRWVOVWNVWKWVNVOWRAVWM
        VWEUMRWVOWUKWRAVWMWVRUMRWVOVWNVWEVWNVWEWUKXAVOWRWVPVVQVWFEPVVSUDUEZUFQZ
        VVSVXNUGQZUHUEZVXNUGQZGULZUKQZUIQZVVRUGQZHULZVIUEZWVQVWETWVPWWHVWKVIWVP
        WWHVWIVVQVWGWWDUIQZHULZUKQZVWKAVWMWWHWWLWSWVOVWNWWHVVQVWHWWJUKQZHULWWLV
        WNVVQWWGWWMHVWRWWGVWGWWEUIQWWMVWRVWFWWEVVRVWRVWFWUPUUPZVWREWWDWVKVWRWVT
        WWCGVWRPWVSURZVXNWVTRZVWRVYQWWCVMRZVXNWVSUTZVWRVYQUPZWWCWWSWWBVXNWWSWWA
        VWRVWSVYOWWAUBRZVYQVXBVXNUUQVVSVXNVEVBZVCZVWRVYQUSZVTZXAZWTZWQZWOZVWRVV
        RWUNXBZVWRVVRWUNUURZUUSVWRVWGEWWDWUQWVKWXGUUTXCXDVWNVVQVWHWWJHVWPWVLVWR
        VWGWWDWUQWXGWPUVAXCWRWVPWWKVWJVWIUKWVPWWKVVQCUCUAUCZUVBSZCVQUVCZVWFVVOW
        XKUGQZUHUEZWXKUGQZUIQZHULUAULZVVOPUGQZUHUEZPUGQZVWJAVWMWWKWXRWSWVOVWNWW
        KVVQWVTVWFVVOVVRVXNUIQZUGQZUHUEZWYBUGQZUIQZGULZHULWXRVWNVVQWWJWYGHVWRWW
        JWVTVWGWWCUIQZGULWYGVWRWVTWWCVWGGWWOWUQWXFXEVWRWVTWYHWYFGWWPVWRVYQWYHWY
        FWSWWRWWSWYHVWFWWCVVRUGQZUIQZWYFWWSVWFVMRZWWQVVRVMRZVVRXFXGZUPZWYHWYJWS
        VWRWYKVYQWWNWDWXEVWRWYNVYQVWRWYLWYMWXIWXJXHZWDZWYKWWQWYNUVDVWFWWCUIQVVR
        UGQWYHWYJVWFWWCVVRXLVWFWWCVVRUVFUVGXIWWSWYIWYEVWFUIWWSWYIWWBVXNVVRUIQZU
        GQZWYEWWSWWBVMRVXNVMRZVXNXFXGUPZWYNWYIWYRWSWWSWWBWXBXAWWSVYOWYTWWSVXNWX
        CVAZVXNXJVNZWYPWWBVXNVVRXMXIWWSWWBWYDWYQWYBUGWWSWWAWYCUHWWSVVOVMRZWYNWY
        TWWAWYCWSVWRXUCVYQVWRVVOVWNVVOUMRZVWQVWMXUDAVVOUVHVSZWDZXAWDWYPXUBVVOVV
        RVXNXMXIXKWWSVXNVVRWWSVXNWXCXBZVWRWYLVYQWXIWDUVIXNXCXOXCWTXDXCXDVWNCVVO
        WXQWYFGUAHWXKWYBWSZWXPWYEVWFUIXUHWXOWYDWXKWYBUGXUHWXNWYCUHWXKWYBVVOUGXP
        XKXUHXQXNXOVWNVVOVWTXRVWNWXKVVQRZVVRWXMRZUPZUPZWXQXULVWFWXPXULVWFXULWUL
        WUMXULWXMVQVVRWXLCVQUVJVWNXUIXUJUVKUVLWUOVNWMXULWXOWXKXULWXNVWNVWMWXKUB
        RZWXNUBRZXUKVWTXUKWXKXUIWXKVQRZXUJWXKVVPUTZWDVAVVOWXKVEZVBVCXUIXUOVWNXU
        JXUPUVMVTUVNXAUVOUVPWRWVPVVQWXPWYAHUACWXKPWSZWXOWXTWXKPUGXURWXNWXSUHWXK
        PVVOUGXPXKXURXQXNWVPPVVPURVVQVQWEZWVPHVVQVQVXAUVQZUOWVPVVPPUVRUEZRPVVQR
        WVPVVPVQXVAWVPXUDWVOVVPVQRAVWMXUDWVOXUEWRAVWMWVOUVKVVOUVSUVTUWDUWAPVVPU
        WBVNAVWMXUIWXPVMRWVOVWNXUIUPZWXPXVBWXOWXKXVBWXNVWNVWMXUMXUNXUIVWTXUIWXK
        XUPVAXUQVBVCVWNVVQVQWXKXUSVWNXUTUOUWEVTXAUWCUWFAVWMWYAVWJWSWVOVWNWYAVWJ
        PUGQVWJVWNWXTVWJPUGVWNWXSVVOUHVWNVVOVWNVVOVWTUWGUWHXKUWIVWNVWJWVMUWHXCW
        RUWJXOXCXKAVWMWWIVWETSWVOVWNWWIVVQOVWAUIQZHULZDVJUHUEZPUJQZUIQZUJQVWETV
        WNVVOWWFXVCDVJHVWTVWNVJUMRZPVJTSXVHVWNXSUOPVJUNXSPOXTSOVJXTSZPVJXTSUWKX
        VIVJYDXTSZUWLUWOZPOVJUNUQXSUWMUWNYAUWPVWNVXHXFDTSZAVXHVWMWUEWDAXVLVWMAX
        FVXSDTAVXLVXRVYJWUDAVXIVXKVXTAVYCUOVYIVXIUBRZXFVXITSAPUBRZXVMYEPUWQUWRV
        XIUWSWKAVHVXJVYDAVKUOVYHXFVHTSZAXFVHUWTVKUXNYAZUOAJVYGUXAYBYBAVXMVXQGVY
        KWUCVYMVXPVXNWUBVYTVYMXFPUHUEZVXPTYCVYMPVXOTSZXVQVXPTSZVYMPVXNUIQZVJTSX
        VRVYMXVTVXNVJTVYMVXNVYMVXNVYSXBYFVYMVXNOVJVYMVXNVYTXRVWOVYMUQUOXVHVYMXS
        UOZVYLVXNOTSAVXNPOUXBVSOVJTSVYMOVJUQXSXVKYAUOYGYHVYMPVJVXNVWLVYMUNUOXWA
        VYTUXCYIVYMXVNVYPXVRXVSYJYEWUAPVXOYKVGYIYLUXDZUXEYBNUXFWDXHVWRVWFWWEWWN
        WXHWPZVWRVWOVWAUMRXVCUMRUQVXDOVWAVFVGZVWROVWAVWOVWRUQUOVXDXFOTSVWRXFOUW
        TUQUXGYAUOVWRWVEXFVVTTSXUDXFVVOXTSUPZXFVWATSVXCVWRXFXVQVVTTYCVWRPVVSTSZ
        XVQVVTTSZVWRPVVRUIQZVVOTSXWFVWRXWHVVRVVOTVWRVVRWXIYFVWNVWQWULVVRVVOTSZV
        WNXUDVWQWULXWIUPYJXUEVVRVVOUXHVNUXIYHVWRPVVOVVRVWLVWRUNUOZXUFVWRVVRWUNV
        AZUXCYIVWRXVNVWSXWFXWGYJYEVXBPVVSYKVGYIYLZVWMXWEAVWQVVOUXJUXKVVTVVOYMYO
        UXLVWRVJVVSTSZUPZWWFVIUEZWWEVIUEZXVCVVRUIQZVWRXWOUMRZXWMVWRWWFXWCVOZWDX
        WNWWEVWRWWEVMRXWMWXHWDVOVWRXWQUMRXWMVWRXVCVVRXWDVWRVVRXWKXRUVNWDVWRXWOX
        WPTSZXWMVWRXWOVWFVIUEZXWPUIQZXWPTVWRVWFWWEWWNWXHUXMVWRXXBPXWPUIQXWPTVWR
        XXAPXWPVWRVWFWWNVOXWJVWRWWEWXHVOZVWRWWEWXHUXAVWRWULXXAPTSWUNVVRUXOVNUXP
        VWRXWPVWRXWPXXCXAYFUXQYHZWDXWNWWDWVBUKQZVIUEZOVVTVVSUGQZUIQZXWPXWQTXWNC
        VVSFGIJKAVYEVWMVWQXWMLYNVWRVWSXWMVXBWDVWRXWMUSUXRXWNXWPWWDEUKQZVIUEZXXF
        VWRXWPXXJWSXWMVWREWWDWVKWXGUXSWDXXIXXEVIEWVBWWDUKMUXTUYAUYBVWRXWQXXHWSX
        WMVWRXWQOVWAVVRUIQZUIQXXHVWROVWAVVRWUIVWRWHUOVWRVWAVXDXAZWXIUYCVWRXXGXX
        KOUIVWRXXGVVTVVRUIQVVOUGQZXXKVWRVVTVMRZXUCVVOXFXGUPZWYNXXGXXMWSWVCVWMXX
        OAVWQVVOXJUXKZWYOVVTVVOVVRUYDXIVWRXXNWYLXXOXXMXXKWSWVCWXIXXPVVTVVRVVOXL
        XIXCXOUVPWDUYEYGVWRVVSVJXTSZUPZXWOXWPDVWRXWRXXQXWSWDVWRXWPUMRXXQXXCWDZA
        VXHVWMVWQXXQWUEYNZVWRXWTXXQXXDWDXXRXWPEVIUEZWWDVIUEZUJQZDXXSXXRXYAXYBXX
        REVWREVMRXXQWVKWDZVOZXXRWWDVWRWWDVMRXXQWXGWDZVOZWAXXTXXREWWDXYDXYFUYFXX
        RXYCVXSDTXXRXYAXYBVXLVXRXYEXYGAVYBVWMVWQXXQVYJYNZAVXRUMRVWMVWQXXQWUDYNZ
        XXRXYAWVBVIUEZVXLTEWVBVIMUYAZXXRXYJWUSVIUEZWVAVIUEZUJQVXLXXRXYJXYAUMXYK
        XYEUYGXXRXYLXYMXXRWUSVWRWUSVMRXXQWVDWDZVOZXXRWVAVWRWVAVMRXXQWVJWDZVOZWA
        XYHXXRWUSWVAXYNXYPUYHXXRXYLXYMVXIVXKXYOXYQVXTXXRVYCUOAVYAVWMVWQXXQVYIYN
        ZXXRXYLWUSVXITVWRXYLWUSWSXXQVWRWUSVWRWURVWRVVTVXCUYLZUYIVWRWURUMRZXFWUR
        TSVWOXFOXTSZUPZXFWUSTSXYSVWRVVTVXCUYJYUBVWRVWOYUAUQUXGUYMZUOWUROYMYOYPW
        DXXRWURPTSZWUSVXITSZXXRWURPOWNQZPTXXRVVTPTSZWURYUFTSZXXRVVTXVEPTXXRVVSV
        JTSZVVTXVETSZVWRXXQYUIVWRVVSUMRZXVHXXQYUIUYKVWRVVSVXBXRZXSVVSVJUYNWCUYO
        ZXXRVWSVYNYUIYUJYJVWRVWSXXQVXBWDVRVVSVJYKWCYIUYPYQZVWRYUGYUHYJXXQVWRVVT
        PVXCXWJXWLXFPTSVWRVUCUOUYQWDYIUYRYQXXRXYTVWLYUBYUDYUEYJVWRXYTXXQXYSWDVW
        LXXRUNUOZYUBXXRYUCUOWURPOYRXIYIYHXXRXYMWUTVXJUJQZVXKXYQVWRYUPUMRXXQVWRW
        UTVXJWVGVWRJWVIVOWAWDXYRXXRXYMWUTVIUEZVXJUJQYUPTXXRWUTJVWRWUTVMRXXQWVHW
        DAVYFVWMVWQXXQVYGYNZUYFXXRYUQWUTVXJUJVWRYUQWUTWSXXQVWRWUTWVGVWRVHVVTVYD
        VWRVKUOVXCXVOVWRXVPUOXWLUXLYPWDUWIUXQXXRWUTVHVXJVWRWVFXXQWVGWDVYDXXRVKU
        OZXXRJYURVOXXRWUTVHPUIQZVHTXXRYUGWUTYUTTSZYUNXXRWVEVWLVYDXFVHXTSZUPYUGY
        VAYJVWRWVEXXQVXCWDYUOXXRVYDYVBYUSUXNUWPVVTPVHUYSXIYIVHVHVKVUDUYTYQVUAYG
        VUBYGVUEXXRXYBWWDVXRTXXRWWDVWRWWDUMRXXQVWRWVTWWCGWWOWWPVWRVYQWWCUMRZWWR
        WXDWTZVDWDZVWRXFWWDTSXXQVWRWVTWWCGWWOYVDVWRWWPUPZWWBUMRZXFWWBTSVXNUMRXF
        VXNXTSUPZXFWWCTSWWPVWRVYQYVGWWRWXBWTYVFXFXVQWWBTYCYVFPWWATSZXVQWWBTSZYV
        FXVTVVSTSZYVIYVFXVTVXNVVSTYVFVXNWWPVWRVYQWYSWWRXUGWTYFVWRWWPVYQVXNVVSTS
        ZVWRYUKWWPVYQYVLUPYJYULVXNVVSUXHVNUXIYHYVFVWLYUKYVHYVKYVIYJVWLYVFUNUOVW
        RYUKWWPYULWDWWPVWRVYQYVHWWRWWSVXNXUAVUFWTZPVVSVXNVUGXIYIYVFXVNWWTYVIYVJ
        YJYEWWPVWRVYQWWTWWRWXAWTPWWAYKVGYIYLYVMWWBVXNYMYOUXEWDYPXXRWWDWVTVXQGUL
        VXRYVEXXRWVTVXQGXXRPWVSURZXXRWWPVYLVXQUMRZXXRWVTVXMVXNXXROWVSUVRUERZWVT
        VXMWEXXRWVSWLRZOWLRZWVSOTSZYVPVWRYVQXXQVWRVVSYULVUHWDZYVRXXRVUIUOXXRYVS
        WVSOPUJQZXTSZXXRWVSYDYWAXTXXRVVSYDXTSZWVSYDXTSZXXRVVSVJYDVWRYUKXXQYULWD
        ZXVHXXRXSUOYDUMRXXRVUJUOVWRXXQUSXVJXXRXVIXVJUWLVUKUOVUOXXRYUKYDWLRYWCYW
        DYJYWEYDVULVUMVVSYDVUNWCYIVVEYQXXRYVQYVRYVSYWBYJYVTVUIWVSOVUPWCVUQWVSOV
        URVUSWVSPOVUTVNZUWEZXXRAVYLYVOAVWMVWQXXQVVAZWUCYSZVVBZVDXYIXXRWVTWWCVXQ
        GYVNWWPXXRVYQYVCWWRVWRVYQYVCXXQWXDYTWTYWJXXRWWPVYLWWCVXQTSZYWGXXRVYLUPZ
        WWBVXPTSZYWKYWLWWAVXOTSZYWMYWLYUIYWNXXRYUIVYLYUMWDYWLYUKXVHYVHYUIYWNYJX
        XRYUKVYLYWEWDXVHYWLXSUOXXRAVYLYVHYWHVYMVXNVYTVUFYSZVVSVJVXNYRXIYIYWLWWA
        VXOVYLXXRVYQWWTVYRVWRVYQWWTXXQWXAYTWTXXRAVYLVYPYWHWUAYSVVCYIYWLYVGVXPUM
        RZYVHYWMYWKYJVYLXXRVYQYVGVYRVWRVYQYVGXXQWXBYTWTXXRAVYLYWPYWHWUBYSYWOWWB
        VXPVXNYRXIYIVVBVVDXXRVXMVXQWVTGXXRPOURYWIXXRAVYLXFVXQTSYWHXWBYSYWFVVFYG
        YHVUBNUXFYGYGVVGVWNVWCXVDVWDXVGUJVWNVVQVWAOHVWPWUIVWNWHUOXXLXEVWNOXVFDU
        IOXVFWSVWNOPPUJQXVFVVHXVEPPUJUYPVVIVVJUOXOXNVVKWRVVLAVWMVWEWVRTSWVOVWNV
        WEWUKVVMWRYGVVN $.
    $}

    $( Lemma for ~ mulog2sum .  (Contributed by Mario Carneiro,
       13-May-2016.) $)
    mulog2sumlem3 $p |- ( ph -> ( x e. RR+ |-> ( sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( mmu ` n ) / n ) x. ( ( log ` ( x / n ) ) ^ 2 ) )
          - ( 2 x. ( log ` x ) ) ) ) e. O(1) ) $=
      ( crp c2 co cmul csu cmin cmpt wcel cc a1i cem vm c1 cfl cfv cfz cmu cdiv
      cv clog cexp co1 wa 2cn fzfid cn cz elfznn adantl mucl syl nndivred recnd
      zred simpr nnrpd rpdivcl syl2an relogcld halfcld mulcld fsumcl cr relogcl
      sqcld subdid fsummulc2 mul12d cc0 wne 2ne0 divcan2d oveq2d eqtrd sumeq2dv
      oveq1d mpteq2dva subcld wss rpssre o1const mp2an caddc emre recni sylancr
      mulcl crli wbr rlimcl ad2antrr addcld sub32d fsumsub pncand cabs ceu eqid
      eqtr3d mulog2sumlem2 adantr oveq12d eqtr4d 3eqtr2d mulogsum o1mul2 o1sub2
      fsummulc1 mudivsum eqeltrrd ) ABJKUBBUHZUCUDZUELZEUHZUFUDZYCUGLZXTYCUGLZU
      IUDZKUJLZKUGLZMLZENZXTUIUDZOLZMLZPBJYBYEYHMLZENZKYLMLZOLZPUKABJYNYRAXTJQZ
      ULZYNKYKMLZYQOLYRYTKYKYLKRQZYTUMSZYTYBYJEYTUBYAUNZYTYCYBQZULZYEYIUUFYEUUF
      YDYCUUFYDUUFYCUOQZYDUPQUUEUUGYTYCYAUQZURZYCUSUTVCUUIVAVBZUUFYHUUFYGUUFYGU
      UFYFYTYSYCJQYFJQUUEAYSVDUUEYCUUHVEXTYCVFVGVHVBZVNZVIZVJZVKZYTYLYSYLVLQAXT
      VMURVBZVOYTUUAYPYQOYTUUAYBKYJMLZENYPYTYBYJKEUUDUUCUUNVPYTYBUUQYOEUUFUUQYE
      KYIMLZMLYOUUFKYEYIUUBUUFUMSZUUJUUMVQUUFUURYHYEMUUFYHKUULUUSKVRVSUUFVTSWAW
      BWCWDWCWEWCWFABJKYMRUUCYTYKYLUUOUUPWGBJKPUKQZAJVLWHZUUBUUTWIUMBJKWJWKSABJ
      YBYEYITYGMLZGOLZWLLZMLZENZYLOLZYBYEUVCMLZENZOLZPBJYMPUKABJUVJYMYTUVJUVFUV
      IOLZYLOLYMYTUVFYLUVIYTYBUVEEUUDUUFYEUVDUUJUUFYIUVCUUMUUFUVBGUUFTRQZYGRQUV
      BRQTWMWNZUUKTYGWPWOZAGRQZYSUUEAFGWQWRUVOIGFWSUTZWTZWGZXAZVJZVKZUUPYTYBUVH
      EUUDUUFYEUVCUUJUVRVJZVKZXBYTUVKYKYLOYTYBUVEUVHOLZENUVKYKYTYBUVEUVHEUUDUVT
      UWBXCYTYBUWDYJEUUFYEUVDUVCOLZMLUWDYJUUFYEUVDUVCUUJUVSUVRVOUUFUWEYIYEMUUFY
      IUVCUUMUVRXDWBXHWDXHWEWCWFABJUVGUVIRYTUVFYLUWAUUPWGUWCABCUBKUGLTGXEUDWLLW
      LLUBKUELXFUAUHZUGLUIUDUWFUGLUANWLLZUVDDUAEFGHIUVDXGUWGXGXIABJTYBYEYGMLZEN
      ZMLZYBYEENZGMLZOLZPBJUVIPUKABJUWMUVIYTUWMYBTUWHMLZENZYBYEGMLZENZOLYBUWNUW
      POLZENUVIYTUWJUWOUWLUWQOYTYBUWHTEUUDUVLYTUVMSZUUFYEYGUUJUUKVJZVPYTYBYEGEU
      UDAUVOYSUVPXJZUUJXQXKYTYBUWNUWPEUUDUUFUVLUWHRQUWNRQUVMUWTTUWHWPWOUUFYEGUU
      JUVQVJXCYTYBUWRUVHEUUFUWRYEUVBMLZUWPOLUVHUUFUWNUXBUWPOUUFTYEYGUVLUUFUVMSU
      UJUUKVQWEUUFYEUVBGUUJUVNUVQVOXLWDXMWFABJUWJUWLRYTUVLUWIRQUWJRQUVMYTYBUWHE
      UUDUWTVKZTUWIWPWOYTUWKGYTYBYEEUUDUUJVKZUXAVJABJTUWIRUWSUXCAUVAUVLBJTPUKQW
      IUVLAUVMSBJTWJWOBJUWIPUKQABEXNSXOABJUWKGRUXDUXABJUWKPUKQABEXRSAUVAUVOBJGP
      UKQWIUVPBJGWJWOXOXPXSXPXSXOXS $.
  $}

  ${
    $d k m n x y z $.
    $( TODO - see if alternative derivation (10.2.9) using vmadivsum is
       simpler $)
    $( Asymptotic formula for
` sum_ n <_ x , ( mmu ( n ) / n ) log ^ 2 ( x / n ) = 2 log x + O(1) ` .
       Equation 10.2.8 of [Shapiro], p. 407.  (Contributed by Mario Carneiro,
       19-May-2016.) $)
    mulog2sum $p |- ( x e. RR+ |-> ( sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( mmu ` n ) / n ) x. ( ( log ` ( x / n ) ) ^ 2 ) )
          - ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( vy vm vz crp c1 cv cfl cfv cfz co clog cdiv csu c2 cmin crli wcel wbr
      cexp cmpt cdm wex cmu cmul co1 cr wf ceu cle w3a cabs wi logdivsum simp2i
      eqid eldmg ibi id mulog2sumlem3 exlimiv mp2b ) CFGCHZIJKLDHZMJVENLDOVDMJP
      UALPNLQLUBZRUCZSZVFEHZRTZEUDZAFGAHZIJKLBHZUEJVMNLVLVMNLMJPUALUFLBOPVLMJUF
      LQLUBUGSZFUHVFUIVHVFGRTGFSUJGUKTULGVFJGQLUMJGMJGNLUKTUNCGDVFGVFUQZUOUPVHV
      KEVFRVGURUSVJVNEVJACDBVFVIVOVJUTVAVBVC $.

    $( The sum ` sum_ n <_ x , Lam ( n ) log ( x / n ) / n ` is asymptotic to
       ` log ^ 2 ( x ) / 2 + O ( log x ) ` .  Exercise 9.1.7 of [Shapiro],
       p. 336.  (Contributed by Mario Carneiro, 30-May-2016.) $)
    vmalogdivsum2 $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( ( Lam ` n ) / n ) x. ( log ` ( x / n ) ) ) / ( log ` x ) )
        - ( ( log ` x ) / 2 ) ) ) e. O(1) $=
      ( vm c1 co cfv cdiv cmul csu c2 cmin cmpt co1 wcel wtru recnd crp wbr cle
      cr vk vy cpnf cioo cv cfl cfz cvma clog cexp wa fzfid elfznn adantl nnrpd
      cn relogcld nndivred fsumrecl elioore 1rp a1i rpred eliooord simpld ltled
      clt rpgecld resqcld rehalfcld rplogcld rpne0d divsubdird resubcld divrecd
      cc 2cn cc0 2ne0 divdiv32d sqvald oveq1d divcan3d eqtrd 3eqtr3rd mpteq2dva
      wne oveq2d rprecred ex ssrdv crli cdm wf ceu w3a cabs wi logdivsum simp2i
      eqid rlimdmo1 mp1i o1res2 divlogrlim rlimo1 o1mul2 eqeltrd divcld halfcld
      subcld vmacl syl adantr rpdivcld remulcld rpcnd nnncan2d nnmulcld fsumsub
      nnne0d nnrecred subdid divdiv1d eqtr3d sumeq2dv reccld fsummulc2 cdivides
      nncnd eqtr4d cfn wss syl2anc 1re rerpdivcld o1dif mpbird divge0d mpbid wb
      crab wceq vmasum sgmss ssfi ssrab2 simprr anassrs fsumdivc oveq2 ad2antrl
      sseldi dvdsflsumcom 3eqtr4rd 3eqtr2d clo1 ioossre o1const mp2an vmadivsum
      ax-1cn dividd o1lo1d vmage0 caddc mulid2d simplbda lemuldivd harmonicubnd
      fznnfl eqbrtrd lesubadd2d lemul2ad mulid1d breqtrd lediv1dd adantrr lo1le
      fsumle 0re harmoniclbnd subge0d mulge0d fsumge0 o1lo12 trud ) ADUCUDEZDAU
      EZUFFZUGEZBUEZUHFZUWLGEZUWIUWLGEZUIFZHEZBIZUWIUIFZGEZUWSJGEZKEZLMNZOAUWHU
      WKUAUEZUIFZUXDGEZUAIZUWSGEZUXAKEZLZMNUXCOUXJAUWHUXGUWSJUJEZJGEZKEZDUWSGEZ
      HEZLMOAUWHUXIUXOOUWIUWHNZUKZUXMUWSGEUXHUXLUWSGEZKEUXOUXIUXQUXGUXLUWSUXQUX
      GUXQUWKUXFUAUXQDUWJULZUXQUXDUWKNZUKZUXEUXDUYAUXDUYAUXDUXTUXDUPNZUXQUXDUWJ
      UMZUNZUOUQUYDURUSZPZUXQUXLUXQUXKUXQUWSUXQUWIUXQUWIDUXPUWITNZOUWIDUCUTUNZD
      QNZUXQVAVBZUXQDUWIUXQDUYJVCUYHUXQDUWIVGRZUWIUCVGRZUXPUYKUYLUKOUWIDUCVDUNV
      EZVFVHZUQZVIZVJZPUXQUWSUYOPZUXQUWSUXQUWIUYHUYMVKZVLZVMUXQUXMUWSUXQUXMUXQU
      XGUXLUYEUYQVNZPUYRUYTVOUXQUXRUXAUXHKUXQUXRUXKUWSGEZJGEUXAUXQUXKJUWSUXQUXK
      UYPPJVPNUXQVQVBUYRJVRWGUXQVSVBUYTVTUXQVUBUWSJGUXQVUBUWSUWSHEZUWSGEUWSUXQU
      XKVUCUWSGUXQUWSUYRWAWBUXQUWSUWSUYRUYRUYTWCWDWBWDWHWEWFOAUWHUXMUXNTVUAUXQU
      WSUYSWIZOAUWHQUXMOAUWHQOUXPUWIQNZUYNWJWKZAQUXMLZWLWMNZVUGMNOQTVUGWNVUHVUG
      DWLRUYIWODSRWPDVUGFDKEWQFDUIFDGESRWRADUAVUGDVUGXAWSWTVUGXBXCXDAUWHUXNLZVR
      WLRVUIMNOAXEVRVUIXFXCZXGXHOAUWHUXIUXBUXQUXHUXAUXQUXGUWSUYFUYRUYTXIZUXQUWS
      UYRXJZXKUXQUWTUXAUXQUWRUWSUXQUWRUXQUWKUWQBUXSUXQUWLUWKNZUKZUWNUWPVUNUWMUW
      LVUNUWLUPNZUWMTNZVUMVUOUXQUWLUWJUMUNZUWLXLZXMZVUQURZVUNUWOVUNUWIUWLUXQVUE
      VUMUYNXNVUNUWLVUQUOZXOZUQZXPZUSPZUXQUWSUYSXQZUYTXIZUXQUWSVVFXJXKOAUWHUXIU
      XBKEZLAUWHUWKUWNDUWOUFFZUGEZDCUEZGEZCIZUWPKEZHEZBIZUWSGEZLZMOAUWHVVHVVQUX
      QVVHUXHUWTKEUXGUWRKEZUWSGEVVQUXQUXHUWTUXAVUKVVGVULXRUXQUXGUWRUWSUYFVVEUYR
      UYTVMUXQVVSVVPUWSGUXQUWKVVJUWMUWLVVKHEZGEZCIZUWQKEZBIUWKVWBBIZUWRKEVVPVVS
      UXQUWKVWBUWQBUXSVUNVWBVUNVVJVWACVUNDVVIULZVUNVVKVVJNZUKZUWMVVTVUNVUPVWFVU
      SXNVWGUWLVVKVUNVUOVWFVUQXNVWFVVKUPNVUNVVKVVIUMUNZXSURUSPVUNUWQVVDPXTUXQUW
      KVVOVWCBVUNVVOUWNVVMHEZUWQKEVWCVUNUWNVVMUWPVUNUWMUWLVUNUWMVUSPZVUNUWLVUQY
      JZVUNUWLVUQYAZXIZVUNVVMVUNVVJVVLCVWEVWGVVKVWHYBUSZPVUNUWPVVCPYCVUNVWBVWIU
      WQKVUNVWBVVJUWNVVLHEZCIVWIVUNVVJVWAVWOCVWGUWNVVKGEVWAVWOVWGUWMUWLVVKVUNUW
      MVPNZVWFVWJXNZVUNUWLVPNVWFVWKXNZVWGVVKVWHYJZVUNUWLVRWGVWFVWLXNZVWGVVKVWHY
      AZYDVWGUWNVVKVWGUWMUWLVWQVWRVWTXIVWSVXAVOYEYFVUNVVJVVLUWNCVWEVWMVWGVVKVWS
      VXAYGYHYKWBYKYFUXQUXGVWDUWRKUXQUXGUWKUBUEUXDYIRZUBUPUUBZUWMUXDGEZBIZUAIVW
      DUXQUWKUXFVXEUAUYAVXCUWMBIZUXDGEUXFVXEUYAVXFUXEUXDGUYAUYBVXFUXEUUCUYDUBUX
      DBUUDXMWBUYAVXCUWMUXDBUYADUXDUGEZYLNVXCVXGYMZVXCYLNUYADUXDULUYAUYBVXHUYDU
      XDUBUUEXMVXGVXCUUFYNUYAUXDUYDYJUXQUXTUWLVXCNZVWPUXQUXTVXIUKUKZUWMVXJVUOVU
      PVXJVXCUPUWLVXBUBUPUUGUXQUXTVXIUUHUUMVURXMPZUUIUYAUXDUYDYAUUJYEYFUXQUBUWI
      VXDVWACUABUXDVVTUWMGUUKUYHVXJUWMUXDVXKVXJUXDUXTUYBUXQVXIUYCUULZYJVXJUXDVX
      LYAXIUUNWDWBUUOWBUUPWFOVVRMNVVRUUQNOAUWHUWKUWNBIZUWSGEZVVQDTDTNZOYOVBOAUW
      HVXNUXQVXMUWSUXQUWKUWNBUXSVUTUSZUYSYPZOAUWHVXNLMNAUWHDLMNZVXROUWHTYMDVPNV
      XRDUCUURUVBAUWHDUUSUUTVBOAUWHVXNDUXQVXNVXQPUXQDUYJXQOAUWHVXNDKEZLAUWHVXMU
      WSKEZUXNHEZLMOAUWHVXSVYAUXQVXTUWSGEVXNUWSUWSGEZKEVYAVXSUXQVXMUWSUWSUXQVXM
      VXPPZUYRUYRUYTVMUXQVXTUWSUXQVXMUWSVYCUYRXKUYRUYTVOUXQVYBDVXNKUXQUWSUYRUYT
      UVCWHWEWFOAUWHVXTUXNTUXQVXMUWSVXPUYOVNVUDOAUWHQVXTVUFAQVXTLMNOABUVAVBXDVU
      JXGXHYQYRUVDVXQUXQVVPUWSUXQUWKVVOBUXSVUNUWNVVNVUTVUNVVMUWPVWNVVCVNZXPZUSZ
      UYSYPZOUXPVVQVXNSRDUWISRUXQVVPVXMUWSVYFVXPUYSUXQUWKVVOUWNBUXSVYEVUTVUNVVO
      UWNDHEUWNSVUNVVNDUWNVYDVXOVUNYOVBZVUTVUNUWMUWLVUSVVAVUNVUOVRUWMSRVUQUWLUV
      EXMYSZVUNVVNDSRVVMUWPDUVFESRZVUNUWOTNDUWOSRZVYJVUNUWOVVBVCVUNDUWLHEZUWISR
      VYKVUNVYLUWLUWISVUNUWLVWKUVGUXQVUMVUOUWLUWISRZUXQUYGVUMVUOVYMUKUUAUYHUWLU
      WIUVKXMUVHUVLVUNDUWIUWLVYHUXQUYGVUMUYHXNVVAUVIYTUWOCUVJYNVUNVVMUWPDVWNVVC
      VYHUVMYRUVNVUNUWNVWMUVOUVPUVTUVQUVRUVSOAUWHVVQVRVYGVRTNOUWAVBUXQVVPUWSVYF
      UYSUXQUWKVVOBUXSVYEVUNUWNVVNVUTVYDVYIVUNVRVVNSRUWPVVMSRZVUNUWOQNVYNVVBUWO
      CUWBXMVUNVVMUWPVWNVVCUWCYRUWDUWEYSUWFYRXHYQYTUWG $.

    $( The sum ` sum_ n <_ x , Lam ( n ) log n / n ` is asymptotic to
       ` log ^ 2 ( x ) / 2 + O ( log x ) ` .  Exercise 9.1.7 of [Shapiro],
       p. 336.  (Contributed by Mario Carneiro, 30-May-2016.) $)
    vmalogdivsum $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( ( Lam ` n ) / n ) x. ( log ` n ) ) / ( log ` x ) )
        - ( ( log ` x ) / 2 ) ) ) e. O(1) $=
      ( c1 cpnf co cfv cdiv clog cmul csu cmin cmpt co1 wcel wtru crp wa adantl
      recnd oveq1d cioo cv cfl cfz c2 cr elioore 1rp a1i rpred clt wbr eliooord
      cvma simpld ltled rpgecld ex ssrdv vmadivsum o1res2 fzfid cn elfznn vmacl
      syl nndivred fsumcl relogcld subcld remulcld fsumrecl rplogcld rerpdivcld
      nnrpd rehalfcld resubcld nnncan2d subsub4d 2halvesd oveq2d sub32d fsumsub
      caddc adantr relogdivd cc subdid sumeq2dv nnne0d divcld fsummulc1 3eqtr4d
      eqtrd nncnd mulcld rpne0d divsubdird divcan4d 3eqtrd eqtr4d vmalogdivsum2
      3eqtr3d mpteq2dva syl6eqel o1dif mpbid trud ) ACDUAEZCAUBZUCFZUDEZBUBZUNF
      ZXMGEZXMHFZIEZBJZXJHFZGEZXSUEGEZKEZLMNZOAXIXLXOBJZXSKEZLMNYCOAXIPYEOAXIPO
      XJXINZXJPNZOYFQZXJCYFXJUFNOXJCDUGRZCPNYHUHUIZYHCXJYHCYJUJYIYHCXJUKULZXJDU
      KULZYFYKYLQOXJCDUMRUOZUPUQZURUSAPYELMNOABUTUIVAOAXIYEYBYHYDXSYHXLXOBYHCXK
      VBZYHXMXLNZQZXOYQXNXMYQXMVCNZXNUFNYPYRYHXMXKVDRZXMVEVFZYSVGZSZVHZYHXSYHXJ
      YNVIZSZVJYHYBYHXTYAYHXRXSYHXLXQBYOYQXOXPUUAYQXMYQXMYSVOZVIZVKZVLZYHXJYIYM
      VMZVNZYHXSUUDVPZVQSOAXIYEYBKEZLAXIXLXOXJXMGEHFZIEZBJZXSGEZYAKEZLMOAXIUUMU
      URYHYDYAKEZYAKEZYBKEUUSXTKEZUUMUURYHUUSXTYAYHYDYAUUCYHYAUULSZVJYHXTUUKSZU
      VBVRYHUUTYEYBKYHUUTYDYAYAWDEZKEYEYHYDYAYAUUCUVBUVBVSYHUVDXSYDKYHXSUUEVTWA
      WNTYHUVAYDXTKEZYAKEUURYHYDYAXTUUCUVBUVCWBYHUUQUVEYAKYHUUQYDXSIEZXRKEZXSGE
      UVFXSGEZXTKEUVEYHUUPUVGXSGYHXLXOXSIEZXQKEZBJXLUVIBJZXRKEUUPUVGYHXLUVIXQBY
      OYQUVIYQXOXSUUAYQXJYHYGYPYNWEZVIVKSYQXQUUHSWCYHXLUUOUVJBYQUUOXOXSXPKEZIEU
      VJYQUUNUVMXOIYQXJXMUVLUUFWFWAYQXOXSXPUUBYHXSWGNYPUUEWEYQXPUUGSWHWNWIYHUVF
      UVKXRKYHXLXOXSBYOUUEYQXNXMYQXNYTSYQXMYSWOYQXMYSWJWKWLTWMTYHUVFXRXSYHYDXSU
      UCUUEWPYHXRUUISUUEYHXSUUJWQZWRYHUVHYDXTKYHYDXSUUCUUEUVNWSTWTTXAXCXDABXBXE
      XFXGXH $.
  $}

  ${
    $d i m n x y A $.  $d m n x ph $.
    2vmadivsum.1 $e |- ( ph -> A e. RR+ ) $.
    2vmadivsum.2 $e |- ( ph -> A. y e. ( 1 [,) +oo ) ( abs `
      ( sum_ i e. ( 1 ... ( |_ ` y ) ) ( ( Lam ` i ) / i ) -
        ( log ` y ) ) ) <_ A ) $.
    $( Lemma for ~ 2vmadivsum .  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    2vmadivsumlem $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( ( Lam ` n ) / n ) x. sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) )
              ( ( Lam ` m ) / m ) ) / ( log ` x ) )
        - ( ( log ` x ) / 2 ) ) ) e. O(1) ) $=
      ( c1 co cfv cdiv cmul cmin cmpt wcel wbr recnd cle cpnf cioo cfl cfz cvma
      cv csu clog c2 co1 vmalogdivsum2 a1i wa fzfid cn cr elfznn vmacl nndivred
      adantl syl fsumrecl remulcld elioore clt eliooord rplogcld rerpdivcld crp
      simpld 1rp rpred ltled rpgecld relogcld rehalfcld resubcld nnrpd rpdivcld
      adantr rpne0d divsubdird subdid sumeq2dv fsumsub eqtrd nnncan2d mpteq2dva
      oveq1d 3eqtr4d 1re wss cc ioossre o1const sylancr subcld dividd oveq2d ex
      divrecd 3eqtr3d ssrdv vmadivsum o1res2 crli divlogrlim rlimo1 mp1i o1mul2
      eqeltrrd o1dif mpbird divcld abscld fsumabs absmuld vmage0 divge0d absidd
      cc0 cabs cico nncnd mulid2d wb fznnfl simplbda eqbrtrd lemuldivd elicopnf
      wral mpbid ax-mp sylanbrc ad2antrr wceq fveq2 oveq12d rpge0d syl5eq rspcv
      id cbvsumv sumeq1d fveq2d breq1d lemul2ad fsumle fsummulc1 breqtrrd letrd
      sylc lediv1dd absdivd fsumge0 mulge0d div23d eqtr4d 3brtr4d adantrr o1le
      ) ABJUAUBKZJBUFZUCLZUDKZGUFZUELZUVGMKZJUVDUVGMKZUCLZUDKZFUFZUELZUVMMKZFUG
      ZNKZGUGZUVDUHLZMKZUVSUIMKZOKZPUJQBUVCUVFUVIUVJUHLZNKZGUGZUVSMKZUWAOKZPUJQ
      ZUWHABGUKULABUVCUWBUWGAUVDUVCQZUMZUWBUWJUVTUWAUWJUVRUVSUWJUVFUVQGUWJJUVEU
      NZUWJUVGUVFQZUMZUVIUVPUWMUVHUVGUWMUVGUOQZUVHUPQUWLUWNUWJUVGUVEUQUTZUVGURV
      AZUWOUSZUWMUVLUVOFUWMJUVKUNUWMUVMUVLQZUMZUVNUVMUWSUVMUOQZUVNUPQUWRUWTUWMU
      VMUVKUQUTZUVMURVAUXAUSVBZVCZVBZUWJUVDUWIUVDUPQZAUVDJUAVDUTZUWJJUVDVERZUVD
      UAVERZUWIUXGUXHUMAUVDJUAVFUTVJZVGZVHZUWJUVSUWJUVDUWJUVDJUXFJVIQUWJVKULZUW
      JJUVDUWJJUXLVLZUXFUXIVMVNZVOZVPZVQSUWJUWGUWJUWFUWAUWJUWEUVSUWJUVFUWDGUWKU
      WMUVIUWCUWQUWMUVJUWMUVDUVGUWJUVDVIQZUWLUXNVTUWMUVGUWOVRZVSZVOZVCZVBZUXJVH
      ZUXPVQSABUVCUVFUVIUVPUWCOKZNKZGUGZUVSMKZPBUVCUWBUWGOKZPUJABUVCUYGUYHUWJUV
      RUWEOKZUVSMKUVTUWFOKUYGUYHUWJUVRUWEUVSUWJUVRUXDSUWJUWEUYBSUWJUVSUXOSZUWJU
      VSUXJWAZWBUWJUYFUYIUVSMUWJUYFUVFUVQUWDOKZGUGUYIUWJUVFUYEUYLGUWMUVIUVPUWCU
      WMUVIUWQSZUWMUVPUXBSUWMUWCUXTSWCWDUWJUVFUVQUWDGUWKUWMUVQUXCSUWMUWDUYASWEW
      FWIUWJUVTUWFUWAUWJUVTUXKSUWJUWFUYCSUWJUWAUXPSWGWJWHABUVCUVFUVIGUGZUVSMKZD
      NKZUYGJUPJUPQZAWKULZABUVCUYODUPUWJUYNUVSUWJUVFUVIGUWKUWQVBZUXJVHZADUPQZUW
      IADHVLZVTZABUVCUYOPUJQBUVCJPUJQZAUVCUPWLZJWMQVUDJUAWNZAJUYRSBUVCJWOWPABUV
      CUYOJUWJUYOUYTSUWJJUXMSABUVCUYNUVSOKZJUVSMKZNKZPBUVCUYOJOKZPUJABUVCVUIVUJ
      UWJVUGUVSMKUYOUVSUVSMKZOKVUIVUJUWJUYNUVSUVSUWJUYNUYSSZUYJUYJUYKWBUWJVUGUV
      SUWJUYNUVSVULUYJWQUYJUYKXAUWJVUKJUYOOUWJUVSUYJUYKWRWSXBWHABUVCVUGVUHUPUWJ
      UYNUVSUYSUXOVQUWJJUVSUXMUXJVHABUVCVIVUGABUVCVIAUWIUXQUXNWTXCBVIVUGPUJQABG
      XDULXEBUVCVUHPZYAXFRVUMUJQABXGYAVUMXHXIXJXKXLXMAVUEDWMQZBUVCDPUJQVUFADVUB
      SZBUVCDWOWPXJUWJUYODUYTVUCVCZUWJUYFUVSUWJUYFUWJUVFUYEGUWKUWMUVIUYDUWQUWMU
      VPUWCUXBUXTVQZVCZVBSZUYJUYKXNAUWIUYGYBLZUYPYBLZTRJUVDTRUWJUYFYBLZUVSMKZUY
      NDNKZUVSMKZVUTVVATUWJVVBVVDUVSUWJUYFVUSXOZUWJUYNDUYSVUCVCZUXJUWJVVBUVFUYE
      YBLZGUGZVVDVVFUWJUVFVVHGUWKUWMUYEUWMUYEVURSZXOZVBVVGUWJUVFUYEGUWKVVJXPUWJ
      VVIUVFUVIDNKZGUGVVDTUWJUVFVVHVVLGUWKVVKUWMUVIDUWQUWJVUAUWLVUCVTZVCUWMVVHU
      VIUYDYBLZNKZVVLTUWMVVHUVIYBLZVVNNKVVOUWMUVIUYDUYMUWMUYDVUQSZXQUWMVVPUVIVV
      NNUWMUVIUWQUWMUVHUVGUWPUXRUWMUWNYAUVHTRUWOUVGXRVAXSZXTWIWFUWMVVNDUVIUWMUY
      DVVQXOVVMUWQVVRUWMUVJJUAYCKZQZJCUFZUCLZUDKZEUFZUELZVWDMKZEUGZVWAUHLZOKZYB
      LZDTRZCVVSYLZVVNDTRZUWMUVJUPQZJUVJTRZVVTUWMUVJUXSVLUWMJUVGNKZUVDTRVWOUWMV
      WPUVGUVDTUWMUVGUWMUVGUWOYDYEUWJUWLUWNUVGUVDTRZUWJUXEUWLUWNVWQUMYFUXFUVGUV
      DYGVAYHYIUWMJUVDUVGUYQUWMWKULUWJUXEUWLUXFVTUXRYJYMUYQVVTVWNVWOUMYFWKJUVJY
      KYNYOAVWLUWIUWLIYPVWKVWMCUVJVVSVWAUVJYQZVWJVVNDTVWRVWIUYDYBVWRVWGUVPVWHUW
      COVWRVWGVWCUVOFUGUVPVWCVWFUVOEFVWDUVMYQZVWEUVNVWDUVMMVWDUVMUEYRVWSUUCYSUU
      DVWRVWCUVLUVOFVWRVWBUVKJUDVWAUVJUCYRWSUUEUUAVWAUVJUHYRYSUUFUUGUUBUUMUUHYI
      UUIUWJUVFUVIDGUWKAVUNUWIVUOVTZUYMUUJUUKUULUUNUWJVUTVVBUVSYBLZMKVVCUWJUYFU
      VSVUSUYJUYKUUOUWJVXAUVSVVBMUWJUVSUXOUWJUVSUXJYTXTWSWFUWJVVAUYPVVEUWJUYPVU
      PUWJUYODUYTVUCUWJUYNUVSUYSUXJUWJUVFUVIGUWKUWQVVRUUPXSUWJDADVIQUWIHVTYTUUQ
      XTUWJUYNDUVSVULVWTUYJUYKUURUUSUUTUVAUVBXKXLXM $.
  $}

  ${
    $d c d i j k m n u x y N $.
    $( The sum ` sum_ m n <_ x , Lam ( m ) Lam ( n ) / m n ` is asymptotic to
       ` log ^ 2 ( x ) / 2 + O ( log x ) ` .  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    2vmadivsum $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( ( Lam ` n ) / n ) x. sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) )
              ( ( Lam ` m ) / m ) ) / ( log ` x ) )
        - ( ( log ` x ) / 2 ) ) ) e. O(1) $=
      ( vy vi vc c1 cv cfl cfv cfz co cvma cdiv csu clog cmin cpnf crp wcel cle
      cabs wbr cico wral wrex cioo cmul c2 cmpt co1 vmadivsumb wa 2vmadivsumlem
      simpl simpr rexlimiva ax-mp ) GDHZIJKLEHZMJUTNLEOUSPJQLUBJFHZUAUCDGRUDLUE
      ZFSUFAGRUGLGAHZIJKLCHZMJVDNLGVCVDNLIJKLBHZMJVENLBOUHLCOVCPJZNLVFUINLQLUJU
      KTZDEFULVBVGFSVASTZVBUMADVAEBCVHVBUOVHVBUPUNUQUR $.

    $( A formula for ` log ^ 2 ( N ) ` in terms of the primes.  Equation 10.4.6
       of [Shapiro], p. 418.  (Contributed by Mario Carneiro, 13-May-2016.) $)
    logsqvma $p |- ( N e. NN -> sum_ d e. { x e. NN | x || N }
      ( sum_ u e. { x e. NN | x || d } ( ( Lam ` u ) x. ( Lam ` ( d / u ) ) ) +
        ( ( Lam ` d ) x. ( log ` d ) ) ) = ( ( log ` N ) ^ 2 ) ) $=
      ( vk cn wcel cdivides cvma cfv co cmul csu clog cmin c1 cfn wa syl recnd
      cv wbr crab cdiv caddc c2 cexp cfz fzfid sgmss ssfi syl2anc elrabi adantl
      wss cc cr ad2antll vmacl breq1 elrab wb ad2antrl nndivdvds mpbid remulcld
      simprbi anassrs fsumcl nnrpd relogcld fsumadd id wceq oveq1 fveq2d oveq2d
      fsumdvdscom ssrab2 simpr sseldi nncnd adantr cc0 nnne0d divcan3d sumeq2dv
      wne dvdsdivcl vmasum crp nnrp relogdivd eqeltrd fsummulc2 relogcl 3eqtr3d
      3eqtrd subdid mulcld fsumsub sqvald oveq1d 3eqtr2rd fveq2 oveq12d cbvsumv
      fsummulc1 a1i eqtrd sqcld npcand ) CFGZAUAZCHUBZAFUCZXNDUAZHUBZAFUCZBUAZI
      JZXQXTUDKZIJZLKZBMZXQIJZXQNJZLKZUEKDMXPYEDMZXPYHDMZUEKCNJZUFUGKZYJOKZYJUE
      KYLXMXPYEYHDXMPCUHKZQGXPYNUOXPQGXMPCUICAUJYNXPUKULZXMXQXPGZRZXSYDBYQPXQUH
      KZQGXSYRUOZXSQGYQPXQUIYQXQFGZYSYPYTXMXOAXQFUMZUNZXQAUJSYRXSUKULXMYPXTXSGZ
      YDUPGXMYPUUCRRZYDUUDYAYCUUDXTFGZYAUQGZUUCUUEXMYPXRAXTFUMURZXTUSZSUUDYBFGZ
      YCUQGUUDXTXQHUBZUUIUUCUUJXMYPUUCUUEUUJXRUUJAXTFXNXTXQHUTVAVGURUUDYTUUEUUJ
      UUIVBYPYTXMUUCUUAVCUUGXQXTVDULVEYBUSSVFTZVHVIYQYHYQYFYGYQYTYFUQGUUBXQUSSY
      QXQYQXQUUBVJVKVFTZVLXMYIYMYJUEXMYIXPXNCXTUDKZHUBZAFUCZYAXTEUAZLKZXTUDKZIJ
      ZLKZEMZBMXPYAYKLKZYAXTNJZLKZOKZBMZYMXMAYDUUTDBECXMVMXQUUQVNZYCUUSYALUVGYB
      UURIXQUUQXTUDVOVPVQUUKVRXMXPUVAUVEBXMXTXPGZRZYAUUOUUSEMZLKYAYKUVCOKZLKUVA
      UVEUVIUVJUVKYALUVIUVJUUOUUPIJZEMZUUMNJZUVKUVIUUOUUSUVLEUVIUUPUUOGZRZUURUU
      PIUVPUUPXTUVPUUPUVPUUOFUUPUUNAFVSUVIUVOVTWAZWBUVIXTUPGUVOUVIXTUVIXPFXTXOA
      FVSZXMUVHVTWAZWBWCUVIXTWDWHUVOUVIXTUVSWEWCWFVPZWGUVIUUMFGZUVMUVNVNUVIXPFU
      UMUVRAXTCWIWAZAUUMEWJSUVICXTXMCWKGZUVHCWLZWCZUVIXTUVSVJZWMWRVQUVIUUOUUSYA
      EUVIPUUMUHKZQGUUOUWGUOZUUOQGUVIPUUMUIUVIUWAUWHUWBUUMAUJSUWGUUOUKULUVIYAUV
      IUUEUUFUVSUUHSTZUVPUUSUVLUPUVTUVPUVLUVPUUPFGUVLUQGUVQUUPUSSTWNWOUVIYAYKUV
      CUWIUVIUWCYKUPGZUWEUWCYKCWPTZSZUVIUVCUVIXTUWFVKTZWSWQWGXMUVFXPUVBBMZXPUVD
      BMZOKYMXMXPUVBUVDBYOUVIYAYKUWIUWLWTUVIYAUVCUWIUWMWTXAXMUWNYLUWOYJOXMYLYKY
      KLKXPYABMZYKLKUWNXMYKXMUWCUWJUWDUWKSZXBXMUWPYKYKLACBWJXCXMXPYAYKBYOUWQUWI
      XHXDUWOYJVNXMXPUVDYHBDXTXQVNYAYFUVCYGLXTXQIXEXTXQNXEXFXGXIXFXJWRXCXMYLYJX
      MYKUWQXKXMXPYHDYOUULVIXLWR $.

    $( The M&ouml;bius inverse of ~ logsqvma .  Equation 10.4.8 of [Shapiro],
       p. 418.  (Contributed by Mario Carneiro, 13-May-2016.) $)
    logsqvma2 $p |- ( N e. NN -> sum_ d e. { x e. NN | x || N }
        ( ( mmu ` d ) x. ( ( log ` ( N / d ) ) ^ 2 ) ) =
      ( sum_ d e. { x e. NN | x || N } ( ( Lam ` d ) x. ( Lam ` ( N / d ) ) ) +
        ( ( Lam ` N ) x. ( log ` N ) ) ) ) $=
      ( vj vm cn wcel cv cdivides cvma cfv cdiv co cmul clog caddc c2 cexp wceq
      csu vk vi vn wbr crab cmpt cmu cc c1 cfz cfn wss fzfid sgmss ssfi syl2anc
      wa cr ssrab2 simpr sseldi vmacl dvdsdivcl remulcld fsumrecl nnrp relogcld
      readdcld recnd adantl eqid fmptd breq2 rabbidv oveq1 fveq2d oveq2d adantr
      syl sumeq12dv fveq2 oveq12d ovex sumeq2dv logsqvma eqtr2d mpteq2dva muinv
      fvmpt3i fveq1d oveq2 oveq1d cbvsumv syl5eq mpteq2ia sumex 3eqtr3rd ) BFGZ
      BUAFAHZUAHZIUDZAFUEZCHZJKZWTXCLMZJKZNMZCTZWTJKZWTOKZNMZPMZUFZKBUBFWSUBHZI
      UDZAFUEZDHZUGKZXNXQLMZUCFUCHZOKZQRMZUFZKZNMZDTZUFZKWSBIUDZAFUEZXDBXCLMZJK
      ZNMZCTZBJKZBOKZNMZPMZYIXCUGKZYJOKZQRMZNMZCTZWRBXMYGWRADEUBUCXMYCWRUAFXLUH
      XMWTFGZXLUHGWRUUCXLUUCXHXKUUCXBXGCUUCUIWTUJMZUKGXBUUDULXBUKGUUCUIWTUMWTAU
      NUUDXBUOUPUUCXCXBGZUQZXDXFUUFXCFGXDURGUUFXBFXCXAAFUSZUUCUUEUTVAXCVBVSUUFX
      EFGXFURGUUFXBFXEUUGAXCWTVCVAXEVBVSVDVEUUCXIXJWTVBUUCWTWTVFVGVDVHVIVJXMVKZ
      VLWRUCFYBWSXTIUDZAFUEZEHZXMKZETZWRXTFGZUQZUUMUUJWSUUKIUDZAFUEZXDUUKXCLMZJ
      KZNMZCTZUUKJKZUUKOKZNMZPMZETZYBUUOUUJUULUVEEUUOUUKUUJGZUQZUUKFGUULUVESUVH
      UUJFUUKUUIAFUSUUOUVGUTVAUAUUKXLUVEFXMWTUUKSZXHUVAXKUVDPUVIXBUUQXGUUTCUVIX
      AUUPAFWTUUKWSIVMVNUVIXGUUTSUUEUVIXFUUSXDNUVIXEUURJWTUUKXCLVOVPVQVRVTUVIXI
      UVBXJUVCNWTUUKJWAWTUUKOWAWBWBUUHXHXKPWCZWIVSWDUUNUVFYBSWRACXTEWEVJWFWGWHW
      JUABXLYQFXMWTBSZXHYMXKYPPUVKXBYIXGYLCUVKXAYHAFWTBWSIVMVNUVKXGYLSUUEUVKXFY
      KXDNUVKXEYJJWTBXCLVOVPVQVRVTUVKXIYNXJYONWTBJWAWTBOWAWBWBUUHUVJWIUBBXPXRXS
      OKZQRMZNMZDTZUUBFYGXNBSZUVOXPYRXNXCLMZOKZQRMZNMZCTUUBXPUVNUVTDCXQXCSZXRYR
      UVMUVSNXQXCUGWAUWAUVLUVRQRUWAXSUVQOXQXCXNLWKVPWLWBWMUVPXPYIUVTUUACUVPXOYH
      AFXNBWSIVMVNUVPUVTUUASXCXPGUVPUVSYTYRNUVPUVRYSQRUVPUVQYJOXNBXCLVOVPWLVQVR
      VTWNUBFYFUVOXNFGZXPYEUVNDUWBXQXPGUQZYDUVMXRNUWCXSFGYDUVMSUWCXPFXSXOAFUSAX
      QXNVCVAUCXSYBUVMFYCXTXSSYAUVLQRXTXSOWAWLYCVKYAQRWCWIVSVQWDWOXPUVNDWPWIWQ
      $.
  $}

  ${
    $d n x y A $.
    $( Bound on the difference between ` sum_ n <_ A , log ^ 2 ( n ) ` and the
       equivalent integral.  (Contributed by Mario Carneiro, 20-May-2016.) $)
    log2sumbnd $p |- ( ( A e. RR+ /\ 1 <_ A ) ->
      ( abs ` ( sum_ n e. ( 1 ... ( |_ ` A ) ) ( ( log ` n ) ^ 2 ) -
          ( A x. ( ( ( log ` A ) ^ 2 ) + ( 2 - ( 2 x. ( log ` A ) ) ) ) ) ) )
        <_ ( ( ( log ` A ) ^ 2 ) + 2 ) ) $=
      ( vx crp wcel c1 cle wbr cfv co c2 cmul cmin caddc cr cc 2cn cc0 cmpt a1i
      vy wa cfl cfz cv clog cexp csu cabs fzfid cn elfznn adantl nnrpd relogcld
      cneg resqcld fsumrecl adantr relogcl 2re remulcl sylancr resubcl readdcld
      rpre remulcld resubcld recnd abscld sylancl negcli subcl absnegi wceq 0re
      ltleii absid mp2an eqtri oveq2i abs2dif syl5eqbrr fveq2 oveq2d sumeq1d id
      2pos oveq1d oveq12d eqid ovex fvmpt3i 1rp cz flid ax-mp syl6eq log1 sq0id
      1z 0cn fsum1 mul01i subid1i addid2i mulid2i df-neg syl6eqr mp1i cpnf cioo
      fveq2d ioorp eqcomi nnuz 1re pnfxr 1nn0 nn0addge1i simpr nnrp sylan2 cdiv
      cxr cdv cpr reex prid1 crn dvmptres cvv mulcl mpteq2dva eqtrd mpbid rpred
      mpteq2ia w3a letrd ctg ccnfld ctopn recn dvmptid rpssre iooretop eqeltrri
      tgioo2 rerpdivcld rpreccld rpcnd mulcld cnex prid2 sqcl cres dvrelog wf1o
      wss wf relogf1o f1of feqmptd fvres syl5reqr dvexp 2m1e1 exp1 syl5eq oveq1
      2nn oveq2 dvmptco dvmptcmul dvmptsub dvmptadd subdird wne divrecd negsubd
      dvmptc rpne0 syl5eqr 3eqtr4rd dvmptmul eqtr4d npcand simp32 simp2l simp2r
      mulid2d subsub2d divcan1d logled simp31 wb logleb logge0d le2sqd ad2antrl
      sqge0d simpl 1le1 rexrd pnfge syl dvfsum2 eqbrtrrd lesubaddd ) ADEZFAGHZU
      BZFAUCIZUDJZBUEZUFIZKUGJZBUHZAAUFIZKUGJZKKUXTLJZMJZNJZLJZMJZUIIZKMJZUYAGH
      UYGUYAKNJGHUXMUYHUYFKUPZMJZUIIZUYAUXMUYGOEKOEZUYHOEUXMUYFUXMUYFUXMUXSUYEU
      XMUXOUXRBUXMFUXNUJUXMUXPUXOEZUBZUXQUYNUXPUYNUXPUYMUXPUKEUXMUXPUXNULUMUNUO
      UQURUXMAUYDUXKAOEUXLAVFUSZUXMUYAUYCUXMUXTUXKUXTOEZUXLAUTUSZUQZUXMUYLUYBOE
      ZUYCOEVAUXMUYLUYPUYSVAUYQKUXTVBVCKUYBVDVCVEVGVHVIZVJZVAUYGKVDVKUXMUYJUXMU
      YFPEZUYIPEZUYJPEUYTKQVLZUYFUYIVMVKVJUYRUXMUYHUYGUYIUIIZMJZUYKGVUEKUYGMVUE
      KUIIZKKQVNUYLRKGHVUGKVOVARKVPVAWHVQKVRVSVTWAUXMVUBVUCVUFUYKGHUYTVUDUYFUYI
      WBVKWCUXMACDFCUEZUCIZUDJZUXRBUHZVUHVUHUFIZKUGJZKKVULLJZMJZNJZLJZMJZSZIZFV
      USIZMJZUIIUYKUYAGUXMVVBUYJUIUXMVUTUYFVVAUYIMUXKVUTUYFVOUXLCAVURUYFDVUSVUH
      AVOZVUKUXSVUQUYEMVVCVUJUXOUXRBVVCVUIUXNFUDVUHAUCWDWEWFVVCVUHAVUPUYDLVVCWG
      VVCVUMUYAVUOUYCNVVCVULUXTKUGVUHAUFWDZWIZVVCVUNUYBKMVVCVULUXTKLVVDWEWEWJWJ
      WJVUSWKZVUKVUQMWLZWMUSFDEZVVAUYIVOUXMWNCFVURUYIDVUSVUHFVOZVURRKMJUYIVVIVU
      KRVUQKMVVIVUKFFUDJZUXRBUHZRVVIVUJVVJUXRBVVIVUIFFUDVVIVUIFUCIZFVUHFUCWDFWO
      EZVVLFVOXAFWPWQWRWEWFVVMRPEVVKRVOXAXBUXRRBFUXPFVOZUXQVVNUXQFUFIZRUXPFUFWD
      WSWRWTXCVSWRVVIVUQFKLJKVVIVUHFVUPKLVVIWGVVIVUPRKNJKVVIVUMRVUOKNVVIVULVVIV
      ULVVORVUHFUFWDWSWRZWTVVIVUOKRMJKVVIVUNRKMVVIVUNKRLJRVVIVULRKLVVPWEKQXDWRW
      EKQXEWRWJKQXFWRWJKQXGWRWJKXHXIVVFVVGWMXJWJXMUXMCVUQVUMUXRFDRXKBUYAVUSFOFA
      UKRXKXLJZDXNXOXPVVMUXMXATFOEZUXMXQTXKYEEUXMXRTFFFNJGHUXMFFXQXSXTTROEZUXMV
      PTUXMVUHDEZUBZVUHVUPVVTVUHOEZUXMVUHVFUMZVWAVUMVUOVWAVULVWAVUHUXMVVTYAZUOZ
      UQZVWAUYLVUNOEZVUOOEVAVWAUYLVULOEZVWGVAVWEKVULVBVCZKVUNVDVCZVEZVGVWFVUHUK
      EUXMVVTVUMOEVUHYBVWFYCUXMOCDVUQSYFJCDFVUPLJZVUNKMJZVUHYDJZVUHLJZNJZSCDVUM
      SUXMCVUHFVUPVWNOOODOOPYGZEUXMOPYHYITZVWAVUHVWCVIZVVRVWAXQTUXMCVUHFOXLYJUU
      AIZUUBUUCIZOODVWRVWBVUHPEUXMVUHUUDUMVVRUXMVWBUBZXQTUXMCOVWRUUEDOUUTUXMUUF
      TZVXAVXAWKZUUIZVXDDVWTEUXMVVQDVWTXNRXKUUGUUHTZYKVWAVUPVWKVIZVWAVWMVUHVWAV
      WGUYLVWMOEVWIVAVUNKVDVKZVWDUUJUXMOCDVUPSYFJCDVUNFVUHYDJZLJZRKVXILJZMJZNJZ
      SCDVWNSUXMCVUMVXJVUOVXLOPYLDVWRVWAVUMVWFVIZVWAVUNVXIVWAVUNVWIVIZVWAVXIVWA
      VUHVWDUUKZUULZUUMZUXMCUAVULVXIUAUEZKUGJZKVXSLJZOPVUMVUNDPDPVWRPVWQEUXMOPU
      UNUUOTVWAVULVWEVIZVXPVXSPEZVXTPEUXMVXSUUPUMUXMVYCUBKPEZVYCVYAPEQUXMVYCYAK
      VXSYMVCUXMCDVXISOUFDUUQZYFJOCDVULSZYFJCUURUXMVYEVYFOYFUXMVYECDVUHVYEIZSVY
      FUXMCDOVYEDOVYEUUSDOVYEUVAUXMUVBDOVYEUVCXJUVDCDVYGVULVUHDUFUVEYRWRWEUVFZU
      XMPUAPVXTSYFJZUAPKVXSKFMJZUGJZLJZSZUAPVYASKUKEVYIVYMVOUXMUVLUAKUVGXJUAPVY
      LVYAVYCVYKVXSKLVYCVYKVXSFUGJVXSVYJFVXSUGUVHWAVXSUVIUVJWEYRWRVXSVULKUGUVKV
      XSVULKLUVMUVNVWAVUOVWJVIVXLYLEVWARVXKMWLTUXMCKRVUNVXKOOPDVWRVYDVWAQTZVVSV
      WAVPTUXMCKROVWTVXAOODVWRVYDVXBQTVVSVXBVPTUXMCKOVWRVYDUXMQTZUWBVXCVXEVXDVX
      FYKVXOVWAVYDVXIPEVXKPEQVXQKVXIYMVCZUXMCVULVXIKODDVWRVYBVXPVYHVYOUVOUVPUVQ
      UXMCDVXMVWNVWAVWMVXILJVXJVXKMJZVWNVXMVWAVUNKVXIVXOVYNVXQUVRVWAVWMVUHVWAVW
      MVXHVIZVWSVVTVUHRUVSUXMVUHUWCUMZUVTVWAVXMVXJVXKUPZNJVYQVYTVXLVXJNVXKXHWAV
      WAVXJVXKVXRVYPUWAUWDUWEYNYOUWFUXMCDVWPVUMVWAVWPVUMVWMMJZVWMNJVUMVWAVWLWUA
      VWOVWMNVWAVWLVUPWUAVWAVUPVXGUWLVWAVUMVUNKVXNVXOVYNUWMUWGVWAVWMVUHVYRVWSVY
      SUWNWJVWAVUMVWMVXNVYRUWHYOYNYOVUHUXPVOVULUXQKUGVUHUXPUFWDWIUXMVVTUXPDEZUB
      ZFVUHGHZVUHUXPGHZUXPXKGHZYSZYSZVULUXQGHZVUMUXRGHWUHWUEWUIUXMWUCWUDWUEWUFU
      WIZWUHVUHUXPUXMVVTWUBWUGUWJZUXMVVTWUBWUGUWKZUWOYPWUHVULUXQWUHVUHWUKUOWUHU
      XPWULUOWUHRVVOVULGWSWUHWUDVVOVULGHZUXMWUCWUDWUEWUFUWPZWUHVVHVVTWUDWUMUWQW
      NWUKFVUHUWRVCYPWCWUHUXPWUHUXPWULYQZWUHFVUHUXPVVRWUHXQTWUHVUHWUKYQWUOWUNWU
      JYTUWSUWTYPVVFUXMVVTWUDUBUBVULVVTVWHUXMWUDVUHUTUXAUXBVVHUXMWNTUXKUXLUXCFF
      GHUXMUXDTUXKUXLYAUXMAYEEAXKGHUXMAUYOUXEAUXFUXGVVEUXHUXIYTUXMUYGKUYAVUAUYL
      UXMVATUYRUXJYP $.
  $}

  ${
    $d m n x $.
    selberglem1.t $e |- T = ( ( ( ( log ` ( x / n ) ) ^ 2 ) +
      ( 2 - ( 2 x. ( log ` ( x / n ) ) ) ) ) / n ) $.
    $( Lemma for ~ selberg .  Estimation of the asymptotic part of
       ~ selberglem3 .  (Contributed by Mario Carneiro, 20-May-2016.) $)
    selberglem1 $p |- ( x e. RR+ |->
      ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( mmu ` n ) x. T )
        - ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( crp cfv co cmul csu c2 cmin cmpt caddc co1 wcel cc 2cn a1i wtru cvv cfl
      c1 cv cfz cmu clog cdiv cexp fzfid wa cn elfznn adantl mucl zred nndivred
      cz recnd cr nnrpd rpdivcl sylan2 relogcl sqcld mulcld fsumcl subcld mulcl
      syl sylancr addsubd oveq2i cc0 wne wceq zcnd addcld rpcnne0d divass div23
      w3a eqtr3d syl3anc adddid eqtrd syl5eq sumeq2dv fsumadd fsummulc2 fsumsub
      oveq1d oveq2d mulcomd mul12d oveq12d subdid mpteq2ia ovex mulog2sum elexi
      3eqtr4d wss rpssre o1const mp2an reex ssexi sumex eqidd mudivsum mulogsum
      cof offval2 o1sub syl6eqelr o1mul2 o1add2 trud eqeltri ) AEUBAUCZUAFZUDGZ
      CUCZUEFZBHGZCIZJXTUFFZHGZKGZLAEYBYDYCUGGZXTYCUGGZUFFZJUHGZHGZCIZYHKGZJYBY
      JCIZYBYJYLHGZCIZKGZHGZMGZLZNAEYIUUBXTEOZYOYBYJJJYLHGZKGZHGZCIZMGZYHKGYPUU
      HMGYIUUBUUDYOUUHYHUUDYBYNCUUDUBYAUIZUUDYCYBOZUJZYJYMUULYJUULYDYCUULYDUULY
      CUKOZYDUQOUUKUUMUUDYCYAULZUMZYCUNVIZUOUUOUPURZUULYLUULYLUULYKEOZYLUSOUUKU
      UDYCEOUURUUKYCUUNUTXTYCVAVBYKVCVIURZVDZVEZVFUUDYBUUGCUUJUULYJUUFUUQUULJUU
      EJPOZUULQRZUULJYLUVCUUSVEZVGZVEZVFUUDUVBYGPOYHPOQUUDYGXTVCURJYGVHVJVKUUDY
      FUUIYHKUUDYFYBYNUUGMGZCIUUIUUDYBYEUVGCUULYEYDYMUUFMGZYCUGGZHGZUVGBUVIYDHD
      VLUULUVJYJUVHHGZUVGUULYDPOZUVHPOZYCPOYCVMVNUJZUVJUVKVOUULYDUUPVPUULYMUUFU
      UTUVEVQUULYCUULYCUUOUTVRUVLUVMUVNWAYDUVHHGYCUGGUVJUVKYDUVHYCVSYDUVHYCVTWB
      WCUULYJYMUUFUUQUUTUVEWDWEWFWGUUDYBYNUUGCUUJUVAUVFWHWEWKUUDUUAUUHYPMUUDYBJ
      YJYRKGZHGZCIZUUAUUHUUDJYBUVOCIZHGUVQUUAUUDYBUVOJCUUJUVBUUDQRUULYJYRUUQUUL
      YJYLUUQUUSVEZVGWIUUDUVRYTJHUUDYBYJYRCUUJUUQUVSWJWLWBUUDYBUVPUUGCUULJYJHGZ
      JYRHGZKGYJJHGZYJUUEHGZKGUVPUUGUULUVTUWBUWAUWCKUULJYJUVCUUQWMUULJYJYLUVCUU
      QUUSWNWOUULJYJYRUVCUUQUVSWPUULYJJUUEUUQUVCUVDWPXAWGWBWLXAWQUUCNOSAEYPUUAT
      YPTOSUUDUJZYOYHKWRRUUATOUWDJYTHWRRAEYPLNOSACWSRSAEJYTTJTOUWDJPQWTRYTTOUWD
      YQYSKWRRAEJLNOZSEUSXBUVBUWEXCQAEJXDXERSAEYTLAEYQLZAEYSLZKXLGZNSAEYQYSKUWF
      UWGTTTETOSEUSXFXCXGRYQTOUWDYBYJCXHRYSTOUWDYBYRCXHRSUWFXISUWGXIXMUWFNOUWGN
      OUWHNOACXJACXKUWFUWGXNXEXOXPXQXRXS $.

    $( Lemma for ~ selberg .  (Contributed by Mario Carneiro, 23-May-2016.) $)
    selberglem2 $p |- ( x e. RR+ |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) ) sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) )
        ( ( mmu ` n ) x. ( ( log ` m ) ^ 2 ) ) / x ) -
        ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( crp c1 cfv co cdiv c2 cmul wcel wtru caddc cc cr recnd wbr cle cfl clog
      cv cfz cmu cexp csu cmin cmpt co1 cof cvv rpssre ssexi a1i wa fzfid cn cz
      reex elfznn adantl mucl syl zred nnrpd relogcld resqcld simplr rerpdivcld
      fsumrecl simpr rpdivcl remulcl sylancr resubcl readdcld nndivred syl5eqel
      syl2an 2re subcld mulcld 2cn relogcl mulcl offval2 addsubassd cc0 rpcnne0
      fsumcl eqidd simpld adantr remulcld simprd fsumdivc wceq divass fsummulc2
      wne syl3anc oveq1d npcand oveq2d adddid eqtr3d 3eqtr3d sumeq2dv mpteq2dva
      fsumadd 3eqtrrd eqtrd 1re cfa crli cn0 2nn0 logexprlim mp1i wss rlimconst
      rlimadd rlimo1 readdcl sylancl cabs abscld fsumabs absmuld mule1 lemul1ad
      absge0d mulid2d breqtrd eqbrtrd 3syl wb mpbid letrd subdid oveq2i syl6eqr
      divcan2d w3a div23 oveq12d fveq2d rprege0 absid nncnd rpre simplbda rpred
      fznnfl lemuldivd log2sumbnd syl2anc lemuldiv2d fsumle chash cfn fsumconst
      eqbrtrrd flge0nn0 hashfz1 reflcl flle clt pm3.2i lemul1 leadd2dd lediv1dd
      2pos divdir divcan3d 3brtr3d adantrr o1le selberglem1 o1add eqeltrrd trud
      leabsd ) AFGAUCZUAHZUDIZGUWEDUCZJIZUAHZUDIZUWHUEHZCUCZUBHZKUFIZLIZCUGZDUG
      UWEJIZKUWEUBHZLIZUHIZUIZUJMNAFUWGUWLUWKUWOCUGZUWEJIZBUHIZLIZDUGZUIZAFUWGU
      WLBLIZDUGZUWTUHIZUIZOUKIZUXBUJNUXMAFUXGUXKOIZUIUXBNAFUXGUXKOUXHUXLULPPFUL
      MNFQUTUMUNUONUWEFMZUPZUWGUXFDUXPGUWFUQZUXPUWHUWGMZUPZUWLUXEUXSUWLUXSUWLUX
      SUWHURMZUWLUSMUXRUXTUXPUWHUWFVAZVBZUWHVCVDVEZRZUXSUXDBUXSUXDUXSUXCUWEUXSU
      WKUWOCUXSGUWJUQZUXSUWMUWKMZUPZUWNUYGUWMUYGUWMUYFUWMURMUXSUWMUWJVAVBVFVGVH
      ZVKNUXOUXRVIZVJRZUXSBUXSBUWIUBHZKUFIZKKUYKLIZUHIZOIZUWHJIZQEUXSUYOUWHUXSU
      YLUYNUXSUYKUXSUWIUXPUXOUWHFMZUWIFMZUXRNUXOVLZUXRUWHUYAVFUWEUWHVMVTZVGZVHZ
      UXSKQMZUYMQMZUYNQMWAUXSVUCUYKQMVUDWAVUAKUYKVNVOKUYMVPVOVQZUYBVRVSRZWBZWCZ
      WKZUXPUXJUWTUXPUWGUXIDUXQUXSUWLBUYDVUFWCZWKZUXPKPMZUWSPMUWTPMWDUXPUWSUXOU
      WSQMNUWEWEVBRKUWSWFVOZWBNUXHWLNUXLWLWGNAFUXNUXAUXPUXGUXJOIZUWTUHIUXNUXAUX
      PUXGUXJUWTVUIVUKVUMWHUXPVUNUWRUWTUHUXPUWRUWGUWQUWEJIZDUGUWGUXFUXIOIZDUGVU
      NUXPUWGUWQUWEDUXQUXPUWEPMZUWEWIXAZUXOVUQVURUPZNUWEWJVBZWMZUXSUWQUXSUWKUWP
      CUYEUYGUWLUWOUXSUWLQMUYFUYCWNUYHWOVKRUXPVUQVURVUTWPZWQUXPUWGVUOVUPDUXSUWL
      UXCLIZUWEJIZUWLUXDLIZVUOVUPUXSUWLPMUXCPMVUSVVDVVEWRUYDUXSUWKUWOCUYEUYGUWO
      UYHRZWKZUXPVUSUXRVUTWNZUWLUXCUWEWSXBUXSVVCUWQUWEJUXSUWKUWOUWLCUYEUYDVVFWT
      XCUXSUWLUXEBOIZLIVVEVUPUXSVVIUXDUWLLUXSUXDBUYJVUFXDXEUXSUWLUXEBUYDVUGVUFX
      FXGXHXIUXPUWGUXFUXIDUXQVUHVUJXKXLXCXGXJXMNUXHUJMUXLUJMUXMUJMNAFUWGUYLDUGZ
      UWEJIZKOIZUXGGQGQMZNXNUONAFVVLUIZKXOHZKOIZXPSVVNUJMNAFVVKKVVOKPUXPVVKUXPV
      VJUWEUXPUWGUYLDUXQVUBVKZUYSVJZRVULUXPWDUOZKXQMAFVVKUIVVOXPSNXRADKXSXTNFQY
      AVULAFKUIKXPSUMVULNWDUOAFKYBVOYCVVPVVNYDVDUXPVVKQMVUCVVLQMVVRWAVVKKYEYFZV
      UINUXOUXGYGHZVVLYGHZTSGUWETSUXPVWAVVLVWBUXPUXGVUIYHZVVTUXPVVLUXPVVLVVTRYH
      UXPVWAUWGUXFYGHZDUGZVVLVWCUXPUWGVWDDUXQUXSUXFVUHYHZVKZVVTUXPUWGUXFDUXQVUH
      YIUXPVWEUWGUYLKOIZUWEJIZDUGZVVLVWGUXPUWGVWIDUXQUXSVWHUWEUXSUYLQMVUCVWHQMV
      UBWAUYLKYEYFZUYIVJZVKVVTUXPUWGVWDVWIDUXQVWFVWLUXSVWDUXEYGHZVWIVWFUXSUXEVU
      GYHZVWLUXSVWDUWLYGHZVWMLIZVWMTUXSUWLUXEUYDVUGYJUXSVWPGVWMLIVWMTUXSVWOGVWM
      UXSUWLUYDYHVVMUXSXNUOZVWNUXSUXEVUGYMUXSUXTVWOGTSUYBUWHYKVDYLUXSVWMUXSVWMV
      WNRYNYOYPUXSUWEVWMLIZVWHTSVWMVWITSUXSUXCUWIUYOLIZUHIZYGHZVWRVWHTUXSUWEUXE
      LIZYGHUWEYGHZVWMLIVXAVWRUXSUWEUXEUXSVUQVURVVHWMZVUGYJUXSVXBVWTYGUXSVXBUWE
      UXDLIZUWEBLIZUHIVWTUXSUWEUXDBVXDUYJVUFUUAUXSVXEUXCVXFVWSUHUXSUXCUWEVVGVXD
      UXSVUQVURVVHWPUUDUXSVUQUYOPMZUWHPMUWHWIXAUPZVXFVWSWRVXDUXSUYOVUERUXSUYQVX
      HUXSUWHUYBVFZUWHWJVDVUQVXGVXHUUEZUWEUYOLIUWHJIZVXFVWSVXJVXKUWEUYPLIVXFUWE
      UYOUWHWSBUYPUWELEUUBUUCUWEUYOUWHUUFXGXBUUGXMUUHUXSVXCUWEVWMLUXSUXOUWEQMZW
      IUWETSUPZVXCUWEWRUYIUWEUUIZUWEUUJYQXCXHUXSUYRGUWITSZVXAVWHTSUYTUXSGUWHLIZ
      UWETSVXOUXSVXPUWHUWETUXSUWHUXSUWHUYBUUKYNUXPUXRUXTUWHUWETSZUXPVXLUXRUXTVX
      QUPYRUXOVXLNUWEUULVBZUWHUWEUUOVDUUMYPUXSGUWEUWHVWQUXSUWEUYIUUNVXIUUPYSUWI
      CUUQUURUVDUXSVWMVWHUWEVWNVWKUYIUUSYSYTUUTUXPUWGVWHDUGZUWEJIVVJUWEKLIZOIZU
      WEJIZVWJVVLTUXPVXSVYAUWEUXPUWGVWHDUXQVWKVKUXPVVJVXTVVQUXPVXLVUCVXTQMVXRWA
      UWEKVNYFZVQUYSUXPVXSVVJUWFKLIZOIZVYATUXPVXSVVJUWGKDUGZOIVYEUXPUWGUYLKDUXQ
      UXSUYLVUBRVULUXSWDUOXKUXPVYFVYDVVJOUXPVYFUWGUVAHZKLIZVYDUXPUWGUVBMVULVYFV
      YHWRUXQWDUWGKDUVCYFUXPVYGUWFKLUXPVXMUWFXQMVYGUWFWRUXOVXMNVXNVBUWEUVEUWFUV
      FYQXCXMXEXMUXPVYDVXTVVJUXPUWFKUXPVXLUWFQMZVXRUWEUVGVDZVUCUXPWAUOWOVYCVVQU
      XPUWFUWETSZVYDVXTTSZUXPVXLVYKVXRUWEUVHVDUXPVYIVXLVUCWIKUVISZUPZVYKVYLYRVY
      JVXRVYNUXPVUCVYMWAUVNUVJUOUWFUWEKUVKXBYSUVLYPUVMUXPUWGVWHUWEDUXQVVAUXSVWH
      VWKRVVBWQUXPVYBVVKVXTUWEJIZOIZVVLUXPVVJPMVXTPMVUSVYBVYPWRUXPVVJVVQRUXPUWE
      KVVAVVSWCVUTVVJVXTUWEUVOXBUXPVYOKVVKOUXPKUWEVVSVVAVVBUVPXEXMUVQYTYTUXPVVL
      VVTUWDYTUVRUVSABDEUVTUXHUXLUWAYFUWBUWC $.
  $}

  ${
    $d c d m n x y $.
    $( Lemma for ~ selberg .  Estimation of the left-hand side of
       ~ logsqvma2 .  (Contributed by Mario Carneiro, 23-May-2016.) $)
    selberglem3 $p |- ( x e. RR+ |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) ) sum_ d e. { y e. NN | y || n }
        ( ( mmu ` d ) x. ( ( log ` ( n / d ) ) ^ 2 ) ) / x ) -
        ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( vm crp cv cfv co cn cdiv clog c2 cexp cmul csu cmin wcel oveq1d elfznn
      c1 cfl cfz cdivides wbr crab cmu cmpt wceq oveq1 fveq2d oveq2d rpre wa cz
      co1 ssrab2 simprr sseldi mucl syl zcnd cc nnrpd ad2antrl rpdivcld relogcl
      recnd mulcld dvdsflsumcom w3a 3ad2ant3 3ad2ant2 nnne0d divcan3d 2sumeq2dv
      sqcld nncnd eqtrd mpteq2ia caddc eqid selberglem2 eqeltri ) AFUAAGZUBHZUC
      IZBGCGZUDUEZBJUFZDGZUGHZWHWKKIZLHZMNIZOIZDPCPZWEKIZMWELHOIZQIZUHAFWGUAWEW
      KKIZUBHZUCIZWLEGZLHZMNIZOIZEPDPZWEKIZWSQIZUHUPAFWTXJWEFRZWRXIWSQXKWQXHWEK
      XKWQWGXCWLWKXDOIZWKKIZLHZMNIZOIZEPDPXHXKBWEWPXPECDWHXLUIZWOXOWLOXQWNXNMNX
      QWMXMLWHXLWKKUJUKSULWEUMXKWHWGRZWKWJRZUNUNZWLWOXTWLXTWKJRZWLUORXTWJJWKWIB
      JUQXKXRXSURUSZWKUTVAVBXTWNXTWMFRZWNVCRXTWHWKXRWHFRXKXSXRWHWHWFTVDVEXTWKYB
      VDVFYCWNWMVGVHVAVQVIVJXKWGXCXPXGDEXKWKWGRZXDXCRZVKZXOXFWLOYFXNXEMNYFXMXDL
      YFXDWKYFXDYEXKXDJRYDXDXBTVLVRYFWKYDXKYAYEWKWFTVMZVRYFWKYGVNVOUKSULVPVSSSV
      TAXALHZMNIMMYHOIQIWAIWKKIZEDYIWBWCWD $.

    $( Selberg's symmetry formula.  The statement has many forms, and this one
       is equivalent to the statement that ` sum_ n <_ x , Lam ( n ) log n + `
       ` sum_ m x. n <_ x , Lam ( m ) Lam ( n ) = 2 x log x + O ( x ) ` .
       Equation 10.4.10 of [Shapiro], p. 419.  (Contributed by Mario Carneiro,
       23-May-2016.) $)
    selberg $p |- ( x e. RR+ |-> ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( Lam ` n ) x. ( ( log ` n ) + ( psi ` ( x / n ) ) ) ) / x )
      - ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( vd vm vy crp cfv co cvma clog cdiv caddc cmul csu c2 wcel cn syl recnd
      cr c1 cv cfl cfz cchp cmin cmpt cmu cexp co1 cdivides wbr crab wceq fveq2
      oveq2 fveq2d oveq12d cbvsumv wa fzfid elfznn adantl vmacl fsummulc2 nnrpd
      rpdivcl sylan2 rpred chpval oveq2d nncnd ad2antlr nnne0d divcan3d 3eqtr4d
      sumeq2dv syl5eq oveq1 rpre cc ssrab2 simprr sseldi anassrs sylan remulcld
      dvdsdivcl anasss dvdsflsumcom eqtr4d oveq1d chpcl relogcl fsumadd cfn wss
      mulcld sgmss ssfi syl2anc fsumrecl addcomd adddid eqtrd logsqvma2 cz mucl
      zcnd ad2antrl rpdivcld sqcld 3eqtrd mpteq2ia eqid selberglem2 eqeltri ) A
      FUAAUBZUCGZUDHZBUBZIGZYAJGZXRYAKHZUEGZLHZMHZBNZXRKHZOXRJGMHZUFHZUGAFXTUAX
      RCUBZKHZUCGZUDHZYLUHGZDUBZJGZOUIHZMHZDNZCNZXRKHZYJUFHZUGUJAFYKUUDXRFPZYIU
      UCYJUFUUEYHUUBXRKUUEYHXTEUBYAUKULZEQUMZYPYAYLKHZJGZOUIHZMHZCNZBNZXTYOYPYL
      YQMHZYLKHZJGZOUIHZMHZDNZCNUUBUUEXTYBYEMHZYBYCMHZLHZBNZXTUUGYLIGZUUHIGZMHZ
      CNZUVALHZBNZYHUUMUUEXTUUTBNZXTUVABNZLHXTUVGBNZUVKLHUVCUVIUUEUVJUVLUVKLUUE
      UVJXTYOUVDUUOIGZMHZDNZCNZUVLUUEUVJXTUVDYMUEGZMHZCNUVPXTUUTUVRBCYAYLUNZYBU
      VDYEUVQMYAYLIUOUVSYDYMUEYAYLXRKUPUQURUSUUEXTUVRUVOCUUEYLXTPZUTZUVDYOYQIGZ
      DNZMHYOUVDUWBMHZDNUVRUVOUWAYOUWBUVDDUWAUAYNVAUWAUVDUWAYLQPZUVDTPZUVTUWEUU
      EYLXSVBZVCYLVDZRSUWAYQYOPZUTZUWBUWJYQQPZUWBTPUWIUWKUWAYQYNVBVCZYQVDRSVEUW
      AUVQUWCUVDMUWAYMTPUVQUWCUNUWAYMUVTUUEYLFPYMFPUVTYLUWGVFXRYLVGVHVIYMDVJRVK
      UWAYOUVNUWDDUWJUVMUWBUVDMUWJUUOYQIUWJYQYLUWJYQUWLVLUWJYLUVTUWEUUEUWIUWGVM
      ZVLUWJYLUWMVNVOZUQVKVQVPVQVRUUEEXRUVFUVNDBCYAUUNUNZUVEUVMUVDMUWOUUHUUOIYA
      UUNYLKVSZUQVKXRVTZUUEYAXTPZYLUUGPZUVFWAPUUEUWRUTZUWSUTZUVFUXAUVDUVEUXAUWE
      UWFUUEUWRUWSUWEUUEUWRUWSUTUTZUUGQYLUUFEQWBZUUEUWRUWSWCWDZWEUWHRUXAUUHQPUV
      ETPUXAUUGQUUHUXCUWTYAQPZUWSUUHUUGPUWRUXEUUEYAXSVBZVCZEYLYAWHWFWDUUHVDRWGZ
      SWIWJWKWLUUEXTUUTUVABUUEUAXSVAZUWTYBYEUWTYBUWTUXEYBTPUXGYAVDRSZUWTYEUWTYD
      TPYETPUWTYDUWRUUEYAFPZYDFPUWRYAUXFVFZXRYAVGVHVIYDWMRSZWRUWTYBYCUXJUWTYCUW
      TUXKYCTPUWTYAUXGVFYAWNRSZWRZWOUUEXTUVGUVABUXIUWTUVGUWTUUGUVFCUWTUAYAUDHZW
      PPUUGUXPWQZUUGWPPUWTUAYAVAUWTUXEUXQUXGYAEWSRUXPUUGWTXAUXHXBSUXOWOVPUUEXTY
      GUVBBUWTYGYBYEYCLHZMHUVBUWTYFUXRYBMUWTYCYEUXNUXMXCVKUWTYBYEYCUXJUXMUXNXDX
      EVQUUEXTUULUVHBUWTUXEUULUVHUNUXGEYACXFRVQVPUUEEXRUUKUURDBCUWOUUJUUQYPMUWO
      UUIUUPOUIUWOUUHUUOJUWPUQWLVKUWQUXBYPUUJUXBYPUXBUWEYPXGPUXDYLXHRXIUXBUUIUX
      BUUHFPZUUIWAPUXBYAYLUWRUXKUUEUWSUXLXJUXBYLUXDVFXKUXSUUIUUHWNSRXLWRWJUUEXT
      UUSUUACUWAYOUURYTDUWJUUQYSYPMUWJUUPYROUIUWJUUOYQJUWNUQWLVKVQVQXMWLWLXNAYM
      JGZOUIHOOUXTMHUFHLHYLKHZDCUYAXOXPXQ $.

    $( Convert eventual boundedness in ~ selberg to boundedness on
       ` [ 1 , +oo ) ` .  (We have to bound away from zero because the log
       terms diverge at zero.)  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    selbergb $p |- E. c e. RR+ A. x e. ( 1 [,) +oo )
      ( abs ` ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( Lam ` n ) x. ( ( log ` n ) + ( psi ` ( x / n ) ) ) ) / x )
      - ( 2 x. ( log ` x ) ) ) ) <_ c $=
      ( c1 cfv co c2 cle wbr crp wtru cr wcel wa a1i relogcld readdcld remulcld
      syl adantr vy cv cfl cfz cvma clog cdiv cchp cmul csu cmin cabs cpnf cico
      caddc wral wrex wb elicopnf mp1i simprbda ex ssrdv fzfid cn elfznn adantl
      1re vmacl nnrpd nndivred chpcl fsumrecl 1rp simplbda rpgecld 2re resubcld
      rerpdivcld recnd cmpt co1 selberg o1res2 simprl simprr clt abscld simprll
      ltled abs2dif2d cc0 vmage0 nnge1d logge0d addge0d mulge0d fsumge0 divge0d
      nnred chpge0 2rp rpge0 oveq12d breqtrd cuz flword2 syl3anc fzss2 fsumless
      absidd wss lediv1dd chpwordi leadd2dd fsumle letrd lediv12ad div1d logled
      lemul2ad mpbid le2addd o1bddrp trud ) DAUBZUCEZUDFZBUBZUEEZYIUFEZYFYIUGFZ
      UHEZUOFZUIFZBUJZYFUGFZGYFUFEZUIFZUKFZULEZCUBHIADUMUNFZUPCJUQKAUAUUBYTDCDU
      AUBZUCEZUDFZYJYKUUCYIUGFZUHEZUOFZUIFZBUJZGUUCUFEZUIFZUOFZKAUUBLKYFUUBMZYF
      LMZKUUNUUODYFHIZDLMZUUNUUOUUPNURKVHDYFUSUTZVAZVBVCUUQKVHOKUUNNZYTUUTYQYSU
      UTYPYFUUTYHYOBUUTDYGVDZUUTYIYHMZNZYJYNUVCYIVEMZYJLMZUVBUVDUUTYIYGVFVGZYIV
      IZSZUVCYKYMUVCYIUVCYIUVFVJPZUVCYLLMZYMLMZUVCYFYIUUTUUOUVBUUSTUVFVKZYLVLZS
      ZQZRZVMZUUTYFDUUSDJMZUUTVNOKUUNUUOUUPUURVOZVPZVSZUUTGYRGLMZUUTVQOUUTYFUVT
      PRZVRZVTKAUUBJYTKAUUBJKUUNYFJMZUVTVBVCAJYTWAWBMKABWCOWDKUUCLMZDUUCHIZNZNZ
      UUJUULUWIUUEUUIBUWIDUUDVDUWIYIUUEMZNZYJUUHUWKUVDUVEUWJUVDUWIYIUUDVFZVGZUV
      GSUWKYKUUGUWKYIUWKYIUWMVJPUWKUUFLMZUUGLMZUWKUUCYIUWIUWFUWJKUWFUWGWEZTUWMV
      KUUFVLZSQRVMUWIGUUKUWBUWIVQOUWIUUCUWIUUCDUWPUVRUWIVNOKUWFUWGWFVPPRQUUTUWH
      YFUUCWGIZNZNZUUAYQYSUOFZUUMUWTYTUWTYTUUTYTLMUWSUWDTVTWHUWTYQYSUUTYQLMUWSU
      WATZUUTYSLMUWSUWCTZQUWTUUJUULUWTUUEUUIBUWTDUUDVDZUWTUWJNZYJUUHUXEUVDUVEUW
      JUVDUWTUWLVGZUVGSZUXEYKUUGUXEYIUXEYIUXFVJZPZUXEUWNUWOUXEUUCYIUWTUWFUWJUUT
      UWFUWGUWRWIZTZUXFVKZUWQSZQZRZVMZUWTGUUKUWBUWTVQOZUWTUUCUWTUUCYFUXJUUTUWEU
      WSUVTTZUWTYFUUCUUTUUOUWSUUSTZUXJUUTUWHUWRWFWJZVPZPZRZQUWTUUAYQULEZYSULEZU
      OFUXAHUWTYQYSUWTYQUXBVTUWTYSUXCVTWKUWTUYDYQUYEYSUOUWTYQUXBUWTYPYFUUTYPLMU
      WSUVQTZUXRUUTWLYPHIUWSUUTYHYOBUVAUVPUVCYJYNUVHUVOUVCUVDWLYJHIZUVFYIWMZSUV
      CYKYMUVIUVNUVCYIUVCYIUVFWTUVCYIUVFWNWOUVCUVJWLYMHIZUVLYLXAZSWPWQWRTZWSXKU
      WTYSUXCUWTGYRUXQUWTYFUXRPZGJMWLGHIUWTXBGXCUTZUWTYFUXSUUTUUPUWSUVSTZWOWQXK
      XDXEUWTYQYSUUJUULUXBUXCUXPUYCUWTYQUUJDUGFUUJHUWTYPUUJDYFUYFUXPUVRUWTVNOUX
      SUYKUWTYPUUEYOBUJUUJUYFUWTUUEYOBUXDUXEYJYNUXGUXEYKYMUXIUXEUVJUVKUXEYFYIUW
      TUUOUWJUXSTZUXFVKZUVMSZQZRZVMUXPUWTUUEYOYHBUXDUYSUXEYJYNUXGUYRUXEUVDUYGUX
      FUYHSZUXEYKYMUXIUYQUXEYIUXEYIUXFWTUXEYIUXFWNWOUXEUVJUYIUYPUYJSWPWQUWTUUDY
      GXFEMZYHUUEXLUWTUUOUWFYFUUCHIZVUAUXSUXJUXTYFUUCXGXHYGDUUDXISXJUWTUUEYOUUI
      BUXDUYSUXOUXEYNUUHYJUYRUXNUXGUYTUXEYMUUGYKUYQUXMUXIUXEUVJUWNYLUUFHIYMUUGH
      IUYPUXLUXEYFUUCYIUYOUXKUXHUWTVUBUWJUXTTXMYLUUFXNXHXOYAXPXQUYNXRUWTUUJUWTU
      UJUXPVTXSXEUWTYRUUKGUYLUYBUXQUYMUWTVUBYRUUKHIUXTUWTYFUUCUXRUYAXTYBYAYCXQY
      DYE $.

    $( Lemma for ~ selberg2 .  Equation 10.4.12 of [Shapiro], p. 420.
       (Contributed by Mario Carneiro, 23-May-2016.) $)
    selberg2lem $p |- ( x e. RR+ |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( Lam ` n ) x. ( log ` n ) )
        - ( ( psi ` x ) x. ( log ` x ) ) ) / x ) ) e. O(1) $=
      ( crp c1 cfv co clog cmul cchp cmin cdiv wcel wtru cc cc0 wceq cr syl cle
      wbr vm cv cfl cfz cvma csu cmpt co1 caddc wne wa rpre chpcl recnd rprege0
      cn0 cn flge0nn0 nn0p1nn nnrpd relogcld relogcl subcld mulcld fzfid elfznn
      adantl 1rp rpaddcl mpan2 resubcld fsumcl rpcnne0 divsubdir syl3anc sub32d
      remulcld subdid oveq1d cfzo fveq2 oveq1 fveq2d jca log1 syl6eq 1m1e0 2pos
      c2 clt 0re chpeq0 ax-mp mpbir cuz nnuz syl6eleq nnred peano2rem fsumparts
      wb cz nn0zd fzval3 eqcomd nncnd ax-1cn pncan sylancl npcan eqtr4d nnm1nn0
      chpp1 oveq2d 3eqtrd nn0red vmacl pncan2d eqtrd mulcomd sumeq12rdv oveq12d
      a1i cvv ovex eqidd chpo1ub crli 1re rpred mpbid logdifbnd ad2antrl logleb
      rpreccl mpdan subge0d mpbird cabs absidd nn0cnd chpfl 0cn subid1d 3eqtr3d
      mul01i 3eqtr4d div23 3eqtr3rd mpteq2ia cof reex rpssre ssexi offval2 mp1i
      divrcnv flle leadd1dd logled lesub1dd letrd fllep1 rlimsqz2 o1mul sylancr
      rlimo1 eqeltrrd nnrp ssriv sselda rerpdivcl mpancom chpge0 lemul1ad lep1d
      mulge0d rpregt0 divge0 syl21anc rpcn rpne0 divrec2d 3brtr4d o1res2 o1fsum
      wss o1le o1sub2 syl5eqelr trud ) ACDAUBZUCEZUDFZBUBZUEEZUWOGEZHFZBUFZUWLI
      EZUWLGEZHFZJFZUWLKFZUGZUHLMUXEACUWTUWLKFZUWMDUIFZGEZUXAJFZHFZUWNUWODUIFZG
      EZUWQJFZUWOIEZHFZBUFZUWLKFZJFZUGUHACUXRUXDUWLCLZUWTUXIHFZUXPJFZUWLKFZUXTU
      WLKFZUXQJFZUXDUXRUXSUXTNLUXPNLUWLNLUWLOUJUKZUYBUYDPUXSUWTUXIUXSUWTUXSUWLQ
      LZUWTQLUWLULZUWLUMRUNZUXSUXHUXAUXSUXHUXSUXGUXSUXGUXSUWMUPLZUXGUQLUXSUYFOU
      WLSTUKUYIUWLUOUWLURRZUWMUSRZUTZVAZUNZUXSUXAUWLVBZUNZVCZVDUXSUWNUXOBUXSDUW
      MVEUXSUWOUWNLZUKZUWOCLZUXONLZUYSUWOUYRUWOUQLZUXSUWOUWMVFVGZUTZUYTUXOUYTUX
      MUXNUYTUXLUWQUYTUXKUYTDCLZUXKCLZVHUWODVIVJZVAZUWOVBZVKZUYTUWOQLZUXNQLZUWO
      ULZUWOUMRZVQZUNZRVLZUWLVMZUXTUXPUWLVNVOUXSUYAUXCUWLKUXSUWTUXHHFZUXBJFZUXP
      JFVUSUXPJFZUXBJFUYAUXCUXSVUSUXBUXPUXSUWTUXHUYHUYNVDZUXSUWTUXAUYHUYPVDVUQV
      PUXSUXTVUTUXPJUXSUWTUXHUXAUYHUYNUYPVRVSUXSUWSVVAUXBJUXSDUXGVTFZUWQUXKDJFZ
      IEZUWODJFZIEZJFZHFZBUFUXHUXGDJFZIEZHFZOOHFZJFZVVCUXMVVEHFZBUFZJFUWSVVAUXS
      UAUBZGEZUWQUXLOBUAUXHDUXGVVQDJFZIEZVVGVVEOVVKVVQUWOPZVVRUWQPVVTVVGPVVQUWO
      GWAVWAVVSVVFIVVQUWODJWBWCWDVVQUXKPZVVRUXLPVVTVVEPVVQUXKGWAVWBVVSVVDIVVQUX
      KDJWBWCWDVVQDPZVVROPVVTOPVWCVVRDGEOVVQDGWAWEWFVWCVVTOIEZOVWCVVSOIVWCVVSDD
      JFOVVQDDJWBWGWFWCVWDOPZOWIWJTZWHOQLZVWEVWFXAWKOWLWMWNWFWDVVQUXGPZVVRUXHPV
      VTVVKPVVQUXGGWAVWHVVSVVJIVVQUXGDJWBWCWDUXSUXGUQDWOEUYKWPWQUXSVVQDUXGUDFLZ
      UKZVVRVWJVVQVWJVVQVWIVVQUQLUXSVVQUXGVFVGZUTVAUNVWJVVTVWJVVSQLZVVTQLVWJVVQ
      QLVWLVWJVVQVWKWRVVQWSRVVSUMRUNWTUXSVVCUWNVVIUWRBUXSUWNVVCUXSUWMXBLUWNVVCP
      UXSUWMUYJXCDUWMXDRXEZUYSVVIUWQUWPHFUWRUYSVVHUWPUWQHUYSVVHVVGUWPUIFZVVGJFU
      WPUYSVVEVWNVVGJUYSVVEVVFDUIFZIEZVVGVWOUEEZUIFZVWNUYSVVDVWOIUYSVVDUWOVWOUY
      SUWONLZDNLZVVDUWOPUYSUWOVUCXFZXGUWODXHXIZUYSVWSVWTVWOUWOPVXAXGUWODXJXIZXK
      WCUYSVVFUPLZVWPVWRPUYSVUBVXDVUCUWOXLRZVVFXMRUYSVWQUWPVVGUIUYSVWOUWOUEVXCW
      CXNXOVSUYSVVGUWPUYSVVGUYSVVFQLVVGQLUYSVVFVXEXPVVFUMRUNUYSUWPUYSVUBUWPQLVU
      CUWOXQRUNZXRXSXNUYSUWPUWQVXFUYSUWQUYSUWOVUDVAUNXTXKYAUXSVVNVUSVVPUXPJUXSV
      VNVUSOJFVUSUXSVVLVUSVVMOJUXSVVLUXHUWTHFVUSUXSVVKUWTUXHHUXSVVKUWMIEZUWTUXS
      VVJUWMIUXSUWMNLVWTVVJUWMPUXSUWMUYJUUAXGUWMDXHXIWCUXSUYFVXGUWTPUYGUWLUUBRX
      SXNUXSUXHUWTUYNUYHXTXSVVMOPUXSOUUCUUFYCYBUXSVUSVVBUUDXSUXSVVCUWNVVOUXOBVW
      MUYSVVEUXNUXMHUYSVVDUWOIVXBWCXNYAYBUUEVSUUGVSUXSUYCUXJUXQJUXSUWTNLUXINLZU
      YEUYCUXJPUYHUYQVURUWTUXIUWLUUHVOVSUUIUUJMACUXJUXQYDUXJYDLMUXSUKZUXFUXIHYE
      YCUXQYDLVXIUXPUWLKYEYCMACUXFUGZACUXIUGZHUUKFZACUXJUGUHMACUXFUXIHVXJVXKYDY
      DNCYDLMCQUULUUMUUNYCUXFYDLVXIUWTUWLKYEYCUXSVXHMUYQVGMVXJYFMVXKYFUUOMVXJUH
      LVXKUHLZVXLUHLAYGMVXKOYHTVXMMACDUWLKFZUXIODVWGMWKYCDQLZMYIYCZVWTACVXNUGOY
      HTMXGDAUUQUUPUXSVXNQLMUXSVXNUWLYOYJZVGUXSUXIQLMUXSUXHUXAUYMUYOVKZVGUXSUXI
      VXNSTMDUWLSTZUXSUXIUWLDUIFZGEZUXAJFVXNVXRUXSVYAUXAUXSVXTUXSVUEVXTCLVHUWLD
      VIVJZVAZUYOVKVXQUXSUXHVYAUXAUYMVYCUYOUXSUXGVXTSTUXHVYASTUXSUWMUWLDUXSUWMU
      YJXPUYGVXOUXSYIYCUXSUYFUWMUWLSTUYGUWLUURRUUSUXSUXGVXTUYLVYBUUTYKUVAUWLYLU
      VBYMUXSOUXISTZMVXSUXSVYDUXAUXHSTZUXSUWLUXGSTZVYEUXSUYFVYFUYGUWLUVCRUXSUXG
      CLVYFVYEXAUYLUWLUXGYNYPYKUXSUXHUXAUYMUYOYQYRYMUVDOVXKUVGRVXJVXKUVEUVFUVHM
      AUXOBNMVUBUKUYTVUAMUQCUWOUQCUWGMUAUQCVVQUVIUVJYCZUVKVUPRMBUQCUXOVYGMBCUXN
      UWOKFZUXODQVXPBCVYHUGUHLMBYGYCUYTVYHQLZMVULUYTVYIVUNUXNUWOUVLUVMZVGUYTVUA
      MVUPVGUYTUXOYSEZVYHYSEZSTMDUWOSTUYTUXODUWOKFZUXNHFZVYKVYLSUYTUXMVYMUXNVUJ
      UYTVYMUWOYOYJVUNUYTVUKOUXNSTZVUMUWOUVNRZUWOYLUVOUYTUXOVUOUYTUXMUXNVUJVUNU
      YTOUXMSTUWQUXLSTZUYTUWOUXKSTZVYQUYTUWOVUMUVPUYTVUFVYRVYQXAVUGUWOUXKYNYPYK
      UYTUXLUWQVUHVUIYQYRVYPUVQYTUYTVYLVYHVYNUYTVYHVYJUYTVULVYOVUKOUWOWJTUKOVYH
      STVUNVYPUWOUVRUXNUWOUVSUVTYTUYTUXNUWOUYTUXNVUNUNUWOUWAUWOUWBUWCXSUWDYMUWH
      UWEUWFUWIUWJUWK $.

    $( Selberg's symmetry formula, using the second Chebyshev function.
       Equation 10.4.14 of [Shapiro], p. 420.  (Contributed by Mario Carneiro,
       23-May-2016.) $)
    selberg2 $p |- ( x e. RR+ |->
      ( ( ( ( ( psi ` x ) x. ( log ` x ) ) +
      sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) )
        / x ) - ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( crp cfv co cdiv caddc cmul csu cmin cmpt co1 wtru cvv wcel cr syl recnd
      mulcld cc c1 cv cfl cfz cvma clog cchp c2 cof wceq reex rpssre ssexi ovex
      a1i wa eqidd offval2 trud fzfid cn elfznn adantl vmacl nnrpd relogcl rpre
      nndivre syl2an chpcl addcld fsumcl rpcn rpne0 divcld mulcl sylancr subcld
      2cn sub32d cc0 wne rpcnne0 divsubdir syl3anc adddid sumeq2dv eqtrd oveq1d
      fsumadd pnncand addcomd 3eqtrd eqtr3d mpteq2ia eqtri selberg2lem eqeltrri
      selberg o1sub mp2an ) ACUAAUBZUCDZUDEZBUBZUEDZXEUFDZXBXEFEZUGDZGEZHEZBIZX
      BFEZUHXBUFDZHEZJEZKZACXDXFXGHEZBIZXBUGDZXNHEZJEZXBFEZKZJUIEZACYAXDXFXIHEZ
      BIZGEZXBFEZXOJEZKZLYEACXPYCJEZKZYKYEYMUJMACXPYCJXQYDNNNCNOMCPUKULUMUOXPNO
      MXBCOZUPZXMXOJUNUOYCNOYOYBXBFUNUOMXQUQMYDUQURUSACYLYJYNYLXMYCJEZXOJEYJYNX
      MXOYCYNXLXBYNXDXKBYNUAXCUTZYNXEXDOZUPZXFXJYSXFYSXEVAOZXFPOYRYTYNXEXCVBZVC
      ZXEVDQRZYSXGXIYSXGYSXECOXGPOYSXEUUBVEXEVFQRZYSXIYSXHPOZXIPOYNXBPOZYTUUEYR
      XBVGZUUAXBXEVHVIXHVJQRZVKSVLZXBVMZXBVNZVOYNUHTOXNTOXOTOVSYNXNXBVFRZUHXNVP
      VQYNYBXBYNXSYAYNXDXRBYQYSXFXGUUCUUDSZVLZYNXTXNYNXTYNUUFXTPOUUGXBVJQRUULSZ
      VRZUUJUUKVOVTYNYPYIXOJYNXLYBJEZXBFEZYPYIYNXLTOYBTOXBTOXBWAWBUPUURYPUJUUIU
      UPXBWCXLYBXBWDWEYNUUQYHXBFYNUUQXSYGGEZYBJEYGYAGEYHYNXLUUSYBJYNXLXDXRYFGEZ
      BIUUSYNXDXKUUTBYSXFXGXIUUCUUDUUHWFWGYNXDXRYFBYQUUMYSXFXIUUCUUHSZWJWHWIYNX
      SYGYAUUNYNXDYFBYQUVAVLZUUOWKYNYGYAUVBUUOWLWMWIWNWIWHWOWPXQLOYDLOYELOABWSA
      BWQXQYDWTXAWR $.

    $( Convert eventual boundedness in ~ selberg2 to boundedness on any
       interval ` [ A , +oo ) ` .  (We have to bound away from zero because the
       log terms diverge at zero.)  (Contributed by Mario Carneiro,
       25-May-2016.) $)
    selberg2b $p |- E. c e. RR+ A. x e. ( 1 [,) +oo )
      ( abs ` ( ( ( ( ( psi ` x ) x. ( log ` x ) ) +
      sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) )
        / x ) - ( 2 x. ( log ` x ) ) ) ) <_ c $=
      ( cfv cmul co c1 c2 cle wbr crp wtru cr wcel wa a1i syl remulcld readdcld
      adantr vy cchp clog cfl cfz cvma cdiv caddc cmin cabs cpnf cico wral wrex
      cv csu wb 1re elicopnf mp1i simprbda ex ssrdv chpcl 1rp simplbda relogcld
      rpgecld fzfid cn elfznn vmacl nndivred fsumrecl rerpdivcld resubcld recnd
      adantl 2re co1 selberg2 o1res2 ad2antrl simprl simprr clt abscld ad2ant2r
      abs2dif2d simprll ltled cc0 chpge0 logge0d mulge0d vmage0 fsumge0 addge0d
      cmpt divge0d absidd chpwordi syl3anc logled mpbid lemul12ad cuz wss fzss2
      flword2 fsumless nnrpd lediv1dd lemul2ad fsumle le2addd lediv12ad breqtrd
      letrd div1d eqbrtrd 2rp rpge0 o1bddrp trud ) AUOZUBDZYFUCDZEFZGYFUDDZUEFZ
      BUOZUFDZYFYLUGFZUBDZEFZBUPZUHFZYFUGFZHYHEFZUIFZUJDZCUOIJAGUKULFZUMCKUNLAU
      AUUCUUAGCUAUOZUBDZUUDUCDZEFZGUUDUDDZUEFZYMUUDYLUGFZUBDZEFZBUPZUHFZHUUFEFZ
      UHFZLAUUCMLYFUUCNZYFMNZLUUQUURGYFIJZGMNZUUQUURUUSOUQLURGYFUSUTZVAZVBVCUUT
      LURPLUUQOZUUAUVCYSYTUVCYRYFUVCYIYQUVCYGYHUVCUURYGMNZUVBYFVDZQUVCYFUVCYFGU
      VBGKNZUVCVEPLUUQUURUUSUVAVFZVHZVGZRUVCYKYPBUVCGYJVIZUVCYLYKNZOZYMYOUVLYLV
      JNZYMMNZUVKUVMUVCYLYJVKVRZYLVLZQZUVLYNMNZYOMNZUVLYFYLUVCUURUVKUVBTUVOVMZY
      NVDZQZRZVNZSUVHVOZUVCHYHHMNZUVCVSPUVIRZVPZVQLAUUCKUUALAUUCKLUUQYFKNZUVHVB
      VCAKUUAWSVTNLABWAPWBLUUDMNZGUUDIJZOZOZUUNUUOUWMUUGUUMUWMUUEUUFUWJUUEMNZLU
      WKUUDVDZWCUWMUUDUWMUUDGLUWJUWKWDZUVFUWMVEPLUWJUWKWEVHVGZRUWMUUIUULBUWMGUU
      HVIUWMYLUUINZOZYMUUKUWSUVMUVNUWRUVMUWMYLUUHVKZVRZUVPQUWSUUJMNZUUKMNZUWSUU
      DYLUWMUWJUWRUWPTUXAVMUUJVDZQRVNZSUWMHUUFUWFUWMVSPUWQRSZUVCUWLYFUUDWFJZOZO
      ZUUBYSUJDZYTUJDZUHFUUPUXIUUAUXIUUAUVCUUAMNUXHUWHTVQWGUXIUXJUXKUXIYSUXIYSU
      VCYSMNUXHUWETZVQZWGZUXIYTUXIYTUVCYTMNUXHUWGTZVQZWGZSLUWLUUPMNUUQUXGUXFWHU
      XIYSYTUXMUXPWIUXIUXJUXKUUNUUOUXNUXQUXIUUGUUMUXIUUEUUFUXIUWJUWNUVCUWJUWKUX
      GWJZUWOQZUXIUUDUXIUUDYFUXRUVCUWIUXHUVHTZUXIYFUUDUVCUURUXHUVBTZUXRUVCUWLUX
      GWEWKZVHZVGZRZLUWLUUMMNUUQUXGUXEWHZSZUXIHUUFUWFUXIVSPZUYDRUXIUXJYSUUNIUXI
      YSUXLUXIYRYFUXIYIYQUXIYGYHUXIUURUVDUYAUVEQZUXIYFUXTVGZRZUVCYQMNUXHUWDTZSZ
      UXTUXIYIYQUYKUYLUXIYGYHUYIUYJUXIUURWLYGIJUYAYFWMQZUXIYFUYAUVCUUSUXHUVGTZW
      NZWOUVCWLYQIJUXHUVCYKYPBUVJUWCUVLYMYOUVQUWBUVLUVMWLYMIJZUVOYLWPZQUVLUVRWL
      YOIJZUVTYNWMZQWOWQTWRZWTXAUXIYSUUNGUGFUUNIUXIYRUUNGYFUYMUYGUVFUXIVEPUYAVU
      AUXIYIYQUUGUUMUYKUYLUYEUYFUXIYGUUEYHUUFUYIUXSUYJUYDUYNUYPUXIUURUWJYFUUDIJ
      ZYGUUEIJUYAUXRUYBYFUUDXBXCUXIVUBYHUUFIJUYBUXIYFUUDUXTUYCXDXEZXFUXIYQUUIYP
      BUPUUMUYLUXIUUIYPBUXIGUUHVIZUXIUWROZYMYOVUEUVMUVNUWRUVMUXIUWTVRZUVPQZVUEU
      VRUVSVUEYFYLUXIUURUWRUYATZVUFVMZUWAQZRZVNUYFUXIUUIYPYKBVUDVUKVUEYMYOVUGVU
      JVUEUVMUYQVUFUYRQZVUEUVRUYSVUIUYTQWOUXIUUHYJXGDNZYKUUIXHUXIUURUWJVUBVUMUY
      AUXRUYBYFUUDXJXCYJGUUHXIQXKUXIUUIYPUULBVUDVUKVUEYMUUKVUGVUEUXBUXCVUEUUDYL
      UXIUWJUWRUXRTZVUFVMZUXDQZRVUEYOUUKYMVUJVUPVUGVULVUEUVRUXBYNUUJIJYOUUKIJVU
      IVUOVUEYFUUDYLVUHVUNVUEYLVUFXLUXIVUBUWRUYBTXMYNUUJXBXCXNXOXSXPUYOXQUXIUUN
      UXIUUNUYGVQXTXRYAUXIUXKYTUUOIUXIYTUXOUXIHYHUYHUYJHKNWLHIJUXIYBHYCUTZUYPWO
      XAUXIYHUUFHUYJUYDUYHVUQVUCXNYAXPXSYDYE $.
  $}

  ${
    $d c m n x y z C $.  $d n x y ph $.  $d n z X $.  $d n z Y $.  $d c A $.
    $d z B $.
    chpdifbnd.a $e |- ( ph -> A e. RR+ ) $.
    chpdifbnd.1 $e |- ( ph -> 1 <_ A ) $.
    chpdifbnd.b $e |- ( ph -> B e. RR+ ) $.
    chpdifbnd.2 $e |- ( ph -> A. z e. ( 1 [,) +oo )
      ( abs ` ( ( ( ( ( psi ` z ) x. ( log ` z ) ) +
      sum_ m e. ( 1 ... ( |_ ` z ) ) ( ( Lam ` m ) x. ( psi ` ( z / m ) ) ) )
        / z ) - ( 2 x. ( log ` z ) ) ) ) <_ B ) $.
    chpdifbnd.c $e |- C = ( ( B x. ( A + 1 ) ) +
      ( ( 2 x. A ) x. ( log ` A ) ) ) $.
    ${
      chpdifbnd.x $e |- ( ph -> X e. ( 1 (,) +oo ) ) $.
      chpdifbnd.y $e |- ( ph -> Y e. ( X [,] ( A x. X ) ) ) $.
      $( Lemma for ~ chpdifbnd .  (Contributed by Mario Carneiro,
         25-May-2016.) $)
      chpdifbndlem1 $p |- ( ph -> ( ( psi ` Y ) - ( psi ` X ) ) <_
          ( ( 2 x. ( Y - X ) ) + ( C x. ( X / ( log ` X ) ) ) ) ) $=
        ( co cmul caddc cle wcel vn cchp cfv cmin c2 clog cdiv wbr cr w3a wb c1
        cicc cpnf cioo ioossre sseldi rpred remulcld elicc2 syl2anc mpbid chpcl
        simp1d syl resubcld cc0 0re a1i 1re 0lt1 wa eliooord simpld lttrd elrpd
        clt relogcld 2re remulcl sylancr readdcld peano2re syl5eqel cfl cv cvma
        cfz csu fzfid cuz simp2d flword2 syl3anc fzss2 sselda cn elfznn nndivre
        wss syl2an fsumrecl chpge0 logled lemul2ad mulge0d adantr letrd le2addd
        rerpdivcld cabs recnd elicopnf ax-mp sylanbrc wceq fveq2 oveq12d fveq2d
        oveq2d simpl oveq1d sumeq12rdv syl5eq breq1d rspcv sylc leadd2dd mpbird
        2pos subdird eqtr4d eqtrd adddid adddird 3eqtr4d breqtrrd mulassd crp
        id adantl vmacl syldan rpmulcld vmage0 fsumless nnrpd lediv1dd chpwordi
        ltletrd fsumle abscld leabsd cico ltled cbvsumv lesubaddd simp3d pm3.2i
        wral lemul2 ledivmul2d absdifled lemuldivd le2subd pnpcan2d cneg negcld
        oveq2 addsub4d relogmuld addcomd cc add12d negsubd mul32d subdid add32d
        2cn subnegd 3brtr3d leadd1dd mulid2d lemul2d ltleii 1rp syl5eqbrr mul4d
        log1 logleb oveq1i rplogcld rpne0d divcan1d lemul1d ) AHUBUCZGUBUCZUDPZ
        UEHGUDPZQPZEGGUFUCZUGPZQPZRPZSUHUWRUXAQPZUXDUXAQPZSUHAUXEUWTUXAQPZEGQPZ
        RPZUXFSAUXEUXGDHGRPZQPZUECUFUCZQPZHQPZRPZRPZUXIAUWRUXAAUWPUWQAHUITZUWPU
        ITAUXQGHSUHZHCGQPZSUHZAHGUXSUMPTZUXQUXRUXTUJZOAGUITZUXSUITUYAUYBUKAULUN
        UOPZUIGULUNUPNUQZACGACIURZUYEUSZGUXSHUTVAVBZVDZHVCVEZAUYCUWQUITUYEGVCVE
        ZVFZAGAGUYEAVGULGVGUITAVHVIZULUITZAVJVIZUYEVGULVQUHAVKVIAULGVQUHZGUNVQU
        HZAGUYDTUYPUYQVLNGULUNVMVEVNZVOZVPZVRZUSAUXGUXOAUWTUXAAUEUITZUWSUITUWTU
        ITVSAHGUYIUYEVFZUEUWSVTWAZVUAUSZAUXKUXNADUXJADKURZAHGUYIUYEWBZUSZAUXMHA
        VUBUXLUITUXMUITVSACIVRZUEUXLVTWAZUYIUSZWBZWBAUXGUXHVUEAEGAEDCULRPZQPZUE
        CQPZUXLQPZRPZUIMAVUNVUPADVUMVUFACUITZVUMUITUYFCWCVEZUSZAVUOUXLAVUBVURVU
        OUITVSUYFUECVTWAZVUIUSZWBWDZUYEUSZWBAUWPUXAQPZULGWEUCZWHPZUAWFZWGUCZGVV
        HUGPZUBUCZQPZUAWIZRPZUWQUXAQPZVVMRPZUDPZDUEUXSUFUCZQPZRPZHQPZUEUXAQPZDU
        DPZGQPZUDPZUXEUXPSAVVNVWDVWAVVPAVVEVVMAUWPUXAUYJVUAUSZAVVGVVLUAAULVVFWJ
        AVVHVVGTZVVHULHWEUCZWHPZTZVVLUITAVVGVWIVVHAVWHVVFWKUCTZVVGVWIWTAUYCUXQU
        XRVWKUYEUYIAUXQUXRUXTUYHWLZGHWMWNVVFULVWHWOVEZWPAVWJVLZVVIVVKVWNVVHWQTZ
        VVIUITVWJVWOAVVHVWHWRZUUAZVVHUUBVEZVWNVVJUITZVVKUITAUYCVWOVWSVWJUYEVWPG
        VVHWSXAZVVJVCVEZUSZUUCXBZWBZAVWCGAVWBDAVUBUXAUITVWBUITVSVUAUEUXAVTWAZVU
        FVFZUYEUSAVVTHADVVSVUFAVUBVVRUITZVVSUITVSAUXSACGIUYTUUDZVRZUEVVRVTWAZWB
        ZUYIUSZAVVOVVMAUWQUXAUYKVUAUSZVXCWBZAVVNUWPHUFUCZQPZVWIVVIHVVHUGPZUBUCZ
        QPZUAWIZRPZVWAVXDAVXPVXTAUWPVXOUYJAHAHUYIAVGGHUYMUYEUYIUYSVWLUUJVPZVRZU
        SZAVWIVXSUAAULVWHWJZVWNVVIVXRVWRVWNVXQUITZVXRUITAUXQVWOVYFVWJUYIVWPHVVH
        WSXAZVXQVCVEZUSZXBZWBZVXLAVVEVVMVXPVXTVWFVXCVYDVYJAUXAVXOUWPVUAVYCUYJAU
        XQVGUWPSUHUYIHXCVEAUXRUXAVXOSUHVWLAGHUYTVYBXDVBXEAVVMVWIVVLUAWIVXTVXCAV
        WIVVLUAVYEVXBXBVYJAVWIVVLVVGUAVYEVXBVWNVVIVVKVWRVXAVWNVWOVGVVISUHVWQVVH
        UUEVEZVWNVWSVGVVKSUHVWTVVJXCVEXFVWMUUFAVWIVVLVXSUAVYEVXBVYIVWNVVKVXRVVI
        VXAVYHVWRVYLVWNVWSVYFVVJVXQSUHVVKVXRSUHVWTVYGVWNGHVVHAUYCVWJUYEXGAUXQVW
        JUYIXGVWNVVHVWQUUGAUXRVWJVWLXGUUHVVJVXQUUIWNXEUUKXHXIAVYAHUGPZVVTSUHVYA
        VWASUHAVYMDUEVXOQPZRPZVVTAVYAHVYKVYBXJZADVYNVUFAVUBVXOUITZVYNUITVSVYCUE
        VXOVTWAZWBVXKAVYMVYNUDPZDSUHVYMVYOSUHAVYSVYSXKUCZDAVYMVYNVYPVYRVFZAVYSA
        VYSWUAXLUULVUFAVYSWUAUUMAHULUNUUNPZTZBWFZUBUCZWUDUFUCZQPZULWUDWEUCZWHPZ
        FWFZWGUCZWUDWUJUGPZUBUCZQPZFWIZRPZWUDUGPZUEWUFQPZUDPZXKUCZDSUHZBWUBUUTZ
        VYTDSUHZAUXQULHSUHZWUCUYIAULGHUYOUYEUYIAULGUYOUYEUYRUUOZVWLXHUYNWUCUXQW
        VDVLUKVJULHXMXNXOLWVAWVCBHWUBWUDHXPZWUTVYTDSWVFWUSVYSXKWVFWUQVYMWURVYNU
        DWVFWUPVYAWUDHUGWVFWUGVXPWUOVXTRWVFWUEUWPWUFVXOQWUDHUBXQWUDHUFXQZXRWVFW
        UOWUIVVIWUDVVHUGPZUBUCZQPZUAWIZVXTWUIWUNWVJFUAWUJVVHXPZWUKVVIWUMWVIQWUJ
        VVHWGXQWVLWULWVHUBWUJVVHWUDUGUVIXSXRUUPZWVFWUIVWIWVJVXSUAWVFWUHVWHULWHW
        UDHWEXQXTWVFVWJVLZWVIVXRVVIQWVNWVHVXQUBWVNWUDHVVHUGWVFVWJYAYBXSXTYCYDXR
        WVFYTXRWVFWUFVXOUEQWVGXTXRXSYEYFYGXHAVYMVYNDVYPVYRVUFUUQVBAVYNVVSDVYRVX
        JVUFAVXOVVRSUHZVYNVVSSUHZAUXTWVOAUXQUXRUXTUYHUURZAHUXSVYBVXHXDVBAVYQVXG
        VUBVGUEVQUHZVLZWVOWVPUKVYCVXIWVSAVUBWVRVSYJUUSVIVXOVVRUEUVAWNVBYHXHAVYA
        VVTHVYKVXKVYBUVBVBXHAVWDVVPSUHVWCVVPGUGPZSUHZAWWAWVTVWBDRPSUHZAWVTVWBUD
        PZXKUCZDSUHZWWAWWBVLAGWUBTZWVBWWEAUYCULGSUHZWWFUYEWVEUYNWWFUYCWWGVLUKVJ
        ULGXMXNXOLWVAWWEBGWUBWUDGXPZWUTWWDDSWWHWUSWWCXKWWHWUQWVTWURVWBUDWWHWUPV
        VPWUDGUGWWHWUGVVOWUOVVMRWWHWUEUWQWUFUXAQWUDGUBXQWUDGUFXQZXRWWHWUOWVKVVM
        WVMWWHWUIVVGWVJVVLUAWWHWUHVVFULWHWUDGWEXQXTWWHVWGVLZWVIVVKVVIQWWJWVHVVJ
        UBWWJWUDGVVHUGWWHVWGYAYBXSXTYCYDXRWWHYTXRWWHWUFUXAUEQWWIXTXRXSYEYFYGAWV
        TVWBDAVVPGVXNUYTXJVXEVUFUVCVBVNAVWCVVPGVXFVXNUYTUVDYIUVEAVVQVVEVVOUDPUX
        EAVVEVVOVVMAVVEVWFXLAVVOVXMXLAVVMVXCXLUVFAUWPUWQUXAAUWPUYJXLAUWQUYKXLAU
        XAVUAXLZYKYLAVWBHQPZDUXMRPZHQPZRPZVWBGQPZDGQPZUVGZRPZUDPWWLWWPUDPZWWNWW
        RUDPZRPVWEUXPAWWLWWNWWPWWRAWWLAVWBHVXEUYIUSXLAWWNAWWMHADUXMVUFVUJWBZUYI
        USXLZAWWPAVWBGVXEUYEUSXLZAWWQAWWQADGVUFUYEUSXLZUVHUVJAVWAWWOVWDWWSUDAVW
        AVWBWWMRPZHQPWWOAVVTWXFHQAVVTDVWBUXMRPZRPWXFAVVSWXGDRAVVSUEUXAUXLRPZQPW
        XGAVVRWXHUEQAVVRUXLUXARPWXHACGIUYTUVKAUXLUXAAUXLVUIXLZWWKUVLYMXTAUEUXAU
        XLUEUVMTAUVSVIZWWKWXIYNYMXTADVWBUXMADVUFXLZAVWBVXEXLZAUXMVUJXLZUVNYMYBA
        VWBWWMHWXLAWWMWXBXLAHUYIXLZYOYMAVWDWWPWWQUDPWWSAVWBDGWXLWXKAGUYEXLZYKAW
        WPWWQWXDWXEUVOYLXRAUXGWWTUXOWXARAUXGVWBUWSQPWWTAUEUWSUXAWXJAUWSVUCXLWWK
        UVPAVWBHGWXLWXNWXOUVQYMAUXOWWNWWQRPZWXAADHQPZWWQRPZUXNRPWXQUXNRPZWWQRPU
        XOWXPAWXQWWQUXNAWXQADHVUFUYIUSXLWXEAUXNVUKXLUVRAUXKWXRUXNRADHGWXKWXNWXO
        YNYBAWWNWXSWWQRADUXMHWXKWXMWXNYOYBYPAWWNWWQWXCWXEUVTYLXRYPUWAAUXOUXHUXG
        VULVVDVUEAUXOVUNGQPZVUPGQPZRPZUXHSAUXKUXNWXTWYAVUHVUKAVUNGVUTUYEUSAVUPG
        VVBUYEUSAUXKDVUMGQPZQPZWXTSAUXJWYCSUHUXKWYDSUHAUXJUXSGRPZWYCSAHUXSGUYIU
        YGUYEWVQUWBAWYCUXSULGQPZRPWYEACULGACUYFXLZAULUYOXLWXOYOAWYFGUXSRAGWXOUW
        CXTYMYQAUXJWYCDVUGAVUMGVUSUYEUSKUWDVBADVUMGWXKAVUMVUSXLWXOYRYQAUXNUXMUX
        SQPZWYASAHUXSUXMUYIUYGVUJAUEUXLVUBAVSVIVUIVGUESUHAVGUEVHVSYJUWEVIAVGULU
        FUCZUXLSUWIAULCSUHZWYIUXLSUHZJAULYSTCYSTWYJWYKUKUWFIULCUWJWAVBUWGXFWVQX
        EAWYAVUOUXLGQPQPWYHAVUOUXLGAVUOVVAXLWXIWXOYRAUECUXLGWXJWYGWXIWXOUWHYMYQ
        XIAUXHVUQGQPWYBEVUQGQMUWKAVUNVUPGAVUNVUTXLAVUPVVBXLWXOYOYDYQYHXHAUXFUXG
        UXCUXAQPZRPUXIAUWTUXCUXAAUWTVUDXLAUXCAEUXBVVCAGUXAUYEAGUYEUYRUWLZXJZUSZ
        XLWWKYOAWYLUXHUXGRAWYLEUXBUXAQPZQPUXHAEUXBUXAAEVVCXLAUXBWYNXLWWKYRAWYPG
        EQAGUXAWXOWWKAUXAWYMUWMUWNXTYMXTYMYQAUWRUXDUXAUYLAUWTUXCVUDWYOWBWYMUWOY
        I $.
    $}

    $( Lemma for ~ chpdifbnd .  (Contributed by Mario Carneiro,
       25-May-2016.) $)
    chpdifbndlem2 $p |- ( ph ->
      E. c e. RR+ A. x e. ( 1 (,) +oo ) A. y e. ( x [,] ( A x. x ) )
          ( ( psi ` y ) - ( psi ` x ) ) <_
        ( ( 2 x. ( y - x ) ) + ( c x. ( x / ( log ` x ) ) ) ) ) $=
      ( crp wcel cfv co cmul cle cv cchp cmin c2 clog cdiv caddc cicc wral cpnf
      wbr cioo wrex 1rp rpaddcl sylancl rpmulcld rpred rpmulcl sylancr relogcld
      c1 2rp remulcld readdcld cc0 clt 00id 0re a1i rpgt0d rprege0d log1 logleb
      cr wa wb mpbid syl5eqbrr mulge0 syl12anc ltleaddd syl5eqel adantr cfl cfz
      elrpd cvma cabs cico simprl simprr chpdifbndlem1 ralrimivva oveq2d breq2d
      csu wceq oveq1 2ralbidv rspcev syl2anc ) AGOPCUAZUBQBUAZUBQUCRZUDXCXDUCRS
      RZGXDXDUEQUFRZSRZUGRZTUKZCXDEXDSRUHRZUIBVBUJULRZUIZXEXFIUAZXGSRZUGRZTUKZC
      XKUIBXLUIZIOUMAGFEVBUGRZSRZUDESRZEUEQZSRZUGRZONAYDAXTYCAXTAFXSLAEOPZVBOPZ
      XSOPJUNEVBUOUPUQZURZAYAYBAYAAUDOPYEYAOPVCJUDEUSUTZURAEJVAZVDZVEAVFVFVFUGR
      YDVGVHAVFVFXTYCVFVOPAVIVJZYLYHYKAXTYGVKAYAVOPVFYATUKVPYBVOPVFYBTUKVFYCTUK
      AYAYIVLYJAVFVBUEQZYBTVMAVBETUKZYMYBTUKZKAYFYEYNYOVQUNJVBEVNUTVRVSYAYBVTWA
      WBVSWGWCAXJBCXLXKAXDXLPZXCXKPZVPZVPDEFGHXDXCAYEYRJWDAYNYRKWDAFOPYRLWDADUA
      ZUBQYSUEQZSRVBYSWEQWFRHUAZWHQYSUUAUFRUBQSRHWQUGRYSUFRUDYTSRUCRWIQFTUKDVBU
      JWJRUIYRMWDNAYPYQWKAYPYQWLWMWNXRXMIGOXNGWRZXQXJBCXLXKUUBXPXIXETUUBXOXHXFU
      GXNGXGSWSWOWPWTXAXB $.
  $}

  ${
    $d b c n x y z A $.
    $( A bound on the difference of nearby ` psi ` values.  Theorem 10.5.2 of
       [Shapiro], p. 427.  (Contributed by Mario Carneiro, 25-May-2016.) $)
    chpdifbnd $p |- ( ( A e. RR /\ 1 <_ A ) ->
      E. c e. RR+ A. x e. ( 1 (,) +oo ) A. y e. ( x [,] ( A x. x ) )
          ( ( psi ` y ) - ( psi ` x ) ) <_
        ( ( 2 x. ( y - x ) ) + ( c x. ( x / ( log ` x ) ) ) ) ) $=
      ( vz vn vb cr wcel c1 cle wbr wa cv cchp cfv cmul co caddc crp cfl cfz c2
      clog cvma cdiv csu cmin cabs cpnf cico wral wrex cicc selberg2b simpl cc0
      cioo 0re a1i 1re clt 0lt1 simpr ltletrd elrpd adantr simplr simprl simprr
      eqid chpdifbndlem2 rexlimdvaa mpi ) CHIZJCKLZMZENZOPVRUDPZQRJVRUAPUBRFNZU
      EPVRVTUFROPQRFUGSRVRUFRUCVSQRUHRUIPGNZKLEJUJUKRULZGTUMBNZOPANZOPUHRUCWCWD
      UHRQRDNWDWDUDPUFRQRSRKLBWDCWDQRUNRULAJUJURRULDTUMZEFGUOVQWBWEGTVQWATIZWBM
      ZMABECWAWACJSRQRUCCQRCUDPQRSRZFDVQCTIWGVQCVOVPUPZVQUQJCUQHIVQUSUTJHIVQVAU
      TWIUQJVBLVQVCUTVOVPVDVEVFVGVOVPWGVHVQWFWBVIVQWFWBVJWHVKVLVMVN $.
  $}

  ${
    $d i m n N $.
    $( A bound on a sum of logs, used in ~ pntlemk .  This is not as precise as
       ~ logdivsum in its asymptotic behavior, but it is valid for all ` N `
       and does not require a limit value.  (Contributed by Mario Carneiro,
       13-Apr-2016.) $)
    logdivbnd $p |- ( N e. NN -> sum_ n e. ( 1 ... N ) ( ( log ` n ) / n ) <_
      ( ( ( ( log ` N ) + 1 ) ^ 2 ) / 2 ) ) $=
      ( vi wcel c2 c1 cfz co cfv cdiv csu cmul cle wbr cr recnd cmin cc0 oveq2d
      wceq vm cn cv clog caddc cexp 2re fzfid cuz elfzuz adantl syl6eleqr nnrpd
      nnuz relogcld nndivred fsumrecl remulcl sylancr nnrecred resqcld peano2re
      wa elfznn nnrp syl 2timesd cem cicc nncnd ax-1cn npcan sylancl fveq2d cn0
      nnm1nn0 harmonicbnd3 3syl eqeltrrd 0re emre elicc2i simp2bi subge0d mpbid
      cc lediv1dd rpreccld rpge0d wss cz elfzelz peano2zm nnred lem1d syl3anbrc
      eluz2 fzss2 fsumless wb nngt0d lediv1 syl112anc letrd fsumle le2addd cfzo
      clt oveq1 sumeq1d jca c0 syl6eq fz10 sum0 peano2nn syl6eleq fsumparts nnz
      1m1e0 fzval3 eqcomd pncan oveq2 fsumm1 eqtrd oveq1d pncan2d nnne0d eqtr4d
      divrecd sumeq12rdv nncn oveq12d sqvald 0cn mul01i a1i sqcld crp flid nnre
      subid1d divrec2d 3eqtr3rd subaddd breqtrd cfl nnge1 harmonicubnd eqbrtrrd
      eqbrtrd syl2anc fsumge0 log1 logleb syl5eqbrr lep1d le2sqd 2pos lemuldiv2
      1rp ) BUBDZEFBGHZAUCZUDIZUVEJHZAKZLHZBUDIZFUEHZEUFHZMNZUVHUVLEJHMNZUVCUVI
      UVDFCUCZJHZCKZEUFHZUVLUVCEODZUVHODZUVIODUGUVCUVDUVGAUVCFBUHZUVCUVEUVDDZVC
      ZUVFUVEUWCUVEUWCUVEUWCUVEFUIIZUBUWBUVEUWDDUVCUVEFBUJUKZUNULZUMZUOZUWFUPZU
      QZEUVHURUSUVCUVQUVCUVDUVPCUWAUVCUVOUVDDZVCZUVOUWKUVOUBDZUVCUVOBVDUKZUTZUQ
      ZVAUVCUVKUVCUVJODUVKODUVCBBVEZUOZUVJVBVFZVAZUVCUVIUVHUVHUEHZUVRMUVCUVHUVC
      UVHUWJPVGUVCUXAUVDFUVEGHZUVPCKZUVEJHZAKZUVDFUVEFQHZGHZUVPCKZUVEJHZAKZUEHZ
      UVRMUVCUVHUVHUXEUXJUWJUWJUVCUVDUXDAUWAUWCUXCUVEUWCUXBUVPCUWCFUVEUHZUWCUVO
      UXBDZVCZUVOUXMUWMUWCUVOUVEVDUKZUTZUQZUWFUPZUQZUVCUVDUXIAUWAUWCUXHUVEUWCUX
      GUVPCUWCFUXFUHUWCUVOUXGDZVCUVOUXTUWMUWCUVOUXFVDUKUTUQZUWFUPZUQZUVCUVDUVGU
      XDAUWAUWIUXRUWCUVGUXIUXDUWIUYBUXRUWCUVFUXHUVEUWHUYAUWGUWCRUXHUVFQHZMNZUVF
      UXHMNUWCUYDRVHVIHZDZUYEUWCUXHUXFFUEHZUDIZQHZUYDUYFUWCUYIUVFUXHQUWCUYHUVEU
      DUWCUVEWFDZFWFDZUYHUVETUWCUVEUWFVJZVKUVEFVLVMVNSUWCUVEUBDUXFVODUYJUYFDUWF
      UVEVPCUXFVQVRVSUYGUYDODUYEUYDVHMNRVHUYDVTWAWBWCVFUWCUXHUVFUYAUWHWDWEWGZUW
      CUXHUXCMNZUXIUXDMNZUWCUXBUVPUXGCUXLUXPUXNUVPUXNUVOUXNUVOUXOUMWHWIUWCUVEUX
      FUIIDZUXGUXBWJUWCUXFWKDZUVEWKDZUXFUVEMNUYQUWCUYSUYRUWBUYSUVCUVEFBWLUKZUVE
      WMVFUYTUWCUVEUWCUVEUWFWNZWOUXFUVEWQWPUXFFUVEWRVFWSUWCUXHODUXCODUVEODRUVEX
      HNUYOUYPWTUYAUXQVUAUWCUVEUWFXAUXHUXCUVEXBXCWEXDXEUVCUVDUVGUXIAUWAUWIUYBUY
      NXEXFUVCUVRUXEQHZUXJTUXKUVRTUVCFBFUEHZXGHZUXHFUVEFUEHZFQHZGHZUVPCKZUXHQHZ
      LHZAKFVUCFQHZGHZUVPCKZVUMLHZRRLHZQHZVUDVUIVUHLHZAKZQHUXJVUBUVCFUAUCZFQHZG
      HZUVPCKZUXHVUHRAUAVUMFVUCVVBUXHVUHRVUMVUSUVETZVVBUXHTZVVDVVCVVAUXGUVPCVVC
      VUTUXFFGVUSUVEFQXISXJZVVEXKVUSVUETZVVBVUHTZVVGVVFVVAVUGUVPCVVFVUTVUFFGVUS
      VUEFQXISXJZVVHXKVUSFTZVVBRTZVVJVVIVVBXLUVPCKRVVIVVAXLUVPCVVIVVAFRGHXLVVIV
      UTRFGVVIVUTFFQHRVUSFFQXIXTXMSXNXMXJUVPCXOXMZVVKXKVUSVUCTZVVBVUMTZVVMVVLVV
      AVULUVPCVVLVUTVUKFGVUSVUCFQXISXJZVVNXKUVCVUCUBUWDBXPUNXQUVCVUSFVUCGHDVCZV
      VBVVOVVAUVPCVVOFVUTUHVVOUVOVVADZVCUVOVVPUWMVVOUVOVUTVDUKUTUQPZVVQXRUVCVUD
      UVDVUJUXIAUVCUVDVUDUVCBWKDZUVDVUDTBXSZFBYAVFYBZUWCVUJUXHFUVEJHZLHUXIUWCVU
      IVWAUXHLUWCVUIUXHVWAUEHZUXHQHVWAUWCVUHVWBUXHQUWCVUHUXCVWBUWCVUGUXBUVPCUWC
      VUFUVEFGUWCUYKUYLVUFUVETUYMVKUVEFYCVMSXJZUWCUVPVWACFUVEUWEUXNUVPUXPPUVOUV
      EFJYDYEYFYGUWCUXHVWAUWCUXHUYAPZUWCVWAUWCUVEUWFUTPYHYFZSUWCUXHUVEVWDUYMUWC
      UVEUWFYIZYKYJYLUVCVUPUVRVURUXEQUVCVUPUVRRQHUVRUVCVUNUVRVUORQUVCVUNUVQUVQL
      HUVRUVCVUMUVQVUMUVQLUVCVULUVDUVPCUVCVUKBFGUVCBWFDUYLVUKBTBYMVKBFYCVMSXJZV
      WGYNUVCUVQUVCUVQUWPPZYOYJVUORTUVCRYPYQYRYNUVCUVRUVCUVQVWHYSZUUCYFUVCVUDUV
      DVUQUXDAVVTUWCVUQVWAUXCLHUXDUWCVUIVWAVUHUXCLVWEVWCYNUWCUXCUVEUWCUXCUXQPUY
      MVWFUUDYJYLYNUUEUVCUVRUXEUXJVWIUVCUXEUXSPUVCUXJUYCPUUFWEUUGUULUVCUVQUVKMN
      UVRUVLMNUVCFBUUHIZGHZUVPCKZUVQUVKMUVCVWKUVDUVPCUVCVWJBFGUVCVVRVWJBTVVSBUU
      AVFSXJUVCBODFBMNZVWLUVKMNBUUBBUUIZBCUUJUUMUUKUVCUVQUVKUWPUWSUVCUVDUVPCUWA
      UWOUWLUVPUWLUVOUWLUVOUWNUMWHWIUUNUVCRUVJUVKRODUVCVTYRUWRUWSUVCRFUDIZUVJMU
      UOUVCVWMVWOUVJMNZVWNUVCFYTDBYTDVWMVWPWTUVBUWQFBUUPUSWEUUQUVCUVJUWRUURXDUU
      SWEXDUVCUVTUVLODUVSREXHNZUVMUVNWTUWJUWTUVSUVCUGYRVWQUVCUUTYRUVHUVLEUVAXCW
      E $.
  $}

  ${
    $d k m n x y A $.  $d m n x ph $.
    selberg3lem1.1 $e |- ( ph -> A e. RR+ ) $.
    selberg3lem1.2 $e |- ( ph -> A. y e. ( 1 [,) +oo )
      ( abs ` ( ( sum_ k e. ( 1 ... ( |_ ` y ) ) ( ( Lam ` k ) x. ( log ` k ) )
        - ( ( psi ` y ) x. ( log ` y ) ) ) / y ) ) <_ A ) $.
    $( Introduce a log weighting on the summands of
       ` sum_ m x. n <_ x , Lam ( m ) Lam ( n ) ` , the core of ~ selberg2
       (written here as ` sum_ n <_ x , Lam ( n ) psi ( x / n ) ` ).  Equation
       10.4.21 of [Shapiro], p. 422.  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    selberg3lem1 $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
    ( ( ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) x. ( log ` n ) ) )
      - sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) ) / x ) ) e. O(1) ) $=
      ( c1 co cfv cdiv csu cmul cmin cr wcel wbr recnd cle vm cpnf cioo cfl cfz
      cv cvma clog c2 cchp 1re a1i cmpt co1 cc ioossre rpcnd o1const sylancr wa
      wss fzfid cn elfznn adantl syl nndivred fsumrecl crp elioore clt eliooord
      vmacl simpld rplogcld rpdivcl syl2an rpred remulcld adantr subdird rpne0d
      divcan2d oveq2d eqtrd mpteq2dva resubcld cc0 0re lttrd elrpd ex vmadivsum
      0lt1 ssrdv o1res2 ceu ere cabs wceq adantrr rprege0d absid loge simprr wb
      mpbid rpregt0d eqbrtrd mpbird chpcl nnrpd relogcld abscld mulcld ad2antrr
      absdivd rpge0d absidd weq fveq2 oveq12d cbvsumv syl5eq ledivmul2d divassd
      fveq2d oveq1d 3brtr4d fsummulc1 letrd caddc subdid mulassd 3eqtr4d 3eqtrd
      breqtrrd sumeq2dv eqtr4d divdiv1d epr logleb syl5eqbrr 1rp rpregt0 lediv2
      mp1i syl3anc div1d breqtrd elo1d o1mul2 eqeltrrd 2re rerpdivcl rerpdivcld
      o1dif nndivre 2cn subcld gt0ne0d redivcld fsumcl fsumabs vmage0 cico wral
      nncnd mulid2d fznnfl simplbda lemuldivd elicopnf ax-mp sylanbrc id breq1d
      sumeq1d sylc eqbrtrrd nnne0d lemul2ad absmuld div32d fsumle divcld addcld
      rspcv fsumsub relogdivd subsub3d oveq2 anasss fsumfldivdiag mul32d chpval
      mulcomd fsummulc2 2timesd 3eqtr4rd lediv1dd divdiv32d divsubdird divcan4d
      fsumadd adddid div23d 3eqtr3d rpmulcld 3brtr3d leabsd o1le ) ABIUBUCJZIBU
      FZUDKZUEJZFUFZUGKZUXQLJZFMZDUXNUHKZLJZNJZUIUYALJZUXPUXRUXNUXQLJZUJKZNJZUX
      QUHKZNJZFMZNJZUXPUYGFMZOJZUXNLJZIPIPQZAUKULABUXMUYCUMUNQBUXMDUMUNQZAUXMPV
      AZDUOQZUYPIUBUPZADGUQZBUXMDURUSABUXMUYCDAUXNUXMQZUTZUYCVUBUXTUYBVUBUXPUXS
      FVUBIUXOVBZVUBUXQUXPQZUTZUXRUXQVUEUXQVCQZUXRPQZVUDVUFVUBUXQUXOVDZVEZUXQVM
      ZVFZVUIVGZVHZVUBUYBADVIQZUYAVIQZUYBVIQZVUAGVUAUXNUXNIUBVJZVUAIUXNVKRZUXNU
      BVKRUXNIUBVLVNZVOZDUYAVPVQZVRZVSZSZAUYRVUAUYTVTZABUXMUXTUYAOJZUYBNJZUMBUX
      MUYCDOJZUMUNABUXMVVGVVHVUBVVGUYCUYAUYBNJZOJVVHVUBUXTUYAUYBVUBUXTVUMSZVUBU
      YAVUAVUOAVUTVEZUQZVUBUYBVVAUQZWAVUBVVIDUYCOVUBDUYAVVEVVLVUBUYAVVKWBZWCWDW
      EWFABUXMVVFUYBPVUBUXTUYAVUMVUBUYAVVKVRWGVVBABUXMVIVVFABUXMVIAVUAUXNVIQZVU
      BUXNVUAUXNPQZAVUQVEZVUBWHIUXNWHPQVUBWIULUYOVUBUKULVVQWHIVKRZVUBWNULVUAVUR
      AVUSVEWJZWKZWLWOBVIVVFUMUNQABFWMULWPABUXMUYBWQDUYQAUYSULVVMWQPQAWRULADGVR
      ZAVUAWQUXNTRZUTZUTZUYBWSKZUYBDTVWDUYBPQWHUYBTRUTVWEUYBWTVWDUYBAVUAVUPVWBV
      VAXAXBUYBXCVFVWDUYBDILJZDTVWDIUYATRZUYBVWFTRZVWDIWQUHKZUYATXDVWDVWBVWIUYA
      TRZAVUAVWBXEVWDWQVIQVVOVWBVWJXFUUAAVUAVVOVWBVVTXAWQUXNUUBUSXGUUCVWDUYOVVR
      UTZUYAPQWHUYAVKRUTDPQZWHDVKRUTVWGVWHXFIVIQVWKVWDUUDIUUEUUGVWDUYAAVUAVUOVW
      BVVKXAXHVWDDAVUNVWCGVTXHIUYADUUFUUHXGVWDDAUYRVWCUYTVTUUIUUJXIUUKUULUUMUUQ
      XJVVCVUBUYNVUBUYMUXNVUBUYKUYLVUBUYDUYJVUBUIPQVUOUYDPQUUNVVKUIUYAUUOUSVUBU
      XPUYIFVUCVUEUYGUYHVUEUXRUYFVUKVUEUYEPQZUYFPQVUBVVPVUFVWMVUDVVQVUHUXNUXQUU
      RVQZUYEXKVFZVSZVUEUXQVUEUXQVUIXLZXMZVSVHZVSVUBUXPUYGFVUCVWPVHZWGVVTUUPSZA
      VUAUYNWSKZUYCWSKZTRIUXNTRVUBVXBUYCVXCVUBUYNVXAXNVVCVUBUYCVVDXNVUBUIUYJNJZ
      UYLUYANJZOJZWSKZUXNLJZUYALJZUXTDNJZUYALJVXBUYCTVUBVXHVXJUYAVUBVXGUXNVUBVX
      FVUBVXDVXEVUBUIUYJUIUOQVUBUUSULZVUBUYJVWSSZXOZVUBUYLUYAVUBUYLVWTSZVVLXOZU
      UTZXNZVVQVUBUXNVVSUVAZUVBVUBUXTDVUMAVWLVUAVWAVTZVSZVVKVUBVXHVXJTRVXGVXJUX
      NNJZTRVUBUXPUXRIUYEUDKZUEJZUAUFZUGKZVYDUHKZNJZUAMZUYFUYEUHKZNJZOJZNJZFMZW
      SKZUXTDUXNNJZNJZVXGVYATVUBVYNUXPVYLWSKZFMZVYPVUBVYMVUBUXPVYLFVUCVUEUXRVYK
      VUEUXRVUKSZVUEVYKVUEVYHVYJVUEVYCVYGUAVUEIVYBVBZVUEVYDVYCQZUTZVYEVYFWUBVYD
      VCQZVYEPQZWUAWUCVUEVYDVYBVDVEZVYDVMZVFWUBVYDWUBVYDWUEXLXMVSZVHZVUEUYFVYIV
      WOVUEUYEVUBVVOUXQVIQUYEVIQVUDVVTVUDUXQVUHXLUXNUXQVPVQZXMVSWGSZXOZUVCXNVUB
      UXPVYQFVUCVUEVYLWUKXNZVHVUBUXTVYOVUMVUBDUXNVXSVVQVSVSVUBUXPVYLFVUCWUKUVDV
      UBVYRUXPUXSVYONJZFMVYPTVUBUXPVYQWUMFVUCWULVUEUXSVYOVULVUEDUXNAVWLVUAVUDVW
      AXPZVUBVVPVUDVVQVTZVSZVSVUEUXRVYKWSKZNJZUXRVYOUXQLJZNJVYQWUMTVUEWUQWUSUXR
      VUEVYKWUJXNZVUEVYOUXQWUPVUIVGVUKVUEVUFWHUXRTRVUIUXQUVEVFZVUEWUQDUYENJZWUS
      TVUEWUQUYELJZDTRWUQWVBTRVUEVYKUYELJZWSKZWVCDTVUEWVEWUQUYEWSKZLJWVCVUEVYKU
      YEWUJVUEUYEVWNSVUEUYEWUIWBXQVUEWVFUYEWUQLVUEUYEVWNVUEUYEWUIXRXSWDWEVUEUYE
      IUBUVFJZQZICUFZUDKZUEJZEUFZUGKZWVLUHKZNJZEMZWVIUJKZWVIUHKZNJZOJZWVILJZWSK
      ZDTRZCWVGUVGZWVEDTRZVUEVWMIUYETRZWVHVWNVUEIUXQNJZUXNTRWWFVUEWWGUXQUXNTVUE
      UXQVUEUXQVUIUVHZUVIVUBVUDVUFUXQUXNTRZVUBVVPVUDVUFWWIUTXFVVQUXQUXNUVJVFUVK
      XIVUEIUXNUXQUYOVUEUKULWUOVWQUVLXGUYOWVHVWMWWFUTXFUKIUYEUVMUVNUVOAWWDVUAVU
      DHXPWWCWWECUYEWVGWVIUYEWTZWWBWVEDTWWJWWAWVDWSWWJWVTVYKWVIUYELWWJWVPVYHWVS
      VYJOWWJWVPWVKVYGUAMVYHWVKWVOVYGEUAEUAXTWVMVYEWVNVYFNWVLVYDUGYAWVLVYDUHYAY
      BYCWWJWVKVYCVYGUAWWJWVJVYBIUEWVIUYEUDYAWDUVRYDWWJWVQUYFWVRVYINWVIUYEUJYAW
      VIUYEUHYAYBYBWWJUVPYBYGUVQUWHUVSUVTVUEWUQDUYEWUTWUNWUIYEXGVUEDUXNUXQVUBUY
      RVUDVVEVTVUEUXNWUOSWWHVUEUXQVUIUWAZYFYQUWBVUEVYQUXRWSKZWUQNJWURVUEUXRVYKV
      YSWUJUWCVUEWWLUXRWUQNVUEUXRVUKWVAXSYHWEVUEUXRUXQVYOVYSWWHVUEVYOWUPSWWKUWD
      YIUWEVUBUXPUXSVYOFVUCVUBDUXNVVEVUBUXNVVQSZXOVUEUXRUXQVYSWWHWWKUWFYJYQYKVU
      BVXFVYMWSVUBUXPUXRVYHUYFUYHNJZYLJZNJZUYGUYANJZOJZFMUXPWWPFMZUXPWWQFMZOJVY
      MVXFVUBUXPWWPWWQFVUCVUEUXRWWOVYSVUEVYHWWNVUEVYHWUHSZVUEUYFUYHVUEUYFVWOSZV
      UEUYHVWRSZXOZUWGZXOVUEUYGUYAVUEUXRUYFVYSWXBXOVUBUYAUOQVUDVVLVTZXOUWIVUBUX
      PVYLWWRFVUEUXRWWOUYFUYANJZOJZNJWWPUXRWXGNJZOJVYLWWRVUEUXRWWOWXGVYSWXEVUEU
      YFUYAWXBWXFXOZYMVUEVYKWXHUXRNVUEVYKVYHWXGWWNOJZOJWXHVUEVYJWXKVYHOVUEVYJUY
      FUYAUYHOJZNJWXKVUEVYIWXLUYFNVUEUXNUXQVUBVVOVUDVVTVTVWQUWJWDVUEUYFUYAUYHWX
      BWXFWXCYMWEWDVUEVYHWXGWWNWXAWXJWXDUWKWEWDVUEWWQWXIWWPOVUEUXRUYFUYAVYSWXBW
      XFYNWDYOYRVUBVXDWWSVXEWWTOVUBVXDUXPUXRVYHNJZUXRWWNNJZYLJZFMZWWSVUBUYJUYJY
      LJUXPWXMFMZUXPWXNFMZYLJVXDWXPVUBUYJWXQUYJWXRYLVUBUYJUXPVYEUXNVYDLJZUJKZNJ
      ZVYFNJZUAMZWXQUXPUYIWYBFUAFUAXTZUYGWYAUYHVYFNWYDUXRVYEUYFWXTNUXQVYDUGYAWY
      DUYEWXSUJUXQVYDUXNLUWLYGYBUXQVYDUHYAYBYCVUBUXPIWXSUDKZUEJZUXRVYGNJZFMZUAM
      UXPVYCWYGUAMZFMWYCWXQVUBUXNWYGFUAVVQVUBVYDUXPQZUXQWYFQZUTUTUXRVYGVUBWYJWY
      KUXRUOQVUBWYJUTZWYKUTZUXRWYMVUFVUGWYKVUFWYLUXQWYEVDVEVUJVFSZUWMVUBWYJVYGU
      OQWYKWYLVYEVYFWYLVYEWYLWUCWUDWYJWUCVUBVYDUXOVDVEZWUFVFZSZWYLVYFWYLVYDWYLV
      YDWYOXLXMZSZXOXAXOUWNVUBUXPWYBWYHUAWYLWYBVYGWXTNJWXTVYGNJZWYHWYLVYEWXTVYF
      WYQWYLWXTWYLWXSPQZWXTPQWYLUXNVYDVUBVVPWYJVVQVTWYOVGZWXSXKVFSZWYSUWOWYLVYG
      WXTWYLVYGWYLVYEVYFWYPWYRVSSZXUCUWQWYLWYTWYFUXRFMZVYGNJWYHWYLWXTXUEVYGNWYL
      XUAWXTXUEWTXUBWXSFUWPVFYHWYLWYFUXRVYGFWYLIWYEVBXUDWYNYJWEYPYRVUBUXPWXMWYI
      FVUEVYCVYGUXRUAVYTVYSWUBVYGWUGSUWRYRYOYDVUBUXPUYIWXNFVUEUXRUYFUYHVYSWXBWX
      CYNYRYBVUBUYJVXLUWSVUBUXPWXMWXNFVUCVUEUXRVYHVYSWXAXOVUEUXRWWNVYSWXDXOUXEY
      OVUBUXPWWPWXOFVUEUXRVYHWWNVYSWXAWXDUXFYRYSVUBUXPUYGUYAFVUCVVLVUEUYGVWPSYJ
      YBUWTYGVUBUXTDUXNVVJVVEWWMYNYIVUBVXGVXJUXNVXQVXTVVTYEXJUXAVUBVXIVXGUXNUYA
      NJZLJZVXBVUBVXGUXNUYAVUBVXGVXQSWWMVVLVXRVVNYTVUBVXBVXFXUFLJZWSKVXGXUFWSKZ
      LJXUGVUBUYNXUHWSVUBVXFUYALJZUXNLJVXFUXNLJUYALJUYNXUHVUBVXFUYAUXNVXPVVLWWM
      VVNVXRUXBVUBXUJUYMUXNLVUBXUJVXDUYALJZVXEUYALJZOJUYMVUBVXDVXEUYAVXMVXOVVLV
      VNUXCVUBXUKUYKXULUYLOVUBUIUYJUYAVXKVXLVVLVVNUXGVUBUYLUYAVXNVVLVVNUXDYBWEY
      HVUBVXFUXNUYAVXPWWMVVLVXRVVNYTUXHYGVUBVXFXUFVXPVUBXUFVUBUXNUYAVVTVVKUXIZU
      QVUBXUFXUMWBXQVUBXUIXUFVXGLVUBXUFVUBXUFXUMVRVUBXUFXUMXRXSWDYPYSVUBUXTDUYA
      VVJVVEVVLVVNYFUXJVUBUYCVVCUXKYKXAUXL $.
  $}

  ${
    $d c m n x y $.
    $( Lemma for ~ selberg3 .  Equation 10.4.21 of [Shapiro], p. 422.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    selberg3lem2 $p |- ( x e. ( 1 (,) +oo ) |->
    ( ( ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) x. ( log ` n ) ) )
      - sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) ) / x ) ) e. O(1) $=
      ( vy vm c1 cfv co cmul cdiv cle wbr crp wcel wtru cr wa relogcld remulcld
      syl adantr vc cv cfl cfz cvma clog csu cchp cmin cabs cpnf cico wral wrex
      cioo c2 cmpt co1 caddc wss wb 1re elicopnf ax-mp simplbi ssriv a1i elfznn
      fzfid cn adantl vmacl nnrpd fsumrecl chpcl 1rp simprbi rpgecld rerpdivcld
      resubcld recnd ex ssrdv selberg2lem o1res2 ad2antrl simprl readdcld rpcnd
      simprr clt rpne0d absdivd rpge0d absidd oveq2d eqtrd abscld simprll ltled
      ad2ant2r absge0d lediv2ad div1d breqtrd abs2dif2d cc0 vmage0 nnred nnge1d
      logge0d mulge0d fsumge0 chpge0 oveq12d cuz flword2 syl3anc fzss2 fsumless
      chpwordi logled mpbid lemul12ad le2addd letrd eqbrtrd o1bddrp simpl simpr
      trud selberg3lem1 rexlimiva ) ECUBZUCFZUDGZDUBZUEFZYQUFFZHGZDUGZYNUHFZYNU
      FFZHGZUIGZYNIGZUJFZUAUBZJKCEUKULGZUMZUALUNZAEUKUOGUPAUBZUFFZIGEUULUCFZUDG
      ZBUBZUEFUULUUPIGUHFHGZUUPUFFHGBUGHGUUOUUQBUGUIGUULIGUQURMZUUKNCAUUIUUFEUA
      UUOYTDUGZUULUHFZUUMHGZUSGZUUIOUTNCUUIOYNUUIMZYNOMZEYNJKZEOMZUVCUVDUVEPVAV
      BEYNVCVDZVEZVFVGUVFNVBVGNUVCPZUUFUVIUUEYNUVIUUAUUDUVIYPYTDUVIEYOVIZUVIYQY
      PMZPZYRYSUVLYQVJMZYROMZUVKUVMUVIYQYOVHVKZYQVLZSZUVLYQUVLYQUVOVMQZRZVNZUVI
      UUBUUCUVIUVDUUBOMZUVCUVDNUVHVKZYNVOZSUVIYNUVIYNEUWBELMZUVIVPVGUVCUVENUVCU
      VDUVEUVGVQVKZVRZQRZVTZUWFVSWANCUUILUUFNCUUILNUVCYNLMZUWFWBWCCLUUFUQURMNCD
      WDVGWENUULOMZEUULJKZPZPZUUSUVAUWMUUOYTDUWMEUUNVIUWMYQUUOMZPZYRYSUWOUVMUVN
      UWNUVMUWMYQUUNVHZVKZUVPSUWOYQUWOYQUWQVMQRVNZUWMUUTUUMUWJUUTOMZNUWKUULVOZW
      FUWMUULUWMUULENUWJUWKWGUWDUWMVPVGNUWJUWKWJVRQRWHUVIUWLYNUULWKKZPZPZUUGUUE
      UJFZYNIGZUVBJUXCUUGUXDYNUJFZIGUXEUXCUUEYNUXCUUEUVIUUEOMUXBUWHTWAZUXCYNUVI
      UWIUXBUWFTZWIUXCYNUXHWLWMUXCUXFYNUXDIUXCYNUVIUVDUXBUWBTZUXCYNUXHWNWOWPWQU
      XCUXEUXDUVBUXCUXDYNUXCUUEUXGWRZUXHVSUXJUXCUUSUVANUWLUUSOMUVCUXAUWRXAZUXCU
      UTUUMUXCUWJUWSUVIUWJUWKUXAWSZUWTSZUXCUULUXCUULYNUXLUXHUXCYNUULUXIUXLUVIUW
      LUXAWJWTZVRZQZRZWHZUXCUXEUXDEIGUXDJUXCEYNUXDUWDUXCVPVGUXHUXJUXCUUEUXGXBUV
      IUVEUXBUWETZXCUXCUXDUXCUXDUXJWAXDXEUXCUXDUUAUUDUSGZUVBUXJUXCUUAUUDUVIUUAO
      MUXBUVTTZUXCUUBUUCUXCUVDUWAUXIUWCSZUXCYNUXHQZRZWHUXRUXCUXDUUAUJFZUUDUJFZU
      SGUXTJUXCUUAUUDUXCUUAUYAWAUXCUUDUVIUUDOMUXBUWGTZWAXFUXCUYEUUAUYFUUDUSUXCU
      UAUYAUVIXGUUAJKUXBUVIYPYTDUVJUVSUVLYRYSUVQUVRUVLUVMXGYRJKZUVOYQXHZSUVLYQU
      VLYQUVOXIUVLYQUVOXJXKXLXMTWOUXCUUDUYGUXCUUBUUCUYBUYCUXCUVDXGUUBJKUXIYNXNS
      ZUXCYNUXIUXSXKZXLWOXOXEUXCUUAUUDUUSUVAUYAUYDUXKUXQUXCUUOYTYPDUXCEUUNVIUXC
      UWNPZYRYSUYLUVMUVNUWNUVMUXCUWPVKZUVPSZUYLYQUYLYQUYMVMQZRUYLYRYSUYNUYOUYLU
      VMUYHUYMUYISUYLYQUYLYQUYMXIUYLYQUYMXJXKXLUXCUUNYOXPFMZYPUUOUTUXCUVDUWJYNU
      ULJKZUYPUXIUXLUXNYNUULXQXRYOEUUNXSSXTUXCUUBUUTUUCUUMUYBUXMUYCUXPUYJUYKUXC
      UVDUWJUYQUUBUUTJKUXIUXLUXNYNUULYAXRUXCUYQUUCUUMJKUXNUXCYNUULUXHUXOYBYCYDY
      EYFYFYGYHYKUUJUURUALUUHLMZUUJPACUUHDBUYRUUJYIUYRUUJYJYLYMVD $.

    $( Introduce a log weighting on the summands of
       ` sum_ m x. n <_ x , Lam ( m ) Lam ( n ) ` , the core of ~ selberg2
       (written here as ` sum_ n <_ x , Lam ( n ) psi ( x / n ) ` ).  Equation
       10.6.7 of [Shapiro], p. 422.  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    selberg3 $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( ( ( ( psi ` x ) x. ( log ` x ) ) +
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( Lam ` n ) x. ( psi ` ( x / n ) ) ) x. ( log ` n ) ) ) )
        / x ) - ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( c1 cpnf co cfv cmul cdiv caddc cmin cmpt co1 wcel wtru crp a1i remulcld
      c2 cr recnd cioo cv cchp clog cfl cfz csu wa elioore adantl chpcl syl 1rp
      cvma rpred clt wbr eliooord simpld ltled rpgecld relogcld fzfid cn elfznn
      vmacl adantr nndivred fsumrecl rplogcld rerpdivcld nnrpd resubcld addassd
      2re cc rpne0d divcld mulcld pncan3d oveq2d eqtr2d oveq1d readdcld divdird
      2cn eqtrd addsubd mpteq2dva ex ssrdv selberg2 o1res2 selberg3lem2 eqeltrd
      o1add2 trud ) ACDUAEZAUBZUCFZWSUDFZGEZRXAHEZCWSUEFZUFEZBUBZUNFZWSXFHEZUCF
      ZGEZXFUDFZGEZBUGZGEZIEZWSHEZRXAGEZJEZKZLMNXSAWRXBXEXJBUGZIEZWSHEZXQJEZXNX
      TJEZWSHEZIEZKLNAWRXRYFNWSWRMZUHZXRYBYEIEZXQJEYFYHXPYIXQJYHXPYAYDIEZWSHEYI
      YHXOYJWSHYHYJXBXTYDIEZIEXOYHXBXTYDYHXBYHWTXAYHWSSMZWTSMYGYLNWSCDUIUJZWSUK
      ULYHWSYHWSCYMCOMYHUMPZYHCWSYHCYNUOYMYHCWSUPUQZWSDUPUQZYGYOYPUHNWSCDURUJUS
      ZUTVAZVBZQZTYHXTYHXEXJBYHCXDVCZYHXFXEMZUHZXGXIUUCXFVDMZXGSMUUBUUDYHXFXDVE
      UJZXFVFULUUCXHSMXISMUUCWSXFYHYLUUBYMVGUUEVHXHUKULQZVIZTZYHYDYHXNXTYHXCXMY
      HRXARSMYHVOPZYHWSYMYQVJZVKYHXEXLBUUAUUCXJXKUUFUUCXFUUCXFUUEVLVBQVIZQUUGVM
      ZTZVNYHYKXNXBIYHXTXNUUHYHXCXMYHRXARVPMYHWFPYHXAYSTYHXAUUJVQVRYHXMUUKTVSVT
      WAWBWCYHYAYDWSYHYAYHXBXTYTUUGWDZTUUMYHWSYMTYHWSYRVQWEWGWCYHYBYEXQYHYBYHYA
      WSUUNYRVKZTYHYEYHYDWSUULYRVKZTYHXQYHRXAUUIYSQZTWHWGWINAWRYCYESYHYBXQUUOUU
      QVMUUPNAWROYCNAWRONYGWSOMYRWJWKAOYCKLMNABWLPWMAWRYEKLMNABWNPWPWOWQ $.
  $}

  ${
    $d i m n x y A $.  $d m n x ph $.
    selberg4lem1.1 $e |- ( ph -> A e. RR+ ) $.
    selberg4lem1.2 $e |- ( ph -> A. y e. ( 1 [,) +oo )
      ( abs ` ( ( sum_ i e. ( 1 ... ( |_ ` y ) )
        ( ( Lam ` i ) x. ( ( log ` i ) + ( psi ` ( y / i ) ) ) ) / y )
      - ( 2 x. ( log ` y ) ) ) ) <_ A ) $.
    $( Lemma for ~ selberg4 .  Equation 10.4.20 of [Shapiro], p. 422.
       (Contributed by Mario Carneiro, 30-May-2016.) $)
    selberg4lem1 $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
      ( ( sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( Lam ` n ) x. sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) )
          ( ( Lam ` m ) x. ( ( log ` m ) + ( psi ` ( ( x / n ) / m ) ) ) ) )
          / ( x x. ( log ` x ) ) ) - ( log ` x ) ) ) e. O(1) ) $=
      ( c1 co cfv cdiv cmul cmin cmpt wcel c2 recnd cle cpnf cioo cfl cvma clog
      cv cfz cchp caddc csu co1 wa cc 2cn a1i fzfid cn cr elfznn vmacl nndivred
      adantl syl crp elioore 1rp rpred clt eliooord simpld ltled rpgecld adantr
      wbr nnrpd rpdivcld relogcld remulcld fsumrecl rerpdivcld rehalfcld subdid
      rplogcld cc0 wne divcan2d oveq2d eqtrd mpteq2dva 2re resubcld wss ioossre
      2ne0 o1const mp2an vmalogdivsum2 o1mul2 eqeltrrd readdcld rpmulcld rpne0d
      chpcl divcld mulcld nnncan2d divdiv1d divassd oveq12d divsubdird redivcld
      subcld fsumsub nncnd nnne0d div32d mul12d eqtr4d sumeq2dv fsumdivc oveq1d
      fsummulc2 1re sylancr o1dif mpbird abscld fveq2d absmuld rpge0d absidd wb
      cabs lemuldivd mpbid ad2antrr wceq fveq2 3brtr4d divge0d 3eqtr4rd 3eqtr2d
      eqtr3d rpcnd divrecd dividd 3eqtr3d ex ssrdv vmadivsum o1res2 crli rlimo1
      divlogrlim fsumabs vmage0 divdiv2d div23d mulassd divcan1d eqtr2d subdird
      mp1i nnred 3eqtrd mulid2d fznnfl simplbda eqbrtrd elicopnf ax-mp sylanbrc
      cico wral oveq2 cbvsumv oveq1 sumeq12dv syl5eq breq1d rspcv sylc eqbrtrrd
      id lemul2ad div12d fsumle breqtrrd letrd lediv1dd breqtrd absdivd fsumge0
      mulge0d adantrr o1le eqeltrd ) ABJUAUBKZJBUFZUCLZUGKZGUFZUDLZJUWSUXBMKZUC
      LZUGKZFUFZUDLZUXGUELZUXDUXGMKZUHLZUIKZNKZFUJZNKZGUJZUWSUWSUELZNKZMKZUXQOK
      ZPUKQBUWRRUXAUXCUXBMKZUXDUELZNKZGUJZUXQMKZNKZUXQOKZPZUKQABUWRRUYEUXQRMKZO
      KZNKZPUYHUKABUWRUYKUYGAUWSUWRQZULZUYKUYFRUYINKZOKUYGUYMRUYEUYIRUMQZUYMUNU
      OZUYMUYEUYMUYDUXQUYMUXAUYCGUYMJUWTUPZUYMUXBUXAQZULZUYAUYBUYSUXCUXBUYSUXBU
      QQZUXCURQUYRUYTUYMUXBUWTUSVBZUXBUTVCZVUAVAZUYSUXDUYSUWSUXBUYMUWSVDQZUYRUY
      MUWSJUYLUWSURQZAUWSJUAVEVBZJVDQUYMVFUOZUYMJUWSUYMJVUGVGZVUFUYMJUWSVHVNZUW
      SUAVHVNZUYLVUIVUJULAUWSJUAVIVBVJZVKVLZVMUYSUXBVUAVOZVPVQZVRZVSZUYMUWSVUFV
      UKWCZVTZSUYMUYIUYMUXQUYMUWSVULVQZWAZSWBUYMUYNUXQUYFOUYMUXQRUYMUXQVUSSZUYP
      RWDWEUYMWNUOWFWGWHWIABUWRRUYJURRURQZUYMWJUOUYMUYEUYIVURVUTWKBUWRRPUKQZAUW
      RURWLZUYOVVCJUAWMZUNBUWRRWOWPUOBUWRUYJPUKQABGWQUOWRWSABUWRUXTUYGUYMUXTUYM
      UXSUXQUYMUXPUXRUYMUXAUXOGUYQUYSUXCUXNVUBUYSUXFUXMFUYSJUXEUPUYSUXGUXFQZULZ
      UXHUXLVVGUXGUQQZUXHURQVVFVVHUYSUXGUXEUSVBZUXGUTVCVVGUXIUXKVVGUXGVVGUXGVVI
      VOVQVVGUXJURQUXKURQVVGUXDUXGUYSUXDURQZVVFUYSUWSUXBUYMVUEUYRVUFVMZVUAVAZVM
      VVIVAUXJXCVCWTVRVSZVRZVSZUYMUWSUXQVULVUQXAVTZVUSWKSUYMUYFUXQUYMRUYEUYPUYM
      UYDUXQUYMUYDVUPSZVVAUYMUXQVUQXBZXDXEZVVAXLABUWRUXTUYGOKZPBUWRUXAUXCUXNUWS
      MKZRUYBUXBMKZNKZOKZNKZGUJZUXQMKZPUKABUWRVVTVWGUYMVVTUXSUYFOKUXPUWSMKZUXQM
      KZRUYDNKZUXQMKZOKZVWGUYMUXSUYFUXQUYMUXSVVPSVVSVVAXFUYMVWIUXSVWKUYFOUYMUXP
      UWSUXQUYMUXPVVOSUYMUWSVUFSZVVAUYMUWSVULXBZVVRXGUYMRUYDUXQUYPVVQVVAVVRXHXI
      UYMVWHVWJOKZUXQMKVWLVWGUYMVWHVWJUXQUYMVWHUYMUXPUWSVVOVULVTSUYMRUYDUYPVVQX
      EVVAVVRXJUYMVWOVWFUXQMUYMUXAUXOUWSMKZRUYCNKZOKZGUJUXAVWPGUJZUXAVWQGUJZOKV
      WFVWOUYMUXAVWPVWQGUYQUYSVWPUYSUXOUWSVVNVVKUYMUWSWDWEUYRVWNVMZXKSUYSVWQUYS
      RUYCVVBUYSWJUOZVUOVRSXMUYMUXAVWEVWRGUYSVWEUXCVWANKZUXCVWCNKZOKVWRUYSUXCVW
      AVWCUYSUXCVUBSZUYSVWAUYSUXNUWSVVMVVKVXAXKZSZUYSRVWBUYOUYSUNUOZUYSUYBUXBUY
      SUYBVUNSZUYSUXBVUAXNZUYSUXBVUAXOZXDZXEZWBUYSVWPVXCVWQVXDOUYSUXCUXNUWSVXEU
      YSUXNVVMSZUYMUWSUMQUYRVWMVMZVXAXHUYSVWQRUXCVWBNKZNKVXDUYSUYCVXPRNUYSUXCUX
      BUYBVXEVXJVXIVXKXPWGUYSRUXCVWBVXHVXEVXLXQWHXIXRXSUYMVWHVWSVWJVWTOUYMUXAUX
      OUWSGUYQVWMUYSUXOVVNSVWNXTUYMUXAUYCRGUYQUYPUYSUYCVUOSYBXIUUAYAUUCUUBWIABU
      WRDUXAUYAGUJZUXQMKZNKZVWGJURJURQZAYCUOZABUWRDVXRURUYMDADVDQUYLHVMZVGZUYMV
      XQUXQUYMUXAUYAGUYQVUCVSZVUQVTZAVVDDUMQZBUWRDPUKQVVEADHUUDZBUWRDWOYDABUWRV
      XRPUKQBUWRJPUKQZAVVDJUMQVYHVVEAJVYASBUWRJWOYDABUWRVXRJUYMVXRVYESUYMJVUHSA
      BUWRVXQUXQOKZJUXQMKZNKZPBUWRVXRJOKZPUKABUWRVYKVYLUYMVYIUXQMKVXRUXQUXQMKZO
      KVYKVYLUYMVXQUXQUXQUYMVXQVYDSZVVAVVAVVRXJUYMVYIUXQUYMVXQUXQVYNVVAXLVVAVVR
      UUEUYMVYMJVXROUYMUXQVVAVVRUUFWGUUGWIABUWRVYIVYJURUYMVXQUXQVYDVUSWKUYMJUXQ
      VUHVUQVTABUWRVDVYIABUWRVDAUYLVUDVULUUHUUIBVDVYIPUKQABGUUJUOUUKBUWRVYJPZWD
      UULVNVYOUKQABUUNWDVYOUUMUVCWRWSYEYFWRUYMDVXRVYCVYEVRZUYMVWGUYMVWFUXQUYMUX
      AVWEGUYQUYSUXCVWDVUBUYSVWAVWCVXFUYSRVWBVXBUYSUYBUXBVUNVUAVAVRWKVRZVSZVUQV
      TSAUYLVWGYMLZVXSYMLZTVNJUWSTVNUYMVWFYMLZUXQMKZVXSVYSVYTTUYMWUBDVXQNKZUXQM
      KVXSTUYMWUAWUCUXQUYMVWFUYMVWFVYRSZYGZUYMDVXQVYCVYDVRZVUQUYMWUAUXAVWEYMLZG
      UJZWUCWUEUYMUXAWUGGUYQUYSVWEUYSUXCVWDVXEUYSVWAVWCVXGVXMXLZXEYGZVSWUFUYMUX
      AVWEGUYQUYSVWEVYQSUUOUYMWUHUXADUYANKZGUJWUCTUYMUXAWUGWUKGUYQWUJUYSDUYAUYM
      DURQUYRVYCVMZVUCVRUYSUXCVWDYMLZNKZUXCDUXBMKZNKWUGWUKTUYSWUMWUOUXCUYSVWDWU
      IYGZUYSDUXBWULVUAVAVUBUYSUYTWDUXCTVNVUAUXBUUPVCZUYSWUMUXBNKZDTVNWUMWUOTVN
      UYSUXNUXDMKZRUYBNKZOKZYMLZWURDTUYSWVBVWDUXBNKZYMLWUMUXBYMLZNKWURUYSWVAWVC
      YMUYSWVAVWAUXBNKZVWCUXBNKZOKWVCUYSWUSWVEWUTWVFOUYSWUSUXNUXBNKUWSMKWVEUYSU
      XNUWSUXBVXNVXOVXJVXAVXKUUQUYSUXNUXBUWSVXNVXJVXOVXAUURWHUYSWVFRVWBUXBNKZNK
      WUTUYSRVWBUXBVXHVXLVXJUUSUYSWVGUYBRNUYSUYBUXBVXIVXJVXKUUTWGUVAXIUYSVWAVWC
      UXBVXGVXMVXJUVBXRYHUYSVWDUXBWUIVXJYIUYSWVDUXBWUMNUYSUXBUYSUXBVUAUVDUYSUXB
      VUMYJYKWGUVEUYSUXDJUAUVMKZQZJCUFZUCLZUGKZEUFZUDLZWVMUELZWVJWVMMKZUHLZUIKZ
      NKZEUJZWVJMKZRWVJUELZNKZOKZYMLZDTVNZCWVHUVNZWVBDTVNZUYSVVJJUXDTVNZWVIVVLU
      YSJUXBNKZUWSTVNWWIUYSWWJUXBUWSTUYSUXBVXJUVFUYMUYRUYTUXBUWSTVNZUYMVUEUYRUY
      TWWKULYLVUFUXBUWSUVGVCUVHUVIUYSJUWSUXBVXTUYSYCUOVVKVUMYNYOVXTWVIVVJWWIULY
      LYCJUXDUVJUVKUVLAWWGUYLUYRIYPWWFWWHCUXDWVHWVJUXDYQZWWEWVBDTWWLWWDWVAYMWWL
      WWAWUSWWCWUTOWWLWVTUXNWVJUXDMWWLWVTWVLUXHUXIWVJUXGMKZUHLZUIKZNKZFUJUXNWVL
      WVSWWPEFWVMUXGYQZWVNUXHWVRWWONWVMUXGUDYRWWQWVOUXIWVQWWNUIWVMUXGUEYRWWQWVP
      WWMUHWVMUXGWVJMUVOYHXIXIUVPWWLWVLUXFWWPUXMFWWLWVKUXEJUGWVJUXDUCYRWGWWLWWP
      UXMYQUXGWVLQWWLWWOUXLUXHNWWLWWNUXKUXIUIWWLWWMUXJUHWVJUXDUXGMUVQYHWGWGVMUV
      RUVSWWLUWDXIWWLWWBUYBRNWVJUXDUEYRWGXIYHUVTUWAUWBUWCUYSWUMDUXBWUPWULVUMYNY
      OUWEUYSWUGUXCYMLZWUMNKWUNUYSUXCVWDVXEWUIYIUYSWWRUXCWUMNUYSUXCVUBWUQYKYAWH
      UYSDUXCUXBAVYFUYLUYRVYGYPVXEVXJVXKUWFYSUWGUYMUXAUYADGUYQAVYFUYLVYGVMZUYSU
      YAVUCSYBUWHUWIUWJUYMDVXQUXQWWSVYNVVAVVRXHUWKUYMVYSWUAUXQYMLZMKWUBUYMVWFUX
      QWUDVVAVVRUWLUYMWWTUXQWUAMUYMUXQVUSUYMUXQVUQYJYKWGWHUYMVXSVYPUYMDVXRVYCVY
      EUYMDVYBYJUYMVXQUXQVYDVUQUYMUXAUYAGUYQVUCUYSUXCUXBVUBVUMWUQYTUWMYTUWNYKYS
      UWOUWPUWQYEYF $.
  $}

  ${
    $d c i m n x y $.
    $( The Selberg symmetry formula for products of three primes, instead of
       two.  The sum here can also be written in the symmetric form
       ` sum_ i j k <_ x , Lam ( i ) Lam ( j ) Lam ( k ) ` ; we eliminate one
       of the nested sums by using the definition of
       ` psi ( x ) = sum_ k <_ x , Lam ( k ) ` .  This statement can thus
       equivalently be written ` psi ( x ) log ^ 2 ( x ) = `
       ` 2 sum_ i j k <_ x , Lam ( i ) Lam ( j ) Lam ( k ) + O ( x log x ) ` .
       Equation 10.4.23 of [Shapiro], p. 422.  (Contributed by Mario Carneiro,
       30-May-2016.) $)
    selberg4 $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( ( ( psi ` x ) x. ( log ` x ) ) -
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( Lam ` n ) x. sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) )
            ( ( Lam ` m ) x. ( psi ` ( ( x / n ) / m ) ) ) ) ) )
        / x ) ) e. O(1) $=
      ( c1 co cfv cmul c2 cdiv csu cmin cmpt wcel wtru caddc wa cr remulcld crp
      recnd vy vi vc cpnf cioo cv cchp clog cfl cfz cvma co1 2re elioore adantl
      a1i clt wbr eliooord simpld rplogcld rerpdivcld fzfid cn elfznn vmacl syl
      adantr nndivred chpcl nnrpd relogcld fsumrecl resubcld 1rp rpred readdcld
      rpgecld addsubassd rpne0d divdird nppcan3d ad2antll adantrr fsumfldivdiag
      ltled mul32d mulcld mulcomd wceq chpval oveq1d anassrs fsummulc1 sumeq2dv
      eqtrd 3eqtrd fsummulc2 3eqtr4d oveq2d eqtr3d mpteq2dva selberg3lem2 ssrdv
      selberg2 o1res2 o1add2 eqeltrrd pnncand addcomd adddid fsumadd divsubdird
      ex subcld cc divdiv1d div23d rpmulcld rpcnd divassd 3eqtr3d sub32d subdid
      2cn wss ioossre o1const sylancr cabs cico wral wrex selbergb selberg4lem1
      cle simpl simpr rexlimiva mp1i o1mul2 eqeltrd o1dif mpbid trud ) ADUDUEEZ
      AUFZUGFZUUGUHFZGEZHUUIIEZDUUGUIFZUJEZCUFZUKFZDUUGUUNIEZUIFZUJEZBUFZUKFZUU
      PUUSIEZUGFZGEZBJZGEZCJZGEZKEZUUGIEZLULMZNAUUFUUKUUMUUOUURUUTUUSUHFZGEZBJZ
      GEZCJZGEZUUJOEZUUGIEZHUUIGEZKEZLZULMUVJNAUUFUUKUUMUUTUUGUUSIEZUGFZGEZUVKG
      EZBJZGEZUUMUWDBJZKEZUUGIEZUUJUWHOEZUUGIEZUVSKEZOEZLUWAULNAUUFUWNUVTNUUGUU
      FMZPZUWJUWLOEZUVSKEUWNUVTUWPUWJUWLUVSUWPUWJUWPUWIUUGUWPUWGUWHUWPUUKUWFUWP
      HUUIHQMUWPUMUPZUWPUUGUWOUUGQMZNUUGDUDUNUOZUWPDUUGUQURZUUGUDUQURZUWOUXAUXB
      PNUUGDUDUSUOUTZVAZVBZUWPUUMUWEBUWPDUULVCZUWPUUSUUMMZPZUWDUVKUXHUUTUWCUXHU
      USVDMZUUTQMZUXGUXIUWPUUSUULVEUOZUUSVFZVGZUXHUWBQMZUWCQMUXHUUGUUSUWPUWSUXG
      UWTVHUXKVIZUWBVJVGZRZUXHUUSUXHUUSUXKVKZVLZRVMRZUWPUUMUWDBUXFUXQVMZVNZUWPU
      UGDUWTDSMUWPVOUPZUWPDUUGUWPDUYCVPUWTUXCWFVRZVBZTUWPUWLUWPUWKUUGUWPUUJUWHU
      WPUUHUUIUWPUWSUUHQMUWTUUGVJVGUWPUUGUYDVLZRZUYAVQZUYDVBZTUWPUVSUWPHUUIUWRU
      YFRZTZVSUWPUWQUVRUVSKUWPUWIUWKOEZUUGIEUWQUVRUWPUWIUWKUUGUWPUWIUYBTUWPUWKU
      YHTUWPUUGUWTTZUWPUUGUYDVTZWAUWPUYLUVQUUGIUWPUYLUWGUUJOEUVQUWPUWGUWHUUJUWP
      UWGUXTTUWPUWHUYATUWPUUJUYGTZWBUWPUWGUVPUUJOUWPUWFUVOUUKGUWPUUMDUWBUIFZUJE
      ZUUOUVLGEZCJZBJUUMUURUYRBJZCJUWFUVOUWPUUGUYRCBUWTUWPUXGUUNUYQMZPPZUYRVUBU
      UOUVLVUBUUNVDMZUUOQMZVUAVUCUWPUXGUUNUYPVEWCUUNVFZVGZVUBUUTUVKUWPUXGUXJVUA
      UXMWDVUBUUSUWPUXGUUSSMVUAUXRWDVLRRTWEUWPUUMUWEUYSBUXHUWEUVLUWCGEUWCUVLGEZ
      UYSUXHUUTUWCUVKUXHUUTUXMTZUXHUWCUXPTZUXHUVKUXSTZWGUXHUVLUWCUXHUUTUVKVUHVU
      JWHZVUIWIUXHVUGUYQUUOCJZUVLGEUYSUXHUWCVULUVLGUXHUXNUWCVULWJUXOUWBCWKVGWLU
      XHUYQUUOUVLCUXHDUYPVCVUKUXHVUAPUUOUWPUXGVUAVUDVUFWMTWNWPWQWOUWPUUMUVNUYTC
      UWPUUNUUMMZPZUURUVLUUOBVUNDUUQVCZVUNUUOVUNVUCVUDVUMVUCUWPUUNUULVEUOZVUEVG
      ZTZVUNUUSUURMZPZUVLVUTUUTUVKVUTUXIUXJVUSUXIVUNUUSUUQVEUOZUXLVGZVUTUUSVUTU
      USVVAVKVLZRZTZWRWOWSWTWLWPWLXAWLXAXBNAUUFUWJUWMQUYEUWPUWLUVSUYIUYJVNAUUFU
      WJLULMNABXCUPNAUUFSUWMNAUUFSNUWOUUGSMUYDXNXDASUWMLULMNABXEUPXFXGXHNAUUFUV
      TUVIUWPUVTUWPUVRUVSUWPUVQUUGUWPUVPUUJUWPUUKUVOUXEUWPUUMUVNCUXFVUNUUOUVMVU
      QVUNUURUVLBVUOVVDVMZRZVMZRZUYGVQZUYDVBZUYJVNTUWPUVIUWPUVHUUGUWPUUJUVGUYGU
      WPUUKUVFUXEUWPUUMUVECUXFVUNUUOUVDVUQVUNUURUVCBVUOVUTUUTUVBVVBVUTUVAQMUVBQ
      MVUTUUPUUSVUNUUPQMVUSVUNUUGUUNUWPUWSVUMUWTVHVUPVIVHVVAVIUVAVJVGZRZVMZRZVM
      ZRZVNUYDVBTZNAUUFUVTUVIKEZLAUUFHUUMUUOUURUUTUVKUVBOEZGEZBJZGEZCJZUUGUUIGE
      ZIEZUUIKEZGEZLULNAUUFVVSVWHUWPUVRUVIKEZUVSKEHVWFGEZUVSKEVVSVWHUWPVWIVWJUV
      SKUWPUVQUVHKEZUUGIEUUKVWDGEZUUGIEZVWIVWJUWPVWKVWLUUGIUWPUUJUVPOEZUVHKEUVP
      UVGOEZVWKVWLUWPUUJUVPUVGUYOUWPUVPVVITZUWPUVGVVQTZXIUWPUVQVWNUVHKUWPUVPUUJ
      VWPUYOXJWLUWPVWLUUKUVOUVFOEZGEVWOUWPVWDVWRUUKGUWPVWDUUMUVNUVEOEZCJVWRUWPU
      UMVWCVWSCVUNVWCUUOUVMUVDOEZGEVWSVUNVWBVWTUUOGVUNVWBUURUVLUVCOEZBJVWTVUNUU
      RVWAVXABVUTUUTUVKUVBVUTUUTVVBTVUTUVKVVCTVUTUVBVVLTXKWOVUNUURUVLUVCBVUOVVE
      VUTUVCVVMTXLWPWTVUNUUOUVMUVDVURVUNUVMVVFTVUNUVDVVNTXKWPWOUWPUUMUVNUVECUXF
      VUNUVNVVGTVUNUVEVVOTXLWPWTUWPUUKUVOUVFUWPUUKUXETUWPUVOVVHTUWPUVFVVPTXKWPW
      SWLUWPUVQUVHUUGUWPUVQVVJTUWPUUJUVGUYOVWQXOUYMUYNXMUWPHVWDGEZUUIIEZUUGIEZV
      XBVWEIEZVWMVWJUWPVXDVXBUUIUUGGEZIEVXEUWPVXBUUIUUGUWPHVWDHXPMZUWPYEUPZUWPV
      WDUWPUUMVWCCUXFVUNUUOVWBVUQVUNUURVWABVUOVUTUUTVVTVVBVUTUVKUVBVVCVVLVQRVMR
      VMZTZWHUWPUUIUYFTZUYMUWPUUIUXDVTZUYNXQUWPVXFVWEVXBIUWPUUIUUGVXKUYMWIWTWPU
      WPVXCVWLUUGIUWPHVWDUUIVXHVXJVXKVXLXRWLUWPHVWDVWEVXHVXJUWPVWEUWPUUGUUIUYDU
      XDXSZXTUWPVWEVXMVTYAYBYBWLUWPUVRUVSUVIUWPUVRVVKTUYKVVRYCUWPHVWFUUIVXHUWPV
      WFUWPVWDVWEVXIVXMVBZTVXKYDWSXBNAUUFHVWGQUWRUWPVWFUUIVXNUYFVNNUUFQYFVXGAUU
      FHLULMDUDYGVXGNYEUPAUUFHYHYIDUAUFZUIFUJEUBUFZUKFVXPUHFVXOVXPIEUGFOEGEUBJV
      XOIEHVXOUHFGEKEYJFUCUFZYPURUADUDYKEYLZUCSYMAUUFVWGLULMZNUAUBUCYNVXRVXSUCS
      VXQSMZVXRPAUAVXQUBBCVXTVXRYQVXTVXRYRYOYSYTUUAUUBUUCUUDUUE $.
  $}

  ${
    $d a d k m n x A $.  $d b c d k m n x y R $.
    pntrval.r $e |- R = ( a e. RR+ |-> ( ( psi ` a ) - a ) ) $.
    $( Define the residual of the second Chebyshev function.  The goal is to
       have ` R ( x ) e. o ( x ) ` , or ` R ( x ) / x ~~>r 0 ` .  (Contributed
       by Mario Carneiro, 8-Apr-2016.) $)
    pntrval $p |- ( A e. RR+ -> ( R ` A ) = ( ( psi ` A ) - A ) ) $=
      ( cv cchp cfv cmin co crp wceq fveq2 id oveq12d ovex fvmpt ) CACEZFGZQHIA
      FGZAHIJBQAKZRSQAHQAFLTMNDSAHOP $.

    $( Functionality of the residual.  Lemma for ~ pnt .  (Contributed by Mario
       Carneiro, 8-Apr-2016.) $)
    pntrf $p |- R : RR+ --> RR $=
      ( crp cr cv cchp cfv cmin co wcel rpre chpcl syl resubcld fmpti ) BDEBFZG
      HZQIJACQDKZRQSQEKREKQLZQMNTOP $.

    $( There is a bound on the residual valid for all ` x ` .  (Contributed by
       Mario Carneiro, 9-Apr-2016.) $)
    pntrmax $p |- E. c e. RR+ A. x e. RR+ ( abs ` ( ( R ` x ) / x ) ) <_ c $=
      ( cdiv co cle wbr crp wtru c1 caddc cr a1i wcel 1re wa cc0 c2 vy cfv cabs
      cv wral wrex cchp wss rpssre cmin pntrval rpre chpcl syl resubcld eqeltrd
      cc rerpdivcl mpancom recnd adantl cmpt co1 oveq1d rpne0 divsubdird dividd
      rpcn oveq2d 3eqtrd mpteq2ia chpo1ub ax-1cn mp2an o1sub2 syl5eqel peano2re
      o1const ad2antrl clt wceq 3ad2ant1 fveq2d 3ad2ant2 resubcl sylancr chpge0
      w3a 0re addge02 mpbid suble0 mpbird rpregt0 divge0 syl21anc letrd readdcl
      wb 2re sylancl adantr simpr 1lt2 lelttrd chpeq0 wne rpcnne0d div0 eqbrtrd
      simp1 wi 0lt1 lediv2a syl212anc imp div1d breqtrd simp2 ltle sylan 3impia
      ex chpwordi syl3anc lecasei 2nn0 nn0addge1 oveq2i add12d syl5eq absdifled
      cn0 df-2 mpbir2and 3expb adantrlr adantll o1bddrp trud ) AUDZBUBZUUAFGZUC
      UBZDUDHIAJUEDJUFKAUAJUUCLDUAUDZUGUBZLMGZJNUHZKUIOLNPZKQOUUAJPZUUCUQPKUUJU
      UCUUBNPUUJUUCNPUUJUUBUUAUGUBZUUAUJGZNUUABCEUKZUUJUUKUUAUUJUUANPZUUKNPZUUA
      ULZUUAUMUNZUUPUOUPUUBUUAURUSUTVAKAJUUCVBAJUUKUUAFGZLUJGZVBVCAJUUCUUSUUJUU
      CUULUUAFGUURUUAUUAFGZUJGUUSUUJUUBUULUUAFUUMVDUUJUUKUUAUUAUUJUUKUUQUTUUAVH
      ZUVAUUAVEZVFUUJUUTLUURUJUUJUUAUVAUVBVGVIVJZVKKAJUURLNUUJUURNPZKUUOUUJUVDU
      UQUUKUUAURUSZVAUUIKUUJRQOAJUURVBVCPKAVLOAJLVBVCPZKUUHLUQPZUVFUIVMAJLVRVNO
      VOVPUUENPZUUGNPZKLUUEHIZUVHUUFNPZUVIUUEUMZUUFVQUNZVSUUJUVHUVJRUUAUUEVTIZR
      UUDUUGHIZKUUJUVHUVNUVOUVJUUJUVHUVNUVOUUJUVHUVNWHZUUDUUSUCUBZUUGHUVPUUCUUS
      UCUUJUVHUUCUUSWAUVNUVCWBWCUVPUVQUUGHILUUGUJGZUURHIUURLUUGMGZHIUVPUVRSUURU
      VPUUIUVIUVRNPQUVHUUJUVIUVNUVMWDZLUUGWEWFSNPUVPWIOUUJUVHUVDUVNUVEWBZUVPUVR
      SHIZLUUGHIZUVPSUUFHIZUWCUVHUUJUWDUVNUUEWGWDZUVPUUIUVKUWDUWCWSQUVHUUJUVKUV
      NUVLWDZLUUFWJWFWKUVPUUIUVIUWBUWCWSQUVTLUUGWLWFWMUVPUUOSUUKHIZUUNSUUAVTIRZ
      SUURHIUUJUVHUUOUVNUUQWBZUVPUUNUWGUUJUVHUUNUVNUUPWBZUUAWGUNZUUJUVHUWHUVNUU
      AWNWBZUUKUUAWOWPWQUVPUURUUFTMGZUVSHUVPUURUUFUWMUWAUWFUVPUVKTNPZUWMNPUWFWT
      UUFTWRXAUVPUURUUFHIUUALUWJUUIUVPQOZUVPUUALHIZRZUURSUUAFGZUUFHUWQUUKSUUAFU
      WQUUKSWAZUUATVTIZUWQUUALTUVPUUNUWPUWJXBZUUIUWQQOUWNUWQWTOUVPUWPXCLTVTIUWQ
      XDOXEUWQUUNUWSUWTWSUXAUUAXFUNWMVDUVPUWRUUFHIUWPUVPUWRSUUFHUVPUUAUQPUUASXG
      RUWRSWAUVPUUAUUJUVHUVNXKXHUUAXIUNUWEXJXBXJUVPLUUAHIZRZUURUUKUUFUVPUVDUXBU
      WAXBUVPUUOUXBUWIXBZUVPUVKUXBUWFXBUXCUURUUKLFGZUUKHUVPUXBUURUXEHIZUVPUUISL
      VTIZUWHUUOUWGUXBUXFXLUWOUXGUVPXMOUWLUWIUWKUUIUXGRUWHUUOUWGRWHUXBUXFLUUAUU
      KXNYCXOXPUXCUUKUXCUUKUXDUTXQXRUVPUUKUUFHIZUXBUVPUUNUVHUUAUUEHIZUXHUWJUUJU
      VHUVNXSUUJUVHUVNUXIUUJUUNUVHUVNUXIXLUUPUUAUUEXTYAYBUUAUUEYDYEXBWQYFUVPUVK
      TYMPUUFUWMHIUWFYGUUFTYHXAWQUVPUWMUUFLLMGZMGUVSTUXJUUFMYNYIUVPUUFLLUVPUUFU
      WFUTUVGUVPVMOZUXKYJYKXRUVPUURLUUGUWAUWOUVTYLYOXJYPYQYRYSYT $.

    $( A bound on a sum over ` R ` .  Equation 10.1.16 of [Shapiro], p. 403.
       (Contributed by Mario Carneiro, 25-May-2016.) $)
    pntrsumo1 $p |- ( x e. RR |-> sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( R ` n ) / ( n x. ( n + 1 ) ) ) ) e. O(1) $=
      ( cr c1 cfv co cmul cdiv wcel wtru wceq crp wbr cc0 syl cmin recnd vm cfl
      cv cfz caddc csu cmpt co1 cpnf cico cres wss cle wa wb 1re elicopnf ax-mp
      simplbi 0re a1i clt 0lt1 simprbi ltletrd elrpd ssriv rpssre syl6ss resmpt
      cvma cchp cneg cfzo oveq2 oveq1 fveq2d oveq12d ax-1cn div1i syl6eq subidi
      jca c2 2pos chpeq0 cn cn0 rprege0d elfznn adantl nnrecred nnred peano2rem
      chpcl resubcld eqcomd cc nncnd pncan sylancl eqeltrd subcld eqtr4d oveq2d
      3eqtr3d oveq1d pncan2d eqtrd peano2cn nnncan2d nnne0d divrec2d sumeq12rdv
      nndivred mulcld divsubdird mulid1d divcan5d eqtr3d negeqd nnrpd fzfid cof
      fsumrecl cvv eqidd offval2 mpteq2dva cabs adantrr syl2anc eqbrtrd sylancr
      mpbird eqeltrrd syl3anc rerpdivcld rpregt0d o1sub2 mpbir 0cn cuz flge0nn0
      nn0p1nn nnuz syl6eleq fsumparts cz flcld fzval3 sub4d nnm1nn0 chpp1 npcan
      vmacl pncan2 nn0cnd chpfl subsub3d subdid recid2d 3eqtrd peano2re subid1d
      mul01i subcl peano2nn nnmulcl mpdan nnrp ffvelrni mulneg1d mulcomd eqtr2d
      pntrf negsubdi2d pntrval 3eqtr4d fsumneg subnegd mpteq2ia rpre clog ssexi
      rprege0 fsumcl relogcl fsumsub sumeq2dv vmadivsum harmoniclbnd abssubge0d
      reex 3eqtr4rd ad2antrl simprr harmonicubnd lesubadd2d elo1d o1sub rpcnne0
      wne divdir simpr rpreccl chpo1ub crli divrcnv rlimo1 mp1i chpge0 ge0p1rpd
      o1add divge0 absidd abscld fllep1 rpregt0 lediv2 mpbid letrd o1le o1const
      leabsd mp2an o1res2 syl5eqelr wf eqid fmpti ssid o1resb trud ) AFGAUCZUBH
      ZUDIZCUCZBHZUYRUYRGUEIZJIZKIZCUFZUGZUHLZMVUEVUDGUIUJIZUKZUHLMVUGAVUFVUCUG
      ZUHMVUFFULVUGVUHNMVUFOFVUFOULMAVUFOUYOVUFLZUYOVUIUYOFLZGUYOUMPZGFLZVUIVUJ
      VUKUNUOUPGUYOUQURZUSZVUIQGUYOQFLZVUIUTVAVULVUIUPVAVUNQGVBPVUIVCVAVUIVUJVU
      KVUMVDVEVFZVGVAZVHVIAFVUFVUCVJRMVUHAVUFUYQUYRVKHZGSIZUYRKIZCUFZUYOVLHZGUE
      IZUYPGUEIZKIZGSIZSIZUGUHAVUFVVGVUCVUIVVGVVFVUCUEIZVVFSIVUCVUIVVAVVHVVFSVU
      IVVAVVFVUCVMZSIZVVHVUIGVVDVNIZGUYRKIZUYTGSIZVLHZVVMSIZUYRGSIZVLHZVVPSIZSI
      ZJIZCUFGVVDKIZVVDGSIZVLHZVWBSIZJIZGQJIZSIZVVKGUYTKIZVVLSIZVVOJIZCUFZSIVVA
      VVJVUIGUAUCZKIZVVLVWHGCUAVWAGVVDVWLGSIZVLHZVWNSIZVVRVVOQVWDVWLUYRNZVWMVVL
      NVWPVVRNVWLUYRGKVOVWQVWOVVQVWNVVPSVWQVWNVVPVLVWLUYRGSVPZVQVWRVRWCVWLUYTNZ
      VWMVWHNVWPVVONVWLUYTGKVOVWSVWOVVNVWNVVMSVWSVWNVVMVLVWLUYTGSVPZVQVWTVRWCVW
      LGNZVWMGNVWPQNVXAVWMGGKIGVWLGGKVOGVSVTWAVXAVWPQQSIQVXAVWOQVWNQSVXAVWOQVLH
      ZQVXAVWNQVLVXAVWNGGSIQVWLGGSVPGVSWBWAZVQVXBQNZQWDVBPZWEVUOVXDVXEUOUTQWFUR
      UUAWAVXCVRQUUBWBWAWCVWLVVDNZVWMVWANVWPVWDNVWLVVDGKVOVXFVWOVWCVWNVWBSVXFVW
      NVWBVLVWLVVDGSVPZVQVXGVRWCVUIVVDWGGUUCHVUIUYPWHLZVVDWGLZVUIVUJQUYOUMPUNZV
      XHVUIUYOVUPWIUYOUUDZRZUYPUUEZRZUUFUUGVUIVWLGVVDUDILZUNZVWMVXPVWLVXOVWLWGL
      VUIVWLVVDWJWKZWLTVXPVWPVXPVWOVWNVXPVWNFLZVWOFLVXPVWLFLVXRVXPVWLVXQWMVWLWN
      RZVWNWORVXSWPTUUHVUIVVKUYQVVTVUTCVUIUYQVVKVUIUYPUUILUYQVVKNVUIUYOVUNUUJGU
      YPUUKRWQZVUIUYRUYQLZUNZVVTVVLVUSJIVUTVYBVVSVUSVVLJVYBVVSVVNVVQSIZVVMVVPSI
      ZSIVUSVYBVVNVVMVVQVVPVYBVVNVYBVVMFLVVNFLVYBVVMUYRFVYBUYRWRLZGWRLZVVMUYRNV
      YBUYRVYAUYRWGLZVUIUYRUYPWJZWKZWSZVSUYRGWTXAZVYBUYRVYIWMZXBZVVMWORTVYBVVMV
      YMTVYBVVQVYBVVPFLZVVQFLVYBUYRFLVYNVYLUYRWNRVVPWORTZVYBUYRGVYJVYFVYBVSVAZX
      CUULVYBVYCVURVYDGSVYBVYCVVQVURUEIZVVQSIVURVYBVVNVYQVVQSVYBVVPGUEIZVLHZVVQ
      VYRVKHZUEIZVVNVYQVYBVVPWHLZVYSWUANVYBVYGWUBVYIUYRUUMRVVPUUNRVYBVYRVVMVLVY
      BVYRUYRVVMVYBVYEVYFVYRUYRNVYJVSUYRGUUOXAZVYKXDVQVYBVYTVURVVQUEVYBVYRUYRVK
      WUCVQXEXFXGVYBVVQVURVYOVYBVURVYBVYGVURFLZVYIUYRUUPZRZTXHXIVYBVYDUYTUYRSIZ
      GVYBUYTUYRGVYBVYEUYTWRLVYJUYRXJRZVYJVYPXKVYBVYEVYFWUGGNVYJVSUYRGUUQXAZXIV
      RXIXEVYBVUSUYRVYBVUSVYBWUDVUSFLZWUFVURWNZRTVYJVYBUYRVYIXLZXMXDXNVUIVWGVVF
      VWKVVISVUIVWGVVFQSIVVFVUIVWEVVFVWFQSVUIVWEVWAVVCVVDSIZJIVWAVVCJIZVWAVVDJI
      ZSIVVFVUIVWDWUMVWAJVUIVWDVVBVWBSIWUMVUIVWCVVBVWBSVUIVWCUYPVLHZVVBVUIVWBUY
      PVLVUIUYPWRLVYFVWBUYPNVUIUYPVXLUURVSUYPGWTXAVQVUIVUJWUPVVBNVUNUYOUUSRXIXG
      VUIVVBVVDGVUIVVBVUIVUJVVBFLZVUNUYOWOZRZTZVUIVVDVXNWSZVYFVUIVSVAUUTXIXEVUI
      VWAVVCVVDVUIVWAVUIVVDVXNWLTVUIVVBWRLZVVCWRLWUTVVBXJRZWVAUVAVUIWUNVVEWUOGS
      VUIVVEWUNVUIVVCVVDWVCWVAVUIVVDVXNXLZXMWQVUIVVDWVAWVDUVBVRUVCVWFQNVUIGVSUV
      FVAVRVUIVVFVUIVVEWRLVYFVVFWRLVUIVVEVUIVVCVVDVUIWUQVVCFLZWUSVVBUVDZRVXNXOT
      VSVVEGUVGXAZUVEXIVUIVWKUYQVUBVMZCUFVVIVUIVVKUYQVWJWVHCVXTVYBGVUAKIZVMZUYS
      JIWVIUYSJIZVMVWJWVHVYBWVIUYSVYBWVIVYBVUAVYBVYGVUAWGLZVYIVYGUYTWGLZWVLUYRU
      VHZUYRUYTUVIUVJZRZWLTVYBUYSVYBVYGUYSFLZVYIVYGUYROLWVQUYRUVKOFUYRBBDEUVPUV
      LRZRTZUVMVYBVWIWVJVVOUYSJVYBWVJVVLVWHSIZVMVWIVYBWVIWVTVYBUYTUYRGJIZSIZVUA
      KIUYTVUAKIZWWAVUAKIZSIWVIWVTVYBUYTWWAVUAWUHVYBUYRGVYJVYPXPVYBUYRUYTVYJWUH
      XPZVYBVUAWVPXLZXQVYBWWBGVUAKVYBWWBWUGGVYBWWAUYRUYTSVYBUYRVYJXRXEWUIXIXGVY
      BWWCVVLWWDVWHSVYBUYTGJIZUYTUYRJIZKIWWCVVLVYBWWGUYTWWHVUAKVYBUYTWUHXRVYBUY
      TUYRWUHVYJUVNVRVYBGUYRUYTVYPVYJWUHWULVYBUYTVYBVYGWVMVYIWVNRZXLZXSXTVYBGUY
      TUYRVYPWUHVYJWWJWULXSVRXFYAVYBVVLVWHVYBVVLVYBUYRVYIWLTVYBVWHVYBUYTWWIWLTU
      VQUVOVYBVVMBHZVVOUYSVYBVVMOLWWKVVONVYBVVMUYROVYKVYBUYRVYIYBXBVVMBDEUVRRVY
      BVVMUYRBVYKVQXTVRVYBVUBWVKVYBUYSVUAWVSWWEWWFXMYAUVSXNVUIUYQVUBCVUIGUYPYCV
      YBVUBVYBVYGVUBFLZVYIVYGUYSVUAWVRWVOXOZRTUVTXIVRXFVUIVVFVUCWVGVUIVUJVUCWRL
      VUNVUJVUCVUJUYQVUBCVUJGUYPYCVUJVYAUNVYGWWLVYAVYGVUJVYHWKWWMRYETZRZUWAXIXG
      VUIVVFVUCWVGWWOXHXIUWBMAVUFOVVGVUQMAOVVAVVFFMUYOOLZUNZUYQVUTCWWQGUYPYCZWW
      QVYAUNZVUSUYRWWSWUDWUJWWSVYGWUDVYAVYGWWQVYHWKZWUERZWUKRWWTXOYEWWQVVEFLVVF
      FLWWQVVCVVDWWQWUQWVEWWQVUJWUQWWPVUJMUYOUWCZWKZWURRZWVFRZWWQVXHVXIWWPVXHMW
      WPVXJVXHUYOUWFVXKRWKVXMRZXOZVVEWNRMAOUYQVURUYRKIZCUFZUYOUWDHZSIZUGZAOUYQV
      VLCUFZWXJSIZUGZSYDIZAOVVAUGZUHMWXPAOWXKWXNSIZUGWXQMAOWXKWXNSWXLWXOYFWRFOY
      FLMOFUWNVHUWEVAZWWQWXIWXJWWQUYQWXHCWWRWWSWXHWWSVURUYRWXAWWTXOTZUWGZWWQWXJ
      WWPWXJFLMUYOUWHWKZTZXCWWQWXMWXJWWQUYQVVLCWWRWWSUYRWWTWLZYEZWYBWPZMWXLYGMW
      XOYGYHMAOWXRVVAWWQUYQWXHVVLSIZCUFWXIWXMSIVVAWXRWWQUYQWXHVVLCWWRWXTWWSVVLW
      YDTUWIWWQUYQVUTWYGCWWSVURGUYRWWSVURWXATVYFWWSVSVAWWSUYRWWTWSWWSUYRWWTXLXQ
      UWJWWQWXIWXMWXJWYAWWQWXMWYETWYCXKUWOYIXIMWXLUHLWXOUHLWXPUHLACUWKMAOWXNGGO
      FULZMVHVAWWQWXNWYFTVULMUPVAZWYIMWWPVUKUNUNZWXNYJHZWXNGUMMWWPWYKWXNNVUKWWQ
      WXJWXMWYBWYEWWPWXJWXMUMPMUYOCUWLWKUWMYKWYJWXNGUMPZWXMWXJGUEIUMPZWYJVUJVUK
      WYMWWPVUJMVUKWXBUWPMWWPVUKUWQUYOCUWRYLMWWPWYLWYMUOVUKWWQWXMWXJGWYEWYBVULW
      WQUPVAUWSYKYOYMUWTWXLWXOUXAYNYPMAOVVEGWRWWQVVEWXGTZVYFWWQVSVAZMAOVVCUYOKI
      ZVVEGFWYIMAOWYPUGAOVVBUYOKIZGUYOKIZUEIZUGZUHMAOWYPWYSWWQWVBVYFUYOWRLUYOQU
      XCUNZWYPWYSNWWQVVBWXDTWYOWWPXUAMUYOUXBWKVVBGUYOUXDYQYIMAOWYQUGZAOWYRUGZUE
      YDIZWYTUHMAOWYQWYRUEXUBXUCYFFOWXSWWQVVBUYOWXDMWWPUXEZYRWWPWYROLMUYOUXFWKM
      XUBYGMXUCYGYHMXUBUHLXUCUHLZXUDUHLAUXGXUCQUXHPZXUFMVYFXUGVSGAUXIURQXUCUXJU
      XKXUBXUCUXNYNYPXBWWQVVCUYOWXEXUEYRZWYNMWWPVVEYJHZWYPYJHZUMPVUKWWQXUIVVEXU
      JUMWWQVVEWXGWWQWVEQVVCUMPUNVVDFLQVVDVBPUNZQVVEUMPWWQVVCWWQVVBWXDWWQVUJQVV
      BUMPWXCUYOUXLRUXMZWIWWQVVDWWQVVDWXFYBYSZVVCVVDUXOYLUXPWWQVVEWYPXUJWXGXUHW
      WQWYPWWQWYPXUHTUXQWWQUYOVVDUMPZVVEWYPUMPZWWQVUJXUNWXCUYOUXRRWWQVUJQUYOVBP
      UNZXUKWVEQVVCVBPUNXUNXUOUOWWPXUPMUYOUXSWKXUMWWQVVCXULYSUYOVVDVVCUXTYQUYAW
      WQWYPXUHUYEUYBYMYKUYCAOGUGUHLZMWYHVYFXUQVHVSAOGUYDUYFVAYTYTUYGUYHXBMFGVUD
      FWRVUDUYIMAFWRVUCVUDVUDUYJWWNUYKVAFFULMFUYLVAWYIUYMYOUYN $.

    $( A bound on a sum over ` R ` .  Equation 10.1.16 of [Shapiro], p. 403.
       (Contributed by Mario Carneiro, 25-May-2016.) $)
    pntrsumbnd $p |- E. c e. RR+ A. m e. ZZ ( abs ` sum_ n e. ( 1 ... m )
        ( ( R ` n ) / ( n x. ( n + 1 ) ) ) ) <_ c $=
      ( c1 cv cfv cfz co csu cle wbr cr crp wtru wcel wa syl vx caddc cmul cdiv
      cfl cabs wral wrex cz wss ssid a1i 1re fzfid cn cc elfznn adantl ffvelrni
      nnrp pntrf peano2nn mpdan nndivred recnd fsumcl cmpt co1 pntrsumo1 abscld
      nnmulcl fsumrecl clt adantr adantlr fsumabs absge0d simplr simprll simprr
      ad2ant2r cuz ltled flword2 syl3anc fzss2 fsumless letrd o1bddrp wi imim1i
      trud zre flid oveq2d sumeq1d fveq2d breq1d mpbidi ralimi2 reximi ax-mp )
      GBHZUEIZJKZCHZAIZXFXFGUBKZUCKZUDKZCLZUFIZEHZMNZBOUGZEPUHZGXCJKZXJCLZUFIZX
      MMNZBUIUGZEPUHXPQBUAOXKGEGUAHZUEIZJKZXJUFIZCLZOOUJQOUKULGORQUMULQXCORZSZX
      EXJCYHGXDUNYHXFXERZSXFUORZXJUPRZYIYJYHXFXDUQURYJXJYJXGXIYJXFPRXGORXFUTPOX
      FAADFVAUSTYJXHUORXIUORXFVBXFXHVKVCVDVEZTZVFZBOXKVGVHRQBACDFVIULQYBORZGYBM
      NZSZSZYDYECYRGYCUNYRXFYDRZSZXJYTYJYKYSYJYRXFYCUQZURYLTVJVLZYHYQXCYBVMNZSZ
      SZXLXEYECLYFUUEXKYHXKUPRUUDYNVNVJUUEXEYECUUEGXDUNZUUEYISXJYHYIYKUUDYMVOZV
      JVLQYQYFORYGUUCUUBWAUUEXEXJCUUFUUGVPUUEYDYEXECUUEGYCUNUUEYSSZXJUUHYJYKYSY
      JUUEUUAURYLTZVJUUHXJUUIVQUUEYCXDWBIRZXEYDUJUUEYGYOXCYBMNUUJQYGUUDVRZYHYOY
      PUUCVSZUUEXCYBUUKUULYHYQUUCVTWCXCYBWDWEXDGYCWFTWGWHWIWLXOYAEPXNXTBOUIXCUI
      RZXNXTYGXNWJUUMYGXNXCWMWKUUMXLXSXMMUUMXKXRUFUUMXEXQXJCUUMXDXCGJXCWNWOWPWQ
      WRWSWTXAXB $.

    $( A bound on a sum over ` R ` .  Equation 10.1.16 of [Shapiro], p. 403.
       (Contributed by Mario Carneiro, 14-Apr-2016.) $)
    pntrsumbnd2 $p |- E. c e. RR+ A. k e. NN A. m e. ZZ
     ( abs ` sum_ n e. ( k ... m ) ( ( R ` n ) / ( n x. ( n + 1 ) ) ) ) <_ c $=
      ( c1 cfz co cfv cabs cle wbr cz crp cn wcel wa cr vb caddc cmul cdiv wral
      cv csu wrex pntrsumbnd c2 2rp rpmulcl mpan adantr nnz adantl peano2zm syl
      cmin simplr wceq oveq2 sumeq1d fveq2d breq1d rspcv wi cc0 ad2antrr rpge0d
      sylc c0 sumeq1 sum0 syl6eq abs00bd syl5ibrcom imp a1d wne cuz fzn0 elfznn
      fzfid simpr nnrpd pntrf ffvelrni peano2nnd nnmulcld nndivred sylan2 recnd
      fsumrecl abscld simplll rpred le2add 2timesd breq2d clt cin simpllr nnred
      syl22anc ltm1d fzdisj cc nncnd ax-1cn npcan sylancl eqeltrd nnuz syl6eleq
      cun nnzd eleq2d biimpar peano2uzr syl2anc fzsplit2 oveq1d eqtrd fsumsplit
      uneq2d elfzuz uztrn2 syl2an syldan pncan2d eqbrtrrd readdcld 2re remulcld
      abs2dif2d a1i letr syl3anc mpand sylbird syld ancomsd pm2.61dane ralimdva
      sylan2b an4s impancom an32s mpd ralrimiva breq2 2ralbidv rspcev rexlimiva
      expr ax-mp ) HCUFZIJZDUFZAKZUUTUUTHUBJZUCJZUDJZDUGZLKZUAUFZMNZCOUEZUAPUHB
      UFZUURIJZUVDDUGZLKZFUFZMNZCOUEBQUEZFPUHZACDEUAGUIUVIUVQUAPUVGPRZUVISZUJUV
      GUCJZPRZUVMUVTMNZCOUEZBQUEZUVQUVRUWAUVIUJPRUVRUWAUKUJUVGULUMZUNUVSUWCBQUV
      SUVJQRZSZHUVJHUSJZIJZUVDDUGZLKZUVGMNZUWCUWGUWHORZUVIUWLUWGUVJORZUWMUWFUWN
      UVSUVJUOUPUVJUQZURUVRUVIUWFUTUVHUWLCUWHOUURUWHVAZUVFUWKUVGMUWPUVEUWJLUWPU
      USUWIUVDDUURUWHHIVBVCVDVEVFVKUVRUWFUVIUWLUWCVGUVRUWFSZUWLUVIUWCUWQUWLSZUV
      HUWBCOUWRUURORZUVHUWBUWQUWSUWLUVHUWBUWQUWSSZUWLUVHSZUWBUWTUXAUWBVGZUVKVLU
      WTUVKVLVAZSUWBUXAUWTUXCUWBUWTUWBUXCVHUVTMNUWTUVTUVRUWAUWFUWSUWEVIVJUXCUVM
      VHUVTMUXCUVLUXCUVLVLUVDDUGVHUVKVLUVDDVMUVDDVNVOVPVEVQVRVSUVKVLVTUWTUURUVJ
      WAKZRZUXBUVJUURWBUWTUXESZUVHUWLUWBUXFUVHUWLSZUVFUWKUBJZUVGUVGUBJZMNZUWBUX
      FUVFTRUWKTRUVGTRZUXKUXGUXJVGUXFUVEUXFUVEUXFUUSUVDDUXFHUURWDZUUTUUSRZUXFUU
      TQRZUVDTRZUUTUURWCUXFUXNSZUVAUVCUXPUUTPRUVATRUXPUUTUXFUXNWEZWFPTUUTAAEGWG
      WHURUXPUUTUVBUXQUXPUUTUXQWIWJWKZWLZWNWMZWOZUXFUWJUXFUWJUXFUWIUVDDUXFHUWHW
      DUUTUWIRUXFUXNUXOUUTUWHWCUXRWLWNWMZWOZUXFUVGUVRUWFUWSUXEWPWQZUYDUVFUWKUVG
      UVGWRXEUXFUXJUXHUVTMNZUWBUXFUVTUXIUXHMUXFUVGUXFUVGUYDWMWSWTUXFUVMUXHMNZUY
      EUWBUXFUVEUWJUSJZLKUVMUXHMUXFUYGUVLLUXFUYGUWJUVLUBJZUWJUSJUVLUXFUVEUYHUWJ
      USUXFUWIUVKUVDUUSDUXFUWHUVJXANUWIUVKXBVLVAUXFUVJUXFUVJUVRUWFUWSUXEXCZXDXF
      HUWHUVJUURXGURUXFUUSUWIUWHHUBJZUURIJZXPZUWIUVKXPUXFUYJHWAKZRUURUWHWAKRZUU
      SUYLVAUXFUYJQUYMUXFUYJUVJQUXFUVJXHRZHXHRZUYJUVJVAZUXFUVJUYIXIXJUVJHXKZXLZ
      UYIXMXNXOUXFUWMUURUYJWAKZRZUYNUXFUWNUWMUXFUVJUYIXQUWOURUWTVUAUXEUWTUYTUXD
      UURUWTUYJUVJWAUWTUYOUYPUYQUWTUVJUVRUWFUWSUTXIXJUYRXLVDXRXSUWHUURXTYAUWHHU
      URYBYAUXFUYKUVKUWIUXFUYJUVJUURIUYSYCYFYDUXLUXFUXMSUVDUXSWMYEYCUXFUWJUVLUY
      BUXFUVLUXFUVKUVDDUXFUVJUURWDUXFUUTUVKRZUXNUXOUXFUWFUUTUXDRUXNVUBUYIUUTUVJ
      UURYGHUUTUVJQXNYHYIUXRYJWNWMZYKYDVDUXFUVEUWJUXTUYBYPYLUXFUVMTRUXHTRUVTTRU
      YFUYESUWBVGUXFUVLVUCWOUXFUVFUWKUYAUYCYMUXFUJUVGUJTRUXFYNYQUYDYOUVMUXHUVTY
      RYSYTUUAUUBUUCUUFUUDVRUUGUUPUUEUUHUUIUUJUUKUVPUWDFUVTPUVNUVTVAUVOUWBBCQOU
      VNUVTUVMMUULUUMUUNYAUUOUUQ $.

    $( Selberg's symmetry formula, using the residual of the second Chebyshev
       function.  Equation 10.6.2 of [Shapiro], p. 428.  (Contributed by Mario
       Carneiro, 16-Apr-2016.) $)
    selbergr $p |- ( x e. RR+ |-> ( ( ( ( R ` x ) x. ( log ` x ) ) +
      sum_ d e. ( 1 ... ( |_ ` x ) ) ( ( Lam ` d ) x. ( R ` ( x / d ) ) ) )
        / x ) ) e. O(1) $=
      ( crp cfv cmul co cdiv caddc cmin cvv wcel cr recnd mulcld oveq1d oveq2d
      cc cv cchp clog c1 cfl cfz cvma csu c2 cmpt cof co1 wceq wtru reex rpssre
      ssexi a1i wa ovex eqidd offval2 trud pntrf ffvelrni relogcl elfznn adantl
      fzfid vmacl syl rpre nndivre syl2an chpcl fsumcl addcld rpcn rpne0 divcld
      nndivred nnncan2d subsub4d pntrval subdird addsubd eqtr4d cc0 wne rpcnne0
      eqtrd divsubdir syl3anc divcan3d 3eqtrd 2timesd 3eqtr4d addsubassd adantr
      cn fsumsub subdid nnrpd sylan2 div12 sumeq2dv fsummulc2 3eqtr4rd 3eqtr3rd
      rpdivcl 3eqtr3d mpteq2ia eqtri selberg2 vmadivsum o1sub mp2an eqeltrri )
      AFAUAZUBGZXSUCGZHIZUDXSUEGZUFIZDUAZUGGZXSYEJIZUBGZHIZDUHZKIZXSJIZUIYAHIZL
      IZUJZAFYDYFYEJIZDUHZYALIZUJZLUKIZAFXSBGZYAHIZYDYFYGBGZHIZDUHZKIZXSJIZUJZU
      LYTAFYNYRLIZUJZUUHYTUUJUMUNAFYNYRLYOYSMMMFMNUNFOUOUPUQURYNMNUNXSFNZUSZYLY
      MLUTURYRMNUULYQYALUTURUNYOVAUNYSVAVBVCAFUUIUUGUUKUUBYJKIZXSJIZYALIZYRLIUU
      NYQLIZUUIUUGUUKUUNYQYAUUKUUMXSUUKUUBYJUUKUUAYAUUKUUAFOXSBBCEVDVEPUUKYAXSV
      FPZQZUUKYDYIDUUKUDYCVIZUUKYEYDNZUSZYFYHUVAYFUVAYEWTNZYFONUUTUVBUUKYEYCVGZ
      VHZYEVJVKZPZUVAYHUVAYGONZYHONUUKXSONZUVBUVGUUTXSVLZUVCXSYEVMVNZYGVOVKPZQZ
      VPZVQZXSVRZXSVSZVTUUKYDYPDUUSUVAYPUVAYFYEUVEUVDWAPZVPZUUQWBUUKUUOYNYRLUUK
      YLYALIZYALIYLYAYAKIZLIUUOYNUUKYLYAYAUUKYKXSUUKYBYJUUKXTYAUUKXTUUKUVHXTONU
      VIXSVOVKPZUUQQZUVMVQZUVOUVPVTUUQUUQWCUUKUUNUVSYALUUKUUNYKXSYAHIZLIZXSJIZY
      LUWDXSJIZLIZUVSUUKUUMUWEXSJUUKUUMYBUWDLIZYJKIUWEUUKUUBUWIYJKUUKUUBXTXSLIZ
      YAHIUWIUUKUUAUWJYAHXSBCEWDRUUKXTXSYAUWAUVOUUQWEWKRUUKYBYJUWDUWBUVMUUKXSYA
      UVOUUQQZWFWGRUUKYKTNUWDTNXSTNZXSWHWIUSZUWFUWHUMUWCUWKXSWJZYKUWDXSWLWMUUKU
      WGYAYLLUUKYAXSUUQUVOUVPWNSWORUUKYMUVTYLLUUKYAUUQWPSWQRUUKUUMXSYQHIZLIZXSJ
      IZUUNUWOXSJIZLIZUUGUUPUUKUUMTNUWOTNUWMUWQUWSUMUVNUUKXSYQUVOUVRQZUWNUUMUWO
      XSWLWMUUKUWPUUFXSJUUKUWPUUBYJUWOLIZKIUUFUUKUUBYJUWOUURUVMUWTWRUUKUXAUUEUU
      BKUUKYDYIXSYPHIZLIZDUHYJYDUXBDUHZLIUUEUXAUUKYDYIUXBDUUSUVLUVAXSYPUUKUWLUU
      TUVOWSZUVQQXAUUKYDUUDUXCDUVAYFYHYGLIZHIYIYFYGHIZLIUUDUXCUVAYFYHYGUVFUVKUV
      AYGUVJPXBUVAUUCUXFYFHUVAYGFNZUUCUXFUMUUTUUKYEFNZUXHUUTYEUVCXCXSYEXJXDYGBC
      EWDVKSUVAUXBUXGYILUVAUWLYFTNYETNYEWHWIUSZUXBUXGUMUXEUVFUVAUXIUXJUVAYEUVDX
      CYEWJVKXSYFYEXEWMSWQXFUUKUWOUXDYJLUUKYDYPXSDUUSUVOUVQXGSXHSWKRUUKUWRYQUUN
      LUUKYQXSUVRUVOUVPWNSXIXKXLXMYOULNYSULNYTULNADXNADXOYOYSXPXQXR $.

    $( Selberg's symmetry formula, using the residual of the second Chebyshev
       function.  Equation 10.6.8 of [Shapiro], p. 429.  (Contributed by Mario
       Carneiro, 30-May-2016.) $)
    selberg3r $p |- ( x e. ( 1 (,) +oo ) |-> ( ( ( ( R ` x ) x. ( log ` x ) ) +
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( ( Lam ` n ) x. ( R ` ( x / n ) ) ) x. ( log ` n ) ) ) )
          / x ) ) e. O(1) $=
      ( c1 co cfv cmul c2 cdiv caddc cmpt wcel wtru cmin cr a1i recnd oveq2d cv
      cpnf cioo clog cfl cfz cvma csu co1 cchp elioore adantl crp 1rp rpred clt
      wbr eliooord simpld ltled rpgecld relogcld 2timesd chpcl syl remulcld 2re
      wa rplogcld fzfid cn elfznn vmacl adantr nndivred nnrpd fsumrecl readdcld
      rerpdivcld subsub4d eqtr4d oveq1d subcld cc rpne0d divcld mulcld nnncan2d
      2cn ffvelrni addcld divsubdird addsubassd subdid fsummulc2 fsumsub mul32d
      pntrf nncnd nnne0d div23d div12d eqtr3d oveq12d rpdivcld pntrval sumeq2dv
      eqtrd mul12d 3eqtr3rd subdird addsubd divcan3d 3eqtrrd mpteq2dva resubcld
      wceq selberg3 rehalfcld div32d eqcomd cc0 wne 2ne0 divcan2d ioossre mp2an
      wss o1const vmalogdivsum o1mul2 eqeltrrd o1sub2 eqeltrd trud ) AFUBUCGZAU
      AZBHZYQUDHZIGZJYSKGZFYQUEHZUFGZCUAZUGHZYQUUDKGZBHZIGUUDUDHZIGZCUHZIGZLGZY
      QKGZMZUINOUUNAYPYQUJHZYSIGZUUAUUCUUEUUFUJHZIGZUUHIGZCUHZIGZLGZYQKGZJYSIGZ
      PGZUUAUUCUUEUUDKGZUUHIGZCUHZIGZYSPGZPGZMUIOAYPUUMUVKOYQYPNZVHZUVKUVCYSPGZ
      YSPGZUVJPGUVNUVIPGZUUMUVMUVEUVOUVJPUVMUVEUVCYSYSLGZPGUVOUVMUVDUVQUVCPUVMY
      SUVMYSUVMYQUVMYQFUVLYQQNZOYQFUBUKULZFUMNUVMUNRZUVMFYQUVMFUVTUOUVSUVMFYQUP
      UQZYQUBUPUQZUVLUWAUWBVHOYQFUBURULUSZUTVAZVBZSZVCTUVMUVCYSYSUVMUVCUVMUVBYQ
      UVMUUPUVAUVMUUOYSUVMUVRUUOQNUVSYQVDVEZUWEVFZUVMUUAUUTUVMJYSJQNUVMVGRZUVMY
      QUVSUWCVIZVSZUVMUUCUUSCUVMFUUBVJZUVMUUDUUCNZVHZUURUUHUWNUUEUUQUWNUUDVKNZU
      UEQNUWMUWOUVMUUDUUBVLULZUUDVMVEZUWNUUFQNUUQQNUWNYQUUDUVMUVRUWMUVSVNUWPVOZ
      UUFVDVEZVFUWNUUDUWNUUDUWPVPZVBZVFZVQZVFZVRZUWDVSZSZUWFUWFVTWAWBUVMUVNUVIY
      SUVMUVCYSUXGUWFWCUVMUUAUVHUVMJYSJWDNZUVMWIRUWFUVMYSUWJWEZWFZUVMUVHUVMUUCU
      VGCUWLUWNUVFUUHUWNUUEUUDUWQUWPVOUXAVFZVQZSZWGZUWFWHUVMYTUVALGZYQUVIIGZPGZ
      YQKGUXOYQKGZUXPYQKGZPGUUMUVPUVMUXOUXPYQUVMYTUVAUVMYRYSUVMYRUVMYQUMNZYRQNU
      WDUMQYQBBDEWRZWJVESUWFWGZUVMUVAUXDSZWKUVMYQUVIUVMYQUVSSZUXNWGZUYDUVMYQUWD
      WEZWLUVMUXQUULYQKUVMUXQYTUVAUXPPGZLGUULUVMYTUVAUXPUYBUYCUYEWMUVMUYGUUKYTL
      UVMUUAUUTYQUVHIGZPGZIGUVAUUAUYHIGZPGUUKUYGUVMUUAUUTUYHUXJUVMUUTUXCSUVMYQU
      VHUYDUXMWGWNUVMUYIUUJUUAIUVMUYIUUCUUSYQUVGIGZPGZCUHZUUJUVMUYIUUTUUCUYKCUH
      ZPGUYMUVMUYHUYNUUTPUVMUUCUVGYQCUWLUYDUWNUVGUXKSZWOTUVMUUCUUSUYKCUWLUWNUUS
      UXBSUWNYQUVGUVMYQWDNUWMUYDVNZUYOWGWPWAUVMUUCUYLUUICUWNUYLUUEUUHIGZUUGIGZU
      UIUWNUYLUYQUUQIGZUYQUUFIGZPGZUYRUWNUUSUYSUYKUYTPUWNUUEUUQUUHUWNUUEUWQSZUW
      NUUQUWSSZUWNUUHUXASZWQUWNYQUYQUUDKGZIGUYKUYTUWNVUEUVGYQIUWNUUEUUHUUDVUBVU
      DUWNUUDUWPWSZUWNUUDUWPWTZXATUWNYQUYQUUDUYPUWNUUEUUHVUBVUDWGZVUFVUGXBXCXDU
      WNUYRUYQUUQUUFPGZIGVUAUWNUUGVUIUYQIUWNUUFUMNZUUGVUIXQUWNYQUUDUVMUXTUWMUWD
      VNUWTXEZUUFBDEXFVETUWNUYQUUQUUFVUHVUCUWNUUFUWRSWNXHWAUWNUUEUUGUUHVUBUWNUU
      GUWNVUJUUGQNVUKUMQUUFBUYAWJVESVUDWQWAXGXHTUVMUYJUXPUVAPUVMUUAYQUVHUXJUYDU
      XMXITXJTXHWBUVMUXRUVNUXSUVIPUVMUXRUVBYQYSIGZPGZYQKGZUVNUVMUXOVUMYQKUVMUXO
      UUPVULPGZUVALGVUMUVMYTVUOUVALUVMYTUUOYQPGZYSIGVUOUVMYRVUPYSIUVMUXTYRVUPXQ
      UWDYQBDEXFVEWBUVMUUOYQYSUVMUUOUWGSUYDUWFXKXHWBUVMUUPUVAVULUVMUUPUWHSUYCUV
      MYQYSUYDUWFWGZXLWAWBUVMVUNUVCVULYQKGZPGUVNUVMUVBVULYQUVMUVBUXESVUQUYDUYFW
      LUVMVURYSUVCPUVMYSYQUWFUYDUYFXMTXHXHUVMUVIYQUXNUYDUYFXMXDXJXNXOOAYPUVEUVJ
      QUVMUVCUVDUXFUVMJYSUWIUWEVFXPUVMUVIYSUVMUUAUVHUWKUXLVFUWEXPAYPUVEMUINOACX
      RROAYPJUVHYSKGZYSJKGZPGZIGZMAYPUVJMUIOAYPVVBUVJUVMVVBJVUSIGZJVUTIGZPGUVJU
      VMJVUSVUTUVMJUWISZUVMVUSUVMUVHYSUXLUWJVSZSUVMVUTUVMYSUWEXSZSWNUVMVVCUVIVV
      DYSPUVMUVIVVCUVMJYSUVHVVEUWFUXMUXIXTYAUVMYSJUWFVVEJYBYCUVMYDRYEXDXHXOOAYP
      JVVAQUWIUVMVUSVUTVVFVVGXPAYPJMUINZOYPQYHUXHVVHFUBYFWIAYPJYIYGRAYPVVAMUINO
      ACYJRYKYLYMYNYO $.

    $( Selberg's symmetry formula, using the residual of the second Chebyshev
       function.  Equation 10.6.11 of [Shapiro], p. 430.  (Contributed by Mario
       Carneiro, 30-May-2016.) $)
    selberg4r $p |- ( x e. ( 1 (,) +oo ) |-> ( ( ( ( R ` x ) x. ( log ` x ) ) -
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( Lam ` n ) x. sum_ m e. ( 1 ... ( |_ ` ( x / n ) ) )
            ( ( Lam ` m ) x. ( R ` ( ( x / n ) / m ) ) ) ) ) )
        / x ) ) e. O(1) $=
      ( c1 co cmul c2 cdiv csu cmin wcel wtru cr recnd eqtrd adantr remulcld cv
      cpnf cioo cfv clog cfl cfz cvma cmpt co1 cchp caddc wa crp elioore adantl
      wceq 1rp a1i rpred clt eliooord simpld ltled rpgecld pntrval oveq1d chpcl
      wbr syl relogcld subdird ad2antrr cn elfznn nnrpd rpdivcld vmacl nndivred
      oveq2d subdid sumeq2dv mulcld fsumsub fsumrecl fsumcl rplogcld rerpdivcld
      fzfid 2re oveq12d sub4d resubcld rpne0d divsubdird divcan3d divassd nncnd
      fsumdivc nnne0d div12d cc cc0 wne div32d eqtr3d divcld subsub2d mpteq2dva
      3eqtr4d selberg4 2cn rehalfcld eqcomd divcan2d ioossre o1const 2vmadivsum
      2ne0 wss sylancr o1mul2 eqeltrrd o1add2 eqeltrd trud ) AGUBUCHZAUAZBUDZYH
      UEUDZIHZJYJKHZGYHUFUDZUGHZDUAZUHUDZGYHYOKHZUFUDZUGHZCUAZUHUDZYQYTKHZBUDZI
      HZCLZIHZDLZIHZMHZYHKHZUIZUJNOUUKAYGYHUKUDZYJIHZYLYNYPYSUUAUUBUKUDZIHZCLZI
      HZDLZIHZMHZYHKHZYLYNYPYOKHZYSUUAYTKHZCLZIHZDLZIHZYJMHZULHZUIUJOAYGUUJUVIO
      YHYGNZUMZUUJUUTYHYJIHZYLYNYPYSUUAUUBIHZCLZIHZDLZIHZMHZMHZYHKHZUVIUVKUUIUV
      SYHKUVKUUIUUMUVLMHZUUSUVQMHZMHUVSUVKYKUWAUUHUWBMUVKYKUULYHMHZYJIHUWAUVKYI
      UWCYJIUVKYHUNNZYIUWCUQUVKYHGUVJYHPNZOYHGUBUOUPZGUNNUVKURUSZUVKGYHUVKGUWGU
      TUWFUVKGYHVAVIZYHUBVAVIZUVJUWHUWIUMOYHGUBVBUPVCZVDVEZYHBEFVFVJVGUVKUULYHY
      JUVKUULUVKUWEUULPNUWFYHVHVJZQUVKYHUWFQZUVKYJUVKYHUWKVKZQZVLRUVKUUHYLUURUV
      PMHZIHUWBUVKUUGUWPYLIUVKUUGYNUUQUVOMHZDLUWPUVKYNUUFUWQDUVKYOYNNZUMZUUFYPU
      UPUVNMHZIHUWQUWSUUEUWTYPIUWSUUEYSUUOUVMMHZCLUWTUWSYSUUDUXACUWSYTYSNZUMZUU
      DUUAUUNUUBMHZIHUXAUXCUUCUXDUUAIUXCUUBUNNUUCUXDUQUXCYQYTUXCYHYOUVKUWDUWRUX
      BUWKVMUWSYOUNNUXBUWSYOUWRYOVNNZUVKYOYMVOUPZVPSVQUXCYTUXBYTVNNZUWSYTYRVOUP
      ZVPVQUUBBEFVFVJVTUXCUUAUUNUUBUXCUUAUXCUXGUUAPNUXHYTVRVJZQZUXCUUNUXCUUBPNU
      UNPNUXCYQYTUWSYQPNUXBUWSYHYOUVKUWEUWRUWFSUXFVSSZUXHVSZUUBVHVJZQUXCUUBUXLQ
      ZWARWBUWSYSUUOUVMCUWSGYRWIZUXCUUOUXCUUAUUNUXIUXMTZQUXCUUAUUBUXJUXNWCZWDRV
      TUWSYPUUPUVNUWSYPUWSUXEYPPNUXFYOVRVJZQZUWSUUPUWSYSUUOCUXOUXPWEZQUWSYSUVMC
      UXOUXQWFZWARWBUVKYNUUQUVODUVKGYMWIZUWSUUQUWSYPUUPUXRUXTTZQUWSYPUVNUXSUYAW
      CZWDRVTUVKYLUURUVPUVKYLUVKJYJJPNUVKWJUSZUVKYHUWFUWJWGZWHZQZUVKUURUVKYNUUQ
      DUYBUYCWEZQUVKYNUVODUYBUYDWFZWARWKUVKUUMUVLUUSUVQUVKUUMUVKUULYJUWLUWNTZQU
      VKYHYJUWMUWOWCUVKUUSUVKYLUURUYGUYITZQUVKYLUVPUYHUYJWCWLRVGUVKUVTUVAUVRYHK
      HZMHZUVIUVKUUTUVRYHUVKUUTUVKUUMUUSUYKUYLWMZQZUVKUVRUVKUVLUVQUVKYHYJUWFUWN
      TZUVKYLUVPUYGUVKYNUVODUYBUWSYPUVNUXRUWSYSUVMCUXOUXCUUAUUBUXIUXLTZWEZTZWEZ
      TWMQUWMUVKYHUWKWNZWOUVKUYNUVAYJUVGMHZMHUVIUVKUYMVUCUVAMUVKUYMUVLYHKHZUVQY
      HKHZMHVUCUVKUVLUVQYHUVKUVLUYQQUVKYLUVPUYHUVKUVPVUAQZWCUWMVUBWOUVKVUDYJVUE
      UVGMUVKYJYHUWOUWMVUBWPUVKVUEYLUVPYHKHZIHUVGUVKYLUVPYHUYHVUFUWMVUBWQUVKVUG
      UVFYLIUVKVUGYNUVOYHKHZDLUVFUVKYNUVOYHDUYBUWMUWSUVOUYTQVUBWSUVKYNVUHUVEDUW
      SYPUVNYHKHZIHYPUVDYOKHZIHVUHUVEUWSVUIVUJYPIUWSYSUVMYHKHZCLYSUVCYOKHZCLVUI
      VUJUWSYSVUKVULCUXCVUKYHVULIHZYHKHVULUXCUVMVUMYHKUXCYQUVCIHUVMVUMUXCYQUUAY
      TUXCYQUXKQUXJUXCYTUXHWRUXCYTUXHWTXAUXCYHYOUVCUWSYHXBNZUXBUVKVUNUWRUWMSZSZ
      UWSYOXBNUXBUWSYOUXFWRZSUXCUVCUXCUUAYTUXIUXHVSZQZUWSYOXCXDUXBUWSYOUXFWTZSX
      EXFVGUXCVULYHUXCVULUXCUVCYOVURUWSUXEUXBUXFSVSQVUPUWSYHXCXDZUXBUVKVVAUWRVU
      BSZSWPRWBUWSYSUVMYHCUXOVUOUXCUVMUYRQVVBWSUWSYSUVCYOCUXOVUQVUSVUTWSXJVTUWS
      YPUVNYHUXSUWSUVNUYSQVUOVVBWQUWSYPYOUVDUXSVUQUWSUVDUWSYSUVCCUXOVURWEZQVUTX
      EXJWBRVTRWKRVTUVKUVAYJUVGUVKUUTYHUYPUWMVUBXGUWOUVKUVGUVKYLUVFUYGUVKYNUVED
      UYBUWSUVBUVDUWSYPYOUXRUXFVSVVCTWEZTZQXHRRRXIOAYGUVAUVHPUVKUUTYHUYOUWKWHUV
      KUVGYJVVEUWNWMAYGUVAUIUJNOACDXKUSOAYGJUVFYJKHZYJJKHZMHZIHZUIAYGUVHUIUJOAY
      GVVIUVHUVKVVIJVVFIHZJVVGIHZMHUVHUVKJVVFVVGJXBNZUVKXLUSZUVKVVFUVKUVFYJVVDU
      YFWHZQUVKVVGUVKYJUWNXMZQWAUVKVVJUVGVVKYJMUVKUVGVVJUVKJYJUVFVVMUWOUVKUVFVV
      DQUVKYJUYFWNXEXNUVKYJJUWOVVMJXCXDUVKXSUSXOWKRXIOAYGJVVHPUYEUVKVVFVVGVVNVV
      OWMOYGPXTVVLAYGJUIUJNGUBXPVVLOXLUSAYGJXQYAAYGVVHUIUJNOACDXRUSYBYCYDYEYF
      $.

    $( The sum of ~ selberg3r and ~ selberg4r .  (Contributed by Mario
       Carneiro, 31-May-2016.) $)
    selberg34r $p |- ( x e. ( 1 (,) +oo ) |-> ( ( ( ( R ` x ) x. ( log ` x ) )
      - ( sum_ n e. ( 1 ... ( |_ ` x ) )
          ( ( R ` ( x / n ) ) x. ( sum_ m e. { y e. NN | y || n }
            ( ( Lam ` m ) x. ( Lam ` ( n / m ) ) ) -
          ( ( Lam ` n ) x. ( log ` n ) ) ) ) / ( log ` x ) ) )
        / x ) ) e. O(1) $=
      ( c1 co cfv cmul cdiv csu cmin wcel wtru c2 cr remulcld recnd vk cpnf cfl
      cioo cv clog cfz cdivides wbr cn crab cvma cmpt co1 wa 2re a1i crp adantl
      elioore 1rp rpred clt eliooord simpld ltled rpgecld ffvelrni syl relogcld
      pntrf rplogcld rerpdivcld fzfid adantr elfznn nnrpd rpdivcld cfn wss ssfi
      sgmss syl2anc ssrab2 simpr sseldi vmacl dvdsdivcl sylan fsumrecl resubcld
      mulcld subcld 2cn rpne0d cc0 wne 2ne0 divdiv32d divcld divrecd divsubdird
      cc divcan3d rpcnd div32d oveq1d eqtrd oveq12d 3eqtr3d mpteq2dva rehalfcld
      caddc subdid mul12d mulassd eqtr4d oveq2d sumeq2dv fsumsub fsummulc2 wceq
      1re oveq2 fveq2d oveq1 anasss dvdsflsumcom ad2antrr nncnd nnne0d divdiv1d
      adantrr eqcomd mulcomd 3eqtrd subsub3d 2timesd add32d readdcld addsubassd
      divdird selberg3r selberg4r o1add2 eqeltrd ioossre ax-1cn halfcld o1const
      sylancr o1mul2 eqeltrrd trud ) AHUBUDIZAUEZCJZUUPUFJZKIZHUUPUCJZUGIZUUPEU
      EZLIZCJZBUEUVBUHUIZBUJUKZDUEZULJZUVBUVGLIZULJZKIZDMZUVBULJZUVBUFJZKIZNIZK
      IZEMZUURLIZNIZUUPLIZUMZUNOPAUUOQUUSKIZQUURLIZUVRKIZNIZUUPLIZHQLIZKIZUMUWB
      UNPAUUOUWIUWAPUUPUUOOZUOZUWGQLIUWFQLIZUUPLIUWIUWAUWKUWFUUPQUWKUWCUWEUWKUW
      CUWKQUUSQROUWKUPUQZUWKUUQUURUWKUUPUROZUUQROUWKUUPHUWJUUPROPUUPHUBUTUSZHUR
      OUWKVAUQZUWKHUUPUWKHUWPVBUWOUWKHUUPVCUIZUUPUBVCUIZUWJUWQUWRUOPUUPHUBVDUSV
      EZVFVGZURRUUPCCFGVKZVHVIUWKUUPUWTVJSZSZTZUWKUWDUVRUWKUWDUWKQUURUWMUWKUUPU
      WOUWSVLZVMZTZUWKUVRUWKUVAUVQEUWKHUUTVNZUWKUVBUVAOZUOZUVDUVPUXJUVCUROUVDRO
      ZUXJUUPUVBUWKUWNUXIUWTVOUXJUVBUXIUVBUJOZUWKUVBUUTVPUSZVQZVRURRUVCCUXAVHVI
      ZUXJUVLUVOUXJUVFUVKDUXJHUVBUGIZVSOUVFUXPVTZUVFVSOUXJHUVBVNUXJUXLUXQUXMUVB
      BWBVIUXPUVFWAWCZUXJUVGUVFOZUOZUVHUVJUXTUVGUJOZUVHROZUXTUVFUJUVGUVEBUJWDZU
      XJUXSWEWFUVGWGZVIZUXTUVIUJOUVJROZUXTUVFUJUVIUYCUXJUXLUXSUVIUVFOUXMBUVGUVB
      WHWIWFUVIWGVIZSZWJZUXJUVMUVNUXJUXLUVMROUXMUVBWGVIZUXJUVBUXNVJZSWKSWJZTZWL
      ZWMZUWKUUPUWOTZQXCOUWKWNUQZUWKUUPUWTWOZQWPWQUWKWRUQZWSUWKUWGQUWKUWFUUPUYO
      UYPUYRWTUYQUYSXAUWKUWLUVTUUPLUWKUWLUWCQLIZUWEQLIZNIUVTUWKUWCUWEQUXDUYNUYQ
      UYSXBUWKUYTUUSVUAUVSNUWKUUSQUWKUUSUXBTZUYQUYSXDUWKVUAQUVSKIZQLIUVSUWKUWEV
      UCQLUWKQUURUVRUYQUWKUURUXEXEUYMUWKUURUXEWOXFXGUWKUVSQUWKUVSUWKUVRUURUYLUX
      EVMTUYQUYSXDXHXIXHXGXJXKPAUUOUWGUWHRUWKUWFUUPUWKUWCUWEUXCUWKUWDUVRUXFUYLS
      WKUWTVMUWKHHROUWKYCUQXLPAUUOUWGUMAUUOUUSUWDUVAUVMUVDKIZUVNKIZEMZKIZXMIZUU
      PLIZUUSUWDUVAUVHHUUPUVGLIZUCJZUGIZUAUEZULJZVUJVUMLIZCJZKIZUAMZKIZDMZKIZNI
      ZUUPLIZXMIZUMUNPAUUOUWGVVDUWKUWGVUHVVBXMIZUUPLIVVDUWKUWFVVEUUPLUWKUWFUWCV
      UGXMIZVVANIZVUHUUSXMIZVVANIVVEUWKUWFUWCVVAVUGNIZNIVVGUWKUWEVVIUWCNUWKUWEU
      WDVUTVUFNIZKIVVIUWKUVRVVJUWDKUWKUVRUVAUVDUVLKIZVUENIZEMUVAVVKEMZVUFNIVVJU
      WKUVAUVQVVLEUXJUVQVVKUVDUVOKIZNIVVLUXJUVDUVLUVOUXJUVDUXOTZUXJUVLUYITZUXJU
      VMUVNUXJUVMUYJTZUXJUVNUYKTZWLXNUXJVVNVUEVVKNUXJVVNUVMUVDUVNKIKIVUEUXJUVDU
      VMUVNVVOVVQVVRXOUXJUVMUVDUVNVVQVVOVVRXPXQXRXHXSUWKUVAVVKVUEEUXHUXJUVDUVLV
      VOVVPWLUXJVUDUVNUXJUVMUVDVVQVVOWLVVRWLXTUWKVVMVUTVUFNUWKVVMUVAUVFUVDUVKKI
      ZDMZEMUVAVULUUPUVGVUMKIZLIZCJZUVHVWAUVGLIZULJZKIZKIZUAMZDMVUTUWKUVAVVKVVT
      EUXJUVFUVKUVDDUXRVVOUXTUVKUYHTYAXSUWKBUUPVVSVWGUAEDUVBVWAYBZUVDVWCUVKVWFK
      VWIUVCVWBCUVBVWAUUPLYDYEVWIUVJVWEUVHKVWIUVIVWDULUVBVWAUVGLYFYEXRXIUWOUWKU
      XIUXSUOUOZVVSVWJUVDUVKUWKUXIUXKUXSUXOYMVWJUVHUVJUWKUXIUXSUYBUYEYGUWKUXIUX
      SUYFUYGYGSSTYHUWKUVAVWHVUSDUWKUVGUVAOZUOZVWHVULUVHVUQKIZUAMVUSVWLVULVWGVW
      MUAVWLVUMVULOZUOZVWGVUPUVHVUNKIZKIVWPVUPKIVWMVWOVWCVUPVWFVWPKVWOVWBVUOCVW
      OVUOVWBVWOUUPUVGVUMUWKUUPXCOVWKVWNUYPYIVWOUVGVWLUVGUROVWNVWLUVGVWKUYAUWKU
      VGUUTVPUSZVQVOZXEZVWOVUMVWNVUMUJOZVWLVUMVUKVPUSZYJZVWOUVGVWRWOZVWOVUMVXAY
      KYLYNYEVWOVWEVUNUVHKVWOVWDVUMULVWOVUMUVGVXBVWSVXCXDYEXRXIVWOVUPVWPVWOVUPV
      WOVUOUROVUPROVWOVUJVUMVWOUUPUVGUWKUWNVWKVWNUWTYIVWRVRVWOVUMVXAVQVRURRVUOC
      UXAVHVIZTZVWOUVHVUNVWLUVHXCOVWNVWLUVHVWLUYAUYBVWQUYDVIZTZVOZVWOVUNVWOVWTV
      UNROVXAVUMWGVIZTZWLYOVWOUVHVUNVUPVXHVXJVXEXPYPXSVWLVULVUQUVHUAVWLHVUKVNZV
      XGVWOVUQVWOVUNVUPVXIVXDSZTYAXQXSYPXGYPXRUWKUWDVUTVUFUXGUWKVUTUWKUVAVUSDUX
      HVWLUVHVURVXFVWLVULVUQUAVXKVXLWJSWJZTZUWKVUFUWKUVAVUEEUXHUXJVUDUVNUXJUVMU
      VDUYJUXOSUYKSWJZTXNXHXRUWKUWCVVAVUGUXDUWKUWDVUTUXGVXNWLZUWKVUGUWKUWDVUFUX
      FVXOSZTZYQXHUWKVVFVVHVVANUWKVVFUUSUUSXMIZVUGXMIVVHUWKUWCVXSVUGXMUWKUUSVUB
      YRXGUWKUUSVUGUUSVUBVXRVUBYSXQXGUWKVUHUUSVVAUWKVUHUWKUUSVUGUXBVXQYTZTZVUBV
      XPUUAYPXGUWKVUHVVBUUPVYAUWKUUSVVAVUBVXPWMUYPUYRUUBXHXKPAUUOVUIVVCRUWKVUHU
      UPVXTUWTVMUWKVVBUUPUWKUUSVVAUXBUWKUWDVUTUXFVXMSWKUWTVMAUUOVUIUMUNOPACEFGU
      UCUQAUUOVVCUMUNOPACUADFGUUDUQUUEUUFPUUORVTUWHXCOAUUOUWHUMUNOHUBUUGPHHXCOP
      UUHUQUUIAUUOUWHUUJUUKUULUUMUUN $.
  $}

  ${
    $d a c i k m n x y A $.  $d n x y B $.  $d m n x ph $.  $d c k m n x y S $.
    $d c m n x y R $.  $d m n T $.
    pntsval.1 $e |- S = ( a e. RR |-> sum_ i e. ( 1 ... ( |_ ` a ) )
      ( ( Lam ` i ) x. ( ( log ` i ) + ( psi ` ( a / i ) ) ) ) ) $.
    $( Define the "Selberg function", whose asymptotic behavior is the content
       of ~ selberg .  (Contributed by Mario Carneiro, 31-May-2016.) $)
    pntsval $p |- ( A e. RR -> ( S ` A ) = sum_ n e. ( 1 ... ( |_ ` A ) )
      ( ( Lam ` n ) x. ( ( log ` n ) + ( psi ` ( A / n ) ) ) ) ) $=
      ( c1 cv cfl cfv cfz co cvma clog cdiv cchp caddc cmul csu wceq cr oveq12d
      fveq2 oveq2 fveq2d cbvsumv oveq2d wcel oveq1 adantr sumeq12dv sumex fvmpt
      syl5eq ) EAGEHZIJZKLZCHZMJZURNJZUOUROLZPJZQLZRLZCSZGAIJZKLZDHZMJZVHNJZAVH
      OLZPJZQLZRLZDSZUABUOATZVEUQVIVJUOVHOLZPJZQLZRLZDSVOUQVDVTCDURVHTZUSVIVCVS
      RURVHMUCWAUTVJVBVRQURVHNUCWAVAVQPURVHUOOUDUEUBUBUFVPUQVGVTVNDVPUPVFGKUOAI
      UCUGVPVTVNTVHUQUHVPVSVMVIRVPVRVLVJQVPVQVKPUOAVHOUIUEUGUGUJUKUNFVGVNDULUM
      $.

    $( Functionality of the Selberg function.  (Contributed by Mario Carneiro,
       31-May-2016.) $)
    pntsf $p |- S : RR --> RR $=
      ( cr c1 cv cfl cfv cfz co cvma clog cdiv cchp caddc cmul csu wcel syl wa
      fzfid cn elfznn adantl vmacl nnrpd relogcld simpl nndivred chpcl readdcld
      remulcld fsumrecl fmpti ) CEEFCGZHIZJKZBGZLIZUSMIZUPUSNKZOIZPKZQKZBRADUPE
      SZURVEBVFFUQUBVFUSURSZUAZUTVDVHUSUCSZUTESVGVIVFUSUQUDUEZUSUFTVHVAVCVHUSVH
      USVJUGUHVHVBESVCESVHUPUSVFVGUIVJUJVBUKTULUMUNUO $.

    $( Selberg's symmetry formula, using the definition of the Selberg
       function.  (Contributed by Mario Carneiro, 31-May-2016.) $)
    selbergs $p |- ( x e. RR+ |->
      ( ( ( S ` x ) / x ) - ( 2 x. ( log ` x ) ) ) ) e. O(1) $=
      ( vn crp cv cfv cdiv co c2 clog cmul cmin cmpt c1 cfl wcel oveq1d cfz csu
      cvma cchp caddc co1 cr wceq rpre pntsval syl mpteq2ia selberg eqeltri ) A
      GAHZBIZUOJKZLUOMINKZOKZPAGQUORIUAKFHZUCIUTMIUOUTJKUDIUEKNKFUBZUOJKZUROKZP
      UFAGUSVCUOGSZUQVBUROVDUPVAUOJVDUOUGSUPVAUHUOUIUOBCFDEUJUKTTULAFUMUN $.

    $( Selberg's symmetry formula, using the definition of the Selberg
       function.  (Contributed by Mario Carneiro, 31-May-2016.) $)
    selbergsb $p |- E. c e. RR+ A. x e. ( 1 [,) +oo )
      ( abs ` ( ( ( S ` x ) / x ) - ( 2 x. ( log ` x ) ) ) ) <_ c $=
      ( vn cv cfv cdiv co clog cmul cmin cabs cle wbr c1 crp wcel cpnf cico cfl
      c2 wral wrex cfz cvma cchp caddc csu selbergb cr wa wb 1re elicopnf ax-mp
      wceq simplbi pntsval syl oveq1d fveq2d breq1d ralbiia rexbii mpbir ) AHZB
      IZVIJKZUDVILIMKZNKZOIZEHZPQZARUAUBKZUEZESUFRVIUCIUGKGHZUHIVSLIVIVSJKUIIUJ
      KMKGUKZVIJKZVLNKZOIZVOPQZAVQUEZESUFAGEULVRWEESVPWDAVQVIVQTZVNWCVOPWFVMWBO
      WFVKWAVLNWFVJVTVIJWFVIUMTZVJVTUSWFWGRVIPQZRUMTWFWGWHUNUOUPRVIUQURUTVIBCGD
      FVAVBVCVCVDVEVFVGVH $.

    $( The Selberg function can be expressed using the convolution product of
       the von Mangoldt function with itself.  (Contributed by Mario Carneiro,
       31-May-2016.) $)
    pntsval2 $p |- ( A e. RR -> ( S ` A ) = sum_ n e. ( 1 ... ( |_ ` A ) )
      ( ( ( Lam ` n ) x. ( log ` n ) ) + sum_ m e. { y e. NN | y || n }
        ( ( Lam ` m ) x. ( Lam ` ( n / m ) ) ) ) ) $=
      ( vk cr wcel cfv c1 co cvma cmul csu cn syl recnd cfl cfz clog cdiv caddc
      cv cchp cdivides crab pntsval wa elfznn adantl vmacl nnrpd relogcld simpl
      wbr nndivred chpcl adddid sumeq2dv wceq fveq2 oveq2 oveq12d cbvsumv fzfid
      fveq2d fsummulc2 chpval oveq2d nncnd ad2antlr nnne0d divcan3d oveq1 id cc
      3eqtr4d ssrab2 simpr sseldi dvdsdivcl remulcld anasss dvdsflsumcom eqtr4d
      sylan syl5eq mulcld fsumadd cfn wss sgmss ssfi syl2anc fsumrecl 3eqtrd )
      BJKZBCLMBUALZUBNZFUFZOLZXCUCLZBXCUDNZUGLZUENPNZFQXBXDXEPNZXDXGPNZUENZFQZX
      BXIAUFXCUHURZARUIZEUFZOLZXCXOUDNZOLZPNZEQZUENFQZBCDFGHUJWTXBXHXKFWTXCXBKZ
      UKZXDXEXGYCXDYCXCRKZXDJKYBYDWTXCXAULUMZXCUNSTZYCXEYCXCYCXCYEUOUPTZYCXGYCX
      FJKXGJKYCBXCWTYBUQYEUSXFUTSTZVAVBWTXBXIFQZXBXJFQZUENYIXBXTFQZUENXLYAWTYJY
      KYIUEWTYJXBXPBXOUDNZUGLZPNZEQZYKXBXJYNFEXCXOVCZXDXPXGYMPXCXOOVDYPXFYLUGXC
      XOBUDVEVIVFVGWTYOXBMYLUALZUBNZXPXOIUFZPNZXOUDNZOLZPNZIQZEQYKWTXBYNUUDEWTX
      OXBKZUKZXPYRYSOLZIQZPNYRXPUUGPNZIQYNUUDUUFYRUUGXPIUUFMYQVHUUFXPUUFXORKZXP
      JKZUUEUUJWTXOXAULZUMZXOUNZSTUUFYSYRKZUKZUUGUUPYSRKZUUGJKUUOUUQUUFYSYQULUM
      ZYSUNSTVJUUFYMUUHXPPUUFYLJKYMUUHVCUUFBXOWTUUEUQUUMUSYLIVKSVLUUFYRUUCUUIIU
      UPUUBUUGXPPUUPUUAYSOUUPYSXOUUPYSUURVMUUPXOUUEUUJWTUUOUULVNZVMUUPXOUUSVOVP
      VIVLVBVTVBWTABXSUUCIFEXCYTVCZXRUUBXPPUUTXQUUAOXCYTXOUDVQVIVLWTVRWTYBXOXNK
      ZXSVSKYCUVAUKZXSUVBXPXRUVBUUJUUKUVBXNRXOXMARWAZYCUVAWBWCUUNSUVBXQRKXRJKUV
      BXNRXQUVCYCYDUVAXQXNKYEAXOXCWDWIWCXQUNSWEZTWFWGWHWJVLWTXBXIXJFWTMXAVHZYCX
      DXEYFYGWKZYCXDXGYFYHWKWLWTXBXIXTFUVEUVFYCXTYCXNXSEYCMXCUBNZWMKXNUVGWNZXNW
      MKYCMXCVHYCYDUVHYEXCAWOSUVGXNWPWQUVDWRTWLVTWS $.

    pntrlog2bnd.r $e |- R = ( a e. RR+ |-> ( ( psi ` a ) - a ) ) $.
    $( The sum of ~ selberg3r and ~ selberg4r .  (Contributed by Mario
       Carneiro, 31-May-2016.) $)
    pntrlog2bndlem1 $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( ( ( abs ` ( R ` x ) ) x. ( log ` x ) ) -
        ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( abs ` ( R ` ( x / n ) ) ) x.
      ( ( S ` n ) - ( S ` ( n - 1 ) ) ) ) / ( log ` x ) ) )
      / x ) ) e. <_O(1) $=
      ( vy c1 co cfv cabs cmul cdiv wcel cn cr syl recnd vm vk cpnf cioo cv cfl
      clog cfz cmin csu cmpt clo1 wtru cdivides wbr crab 1re a1i co1 selberg34r
      cvma crp elioore adantl 1rp rpred clt eliooord simpld ltled rpgecld pntrf
      wa ffvelrni relogcld remulcld fzfid adantr elfznn nnrpd rpdivcld cfn ssfi
      sgmss syl2anc ssrab2 simpr sseldi vmacl dvdsdivcl sylan fsumrecl resubcld
      wss rplogcld rerpdivcld lo1o12 mpbii abscld nnred pntsf cle mulcld rpne0d
      divcld subcld fsumabs absmuld absge0d abs2dif2d addcld pncan2d cuz elfzuz
      caddc readdcld fveq2 oveq12d breq2 rabbidv oveq1 fveq2d oveq2d sumeq12rdv
      wceq pntsval2 cz flid sumeq1d eqtrd 3eqtr4d vmage0 mulge0d absidd logge0d
      cc0 breqtrrd letrd lediv1dd absdivd fsumm1 nnzd 1z zsubcld addcomd oveq1d
      fsumge0 nnge1d lemul2ad eqbrtrd fsumle lesub2dd abs2difd eqbrtrrd adantrr
      rpge0d lo1le trud ) AJUCUDKZAUEZBLZMLZUUTUGLZNKZJUUTUFLZUHKZUUTEUEZOKZBLZ
      MLZUVGCLZUVGJUIKZCLZUIKZNKZEUJZUVCOKZUIKZUUTOKZUKULPUMAUUSUVAUVCNKZUVFUVI
      IUEZUVGUNUOZIQUPZUAUEZVALZUVGUWDOKZVALZNKZUAUJZUVGVALZUVGUGLZNKZUIKZNKZEU
      JZUVCOKZUIKZUUTOKZMLZUVSJRJRPZUMUQURUMAUUSUWRUKUSPAUUSUWSUKULPAIBUAEFHUTU
      MAUUSUWRUMUUTUUSPZVMZUWRUXBUWQUUTUXBUVTUWPUXBUVAUVCUXBUUTVBPZUVARPUXBUUTJ
      UXAUUTRPUMUUTJUCVCVDZJVBPUXBVEURZUXBJUUTUXBJUXEVFUXDUXBJUUTVGUOZUUTUCVGUO
      ZUXAUXFUXGVMUMUUTJUCVHVDVIZVJZVKZVBRUUTBBFHVLZVNSZUXBUUTUXJVOZVPUXBUWOUVC
      UXBUVFUWNEUXBJUVEVQZUXBUVGUVFPZVMZUVIUWMUXPUVHVBPUVIRPUXPUUTUVGUXBUXCUXOU
      XJVRUXPUVGUXOUVGQPZUXBUVGUVEVSVDZVTZWAVBRUVHBUXKVNSZUXPUWIUWLUXPUWCUWHUAU
      XPJUVGUHKZWBPUWCUYAWNZUWCWBPUXPJUVGVQUXPUXQUYBUXRUVGIWDSUYAUWCWCWEZUXPUWD
      UWCPZVMZUWEUWGUYEUWDQPZUWERPZUYEUWCQUWDUWBIQWFZUXPUYDWGWHZUWDWIZSZUYEUWFQ
      PZUWGRPUYEUWCQUWFUYHUXPUXQUYDUWFUWCPUXRIUWDUVGWJWKWHZUWFWISZVPZWLZUXPUWJU
      WKUXPUXQUWJRPUXRUVGWISZUXPUVGUXSVOZVPZWMZVPZWLZUXBUUTUXDUXHWOZWPWMZUXJWPT
      ZWQWRUXBUWRVUEWSUXBUVRUUTUXBUVDUVQUXBUVBUVCUXBUVAUXBUVAUXLTZWSUXMVPZUXBUV
      PUVCUXBUVFUVOEUXNUXPUVJUVNUXPUVIUXPUVIUXTTZWSZUXPUVKUVMUXPUVGRPZUVKRPUXPU
      VGUXRWTZRRUVGCCDFGXAZVNSUXPUVLRPZUVMRPUXPUVGJVUKUWTUXPUQURWMZRRUVLCVULVNS
      ZWMZVPZWLZVUCWPZWMZUXJWPUMUXAUVSUWSXBUOJUUTXBUOUXBUVSUWQMLZUUTOKZUWSXBUXB
      UVRVVAUUTVUTUXBUWQUXBUVTUWPUXBUVAUVCVUFUXBUVCUXMTZXCZUXBUWOUVCUXBUWOVUBTZ
      VVCUXBUVCVUCXDZXEZXFWSZUXJUXBUVRUVDUWOMLZUVCOKZUIKZVVAVUTUXBUVDVVJVUGUXBV
      VIUVCUXBUWOVVEWSZVUCWPZWMVVHUXBVVJUVQUVDVVMVUSVUGUXBVVIUVPUVCVVLVURVUCUXB
      VVIUVFUWNMLZEUJUVPVVLUXBUVFVVNEUXNUXPUWNUXPUWNVUATZWSZWLVURUXBUVFUWNEUXNV
      VOXGUXBUVFVVNUVOEUXNVVPVUQUXPVVNUVJUWMMLZNKUVOXBUXPUVIUWMVUHUXPUWMUYTTZXH
      UXPVVQUVNUVJUXPUWMVVRWSVUPVUIUXPUVIVUHXIUXPVVQUWIMLZUWLMLZXOKZUVNXBUXPUWI
      UWLUXPUWIUYPTZUXPUWLUYSTZXJUXPUVMUWIUWLXOKZXOKZUVMUIKVWDUVNVWAUXPUVMVWDUX
      PUVMVUOTUXPUWIUWLVWBVWCXKXLUXPUVKVWEUVMUIUXPUYAUBUEZVALZVWFUGLZNKZUWAVWFU
      NUOZIQUPZUWEVWFUWDOKZVALZNKZUAUJZXOKZUBUJZJUVLUHKZVWPUBUJZUWLUWIXOKZXOKUV
      KVWEUXPVWPVWTUBJUVGUXOUVGJXMLPUXBUVGJUVEXNVDUXPVWFUYAPZVMZVWPVXBVWIVWOVXB
      VWGVWHVXBVWFQPZVWGRPVXAVXCUXPVWFUVGVSVDZVWFWISVXBVWFVXBVWFVXDVTVOVPVXBVWK
      VWNUAVXBJVWFUHKZWBPVWKVXEWNZVWKWBPVXBJVWFVQVXBVXCVXFVXDVWFIWDSVXEVWKWCWEV
      XBUWDVWKPZVMZUWEVWMVXHUYFUYGVXHVWKQUWDVWJIQWFZVXBVXGWGWHUYJSVXHVWLQPVWMRP
      VXHVWKQVWLVXIVXBVXCVXGVWLVWKPVXDIUWDVWFWJWKWHVWLWISVPWLXPTVWFUVGYEZVWIUWL
      VWOUWIXOVXJVWGUWJVWHUWKNVWFUVGVAXQVWFUVGUGXQXRVXJVWKUWCVWNUWHUAVXJVWJUWBI
      QVWFUVGUWAUNXSXTVXJVWNUWHYEUYDVXJVWMUWGUWENVXJVWLUWFVAVWFUVGUWDOYAYBYCVRY
      DXRUUAUXPUVKJUVGUFLZUHKZVWPUBUJZVWQUXPVUJUVKVXMYEVUKIUVGCDUAUBFGYFSUXPVXL
      UYAVWPUBUXPVXKUVGJUHUXPUVGYGPVXKUVGYEUXPUVGUXRUUBZUVGYHSYCYIYJUXPUVMVWSVW
      DVWTXOUXPUVMJUVLUFLZUHKZVWPUBUJZVWSUXPVUMUVMVXQYEVUNIUVLCDUAUBFGYFSUXPVXP
      VWRVWPUBUXPVXOUVLJUHUXPUVLYGPVXOUVLYEUXPUVGJVXNJYGPUXPUUCURUUDUVLYHSYCYIY
      JUXPUWIUWLVWBVWCUUEXRYKUUFUXPVVSUWIVVTUWLXOUXPUWIUYPUXPUWCUWHUAUYCUYOUYEU
      WEUWGUYKUYNUYEUYFYPUWEXBUOUYIUWDYLSUYEUYLYPUWGXBUOUYMUWFYLSYMUUGYNUXPUWLU
      YSUXPUWJUWKUYQUYRUXPUXQYPUWJXBUOUXRUVGYLSUXPUVGVUKUXPUVGUXRUUHYOYMYNXRYKY
      QUUIUUJUUKYRYSUULUXBUVTMLZUWPMLZUIKVVKVVAXBUXBVXRUVDVXSVVJUIUXBVXRUVBUVCM
      LZNKUVDUXBUVAUVCVUFVVCXHUXBVXTUVCUVBNUXBUVCUXMUXBUUTUXDUXIYOYNZYCYJUXBVXS
      VVIVXTOKVVJUXBUWOUVCVVEVVCVVFYTUXBVXTUVCVVIOVYAYCYJXRUXBUVTUWPVVDVVGUUMUU
      NYRYSUXBUWSVVAUUTMLZOKVVBUXBUWQUUTUXBUWQVUDTUXBUUTUXDTUXBUUTUXJXDYTUXBVYB
      UUTVVAOUXBUUTUXDUXBUUTUXJUUPYNYCYJYQUUOUUQUUR $.

    ${
      pntrlog2bndlem2.1 $e |- ( ph -> A e. RR+ ) $.
      pntrlog2bndlem2.2 $e |- ( ph ->
        A. y e. RR+ ( psi ` y ) <_ ( A x. y ) ) $.
      $( Lemma for ~ pntrlog2bnd .  Bound on the difference between the Selberg
         function and its approximation, inside a sum.  (Contributed by Mario
         Carneiro, 31-May-2016.) $)
      pntrlog2bndlem2 $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
        ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( n x. ( abs `
          ( ( R ` ( x / ( n + 1 ) ) ) - ( R ` ( x / n ) ) ) ) )
        / ( x x. ( log ` x ) ) ) ) e. O(1) ) $=
        ( c1 co caddc cdiv cmul cr wcel vm cpnf cioo cchp cfv cfl cfz clog cmin
        cv csu cabs 1re a1i cmpt co1 wa elioore adantl chpcl recnd fzfid adantr
        syl elfznn peano2nnd nndivred readdcld fsumrecl clt wbr eliooord mulcld
        crp 1rp rpne0d divdird mpteq2dva rerpdivcld divdiv1d divrecd eqtr3d cc0
        cn o1mul2 eqeltrd cc o1const sylancr ax-1cn o1add2 remulcld cle divge0d
        nnrpd rpge0d addge0d fsumge0 absidd abscld ad2antrr rpdivcld wceq oveq2
        nncnd addcld nnne0d divassd divcld mulid2d oveq2d mulge0d letrd breqtrd
        breqtrrd lediv2ad fsumle lemul2ad mpbird lediv1dd oveq1d eqtr2d eqbrtrd
        eqtr4d leabsd adantrr o1le ffvelrni subcld pntrval oveq12d eqtrd fveq2d
        abssuble0d cneg c2 negsubdi2d 3eqtr2d sumeq12rdv ancli rplogcld rpgecld
        simpld rpcnd ltled mulne0d rpmulcld rprecred ex ssrdv o1res2 divlogrlim
        chpo1ub crli rlimo1 rpred wss ioossre chpge0 rpaddcld relogcld nnrecred
        mp1i wral fveq2 breq12d rspcv sylc leadd1dd adddird 3eqtrd nnred reccld
        fsummulc2 harmonicubnd syl2anc mul32d ledivmul2d dividd 3brtr3d absge0d
        lep1d pntrf resubcld abs2dif2d chpwordi syl3anc addsub4d fsumcl negdi2d
        sub4d cfzo cn0 rprege0d flge0nn0 nn0p1nn 3syl 2re flltp1 ltdivmuld 1lt2
        mulid1d lttrd chpeq0 addid2d divcan2d div1d pncand negeqd fzval3 eqcomd
        wb cz flcld pncan2d cuz nnuz syl6eleq fsumparts mulneg2d fsumneg neg11d
        ) ABNUBUCOZBUJZUDUEZNUYDUFUEZUGOZUYDHUJZNPOZQOZUDUEZUYJPOZHUKZPOZUYDUYD
        UHUEZROZQOZUYGUYHUYJEUEZUYDUYHQOZEUEZUIOZULUEZROZHUKZUYPQOZNSNSTZAUMUNZ
        ABUYCUYQUOBUYCUYEUYPQOZUYMUYPQOZPOZUOUPABUYCUYQVUJAUYDUYCTZUQZUYEUYMUYP
        VULUYEVULUYDSTZUYESTVUKVUMAUYDNUBURUSZUYDUTVDZVAZVULUYMVULUYGUYLHVULNUY
        FVBZVULUYHUYGTZUQZUYKUYJVUSUYJSTZUYKSTVUSUYDUYIVULVUMVURVUNVCZVUSUYHVUR
        UYHWDTVULUYHUYFVEUSZVFZVGZUYJUTVDZVVDVHZVIZVAZVULUYDUYOVULUYDVUNVAZVULU
        YOVULUYDVUNVULNUYDVJVKZUYDUBVJVKZVUKVVJVVKUQAUYDNUBVLUSUUCZUUAZUUDZVMZV
        ULUYDUYOVVIVVNVULUYDVULUYDNVUNNVNTZVULVOUNZVULNUYDVUFVULUMUNZVUNVVLUUEZ
        UUBZVPZVULUYOVVMVPZUUFZVQVRABUYCVUHVUISVULUYEUYPVUOVULUYDUYOVVTVVMUUGZV
        SVULUYMUYPVVGVWDVSZABUYCVUHUOBUYCUYEUYDQOZNUYOQOZROZUOUPABUYCVUHVWHVULV
        WFUYOQOVUHVWHVULUYEUYDUYOVUPVVIVVNVWAVWBVTVULVWFUYOVULVWFVULUYEUYDVUOVV
        TVSZVAVVNVWBWAWBVRABUYCVWFVWGSVWIVULUYOVVMUUHZABUYCVNVWFABUYCVNAVUKUYDV
        NTZVVTUUIUUJBVNVWFUOUPTABUUMUNUUKBUYCVWGUOZWCUUNVKVWLUPTABUULWCVWLUUOUV
        CZWEWFABUYCDNPOZNVWGPOZROZVUINSVUGABUYCVWNVWOSAVWNSTVUKADNADLUUPZVUGVHZ
        VCZVULNVWGVVRVWJVHZAUYCSUUQZVWNWGTZBUYCVWNUOUPTNUBUURZAVWNVWRVAZBUYCVWN
        WHWIABUYCNVWGSVVRVWJAVXANWGTZBUYCNUOUPTVXCVXEAWJUNBUYCNWHWIVWMWKWEVULVW
        NVWOVWSVWTWLZVULVUIVWEVAAVUKVUIULUEZVWPULUEZWMVKNUYDWMVKZVULVXGVUIVXHWM
        VULVUIVWEVULUYMUYPVVGVWDVULUYGUYLHVUQVVFVUSUYKUYJVVEVVDVUSVUTWCUYKWMVKV
        VDUYJUUSVDVUSUYDUYIVVAVUSUYHNVUSUYHVVBWOZVVPVUSVOUNUUTZVUSUYDVULVWKVURV
        VTVCZWPZWNWQWRWNWSVULVUIVWPVXHVWEVXFVULVWPVULVWPVXFVAWTVULUYMUYDQOZUYOQ
        OVWNUYONPOZROZUYOQOZVUIVWPWMVULVXNVXPUYOVULUYMUYDVVGVVTVSVULVWNVXOVWSVU
        LUYONVULUYDVVTUVAVVRVHZWLZVVMVULVXNVXPWMVKUYMVXPUYDROZWMVKVULUYMVWNUYDR
        OZVXOROZVXTWMVULUYMVYAUYGNUYHQOZHUKZROZVYBVVGVULVYAVYDVULVWNUYDVWSVUNWL
        ZVULUYGVYCHVUQVUSUYHVVBUVBZVIZWLVULVYAVXOVYFVXRWLVULUYMUYGVYAVYCROZHUKV
        YEWMVULUYGUYLVYIHVUQVVFVUSVYAVYCVUSVWNUYDVUSDNADSTZVUKVURVWQXAZVUFVUSUM
        UNVHVVAWLZVYGWLVUSUYLVYAUYHQOZVYIWMVUSUYLVYAUYIQOZVYMVVFVUSVYAUYIVYLVVC
        VGVUSVYAUYHVYLVVBVGVUSUYLDUYJROZUYJPOZVYNWMVUSUYKVYOUYJVVEVUSDUYJVYKVVD
        WLVVDVUSUYJVNTZCUJZUDUEZDVYRROZWMVKZCVNUVDZUYKVYOWMVKZVUSUYDUYIVXLVXKXB
        ZAWUBVUKVURMXAWUAWUCCUYJVNVYRUYJXCVYSUYKVYTVYOWMVYRUYJUDUVEVYRUYJDRXDUV
        FUVGUVHUVIVUSVYNVWNUYJROVYONUYJROZPOVYPVUSVWNUYDUYIAVXBVUKVURVXDXAVULUY
        DWGTVURVVIVCZVUSUYHNVUSUYHVVBXEZVXEVUSWJUNZXFZVUSUYIVVCXGZXHVUSDNUYJVUS
        DVYKVAWUHVUSUYDUYIWUFWUIWUJXIZUVJVUSWUEUYJVYOPVUSUYJWUKXJXKUVKXOVUSUYHU
        YIVYAVXJVXKVYLVULWCVYAWMVKVURVULVWNUYDVWSVUNVULDNAVYJVUKVWQVCVVRVULDADV
        NTVUKLVCWPVULNVVQWPWQVULUYDVVTWPXLZVCVUSUYHVUSUYHVVBUVLZUWBZXPXMVUSVYAU
        YHVUSVYAVYLVAWUGVUSUYHVVBXGZWAXNXQVULUYGVYCVYAHVUQVULVYAVYFVAVUSUYHWUGW
        UOUVMUVNXOVULVYDVXOVYAVYHVXRVYFWULVULVUMVXIVYDVXOWMVKVUNVVSUYDHUVOUVPXR
        XMVULVWNUYDVXOAVXBVUKVXDVCZVVIVULVXOVXRVAUVQXNVULUYMVXPUYDVVGVXSVVTUVRX
        SXTVULUYMUYDUYOVVHVVIVVNVWAVWBVTVULVXQVWNVXOUYOQOZROVWPVULVWNVXOUYOWUPV
        ULUYONVVNVXEVULWJUNZXFVVNVWBXHVULVWOWUQVWNRVULWUQUYOUYOQOZVWGPOVWOVULUY
        ONUYOVVNWURVVNVWBVQVULWUSNVWGPVULUYOVVNVWBUVSYAYBXKYDUVTVULVWPVXFYEXMYC
        YFYGWKWFVULUYNUYPVULUYEUYMVUOVVGVHZVWDVSZVULVUEVULVUDUYPVULUYGVUCHVUQVU
        SUYHVUBWUMVUSVUAVUSUYRUYTVUSUYRVUSVYQUYRSTWUDVNSUYJEEIKUWCZYHVDVAVUSUYT
        VUSUYSVNTZUYTSTVUSUYDUYHVXLVXJXBZVNSUYSEWVBYHVDVAYIZWTZWLZVIZVWDVSZVAAV
        UKVUEULUEZUYQULUEZWMVKVXIVULWVJVUEWVKWMVULVUEWVIVULVUDUYPWVHVWDVULUYGVU
        CHVUQWVGVUSUYHVUBWUMWVFVUSUYHVXJWPZVUSVUAWVEUWAXLWRWNWSVULVUEUYQWVKWVIW
        VAVULUYQVULUYNUYPVULUYEUYMVUPVVHXFZVVOVWCXIWTVULVUDUYNUYPWVHWUTVWDVULVU
        DUYGUYHUYSUDUEZUYSPOZUYLUIOZROZHUKZUYNWMVULUYGVUCWVQHVUQWVGVUSUYHWVPWUM
        VUSWVOUYLVUSWVNUYSVUSUYSSTZWVNSTVUSUYDUYHVVAVVBVGZUYSUTVDZWVTVHVVFUWDZW
        LVUSVUBWVPUYHWVFWWBWUMWVLVUSVUBUYKWVNUIOZULUEZUYJUYSUIOZULUEZPOZWVPWMVU
        SVUBWWCWWEUIOZULUEWWGWMVUSVUAWWHULVUSVUAUYKUYJUIOZWVNUYSUIOZUIOWWHVUSUY
        RWWIUYTWWJUIVUSVYQUYRWWIXCWUDUYJEIKYJVDVUSWVCUYTWWJXCWVDUYSEIKYJVDYKVUS
        UYKUYJWVNUYSVUSUYKVVEVAZWUKVUSWVNWWAVAZVUSUYDUYHWUFWUGWUOXIZUWKYLYMVUSW
        WCWWEVUSUYKWVNWWKWWLYIVUSUYJUYSWUKWWMYIUWEYCVUSWWGWVNUYKUIOZUYSUYJUIOZP
        OWVPVUSWWDWWNWWFWWOPVUSUYKWVNVVEWWAVUSVUTWVSUYJUYSWMVKUYKWVNWMVKVVDWVTV
        USUYHUYIUYDVXJVXKVVAVXMWUNXPZUYJUYSUWFUWGYNVUSUYJUYSVVDWVTWWPYNYKVUSWVN
        UYSUYKUYJWWLWWMWWKWUKUWHYDXNXRXQVULWVRUYNVULUYGWVQHVUQVUSUYHWVPWUGVUSWV
        PWWBVAZVMZUWIWVMVULUYNYOZUYGWVQYOZHUKZWVRYOVULWWSUYEYOZUYMUIOUYFNPOZUYD
        WXCQOZUDUEZWXDPOZROZNUYDNQOZUDUEZWXHPOZROZUIOZNWXCUWLOZUYIUYHUIOZUYLROZ
        HUKZUIOZWXAVULUYEUYMVUPVVHUWJVULWXLWXBWXPUYMUIVULWXLUYDUYEUYDPOZUIOWXRU
        YDUIOZYOWXBVULWXGUYDWXKWXRUIVULWXGWXCWXDROUYDVULWXFWXDWXCRVULWXFWCWXDPO
        WXDVULWXEWCWXDPVULWXEWCXCZWXDYPVJVKZVULWXDNYPVULUYDWXCVUNVULVUMWCUYDWMV
        KUQUYFUWMTWXCWDTVULUYDVVTUWNUYDUWOUYFUWPUWQZVGZVVRYPSTVULUWRUNVULWXDNVJ
        VKUYDWXCNROZVJVKVULUYDWXCWYDVJVULVUMUYDWXCVJVKVUNUYDUWSVDVULWXCVULWXCWY
        BXEZUXBXOVULUYDNWXCVUNVVRVULWXCWYBWOUWTXSNYPVJVKVULUXAUNUXCVULWXDSTWXTW
        YAUXLWYCWXDUXDVDXSYAVULWXDVULWXDWYCVAUXEYLXKVULUYDWXCVVIWYEVULWXCWYBXGU
        XFYLVULWXKNWXRROWXRVULWXJWXRNRVULWXIUYEWXHUYDPVULWXHUYDUDVULUYDVVIUXGZY
        MWYFYKXKVULWXRVULWXRVULUYEUYDVUOVUNVHVAZXJYLYKVULWXRUYDWYGVVIYQVULWXSUY
        EVULUYEUYDVUPVVIUXHUXIYRVULWXMUYGWXOUYLHVULUYGWXMVULUYFUXMTUYGWXMXCVULU
        YDVUNUXNNUYFUXJVDUXKZVUSWXONUYLROUYLVUSWXNNUYLRVUSUYHNWUGWUHUXOYAVUSUYL
        VUSUYLVVFVAXJYLYSYKVULWXMUYHUYLWVOUIOZROZHUKWXQWXAVULUAUJZUYHUYINHUAWXC
        NWXCUYDWYKQOZUDUEZWYLPOZWVOUYLWXJWXFWYKUYHXCZWYNWVOXCWYOWYMWVNWYLUYSPWY
        OWYLUYSUDWYKUYHUYDQXDZYMWYPYKYTWYKUYIXCZWYNUYLXCWYQWYMUYKWYLUYJPWYQWYLU
        YJUDWYKUYIUYDQXDZYMWYRYKYTWYKNXCZWYNWXJXCWYSWYMWXIWYLWXHPWYSWYLWXHUDWYK
        NUYDQXDZYMWYTYKYTWYKWXCXCZWYNWXFXCXUAWYMWXEWYLWXDPXUAWYLWXDUDWYKWXCUYDQ
        XDZYMXUBYKYTVULWXCWDNUXPUEWYBUXQUXRVULWYKNWXCUGOTZUQZWYKXUCWYKWDTVULWYK
        WXCVEUSZXEXUDWYNXUDWYMWYLXUDWYLSTWYMSTXUDUYDWYKVULVUMXUCVUNVCXUEVGZWYLU
        TVDXUFVHVAUXSVULWXMUYGWYJWWTHWYHVUSUYHWVPYOZROWYJWWTVUSXUGWYIUYHRVUSWVO
        UYLVUSWVNUYSWWLWWMXFVUSUYKUYJWWKWUKXFYQXKVUSUYHWVPWUGWWQUXTWBYSWBYRVULU
        YGWVQHVUQWWRUYAYBUYBXNXTVULUYQWVAYEXMYCYFYG $.
    $}

    ${
      pntrlog2bndlem3.1 $e |- ( ph -> A e. RR+ ) $.
      pntrlog2bndlem3.2 $e |- ( ph -> A. y e. ( 1 [,) +oo )
      ( abs ` ( ( ( S ` y ) / y ) - ( 2 x. ( log ` y ) ) ) ) <_ A ) $.
      $( Lemma for ~ pntrlog2bnd .  Bound on the difference between the Selberg
         function and its approximation, inside a sum.  (Contributed by Mario
         Carneiro, 31-May-2016.) $)
      pntrlog2bndlem3 $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
        ( sum_ n e. ( 1 ... ( |_ ` x ) ) ( ( ( abs ` ( R ` ( x / n ) ) ) -
            ( abs ` ( R ` ( x / ( n + 1 ) ) ) ) ) x.
              ( ( S ` n ) - ( 2 x. ( n x. ( log ` n ) ) ) ) )
        / ( x x. ( log ` x ) ) ) ) e. O(1) ) $=
        ( c1 co cfv cabs cmul cr wcel vc cpnf cioo cfl cfz caddc cdiv cmin clog
        cv csu c2 1re a1i rpred adantr wa fzfid elfznn adantl nnred crp elioore
        1rp clt wbr eliooord simpld ltled rpgecld nnrpd rpaddcld rpdivcld pntrf
        cn ffvelrni syl recnd subcld abscld remulcld fsumrecl rplogcld rpmulcld
        rerpdivcld wss cc cmpt co1 ioossre rpcnd o1const sylancr cchp wral wrex
        cle chpo1ubb simpl simpr pntrlog2bndlem2 rexlimiva mp1i o1mul2 resubcld
        pntsf 2re fsumabs absge0d abs2difabsd abssubd breqtrd nnne0d divcld 2cn
        mulcld absmuld subdird mul32d mulassd eqtr3d eqtrd fveq2d rpge0d absidd
        relogcld divcan1d oveq12d oveq2d 3eqtr3d nnge1d elicopnf ax-mp sylanbrc
        cico wb ad2antrr weq fveq2 letrd id breq1d rspcv sylc eqbrtrd lemul12ad
        lemul1ad mulcomd 3brtr4d fsumle breqtrrd lediv1dd rpne0d absdivd eqtr2d
        fsummulc2 divassd 3brtr3d leabsd adantrr o1le ) ABNUBUCOZDNBUJZUDPZUEOZ
        HUJZUVCUVFNUFOZUGOZEPZUVCUVFUGOZEPZUHOZQPZROZHUKZUVCUVCUIPZROZUGOZROZUV
        EUVKQPZUVIQPZUHOZUVFFPZULUVFUVFUIPZROZROZUHOZROZHUKZUVQUGOZNSNSTZAUMUNA
        BUVBDUVRSADSTZUVCUVBTZADLUOUPZAUWMUQZUVOUVQUWOUVEUVNHUWONUVDURZUWOUVFUV
        ETZUQZUVFUVMUWRUVFUWQUVFVOTUWOUVFUVDUSUTZVAZUWRUVLUWRUVIUVKUWRUVIUWRUVH
        VBTUVISTUWRUVCUVGUWOUVCVBTUWQUWOUVCNUWMUVCSTAUVCNUBVCUTZNVBTZUWOVDUNZUW
        ONUVCUWONUXCUOUXAUWONUVCVEVFZUVCUBVEVFZUWMUXDUXEUQAUVCNUBVGUTVHZVIVJZUP
        ZUWRUVFNUWRUVFUWSVKZUXBUWRVDUNVLVMVBSUVHEEIKVNZVPVQVRZUWRUVKUWRUVJVBTUV
        KSTUWRUVCUVFUXHUXIVMVBSUVJEUXJVPVQVRZVSVTZWAZWBZUWOUVCUVPUXGUWOUVCUXAUX
        FWCWDZWEZAUVBSWFDWGTZBUVBDWHWITNUBWJADLWKZBUVBDWLWMCUJZWNPUAUJZUXTROWQV
        FCVBWOZUAVBWPBUVBUVRWHWITZACUAWRUYBUYCUAVBUYAVBTZUYBUQBCUYAEFGHIJKUYDUY
        BWSUYDUYBWTXAXBXCXDUWODUVRUWNUXQWAZUWOUWJUWOUWIUVQUWOUVEUWHHUWPUWRUWBUW
        GUWRUVTUWAUWRUVKUXLVTUWRUVIUXKVTXEZUWRUWCUWFUWRUVFSTZUWCSTUWTSSUVFFFGIJ
        XFVPVQZUWRULUWEULSTUWRXGUNZUWRUVFUWDUWTUWRUVFUXIYFZWAWAXEZWAZWBZUXPWEVR
        ZAUWMUWJQPZUVSQPZWQVFNUVCWQVFUWOUYOUVSUYPUWOUWJUYNVTUYEUWOUVSUWOUVSUYEV
        RVTUWOUWIQPZUVQUGOZDUVOROZUVQUGOUYOUVSWQUWOUYQUYSUVQUWOUWIUWOUWIUYMVRZV
        TZUWODUVOUWNUXOWAZUXPUWOUYQUVEUWHQPZHUKZUYSVUAUWOUVEVUCHUWPUWRUWHUWRUWH
        UYLVRZVTZWBVUBUWOUVEUWHHUWPVUEXHUWOVUDUVEDUVNROZHUKUYSWQUWOUVEVUCVUGHUW
        PVUFUWRDUVNUWOUWLUWQUWNUPZUXNWAUWRUWBQPZUWGQPZROUVMDUVFROZROZVUCVUGWQUW
        RVUIUVMVUJVUKUWRUWBUWRUWBUYFVRZVTUXMUWRUWGUWRUWGUYKVRZVTUWRDUVFVUHUWTWA
        UWRUWBVUMXIUWRUWGVUNXIUWRVUIUVKUVIUHOQPUVMWQUWRUVKUVIUXLUXKXJUWRUVKUVIU
        XLUXKXKXLUWRVUJUWCUVFUGOZULUWDROZUHOZQPZUVFROZVUKWQUWRVUQUVFROZQPVURUVF
        QPZROVUJVUSUWRVUQUVFUWRVUOVUPUWRUWCUVFUWRUWCUYHVRZUWRUVFUWTVRZUWRUVFUWS
        XMZXNZUWRULUWDULWGTUWRXOUNUWRUWDUYJVRZXPZVSZVVCXQUWRVUTUWGQUWRVUTVUOUVF
        ROZVUPUVFROZUHOUWGUWRVUOVUPUVFVVEVVGVVCXRUWRVVIUWCVVJUWFUHUWRUWCUVFVVBV
        VCVVDYGUWRULUVFROUWDROVVJUWFUWRULUVFUWDUWRULUYIVRZVVCVVFXSUWRULUVFUWDVV
        KVVCVVFXTYAYHYBYCUWRVVAUVFVURRUWRUVFUWTUWRUVFUXIYDZYEYIYJUWRVURDUVFUWRV
        UQVVHVTVUHUWTVVLUWRUVFNUBYOOZTZUXTFPZUXTUGOZULUXTUIPZROZUHOZQPZDWQVFZCV
        VMWOZVURDWQVFZUWRUYGNUVFWQVFZVVNUWTUWRUVFUWSYKUWKVVNUYGVWDUQYPUMNUVFYLY
        MYNAVWBUWMUWQMYQVWAVWCCUVFVVMCHYRZVVTVURDWQVWEVVSVUQQVWEVVPVUOVVRVUPUHV
        WEVVOUWCUXTUVFUGUXTUVFFYSVWEUUAYHVWEVVQUWDULRUXTUVFUIYSYIYHYCUUBUUCUUDU
        UGUUEUUFUWRUWBUWGVUMVUNXQUWRVUKUVMROVUGVULUWRDUVFUVMAUXRUWMUWQUXSYQZVVC
        UWRUVMUXMVRZXTUWRVUKUVMUWRDUVFVWFVVCXPVWGUUHYAUUIUUJUWOUVEUVNDHUWPAUXRU
        WMUXSUPZUWRUVNUXNVRUUPUUKYTUULUWOUYOUYQUVQQPZUGOUYRUWOUWIUVQUYTUWOUVQUX
        PWKZUWOUVQUXPUUMZUUNUWOVWIUVQUYQUGUWOUVQUWOUVQUXPUOUWOUVQUXPYDYEYIUUOUW
        ODUVOUVQVWHUWOUVOUXOVRVWJVWKUUQUURUWOUVSUYEUUSYTUUTUVA $.
    $}

    pntrlog2bnd.t $e |- T = ( a e. RR |->
      if ( a e. RR+ , ( a x. ( log ` a ) ) , 0 ) ) $.
    $( Lemma for ~ pntrlog2bnd .  Bound on the difference between the Selberg
       function and its approximation, inside a sum.  (Contributed by Mario
       Carneiro, 31-May-2016.) $)
    pntrlog2bndlem4 $p |- ( x e. ( 1 (,) +oo ) |->
    ( ( ( ( abs ` ( R ` x ) ) x. ( log ` x ) ) -
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
        ( ( abs ` ( R ` ( x / n ) ) ) x.
          ( ( T ` n ) - ( T ` ( n - 1 ) ) ) ) ) ) / x ) ) e. <_O(1) $=
      ( c1 co cfv cmul c2 cmin wcel wtru cc0 cr vy vm vc cpnf cv cabs clog cdiv
      cfl cfz csu cmpt clo1 caddc cneg cchp crp wceq adantl 1rp a1i 1re clt wbr
      wa ltled cn cle syl nnrpd rpdivcld 2re nncnd breqtrrd mpbird oveq1d eqtrd
      fveq2d rpge0d recnd subid1d cvma pntsval2 cc ax-1cn pncand oveq2d sumeq1d
      0re eqtr4d 3eqtr4d oveq12d ffvelrni eqeltrd abscld cif remulcld cz eqcomd
      resubcld adantr elfznn rpre eleq1 id fveq2 eqidd ifbieq12d ovex c0ex ifex
      fvmpt iftrue nnred relogcld sumeq12rdv oveq2 oveq1 subidi syl6eq c0 ax-mp
      weq jca subdid eqtr3d 3eqtr3rd fsumrecl rpne0d divdiv1d rerpdivcld mulcld
      2cn divdird 3eqtr3d divsubdird mpteq2dva adantrr ello1d co1 cioo eliooord
      cfzo elioore simpld rpgecld cn0 rprege0d flge0nn0 nn0p1nn nndivred flltp1
      pntrval mulid1d ltdivmuld 1lt2 lttrd wb chpeq0 abssuble0d 3eqtrd cdivides
      crab nn0red nn0cnd flidm div1d pntrf mul01d relogcl remulcl sylan2 ifclda
      pntsf wn fmpti flcld fzval3 rpaddcld negsubdi2d mulneg1d fzfid fsumneg 0z
      flid fz10 sum0 rpne0 necon2bi iffalse mul01i 0cn cuz nnuz fsumparts sub4d
      syl6eleq fsumcl subnegd mulcomd rplogcld divcld subcld fsummulc2 sumeq2dv
      subsubd nncand fsumsub 3eqtr2rd 3eqtr2d readdcld rpmulcld pntrlog2bndlem1
      mul12d div23d rpcnd divassd wss ioossre o1const sylancr divcan4d ex ssrdv
      divrecd selbergs o1res2 crli divlogrlim rlimo1 mp1i o1dif flge1nn syl2anc
      o1mul2 2rp nn0ge0d nnge1d logge0d logled mpbid lemul12ad eqbrtrd lemul2ad
      flle mulge0d divge0d o1lo12 o1sub2 o1lo1d lo1mul cico wral wrex selbergsb
      ledivmul2d simpl simpr pntrlog2bndlem3 rexlimiva lo1add eqeltrrd trud ) A
      KUDUUALZAUEZBMZUFMZVVEUGMZNLZOVVHUHLKVVEUIMZUJLZVVEFUEZUHLZBMZUFMZVVLDMZV
      VLKPLZDMZPLZNLZFUKZNLZPLZVVEUHLZULZUMQRAVVDVVIVVKVVOVVLCMZVVQCMZPLZNLZFUK
      ZVVHUHLZPLZVVEUHLZVVEVVJKUNLZUHLZVVECMZOVVJDMZNLZPLZNLZVVKVVOVVEVVLKUNLZU
      HLZBMZUFMZPLZVWFOVVLVVLUGMZNLZNLZPLZNLZFUKZUNLZVVEVVHNLZUHLZUNLZULVWEUMRA
      VVDVXOVWDRVVEVVDQZVEZVXOVWMVVKVVOVWHOVVSNLZPLZNLZFUKZVVHUHLZVVEUHLZUNLVWL
      VYBUNLZVVEUHLVWDVXQVXNVYCVWMUNVXQVXNVYAVVHVVENLZUHLVYCVXQVXLVYAVXMVYEUHVX
      QVWOBMZUFMZVWNKPLZCMZOVYHDMZNLZPLZNLZVVEKUHLZBMZUFMZSNLZPLZKVWNUUCLZVXDVV
      OPLZVXAKPLZCMZOWUADMZNLZPLZNLZFUKZPLZVWTVXKUOZPLVYAVXLVXQVYRVWTWUGWUIPVXQ
      VYRVWTSPLVWTVXQVYMVWTVYQSPVXQVYGVWOVYLVWSNVXQVYGSVWOPLZUFMVWOSPLVWOVXQVYF
      WUJUFVXQVYFVWOUPMZVWOPLZWUJVXQVWOUQQVYFWULURVXQVVEVWNVXQVVEKVXPVVETQZRVVE
      KUDUUDUSZKUQQZVXQUTVAVXQKVVEKTQZVXQVBVAZWUNVXQKVVEVCVDZVVEUDVCVDZVXPWURWU
      SVERVVEKUDUUBUSUUEZVFZUUFZVXQVWNVXQVVJUUGQZVWNVGQVXQWUMSVVEVHVDVEWVCVXQVV
      EWVBUUHVVEUUIVIZVVJUUJVIZVJZVKZVWOBGIUUMVIVXQWUKSVWOPVXQWUKSURZVWOOVCVDZV
      XQVWOKOVXQVVEVWNWUNWVEUUKZWUQOTQZVXQVLVAZVXQVWOKVCVDVVEVWNKNLZVCVDVXQVVEV
      WNWVMVCVXQWUMVVEVWNVCVDWUNVVEUULVIVXQVWNVXQVWNWVEVMUUNVNVXQVVEKVWNWUNWUQW
      VFUUOVOZKOVCVDVXQUUPVAUUQVXQVWOTQWVHWVIUURWVJVWOUUSVIVOVPVQVRVXQSVWOSTQZV
      XQWIVAWVJVXQVWOWVGVSZUUTVXQVWOVXQVWOWVJVTZWAUVAVXQVYIVWPVYKVWRPVXQVVJCMZK
      VVJUIMZUJLZVVLWBMVXFNLUAUEZVVLUVBVDUAVGUVCUBUEZWBMVVLWWBUHLWBMNLUBUKUNLZF
      UKZVYIVWPVXQVVJTQZWVRWWDURVXQVVJWVDUVDZUAVVJCEUBFGHWCVIVXQVYHVVJCVXQVVJKV
      XQVVJWVDUVEKWDQZVXQWEVAWFZVRVXQVWPVVKWWCFUKZWWDVXQWUMVWPWWIURWUNUAVVECEUB
      FGHWCVIVXQWVTVVKWWCFVXQWVSVVJKUJVXQWUMWVSVVJURWUNVVEUVFVIWGWHWJWKVXQVYJVW
      QONVXQVYHVVJDWWHVRWGWLWLVXQVYPVXQVYPVXQVYOVXQVYOVXQVYOVVFTVXQVYNVVEBVXQVV
      EVXQVVEWUNVTZUVGVRVXQVVEUQQZVVFTQWVBUQTVVEBBGIUVHZWMVIZWNVTWOVTUVIWLVXQVW
      TVXQVWTVXQVWOVWSWVJVXQVWPVWRVXQWUMVWPTQWUNTTVVECCEGHUVNZWMVIZVXQOVWQWVLVX
      QWWEVWQTQWWFTTVVJDGTTGUEZUQQZWWPWWPUGMZNLZSWPZDJWWPTQZWWQWWSSTWWQWXAWWRTQ
      WWSTQWWPUVJWWPWWRUVKUVLWVOWXAWWQUVOZVEWIVAUVMUVPZWMVIZWQZWTZWQZVTZWAVQVXQ
      WUGVVKVXJUOZFUKWUIVXQVYSVVKWUFWXIFVXQVVKVYSVXQVVJWRQVVKVYSURVXQVVEWUNUVQK
      VVJUVRVIWSZVXQVVLVVKQZVEZWUFVXEUOZVXINLWXIWXLVYTWXMWUEVXINWXLWXMVYTWXLVVO
      VXDWXLVVOWXLVVNWXLVVNWXLVVMUQQVVNTQWXLVVEVVLVXQWWKWXKWVBXAZWXLVVLWXKVVLVG
      QVXQVVLVVJXBUSZVJZVKUQTVVMBWWLWMVIVTWOZVTZWXLVXDWXLVXCWXLVXCWXLVXBUQQVXCT
      QWXLVVEVXAWXNWXLVVLKWXPWUOWXLUTVAUVSVKUQTVXBBWWLWMVIVTWOZVTUVTWSWXLWUBVWF
      WUDVXHPWXLWUAVVLCWXLVVLKWXLVVLWXOVMWWGWXLWEVAWFZVRZWXLWUCVXGONWXLWUCVVPVX
      GWXLWUAVVLDWXTVRZWXLVVLUQQZVVPVXGURWXPWYCVVPWYCVXGSWPZVXGWYCVVLTQZVVPWYDU
      RVVLXCGVVLWWTWYDTDGFYCZWWQWYCWWSSVXGSWWPVVLUQXDWYFWWPVVLWWRVXFNWYFXEWWPVV
      LUGXFWLWYFSXGXHJWYCVXGSVVLVXFNXIXJXKXLVIWYCVXGSXMVQVIVQWGWLWLWXLVXEVXIWXL
      VXEWXLVVOVXDWXQWXSWTZVTWXLVXIWXLVWFVXHWXLWYEVWFTQWXLVVLWXOXNZTTVVLCWWNWMV
      IZWXLOVXGWVKWXLVLVAZWXLVVLVXFWYHWXLVVLWXPXOWQWQWTZVTUWAVQXPVXQVVKVXJFVXQK
      VVJUWBZWXLVXJWXLVXEVXIWYGWYKWQZVTZUWCVQWLVXQVYSVVOWUEVWGOVVRNLZPLZPLZNLZF
      UKWUHVYAVXQVVEWWBUHLZBMZUFMZVVOVXDVYPFUBVYGKVWNWWBKPLZCMZOXUBDMZNLZPLZWYP
      WUESVYLUBFYCZXUAVVOURXUFWYPURXUGWYTVVNUFXUGWYSVVMBWWBVVLVVEUHXQVRVRXUGXUC
      VWGXUEWYOPXUGXUBVVQCWWBVVLKPXRZVRXUGXUDVVRONXUGXUBVVQDXUHVRWGWLYDWWBVXAUR
      ZXUAVXDURXUFWUEURXUIWYTVXCUFXUIWYSVXBBWWBVXAVVEUHXQVRVRXUIXUCWUBXUEWUDPXU
      IXUBWUACWWBVXAKPXRZVRXUIXUDWUCONXUIXUBWUADXUJVRWGWLYDWWBKURZXUAVYPURXUFSU
      RXUKWYTVYOUFXUKWYSVYNBWWBKVVEUHXQVRVRXUKXUFSSPLSXUKXUCSXUESPXUKXUCSCMZSXU
      KXUBSCXUKXUBKKPLSWWBKKPXRKWEXSXTZVRWVOXULSURWIGSKWWPUIMZUJLZEUEZWBMXUPUGM
      WWPXUPUHLUPMUNLNLZEUKZSTCWWPSURZXURYAXUQEUKSXUSXUOYAXUQEXUSXUOKSUJLYAXUSX
      UNSKUJXUSXUNSUIMZSWWPSUIXFSWRQXUTSURUWDSUWEYBXTWGUWFXTWHXUQEUWGXTHXJXLYBX
      TXUKXUEOSNLSXUKXUDSONXUKXUDSDMZSXUKXUBSDXUMVRWVOXVASURWIGSWWTSTDXUSWXBWWT
      SURWWQWWPSWWPUWHUWIWWQWWSSUWJVIJXJXLYBXTWGOYMUWKXTWLSUWLXSXTYDWWBVWNURZXU
      AVYGURXUFVYLURXVBWYTVYFUFXVBWYSVWOBWWBVWNVVEUHXQVRVRXVBXUCVYIXUEVYKPXVBXU
      BVYHCWWBVWNKPXRZVRXVBXUDVYJONXVBXUBVYHDXVCVRWGWLYDVXQVWNVGKUWMMWVEUWNUWQV
      XQWWBKVWNUJLQZVEZXUAXVEWYTXVEWYTXVEWYSUQQWYTTQXVEVVEWWBVXQWWKXVDWVBXAXVEW
      WBXVDWWBVGQVXQWWBVWNXBUSZVJVKUQTWYSBWWLWMVIVTWOVTXVEXUFXVEXUCXUEXVEXUBTQZ
      XUCTQXVEWWBKXVEWWBXVFXNWUPXVEVBVAWTZTTXUBCWWNWMVIXVEOXUDWVKXVEVLVAXVEXVGX
      UDTQXVHTTXUBDWXCWMVIWQWTVTUWOVXQVYSVVKWYRVXTFWXJWXLWYQVXSVVONWXLVWFOVVPNL
      ZPLZWYPPLVWHXVIWYOPLZPLWYQVXSWXLVWFXVIVWGWYOWXLVWFWYIVTWXLXVIWXLOVVPWYJWX
      LWYEVVPTQWYHTTVVLDWXCWMVIZWQVTWXLVWGWXLVVQTQZVWGTQWXLVVLKWYHWUPWXLVBVAWTZ
      TTVVQCWWNWMVIZVTWXLWYOWXLOVVRWYJWXLXVMVVRTQXVNTTVVQDWXCWMVIZWQVTUWPWXLWUE
      XVJWYPPWXLWUBVWFWUDXVIPWYAWXLWUCVVPONWYBWGWLVPWXLVXRXVKVWHPWXLOVVPVVROWDQ
      ZWXLYMVAZWXLVVPXVLVTZWXLVVRXVPVTZYEWGWKWGXPYFVXQVWTVXKWXHVXQVVKVXJFWYLWYN
      UWRZUWSYGVXQVVEVVHWWJVXQVVHVXQVVEWVBXOZVTZUWTWLVXQVYAVVHVVEVXQVYAVXQVVKVX
      TFWYLWXLVVOVXSWXQWXLVWHVXRWXLVWFVWGWYIXVOWTZWXLOVVSWYJWXLVVPVVRXVLXVPWTZW
      QWTZWQZYHVTZXWCWWJVXQVVHVXQVVEWUNWUTUXAZYIZVXQVVEWVBYIZYJWJWGVXQVWLVYBVVE
      VXQVWLVXQVVIVWKVXQVVGVVHVXQVVFVXQVVFWWMVTWOXWBWQZVXQVWJVVHVXQVVKVWIFWYLWX
      LVVOVWHWXQXWDWQZYHZXWIYKZWTZVTVXQVYAVVHXWHXWCXWJUXBZWWJXWKYNVXQVYDVWCVVEU
      HVXQVVIVWKVYBPLZPLVYDVWCVXQVVIVWKVYBVXQVVIXWLVTVXQVWKXWOVTXWQUXFVXQXWRVWB
      VVIPVXQVWJVYAPLZVVHUHLOVWANLZVVHUHLXWRVWBVXQXWSXWTVVHUHVXQXWTVVKOVVTNLZFU
      KVVKVWIVXTPLZFUKXWSVXQVVKVVTOFWYLXVQVXQYMVAZWXLVVOVVSWXRWXLVVPVVRXVSXVTUX
      CZYLUXDVXQVVKXXBXXAFWXLVVOVWHVXSPLZNLVVOVXRNLXXBXXAWXLXXEVXRVVONWXLVWHVXR
      WXLVWHXWDVTZWXLOVVSXVRXXDYLUXGWGWXLVVOVWHVXSWXRXXFWXLVXSXWFVTYEWXLVVOOVVS
      WXRXVRXXDUXNYOUXEVXQVVKVWIVXTFWYLWXLVWIXWMVTWXLVXTXWGVTUXHUXIVPVXQVWJVYAV
      VHVXQVWJXWNVTXWHXWCXWJYPVXQOVWAVVHXXCVXQVWAVXQVVKVVTFWYLWXLVVOVVSWXQXWEWQ
      YHVTXWCXWJUXOYOWGYFVPUXJYQRAVVDVWMVXNTVXQVWLVVEXWPWVBYKVXQVXLVXMVXQVWTVXK
      WXGVXQVVKVXJFWYLWYMYHZUXKVXQVVEVVHWVBXWIUXLZYKAVVDVWMULUMQRABCEFGHIUXMVAR
      AVVDVXNULAVVDVWOVWSVXMUHLZNLZVXKVXMUHLZUNLZULUMRAVVDVXNXXLVXQVXNVWTVXMUHL
      ZXXKUNLXXLVXQVWTVXKVXMWXHXWAVXQVXMXXHUXPZVXQVXMXXHYIZYNVXQXXMXXJXXKUNVXQV
      WOVWSVXMWVQVXQVWSWXFVTXXNXXOUXQVPVQYQRAVVDXXJXXKTVXQVWOXXIWVJVXQVWSVXMWXF
      XXHYKZWQVXQVXKVXMXXGXXHYKZRAVVDVWOXXITWVJXXPRAVVDVWOKKVVDTUXRZRKUDUXSZVAZ
      WVJWUPRVBVAZXYARVXPVWOKVHVDKVVEVHVDZVXQVWOKWVJWUQWVNVFYRYSRAVVDXXIXXPRAVV
      DXXIULAVVDVWPVXMUHLZVWRVXMUHLZPLZULYTRAVVDXXIXYEVXQVWPVWRVXMVXQVWPWWOVTZV
      XQVWRWXEVTXXNXXOYPYQRAVVDXYCXYDTVXQVWPVXMWWOXXHYKZVXQVWRVXMWXEXXHYKZRAVVD
      XYCULYTQAVVDOULYTQZRXXRXVQXYIXXSXVQRYMVAAVVDOUXTUYARAVVDXYCOVXQXYCXYGVTXX
      CRAVVDXYCOPLZULAVVDVWPVVEUHLZOVVHNLZPLZKVVHUHLZNLZULYTRAVVDXYJXYOVXQXYMVV
      HUHLXYKVVHUHLZXYLVVHUHLZPLXYOXYJVXQXYKXYLVVHVXQXYKVXQVWPVVEWWOWVBYKZVTVXQ
      OVVHXXCXWCYLXWCXWJYPVXQXYMVVHVXQXYMVXQXYKXYLXYRVXQOVVHWVLXWBWQWTZVTXWCXWJ
      UYEVXQXYPXYCXYQOPVXQVWPVVEVVHXYFWWJXWCXWKXWJYJVXQOVVHXXCXWCXWJUYBWLYGYQRA
      VVDXYMXYNTXYSVXQKVVHWUQXWIYKRAVVDUQXYMRAVVDUQRVXPWWKWVBUYCUYDAUQXYMULYTQR
      ACEGHUYFVAUYGAVVDXYNULZSUYHVDXYTYTQRAUYISXYTUYJUYKUYOWNUYLVORAVVDXYDULZYT
      QYUAUMQRAVVDXYDKOXXTXYHXYAWVKRVLVARVXPXYDOVHVDZXYBVXQYUBVWROVXMNLVHVDVXQV
      WQVXMOWXDVXQVVEVVHWUNXWBWQWVLVXQOOUQQVXQUYPVAVSZVXQVWQVVJVVJUGMZNLZVXMVHV
      XQVVJUQQZVWQYUEURVXQVVJVXQWUMXYBVVJVGQWUNWVAVVEUYMUYNZVJZYUFVWQYUFYUESWPZ
      YUEYUFWWEVWQYUIURVVJXCGVVJWWTYUITDWWPVVJURZWWQYUFWWSSYUESWWPVVJUQXDYUJWWP
      VVJWWRYUDNYUJXEWWPVVJUGXFWLYUJSXGXHJYUFYUESVVJYUDNXIXJXKXLVIYUFYUESXMVQVI
      ZVXQVVJVVEYUDVVHWWFWUNVXQVVJYUHXOZXWBVXQVVJWVDUYQZVXQVVJWWFVXQVVJYUGUYRUY
      SZVXQWUMVVJVVEVHVDZWUNVVEVUEVIZVXQYUOYUDVVHVHVDYUPVXQVVJVVEYUHWVBUYTVUAVU
      BVUCVUDVXQVWROVXMWXEWVLXXHVUPVOYRYSRAVVDXYDSXYHWVORWIVAVXQVWRVXMWXEXXHVXQ
      OVWQWVLWXDYUCVXQSYUEVWQVHVXQVVJYUDWWFYULYUMYUNVUFYUKVNVUFVUGVUHVOVUIWNVUJ
      WVPVUKRAVVDXXKXXQWWACMWWAUHLOWWAUGMNLPLUFMUCUEZVHVDUAKUDVULLVUMZUCUQVUNAV
      VDXXKULYTQZRUACEGUCHVUOYURYUSUCUQYUQUQQZYURVEAUAYUQBCEFGHIYUTYURVUQYUTYUR
      VURVUSVUTUYKVUJVVAWNVVAVVBVVC $.

    pntrlog2bndlem5.1 $e |- ( ph -> B e. RR+ ) $.
    pntrlog2bndlem5.2 $e |- ( ph ->
      A. y e. RR+ ( abs ` ( ( R ` y ) / y ) ) <_ B ) $.
    $( Lemma for ~ pntrlog2bnd .  Bound on the difference between the Selberg
       function and its approximation, inside a sum.  (Contributed by Mario
       Carneiro, 31-May-2016.) $)
    pntrlog2bndlem5 $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
    ( ( ( ( abs ` ( R ` x ) ) x. ( log ` x ) ) -
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` x ) )
      ( ( abs ` ( R ` ( x / n ) ) ) x. ( log ` n ) ) ) ) / x ) ) e. <_O(1) ) $=
      ( c1 co cmul wcel cc0 cpnf cioo cv cfv cabs clog c2 cdiv cfl cfz csu cmin
      caddc cmpt wa crp cr elioore adantl 1rp a1i rpred clt wbr eliooord simpld
      clo1 ltled rpgecld pntrf ffvelrni syl recnd abscld relogcld mulcld cc 2cn
      rplogcld rpne0d divcld fzfid adantr cn elfznn nnrpd 1re readdcld remulcld
      fsumcl divdird subdid ax-1cn oveq2d eqtr3d oveq1d rerpdivcld fsumrecl cif
      subsubd resubcld simpr 0re cle rpge0d wceq rpcnd sylancr mpbid rpre eleq1
      2rp id fveq2 oveq12d eqidd ifbieq12d ovex c0ex fvmpt iftrue eqtrd subdird
      mulid2d 3eqtrd fveq2d eqbrtrrd eqbrtrd syl6eq ax-mp subidi letrd lemul2ad
      ifex fsumle adantrr lo1le lo1const lo1add 3brtr4d rpdivcld subcld fsumsub
      pncand mulid1d 3eqtr3rd sumeq2dv mpteq2dva pntrlog2bndlem4 nnred simpl wn
      2re ifclda fmpti divge0d absge0d difrp 3eqtr4d subsub3d npcand lemuldiv2d
      wb logdifbnd mpbird lesubadd2d syl6eqel log1 oveq1 rpne0 necon2bi iffalse
      mul01i 0cn eqcoms nnge1d logge0d lep1d elfzle1 mpjaodan lesub2dd lediv1dd
      leloed rpmulcld wss ioossre crli co1 divlogrlim rlimo1 mp1i o1lo1d lo1mul
      nnrecred absdivd nndivred absidd wne nnne0d divdiv2d div23d wral ad2antrr
      wo breq1d sylc lemuldivd divrec2d breqtrd fsumdivc fsummulc1 harmonicubnd
      rspcv syl2anc lemul1ad divassd mul32d dividd eqtr2d addcld div32d mulassd
      eqtr4d eqeltrrd ) ABPUAUBQZBUCZEUDZUEUDZUYFUFUDZRQZUGUYIUHQZPUYFUIUDZUJQZ
      UYFIUCZUHQZEUDZUEUDZUYNUFUDZPUMQZRQZIUKZRQZULQZUYFUHQZUYKUYMUYQIUKZRQZUYF
      UHQZUMQZUNBUYEUYJUYKUYMUYQUYRRQZIUKZRQZULQZUYFUHQZUNVGABUYEVUHVUMAUYFUYES
      ZUOZVUCVUFUMQZUYFUHQVUHVUMVUOVUCVUFUYFVUOUYJVUBVUOUYHUYIVUOUYHVUOUYGVUOUY
      GVUOUYFUPSZUYGUQSVUOUYFPVUNUYFUQSZAUYFPUAURUSZPUPSVUOUTVAZVUOPUYFVUOPVUTV
      BZVUSVUOPUYFVCVDZUYFUAVCVDZVUNVVBVVCUOAUYFPUAVEUSVFZVHZVIZUPUQUYFEEJLVJZV
      KVLVMVNZVMVUOUYIVUOUYFVVFVOZVMZVPVUOUYKVUAVUOUGUYIUGVQSVUOVRVAZVVJVUOUYIV
      UOUYFVUSVVDVSZVTZWAZVUOUYMUYTIVUOPUYLWBZVUOUYNUYMSZUOZUYTVVQUYQUYSVVQUYPV
      VQUYPVVQUYOUPSZUYPUQSVVQUYFUYNVUOVUQVVPVVFWCZVVQUYNVVPUYNWDSVUOUYNUYLWEUS
      ZWFZUUAZUPUQUYOEVVGVKVLVMZVNZVVQUYRPVVQUYNVWAVOZPUQSZVVQWGVAZWHZWIZVMZWJZ
      VPZUUBVUOUYKVUEVVNVUOUYMUYQIVVOVVQUYQVWDVMZWJZVPZVUOUYFVUSVMZVUOUYFVVFVTZ
      WKVUOVUPVULUYFUHVUOUYJVUBVUFULQZULQVUPVULVUOUYJVUBVUFVUOUYJVUOUYHUYIVVHVV
      IWIZVMVWLVWOWTVUOVWRVUKUYJULVUOUYKVUAVUEULQZRQVWRVUKVUOUYKVUAVUEVVNVWKVWN
      WLVUOVWTVUJUYKRVUOUYMUYTUYQULQZIUKVWTVUJVUOUYMUYTUYQIVVOVWJVWMUUCVUOUYMVX
      AVUIIVVQUYQUYSPULQZRQUYTUYQPRQZULQVUIVXAVVQUYQUYSPVWMVVQUYSVWHVMPVQSZVVQW
      MVAZWLVVQVXBUYRUYQRVVQUYRPVVQUYRVWEVMZVXEUUDWNVVQVXCUYQUYTULVVQUYQVWMUUEW
      NUUFUUGWOWNWOWNWOWPWOUUHABUYEVUDVUGUQVUOVUCUYFVUOUYJVUBVWSVUOUYKVUAVUOUGU
      YIUGUQSVUOUUMVAZVVLWQZVUOUYMUYTIVVOVWIWRZWIZXAZVVFWQZVUOVUFUYFVUOUYKVUEVX
      HVUOUYMUYQIVVOVWDWRZWIVVFWQZABUYEUYJUYKUYMUYQUYNGUDZUYNPULQZGUDZULQZRQZIU
      KZRQZULQZUYFUHQZVUDPUQVWFAWGVAZBUYEVYCUNVGSABEFGHIJKLMUUIVAVUOVYBUYFVUOUY
      JVYAVWSVUOUYKVXTVXHVUOUYMVXSIVVOVVQUYQVXRVWDVVQVXOVXQVVQUYNUQSZVXOUQSVVQU
      YNVVTUUJZUQUQUYNGJUQUQJUCZUPSZVYGVYGUFUDZRQZTWSZGMVYGUQSZVYHVYJTUQVYLVYHU
      OZVYGVYIVYLVYHUUKVYMVYGVYLVYHXBVOWITUQSZVYLVYHUULZUOXCVAUUNUUOZVKVLVVQVXP
      UQSZVXQUQSVVQUYNPVYFVWGXAUQUQVXPGVYPVKVLXAZWIZWRZWIZXAZVVFWQVXLAVUNVUDVYC
      XDVDPUYFXDVDZVUOVUCVYBUYFVXKWUBVVFVUOVYAVUBUYJWUAVXJVWSVUOVXTVUAUYKVYTVXI
      VXHVUOUGUYIVXGVVLVUOUGUGUPSZVUOXLVAXEUUPZVUOUYMVXSUYTIVVOVYSVWIVVQVXRUYSU
      YQVYRVWHVWDVVQUYPVWCUUQVVQPUYNVCVDZVXRUYSXDVDPUYNXFZVVQWUFUOZVXRUYNUYRVXP
      UFUDZULQZRQZWUIUMQZUYSXDWUHUYNUYRRQZUYNWUIRQZWUIULQZULQWUMWUNULQZWUIUMQVX
      RWULWUHWUMWUNWUIWUHUYNUYRWUHUYNVVQUYNUPSZWUFVWAWCZXGZVVQUYRVQSWUFVXFWCZVP
      WUHUYNWUIWUSWUHWUIWUHVXPWUHWUFVXPUPSZVVQWUFXBWUHVWFVYEWUFWVAUVCWGWUHUYNWU
      RVBZPUYNUURXHXIZVOZVMZVPWVEWTWUHVXOWUMVXQWUOULWUHWUQVXOWUMXFWURWUQVXOWUQW
      UMTWSZWUMWUQVYEVXOWVFXFUYNXJJUYNVYKWVFUQGVYGUYNXFZVYHWUQVYJTWUMTVYGUYNUPX
      KWVGVYGUYNVYIUYRRWVGXMVYGUYNUFXNXOWVGTXPXQMWUQWUMTUYNUYRRXRXSYNXTVLWUQWUM
      TYAYBVLWUHVXQVXPWUIRQZWUNPWUIRQZULQWUOWUHWVAVXQWVHXFWVCWVAVXQWVAWVHTWSZWV
      HWVAVYQVXQWVJXFVXPXJJVXPVYKWVJUQGVYGVXPXFZVYHWVAVYJTWVHTVYGVXPUPXKWVKVYGV
      XPVYIWUIRWVKXMVYGVXPUFXNXOWVKTXPXQMWVAWVHTVXPWUIRXRXSYNXTVLWVAWVHTYAYBVLW
      UHUYNPWUIWUSVXDWUHWMVAZWVEYCWUHWVIWUIWUNULWUHWUIWVEYDWNYEXOWUHWUKWUPWUIUM
      WUHUYNUYRWUIWUSWUTWVEWLWPUUSWUHWULUYRULQZPXDVDWULUYSXDVDWUHVXPWUJRQZWVMPX
      DWUHWVNWUKPWUJRQZULQWUKWUJULQWVMWUHUYNPWUJWUSWVLWUHWUJWUHUYRWUIWUHUYNWURV
      OZWVDXAZVMZYCWUHWVOWUJWUKULWUHWUJWVRYDWNWUHWUKUYRWUIWUHWUKWUHUYNWUJWVBWVQ
      WIZVMWUTWVEUUTYEWUHWVNPXDVDWUJPVXPUHQZXDVDWUHVXPPUMQZUFUDZWUIULQZWUJWVTXD
      WUHWWBUYRWUIULWUHWWAUYNUFWUHUYNPWUSWVLUVAYFWPWUHWVAWWCWVTXDVDWVCVXPUVDVLY
      GWUHWUJPVXPWVQVWFWUHWGVAZWVCUVBUVEYGWUHWULUYRPWUHWUKWUIWVSWVDWHWVPWWDUVFX
      IYHVVQWUGUOVXRTUYSXDWUGVXRTXFZVVQWWEUYNPUYNPXFZVXRTTULQTWWFVXOTVXQTULWWFV
      XOPGUDZTUYNPGXNVWFWWGTXFWGJPVYKTUQGVYGPXFZVYKVYJTWWHVYHVYKVYJXFWWHVYGPUPW
      WHXMZUTUVGVYHVYJTYAVLWWHVYJPTRQTWWHVYGPVYITRWWIWWHVYIPUFUDTVYGPUFXNUVHYIX
      OPWMUVMYIYBMXSXTYJYIWWFVXQTGUDZTWWFVXPTGWWFVXPPPULQTUYNPPULUVIPWMYKYIYFVY
      NWWJTXFXCJTVYKTUQGVYGTXFVYOVYKTXFVYHVYGTVYGUVJUVKVYHVYJTUVLVLMXSXTYJYIXOT
      UVNYKYIUVOUSVVQTUYSXDVDWUGVVQTUYRUYSVYNVVQXCVAVWEVWHVVQUYNVYFVVQUYNVVTUVP
      UVQVVQUYRVWEUVRYLWCYHVVQPUYNXDVDZWUFWUGUXDVVPWWKVUOUYNPUYLUVSUSVVQPUYNVWG
      VYFUWCXIUVTYMYOYMUWAUWBYPYQABUYEUGDRQZPPUYIUHQZUMQZRQZVUGPUQVYDABUYEWWLWW
      NUQAWWLUQSZVUNAWWLAUGDWUDAXLVANUWDZVBZWCZVUOPWWMVVAVUOPUYIVVAVVLWQZWHZAUY
      EUQUWEZWWPBUYEWWLUNVGSPUAUWFZWWRBUYEWWLYRXHABUYEPWWMUQVVAWWTAWXBVWFBUYEPU
      NVGSWXCVYDBUYEPYRXHABUYEWWMWWTBUYEWWMUNZTUWGVDWXDUWHSABUWITWXDUWJUWKUWLYS
      VUOWWLAWWLUPSVUNWWQWCXEUWMVUOWWLWWNWWSWXAWIVXNAVUNVUGWWOXDVDWUCVUOUYKVUEU
      YFUHQZRQUYKUYIPUMQZDRQZRQZVUGWWOXDVUOWXEWXGUYKVUOVUEUYFVXMVVFWQZVUOWXFDVU
      OUYIPVVIVVAWHZVUODADUPSVUNNWCZVBZWIZVXHWUEVUOWXEUYMPUYNUHQZIUKZDRQZWXGWXI
      VUOWXODVUOUYMWXNIVVOVVQUYNVVTUWNZWRZWXLWIWXMVUOUYMUYQUYFUHQZIUKUYMWXNDRQZ
      IUKWXEWXPXDVUOUYMWXSWXTIVVOVVQUYQUYFVWDVVSWQZVVQWXNDWXQVUODUQSVVPWXLWCZWI
      VVQWXSDUYNUHQZWXTXDVVQWXSUYNRQZDXDVDWXSWYCXDVDVVQUYPUYOUHQZUEUDZWYDDXDVVQ
      WYFUYQUYOUHQZUYQUYNRQUYFUHQWYDVVQWYFUYQUYOUEUDZUHQWYGVVQUYPUYOVWCVVQUYOVW
      BXGVVQUYOVWBVTUWOVVQWYHUYOUYQUHVVQUYOVVQUYFUYNVUOVURVVPVUSWCVVTUWPVVQUYOV
      WBXEUWQWNYBVVQUYQUYFUYNVWMVUOUYFVQSVVPVWPWCZVVQUYNVYFVMZVUOUYFTUWRVVPVWQW
      CZVVQUYNVVTUWSZUWTVVQUYQUYNUYFVWMWYJWYIWYKUXAYEVVQVVRCUCZEUDZWYMUHQZUEUDZ
      DXDVDZCUPUXBZWYFDXDVDZVWBAWYRVUNVVPOUXCWYQWYSCUYOUPWYMUYOXFZWYPWYFDXDWYTW
      YOWYEUEWYTWYNUYPWYMUYOUHWYMUYOEXNWYTXMXOYFUXEUXMUXFYGVVQWXSDUYNWYAWYBVWAU
      XGXIVVQDUYNVVQDWYBVMWYJWYLUXHUXIYOVUOUYMUYQUYFIVVOVWPVWMVWQUXJVUOUYMWXNDI
      VVOVUODWXKXGZVVQWXNWXQVMUXKYTVUOWXOWXFDWXRWXJWXLVUODWXKXEVUOVURWUCWXOWXFX
      DVDVUSVVEUYFIUXLUXNUXOYLYMVUOUYKVUEUYFVVNVWNVWPVWQUXPVUOWWOUGWWNRQZDRQUYK
      WXFRQZDRQWXHVUOUGDWWNVVKXUAVUOWWNWXAVMUXQVUOXUBXUCDRVUOXUBUGWXFUYIUHQZRQX
      UCVUOWWNXUDUGRVUOXUDUYIUYIUHQZWWMUMQWWNVUOUYIPUYIVVJVXDVUOWMVAZVVJVVMWKVU
      OXUEPWWMUMVUOUYIVVJVVMUXRWPUXSWNVUOUGUYIWXFVVKVVJVUOUYIPVVJXUFUXTZVVMUYAU
      YCWPVUOUYKWXFDVVNXUGXUAUYBYEYTYPYQYSUYD $.

    pntrlog2bndlem6.1 $e |- ( ph -> A e. RR ) $.
    pntrlog2bndlem6.2 $e |- ( ph -> 1 <_ A ) $.
    $( Lemma for ~ pntrlog2bndlem6 .  (Contributed by Mario Carneiro,
       7-Jun-2016.) $)
    pntrlog2bndlem6a $p |- ( ( ph /\ x e. ( 1 (,) +oo ) ) ->
      ( 1 ... ( |_ ` x ) ) = ( ( 1 ... ( |_ ` ( x / A ) ) ) u.
        ( ( ( |_ ` ( x / A ) ) + 1 ) ... ( |_ ` x ) ) ) ) $=
      ( c1 co wcel cv cpnf cioo wa cdiv cfl cfv caddc cuz cfz cun cn cr cc0 cle
      wceq wbr cn0 elioore adantl crp 1rp a1i rpred clt eliooord simpld rpgecld
      ltled adantr rpdivcld rprege0d flge0nn0 nn0p1nn 3syl nnuz syl6eleq rpge0d
      lediv2ad recnd div1d breqtrd flword2 syl3anc fzsplit2 syl2anc ) ABUAZRUBU
      CSTZUDZWGDUESZUFUGZRUHSZRUIUGZTWGUFUGZWKUIUGTZRWNUJSRWKUJSWLWNUJSUKUPWIWL
      ULWMWIWJUMTZUNWJUOUQUDWKURTWLULTWIWJWIWGDWIWGRWHWGUMTZAWGRUBUSUTZRVATZWIV
      BVCZWIRWGWIRWTVDWRWIRWGVEUQZWGUBVEUQZWHXAXBUDAWGRUBVFUTVGVIVHZADVATWHADRP
      WSAVBVCQVHVJZVKZVLWJVMWKVNVOVPVQWIWPWQWJWGUOUQWOWIWJXEVDWRWIWJWGRUESWGUOW
      IRDWGWTXDWRWIWGXCVRARDUOUQWHQVJVSWIWGWIWGWRVTWAWBWJWGWCWDWKRWNWEWF $.

    $( Lemma for ~ pntrlog2bnd .  Bound on the difference between the Selberg
       function and its approximation, inside a sum.  (Contributed by Mario
       Carneiro, 31-May-2016.) $)
    pntrlog2bndlem6 $p |- ( ph -> ( x e. ( 1 (,) +oo ) |->
    ( ( ( ( abs ` ( R ` x ) ) x. ( log ` x ) ) -
      ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` ( x / A ) ) )
      ( ( abs ` ( R ` ( x / n ) ) ) x. ( log ` n ) ) ) ) / x ) ) e. <_O(1) ) $=
      ( co wcel c1 cpnf cioo cv cfv cabs clog cmul cdiv cfl cfz cmin caddc cmpt
      c2 csu clo1 wa crp cr elioore adantl 1rp a1i rpred clt wbr eliooord ltled
      simpld rpgecld pntrf ffvelrni syl recnd abscld relogcld remulcld rplogcld
      2re rerpdivcld fzfid adantr elfznn nnrpd rpdivcld fsumrecl resubcld ssun2
      cn pntrlog2bndlem6a syl5sseqr sselda syldan rpne0d divdird subsubd subdid
      cun cin c0 reflcl ltp1d fzdisj fsumsplit oveq1d ssun1 pncand eqtrd oveq2d
      wceq eqtr3d mpteq2dva pntrlog2bndlem5 wss ioossre 1re readdcld cle rpge0d
      2rp nnrecred nndivred cc absge0d elfzle2 cz syl2anc mpbird mpbid lemul2ad
      ledivmul2d eqbrtrrd letrd nncnd nnne0d mulcld breqtrd 3brtr4d mul12d nnzd
      flge logled absdivd cc0 divge0d absidd wral ad2antrr fveq2 oveq12d fveq2d
      wb id breq1d rspcv sylc divassd divrecd fsumle fsumdivc fsummulc2 mulge0d
      harmonicubnd relogdivd harmoniclbnd le2subd reccld pncan2d ax-1cn pnncand
      addcomd 3brtr3d mulassd 2cn div32d addcld ledivmuld adantrr ello1d lo1add
      eqeltrrd ) ABUAUBUCSZBUDZFUEZUFUEZUWDUGUEZUHSZUOUWGUISZUAUWDUJUEZUKSZUWDJ
      UDZUISZFUEZUFUEZUWLUGUEZUHSZJUPZUHSZULSZUWDUISZUWIUWDDUISZUJUEZUAUMSZUWJU
      KSZUWQJUPZUHSZUWDUISZUMSZUNBUWCUWHUWIUAUXCUKSZUWQJUPZUHSZULSZUWDUISZUNUQA
      BUWCUXIUXNAUWDUWCTZURZUWTUXGUMSZUWDUISUXIUXNUXPUWTUXGUWDUXPUWTUXPUWHUWSUX
      PUWFUWGUXPUWEUXPUWEUXPUWDUSTZUWEUTTUXPUWDUAUXOUWDUTTZAUWDUAUBVAVBZUAUSTZU
      XPVCVDZUXPUAUWDUXPUAUYBVEZUXTUXPUAUWDVFVGZUWDUBVFVGZUXOUYDUYEURAUWDUAUBVH
      VBVJZVIZVKZUSUTUWDFFKMVLZVMVNVOVPUXPUWDUYHVQZVRZUXPUWIUWRUXPUOUWGUOUTTZUX
      PVTVDZUXPUWDUXTUYFVSZWAZUXPUWKUWQJUXPUAUWJWBZUXPUWLUWKTZURZUWOUWPUYRUWNUY
      RUWNUYRUWMUSTZUWNUTTUYRUWDUWLUXPUXRUYQUYHWCUYRUWLUYQUWLWJTZUXPUWLUWJWDZVB
      ZWEZWFZUSUTUWMFUYIVMVNVOZVPZUYRUWLVUCVQVRZWGZVRZWHZVOUXPUXGUXPUWIUXFUYOUX
      PUXEUWQJUXPUXDUWJWBZUXPUWLUXETZUYQUWQUTTZUXPUXEUWKUWLUXPUXJUXEWSZUXEUWKUX
      EUXJWIABCDEFGHIKLMNOPQRWKZWLWMZVUGWNZWGZVRZVOZUXPUWDUXTVOZUXPUWDUYHWOWPUX
      PUXQUXMUWDUIUXPUWHUWSUXGULSZULSUXQUXMUXPUWHUWSUXGUXPUWHUYKVOUXPUWSVUIVOVU
      TWQUXPVVBUXLUWHULUXPUWIUWRUXFULSZUHSVVBUXLUXPUWIUWRUXFUXPUWIUYOVOUXPUWRVU
      HVOUXPUXFVURVOZWRUXPVVCUXKUWIUHUXPVVCUXKUXFUMSZUXFULSUXKUXPUWRVVEUXFULUXP
      UXJUXEUWQUWKJUXPUXCUXDVFVGUXJUXEWTXAXKUXPUXCUXPUXBUTTUXCUTTUXPUWDDUXTADUS
      TUXOADUAQUYAAVCVDRVKZWCZWAUXBXBVNXCUAUXCUXDUWJXDVNZVUOUYPUYRUWQVUGVOZXEXF
      UXPUXKUXFUXPUXKUXPUXJUWQJUXPUAUXCWBZUXPUWLUXJTZUYQVUMUXPUXJUWKUWLUXPVUNUX
      JUWKUXJUXEXGVUOWLWMZVUGWNWGVOVVDXHXIXJXLXJXLXFXLXMABUWCUXAUXHUTUXPUWTUWDV
      UJUYHWAUXPUXGUWDVUSUYHWAZABCEFGHIJKLMNOPXNABUWCUXHUAUOEDUGUEZUAUMSZUHSZUH
      SZUWCUTXOAUAUBXPVDVVMUAUTTAXQVDZAUOVVPUYLAVTVDAEVVOAEOVEZAVVNUAADVVFVQVVR
      XRVRVRZAUXOUXHVVQXSVGZUAUWDXSVGZUXPVWAUXGUWDVVQUHSZXSVGUXPUOUXFUWGUISZUHS
      UOUWDVVPUHSZUHSUXGVWCXSUXPVWDVWEUOUXPUXFUWGVURUYNWAZUXPUWDVVPUXTUXPEVVOAE
      UTTZUXOVVSWCZUXPVVNUAUXPDVVGVQZUYCXRZVRVRZUYMUXPUOUOUSTUXPYAVDXTUXPVWDEUW
      DUHSZUXEUAUWLUISZJUPZUHSZVWEVWFUXPVWLVWNUXPEUWDVWHUXTVRZUXPUXEVWMJVUKUXPV
      ULURZUWLVWQUYQUYTVUPVUAVNZYBZWGZVRVWKUXPUXEUWQUWGUISZJUPUXEVWLVWMUHSZJUPV
      WDVWOXSUXPUXEVXAVXBJVUKVWQUWQUWGVUQUXPUWGUSTVULUYNWCZWAZVWQVWLVWMVWQEUWDU
      XPVWGVULVWHWCZUXPUXSVULUXTWCZVRVWSVRVWQVXAEUWMUHSZVXBXSVWQVXAUWOVXGVXDUXP
      VULUYQUWOUTTVUPVUFWNZVWQEUWMVXEVWQUWDUWLVXFVWRYCZVRVWQVXAUWOXSVGUWQUWOUWG
      UHSXSVGVWQUWPUWGUWOVWQUWLUXPVULUYQUWLUSTVUPVUCWNZVQVWQUWDUXPUXRVULUYHWCZV
      QVXHVWQUWNUXPVULUYQUWNYDTVUPVUEWNZYEVWQUWLUWDXSVGZUWPUWGXSVGVWQVXMUWLUWJX
      SVGZVULVXNUXPUWLUXDUWJYFVBVWQUXSUWLYGTVXMVXNUUMVXFVWQUWLVWRUUAUWDUWLUUBYH
      YIVWQUWLUWDVXJVXKUUCYJYKVWQUWQUWOUWGVUQVXHVXCYLYIVWQUWOUWMUISZEXSVGUWOVXG
      XSVGVWQUWNUWMUISZUFUEZVXOEXSVWQVXQUWOUWMUFUEZUISVXOVWQUWNUWMVXLVWQUWMVXIV
      OVWQUWMUXPVULUYQUYSVUPVUDWNZWOUUDVWQVXRUWMUWOUIVWQUWMVXIVWQUWDUWLVXFVXJUX
      PUUEUWDXSVGVULUXPUWDUYHXTZWCUUFUUGXJXIVWQUYSCUDZFUEZVYAUISZUFUEZEXSVGZCUS
      UUHZVXQEXSVGZVXSAVYFUXOVULPUUIVYEVYGCUWMUSVYAUWMXKZVYDVXQEXSVYHVYCVXPUFVY
      HVYBUWNVYAUWMUIVYAUWMFUUJVYHUUNUUKUULUUOUUPUUQYMVWQUWOEUWMVXHVXEVXSYLYJYN
      VWQVWLUWLUISVXGVXBVWQEUWDUWLVWQEVXEVOZUXPUWDYDTVULVVAWCZVWQUWLVWRYOZVWQUW
      LVWRYPZUURVWQVWLUWLVWQEUWDVYIVYJYQVYKVYLUUSXLYRUUTUXPUXEUWQUWGJVUKUXPUWGU
      YJVOZUXPVULUYQUWQYDTVUPVVIWNUXPUWGUYNWOZUVAUXPUXEVWMVWLJVUKUXPEUWDUXPEVWH
      VOZVVAYQVWQVWMVWSVOUVBYSUXPVWOVWLVVOUHSZVWEXSUXPVWNVVOVWLVWTVWJVWPUXPEUWD
      VWHUXTUXPEAEUSTUXOOWCXTVXTUVCUXPUWKVWMJUPZUXJVWMJUPZULSZUWGUAUMSZUWGVVNUL
      SZULSZVWNVVOXSUXPVYQWUAVYTVYRUXPUWKVWMJUYPUYRUWLVUBYBZWGUXPUWGVVNUYJVWIWH
      UXPUWGUAUYJUYCXRUXPUXJVWMJVVJUXPVVKUYQVWMUTTVVLWUCWNWGUXPUXSVWBVYQVYTXSVG
      UXTUYGUWDJUVDYHUXPUXBUGUEZWUAVYRXSUXPUWDDUYHVVGUVEUXPUXBUSTWUDVYRXSVGUXPU
      WDDUYHVVGWFUXBJUVFVNYMUVGUXPVYSVYRVWNUMSZVYRULSVWNUXPVYQWUEVYRULUXPUXJUXE
      VWMUWKJVVHVUOUYPUYRUWLUYRUWLVUBYOUYRUWLVUBYPUVHXEXFUXPVYRVWNUXPVYRUXPUXJV
      WMJVVJUXPVVKURZUWLWUFUYQUYTVVLVUAVNYBWGVOUXPVWNVWTVOUVIXIUXPWUBUAVVNUMSVV
      OUXPUWGUAVVNVYMUAYDTUXPUVJVDZUXPVVNVWIVOZUVKUXPUAVVNUXPUAUYCVOWUHUVLXIUVM
      YKUXPVYPEUWDVVOUHSUHSVWEUXPEUWDVVOVYOVVAUXPVVOVWJVOZUVNUXPEUWDVVOVYOVVAWU
      IYTXIYRYNYKUXPUOUWGUXFUOYDTUXPUVOVDZVYMVVDVYNUVPUXPUWDUOVVPVVAWUJUXPEVVOV
      YOUXPVVNUAWUHWUGUVQYQYTYSUXPUXGVVQUWDVUSAVVQUTTUXOVVTWCUYHUVRYIUVSUVTUWAU
      WB $.
  $}

  ${
    $d i j k m n x y K $.  $d a N $.  $d k m n x ph $.  $d c i j m n x y R $.
    $d a c i j m n x y A $.  $d n y E $.  $d i j k m n x y Y $.
    pntpbnd.r $e |- R = ( a e. RR+ |-> ( ( psi ` a ) - a ) ) $.
    $( A bound on ` R ( x ) log ^ 2 ( x ) ` .  Equation 10.6.15 of [Shapiro],
       p. 431.  (Contributed by Mario Carneiro, 1-Jun-2016.) $)
    pntrlog2bnd $p |- ( ( A e. RR /\ 1 <_ A ) ->
      E. c e. RR+ A. x e. ( 1 (,) +oo )
        ( ( ( ( abs ` ( R ` x ) ) x. ( log ` x ) ) -
        ( ( 2 / ( log ` x ) ) x. sum_ n e. ( 1 ... ( |_ ` ( x / A ) ) )
             ( ( abs ` ( R ` ( x / n ) ) ) x. ( log ` n ) ) ) ) / x ) <_ c ) $=
      ( cr wcel c1 cle wbr wa co cfv cdiv a1i crp recnd adantr vy vi cpnf cv c2
      cioo cabs clog cmul cfl cfz csu cmin caddc wss ioossre 1re sselda 1rp clt
      eliooord adantl simpld ltled rpgecld pntrf ffvelrni syl relogcld remulcld
      abscld 2re rplogcld rerpdivcld fzfid cn elfznn rpdivcld fsumrecl resubcld
      cchp nnrpd wral wrex cmpt clo1 pntrmax cvma cc0 eqid simprl simprr simpll
      cif simplr pntrlog2bndlem6 rexlimdvaa mpi chpcl readdcld ad2ant2r simprll
      2rp rpge0d divge0d adantlr absge0d rpred logge0d mulge0d fsumge0 subge02d
      nnge1d mpbid wceq pntrval fveq2d abs2dif2d chpge0 oveq12d breqtrd eqbrtrd
      cc absidd chpwordi syl3anc le2addd letrd logled lemul12ad addge0d simprlr
      lediv1dd lediv2ad addcld mulcld div1d lo1bddrp ) BHIZJBKLZMZAUAJUCUFNZAUD
      ZCOZUGOZUUCUHOZUINZUEUUFPNZJUUCBPNUJOZUKNZUUCDUDZPNZCOZUGOZUUKUHOZUINZDUL
      ZUINZUMNZUUCPNZJFUAUDZWAOZUVAUNNZUVAUHOZUINZUUBHUOUUAJUCUPQZJHIZUUAUQQUUA
      UUCUUBIZMZUUSUUCUVIUUGUURUVIUUEUUFUVIUUDUVIUUDUVIUUCRIZUUDHIZUVIUUCJUUAUU
      BHUUCUVFURZJRIZUVIUSQUVIJUUCUVGUVIUQQUVLUVIJUUCUTLZUUCUCUTLZUVHUVNUVOMUUA
      UUCJUCVAVBVCZVDZVEZRHUUCCCEGVFZVGVHZSVKUVIUUCUVRVIVJUVIUUHUUQUVIUEUUFUEHI
      ZUVIVLQUVIUUCUVLUVPVMVNZUVIUUJUUPDUVIJUUIVOUVIUUKUUJIZMZUUNUUOUWDUUMUWDUU
      MUWDUULRIUUMHIUWDUUCUUKUVIUVJUWCUVRTUWDUUKUWCUUKVPIZUVIUUKUUIVQZVBWBZVRRH
      UULCUVSVGVHSZVKUWDUUKUWGVIVJZVSZVJVTUVRVNZUUAUVACOUVAPNUGOFUDZKLUARWCZFRW
      DAUUBUUTWEWFIZUACEFGWGUUAUWMUWNFRUUAUWLRIZUWMMZMAUABUWLCEHJEUDZUJOUKNUBUD
      ZWHOUWRUHOUWQUWRPNWAOUNNUINUBULWEZEHUWQRIUWQUWQUHOUINWIWNWEZUBDEUWSWJGUWT
      WJUUAUWOUWMWKUUAUWOUWMWLYSYTUWPWMYSYTUWPWOWPWQWRUUAUVAHIZJUVAKLZMZMZUVCUV
      DUXDUVBUVAUXDUXAUVBHIZUUAUXAUXBWKZUVAWSVHZUXFWTUXDUVAUXDUVAJUXFUVMUXDUSQU
      UAUXAUXBWLVEZVIVJUVIUXCUUCUVAUTLZMZMZUUTUVEUUCPNZUVEUVIUUTHIUXJUWKTUXKUVE
      UUCUXKUVCUVDUXKUVBUVAUUAUXCUXEUVHUXIUXGXAZUVIUXAUXBUXIXBZWTZUXKUVAUUAUXCU
      VARIUVHUXIUXHXAZVIZVJZUVIUVJUXJUVRTZVNUXRUXKUUSUVEUUCUXKUUGUURUXKUUEUUFUX
      KUUDUXKUUDUVIUVKUXJUVTTSZVKZUXKUUCUXSVIZVJZUXKUUHUUQUVIUUHHIUXJUWBTZUVIUU
      QHIUXJUWJTZVJZVTZUXRUXSUXKUUSUUGUVEUYGUYCUXRUXKWIUURKLUUSUUGKLUXKUUHUUQUY
      DUYEUXKUEUUFUWAUXKVLQUXKUUCUVIUUCHIZUXJUVLTZUVIUVNUXJUVPTVMZUXKUEUERIUXKX
      CQXDXEUXKUUJUUPDUXKJUUIVOUVIUWCUUPHIUXJUWIXFUXKUWCMZUUNUUOUYKUUMUVIUWCUUM
      YCIUXJUWHXFZVKUYKUUKUVIUWCUUKRIUXJUWGXFZVIUYKUUMUYLXGUYKUUKUYKUUKUYMXHUYK
      UUKUWCUWEUXKUWFVBXMXIXJXKXJUXKUUGUURUYCUYFXLXNUXKUUEUVCUUFUVDUYAUXOUYBUXQ
      UXKUUDUXTXGUXKUUFUYJXDUXKUUEUUCWAOZUUCUNNZUVCUYAUXKUYNUUCUXKUYHUYNHIUYIUU
      CWSVHZUYIWTUXOUXKUUEUYNUUCUMNZUGOZUYOKUXKUUDUYQUGUXKUVJUUDUYQXOUXSUUCCEGX
      PVHXQUXKUYRUYNUGOZUUCUGOZUNNUYOKUXKUYNUUCUXKUYNUYPSUXKUUCUYISXRUXKUYSUYNU
      YTUUCUNUXKUYNUYPUXKUYHWIUYNKLUYIUUCXSVHYDUXKUUCUYIUXKUUCUXSXDYDXTYAYBUXKU
      YNUUCUVBUVAUYPUYIUXMUXNUXKUYHUXAUUCUVAKLZUYNUVBKLUYIUXNUXKUUCUVAUYIUXNUVI
      UXCUXIWLVDZUUCUVAYEYFVUBYGYHUXKVUAUUFUVDKLVUBUXKUUCUVAUXSUXPYIXNYJYHYMUXK
      UXLUVEJPNUVEKUXKJUUCUVEUVMUXKUSQUXSUXRUXKUVCUVDUXOUXQUXKUVBUVAUXMUXNUXKUX
      AWIUVBKLUXNUVAXSVHUXKUVAUXPXDYKUXKUVAUXNUVIUXAUXBUXIYLXIXJUVIJUUCKLUXJUVQ
      TYNUXKUVEUXKUVCUVDUXKUVBUVAUXKUVBUXMSUXKUVAUXNSYOUXKUVDUXQSYPYQYAYHYR $.

    pntpbnd1.e $e |- ( ph -> E e. ( 0 (,) 1 ) ) $.
    pntpbnd1.x $e |- X = ( exp ` ( 2 / E ) ) $.
    pntpbnd1.y $e |- ( ph -> Y e. ( X (,) +oo ) ) $.
    ${
      pntpbnd1a.1 $e |- ( ph -> N e. NN ) $.
      pntpbnd1a.2 $e |- ( ph -> ( Y < N /\ N <_ ( K x. Y ) ) ) $.
      pntpbnd1a.3 $e |- ( ph -> ( abs ` ( R ` N ) ) <_
        ( abs ` ( ( R ` ( N + 1 ) ) - ( R ` N ) ) ) ) $.
      $( Lemma for ~ pntpbnd .  (Contributed by Mario Carneiro,
         11-Apr-2016.) $)
      pntpbnd1a $p |- ( ph -> ( abs ` ( ( R ` N ) / N ) ) <_ E ) $=
        ( co wcel c1 wbr c2 cfv cdiv cabs clog crp cr nnrpd ffvelrni rerpdivcld
        pntrf syl recnd abscld relogcld cc0 ioossre sseldi nnred nnne0d absdivd
        cioo nnnn0d nn0ge0d absidd oveq2d eqtrd caddc cvma cmin peano2nnd vmacl
        cle peano2rem cchp wceq pntrval oveq12d peano2re chpcl sub4d cn0 oveq1d
        cn chpp1 pncan2d cc ax-1cn pncan2 sylancl 3eqtrd fveq2d breqtrd 1re a1i
        resubcld 0re 2re clt eliooord simpld elrpd rerpdivcl sylancr 1lt2 div1i
        wa simprd wb 0lt1 2pos ltdiv2OLD syl33anc mpbid syl5eqbrr lttrd rpefcld
        2cn ce syl5eqel rpred cpnf cxr rpxrd elioopnf reeflogd breqtrrd syl2anc
        cmul eflt mpbird ltled suble0 letrd ceu epr ere loge eqbrtrd rpcnd wne
        vmage0 readdcl vmalelog remulcld rpmulcl nnge1d leadd2dd 2timesd simpli
        c3 egt2lt3 ltleii nngt0d lemul1 syl112anc logled relogmul oveq1i syl6eq
        absdifled mpbir2and lediv1dd efle df-e 3brtr4g syl5eqbr logleb logdivlt
        syl22anc fveq2i relogefd syl5eq cexp 2rp rpdivcl rpcnne0d div12 syl3anc
        rpdivcld 2ne0 divcan3d resqcld rehalfcld 1rp rpaddcl readdcld ltaddrp2d
        sqvald efgt1p2 syl6breqr eqbrtrrd ltdiv23d ) AEBUAZEUBPZUCUAZEUDUAZEUBP
        ZCAUWNAUWNAUWMEAEUEQZUWMUFQAEMUGZUEUFEBBHIUJUHUKZUWSUIULUMAUWPEAEUWSUNZ
        UWSUIZAUORVAPZUFCUORUPJUQZAUWOUWMUCUAZEUBPZUWQVLAUWOUXEEUCUAZUBPUXFAUWM
        EAUWMUWTULZAEAEMURZULZAEMUSUTAUXGEUXEUBAEUXIAEAEMVBZVCVDVEVFAUXEUWPEAUW
        MUXHUMZUXAUWSAUXEERVGPZVHUAZRVIPZUCUAZUWPUXLAUXOAUXOAUXNUFQZUXOUFQAUXMW
        CQZUXQAEMVJZUXMVKUKZUXNVMUKULUMUXAAUXEUXMBUAZUWMVIPZUCUAUXPVLOAUYBUXOUC
        AUYBUXMVNUAZUXMVIPZEVNUAZEVIPZVIPUYCUYEVIPZUXMEVIPZVIPUXOAUYAUYDUWMUYFV
        IAUXMUEQUYAUYDVOAUXMUXSUGZUXMBHIVPUKAUWRUWMUYFVOUWSEBHIVPUKVQAUYCUXMUYE
        EAUYCAUXMUFQZUYCUFQAEUFQZUYJUXIEVRUKZUXMVSUKULAUXMUYLULAUYEAUYKUYEUFQUX
        IEVSUKULZUXJVTAUYGUXNUYHRVIAUYGUYEUXNVGPZUYEVIPUXNAUYCUYNUYEVIAEWAQUYCU
        YNVOUXKEWDUKWBAUYEUXNUYMAUXNUXTULWEVFAEWFQRWFQUYHRVOUXJWGERWHWIVQWJWKWL
        AUXPUWPVLSRUWPVIPZUXNVLSUXNRUWPVGPZVLSAUYOUOUXNARUWPRUFQZAWMWNZUXAWOUOU
        FQAWPWNUXTAUYOUOVLSZRUWPVLSZARUWPUYRUXAARTCUBPZUWPUYRATUFQZCUEQZVUAUFQZ
        WQACUXDAUOCWRSZCRWRSZACUXCQVUEVUFXFJCUORWSUKZWTZXAZTCXBXCZUXAARTVUAUYRV
        UBAWQWNZVUJRTWRSAXDWNATTRUBPZVUAWRTXQXEAVUFVULVUAWRSZAVUEVUFVUGXGACUFQU
        YQVUBVUEUORWRSZUOTWRSZVUFVUMXHUXDUYRVUKVUHVUNAXIWNVUOAXJWNCRTXKXLXMXNXO
        ZAVUAUWPWRSZVUAXRUAZUWPXRUAZWRSZAVUREVUSWRAVURFEWRKAFGEAFAFVURUEKAVUAVU
        JXPXSZXTZAGUFQZFGWRSZAGFYAVAPQZVVCVVDXFZLAFYBQVVEVVFXHAFVVAYCFGYDUKXMZW
        TUXIAVVCVVDVVGXGAGEWRSEDGYHPVLSNWTXOZXNAEUWSYEYFAVUDUWPUFQZVUQVUTXHVUJU
        XAVUAUWPYIYGYJXOYKZAUYQVVIUYSUYTXHWMUXARUWPYLXCYJAUXRUOUXNVLSUXSUXMUUAU
        KYMAUXNUXMUDUAZUYPUXTAUXMUYIUNAUYQVVIUYPUFQWMUXARUWPUUBXCAUXRUXNVVKVLSU
        XSUXMUUCUKAVVKYNEYHPZUDUAZUYPVLAUXMVVLVLSVVKVVMVLSAUXMTEYHPZVVLUYLATEVU
        KUXIUUDAVVLAYNUEQZUWRVVLUEQYOUWSYNEUUEXCZXTAUXMEEVGPVVNVLAREEUYRUXIUXIA
        EMUUFUUGAEUXJUUHYFATYNVLSZVVNVVLVLSZVVQATYNWQYPTYNWRSYNUUJWRSUUKUUIUULW
        NAVUBYNUFQZUYKUOEWRSVVQVVRXHVUKVVSAYPWNUXIAEMUUMTYNEUUNUUOXMYMAUXMVVLUY
        IVVPUUPXMAVVMYNUDUAZUWPVGPZUYPAVVOUWRVVMVWAVOYOUWSYNEUUQXCVVTRUWPVGYQUU
        RUUSWLYMAUXNRUWPUXTUYRUXAUUTUVAYMUVBYRAUWQCUXBUXDAUWQFUDUAZFUBPZCUXBAVW
        BFAFVVAUNVVAUIUXDAFEWRSZUWQVWCWRSZVVHAFUFQYNFVLSUYKYNEVLSZVWDVWEXHVVBAR
        XRUAZVURYNFVLARVUAVLSZVWGVURVLSZARVUAUYRVUJVUPYKAUYQVUDVWHVWIXHWMVUJRVU
        AUVCXCXMUVDKUVEUXIAVWFVVTUWPVLSZAVVTRUWPVLYQVVJUVFAVVOUWRVWFVWJXHYOUWSY
        NEUVGXCYJFEUVHUVIXMAVWCVUAFUBPCWRAVWBVUAFUBAVWBVURUDUAVUAFVURUDKUVJAVUA
        VUJUVKUVLWBAVUACFVUJVUIVVAAVUATUVMPZTUBPZVUACUBPZFWRAVWLTVWMYHPZTUBPVWM
        AVWKVWNTUBAVWKVUAVUAYHPZVWNAVUAAVUAATUEQVUCVUAUEQZUVNVUITCUVOXCZYSZUWHA
        VUAWFQTWFQZCWFQCUOYTXFVWOVWNVOVWRVWSAXQWNZACVUIUVPVUATCUVQUVRVFWBAVWMTA
        VWMAVUACVWQVUIUVSYSVWTTUOYTAUVTWNUWAVFAVWLRVUAVGPZVWLVGPZFAVWKAVUAVUJUW
        BUWCZAVXAVWLAVXAARUEQVWPVXAUEQUWDVWQRVUAUWEXCZXTVXCUWFVVBAVWLVXAVXCVXDU
        WGAVXBVURFWRAVWPVXBVURWRSVWQVUAUWIUKKUWJXOUWKUWLYRXOYKYM $.
    $}

    pntpbnd1.1 $e |- ( ph -> A e. RR+ ) $.
    pntpbnd1.2 $e |- ( ph -> A. i e. NN A. j e. ZZ
   ( abs ` sum_ y e. ( i ... j ) ( ( R ` y ) / ( y x. ( y + 1 ) ) ) ) <_ A ) $.
    pntpbnd1.c $e |- C = ( A + 2 ) $.
    pntpbnd1.k $e |- ( ph -> K e. ( ( exp ` ( C / E ) ) [,) +oo ) ) $.
    pntpbnd1.3 $e |- ( ph -> -. E. y e. NN ( ( Y < y /\ y <_ ( K x. Y ) ) /\
        ( abs ` ( ( R ` y ) / y ) ) <_ E ) ) $.
    $( Lemma for ~ pntpbnd .  (Contributed by Mario Carneiro, 11-Apr-2016.) $)
    pntpbnd1 $p |- ( ph ->
      sum_ n e. ( ( ( |_ ` Y ) + 1 ) ... ( |_ ` ( K x. Y ) ) )
        ( abs ` ( ( R ` n ) / ( n x. ( n + 1 ) ) ) ) <_ A ) $=
      ( vx vm cfl cfv c1 caddc co cmul cfz cv cdiv csu cabs cle cc0 wbr wral wa
      wceq fzfid wcel cr crp cn cuz cpnf cioo ioossre sseldi 0re c2 ce eliooord
      a1i clt syl simpld sylancr syl5eqel ltled elfzuz nnuz uztrn2 syl2an nnrpd
      reefcld ffvelrni peano2nnd adantlr weq fveq2 breq2d rspccva adantll nnred
      fsumrecl nngt0d divge0 syl22anc fsumge0 absidd sumeq2dv cneg recnd breq1d
      renegcld le0neg1d mpbid mpbird absnidd breqtrd wo wb eqbrtrrd cz flcld wi
      sylancl oveq2 raleqdv orbi12d imbi2d wn imp adantr csn oveq1 ralsn syl6bb
      ovex adantl rspcv cmin ad2antrr anbi12d id oveq12d fveq2d elrpd rerpdivcl
      cn0 2re efgt0 syl6breqr flge0nn0 syl2anc nn0p1nn nnmulcld nndivred eqtr4d
      lttrd pntrf fsumneg nnne0d divnegd breqtrrd 3eqtr4rd cico cxr wss rpaddcl
      nncnd rpdivcld rpred pnfxr icossre sseldd remulcld mulid2d efgt1 elicopnf
      2rp simplbda mpdan ltletrd ltmul1 syl112anc flword2 syl3anc uzid sylanbrc
      1re elfzuzb elfzle3 elfzel2 zred ltp1d peano2re ltnled pm2.21dd rgen olci
      a1ii cfzo elfzofz elfzp12 syl5ib letrid oveq2d peano2zd sylan9eqr eluzfz2
      fzsn wrex elfzle1 elfzelz zltp1le fllt elfzle2 flge simpr pntpbnd1a breq2
      a1d jca breq1 rspcev syl12anc mtand subid1d letric adantrl lesub2dd letrd
      ord simprl abssuble0d 3brtr4d expr mt3d ex syl6ibr ancld cun fzsuc ralunb
      syld sylibrd addge02d negsubd abssubge0d orim12d jaodan syldan expcom a2d
      con1d fzind2 mpcom mpjaodan cbvsumv sumeq1d syl5eq rspc2va syl21anc ) ALU
      EUFZUGUHUIZJLUJUIZUEUFZUKUIZHULZEUFZVVCVVCUGUHUIZUJUIZUMUIZHUNZUOUFZVVBVV
      GUOUFZHUNZCUPAUQFULZEUFZUPURZFVVBUSZVVIVVKVAVVMUQUPURZFVVBUSZAVVOUTZVVIVV
      HVVKVVRVVHVVRVVBVVGHVVRVUSVVAVBZAVVCVVBVCZVVGVDVCZVVOAVVTUTZVVDVVFVWBVVCV
      EVCVVDVDVCZVWBVVCAVUSVFVCZVVCVUSVGUFZVCVVCVFVCVVTAVURUUCVCZVWDALVDVCZUQLU
      PURVWFAKVHVIUIZVDLKVHVJQVKZAUQLUQVDVCZAVLVPZVWIAUQKLVWKAKVMIUMUIZVNUFZVDP
      AVWLAVMVDVCIVEVCVWLVDVCZUUDAIAUQUGVIUIZVDIUQUGVJOVKAUQIVQURZIUGVQURZAIVWO
      VCZVWPVWQUTOIUQUGVOVRVSUUAZVMIUUBVTZWHWAVWIAUQVWMKVQAVWNUQVWMVQURVWTVWLUU
      EVRPUUFAKLVQURZLVHVQURZALVWHVCZVXAVXBUTQLKVHVOVRVSUUMZWBLUUGUUHVURUUIVRZV
      VCVUSVVAWCUGVVCVUSVFWDWEWFZWGVEVDVVCEEMNUUNZWIVRZVWBVVCVVEVXFVWBVVCVXFWJU
      UJZUUKZWKZWRVVRVVBVVGHVVSVXKVVRVVTUTZVWCUQVVDUPURZVVFVDVCZUQVVFVQURZUQVVG
      UPURAVVTVWCVVOVXHWKVVOVVTVXMAVVNVXMFVVCVVBFHWLZVVMVVDUQUPVVLVVCEWMZWNWOWP
      VXLVVFAVVTVVFVFVCZVVOVXIWKZWQVXLVVFVXSWSVVDVVFWTXAZXBXCVVRVVBVVJVVGHVXLVV
      GVXKVXTXCXDUULAVVQUTZVVBVVGXEZHUNZVVHXEZVVKVVIVYAVVBVVGHVYAVUSVVAVBZVYAVV
      TUTZVVGAVVTVWAVVQVXJWKZXFUUOZVYAVVBVVJVYBHVYFVVGVYGVYFVVGUQUPURUQVYBUPURV
      YFUQVVDXEZVVFUMUIZVYBUPVYFVYIVDVCUQVYIUPURZVXNVXOUQVYJUPURVYFVVDAVVTVWCVV
      QVXHWKZXHVYFVVDUQUPURZVYKVVQVVTVYMAVVPVYMFVVCVVBVXPVVMVVDUQUPVXQXGWOWPVYF
      VVDVYLXIXJVYFVVFAVVTVXRVVQVXIWKZWQVYFVVFVYNWSVYIVVFWTXAAVVTVYBVYJVAVVQVWB
      VVDVVFVWBVVDVXHXFVWBVVFVXIUVDVWBVVFVXIUUPUUQWKUURZVYFVVGVYGXIXKXLXDVYAVVH
      VYAVVBVVGHVYEVYGWRZVYAVVHUQUPURUQVYDUPURVYAUQVYCVYDUPVYAVVBVYBHVYEVYFVVGV
      YGXHVYOXBVYHXMVYAVVHVYPXIXKXLUUSVVAVURVVAUKUIZVCZAVVOVVQXNZAVVAVURVGUFVCZ
      VVAVVAVGUFVCZVYRAVWGVUTVDVCZLVUTUPURVYTVWIAJLADIUMUIZVNUFZVHUUTUIZVDJAWUD
      VDVCZVHUVAVCWUEVDUVBAWUCAWUCADIADCVMUHUIZVETACVEVCVMVEVCWUGVEVCRUVNCVMUVC
      XTWAVWSUVEZUVFWHZUVGWUDVHUVHXTUAUVIZVWIUVJZALVUTVWIWUKAUGLUJUIZLVUTVQALAL
      VWIXFUVKAUGJVQURZWULVUTVQURZAUGWUDJUGVDVCZAUWDVPZWUIWUJAWUCVEVCUGWUDVQURW
      UHWUCUVLVRAJWUEVCZWUDJUPURZUAAWUQJVDVCZWURAWUFWUQWUSWURUTXOWUIWUDJUVMVRUV
      OUVPUVQAWUOWUSVWGUQLVQURWUMWUNXOWUPWUJVWIVXDUGJLUVRUVSXJXPWBLVUTUVTUWAZAV
      VAXQVCZWUAAVUTWUKXRZVVAUWBVRVVAVURVVAUWEUWCAVVNFVUSUCULZUKUIZUSZVVPFWVDUS
      ZXNZXSAVVNFVUSVURUKUIZUSZVVPFWVHUSZXNZXSAVVNFVUSUDULZUKUIZUSZVVPFWVMUSZXN
      ZXSAVVNFVUSWVLUGUHUIZUKUIZUSZVVPFWVRUSZXNZXSAVYSXSUCUDVVAVURVVAWVCVURVAZW
      VGWVKAWWBWVEWVIWVFWVJWWBVVNFWVDWVHWVCVURVUSUKYAZYBWWBVVPFWVDWVHWWCYBYCYDU
      CUDWLZWVGWVPAWWDWVEWVNWVFWVOWWDVVNFWVDWVMWVCWVLVUSUKYAZYBWWDVVPFWVDWVMWWE
      YBYCYDWVCWVQVAZWVGWWAAWWFWVEWVSWVFWVTWWFVVNFWVDWVRWVCWVQVUSUKYAZYBWWFVVPF
      WVDWVRWWGYBYCYDWVCVVAVAZWVGVYSAWWHWVEVVOWVFVVQWWHVVNFWVDVVBWVCVVAVUSUKYAZ
      YBWWHVVPFWVDVVBWWIYBYCYDVYTAWVKWVJWVIVVPFWVHVVLWVHVCZVUSVURUPURZVVPVVLVUS
      VURUWFWWJVURVUSVQURWWKYEWWJVURWWJVURVVLVUSVURUWGUWHZUWIWWJVURVUSWWLWWJVUR
      VDVCVUSVDVCWWLVURUWJVRUWKXJUWLUWMUWNUWOWVLVURVVAUWPUIVCZAWVPWWAAWWMWVPWWA
      XSZAWWMWVLVURVAZWVLVVBVCZXNZWWNAWWMWWQWWMWVLVYQVCZAWWQWVLVURVVAUWQAVYTWWR
      WWQXOWUTWVLVURVVAUWRVRUWSYFAWWOWWNWWPAWWOUTZWWAWVPWWSWWAUQVUSEUFZUPURZWWT
      UQUPURZXNZAWXCWWOAUQWWTVWKAVUSVEVCWWTVDVCAVUSVXEWGVEVDVUSEVXGWIVRUWTYGWWS
      WVSWXAWVTWXBWWSWVSVVNFVUSYHZUSWXAWWSVVNFWVRWXDWWOAWVRVUSVUSUKUIZWXDWWOWVQ
      VUSVUSUKWVLVURUGUHYIUXAAVUSXQVCWXEWXDVAAVURALVWIXRZUXBVUSUXEVRUXCZYBVVNWX
      AFVUSVURUGUHYLZVVLVUSVAZVVMWWTUQUPVVLVUSEWMZWNYJYKWWSWVTVVPFWXDUSWXBWWSVV
      PFWVRWXDWXGYBVVPWXBFVUSWXHWXIVVMWWTUQUPWXJXGYJYKYCXKUXPAWWPUTZWVNWVSWVOWV
      TWXKWVNWVNVVNFWVQYHZUSZUTZWVSWXKWVNWXMWXKWVNUQWVQEUFZUPURZWXMWXKWVNUQWVLE
      UFZUPURZWXPWXKWVLWVMVCZWVNWXRXSWXKWVLVWEVCZWXSWWPWXTAWVLVUSVVAWCZYMZVUSWV
      LUXDVRZVVNWXRFWVLWVMFUDWLZVVMWXQUQUPVVLWVLEWMZWNYNVRWXKWXRWXPWXKWXRUTWXPW
      XQUOUFZWXOWXQYOUIZUOUFZUPURZWXKWYIYEZWXRWXKWYILBULZVQURZWYKVUTUPURZUTZWYK
      EUFZWYKUMUIZUOUFZIUPURZUTZBVFUXFZAWYTYEWWPUBYGWXKWYIUTZWVLVFVCZLWVLVQURZW
      VLVUTUPURZUTZWXQWVLUMUIZUOUFZIUPURZWYTWXKXUBWYIAVWDWXTXUBWWPVXEWYAUGWVLVU
      SVFWDWEWFZYGZWXKXUEWYIWXKXUCXUDWXKXUCVURWVLVQURZWXKXUKVUSWVLUPURZWWPXULAW
      VLVUSVVAUXGYMAVURXQVCWVLXQVCZXUKXULXOWWPWXFWVLVUSVVAUXHZVURWVLUXIWFXKAVWG
      XUMXUCXUKXOWWPVWIXUNLWVLUXJWFXKWXKXUDWVLVVAUPURZWWPXUOAWVLVUSVVAUXKYMAWUB
      XUMXUDXUOXOWWPWUKXUNVUTWVLUXLWFXKUXQYGZXUAEIJWVLKLMNAVWRWWPWYIOYPPAVXCWWP
      WYIQYPXUJXUPWXKWYIUXMUXNWYSXUEXUHUTBWVLVFBUDWLZWYNXUEWYRXUHXUQWYLXUCWYMXU
      DWYKWVLLVQUXOWYKWVLVUTUPUXRYQXUQWYQXUGIUPXUQWYPXUFUOXUQWYOWXQWYKWVLUMWYKW
      VLEWMXUQYRYSYTXGYQUXSUXTUYAZYGWXKWXRWXPYEZWYIWXKWXRXUSUTZUTZWXQWXQWXOYOUI
      ZWYFWYHUPXVAWXQUQYOUIWXQXVBUPXVAWXQXVAWXQWXKWXQVDVCZXUTWXKWVLVEVCXVCWXKWV
      LXUIWGVEVDWVLEVXGWIVRZYGZXFUYBXVAWXOUQWXQWXKWXOVDVCZXUTWXKWVQVEVCXVFWXKWV
      QWXKWVLXUIWJWGVEVDWVQEVXGWIVRZYGZVWJXVAVLVPZXVEWXKXUSWXOUQUPURZWXRWXKXUSX
      VJWXKWXPXVJWXKVWJXVFWXPXVJXNVLXVGUQWXOUYCVTUYGZYFUYDZUYEXPXVAWXQXVEWXKWXR
      XUSUYHZXCXVAWXOWXQXVHXVEXVAWXOUQWXQXVHXVIXVEXVLXVMUYFUYIUYJUYKUYLUYMUYSVV
      NWXPFWVQWVLUGUHYLZVVLWVQVAZVVMWXOUQUPVVLWVQEWMZWNYJUYNUYOWXKWVSVVNFWVMWXL
      UYPZUSWXNWXKVVNFWVRXVQWXKWXTWVRXVQVAWYBVUSWVLUYQVRZYBVVNFWVMWXLUYRYKUYTWX
      KWVOWVOVVPFWXLUSZUTZWVTWXKWVOXVSWXKWVOXVJXVSWXKWVOWXQUQUPURZXVJWXKWXSWVOX
      WAXSWYCVVPXWAFWVLWVMWYDVVMWXQUQUPWYEXGYNVRWXKXWAXVJWXKXWAUTXVJWYIWXKWYJXW
      AXURYGWXKXWAXVJYEZWYIWXKXWAXWBUTZUTZWXQXEZWYGWYFWYHUPXWDXWEWXOXWEUHUIZWYG
      UPXWDWXPXWEXWFUPURWXKXWBWXPXWAWXKXWBWXPWXKWXPXVJXVKVUIYFUYDZXWDXWEWXOXWDW
      XQWXKXVCXWCXVDYGZXHWXKXVFXWCXVGYGZVUAXJXWDWXOWXQXWDWXOXWIXFXWDWXQXWHXFVUB
      XMXWDWXQXWHWXKXWAXWBUYHZXLXWDWXQWXOXWHXWIXWDWXQUQWXOXWHVWJXWDVLVPXWIXWJXW
      GUYFVUCUYJUYKUYLUYMUYSVVPXVJFWVQXVNXVOVVMWXOUQUPXVPXGYJUYNUYOWXKWVTVVPFXV
      QUSXVTWXKVVPFWVRXVQXVRYBVVPFWVMWXLUYRYKUYTVUDVUEVUFVUGVUHVUJVUKVULAVWDWVA
      VVLGULZUKUIZWYOWYKWYKUGUHUIZUJUIZUMUIZBUNZUOUFZCUPURZGXQUSFVFUSVVICUPURZV
      XEWVBSXWRXWSVUSXWKUKUIZVVGHUNZUOUFZCUPURFGVUSVVAVFXQWXIXWQXXBCUPWXIXWPXXA
      UOWXIXWPXWLVVGHUNXXAXWLXWOVVGBHBHWLZWYOVVDXWNVVFUMWYKVVCEWMXXCWYKVVCXWMVV
      EUJXXCYRWYKVVCUGUHYIYSYSVUMWXIXWLXWTVVGHVVLVUSXWKUKYIVUNVUOYTXGXWKVVAVAZX
      XBVVICUPXXDXXAVVHUOXXDXWTVVBVVGHXWKVVAVUSUKYAVUNYTXGVUPVUQXP $.

    $( Lemma for ~ pntpbnd .  (Contributed by Mario Carneiro, 11-Apr-2016.) $)
    pntpbnd2 $p |- -. ph $=
      ( vn vk c1 cle wbr c2 cdiv co 2cn cr wcel 2re a1i cc0 cioo ioossre sseldi
      clt wa syl simpld elrpd crp 2rp cmin caddc oveq1i cc rpcnd sylancl syl5eq
      wceq syl5eqel recnd rpdivcld rpred clog cfv resubcl ce cpnf reefcld mpbid
      wb 0re 1re efgt1 simprd lttrd relogcld breqtrrd syl2anc mpbird cfl cfz cv
      cmul csu fzfid sylancr syl6breqr ltled flge0nn0 nn0p1nn nnrecred fsumrecl
      cn cn0 readdcld eqeltrd elfznn0 adantl remulcld lemul1 syl112anc eqbrtrrd
      readdcl letrd nnrpd flcld peano2zd elfznn fsumshftm pncan oveq12d sumeq1d
      cz ax-1cn logled cem emre ltleii harmonicbnd elicc2i cabs adantr nndivred
      ceu wn dividi eliooord pncan2 oveq1d rpaddcl rpne0d divsubdird rerpdivcld
      2ne0 eqtr3d cico elicopnf 0lt1 reeflogd efle lesub1dd cuz rerpdivcl efgt0
      cxr rexrd elioopnf elfzuz nnuz uztrn2 syl2an peano2nnd pnpcan2d relogmuld
      ltletrd mulid2d 1z nnrecre oveq2 1m1e0 cin c0 reflcl ltp1d fzdisj flwordi
      cun syl3anc elfz2nn0 syl3anbrc fzsplit fsumsplit 3eqtrd rpmulcld resubcld
      zcnd fllep1 emgt0 cicc simp2bi subge0d breqtrd simp3bi lesubaddd peano2re
      eqtrd epr rpmulcl flle le2addd 2timesd ere egt2lt3 simpli relogmul syl6eq
      c3 loge leadd2dd df-2 addassd leadd1dd lesubadd2d fsummulc2 nncnd divrecd
      nnne0d eqeltrrd pntrf ffvelrni nnmulcld wrex wi elfzle1 nnzd zltp1le fllt
      abscld elfzle2 breq2 breq1 anbi12d fveq2 id fveq2d breq1d rspcev syl12anc
      flge expr mtod letrid ord lediv1dd absdivd divdiv1d rprege0d absid oveq2d
      mpd 3eqtr3rd 3brtr3d fsumle pntpbnd1 lemuldiv2d subled lediv23d syl5eqbrr
      eqbrtrd ltnle pm2.65i ) AUDHUEUFZAUDUGUGUHUIHUEUGUJUUIUUAAUGHUGUGUKULZAUM
      UNZAHAUOUDUPUIZUKHUOUDUQNURZAUOHUSUFZHUDUSUFZAHVVJULVVLVVMUTNHUOUDUUBVAZV
      BVCZUGVDULZAVEUNZAUGHUHUIZDHUHUIZCHUHUIZVFUIZUGUEADCVFUIZHUHUIVVRVWAAVWBU
      GHUHAVWBCUGVGUIZCVFUIZUGDVWCCVFSVHACVIULUGVIULZVWDUGVMACQVJZUJCUGUUCVKVLU
      UDADCHADADVWCVDSACVDULVVPVWCVDULQVECUGUUEVKVNZVJVWFAHVVKVOZAHVVOUUFUUGUUJ
      AVVSUGVVTAVVSADHVWGVVOVPZVQZVVIACHACQVQZVVOUUHZAVVSUGVFUIZIVRVSZUGVFUIZVV
      TAVVSUKULZVVHVWMUKULVWJUMVVSUGVTVKAVWNUKULZVVHVWOUKULAIAIAIUKULZVVSWAVSZI
      UEUFZAIVWSWBUUKUIULZVWRVWTUTZTAVWSUKULVXAVXBWEAVVSVWJWCZVWSIUULVAWDZVBZAU
      OUDIUOUKULAWFUNZUDUKULZAWGUNZVXEUOUDUSUFAUUMUNAUDVWSIVXHVXCVXEAVVSVDULUDV
      WSUSUFVWIVVSWHVAAVWRVWTVXDWIZUVJZWJVCZWKZUMVWNUGVTVKZVWLAVVSVWNUGVWJVXLVV
      IAVVSVWNUEUFZVWSVWNWAVSZUEUFZAVWSIVXOUEVXIAIVXKUUNWLAVWPVWQVXNVXPWEVWJVXL
      VVSVWNUUOWMWNUUPAVWOKWOVSZUDVGUIZIKWRUIZWOVSZWPUIZUDUBWQZUDVGUIZUHUIZUBWS
      ZVVTVXMAVYAVYDUBAVXRVXTWTZAVYBVYAULZUTZVYCVYHVYBAVXRXHULZVYBVXRUUQVSULVYB
      XHULZVYGAVXQXIULZVYIAKUKULZUOKUEUFVYKAJWBUPUIZUKKJWBUQPURZAUOKVXFVYNAUOJK
      VXFAJVVRWAVSZUKOAVVRAVVHHVDULVVRUKULZUMVVOUGHUURXAZWCVNZVYNAUOVYOJUSAVYPU
      OVYOUSUFVYQVVRUUSVAOXBAVYLJKUSUFZAKVYMULZVYLVYSUTZPAJUUTULVYTWUAWEAJVYRUV
      AJKUVBVAWDWIZWJZXCZKXDWMZVXQXEVAZVYBVXRVXTUVCUDVYBVXRXHUVDUVEUVFZUVGZXFZX
      GZVWLAVWNKVRVSZVGUIZUGWUKVGUIZVFUIZVWOVYEUEAVWNUGWUKAVWNVXLVOVWEAUJUNAWUK
      AKAKVYNWUCVCZWKZVOZUVHAWUNVYEUEUFWULWUMVYEVGUIZUEUFAVXSVRVSZWULWURUEAIKVX
      KWUOUVIZAWUSUOVXQWPUIZVYDUBWSZVYEVGUIZWURAWUSWULUKWUTAVWNWUKVXLWUPXJZXKZA
      WVBVYEAWVAVYDUBAUOVXQWTAVYBWVAULZUTZVYCWVGVYBXIULZVYCXHULZWVFWVHAVYBVXQXL
      XMVYBXEZVAXFXGZWUJXJZAWUMVYEAVVHWUKUKULZWUMUKULUMWUPUGWUKXRXAZWUJXJAWUSUD
      VXTUDVGUIZWPUIZUDUCWQZUHUIZUCWSZWVCUEAWUSWVOVRVSZWVSWVEAWVOAWVOAVXTXIULZW
      VOXHULZAVXSUKULZUOVXSUEUFWWAAIKVXEVYNXNZAUOKVXSVXFVYNWWDWUDAUDKWRUIZKVXSU
      EAKAKVYNVOZUVKAUDIUEUFZWWEVXSUEUFZAUDIVXHVXEVXJXCAVXGVWRVYLUOKUSUFZWWGWWH
      WEVXHVXEVYNWUCUDIKXOXPWDXQZXSVXSXDWMZVXTXEVAZXTZWKZAWVSWVCUKAWVSUDUDVFUIZ
      WVOUDVFUIZWPUIZVYDUBWSUOVXTWPUIZVYDUBWSWVCAWVRVYDUCUBUDUDWVOUDYHULAUVLUNZ
      WWSAVXTAVXSWWDYAZYBAWVQWVPULZUTWVQXHULZWVRVIULZWXAWXBAWVQWVOYCXMWXBWVRWVQ
      UVMVOZVAWVQVYCUDUHUVNZYDAWWQWWRVYDUBAWWOUOWWPVXTWPWWOUOVMAUVOUNZAVXTVIULU
      DVIULZWWPVXTVMAVXTWWTUWKYIVXTUDYEVKYFYGAWVAVYAVYDWWRUBAVXQVXRUSUFWVAVYAUV
      PUVQVMAVXQAVYLVXQUKULZVYNKUVRVAZUVSUOVXQVXRVXTUVTVAAVXQWWRULZWWRWVAVYAUWB
      VMAVYKWWAVXQVXTUEUFZWXJWUEWWKAVYLWWCKVXSUEUFWXKVYNWWDWWJKVXSUWAUWCVXQVXTU
      WDUWEVXQUOVXTUWFVAAUOVXTWTAVYBWWRULZUTZVYDWXMVYCWXMWVHWVIWXLWVHAVYBVXTXLX
      MWVJVAXFVOUWGUWHZWVLXKZAVXSWVOUEUFZWUSWVTUEUFAWWCWXPWWDVXSUWLVAAVXSWVOAIK
      VXKWUOUWIWWMYJWDAUOWVSWVTVFUIZUEUFWVTWVSUEUFAUOYKWXQVXFYKUKULAYLUNAWVSWVT
      WXOWWNUWJUOYKUEUFAUOYKWFYLUWMYMUNAWXQYKUDUWNUIZULZYKWXQUEUFZAWWBWXSWWLUCW
      VOYNVAWXSWXQUKULWXTWXQUDUEUFYKUDWXQYLWGYOUWOVAXSAWVSWVTWXOWWNUWPWDXSWXNUW
      QAWVBWUMVYEWVKWVNWUJAUDVXRWPUIZWVRUCWSZWVBWUMUEAWYBWWOVXRUDVFUIZWPUIZVYDU
      BWSWVBAWVRVYDUCUBUDUDVXRWWSWWSAVXQAKVYNYAYBAWVQWYAULZUTWXBWXCWYEWXBAWVQVX
      RYCXMWXDVAWXEYDAWYDWVAVYDUBAWWOUOWYCVXQWPWXFAVXQVIULWXGWYCVXQVMAVXQWXIVOY
      IVXQUDYEVKYFYGUXAZAWYBUDVXRVRVSZVGUIZWUMAWYBWVBUKWYFWVKXKZAVXGWYGUKULWYHU
      KULWGAVXRAVXRWUFXTZWKZUDWYGXRXAWVNAWYBWYGVFUIZUDUEUFZWYBWYHUEUFAWYLWXRULZ
      WYMAVYIWYNWUFUCVXRYNVAWYNWYLUKULYKWYLUEUFWYMYKUDWYLYLWGYOUWRVAAWYBWYGUDWY
      IWYKVXHUWSWDAWYHUDUDWUKVGUIZVGUIZWUMUEAWYGWYOUDWYKAVXGWVMWYOUKULWGWUPUDWU
      KXRXAVXHAWYGYSKWRUIZVRVSZWYOUEAVXRWYQUEUFWYGWYRUEUFAVXRUGKWRUIZWYQAWXHVXR
      UKULWXIVXQUWTVAAUGKVVIVYNXNAWYQAYSVDULZKVDULZWYQVDULUXBWUOYSKUXCXAZVQAVXR
      KKVGUIWYSUEAVXQUDKKWXIVXHVYNVYNAVYLVXQKUEUFVYNKUXDVAAUDKVXHVYNAUDJKVXHVYR
      VYNAUDVYOJUSAVVRVDULUDVYOUSUFAUGHVVQVVOVPVVRWHVAOXBWUBWJXCUXEAKWWFUXFWLAU
      GYSUEUFZWYSWYQUEUFZXUCAUGYSUMUXGUGYSUSUFYSUXLUSUFUXHUXIYMUNAVVHYSUKULZVYL
      WWIXUCXUDWEVVIXUEAUXGUNVYNWUCUGYSKXOXPWDXSAVXRWYQWYJXUBYJWDAWYRYSVRVSZWUK
      VGUIZWYOAWYTXUAWYRXUGVMUXBWUOYSKUXJXAXUFUDWUKVGUXMVHUXKUWQUXNAWUMUDUDVGUI
      ZWUKVGUIWYPUGXUHWUKVGUXOVHAUDUDWUKWXGAYIUNZXUIWUQUXPVLWLXSXQUXQXSXQAWULWU
      MVYEWVDWVNWUJUXRWNXQAHVYEWRUIZCUEUFVYEVVTUEUFAXUJVYAHVYDWRUIZUBWSZCUEAVYA
      VYDHUBVYFVWHVYHVYDWUIVOUXSAXULVYAVYBEVSZVYBVYCWRUIZUHUIZYPVSZUBWSCAVYAXUK
      UBVYFVYHHVYCUHUIZXUKUKVYHHVYCVYHHAHUKULZVYGVVKYQZVOVYHVYCWUHUXTZVYHVYCWUH
      UYBZUYAZVYHHVYCXUSWUHYRUYCZXGAVYAXUPUBVYFVYHXUOVYHXUOVYHXUMXUNVYHVYBVDULX
      UMUKULVYHVYBWUGXTVDUKVYBEELMUYDUYEVAZVYHVYBVYCWUGWUHUYFYRVOUYMZXGVWKAVYAX
      UKXUPUBVYFXVCXVEVYHXUQXUMVYBUHUIZYPVSZVYCUHUIZXUKXUPUEVYHHXVGVYCXUSVYHXVF
      VYHXVFVYHXUMVYBXVDWUGYRVOZUYMZVYHVYCWUHXTZVYHXVGHUEUFZYTHXVGUEUFZVYHXVLKB
      WQZUSUFZXVNVXSUEUFZUTZXVNEVSZXVNUHUIZYPVSZHUEUFZUTZBXHUYGZAXWCYTVYGUAYQVY
      HVYJKVYBUSUFZVYBVXSUEUFZXVLXWCUYHWUGVYHXWDVXQVYBUSUFZVYHXWFVXRVYBUEUFZVYG
      XWGAVYBVXRVXTUYIXMVYHVXQYHULVYBYHULZXWFXWGWEVYHKAVYLVYGVYNYQZYAVYHVYBWUGU
      YJZVXQVYBUYKWMWNVYHVYLXWHXWDXWFWEXWIXWJKVYBUYLWMWNVYHXWEVYBVXTUEUFZVYGXWK
      AVYBVXRVXTUYNXMVYHWWCXWHXWEXWKWEAWWCVYGWWDYQXWJVXSVYBVUDWMWNVYJXWDXWEUTZX
      VLXWCXWBXWLXVLUTBVYBXHXVNVYBVMZXVQXWLXWAXVLXWMXVOXWDXVPXWEXVNVYBKUSUYOXVN
      VYBVXSUEUYPUYQXWMXVTXVGHUEXWMXVSXVFYPXWMXVRXUMXVNVYBUHXVNVYBEUYRXWMUYSYFU
      YTVUAUYQVUBVUEVUCVUFVYHXVLXVMVYHXVGHXVJXUSVUGVUHVUOVUIXVBVYHXVFVYCUHUIZYP
      VSXVGVYCYPVSZUHUIXUPXVHVYHXVFVYCXVIXUTXVAVUJVYHXWNXUOYPVYHXUMVYBVYCVYHXUM
      XVDVOVYHVYBWUGUXTXUTVYHVYBWUGUYBXVAVUKUYTVYHXWOVYCXVGUHVYHVYCUKULUOVYCUEU
      FUTXWOVYCVMVYHVYCXVKVULVYCVUMVAVUNVUPVUQVURABCDEFGUBHIJKLMNOPQRSTUAVUSXSV
      VDAVYECHWUJVWKVVOVUTWDXSXSVVAVVDVVBVVCAVVMVVGYTZAVVLVVMVVNWIAXURVXGVVMXWP
      WEVVKWGHUDVVEVKWDVVF $.
  $}

  ${
    $d a d i j k m n t u v w x y z E $.  $d n t u v x z L $.  $d a u x y z N $.
    $d u v x A $.  $d n t u v w x y C $.  $d c d e i j k m n t u v w x y z R $.
    $d m K $.  $d z M $.  $d x y T $.  $d z Y $.  $d k m n u v w x y Z $.
    $d k n t u w ph $.
    pntibnd.r $e |- R = ( a e. RR+ |-> ( ( psi ` a ) - a ) ) $.
    $( Lemma for ~ pnt .  Establish smallness of ` R ` at a point.  Lemma
       10.6.1 in [Shapiro], p. 436.  (Contributed by Mario Carneiro,
       10-Apr-2016.) $)
    pntpbnd $p |- E. c e. RR+ A. e e. ( 0 (,) 1 ) E. x e. RR+
      A. k e. ( ( exp ` ( c / e ) ) [,) +oo )
      A. y e. ( x (,) +oo ) E. n e. NN ( ( y < n /\ n <_ ( k x. y ) ) /\
        ( abs ` ( ( R ` n ) / n ) ) <_ e ) $=
      ( cv co cfv cdiv wbr wral crp wa cpnf wcel c2 vi vj vd cfz caddc cmul csu
      c1 cabs cle cz cn wrex clt cioo ce cico cc0 pntrsumbnd2 simpl 2rp rpaddcl
      sylancl cr elioore adantl eliooord simpld elrpd rerpdivcl sylancr rpefcld
      wi simpllr eqid simplrr simp-4l simp-4r simplrl simpr pntpbnd2 iman mpbir
      2re ralrimivva wceq oveq1 raleqdv ralbidv rspcev syl2anc ralrimiva fveq2d
      wn oveq1d rexbidv rexlimiva ax-mp ) UAJUBJUDKFJZCLZWSWSUHUEKUFKMKFUGUILUC
      JZUJNUBUKOUAULOZUCPUMBJZWSUNNWSEJZXCUFKUJNQWTWSMKUILDJZUJNQFULUMZBAJZRUOK
      ZOZEHJZXEMKZUPLZRUQKZOZAPUMZDURUHUOKZOZHPUMZCUAUBFGUCIUSXBXRUCPXAPSZXBQZX
      ATUEKZPSZXIEYAXEMKZUPLZRUQKZOZAPUMZDXPOZXRXTXSTPSYBXSXBUTVAXATVBVCXTYGDXP
      XTXEXPSZQZTXEMKZUPLZPSXFBYLRUOKZOZEYEOZYGYJYKYJTVDSXEPSYKVDSWDYJXEYIXEVDS
      XTXEURUHVEVFYJURXEUNNZXEUHUNNZYIYPYQQXTXEURUHVGVFVHVITXEVJVKVLYJXFEBYEYMY
      JXDYESZXCYMSZQZQZXFVMUUAXFWNZQZWNUUCFXAYACUAUBXEXDYLXCGIXTYIYTUUBVNYLVOYJ
      YRYSUUBVPXSXBYIYTUUBVQXSXBYIYTUUBVRYAVOYJYRYSUUBVSUUAUUBVTWAUUAXFWBWCWEYF
      YOAYLPXGYLWFZXIYNEYEUUDXFBXHYMXGYLRUOWGWHWIWJWKWLXQYHHYAPXJYAWFZXOYGDXPUU
      EXNYFAPUUEXIEXMYEUUEXLYDRUQUUEXKYCUPXJYAXEMWGWMWOWHWPWIWJWKWQWR $.

    pntibndlem1.1 $e |- ( ph -> A e. RR+ ) $.
    pntibndlem1.l $e |- L = ( ( 1 / 4 ) / ( A + 3 ) ) $.
    $( Lemma for ~ pntibnd .  (Contributed by Mario Carneiro, 10-Apr-2016.) $)
    pntibndlem1 $p |- ( ph -> L e. ( 0 (,) 1 ) ) $=
      ( cr wcel cc0 clt wbr c1 co c4 cdiv c3 crp a1i cioo caddc cn nnrp rpreccl
      4nn mp2b ax-mp rpaddcl sylancl rpdivcl sylancr syl5eqel rpred rpgt0d rpcn
      3nn cc div1i rpre mp1i 3re 1lt4 4re 4pos recgt1 mp2an mpbi 1lt3 1re lttri
      wb ltaddrp wceq rpcnd addcom breqtrd lttrd syl5eqbr 0lt1 rpregt0d ltdiv23
      3cn wa syl121anc mpbid cxr w3a 0xr rexri elioo2 syl3anbrc ) ADIJZKDLMZDNL
      MZDKNUAOJZADADNPQOZBRUBOZQOZSHAWQSJZWRSJZWSSJPUCJPSJWTUFPUDPUEUGZABSJZRSJ
      ZXAGRUCJXDUQRUDUHBRUIUJZWQWRUKULUMZUNADXFUOADWSNLHAWQNQOZWRLMZWSNLMZAXGWQ
      WRLWQWTWQURJXBWQUPUHUSAWQRWRWTWQIJZAXBWQUTZVAZRIJZAVBTAWRXEUNWQRLMZAWQNLM
      ZNRLMXNNPLMZXOVCPIJKPLMXPXOVLVDVEPVFVGVHVIWQNRWTXJXBXKUHVJVBVKVGTARRBUBOZ
      WRLAXMXCRXQLMVBGRBVMULARURJBURJXQWRVNWCABGVORBVPULVQVRVSAXJNIJZKNLMZWRIJK
      WRLMWDXHXIVLXLXRAVJTXSAVTTAWRXEWAWQNWRWBWEWFVSKWGJNWGJWPWMWNWOWHVLWINVJWJ
      KNDWKVGWL $.

    pntibndlem3.2 $e |- ( ph ->
      A. x e. RR+ ( abs ` ( ( R ` x ) / x ) ) <_ A ) $.
    pntibndlem3.3 $e |- ( ph -> B e. RR+ ) $.
    pntibndlem3.k $e |- K = ( exp ` ( B / ( E / 2 ) ) ) $.
    pntibndlem3.c $e |- C = ( ( 2 x. B ) + ( log ` 2 ) ) $.
    pntibndlem3.4 $e |- ( ph -> E e. ( 0 (,) 1 ) ) $.
    pntibndlem3.6 $e |- ( ph -> Z e. RR+ ) $.
    ${
      pntibndlem2.10 $e |- ( ph -> N e. NN ) $.
      $( Lemma for ~ pntibndlem2 .  (Contributed by Mario Carneiro,
         7-Jun-2016.) $)
      pntibndlem2a $p |- ( ( ph /\ u e. ( N [,] ( ( 1 + ( L x. E ) ) x. N ) ) )
        -> ( u e. RR /\ N <_ u /\ u <_ ( ( 1 + ( L x. E ) ) x. N ) ) ) $=
        ( cv c1 cmul co caddc cicc wcel cr cle wbr w3a wb nnred 1re a1i ioossre
        cc0 cioo pntibndlem1 sseldi remulcld readdcld elicc2 syl2anc biimpa ) A
        CUDZKUEJHUFUGZUHUGZKUFUGZUIUGUJZVIUKUJKVIULUMVIVLULUMUNZAKUKUJVLUKUJVMV
        NUOAKUCUPZAVKKAUEVJUEUKUJAUQURAJHAUTUEVAUGZUKJUTUEUSZADGJMNOPVBVCAVPUKH
        VQUAVCVDVEVOVDKVLVIVFVGVH $.

      pntibndlem2.5 $e |- ( ph -> T e. RR+ ) $.
      pntibndlem2.6 $e |- ( ph -> A. x e. ( 1 (,) +oo )
        A. y e. ( x [,] ( 2 x. x ) ) ( ( psi ` y ) - ( psi ` x ) ) <_
          ( ( 2 x. ( y - x ) ) + ( T x. ( x / ( log ` x ) ) ) ) ) $.
      pntibndlem2.7 $e |- X = ( ( exp ` ( T / ( E / 4 ) ) ) + Z ) $.
      pntibndlem2.8 $e |- ( ph -> M e. ( ( exp ` ( C / E ) ) [,) +oo ) ) $.
      pntibndlem2.9 $e |- ( ph -> Y e. ( X (,) +oo ) ) $.
      pntibndlem2.11 $e |- ( ph -> ( ( Y < N /\ N <_ ( ( M / 2 ) x. Y ) ) /\
          ( abs ` ( ( R ` N ) / N ) ) <_ ( E / 2 ) ) ) $.
      $( Lemma for ~ pntibnd .  The main work, after eliminating all the
         quantifiers.  (Contributed by Mario Carneiro, 10-Apr-2016.) $)
      pntibndlem2 $p |- ( ph -> E. z e. RR+ ( ( Y < z /\
          ( ( 1 + ( L x. E ) ) x. z ) < ( M x. Y ) ) /\
          A. u e. ( z [,] ( ( 1 + ( L x. E ) ) x. z ) )
            ( abs ` ( ( R ` u ) / u ) ) <_ E ) ) $=
        ( crp wcel clt wbr c1 cmul co caddc wa cv cfv cdiv cabs cle cicc simpld
        wral c2 cr 1re a1i cc0 ioossre sseldi remulcld readdcld remulcl sylancr
        cioo 2re cpnf cxr clog rpred 2rp syl5eqel eliooord syl elrpd rerpdivcld
        ce reefcld sylancl rpge0d simprd syl6breqr wne wceq recnd mp1i breqtrrd
        cc syl3anc mpbird adantr ffvelrni abscld c3 resubcld 4nn rpdivcld lttrd
        cmin c4 cchp rpne0d oveq2d eqtrd oveq1d ax-1cn rpcnne0d oveq12d addassd
        fveq2d letrd wb syl2anc id oveq2 fveq2 rspcv sylc 2cn rpcnd breqtrd wss
        wrex nnrpd pntibndlem1 nnred cico relogcld pnfxr sseldd ltmul12ad 1t1e1
        icossre syl6breq ltadd2dd df-2 ltmul1dd rpcnne0 lemuldiv2d pntibndlem2a
        div23 ltletrd simp1d simp2d rpgecld nndivred subcld lesubaddd rehalfcld
        pntrf abs2difd mpbid 3re cn nnrp efgt1 ltaddrpd rplogcld peano2re chpcl
        renegcld abstrid divsubdird dividd subdird dmdcan mulid2d 3eqtrd negeqd
        cneg negsubdi2d npncand absnegd absmuld subge0d divge0d absidd rprege0d
        absdivd absid 3brtr3d pntrval subadd4 sub4 addsub4 an42s 3eqtr3d eqtr2d
        syl22anc chpwordi abssubge0d abssuble0d addcomd lediv1dd adddid mulid1d
        leadd2dd divdird 3eqtr4d simp3d wi ltle mpd lemul1d w3a mpbir3and rexri
        elicc2 elioopnf ax-mp sylanbrc breq12d raleqbidv weq oveq1 divdir div12
        divassd divcan3d mulcom 2p1e3 addcomli oveq2i syl6eq 3eqtr2d ledivmul2d
        eqtr3d addcom eqbrtrd breq1d leadd1dd jca 3nn rpaddcl lemul12b divcan1d
        mp2and divrec2d nnne0i reccli div23d oveq1i syl6eqr 2ne0 divdiv1d 2t2e4
        4cn reeflogd eflt ltled lediv23d le2addd 2halvesd ralrimiva jca31 breq2
        anbi12d raleqdv rspcev ) AOUPUQZQOURUSZUTMKVAVBZVCVBZOVAVBZNQVAVBZURUSZ
        VDZEVEZIVFZVWGVGVBZVHVFZKVIUSZEOVWCVJVBZVLZVDZQDVEZURUSZVWBVWOVAVBZVWDU
        RUSZVDZVWKEVWOVWQVJVBZVLZVDZDUPUUBAOUIUUCZAVVTVWEVWMAVVTONVMVGVBQVAVBZV
        IUSZAVVTVXEVDZOIVFZOVGVBZVHVFZKVMVGVBZVIUSZUOVKZVKZAVWCVMOVAVBZVWDAVWBO
        AUTVWAUTVNUQZAVOVPZAMKAVQUTWDVBZVNMVQUTVRZAFIMSTUAUBUUDZVSZAVXQVNKVXRUG
        VSZVTZWAZAOUIUUEZVTZAVMVNUQZOVNUQZVXNVNUQZWEVYDVMOWBWCZANQAHKVGVBZWPVFZ
        WFUUFVBZVNNAVYKVNUQWFWGUQVYLVNUUAAVYJAHKAHVMGVAVBZVMWHVFZVCVBVNUFAVYMVY
        NAVYFGVNUQVYMVNUQWEAGUDWIVMGWBWCAVMVMUPUQZAWJVPZUUGWAWKAKVYAAVQKURUSZKU
        TURUSZAKVXQUQVYQVYRVDUGKVQUTWLWMZVKWNZWOWQUUHVYKWFUULWRUMUUIZAPWFWDVBZV
        NQPWFVRUNVSZVTZAVWBVMOVYCVYFAWEVPVXCAVWBUTUTVCVBVMURAVWAUTUTVYBVXPVXPAV
        WAUTUTVAVBUTURAMUTKUTVXTVXPVYAVXPAMAMVXTAVQMURUSZMUTURUSZAMVXQUQWUEWUFV
        DVXSMVQUTWLWMZVKWNWSAWUEWUFWUGWTAKVYTWSAVYQVYRVYSWTUUJUUKUUMUUNUUOXAZUU
        PAVXNVWDVIUSOVWDVMVGVBZVIUSAOVXDWUIVIAVVTVXEVXLWTANXGUQQXGUQVMXGUQZVMVQ
        XBZVDZWUIVXDXCANWUAXDAQWUCXDVYOWULAWJVMUUQXENQVMUUTXHXFAOVWDVMVYDWUDVYP
        UURXIUVAAVWKEVWLAVWGVWLUQZVDZVWJVWIVXHXRVBZVHVFZVXIVCVBZKWUNVWIWUNVWIWU
        NVWHVWGWUNVWGUPUQZVWHVNUQWUNVWGOWUNVWGVNUQZOVWGVIUSZVWGVWCVIUSZABEFGHIK
        LMOFSTUAUBUCUDUEUFUGUAUIUUSZUVBZAVVSWUMVXCXJZWUNWUSWUTWVAWVBUVCZUVDZUPV
        NVWGIISTUVIZXKWMZWVFWOZXDZXLZWUNWUPVXIWUNWUOWUNVWIVXHWVJWUNVXHAVXHVNUQW
        UMAVXGOAVVSVXGVNUQZVXCUPVNOIWVGXKWMZUIUVEXJXDZUVFXLZWUNVXHWVNXLZWAAKVNU
        QWUMVYAXJZWUNVWJVXIXRVBWUPVIUSVWJWUQVIUSWUNVWIVXHWVJWVNUVJWUNVWJVXIWUPW
        VKWVPWVOUVGUVKWUNWUQVXJVXJVCVBKVIWUNWUPVXIVXJVXJWVOWVPWUNKWVQUVHZWVRWUN
        WUPVWGOXRVBZOVGVBZVWJXMVCVBZVAVBZJOWHVFZVGVBZVCVBZVXJWVOWUNWWBWWDWUNWVT
        WWAWUNWVSOWUNVWGOWVCAVYGWUMVYDXJZXNZWVDWOZWUNVWJXMWVKXMVNUQWUNUVLVPZWAZ
        VTZWUNJWWCAJVNUQWUMAJUJWIXJZWUNOWWFWUNUTJKXSVGVBZVGVBZWPVFZOVXOWUNVOVPZ
        AWWOVNUQWUMAWWNAWWNAJWWMUJAKXSVYTXSUVMUQZXSUPUQZAXOXSUVNZXEXPXPZWIZWQZX
        JWWFAUTWWOURUSZWUMAWWNUPUQWXCWWTWWNUVOWMXJAWWOOURUSWUMAWWOQOWXBWUCVYDAW
        WOPQWXBAPWWORVCVBZVNULAWWORWXBARUHWIWAWKWUCAWWOWXDPURAWWORWXBUHUVPULXAA
        PQURUSZQWFURUSZAQWUBUQWXEWXFVDUNQPWFWLWMVKXQVXMXQXJZXQZUVQZWOZWAZWVRWUN
        WUPWVTVWJUTVCVBZVAVBZVWGXTVFZOXTVFZXRVBZOVGVBZVCVBZWWEWVOWUNWXMWXQWUNWV
        TWXLWWHWUNVWJVNUQWXLVNUQWVKVWJUVRWMZVTZWUNWXPOWUNWXNWXOWUNWUSWXNVNUQWVC
        VWGUVSWMZWUNVYGWXOVNUQWWFOUVSWMZXNZWVDWOZWAZWXKWUNWUPWVTVWJVAVBZVWHVXGX
        RVBZVHVFZOVGVBZVCVBZWXRWVOWUNWYFWYIWUNWVTVWJWWHWVKVTZWUNWYHOWUNWYGWUNWY
        GWUNVWHVXGWVHAWVLWUMWVMXJZXNZXDZXLZWVDWOZWAWYEWUNWVTVWIVAVBZUWIZWYGOVGV
        BZVCVBZVHVFWYRVHVFZWYSVHVFZVCVBWUPWYJVIWUNWYRWYSWUNWYRWUNWYQWUNWVTVWIWW
        HWVIVTZUVTXDWUNWYSWUNWYGOWYMWVDWOXDUWAWUNWYTWUOVHWUNWYTVWIVWHOVGVBZXRVB
        ZXUDVXHXRVBZVCVBWUOWUNWYRXUEWYSXUFVCWUNWYRXUDVWIXRVBZUWIXUEWUNWYQXUGWUN
        WYQVWGOVGVBZUTXRVBZVWIVAVBXUHVWIVAVBZUTVWIVAVBZXRVBXUGWUNWVTXUIVWIVAWUN
        WVTXUHOOVGVBZXRVBXUIWUNVWGOOWUNVWGWVCXDZWUNOWWFXDZXUNWUNOWVDYAZUWBWUNXU
        LUTXUHXRWUNOXUNXUOUWCYBYCZYDWUNXUHUTVWIWUNXUHWUNVWGOWVCWVDWOZXDUTXGUQZW
        UNYEVPZWVJUWDWUNXUJXUDXUKVWIXRWUNVWGXGUQZVWGVQXBVDOXGUQZOVQXBVDZVWHXGUQ
        XUJXUDXCWUNVWGWVFYFWUNOWVDYFZWUNVWHWVHXDZVWGOVWHUWEXHWUNVWIWVJUWFYGUWGU
        WHWUNXUDVWIWUNXUDWUNVWHOWVHWVDWOXDZWVJUWJYCWUNVWHVXGOXVDWUNVXGWYLXDXUNX
        UOUWBYGWUNVWIXUDVXHWVJXVEWVNUWKYCYIWUNXUAWYFXUBWYIVCWUNXUAWYQVHVFWVTVHV
        FZVWJVAVBWYFWUNWYQWUNWYQXUCXDUWLWUNWVTVWIWUNWVTWWHXDZWVJUWMWUNXVFWVTVWJ
        VAWUNWVTWWHWUNWVSOWWGWVDWUNVQWVSVIUSWUTWVEWUNVWGOWVCWWFUWNXIUWOZUWPYDUW
        GWUNXUBWYHOVHVFZVGVBWYIWUNWYGOWYNXUNXUOUWRWUNXVIOWYHVGWUNVYGVQOVIUSVDXV
        IOXCWUNOWVDUWQOUWSWMYBYCYGUWTWUNWYJWYFWVSWXPVCVBZOVGVBZVCVBZWXRVIWUNWYI
        XVKWYFWYPWUNXVJOWUNWVSWXPWWGWYCWAZWVDWOWYKWUNWYHXVJOWYOXVMWVDWUNWXPOVWG
        XRVBZVCVBZVHVFWXPVHVFZXVNVHVFZVCVBZWYHXVJVIWUNWXPXVNWUNWXPWYCXDZWUNOVWG
        XUNXUMUVFUWAWUNXVOWYGVHWUNWYGWXNVWGXRVBZWXOOXRVBZXRVBZXVOWUNVWHXVTVXGXW
        AXRWUNWURVWHXVTXCWVFVWGISTUXAWMWUNVVSVXGXWAXCWVDOISTUXAWMYGWUNWXNXGUQZW
        XOXGUQZXUTXVAXWBXVOXCWUNWXNWYAXDWUNWXOWYBXDXUMXUNXWCXWDVDXUTXVAVDVDWXPW
        VSXRVBWXNOVCVBWXOVWGVCVBXRVBZXWBXVOWXNWXOVWGOUXBWXNWXOVWGOUXCXWCXVAXWDX
        UTXWEXVOXCWXNOWXOVWGUXDUXEUXFUXHUXGYIWUNXVRWXPWVSVCVBXVJWUNXVPWXPXVQWVS
        VCWUNWXOWXNWYBWYAWUNVYGWUSWUTWXOWXNVIUSWWFWVCWVEOVWGUXIXHUXJWUNOVWGWWFW
        VCWVEUXKYGWUNWXPWVSXVSWUNWVSWWGXDZUXLYCUWTUXMUXPWUNWYFWVTVCVBZWXQVCVBWY
        FWVTWXQVCVBZVCVBWXRXVLWUNWYFWVTWXQWUNWYFWYKXDXVGWUNWXQWYDXDYHWUNWXMXWGW
        XQVCWUNWXMWYFWVTUTVAVBZVCVBXWGWUNWVTVWJUTXVGWUNVWJWVKXDZXUSUXNWUNXWIWVT
        WYFVCWUNWVTXVGUXOYBYCYDWUNXVKXWHWYFVCWUNWVSWXPOXWFXVSXUNXUOUXQYBUXRXFYJ
        WUNWXRWXMVMWVTVAVBZWWDVCVBZVCVBZWWEVIWUNWXQXWLWXMWYDWUNXWKWWDWUNVYFWVTV
        NUQZXWKVNUQWEWWHVMWVTWBWCZWXJWAWXTWUNWXQVMWVSVAVBZJOWWCVGVBZVAVBZVCVBZO
        VGVBZXWLVIWUNWXPXWSOWYCWUNXWPXWRWUNVYFWVSVNUQXWPVNUQWEWWGVMWVSWBWCZWUNJ
        XWQWWLWUNOWWCWWFWXIWOZVTWAWVDWUNVWGOVXNVJVBZUQZCVEZXTVFZWXOXRVBZVMXXEOX
        RVBZVAVBZXWRVCVBZVIUSZCXXCVLZWXPXWSVIUSZWUNXXDWUSWUTVWGVXNVIUSZWVCWVEWU
        NVWGVWCVXNWVCAVWCVNUQWUMVYEXJAVYHWUMVYIXJZWUNWUSWUTWVAWVBUXSZWUNVWBVMVI
        USZVWCVXNVIUSAXXQWUMAVWBVMURUSZXXQWUHAVWBVNUQZVYFXXRXXQUXTVYCWEVWBVMUYA
        WRUYBXJWUNVWBVMOAXXSWUMVYCXJZVYFWUNWEVPWVDUYCUVKYJWUNVYGVYHXXDWUSWUTXXN
        UYDYKWWFXXOOVXNVWGUYGYLUYEWUNOUTWFWDVBZUQZXXFBVEZXTVFZXRVBZVMXXEXYCXRVB
        ZVAVBZJXYCXYCWHVFZVGVBZVAVBZVCVBZVIUSZCXYCVMXYCVAVBZVJVBZVLZBXYAVLZXXLW
        UNVYGUTOURUSZXYBWWFWXHUTWGUQXYBVYGXYQVDYKUTVOUYFUTOUYHUYIUYJAXYPWUMUKXJ
        XYOXXLBOXYAXYCOXCZXYLXXKCXYNXXCXYRXYCOXYMVXNVJXYRYMZXYCOVMVAYNYGXYRXYEX
        XGXYKXXJVIXYRXYDWXOXXFXRXYCOXTYOYBXYRXYGXXIXYJXWRVCXYRXYFXXHVMVAXYCOXXE
        XRYNYBXYRXYIXWQJVAXYRXYCOXYHWWCVGXYSXYCOWHYOYGYBYGUYKUYLYPYQXXKXXMCVWGX
        XCCEUYMZXXGWXPXXJXWSVIXYTXXFWXNWXOXRXXEVWGXTYOYDXYTXXIXWPXWRVCXYTXXHWVS
        VMVAXXEVWGOXRUYNYBYDUYKYPYQUXMWUNXWTXWPOVGVBZXWROVGVBZVCVBZXWLWUNXWPXGU
        QXWRXGUQXVBXWTYUCXCWUNXWPXXAXDWUNXWRWUNJXWQWUNJAJUPUQWUMUJXJZWIXXBVTXDX
        VCXWPXWROUYOXHWUNYUAXWKYUBWWDVCWUNVMWVSOWUJWUNYRVPZXWFXUNXUOUYQWUNYUBOW
        WDVAVBZOVGVBWWDWUNXWRYUFOVGWUNJXGUQXVAWWCXGUQWWCVQXBVDXWRYUFXCWUNJWWLXD
        XUNWUNWWCWXIYFJOWWCUYPXHYDWUNWWDOWUNWWDWUNJWWCYUDWXIXPYSXUNXUOUYRYCYGYC
        YTUXPWUNWXMXWKVCVBZWWDVCVBXWMWWEWUNWXMXWKWWDWUNWXMWXTXDWUNXWKXWOXDWUNWW
        DWXJXDYHWUNYUGWWBWWDVCWUNYUGWXMWVTVMVAVBZVCVBWVTWXLVMVCVBZVAVBWWBWUNXWK
        YUHWXMVCWUNWUJWVTXGUQXWKYUHXCYRXVGVMWVTUYSWCYBWUNWVTWXLVMXVGWUNWXLWXSXD
        YUEUXNWUNYUIWWAWVTVAWUNYUIVWJUTVMVCVBZVCVBWWAWUNVWJUTVMXWJXUSYUEYHYUJXM
        VWJVCVMUTXMYRYEUYTVUAVUBVUCYBVUDYDVUFYTYJWUNWWEVXJVMVGVBZYUKVCVBVXJVIWU
        NWWBWWDYUKYUKWWKWXJWUNVXJWVRUVHZYULWUNWWBVWAFXMVCVBZVAVBZYUKVIWUNWVTVWA
        VIUSZWWAYUMVIUSZWWBYUNVIUSZWUNWVTXUIVWAVIXUPWUNXUIVWAVIUSXUHVWAUTVCVBZV
        IUSWUNXUHVWBYURVIWUNXUHVWBVIUSWVAXXPWUNVWGVWBOWVCXXTWVDVUEXIWUNXURVWAXG
        UQVWBYURXCYEWUNVWAAVWAVNUQZWUMVYBXJZXDUTVWAVUGWCYTWUNXUHUTVWAXUQWWPYUTU
        VGXIVUHWUNVWJFXMWVKWUNFAFUPUQZWUMUAXJZWIWWIWUNWURXYCIVFZXYCVGVBZVHVFZFV
        IUSZBUPVLZVWJFVIUSZWVFAYVGWUMUCXJYVFYVHBVWGUPBEUYMZYVEVWJFVIYVIYVDVWIVH
        YVIYVCVWHXYCVWGVGXYCVWGIYOYVIYMYGYIVUIYPYQVUJWUNXWNVQWVTVIUSZVDYUSWWAVN
        UQYUMVNUQVQYUMVIUSVDYUOYUPVDYUQUXTWUNXWNYVJWWHXVHVUKYUTWWJWUNYUMWUNYVAX
        MUPUQZYUMUPUQYVBXMUVMUQYVKVULXMUVNUYIFXMVUMWRZUWQWVTVWAWWAYUMVUNUXHVUPW
        UNWWMYUMVGVBZYUMVAVBWWMYUNYUKWUNWWMYUMWUNWWMWUNKXSAKUPUQWUMVYTXJWWQWWRW
        UNXOWWSXEZXPZYSWUNYUMYVLYSZWUNYUMYVLYAZVUOWUNVWAYVMYUMVAWUNYVMUTXSVGVBZ
        KVAVBZYUMVGVBZVWAWUNWWMYVSYUMVGWUNKXSAKXGUQWUMAKVYAXDXJZWUNXSYVNYSWUNXS
        YVNYAVUQYDWUNYVTYVRYUMVGVBZKVAVBVWAWUNYVRKYUMYVRXGUQWUNXSVVFXSXOVURVUSV
        PYWAYVPYVQVUTMYWBKVAUBVVAVVBUXGYDWUNYUKKVMVMVAVBZVGVBWWMWUNKVMVMYWAYUEY
        UEWUKWUNVVCVPZYWDVVDYWCXSKVGVVEVUBVUCZUXRYTWUNWWDWWMYUKVIWUNJWWMWWCWWLY
        VOWXIWUNWWNWWCAWWNVNUQZWUMWXAXJZWUNWWCWXIWIZWUNWWNWWCURUSZWWOWWCWPVFZUR
        USZWUNWWOOYWJURWXGWUNOWVDVVGXFWUNYWFWWCVNUQYWIYWKYKYWGYWHWWNWWCVVHYLXIV
        VIVVJYWEXFVVKWUNVXJWUNVXJWVRXDVVLYTYJAVXKWUMAVXFVXKUOWTXJVVKWUNKYWAVVLY
        TYJVVMVVNVXBVWNDOUPVWOOXCZVWSVWFVXAVWMYWLVWPVVTVWRVWEVWOOQURVVOYWLVWQVW
        CVWDURVWOOVWBVAYNZVUIVVPYWLVWKEVWTVWLYWLVWOOVWQVWCVJYWLYMYWMYGVVQVVPVVR
        YL $.
    $}

    $d y ph $.
    pntibndlem3.5 $e |- ( ph -> A. m e. ( K [,) +oo )
      A. v e. ( Z (,) +oo ) E. i e. NN ( ( v < i /\ i <_ ( m x. v ) ) /\
        ( abs ` ( ( R ` i ) / i ) ) <_ ( E / 2 ) ) ) $.
    $( Lemma for ~ pntibnd .  Package up ~ pntibndlem2 in quantifiers.
       (Contributed by Mario Carneiro, 10-Apr-2016.) $)
    pntibndlem3 $p |- ( ph -> E. x e. RR+
      A. k e. ( ( exp ` ( C / E ) ) [,) +oo )
      A. y e. ( x (,) +oo ) E. z e. RR+ ( ( y < z /\
        ( ( 1 + ( L x. E ) ) x. z ) < ( k x. y ) ) /\
        A. u e. ( z [,] ( ( 1 + ( L x. E ) ) x. z ) )
          ( abs ` ( ( R ` u ) / u ) ) <_ E ) ) $=
      ( vw vt vn cv cchp cfv cmin co c2 cmul clog cdiv caddc cle cicc wral cpnf
      wbr c1 cioo crp wrex clt wa cabs ce cico cr wcel 2re 1re ltleii chpdifbnd
      mp2an c4 simpr cc0 ioossre sseldi eliooord syl simpld elrpd adantr cn 4nn
      1lt2 ax-mp sylancl adantrr ad2antll reefcld wb mpbir2and adantlrr remulcl
      rpred sylancr 2rp readdcl syl5eqel rerpdivcld elicopnf cc recnd recni a1i
      wceq rpregt0 mp1i syl3anc mpbid wne rpcnne0 oveq1d syl2anc ad2antrr oveq1
      breq2d anbi1d rexbidv ralbidv rspcv sylc weq breq1 anbi12d oveq12d fveq2d
      fveq2 id breq1d nnrp rpdivcl rpdivcld rpefcld rpaddcld readdcld ltaddrp2d
      elioore lttrd rexrd elioopnf relogcl simprbda rehalfcld rphalfcld reeflog
      cxr efadd oveq2i syl6eq rerpdivcl simprd wi ltle mpd rpregt0d 1rp rplogcl
      div1i lediv2 syl5eqbrr leadd2dd oveq1i divdir syl5eq mulcom divdiv2 eqtrd
      eqtr4d breqtrrd efle eqbrtrrd simplbda letrd lemuldiv breq2 cbvrexv oveq2
      syl5eqbr anbi2d syl5bb cbvralv sylib simprrl simplrl simplrr eqid simprll
      simprlr simprrr pntibndlem2 anassrs ralrimivva raleqdv rspcev rexlimdvaa
      rexlimddv mpi ) AUIULZUMUNEULZUMUNUOUPUQUXIUXJUOUPURUPUJULZUXJUXJUSUNUTUP
      URUPVAUPVBVFUIUXJUQUXJURUPVCUPVDEVGVEVHUPVDZUJVIVJZCULZDULZVKVFVGPNURUPVA
      UPUXOURUPZLULZUXNURUPVKVFVLFULZJUNUXRUTUPVMUNNVBVFFUXOUXPVCUPVDVLDVIVJZCB
      ULZVEVHUPZVDZLINUTUPZVNUNZVEVOUPZVDZBVIVJZUQVPVQZVGUQVBVFUXMVRVGUQVSVRWOV
      TEUIUQUJWAWBAUXLUYGUJVIAUXKVIVQZUXLVLZVLZUXKNWCUTUPZUTUPZVNUNZQVAUPZVIVQZ
      UXSCUYOVEVHUPZVDZLUYEVDZUYGAUYIUYPUXLAUYIVLZUYNQUYTUYMUYTUYMUYTUXKUYLAUYI
      WDUYTNVIVQZWCVIVQZUYLVIVQAVUAUYIANAWEVGVHUPZVPNWEVGWFUFWGZAWENVKVFZNVGVKV
      FZANVUCVQZVUEVUFVLUFNWEVGWHWIZWJWKWLZWCWMVQVUBWNWCUUAWPNWCUUBWQUUCXEZUUDZ
      AQVIVQZUYIUGWLZUUEWRUYKUXSLCUYEUYQUYKUXQUYEVQZUXNUYQVQZVLZVLZUXNUKULZVKVF
      ZVURUXQUQUTUPZUXNURUPZVBVFZVLZVURJUNZVURUTUPZVMUNZNUQUTUPZVBVFZVLZUXSUKWM
      VUQUXNQVEVHUPZVQZUXJKULZVKVFZVVLVUTUXJURUPZVBVFZVLZVVLJUNZVVLUTUPZVMUNZVV
      GVBVFZVLZKWMVJZEVVJVDZVVIUKWMVJZAUYIVUPVVKUXLUYTVUPVLZVVKUXNVPVQZQUXNVKVF
      ZVUOVWFUYTVUNUXNUYOVEUUHWSZVWEQUYOUXNUYTQVPVQVUPUYTQVUMXEZWLZUYTUYOVPVQVU
      PUYTUYNQUYTUYMVUJWTVWIUUFWLVWHUYTQUYOVKVFVUPUYTQUYNVWIVUKUUGWLVUOUYOUXNVK
      VFZUYTVUNVUOVWKUXNVEVKVFUXNUYOVEWHWJWSUUIVWEQUUQVQVVKVWFVWGVLXAVWEQVWJUUJ
      QUXNUUKWIXBXCVUQVUTOVEVOUPZVQZVVMVVLMULZUXJURUPZVBVFZVLZVVTVLZKWMVJZEVVJV
      DZMVWLVDZVWCAUYIVUPVWMUXLUYTVUNVWMVUOUYTVUNVLZVWMVUTVPVQZOVUTVBVFZVXBUXQU
      YTVUNUXQVPVQZUYDUXQVBVFZUYTUYDVPVQZVUNVXEVXFVLXAUYTUYCUYTINUYTIUQHURUPZUQ
      USUNZVAUPZVPUEUYTVXHVPVQZVXIVPVQZVXJVPVQUYTUYHHVPVQVXKVRUYTHAHVIVQZUYIUCW
      LXEZUQHXDXFZUQVIVQZVXLXGUQUULWPZVXHVXIXHWQXIVUIXJZWTZUYDUXQXKWIZUUMZUUNVX
      BOHVVGUTUPZVNUNZVUTVBUDVXBVYCUQURUPZUXQVBVFZVYCVUTVBVFZVXBVYDUYDUXQUYTVYD
      VPVQZVUNUYTVYCVPVQZUYHVYGUYTVYBUYTHVVGVXNUYTNVUIUUOXJZWTZVRVYCUQXDWQWLUYT
      VXGVUNVXSWLVYAUYTVYDUYDVBVFVUNUYTVYBVXIVAUPZVNUNZVYDUYDVBUYTVYLVYCVXIVNUN
      ZURUPZVYDUYTVYBXLVQVXIXLVQZVYLVYNXPUYTVYBVYIXMVXIVXQXNZVYBVXIUURWQVYMUQVY
      CURVXPVYMUQXPXGUQUUPWPUUSUUTUYTVYKUYCVBVFZVYLUYDVBVFZUYTVYKVYBVXINUTUPZVA
      UPZUYCVBUYTVXIVYSVYBVXLUYTVXQXOUYTVXLVUAVYSVPVQVXQVUIVXINUVAXFVYIUYTVXIVX
      IVGUTUPZVYSVBVXIVYPUVIUYTNVGVBVFZWUAVYSVBVFZUYTVUFWUBAVUFUYIAVUEVUFVUHUVB
      WLUYTNVPVQZVGVPVQZVUFWUBUVCAWUDUYIVUDWLVSNVGUVDWQUVEUYTWUDVUEVLWUEWEVGVKV
      FVLZVXLWEVXIVKVFVLZWUBWUCXAUYTNVUIUVFVGVIVQWUFUYTUVGVGXQXRVXIVIVQZWUGUYTU
      YHVGUQVKVFWUHVRWOUQUVHWBVXIXQXRNVGVXIUVJXSXTUVKUVLUYTUYCVXHNUTUPZVYSVAUPZ
      VYTUYTUYCVXJNUTUPZWUJIVXJNUTUEUVMUYTVXHXLVQVYONXLVQNWEYAVLZWUKWUJXPUYTVXH
      VXOXMVYOUYTVYPXOUYTVUAWULVUINYBWIZVXHVXINUVNXSUVOUYTWUIVYBVYSVAUYTWUIHUQU
      RUPZNUTUPZVYBUYTVXHWUNNUTUYTUQXLVQZHXLVQZVXHWUNXPUQVRXNUYTHVXNXMZUQHUVPXF
      YCUYTWUQWULWUPUQWEYAVLZVYBWUOXPWURWUMVXPWUSUYTXGUQYBXRHNUQUVQXSUVSYCUVRUV
      TUYTVYKVPVQZUYCVPVQVYQVYRXAUYTVYBVPVQVXLWUTVYIVXQVYBVXIXHWQVXRVYKUYCUWAYD
      XTUWBWLUYTVUNVXEVXFVXTUWCUWDVXBVYHVXEUYHWEUQVKVFVLZVYEVYFXAUYTVYHVUNVYJWL
      ZVYAVXPWVAVXBXGUQXQXRVYCUXQUQUWEXSXTUWIVXBOVPVQVWMVXCVXDVLXAVXBOVYCVPUDWV
      BXIOVUTXKWIXBWRXCAVXAUYJVUPUHYEVWTVWCMVUTVWLVWNVUTXPZVWSVWBEVVJWVCVWRVWAK
      WMWVCVWQVVPVVTWVCVWPVVOVVMWVCVWOVVNVVLVBVWNVUTUXJURYFYGUWJYHYIYJYKYLVWBVW
      DEUXNVVJVWBUXJVURVKVFZVURVVNVBVFZVLZVVHVLZUKWMVJECYMZVWDVWAWVGKUKWMKUKYMZ
      VVPWVFVVTVVHWVIVVMWVDVVOWVEVVLVURUXJVKUWFVVLVURVVNVBYNYOWVIVVSVVFVVGVBWVI
      VVRVVEVMWVIVVQVVDVVLVURUTVVLVURJYRWVIYSYPYQYTYOUWGWVHWVGVVIUKWMWVHWVFVVCV
      VHWVHWVDVUSWVEVVBUXJUXNVURVKYNWVHVVNVVAVURVBUXJUXNVUTURUWHYGYOYHYIUWKYKYL
      UYKVUPVURWMVQZVVIVLZUXSUYKVUPWVKVLZVLEUIDFGHIJUXKNOPUXQVURUYOUXNQRSAGVIVQ
      UYJWVLTYEUAAUXJJUNZUXJUTUPZVMUNZGVBVFZEVIVDZUYJWVLAUXTJUNZUXTUTUPZVMUNZGV
      BVFZBVIVDWVQUBWWAWVPBEVIBEYMZWVTWVOGVBWWBWVSWVNVMWWBWVRWVMUXTUXJUTUXTUXJJ
      YRWWBYSYPYQYTUWLUWMYEAVXMUYJWVLUCYEUDUEAVUGUYJWVLUFYEAVULUYJWVLUGYEUYKVUP
      WVJVVIUWNAUYIUXLWVLUWOAUYIUXLWVLUWPUYOUWQUYKVUNVUOWVKUWRUYKVUNVUOWVKUWSUY
      KVUPWVJVVIUWTUXAUXBUXGUXCUYFUYSBUYOVIUXTUYOXPZUYBUYRLUYEWWCUXSCUYAUYQUXTU
      YOVEVHYFUXDYJUXEYDUXFUXH $.
  $}

  ${
    $d x z C $.  $d w F $.  $d n I $.  $d n x y z J $.  $d j k m n u x y z L $.
    $d j k m n x y z K $.  $d j m n x z M $.  $d n x z O $.  $d j m n v x ph $.
    $d j m n x z N $.  $d b c d e f g i j k l m n u v w x y z R $.  $d n u V $.
    $d j m n w x z U $.  $d n v w z W $.  $d k n y z X $.  $d i j m n x z Y $.
    $d a e g j k m n u v x y z E $.  $d j m n u x z Z $.
    pntlem1.r $e |- R = ( a e. RR+ |-> ( ( psi ` a ) - a ) ) $.
    $( Lemma for ~ pnt .  Establish smallness of ` R ` on an interval.  Lemma
       10.6.2 in [Shapiro], p. 436.  (Contributed by Mario Carneiro,
       10-Apr-2016.) $)
    pntibnd $p |- E. c e. RR+ E. l e. ( 0 (,) 1 ) A. e e. ( 0 (,) 1 )
      E. x e. RR+ A. k e. ( ( exp ` ( c / e ) ) [,) +oo )
      A. y e. ( x (,) +oo ) E. z e. RR+ ( ( y < z /\
        ( ( 1 + ( l x. e ) ) x. z ) < ( k x. y ) ) /\
        A. u e. ( z [,] ( ( 1 + ( l x. e ) ) x. z ) )
          ( abs ` ( ( R ` u ) / u ) ) <_ e ) $=
      ( cv co wbr crp wral wrex wa c1 wcel vd vv vn vm vf cfv cdiv cabs cle clt
      vg vb cmul cn cpnf cioo ce cico caddc cicc pntrmax pntpbnd reeanv c2 clog
      cc0 c4 c3 2rp rpmulcl mpan cr 1lt2 rplogcl mp2an rpaddcl sylancl ad2antlr
      2re id eqid pntibndlem1 ad2antrr wi eliooord simpld elrpd rphalfcld rpred
      elioore rpgt0d 1re a1i rphalflt syl simprd lttrd cxr w3a 0xr rexri elioo2
      wb syl3anbrc adantl wceq oveq2 fveq2d oveq1d breq2 anbi2d rexbidv ralbidv
      raleqbidv rspcv simp-4l simpllr simplr simprl pntibndlem3 rexlimdvaa syld
      simprr ralrimdva impr oveq1 raleqdv oveq2d breq1d anbi12d rspc2ev syl3anc
      rexralbidv ex rexlimivv sylbir ) ALZEUFYQUGMUHUFUALZUINAOPZUAOQZUBLZUCLZU
      JNUUBUDLUUAUMMUINRZUUBEUFUUBUGMUHUFZUELZUINZRZUCUNQZUBUKLZUOUPMZPZUDULLZU
      UEUGMZUQUFZUOURMZPZUKOQZUEVFSUPMZPZULOQZBLZCLZUJNZSJLZFLZUMMZUSMZUVBUMMZG
      LUVAUMMZUJNZRZDLZEUFUVLUGMUHUFUVEUINZDUVBUVHUTMZPZRZCOQZBYQUOUPMZPZGILZUV
      EUGMZUQUFZUOURMZPZAOQZFUURPZJUURQIOQZAEHUAKVAUKUBEUEUDUCHULKVBYTUUTRYSUUS
      RZULOQUAOQUWGYSUUSUAULOOVCUWHUWGUAULOOYROTZUULOTZRZUWHUWGUWKUWHRVDUULUMMZ
      VDVEUFZUSMZOTZSVGUGMYRVHUSMUGMZUURTZUVCSUWPUVEUMMZUSMZUVBUMMZUVIUJNZRZUVM
      DUVBUWTUTMZPZRZCOQZBUVRPZGUWNUVEUGMZUQUFZUOURMZPAOQZFUURPZUWGUWJUWOUWIUWH
      UWJUWLOTZUWMOTZUWOVDOTUWJUXMVIVDUULVJVKVDVLTSVDUJNUXNVSVMVDVNVOUWLUWMVPVQ
      VRUWIUWQUWJUWHUWIYREUWPHKUWIVTUWPWAZWBWCUWKYSUUSUXLUWKYSRZUUSUXKFUURUXPUV
      EUURTZRZUUSUUCUUDUVEVDUGMZUINZRZUCUNQZUBUUJPZUDUULUXSUGMZUQUFZUOURMZPZUKO
      QZUXKUXRUXSUURTZUUSUYHWDUXQUYIUXPUXQUXSVLTZVFUXSUJNZUXSSUJNZUYIUXQUXSUXQU
      VEUXQUVEUVEVFSWJZUXQVFUVEUJNZUVESUJNZUVEVFSWEZWFWGZWHZWIZUXQUXSUYRWKUXQUX
      SUVESUYSUYMSVLTUXQWLWMUXQUVEOTUXSUVEUJNUYQUVEWNWOUXQUYNUYOUYPWPWQVFWRTSWR
      TUYIUYJUYKUYLWSXCWTSWLXAVFSUXSXBVOXDXEUUQUYHUEUXSUURUUEUXSXFZUUPUYGUKOUYT
      UUKUYCUDUUOUYFUYTUUNUYEUOURUYTUUMUYDUQUUEUXSUULUGXGXHXIUYTUUHUYBUBUUJUYTU
      UGUYAUCUNUYTUUFUXTUUCUUEUXSUUDUIXJXKXLXMXNXLXOWOUXRUYGUXKUKOUXRUUIOTZUYGR
      ZRABCUBDYRUULUWNEUCGUDUVEUYEUWPUUIHKUWIUWJYSUXQVUBXPUXOUWKYSUXQVUBXQUXPUW
      JUXQVUBUWIUWJYSXRWCUYEWAUWNWAUXPUXQVUBXRUXRVUAUYGXSUXRVUAUYGYCXTYAYBYDYEU
      WFUXLUVSGUXJPZAOQZFUURPIJUWNUWPOUURUVTUWNXFZUWEVUDFUURVUEUWDVUCAOVUEUVSGU
      WCUXJVUEUWBUXIUOURVUEUWAUXHUQUVTUWNUVEUGYFXHXIYGXLXMUVDUWPXFZVUDUXKFUURVU
      FUVSUXGAGOUXJVUFUVQUXFBUVRVUFUVPUXECOVUFUVKUXBUVOUXDVUFUVJUXAUVCVUFUVHUWT
      UVIUJVUFUVGUWSUVBUMVUFUVFUWRSUSUVDUWPUVEUMYFYHXIZYIXKVUFUVMDUVNUXCVUFUVHU
      WTUVBUTVUGYHYGYJXLXMYMXMYKYLYNYOYPVO $.

    pntlem1.a $e |- ( ph -> A e. RR+ ) $.
    pntlem1.b $e |- ( ph -> B e. RR+ ) $.
    pntlem1.l $e |- ( ph -> L e. ( 0 (,) 1 ) ) $.
    pntlem1.d $e |- D = ( A + 1 ) $.
    pntlem1.f $e |- F = ( ( 1 - ( 1 / D ) ) x.
      ( ( L / ( ; 3 2 x. B ) ) / ( D ^ 2 ) ) ) $.
    $( Lemma for ~ pnt .  Closure for the constants used in the proof.  For
       comparison with Equation 10.6.27 of [Shapiro], p. 434, ` A ` is C^*,
       ` B ` is c_1, ` L ` is &lambda;, ` D ` is c_2, and ` F ` is c_3.
       (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    pntlemd $p |- ( ph -> ( L e. RR+ /\ D e. RR+ /\ F e. RR+ ) ) $=
      ( crp wcel c1 co clt wbr cc0 cioo cr ioossre sseldi wa eliooord syl elrpd
      simpld caddc 1rp rpaddcl sylancl syl5eqel cdiv cmin cdc cmul cexp ltaddrp
      c3 c2 1re sylancr cc rpcnd ax-1cn addcom syl5eq breqtrrd recgt1d mpbid wb
      wceq rprecred difrp cn 3nn0 2nn decnncl nnrp ax-mp rpmulcl rpdivcld cz 2z
      rpexpcl rpmulcld 3jca ) AGOPDOPZFOPAGAUAQUBRZUCGUAQUDLUEAUAGSTZGQSTZAGWLP
      WMWNUFLGUAQUGUHUJUIZADBQUKRZOMABOPZQOPWPOPJULBQUMUNUOZAFQQDUPRZUQRZGVBVCU
      RZCUSRZUPRZDVCUTRZUPRZUSRONAWTXEAWSQSTZWTOPZAQDSTXFAQQBUKRZDSAQUCPZWQQXHS
      TVDJQBVAVEADWPXHMABVFPQVFPWPXHVOABJVGVHBQVIUNVJVKADWRVLVMAWSUCPXIXFXGVNAD
      WRVPVDWSQVQUNVMAXCXDAGXBWOAXAOPZCOPXBOPXAVRPXJVBVCVSVTWAXAWBWCKXACWDVEWEA
      WKVCWFPXDOPWRWGDVCWHUNWEWIUOWJ $.

    pntlem1.u $e |- ( ph -> U e. RR+ ) $.
    pntlem1.u2 $e |- ( ph -> U <_ A ) $.
    pntlem1.e $e |- E = ( U / D ) $.
    pntlem1.k $e |- K = ( exp ` ( B / E ) ) $.
    $( Lemma for ~ pnt .  Closure for the constants used in the proof.  For
       comparison with Equation 10.6.27 of [Shapiro], p. 434, ` U ` is &alpha;,
       ` E ` is &epsilon;, and ` K ` is _K_.  (Contributed by Mario Carneiro,
       13-Apr-2016.) $)
    pntlemc $p |- ( ph -> ( E e. RR+ /\ K e. RR+ /\
      ( E e. ( 0 (,) 1 ) /\ 1 < K /\ ( U - E ) e. RR+ ) ) ) $=
      ( crp wcel cc0 c1 cioo co clt wbr cmin w3a cdiv pntlemd rpdivcld syl5eqel
      simp2d ce cfv rpred rpefcld cr rpgt0d caddc ltp1d syl6breqr lelttrd rpcnd
      cmul mulid1d breqtrrd 1re a1i ltdivmuld mpbird syl5eqbr cxr wb 0xr elioo2
      rexri mp2an syl3anbrc efgt1 syl ltaddrp sylancr cc wa wceq rpcnne0d divid
      ax-1cn addcom sylancl syl5eq 3brtr4d ltdiv23d difrp syl2anc mpbid 3jca
      wne ) AGUBUCIUBUCGUDUEUFUGUCZUEIUHUIZFGUJUGUBUCZUKAGFDULUGZUBTAFDRAJUBUCD
      UBUCHUBUCABCDEHJKLMNOPQUMUPZUNUOZAICGULUGZUQURZUBUAAXIAXIACGNXHUNZUSUTUOA
      XCXDXEAGVAUCZUDGUHUIZGUEUHUIZXCAGXHUSZAGXHVBAGXFUEUHTAXFUEUHUIFDUEVHUGZUH
      UIAFDXPUHAFBDAFRUSZABMUSZADXGUSSABBUEVCUGZDUHABXRVDPVEVFADADXGVGVIVJAFUED
      XQUEVAUCZAVKVLXGVMVNVOUDVPUCUEVPUCXCXLXMXNUKVQVRUEVKVTUDUEGVSWAWBAUEXJIUH
      AXIUBUCUEXJUHUIXKXIWCWDUAVEAGFUHUIZXEAGXFFUHTAFFDXQRXGAUEUEBVCUGZFFULUGZD
      UHAXTBUBUCUEYBUHUIVKMUEBWEWFAFWGUCFUDXBWHYCUEWIAFRWJFWKWDADXSYBPABWGUCUEW
      GUCXSYBWIABMVGWLBUEWMWNWOWPWQVOAXLFVAUCYAXEVQXOXQGFWRWSWTXAXA $.

    pntlem1.y $e |- ( ph -> ( Y e. RR+ /\ 1 <_ Y ) ) $.
    pntlem1.x $e |- ( ph -> ( X e. RR+ /\ Y < X ) ) $.
    pntlem1.c $e |- ( ph -> C e. RR+ ) $.
    pntlem1.w $e |- W = ( ( ( Y + ( 4 / ( L x. E ) ) ) ^ 2 ) +
      ( ( ( X x. ( K ^ 2 ) ) ^ 4 ) + ( exp ` ( ( ( ; 3 2 x. B ) /
     ( ( U - E ) x. ( L x. ( E ^ 2 ) ) ) ) x. ( ( U x. 3 ) + C ) ) ) ) ) $.
    $( Lemma for ~ pnt .  Closure for the constants used in the proof.  The
       mammoth expression ` W ` is a number large enough to satisfy all the
       lower bounds needed for ` Z ` .  For comparison with Equation 10.6.27 of
       [Shapiro], p. 434, ` Y ` is x_2, ` X ` is x_1, ` C ` is the big-O
       constant in Equation 10.6.29 of [Shapiro], p. 435, and ` W ` is the
       unnamed lower bound of "for sufficiently large x" in Equation 10.6.34 of
       [Shapiro], p. 436.  (Contributed by Mario Carneiro, 13-Apr-2016.) $)
    pntlema $p |- ( ph -> W e. RR+ ) $=
      ( c4 cmul co cdiv caddc c2 cexp c3 cdc cmin ce cfv crp wcel cz c1 cle wbr
      simpld cn 4nn nnrp ax-mp pntlemd simp1d cc0 cioo clt w3a pntlemc rpmulcld
      rpdivcl sylancr rpaddcld rpexpcl sylancl simp2d nnzi 3nn0 decnncl rpmulcl
      2z 2nn simp3d rpdivcld 3nn rpred rpefcld syl5eqel ) ALNUJKHUKULZUMULZUNUL
      ZUOUPULZMJUOUPULZUKULZUJUPULZUQUOURZCUKULZGHUSULZKHUOUPULZUKULZUKULZUMULZ
      GUQUKULZDUNULZUKULZUTVAZUNULZUNULVBUIAXBXQAXAVBVCUOVDVCZXBVBVCANWTANVBVCV
      ENVFVGUFVHAUJVBVCZWSVBVCWTVBVCUJVIVCXSVJUJVKVLAKHAKVBVCEVBVCIVBVCABCEFIKO
      PQRSTUAVMVNZAHVBVCZJVBVCZHVOVEVPULVCZVEJVQVGZXHVBVCZVRZABCEFGHIJKOPQRSTUA
      UBUCUDUEVSZVNZVTUJWSWAWBWCWKXAUOWDWEAXEXPAXDVBVCUJVDVCXEVBVCAMXCAMVBVCNMV
      QVGUGVHAYBXRXCVBVCAYAYBYFYGWFWKJUOWDWEVTUJVJWGXDUJWDWEAXOAXOAXLXNAXGXKAXF
      VBVCZCVBVCXGVBVCXFVIVCYIUQUOWHWLWIXFVKVLRXFCWJWBAXHXJAYCYDYEAYAYBYFYGWMWM
      AKXIXTAYAXRXIVBVCYHWKHUOWDWEVTVTWNAXMDAGVBVCUQVBVCZXMVBVCUBUQVIVCYJWOUQVK
      VLGUQWJWEUHWCVTWPWQWCWCWR $.

    ${
      pntlem1.z $e |- ( ph -> Z e. ( W [,) +oo ) ) $.
      $( Lemma for ~ pnt .  Unpack all the lower bounds contained in ` W ` , in
         the form they will be used.  For comparison with Equation 10.6.27 of
         [Shapiro], p. 434, ` Z ` is x.  (Contributed by Mario Carneiro,
         13-Apr-2016.) $)
      pntlemb $p |- ( ph -> ( Z e. RR+ /\ ( 1 < Z /\ _e <_ ( sqr ` Z ) /\
      ( sqr ` Z ) <_ ( Z / Y ) ) /\ ( ( 4 / ( L x. E ) ) <_ ( sqr ` Z ) /\
        ( ( ( log ` X ) / ( log ` K ) ) + 2 ) <_
        ( ( ( log ` Z ) / ( log ` K ) ) / 4 ) /\
        ( ( U x. 3 ) + C ) <_ ( ( ( U - E ) x.
        ( ( L x. ( E ^ 2 ) ) / ( ; 3 2 x. B ) ) ) x. ( log ` Z ) ) ) ) ) $=
        ( crp wcel c1 clt wbr ceu csqr cfv cle cdiv co c4 cmul clog c2 caddc c3
        w3a cmin cexp cdc cr cpnf cico cxr wb pntlema rpred pnfxr sylancl mpbid
        simp1d simp2d 1re a1i ere egt2lt3 2re lttri mp2an 4re cn 4nn nnrp ax-mp
        cc0 rpmulcld sylancr wa eliooord syl simprd rpcnd breqtrd lttrd syl3anc
        simp3d ltmuldivd simpld rpaddcld ltaddrp2d ce rpexpcl rpdivcld ltaddrpd
        cz 2z rpmulcl ltletrd wceq rprege0d breqtrrd lt2sq syl2anc mpbird ltled
        3brtr3d rerpdivcld relogcld nndivre relogexp recnd oveq2d oveq1d cc wne
        3jca rpcnne0d 3eqtrd elico2 rpgecld rpsqrcld 1lt2 simpli simpri pntlemd
        3lt4 3re cioo pntlemc rpdivcl ltmul1dd mulid2d jctir ltmul2 4cn mulid1i
        4pos syl6breq resqcld nnzi 3nn0 2nn decnncl 3nn syl6breqr 0le1 syl21anc
        rpefcld resqrth sq1 ltmul2dd remsqsqr rplogcld readdcl addcomd eqbrtrrd
        syl5eq logltb ltmuldiv2 ltdiv1dd relogmuld eqtrd mulcld divdir divcan4d
        rpcnne0 mp1i divdiv32 remulcld divdiv2 mulcomd reefcld reeflogd eqbrtrd
        div23 eflt ltdivmuld divass ) AOULUMZUNOUOUPZUQOURUSZUTUPZUXCONVAVBZUTU
        PZVIVCKHVDVBZVAVBZUXCUTUPZMVEUSZJVEUSZVAVBZVFVGVBZOVEUSZUXKVAVBZVCVAVBZ
        UTUPZGVHVDVBZDVGVBZGHVJVBZKHVFVKVBZVDVBZVHVFVLZCVDVBZVAVBVDVBZUXNVDVBZU
        TUPZVIAOLAOVMUMZLOUTUPZOVNUOUPZAOLVNVOVBUMZUYHUYIUYJVIZUKALVMUMVNVPUMUY
        KUYLVQALABCDEFGHIJKLMNPQRSTUAUBUCUDUEUFUGUHUIUJVRZVSZVTLVNOUUAWAWBZWCZU
        YMAUYHUYIUYJUYOWDZUUBZAUXBUXDUXFAUNVFVKVBZUXCVFVKVBZUNOUOAUNUXCUOUPZUYS
        UYTUOUPZAUNUQUXCUNVMUMZAWEWFZUQVMUMAWGWFZAUXCAOUYRUUCZVSZUNUQUOUPZAUNVF
        UOUPVFUQUOUPZVUHUUDVUIUQVHUOUPZWHUUEUNVFUQWEWIWGWJWKWFAUQVCUXCVUEVCVMUM
        ZAWLWFZVUGUQVCUOUPZAVUJVHVCUOUPVUMVUIVUJWHUUFUUHUQVHVCWGUUIWLWJWKWFAVCU
        XHUXCVULAUXHAVCULUMZUXGULUMUXHULUMVCWMUMZVUNWNVCWOWPZAKHAKULUMEULUMIULU
        MABCEFIKPQRSTUAUBUUGWCZAHULUMZJULUMZHWQUNUUJVBZUMZUNJUOUPZUXTULUMZVIZAB
        CEFGHIJKPQRSTUAUBUCUDUEUFUUKZWCZWRZVCUXGUULWSZVSZVUGAVCUXGVDVBZVCUOUPVC
        UXHUOUPAVVJVCUNVDVBZVCUOAUXGUNUOUPZVVJVVKUOUPZAUXGHUNAUXGVVGVSZAHVVFVSV
        UDAUXGUNHVDVBHUOAKUNHAKVUQVSVUDVVFAWQKUOUPZKUNUOUPZAKVUTUMVVOVVPWTTKWQU
        NXAXBXCUUMAHAHVVFXDUUNXEAWQHUOUPZHUNUOUPZAVVAVVQVVRWTAVVAVVBVVCAVURVUSV
        VDVVEXHZWCHWQUNXAXBXCXFAUXGVMUMVUCVUKWQVCUOUPZWTZVVLVVMVQVVNVUDAVUKVVTV
        ULUUSUUOZUXGUNVCUUPXGWBVCUUQUURUUTAVCVCUXGVULVULVVGXIWBAUXHNUXHVGVBZUXC
        VVIAVWCANUXHANULUMUNNUTUPUGXJZVVHXKZVSZVUGAUXHNVVIVWDXLAVWCUXCUOUPZVWCV
        FVKVBZUYTUOUPZAVWHOUYTUOAVWHLOAVWCVWFUVAZUYNUYPAVWHVWHMJVFVKVBZVDVBZVCV
        KVBZUYDUXTUYBVDVBZVAVBZUXSVDVBZXMUSZVGVBZVGVBZLUOAVWHVWRVWJAVWMVWQAVWLU
        LUMZVCXQUMZVWMULUMZAMVWKAMULUMNMUOUPUHXJZAVUSVFXQUMZVWKULUMAVURVUSVVDVV
        EWDZXRJVFXNWAZWRZVCWNUVBZVWLVCXNWAZAVWPAVWPAVWOUXSAUYDVWNAUYCULUMZCULUM
        UYDULUMUYCWMUMVXJVHVFUVCUVDUVEUYCWOWPSUYCCXSWSZAUXTUYBAVVAVVBVVCVVSXHZA
        KUYAVUQAVURVXDUYAULUMVVFXRHVFXNWAWRZWRZXOAUXRDAGULUMVHULUMZUXRULUMUCVHW
        MUMVXOUVFVHWOWPGVHXSWAUIXKZWRVSZUVJZXKZXPUJUVGUYQXTAUYHWQOUTUPWTZUYTOYA
        AOUYRYBZOUVKXBZYCAVWCVMUMWQVWCUTUPWTUXCVMUMWQUXCUTUPWTZVWGVWIVQAVWCVWEY
        BAUXCVUFYBZVWCUXCYDYEYFZXFZXFXFZXFAVUCWQUNUTUPZVYCVUAVUBVQVUDVYHAUVHWFV
        YDUNUXCYDUVIWBUYSUNYAAUVLWFVYBYHAUQUXCVUEVUGVYGYGAUXCUXEVUGAONUYPVWDYIA
        UXCNVDVBZOUOUPUXCUXEUOUPAVYIUXCUXCVDVBZOUOANUXCUXCANVWDVSZVUGVUFANVWCUX
        CVYKVWFVUGANUXHVYKVVHXPVYEXFUVMAVXTVYJOYAVYAOUVNXBXEAUXCONVUGUYPVWDXIWB
        YGYRAUXIUXQUYGAUXHUXCVVIVUGVYFYGAUXMUXPAUXLVMUMVFVMUMZUXMVMUMAUXJUXKAMV
        XCYJZAJAJVXEVSAVVAVVBVVCVVSWDUVOZYIWIUXLVFUVPWAAUXOVMUMVUOUXPVMUMAUXNUX
        KAOUYRYJZVYNYIWNUXOVCYKWAAVWLVEUSZUXKVAVBZUXNVCVAVBZUXKVAVBZUXMUXPUOAVY
        PVYRUXKAVWLVXGYJZAUXNVMUMZVUOVYRVMUMVYOWNUXNVCYKWAVYNAVCVYPVDVBZUXNUOUP
        ZVYPVYRUOUPZAVWMVEUSZWUBUXNUOAVWTVXAWUEWUBYAVXGVXHVWLVCYLWAAVWMOUOUPZWU
        EUXNUOUPZAVWMVWROAVWMVXIVSZAVWRVXSVSZUYPAVWMVWQWUHVXRXPAVWRLOWUIUYNUYPA
        VWRVWRVWHVGVBZLUOAVWRVWHWUIAVWCULUMVXDVWHULUMVWEXRVWCVFXNWAXPALVWSWUJUJ
        AVWHVWRAVWHVWJYMAVWRVXSXDUVQUVSYCUYQXTZXFAVXBUXAWUFWUGVQVXIUYRVWMOUVTYE
        WBUVRAVYPVMUMWUAVWAWUCWUDVQVYTVYOVWBVYPUXNVCUWAXGWBUWBAVYQUXJVFUXKVDVBZ
        VGVBZUXKVAVBZUXLWULUXKVAVBZVGVBZUXMAVYPWUMUXKVAAVYPUXJVWKVEUSZVGVBWUMAM
        VWKVXCVXFUWCAWUQWULUXJVGAVUSVXDWUQWULYAVXEXRJVFYLWAYNUWDYOAUXJYPUMWULYP
        UMUXKYPUMZUXKWQYQZWTZWUNWUPYAAUXJVYMYMAVFUXKAVFVYLAWIWFYMZAUXKVYNXDZUWE
        AUXKVYNYSZUXJWULUXKUWFXGAWUOVFUXLVGAVFUXKWVAWVBAWURWUSWVCXCUWGYNYTAUXNY
        PUMVCYPUMVCWQYQWTZWUTVYSUXPYAAUXNVYOYMVUNWVDAVUPVCUWHUWIWVCUXNVCUXKUWJX
        GYHYGAUXSVWNUYDVAVBZUXNVDVBZUYFUTAUXSWVFAUXSVXPVSZAWVEUXNAWVEAVWNUYDVXN
        VXKXOZVSVYOUWKAUXSWVEVAVBZUXNUOUPUXSWVFUOUPAWVIVWPUXNUOAWVIUXSUYDVDVBZV
        WNVAVBZUYDUXSVDVBZVWNVAVBZVWPAUXSYPUMZVWNYPUMVWNWQYQWTZUYDYPUMZUYDWQYQW
        TZWVIWVKYAAUXSVXPXDZAVWNVXNYSZAUYDVXKYSZUXSVWNUYDUWLXGAWVJWVLVWNVAAUXSU
        YDWVRAUYDVXKXDZUWMYOAWVPWVNWVOWVMVWPYAWWAWVRWVSUYDUXSVWNUWQXGYTAVWPUXNU
        OUPZVWQUXNXMUSZUOUPZAVWQOWWCUOAVWQVWROAVWPVXQUWNZWUIUYPAVWQVWMWWEVXIXLW
        UKXFAOUYRUWOYCAVWPVMUMWUAWWBWWDVQVXQVYOVWPUXNUWRYEYFUWPAUXSUXNWVEWVGVYO
        WVHUWSWBYGAWVEUYEUXNVDAUXTYPUMUYBYPUMWVQWVEUYEYAAUXTVXLXDAUYBVXMXDWVTUX
        TUYBUYDUWTXGYOXEYRYR $.

      pntlem1.m $e |- M =
        ( ( |_ ` ( ( log ` X ) / ( log ` K ) ) ) + 1 ) $.
      pntlem1.n $e |- N =
        ( |_ ` ( ( ( log ` Z ) / ( log ` K ) ) / 2 ) ) $.
      $( Lemma for ~ pnt .  Closure for the constants used in the proof.  For
         comparison with Equation 10.6.27 of [Shapiro], p. 434, ` M ` is j^*
         and ` N ` is &#309;.  (Contributed by Mario Carneiro, 13-Apr-2016.) $)
      pntlemg $p |- ( ph -> ( M e. NN /\ N e. ( ZZ>= ` M ) /\
        ( ( ( log ` Z ) / ( log ` K ) ) / 4 ) <_ ( N - M ) ) ) $=
        ( cn wcel cuz cfv clog cdiv co c4 cmin cle wbr cfl c1 caddc cc0 cn0 crp
        cr wa clt simpld rpred 1re a1i simprd lelttrd rplogcld cioo w3a pntlemc
        simp2d simp3d rpdivcld rprege0d flge0nn0 nn0p1nn 3syl syl5eqel nnzd ceu
        cz c2 csqr cmul c3 cexp cdc pntlemb relogcld rerpdivcld rehalfcld flcld
        simp1d 0re 4nn nndivre sylancl nnred resubcld 4re elrpii rpdivcl rpge0d
        zred 4pos recnd nncnd cc ax-1cn addassd readdcld peano2re reflcl oveq1i
        syl 2re df-2 oveq2i 3eqtr4g flle leadd1dd eqbrtrd letrd leadd2dd mpbid
        2cn 2ne0 divdiv1d 2t2e4 syl6eq oveq2d divcan2d 2timesd 3eqtr3d breqtrrd
        wne fllep1 syl6breqr leadd1d mpbird wb leaddsub syl3anc eluz2 syl3anbrc
        subge0d 3jca ) ALUPUQMLURUSUQZQUTUSZJUTUSZVAVBZVCVAVBZMLVDVBZVEVFZALOUT
        USZUVEVAVBZVGUSZVHVIVBZUPUNAUVKVMUQZVJUVKVEVFVNUVLVKUQUVMUPUQAUVKAUVJUV
        EAOAOAOVLUQZPOVOVFZUJVPVQZAVHPOVHVMUQAVRVSZAPAPVLUQZVHPVEVFZUIVPVQUVQAU
        VSUVTUIVTAUVOUVPUJVTWAWBAJAJAHVLUQZJVLUQZHVJVHWCVBUQZVHJVOVFZGHVDVBZVLU
        QZWDZABCEFGHIJKRSTUAUBUCUDUEUFUGUHWEZWFVQAUWCUWDUWFAUWAUWBUWGUWHWGWFWBZ
        WHZWIUVKWJUVLWKWLWMZALWPUQMWPUQLMVEVFZUVCALUWKWNAMUVFWQVAVBZVGUSZWPUOAU
        WMAUVFAUVDUVEAQAQVLUQZVHQVOVFZWOQWRUSZVEVFZUWQQPVAVBVEVFZWDZVCKHWSVBVAV
        BUWQVEVFZUVKWQVIVBZUVGVEVFZGWTWSVBDVIVBUWEKHWQXAVBWSVBWTWQXBCWSVBVAVBWS
        VBUVDWSVBVEVFZWDZABCDEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMXCZXHZXDUW
        IXEZXFZXGWMZAVJUVHVEVFUWLAVJUVGUVHVJVMUQAXIVSAUVFVMUQVCUPUQUVGVMUQZUXHX
        JUVFVCXKXLZAMLAMUXJXSZALUWKXMZXNAUVGAUVFVLUQVCVLUQUVGVLUQAUVDUVEAQAQUXG
        VQAUWPUWRUWSAUWOUWTUXEUXFWFXHWBUWIWHVCXOXTXPUVFVCXQXLXRAUVGLVIVBZMVEVFZ
        UVIAUXPUXOVHVIVBZMVHVIVBZVEVFAUXQUVGLVHVIVBZVIVBZUXRVEAUVGLVHAUVGUXLYAZ
        ALUWKYBVHYCUQAYDVSZYEAUXTUWMUXRAUVGUXSUXLALVHUXNUVRYFZYFUXIAMVMUQZUXRVM
        UQUXMMYGYJAUXTUVGUVGVIVBZUWMVEAUXSUVGUVGUYCUXLUXLAUXSUXBUVGUYCAUVKWQAUV
        KUWJVQZWQVMUQAYKVSZYFUXLAUXSUVLWQVIVBZUXBVEAUVMVHVIVBUVLVHVHVIVBZVIVBUX
        SUYHAUVLVHVHAUVLAUVNUVLVMUQUYFUVKYHYJZYAUYBUYBYELUVMVHVIUNYIWQUYIUVLVIY
        LYMYNAUVLUVKWQUYJUYFUYGAUVNUVLUVKVEVFUYFUVKYOYJYPYQAUXAUXCUXDAUWOUWTUXE
        UXFWGWFYRYSAWQUWMWQVAVBZWSVBWQUVGWSVBUWMUYEAUYKUVGWQWSAUYKUVFWQWQWSVBZV
        AVBUVGAUVFWQWQAUVFUXHYAWQYCUQAUUAVSZUYMWQVJUUKAUUBVSZUYNUUCUYLVCUVFVAUU
        DYMUUEUUFAUWMWQAUWMUXIYAUYMUYNUUGAUVGUYAUUHUUIUUJAUWMUWNVHVIVBZUXRVEAUW
        MVMUQUWMUYOVEVFUXIUWMUULYJMUWNVHVIUOYIUUMYRYQAUXOMVHAUVGLUXLUXNYFUXMUVR
        UUNUUOAUXKLVMUQUYDUXPUVIUUPUXLUXNUXMUVGLMUUQUURYTZYRAMLUXMUXNUVAYTLMUUS
        UUTUYPUVB $.

      $( Lemma for ~ pnt .  Bounds on the subintervals in the induction.
         (Contributed by Mario Carneiro, 13-Apr-2016.) $)
      pntlemh $p |- ( ( ph /\ J e. ( M ... N ) ) ->
        ( X < ( K ^ J ) /\ ( K ^ J ) <_ ( sqr ` Z ) ) ) $=
        ( cfz co wcel wa cexp clt wbr csqr cfv cle clog cmul cdiv simpld adantr
        crp relogcld cc0 cioo cmin w3a pntlemc simp2d rpred rplogcld rerpdivcld
        c1 simp3d cn cuz c4 pntlemg simp1d nnred elfzuz uztrn2 syl2an cfl caddc
        nnuz cr flltp1 syl syl6breqr elfzle1 adantl ltletrd ltdivmul2d mpbid cz
        wceq elfzelz relogexp syl2anc breqtrrd wb rpexpcld logltb mpbird oveq2d
        c2 2z sylancl cc 2cn a1i recnd mulassd 3eqtr4d elfzle2 syl6breq ceu cdc
        c3 pntlemb rehalfcld flge 2re 2pos lemuldiv2 syl112anc remulcl rprege0d
        sylancr lemuldivd eqbrtrd rpexpcl logled resqrth rpsqrcld le2sq jca ) A
        JMNUQURUSZUTZPKJVAURZVBVCZUUKRVDVEZVFVCZUUJUULPVGVEZUUKVGVEZVBVCZUUJUUO
        JKVGVEZVHURZUUPVBUUJUUOUURVIURZJVBVCUUOUUSVBVCUUJUUTMJUUJUUOUURUUJPAPVL
        USZUUIAUVAQPVBVCUKVJVKZVMZAUURVLUSUUIAKAKAHVLUSZKVLUSZHVNWCVOURUSZWCKVB
        VCZGHVPURZVLUSZVQZABCEFGHIKLSTUAUBUCUDUEUFUGUHUIVRZVSZVTAUVFUVGUVIAUVDU
        VEUVJUVKWDVSWAVKZWBZUUJMAMWEUSZUUIAUVONMWFVEZUSRVGVEZUURVIURZWGVIURZNMV
        PURVFVCABCDEFGHIKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPWHWIZVKWJUUJJ
        AUVOJUVPUSJWEUSUUIUVTJMNWKWCJMWEWPWLWMWJZUUJUUTUUTWNVEWCWOURZMVBUUJUUTW
        QUSUUTUWBVBVCUVNUUTWRWSUOWTUUIMJVFVCAJMNXAXBXCUUJUUOJUURUVCUWAUVMXDXEUU
        JUVEJXFUSZUUPUUSXGAUVEUUIUVLVKZUUIUWCAJMNXHXBZKJXIXJZXKUUJUVAUUKVLUSZUU
        LUUQXLUVBUUJKJUWDUWEXMZPUUKXNXJXOUUJUUNUUKXQVAURZUUMXQVAURZVFVCZUUJUWIR
        UWJVFUUJUWIRVFVCUWIVGVEZUVQVFVCUUJUWLXQJVHURZUURVHURZUVQVFUUJXQUUPVHURZ
        XQUUSVHURUWLUWNUUJUUPUUSXQVHUWFXPUUJUWGXQXFUSZUWLUWOXGUWHXRUUKXQXIXSUUJ
        XQJUURXQXTUSUUJYAYBUUJJUWAYCUUJUURUUJKUWDVMYCYDYEUUJUWNUVQVFVCUWMUVRVFV
        CZUUJUWQJUVRXQVIURZVFVCZUUJUWSJUWRWNVEZVFVCZUUJJNUWTVFUUIJNVFVCAJMNYFXB
        UPYGUUJUWRWQUSUWCUWSUXAXLUUJUVRUUJUVQUURUUJRARVLUSZUUIAUXBWCRVBVCYHUUMV
        FVCUUMRQVIURVFVCVQWGLHVHURVIURUUMVFVCUUTXQWOURUVSVFVCGYJVHURDWOURUVHLHX
        QVAURVHURYJXQYICVHURVIURVHURUVQVHURVFVCVQABCDEFGHIKLOPQRSTUAUBUCUDUEUFU
        GUHUIUJUKULUMUNYKWIVKZVMZUVMWBZYLUWEUWRJYMXJXOUUJJWQUSZUVRWQUSXQWQUSZVN
        XQVBVCZUWQUWSXLUWAUXEUXGUUJYNYBUXHUUJYOYBJUVRXQYPYQXOUUJUWMUVQUURUUJUXG
        UXFUWMWQUSYNUWAXQJYRYTUXDUVMUUAXOUUBUUJUWIRUUJUWGUWPUWIVLUSUWHXRUUKXQUU
        CXSUXCUUDXOUUJRWQUSVNRVFVCUTUWJRXGUUJRUXCYSRUUEWSXKUUJUUKWQUSVNUUKVFVCU
        TUUMWQUSVNUUMVFVCUTUUNUWKXLUUJUUKUWHYSUUJUUMUUJRUXCUUFYSUUKUUMUUGXJXOUU
        H $.

      pntlem1.U $e |- ( ph -> A. z e. ( Y [,) +oo )
        ( abs ` ( ( R ` z ) / z ) ) <_ U ) $.
      $( Lemma for ~ pnt .  The "naive" base bound, which we will slightly
         improve.  (Contributed by Mario Carneiro, 13-Apr-2016.) $)
      pntlemn $p |- ( ( ph /\ ( J e. NN /\ J <_ ( Z / Y ) ) ) ->
        0 <_ ( ( ( U / J ) - ( abs ` ( ( R ` ( Z / J ) ) / Z ) ) )
          x. ( log ` J ) ) ) $=
        ( cn wcel cdiv co cle wbr wa cfv cabs cmin clog crp adantr rpred simprl
        nndivred cr c1 clt ceu csqr w3a c4 cmul c2 caddc c3 cexp pntlemb simp1d
        nnrpd rpdivcld pntrf ffvelrni rerpdivcld recnd abscld resubcld relogcld
        cdc syl cc0 wne wceq rpcnne0d divdiv2 syl3anc nncnd div23 eqtrd absmuld
        cc fveq2d rprege0d absid oveq2d 3eqtrd cpnf cico wral simprr lemuldiv2d
        cv simpld mpbird lemuldivd mpbid wb elicopnf mpbir2and fveq2 id oveq12d
        breq1d rspcv sylc eqbrtrrd subge0d log1 nnge1 ad2antrl 1rp syl5eqbrr
        logleb sylancr mulge0d ) AKUSUTZKSRVAVBZVCVDZVEZVEZHKVAVBZSKVAVBZGVFZSV
        AVBZVGVFZVHVBZKVIVFZUUIUUJUUNUUIHKUUIHAHVJUTUUHUGVKVLZAUUEUUGVMZVNZUUIU
        UMUUIUUMUUIUULSUUIUUKVJUTUULVOUTUUISKASVJUTZUUHAUUTVPSVQVDVRSVSVFZVCVDU
        VAUUFVCVDVTWAMIWBVBVAVBUVAVCVDQVIVFLVIVFZVAVBWCWDVBSVIVFZUVBVAVBWAVAVBV
        CVDHWEWBVBEWDVBHIVHVBMIWCWFVBWBVBWEWCWRDWBVBVAVBWBVBUVCWBVBVCVDVTACDEFG
        HIJLMPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOWGWHVKZUUIKUURWIZWJZVJVOUUKGGTU
        AWKWLWSZUVDWMWNZWOZWPUUIKUVEWQUUIWTUUOVCVDUUNUUJVCVDZUUIUUNKWBVBZHVCVDU
        VJUUIUULUUKVAVBZVGVFZUVKHVCUUIUVMUUMKWBVBZVGVFUUNKVGVFZWBVBUVKUUIUVLUVN
        VGUUIUVLUULKWBVBSVAVBZUVNUUIUULXJUTZSXJUTSWTXAVEZKXJUTZKWTXAVEUVLUVPXBU
        UIUULUVGWNZUUISUVDXCZUUIKUVEXCUULSKXDXEUUIUVQUVSUVRUVPUVNXBUVTUUIKUURXF
        ZUWAUULKSXGXEXHXKUUIUUMKUVHUWBXIUUIUVOKUUNWBUUIKVOUTWTKVCVDVEUVOKXBUUIK
        UVEXLKXMWSXNXOUUIUUKRXPXQVBZUTZBYAZGVFZUWEVAVBZVGVFZHVCVDZBUWCXRZUVMHVC
        VDZUUIUWDUUKVOUTZRUUKVCVDZUUIUUKUVFVLUUIRKWBVBSVCVDZUWMUUIUWNUUGAUUEUUG
        XSUUIKSRUUIKUVEVLUUISUVDVLZARVJUTZUUHAUWPVPRVCVDUKYBVKZXTYCUUIRSKUUIRUW
        QVLZUWOUVEYDYEUUIRVOUTUWDUWLUWMVEYFUWRRUUKYGWSYHAUWJUUHURVKUWIUWKBUUKUW
        CUWEUUKXBZUWHUVMHVCUWSUWGUVLVGUWSUWFUULUWEUUKVAUWEUUKGYIUWSYJYKXKYLYMYN
        YOUUIUUNHKUVIUUQUVEYDYEUUIUUJUUNUUSUVIYPYCUUIWTVPVIVFZUUPVCYQUUIVPKVCVD
        ZUWTUUPVCVDZUUEUXAAUUGKYRYSUUIVPVJUTKVJUTUXAUXBYFYTUVEVPKUUBUUCYEUUAUUD
        $.

      pntlem1.K $e |- ( ph -> A. y e. ( X (,) +oo ) E. z e. RR+
      ( ( y < z /\ ( ( 1 + ( L x. E ) ) x. z ) < ( K x. y ) ) /\
        A. u e. ( z [,] ( ( 1 + ( L x. E ) ) x. z ) )
          ( abs ` ( ( R ` u ) / u ) ) <_ E ) ) $.
      ${
        pntlem1.o $e |- O =
          ( ( ( |_ ` ( Z / ( K ^ ( J + 1 ) ) ) ) + 1 ) ...
             ( |_ ` ( Z / ( K ^ J ) ) ) ) $.
        ${
          pntlem1.v $e |- ( ph -> V e. RR+ ) $.
          pntlem1.V $e |- ( ph -> ( ( ( K ^ J ) < V /\
            ( ( 1 + ( L x. E ) ) x. V ) < ( K x. ( K ^ J ) ) ) /\
            A. u e. ( V [,] ( ( 1 + ( L x. E ) ) x. V ) )
              ( abs ` ( ( R ` u ) / u ) ) <_ E ) ) $.
          pntlem1.j $e |- ( ph -> J e. ( M ..^ N ) ) $.
          pntlem1.i $e |- I =
            ( ( ( |_ ` ( Z / ( ( 1 + ( L x. E ) ) x. V ) ) ) + 1 )
              ... ( |_ ` ( Z / V ) ) ) $.
          $( Lemma for ~ pntlemj .  (Contributed by Mario Carneiro,
             7-Jun-2016.) $)
          pntlemq $p |- ( ph -> I C_ O ) $=
            ( c1 cmul co caddc cdiv cfl cfv cfz cexp cuz wss cz cle wbr crp clt
            wcel ceu csqr w3a c4 clog c2 c3 cmin cdc pntlemb simp1d cc0 pntlemc
            cioo simp2d elfzoelz syl peano2zd rpexpcld rpdivcld rpred flcld 1rp
            cfzo pntlemd rpmulcld rpaddcl sylancr cr wa cabs cicc simpld simprd
            cv wral rpcnd mulcomd cn pntlemg elfzouz nnuz uztrn2 syl2anc nnnn0d
            expp1d eqtr4d ltled lediv2d mpbid flwordi syl3anc eluz2 syl3anbrc
            breqtrd eluzp1p1 fzss1 3syl fzss2 sstrd 3sstr4g ) AUDVJPKVKVLZVMVLZ
            TVKVLZVNVLZVOVPZVJVMVLZUDTVNVLZVOVPZVQVLZUDONVJVMVLZVRVLZVNVLZVOVPZ
            VJVMVLZUDONVRVLZVNVLZVOVPZVQVLZMSAUUPUVAUUOVQVLZUVEAUULUUTVSVPWFZUU
            MUVAVSVPWFUUPUVFVTAUUTWAWFUULWAWFUUTUULWBWCZUVGAUUSAUUSAUDUURAUDWDW
            FVJUDWEWCWGUDWHVPZWBWCUVIUDUCVNVLWBWCWIWJUUHVNVLUVIWBWCUBWKVPOWKVPZ
            VNVLWLVMVLUDWKVPZUVJVNVLWJVNVLZWBWCJWMVKVLGVMVLJKWNVLZPKWLVRVLVKVLW
            MWLWOFVKVLVNVLVKVLUVKVKVLWBWCWIAEFGHIJKLOPUAUBUCUDUEUFUGUHUIUJUKULU
            MUNUOUPUQURUSUTWPWQZAOUUQAKWDWFZOWDWFZKWRVJWTVLWFVJOWEWCUVMWDWFWIZA
            EFHIJKLOPUEUFUGUHUIUJUKULUMUNUOWSZXAZANANQRXJVLWFZNWAWFVHNQRXBXCZXD
            XEZXFXGZXHAUUKAUUKAUDUUJUVNAUUITAVJWDWFUUHWDWFUUIWDWFXIAPKAPWDWFHWD
            WFLWDWFAEFHILPUEUFUGUHUIUJUKXKWQAUVOUVPUVQUVRWQXLVJUUHXMXNVFXLZXFXG
            ZXHAUUSXOWFUUKXOWFUUSUUKWBWCZUVHUWCUWEAUUJUURWBWCUWFAUUJUURAUUJUWDX
            GAUURUWBXGAUUJOUVBVKVLZUURWEAUVBTWEWCZUUJUWGWEWCZAUWHUWIXPDYAZIVPUW
            JVNVLXQVPKWBWCDTUUJXRVLYBVGXSZXTAUWGUVBOVKVLUURAOUVBAOUVSYCZAUVBAON
            UVSUWAXEZYCYDAONUWLANAQYEWFZNQVSVPZWFZNYEWFAUWNRUWOWFUVLRQWNVLWBWCA
            EFGHIJKLOPQRUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBYFWQAUVTUWP
            VHNQRYGXCVJNQYEYHYIYJYKYLYMUUAYNAUUJUURUDUWDUWBUVNYOYPUUSUUKYQYRUUT
            UULYSYTUUTUULUUBUUMUVAUUOUUCUUDAUVDUUOVSVPWFZUVFUVEVTAUUOWAWFUVDWAW
            FUUOUVDWBWCZUWQAUUNAUUNAUDTUVNVFXFXGZXHAUVCAUVCAUDUVBUVNUWMXFXGZXHA
            UUNXOWFUVCXOWFUUNUVCWBWCZUWRUWSUWTAUVBTWBWCUXAAUVBTAUVBUWMXGATVFXGA
            UWHUWIUWKXSYNAUVBTUDUWMVFUVNYOYPUUNUVCYQYRUUOUVDYSYTUUOUVAUVDUUEXCU
            UFVIVEUUG $.

          $( Lemma for ~ pntlemj .  (Contributed by Mario Carneiro,
             7-Jun-2016.) $)
          pntlemr $p |- ( ph ->
            ( ( U - E ) x. ( ( ( L x. E ) / 8 ) x. ( log ` Z ) ) ) <_
     ( ( # ` I ) x. ( ( U - E ) x. ( ( log ` ( Z / V ) ) / ( Z / V ) ) ) ) ) $=
            ( cmin co cmul c8 cdiv clog cfv chash cle wbr c4 c2 crp wcel simp1d
            cc0 clt rpmulcld rpdivcl sylancl rpred caddc cexp rpdivcld remulcld
            c1 w3a c3 cfn cfl cfz syl recnd cr sylancr reflcl peano2re readdcld
            cc ax-1cn a1i simp3d cz wa simprd rpcnd syl2anc breqtrd ltled letrd
            cuz lemul2d mpbid wceq rprege0d lemuldivd mulid2d ltmul1dd breqtrrd
            cn wne rpcnne0d rpcnne0 mp1i oveq2d syl3anc oveq1d eqtr3d wb mpbird
            2z pntlemd cioo pntlemc 4re 4pos elrpii ceu csqr cdc fzfid syl5eqel
            pntlemb cn0 hashcl nn0red 1rp add32d rphalfcld rpsqrcld simp2d cfzo
            rpaddcl elfzoelz peano2zd rpexpcld cv cabs cicc wral simpld mulcomd
            pntlemg elfzouz uztrn2 nnnn0d expp1d fzofzp1 pntlemh mpdan remsqsqr
            eqtr4d 1re ltaddrp eqbrtrrd ltdiv2d leadd2dd 2timesd remulcl adddid
            nnuz 2re divcan6 eqtrd mulassd divdiv1 2t2e4 oveq2i syl6req halfcld
            divcan1d 3brtr3d flle le2addd rprecred eliooord lttrd ltadd2dd df-2
            2rp syl6breqr rpregt0d 2pos ltdiv2 syl121anc divsubdir pncan2 divid
            3eqtr3d reccl adddird rpne0d 3eqtr2d lelttrd fllep1 ltletrd eqbrtrd
            ltaddsubd divrec2d ltadd1d fzval3 flword2 eluzp1p1 hashfzo pnpcan2d
            syl5eq fveq2d 3eqtrd resqrth rpexpcl sqvald resqcld sqdivd relogexp
            flcld le2sq logled relogcld ledivmul syl112anc wi rplogcld lemul12a
            rerpdivcld syl22anc mp2and nnrp ax-mp div23 divmuldiv 4t2e8 3brtr4d
            8nn divass mul12d ) AJKVJVKZPKVLVKZVMVNVKZUDVOVPZVLVKZVLVKZVVEMVQVP
            ZUDTVNVKZVOVPZVVLVNVKZVLVKZVLVKZVVKVVEVVNVLVKVLVKVRAVVIVVOVRVSVVJVV
            PVRVSAVVFVTVNVKZVVHWAVNVKZVLVKZVVKVVLVNVKZVVMVLVKZVVIVVOVRAVVQVVTVR
            VSZVVRVVMVRVSZVVSVWAVRVSZAVVQVVLVLVKZVVKVRVSVWBAVWEVVKAVVQVVLAVVQAV
            VFWBWCZVTWBWCZVVQWBWCAPKAPWBWCHWBWCLWBWCAEFHILPUEUFUGUHUIUJUKUUAWDZ
            AKWBWCZOWBWCZKWEWOUUBVKZWCZWOOWFVSZVVEWBWCZWPZAEFHIJKLOPUEUFUGUHUIU
            JUKULUMUNUOUUCZWDZWGZVTUUDUUEUUFZVVFVTWHWIZWJZAVVLAUDTAUDWBWCZWOUDW
            FVSZUUGUDUUHVPZVRVSZVXDUDUCVNVKVRVSZWPZVTVVFVNVKZVXDVRVSZUBVOVPOVOV
            PZVNVKWAWKVKVVHVXJVNVKVTVNVKZVRVSZJWQVLVKGWKVKVVEPKWAWLVKVLVKWQWAUU
            IFVLVKVNVKVLVKVVHVLVKVRVSZWPZAEFGHIJKLOPUAUBUCUDUEUFUGUHUIUJUKULUMU
            NUOUPUQURUSUTUULZWDZVFWMZWJZWNZAVVKAMWRWCVVKUUMWCAMUDWOVVFWKVKZTVLV
            KZVNVKZWSVPZWOWKVKZVVLWSVPZWTVKZWRVIAVYDVYEUUJUUKMUUNXAUUOZAVWEVYEV
            YCVJVKZVVKWFAVWEVYCWKVKZVYEWFVSZVWEVYHWFVSAVYJVYIWOWKVKZVYEWOWKVKZW
            FVSAVYKVWEWOWKVKZVYCWKVKZVYLWFAVWEVYCWOAVWEVXSXBAVYCAVYBXCWCZVYCXCW
            CAVYBAUDVYAVXPAVXTTAWOWBWCVWFVXTWBWCUUPVWRWOVVFUVBXDZVFWGZWMWJZVYBX
            EXAZXBZWOXHWCZAXIXJZUUQAVYNVVLVYLAVYMVYCAVWEXCWCVYMXCWCVXSVWEXFXAZV
            YSXGZVXRAVYEXCWCZVYLXCWCAVVLXCWCZWUEVXRVVLXEXAZVYEXFXAAVYNVVFWAVNVK
            ZVVLVLVKZVYBWKVKZVVLWUDAWUIVYBAWUIAWUHVVLAVVFVWRUURZVXQWGWJZVYRXGVX
            RAVYMVYCWUIVYBWUCVYSWULVYRAVVQVVLVXHWKVKZVLVKZVVQWAVVLVLVKZVLVKZVYM
            WUIVRAWUMWUOVRVSWUNWUPVRVSAWUMVVLVVLWKVKWUOVRAVXHVVLVVLAVXHAVWGVWFV
            XHWBWCVWSVWRVTVVFWHXDZWJZVXRVXRAVXHVXDVVLWURAVXDAUDVXPUUSZWJZVXRAVX
            IVXLVXMAVXBVXGVXNVXOXKWDAVXDVYBVVLWUTVYRVXRAVXDVYAVLVKZUDVRVSVXDVYB
            VRVSAWVAVXDVXDVLVKZUDVRAVYAVXDVRVSWVAWVBVRVSAVYAONWOWKVKZWLVKZVXDAV
            YAVYQWJZAWVDAOWVCAVWIVWJVWOVWPUUTZANANQRUVAVKWCZNXLWCVHNQRUVCXAZUVD
            UVEWJZWUTAVYAWVDWVEWVIAVYAOONWLVKZVLVKZWVDWFAWVJTWFVSZVYAWVKWFVSZAW
            VLWVMXMDUVFZIVPWVNVNVKUVGVPKVRVSDTVYAUVHVKUVIVGUVJXNAWVKWVJOVLVKWVD
            AOWVJAOWVFXOZAWVJAONWVFWVHUVEXOUVKAONWVOANAQYIWCZNQXTVPZWCZNYIWCAWV
            PRWVQWCVXKRQVJVKVRVSAEFGHIJKLOPQRUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQ
            URUSUTVAVBUVLWDAWVGWVRVHNQRUVMXAWONQYIUWJUVNXPUVOUVPUWAXQZXRAUBWVDW
            FVSZWVDVXDVRVSZAWVCQRWTVKWCZWVTWWAXMAWVGWWBVHQRNUVQXAAEFGHIJKLWVCOP
            QRUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBUVRUVSXNZXSAVYAVXDVXD
            WVEWUTWUSYAYBAUDXCWCWEUDVRVSXMZWVBUDYCAUDVXPYDZUDUVTXAXQAVXDUDVYAWU
            TAUDVXPWJZVYQYEYBAVYBVVLVYRVXRATVYAWFVSVYBVVLWFVSAWOTVLVKTVYAWFATAT
            VFXOZYFAWOVXTTWOXCWCZAUWBXJZAVXTVYPWJVFAWWHVWFWOVXTWFVSUWBVWRWOVVFU
            WCXDYGUWDZATVYAUDVFVYQVXPUWEYBXRZXSXSUWFAVVLAVVLVXQXOZUWGYHAWUMWUOV
            VQAVVLVXHVXRWURXGAWAXCWCZWUFWUOXCWCUWKVXRWAVVLUWHXDVWTYAYBAWUNVWEVV
            QVXHVLVKZWKVKVYMAVVQVVLVXHAVVQVWTXOZWWLAVXHWUQXOUWIAWWNWOVWEWKAVVFX
            HWCZVVFWEYJXMVTXHWCVTWEYJXMZWWNWOYCAVVFVWRYKVWGWWQAVWSVTYLYMZVVFVTU
            WLXPYNUWMAVVQWAVLVKZVVLVLVKWUPWUIAVVQWAVVLWWOAWAXHWCZWAWEYJZWAWBWCW
            WTWXAXMZAUXIWAYLYMZUVJZWWLUWNAWWSWUHVVLVLAWWSWUHWAVNVKZWAVLVKWUHAVV
            QWXEWAVLAWXEVVFWAWAVLVKZVNVKZVVQAWWPWXBWXBWXEWXGYCAVVFVWRXOZWXCWXCV
            VFWAWAUWOYOWXFVTVVFVNUWPUWQUWRYPAWUHWAAVVFWXHUWSZWXDAWWTWXAWXCXNUWT
            UWMYPYQUXAAVYOVYCVYBVRVSVYRVYBUXBXAUXCAWUHWOVXTVNVKZWKVKZVVLVLVKZWO
            VVLVLVKWUJVVLWFAWXKWOVVLAWUHWXJAWUHWUKWJZAVXTVYPUXDZXGWWIVXQAWXKWOW
            FVSWUHWOWXJVJVKZWFVSAWUHVVFVXTVNVKZWXOWFAVXTWAWFVSZWUHWXPWFVSZAVXTW
            OWOWKVKWAWFAVVFWOWOAVVFVWRWJZWWIWWIAVVFKWOWXSAKVWQWJWWIAVVFWOKVLVKK
            WFAPWOKAPVWHWJWWIVWQAWEPWFVSZPWOWFVSZAPVWKWCWXTWYAXMUIPWEWOUXEXAXNY
            GAKAKVWQXOYFXQAWEKWFVSZKWOWFVSZAVWLWYBWYCXMAVWLVWMVWNAVWIVWJVWOVWPX
            KZWDKWEWOUXEXAXNUXFUXGUXHUXJAVXTXCWCWEVXTWFVSXMWWMWEWAWFVSZVVFXCWCW
            EVVFWFVSXMWXQWXRYRAVXTVYPUXKWWMAUWKXJZWYEAUXLXJZAVVFVWRUXKVXTWAVVFU
            XMUXNYBAVXTWOVJVKZVXTVNVKZVXTVXTVNVKZWXJVJVKZWXPWXOAVXTXHWCZWUAWYLV
            XTWEYJXMZWYIWYKYCAVXTVYPXOZWUBAVXTVYPYKZVXTWOVXTUXOYOAWYHVVFVXTVNAW
            UAWWPWYHVVFYCXIWXHWOVVFUXPXDYPAWYJWOWXJVJAWYMWYJWOYCWYOVXTUXQXAYPUX
            RXQAWUHWXJWOWXMWXNWWIUYGYSYGAWXLWUIWXJVVLVLVKZWKVKWUJAWUHWXJVVLWXIA
            WYMWXJXHWCWYOVXTUXSXAWWLUXTAVYBWYPWUIWKAVYBUDTVXTVLVKZVNVKZVVLVXTVN
            VKZWYPAVYAWYQUDVNAVXTTWYNWWGUVKYNAUDXHWCTXHWCTWEYJXMWYMWYSWYRYCAUDV
            XPXOZATVFYKWYOUDTVXTUWOYOAVVLVXTWWLWYNAVXTVYPUYAUYHUYBYNUWAAVVLWWLY
            FUXAUYCAWUFVVLVYLVRVSVXRVVLUYDXAUYEUYFAVYIVYEWOAVWEVYCVXSVYSXGWUGWW
            IUYIYSAVWEVYCVYEVXSVYSWUGUYGYBAVVKVYDVYLUVAVKZVQVPZVYLVYDVJVKZVYHAM
            XUAVQAMVYFXUAVIAVYEXLWCVYFXUAYCAVVLVXRVUDVYDVYEUYJXAUYOUYPAVYLVYDXT
            VPWCZXUBXUCYCAVYEVYCXTVPWCZXUDAVYOWUFVYBVVLVRVSXUEVYRVXRWWKVYBVVLUY
            KYOVYCVYEUYLXAVYDVYLUYMXAAVYEVYCWOAVYEWUGXBVYTWUBUYNUYQYHXRAVVQVVKV
            VLVXAVYGVXQYEYBAVWCVVHWAVVMVLVKZVRVSZAVVHVVLWAWLVKZVOVPZXUFVRAUDXUH
            VRVSVVHXUIVRVSAUDUDWAWLVKZTWAWLVKZVNVKZXUHVRAUDXUKVLVKZXUJVRVSUDXUL
            VRVSAXUMUDUDVLVKZXUJVRAXUKUDVRVSXUMXUNVRVSAXUKVXDWAWLVKZUDVRATVXDVR
            VSZXUKXUOVRVSZATVXDATVFWJZWUTATVYAVXDXURWVEWUTWWJAVYAWVDVXDWVEWVIWU
            TWVSWWCUYEUXFXRATXCWCWETVRVSXMVXDXCWCWEVXDVRVSXMXUPXUQYRATVFYDAVXDW
            USYDTVXDVUEXPYBAWWDXUOUDYCWWEUDUYRXAXQAXUKUDUDAXUKATWBWCWAXLWCZXUKW
            BWCVFYTTWAUYSWIZWJWWFVXPYAYBAUDWYTUYTYHAUDXUJXUKWWFAUDWWFVUAXUTYEYB
            AUDTWYTWWGATVFUYAVUBYHAUDXUHVXPAVVLWBWCZXUSXUHWBWCVXQYTVVLWAUYSWIVU
            FYBAXVAXUSXUIXUFYCVXQYTVVLWAVUCWIXQAVVHXCWCVVMXCWCZWWMWYEVWCXUGYRAU
            DVXPVUGAVVLVXQVUGZWYFWYGVVHVVMWAVUHVUIYSAVVQXCWCWEVVQVRVSXMVVTXCWCV
            VRXCWCWEVVRVRVSXMXVBVWBVWCXMVWDVUJAVVQVWTYDAVVKVVLVYGVXQVUMAVVRAVVH
            AUDWWFAVXCVXEVXFAVXBVXGVXNVXOUUTWDVUKZUURYDXVCVVQVVTVVRVVMVULVUNVUO
            AVVFVVHVLVKZVMVNVKZVVIVVSAWWPVVHXHWCZVMXHWCVMWEYJXMZXVFVVIYCWXHAVVH
            XVDXOZVMWBWCZXVHAVMYIWCXVJVVBVMVUPVUQZVMYLYMVVFVVHVMVURYOAVVSXVEVTW
            AVLVKZVNVKZXVFAWWPXVGWWQWXBVVSXVMYCWXHXVIWWRWXCVVFVVHVTWAVUSVUNXVLV
            MXVEVNVUTUWQUWRYQAVVKXHWCZVVMXHWCZVVLXHWCVVLWEYJXMZVVOVWAYCAVVKVYGX
            BZAVVMXVCXBAVVLVXQYKXVNXVOXVPWPVVKVVMVLVKVVLVNVKVVOVWAVVKVVMVVLVVCV
            VKVVMVVLVURYQYOVVAAVVIVVOVVEAVVIAVVGVVHAVWFXVJVVGWBWCVWRXVKVVFVMWHW
            IXVDWGWJAVVKVVNVYGAVVMVVLXVCVXQVUMZWNAVWLVWMVWNWYDXKZYAYBAVVEVVKVVN
            AVVEXVSXOXVQAVVNXVRXBVVDXQ $.

          $( Lemma for ~ pnt .  The induction step.  Using ~ pntibnd , we find
             an interval in ` K ^ J ... K ^ ( J + 1 ) ` which is sufficiently
             large and has a much smaller value, ` R ( z ) / z <_ E ` (instead
             of our original bound ` R ( z ) / z <_ U ` ).  (Contributed by
             Mario Carneiro, 13-Apr-2016.) $)
          pntlemj $p |- ( ph ->
    ( ( U - E ) x. ( ( ( L x. E ) / 8 ) x. ( log ` Z ) ) ) <_ sum_ n e. O
    ( ( ( U / n ) - ( abs ` ( ( R ` ( Z / n ) ) / Z ) ) ) x. ( log ` n ) ) ) $=
            ( cmin co cmul c8 cdiv clog cfv cv cabs csu cc0 c1 wcel clt wbr crp
            w3a simp3d simp1d rpmulcld cn ceu cle c4 c2 caddc cexp rpred simp2d
            c3 cfn cn0 cfl fzfid syl5eqel rpdivcld relogcld rerpdivcld remulcld
            cfz syl wa cr adantr cz rpexpcld rprege0d flge0nn0 3syl nnuz uztrn2
            cuz nndivred recnd cc wceq syl2anc rpregt0d simpld syldan wb mpbird
            a1i simprd rpcnd ltled letrd mpbid lemuldivd syl3anc chash cioo 8nn
            pntlemc pntlemd nnrp ax-mp rpdivcl sylancl csqr cdc rplogcld hashcl
            pntlemb nn0red elfzoelz peano2zd nn0p1nn elfzuz eleq2s syl2an nnrpd
            cfzo pntrf ffvelrni abscld resubcld fsumrecl pntlemr fsumconst wral
            cif wss wo pntlemq ralrimivw olcd sumss2 syl21anc eqtr3d adantlr wn
            0re ifclda breq1 1rp rpaddcl sylancr simpr syl6eleq elfzle2 elfzelz
            sselda flge ere rpsqrcld cicc mulcomd pntlemg elfzouz nnnn0d expp1d
            nnred eqtr4d breqtrd fzofzp1 pntlemh mpdan remsqsqr reflcl peano2re
            lemul2d fllep1 elfzle1 logdivle syl22anc lemul2 wne rpcnne0d divass
            div23 log1 nnge1d logleb syl5eqbrr divsubdir divdiv2 fveq2d absmuld
            eqtrd absid oveq2d 3eqtrd lemuldiv2 lediv23 mpbir3and fveq2 oveq12d
            elicc2 id breq1d rspcv sylc eqbrtrrd lesub2dd eqbrtrd lemul1ad nnzd
            elfzofz lediv2d jca pntlemn ifbothda fsumle ) AJLVKVLZQLVMVLZVNVOVL
            ZUEVPVQZVMVLZVMVLZNUUAVQZVUOUEUAVOVLZVPVQZVVBVOVLZVMVLZVMVLZTJKVRZV
            OVLZUEVVGVOVLZIVQZUEVOVLZVSVQZVKVLZVVGVPVQZVMVLZKVTZAVUTAVUOVUSALWA
            WBUUBVLWCZWBPWDWEZVUOWFWCZALWFWCZPWFWCZVVQVVRVVSWGZAEFHIJLMPQUFUGUH
            UIUJUKULUMUNUOUPUUDZWHWHZAVUQVURAVUPWFWCZVNWFWCZVUQWFWCAQLAQWFWCHWF
            WCMWFWCAEFHIMQUFUGUHUIUJUKULUUEWIAVVTVWAVWBVWCWIZWJZVNWKWCVWFUUCVNU
            UFUUGVUPVNUUHUUIAUEAUEAUEWFWCZWBUEWDWEZWLUEUUJVQZWMWEZVWKUEUDVOVLZW
            MWEZWGZWNVUPVOVLVWKWMWEUCVPVQPVPVQZVOVLWOWPVLVURVWPVOVLWNVOVLZWMWEJ
            WTVMVLGWPVLVUOQLWOWQVLVMVLWTWOUUKFVMVLVOVLVMVLVURVMVLWMWEWGZAEFGHIJ
            LMPQUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAUUNZWIZWRZAVWJVWLVWNAVW
            IVWOVWRVWSWSZWIUULWJWJWRAVVAVVEAVVAANXAWCZVVAXBWCANUEWBVUPWPVLZUAVM
            VLZVOVLZXCVQZWBWPVLZVVBXCVQZXJVLZXAVJAVXHVXIXDXEZNUUMXKUUOAVUOVVDAV
            UOVWDWRZAVVCVVBAVVBAUEUAVWTVGXFZXGVXMXHZXIZXIATVVOKATUEPOWBWPVLZWQV
            LZVOVLZXCVQZWBWPVLZUEPOWQVLZVOVLZXCVQZXJVLZXAVFAVXTVYCXDXEZAVVGTWCZ
            XLZVVMVVNVYGVVHVVLVYGJVVGAJXMWCVYFAJUMWRXNAVXTWKWCZVVGVXTYBVQWCZVVG
            WKWCZVYFAVXRXMWCWAVXRWMWEXLVXSXBWCVYHAVXRAUEVXQVWTAPVXPAVVTVWAVWBVW
            CWSZAOAORSUVCVLWCZOXOWCVIORSUUPXKZUUQXPZXFXQVXRXRVXSUURXSVYIVVGVYDT
            VVGVXTVYCUUSVFUUTWBVVGVXTWKXTYAUVAZYCZVYGVVKVYGVVKVYGVVJUEVYGVVIWFW
            CVVJXMWCZVYGUEVVGAVWIVYFVWTXNZVYGVVGVYOUVBZXFWFXMVVIIIUFUGUVDUVEXKZ
            VYRXHYDZUVFZUVGZVYGVVGVYSXGXIZUVHABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGU
            HUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJUVIAVVFTVVGNWCZVVEWAUV
            LZKVTZVVPWMANVVEKVTZVVFWUGAVXCVVEYEWCZWUHVVFYFVXKAVVEVXOYDZNVVEKUVJ
            YGANTUVMWUIKNUVKTWBYBVQUVMZTXAWCZUVNWUHWUGYFABCDEFGHIJLMNOPQRSTUAUB
            UCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJUVOZAWUIKNW
            UJUVPAWULWUKVYEUVQNTVVEKWBUVRUVSUVTATWUFVVOKVYEVYGWUEVVEWAXMAWUEVVE
            XMWCZVYFAWUNWUEVXOXNZUWAWAXMWCVYGWUEUWBZXLUWCYMUWDWUDWUEVVEVVOWMWEZ
            WAVVOWMWEZWUFVVOWMWEVYGVVEWAVVEWUFVVOWMUWEWAWUFVVOWMUWEAWUEWUQVYFAW
            UEXLZVVEVUOVVNVVGVOVLZVMVLZVVOWUOWUSVUOWUTWUSVUOXMWCZWAVUOWDWEZAWVB
            WVCXLZWUEAVUOVWDYHXNZYIWUSVVNVVGWUSVVGWUSVVGAVXHWKWCZVVGVXHYBVQWCZV
            YJWUEAVXFXMWCZWAVXFWMWEXLVXGXBWCWVFAVXFAUEVXEVWTAVXDUAAWBWFWCZVWEVX
            DWFWCUWFVWHWBVUPUWGUWHVGWJZXFZXQVXFXRVXGUURXSWVGVVGVXJNVVGVXHVXIUUS
            VJUUTWBVVGVXHWKXTYAUVAZUVBZXGZWVLYCZXIAWUEVYFVVOXMWCANTVVGWUMUWMZWU
            DYJWUSVVDWUTWMWEZVVEWVAWMWEZWUSVVGVVBWMWEZWVQWUSWVSVVGVXIWMWEZWUSVV
            GVXJWCZWVTWUSVVGNVXJAWUEUWIVJUWJZVVGVXHVXIUWKXKWUSVVBXMWCZVVGXOWCZW
            VSWVTYKAWWCWUEAVVBVXMWRXNZWUSWWAWWDWWBVVGVXHVXIUWLXKVVBVVGUWNYGYLZW
            USVVGXMWCZWLVVGWMWEWWCWLVVBWMWEWVSWVQYKWUSVVGWVLUXCZWUSWLVXFVVGWLXM
            WCZWUSUWOYMZAWVHWUEAVXFWVKWRZXNZWWHAWLVXFWMWEWUEAWLVWKVXFWWIAUWOYMA
            VWKAUEVWTUWPZWRZWWKAVWJVWLVWNVXBWSAVWKVXEVMVLZUEWMWEVWKVXFWMWEAWWOV
            WKVWKVMVLZUEWMAVXEVWKWMWEWWOWWPWMWEAVXEVXQVWKAVXEWVJWRZAVXQVYNWRZWW
            NAVXEVXQWWQWWRAVXEPVYAVMVLZVXQWDAVYAUAWDWEZVXEWWSWDWEZAWWTWXAXLZDVR
            ZIVQZWXCVOVLZVSVQZLWMWEZDUAVXEUWQVLZUVKZVHYIYNAWWSVYAPVMVLVXQAPVYAA
            PVYKYOZAVYAAPOVYKVYMXPZYOUWRAPOWXJAOARWKWCZORYBVQZWCZOWKWCAWXLSWXMW
            CVWQSRVKVLWMWEAEFGHIJLMPQRSUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVA
            VBVCUWSWIAVYLWXNVIORSUWTXKWBORWKXTYAYGUXAUXBUXDUXEYPAUCVXQWDWEZVXQV
            WKWMWEZAVXPRSXJVLZWCZWXOWXPXLAVYLWXRVIRSOUXFXKAEFGHIJLMVXPPQRSUBUCU
            DUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCUXGUXHYNYQAVXEVWKVWKWWQWWNWW
            MUXLYRAUEXMWCZWAUEWMWEXLWWPUEYFAUEVWTXQUEUXIXKUXEAVWKUEVXEWWNVXAWVJ
            YSYRYQXNWUSVXFVXHVVGWWLAVXHXMWCZWUEAWVHVXGXMWCWXTWWKVXFUXJVXGUXKXSX
            NWWHWUSWVHVXFVXHWMWEWWLVXFUXMXKWUSWWAVXHVVGWMWEWWBVVGVXHVXIUXNXKYQZ
            YQZWWEWUSWLVVGVVBWWJWWHWWEWYBWWFYQVVGVVBUXOUXPYRWUSVVDXMWCZWUTXMWCW
            VDWVQWVRYKAWYCWUEVXNXNWVOWVEVVDWUTVUOUXQYTYRWUSVUOVVGVOVLZVVNVMVLZW
            VAVVOWMWUSVUOVVNVMVLVVGVOVLZWYEWVAWUSVUOYEWCZVVNYEWCZVVGYEWCZVVGWAU
            XRXLZWYFWYEYFAWYGWUEAVUOVWDYOXNZWUSVVNWVNYDZWUSVVGWVMUXSZVUOVVNVVGU
            YAYTWUSWYGWYHWYJWYFWVAYFWYKWYLWYMVUOVVNVVGUXTYTUVTWUSWYDVVMVVNWUSVU
            OVVGAWVBWUEVXLXNWVLYCAWUEVYFVVMXMWCWVPWUCYJWVNWUSWAWBVPVQZVVNWMUYBW
            USWBVVGWMWEZWYNVVNWMWEZWUSVVGWVLUYCWUSWVIVVGWFWCWYOWYPYKUWFWVMWBVVG
            UYDUWHYRUYEWUSWYDVVHLVVGVOVLZVKVLZVVMWMWUSJYEWCZLYEWCWYJWYDWYRYFAWY
            SWUEAJUMYOXNWUSLALXMWCWUEALVWGWRXNZYDWYMJLVVGUYFYTWUSVVLWYQVVHAWUEV
            YFVVLXMWCWVPWUBYJZWUSLVVGWYTWVLYCAWUEVYFVVHXMWCWVPVYPYJWUSVVLVVGVMV
            LZLWMWEVVLWYQWMWEWUSVVJVVIVOVLZVSVQZXUBLWMWUSXUDVVKVVGVMVLZVSVQVVLV
            VGVSVQZVMVLXUBWUSXUCXUEVSWUSXUCVVJVVGVMVLUEVOVLZXUEWUSVVJYEWCZUEYEW
            CUEWAUXRXLZWYJXUCXUGYFWUSVVJAWUEVYFVYQWVPVYTYJYDZWUSUEAVWIWUEVWTXNU
            XSZWYMVVJUEVVGUYGYTWUSXUHWYIXUIXUGXUEYFXUJWUSVVGWVMYOZXUKVVJVVGUEUY
            AYTUYJUYHWUSVVKVVGAWUEVYFVVKYEWCWVPWUAYJXULUYIWUSXUFVVGVVLVMWUSWWGW
            AVVGWMWEXLXUFVVGYFWUSVVGWVMXQVVGUYKXKUYLUYMWUSVVIWXHWCZWXIXUDLWMWEZ
            WUSXUMVVIXMWCZUAVVIWMWEZVVIVXEWMWEZWUSUEVVGAWXSWUEVXAXNZWVLYCWUSUAV
            VGVMVLUEWMWEZXUPWUSXUSWVSWWFWUSWWGWXSUAXMWCZWAUAWDWEZXLZXUSWVSYKWWH
            XURAXVBWUEAUAVGYHXNZVVGUEUAUYNYTYLWUSUAUEVVGWUSXUTXVAXVCYIXURWVMYSY
            RWUSVXFVVGWMWEZXUQWYAWUSWXSVXEXMWCZWAVXEWDWEXLZWWGWAVVGWDWEXLXVDXUQ
            YKXURAXVFWUEAVXEWVJYHXNWUSVVGWVMYHUEVXEVVGUYOYTYRWUSXUTXVEXUMXUOXUP
            XUQWGYKAXUTWUEAUAVGWRXNAXVEWUEWWQXNUAVXEVVIUYSYGUYPAWXIWUEAWXBWXIVH
            YNXNWXGXUNDVVIWXHWXCVVIYFZWXFXUDLWMXVGWXEXUCVSXVGWXDVVJWXCVVIVOWXCV
            VIIUYQXVGUYTUYRUYHVUAVUBVUCVUDWUSVVLLVVGXUAWYTWVMYSYRVUEVUFVUGVUDYQ
            UWAVYGWURWUPAVYFVYJVVGVWMWMWEZXLWURVYGVYJXVHVYOVYGVVGVYBVWMVYGVVGVY
            OUXCAVYBXMWCZVYFAVYBAUEVYAVWTWXKXFWRXNZAVWMXMWCVYFAVWMAUEUDVWTAUDWF
            WCWBUDWMWEUQYIZXFWRXNVYGVVGVYBWMWEZVVGVYCWMWEZVYGVVGVYDWCXVMVYGVVGT
            VYDAVYFUWIVFUWJVVGVXTVYCUWKXKVYGXVIWWDXVLXVMYKXVJVYGVVGVYOVUHVYBVVG
            UWNYGYLAVYBVWMWMWEZVYFAUDVYAWMWEXVNAUDUCVYAAUDXVKWRZAUCAUCWFWCZUDUC
            WDWEZURYIWRZAVYAWXKWRZAUDUCXVOXVRAXVPXVQURYNYPAUCVYAXVRXVSAUCVYAWDW
            EZVYAVWKWMWEZAOWXQWCZXVTXWAXLAVYLXWBVIORSVUIXKAEFGHIJLMOPQRSUBUCUDU
            EUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCUXGUXHYIYPYQAUDVYAUEXVKWXKVWTV
            UJYRXNYQVUKACEFGHIJLMVVGPQRSUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTV
            AVBVCVDVULYJXNVUMVUNVUFYQ $.
        $}

        $( Lemma for ~ pnt .  Eliminate some assumptions from ~ pntlemj .
           (Contributed by Mario Carneiro, 13-Apr-2016.) $)
        pntlemi $p |- ( ( ph /\ J e. ( M ..^ N ) ) ->
    ( ( U - E ) x. ( ( ( L x. E ) / 8 ) x. ( log ` Z ) ) ) <_ sum_ n e. O
    ( ( ( U / n ) - ( abs ` ( ( R ` ( Z / n ) ) / Z ) ) ) x. ( log ` n ) ) ) $=
          ( vx cfzo co wcel wa cexp cv clt wbr c1 cmul caddc cfv cdiv cabs cicc
          cle wral cmin c8 clog csu crp cpnf cioo wrex cr cz cc0 pntlemc simp2d
          w3a elfzoelz rpexpcl syl2an rpred csqr cfz elfzofz pntlemh sylan2 cxr
          simpld wb adantr rpxr elioopnf 3syl mpbir2and wceq breq2 oveq2 breq1d
          anbi12d id oveq12d raleqdv cbvrexv breq1 breq2d anbi1d rexbidv syl5bb
          rspcv sylc ad2antrr cico simprl simprr simplr eqid pntlemj rexlimddv
          cfl ) ANQRVFVGVHZVIZONVJVGZVEVKZVLVMZVNPLVOVGZVPVGZUUBVOVGZOUUAVOVGZV
          LVMZVIZDVKZIVQUUJVRVGVSVQLWAVMZDUUBUUFVTVGZWBZVIZJLWCVGZUUDWDVRVGUCWE
          VQVOVGVOVGSJKVKZVRVGUCUUPVRVGIVQUCVRVGVSVQWCVGUUPWEVQVOVGKWFWAVMVEWGY
          TUUAUAWHWIVGZVHZBVKZCVKZVLVMZUUEUUTVOVGZOUUSVOVGZVLVMZVIZUUKDUUTUVBVT
          VGZWBZVIZCWGWJZBUUQWBZUUNVEWGWJZYTUURUUAWKVHZUAUUAVLVMZYTUUAAOWGVHZNW
          LVHUUAWGVHYSALWGVHUVNLWMVNWIVGZVHVNOVLVMUUOWGVHWPAEFHIJLMOPUDUEUFUGUH
          UIUJUKULUMUNWNWONQRWQONWRWSWTYTUVMUUAUCXAVQWAVMZYSANQRXBVGVHUVMUVPVIN
          QRXCAEFGHIJLMNOPQRTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAXDXEXGYT
          UAWGVHZUAXFVHUURUVLUVMVIXHAUVQYSAUVQUBUAVLVMZUPXGXIUAXJUAUUAXKXLXMAUV
          JYSVCXIUVIUVKBUUAUUQUVIUUSUUBVLVMZUUFUVCVLVMZVIZUUMVIZVEWGWJUUSUUAXNZ
          UVKUVHUWBCVEWGUUTUUBXNZUVEUWAUVGUUMUWDUVAUVSUVDUVTUUTUUBUUSVLXOUWDUVB
          UUFUVCVLUUTUUBUUEVOXPZXQXRUWDUUKDUVFUULUWDUUTUUBUVBUUFVTUWDXSUWEXTYAX
          RYBUWCUWBUUNVEWGUWCUWAUUIUUMUWCUVSUUCUVTUUHUUSUUAUUBVLYCUWCUVCUUGUUFV
          LUUSUUAOVOXPYDXRYEYFYGYHYIYTUUBWGVHZUUNVIZVIBCDEFGHIJKLMUCUUFVRVGYRVQ
          VNVPVGUCUUBVRVGYRVQXBVGZNOPQRSUUBTUAUBUCUDUEAEWGVHYSUWGUFYJAFWGVHYSUW
          GUGYJAPUVOVHYSUWGUHYJUIUJAJWGVHYSUWGUKYJAJEWAVMYSUWGULYJUMUNAUBWGVHVN
          UBWAVMVIYSUWGUOYJAUVQUVRVIYSUWGUPYJAGWGVHYSUWGUQYJURAUCTWHYKVGVHYSUWG
          USYJUTVAAUUTIVQUUTVRVGVSVQJWAVMCUBWHYKVGWBYSUWGVBYJAUVJYSUWGVCYJVDYTU
          WFUUNYLYTUWFUUNYMAYSUWGYNUWHYOYPYQ $.
      $}

      $( Lemma for ~ pnt .  Add up the pieces in ~ pntlemi to get an estimate
         slightly better than the naive lower bound ` 0 ` .  (Contributed by
         Mario Carneiro, 13-Apr-2016.) $)
      pntlemf $p |- ( ph -> ( ( U - E ) x.
      ( ( ( L x. ( E ^ 2 ) ) / ( ; 3 2 x. B ) ) x. ( ( log ` Z ) ^ 2 ) ) )
      <_ sum_ n e. ( 1 ... ( |_ ` ( Z / Y ) ) )
    ( ( ( U / n ) - ( abs ` ( ( R ` ( Z / n ) ) / Z ) ) ) x. ( log ` n ) ) ) $=
        ( cmin co c2 cexp cmul c3 cdiv clog cfv c8 cfl cfz csu cc0 wcel clt wbr
        c1 cv crp w3a simp3d simp1d cz sylancl rpmulcld cn sylancr rpdivcld cle
        caddc rpred simp2d cuz nnuz nnred resubcld remulcld fzfid adantr adantl
        c4 wa cr syl rerpdivcld recnd fsumrecl cc wne wceq rpcnd rpcnne0 oveq2d
        mp1i rpcnne0d syl3anc 3eqtr2d oveq1d a1i wss rpexpcld rprege0d flge0nn0
        mpbid cn0 nn0p1nn 3syl syl6eleq fzss1 sselda syldan oveq1 oveq2 sumeq1d
        wi fveq2d breq12d imbi2d vm vj cdc cabs cioo pntlemc pntlemd 2z rpexpcl
        3nn0 2nn decnncl nnrp rpmulcl ceu csqr pntlemb rplogcld 8re 8pos elrpii
        ax-mp rpdivcl pntlemg uztrn2 syl2anc elfznn syl2an nnrpd pntrf ffvelrni
        nndivre abscld relogcld 4re 4pos divmuldiv syl22anc ce relogefd divdiv2
        fveq2i syl5eq mulcld divass sqvald mul32d 8t4e32 oveq12d divdiv1 mulcom
        eqtrd mul4d sqcld nncni div23 3eqtrd 4nn mulassd eqtr4d 3eqtr4d lemul2d
        eqbrtrrd breqtrrd eluzfz2 nncnd subidd mul01d elfzle2 wb simpld elfzelz
        nnzd flge mpbird jca pntlemn fsumge0 eqbrtrd cfzo eqid pntlemi elfzoelz
        zred cun ssun1 peano2zd 1re ltle uzid peano2uz leexp2ad lediv2d flword2
        mpd eluzp1p1 flcld simprd elfzofz pntlemh lttrd ltled flwordi syl3anbrc
        sylan2 eluz2 fzsplit2 syl5sseqr sstrd adantlr ssun2 le2add mpand ax-1cn
        zcnd subcld adddid addcomd addsubd mulid1d 3eqtr3d cin c0 reflcl fzdisj
        ltp1d fsumsplit sylibrd expcom a2d fzind2 mpcom fsumless letrd ) AJLVBV
        CZOLVDVEVCZVFVCZVGVDUUCZFVFVCZVHVCZUAVIVJZVDVEVCZVFVCZVFVCZVVOOLVFVCZVK
        VHVCZVWAVFVCZVFVCZQPVBVCZVFVCZVSUATVHVCZVLVJZVMVCZJKVTZVHVCZUAVWNVHVCZI
        VJZUAVHVCZUUDVJZVBVCZVWNVIVJZVFVCZKVNZAVWDAVVOVWCALVOVSUUEVCVPZVSNVQVRZ
        VVOWAVPZALWAVPZNWAVPZVXDVXEVXFWBZAEFHIJLMNOUBUCUDUEUFUGUHUIUJUKULUUFZWC
        ZWCZAVVTVWBAVVQVVSAOVVPAOWAVPHWAVPMWAVPAEFHIMOUBUCUDUEUFUGUHUUGWDZAVXGV
        DWEVPZVVPWAVPAVXGVXHVXIVXJWDZUUHLVDUUIWFWGZAVVRWAVPZFWAVPVVSWAVPVVRWHVP
        VXQVGVDUUJUUKUULZVVRUUMUVBZUEVVRFUUNWIZWJZAVWAWAVPVXNVWBWAVPAUAAUAAUAWA
        VPZVSUAVQVRZUUOUAUUPVJZWKVRZVYDVWKWKVRZWBZXCVWEVHVCVYDWKVRSVIVJNVIVJZVH
        VCVDWLVCVWAVYHVHVCZXCVHVCZWKVRJVGVFVCGWLVCVVOVVTVFVCVWAVFVCWKVRWBZAEFGH
        IJLMNORSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQUUQZWDZWMZAVYCVYEVYFAVYBVYGV
        YKVYLWNWDUURZUUHVWAVDUUIWFWGZWGWMAVWHVWIAVWHAVVOVWGVXLAVWFVWAAVWEWAVPVK
        WAVPZVWFWAVPAOLVXMVXOWGZVKUUSUUTUVAZVWEVKUVCWFZVYOWGZWGZWMAQPAQAPWHVPZQ
        PWOVJVPZQWHVPAWUCWUDVYJVWIWKVRZAEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
        UMUNUOUPUQURUSUVDZWDZAWUCWUDWUEWUFWNZVSQPWHWPUVEUVFZWQAPWUGWQWRZWSZAVWM
        VXBKAVSVWLWTZAVWNVWMVPZXDZVWTVXAWUNVWOVWSAJXEVPVWNWHVPZVWOXEVPWUMAJUIWM
        VWNVWLUVGZJVWNUVLUVHWUNVWRWUNVWRWUNVWQUAWUNVWPWAVPVWQXEVPWUNUAVWNAVYBWU
        MVYMXAZWUNVWNWUMWUOAWUPXBZUVIZWJWAXEVWPIIUBUCUVJUVKXFWUQXGXHUVMWRWUNVWN
        WUSUVNWSZXIZAVWDVVOVWGVWIVFVCZVFVCZVWJWKAVWCWVBWKVRVWDWVCWKVRAVWGVYJVFV
        CZVWCWVBWKAVWFVYJVFVCZVWAVFVCVVTVWAVFVCZVWAVFVCZWVDVWCAWVEWVFVWAVFAWVEV
        WEVYIVFVCZVKXCVFVCZVHVCZVVQVWAVFVCZFVHVCZVVRVHVCZWVFAVWEXJVPZVYIXJVPVKX
        JVPVKVOXKXDZXCXJVPXCVOXKXDZWVEWVJXLAVWEVYRXMZAVYIAVWAVYHVYOANANAVXGVXHV
        XIVXJWNZWMZAVXDVXEVXFVXKWNZUURWJZXMVYQWVOAVYSVKXNXPXCWAVPWVPAXCUVOUVPUV
        AXCXNXPVWEVYIVKXCUVQUVRAWVHWVLWVIVVRVHAWVHVWEVWALVFVCZFVHVCZVFVCZVWEWWB
        VFVCZFVHVCZWVLAVYIWWCVWEVFAVYIVWAFLVHVCZVHVCZWWCAVYHWWGVWAVHAVYHWWGUVSV
        JZVIVJWWGNWWIVIULUWBAWWGAWWGAFLUEVXOWJWMUVTUWCXOAVWAXJVPZFXJVPZFVOXKXDZ
        LXJVPLVOXKXDWWHWWCXLAVWAVYOXMZAFUEXQZALVXOXQVWAFLUWAXRUWLXOAWVNWWBXJVPW
        WLWWFWWDXLWVQAVWALWWMALVXOXMZUWDWWNVWEWWBFUWEXRAWWEWVKFVHAWWEOVWAVFVCZL
        LVFVCZVFVCWWPVVPVFVCWVKAOLVWALAOVXMXMZWWOWWMWWOUWMAVVPWWQWWPVFALWWOUWFX
        OAOVWAVVPWWRWWMALWWOUWNUWGXSXTXSWVIVVRXLAUWHYAUWIAWVMWVKFVVRVFVCZVHVCZW
        VKVVSVHVCZWVFAWVKXJVPWWLVVRXJVPZVVRVOXKXDZWVMWWTXLAVVQVWAAVVQVXPXMZWWMU
        WDWWNVXQWXCAVXSVVRXNXPWVKFVVRUWJXRAVVSWWSWVKVHAWXBWWKVVSWWSXLVVRVXRUWOA
        FUEXMVVRFUWKWIXOAVVQXJVPWWJVVSXJVPVVSVOXKXDWXAWVFXLWXDWWMAVVSVXTXQVVQVW
        AVVSUWPXRXSUWQXTAVWFVWAVYJAVWFVYTXMWWMAVYJAVYIXEVPXCWHVPVYJXEVPAVYIWWAW
        MUWRVYIXCUVLWFZXHUWGAVWCVVTVWAVWAVFVCZVFVCWVGAVWBWXFVVTVFAVWAWWMUWFXOAV
        VTVWAVWAAVVTVYAXMWWMWWMUWSUWTUXAAWUEWVDWVBWKVRAWUCWUDWUEWUFWCAVYJVWIVWG
        WXEWUJWUAUXBYFUXCAVWCWVBVVOAVWCVYPWMAVWGVWIAVWGWUAWMWUJWSVXLUXBYFAVVOVW
        GVWIAVVOVXLXMAVWGWUAXMAVWIWUJXHUWSUXDAVWJUANQVEVCZVHVCZVLVJZVSWLVCZVWLV
        MVCZVXBKVNZVXCWUKAWXKVXBKAWXJVWLWTAVWNWXKVPWUMVXBXEVPZAWXKVWMVWNAWXJVSW
        OVJZVPWXKVWMYBAWXJWHWXNAWXHXEVPVOWXHWKVRXDWXIYGVPWXJWHVPAWXHAUAWXGVYMAN
        QWVRAQWUIUXMYCWJYDWXHYEWXIYHYIWPYJWXJVSVWLYKXFZYLWUTYMXIWVAQPQVMVCZVPZA
        VWJWXLWKVRZAWUDWXQWUHPQUXEXFAVWHUUAVTZPVBVCZVFVCZUANWXSVEVCZVHVCZVLVJZV
        SWLVCZVWLVMVCZVXBKVNZWKVRZYQAVWHPPVBVCZVFVCZUANPVEVCZVHVCZVLVJZVSWLVCZV
        WLVMVCZVXBKVNZWKVRZYQZAVWHUUBVTZPVBVCZVFVCZUANWYSVEVCZVHVCZVLVJZVSWLVCZ
        VWLVMVCZVXBKVNZWKVRZYQAVWHWYSVSWLVCZPVBVCZVFVCZUANXUIVEVCZVHVCZVLVJZVSW
        LVCZVWLVMVCZVXBKVNZWKVRZYQAWXRYQUUAUUBQPQWXSPXLZWYHWYQAXUSWYAWYJWYGWYPW
        KXUSWXTWYIVWHVFWXSPPVBYNXOXUSWYFWYOVXBKXUSWYEWYNVWLVMXUSWYDWYMVSWLXUSWY
        CWYLVLXUSWYBWYKUAVHWXSPNVEYOXOYRXTXTYPYSYTWXSWYSXLZWYHXUHAXUTWYAXUAWYGX
        UGWKXUTWXTWYTVWHVFWXSWYSPVBYNXOXUTWYFXUFVXBKXUTWYEXUEVWLVMXUTWYDXUDVSWL
        XUTWYCXUCVLXUTWYBXUBUAVHWXSWYSNVEYOXOYRXTXTYPYSYTWXSXUIXLZWYHXURAXVAWYA
        XUKWYGXUQWKXVAWXTXUJVWHVFWXSXUIPVBYNXOXVAWYFXUPVXBKXVAWYEXUOVWLVMXVAWYD
        XUNVSWLXVAWYCXUMVLXVAWYBXULUAVHWXSXUINVEYOXOYRXTXTYPYSYTWXSQXLZWYHWXRAX
        VBWYAVWJWYGWXLWKXVBWXTVWIVWHVFWXSQPVBYNXOXVBWYFWXKVXBKXVBWYEWXJVWLVMXVB
        WYDWXIVSWLXVBWYCWXHVLXVBWYBWXGUAVHWXSQNVEYOXOYRXTXTYPYSYTWYRWUDAWYJVOWY
        PWKAWYJVWHVOVFVCVOAWYIVOVWHVFAPAPWUGUXFZUXGXOAVWHAVWHWUBXMZUXHUWLAWYOVX
        BKAWYNVWLWTAVWNWYOVPZWUMWXMAWYOVWMVWNAWYNWXNVPWYOVWMYBAWYNWHWXNAWYLXEVP
        VOWYLWKVRXDWYMYGVPWYNWHVPAWYLAUAWYKVYMANPWVRAPWUGUXMYCWJYDWYLYEWYMYHYIW
        PYJWYNVSVWLYKXFYLZWUTYMAXVEWUMVOVXBWKVRZXVFAWUMWUOVWNVWKWKVRZXDXVGWUNWU
        OXVHWURWUNXVHVWNVWLWKVRZWUMXVIAVWNVSVWLUXIXBAVWKXEVPZVWNWEVPXVHXVIUXJWU
        MAVWKAUATVYMATWAVPZVSTWKVRUMUXKZWJZWMVWNVSVWLUXLVWKVWNUXNUVHUXOUXPACEFG
        HIJLMVWNNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTUXQYMZYMUXRUXSYA
        WYSPQUXTVCVPZAXUHXURAXVOXUHXURYQAXVOXDZXUHVWHXUAWLVCZXUOXUDVMVCZVXBKVNZ
        XUGWLVCZWKVRZXURXVPVWHXVSWKVRZXUHXWAABCDEFGHIJKLMWYSNOPQXVRRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAXVRUYAUYBXVPVWHXEVPXUAXEVPXVSXEVPXUGXE
        VPXWBXUHXDXWAYQXVPVWHAVWHWAVPXVOWUBXAWMZXVPVWHWYTXWCXVPWYSPXVPWYSXVOWYS
        WEVPZAWYSPQUYCXBZUYDXVPPAWUCXVOWUGXAWQWRWSXVPXVRVXBKXVPXUOXUDWTXVPVWNXV
        RVPWUMWXMXVPXVRVWMVWNXVPXVRXUPVWMXVPXVRXUFUYEZXVRXUPXVRXUFUYFXVPXUEXUOW
        OVJVPZVWLXUDWOVJVPZXUPXWFXLXVPXUDXUNWOVJVPZXWGXVPXUMXEVPZXUCXEVPZXUMXUC
        WKVRZXWIXVPUAXULAUAXEVPXVOVYNXAZXVPNXUIAVXHXVOWVRXAZXVPWYSXWEUYGYCZXGXV
        PUAXUBXWMXVPNWYSXWNXWEYCZXGZXVPXUBXULWKVRXWLXVPNWYSXUIANXEVPZXVOWVSXAAV
        SNWKVRZXVOAVXEXWSWVTAVSXEVPXWRVXEXWSYQUYHWVSVSNUYIWIUYOXAXVPXWDWYSWYSWO
        VJZVPXUIXWTVPXWEWYSUYJWYSWYSUYKYIUYLXVPXUBXULUAXWPXWOAVYBXVOVYMXAZUYMYF
        XUMXUCUYNXRXUNXUDUYPXFXVPXUDWEVPVWLWEVPXUDVWLWKVRZXWHXVPXUCXWQUYQXVPVWK
        XVPVWKAVWKWAVPXVOXVMXAWMZUYQXVPXWKXVJXUCVWKWKVRZXXBXWQXXCXVPTXUBWKVRXXD
        XVPTXUBXVPTAXVKXVOXVLXAZWMZXVPXUBXWPWMZXVPTSXUBXXFASXEVPXVOASASWAVPZTSV
        QVRZUNUXKWMXAXXGAXXIXVOAXXHXXIUNUYRXAXVPSXUBVQVRZXUBVYDWKVRZXVOAWYSWXPV
        PXXJXXKXDWYSPQUYSAEFGHIJLMWYSNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQU
        RUSUYTVUEUXKVUAVUBXVPTXUBUAXXEXWPXXAUYMYFXUCVWKVUCXRXUDVWLVUFVUDXUDXUOV
        WLVUGUVFZVUHXVPXUOWXNVPXUPVWMYBXVPXUOWHWXNXVPXWJVOXUMWKVRXDXUNYGVPXUOWH
        VPXVPXUMXVPUAXULXXAXWOWJYDXUMYEXUNYHYIWPYJXUOVSVWLYKXFZVUIYLAWUMWXMXVOW
        UTVUJZYMXIXVPXUFVXBKXVPXUEVWLWTXVPVWNXUFVPWUMWXMXVPXUFVWMVWNXVPXUFXUPVW
        MXVPXWFXUFXUPXUFXVRVUKXXLVUHXXMVUIYLXXNYMXIVWHXUAXVSXUGVULUVRVUMXVPXUKX
        VQXUQXVTWKXVPVWHVSWYTWLVCZVFVCVWHVSVFVCZXUAWLVCXUKXVQXVPVWHVSWYTAVWHXJV
        PXVOXVDXAZVSXJVPXVPVUNYAZXVPWYSPXVPWYSXWEVUOZAPXJVPXVOXVCXAZVUPZVUQXVPX
        XOXUJVWHVFXVPXXOWYTVSWLVCXUJXVPVSWYTXXRXYAVURXVPWYSVSPXXSXXRXXTVUSUWTXO
        XVPXXPVWHXUAWLXVPVWHXXQVUTXTVVAXVPXVRXUFVXBXUPKXVPXUDXUEVQVRXVRXUFVVBVV
        CXLXVPXUDXVPXWKXUDXEVPXWQXUCVVDXFVVFXUOXUDXUEVWLVVEXFXXLXVPXUOVWLWTXVPV
        WNXUPVPZXDVXBXVPXYBWUMWXMXVPXUPVWMVWNXXMYLXXNYMXHVVGYSVVHVVIVVJVVKVVLAV
        WMVXBWXKKWULWUTXVNWXOVVMVVNVVN $.

      $( Lemma for ~ pnt .  Evaluate the naive part of the estimate.
         (Contributed by Mario Carneiro, 14-Apr-2016.) $)
      pntlemk $p |- ( ph -> ( 2 x. sum_ n e. ( 1 ... ( |_ ` ( Z / Y ) ) )
          ( ( U / n ) x. ( log ` n ) ) ) <_
      ( ( U x. ( ( log ` Z ) + 3 ) ) x. ( log ` Z ) ) ) $=
        ( c2 c1 cdiv co cfl cfv cfz cv clog csu cmul c3 caddc cle wbr cexp wcel
        cr fzfid wa cn elfznn adantl relogcld nndivred fsumrecl remulcl sylancr
        2re nnrpd crp clt ceu csqr w3a cmin cdc pntlemb simp1d peano2re resqcld
        c4 syl 3re readdcl sylancl remulcld rpred simpld rerpdivcld 1re a1i ere
        rpsqrcld egt2lt3 simpli lttri mp2an ltleii simp2d letrd simp3d readdcld
        1lt2 flge1nn cc0 wb 1rp mpbid recnd breqtrd logleb syl5eqbrr cc adddird
        wceq 2cn oveq2d 3brtr4d syl2anc logdivbnd 2pos lemuldiv2 syl112anc flle
        mpbird reflcl simprd div1d logled leadd1dd 0re log1 nnge1d lep1d le2sqd
        lediv2d rpge0d lemulge12d rprege0d remsqsqr epr leadd2dd binom21 sqvald
        loge df-3 oveq1i ax-1cn syl5eq mulid2d eqtr2d oveq12d sqcld addassd 3cn
        mulcl 3eqtr4rd lemul2d wne adantr rpcnne0d div23 divass eqtr3d sumeq2dv
        syl3anc fsummulc2 eqtr4d mul12d eqtrd mulassd ) AJVBVCUATVDVEZVFVGZVHVE
        ZKVIZVJVGZUWQVDVEZKVKZVLVEZVLVEZJUAVJVGZVMVNVEZUXCVLVEZVLVEZVBUWPJUWQVD
        VEUWRVLVEZKVKZVLVEZJUXDVLVEUXCVLVEVOAUXAUXEVOVPUXBUXFVOVPAUXAUXCVCVNVEZ
        VBVQVEZUXEAVBVSVRZUWTVSVRZUXAVSVRWJAUWPUWSKAVCUWOVTZAUWQUWPVRZWAZUWRUWQ
        UXPUWQUXPUWQUXOUWQWBVRAUWQUWOWCWDZWKZWEZUXQWFZWGZVBUWTWHWIZAUXJAUXCVSVR
        ZUXJVSVRAUAAUAWLVRZVCUAWMVPZWNUAWOVGZVOVPZUYFUWNVOVPZWPZXCOLVLVEVDVEUYF
        VOVPSVJVGNVJVGZVDVEVBVNVEUXCUYJVDVEXCVDVEVOVPJVMVLVEGVNVEJLWQVEOLVBVQVE
        VLVEVMVBWRFVLVEVDVEVLVEUXCVLVEVOVPWPZAEFGHIJLMNORSTUAUBUCUDUEUFUGUHUIUJ
        UKULUMUNUOUPUQWSZWTZWEZUXCXAXDZXBZAUXDUXCAUYCVMVSVRUXDVSVRUYNXEUXCVMXFX
        GZUYNXHZAUXAUWOVJVGZVCVNVEZVBVQVEZUXKUYBAUYTAUYSVCAUWOAUWOAUWNVSVRZVCUW
        NVOVPUWOWBVRZAUATAUAUYMXIZATWLVRZVCTVOVPZUMXJZXKZAVCUYFUWNVCVSVRAXLXMZA
        UYFAUAUYMXOZXIZVUHAVCWNUYFVUIWNVSVRAXNXMZVUKVCWNVOVPAVCWNXLXNVCVBWMVPVB
        WNWMVPZVCWNWMVPYEVUMWNVMWMVPXPXQVCVBWNXLWJXNXRXSXTXMAUYEUYGUYHAUYDUYIUY
        KUYLYAZYAZYBZAUYEUYGUYHVUNYCYBUWNYFUUAZWKZWEZVUIYDZXBZUYPAUXAVUAVOVPZUW
        TVUAVBVDVEVOVPZAVUCVVCVUQKUWOUUBXDAUXMVUAVSVRUXLYGVBWMVPZVVBVVCYHUYAVVA
        UXLAWJXMZVVDAUUCXMUWTVUAVBUUDUUEUUGAUYTUXJVOVPVUAUXKVOVPAUYSUXCVCVUSUYN
        VUIAUWOUAVOVPUYSUXCVOVPAUWOUWNUAAVUBUWOVSVRVUHUWNUUHXDVUHVUDAVUBUWOUWNV
        OVPVUHUWNUUFXDAUWNUAVCVDVEZUAVOAVUFUWNVVFVOVPAVUEVUFUMUUIAVCTUAVCWLVRZA
        YIXMVUGUYMUURYJAUAAUAVUDYKUUJYLYBAUWOUAVURUYMUUKYJUULZAUYTUXJVUTUYOAYGU
        YSUYTYGVSVRAUUMXMZVUSVUTAYGVCVJVGZUYSVOUUNAVCUWOVOVPZVVJUYSVOVPZAUWOVUQ
        UUOAVVGUWOWLVRVVKVVLYHYIVURVCUWOYMWIYJYNAUYSVUSUUPYBZAYGUYTUXJVVIVUTUYO
        VVMVVHYBUUQYJYBAUXCVBVQVEZVBUXCVLVEZVNVEZVCVNVEZVVPUXCVNVEZUXKUXEVOAVCU
        XCVVPVUIUYNAVVNVVOAUXCUYNXBAVBUXCVVEUYNXHYDAVCWNVJVGZUXCVOUVGAWNUAVOVPZ
        VVSUXCVOVPZAWNUYFUAVULVUKVUDVUOAUYFUYFUYFVLVEZUAVOAUYFUYFVUKVUKAUYFVUJU
        USVUPUUTAUAVSVRYGUAVOVPWAVWBUAYQAUAUYMUVAUAUVBXDYLYBAWNWLVRUYDVVTVWAYHU
        VCUYMWNUAYMWIYJYNUVDAUXCYOVRZUXKVVQYQAUXCUYNYKZUXCUVEXDAVVNVVOUXCVNVEZV
        NVEUXCUXCVLVEZVMUXCVLVEZVNVEVVRUXEAVVNVWFVWEVWGVNAUXCVWDUVFAVWGVVOVCUXC
        VLVEZVNVEZVWEAVWGVBVCVNVEZUXCVLVEVWIVMVWJUXCVLUVHUVIAVBVCUXCVBYOVRZAYRX
        MZVCYOVRAUVJXMVWDYPUVKAVWHUXCVVOVNAUXCVWDUVLYSUVMUVNAVVNVVOUXCAUXCVWDUV
        OAVWKVWCVVOYOVRYRVWDVBUXCUVRWIVWDUVPAUXCVMUXCVWDVMYOVRAUVQXMVWDYPUVSYTY
        BAUXAUXEJUYBUYRUIUVTYJAUXIVBJUWTVLVEZVLVEUXBAUXHVWMVBVLAUXHUWPJUWSVLVEZ
        KVKVWMAUWPUXGVWNKUXPJYOVRZUWRYOVRZUWQYOVRUWQYGUWAWAZUXGVWNYQUXPJAJVSVRU
        XOAJUIXIZUWBYKUXPUWRUXSYKUXPUWQUXRUWCVWOVWPVWQWPJUWRVLVEUWQVDVEUXGVWNJU
        WRUWQUWDJUWRUWQUWEUWFUWHUWGAUWPUWSJKUXNAJVWRYKZUXPUWSUXTYKUWIUWJYSAVBJU
        WTVWLVWSAUWTUYAYKUWKUWLAJUXDUXCVWSAUXDUYQYKVWDUWMYT $.

      pntlem1.C $e |- ( ph -> A. z e. ( 1 (,) +oo )
      ( ( ( ( abs ` ( R ` z ) ) x. ( log ` z ) ) -
        ( ( 2 / ( log ` z ) ) x. sum_ i e. ( 1 ... ( |_ ` ( z / Y ) ) )
             ( ( abs ` ( R ` ( z / i ) ) ) x. ( log ` i ) ) ) ) / z ) <_ C ) $.
      $( Lemma for ~ pnt .  Combine all the estimates to establish a smaller
         eventual bound on ` R ( Z ) / Z ` .  (Contributed by Mario Carneiro,
         14-Apr-2016.) $)
      pntlemo $p |- ( ph ->
        ( abs ` ( ( R ` Z ) / Z ) ) <_ ( U - ( F x. ( U ^ 3 ) ) ) ) $=
        ( vn cfv cdiv co cabs c3 cexp cmul cmin cle wbr clog caddc c2 crp cr c1
        wcel clt w3a c4 simp1d ffvelrni syl rerpdivcld abscld relogcld remulcld
        recnd rpred 3re a1i readdcld 2re cc0 cioo simp3d cz 2z rpexpcl rpmulcld
        sylancl cn 3nn0 sylancr rpdivcld resubcld rpcnd subdird cc wne rpcnne0d
        wa wceq div23 syl3anc oveq1i rpne0d syl5eq oveq2d eqtrd mulassd oveq12d
        eqtr3d oveq1d eqtr4d cfl cfz cv csu adantr fsumrecl mulcld fveq2 fveq2d
        remulcl letrd mpbird cdc ceu csqr pntlemb pntrf pntlemc pntlemd decnncl
        2nn nnrp ax-mp rpmulcl simp2d sqdivd divass 3eqtrd df-3 oveq2i cn0 2nn0
        sqcld expp1 mulcomd ax-1cn mulid2d syl5req eqtr2d subcld mul32d 3eqtr2d
        rpreccld divrec2d eqeltrrd fzfid elfznn adantl nnrpd divsubdird absdivd
        rplogcld div23d rprege0d divassd sumeq2dv fsumdivc cpnf wral cxr wb 1re
        absid rexr elioopnf mp2b sylanbrc oveq2 cbvsumv oveq1 sumeq12rdv breq1d
        simpl rspcv sylc eqbrtrrd lesubadd2d mpbid 2cn resqcld nndivred pntlemf
        id fsumcl 2pos lemul2 syl112anc fsumsub subdid pntlemk lesub1dd eqbrtrd
        lesubd sqvald breqtrrd leadd1dd leadd2dd adddid addassd 2timesd 3brtr4d
        ledivmul2d nppcan3d lesubaddd addsubd 3brtr3d nn0zi lemul1d ) AUAIVDZUA
        VEVFZVGVDZJMJVHVIVFZVJVFZVKVFZVLVMUYSUAVNVDZVJVFZVUBVUCVJVFZVLVMAVUDJVU
        CVHVOVFZVJVFZVPJLVKVFZOLVPVIVFZVJVFZVHVPUUAZFVJVFZVEVFZVJVFZVUCVJVFZVJV
        FZVKVFZGVOVFZVUEAUYSVUCAUYRAUYRAUYQUAAUAVQVTZUYQVRVTAVUSVSUAWAVMZUUBUAU
        UCVDZVLVMZVVAUATVEVFZVLVMZWBZWCOLVJVFVEVFVVAVLVMZSVNVDNVNVDZVEVFVPVOVFV
        UCVVGVEVFWCVEVFVLVMZJVHVJVFZGVOVFZVUOVLVMZWBZAEFGHIJLMNORSTUAUBUCUDUEUF
        UGUHUIUJUKULUMUNUOUPUQUUDZWDZVQVRUAIIUBUCUUEZWEWFZVVNWGWKWHZAUAVVNWIZWJ
        ZAVUQGAVUGVUPAJVUFAJUIWLZAVUCVHVVRVHVRVTZAWMWNZWOWJZAVPVUOVPVRVTZAWPWNZ
        AVUNVUCAVUHVUMAVUHALWQVSWRVFVTZVSNWAVMZVUHVQVTZALVQVTZNVQVTZVWFVWGVWHWB
        ZAEFHIJLMNOUBUCUDUEUFUGUHUIUJUKULUUFZWSWSZWLZAVUMAVUJVULAOVUIAOVQVTZHVQ
        VTZMVQVTZAEFHIMOUBUCUDUEUFUGUHUUGZWDZAVWIVPWTVTZVUIVQVTAVWIVWJVWKVWLWDX
        ALVPXBXDZXCAVUKVQVTZFVQVTVULVQVTVUKXEVTVXBVHVPXFUUIUUHVUKUUJUUKUEVUKFUU
        LXGZXHZWLZWJZVVRWJZWJZXIZAGUOWLZWOZAJVUCVJVFZVUOVKVFZVUEVRAJVUNVKVFZVUC
        VJVFVXMVUEAJVUNVUCAJUIXJZAVUNVXFWKZAVUCVVRWKZXKAVXNVUBVUCVJAVUNVUAJVKAV
        UNVUHOVULVEVFZHVPVIVFZVEVFZJVPVIVFZVJVFZVJVFZVUAAVUMVYBVUHVJAVUMVXRVUIV
        JVFZVXRVYAVXSVEVFZVJVFZVYBAOXLVTVUIXLVTVULXLVTVULWQXMXOVUMVYDXPAOVWSXJA
        VUIVXAXJAVULVXCXNOVUIVULXQXRAVUIVYEVXRVJAVUIJHVEVFZVPVIVFVYELVYGVPVIUKX
        SAJHVXOAHAVWOVWPVWQVWRUUMZXJZAHVYHXTZUUNYAYBAVXRXLVTZVYAXLVTZVXSXLVTVXS
        WQXMXOZVYFVYBXPAVXRAOVULVWSVXCXHZXJAJVXOUVAZAVXSAVWPVWTVXSVQVTVYHXAHVPX
        BXDZXNVYKVYLVYMWBVXRVYAVJVFVXSVEVFVYFVYBVXRVYAVXSUUOVXRVYAVXSXQYFXRUUPY
        BAVUAMJVYAVJVFZVJVFMJVJVFZVYAVJVFZVYCAUYTVYQMVJAUYTVYAJVJVFZVYQAUYTJVPV
        SVOVFZVIVFZVYTVHWUAJVIUUQUURAJXLVTVPUUSVTWUBVYTXPVXOUUTJVPUVBXDYAAVYAJV
        YOVXOUVCYCYBAMJVYAAMAVWOVWPVWQVWRWSZXJVXOVYOYDAVUHVXTVJVFZVYAVJVFVYSVYC
        AWUDVYRVYAVJAWUDVSVSHVEVFZVKVFZJVJVFZVXTVJVFZVYRAVUHWUGVXTVJAWUGVSJVJVF
        ZWUEJVJVFZVKVFVUHAVSWUEJVSXLVTAUVDWNZAWUEAHVYHUVKXJZVXOXKAWUIJWUJLVKAJV
        XOUVEALVYGWUJUKAJHVXOVYIVYJUVLUVFYEUVGYGAVYRWUFVXTVJVFZJVJVFWUHMWUMJVJU
        HXSAWUFVXTJAVSWUEWUKWULUVHAVXTAVXRVXSVYNVYPXHXJZVXOUVIYAYHYGAVUHVXTVYAA
        VUHVWMXJZWUNVYOYDYFUVJYHYBYGYFZAVXLVUOAJVUCVVTVVRWJZVXGXIZUVMAVUDVPVUCV
        EVFZVSVVCYIVDZYJVFZUAVCYKZVEVFZIVDZUAVEVFZVGVDZWVBVNVDZVJVFZVCYLZVJVFZG
        VOVFZVURVVSAWVJGAWUSWVIAVPVUCVWEAUAAUAVVNWLZAVUTVVBVVDAVUSVVEVVLVVMUUMW
        DZUVTZWGZAWVAWVHVCAVSWUTUVNZAWVBWVAVTZXOZWVFWVGWVRWVEWVRWVEWVRWVDUAWVRW
        VCVQVTWVDVRVTWVRUAWVBAVUSWVQVVNYMZWVRWVBWVQWVBXEVTAWVBWUTUVOUVPZUVQZXHV
        QVRWVCIVVOWEWFZWVSWGWKWHZWVRWVBWWAWIZWJYNZWJZVXJWOVXKAVUDWVJVKVFZGVLVMV
        UDWVKVLVMAUYQVGVDZVUCVJVFZWUSWVAWVDVGVDZWVGVJVFZVCYLZVJVFZVKVFZUAVEVFZW
        WGGVLAWWOWWIUAVEVFZWWMUAVEVFZVKVFWWGAWWIWWMUAAWWHVUCAWWHAUYQAUYQVVPWKZW
        HWKZVXQYOAWUSWWLAWUSWVOWKZAWWLAWVAWWKVCWVPWVRWWJWVGWVRWVDWVRWVDWWBWKZWH
        ZWWDWJZYNWKZYOAUAVVNXJZAUAVVNXTZUVRAWWPVUDWWQWVJVKAWWPWWHUAVEVFZVUCVJVF
        VUDAWWHVUCUAWWSVXQWXEWXFUWAAUYSWXGVUCVJAUYSWWHUAVGVDZVEVFWXGAUYQUAWWRWX
        EWXFUVSAWXHUAWWHVEAUAVRVTZWQUAVLVMXOWXHUAXPZAUAVVNUWBUAUWKWFZYBYCYGYHAW
        WQWUSWWLUAVEVFZVJVFWVJAWUSWWLUAWWTWXDWXEWXFUWCAWVIWXLWUSVJAWVIWVAWWKUAV
        EVFZVCYLWXLAWVAWVHWXMVCWVRWVHWWJUAVEVFZWVGVJVFZWXMWVRWVFWXNWVGVJWVRWVFW
        WJWXHVEVFWXNWVRWVDUAWXAAUAXLVTZWVQWXEYMAUAWQXMZWVQWXFYMUVSWVRWXHUAWWJVE
        AWXJWVQWXKYMYBYCYGWVRWWJXLVTWVGXLVTWXPWXQXOZWXMWXOXPWVRWWJWXBWKWVRWVGWW
        DWKZAWXRWVQAUAVVNXNYMWWJWVGUAXQXRYHUWDAWVAWWKUAVCWVPWXEWVRWWKWXCWKWXFUW
        EYHYBYHYEYCAUAVSUWFWRVFZVTZCYKZIVDZVGVDZWYBVNVDZVJVFZVPWYEVEVFZVSWYBTVE
        VFZYIVDZYJVFZWYBKYKZVEVFZIVDZVGVDZWYKVNVDZVJVFZKYLZVJVFZVKVFZWYBVEVFZGV
        LVMZCWXTUWGWWOGVLVMZAWXIVUTWYAWVLWVMVSVRVTVSUWHVTWYAWXIVUTXOUWIUWJVSUWL
        VSUAUWMUWNUWOVBXUAXUBCUAWXTWYBUAXPZWYTWWOGVLXUCWYSWWNWYBUAVEXUCWYFWWIWY
        RWWMVKXUCWYDWWHWYEVUCVJXUCWYCUYQVGWYBUAIYPYQWYBUAVNYPZYEXUCWYGWUSWYQWWL
        VJXUCWYEVUCVPVEXUDYBXUCWYQWYJWYBWVBVEVFZIVDZVGVDZWVGVJVFZVCYLWWLWYJWYPX
        UHKVCWYKWVBXPZWYNXUGWYOWVGVJXUIWYMXUFVGXUIWYLXUEIWYKWVBWYBVEUWPYQYQWYKW
        VBVNYPYEUWQXUCWYJWVAXUHWWKVCXUCWYIWUTVSYJXUCWYHVVCYIWYBUATVEUWRYQYBXUCW
        VQXOZXUGWWJWVGVJXUJXUFWVDVGXUJXUEWVCIXUJWYBUAWVBVEXUCWVQUXAYGYQYQYGUWSY
        AYEYEXUCUXKYEUWTUXBUXCUXDAVUDWVJGVVSWWFVXJUXEUXFAWVJVUQGWWFVXIVXJAVPWVI
        VJVFZVUCVEVFZWVJVUQVLAVPWVIVUCVPXLVTAUXGWNZAWVAWVHVCWVPWVRWVFWVGWVRWVFW
        WCWKZWXSYOZUXLZVXQAVUCWVNXTUWAAXULVUQVLVMXUKVUQVUCVJVFZVLVMAXUKVUGVUCVJ
        VFZVPVUHVUMVUCVPVIVFZVJVFZVJVFZVJVFZVKVFZXUQVLAXVBXURXUKAVWDXVAVRVTZXVB
        VRVTWPAVUHXUTVWNAVUMXUSVXEAVUCVVRUXHZWJWJZVPXVAYRXGZAVUGVUCVWCVVRWJZAVW
        DWVIVRVTXUKVRVTWPWWEVPWVIYRXGZAXVBVPWVAJWVBVEVFZWVFVKVFZWVGVJVFZVCYLZVJ
        VFZXURXUKVKVFZXVGAVPXVMVWEAWVAXVLVCWVPWVRXVKWVGWVRXVJWVFWVRJWVBAJVRVTZW
        VQVVTYMWVTUXIZWWCXIWWDWJYNZWJAXURXUKXVHXVIXIAXVAXVMVLVMZXVBXVNVLVMZABCD
        EFGHIJVCLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAUXJAXVDXVMVR
        VTVWDWQVPWAVMZXVSXVTUWIXVFXVRVWEXWAAUXMWNXVAXVMVPUXNUXOUXFAXVNVPWVAXVJW
        VGVJVFZVCYLZVJVFZXUKVKVFZXVOVLAXVNVPXWCWVIVKVFZVJVFXWEAXVMXWFVPVJAXVMWV
        AXWBWVHVKVFZVCYLXWFAWVAXVLXWGVCWVRXVJWVFWVGWVRXVJXVQWKXUNWXSXKUWDAWVAXW
        BWVHVCWVPWVRXWBWVRXVJWVGXVQWWDWJZWKXUOUXPYCYBAVPXWCWVIXUMAXWCAWVAXWBVCW
        VPXWHYNZWKXUPUXQYCAXWDXURXUKAVWDXWCVRVTXWDVRVTWPXWIVPXWCYRXGXVHXVIABCDE
        FGHIJVCLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAUXRUXSUXTYSUY
        AAXUQXURVUPVUCVJVFZVKVFXVCAVUGVUPVUCAVUGVWCWKZAVUPVXHWKZVXQXKAXWJXVBXUR
        VKAXWJVPVUOVUCVJVFZVJVFXVBAVPVUOVUCXUMAVUOVXGWKZVXQYDAXWMXVAVPVJAXWMVUN
        VUCVUCVJVFZVJVFVUNXUSVJVFXVAAVUNVUCVUCVXPVXQVXQYDAXUSXWOVUNVJAVUCVXQUYB
        YBAVUHVUMXUSWUOAVUMVXDXJAXUSXVEWKYDUVJYBYCYBYCUYCAXUKVUQVUCXVIVXIWVNUYJ
        YTUXDUYDYSAVUGGVOVFZVUPVKVFZVXMVURVUEVLAXWQVXMVLVMXWPVXMVUPVOVFZVLVMAVX
        LVVJVOVFZVXLVUOVOVFZXWPXWRVLAVVJVUOVXLAVVIGAXVPVWAVVIVRVTVVTWMJVHYRXDVX
        JWOVXGWUQAVVFVVHVVKAVUSVVEVVLVVMWSWSUYEAXWPVXLVVIVOVFZGVOVFXWSAVUGXXAGV
        OAJVUCVHVXOVXQAVHVWBWKZUYFYGAVXLVVIGAVXLWUQWKZAJVHVXOXXBYOAGUOXJZUYGYCA
        XWRVXMVUOVUOVOVFZVOVFXWTAVUPXXEVXMVOAVUOXWNUYHYBAVXLVUOVUOXXCXWNXWNUYKY
        CUYIAXWPVUPVXMAVUGGVWCVXJWOVXHWURUYLYTAVUGGVUPXWKXXDXWLUYMWUPUYNYSAUYSV
        UBVUCVVQAJVUAVVTAVUAAMUYTWUCAJVQVTVHWTVTUYTVQVTUIVHXFUYOJVHXBXDXCWLXIWV
        NUYPYT $.
    $}

    pntleme.U $e |- ( ph -> A. z e. ( Y [,) +oo )
      ( abs ` ( ( R ` z ) / z ) ) <_ U ) $.
    pntleme.K $e |- ( ph -> A. k e. ( K [,) +oo ) A. y e. ( X (,) +oo )
    E. z e. RR+ ( ( y < z /\ ( ( 1 + ( L x. E ) ) x. z ) < ( k x. y ) ) /\
        A. u e. ( z [,] ( ( 1 + ( L x. E ) ) x. z ) )
          ( abs ` ( ( R ` u ) / u ) ) <_ E ) ) $.
    pntleme.C $e |- ( ph -> A. z e. ( 1 (,) +oo )
  ( ( ( ( abs ` ( R ` z ) ) x. ( log ` z ) ) -
      ( ( 2 / ( log ` z ) ) x. sum_ i e. ( 1 ... ( |_ ` ( z / Y ) ) )
           ( ( abs ` ( R ` ( z / i ) ) ) x. ( log ` i ) ) ) ) / z ) <_ C ) $.
    $( Lemma for ~ pnt .  Package up ~ pntlemo in quantifiers.  (Contributed by
       Mario Carneiro, 14-Apr-2016.) $)
    pntleme $p |- ( ph -> E. w e. RR+ A. v e. ( w [,) +oo )
      ( abs ` ( ( R ` v ) / v ) ) <_ ( U - ( F x. ( U ^ 3 ) ) ) ) $=
      ( crp wcel cv cfv cdiv co cabs cexp cmul cmin cle wbr cpnf cico wral wrex
      c3 pntlema wa clog cfl c1 caddc c2 adantr cc0 cioo clt simpr eqid cxr w3a
      cicc pntlemc simp2d rpxrd pnfxr a1i cr rpred ltpnf syl syl3anc wceq oveq1
      lbico1 breq2d anbi2d anbi1d rexbidv ralbidv syl2anc cfz pntlemo ralrimiva
      rspcva csu raleqdv rspcev ) ASUTVAEVBZKVCXSVDVEVFVCLPLVPVGVEVHVEVIVEVJVKZ
      ESVLVMVEZVNZXTEDVBZVLVMVEZVNZDUTVOAGHIJKLOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
      UNUOUPVQAXTEYAAXSYAVAZVRBCFGHIJKLMOPQRTVSVCQVSVCZVDVEVTVCWAWBVEZXSVSVCYGV
      DVEWCVDVEVTVCZSTUAXSUBUCAGUTVAYFUDWDAHUTVAYFUEWDARWEWAWFVEZVAYFUFWDUGUHAL
      UTVAYFUIWDALGVJVKYFUJWDUKULAUAUTVAWAUAVJVKVRYFUMWDATUTVAUATWGVKVRYFUNWDAI
      UTVAYFUOWDUPAYFWHYHWIYIWIACVBZKVCZYKVDVEVFVCLVJVKCUAVLVMVEVNYFUQWDABVBZYK
      WGVKZWAROVHVEWBVEYKVHVEZQYMVHVEZWGVKZVRZFVBZKVCYSVDVEVFVCOVJVKFYKYOWLVEVN
      ZVRZCUTVOZBTVLWFVEZVNZYFAQQVLVMVEZVAZYNYONVBZYMVHVEZWGVKZVRZYTVRZCUTVOZBU
      UCVNZNUUEVNUUDAQWJVAVLWJVAZQVLWGVKZUUFAQAOUTVAQUTVAOYJVAWAQWGVKLOVIVEUTVA
      WKAGHJKLOPQRUBUCUDUEUFUGUHUIUJUKULWMWNZWOUUNAWPWQAQWRVAUUOAQUUPWSQWTXAQVL
      XEXBURUUMUUDNQUUEUUGQXCZUULUUBBUUCUUQUUKUUACUTUUQUUJYRYTUUQUUIYQYNUUQUUHY
      PYOWGUUGQYMVHXDXFXGXHXIXJXOXKWDAYLVFVCYKVSVCZVHVEWCUURVDVEWAYKUAVDVEVTVCX
      LVEYKMVBZVDVEKVCVFVCUUSVSVCVHVEMXPVHVEVIVEYKVDVEIVJVKCWAVLWFVEVNYFUSWDXMX
      NYEYBDSUTYCSXCXTEYDYAYCSVLVMXDXQXRXK $.
  $}

  ${
    $d r s t v w x y z A $.  $d a e k u v w x y z D $.  $d c r s t v w y z F $.
    $d p s u C $.  $d c e k t v w x y z K $.  $d c e k n r s t u v w x y z R $.
    $d a c e k t u v w x y z E $.  $d p s u w x T $.  $d a c k n t v w y z Y $.
    $d a r s $.  $d c e k t u v w x y z L $.  $d c p r s t v w x y ph $.
    $d e k v w x y z B $.  $d c t v w z U $.
    pntlem3.r $e |- R = ( a e. RR+ |-> ( ( psi ` a ) - a ) ) $.
    pntlem3.a $e |- ( ph -> A e. RR+ ) $.
    pntlem3.A $e |- ( ph -> A. x e. RR+ ( abs ` ( ( R ` x ) / x ) ) <_ A ) $.
    ${
      $d u z ph $.
      pntlem3.1 $e |- T = { t e. ( 0 [,] A ) | E. y e. RR+
        A. z e. ( y [,) +oo ) ( abs ` ( ( R ` z ) / z ) ) <_ t } $.
      pntlem3.2 $e |- ( ph -> C e. RR+ ) $.
      pntlem3.3 $e |- ( ( ph /\ u e. T ) ->
        ( u - ( C x. ( u ^ 3 ) ) ) e. T ) $.
      $( Lemma for ~ pnt .  Equation 10.6.35 in [Shapiro], p. 436.
         (Contributed by Mario Carneiro, 8-Apr-2016.) $)
      pntlem3 $p |- ( ph -> ( x e. RR+ |-> ( ( psi ` x ) / x ) ) ~~>r 1 ) $=
        ( co wbr wcel vs vp vw crp cv cchp cfv cdiv cmpt crli cle cmin cabs clt
        c1 wi wral cr wrex wss wa rpssre cpnf cico wn cicc ccnv csup cc c3 cexp
        cc0 cmul ccncf ccnfld ctopn eqid ctx ccn subcn adantr syl3anc 3nn0 mp1i
        a1i cncfmpt2f wne 0re rpred sylancr cxr wb 1re elicopnf ltletrd oveq12d
        weq fveq2 id fveq2d breq1d ralrimiva wceq oveq1 rspcev breq2 syl raleqi
        ralrab2 bitri sylibr recnd sylan caddc ad2antrr adantl ltnled ad3antrrr
        sylancl mpbid resubcld absdifltd mpand ad2antlr abscld rpre mpan2d syld
        infmrlb sylbird oveq2d ovex remulcld sylbid infmrgelb syl31anc ad2antll
        fvmpt mtod mpbird ssid cncfmptid mp2an mulcn rpcnd cncfmptc cn0 cncfcn1
        expcn syl6eleqr c0 crab ssrab2 eqsstri iccssre syl5ss 0xr rpge0d ubicc2
        rpxrd simprbda 0lt1 simplbda elrpd rspcv sylc raleqdv rexralbidv elrab2
        1rp sylanbrc ne0i w3a elicc2 biimpa simp2d a1d breq1 ralbidv infmrcl cz
        elrp biimpri nn0zi rpexpcl rpmulcld cncfi c2 rphalfcl ltaddrpd readdcld
        syl6ss ssralv sselda ltsubrpd simpr biimprd rphalflt lttr con1d reexpcl
        ax-resscn reexpcld npcand breq2d simpll lenltd pm2.21d adantld ralimdva
        jad sylibrd nrexdv pm2.65da syl6bb rpgt0 ltletr rexanali cbvralv simprl
        simplr pntrval oveq1d chpcl rpcn rpne0 divsubdird dividd 3eqtrrd simprr
        mpbir2and simplrl sseldd simp-4r rerpdivcl mpancom resubcl lelttr exp32
        embantd ralimdv2 syl5bi reximdva anassrs impancom expimpd rexlimdva mpd
        com24 ssrexv mpsyl rgen ax-1cn rlim2 ) ABUDBUEZUFUGZVUOUHRZUIUOUJSCUEZV
        UOUKSZVUQUOULRZUMUGZUAUEZUNSZUPZBUDUQZCURUSZUAUDUQAVVFUAUDUDURUTZAVVBUD
        TZVAZVVECUDUSZVVFVBVVIDUEZIUGZVVKUHRZUMUGZFUEZUKSZDVURVCVDRZUQZCUDUSZVV
        BVVOUKSZVEZVAZFVLGVFRZUSZVVJVVIVVSVVTUPFVWCUQZVEVWDVVIVWEVLJURUNVGVHZUN
        SZAVWGVEVVHAVWGEUEZVWFULRZUMUGZVVBUNSZVWHUBVIUBUEZHVWLVJVKRZVMRZULRZUIZ
        UGZVWFVWPUGZULRZUMUGZHVWFVJVKRZVMRZUNSZUPZEVIUQZUAUDUSZAVWGVAZVWPVIVIVN
        RZTVWFVITZVXBUDTVXFVXGUBVWLVWNULVOVPUGZVIVXJVQZULVXJVXJVRRVXJVSRZTVXGVX
        JVXKVTWEUBVIVWLUIVXHTZVXGVIVIUTZVXNVXMVIUUAZVXOUBVIVIUUBUUCWEVXGUBHVWMV
        MVXJVIVXKVMVXLTVXGVXJVXKUUDWEVXGHVITVXNVXNUBVIHUIVXHTVXGHAHUDTVWGPWAZUU
        EVXNVXGVXOWEZVXQUBHVIVIUUFWBVXGUBVIVWMUIZVXJVXJVSRZVXHVJUUGTZVXRVXSTVXG
        WCUBVXJVJVXKUUIWDVXJVXKUUHUUJWFWFAVXIVWGAVWFAJURUTZJUUKWGZVUOUCUEZUKSZU
        CJUQZBURUSZVWFURTZAJVWCURJVVSFVWCUULZVWCOVVSFVWCUUMUUNAVLURTZGURTZVWCUR
        UTZWHAGMWIZVLGUUOWJZUUPZAGJTZVYBAGVWCTZVVNGUKSZDVVQUQZCUDUSZVYOAVLWKTZG
        WKTVLGUKSVYPVYTAUUQWEAGMUUTAGMUURVLGUUSWBAUOUDTVYQDUOVCVDRZUQZVYSUVJAVY
        QDWUAAVVKWUATZVAZVVKUDTVUOIUGZVUOUHRZUMUGZGUKSZBUDUQZVYQWUDVVKAWUCVVKUR
        TZUOVVKUKSZUOURTZWUCWUJWUKVAWLAWMUOVVKWNWDZUVAZWUDVLUOVVKVYIWUDWHWEWULW
        UDWMWEWUNVLUOUNSWUDUVBWEAWUCWUJWUKWUMUVCWOUVDAWUIWUCNWAWUHVYQBVVKUDBDWQ
        ZWUGVVNGUKWUOWUFVVMUMWUOWUEVVLVUOVVKUHVUOVVKIWRWUOWSWPWTXAUVEUVFXBVYRWU
        BCUOUDVURUOXCVYQDVVQWUAVURUOVCVDXDUVGXEWJVVSVYSFGVWCJVVOGXCVVPVYQCDUDVV
        QVVOGVVNUKXFUVHOUVIUVKJGUVLXGZAVYIVLVYCUKSZUCJUQZVYFWHAVVSVLVVOUKSZUPZF
        VWCUQZWURAWUTFVWCAVVOVWCTZVAZWUSVVSWVCVVOURTZWUSVVOGUKSZAWVBWVDWUSWVEUV
        MZAVYIVYJWVBWVFWLWHVYLVLGVVOUVNWJUVOUVPUVQXBWURWUQUCVYHUQWVAWUQUCJVYHOX
        HVVSWUQWUSUCFVWCVYCVVOVLUKXFXIXJXKVYEWURBVLURVUOVLXCVYDWUQUCJVUOVLVYCUK
        UVRUVSXEWJZBUCJUVTWBZXLWAZVXGHVXAVXPVXGVWFUDTZVJUWATVXAUDTAVYGVWGWVJWVH
        WVJVYGVWGVAVWFUWBUWCXMVJWCUWDVWFVJUWEXSUWFUAEVIVIVWFVXBVWPUWGWBVXGVXEUA
        UDVXGVVHVAZVXEVWFVVBUWHUHRZXNRZVWFUKSZWVKVWFWVMUNSWVNVEWVKVWFWVLAVYGVWG
        VVHWVHXOZVVHWVLUDTVXGVVBUWIXPZUWJWVKVWFWVMWVOWVKVWFWVLWVOWVKWVLWVPWIZUW
        KZXQXTWVKVXEVXDEJUQZWVNWVKJVIUTZVXEWVSUPAWVTVWGVVHAJURVIVYNUXBUWLXOVXDE
        JVIUWMXGWVKWVSWVMVWHUKSZEJUQZWVNWVKVXDWWAEJWVKVWHJTZVAZVWKVXCWWAWWDWWAV
        WKWWDWWAVEVWHWVMUNSZVWKWWDVWHWVMWVKJURVWHAVYAVWGVVHVYNXOZUWNZWVKWVMURTZ
        WWCWVRWAXQWWDWWEVWJWVLUNSZVWKWWDVWFWVLULRZVWHUNSZWWEWWIWWDWWJVWFVWHWWDV
        WFWVLAVYGVWGVVHWWCWVHXRZWVKWVLURTZWWCWVQWAZYAWWLWWGWVKWWJVWFUNSWWCWVKVW
        FWVLWVOWVPUWOWAWWDVYAVYFWWCVWFVWHUKSAVYAVWGVVHWWCVYNXRZAVYFVWGVVHWWCWVG
        XRZWVKWWCUWPBUCVWHJYIWBWOWWDWWIWWKWWEVAWWDVWHVWFWVLWWGWWLWWNYBUWQYCWWDW
        WIWVLVVBUNSZVWKVVHWWQVXGWWCVVBUWRYDWWDVWJURTWWMVVBURTZWWIWWQVAVWKUPWWDV
        WIWWDVWIWWDVWHVWFWWGWWLYAXLYEWWNVVHWWRVXGWWCVVBYFZYDVWJWVLVVBUWSWBYGYHY
        JUWTWWDVXCVWHHVWHVJVKRZVMRZULRZVWFVXBULRZULRZUMUGZVXBUNSZWWAWWDVWTWXEVX
        BUNWWDVWSWXDUMWWDVWQWXBVWRWXCULWWDVWHVITVWQWXBXCWWDVWHWWGXLUBVWHVWOWXBV
        IVWPUBEWQZVWLVWHVWNWXAULWXGWSWXGVWMWWTHVMVWLVWHVJVKXDYKWPVWPVQZVWHWXAUL
        YLYRXGWWDVXIVWRWXCXCVXGVXIVVHWWCWVIXOZUBVWFVWOWXCVIVWPVWLVWFXCZVWLVWFVW
        NVXBULWXJWSWXJVWMVXAHVMVWLVWFVJVKXDYKWPWXHVWFVXBULYLYRXGWPWTXAWWDWXFWXC
        VXBULRWXBUNSZWXBWXCVXBXNRZUNSZVAWWAWWDWXBWXCVXBWWDVWHWXAWWGWWDHWWTAHURT
        VWGVVHWWCAHPWIXRZWWDVWHURTVXTWWTURTWWGWCVWHVJUXAXSYMYAZWWDVWFVXBWWLWWDH
        VXAWXNWWDVWFVJWWLVXTWWDWCWEUXCYMZYAWXPYBWWDWXMWWAWXKWWDWXMWXBVWFUNSZWWA
        WWDWXLVWFWXBUNWWDVWFVXBWXIWWDVXBWXPXLUXDUXEWWDWXQWWAWWDVWFWXBUKSZWXQVEW
        WDVYAVYFWXBJTZWXRWWOWWPWVKAWWCWXSAVWGVVHUXFQXMBUCWXBJYIWBWWDVWFWXBWWLWX
        OUXGXTUXHYNUXIYNYNUXKUXJWVKVYAVYBVYFWWHWVNWWBWLWWFAVYBVWGVVHWUPXOAVYFVW
        GVVHWVGXOWVRBUCEJWVMYOYPUXLYHYSUXMUXNWAVVIVWEVVBVWFUKSZVWGVVIWXTVVBVYCU
        KSZUCJUQZVWEVVIVYAVYBVYFWWRWXTWYBWLAVYAVVHVYNWAAVYBVVHWUPWAAVYFVVHWVGWA
        VVHWWRAWWSXPZBUCUCJVVBYOYPWYBWYAUCVYHUQVWEWYAUCJVYHOXHVVSWYAVVTUCFVWCVY
        CVVOVVBUKXFXIXJUXOVVIVLVVBUNSZWXTVWGVVHWYDAVVBUXPXPVVIVYIWWRVYGWYDWXTVA
        VWGUPVYIVVIWHWEWYCAVYGVVHWVHWAVLVVBVWFUXQWBYCYJYSVVSVVTFVWCUXRXKVVIVWBV
        VJFVWCVVIWVBVAZVVSVWAVVJWYEVWAVVSVVJVVIWVBVWAVVSVVJUPVVIWVBVWAVAZVAZVVR
        VVECUDVVRWUGVVOUKSZBVVQUQWYGVURUDTZVAZVVEVVPWYHDBVVQDBWQZVVNWUGVVOUKWYK
        VVMWUFUMWYKVVLWUEVVKVUOUHVVKVUOIWRWYKWSWPWTXAUXSWYJWYHVVDBVVQUDWYJVUSVU
        OUDTZVUOVVQTZWYHUPZVVCWYJVUSWYLWYNVVCUPWYJVUSWYLVAZVAZWYMWYHVVCWYPWYMVU
        OURTZVUSWYLWYQWYJVUSVUOYFZYQZWYJVUSWYLUXTWYPVURURTWYMWYQVUSVAWLWYPVURWY
        GWYIWYOUYAWIVURVUOWNXGUYKWYPWYHVVAVVOUKSZVVCWYPVVAWUGVVOUKWYPVUTWUFUMWY
        PWUFVUPVUOULRZVUOUHRVUQVUOVUOUHRZULRVUTWYPWUEXUAVUOUHWYLWUEXUAXCWYJVUSV
        UOIKLUYBYQUYCWYPVUPVUOVUOWYPVUPWYPWYQVUPURTZWYSVUOUYDZXGXLWYLVUOVITWYJV
        USVUOUYEYQZXUEWYLVUOVLWGWYJVUSVUOUYFYQZUYGWYPXUBUOVUQULWYPVUOXUEXUFUYHY
        KUYIWTXAWYPWYTVVOVVBUNSZVVCWYPXUGVWAWYGVWAWYIWYOVVIWVBVWAUYJXOWYPVVOVVB
        WYPVWCURVVOWYGVYKWYIWYOAVYKVVHWYFVYMXOXOWYJWVBWYOVVIWVBVWAWYIUYLWAUYMZW
        YPVVBAVVHWYFWYIWYOUYNWIZXQYTWYPVVAURTWVDWWRWYTXUGVAVVCUPWYPVUTWYPVUTWYP
        VUQURTZWULVUTURTWYLXUJWYJVUSXUCWYLXUJWYLWYQXUCWYRXUDXGVUPVUOUYOUYPZYQWM
        VUQUOUYQXSXLYEXUHXUIVVAVVOVVBUYRWBYGYJUYTUYSVUIVUAVUBVUCVUDVUEVUFVUGVUH
        VVECUDURVUJVUKXBAUACBUDVUQUOVUQVITZBUDUQAXULBUDWYLVUQXUKXLVULWEVVGAVBWE
        UOVITAVUMWEVUNYT $.
    $}

    pntlemp.b $e |- ( ph -> B e. RR+ ) $.
    pntlemp.l $e |- ( ph -> L e. ( 0 (,) 1 ) ) $.
    pntlemp.d $e |- D = ( A + 1 ) $.
    pntlemp.f $e |- F = ( ( 1 - ( 1 / D ) ) x.
      ( ( L / ( ; 3 2 x. B ) ) / ( D ^ 2 ) ) ) $.
    pntlemp.K $e |- ( ph -> A. e e. ( 0 (,) 1 ) E. x e. RR+
    A. k e. ( ( exp ` ( B / e ) ) [,) +oo ) A. y e. ( x (,) +oo )
    E. z e. RR+ ( ( y < z /\ ( ( 1 + ( L x. e ) ) x. z ) < ( k x. y ) ) /\
        A. u e. ( z [,] ( ( 1 + ( L x. e ) ) x. z ) )
          ( abs ` ( ( R ` u ) / u ) ) <_ e ) ) $.
    ${
      pntlemp.u $e |- ( ph -> U e. RR+ ) $.
      pntlemp.u2 $e |- ( ph -> U <_ A ) $.
      pntlemp.e $e |- E = ( U / D ) $.
      pntlemp.k $e |- K = ( exp ` ( B / E ) ) $.
      pntlemp.y $e |- ( ph -> ( Y e. RR+ /\ 1 <_ Y ) ) $.
      pntlemp.U $e |- ( ph -> A. z e. ( Y [,) +oo )
        ( abs ` ( ( R ` z ) / z ) ) <_ U ) $.
      $( Lemma for ~ pnt .  Wrapping up more quantifiers.  (Contributed by
         Mario Carneiro, 14-Apr-2016.) $)
      pntlemp $p |- ( ph -> E. w e. RR+ A. v e. ( w [,) +oo )
        ( abs ` ( ( R ` v ) / v ) ) <_ ( U - ( F x. ( U ^ 3 ) ) ) ) $=
        ( vt vn vc cv clt wbr c1 cmul co caddc cfv cdiv cabs cle cicc wral wrex
        wa crp cpnf cioo cico clog c2 cfl cfz csu cmin c3 cexp cc0 wcel pntlemc
        w3a simp3d simp1d wceq oveq2 fveq2d syl6eqr oveq1d oveq2d breq1d anbi2d
        ce breq2 raleqbidv anbi12d rexbidv ralbidv oveq1 raleqdv cbvrexv syl6bb
        rspcva syl2anc cr simpld rpred simprd pntrlog2bnd reeanv c4 cdc rpaddcl
        adantr simpl syl2an ltaddrp jca adantrr simprlr eqid rpxr ad2antrl rpre
        wss cxr ltaddrp2d ltled iooss1 simprrl ssralv ralimdv sylc simprrr expr
        pntleme rexlimdvva syl5bir mp2and ) ACURZDURZUSUTZVAROVBVCZVDVCZUUGVBVC
        ZNURUUFVBVCZUSUTZVLZGURZKVEUUOVFVCVGVEZOVHUTZGUUGUUKVIVCZVJZVLZDVMVKZCU
        OURZVNVOVCZVJZNQVNVPVCZVJZUOVMVKZUUGKVEZVGVEUUGVQVEZVBVCVRUVIVFVCVAUUGS
        VFVCVSVEVTVCUUGUPURZVFVCKVEVGVEUVJVQVEVBVCUPWAVBVCWBVCUUGVFVCUQURZVHUTD
        VAVNVOVCVJZUQVMVKZFURZKVEUVNVFVCVGVELPLWCWDVCVBVCWBVCVHUTFEURVNVPVCVJEV
        MVKZAOWEVAVOVCZWFZUUHVARMURZVBVCZVDVCZUUGVBVCZUULUSUTZVLZUUPUVRVHUTZGUU
        GUWAVIVCZVJZVLZDVMVKZCBURZVNVOVCZVJZNIUVRVFVCZWSVEZVNVPVCZVJZBVMVKZMUVP
        VJUVGAUVQVAQUSUTZLOWBVCZVMWFZAOVMWFQVMWFUVQUWQUWSWHAHIJKLOPQRTUAUBUDUEU
        FUGUIUJUKULWGWIWJUHUWPUVGMOUVPUVROWKZUWPUVACUWJVJZNUVEVJZBVMVKUVGUWTUWO
        UXBBVMUWTUWKUXANUWNUVEUWTUWMQVNVPUWTUWMIOVFVCZWSVEQUWTUWLUXCWSUVROIVFWL
        WMULWNWOUWTUWHUVACUWJUWTUWGUUTDVMUWTUWCUUNUWFUUSUWTUWBUUMUUHUWTUWAUUKUU
        LUSUWTUVTUUJUUGVBUWTUVSUUIVAVDUVRORVBWLWPWOZWQWRUWTUWDUUQGUWEUURUWTUWAU
        UKUUGVIUXDWPUVROUUPVHWTXAXBXCXDXAXCUXBUVFBUOVMUWIUVBWKZUXAUVDNUVEUXEUVA
        CUWJUVCUWIUVBVNVOXEXFXDXGXHXIXJASXKWFZVASVHUTZUVMASASVMWFZUXGUMXLZXMZAU
        XHUXGUMXNDSKUPTUQUAXOXJUVGUVMVLUVFUVLVLZUQVMVKUOVMVKAUVOUVFUVLUOUQVMVMX
        PAUXKUVOUOUQVMVMAUVBVMWFZUVKVMWFZVLZUXKUVOAUXNUXKVLZVLZCDEFGHIUVKJKLUPN
        OPQRSXQUUIVFVCVDVCVRWDVCSUVBVDVCZQVRWDVCVBVCXQWDVCWCVRXRIVBVCUWRROVRWDV
        CVBVCVBVCVFVCLWCVBVCUVKVDVCVBVCWSVEVDVCVDVCZUXQSTUAAHVMWFUXOUBXTAIVMWFU
        XOUDXTARUVPWFUXOUEXTUFUGALVMWFUXOUIXTALHVHUTUXOUJXTUKULAUXHUXGVLUXOUMXT
        AUXNUXQVMWFZSUXQUSUTZVLUXKAUXNVLZUXSUXTAUXHUXLUXSUXNUXIUXLUXMYAZSUVBXSY
        BZAUXFUXLUXTUXNUXJUYBSUVBYCYBYDYEAUXLUXMUXKYFUXRYGAUVHUUGVFVCVGVELVHUTD
        SVNVPVCVJUXOUNXTUXPUXQVNVOVCZUVCYKZUVFUVACUYDVJZNUVEVJAUXNUYEUXKUYAUVBY
        LWFZUVBUXQVHUTUYEUXLUYGAUXMUVBYHYIUYAUVBUXQUXLUVBXKWFAUXMUVBYJYIZUYAUXQ
        UYCXMUYAUVBSUYHAUXHUXNUXIXTYMYNUVBUXQVNYOXJYEAUXNUVFUVLYPUYEUVDUYFNUVEU
        VACUYDUVCYQYRYSAUXNUVFUVLYTUUBUUAUUCUUDUUE $.
    $}

    $d z ph $.
    $( Lemma for ~ pnt .  Equation 10.6.35 in [Shapiro], p. 436.  (Contributed
       by Mario Carneiro, 14-Apr-2016.) $)
    pntleml $p |- ( ph -> ( x e. RR+ |-> ( ( psi ` x ) / x ) ) ~~>r 1 ) $=
      ( vr vt vv vw vs cv cfv cdiv co cabs cle wbr cpnf cico wral crp wrex cicc
      cc0 crab eqid wcel pntlemd simp3d wa cexp cmul cmin wceq 0cn subidi simpr
      c3 oveq1d cn 0exp ax-mp syl6eq oveq2d rpcnd mul01d ad2antrr eqtrd oveq12d
      3nn 3eqtr4a simplr eqeltrd wne wi weq oveq1 raleqdv cbvrexv cr simplrr wb
      w3a 0re rpred elicc2 sylancr mpbid simp1d cz simp2d simplrl ne0gt0d elrpd
      3nn0 nn0zi rpexpcl sylancl rpmulcld resubcld ce caddc cioo clt simprl 1rp
      c1 rpaddcl rpge0d 1re addge02 jca wss adantl fveq2 id fveq2d breq1d breq2
      cxr syl rexralbidv elrab rpxrd df-ico xrletr ixxss1 syl2anc simprr ssralv
      lep1d sylc pntlemp rpre leidd elicopnf mpbir2and rspcv ffvelrni rerpdivcl
      pntrf mpancom recnd absge0d a1i abscld adantr letr syl3anc syld rexlimdva
      mpand mpd subge02d letrd rexlimdvaa syl5bi anassrs expimpd cbvralv syl5bb
      mpbir3and syl6bbr 3imtr4g imp an32s pm2.61dane pntlem3 ) ABCDUCUDFLIDUHZI
      UIZUWFUJUKZULUIZUDUHZUMUNZDCUHZUOUPUKZUQCURUSZUDVAFUTUKZVBZNOPQUWPVCAMURV
      DHURVDLURVDZAFGHILMNOPRSTUAVEVFZAUCUHZUWPVDZVGZUWSLUWSVOVHUKZVIUKZVJUKZUW
      PVDZUWSVAUXAUWSVAVKZVGZUXDUWSUWPUXGVAVAVJUKVAUXDUWSVAVLVMUXGUWSVAUXCVAVJU
      XAUXFVNZUXGUXCLVAVIUKZVAUXGUXBVALVIUXGUXBVAVOVHUKZVAUXGUWSVAVOVHUXHVPVOVQ
      VDUXJVAVKWGVOVRVSVTWAAUXIVAVKUWTUXFALALUWRWBWCWDWEWFUXHWHAUWTUXFWIWJAUWSV
      AWKZUWTUXEAUXKVGZUWTUXEUXLUWSUWOVDZUWIUWSUMUNZDUWMUQZCURUSZVGUXDUWOVDZUEU
      HZIUIZUXRUJUKZULUIZUXDUMUNZUEUFUHZUOUPUKZUQZUFURUSZVGZUWTUXEUXLUXMUXPUYGA
      UXKUXMUXPUYGWLUXPUXNDUGUHZUOUPUKZUQZUGURUSAUXKUXMVGZVGZUYGUXOUYJCUGURCUGW
      MUXNDUWMUYIUWLUYHUOUPWNWOWPUYLUYJUYGUGURUYLUYHURVDZUYJVGZVGZUXQUYFUYOUXQU
      XDWQVDZVAUXDUMUNZUXDFUMUNZUYOUWSUXCUYOUWSWQVDZVAUWSUMUNZUWSFUMUNZUYOUXMUY
      SUYTVUAWTZAUXKUXMUYNWRUYOVAWQVDZFWQVDZUXMVUBWSXAUYOFAFURVDUYKUYNPWDZXBZVA
      FUWSXCXDXEZXFZUYOUXCUYOLUXBAUWQUYKUYNUWRWDUYOUWSURVDVOXGVDUXBURVDUYOUWSVU
      HUYOUWSVUHUYOUYSUYTVUAVUGXHAUXKUXMUYNXIXJXKZVOXLXMUWSVOXNXOXPZXBZXQZUYOUY
      FUYQUYOBCDUFUEEFGHIUWSJKUWSHUJUKZLGVUMUJUKXRUIZMUYHYDXSUKZNOVUEABUHZIUIVU
      PUJUKULUIFUMUNBURUQUYKUYNQWDAGURVDUYKUYNRWDAMVAYDXTUKZVDUYKUYNSWDTUAAUWLU
      WFYAUNYDMJUHZVIUKXSUKUWFVIUKZKUHUWLVIUKYAUNVGEUHZIUIVUTUJUKULUIVURUMUNEUW
      FVUSUTUKUQVGDURUSCVUPUOXTUKUQKGVURUJUKXRUIUOUPUKUQBURUSJVUQUQUYKUYNUBWDVU
      IUYOUYSUYTVUAVUGVFZVUMVCVUNVCUYOVUOURVDZYDVUOUMUNZUYOUYMYDURVDVVBUYLUYMUY
      JYBZYCUYHYDYEXOUYOVAUYHUMUNZVVCUYOUYHVVDYFUYOYDWQVDUYHWQVDVVEVVCWSYGUYOUY
      HVVDXBZYDUYHYHXDXEYIUYOVUOUOUPUKZUYIYJZUYJUXNDVVGUQUYOUYHYQVDUYHVUOUMUNVV
      HUYOUYHVVDUUAUYOUYHVVFUUHUDUCUFUEUYHVUOUOUPUMYAUMUPUMUDUCUFUUBZVVIUYHVUOU
      XRUUCUUDUUEUYLUYMUYJUUFUXNDVVGUYIUUGUUIUUJZUYOUYEUYQUFURUYOUYCURVDZVGZUYE
      UYCIUIZUYCUJUKZULUIZUXDUMUNZUYQVVLUYCUYDVDZUYEVVPWLVVLVVQUYCWQVDZUYCUYCUM
      UNZVVKVVRUYOUYCUUKYKZVVLUYCVVTUULVVLVVRVVQVVRVVSVGWSVVTUYCUYCUUMYRUUNUYBV
      VPUEUYCUYDUEUFWMZUYAVVOUXDUMVWAUXTVVNULVWAUXSVVMUXRUYCUJUXRUYCIYLVWAYMWFY
      NYOUUOYRVVLVAVVOUMUNZVVPUYQVVLVVNVVLVVNVVKVVNWQVDZUYOVVMWQVDVVKVWCURWQUYC
      IINOUURUUPVVMUYCUUQUUSYKUUTZUVAVVLVUCVVOWQVDUYPVWBVVPVGUYQWLVUCVVLXAUVBVV
      LVVNVWDUVCUYOUYPVVKVULUVDVAVVOUXDUVEUVFUVIUVGUVHUVJUYOUXDUWSFVULVUHVUFUYO
      VAUXCUMUNUXDUWSUMUNUYOUXCVUJYFUYOUWSUXCVUHVUKUVKXEVVAUVLUYOVUCVUDUXQUYPUY
      QUYRWTWSXAVUFVAFUXDXCXDUVSVVJYIUVMUVNUVOUVPUWNUXPUDUWSUWOUDUCWMUWKUXNCDUR
      UWMUWJUWSUWIUMYPYSYTUWNUYFUDUXDUWOUWJUXDVKZUWNUWIUXDUMUNZDUWMUQZCURUSUYFV
      WEUWKVWFCDURUWMUWJUXDUWIUMYPYSUYEVWGUFCURUYEVWFDUYDUQUFCWMZVWGUYBVWFUEDUY
      DUEDWMZUYAUWIUXDUMVWIUXTUWHULVWIUXSUWGUXRUWFUJUXRUWFIYLVWIYMWFYNYOUVQVWHV
      WFDUYDUWMUYCUWLUOUPWNWOUVRWPUVTYTUWAUWBUWCUWDUWE $.
  $}

  ${
    $d a b c e f g k l r u w x y z $.
    $( The Prime Number Theorem, version 3: the second Chebyshev function tends
       asymptotically to ` x ` .  (Contributed by Mario Carneiro,
       1-Jun-2016.) $)
    pnt3 $p |- ( x e. RR+ |-> ( ( psi ` x ) / x ) ) ~~>r 1 $=
      ( vr va ve vk vu vf vg cv crp cfv co cdiv wbr wral wrex c1 wa clt cmul vb
      vy vz vl vc cchp cmin cmpt cabs cle crli eqid pntrmax wcel cicc cpnf cioo
      caddc ce cico cc0 pntibnd c3 c2 cdc cexp simpll simplr weq oveq12d fveq2d
      fveq2 id breq1d cbvralv sylib simprll simprlr breq2 oveq2 anbi12d raleqdv
      simprr cbvrexv breq1 breq2d anbi1d rexbidv syl5bb oveq1 ralbii rexlimdvva
      ralbidv pntleml expr mpi rexlimiva ax-mp ) BIZCJCIZUFKWTUGLUHZKZWSMLZUIKZ
      UAIZUJNZBJOZUAJPAJAIZUFKXHMLUHQUKNZBXACUAXAULZUMXGXIUAJXEJUNZXGRZUBIZUCIZ
      SNZQUDIZDIZTLURLZXNTLZEIZXMTLZSNZRZFIZXAKYDMLUIKXQUJNZFXNXSUOLZOZRZUCJPZU
      BWSUPUQLZOZEUEIZXQMLUSKUPUTLZOZBJPZDVAQUQLZOZUDYPPUEJPXIBUBUCFXADECUEUDXJ
      VBXLYQXIUEUDJYPXLYLJUNZXPYPUNZRZYQXIXLYTYQRZRZAGHFXEYLXEQURLZXADEQQUUCMLU
      GLXPVCVDVEYLTLMLUUCVDVFLMLTLZXPCXJXKXGUUAVGUUBXGXHXAKZXHMLZUIKZXEUJNZAJOX
      KXGUUAVHXFUUHBAJBAVIZXDUUGXEUJUUIXCUUFUIUUIXBUUEWSXHMWSXHXAVLUUIVMVJVKVNV
      OVPXLYRYSYQVQXLYRYSYQVRUUCULUUDULUUBYQGIZHIZSNZXRUUKTLZXTUUJTLZSNZRZYEFUU
      KUUMUOLZOZRZHJPZGXHUPUQLZOZEYMOZAJPZDYPOXLYTYQWCYOUVDDYPYNUVCBAJUUIYKUVBE
      YMYKUUTGYJOUUIUVBYIUUTUBGYJYIXMUUKSNZUUMYASNZRZUURRZHJPUBGVIZUUTYHUVHUCHJ
      UCHVIZYCUVGYGUURUVJXOUVEYBUVFXNUUKXMSVSUVJXSUUMYASXNUUKXRTVTZVNWAUVJYEFYF
      UUQUVJXNUUKXSUUMUOUVJVMUVKVJWBWAWDUVIUVHUUSHJUVIUVGUUPUURUVIUVEUULUVFUUOX
      MUUJUUKSWEUVIYAUUNUUMSXMUUJXTTVTWFWAWGWHWIVOUUIUUTGYJUVAWSXHUPUQWJWBWIWMW
      DWKVPWNWOWLWPWQWR $.

    $( The Prime Number Theorem, version 2: the first Chebyshev function tends
       asymptotically to ` x ` .  (Contributed by Mario Carneiro,
       1-Jun-2016.) $)
    pnt2 $p |- ( x e. RR+ |-> ( ( theta ` x ) / x ) ) ~~>r 1 $=
      ( crp cdiv co cmpt c1 crli wbr wtru c2 cr wa 2re cc0 a1i wne cc syl recnd
      wcel cv ccht cfv cpnf cico cres cchp elicopnf ax-mp chprpcl sylbi simplbi
      cle 0re clt 2pos simprbi ltletrd elrpd rpdivcld adantl chtrpcl ssriv pnt3
      wb wss rlimres2 chpchtlim ax-1ne0 rpne0d rlimdiv cmul wceq chpcl rpcnne0d
      rpre syl22anc mulcomd oveq2d chtcl divcan5 syl3anc 3eqtrd mpteq2ia resmpt
      divdivdiv eqtr4i ax-1cn div1i 3brtr3g rerpdivcl mpancom eqid fmptd rpssre
      rlimresb mpbird trud ) ABAUAZUBUCZWSCDZEZFGHZIXCXBJUDUEDZUFZFGHIAXDWSUGUC
      ZWSCDZXFWTCDZCDZEZFFCDXEFGIAXDXGXHFFBWSXDTZXGBTIXKXFWSXKWSKTZJWSUMHZLZXFB
      TJKTZXKXNVEMJWSUHUIZWSUJUKZXKWSXKXLXMXPULZXKNJWSNKTXKUNOXOXKMOXRNJUOHXKUP
      OXKXLXMXPUQURUSZUTVAXKXHBTIXKXFWTXQXKXNWTBTXPWSVBUKZUTVAZIAXDBXGFXDBVFZIA
      XDBXSVCZOABXGEFGHIAVDOVGAXDXHEFGHIAVHOFNPIVIOIXKLXHYAVJVKXJAXDXAEZXEAXDXI
      XAXKXIXFWTVLDZWSXFVLDZCDZYEXFWSVLDZCDZXAXKXFQTZWSQTWSNPLZYJXFNPLZWTQTZWTN
      PLXIYGVMXKWSBTZYJXSYNXFYNXLXFKTWSVPZWSVNRSRZXKWSXSVOZXKXFXQVOZXKWTXTVOXFW
      SXFWTWFVQXKYFYHYECXKWSXFXKWSXRSYPVRVSXKYMYKYLYIXAVMXKYNYMXSYNWTYNXLWTKTZY
      OWSVTRZSRYQYRWTWSXFWAWBWCWDYBXEYDVMYCABXDXAWEUIWGFWHWIWJIBJFXBIABXAQXBIYN
      LXAYNXAKTZIYSYNUUAYTWTWSWKWLVASXBWMWNBKVFIWOOXOIMOWPWQWR $.

    $( The Prime Number Theorem: the number of prime numbers less than ` x `
       tends asymptotically to ` x / log ( x ) ` as ` x ` goes to infinity.
       (Contributed by Mario Carneiro, 1-Jun-2016.) $)
    pnt $p |- ( x e. ( 1 (,) +oo ) |->
      ( ( ppi ` x ) / ( x / ( log ` x ) ) ) ) ~~>r 1 $=
      ( c1 cpnf co cdiv cmpt crli wbr wtru wcel clt cmul crp syl cc0 a1i adantl
      c2 cr rpne0d vy vz vw cioo cppi cfv clog cico cres wss wceq cxr 1re rexri
      cv 1lt2 cle df-ioo df-ico xrltletr ixxss1 mp2an resmpt mp1i sseli ioossre
      ccht w3a wb 2re pnfxr elico2 simp2bi chtrpcl syl2anc 0lt1 eliooord simpld
      0re lttrd elrpd rpdivcld ppinncl nnrpd rplogcld rpmulcld ssriv ax-mp pnt2
      cn rlimres syl5eqbrr chtppilim wne ax-1ne0 rlimdiv recnd cc chtcl mulcomd
      oveq2d rpcnd divcan5d divdivdivd divdiv2d 3eqtr4d mpteq2ia ax-1cn 3brtr3g
      eqtrd nncnd div1i eqbrtrd cn0 ppicl nn0red rerpdivcld eqid fmptd rlimresb
      mpbird trud ) ABCUDDZAUOZUEUFZYDYDUGUFZEDZEDZFZBGHZIYJYIRCUHDZUIZBGHIYLAY
      KYHFZBGYKYCUJZYLYMUKIBULJBRKHYNBUMUNUPAUAUBUCBRCUHKKUQUDKAUAUBURAUAUBUSBR
      UCUOUTVAVBZAYCYKYHVCVDIAYKYDVGUFZYDEDZYPYEYFLDZEDZEDZFBBEDYMBGIAYKYQYSBBM
      YDYKJZYQMJIUUAYPYDUUAYDSJZRYDUQHZYPMJUUAYDYCJZUUBYKYCYDYOVEZYCSYDBCVFZVEZ
      NZUUAUUBUUCYDCKHZRSJZCULJUUAUUBUUCUUIVHVIVJVKRCYDVLVBVMZYDVNVOZUUAUUDYDMJ
      UUEUUDYDUUGUUDOBYDOSJUUDVSPBSJUUDUMPUUGOBKHUUDVPPUUDBYDKHUUIYDBCVQVRZVTWA
      ZNZWBQUUAYSMJIUUAYPYRUULUUAYEYFUUAYEUUAUUBUUCYEWJJUUHUUKYDWCVOZWDUUAUUDYF
      MJUUEUUDYDUUGUUMWEZNZWFZWBZQIAYKYQFZAMYQFZYKUIZBGYKMUJUVCUVAUKAYKMUUOWGAM
      YKYQVCWHUVBBGHUVCBGHIAWIBYKUVBWKVDWLAYKYSFBGHIAWMPBOWNIWOPUUAYSOWNIUUAYSU
      UTTQWPAYKYTYHUUAYPYRLDZYDYPLDZEDZYRYDEDZYTYHUUAUVFUVDYPYDLDZEDUVGUUAUVEUV
      HUVDEUUAYDYPUUAYDUUHWQZUUAUUDYPWRJUUEUUDYPUUDUUBYPSJUUGYDWSNWQNZWTXAUUAYR
      YDYPUUAYRUUSXBZUVIUVJUUAYDUUOTZUUAYPUULTZXCXJUUAYPYDYPYRUVJUVIUVJUVKUVLUU
      AYRUUSTUVMXDUUAYEYDYFUUAYEUUPXKUVIUUAYFUURXBUVLUUAYFUURTXEXFXGBXHXLXIXMIY
      CRBYIIAYCYHWRYIUUDYHWRJIUUDYHUUDYEYGUUDYEUUDUUBYEXNJUUGYDXONXPUUDYDYFUUNU
      UQWBXQWQQYIXRXSYCSUJIUUFPUUJIVJPXTYAYB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Ostrowski's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z F $.  $d x y z R $.  $d x y z S $.
    $d y z G $.
    abvcxp.a $e |- A = ( AbsVal ` R ) $.
    abvcxp.b $e |- B = ( Base ` R ) $.
    abvcxp.f $e |- G = ( x e. B |-> ( ( F ` x ) ^c S ) ) $.
    $( Raising an absolute value to a power less than one yields another
       absolute value.  (Contributed by Mario Carneiro, 8-Sep-2014.) $)
    abvcxp $p |- ( ( F e. A /\ S e. ( 0 (,] 1 ) ) -> G e. A ) $=
      ( wcel cc0 co cfv wceq ccxp cr cle wbr syl vy vz c1 cioc cplusg cmulr c0g
      wa cabv a1i cbs eqidd crg abvrcl adantr cv abvcl adantlr abvge0 clt simpr
      w3a cxr wb 0xr elioc2 mp2an sylib simp1d recxpcld fmptd eqid rng0cl fveq2
      1re oveq1d ovex fvmpt recnd simp2d gt0ne0d 0cxpd eqtrd wne simp1l syl2anc
      abv0 simp2 abvgt0 3adant1r elrpd 3ad2ant1 rpcxpcld rpgt0d breqtrrd simp2l
      cmul simp3l abvmul syl3anc mulcxpd rngcl oveq12d 3eqtr4d caddc cgrp grpcl
      rnggrp readdcld addge0d abvtri cxple2d mpbid simp3d cxpaddle letrd isabvd
      cc 3brtr4d ) FBKZELUCUDMKZUHZUAUBBCDUENZDDUFNZGDUGNZBDUINOYBHUJCDUKNOYBIU
      JYBYCULYBYDULYBYEULXTDUMKZYABDFHUNUOZYBACAUPZFNZEPMZQGYBYHCKZUHYIEXTYKYIQ
      KYABCDFYHHIUQURXTYKLYIRSYABCDFYHHIUSURYBEQKZYKYBYLLEUTSZEUCRSZYBYAYLYMYNV
      BZXTYAVALVCKUCQKYAYOVDVEVOLUCEVFVGVHZVIZUOVJJVKYBYEGNZYEFNZEPMZLYBYECKZYR
      YTOYBYFUUAYGCDYEIYEVLZVMTAYEYJYTCGYHYEOYIYSEPYHYEFVNVPJYSEPVQVRTYBYTLEPML
      YBYSLEPXTYSLOYABDFYEHUUBWGUOVPYBEYBEYQVSZYBEYBYLYMYNYPVTWAWBWCWCYBUAUPZCK
      ZUUDYEWDZVBZLUUDFNZEPMZUUDGNZUTUUGUUIUUGUUHEUUGUUHUUGXTUUEUUHQKZXTYAUUEUU
      FWEYBUUEUUFWHZBCDFUUDHIUQZWFXTUUEUUFLUUHUTSYABCDFUUDYEHIUUBWIWJWKYBUUEYLU
      UFYQWLWMWNUUGUUEUUJUUIOZUULAUUDYJUUICGYHUUDOYIUUHEPYHUUDFVNVPJUUHEPVQVRZT
      WOYBUUEUUFUHZUBUPZCKZUUQYEWDZUHZVBZUUDUUQYDMZFNZEPMZUUIUUQFNZEPMZWQMZUVBG
      NZUUJUUQGNZWQMUVAUVDUUHUVEWQMZEPMUVGUVAUVCUVJEPUVAXTUUEUURUVCUVJOXTYAUUPU
      UTWEZYBUUEUUFUUTWPZYBUUPUURUUSWRZBCDYDFUUDUUQHIYDVLZWSWTVPUVAUUHUVEEUVAXT
      UUEUUKUVKUVLUUMWFZUVAXTUUELUUHRSUVKUVLBCDFUUDHIUSWFZUVAXTUURUVEQKUVKUVMBC
      DFUUQHIUQWFZUVAXTUURLUVERSUVKUVMBCDFUUQHIUSWFZYBUUPEXRKUUTUUCWLXAWCUVAUVB
      CKZUVHUVDOUVAYFUUEUURUVSYBUUPYFUUTYGWLZUVLUVMCDYDUUDUUQIUVNXBWTAUVBYJUVDC
      GYHUVBOYIUVCEPYHUVBFVNVPJUVCEPVQVRTUVAUUJUUIUVIUVFWQUVAUUEUUNUVLUUOTZUVAU
      URUVIUVFOUVMAUUQYJUVFCGYHUUQOYIUVEEPYHUUQFVNVPJUVEEPVQVRTZXCXDUVAUUDUUQYC
      MZFNZEPMZUUIUVFXEMZUWCGNZUUJUVIXEMRUVAUWEUUHUVEXEMZEPMZUWFUVAUWDEUVAXTUWC
      CKZUWDQKUVKUVADXFKZUUEUURUWJUVAYFUWKUVTDXHTUVLUVMCYCDUUDUUQIYCVLZXGWTZBCD
      FUWCHIUQWFZUVAXTUWJLUWDRSUVKUWMBCDFUWCHIUSWFZUVAYLYMYNYBUUPYOUUTYPWLZVIZV
      JUVAUWHEUVAUUHUVEUVOUVQXIZUVAUUHUVEUVOUVQUVPUVRXJZUWQVJUVAUUIUVFUVAUUHEUV
      OUVPUWQVJUVAUVEEUVQUVRUWQVJXIUVAUWDUWHRSZUWEUWIRSUVAXTUUEUURUWTUVKUVLUVMB
      CYCDFUUDUUQHIUWLXKWTUVAUWDUWHEUWNUWOUWRUWSUVAEUWQUVAYLYMYNUWPVTWKZXLXMUVA
      UUHUVEEUVOUVPUVQUVRUXAUVAYLYMYNUWPXNXOXPUVAUWJUWGUWEOUWMAUWCYJUWECGYHUWCO
      YIUWDEPYHUWCFVNVPJUWDEPVQVRTUVAUUJUUIUVIUVFXEUWAUWBXCXSXQ $.
  $}

  ${
    $d q x P $.  $d x X $.
    padicval.j $e |- J = ( q e. Prime |-> ( x e. QQ |->
      if ( x = 0 , 0 , ( q ^ -u ( q pCnt x ) ) ) ) ) $.
    $( Value of the p-adic absolute value.  (Contributed by Mario Carneiro,
       8-Sep-2014.) $)
    padicfval $p |- ( P e. Prime -> ( J ` P ) = ( x e. QQ |->
      if ( x = 0 , 0 , ( P ^ -u ( P pCnt x ) ) ) ) ) $=
      ( cq cv cc0 wceq cpc co cneg cexp cif cmpt cprime id oveq1 negeqd oveq12d
      ifeq2d mpteq2dv qex mptex fvmpt ) DBAFAGZHIZHDGZUHUFJKZLZMKZNZOAFUGHBBUFJ
      KZLZMKZNZOPCUHBIZAFULUPUQUGUKUOHUQUHBUJUNMUQQUQUIUMUHBUFJRSTUAUBEAFUPUCUD
      UE $.

    $( Value of the p-adic absolute value.  (Contributed by Mario Carneiro,
       8-Sep-2014.) $)
    padicval $p |- ( ( P e. Prime /\ X e. QQ ) -> ( ( J ` P ) ` X ) =
      if ( X = 0 , 0 , ( P ^ -u ( P pCnt X ) ) ) ) $=
      ( cprime wcel cq cfv cv cc0 wceq cpc co cneg cexp cif cmpt padicfval eqid
      fveq1d eqeq1 oveq2 negeqd oveq2d ifbieq2d c0ex ovex ifex fvmpt sylan9eq )
      BGHZDIHDBCJZJDAIAKZLMZLBBUONOZPZQOZRZSZJDLMZLBBDNOZPZQOZRZUMDUNVAABCEFTUB
      ADUTVFIVAUODMZUPVBUSVELUODLUCVGURVDBQVGUQVCUODBNUDUEUFUGVAUAVBLVEUHBVDQUI
      UJUKUL $.
  $}

  ${
    $d k n A $.  $d k n B $.  $d k n ph $.
    ostth2lem1.1 $e |- ( ph -> A e. RR ) $.
    ostth2lem1.2 $e |- ( ph -> B e. RR ) $.
    ostth2lem1.3 $e |- ( ( ph /\ n e. NN ) -> ( A ^ n ) <_ ( n x. B ) ) $.
    $( Lemma for ~ ostth2 , although it is just a simple statement about
       exponentials which does not involve any specifics of ~ ostth2 .  If a
       power is upper bounded by a linear term, the exponent must be less than
       one.  Or in big-O notation, ` n e. o ( A ^ n ) ` for any ` 1 < A ` .
       (Contributed by Mario Carneiro, 10-Sep-2014.) $)
    ostth2lem1 $p |- ( ph -> A <_ 1 ) $=
      ( c1 cle wbr clt c2 cmul co cexp cn cr wcel adantr cc0 vk wn cmin cdiv cv
      wrex wa 2re remulcl sylancr crp simpr wb difrp rerpdivcld expnbnd syl3anc
      1re mpbid cn0 nnnn0 reexpcl syl2an rpred adantl remulcld ad2antrr nnmulcl
      nnre 2nn syl reexpcld nnred cz 0re a1i 0lt1 lttrd elrpd nnz rpexpcl caddc
      peano2re ltp1d rpge0d bernneq2 ltletrd recnd 2timesd oveq2d expaddd eqtrd
      ltmul1dd breqtrrd wral ralrimiva wceq oveq2 oveq1 breq12d rspcv mul32d cc
      sylc 2cn mpbird ltmul1 syl112anc rpgt0d ltmuldiv2 ltnsymd nrexdv pm2.65da
      nngt0 lenlt sylancl ) ABHIJZHBKJZUBZAXRLCMNZBHUCNZUDNZBUAUEZONZKJZUAPUFZA
      XRUGZYBQRZBQRZXRYFYGXTYAYGLQRCQRZXTQRZUHAYJXRFSLCUIUJZYGXRYAUKRZAXRULZYGH
      QRZYIXRYMUMURAYIXRESZHBUNUJUSZUOZYPYNYBBUAUPUQYGYEUAPYGYCPRZUGZYDYBYGYIYC
      UTRZYDQRZYSYPYCVAZBYCVBVCZYGYHYSYRSYTYAYDMNZXTKJZYDYBKJZYTUUFUUEYCMNZXTYC
      MNZKJZYTUUJYAYCMNZYDMNZLYCMNZCMNZKJYTUULBUUMONZUUNYTUUKYDYTYAYCYGYAQRZYSY
      GYAYQVDSZYSYCQRZYGYCVIVEZVFZUUDVFYTBUUMAYIXRYSEVGZYTUUMPRZUUMUTRYTLPRYSUV
      BVJYGYSULLYCVHUJZUUMVAVKVLYTUUMCYTUUMUVCVMAYJXRYSFVGZVFYTUULYDYDMNZUUOKYT
      UUKYDYDUUTUUDYGBUKRZYCVNRYDUKRYSYGBYPYGTHBTQRYGVOVPYOYGURVPYPTHKJYGVQVPYN
      VRVSZYCVTBYCWAVCYTUUKUUKHWBNZYDUUTYTUUKQRUVHQRUUTUUKWCVKUUDYTUUKUUTWDYTYI
      UUATBIJUVHYDIJUVAYSUUAYGUUCVEZYTBYGUVFYSUVGSWEBYCWFUQWGWMYTUUOBYCYCWBNZON
      UVEYTUUMUVJBOYTYCYTYCUUSWHZWIWJYTBYCYCYTBUVAWHUVIUVIWKWLWNYTUVBBDUEZONZUV
      LCMNZIJZDPWOZUUOUUNIJZUVCAUVPXRYSAUVODPGWPVGUVOUVQDUUMPUVLUUMWQUVMUUOUVNU
      UNIUVLUUMBOWRUVLUUMCMWSWTXAXDWGYTUUHUULUUIUUNKYTYAYDYCYTYAUUQWHYTYDUUDWHU
      VKXBYTLCYCLXCRYTXEVPYTCUVDWHUVKXBWTXFYTUUEQRYKUURTYCKJZUUFUUJUMYTYAYDUUQU
      UDVFYGYKYSYLSZUUSYSUVRYGYCXNVEUUEXTYCXGXHXFYTUUBYKUUPTYAKJZUUFUUGUMUUDUVS
      UUQYGUVTYSYGYAYQXISYDXTYAXJXHUSXKXLXMAYIYOXQXSUMEURBHXOXPXF $.
  $}

  ${
    $d k n p y z G $.  $d k n K $.  $d j k n x M $.  $d a b k n p q x y z ph $.
    $d a g p y z J $.  $d a b k S $.  $d j k n x T $.  $d n x U $.  $d k x X $.
    $d a k n p q x y z A $.  $d k n x y z N $.  $d k n x y z Q $.  $d k Y $.
    $d a b g j k n p q y z F $.  $d a b k p q x y z P $.  $d a p q y z R $.
    qrng.q $e |- Q = ( CCfld |`s QQ ) $.
    $( The base set of the field of rationals.  (Contributed by Mario Carneiro,
       8-Sep-2014.) $)
    qrngbas $p |- QQ = ( Base ` Q ) $=
      ( cq cc wss cbs cfv wceq qsscn ccnfld cnfldbas ressbas2 ax-mp ) CDECAFGHI
      CDAJBKLM $.

    $( The rationals form a division ring.  (Contributed by Mario Carneiro,
       8-Sep-2014.) $)
    qdrng $p |- Q e. DivRing $=
      ( ccnfld cq cress co cdr csubrg cfv wcel qsubdrg simpri eqeltri ) ACDEFZG
      BDCHIJNGJKLM $.

    $( The zero element of the field of rationals.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    qrng0 $p |- 0 = ( 0g ` Q ) $=
      ( cq ccnfld csubrg cfv wcel csubg cc0 c0g wceq cress co qsubdrg subrgsubg
      cdr simpli cnfld0 subg0 mp2b ) CDEFGZCDHFGIAJFKUADCLMPGNQCDOCDAIBRST $.

    $( The unit element of the field of rationals.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    qrng1 $p |- 1 = ( 1r ` Q ) $=
      ( cq ccnfld csubrg cfv wcel c1 cur wceq cress co cdr simpli cnfld1 subrg1
      qsubdrg ax-mp ) CDEFGZHAIFJSDCKLMGQNCDAHBOPR $.

    $( The additive inverse in the field of rationals.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    qrngneg $p |- ( X e. QQ -> ( ( invg ` Q ) ` X ) = -u X ) $=
      ( wcel ccnfld cminusg cfv cneg csubg wceq csubrg cress cdr qsubdrg simpli
      cq co subrgsubg ax-mp eqid subginv mpan cc qcn cnfldneg syl eqtr3d ) BPDZ
      BEFGZGZBAFGZGZBHZPEIGDZUHUJULJPEKGDZUNUOEPLQMDNOPERSPEAUIUKBCUITUKTUAUBUH
      BUCDUJUMJBUDBUEUFUG $.

    $( The division operation in the field of rationals.  (Contributed by Mario
       Carneiro, 8-Sep-2014.) $)
    qrngdiv $p |- ( ( X e. QQ /\ Y e. QQ /\ Y =/= 0 ) ->
                    ( X ( /r ` Q ) Y ) = ( X / Y ) ) $=
      ( cq wcel cc0 wne w3a cdiv cdvr cfv ccnfld csubrg csn cdif wceq cress cdr
      co qsubdrg simpli a1i simp1 wa 3simpc eldifsn sylibr cnflddiv qrng0 qdrng
      qrngbas drngui eqid subrgdv syl3anc eqcomd ) BEFZCEFZCGHZIZBCJTZBCAKLZTZV
      AEMNLFZURCEGOPZFZVBVDQVEVAVEMERTSFUAUBUCURUSUTUDVAUSUTUEVGURUSUTUFCEGUGUH
      EJMAVFVCBCDUIEAGADULADUJADUKUMVCUNUOUPUQ $.

    qabsabv.a $e |- A = ( AbsVal ` Q ) $.
    $( By using induction on ` N ` , we show a long-range inequality coming
       from the triangle inequality.  (Contributed by Mario Carneiro,
       10-Sep-2014.) $)
    qabvle $p |- ( ( F e. A /\ N e. NN0 ) -> ( F ` N ) <_ N ) $=
      ( wcel cfv cle wbr wi cc0 c1 caddc wceq fveq2 id breq12d cq cr cn0 imbi2d
      vk vn cv co qrng0 abv0 0le0 syl6eqbr wa cn nn0p1nn ad2antrl nnq syl abvcl
      qrngbas syldan cz nn0z zq peano2re zred simpl 1z mp1i cvv cplusg cnfldadd
      qex ccnfld ressplusg ax-mp abvtri syl3anc wne ax-1ne0 qrng1 adantr oveq2d
      abv1z mpan2 breqtrd 1re a1i simprr leadd1dd expr expcom a2d nn0ind impcom
      letrd ) DUAGCAGZDCHZDIJZWOUCUEZCHZWRIJZKWOLCHZLIJZKWOUDUEZCHZXCIJZKWOXCMN
      UFZCHZXFIJZKWOWQKUCUDDWRLOZWTXBWOXIWSXAWRLIWRLCPXIQRUBWRXCOZWTXEWOXJWSXDW
      RXCIWRXCCPXJQRUBWRXFOZWTXHWOXKWSXGWRXFIWRXFCPXKQRUBWRDOZWTWQWOXLWSWPWRDIW
      RDCPXLQRUBWOXALLIABCLFBEUGZUHUIUJXCUAGZWOXEXHWOXNXEXHKWOXNXEXHWOXNXEUKZUK
      ZXGXDMNUFZXFWOXOXFSGZXGTGXPXFULGZXRXNXSWOXEXCUMUNXFUOUPASBCXFFBEURZUQUSXP
      XDTGZXQTGWOXOXCSGZYAXPXCUTGZYBXNYCWOXEXCVAUNZXCVBUPZASBCXCFXTUQUSZXDVCUPX
      PXCTGXFTGXPXCYDVDZXCVCUPXPXGXDMCHZNUFZXQIXPWOYBMSGZXGYIIJWOXOVEYEMUTGYJXP
      VFMVBVGASNBCXCMFXTSVHGNBVIHOVKSNVLBVHEVJVMVNVOVPXPYHMXDNWOYHMOZXOWOMLVQYK
      VRABMCLFBEVSXMWBWCVTWAWDXPXDXCMYFYGMTGXPWEWFWOXNXEWGWHWNWIWJWKWLWM $.

    $( Induct the product rule ~ abvmul to find the absolute value of a power.
       (Contributed by Mario Carneiro, 10-Sep-2014.) $)
    qabvexp $p |- ( ( F e. A /\ M e. QQ /\ N e. NN0 ) ->
      ( F ` ( M ^ N ) ) = ( ( F ` M ) ^ N ) ) $=
      ( wcel cq cexp co cfv wceq wi cc0 c1 oveq2 fveq2d eqeq12d cmul cn0 imbi2d
      vk vn wa cv caddc wne ax-1ne0 qrng1 qrng0 abv1z mpan2 adantr cc qcn exp0d
      adantl qrngbas abvcl recnd 3eqtr4d oveq1 expp1 sylan simpll qexpcl simplr
      adantll cvv cmulr qex ccnfld cnfldmul ressmulr ax-mp abvmul syl3anc eqtrd
      syl5ibr expcom a2d nn0ind com12 3impia ) CAHZDIHZEUAHZDEJKZCLZDCLZEJKZMZW
      HWFWGUEZWMWNDUCUFZJKZCLZWKWOJKZMZNWNDOJKZCLZWKOJKZMZNWNDUDUFZJKZCLZWKXDJK
      ZMZNWNDXDPUGKZJKZCLZWKXIJKZMZNWNWMNUCUDEWOOMZWSXCWNXNWQXAWRXBXNWPWTCWOODJ
      QRWOOWKJQSUBWOXDMZWSXHWNXOWQXFWRXGXOWPXECWOXDDJQRWOXDWKJQSUBWOXIMZWSXMWNX
      PWQXKWRXLXPWPXJCWOXIDJQRWOXIWKJQSUBWOEMZWSWMWNXQWQWJWRWLXQWPWICWOEDJQRWOE
      WKJQSUBWNPCLZPXAXBWFXRPMZWGWFPOUHXSUIABPCOGBFUJBFUKULUMUNWNWTPCWNDWGDUOHZ
      WFDUPURZUQRWNWKWNWKAIBCDGBFUSZUTVAZUQVBXDUAHZWNXHXMWNYDXHXMNXHXMWNYDUEZXF
      WKTKZXGWKTKZMXFXGWKTVCYEXKYFXLYGYEXKXEDTKZCLZYFYEXJYHCWNXTYDXJYHMYADXDVDV
      ERYEWFXEIHZWGYIYFMWFWGYDVFWGYDYJWFDXDVGVIWFWGYDVHAIBTCXEDGYBIVJHTBVKLMVLI
      VMBTVJFVNVOVPVQVRVSWNWKUOHYDXLYGMYCWKXDVDVESVTWAWBWCWDWE $.

    ${
      ostthlem1.1 $e |- ( ph -> F e. A ) $.
      ostthlem1.2 $e |- ( ph -> G e. A ) $.
      ${
        ostthlem1.3 $e |- ( ( ph /\ n e. ( ZZ>= ` 2 ) ) ->
          ( F ` n ) = ( G ` n ) ) $.
        $( Lemma for ~ ostth .  If two absolute values agree on the positive
           integers greater than one, then they agree for all rational numbers
           and thus are equal as functions.  (Contributed by Mario Carneiro,
           9-Sep-2014.) $)
        ostthlem1 $p |- ( ph -> F = G ) $=
          ( cq wcel cr cfv wceq cn cc0 fveq2 c1 vy vk wfn qrngbas abvf ffn 3syl
          wf cv cdiv co wrex cz elq wa cdr wne qdrng a1i adantr zq ad2antrl nnq
          cdvr ad2antll nnne0 qrng0 eqid abvdiv syl23anc w3o elz simprbi adantl
          cneg wi abv0 syl eqtr4d eqeq12d syl5ibrcom imp wral c2 elnn1uz2 qrng1
          cuz wo abv1 sylancr jaodan sylan2b ralrimiva rspccva cminusg ad2antrr
          sylan qrngneg eleq1d biimpar syl2anc ad2antlr 3eqtr3d 3jaodan adantrr
          abvneg mpdan adantrl oveq12d qrngdiv syl3anc fveq2d rexlimdvva syl5bi
          eqfnfvd ) AUALEFAEBMZLNEUHELUCIBLCEHCGUDZUELNEUFUGAFBMZLNFUHFLUCJBLCF
          HXQUELNFUFUGAUAUIZLMZXSEOZXSFOZPZXTXSUBUIZDUIZUJUKZPZDQULUBUMULAYCUBD
          XSUNAYGYCUBDUMQAYDUMMZYEQMZUOZUOZYCYGYFEOZYFFOZPYKYDYECVDOZUKZEOZYOFO
          ZYLYMYKYPYDEOZYEEOZUJUKZYQYKCUPMZXPYDLMZYELMZYERUQZYPYTPUUAYKCGURZUSZ
          AXPYJIUTYHUUBAYIYDVAZVBZYIUUCAYHYEVCVEZYIUUDAYHYEVFVEZBLYNCEYDYERHXQC
          GVGZYNVHZVIVJYKYQYDFOZYEFOZUJUKZYTYKUUAXRUUBUUCUUDYQUUOPUUFAXRYJJUTUU
          HUUIUUJBLYNCFYDYERHXQUUKUULVIVJYKYRUUMYSUUNUJAYHYRUUMPZYIAYHUOZYDRPZY
          DQMZYDVOZQMZVKZUUPYHUVBAYHYDNMUVBYDVLVMVNUUQUURUUPUUSUVAUUQUURUUPAUUR
          UUPVPYHAUUPUURREOZRFOZPAUVCRUVDAXPUVCRPIBCERHUUKVQVRAXRUVDRPJBCFRHUUK
          VQVRVSUURYRUVCUUMUVDYDRESYDRFSVTWAUTWBUUQYSUUNPZDQWCZUUSUUPAUVFYHAUVE
          DQYIAYETPZYEWDWGOMZWHUVEYEWEAUVGUVEUVHAUVGUVEAUVEUVGTEOZTFOZPAUVITUVJ
          AUUAXPUVITPUUEIBCTEHCGWFZWIWJAUUAXRUVJTPUUEJBCTFHUVKWIWJVSUVGYSUVIUUN
          UVJYETESYETFSVTWAWBKWKWLZWMZUTUVEUUPDYDQYEYDPYSYRUUNUUMYEYDESYEYDFSVT
          WNWQUUQUVAUOZYDCWOOZOZEOZUVPFOZYRUUMUVNUVFUVPQMZUVQUVRPZAUVFYHUVAUVMW
          PUUQUVSUVAUUQUVPUUTQUUQUUBUVPUUTPYHUUBAUUGVNCYDGWRVRWSWTUVEUVTDUVPQYE
          UVPPYSUVQUUNUVRYEUVPESYEUVPFSVTWNXAUVNXPUUBUVQYRPAXPYHUVAIWPYHUUBAUVA
          UUGXBZBLCEUVOYDHXQUVOVHZXFXAUVNXRUUBUVRUUMPAXRYHUVAJWPUWABLCFUVOYDHXQ
          UWBXFXAXCXDXGXEAYIUVEYHUVLXHXIVSVSYKYOYFEYKUUBUUCUUDYOYFPUUHUUIUUJCYD
          YEGXJXKZXLYKYOYFFUWCXLXCYGYAYLYBYMXSYFESXSYFFSVTWAXMXNWBXO $.
      $}

      ${
        ostthlem2.3 $e |- ( ( ph /\ p e. Prime ) ->
          ( F ` p ) = ( G ` p ) ) $.
        $( Lemma for ~ ostth .  Refine ~ ostthlem1 so that it is sufficient to
           only show equality on the primes.  (Contributed by Mario Carneiro,
           9-Sep-2014.)  (Revised by Mario Carneiro, 20-Jun-2015.) $)
        ostthlem2 $p |- ( ph -> F = G ) $=
          ( cfv wcel wceq c1 wi cmul fveq2 eqeq12d cq vn vy vz cv c2 cuz cn clt
          wbr eluz2b2 simplbi imbi2d cc0 wne ax-1ne0 qrng1 qrng0 sylancl eqtr4d
          co abv1z cprime expcom wa jcab oveq12 cz eluzelz ad2antrl zq ad2antll
          adantr syl qrngbas cvv cmulr qex ccnfld cnfldmul ax-mp abvmul syl3anc
          ressmulr syl5ibr a2d syl5bir prmind impcom sylan2 ostthlem1 ) ABCUADE
          GHIJUAUDZUEUFLZMZAWKUGMZWKDLZWKELZNZWMWNOWKUHUIWKUJUKWNAWQAFUDZDLZWRE
          LZNZPAODLZOELZNZPAUBUDZDLZXEELZNZPZAUCUDZDLZXJELZNZPZAXEXJQUTZDLZXOEL
          ZNZPZAWQPFUBUCWKWRONZXAXDAXTWSXBWTXCWRODRWROERSULWRXENZXAXHAYAWSXFWTX
          GWRXEDRWRXEERSULWRXJNZXAXMAYBWSXKWTXLWRXJDRWRXJERSULWRXONZXAXRAYCWSXP
          WTXQWRXODRWRXOERSULWRWKNZXAWQAYDWSWOWTWPWRWKDRWRWKERSULAXBOXCADBMZOUM
          UNZXBONIUOBCODUMHCGUPZCGUQZVAURAEBMZYFXCONJUOBCOEUMHYGYHVAURUSAWRVBMX
          AKVCXIXNVDAXHXMVDZPXEWLMZXJWLMZVDZXSAXHXMVEYMAYJXRAYMYJXRPYJXRAYMVDZX
          FXKQUTZXGXLQUTZNXFXGXKXLQVFYNXPYOXQYPYNYEXETMZXJTMZXPYONAYEYMIVLYNXEV
          GMZYQYKYSAYLUEXEVHVIXEVJVMZYNXJVGMZYRYLUUAAYKUEXJVHVKXJVJVMZBTCQDXEXJ
          HCGVNZTVOMQCVPLNVQTVRCQVOGVSWCVTZWAWBYNYIYQYRXQYPNAYIYMJVLYTUUBBTCQEX
          EXJHUUCUUDWAWBSWDVCWEWFWGWHWIWJ $.
      $}
    $}

    $( The regular absolute value function on the rationals is in fact an
       absolute value under our definition.  (Contributed by Mario Carneiro,
       9-Sep-2014.) $)
    qabsabv $p |- ( abs |` QQ ) e. A $=
      ( cabs ccnfld cabv cfv wcel cq csubrg cres absabv cress co qsubdrg simpli
      cdr eqid abvres mp2an ) EFGHZIJFKHIZEJLAIMUCFJNORIPQUBAJFBEUBSCDTUA $.

    ${
      padic.f $e |- F = ( x e. QQ |->
        if ( x = 0 , 0 , ( N ^ ( P pCnt x ) ) ) ) $.
      $( The p-adic absolute value (with arbitrary base) is an absolute value.
         (Contributed by Mario Carneiro, 9-Sep-2014.) $)
      padicabv $p |- ( ( P e. Prime /\ N e. ( 0 (,) 1 ) ) -> F e. A ) $=
        ( wcel cc0 co wa cq wceq cexp wbr syl cle adantr vy vz cprime cioo cmul
        caddc cabv cfv a1i cbs qrngbas cvv cplusg qex ccnfld cnfldadd ressplusg
        c1 mp1i cmulr cnfldmul ressmulr c0g qrng0 cdr crg qdrng drngrng cpc cif
        cv cr 0re wn ioossre simpr sseldi ad2antrr eliooord adantl simpld elrpd
        wne clt rpne0d cz df-ne pcqcl adantlr anassrs sylan2br reexpclzd ifclda
        fmptd 0z zq ax-mp iftrue c0ex fvmpt 3ad2ant1 3impb expgt0 syl3anc eqeq1
        w3a oveq2 oveq2d ifbieq2d ovex ifex 3ad2ant2 simp3 neneqd iffalse eqtrd
        breqtrrd pcqmul 3adant1r cc 3adant3 simp1l syl12anc syl2anc qcn oveq12d
        recnd zred ltexp2rd notbid lenltd 3bitr4d biimpa syldan rpexpcld rpge0d
        pcadd crp mpbid letrd simp3l simp3r syl22anc simp2l qmulcl simp2r 3expb
        expaddz mulne0d 3eqtr4d breq1d ifnefalse simp1 qaddcl readdcld addge01d
        simprd addcomd addge02d lecasei eqbrtrd rpaddcld pm2.61ne 3brtr4d
        isabvd ) CUCJZFKURUDLZJZMZUAUBBNUFDUEEKBDUGUHOUVIHUINDUJUHOUVIDGUKUINUL
        JZUFDUMUHOUVIUNNUFUODULGUPUQUSUVJUEDUTUHOUVIUNNUODUEULGVAVBUSKDVCUHOUVI
        DGVDUIDVEJDVFJUVIDGVGDVHUSUVIANAVKZKOZKFCUVKVILZPLZVJZVLEUVIUVKNJZMZUVL
        KUVNVLKVLJUVQUVLMVMUIUVQUVLVNZMFUVMUVIFVLJZUVPUVRUVIUVGVLFKURVOUVFUVHVP
        VQZVRUVIFKWCZUVPUVRUVIFUVIFUVTUVIKFWDQZFURWDQZUVHUWBUWCMUVFFKURVSVTZWAZ
        WBZWEZVRUVRUVQUVKKWCZUVMWFJZUVKKWGUVIUVPUWHUWIUVFUVPUWHMUWIUVHCUVKWHWIW
        JWKWLWMIWNKNJZKEUHKOUVIKWFJUWJWOKWPWQAKUVOKNEUVLKUVNWRIWSWTUSUVIUAVKZNJ
        ZUWKKWCZXFZKFCUWKVILZPLZUWKEUHZWDUWNUVSUWOWFJZUWBKUWPWDQUVIUWLUVSUWMUVT
        XAUVIUWLUWMUWRUVFUWLUWMMZUWRUVHCUWKWHWIZXBUVIUWLUWBUWMUWEXAFUWOXCXDUWNU
        WQUWKKOZKUWPVJZUWPUWLUVIUWQUXBOUWMAUWKUVOUXBNEUVKUWKOZUVLUXAUVNUWPKUVKU
        WKKXEUXCUVMUWOFPUVKUWKCVIXGXHXIIUXAKUWPWSFUWOPXJXKWTXLUWNUXAVNUXBUWPOUW
        NUWKKUVIUWLUWMXMXNUXAKUWPXORXPZXQUVIUWSUBVKZNJZUXEKWCZMZXFZFCUWKUXEUELZ
        VILZPLZUWPFCUXEVILZPLZUELZUXJEUHZUWQUXEEUHZUELUXIUXLFUWOUXMUFLZPLZUXOUX
        IUXKUXRFPUVFUWSUXHUXKUXROUVHUWKUXECXRXSXHUXIFXTJZUWAUWRUXMWFJZUXSUXOOUV
        IUWSUXTUXHUVIFUVTYGXAUVIUWSUWAUXHUWGXAZUVIUWSUWRUXHUWTYAZUXIUVFUXFUXGUY
        AUVFUVHUWSUXHYBZUVIUWSUXFUXGUUAZUVIUWSUXFUXGUUBZCUXEWHYCZFUWOUXMUUHUUCX
        PUXIUXPUXJKOZKUXLVJZUXLUXIUXJNJZUXPUYIOUXIUWLUXFUYJUVIUWLUWMUXHUUDZUYEU
        WKUXEUUEYDAUXJUVOUYINEUVKUXJOZUVLUYHUVNUXLKUVKUXJKXEUYLUVMUXKFPUVKUXJCV
        IXGXHXIIUYHKUXLWSFUXKPXJXKWTRUXIUYHVNUYIUXLOUXIUXJKUXIUWKUXEUXIUWLUWKXT
        JUYKUWKYERZUXIUXFUXEXTJUYEUXEYERZUVIUWLUWMUXHUUFUYFUUIXNUYHKUXLXORXPUXI
        UWQUWPUXQUXNUEUVIUWSUWQUWPOZUXHUVIUWLUWMUYOUXDUUGYAZUXIUXQUXEKOZKUXNVJZ
        UXNUXIUXFUXQUYROUYEAUXEUVOUYRNEUVKUXEOZUVLUYQUVNUXNKUVKUXEKXEUYSUVMUXMF
        PUVKUXECVIXGXHXIIUYQKUXNWSFUXMPXJXKWTRUXIUYQVNUYRUXNOUXIUXEKUYFXNUYQKUX
        NXORXPZYFUUJUXIUWKUXEUFLZKOZKFCVUAVILZPLZVJZUWPUXNUFLZVUAEUHZUWQUXQUFLS
        UXIVUEVUFSQKVUFSQVUAKVUBVUEKVUFSVUBKVUDWRUUKUXIVUAKWCZMZVUEVUDVUFSVUHVU
        EVUDOUXIVUAKKVUDUULVTVUIVUDVUFSQUWOUXMVUIUWOUXIUWRVUHUYCTZYHZVUIUXMUXIU
        YAVUHUYGTZYHZVUIUWOUXMSQZMZVUDUWPVUFVUOFVUCUXIUVSVUHVUNUXIUVIUVSUVIUWSU
        XHUUMZUVTRVRZUXIUWAVUHVUNUYBVRZVUIVUCWFJZVUNVUIUVFVUANJZVUHVUSUXIUVFVUH
        UYDTZUXIVUTVUHUXIUWLUXFVUTUYKUYEUWKUXEUUNYDZTUXIVUHVPCVUAWHYCZTWLVUOFUW
        OVUQVURVUIUWRVUNVUJTWLVUIVUFVLJZVUNVUIUWPUXNVUIFUWOVUIUVIUVSUXIUVIVUHVU
        PTZUVTRZVUIUVIUWAVVEUWGRZVUJWLZVUIFUXMVVFVVGVULWLZUUOZTVUIVUNUWOVUCSQZV
        UDUWPSQZVUOUWKUXECVUIUVFVUNVVATUXIUWLVUHVUNUYKVRUXIUXFVUHVUNUYEVRVUIVUN
        VPYQVUIVVKVVLVUIVUCUWOWDQZVNUWPVUDWDQZVNVVKVVLVUIVVMVVNVUIFVUCUWOVUIUVI
        FYRJZVVEUWFRZVUJVVCVUIUVIUWCVVEUVIUWBUWCUWDUUQRZYIYJVUIUWOVUCVUKVUIVUCV
        VCYHZYKVUIVUDUWPVUIFVUCVVFVVGVVCWLZVVHYKYLYMYNVUIUWPVUFSQZVUNVUIKUXNSQV
        VTVUIUXNUXIUXNYRJVUHUXIFUXMUXIUVIVVOVUPUWFRZUYGYOZTYPVUIUWPUXNVVHVVIUUP
        YSTYTVUIUXMUWOSQZMZVUDUXNVUFVUIVUDVLJVWCVVSTVUIUXNVLJVWCVVITVUIVVDVWCVV
        JTVUIVWCUXMVUCSQZVUDUXNSQZVWDUXMCUXEUWKUFLZVILZVUCSVWDUXEUWKCVUIUVFVWCV
        VATUXIUXFVUHVWCUYEVRUXIUWLVUHVWCUYKVRVUIVWCVPYQUXIVUCVWHOVUHVWCUXIVUAVW
        GCVIUXIUWKUXEUYMUYNUURXHVRXQVUIVWEVWFVUIVUCUXMWDQZVNUXNVUDWDQZVNVWEVWFV
        UIVWIVWJVUIFVUCUXMVVPVULVVCVVQYIYJVUIUXMVUCVUMVVRYKVUIVUDUXNVVSVVIYKYLY
        MYNVUIUXNVUFSQZVWCVUIKUWPSQVWKVUIUWPUXIUWPYRJVUHUXIFUWOVWAUYCYOZTYPVUIU
        XNUWPVVIVVHUUSYSTYTUUTUVAUXIVUFUXIUWPUXNVWLVWBUVBYPUVCUXIVUTVUGVUEOVVBA
        VUAUVOVUENEUVKVUAOZUVLVUBUVNVUDKUVKVUAKXEVWMUVMVUCFPUVKVUACVIXGXHXIIVUB
        KVUDWSFVUCPXJXKWTRUXIUWQUWPUXQUXNUFUYPUYTYFUVDUVE $.
    $}

    padic.j $e |- J = ( q e. Prime |-> ( x e. QQ |->
      if ( x = 0 , 0 , ( q ^ -u ( q pCnt x ) ) ) ) ) $.
    $( The p-adic absolute value is an absolute value.  (Contributed by Mario
       Carneiro, 9-Sep-2014.) $)
    padicabvf $p |- J : Prime --> A $=
      ( vp cprime cv wcel cq cc0 co cexp cif cmpt c1 wa wf wfn cfv wral cpc qex
      wceq cneg mptex fnmpti padicfval wn cn prmnn ad2antrr nncnd nnne0d wne cz
      cdiv df-ne pcqcl anassrs sylan2br expnegd exprecd ifeq2da mpteq2dva eqtrd
      eqtr4d cioo clt wbr nnrecred nnred cuz prmuz2 eluz2b2 simprbi syl recgt1i
      cr c2 syl2anc simpld simprd cxr w3a wb 0xr 1re rexri mp2an syl3anbrc eqid
      elioo2 padicabv mpdan eqeltrd rgen ffnfv mpbir2an ) JBDUADJUBIKZDUCZBLZIJ
      UDEJAMAKZNUGZNEKZXHXFUEOUHPOQZRDAMXIUFUIHUJXEIJXCJLZXDAMXGNSXCUTOZXCXFUEO
      ZPOZQZRZBXJXDAMXGNXCXLUHPOZQZRXOAXCDEHUKXJAMXQXNXJXFMLZTZXGXPXMNXSXGULZTZ
      XPSXCXLPOUTOXMYAXCXLYAXCXJXCUMLZXRXTXCUNZUOZUPZYAXCYDUQZXTXSXFNURZXLUSLZX
      FNVAXJXRYGYHXCXFVBVCVDZVEYAXCXLYEYFYIVFVJVGVHVIXJXKNSVKOLZXOBLXJXKWBLZNXK
      VLVMZXKSVLVMZYJXJXCYCVNXJYLYMXJXCWBLSXCVLVMZYLYMTXJXCYCVOXJXCWCVPUCLZYNXC
      VQYOYBYNXCVRVSVTXCWAWDZWEXJYLYMYPWFNWGLSWGLYJYKYLYMWHWIWJSWKWLNSXKWPWMWNA
      BXCCXOXKFGXOWOWQWRWSWTIJBDXAXB $.

    $( All positive powers of the p-adic absolute value are absolute values.
       (Contributed by Mario Carneiro, 9-Sep-2014.) $)
    padicabvcxp $p |- ( ( P e. Prime /\ R e. RR+ ) ->
      ( y e. QQ |-> ( ( ( J ` P ) ` y ) ^c R ) ) e. A ) $=
      ( wcel wa ccxp co cc0 adantr c1 clt wbr cprime crp cfv cmpt wceq cneg cpc
      cq cv cexp cif padicval adantlr oveq1d oveq1 ifsb rpre adantl recnd rpne0
      cr wne 0cxpd ifeq1d syl5eq wn df-ne cmul cc cz pcqcl zcnd mulneg12 negcld
      syl2anc mulcomd eqtrd oveq2d cn c2 cuz prmuz2 eluz2b2 sylib nnrpd znegcld
      simpld zred cxpmuld renegcld 3eqtr3d nnred nnne0d cxpexpzd rpcxpcld rpcnd
      syl anassrs sylan2br ifeq2da mpteq2dva cioo rpgt0 lt0neg2d simprd 0re a1i
      mpbid cxpltd cxp0d breqtrd cxr w3a wb 0xr 1re rexri elioo2 syl3anbrc eqid
      mp2an padicabv syldan eqeltrd ) DUALZFUBLZMZBUHBUIZDGUCUCZFNOZUDBUHYHPUEZ
      PDFUFZNOZDYHUGOZUJOZUKZUDZCYGBUHYJYPYGYHUHLZMZYJYKPDYNUFZUJOZUKZFNOZYPYSY
      IUUBFNYEYRYIUUBUEYFADGYHHKULUMUNYSUUCYKPUUAFNOZUKZYPYSUUCYKPFNOZUUDUKUUEY
      KPUUAUUCUUFUUDUUBPFNUOUUBUUAFNUOUPYSYKUUFPUUDYGUUFPUEYRYGFYGFYFFVALYEFUQU
      RZUSZYFFPVBYEFUTURVCQVDVEYSYKUUDYOPYKVFYSYHPVBZUUDYOUEZYHPVGYGYRUUIUUJYGY
      RUUIMZMZDYTNOZFNOZYMYNNOZUUDYOUULDYTFVHOZNODYLYNVHOZNOUUNUUOUULUUPUUQDNUU
      LUUPYNYLVHOZUUQUULYNVILFVILZUUPUURUEUULYNYEUUKYNVJLYFDYHVKUMZVLZYGUUSUUKU
      UHQZYNFVMVOUULYNYLUVAUULFUVBVNVPVQVRUULDYTFYGDUBLUUKYGDYGDVSLZRDSTZYGDVTW
      AUCLZUVCUVDMYEUVEYFDWBQDWCWDZWGZWEZQZUULYTUULYNUUTWFZWHUVBWIUULDYLYNUVIYG
      YLVALUUKYGFUUGWJZQUVAWIWKUULUUMUUAFNUULDYTYGDVILUUKYGDYGDUVGWLZUSZQYGDPVB
      UUKYGDUVGWMQUVJWNUNUULYMYNUULYMYGYMUBLZUUKYGDYLUVHUVKWOZQZWPUULUVNYMPVBUV
      PYMUTWQUUTWNWKWRWSWTVQVQXAYEYFYMPRXBOLZYQCLYGYMVALZPYMSTZYMRSTZUVQYGUVNUV
      RUVOYMUQWQYGUVNUVSUVOYMXCWQYGYMDPNOZRSYGYLPSTZYMUWASTYGPFSTZUWBYFUWCYEFXC
      URYGFUUGXDXHYGDYLPUVLYGUVCUVDUVFXEUVKPVALYGXFXGXIXHYGDUVMXJXKPXLLRXLLUVQU
      VRUVSUVTXMXNXORXPXQPRYMXRYAXSBCDEYQYMIJYQXTYBYCYD $.

    ostth.k $e |- K = ( x e. QQ |-> if ( x = 0 , 0 , 1 ) ) $.
    $d x F $.
    ${
      ostth.1 $e |- ( ph -> F e. A ) $.
      ${
        ostth1.2 $e |- ( ph -> A. n e. NN -. 1 < ( F ` n ) ) $.
        ostth1.3 $e |- ( ph -> A. n e. Prime -. ( F ` n ) < 1 ) $.
        $( - Lemma for ~ ostth : trivial case.  (Not that the proof is trivial,
           but that we are proving that the function is trivial.)  If ` F ` is
           equal to ` 1 ` on the primes, then by complete induction and the
           multiplicative property ~ abvmul of the absolute value, ` F ` is
           equal to ` 1 ` on all the integers, and ~ ostthlem1 extends this to
           the other rational numbers.  (Contributed by Mario Carneiro,
           10-Sep-2014.) $)
        ostth1 $p |- ( ph -> F = K ) $=
          ( wcel cc0 c1 wceq cdr qdrng cq qrngbas qrng0 abvtriv mp1i cprime cfv
          cv wa clt wbr wn r19.21bi cn prmnn sylan2 cr nnq syl abvcl syl2an 1re
          lttri3 sylancl mpbir2and adantl cif eqeq1 ifbid c0ex ifex fvmpt nnne0
          wb 1ex neneqd iffalse eqtrd eqtr4d ostthlem2 ) ACDFHEJKNDUAQHCQADJUBB
          CUCDHRKDJUDZDJUEMUFUGAEUJZUHQZUKZWDFUIZSWDHUIZWFWGSTZWGSULUMUNZSWGULU
          MUNZAWJEUHPUOWEAWDUPQZWKWDUQZAWKEUPOUOURWFWGUSQZSUSQWIWJWKUKVPAFCQWDU
          CQZWNWENWEWLWOWMWDUTZVACUCDFWDKWCVBVCVDWGSVEVFVGWFWLWHSTWEWLAWMVHWLWH
          WDRTZRSVIZSWLWOWHWRTWPBWDBUJZRTZRSVIWRUCHWSWDTWTWQRSWSWDRVJVKMWQRSVLV
          QVMVNVAWLWQUNWRSTWLWDRWDVOVRWQRSVSVAVTVAWAWB $.
      $}

      ${
        ostth2.2 $e |- ( ph -> N e. ( ZZ>= ` 2 ) ) $.
        ostth2.3 $e |- ( ph -> 1 < ( F ` N ) ) $.
        ostth2.4 $e |- R = ( ( log ` ( F ` N ) ) / ( log ` N ) ) $.
        ${
          ostth2.5 $e |- ( ph -> M e. ( ZZ>= ` 2 ) ) $.
          ostth2.6 $e |- S = ( ( log ` ( F ` M ) ) / ( log ` M ) ) $.
          ostth2.7 $e |- T = if ( ( F ` M ) <_ 1 , 1 , ( F ` M ) ) $.
          $( Lemma for ~ ostth2 .  (Contributed by Mario Carneiro,
             10-Sep-2014.) $)
          ostth2lem2 $p |- ( ( ph /\ X e. NN0 /\
            Y e. ( 0 ... ( ( M ^ X ) - 1 ) ) ) ->
              ( F ` Y ) <_ ( ( M x. X ) x. ( T ^ X ) ) ) $=
            ( vk vn vj cn0 wcel cc0 cexp co c1 cmin cfz cfv cmul cle wa cv wral
            wbr wi caddc wceq oveq1d oveq2d oveq12d breq2d raleqbidv imbi2d weq
            oveq2 c2 cuz cn clt eluz2b2 simplbi nncnd exp0d 1m1e0 syl6eq eleq2d
            syl 0le0 a1i qrng0 abv0 mul01d cc cif cr 1re cq nnq qrngbas syl2anc
            abvcl ifcl sylancr syl5eqel recnd 0nn0 expcl sylancl mul02d 3brtr4d
            eqtrd elfz1eq fveq2d breq1d sylbid ralrimiv fveq2 ad2antrr ad2antrl
            syl5ibrcom cz zq nnexpcld reexpcld zred remulcld nnred ad2antlr cvv
            ccnfld ax-mp syl3anc nngt0d wb nnzd mpbid syl112anc letrd syl6breqr
            qex cbvralv cmo cdiv elfzelz simplr zmodcld nn0zd nndivred readdcld
            cfl flcld nn0p1nn peano2nn0 qmulcl cplusg cnfldadd ressplusg abvtri
            crp nnrpd modval qcn npcand cmulr cnfldmul ressmulr qabvexp 3brtr3d
            abvmul nn0re zmodfz simprr rspcv sylc mulcomd abvge0 expge0d divge0
            elfzle1 syl22anc qabvle w3a simprl 0z elfzm11 simp3d expp1d breqtrd
            flge0nn0 ltdivmul mpbird fllt ltled lemul1ad eqbrtrd nnnn0d nn0ge0d
            max1 leexp1a syl32anc lemul2ad le2addd ax-1cn adddid mulid1d mulcld
            nn0cn adddird breqtrrd max2 nn0z uzid peano2uz leexp2ad lemul2 expr
            nnmulcld ralrimdva syl5bi expcom a2d nn0ind impcom rspccv 3impia )
            AMUJUKZNULKMUMUNZUOUPUNZUQUNZUKZNHURZKMUSUNZGMUMUNZUSUNZUTVDZAUYFVA
            UGVBZHURZUYNUTVDZUGUYIVCZUYJUYOVEUYFAUYSAUYQKBVBZUSUNZGUYTUMUNZUSUN
            ZUTVDZUGULKUYTUMUNZUOUPUNZUQUNZVCZVEAUYQKULUSUNZGULUMUNZUSUNZUTVDZU
            GULKULUMUNZUOUPUNZUQUNZVCZVEAUYQKUHVBZUSUNZGVUQUMUNZUSUNZUTVDZUGULK
            VUQUMUNZUOUPUNZUQUNZVCZVEAUYQKVUQUOVFUNZUSUNZGVVFUMUNZUSUNZUTVDZUGU
            LKVVFUMUNZUOUPUNZUQUNZVCZVEAUYSVEBUHMUYTULVGZVUHVUPAVVOVUDVULUGVUGV
            UOVVOVUFVUNULUQVVOVUEVUMUOUPUYTULKUMVOVHVIVVOVUCVUKUYQUTVVOVUAVUIVU
            BVUJUSUYTULKUSVOUYTULGUMVOVJVKVLVMBUHVNZVUHVVEAVVPVUDVVAUGVUGVVDVVP
            VUFVVCULUQVVPVUEVVBUOUPUYTVUQKUMVOVHVIVVPVUCVUTUYQUTVVPVUAVURVUBVUS
            USUYTVUQKUSVOUYTVUQGUMVOVJVKVLVMUYTVVFVGZVUHVVNAVVQVUDVVJUGVUGVVMVV
            QVUFVVLULUQVVQVUEVVKUOUPUYTVVFKUMVOVHVIVVQVUCVVIUYQUTVVQVUAVVGVUBVV
            HUSUYTVVFKUSVOUYTVVFGUMVOVJVKVLVMUYTMVGZVUHUYSAVVRVUDUYRUGVUGUYIVVR
            VUFUYHULUQVVRVUEUYGUOUPUYTMKUMVOVHVIVVRVUCUYNUYQUTVVRVUAUYLVUBUYMUS
            UYTMKUSVOUYTMGUMVOVJVKVLVMAVULUGVUOAUYPVUOUKUYPULULUQUNZUKZVULAVUOV
            VSUYPAVUNULULUQAVUNUOUOUPUNULAVUMUOUOUPAKAKAKVPVQURUKZKVRUKZUDVWAVW
            BUOKVSVDKVTWAWGZWBZWCVHWDWEVIWFAVULVVTULHURZVUKUTVDAULULVWEVUKUTULU
            LUTVDAWHWIAHCUKZVWEULVGTCDHULQDPWJWKWGAVUKULVUJUSUNULAVUIULVUJUSAKV
            WDWLVHAVUJAGWMUKULUJUKVUJWMUKAGAGKHURZUOUTVDZUOVWGWNZWOUFAUOWOUKZVW
            GWOUKZVWIWOUKWPAVWFKWQUKZVWKTAVWBVWLVWCKWRZWGCWQDHKQDPWSZXAZWTVWHUO
            VWGWOXBXCXDZXEXFGULXGXHXIXKXJVVTUYQVWEVUKUTVVTUYPULHUYPULXLXMXNXTXO
            XPVUQUJUKZAVVEVVNAVWQVVEVVNVEVVEUIVBZHURZVUTUTVDZUIVVDVCZAVWQVAZVVN
            VVAVWTUGUIVVDUGUIVNUYQVWSVUTUTUYPVWRHXQXNUUAVXBVXAVVJUGVVMVXBUYPVVM
            UKZVXAVVJVXBVXCVXAVAZVAZUYQUYPVVBUUBUNZHURZVWGVUQUMUNZUYPVVBUUCUNZU
            UJURZHURZUSUNZVFUNZVVIVXEVWFUYPWQUKZUYQWOUKAVWFVWQVXDTXRZVXEUYPYAUK
            ZVXNVXCVXPVXBVXAUYPULVVLUUDXSZUYPYBWGCWQDHUYPQVWNXAWTVXEVXGVXLVXEVW
            FVXFWQUKZVXGWOUKVXOVXEVXFYAUKVXRVXEVXFVXEUYPVVBVXQVXEKVUQAVWBVWQVXD
            VWCXRZAVWQVXDUUEZYCZUUFUUGVXFYBWGZCWQDHVXFQVWNXAWTZVXEVXHVXKVXEVWGV
            UQVXEVWFVWLVWKVXOVXEVWBVWLVXSVWMWGZVWOWTZVXTYDZVXEVWFVXJWQUKZVXKWOU
            KVXOVXEVXJYAUKVYGVXEVXIVXEUYPVVBVXEUYPVXQYEZVYAUUHZUUKZVXJYBWGZCWQD
            HVXJQVWNXAWTZYFZUUIZVXEVVGVVHVXEKVVFVXEKVXSYGZVXEVVFVWQVVFVRUKAVXDV
            UQUULYHZYGYFZVXEGVVFAGWOUKZVWQVXDVWPXRZVWQVVFUJUKAVXDVUQUUMYHZYDZYF
            ZVXEVXFVVBVXJUSUNZVFUNZHURZVXGWUCHURZVFUNZUYQVXMUTVXEVWFVXRWUCWQUKZ
            WUEWUGUTVDVXOVYBVXEVVBWQUKZVYGWUHVXEVVBVRUKZWUIVYAVVBWRWGZVYKVVBVXJ
            UUNWTZCWQVFDHVXFWUCQVWNWQYIUKZVFDUUOURVGYTWQVFYJDYIPUUPUUQYKUURYLVX
            EWUDUYPHVXEWUDUYPWUCUPUNZWUCVFUNUYPVXEVXFWUNWUCVFVXEUYPWOUKZVVBUUSU
            KVXFWUNVGVYHVXEVVBVYAUUTUYPVVBUVAWTVHVXEUYPWUCVXEUYPVYHXEVXEWUHWUCW
            MUKWULWUCUVBWGUVCXKXMVXEWUFVXLVXGVFVXEWUFVVBHURZVXKUSUNZVXLVXEVWFWU
            IVYGWUFWUQVGVXOWUKVYKCWQDUSHVVBVXJQVWNWUMUSDUVDURVGYTWQYJDUSYIPUVEU
            VFYKUVIYLVXEWUPVXHVXKUSVXEVWFVWLVWQWUPVXHVGVXOVYDVXTCDHKVUQPQUVGYLV
            HXKVIUVHVXEVXMVVGVUSUSUNZVVIVYNVXEVVGVUSVYQVXEGVUQVYSVXTYDZYFWUBVXE
            VXMVUTKVUSUSUNZVFUNZWURUTVXEVXGVXLVUTWUTVYCVYMVXEVURVUSVXEKVUQVYOVW
            QVUQWOUKAVXDVUQUVJYHYFWUSYFVXEKVUSVYOWUSYFZVXEVXFVVDUKZVXAVXGVUTUTV
            DZVXEVXPWUJWVCVXQVYAUYPVVBUVKWTVXBVXCVXAUVLVWTWVDUIVXFVVDVWRVXFVGVW
            SVXGVUTUTVWRVXFHXQXNUVMUVNVXEVXLKVXHUSUNZWUTVYMVXEKVXHVYOVYFYFWVBVX
            EVXLVXKVXHUSUNWVEUTVXEVXHVXKVXEVXHVYFXEVXEVXKVYLXEUVOVXEVXKKVXHVYLV
            YOVYFVXEVWGVUQVYEVXTVXEVWFVWLULVWGUTVDZVXOVYDCWQDHKQVWNUVPWTZUVQVXE
            VXKVXJKVYLVXEVXJVYJYEZVYOVXEVWFVXJUJUKZVXKVXJUTVDVXOVXEVXIWOUKZULVX
            IUTVDZWVIVYIVXEWUOULUYPUTVDZVVBWOUKZULVVBVSVDZWVKVYHVXCWVLVXBVXAUYP
            ULVVLUVSXSVXEVVBVYAYGZVXEVVBVYAYMZUYPVVBUVRUVTVXIUWIWTCDHVXJPQUWAWT
            VXEVXJKWVHVYOVXEVXIKVSVDZVXJKVSVDZVXEWVQUYPVVBKUSUNZVSVDZVXEUYPVVKW
            VSVSVXEVXPWVLUYPVVKVSVDZVXEVXCVXPWVLWWAUWBZVXBVXCVXAUWCVXEULYAUKVVK
            YAUKVXCWWBYNUWDVXEVVKVXEKVVFVXSVYTYCYOUYPULVVKUWEXCYPUWFVXEKVUQVXEK
            VXSWBZVXTUWGUWHVXEWUOKWOUKWVMWVNWVQWVTYNVYHVYOWVOWVPUYPKVVBUWJYQUWK
            VXEWVJKYAUKWVQWVRYNVYIVXEKVXSYOVXIKUWLWTYPUWMYRUWNUWOVXEVXHVUSKVYFW
            USVYOVXEKVXEKVXSUWPUWQVXEVWKVYRVWQWVFVWGGUTVDVXHVUSUTVDVYEVYSVXTWVG
            VXEVWGVWIGUTVXEVWKVWJVWGVWIUTVDVYEWPVWGUOUWRXHUFYSVWGGVUQUWSUWTUXAY
            RUXBVXEWURVURKVFUNZVUSUSUNWVAVXEVVGWWDVUSUSVXEVVGVURKUOUSUNZVFUNWWD
            VXEKVUQUOWWCVWQVUQWMUKAVXDVUQUXGYHZUOWMUKVXEUXCWIUXDVXEWWEKVURVFVXE
            KWWCUXEVIXKVHVXEVURKVUSVXEKVUQWWCWWFUXFWWCVXEVUSWUSXEUXHXKUXIVXEVUS
            VVHUTVDZWURVVIUTVDZVXEGVUQVVFVYSVXEUOVWIGUTVXEVWKVWJUOVWIUTVDVYEWPV
            WGUOUXJXHUFYSVXEVUQVUQVQURZUKZVVFWWIUKVXEVUQYAUKZWWJVWQWWKAVXDVUQUX
            KYHVUQUXLWGVUQVUQUXMWGUXNVXEVUSWOUKVVHWOUKVVGWOUKULVVGVSVDWWGWWHYNW
            USWUAVYQVXEVVGVXEKVVFVXSVYPUXQYMVUSVVHVVGUXOYQYPYRYRUXPUXRUXSUXTUYA
            UYBUYCUYRUYOUGNUYIUYPNVGUYQUYKUYNUTUYPNHXQXNUYDWGUYE $.

          ostth2.8 $e |- U = ( ( log ` N ) / ( log ` M ) ) $.
          $( Lemma for ~ ostth2 .  (Contributed by Mario Carneiro,
             10-Sep-2014.) $)
          ostth2lem3 $p |- ( ( ph /\ X e. NN ) ->
            ( ( ( F ` N ) / ( T ^c U ) ) ^ X ) <_
            ( X x. ( ( M x. T ) x. ( U + 1 ) ) ) ) $=
            ( cn wcel wa cfv ccxp co cdiv cexp cmul c1 caddc cle cr clt wbr cuz
            cq c2 eluz2b2 sylib simpld nnq syl qrngbas abvcl syl2anc adantr cif
            recnd 1re ifcl sylancr syl5eqel cc0 0re 0lt1 max2 syl6breqr ltletrd
            a1i elrpd rpge0d clog nnred simprd rplogcld rpdivcld rpred recxpcld
            crp rpcxpcld rpne0d cn0 adantl expdivd reexpcl syl2an nnre remulcld
            nnnn0 cfl nn0ge0d mulge0d flge0nn0 peano2nn0 reexpcld peano2re wceq
            nn0red qabvexp syl3anc cmin ce cc mulcld eqbrtrrd wb mpbid cz nnrpd
            reexplog mpbird oveq2d eqtrd letrd lemul2 syl112anc breqtrd eqbrtrd
            cfz cxpexp mulgt0d mul12d divassd oveq2i syl6eqr oveq1d eqtr3d eflt
            divcan1d flltp1 ltmul1dd nnz nn0zd 3brtr4d nnexpcld nnltlem1 nnnn0d
            nnexpcl nn0uz syl6eleq nnzd peano2zm elfz5 ostth2lem2 3expia syldan
            wi mpd flle leadd1dd leadd2dd adddid mulid1d breqtrrd nngt0d expgt0
            nnge1 lemul1 expp1d remulcl mulcomd cxplead cxpmuld 3brtr3d lemul1d
            nngt0 rpgt0d ltp1d lttrd mul32d rpexpcld ledivmuld ) ANUHUIZUJZMIUK
            ZGHULUMZUNUMNUOUMUWMNUOUMZUWNNUOUMZUNUMZNLGUPUMZHUQURUMZUPUMZUPUMZU
            SUWLUWMUWNNUWLUWMAUWMUTUIZUWKAICUIZMVDUIZUXBTAMUHUIZUXDAUXEUQMVAVBZ
            AMVEVCUKZUIUXEUXFUJUAMVFVGZVHZMVIVJZCVDDIMQDPVKZVLVMZVNVPUWLUWNUWLG
            HAGUTUIZUWKAGLIUKZUQUSVBZUQUXNVOZUTUFAUQUTUIZUXNUTUIZUXPUTUIVQAUXCL
            VDUIZUXRTALUHUIZUXSAUXTUQLVAVBZALUXGUIUXTUYAUJUDLVFVGZVHZLVIVJCVDDI
            LQUXKVLVMZUXOUQUXNUTVRVSVTZVNZUWLGUWLGUYFAWAGVAVBZUWKAWAUQGWAUTUIZA
            WBWGUXQAVQWGZUYEWAUQVAVBAWCWGAUQUXPGUSAUXRUXQUQUXPUSVBUYDUYIUXNUQWD
            VMUFWEZWFVNZWHZWIAHUTUIZUWKAHAHMWJUKZLWJUKZUNUMZWQUGAUYNUYOAMAMUXIW
            KAUXEUXFUXHWLWMZALALUYCWKAUXTUYAUYBWLWMZWNVTZWOZVNZWPZVPZUWLUWNUWLG
            HUYLVUAWRZWSUWKNWTUIZANXGZXAZXBUWLUWQUXAUSVBUWOUWPUXAUPUMZUSVBUWLUW
            OLNUWSUPUMZUPUMZUWPGUPUMZUPUMZVUHUSUWLUWOLNHUPUMZXHUKZUQURUMZUPUMZG
            VUOUOUMZUPUMZVULAUXBVUEUWOUTUIUWKUXLVUFUWMNXCXDZUWLVUPVUQUWLLVUOUWL
            LAUXTUWKUYCVNZWKZUWLVUOUWLVUNWTUIZVUOWTUIZUWLVUMUTUIZWAVUMUSVBVVBUW
            LNHUWKNUTUIZANXEZXAZVUAXFZUWLNHVVGVUAUWLNVUGXIAWAHUSVBUWKAHUYSWIVNX
            JVUMXKVMZVUNXLVJZXPZXFZUWLGVUOUYFVVJXMZXFZUWLVUJVUKUWLLVUIVVAUWLNUW
            SVVGUWLUYMUWSUTUIVUAHXNVJZXFZXFZUWLUWPGUWLUWNNVUBVUGXMZUYFXFZXFZUWL
            MNUOUMZIUKZUWOVURUSUWLUXCUXDVUEVWBUWOXOAUXCUWKTVNAUXDUWKUXJVNVUGCDI
            MNPQXQXRUWLVWAWALVUOUOUMZUQXSUMZYQUMUIZVWBVURUSVBZUWLVWEVWAVWDUSVBZ
            UWLVWAVWCVAVBZVWGUWLNUYNUPUMZXTUKZVUOUYOUPUMZXTUKZVWAVWCVAUWLVWIVWK
            VAVBZVWJVWLVAVBZUWLVUMUYOUPUMZVWIVWKVAUWLVWIUYOUNUMZUYOUPUMVWOVWIUW
            LVWPVUMUYOUPUWLVWPNUYPUPUMVUMUWLNUYNUYOUWLNVVGVPZAUYNYAUIUWKAUYNAUY
            NUYQWOZVPVNZAUYOYAUIUWKAUYOAUYOUYRWOZVPVNZUWLUYOAUYOWQUIUWKUYRVNZWS
            ZUUAHUYPNUPUGUUBUUCUUDUWLVWIUYOUWLNUYNVWQVWSYBVXAVXCUUGUUEUWLVUMVUO
            UYOVVHVVKVXBUWLVVDVUMVUOVAVBVVHVUMUUHVJUUIYCUWLVWIUTUIVWKUTUIVWMVWN
            YDUWLNUYNVVGAUYNUTUIUWKVWRVNXFUWLVUOUYOVVKAUYOUTUIUWKVWTVNXFVWIVWKU
            UFVMYEAMWQUINYFUIZVWAVWJXOUWKAMUXIYGNUUJZMNYHXDUWLLWQUIVUOYFUIZVWCV
            WLXOUWLLVUTYGUWLVUOVVJUUKZLVUOYHVMUULUWLVWAUHUIZVWCUHUIVWHVWGYDAUXE
            VUEVXHUWKUXIVUFMNUUPXDZUWLLVUOVUTVVJUUMZVWAVWCUUNVMYEUWLVWAWAVCUKZU
            IVWDYFUIZVWEVWGYDUWLVWAWTVXKUWLVWAVXIUUOUUQUURUWLVWCYFUIVXLUWLVWCVX
            JUUSVWCUUTVJVWAWAVWDUVAVMYIAUWKVVCVWEVWFUVEVVJAVVCVWEVWFABCDEFGIJKL
            MVUOVWAOPQRSTUAUBUCUDUEUFUVBUVCUVDUVFYCUWLVURVUJVUQUPUMZVULVVNUWLVU
            JVUQVVQVVMXFVVTUWLVUPVUJUSVBZVURVXMUSVBZUWLVUOVUIUSVBZVXNUWLVUOVUMU
            QURUMZVUIVVKUWLVVDVXQUTUIVVHVUMXNVJVVPUWLVUNVUMUQUWLVUNVVIXPZVVHUXQ
            UWLVQWGZUWLVVDVUNVUMUSVBVVHVUMUVGVJZUVHUWLVXQVUMNURUMZVUIUSUWLUQNVU
            MVXSVVGVVHUWKUQNUSVBANUVOXAUVIUWLVUIVUMNUQUPUMZURUMVYAUWLNHUQVWQUWL
            HVUAVPZUWLUQVXSVPUVJUWLVYBNVUMURUWLNVWQUVKYJYKUVLYLUWLVUOUTUIVUIUTU
            ILUTUIWALVAVBVXPVXNYDVVKVVPVVAUWLLVUTUVMZVUOVUILYMYNYEUWLVUPUTUIVUJ
            UTUIZVUQUTUIZWAVUQVAVBZVXNVXOYDVVLVVQVVMUWLUXMVXFUYGVYGUYFVXGUYKGVU
            OUVNXRVUPVUJVUQUVPYNYEUWLVUQVUKUSVBZVXMVULUSVBZUWLVUQGVUNUOUMZGUPUM
            ZVUKUSUWLGVUNUWLGUYFVPZVVIUVQUWLVYJUWPUSVBVYKVUKUSVBUWLGVUNULUMZGHN
            UPUMZULUMZVYJUWPUSUWLGVUNVYNUYFAUQGUSVBUWKUYJVNVXRAUYMVVEVYNUTUIUWK
            UYTVVFHNUVRXDUWLVUNVUMVYNUSVXTUWLNHVWQVYCUVSYOUVTUWLGYAUIVVBVYMVYJX
            OVYLVVIGVUNYRVMUWLVYOUWNNULUMZUWPUWLGHNUYLVUAVWQUWAUWLUWNYAUIVUEVYP
            UWPXOVUCVUGUWNNYRVMYKUWBUWLVYJUWPGUWLGVUNUYFVVIXMVVRUYLUWCYEYPUWLVY
            FVUKUTUIVYEWAVUJVAVBVYHVYIYDVVMVVSVVQUWLLVUIVVAVVPVYDUWLNUWSVVGVVOU
            WKWANVAVBANUWDXAUWLWAHUWSUYHUWLWBWGVUAVVOUWLHAHWQUIUWKUYSVNUWEUWLHV
            UAUWFUWGYSYSVUQVUKVUJYMYNYEYLYLUWLVULUWPVUJGUPUMZUPUMVUHUWLVUJUWPGU
            WLVUJVVQVPUWLUWPVVRVPVYLYTUWLVYQUXAUWPUPUWLVYQUWRVUIUPUMUXAUWLLVUIG
            UWLLVVAVPZUWLVUIVVPVPVYLUWHUWLUWRNUWSUWLLGVYRVYLYBVWQUWLUWSVVOVPYTY
            KYJYKYOUWLUWOUXAUWPVUSUWLNUWTVVGUWLUWRUWSUWLLGVVAUYFXFVVOXFXFUWLUWN
            NVUDUWKVXDAVXEXAUWIUWJYIYP $.

          $( Lemma for ~ ostth2 .  (Contributed by Mario Carneiro,
             10-Sep-2014.) $)
          ostth2lem4 $p |- ( ph -> ( 1 < ( F ` M ) /\ R <_ S ) ) $=
            ( vn c1 cfv clt wbr cle wn cr wcel wb 1re cq cn c2 wa eluz2b2 sylib
            cuz simpld nnq syl qrngbas abvcl syl2anc ltnle sylancr ccxp co cmul
            mpbid cdiv caddc cif ifcl syl5eqel cc0 0re a1i 0lt1 sylancl ltletrd
            max2 syl6breqr elrpd clog nnrpd relogcld simprd rplogcld rerpdivcld
            nnred rpcxpcld remulcld peano2re cv ostth2lem3 ostth2lem1 ledivmuld
            rpcnd mulid1d breqtrd adantr iftrue syl5eq oveq1d recnd 1cxpd mtand
            sylan9eqr mpbird ce lttrd wceq iffalse rpne0d cxpefd eqtr2d 3brtr4d
            reeflogd efle div12d oveq2i syl6eqr mulcomd eqtrd breqtrrd 3brtr4g
            jca ) AUHLIUIZUJUKZEFULUKAYPYOUHULUKZUMZAYQMIUIZUHULUKZAUHYSUJUKZYT
            UMZUAAUHUNUOZYSUNUOZUUAUUBUPUQAICUOZMURUOZUUDSAMUSUOZUUFAUUGUHMUJUK
            ZAMUTVDUIZUOUUGUUHVATMVBVCZVEZMVFVGCURDIMPDOVHZVIVJZUHYSVKVLVPAYQVA
            YSGHVMVNZUHULAYSUUNULUKYQAYSUUNUHVOVNZUUNULAYSUUNVQVNZUHULUKYSUUOUL
            UKAUUPLGVOVNZHUHVRVNZVOVNUGAYSUUNUUMAGHAGAGYQUHYOVSZUNUEAUUCYOUNUOZ
            UUSUNUOUQAUUELURUOZUUTSALUSUOZUVAAUVBUHLUJUKZALUUIUOUVBUVCVAUCLVBVC
            ZVEZLVFVGCURDILPUULVIVJZYQUHYOUNVTVLWAZAWBUHGWBUNUOAWCWDZUUCAUQWDZU
            VGWBUHUJUKAWEWDZAUHUUSGULAUUTUUCUHUUSULUKUVFUQYOUHWHWFUEWIWGWJAHMWK
            UIZLWKUIZVQVNZUNUFAUVKUVLAMAMUUKWLWMZALALUVEWQZAUVBUVCUVDWNWOZWPWAZ
            WRZWPAUUQUURALGUVOUVGWSAHUNUOUURUNUOUVQHWTVGWSABCDEFGHIJKLMUGXANOPQ
            RSTUAUBUCUDUEUFXBXCAYSUHUUNUUMUVIUVRXDVPAUUNAUUNUVRXEXFXGZXHYQAUUNU
            HHVMVNUHYQGUHHVMYQGUUSUHUEYQUHYOXIXJXKAHAHUVQXLZXMXOXGXNZAUUCUUTYPY
            RUPUQUVFUHYOVKVLXPZAYSWKUIZUVKVQVNZYOWKUIZUVLVQVNZEFULAUWDUWFULUKUW
            CUVKUWFVOVNZULUKAUWCHUWEVOVNZUWGULAUWCUWHULUKZUWCXQUIZUWHXQUIZULUKZ
            AYSUUNUWJUWKULUVSAYSAYSUUMAWBUHYSUVHUVIUUMUVJUAXRWJZYEAUUNYOHVMVNUW
            KAGYOHVMAYRGYOXSUWAYRGUUSYOUEYQUHYOXTXJVGXKAYOHAYOUVFXLAYOAYOUVFAWB
            UHYOUVHUVIUVFUVJUWBXRWJZYAUVTYBYCYDAUWCUNUOUWHUNUOUWIUWLUPAYSUWMWMZ
            AHUWEUVQAYOUWNWMZWSUWCUWHYFVJXPAUWGUWEHVOVNZUWHAUWGUWEUVMVOVNUWQAUV
            KUWEUVLAUVKUVNXLAUWEUWPXLZAUVLUVPXEAUVLUVPYAYGHUVMUWEVOUFYHYIAUWEHU
            WRUVTYJYKYLAUWCUWFUVKUWOAUWEUVLUWPUVPWPAMAMUUKWQAUUGUUHUUJWNWOXDXPU
            BUDYMYN $.
        $}

        $( - Lemma for ~ ostth : regular case.  (Contributed by Mario Carneiro,
           10-Sep-2014.) $)
        ostth2 $p |- ( ph -> E. a e. ( 0 (,] 1 )
          F = ( y e. QQ |-> ( ( abs ` y ) ^c a ) ) ) $=
          ( vz cc0 c1 cioc co wcel cq cv cabs cfv ccxp cmpt wceq cr clt wbr cle
          wrex clog crp cn c2 cuz wa eluz2b2 sylib simpld nnq syl qrngbas abvcl
          cdiv syl2anc rplogcld nnred simprd rpdivcld syl5eqel rpred rpgt0d cn0
          ce nnnn0d qabvle wne nnne0d qrng0 abvgt0 syl3anc elrpd reeflogd nnrpd
          cmul 3brtr4d wb relogcld efle mpbird rpcnd mulid1d breqtrrd ledivmuld
          1re a1i syl5eqbr cxr w3a 0xr elioc2 mp2an syl3anbrc cres fvres oveq1d
          qabsabv mpteq2ia eqcomi abvcxp sylancr cz eluzelz zq fveq2 eqid fvmpt
          ovex 3syl adantl simpr nn0ge0d absidd cc adantr cxpefd cif ostth2lem4
          recnd ef0 0re eflt gt0ne0d redivcld letri3d mpbir2and divcan1d fveq2d
          eqtrd 3eqtrd 3eqtrrd ostthlem1 oveq2 mpteq2dv eqeq2d rspcev ) AFUBUCU
          DUEZUFZGCUGCUHZUIUJZFUKUEZULZUMZGCUGUURLUHZUKUEZULZUMZLUUOURAFUNUFZUB
          FUOUPZFUCUQUPZUUPAFAFJGUJZUSUJZJUSUJZVLUEZUTTAUVJUVKAUVIAGDUFZJUGUFZU
          VIUNUFQAJVAUFZUVNAUVOUCJUOUPZAJVBVCUJZUFZUVOUVPVDRJVEVFZVGZJVHVIZDUGE
          GJNEMVJZVKVMZSVNZAJAJUVTVOAUVOUVPUVSVPVNZVQVRZVSZAFUWFVTAFUVLUCUQTAUV
          LUCUQUPUVJUVKUCWMUEZUQUPAUVJUVKUWHUQAUVJUVKUQUPZUVJWBUJZUVKWBUJZUQUPZ
          AUVIJUWJUWKUQAUVMJWAUFUVIJUQUPQAJUVTWCDEGJMNWDVMAUVIAUVIUWCAUVMUVNJUB
          WEUBUVIUOUPQUWAAJUVTWFDUGEGJUBNUWBEMWGZWHWIWJWKAJAJUVTWLZWKWNAUVJUNUF
          UVKUNUFUWIUWLWOAUVJUWDVSZAJUWNWPUVJUVKWQVMWRAUVKAUVKUWEWSWTXAAUVJUCUV
          KUWOUCUNUFZAXCXDUWEXBWRXEUBXFUFUWPUUPUVFUVGUVHXGWOXHXCUBUCFXIXJXKZADE
          UAGUUTMNQAUIUGXLZDUFUUPUUTDUFDEMNXOUWQCDUGEFUWRUUTNUWBCUGUUQUWRUJZFUK
          UEZULUUTCUGUWTUUSUUQUGUFUWSUURFUKUUQUGUIXMXNXPXQXRXSAUAUHZUVQUFZVDZUX
          AUUTUJZUXAUIUJZFUKUEZUXAFUKUEZUXAGUJZUXBUXDUXFUMZAUXBUXAXTUFZUXAUGUFZ
          UXIVBUXAYAZUXAYBZCUXAUUSUXFUGUUTUUQUXAUMUURUXEFUKUUQUXAUIYCXNUUTYDUXE
          FUKYFYEYGYHUXCUXEUXAFUKUXCUXAUXCUXAUXCUXAVAUFZUCUXAUOUPZUXCUXBUXNUXOV
          DAUXBYIZUXAVEVFZVGZVOZUXCUXAUXCUXAUXRWCYJYKXNUXCUXGFUXAUSUJZWMUEZWBUJ
          UXHUSUJZWBUJUXHUXCUXAFUXCUXAUXSYQUXCUXAUXRWFZAFYLUFUXBAFUWFWSYMYNUXCU
          YAUYBWBUXCUYAUYBUXTVLUEZUXTWMUEUYBUXCFUYDUXTWMUXCFUYDUMFUYDUQUPZUYDFU
          QUPZUXCUCUXHUOUPZUYEUXCBDEFUYDUXHUCUQUPUCUXHYOZUVKUXTVLUEZGHIUXAJKMNO
          PAUVMUXBQYMZAUVRUXBRYMZAUCUVIUOUPZUXBSYMTUXPUYDYDZUYHYDUYIYDYPZVPUXCU
          YLUYFUXCBDEUYDFUVIUCUQUPUCUVIYOZUXTUVKVLUEZGHIJUXAKMNOPUYJUXPUXCUYGUY
          EUYNVGUYMUYKTUYOYDUYPYDYPVPUXCFUYDAUVFUXBUWGYMUXCUYBUXTUXCUXHUXCUXHUX
          CUVMUXKUXHUNUFUYJUXCUXJUXKUXBUXJAUXLYHUXMVIZDUGEGUXANUWBVKVMUXCUVMUXK
          UXAUBWEUBUXHUOUPUYJUYQUYCDUGEGUXAUBNUWBUWMWHWIWJZWPZUXCUXAUXCUXAUXRWL
          ZWPZUXCUXTUXCUBUXTUOUPZUBWBUJZUXTWBUJZUOUPZUXCVUCUCVUDUOYRUXCUCUXAVUD
          UOUXCUXNUXOUXQVPUXCUXAUYTWKXAXEUXCUBUNUFUXTUNUFVUBVUEWOYSVUAUBUXTYTXS
          WRUUAZUUBUUCUUDXNUXCUYBUXTUXCUYBUYSYQUXCUXTVUAYQVUFUUEUUGUUFUXCUXHUYR
          WKUUHUUIUUJUVEUVALFUUOUVBFUMZUVDUUTGVUGCUGUVCUUSUVBFUURUKUUKUULUUMUUN
          VM $.
      $}

      ${
        ostth3.2 $e |- ( ph -> A. n e. NN -. 1 < ( F ` n ) ) $.
        ostth3.3 $e |- ( ph -> P e. Prime ) $.
        ostth3.4 $e |- ( ph -> ( F ` P ) < 1 ) $.
        ostth3.5 $e |- R = -u ( ( log ` ( F ` P ) ) / ( log ` P ) ) $.
        ostth3.6 $e |- S =
          if ( ( F ` P ) <_ ( F ` p ) , ( F ` p ) , ( F ` P ) ) $.
        $( - Lemma for ~ ostth : p-adic case.  (Contributed by Mario Carneiro,
           10-Sep-2014.) $)
        ostth3 $p |- ( ph -> E. a e. RR+
          F = ( y e. QQ |-> ( ( ( J ` P ) ` y ) ^c a ) ) ) $=
          ( vk vb crp wcel cq cv ccxp co cmpt wceq wrex clog cdiv cneg cr cn c1
          cfv clt wbr c2 wa cprime syl nnq abvcl syl2anc cc0 wne nnne0d syl3anc
          abvgt0 elrpd syl5eqel cmul wb sylancl mpbid rpcnd breqtrrd a1i mpbird
          syl6breqr wi fveq2 oveq1d eqid ovex fvmpt cpc cexp padicval wn neneqd
          iffalse oveq2d cz 1z negeqd ax-mp 3eqtrd recnd eqtrd ce rpne0d adantr
          cif ad2antlr weq cc ad2antrr syl2an 2re simprr breq1 adantl ad3antrrr
          cle adantrr cgcd caddc nnexpcl nnzd mpd zq qmulcl cvv ad2antrl breq1d
          wral 1re rspcv sylc letrd eqbrtrd prmuz2 eluz2b2 sylib simpld qrngbas
          cuz qrng0 relogcld nnred simprd rplogcld rerpdivcld renegcld 1rp log1
          logltb syl6breq mul01d 0re ltdivmuld lt0neg1d padicabvcxp nncnd exp1d
          pcid eqtr3d znegcl cxpexpzd eqtr4d mulm1d negeqi negnegd syl5eq nnrpd
          zrei cxpmuld cxpefd divcan1d fveq2d 3eqtr3d 3eqtrrd eqeq12d syl5ibcom
          reeflogd prmnn 1cxpd cdivides pceq0 dvdsprm necon3bbid biimpar syl6eq
          sylan bitrd neg0 exp0d ifcl rprecred syl5eqbr reclt1d expnbnd exprecd
          ifboth nnz ax-1ne0 qrng1 abv1z nnnn0 bezout simprl simplr prmrp simpr
          cn0 rppwr eqeq1d simprrl simprrr qaddcl rpexpcl rpred remulcl sylancr
          readdcld cplusg qex ccnfld cnfldadd ressplusg cmulr cnfldmul ressmulr
          abvtri abvmul qabvexp reexpcld remulcld w3o elz simprbi abv0 syl6eqbr
          0le1 syl5ibrcom lenlt ralbidva rspccv cminusg abvneg qrngneg eqbrtrrd
          eqeltrd expr 3jaod ralrimiva rsp expgt0 lemul2 mulid1d breqtrd rpge0d
          syl112anc max1 leexp1a max2 le2addd 2timesd sylbid anassrs rexlimdvva
          syl32anc rpregt0d ledivmul2 mp3an12 reexpcl pm2.21d rexlimdva pm2.01d
          breq2d notbid lttri3 mpbir2and eqtr2d ex pm2.61dne ostthlem2 mpteq2dv
          3eqtr4d oveq2 eqeq2d rspcev ) AGUHUIZJCUJCUKZEKVCZVCZGULUMZUNZUOZJCUJ
          VWOOUKZULUMZUNZUOZOUHUPAGAGEJVCZUQVCZEUQVCZURUMZUSZUTUDAVXFAVXDVXEAVX
          CAVXCAJDUIZEUJUIZVXCUTUIZTAEVAUIZVXIAVXKVBEVDVEZAEVFUUFVCUIZVXKVXLVGA
          EVHUIZVXMUBEUUAVIZEUUBUUCZUUDZEVJVIZDUJFJEQFPUUEZVKZVLAVXHVXIEVMVNVMV
          XCVDVEZTVXRAEVXQVOZDUJFJEVMQVXSFPUUGZVQVPZVRZUUHZAEAEVXQUUIAVXKVXLVXP
          UUJUUKZUULZUUMVSZAVMVXGGVDAVXFVMVDVEZVMVXGVDVEAVYJVXDVXEVMVTUMZVDVEAV
          XDVMVYKVDAVXDVBUQVCZVMVDAVXCVBVDVEZVXDVYLVDVEZUCAVXCUHUIZVBUHUIVYMVYN
          WAVYEUUNVXCVBUUPWBWCUUOUUQAVXEAVXEVYGWDZUURWEAVXDVMVXEVYFVMUTUIAUUSWF
          VYGUUTWGAVXFVYHUVAWCUDWHVRZADFJVWQNPQTAVXNVWLVWQDUIUBVYQBCDEFGKMPQRUV
          BVLANUKZVHUIZVGZVYRJVCZVYRVWQVCZUOZEVYRAEVYRUOZWUCWIVYSAVXCEVWQVCZUOW
          UDWUCAWUEEVWNVCZGULUMZEVBUSZULUMZGULUMZVXCAVXIWUEWUGUOVXRCEVWPWUGUJVW
          QVWMEUOVWOWUFGULVWMEVWNWJWKVWQWLZWUFGULWMWNVIAWUFWUIGULAWUFEVMUOZVMEE
          EWOUMZUSZWPUMZXLZWUOWUIAVXNVXIWUFWUPUOUBVXRBEKEMRWQVLAWULWRWUPWUOUOAE
          VMVYBWSWULVMWUOWTVIAWUOEWUHWPUMWUIAWUNWUHEWPAWUMVBAEEVBWPUMZWOUMZWUMV
          BAWUQEEWOAEAEVXQUVCZUVDXAAVXNVBXBUIZWURVBUOUBXCVBEUVEWBUVFXDXAAEWUHWU
          SVYBWUHXBUIZAWUTWVAXCVBUVGXEZWFUVHUVIXFWKAEWUHGVTUMZULUMEVXFULUMZWUJV
          XCAWVCVXFEULAWVCGUSZVXFAGAGVYIXGZUVJAWVEVXGUSVXFGVXGUDUVKAVXFAVXFVYHX
          GZUVLUVMXHXAAEWUHGAEVXQUVNWUHUTUIAWUHWVBUVOWFWVFUVPAWVDVXFVXEVTUMZXIV
          CVXDXIVCVXCAEVXFWUSVYBWVGUVQAWVHVXDXIAVXDVXEAVXDVYFXGVYPAVXEVYGXJUVRU
          VSAVXCVYEUWDXFUVTUWAWUDVXCWUAWUEWUBEVYRJWJEVYRVWQWJUWBUWCXKVYTEVYRVNZ
          WUCVYTWVIVGZWUBVYRVWNVCZGULUMZWUAWVJVYRUJUIZWUBWVLUOWVJVYRVAUIZWVMVYS
          WVNAWVIVYRUWEZXMZVYRVJZVIZCVYRVWPWVLUJVWQCNXNVWOWVKGULVWMVYRVWNWJWKWU
          KWVKGULWMWNVIWVJVBGULUMVBWVLWUAWVJGAGXOUIVYSWVIWVFXPUWFWVJWVKVBGULWVJ
          WVKVYRVMUOZVMEEVYRWOUMZUSZWPUMZXLZWWBVBWVJVXNWVMWVKWWCUOAVXNVYSWVIUBX
          PWVRBEKVYRMRWQVLWVJWVSWRWWCWWBUOWVJVYRVMWVJVYRWVPVOZWSWVSVMWWBWTVIWVJ
          WWBEVMWPUMVBWVJWWAVMEWPWVJWWAVMUSVMWVJWVTVMVYTWVTVMUOZWVIVYTWWEEVYRUW
          GVEZWRZWVIAVXNWVNWWEWWGWAVYSUBWVOEVYRUWHXQVYTWWFEVYRAVXMVYSWWFWUDWAVX
          OVYREUWIUWMUWJUWNUWKXDUWOUWLXAWVJEAEXOUIVYSWVIWUSXPUWPXHXFWKWVJWUAVBU
          OZWUAVBVDVEZWRZVBWUAVDVEZWRZWVJWWIVYTWVIWWIWWJVYTWVIWWIVGZVGZVFVBHURU
          MZUFUKZWPUMZVDVEZUFVAUPZWWJWWNVFUTUIZWWOUTUIZVBWWOVDVEZWWSWWTWWNXRWFW
          WNHWWNHVXCWUAYCVEZWUAVXCXLZUHUEWWNWUAUHUIZVYOWXDUHUIVYTWVIWXEWWIWVJWU
          AWVJVXHWVMWUAUTUIZAVXHVYSWVITXPZWVRDUJFJVYRQVXSVKZVLZWVJVXHWVMVYRVMVN
          ZVMWUAVDVEZWXGWVRWWDDUJFJVYRVMQVXSVYCVQZVPVRYDZAVYOVYSWWMVYEXPZWXCWUA
          VXCUHUWQVLVSZUWRZWWNHVBVDVEWXBWWNHWXDVBVDUEWWNWWIVYMWXDVBVDVEZVYTWVIW
          WIXSAVYMVYSWWMUCXPWXCWWIVYMWXQWUAVXCWUAWXDVBVDXTVXCWXDVBVDXTUXCVLUWSW
          WNHWXOUWTWCVFWWOUFUXAVPWWNWWRWWJUFVAWWNWWPVAUIZVGZWWRWWJWXSWWQVFYCVEZ
          WWRWRZWXSWWQVBHWWPWPUMZURUMZVFYCWXSHWWPWWNHXOUIWXRWWNHWXOWDXKWWNHVMVN
          WXRWWNHWXOXJXKWXRWWPXBUIZWWNWWPUXDZYAUXBWXSWYCVFYCVEZVBVFWYBVTUMZYCVE
          ZWXSVBJVCZVBWYGYCWXSVXHVBVMVNWYIVBUOAVXHVYSWWMWXRTYBUXEDFVBJVMQFPUXFV
          YCUXGWBWXSEWWPWPUMZVYRWWPWPUMZYEUMZWYJVWSVTUMZWYKUGUKZVTUMZYFUMZUOZUG
          XBUPOXBUPZWYIWYGYCVEZWXSWYJXBUIWYKXBUIWYRWXSWYJWWNVXKWWPUXNUIZWYJVAUI
          ZWXRAVXKVYSWWMVXQXPZWWPUXHZEWWPYGXQZYHWXSWYKWWNWVNWYTWYKVAUIZWXRVYSWV
          NAWWMWVOXMZXUCVYRWWPYGXQZYHOUGWYJWYKUXIVLWXSWYQWYSOUGXBXBWWNWXRVWSXBU
          IZWYNXBUIZVGZWYQWYSWIWWNWXRXUJVGZVGZWYQVBWYPUOZWYSXULWYLVBWYPWWNWXRWY
          LVBUOZXUJWXSEVYRYEUMVBUOZXUNWWNXUOWXRWWNXUOWVIVYTWVIWWIUXJWWNVXNVYSXU
          OWVIWAAVXNVYSWWMUBXPAVYSWWMUXKEVYRUXLVLWGXKWXSVXKWVNWXRXUOXUNWIWWNVXK
          WXRXUBXKWWNWVNWXRXUFXKWWNWXRUXMEVYRWWPUXOVPYIYDUXPXULWYSXUMWYPJVCZWYG
          YCVEXULXUPWYMJVCZWYOJVCZYFUMZWYGXULVXHWYPUJUIZXUPUTUIAVXHVYSWWMXUKTYB
          ZXULWYMUJUIZWYOUJUIZXUTXULWYJUJUIZVWSUJUIZXVBXULXUAXVDWWNWXRXUAXUJXUD
          YDWYJVJVIZXULXUHXVEWWNWXRXUHXUIUXQZVWSYJZVIZWYJVWSYKVLZXULWYKUJUIZWYN
          UJUIZXVCXULXUEXVKWWNWXRXUEXUJXUGYDWYKVJVIZXULXUIXVLWWNWXRXUHXUIUXRZWY
          NYJVIZWYKWYNYKVLZWYMWYOUXSVLDUJFJWYPQVXSVKVLXULXUQXURXULVXHXVBXUQUTUI
          XVAXVJDUJFJWYMQVXSVKVLZXULVXHXVCXURUTUIXVAXVPDUJFJWYOQVXSVKVLZUYDXULW
          WTWYBUTUIZWYGUTUIXRWWNWXRXVSXUJWXSWYBWWNHUHUIWYDWYBUHUIWXRWXOWYEHWWPU
          XTXQZUYAYDZVFWYBUYBUYCXULVXHXVBXVCXUPXUSYCVEXVAXVJXVPDUJYFFJWYMWYOQVX
          SUJYLUIZYFFUYEVCUOUYFUJYFUYGFYLPUYHUYIXEUYMVPXULXUSWYBWYBYFUMZWYGYCXU
          LXUQXURWYBWYBXVQXVRXWAXWAXULXUQVXCWWPWPUMZVWSJVCZVTUMZWYBYCXULXUQWYJJ
          VCZXWEVTUMZXWFXULVXHXVDXVEXUQXWHUOXVAXVFXVIDUJFVTJWYJVWSQVXSXWBVTFUYJ
          VCUOUYFUJUYGFVTYLPUYKUYLXEZUYNVPXULXWGXWDXWEVTXULVXHVXIWYTXWGXWDUOXVA
          AVXIVYSWWMXUKVXRYBZWXRWYTWWNXUJXUCYMZDFJEWWPPQUYOVPWKXHXULXWFXWDWYBXU
          LXWDXWEXULVXCWWPXULVXHVXIVXJXVAXWJVXTVLZXWKUYPZXULVXHXVEXWEUTUIZXVAXV
          IDUJFJVWSQVXSVKVLZUYQXWMXWAXULXWFXWDVBVTUMZXWDYCXULXWEVBYCVEZXWFXWPYC
          VEZXULXWQOXBYOZXUHXWQAXWSVYSWWMXUKAXWQOXBAXUHVGZVWSVMUOZVWSVAUIZVWSUS
          ZVAUIZUYRZXWQXUHXXEAXUHVWSUTUIXXEVWSUYSUYTYAXWTXXAXWQXXBXXDXWTXWQXXAV
          MJVCZVBYCVEZAXXGXUHAXXFVMVBYCAVXHXXFVMUOTDFJVMQVYCVUAVIVUCVUBXKXXAXWE
          XXFVBYCVWSVMJWJYNVUDAXXBXWQWIZXUHAIUKZJVCZVBYCVEZIVAYOZXXHAXXLVBXXJVD
          VEZWRZIVAYOZUAAXXKXXNIVAAXXIVAUIZVGXXJUTUIZVBUTUIZXXKXXNWAAVXHXXIUJUI
          XXQXXPTXXIVJDUJFJXXIQVXSVKXQYPXXJVBVUEWBVUFWGZXXKXWQIVWSVAIOXNXXJXWEV
          BYCXXIVWSJWJYNVUGVIXKAXUHXXDXWQAXUHXXDVGZVGZVWSFVUHVCZVCZJVCZXWEVBYCX
          YAVXHXVEXYDXWEUOAVXHXXTTXKXUHXVEAXXDXVHYMZDUJFJXYBVWSQVXSXYBWLVUIVLXY
          AXYCVAUIXXLXYDVBYCVEZXYAXYCXXCVAXYAXVEXYCXXCUOXYEFVWSPVUJVIAXUHXXDXSV
          ULAXXLXXTXXSXKXXKXYFIXYCVAXXIXYCUOXXJXYDVBYCXXIXYCJWJYNYQYRVUKVUMVUNY
          IVUOYBZXVGXWQOXBVUPYRXULXWNXXRXWDUTUIVMXWDVDVEZXWQXWRWAXWOXXRXULYPWFZ
          XWMXULVXJWYDVYAXYHXWLWXRWYDWWNXUJWYEYMZAVYAVYSWWMXUKVYDYBVXCWWPVUQVPX
          WEVBXWDVURVVBWCXULXWDXULXWDXWMXGVUSVUTXULVXJHUTUIZWYTVMVXCYCVEVXCHYCV
          EXWDWYBYCVEXWLWWNXYKXUKWWNHWXOUYAXKZXWKXULVXCWWNVYOXUKWXNXKVVAXULVXCW
          XDHYCXULVXJWXFVXCWXDYCVEXWLXULVXHWVMWXFXVAXULWVNWVMWWNWVNXUKXUFXKZWVQ
          VIZWXHVLZVXCWUAVVCVLUEWHVXCHWWPVVDVVKYSYTXULXURWUAWWPWPUMZWYNJVCZVTUM
          ZWYBYCXULXURWYKJVCZXYQVTUMZXYRXULVXHXVKXVLXURXYTUOXVAXVMXVODUJFVTJWYK
          WYNQVXSXWIUYNVPXULXYSXYPXYQVTXULVXHWVMWYTXYSXYPUOXVAXYNXWKDFJVYRWWPPQ
          UYOVPWKXHXULXYRXYPWYBXULXYPXYQXULWUAWWPXYOXWKUYPZXULVXHXVLXYQUTUIZXVA
          XVODUJFJWYNQVXSVKVLZUYQYUAXWAXULXYRXYPVBVTUMZXYPYCXULXYQVBYCVEZXYRYUD
          YCVEZXULXUIXWSYUEXVNXYGXWQYUEOWYNXBOUGXNXWEXYQVBYCVWSWYNJWJYNYQYRXULY
          UBXXRXYPUTUIVMXYPVDVEZYUEYUFWAYUCXYIYUAXULWXFWYDWXKYUGXYOXYJXULVXHWVM
          WXJWXKXVAXYNXULVYRXYMVOWXLVPWUAWWPVUQVPXYQVBXYPVURVVBWCXULXYPXULXYPYU
          AXGVUSVUTXULWXFXYKWYTVMWUAYCVEWUAHYCVEXYPWYBYCVEXYOXYLXWKXULWUAWWNWXE
          XUKWXMXKVVAXULWUAWXDHYCXULVXJWXFWUAWXDYCVEXWLXYOVXCWUAVVEVLUEWHWUAHWW
          PVVDVVKYSYTVVFWWNWXRWYGXWCUOXUJWXSWYBWXSWYBXVTWDVVGYDWEYSXUMWYIXUPWYG
          YCVBWYPJWJYNVUDVVHVVIVVJYIVUKWXSXVSVMWYBVDVEVGZWYFWYHWAZWXSWYBXVTVVLX
          XRWWTYUHYUIYPXRVBVFWYBVVMVVNVIWGYTWXSWWQUTUIZWWTWXTWYAWAWWNWXAWYTYUJW
          XRWXPXUCWWOWWPVVOXQXRWWQVFVUEWBWCVVPVVQYIVUMVVRWVJWVNXXOWWLWVPAXXOVYS
          WVIUAXPXXNWWLIVYRVAINXNZXXMWWKYUKXXJWUAVBVDXXIVYRJWJVVSVVTYQYRWVJWXFX
          XRWWHWWJWWLVGWAWXIYPWUAVBVWAWBVWBVWHVWCVWDVWEVWFVXBVWROGUHVWSGUOZVXAV
          WQJYULCUJVWTVWPVWSGVWOULVWIVWGVWJVWKVL $.
      $}
    $}

    $( Ostrowski's theorem, which classifies all absolute values on ` QQ ` .
       Any such absolute value must either be the trivial absolute value
       ` K ` , a constant exponent ` 0 < a <_ 1 ` times the regular absolute
       value, or a positive exponent times the p-adic absolute value.
       (Contributed by Mario Carneiro, 10-Sep-2014.) $)
    ostth $p |- ( F e. A <-> ( F = K \/
      E. a e. ( 0 (,] 1 ) F = ( y e. QQ |-> ( ( abs ` y ) ^c a ) ) \/
      E. a e. RR+ E. g e. ran J F = ( y e. QQ |-> ( ( g ` y ) ^c a ) ) ) ) $=
      ( vp wcel cq cfv c1 cprime vn vz vk wceq cabs ccxp cmpt cc0 cioc wrex crn
      cv co crp w3o clt wbr cn wa clog cdiv simpl wn c2 cuz 1re ltnri wne qrng1
      qrng0 abv1z mpan2 breq2d mtbiri adantr simprr fveq2 syl5ibcom mtod simprl
      ax-1ne0 wo elnn1uz2 sylib ord mpd eqid ostth2 rexlimdvaa syl6 wral ralnex
      cneg cle cif simpll simplr weq notbid cbvralv ostth3 expr reximdva wf wfn
      3mix2 padicabvf ffn fveq1 oveq1d mpteq2dv eqeq2d rexrn mp2b rexbii rexcom
      wb bitri 3mix3 sylbir breq1d ostth1 3mix1 syl syl5bir pm2.61d ex id qdrng
      cdr qrngbas abvtriv ax-mp syl6eqel cres qabsabv fvres mpteq2ia syl5ibrcom
      eleq1 eqcomi abvcxp mpan padicabvcxp ancoms rexlimivv sylbi 3jaoi impbii
      rexlimiv ) FCPZFHUDZFBQBULZUERZJULZUFUMZUGZUDZJUHSUIUMZUJZFBQUUMEULZRZUUO
      UFUMZUGZUDZEGUKUJZJUNUJZUOZUUKSUAULZFRZUPUQZUAURUJZUVHUUKUVLUUTUVHUUKUVKU
      UTUAURUUKUVIURPZUVKUSZUSZABCDUVJUTRUVIUTRVAUMZFGHUVIIJKLMNUUKUVNVBUVOUVIS
      UDZVCUVIVDVERPZUVOUVQSSFRZUPUQZUUKUVTVCUVNUUKUVTSSUPUQSVFVGUUKUVSSSUPUUKS
      UHVHUVSSUDWACDSFUHLDKVIDKVJZVKVLVMVNVOUVOUVKUVQUVTUUKUVMUVKVPZUVQUVJUVSSU
      PUVISFVQVMVRVSUVOUVQUVRUVOUVMUVQUVRWBUUKUVMUVKVTUVIWCWDWEWFUWBUVPWGWHWIUU
      TUULUVGXFWJUVLVCUVKVCZUAURWKZUUKUVHUVKUAURWLUUKUWDUVHUUKUWDUSZOULZFRZSUPU
      QZOTUJZUVHUWEUWIFBQUUMUWFGRZRZUUOUFUMZUGZUDZJUNUJZOTUJZUVHUWEUWHUWOOTUWEU
      WFTPZUWHUWOUWEUWQUWHUSZUSZABCUWFDUWGUTRUWFUTRVAUMWMZUWGUBULFRZWNUQUXAUWGW
      OZUCFGHIUBJKLMNUUKUWDUWRWPUWSUWDSUCULZFRZUPUQZVCZUCURWKZUUKUWDUWRWQUWCUXF
      UAUCURUAUCWRZUVKUXEUXHUVJUXDSUPUVIUXCFVQVMWSWTZWDUWEUWQUWHVTUWEUWQUWHVPUW
      TWGUXBWGXAXBXCUWPUVGUVHUVGUWNOTUJZJUNUJZUWPUVFUXJJUNTCGXDGTXEUVFUXJXQACDG
      IKLMXGTCGXHUVEUWNEOTGUVAUWJUDZUVDUWMFUXLBQUVCUWLUXLUVBUWKUUOUFUUMUVAUWJXI
      XJXKXLXMXNXOZUWNJOUNTXPXRUVGUULUUTXSXTWJUWIVCUWHVCZOTWKZUWEUVHUWHOTWLUUKU
      WDUXOUVHUUKUWDUXOUSZUSZUULUVHUXQACDUCFGHIKLMNUUKUXPVBUXQUWDUXGUUKUWDUXOVT
      UXIWDUXQUXOUXDSUPUQZVCZUCTWKUUKUWDUXOVPUXNUXSOUCTOUCWRZUWHUXRUXTUWGUXDSUP
      UWFUXCFVQYAWSWTWDYBUULUUTUVGYCYDXBYEYFYGYEYFUULUUKUUTUVGUULFHCUULYHDYJPHC
      PDKYIACQDHUHLDKYKZUWANYLYMYNUURUUKJUUSUUOUUSPZUUKUURUUQCPZUEQYOZCPUYBUYCC
      DKLYPBCQDUUOUYDUUQLUYABQUUMUYDRZUUOUFUMZUGUUQBQUYFUUPUUMQPUYEUUNUUOUFUUMQ
      UEYQXJYRUUAUUBUUCFUUQCYTYSUUJUVGUXKUUKUXMUWNUUKJOUNTUUOUNPZUWQUSUUKUWNUWM
      CPZUWQUYGUYHABCUWFDUUOGIKLMUUDUUEFUWMCYTYSUUFUUGUUHUUI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Fermat's Last Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
  @{
    flt.f @e |- F = { n e. ( ZZ>= ` 3 ) | ( ( X e. NN /\ Y e. NN /\ Z e. NN )
      /\ ( ( X ^ n ) + ( Y ^ n ) ) = ( Z ^ n ) ) } @.

    fltval @p |- ( N e. F <-> ( N e. ( ZZ>= ` 3 ) /\
      ( X e. NN /\ Y e. NN /\ Z e. NN ) /\
      ( ( X ^ N ) + ( Y ^ N ) ) = ( Z ^ N ) ) ) @=
      ? @.

    fltrcl1 @p |- ( N e. F -> N e. ( ZZ>= ` 3 ) ) @=
      ? @.

    fltrclnn @p |- ( N e. F -> N e. NN ) @=
      ? @.

    fltrcl2 @p |- ( N e. F ->
      ( X e. NN /\ Y e. NN /\ Z e. NN ) ) @=
      ? @.

    fltvali @p |- ( N e. F ->
      ( ( X ^ N ) + ( Y ^ N ) ) = ( Z ^ N ) ) @=
      ? @.

    fltlem1 @p |- ( N e. F -> ( X < Z /\ Y < Z ) ) @=
      ? @.

    @{
      fltlem2.1 @e |- ( ph -> ( X e. NN /\ Y e. NN /\ Z e. NN ) ) @.
      fltlem2.2 @e |- ( ph -> N e. NN ) @.
      fltlem2.3 @e |- ( ph -> ( ( X ^ N ) + ( Y ^ N ) ) <_ ( Z ^ N ) ) @.
      fltlem2.4 @e |- ( ph -> M e. NN ) @.
      fltlem2.5 @e |- ( ph -> N < M ) @.
      fltlem2 @p |- ( ph -> ( ( X ^ M ) + ( Y ^ M ) ) < ( Z ^ M ) ) @=
        ? @.
    @}

    fltlem5 @p |- ( N e. F -> X =/= Y ) @=
      ? @.

    fltlem6 @p |- ( N e. F -> Z < ( X + Y ) ) @=
      ? @.

    fltlem7 @p |- ( N e. F -> ( Z ^ 2 ) < ( ( X ^ 2 ) + ( Y ^ 2 ) ) ) @=
      ? @.

    fltlem8 @p |- E* n n e. F @=
      ? @.

    flt.k @e |- K = ( n e. NN |-> ( ( ( X ^ ( n + 1 ) ) + ( Y ^ ( n + 1 ) ) ) /
        ( ( X ^ n ) + ( Y ^ n ) ) ) ) @.
    @{
      fltkval.1 @e |- ( ph -> N e. NN ) @.
      fltkval @p |- ( ph
        -> ( K ` N ) = ( ( ( X ^ ( N + 1 ) ) + ( Y ^ ( N + 1 ) ) ) /
          ( ( X ^ N ) + ( Y ^ N ) ) ) ) @=
        ? @.

      fltkval.2 @e |- ( ph -> X e. NN ) @.
      fltkval.3 @e |- ( ph -> Y e. NN ) @.
      fltkcl @p |- ( ph -> ( K ` N ) e. RR+ ) @=
        ? @.

      fltlem91a @p |- ( ph -> ( X < ( K ` N ) \/ Y < ( K ` N ) ) ) @=
        ? @.

      fltlem91b @p |- ( ph -> ( K ` N ) < ( K ` ( N + 1 ) ) ) @=
        ? @.

      fltlem91c @p |- ( ph ->
        ( ( K ` ( N + 1 ) ) < X \/ ( K ` ( N + 1 ) ) < Y ) ) @=
        ? @.
    @}

    fltlem92 @p |- ( N e. F ->
      ( ( X ^ ( N + 1 ) ) + ( Y ^ ( N + 1 ) ) ) < ( Z ^ ( N + 1 ) ) ) @=
      ? @.

    @{
      fltlem93.1 @e |- ( ph -> N e. ( ZZ>= ` 3 ) ) @.
      fltlem93.2 @e |- ( ph -> ( X e. NN /\ Y e. NN /\ Z e. NN ) ) @.
      fltlem93.3 @e |- T = ( ( ( log ` ( X + Y ) ) - ( log ` Z ) ) /
        ( ( log ` Z ) - ( log ` if ( X <_ Y , Y , X ) ) ) ) @.
      fltlem93.4 @e |- ( ph -> T < N ) @.
      fltlem93 @p |- ( ph ->
            ( ( X ^ ( N + 1 ) ) + ( Y ^ ( N + 1 ) ) ) < ( Z ^ ( N + 1 ) ) ) @=
        ? @.
    @}

    fltlem9 @p |- ( <. X , Y >. ( F ` N ) Z ->
     E. j e. ZZ A. m e. ( ZZ>= ` j ) ( ( X ^ m ) + ( Y ^ m ) ) < ( Z ^ m ) ) @=
      ? @.

    flt.s @e |- ( ps <-> ( ( X e. NN /\ Y e. NN /\ Z e. NN ) /\
      ( X =/= Y /\ ( X < Z /\ Y < Z /\ Z < ( X + Y ) ) ) /\
        ( ( Z ^ 2 ) < ( ( X ^ 2 ) + ( Y ^ 2 ) ) /\ E. j e. ZZ
        A. m e. ( ZZ>= ` j ) ( ( X ^ m ) + ( Y ^ m ) ) < ( Z ^ m ) ) ) ) @.
    fltsval1 @p |- ( ps -> ( X e. NN /\ Y e. NN /\ Z e. NN ) ) @=
      ? @.

    fltsval2 @p |- ( ps -> X =/= Y ) @=
      ? @.

    fltsval3 @p |- ( ps -> ( X < Z /\ Y < Z ) ) @=
      ? @.

    fltsval4 @p |- ( ps -> Z < ( X + Y ) ) @=
      ? @.

    fltsval5 @p |- ( ps -> ( Z ^ 2 ) < ( ( X ^ 2 ) + ( Y ^ 2 ) ) ) @=
      ? @.

    fltsval6 @p |- ( ps -> E. j e. ZZ
        A. m e. ( ZZ>= ` j ) ( ( X ^ m ) + ( Y ^ m ) ) < ( Z ^ m ) ) @=
      ? @.

    fltfs @p |- ( N e. F -> ps ) @=
      ? @.

    flt.p @e |- P = sup ( { q e. NN |
      ( ( X ^ q ) + ( Y ^ q ) ) <_ ( Z ^ q ) } , RR , `' < ) @.
    fltlem11 @p |- ( ps -> ( P e. ( ZZ>= ` 3 ) /\
      ( ( X ^ P ) + ( Y ^ P ) ) <_ ( Z ^ P ) ) ) @=
      ? @.

    fltlem12a @p |- ( ps -> ( ( 2 <_ X \/ 2 <_ Y ) /\ 2 < Z ) ) @=
      ? @.

    fltlem12c @p |- ( ps ->
      ( ( X ^ ( P - 1 ) ) + ( Y ^ ( P - 1 ) ) ) <
        ( ( X ( K ` ( P - 2 ) ) Y ) x. ( Z ^ ( P - 1 ) ) ) ) @=
      ? @.

    @{
      flt.w @e |- W = ( Z / ( K ` ( P - 1 ) ) ) @.
      fltlem13a @p |- ( ps -> ( W e. RR /\ 1 < W ) ) @=
        ? @.

      fltlem13b @p |- ( ps -> X < W  ) @=
        ? @.

      fltlem13c @p |- ( ps -> W < Z ) @=
        ? @.

      fltlem13d @p |- ( ps -> ( ( X ^ ( P - 1 ) ) + ( Y ^ ( P - 1 ) ) )
          <_ ( W x. ( Z ^ ( P - 1 ) ) ) ) @=
        ? @.

      fltlem13 @p |- ( ps -> ( ( X ^ P ) + ( Y ^ P ) ) < ( Z ^ P ) ) @=
        ? @.
    @}

    fltlem14 @p |- -. N e. F @=
      ( wcel cexp co cn clt wbr caddc fltvali wceq wo cle cv crab ccnv csup cuz
      cr c1 cfv wss ssrab2 nnuz sseqtri fltrclnn cn0 fltrcl2 simp3d syl nnexpcl
      nnnn0 syl2anc nnre leid eqbrtrd oveq2 oveq12d breq12d sylanbrc infmssuzle
      elrab sylancr syl5eqbr wb c3 3nn fltfs fltlem11 simpld uztrn2 leloe mpbid
      wa w3a adantr simprd simpr fltlem2 cmin cdiv eqid fltlem13 syl5ibcom jaod
      ex mpd eqbrtrrd wn ltnr pm2.65i ) HFQZKHRSZXGUAUBZXFIHRSZJHRSZUCSZXGXGUAE
      FHIJKMUDZXFBHUAUBZBHUEZUFZXKXGUAUBZXFBHUGUBZXOXFBILUHZRSZJXRRSZUCSZKXRRSZ
      UGUBZLTUIZUMUAUJUKZHUGPXFYDUNULUOZUPHYDQZYEHUGUBYDTYFYCLTUQURUSXFHTQZXKXG
      UGUBZYGEFHIJKMUTZXFXKXGXGUGXLXFXGUMQZXGXGUGUBXFXGTQZYKXFKTQZHVAQZYLXFITQZ
      JTQZYMEFHIJKMVBZVCXFYHYNYJHVFVDKHVEVGXGVHVDZXGVIVDVJYCYILHTXRHUEZYAXKYBXG
      UGYSXSXIXTXJUCXRHIRVKXRHJRVKVLXRHKRVKVMVPVNHYDUNVOVQVRXFBUMQZHUMQZXQXOVSX
      FBTQZYTXFVTTQZBVTULUOQZUUBWAXFUUDIBRSZJBRSZUCSZKBRSZUGUBZXFAUUDUUIWHZACDE
      FGHIJKMNOWBZABCDEFGIJKLMNOPWCVDZWDUNBVTTURWEZVQBVHVDXFYHUUAYJHVHVDBHWFVGW
      GXFXMXPXNXFXMXPXFXMWHZEFHBIJKMXFYOYPYMWIXMYQWJUUNUUCUUDUUBWAUUNUUDUUIXFUU
      JXMUULWJZWDUUMVQUUNUUDUUIUUOWKXFYHXMYJWJXFXMWLWMWTXFUUGUUHUAUBZXNXPXFAUUP
      UUKABCDEFGKBUNWNSGUOWOSZIJKLMNOPUUQWPWQVDXNUUGXKUUHXGUAXNUUEXIUUFXJUCBHIR
      VKBHJRVKVLBHKRVKVMWRWSXAXBXFYKXHXCYRXGXDVDXE @.
      @( [11-Aug-2015] @)

    fltlem15 @p |- ( ( N e. ( ZZ>= ` 3 ) /\ ( X e. NN /\ Y e. NN /\ Z e. NN ) )
      -> ( ( X ^ N ) + ( Y ^ N ) ) =/= ( Z ^ N ) ) @=
      ( wcel cn cexp co c3 cuz cfv w3a wa wn caddc fltlem14 wceq fltval biimpri
      wne 3expia necon3bd mpi ) HUAUBUCQZIRQJRQKRQUDZUEZHFQZUFIHSTJHSTUGTZKHSTZ
      ULABCDEFGHIJKLMNOPUHURUSUTVAUPUQUTVAUIZUSUSUPUQVBUDEFHIJKMUJUKUMUNUO @.
      @( [11-Aug-2015] @)
  @}

  flt @p |- ( ( N e. ( ZZ>= ` 3 ) /\ ( X e. NN /\ Y e. NN /\ Z e. NN ) )
    -> ( ( X ^ N ) + ( Y ^ N ) ) =/= ( Z ^ N ) ) @=
    ? @.
$)

$(
###############################################################################
               GRAPH THEORY
###############################################################################
<HTML>
<br><br>
To give an overview of the definitions and terms used in the context of graph
theory, a glossary is provided in the following, mainly according to
Definitions in [Bollobas] p. 1-8. Although this glossary concentrates on
<b>undirected graphs</b>, many of the concepts are also useful for directed
graphs.
<br><br>
Basic kinds of graphs:
<table border="1" id="graph-theory-glossary1">
<tr><th>Term</th><th>Reference</th><th>Definition</th><th>Remarks</th></tr>
<tr><td><b>(Undirected) Hypergraph</b></td><td> ~ df-uhgra </td><td>an ordered
  pair ` <. V , E >. ` of a set ` V ` and a function ` E ` into the powerset of
  ` V ` ( ` ran E C_ ( ~P V ) ` ).<br>
  An element of ` V ` is called <b>"vertex"</b>, an element of ` ran E ` is
  called <b>"edge"</b>, the function ` E ` is called the <b>"edge-function"
  </b>.</td>
  <td>In this most general definition of a graph, an "edge" may connect three
  or more vertices with each other, compare with the definition in Section I.1
  in [Bollobas] p. 7. </td></tr>
<tr><td><b>Undirected multigraph</b></td><td> ~ df-umgra </td><td>a graph
  ` <. V , E >. ` such that ` E ` is a function into the set of (proper or not
  proper) unordered pairs of ` V `.</td><td>A proper unordered pair contains
  two different elements, a not proper unordered pair contains two times the
  same element, so it is a singleton (see ~ preqsn ).<br> According to the
  definition in Section I.1 in [Bollobas] p. 7, "In a multigraph both
  <b>multiple edges</b> [joining two vertices] and multiple <b>loops</b>
  [joining a vertex to itself] are allowed".</td></tr>
<tr><td><b>Undirected simple graph with loops</b></td><td> ~ df-uslgra </td>
  <td>a graph ` <. V , E >. ` such that ` E ` is a one-to-one function into the
  set of (proper or not proper) unordered pairs of ` V `.</td><td>This means
  that there is at most one edge between two vertices, and at most one loop
  from a vertex to itself.
  </td></tr>
<tr><td><b>Undirected simple graph without loops</b> (in short <b>"simple
  graph"</b>)</td><td> ~ df-usgra </td><td>a graph ` <. V , E >. ` such that
  ` E ` is a one-to-one function into the set of (proper) unordered pairs of
  ` V `.</td><td>An ordered pair ` <. V , E >. ` of two distinct sets ` V ` and
  ` E ` (the "usual" definition of a "graph", see, for example, the definition
  in Section I.1 in [Bollobas] p. 1) can be identified with an undirected
  simple graph without loops by "indexing" the edges with themselves, see
  ~ ausisusgra .</td></tr>
<tr><td><b>Finite graph</b></td><td>---</td><td>a graph ` <. V , E >. ` with
  finite sets ` V ` and ` E `.</td><td>In simple graphs, ` E ` is finite if
  ` V ` is finite, see ~ usgrafis . The number of edges is limited by
  ` ( n _C 2 ) ` (or "` n ` choose 2") with ` n = ( # `` V ) `, see
  ~ usgramaxsize . Analogously, the number of edges of an undirected simple
  graph with loops is limited by ` ( ( n + 1 ) _C 2 ) ` . In multigraphs,
  however, ` E ` can be infinite although ` V ` is finite.</td></tr>
<tr><td><b>Graph of finite size</b></td><td>---</td><td>a graph ` <. V , E >. `
  with finite set ` E `, i.e. with a finite number of edges.</td><td>A graph
  can be of finite size although ` V ` is infinite.</td></tr>
</table>
<br><br>
Terms and properties of graphs:
<table border="1" id="graph-theory-glossary2">
<tr><th>Term</th><th>Reference</th><th>Definition</th><th>Remarks</th></tr>
<tr><td><b>Edge joining (two) vertices</b></td>
<td>---</td>
<td>An edge ` e e. ran E ` <b>"joins"</b> the vertices v_1, v_2, ... v_n
( ` n e. NN ` ) if ` e ` = { v_1, v_2, ... v_n }.</td>
<td>If ` n = 1 ` , ` e ` = { v_1 } is a "loop", if ` n = 2 ` , ` e ` =
  { v_1 , v_2 } is an egde as it is usually defined, see definition in
  Section I.1 in [Bollobas] p. 1.</td></tr>
<tr><td><b>(Two) Endvertices of an edge</b></td>
<td> see definition in Section I.1 in [Bollobas] p. 1.</td>
<td>If an edge ` e e. ran E ` joins the vertices v_1, v_2, ... v_n
  ( ` n e. NN ` ), then the vertices v_1, v_2, ... v_n are called the
  <b>"endvertices"</b> of the edge ` e `.</td>
<td></td></tr>
<tr><td><b>(Two) Adjacent vertices</b></td>
<td> see definition in Section I.1 in [Bollobas] p. 1/2.</td>
<td>The vertices v_1, v_2, ... v_n ( ` n e. NN ` ) are <b>"adjacent"</b> if
  there is an edge e = { v_1, v_2, ... v_n } joining these vertices. In this
  case, the vertices are <b>"incident"</b> with the edge e (see definition in
  Section I.1 in [Bollobas] p. 2) or "connected" by the edge e.</td>
<td></td></tr>
<tr><td><b>(Two) Adjacent edges</b></td>
<td></td>
<td>The edges e_0, e_1, ... e_n ( ` n e. NN ` ) are <b>"adjacent"</b> if they
  have exactly one common endvertex.</td>
<td>Generalization of definition in Section I.1 in [Bollobas] p. 2.</td></tr>
<tr><td><b>Order of a graph</b></td>
<td>see definition in Section I.1 in [Bollobas] p. 3</td>
<td>the <b>"order"</b> of a graph ` <. V , E >. ` is the number of vertices in
  the graph ( ` ( # `` V ) ` ).</td>
<td></td></tr>
<tr><td><b>Size of a graph</b></td>
<td>see definition in Section I.1 in [Bollobas] p. 3</td>
<td>the <b>"size"</b> of a graph ` <. V , E >. ` is the number of edges in the
  graph ( ` ( # `` E ) ` ).</td>
<td></td></tr>
<tr><td><b>Neighborhood of a vertex</b></td>
<td> ~ df-nbgra resp. definition in Section I.1 in [Bollobas] p. 3</td>
<td>A vertex connected with a vertex ` v ` by an edge is called a
  <b>"neighbor"</b> of the vertex ` v `. The set of neighbors of a vertex ` v `
  is called the <b>"neighborhood"</b> (or <b>"open neighborhood"</b>) of the
  vertex ` v `. The <b>"closed neighborhood"</b> is the union of the (open)
  neighborhood of the vertex ` v ` with ` { v } `.</td>
<td></td></tr>
<tr><td><b>Degree of a vertex</b></td>
<td>~ df-vdgr </td>
<td>The <b>"degree"</b> of a vertex is the number of the
  edges having this vertex as endvertex.</td>
<td>In a simple graph, the degree of a vertex is the number of neighbors of
  this vertex, see definition in Section I.1 in [Bollobas] p. 3</td></tr>
<tr><td><b>Isolated vertex</b></td>
<td> ~ usgravd0nedg </td>
<td>A vertex is called <b>"isolated"</b> if it is not an endvertex of any edge,
  thus having degree 0.</td>
<td></td></tr>
<tr><td><b>Universal vertex</b></td>
<td> ~ df-uvtx </td>
<td>A vertex is called <b>"universal"</b> if it is connected with every other
  vertex of the graph by an edge, thus having degree ` ( # `` V ) ` .</td>
<td></td></tr>
</table>
<br><br>
Special kinds of graphs:
<table border="1" id="graph-theory-glossary2">
<tr><th>Term</th><th>Reference</th><th>Definition</th><th>Remarks</th></tr>
<tr><td><b>Complete graph</b></td>
<td> ~ df-cusgra </td>
<td>A graph is called <b>"complete"</b> if each pair of vertices is connected
  by an edge.</td>
<td>The size of a complete undirected simple graph of order ` n ` is
  ` ( n _C 2 ) ` (or "` n ` choose 2"), see ~ cusgrasize .</td></tr>
<tr><td><b>Empty graph</b></td>
<td> ~ umgra0 and ~ usgra0 </td>
<td>A graph is called <b>"empty"</b> if it has no edges.</td>
<td></td></tr>
<tr><td><b>Null graph</b></td>
<td> ~ usgra0v </td>
<td>A graph is called the <b>"null graph"</b> if it has no vertices (and
  therefore also no edges).</td>
<td></td></tr>
<tr><td><b>Trivial graph</b></td>
<td> ~ usgra1v </td>
<td>A graph is called the <b>"trivial graph"</b> if it has only one vertex and
 no edges.</td>
<td></td></tr>
<tr><td><b>Connected graph</b></td>
<td> ~ df-conngra resp. definition in Section I.1 in [Bollobas] p. 6</td>
<td>A graph is called <b>"connected"</b> if for each pair of vertices there is
  a path between these vertices.</td>
<td></td></tr>
</table>
<br><br>
For the terms <b>"Path"</b>, <b>"Walk"</b>, <b>"Trail"</b>, <b>"Circuit"</b>,
<b>"Cycle"</b> see the remarks below and the definitions in Section I.1 in
[Bollobas] p. 4-5.
<HTML>
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Undirected graphs - basics
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Undirected hypergraphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c UHGrph $.

  $( Extend class notation with undirected hypergraphs. $)
  cuhg $a class UHGrph $.

  ${
    $d e v x $.
    $( Define the class of all undirected hypergraphs.  An undirected
       hypergraph is a pair of a set and a function into the powerset of this
       set (the empty set excluded).  (Contributed by Alexander van der Vekens,
       26-Dec-2017.) $)
    df-uhgra $a |- UHGrph
                   = { <. v , e >. | e : dom e --> ( ~P v \ { (/) } ) } $.

    $( The class of all undirected hypergraphs is a relation.  (Contributed by
       Alexander van der Vekens, 26-Dec-2017.) $)
    reluhgra $p |- Rel UHGrph $=
      ( ve vv cv cdm cpw c0 csn cdif wf cuhg df-uhgra relopabi ) ACZDBCEFGHMIBA
      JBAKL $.
  $}

  $( The classes of vertices and edges of an undirected hypergraph are sets.
     (Contributed by Alexander van der Vekens, 26-Dec-2017.) $)
  uhgrav $p |- ( V UHGrph E -> ( V e. _V /\ E e. _V ) ) $=
    ( cuhg wbr cvv wcel reluhgra brrelexi brrelex2i jca ) BACDBEFAEFBACGHBACGIJ
    $.

  ${
    $d e v E $.  $d e v V $.
    $( The property of being an undirected hypergraph.  (Contributed by
       Alexander van der Vekens, 26-Dec-2017.) $)
    isuhgra $p |- ( ( V e. W /\ E e. X ) -> ( V UHGrph E <->
      E : dom E --> ( ~P V \ { (/) } ) ) ) $=
      ( ve vv cv cdm cpw c0 csn cdif wf cuhg wceq wa simpr dmeq adantl pweq
      difeq1d adantr feq123d df-uhgra brabga ) EGZHZFGZIZJKZLZUFMAHZBIZUJLZAMFE
      BANCDUHBOZUFAOZPUGULUKUNUFAUOUPQUPUGULOUOUFARSUOUKUNOUPUOUIUMUJUHBTUAUBUC
      FEUDUE $.

    $( The edge function of an undirected hypergraph is a function into the
       power set of the set of vertices.  (Contributed by Alexander van der
       Vekens, 26-Dec-2017.) $)
    uhgraf $p |- ( V UHGrph E -> E : dom E --> ( ~P V \ { (/) } ) ) $=
      ( cuhg wbr cdm cpw c0 csn cdif wf cvv wcel wa wb uhgrav isuhgra syl ibi )
      BACDZAEBFGHIAJZSBKLAKLMSTNABOABKKPQR $.

    $( The edge function of an undirected hypergraph is a function.
       (Contributed by Alexander van der Vekens, 26-Dec-2017.) $)
    uhgrafun $p |- ( V UHGrph E -> Fun E ) $=
      ( cuhg wbr cdm cpw c0 csn cdif wf wfun uhgraf ffun syl ) BACDAEZBFGHIZAJA
      KABLOPAMN $.
  $}

  $( An edge is a subset of vertices, analogous to ~ umgrass .  (Contributed by
     Alexander van der Vekens, 26-Dec-2017.) $)
  uhgrass $p |- ( ( V UHGrph E /\ F e. dom E ) -> ( E ` F ) C_ V ) $=
    ( cuhg wbr cdm wcel wa cfv cpw c0 csn cdif uhgraf ffvelrnda eldifad elpwid
    ) CADEZBAFZGHZBAIZCTUACJZKLZRSUBUCMBAACNOPQ $.

  $( Equality of hypergraphs.  (Contributed by Alexander van der Vekens,
     26-Dec-2017.) $)
  uhgraeq12d $p |- ( ( ( V e. X /\ E e. Y ) /\ ( V = W /\ E = F ) )
                     -> ( V UHGrph E <-> W UHGrph F ) ) $=
    ( wcel wa wceq cdm cpw cdif wf cuhg wbr wb adantl adantr isuhgra wi c0 dmeq
    csn simpr pweq difeq1d feq123d eleq1 biimpd com12 imp syl2anc 3bitr4d ) CEG
    ZAFGZHZCDIZABIZHZHZAJZCKZUAUCZLZAMZBJZDKZVCLZBMZCANOZDBNOZUSVEVIPUPUSVAVFVD
    VHABUQURUDURVAVFIUQABUBQUQVDVHIURUQVBVGVCCDUEUFRUGQUPVJVEPUSACEFSRUTDEGZBFG
    ZVKVIPUPUSVLUNUSVLTUOUSUNVLUQUNVLTURUQUNVLCDEUHUIRUJRUKUPUSVMUOUSVMTUNUSUOV
    MURUOVMTUQURUOVMABFUHUIQUJQUKBDEFSULUM $.

  $( A subgraph of a hypergraph (formed by removing some edges from the
     original graph) is a hypergraph, analogous to ~ umgrares .  (Contributed
     by Alexander van der Vekens, 27-Dec-2017.) $)
  uhgrares $p |- ( V UHGrph E -> V UHGrph ( E |` A ) ) $=
    ( cuhg wbr cres cdm cpw c0 csn cdif wf wss uhgraf resss dmss mp1i cvv wcel
    wa fssres syl2anc resdmres feq1i sylib wb uhgrav resexg anim2i isuhgra 3syl
    mpbird ) CBDEZCBAFZDEZUNGZCHIJKZUNLZUMUPUQBUPFZLZURUMBGZUQBLUPVAMZUTBCNUNBM
    VBUMBAOUNBPQVAUQUPBUAUBUPUQUSUNBAUCUDUEUMCRSZBRSZTVCUNRSZTUOURUFBCUGVDVEVCB
    ARUHUIUNCRRUJUKUL $.

  $( The empty graph, with vertices but no edges, is a hypergraph, analogous to
     ~ umgra0 .  (Contributed by Alexander van der Vekens, 27-Dec-2017.) $)
  uhgra0 $p |- ( V e. W -> V UHGrph (/) ) $=
    ( wcel c0 cuhg wbr cdm cpw csn cdif wf f0 dm0 feq2i mpbir cvv isuhgra mpan2
    wb 0ex mpbiri ) ABCZADEFZDGZAHDIJZDKZUFDUEDKUELUDDUEDMNOUBDPCUCUFSTDABPQRUA
    $.

  $( The null graph, with no vertices, is a hypergraph if and only if the edge
     function is empty.  (Contributed by Alexander van der Vekens,
     27-Dec-2017.) $)
  uhgra0v $p |- ( (/) UHGrph E <-> E = (/) ) $=
    ( c0 cuhg wbr wceq cvv wcel wa uhgrav cdm cpw csn cdif isuhgra eqid difeq1i
    wf pw0 difid eqtri feq23i f00 simplbi sylbi syl6bi mpcom uhgra0 ax-mp breq2
    0ex mpbiri impbii ) BACDZABEZBFGZAFGHZUMUNABIUPUMAJZBKZBLZMZAQZUNABFFNVAUQB
    AQZUNUQUTUQBAUQOUTUSUSMBURUSUSRPUSSTUAVBUNUQBEUQAUBUCUDUEUFUNUMBBCDZUOVCUJB
    FUGUHABBCUIUKUL $.

  ${
    uhgraun.e $e |- ( ph -> E Fn A ) $.
    uhgraun.f $e |- ( ph -> F Fn B ) $.
    uhgraun.i $e |- ( ph -> ( A i^i B ) = (/) ) $.
    uhgraun.ge $e |- ( ph -> V UHGrph E ) $.
    uhgraun.gf $e |- ( ph -> V UHGrph F ) $.
    $( If ` <. V , E >. ` and ` <. V , F >. ` are hypergraphs, then
       ` <. V , E u. F >. ` is a hypergraph (the vertex set stays the same, but
       the edges from both graphs are kept, maybe resulting in two edges
       between two vertices), analogous to ~ umgraun .  (Contributed by
       Alexander van der Vekens, 27-Dec-2017.) $)
    uhgraun $p |- ( ph -> V UHGrph ( E u. F ) ) $=
      ( cuhg wbr cdm wf syl feq2d syl2anc wcel cvv cun cpw c0 csn cdif cin wceq
      wfn uhgraf fndm biimpac fun2 syl21anc fdm mpbird wb wrel reluhgra releldm
      sylancr uhgrav simprd unexg isuhgra ) AFDEUAZLMZVENZFUBUCUDUEZVEOZAVIBCUA
      ZVHVEOZABVHDOZCVHEOZBCUFUCUGVKADNZVHDOZDBUHZVLAFDLMZVOJDFUIPGVPVOVLVPVNBV
      HDBDUJQUKRAENZVHEOZECUHZVMAFELMZVSKEFUIPHVTVSVMVTVRCVHECEUJQUKRIBCVHDEULU
      MZAVGVJVHVEAVKVGVJUGWBVJVHVEUNPQUOAFLNZSZVETSZVFVIUPALUQVQWDURJFDLUSUTADT
      SZETSZWEAVQWFJVQFTSZWFDFVAVBPAWAWGKWAWHWGEFVAVBPDETTVCRVEFWCTVDRUO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Undirected multigraphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c UMGrph $.

  $( Extend class notation with undirected multigraphs. $)
  cumg $a class UMGrph $.

  ${
    $d e f k n p u v x $.
    $( Define the class of all undirected multigraphs.  A multigraph is a pair
       ` <. V , E >. ` where ` E ` is a function into subsets of ` V ` of
       cardinality one or two, representing the two vertices incident to the
       edge, or the one vertex if the edge is a loop.  (Contributed by Mario
       Carneiro, 11-Mar-2015.) $)
    df-umgra $a |- UMGrph = { <. v , e >. | e : dom e -->
       { x e. ( ~P v \ { (/) } ) | ( # ` x ) <_ 2 } } $.

    $( The class of all undirected multigraphs is a relation.  (Contributed by
       Mario Carneiro, 11-Mar-2015.) $)
    relumgra $p |- Rel UMGrph $=
      ( ve vx vv cv cdm chash cfv c2 cle wbr cpw c0 csn cdif crab cumg df-umgra
      wf relopabi ) ADZEBDFGHIJBCDKLMNOTRCAPBCAQS $.
  $}

  ${
    $d x y A $.  $d e v x y E $.  $d x y F $.  $d e v x y V $.  $d x y W $.
    $d x B $.  $d x C $.
    $( The property of being an undirected multigraph.  (Contributed by Mario
       Carneiro, 11-Mar-2015.) $)
    isumgra $p |- ( ( V e. W /\ E e. X ) -> ( V UMGrph E <->
      E : dom E --> { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) ) $=
      ( ve vv cv cdm chash cfv c2 cle wbr cpw c0 cdif crab wf wceq csn wa simpr
      cumg dmeqd feq12d wb simpl pweqd difeq1d rabeq feq3 bitrd df-umgra brabga
      3syl ) FHZIZAHJKLMNZAGHZOZPUAZQZRZUQSZBIZUSACOZVBQZRZBSZGFCBUDDEUTCTZUQBT
      ZUBZVEVFVDBSZVJVMURVFVDUQBVKVLUCZVMUQBVOUEUFVMVCVHTVDVITVNVJUGVMVAVGVBVMU
      TCVKVLUHUIUJUSAVCVHUKVDVIVFBULUPUMAGFUNUO $.

    $( The property of being an undirected multigraph.  (Contributed by Mario
       Carneiro, 11-Mar-2015.) $)
    wrdumgra $p |- ( ( V e. W /\ E e. Word X ) -> ( V UMGrph E <->
      E e. Word { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) ) $=
      ( wcel cword wa cumg wbr cdm cv chash cfv c2 cle cpw c0 wf wrdf cdif crab
      csn isumgra cc0 cfzo wceq adantl fdm syl feq2d iswrdi impbii syl6bb bitrd
      co ) CDFZBEGZFZHZCBIJBKZALMNOPJACQRUCUAUBZBSZBVBGFZABCDURUDUTVCUEBMNZUFUP
      ZVBBSZVDUTVAVFVBBUTVFEBSZVAVFUGUSVHUQEBTUHVFEBUIUJUKVGVDVBVEBULVBBTUMUNUO
      $.

    $( The edge function of an undirected multigraph is a function into
       unordered pairs of vertices.  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    umgraf2 $p |- ( V UMGrph E ->
      E : dom E --> { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) $=
      ( cumg wbr cdm cv chash cfv c2 cle cpw c0 csn cdif crab cvv wcel relumgra
      wf wb brrelexi brrelex2i isumgra syl2anc ibi ) CBDEZBFAGHIJKEACLMNOPBTZUG
      CQRBQRUGUHUACBDSUBCBDSUCABCQQUDUEUF $.

    $( The edge function of an undirected multigraph is a function into
       unordered pairs of vertices.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    umgraf $p |- ( ( V UMGrph E /\ E Fn A ) ->
      E : A --> { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) $=
      ( cumg wbr wfn cv chash cfv c2 cle cpw c0 csn cdif crab wf cdm umgraf2
      fndm feq2d syl5ibcom imp ) DCEFZCBGZBAHIJKLFADMNOPQZCRZUECSZUGCRUFUHACDTU
      FUIBUGCBCUAUBUCUD $.

    $( An edge is a subset of vertices.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    umgrass $p |- ( ( V UMGrph E /\ E Fn A /\ F e. A ) ->
      ( E ` F ) C_ V ) $=
      ( vx cumg wbr wfn wcel w3a cfv cv chash c2 cle cpw c0 csn cdif crab difss
      ssrab2 sstri wa umgraf ffvelrnda 3impa sseldi elpwid ) DBFGZBAHZCAIZJZCBK
      ZDUMELMKNOGZEDPZQRZSZTZUPUNUSURUPUOEURUBUPUQUAUCUJUKULUNUSIUJUKUDAUSCBEAB
      DUEUFUGUHUI $.

    $( An edge is a nonempty subset of vertices.  (Contributed by Mario
       Carneiro, 11-Mar-2015.) $)
    umgran0 $p |- ( ( V UMGrph E /\ E Fn A /\ F e. A ) ->
      ( E ` F ) =/= (/) ) $=
      ( vx cumg wbr wfn wcel w3a cfv cpw c0 csn cdif wne cv chash c2 cle ssrab2
      crab wa umgraf ffvelrnda 3impa sseldi eldifsni syl ) DBFGZBAHZCAIZJZCBKZD
      LZMNOZIUNMPUMEQRKSTGZEUPUBZUPUNUQEUPUAUJUKULUNURIUJUKUCAURCBEABDUDUEUFUGU
      NUOMUHUI $.

    $( An edge has at most two ends.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    umgrale $p |- ( ( V UMGrph E /\ E Fn A /\ F e. A ) ->
      ( # ` ( E ` F ) ) <_ 2 ) $=
      ( vx cumg wbr wfn wcel w3a cfv cv chash c2 cle cpw c0 csn cdif crab 3impa
      wa umgraf ffvelrnda wceq fveq2 breq1d elrab simprbi syl ) DBFGZBAHZCAIZJC
      BKZELZMKZNOGZEDPQRSZTZIZUNMKZNOGZUKULUMUTUKULUBAUSCBEABDUCUDUAUTUNURIVBUQ
      VBEUNURUOUNUEUPVANOUOUNMUFUGUHUIUJ $.

    $( An edge is a finite subset of vertices.  (Contributed by Mario Carneiro,
       11-Mar-2015.) $)
    umgrafi $p |- ( ( V UMGrph E /\ E Fn A /\ F e. A ) ->
      ( E ` F ) e. Fin ) $=
      ( cumg wbr wfn wcel w3a cfv chash c2 cle cfn umgrale wn cpnf 2re cxr cvv
      cr ltpnf ax-mp wb rexri pnfxr xrltnle mp2an mpbi wceq fvex hashinf breq1d
      clt mpan mtbiri con4i syl ) DBEFBAGCAHICBJZKJZLMFZUSNHZABCDOVBVAVBPZVAQLM
      FZLQUNFZVDPZLUAHVERLUBUCLSHQSHVEVFUDLRUEUFLQUGUHUIVCUTQLMUSTHVCUTQUJCBUKU
      STULUOUMUPUQUR $.

    $( An edge is an unordered pair of vertices.  (Contributed by Mario
       Carneiro, 11-Mar-2015.) $)
    umgraex $p |- ( ( V UMGrph E /\ E Fn A /\ F e. A ) ->
      E. x e. V E. y e. V ( E ` F ) = { x , y } ) $=
      ( wbr wcel cfv wceq wa wex c0 wne adantr wss sylibr syl2anc cfn cvv cv n0
      cumg wfn w3a cpr wrex umgran0 sylib umgrass sselda csn simpr ssdif0 snssd
      eqssd preq2 dfsn2 syl6eqr eqeq2d rspcev simprr eldifad sseldd cen umgrafi
      cdif simprl prssi cdom fvex ssdomg mpsyl cle c2 umgrale eldifsni ad2antll
      chash necomd wb vex hashprg mp2an breqtrrd hashdom sylancl mpbid fisseneq
      prfi sbth syl3anc eqcomd jca expr eximdv imp df-rex sylan2b pm2.61dane ex
      mpd ) FDUCGDCUDECHUEZAUAZFHZEDIZXDBUAZUFZJZBFUGZKZALZXJAFUGXCXDXFHZALZXLX
      CXFMNXNCDEFUHAXFUBUIXCXMXKAXCXMXKXCXMKZXEXJXCXFFXDCDEFUJZUKZXOXJXFXDULZVG
      ZMXOXSMJZKZXEXFXRJZXJXOXEXTXQOYAXFXRYAXTXFXRPXOXTUMXFXRUNQXOXRXFPXTXOXDXF
      XCXMUMUOOUPXIYBBXDFXGXDJZXHXRXFYCXHXDXDUFXRXGXDXDUQXDURUSUTVARXSMNXOXGXSH
      ZBLZXJBXSUBXOYEKXGFHZXIKZBLZXJXOYEYHXOYDYGBXCXMYDYGXCXMYDKZKZYFXIYJXFFXGX
      CXFFPYIXPOYJXGXFXRXCXMYDVBVCZVDYJXHXFYJXFSHZXHXFPZXHXFVEGZXHXFJXCYLYICDEF
      VFOZYJXMXGXFHYMXCXMYDVHYKXDXGXFVIRZYJXHXFVJGZXFXHVJGZYNXFTHYJYMYQEDVKYPXH
      XFTVLVMYJXFVSIZXHVSIZVNGZYRYJYSVOYTVNXCYSVOVNGYICDEFVPOYJXDXGNZYTVOJZYJXG
      XDYDXGXDNXCXMXGXFXDVQVRVTXDTHXGTHUUBUUCWAAWBBWBXDXGTWCWDUIWEYJYLXHSHUUAYR
      WAYOXDXGWJXFXHSWFWGWHXHXFWKRXHXFWIWLWMWNWOWPWQXIBFWRQWSWTWNXAWPXBXJAFWRQ
      $.

    $( A subgraph of a graph (formed by removing some edges from the original
       graph) is a graph.  (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    umgrares $p |- ( V UMGrph E -> V UMGrph ( E |` A ) ) $=
      ( vx cumg wbr cres cdm cv chash cfv cle cpw wss syl2anc cvv wcel relumgra
      c2 wf c0 cdif crab umgraf2 resss dmss mp1i fssres resdmres feq1i sylib wb
      csn brrelexi brrelex2i resexg syl isumgra mpbird ) CBEFZCBAGZEFZVAHZDIJKS
      LFDCMUAUMUBUCZVATZUTVCVDBVCGZTZVEUTBHZVDBTVCVHNZVGDBCUDVABNVIUTBAUEVABUFU
      GVHVDVCBUHOVCVDVFVABAUIUJUKUTCPQVAPQZVBVEULCBERUNUTBPQVJCBERUOBAPUPUQDVAC
      PPUROUS $.

    $( The empty graph, with vertices but no edges, is a graph.  (Contributed
       by Mario Carneiro, 12-Mar-2015.) $)
    umgra0 $p |- ( V e. W -> V UMGrph (/) ) $=
      ( vx wcel c0 cumg wbr cdm cv chash cfv c2 cle cpw csn cdif crab wf f0 cvv
      dm0 feq2i mpbir wb 0ex isumgra mpan2 mpbiri ) ABDZAEFGZEHZCIJKLMGCANEOPQZ
      ERZUMEULERULSUKEULEUAUBUCUIETDUJUMUDUECEABTUFUGUH $.

    $( The graph with one edge.  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    umgra1 $p |- ( ( ( V e. W /\ A e. X ) /\ ( B e. V /\ C e. V ) ) ->
      V UMGrph { <. A , { B , C } >. } ) $=
      ( vx wcel wa csn wbr chash cfv c2 cle c0 wf wss cvv sylancl cpr cumg cdif
      cop cdm cpw crab wf1o simplr prex f1osng f1of syl wne prssi adantl sylibr
      elpw prnzg ad2antrl eldifsn sylanbrc cfn hashprlei simpri a1i wceq breq1d
      cv fveq2 elrab snssd fss syl2anc fdm feq2d mpbird wb simpll snex isumgra
      ) DEHZAFHZIZBDHZCDHZIZIZDABCUAZUDZJZUBKZWKUEZGVIZLMZNOKZGDUFZPJUCZUGZWKQZ
      WHWTAJZWSWKQZWHXAWIJZWKQZXCWSRXBWHXAXCWKUHZXDWHWCWISHXEWBWCWGUIBCUJZAWIFS
      UKTXAXCWKULUMWHWIWSWHWIWRHZWILMZNOKZWIWSHWHWIWQHZWIPUNZXGWHWIDRZXJWGXLWDB
      CDUOUPWIDXFURUQWEXKWDWFBCDUSUTWIWQPVAVBXIWHWIVCHXIBCVDVEVFWPXIGWIWRWNWIVG
      WOXHNOWNWILVJVHVKVBVLXAXCWSWKVMVNZWHWMXAWSWKWHXBWMXAVGXMXAWSWKVOUMVPVQWHW
      BWKSHWLWTVRWBWCWGVSWJVTGWKDESWATVQ $.
  $}

  ${
    $d x E $.  $d x V $.
    $( An undirected multigraph is an undirected hypergraph.  (Contributed by
       Alexander van der Vekens, 27-Dec-2017.) $)
    umisuhgra $p |- ( V UMGrph E -> V UHGrph E ) $=
      ( vx cvv wcel wa cumg wbr cuhg relumgra brrelexi brrelex2i jca cdm cpw c0
      csn cdif wf cv chash cfv c2 cle crab isumgra wss ssrab2 fss mpan2 isuhgra
      syl6bi sylibrd mpcom ) BDEZADEZFZBAGHZBAIHZURUOUPBAGJKBAGJLMUQURANZBOPQRZ
      ASZUSUQURUTCTUAUBUCUDHZCVAUEZASZVBCABDDUFVEVDVAUGVBVCCVAUHUTVDVAAUIUJULAB
      DDUKUMUN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x E $.  $d x F $.  $d x V $.
    umgraun.e $e |- ( ph -> E Fn A ) $.
    umgraun.f $e |- ( ph -> F Fn B ) $.
    umgraun.i $e |- ( ph -> ( A i^i B ) = (/) ) $.
    umgraun.ge $e |- ( ph -> V UMGrph E ) $.
    umgraun.gf $e |- ( ph -> V UMGrph F ) $.
    $( If ` <. V , E >. ` and ` <. V , F >. ` are graphs, then
       ` <. V , E u. F >. ` is a graph (the vertex set stays the same, but the
       edges from both graphs are kept).  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    umgraun $p |- ( ph -> V UMGrph ( E u. F ) ) $=
      ( vx cumg wbr wf syl2anc syl wcel cvv relumgra cun cdm cv chash cfv c2 c0
      cle cpw csn cdif crab cin wceq wfn umgraf fun2 syl21anc feq2d mpbird wrel
      fdm wb releldm sylancr brrelex2i unexg isumgra ) AFDEUAZMNZVIUBZLUCUDUEUF
      UHNLFUIUGUJUKULZVIOZAVMBCUAZVLVIOZABVLDOZCVLEOZBCUMUGUNVOAFDMNZDBUOVPJGLB
      DFUPPAFEMNZECUOVQKHLCEFUPPIBCVLDEUQURZAVKVNVLVIAVOVKVNUNVTVNVLVIVBQUSUTAF
      MUBZRZVISRZVJVMVCAMVAVRWBTJFDMVDVEADSRZESRZWCAVRWDJFDMTVFQAVSWEKFEMTVFQDE
      SSVGPLVIFWASVHPUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Undirected simple graphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                        Undirected simple graphs - basics
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c USLGrph $.
  $c USGrph $.

  $( Extend class notation with undirected (simple) graphs with loops. $)
  cuslg $a class USLGrph $.

  $( Extend class notation with undirected (simple) graphs (without loops). $)
  cusg $a class USGrph $.

  ${
    $d e v x $.
    $( Define the class of all undirected simple graphs with loops.  An
       undirected simple graph with loops is a special undirected multigraph
       ` <. V , E >. ` where ` E ` is an injective (one-to-one) function into
       subsets of ` V ` of cardinality one or two, representing the two
       vertices incident to the edge, or the one vertex if the edge is a loop.
       In contrast to a multigraph, there is at most one edge between two
       vertices.  (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    df-uslgra $a |- USLGrph = { <. v , e >. | e : dom e -1-1->
       { x e. ( ~P v \ { (/) } ) | ( # ` x ) <_ 2 } } $.

    $( Define the class of all undirected simple graphs without loops.  An
       undirected simple graph without loops is a special undirected simple
       graph ` <. V , E >. ` where ` E ` is an injective (one-to-one) function
       into subsets of ` V ` of cardinality two, representing the two vertices
       incident to the edge.  Such graphs are usually simply called "undirected
       graphs", so if only the term "undirected graph" is used, an undirected
       simple graph without loops is meant.  Therefore, an undirected graph has
       no loops (edges a vertex to itsself).  (Contributed by Alexander van der
       Vekens, 10-Aug-2017.) $)
    df-usgra $a |- USGrph = { <. v , e >. | e : dom e -1-1->
       { x e. ( ~P v \ { (/) } ) | ( # ` x ) = 2 } } $.

    $( The class of all undirected simple graph with loops is a relation.
       (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    reluslgra $p |- Rel USLGrph $=
      ( ve vx vv cv cdm chash cfv c2 cle wbr cpw c0 csn cdif crab wf1 df-uslgra
      cuslg relopabi ) ADZEBDFGHIJBCDKLMNOTPCARBCAQS $.

    $( The class of all undirected simple graph without loops is a relation.
       (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    relusgra $p |- Rel USGrph $=
      ( ve vx vv cv cdm chash cfv c2 wceq cpw c0 csn cdif wf1 df-usgra relopabi
      crab cusg ) ADZEBDFGHIBCDJKLMQSNCARBCAOP $.
  $}

  $( The classes of vertices and edges of an undirected simple graph with loops
     are sets.  (Contributed by Alexander van der Vekens, 20-Aug-2017.) $)
  uslgrav $p |- ( V USLGrph E -> ( V e. _V /\ E e. _V ) ) $=
    ( cuslg wbr cvv wcel reluslgra brrelexi brrelex2i jca ) BACDBEFAEFBACGHBACG
    IJ $.

  $( The classes of vertices and edges of an undirected simple graph without
     loops are sets.  (Contributed by Alexander van der Vekens,
     19-Aug-2017.) $)
  usgrav $p |- ( V USGrph E -> ( V e. _V /\ E e. _V ) ) $=
    ( cusg wbr cvv wcel relusgra brrelexi brrelex2i jca ) BACDBEFAEFBACGHBACGIJ
    $.

  ${
    $d e v x E $.  $d e v x V $.
    $( The property of being an undirected simple graph with loops.
       (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    isuslgra $p |- ( ( V e. W /\ E e. X ) -> ( V USLGrph E <->
      E : dom E -1-1-> { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) ) $=
      ( ve vv cv cdm chash cfv c2 cle cpw cdif crab wf1 wceq wb adantl c0 cuslg
      wbr csn wa f1eq1 dmeq f1eq2 syl simpl pweqd difeq1d rabeq f1eq3 df-uslgra
      3syl 3bitrd brabga ) FHZIZAHJKLMUCZAGHZNZUAUDZOZPZUSQZBIZVAACNZVDOZPZBQZG
      FCBUBDEVBCRZUSBRZUEZVGUTVFBQZVHVFBQZVLVNVGVPSVMUTVFUSBUFTVOUTVHRZVPVQSVNV
      RVMUSBUGTUTVHVFBUHUIVOVEVJRVFVKRVQVLSVOVCVIVDVOVBCVMVNUJUKULVAAVEVJUMVFVK
      VHBUNUPUQAGFUOUR $.

    $( The property of being an undirected simple graph without loops.
       (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    isusgra $p |- ( ( V e. W /\ E e. X ) -> ( V USGrph E <->
      E : dom E -1-1-> { x e. ( ~P V \ { (/) } ) | ( # ` x ) = 2 } ) ) $=
      ( ve vv cv cdm chash cfv c2 wceq cpw c0 cdif crab wf1 wb adantl csn f1eq1
      cusg wa dmeq f1eq2 syl simpl pweqd difeq1d rabeq f1eq3 3syl 3bitrd brabga
      df-usgra ) FHZIZAHJKLMZAGHZNZOUAZPZQZUQRZBIZUSACNZVBPZQZBRZGFCBUCDEUTCMZU
      QBMZUDZVEURVDBRZVFVDBRZVJVLVEVNSVKURVDUQBUBTVMURVFMZVNVOSVLVPVKUQBUETURVF
      VDBUFUGVMVCVHMVDVIMVOVJSVMVAVGVBVMUTCVKVLUHUIUJUSAVCVHUKVDVIVFBULUMUNAGFU
      PUO $.

    $( The edge function of an undirected simple graph with loops is a
       one-to-one function into unordered pairs of vertices.  (Contributed by
       Alexander van der Vekens, 10-Aug-2017.) $)
    uslgraf $p |- ( V USLGrph E ->
      E : dom E -1-1-> { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) $=
      ( cuslg wbr cdm cv chash cfv cle cpw csn cdif crab wf1 cvv wcel reluslgra
      c2 c0 wb brrelexi brrelex2i isuslgra syl2anc ibi ) CBDEZBFAGHISJEACKTLMNB
      OZUGCPQBPQUGUHUACBDRUBCBDRUCABCPPUDUEUF $.

    $( The edge function of an undirected simple graph without loops is a
       one-to-one function into unordered pairs of vertices.  (Contributed by
       Alexander van der Vekens, 10-Aug-2017.) $)
    usgraf $p |- ( V USGrph E ->
      E : dom E -1-1-> { x e. ( ~P V \ { (/) } ) | ( # ` x ) = 2 } ) $=
      ( cusg wbr cdm cv chash cfv c2 wceq cpw c0 csn cdif crab wf1 cvv wcel wa
      wb usgrav isusgra syl ibi ) CBDEZBFAGHIJKACLMNOPBQZUFCRSBRSTUFUGUABCUBABC
      RRUCUDUE $.

    $d x W $.  $d x X $.
    $( The property of being an undirected simple graph without loops.
       (Contributed by Alexander van der Vekens, 13-Aug-2017.) $)
    isusgra0 $p |- ( ( V e. W /\ E e. X ) -> ( V USGrph E <->
                     E : dom E -1-1-> { x e. ~P V | ( # ` x ) = 2 } ) ) $=
      ( wcel wa cusg wbr c2 wceq c0 crab wf1 wb cab wn cc0 cvv df-rab cdm chash
      cv cfv cpw csn cdif isusgra vex hasheq0 ax-mp wne 2ne0 id neeqtrrd necomd
      a1i neneqd sylbir con2i adantl elsn sylnibr biantrud syl6rbbr ex pm5.32rd
      eldif abbidv 3eqtr4g f1eq3 syl bitrd ) CDFBEFGZCBHIBUAZAUCZUBUDZJKZACUEZL
      UFZUGZMZBNZVOVRAVSMZBNZABCDEUHVNWBWDKWCWEOVNVPWAFZVRGZAPVPVSFZVRGZAPWBWDV
      NWGWIAVNVRWFWHVNVRWFWHOVNVRGZWHWHVPVTFZQZGWFWJWLWHWJVPLKZWKVRWMQVNWMVRWMV
      QRKZVRQVPSFWNWMOAUIVPSUJUKWNVQJWNJVQWNJRVQJRULWNUMUQWNUNUOUPURUSUTVAALVBV
      CVDVPVSVTVHVEVFVGVIVRAWATVRAVSTVJWBWDVOBVKVLVM $.

    $( The edge function of an undirected simple graph without loops is a
       one-to-one function into unordered pairs of vertices.  (Contributed by
       Alexander van der Vekens, 13-Aug-2017.) $)
    usgraf0 $p |- ( V USGrph E
                    -> E : dom E -1-1-> { x e. ~P V | ( # ` x ) = 2 } ) $=
      ( cusg wbr cdm cv chash cfv c2 wceq cpw crab wf1 cvv wcel usgrav isusgra0
      wa wb syl ibi ) CBDEZBFAGHIJKACLMBNZUCCOPBOPSUCUDTBCQABCOORUAUB $.

    $( The edge function of an undirected simple graph without loops is a
       function.  (Contributed by Alexander van der Vekens, 18-Aug-2017.) $)
    usgrafun $p |- ( V USGrph E -> Fun E ) $=
      ( vx cusg wbr cdm cv chash cfv wceq cpw crab wf1 wfun usgraf0 f1fun syl
      c2 ) BADEAFZCGHIRJCBKLZAMANCABOSTAPQ $.
  $}

  ${
    $d e v x E $.  $d e v x V $.  $d x X $.  $d x Y $.
    ausgra.1 $e |- G = { <. v , e >. | e C_ { x e. ~P v | ( # ` x ) = 2 } } $.
    $( The property of an unordered pair to be an alternatively defined
       undirected simple graph without loops (defined as a pair (V,E) of a set
       V (vertex set) and a set of unordered pairs of elements of V (edge
       set).  (Contributed by Alexander van der Vekens, 28-Aug-2017.) $)
    isausgra $p |- ( ( V e. W /\ E e. X )
                     -> ( V G E <-> E C_ { x e. ~P V | ( # ` x ) = 2 } ) ) $=
      ( cv chash cfv c2 wceq cpw crab wss wa simpr pweq biidd rabeqbidv sseq12d
      adantr brabga ) CJZAJKLMNZABJZOZPZQDUGAFOZPZQBCFDEGHUHFNZUFDNZRZUFDUJULUM
      UNSUOUGUGAUIUKUMUIUKNUNUHFTUDUOUGUAUBUCIUE $.

    $( The equivalence of the definitions of an undirected simple graph without
       loops.  (Contributed by Alexander van der Vekens, 28-Aug-2017.) $)
    ausisusgra $p |- ( ( V e. X /\ E e. Y )
                       -> ( V G E <-> V USGrph ( _I |` E ) ) ) $=
      ( wcel wa wbr wceq wss wf1 wi wb ax-mp a1d sylbi cv chash cfv c2 cpw crab
      cid cres cdm cusg isausgra wf1o f1oi crn dff1o5 dmresi eqcomi f1eq2 sylib
      f1ss ex adantr wf f1f wfn df-f rnresi sseq1i biimpi adantl syl impbid cvv
      com12 resiexg isusgra0 bicomd sylan2 3bitrd ) FGJZDHJZKZFDELDAUAUBUCUDMAF
      UEUFZNZUGDUHZUIZWCWEOZFWEUJLZABCDEFGHIUKWBWDWGDDWEULZWBWDWGPZPZDUMWIDDWEO
      ZWEUNZDMZKWKDDWEUOWLWKWNWLWJWBWLWDWGWLWDKDWCWEOZWGDDWCWEUTDWFMWOWGQWFDDUP
      UQDWFWCWEURRUSVASVBTRWGWBWDWGWFWCWEVCZWBWDPZWFWCWEVDWPWEWFVEZWMWCNZKWQWFW
      CWEVFWSWQWRWSWDWBWSWDWMDWCDVGVHVISVJTVKVNVLWAVTWEVMJZWGWHQDHVOVTWTKWHWGAW
      EFGVMVPVQVRVS $.
  $}

  $( An edge of an undirected simple graph as second component of an ordered
     pair.  (Contributed by Alexander van der Vekens, 17-Aug-2017.)  (Proof
     shortened by Alexander van der Vekens, 16-Dec-2017.) $)
  usgraedgop $p |- ( ( V USGrph E /\ X e. dom E ) -> ( ( E ` X ) = { M , N }
                     <-> <. X , { M , N } >. e. E ) ) $=
    ( cusg wbr wfun cdm wcel cfv cpr wceq cop wb usgrafun funopfvb sylan ) DAFG
    AHEAIJEAKBCLZMESNAJOADPESAQR $.

  ${
    $d E x $.  $d V x $.
    $( The edge function of an undirected simple graph without loops is a one
       to one function.  (Contributed by Alexander van der Vekens,
       18-Nov-2017.) $)
    usgraf1o $p |- ( V USGrph E -> E : dom E -1-1-onto-> ran E ) $=
      ( vx cusg wbr cdm cv chash cfv wceq cpw crab wf1 crn wf1o usgraf0 f1f1orn
      c2 syl ) BADEAFZCGHIRJCBKLZAMTANAOCABPTUAAQS $.
  $}

  $( The edge function of an undirected simple graph without loops is a one to
     one function.  (Contributed by Alexander van der Vekens, 18-Nov-2017.) $)
  usgraf1 $p |- ( V USGrph E -> E : dom E -1-1-> ran E ) $=
    ( cusg wbr cdm crn wf1o wf1 usgraf1o f1of1 syl ) BACDAEZAFZAGLMAHABILMAJK
    $.

  ${
    $d x E $.  $d x V $.
    $( An edge is a subset of vertices, analogous to ~ umgrass .  (Contributed
       by Alexander van der Vekens, 19-Aug-2017.) $)
    usgrass $p |- ( ( V USGrph E /\ F e. dom E ) -> ( E ` F ) C_ V ) $=
      ( vx cusg wbr cdm wcel wa cfv cv chash c2 wceq cpw crab ssrab2 wf usgraf0
      wf1 f1f syl ffvelrnda sseldi elpwid ) CAEFZBAGZHIZBAJZCUHDKLJMNZDCOZPZUKU
      IUJDUKQUFUGULBAUFUGULATUGULARDACSUGULAUAUBUCUDUE $.
  $}

  ${
    $d x E $.  $d x F $.  $d x V $.  $d x W $.  $d x X $.  $d x Y $.
    $( Equality of simple graphs without loops.  (Contributed by Alexander van
       der Vekens, 11-Aug-2017.) $)
    usgraeq12d $p |- ( ( ( V e. X /\ E e. Y ) /\ ( V = W /\ E = F ) )
                       -> ( V USGrph E <-> W USGrph F ) ) $=
      ( vx wcel wa wceq cdm cpw cdif crab wf1 cusg wbr adantl adantr wi cfv csn
      cv chash c2 c0 simprr dmeq pweq difeq1d biidd rabeqbidv f1eq123d wb eleq1
      isusgra biimpd com12 imp syl2anc 3bitr4d ) CEHZAFHZIZCDJZABJZIZIZAKZGUCUD
      UAUEJZGCLZUFUBZMZNZAOZBKZVJGDLZVLMZNZBOZCAPQZDBPQZVHVIVPVNVSABVDVEVFUGVGV
      IVPJZVDVFWCVEABUHRRVHVJVJGVMVRVHVKVQVLVGVKVQJZVDVEWDVFCDUISRUJVHVJUKULUMV
      DWAVOUNVGGACEFUPSVHDEHZBFHZWBVTUNVDVGWEVBVGWETVCVGVBWEVEVBWETVFVEVBWECDEU
      OUQSURSUSVDVGWFVCVGWFTVBVGVCWFVFVCWFTVEVFVCWFABFUOUQRURRUSGBDEFUPUTVA $.
  $}

  ${
    $d x E $.  $d x V $.
    $( An undirected simple graph with loops is an undirected multigraph.
       (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    uslisumgra $p |- ( V USLGrph E -> V UMGrph E ) $=
      ( vx cvv wcel wa cuslg wbr cumg uslgrav cdm cv chash cfv cle cpw csn cdif
      c2 c0 crab wf wf1 isuslgra f1f syl6bi isumgra sylibrd mpcom ) BDEADEFZBAG
      HZBAIHZABJUJUKAKZCLMNSOHCBPTQRUAZAUBZULUJUKUMUNAUCUOCABDDUDUMUNAUEUFCABDD
      UGUHUI $.

    $( An undirected simple graph without loops is an undirected simple graph
       with loops.  (Contributed by Alexander van der Vekens, 10-Aug-2017.)
       (Proof shortened by Alexander van der Vekens, 20-Mar-2018.) $)
    usisuslgra $p |- ( V USGrph E -> V USLGrph E ) $=
      ( vx cvv wcel wa cusg wbr cuslg usgrav cdm cv chash cfv c2 cle cpw c0 wf1
      crab csn cdif wceq isusgra wss 2re eqlei2 a1i ss2rabi f1ss mpan2 isuslgra
      wi syl6bi sylibrd mpcom ) BDEADEFZBAGHZBAIHZABJUQURAKZCLZMNZOPHZCBQRUAUBZ
      TZASZUSUQURUTVBOUCZCVDTZASZVFCABDDUDVIVHVEUEVFVGVCCVDVGVCUMVAVDEOVBUFUGUH
      UIUTVHVEAUJUKUNCABDDULUOUP $.
  $}

  $( An undirected simple graph without loops is an undirected multigraph.
     (Contributed by Alexander van der Vekens, 20-Aug-2017.) $)
  usisumgra $p |- ( V USGrph E -> V UMGrph E ) $=
    ( cusg wbr cuslg cumg usisuslgra uslisumgra syl ) BACDBAEDBAFDABGABHI $.

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x E $.  $d x V $.  $d x W $.
    $( A subgraph of a graph (formed by removing some edges from the original
       graph) is a graph, analogous to ~ umgrares .  (Contributed by Alexander
       van der Vekens, 10-Aug-2017.) $)
    usgrares $p |- ( V USGrph E -> V USGrph ( E |` A ) ) $=
      ( vx cusg wbr cres cdm cv chash cfv c2 wceq cpw wf1 wss wb cvv wcel wa c0
      csn cdif crab usgraf resss dmss mp1i f1ssres syl2anc resdmres f1eq1 ax-mp
      sylib usgrav resexg anim2i isusgra 3syl mpbird ) CBEFZCBAGZEFZVBHZDIJKLMD
      CNUAUBUCUDZVBOZVAVDVEBVDGZOZVFVABHZVEBOVDVIPZVHDBCUEVBBPVJVABAUFVBBUGUHVI
      VEVDBUIUJVGVBMVHVFQBAUKVDVEVGVBULUMUNVACRSZBRSZTVKVBRSZTVCVFQBCUOVLVMVKBA
      RUPUQDVBCRRURUSUT $.

    $( The empty graph, with vertices but no edges, is a graph, analogous to
       ~ umgra0 .  (Contributed by Alexander van der Vekens, 10-Aug-2017.) $)
    usgra0 $p |- ( V e. W -> V USGrph (/) ) $=
      ( vx wcel c0 cusg wbr cdm cv chash cfv c2 wceq cpw csn cdif crab wf1 cvv
      wb f10 dm0 f1eq2 ax-mp mpbir 0ex isusgra mpan2 mpbiri ) ABDZAEFGZEHZCIJKL
      MCANEOPQZERZUNEUMERZUMUAULEMUNUOTUBULEUMEUCUDUEUJESDUKUNTUFCEABSUGUHUI $.

    $( The empty graph with no vertices is a graph if and only if the edge
       function is empty.  (Contributed by Alexander van der Vekens,
       30-Sep-2017.) $)
    usgra0v $p |- ( (/) USGrph E <-> E = (/) ) $=
      ( vx c0 cusg wbr wceq cvv wcel wa usgrav cdm cv chash cfv c2 cpw cdif wf1
      crab eqidd csn isusgra pw0 difeq1i difid eqtri a1i biidd rabeqbidv syl6eq
      wi rab0 f1eq123d wf f1f f00 simplbi syl syl6bi adantl sylbid mpcom usgra0
      0ex ax-mp breq2 mpbiri impbii ) CADEZACFZCGHZAGHZIZVIVJACJVMVIAKZBLMNOFZB
      CPZCUAZQZSZARZVJBACGGUBVLVTVJUKVKVLVTVNCARZVJVLVNVNVSCAAVLATVLVNTVLVSVOBC
      SCVLVOVOBVRCVRCFVLVRVQVQQCVPVQVQUCUDVQUEUFUGVLVOUHUIVOBULUJUMWAVNCAUNZVJV
      NCAUOWBVJVNCFVNAUPUQURUSUTVAVBVJVICCDEZVKWCVDCGVCVEACCDVFVGVH $.

    $( The graph with one edge, analogous to ~ umgra1 .  (Contributed by
       Alexander van der Vekens, 10-Aug-2017.) $)
    uslgra1 $p |- ( ( ( V e. W /\ A e. X ) /\ ( B e. V /\ C e. V ) ) ->
      V USLGrph { <. A , { B , C } >. } ) $=
      ( vx wcel wa csn wbr chash cfv c2 cle c0 wf1 wss cvv sylancl cpr cuslg cv
      cop cdm cpw cdif crab wf1o simplr prex f1osng f1of1 syl prssi adantl elpw
      wne sylibr prnzg ad2antrl eldifsn sylanbrc cfn hashprlei simpri a1i fveq2
      wceq breq1d elrab snssd f1ss syl2anc wb f1dm f1eq2 mpbird simpll isuslgra
      3syl snex ) DEHZAFHZIZBDHZCDHZIZIZDABCUAZUDZJZUBKZWLUEZGUCZLMZNOKZGDUFZPJ
      UGZUHZWLQZWIXAAJZWTWLQZWIXBWJJZWLQZXDWTRXCWIXBXDWLUIZXEWIWDWJSHXFWCWDWHUJ
      BCUKZAWJFSULTXBXDWLUMUNWIWJWTWIWJWSHZWJLMZNOKZWJWTHWIWJWRHZWJPURZXHWIWJDR
      ZXKWHXMWEBCDUOUPWJDXGUQUSWFXLWEWGBCDUTVAWJWRPVBVCXJWIWJVDHXJBCVEVFVGWQXJG
      WJWSWOWJVIWPXINOWOWJLVHVJVKVCVLXBXDWTWLVMVNZWIXCWNXBVIXAXCVOXNXBWTWLVPWNX
      BWTWLVQWAVRWIWCWLSHWMXAVOWCWDWHVSWKWBGWLDESVTTVR $.

    $( The graph with one edge, analogous to ~ umgra1 ( with additional
       assumption that ` B =/= C ` since otherwise the edge is a loop!).
       (Contributed by Alexander van der Vekens, 10-Aug-2017.)  (Proof
       shortened by Alexander van der Vekens, 16-Dec-2017.) $)
    usgra1 $p |- ( ( ( V e. W /\ A e. X ) /\ ( B e. V /\ C e. V ) ) ->
      ( B =/= C -> V USGrph { <. A , { B , C } >. } ) ) $=
      ( vx wcel wa csn chash cfv c2 wceq wf1 cvv sylancl adantl adantr wb f1of1
      wne cpr cop cusg wbr cdm cv cpw crab wss wf1o simpllr prex f1osng prelpwi
      syl hashprg biimpa fveq2 eqeq1d elrab sylanbrc snssd f1ss f1dm f1eq2 3syl
      syl2anc mpbird simpll snex isusgra0 ex ) DEHZAFHZIZBDHCDHIZIZBCUBZDABCUCZ
      UDZJZUEUFZVSVTIZWDWCUGZGUHZKLZMNZGDUIZUJZWCOZWEWLAJZWKWCOZWEWMWAJZWCOZWOW
      KUKWNWEWMWOWCULZWPWEVPWAPHWQVOVPVRVTUMBCUNAWAFPUOQWMWOWCUAUQWEWAWKWEWAWJH
      ZWAKLZMNZWAWKHVSWRVTVRWRVQBCDUPRSVSVTWTVRVTWTTVQBCDURRUSWIWTGWAWJWGWANWHW
      SMWGWAKUTVAVBVCVDWMWOWKWCVEVIZWEWNWFWMNWLWNTXAWMWKWCVFWFWMWKWCVGVHVJVSWDW
      LTZVTVSVOWCPHXBVOVPVRVKWBVLGWCDEPVMQSVJVN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x E $.  $d x F $.  $d x V $.
    uslgraun.e $e |- ( ph -> E Fn A ) $.
    uslgraun.f $e |- ( ph -> F Fn B ) $.
    uslgraun.i $e |- ( ph -> ( A i^i B ) = (/) ) $.
    uslgraun.ge $e |- ( ph -> V USLGrph E ) $.
    uslgraun.gf $e |- ( ph -> V USLGrph F ) $.
    $( If ` <. V , E >. ` and ` <. V , F >. ` are (simple) graphs (with loops),
       then ` <. V , E u. F >. ` is a multigraph (the vertex set stays the
       same, but the edges from both graphs are kept, maybe resulting incident
       two edges between two vertices), analogous to ~ umgraun .  (Contributed
       by Alexander van der Vekens, 10-Aug-2017.) $)
    uslgraun $p |- ( ph -> V UMGrph ( E u. F ) ) $=
      ( cuslg wbr cumg uslisumgra syl umgraun ) ABCDEFGHIAFDLMFDNMJDFOPAFELMFEN
      MKEFOPQ $.
  $}

  ${
    $d x E $.  $d x V $.  $d x X $.
    $( The value of the "edge function" of a graph is a set containing two
       elements (the vertices the corresponding edge is connecting), analogous
       to ~ umgrale .  (Contributed by Alexander van der Vekens,
       11-Aug-2017.) $)
    usgraedg2 $p |- ( ( V USGrph E /\ X e. dom E )
                      -> ( # ` ( E ` X ) ) = 2 ) $=
      ( vx cusg wbr cdm wcel wa cfv cv chash c2 wceq cpw c0 csn cdif crab syl
      wf1 wf usgraf f1f ffvelrnda fveq2 eqeq1d elrab simprbi ) BAEFZCAGZHICAJZD
      KZLJZMNZDBOPQRZSZHZULLJZMNZUJUKUQCAUJUKUQAUAUKUQAUBDABUCUKUQAUDTUEURULUPH
      UTUOUTDULUPUMULNUNUSMUMULLUFUGUHUIT $.
  $}

  $( In an undirected graph, an edge is an unordered pair of vertices.
     (Contributed by Alexander van der Vekens, 19-Aug-2017.) $)
  usgraedgprv $p |- ( ( V USGrph E /\ X e. dom E )
                      -> ( ( E ` X ) = { M , N } -> ( M e. V /\ N e. V ) ) ) $=
    ( wcel wa cfv chash c2 wceq wi fveq2 cvv wn c1 syl ex c0 cc0 cusg usgraedg2
    wbr cdm wss cpr usgrass sseq1 eqeq1d anbi12d prssg biimprd adantrd wo ianor
    prprc1 hashsng sylan9eqr eqtr2 1ne2 pm2.21i expcom com12 prprc prcom eqeq1i
    neii hash0 syl6eq sylbi 2ne0 nesymi 3syl pm2.61i prprc2 jaoi adantld syl6bi
    csn syl2anc ) DAUAUCEAUDFGEAHZDUEZWAIHZJKZWABCUFZKZBDFCDFGZLAEDUGADEUBWFWBW
    DGZWGWFWHWEDUEZWEIHZJKZGZWGWFWBWIWDWKWAWEDUHWFWCWJJWAWEIMUIUJBNFZCNFZGZWLWG
    LZWOWIWGWKWOWGWIBCDNNUKULUMWOOWMOZWNOZUNZWPWMWNUOWSWKWGWIWQWKWGLZWRWNWQWTLW
    QWNWTWQWECVSZKZWNWTLBCUPWNXBWTWNXBGWJPKZWTXBWNWJXAIHPWEXAIMCNUQURXCWKWGXCWK
    GPJKZWGWJPJUSXDWGPJUTVGVAQRZQVBQVCWRWQWTWRWQGCBUFZSKZWJTKZWTCBVDXGWESKZXHXF
    WESCBVEVFXIWJSIHTWESIMVHVIZVJXHWKWGXHWKGTJKZWGWJTJUSXKWGJTVKVLVAQRZVMRVNWMW
    RWTLWRWMWTWRWEBVSZKZWMWTLBCVOWMXNWTWMXNGXCWTXNWMWJXMIHPWEXMIMBNUQURXEQVBQVC
    WQWRWTWQWRGXIXHWTBCVDXJXLVMRVNVPVQVJVNVRVCVT $.

  ${
    $d V x $.  $d E x $.  $d M x $.  $d N x $.
    $( An edge of an undirected simple graph always connects two vertices.
       (Contributed by Alexander van der Vekens, 7-Oct-2017.) $)
    usgraedgrnv $p |- ( ( V USGrph E /\ { M , N } e. ran E )
                       -> ( M e. V /\ N e. V ) ) $=
      ( vx cpr wcel wa chash cfv c2 wceq wi wss eqeq1d cvv wn elprchashprn2 syl
      sylbi cusg wbr crn cdm cv cpw crab wf1 usgraf0 f1f df-f ssel2 fveq2 elrab
      wf wfn prex elpw wo ianor prcom a1i fveq2d mtbid jaoi con4i prssg biimprd
      com12 imp ex adantl 3syl ) DAUAUBZBCFZAUCZGZBDGCDGHZVNAUDZEUEZIJZKLZEDUFZ
      UGZAUHVSWDAUOZVQVRMZEADUIVSWDAUJWEAVSUPZVPWDNZHWFVSWDAUKWHWFWGWHVQVRWHVQH
      VOWDGZVRVPWDVOULWIVOWCGZVOIJZKLZHVRWBWLEVOWCVTVOLWAWKKVTVOIUMOUNWJWLVRWJV
      ODNZWLVRMVODBCUQURWLWMVRWLBPGZCPGZHZWMVRMWPWLWPQWNQZWOQZUSWLQZWNWOUTWQWSW
      RBCRWRCBFZIJZKLWLCBRWRXAWKKWRWTVOIWTVOLWRCBVAVBVCOVDVETVFWPVRWMBCDPPVGVHS
      VITVJTSVKVLTVMVJ $.
  $}

  $( In an undirected simple graph without loops, there is no edge connecting a
     vertex with itself.  (Contributed by Alexander van der Vekens,
     26-Jan-2018.) $)
  usgranloopv $p |- ( ( V USGrph E /\ M e. W )
                      -> ( ( E ` X ) = { M , N } -> M =/= N ) ) $=
    ( cusg wbr wcel cfv cpr wceq wne wi wa c0 adantr syl chash c2 cdm cres wfun
    prnzg adantl wb neeq1 mpbird fvfundmfvn0 usgraedgprv usgraedg2 fveq2 eqeq1d
    csn biimpd hashprg biimprcd syl6com adantrd expcom com23 mpcom ex com13 imp
    mpdd ) DAGHZBEIZFAJZBCKZLZBCMZNVKVHVGVLVKVHVGVLNZFAUAIZAFUNUBUCZOZVKVHOZVMV
    QVIPMZVPVQVRVJPMZVHVSVKBCEUDUEVKVRVSUFVHVIVJPUGQUHFAUIRVNVQVMNVOVNVGVQVLVGV
    NVQVLNVGVNOZVKVLVHVTVKBDICDIOZVLABCDFUJVTVISJZTLZVKWAVLNZNADFUKVKWCVJSJZTLZ
    WDVKWCWFVKWBWETVIVJSULUMUOWAVLWFBCDUPUQURRVFUSUTVAQVBVCVDVE $.

  ${
    $d x E $.  $d x V $.  $d x M $.  $d x N $.
    $( In an undirected simple graph without loops, there is no edge connecting
       a vertex with itself.  (Contributed by Alexander van der Vekens,
       19-Aug-2017.)  (Proof shortened by Alexander van der Vekens,
       20-Mar-2018.) $)
    usgranloop $p |- ( V USGrph E -> ( E. x e. dom E ( E ` x ) = { M , N }
                       -> M =/= N ) ) $=
      ( cusg wbr cv cfv cpr wceq wne cdm wcel wa usgraedgprv imp wi ex adantr
      usgranloopv com23 com12 mpcom rexlimdva ) EBFGZAHZBICDJKZCDLZABMZUFUGUJNZ
      OZUHUICENZDENZOZULUHOZUIULUHUOBCDEUGPQUMUPUIRUNUPUMUIULUHUMUIRZUFUHUQRUKU
      FUMUHUIUFUMUHUIRBCDEEUGUASUBTQUCTUDSUE $.

    ${
      $d E x $.  $d U x $.  $d V x $.
      $( A simple undirected graph has no loops.  (Contributed by Alexander van
         der Vekens, 6-Dec-2017.) $)
      usgranloop0 $p |- ( ( V USGrph E /\ U e. V ) ->
       { x e. dom E | ( E ` x ) = { U } } = (/) ) $=
        ( cusg wbr wcel wa cv cfv csn wceq wn cdm wral crab c0 wrex cpr sylibr
        wne neirr usgranloop mtoi simpr dfsn2 syl6eq reximdv con3d mpan9 ralnex
        ex rabeq0 ) DCEFZBDGZHZAICJZBKZLZMACNZOZUSAUTPQLUPUSAUTRZMZVAUNUQBBSZLZ
        AUTRZMUOVCUNVFBBUABUBACBBDUCUDUOVBVFUOUSVEAUTUOUSVEUOUSHUQURVDUOUSUEBUF
        UGULUHUIUJUSAUTUKTUSAUTUMT $.
    $}

    $( An edge of an undirected simple graph without loops always connects two
       different vertices.  (Contributed by Alexander van der Vekens,
       2-Sep-2017.) $)
    usgraedgrn $p |- ( ( V USGrph E /\ { M , N } e. ran E ) -> M =/= N ) $=
      ( vx cusg wbr cpr crn wcel wne cv cfv wceq cdm wrex chash c2 cpw crab wf1
      wfn wb usgraf0 f1fn fvelrnb 3syl usgranloop sylbid imp ) DAFGZBCHZAIJZBCK
      ZUKUMELZAMULNEAOZPZUNUKUPUOQMRNEDSTZAUAAUPUBUMUQUCEADUDUPURAUEEUPULAUFUGE
      ABCDUHUIUJ $.
  $}

  ${
    $d E b c x y $.  $d N b c x y $.  $d V x y $.
    $( If a vertex is adjacent to two different vertices in a simple graph,
       there is not only one edge starting at this vertex.  (Contributed by
       Alexander van der Vekens, 10-Dec-2017.) $)
    usgra2edg $p |- ( ( ( V USGrph E /\ N e. V /\ b =/= c )
                     /\ ( { N , b } e. ran E /\ { c , N } e. ran E ) )
                      -> E. x e. dom E E. y e. dom E
                         ( x =/= y /\ N e. ( E ` x ) /\ N e. ( E ` y ) ) ) $=
      ( wcel cv wne w3a cpr wa cfv wrex wceq fvelrnb syl wi weq wbr crn cdm wfn
      cusg wfun usgrafun funfn sylib 3ad2ant1 anbi12d reeanv fveq2 eqeq1d eqtr2
      wb anbi1d prcom eqeq2i vex preqr2 wn df-ne pm2.24 syl5bi sylbi com23 ax-1
      syl6bi imp3a pm2.61ine prid1g 3ad2ant2 eleq2 syl5ibr adantr impcom prid2g
      3ad2antl3 adantl 3jca ex reximdv syl5bir sylbid imp ) ECUEUAZDEHZFIZGIZJZ
      KZDWILZCUBZHZWJDLZWNHZMZAIZBIZJZDWSCNZHZDWTCNZHZKZBCUCZOZAXGOZWLWRXBWMPZA
      XGOZXDWPPZBXGOZMZXIWLCXGUDZWRXNUPWGWHXOWKWGCUFXOCEUGCUHUIUJXOWOXKWQXMAXGW
      MCQBXGWPCQUKRXNXJXLMZBXGOZAXGOWLXIXJXLABXGXGULWLXQXHAXGWLXPXFBXGWLXPXFWLX
      PMXAXCXEWKWGXPXAWHWKXPMZXASWSWTABTZWKXPXAXSXPWKXAXSXPXDWMPZXLMZWKXASZXSXJ
      XTXLXSXBXDWMWSWTCUMUNUQYAWMWPPZYBXDWMWPUOYCWMDWJLZPZYBWPYDWMWJDURUSYEFGTZ
      YBWIWJDFUTGUTVAWKYFVBYFXAWIWJVCYFXAVDVERVFRVIVGVJXAXRVHVKVSXPWLXCXJWLXCSX
      LWLXCXJDWMHZWHWGYGWKDWIEVLVMXBWMDVNVOVPVQXPWLXEXLWLXESXJWLXEXLDWPHZWHWGYH
      WKWJDEVRVMXDWPDVNVOVTVQWAWBWCWCWDWEWF $.

    $( If a vertex is adjacent to two different vertices in a simple graph,
       there is not only one edge starting at this vertex.  (Contributed by
       Alexander van der Vekens, 10-Dec-2017.) $)
    usgra2edg1 $p |- ( ( ( V USGrph E /\ N e. V /\ b =/= c )
                     /\ ( { N , b } e. ran E /\ { c , N } e. ran E ) )
                     -> -. E! x e. dom E N e. ( E ` x ) ) $=
      ( vy cusg wbr wcel cv wne w3a cpr wa cfv wrex wral wn reximi crn cdm wreu
      weq usgra2edg 3simpc df-ne biimpi 3ad2ant1 jca syl rexanali rexbii rexnal
      wi bitri sylib intnand fveq2 eleq2d reu4 sylnibr ) DBHICDJEKZFKZLMCVCNBUA
      ZJVDCNVEJOOZCAKZBPZJZABUBZQZVICGKZBPZJZOZAGUDZUOGVJRZAVJRZOVIAVJUCVFVRVKV
      FVOVPSZOZGVJQZAVJQZVRSZVFVGVLLZVIVNMZGVJQZAVJQWBAGBCDEFUEWFWAAVJWEVTGVJWE
      VOVSWDVIVNUFWDVIVSVNWDVSVGVLUGUHUIUJTTUKWBVQSZAVJQWCWAWGAVJVOVPGVJULUMVQA
      VJUNUPUQURVIVNAGVJVPVHVMCVGVLBUSUTVAVB $.
  $}

  ${
    $d E a b x y $.  $d Y a b x y $.  $d V a b x y $.
    $( For each edge in a simple graph, there are two distinct vertices which
       are connected by this edge.  (Contributed by Alexander van der Vekens,
       9-Dec-2017.) $)
    usgrarnedg $p |- ( ( V USGrph E /\ Y e. ran E )
                       -> E. a e. V E. b e. V ( a =/= b /\ Y = { a , b } ) ) $=
      ( vx vy wcel cv wceq wa wrex cfv 3syl chash c2 wi eleq1 wex vex cusg wfun
      wbr crn wne cpr cdm wfn wb usgrafun funfn biimpi fvelrnb cpw crab usgraf0
      wf1 f1f ffvelrn fveq2 eqeq1d elrab hash2prde prex elpw prss biimpri sylbi
      wss syl6bi adantl imdistanri 2eximdv r2ex syl6ibr adantr syl5com rexlimdv
      wf ex mpd sylbid imp ) BAUAUCZCAUDHZDIZEIZUEZCWFWGUFZJZKZEBLDBLZWDWEFIZAM
      ZCJZFAUGZLZWLWDAUBZAWPUHZWEWQUIABUJWRWSAUKULFWPCAUMNWDWOWLFWPWDWPGIZOMZPJ
      ZGBUNZUOZAUQWPXDAVSZWMWPHZWOWLQZQGABUPWPXDAURXEXFXGXEXFKWNXDHZWOWLWPXDWMA
      USWOXHCXDHZWLWNCXDRXICXCHZCOMZPJZKZWLXBXLGCXCWTCJXAXKPWTCOUTVAVBXMWKESDSZ
      WLCXCDEVCXJXNWLQXLXJXNWFBHWGBHKZWKKZESDSWLXJWKXPDEXJWKXPWKXJXOWJXJXOQWHWJ
      XJWIXCHZXOCWIXCRXQWIBVIZXOWIBWFWGVDVEXOXRWFWGBDTETVFVGVHVJVKVLVTVMWKDEBBV
      NVOVPWAVHVJVQVTNVRWBWC $.
  $}

  ${
    $d x y E $.  $d x y V $.  $d x y X $.
    $( The value of the "edge function" of a graph is a set containing two
       elements (the endvertices of the corresponding edge).  (Contributed by
       Alexander van der Vekens, 18-Dec-2017.) $)
    usgraedg3 $p |- ( ( V USGrph E /\ X e. dom E )
              -> E. x e. V E. y e. V ( x =/= y /\ ( E ` X ) = { x , y } ) ) $=
      ( cusg wbr cdm wcel cfv crn cv wne cpr wceq wa wrex wfun usgrafun fvelrn
      sylan usgrarnedg syldan ) DCFGZECHIZECJZCKIZALZBLZMUFUHUINOPBDQADQUDCRUEU
      GCDSECTUACDUFABUBUC $.

    $d a b E $.  $d a b V $.  $d a b X $.  $d a b y Y $.
    $( The value of the "edge function" of a graph is a set containing two
       elements (the endvertices of the corresponding edge).  (Contributed by
       Alexander van der Vekens, 18-Dec-2017.) $)
    usgraedg4 $p |- ( ( V USGrph E /\ X e. dom E /\ Y e. ( E ` X ) )
                      -> E. y e. V ( E ` X ) = { Y , y } ) $=
      ( va vb wcel cpr wceq wi wa wex wo ex syl6bi eqeq2d cvv com12 sylbi chash
      cusg wbr cdm cfv cv wrex c2 cpw crab wf1 usgraf0 f1f ffvelrn fveq2 eqeq1d
      wf elrab hash2pr 19.42vv eleq2 elpri andir biimpi syl impcom 2eximi 19.43
      pm2.43a exbii bitri weq preq2 anbi2d cbvexv preq1 eqcoms biimpa vex eleq1
      mpbiri adantr wss prex elpw prssg bicomd mpan2 simpr com23 imp simpll jca
      syl2anc eximdv df-rex syl6ibr exlimiv excom mpan simpl eqeq2i jctird jaoi
      wb prcom sylbir com13 mpd 3syl 3imp ) CBUBUCZDBUDZHZEDBUEZHZXOEAUFZIZJZAC
      UGZXLXMXQUAUEZUHJZACUIZUJZBUKXMYDBUQZXNXPXTKZKABCULXMYDBUMYEXNYFYEXNLXOYD
      HZYFXMYDDBUNYGXOYCHZXOUAUEZUHJZLZYFYBYJAXOYCXQXOJYAYIUHXQXOUAUOUPURYKXOFU
      FZGUFZIZJZGMFMZYFXOYCFGUSYHYPYFKYJXPYPYHXTXPYPYHXTKZXPYPLXPYOLZGMFMZYQXPY
      OFGUTYSEYLJZYOLZEYMJZYOLZNZGMZFMZYQYRUUDFGYOXPUUDXPYOUUDYOXPEYNHZYOUUDKZX
      OYNEVAUUGYTUUBNZUUHEYLYMVBUUIYOUUDUUIYOLUUDYTUUBYOVCVDOVEPVIVFVGUUFUUAGMZ
      FMZUUCGMZFMZNZYQUUFUUJUULNZFMUUNUUEUUOFUUAUUCGVHVJUUJUULFVHVKUUKYQUUMUUJY
      QFUUJYTXOYLXQIZJZLZAMZYQUUAUURGAGAVLZYOUUQYTUUTYNUUPXOYMXQYLVMQVNVOYHUUSX
      TYHUUSXQCHZXSLZAMZXTYHUURUVBAUURYHUVBUURXSERHZYHUVBKZYTUUQXSYTUUPXRXOUUPX
      RJYLEYLEXQVPVQQVRYTUVDUUQYTUVDYLRHFVSEYLRVTWAWBXSUVDLZYHUVBUVFYHLUVAXSUVF
      YHUVAXSUVDYHUVAKZXSYHUVDUVAXSYHXRYCHZUVDUVAKZXOXRYCVTUVHXRCWCZUVIXRCEXQWD
      WEUVDUVJUVAUVDUVJECHZUVALZUVAUVDXQRHZUVJUVLXEAVSZUVDUVMLUVLUVJEXQCRRWFWGW
      HUVKUVAWIPSTPWJWKWKXSUVDYHWLWMOWNSWOXSACWPZWQSTWRUUMUUCFMZGMYQUUCFGWSUVPY
      QGUVPUUBXOXQYMIZJZLZAMZYQUUCUVSFAFAVLZYOUVRUUBUWAYNUVQXOYLXQYMVPQVNVOYHUV
      TXTYHUVTUVCXTYHUVSUVBAUVSYHUVBUVSXOXQEIZJZUVDUVEUUBUVRUWCUUBUVQUWBXOUVQUW
      BJYMEYMEXQVMVQQVRUUBUVDUVRUUBUVDYMRHGVSEYMRVTWAWBUWCUVDLYHUVAXSUWCUVDUVGU
      WCYHUVDUVAUWCYHUWBYCHZUVIXOUWBYCVTUWDUWBCWCZUVIUWBCXQEWDWEUVDUWEUVAUVDUWE
      UVAUVKLZUVAUVMUVDUWEUWFXEUVNUVMUVDLUWFUWEXQECRRWFWGWTUVAUVKXAPSTPWJWKUWCX
      SUVDUWCXSUWBXRXOXQEXFXBVDWBXCWNSWOUVOWQSTWRTXDTVEXGOXHWBXITVEOXJXK $.
  $}

  ${
    $d E x y $.  $d V x y $.  $d X x y $.  $d Y x y $.
    $( The value of the "edge function" of a graph is a uniquely determined set
       containing two elements (the endvertices of the corresponding edge).
       Concretising ~ usgraedg4 .  (Contributed by Alexander van der Vekens,
       4-Jan-2018.) $)
    usgraedgreu $p |- ( ( V USGrph E /\ X e. dom E /\ Y e. ( E ` X ) )
                      -> E! y e. V ( E ` X ) = { Y , y } ) $=
      ( vx cusg wbr cdm wcel cfv w3a cv cpr wceq wrex wa weq wral vex usgraedg4
      wi wreu eqtr2 preqr2 syl a1i ralrimivva preq2 eqeq2d reu4 sylanbrc ) CBGH
      DBIJEDBKZJLZUMEAMZNZOZACPUQUMEFMZNZOZQZAFRZUBZFCSACSUQACUCABCDEUAUNVCAFCC
      VCUNUOCJURCJQQVAUPUSOVBUMUPUSUDUOUREATFTUEUFUGUHUQUTAFCVBUPUSUMUOUREUIUJU
      KUL $.
  $}

  ${
    $d E a b y $.  $d I a b y $.  $d Y a b y $.  $d V a b y $.
    $( For each edge in a simple graph, there are two distinct vertices which
       are connected by this edge.  (Contributed by Alexander van der Vekens,
       9-Dec-2017.) $)
    usgrarnedg1 $p |- ( ( V USGrph E /\ E. y e. ran E y = ( E ` I ) )
               -> E. a e. V E. b e. V ( a =/= b /\ ( E ` I ) = { a , b } ) ) $=
      ( cusg wbr cv cfv wceq crn wrex wcel wne cpr wa wi eleq1 biimpcd adantl
      rexlimdva imp usgrarnedg syldan ) DBGHZAIZCBJZKZABLZMZUHUJNZEIZFIZOUHUMUN
      PKQFDMEDMUFUKULUFUIULAUJUGUJNZUIULRUFUIUOULUGUHUJSTUAUBUCBDUHEFUDUE $.
  $}

  ${
    $d A x $.  $d E x $.
    $( A class with one (or no) vertex is a simple graph if and only if it has
       no edges.  (Contributed by Alexander van der Vekens, 13-Oct-2017.) $)
    usgra1v $p |- ( { A } USGrph E <-> E = (/) ) $=
      ( vx cvv wcel csn cusg wbr c0 wceq wb wa chash cfv c2 wne syl wn c1 cc0
      wi usgrav cdm cv cpw cdif crab wf1 isusgra adantr eqidd cpr difeq1i snnzg
      pwsn necomd adantl difprsn1 syl5eq biidd rabeqbidv wral 1ne2 neeq1 mpbiri
      hashsng neneqd 2ne0 necomi snprc biimpi fveq2d hash0 syl6eq eqeq1d mtbird
      a1i pm2.61i snex fveq2 notbid ralsn mpbir rabeq0 f1eq123d f1f f00 simplbi
      wf syl6bi sylbid ex com23 mpcom com12 usgra0 ax-mp impbid1 usgra0v syl6bb
      breq2 breq1 sylbi ) ADEZAFZBGHZBIJZKZXDXFXGXFXDXGXEDEZBDELZXFXDXGUABXEUBX
      JXDXFXGXJXDXFXGUAXJXDLZXFBUCZCUDZMNZOJZCXEUEZIFZUFZUGZBUHZXGXJXFXTKXDCBXE
      DDUIUJXKXTXLIBUHZXGXKXLXLXSIBBXKBUKXKXLUKXKXSXOCXEFZUGZIXKXOXOCXRYBXKXRIX
      EULZXQUFZYBXPYDXQAUOUMXKIXEPZYEYBJXDYFXJXDXEIADUNUPUQIXEURQUSXKXOUTVAYCIJ
      XORZCYBVBZYHXEMNZOJZRZXDYKXDYISJZYKADVFYLYIOYLYIOPSOPVCYISOVDVEVGQXDRZYJT
      OJYMTOTOPYMOTVHVIVQVGYMYITOYMYIIMNTYMXEIMYMXEIJZAVJZVKVLVMVNVOVPVRYGYKCXE
      AVSZXMXEJZXOYJYQXNYIOXMXEMVTVOWAWBWCXOCYBWDWCVNWEYAXLIBWIZXGXLIBWFYRXGXLI
      JXLBWGWHQWJWKWLWMWNWOXGXFXEIGHZXIYSYPXEDWPWQBIXEGXAVEWRYMYNXHYOYNXFIBGHXG
      XEIBGXBBWSWTXCVR $.
  $}

  ${
    $d E x $.  $d N x $.  $d Y x $.  $d E z $.  $d N z $.  $d V z $.  $d Y z $.
    usgraidx2v.a $e |- A = { x e. dom E | N e. ( E ` x ) } $.
    $( Lemma 1 for ~ usgraidx2v .  (Contributed by Alexander van der Vekens,
       4-Jan-2018.) $)
    usgraidx2vlem1 $p |- ( ( V USGrph E /\ Y e. A )
                           -> ( iota_ z e. V ( E ` Y ) = { z , N } ) e. V ) $=
      ( wcel cusg wbr cdm cfv wa cv cpr wceq crio fveq2 wreu eleq2d usgraedgreu
      elrab2 w3a prcom eqeq2i reubii sylib 3expb riotacl syl sylan2b ) GCIFDJKZ
      GDLZIZEGDMZIZNZUPBOZEPZQZBFRFIZEAOZDMZIUQAGUNCVCGQVDUPEVCGDSUAHUCUMURNVAB
      FTZVBUMUOUQVEUMUOUQUDUPEUSPZQZBFTVEBDFGEUBVGVABFVFUTUPEUSUEUFUGUHUIVABFUJ
      UKUL $.

    $d I z $.
    $( Lemma 2 for ~ usgraidx2v .  (Contributed by Alexander van der Vekens,
       4-Jan-2018.) $)
    usgraidx2vlem2 $p |- ( ( V USGrph E /\ Y e. A )
         -> ( I = ( iota_ z e. V ( E ` Y ) = { z , N } )
              -> ( E ` Y ) = { I , N } ) ) $=
      ( wcel cusg cfv cv cpr wceq wi wa biimpi wreu wb crio fveq2 eleq2d elrab2
      wbr usgraedgreu 3expb usgraidx2vlem1 adantlr adantll adantr adantl mpbird
      cdm eleq1 prcom eqeq2i reubii ad3antrrr preq1 eqeq2d riota2 syl2anc com13
      exbiri eqcoms pm2.43i exp3acom3r mpancom expcom com23 mpcom impcom ) HCJZ
      GDKUEZEHDLZBMZFNZOZBGUAZOZVPEFNZOZPZHDUNZJZFVPJZQZVNVOWDPVNWHFAMZDLZJWGAH
      WECWIHOWJVPFWIHDUBUCIUDRWHVOVNWDVOWHVNWDPZVPFVQNZOZBGSZVOWHQZWKVOWFWGWNBD
      GHFUFUGWAWNWOQZVNWCWAWPVNQZWCPZWAWRPVTEWQWAVTEOZWCWQWAWCWSWQWAQZEGJZVSBGS
      ZWCWSTWTXAVTGJZWQXCWAWOVNXCWNVOVNXCWHABCDFGHIUHUIUJUKWAXAXCTWQEVTGUOULUMW
      NXBWOVNWAWNXBWMVSBGWLVRVPFVQUPUQURRUSVSWCBGEVQEOVRWBVPVQEFUTVAVBVCVEVDVFV
      GVHVIVJVKVLVM $.

    $d A w y $.  $d E w x y z $.  $d F w $.  $d N u w y $.  $d V u w y $.
    $d E u w z $.
    usgraidx2v.f $e |- F = ( y e. A
                             |-> ( iota_ z e. V ( E ` y ) = { z , N } ) ) $.
    $( The mapping of indices of edges containing a given vertex into the set
       of vertices is 1-1.  The index is mapped to the other vertex of the edge
       containing the vertex N. (Contributed by Alexander van der Vekens,
       4-Jan-2018.) $)
    usgraidx2v $p |- ( ( V USGrph E /\ N e. V ) -> F : A -1-1-> V ) $=
      ( vw vu wcel wa cv cpr wceq crio adantr wn cusg wbr cfv wi usgraidx2vlem1
      wral weq wf1 ralrimiva cdm wb usgraf1 elrabi eleq2s anim12i f1fveq syl2an
      crab bicomd notbid simpl preq1 eqeq2d cbvriotav usgraidx2vlem2 ee10 simpr
      crn eqeq12d wo cvv riotaex id preq12bg syl22anc adantl ioran ianor notbii
      a1i eqeq12i biimpi eqid pm2.24i sylbi com12 sylbid con4d ralrimivva fveq2
      a1d jaoi eqeq1d riotabidv f1mpt sylanbrc ) HEUAUBZGHMZNZBOZEUCZCOZGPZQZCH
      RZHMZBDUFZXEKOZEUCZXCQZCHRZQZBKUGZUDZKDUFBDUFDHFUHWQXGWRWQXFBDACDEGHWTIUE
      UISWSXNBKDDWSWTDMZXHDMZNZNZXMXLXRXMTXAXIQZTZXLTZXRXMXSXRXSXMWSEUJZEVHZEUH
      ZWTYBMZXHYBMZNXSXMUKXQWQYDWREHULSXOYEXPYFYEWTGAOEUCMZAYBURZDYGAWTYBUMIUNY
      FXHYHDYGAXHYBUMIUNUOYBYCWTXHEUPUQUSUTXRXTXALOZGPZQZLHRZGPZXIYJQZLHRZGPZQZ
      TZYAXRXSYQXRXAYMXIYPXRWQXONYLXEQXAYMQWSWQXQXOWQWRVAZXOXPVAUOYKXDLCHLCUGZY
      JXCXAYIXBGVBZVCVDZACDEYLGHWTIVEVFXRWQXPNYOXKQXIYPQWSWQXQXPYSXOXPVGUOYNXJL
      CHYTYJXCXIUUAVCVDZACDEYOGHXHIVEVFVIUTWSYRYAUDXQWSYRYLYOQZGGQZNZYLGQGYOQNZ
      VJZTZYAWRYRUUIUKWQWRYQUUHWRYLVKMZWRYOVKMZWRYQUUHUKUUJWRYKLHVLVTWRVMZUUKWR
      YNLHVLVTUULYLGYOGVKHVKHVNVOUTVPWQUUIYAUDWRUUIWQYAUUIUUFTZUUGTZNWQYAUDZUUF
      UUGVQUUMUUOUUNUUMUUDTZUUETZVJUUOUUDUUEVRUUPUUOUUQUUPYAWQUUPYAUUDXLYLXEYOX
      KUUBUUCWAVSWBWKUUEUUOGWCWDWLWESWEWFSWGSWGWGWHWIBKDHXEXKFJXMXDXJCHXMXAXIXC
      WTXHEWJWMWNWOWP $.
  $}

  ${
    $d E x y z $.  $d N x y z $.  $d V y z $.
    $( In a graph the number of edges which contain a given vertex is not
       greater than the number of vertices.  (Contributed by Alexander van der
       Vekens, 4-Jan-2018.) $)
    usgraedgleord $p |- ( ( V USGrph E /\ N e. V )
                   -> ( # ` { x e. dom E | N e. ( E ` x ) } ) <_ ( # ` V ) ) $=
      ( vy vz cusg wbr wcel wa cv cfv cdm crab cdom chash cle cvv cpr eqid wceq
      crio cmpt wf1 usgrav simpld adantr usgraidx2v f1domg sylc hashdomi syl )
      DBGHZCDIZJZCAKBLIABMNZDOHZUPPLDPLQHUODRIZUPDEUPEKBLFKCSUAFDUBUCZUDUQUMURU
      NUMURBRIBDUEUFUGAEFUPBUSCDUPTUSTUHUPDRUSUIUJUPDUKUL $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                        Undirected simple graphs - examples
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    usgraexvlem.v $e |- V = ( 0 ... 4 ) $.
    $( Lemma for ~ usgraexmpl .  (Contributed by Alexander van der Vekens,
       13-Aug-2017.) $)
    usgraexvlem $p |- V = ( { 0 , 1 , 2 } u. { 3 , 4 } ) $=
      ( cc0 c4 cfz co c1 c2 c3 caddc cuz cfv wcel eqtri cz cle wbr ltleii ax-mp
      wceq ctp cpr cun df-3 2cn addid2i eqcomi oveq1i 3nn nnzi 0re 3re mpbir2an
      3pos 0z eluz1i eqeltrri 4nn 2re 4re 2lt4 2z fveq2i eleqtri fzsplit2 mp2an
      fztp cc ax-1cn eqidd addid2 a1i tpeq123d oveq1d syl6eqr wa eqid pm3.2i wb
      df-4 3lt4 fzopth sylibr fzpr eqtrd preq2i syl6eq uneq12i ) ACDEFZCGHUAZID
      UBZUCZBWICCHJFZEFZWMGJFZDEFZUCZWLWOCKLZMDWMKLZMWIWQTIWOWRIHGJFZWOUDHWMGJW
      MHHUEUFZUGZUHNIWRMIOMZCIPQIUIUJZCIUKULUNRCIUOUPUMUQDHKLZWSDXEMDOMZHDPQDUR
      UJZHDUSUTVARHDVBUPUMHWMKXBVCVDWMCDVEVFWNWJWPWKWNCCGJFZWMUAZWJCOMWNXITUOCV
      GSGVHMZXIWJTVIXJCCXHGWMHXJCVJGVKWMHTZXJXAVLVMSNXCWPWKTXDXCWPIDEFZWKXCWOID
      EXCWOWTIXCWMHGJXKXCXAVLVNUDVOVNXCXLIIGJFZUBZWKXCXLIXMEFZXNXCIITZDXMTZVPZX
      LXOTZXRXCXPXQIVQVTVRVLDIKLMZXSXRVSXTXFIDPQXGIDULUTWARIDXDUPUMIXMIDWBSWCIW
      DWEXMDIDXMVTUGWFWGWESWHNN $.

    $( Lemma 0 for ~ usgraexmpl .  (Contributed by Alexander van der Vekens,
       13-Aug-2017.) $)
    usgraex0elv $p |- 0 e. V $=
      ( cc0 c4 cfz co wcel cn0 cle wbr 0nn0 4nn0 0re 4re 4pos elfz2nn0 mpbir3an
      ltleii eleqtrri ) CCDEFZACTGCHGDHGCDIJKLCDMNORCDPQBS $.

    $( Lemma 1 for ~ usgraexmpl .  (Contributed by Alexander van der Vekens,
       13-Aug-2017.) $)
    usgraex1elv $p |- 1 e. V $=
      ( c1 cc0 c4 cfz wcel cn0 cle wbr 1nn0 4nn0 1re 4re 1lt4 elfz2nn0 mpbir3an
      co ltleii eleqtrri ) CDEFRZACUAGCHGEHGCEIJKLCEMNOSCEPQBT $.

    $( Lemma 2 for ~ usgraexmpl .  (Contributed by Alexander van der Vekens,
       13-Aug-2017.) $)
    usgraex2elv $p |- 2 e. V $=
      ( c2 cc0 c4 cfz wcel cn0 cle wbr 2nn0 4nn0 2re 4re 2lt4 elfz2nn0 mpbir3an
      co ltleii eleqtrri ) CDEFRZACUAGCHGEHGCEIJKLCEMNOSCEPQBT $.

    $( Lemma 3 for ~ usgraexmpl .  (Contributed by Alexander van der Vekens,
       13-Aug-2017.) $)
    usgraex3elv $p |- 3 e. V $=
      ( c3 cc0 c4 cfz wcel cn0 cle wbr 3nn0 4nn0 3re 4re 3lt4 elfz2nn0 mpbir3an
      co ltleii eleqtrri ) CDEFRZACUAGCHGEHGCEIJKLCEMNOSCEPQBT $.
  $}

  $( Lemma for ~ usgraexmpl : all "edges" are different.  (Contributed by
     Alexander van der Vekens, 15-Aug-2017.) $)
  usgraexmpldifpr $p |- ( ( { 0 , 1 } =/= { 1 , 2 } /\ { 0 , 1 } =/= { 2 , 0 }
                /\ { 0 , 1 } =/= { 0 , 3 } ) /\ ( { 1 , 2 } =/= { 2 , 0 }
                /\ { 1 , 2 } =/= { 0 , 3 } /\ { 2 , 0 } =/= { 0 , 3 } ) ) $=
    ( cc0 c1 cpr c2 wne c3 w3a cz wcel wa wo 0z pm3.2i ax-1ne0 orci prneimg mp2
    1z 2z cn necomi 2ne0 1ne2 olci 3nn 1re 1lt3 ltneii 3pm3.2i 2re 2lt3 ) ABCZB
    DCZEZULDACZEZULAFCZEZGUMUOEZUMUQEZUOUQEZGUNUPURAHIZBHIZJZVCDHIZJZJABEZADEZJ
    ZBBEBDEZJZKUNVDVFVBVCLRMZVCVERSMZMVIVKVGVHBANUADAUBUAMOABBDHHHHPQVDVEVBJZJV
    HAAEZJZVJBAEZJZKUPVDVNVLVEVBSLMZMVRVPVJVQUCNMZUDABDAHHHHPQVDVBFTIZJZJVOAFEJ
    ZVQBFEZJZKURVDWBVLVBWALUEMZMWEWCVQWDNBFUFUGUHMZUDABAFHHHTPQUIUSUTVAVFVNJVRD
    DEDAEZJZKUSVFVNVMVSMVRWIVTOBDDAHHHHPQVFWBJWEWHDFEZJZKUTVFWBVMWFMWEWKWGOBDAF
    HHHTPQVNWBJWKWCKVAVNWBVSWFMWKWCWHWJUBDFUJUKUHMODAAFHHHTPQUIM $.

  ${
    $d x y E $.  $d v E $.  $d e E $.  $d x y V $.  $d p x y $.  $d e p V $.
    usgraexmpl.v $e |- V = ( 0 ... 4 ) $.
    usgraexmpl.e $e |- E = <" { 0 , 1 } { 1 , 2 } { 2 , 0 } { 0 , 3 } "> $.
    $( ` <. V , E >. ` is a graph of five vertices ` 0 , 1 , 2 , 3 , 4 ` , with
       edges ` { 0 , 1 } , { 1 , 2 } , { 2 , 0 } , { 0 , 3 } ` .  (Contributed
       by Alexander van der Vekens, 15-Aug-2017.) $)
    usgraexmpl $p |- V USGrph E $=
      ( ve cvv wcel cc0 c1 cpr c2 c3 wa chash cfv wceq wne wi mp2an cz vy vx vp
      cusg wbr c4 cfz co ovex eqeltri cs4 cword s4cli elexi cdm cv cpw crab wf1
      cun wf1o w3a usgraexmpldifpr s4f1o mp4an mp2 a1i f1of1 wf wmo wal wfn crn
      prex wss id wo vex usgraex0elv usgraex1elv prelpwi eleq1 syl5ibrcom fveq2
      elpr ax-1ne0 necomi wb 0z 1z hashprg mpbi syl6eq jca usgraex2elv 1ne2 1nn
      cn 2nn jaoi sylbi 2ne0 2z usgraex3elv 3ne0 3nn nnzi elun weq eqeq1d elrab
      3imtr4i ssriv syl6ss anim2i df-f anim1i dff12 3syl isusgra0 mpbird ) BFGZ
      AFGZBAUDUEZBHUFUGUHFCHUFUGUIUJAHIJZIKJZKHJZHLJZUKZFDYIFULYEYFYGYHUMUNUJYB
      YCMZYDAUOZEUPZNOZKPZEBUQZURZAUSZYJYKYEYFJZYGYHJZUTZAVAZYKYTAUSZYQUUAYJYEY
      FQYEYGQYEYHQVBYFYGQYFYHQYGYHQVBMZAYIPZUUAVCDYEFGYFFGYGFGYHFGUUCUUDUUARRHI
      VNIKVNKHVNHLVNYEYFYGYHFAVDVEVFVGYKYTAVHYKYTAVIZUAUPUBUPAUEUAVJUBVKZMYKYPA
      VIZUUFMUUBYQUUEUUGUUFAYKVLZAVMZYTVOZMUUHUUIYPVOZMUUEUUGUUJUUKUUHUUJUUIYTY
      PUUJVPUCYTYPUCUPZYRGZUULYSGZVQUULYOGZUULNOZKPZMZUULYTGUULYPGUUMUURUUNUUMU
      ULYEPZUULYFPZVQUURUULYEYFUCVRZWEUUSUURUUTUUSUUOUUQHBGZIBGZUUSUUORBCVSZBCV
      TZUVBUVCMUUOUUSYEYOGHIBWAUULYEYOWBWCSUUSUUPYENOZKUULYENWDHIQZUVFKPZIHWFWG
      HTGZITGUVGUVHWHWIWJHITWKSWLWMWNUUTUUOUUQUVCKBGZUUTUUORUVEBCWOZUVCUVJMUUOU
      UTYFYOGIKBWAUULYFYOWBWCSUUTUUPYFNOZKUULYFNWDIKQZUVLKPZWPIWRGKWRGUVMUVNWHW
      QWSIKWRWKSWLWMWNWTXAUUNUULYGPZUULYHPZVQUURUULYGYHUVAWEUVOUURUVPUVOUUOUUQU
      VJUVBUVOUUORUVKUVDUVJUVBMUUOUVOYGYOGKHBWAUULYGYOWBWCSUVOUUPYGNOZKUULYGNWD
      KHQZUVQKPZXBKTGUVIUVRUVSWHXCWIKHTWKSWLWMWNUVPUUOUUQUVBLBGZUVPUUORUVDBCXDU
      VBUVTMUUOUVPYHYOGHLBWAUULYHYOWBWCSUVPUUPYHNOZKUULYHNWDHLQZUWAKPZLHXEWGUVI
      LTGUWBUWCWHWILXFXGHLTWKSWLWMWNWTXAWTUULYRYSXHYNUUQEUULYOEUCXIYMUUPKYLUULN
      WDXJXKXLXMXNXOYKYTAXPYKYPAXPXLXQUAUBYKYTAXRUAUBYKYPAXRXLXSEABFFXTYAS $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                Finite undirected simple graphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d E x $.  $d N x $.
    $( In a finite graph the number of edges which contain a given vertex is
       also finite.  (Contributed by Alexander van der Vekens, 4-Jan-2018.) $)
    fiusgraedgfi $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                  -> { x e. dom E | N e. ( E ` x ) } e. Fin ) $=
      ( cusg wbr cfn wcel w3a cfv cdm crab cvv chash cn0 cle usgrav simprd syl
      cv 3ad2ant1 rabexg hashcl 3ad2ant2 usgraedgleord 3adant2 hashbnd syl3anc
      dmexg ) DBEFZDGHZCDHZIZCATBJHZABKZLZMHZDNJZOHZUPNJURPFZUPGHUMUOMHZUQUJUKV
      AULUJBMHZVAUJDMHVBBDQRBMUISUAUNAUOMUBSUKUJUSULDUCUDUJULUTUKABCDUEUFUPURMU
      GUH $.
  $}

  $( The size of a finite simple graph with 0 vertices is 0.  Used for the base
     case of the induction in ~ usgrafis .  (Contributed by Alexander van der
     Vekens, 5-Jan-2018.) $)
  usgrafisindb0 $p |- ( ( V USGrph E /\ ( # ` V ) = 0 ) -> ( # ` E ) = 0 ) $=
    ( cusg wbr chash cfv cc0 wceq cvv wcel wa wi usgrav c0 hasheq0 adantr breq1
    wb adantl usgra0v fveq2 hash0 syl6eq sylbi syl6bi ex sylbid com23 mpcom imp
    ) BACDZBEFGHZAEFZGHZBIJZAIJZKZUKULUNLABMUQULUKUNUQULBNHZUKUNLZUOULURRUPBIOP
    UQURUSUQURKUKNACDZUNURUKUTRUQBNACQSUTANHZUNATVAUMNEFGANEUAUBUCUDUEUFUGUHUIU
    J $.

  ${
    $d E v $.  $d V v $.
    $( The size of a finite simple graph with 1 vertex is 0.  (Contributed by
       Alexander van der Vekens, 5-Jan-2018.) $)
    usgrafisindb1 $p |- ( ( V USGrph E /\ ( # ` V ) = 1 ) -> ( # ` E ) = 0 ) $=
      ( vv cusg wbr chash cfv c1 wceq cc0 cvv wcel wa wi usgrav cv csn wex wb
      c0 hash1snb adantr breq1 usgra1v syl6bb adantl fveq2 hash0 syl6eq exlimdv
      syl6bi ex sylbid com23 mpcom imp ) BADEZBFGHIZAFGZJIZBKLZAKLZMZUQURUTNABO
      VCURUQUTVCURBCPZQZIZCRZUQUTNZVAURVGSVBBKCUAUBVCVFVHCVCVFVHVCVFMUQATIZUTVF
      UQVISVCVFUQVEADEVIBVEADUCVDAUDUEUFVIUSTFGJATFUGUHUIUKULUJUMUNUOUP $.
  $}

  ${
    $d x y $.  $d E e y $.  $d E x $.  $d F e $.  $d N e y $.  $d N x $.
    $d V e y $.
    usgrafis.f $e |- F = ( E |` { x e. dom E | N e/ ( E ` x ) } ) $.
    $( Restricting an undirected simple graph.  (Contributed by Alexander van
       der Vekens, 2-Jan-2018.) $)
    usgrares1 $p |- ( ( V USGrph E /\ N e. V ) -> ( V \ { N } ) USGrph F ) $=
      ( ve vy wcel wa cdm cv chash cfv wceq wf1 wss wi syl cvv cusg wbr cdif c2
      csn cpw crab crn wnel usgraf1 adantr ssrab2 f1ssres sylancl dmeqi ssdmres
      cres a1i sylib syl5eq eqidd f1eq123d mpbird cima rneqi df-ima eqtr4i wral
      weq fveq2 neleq12d elrab usgraf0 wf f1f ffvelrn eqeq1d cin c0 wn ad2antlr
      df-nel biimpi disjsn sylibr wb elpwi ad3antrrr reldisj mpbid fvex simpllr
      elpw jca exp31 sylbi imp3a com23 imp31 imp syl5bi ralrimiv wfun funimass4
      ex usgrafun syl5eqss f1ssr syl2anc usgrav difexg resexg syl5eqel isusgra0
      syl2an ) EBUAUBZDEIZJZEDUEZUCZCUAUBZCKZGLZMNZUDOZGXTUFZUGZCPZXRYBBUHZCPZC
      UHZYGQYHXRYJDALZBNZUIZABKZUGZYIBYPUQZPZXRYOYIBPZYPYOQZYRXPYSXQBEUJUKYNAYO
      ULZYOYIYPBUMUNXRYBYPYIYICYQCYQOXRFURXRYBYQKZYPCYQFUOXRYTUUBYPOYTXRUUAURYP
      BUPUSUTXRYIVAVBVCXRYKBYPVDZYGYKYQUHUUCCYQFVEBYPVFVGXRUUCYGQZHLZBNZYGIZHYP
      VHZXRUUGHYPUUEYPIUUEYOIZDUUFUIZJZXRUUGYNUUJAUUEYOAHVIZDDYMUUFUULDVAYLUUEB
      VJVKVLXPXQUUKUUGRZXPYOYEGEUFZUGZBPZXQUUMRGBEVMUUPXQUUKUUGUUPXQJUUKJUUFYFI
      ZUUFMNZUDOZJZUUGUUPXQUUKUUTUUPUUKXQUUTUUPUUIUUJXQUUTRZUUPYOUUOBVNZUUIUUJU
      VARZRYOUUOBVOUVBUUIUVCUVBUUIJUUFUUOIZUVCYOUUOUUEBVPUVDUUFUUNIZUUSJZUVCYEU
      USGUUFUUNYCUUFOYDUURUDYCUUFMVJVQZVLUVFUUJXQUUTUVFUUJJXQJZUUQUUSUVHUUFXTQZ
      UUQUVHUUFXSVRVSOZUVIUVHDUUFIVTZUVJUUJUVKUVFXQUUJUVKDUUFWBWCWAUUFDWDWEUVHU
      UFEQZUVJUVIWFUVEUVLUUSUUJXQUUFEWGWHUUFXSEWISWJUUFXTUUEBWKWMWEUVEUUSUUJXQW
      LWNWOWPSXESWQWRWSYEUUSGUUFYFUVGVLWEWOSWTXAXBXRBXCZYTJZUUDUUHWFXPUVNXQXPUV
      MYTBEXFYTXPUUAURWNUKHYPYGBXDSVCXGYBYIYGCXHXIXPYAYHWFZXQXPETIZBTIZJUVOBEXJ
      UVPXTTICTIUVOUVQEXSTXKUVQCYQTFBYPTXLXMGCXTTTXNXOSUKVC $.

    $( The domain of the edge function is the union of the arguments/indices of
       all edges containing a specific vertex and the arguments/indices of all
       edges not containing this vertex.  (Contributed by Alexander van der
       Vekens, 4-Jan-2018.) $)
    usgrafilem1 $p |- dom E = ( dom F u. { x e. dom E | N e. ( E ` x ) } ) $=
      ( cv cfv wcel cdm crab wnel cun uncom wn rabxm wb df-nel bicomi a1i eqtri
      rabbiia uneq2i cres dmeqi wss wceq ssrab2 ssdmres mpbi uneq1i 3eqtr4i ) D
      AFZBGZHZABIZJZDUMKZAUOJZLZURUPLUOCIZUPLUPURMUOUPUNNZAUOJZLUSUNAUOOVBURUPV
      AUQAUOVAUQPULUOHUQVADUMQRSUAUBTUTURUPUTBURUCZIZURCVCEUDURUOUEVDURUFUQAUOU
      GURBUHUITUJUK $.

    $( In a graph with a finite number of vertices, the number of edges is
       finite if and only if the number of edges not containing one of the
       vertices is finite.  (Contributed by Alexander van der Vekens,
       4-Jan-2018.) $)
    usgrafilem2 $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                         -> ( E e. Fin <-> F e. Fin ) ) $=
      ( cusg wbr cfn wcel w3a cv cfv wnel cdm crab cres finresfin syl5eqel wa
      wfn wfun usgrafun funfn 3ad2ant1 adantr cun usgrafilem1 dmfi fiusgraedgfi
      sylib unfi syl2anr fnfi syl2anc ex impbid2 ) EBGHZEIJZDEJZKZBIJZCIJZVBCBD
      ALBMZNABOZPZQIFVFBRSVAVCVBVAVCTZBVEUAZVEIJVBVAVHVCURUSVHUTURBUBVHBEUCBUDU
      KUEUFVGVECOZDVDJAVEPZUGZIABCDFUHVCVIIJVJIJVKIJVACUIABDEUJVIVJULUMSVEBUNUO
      UPUQ $.

    $( In a graph with a finite number of vertices, the number of edges is
       finite if the number of edges not containing one of the vertices is
       finite.  Used for the step of the induction in ~ usgrafis .
       (Contributed by Alexander van der Vekens, 5-Jan-2018.) $)
    usgrafisinds $p |- ( Y e. NN0
                         -> ( ( V USGrph E /\ ( # ` V ) = Y /\ N e. V )
                              -> ( F e. Fin -> E e. Fin ) ) ) $=
      ( cusg wbr chash cfv wceq wcel w3a cn0 cfn wi cvv wa usgrav biimprd com3l
      hashvnfin usgrafilem2 3exp syl6 ex com25 adantr mpcom 3imp com12 ) EBHIZE
      JKFLZDEMZNFOMZCPMZBPMZQZUMUNUOUPUSQZERMZBRMZSUMUNUOUTQQZBETVAUMVCQVBVAUPU
      NUOUMUSVAUPUNUOUMUSQQZQVAUPSUNEPMZVDEFRUCUMVEUOUSUMVEUOUSUMVEUONURUQABCDE
      GUDUAUEUBUFUGUHUIUJUKUL $.
  $}

  $( Induction base for ~ usgrafis .  Main work is done in ~ usgrafisindb0 .
     (Contributed by Alexander van der Vekens, 5-Jan-2018.) $)
  usgrafisbase $p |- ( ( V USGrph E /\ ( # ` V ) = 0 ) -> E e. Fin ) $=
    ( cusg wbr chash cfv cc0 wceq cfn wcel cvv wa usgrav usgrafisindb0 cn0 0nn0
    wi hashvnfin mpan2 syl5com expcom com13 adantl mpcom imp ) BACDZBEFGHZAIJZB
    KJZAKJZLUFUGUHQZABMUJUFUKQUIUGUFUJUHUFUGUJUHQUFUGLAEFGHZUJUHABNUJGOJULUHQPA
    GKRSTUAUBUCUDUE $.

  ${
    $d e f n v w x $.  $d e f n v w y $.  $d V e n v $.  $d E e n v $.
    $( A simple undirected graph with a finite number of vertices has also only
       a finite number of edges.  (Contributed by Alexander van der Vekens,
       6-Jan-2018.) $)
    usgrafis $p |- ( ( V USGrph E /\ V e. Fin ) -> E e. Fin ) $=
      ( ve vn vx vf vy vw vv cfn wcel cv cfv wnel cusg wceq wb eleq1 adantl weq
      cdm crab cres cvv relusgra vex resex eqid usgrares1 csn cdif usgrafisbase
      c1 caddc co cn0 wbr chash wel w3a usgrafisinds imp31 brfi1ind ) AJKZCLZJK
      ZVEDLZELVEMNEVEUAUBZUCZJKZFLZJKZGHIUDCFDAVIOBUEVEVHCUFUGVEAPVFVDQILZBPVEA
      JRSCFTVFVLQIHTVEVKJRSEVEVIVGVMVIUHZUIVKVIPVLVJQHLVMVGUJUKPVKVIJRSVEVMULGL
      UMUNUOZUPKVMVEOUQVMURMVOPDIUSUTVJVFEVEVIVGVMVOVNVAVBVC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Neighbors, complete graphs and universal vertices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Neighbors $.
  $c ComplUSGrph $.
  $c UnivVertex $.

  $( Extend class notation with Neighbors (of a vertex in a graph). $)
  cnbgra $a class Neighbors $.
  $( Extend class notation with complete (undirected simple) graphs. $)
  ccusgra $a class ComplUSGrph $.
  $( Extend class notation with the universal vertices (in a graph). $)
  cuvtx $a class UnivVertex $.

  ${
    $d g k n $.
    $( Define the class of all Neighbors of a vertex in a graph.  The neighbors
       of a vertex are all vertices which are connected with this vertex by an
       edge.  (Contributed by Alexander van der Vekens and Mario Carneiro,
       7-Oct-2017.) $)
    df-nbgra $a |- Neighbors = ( g e. _V , k e. ( 1st ` g )
      |-> { n e. ( 1st ` g ) | { k , n } e. ran ( 2nd ` g ) } ) $.
  $}

  ${
    $d e v k n $.
    $( Define the class of all complete (undirected simple) graphs.  An
       undirected simple graph is called complete if every pair of distinct
       vertices is connected by a (unique) edge.  (Contributed by Alexander van
       der Vekens, 12-Oct-2017.) $)
    df-cusgra $a |- ComplUSGrph = { <. v , e >. | ( v USGrph e
                 /\ A. k e. v A. n e. ( v \ { k } ) { n , k } e. ran e ) } $.

    $( Define the class of all universal vertices (in graphs).  A vertex is
       called universal if it is adjacent, i.e. connected by an edge, to all
       other vertices (of the graph).  (Contributed by Alexander van der
       Vekens, 12-Oct-2017.) $)
    df-uvtx $a |- UnivVertex = ( v e. _V , e e. _V |-> { n e. v |
                   A. k e. ( v \ { n } ) { k , n } e. ran e } ) $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Neighbors
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d V g k n $.  $d E g k n $.  $d N g k n $.  $d Y g k n $.  $d Z g k n $.
    $( The set of neighbors of an element of the first component of an ordered
       pair, especially of a vertex in a graph.  (Contributed by Alexander van
       der Vekens, 7-Oct-2017.) $)
    nbgraop $p |- ( ( ( V e. Y /\ E e. Z ) /\ N e. V )
          -> ( <. V , E >. Neighbors N ) = { n e. V | { N , n } e. ran E } ) $=
      ( vg vk wcel wa cnbgra cvv cv c1st cfv c2nd wceq adantr adantl wi cpr crn
      crab cmpt2 cop co df-nbgra a1i op1stg eqcomd eleq2d biimpa fveq2 eleqtrrd
      opex fvex rabexg mp1i sylan9eq ex com12 imp preq1 rneqd eleq12d rabeqbidv
      op2ndg ovmpt2dv2 mpi ) DEIBFIJZCDIZJZKGHLGMZNOZHMZAMZUAZVMPOZUBZIZAVNUCZU
      DQDBUEZCKUFCVPUAZBUBZIZADUCZQGHAUGVLGHWBCLVNWAWFKLWBLIVLDBUOUHVLVMWBQZJCW
      BNOZVNVLCWHIZWGVJVKWIVJDWHCVJWHDDBEFUIZUJUKULRWGVNWHQVLVMWBNUMZSUNVNLIWAL
      IVLWGVOCQZJZJZVMNUPVTAVNLUQURWNVTWEAVNDVLWMVNDQZVJWMWOTVKWMVJWOWGVJWOTWLW
      GVJWOWGVJVNWHDWKWJUSUTRVARVBWNVQWCVSWDWMVQWCQZVLWLWPWGVOCVPVCSSWNVRBVLWMV
      RBQZVJWMWQTVKWMVJWQWGVJWQTWLWGVJWQWGVJVRWBPOBVMWBPUMDBEFVGUSUTRVARVBVDVEV
      FVHVI $.
      $( Proof using ~ mpt2xopoveq is longer:
      ( vy vx wcel cv c2nd cfv crn wsbc csb cvv mp1i csn wceq a1i wa cop cnbgra
      co crab df-nbgra mpt2xopoveq wb sbcel1g adantl sbcbidv opex sbcel2gOLD df-pr
      cpr cun csbeq2dv wnfc uneq1d csbiegf eqcomi 3eqtrd csbrngOLD csbfv2g csbvarg
      nfcv sneq fveq2d op2ndg adantr rneqd eqtrd eleq12d 3bitrd rabbidv ) DEIBF
      IUAZCDIZUAZDBUBZCUCUDGJZAJZUOZHJZKLZMZIZGCNZHVSNZADUECWAUOZBMZIZADUEWFHGA
      UCCDBEFHGAUFUGVRWHWKADVRWHGCWBOZWEIZHVSNZWLHVSWEOZIZWKVRWGWMHVSVQWGWMUHVP
      GCWBWEDUIUJUKVSPIZWNWPUHVRDBULZHVSWLWEPUMQVRWLWIWOWJVRWLGCVTRZWARZUPZOZCR
      ZWTUPZWIVRGCWBXAWBXASVRVTWAUNTUQVQXBXDSVPGCXAXDDGXDURVQGXDVFTVTCSWSXCWTVT
      CVGUSUTUJXDWISVRWIXDCWAUNVATVBVRWOHVSWDOZMZWJWQWOXFSVRWRHVSWDPVCQVRXEBVRX
      EHVSWCOZKLZVSKLZBWQXEXHSVRWRHVSWCPKVDQVRXGVSKWQXGVSSVRWRHVSPVEQVHVPXIBSVQ
      DBEFVIVJVBVKVLVMVNVOVL $)
  $}

  ${
    $d E i n $.  $d N i n $.  $d V i n $.  $d Y n $.  $d Z n $.
    $( The set of neighbors of an element of the first component of an ordered
       pair, especially of a vertex in a graph.  (Contributed by Alexander van
       der Vekens, 17-Dec-2017.) $)
    nbgraop1 $p |- ( ( ( V e. Y /\ E e. Z ) /\ N e. V ) -> ( Fun E
                   -> ( <. V , E >. Neighbors N )
                      = { n e. V | E. i e. dom E ( E ` i ) = { N , n } } ) ) $=
      ( wcel wa wfun cop cnbgra co cv cfv cpr wceq cdm wrex crab crn elrnrexdmb
      nbgraop eqcom rexbii syl6bb rabbidv sylan9eq ex ) EFHCGHIDEHIZCJZECKDLMZA
      NCOZDBNPZQZACRZSZBETZQUJUKULUNCUAHZBETURBCDEFGUCUKUSUQBEUKUSUNUMQZAUPSUQA
      CUNUBUTUOAUPUNUMUDUEUFUGUHUI $.
  $}

  ${
    $d V g k n $.  $d E g k n $.  $d K g k n $.  $d N g k n $.  $d X g k n $.
    $d Y g k n $.
    $( The set of neighbors of an element of the first component of an ordered
       pair, especially of a vertex in a graph.  (Contributed by Alexander van
       der Vekens and Mario Carneiro, 9-Oct-2017.) $)
    nbgrael $p |- ( ( V e. X /\ E e. Y ) -> ( N e. ( <. V , E >. Neighbors K )
                    <-> ( K e. V /\ N e. V /\ { K , N } e. ran E ) ) ) $=
      ( vg vk vn wcel wa cop cnbgra co cpr crn w3a cv cfv crab df-nbgra nbgraop
      c2nd c1st mpt2xopn0yelv pm4.71rd eleq2d wceq preq2 eleq1d syl6bb pm5.32da
      elrab 3anass syl6bbr bitrd ) DEJAFJKZCDALBMNZJZBDJZUSKZUTCDJZBCOZAPZJZQZU
      QUSUTGHHRIRZOGRZUCSPJIVHUDSTMBCDAEFGHIUAUEUFUQVAUTVBVEKZKVFUQUTUSVIUQUTKZ
      USCBVGOZVDJZIDTZJVIVJURVMCIABDEFUBUGVLVEICDVGCUHVKVCVDVGCBUIUJUMUKULUTVBV
      EUNUOUP $.
  $}

  ${
    $d V g k n $.  $d E g k n $.  $d N g k n $.
    $( There are no neighbors of a class which is not a vertex.  (Contributed
       by Alexander van der Vekens, 12-Oct-2017.) $)
    nbgranv0 $p |- ( N e/ V -> ( <. V , E >. Neighbors N ) = (/) ) $=
      ( vg vk vn cpr c2nd cfv crn wcel c1st crab cnbgra df-nbgra mpt2xopynvov0
      cv ) DEEQFQGDQZHIJKFRLIMNBCADEFOP $.
  $}

  ${
    $d V n x $.  $d E n x $.  $d N n x $.
    $( The set of neighbors of a vertex in a graph.  (Contributed by Alexander
       van der Vekens, 9-Oct-2017.)  (Proof shortened by Alexander van der
       Vekens, 25-Jan-2018.) $)
    nbusgra $p |- ( V USGrph E -> ( <. V , E >. Neighbors N )
                               = { n e. V | { N , n } e. ran E } ) $=
      ( wcel cusg wbr cop cnbgra co cv wceq wi cvv wa ex syl wn c0 adantr com12
      cpr crn crab usgrav nbgraop wnel df-nel nbgranv0 wral usgraedgrnv notnot1
      sylbir intnand exp3acom23 impcom ralrimiv rabeq0 sylibr eqtr4d pm2.61i
      con2d ) CDEZDBFGZDBHCIJZCAKZUBBUCEZADUDZLZMVDVCVIVDDNEBNEOZVCVIMBDUEVJVCV
      IABCDNNUFPQUAVCRZVDVIVKVDOZVESVHVKVESLZVDVKCDUGVMCDUHBCDUIUMTVLVGRZADUJVH
      SLVLVNADVDVKVFDEZVNMVDVOVKVNVDVGVOVKOZVDVGVPRZVDVGOVCVOOZVQBCVFDUKVRVKVOV
      CVKRVOVCULTUNQPVBUOUPUQVGADURUSUTPVA $.

    $( A vertex which is not endpoint of an edge has no neighbor.  (Contributed
       by Alexander van der Vekens, 12-Oct-2017.) $)
    nbgra0nb $p |- ( V USGrph E -> ( A. x e. ran E N e/ x
                          -> ( <. V , E >. Neighbors N ) = (/) ) ) $=
      ( vn cusg wbr cv wnel crn wral c0 wceq wa wcel wn wi imp ex com13 cop cpr
      cnbgra co nbusgra adantr neleq2 rspcv df-nel wo elprg notbid ioran syl6bb
      crab eqid pm2.24i syl6bi usgraedgrnv simpld con3d a1i a1d sylbi syl6 ax-1
      pm2.61i pm2.61d1 ralrimiv rabeq0 sylibr eqtrd ) DBFGZCAHZIZABJZKZDBUACUCU
      DZLMVMVQNZVRCEHZUBZVPOZEDUOZLVMVRWCMVQEBCDUEUFVSWBPZEDKWCLMVSWDEDVSWBVTDO
      ZWDQZVMVQWBWFQWBVQVMWFWBVQCWAIZVMWFQZVOWGAWAVPVNWACUGUHWGCWAOZPZWHCWAUICD
      OZWJWHQWKWJCCMZPZCVTMZPZNZWHWKWJWLWNUJZPWPWKWIWQCCVTDUKULWLWNUMUNWMWOWHWL
      WOWHQCUPUQRURWKPZWHWJWEVMWRWDVMWRWDQQWEVMWBWKVMWBWKVMWBNWKWEBCVTDUSUTSVAV
      BTVCVGVDVETRWDWEVFVHVIWBEDVJVKVLS $.
  $}

  ${
    $d V n $.  $d E n $.  $d K n $.  $d N n $.
    $( A class/vertex is a neighbor of another class/vertex if and only if it
       is an endpoint of an edge.  (Contributed by Alexander van der Vekens,
       11-Oct-2017.) $)
    nbgraeledg $p |- ( V USGrph E -> ( N e. ( <. V , E >. Neighbors K )
                                       <-> { N , K } e. ran E ) ) $=
      ( vn cusg wbr cop cnbgra co wcel cv cpr crn crab nbusgra wceq a1i eleq1d
      wa eleq2d usgraedgrnv simprd ex pm4.71rd prcom preq2 elrab 3bitr4rd bitrd
      wb ) DAFGZCDAHBIJZKCBELZMZANZKZEDOZKZCBMZUPKZULUMURCEABDPUAULBCMZUPKZCDKZ
      VCTZVAUSULVCVDULVCVDULVCTBDKVDABCDUBUCUDUEULUTVBUPUTVBQULCBUFRSUSVEUKULUQ
      VCECDUNCQUOVBUPUNCBUGSUHRUIUJ $.

    $( Every neighbor of a class/vertex is a vertex.  (Contributed by Alexander
       van der Vekens, 12-Oct-2017.) $)
    nbgraisvtx $p |- ( V USGrph E
                       -> ( N e. ( <. V , E >. Neighbors K ) -> N e. V ) ) $=
      ( cusg wbr cop cnbgra co wcel cpr crn nbgraeledg wa usgraedgrnv simpld ex
      sylbid ) DAEFZCDAGBHIJCBKALJZCDJZABCDMSTUASTNUABDJACBDOPQR $.

    $( In a graph with no edges, every vertex has no neighbor.  (Contributed by
       Alexander van der Vekens, 12-Oct-2017.) $)
    nbgra0edg $p |- ( V USGrph (/) -> ( <. V , (/) >. Neighbors K ) = (/) ) $=
      ( vn c0 cusg wbr cop cnbgra co cv cpr crn wcel crab nbusgra wral wceq a1i
      wn wi noel rn0 eleq2i sylnibr ralrimiv rabeq0 sylibr eqtrd ) BDEFZBDGAHIA
      CJZKZDLZMZCBNZDCDABOUIUMSZCBPUNDQUIUOCBUJBMZUOTUIUPUKDMZUMUQSUPUKUARULDUK
      UBUCUDRUEUMCBUFUGUH $.

    $( The neighbors of a node in a graph are a subset of all nodes of the
       graph.  (Contributed by Alexander van der Vekens, 12-Oct-2017.) $)
    nbgrassvt $p |- ( V USGrph E -> ( <. V , E >. Neighbors N ) C_ V ) $=
      ( vn cusg wbr cop cnbgra co cv cpr crn wcel crab nbusgra ssrab2 syl6eqss
      ) CAEFCAGBHIBDJKALMZDCNCDABCORDCPQ $.
  $}

  ${
    $d V n v $.  $d E n v $.
    $( A node in a graph (without loops!) is not a neighbor of itself.
       (Contributed by Alexander van der Vekens, 12-Oct-2017.) $)
    nbgranself $p |- ( V USGrph E
                       -> A. v e. V v e/ ( <. V , E >. Neighbors v ) ) $=
      ( vn cusg wbr cv cop cnbgra co wnel wcel wa cpr crn wn wne usgraedgrn weq
      crab df-ne equid pm2.24i sylbi syl ex con2d wb preq2 eleq1d elrab3 adantl
      mtbird df-nel sylibr eqidd wceq nbusgra adantr neleq12d mpbird ralrimiva
      imp ) CBEFZAGZCBHVEIJZKZACVDVECLZMZVGVEVEDGZNZBOZLZDCTZKZVIVEVNLZPVOVIVPV
      EVENZVLLZVDVHVRPVDVRVHVDVRVHPZVDVRMVEVEQZVSBVEVECRVTAASZPVSVEVEUAWAVSAUBU
      CUDUEUFUGVCVHVPVRUHVDVMVRDVECDASVKVQVLVJVEVEUIUJUKULUMVEVNUNUOVIVEVEVFVNV
      IVEUPVDVFVNUQVHDBVECURUSUTVAVB $.
  $}

  ${
    $d E n $.  $d N n $.  $d V n $.
    $( The neighbors of a vertex are a subset of the other vertices.
       (Contributed by Alexander van der Vekens, 12-Oct-2017.) $)
    nbgrassovt $p |- ( V USGrph E -> ( N e. V
                       -> ( <. V , E >. Neighbors N ) C_ ( V \ { N } ) ) ) $=
      ( vn cusg wbr wcel cop cnbgra co csn cdif wa wnel cv wral nbgranself wceq
      wss ex id oveq2 neleq12d rspcv mpan9 nbgrassvt adantr wn wi df-nel ssdifd
      difsn simpl simpr eqsstr3d syl sylbi sylc ) CAEFZBCGZCAHZBIJZCBKZLZSZUSUT
      MBVBNZVBCSZVEUSDOZVAVHIJZNZDCPUTVFDACQVJVFDBCVHBRZVHBVIVBVKUAVHBVAIUBUCUD
      UEUSVGUTABCUFUGVFBVBGUHZVGVEUIZBVBUJVLVBVCLZVBRZVMBVBULVOVGVEVOVGMZVBVNVD
      VOVGUMVPVBCVCVOVGUNUKUOTUPUQURT $.
  $}

  $( A class is not a neighbor of itself (whether it is a vertex or not).
     (Contributed by Alexander van der Vekens, 12-Oct-2017.) $)
  nbgranself2 $p |- ( V USGrph E -> N e/ ( <. V , E >. Neighbors N ) ) $=
    ( wcel cusg wbr cop cnbgra co wnel wi csn cdif wss nbgrassovt nnel neldifsn
    wn sylbi con4i ssel mtoi syl6com df-nel c0 wceq nbgranv0 n0i a1d syl sylbir
    com12 pm2.61i ) BCDZCAEFZBCAGBHIZJZKZUOUNUPCBLMZNZUQABCOUQUTUQRZBUPDZUTRBUP
    PZVBUTBUSDZBCQUTVBVDUPUSBUAULUBSTUCUNRBCJZURBCUDVEUPUEUFZURABCUGVFUQUOUQVFV
    AVBVFRVCUPBUHSTUIUJUKUM $.

  $( A vertex in a graph is a neighbor of a second vertex if and only if the
     second vertex is a neighbor of the first vertex.  (Contributed by
     Alexander van der Vekens, 12-Oct-2017.) $)
  nbgrasym $p |- ( V USGrph E -> ( N e. ( <. V , E >. Neighbors K )
                                   <-> K e. ( <. V , E >. Neighbors N ) ) ) $=
    ( cusg wbr cvv wa cop cnbgra co wb usgrav cpr crn w3a 3ancoma prcom nbgrael
    wcel eleq1i 3anbi3i bitri a1i 3bitr4d syl ) DAEFDGTAGTHZCDAIZBJKTZBUHCJKTZL
    ADMUGBDTZCDTZBCNZAOZTZPZULUKCBNZUNTZPZUIUJUPUSLUGUPULUKUOPUSUKULUOQUOURULUK
    UMUQUNBCRUAUBUCUDABCDGGSACBDGGSUEUF $.

  $( Applying the edge function on the converse edge function applied on a pair
     of a vertex and one of its neighbors is this pair.  (Contributed by
     Alexander van der Vekens, 18-Dec-2017.) $)
  nbgracnvfv $p |- ( ( V USGrph E /\ N e. ( <. V , E >. Neighbors U ) )
                     -> ( E ` ( `' E ` { U , N } ) ) = { U , N } ) $=
    ( cusg wbr cop cnbgra co wcel wa cdm crn wf1o cpr ccnv wceq usgraf1o adantr
    cfv prcom nbgraeledg biimpa syl5eqelr f1ocnvfv2 syl2anc ) DBEFZCDBGAHIJZKZB
    LZBMZBNZACOZUKJUMBPTBTUMQUGULUHBDRSUIUMCAOZUKCAUAUGUHUNUKJBACDUBUCUDUJUKUMB
    UEUF $.

  ${
    $d E i j n x $.  $d U i j n x $.  $d V i j n $.  $d A x $.  $d I i j n $.
    $d N j n $.  $d M i j $.
    nbgraf1o.n $e |- N = ( <. V , E >. Neighbors U ) $.
    nbgraf1o.i $e |- I = { i e. dom E | U e. ( E ` i ) } $.
    ${
      nbgraf1o.f $e |- F = ( n e. N |->
                              ( iota_ i e. I ( E ` i ) = { U , n } ) ) $.
      $( Lemma 1 for ~ nbgraf1o .  For each neighbor of a vertex there is
         exacly one index for the edge between the vertex and its neighbor.
         (Contributed by Alexander van der Vekens, 17-Dec-2017.) $)
      nbgraf1olem1 $p |- ( ( ( V USGrph E /\ U e. V ) /\ M e. N )
                            -> E! i e. I ( E ` i ) = { U , M } ) $=
        ( vj vx wcel wa wceq wrex wi wral cusg wbr cfv cpr weq wreu crn w3a cop
        cv cnbgra eleq2i cvv usgrav adantr nbgrael syl syl5bb cdm crab usgrafun
        co wb wfun elrnrexdm com12 3ad2ant3 imp rexbii sylibr prid1g syl5ibrcom
        eqcom eleq2 pm4.71rd bicomd rexbidv ad2antlr mpbird fveq2 eleq2d rexrab
        cbvrabv eqtri rexeqi wf1o usgraf1o wfn dff1o6 wss ssrab2 eqsstri ssralv
        ax-mp ralimi eqtr3 imim1i 3syl sylbi jca ex sylbid eqeq1d reu4 ) IDUAUB
        ZAIOZPZGHOZPBUJZDUCZAGUDZQZBFRZXLMUJZDUCZXKQZPZBMUEZSZMFTZBFTZPZXLBFUFX
        GXHYBXGXHXFGIOZXKDUGZOZUHZYBXHGIDUIAUKVBZOZXGYFHYGGJULXGIUMODUMOPZYHYFV
        CXEYIXFDIUNUODAGIUMUMUPUQURXGYFYBXGYFPZXMYAYJXLBANUJZDUCZOZNDUSZUTZRZXM
        YJAXJOZXLPZBYNRZYPYJYSXLBYNRZYJXKXJQZBYNRZYTXGYFUUBXEYFUUBSXFYFXEUUBYEX
        FXEUUBSYCXEYEUUBXEDVDYEUUBSDIVABDXKVEUQVFVGVFUOVHXLUUABYNXJXKVMVIVJXFYS
        YTVCXEYFXFYRXLBYNXFXLYRXFXLYQXFYQXLAXKOAGIVKXJXKAVNVLVOVPVQVRVSYMYQXLBN
        YNNBUEYLXJAYKXIDVTWAWBVJXLBFYOFYQBYNUTZYOKYQYMBNYNBNUEXJYLAXIYKDVTWAWCW
        DWEVJXGYAYFXEYAXFXEYNYDDWFZYADIWGUUDDYNWHZYDYDQZXJXOQZXRSZMYNTZBYNTZUHY
        ABMYNYDDWIUUJUUEYAUUFUUJUUIBFTZUUHMFTZBFTYAFYNWJZUUJUUKSFUUCYNKYQBYNWKW
        LZUUIBFYNWMWNUUIUULBFUUMUUIUULSUUNUUHMFYNWMWNWOUULXTBFUUHXSMFXQUUGXRXJX
        OXKWPWQWOWOWRVGWSUQUOUOWTXAXBVHXLXPBMFXRXJXOXKXIXNDVTXCXDVJ $.

      $( Lemma 2 for ~ nbgraf1o .  The mapping of neighbors to edge indices is
         a function.  (Contributed by Alexander van der Vekens,
         17-Dec-2017.) $)
      nbgraf1olem2 $p |- ( ( V USGrph E /\ U e. V )
                            -> F : N --> I ) $=
        ( cusg wbr wcel wa cv cfv cpr wceq crio wreu nbgraf1olem1 riotacl fmptd
        syl ) HDLMAHNOZCGBPDQACPZRSZBFTZFEUFUGGNOUHBFUAUIFNABCDEFUGGHIJKUBUHBFU
        CUEKUD $.

      $( Lemma 3 for ~ nbgraf1o .  The restricted iota of an edge is the
         function value of the converse applied to the edge.  (Contributed by
         Alexander van der Vekens, 18-Dec-2017.) $)
      nbgraf1olem3 $p |- ( ( V USGrph E /\ U e. V /\ M e. N )
          -> ( iota_ i e. I ( E ` i ) = { U , M } ) = ( `' E ` { U , M } ) ) $=
        ( cusg wbr wcel cpr cfv wceq wi syl2anc w3a ccnv crio cop cnbgra eleq2i
        cv co nbgracnvfv sylan2b 3adant2 wreu wb cdm crab crn usgraf1o 3ad2ant1
        nbgraeledg prcom eleq1i syl6bb biimpcd a1d eleq2s com13 f1ocnvdm prid1g
        wf1o 3imp eleq2 syl5ibrcom 3ad2ant2 mpd fveq2 eleq2d sylanbrc syl6eleqr
        elrab nbgraf1olem1 3impa eqeq1d riota2 mpbid ) IDMNZAIOZGHOZUAZAGPZDUBQ
        ZDQZWIRZBUGZDQZWIRZBFUCWJRZWEWGWLWFWGWEGIDUDAUEUHZOZWLHWQGJUFADGIUIUJUK
        ZWHWJFOWOBFULZWLWPUMWHWJAWNOZBDUNZUOZFWHWJXBOZAWKOZWJXCOWHXBDUPZDVIZWIX
        FOZXDWEWFXGWGDIUQURWEWFWGXHWGWFWEXHWFWEXHSZSGWQHWRXIWFWEWRXHWEWRGAPZXFO
        XHDAGIUSXJWIXFGAUTVAVBVCVDJVEVFVJXBXFWIDVGTWHWLXEWSWFWEWLXESWGWFXEWLAWI
        OAGIVHWKWIAVKVLVMVNXAXEBWJXBWMWJRZWNWKAWMWJDVOZVPVSVQKVRWEWFWGWTABCDEFG
        HIJKLVTWAWOWLBFWJXKWNWKWIXLWBWCTWD $.

      $d M n $.
      $( Lemma 4 for ~ nbgraf1o .  The mapping of neighbors to edge indices
         applied on a neighbor is the function value of the converse applied on
         the edge between the vertex and this neighbor.  (Contributed by
         Alexander van der Vekens, 18-Dec-2017.) $)
      nbgraf1olem4 $p |- ( ( V USGrph E /\ U e. V /\ M e. N )
                            -> ( F ` M ) = ( `' E ` { U , M } ) ) $=
        ( cusg wcel cfv cv cpr wceq crio cvv wbr w3a simp3 riotaex preq2 eqeq2d
        ccnv riotabidv fvmptg sylancl nbgraf1olem3 eqtrd ) IDMUAZAINZGHNZUBZGEO
        ZBPDOZAGQZRZBFSZUSDUGOUPUOVATNUQVARUMUNUOUCUTBFUDCGURACPZQZRZBFSVAHTEVB
        GRZVDUTBFVEVCUSURVBGAUEUFUHLUIUJABCDEFGHIJKLUKUL $.

      $d V i n x y $.  $d E y $.  $d F x y $.  $d N x y $.  $d U y $.
      $( Lemma 5 for ~ nbgraf1o .  The mapping of neighbors to edge indices is
         a one-to-one onto function.  (Contributed by Alexander van der Vekens,
         19-Dec-2017.) $)
      nbgraf1olem5 $p |- ( ( V USGrph E /\ U e. V )
                            -> F : N -1-1-onto-> I ) $=
        ( vx vy vj wcel wa wceq cfv wi adantr cusg wbr wfn crn cv weq wral wf1o
        nbgraf1olem2 ffn syl cpr crio wrex cab cdm crab ccnv nbgraf1olem3 3expa
        wf eqeq2d usgraf1o cop cnbgra co nbgraeledg prcom eleq1i syl6bb biimpcd
        a1d eleq2s com13 imp31 f1ocnvdm syl2anc prid1g adantl eleq2i nbgracnvfv
        sylan2b adantlr eleqtrrd eleq1 fveq2 eleq2d syl5ibrcom sylbid rexlimdva
        jca anbi12d simpl simprr usgraedg4 syl3anc usgrafun fvelrn com12 impcom
        wfun ex eqcoms syl5eq eleq1d ad2antll mpbird ad3antrrr sylibr f1ocnvfv1
        wb id syl2an eqeq1d eqcom simplll simpllr syl5bb reximdv2 impbid abbidv
        w3a mpd cbvabv syl6eq df-rab syl6eqr rnmpt 3eqtr4g nbgraf1olem4 eqeq12d
        simpr wf1 usgraf1 biimpd syl5bi imp f1ocnvfvrneq vex ralrimiva syl12anc
        preqr2 syl6 dff1o6 syl3anbrc ) HDUAUBZAHOZPZEGUCZEUDZFQLUEZERZMUEZERZQZ
        LMUFZSZMGUGZLGUGGFEUHUUHGFEVAUUIABCDEFGHIJKUIGFEUJUKUUHNUEZBUEZDRZACUEZ
        ULZQBFUMZQZCGUNZNUOZAUVAOZBDUPZUQZUUJFUUHUVGUUTUVIOZUVHPZBUOZUVJUUHUVGU
        USUVIOZAUUSDRZOZPZNUOUVMUUHUVFUVQNUUHUVFUVQUUHUVEUVQCGUUHUVBGOZPZUVEUUS
        UVCDURZRZQZUVQUVSUVDUWAUUSUUFUUGUVRUVDUWAQABCDEFUVBGHIJKUSZUTVBUVSUVQUW
        BUWAUVIOZAUWADRZOZPUVSUWDUWFUVSUVIDUDZDUHZUVCUWGOZUWDUUHUWHUVRUUFUWHUUG
        DHVCTZTUUFUUGUVRUWIUVRUUGUUFUWIUUGUUFUWISZSUVBHDVDAVEVFZGUVBUWLOZUWKUUG
        UUFUWMUWIUUFUWMUVBAULZUWGOZUWIDAUVBHVGZUWNUVCUWGUVBAVHZVIVJVKVLIVMVNVOU
        VIUWGUVCDVPVQUVSAUVCUWEUUHAUVCOZUVRUUGUWRUUFAUVBHVRVSTUUFUVRUWEUVCQZUUG
        UVRUUFUWMUWSGUWLUVBIVTZADUVBHWAWBWCWDWKUWBUVNUWDUVPUWFUUSUWAUVIWEUWBUVO
        UWEAUUSUWADWFWGWLWHWIWJUUHUVQUVFUUHUVQPZUVOUVCQZCHUNZUVFUXAUUFUVNUVPUXC
        UUHUUFUVQUUFUUGWMTUVQUVNUUHUVNUVPWMZVSUUHUVNUVPWNCDHUUSAWOWPUXAUXBUVECH
        GUXAUVBHOZUXBPZUVRUVEPUXAUXFPZUVRUVEUXGUWMUVRUXGUWMUWOUXGUWOUVOUWGOZUXA
        UXHUXFUVQUUHUXHUVNUUHUXHSUVPUUHUVNUXHUUFUVNUXHSZUUGUUFDXAZUXIDHWQUXJUVN
        UXHUUSDWRXBUKTWSTWTTUXBUWOUXHXKUXAUXEUXBUWNUVOUWGUXBUWNUVCUVOUWQUVCUVOQ
        ZUVCUVOUXKXLXCXDXEXFXGUUFUWMUWOXKUUGUVQUXFUWPXHXGUWTXIZUXGUVEUWAUUSQZUX
        GUXMUVOUVTRZUUSQZUXAUXOUXFUUHUWHUVNUXOUVQUWJUXDUVIUWGUUSDXJXMTUXBUXMUXO
        XKUXAUXEUXBUWAUXNUUSUWAUXNQUVCUVOUVCUVOUVTWFXCXNXFXGUVEUVDUUSQZUXGUXMUU
        SUVDXOUXGUUFUUGUVRUXPUXMXKUUFUUGUVQUXFXPUUFUUGUVQUXFXQUXLUUFUUGUVRYBUVD
        UWAUUSUWCXNWPXRXGWKXBXSYCXBXTYAUVQUVLNBNBUFZUVNUVKUVPUVHUUSUUTUVIWEUXQU
        VOUVAAUUSUUTDWFWGWLYDYEUVHBUVIYFYGCNGUVDEKYHJYIUUHUURLGUUHUUKGOZPZUUQMG
        UXSUUMGOZPZUUOAUUKULZUVTRZAUUMULZUVTRZQZUUPUYAUULUYCUUNUYEUXSUULUYCQZUX
        TUUFUUGUXRUYGABCDEFUUKGHIJKYJUTTUYAUUFUUGUXTUUNUYEQUUFUUGUXRUXTXPUUFUUG
        UXRUXTXQUXSUXTYLABCDEFUUMGHIJKYJWPYKUYAUVIUWGDYMZUYBUWGOZUYDUWGOZUYFUUP
        SUUFUYHUUGUXRUXTDHYNXHUXSUYIUXTUUHUXRUYIUUFUXRUYISUUGUXRUUKUWLOZUUFUYIG
        UWLUUKIVTUUFUYKUYIUUFUYKUUKAULZUWGOUYIDAUUKHVGUYLUYBUWGUUKAVHVIVJYOYPTY
        QTUXSUXTUYJUUHUXTUYJSZUXRUUFUYMUUGUXTUUMUWLOZUUFUYJGUWLUUMIVTUUFUYNUYJU
        UFUYNUUMAULZUWGOUYJDAUUMHVGUYOUYDUWGUUMAVHVIVJYOYPTTYQUYHUYIUYJPPUYFUYB
        UYDQUUPUVIUWGUYBUYDDYRUUKUUMALYSMYSUUBUUCUUAWIYTYTLMGFEUUDUUE $.
    $}

    $d V v $.  $d E v $.  $d U v $.  $d V v $.  $d F f i n $.  $d I f i n $.
    $d E f $.  $d U f $.  $d N f $.
    $( The set of neighbors of a vertex is isomorphic to the set of indices of
       edges containing the vertex.  (Contributed by Alexander van der Vekens,
       19-Dec-2017.) $)
    nbgraf1o0 $p |- ( ( V USGrph E /\ U e. V ) -> E. f f : N -1-1-onto-> I ) $=
      ( vn cusg wbr wcel wa cv cfv cpr cvv wf1o cnbgra wceq crio wex co eqeltri
      cmpt cop ovex mptexg mp1i eqid nbgraf1olem5 f1oeq1 spcegv sylc ) GDKLAGMN
      ZJFCODPAJOQUACEUBZUFZRMZFEURSZFEBOZSZBUCFRMUSUPFGDUGZATUDRHVCATUHUEJFUQRU
      IUJACJDUREFGHIURUKULVBUTBURRFEVAURUMUNUO $.
  $}

  ${
    $d E f i j $.  $d U f i j $.  $d V f i j $.
    $( The set of neighbors of a vertex is isomorphic to the set of indices of
       edges containing the vertex.  (Contributed by Alexander van der Vekens,
       19-Dec-2017.) $)
    nbgraf1o $p |- ( ( V USGrph E /\ U e. V )
                   -> E. f f : ( <. V , E >. Neighbors U )
                               -1-1-onto-> { i e. dom E | U e. ( E ` i ) } ) $=
      ( vj cv cfv wcel cdm crab cop cnbgra co eqid weq eleq2d cbvrabv nbgraf1o0
      fveq2 ) ABFDACGZDHZIZCDJZKEDLAMNZEUEOUCAFGZDHZICFUDCFPUBUGAUAUFDTQRS $.
  $}

  ${
    $d E f i $.  $d N f i $.  $d V f i $.
    $( The class of neighbors of a vertex in a finite graph is a finite set.
       (Contributed by Alexander van der Vekens, 19-Dec-2017.) $)
    nbusgrafi $p |- ( ( V USGrph E /\ N e. V /\ E e. Fin )
                      -> ( <. V , E >. Neighbors N ) e. Fin ) $=
      ( vi vf cusg wbr wcel cfn w3a cop cnbgra co cv cfv cdm crab dmfi 3ad2ant3
      syl rabfi cen wb wf1o wex nbgraf1o 3adant3 bren sylibr enfi mpbird ) CAFG
      ZBCHZAIHZJZCAKBLMZIHZBDNAOHZDAPZQZIHZUOUSIHZVAUNULVBUMARSURDUSUATUOUPUTUB
      GZUQVAUCUOUPUTENUDEUEZVCULUMVDUNBEDACUFUGUPUTEUHUIUPUTUJTUK $.
  $}

  ${
    $d E f x $.  $d U f x $.  $d V f x $.
    $( The number of neighbors of a vertex in a graph is finite, if and only if
       the number of edges having this vertex as endpoint is finite.
       (Contributed by Alexander van der Vekens, 20-Dec-2017.) $)
    edgusgranbfin $p |- ( ( V USGrph E /\ U e. V )
                       -> ( ( <. V , E >. Neighbors U ) e. Fin
                            <-> { x e. dom E | U e. ( E ` x ) } e. Fin ) ) $=
      ( vf cusg wbr wcel wa cop cnbgra co cfn cv cfv cdm wi expcom syl exlimiv
      crab wf1o wex nbgraf1o wfo f1ofo fofi wf1 f1of1 f1fi impbid ) DCFGBDHIZDC
      JBKLZMHZBANCOHACPUAZMHZULUMUOENZUBZEUCZUNUPQZBEACDUDZURUTEURUMUOUQUEZUTUM
      UOUQUFUNVBUPUMUOUQUGRSTSULUSUPUNQZVAURVCEURUMUOUQUHZVCUMUOUQUIUPVDUNUMUOU
      QUJRSTSUK $.
  $}

  ${
    $d E v $.  $d V v $.  $d A v $.  $d B v $.  $d C v $.  $d X v $.  $d Y v $.
    $d Z v $.
    $( Lemma 1 for ~ nb3grapr .  (Contributed by Alexander van der Vekens,
       15-Oct-2017.) $)
    nb3graprlem1 $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                       /\ ( V = { A , B , C } /\ V USGrph E ) )
                  -> ( ( <. V , E >. Neighbors A ) = { B , C }
                       <-> ( { A , B } e. ran E /\ { A , C } e. ran E ) ) ) $=
      ( vv wcel wceq wa cpr adantr wb eqcoms adantl mpbid wi a1d w3a ctp cnbgra
      wbr cop co crn prid1g 3ad2ant2 eleq2 nbgraeledg prcom a1i eleq1d ad2antlr
      cusg bitrd prid2g 3ad2ant3 jca crab nbusgra ad2antll cab ad2antrl w3o vex
      cv wo eltp wne usgraedgrn wn df-ne pm2.24 com12 sylbi syl com3r orc 3jaoi
      olc sylbid imp3a eqid 3mix2i eltpg mpbiri imp eleq1 bicomd impcom biimpcd
      ex preq2 tpid3g jaoi impbid abbidv df-rab dfpr2 3eqtr4g eqtrd impbida ) A
      FJZBGJZCHJZUAZEABCUBZKZEDUPUDZLZLZEDUEAUCUFZBCMZKZABMZDUGZJZACMZXRJZLZXMX
      PLZXSYAYCBXNJZXSYCBXOJZYDXMYEXPXHYEXLXFXEYEXGBCGUHUINNXPYEYDOZXMYFXOXNXOX
      NBUJPQRXLYDXSOZXHXPXKYGXJXKYDBAMZXRJXSDABEUKXKYHXQXRYHXQKXKBAULUMUNUQQUOR
      YCCXNJZYAYCCXOJZYIXMYJXPXHYJXLXGXEYJXFBCHURUSNNXPYJYIOZXMYKXOXNXOXNCUJPQR
      XLYIYAOZXHXPXKYLXJXKYICAMZXRJYADACEUKXKYMXTXRYMXTKXKCAULUMUNUQQUORUTXMYBL
      ZXNAIVHZMZXRJZIEVAZXOXMXNYRKZYBXKYSXHXJIDAEVBVCNYNYOEJZYQLZIVDYOBKZYOCKZV
      IZIVDYRXOYNUUAUUDIYNUUAUUDYNYTYQUUDYNYTYOXIJZYQUUDSZXMYTUUEOZYBXJUUGXHXKE
      XIYOUJZVENUUEYNUUFUUEYOAKZUUBUUCVFYNUUFSZYOABCIVGVJUUIUUJUUBUUCYNYQUUIUUD
      XMYQUUIUUDSZSZYBXKUULXHXJXKYQUUKXKYQLAYOVKZUUKDAYOEVLUUMAYOKZVMZUUKAYOVNU
      UIUUOUUDUUOUUDSAYOUUNUUDVOPVPVQVRWNVCNVSUUBUUFYNUUBUUDYQUUBUUCVTTTUUCUUFY
      NUUCUUDYQUUCUUBWBTTWAVQVPWCWDUUDYNUUAUUBYNUUASUUCUUBYNUUAUUBYNLYTYQYNUUBY
      TXMUUBYTSYBXMUUBYTXMUUBLZUUEYTUUPBXIJZUUEXMUUQUUBXHXLUUQXFXEXLUUQSXGXFUUQ
      XLXFUUQBAKZBBKZBCKZVFUUSUURUUTBWEWFBABCGWGWHTUIWINUUBUUQUUEOXMUUBUUEUUQYO
      BXIWJWKQRXMUUEYTOZUUBXJUVAXHXKXJYTUUEUUHWKVEZNRWNNWLYNUUBYQXSUUBYQSXMYAUU
      BXSYQXSYQOBYOBYOKXQYPXRBYOAWOUNPWMVEWLUTWNUUCYNUUAUUCYNLYTYQYNUUCYTXMUUCY
      TSYBXMUUCYTXMUUCLZUUEYTUVCCXIJZUUEXMUVDUUCXHXLUVDXGXEXLUVDSXFXGUVDXLCHABW
      PTUSWINUUCUVDUUEOXMUUCUUEUVDYOCXIWJWKQRXMUVAUUCUVBNRWNNWLYNUUCYQYAUUCYQSX
      MXSUUCYAYQYAYQOCYOCYOKXTYPXRCYOAWOUNPWMVCWLUTWNWQVPWRWSYQIEWTIBCXAXBXCXD
      $.
  $}

  ${
    $d E v w $.  $d V v w $.  $d A v w $.  $d B v w $.  $d C v w $.
    $( Lemma 2 for ~ nb3grapr .  (Contributed by Alexander van der Vekens,
       17-Oct-2017.) $)
    nb3graprlem2 $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                       /\ ( V = { A , B , C } /\ V USGrph E )
                       /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
                      -> ( ( <. V , E >. Neighbors A ) = { B , C }
                           <-> E. v e. V E. w e. ( V \ { v } )
                               ( <. V , E >. Neighbors A ) = { v , w } ) ) $=
      ( wcel wceq wa wne cpr cdif wrex wb eqeq2d wo w3a ctp cusg wbr cop cnbgra
      co cv csn w3o difeq2d preq1 rexeqbidv rextpg 3ad2ant1 simpl difeq1 adantr
      sneq rexeqdv 3ad2ant2 preq2 rexprg 3adant1 ancoms 3adant2 3orbi123d tprot
      3adant3 a1i difeq1d necom diftpsn3 syl2anb eqtrd eqcomi anbi1i biimpi syl
      3ad2ant3 prcom eqeq2i orbi2i oridm bitr2i wn wi nbgranself2 df-nel prid2g
      eleq2 syl5ibrcom con3rr3 sylbi adantl impcom biorf syl6bb orbi12d con3and
      wnel orcom prid1g jca expcom ioran sylibr 3bior1fd 3bitrd 3bitr4rd ) CHKZ
      DIKZEJKZUAZGCDEUBZLZGFUCUDZMZCDNZCENZDENZUAZUAZGFUECUFUGZBUHZAUHZOZLZAXOY
      EUIZPZQZBXOQZYDCYFOZLZAXOCUIZPZQZYDDYFOZLZAXODUIZPZQZYDEYFOZLZAXOEUIZPZQZ
      UJZYHAGYIPZQZBGQZYDDEOZLZXNXRYLUUHRYBYKYQUUBUUGBCDEHIJYECLZYHYNAYJYPUUNYI
      YOXOYECUSUKUUNYGYMYDYECYFULSUMYEDLZYHYSAYJUUAUUOYIYTXOYEDUSUKUUOYGYRYDYED
      YFULSUMYEELZYHUUDAYJUUFUUPYIUUEXOYEEUSUKUUPYGUUCYDYEEYFULSUMUNUOXRXNUUKYL
      RYBXRUUJYKBGXOXPXQUPXRYHAUUIYJXPUUIYJLXQGXOYIUQURUTUMVAYCYNAUULQZYSAECOZQ
      ZUUDACDOZQZUJZYDUUTLZYDCEOZLZTZUUMYDDCOZLZTZYDUURLZYDEDOZLZTZUJZUUHUUMXNX
      RUVBUVNRYBXNUUQUVFUUSUVIUVAUVMXLXMUUQUVFRXKYNUVCUVEADEIJYFDLZYMUUTYDYFDCV
      BSYFELZYMUVDYDYFECVBSVCVDXKXMUUSUVIRZXLXMXKUVQYSUUMUVHAECJHUVPYRUULYDYFED
      VBSYFCLZYRUVGYDYFCDVBSVCVEVFXKXLUVAUVMRXMUUDUVJUVLACDHIUVRUUCUURYDYFCEVBS
      UVOUUCUVKYDYFDEVBSVCVIVGUOYBXNUUHUVBRXRYBYQUUQUUBUUSUUGUVAYBYNAYPUULYBYPD
      ECUBZYOPZUULYBXOUVSYOXOUVSLYBCDEVHVJVKXSXTUVTUULLZYAXSDCNECNUWAXTCDVLCEVL
      DECVMVNVIVOUTYBYSAUUAUURYBUUAECDUBZYTPZUURYBXOUWBYTXOUWBLYBUWBXOECDVHVPVJ
      VKXSYAUWCUURLZXTXSYAMEDNZXSMZUWDYAXSUWFYAXSMUWFYAUWEXSDEVLVQVRVEECDVMVSVF
      VOUTYBUUDAUUFUUTXTYAUUFUUTLXSCDEVMVDUTVGVTYCUUMUUMUVLTZUVIUVMTUVNUUMUWGRY
      CUWGUUMUUMTUUMUVLUUMUUMUVKUULYDEDWAWBWCUUMWDWEVJYCUUMUVIUVLUVMYCUVHWFZUUM
      UVIRXNXRUWHYBXRXNUWHXQXNUWHWGZXPXQCYDXAZUWIFCGWHZUWJCYDKZWFZUWICYDWIZXNUV
      HUWLXNUWLUVHCUVGKZXKXLUWOXMDCHWJUOYDUVGCWKWLWMWNVSWOWPVIUWHUUMUVHUUMTUVIU
      VHUUMWQUVHUUMXBWRVSYCUVJWFZUVLUVMRXNXRUWPYBXRXNUWPXQXNUWPWGZXPXQUWJUWQUWK
      UWJUWMUWQUWNXNUVJUWLXNUWLUVJCUURKZXKXLUWRXMECHWJUOYDUURCWKWLWMWNVSWOWPVIU
      VJUVLWQVSWSYCUVMUVIUVFYCUVCWFZUVEWFZMZUVFWFXNXRUXAYBXRXNUXAXQXNUXAWGZXPXQ
      UWJUXBUWKUWJUWMUXBUWNXNUWMUXAXNUWMMUWSUWTXNUVCUWLXNUWLUVCCUUTKZXKXLUXCXMC
      DHXCUOYDUUTCWKWLWTXNUVEUWLXNUWLUVECUVDKZXKXLUXDXMCEHXCUOYDUVDCWKWLWTXDXEW
      NVSWOWPVIUVCUVEXFXGXHXIXJXJ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d E x y z $.  $d V x y z $.
    $( The neighbors of a vertex in a graph with three elements are an
       unordered pair of the other vertices if and only if all vertices are
       connected with each other.  (Contributed by Alexander van der Vekens,
       18-Oct-2017.) $)
    nb3grapr $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                       /\ ( V = { A , B , C } /\ V USGrph E )
                       /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
                      -> ( ( { A , B } e. ran E
                          /\ { B , C } e. ran E /\ { C , A } e. ran E )
                      <-> A. x e. V E. y e. V E. z e. ( V \ { y } )
                          ( <. V , E >. Neighbors x ) = { y , z } ) ) $=
      ( wcel w3a wceq wa wne cpr cnbgra wrex wb ctp cusg wbr crn cop co cv cdif
      csn wral id prcom eleq1i 3anbi123i 3anrot bitr4i a1i biadan2 nb3graprlem1
      an6 bitri biimpi tprot eqeq2i anim1i syl2an eqcomi 3anbi123d nb3graprlem2
      biimpri 3adant3 anbi1i necom syl3anb syl6eq syl3an 3bitr2d oveq2 2rexbidv
      biid eqeq1d raltpg 3ad2ant1 raleq bicomd adantr 3ad2ant2 ) DILZEJLZFKLZMZ
      HDEFUAZNZHGUBUCZOZDEPZDFPZEFPZMZMZDEQZGUDZLZEFQZXBLZFDQZXBLZMZHGUEZDRUFZB
      UGZCUGQZNZCHXKUIUHZSBHSZXIERUFZXLNZCXNSBHSZXIFRUFZXLNZCXNSBHSZMZXIAUGZRUF
      ZXLNZCXNSBHSZAWLUJZYFAHUJZWTXHXCDFQZXBLZOZXEEDQZXBLZOZXGFEQZXBLZOZMZXJXDN
      ZXPXFNZXSXANZMZYBXHYRTWTXHXHYJYMYPMZOYRXHXHUUCXHUKXHUUCTXHXHYMYPYJMUUCXCY
      MXEYPXGYJXAYLXBDEULUMXDYOXBEFULUMXFYIXBFDULUMUNYJYMYPUOUPUQURXCXEXGYJYMYP
      UTVAUQWKWOUUBYRTWSWKWOOYSYKYTYNUUAYQDEFGHIJKUSWKWIWJWHMZHEFDUAZNZWNOZYTYN
      TWOWKUUDWHWIWJUOZVBWMUUFWNWMUUFWLUUEHDEFVCVDZVBVEEFDGHJKIUSVFWKWJWHWIMZHF
      DEUAZNZWNOZUUAYQTWOUUJWKWJWHWIUOVJZWMUULWNWMUULWLUUKHUUKWLFDEVCVGZVDVBVEF
      DEGHKIJUSVFVHVKWTYSXOYTXRUUAYACBDEFGHIJKVIWKUUDWOUUGWSWREDPZFDPZMZYTXRTUU
      HWMUUFWNUUIVLWSUUPUUQWRMUURWPUUPWQUUQWRWRDEVMDFVMZWRVTUNWRUUPUUQUOUPCBEFD
      GHJKIVIVNWKUUJWOUUMWSUUQFEPZWPMZUUAYATUUNWMUULWNWMHWLUUKWMUKUUOVOVEWSUVAW
      SWQWRWPMUVAWPWQWRUOWQUUQWRUUTWPWPUUSEFVMWPVTUNVAVBCBFDEGHKIJVIVPVHVQWKWOY
      GYBTWSYFXOXRYAADEFIJKYCDNZYEXMBCHXNUVBYDXJXLYCDXIRVRWAVSYCENZYEXQBCHXNUVC
      YDXPXLYCEXIRVRWAVSYCFNZYEXTBCHXNUVDYDXSXLYCFXIRVRWAVSWBWCWOWKYGYHTZWSWMUV
      EWNWMYHYGYFAHWLWDWEWFWGVQ $.
  $}

  $( The neighbors of a vertex in a graph with three elements are an unordered
     pair of the other vertices if and only if all vertices are connected with
     each other.  (Contributed by Alexander van der Vekens, 18-Oct-2017.) $)
  nb3grapr2 $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                      /\ ( V = { A , B , C } /\ V USGrph E )
                      /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
        -> ( ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E )
             <-> ( ( <. V , E >. Neighbors A ) = { B , C }
                /\ ( <. V , E >. Neighbors B ) = { A , C }
                /\ ( <. V , E >. Neighbors C ) = { A , B } ) ) ) $=
    ( wcel w3a ctp wceq wa wne cpr cnbgra co wb prcom biimpi wbr crn cop eleq1i
    cusg 3anan32 pm4.71i anbi2i anass bitr4i anbi1i bitri syl6bb df-3an anbi12i
    a1i 3anass an6 nb3graprlem1 bicomd tpcoma eqeq2i anim1i syl2an 3anrot tprot
    3ancoma biimpri eqcomi 3anbi123d 3adant3 bitrd ) AFIZBGIZCHIZJZEABCKZLZEDUE
    UAZMZABNACNBCNJZJZABOZDUBZIZBCOZWDIZCAOZWDIZJZWEACOZWDIZMZBAOZWDIZWGMZWICBO
    ZWDIZMZJZEDUCZAPQWFLZXABPQWKLZXACPQWCLZJZWBWJWEWIMZWLWGMZMZWTWBWJXFWGMZXHWJ
    XIRWBWEWGWIUFUPXIXFWLMZWGMXHXFXJWGXFWEWIWLMZMXJWIXKWEWIWLWIWLWHWKWDCASUDTUG
    UHWEWIWLUIUJUKXFWLWGUIULUMXHWEWOWIJZWLWGWRJZMWTXFXLXGXMXFWEWOMZWIMXLWEXNWIW
    EWOWEWOWCWNWDABSUDTUGUKWEWOWIUNUJXGWLWGWRMZMXMWGXOWLWGWRWGWRWFWQWDBCSUDTUGU
    HWLWGWRUQUJUOWEWOWIWLWGWRURULUMVPVTWTXERWAVPVTMZWMXBWPXCWSXDXPXBWMABCDEFGHU
    SUTXPXCWPVPVNVMVOJZEBACKZLZVSMXCWPRVTVPXQVMVNVOVGTVRXSVSVRXSVQXREABCVAVBTVC
    BACDEGFHUSVDUTXPXDWSVPVOVMVNJZECABKZLZVSMXDWSRVTXTVPVOVMVNVEVHVRYBVSVRYBVQY
    AEYAVQCABVFVIVBTVCCABDEHFGUSVDUTVJVKVL $.

  $( If the neighbors of two vertices in a graph with three elements are an
     unordered pair of the other vertices, the neighbors of all three vertices
     are an unordered pair of the other vertices.  (Contributed by Alexander
     van der Vekens, 18-Oct-2017.) $)
  nb3gra2nb $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                      /\ ( V = { A , B , C } /\ V USGrph E ) )
        -> ( ( ( <. V , E >. Neighbors A ) = { B , C }
                /\ ( <. V , E >. Neighbors B ) = { A , C } )
             <-> ( ( <. V , E >. Neighbors A ) = { B , C }
                /\ ( <. V , E >. Neighbors B ) = { A , C }
                /\ ( <. V , E >. Neighbors C ) = { A , B } ) ) ) $=
    ( wcel w3a ctp wceq wa cnbgra co cpr prcom eleq1i biimpi nb3graprlem1 wi wb
    cusg wbr cop crn adantl anim12i 3ancoma tpcoma eqeq2i anim1i syl2an anbi12d
    a1i 3anrot biimpri tprot eqcomi anbi1i 3imtr4d pm4.71d df-3an syl6bbr ) AFI
    ZBGIZCHIZJZEABCKZLZEDUCUDZMZMZEDUEZANOBCPZLZVNBNOACPZLZMZVSVNCNOABPZLZMVPVR
    WAJVMVSWAVMVTDUFZIZVQWBIZMZBAPWBIZVOWBIZMZMZCAPZWBIZCBPZWBIZMZVSWAWIWNUAVMW
    EWKWHWMWDWKWCWDWKVQWJWBACQRSUGWGWMWFWGWMVOWLWBBCQRSUGUHUOVMVPWEVRWHABCDEFGH
    TVHVFVEVGJZEBACKZLZVKMVRWHUBVLVHWOVEVFVGUISVJWQVKVJWQVIWPEABCUJUKSULBACDEGF
    HTUMUNVHVGVEVFJZECABKZLZVKMZWAWNUBVLWRVHVGVEVFUPUQVLXAVJWTVKVIWSEWSVICABURU
    SUKUTSCABDEHFGTUMVAVBVPVRWAVCVD $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Complete graphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d V e k n v $.  $d E e k n v $.
    $( The property of being a complete (undirected simple) graph.
       (Contributed by Alexander van der Vekens, 12-Oct-2017.) $)
    iscusgra $p |- ( ( V e. X /\ E e. Y ) -> ( V ComplUSGrph E
            <-> ( V USGrph E /\ A. k e. V A. n e. ( V \ { k } )
                   { n , k } e. ran E ) ) ) $=
      ( vv ve cv cusg wbr cpr crn wcel csn cdif wral wa wceq raleqbidv ccusgra
      breq12 simpl difeq1 adantr rneq adantl eleq2d anbi12d df-cusgra brabga )
      GIZHIZJKZBIAIZLZUMMZNZBULUOOZPZQZAULQZRDCJKZUPCMZNZBDUSPZQZADQZRGHDCUAEFU
      LDSZUMCSZRZUNVCVBVHULDUMCJUBVKVAVGAULDVIVJUCVKURVEBUTVFVIUTVFSVJULDUSUDUE
      VKUQVDUPVJUQVDSVIUMCUFUGUHTTUIGHABUJUK $.
  $}

  ${
    $d e k n v $.  $d E k n $.  $d V k n $.
    $( The property of being a complete (undirected simple) graph.
       (Contributed by Alexander van der Vekens, 13-Oct-2017.) $)
    iscusgra0 $p |- ( V ComplUSGrph E -> ( V USGrph E
               /\ A. k e. V A. n e. ( V \ { k } ) { n , k } e. ran E ) ) $=
      ( vv ve cvv wcel wa ccusgra wbr cusg cpr crn cdif wral df-cusgra relopabi
      cv csn brrelexi brrelex2i jca iscusgra biimpd mpcom ) DGHZCGHZIZDCJKZDCLK
      BSASZMZCNHBDUKTZOPADPIZUJUGUHDCJESZFSZLKULUPNHBUOUMOPAUOPIEFJEFABQRZUADCJ
      UQUBUCUIUJUNABCDGGUDUEUF $.
  $}

  ${
    $d E k n $.  $d V k n $.
    $( A complete (undirected simple) graph is an undirected simple graph.
       (Contributed by Alexander van der Vekens, 13-Oct-2017.) $)
    cusisusgra $p |- ( V ComplUSGrph E -> V USGrph E ) $=
      ( vn vk ccusgra wbr cusg cv cpr crn wcel csn cdif wral iscusgra0 simpld )
      BAEFBAGFCHDHZIAJKCBQLMNDBNDCABOP $.
  $}

  ${
    $d E a b k l $.  $d V a b k l $.  $d E e x $.  $d V e x $.  $d a b e k l $.
    $( In a complete simple graph, the range of the edge function consists of
       all the pairs with different vertices.  (Contributed by Alexander van
       der Vekens, 12-Jan-2018.) $)
    cusgrarn $p |- ( V ComplUSGrph E
                     -> ran E = { x e. ~P V | ( # ` x ) = 2 } ) $=
      ( vl vk ve va vb cv cpr wcel wral wa chash c2 wceq wi syl adantr weq cusg
      ccusgra wbr crn csn cdif cfv cpw iscusgra0 cdm wf1 usgraf0 wf f1f wfn wss
      crab df-f ssel adantl sylbi fveq2 eqeq1d elrab wne wex cvv hash2prde mpan
      vex eleq1 prex elpw prss bitr4i simprl anim1i eldifsn sylibr simplrr sneq
      difeq2d preq2 eleq1d raleqbidv rspcv preq1 sylsyld wb bicomd sylibd exp31
      syl5bi sylbid com23 impcom exlimivv com12 impbid eqrdv sylan ) CBUBUCCBUA
      UCZDIZEIZJZBUDZKZDCXDUEZUFZLZECLZMXFAIZNUGZOPZACUHZUQZPZEDBCUIXBBUJZXPBUK
      ZXKXQABCULXSXKMZFXFXPXTFIZXFKZYAXPKZXSYBYCQZXKXSXRXPBUMZYDXRXPBUNYEBXRUOZ
      XFXPUPZMYDXRXPBURYGYDYFXFXPYAUSUTVARSXKYCYBQXSYCXKYBYCYAXOKZYANUGZOPZMXKY
      BQZXNYJAYAXOAFTXMYIOXLYANVBVCVDYJYHYKYJGIZHIZVEZYAYLYMJZPZMZHVFGVFZYHYKQZ
      YAVGKYJYRFVJYAVGGHVHVIYQYSGHYPYNYSYPYHYNYKYPYHYOXOKZYNYKQZYAYOXOVKYTYLCKZ
      YMCKZMZYPUUAYTYOCUPUUDYOCYLYMVLVMYLYMCGVJHVJVNVOYPUUDYNYKYPUUDMZYNMZXKYOX
      FKZYBUUFYLCYMUEZUFZKZXKXCYMJZXFKZDUUILZUUGUUFUUBYNMUUJUUEUUBYNYPUUBUUCVPV
      QYLCYMVRVSUUFUUCXKUUMQYPUUBUUCYNVTXJUUMEYMCEHTZXGUULDXIUUIUUNXHUUHCXDYMWA
      WBUUNXEUUKXFXDYMXCWCWDWEWFRUULUUGDYLUUIDGTUUKYOXFXCYLYMWGWDWFWHUUEUUGYBWI
      ZYNYPUUOUUDYPYBUUGYAYOXFVKWJSSWKWLWMWNWOWPWQRWPVAWRUTWSWTXAR $.
  $}

  ${
    $d k n $.
    $( A graph with no vertices (and therefore no edges) is complete.
       (Contributed by Alexander van der Vekens, 13-Oct-2017.) $)
    cusgra0v $p |- (/) ComplUSGrph (/) $=
      ( vn vk c0 cvv wcel ccusgra wbr 0ex wa cusg cv cpr crn csn cdif wral mp1i
      usgra0 ral0 a1i iscusgra mpbir2and mp2an ) CDEZUDCCFGZHHUDUDIZUECCJGZAKBK
      ZLCMEACUHNOPZBCPZUDUGUFHCDRQUJUFUIBSTBACCDDUAUBUC $.

    $d A k n $.
    $( A graph with one vertex (and therefore no edges) is complete.
       (Contributed by Alexander van der Vekens, 13-Oct-2017.) $)
    cusgra1v $p |- { A } ComplUSGrph (/) $=
      ( vn vk cvv wcel csn c0 ccusgra wbr cusg cv cpr crn cdif wral snex usgra0
      mp1i wceq mpbiri ral0 sneq difeq2d difid syl6eq preq2 eleq1d raleqbidv wa
      ralsng wb 0ex iscusgra mp2an sylanbrc snprc cusgra0v breq1 sylbi pm2.61i
      wn ) ADEZAFZGHIZVBVCGJIZBKZCKZLZGMZEZBVCVGFZNZOZCVCOZVDVCDEZVEVBAPZVCDQRV
      BVNVFALZVIEZBGOZVRBUAVMVSCADVGASZVJVRBVLGVTVLVCVCNGVTVKVCVCVGAUBUCVCUDUEV
      TVHVQVIVGAVFUFUGUHUJTVOGDEVDVEVNUIUKVPULCBGVCDDUMUNUOVBVAVCGSZVDAUPWAVDGG
      HIUQVCGGHURTUSUT $.

    $d B k n $.  $d E k n $.  $d V n $.  $d W n $.
    $( A graph with two (different) vertices is complete if and only if there
       is an edge between these two vertices.  (Contributed by Alexander van
       der Vekens, 12-Oct-2017.)  (Proof shortened by Alexander van der Vekens,
       16-Dec-2017.) $)
    cusgra2v $p |- ( ( A e. V /\ B e. W /\ A =/= B ) -> ( { A , B } USGrph E
                   -> ( { A , B } ComplUSGrph E <-> { A , B } e. ran E ) ) ) $=
      ( vn vk cpr wbr wcel wb wa csn cdif wral cvv adantl wceq eleq1d bitrd wne
      cusg w3a ccusgra crn usgrav adantr iscusgra syl 3simpa sneq difeq2d preq2
      cv raleqbidv ralprg ibar difprsn1 3ad2ant3 preq1 ralsng 3ad2ant2 difprsn2
      raleqdv 3ad2ant1 anbi12d prcom eleq1i anbi1i anidm syl6bb 3bitr3d expcom
      bitri ) ABHZCUBIZADJZBEJZABUAZUCZVOCUDIZVOCUEZJZKVPVTLZWAVPFUNZGUNZHZWBJZ
      FVOWFMZNZOZGVOOZLZWCWDVOPJCPJLZWAWMKVPWNVTCVOUFUGGFCVOPPUHUIWDWLWEAHZWBJZ
      FVOAMZNZOZWEBHZWBJZFVOBMZNZOZLZWMWCWDVQVRLZWLXEKVTXFVPVQVRVSUJQWKWSXDGABD
      EWFARZWHWPFWJWRXGWIWQVOWFAUKULXGWGWOWBWFAWEUMSUOWFBRZWHXAFWJXCXHWIXBVOWFB
      UKULXHWGWTWBWFBWEUMSUOUPUIVPWLWMKVTVPWLUQUGWDXEBAHZWBJZWCLZWCWDWSXJXDWCWD
      WSWPFXBOZXJWDWPFWRXBVTWRXBRZVPVSVQXMVRABURUSQVDVTXLXJKZVPVRVQXNVSWPXJFBEW
      EBRWOXIWBWEBAUTSVAVBQTWDXDXAFWQOZWCWDXAFXCWQVTXCWQRZVPVSVQXPVRABVCUSQVDVT
      XOWCKZVPVQVRXQVSXAWCFADWEARWTVOWBWEABUTSVAVEQTVFXKWCWCLWCXJWCWCXIVOWBBAVG
      VHVIWCVJVNVKVLTVM $.
  $}

  ${
    $d E k n x $.  $d V k n x $.  $d N k n x $.
    $( In a complete (undirected simple) graph, each vertex has all other
       vertices as neighbors.  (Contributed by Alexander van der Vekens,
       12-Oct-2017.) $)
    nbcusgra $p |- ( ( V ComplUSGrph E /\ N e. V )
                     -> ( <. V , E >. Neighbors N ) = ( V \ { N } ) ) $=
      ( vn vx vk wcel wceq wi wa cv cpr adantr wb cvv syl wn com12 ex imp preq2
      ccusgra wbr cop cnbgra csn cdif cusg cusisusgra crn crab nbusgra wal wral
      co usgrav iscusgra biimpa df-ral weq eleq1d elrab pm2.24 eldif impbid a1d
      sylbi usgraedgrn elsni eqcom sylibr necon3ai ad2antrl elsncg elsn biimpri
      wne simpr syl6bi con3d impcom eldifd preq1 rspcva com24 com13 com14 imp31
      ax-1 pm5.32da syl6bbr syl5bb alimdv syl5bi impancom dfcleq eqtrd mpancom
      ja ) CAUBUCZBCGZCAUDBUEUOZCBUFZUGZHZCAUHUCZWTXAXEIACUIXFWTJZXAXEXGXAJZXBB
      DKZLZAUJZGZDCUKZXDXGXBXMHZXAXFXNWTDABCULMMXHEKZXMGZXOXDGZNZEUMZXMXDHXGXAX
      SXGXFFKZXOLZXKGZFCXOUFZUGZUNZECUNZJZXAXSIXFWTYGXFCOGAOGJWTYGNACUPEFACOOUQ
      PURXFXAYFXSYFXOCGZYEIZEUMXFXAJZXSYEECUSYJYIXREYJYIXRXPYHBXOLZXKGZJZYJYIJX
      QXLYLDXOCDEUTXJYKXKXIXOBUAVAVBYIYJYMXQNZYHYEYJYNIYHQZYNYJYOYMXQYMYOXQYHYO
      XQIYLYHXQVCMRXQYOYMXQYHXOXCGZQZJZYOYMIZXOCXCVDZYHYSYQYHYMVCMVGRVEVFYEYJYN
      YEYJJZYMYRXQUUAYHYLYQUUAYHJYLYQUUAYLYQIZYHXFUUBYEXAXFYLYQXFYLJBXOVQYQABXO
      CVHYPBXOYPXOBHZBXOHZXOBVIBXOVJZVKVLPSVMMYEYJYHYQYLIYQYJYHYEYLYJYQYHYEYLII
      ZXFXAYQUUFIYQXAXFUUFYQXAXFUUFIZYQXAJZBYDGZUUGUUHBCYCYQXAVRXAYQBYCGZQXAUUJ
      YPXAUUJUUDYPBXOCVNUUDUUCYPUUEYPUUCEBVOVPVGVSVTWAWBUUIYEYHXFYLUUIYEYHXFYLI
      ZIZUUIYEJYLUULYBYLFBYDXTBHYAYKXKXTBXOWCVAWDYLUUKYHYLXFWIVFPSWEPSWFTRWGWHV
      EWJYTWKSWSWAWLSWMWNWOPTEXMXDWPVKWQSWRT $.
  $}

  ${
    $d A k n $.  $d B k n $.  $d C k n $.  $d E k n $.  $d V k n $.  $d X k $.
    $d Y k $.  $d Z k $.
    cusgra3v.v $e |- V = { A , B , C } $.
    $( A graph with three (different) vertices is complete if and only if there
       is an edge between each of these three vertices.  (Contributed by
       Alexander van der Vekens, 12-Oct-2017.) $)
    cusgra3v $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z ) /\ V USGrph E
                       /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
                   -> ( V ComplUSGrph E <-> ( { A , B } e. ran E
                        /\ { B , C } e. ran E /\ { C , A } e. ran E ) ) ) $=
      ( vn vk wcel w3a cpr cdif wral wa wceq wb eleq1d cusg wbr wne crn ccusgra
      cv csn simp2 biantrurd ctp difeq1i a1i raleqdv ralbidv sneq difeq2d preq2
      raleqi raleqbidv raltpg 3bitrd tprot difeq1d necom anbi12i biimpi 3adant3
      3ad2ant1 diftpsn3 syl eqtrd tpcomb anim2i 3adant2 3adant1 3anbi123d preq1
      3ad2ant3 ralprg ancom 3anbi2i bitri prcom eleq1i 3anbi123i 3anrot 3bitrrd
      3an6 anidm cvv usgrav iscusgra 3ad2ant2 3bitr4rd ) AFLZBGLZCHLZMZEDUAUBZA
      BUCZACUCZBCUCZMZMZJUFZKUFZNZDUDZLZJEXFUGZOZPZKEPZWSXMQZABNZXHLZBCNZXHLZCA
      NZXHLZMZEDUEUBZXDWSXMWRWSXCUHUIXDXMXEANZXHLZJABCUJZAUGZOZPZXEBNZXHLZJYEBU
      GZOZPZXECNZXHLZJYECUGZOZPZMZYDJXQPZYJJACNZPZYOJXOPZMZYAXDXMXIJYEXJOZPZKEP
      ZUUFKYEPZYSXDXLUUFKEXDXIJXKUUEXKUUERXDEYEXJIUKULUMUNUUGUUHSXDUUFKEYEIURUL
      WRWSUUHYSSXCUUFYHYMYRKABCFGHXFARZXIYDJUUEYGUUIXJYFYEXFAUOUPUUIXGYCXHXFAXE
      UQTUSXFBRZXIYJJUUEYLUUJXJYKYEXFBUOUPUUJXGYIXHXFBXEUQTUSXFCRZXIYOJUUEYQUUK
      XJYPYEXFCUOUPUUKXGYNXHXFCXEUQTUSUTVHVAXDYHYTYMUUBYRUUCXDYDJYGXQXCWRYGXQRW
      SXCYGBCAUJZYFOZXQXCYEUULYFYEUULRXCABCVBULVCXCBAUCZCAUCZQZUUMXQRWTXAUUPXBW
      TXAQUUPWTUUNXAUUOABVDACVDVEVFVGBCAVIVJVKVRUMXDYJJYLUUAXCWRYLUUARWSXCYLACB
      UJZYKOZUUAXCYEUUQYKYEUUQRXCABCVLULVCXCWTCBUCZQZUURUUARWTXBUUTXAXBUUSWTXBU
      USBCVDVFVMVNACBVIVJVKVRUMXDYOJYQXOXCWRYQXORZWSXAXBUVAWTABCVIVOVRUMVPXDUUD
      BANZXHLZXTQZXPCBNZXHLZQZUUAXHLZXRQZMZUVCUVFUVHMZXTXPXRMZQZYAXDYTUVDUUBUVG
      UUCUVIWRWSYTUVDSZXCWPWQUVNWOYDUVCXTJBCGHXEBRZYCUVBXHXEBAVQTXECRZYCXSXHXEC
      AVQTVSVOVHWRWSUUBUVGSZXCWOWQUVQWPYJXPUVFJACFHXEARZYIXOXHXEABVQTUVPYIUVEXH
      XECBVQTVSVNVHWRWSUUCUVISZXCWOWPUVSWQYOUVHXRJABFGUVRYNUUAXHXEACVQTUVOYNXQX
      HXEBCVQTVSVGVHVPUVJUVMSXDUVJUVDUVFXPQZUVIMUVMUVGUVTUVDUVIXPUVFVTWAUVCXTUV
      FXPUVHXRWHWBULUVMYASXDUVMYAYAQYAUVKYAUVLYAUVCXPUVFXRUVHXTUVBXOXHBAWCWDUVE
      XQXHCBWCWDUUAXSXHACWCWDWEXTXPXRWFVEYAWIWBULVAWGWSWRYBXNSZXCWSEWJLDWJLQUWA
      DEWKKJDEWJWJWLVJWMWN $.

    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d E x y z $.  $d V x y z $.
    $( The neighbors of a vertex in a graph with three elements are unordered
       pairs of the other vertices if and only if the graph is complete.
       (Contributed by Alexander van der Vekens, 18-Oct-2017.) $)
    cusgra3vnbpr $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z ) /\ V USGrph E
                       /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
             -> ( V ComplUSGrph E <-> A. x e. V E. y e. V E. z e. ( V \ { y } )
                  ( <. V , E >. Neighbors x ) = { y , z } ) ) $=
      ( wcel w3a wbr wne cpr cv wceq wrex cusg ccusgra crn cop cnbgra cdif wral
      co csn cusgra3v ctp wa wb jctl nb3grapr syl3an2 bitrd ) DIMEJMFKMNZHGUAOZ
      DEPDFPEFPNZNHGUBODEQGUCZMEFQVAMFDQVAMNZHGUDARUEUHBRZCRQSCHVCUIUFTBHTAHUGZ
      DEFGHIJKLUJUSURHDEFUKSZUSULUTVBVDUMUSVELUNABCDEFGHIJKUOUPUQ $.
  $}

  ${
    $d V x $.
    cusgraexi.p $e |- P = { x e. ~P V | ( # ` x ) = 2 } $.
    $( Lemma 1 for ~ cusgraexi .  (Contributed by Alexander van der Vekens,
       12-Jan-2018.) $)
    cusgraexilem1 $p |- ( V e. W -> ( _I |` P ) e. _V ) $=
      ( wcel cvv cid cres cv chash cfv wceq cpw crab pwexg rabexg syl syl5eqel
      c2 resiexg ) CDFZBGFHBIGFUBBAJKLTMZACNZOZGEUBUDGFUEGFCDPUCAUDGQRSBGUAR $.

    $d P x $.  $d V x $.  $d W x $.
    $( Lemma 2 for ~ cusgraexi .  (Contributed by Alexander van der Vekens,
       12-Jan-2018.) $)
    cusgraexilem2 $p |- ( V e. W -> V USGrph ( _I |` P ) ) $=
      ( wcel cid cres cvv cusg wbr cusgraexilem1 wa cdm cv chash wceq wf1 ax-mp
      wb cfv c2 cpw crab wf1o f1oi f1of1 dmresi f1eq2 mpbir eqcomi f1eq3 mpbiri
      mp1i isusgra0 mpbird mpdan ) CDFZGBHZIFZCUSJKZABCDELURUTMZVAUSNZAOPUAUBQA
      CUCUDZUSRZVBVEVCBUSRZVFBBUSRZBBUSUEVGBUFBBUSUGSVCBQVFVGTBUHVCBBUSUISUJVDB
      QVEVFTVBBVDEUKVDBVCUSULUNUMAUSCDIUOUPUQ $.

    $d P a b $.  $d V a b x $.  $d W a b $.
    $( For each set the identity function restricted to the set of pairs of
       elements from the given set is an edge function, so that the given set
       together with this edge function is a complete graph.  (Contributed by
       Alexander van der Vekens, 12-Jan-2018.) $)
    cusgraexi $p |- ( V e. W -> V ComplUSGrph ( _I |` P ) ) $=
      ( vb va wcel cid cvv wbr wa cv wral chash cfv c2 wceq syl2anr ralrimiva
      cres ccusgra cusgraexilem1 cusg cpr crn csn cdif cusgraexilem2 adantr cpw
      eldifi simpr prelpwi eldifsni adantl wb hashprg mpbid fveq2 eqeq1d rnresi
      wne crab eqtri elrab2 sylanbrc iscusgra mpbir2and mpdan ) CDHZIBUAZJHZCVL
      UBKZABCDEUCVKVMLZVNCVLUDKZFMZGMZUEZVLUFZHZFCVRUGZUHZNZGCNVKVPVMABCDEUIUJV
      OWDGCVOVRCHZLZWAFWCWFVQWCHZLZVSCUKZHZVSOPZQRZWAWGVQCHZWEWJWFVQCWBULZVOWEU
      MZVQVRCUNSWHVQVRVCZWLWGWPWFVQCVRUOUPWGWMWEWPWLUQWFWNWOVQVRCURSUSAMZOPZQRZ
      WLAVSWIVTWQVSRWRWKQWQVSOUTVAVTBWSAWIVDBVBEVEVFVGTTGFVLCDJVHVIVJ $.
  $}

  ${
    $d V e x y $.  $d W x $.
    $( For each set there is an edge function so that the set together with
       this edge function is a complete graph.  (Contributed by Alexander van
       der Vekens, 12-Jan-2018.) $)
    cusgraexg $p |- ( V e. W -> E. e V ComplUSGrph e ) $=
      ( vy vx wcel cid cv chash cfv wceq cpw crab cres cvv ccusgra wbr wex weq
      c2 fveq2 eqeq1d cbvrabv cusgraexilem1 cusgraexi breq2 spcegv sylc ) BCFGD
      HZIJZTKZDBLZMZNZOFBUNPQZBAHZPQZAREUMBCUKEHZIJZTKDEULDESUJUSTUIURIUAUBUCZU
      DEUMBCUTUEUQUOAUNOUPUNBPUFUGUH $.
  $}

  $( Base case of the induction in ~ cusgrasize .  The size of a complete
     simple graph with 0 vertices is 0=((0-1)*0)/2.  (Contributed by Alexander
     van der Vekens, 2-Jan-2018.) $)
  cusgrasizeindb0 $p |- ( ( V ComplUSGrph E /\ ( # ` V ) = 0 )
                          -> ( # ` E ) = ( ( # ` V ) _C 2 ) ) $=
    ( ccusgra wbr chash cfv cc0 wceq wa c2 cbc co cusg cusisusgra usgrafisindb0
    sylan wb oveq1 cn wcel 2nn bc0k ax-mp syl6eq eqeq2d adantl mpbird ) BACDZBE
    FZGHZIAEFZUIJKLZHZUKGHZUHBAMDUJUNABNABOPUJUMUNQUHUJULGUKUJULGJKLZGUIGJKRJST
    UOGHUAJUBUCUDUEUFUG $.

  $( Base case of the induction in ~ cusgrasize .  The size of a complete
     simple graph with 1 vertex is 0=((1-1)*1)/2.  (Contributed by Alexander
     van der Vekens, 2-Jan-2018.) $)
  cusgrasizeindb1 $p |- ( ( V ComplUSGrph E /\ ( # ` V ) = 1 )
                          -> ( # ` E ) = ( ( # ` V ) _C 2 ) ) $=
    ( ccusgra wbr chash cfv c1 wceq wa c2 cbc cc0 cusg cusisusgra usgrafisindb1
    co sylan wb wcel clt oveq1 cn0 cz wo 1nn0 2z 1lt2 olci bcval4 syl6eq eqeq2d
    mp3an adantl mpbird ) BACDZBEFZGHZIAEFZUPJKPZHZURLHZUOBAMDUQVAABNABOQUQUTVA
    RUOUQUSLURUQUSGJKPZLUPGJKUAGUBSJUCSJLTDZGJTDZUDVBLHUEUFVDVCUGUHJGUIULUJUKUM
    UN $.

  ${
    $d x y $.  $d E e y $.  $d E k n x y $.  $d F e $.  $d F k n $.
    $d N e y $.  $d N k n x y $.  $d V e y $.  $d V k n $.
    cusgrares.f $e |- F = ( E |` { x e. dom E | N e/ ( E ` x ) } ) $.
    $( Restricting a complete simple graph.  (Contributed by Alexander van der
       Vekens, 2-Jan-2018.) $)
    cusgrares $p |- ( ( V ComplUSGrph E /\ N e. V )
                       -> ( V \ { N } ) ComplUSGrph F ) $=
      ( vn vk vy wbr wcel wa cdif wral wi wnel wceq wn syl cvv ccusgra csn cusg
      cpr crn cusisusgra usgrares1 sylan iscusgra0 cfv crab cima wrex ccnv wf1o
      cv cdm usgraf1o f1ocnvdm adantll wo elpri vex snid syl5eleqr notnot sylib
      sneq df-nel sylnibr orim12i ianor sylibr ad2antrr f1ocnvfv2 neleq2 mpbird
      con2i wb fveq2 elrab sylanbrc jca exp31 com23 ex imp adantr eqeq1d rspcev
      com14 imp31 wfn wfun usgrafun funfn ad6antr ssrab2 fvelimab sylancl rneqi
      wss df-ima eqtr4i syl6eleqr ralimdva raldifb dif32 raleqi impancom syl6ib
      cres usgrav difexg resexg syl5eqel iscusgra syl2an mpbir2and ) EBUAJZDEKZ
      LEDUBZMZCUAJZYCCUCJZGUPZHUPZUDZCUEZKZGYCYGUBZMZNZHYCNZXTEBUCJZYAYEBEUFZAB
      CDEFUGUHXTYAYNXTYOYHBUEZKZGEYKMZNZHENZLZYAYNOHGBEUIUUBYAYGYBPZYMOZHENZYNY
      OYAUUAUUEYOYALZYTUUDHEUUFYGEKZLZUUCYTYMUUHUUCYTYMUUHUUCLZYTLZYJGYSYBMZNZY
      MUUJYFYBPZYJOZGYSNZUULUUIYTUUOUUIYRUUNGYSUUIYFYSKZLZYRUUMYJUUQYRLUUMLZYHB
      DAUPZBUJZPZABUQZUKZULZYIUURYHUVDKZIUPZBUJZYHQZIUVCUMZUURYHBUNUJZUVCKZUVJB
      UJZYHQZLZUVIUUQYRUUMUVNUUIYRUUMUVNOOZUUPUUHUUCUVOYOUUCUVOOZYAUUGYOUVBYQBU
      OZUVPBEURUUMUUCYRUVQUVNUUMUUCYRUVQUVNOOUUMUUCLZUVQYRUVNUVRUVQYRUVNUVRUVQL
      YRLZUVKUVMUVSUVJUVBKZDUVLPZUVKUVQYRUVTUVRUVBYQYHBUSUTUVSUWADYHPZUVRUWBUVQ
      YRUVRDYHKZRUWBUWCUVRUWCUUMRZUUCRZVAZUVRRUWCDYFQZDYGQZVAUWFDYFYGVBUWGUWDUW
      HUWEUWGYFYBKZRZUUMUWGUWIUWJRUWGYFYFUBYBYFGVCVDDYFVHVEUWIVFVGYFYBVIVJUWHYG
      YBKZRZUUCUWHUWKUWLRUWHYGYKYBYGHVCVDDYGVHVEUWKVFVGYGYBVIVJVKSUUMUUCVLVMVRD
      YHVIVMVNUVSUVMUWAUWBVSUVQYRUVMUVRUVBYQYHBVOUTZUVLYHDVPSVQUVAUWAAUVJUVBUUS
      UVJQUUTUVLQUVAUWAVSUUSUVJBVTUUTUVLDVPSWAWBUWMWCWDWEWFWKSVNWGWHWLUVHUVMIUV
      JUVCUVFUVJQUVGUVLYHUVFUVJBVTWIWJSUURBUVBWMZUVCUVBXBUVEUVIVSYOUWNYAUUGUUCU
      UPYRUUMYOBWNUWNBEWOBWPVGWQUVAAUVBWRIUVBUVCYHBWSWTVQYIBUVCXLZUEUVDCUWOFXAB
      UVCXCXDXEWDXFWGYJGYSYBXGVGYJGYLUUKEYBYKXHXIVMWDWEXFXJYMHEYBXGXKSWGXTYDYEY
      NLVSZYAXTETKZBTKZLZUWPXTYOUWSYPBEXMSUWQYCTKCTKUWPUWREYBTXNUWRCUWOTFBUVCTX
      OXPHGCYCTTXQXRSWHXS $.

    $( Lemma 1 for ~ cusgrasizeinds .  The domain of the edge function is the
       union of the arguments/indices of all edges containing a specific vertex
       and the arguments/indices of all edges not containing this vertex.
       (Contributed by Alexander van der Vekens, 4-Jan-2018.) $)
    cusgrasizeindslem1 $p |- dom E = ( dom F
                                       u. { x e. dom E | N e. ( E ` x ) } ) $=
      ( usgrafilem1 ) ABCDEF $.

    $( Lemma 2 for ~ cusgrasizeinds .  (Contributed by Alexander van der
       Vekens, 11-Jan-2018.) $)
    cusgrasizeindslem2 $p |- ( dom F
                               i^i { x e. dom E | N e. ( E ` x ) } ) = (/) $=
      ( cdm cv cfv wcel crab cin wnel c0 cres dmeqi wceq eqtri wn wo mpbir ssid
      incom dmres dfrab3ss ax-mp 3eqtr4i ineq1i wa inrab wral exmid nnel orbi1i
      wss ianor rgenw rabeq0 ) CFZDAGBHZIZABFZJZKDUSLZAVAJZVBKZMURVDVBURBVDNZFZ
      VDCVFEOVDVAKVAVDKZVGVDVDVAUBBVDUCVAVAUNVDVHPVAUAVCAVAVAUDUEUFQUGVEVCUTUHZ
      AVAJZMVCUTAVAUIVJMPVIRZAVAUJVKAVAVKVCRZUTRZSZVNUTVMSUTUKVLUTVMDUSULUMTVCU
      TUOTUPVIAVAUQTQQ $.

    $d E f x $.  $d N f x $.  $d V f x $.
    $( Lemma 3 for ~ cusgrasizeinds .  (Contributed by Alexander van der
       Vekens, 11-Jan-2018.) $)
    cusgrasizeindslem3 $p |- ( ( V ComplUSGrph E /\ V e. Fin /\ N e. V )
            -> ( # ` { x e. dom E | N e. ( E ` x ) } ) = ( ( # ` V ) - 1 ) ) $=
      ( vf vn wbr cfn wcel co chash cfv cv crab wceq 3adant2 wa syl ccusgra w3a
      cop cnbgra csn cdif cdm cmin nbcusgra fveq2d wf1o wex cusisusgra nbgraf1o
      c1 anim1i wb cpr crn nbusgra adantr rabfi adantl eqeltrd 3adant3 usgrafis
      cusg sylan dmfi hasheqf1o syl2anc mpbird hashdifsn 3adant1 3eqtr3d ) EBUA
      IZEJKZDEKZUBZEBUCDUDLZMNZEDUEUFZMNZDAOBNKZABUGZPZMNZEMNUOUHLZVSVTWBMVPVRV
      TWBQVQBDEUIRUJVSWAWGQZVTWFGOUKGULZVSEBVGIZVRSZWJVPVRWLVQVPWKVRBEUMZUPRDGA
      BEUNTVSVTJKZWFJKZWIWJUQVPVQWNVRVPVQSZVTDHOURBUSKZHEPZJVPVTWRQZVQVPWKWSWMH
      BDEUTTVAVQWRJKVPWQHEVBVCVDVEVPVQWOVRWPBJKZWOVPWKVQWTWMBEVFVHWTWEJKWOBVIWD
      AWEVBTTVEVTWFGVJVKVLVQVRWCWHQVPEDVMVNVO $.

    $( Part 1 of induction step in ~ cusgrasize .  The size of a complete
       simple graph with ` n ` vertices is ` ( n - 1 ) ` plus the size of the
       complete graph reduced by one vertex.  (Contributed by Alexander van der
       Vekens, 11-Jan-2018.) $)
    cusgrasizeinds $p |- ( ( V ComplUSGrph E /\ V e. Fin /\ N e. V )
                     -> ( # ` E ) = ( ( ( # ` V ) - 1 ) + ( # ` F ) ) ) $=
      ( wbr cfn wcel chash cfv c1 co caddc wceq wa syl adantr adantl a1i w3a wi
      ccusgra cmin cusg cusisusgra usgrafis a1d 3imp cdm wfun usgrafun 3ad2ant1
      ex wb hashfun mpbid crab cun cusgrasizeindslem1 fveq2d cin wnel finresfin
      cv cres syl5eqel dmfi rabfi cusgrasizeindslem2 syl3anc cusgrasizeindslem3
      c0 hashun oveq2d cc hashcl nn0cnd 3syl cn0 ax-1cn subcld 3ad2ant2 addcomd
      nn0cn eqtrd 3eqtrd csn cdif cusgrares 3adant2 eqcomd mpdan ) EBUCGZEHIZDE
      IZUAZBHIZBJKZEJKZLUDMZCJKZNMZOWNWOWPWRWNEBUEGZWOWPWRUBZUBBEUFZXDWOXEXDWOP
      WRWPBEUGUHUNQUIWQWRPZWSBUJZJKZXACUJZJKZNMZXCXGBUKZWSXIOZWQXMWRWNWOXMWPWNX
      DXMXFBEULQUMRWRXMXNUOWQBUPSUQXGXIXJDAVEBKZIZAXHURZUSZJKZXKXQJKZNMZXLXGXHX
      RJXHXROXGABCDFUTTVAXGXJHIZXQHIZXJXQVBVMOZXSYAOWRYBWQWRCHIZYBWRCBDXOVCAXHU
      RZVFHFYFBVDVGZCVHZQSWRYCWQWRXHHIYCBVHXPAXHVIQSYDXGABCDFVJTXJXQVNVKXGYAXKX
      ANMXLXGXTXAXKNWQXTXAOWRABCDEFVLRVOXGXKXAWRXKVPIZWQWRYEYBYIYGYHYBXKXJVQVRV
      SSWQXAVPIZWRWOWNYJWPWOWTVTIZYJEVQYKWTLWTWELVPIYKWATWBQWCRWDWFWGXGXKXBXANX
      GXBXKXGCUKZXBXKOZWQYLWRWNWPYLWOWNWPPEDWHWIZCUCGYNCUEGYLABCDEFWJCYNUFCYNUL
      VSWKRXGYEYLYMUOWRYEWQYGSCUPQUQWLVOWGWM $.

    $( Induction step in ~ cusgrasize .  If the size of the complete graph with
       ` n ` vertices reduced by one vertex is " ` ( n - 1 ) ` choose 2", the
       size of the complete graph with ` n ` vertices is " ` n ` choose 2".
       (Contributed by Alexander van der Vekens, 11-Jan-2018.) $)
    cusgrasize2inds $p |- ( Y e. NN0
                         -> ( ( V ComplUSGrph E /\ ( # ` V ) = Y /\ N e. V )
                           -> ( ( # ` F ) = ( ( # ` ( V \ { N } ) ) _C 2 )
                             -> ( # ` E ) = ( ( # ` V ) _C 2 ) ) ) ) $=
      ( chash cfv wceq wcel c2 cbc co wi cvv wa c1 caddc imp ccusgra cusisusgra
      wbr w3a cn0 csn cdif cusg usgrav cn hashnn0n0nn anassrs simplll simplr wb
      syl cmin eleq1 eqcoms nnm1nn0 syl6bi ad2antlr cc ax-1cn a1i npcand eqcomd
      brfi1indlem syl31anc oveq1 eqeq2d nnnn0 hashclb syl5ibrcom cusgrasizeinds
      nncn cfn impcom oveq2 adantl bcn2m1 biimpd adantr sylbid com3r 3exp com14
      ex mpd com23 com13 com24 mpcom adantllr exp41 com25 3imp com12 ) EBUAUCZE
      HIZFJZDEKZUDFUEKZCHIZEDUFUGHIZLMNZJZBHIZWTLMNZJZOZWSXAXBXCXKOZEPKZBPKZQZW
      SXAXBXLOOZWSEBUHUCXOBEUBBEUIUPXMWSXPOXNXMXCXAXBWSXKXMXCXAXBWSXKOZXMXCQZXA
      QXBQFUJKZXQXRXAXBXSDEPFUKULXMXAXBXSXQOXCXMXAQZXBQZXSXQXEWTRUQNZJZYAXSQZXQ
      YDXMXBYBUEKZWTYBRSNZJZYCXMXAXBXSUMXTXBXSUNYAXSYEXAXSYEOXMXBXAXSWTUJKZYEXS
      YHUOZFWTFWTUJURUSZWTUTVAVBTYAXSYGXAXSYGOXMXBXAXSYHYGYJYHYFWTYHWTRWTVPRVCK
      YHVDVEVFVGVAVBTXMXBYEUDYGYCDEPYBVHTVIYCXGWSYDXJYCXGXDYBLMNZJZWSYDXJOOYCXF
      YKXDXEYBLMVJVKYDWSYLXJYAXSWSYLXJOZOZYAXSYHYNXAYIXMXBYJVBXTXBYHYNOZXMXBYOO
      XAXMYHXBYNXMYHXBYNOZXMYHQEVQKZYPYHXMYQYHYQXMWTUEKWTVLEPVMVNVRYHYQYPOXMWSY
      QXBYHYMWSYQXBYHYMOZWSYQXBUDXHYBXDSNZJZYRABCDEGVOYHYLYTXJYHYLYTXJOYHYLQYTX
      HYBYKSNZJZXJYLYTUUBUOYHYLYSUUAXHXDYKYBSVSVKVTYHUUBXJOYLYHUUBXJYHUUAXIXHWT
      WAVKWBWCWDWHWEUPWFWGVTWIWHWJWCTWDTWKVAWLWMWHWNWIWOWPWCWMWQWR $.
  $}

  ${
    $d e k l v $.  $d e f i n v w y $.  $d E e n v $.  $d V e n v $.
    $( The size of a finite complete simple graph with ` n ` vertices
       ( ` n e. NN0 ` ) is ` ( n _C 2 ) ` (" ` n ` choose 2") resp.
       ` ( ( ( n - 1 ) * n ) / 2 ) ` .  (Contributed by Alexander van der
       Vekens, 11-Jan-2018.) $)
    cusgrasize $p |- ( ( V ComplUSGrph E /\ V e. Fin )
                       -> ( # ` E ) = ( ( # ` V ) _C 2 ) ) $=
      ( ve vv vn vi vf vw vl vk chash cfv c2 cbc co wceq ccusgra fveq2 oveq1d
      cv vy wnel cdm crab cres csn cdif cvv cusg wbr cpr wcel wral wa df-cusgra
      crn relopabi vex resex eqeqan12rd cusgrares adantl adantr cusgrasizeindb0
      weq eqid eqeq12d c1 caddc cn0 wel w3a cusgrasize2inds imp31 brfi1ind ) AK
      LZBKLZMNOZPCTZKLZDTZKLZMNOZPZVSETZFTVSLUBFVSUCUDZUEZKLZWAWEUFUGZKLZMNOZPZ
      GTZKLZHTZKLZMNOZPUAHDUHCGEAWGQBWAVSUIUJITJTZUKVSUPULIWAWRUFUGUMJWAUMUNDCQ
      DCJIUOUQVSWFCURUSVSAPWABPZVTVPWCVRVSAKRWSWBVQMNWABKRSUTCGVEDHVEZVTWNWCWQV
      SWMKRWTWBWPMNWAWOKRSUTFVSWGWEWAWGVFZVAWOWIPZWMWGPZUNZWNWHWQWKXCWNWHPXBWMW
      GKRVBXDWPWJMNXBWPWJPXCWOWIKRVCSVGVSWAVDUATVHVIOZVJULWAVSQUJWBXEPEDVKVLWLW
      DFVSWGWEWAXEXAVMVNVO $.
  $}

  ${
    $d N a x $.  $d V a x $.  $d E x $.
    cusgrafi.p $e |- P = { x e. ~P V |
                           E. a e. V ( a =/= N /\ x = { a , N } ) } $.
    $( Lemma 1 for ~ cusgrafi .  (Contributed by Alexander van der Vekens,
       13-Jan-2018.) $)
    cusgrafilem1 $p |- ( ( V ComplUSGrph E /\ N e. V ) -> P C_ ran E ) $=
      ( ccusgra wcel wss cv chash cfv c2 wceq crab wa adantl cvv syl wbr crn wi
      cpw cusgrarn wne cpr wrex fveq2 simprrl elex jctil ad2antrr hashprg mpbid
      wb vex eqtrd rexlimdvaa ss2rabdv a1i id sseq12d syl5ibr imp ) ECHUAZDEIZB
      CUBZJZVFVHAKZLMZNOZAEUDZPZOZVGVIUCACEUEVGVIVOFKZDUFZVJVPDUGZOZQZFEUHZAVMP
      ZVNJVGWAVLAVMVGVJVMIZQZVTVLFEWDVPEIZVTQZQZVKVRLMZNWFVKWHOZWDVTWIWEVSWIVQV
      JVRLUIRRRWGVQWHNOZWDWEVQVSUJWGVPSIZDSIZQZVQWJUPVGWMWCWFVGWLWKDEUKFUQULUMV
      PDSUNTUOURUSUTVOBWBVHVNBWBOVOGVAVOVBVCVDTVE $.

    $d F e $.  $d N e v $.  $d P e v x $.  $d V e v $.  $d W a e v x $.
    cusgrafi.f $e |- F = ( x e. ( V \ { N } ) |-> { x , N } ) $.
    $( Lemma 2 for ~ cusgrafi .  (Contributed by Alexander van der Vekens,
       13-Jan-2018.) $)
    cusgrafilem2 $p |- ( ( V e. W /\ N e. V )
                         -> F : ( V \ { N } ) -1-1-onto-> P ) $=
      ( ve vv wcel wa cv cpr wral wceq wrex adantl weq csn cdif cpw wne eldifsn
      wreu wf1o simpl sylbi simpr prelpwi syl2anr biimpi eqidd jca neeq1 eqeq2d
      preq1 anbi12d rspcedv sylc eqeq1 anbi2d rexbidv elrab2 sylanbrc ralrimiva
      wb eleq1d cbvralv sylibr anim2i ad2antlr vex preqr1 eqcomd syl6bi adantll
      wi equcoms biimpcd impbid reximdv2 expimpd reu6 3imtr4g ralrimiv f1ompt
      ex ) EFLZDELZMZANZDOZBLZAEDUAUBZPZJNZWNQZAWPUFZJBPWPBCUGWLKNZDOZBLZKWPPWQ
      WLXCKWPWLXAWPLZMZXBEUCZLZGNZDUDZXBXHDOZQZMZGERZXCXDXAELZWKXGWLXDXNXADUDZM
      ZXNXAEDUEZXNXOUHZUIWJWKUJXADEUKULXEXPXOXBXBQZMZXMXDXPWLXDXPXQUMSXEXOXSXDX
      OWLXDXPXOXQXNXOUJUISXEXBUNUOXPXLXTGXAEXRGKTZXLXTVHXPYAXIXOXKXSXHXADUPYAXJ
      XBXBXHXADURUQUSSUTVAXIWMXJQZMZGERZXMAXBXFBWMXBQZYCXLGEYEYBXKXIWMXBXJVBVCV
      DHVEVFVGWOXCAKWPAKTWNXBBWMXADURVIVJVKWLWTJBWLWRXFLZXIWRXJQZMZGERZMWSAGTZV
      HZAWPPZGWPRZWRBLWTWLYFYIYMWLYFMZYHYLGEWPYNXHELZYHMZXHWPLZYLMYNYPMZYQYLYRY
      OXIMZYQYPYSYNYHXIYOXIYGUHVLSXHEDUEVKYRYKAWPYRWMWPLZMWSYJYPYTWSYJVSYNYPYTM
      WSXJWNQZYJYHWSUUAVHZYOYTYGUUBXIWRXJWNVBSVMUUAXHWMXHWMDGVNAVNVOVPVQVRYPYJW
      SVSZYNYTYHUUCYOYGUUCXIYJYGWSYJXJWNWRUUAGAXHWMDURVTUQWASSVMWBVGUOWIWCWDYDY
      IAWRXFBAJTZYCYHGEUUDYBYGXIWMWRXJVBVCVDHVEWSAGWPWEWFWGAJWPBWNCIWHVF $.

    $d V f $.  $d F f $.  $d N f $.  $d P f $.
    $( Lemma 2 for ~ cusgrafi .  (Contributed by Alexander van der Vekens,
       13-Jan-2018.) $)
    cusgrafilem3 $p |- ( ( V e. W /\ N e. V )
                         -> ( -. V e. Fin -> -. P e. Fin ) ) $=
      ( vf wcel wa cfn wn csn cdif cv wf1o cvv syl diffi snfi difinf sylancl ex
      simpr con4d impbid2 cen wbr wb wex cpr cmpt difexg mptexg syl5eqel adantr
      cusgrafilem2 f1oeq1 spcegv sylc bren sylibr enfi bitrd notbid biimpd ) EF
      KZDEKZLZEMKZNZBMKZNVKVLVNVKVLEDOZPZMKZVNVKVLVQEVOUAVKVLVQVKVMVQNZVKVMLVMV
      OMKVRVKVMUFDUBEVOUCUDUEUGUHVKVPBUIUJZVQVNUKVKVPBJQZRZJULZVSVKCSKZVPBCRZWB
      VIWCVJVICAVPAQDUMZUNZSIVIVPSKWFSKEVOFUOAVPWESUPTUQURABCDEFGHIUSWAWDJCSVPB
      VTCUTVAVBVPBJVCVDVPBVETVFVGVH $.
  $}

  ${
    $d V e n p v $.  $d E e p n $.
    $( If the size of a complete simple graph is finite, then also its order is
       finite.  (Contributed by Alexander van der Vekens, 13-Jan-2018.) $)
    cusgrafi $p |- ( ( V ComplUSGrph E /\ E e. Fin ) -> V e. Fin ) $=
      ( vn vv ve vp wbr cfn wcel wn cv wi wa cvv syl cpr wceq wrex imp com12 ex
      ccusgra nfielex cusg cusisusgra usgrav wne cpw crab csn cdif eqeq1 anbi2d
      cmpt weq rexbidv cbvrabv eqid cusgrafilem3 com13 cusgrafilem1 ssfi expcom
      crn con3d rnfi con3i syl6 com23 adantl sylcom adantr mpcom exlimddv con4d
      wss ) BAUBGZAHIZBHIZVQVSVRVSJZVQVRJZVTCKZBIZVQWALZCCBUCVQVTWCMZWABNIZANIZ
      MZVQWEWALZVQBAUDGWHABUEABUFOWFVQWILWGWFWEVQWAWFWEDKZWBUGZEKZWJWBPZQZMZDBR
      ZEBUHZUIZHIZJZWDWEWFWTVTWCWFWTLWFWCVTWTWFWCVTWTLFWRFBWBUJUKFKZWBPUNZWBBND
      WPWKXAWMQZMZDBREFWQEFUOZWOXDDBXEWNXCWKWLXAWMULUMUPUQZXBURUSUAUTSTWCWTWDLV
      TWCVQWTWAVQWCWTWALZVQWCMWRAVDZVPZXGFWRAWBBDXFVAXIWTXHHIZJWAXIXJWSXJXIWSXH
      WRVBVCVEVRXJAVFVGVHOVCVIVJVKVIVLVMTVNTVOS $.
  $}

  ${
    $d E a b e $.  $d F a b e f k n $.  $d V a b e k n $.
    $( An undirected simple graph is a subgraph of a complete simple graph.
       (Contributed by Alexander van der Vekens, 11-Jan-2018.) $)
    usgrasscusgra $p |- ( ( V USGrph E /\ V ComplUSGrph F )
                          -> A. e e. ran E E. f e. ran F e = f ) $=
      ( va vb vn vk cusg wbr wa weq wrex cv wcel cpr wi wral syl crn usgrarnedg
      ccusgra wne wceq csn cdif iscusgra0 simplrr sneq difeq2d eleq1d raleqbidv
      preq2 rspcv simplrl wn elsn nne bitr4i biimpi a1i con2d imp adantrr preq1
      eldifd eleq1 eqcoms equid equequ2 rspcev mpan2 ad2antll 3syld exp31 com24
      wb syl6bi com13 rexlimivv impancom ralrimiv ) ECJKZEDUCKZLABMZBDUAZNZACUA
      ZWDAOZWIPZWEWHWDWKLFOZGOZUDZWJWLWMQZUEZLZGENFENWEWHRZCEWJFGUBWQWRFGEEWEWQ
      WLEPZWMEPZLZWHWEEDJKZHOZIOZQZWGPZHEXDUFZUGZSZIESZLWQXAWHRRZIHDEUHXBXJXKXB
      XAWQXJWHXBXAWQXJWHRXBXALZWQLZXJXCWMQZWGPZHEWMUFZUGZSZWOWGPZWHXMWTXJXRRXBW
      SWTWQUIXIXRIWMEIGMZXFXOHXHXQXTXGXPEXDWMUJUKXTXEXNWGXDWMXCUNULUMUOTXMWLXQP
      ZXRXSRXLWNYAWPXLWNLWLEXPXBWSWTWNUPXLWNWLXPPZUQXLYBWNYBWNUQZRXLYBYCYBFGMYC
      FWMURWLWMUSUTVAVBVCVDVGVEXOXSHWLXQHFMXNWOWGXCWLWMVFULUOTWPXSWHRXLWNWPXSWJ
      WGPZWHXSYDVRWOWJWOWJWGVHVIYDAAMZWHAVJWFYEBWJWGBAAVKVLVMVSVNVOVPVQVDTVTWAT
      WBWC $.
  $}

  ${
    $d E a b e $.  $d F a b e x y $.  $d V a b e x y $.
    $( Lemma 1 for ~ sizeusglecusg .  (Contributed by Alexander van der Vekens,
       12-Jan-2018.) $)
    sizeusglecusglem1 $p |- ( ( V USGrph E /\ V ComplUSGrph F )
                              -> ( _I |` ran E ) : ran E -1-1-> ran F ) $=
      ( ve va vb vy vx cusg wbr wa crn wf1 cv wcel cpr wceq wrex wi adantl cres
      ccusgra cid wss wf1o f1oi f1of1 ax-mp wne usgrarnedg csn cdif wral simprr
      iscusgra0 weq eldifsn simplbi2 adantr impcom wb sneq eleq2d mpbird preq12
      difeq2d expcom eleq1d rspcdv rspcimdv ex com13 com12 eleq1 imbi2d syl5ibr
      imp rexlimdvva syl syl5com impancom ssrdv f1ss sylancr ) CAIJZCBUBJZKZALZ
      WHUCWHUAZMZWHBLZUDWHWKWIMWHWHWIUEWJWHUFWHWHWIUGUHWGDWHWKWEDNZWHOZWFWLWKOZ
      WEWMKENZFNZUIZWLWOWPPZQZKZFCRECRZWFWNACWLEFUJWFCBIJZGNZHNZPZWKOZGCXDUKZUL
      ZUMZHCUMZKZXAWNSHGBCUOXKWTWNEFCCWTXKWOCOZWPCOZKZKZWNWSWQXOWNSZWQXPWSXOWRW
      KOZSXOWQXQXKXNWQXQSZXJXNXRSXBWQXNXJXQWQXNXJXQSWQXNKZXIXQHWPCWQXLXMUNXSHFU
      PZKZXFXQGWOXHYAWOXHOZWOCWPUKZULZOZXSYEXTXNWQYEXLWQYESXMYEXLWQWOCWPUQURUSU
      TUSXTYBYEVAXSXTXHYDWOXTXGYCCXDWPVBVFVCTVDYAGEUPZKXEWRWKYAYFXEWRQZXTYFYGSX
      SYFXTYGXCXDWOWPVEVGTVQVHVIVJVKVLTVQVMWSWNXQXOWLWRWKVNVOVPUTVMVRVSVTWAWBWH
      WHWKWIWCWD $.
  $}

  $( Lemma 2 for ~ sizeusglecusg .  (Contributed by Alexander van der Vekens,
     13-Jan-2018.) $)
  sizeusglecusglem2 $p |- ( ( V USGrph E /\ V ComplUSGrph F /\ F e. Fin )
                            -> E e. Fin ) $=
    ( cusg wbr ccusgra cfn wcel w3a cusgrafi 3adant1 wi usgrafis 3ad2ant1 mpd
    ex ) CADEZCBFEZBGHZICGHZAGHZRSTQBCJKQRTUALSQTUAACMPNO $.

  ${
    $d E f $.  $d F f $.
    $( The size of an undirected simple graph with ` n ` vertices is at most
       the size of a complete simple graph with ` n ` vertices ( ` n ` may be
       infinite).  (Contributed by Alexander van der Vekens, 13-Jan-2018.) $)
    sizeusglecusg $p |- ( ( V USGrph E /\ V ComplUSGrph F )
                          -> ( # ` E ) <_ ( # ` F ) ) $=
      ( vf cfn wcel wbr wa chash cfv cle wi wf1 cvv adantr adantl wceq syl cpnf
      com13 cusg ccusgra crn wex cid cres usgrav simprd rnexg sizeusglecusglem1
      cv resiexg 3syl f1eq1 spcegv sylc cdom cdm simpl usgraf1 anim12i hashf1rn
      dmexg com12 cusisusgra breq12d wb rnfi hashdom brdomg 3bitrd mpbird ex wn
      jca hashinf cxr hashxrcl pnfge breq2 syl5ibr imp sizeusglecusglem2 3expia
      w3a pm2.24d pnfxr xrleid mp1i breq12 expcom com23 4cases ) AEFZBEFZCAUAGZ
      CBUBGZHZAIJZBIJZKGZLZWNWOHZWRXAXCWRHZXAAUCZBUCZDUKZMZDUDZWRXIXCWRUEXEUFZN
      FZXEXFXJMZXIWPXKWQWPANFZXENFZXKWPCNFZXMACUGZUHANUIXENULUMOABCUJXHXLDXJNXE
      XFXGXJUNUOUPPXDXAXEIJZXFIJZKGZXEXFUQGZXIXDWSXQWTXRKXDWNAURZXEAMZHYANFZXNH
      ZWSXQQZXCWNWRYBWNWOUSWPYBWQACUTOVAXCYDWRWNYDWOWNYCXNAEVCAEUIVOOOYBYDYELWN
      YDYBYEYAXEANNVBVDPUPXDBURZNFZXFNFZHZYFXFBMZWTXRQXCYIWRWOYIWNWOYGYHBEVCBEU
      IZVOPOWRYJXCWQYJWPWQCBUAGZYJBCVEZBCUTRPPYFXFBNNVBUPVFXDXEEFZYHHZXSXTVGXCY
      OWRWNYNWOYHAVHYKVAOXEXFNVIRXCXTXIVGZWRXCYHYPWOYHWNYKPXEXFNDVJROVKVLVMWNWO
      VNZXBWRYQWNXAWQYQWNXALZLZWPWQYLXOBNFZHZYSYMBCUGZYTYSXOYTYQYRYTYQHZWTSQZYR
      BNVPZWNXAUUDWSSKGZWNWSVQFUUFAEVRWSVSRWTSWSKVTWARVMPUMPTWBWNVNZWOXBWRWOUUG
      XAWPWQWOUUGXALWPWQWOWEWNXAABCWCWFWDTWBWRUUGYQHZXAWPWQUUHXALZWPXOXMHWQUUIL
      ZXPXMUUJXOWQXMUUIWQYLUUAXMUUILZYMUUBYTUUKXOUUHXMYTXAUUGYQXMYTXALZLUUGXMYQ
      UULXMUUGYQUULLZXMUUGHWSSQZUUMANVPYTYQUUNXAYTYQUUNXALZUUCUUDUUOUUEUUNUUDXA
      UUNUUDHZXASSKGZSVQFUUQUUPWGSWHWIWSSWTSKWJVLWKRVMTRWKWLWBTPUMVDPRWBVDWM $.
  $}

  ${
    $d E f $.  $d V f $.
    $( The maximum size of an undirected simple graph with ` n ` vertices
       ( ` n e. NN0 ` ) is ` ( ( ( n - 1 ) * n ) / 2 ) ` .  (Contributed by
       Alexander van der Vekens, 13-Jan-2018.) $)
    usgramaxsize $p |- ( ( V USGrph E /\ V e. Fin )
                         -> ( # ` E ) <_ ( ( # ` V ) _C 2 ) ) $=
      ( vf cusg wbr cfn wcel wa cv ccusgra chash cfv c2 cbc co cusgraexg adantl
      cle wex wi sizeusglecusg adantlr wceq cusgrasize breq2 biimpd syl imp mpd
      expcom exlimddv ) BADEZBFGZHZBCIZJEZAKLZBKLMNOZREZCUMUPCSULCBFPQUNUPHUQUO
      KLZREZUSULUPVAUMAUOBUAUBUNUPVAUSTZUMUPVBTULUPUMVBUPUMHUTURUCZVBUOBUDVCVAU
      SUTURUQRUEUFUGUJQUHUIUK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Universal vertices
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d V e k n v $.  $d E e k n v $.  $d X e n v $.  $d Y e n v $.
    $( The set of all universal vertices.  (Contributed by Alexander van der
       Vekens, 12-Oct-2017.) $)
    isuvtx $p |- ( ( V e. X /\ E e. Y ) -> ( V UnivVertex E )
            = { n e. V | A. k e. ( V \ { n } ) { k , n } e. ran E } ) $=
      ( vv ve wcel wa cuvtx cvv cv crn cdif wral crab wceq adantr adantl cpr co
      csn cmpt2 df-uvtx elex rabexg mp1i simprl wb difeq1 rneq eleq2d raleqbidv
      vex rabeqbidv ovmpt2dv2 mpi ) DEIZCFIZJZKGHLLAMBMZUAZHMZNZIZAGMZVBUCZOZPZ
      BVGQZUDRDCKUBVCCNZIZADVHOZPZBDQZRGHABUEVAGHDCLLVKVPKLUSDLIUTDEUFSVACLIZVG
      DRZUTVQUSCFUFTSVGLIVKLIVAVRVDCRZJZJZGUOVJBVGLUGUHWAVJVOBVGDVAVRVSUIVTVJVO
      UJVAVTVFVMAVIVNVRVIVNRVSVGDVHUKSVSVFVMUJVRVSVEVLVCVDCULUMTUNTUPUQUR $.

    $d N k n $.
    $( An element of the set of all universal vertices.  (Contributed by
       Alexander van der Vekens, 12-Oct-2017.) $)
    uvtxel $p |- ( ( V e. X /\ E e. Y ) -> ( N e. ( V UnivVertex E )
            <-> ( N e. V /\ A. k e. ( V \ { N } ) { k , N } e. ran E ) ) ) $=
      ( vn wcel wa cuvtx co cv cpr crn csn cdif wral crab isuvtx eleq2d difeq2d
      wceq sneq preq2 eleq1d raleqbidv elrab syl6bb ) DEHBFHIZCDBJKZHCALZGLZMZB
      NZHZADULOZPZQZGDRZHCDHUKCMZUNHZADCOZPZQZIUIUJUSCAGBDEFSTURVDGCDULCUBZUOVA
      AUQVCVEUPVBDULCUCUAVEUMUTUNULCUKUDUEUFUGUH $.

    $( A universal vertex is a vertex.  (Contributed by Alexander van der
       Vekens, 12-Oct-2017.) $)
    uvtxisvtx $p |- ( N e. ( V UnivVertex E ) -> N e. V ) $=
      ( vk vn vv ve cvv wcel wa cuvtx co wi cv cpr crn csn cdif wral crab wn c0
      isuvtx eleq2d elrabi syl6bi wceq df-uvtx mpt2ndm0 pm2.21d syl5com pm2.61i
      n0i ) CHIAHIJZBCAKLZIZBCIZMUNUPBDNENZOZAPIDCURQZRSZECTZIUQUNUOVBBDEACHHUC
      UDVAEBCUEUFUNUAUOUBUGZUPUQFGUSGNPIDFNZUTRSEVDTKCAHHFGDEUHUIUPVCUQUOBUMUJU
      KUL $.

    $( There is no universal vertex if there is no vertex.  (Contributed by
       Alexander van der Vekens, 12-Oct-2017.) $)
    uvtx0 $p |- ( (/) UnivVertex E ) = (/) $=
      ( vk vn vv ve c0 cvv wcel wa cuvtx wceq cpr crn csn cdif wral crab isuvtx
      co cv wn ral0 a1i rabeq0 sylibr eqtrd df-uvtx mpt2ndm0 pm2.61i ) FGHAGHIZ
      FAJSZFKUJUKBTCTZLZAMHBFULNZOPZCFQZFBCAFGGRUJUOUAZCFPZUPFKURUJUQCUBUCUOCFU
      DUEUFDEUMETMHBDTZUNOPCUSQJFAGGDEBCUGUHUI $.

    $d V k x $.
    $( If a graph/class has no edges, it has universal vertices if and only if
       it has exactly one vertex.  This theorem could have been stated
       ` ( ( V UnivVertex (/) ) =/= (/) <-> ( # `` V ) = 1 ) ` , but a lot of
       auxiliary theorems would have been needed.  (Contributed by Alexander
       van der Vekens, 12-Oct-2017.) $)
    uvtx01vtx $p |- ( ( V UnivVertex (/) ) =/= (/) <-> E. x V = { x } ) $=
      ( vk vv ve vn cvv wcel c0 cuvtx wne cv csn wceq wex wb cpr a1i wa wn cdif
      co crn wral crab wrex 0ex isuvtx mpan2 neeq1d rabn0 df-rex wss rn0 eleq2i
      noel mtbir ralf0 anbi2d ssdif0 bicomd wo sssn anbi2i pm2.21d simpr jaodan
      n0i imp vex snid eleq2 mpbiri olc jca impbii bitri 3bitrd exbidv intnanrd
      syl5bb df-uvtx mpt2ndm0 syl notnot sylib df-ne sylnibr snex eleq1 exlimiv
      id con3i 2falsed pm2.61i ) BGHZBIJUBZIKZBALZMZNZAOZPWPWRCLZWSQZIUCZHZCBWT
      UAZUDZABUEZIKZXHABUFZXBWPWQXIIWPIGHZWQXINUGCAIBGGUHUIUJXJXKPWPXHABUKRXKWS
      BHZXHSZAOWPXBXHABULWPXNXAAWPXNXMXGINZSXMBWTUMZSZXAWPXHXOXMXHXOPWPXFCXGXFX
      DIHXDUPXEIXDUNUOUQURRUSWPXOXPXMWPXPXOXPXOPWPBWTUTRVAUSXQXAPWPXQXMBINZXAVB
      ZSZXAXPXSXMBWSVCVDXTXAXMXRXAXAXMXRXAXMXRXABWSVHVEVIXMXAVFVGXAXMXSXAXMWSWT
      HWSAVJVKBWTWSVLVMXAXRVNVOVPVQRVRVSWAVRWPTZWRXBYAWQINZTZWRYAYBYCTYAWPXLSTY
      BYAWPXLYAWLVTDEXCFLZQELUCHCDLZYDMUAUDFYEUEJBIGGDECFWBWCWDYBWEWFWQIWGWHXBW
      PXAWPAXAWPWTGHWSWIBWTGWJVMWKWMWNWO $.
  $}

  ${
    $d n v x E $.  $d n v x N $.  $d n v x V $.
    $( A universal vertex has all other vertices as neighbors.  (Contributed by
       Alexander van der Vekens, 14-Oct-2017.) $)
    uvtxnbgra $p |- ( ( V USGrph E /\ N e. ( V UnivVertex E ) )
                      -> ( <. V , E >. Neighbors N ) = ( V \ { N } ) ) $=
      ( vv vn vx co wcel wceq cv cpr wa cvv syl adantr weq eleq1d wi ex imp wbr
      cusg cuvtx cop cnbgra csn cdif crn wral wb usgrav uvtxel crab preq2 elrab
      nbusgra wne usgraedgrn simpr wn elsni eqcomd necon3ai eldifd com13 syl5bi
      com12 eldifi adantl preq1 rspcva eleq1i biimpi a1d impcom sylanbrc impbid
      prcom com14 eqrdv eqtrd sylbid ) CAUBUAZBCAUCGHZCAUDBUEGZCBUFZUGZIZWCWDBC
      HZDJZBKZAUHZHZDWGUIZLZWHWCCMHAMHLWDWOUJACUKDABCMMULNWCWOWHWCWOLZWEBEJZKZW
      LHZECUMZWGWCWEWTIWOEABCUPOWPFWTWGWPFJZWTHZXAWGHZXBXACHZBXAKZWLHZLZWPXCWSX
      FEXACEFPWRXEWLWQXABUNQUOZWCXGXCRWOXGWCXCXDXFWCXCRWCXFXDXCWCXFXDXCRZWCXFLB
      XAUQZXIABXACURXJXDXCXJXDLXACWFXJXDUSXJXAWFHZUTXDXKBXAXKXABXABVAVBVCOVDSNS
      VETVGOVFWPXCXBWPXCLXDXFXBXCXDWPXACWFVHVIWPXCXFWOWCXCXFRZWIWNWCXLRXCWNWCWI
      XFXCWNWCWIXFRZRZXCWNLXABKZWLHZXNWMXPDXAWGDFPWKXOWLWJXABVJQVKXPXMWCXPXFWIX
      PXFXOXEWLXABVRVLVMVNVNNSVSTVOTXHVPSVQVTWASWBT $.
  $}

  $( A universal vertex has ` n - 1 ` neighbors in a graph with ` n `
     vertices.  (Contributed by Alexander van der Vekens, 14-Oct-2017.) $)
  uvtxnm1nbgra $p |- ( ( V USGrph E /\ V e. Fin ) -> ( N e. ( V UnivVertex E )
              -> ( # ` ( <. V , E >. Neighbors N ) ) = ( ( # ` V ) - 1 ) ) ) $=
    ( cusg wbr cfn wcel wa cuvtx co cop cnbgra chash cfv c1 cmin wceq uvtxnbgra
    csn cdif adantlr fveq2d wss simpr uvtxisvtx hashssdif syl2an hashsng adantl
    snssd oveq2d 3eqtrd ex ) CADEZCFGZHZBCAIJZGZCAKBLJZMNZCMNZOPJZQUPURHZUTCBSZ
    TZMNZVAVDMNZPJZVBVCUSVEMUNURUSVEQUOABCRUAUBUPUOVDCUCVFVHQURUNUOUDURBCABCUEU
    JCVDUFUGVCVGOVAPURVGOQUPBUQUHUIUKULUM $.

  ${
    $d V v $.  $d E v $.  $d N v $.
    $( A universal vertex is neighbor of all other vertices.  (Contributed by
       Alexander van der Vekens, 14-Oct-2017.) $)
    uvtxnbgravtx $p |- ( ( V USGrph E /\ N e. ( V UnivVertex E ) )
            -> A. v e. ( V \ { N } ) N e. ( <. V , E >. Neighbors v ) ) $=
      ( cusg wbr cuvtx co wcel wa cop cv cnbgra csn cdif wi uvtxnbgra wb adantr
      wceq eleq2 biimpar nbgrasym ad2antrl mpbird ex mpancom ralrimiv ) DBEFZCD
      BGHIZJZCDBKZALZMHIZADCNOZULCMHZUOTZUKUMUOIZUNPBCDQUQUKJZURUNUSURJUNUMUPIZ
      USUTURUQUTURRUKUPUOUMUASUBUSUNUTRZURUIVAUQUJBUMCDUCUDSUEUFUGUH $.
  $}

  ${
    $d V e k n v x $.  $d E e k n v x $.
    $( An undirected simple graph is complete if and only if each vertex is a
       universal vertex.  (Contributed by Alexander van der Vekens,
       14-Oct-2017.)  (Revised by Alexander van der Vekens, 18-Jan-2018.) $)
    cusgrauvtxb $p |- ( V USGrph E
                         -> ( V ComplUSGrph E <-> ( V UnivVertex E ) = V ) ) $=
      ( vn vx vk cvv wcel wa cusg wbr ccusgra wceq wb cpr csn cdif wral wal a1i
      cv cuvtx co usgrav crn iscusgra baibd crab dfcleq isuvtx eqeq1d adantr wi
      df-ral bicom pm4.71 weq sneq difeq2d preq2 eleq1d raleqbidv elrab 3bitr4d
      bibi1d albidv syl5bb 3bitr4rd bitrd mpancom ) BFGAFGHZBAIJZBAKJZBAUAUBZBL
      ZMABUCVJVKHZVLCTZDTZNZAUDZGZCBVQOZPZQZDBQZVNVJVLVKWDDCABFFUEUFVOVPETZNZVS
      GZCBWEOZPZQZEBUGZBLZVQWKGZVQBGZMZDRZVNWDWLWPMVODWKBUHSVJVNWLMVKVJVMWKBCEA
      BFFUIUJUKWDWNWCULZDRVOWPWCDBUMVOWQWODVOWNWNWCHZMZWRWNMZWQWOWSWTMVOWNWRUNS
      WQWSMVOWNWCUOSVOWMWRWNWMWRMVOWJWCEVQBEDUPZWGVTCWIWBXAWHWABWEVQUQURXAWFVRV
      SWEVQVPUSUTVAVBSVDVCVEVFVGVHVI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Walks, paths and cycles
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Walks $.
  $c Trails $.
  $c Paths $.
  $c SPaths $.
  $c WalkOn $.
  $c TrailOn $.
  $c PathOn $.
  $c SPathOn $.
  $c Circuits $.
  $c Cycles $.

  $( Extend class notation with Walks (of a graph). $)
  cwalk $a class Walks $.

  $( Extend class notation with Trails (of a graph). $)
  ctrail $a class Trails $.

  $( Extend class notation with Paths (of a graph). $)
  cpath $a class Paths $.

  $( Extend class notation with Simple Paths (of a graph). $)
  cspath $a class SPaths $.

  $( Extend class notation with Walks between two vertices (within a graph). $)
  cwlkon $a class WalkOn $.

  $( Extend class notation with Trails between two vertices (within a
     graph). $)
  ctrlon $a class TrailOn $.

  $( Extend class notation with Paths between two vertices (within a graph). $)
  cpthon $a class PathOn $.

  $( Extend class notation with simple paths between two vertices (within a
     graph). $)
  cspthon $a class SPathOn $.

  $( Extend class notation with Circuits (of a graph). $)
  ccrct $a class Circuits $.

  $( Extend class notation with Cycles (of a graph). $)
  ccycl $a class Cycles $.

  ${
    $d e v x k n g f p $.
    $( Define the set of all Walks (in an undirected graph).

       According to Wikipedia ("Path (graph theory)",
       ~ https://en.wikipedia.org/wiki/Path_(graph_theory) , 3-Oct-2017):  "A
       walk of length k in a graph is an alternating sequence of vertices and
       edges, v0 , e0 , v1 , e1 , v2 , ... , v(k-1) , e(k-1) , v(k) which
       begins and ends with vertices.  If the graph is undirected, then the
       endpoints of e(i) are v(i) and v(i+1)."

       According to Bollobas:  " A walk W in a graph is an alternating sequence
       of vertices and edges x0 , e1 , x1 , e2 , ... , e(l) , x(l) where e(i) =
       x(i-1)x(i), 0<i<=l.", see Definition of [Bollobas] p. 4.

       Therefore, a walk can be represented by two mappings f from { 1 , ... ,
       n } and p from { 0 , ... , n }, where f enumerates the (indices of the)
       edges, and p enumerates the vertices.  So the walk is represented by the
       following sequence: p(0) e(f(1)) p(1) e(f(2)) ... p(n-1) e(f(n)) p(n).
       (Contributed by Alexander van der Vekens and Mario Carneiro,
       4-Oct-2017.) $)
    df-wlk $a |- Walks = ( v e. _V , e e. _V |-> { <. f , p >. |
       ( f e. Word dom e /\ p : ( 0 ... ( # ` f ) ) --> v
         /\ A. k e. ( 0 ..^ ( # ` f ) ) ( e ` ( f ` k ) )
                                   = { ( p ` k ) , ( p ` ( k + 1 ) ) } ) } ) $.

    $( Define the set of all Trails (in an undirected graph).

       According to Wikipedia ("Path (graph theory)",
       ~ https://en.wikipedia.org/wiki/Path_(graph_theory) , 3-Oct-2017):  "A
       trail is a walk in which all edges are distinct.

       According to Bollobas:  "... walk is called a trail if all its edges are
       distinct.", see Definition of [Bollobas] p. 5.

       Therefore, a trail can be represented by an injective mapping f from {
       1 , ... , n } and a mapping p from { 0 , ... , n }, where f enumerates
       the (indices of the) different edges, and p enumerates the vertices.  So
       the trail is also represented by the following sequence: p(0) e(f(1))
       p(1) e(f(2)) ... p(n-1) e(f(n)) p(n) (Contributed by Alexander van der
       Vekens and Mario Carneiro, 4-Oct-2017.) $)
    df-trail $a |- Trails = ( v e. _V , e e. _V |-> { <. f , p >. |
       ( f ( v Walks e ) p /\ Fun `' f ) } ) $.

    $( Define the set of all Paths (in an undirected graph).

       According to Wikipedia ("Path (graph theory)",
       ~ https://en.wikipedia.org/wiki/Path_(graph_theory) , 3-Oct-2017):  "A
       path is a trail in which all vertices (except possibly the first and
       last) are distinct. ... use the term simple path to refer to a path
       which contains no repeated vertices."

       According to Bollobas:  "... a path is a walk with distinct vertices.",
       see Notation of [Bollobas] p. 5.  (A walk with distinct vertices is
       actually a simple path, see ~ wlkdvspth ).

       Therefore, a path can be represented by an injective mapping f from {
       1 , ... , n } and a mapping p from { 0 , ... , n }, which is injective
       restricted to the set { 1 , ... , n }, where f enumerates the (indices
       of the) different edges, and p enumerates the vertices.  So the path is
       also represented by the following sequence: p(0) e(f(1)) p(1)
       e(f(2)) ... p(n-1) e(f(n)) p(n) (Contributed by Alexander van der Vekens
       and Mario Carneiro, 4-Oct-2017.) $)
    df-pth $a |- Paths = ( v e. _V , e e. _V |-> { <. f , p >. |
       ( f ( v Trails e ) p /\ Fun `' ( p |` ( 1 ..^ ( # ` f ) ) ) /\
   ( ( p " { 0 , ( # ` f ) } ) i^i ( p " ( 1 ..^ ( # ` f ) ) ) ) = (/) ) } ) $.

    $( Define the set of all Simple Paths (in an undirected graph).

       According to Wikipedia ("Path (graph theory)",
       ~ https://en.wikipedia.org/wiki/Path_(graph_theory) , 3-Oct-2017):  "A
       path is a trail in which all vertices (except possibly the first and
       last) are distinct. ... use the term simple path to refer to a path
       which contains no repeated vertices."

       Therefore, a simple path can be represented by an injective mapping f
       from { 1 , ... , n } and an injective mapping p from { 0 , ... , n },
       where f enumerates the (indices of the) different edges, and p
       enumerates the vertices.  So the simple path is also represented by the
       following sequence: p(0) e(f(1)) p(1) e(f(2)) ... p(n-1) e(f(n)) p(n)
       (Contributed by Alexander van der Vekens, 20-Oct-2017.) $)
    df-spth $a |- SPaths = ( v e. _V , e e. _V |-> { <. f , p >. |
       ( f ( v Trails e ) p /\ Fun `' p ) } ) $.

    $( Define the set of all circuits (in an undirected graph).

       According to Wikipedia ("Cycle (graph theory)",
       ~ https://en.wikipedia.org/wiki/Cycle_(graph_theory) , 3-Oct-2017):  "A
       circuit can be a closed walk allowing repetitions of vertices but not
       edges;"; according to Wikipedia ("Glossary of graph theory terms",
       ~ https://en.wikipedia.org/wiki/Glossary_of_graph_theory_terms,
       3-Oct-2017):  "A circuit may refer to ... a trail (a closed tour without
       repeated edges), ...".

       Following Bollobas ("A trail whose endvertices coincide (a closed trail)
       is called a circuit.", see Definition of [Bollobas] p. 5.), a circuit is
       a closed trail without repeated edges.  So the circuit is also
       represented by the following sequence: p(0) e(f(1)) p(1) e(f(2)) ...
       p(n-1) e(f(n)) p(n)=p(0) (Contributed by Alexander van der Vekens,
       3-Oct-2017.) $)
    df-crct $a |- Circuits = ( v e. _V , e e. _V |-> { <. f , p >. |
       ( f ( v Trails e ) p /\ ( p ` 0 ) = ( p ` ( # ` f ) ) ) } ) $.

    $( Define the set of all (simple) cycles (in an undirected graph).

       According to Wikipedia ("Cycle (graph theory)",
       ~ https://en.wikipedia.org/wiki/Cycle_(graph_theory) , 3-Oct-2017):  "A
       simple cycle may be defined either as a closed walk with no repetitions
       of vertices and edges allowed, other than the repetition of the starting
       and ending vertex,"

       According to Bollobas:  "If a walk W = x0 x1 ... x(l) is such that l >=
       3, x0=x(l), and the vertices x(i), 0 < i < l, are distinct from each
       other and x0, then W is said to be a cycle.", see Definition of
       [Bollobas] p. 5.

       However, since a walk consisting of distinct vertices (except the first
       and the last vertex) is a path, a cycle can be defined as path whose
       first and last vertices coincide.  So a cycle is represented by the
       following sequence: p(0) e(f(1)) p(1) ... p(n-1) e(f(n)) p(n)=p(0).
       (Contributed by Alexander van der Vekens, 3-Oct-2017.) $)
    df-cycl $a |- Cycles = ( v e. _V , e e. _V |-> { <. f , p >. |
       ( f ( v Paths e ) p /\ ( p ` 0 ) = ( p ` ( # ` f ) ) ) } ) $.

    $d a b e f p v $.
    $( Define the collection of walks with particular endpoints (in an un-
       directed graph).  This corresponds to the "x0-x(l)-walks", see
       Definition in [Bollobas] p. 5.  (Contributed by Alexander van der Vekens
       and Mario Carneiro, 4-Oct-2017.) $)
    df-wlkon $a |- WalkOn = ( v e. _V , e e. _V |-> ( a e. v , b e. v |->
       { <. f , p >. | ( f ( v Walks e ) p /\ ( p ` 0 ) = a
                         /\ ( p ` ( # ` f ) ) = b ) } ) ) $.

    $( Define the collection of trails with particular endpoints (in an
       undirected graph).  (Contributed by Alexander van der Vekens and Mario
       Carneiro, 4-Oct-2017.) $)
    df-trlon $a |- TrailOn = ( v e. _V , e e. _V |-> ( a e. v , b e. v |->
       { <. f , p >. | ( f ( a ( v WalkOn e ) b ) p
                         /\ f ( v Trails e ) p ) } ) ) $.

    $( Define the collection of paths with particular endpoints (in an
       undirected graph).  (Contributed by Alexander van der Vekens and Mario
       Carneiro, 4-Oct-2017.) $)
    df-pthon $a |- PathOn = ( v e. _V , e e. _V |-> ( a e. v , b e. v |->
       { <. f , p >. | ( f ( a ( v WalkOn e ) b ) p
                         /\ f ( v Paths e ) p ) } ) ) $.

    $( Define the collection of simple paths with particular endpoints (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       1-Mar-2018.) $)
    df-spthon $a |- SPathOn = ( v e. _V , e e. _V |-> ( a e. v , b e. v |->
       { <. f , p >. | ( f ( a ( v WalkOn e ) b ) p
                         /\ f ( v SPaths e ) p ) } ) ) $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Walks and trails
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d E e f k p v $.  $d V e f p v $.
    $( The set of walks (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 19-Oct-2017.) $)
    wlks $p |- ( ( V e. X /\ E e. Y ) -> ( V Walks E ) = { <. f , p >. |
            ( f e. Word dom E /\ p : ( 0 ... ( # ` f ) ) --> V
              /\ A. k e. ( 0 ..^ ( # ` f ) ) ( E ` ( f ` k ) )
                          = { ( p ` k ) , ( p ` ( k + 1 ) ) } ) } ) $=
      ( vv ve wcel cvv cwalk co cv cdm cc0 cfv wceq copab wa cword chash cfz wf
      c1 caddc cpr cfzo wral w3a elex cmpt2 df-wlk a1i dmeq syl ad2antll eleq2d
      wrdeq wb feq3 adantr adantl fveq1 eqeq1d ralbidv 3anbi123d opabbidv simpl
      simpr 3anass opabbii dmexg wrdexg cab cfn fzfi mapex sylancr ss2abi ssexd
      wss opabex3d syl5eqel ovmpt2d syl2an ) DEJDKJZCKJZDCLMANZCOZUAZJZPWIUBQZU
      CMZDGNZUDZBNZWIQZCQZWQWOQWQUEUFMWOQUGZRZBPWMUHMZUIZUJZAGSZRCFJDEUKCFUKWGW
      HTZHIDCKKWIINZOZUAZJZWNHNZWOUDZWRXGQZWTRZBXBUIZUJZAGSZXELKLHIKKXQULRXFHIA
      BGUMUNXFXKDRZXGCRZTZTZXPXDAGYAXJWLXLWPXOXCYAXIWKWIXSXIWKRZXFXRXSXHWJRYBXG
      CUOXHWJUSUPUQURXTXLWPUTZXFXRYCXSXKDWNWOVAVBVCXSXOXCUTXFXRXSXNXABXBXSXMWSW
      TWRXGCVDVEVFUQVGVHWGWHVIZWGWHVJXFXEWLWPXCTZTZAGSKXDYFAGWLWPXCVKVLXFYEAGWK
      XFWJKJZWKKJWHYGWGCKVMVCWJKVNUPXFWLTZYEGVOZWPGVOZKYHWNVPJWGYJKJPWMVQXFWGWL
      YDVBWNDVPKGVRVSYIYJWBYHYEWPGWPXCVIVTUNWAWCWDWEWF $.
  $}

  ${
    $d E f k p $.  $d F f k p $.  $d P f k p $.  $d V f p $.
    $( Properties of a pair of functions to be a walk (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 20-Oct-2017.) $)
    iswlk $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
                  -> ( F ( V Walks E ) P <-> ( F e. Word dom E
                       /\ P : ( 0 ... ( # ` F ) ) --> V
                       /\ A. k e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` k ) )
                             = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) ) ) $=
      ( vf vp wcel wa co cv cc0 chash cfv cfz wceq cwalk wbr cop cword wf caddc
      cdm c1 cpr cfzo wral w3a copab df-br adantr eleq2d syl5bb wb simpl eleq1d
      wlks simpr fveq2 oveq2d feq12d fveq1 fveq2d eqeqan12d raleqbidv 3anbi123d
      preq12d opelopabga adantl bitrd ) EGLCHLMZDFLAILMZMZDAECUANZUBZDAUCZJOZCU
      GUDZLZPWAQRZSNZEKOZUEZBOZWARZCRZWHWFRZWHUHUFNZWFRZUIZTZBPWDUJNZUKZULZJKUM
      ZLZDWBLZPDQRZSNZEAUEZWHDRZCRZWHARZWLARZUIZTZBPXBUJNZUKZULZVSVTVRLVQWTDAVR
      UNVQVRWSVTVOVRWSTVPJBCEGHKVAUOUPUQVPWTXMURVOWRXMJKDAFIWADTZWFATZMZWCXAWGX
      DWQXLXPWADWBXNXOUSUTXPWEXCEWFAXNXOVBXNWEXCTXOXNWDXBPSWADQVCZVDUOVEXPWOXJB
      WPXKXPWDXBPUJXNWDXBTXOXQUOVDXNXOWJXFWNXIXNWIXECWHWADVFVGXOWKXGWMXHWHWFAVF
      WLWFAVFVKVHVIVJVLVMVN $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.  $d e f k p v $.
    $( The two mappings determining a walk (in an undirected graph).
       (Contributed by Alexander van der Vekens, 20-Oct-2017.) $)
    2mwlk $p |- ( F ( V Walks E ) P -> ( F e. Word dom E
                                   /\ P : ( 0 ... ( # ` F ) ) --> V ) ) $=
      ( vf ve vv vp vk cvv wcel wa cwalk co cdm cword cc0 chash cfv cv wf caddc
      wbr cfz c1 cpr wceq cfzo wral df-wlk brovmpt2ex iswlk 3simpa syl6bi mpcom
      w3a ) DJKBJKLCJKAJKLLZCADBMNUCZCBOPKZQCRSZUDNDAUAZLZETZFTZOPKQVCRSZUDNGTH
      TZUAITZVCSVDSVGVFSVGUEUBNZVFSUFUGIQVEUHNUIUPGFEHABCMDGFEIHUJUKUQURUSVAVGC
      SBSVGASVHASUFUGIQUTUHNUIZUPVBAIBCDJJJJULUSVAVIUMUNUO $.
  $}

  ${
    $d E f p $.  $d V f p $.
    wlkres.1 $e |- ( f ( V W E ) p -> f ( V Walks E ) p ) $.
    $( Restrictions of walks are sets.  (Contributed by Alexander van der
       Vekens, 1-Nov-2017.) $)
    wlkres $p |- ( ( V e. _V /\ E e. _V )
                   -> { <. f , p >. | ( f ( V W E ) p /\ ph ) } e. _V ) $=
      ( cv cdm cword wcel cc0 chash cfv co wa wbr cvv syl cfn wf wi cwalk 2mwlk
      cfz a1i dmexg adantl wrdexg fzfi simpll mapex sylancr opabex3d opabbrex
      cab ) ABHZCIZJZKZLUQMNZUEOZDFHZUAZPZBCDEFUQVCDCEOQZVEUBDRKZCRKZPZVFUQVCDC
      UCOQVEGVCCUQDUDSUFVIVDBFUSVIURRKZUSRKVHVJVGCRUGUHURRUISVIUTPVBTKVGVDFUPRK
      LVAUJVGVHUTUKVBDTRFULUMUNUO $.
  $}

  ${
    $d E a b e f p v $.  $d V a b e f p v $.  $d X f p $.  $d Y f p $.
    $d A a b f p $.  $d B a b f p $.
    $( The set of walks between two vertices (in an undirected graph).
       (Contributed by Alexander van der Vekens, 12-Dec-2017.) $)
    wlkon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V ) )
           -> ( A ( V WalkOn E ) B ) = { <. f , p >. |
         ( f ( V Walks E ) p /\ ( p ` 0 ) = A /\ ( p ` ( # ` f ) ) = B ) } ) $=
      ( va vb vv ve wcel wa co cv cwalk wceq copab cvv cwlkon wbr cc0 cfv chash
      w3a cmpt2 ad2antrr adantl adantr id ancli mpt2exga syl simpl oveq12 breqd
      elex 3anbi1d opabbidv mpt2eq123dv df-wlkon ovmpt2ga syl3anc simprr 3anass
      oveqd wb a1i wlkres syl2an eqeltrd eqeq2 3anbi23d eqid eqtrd ) EFMZDGMZNZ
      AEMZBEMZNZNZABEDUAOZOABIJEECPZHPZEDQOZUBZUCWFUDZIPZRZWEUEUDWFUDZJPZRZUFZC
      HSZUGZOZWHWIARZWLBRZUFZCHSZWCWDWQABWCETMZDTMZWQTMZWDWQRVQXCVRWBEFURZUHVSX
      DWBVRXDVQDGURZUIUJWCVQVQNZXEVQXHVRWBVQVQVQUKULUHIJEEWPFFUMUNKLEDTTIJKPZXI
      WEWFXILPZQOZUBZWKWNUFZCHSZUGWQUATXIERZXJDRZNZIJXIXIXNEEWPXOXPUOZXRXQXMWOC
      HXQXLWHWKWNXQXKWGWEWFXIEXJDQUPUQUSUTVAKLCHIJVBVCVDVGWCVTWAXBTMZWRXBRWBVTV
      SVTWAUOUIVSVTWAVEVSXSWBVSXBWHWSWTNZNZCHSZTVSXAYACHXAYAVHVSWHWSWTVFVIUTVQX
      CXDYBTMVRXFXGXTCDEQHWHUKVJVKVLUJIJABEEWPXBWQTWJARZWMBRZNZWOXACHYEWKWSWNWT
      WHYCWKWSVHYDWJAWIVMUJYDWNWTVHYCWMBWLVMUIVNUTWQVOVCVDVP $.
  $}

  ${
    $d E f p $.  $d V f p $.  $d X f p $.  $d Y f p $.  $d A f p $.
    $d B f p $.  $d F f p $.  $d P f p $.
    $( Properties of a pair of functions to be a walk between two given
       vertices (in an undirected graph).  (Contributed by Alexander van der
       Vekens, 2-Nov-2017.)  (Proof shortened by Alexander van der Vekens,
       16-Dec-2017.) $)
    iswlkon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z )
                      /\ ( A e. V /\ B e. V ) )
                  -> ( F ( A ( V WalkOn E ) B ) P <-> ( F ( V Walks E ) P
                       /\ ( P ` 0 ) = A /\ ( P ` ( # ` F ) ) = B ) ) ) $=
      ( vf vp wcel wa w3a co wbr cc0 cfv wceq cwlkon cv cwalk chash copab wlkon
      wb breqd 3adant2 breq12 fveq1 eqeq1d adantl simpr fveq2 fveq12d 3anbi123d
      adantr eqid brabga 3ad2ant2 bitrd ) FHMDIMNZEGMCJMNZAFMBFMNZOECABFDUAPPZQ
      ZECKUBZLUBZFDUCPZQZRVISZATZVHUDSZVISZBTZOZKLUEZQZECVJQZRCSZATZEUDSZCSZBTZ
      OZVCVEVGVSUGVDVCVENVFVRECABKDFHILUFUHUIVDVCVSWFUGVEVQWFKLECVRGJVHETZVICTZ
      NZVKVTVMWBVPWEVHEVICVJUJWHVMWBUGWGWHVLWAARVICUKULUMWIVOWDBWIVNWCVICWGWHUN
      WGVNWCTWHVHEUDUOURUPULUQVRUSUTVAVB $.
  $}

  ${
    $d E a b c e f p v $.  $d V a b c e f p v $.  $d A f p $.  $d B f p $.
    $( Properties of a walk between two vertices.  (Contributed by Alexander
       van der Vekens, 12-Dec-2017.) $)
    wlkonprop $p |- ( F ( A ( V WalkOn E ) B ) P -> ( ( ( V e. _V /\ E e. _V )
      /\ ( F e. _V /\ P e. _V ) /\ ( A e. V /\ B e. V ) )
      /\ ( F ( V Walks E ) P /\ ( P ` 0 ) = A /\ ( P ` ( # ` F ) ) = B ) ) ) $=
      ( vf vp vv ve va cvv wcel wa w3a co wbr cfv wceq cv vb cwlkon cwalk chash
      cc0 oveq12 breqd 3anbi1d wlkon bropopvvv iswlkon biimpd imdistani mpancom
      df-wlkon ) FLMDLMNELMCLMNAFMBFMNOZECABFDUBPPQZUPECFDUCPZQUECRASEUDRCRBSOZ
      NGTZHTZITZJTZUCPZQZUEVARZKTSZUTUDRVARZUATSZOUTVAURQZVGVIOVJVFASVHBSOIABCJ
      GDEUBFHKUAIJGHKUAUOVBFSVCDSNZVEVJVGVIVKVDURUTVAVBFVCDUCUFUGUHABGDFLLHUIUJ
      UPUQUSUPUQUSABCDEFLLLLUKULUMUN $.
  $}

  $( A walk between to vertices is a walk.  (Contributed by Alexander van der
     Vekens, 12-Dec-2017.) $)
  wlkoniswlk $p |- ( F ( A ( V WalkOn E ) B ) P -> F ( V Walks E ) P ) $=
    ( cwlkon co wbr cvv wcel wa w3a cwalk cc0 cfv wceq chash wlkonprop simpr1
    syl ) ECABFDGHHIFJKDJKLEJKCJKLAFKBFKLMZECFDNHIZOCPAQZERPCPBQZMLUCABCDEFSUBU
    CUDUETUA $.

  ${
    $d e f k p v $.
    $( Basic properties of a walk.  (Contributed by Alexander van der Vekens,
       31-Oct-2017.) $)
    wlkbprop $p |- ( F ( V Walks E ) P -> ( ( # ` F ) e. NN0
                     /\ ( V e. _V /\ E e. _V ) /\ ( F e. _V /\ P e. _V ) ) ) $=
      ( vf ve vv vp vk cvv wcel wa cwalk co chash cfv w3a cv cdm cc0 wbr cn0 wf
      cword cfz c1 caddc cpr wceq cfzo df-wlk brovmpt2ex 2mwlk lencl adantr syl
      wral adantl simpll simplr 3jca mpancom ) DJKBJKLZCJKAJKLZLZCADBMNUAZCOPZU
      BKZVCVDQERZFRZSUDKTVIOPZUENGRHRZUCIRZVIPVJPVMVLPVMUFUGNVLPUHUIITVKUJNUQQG
      FEHABCMDGFEIHUKULVEVFLVHVCVDVFVHVEVFCBSZUDKZTVGUENDAUCZLVHABCDUMVOVHVPVNC
      UNUOUPURVCVDVFUSVCVDVFUTVAVB $.
  $}

  $( A walk is a walk between its endpoints.  (Contributed by Alexander van der
     Vekens, 2-Nov-2017.) $)
  wlkonwlk $p |- ( F ( V Walks E ) P
                   -> F ( ( P ` 0 ) ( V WalkOn E ) ( P ` ( # ` F ) ) ) P ) $=
    ( co wbr cc0 cfv wceq id eqidd cvv wcel wa w3a cn0 cle 3jca syl adantr 0nn0
    cwalk chash cwlkon wb wlkbprop simp2d simp3d cdm cword wf 2mwlk simpr lencl
    cfz a1i nn0ge0 elfz2nn0 sylibr ffvelrnd nn0re jca iswlkon syl3anc mpbir3and
    leidd ) CADBUBEFZCAGAHZCUCHZAHZDBUDEEFZVGVHVHIZVJVJIZVGJVGVHKVGVJKVGDLMBLMN
    ZCLMALMNZVHDMZVJDMZNZVKVGVLVMOUEVGVIPMZVNVOABCDUFZUGVGVSVNVOVTUHVGCBUIZUJMZ
    GVIUOEZDAUKZNZVRABCDULWEVPVQWEWCDGAWBWDUMZWEGPMZVSGVIQFZOZGWCMWBWIWDWBVSWIW
    ACUNZVSWGVSWHWGVSUAUPVSJZVIUQRSTGVIURUSUTWEWCDVIAWFWEVSVSVIVIQFZOZVIWCMWBWM
    WDWBVSWMWJVSVSVSWLWKWKVSVIVIVAVFRSTVIVIURUSUTVBSVHVJABCDLLLLVCVDVE $.

  ${
    $d E e f k p v $.  $d V e f p v $.
    $( The set of trails (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 20-Oct-2017.) $)
    trls $p |- ( ( V e. X /\ E e. Y ) -> ( V Trails E ) = { <. f , p >. |
          ( ( f e. Word dom E /\ Fun `' f ) /\ p : ( 0 ... ( # ` f ) ) --> V
            /\ A. k e. ( 0 ..^ ( # ` f ) ) ( E ` ( f ` k ) )
                  = { ( p ` k ) , ( p ` ( k + 1 ) ) } ) } ) $=
      ( vv ve wcel cvv ctrail co cv wa cc0 cfv wceq copab cwalk cword ccnv wfun
      cdm chash cfz wf c1 caddc cpr cfzo wral w3a wbr cmpt2 df-trail a1i oveq12
      wb breqd anbi1d adantl vex iswlk mpanr12 adantr 3anass ancom anbi1i anass
      elex bicomi 3bitri syl6bbr bitrd opabbidv simpl simpr bitri opabbii dmexg
      wrdexg syl cab cfn fzfi mapex sylancr wss ssexd opabex3d syl5eqel ovmpt2d
      ss2abi syl2an ) DEJDKJZCKJZDCLMANZCUDZUAZJZWRUBUCZOZPWRUEQZUFMZDGNZUGZBNZ
      WRQCQXHXFQXHUHUIMXFQUJRBPXDUKMULZUMZAGSZRCFJDEVKCFVKWPWQOZHIDCKKWRXFHNZIN
      ZTMZUNZXBOZAGSZXKLKLHIKKXRUORXLHIAGUPUQXLXMDRXNCROZOZXQXJAGXTXQWRXFDCTMZU
      NZXBOZXJXSXQYCUSXLXSXPYBXBXSXOYAWRXFXMDXNCTURUTVAVBXTYCXAXGXIUMZXBOZXJXTY
      BYDXBXLYBYDUSZXSXLWRKJXFKJYFAVCGVCXFBCWRDKKKKVDVEVFVAXJXCXGXIOZOZXBXAOZYG
      OZYEXCXGXIVGZXCYIYGXAXBVHVIYJXBXAYGOZOYLXBOYEXBXAYGVJXBYLVHYLYDXBYDYLXAXG
      XIVGVLVIVMVMVNVOVPWPWQVQZWPWQVRXLXKXAXBYGOZOZAGSKXJYOAGXJYHYOYKXAXBYGVJVS
      VTXLYNAGWTXLWSKJZWTKJWQYPWPCKWAVBWSKWBWCXLXAOZYNGWDZXGGWDZKYQXEWEJWPYSKJP
      XDWFXLWPXAYMVFXEDWEKGWGWHYRYSWIYQYNXGGYGXGXBXGXIVQVBWNUQWJWKWLWMWO $.
  $}

  ${
    $d E f k p $.  $d F f k p $.  $d P f k p $.  $d V f p $.
    $( Properties of a pair of functions to be a trail (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 20-Oct-2017.) $)
    istrl $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
                  -> ( F ( V Trails E ) P <-> ( ( F e. Word dom E
           /\ Fun `' F ) /\ P : ( 0 ... ( # ` F ) ) --> V
           /\ A. k e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` k ) )
                  = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) ) ) $=
      ( vf vp wcel wa co cv cc0 chash cfv wceq adantr ctrail wbr cop cword ccnv
      cdm wfun cfz wf c1 caddc cpr cfzo wral w3a copab df-br trls eleq2d syl5bb
      eleq1 cnveq funeqd anbi12d simpr fveq2 oveq2d feq12d fveq1 fveq2d preq12d
      wb eqeqan12d raleqbidv 3anbi123d opelopabga adantl bitrd ) EGLCHLMZDFLAIL
      MZMZDAECUANZUBZDAUCZJOZCUFUDZLZWEUEZUGZMZPWEQRZUHNZEKOZUIZBOZWERZCRZWOWMR
      ZWOUJUKNZWMRZULZSZBPWKUMNZUNZUOZJKUPZLZDWFLZDUEZUGZMZPDQRZUHNZEAUIZWODRZC
      RZWOARZWSARZULZSZBPXLUMNZUNZUOZWCWDWBLWAXGDAWBUQWAWBXFWDVSWBXFSVTJBCEGHKU
      RTUSUTVTXGYCVLVSXEYCJKDAFIWEDSZWMASZMZWJXKWNXNXDYBYDWJXKVLYEYDWGXHWIXJWED
      WFVAYDWHXIWEDVBVCVDTYFWLXMEWMAYDYEVEYDWLXMSYEYDWKXLPUHWEDQVFZVGTVHYFXBXTB
      XCYAYDXCYASYEYDWKXLPUMYGVGTYDYEWQXPXAXSYDWPXOCWOWEDVIVJYEWRXQWTXRWOWMAVIW
      SWMAVIVKVMVNVOVPVQVR $.
  $}

  ${
    $d E k l $.  $d F k l $.  $d P k $.
    $( Properties of a pair of functions to be a trail (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 20-Oct-2017.) $)
    istrl2 $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
        -> ( F ( V Trails E ) P <-> ( F : ( 0 ..^ ( # ` F ) ) -1-1-> dom E
                      /\ P : ( 0 ... ( # ` F ) ) --> V
                      /\ A. k e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` k ) )
                            = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) ) ) $=
      ( wcel wa ctrail co wbr cdm cword cc0 cfv wf w3a ccnv wfun chash cv caddc
      cfz c1 cpr wceq cfzo wral wf1 istrl wrdf iswrdi impbii a1i anbi1d syl6bbr
      wb df-f1 3anbi1d bitrd ) EGJCHJKDFJAIJKKZDAECLMNDCOZPJZDUAUBZKZQDUCRZUFME
      ASZBUDZDRCRVKARVKUGUEMARUHUIBQVIUJMZUKZTVLVEDULZVJVMTABCDEFGHIUMVDVHVNVJV
      MVDVHVLVEDSZVGKVNVDVFVOVGVFVOUTVDVFVOVEDUNVEVIDUOUPUQURVLVEDVAUSVBVC $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.  $d e f p v $.
    $( A trail is a walk (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 20-Oct-2017.) $)
    trliswlk $p |- ( F ( V Trails E ) P -> F ( V Walks E ) P ) $=
      ( vf vp vv ve vk cvv wcel wa ctrail co wbr cwalk cv ccnv wfun cfv cdm cc0
      df-trail brovmpt2ex cword chash cfz wf caddc cpr wceq cfzo wral w3a istrl
      c1 simpl 3anim1i iswlk syl5ibr sylbid mpcom ) DJKBJKLCJKAJKLLZCADBMNOZCAD
      BPNOZEQZFQGQHQPNOVFRSLGHEFABCMDGHEFUCUDVCVDCBUAUEKZCRSZLZUBCUFTZUGNDAUHZI
      QZCTBTVLATVLUPUINATUJUKIUBVJULNUMZUNZVEAIBCDJJJJUOVNVEVCVGVKVMUNVIVGVKVMV
      GVHUQURAIBCDJJJJUSUTVAVB $.
  $}

  ${
    $d E a b e f p v $.  $d F f p $.  $d P f p $.  $d V a b e f p v $.
    $d X f p $.  $d Y f p $.  $d A a b f p $.  $d B a b f p $.
    $( The set of trails between two vertices (in an undirected graph).
       (Contributed by Alexander van der Vekens, 4-Nov-2017.) $)
    trlon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V ) )
           -> ( A ( V TrailOn E ) B ) = { <. f , p >. |
              ( f ( A ( V WalkOn E ) B ) p /\ f ( V Trails E ) p ) } ) $=
      ( va vb vv wcel wa co cv wbr ctrail copab cvv wceq ve ctrlon cwlkon cmpt2
      elex ad2antrr adantl adantr ancli mpt2exga syl simpl oveq12 oveqd anbi12d
      id breqd opabbidv mpt2eq123dv df-trlon ovmpt2ga syl3anc wb ancom trliswlk
      simprr a1i wlkres syl2an eqeltrd anbi1d eqid eqtrd ) EFLZDGLZMZAELZBELZMZ
      MZABEDUBNZNABIJEECOZHOZIOZJOZEDUCNZNZPZWBWCEDQNZPZMZCHRZUDZNZWBWCABWFNZPZ
      WJMZCHRZVTWAWMABVTESLZDSLZWMSLZWAWMTVNWSVOVSEFUEZUFVPWTVSVOWTVNDGUEZUGUHV
      TVNVNMZXAVNXDVOVSVNVNVNUPUIUFIJEEWLFFUJUKKUAEDSSIJKOZXEWBWCWDWEXEUAOZUCNZ
      NZPZWBWCXEXFQNZPZMZCHRZUDWMUBSXEETZXFDTZMZIJXEXEXMEEWLXNXOULZXQXPXLWKCHXP
      XIWHXKWJXPXHWGWBWCXPXGWFWDWEXEEXFDUCUMUNUQXPXJWIWBWCXEEXFDQUMUQUOURUSKUAC
      HIJUTVAVBUNVTVQVRWRSLZWNWRTVSVQVPVQVRULUGVPVQVRVFVPXRVSVPWRWJWPMZCHRZSVPW
      QXSCHWQXSVCVPWPWJVDVGURVNWSWTXTSLVOXBXCWPCDEQHWCDWBEVEVHVIVJUHIJABEEWLWRW
      MSWDATWEBTMZWKWQCHYAWHWPWJYAWGWOWBWCWDAWEBWFUMUQVKURWMVLVAVBVM $.
  $}

  ${
    $d E f p $.  $d F f p $.  $d P f p $.  $d V f p $.  $d X f p $.
    $d Y f p $.  $d A f p $.  $d B f p $.
    $( Properties of a pair of functions to be a trail between two given
       vertices(in an undirected graph).  (Contributed by Alexander van der
       Vekens, 3-Nov-2017.)  (Proof shortened by Alexander van der Vekens,
       16-Dec-2017.) $)
    istrlon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z )
                    /\ ( A e. V /\ B e. V ) ) -> ( F ( A ( V TrailOn E ) B ) P
              <-> ( F ( A ( V WalkOn E ) B ) P /\ F ( V Trails E ) P ) ) ) $=
      ( vf vp wcel wa co wbr cv wb wceq breq12 ctrlon cwlkon ctrail copab trlon
      w3a breqd 3adant2 anbi12d eqid brabga 3ad2ant2 bitrd ) FHMDIMNZEGMCJMNZAF
      MBFMNZUFECABFDUAOOZPZECKQZLQZABFDUBOOZPZUSUTFDUCOZPZNZKLUDZPZECVAPZECVCPZ
      NZUNUPURVGRUOUNUPNUQVFECABKDFHILUEUGUHUOUNVGVJRUPVEVJKLECVFGJUSESUTCSNVBV
      HVDVIUSEUTCVATUSEUTCVCTUIVFUJUKULUM $.
  $}

  ${
    $d E a b c e f m n p v z $.  $d F f m n p z $.  $d P f m n p z $.
    $d V a b c e f m n p v z $.  $d e f k p v $.  $d A f p $.  $d B f p $.
    $( Properties of a trail between two vertices.  (Contributed by Alexander
       van der Vekens, 5-Nov-2017.)  (Proof shortened by Alexander van der
       Vekens, 16-Dec-2017.) $)
    trlonprop $p |- ( F ( A ( V TrailOn E ) B ) P -> ( ( ( V e. _V /\ E e. _V )
                 /\ ( F e. _V /\ P e. _V ) /\ ( A e. V /\ B e. V ) )
                 /\ ( F ( A ( V WalkOn E ) B ) P /\ F ( V Trails E ) P ) ) ) $=
      ( vf vp va vb vv ve cvv wcel wa co wbr cwlkon ctrail cv w3a df-trlon wceq
      ctrlon oveq12 oveqd breqd anbi12d trlon bropopvvv istrlon biimpd mpancom
      imdistani ) FMNDMNOEMNCMNOAFNBFNOUAZECABFDUDPPQZUOECABFDRPZPZQECFDSPZQOZO
      GTZHTZITZJTZKTZLTZRPZPZQZVAVBVEVFSPZQZOVAVBVCVDUQPZQZVAVBUSQZOVAVBURQVNOK
      ABCLGDEUDFHIJKLGHIJUBVEFUCVFDUCOZVIVMVKVNVOVHVLVAVBVOVGUQVCVDVEFVFDRUEUFU
      GVOVJUSVAVBVEFVFDSUEUGUHABGDFMMHUIUJUOUPUTUOUPUTABCDEFMMMMUKULUNUM $.
  $}

  $( A trail between to vertices is a trail.  (Contributed by Alexander van der
     Vekens, 12-Dec-2017.) $)
  trlonistrl $p |- ( F ( A ( V TrailOn E ) B ) P -> F ( V Trails E ) P ) $=
    ( ctrlon co wbr cvv wcel wa w3a cwlkon ctrail trlonprop simprr syl ) ECABFD
    GHHIFJKDJKLEJKCJKLAFKBFKLMZECABFDNHHIZECFDOHIZLLUAABCDEFPSTUAQR $.

  $( A trail between two vertices is a walk between these vertices.
     (Contributed by Alexander van der Vekens, 5-Nov-2017.) $)
  trlonwlkon $p |- ( F ( A ( V TrailOn E ) B ) P
                     -> F ( A ( V WalkOn E ) B ) P ) $=
    ( ctrlon co wbr cvv wcel wa w3a cwlkon ctrail trlonprop simprl syl ) ECABFD
    GHHIFJKDJKLEJKCJKLAFKBFKLMZECABFDNHHIZECFDOHIZLLTABCDEFPSTUAQR $.

  ${
    $d E k $.  $d P k $.
    $( A pair of an empty set (of edges) and a second set (of vertices) is a
       walk if and only if the second set contains exactly one vertex (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    0wlk $p |- ( ( ( V e. X /\ E e. Y ) /\ P e. Z )
                 -> ( (/) ( V Walks E ) P <-> P : ( 0 ... 0 ) --> V ) ) $=
      ( vk wcel wa c0 co cc0 cfv cfz wf cfzo wral cvv hash0 oveq2i cwalk wbr cv
      cdm cword chash c1 caddc cpr wceq w3a wb 0ex iswlk mpanr1 ral0 fzo0 eqtri
      raleqi mpbir biantru eqcomi feq2i biantrur bitri df-3an 3bitr4ri syl6bb
      wrd0 ) CDHBEHIZAFHZIJACBUAKUBZJBUDZUEHZLJUFMZNKZCAOZGUCZJMBMVRAMVRUGUHKAM
      UIUJZGLVOPKZQZUKZLLNKZCAOZVJJRHVKVLWBULUMAGBJCRDEFUNUOVNVQIZWEWAIWDWBWAWE
      WAVSGJQVSGUPVSGVTJVTLLPKJVOLLPSTLUQURUSUTVAWDVQWEWCVPCALVOLNVOLSVBTVCVNVQ
      VMVIVDVEVNVQWAVFVGVH $.

    $( A pair of an empty set (of edges) and a second set (of vertices) is a
       trail if and only if the second set contains exactly one vertex (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    0trl $p |- ( ( ( V e. X /\ E e. Y ) /\ P e. Z )
                 -> ( (/) ( V Trails E ) P <-> P : ( 0 ... 0 ) --> V ) ) $=
      ( vk wcel wa c0 co wfun cc0 cfv cfz wf cfzo wral cvv hash0 ctrail wbr cdm
      cword ccnv chash cv c1 caddc cpr wceq w3a wb 0ex istrl mpanr1 ral0 oveq2i
      fzo0 eqtri raleqi mpbir biantru eqcomi feq2i wrd0 fun0 cnv0 funeqi pm3.2i
      biantrur bitri df-3an 3bitr4ri syl6bb ) CDHBEHIZAFHZIJACBUAKUBZJBUCZUDHZJ
      UEZLZIZMJUFNZOKZCAPZGUGZJNBNWGANWGUHUIKANUJUKZGMWDQKZRZULZMMOKZCAPZVPJSHV
      QVRWKUMUNAGBJCSDEFUOUPWCWFIZWNWJIWMWKWJWNWJWHGJRWHGUQWHGWIJWIMMQKJWDMMQTU
      RMUSUTVAVBVCWMWFWNWLWECAMWDMOWDMTVDURVEWCWFVTWBVSVFWBJLVGWAJVHVIVBVJVKVLW
      CWFWJVMVNVO $.
  $}

  $( A walk of length 0 from a vertex to itself.  (Contributed by Alexander van
     der Vekens, 2-Dec-2017.) $)
  0wlkon $p |- ( ( ( V e. X /\ E e. Y ) /\ N e. V )
                 -> ( ( P : ( 0 ... 0 ) --> V /\ ( P ` 0 ) = N )
                      -> (/) ( N ( V WalkOn E ) N ) P ) ) $=
    ( wcel wa cc0 co cfv wceq c0 wbr simpl adantl wb adantr cfn id cfz wf cwalk
    cwlkon chash fzfid simplll fpmg syl3anc 0wlk syl2anc mpbird simprr wi hash0
    cpm eqcomd fveq2d eqeq1d biimpd ax-mp cvv w3a 0ex ancri syl121anc mpbir3and
    a1i iswlkon ex ) DEGZBFGZHZCDGZHZIIUAJZDAUBZIAKZCLZHZMACCDBUDJJNZVOVTHZWAMA
    DBUCJNZVSMUEKZAKZCLZWBWCVQVTVQVOVQVSOPZWBVMADVPUPJZGZWCVQQVOVMVTVMVNORZWBVP
    SGVKVQWIWBIIUFVKVLVNVTUGWGVPDASEUHUIZABDEFWHUJUKULVOVQVSUMVTWFVOVSWFVQWDILZ
    VSWFUNUOWLVSWFWLVRWECWLIWDAWLWDIWLTUQURUSUTVAPPWBVMMVBGZWIVNVNHZWAWCVSWFVCQ
    WJWMWBVDVHWKVOWNVTVNWNVMVNVNVNTVEPRCCABMDVBEFWHVIVFVGVJ $.

  $( A trail of length 0 from a vertex to itself.  (Contributed by Alexander
     van der Vekens, 2-Dec-2017.) $)
  0trlon $p |- ( ( ( V e. X /\ E e. Y ) /\ N e. V )
                 -> ( ( P : ( 0 ... 0 ) --> V /\ ( P ` 0 ) = N )
                      -> (/) ( N ( V TrailOn E ) N ) P ) ) $=
    ( wcel wa cc0 co c0 wbr simpl adantl wb adantr cfn syl3anc mpbird jca fzfid
    cfz wf cfv wceq ctrlon cwlkon ctrail 0wlkon imp cpm simplll syl2anc cvv 0ex
    fpmg 0trl jctil id istrlon ex ) DEGZBFGZHZCDGZHZIIUBJZDAUCZIAUDCUEZHZKACCDB
    UFJJLZVFVJHZVKKACCDBUGJJLZKADBUHJLZHZVLVMVNVFVJVMABCDEFUIUJVLVNVHVJVHVFVHVI
    MNZVLVDADVGUKJZGZVNVHOVFVDVJVDVEMPZVLVGQGVBVHVRVLIIUAVBVCVEVJULVPVGDAQEUPRZ
    ABDEFVQUQUMSTVLVDKUNGZVRHVEVEHZVKVOOVSVLVRWAVTUOURVFWBVJVEWBVDVEVEVEVEUSZWC
    TNPCCABKDUNEFVQUTRSVA $.

  $( Lemma 5 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
     31-Jan-2018.) $)
  2trllemF $p |- ( ( ( E ` I ) = { X , Y } /\ Y e. V ) -> I e. dom E ) $=
    ( cfv cpr wceq wcel wa cdm prid2g eleq2 syl5ibr imp elfvdm syl ) BAFZDEGZHZ
    ECIZJERIZBAKITUAUBUAUBTESIDECLRSEMNOEBAPQ $.

  ${
    2trlX.i $e |- ( I e. U /\ J e. W ) $.
    2trlX.f $e |- F = { <. 0 , I >. , <. 1 , J >. } $.
    $( Lemma 1 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
       4-Dec-2017.)  (Revised by Alexander van der Vekens, 31-Jan-2018.) $)
    2trllemA $p |- ( # ` F ) = 2 $=
      ( cc0 cop c1 cpr wceq chash cfv c2 fveq2 wcel cvv ax-mp opex ax-1ne0 c0ex
      wne wn nesymi wa elex adantr opth1 necon3bi wb hashprg mp2an mpbi syl6eq
      ) BHCIZJDIZKZLZBMNZOLGUSUTURMNZOBURMPUPUQUCZVAOLZHJLZUDVBJHUAUEVDUPUQHCJD
      UBCAQZDEQZUFCRQZFVEVGVFCAUGUHSUIUJSUPRQUQRQVBVCUKHCTJDTUPUQRULUMUNUOS $.

    $( Lemma 2 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
       4-Dec-2017.)  (Revised by Alexander van der Vekens, 31-Jan-2018.) $)
    2trllemB $p |- ( 0 ..^ ( # ` F ) ) = { 0 , 1 } $=
      ( chash cfv c2 wceq cc0 cfzo co c1 cpr 2trllemA oveq2 fzo0to2pr syl6eq
      ax-mp ) BHIZJKZLUBMNZLOPZKABCDEFGQUCUDLJMNUEUBJLMRSTUA $.

    $( Lemma 3 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
       31-Jan-2018.) $)
    2trllemH $p |- ( ( ( V e. X /\ E e. Y /\ B e. V )
                       /\ ( ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } ) )
                     -> F : ( 0 ..^ ( # ` F ) ) --> dom E ) $=
      ( wcel cpr wceq wa cc0 c1 w3a cfv chash cfzo cdm cop wss cvv wne c0ex 1ex
      co wf pm3.2i ax-1ne0 necomi 3pm3.2i fprg 2trllemB a1i feq2d mp1i 2trllemF
      mpbird wi adantlr prcom eqeq2i biimpi adantl sylan jca expcom 3ad2ant3 wb
      imp prssg ax-mp sylib fss syl2anc feq1i sylibr ) IKOZELOZBIOZUAZGEUBABPQZ
      HEUBZBCPZQZRZRZSFUCUBUDULZEUEZSGUFTHUFPZUMZWNWOFUMWMWNGHPZWPUMZWRWOUGZWQS
      UHOZTUHOZRZGDOHJORZSTUIZUAZWSWMXCXDXEXAXBUJUKUNMTSUOUPUQXFWSSTPZWRWPUMSTG
      HUHUHDJURXFWNXGWRWPWNXGQXFDFGHJMNUSUTVAVDVBWMGWOOZHWOOZRZWTWGWLXJWFWDWLXJ
      VEWEWLWFXJWLWFRXHXIWHWFXHWKEGIABVCVFWLWICBPZQZWFXIWKXLWHWKXLWJXKWIBCVGVHV
      IVJEHICBVCVKVLVMVNVPXDXJWTVOMGHWODJVQVRVSWNWRWOWPVTWAWNWOFWPNWBWC $.

    $( Lemma 4 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
       31-Jan-2018.) $)
    2trllemE $p |- ( ( ( V e. X /\ E e. Y /\ B e. V ) /\ I =/= J /\
                       ( ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } ) )
                     -> F : ( 0 ..^ ( # ` F ) ) -1-1-> dom E ) $=
      ( wcel cpr wceq wa cc0 c1 w3a wne cfv chash cfzo co cdm cop wf1 wf1o c0ex
      cvv simpli pm3.2i simpri simp2 ax-1ne0 necomi jctil f1oprg mpsyl wi f1of1
      1ex wss 2trllemB eqcomi f1eq2 ax-mp biimpi adantr 2trllemF adantlr eqeq2i
      wb prcom adantl sylan jca expcom 3ad2ant3 imp 3adant2 prssg sylib syl2anc
      f1ss ex syl mpcom f1eq1 sylibr ) IKOZELOZBIOZUAZGHUBZGEUCABPQZHEUCZBCPZQZ
      RZUAZSFUDUCUEUFZEUGZSGUHTHUHPZUIZXDXEFUIZSTPZGHPZXFUJZXCXGSULOZGDOZRZTULO
      ZHJOZRZRXCSTUBZWQRXKXNXQXLXMUKXMXPMUMUNXOXPVDXMXPMUOUNUNXCWQXRWPWQXBUPTSU
      QURUSSGTHULDULJUTVAXKXIXJXFUIZXCXGVBXIXJXFVCXSXCXGXSXCRZXDXJXFUIZXJXEVEZX
      GXSYAXCXSYAXIXDQXSYAVOXDXIDFGHJMNVFVGXIXDXJXFVHVIVJVKXTGXEOZHXEOZRZYBXCYE
      XSWPXBYEWQWPXBYEWOWMXBYEVBWNXBWOYEXBWORYCYDWRWOYCXAEGIABVLVMXBWSCBPZQZWOY
      DXAYGWRXAYGWTYFWSBCVPVNVJVQEHICBVLVRVSVTWAWBWCVQXMXPRYEYBVOMGHXEDJWDVIWEX
      DXJXEXFWGWFWHWIWJFXFQXHXGVONXDXEFXFWKVIWL $.
  $}

  ${
    2trlX.p $e |- P = { <. 0 , A >. , <. 1 , B >. , <. 2 , C >. } $.
    $( Lemma for ~ constr2wlk .  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    2wlklemA $p |- ( A e. V -> ( P ` 0 ) = A ) $=
      ( wcel cc0 cfv cop c1 c2 ctp fveq1i cvv wne wa wceq a1i necomi id ax-1ne0
      c0ex 2ne0 pm3.2i fvtp1g syl21anc syl5eq ) AEGZHDIHHAJKBJLCJMZIZAHDUJFNUIH
      OGZUIHKPZHLPZQZUKARULUIUCSUIUAUOUIUMUNKHUBTLHUDTUESHKLABCOEUFUGUH $.

    $( Lemma for ~ constr2wlk .  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    2wlklemB $p |- ( B e. V -> ( P ` 1 ) = B ) $=
      ( wcel c1 cfv cc0 cop c2 ctp fveq1i cvv wne wa wceq 1ex a1i necomi pm3.2i
      id ax-1ne0 1ne2 fvtp2g syl21anc syl5eq ) BEGZHDIHJAKHBKLCKMZIZBHDUJFNUIHO
      GZUIJHPZHLPZQZUKBRULUISTUIUCUOUIUMUNHJUDUAUEUBTJHLABCOEUFUGUH $.

    $( Lemma for ~ constr2wlk .  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    2wlklemC $p |- ( C e. V -> ( P ` 2 ) = C ) $=
      ( wcel c2 cfv cc0 cop c1 ctp fveq1i cz wne wa wceq 2z a1i necomi syl21anc
      id 2ne0 1ne2 pm3.2i fvtp3g syl5eq ) CEGZHDIHJAKLBKHCKMZIZCHDUJFNUIHOGZUIJ
      HPZLHPZQZUKCRULUISTUIUCUOUIUMUNHJUDUAUEUFTJLHABCOEUGUBUH $.

    $( Lemma 4 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
       5-Dec-2017.)  (Revised by Alexander van der Vekens, 31-Jan-2018.) $)
    2trllemD $p |- ( ( A e. V /\ B e. V /\ C e. V ) -> P Fn { 0 , 1 , 2 } ) $=
      ( cc0 cz wcel c1 c2 w3a wne ctp wfn 0z 1z 3pm3.2i necomi cop ax-1ne0 2ne0
      2z 1ne2 fntpg fneq1i sylibr mp3an13 ) GHIZJHIZKHIZLZAEIBEICEILZGJMZGKMZJK
      MZLZDGJKNZOZUIUJUKPQUCRUNUOUPJGUASKGUBSUDRULUMUQLGATJBTKCTNZUROUSABCHEEEH
      HGJKUEURDUTFUFUGUH $.

    $( Lemma 7 for ~ constr2trl .  (Contributed by Alexander van der Vekens,
       1-Feb-2018.) $)
    2trllemG $p |- ( ( A e. V /\ B e. V /\ C e. V )
                     -> P : ( 0 ... 2 ) --> V ) $=
      ( wcel w3a cc0 c1 c2 ctp wf wss cfz cz wne 3pm3.2i necomi cop co 0z 1z 2z
      ax-1ne0 2ne0 1ne2 ftpg feq1i sylibr mp3an13 tpssi wa fss wceq fz0tp feq2d
      a1i mpbird syl2anc ) AEGBEGCEGHZIJKLZABCLZDMZVCENZIKOUAZEDMZIPGZJPGZKPGZH
      ZVAIJQZIKQZJKQZHZVDVHVIVJUBUCUDRVLVMVNJIUESKIUFSUGRVKVAVOHVBVCIATJBTKCTLZ
      MVDABCPEEEPPIJKUHVBVCDVPFUIUJUKABCEULVDVEUMZVGVBEDMVBVCEDUNVQVFVBEDVFVBUO
      VQUPURUQUSUT $.

  $}

  ${
    wlkntrl.v $e |- V = { x , y } $.
    wlkntrl.e $e |- E = { <. 0 , { x , y } >. } $.
    wlkntrl.f $e |- F = { <. 0 , 0 >. , <. 1 , 0 >. } $.
    wlkntrl.p $e |- P = { <. 0 , x >. , <. 1 , y >. , <. 2 , x >. } $.
    $( Lemma 1 for ~ wlkntrl :  F is a word over ` { 0 } ` , the domain of E.
       (Contributed by Alexander van der Vekens, 22-Oct-2017.)  (Proof
       shortened by Alexander van der Vekens, 16-Dec-2017.) $)
    wlkntrllem1 $p |- F e. Word dom E $=
      ( cc0 csn cword wf c1 cpr cop c0ex ax-mp eqcomi cdm cfzo wcel wne ax-1ne0
      c2 co necomi 1ex fpr feq1i fzo0to2pr dfsn2 feq23i bitri mpbi iswrdi dmeqi
      wceq cv zfpair2 dmsnop eqtri wrdeq eleqtrri ) EKLZMZDUAZMZKUFUBUGZVFENZEV
      GUCKOPZKKPZKKQOKQPZNZVKKOUDVOOKUEUHKOKKRUIRRUJSVOVLVMENVKVLVMVNEEVNITUKVL
      VMVJVFEVJVLULTVFVMKUMTUNUOUPVFUFEUQSVHVFUSVIVGUSVHKAUTBUTPZQLZUAVFDVQHURK
      VPABVAVBVCVHVFVDSVE $.

    $d E k $.  $d F k $.  $d P k $.
    $( Lemma 2 for ~ wlkntrl :  The values of E after F are edges between two
       vertices enumerated by P. (Contributed by Alexander van der Vekens,
       22-Oct-2017.) $)
    wlkntrllem2 $p |- A. k e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` k ) )
                             = { ( P ` k ) , ( P ` ( k + 1 ) ) } $=
      ( cfv c1 co cpr wceq cc0 c2 cop fveq1i cv caddc chash cfzo ax-1ne0 necomi
      wral wne c0ex fvpr1 ax-mp eqtri fveq2i csn prex fvsn ctp 2ne0 fvtp1 mp2an
      vex eqtr2i 1ne2 1ex fvtp2 preq12i 3eqtri fvpr2 prcom cr elexi fvtp3 0p1e1
      2re wa preq2i raleqi fveq2 fveq2d oveq1 preq12d eqeq12d 1p1e2 ralpr bitri
      syl6eq mpbir2an cmin cfz cz wcel 0z pm3.2i 2trllemA oveq2i 2z 2m1e1 1e0p1
      fzoval fzpr mpbir ) DUAZFLZELZXBCLZXBMUBNZCLZOZPZDQFUCLZUDNZUGXIDQQMUBNZO
      ZUGZXNQFLZELZQCLZMCLZOZPZMFLZELZXRRCLZOZPZXPQELZAUAZBUAZOZXSXOQEXOQQQSMQS
      OZLZQQFYJJTQMUHZYKQPMQUEUFZQMQQUIUIUJUKULUMYFQQYISUNZLYIQEYNITQYIUIYGYHUO
      UPULZYGXQYHXRXQQQYGSMYHSRYGSUQZLZYGQCYPKTYLQRUHZYQYGPYMRQURUFZQMRYGYHYGUI
      AVAZUSUTVBXRMYPLZYHMCYPKTYLMRUHZUUAYHPYMVCQMRYGYHYGVDBVAVEUTVBZVFVGYBYFYI
      YDYAQEYAMYJLZQMFYJJTYLUUDQPYMQMQQVDUIVHUKULUMYOYIYHYGOYDYGYHVIYHXRYGYCUUC
      YCRYPLZYGRCYPKTYRUUBUUEYGPYSVCQMRYGYHYGRVJVNVKYTVLUTVBVFULVGXNXIDQMOZUGXT
      YEVOXIDXMUUFXLMQVMVPVQXIXTYEDQMUIVDXBQPZXDXPXHXSUUGXCXOEXBQFVRVSUUGXEXQXG
      XRXBQCVRUUGXFMCUUGXFXLMXBQMUBVTVMWFVSWAWBXBMPZXDYBXHYDUUHXCYAEXBMFVRVSUUH
      XEXRXGYCXBMCVRUUHXFRCUUHXFMMUBNRXBMMUBVTWCWFVSWAWBWDWEWGXIDXKXMXKQRUDNZQR
      MWHNZWINZXMXJRQUDWJFQQWJQWJWKZUULWLWLWMJWNWORWJWKUUIUUKPWPQRWSUKUUKQMWINQ
      XLWINZXMUUJMQWIWQWOMXLQWIWRWOUULUUMXMPWLQWTUKVGVGVQXA $.

    $d F x y $.
    $( Lemma 3 for ~ wlkntrl :  F is not injective.  (Contributed by Alexander
       van der Vekens, 22-Oct-2017.) $)
    wlkntrllem3 $p |- -. Fun `' F $=
      ( c1 cc0 wceq c0ex 1ex wa cfv wi wral imbi12d ccnv ax-1ne0 cpr wf cop wne
      wfun neii necomi fpr ax-mp eqcomi feq1i mpbi wf1 df-f1 cv weq dff13 fveq2
      eqeq1d eqeq1 ralbidv ralpr eqeq2d eqeq2 wn fveq1i fvpr2 mp1i syl5eq fvpr1
      syl5req eqtrd con1i id ja ad2antrl syl2anb sylbi adantl sylbir mpan mto )
      EUAUGZKLMZKLUBUHLKUCZLLUCZEUDZWEWFWGWHLLUEKLUEUCZUDZWILKUFZWKKLUBUIZLKLLN
      ONNUJUKWGWHWJEEWJIULUMUNWIWEPWGWHEUOZWFWGWHEUPWNWIAUQZEQZBUQZEQZMZABURZRZ
      BWGSZAWGSZPWFABWGWHEUSXCWFWIXCLEQZWRMZLWQMZRZBWGSZKEQZWRMZKWQMZRZBWGSZPWF
      XBXHXMALKNOWOLMZXAXGBWGXNWSXEWTXFXNWPXDWRWOLEUTVAWOLWQVBTVCWOKMZXAXLBWGXO
      WSXJWTXKXOWPXIWRWOKEUTVAWOKWQVBTVCVDXHXDXDMZLLMZRZXDXIMZLKMZRZPZXIXDMZWFR
      ZXIXIMZKKMZRZPWFXMXGXRYABLKNOWQLMZXEXPXFXQYHWRXDXDWQLEUTZVEWQLLVFTWQKMZXE
      XSXFXTYJWRXIXDWQKEUTZVEWQKLVFTVDXLYDYGBLKNOYHXJYCXKWFYHWRXDXIYIVEWQLKVFTY
      JXJYEXKYFYJWRXIXIYKVEWQKKVFTVDYDWFYBYGYCWFWFWFYCWFVGZXILXDYLXIKWJQZLKEWJI
      VHWLYMLMYLWMLKLLONVIVJVKYLXDLWJQZLLEWJIVHWLYNLMYLWMLKLLNNVLVJVMVNVOWFVPVQ
      VRVSVTWAVTWBWCWD $.

    $( A walk which is not a trail:  In a graph with two vertices and one edge
       connecting these two vertices, to go from one edge to the other is a
       walk, but not a trail.  Notice that ` <. V , E >. ` is a simple graph
       (without loops) only if ` x =/= y ` .  (Contributed by Alexander van der
       Vekens, 22-Oct-2017.) $)
    wlkntrl $p |- ( F ( V Walks E ) P /\ -. F ( V Trails E ) P ) $=
      ( vk co cvv wcel wa eqeltri cc0 cop pm3.2i cfv cwalk wbr ctrail wn cv cpr
      prex csn snex c1 c2 ctp tpex cdm cword chash cfz caddc wceq cfzo wral w3a
      wlkntrllem1 vex prid1 prid2 3pm3.2i eleq2 3anbi123d mpbiri ax-mp 2trllemG
      wf cz 2trllemA oveq2i feq2i mpbir wlkntrllem2 iswlk ccnv wfun wlkntrllem3
      0z wb istrl notnot1 adantl 3ad2ant1 sylbi mt2 ) ECFDUALUBZECFDUCLUBZUDFMN
      ZDMNZOZEMNZCMNZOZOZWLWPWSWNWOFAUEZBUEZUFZMGXAXBUGPDQXCRZUHMHXDUIPSWQWREQQ
      RZUJQRZUFMIXEXFUGPCQXARZUJXBRZUKXARZULMJXGXHXIUMPSSZWTWLEDUNUONZQEUPTZUQL
      ZFCVMZKUEZETDTXOCTXOUJURLCTUFUSKQXLUTLVAZVBXKXNXPABCDEFGHIJVCXNQUKUQLZFCV
      MZXAFNZXBFNZXSVBZXRFXCUSZYAGYBYAXAXCNZXBXCNZYCVBYCYDYCXAXBAVDVEZXAXBBVDVF
      YEVGYBXSYCXTYDXSYCFXCXAVHZFXCXBVHYFVIVJVKXAXBXACFJVLVKXMXQFCXLUKQUQVNEQQV
      NQVNNZYGWDWDSIVOVPVQVRABCKDEFGHIJVSVGCKDEFMMMMVTVJVKWMEWAWBZUDZABCDEFGHIJ
      WCWMXKYHOZXNXPVBZYIUDZWTWMYKWEXJCKDEFMMMMWFVKYJXNYLXPYHYLXKYHWGWHWIWJWKS
      $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.  $d V k $.
    $( In an undirected simple graph, each walk has no loops!  (Contributed by
       Alexander van der Vekens, 7-Nov-2017.) $)
    usgrnloop $p |- ( ( V USGrph E /\ F ( V Walks E ) P )
        -> A. k e. ( 0 ..^ ( # ` F ) ) ( P ` k ) =/= ( P ` ( k + 1 ) ) ) $=
      ( co wbr cfv cc0 wral wcel cvv wa w3a wi wf syl ex com23 mpcom cwalk cusg
      cv c1 caddc wne chash cfzo cn0 wlkbprop cdm cword cfz cpr wceq wb 3adant1
      iswlk wrdf ffvelrn usgrafun fvelrn eleq1 anbi2d biimpd usgraedgrn syl6com
      wfun crn expcom syl5com imp31 ralimdva impancom 3adant2 syl6bi impcom ) D
      AECUAFGZECUBGZBUCZAHZVTUDUEFAHZUFZBIDUGHZUHFZJZWDUIKZELKCLKMZDLKALKMZNZVR
      VSWFOZACDEUJWJVRDCUKZULKZIWDUMFEAPZVTDHZCHZWAWBUNZUOZBWEJZNZWKWHWIVRWTUPW
      GABCDELLLLURUQWMWSWKWNWMVSWSWFWMVSMWRWCBWEWMVSVTWEKZWRWCOZWMWEWLDPZVSXAXB
      OOWLDUSXCXAVSXBXCXAVSXBOZXCXAMWOWLKZVSXBWEWLVTDUTCVHZVSXEXBOCEVAXFXEVSXBX
      FXEXDXFXEMWPCVIZKZXDWOCVBVSXHXBWRVSXHMZVSWQXGKZMZWCWRXIXKWRXHXJVSWPWQXGVC
      VDVECWAWBEVFVGVJQRSTVKRSQVLVMVNVOVPTVQ $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.
    $( Lemma for ~ is2wlk and ~ 2wlklemA .  (Contributed by Alexander van der
       Vekens, 1-Feb-2018.) $)
    2wlklem $p |- ( A. k e. { 0 , 1 } ( E ` ( F ` k ) )
                                        = { ( P ` k ) , ( P ` ( k + 1 ) ) }
                     <-> ( ( E ` ( F ` 0 ) ) = { ( P ` 0 ) , ( P ` 1 ) }
                        /\ ( E ` ( F ` 1 ) ) = { ( P ` 1 ) , ( P ` 2 ) } ) ) $=
      ( cv cfv c1 caddc co cpr wceq cc0 c0ex fveq2 fveq2d oveq1 preq12d eqeq12d
      c2 syl6eq 1ex 0p1e1 1p1e2 ralpr ) BEZDFZCFZUEAFZUEGHIZAFZJZKLDFZCFZLAFZGA
      FZJZKGDFZCFZUOSAFZJZKBLGMUAUELKZUGUMUKUPVAUFULCUELDNOVAUHUNUJUOUELANVAUIG
      AVAUILGHIGUELGHPUBTOQRUEGKZUGURUKUTVBUFUQCUEGDNOVBUHUOUJUSUEGANVBUISAVBUI
      GGHISUEGGHPUCTOQRUD $.

    $( Properties of a pair of functions to be a walk of length 2 (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       16-Feb-2018.) $)
    is2wlk $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
            -> ( ( F ( V Walks E ) P /\ ( # ` F ) = 2 )
                  <-> ( F : ( 0 ..^ 2 ) --> dom E /\ P : ( 0 ... 2 ) --> V
               /\ ( ( E ` ( F ` 0 ) ) = { ( P ` 0 ) , ( P ` 1 ) }
                    /\ ( E ` ( F ` 1 ) ) = { ( P ` 1 ) , ( P ` 2 ) } ) ) ) ) $=
      ( vk wcel wa co cfv c2 wceq cc0 wf c1 cpr wb cwalk wbr chash cdm cword cv
      cfz caddc cfzo wral iswlk anbi1d oveq2 feq2d syl5ib iswrdi impbid1 adantl
      wrdf fzo0to2pr syl6eq raleqdv 2wlklem syl6bb 3anbi123d 3anass ex pm5.32rd
      w3a an32 bitri syl6bbr wfn ffn hashfn cn0 2nn0 hashfzo0 ax-mp syl pm4.71i
      bicomi a1i 3anbi1d 3bitrd ) DFJBGJKCEJAHJKKZCADBUALUBZCUCMZNOZKCBUDZUEJZP
      WHUGLZDAQZIUFZCMBMWNAMWNRUHLAMSOZIPWHUILZUJZVIZWIKZPNUILZWJCQZWIKZPNUGLZD
      AQZPCMBMPAMRAMZSORCMBMXENAMSOKZVIZXAXDXFVIZWFWGWRWIAIBCDEFGHUKULWFWSXAXDX
      FKZKZWIKZXGWFWIWRXJWFWIWRXJTWFWIKZWRXHXJXLWKXAWMXDWQXFWIWKXATWFWIWKXAWKWP
      WJCQWIXAWJCUSWIWPWTWJCWHNPUIUMZUNUOWJNCUPUQURWIWMXDTWFWIWLXCDAWHNPUGUMUNU
      RWIWQXFTWFWIWQWOIPRSZUJXFWIWOIWPXNWIWPWTXNXMUTVAVBAIBCVCVDURVEXAXDXFVFVDV
      GVHXGXBXIKXKXBXDXFVFXAWIXIVJVKVLWFXBXAXDXFXBXATWFXAXBXAWIXACWTVMZWIWTWJCV
      NXOWHWTUCMZNWTCVONVPJXPNOVQNVRVSVAVTWAWBWCWDWE $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Paths and simple paths
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d E e f k p v $.  $d V e f p v $.
    $( The set of paths (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 20-Oct-2017.) $)
    pths $p |- ( ( V e. X /\ E e. Y ) -> ( V Paths E ) = { <. f , p >. |
                 ( f ( V Trails E ) p
                   /\ Fun `' ( p |` ( 1 ..^ ( # ` f ) ) )
                   /\ ( ( p " { 0 , ( # ` f ) } )
                    i^i ( p " ( 1 ..^ ( # ` f ) ) ) ) = (/) ) } ) $=
      ( vv ve wcel cvv cpath co cv ctrail wbr cima wceq w3a copab wa chash cfzo
      c1 cfv cres ccnv wfun cc0 cpr cin c0 cmpt2 df-pth a1i oveq12 adantl breqd
      elex 3anbi1d opabbidv simpl simpr wb 3anass wlkres eqeltrd ovmpt2d syl2an
      trliswlk ) CDICJIZBJIZCBKLAMZFMZCBNLZOZVMUCVLUAUDZUBLZUEUFUGZVMUHVPUIPVMV
      QPUJUKQZRZAFSZQBEICDURBEURVJVKTZGHCBJJVLVMGMZHMZNLZOZVRVSRZAFSZWAKJKGHJJW
      HULQWBGHAFUMUNWBWCCQWDBQTZTZWGVTAFWJWFVOVRVSWJWEVNVLVMWIWEVNQWBWCCWDBNUOU
      PUQUSUTVJVKVAVJVKVBWBWAVOVRVSTZTZAFSJWBVTWLAFVTWLVCWBVOVRVSVDUNUTWKABCNFV
      MBVLCVIVEVFVGVH $.

    $( The set of simple paths (in an undirected graph).  (Contributed by
       Alexander van der Vekens, 21-Oct-2017.) $)
    spths $p |- ( ( V e. X /\ E e. Y ) -> ( V SPaths E ) = { <. f , p >. |
       ( f ( V Trails E ) p /\ Fun `' p ) } ) $=
      ( vv ve wcel cvv cspath co cv ctrail wbr ccnv wa copab wceq elex wfun a1i
      cmpt2 df-spth oveq12 adantl breqd anbi1d opabbidv trliswlk wlkres ovmpt2d
      simpl simpr syl2an ) CDICJIZBJIZCBKLAMZFMZCBNLZOZUSPUAZQZAFRZSBEICDTBETUP
      UQQZGHCBJJURUSGMZHMZNLZOZVBQZAFRZVDKJKGHJJVKUCSVEGHAFUDUBVEVFCSVGBSQZQZVJ
      VCAFVMVIVAVBVMVHUTURUSVLVHUTSVEVFCVGBNUEUFUGUHUIUPUQUMUPUQUNVBABCNFUSBURC
      UJUKULUO $.
  $}

  ${
    $d E f k p $.  $d F f k p $.  $d P f k p $.  $d V f p $.
    $( Properties of a pair of functions to be a path (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 21-Oct-2017.) $)
    ispth $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
                  -> ( F ( V Paths E ) P <-> ( F ( V Trails E ) P
                         /\ Fun `' ( P |` ( 1 ..^ ( # ` F ) ) )
                         /\ ( ( P " { 0 , ( # ` F ) } )
                          i^i ( P " ( 1 ..^ ( # ` F ) ) ) ) = (/) ) ) ) $=
      ( vf vp wcel wa co wbr c1 chash cfzo cima wceq adantr cpath cop cv ctrail
      cfv cres ccnv wfun cc0 cpr cin c0 w3a copab df-br eleq2d syl5bb wb breq12
      pths simpr fveq2 oveq2d reseq12d cnveqd funeqd imaeq12d ineq12d 3anbi123d
      preq2d eqeq1d opelopabga adantl bitrd ) DFKBGKLZCEKAHKLZLZCADBUAMZNZCAUBZ
      IUCZJUCZDBUDMZNZWBOWAPUEZQMZUFZUGZUHZWBUIWEUJZRZWBWFRZUKZULSZUMZIJUNZKZCA
      WCNZAOCPUEZQMZUFZUGZUHZAUIWSUJZRZAWTRZUKZULSZUMZVSVTVRKVQWQCAVRUOVQVRWPVT
      VOVRWPSVPIBDFGJUTTUPUQVPWQXIURVOWOXIIJCAEHWACSZWBASZLZWDWRWIXCWNXHWACWBAW
      CUSXLWHXBXLWGXAXLWBAWFWTXJXKVAZXLWEWSOQXJWEWSSXKWACPVBZTVCVDVEVFXLWMXGULX
      LWKXEWLXFXLWBAWJXDXMXJWJXDSXKXJWEWSUIXNVJTVGXLWBAWFWTXMXJWFWTSXKXJWEWSOQX
      NVCTVGVHVKVIVLVMVN $.

    $( Properties of a pair of functions to be a simple path (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 21-Oct-2017.) $)
    isspth $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
                  -> ( F ( V SPaths E ) P
                       <-> ( F ( V Trails E ) P /\ Fun `' P ) ) ) $=
      ( vf vp wcel wa co wbr cv ccnv wfun wceq wb adantl cspath cop copab df-br
      ctrail spths adantr eleq2d syl5bb breq12 cnveq funeqd anbi12d opelopabga
      bitrd ) DFKBGKLZCEKAHKLZLZCADBUAMZNZCAUBZIOZJOZDBUEMZNZVCPZQZLZIJUCZKZCAV
      DNZAPZQZLZUTVAUSKURVJCAUSUDURUSVIVAUPUSVIRUQIBDFGJUFUGUHUIUQVJVNSUPVHVNIJ
      CAEHVBCRZVCARZLVEVKVGVMVBCVCAVDUJVPVGVMSVOVPVFVLVCAUKULTUMUNTUO $.
  $}

  ${
    $d E k $.  $d P k $.
    $( A pair of an empty set (of edges) and a second set (of vertices) is a
       path if and only if the second set contains exactly one vertex (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    0pth $p |- ( ( ( V e. X /\ E e. Y ) /\ P e. Z )
                 -> ( (/) ( V Paths E ) P <-> P : ( 0 ... 0 ) --> V ) ) $=
      ( wcel wa c0 co wbr c1 cres ccnv wfun cc0 cima wb cz eqtri cpath cfv cfzo
      ctrail chash cpr cin wceq w3a cfz wf cvv 0ex ispth mpanr1 3anass a1i fun0
      cnv0 funeqi mpbir cle hash0 0le1 eqbrtri 1z 0z eqeltri fzon mp2an reseq2i
      mpbi res0 cnveqi imaeq2i ima0 ineq2i pm3.2i biantru syl6bbr 0trl 3bitrd
      in0 ) CDGBEGHZAFGZHZIACBUAJKZIACBUDJKZALIUEUBZUCJZMZNZOZAPWIUFQZAWJQZUGZI
      UHZUIZWHPPUJJCAUKWDIULGWEWGWRRUMABICULDEFUNUOWFWRWHWMWQHZHZWHWRWTRWFWHWMW
      QUPUQWSWHWMWQWMINZOZXBIOURXAIUSUTVAWLXAWKIWKAIMIWJIAWILVBKZWJIUHZWIPLVBVC
      VDVELSGWISGXCXDRVFWIPSVCVGVHLWIVIVJVLZVKAVMTVNUTVAWPWNIUGIWOIWNWOAIQIWJIA
      XEVOAVPTVQWNWCTVRVSVTABCDEFWAWB $.

    $( A pair of an empty set (of edges) and a second set (of vertices) is a
       simple path if and only if the second set contains exactly one vertex
       (in an undirected graph).  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    0spth $p |- ( ( ( V e. X /\ E e. Y ) /\ P e. Z )
                 -> ( (/) ( V SPaths E ) P <-> P : ( 0 ... 0 ) --> V ) ) $=
      ( wcel wa c0 cspath co wbr ccnv wfun cc0 wf cvv csn wceq sylbi ctrail cfz
      wb 0ex isspth mpanr1 0trl anbi1d cz 0z fzsn ax-mp feq2i cfv cop c0ex fsn2
      funcnvsn cnveq funeqd mpbiri adantl pm4.71i syl6bbr bitrd ) CDGBEGHZAFGZH
      ZIACBJKLZIACBUAKLZAMZNZHZOOUBKZCAPZVFIQGVGVIVMUCUDABICQDEFUEUFVHVMVOVLHVO
      VHVJVOVLABCDEFUGUHVOVLVOORZCAPZVLVNVPCAOUIGVNVPSUJOUKULUMVQOAUNZCGZAOVRUO
      RZSZHVLOCAUPUQWAVLVSWAVLVTMZNOVRURWAVKWBAVTUSUTVAVBTTVCVDVE $.
  $}

  ${
    $d e f p v $.
    $( A path is a trail (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 21-Oct-2017.) $)
    pthistrl $p |- ( F ( V Paths E ) P -> F ( V Trails E ) P ) $=
      ( vf vp vv ve cvv wcel wa cpath co wbr ctrail cv c1 chash cfv cima cc0 c0
      cfzo cres ccnv wfun cpr cin wceq w3a df-pth brovmpt2ex ispth simp1 syl6bi
      mpcom ) DIJBIJKCIJAIJKKZCADBLMNZCADBOMNZEPZFPZGPHPOMNVAQUTRSZUCMZUDUEUFVA
      UAVBUGTVAVCTUHUBUIUJGHEFABCLDGHEFUKULUQURUSAQCRSZUCMZUDUEUFZAUAVDUGTAVETU
      HUBUIZUJUSABCDIIIIUMUSVFVGUNUOUP $.
  $}

  ${
    $d F x $.  $d e f p v $.
    $( A simple path is a path (in an undirected graph).  (Contributed by
       Alexander van der Vekens, 21-Oct-2017.) $)
    spthispth $p |- ( F ( V SPaths E ) P -> F ( V Paths E ) P ) $=
      ( vf vp vv vx cvv wcel wa co wbr cv c1 cc0 cima c0 wceq wn ve cspath ccnv
      cpath ctrail wfun df-spth brovmpt2ex chash cfv cfzo cres cpr cin funres11
      w3a simprl adantl cdm cword cfz wf wi cwalk trliswlk a1i 2mwlk syl6 imain
      imp wral cle clt 0lt1 0re 1re ltnlei mpbi elfzole1 mto cuz w3o cfn wrdfin
      cz cr hashcl nn0red syl ltnrd 3mix3 3ianor sylibr elfzo2 sylnibr wb eleq1
      fvex notbid ralprg mp2an sylanbrc disj imaeq2d ima0 syl6eq adantr ex impr
      eqtr3d 3jca isspth ispth 3imtr4d mpcom ) DIJBIJKCIJAIJKKZCADBUBLMZCADBUDL
      MZENFNZGNUANUELMXSUCUFKGUAEFABCUBDGUAEFUGUHXPCADBUELMZAUCUFZKZXTAOCUIUJZU
      KLZULUCUFZAPYCUMZQAYDQUNZRSZUPZXQXRXPYBYIXPYBKXTYEYHXPXTYAUQYBYEXPYAYEXTY
      DAUOURURXPXTYAYHXPXTKCBUSZUTJZPYCVALDAVBZKZYAYHVCZXPXTYMXPXTCADBVDLMZYMXT
      YOVCXPABCDVEVFABCDVGVHVJYKYNYLYKYAYHYKYAKAYFYDUNZQZYGRYAYQYGSYKYFYDAVIURY
      KYQRSYAYKYQARQRYKYPRAYKHNZYDJZTZHYFVKZYPRSYKPYDJZTZYCYDJZTZUUAUUCYKUUBOPV
      LMZPOVMMUUFTVNPOVOVPVQVRPOYCVSVTVFYKYCOWAUJJZYCWEJZYCYCVMMZUPZUUDYKUUGTZU
      UHTZUUITZWBZUUJTYKUUMUUNYKYCYKCWCJZYCWFJYJCWDUUOYCCWGWHWIWJUUMUUKUULWKWIU
      UGUUHUUIWLWMYCOYCWNWOPWFJYCIJUUAUUCUUEKWPVOCUIWRYTUUCUUEHPYCWFIYRPSYSUUBY
      RPYDWQWSYRYCSYSUUDYRYCYDWQWSWTXAXBHYFYDXCWMXDAXEXFXGXJXHXGWIXIXKXHABCDIII
      IXLABCDIIIIXMXNXO $.
  $}

  ${
    $d e f p v $.
    $( A path with different start and end points is a simple path (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       31-Oct-2017.) $)
    pthdepisspth $p |- ( ( F ( V Paths E ) P
                /\ ( P ` 0 ) =/= ( P ` ( # ` F ) ) ) -> F ( V SPaths E ) P ) $=
      ( vf vp vv ve co wbr cc0 cfv wa ccnv wfun cvv wcel wi cv cima cpath chash
      wne cspath ctrail c1 cfzo cres cpr cin wceq w3a df-pth brovmpt2ex simp-4l
      c0 ispth cdm cword cfz cwalk trliswlk 2mwlk syl cn0 lencl ad5antr simp-5r
      wf simp-4r simpr 3jca simpllr injresinj syl3c exp31 imp31 jca 3impa com12
      sylanl1 sylbid mpcom imp wb adantr isspth mpbird ) CADBUAIJZKALCUBLZALUCZ
      MZCADBUDIJZCADBUEIJZANOZMZWIWKWPDPQBPQMCPQAPQMMZWIWKWPRZESZFSZGSHSUEIJWTU
      FWSUBLZUGIZUHNOWTKXAUITWTXBTUJUPUKULGHEFABCUADGHEFUMUNZWQWIWNAUFWJUGIZUHN
      OZAKWJUITAXDTUJUPUKZULZWRABCDPPPPUQXGWQWRWNXEXFWQWRRWNXEMXFMZWQWKWPXHWQMW
      KMWNWOWNXEXFWQWKUOXHWQWKWOWNCBURZUSQZKWJUTIDAVIZMZXEXFWQWKWORRWNCADBVAIJX
      LABCDVBABCDVCVDXLXEMZXFMZWQWKWOXNWQMZWKMZWJVEQZXKXEWKULXFWOXJXQXKXEXFWQWK
      XICVFVGXPXKXEWKXJXKXEXFWQWKVHXLXEXFWQWKVJXOWKVKVLXMXFWQWKVMAWJDVNVOVPWAVQ
      VRVPVSVTWBWCWDWLWQWMWPWEWIWQWKXCWFABCDPPPPWGVDWH $.
  $}

  ${
    $d E a b e f p v $.  $d F f p $.  $d P f p $.  $d V a b e f p v $.
    $d X f p $.  $d Y f p $.  $d A a b f p $.  $d B a b f p $.
    $( The set of paths between two vertices (in an undirected graph).
       (Contributed by Alexander van der Vekens, 8-Nov-2017.) $)
    pthon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V ) )
           -> ( A ( V PathOn E ) B ) = { <. f , p >. |
              ( f ( A ( V WalkOn E ) B ) p /\ f ( V Paths E ) p ) } ) $=
      ( va vb vv wcel wa co cv wbr cpath copab cvv wceq ve cpthon elex ad2antrr
      cwlkon cmpt2 adantl adantr id ancli mpt2exga syl simpl oveq12 oveqd breqd
      anbi12d opabbidv mpt2eq123dv df-pthon ovmpt2ga simprr wb ancom a1i ctrail
      syl3anc cwalk pthistrl trliswlk wlkres syl2an eqeltrd anbi1d eqid eqtrd )
      EFLZDGLZMZAELZBELZMZMZABEDUBNZNABIJEECOZHOZIOZJOZEDUENZNZPZWEWFEDQNZPZMZC
      HRZUFZNZWEWFABWINZPZWMMZCHRZWCWDWPABWCESLZDSLZWPSLZWDWPTVQXBVRWBEFUCZUDVS
      XCWBVRXCVQDGUCZUGUHWCVQVQMZXDVQXGVRWBVQVQVQUIUJUDIJEEWOFFUKULKUAEDSSIJKOZ
      XHWEWFWGWHXHUAOZUENZNZPZWEWFXHXIQNZPZMZCHRZUFWPUBSXHETZXIDTZMZIJXHXHXPEEW
      OXQXRUMZXTXSXOWNCHXSXLWKXNWMXSXKWJWEWFXSXJWIWGWHXHEXIDUEUNUOUPXSXMWLWEWFX
      HEXIDQUNUPUQURUSKUACHIJUTVAVGUOWCVTWAXASLZWQXATWBVTVSVTWAUMUGVSVTWAVBVSYA
      WBVSXAWMWSMZCHRZSVSWTYBCHWTYBVCVSWSWMVDVEURVQXBXCYCSLVRXEXFWSCDEQHWMWEWFE
      DVFNPWEWFEDVHNPWFDWEEVIWFDWEEVJULVKVLVMUHIJABEEWOXAWPSWGATWHBTMZWNWTCHYDW
      KWSWMYDWJWRWEWFWGAWHBWIUNUPVNURWPVOVAVGVP $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d E f p $.  $d F f p $.  $d P f p $.
    $d V f p $.  $d X f p $.  $d Y f p $.
    $( Properties of a pair of functions to be a path between two given
       vertices(in an undirected graph).  (Contributed by Alexander van der
       Vekens, 8-Nov-2017.) $)
    ispthon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z )
                    /\ ( A e. V /\ B e. V ) ) -> ( F ( A ( V PathOn E ) B ) P
              <-> ( F ( A ( V WalkOn E ) B ) P /\ F ( V Paths E ) P ) ) ) $=
      ( vf vp wcel wa co wbr cv wb wceq breq12 cpthon cpath copab pthon 3adant2
      w3a cwlkon breqd anbi12d eqid brabga 3ad2ant2 bitrd ) FHMDIMNZEGMCJMNZAFM
      BFMNZUFECABFDUAOOZPZECKQZLQZABFDUGOOZPZUSUTFDUBOZPZNZKLUCZPZECVAPZECVCPZN
      ZUNUPURVGRUOUNUPNUQVFECABKDFHILUDUHUEUOUNVGVJRUPVEVJKLECVFGJUSESUTCSNVBVH
      VDVIUSEUTCVATUSEUTCVCTUIVFUJUKULUM $.
  $}

  ${
    $d E a b e f p v $.  $d V a b e f p v $.  $d A f p $.  $d B f p $.
    $( Properties of a path between two vertices.  (Contributed by Alexander
       van der Vekens, 12-Dec-2017.) $)
    pthonprop $p |- ( F ( A ( V PathOn E ) B ) P -> ( ( ( V e. _V /\ E e. _V )
      /\ ( F e. _V /\ P e. _V ) /\ ( A e. V /\ B e. V ) )
      /\ ( F ( A ( V WalkOn E ) B ) P /\ F ( V Paths E ) P ) ) ) $=
      ( vf vp va vb vv ve cvv wcel wa co wbr cwlkon cpath cv cpthon wceq oveq12
      w3a df-pthon oveqd breqd anbi12d pthon bropopvvv ispthon biimpd imdistani
      mpancom ) FMNDMNOEMNCMNOAFNBFNOUDZECABFDUAPPQZUOECABFDRPZPZQECFDSPZQOZOGT
      ZHTZITZJTZKTZLTZRPZPZQZVAVBVEVFSPZQZOVAVBVCVDUQPZQZVAVBUSQZOVAVBURQVNOKAB
      CLGDEUAFHIJKLGHIJUEVEFUBVFDUBOZVIVMVKVNVOVHVLVAVBVOVGUQVCVDVEFVFDRUCUFUGV
      OVJUSVAVBVEFVFDSUCUGUHABGDFMMHUIUJUOUPUTUOUPUTABCDEFMMMMUKULUMUN $.
  $}

  $( A path between two vertices is a path.  (Contributed by Alexander van der
     Vekens, 12-Dec-2017.) $)
  pthonispth $p |- ( F ( A ( V PathOn E ) B ) P -> F ( V Paths E ) P ) $=
    ( cpthon co wbr cvv wcel wa w3a cwlkon cpath pthonprop simprr syl ) ECABFDG
    HHIFJKDJKLEJKCJKLAFKBFKLMZECABFDNHHIZECFDOHIZLLUAABCDEFPSTUAQR $.

  $( A path of length 0 from a vertex to itself.  (Contributed by Alexander van
     der Vekens, 3-Dec-2017.) $)
  0pthon $p |- ( ( ( V e. X /\ E e. Y ) /\ N e. V )
                 -> ( ( P : ( 0 ... 0 ) --> V /\ ( P ` 0 ) = N )
                      -> (/) ( N ( V PathOn E ) N ) P ) ) $=
    ( wcel wa cc0 cfz co wf cfv c0 wbr wb cfn mpbird jca cvv wceq cpthon cwlkon
    cpath 0wlkon imp simprl cpm fzfid simplll fpmg syl3anc 0pth syl2anc 0ex a1i
    simpll simpr adantr ispthon syl121anc ex ) DEGZBFGZHZCDGZHZIIJKZDALZIAMCUAZ
    HZNACCDBUBKKOZVGVKHZVLNACCDBUCKKOZNADBUDKOZHZVMVNVOVGVKVNABCDEFUEUFVMVOVIVG
    VIVJUGZVMVEADVHUHKZGZVOVIPVEVFVKUQZVMVHQGVCVIVSVMIIUIVCVDVFVKUJVQVHDAQEUKUL
    ZABDEFVRUMUNRSVMVENTGZVSVFVFHZVLVPPVTWBVMUOUPWAVGWCVKVGVFVFVEVFURZWDSUSCCAB
    NDTEFVRUTVARVB $.

  $( A path of length 0 from a vertex to itself.  (Contributed by Alexander van
     der Vekens, 3-Dec-2017.) $)
  0pthon1 $p |- ( ( ( V e. X /\ E e. Y ) /\ N e. V )
                  -> (/) ( N ( V PathOn E ) N ) { <. 0 , N >. } ) $=
    ( wcel wa cc0 cfz co cop csn wf cfv wceq c0 cpthon wbr simpr eqidd syl2anc
    1fv 0pthon mpd ) CDFAEFGZBCFZGZHHIJCHBKLZMHUHNBOGZPUHBBCAQJJRUGUFUHUHOUIUEU
    FSUGUHTUHBCUBUAUHABCDEUCUD $.

  ${
    $d E f p $.  $d N f p $.  $d V f p $.
    $( For each vertex there is a path of length 0 from the vertex to itself.
       (Contributed by Alexander van der Vekens, 3-Dec-2017.) $)
    0pthonv $p |- ( ( V e. X /\ E e. Y ) -> ( N e. V
                 -> E. f E. p f ( N ( V PathOn E ) N ) p ) ) $=
      ( wcel wa cv cpthon co wbr wex c0 cvv cc0 cop csn 0ex snex pm3.2i 0pthon1
      breq12 spc2egv mpsyl ex ) DEHBFHIZCDHZAJZGJZCCDBKLLZMZGNANZOPHZQCRZSZPHZI
      UHUIIOUQULMZUNUOURTUPUAUBBCDEFUCUMUSAGOUQPPUJOUKUQULUDUEUFUG $.
  $}

  ${
    $d E a b e f p v $.  $d F f p $.  $d P f p $.  $d V a b e f p v $.
    $d X f p $.  $d Y f p $.  $d A a b f p $.  $d B a b f p $.
    $( The set of simple paths between two vertices (in an undirected graph).
       (Contributed by Alexander van der Vekens, 1-Mar-2018.) $)
    spthon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V ) )
           -> ( A ( V SPathOn E ) B ) = { <. f , p >. |
              ( f ( A ( V WalkOn E ) B ) p /\ f ( V SPaths E ) p ) } ) $=
      ( va vb vv wcel wa co cv wbr cspath copab cvv wceq ve cspthon cwlkon elex
      cmpt2 ad2antrr adantl adantr id ancli mpt2exga simpl oveq12 oveqd anbi12d
      syl breqd opabbidv mpt2eq123dv df-spthon ovmpt2ga syl3anc simprr wb ancom
      cpath ctrail cwalk spthispth pthistrl trliswlk 3syl wlkres syl2an eqeltrd
      a1i anbi1d eqid eqtrd ) EFLZDGLZMZAELZBELZMZMZABEDUBNZNABIJEECOZHOZIOZJOZ
      EDUCNZNZPZWHWIEDQNZPZMZCHRZUEZNZWHWIABWLNZPZWPMZCHRZWFWGWSABWFESLZDSLZWSS
      LZWGWSTVTXEWAWEEFUDZUFWBXFWEWAXFVTDGUDZUGUHWFVTVTMZXGVTXJWAWEVTVTVTUIUJUF
      IJEEWRFFUKUPKUAEDSSIJKOZXKWHWIWJWKXKUAOZUCNZNZPZWHWIXKXLQNZPZMZCHRZUEWSUB
      SXKETZXLDTZMZIJXKXKXSEEWRXTYAULZYCYBXRWQCHYBXOWNXQWPYBXNWMWHWIYBXMWLWJWKX
      KEXLDUCUMUNUQYBXPWOWHWIXKEXLDQUMUQUOURUSKUACHIJUTVAVBUNWFWCWDXDSLZWTXDTWE
      WCWBWCWDULUGWBWCWDVCWBYDWEWBXDWPXBMZCHRZSWBXCYECHXCYEVDWBXBWPVEVPURVTXEXF
      YFSLWAXHXIXBCDEQHWPWHWIEDVFNPWHWIEDVGNPWHWIEDVHNPWIDWHEVIWIDWHEVJWIDWHEVK
      VLVMVNVOUHIJABEEWRXDWSSWJATWKBTMZWQXCCHYGWNXBWPYGWMXAWHWIWJAWKBWLUMUQVQUR
      WSVRVAVBVS $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d E f p $.  $d F f p $.  $d P f p $.
    $d V f p $.  $d X f p $.  $d Y f p $.
    $( Properties of a pair of functions to be a simple path between two given
       vertices(in an undirected graph).  (Contributed by Alexander van der
       Vekens, 1-Mar-2018.) $)
    isspthon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z )
                    /\ ( A e. V /\ B e. V ) ) -> ( F ( A ( V SPathOn E ) B ) P
              <-> ( F ( A ( V WalkOn E ) B ) P /\ F ( V SPaths E ) P ) ) ) $=
      ( vf vp wcel wa co wbr cv wb wceq breq12 w3a cspthon cwlkon cspath spthon
      copab breqd 3adant2 anbi12d eqid brabga 3ad2ant2 bitrd ) FHMDIMNZEGMCJMNZ
      AFMBFMNZUAECABFDUBOOZPZECKQZLQZABFDUCOOZPZUSUTFDUDOZPZNZKLUFZPZECVAPZECVC
      PZNZUNUPURVGRUOUNUPNUQVFECABKDFHILUEUGUHUOUNVGVJRUPVEVJKLECVFGJUSESUTCSNV
      BVHVDVIUSEUTCVATUSEUTCVCTUIVFUJUKULUM $.
  $}

  $( Properties of a pair of functions to be a simple path between two given
     vertices(in an undirected graph).  (Contributed by Alexander van der
     Vekens, 9-Mar-2018.) $)
  isspthonpth $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z )
                    /\ ( A e. V /\ B e. V ) ) -> ( F ( A ( V SPathOn E ) B ) P
    <-> ( F ( V SPaths E ) P /\ ( P ` 0 ) = A /\ ( P ` ( # ` F ) ) = B ) ) ) $=
    ( wcel wa w3a cspthon co wbr cwlkon cspath cfv wceq cc0 chash cwalk iswlkon
    isspthon anbi1d simpl simpr2 simpr3 3jca ancoms spthispth pthistrl trliswlk
    cpath ctrail 3syl 3anim1i simp1 jca impbii syl6bb bitrd ) FHKDIKLEGKCJKLAFK
    BFKLMZECABFDNOOPECABFDQOOPZECFDROPZLZVFUACSATZEUBSCSBTZMZABCDEFGHIJUEVDVGEC
    FDUCOPZVHVIMZVFLZVJVDVEVLVFABCDEFGHIJUDUFVMVJVFVLVJVFVLLVFVHVIVFVLUGVFVKVHV
    IUHVFVKVHVIUIUJUKVJVLVFVFVKVHVIVFECFDUOOPECFDUPOPVKCDEFULCDEFUMCDEFUNUQURVF
    VHVIUSUTVAVBVC $.

  ${
    $d E a b e f p v $.  $d V a b e f p v $.  $d A f p $.  $d B f p $.
    $( Properties of a simple path between two vertices.  (Contributed by
       Alexander van der Vekens, 1-Mar-2018.) $)
    spthonprp $p |- ( F ( A ( V SPathOn E ) B ) P -> ( ( ( V e. _V /\ E e. _V )
      /\ ( F e. _V /\ P e. _V ) /\ ( A e. V /\ B e. V ) )
      /\ ( F ( A ( V WalkOn E ) B ) P /\ F ( V SPaths E ) P ) ) ) $=
      ( vf vp va vb vv ve cvv wcel wa co wbr cwlkon cspath cv cspthon df-spthon
      w3a oveq12 oveqd breqd anbi12d spthon bropopvvv isspthon biimpd imdistani
      wceq mpancom ) FMNDMNOEMNCMNOAFNBFNOUCZECABFDUAPPQZUOECABFDRPZPZQECFDSPZQ
      OZOGTZHTZITZJTZKTZLTZRPZPZQZVAVBVEVFSPZQZOVAVBVCVDUQPZQZVAVBUSQZOVAVBURQV
      NOKABCLGDEUAFHIJKLGHIJUBVEFUMVFDUMOZVIVMVKVNVOVHVLVAVBVOVGUQVCVDVEFVFDRUD
      UEUFVOVJUSVAVBVEFVFDSUDUFUGABGDFMMHUHUIUOUPUTUOUPUTABCDEFMMMMUJUKULUN $.
  $}

  $( A simple path between to vertices is a simple path.  (Contributed by
     Alexander van der Vekens, 2-Mar-2018.) $)
  spthonisspth $p |- ( F ( A ( V SPathOn E ) B ) P -> F ( V SPaths E ) P ) $=
    ( cspthon co wbr cvv wcel wa w3a cwlkon cspath spthonprp simprr syl ) ECABF
    DGHHIFJKDJKLEJKCJKLAFKBFKLMZECABFDNHHIZECFDOHIZLLUAABCDEFPSTUAQR $.

  $( The endpoints of a simple path between two vertices are equal if and only
     if the path is of length 0 (in an undirected graph).  (Contributed by
     Alexander van der Vekens, 1-Mar-2018.) $)
  spthonepeq $p |- ( F ( A ( V SPathOn E ) B ) P
                     -> ( A = B <-> ( # ` F ) = 0 ) ) $=
    ( co wbr cvv wcel wa w3a wceq cfv cc0 wb wi sylbi syl syl6bi cspthon cwlkon
    cspath chash spthonprp cwalk ctrail ccnv iswlkon isspth 3adant3 anbi12d cdm
    wfun cword cfz cn0 2mwlk lencl anim1i wf1 df-f1 eqeq2 eqtr3 elnn0uz eluzfz2
    wf cuz eluzfz1 jca f1veqaeq sylan2 com13 expcom com15 sylbir imp 3syl 3imp1
    ex fveq2 eqeq1d anbi2d eqtr2 com12 3adant1 adantr impbid adantrl ) ECABFDUA
    GGHFIJDIJKZEIJCIJKZAFJBFJKZLZECABFDUBGGHZECFDUCGHZKZKABMZEUDNZOMZPZABCDEFUE
    WMWPWTWMWPECFDUFGHZOCNZAMZWRCNZBMZLZECFDUGGHZCUHUNZKZKWTWMWNXFWOXIABCDEFIII
    IUIWJWKWOXIPWLCDEFIIIIUJUKULXFXHWTXGXFXHKWQWSXAXCXEXHWQWSQZXAEDUMZUOJZOWRUP
    GZFCVGZKWRUQJZXNKXCXEXHXJQQQZCDEFURXLXOXNXKEUSUTXOXNXPXHXNXCXEXOXJXNXHXCXEX
    OXJQQQZXNXHKXMFCVAZXQXMFCVBWQXCXEXOXRWSWQXCXBBMZXEXOXRWSQQZQABXBVCXEXSXTXEX
    SKXDXBMZXTXDXBBVDXRXOYAWSXRXOYAWSQZXOXRWRXMJZOXMJZKYBXOYCYDXOWROVHNJZYCWRVE
    ZOWRVFRXOYEYDYFOWRVIRVJXMFWROCVKVLVTVMSVNTVOVPVNVOVQVRVSXFWSWQQZXHXCXEYGXAW
    SXCXEKZWQWSYHXCXSKWQWSXEXSXCWSXDXBBWROCWAWBWCXBABWDTWEWFWGWHWITVQS $.

  ${
    $d E k $.  $d F k $.  $d P k $.
    1trl.f $e |- F = { <. 0 , i >. } $.
    1trl.p $e |- P = { <. 0 , A >. , <. 1 , B >. } $.
    $( Construction of a trail from one given edge in a graph.  (Contributed by
       Alexander van der Vekens, 3-Dec-2017.) $)
    constr1trl $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V )
                         /\ ( E ` i ) = { A , B } ) -> F ( V Trails E ) P ) $=
      ( vk wcel wa cfv wceq co cc0 c1 cvv cpr w3a ctrail wbr chash cfzo cdm wf1
      cv cfz wf caddc wral cop csn wf1o wi vex f1osn f1of1 wss wb fveq2 hashsng
      c0ex ax-mp syl6eq oveq2i fzo01 eqtri eqcomi biimpi adantr prid1g 3ad2ant2
      opex f1eq2 adantl eleq2 3ad2ant3 mpbird elfvdm snssd f1ss syl2anc ex mp2b
      syl f1eq1 mpan cz wne 0z 1z pm3.2i ax-1ne0 necomi fprg fzpr preq2i 3eqtri
      0p1e1 feq2i sylibr mp3an13 prssi fss id feq12d fveq1 fvsn fveq2d sylan9eq
      a1i fvpr1g 1ex fvpr2g preq12d 3eqtr4d oveq1 eqeq12d ralsn raleqdv eqeltri
      snex prex istrl2 mpanr12 3ad2ant1 mpbir3and ) GHMEIMNZAGMZBGMZNZDUIZEOZAB
      UAZPZUBZFCGEUCQUDZRFUEOZUFQZEUGZFUHZRUUAUJQZGCUKZLUIZFOZEOZUUGCOZUUGSULQZ
      COZUAZPZLUUBUMZFRYOUNZUOZPZYSUUDJUURYSNUUDUUBUUCUUQUHZYSUUSUURRUOZYOUOZUU
      QUPUUTUVAUUQUHZYSUUSUQRYOVEDURZUSUUTUVAUUQUTUVBYSUUSUVBYSNZUUBUVAUUQUHZUV
      AUUCVAUUSUVBUVEYSUVBUVEUUTUUBPUVBUVEVBUUBUUTUUBRSUFQUUTUUASRUFUURUUASPJUU
      RUUAUUQUEOZSFUUQUEVCUUPTMUVFSPRYOVPUUPTVDVFVGVFZVHVIVJZVKUUTUUBUVAUUQVQVF
      VLVMUVDYOUUCUVDAYPMZYOUUCMUVDUVIAYQMZYSUVJUVBYNYKUVJYRYLUVJYMABGVNVMVOVRY
      SUVIUVJVBZUVBYRYKUVKYNYPYQAVSVTVRWAAYOEWBWHWCUUBUVAUUCUUQWDWEWFWGVRUURUUD
      UUSVBYSUUBUUCFUUQWIVMWAWJYNYKUUFYRCRAUNZSBUNZUAZPZYNUUFKUVOYNNUUFRSUJQZGU
      VNUKZYNUVQUVOYNUVPYQUVNUKZYQGVAUVQRWKMZSWKMZNZYNRSWLZUVRUVSUVTWMWNWOSRWPW
      QZUWAYNUWBUBRSUAZYQUVNUKUVRRSABWKWKGGWRUVPUWDYQUVNUVPRRSULQZUJQZRUWEUAZUW
      DSUWERUJUWESXBVKVHUVSUWFUWGPWMRWSVFUWESRXBWTXAXCXDXEABGXFUVPYQGUVNXGWEVRU
      VOUUFUVQVBYNUVOUUEUVPGCUVNUVOXHUUEUVPPUVOUUASRUJUVGVHXNXIVMWAWJVOYSUUOUUN
      LUUTUMZYSRFOZEOZRCOZSCOZUAZPZUWHYSYPYQUWJUWMYRYKYRYNYRXHVTYSUWIYOEUWIYOPZ
      YSUURUWOJUURUWIRUUQOYORFUUQXJRYOVEUVCXKVGVFXNXLYSUWKAUWLBYNYKUWKAPZYRYLUW
      PYMUVOYLUWPKUVOYLUWKRUVNOZARCUVNXJRTMYLUWBUWQAPVEUWCRSABTGXOXEXMWJVMVOYNY
      KUWLBPZYRYMUWRYLUVOYMUWRKUVOYMUWLSUVNOZBSCUVNXJSTMYMUWBUWSBPXPUWCRSABTGXQ
      XEXMWJVRVOXRXSUUNUWNLRVEUUGRPZUUIUWJUUMUWMUWTUUHUWIEUUGRFVCXLUWTUUJUWKUUL
      UWLUUGRCVCUWTUUKSCUWTUUKUWESUUGRSULXTXBVGXLXRYAYBXDYSUUNLUUBUUTUUBUUTPYSU
      VHXNYCWAYKYNYTUUDUUFUUOUBVBZYRYKFTMCTMUXAFUUQTJUUPYEYDCUVNTKUVLUVMYFYDCLE
      FGTHITYGYHYIYJ $.

    $( Lemma 1 for ~ 1pthon .  (Contributed by Alexander van der Vekens,
       4-Dec-2017.) $)
    1pthonlem1 $p |- Fun `' ( P |` ( 1 ..^ ( # ` F ) ) ) $=
      ( cc0 wceq c1 chash cfv cfzo co cres ccnv wfun c0 cvv ax-mp cop fun0 res0
      cv csn cnveqi cnv0 eqtri funeqi mpbir oveq2d wcel opex hashsng oveq2i a1i
      fveq2 fzo0 3eqtrd reseq2d cnveqd funeqd mpbiri ) EHDUDZUAZUEZIZCJEKLZMNZO
      ZPZQZFVGVLCROZPZQZVORQUBVNRVNRPRVMRCUCUFUGUHUIUJVGVKVNVGVJVMVGVIRCVGVIJVF
      KLZMNZJJMNZRVGVHVPJMEVFKUQUKVQVRIVGVPJJMVESULVPJIHVDUMVESUNTUOUPVRRIVGJUR
      UPUSUTVAVBVCT $.

    $( Lemma 2 for ~ 1pthon .  (Contributed by Alexander van der Vekens,
       4-Dec-2017.) $)
    1pthonlem2 $p |- ( ( P " { 0 , ( # ` F ) } )
                   i^i ( P " ( 1 ..^ ( # ` F ) ) ) ) = (/) $=
      ( cc0 wceq chash cfv cpr cima c1 cfzo co cin c0 cvv syl6eq cop fveq2 wcel
      csn opex hashsng ax-mp preq2d imaeq2d oveq2d fzo0 ineq12d ima0 ineq2i in0
      cv eqtri ) EHDUPZUAZUDZIZCHEJKZLZMZCNVBOPZMZQZRIFVAVGCHNLZMZCRMZQZRVAVDVI
      VFVJVAVCVHCVAVBNHVAVBUTJKZNEUTJUBUSSUCVLNIHURUEUSSUFUGTZUHUIVAVERCVAVENNO
      PRVAVBNNOVMUJNUKTUIULVKVIRQRVJRVICUMUNVIUOUQTUG $.
  $}

  $( A path of length 1 from one vertex to another vertex.  (Contributed by
     Alexander van der Vekens, 3-Dec-2017.) $)
  1pthon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V )
                   /\ ( E ` i ) = { A , B } )
                      -> { <. 0 , i >. } ( A ( V PathOn E ) B )
                         { <. 0 , A >. , <. 1 , B >. } ) $=
    ( wcel wa cfv cpr wceq w3a cc0 cop c1 co wbr cvv a1i csn cpthon cwalk chash
    cv ctrail cfzo cres ccnv wfun cima cin c0 eqid constr1trl trliswlk syl c0ex
    wne simp2l ax-1ne0 necomi fvpr1g syl3anc 1ex simp2r opex ax-mp fveq2 fvpr2g
    hashsng sylan9eq mpan 3jca 1pthonlem1 1pthonlem2 wb simp1 snex pm3.2i simp2
    prex cwlkon cpath ispthon iswlkon ispth 3adant3 anbi12d bitrd mpbir2and ) E
    FHDGHIZAEHZBEHZIZCUEZDJABKLZMZNWPOZUAZNAOZPBOZKZABEDUBQQRZWTXCEDUCQRZNXCJAL
    ZWTUDJZXCJZBLZMZWTXCEDUFQRZXCPXGUGQZUHUIUJZXCNXGKUKXCXLUKULUMLZMZWRXEXFXIWR
    XKXEABXCCDWTEFGWTUNZXCUNZUOZXCDWTEUPUQWRNSHZWMNPUSZXFXSWRURTWLWMWNWQUTXTWRP
    NVAVBTZNPABSEVCVDWRPSHZWNXTXIYBWRVETWLWMWNWQVFYAXGPLZYBWNXTMZXIWSSHYCNWPVGW
    SSVKVHYCYDXHPXCJBXGPXCVINPABSEVJVLVMVDVNWRXKXMXNXRXMWRABXCCWTXPXQVOTXNWRABX
    CCWTXPXQVPTVNWRWLWTSHZXCSHZIZWOXDXJXOIZVQWLWOWQVRYGWRYEYFWSVSXAXBWBVTTWLWOW
    QWAWLYGWOMZXDWTXCABEDWCQQRZWTXCEDWDQRZIYHABXCDWTESFGSWEYIYJXJYKXOABXCDWTESF
    GSWFWLYGYKXOVQWOXCDWTESFGSWGWHWIWJVDWK $.

  ${
    $d A i $.  $d B i $.  $d I i $.  $d E i $.  $d V i $.  $d X i $.  $d Y i $.
    $( A path of length 1 from one vertex to another vertex.  (Contributed by
       Alexander van der Vekens, 4-Dec-2017.) $)
    1pthoncl $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V )
                     /\ ( I e. _V /\ ( E ` I ) = { A , B } ) )
                        -> { <. 0 , I >. } ( A ( V PathOn E ) B )
                           { <. 0 , A >. , <. 1 , B >. } ) $=
      ( vi wcel wa cvv cfv cpr wceq cc0 cop csn co wbr wi c1 cpthon w3a 3anbi3d
      cv fveq2 eqeq1d opeq2 sneqd breq1d imbi12d 1pthon vtoclg com12 3exp com23
      com14 imp com13 3imp ) EFICGIJZAEIBEIJZDKIZDCLZABMZNZJZODPZQZOAPUABPMZABE
      CUBRRZSZVGVBVAVLVCVFVBVAVLTTVAVFVBVCVLVAVBVFVCVLTZVAVBVFVMVCVAVBVFUCZVLVA
      VBHUEZCLZVENZUCZOVOPZQZVJVKSZTVNVLTHDKVODNZVRVNWAVLWBVQVFVAVBWBVPVDVEVODC
      UFUGUDWBVTVIVJVKWBVSVHVODOUHUIUJUKABHCEFGULUMUNUOUPUQURUSUT $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d E f p $.  $d N f p $.  $d V f p $.
    $( For each pair of adjacent vertices there is a path of length 1 from one
       vertex to the other.  (Contributed by Alexander van der Vekens,
       4-Dec-2017.) $)
    1pthon2v $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V )
                       /\ ( E ` ( `' E ` { A , B } ) ) = { A , B } )
                     -> E. f E. p f ( A ( V PathOn E ) B ) p ) $=
      ( cc0 cpr ccnv cfv cop cvv wcel wa co wbr cv wex csn wceq w3a cpthon snex
      c1 prex pm3.2i simp3 fvex jctil 1pthoncl syld3an3 breq12 spc2egv mpsyl )
      IABJZDKZLZMZUAZNOZIAMZUFBMZJZNOZPEFODGOPZAEOBEOPZUSDLUQUBZUCZVAVEABEDUDQQ
      ZRZCSZHSZVKRZHTCTVBVFUTUEVCVDUGUHVGVHVIUSNOZVIPVLVJVIVPVGVHVIUIUQURUJUKAB
      DUSEFGULUMVOVLCHVAVENNVMVAVNVEVKUNUOUP $.
  $}

  ${
    2pth.p $e |- P = { <. 0 , A >. , <. 1 , B >. , <. 2 , C >. } $.
    $( Lemma 1 for ~ constr2spth .  (Contributed by Alexander van der Vekens,
       31-Jan-2018.) $)
    constr2spthlem1 $p |- ( ( ( A e. V /\ B e. V /\ C e. V )
                        /\ ( A =/= B /\ A =/= C /\ B =/= C ) ) -> Fun `' P ) $=
      ( wcel w3a wne wa ccnv cc0 cop c1 c2 cz csn cun wceq jctl wfun 0z 3pm3.2i
      ctp 1z 2z funtpg mp3an2 wb cpr cnvun 3ad2ant1 cnvsng syl 3ad2ant2 uneq12d
      syl5eq df-pr a1i cnveqd 3eqtr4d cnveqi df-tp 3eqtri 3eqtr4g funeqd adantr
      3ad2ant3 mpbird ) AEGZBEGZCEGZHZABIACIBCIHZJDKZUAZALMZBNMZCOMZUDZUAZVMLPG
      ZNPGZOPGZHVNWAWBWCWDUBUEUFUCLNOEPPPEEABCUGUHVMVPWAUIVNVMVOVTVMLAMZNBMZUJZ
      KZOCMZQZKZRZVQVRUJZVSQZRVOVTVMWHWMWKWNVMWEQZWFQZRZKZVQQZVRQZRZWHWMVMWRWOK
      ZWPKZRXAWOWPUKVMXBWSXCWTVMWBVJJZXBWSSVJVKXDVLVJWBUBTULLAPEUMUNVMWCVKJZXCW
      TSVKVJXEVLVKWCUETUONBPEUMUNUPUQVMWGWQWGWQSVMWEWFURUSUTWMXASVMVQVRURUSVAVM
      WDVLJZWKWNSVLVJXFVKVLWDUFTVHOCPEUMUNUPVOWEWFWIUDZKWGWJRZKWLDXGFVBXGXHWEWF
      WIVCVBWGWJUKVDVQVRVSVCVEVFVGVI $.

    $( Lemma 1 for ~ constr2pth .  (Contributed by Alexander van der Vekens,
       5-Dec-2017.)  (Revised by Alexander van der Vekens, 31-Jan-2018.) $)
    2pthlem1 $p |- ( ( A e. V /\ B e. V /\ C e. V )
                       -> Fun `' ( P |` ( 1 ..^ 2 ) ) ) $=
      ( wcel w3a c1 csn cres ccnv wfun c2 cfzo co cfv cop funcnvsn cc0 ctp wceq
      wfn 1ex tpid2 fnressn sylancl cnveqd funeqd mpbiri fzo12sn reseq2i cnveqi
      2trllemD funeqi sylibr ) AEGBEGCEGHZDIJZKZLZMZDINOPZKZLZMUQVAIIDQZRJZLZMI
      VESUQUTVGUQUSVFUQDTINUAZUCIVHGUSVFUBABCDEFUNTINUDUEVHIDUFUGUHUIUJVDUTVCUS
      VBURDUKULUMUOUP $.

    $( Lemma 2 for ~ constr2pth .  (Contributed by Alexander van der Vekens,
       5-Dec-2017.)  (Revised by Alexander van der Vekens, 18-Feb-2018.) $)
    2pthlem2 $p |- ( ( ( A e. V /\ B e. V /\ C e. V )
                     /\ ( A =/= B /\ B =/= C ) )
                    -> ( ( P " { 0 , 2 } ) i^i ( P " ( 1 ..^ 2 ) ) ) = (/) ) $=
      ( wcel wne wa cc0 c2 cpr cima c1 cin cfv csn c0 wceq wn w3a cfzo 2trllemD
      co ctp wfn 1ex fnsnfv sylancl fzo12sn imaeq2i syl6reqr ineq2d adantr c0ex
      tpid2 tpid1 a1i cz elexi tpid3 fnimapr syl3anc 2wlklemA 3ad2ant1 2wlklemC
      2z ineq1d 3ad2ant3 preq12d 2wlklemB 3ad2ant2 sneqd ineq12d wo nne biimpri
      elpri eqcoms orim12i syl ianor sylibr con2i disjsn sylan9eq 3eqtrd ) AEGZ
      BEGZCEGZUAZABHZBCHZIZIDJKLMZDNKUBUDZMZOZWONDPZQZOZJDPZKDPZLZWTOZRWKWRXASW
      NWKWQWTWOWKWTDNQZMZWQWKDJNKUEZUFZNXHGWTXGSABCDEFUCZJNKUGUPXHNDUHUIWPXFDUJ
      UKULUMUNWKXAXESWNWKWOXDWTWKXIJXHGZKXHGZWOXDSXJXKWKJNKUOUQURXLWKJNKKUSVGUT
      VAURXHJKDVBVCVHUNWKWNXEACLZBQZOZRWKXDXMWTXNWKXBAXCCWHWIXBASWJABCDEFVDVEWJ
      WHXCCSWIABCDEFVFVIVJWKWSBWIWHWSBSWJABCDEFVKVLVMVNWNBXMGZTXORSXPWNXPWLTZWM
      TZVOZWNTXPBASZBCSZVOXSBACVRXTXQYAXRXQABXQABSABVPVQVSXRYABCVPVQVTWAWLWMWBW
      CWDXMBWEWCWFWG $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.
    2trlY.i $e |- ( I e. U /\ J e. W ) $.
    2trlY.f $e |- F = { <. 0 , I >. , <. 1 , J >. } $.
    2trlY.p $e |- P = { <. 0 , A >. , <. 1 , B >. , <. 2 , C >. } $.
    $( Lemma 1 for ~ constr2wlk .  (Contributed by Alexander van der Vekens,
       1-Feb-2018.) $)
    2wlklem1 $p |- ( ( ( ( V e. X /\ E e. Y )
                 /\ ( A e. V /\ B e. V /\ C e. V ) ) /\ ( ( E ` I ) = { A , B }
                 /\ ( E ` J ) = { B , C } ) ) -> A. k e. { 0 , 1 }
                     ( E ` ( F ` k ) ) = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) $=
      ( cfv wceq c1 wcel wa w3a cpr cc0 c2 cv caddc co simprl cop fveq1 ax-1ne0
      wral wne necomi c0ex cvv elex adantr ax-mp fvpr1 syl6eq 2wlklemA 3ad2ant1
      fveq2d ad2antlr 2wlklemB 3ad2ant2 preq12d 3eqtr4d simprr 1ex adantl fvpr2
      mp1i 2wlklemC 3ad2ant3 2wlklem sylanbrc ) KMUAGNUAUBZAKUAZBKUAZCKUAZUCZUB
      ZIGRZABUDZSZJGRZBCUDZSZUBZUBZUEHRZGRZUEDRZTDRZUDZSTHRZGRZWRUFDRZUDZSFUGZH
      RGRXDDRXDTUHUIDRUDSFUETUDUNWNWGWHWPWSWFWIWLUJWNWOIGHUEIUKTJUKUDZSZWOISWNP
      XFWOUEXERZIUEHXEULUETUOZXGISTUEUMUPZUETIJUQIEUAZJLUAZUBZIURUAZOXJXMXKIEUS
      UTVAVBVAVCVPVFWNWQAWRBWEWQASZWAWMWBWCXNWDABCDKQVDVEVGWEWRBSZWAWMWCWBXOWDA
      BCDKQVHVIVGZVJVKWNWJWKXAXCWFWIWLVLWNWTJGXFWTJSWNPXFWTTXERZJTHXEULXHXQJSXI
      UETIJVMXLJURUAZOXKXRXJJLUSVNVAVOVAVCVPVFWNWRBXBCXPWEXBCSZWAWMWDWBXSWCABCD
      KQVQVRVGVJVKDFGHVSVT $.

    $( Construction of a walk from two given edges in a graph.  (Contributed by
       Alexander van der Vekens, 5-Feb-2018.) $)
    constr2wlk $p |- ( ( ( V e. X /\ E e. Y )
                         /\ ( A e. V /\ B e. V /\ C e. V ) )
                        -> ( ( ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } )
                             -> F ( V Walks E ) P ) ) $=
      ( vk wcel cfv cc0 wa w3a cpr cwalk co wbr cdm cword chash cfz wf cv caddc
      wceq c1 cfzo wral wi df-3an 2trllemH sylanbr iswrdi ex 3ad2antr2 2trllemG
      syl imp c2 2trllemA oveq2i feq2i sylibr ad2antlr 2wlklem1 2trllemB mpbird
      a1i raleqdv wb cvv cop prex eqeltri tpex iswlk mpanr12 ad2antrr mpbir3and
      ctp ) JLRZFMRZUAZAJRZBJRZCJRZUBZUAZHFSABUCUNIFSBCUCUNUAZGDJFUDUEUFZWQWRUA
      ZWSGFUGZUHRZTGUISZUJUEZJDUKZQULZGSFSXFDSXFUOUMUEDSUCUNZQTXCUPUEZUQZWQWRXB
      WLWMWNWRXBURWOWLWNUAZWRXBXJWRUAXHXAGUKZXBXJWJWKWNUBWRXKWJWKWNUSABCEFGHIJK
      LMNOUTVAXAXCGVBVFVCVDVGWPXEWLWRWPTVHUJUEZJDUKXEABCDJPVEXDXLJDXCVHTUJEGHIK
      NOVIVJVKVLVMWTXIXGQTUOUCZUQABCDEQFGHIJKLMNOPVNWTXGQXHXMXHXMUNWTEGHIKNOVOV
      QVRVPWLWSXBXEXIUBVSZWPWRWLGVTRDVTRXNGTHWAZUOIWAZUCVTOXOXPWBWCDTAWAZUOBWAZ
      VHCWAZWIVTPXQXRXSWDWCDQFGJVTLMVTWEWFWGWHVC $.

    $( Construction of a trail from two given edges in a graph.  (Contributed
       by Alexander van der Vekens, 4-Dec-2017.)  (Revised by Alexander van der
       Vekens, 1-Feb-2018.) $)
    constr2trl $p |- ( ( ( V e. X /\ E e. Y )
                          /\ ( A e. V /\ B e. V /\ C e. V ) )
             -> ( ( I =/= J /\ ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } )
                  -> F ( V Trails E ) P ) ) $=
      ( vk wcel cfv cc0 wa w3a wne cpr wceq ctrail co wbr chash cfzo cdm wf1 wf
      cfz cv c1 caddc wral wi simpll simpr adantr simpr1 3simpc adantl 2trllemE
      3jca syl3anc ex 3ad2antr2 imp c2 2trllemG 2trllemA oveq2i sylibr 2wlklem1
      feq2i sylan2 2trllemB a1i raleqdv mpbird wb cvv cop prex eqeltri ctp tpex
      istrl2 mpanr12 mpbir3and ) JLRZFMRZUAZAJRZBJRZCJRZUBZUAZHIUCZHFSABUDUEZIF
      SBCUDUEZUBZGDJFUFUGUHZXAXEUAZXFTGUISZUJUGZFUKGULZTXHUNUGZJDUMZQUOZGSFSXMD
      SXMUPUQUGDSUDUEZQXIURZXAXEXJWPWQWRXEXJUSWSWPWRUAZXEXJXPXEUAWNWOWRUBZXBXCX
      DUAZXJXPXQXEXPWNWOWRWNWOWRUTWPWOWRWNWOVAVBWPWRVAVGVBXPXBXCXDVCXEXRXPXBXCX
      DVDZVEABCEFGHIJKLMNOVFVHVIVJVKXAXLXEWTXLWPWTTVLUNUGZJDUMXLABCDJPVMXKXTJDX
      HVLTUNEGHIKNOVNVOVRVPVEVBXGXOXNQTUPUDZURZXEXAXRYBXSABCDEQFGHIJKLMNOPVQVSX
      GXNQXIYAXIYAUEXGEGHIKNOVTWAWBWCXAXFXJXLXOUBWDZXEWPYCWTWPGWERDWERYCGTHWFZU
      PIWFZUDWEOYDYEWGWHDTAWFZUPBWFZVLCWFZWIWEPYFYGYHWJWHDQFGJWELMWEWKWLVBVBWMV
      I $.

    $( A simple path of length 2 from one vertex to another vertex via a third
       vertex.  (Contributed by Alexander van der Vekens, 1-Feb-2018.) $)
    constr2spth $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V
                            /\ C e. V ) /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
             -> ( ( I =/= J /\ ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } )
                  -> F ( V SPaths E ) P ) ) $=
      ( wcel wa cvv cop w3a wne cfv cpr wceq cspath co wbr ccnv wfun constr2trl
      ctrail wi 3adant3 imp constr2spthlem1 3adant1 adantr wb cc0 c1 eqeltri c2
      prex ctp tpex pm3.2i jctr 3ad2ant1 isspth syl mpbir2and ex ) JLQFMQRZAJQB
      JQCJQUAZABUBACUBBCUBUAZUAZHIUBHFUCABUDUEIFUCBCUDUEUAZGDJFUFUGUHZVQVRRZVSG
      DJFULUGUHZDUIUJZVQVRWAVNVOVRWAUMVPABCDEFGHIJKLMNOPUKUNUOVQWBVRVOVPWBVNABC
      DJPUPUQURVTVNGSQZDSQZRZRZVSWAWBRUSVQWFVRVNVOWFVPVNWEWCWDGUTHTZVAITZUDSOWG
      WHVDVBDUTATZVABTZVCCTZVESPWIWJWKVFVBVGVHVIURDFGJSLMSVJVKVLVM $.

    $( A path of length 2 from one vertex to another vertex via a third
       vertex.  (Contributed by Alexander van der Vekens, 6-Dec-2017.)
       (Revised by Alexander van der Vekens, 31-Jan-2018.) $)
    constr2pth $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V /\ C e. V )
                         /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
             -> ( ( I =/= J /\ ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } )
                  -> F ( V Paths E ) P ) ) $=
      ( wcel wa c2 cvv w3a wne cfv cpr wceq cpath co wbr ctrail chash cfzo cres
      c1 ccnv wfun cc0 cin c0 wi constr2trl 3adant3 imp 2pthlem1 2trllemA oveq2
      cima wb reseq2d cnveqd funeqd ax-mp sylibr 3ad2ant2 adantr 2pthlem2 preq2
      imaeq2d ineq12d eqeq1d 3adantr2 3adant1 cop prex eqeltri tpex pm3.2i jctr
      ctp 3ad2ant1 ispth syl mpbir3and ex ) JLQFMQRZAJQBJQCJQUAZABUBZACUBZBCUBZ
      UAZUAZHIUBHFUCABUDUEIFUCBCUDUEUAZGDJFUFUGUHZWTXARZXBGDJFUIUGUHZDUMGUJUCZU
      KUGZULZUNZUOZDUPXEUDZVFZDXFVFZUQZURUEZWTXAXDWNWOXAXDUSWSABCDEFGHIJKLMNOPU
      TVAVBWTXIXAWOWNXIWSWODUMSUKUGZULZUNZUOZXIABCDJPVCXESUEZXIXRVGEGHIKNOVDZXS
      XHXQXSXGXPXSXFXODXESUMUKVEZVHVIVJVKVLVMVNWTXNXAWOWSXNWNWOWPWRXNWQWOWPWRRR
      DUPSUDZVFZDXOVFZUQZURUEZXNABCDJPVOXSXNYFVGXTXSXMYEURXSXKYCXLYDXSXJYBDXESU
      PVPVQXSXFXODYAVQVRVSVKVLVTWAVNXCWNGTQZDTQZRZRZXBXDXIXNUAVGWTYJXAWNWOYJWSW
      NYIYGYHGUPHWBZUMIWBZUDTOYKYLWCWDDUPAWBZUMBWBZSCWBZWHTPYMYNYOWEWDWFWGWIVND
      FGJTLMTWJWKWLWM $.
  $}

  $( A path of length 2 from one vertex to another vertex via a third vertex.
     (Contributed by Alexander van der Vekens, 6-Dec-2017.) $)
  2pthon $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V /\ C e. V )
                         /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
             -> ( ( i =/= j /\ ( E ` i ) = { A , B } /\ ( E ` j ) = { B , C } )
                  -> { <. 0 , i >. , <. 1 , j >. } ( A ( V PathOn E ) C )
                         { <. 0 , A >. , <. 1 , B >. , <. 2 , C >. } ) ) $=
    ( wcel wa w3a wne cfv wceq cc0 c1 c2 co cvv cv cpr cop ctp cpthon wbr cpath
    cwlkon cwalk chash ctrail wi vex pm3.2i eqid constr2trl 3adant3 syl3an3 imp
    trliswlk syl c0ex jctl 3ad2ant1 ax-1ne0 necomi 2ne0 fvtp1g sylancl 3ad2ant2
    simp2 adantr wn nesymi opth1 necon3bi ax-mp wb opex hashprg mp2an fveq2i cz
    mpbi 3ad2ant3 1ne2 fvtp3g syl5eq simpl1 prex tpex a1i 3simpb 3jca mpbir3and
    2z iswlkon constr2pth ispthon mpbir2and ex ) GHJFIJKZAGJZBGJZCGJZLZABMZACMZ
    BCMZLZLZDUAZEUAZMXLFNABUBOXMFNBCUBOLZPXLUCZQXMUCZUBZPAUCZQBUCZRCUCZUDZACGFU
    ESSUFZXKXNKZYBXQYAACGFUHSSUFZXQYAGFUGSUFZYCYDXQYAGFUISUFZPYANAOZXQUJNZYANZC
    OZYCXQYAGFUKSUFZYFXKXNYKXJXBXFXHXNYKULZXGXHXIVKXBXFYLXHABCYATFXQXLXMGTHIXLT
    JXMTJDUMZEUMUNZXQUOZYAUOZUPUQURUSYAFXQGUTVAXKYGXNXFXBYGXJXFPTJZXCKZPQMZPRMZ
    KYGXCXDYRXEXCYQVBVCVDYSYTQPVEVFRPVGVFZUNPQRABCTGVHVIVJVLYCYIRYANZCYHRYAXOXP
    MZYHROZPQOZVMUUCQPVEVNUUEXOXPPXLQXMVBYMVOVPVQXOTJXPTJUUCUUDVRPXLVSQXMVSXOXP
    TVTWAWDWBXKUUBCOZXNXFXBUUFXJXFRWCJZXEKZYTQRMZKUUFXEXCUUHXDXEUUGWPVCWEYTUUIU
    UAWFUNPQRABCWCGWGVIVJVLWHYCXBXQTJZYATJZKZXCXEKZLZYDYFYGYJLVRYCXBUULUUMXBXFX
    JXNWIUULYCUUJUUKXOXPWJXRXSXTWKUNWLXKUUMXNXFXBUUMXJXCXDXEWMVJVLWNZACYAFXQGTH
    ITWQVAWOXKXNYEABCYATFXQXLXMGTHIYNYOYPWRUSYCUUNYBYDYEKVRUUOACYAFXQGTHITWSVAW
    TXA $.

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d I i j $.  $d J i j $.
    $d E i j $.  $d V i j $.  $d X i j $.  $d Y i j $.
    $( A path of length 2 from one vertex to another vertex via a third
       vertex.  (Contributed by Alexander van der Vekens, 6-Dec-2017.) $)
    2pthoncl $p |- ( ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V /\ C e. V )
               /\ ( A =/= B /\ A =/= C /\ B =/= C ) ) /\ ( I e. _V /\ J e. _V )
          /\ ( I =/= J /\ ( E ` I ) = { A , B } /\ ( E ` J ) = { B , C } ) )
                        -> { <. 0 , I >. , <. 1 , J >. } ( A ( V PathOn E ) C )
                           { <. 0 , A >. , <. 1 , B >. , <. 2 , C >. } ) $=
      ( wcel w3a wne cvv cfv cpr wceq cc0 cop c1 wi vi vj wa c2 cpthon co neeq1
      ctp wbr cv fveq2 eqeq1d biidd 3anbi123d opeq2 preq1d breq1d imbi12d neeq2
      imbi2d preq2d 2pthon vtocl2g com12 3imp ) GHJDIJUCAGJBGJCGJKABLACLBCLKKZE
      MJFMJUCZEFLZEDNZABOZPZFDNZBCOZPZKZQERZSFRZOZQARSBRUDCRUHZACGDUEUFUFZUIZVG
      VFVOWATZVFUAUJZUBUJZLZWCDNZVJPZWDDNZVMPZKZQWCRZSWDRZOZVSVTUIZTZTVFEWDLZVK
      WIKZVPWLOZVSVTUIZTZTVFWBTUAUBEFMMWCEPZWOWTVFXAWJWQWNWSXAWEWPWGVKWIWIWCEWD
      UGXAWFVIVJWCEDUKULXAWIUMUNXAWMWRVSVTXAWKVPWLWCEQUOUPUQURUTWDFPZWTWBVFXBWQ
      VOWSWAXBWPVHVKVKWIVNWDFEUSXBVKUMXBWHVLVMWDFDUKULUNXBWRVRVSVTXBWLVQVPWDFSU
      OVAUQURUTABCUAUBDGHIVBVCVDVE $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d C f p $.  $d E f p $.  $d N f p $.
    $d V f p $.
    $( For a vertex adjacent to two other vertices there is a path of length 2
       between these other vertices.  (Contributed by Alexander van der Vekens,
       4-Dec-2017.) $)
    2pthon3v $p |- ( ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V /\ C e. V )
                    /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
                       /\ ( ( `' E ` { A , B } ) =/= ( `' E ` { B , C } )
                         /\ ( E ` ( `' E ` { A , B } ) ) = { A , B }
                         /\ ( E ` ( `' E ` { B , C } ) ) = { B , C } ) )
              -> E. f E. p ( f ( A ( V PathOn E ) C ) p /\ ( # ` f ) = 2 ) ) $=
      ( cc0 cfv cop c1 cvv wcel c2 wa w3a wne wceq cpr ccnv ctp cpthon co chash
      wbr cv prex tpex pm3.2i fvex 2pthoncl mp3an2 wn ax-1ne0 nesymi c0ex opth1
      wex necon3bi ax-mp wb opex hashprg mp2an jctir breq12 fveq2 eqeq1d adantr
      mpbi anbi12d spc2egv mpsyl ) JABUAZEUBZKZLZMBCUAZVQKZLZUAZNOZJALZMBLZPCLZ
      UCZNOZQFGOEHOQAFOBFOCFORABSACSBCSRRZVRWASVREKVPTWAEKVTTRZQZWCWHACFEUDUEUE
      ZUGZWCUFKZPTZQZDUHZIUHZWMUGZWRUFKZPTZQZIUTDUTWDWIVSWBUIWEWFWGUJUKWLWNWPWJ
      VRNOZWANOZQWKWNXDXEVPVQULZVTVQULUKABCEVRWAFGHUMUNVSWBSZWPJMTZUOXGMJUPUQXH
      VSWBJVRMWAURXFUSVAVBVSNOWBNOXGWPVCJVRVDMWAVDVSWBNVEVFVLVGXCWQDIWCWHNNWRWC
      TZWSWHTZQWTWNXBWPWRWCWSWHWMVHXIXBWPVCXJXIXAWOPWRWCUFVIVJVKVMVNVO $.
  $}

  $( Lemma for ~ redwlk .  (Contributed by Alexander van der Vekens,
     1-Nov-2017.) $)
  redwlklem $p |- ( ( F ( V Walks E ) P /\ 1 <_ ( # ` F ) )
       -> ( # ` ( F |` ( 0 ..^ ( ( # ` F ) - 1 ) ) ) ) = ( ( # ` F ) - 1 ) ) $=
    ( co wbr c1 chash cfv cc0 cfzo wceq wcel wf wa wi cn0 wfn adantr syl adantl
    cwalk cle cmin cres cdm cword cfz 2mwlk lencl ffn wss fzossrbm1 wb fnssresb
    wrdf mpbird hashfn 1nn0 nn0sub2 mp3an1 hashfzo0 eqtrd ex 3syl mpand imp ) C
    ADBUBEFZGCHIZUCFZCJVIGUDEZKEZUEZHIZVKLZVHCBUFZUGMZJVIUHEDANZOVJVOPZABCDUIVQ
    VSVRVQVIQMZVJVOVPCUJVQJVIKEZVPCNCWARZVTVJOZVOPVPCUPWAVPCUKWBWCVOWBWCOZVNVLH
    IZVKWDVMVLRZVNWELWDWFVLWAULZWCWGWBVTWGVJVIUMSUAWBWFWGUNWCWAVLCUOSUQVLVMURTW
    CWEVKLZWBWCVKQMZWHGQMVTVJWIUSGVIUTVAVKVBTUAVCVDVEVFSTVG $.

  ${
    $d E k $.  $d F k $.  $d P k $.  $d V k $.
    $( A walk ending at the last but one vertex of the walk is a walk.
       (Contributed by Alexander van der Vekens, 1-Nov-2017.) $)
    redwlk $p |- ( ( F ( V Walks E ) P /\ 1 <_ ( # ` F ) )
            -> ( F |` ( 0 ..^ ( ( # ` F ) - 1 ) ) ) ( V Walks E )
               ( P |` ( 0 ..^ ( # ` F ) ) ) ) $=
      ( vk co c1 cfv cc0 cfzo wcel cvv wa wi cfz wf wceq wral syl ex cwalk cmin
      wbr chash cle cres cn0 w3a wlkbprop cdm cword cv caddc iswlk 3adant1 wrdf
      cpr wb fzossrbm1 fssres sylan2 iswrdi com12 3ad2ant1 adantr simpr fzossfz
      wss sylancl redwlklem cz nn0z fzoval adantl simpl oveq2d eqtr4d imp feq2d
      sylibd ssralv fvres eqcomd fveq2d sselda cuz 1nn0 elnn0uz fzoss1 ax-mp 1z
      mpbi a1i fzoaddel2 syl3anc sseldi preq12d eqeq12d 3ad2antl1 ralimdva syld
      biimpd oveq2 raleqdv impcom 3anim123d expimpd resexg anim2i bicomd sylbid
      anim12i exp3acom23 mpcom anabsi5 ) CADBUAFZUCZGCUDHZUEUCZCIXRGUBFZJFZUFZA
      IXRJFZUFZXPUCZXRUGKZDLKBLKMZCLKZALKZMZUHZXQXQXSMZYENZABCDUIYKXQCBUJZUKZKZ
      IXROFZDAPZEULZCHZBHZYSAHZYSGUMFZAHZUQZQZEYCRZUHZYMYGYJXQUUHURYFAEBCDLLLLU
      NUOYKYLUUHYEYKYLUUHMYBYOKZIYBUDHZOFZDYDPZYSYBHZBHZYSYDHZUUCYDHZUQZQZEIUUJ
      JFZRZUHZYEYKYLUUHUVAYKYLMZYPUUIYRUULUUGUUTYKYPUUINZYLYFYGUVCYJYPYFUUIYPYC
      YNCPZYFUUINYNCUPUVDYFUUIUVDYFMYAYNYBPZUUIYFUVDYAYCVHZUVEXRUSZYCYNYACUTVAY
      NXTYBVBSTSVCVDVEUVBYRYCDYDPZUULUVBYRUVHUVBYRMYRYCYQVHUVHUVBYRVFIXRVGYQDYC
      AUTVITUVBYCUUKDYDYKYLYCUUKQZYFYGYLUVINYJYLYFUVIYLUUJXTQZYFUVINABCDVJZUVJY
      FUVIUVJYFMZYCIXTOFZUUKYFYCUVMQZUVJYFXRVKKZUVNXRVLZIXRVMSVNUVLUUJXTIOUVJYF
      VOVPVQTSVCVDVRVSVTYLYKUUGUUTNZYLUVJYKUVQNUVKUVJYKUVQUVJYKMUUGUUREYARZUUTY
      KUUGUVRNUVJYKUUGUUFEYARZUVRYKUVFUUGUVSNYFYGUVFYJUVGVDUUFEYAYCWASYKUUFUURE
      YAYFYGYSYAKZUUFUURNYJYFUVTMZUUFUURUWAUUAUUNUUEUUQUWAYTUUMBUWAUUMYTUVTUUMY
      TQYFYSYACWBVNWCWDUWAUUBUUOUUDUUPUWAUUOUUBUWAYSYCKUUOUUBQYFYAYCYSUVGWEYSYC
      AWBSWCUWAUUPUUDUWAUUCYCKUUPUUDQUWAGXRJFZYCUUCGIWFHKZUWBYCVHGUGKUWCWGGWHWL
      GIXRWIWJUWAUVTUVOGVKKZUUCUWBKYFUVTVFYFUVOUVTUVPVEUWDUWAWKWMYSXRGWNWOWPUUC
      YCAWBSWCWQWRXBWSWTXAVNUVJUVRUUTURYKUVJUUREYAUUSUVJUUSYAUUJXTIJXCWCXDVEVTT
      SXEXFXGYKYGYBLKZYDLKZMZMZUVAYEURYGYJUWHYFYJUWGYGYHUWEYIUWFCYALXHAYCLXHXLX
      IUOUWHYEUVAYDEBYBDLLLLUNXJSVTXMXKXNXO $.
  $}

  ${
    $d F k x y $.  $d E k x y $.  $d P k x y $.  $d V x y $.
    $( Lemma for ~ wlkdvspth .  (Contributed by Alexander van der Vekens,
       27-Oct-2017.) $)
    wlkdvspthlem $p |- ( ( F e. Word dom E /\ P : ( 0 ... ( # ` F ) ) -1-1-> V
                 /\ A. k e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` k )
                    ) = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) -> Fun `' F ) $=
      ( vx vy wcel cc0 cfv co c1 caddc wceq wi wa syl ex wb c2 cdm cword cfz cv
      chash wf1 cpr cfzo wral w3a ccnv wfun wf weq wrdf 3ad2ant1 wn fveq2 oveq1
      fveq2d preq12d eqeq12d rspcva pm3.2 com3r impancom pm2.43a impcom syl6com
      eqtr2 eqcoms com23 imp elfzofz anim2i ancoms f1fveq notbid biimparc simpr
      anim12i fzofzp1 adantr syl2anc elfzoelz zcnd ad2antrr adantl a1i addcan2d
      cc ax-1cn bitrd syl6bir com13 wo fvex preq12b pm2.24 im2anan9r ax-1 sylbi
      jaoi anim12ci sylan2 biimpd biimpa eqeq1d 3jca addass 1p1e2 oveq2i eqeq1i
      cmin cz zcn 2cn jctir subcan2 bicomd 3syl pncan2 subidd syl5bb 3bitrd wne
      addcl 2ne0 df-ne pm2.21 ax-mp syl6bi expcom syl6 syl8 com14 pm2.43i com15
      mpd 3imp pm2.61d2 ralrimivv syl3an1 dff13 sylanbrc biantrurd df-f1 mpbird
      a1d syl6bbr ) DCUAZUBHZIDUEJZUCKZEAUFZBUDZDJZCJZUUPAJZUUPLMKZAJZUGZNZBIUU
      MUHKZUIZUJZDUKULZUVDUUKDUFZUVFUVDUUKDUMZFUDZDJZGUDZDJZNZFGUNZOZGUVDUIFUVD
      UIZUVHUULUUOUVIUVEUUKDUOZUPZUULUVIUUOUVEUVQUVRUVIUUOUVEUJZUVPFGUVDUVDUVTU
      VOUVJUVDHZUVLUVDHZPZUVPOZUVIUUOUVEUVOUQZUWDOZUUOUVEUWFOOUVIUWCUVEUWEUUOUV
      PUWCUVEUWEUUOUVPOOZUWCUVEPUVMCJZUVLAJZUVLLMKZAJZUGZNZUVKCJZUVJAJZUVJLMKZA
      JZUGZNZPZUWGUVEUWCUWTUWCUVEUWTUWCUVEUVEUWTUWAUVEUWBUVEUWTOZUWAUVEPUWSUWBU
      XAOUVCUWSBUVJUVDBFUNZUURUWNUVBUWRUXBUUQUVKCUUPUVJDURUTUXBUUSUWOUVAUWQUUPU
      VJAURUXBUUTUWPAUUPUVJLMUSUTVAVBVCUWBUVEUWSUWTUWBUVEUWSUWTOZUWBUVEPUWMUXCU
      VCUWMBUVLUVDBGUNZUURUWHUVBUWLUXDUUQUVMCUUPUVLDURUTUXDUUSUWIUVAUWKUUPUVLAU
      RUXDUUTUWJAUUPUVLLMUSUTVAVBVCUWMUWSVDQRVEQVFVEVGVHUWCUWTUWGOUVEUVNUWTUWEU
      UOUWCUVOUVNUWNUWHNZUWTUWEUUOUWCUVOOOOZOUVKUVMCURUWTUXEUWLUWRNZUXFUWMUWSUX
      EUXGOUWMUXEUWSUXGUXEUWMUWNUWLNZUWSUXGOUWMUXHOUWHUWNUWHUWNNUWMUXHUWHUWNUWL
      VJRVKUXHUWSUXGUWNUWLUWRVJRVIVLVMUWCUWEUUOUXGUVOUWCUUOUWEUXGUVOOZUWCUUOUWE
      UXIOZUWCUUOPZUXJUXKUXKUXJUWEUXKUXKUXKUXIUXKUWEUXKUXKUXIOZOZUWEUXKUWEUXMOU
      WEUXKPZUWEUXKUWQUWKNZUQZUWOUWINZUQZPZUXLUXNUXRUWEUXKUXSOOUXKUXRUWEUXKUXQU
      VOUXKUUOUVJUUNHZUVLUUNHZPZPZUXQUVOSUUOUWCUYCUWCUYBUUOUWAUXTUWBUYAUVJIUUMV
      NZUVLIUUMVNZWAVOVPUUNEUVJUVLAVQQVRVSUXKUWEUXRUXSUXKUWEUXPUXRUXSOUXKUXOUVO
      UXKUXOUWPUWJNZUVOUXKUUOUWPUUNHZUWJUUNHZPZUXOUYFSUWCUUOVTUWCUYIUUOUWAUYGUW
      BUYHIUUMUVJWBZIUUMUVLWBZWAWCUUNEUWPUWJAVQWDUXKUVJUVLLUWAUVJWKHZUWBUUOUWAU
      VJUVJIUUMWEZWFZWGUWCUVLWKHZUUOUWBUYOUWAUWBUVLUVLIUUMWEWFWHWCLWKHZUXKWLWIW
      JWMVRUXPUXRVDWNWOQUXSUXGUXKUVOUXGUXSUWIUWQNZUWKUWONZPZUXKUVOOZUXGUWIUWONZ
      UWKUWQNZPZUYSWPUXSUYSOZUWIUWKUWOUWQUVLAWQUWJAWQUVJAWQUWPAWQWRVUCVUDUYSVUB
      UXPUYQVUAUXRUYRUXPUYQOUWQUWKUXOUYQWSVKUXRUYROUWOUWIUXQUYRWSVKWTUYSUXSXAXC
      XBUYQUYRUYTUXKUYRUYQUVOUYRUXKUYQUVOOZUXKUYRUWJUVJNZUXKVUEOUUOUWCUYRVUFOUU
      OUWCPUYRVUFUWCUUOUYHUXTPUYRVUFSUWAUXTUWBUYHUYDUYKXDUUNEUWJUVJAVQXEXFVPUYQ
      UXKVUFUVOUXKUYQVUFUVOOZUXKUYQPUVLUWPNZVUGUXKUYQVUHUUOUWCUYQVUHSZUWCUUOUYA
      UYGPVUIUWAUYGUWBUYAUYJUYEXDUUNEUVLUWPAVQXEVPXGUWCVUHVUGOUUOUYQUWCVUHVUGUW
      CVUHPZVUFTINZUVOVUJVUFUWPLMKZUVJNZUVJLLMKZMKZUVJNZVUKVUHVUFVUMSUWCVUHUWJV
      ULUVJUVLUWPLMUSXHWHVUJUYLUYPUYPUJZVUMVUPSUWAVUQUWBVUHUWAUYLUYPUYPUYNUYPUW
      AWLWIZVURXIWGVUQVULVUOUVJUVJLLXJXHQUWAVUPVUKSUWBVUHVUPUVJTMKZUVJNZUWAVUKV
      UOVUSUVJVUNTUVJMXKXLXMUWAVUTVUSUVJXNKZUVJUVJXNKZNZVUKUWAUVJXOHZVUSWKHZUYL
      UYLUJZVUTVVCSUYMVVDVVEUYLUYLVVDUYLTWKHZPZVVEVVDUYLVVGUVJXPZXQXRZUVJTYGQVV
      IVVIXIVVFVVCVUTVUSUVJUVJXSXTYAUWAVVATVVBIUWAVVDVVHVVATNUYMVVJUVJTYBYAUWAU
      VJUYNYCVBWMYDWGYETIYFZVUKUVOOZYHVVKVUKUQVVLTIYIVUKUVOYJXBYKYLRWGYSYMWOYNV
      GWOVMVIVLYORVGYPVGYQRVLYPVIQYRWCYSRYPWIYTUVOUVPUWCUVOUVNXAUUIUUAUUBUUCFGU
      VDUUKDUUDUUEUVFUVGUVIUVGPUVHUVFUVIUVGUVSUUFUVDUUKDUUGUUJUUH $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.  $d e f k p v $.
    $( A walk consisting of different vertices is a simple path.  (Contributed
       by Alexander van der Vekens, 27-Oct-2017.) $)
    wlkdvspth $p |- ( ( F ( V Walks E ) P /\ Fun `' P )
                      -> F ( V SPaths E ) P ) $=
      ( vf ve vv vp vk co wbr cvv wcel wa wi cv cc0 cfv w3a wb ccnv wfun cspath
      cwalk cdm cword chash cfz wf caddc cpr wceq cfzo df-wlk brovmpt2ex ctrail
      c1 wral simpr1 wf1 df-f1 wlkdvspthlem 3exp com3l sylbir expcom com14 3imp
      com12 adantl imp jca simpr2 simpr3 3jca iswlk adantr istrl 3imtr4d jctird
      ex simpr isspth bicomd sylibd com23 mpcom ) CADBUDJKZAUAUBZCADBUCJKZDLMBL
      MNCLMALMNNZWHWIWJOEPZFPZUEUFMQWLUGRZUHJGPHPZUIIPZWLRWMRWPWORWPUQUJJZWORUK
      ULIQWNUMJURSGFEHABCUDDGFEIHUNUOWKWIWHWJWKWIWHWJOWKWINZWHCADBUPJKZWINZWJWR
      WHWSWIWRCBUEUFMZQCUGRZUHJZDAUIZWPCRBRWPARWQARUKULIQXBUMJURZSZXACUAUBZNZXD
      XESZWHWSWRXFXIWRXFNZXHXDXEXJXAXGWRXAXDXEUSWRXFXGWIXFXGOWKXFWIXGXAXDXEWIXG
      OWIXDXEXAXGXDWIXEXAXGOOZXDWINXCDAUTZXKXCDAVAXAXLXEXGXAXLXEXGAIBCDVBVCVDVE
      VFVGVHVIVJVKVLWRXAXDXEVMWRXAXDXEVNVOWAWKWHXFTWIAIBCDLLLLVPVQWKWSXITWIAIBC
      DLLLLVRVQVSWKWIWBVTWKWTWJTWIWKWJWTABCDLLLLWCWDVQWEWAWFWGVK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
               Circuits and cycles
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d E e f p v $.  $d V e f p v $.
    $( The set of circuits (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 30-Oct-2017.) $)
    crcts $p |- ( ( V e. X /\ E e. Y ) -> ( V Circuits E ) = { <. f , p >. |
                 ( f ( V Trails E ) p /\ ( p ` 0 ) = ( p ` ( # ` f ) ) ) } ) $=
      ( vv ve wcel cvv ccrct co cv ctrail wbr cc0 cfv wceq wa elex chash cdm wf
      copab cword cfz df-crct biidd cwalk trliswlk 2mwlk a1i syl5 adantl wrdexg
      wi dmexg syl cfn cab fzfi simpll mapex sylancr opabex3d sprmpt2 syl2an )
      CDICJIZBJIZCBKLAMZFMZCBNLOZPVKQVJUAQZVKQRZSAFUDRBEICDTBETVNVNVJBUBZUEZIZP
      VMUFLZCVKUCZSZGHABKCNFGHAFUGGMCRHMBRSVNUHVLVJVKCBUILOZVHVISZVTVKBVJCUJWAV
      TUPWBVKBVJCUKULUMWBVSAFVPWBVOJIZVPJIVIWCVHBJUQUNVOJUOURWBVQSVRUSIVHVSFUTJ
      IPVMVAVHVIVQVBVRCUSJFVCVDVEVFVG $.

    $( The set of cycles (in an undirected graph).  (Contributed by Alexander
       van der Vekens, 30-Oct-2017.) $)
    cycls $p |- ( ( V e. X /\ E e. Y ) -> ( V Cycles E ) = { <. f , p >. |
                 ( f ( V Paths E ) p /\ ( p ` 0 ) = ( p ` ( # ` f ) ) ) } ) $=
      ( vv ve wcel cvv ccycl co cv cpath wbr cc0 cfv wceq wa elex chash cdm cfz
      copab cword wf df-cycl biidd cwalk ctrail pthistrl trliswlk syl 2mwlk a1i
      wi syl5 dmexg adantl wrdexg cfn cab simpll mapex sylancr opabex3d sprmpt2
      fzfi syl2an ) CDICJIZBJIZCBKLAMZFMZCBNLOZPVMQVLUAQZVMQRZSAFUDRBEICDTBETVP
      VPVLBUBZUEZIZPVOUCLZCVMUFZSZGHABKCNFGHAFUGGMCRHMBRSVPUHVNVLVMCBUILOZVJVKS
      ZWBVNVLVMCBUJLOWCVMBVLCUKVMBVLCULUMWCWBUPWDVMBVLCUNUOUQWDWAAFVRWDVQJIZVRJ
      IVKWEVJBJURUSVQJUTUMWDVSSVTVAIVJWAFVBJIPVOVHVJVKVSVCVTCVAJFVDVEVFVGVI $.
  $}

  ${
    $d E f p $.  $d F f p $.  $d P f p $.  $d V f p $.
    $( Properties of a pair of functions to be a circuit (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 30-Oct-2017.) $)
    iscrct $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
                  -> ( F ( V Circuits E ) P <-> ( F ( V Trails E ) P
                         /\ ( P ` 0 ) = ( P ` ( # ` F ) ) ) ) ) $=
      ( vp vf wcel wa ccrct co wbr cc0 cfv chash wceq cv ctrail wb crcts adantl
      fveq1 simpr fveq2 adantr fveq12d eqeq12d isprmpt2 imp ) DFKBGKLZCEKAHKLCA
      DBMNZOCADBUANZOPAQZCRQZAQZSZLUBUMPITZQZJTZRQZUTQZSUSAJCUNUOEHIJBDFGIUCVBC
      SZUTASZLZVAUPVDURVFVAUPSVEPUTAUEUDVGVCUQUTAVEVFUFVEVCUQSVFVBCRUGUHUIUJUKU
      L $.

    $( Properties of a pair of functions to be a cycle (in an undirected
       graph).  (Contributed by Alexander van der Vekens, 30-Oct-2017.) $)
    iscycl $p |- ( ( ( V e. X /\ E e. Y ) /\ ( F e. W /\ P e. Z ) )
                  -> ( F ( V Cycles E ) P <-> ( F ( V Paths E ) P
                         /\ ( P ` 0 ) = ( P ` ( # ` F ) ) ) ) ) $=
      ( vp vf wcel wa ccycl co wbr cc0 cfv chash wceq cv cpath wb adantl adantr
      cycls fveq1 simpr fveq2 fveq12d eqeq12d isprmpt2 imp ) DFKBGKLZCEKAHKLCAD
      BMNZOCADBUANZOPAQZCRQZAQZSZLUBUMPITZQZJTZRQZUTQZSUSAJCUNUOEHIJBDFGIUEVBCS
      ZUTASZLZVAUPVDURVFVAUPSVEPUTAUFUCVGVCUQUTAVEVFUGVEVCUQSVFVBCRUHUDUIUJUKUL
      $.
  $}

  $( A pair of an empty set (of edges) and a second set (of vertices) is a
     circuit if and only if the second set contains exactly one vertex (in an
     undirected graph).  (Contributed by Alexander van der Vekens,
     30-Oct-2017.) $)
  0crct $p |- ( ( ( V e. X /\ E e. Y ) /\ P e. Z )
                -> ( (/) ( V Circuits E ) P <-> P : ( 0 ... 0 ) --> V ) ) $=
    ( wcel wa c0 ccrct co wbr ctrail cc0 cfv chash wceq cfz wf cvv wb 0ex hash0
    iscrct mpanr1 0trl anbi1d eqcomi a1i fveq2d pm4.71i syl6bbr bitrd ) CDGBEGH
    ZAFGZHZIACBJKLZIACBMKLZNAOIPOZAOQZHZNNRKCASZUNITGUOUQVAUAUBABICTDEFUDUEUPVA
    VBUTHVBUPURVBUTABCDEFUFUGVBUTVBNUSANUSQVBUSNUCUHUIUJUKULUM $.

  $( A pair of an empty set (of edges) and a second set (of vertices) is a
     cycle if and only if the second set contains exactly one vertex (in an
     undirected graph).  (Contributed by Alexander van der Vekens,
     30-Oct-2017.) $)
  0cycl $p |- ( ( ( V e. X /\ E e. Y ) /\ P e. Z )
                -> ( (/) ( V Cycles E ) P <-> P : ( 0 ... 0 ) --> V ) ) $=
    ( wcel wa c0 ccycl co wbr cpath cc0 cfv chash wceq cfz wf cvv wb 0ex iscycl
    mpanr1 0pth anbi1d hash0 eqcomi a1i fveq2d pm4.71i syl6bbr bitrd ) CDGBEGHZ
    AFGZHZIACBJKLZIACBMKLZNAOIPOZAOQZHZNNRKCASZUNITGUOUQVAUAUBABICTDEFUCUDUPVAV
    BUTHVBUPURVBUTABCDEFUEUFVBUTVBNUSANUSQVBUSNUGUHUIUJUKULUM $.

  ${
    $d e f p v $.
    $( A circuit is a trail.  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    crctistrl $p |- ( F ( V Circuits E ) P -> F ( V Trails E ) P ) $=
      ( vf vp vv ve cvv wcel wa ccrct co wbr ctrail cv cc0 cfv chash wceq simpl
      df-crct brovmpt2ex iscrct syl6bi mpcom ) DIJBIJKCIJAIJKKZCADBLMNZCADBOMNZ
      EPZFPZGPHPOMNQUKRUJSRUKRTKGHEFABCLDGHEFUBUCUGUHUIQARCSRARTZKUIABCDIIIIUDU
      IULUAUEUF $.

    $( A cycle is a path.  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    cyclispth $p |- ( F ( V Cycles E ) P -> F ( V Paths E ) P ) $=
      ( vf vp vv ve cvv wcel wa ccycl co wbr cpath cv cc0 cfv chash wceq iscycl
      df-cycl brovmpt2ex simpl syl6bi mpcom ) DIJBIJKCIJAIJKKZCADBLMNZCADBOMNZE
      PZFPZGPHPOMNQUKRUJSRUKRTKGHEFABCLDGHEFUBUCUGUHUIQARCSRARTZKUIABCDIIIIUAUI
      ULUDUEUF $.

    $( A cycle is a circuit.  (Contributed by Alexander van der Vekens,
       30-Oct-2017.) $)
    cycliscrct $p |- ( F ( V Cycles E ) P -> F ( V Circuits E ) P ) $=
      ( vf vp vv ve cvv wcel wa ccycl co wbr cv cpath cc0 cfv chash wceq ctrail
      ccrct df-cycl brovmpt2ex pthistrl a1i anim1d iscycl iscrct 3imtr4d mpcom
      wi ) DIJBIJKCIJAIJKKZCADBLMNZCADBUBMNZEOZFOZGOHOPMNQUQRUPSRUQRTKGHEFABCLD
      GHEFUCUDUMCADBPMNZQARCSRARTZKCADBUAMNZUSKUNUOUMURUTUSURUTULUMABCDUEUFUGAB
      CDIIIIUHABCDIIIIUIUJUK $.

    $( A (non trivial) cycle is not a simple path.  (Contributed by Alexander
       van der Vekens, 30-Oct-2017.) $)
    cyclnspth $p |- ( F =/= (/)
                      -> ( F ( V Cycles E ) P -> -. F ( V SPaths E ) P ) ) $=
      ( vf vp vv co wbr wn cvv wcel wa wi cv cc0 cfv adantr imp ex ve ccycl wne
      c0 cspath cpath chash wceq df-cycl brovmpt2ex iscycl ctrail ccnv wfun cdm
      cwalk cword cfz wf pthistrl trliswlk 2mwlk lennncl wf1 df-f1 nnne0 necomd
      cn neneqd wb simpr cn0 nnnn0 cle 0nn0 a1i nn0ge0 elfz2nn0 syl3anbrc nn0re
      leidd jca syl f1fveq syl2anc mtbird expcom sylbir com13 con2d com23 com24
      id 4syl adantl intnand isspth sylbid mpcom com12 ) CADBUBHIZCUDUCZCADBUEH
      IZJZDKLBKLMCKLAKLMMZXAXBXDNZEOZFOZGOUAOUFHIPXHQXGUGQXHQUHMGUAEFABCUBDGUAE
      FUIUJXEXACADBUFHIZPAQCUGQZAQUHZMZXFABCDKKKKUKXEXLXFXEXLMZXBXDXMXBMZXCCADB
      ULHIZAUMUNZMZXNXPXOXMXBXPJZXLXBXRNZXEXIXKXSXIXOCADBUPHICBUOZUQLZPXJURHZDA
      USZMXKXSNZABCDUTABCDVAABCDVBYAYCYDYAXBXKYCXRYAXBXKYCXRNNZYAXBMXJVHLZYEXTC
      VCYFYCXKXRYFYCXKXRNYFYCMXPXKYFYCXPXKJZNXPYCYFYGYCXPYFYGNZYCXPMYBDAVDZYHYB
      DAVEYFYIYGYFYIMZXKPXJUHZYFYKJYIYFPXJYFXJPXJVFVGVIRYJYIPYBLZXJYBLZMZXKYKVJ
      YFYIVKYFYNYIYFXJVLLZYNXJVMYOYLYMYOPVLLZYOPXJVNIYLYPYOVOVPYOWMZXJVQPXJVRVS
      YOYOYOXJXJVNIYMYQYQYOXJXJVTWAXJXJVRVSWBWCRYBDPXJAWDWEWFWGWHWGWISWJTWKWCTW
      LSWNSWOSWPXMXCXQVJZXBXEYRXLABCDKKKKWQRRWFTTWRWSWT $.
  $}

  $( A cycle is a walk.  (Contributed by Alexander van der Vekens,
     7-Nov-2017.) $)
  cycliswlk $p |- ( F ( V Cycles E ) P -> F ( V Walks E ) P ) $=
    ( ccycl co wbr cpath ctrail cwalk cyclispth pthistrl trliswlk 3syl ) CADBEF
    GCADBHFGCADBIFGCADBJFGABCDKABCDLABCDMN $.

  $( A cycle is a path starting and ending at its first vertex.  (Contributed
     by Alexander van der Vekens, 8-Nov-2017.) $)
  cyclispthon $p |- ( F ( V Cycles E ) P
                      -> F ( ( P ` 0 ) ( V PathOn E ) ( P ` 0 ) ) P ) $=
    ( ccycl co wbr cc0 cfv wa syl cn0 wcel cvv w3a wi mpbird jca id 3syl cpthon
    cwlkon cpath chash cwalk wlkonwlk wceq wlkbprop iscycl simpr syl6bi 3adant1
    cycliswlk mpcom oveq2d breqd cyclispth wb simpl2 simpl3 cdm cword cfz 2mwlk
    wf cle 0nn0 a1i nn0ge0 elfz2nn0 syl3anbrc anim2i ffvelrn ex adantl 3ad2ant1
    com12 imp 3jca mpancom ispthon ) CADBEFGZCAHAIZWCDBUAFFGZCAWCWCDBUBFZFZGZCA
    DBUCFGZJZWBWGWHWBWGCAWCCUDIZAIZWEFZGZWBCADBUEFGZWMABCDUMZABCDUFKWBWFWLCAWBW
    CWKWCWEWJLMZDNMBNMJZCNMANMJZOZWBWCWKUGZWBWNWSWOABCDUHZKWQWRWBWTPWPWQWRJWBWH
    WTJWTABCDNNNNUIWHWTUJUKULUNUOUPQABCDUQRWBWNWQWRWCDMZXBJZOZWDWIURWOWSWNXDXAW
    SWNJWQWRXCWPWQWRWNUSWPWQWRWNUTWSWNXCWPWQWNXCPWRWNWPXCWNCBVAVBMZHWJVCFZDAVEZ
    JWPXCPZABCDVDXGXHXEXGWPXCXGWPJXGHXFMZJXBXCWPXIXGWPHLMZWPHWJVFGXIXJWPVGVHWPS
    WJVIHWJVJVKVLXFDHAVMXBXBXBXBSZXKRTVNVOKVQVPVRVSVTWCWCABCDNNNNWATQ $.

  $( If a class is a function, then also its "shifted function" is a function.
     (Contributed by Alexander van der Vekens, 23-Nov-2017.) $)
  fargshiftlem $p |- ( ( N e. NN0 /\ X e. ( 0 ..^ N ) )
                         -> ( X + 1 ) e. ( 1 ... N ) ) $=
    ( cn0 wcel cc0 cfzo co wa c1 caddc cfz cz 1z fzoaddel mpan2 adantl wb 0p1e1
    oveq1i wceq nn0z fzval3 eqcomd syl syl5eq eleq2d adantr mpbid ) ACDZBEAFGDZ
    HBIJGZEIJGZAIJGZFGZDZUKIAKGZDZUJUOUIUJILDUOMBEAINOPUIUOUQQUJUIUNUPUKUIUNIUM
    FGZUPULIUMFRSUIALDZURUPTAUAUSUPURIAUBUCUDUEUFUGUH $.

  ${
    $d F x $.  $d E x $.  $d X x $.
    fargshift.g $e |- G = ( x e. ( 0 ..^ ( # ` F ) ) |-> ( F ` ( x + 1 ) ) ) $.
    $( If a class is a function, then the values of the "shifted function"
       correspond to the function values of the class.  (Contributed by
       Alexander van der Vekens, 23-Nov-2017.) $)
    fargshiftfv $p |- ( ( N e. NN0 /\ F : ( 1 ... N ) --> dom E )
                  -> ( X e. ( 0 ..^ N ) -> ( G ` X ) = ( F ` ( X + 1 ) ) ) ) $=
      ( cn0 wcel c1 cfz co cdm wa cc0 cfzo cfv caddc wceq cvv wfn ffn fseq1hash
      wf chash wi oveq2 eqcoms eleq2d biimpd syl sylan2 imp oveq1 fveq2d fvmptg
      fvex cv sylancl ex ) EHIZJEKLZBMZCUDZNZFOEPLZIZFDQFJRLZCQZSZVEVGNFOCUEQZP
      LZIZVITIVJVEVGVMVDVACVBUAZVGVMUFZVBVCCUBVAVNNVKESZVOCEUCVPVGVMVPVFVLFVFVL
      SEVKEVKOPUGUHUIUJUKULUMVHCUQAFAURZJRLZCQVIVLTDVQFSVRVHCVQFJRUNUOGUPUSUT
      $.

    $( If a class is a function, then also its "shifted function" is a
       function.  (Contributed by Alexander van der Vekens, 23-Nov-2017.) $)
    fargshiftf $p |- ( ( N e. NN0 /\ F : ( 1 ... N ) --> dom E )
                     -> G : ( 0 ..^ ( # ` F ) ) --> dom E ) $=
      ( cn0 wcel c1 cfz co cdm wf wa cv caddc cfv cc0 chash wceq cfzo fseq1hash
      wral wfn ffn sylan2 eleq1 oveq2 feq2d anbi12d eqcoms fargshiftlem ffvelrn
      wb wi expcom syl impancom ralrimiv syl6bi mpcom fmpt sylib ) EGHZIEJKZBLZ
      CMZNZAOZIPKZCQZVFHZARCSQZUAKZUCZVNVFDMVMETZVHVOVGVDCVEUDVPVEVFCUECEUBUFVP
      VHVMGHZIVMJKZVFCMZNZVOVHVTUNEVMEVMTZVDVQVGVSEVMGUGWAVEVRVFCEVMIJUHUIUJUKV
      TVLAVNVQVIVNHZVSVLVQWBNVJVRHZVSVLUOVMVIULVSWCVLVRVFVJCUMUPUQURUSUTVAAVNVF
      VKDFVBVC $.

    $d F k l x y z $.  $d E y z $.  $d G y z $.
    $( If a function is 1-1, then also the shifted function is 1-1.
       (Contributed by Alexander van der Vekens, 23-Nov-2017.) $)
    fargshiftf1 $p |- ( ( N e. NN0 /\ F : ( 1 ... N ) -1-1-> dom E )
                     -> G : ( 0 ..^ ( # ` F ) ) -1-1-> dom E ) $=
      ( vy vz vk vl wcel c1 co wa cfv wceq wi adantl adantr impcom cn0 cfz cfzo
      cdm wf1 cc0 chash wf cv weq f1f fargshiftf sylan2 wfn ffn fseq1hash eleq1
      wral wb oveq2 f1eq2 syl anbi12d dff13 caddc fargshiftlem anim12dan eqeq1d
      fveq2 eqeq1 imbi12d eqeq2d eqeq2 rspc2v fargshiftfv expcom eqeq12d cc w3a
      com13 elfzoelz zcnd ax-1cn a1i 3jca addcan2 imbi2d biimpa sylbid ex exp31
      syld com24 imp mpd ralrimdvv sylbi syl6bir mpcom sylanbrc ) EUAKZLEUBMZBU
      DZCUEZNZUFCUGOZUCMZXCDUHZGUIZDOZHUIZDOZPZGHUJZQZHXGURGXGURZXGXCDUEXDXAXBX
      CCUHZXHXBXCCUKZABCDEFULUMXFEPZXEXPXDXAXQXSXRXQXACXBUNXSXBXCCUOCEUPUMUMXSX
      EXFUAKZLXFUBMZXCCUEZNXPXSXTXAYBXDXFEUAUQXSYAXBPYBXDUSXFELUBUTYAXBXCCVAVBV
      CYBXTXPYBYAXCCUHZIUIZCOZJUIZCOZPZIJUJZQZJYAURIYAURZNZXTXPQIJYAXCCVDYLXTXO
      GHXGXGXIXGKZXKXGKZNZXTYLXOXTYOYLXOQZXTYONZXILVEMZYAKZXKLVEMZYAKZNZYPXTYMY
      SYNUUAXFXIVFXFXKVFVGYLUUBYQXOYCYKUUBYQXOQQYCYQUUBYKXOYCYQUUBYKXOQYCYQNZUU
      BNZYKYRCOZYTCOZPZYRYTPZQZXOUUBYKUUIQUUCYJUUIUUEYGPZYRYFPZQIJYRYTYAYAYDYRP
      ZYHUUJYIUUKUULYEUUEYGYDYRCVIVHYDYRYFVJVKYFYTPZUUJUUGUUKUUHUUMYGUUFUUEYFYT
      CVIVLYFYTYRVMVKVNRUUDUUIXOUUDUUINXMUUGXNUUDXMUUGUSZUUIUUCUUNUUBUUCXJUUEXL
      UUFYQYCXJUUEPZYOXTYCUUOQZYMXTUUPQYNYCXTYMUUOXTYCYMUUOQABCDXFXIFVOVPVTSTTY
      QYCXLUUFPZYOXTYCUUQQZYNXTUURQYMYCXTYNUUQXTYCYNUUQQABCDXFXKFVOVPVTRTTVQSSU
      UDUUIUUGXNQUUDUUHXNUUGUUDXIVRKZXKVRKZLVRKZVSZUUHXNUSUUCUVBUUBYQUVBYCYQUUS
      UUTUVAYOUUSXTYMUUSYNYMXIXIUFXFWAWBSRYOUUTXTYNUUTYMYNXKXKUFXFWAWBRRUVAYQWC
      WDWERSXIXKLWFVBWGWHWIWJWLWKWMWNVTWOVPVTWPWQTWRWSGHXGXCDVDWT $.

    $d N x y z $.
    $( If a function is onto, then also the shifted function is onto.
       (Contributed by Alexander van der Vekens, 24-Nov-2017.) $)
    fargshiftfo $p |- ( ( N e. NN0 /\ F : ( 1 ... N ) -onto-> dom E )
                     -> G : ( 0 ..^ ( # ` F ) ) -onto-> dom E ) $=
      ( vy vz wcel c1 co wa cc0 cfv cfzo wceq caddc wrex adantl wb cn0 chash wf
      cfz cdm wfo crn fof fargshiftf sylan2 cv cab rnmpt a1i wfn fofn fnrnfv wi
      syl df-fo biimpi eqeq1 eqcom syl6bb fseq1hash fargshiftlem cmin cz fzval3
      ffn nn0z nn0cn ax-1cn addcomd oveq2d eqtrd eleq2d biimpa adantr fzosubel3
      cc syl2anc elfzelz zcnd npcand eqcomd oveq1 eqeq2d mpbird rspcimedv com12
      a1d anabsi7 fveq2 rexxfrd oveq2 rexeqdv bibi2d syldan abbidv eqeq1d com23
      biimpcd syl6bi mpcom mpd dffo2 sylanbrc ) EUAIZJEUDKZBUEZCUFZLZMCUBNZOKZX
      KDUCZDUGZXKPXOXKDUFXLXIXJXKCUCZXPXJXKCUHZABCDEFUIUJXMXQGUKZAUKZJQKZCNZPZA
      XORZGULZXKXQYFPXMAGXOYCDFUMUNXMCUGZXTHUKZCNZPZHXJRZGULZPZYFXKPZXLYMXIXLCX
      JUOZYMXJXKCUPHGXJCUQUSSYOYGXKPZLZXMYMYNURZXLYQXIXLYQXJXKCUTVASYPXMYRURYOY
      PYMXMYNYPYMYLXKPZXMYNURYPYMXKYLPYSYGXKYLVBXKYLVCVDXMYSYNXMYLYFXKXMYKYEGXI
      XLXNEPZYKYETZXLXIXRYTXSXRXIYOYTXJXKCVJCEVEUJUJXIYTLUUAYKYDAMEOKZRZTZXIUUD
      YTXIYJYDHAYBXJUUBEYAVFXIYHXJIZYHYBPZAUUBRZXIUUELZUUEUUGUUHUUFUUEAYHJVGKZU
      UBUUHYHJJEQKZOKZIZEVHIZUUIUUBIXIUUEUULXIXJUUKYHXIXJJEJQKZOKZUUKXIUUMXJUUO
      PEVKZJEVIUSXIUUNUUJJOXIEJEVLJWAIZXIVMUNVNVOVPVQVRXIUUMUUEUUPVSYHJEVTWBUUH
      YAUUIPZLZUUFUUEUUSUUFYHUUIJQKZPZUUHUVAUURUUHUUTYHUUHYHJUUEYHWAIXIUUEYHYHJ
      EWCWDSUUQUUHVMUNWEWFVSUURUUFUVATUUHUURYBUUTYHYAUUIJQWGWHSWIWLWJWKWMUUFYJY
      DTXIUUFYIYCXTYHYBCWNWHSWOVSYTUUAUUDTXIYTYEUUCYKYTYDAXOUUBXNEMOWPWQWRSWIWS
      WTXAXCXDXBSXEXFVPXOXKDXGXH $.

    $d E k $.  $d G k $.  $d N k $.  $d P k $.  $d E l $.  $d N l $.  $d P l $.
    $( The values of a shifted function correspond to the value of the original
       function.  (Contributed by Alexander van der Vekens, 24-Nov-2017.) $)
    fargshiftfva $p |- ( ( N e. NN0 /\ F : ( 1 ... N ) --> dom E )
      -> ( A. k e. ( 1 ... N ) ( E ` ( F ` k ) ) = [_ k / x ]_ P
        -> A. l e. ( 0 ..^ N ) ( E ` ( G ` l ) ) = [_ ( l + 1 ) / x ]_ P ) ) $=
      ( wcel c1 co wa cv cfv csb wceq wral wi ex cn0 cfz cdm caddc fargshiftlem
      wf cc0 simpl adantr wb fveq2 fveq2d csbeq1 eqeq12d adantl anim1i ad3antlr
      cfzo simpr fargshiftfv imp eqcomd syl2anc eqeq1d bitrd rspcdv com23 com24
      mpancom imp31 ralrimiv ) GUAJZKGUBLZDUCEUFZMZCNZEOZDOZAVPBPZQZCVMRZHNZFOZ
      DOZAWBKUDLZBPZQZHUGGURLZRVOWAMWGHWHVLVNWAWBWHJZWGSVLWIWAVNWGVLWIWAVNWGSSZ
      WEVMJZVLWIMZWJGWBUEWKWLMZVNWAWGWMVNWAWGSWMVNMZVTWGCWEVMWMWKVNWKWLUHUIWNVP
      WEQZMZVTWEEOZDOZWFQZWGWOVTWSUJWNWOVRWRVSWFWOVQWQDVPWEEUKULAVPWEBUMUNUOWPW
      RWDWFWPWQWCDWPVOWIWQWCQWNVOWOWMVLVNWLVLWKVLWIUHUOUPUIWLWIWKVNWOVLWIUSUQVO
      WIMWCWQVOWIWCWQQADEFGWBIUTVAVBVCULVDVEVFTVGVITVHVJVKT $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.  $d V k $.
    $( In an undirected simple graph (with no loops!) there are no cycles with
       length 1 (consisting of one edge ).  (Contributed by Alexander van der
       Vekens, 7-Nov-2017.) $)
    usgrcyclnl1 $p |- ( ( V USGrph E /\ F ( V Cycles E ) P )
                        -> ( # ` F ) =/= 1 ) $=
      ( vk co wbr cfv c1 wne wi wcel cvv wa cc0 wceq syl caddc cfzo ex cusg cn0
      ccycl chash cwalk cycliswlk w3a wlkbprop cpath wb iscycl 3adant1 pthistrl
      ctrail trliswlk cv wral usgrnloop wn nne cz clt 0z 1z 0lt1 fzolb mpbir3an
      oveq2 syl5eleqr anim2i adantr impcom fveq2 oveq1 neeq12d rspccva 0p1e1 id
      fveq2d eqcoms syl5eq neeq2d df-ne syl5ibcom sylbi com12 con4d com23 com14
      syl6bb pm2.43a 3ad2ant1 syl5 imp3a sylbid mpcom ) CADBUCFGZDBUAGZCUDHZIJZ
      CADBUEFGZWQWRWTKZABCDUFXAWSUBLZDMLBMLNZCMLAMLNZUGZWQXBKABCDUHXFWQCADBUIFG
      ZOAHZWSAHZPZNZXBXDXEWQXKUJXCABCDMMMMUKULXFXGXJXBXGXAXFXJXBKZXGCADBUNFGXAA
      BCDUMABCDUOQXCXDXAXLKXEWRXAXJXCWTWRXAXJXCWTKKZWRXANEUPZAHZXNIRFZAHZJZEOWS
      SFZUQZXMAEBCDURXTXCXJWTXTXCXJWTKXTXCNZWTXJWTUSZYAXJUSZYBWSIPZYAYCKWSIUTYA
      YDYCYDYAYDYCKYDYANZXHOIRFZAHZJZYDYCYEXTOXSLZNZYHYAYDYJXTYDYJKXCXTYDYJYDYI
      XTYDOOISFZXSOYKLOVALIVALOIVBGVCVDVEOIVFVGWSIOSVHVIVJTVKVLXRYHEOXSXNOPZXOX
      HXQYGXNOAVMYLXPYFAXNOIRVNVSVOVPQYDYHXHXIJYCYDYGXIXHYDYFWSAYDYFIWSVQIWSPZI
      WSYMVRVTWAVSWBXHXIWCWJWDTWKWEWFWGTWHQTWIWLWMWNWOQWPVL $.

    $( In an undirected simple graph (with no loops!) there are no cycles with
       length 2 (consisting of two edges ).  (Contributed by Alexander van der
       Vekens, 9-Nov-2017.) $)
    usgrcyclnl2 $p |- ( ( V USGrph E /\ F ( V Cycles E ) P )
                        -> ( # ` F ) =/= 2 ) $=
      ( vk co wbr cfv c2 cvv wcel wa cc0 c1 caddc cpr wceq wi wb fveq2 cusg wne
      ccycl chash cfzo cdm wf1 wf cv wral cpath cyclispth ctrail pthistrl cwalk
      cfz w3a cycliswlk wlkbprop istrl2 pm3.2 sylbid 3adant1 3syl syl5com mpcom
      cn0 iscycl adantr oveq2 f1eq2 syl raleqdv anbi12d eqeq2d anbi1d fzo0to2pr
      raleqi cz 0z fveq2d oveq1 0p1e1 syl6eq preq12d eqeq12d 1p1e2 ralprg mp2an
      1z prcom eqeq2i preq1 eqcoms syl5bb anbi2d eqtr3 crn usgraf1 f1f cn mpbir
      2nn lbfzo0 ffvelrn mpan2 clt 1nn0 1lt2 elfzo0 mpbir3an jca f1fveq mpanr12
      sylan2 necom wn df-ne pm2.21 sylbi ax-mp syl6bi adantl com13 com3l impcom
      ax-1ne0 ex imp31 ax-1 pm2.61ine exp31 3adant2 adantld ) CADBUCFGZDBUAGZCU
      DHZIUBZDJKBJKLZCJKAJKLZLZMYQUEFZBUFZCUGZMYQUPFDAUHZEUIZCHZBHZUUFAHZUUFNOF
      ZAHZPZQZEUUBUJZUQZLZYOYPYRRZCADBUKFGZYOUUPABCDULUURCADBUMFGZYOUUPABCDUNYO
      CADBUOFGYQVGKZYSYTUQUUSUUPRZABCDURABCDUSYSYTUVAUUTUUAUUSUUOUUPAEBCDJJJJUT
      UUAUUOVAVBVCVDVEVFUUPYOUURMAHZYQAHZQZLZUUQUUAYOUVESUUOABCDJJJJVHVIUUOUVEU
      UQRUUAUUOUVDUUQUURUUDUUNUVDUUQRUUEUUDUUNLZUVDYPYRUVFUVDLZYPLZYRRYQIYQIQZU
      VHMIUEFZUUCCUGZUUMEUVJUJZLZUVBIAHZQZLZYPLYRUVIUVGUVPYPUVIUVFUVMUVDUVOUVIU
      UDUVKUUNUVLUVIUUBUVJQUUDUVKSYQIMUEVJZUUBUVJUUCCVKVLUVIUUMEUUBUVJUVQVMVNUV
      IUVCUVNUVBYQIATVOVNVPUVMUVOYPYRUVLUVKUVOUUQRZUVLUUMEMNPZUJZUVKUVRRZUUMEUV
      JUVSVQVRUVTMCHZBHZUVBNAHZPZQZNCHZBHZUWDUVNPZQZLZUWAMVSKNVSKUVTUWKSVTWJUUM
      UWFUWJEMNVSVSUUFMQZUUHUWCUULUWEUWLUUGUWBBUUFMCTWAUWLUUIUVBUUKUWDUUFMATUWL
      UUJNAUWLUUJMNOFNUUFMNOWBWCWDWAWEWFUUFNQZUUHUWHUULUWIUWMUUGUWGBUUFNCTWAUWM
      UUIUWDUUKUVNUUFNATUWMUUJIAUWMUUJNNOFIUUFNNOWBWGWDWAWEWFWHWIUVOUWKUVKUUQUV
      OUWKUWFUWHUWEQZLZUVKUUQRZUVOUWJUWNUWFUWJUWHUVNUWDPZQUVOUWNUWIUWQUWHUWDUVN
      WKWLUVOUWQUWEUWHUWQUWEQUVNUVBUVNUVBUWDWMWNVOWOWPUWOUWCUWHQZUWPUWCUWHUWEWQ
      YPUVKUWRYRYPUUCBWRZBUGZUVKUWRYRRZRBDWSUWTUVKUXAUWTUVKLUWRUWBUWGQZYRUVKUWT
      UWBUUCKZUWGUUCKZLZUWRUXBSUVKUVJUUCCUHZUXEUVJUUCCWTUXFUXCUXDUXFMUVJKZUXCUX
      GIXAKZXCIXDXBZUVJUUCMCXEXFUXFNUVJKZUXDUXJNVGKUXHNIXGGXHXCXINIXJXKZUVJUUCN
      CXEXFXLVLUUCUWSUWBUWGBXMXOUVKUXBYRRUWTUVKUXBMNQZYRUVKUXGUXJUXBUXLSUXIUXKU
      VJUUCMNCXMXNNMUBZUXLYRRZYGUXMMNUBZUXNNMXPUXOUXLXQUXNMNXRUXLYRXSXTXTYAYBYC
      VBYHVLYDVLYBYEXTXTYFYIYBYRUVHYJYKYLYMYNYCVBVFYF $.
  $}

  $( In a simple graph, the vertices of a 3-cycle are mutually different.
     (Contributed by Alexander van der Vekens, 11-Nov-2017.) $)
  3cycl3dv $p |- ( ( V USGrph E
        /\ ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
        -> ( A =/= B /\ B =/= C /\ C =/= A ) ) $=
    ( cusg wbr cpr crn wcel w3a wne usgraedgrn ex 3anim123d imp ) EDFGZABHDIZJZ
    BCHRJZCAHRJZKABLZBCLZCALZKQSUBTUCUAUDQSUBDABEMNQTUCDBCEMNQUAUDDCAEMNOP $.

  $( Lemma for ~ 3v3e3cycl1 and ~ 4cycl4v4e .  (Contributed by Alexander van
     der Vekens, 9-Nov-2017.) $)
  nvnencycllem $p |- ( ( ( Fun E /\ F e. Word dom E )
                    /\ ( X e. NN0 /\ X < ( # ` F ) ) )
            -> ( ( E ` ( F ` X ) ) = { A , B } -> { A , B } e. ran E ) ) $=
    ( wcel wa cn0 cfv clt wbr simpl adantr cc0 adantl wi cr nn0re ex mpcom wfun
    cdm cword chash crn cpr wceq cfzo co wf wrdf lencl cn wne cle nn0ge0 lelttr
    0re a1i syl3anc ltne ee12an com13 com23 imp impcom elnnne0 sylanbrc biimpri
    w3a elfzo0 3exp com12 imp3a adantld ffvelrnd fvelrn syl2anc eleq1 syl5ibcom
    syl ) CUAZDCUBZUCFZGZEHFZEDUDIZJKZGZGZEDIZCIZCUEZFZWLABUFZUGWOWMFWJWBWKWCFW
    NWEWBWIWBWDLMWJNWGUHUIZWCEDWEWPWCDUJZWIWDWQWBWCDUKOMWEWIEWPFZWDWIWRPZWBWDWG
    HFZWSWCDULWTWIWRWGUMFZWTWIGZWRXBWTWGNUNZXAWTWILWIWTXCWFWHWTXCPZNEUOKZWFWHXD
    PEUPXEWHWFXDXEWHWFXDPWTWFXEWHGZXCWTWFXFXCPWTWFGZNQFZXFNWGJKZXCXHXGURUSZXGXH
    EQFZWGQFZXFXIPXJWFXKWTEROWTXLWFWGRMNEWGUQUTNWGVAVBSVCSVDTVEVFWGVGVHXAWIWRWT
    XAWFWHWRWFXAWHWRPWFXAWHWRWRWFXAWHVJEWGVKVIVLVMVNVOTSWAOVEVPWKCVQVRWLWOWMVSV
    T $.

  ${
    $d E a b c $.  $d E k $.  $d F k $.  $d P a b c d $.  $d P k $.
    $d V a b c d $.
    $( If there is a cycle of length 3 in a graph, there are three (different)
       vertices in the graph which are mutually connected by edges.
       (Contributed by Alexander van der Vekens, 9-Nov-2017.) $)
    3v3e3cycl1 $p |- ( ( Fun E /\ F ( V Cycles E ) P /\ ( # ` F ) = 3 )
                       -> E. a e. V E. b e. V E. c e. V ( { a , b } e. ran E
                           /\ { b , c } e. ran E /\ { c , a } e. ran E ) ) $=
      ( co wbr cfv c3 wceq wcel wrex wi cvv wa cc0 c1 c2 vk vd wfun ccycl chash
      cv cpr crn w3a cn0 cwalk cycliswlk wlkbprop cpath iscycl ctrail cfzo cres
      syl ccnv cima cin c0 ispth cdm cword wf caddc wral istrl fzo0to3tp raleqi
      cfz ctp cz wb 0z 1z fveq2 fveq2d oveq1 0p1e1 syl6eq preq12d eqeq12d 1p1e2
      2z 2p1e3 raltpg mp3an bitri preq2 eqcoms eqeq2d 3anbi3d 3pos breq2 mpbiri
      clt 0nn0 jctil nvnencycllem sylan2 1lt3 1nn0 2lt3 2nn0 3anim123d adantlrr
      imp cuz 3nn0 nn0zi uzid ax-mp 4fvwrd4 mpan anim2i df-3an sylibr rexlimivw
      simpl reximi preq12 3adant3 eleq1d 3adant1 ancoms 3adant2 biimpcd reximdv
      3anbi123d syl2im com14 syl6bi com12 3imp oveq2 a1d sylbid 3anbi23d imbi1d
      exp41 com35 com24 sylbi com13 feq2d raleqdv imbi2d 3imtr4d 3impd imp3a
      mpcom ) BUCZCADBUDHIZCUEJZKLZEUFZFUFZUGZBUHZMZUUTGUFZUGZUVBMZUVDUUSUGZUVB
      MZUIZGDNZFDNZEDNZUUPUUOUURUVLOZUUQUJMZDPMBPMQZCPMAPMQZUIZUUPUUOUVMOZUUPCA
      DBUKHIUVQABCDULABCDUMUSUVOUVPUUPUVROUVNUVOUVPQZUUPCADBUNHIZRAJZUUQAJZLZQU
      VRABCDPPPPUOUVSUVTUWCUVRUVSUVTCADBUPHIZASUUQUQHZURUTUCZARUUQUGVAAUWEVAVBV
      CLZUIUWCUVROZABCDPPPPVDUVSUWDUWFUWGUWHUVSUWDCBVEVFMZCUTUCZQZRUUQVMHZDAVGZ
      UAUFZCJZBJZUWNAJZUWNSVHHZAJZUGZLZUARUUQUQHZVIZUIZUWFUWGUWHOZOAUABCDPPPPVJ
      UXDUXEUWFUXDUWHUWGUURUWCUUOUXDUVLUURUWAKAJZLZUUOUWKRKVMHZDAVGZUXAUARKUQHZ
      VIZUIZUVLOZOUWCUUOUXDUVLOZOUXLUXGUUOUURUVLUWKUXIUXKUXGUVROZUXKUXIUWKUXOUX
      KRCJZBJZUWASAJZUGZLZSCJZBJZUXRTAJZUGZLZTCJZBJZUYCUXFUGZLZUIZUXIUWKUXOOOUX
      KUXAUARSTVNZVIZUYJUXAUAUXJUYKVKVLRVOMSVOMTVOMUYLUYJVPVQVRWGUXAUXTUYEUYIUA
      RSTVOVOVOUWNRLZUWPUXQUWTUXSUYMUWOUXPBUWNRCVSVTUYMUWQUWAUWSUXRUWNRAVSUYMUW
      RSAUYMUWRRSVHHSUWNRSVHWAWBWCVTWDWEUWNSLZUWPUYBUWTUYDUYNUWOUYABUWNSCVSVTUY
      NUWQUXRUWSUYCUWNSAVSUYNUWRTAUYNUWRSSVHHTUWNSSVHWAWFWCVTWDWEUWNTLZUWPUYGUW
      TUYHUYOUWOUYFBUWNTCVSVTUYOUWQUYCUWSUXFUWNTAVSUYOUWRKAUYOUWRTSVHHKUWNTSVHW
      AWHWCVTWDWEWIWJWKUYJUXGUWKUXIUVRUXGUYJUWKUXIUVROOZUXGUYJUXTUYEUYGUYCUWAUG
      ZLZUIZUYPUXGUYIUYRUXTUYEUXGUYHUYQUYGUYHUYQLUXFUWAUXFUWAUYCWLWMWNWOUYSUWKU
      URUUOUXIUVLUUOUWKUURUYSUXIUVLOZUUOUWKUURUYSUYTUUOUWKQUURQZUYSQUXSUVBMZUYD
      UVBMZUYQUVBMZUIZUXIUWAUUSLZUXRUUTLZUYCUVDLZUIZGDNZFDNZEDNZUVLVUAUYSVUEUUO
      UWIUURUYSVUEOUWJUUOUWIQZUURQUXTVUBUYEVUCUYRVUDUURVUMRUJMZRUUQWSIZQUXTVUBO
      UURVUOVUNUURVUORKWSIWPUUQKRWSWQWRWTXAUWAUXRBCRXBXCUURVUMSUJMZSUUQWSIZQUYE
      VUCOUURVUQVUPUURVUQSKWSIXDUUQKSWSWQWRXEXAUXRUYCBCSXBXCUURVUMTUJMZTUUQWSIZ
      QUYRVUDOUURVUSVURUURVUSTKWSIXFUUQKTWSWQWRXGXAUYCUWABCTXBXCXHXIXJUXIVUFVUG
      QZVUHUXFUBUFLZQZQZUBDNZGDNZFDNZEDNZVULKKXKJMZUXIVVGKVOMVVHKXLXMKXNXOAKDEF
      GUBXPXQVVFVUKEDVVEVUJFDVVDVUIGDVVCVUIUBDVVCVUTVUHQVUIVVBVUHVUTVUHVVAYBXRV
      UFVUGVUHXSXTYAYCYCYCUSVUEVUKUVKEDVUEVUJUVJFDVUEVUIUVIGDVUIVUEUVIVUIVUBUVC
      VUCUVFVUDUVHVUIUXSUVAUVBVUFVUGUXSUVALVUHUWAUXRUUSUUTYDYEYFVUIUYDUVEUVBVUG
      VUHUYDUVELVUFUXRUYCUUTUVDYDYGYFVUIUYQUVGUVBVUFVUHUYQUVGLZVUGVUHVUFVVIUYCU
      WAUVDUUSYDYHYIYFYLYJYKYKYKYMUUCYNUUDYOYPUUEUUFUUGYQYNUURUWBUXFUWAUUQKAVSW
      NUURUXNUXMUUOUURUXDUXLUVLUURUWMUXIUXCUXKUWKUURUWLUXHDAUUQKRVMYRUUHUURUXAU
      AUXBUXJUUQKRUQYRUUIUUAUUBUUJUUKYNYSYSYOUULYTUUMYTYGUUNYPYQ $.
  $}

  ${
    constr3cycl.f $e |- F = { <. 0 , ( `' E ` { A , B } ) >. ,
                              <. 1 , ( `' E ` { B , C } ) >. ,
                              <. 2 , ( `' E ` { C , A } ) >. } $.
    constr3cycl.p $e |- P = ( { <. 0 , A >. , <. 1 , B >. }
                           u. { <. 2 , C >. , <. 3 , A >. } ) $.
    $( Lemma for ~ constr3trl etc.  (Contributed by Alexander van der Vekens,
       10-Nov-2017.) $)
    constr3lem1 $p |- ( F e. _V /\ P e. _V ) $=
      ( cvv wcel cc0 cpr ccnv cfv cop c1 c2 ctp eqeltri prex tpex c3 cun pm3.2i
      unex ) FIJDIJFKABLEMZNOZPBCLUFNOZQCALUFNOZRIGUGUHUIUASDKAOZPBOZLZQCOZUBAO
      ZLZUCIHULUOUJUKTUMUNTUESUD $.

    $( Lemma for ~ constr3trl etc.  (Contributed by Alexander van der Vekens,
       10-Nov-2017.) $)
    constr3lem2 $p |- ( # ` F ) = 3 $=
      ( cc0 cpr cfv cop c1 c2 wceq chash c3 wne fvex ax-mp ccnv ctp w3a ax-1ne0
      necomi c0ex opth1 necon3i 1ne2 1ex 2ne0 cz elexi 3pm3.2i fveq2 eqeq1d cvv
      2z wcel wb opex hashtpg mp3an syl6rbbr mpbii ) FIABJZEUAZKZLZMBCJZVGKZLZN
      CAJZVGKZLZUBZOZFPKZQOZGVQVIVLRZVLVORZVOVIRZUCZVSVTWAWBIMRVTMIUDUEVIVLIMIV
      HMVKUFVFVGSUGUHTMNRWAUIVLVOMNMVKNVNUJVJVGSUGUHTNIRWBUKVOVININVNIVHNULURUM
      VMVGSUGUHTUNVQVSVPPKZQOZWCVQVRWDQFVPPUOUPVIUQUSVLUQUSVOUQUSWCWEUTIVHVAMVK
      VANVNVAVIVLVOVBVCVDVET $.

    $( Lemma for ~ constr3trl etc.  (Contributed by Alexander van der Vekens,
       10-Nov-2017.)  (Proof shortened by Alexander van der Vekens,
       16-Dec-2017.) $)
    constr3lem4 $p |- ( ( A e. V /\ B e. V /\ C e. V )
                        -> ( ( ( P ` 0 ) = A /\ ( P ` 1 ) = B )
                          /\ ( ( P ` 2 ) = C /\ ( P ` 3 ) = A ) ) ) $=
      ( cc0 c1 c2 c3 wceq w3a wcel cfv wa cz wne cop cpr c0 0z 1z pm3.2i 3simpa
      wfn cin a1i ax-1ne0 necomi fnprg syl3anc cn0 3nn0 pm3.22 3adant2 2re 2lt3
      2z ltneii 2ne0 1ne2 3ne0 1re 1lt3 disjpr2 mp4an 3jca cun fveq1i c0ex jctr
      prid1 3anim3i adantr fvun1 syl syl5eq fvpr1g mp3an13 3ad2ant1 eqtrd prid2
      adantl 1ex cr fvpr2g 3ad2ant2 elexi fvun2 3ad2ant3 jca jca31 mpancom ) JA
      UAKBUAUBZJKUBZUHZLCUAMAUAUBZLMUBZUHZWRXAUIUCNZOZAGPZBGPZCGPZOZJDQZANZKDQZ
      BNZRLDQZCNZMDQZANZRZRXHWSXBXCXHJSPZKSPZRZXEXFRJKTZWSXTXHXRXSUDUEUFUJXEXFX
      GUGYAXHKJUKULZUJJKABSSGGUMUNXHLSPZMUOPZRZXGXERZLMTZXBYEXHYCYDVAUPUFUJXEXG
      YFXFXEXGUQURYGXHLMUSUTVBZUJLMCASUOGGUMUNXCXHJLTKLTJMTKMTXCLJVCULVDMJVEULK
      MVFVGVBJKLMVHVIUJVJXDXHRZXJXLXQYIXIJWQQZAYIXIJWQWTVKZQZYJJDYKIVLYIWSXBXCJ
      WRPZRZOZYLYJNXDYOXHXCYNWSXBXCYMJKVMVOVNVPVQWRXAWQWTJVRVSVTXHYJANZXDXEXFYP
      XGXRXEYAYPUDYBJKABSGWAWBWCWFWDYIXKKWQQZBYIXKKYKQZYQKDYKIVLYIWSXBXCKWRPZRZ
      OZYRYQNXDUUAXHXCYTWSXBXCYSJKWGWEVNVPVQWRXAWQWTKVRVSVTXHYQBNZXDXFXEUUBXGKW
      HPXFYAUUBVFYBJKABWHGWIWBWJWFWDYIXNXPYIXMLWTQZCYIXMLYKQZUUCLDYKIVLYIWSXBXC
      LXAPZRZOZUUDUUCNXDUUGXHXCUUFWSXBXCUUELMLSVAWKVOVNVPVQWRXAWQWTLWLVSVTXHUUC
      CNZXDXGXEUUHXFYCXGYGUUHVAYHLMCASGWAWBWMWFWDYIXOMWTQZAYIXOMYKQZUUIMDYKIVLY
      IWSXBXCMXAPZRZOZUUJUUINXDUUMXHXCUULWSXBXCUUKLMMUOUPWKWEVNVPVQWRXAWQWTMWLV
      SVTXHUUIANZXDXEXFUUNXGYDXEYGUUNUPYHLMCAUOGWIWBWCWFWDWNWOWP $.

    $( Lemma for ~ constr3trl etc.  (Contributed by Alexander van der Vekens,
       12-Nov-2017.) $)
    constr3lem5 $p |- ( ( F ` 0 ) = ( `' E ` { A , B } )
                     /\ ( F ` 1 ) = ( `' E ` { B , C } )
                     /\ ( F ` 2 ) = ( `' E ` { C , A } ) ) $=
      ( cc0 c1 wne c2 cfv cpr wceq w3a cop fveq1i fvex syl5eq ccnv ax-1ne0 2ne0
      necomi 1ne2 ctp fvtp1 3adant3 1ex fvtp2 3adant2 cz 2z elexi fvtp3 3adant1
      c0ex 3jca mp3an ) IJKZILKZJLKZIFMZABNZEUAZMZOZJFMZBCNZVEMZOZLFMZCANZVEMZO
      ZPJIUBUDLIUCUDUEUTVAVBPZVGVKVOVPVCIIVFQJVJQLVNQUFZMZVFIFVQGRUTVAVRVFOVBIJ
      LVFVJVNUQVDVESUGUHTVPVHJVQMZVJJFVQGRUTVBVSVJOVAIJLVFVJVNUIVIVESUJUKTVPVLL
      VQMZVNLFVQGRVAVBVTVNOUTIJLVFVJVNLULUMUNVMVESUOUPTURUS $.

    $( Lemma for ~ constr3pthlem3 .  (Contributed by Alexander van der Vekens,
       11-Nov-2017.) $)
    constr3lem6 $p |- ( ( ( A e. V /\ B e. V /\ C e. V )
                        /\ ( A =/= B /\ B =/= C /\ C =/= A ) )
                         -> ( { ( P ` 0 ) , ( P ` 3 ) }
                          i^i { ( P ` 1 ) , ( P ` 2 ) } ) = (/) ) $=
      ( wcel w3a wne wa cfv cpr wceq neeq12d adantr adantl anbi12d cc0 c1 c3 c2
      cin c0 wi constr3lem4 id ancli necom sylbi anim12i 3adant2 wb simpl simpr
      syl5ibr syl imp disjpr2 ) AGJBGJCGJKZABLZBCLZCALZKZMUADNZUBDNZLZUCDNZVHLZ
      MZVGUDDNZLZVJVMLZMZMZVGVJOVHVMOUEUFPVBVFVQVBVGAPZVHBPZMZVMCPZVJAPZMZMZVFV
      QUGABCDEFGHIUHVFVQWDVCVCMZACLZWFMZMZVCVEWHVDVCWEVEWGVCVCVCUIUJVEWFWGCAUKW
      FWFWFUIUJULUMUNWDVLWEVPWGWDVIVCVKVCVTVIVCUOWCVTVGAVHBVRVSUPZVRVSUQZQRWDVJ
      AVHBWCWBVTWAWBUQZSVTVSWCWJRQTWDVNWFVOWFWDVGAVMCVTVRWCWIRWCWAVTWAWBUPZSQWC
      VOWFUOVTWCVJAVMCWKWLQSTTURUSUTVGVJVHVMVAUS $.

    $d E x $.  $d F x y $.  $d V x $.  $d A x $.  $d B x $.  $d C x $.
    $( Lemma for ~ constr3trl .  (Contributed by Alexander van der Vekens,
       10-Nov-2017.) $)
    constr3trllem1 $p |- ( ( V USGrph E /\ ( { A , B } e. ran E
        /\ { B , C } e. ran E /\ { C , A } e. ran E ) ) -> F e. Word dom E ) $=
      ( vx cpr wcel wa cc0 cfv ctp wf c1 c2 cop cusg wbr crn w3a c3 cfzo co cdm
      ccnv wss cword c0ex 1ex cz 2z elexi fvex ax-1ne0 necomi 2ne0 1ne2 ftp a1i
      wceq fzo0to3tp feq12d mpbiri cv chash cpw c0 csn cdif crab wf1o wi usgraf
      wf1 f1f1orn f1ocnvdm 3ad2antr1 3ad2antr2 3ad2antr3 3jca ex 3syl imp sylib
      tpss jca fss iswrdi ) GEUAUBZABKZEUCZLZBCKZWOLZCAKZWOLZUDZMZNUEUFUGZWNEUI
      ZOZWQXDOZWSXDOZPZFQZXHEUHZUJZMXCXJFQFXJUKLXBXIXKXBXINRSPZXHNXETRXFTSXGTPZ
      QNRSXEXFXGULUMSUNUOUPWNXDUQZWQXDUQZWSXDUQZRNURUSSNUTUSVAVBXBXCXLXHFXMFXMV
      DXBHVCXCXLVDXBVEVCVFVGXBXEXJLZXFXJLZXGXJLZUDZXKWMXAXTWMXJJVHVIOSVDJGVJVKV
      LVMVNZEVRXJWOEVOZXAXTVPJEGVQXJYAEVSYBXAXTYBXAMXQXRXSYBWRWPXQWTXJWOWNEVTWA
      YBWPWRXRWTXJWOWQEVTWBYBWPWTXSWRXJWOWSEVTWCWDWEWFWGXEXFXGXJXNXOXPWIWHWJXCX
      HXJFWKXJUEFWLWF $.

    $( Lemma for ~ constr3trl .  (Contributed by Alexander van der Vekens,
       12-Nov-2017.) $)
    constr3trllem2 $p |- ( ( V USGrph E /\ ( { A , B } e. ran E
               /\ { B , C } e. ran E /\ { C , A } e. ran E ) ) -> Fun `' F ) $=
      ( vy wa cc0 wceq wi c1 c2 com12 adantl wb adantr vx cusg wbr cpr crn wcel
      w3a chash cfv cfzo co cdm wf ccnv wfun wf1 wral cword constr3trllem1 wrdf
      cv weq syl constr3lem2 ctp wne wf1o usgraf1o 3cycl3dv usgraedgrnv anim12d
      c3 ex 3adant2 impcom constr3lem5 jctl exp31 mpancom mpd mpid imp cvv c0ex
      cz 1ex 2z 3pm3.2i eqidd a1i f1of1 3simpa ad3antlr f1ocnvfvrneq syl2anc wo
      simpl simpr anim12i preq12bg wn df-ne pm2.21 sylbi 3ad2ant1 3ad2ant3 jaoi
      eqcoms syl6bi com23 syld eqeq12 3adant3 imbi1d mpbird 3ad2ant2 3jca fveq2
      3simpb eqeq2d imbi12d raltpg pm3.22 ancoms 3simpc sylancom 3adant1 eqeq1d
      eqeq2 mpan eqeq1 ralbidv ax-mp fzo0to3tp raleqdv raleqbidv oveq2 sylanbrc
      sylibr dff13 df-f1 sylib simprd ) GEUBUCZABUDZEUEZUFZBCUDZUUFUFZCAUDZUUFU
      FZUGZKZLFUHUIZUJUKZEULZFUMZFUNUOZUUMUUOUUPFUPZUUQUURKUUMUUQUAVAZFUIZJVAZF
      UIZMZUAJVBZNZJUUOUQZUAUUOUQZUUSUUMFUUPURUFUUQABCDEFGHIUSUUPFUTVCUUNVLMZUU
      MUVHABCDEFHIVDUVIUUMKZUVHUVFJLVLUJUKZUQZUAUVKUQZUVJUVMUVFJLOPVEZUQZUAUVNU
      QZUVJLFUIZUVCMZLUVBMZNZJUVNUQZOFUIZUVCMZOUVBMZNZJUVNUQZPFUIZUVCMZPUVBMZNZ
      JUVNUQZUGZUVPUVJUVQUUEEUNZUIZMZUWBUUHUWMUIZMZUWGUUJUWMUIZMZUGZAGUFZBGUFZK
      ZCGUFZUXAKZKZUUMKZABVFZBCVFZCAVFZUGZKZUUPUUFEVGZKZKZUWLUUMUXOUVIUUDUULUXO
      UUDUULUXMUXOEGVHUUDUULUXMUXONZUUMUXKUXPABCEGVIUXFUUMUXKUXPNUULUUDUXFUUGUU
      KUUDUXFNUUIUUDUUGUUKKZUXFUUDUUGUXCUUKUXEUUDUUGUXCEABGVJVMUUDUUKUXEECAGVJV
      MVKQVNVOUXGUXKUXMUXOUXNUWTABCDEFHIVPVQVRVSVTVMWAWBRLWCUFZOWCUFZPWEUFZUGZU
      XOUWLUXRUXSUXTWDWFWGWHZUYAUXOKZUWAUWFUWKUYCUWAUVQUVQMZLLMZNZUVQUWBMZLOMZN
      ZUVQUWGMZLPMZNZUGZUXOUYMUYAUXOUYFUYIUYLUYFUXOUYDLWIWJUXOUYIUWNUWPMZUYHNZU
      XNUYOUWTUXNUYNUUEUUHMZUYHUXNUUPUUFEUPZUUGUUIKZUYNUYPNUXMUYQUXLUUPUUFEWKRZ
      UUMUYRUXFUXKUXMUULUYRUUDUUGUUIUUKWLRWMUUPUUFUUEUUHEWNWOUXLUYPUYHNZUXMUXGU
      XKUYTUXFUXKUYTNUUMUXFUYPUXKUYHUXFUYPABMZBCMZKZACMZBBMZKZWPZUXKUYHNZUXFUXC
      UXBUXDKZUYPVUGSUXCUXEWQZUXCUXBUXEUXDUXAUXBWRUXDUXAWQWSZABBCGGGGWTWOVUCVUH
      VUFVUAVUHVUBUXKVUAUYHUXHUXIVUAUYHNZUXJUXHVUAXAZVULABXBZVUAUYHXCXDXEQTVUDV
      UHVUEVUHCAUXKCAMZUYHUXJUXHVUOUYHNZUXIUXJVUOXAZVUPCAXBZVUOUYHXCXDXFQXHTXGX
      IXJTWBTXKRUWTUYIUYOSUXNUWTUYGUYNUYHUWOUWQUYGUYNSUWSUVQUWNUWBUWPXLXMXNTXOU
      XOUYLUWNUWRMZUYKNZUXNVUTUWTUXNVUSUUEUUJMZUYKUXNUYQUXQVUSVVANUYSUUMUXQUXFU
      XKUXMUULUXQUUDUUGUUIUUKXSRWMUUPUUFUUEUUJEWNWOUXLVVAUYKNZUXMUXGUXKVVBUXFUX
      KVVBNUUMUXFVVAUXKUYKUXFVVAVUDBAMZKZAAMZVUBKZWPUXKUYKNZABCAGGGGWTVVDVVGVVF
      VVCVVGVUDVVGABUXKVUAUYKUXHUXIVUAUYKNZUXJUXHVUMVVHVUNVUAUYKXCXDXEQXHRVUBVV
      GVVEUXKVUBUYKUXIUXHVUBUYKNZUXJUXIVUBXAZVVIBCXBZVUBUYKXCXDXPQRXGXIXJTWBTXK
      RUWTUYLVUTSUXNUWTUYJVUSUYKUWOUWSUYJVUSSUWQUVQUWNUWGUWRXLVNXNTXOXQRUYAUWAU
      YMSUXOUVTUYFUYIUYLJLOPWCWCWEUVBLMZUVRUYDUVSUYEVVLUVCUVQUVQUVBLFXRZXTUVBLL
      YIYAUVBOMZUVRUYGUVSUYHVVNUVCUWBUVQUVBOFXRZXTUVBOLYIYAUVBPMZUVRUYJUVSUYKVV
      PUVCUWGUVQUVBPFXRZXTUVBPLYIYAYBTXOUYCUWFUWBUVQMZOLMZNZUWBUWBMZOOMZNZUWBUW
      GMZOPMZNZUGZUXOVWGUYAUXOVVTVWCVWFUXOVVTUWPUWNMZVVSNZUXNVWIUWTUXNVWHUUHUUE
      MZVVSUXNUYQUUIUUGKZVWHVWJNUYSUUMVWKUXFUXKUXMUULVWKUUDUUGUUIVWKUUKUUGUUIYC
      XMRWMUUPUUFUUHUUEEWNWOUXLVWJVVSNZUXMUXGUXKVWLUXFUXKVWLNUUMUXFVWJUXKVVSUXF
      VWJVVCCBMZKZVUEVUOKZWPZUXKVVSNZUXFVUIUXCVWJVWPSVUKVUJBCABGGGGWTWOVWNVWQVW
      OVVCVWQVWMVWQABUXKVUAVVSUXHUXIVUAVVSNZUXJUXHVUMVWRVUNVUAVVSXCXDXEQXHTVUOV
      WQVUEUXKVUOVVSUXJUXHVUOVVSNZUXIUXJVUQVWSVURVUOVVSXCXDXFQRXGXIXJTWBTXKRUWT
      VVTVWISUXNUWTVVRVWHVVSUWOUWQVVRVWHSZUWSUWQUWOVWTUWBUWPUVQUWNXLYDXMXNTXOVW
      CUXOVWAOWIWJUXOVWFUWPUWRMZVWENZUXNVXBUWTUXNVXAUUHUUJMZVWEUXNUYQUUIUUKKZVX
      AVXCNUYSUUMVXDUXFUXKUXMUULVXDUUDUUGUUIUUKYERWMUUPUUFUUHUUJEWNWOUXLVXCVWEN
      ZUXMUXGUXKVXEUXFUXKVXENUUMUXFVXCUXKVWEUXFVXCVUBVUOKZVVCCCMZKZWPZUXKVWENZU
      XCUXEVUIVXCVXISVUKBCCAGGGGWTYFVXFVXJVXHVUBVXJVUOUXKVUBVWEUXIUXHVUBVWENZUX
      JUXIVVJVXKVVKVUBVWEXCXDXPQTVVCVXJVXGVXJABUXKVUAVWEUXHUXIVUAVWENZUXJUXHVUM
      VXLVUNVUAVWEXCXDXEQXHTXGXIXJTWBTXKRUWTVWFVXBSUXNUWTVWDVXAVWEUWQUWSVWDVXAS
      UWOUWBUWPUWGUWRXLYGXNTXOXQRUYAUWFVWGSUXOUWEVVTVWCVWFJLOPWCWCWEVVLUWCVVRUW
      DVVSVVLUVCUVQUWBVVMXTUVBLOYIYAVVNUWCVWAUWDVWBVVNUVCUWBUWBVVOXTUVBOOYIYAVV
      PUWCVWDUWDVWEVVPUVCUWGUWBVVQXTUVBPOYIYAYBTXOUYCUWKUWGUVQMZPLMZNZUWGUWBMZP
      OMZNZUWGUWGMZPPMZNZUGZUXOVYBUYAUXOVXOVXRVYAUXOVXOUWRUWNMZVXNNZUXNVYDUWTUX
      NVYCUUJUUEMZVXNUXNUYQUUKUUGKZVYCVYENUYSUUMVYFUXFUXKUXMUULVYFUUDUUGUUKVYFU
      UIUUGUUKYCVNRWMUUPUUFUUJUUEEWNWOUXLVYEVXNNZUXMUXGUXKVYGUXFUXKVYGNUUMUXFVY
      EUXKVXNUXFVYEVUOVUAKZVWMVVEKZWPZUXKVXNNZUXEUXCVYEVYJSCAABGGGGWTYDVYHVYKVY
      IVUAVYKVUOUXKVUAVXNUXHUXIVUAVXNNZUXJUXHVUMVYLVUNVUAVXNXCXDXEQRVWMVYKVVEVY
      KBCUXKVUBVXNUXIUXHVUBVXNNZUXJUXIVVJVYMVVKVUBVXNXCXDXPQXHTXGXIXJTWBTXKRUWT
      VXOVYDSUXNUWTVXMVYCVXNUWOUWSVXMVYCSZUWQUWSUWOVYNUWGUWRUVQUWNXLYDVNXNTXOUX
      OVXRUWRUWPMZVXQNZUXNVYPUWTUXNVYOUUJUUHMZVXQUXNUYQUUKUUIKZVYOVYQNUYSUUMVYR
      UXFUXKUXMUULVYRUUDUUIUUKVYRUUGUUIUUKYCYGRWMUUPUUFUUJUUHEWNWOUXLVYQVXQNZUX
      MUXGUXKVYSUXFUXKVYSNUUMUXFVYQUXKVXQUXFVYQVWMVUDKZVXGVUAKZWPZUXKVXQNZUXFUX
      EVUIVYQWUBSUXCUXEWRVUKCABCGGGGWTWOVYTWUCWUAVUDWUCVWMWUCCAUXKVUOVXQUXJUXHV
      UOVXQNZUXIUXJVUQWUDVURVUOVXQXCXDXFQXHRVUAWUCVXGUXKVUAVXQUXHUXIVUAVXQNZUXJ
      UXHVUMWUEVUNVUAVXQXCXDXEQRXGXIXJTWBTXKRUWTVXRVYPSUXNUWTVXPVYOVXQUWQUWSVXP
      VYOSZUWOUWSUWQWUFUWGUWRUWBUWPXLYDYGXNTXOVYAUXOVXSPWIWJXQRUYAUWKVYBSUXOUWJ
      VXOVXRVYAJLOPWCWCWEVVLUWHVXMUWIVXNVVLUVCUVQUWGVVMXTUVBLPYIYAVVNUWHVXPUWIV
      XQVVNUVCUWBUWGVVOXTUVBOPYIYAVVPUWHVXSUWIVXTVVPUVCUWGUWGVVQXTUVBPPYIYAYBTX
      OXQYJVCUYAUVPUWLSUYBUVOUWAUWFUWKUALOPWCWCWEUUTLMZUVFUVTJUVNWUGUVDUVRUVEUV
      SWUGUVAUVQUVCUUTLFXRYHUUTLUVBYKYAYLUUTOMZUVFUWEJUVNWUHUVDUWCUVEUWDWUHUVAU
      WBUVCUUTOFXRYHUUTOUVBYKYAYLUUTPMZUVFUWJJUVNWUIUVDUWHUVEUWIWUIUVAUWGUVCUUT
      PFXRYHUUTPUVBYKYAYLYBYMYSUVJUVLUVOUAUVKUVNUVKUVNMUVJYNWJZUVJUVFJUVKUVNWUJ
      YOYPXOUVIUVHUVMSUUMUVIUVGUVLUAUUOUVKUUNVLLUJYQZUVIUVFJUUOUVKWUKYOYPTXOYJU
      AJUUOUUPFYTYRUUOUUPFUUAUUBUUC $.

    $( Lemma for ~ constr3trl .  (Contributed by Alexander van der Vekens,
       11-Nov-2017.) $)
    constr3trllem3 $p |- ( ( A e. V /\ B e. V /\ C e. V )
                           -> P : ( 0 ... ( # ` F ) ) --> V ) $=
      ( wcel cc0 c1 cfz co cpr wf c2 c3 wceq wa w3a cop chash cfv cin c0 wss cz
      wne 0z 1z pm3.2i a1i 3simpa ax-1ne0 necomi fprg caddc 0p1e1 eqcomi oveq2i
      fzpr ax-mp preq2i 3eqtri feq2i syl3anc prssi 3adant3 fss syl2anc cn0 2nn0
      sylibr 3nn0 pm3.22 3adant2 2re 2lt3 ltneii constr3lem2 df-3 2z ancoms clt
      eqtri wbr 1lt2 fzdisj mp1i cun fun cuz 3nn eqeltri elnnuz mpbi cle eluzle
      cn 0le1 wb eluzelz elfz mp3an12 syl mpbir2and fzsplit df-2 oveq1i syl6eqr
      uneq2i unidm feq123d mpbird syl21anc ) AGJZBGJZCGJZUAZKLMNZGKAUBLBUBOZPZQ
      FUCUDZMNZGQCUBRAUBOZPZYAYEUEUFSZKYDMNZGDPZXTYAABOZYBPZYKGUGZYCXTKUHJZLUHJ
      ZTZXQXRTZKLUIZYLYPXTYNYOUJUKULUMXQXRXSUNYRXTLKUOUPUMYPYQYRUAKLOZYKYBPYLKL
      ABUHUHGGUQYAYSYKYBYAKKLURNZMNZKYTOZYSLYTKMYTLUSUTVAYNUUAUUBSUJKVBVCYTLKUS
      VDVEVFVNVGXQXRYMXSABGVHVIYAYKGYBVJVKXTYECAOZYFPZUUCGUGZYGXTQVLJZRVLJZTZXS
      XQTZQRUIZUUDUUHXTUUFUUGVMVOULUMXQXSUUIXRXQXSVPVQUUJXTQRVRVSVTUMUUHUUIUUJU
      AQROZUUCYFPUUDQRCAVLVLGGUQYEUUKUUCYFYEQQLURNZMNZQUULOZUUKYDUULQMYDRUULABC
      DEFHIWAZWBWFVAQUHJUUMUUNSWCQVBVCUULRQRUULWBUTVDVEVFVNVGXQXSUUEXRXSXQUUECA
      GVHWDVQYEUUCGYFVJVKLQWEWGYHXTWHKLQYDWIWJYCYGTYHTZYJYAYEWKZGGWKZYBYFWKZPYA
      YEGGYBYFWLUUPYIUUQGUURDUUSDUUSSUUPIUMYDLWMUDJZYIUUQSUUPYDWTJUUTYDRWTUUOWN
      WOYDWPWQUUTYIYALLURNZYDMNZWKZUUQUUTLYIJZYIUVCSUUTUVDKLWRWGZLYDWRWGZUVEUUT
      XAUMLYDWSUUTYDUHJZUVDUVEUVFTXBZLYDXCYOYNUVGUVHUKUJLKYDXDXEXFXGLKYDXHXFYEU
      VBYAQUVAYDMXIXJXLXKWJGUURSUUPUURGGXMUTUMXNXOXP $.

    $( Lemma for ~ constr3trl .  (Contributed by Alexander van der Vekens,
       11-Nov-2017.) $)
    constr3trllem4 $p |- ( ( A e. V /\ B e. V /\ C e. V )
                        -> P : ( 0 ... 3 ) --> V ) $=
      ( wcel w3a cc0 chash cfv cfz co wf c3 constr3trllem3 constr3lem2 oveq2i
      feq2i sylib ) AGJBGJCGJKLFMNZOPZGDQLROPZGDQABCDEFGHISUEUFGDUDRLOABCDEFHIT
      UAUBUC $.

    $d E k $.  $d F k $.  $d P k $.
    $( Lemma for ~ constr3trl .  (Contributed by Alexander van der Vekens,
       12-Nov-2017.) $)
    constr3trllem5 $p |- ( ( V USGrph E /\ ( { A , B } e. ran E
                          /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
              -> A. k e. ( 0 ..^ ( # ` F ) )
                 ( E ` ( F ` k ) ) = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) $=
      ( cpr wcel wa cfv c1 wceq cc0 c2 ex fveq2 vx cusg wbr crn w3a cv caddc co
      chash cfzo wral ctp c3 usgraedgrnv 3anim123d wi simpll simprl constr3lem4
      imp simprr syl3anc ccnv cdm cpw c0 csn cdif crab usgraf f1f1orn f1ocnvfv2
      wf1 wf1o 3syl adantl constr3lem5 3ad2ant1 eqeq1d 3ad2ant2 3anbi123d ax-mp
      wb 3ad2ant3 sylibr simplr preq12d eqeq2d ad2antrr mpbird mpcom 3adant3 cz
      0z 1z 2z fveq2d oveq1 0p1e1 syl6eq eqeq12d 1p1e2 2p1e3 raltpg constr3lem2
      mp3an oveq2i fzo0to3tp eqtri a1i raleqdv ) HFUBUCZABKZFUDZLZBCKZXNLZCAKZX
      NLZUEZMZEUFZGNZFNZYBDNZYBOUGUHZDNZKZPZEQGUINZUJUHZUKYIEQORULZUKZYAQGNZFNZ
      QDNZODNZKZPZOGNZFNZYQRDNZKZPZRGNZFNZUUBUMDNZKZPZUEZYMAHLZBHLZMZUULCHLZMZU
      UNUUKMZUEZYAUUJXLXTUUQXLXOUUMXQUUOXSUUPXLXOUUMFABHUNSXLXQUUOFBCHUNSXLXSUU
      PFCAHUNSUOUTUUMUUOYAUUJUPZUUPYPAPZYQBPZMZUUBCPZUUGAPZMZMZUUMUUOMZUURUVFUU
      KUULUUNUVEUUKUULUUOUQUUMUULUUNURUUMUULUUNVAABCDFGHIJUSVBUVEUVFUURUVEUVFMZ
      YAUUJUVGYAMZUUJYOXMPZUUAXPPZUUFXRPZUEZUVHXMFVCZNZFNZXMPZXPUVMNZFNZXPPZXRU
      VMNZFNZXRPZUEZUVLYAUWCUVGXLXTUWCXLFVDZUAUFUINRPUAHVEVFVGVHVIZFVMUWDXNFVNZ
      XTUWCUPUAFHVJUWDUWEFVKUWFXOUVPXQUVSXSUWBUWFXOUVPUWDXNXMFVLSUWFXQUVSUWDXNX
      PFVLSUWFXSUWBUWDXNXRFVLSUOVOUTVPYNUVNPZYTUVQPZUUEUVTPZUEZUVLUWCWCABCDFGIJ
      VQUWJUVIUVPUVJUVSUVKUWBUWJYOUVOXMUWGUWHYOUVOPUWIYNUVNFTVRVSUWJUUAUVRXPUWH
      UWGUUAUVRPUWIYTUVQFTVTVSUWJUUFUWAXRUWIUWGUUFUWAPUWHUUEUVTFTWDVSWAWBWEUVEU
      UJUVLWCUVFYAUVEYSUVIUUDUVJUUIUVKUVEYRXMYOUVEYPAYQBUUSUUTUVDUQUUSUUTUVDWFZ
      WGWHUVEUUCXPUUAUVEYQBUUBCUWKUVAUVBUVCURZWGWHUVEUUHXRUUFUVEUUBCUUGAUWLUVAU
      VBUVCVAWGWHWAWIWJSSWKWLWKQWMLOWMLRWMLYMUUJWCWNWOWPYIYSUUDUUIEQORWMWMWMYBQ
      PZYDYOYHYRUWMYCYNFYBQGTWQUWMYEYPYGYQYBQDTUWMYFODUWMYFQOUGUHOYBQOUGWRWSWTW
      QWGXAYBOPZYDUUAYHUUCUWNYCYTFYBOGTWQUWNYEYQYGUUBYBODTUWNYFRDUWNYFOOUGUHRYB
      OOUGWRXBWTWQWGXAYBRPZYDUUFYHUUHUWOYCUUEFYBRGTWQUWOYEUUBYGUUGYBRDTUWOYFUMD
      UWOYFROUGUHUMYBROUGWRXCWTWQWGXAXDXFWEYAYIEYKYLYKYLPYAYKQUMUJUHYLYJUMQUJAB
      CDFGIJXEXGXHXIXJXKWJ $.

    $( Lemma for ~ constr3pth .  (Contributed by Alexander van der Vekens,
       13-Nov-2017.) $)
    constr3pthlem1 $p |- ( ( B e. V /\ C e. W )
           -> ( P |` ( 1 ..^ ( # ` F ) ) ) = { <. 1 , B >. , <. 2 , C >. } ) $=
      ( wcel cc0 c1 c2 c3 cun cres wceq co c0 wa cop cpr chash cfv cfzo reseq1i
      csn df-pr resundir eqtri ax-1ne0 necomi 2ne0 nelpri ressnop0 ax-mp uneq1i
      wn uncom un0 wrel cdm wss cr wfun jctl adantr funsng funrel 3syl dmsnopss
      1re snsspr1 sstri relssres sylancl syl5eq 1lt3 gtneii 2lt3 uneq2i cz mpan
      2re 2z syl adantl snsspr2 uneq12d 3eqtr4g wb id cmin cfz constr3lem2 3nn0
      oveq2i nn0zi fzoval caddc 3m1e2 df-2 1z fzpr 1p1e2 preq2i 3eqtri reseq12d
      a1i eqeq1d sylibr ) BGKZCHKZUAZLAUBZMBUBZUCZNCUBZOAUBZUCZPZMNUCZQZXQXSUCZ
      RZDMFUDUEZUFSZQZYERZXOXRYCQZYAYCQZPXQUHZXSUHZPYDYEXOYKYMYLYNXOYKXPUHZYCQZ
      YMYCQZPZYMYKYOYMPZYCQYRXRYSYCXPXQUIUGYOYMYCUJUKXOYRTYQPZYMYPTYQLYCKUSYPTR
      LMNMLULUMNLUNUMUOLAYCUPUQURXOYTYQYMYTYQTPYQTYQUTYQVAUKXOYMVBZYMVCZYCVDYQY
      MRXOMVEKZXMUAZYMVFUUAXMUUDXNXMUUCVMVGVHMBVEGVIYMVJVKUUBMUHYCMBVLMNVNVOYMY
      CVPVQVRVRVRXOYLYNYCQZXTUHZYCQZPZYNYLYNUUFPZYCQUUHYAUUIYCXSXTUIUGYNUUFYCUJ
      UKXOUUHUUETPZYNUUGTUUEOYCKUSUUGTROMNMOVMVSVTNOWEWAVTUOOAYCUPUQWBXOUUJUUEY
      NUUEVAXOYNVBZYNVCZYCVDUUEYNRXNUUKXMXNYNVFZUUKNWCKXNUUMWFNCWCHVIWDYNVJWGWH
      UULNUHYCNCVLMNWIVOYNYCVPVQVRVRVRWJXRYAYCUJXQXSUIWKDYBRZYJYFWLJUUNYIYDYEUU
      NDYBYHYCUUNWMYHYCRUUNYHMOUFSZMOMWNSZWOSZYCYGOMUFABCDEFIJWPWROWCKUUOUUQROW
      QWSMOWTUQUUQMMMXASZWOSZMUURUCZYCUUPUURMWOUUPNUURXBXCUKWRMWCKUUSUUTRXDMXEU
      QUURNMXFXGXHXHXJXIXKUQXL $.

    $( Lemma for ~ constr3pth .  (Contributed by Alexander van der Vekens,
       13-Nov-2017.) $)
    constr3pthlem2 $p |- ( ( ( A e. V /\ B e. V /\ C e. V ) /\ B =/= C )
                        -> Fun `' ( P |` ( 1 ..^ ( # ` F ) ) ) ) $=
      ( wcel wa c1 ccnv wfun cop c2 cz adantr csn cun w3a wne chash cfv cfzo co
      cres cpr 3simpc 1z 2z pm3.2i a1i simpr funprg syl3anc cnvun wceq 3ad2ant2
      jctl cnvsng syl uneq12d syl5eq df-pr cnveqi 3eqtr4g funeqd constr3pthlem1
      3ad2ant3 mpbird 3adant1 cnveqd ) AGJZBGJZCGJZUAZBCUBZKZDLFUCUDUEUFUGZMZNL
      BOZPCOZUHZMZNZVSWFBLOZCPOZUHZNZVSVOVPKZLQJZPQJZKZVRWJVQWKVRVNVOVPUIRWNVSW
      LWMUJUKULUMVQVRUNBCLPGGQQUOUPVSWEWIVSWBSZWCSZTZMZWGSZWHSZTZWEWIVSWRWOMZWP
      MZTXAWOWPUQVSXBWSXCWTVSWLVOKZXBWSURVQXDVRVOVNXDVPVOWLUJUTUSRLBQGVAVBVSWMV
      PKZXCWTURVQXEVRVPVNXEVOVPWMUKUTVJRPCQGVAVBVCVDWDWQWBWCVEVFWGWHVEVGVHVKVSW
      AWEVSVTWDVQVTWDURZVRVOVPXFVNABCDEFGGHIVIVLRVMVHVK $.

    $( Lemma for ~ constr3pth .  (Contributed by Alexander van der Vekens,
       11-Nov-2017.) $)
    constr3pthlem3 $p |- ( ( ( A e. V /\ B e. V /\ C e. V )
                       /\ ( A =/= B /\ B =/= C /\ C =/= A ) )
                        -> ( ( P " { 0 , ( # ` F ) } )
                           i^i ( P " ( 1 ..^ ( # ` F ) ) ) ) = (/) ) $=
      ( cfv c3 wceq wcel cc0 cpr cima c1 co c2 cfz chash w3a wne wa cfzo cin c0
      constr3lem2 preq2 imaeq2d oveq2 ineq12d constr3lem6 wb wfn constr3trllem4
      wf ffn syl cuz cn0 3nn0 elnn0uz mpbi eluzfz1 mp1i eluzfz2 fnimapr syl3anc
      cmin cz nn0zi fzoval ax-mp 3m1e2 oveq2i eqtri imaeq2i caddc df-2 1z 1p1e2
      fzpr preq2i 3eqtri 1nn0 cle wbr 1re 3re 1lt3 ltleii elfz5 mpbiri a1i 2nn0
      mp2an 2re 2lt3 syl5eq eqeq1d adantr mpbird sylan9eq mpan ) FUAJZKLZAGMBGM
      CGMUBZABUCBCUCCAUCUBZUDZDNXFOZPZDQXFUERZPZUFZUGLABCDEFHIUHXGXJXODNKOZPZDQ
      KUERZPZUFZUGXGXLXQXNXSXGXKXPDXFKNUIUJXGXMXRDXFKQUEUKUJULXJXTUGLZNDJKDJOZQ
      DJSDJOZUFZUGLZABCDEFGHIUMXHYAYEUNXIXHXTYDUGXHXQYBXSYCXHDNKTRZUOZNYFMZKYFM
      ZXQYBLXHYFGDUQYGABCDEFGHIUPYFGDURUSZKNUTJZMZYHXHKVAMYLVBKVCVDZNKVEVFYLYIX
      HYMNKVGVFYFNKDVHVIXHXSDQSTRZPZYCXRYNDXRQKQVJRZTRZYNKVKMZXRYQLKVBVLZQKVMVN
      YPSQTVOVPVQVRXHYODQSOZPZYCYNYTDYNQQQVSRZTRZQUUBOZYTSUUBQTVTVPQVKMUUCUUDLW
      AQWCVNUUBSQWBWDWEVRXHYGQYFMZSYFMZUUAYCLYJUUEXHQYKMZYRUUEQVAMUUGWFQVCVDYSU
      UGYRUDUUEQKWGWHQKWIWJWKWLQNKWMWNWQWOUUFXHSYKMZYRUUFSVAMUUHWPSVCVDYSUUHYRU
      DUUFSKWGWHSKWRWJWSWLSNKWMWNWQWOYFQSDVHVIWTWTULXAXBXCXDXE $.

    $( Lemma for ~ constr3cycl .  (Contributed by Alexander van der Vekens,
       11-Nov-2017.) $)
    constr3cycllem1 $p |- ( ( A e. V /\ B e. V /\ C e. V )
                            -> ( P ` 0 ) = ( P ` ( # ` F ) ) ) $=
      ( wcel w3a cc0 cfv c3 chash wceq c1 wa c2 constr3lem4 constr3lem2 syl6eqr
      simpll simprr eqtr4d syl fveq2i ) AGJBGJCGJKZLDMZNDMZFOMZDMUHUIAPZQDMBPZR
      ZSDMCPZUJAPZRZRZUIUJPABCDEFGHITURUIAUJULUMUQUCUNUOUPUDUEUFUKNDABCDEFHIUAU
      GUB $.

    $( Construction of a trail from three given edges in a graph.  (Contributed
       by Alexander van der Vekens, 13-Nov-2017.) $)
    constr3trl $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V )
        /\ ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
        -> F ( V Trails E ) P ) $=
      ( vk wcel w3a cpr co cvv wa wi cfv sylan ex wbr ctrail usgrav constr3lem1
      cusg crn cdm cword ccnv wfun cc0 chash cfz wf cv c1 wceq cfzo wral simplr
      constr3trllem1 constr3trllem2 constr3trllem3 ad2antlr constr3trllem5 3jca
      caddc jca wb istrl ad2antrr sylibrd mpan2 mpcom 3imp ) GEUEUAZAGKBGKCGKLZ
      ABMEUFZKBCMVRKCAMVRKLZFDGEUBNUAZGOKEOKPZVPVQVSVTQZQZEGUCWAFOKDOKPZVPWCQAB
      CDEFHIUDWAWDPZVPWCWEVPPZVQWBWFVQPZVSFEUGUHKZFUIUJZPZUKFULRZUMNGDUNZJUOZFR
      ERWMDRWMUPVGNDRMUQJUKWKURNUSZLZVTWGVSWOWGVSPZWJWLWNWPWHWIWGVPVSWHWEVPVQUT
      ZABCDEFGHIVASWGVPVSWIWQABCDEFGHIVBSVHVQWLWFVSABCDEFGHIVCVDWGVPVSWNWQABCDJ
      EFGHIVESVFTWEVTWOVIVPVQDJEFGOOOOVJVKVLTTVMVNVO $.

    $( Construction of a path from three given edges in a graph.  (Contributed
       by Alexander van der Vekens, 13-Nov-2017.) $)
    constr3pth $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V )
        /\ ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
        -> F ( V Paths E ) P ) $=
      ( wbr wcel w3a cpr co cvv wa wi cima wne ex cusg cpath usgrav constr3lem1
      crn ctrail c1 chash cfv cfzo cres ccnv wfun cc0 cin simpr ad2antrr simplr
      c0 constr3trl syl3anc 3cycl3dv ad2antlr imp simp2d constr3pthlem2 syl2anc
      wceq constr3pthlem3 3jca wb ispth sylibrd mpan2 mpcom 3imp ) GEUAJZAGKBGK
      CGKLZABMEUEZKBCMVSKCAMVSKLZFDGEUBNJZGOKEOKPZVQVRVTWAQZQZEGUCWBFOKDOKPZVQW
      DQABCDEFHIUDWBWEPZVQWDWFVQPZVRWCWGVRPZVTFDGEUFNJZDUGFUHUIZUJNZUKULUMZDUNW
      JMRDWKRUOUSVHZLZWAWHVTWNWHVTPZWIWLWMWOVQVRVTWIWGVQVRVTWFVQUPUQWGVRVTURZWH
      VTUPABCDEFGHIUTVAWOVRBCSZWLWPWOABSZWQCASZWHVTWRWQWSLZVQVTWTQWFVRVQVTWTABC
      EGVBTVCVDZVEABCDEFGHIVFVGWOVRWTWMWPXAABCDEFGHIVIVGVJTWFWAWNVKVQVRDEFGOOOO
      VLUQVMTTVNVOVP $.

    $( Construction of a 3-cycle from three given edges in a graph.
       (Contributed by Alexander van der Vekens, 13-Nov-2017.) $)
    constr3cycl $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V )
        /\ ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
        -> ( F ( V Cycles E ) P /\ ( # ` F ) = 3 ) ) $=
      ( cusg wbr wcel w3a cpr co cfv wceq wa cvv wi crn ccycl chash constr3lem1
      c3 usgrav cpath cc0 constr3pth 3expa adantlll constr3cycllem1 ad2antlr wb
      iscycl ad3antrrr mpbir2and constr3lem2 jctir exp41 mpan2 mpcom 3imp ) GEJ
      KZAGLBGLCGLMZABNEUAZLBCNVFLCANVFLMZFDGEUBOKZFUCPZUEQZRZGSLESLRZVDVEVGVKTT
      ZEGUFVLFSLDSLRZVDVMTABCDEFHIUDVLVNRZVDVEVGVKVOVDRZVERVGRZVHVJVQVHFDGEUGOK
      ZUHDPVIDPQZVDVEVGVRVOVDVEVGVRABCDEFGHIUIUJUKVEVSVPVGABCDEFGHIULUMVOVHVRVS
      RUNVDVEVGDEFGSSSSUOUPUQABCDEFHIURUSUTVAVBVC $.

    $( Construction of a 3-cycle from three given edges in a graph, containing
       an endpoint of one of these edges.  (Contributed by Alexander van der
       Vekens, 17-Nov-2017.) $)
    constr3cyclp $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V )
        /\ ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
        -> ( F ( V Cycles E ) P /\ ( # ` F ) = 3 /\ ( P ` 0 ) = A ) ) $=
      ( cusg wbr wcel w3a cpr crn ccycl cfv c3 wceq wa co chash cc0 constr3cycl
      wi simprl simprr c1 c2 constr3lem4 simpll syl adantr 3jca ex 3ad2ant2 mpd
      ) GEJKZAGLBGLCGLMZABNEOZLBCNUTLCANUTLMZMFDGEPUAKZFUBQRSZTZVBVCUCDQASZMZAB
      CDEFGHIUDUSURVDVFUEVAUSVDVFUSVDTVBVCVEUSVBVCUFUSVBVCUGUSVEVDUSVEUHDQBSZTU
      IDQCSRDQASTZTVEABCDEFGHIUJVEVGVHUKULUMUNUOUPUQ $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d C f p $.  $d E f p $.  $d V f p $.
    $( If there are three (different) vertices in a graph which are mutually
       connected by edges, there is a 3-cycle in the graph containing one of
       these vertices.  (Contributed by Alexander van der Vekens,
       17-Nov-2017.) $)
    constr3cyclpe $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V )
        /\ ( { A , B } e. ran E /\ { B , C } e. ran E /\ { C , A } e. ran E ) )
     -> E. f E. p ( f ( V Cycles E ) p /\ ( # ` f ) = 3 /\ ( p ` 0 ) = A ) ) $=
      ( wbr wcel w3a cpr cc0 cfv cop c1 c2 c3 chash wceq cv cusg crn ccnv ccycl
      ctp cun co wex eqid constr3cyclp tpex prex unex wa breq12 wb fveq2 eqeq1d
      adantr fveq1 adantl 3anbi123d spc2ev syl ) FEUAHAFIBFICFIJABKZEUBZIBCKZVF
      ICAKZVFIJJLVEEUCZMNZOVGVIMNZPVHVIMNZUEZLANZOBNZKZPCNZQANZKZUFZFEUDUGZHZVM
      RMZQSZLVTMZASZJZDTZGTZWAHZWHRMZQSZLWIMZASZJZGUHDUHABCVTEVMFVMUIVTUIUJWOWG
      DGVMVTVJVKVLUKVPVSVNVOULVQVRULUMWHVMSZWIVTSZUNWJWBWLWDWNWFWHVMWIVTWAUOWPW
      LWDUPWQWPWKWCQWHVMRUQURUSWQWNWFUPWPWQWMWEALWIVTUTURVAVBVCVD $.
  $}

  ${
    $d E a b c f p $.  $d V a b c f p $.
    $( If there are three (different) vertices in a graph which are mutually
       connected by edges, there is a 3-cycle in the graph.  (Contributed by
       Alexander van der Vekens, 14-Nov-2017.) $)
    3v3e3cycl2 $p |- ( V USGrph E -> ( E. a e. V E. b e. V E. c e. V
             ( { a , b } e. ran E /\ { b , c } e. ran E /\ { c , a } e. ran E )
               -> E. f E. p ( f ( V Cycles E ) p /\ ( # ` f ) = 3 ) ) ) $=
      ( cv cpr wcel wrex wa wex wbr cfv c3 wceq exbii 19.41v cop crn cusg ccycl
      w3a co chash df-rex anbi2i bitri ancom bitr4i anbi1i anass 3bitr2i cc0 c1
      ccnv c2 ctp cun simprr simprl simplr simplll adantr constr3cycl syl131anc
      eqid eximi 2eximi tpex prex breq12 wb fveq2 eqeq1d anbi12d spc2ev exlimiv
      unex exlimivv syl sylbi sylbir expcom syl5bi ) EHZFHZIZBUAZJWHGHZIZWJJWKW
      GIZWJJUDZGCKZFCKZECKZWGCJZWHCJZWKCJZWNLZGMZLZFMZLZEMZCBUBNZAHZDHZCBUCUEZN
      ZXHUFOZPQZLZDMAMZWQWRWPLZEMXFWPECUGXPXEEWPXDWRWPWSWOLZFMXDWOFCUGXQXCFWOXB
      WSWNGCUGUHRUIUHRUIXFXGXOXFXGLXEXGLZEMZXOXEXGESXSXAWSLZWRXGLZLZGMZFMZEMZXO
      XRYDEXRXCWRLZFMZXGLYFXGLZFMYDXEYGXGXEXDWRLYGWRXDUJXCWRFSUKULYFXGFSYHYCFYH
      XCYALZYCXCWRXGUMYIXTGMZYALYCXCYJYAXCXBWSLYJWSXBUJXAWSGSUKULXTYAGSUKUIRUNR
      YEUOWIBUQZOTZUPWLYKOTZURWMYKOTZUSZUOWGTZUPWHTZIZURWKTZPWGTZIZUTZXJNZYOUFO
      ZPQZLZGMZFMEMXOYCUUGEFYBUUFGYBXGWRWSWTWNUUFXTWRXGVAXTWRXGVBXAWSYAVCWTWNWS
      YAVDXTWNYAWTWNWSVCVEWGWHWKUUBBYOCYOVHUUBVHVFVGVIVJUUGXOEFUUFXOGXNUUFADYOU
      UBYLYMYNVKYRUUAYPYQVLYSYTVLVTXHYOQZXIUUBQZLXKUUCXMUUEXHYOXIUUBXJVMUUHXMUU
      EVNUUIUUHXLUUDPXHYOUFVOVPVEVQVRVSWAWBWCWDWEWF $.

    $( If and only if there is a 3-cycle in a graph, there are three
       (different) vertices in the graph which are mutually connected by
       edges.  (Contributed by Alexander van der Vekens, 14-Nov-2017.) $)
    3v3e3cycl $p |- ( V USGrph E -> (
               E. f E. p ( f ( V Cycles E ) p /\ ( # ` f ) = 3 )
           <-> E. a e. V E. b e. V E. c e. V ( { a , b } e. ran E
                           /\ { b , c } e. ran E /\ { c , a } e. ran E ) ) ) $=
      ( cusg wbr cv ccycl co chash cfv c3 wa wex cpr wcel wrex wceq crn wfun wi
      w3a usgrafun 19.41vv simpr simpll simplr 3v3e3cycl1 syl3anc sylbir expcom
      exlimivv syl 3v3e3cycl2 impbid ) CBHIZAJZDJZCBKLIZUTMNOUAZPZDQAQZEJZFJZRB
      UBZSVGGJZRVHSVIVFRVHSUEGCTFCTECTZUSBUCZVEVJUDBCUFVEVKVJVEVKPVDVKPZDQAQVJV
      DVKADUGVLVJADVLVKVBVCVJVDVKUHVBVCVKUIVBVCVKUJVABUTCEFGUKULUOUMUNUPABCDEFG
      UQUR $.
  $}

  ${
    $d E a b c d $.  $d E k $.  $d F k $.  $d P a b c d $.  $d P k $.
    $d V a b c d $.
    $( If there is a cycle of length 4 in a graph, there are four (different)
       vertices in the graph which are mutually connected by edges.
       (Contributed by Alexander van der Vekens, 9-Nov-2017.) $)
    4cycl4v4e $p |- ( ( Fun E /\ F ( V Cycles E ) P /\ ( # ` F ) = 4 )
       -> E. a e. V E. b e. V E. c e. V E. d e. V
                   ( ( { a , b } e. ran E /\ { b , c } e. ran E )
                /\ ( { c , d } e. ran E /\ { d , a } e. ran E ) ) ) $=
      ( co cfv c4 wceq wcel wa wi cvv cc0 c1 c2 c3 wfun ccycl wbr chash cpr crn
      vk cv wrex cn0 w3a cwalk cycliswlk wlkbprop cpath iscycl ctrail cfzo cres
      syl ccnv cima cin c0 ispth cdm cword cfz wf caddc istrl fzo0to42pr raleqi
      wral cun ralunb cz wb 0z 1z fveq2 fveq2d oveq1 0p1e1 syl6eq preq12d 1p1e2
      eqeq12d ralprg mp2an 2z 3nn0 nn0zi 2p1e3 3p1e4 3bitri preq2 eqcoms eqeq2d
      anbi12i anbi2d 4pos breq2 mpbiri 0nn0 jctil nvnencycllem sylan2 1lt4 1nn0
      clt anim12d 2lt4 2nn0 3lt4 adantlrr imp cuz cle 4nn0 3re 4re ltleii eluz2
      mpbir3an 4fvwrd4 preq12 adantr eleq1d simplr anbi12d reximdv com14 syl6bi
      mpan com12 3imp oveq2 a1d sylbid simprl adantl simprr simpll syl2im exp41
      biimpcd com35 com24 sylbi com13 feq2d raleqdv imbi1d imbi2d 3imtr4d 3impd
      3anbi23d imp3a 3adant1 mpcom ) BUAZCADBUBIUCZCUDJZKLZEUHZFUHZUEZBUFZMZUVG
      GUHZUEZUVIMZNZUVKHUHZUEZUVIMZUVOUVFUEZUVIMZNZNZHDUIZGDUIZFDUIZEDUIZUVCUVB
      UVEUWEOZUVDUJMZDPMBPMNZCPMAPMNZUKZUVCUVBUWFOZUVCCADBULIUCUWJABCDUMABCDUNU
      TUWHUWIUVCUWKOUWGUWHUWINZUVCCADBUOIUCZQAJZUVDAJZLZNUWKABCDPPPPUPUWLUWMUWP
      UWKUWLUWMCADBUQIUCZARUVDURIZUSVAUAZAQUVDUEVBAUWRVBVCVDLZUKUWPUWKOZABCDPPP
      PVEUWLUWQUWSUWTUXAUWLUWQCBVFVGMZCVAUAZNZQUVDVHIZDAVIZUGUHZCJZBJZUXGAJZUXG
      RVJIZAJZUEZLZUGQUVDURIZVNZUKZUWSUWTUXAOZOAUGBCDPPPPVKUXQUXRUWSUXQUXAUWTUV
      EUWPUVBUXQUWEUVEUWNKAJZLZUVBUXDQKVHIZDAVIZUXNUGQKURIZVNZUKZUWEOZOUWPUVBUX
      QUWEOZOUYEUXTUVBUVEUWEUXDUYBUYDUXTUWKOZUYDUYBUXDUYHUYDQCJZBJZUWNRAJZUEZLZ
      RCJZBJZUYKSAJZUEZLZNZSCJZBJZUYPTAJZUEZLZTCJZBJZVUBUXSUEZLZNZNZUYBUXDUYHOO
      UYDUXNUGQRUEZSTUEZVOZVNUXNUGVUKVNZUXNUGVULVNZNVUJUXNUGUYCVUMVLVMUXNUGVUKV
      ULVPVUNUYSVUOVUIQVQMRVQMVUNUYSVRVSVTUXNUYMUYRUGQRVQVQUXGQLZUXIUYJUXMUYLVU
      PUXHUYIBUXGQCWAWBVUPUXJUWNUXLUYKUXGQAWAVUPUXKRAVUPUXKQRVJIRUXGQRVJWCWDWEW
      BWFWHUXGRLZUXIUYOUXMUYQVUQUXHUYNBUXGRCWAWBVUQUXJUYKUXLUYPUXGRAWAVUQUXKSAV
      UQUXKRRVJISUXGRRVJWCWGWEWBWFWHWIWJSVQMTVQMZVUOVUIVRWKTWLWMZUXNVUDVUHUGSTV
      QVQUXGSLZUXIVUAUXMVUCVUTUXHUYTBUXGSCWAWBVUTUXJUYPUXLVUBUXGSAWAVUTUXKTAVUT
      UXKSRVJITUXGSRVJWCWNWEWBWFWHUXGTLZUXIVUFUXMVUGVVAUXHVUEBUXGTCWAWBVVAUXJVU
      BUXLUXSUXGTAWAVVAUXKKAVVAUXKTRVJIKUXGTRVJWCWOWEWBWFWHWIWJWTWPVUJUXTUXDUYB
      UWKUXTVUJUXDUYBUWKOOZUXTVUJUYSVUDVUFVUBUWNUEZLZNZNZVVBUXTVUIVVEUYSUXTVUHV
      VDVUDUXTVUGVVCVUFVUGVVCLUXSUWNUXSUWNVUBWQWRWSXAXAVVFUXDUVEUVBUYBUWEUVBUXD
      UVEVVFUYBUWEOZUVBUXDUVEVVFVVGUVBUXDNUVENZVVFNUYLUVIMZUYQUVIMZNZVUCUVIMZVV
      CUVIMZNZNZUYBUWNUVFLZUYKUVGLZNZUYPUVKLZVUBUVOLZNZNZHDUIZGDUIZFDUIZEDUIZUW
      EVVHVVFVVOUVBUXBUVEVVFVVOOUXCUVBUXBNZUVENZUYSVVKVVEVVNVWHUYMVVIUYRVVJUVEV
      WGQUJMZQUVDXKUCZNUYMVVIOUVEVWJVWIUVEVWJQKXKUCXBUVDKQXKXCXDXEXFUWNUYKBCQXG
      XHUVEVWGRUJMZRUVDXKUCZNUYRVVJOUVEVWLVWKUVEVWLRKXKUCXIUVDKRXKXCXDXJXFUYKUY
      PBCRXGXHXLVWHVUDVVLVVDVVMUVEVWGSUJMZSUVDXKUCZNVUDVVLOUVEVWNVWMUVEVWNSKXKU
      CXMUVDKSXKXCXDXNXFUYPVUBBCSXGXHUVEVWGTUJMZTUVDXKUCZNVVDVVMOUVEVWPVWOUVEVW
      PTKXKUCXOUVDKTXKXCXDWLXFVUBUWNBCTXGXHXLXLXPXQKTXRJMZUYBVWFVWQVURKVQMTKXSU
      CVUSKXTWMTKYAYBXOYCTKYDYEAKDEFGHYFYOVVOVWEUWDEDVVOVWDUWCFDVVOVWCUWBGDVVOV
      WBUWAHDVWBVVOUWAVWBVVKUVNVVNUVTVWBVVIUVJVVJUVMVWBUYLUVHUVIVVRUYLUVHLVWAUW
      NUYKUVFUVGYGYHYIVWBUYQUVLUVIVWBUYKUVGUYPUVKVVPVVQVWAYJVVRVVSVVTUUAWFYIYKV
      WBVVLUVQVVMUVSVWBVUCUVPUVIVWAVUCUVPLVVRUYPVUBUVKUVOYGUUBYIVWBVVCUVRUVIVWB
      VUBUVOUWNUVFVVRVVSVVTUUCVVPVVQVWAUUDWFYIYKYKUUGYLYLYLYLUUEUUFYMUUHYNYPUUI
      UUJUUKYQYMUVEUWOUXSUWNUVDKAWAWSUVEUYGUYFUVBUVEUXQUYEUWEUVEUXFUYBUXPUYDUXD
      UVEUXEUYADAUVDKQVHYRUULUVEUXNUGUXOUYCUVDKQURYRUUMUURUUNUUOUUPYMYSYSYNUUQY
      TUUSYTUUTUVAYPYQ $.
  $}

  $( In a simple graph, the vertices of a 4-cycle are mutually different.
     (Contributed by Alexander van der Vekens, 18-Nov-2017.) $)
  4cycl4dv $p |- ( ( V USGrph E
                     /\ ( F e. Word dom E /\ Fun `' F /\ ( # ` F ) = 4 ) )
    -> ( ( ( ( E ` ( F ` 0 ) ) = { A , B } /\ ( E ` ( F ` 1 ) ) = { B , C } )
        /\ ( ( E ` ( F ` 2 ) ) = { C , D } /\ ( E ` ( F ` 3 ) ) = { D , A } ) )
       -> ( ( ( { A , B } e. ran E /\ { B , C } e. ran E )
           /\ ( { C , D } e. ran E /\ { D , A } e. ran E ) )
         /\ ( ( A =/= B /\ A =/= C /\ A =/= D )
           /\ ( B =/= C /\ B =/= D /\ C =/= D ) ) ) ) ) $=
    ( wbr wcel cfv c4 wceq wa cc0 c1 c3 wi clt ex adantl cusg cdm ccnv wfun w3a
    cword chash cpr c2 crn wne usgrafun cn0 4pos breq2 mpbiri 0nn0 nvnencycllem
    jctil sylan2 1lt4 1nn0 anim12d 2lt4 2nn0 3lt4 3nn0 expcom com23 imp 3adant2
    mpan9 simpl usgraedgrn ad2antrr com12 preq1 eqeq2d prcom eqeq2i a1i anbi12d
    wb adantr eqtr3 wf1 usgraf1 cfzo co wf wrdf oveq2 feq2d cn 4nn lbfzo0 mpbir
    ffvelrn mpan2 elfzo0 mpbir3an jca syl6bi syl2an df-f1 f1eq2 mpanr12 ax-1ne0
    f1veqaeq syl nesymi pm2.21i syl6 sylbir 3imp syld syl5 adantrd expimpd ax-1
    sylbid pm2.61ine necomd 3jca preq2 3ne0 neii mpancom ) GEUAHZFEUBZUFIZFUCUD
    ZFUGJZKLZUEZMZNFJZEJZABUHZLZOFJZEJZBCUHZLZMZUIFJEJCDUHZLZPFJZEJZDAUHZLZMZMZ
    YSEUJZIZUUCUUNIZMZUUFUUNIZUUJUUNIZMZMZABUKZACUKZADUKZUEZBCUKZBDUKZCDUKZUEZM
    ZMZUVAYPUUMMZUVKYPUUMUVAYIEUDZYOUUMUVAQZEGULYKYNUVMUVNQZYLYKYNUVOYKUVMYNUVN
    UVMYKYNUVNQUVMYKMZYNUVNUVPYNMZUUEUUQUULUUTUVQYTUUOUUDUUPYNUVPNUMIZNYMRHZMYT
    UUOQYNUVSUVRYNUVSNKRHUNYMKNRUOUPUQUSABEFNURUTYNUVPOUMIZOYMRHZMUUDUUPQYNUWAU
    VTYNUWAOKRHZVAYMKORUOUPVBUSBCEFOURUTVCUVQUUGUURUUKUUSYNUVPUIUMIZUIYMRHZMUUG
    UURQYNUWDUWCYNUWDUIKRHVDYMKUIRUOUPVEUSCDEFUIURUTYNUVPPUMIZPYMRHZMUUKUUSQYNU
    WFUWEYNUWFPKRHZVFYMKPRUOUPVGUSDAEFPURUTVCVCSVHVIVJVKVLVJUVAUVLMZUVAUVJUVAUV
    LVMUWHUVEUVIUWHUVBUVCUVDUVAUVLUVBUUOUVLUVBQUUPUUTUVLUUOUVBYIUUOUVBQYOUUMYIU
    UOUVBEABGVNSVOVPVOVJUVLUVCUVAUVLUVCQACACLZYPUUMUVCUWIYPMZUUEUVCUULUWJUUEYRC
    BUHZLZUUBUWKLZMZUVCUWIUUEUWNWCYPUWIYTUWLUUDUWMUWIYSUWKYRACBVQVRUUDUWMWCUWIU
    UCUWKUUBBCVSVTWAWBWDYPUWNUVCQUWIUWNYRUUBLZYPUVCYRUUBUWKWEYPUWOYQUUALZUVCYIY
    JUUNEWFZYQYJIZUUAYJIZMZUWOUWPQYOEGWGZYKYNUWTYLYKNYMWHWIZYJFWJZYNUWTYJFWKZYN
    UXCNKWHWIZYJFWJZUWTYNUXBUXEYJFYMKNWHWLZWMZUXFUWRUWSUXFNUXEIZUWRUXIKWNIZWOKW
    PWQZUXEYJNFWRWSZUXFOUXEIZUWSUXMUVTUXJUWBVBWOVAOKWTXAZUXEYJOFWRWSXBXCVLVKYJU
    UNYQUUAEXIXDYOUWPUVCQZYIYKYLYNUXOYKUXCYLYNUXOQZQUXDUXCYLUXPUXCYLMZUXBYJFWFZ
    UXPUXBYJFXEZYNUXRUXOYNUXRUXEYJFWFZUXOYNUXBUXELUXRUXTWCUXGUXBUXEYJFXFXJZUXTU
    WPNOLZUVCUXTUXIUXMUWPUYBQUXKUXNUXEYJNOFXIXGUYBUVCONXHXKXLXMXCVPXNSXJXOTXPXQ
    TYAXRXSUVCUVLXTYBTUVAUVLUVDUUTUVLUVDQZUUQUUSUYCUURUVLUUSUVDYIUUSUVDQYOUUMYI
    UUSUVDYIUUSMDAEDAGVNYCSVOVPTTVJYDUWHUVFUVGUVHUVAUVLUVFUUQUVLUVFQZUUTUUPUYDU
    UOUVLUUPUVFYIUUPUVFQYOUUMYIUUPUVFEBCGVNSVOVPTWDVJUVLUVGUVAUVLUVGQBDBDLZYPUU
    MUVGUUMUYEYPMZUVGUUEUULUYFUVGQZYTUULUYGQUUDUULYTUYGUUKYTUYGQUUGUUKYTUYGUYFU
    UKYTMZUVGUYFUYHUUIADUHZLZYRUYILZMZUVGUYEUYHUYLWCYPUYEUUKUYJYTUYKUUKUYJWCUYE
    UUJUYIUUIDAVSVTWAUYEYSUYIYRBDAYEVRWBWDYPUYLUVGQUYEUYLUUIYRLZYPUVGUUIYRUYIWE
    YPUYMUUHYQLZUVGYIUWQUUHYJIZUWRMZUYMUYNQYOUXAYKYNUYPYLYKUXCYNUYPUXDYNUXCUXFU
    YPUXHUXFUYOUWRUXFPUXEIZUYOUYQUWEUXJUWGVGWOVFPKWTXAZUXEYJPFWRWSUXLXBXCVLVKYJ
    UUNUUHYQEXIXDYOUYNUVGQZYIYKYLYNUYSYKUXCYLYNUYSQZQUXDUXCYLUYTUXQUXRUYTUXSYNU
    XRUYSYNUXRUXTUYSUYAUXTUYNPNLZUVGUXTUYQUXIUYNVUAQUYRUXKUXEYJPNFXIXGVUAUVGPNY
    FYGXLXMXCVPXNSXJXOTXPXQTYAVPSTVPWDVJVPXSUVGUVLXTYBTUVAUVLUVHUUTUVLUVHQZUUQU
    URVUBUUSUVLUURUVHYIUURUVHQYOUUMYIUURUVHECDGVNSVOVPWDTVJYDXBXBYHS $.

  ${
    $d E a b c d $.  $d E k $.  $d F k $.  $d P a b c d $.  $d P k $.
    $d V a b c d $.
    $( If there is a cycle of length 4 in a graph, there are four (different)
       vertices in the graph which are mutually connected by edges.
       (Contributed by Alexander van der Vekens, 9-Nov-2017.) $)
    4cycl4dv4e $p |- ( ( V USGrph E /\ F ( V Cycles E ) P /\ ( # ` F ) = 4 )
       -> E. a e. V E. b e. V E. c e. V E. d e. V (
                   ( ( { a , b } e. ran E /\ { b , c } e. ran E )
                  /\ ( { c , d } e. ran E /\ { d , a } e. ran E ) )
               /\ ( ( a =/= b /\ a =/= c /\ a =/= d )
                  /\ ( b =/= c /\ b =/= d /\ c =/= d ) ) ) ) $=
      ( co cfv c4 wceq cpr wcel wa wi cvv cc0 c1 c3 vk cusg wbr ccycl chash crn
      cv wne w3a wrex cn0 cwalk cycliswlk wlkbprop syl cpath iscycl ctrail cfzo
      cres ccnv wfun cima cin c0 ispth cdm cword cfz wf caddc wral istrl c2 cun
      fzo0to42pr raleqi ralunb cz wb 0z fveq2 fveq2d oveq1 0p1e1 syl6eq preq12d
      1z eqeq12d 1p1e2 ralprg mp2an 3nn0 nn0zi 2p1e3 3p1e4 anbi12i 3bitri preq2
      2z eqcoms eqeq2d anbi2d simpll simplrl simplrr simpr 4cycl4dv imp cuz cle
      syl13anc 4nn0 3re 3lt4 ltleii eluz2 mpbir3an 4fvwrd4 preq12 adantr eleq1d
      simplr simprl anbi12d adantl simprr neeq12d 3anbi123d simpl reximdv com14
      4re mpan syl6bi com12 3imp oveq2 a1d sylbid exp41 com35 com24 sylbi com13
      biimpcd syl2im feq2d raleqdv 3anbi23d imbi1d imbi2d 3imtr4d 3impd 3adant1
      imp3a mpcom ) DBUBUCZCADBUDIUCZCUEJZKLZEUGZFUGZMZBUFZNZUVCGUGZMZUVENZOZUV
      GHUGZMZUVENZUVKUVBMZUVENZOZOZUVBUVCUHZUVBUVGUHZUVBUVKUHZUIZUVCUVGUHZUVCUV
      KUHZUVGUVKUHZUIZOZOZHDUJZGDUJZFDUJZEDUJZUUSUURUVAUWKPZUUTUKNZDQNBQNOZCQNA
      QNOZUIZUUSUURUWLPZUUSCADBULIUCUWPABCDUMABCDUNUOUWNUWOUUSUWQPUWMUWNUWOOZUU
      SCADBUPIUCZRAJZUUTAJZLZOUWQABCDQQQQUQUWRUWSUXBUWQUWRUWSCADBURIUCZASUUTUSI
      ZUTVAVBZARUUTMVCAUXDVCVDVELZUIUXBUWQPZABCDQQQQVFUWRUXCUXEUXFUXGUWRUXCCBVG
      VHNZCVAVBZOZRUUTVIIZDAVJZUAUGZCJZBJZUXMAJZUXMSVKIZAJZMZLZUARUUTUSIZVLZUIZ
      UXEUXFUXGPZPAUABCDQQQQVMUYCUYDUXEUYCUXGUXFUVAUXBUURUYCUWKUVAUWTKAJZLZUURU
      XJRKVIIZDAVJZUXTUARKUSIZVLZUIZUWKPZPUXBUURUYCUWKPZPUYKUYFUURUVAUWKUXJUYHU
      YJUYFUWQPZUYJUYHUXJUYNUYJRCJZBJZUWTSAJZMZLZSCJZBJZUYQVNAJZMZLZOZVNCJZBJZV
      UBTAJZMZLZTCJZBJZVUHUYEMZLZOZOZUYHUXJUYNPPUYJUXTUARSMZVNTMZVOZVLUXTUAVUQV
      LZUXTUAVURVLZOVUPUXTUAUYIVUSVPVQUXTUAVUQVURVRVUTVUEVVAVUORVSNSVSNVUTVUEVT
      WAWHUXTUYSVUDUARSVSVSUXMRLZUXOUYPUXSUYRVVBUXNUYOBUXMRCWBWCVVBUXPUWTUXRUYQ
      UXMRAWBVVBUXQSAVVBUXQRSVKISUXMRSVKWDWEWFWCWGWIUXMSLZUXOVUAUXSVUCVVCUXNUYT
      BUXMSCWBWCVVCUXPUYQUXRVUBUXMSAWBVVCUXQVNAVVCUXQSSVKIVNUXMSSVKWDWJWFWCWGWI
      WKWLVNVSNTVSNZVVAVUOVTWTTWMWNZUXTVUJVUNUAVNTVSVSUXMVNLZUXOVUGUXSVUIVVFUXN
      VUFBUXMVNCWBWCVVFUXPVUBUXRVUHUXMVNAWBVVFUXQTAVVFUXQVNSVKITUXMVNSVKWDWOWFW
      CWGWIUXMTLZUXOVULUXSVUMVVGUXNVUKBUXMTCWBWCVVGUXPVUHUXRUYEUXMTAWBVVGUXQKAV
      VGUXQTSVKIKUXMTSVKWDWPWFWCWGWIWKWLWQWRVUPUYFUXJUYHUWQUYFVUPUXJUYHUWQPPZUY
      FVUPVUEVUJVULVUHUWTMZLZOZOZVVHUYFVUOVVKVUEUYFVUNVVJVUJUYFVUMVVIVULVUMVVIL
      UYEUWTUYEUWTVUHWSXAXBXCXCVVLUXJUVAUURUYHUWKUURUXJUVAVVLUYHUWKPZUURUXJUVAV
      VLVVMUURUXJOZUVAOZVVLOUYRUVENZVUCUVENZOZVUIUVENZVVIUVENZOZOZUWTUYQUHZUWTV
      UBUHZUWTVUHUHZUIZUYQVUBUHZUYQVUHUHZVUBVUHUHZUIZOZOZUYHUWTUVBLZUYQUVCLZOZV
      UBUVGLZVUHUVKLZOZOZHDUJZGDUJZFDUJZEDUJZUWKVVOVVLVWLVVOUURUXHUXIUVAVVLVWLP
      UURUXJUVAXDUURUXHUXIUVAXEUURUXHUXIUVAXFVVNUVAXGUWTUYQVUBVUHBCDXHXLXIKTXJJ
      NZUYHVXCVXDVVDKVSNTKXKUCVVEKXMWNTKXNYMXOXPTKXQXRAKDEFGHXSYNVWLVXBUWJEDVWL
      VXAUWIFDVWLVWTUWHGDVWLVWSUWGHDVWSVWLUWGVWSVWBUVQVWKUWFVWSVVRUVJVWAUVPVWSV
      VPUVFVVQUVIVWSUYRUVDUVEVWOUYRUVDLVWRUWTUYQUVBUVCXTYAYBVWSVUCUVHUVEVWSUYQU
      VCVUBUVGVWMVWNVWRYCZVWOVWPVWQYDZWGYBYEVWSVVSUVMVVTUVOVWSVUIUVLUVEVWRVUIUV
      LLVWOVUBVUHUVGUVKXTYFYBVWSVVIUVNUVEVWSVUHUVKUWTUVBVWOVWPVWQYGZVWMVWNVWRXD
      ZWGYBYEYEVWSVWFUWAVWJUWEVWSVWCUVRVWDUVSVWEUVTVWSUWTUVBUYQUVCVXHVXEYHVWSUW
      TUVBVUBUVGVXHVXFYHVWSUWTUVBVUHUVKVXHVXGYHYIVWSVWGUWBVWHUWCVWIUWDVWSUYQUVC
      VUBUVGVXEVXFYHVWSUYQUVCVUHUVKVXEVXGYHVWRVWIUWDVTVWOVWRVUBUVGVUHUVKVWPVWQY
      JVWPVWQXGYHYFYIYEYEUUFYKYKYKYKUUGUUAYLUUBYOYPUUCUUDUUEYQYLUVAUXAUYEUWTUUT
      KAWBXBUVAUYMUYLUURUVAUYCUYKUWKUVAUXLUYHUYBUYJUXJUVAUXKUYGDAUUTKRVIYRUUHUV
      AUXTUAUYAUYIUUTKRUSYRUUIUUJUUKUULUUMYLYSYSYOUUNYTUUPYTUUOUUQYPYQ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
               Connected graphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c ConnGrph $.

  $( Extend class notation with connected graphs. $)
  cconngra $a class ConnGrph $.

  ${
    $d e v k n f p $.
    $( Define the class of all connected graphs.  A graph (or, more generally,
       any pair representing a structure consisting of "vertices" and "edges")
       is called connected if there is a path between every pair of (distinct)
       vertices.  The distinctness of the vertices is not necessary for the
       definition, because there is always a path (of length 0) from a vertex
       to itself, see ~ 0pthonv and ~ dfconngra1 .  (Contributed by Alexander
       van der Vekens, 2-Dec-2017.) $)
    df-conngra $a |- ConnGrph = { <. v , e >. |
                  A. k e. v A. n e. v E. f E. p f ( k ( v PathOn e ) n ) p } $.
  $}

  ${
    $d e f k n p v $.
    $( Alternative definition of the class of all connected graphs, requiring
       paths between distinct vertices.  (Contributed by Alexander van der
       Vekens, 3-Dec-2017.) $)
    dfconngra1 $p |- ConnGrph = { <. v , e >. | A. k e. v A. n e. ( v \ { k } )
                                      E. f E. p f ( k ( v PathOn e ) n ) p } $=
      ( cconngra cv cpthon wbr wex wral copab csn cdif df-conngra cvv wcel vex
      co wel wa cun difsnid eqcomd raleqdv ralunb syl6bb wi 0pthonv mp2an oveq2
      weq breqd 2exbidv ralsng mpbird biantrud bitr4d ralbiia opabbii eqtri ) G
      CHZFHZDHZEHZAHZBHZITZTZJZFKCKZEVGLZDVGLZABMVLEVGVENZOZLZDVGLZABMABCDEFPVN
      VRABVMVQDVGDAUAZVMVQVLEVOLZUBZVQVSVMVLEVPVOUCZLWAVSVLEVGWBVSWBVGVGVEUDUEU
      FVLEVPVOUGUHVSVTVQVSVTVCVDVEVEVITZJZFKCKZVGQRVHQRVSWEUIASBSCVHVEVGQQFUJUK
      VLWEEVEVGEDUMZVKWDCFWFVJWCVCVDVFVEVEVIULUNUOUPUQURUSUTVAVB $.
  $}

  ${
    $d V f k v $.  $d V e $.  $d V n $.  $d V p $.  $d E f k v $.  $d E e $.
    $d E n $.  $d E p $.  $d e f k v $.  $d e k p v $.  $d e k n v $.
    $d f n p $.
    $( The property of being a connected graph.  (Contributed by Alexander van
       der Vekens, 2-Dec-2017.) $)
    isconngra $p |- ( ( V e. X /\ E e. Y ) -> ( V ConnGrph E
          <-> A. k e. V A. n e. V E. f E. p f ( k ( V PathOn E ) n ) p ) ) $=
      ( vv ve cv cpthon co wbr wex wral cconngra wceq wa raleqbidv simpl oveq12
      oveqd breqd 2exbidv df-conngra brabga ) AKZHKZBKZCKZIKZJKZLMZMZNZHOAOZCUL
      PZBULPUHUIUJUKEDLMZMZNZHOAOZCEPZBEPIJEDQFGULERZUMDRZSZURVCBULEVDVEUAZVFUQ
      VBCULEVGVFUPVAAHVFUOUTUHUIVFUNUSUJUKULEUMDLUBUCUDUETTIJABCHUFUG $.

    $( The property of being a connected graph.  (Contributed by Alexander van
       der Vekens, 2-Dec-2017.) $)
    isconngra1 $p |- ( ( V e. X /\ E e. Y ) -> ( V ConnGrph E
                       <-> A. k e. V A. n e. ( V \ { k } )
                           E. f E. p f ( k ( V PathOn E ) n ) p ) ) $=
      ( vv ve cv cpthon co wbr wex csn cdif wral wceq raleqbidv cconngra oveq12
      wa simpl difeq1d oveqd breqd 2exbidv dfconngra1 brabga ) AKZHKZBKZCKZIKZJ
      KZLMZMZNZHOAOZCUOUMPZQZRZBUORUKULUMUNEDLMZMZNZHOAOZCEVAQZRZBERIJEDUAFGUOE
      SZUPDSZUCZVCVIBUOEVJVKUDZVLUTVGCVBVHVLUOEVAVMUEVLUSVFAHVLURVEUKULVLUQVDUM
      UNUOEUPDLUBUFUGUHTTIJABCHUIUJ $.
  $}

  ${
    $d E f k n p $.
    $( A class/graph without vertices is connected.  (Contributed by Alexander
       van der Vekens, 2-Dec-2017.) $)
    0conngra $p |- ( E e. V -> (/) ConnGrph E ) $=
      ( vf vp vk vn c0 cvv wcel cconngra wbr 0ex wa cv cpthon co wral isconngra
      wex ral0 mpbiri mpan ) GHIZABIZGAJKZLUCUDMUECNDNENFNGAOPPKDSCSFGQZEGQUFET
      CEFAGHBDRUAUB $.

    $d A f k n p $.
    $( A class/graph with (at most) one vertex is connected.  (Contributed by
       Alexander van der Vekens, 2-Dec-2017.) $)
    1conngra $p |- ( E e. V -> { A } ConnGrph E ) $=
      ( vf vp vk vn cvv wcel cconngra wbr cv co wex wral adantr wb wceq mpbird
      c0 csn wi cpthon simpr snex jctil snidg 0pthonv sylc oveq2 2exbidv ralsng
      wa breqd oveq1 ralbidv isconngra ex wn snprc 0conngra breq1 syl5ibr sylbi
      syl pm2.61i ) AHIZBCIZAUAZBJKZUBZVGVHVJVGVHUMZVJDLZELZFLZGLZVIBUCMZMZKZEN
      DNZGVIOZFVIOZVLWBVMVNAVPVQMZKZENDNZGVIOZVLWFVMVNAAVQMZKZENDNZVLVIHIZVHUMZ
      AVIIZWIVLVHWJVGVHUDAUEUFZVGWLVHAHUGPDBAVIHCEUHUIVGWFWIQVHWEWIGAHVPARZWDWH
      DEWNWCWGVMVNVPAAVQUJUNUKULPSVGWBWFQVHWAWFFAHVOARZVTWEGVIWOVSWDDEWOVRWCVMV
      NVOAVPVQUOUNUKUPULPSVLWKVJWBQWMDFGBVIHCEUQVESURVGUSVITRZVKAUTVHVJWPTBJKBC
      VAVITBJVBVCVDVF $.
  $}

  ${
    $d E f k n p $.  $d V f k n p $.
    $( A complete (undirected simple) graph is connected.  (Contributed by
       Alexander van der Vekens, 4-Dec-2017.) $)
    cusconngra $p |- ( V ComplUSGrph E -> V ConnGrph E ) $=
      ( vn vk vf vp cvv wcel wa wbr syl cv cpr wral co wex cfv adantr ralimdva
      ex ccusgra cconngra cusg cusisusgra usgrav crn csn cdif ccnv wceq simp-4l
      cpthon simpr eldifi anim12i wi cdm usgraf1o adantl prcom eleq1i f1ocnvfv2
      wf1o sylan2b 1pthon2v syl3anc expimpd iscusgra isconngra1 3imtr4d mpcom
      imp ) BGHAGHIZBAUAJZBAUBJZVNBAUCJZVMABUDABUEKVMVPCLZDLZMZAUFZHZCBVRUGZUHZ
      NZDBNZIELFLVRVQBAULOOJFPEPZCWCNZDBNZVNVOVMVPWEWHVMVPIZWDWGDBWIVRBHZIZWAWF
      CWCWKVQWCHZIZWAWFWMWAIVMWJVQBHZIZVRVQMZAUIQAQWPUJZWFVMVPWJWLWAUKWMWOWAWKW
      JWLWNWIWJUMVQBWBUNUORWMWAWQWKWAWQUPZWLWIWRWJWIAUQZVTAVCZWRVPWTVMABURUSWTW
      AWQWAWTWPVTHWQVSWPVTVQVRUTVAWSVTWPAVBVDTKRRVLVRVQEABGGFVEVFTSSVGDCABGGVHE
      DCABGGFVIVJVK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Vertex Degree
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c VDeg $.

  $( Extend class notation with the vertex degree function. $)
  cvdg $a class VDeg $.

  ${
    $d e f k n p u v x $.
    $( Define the vertex degree function (for an undirected multigraph).  To be
       appropriate for multigraphs, we have to double-count those edges that
       contain ` u ` "twice" (i.e. self-loops), this being represented as a
       singleton as the edge's value.  Since the degree of a vertex can be
       (positive) infinity (if the graph containing the vertex is not of finite
       size), the extended addition ` +e ` is used for the summation of the
       number of "ordinary" edges" and the number of "loops".  (Contributed by
       Mario Carneiro, 12-Mar-2015.)  (Revised by Alexander van der Vekens,
       20-Dec-2017.) $)
    df-vdgr $a |- VDeg = ( v e. _V , e e. _V |-> ( u e. v |->
      ( ( # ` { x e. dom e | u e. ( e ` x ) } ) +e
        ( # ` { x e. dom e | ( e ` x ) = { u } } ) ) ) ) $.
  $}

  ${
    $d e u v x A $.  $d e u v x E $.  $d e u v x V $.  $d e u v x W $.
    $d u x U $.  $d e u v x X $.
    $( The value of the vertex degree function.  (Contributed by Mario
       Carneiro, 12-Mar-2015.)  (Revised by Alexander van der Vekens,
       20-Dec-2017.) $)
    vdgrfval $p |- ( ( V e. W /\ E Fn A /\ A e. X ) -> ( V VDeg E ) =
      ( u e. V |-> ( ( # ` { x e. A | u e. ( E ` x ) } ) +e
        ( # ` { x e. A | ( E ` x ) = { u } } ) ) ) ) $=
      ( vv ve wcel cvv cv cfv cdm crab chash wceq cxad co cmpt wfn w3a csn cvdg
      cmpt2 df-vdgr a1i simprl simprr dmeqd simpl2 fndm syl eqtrd fveq1d eleq2d
      wa rabeqbidv fveq2d eqeq1d oveq12d mpteq12dv elex 3ad2ant1 3adant1 mptexg
      fnex ovmpt2d ) EFJZDCUAZCGJZUBZHIEDKKBHLZBLZALZILZMZJZAVPNZOZPMZVQVNUCZQZ
      AVSOZPMZRSZTZBEVNVODMZJZACOZPMZWHWBQZACOZPMZRSZTZUDKUDHIKKWGUEQVLAHBIUFUG
      VLVMEQZVPDQZUQZUQZBVMWFEWOVLWQWRUHWTWAWKWEWNRWTVTWJPWTVRWIAVSCWTVSDNZCWTV
      PDVLWQWRUIZUJWTVJXACQVIVJVKWSUKCDULUMUNZWTVQWHVNWTVOVPDXBUOZUPURUSWTWDWMP
      WTWCWLAVSCXCWTVQWHWBXDUTURUSVAVBVIVJEKJVKEFVCVDVJVKDKJVICGDVGVEVIVJWPKJVK
      BEWOFVFVDVH $.

    $( The value of the vertex degree function.  (Contributed by Mario
       Carneiro, 12-Mar-2015.)  (Revised by Alexander van der Vekens,
       20-Dec-2017.) $)
    vdgrval $p |- ( ( ( V e. W /\ E Fn A /\ A e. X ) /\ U e. V ) ->
      ( ( V VDeg E ) ` U ) = ( ( # ` { x e. A | U e. ( E ` x ) } ) +e
        ( # ` { x e. A | ( E ` x ) = { U } } ) ) ) $=
      ( vu wcel wfn co cfv cv crab chash csn wceq cxad rabbidv fveq2d cvdg cmpt
      w3a vdgrfval fveq1d eleq1 sneq eqeq2d oveq12d eqid ovex fvmpt sylan9eq )
      EFIDBJBGIUCZCEICEDUAKZLCHEHMZAMDLZIZABNZOLZUQUPPZQZABNZOLZRKZUBZLCUQIZABN
      ZOLZUQCPZQZABNZOLZRKZUNCUOVFAHBDEFGUDUEHCVEVNEVFUPCQZUTVIVDVMRVOUSVHOVOUR
      VGABUPCUQUFSTVOVCVLOVOVBVKABVOVAVJUQUPCUGUHSTUIVFUJVIVMRUKULUM $.

    $( The value of the vertex degree function (for graphs of finite size).
       (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Alexander van
       der Vekens, 21-Jan-2018.) $)
    vdgrfival $p |- ( ( ( V e. W /\ E Fn A /\ A e. Fin ) /\ U e. V ) ->
      ( ( V VDeg E ) ` U ) = ( ( # ` { x e. A | U e. ( E ` x ) } ) +
        ( # ` { x e. A | ( E ` x ) = { U } } ) ) ) $=
      ( wcel cfn wa co cfv crab chash wceq cr cn0 rabfi hashcl syl nn0red caddc
      wfn w3a cvdg cv csn cxad vdgrval jca 3ad2ant3 adantr rexadd eqtrd ) EFGZD
      BUBZBHGZUCZCEGZIZCEDUDJKCAUEDKZGZABLZMKZUTCUFNZABLZMKZUGJZVCVFUAJZABCDEFH
      UHUSVCOGZVFOGZIZVGVHNUQVKURUPUNVKUOUPVIVJUPVCUPVBHGVCPGVAABQVBRSTUPVFUPVE
      HGVFPGVDABQVERSTUIUJUKVCVFULSUM $.

    $( The vertex degree function is a function from vertices to nonnegative
       integers or plus infinity.  (Contributed by Alexander van der Vekens,
       20-Dec-2017.) $)
    vdgrf $p |- ( ( V e. W /\ E Fn A /\ A e. X )
                   -> ( V VDeg E ) : V --> ( NN0 u. { +oo } ) ) $=
      ( vu vx wcel w3a cn0 cpnf co cfv wceq wa wn cvv ad2antrl ex cxr wfn wf cv
      csn cun cvdg crab chash cxad cmpt wi caddc nn0addcl elun1 syl cr wb nn0re
      rexadd eleq1d syl2an mpbird a1d wo ianor wnel df-nel 3ad2ant3 hashinfxadd
      rabexg simpl syl3anc sylbir hashxrcl anim12ci 3adant3 xaddcom eqtrd pnfxr
      jaoi imp elexi snid olci elun mpbir syl6eqel sylbi pm2.61i fmptd vdgrfval
      eqid feq1d ) CDHZBAUAZAEHZIZCJKUDZUEZCBUFLZUBCWSFCFUCZGUCBMZHZGAUGZUHMZXB
      XAUDNZGAUGZUHMZUILZUJZUBWQFCXIWSXJXEJHZXHJHZOZWQXACHZOZXIWSHZUKZXMXPXOXMX
      PXEXHULLZWSHZXMXRJHXSXEXHUMXRJWRUNUOXKXEUPHZXHUPHZXPXSUQXLXEURXHURXTYAOXI
      XRWSXEXHUSUTVAVBVCXMPXKPZXLPZVDZXQXKXLVEYDXOXPYDXOOXIKWSYDXOXIKNZYBXOYEUK
      ZYCYBXEJVFZYFXEJVGYGXOYEYGXOOXDQHZXGQHZYGYEWQYHYGXNWPWNYHWOXCGAEVJVHZRWQY
      IYGXNWPWNYIWOXFGAEVJVHZRYGXOVKXDXGQQVIVLSVMYCXHJVFZYFXHJVGYLXOYEYLXOOYIYH
      YLYEWQYIYLXNYKRWQYHYLXNYJRYLXOVKYIYHYLIZXIXHXEUILZKYMXETHZXHTHZOZXIYNNYIY
      HYQYLYIYPYHYOXGQVNXDQVNVOVPXEXHVQUOXGXDQQVIVRVLSVMVTWAKWSHKJHZKWRHZVDYSYR
      KKTVSWBWCWDKJWRWEWFWGSWHWIXJWLWJWQCWSWTXJGFABCDEWKWMVB $.

    $( The vertex degree function on graphs of finite size is a function from
       vertices to nonnegative integers.  (Contributed by Mario Carneiro,
       12-Mar-2015.)  (Revised by Alexander van der Vekens, 20-Dec-2017.) $)
    vdgrfif $p |- ( ( V e. W /\ E Fn A /\ A e. Fin ) ->
      ( V VDeg E ) : V --> NN0 ) $=
      ( vu vx wcel cfn cn0 co wf cv cfv crab chash wceq wa cr rabfi 3syl hashcl
      wfn w3a cvdg csn cxad cmpt caddc jca 3ad2ant3 adantr rexadd syl nn0addcld
      nn0re simpl3 eqeltrd eqid fmptd vdgrfval feq1d mpbird ) CDGZBAUBZAHGZUCZC
      ICBUDJZKCIECELZFLBMZGZFANZOMZVIVHUEPZFANZOMZUFJZUGZKVFECVPIVQVFVHCGZQZVPV
      LVOUHJZIVSVLRGZVORGZQZVPVTPVFWCVRVEVCWCVDVEWAWBVEVKHGZVLIGZWAVJFASZVKUAZV
      LUOTVEVNHGZVOIGZWBVMFASZVNUAZVOUOTUIUJUKVLVOULUMVSVLVOVSVEWDWEVCVDVEVRUPZ
      WFWGTVSVEWHWIWLWJWKTUNUQVQURUSVFCIVGVQFEABCDHUTVAVB $.

    $( The degree of a vertex in an empty graph is zero, because there are no
       edges.  (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by
       Alexander van der Vekens, 20-Dec-2017.) $)
    vdgr0 $p |- ( ( V e. W /\ U e. V ) -> ( ( V VDeg (/) ) ` U ) = 0 ) $=
      ( vx wcel wa c0 co cfv crab chash wceq cxad cc0 cvv rab0 fveq2i hash0 0re
      eqtri cvdg cv csn wfn w3a id wf ffn mp1i 0ex a1i 3jca vdgrval sylan caddc
      f0 oveq12i cr rexadd mp2an 00id syl6eq ) BCEZABEZFABGUAHIZADUBGIZEZDGJZKI
      ZVFAUCLZDGJZKIZMHZNVCVCGGUDZGOEZUEVDVEVMLVCVCVNVOVCUFGGGUGVNVCGUPGGGUHUIV
      OVCUJUKULDGAGBCOUMUNVMNNUOHZNVMNNMHZVPVINVLNMVIGKIZNVHGKVGDPQRTVLVRNVKGKV
      JDPQRTUQNUREZVSVQVPLSSNNUSUTTVATVB $.
  $}

  ${
    $d x A $.  $d x B $.  $d x E $.  $d x F $.  $d x ph $.  $d x U $.
    $d x V $.  $d x X $.  $d x Y $.
    vdgrun.e $e |- ( ph -> E Fn A ) $.
    vdgrun.f $e |- ( ph -> F Fn B ) $.
    vdgrun.a $e |- ( ph -> A e. X ) $.
    vdgrun.b $e |- ( ph -> B e. Y ) $.
    vdgrun.i $e |- ( ph -> ( A i^i B ) = (/) ) $.
    vdgrun.ge $e |- ( ph -> V UMGrph E ) $.
    vdgrun.gf $e |- ( ph -> V UMGrph F ) $.
    vdgrun.u $e |- ( ph -> U e. V ) $.
    $( The degree of a vertex in the union of two graphs on the same vertex set
       is the sum of the degrees of the vertex in each graph.  (Contributed by
       Mario Carneiro, 12-Mar-2015.)  (Revised by Alexander van der Vekens,
       21-Dec-2017.) $)
    vdgrun $p |- ( ph -> ( ( V VDeg ( E u. F ) ) ` U ) =
      ( ( ( V VDeg E ) ` U ) +e ( ( V VDeg F ) ` U ) ) ) $=
      ( vx wcel cvv cv cun cfv crab chash csn wceq cxad co cvdg cab elun anbi1i
      wa wo andir bitri abbii df-rab unab 3eqtr4i wfn cin c0 adantr simpr fvun1
      syl112anc eleq2d rabbidva syl5eqr uneq12d syl5eq fveq2d rabexg syl ssrab2
      fvun2 wss ss2in mp2an syl5sseq ss0 hashunx syl3anc eqtrd oveq12d cxr cmnf
      eqeq1d wne hashxrcl hashnemnf jca cumg wrel relumgra brrelex sylancr fnun
      xadd4d wbr syl21anc unexg syl2anc vdgrval syl31anc 3eqtr4d ) ADRUAZEFUBZU
      CZSZRBCUBZUDZUEUCZXKDUFZUGZRXMUDZUEUCZUHUIZDXIEUCZSZRBUDZUEUCZYAXPUGZRBUD
      ZUEUCZUHUIZDXIFUCZSZRCUDZUEUCZYIXPUGZRCUDZUEUCZUHUIZUHUIZDGXJUJUIUCZDGEUJ
      UIUCZDGFUJUIUCZUHUIAXTYDYLUHUIZYGYOUHUIZUHUIYQAXOUUAXSUUBUHAXOYCYKUBZUEUC
      ZUUAAXNUUCUEAXNXIBSZXLUNZRUKZXICSZXLUNZRUKZUBZUUCXIXMSZXLUNZRUKUUFUUIUOZR
      UKXNUUKUUMUUNRUUMUUEUUHUOZXLUNUUNUULUUOXLXIBCULZUMUUEUUHXLUPUQURXLRXMUSUU
      FUUIRUTVAAUUGYCUUJYKAUUGXLRBUDYCXLRBUSAXLYBRBAUUEUNZXKYADUUQEBVBZFCVBZBCV
      CZVDUGZUUEXKYAUGAUURUUEJVEAUUSUUEKVEAUVAUUENVEAUUEVFBCEFXIVGVHZVIVJVKAUUJ
      XLRCUDYKXLRCUSAXLYJRCAUUHUNZXKYIDUVCUURUUSUVAUUHXKYIUGAUURUUHJVEAUUSUUHKV
      EAUVAUUHNVEAUUHVFBCEFXIVRVHZVIVJVKVLVMVNAYCTSZYKTSZYCYKVCZVDUGZUUDUUAUGAB
      HSZUVELYBRBHVOVPZACISZUVFMYJRCIVOVPZAUVGVDVSUVHAUUTUVGVDYCBVSYKCVSUVGUUTV
      SYBRBVQYJRCVQYCBYKCVTWANWBUVGWCVPYCYKTTWDWEWFAXSYFYNUBZUEUCZUUBAXRUVMUEAX
      RUUEXQUNZRUKZUUHXQUNZRUKZUBZUVMUULXQUNZRUKUVOUVQUOZRUKXRUVSUVTUWARUVTUUOX
      QUNUWAUULUUOXQUUPUMUUEUUHXQUPUQURXQRXMUSUVOUVQRUTVAAUVPYFUVRYNAUVPXQRBUDY
      FXQRBUSAXQYERBUUQXKYAXPUVBWJVJVKAUVRXQRCUDYNXQRCUSAXQYMRCUVCXKYIXPUVDWJVJ
      VKVLVMVNAYFTSZYNTSZYFYNVCZVDUGZUVNUUBUGAUVIUWBLYERBHVOVPZAUVKUWCMYMRCIVOV
      PZAUWDVDVSUWEAUUTUWDVDYFBVSYNCVSUWDUUTVSYERBVQYMRCVQYFBYNCVTWANWBUWDWCVPY
      FYNTTWDWEWFWGAYDYLYGYOAYDWHSZYDWIWKZAUVEUWHUVJYCTWLVPAUVEUWIUVJYCTWMVPWNA
      YLWHSZYLWIWKZAUVFUWJUVLYKTWLVPAUVFUWKUVLYKTWMVPWNAYGWHSZYGWIWKZAUWBUWLUWF
      YFTWLVPAUWBUWMUWFYFTWMVPWNAYOWHSZYOWIWKZAUWCUWNUWGYNTWLVPAUWCUWOUWGYNTWMV
      PWNXAWFAGTSZXJXMVBZXMTSZDGSZYRXTUGAWOWPGEWOXBUWPWQOGEWOWRWSZAUURUUSUVAUWQ
      JKNBCEFWTXCAUVIUVKUWRLMBCHIXDXEQRXMDXJGTTXFXGAYSYHYTYPUHAUWPUURUVIUWSYSYH
      UGUWTJLQRBDEGTHXFXGAUWPUUSUVKUWSYTYPUGUWTKMQRCDFGTIXFXGWGXH $.
  $}

  ${
    $d x A $.  $d x B $.  $d x E $.  $d x F $.  $d x ph $.  $d x U $.
    $d x V $.
    vdgrfiun.e $e |- ( ph -> E Fn A ) $.
    vdgrfiun.f $e |- ( ph -> F Fn B ) $.
    vdgrfiun.a $e |- ( ph -> A e. Fin ) $.
    vdgrfiun.b $e |- ( ph -> B e. Fin ) $.
    vdgrfiun.i $e |- ( ph -> ( A i^i B ) = (/) ) $.
    vdgrfiun.ge $e |- ( ph -> V UMGrph E ) $.
    vdgrfiun.gf $e |- ( ph -> V UMGrph F ) $.
    vdgrfiun.u $e |- ( ph -> U e. V ) $.
    $( The degree of a vertex in the union of two graphs (of finite size) on
       the same vertex set is the sum of the degrees of the vertex in each
       graph.  (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by
       Alexander van der Vekens, 21-Jan-2018.) $)
    vdgrfiun $p |- ( ph -> ( ( V VDeg ( E u. F ) ) ` U ) =
      ( ( ( V VDeg E ) ` U ) + ( ( V VDeg F ) ` U ) ) ) $=
      ( vx cfv wcel wceq co cv cun crab chash csn caddc cvdg wa cab elun anbi1i
      wo andir bitri abbii df-rab unab 3eqtr4i wfn cin c0 simpr fvun1 syl112anc
      adantr eleq2d rabbidva syl5eqr fvun2 uneq12d syl5eq fveq2d cfn wss ssrab2
      ssfi sylancl ss2in mp2an syl5sseq ss0 hashun syl3anc eqtrd eqeq1d oveq12d
      syl cn0 hashcl nn0cnd cvv cumg wrel wbr relumgra brrelex sylancr syl21anc
      add4d fnun unfi syl2anc vdgrfival syl31anc 3eqtr4d ) ADPUAZEFUBZQZRZPBCUB
      ZUCZUDQZXHDUEZSZPXJUCZUDQZUFTZDXFEQZRZPBUCZUDQZXRXMSZPBUCZUDQZUFTZDXFFQZR
      ZPCUCZUDQZYFXMSZPCUCZUDQZUFTZUFTZDGXGUGTQZDGEUGTQZDGFUGTQZUFTAXQYAYIUFTZY
      DYLUFTZUFTYNAXLYRXPYSUFAXLXTYHUBZUDQZYRAXKYTUDAXKXFBRZXIUHZPUIZXFCRZXIUHZ
      PUIZUBZYTXFXJRZXIUHZPUIUUCUUFULZPUIXKUUHUUJUUKPUUJUUBUUEULZXIUHUUKUUIUULX
      IXFBCUJZUKUUBUUEXIUMUNUOXIPXJUPUUCUUFPUQURAUUDXTUUGYHAUUDXIPBUCXTXIPBUPAX
      IXSPBAUUBUHZXHXRDUUNEBUSZFCUSZBCUTZVASZUUBXHXRSAUUOUUBHVEAUUPUUBIVEAUURUU
      BLVEAUUBVBBCEFXFVCVDZVFVGVHAUUGXIPCUCYHXIPCUPAXIYGPCAUUEUHZXHYFDUUTUUOUUP
      UURUUEXHYFSAUUOUUEHVEAUUPUUEIVEAUURUUELVEAUUEVBBCEFXFVIVDZVFVGVHVJVKVLAXT
      VMRZYHVMRZXTYHUTZVASZUUAYRSABVMRZXTBVNZUVBJXSPBVOZBXTVPVQZACVMRZYHCVNZUVC
      KYGPCVOZCYHVPVQZAUVDVAVNUVEAUUQUVDVAUVGUVKUVDUUQVNUVHUVLXTBYHCVRVSLVTUVDW
      AWGXTYHWBWCWDAXPYCYKUBZUDQZYSAXOUVNUDAXOUUBXNUHZPUIZUUEXNUHZPUIZUBZUVNUUI
      XNUHZPUIUVPUVRULZPUIXOUVTUWAUWBPUWAUULXNUHUWBUUIUULXNUUMUKUUBUUEXNUMUNUOX
      NPXJUPUVPUVRPUQURAUVQYCUVSYKAUVQXNPBUCYCXNPBUPAXNYBPBUUNXHXRXMUUSWEVGVHAU
      VSXNPCUCYKXNPCUPAXNYJPCUUTXHYFXMUVAWEVGVHVJVKVLAYCVMRZYKVMRZYCYKUTZVASZUV
      OYSSAUVFYCBVNZUWCJYBPBVOZBYCVPVQZAUVJYKCVNZUWDKYJPCVOZCYKVPVQZAUWEVAVNUWF
      AUUQUWEVAUWGUWJUWEUUQVNUWHUWKYCBYKCVRVSLVTUWEWAWGYCYKWBWCWDWFAYAYIYDYLAYA
      AUVBYAWHRUVIXTWIWGWJAYIAUVCYIWHRUVMYHWIWGWJAYDAUWCYDWHRUWIYCWIWGWJAYLAUWD
      YLWHRUWLYKWIWGWJWSWDAGWKRZXGXJUSZXJVMRZDGRZYOXQSAWLWMGEWLWNUWMWOMGEWLWPWQ
      ZAUUOUUPUURUWNHILBCEFWTWRAUVFUVJUWOJKBCXAXBOPXJDXGGWKXCXDAYPYEYQYMUFAUWMU
      UOUVFUWPYPYESUWQHJOPBDEGWKXCXDAUWMUUPUVJUWPYQYMSUWQIKOPCDFGWKXCXDWFXE $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.  $d x U $.  $d x V $.
    vdgr1.1 $e |- ( ph -> V e. _V ) $.
    vdgr1.2 $e |- ( ph -> A e. _V ) $.
    vdgr1.3 $e |- ( ph -> U e. V ) $.
    $( The vertex degree of a one-edge graph, case 4: an edge from a vertex to
       itself contributes two to the vertex's degree.  (Contributed by Mario
       Carneiro, 12-Mar-2015.)  (Revised by Alexander van der Vekens,
       22-Dec-2017.) $)
    vdgr1d $p |- ( ph ->
      ( ( V VDeg { <. A , { U } >. } ) ` U ) = 2 ) $=
      ( vx csn co cfv wcel crab chash wceq caddc cvv syl c1 fveq2d cvdg cv cxad
      cop c2 wfn wf1o snex f1osng sylancl f1ofn a1i vdgrval syl31anc hashrabrsn
      cr nn0rei rexadd sylancr wral snidg adantr elsni fvsng sylan9eqr eleqtrrd
      wa ralrimiva rabid2 sylibr hashsng eqtr3d oveq12d df-2 syl6eqr 3eqtrd ) A
      CDBCIZUDIZUAJKZCHUBZVRKZLZHBIZMZNKZWAVQOZHWCMZNKZUCJZWEWHPJZUEADQLVRWCUFZ
      WCQLZCDLZVSWIOEAWCVQIZVRUGZWKABQLZVQQLZWOFCUHZBVQQQUIUJWCWNVRUKRWLABUHULG
      HWCCVRDQQUMUNAWEUPLWHUPLZWIWJOWEWBHBUOUQWSAWHWFHBUOUQULWEWHURUSAWJSSPJUEA
      WESWHSPAWCNKZWESAWCWDNAWBHWCUTWCWDOAWBHWCAVTWCLZVGCVQWAACVQLZXAAWMXBGCDVA
      RVBXAAWABVRKZVQXAVTBVRVTBVCTAWPWQXCVQOFWRBVQQQVDUJVEZVFVHWBHWCVIVJTAWPWTS
      OFBQVKRZVLAWTWHSAWCWGNAWFHWCUTWCWGOAWFHWCXDVHWFHWCVIVJTXEVLVMVNVOVP $.

    vdgr1.4 $e |- ( ph -> B e. V ) $.
    vdgr1.5 $e |- ( ph -> B =/= U ) $.
    $( The vertex degree of a one-edge graph, case 2: an edge from the given
       vertex to some other vertex contributes one to the vertex's degree.
       (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Alexander van
       der Vekens, 22-Dec-2017.) $)
    vdgr1b $p |- ( ph ->
      ( ( V VDeg { <. A , { U , B } >. } ) ` U ) = 1 ) $=
      ( vx csn co cfv wcel chash wceq c1 cvv syl cpr cop cvdg cv crab caddc wfn
      cxad wf1o prex f1osng sylancl snex a1i vdgrval syl31anc hashrabrsn nn0rei
      f1ofn cr rexadd mp2an syl6eq cc0 wral wa prid1g adantr elsni fveq2d fvsng
      sylan9eqr eleqtrrd ralrimiva rabid2 sylibr hashsng eqtr3d prid2g necon3ai
      c0 wn wne nelneq2 syl2anc rabeq0 hash0 oveq12d ax-1cn addid1i eqtrd ) ADE
      BDCUAZUBLZUCMNZDKUDZWMNZOZKBLZUEZPNZWPDLZQZKWRUEZPNZUFMZRAWNWTXDUHMZXEAES
      OWMWRUGZWRSOZDEOZWNXFQFAWRWLLZWMUIZXGABSOZWLSOZXKGDCUJZBWLSSUKULWRXJWMUST
      XHABUMUNHKWRDWMESSUOUPWTUTOXDUTOXFXEQWTWQKBUQURXDXBKBUQURWTXDVAVBVCAXERVD
      UFMRAWTRXDVDUFAWRPNZWTRAWRWSPAWQKWRVEWRWSQAWQKWRAWOWROZVFZDWLWPADWLOZXPAX
      IXRHDCEVGTVHXPAWPBWMNZWLXPWOBWMWOBVIVJAXLXMXSWLQGXNBWLSSVKULVLZVMVNWQKWRV
      OVPVJAXLXORQGBSVQTVRAXDWAPNVDAXCWAPAXBWBZKWRVEXCWAQAYAKWRXQCWPOCXAOZWBZYA
      XQCWLWPACWLOZXPACEOYDIDCEVSTVHXTVMAYCXPACDWCYCJYBCDCDVIVTTVHCWPXAWDWEVNXB
      KWRWFVPVJWGVCWHRWIWJVCWK $.

    $( The vertex degree of a one-edge graph, case 3: an edge from some other
       vertex to the given vertex contributes one to the vertex's degree.
       (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Alexander van
       der Vekens, 22-Dec-2017.) $)
    vdgr1c $p |- ( ph ->
      ( ( V VDeg { <. A , { B , U } >. } ) ` U ) = 1 ) $=
      ( cpr cop csn cvdg co cfv c1 prcom opeq2i sneqi oveq2i fveq1i vdgr1b
      syl5eq ) ADEBCDKZLZMZNOZPDEBDCKZLZMZNOZPQDUHULUGUKENUFUJUEUIBCDRSTUAUBABC
      DEFGHIJUCUD $.

    vdgr1a.6 $e |- ( ph -> C e. V ) $.
    vdgr1a.7 $e |- ( ph -> C =/= U ) $.
    $( The vertex degree of a one-edge graph, case 1: an edge between two
       vertices other than the given vertex contributes nothing to the vertex
       degree.  (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by
       Alexander van der Vekens, 22-Dec-2017.) $)
    vdgr1a $p |- ( ph ->
      ( ( V VDeg { <. A , { B , C } >. } ) ` U ) = 0 ) $=
      ( vx cfv wcel chash wceq cc0 cvv cpr cop csn cvdg co crab cxad caddc wf1o
      cv wfn prex f1osng sylancl f1ofn syl snex a1i vdgrval syl31anc hashrabrsn
      cr nn0rei rexadd sylancr c0 wn wral wa wo wne necomd neanior sylib adantr
      jca elsni fveq2d fvsng sylan9eqr eleq2d elpri syl6bi mtod ralrimiva hash0
      rabeq0 sylibr syl6eq snidg eleq2 syl5ibrcom oveq12d 00id 3eqtrd ) AEFBCDU
      AZUBUCZUDUEOZENUJZWQOZPZNBUCZUFZQOZWTEUCZRZNXBUFZQOZUGUEZXDXHUHUEZSAFTPWQ
      XBUKZXBTPZEFPZWRXIRGAXBWPUCZWQUIZXKABTPZWPTPZXOHCDULZBWPTTUMUNXBXNWQUOUPX
      LABUQURINXBEWQFTTUSUTAXDVBPXHVBPZXIXJRXDXANBVAVCXSAXHXFNBVAVCURXDXHVDVEAX
      JSSUHUESAXDSXHSUHAXDVFQOZSAXCVFQAXAVGZNXBVHXCVFRAYANXBAWSXBPZVIZXAECREDRV
      JZAYDVGZYBAECVKZEDVKZVIYEAYFYGACEKVLADEMVLVPECEDVMVNVOYCXAEWPPYDYCWTWPEYB
      AWTBWQOZWPYBWSBWQWSBVQVRAXPXQYHWPRHXRBWPTTVSUNVTWAECDWBWCWDZWEXANXBWGWHVR
      WFWIAXHXTSAXGVFQAXFVGZNXBVHXGVFRAYJNXBYCXFXAYIYCXAXFEXEPZAYKYBAXMYKIEFWJU
      PVOWTXEEWKWLWDWEXFNXBWGWHVRWFWIWMWNWIWO $.
  $}

  ${
    $d E x $.  $d U x $.  $d V x $.
    $( The value of the vertex degree function for simple undirected graphs.
       (Contributed by Alexander van der Vekens, 20-Dec-2017.) $)
    vdusgraval $p |- ( ( V USGrph E /\ U e. V ) ->
           ( ( V VDeg E ) ` U ) = ( # ` { x e. dom E | U e. ( E ` x ) } ) ) $=
      ( wcel wa cfv wceq crab c0 co chash wi cvv cxad simpl adantl ex cc0 3syl
      cusg wbr cv csn cdm cvdg usgranloop0 wfn wfun usgrafun usgrav funfn dmexg
      w3a 3jca sylbi sylc anim1i vdgrval fveq2 hash0 syl6eq oveq2 adantr simprd
      cxr rabexg hashxrcl xaddid1 eqtrd syl com12 wb eqeq1 sylibrd anabsi5 mpd
      ) DCUAUBZBDEZFZAUCCGZBUDHACUEZIZJHZBDCUFKGZBWAEZAWBIZLGZHZABCDUGVRVSWDWIM
      ZVTVRWJVTDNEZCWBUHZWBNEZUNZVSFWEWHWCLGZOKZHZVRWJMVRWNVSVRCUIZWKCNEZFZWNCD
      UJCDUKZWRWLWTWNMCULWLWTWNWLWTFWKWLWMWTWKWLWKWSPQWLWTPWTWMWLWSWMWKCNUMZQQU
      ORUPUQURAWBBCDNNUSWQVRWJWQVRFWDWPWHHZWIVRWDXCMWQWDVRXCWDWOSHZVRXCMWDWOJLG
      SWCJLUTVAVBXDVRXCXDVRFZWPWHSOKZWHXDWPXFHVRWOSWHOVCVDXEWGNEZWHVFEXFWHHVRXG
      XDVRWSWMXGVRWKWSXAVEXBWFAWBNVGTQWGNVHWHVITVJRVKVLQWQWIXCVMVRWEWPWHVNVDVOR
      TVLVPVQ $.
  $}

  ${
    $d E v x $.  $d U v x $.  $d V v x $.
    $( If a vertex in a simple graph has degree 0, the vertex is not adjacent
       to another vertex via an edge.  (Contributed by Alexander van der
       Vekens, 8-Dec-2017.) $)
    vdusgra0nedg $p |- ( ( V USGrph E /\ U e. V /\ E e. Fin )
       -> ( ( ( V VDeg E ) ` U ) = 0 -> -. E. v e. V { U , v } e. ran E ) ) $=
      ( vx cusg wcel cfn cfv cc0 wceq cv wrex wn wb syl wi adantr syl5bi sylbid
      wbr w3a cvdg co cdm crab chash cpr crn vdusgraval 3adant3 eqeq1d c0 rabfi
      dmfi 3ad2ant3 hasheq0 wral rabeq0 ralnex wfun usgrafun 3ad2ant1 elrnrexdm
      wa prid1g eleq2 eqcoms syl5ibrcom 3ad2ant2 reximdv syld rexlimdva con3d )
      DCFUAZBDGZCHGZUBZBDCUCUDIZJKBELCIZGZECUEZUFZUGIZJKZBALZUHZCUIGZADMZNZVRVS
      WDJVOVPVSWDKVQEBCDUJUKULVRWEWCUMKZWJVRWCHGZWEWKOVQVOWLVPVQWBHGWLCUOWAEWBU
      NPUPWCHUQPWKWANEWBURZVRWJWAEWBUSWMWAEWBMZNVRWJWAEWBUTVRWIWNVRWHWNADVRWFDG
      ZVEZWHWGVTKZEWBMZWNWPCVAZWHWRQVRWSWOVOVPWSVQCDVBVCRECWGVDPWPWQWAEWBVRWQWA
      QZWOVPVOWTVQVPWAWQBWGGZBWFDVFWAXAOVTWGVTWGBVGVHVIVJRVKVLVMVNSSTT $.
  $}

  $( The degree of a vertex is either a nonnegative integer or positive
     infinity.  (Contributed by Alexander van der Vekens, 30-Dec-2017.) $)
  vdgrnn0pnf $p |- ( ( V USGrph E /\ X e. V )
                     -> ( ( V VDeg E ) ` X ) e. ( NN0 u. { +oo } ) ) $=
    ( cusg wbr wcel cn0 cpnf csn cun cvdg co wf cfv wa cvv cdm wfn w3a adantr
    wfun usgrafun usgrav simprl funfn dmexg ad2antll 3jca syl2anc vdgrf ffvelrn
    biimpi syl sylancom ) BADEZCBFZBGHIJZBAKLZMZCURNUQFUOUPOBPFZAAQZRZVAPFZSZUS
    UOVDUPUOAUAZUTAPFZOZVDABUBABUCVEVGOUTVBVCVEUTVFUDVEVBVGVEVBAUEULTVFVCVEUTAP
    UFUGUHUITVAABPPUJUMBUQCURUKUN $.

  ${
    $d E f i $.  $d U f i $.  $d V f i $.
    $( The size of the set of the neighbors of a vertex is the vertex degree of
       this vertex.  (Contributed by Alexander van der Vekens, 17-Dec-2017.) $)
    hashnbgravd $p |- ( ( V USGrph E /\ U e. V /\ E e. Fin )
             -> ( # ` ( <. V , E >. Neighbors U ) ) = ( ( V VDeg E ) ` U ) ) $=
      ( vi vf cusg wbr wcel cfn w3a cop cnbgra co chash cfv cv cdm crab 3adant3
      wceq cvdg wf1o wex nbgraf1o wb nbusgrafi 3ad2ant3 rabfi hasheqf1o syl2anc
      dmfi syl mpbird vdusgraval eqtr4d ) CBFGZACHZBIHZJZCBKALMZNOZADPBOHZDBQZR
      ZNOZACBUAMOZUSVAVETZUTVDEPUBEUCZUPUQVHURAEDBCUDSUSUTIHVDIHZVGVHUEBACUFUSV
      CIHZVIURUPVJUQBUKUGVBDVCUHULUTVDEUIUJUMUPUQVFVETURDABCUNSUO $.
  $}

  ${
    $d E f x $.  $d U f x $.  $d V f x $.
    $( The size of the set of the neighbors of a vertex is the vertex degree of
       this vertex, analogous to ~ hashnbgravd .  (Contributed by Alexander van
       der Vekens, 20-Dec-2017.) $)
    hashnbgravdg $p |- ( ( V USGrph E /\ U e. V )
            -> ( # ` ( <. V , E >. Neighbors U ) ) = ( ( V VDeg E ) ` U ) ) $=
      ( vx vf wcel wa cnbgra co chash cfv cv cfn wceq wi wn pm2.24 imp cpnf cvv
      cusg wbr cop cdm crab cvdg wf1o wex nbgraf1o syl5ibr edgusgranbfin syl6bi
      hasheqf1o com3l syl6bir com13 ovex a1i simpl hashinf syl2anr usgrav dmexg
      simprd rabexg 3syl adantr simpr eqtr4d ex 4cases vdusgraval ) CBUAUBZACFZ
      GZCBUCZAHIZJKZADLBKFZDBUDZUEZJKZACBUFIKVQMFZWAMFZVOVRWBNZOZVOWEWCWDGVQWAE
      LUGEUHAEDBCUIVQWAEUMUJWCWDPZWFVOWCWGWEVOWCWDWGWEODABCUKZWDWEQULUNRWCPZWDW
      FVOWDWIWEVOWDWCWIWEOWHWCWEQUOUPRWIWGGZVOWEWJVOGVRSWBVOVQTFZWIVRSNWJWKVOVP
      AHUQURWIWGUSVQTUTVAVOWATFZWGWBSNWJVMWLVNVMBTFZVTTFWLVMCTFWMBCVBVDBTVCVSDV
      TTVEVFVGWIWGVHWATUTVAVIVJVKDABCVLVI $.
  $}

  ${
    $d E v x $.  $d U v x $.  $d V v x $.
    $( If a vertex in a simple graph has degree 0, the vertex is not adjacent
       to another vertex via an edge, analogous to ~ vdusgra0nedg .
       (Contributed by Alexander van der Vekens, 20-Dec-2017.) $)
    usgravd0nedg $p |- ( ( V USGrph E /\ U e. V )
       -> ( ( ( V VDeg E ) ` U ) = 0 -> -. E. v e. V { U , v } e. ran E ) ) $=
      ( vx cusg wcel wa cfv cc0 wceq cv wrex wn cvv wb adantr wi syl5bi sylbid
      wbr cvdg co cdm crab chash cpr crn vdusgraval eqeq1d usgrav simprd rabexg
      dmexg hasheq0 4syl wral rabeq0 ralnex usgrafun elrnrexdm syl prid1g eleq2
      c0 wfun eqcoms syl5ibrcom ad2antlr reximdv syld rexlimdva con3d ) DCFUAZB
      DGZHZBDCUBUCIZJKBELCIZGZECUDZUEZUFIZJKZBALZUGZCUHGZADMZNZVPVQWBJEBCDUIUJV
      PWCWAVEKZWHVPCOGZVTOGWAOGWCWIPVNWJVOVNDOGWJCDUKULQCOUNVSEVTOUMWAOUOUPWIVS
      NEVTUQZVPWHVSEVTURWKVSEVTMZNVPWHVSEVTUSVPWGWLVPWFWLADVPWDDGZHZWFWEVRKZEVT
      MZWLWNCVFZWFWPRVPWQWMVNWQVOCDUTQQECWEVAVBWNWOVSEVTVOWOVSRVNWMVOVSWOBWEGZB
      WDDVCVSWRPVRWEVRWEBVDVGVHVIVJVKVLVMSSTT $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
               Eulerian paths and the Konigsberg Bridge problem
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Eulerian paths
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c EulPaths $.

  $( Extend class notation with Eulerian paths. $)
  ceup $a class EulPaths $.

  ${
    $d e f k n p u v x $.
    $( Define the set of all Eulerian paths on an undirected multigraph.
       (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    df-eupa $a |- EulPaths = ( v e. _V , e e. _V |-> { <. f , p >. |
      ( v UMGrph e /\ E. n e. NN0 ( f : ( 1 ... n ) -1-1-onto-> dom e /\
      p : ( 0 ... n ) --> v /\ A. k e. ( 1 ... n ) ( e ` ( f ` k ) ) =
          { ( p ` ( k - 1 ) ) , ( p ` k ) } ) ) } ) $.
  $}

  ${
    $d e f k n p v x A $.  $d e f k n p v x E $.  $d e f k n p v x F $.
    $d e f k n p v x P $.  $d e f k n p v x V $.  $d e f k n p v x W $.
    $d e f k n p v x X $.  $d k N $.
    $( The set ` ( V EulPaths E ) ` of all Eulerian paths on ` <. V , E >. ` is
       a set of pairs by our definition of an Eulerian path, and so is a
       relation.  (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    releupa $p |- Rel ( V EulPaths E ) $=
      ( vv ve vn vf vp vk cv cumg wbr c1 cfz co cdm wf1o cc0 wf cfv cvv cpr w3a
      cmin wceq wral cn0 wrex wa ceup df-eupa relmpt2opab ) CIZDIZJKLEIZMNZUMOF
      IZPQUNMNULGIZRHIZUPSUMSURLUCNUQSURUQSUAUDHUOUEUBEUFUGUHCDFGTTBAUICDFHEGUJ
      UK $.

    $( The property " ` <. F , P >. ` is an Eulerian path on the graph
       ` <. V , E >. ` ".  An Eulerian path is defined as bijection ` F ` from
       the edges to a set ` 1 ... N ` a function ` P : ( 0 ... N ) --> V ` into
       the vertices such that for each ` 1 <_ k <_ N ` , ` F ( k ) ` is an edge
       from ` P ( k - 1 ) ` to ` P ( k ) ` .  (Since the edges are undirected
       and there are possibly many edges between any two given vertices, we
       need to list both the edges and the vertices of the path separately.)
       (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Mario
       Carneiro, 3-May-2015.) $)
    iseupa $p |- ( dom E = A ->
      ( F ( V EulPaths E ) P <-> ( V UMGrph E /\
        E. n e. NN0 ( F : ( 1 ... n ) -1-1-onto-> A /\
        P : ( 0 ... n ) --> V /\ A. k e. ( 1 ... n ) ( E ` ( F ` k ) ) =
          { ( P ` ( k - 1 ) ) , ( P ` k ) } ) ) ) ) $=
      ( vf vp wceq cvv wcel wa co cv cfv cn0 a1i wb cn vv cdm ceup wbr cumg cfz
      ve c1 wf1o cc0 wf cmin cpr wral w3a wrex df-eupa brovmpt2ex wrel relumgra
      wi brrelex12 mpan f1of ovex sylancl mpan2 anim12i 3adant3 rexlimivw copab
      cmpt2 breq12 adantl simprr dmeqd simplr eqtrd f1oeq3 feq3 ad2antrl fveq1d
      fex syl eqeq1d ralbidv 3anbi123d rexbidv anbi12d opabbidv simplll simpllr
      cpm wss simpr dmexg eqeltrrd adantr nnex simpr1 elfznn ssriv elpm2r nn0ex
      syl22anc simpr2 elfznn0 jca ex rexlimdvw adantld ssopab2dv cxp df-xp xpex
      eqeltrri ssexg ovmpt2d breqd f1oeq1 feq1 fveq1 fveq2d preq12d anbi2d eqid
      eqeq12d brabga ad2antlr bitrd expcom pm5.21ndd ) EUBZAJZGKLZEKLZMZFKLZBKL
      ZMZMZFBGEUCNZUDZGEUEUDZUHDOZUFNZAFUIZUJUUEUFNZGBUKZCOZFPZEPZUUJUHULNZBPZU
      UJBPZUMZJZCUUFUNZUOZDQUPZMZUUCUUAVAYNUAOZUGOZUEUDZUUFUVCUBZHOZUIZUUHUVBIO
      ZUKZUUJUVFPZUVCPZUUMUVHPZUUJUVHPZUMZJZCUUFUNZUOZDQUPZMZUAUGHIBEFUCGUAUGHC
      DIUQZURRUVAUUAVAYNUUDYQUUTYTUEUSUUDYQUTGEUEVBVCUUSYTDQUUGUUIYTUURUUGYRUUI
      YSUUGUUFAFUKUUFKLYRUUFAFVDUHUUEUFVEUUFAKFWCVFUUIUUHKLYSUJUUEUFVEUUHGKBWCV
      GVHVIVJVHRUUAYNUUCUVASUUAYNMZUUCFBUUDUUFAUVFUIZUUHGUVHUKZUVJEPZUVNJZCUUFU
      NZUOZDQUPZMZHIVKZUDZUVAUWAUUBUWJFBUWAUAUGGEKKUVSHIVKZUWJUCKUCUAUGKKUWLVLJ
      UWAUVTRUWAUVBGJZUVCEJZMZMZUVSUWIHIUWPUVDUUDUVRUWHUWOUVDUUDSUWAUVBGUVCEUEV
      MVNUWPUVQUWGDQUWPUVGUWBUVIUWCUVPUWFUWPUVEAJUVGUWBSUWPUVEYMAUWPUVCEUWAUWMU
      WNVOZVPUUAYNUWOVQVRUVEAUUFUVFVSWDUWMUVIUWCSUWAUWNUVBGUUHUVHVTWAUWPUVOUWEC
      UUFUWPUVKUWDUVNUWPUVJUVCEUWQWBWEWFWGWHWIWJYOYPYTYNWKZYOYPYTYNWLZUWAUWJUVF
      ATWMNZLZUVHGQWMNZLZMZHIVKZWNUXEKLUWJKLUWAUWIUXDHIUWAUWHUXDUUDUWAUWGUXDDQU
      WAUWGUXDUWAUWGMZUXAUXCUXFAKLZTKLZUUFAUVFUKZUUFTWNZUXAUWAUXGUWGUWAYMAKUUAY
      NWOUWAYPYMKLUWSEKWPWDWQWRUXHUXFWSRUXFUWBUXIUWAUWBUWCUWFWTUUFAUVFVDWDUXJUX
      FCUUFTUUJUUEXAXBRATUUFUVFKKXCXEUXFYOQKLZUWCUUHQWNZUXCUWAYOUWGUWRWRUXKUXFX
      DRUWAUWBUWCUWFXFUXLUXFCUUHQUUJUUEXGXBRGQUUHUVHKKXCXEXHXIXJXKXLUWTUXBXMUXE
      KHIUWTUXBXNUWTUXBATWMVEGQWMVEXOXPUWJUXEKXQVFXRXSYTUWKUVASYQYNUWIUVAHIFBUW
      JKKUVFFJZUVHBJZMZUWHUUTUUDUXOUWGUUSDQUXOUWBUUGUWCUUIUWFUURUXMUWBUUGSUXNUU
      FAUVFFXTWRUXNUWCUUISUXMUUHGUVHBYAVNUXOUWEUUQCUUFUXOUWDUULUVNUUPUXMUWDUULJ
      UXNUXMUVJUUKEUUJUVFFYBYCWRUXOUVLUUNUVMUUOUXOUUMUVHBUXMUXNWOZWBUXOUUJUVHBU
      XPWBYDYGWFWGWHYEUWJYFYHYIYJYKYL $.

    $( If an eulerian path exists, then ` <. V , E >. ` is a graph.
       (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    eupagra $p |- ( F ( V EulPaths E ) P -> V UMGrph E ) $=
      ( vn vk ceup co wbr cumg c1 cv cfz cdm wf1o cc0 wf cfv cmin wceq cpr wral
      w3a cn0 wrex wa wb eqid iseupa ax-mp simplbi ) CADBGHIZDBJIZKELZMHZBNZCOP
      UNMHDAQFLZCRBRUQKSHARUQARUATFUOUBUCEUDUEZUPUPTULUMURUFUGUPUHUPAFEBCDUIUJU
      K $.

    $( Properties of an Eulerian path.  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    eupai $p |- ( ( F ( V EulPaths E ) P /\ E Fn A ) ->
      ( ( ( # ` F ) e. NN0 /\ F : ( 1 ... ( # ` F ) ) -1-1-onto-> A /\
        P : ( 0 ... ( # ` F ) ) --> V ) /\ A. k e. ( 1 ... ( # ` F ) )
         ( E ` ( F ` k ) ) = { ( P ` ( k - 1 ) ) , ( P ` k ) } ) ) $=
      ( vn co wbr wa c1 cfz cc0 cfv wceq cn0 wcel wb syl cfn ceup wfn wf1o cmin
      cv wf cpr wral w3a wrex chash cumg cdm iseupa biimpac simprd wi cen f1ofn
      fndm ad2antll fzfid fndmeng syl2anc hashen mpbird hashfz1 ad2antrl eqtr3d
      mpbid simprl eqeltrd a1d simprr oveq2d f1oeq2 feq2d biimprd 3jcad raleqdv
      enfi anim12d exp3a expr 3impd rexlimdva mpd ) EBFDUAHIZDAUBZJZKGUEZLHZAEU
      CZMWKLHZFBUFZCUEZENDNWPKUDHBNWPBNUGOZCWLUHZUIZGPUJZEUKNZPQZKXALHZAEUCZMXA
      LHZFBUFZUIZWQCXCUHZJZWJFDULIZWTWIWHXJWTJZWIDUMAOWHXKRADUTABCGDEFUNSUOUPWJ
      WSXIGPWJWKPQZJWMWOWRXIWJXLWMWOWRXIUQUQWJXLWMJJZWOWRXIXMWOXGWRXHXMWOXBXDXF
      XMXBWOXMXAWKPXMWLUKNZXAWKXMXNXAOZWLEURIZXMEWLUBZWLTQZXPWMXQWJXLWLAEUSVAXM
      KWKVBZWLTEVCVDZXMXRETQZXOXPRXSXMXRYAXSXMXPXRYARXTWLEWASVJWLEVEVDVFXLXNWKO
      WJWMWKVGVHVIZWJXLWMVKVLVMXMXDWOXMXDWMWJXLWMVNXMXCWLOXDWMRXMXAWKKLYBVOZXCW
      LAEVPSVFVMXMXFWOXMXEWNFBXMXAWKMLYBVOVQVRVSXMXHWRXMWQCXCWLYCVTVRWBWCWDWEWF
      WG $.

    ${
      $d e f k n p v $.  $d E k l x y $.  $d F k l x y $.  $d G k l n $.
      $d P k l n $.  $d E n $.  $d F n $.  $d V k n $.
      eupatrl.f $e |- G = ( x e. ( 0 ..^ ( # ` F ) ) |-> ( F ` ( x + 1 ) ) ) $.
      $( An Eulerian path is a trail.

         Unfortunately, the edge function ` F ` of an Eulerian path has the
         domain ` ( 1 ... ( # `` F ) ) ` , whereas the edge functions of all
         kinds of walks defined here have the domain ` ( 0 ..^ ( # `` F ) ) `
         (i.e. the edge functions are "words of edge indices", see discussion
         and proposal of Mario Carneiro at
~ https://groups.google.com/d/msg/metamath/KdVXdL3IH3k/2-BYcS_ACQAJ ).
         Therefore, the arguments of the edge function of an Eulerian path must
         be shifted by 1 to obtain an edge function of a trail in this theorem,
         using the auxiliary theorems above ( ~ fargshiftlem , ~ fargshiftfv ,
         etc.).  TODO:  The definition of an Eulerian path and all related
         theorems should be modified to fit to the general definition of a
         trail.  (Contributed by Alexander van der Vekens, 24-Nov-2017.) $)
      eupatrl $p |- ( F ( V EulPaths E ) P -> G ( V Trails E ) P ) $=
        ( vk cvv wcel wa co cv c1 cfz cc0 cfv wceq wi adantr vv ve vn vf vp wbr
        ceup ctrail cumg cdm wf1o cmin cpr wral w3a cn0 wrex df-eupa brovmpt2ex
        vl chash cfzo caddc cmpt ovex mptex eqeltri a1i anim1i anim2i syl cword
        wf ccnv wfun wfn f1ofn fseq1hash sylan2 ancoms f1of1 fargshiftf1 expcom
        wf1 wfo f1ofo fargshiftfo df-f1o sylanbrc hashfn hashfzo0 eqeq2d biimpa
        imp sylan pm3.2 syl5com mpcom sylancom df-f1 iswrdi ad4antr simprbi jca
        sylbi eqcom biimpi ad3antlr oveq2d feq2d f1of fargshiftlem simpll fveq2
        wb fveq2d adantl oveq1 cc elfzoelz zcnd ax-1cn pncand sylan9eqr preq12d
        eqeq12d ex simprl simpr fargshiftfv eqcomd syl2anc eqeq1d mpancom com24
        imp31 oveq2 raleqdv eqcoms 3imtr4d bitrd rspcdv ralrimiv imbi2d syl5ibr
        com23 3jca exp31 f1oeq2 eleq1 anbi12d imbi1d imbi12d 3imp rexlimiv eqid
        com12 iseupa mp1i istrl ) FIJCIJKZEIJZBIJZKZKZDBFCUGLUFZEBFCUHLUFZUVFUV
        ADIJZUVCKZKUVEUAMZUBMZUIUFNUCMZOLZUVKUJUDMZUKPUVLOLZUVJUEMZVMHMZUVNQUVK
        QUVQNULLZUVPQUVQUVPQUMRHUVMUNUOUCUPUQKUAUBUDUEBCDUGFUAUBUDHUCUEURUSUVIU
        VDUVAUVHUVBUVCUVBUVHEAPDVAQZVBLZAMNVCLDQZVDIGAUVTUWAPUVSVBVEVFVGVHVIVJV
        KUVEFCUIUFZUVMCUJZDUKZUVOFBVMZUVQDQZCQZUVRBQZUVQBQZUMZRZHUVMUNZUOZUCUPU
        QZKZEUWCVLJZEVNVOZKZPEVAQZOLZFBVMZUTMZEQZCQZUXBBQZUXBNVCLZBQZUMZRZUTPUW
        SVBLZUNZUOZUVFUVGUWOUXLSUVEUWNUXLUWBUWMUXLUCUPUWMUVLUPJZUXLUWDUWEUWLUXM
        UXLSUWDUXMUWLUWEUXLUWDUXMUWLUWEUXLSZSZUVSUVLRZUWDUXMKZUXOUXMUWDUXPUWDUX
        MDUVMVPUXPUVMUWCDVQDUVLVRVSVTUXPNUVSOLZUWCDUKZUVSUPJZKZUWKHUXRUNZPUVSOL
        ZFBVMZUXLSZSZUXQUXOUYAUYFSUXPUVTUWCEUKZUWSUVSRZKZUYAUYFUXSUXTUYGUYIUYAU
        VTUWCEWDZUVTUWCEWEZUYGUXSUXTUYJUXSUXRUWCDWDZUXTUYJSUXRUWCDWAUXTUYLUYJAC
        DEUVSGWBWCVKWNUXSUXTUYKUXSUXRUWCDWEZUXTUYKSUXRUWCDWFUXTUYMUYKACDEUVSGWG
        WCVKWNUVTUWCEWHZWIUXTUWSUVTVAQZRZKZUYGUXTKZUYIUYGEUVTVPZUXTUYQUVTUWCEVQ
        UXTUYSUYQUYSUYPUXTUVTEWJVJVTWOUYQUYHUYRUYIUXTUYPUYHUXTUYOUVSUWSUVSWKWLW
        MUYGUYHUYISUXTUYGUYHWPTWQWRWSUYIUYAKZUYBUYDUXLUYTUYBKZUYDKZUWRUXAUXKVUB
        UWPUWQUYGUWPUYHUYAUYBUYDUYGUYJUYKKZUWPUYNUYJUWPUYKUYJUVTUWCEVMZUWQKUWPU
        VTUWCEWTZVUDUWPUWQUWCUVSEXATXETXEXBUYGUWQUYHUYAUYBUYDUYGVUCUWQUYNUYJUWQ
        UYKUYJVUDUWQVUEXCTXEXBXDVUAUYDUXAVUAUYCUWTFBVUAUVSUWSPOUYHUVSUWSRZUYGUY
        AUYBUYHVUFUWSUVSXFXGXHXIXJWMVUAUXKUYDUYIUYAUYBUXKUYHUYAUYBUXKSZSUYGUYAV
        UGUYHUYBUXIUTUVTUNZSZUXSUXTVUIUXSUXRUWCDVMZUXTVUISUXRUWCDXKUXTVUJVUIUXT
        VUJKZUYBVUHVUKUYBKUXIUTUVTUXTVUJUYBUXBUVTJZUXISUXTVULUYBVUJUXIUXTVULUYB
        VUJUXISSZUXFUXRJZUXTVULKZVUMUVSUXBXLVUNVUOKZVUJUYBUXIVUPVUJUYBUXISVUPVU
        JKZUWKUXIHUXFUXRVUNVUOVUJXMVUQUVQUXFRZKZUWKUXFDQZCQZUXHRZUXIVUQVURUWKVV
        BXOZVUPVURVVCSZVUJVUOVVDVUNVUOVURVVCVUOVURKZUWGVVAUWJUXHVURUWGVVARVUOVU
        RUWFVUTCUVQUXFDXNXPXQVVEUWHUXEUWIUXGVVEUVRUXBBVURVUOUVRUXFNULLUXBUVQUXF
        NULXRVUOUXBNVULUXBXSJUXTVULUXBUXBPUVSXTYAXQNXSJVUOYBVHYCYDXPVURUWIUXGRV
        UOUVQUXFBXNXQYEYFYGXQTWNVUSVVAUXDUXHVUSVUTUXCCVUSVUKVULVUTUXCRVUQVUKVUR
        VUPUXTVUJVUNUXTVULYHVITVUOVULVUNVUJVURUXTVULYIXHVUKVULKUXCVUTVUKVULUXCV
        UTRACDEUVSUXBGYJWNYKYLXPYMUUAUUBYGUUFYNYGYOYPUUCYGWCVKWNUYHUXKVUHUYBUYH
        UXIUTUXJUVTUWSUVSPVBYQYRUUDUUEXQYPTUUGUUHYNVHUXPUWDUXSUXMUXTUXPUVMUXRRZ
        UWDUXSXOVVFUVLUVSUVLUVSNOYQYSZUVMUXRUWCDUUIVKUXMUXTXOUVLUVSUVLUVSUPUUJY
        SUUKUXPUWLUYBUXNUYEUXPUWKHUVMUXRVVGYRUXPUWEUYDUXLUXPUVOUYCFBUVOUYCRUVLU
        VSUVLUVSPOYQYSXJUULUUMYTWRYGYOUUNUUQUUOXQVHUWCUWCRUVFUWOXOUVEUWCUUPUWCB
        HUCCDFUURUUSBUTCEFIIIIUUTYTWR $.
    $}

    $( An Eulerian path has length ` # ( F ) ` , which is an integer.
       (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    eupacl $p |- ( F ( V EulPaths E ) P -> ( # ` F ) e. NN0 ) $=
      ( vk ceup co wbr chash cfv cn0 wcel c1 cfz cdm wf1o cc0 wf w3a cv cpr wfn
      cmin wceq wral wa cumg c2 cle cpw csn cdif crab eupagra umgraf2 ffn eupai
      c0 3syl mpdan simpld simp1d ) CADBFGHZCIJZKLZMVDNGZBOZCPZQVDNGDARZVCVEVHV
      ISZETZCJBJVKMUCGAJVKAJUAUDEVFUEZVCBVGUBZVJVLUFVCDBUGHVGVKIJUHUIHEDUJURUKU
      LUMZBRVMABCDUNEBDUOVGVNBUPUSVGAEBCDUQUTVAVB $.

    $( The ` F ` function in an Eulerian path is a bijection from a one-based
       sequence to the set of edges.  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    eupaf1o $p |- ( ( F ( V EulPaths E ) P /\ E Fn A ) ->
      F : ( 1 ... ( # ` F ) ) -1-1-onto-> A ) $=
      ( vx ceup co wbr wfn wa chash cfv cn0 wcel c1 cfz wf1o cc0 wf w3a cv cmin
      cpr wceq wral eupai simpld simp2d ) DBECGHICAJKZDLMZNOZPUKQHZADRZSUKQHEBT
      ZUJULUNUOUAFUBZDMCMUPPUCHBMUPBMUDUEFUMUFABFCDEUGUHUI $.

    $( Any graph with an Eulerian path is finite.  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    eupafi $p |- ( ( F ( V EulPaths E ) P /\ E Fn A ) -> A e. Fin ) $=
      ( ceup co wbr wfn wa c1 chash cfv cfz cfn wcel cen fzfid wf1o eupaf1o
      ovex f1oen ensym 3syl enfii syl2anc ) DBECFGHCAIJZKDLMZNGZOPAUIQHZAOPUGKU
      HRUGUIADSUIAQHUJABCDETUIADKUHNUAUBUIAUCUDAUIUEUF $.

    $( The ` P ` function in an Eulerian path is a function from a zero-based
       finite sequence to the vertices.  (Contributed by Mario Carneiro,
       12-Mar-2015.) $)
    eupapf $p |- ( F ( V EulPaths E ) P -> P : ( 0 ... ( # ` F ) ) --> V ) $=
      ( vx ceup co wbr chash cfv cn0 wcel c1 cfz cdm wf1o cc0 wf w3a cv cpr wfn
      cmin wceq wral wa cumg c2 cle cpw csn cdif crab eupagra umgraf2 ffn eupai
      c0 3syl mpdan simpld simp3d ) CADBFGHZCIJZKLZMVDNGZBOZCPZQVDNGDARZVCVEVHV
      ISZETZCJBJVKMUCGAJVKAJUAUDEVFUEZVCBVGUBZVJVLUFVCDBUGHVGVKIJUHUIHEDUJURUKU
      LUMZBRVMABCDUNEBDUOVGVNBUPUSVGAEBCDUQUTVAVB $.

    $( The ` N ` -th edge in an eulerian path is the edge from ` P ( N - 1 ) `
       to ` P ( N ) ` .  (Contributed by Mario Carneiro, 12-Mar-2015.) $)
    eupaseg $p |- ( ( F ( V EulPaths E ) P /\ N e. ( 1 ... ( # ` F ) ) ) ->
      ( E ` ( F ` N ) ) = { ( P ` ( N - 1 ) ) , ( P ` N ) } ) $=
      ( vk ceup co wbr cfv c1 cmin cpr wceq chash cfz wcel wf fveq2 fveq2d wral
      cv cn0 cdm wf1o cc0 w3a wfn wa cumg cle cpw csn cdif crab eupagra umgraf2
      c2 c0 ffn 3syl eupai mpdan simprd oveq1 preq12d eqeq12d rspccva sylan ) C
      AEBGHIZFUBZCJZBJZVKKLHZAJZVKAJZMZNZFKCOJZPHZUAZDVTQDCJZBJZDKLHZAJZDAJZMZN
      ZVJVSUCQVTBUDZCUEUFVSPHEARUGZWAVJBWIUHZWJWAUIVJEBUJIWIVKOJURUKIFEULUSUMUN
      UOZBRWKABCEUPFBEUQWIWLBUTVAWIAFBCEVBVCVDVRWHFDVTVKDNZVMWCVQWGWMVLWBBVKDCS
      TWMVOWEVPWFWMVNWDAVKDKLVETVKDASVFVGVHVI $.
  $}

  ${
    $d k n A $.  $d k n F $.  $d k n G $.  $d k n H $.  $d k n N $.  $d k ph $.
    $d x E $.  $d k n Q $.  $d k n x V $.
    $( There is an Eulerian path on the empty graph.  (Contributed by Mario
       Carneiro, 7-Apr-2015.) $)
    eupa0 $p |- ( ( V e. W /\ A e. V ) ->
      (/) ( V EulPaths (/) ) { <. 0 , A >. } ) $=
      ( vn vk wcel wa c0 wbr c1 cfz co wf1o cc0 csn wf cfv wceq cn0 a1i cumg cv
      cop cmin cpr wral w3a wrex ceup umgra0 adantr 0nn0 f1o0 wss simpr sylancr
      f1osng f1of syl snssd syl2anc ral0 wb oveq2 fz10 syl6eq f1oeq2 cz 0z fzsn
      fss ax-mp feq2d raleqdv 3anbi123d rspcev syl13anc cdm dm0 iseupa sylanbrc
      ) BCFZABFZGZBHUAIZJDUBZKLZHHMZNWFKLZBNAUCOZPZEUBZHQHQWLJUDLWJQWLWJQUERZEW
      GUFZUGZDSUHZHWJBHUILIZWBWEWCBCUJUKWDNSFZHHHMZNOZBWJPZWMEHUFZWPWRWDULTWSWD
      UMTWDWTAOZWJPZXCBUNXAWDWTXCWJMZXDWDWRWCXEULWBWCUOZNASBUQUPWTXCWJURUSWDABX
      FUTWTXCBWJVKVAXBWDWMEVBTWOWSXAXBUGDNSWFNRZWHWSWKXAWNXBXGWGHRWHWSVCXGWGJNK
      LHWFNJKVDVEVFZWGHHHVGUSXGWIWTBWJXGWINNKLZWTWFNNKVDNVHFXIWTRVINVJVLVFVMXGW
      MEWGHXHVNVOVPVQHVRHRWQWEWPGVCVSHWJEDHHBVTVLWA $.

    eupares.g $e |- ( ph -> G ( V EulPaths E ) P ) $.
    eupares.n $e |- ( ph -> N e. ( 0 ... ( # ` G ) ) ) $.
    eupares.f $e |- F = ( E |` ( G " ( 1 ... N ) ) ) $.
    eupares.h $e |- H = ( G |` ( 1 ... N ) ) $.
    eupares.q $e |- Q = ( P |` ( 0 ... N ) ) $.
    $( The restriction of an Eulerian path to an initial segment of the path
       forms an Eulerian path on the subgraph consisting of the edges in the
       initial segment.  (Contributed by Mario Carneiro, 12-Mar-2015.)
       (Revised by Mario Carneiro, 3-May-2015.) $)
    eupares $p |- ( ph -> H ( V EulPaths F ) Q ) $=
      ( co c1 cfv wceq syl wcel vn vk vx ceup wbr cumg cv cfz cima wf1o wf cmin
      cc0 cpr wral w3a cn0 wrex cres eupagra umgrares syl6breqr elfznn0 cdm wf1
      chash wss wfn c2 cle cpw c0 csn cdif crab umgraf2 ffn eupaf1o syl2anc cuz
      f1of1 elfzuz3 fzss2 f1ores f1oeq1 ax-mp sylibr eupapf fssres feq1i adantr
      wb wa sselda eupaseg fveq1i fvres adantl syl5eq fveq2d wfun wi f1ofun fdm
      f1of 3syl sseqtr4d funfvima2 eqtrd caddc cn elfznn nnm1nn0 nn0uz syl6eleq
      imp cc nncnd ax-1cn npcan sylancl 1e0p1 oveq1i cz 0z fzp1ss mp1i syl5eqss
      eqeltrd peano2fzr preq12d 3eqtr4d ralrimiva oveq2 feq2d raleqdv 3anbi123d
      f1oeq2 rspcev syl13anc cin dmeqi dmres eqtri crn imassrn f1ofo forn df-ss
      wfo syl5sseq sylib iseupa mpbir2and ) AGCIEUDOUEZIEUFUEZPUAUGZUHOZFPHUHOZ
      UIZGUJZUMUUQUHOZICUKZUBUGZGQZEQZUVDPULOZCQZUVDCQZUNZRZUBUURUOZUPZUAUQURZA
      IDUUTUSZEUFAIDUFUEZIUVOUFUEAFBIDUDOUEZUVPJBDFIUTSZUUTDIVASLVBAHUQTZUUSUUT
      GUJZUMHUHOZICUKZUVKUBUUSUOZUVNAHUMFVFQZUHOZTZUVSKHUWDVCSAUUSUUTFUUSUSZUJZ
      UVTAPUWDUHOZDVDZFVEZUUSUWIVGZUWHAUWIUWJFUJZUWKAUVQDUWJVHZUWMJAUWJUCUGVFQV
      IVJUEUCIVKVLVMVNVOZDUKZUWNAUVPUWPUVRUCDIVPSUWJUWODVQSUWJBDFIVRVSZUWIUWJFW
      ASAUWDHVTQTZUWLAUWFUWRKHUMUWDWBSZHPUWDWCSZUWIUWJUUSFWDVSGUWGRUVTUWHWLMUUS
      UUTGUWGWEWFWGAUWAIBUWAUSZUKZUWBAUWEIBUKZUWAUWEVGZUXBAUVQUXCJBDFIWHSAUWRUX
      DUWSHUMUWDWCSUWEIUWABWIVSUWAICUXANWJWGAUVKUBUUSAUVDUUSTZWMZUVDFQZDQZUVGBQ
      ZUVDBQZUNZUVFUVJUXFUVQUVDUWITUXHUXKRAUVQUXEJWKAUUSUWIUVDUWTWNBDFUVDIWOVSU
      XFUVFUXGEQZUXHUXFUVEUXGEUXFUVEUVDUWGQZUXGUVDGUWGMWPUXEUXMUXGRAUVDUUSFWQWR
      WSWTUXFUXLUXGUVOQZUXHUXGEUVOLWPUXFUXGUUTTZUXNUXHRAUXEUXOAFXAZUUSFVDZVGUXE
      UXOXBAUWMUXPUWQUWIUWJFXCSAUUSUWIUXQUWTAUWMUWIUWJFUKUXQUWIRUWQUWIUWJFXEUWI
      UWJFXDXFXGUUSUVDFXHVSXPUXGUUTDWQSWSXIUXFUVHUXIUVIUXJUXFUVGUWATZUVHUXIRUXF
      UVGUMVTQZTUVGPXJOZUWATUXRUXFUVGUQUXSUXFUVDXKTZUVGUQTUXEUYAAUVDHXLWRZUVDXM
      SXNXOUXFUXTUVDUWAUXFUVDXQTPXQTUXTUVDRUXFUVDUYBXRXSUVDPXTYAAUUSUWAUVDAUUSU
      MPXJOZHUHOZUWAPUYCHUHYBYCUMYDTUYDUWAVGAYEUMHYFYGYHWNZYIUVGUMHYJVSUXRUVHUV
      GUXAQUXIUVGCUXANWPUVGUWABWQWSSUXFUVDUWATZUVIUXJRUYEUYFUVIUVDUXAQUXJUVDCUX
      ANWPUVDUWABWQWSSYKYLYMUVMUVTUWBUWCUPUAHUQUUQHRZUVAUVTUVCUWBUVLUWCUYGUURUU
      SRUVAUVTWLUUQHPUHYNZUURUUSUUTGYRSUYGUVBUWAICUUQHUMUHYNYOUYGUVKUBUURUUSUYH
      YPYQYSYTAEVDZUUTRUUOUUPUVNWMWLAUYIUUTUWJUUAZUUTUYIUVOVDUYJEUVOLUUBDUUTUUC
      UUDAUUTUWJVGUYJUUTRAFUUEZUUTUWJFUUSUUFAUWMUWIUWJFUUJUYKUWJRUWQUWIUWJFUUGU
      WIUWJFUUHXFUUKUUTUWJUUIUULWSUUTCUBUAEGIUUMSUUN $.
  $}

  ${
    $d k n A $.  $d k n B $.  $d k n F $.  $d k n H $.  $d k n N $.  $d k ph $.
    $d k n Q $.  $d k n V $.
    eupap1.e $e |- ( ph -> E Fn A ) $.
    eupap1.a $e |- ( ph -> A e. Fin ) $.
    eupap1.b $e |- ( ph -> B e. _V ) $.
    eupap1.c $e |- ( ph -> C e. V ) $.
    eupap1.d $e |- ( ph -> -. B e. A ) $.
    eupap1.g $e |- ( ph -> G ( V EulPaths E ) P ) $.
    eupap1.n $e |- ( ph -> N = ( # ` G ) ) $.
    eupap1.f $e |- F = ( E u. { <. B , { ( P ` N ) , C } >. } ) $.
    eupap1.h $e |- H = ( G u. { <. ( N + 1 ) , B >. } ) $.
    eupap1.q $e |- Q = ( P u. { <. ( N + 1 ) , C >. } ) $.
    $( Append one path segment to an Eulerian path (enlarging the graph to add
       the new edge).  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    eupap1 $p |- ( ph -> H ( V EulPaths F ) Q ) $=
      ( vn vk ceup co wbr cumg c1 cv cfz csn cun wf1o cc0 wf cfv cmin wceq wral
      cpr w3a cn0 wrex cop wfn cvv wcel prex f1osng sylancl f1ofn syl wn cin c0
      disjsn sylibr eupagra relumgra brrelexi chash eupapf eupacl eqeltrd nn0uz
      syl6eleq eluzfz2 oveq2d eleqtrd ffvelrnd syl22anc umgraun syl6breqr caddc
      cuz umgra1 peano2nn0 eupaf1o syl2anc wb f1oeq2 mpbird fzp1disj a1i f1oeq1
      f1oun ax-mp cz syl6eleqr feq2d wss f1of syl21anc fveq1i wne adantr fvunsn
      wa syl5eq adantl nn0red gtned fveq2d preq12d 3eqtr4d wfun cdm ssun2 snidg
      cr funssfv syl3anc fvsng eqtrd dmsnopg eleqtrrd cc raleqdv oveq2 1z 1m1e0
      fveq2i fzsuc2 sylancr snssd fss fun2 fzsuc feq12d ffvelrnda nelne2 necomd
      cn elfznn nnred cle elfzle2 clt ltp1d peano2rem ltm1d lttrd eleq2d biimpa
      lelttrd eqtr4d ralrimiva fnun fnfun dmsnop f1ofun recnd ax-1cn pncan ffun
      eupaseg elsni oveq1d eqeq12d syl5ibrcom ralrimiv ralun 3anbi123d syl13anc
      rspcev fneq1i fndm iseupa mpbir2and ) AJFLHUEUFUGZLHUHUGZUIUCUJZUKUFZBCUL
      ZUMZJUNZUOUWMUKUFZLFUPZUDUJZJUQZHUQZUWTUIURUFZFUQZUWTFUQZVAZUSZUDUWNUTZVB
      ZUCVCVDZALGCKEUQZDVAZVEULZUMZHUHABUWOGUXMLMAUWOUXLULZUXMUNZUXMUWOVFZACVGV
      HZUXLVGVHZUXPOUXKDVIZCUXLVGVGVJVKUWOUXOUXMVLVMZACBVHVNZBUWOVOVPUSZQBCVQVR
      ZAIELGUEUFUGZLGUHUGZREGILVSVMZALVGVHZUXRUXKLVHDLVHZLUXMUHUGAUYFUYHUYGLGUH
      VTWAVMOAUOIWBUQZUKUFZLKEAUYEUYKLEUPZREGILWCVMZAKUOKUKUFZUYKAKUOWPUQZVHZKU
      YNVHAKVCUYOAKUYJVCSAUYEUYJVCVHREGILWDVMWEZWFWGZUOKWHVMAKUYJUOUKSWIZWJWKPC
      UXKDLVGVGWQWLWMTWNAKUIWOUFZVCVHZUIUYTUKUFZUWPJUNZUOUYTUKUFZLFUPZUXGUDVUBU
      TZUXJAKVCVHVUAUYQKWRVMZAVUCUIKUKUFZUYTULZUMZUWPJUNZAVUJUWPIUYTCVEULZUMZUN
      ZVUKAVUHBIUNZVUIUWOVULUNZVUHVUIVOVPUSZUYCVUNAVUOUIUYJUKUFZBIUNZAUYEGBVFZV
      USRMBEGILWSWTAVUHVURUSVUOVUSXAAKUYJUIUKSWIZVUHVURBIXBVMXCZAVUAUXRVUPVUGOU
      YTCVCVGVJWTVUQAUIKXDXEUYDVUHBVUIUWOIVULXGWLZJVUMUSVUKVUNXAUAVUJUWPJVUMXFX
      HVRAVUBVUJUSZVUCVUKXAAUIXIVHKUIUIURUFZWPUQZVHVVDUUAAKUYOVVFUYRVVEUOWPUUBU
      UCXJUIKUUDUUEZVUBVUJUWPJXBVMXCAVUEUYNVUIUMZLEUYTDVEULZUMZUPZAUYNLEUPZVUIL
      VVIUPZUYNVUIVOVPUSZVVKAVVLUYLUYMAUYNUYKLEUYSXKXCAVUIDULZVVIUPZVVOLXLVVMAV
      UIVVOVVIUNZVVPAVUAUYIVVQVUGPUYTDVCLVJWTVUIVVOVVIXMVMADLPUUFVUIVVOLVVIUUGW
      TVVNAUOKXDXEUYNVUILEVVIUUHXNZAVUDVVHLFVVJFVVJUSAUBXEAUYPVUDVVHUSUYRUOKUUI
      VMUUJXCAVUFUXGUDVUJUTZAUXGUDVUHUTUXGUDVUIUTVVSAUXGUDVUHAUWTVUHVHZXSZUWTIU
      QZHUQZVWBGUQZUXBUXFVWAVWCVWBUXNUQZVWDVWBHUXNTXOVWACVWBXPVWEVWDUSVWAVWBCVW
      AVWBBVHUYBVWBCXPAVUHBUWTIAVUOVUHBIUPVVBVUHBIXMVMUUKAUYBVVTQXQVWBCBUULWTUU
      MGCUXLVWBXRVMXTVWAUXAVWBHVWAUXAUWTVUMUQZVWBUWTJVUMUAXOVWAUYTUWTXPZVWFVWBU
      SVWAUWTUYTVWAUWTVVTUWTUUNVHAUWTKUUOYAUUPZVWAUWTKUYTVWHAKYKVHVVTAKUYQYBZXQ
      AUYTYKVHVVTAUYTVUGYBXQZVVTUWTKUUQUGAUWTUIKUURYAAKUYTUUSUGVVTAKVWIUUTZXQUV
      FZYCZIUYTCUWTXRVMXTYDVWAUXFUXCEUQZUWTEUQZVAZVWDVWAUXDVWNUXEVWOVWAUXDUXCVV
      JUQZVWNUXCFVVJUBXOVWAUYTUXCXPVWQVWNUSVWAUXCUYTVWAUWTYKVHUXCYKVHVWHUWTUVAV
      MZVWAUXCUWTUYTVWRVWHVWJVWAUWTVWHUVBVWLUVCYCEUYTDUXCXRVMXTVWAUXEUWTVVJUQZV
      WOUWTFVVJUBXOVWAVWGVWSVWOUSVWMEUYTDUWTXRVMXTYEVWAUYEUWTVURVHZVWDVWPUSAUYE
      VVTRXQAVVTVWTAVUHVURUWTVVAUVDUVEEGIUWTLUVQWTUVGYFUVHAUXGUDVUIAUXGUWTVUIVH
      ZUYTJUQZHUQZUYTUIURUFZFUQZUYTFUQZVAZUSACHUQZUXLVXCVXGAVXHCUXMUQZUXLAVXHCU
      XNUQZVXICHUXNTXOAUXNYGZUXMUXNXLZCUXMYHZVHVXJVXIUSAUXNUWPVFZVXKAVUTUXQUYCV
      XNMUYAUYDBUWOGUXMUVIXNZUWPUXNUVJVMVXLAUXMGYIXEACUWOVXMAUXRCUWOVHOCVGYJVMC
      UXLUXTUVKXJCUXNUXMYLYMXTAUXRUXSVXIUXLUSOUXTCUXLVGVGYNVKYOAVXBCHAVXBUYTVUL
      UQZCAVXBUYTVUMUQZVXPUYTJVUMUAXOAVUMYGZVULVUMXLZUYTVULYHZVHVXQVXPUSAVUNVXR
      VVCVUJUWPVUMUVLVMVXSAVULIYIXEAUYTVUIVXTAVUAUYTVUIVHVUGUYTVCYJVMZAUXRVXTVU
      IUSOUYTCVGYPVMYQUYTVUMVULYLYMXTAVUAUXRVXPCUSVUGOUYTCVCVGYNWTYOYDAVXEUXKVX
      FDAVXEKFUQZUXKAVXDKFAKYRVHUIYRVHVXDKUSAKVWIUVMUVNKUIUVOVKYDAVYBKVVJUQZUXK
      KFVVJUBXOAUYTKXPVYCUXKUSAKUYTVWIVWKYCEUYTDKXRVMXTYOAVXFUYTVVIUQZDAVXFUYTV
      VJUQZVYDUYTFVVJUBXOAVVJYGZVVIVVJXLZUYTVVIYHZVHVYEVYDUSAVVKVYFVVRVVHLVVJUV
      PVMVYGAVVIEYIXEAUYTVUIVYHVYAAUYIVYHVUIUSPUYTDLYPVMYQUYTVVJVVIYLYMXTAVUAUY
      IVYDDUSVUGPUYTDVCLYNWTYOYEYFVXAUXBVXCUXFVXGVXAUXAVXBHVXAUWTUYTJUWTUYTUVRZ
      YDYDVXAUXDVXEUXEVXFVXAUXCVXDFVXAUWTUYTUIURVYIUVSYDVXAUWTUYTFVYIYDYEUVTUWA
      UWBUXGUDVUHVUIUWCWTAUXGUDVUBVUJVVGYSXCUXIVUCVUEVUFVBUCUYTVCUWMUYTUSZUWQVU
      CUWSVUEUXHVUFVYJUWNVUBUSUWQVUCXAUWMUYTUIUKYTZUWNVUBUWPJXBVMVYJUWRVUDLFUWM
      UYTUOUKYTXKVYJUXGUDUWNVUBVYKYSUWDUWFUWEAHYHUWPUSZUWKUWLUXJXSXAAHUWPVFZVYL
      AVXNVYMVXOUWPHUXNTUWGVRUWPHUWHVMUWPFUDUCHJLUWIVMUWJ $.
  $}

  $( Lemma for ~ eupath2 .  (Contributed by Mario Carneiro, 8-Apr-2015.) $)
  eupath2lem1 $p |- ( U e. V -> ( U e. if ( A = B , (/) , { A , B } ) <->
      ( A =/= B /\ ( U = A \/ U = B ) ) ) ) $=
    ( wceq c0 wcel wne wo wa wb cpr cif eleq2 bibi1d wn noel a1i simpl neneqd
    simpr nsyl3 2falsed elprg df-ne ibar sylbir sylan9bb ifbothda ) ABEZCFGZABH
    ZCAECBEIZJZKCABLZGZUNKCUJFUOMZGZUNKCDGZFUOFUQEUKURUNFUQCNOUOUQEUPURUNUOUQCN
    OUSUJJZUKUNUKPUTCQRUNUJUTUNABULUMSTUSUJUAUBUCUSUPUMUJPZUNCABDUDVAULUMUNKABU
    EULUMUFUGUHUI $.

  ${
    eupath2lem2.1 $e |- B e. _V $.
    $( Lemma for ~ eupath2 .  (Contributed by Mario Carneiro, 8-Apr-2015.) $)
    eupath2lem2 $p |- ( ( B =/= C /\ B = U ) ->
     ( -. U e. if ( A = B , (/) , { A , B } ) <->
          U e. if ( A = C , (/) , { A , C } ) ) ) $=
      ( wne wceq wa c0 cpr cif wcel wn wo cvv eupath2lem1 ax-mp syl6bbr eleq1d
      wb eqidd olcd biantrud simpr bitrd necon1bbid simpl neeq1 syl5ibcom eqcom
      pm4.71rd ancom 3bitr4g neneqd biorf orcom syl6bb anbi1d syl5bbr 3bitrd
      syl ) BCFZBDGZHZDABGZIABJKZLZMVEACFZBAGZBCGZNZHZDACGIACJKZLZVDVGABVDABFZB
      VFLZVGVDVOVOVIBBGZNZHZVPVDVRVOVDVQVIVDBUAUBUCBOLZVPVSTEABBOPQRVDBDVFVBVCU
      DZSUEUFVDVEVKVHHZVLVDVEVIVHHZWBVDVIVHVIHVEWCVDVIVHVDVBVIVHVBVCUGZBACUHUIU
      KABUJVIVHULUMVDVIVKVHVDVIVJVINZVKVDVJMVIWETVDBCWDUNVJVIUOVAVJVIUPUQURUEVH
      VKULRVLBVMLZVDVNVTWFVLTEACBOPQVDBDVMWASUSUT $.
  $}

  ${
    $d m n x y E $.  $d m n x y F $.  $d x N $.  $d m n y P $.  $d m n x y V $.
    $d m n y ph $.  $d x U $.
    eupath2.1 $e |- ( ph -> E Fn A ) $.
    eupath2.3 $e |- ( ph -> F ( V EulPaths E ) P ) $.
    ${
      eupath2.5 $e |- ( ph -> N e. NN0 ) $.
      eupath2.6 $e |- ( ph -> ( N + 1 ) <_ ( # ` F ) ) $.
      eupath2.7 $e |- ( ph -> U e. V ) $.
      eupath2.8 $e |- ( ph -> { x e. V | -. 2 ||
        ( ( V VDeg ( E |` ( F " ( 1 ... N ) ) ) ) ` x ) } =
        if ( ( P ` 0 ) = ( P ` N ) , (/) , { ( P ` 0 ) , ( P ` N ) } ) ) $.
      $( Lemma for ~ eupath2 .  (Contributed by Mario Carneiro, 8-Apr-2015.) $)
      eupath2lem3 $p |- ( ph ->
       ( -. 2 || ( ( V VDeg ( E |` ( F " ( 1 ... ( N + 1 ) ) ) ) ) ` U ) <->
         U e. if ( ( P ` 0 ) = ( P ` ( N + 1 ) ) , (/) ,
                 { ( P ` 0 ) , ( P ` ( N + 1 ) ) } ) ) ) $=
        ( c2 c1 cfv wcel ad2antrr caddc cfz cima cres cvdg cdivides wbr cpr cop
        co wn csn cc0 wceq c0 cif cun imaundi cz cmin cuz 1z nn0uz 1m1e0 fveq2i
        cn0 eqtr4i syl6eleq sylancr imaeq2d chash wfn wf1o ceup eupaf1o syl2anc
        fzsuc2 f1ofn syl wb cn nn0p1nn nnuz eupacl nn0zd elfz5 mpbird uneq2d wf
        cle ffvelrnd cc nn0cnd preq1d eqtrd opeq2d sneqd oveq2d fveq1d wss 3syl
        fvex a1i cfn clt cr syl3anc bitrd cvv breq2d notbid wa eleq2d adantr 2z
        cumg ax-mp simpr simplr syl5breqr wne eqnetrrd vdgr1a pm2.61dane preq2d
        vdgrfif 3bitr3d necomd wi eupath2lem2 adantll 3bitrd neeq1 neneqd biorf
        wo orcom syl6bb anbi2d eupath2lem1 3eqtr4a reseq2d resundi f1of fnressn
        fnsnfv syl6eq eupaseg ax-1cn pncan sylancl fveq2d crn imassrn wfo f1ofo
        forn syl5sseq fnssres prex fnsn eupafi ssfi snfi nn0red peano2re ltnled
        cin ltp1d mpbid f1of1 peano2zd eluz2 syl3anbrc peano2uzr f1elima mtbird
        fzss2 disjsn sylibr eupagra umgrares relumgra brrelexi elfzuzb sylanbrc
        wf1 eupapf peano2nn0 umgra1 syl22anc vdgrfiun crab elrab3 bitr3d iddvds
        cv fveq2 eqtr3d preq12d dfsn2 syl6eqr dvds0 dvdsadd2b syl112anc addcomd
        vdgr1d eqeq2d ifbieq2d vdgr1b 2nn 1lt2 con2d cprime 2prm nprmdvds1 opoe
        ndvdsp1 mpanr12 impbid neeqtrd vdgr1c sylanb con1bid simprl simprr 2thd
        ex necom addid1d bibi12d syl5ibcom pm5.32rd 3bitr4d pm2.61da2ne ) APEIF
        GQHQUAUJZUBUJZUCZUDZUEUJZRZUFUGZUKPEIFGQHUBUJZUCZUDZUEUJZRZEIUYPGRZHDRZ
        UYPDRZUHZUIZULZUEUJZRZUAUJZUFUGZUKZEUMDRZVUJUNZUOVUSVUJUHZUPZSZAVUBVUQA
        VUAVUPPUFAVUAEIVUEVUMUQZUEUJZRVUPAEUYTVVEAUYSVVDIUEAUYSVUEFVUHULZUDZUQZ
        VVDAUYSFVUDVVFUQZUDVVHAUYRVVIFAGVUCUYPULZUQZUCVUDGVVJUCZUQUYRVVIGVUCVVJ
        URAUYQVVKGAQUSSZHQQUTUJZVARZSUYQVVKUNVBAHVFVVOLVFUMVARZVVOVCVVNUMVAVDVE
        VGVHQHVQVIVJAVVFVVLVUDAGQGVKRZUBUJZVLZUYPVVRSZVVFVVLUNAVVRCGVMZVVSAGDIF
        VNUJUGZFCVLZVWAKJCDFGIVOVPZVVRCGVRVSAVVTUYPVVQWJUGZMAUYPQVARZSZVVQUSSZV
        VTVWEVTAUYPWAVWFAHVFSZUYPWASLHWBVSWCVHZAVVQAVWBVVQVFSKDFGIWDVSWEZUYPQVV
        QWFVPWGZVVRUYPGUUFVPWHUUAUUBFVUDVVFUUCUUGAVVGVUMVUEAVVGVUHVUHFRZUIZULZV
        UMAVWCVUHCSZVVGVWOUNJAVVRCUYPGAVWAVVRCGWIVWDVVRCGUUDVSVWLWKZCVUHFUUEVPA
        VWNVULAVWMVUKVUHAVWMUYPQUTUJZDRZVUJUHZVUKAVWBVVTVWMVWTUNKVWLDFGUYPIUUHV
        PAVWSVUIVUJAVWRHDAHWLSQWLSVWRHUNAHLWMUUIHQUUJUUKUULWNWOWPWQWOWHWOWRWSAV
        UDVVFEVUEVUMIAVWCVUDCWTZVUEVUDVLZJAGUUMZVUDCGVUCUUNAVWAVVRCGUUOVXCCUNVW
        DVVRCGUUPVVRCGUUQXAUURZCVUDFUUSVPZVUMVVFVLZAVUHVUKUYPGXBZVUIVUJUUTUVAXC
        ZACXDSZVXAVUDXDSZAVWBVWCVXIKJCDFGIUVBVPVXDCVUDUVCVPZVVFXDSZAVUHUVDXCZAV
        UHVUDSZUKVUDVVFUVHUOUNAVXNUYPHWJUGZAHUYPXEUGVXOUKAHAHLUVEZUVIAHUYPVXPAH
        XFSUYPXFSVXPHUVFVSUVGUVJAVXNUYPVUCSZVXOAVVRCGUWGZVVTVUCVVRWTZVXNVXQVTAV
        WAVXRVWDVVRCGUVKVSVWLAVVQHVARSZVXSAHUSSZVVQUYPVARSZVXTAHLWEZAUYPUSSVWHV
        WEVYBAHVYCUVLVWKMUYPVVQUVMUVNHVVQUVOVPZHQVVQUVRVSVVRCGUYPVUCUVPXGAVWGVY
        AVXQVXOVTVWJVYCUYPQHWFVPXHUVQVUDVUHUVSUVTAVWBIFXPUGZIVUEXPUGKDFGIUWAZVU
        DFIUWBXAAIXISZVWPVUIISZVUJISZIVUMXPUGAVWBVYEVYGKVYFIFXPUWCUWDXAZVWQAUMV
        VQUBUJZIHDAVWBVYKIDWIKDFGIUWHVSZAHVVPSVXTHVYKSAHVFVVPLVCVHVYDHUMVVQUWEU
        WFWKZAVYKIUYPDVYLAUYPVYKSZVWEMAUYPVVPSVWHVYNVWEVTAUYPVFVVPAVWIUYPVFSLHU
        WIVSVCVHVWKUYPUMVVQWFVPWGWKZVUHVUIVUJIXICUWJUWKNUWLWOXJXKAVURVVCVTZVUIV
        UJAVUIVUJUNZXLZPVUGUFUGZUKZEVUSVUIUNZUOVUSVUIUHZUPZSZVURVVCAVYTWUDVTZVY
        QAEPBUWQZVUFRZUFUGZUKZBIUWMZSZVYTWUDAEISZWUKVYTVTNWUIVYTBEIWUFEUNZWUHVY
        SWUMWUGVUGPUFWUFEVUFUWRXJXKUWNVSAWUJWUCEOXMUWOZXNVYRVYSVUQVYRVYSPVUOVUG
        UAUJZUFUGZVUQVYRPUSSZVUGUSSZVUOUSSZPVUOUFUGZVYSWUPVTWUQVYRXOXCAWURVYQAV
        UGAIVFEVUFAVYGVXBVXJIVFVUFWIVYJVXEVXKVUDVUEIXIYFXGNWKZWEZXNAWUSVYQAVUOA
        IVFEVUNAVYGVXFVXLIVFVUNWIVYJVXHVXMVVFVUMIXIYFXGNWKZWEXNVYRWUTVUIEVYRVUI
        EUNZXLZPPVUOUFWUQPPUFUGXOPUWPXQWVEVUOEIVUHEULZUIZULZUEUJZRPWVEEVUNWVIWV
        EVUMWVHIUEWVEVULWVGWVEVUKWVFVUHWVEVUKEEUHWVFWVEVUIEVUJEVYRWVDXRZWVEVUIV
        UJEAVYQWVDXSWVJUWSUWTEUXAUXBWPWQWRWSWVEVUHEIAVYGVYQWVDVYJTVUHXISZWVEVXG
        XCAWULVYQWVDNTUXGWOXTVYRVUIEYAZXLZPUMVUOUFWUQPUMUFUGXOPUXCXQWVMVUHVUIVU
        JEIAVYGVYQWVLVYJTWVKWVMVXGXCAWULVYQWVLNTAVYHVYQWVLVYMTVYRWVLXRZAVYIVYQW
        VLVYOTWVMVUIVUJEAVYQWVLXSWVNYBYCXTYDPVUGVUOUXDUXEAWUPVUQVTVYQAWUOVUPPUF
        AVUOVUGAVUOWVCWMAVUGWVAWMZUXFXJXNXHXKVYRWUCVVBEVYRWUAVUTWUBVVAUOVYRVUIV
        UJVUSAVYQXRZUXHVYRVUIVUJVUSWVPYEUXIXMYGAVUIVUJYAZXLZVYPVUIEVUJEWVRWVDXL
        ZVURPVUGQUAUJZUFUGZUKZWUDUKZVVCWVSVUQWWAWVSVUPWVTPUFWVSVUOQVUGUAWVSVUOE
        IVUHEVUJUHZUIZULZUEUJZRQWVSEVUNWWGWVSVUMWWFIUEWVSVULWWEWVSVUKWWDVUHWVSV
        UIEVUJWVRWVDXRZWNWPWQWRWSWVSVUHVUJEIAVYGWVQWVDVYJTWVKWVSVXGXCAWULWVQWVD
        NTAVYIWVQWVDVYOTWVSEVUJWVSVUIEVUJWWHAWVQWVDXSYBYHUXJWOWRXJXKAWWBWWCVTZW
        VQWVDAWWAWUDAWWAVYTWUDAWWAVYTAVYSWWAAWURPWASZQPXEUGZVYSWWBYIWVBWWJAUXKX
        CWWKAUXLXCPVUGUXRXGUXMAWURVYTWWAYIWVBWURVYTWWAWURVYTXLVVMPQUFUGUKZWWAVB
        PUXNSWWLUXOPUXPXQVUGQUXQUXSUYHVSUXTWUNXHXKZTWVQWVDWWCVVCVTZAVUSVUIVUJEH
        DXBYJYKYLWVRVUJEUNZXLZVURWWBWWCVVCWWPVUQWWAWWPVUPWVTPUFWWPVUOQVUGUAWWPV
        UOEIVUHVUIEUHZUIZULZUEUJZRQWWPEVUNWWTWWPVUMWWSIUEWWPVULWWRWWPVUKWWQVUHW
        WPVUJEVUIWVRWWOXRZYEWPWQWRWSWWPVUHVUIEIAVYGWVQWWOVYJTWVKWWPVXGXCAWULWVQ
        WWONTAVYHWVQWWOVYMTWWPVUIVUJEAWVQWWOXSWXAUYAUYBWOWRXJXKAWWIWVQWWOWWMTWV
        QWWOWWNAWVQWWOXLVVCWUDWVQVUJVUIYAWWOVVCUKWUDVTVUIVUJUYIVUSVUJVUIEUYPDXB
        YJUYCUYDYKYLWVRWVLVUJEYAZXLZXLZVURVYTWUDVVCWXDVUQVYSWXDVUPVUGPUFWXDVUPV
        UGUMUAUJZVUGWXDVUOUMVUGUAWXDVUHVUIVUJEIAVYGWVQWXCVYJTWVKWXDVXGXCAWULWVQ
        WXCNTZAVYHWVQWXCVYMTWVRWVLWXBUYEZAVYIWVQWXCVYOTWVRWVLWXBUYFZYCWRAWXEVUG
        UNWVQWXCAVUGWVOUYJTWOXJXKAWUEWVQWXCWUNTWXDVUSVUIYAZEVUSUNZEVUIUNZYPZXLZ
        VUSVUJYAZWXJEVUJUNZYPZXLZWUDVVCWXDWXIWXJXLWXNWXJXLWXMWXQWXDWXJWXIWXNWXD
        EVUIYAZEVUJYAZVTWXJWXIWXNVTWXDWXRWXSWXDVUIEWXGYHZWXDVUJEWXHYHZUYGWXJWXR
        WXIWXSWXNEVUSVUIYMEVUSVUJYMUYKUYLUYMWXDWXJWXLWXIWXDWXJWXKWXJYPZWXLWXDWX
        KUKWXJWYBVTWXDEVUIWXTYNWXKWXJYOVSWXKWXJYQYRYSWXDWXJWXPWXNWXDWXJWXOWXJYP
        ZWXPWXDWXOUKWXJWYCVTWXDEVUJWYAYNWXOWXJYOVSWXOWXJYQYRYSYGWXDWULWUDWXMVTW
        XFVUSVUIEIYTVSWXDWULVVCWXQVTWXFVUSVUJEIYTVSUYNYLUYOYDXH $.
    $}

    $d x ph $.
    $( The only vertices of odd degree in a graph with an Eulerian path are the
       endpoints, and then only if the endpoints are distinct.  (Contributed by
       Mario Carneiro, 8-Apr-2015.) $)
    eupath2 $p |- ( ph ->
      { x e. V | -. 2 || ( ( V VDeg E ) ` x ) } =
        if ( ( P ` 0 ) = ( P ` ( # ` F ) ) , (/) ,
           { ( P ` 0 ) , ( P ` ( # ` F ) ) } ) ) $=
      ( c2 cfv co cvdg cdivides wbr cc0 wceq c0 wcel wi vm vn vy cv c1 cfz cima
      chash cres wn crab cpr cif wf1o wfo ceup eupaf1o syl2anc f1ofo foima 3syl
      wfn reseq2d fnresdm syl eqtrd oveq2d fveq1d breq2d notbid rabbidv cle cn0
      eupacl nn0re leidd caddc breq1 oveq2 fz10 syl6eq imaeq2d ima0 res0 eqcomd
      cr fveq2 iftrue eqeq12d imbi12d imbi2d eqeq2d preq2d ifbieq2d wa cz dvds0
      wral 2z ax-mp cvv eupagra relumgra brrelexi vdgr0 sylan syl5breqr notnot1
      cumg ralrimiva rabeq0 sylibr a1d adantl lep1d peano2re letr syl3anc mpand
      adantr elrab ad3antrrr simpllr simplrl simpr simplrr eupath2lem3 pm5.32da
      imim1d cpw 0elpw wss wf eupapf ad2antrr cuz nn0uz syl6eleq ffvelrnd a2d
      eluzfz1 simprl peano2nn0 ad2antlr nn0zd elfz5 mpbird prssi prex elpw ifcl
      sylancr elpwid sseld pm4.71rd bitr4d syl5bb eqrdv exp32 syld expcom mpcom
      wb nn0ind mpd eqtr3d ) AJBUDZGEFUEFUHKZUFLZUGZUIZMLZKZNOZUJZBGUKZJUVGGEML
      ZKZNOZUJZBGUKPDKZUVHDKZQZRUWAUWBULZUMZAUVOUVTBGAUVNUVSAUVMUVRJNAUVGUVLUVQ
      AUVKEGMAUVKECUIZEAUVJCEAUVICFUNZUVICFUOUVJCQAFDGEUPLOZECVBZUWGIHCDEFGUQUR
      UVICFUSUVICFUTVAVCAUWIUWFEQHCEVDVEVFVGVHVIVJVKAUVHUVHVLOZUVPUWEQZAUVHAUWH
      UVHVMSZUVHWFSZIDEFGVNZUVHVOVAZVPUWLAUWJUWKTZAUWHUWLIUWNVEZAUAUDZUVHVLOZJU
      VGGEFUEUWRUFLZUGZUIZMLZKZNOZUJZBGUKZUWAUWRDKZQZRUWAUXHULZUMZQZTZTAPUVHVLO
      ZJUVGGRMLZKZNOZUJZBGUKZRQZTZTAUBUDZUVHVLOZJUVGGEFUEUYBUFLZUGZUIZMLZKZNOZU
      JZBGUKZUWAUYBDKZQZRUWAUYLULZUMZQZTZTAUYBUEVQLZUVHVLOZJUVGGEFUEUYRUFLZUGZU
      IZMLZKZNOZUJZBGUKZUWAUYRDKZQZRUWAVUHULZUMZQZTZTAUWPTUAUBUVHUWRPQZUXMUYAAV
      UNUWSUXNUXLUXTUWRPUVHVLVRVUNUXGUXSUXKRVUNUXFUXRBGVUNUXEUXQVUNUXDUXPJNVUNU
      VGUXCUXOVUNUXBRGMVUNUXBERUIRVUNUXAREVUNUXAFRUGRVUNUWTRFVUNUWTUEPUFLRUWRPU
      EUFVSVTWAWBFWCWAVCEWDWAVGVHVIVJVKVUNUXIUXKRQVUNUXHUWAUWRPDWGWEUXIRUXJWHVE
      WIWJWKUWRUYBQZUXMUYQAVUOUWSUYCUXLUYPUWRUYBUVHVLVRVUOUXGUYKUXKUYOVUOUXFUYJ
      BGVUOUXEUYIVUOUXDUYHJNVUOUVGUXCUYGVUOUXBUYFGMVUOUXAUYEEVUOUWTUYDFUWRUYBUE
      UFVSWBVCVGVHVIVJVKVUOUXIUYMUXJUYNRVUOUXHUYLUWAUWRUYBDWGZWLVUOUXHUYLUWAVUP
      WMWNWIWJWKUWRUYRQZUXMVUMAVUQUWSUYSUXLVULUWRUYRUVHVLVRVUQUXGVUGUXKVUKVUQUX
      FVUFBGVUQUXEVUEVUQUXDVUDJNVUQUVGUXCVUCVUQUXBVUBGMVUQUXAVUAEVUQUWTUYTFUWRU
      YRUEUFVSWBVCVGVHVIVJVKVUQUXIVUIUXJVUJRVUQUXHVUHUWAUWRUYRDWGZWLVUQUXHVUHUW
      AVURWMWNWIWJWKUWRUVHQZUXMUWPAVUSUWSUWJUXLUWKUWRUVHUVHVLVRVUSUXGUVPUXKUWEV
      USUXFUVOBGVUSUXEUVNVUSUXDUVMJNVUSUVGUXCUVLVUSUXBUVKGMVUSUXAUVJEVUSUWTUVIF
      UWRUVHUEUFVSWBVCVGVHVIVJVKVUSUXIUWCUXJUWDRVUSUXHUWBUWAUWRUVHDWGZWLVUSUXHU
      WBUWAVUTWMWNWIWJWKAUXTUXNAUXRUJZBGWRUXTAVVABGAUVGGSZWOZUXQVVAVVCJPUXPNJWP
      SJPNOWSJWQWTAGXASZVVBUXPPQAUWHGEXIOVVDIDEFGXBGEXIXCXDVAUVGGXAXEXFXGUXQXHV
      EXJUXRBGXKXLXMUYBVMSZAUYQVUMAVVEUYQVUMTAVVEWOZUYQUYSUYPTVUMVVFUYSUYCUYPVV
      FUYBUYRVLOZUYSUYCVVFUYBVVEUYBWFSZAUYBVOXNZXOVVFVVHUYRWFSZUWMVVGUYSWOUYCTV
      VIVVFVVHVVJVVIUYBXPVEAUWMVVEUWOXTUYBUYRUVHXQXRXSYIVVFUYSUYPVULVVFUYSUYPVU
      LVVFUYSUYPWOZWOZUCVUGVUKUCUDZVUGSVVMGSZJVVMVUCKZNOZUJZWOZVVLVVMVUKSZVUFVV
      QBVVMGUVGVVMQZVUEVVPVVTVUDVVOJNUVGVVMVUCWGVIVJYAVVLVVRVVNVVSWOVVSVVLVVNVV
      QVVSVVLVVNWOBCDVVMEFUYBGAUWIVVEVVKVVNHYBAUWHVVEVVKVVNIYBAVVEVVKVVNYCVVFUY
      SUYPVVNYDVVLVVNYEVVFUYSUYPVVNYFYGYHVVLVVSVVNVVLVUKGVVMVVLVUKGVVLRGYJZSVUJ
      VWASZVUKVWASGYKVVLVUJGYLZVWBVVLUWAGSVUHGSVWCVVLPUVHUFLZGPDAVWDGDYMZVVEVVK
      AUWHVWEIDEFGYNVEYOZVVLUVHPYPKZSPVWDSVVLUVHVMVWGAUWLVVEVVKUWQYOZYQYRPUVHUU
      AVEYSVVLVWDGUYRDVWFVVLUYRVWDSZUYSVVFUYSUYPUUBVVLUYRVWGSUVHWPSVWIUYSUVCVVL
      UYRVMVWGVVEUYRVMSAVVKUYBUUCUUDYQYRVVLUVHVWHUUEUYRPUVHUUFURUUGYSUWAVUHGUUH
      URVUJGUWAVUHUUIUUJXLVUIRVUJVWAUUKUULUUMUUNUUOUUPUUQUURUUSYTUUTUVAYTUVDUVB
      UVEUVF $.
  $}

  ${
    $d f p x y E $.  $d f p x y V $.  $d f p x y W $.
    $( A graph with an Eulerian path has either zero or two vertices of odd
       degree.  (Contributed by Mario Carneiro, 7-Apr-2015.) $)
    eupath $p |- ( ( V EulPaths E ) =/= (/) ->
      ( # ` { x e. V | -. 2 || ( ( V VDeg E ) ` x ) } ) e. { 0 , 2 } ) $=
      ( vf vp vy co c0 wne cv cdm wcel wex c2 cfv wbr chash cc0 wceq cvv wn cpr
      ceup cvdg cdivides crab wrel wb releupa reldm0 ax-mp necon3bii bitri eldm
      vex cif cumg cle cpw csn cdif wfn eupagra umgraf2 ffn 3syl eupath2 fveq2d
      n0 wf id fveq2 eleq1d hash0 c0ex prid1 eqeltri simpr neneqad fvex hashprg
      wa a1i mp2an sylib cc elexi prid2 syl6eqel ifbothda eqeltrd exlimiv sylbi
      2cn ) CBUCGZHIZDJZWOKZLZDMZNAJCBUDGOUEPUAACUFZQOZRNUBZLZWPWRHIWTWOHWRHWOU
      GWOHSWRHSUHBCUIWOUJUKULDWRVIUMWSXDDWSWQEJZWOPZEMXDEWQWODUOUNXFXDEXFXBRXEO
      ZWQQOZXEOZSZHXGXIUBZUPZQOZXCXFXAXLQXFABKZXEBWQCXFCBUQPXNFJQONURPFCUSHUTVA
      UFZBVJBXNVBXEBWQCVCFBCVDXNXOBVEVFXFVKVGVHXJHQOZXCLZXKQOZXCLXMXCLXFHXKHXLS
      XPXMXCHXLQVLVMXKXLSXRXMXCXKXLQVLVMXQXFXJWBXPRXCVNRNVOVPVQWCXFXJUAZWBZXRNX
      CXTXGXIIZXRNSZXTXGXIXFXSVRVSXGTLXITLYAYBUHRXEVTXHXEVTXGXITWAWDWERNNWFWNWG
      WHWIWJWKWLWMWLWM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               The Konigsberg Bridge problem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x E $.  $d x U $.  $d x V $.  $d x X $.  $d x Y $.
    vdeg0i.v $e |- V e. _V $.
    ${
      vdeg0i.u $e |- U e. V $.
      $( The base case for the induction for calculating the degree of a
         vertex.  The degree of ` U ` in the empty graph is ` 0 ` .
         (Contributed by Mario Carneiro, 12-Mar-2015.) $)
      vdeg0i $p |- ( ( V VDeg (/) ) ` U ) = 0 $=
        ( cvv wcel c0 cvdg co cfv cc0 wceq vdgr0 mp2an ) BEFABFABGHIJKLCDABEMN
        $.
    $}

    ${
      umgrabi.4 $e |- X e. V $.
      umgrabi.5 $e |- Y e. V $.
      $( Show that an unordered pair is a valid edge in a graph.  (Contributed
         by Mario Carneiro, 12-Mar-2015.)  (Revised by Mario Carneiro,
         28-Feb-2016.) $)
      umgrabi $p |- ( ph ->
        { X , Y } e. { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) $=
        ( cpr cv chash cfv c2 cle wbr cpw c0 csn wcel mpbir2an cdif prssi mp2an
        crab wne wss elpw2 mpbir elexi prnz eldifsn hashprlei simpri wceq fveq2
        cfn breq1d elrab a1i ) DEIZBJZKLZMNOZBCPZQRUAZUDSZAVFUTVESZUTKLZMNOZVGU
        TVDSZUTQUEVJUTCUFZDCSECSVKGHDECUBUCUTCFUGUHDEDCGUIUJUTVDQUKTUTUPSVIDEUL
        UMVCVIBUTVEVAUTUNVBVHMNVAUTKUOUQURTUS $.
    $}

    vdegp1ai.1 $e |- ( T. ->
       E e. Word { x e. ( ~P V \ { (/) } ) | ( # ` x ) <_ 2 } ) $.
    vdegp1ai.u $e |- U e. V $.
    vdegp1ai.2 $e |- ( ( V VDeg E ) ` U ) = P $.
    ${
      vdegp1ai.3 $e |- X e. V $.
      vdegp1ai.4 $e |- X =/= U $.
      vdegp1ai.5 $e |- Y e. V $.
      vdegp1ai.6 $e |- Y =/= U $.
      vdegp1ai.f $e |- F = ( E concat <" { X , Y } "> ) $.
      $( The induction step for a vertex degree calculation.  If the degree of
         ` U ` in the edge set ` E ` is ` P ` , then adding ` { X , Y } ` to
         the edge set, where ` X =/= U =/= Y ` , yields degree ` P ` as well.
         (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Mario
         Carneiro, 28-Feb-2016.) $)
      vdegp1ai $p |- ( ( V VDeg F ) ` U ) = P $=
        ( wcel wtru a1i cvdg co cfv chash cpr cop csn cun cs1 cconcat cv c2 cle
        wbr cpw c0 cdif crab cword wceq trud umgrabi cats1un mp2an eqtri oveq2i
        fveq1i caddc cc0 cfzo wfn wrdf ffn mp2b wf1o fvex prex f1osn f1ofn mp1i
        wf cfn fzofi snfi cin wn fzonel disjsn mpbir cvv wrdumgra sylibr umgra1
        cumg mp4an vdgrfiun wne vdgr1a cn0 vdgrfif mp3an ffvelrni ax-mp addid1i
        wb nn0cni 3eqtri ) CFEUAUBZUCCFDDUDUCZGHUEZUFUGZUHZUAUBZUCZCFDUAUBZUCZB
        CXHXMEXLFUAEDXJUIUJUBZXLQDAUKUDUCULUMUNAFUOUPUGUQURZUSRZXJXRRZXQXLUTXSJ
        VAZXTSAFGHIMOVBVADXJXRVCVDVEVFVGXNXPCFXKUAUBUCZVHUBZXPVIVHUBXPXNYCUTSVI
        XIVJUBZXIUGZCDXKFDYDVKZSXSYDXRDWAYFYAXRDVLYDXRDVMVNZTYEXJUGZXKVOXKYEVKS
        XIXJDUDVPZGHVQVRYEYHXKVSVTYDWBRZSVIXIWCZTYEWBRSXIWDTYDYEWEUPUTZSYLXIYDR
        WFVIXIWGYDXIWHWITSXSFDWNUNZJFWJRZXSYMXSXEIYAADFWJXRWKVDWLFXKWNUNZSYNXIW
        JRZGFRZHFRZYOIYIMOXIGHFWJWJWMWOTCFRZSKTZWPVAYBVIXPVHYBVIUTSXIGHCFYNSITY
        PSYITYTYQSMTGCWQSNTYRSOTHCWQSPTWRVAVFXPXPYSXPWSRKFWSCXOYNYFYJFWSXOWAIYG
        YKYDDFWJWTXAXBXCXFXDXGLXG $.
    $}

    ${
      vdegp1bi.3 $e |- Q = ( P + 1 ) $.
      vdegp1bi.4 $e |- X e. V $.
      vdegp1bi.5 $e |- X =/= U $.
      ${
        vdegp1bi.f $e |- F = ( E concat <" { U , X } "> ) $.
        $( The induction step for a vertex degree calculation.  If the degree
           of ` U ` in the edge set ` E ` is ` P ` , then adding ` { U , X } `
           to the edge set, where ` X =/= U ` , yields degree ` P + 1 ` .
           (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Mario
           Carneiro, 28-Feb-2016.) $)
        vdegp1bi $p |- ( ( V VDeg F ) ` U ) = Q $=
          ( co wtru wcel a1i chash cfv cpr cop csn cun cvdg caddc wceq cc0 cfzo
          c1 cv c2 cle wbr cpw cdif crab cword wfn wrdf ffn 3syl wf1o fvex prex
          c0 wf f1osn f1ofn mp1i cfn fzofi snfi cin wn fzonel disjsn mpbir cumg
          cvv wb wrdumgra mp2an sylibr umgra1 mp4an vdgrfiun wne vdgr1b oveq12i
          trud eqtri cs1 cconcat umgrabi cats1un oveq2i fveq1i 3eqtr4i ) DGEEUA
          UBZDHUCZUDUEZUFZUGQZUBZBULUHQZDGFUGQZUBCXGDGEUGQUBZDGXDUGQUBZUHQZXHXG
          XLUIRUJXBUKQZXBUEZDEXDGREAUMUAUBUNUOUPAGUQVHUEURUSZUTSZXMXOEVIEXMVAJX
          OEVBXMXOEVCVDXNXCUEZXDVEXDXNVARXBXCEUAVFZDHVGVJXNXQXDVKVLXMVMSRUJXBVN
          TXNVMSRXBVOTXMXNVPVHUIZRXSXBXMSVQUJXBVRXMXBVSVTTRXPGEWAUPZJGWBSZXPXTX
          PWCIXPJWMZAEGWBXOWDWEWFGXDWAUPZRYAXBWBSZDGSZHGSZYCIXRKNXBDHGWBWBWGWHT
          YERKTZWIWMXJBXKULUHLXKULUIRXBHDGYARITYDRXRTYGYFRNTHDWJROTWKWMWLWNDXIX
          FFXEGUGFEXCWOWPQZXEPXPXCXOSZYHXEUIYBYIRAGDHIKNWQWMEXCXOWRWEWNWSWTMXA
          $.
      $}

      vdegp1ci.f $e |- F = ( E concat <" { X , U } "> ) $.
      $( The induction step for a vertex degree calculation.  If the degree of
         ` U ` in the edge set ` E ` is ` P ` , then adding ` { X , U } ` to
         the edge set, where ` X =/= U ` , yields degree ` P + 1 ` .
         (Contributed by Mario Carneiro, 12-Mar-2015.)  (Revised by Mario
         Carneiro, 28-Feb-2016.) $)
      vdegp1ci $p |- ( ( V VDeg F ) ` U ) = Q $=
        ( cpr cs1 cconcat co wceq prcom s1eq ax-mp oveq2i eqtri vdegp1bi ) ABCD
        EFGHIJKLMNOFEHDQZRZSTEDHQZRZSTPUIUKESUHUJUAUIUKUAHDUBUHUJUCUDUEUFUG $.
    $}
  $}

  ${
    $d x E $.  $d x V $.
    konigsberg.v $e |- V = ( 0 ... 3 ) $.
    konigsberg.e $e |- E = <" { 0 , 1 } { 0 , 2 } { 0 , 3 }
                              { 1 , 2 } { 1 , 2 } { 2 , 3 } { 2 , 3 } "> $.
    $( The Konigsberg Bridge problem.  If ` <. V , E >. ` is the graph on four
       vertices ` 0 , 1 , 2 , 3 ` , with edges ` { 0 , 1 } , { 0 , 2 } , `
       ` { 0 , 3 } , { 1 , 2 } , { 1 , 2 } , { 2 , 3 } , { 2 , 3 } ` , then
       vertices ` 0 , 1 , 3 ` each have degree three, and ` 2 ` has degree
       five, so there are four vertices of odd degree and thus by ~ eupath the
       graph cannot have an Eulerian path.  (Contributed by Mario Carneiro,
       11-Mar-2015.)  (Revised by Mario Carneiro, 28-Feb-2016.) $)
    konigsberg $p |- ( V EulPaths E ) = (/) $=
      ( vx c2 co cfv wbr c3 c0 wceq cc0 c1 cfn wcel cn0 mp2an wtru vdegp1ai clt
      cv cvdg cdivides crab chash ceup cle cpr csn cun caddc prfi 3ne0 1re 1lt3
      wn gtneii nelpri wa wi 3nn0 hashunsng ax-mp df-3 ax-1ne0 necomi 0nn0 1nn0
      wne wb hashprg mpbi oveq1i eqtr4i cdom wss fzfi eqeltri ssrab2 ssfi nn0uz
      cfz cuz eleqtri eluzfz1 eleqtrri 2nn 1nn cmul 2cn mulid1i 1lt2 ndvdsi cs6
      fveq2 elexi cpw cdif cs5 df-s6 cs4 df-s5 cs3 df-s4 cs2 df-s3 df-s2 ltleii
      cs1 3re cz nn0zi elfz5 mpbir umgrabi s1cld 2re 2lt3 2nn0 cats1cld eluzfz2
      cword wrd0 a1i vdeg0i 1e0p1 vdegp1bi df-2 2ne0 syl6eq breq2d notbid elrab
      mpbir2an vdegp1ci 3pos ltneii id syl6eqbr cconcat df-s7 eqtri prssi snssi
      s0s1 cs7 0re unssi ssdomg snfi unfi hashdom eqbrtrri hashcl nn0rei lenlti
      mp2 wo eupath elpri jaoi 3syl necon1bi ) FEUBZBAUCGZHZUDIZUQZEBUEZUFHZJUA
      IZUQZBAUGGZKLJUVKUHIUVMMNUIZJUJZUKZUFHZJUVKUHUVRUVOUFHZNULGZJUVOOPZJUVOPU
      QZUVRUVTLZMNUMZJMNUNNJUOUPURZUSJQPUWAUWBUTUWCVAVBUVOJQVCVDRJFNULGZUVTVEUV
      SFNULMNVJZUVSFLZNMVFVGZMQPNQPUWGUWHVKVHVIMNQVLRVMVNVOVOUVRUVKUHIZUVQUVJVP
      IZUVJOPZUVQUVJVQUWKBOPUVJBVQUWLBMJWCGZOCMJVRVSZUVIEBVTBUVJWARZUVOUVPUVJMU
      VJPZNUVJPZUVOUVJVQUWPMBPFJUDIZUQZMUWMBJMWDHZPZMUWMPJQUWTVBWBWEZMJWFVDCWGZ
      FJNNWHVIWIFNWJGZNULGUWFJUXDFNULFWKWLVNVEVOWMWNZUVIUWSEMBUVEMLZUVHUWRUXFUV
      GJFUDUXFUVGMUVFHJUVEMUVFWPEJMUVOMFUIZMJUIZNFUIZUXIFJUIZWOZABFJBOUWNWQZSUV
      EUFHFUHIEBWRKUJWSUEZUVOUXGUXHUXIUXIWTZUXKUXJUVOUXGUXHUXIUXIUXJXAZSUXMUVOU
      XGUXHUXIXBZUXNUXIUVOUXGUXHUXIUXIXCZSUXMUVOUXGUXHXDZUXPUXIUVOUXGUXHUXIXEZS
      UXMUVOUXGXFZUXRUXHUVOUXGUXHXGZSUXMUVOXJZUXTUXGUVOUXGXHZSUVOUXMSEBMNUXLUXC
      NUWMBNUWMPZNJUHIZNJUOXKUPXINUWTPJXLPZUYDUYEVKNQUWTVIWBWEJVBXMZNMJXNRXOCWG
      ZXPXQZSEBMFUXLUXCFUWMBFUWMPZFJUHIZFJXRXKXSXIFUWTPUYFUYJUYKVKFQUWTXTWBWEUY
      GFMJXNRXOCWGZXPYAZSEBMJUXLUXCJUWMBUXAJUWMPUXBMJYBVDCWGZXPYAZSEBNFUXLUYHUY
      LXPZYAZUYPYAZSEBFJUXLUYLUYNXPYAZUXCEJMUXNUXKBFJUXLUYRUXCEJMUXPUXNBNFUXLUY
      QUXCEJMUXRUXPBNFUXLUYOUXCEFJMUXTUXRBJUXLUYMUXCENFMUYBUXTBFUXLUYIUXCEMNMKU
      YBBNUXLKUXMYCPSUXMYDYEZUXCMBUXLUXCYFYGUYHVFUVOUUFZYHYIUYLYJUYCYHVEUYNUNUY
      AYHUYHVFUYLYJUXSTUYHVFUYLYJUXQTUYLYJUYNUNUXOTUYLYJUYNUNAUVOUXGUXHUXIUXIUX
      JUXJUUGUXKUXJXJUUAGDUVOUXGUXHUXIUXIUXJUXJUUBUUCZTYKYLYMYNYOUWQNBPUWSUYHUX
      EUVIUWSENBUVENLZUVHUWRVUCUVGJFUDVUCUVGNUVFHJUVENUVFWPEJNUXKABFJUXLUYSUYHE
      JNUXNUXKBFJUXLUYRUYHEFJNUXPUXNBFUXLUYQUYHENFNUXRUXPBFUXLUYOUYHENNUXTUXRBM
      JUXLUYMUYHENNUYBUXTBMFUXLUYIUYHEMNNKUYBBMUXLUYTUYHNBUXLUYHYFYGUXCUWIVUAYP
      UXCUWIUYLNFUOWMURZUYCTUXCUWIUYNUWEUYATYIUYLVUDUXSYHVEUYLVUDUXQYHUYLVUDUYN
      UWEUXOTUYLVUDUYNUWEVUBTYKYLYMYNYOMNUVJUUDRJUVJPZUVPUVJVQVUEJBPUWSUYNUXEUV
      IUWSEJBUVEJLZUVHUWRVUFUVGJFUDVUFUVGJUVFHJUVEJUVFWPEFJJUXKABFUXLUYSUYNENFJ
      UXNUXKBFUXLUYRUYNENJUXPUXNBNFUXLUYQUYNENJUXRUXPBNFUXLUYOUYNEMNJUXTUXRBMUX
      LUYMUYNEMJUYBUXTBMFUXLUYIUYNEMJKUYBBMNUXLUYTUYNJBUXLUYNYFUXCMJUUHYQYRZUYH
      NJUOUPYRZVUATUXCVUGUYLFJXRXSYRZUYCTYGUXCVUGUYAYPUYHVUHUYLVUIUXSTUYHVUHUYL
      VUIUXQTYIUYLVUIUXOYPVEUYLVUIVUBYPYKYLYMYNYOJUVJUUEVDUUIUVQUVJOUUJUURUVQOP
      ZUWLUWJUWKVKUWAUVPOPVUJUWDJUUKUVOUVPUULRUWOUVQUVJOUUMRXOUUNJUVKXKUVKUWLUV
      KQPUWOUVJUUOVDUUPUUQVMUVLUVNKUVNKVJUVKUXGPUVKMLZUVKFLZUUSUVLEABUUTUVKMFUV
      AVUKUVLVULVUKUVKMJUAVUKYSYQYTVULUVKFJUAVULYSXSYTUVBUVCUVDVD $.
  $}

$(
###############################################################################
               GUIDES AND MISCELLANEA
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
          Guides (conventions, explanations, and examples)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Conventions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

This section describes the conventions we use.
However, these conventions often refer to existing mathematical
practices, which are discussed in more detail in other references.

Logic and set theory provide a foundation for all of mathematics.  To learn
about them, you should study one or more of the references listed below.
We indicate references using square brackets.  The
textbooks provide a motivation for what we are doing, whereas Metamath lets you
see in detail all hidden and implicit steps.  Most standard theorems are
accompanied by citations.  Some closely followed texts include the following:

  <HTML><ul>
  <li>Axioms of propositional calculus - [Margaris].</li>
  <li>Axioms of predicate calculus - [Megill] (System S3' in the article
      referenced).</li>
  <li>Theorems of propositional calculus - [WhiteheadRussell].</li>
  <li>Theorems of pure predicate calculus - [Margaris].</li>
  <li>Theorems of equality and substitution - [Monk2], [Tarski], [Megill].</li>
  <li>Axioms of set theory - [BellMachover].</li>
  <li>Development of set theory - [TakeutiZaring].  (The first part of [Quine]
      has a good explanation of the powerful device of "virtual" or
      class abstractions, which is essential to our development.)</li>
  <li>Construction of real and complex numbers - [Gleason]</li>
  <li>Theorems about real numbers - [Apostol]</li></ul></HTML>

$)

  ${
   $( Dummy premise for "conventions" $)
    conventions.1 $e |- ph $.
    $(

       Here are some of the conventions we use in the
       Metamath Proof Explorer (aka "set.mm"), and how they correspond to
       typical textbook language (skipping the many cases
       where they're identical):

       <HTML><br></HTML>

       <HTML><ul>
       <li><b>Notation.</b>
       Where possible, the notation attempts to conform to modern
       conventions, with variations due to our choice of the axiom system
       or to make proofs shorter.  However, our notation is strictly
       sequential (left-to-right). For example, summation is written in the
       form ` sum_ k e. A B ` ( ~ df-sum ) which denotes that index
       variable ` k ` ranges over ` A ` when evaluating ` B ` .  Thus,
       ` sum_ k e. NN ` ` ( 1 / ( 2 ^ k ) ) = 1 ` means 1/2 + 1/4 + 1/8 + ...
       = 1 ( ~ geoihalfsum ).  Also, the method of definition,
       the axioms for predicate calculus, and the
       development of substitution are somewhat different from those found
       in standard texts. For example, the expressions for the
       axioms were designed for direct derivation of
       standard results without excessive use of metatheorems.
       (See Theorem 9.7 of [Megill] p. 448 for a rigorous justification.)
       The notation is usually explained in more detail when first introduced.
       </li>

       <li><b>Axiomatic assertions ($a).</b>
       All axiomatic assertions ($a statements)
       starting with " ` |- ` " have labels starting
       with "ax-" (axioms) or "df-" (definitions).  A statement with a
       label starting with "ax-" corresponds to what is traditionally
       called an axiom.  A statement with a label starting with "df-"
       introduces new symbols or a new relationship among symbols
       that can be eliminated; they always extend the definition of
       a wff or class.  Metamath blindly treats $a statements as new
       given facts but does not try to justify them.  The mmj2 program
       will justify the definitions as sound, except for 4 (df-bi,
       df-cleq, df-clel, df-clab) that require a more complex
       metalogical justification by hand.

       <li><b>Proven axioms.</b>
       In some cases we wish to treat an expression as an axiom in
       later theorems, even though it can be proved.  For example,
       we derive the postulates or axioms of complex arithmetic as
       theorems of ZFC set theory.  For convenience, after deriving
       the postulates we re-introduce them as new axioms on
       top of set theory. This lets us easily identify which axioms
       are needed for a particular complex number proof, without the
       obfuscation of the set theory used to derive them.  For more, see
       ~ http://us.metamath.org/mpeuni/mmcomplex.html .  When we wish
       to use a previously-proven assertion as an axiom, our convention
       is that we use the
       regular "ax-NAME" label naming convention to define the axiom,
       but we precede it with a proof of the same statement with the label
       "axNAME" .  An example is complex arithmetic axiom ~ ax-1cn ,
       proven by the preceding theorem ~ ax1cn .
       The metamath.exe program will warn if an axiom does not match the
       preceding theorem that justifies it if the names match in this way.
       </li>

       <li><b>Definitions (df-...).</b>
       We encourage definitions to include hypertext links to proven examples.
       </li>

       <li><b>Statements with hypotheses.</b> Many theorems and some axioms,
       such as ~ ax-mp , have hypotheses that must be satisfied in order for
       the conclusion to hold, in this case min and maj.  When presented in
       summarized form such as in the Theorem List (click on "Nearby theorems"
       on the ~ ax-mp page), the hypotheses are connected with an ampersand and
       separated from the conclusion with a big arrow, such as in " ` |- ph `
       &amp; ` |- ( ph -> ps ) ` =&gt; ` |- ps ` ". These symbols are _not_
       part of the Metamath language but are just informal notation meaning
       "and" and "implies".
       </li>

       <li><b>Discouraged use and modification.</b>
       If something should only be used in limited ways, it is marked with
       "(New usage is discouraged.)". This is used, for example, when something
       can be constructed in more than one way, and we do not want later
       theorems to depend on that specific construction.
       This marking is also used if we want later proofs to use proven axioms.
       For example, we want later proofs to
       use ~ ax-1cn (not ~ ax1cn ) and ~ ax-1ne0 (not ~ ax1ne0 ), as these
       are proven axioms for complex arithmetic.  Thus, both
       ~ ax1cn and ~ ax1ne0 are marked as "(New usage is discouraged.)".
       In some cases a proof should not normally be changed, e.g., when it
       demonstrates some specific technique.
       These are marked with "(Proof modification is discouraged.)".
       </li>

       <li><b>New definitions infrequent.</b>
       Typically, we are minimalist when introducing new definitions; they are
       introduced only when a clear advantage becomes apparent for reducing
       the number of symbols, shortening proofs, etc.  We generally avoid
       the introduction of gratuitous definitions because each one requires
       associated theorems and additional elimination steps in proofs.
       For example, we use ` < ` and ` <_ ` for inequality expressions, and
       use ` ( ( sin `` ( _i x. A ) ) / _i ) ` instead of ` ( sinh `` A ) `
       for the hyperbolic sine.
       </li>

       <li><b>Axiom of choice.</b>
       The axiom of choice ( ~ df-ac ) is widely accepted, and ZFC is the most
       commonly-accepted fundamental set of axioms for mathematics.
       However, there have been and still are some lingering controversies
       about the Axiom of Choice.  Therefore, where a proof
       does not require the axiom of choice, we prefer that proof instead.
       E.g., our proof of the Schroeder-Bernstein Theorem ( ~ sbth )
       does not use the axiom of choice.
       In some cases, the weaker axiom of countable choice ( ~ ax-cc )
       or axiom of dependent choice ( ~ ax-dc ) can be used instead.
       </li>

       <li><b>Variables.</b>
       Typically, Greek letters
       ( ` ph ` = phi, ` ps ` = psi, ` ch ` = chi, etc.),... are used for
       propositional (wff) variables;
       ` x ` , ` y ` , ` z ` ,...  for individual (set) variables;
       and ` A ` , ` B ` , ` C ` ,... for class variables.</li>

       <li><b>Turnstile.</b>
       "` |- ` ", meaning "It is provable that," is the first token
       of all assertions
       and hypotheses that aren't syntax constructions.  This is a standard
       convention in logic.  For us, it also prevents any ambiguity with
       statements that are syntax constructions, such as "wff ` -. ph ` ".</li>

       <li><b>Biconditional ( ` <-> ` ).</b>
       There are basically two ways to maximize the effectiveness of
       biconditionals ( ` <-> ` ):
       you can either have one-directional simplifications of all theorems
       that <i>produce</i> biconditionals, or you can have one-directional
       simplifications of theorems that <i>consume</i> biconditionals.
       Some tools (like Lean) follow the first approach, but set.mm follows
       the second approach. Practically, this means that in set.mm, for
       every theorem that uses an implication in the hypothesis, like
       ~ ax-mp , there is a corresponding version with a biconditional or a
       reversed biconditional, like ~ mpbi or ~ mpbir .  We prefer this
       second approach because the number of duplications in the second
       approach is bounded by the size of the propositional calculus section,
       which is much smaller than the number of possible theorems in all later
       sections that produce biconditionals.  So although theorems like
       ~ biimpi are available, in most cases there is already a theorem that
       combines it with your theorem of choice, like ~ mpbir2an , ~ sylbir ,
       or ~ 3imtr4i .

       <li><b>Substitution.</b>
       "` [ y / x ] ph ` " should be read "the wff that results from the
       proper substitution of ` y ` for ` x ` in wff ` ph ` ." See ~ df-sb
       and the related ~ df-sbc and ~ df-csb .</li>

       <li><b>Is-a set.</b>
       "` A e. _V ` " should be read
       "Class ` A ` is a set (i.e. exists)."
       This is a convenient convention based on
       Definition 2.9 of [Quine] p. 19.  See ~ df-v and ~ isset .</li>

       <li><b>Converse.</b>
       "` ``' R ` " should be read "converse of (relation) ` R ` "
       and is the same as the more standard notation R^{-1}
       (the standard notation is ambiguous). See ~ df-cnv .
       This can be used to define a subset, e.g., ~ df-tan notates
       "the set of values whose cosine is a nonzero complex number" as
       ` ( ``' cos " ( CC \ { 0 } ) ) ` .
       </li>

       <li><b>Function application.</b>
       "( ` F `` x ` )" should be read "the value
       of function ` F ` at ` x ` " and has the same meaning as the more
       familiar but ambiguous notation F(x).  For example,
       ` ( cos `` 0 ) = 1 ` (see ~ cos0 ).  The left apostrophe notation
       originated with Peano and was adopted in Definition *30.01 of
       [WhiteheadRussell] p. 235, Definition 10.11 of [Quine] p. 68, and
       Definition 6.11 of [TakeutiZaring] p. 26.  See ~ df-fv .
       In the ASCII (input) representation there are spaces around the grave
       accent; there is a single accent when it is used directly,
       and it is doubled within comments.
       </li>

       <li><b>Infix and parentheses.</b>
       When a function that takes two classes and produces a class
       is applied as part of an infix expression, the expression is always
       surrounded by parentheses (see ~ df-ov ).
       For example, the ` + ` in ` ( 2 + 2 ) ` ; see ~ 2p2e4 .
       Function application is itself an example of this.
       Similarly, predicate expressions
       in infix form that take two or three wffs and produce a wff
       are also always surrounded by parentheses, such as
       ` ( ph -> ps ) ` , ` ( ph \/ ps ) ` , ` ( ph /\ ps ) ` , and
       ` ( ph <-> ps ) `
       (see ~ wi , ~ df-or , ~ df-an , and ~ df-bi respectively).
       In contrast, a binary relation (which compares two _classes_ and
       produces a _wff_) applied in an infix expression is _not_
       surrounded by parentheses.
       This includes set membership ` A e. B ` (see ~ wel ),
       equality ` A = B ` (see ~ df-cleq ),
       subset ` A C_ B ` (see ~ df-ss ), and
       less-than ` A < B ` (see ~ df-lt ).  For the general definition
       of a binary relation in the form ` A R B ` , see ~ df-br .
       For example, ` 0 < 1 ` ( see ~ 0lt1 ) does not use parentheses.
       </li>

       <li><b>Unary minus.</b>
       The symbol ` -u ` is used to indicate a unary minus, e.g., ` -u 1 ` .
       It is specially defined because it is so commonly used.
       See ~ cneg .</li>

       <li><b>Function definition.</b>
       Functions are typically defined by first defining the constant symbol
       (using $c) and declaring that its symbol is a class with the
       label cNAME (e.g., ~ ccos ).
       The function is then defined labelled df-NAME; definitions
       are typically given using the maps-to notation (e.g., ~ df-cos ).
       Typically, there are other proofs such as its
       closure labelled NAMEcl (e.g., ~ coscl ), its
       function application form labelled NAMEval (e.g., ~ cosval ),
       and at least one simple value (e.g., ~ cos0 ).
       </li>

       <li><b>Factorial.</b>
       The factorial function is traditionally a postfix operation,
       but we treat it as a normal function applied in prefix form, e.g.,
       ` ( ! `` 4 ) = ; 2 4 ` ( ~ df-fac and ~ fac4 ).</li>

       <li><b>Unambiguous symbols.</b>
       A given symbol has a single unambiguous meaning in general.
       Thus, where the literature might use the same symbol with different
       meanings, here we use different (variant) symbols for different
       meanings.  These variant symbols often have suffixes, subscripts,
       or underlines to distinguish them.  For example, here
       "` 0 ` " always means the value zero ( ~ df-0 ), while
       "` 0g ` " is the group identity element ( ~ df-0g ),
       "` 0. ` " is the poset zero ( ~ df-p0 ),
       "` 0p ` " is the zero polynomial ( ~ df-0p ),
       "` 0vec ` " is the zero vector in a normed complex vector space
       ( ~ df-0v ), and
       "` .0. ` " is a class variable for use as a connective symbol
       (this is used, for example, in ~ p0val ).
       There are other class variables used as connective symbols
       where traditional notation would use ambiguous symbols, including
       "` .1. ` ", "` .+ ` ", "` .* ` ", and "` .|| ` ".
       These symbols are very similar to traditional notation, but because
       they are different symbols they eliminate ambiguity.
       </li>

       <li><b>Natural numbers.</b>
       There are different definitions of "natural" numbers in the literature.
       We use ` NN ` ( ~ df-nn ) for the integer numbers starting
       from 1, and ` NN0 ` ( ~ df-n0 ) for the set of nonnegative integers
       starting at zero.
       </li>

       <li><b>Decimal numbers.</b>
       Numbers larger than ten are often expressed in base 10
       using the decimal constructor ~ df-dec , e.g.,
       ` ; ; ; 4 0 0 1 ` (see ~ 4001prm for a proof that 4001 is prime).</li>

       <li><b>Theorem forms.</b>
       We often call a theorem a "deduction" whenever the conclusion and
       all hypotheses are each prefixed
       with the same antecedent ` ph -> ` .  Deductions are often the
       preferred form for theorems because they
       allow us to easily use the theorem in places where
       (in traditional textbook formalizations) the standard
       Deduction Theorem would be used.  See, for example, ~ a1d .
       A deduction hypothesis can have an indirect antecedent via definitions,
       e.g., see ~ lhop .  Deductions have a label suffix of "d"
       if there are other forms of the same theorem.  By contrast,
       we tend to call the simpler version with no common antecedent an
       "inference" and suffix its label with "i"; compare theorem ~ a1i .
       Finally, a "tautology" would be the form with no hypotheses,
       and its label would have no suffix.  For example, see ~ pm2.43 ,
       ~ pm2.43i , and ~ pm2.43d .</li>

       <li><b>Deduction theorem.</b>
       The Deduction Theorem is a metalogical theorem that
       provides an algorithm for constructing a proof of a theorem from
       the proof of its corresponding deduction.
       In ordinary mathematics, no one actually carries out the algorithm,
       because (in its most basic form) it involves an exponential
       explosion of the number of proof steps as more hypotheses are
       eliminated. Instead, in ordinary mathematics the Deduction Theorem
       is invoked simply to claim that something can be done in principle,
       without actually doing it.  For more details, see
       ~ http://us.metamath.org/mpeuni/mmdeduction.html .
       The Deduction Theorem is a metalogical theorem that cannot be
       applied directly in metamath, and the explosion of steps would
       be a problem anyway, so alternatives are used.  One alternative
       we use sometimes is the "weak deduction theorem" ~ dedth ,
       which works in certain cases in set theory.  We also
       sometimes use ~ dedhb .
       However, the primary mechanism we use today for
       emulating the deduction theorem is to write proofs in the deduction
       theorem form (aka "deduction style") described earlier; the
       prefixed ` ph -> ` mimics the context in a deduction proof system.
       In practice this mechanism works very well.
       This approach is described in the
       <A HREF="http://us.metamath.org/mpeuni/mmnatded.html">deduction form
       and natural deduction</A> page; a list of translations
       for common natural deduction rules is given in ~ natded .
       </li>

       <li><b>Recursion.</b>  We define recursive functions
       using various "recursion constructors".  These allow us to define, with
       compact direct definitions, functions that are usually defined in
       textbooks with indirect self-referencing recursive definitions.
       This produces compact definition and much simpler proofs, and
       greatly reduces the risk of creating unsound definitions.
       Examples of recursion constructors include ` recs ( F ) ` in ~ df-recs ,
       ` rec ( F , I ) ` in ~ df-rdg , ` seqom ( F , I ) ` in ~ df-seqom , and
       ` seq M ( .+ , F ) ` in ~ df-seq .
       These have characteristic function ` F ` and initial value ` I ` .
       ( ` gsum ` in ~ df-gsum isn't really designed for arbitrary recursion,
       but you could do it with the right magma.)
       The logically primary one is ~ df-recs , but for the "average user"
       the most useful one is probably ~ df-seq - provided that
       a countable sequence is sufficient for the recursion.</li>

       <li><b>Extensible structures.</b>
       Mathematics includes many structures such as
       ring, group, poset, etc.  We define an "extensible structure"
       which is then used to define group, ring, poset, etc.
       This allows theorems from more general structures (groups)
       to be reused for more specialized structures (rings) without
       having to reprove them.  See ~ df-struct .</li>

       <li><b>Organizing proofs.</b>
       Humans have trouble understanding long proofs.
       It is often preferable to break longer proofs into
       smaller parts (just as with traditional proofs). In Metamath
       this is done by creating separate proofs of the separate parts.
       A proof with the sole purpose of supporting a final proof is a
       lemma; the naming convention for a lemma is the final proof's name
       followed by "lem", and a number if there is more than one. E.g.,
       ~ sbthlem1 is the first lemma for ~ sbth .  Also, consider proving
       reusable results separately, so that others will be able to easily
       reuse that part of your work.
       </li>

       <li><b>Hypertext links.</b>
       We strongly encourage comments to have many links to related material,
       with accompanying text that explains the relationship.
       These can help readers understand the context.
       Links to other statements, or to HTTP/HTTPS URLs,
       can be inserted in ASCII source text by prepending a
       space-separated tilde.
       When metamath.exe is used to generate HTML it automatically inserts
       hypertext links for syntax used (e.g., every symbol used),
       every axiom and definition depended on, the justification
       for each step in a proof, and to both the
       next and previous assertion.
       </li>

       <li><b>Bibliography references.</b>
       Please include a bibliographic reference to any external material used.
       A name in square brackets in a comment indicates a
       bibliographic reference. The full reference must be of the form
       KEYWORD IDENTIFIER? NOISEWORD(S)* &#91;AUTHOR(S)&#93; p. NUMBER -
       note that this is a very specific form that requires a page number.
       There should be no comma between the author reference and the
       "p." (a constant indicator).
       Whitespace, comma, period, or semicolon should follow NUMBER.
       An example is Theorem 3.1 of [Monk1] p. 22,
       The KEYWORD, which is not case-sensitive,
       must be one of the following: Axiom, Chapter, Compare, Condition,
       Corollary, Definition, Equation, Example, Exercise, Figure, Item,
       Lemma, Lemmas, Line, Lines, Notation, Part, Postulate, Problem,
       Property, Proposition, Remark, Rule, Scheme, Section, or Theorem.
       The IDENTIFIER is optional, as in for example
       "Remark in [Monk1] p. 22".
       The NOISEWORDS(S) are zero or more from the list: from, in, of, on.
       The AUTHOR(S) must be present in the file identified with the
       htmlbibliography assignment (e.g.  mmset.html) as a named anchor
       (NAME=).  If there is more than one document by the same author(s),
       add a numeric suffix (as shown here).
       The NUMBER is a page number, and may be any alphanumeric string such as
       an integer or Roman numeral.
       Note that we _require_ page numbers in comments for individual
       $a or $p statements.  We allow names in square brackets without
       page numbers (a reference to an entire document) in
       heading comments.
       If this is a new reference, please also add it to the
       "Bibliography" section of mmset.html.
       (The file mmbiblio.html is automatically rebuilt, e.g.,
       using the metamath.exe "write bibliography" command.)</li>

       <li><b>Input format.</b>
       The input is in ASCII with two-space indents.
       Tab characters are not allowed.
       Use embedded math comments or HTML entities for non-ASCII characters
       (e.g., "&amp;eacute;" for "&eacute;").

       <li><b>Information on syntax, axioms, and definitions.</b>
       For a hyperlinked list of syntax, axioms, and definitions, see
       ~ http://us.metamath.org/mpeuni/mmdefinitions.html .
       If you have questions about a specific symbol or axiom, it is best
       to go directly to its definition to learn more about it.
       The generated HTML for each theorem and axiom includes hypertext
       links to each symbol's definition.
       </li>
       </ul></HTML>

       <HTML><b>Naming conventions</b></HTML>

       Every statement has a unique identifying label.
       We use various label naming conventions to provide
       easy-to-remember hints about their contents.
       Labels are not a 1-to-1 mapping, because that would create
       long names that would be difficult to remember and tedious to type.
       Instead, label names are relatively short while
       suggesting their purpose.
       Names are occasionally changed to make them more consistent or
       as we find better ways to name them.
       Here are a few of the label naming conventions:

       <HTML><ul>
       <li><b>Axioms, definitions, and wff syntax.</b>
       As noted earlier, axioms are named "ax-NAME",
       proofs of proven axioms are named "axNAME", and
       definitions are named "df-NAME".
       Wff syntax declarations have labels beginning with "w"
       followed by short fragment suggesting its purpose.</li>
       <li><b>Hypotheses.</b>
       Hypotheses have the name of the final axiom or theorem, followed by
       ".", followed by a unique id.</li>
       <li><b>Common names.</b>
       If a theorem has a well-known name, that name (or a short version of it)
       is sometimes used directly. Examples include
       ~ barbara and ~ stirling .</li>
       <li><b>Syntax label fragments.</b>
       Most theorems are named using syntax label fragments.
       Almost every syntactic construct has a definition labelled "df-NAME",
       and NAME normally is the syntax label fragment.
       For example, the difference construct ` ( A \ B ) `
       is defined in ~ df-dif , and thus its syntax label fragment is "dif".
       Similarly, the singleton construct
       ` { A } ` has syntax label fragment "sn"
       (because it is defined in ~ df-sn ),
       the subclass (subset) relation ` A C_ B ` has "ss"
       (because it is defined in ~ df-ss ), and
       the pair construct ` { A , B } ` has "pr" ( ~ df-pr ).
       Theorem names are often a concatenation of the syntax label fragments
       (omitting variables).
       For example, a theorem about
       ` ( A \ B ) C_ A ` involves a difference ("dif")
       of a subset ("ss"), and thus is named ~ difss .
       Digits are used to represent themselves.
       Suffixes (e.g., with numbers) are sometimes used to distinguish
       multiple theorems that would otherwise produce the same label.</li>
       <li><b>Phantom definitions.</b>
       In some cases there are common label fragments for something that
       could be in a definition, but for technical reasons is not.
       The is-element-of (is member of) construct ` A e. B `
       does not have a df-NAME definition; in this case its syntax
       label fragment is "el".
       Thus, because the theorem beginning with
       ` ( A e. ( B \ { C } ) ` uses is-element-of ("el")
       of a difference ("dif") of a singleton ("sn"), it is named ~ eldifsn .
       An "n" is often used for negation ( ` -. ` ), e.g., ~ nan .
       <li><b>Exceptions.</b>
       Sometimes there is a definition df-NAME but the
       label fragment is not the NAME part.
       The table below attempts to list all such cases and marks them in bold.
       For example, label fragment
       "cn" represents complex numbers ` CC ` (even though its definition
       is in ~ df-c ) and "re" represents real numbers ` RR ` .
       The empty set ` (/) ` often uses fragment 0, even though it is defined
       in ~ df-nul .
       Syntax construct ` ( A + B ) ` usually uses the fragment "add"
       (which is consistent with ~ df-add ),
       but "p" is used as the fragment for constant theorems.
       Equality ` ( A = B ) ` often uses "e" as the fragment.
       As a result, "two plus two equals four" is named ~ 2p2e4 .</li>
       <li><b>Other markings.</b>
       In labels we sometimes use "com" for "commutative",
       "ass" for "associative", "rot" for "rotation",
       and "di" for "distributive".
       <li><b>Principia Mathematica.</b>
       Proofs of theorems from Principia Mathematica often use a different
       naming convention.
       They are instead often named "pm" followed by its identifier.
       For example, Theorem *2.27 of [WhiteheadRussell] p. 104 is named
       ~ pm2.27 .</li>
       <li><b>Closures and values.</b>
       As noted above,
       if a function df-NAME is defined, there is typically a proof
       of its value named "NAMEval" and its closure named "NAMEcl".
       E.g., for cosine ( ~ df-cos ) we have
       value ~ cosval and closure ~ coscl .
       <li><b>Special cases.</b>
       Sometimes syntax and related markings are
       insufficient to distinguish different theorems.
       For example, there are over 100 different
       implication-exclusive theorems.
       These are then grouped in a more ad-hoc way that attempts to
       make their distinctions clearer.
       These often use abbreviations such as "mp" for "modus ponens",
       "syl" for syllogism, and "id" for "identity".
       It's especially hard to give good names in the propositional
       calculus section because there are so few primitives.  However,
       in most cases this is not a serious problem.  There are a few
       very common theorems like ~ ax-mp and ~ syl that you will have no
       trouble remembering, a few theorem series like syl*anc and simp*
       that you can use parametrically, and a few other useful glue things
       for destructuring 'and's and 'or's (see ~ natded for a list),
       and that's about all you need for most things. As for the rest,
       you can just assume that if it involves three or less connectives
       we probably already have a proof, and searching for it will give
       you the name.

       <li><b>Suffixes.</b>
       We sometimes suffix with "v" the label of a theorem
       eliminating a hypothesis such as ` F/ x ph ` in ~ 19.21 via the use of
       distinct variable conditions combined with ~ nfv .  Conversely, we
       sometimes suffix with "f" the label of a theorem introducing such a
       hypothesis to eliminate the need for the distinct variable condition;
       e.g. ~ euf derived from ~ df-eu .  The "f" stands for "not free in"
       which is less restrictive than "does not occur in."
       We sometimes suffix with "s" the label of an inference
       that manipulates an
       antecedent, leaving the consequent unchanged.  The "s" means that the
       inference eliminates the need for a syllogism ( ~ syl ) -type inference
       in a proof.  When an inference is converted to a
       theorem by eliminating an "is a set" hypothesis, we sometimes
       suffix the theorem form with "g" (for "more general") as in
       ~ uniex vs. ~ uniexg .
       A theorem name is suffixed with "ALT" if it's an alternative
       less-preferred proof of a theorem.</li>
       <li><b>Reuse.</b>
       When creating a new theorem or axiom, try to reuse abbreviations
       used elsewhere.  A comment should explain the first use of an
       abbreviation.</li>
       </ul></HTML>

       <HTML>
       The following table shows some commonly-used abbreviations in labels,
       in alphabetical order.
       For each abbreviation we provide a mnenomic to help you remember it,
       the source theorem/assumption defining it, an expression showing
       what it looks like, whether or not it is a "syntax fragment"
       (an abbreviation that indicates a particular kind of syntax), and
       hyperlinks to label examples that use the abbreviation.
       The abbreviation is bolded if there is a df-NAME definition but
       the label fragment is not NAME.
       This is <i>not</i> a complete list of abbreviations, though
       we do want this to eventually be a complete list of exceptions.
       <table border="1" id="naming-abbreviation-table">
       <tr><th>Abbreviation</th><th>Mnenomic</th><th>Source</th>
       <th>Expression</th><th>Syntax?</th><th>Example(s)</th></tr>
       <tr><td>add</td><td>add (see "p")</td><td> ~ df-add </td>
       <td> ` ( A + B ) ` </td><td>Yes</td>
       <td> ~ addcl , ~ addcom , ~ addass </td></tr>
       <tr><td>ALT</td><td>alternative/less preferred (suffix)</td><td> </td>
       <td> </td><td>No</td><td> </td></tr>
       <tr><td>an</td><td>and</td><td> ~ df-an </td>
       <td> ` ( ph /\ ps ) ` </td><td>Yes</td>
       <td> ~ anor , ~ iman , ~ imnan </td></tr>
       <tr><td>ass</td><td>associative</td><td> </td>
       <td> </td><td>No</td><td> ~ biass , ~ orass , ~ mulass </td></tr>
       <tr><td>bi</td><td>biconditional</td><td> ~ df-bi </td>
       <td> ` ( ph <-> ps ) ` </td><td>Yes</td><td> ~ impbid </td></tr>
       <tr><td><b>cn</b></td><td>complex numbers</td><td> ~ df-c </td>
       <td> ` CC ` </td><td>Yes</td><td> ~ nnsscn , ~ nncn </td></tr>
       <tr><td>com</td><td>commutative</td><td> </td>
       <td> </td><td>No</td><td> ~ orcom , ~ bicomi , ~ eqcomi </td></tr>
       <tr><td>d</td><td>deduction form</td><td> </td>
       <td> </td><td>No</td><td> ~ idd , ~ impbid </td></tr>
       <tr><td>di, distr</td><td>distributive</td><td> </td>
       <td> </td><td>No</td>
       <td> ~ andi , ~ imdi , ~ ordi , ~ difindi , ~ ndmovdistr </td></tr>
       <tr><td>dif</td><td>difference</td><td> ~ df-dif </td>
       <td> ` ( A \ B ) ` </td><td>Yes</td>
       <td> ~ difss , ~ difindi </td></tr>
       <tr><td>div</td><td>division</td><td> ~ df-div </td>
       <td> ` ( A / B ) ` </td><td>Yes</td>
       <td> ~ divcl , ~ divval , ~ divmul </td></tr>
       <tr><td><b>e, eq</b></td><td>equals</td><td> ~ df-cleq </td>
       <td> ` A = B ` </td><td>Yes</td><td> ~ 2p2e4 , ~ uneqri </td></tr>
       <tr><td>el</td><td>element of</td><td> </td>
       <td> ` A e. B ` </td><td>Yes</td>
       <td> ~ eldif , ~ eldifsn , ~ elssuni </td></tr>
       <tr><td>f</td><td>"not free in" (suffix)</td><td> </td>
       <td> </td><td>No</td><td> </td></tr>
       <tr><td>g</td><td>more general (suffix); eliminates "is a set"
       hypothsis</td><td> </td>
       <td> </td><td>No</td><td> ~ uniexg </td></tr>
       <tr><td>id</td><td>identity</td><td> </td>
       <td> </td><td>No</td><td> </td></tr>
       <tr><td>idm</td><td>idempotent</td><td> </td>
       <td> </td><td>No</td><td> ~ anidm , ~ tpidm13 </td></tr>
       <tr><td>im, <b>imp</b></td><td>implication (label often omitted)</td>
       <td> ~ df-im </td><td> ` ( A -> B ) ` </td><td>Yes</td>
       <td> ~ iman , ~ imnan , ~ impbidd </td></tr>
       <tr><td>in</td><td>intersection</td><td> ~ df-in </td>
       <td> ` ( A i^i B ) ` </td><td>Yes</td>
       <td> ~ elin , ~ incom </td></tr>
       <tr><td>is...</td><td>is (something a) ...?</td><td> </td>
       <td> </td><td>No</td>
       <td> ~ isrng </td></tr>
       <tr><td>mp</td><td>modus ponens</td><td> ~ ax-mp </td>
       <td> </td><td>No</td><td> ~ mpd , ~ mpi </td></tr>
       <tr><td>mul</td><td>multiplication (see "t")</td><td> ~ df-mul </td>
       <td> ` ( A x. B ) ` </td><td>Yes</td>
       <td> ~ mulcl , ~ divmul , ~ mulcom , ~ mulass </td></tr>
       <tr><td>n, not</td><td>not</td><td> </td>
       <td> ` -. ph ` </td><td>Yes</td>
       <td> ~ nan , ~ notnot2 </td></tr>
       <tr><td>ne0</td><td>not equal to zero (see n0)</td><td></td>
       <td> ` =/= 0 ` </td><td>No</td>
       <td> ~ negne0d , ~ ine0 , ~ gt0ne0 </td></tr>
       <tr><td>nn</td><td>natural numbers</td><td> ~ df-nn </td>
       <td> ` NN ` </td><td>Yes</td><td>  ~ nnsscn , ~ nncn </td></tr>
       <tr><td>n0</td><td>not the empty set (see ne0)</td><td></td>
       <td> ` =/= (/) ` </td><td>No</td><td> ~ n0i , ~ vn0 , ~ ssn0 </td></tr>
       <tr><td>or</td><td>or</td><td> ~ df-or </td>
       <td> ` ( ph \/ ps ) ` </td><td>Yes</td>
       <td> ~ orcom , ~ anor </td></tr>
       <tr><td><b>p</b></td><td>plus (see "add"), for all-constant
       theorems</td>
       <td> ~ df-add </td>
       <td> ` ( 3 + 2 ) = 5 ` </td><td>Yes</td>
       <td> ~ 3p2e5 </td></tr>
       <tr><td>pm</td><td>Principia Mathematica</td><td> </td>
       <td> </td><td>No</td><td> ~ pm2.27 </td></tr>
       <tr><td>pr</td><td>pair</td><td> ~ df-pr </td>
       <td> ` { A , B } ` </td><td>Yes</td>
       <td> ~ elpr , ~ prcom , ~ prid1g , ~ prnz </td></tr>
       <tr><td>q</td><td> ` QQ ` (quotients)</td><td> ~ df-q </td>
       <td> ` QQ ` </td><td>Yes</td>
       <td> ~ elq </td></tr>
       <tr><td><b>re</b></td><td>real numbers</td><td> ~ df-r </td>
       <td> ` RR ` </td><td>Yes</td><td> ~ recn , ~ 0re </td></tr>
       <tr><td>rng</td><td>ring</td><td> ~ df-rng </td>
       <td> ` Ring ` </td><td>Yes</td>
       <td> ~ rngidval , ~ isrng , ~ rnggrp </td></tr>
       <tr><td>rot</td><td>rotation</td><td> </td>
       <td> </td><td>No</td><td> ~ 3anrot , ~ 3orrot </td></tr>
       <tr><td>s</td><td>eliminates need for syllogism (suffix)</td>
       <td> </td> <td> </td><td>No</td><td> </td></tr>
       <tr><td>sn</td><td>singleton</td><td> ~ df-sn </td>
       <td> ` { A } ` </td><td>Yes</td><td> ~ eldifsn </td></tr>
       <tr><td>ss</td><td>subset</td><td> ~ df-ss </td>
       <td> ` A C_ B ` </td><td>Yes</td><td> ~ difss </td></tr>
       <tr><td>sub</td><td>subtract</td><td> ~ df-sub </td>
       <td> ` ( A - B ) ` </td><td>Yes</td>
       <td> ~ subval , ~ subaddi </td></tr>
       <tr><td>syl</td><td>syllogism</td><td> ~ syl </td>
       <td> </td><td>No</td><td> ~ 3syl </td></tr>
       <tr><td><b>t</b></td>
       <td>times (see "mul"), for all-constant theorems</td>
       <td> ~ df-mul </td>
       <td> ` ( 3 x. 2 ) = 6 ` </td><td>Yes</td>
       <td> ~ 3t2e6 </td></tr>
       <tr><td>tp</td><td>triple</td><td> ~ df-tp </td>
       <td> ` { A , B , C } ` </td><td>Yes</td>
       <td> ~ eltpi , ~ tpeq1 </td></tr>
       <tr><td>un</td><td>union</td><td> ~ df-un </td>
       <td> ` ( A u. B ) ` </td><td>Yes</td>
       <td> ~ uneqri , ~ uncom </td></tr>
       <tr><td>v</td><td>distinct variable conditions used when
       a not-free hypothesis (suffix)</td>
       <td> </td> <td> </td><td>No</td><td> ~ spimv </td></tr>
       <tr><td>xr</td><td>eXtended reals</td><td> ~ df-xr </td>
       <td> ` RR* ` </td><td>Yes</td><td> ~ ressxr , ~ rexr , ~ 0xr </td></tr>
       <tr><td>z</td><td> ` ZZ ` (integers, from German Zahlen)</td>
       <td> ~ df-z </td><td> ` ZZ ` </td><td>Yes</td>
       <td> ~ elz , ~ zcn </td></tr>
       <tr><td><b>0, z</b></td>
       <td>slashed zero (empty set) (see n0)</td><td> ~ df-nul </td>
       <td> ` (/) ` </td><td>Yes</td>
       <td> ~ n0i , ~ vn0 ; ~ snnz , ~ prnz </td></tr>
       </table>
       </HTML>

       <HTML><b>Distinctness or freeness</b></HTML>

       Here are some conventions that address distinctness or freeness of a
       variable:

       <HTML><ul>
       <li> ` F/ x ph ` is read " ` x ` is not free in (wff) ` ph ` ";
       see ~ df-nf (whose description has some important technical
       details).  Similarly, ` F/_ x A ` is read ` x ` is not free in (class)
       ` A ` , see ~ df-nfc .</li>

       <li>"$d x y $." should be read "Assume x and y are distinct
       variables."</li>

       <li>"$d x ` ph ` $." should be read "Assume x does not occur in phi $."
       Sometimes a theorem is proved using
       ` F/ x ph `  ( ~ df-nf ) in place of
       "$d ` x ph ` $." when a more general result is desired;
       ~ ax-17 can be used to derive the $d version.  For an example of
       how to get from the $d version back to the $e version, see the
       proof of ~ euf from ~ df-eu .</li>

       <li>"$d x A $." should be read "Assume x is not a variable occurring in
       class A."</li>

       <li>"$d x A $.  $d x ps $.  $e |- ` ( x = A -> ( ph <-> ps ) ) ` $."
       is an idiom
       often used instead of explicit substitution, meaning "Assume psi results
       from the proper substitution of A for x in phi."</li>

       <li>" ` |- ( -. A. x x = y -> ... ` " occurs early in some cases, and
       should be read "If x and y are distinct
       variables, then..."  This antecedent provides us with a technical
       device (called a "distinctor" in Section 7 of [Megill] p. 444)
       to avoid the need for the
       $d statement early in our development of predicate calculus, permitting
       unrestricted substitutions as conceptually simple as those in
       propositional calculus.  However, the $d eventually becomes a
       requirement, and after that this device is rarely used.</li>
       </ul></HTML>

       Here is more information about our processes for checking and
       contributing to this work:

       <HTML><ul>
       <li><b>Multiple verifiers.</b>
       This entire file is verified by multiple independently-implemented
       verifiers when it is checked in, giving us extremely high
       confidence that all proofs follow from the assumptions.
       The checkers also check for various other problems such as
       overly long lines.
       </li>

       <li><b>Rewrapped line length.</b>
       The input file routinely has its text wrapped using <tt>
       metamath 'read set.mm' 'save proof */c/f' 'write source set.mm/rewrap'
       </tt> (so please do the same).
       </li>

       <li><b>Discouraged information.</b>
       A separate file named "discouraged" lists all
       discouraged statements and uses of them, and this file is checked.
       If you change the use of discouraged things, you will need to change
       this file.
       This makes it obvious when there is a change to anything discouraged
       (triggering further review).
       </li>

       <li><b>Proposing specific changes.</b>
       Please propose specific changes as pull requests (PRs) against the
       "develop" branch of set.mm, at:
       ~ https://github.com/metamath/set.mm/tree/develop
       </li>

       <li><b>Community.</b>
       We encourage anyone interested in Metamath to join our mailing list:
       ~ https://groups.google.com/forum/#!forum/metamath .
       </li>
       </ul></HTML>


       (Contributed by DAW, 27-Dec-2016.) $)
    conventions $p |- ph $=
      (  ) B $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Natural deduction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
   $( Note:  validator.w3.org  rejects "&sacute;" so I changed it to
      "&#347;" - NM 22-Jun-2017 $)
   $( Dummy premise for "natded" $)
    natded.1 $e |- ph $.
    $(
       Here are typical natural deduction (ND) rules in the style of Gentzen
       and Ja&#347;kowski, along with MPE translations of them.
       This also shows the recommended theorems when you find yourself
       needing these rules (the recommendations encourage a slightly
       different proof style that works more naturally with metamath).
       A decent list of the standard rules of natural deduction can be
       found beginning with definition /\I in [Pfenning] p. 18.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       Many more citations could be added.

       <HTML>
       <P>
       <TABLE ALIGN=CENTER BORDER CELLSPACING=0 WIDTH="95%">
       <TR><TH>Name</TH><TH>Natural Deduction Rule</TH><TH>Translation</TH>
       <TH>Recommendation</TH><TH>Comments</TH></TR>
       <TR><TD> IT </TD>
       <TD> ` _G |- ps ` => ` _G |- ps ` </TD>
       <TD> ~ idi </TD>
       <TD> nothing </TD><TD>Reiteration is always redundant in Metamath.
       Definition "new rule" in [Pfenning] p. 18,
       definition IT in [Clemente] p. 10. </TD>
       </TR>

       <TR><TD> ` /\ `I</TD>
       <TD> ` _G |- ps ` & ` _G |- ch ` => ` _G |- ps /\ ch ` </TD>
       <TD> ~ jca </TD>
       <TD> ~ jca , ~ pm3.2i </TD>
       <TD>Definition ` /\ `I in [Pfenning] p. 18,
       definition I` /\ `m,n in [Clemente] p. 10, and
       definition ` /\ `I in [Indrzejczak] p. 34
       (representing both Gentzen's system NK and Ja&#347;kowski)</TD>
       </TR>

       <TR><TD> ` /\ `E<SUB>L</SUB></TD>
       <TD> ` _G |- ps /\ ch ` => ` _G |- ps ` </TD>
       <TD> ~ simpld </TD>
       <TD> ~ simpld , ~ adantr </TD>
       <TD>Definition ` /\ `E<SUB>L</SUB> in [Pfenning] p. 18,
       definition E` /\ `(1) in [Clemente] p. 11, and
       definition ` /\ `E in [Indrzejczak] p. 34
       (representing both Gentzen's system NK and Ja&#347;kowski)</TD>
       </TR>

       <TR><TD> ` /\ `E<SUB>R</SUB></TD>
       <TD> ` _G |- ps /\ ch ` => ` _G |- ch ` </TD>
       <TD> ~ simprd </TD>
       <TD> ~ simpr , ~ adantl </TD>
       <TD>Definition ` /\ `E<SUB>R</SUB> in [Pfenning] p. 18,
       definition E` /\ `(2) in [Clemente] p. 11, and
       definition ` /\ `E in [Indrzejczak] p. 34
       (representing both Gentzen's system NK and Ja&#347;kowski)</TD>
       </TR>

       <TR><TD> ` -> `I </TD>
       <TD> ` _G , ps |- ch ` => ` _G |- ps -> ch ` </TD>
       <TD> ~ ex </TD><TD> ~ ex </TD>
       <TD>Definition ` -> `I in [Pfenning] p. 18,
       definition I=>m,n in [Clemente] p. 11, and
       definition ` -> `I in [Indrzejczak] p. 33. </TD>
       </TR>

       <TR><TD> ` -> `E </TD>
       <TD> ` _G |- ps -> ch ` & ` _G |- ps ` => ` _G |- ch ` </TD>
       <TD> ~ mpd </TD><TD> ~ ax-mp , ~ mpd , ~ mpdan , ~ imp </TD>
       <TD>Definition ` -> `E in [Pfenning] p. 18,
       definition E=>m,n in [Clemente] p. 11, and
       definition ` -> `E in [Indrzejczak] p. 33. </TD>
       </TR>

       <TR><TD> ` \/ `I<SUB>L</SUB> </TD><TD> ` _G |- ps ` =>
       ` _G |- ps \/ ch ` </TD>
       <TD> ~ olcd </TD>
       <TD> ~ olc , ~ olci , ~ olcd </TD>
       <TD>Definition ` \/ `I in [Pfenning] p. 18,
       definition I` \/ `n(1) in [Clemente] p. 12</TD>
       </TR>

       <TR><TD> ` \/ `I<SUB>R</SUB> </TD><TD> ` _G |- ch ` =>
       ` _G |- ps \/ ch ` </TD>
       <TD> ~ orcd </TD>
       <TD> ~ orc , ~ orci , ~ orcd </TD>
       <TD>Definition ` \/ `I<SUB>R</SUB> in [Pfenning] p. 18,
       definition I` \/ `n(2) in [Clemente] p. 12. </TD>
       </TR>

       <TR><TD> ` \/ `E </TD><TD> ` _G |- ps \/ ch ` & ` _G , ps |- th ` &
       ` _G , ch |- th ` => ` _G |- th ` </TD>
       <TD> ~ mpjaodan </TD>
       <TD> ~ mpjaodan , ~ jaodan , ~ jaod </TD>
       <TD>Definition ` \/ `E in [Pfenning] p. 18,
       definition E` \/ `m,n,p in [Clemente] p. 12. </TD>
       </TR>

       <!-- This is NOT quite the same as Pfenning page 22,
       because they don't use falsum. (Instead, they use an arbitrary
       atomic propositional letter in place of F. -->
       <TR><TD> ` -. `I </TD><TD> ` _G , ps |- F. ` => ` _G |- -. ps ` </TD>
       <TD> ~ inegd </TD><TD> ~ pm2.01d </TD>
       <TD></TD>
       </TR>

       <TR><TD> ` -. `I </TD><TD> ` _G , ps |- th ` & ` _G |- -. th ` =>
       ` _G |- -. ps ` </TD>
       <TD> ~ mtand </TD><TD> ~ mtand </TD>
       <TD>definition I` -.`m,n,p in [Clemente] p. 13. </TD>
       </TR>

       <TR><TD> ` -. `I </TD><TD> ` _G , ps |- ch ` & ` _G , ps |- -. ch ` =>
       ` _G |- -. ps ` </TD>
       <TD> ~ pm2.65da </TD><TD> ~ pm2.65da </TD>
       <TD>Contradiction.</TD>
       </TR>

       <TR><TD> ` -. `I </TD>
       <TD> ` _G , ps |- -. ps ` => ` _G |- -. ps ` </TD>
       <TD> ~ pm2.01da </TD><TD> ~ pm2.01d , ~ pm2.65da , ~ pm2.65d </TD>
       <TD>For an alternative falsum-free natural deduction ruleset</TD>
       </TR>

       <TR><TD> ` -. `E </TD>
       <TD> ` _G |- ps ` & ` _G |- -. ps ` => ` _G |- F. ` </TD>
       <TD> ~ pm2.21fal </TD>
       <TD> ~ pm2.21dd </TD><TD></TD>
       </TR>

       <TR><TD> ` -. `E </TD>
       <TD> ` _G , -. ps |- F. ` => ` _G |- ps ` </TD>
       <TD> </TD>
       <TD> ~ pm2.21dd </TD>
       <TD>definition ` -> `E in [Indrzejczak] p. 33. </TD>
       </TR>

       <TR><TD> ` -. `E </TD>
       <TD> ` _G |- ps ` & ` _G |- -. ps ` => ` _G |- th ` </TD>
       <TD> ~ pm2.21dd </TD><TD> ~ pm2.21dd , ~ pm2.21d , ~ pm2.21 </TD>
       <TD>For an alternative falsum-free natural deduction ruleset.
       Definition ` -. `E in [Pfenning] p. 18. </TD>
       </TR>

       <TR><TD> ` T. `I </TD><TD> ` _G |- T. ` </TD>
       <TD> ~ a1tru </TD><TD> ~ tru , ~ a1tru , ~ trud </TD>
       <TD>Definition ` T. `I in [Pfenning] p. 18. </TD>
       </TR>

       <TR><TD> ` F. `E </TD><TD> ` _G , F. |- th ` </TD>
       <TD> ~ falimd </TD><TD> ~ falim </TD>
       <TD>Definition ` F. `E in [Pfenning] p. 18. </TD>
       </TR>

       <TR><TD> ` A. `I </TD>
       <TD> ` _G |- [ a / x ] ps ` => ` _G |- A. x ps ` </TD>
       <TD> ~ alrimiv </TD><TD> ~ alrimiv , ~ ralrimiva </TD>
       <TD>Definition ` A. `I<SUP>a</SUP> in [Pfenning] p. 18,
       definition I` A. `n in [Clemente] p. 32. </TD>
       </TR>

       <TR><TD> ` A. `E </TD>
       <TD> ` _G |- A. x ps ` => ` _G |- [ t / x ] ps ` </TD>
       <TD> ~ spsbcd </TD><TD> ~ spcv , ~ rspcv </TD>
       <TD>Definition ` A. `E in [Pfenning] p. 18,
       definition E` A. `n,t in [Clemente] p. 32. </TD>
       </TR>

       <TR><TD> ` E. `I </TD>
       <TD> ` _G |- [ t / x ] ps ` => ` _G |- E. x ps ` </TD>
       <TD> ~ spesbcd </TD><TD> ~ spcev , ~ rspcev </TD>
       <TD>Definition ` E. `I in [Pfenning] p. 18,
       definition I` E. `n,t in [Clemente] p. 32. </TD>
       </TR>

       <TR><TD> ` E. `E </TD>
       <TD> ` _G |- E. x ps ` & ` _G , [ a / x ] ps |- th ` =>
       ` _G |- th ` </TD>
       <TD> ~ exlimddv </TD><TD> ~ exlimddv , ~ exlimdd ,
       ~ exlimdv , ~ rexlimdva </TD>
       <TD>Definition ` E. `E<SUP>a,u</SUP> in [Pfenning] p. 18,
       definition E` E. `m,n,p,a in [Clemente] p. 32. </TD>
       </TR>

       <TR><TD> ` F. `C </TD>
       <TD> ` _G , -. ps |- F. ` => ` _G |- ps ` </TD>
       <TD> ~ efald </TD><TD> ~ efald </TD>
       <TD>Proof by contradiction (classical logic),
       definition ` F. `C in [Pfenning] p. 17. </TD>
       </TR>

       <TR><TD> ` F. `C </TD>
       <TD> ` _G , -. ps |- ps ` => ` _G |- ps ` </TD>
       <TD> ~ pm2.18da </TD><TD> ~ pm2.18da , ~ pm2.18d , ~ pm2.18 </TD>
       <TD>For an alternative falsum-free natural deduction ruleset</TD>
       </TR>

       <TR><TD> ` -. -. `C </TD>
       <TD> ` _G |- -. -. ps ` => ` _G |- ps ` </TD>
       <TD> ~ notnotrd </TD><TD> ~ notnotrd , ~ notnot2 </TD>
       <TD>Double negation rule (classical logic),
       definition NNC in [Pfenning] p. 17,
       definition E` -.`n in [Clemente] p. 14. </TD>
       </TR>

       <TR><TD> EM </TD><TD> ` _G |- ps \/ -. ps ` </TD>
       <TD> ~ exmidd </TD><TD> ~ exmid </TD>
       <TD>Excluded middle (classical logic),
       definition XM in [Pfenning] p. 17,
       proof 5.11 in [Clemente] p. 14. </TD>
       </TR>

       <TR><TD> ` = `I </TD><TD> ` _G |- A = A ` </TD>
       <TD> ~ eqidd </TD><TD> ~ eqid , ~ eqidd </TD>
       <TD>Introduce equality,
       definition =I in [Pfenning] p. 127. </TD>
       </TR>

       <!-- In metamath, no need to introduce E1 and E2 separately. -->
       <TR><TD> ` = `E </TD><TD> ` _G |- A = B ` & ` _G [. A / x ]. ps ` =>
       ` _G |- [. B / x ]. ps ` </TD>
       <TD> ~ sbceq1dd </TD><TD> ~ sbceq1d , equality theorems </TD>
       <TD>Eliminate equality,
       definition =E in [Pfenning] p. 127. (Both E1 and E2.) </TD>
       </TR>

       </TABLE>
       </HTML>

       <P>
       Note that MPE uses classical logic, not intuitionist logic.
       As is conventional, the "I" rules are introduction rules,
       "E" rules are elimination rules, the "C" rules are conversion rules,
       and ` _G ` represents the set of (current) hypotheses.
       We use wff variable names beginning with ` ps ` to provide a closer
       representation of the Metamath equivalents
       (which typically use the antedent ` ph ` to represent
       the context ` _G ` ).

       Most of this information was developed by
       Mario Carneiro and posted on 3-Feb-2017.
       For more information, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.

       For annotated examples where some traditional ND rules
       are directly applied in MPE, see ~ ex-natded5.2 , ~ ex-natded5.3 ,
       ~ ex-natded5.5 , ~ ex-natded5.7 , ~ ex-natded5.8 , ~ ex-natded5.13 ,
       ~ ex-natded9.20 , and ~ ex-natded9.26 .

       (Contributed by DAW, 4-Feb-2017.) $)
    natded $p |- ph $=
      (  ) B $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Natural deduction examples
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  These are examples of how natural deduction rules can be applied
  in metamath (both as line-for-line translations of ND rules, and as
  a way to apply deduction forms without being limited to applying
  ND rules).  For more information, see ~ natded and
  ~ http://us.metamath.org/mpeuni/mmnatded.html .

$)

  ${
    ex-natded5.2.1 $e |- ( ph -> ( ( ps /\ ch ) -> th ) ) $.
    ex-natded5.2.2 $e |- ( ph -> ( ch -> ps ) ) $.
    ex-natded5.2.3 $e |- ( ph -> ch ) $.
    $( Theorem 5.2 of [Clemente] p. 15, translated line by line using the
       interpretation of natural deduction in Metamath.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       The original proof, which uses Fitch style, was written as follows:

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>5</TD><TD NOWRAP> ` ( ( ps /\ ch ) -> th ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ( ps /\ ch ) -> th ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e. </TD></TR>
       <TR><TD>2</TD><TD>2</TD><TD NOWRAP> ` ( ch -> ps ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ch -> ps ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e. </TD></TR>
       <TR><TD>3</TD><TD>1</TD><TD> ` ch ` </TD>
       <TD> ` ( ph -> ch ) ` </TD>
       <TD>Given</TD>
       <TD>$e. </TD></TR>
       <TR><TD>4</TD><TD>3</TD><TD> ` ps ` </TD>
       <TD> ` ( ph -> ps ) ` </TD>
       <TD> ` -> `E 2,3</TD>
       <TD> ~ mpd , the MPE equivalent of ` -> `E, 1,2</TD></TR>
       <TR><TD>5</TD><TD>4</TD><TD> ` ( ps /\ ch ) ` </TD>
       <TD> ` ( ph -> ( ps /\ ch ) ) ` </TD>
       <TD> ` /\ `I 4,3</TD>
       <TD> ~ jca , the MPE equivalent of ` /\ `I, 3,1</TD></TR>
       </TR>
       <TR><TD>6</TD><TD>6</TD><TD> ` th ` </TD>
       <TD> ` ( ph -> th ) ` </TD>
       <TD> ` -> `E 1,5</TD>
       <TD> ~ mpd , the MPE equivalent of ` -> `E, 4,5</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters for predicates;
       we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       Below is the final metamath proof (which reorders some steps).
       A much more efficient proof, using more of Metamath and MPE's
       capabilities, is shown in ~ ex-natded5.2-2 .
       A proof without context is shown in ~ ex-natded5.2i .
       (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.2 $p |- ( ph -> th ) $=
      ( wa mpd jca ) ABCHDABCACBGFIGJEI $.

    $( A more efficient proof of Theorem 5.2 of [Clemente] p. 15.  Compare with
       ~ ex-natded5.2 and ~ ex-natded5.2i .
       (Proof modification is discouraged.)  (Contributed by Mario Carneiro,
       9-Feb-2017.) $)
    ex-natded5.2-2 $p |- ( ph -> th ) $=
      ( mpd mp2and ) ABCDACBGFHGEI $.
  $}

  ${
    ex-natded5.2i.1 $e |- ( ( ps /\ ch ) -> th ) $.
    ex-natded5.2i.2 $e |- ( ch -> ps ) $.
    ex-natded5.2i.3 $e |- ch $.
    $( The same as ~ ex-natded5.2 and ~ ex-natded5.2-2 but with no context.
       (Proof modification is discouraged.)  (Contributed by Mario Carneiro,
       9-Feb-2017.) $)
    ex-natded5.2i $p |- th $=
      ( wa ax-mp pm3.2i ) ABGCABBAFEHFIDH $.
  $}

  ${
    ex-natded5.3.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ex-natded5.3.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( Theorem 5.3 of [Clemente] p. 16, translated line by line using an
       interpretation of natural deduction in Metamath.
       A much more efficient proof, using more of Metamath and MPE's
       capabilities, is shown in ~ ex-natded5.3-2 .
       A proof without context is shown in ~ ex-natded5.3i .
       For information about ND and Metamath, see the <HTML>
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A></HTML>.
       The original proof, which uses Fitch style, was written as follows:

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>2;3</TD><TD NOWRAP> ` ( ps -> ch ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps -> ch ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e; ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>2</TD><TD>5;6</TD><TD NOWRAP> ` ( ch -> th ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ch -> th ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e; ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>3</TD><TD>1</TD><TD> ...| ` ps ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ps ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD> ~ simpr , to access the new assumption </TD></TR>
       <TR><TD>4</TD><TD>4</TD><TD> ... ` ch ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ch ) ` </TD>
       <TD> ` -> `E 1,3</TD>
       <TD> ~ mpd , the MPE equivalent of ` -> `E, 1.3.
       ~ adantr was used to transform its dependency
       (we could also use ~ imp to get this directly from 1)
       </TD></TR>
       <TR><TD>5</TD><TD>7</TD><TD> ... ` th ` </TD>
       <TD> ` ( ( ph /\ ps ) -> th ) ` </TD>
       <TD> ` -> `E 2,4</TD>
       <TD> ~ mpd , the MPE equivalent of ` -> `E, 4,6.
       ~ adantr was used to transform its dependency</TD></TR>
       <TR><TD>6</TD><TD>8</TD><TD> ... ` ( ch /\ th ) ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ( ch /\ th ) ) ` </TD>
       <TD> ` /\ `I 4,5</TD>
       <TD> ~ jca , the MPE equivalent of ` /\ `I, 4,7</TD></TR>
       <TR><TD>7</TD><TD>9</TD><TD NOWRAP> ` ( ps -> ( ch /\ th ) ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps -> ( ch /\ th ) ) ) ` </TD>
       <TD> ` -> `I 3,6</TD>
       <TD> ~ ex , the MPE equivalent of ` -> `I, 8</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters for predicates;
       we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.3 $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      ( wa simpr wi adantr mpd jca ex ) ABCDGABGZCDNBCABHABCIBEJKZNCDOACDIBFJKL
      M $.

    $( A more efficient proof of Theorem 5.3 of [Clemente] p. 16.  Compare with
       ~ ex-natded5.3 and ~ ex-natded5.3i .
       (Proof modification is discouraged.)  (Contributed by Mario Carneiro,
       9-Feb-2017.) $)
    ex-natded5.3-2 $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      ( syld jcad ) ABCDEABCDEFGH $.
  $}

  ${
    ex-natded5.3i.1 $e |- ( ps -> ch ) $.
    ex-natded5.3i.2 $e |- ( ch -> th ) $.
    $( The same as ~ ex-natded5.3 and ~ ex-natded5.3-2 but with no context.
       (Proof modification is discouraged.)  (Contributed by Mario Carneiro,
       9-Feb-2017.) $)
    ex-natded5.3i $p |- ( ps -> ( ch /\ th ) ) $=
      ( syl jca ) ABCDABCDEFG $.
  $}

  ${
    ex-natded5.5.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ex-natded5.5.2 $e |- ( ph -> -. ch ) $.
    $( Theorem 5.5 of [Clemente] p. 18, translated line by line using the
       usual translation of natural deduction (ND) in the
       Metamath Proof Explorer (MPE) notation.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       The original proof, which uses Fitch style, was written as follows
       (the leading "..." shows an embedded ND hypothesis, beginning with
       the initial assumption of the ND hypothesis):

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>2;3</TD>
       <TD NOWRAP> ` ( ps -> ch ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps -> ch ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e; ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>2</TD><TD>5</TD><TD NOWRAP> ` -. ch ` </TD>
       <TD NOWRAP> ` ( ph -> -. ch ) ` </TD><TD>Given</TD>
       <TD>$e; we'll use ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>3</TD><TD>1</TD>
       <TD> ...| ` ps ` </TD><TD> ` ( ph -> ps ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>4</TD><TD>4</TD><TD> ... ` ch ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ch ) ` </TD>
       <TD> ` -> `E 1,3</TD>
       <TD> ~ mpd 1,3</TD></TR>
       <TR><TD>5</TD><TD>6</TD><TD> ... ` -. ch ` </TD>
       <TD> ` ( ( ph /\ ps ) -> -. ch ) ` </TD>
       <TD>IT 2</TD>
       <TD> ~ adantr 5</TD></TR>
       <TR><TD>6</TD><TD>7</TD><TD> ` -. ps ` </TD>
       <TD> ` ( ph -> -. ps ) ` </TD>
       <TD> ` /\ `I 3,4,5</TD>
       <TD> ~ pm2.65da 4,6</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters; we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       To add an assumption, the antecedent is modified to include it
       (typically by using ~ adantr ; ~ simpr is useful when you want to
       depend directly on the new assumption).
       Below is the final metamath proof (which reorders some steps).

       A much more efficient proof is ~ mtod ;
       a proof without context is shown in ~ mto .

       (Proof modification is discouraged.)
       (Contributed by David A. Wheeler, 19-Feb-2017.) $)
    ex-natded5.5 $p |- ( ph -> -. ps )
      $=
      ( wa simpr wi adantr mpd wn pm2.65da ) ABCABFBCABGABCHBDIJACKBEIL $.
  $}

  ${
    ex-natded5.7.1 $e |- ( ph -> ( ps \/ ( ch /\ th ) ) ) $.
    $( Theorem 5.7 of [Clemente] p. 19, translated line by line using the
       interpretation of natural deduction in Metamath.
       A much more efficient proof, using more of Metamath and MPE's
       capabilities, is shown in ~ ex-natded5.7-2 .
       For information about ND and Metamath, see the <HTML>
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A></HTML>.
       The original proof, which uses Fitch style, was written as follows:

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>6</TD>
       <TD NOWRAP> ` ( ps \/ ( ch /\ th ) ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps \/ ( ch /\ th ) ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e. No need for ~ adantr because we do not move this
       into an ND hypothesis</TD></TR>
       <TR><TD>2</TD><TD>1</TD><TD NOWRAP> ...| ` ps ` </TD>
       <TD NOWRAP> ` ( ( ph /\ ps ) -> ps ) ` </TD>
       <TD>ND hypothesis assumption (new scope)</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>3</TD><TD>2</TD><TD> ... ` ( ps \/ ch ) ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ( ps \/ ch ) ) ` </TD>
       <TD> ` \/ `I<SUB>L</SUB> 2</TD>
       <TD> ~ orcd , the MPE equivalent of ` \/ `I<SUB>L</SUB>, 1</TD></TR>
       <TR><TD>4</TD><TD>3</TD><TD> ...| ` ( ch /\ th ) ` </TD>
       <TD> ` ( ( ph /\ ( ch /\ th ) ) -> ( ch /\ th ) ) ` </TD>
       <TD>ND hypothesis assumption (new scope)</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>5</TD><TD>4</TD><TD> ... ` ch ` </TD>
       <TD> ` ( ( ph /\ ( ch /\ th ) ) -> ch ) `  </TD>
       <TD> ` /\ `E<SUB>L</SUB> 4</TD>
       <TD> ~ simpld , the MPE equivalent of ` /\ `E<SUB>L</SUB>, 3</TD></TR>
       <TR><TD>6</TD><TD>6</TD><TD> ... ` ( ps \/ ch ) ` </TD>
       <TD> ` ( ( ph /\ ( ch /\ th ) ) -> ( ps \/ ch ) ) `  </TD>
       <TD> ` \/ `I<SUB>R</SUB> 5</TD>
       <TD> ~ olcd , the MPE equivalent of ` \/ `I<SUB>R</SUB>, 4</TD></TR>
       <TR><TD>7</TD><TD>7</TD><TD NOWRAP> ` ( ps \/ ch ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps \/ ch ) ) ` </TD>
       <TD> ` \/ `E 1,3,6</TD>
       <TD> ~ mpjaodan , the MPE equivalent of ` \/ `E, 2,5,6 </TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters for predicates;
       we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.7 $p |- ( ph -> ( ps \/ ch ) ) $=
      ( wo wa simpr orcd simpld olcd mpjaodan ) ABBCFCDGZABGBCABHIAMGZCBNCDAMHJ
      KEL $.

    $( A more efficient proof of Theorem 5.7 of [Clemente] p. 19.  Compare with
       ~ ex-natded5.7 .  (Proof modification is discouraged.)  (Contributed by
       Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.7-2 $p |- ( ph -> ( ps \/ ch ) ) $=
      ( wa wo simpl orim2i syl ) ABCDFZGBCGEKCBCDHIJ $.
  $}

  ${
    ex-natded5.8.1 $e |- ( ph -> ( ( ps /\ ch ) -> -. th ) ) $.
    ex-natded5.8.2 $e |- ( ph -> ( ta -> th ) ) $.
    ex-natded5.8.3 $e |- ( ph -> ch ) $.
    ex-natded5.8.4 $e |- ( ph -> ta ) $.
    $( Theorem 5.8 of [Clemente] p. 20, translated line by line using the
       usual translation of natural deduction (ND) in the
       Metamath Proof Explorer (MPE) notation.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       The original proof, which uses Fitch style, was written as follows
       (the leading "..." shows an embedded ND hypothesis, beginning with
       the initial assumption of the ND hypothesis):

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>10;11</TD>
       <TD NOWRAP> ` ( ( ps /\ ch ) -> -. th ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ( ps /\ ch ) -> -. th ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e; ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>2</TD><TD>3;4</TD><TD NOWRAP> ` ( ta -> th ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ta -> th ) ) ` </TD><TD>Given</TD>
       <TD>$e; ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>3</TD><TD>7;8</TD>
       <TD> ` ch ` </TD><TD> ` ( ph -> ch ) ` </TD>
       <TD>Given</TD>
       <TD>$e; ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>4</TD><TD>1;2</TD><TD> ` ta ` </TD><TD> ` ( ph -> ta ) ` </TD>
       <TD>Given</TD>
       <TD>$e. ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>5</TD><TD>6</TD><TD> ...| ` ps ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ps ) ` </TD>
       <TD>ND Hypothesis/Assumption</TD>
       <TD> ~ simpr . New ND hypothesis scope, each reference outside
       the scope must change antedent ` ph ` to ` ( ph /\ ps )`.</TD></TR>
       <TR><TD>6</TD><TD>9</TD><TD> ... ` ( ps /\ ch ) ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ( ps /\ ch ) ) ` </TD>
       <TD> ` /\ `I 5,3</TD>
       <TD> ~ jca ( ` /\ `I), 6,8 ( ~ adantr to bring in scope)</TD></TR>
       <TR><TD>7</TD><TD>5</TD><TD> ... ` -. th ` </TD>
       <TD> ` ( ( ph /\ ps ) -> -. th ) ` </TD>
       <TD> ` -> `E 1,6</TD>
       <TD> ~ mpd ( ` -> `E), 2,4</TD></TR>
       <TR><TD>8</TD><TD>12</TD><TD> ... ` th ` </TD>
       <TD> ` ( ( ph /\ ps ) -> th ) ` </TD>
       <TD> ` -> `E 2,4</TD>
       <TD> ~ mpd ( ` -> `E), 9,11;
       note the contradiction with ND line 7 (MPE line 5)</TD></TR>
       <TR><TD>9</TD><TD>13</TD><TD> ` -. ps ` </TD>
       <TD> ` ( ph -> -. ps ) ` </TD>
       <TD> ` -. `I 5,7,8</TD>
       <TD> ~ pm2.65da ( ` -. `I), 5,12; proof by contradiction.
       MPE step 6 (ND#5) does not need a reference here, because
       the assumption is embedded in the antecedents</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters; we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       To add an assumption, the antecedent is modified to include it
       (typically by using ~ adantr ; ~ simpr is useful when you want to
       depend directly on the new assumption).
       Below is the final metamath proof (which reorders some steps).

       A much more efficient proof, using more of Metamath and MPE's
       capabilities, is shown in ~ ex-natded5.8-2 .

       (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.8 $p |- ( ph -> -. ps ) $=
      ( wa adantr wi mpd wn simpr jca pm2.65da ) ABDABJZEDAEBIKAEDLBGKMRBCJZDNZ
      RBCABOACBHKPASTLBFKMQ $.

    $( A more efficient proof of Theorem 5.8 of [Clemente] p. 20.  For a longer
       line-by-line translation, see ~ ex-natded5.8 .
       (Proof modification is discouraged.)  (Contributed by Mario Carneiro,
       9-Feb-2017.) $)
    ex-natded5.8-2 $p |- ( ph -> -. ps ) $=
      ( mpd wn mpan2d mt2d ) ABDAEDIGJABCDKHFLM $.
  $}

  ${
    ex-natded5.13.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    ex-natded5.13.2 $e |- ( ph -> ( ps -> th ) ) $.
    ex-natded5.13.3 $e |- ( ph -> ( -. ta -> -. ch ) ) $.
    $( Theorem 5.13 of [Clemente] p. 20, translated line by line using the
       interpretation of natural deduction in Metamath.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       A much more efficient proof, using more of Metamath and MPE's
       capabilities, is shown in ~ ex-natded5.13-2 .
       The original proof, which uses Fitch style, was written as follows
       (the leading "..." shows an embedded ND hypothesis, beginning with
       the initial assumption of the ND hypothesis):

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>15</TD><TD NOWRAP> ` ( ps \/ ch ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps \/ ch ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e. </TD></TR>
       <TR><TD>2;3</TD><TD>2</TD><TD NOWRAP> ` ( ps -> th ) ` </TD>
       <TD NOWRAP> ` ( ph -> ( ps -> th ) ) ` </TD><TD>Given</TD>
       <TD>$e. ~ adantr to move it into the ND hypothesis</TD></TR>
       <TR><TD>3</TD><TD>9</TD><TD> ` ( -. ta -> -. ch ) ` </TD>
       <TD> ` ( ph -> ( -. ta -> -. ch ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e. ~ ad2antrr to move it into the ND sub-hypothesis</TD></TR>
       <TR><TD>4</TD><TD>1</TD><TD> ...| ` ps ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ps ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>5</TD><TD>4</TD><TD> ... ` th ` </TD>
       <TD> ` ( ( ph /\ ps ) -> th ) ` </TD>
       <TD> ` -> `E 2,4</TD>
       <TD> ~ mpd 1,3</TD></TR>
       <TR><TD>6</TD><TD>5</TD><TD> ... ` ( th \/ ta ) ` </TD>
       <TD> ` ( ( ph /\ ps ) -> ( th \/ ta ) ) ` </TD>
       <TD> ` \/ `I 5</TD>
       <TD> ~ orcd 4</TD></TR>
       <TR><TD>7</TD><TD>6</TD><TD> ...| ` ch ` </TD>
       <TD> ` ( ( ph /\ ch ) -> ch ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>8</TD><TD>8</TD><TD> ... ...| ` -. ta ` </TD>
       <TD> ` ( ( ( ph /\ ch ) /\ -. ta ) -> -. ta ) ` </TD>
       <TD>(sub) ND hypothesis assumption</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>9</TD><TD>11</TD><TD> ... ... ` -. ch ` </TD>
       <TD> ` ( ( ( ph /\ ch ) /\ -. ta ) -> -. ch ) ` </TD>
       <TD> ` -> `E 3,8</TD>
       <TD> ~ mpd 8,10</TD></TR>
       <TR><TD>10</TD><TD>7</TD><TD> ... ... ` ch ` </TD>
       <TD> ` ( ( ( ph /\ ch ) /\ -. ta ) -> ch ) ` </TD>
       <TD> IT 7</TD>
       <TD> ~ adantr 6</TD></TR>
       <TR><TD>11</TD><TD>12</TD><TD> ... ` -. -. ta ` </TD>
       <TD> ` ( ( ph /\ ch ) -> -. -. ta ) ` </TD>
       <TD> ` -. `I 8,9,10</TD>
       <TD> ~ pm2.65da 7,11</TD></TR>
       <TR><TD>12</TD><TD>13</TD><TD> ... ` ta ` </TD>
       <TD> ` ( ( ph /\ ch ) -> ta ) ` </TD>
       <TD> ` -. `E 11</TD>
       <TD> ~ notnotrd 12</TD></TR>
       <TR><TD>13</TD><TD>14</TD><TD> ... ` ( th \/ ta ) ` </TD>
       <TD> ` ( ( ph /\ ch ) -> ( th \/ ta ) ) ` </TD>
       <TD> ` \/ `I 12</TD>
       <TD> ~ olcd 13</TD></TR>
       <TR><TD>14</TD><TD>16</TD><TD> ` ( th \/ ta ) ` </TD>
       <TD> ` ( ph -> ( th \/ ta ) ) ` </TD>
       <TD> ` \/ `E 1,6,13</TD>
       <TD> ~ mpjaodan 5,14,15</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters; we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       To add an assumption, the antecedent is modified to include it
       (typically by using ~ adantr ; ~ simpr is useful when you want to
       depend directly on the new assumption).
       (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.13 $p |- ( ph -> ( th \/ ta ) ) $=
      ( wo wa simpr wi adantr mpd orcd wn ad2antrr pm2.65da notnotrd olcd
      mpjaodan ) ABDEICABJZDEUBBDABKABDLBGMNOACJZEDUCEUCEPZCUCCUDACKMUCUDJUDCPZ
      UCUDKAUDUELCUDHQNRSTFUA $.

    $( A more efficient proof of Theorem 5.13 of [Clemente] p. 20.  Compare
       with ~ ex-natded5.13 .  (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded5.13-2 $p |- ( ph -> ( th \/ ta ) ) $=
      ( wo con4d orim12d mpd ) ABCIDEIFABDCEGAECHJKL $.
  $}

  ${
    ex-natded9.20.1 $e |- ( ph -> ( ps /\ ( ch \/ th ) ) ) $.
    $( Theorem 9.20 of [Clemente] p. 43, translated line by line using the
       usual translation of natural deduction (ND) in the
       Metamath Proof Explorer (MPE) notation.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       The original proof, which uses Fitch style, was written as follows
       (the leading "..." shows an embedded ND hypothesis, beginning with
       the initial assumption of the ND hypothesis):

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>1</TD>
       <TD NOWRAP> ` ( ps /\ ( ch \/ th ) ) ` </TD>
       <TD NOWRAP> ` ( ph ->  ( ps /\ ( ch \/ th ) ) ) ` </TD>
       <TD>Given</TD>
       <TD>$e</TD></TR>
       <TR><TD>2</TD><TD>2</TD><TD NOWRAP> ` ps ` </TD>
       <TD NOWRAP> ` ( ph -> ps ) ` </TD>
       <TD>` /\ `E<SUB>L</SUB> 1</TD>
       <TD> ~ simpld 1</TD></TR>
       <TR><TD>3</TD><TD>11</TD>
       <TD> ` ( ch \/ th ) ` </TD>
       <TD> ` ( ph -> ( ch \/ th ) ) ` </TD>
       <TD> ` /\ `E<SUB>R</SUB> 1</TD>
       <TD>  ~ simprd 1</TD></TR>
       <TR><TD>4</TD><TD>4</TD>
       <TD> ...| ` ch ` </TD>
       <TD> ` ( ( ph /\ ch ) -> ch ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>5</TD><TD>5</TD>
       <TD> ... ` ( ps /\ ch ) ` </TD>
       <TD> ` ( ( ph /\ ch ) -> ( ps /\ ch ) ) ` </TD>
       <TD> ` /\ `I 2,4</TD>
       <TD> ~ jca 3,4</TD></TR>
       <TR><TD>6</TD><TD>6</TD>
       <TD> ... ` ( ( ps /\ ch ) \/ ( ps /\ th ) ) ` </TD>
       <TD> ` ( ( ph /\ ch ) -> ( ( ps /\ ch ) \/ ( ps /\ th ) ) ) ` </TD>
       <TD> ` \/ `I<SUB>R</SUB> 5</TD>
       <TD> ~ orcd 5</TD></TR>
       <TR><TD>7</TD><TD>8</TD>
       <TD> ...| ` th ` </TD>
       <TD> ` ( ( ph /\ th ) -> th ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD> ~ simpr </TD></TR>
       <TR><TD>8</TD><TD>9</TD>
       <TD> ... ` ( ps /\ th ) ` </TD>
       <TD> ` ( ( ph /\ th ) -> ( ps /\ th ) ) ` </TD>
       <TD> ` /\ `I 2,7</TD>
       <TD> ~ jca 7,8</TD></TR>
       <TR><TD>9</TD><TD>10</TD>
       <TD> ... ` ( ( ps /\ ch ) \/ ( ps /\ th ) ) ` </TD>
       <TD> ` ( ( ph /\ th ) -> ( ( ps /\ ch ) \/ ( ps /\ th ) ) ) ` </TD>
       <TD> ` \/ `I<SUB>L</SUB> 8</TD>
       <TD> ~ olcd 9</TD></TR>
       <TR><TD>10</TD><TD>12</TD>
       <TD> ` ( ( ps /\ ch ) \/ ( ps /\ th ) ) ` </TD>
       <TD> ` ( ph -> ( ( ps /\ ch ) \/ ( ps /\ th ) ) ) ` </TD>
       <TD> ` \/ `E 3,6,9</TD>
       <TD> ~ mpjaodan 6,10,11</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters; we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       To add an assumption, the antecedent is modified to include it
       (typically by using ~ adantr ; ~ simpr is useful when you want to
       depend directly on the new assumption).
       Below is the final metamath proof (which reorders some steps).

       A much more efficient proof is ~ ex-natded9.20-2 .
       (Proof modification is discouraged.)
       (Contributed by David A. Wheeler, 19-Feb-2017.) $)
    ex-natded9.20 $p |- ( ph -> ( ( ps /\ ch ) \/ ( ps /\ th ) ) )
      $=
      ( wa wo simpld adantr simpr jca orcd olcd simprd mpjaodan ) ACBCFZBDFZGDA
      CFZPQRBCABCABCDGZEHZIACJKLADFZQPUABDABDTIADJKMABSENO $.

    $( A more efficient proof of Theorem 9.20 of [Clemente] p. 45.  Compare
       with ~ ex-natded9.20 .  (Proof modification is discouraged.)
       (Contributed by David A. Wheeler, 19-Feb-2017.) $)
    ex-natded9.20-2 $p |- ( ph -> ( ( ps /\ ch ) \/ ( ps /\ th ) ) )
      $=
      ( wa wo simpld anim1i orcd olcd simprd mpjaodan ) ACBCFZBDFZGDACFNOABCABC
      DGZEHZIJADFONABDQIKABPELM $.
  $}

  ${
    $d x y ph $.
    ex-natded9.26.1 $e |- ( ph -> E. x A. y ps ) $.
    $( Theorem 9.26 of [Clemente] p. 45, translated line by line using an
       interpretation of natural deduction in Metamath.  This proof has some
       additional complications due to the fact that Metamath's existential
       elimination rule does not change bound variables, so we need to verify
       that ` x ` is bound in the conclusion.
       For information about ND and Metamath, see the
       <A HREF="mmnatded.html">page on Deduction Form and Natural Deduction
       in Metamath Proof Explorer</A>.
       The original proof, which uses Fitch style, was written as follows
       (the leading "..." shows an embedded ND hypothesis, beginning with
       the initial assumption of the ND hypothesis):

       <HTML>
       <TABLE BORDER>
       <TR><TH NOWRAP>#</TH><TH>MPE#</TH><TH>ND Expression</TH>
       <TH NOWRAP>MPE Translation</TH><TH>ND Rationale</TH>
       <TH>MPE Rationale</TH></TR>
       <TR><TD>1</TD><TD>3</TD><TD NOWRAP> ` E. x A. y ps ( x , y ) ` </TD>
       <TD NOWRAP> ` ( ph -> E. x A. y ps ) ` </TD>
       <TD>Given</TD>
       <TD>$e. </TD></TR>
       <TR><TD>2</TD><TD>6</TD><TD NOWRAP> ...| ` A. y ps ( x , y ) ` </TD>
       <TD NOWRAP> ` ( ( ph /\ A. y ps ) -> A. y ps ) ` </TD>
       <TD>ND hypothesis assumption</TD>
       <TD>~ simpr . Later statements will have this scope.</TD></TR>
       <TR><TD>3</TD><TD>7;5,4</TD><TD> ... ` ps ( x , y ) ` </TD>
       <TD> ` ( ( ph /\ A. y ps ) -> ps ) ` </TD>
       <TD> ` A. `E 2,y </TD>
       <TD> ~ spsbcd (` A. `E), 5,6. To use it we need ~ a1i and ~ vex .
       This could be immediately done with ~ 19.21bi , but we want to show
       the general approach for substitution.
       </TD></TR>
       <TR><TD>4</TD><TD>12;8,9,10,11</TD><TD> ... ` E. x ps ( x , y ) ` </TD>
       <TD> ` ( ( ph /\ A. y ps ) -> E. x ps ) ` </TD>
       <TD> ` E. `I 3,a</TD>
       <TD> ~ spesbcd (` E. `I), 11.
       To use it we need ~ sylibr , which in turn requires ~ sylib and
       two uses of ~ sbcid .
       This could be more immediately done using ~ 19.8a , but we want to show
       the general approach for substitution.
       </TD></TR>
       <TR><TD>5</TD><TD>13;1,2</TD><TD> ` E. x ps ( x , y ) ` </TD>
       <TD> ` ( ph -> E. x ps ) ` </TD><TD> ` E. `E 1,2,4,a</TD>
       <TD> ~ exlimdd (` E. `E), 1,2,3,12.
       We'll need supporting
       assertions that the variable is free (not bound),
       as provided in ~ nfv and ~ nfe1 (MPE# 1,2)</TD></TR>
       </TR>
       <TR><TD>6</TD><TD>14</TD><TD> ` A. y E. x ps ( x , y ) ` </TD>
       <TD> ` ( ph -> A. y E. x ps ) ` </TD>
       <TD> ` A. `I 5</TD>
       <TD> ~ alrimiv (` A. `I), 13</TD></TR>
       </TABLE>
       </HTML>

       The original used Latin letters for predicates;
       we have replaced them with
       Greek letters to follow Metamath naming conventions and so that
       it is easier to follow the Metamath translation.
       The Metamath line-for-line translation of this
       natural deduction approach precedes every line with an antecedent
       including ` ph ` and uses the Metamath equivalents
       of the natural deduction rules.
       Below is the final metamath proof (which reorders some steps).

       Note that in the original proof, ` ps ( x , y ) ` has explicit
       parameters.  In Metamath, these parameters are always implicit, and the
       parameters upon which a wff variable can depend are recorded in the
       "allowed substitution hints" below.

       A much more efficient proof, using more of Metamath and MPE's
       capabilities, is shown in ~ ex-natded9.26-2 .

       (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.)
       (Revised by David A. Wheeler, 18-Feb-2017.) $)
    ex-natded9.26 $p |- ( ph -> A. y E. x ps ) $=
      ( wex wal nfv nfe1 wa cv wsbc cvv wcel vex a1i simpr spsbcd sbcid sylib
      sylibr spesbcd exlimdd alrimiv ) ABCFZDABDGZUECACHBCIEAUFJZBCCKZUGBBCUHLU
      GBDDKZLBUGBDUIMUIMNUGDOPAUFQRBDSTBCSUAUBUCUD $.

    $( A more efficient proof of Theorem 9.26 of [Clemente] p. 45.  Compare
       with ~ ex-natded9.26 .  (Proof modification is discouraged.)
       (Contributed by Mario Carneiro, 9-Feb-2017.) $)
    ex-natded9.26-2 $p |- ( ph -> A. y E. x ps ) $=
      ( wex wal sp eximi syl alrimiv ) ABCFZDABDGZCFLEMBCBDHIJK $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Definitional examples
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Example for ~ df-or .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 9-May-2015.) $)
  ex-or $p |- ( 2 = 3 \/ 4 = 4 ) $=
    ( c4 wceq c2 c3 eqid olci ) AABCDBAEF $.

  $( Example for ~ df-an .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 9-May-2015.) $)
  ex-an $p |- ( 2 = 2 /\ 3 = 3 ) $=
    ( c2 wceq c3 eqid pm3.2i ) AABCCBADCDE $.

  $( Example for ~ df-dif .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 6-May-2015.) $)
  ex-dif $p |- ( { 1 , 3 } \ { 1 , 8 } ) = { 3 } $=
    ( c1 c3 cpr c8 cdif csn cun df-pr difeq1i difundir c0 wss wceq snsspr1 mpbi
    ssdif0 cin incom wcel 3eqtri 1re 1lt3 gtneii 3re ltneii nelpri disjsn mpbir
    wn 3lt8 eqtri disj3 eqcomi uneq12i uncom un0 ) ABCZADCZEAFZBFZGZUREUSUREZUT
    UREZGZUTUQVAURABHIUSUTURJVDKUTGUTKGUTVBKVCUTUSURLVBKMADNUSURPOUTVCUTURQZKMU
    TVCMVEURUTQZKUTURRVFKMBURSUIBADABUAUBUCBDUDUJUEUFURBUGUHUKUTURULOUMUNKUTUOU
    TUPTT $.

  $( Example for ~ df-un .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 6-May-2015.) $)
  ex-un $p |- ( { 1 , 3 } u. { 1 , 8 } ) = { 1 , 3 , 8 } $=
    ( c1 c3 cpr csn c8 cun ctp unass wss wceq snsspr1 ssequn2 mpbi uneq1i df-pr
    eqtr3i uneq2i df-tp 3eqtr4i ) ABCZADZEDZFZFZTUBFZTAECZFABEGTUAFZUBFUDUETUAU
    BHUGTUBUATIUGTJABKUATLMNPUFUCTAEOQABERS $.

  $( Example for ~ df-in .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 6-May-2015.) $)
  ex-in $p |- ( { 1 , 3 } i^i { 1 , 8 } ) = { 1 } $=
    ( c1 c3 cpr c8 cin csn cun df-pr ineq2i indi c0 wss wceq snsspr1 dfss1 mpbi
    wcel wn gtneii eqtri 1re 1lt8 3re 3lt8 nelpri disjsn mpbir uneq12i un0 ) AB
    CZADCZEUJAFZDFZGZEZULUKUNUJADHIUOUJULEZUJUMEZGZULUJULUMJURULKGULUPULUQKULUJ
    LUPULMABNULUJOPUQKMDUJQRDABADUAUBSBDUCUDSUEUJDUFUGUHULUITTT $.

  $( Example for ~ df-uni .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 2-Jul-2016.) $)
  ex-uni $p |- U. { { 1 , 3 } , { 1 , 8 } } = { 1 , 3 , 8 } $=
    ( c1 c3 cpr c8 cuni cun ctp prex unipr ex-un eqtri ) ABCZADCZCELMFABDGLMABH
    ADHIJK $.

  $( Example for ~ df-ss .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 6-May-2015.) $)
  ex-ss $p |- { 1 , 2 } C_ { 1 , 2 , 3 } $=
    ( c1 c2 cpr c3 csn cun ctp ssun1 df-tp sseqtr4i ) ABCZKDEZFABDGKLHABDIJ $.

  $( Example for ~ df-pss .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 6-May-2015.) $)
  ex-pss $p |- { 1 , 2 } C. { 1 , 2 , 3 } $=
    ( c1 c2 cpr c3 ctp wpss wss wne ex-ss wcel wn cr 3re elexi tpid3 1re gtneii
    1lt3 2re 2lt3 nelpri nelne1 mp2an necomi df-pss mpbir2an ) ABCZABDEZFUGUHGU
    GUHHIUHUGDUHJDUGJKUHUGHABDDLMNODABADPRQBDSTQUADUHUGUBUCUDUGUHUEUF $.

  $( Example for ~ df-pw .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 2-Jul-2016.) $)
  ex-pw $p |- ( A = { 3 , 5 , 7 } -> ~P A =
    ( ( { (/) } u. { { 3 } , { 5 } , { 7 } } ) u.
      ( { { 3 , 5 } , { 3 , 7 } , { 5 , 7 } } u. { { 3 , 5 , 7 } } ) ) ) $=
    ( c3 c5 c7 ctp wceq cpw c0 csn cun cpr pweq df-tp uneq2i unass eqtr4i tpass
    uneq12i uneq1i 3eqtr4i qdass qdassr pwtp un4 syl6eq ) ABCDEZFAGUFGZHIZBIZCI
    ZDIZEZJZBCKZBDKZCDKZEZUFIZJZJZAUFLHUIKUJUNKJZUKUOKUPUFKJZJHUIUJEZUNIZJZUKIZ
    UOUPUFEZJZJZUGUTVAVEVBVHHUIUJUNUAUKUOUPUFUBRBCDUCUTVCVFJZVDVGJZJVIUMVJUSVKU
    MUHUIUJKZJZVFJZVJUMUHVLVFJZJVNULVOUHUIUJUKMNUHVLVFOPVCVMVFHUIUJQSPVDUOUPKZJ
    ZURJVDVPURJZJUSVKVDVPUROUQVQURUNUOUPQSVGVRVDUOUPUFMNTRVCVDVFVGUDPTUE $.

  $( Example for ~ df-pr .  (Contributed by Mario Carneiro, 7-May-2015.) $)
  ex-pr $p |- ( A e. { 1 , -u 1 } -> ( A ^ 2 ) = 1 ) $=
    ( c1 cneg cpr wcel wceq wo c2 cexp co elpri oveq1 sq1 syl6eq cc sqneg ax-mp
    ax-1cn eqtri jaoi syl ) ABBCZDEABFZAUBFZGAHIJZBFZABUBKUCUFUDUCUEBHIJZBABHIL
    MNUDUEUBHIJZBAUBHILUHUGBBOEUHUGFRBPQMSNTUA $.

  $( Example for ~ df-br .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 6-May-2015.) $)
  ex-br $p |- ( R = { <. 2 , 6 >. , <. 3 , 9 >. } -> 3 R 9 ) $=
    ( c2 c6 cop c3 c9 cpr wceq wcel wbr opex prid2 id syl5eleqr df-br sylibr )
    ABCDZEFDZGZHZRAIEFAJTRSAQREFKLTMNEFAOP $.

  ${
    $d x y $.
    $( Example for ~ df-opab .  Example by David A. Wheeler.  (Contributed by
       Mario Carneiro, 18-Jun-2015.) $)
    ex-opab $p |- ( R = { <. x , y >. |
        ( x e. CC /\ y e. CC /\ ( x + 1 ) = y ) } -> 3 R 4 ) $=
      ( cv cc wcel c1 caddc co wceq w3a copab c3 wbr 3cn 4cn 3p1e4 elexi eleq1
      c4 oveq1 eqeq1d 3anbi13d eqeq2 3anbi23d eqid brab mpbir3an breq mpbiri )
      CADZEFZBDZEFZUKGHIZUMJZKZABLZJMTCNMTURNZUSMEFZTEFZMGHIZTJZOPQUQUTUNVBUMJZ
      KUTVAVCKABMTURMEORTEPRUKMJZULUTUPVDUNUKMESVEUOVBUMUKMGHUAUBUCUMTJUNVAVDVC
      UTUMTESUMTVBUDUEURUFUGUHMTCURUIUJ $.
  $}

  $( Example for ~ df-eprel .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 18-Jun-2015.) $)
  ex-eprel $p |- 5 _E { 1 , 5 } $=
    ( c5 c1 cpr cep wbr wcel cn 5nn elexi prid2 prex epelc mpbir ) ABACZDEANFBA
    AGHIJANBAKLM $.

  $( Example for ~ df-id .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 18-Jun-2015.) $)
  ex-id $p |- ( 5 _I 5 /\ -. 4 _I 5 ) $=
    ( c5 cid wbr c4 wn wceq eqid cr 5re elexi ideq mpbir 4re 4lt5 ltneii pm3.2i
    nemtbir ) AABCZDABCZERAAFAGAAAHIJZKLSDADAMNODATKQP $.

  $( Example for ~ df-po .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 18-Jun-2015.) $)
  ex-po $p |- ( < Po RR /\ -. <_ Po RR ) $=
    ( cr clt wpo cle wn wor ltso sopo ax-mp cc0 wbr 0le0 0re poirr mpan2 pm3.2i
    wcel mt2 ) ABCZADCZEABFSGABHITJJDKZLTJAQUAEMAJDNORP $.

  $( Example for ~ df-xp .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 7-May-2015.) $)
  ex-xp $p |- ( { 1 , 5 } X. { 2 , 7 } ) =
      ( { <. 1 , 2 >. , <. 1 , 7 >. } u. { <. 5 , 2 >. , <. 5 , 7 >. } ) $=
    ( c1 c5 cpr c2 c7 cxp csn cun cop df-pr xpeq12i xpun 1ex 2nn elexi xpsn 7nn
    cn uneq12i eqtr4i 5nn 3eqtri ) ABCZDECZFAGZBGZHZDGZEGZHZFUEUHFZUEUIFZHZUFUH
    FZUFUIFZHZHADIZAEIZCZBDIZBEIZCZHUCUGUDUJABJDEJKUEUFUHUILUMUSUPVBUMUQGZURGZH
    USUKVCULVDADMDRNOZPAEMERQOZPSUQURJTUPUTGZVAGZHVBUNVGUOVHBDBRUAOZVEPBEVIVFPS
    UTVAJTSUB $.

  $( Example for ~ df-cnv .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 6-May-2015.) $)
  ex-cnv $p |- `' { <. 2 , 6 >. , <. 3 , 9 >. }
      = { <. 6 , 2 >. , <. 9 , 3 >. } $=
    ( c2 c6 cop csn c3 c9 cun ccnv cpr cnvun cn 2nn elexi 6nn cnvsn 3nn uneq12i
    9nn eqtri df-pr cnveqi 3eqtr4i ) ABCZDZEFCZDZGZHZBACZDZFECZDZGZUCUEIZHUIUKI
    UHUDHZUFHZGUMUDUFJUOUJUPULABAKLMBKNMOEFEKPMFKRMOQSUNUGUCUETUAUIUKTUB $.

  $( Example for ~ df-co .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 7-May-2015.) $)
  ex-co $p |- ( ( exp o. cos ) ` 0 ) = _e $=
    ( cc0 ccos cfv ce c1 ccom ceu cos0 fveq2i cc wcel wceq cosf 0cn fvco3 mp2an
    wf df-e 3eqtr4i ) ABCZDCZEDCADBFCZGTEDHIJJBQAJKUBUALMNJJADBOPRS $.

  $( Example for ~ df-dm .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 7-May-2015.) $)
  ex-dm $p |- ( F = { <. 2 , 6 >. , <. 3 , 9 >. } -> dom F = { 2 , 3 } ) $=
    ( c2 c6 cop c3 c9 cpr wceq cdm dmeq cn 6nn elexi 9nn dmprop syl6eq ) ABCDEF
    DGZHAIQIBEGAQJBCEFCKLMFKNMOP $.

  $( Example for ~ df-rn .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 7-May-2015.) $)
  ex-rn $p |- ( F = { <. 2 , 6 >. , <. 3 , 9 >. } -> ran F = { 6 , 9 } ) $=
    ( c2 c6 cop c3 c9 cpr wceq crn rneq csn cun df-pr rneqi cn 2nn elexi rnsnop
    rnun 3nn uneq12i eqtr4i 3eqtri syl6eq ) ABCDZEFDZGZHAIUGIZCFGZAUGJUHUEKZUFK
    ZLZIUJIZUKIZLZUIUGULUEUFMNUJUKSUOCKZFKZLUIUMUPUNUQBCBOPQREFEOTQRUACFMUBUCUD
    $.

  $( Example for ~ df-res .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 7-May-2015.) $)
  ex-res $p |- ( ( F = { <. 2 , 6 >. , <. 3 , 9 >. } /\ B = { 1 , 2 } ) ->
         ( F |` B ) = { <. 2 , 6 >. } ) $=
    ( c2 c6 cop c3 c9 cpr wceq c1 cres csn cun syl6eq c0 2re elexi wcel gtneii
    cr simpl df-pr reseq1d resundir wrel cdm wss relsnop dmsnopss snsspr2 simpr
    wa 6re syl5sseqr syl5ss relssres sylancr 1re 1lt3 2lt3 nelpri eleq2d mtbiri
    wn ressnop0 syl uneq12d un0 eqtrd ) BCDEZFGEZHZIZAJCHZIZULZBAKZVJLZAKZVKLZA
    KZMZVRVPVQVRVTMZAKWBVPBWCAVPBVLWCVMVOUAVJVKUBNUCVRVTAUDNVPWBVROMVRVPVSVRWAO
    VPVRUEVRUFZAUGVSVRICDCTPQDTUMQUHVPWDCLZACDUIVPVNWEAJCUJVMVOUKZUNUOVRAUPUQVP
    FARZVDWAOIVPWGFVNRFJCJFURUSSCFPUTSVAVPAVNFWFVBVCFGAVEVFVGVRVHNVI $.

  $( Example for ~ df-ima .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 7-May-2015.) $)
  ex-ima $p |- ( ( F = { <. 2 , 6 >. , <. 3 , 9 >. } /\ B = { 1 , 2 } ) ->
         ( F " B ) = { 6 } ) $=
    ( c2 c6 cop c3 c9 cpr wceq c1 wa cima csn crn df-ima ex-res rneqd syl5eq cn
    cres 2nn elexi rnsnop syl6eq ) BCDEZFGEHIAJCHIKZBALZUEMZNZDMUFUGBATZNUIBAOU
    FUJUHABPQRCDCSUAUBUCUD $.

  $( Example for ~ df-fv .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 7-May-2015.) $)
  ex-fv $p |- ( F = { <. 2 , 6 >. , <. 3 , 9 >. } -> ( F ` 3 ) = 9 ) $=
    ( c2 c6 cop c3 c9 cpr wceq cfv fveq1 wne 2re 2lt3 ltneii cr 3re elexi fvpr2
    9re ax-mp syl6eq ) ABCDEFDGZHEAIEUBIZFEAUBJBEKUCFHBELMNBECFEOPQFOSQRTUA $.

  $( Example for ~ df-1st .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 18-Jun-2015.) $)
  ex-1st $p |- ( 1st ` <. 3 , 4 >. ) = 3 $=
    ( c3 c4 cr 3re elexi 4re op1st ) ABACDEBCFEG $.

  $( Example for ~ df-2nd .  Example by David A. Wheeler.  (Contributed by
     Mario Carneiro, 18-Jun-2015.) $)
  ex-2nd $p |- ( 2nd ` <. 3 , 4 >. ) = 4 $=
    ( c3 c4 cr 3re elexi 4re op2nd ) ABACDEBCFEG $.

  $( Example for ~ df-dec , 1000 + 2000 = 3000.

     This proof disproves (by counter-example) the assertion of Hao Wang, who
     stated, "There is a theorem in the primitive notation of set theory that
     corresponds to the arithmetic theorem 1000 + 2000 = 3000.  The formula
     would be forbiddingly long... even if (one) knows the definitions and is
     asked to simplify the long formula according to them, chances are he will
     make errors and arrive at some incorrect result."  (Hao Wang, "Theory and
     practice in mathematics" , In Thomas Tymoczko, editor, _New Directions in
     the Philosophy of Mathematics_, pp 129-152, Birkauser Boston, Inc.,
     Boston, 1986.  (QA8.6.N48).  The quote itself is on page 140.)

     This is noted in _Metamath:  A Computer Language for Pure Mathematics_ by
     Norman Megill (2007) section 1.1.3.  Megill then states, "A number of
     writers have conveyed the impression that the kind of absolute rigor
     provided by Metamath is an impossible dream, suggesting that a complete,
     formal verification of a typical theorem would take millions of steps in
     untold volumes of books...  These writers assume, however, that in order
     to achieve the kind of complete formal verification they desire one must
     break down a proof into individual primitive steps that make direct
     reference to the axioms.  This is not necessary.  There is no reason not
     to make use of previously proved theorems rather than proving them over
     and over...  A hierarchy of theorems and definitions permits an
     exponential growth in the formula sizes and primitive proof steps to be
     described with only a linear growth in the number of symbols used.  Of
     course, this is how ordinary informal mathematics is normally done anyway,
     but with Metamath it can be done with absolute rigor and precision."

     The proof here starts with ` ( 2 + 1 ) = 3 ` , commutes it, and repeatedly
     multiplies both sides by ten.  This is certainly longer than traditional
     mathematical proofs, e.g., there are a number of steps explicitly shown
     here to show that we're allowed to do operations such as multiplication.
     However, while longer, the proof is clearly a manageable size - even
     though every step is rigorously derived all the way back to the primitive
     notions of set theory and logic.  And while there's a risk of making
     errors, the many independent verifiers make it much less likely that an
     incorrect result will be accepted.

     This proof heavily relies on the decimal constructor ~ df-dec developed by
     Mario Carneiro in 2015.  The underlying Metamath language has an
     intentionally very small set of primitives; it doesn't even have a
     built-in construct for numbers.  Instead, the digits are defined using
     these primitives, and the decimal constructor is used to make it easy to
     express larger numbers as combinations of digits.

     (Contributed by David A. Wheeler, 29-Jun-2016.)  (Shortened by Mario
     Carneiro using the arithmetic algorithm in mmj2, 30-Jun-2016.) $)
  1kp2ke3k $p |- ( ; ; ; 1 0 0 0 + ; ; ; 2 0 0 0 ) = ; ; ; 3 0 0 0 $=
    ( c1 cc0 cdc c2 c3 1nn0 0nn0 deccl 2nn0 eqid 2cn ax-1cn 2p1e3 addcomli 00id
    decadd ) ABCZBCZBDBCZBCZBEBCZBCBRBCZTBCZQBABFGHZGHGSBDBIGHZGHGUBJUCJQBSBUAB
    RTUDGUEGRJTJABDBEBQSFGIGQJSJDAEKLMNOPOPOP $.

  $( Example for ~ df-fl .  Example by David A. Wheeler.  (Contributed by Mario
     Carneiro, 18-Jun-2015.) $)
  ex-fl $p |- ( ( |_ ` ( 3 / 2 ) ) = 1 /\ ( |_ ` -u ( 3 / 2 ) ) = -u 2 ) $=
    ( c3 c2 co c1 wceq cneg wbr clt 1re 3re 2cn eqbrtri wb 2re mpbi cr wa mp2an
    wcel cz cdiv cfl cfv caddc rehalfcli cmul mulid2i 2lt3 2pos ltmuldivi ax-mp
    cle cc0 ltleii 3lt4 2t2e4 breqtrri pm3.2i ltdivmul mp3an mpbir df-2 breqtri
    c4 1z flbi mpbir2an renegcli ltnegi cmin negcli ax-1cn negdi2 negnegi eqtri
    cc oveq1i 2m1e1 readdcli ltnegcon1i 2z znegcl ) ABUACZUBUCDEZWCFZUBUCBFZEZW
    DDWCULGZWCDDUDCZHGZDWCIAJUEZDBUFCZAHGZDWCHGZWLBAHBKUGUHLUMBHGZWMWNMUIDABIJN
    UJUKOZUNWCBWIHWCBHGZABBUFCZHGZAVDWRHUOUPUQAPSBPSZWTWOQWQWSMJNWTWONUIURABBUS
    UTVAZVBVCWCPSDTSWDWHWJQMWKVEWCDVFRVGWGWFWEULGZWEWFDUDCZHGZWFWEBNVHZWCWKVHZW
    QWFWEHGXAWCBWKNVIOUNXCFZWCHGXDXGBDVJCZWCHXGWFFZDVJCZXHWFVPSDVPSXGXJEBKVKVLW
    FDVMRXIBDVJBKVNVQVOXHDWCHVRWPLLXCWCWFDXEIVSWKVTOWEPSWFTSZWGXBXDQMXFBTSXKWAB
    WBUKWEWFVFRVGUR $.

  $( 3 divides into 6.  A demonstration of ~ df-dvds .  (Contributed by David
     A. Wheeler, 19-May-2015.) $)
  ex-dvds $p |- 3 || 6 $=
    ( c2 cz wcel c3 c6 w3a cmul co wceq cdivides wbr 3nn nnzi 6nn 3pm3.2i caddc
    2z 3cn 2timesi 3p3e6 eqtri dvds0lem mp2an ) ABCZDBCZEBCZFADGHZEIDEJKUDUEUFQ
    DLMENMOUGDDPHEDRSTUAADEUBUC $.


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 Humor
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              April Fool's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x F $.
    $( Poisson d'Avril's Theorem.  This theorem is noted for its
       _Selbstdokumentieren_ property, which means, literally,
       "self-documenting" and recalls the principle of _quidquid german dictum
       sit, altum viditur_, often used in set theory.  Starting with the
       seemingly simple yet profound fact that any object ` x ` equals itself
       (proved by Tarski in 1965; see Lemma 6 of [Tarski] p. 68), we
       demonstrate that the power set of the real numbers, as a relation on the
       value of the imaginary unit, does not conjoin with an empty relation on
       the product of the additive and multiplicative identity elements,
       leading to this startling conclusion that has left even seasoned
       professional mathematicians scratching their heads.  (Contributed by
       Prof.  Loof Lirpa, 1-Apr-2005.)  (Proof modification is discouraged.)
       (New usage is discouraged.)

       _A reply to skeptics can be found at
       ~ http://us.metamath.org/mpeuni/mmnotes.txt , under the 1-Apr-2006
       entry_. $)
    avril1 $p |- -. ( A ~P RR ( _i ` 1 ) /\ F (/) ( 0 x. 1 ) ) $=
      ( vy vx vz c1 ci cfv cr cpw wbr cc0 c0 wa wn cv c0r cop wcel wceq cmul co
      c1r cio cnr csn cxp cvv weq equid dfnul2 con2bii mpbi eleq1 mtbii vtocleg
      abeq2i elex con3i pm2.61i df-br 0cn opeq2i eleq1i bitri mtbir intnan df-i
      mulid1i fveq1i df-fv eqtri breq2i df-r wss cab sseq2 abbidv df-pw 3eqtr4g
      ax-mp breqi anbi1i notbii mpbir ) AFGHZIJZKZBLFUAUBZMKZNZOAFCPQUCRZKCUDZU
      EQUFUGZJZKZWJNZOWJWPWJBLRZMSZWRUHSZWSOZXADWRUHDPZWRTXBMSZWSDDUIZXCODUJXCX
      DXDODMDUKUQULUMXBWRMUNUOUPWSWTWRMURUSUTWJBWIRZMSWSBWIMVAXEWRMWILBLVBVIVCV
      DVEVFVGWKWQWHWPWJWHAWMWGKWPWFWMAWGWFFWLHWMFGWLVHVJCFWLVKVLVMAWMWGWOIWNTZW
      GWOTVNXFEPZIVOZEVPXGWNVOZEVPWGWOXFXHXIEIWNXGVQVREIVSEWNVSVTWAWBVEWCWDWE
      $.
  $}

  $( The law of excluded middle.  Act III, Theorem 1 of Shakespeare, _Hamlet,
     Prince of Denmark_ (1602).  Its author leaves its proof as an exercise for
     the reader - "To be, or not to be: that is the question" - starting a
     trend that has become standard in modern-day textbooks, serving to make
     the frustrated reader feel inferior, or in some cases to mask the fact
     that the author does not know its solution.  (Contributed by Prof.  Loof
     Lirpa, 1-Apr-2006.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  2bornot2b $p |- ( 2 x. B \/ -. 2 x. B ) $=
    ( c2 cmul wbr wn wo wi ax-1 mpd df-or mpbir ) BACDZLEZFMMGMLMGZMMLHMNHILMJK
    $.

  $( The classic "Hello world" benchmark has been translated into 314 computer
     programming languages - see
     ~ http://www.roesler-ac.de/wolfram/hello.htm .  However, for many years it
     eluded a proof that it is more than just a conjecture, even though a wily
     mathematician once claimed, "I have discovered a truly marvelous proof of
     this, which this margin is too narrow to contain."  Using an IBM 709
     mainframe, a team of mathematicians led by Prof.  Loof Lirpa, at the New
     College of Tahiti, were finally able put it rest with a remarkably short
     proof only 4 lines long.  (Contributed by Prof.  Loof Lirpa, 1-Apr-2007.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  helloworld $p |- -. ( h e. ( L L 0 ) /\ W (/) ( R. 1 d ) ) $=
    ( cnr cv c1 co c0 wbr cc0 wcel cop noel df-br mtbir intnan ) CEDFGHZIJZAFBK
    BHLSCRMZILTNCRIOPQ $.

  $( One plus one equals two.  Using proof-shortening techniques pioneered by
     Mr.  Mel O'Cat, along with the latest supercomputer technology, Prof.
     Loof Lirpa and colleagues were able to shorten Whitehead and Russell's
     360-page proof that 1+1=2 in _Principia Mathematica_ to this remarkable
     proof only two steps long, thus establishing a new world's record for this
     famous theorem.  (Contributed by Prof.  Loof Lirpa, 1-Apr-2008.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  1p1e2apr1 $p |- ( 1 + 1 ) = 2 $=
    ( c2 c1 caddc co df-2 eqcomi ) ABBCDEF $.

  ${
    $d x A $.
    $( Law of identity (reflexivity of class equality).  Theorem 6.4 of [Quine]
       p. 41.

       This law is thought to have originated with Aristotle (_Metaphysics_,
       Book VII, Part 17).  It is one of the three axioms of Ayn Rand's
       philosophy (_Atlas Shrugged_, Part Three, Chapter VII).  While some have
       proposed extending Rand's axiomatization to include Compassion and
       Kindness, others fear that such an extension may flirt with logical
       inconsistency.  (Contributed by Stefan Allan, 1-Apr-2009.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eqid1 $p |- A = A $=
      ( vx cv wcel biid eqriv ) BAABCADEF $.
  $}

  ${
    $d x y z $.
    $( Division by zero is forbidden!  If we try, we encounter the DO NOT ENTER
       sign, which in mathematics means it is foolhardy to venture any further,
       possibly putting the underlying fabric of reality at risk.  Based on a
       dare by David A. Wheeler.  (Contributed by Mario Carneiro, 1-Apr-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    1div0apr $p |- ( 1 / 0 ) = (/) $=
      ( vx vy vz cdiv cdm cc cc0 csn cdif wceq c1 wcel wa wn co c0 cv cmul crio
      cxp df-div riotaex dmmpt2 wne eldifsni adantl necon2bi ax-mp ndmovg mp2an
      eqid ) DEFFGHIZTJKFLZGULLZMZNZKGDOPJABFULBQCQROAQJZCFSDABCUAUQCFUBUCGGJUP
      GUKUOGGUNGGUDUMGFGUEUFUGUHKGFULDUIUJ $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 (Future - to be reviewed and classified)
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Planar incidence geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Plig $.

  $( Extend class notation with the class of all planar incidence
     geometries. $)
  cplig $a class Plig $.

  ${
    $d x a b l c $.
    $( Planar incidence geometry.  I use Hilbert's "axioms" adapted to planar
       geometry. ` e. ` is the incidence relation.  I could take a generic
       incidence relation but I'm lazy and I'm not sure the gain is worth the
       extra work.  Much of what follows is directly borrowed from Aitken.
       ~ http://public.csusm.edu/aitken_html/m410/betweenness.08.pdf
       (Contributed by FL, 2-Aug-2009.) $)
    df-plig $a |- Plig = { x | ( A. a e. U. x A. b e. U. x
          ( a =/= b -> E! l e. x ( a e. l /\ b e. l ) )
      /\ A. l e. x E. a e. U. x E. b e. U. x ( a =/= b /\ a e. l /\ b e. l )
      /\ E. a e. U. x E. b e. U. x E. c e. U. x A. l e. x
           -. ( a e. l /\ b e. l /\ c e. l ) ) } $.
  $}

  ${
    $d L a b c l x $.  $d P a b c x $.
    isplig.1 $e |- P = U. L $.
    $( The predicate "is a planar incidence geometry".  (Contributed by FL,
       2-Aug-2009.) $)
    isplig $p |- ( L e. A -> ( L e. Plig <->
     ( A. a e. P A. b e. P ( a =/= b -> E! l e. L ( a e. l /\ b e. l ) )
     /\ A. l e. L E. a e. P E. b e. P ( a =/= b /\ a e. l /\ b e. l )
     /\ E. a e. P E. b e. P E. c e. P A. l e. L
           -. ( a e. l /\ b e. l /\ c e. l ) ) ) ) $=
      ( vx cv wne wel wreu wi cuni wral w3a wrex raleqbidv rexeqbidv wa wn wceq
      cplig unieq syl6eqr reueq1 imbi2d rexeqdv raleqbi1dv raleq df-plig elab2g
      3anbi123d ) DJEJKZDGLZEGLZUAZGIJZMZNZEUSOZPZDVBPZUOUPUQQZEVBRZDVBRZGUSPZU
      PUQFGLQUBZGUSPZFVBRZEVBRZDVBRZQUOURGCMZNZEBPZDBPZVEEBRZDBRZGCPZVIGCPZFBRZ
      EBRZDBRZQICUDAUSCUCZVDVQVHVTVMWDWEVCVPDVBBWEVBCOBUSCUEHUFZWEVAVOEVBBWFWEU
      TVNUOURGUSCUGUHSSVGVSGUSCWEVFVRDVBBWFWEVEEVBBWFUITUJWEVLWCDVBBWFWEVKWBEVB
      BWFWEVJWAFVBBWFVIGUSCUKTTTUNIDEFGULUM $.
  $}

  ${
    $d L a b c l $.  $d P a b c $.
    tncp.1 $e |- P = U. L $.
    $( There exist three non colinear points.  (Contributed by FL,
       3-Aug-2009.) $)
    tncp $p |- ( L e. Plig -> E. a e. P E. b e. P E. c e. P A. l e. L
           -. ( a e. l /\ b e. l /\ c e. l ) ) $=
      ( cplig wcel cv wne wel wa wreu wi wral w3a wrex wn isplig ibi simp3d ) B
      HIZCJDJKZCFLZDFLZMFBNODAPCAPZUDUEUFQDARCARFBPZUEUFEFLQSFBPEARDARCARZUCUGU
      HUIQHABCDEFGTUAUB $.
  $}

  ${
    $d a b c d l G $.  $d a b c d l L $.  $d a b c d l P $.
    lpni.1 $e |- P = U. G $.
    $( For any line, there exists a point not on the line.  (Contributed by
       Jeff Hankins, 15-Aug-2009.) $)
    lpni $p |- ( ( G e. Plig /\ L e. G ) -> E. a e. P a e/ L ) $=
      ( vb vl vc vd wcel cv wrex w3a wn eleq2 notbid weq eleq1 rspcev ex rspccv
      cplig wnel wral wi tncp wa wceq 3anbi123d w3o 3jaao 3ianor df-nel 3imtr4g
      rexbii syl9r 3expia rexlimdv rexlimivv syl imp ) BUBJZCBJZDKZCUCZDALZVBFK
      ZGKZJZHKZVHJZIKZVHJZMZNZGBUDZIALZHALFALVCVFUEZABFHIGEUFVQVRFHAAVGAJZVJAJZ
      UGVPVRIAVSVTVLAJZVPVRUEVPVCVGCJZVJCJZVLCJZMZNZVSVTWAMZVFVOWFGCBVHCUHZVNWE
      WHVIWBVKWCVMWDVHCVGOVHCVJOVHCVLOUIPUAWGWBNZWCNZWDNZUJVDCJZNZDALZWFVFVSWIW
      NVTWJWAWKVSWIWNWMWIDVGADFQWLWBVDVGCRPSTVTWJWNWMWJDVJADHQWLWCVDVJCRPSTWAWK
      WNWMWKDVLADIQWLWDVDVLCRPSTUKWBWCWDULVEWMDAVDCUMUOUNUPUQURUSUTVA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Algebra preliminaries
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c RPrime $. $( Ring prime element $)
  $( $c UFD $. $) $( Unique factorization domain $)

  $( Ring primes. $)
  crpm $a class RPrime $.

  $( Unique factorization domain. $)
  $( cufd $a class UFD $. $)

  ${
    $d b d e f g h i n p q r s t v w x y z $.
    $( Define the set of prime elements in a ring.  A prime element is a
       nonzero non-unit that satisfies an equivalent of Euclid's lemma
       ~ euclemma .  (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    df-rprm $a |- RPrime = ( w e. _V |-> [_ ( Base ` w ) / b ]_
        { p e. ( b \ ( ( Unit ` w ) u. { ( 0g ` w ) } ) ) | A. x e. b A. y e. b
  [. ( ||r ` w ) / d ]. ( p d ( x ( .r ` w ) y ) -> ( p d x \/ p d y ) ) } ) $.

    $(
    @( Define a unique factorization domain, which is a commutative ring with
       an absolute value (from ~ abvtriv this is equivalent to being a domain)
       such that every prime ideal contains a prime element (this is a
       characterization due to Kaplansky). @)
    df-ufd @a |- UFD = { r e. CRing | ( ( AbsVal ` r ) =/= (/) /\
      A. i e. ( PrIdl ` r ) ( i i^i ( RPrime ` r ) ) =/= (/) ) } @.
    $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Transitive closure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c t+ $.
  $c t* $.

  $( Extend class notation to include the transitive closure symbol. $)
  ctcl $a class t+ $.

  $( Extend class notation with transitive closure. $)
  crtcl $a class t* $. $( Extend class notation with reflexive transitive
  closure. $)

  ${
    $d x y z $.
    $( Transitive closure of a relation.  Experimental.  (Contributed by FL,
       27-Jun-2011.) $)
    df-trcl $a |- t+ = ( x e. _V |->
      |^| { z | ( x C_ z /\ ( z o. z ) C_ z ) } ) $.

    $( Reflexive-transitive closure of a relation.  Experimental.  (Contributed
       by FL, 27-Jun-2011.) $)
    df-rtrcl $a |- t* = ( x e. _V |->
      |^| { z | ( ( _I |` ( dom x u. ran x ) ) C_ z /\ x C_ z
                /\ ( z o. z ) C_ z ) } ) $.
  $}

$(


@(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Calculus
                    Version of 10-Aug-2005 Roy F. Longton
                            9-Sep-2005  neighex added
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
@)

  @c neigh @.

  @( Extend the definition of classes to include neighborhoods.  ( Contributed
    by Roy F. Longton, 7-Aug-2005.) @)
  cneigh @a class neigh @.

  @{
    @d x y z w @.
    @( Define the notion of neighborhoods: "neigh" is a relation that relates
      a subset of the real numbers to a point within it for which it acts as a
      neighborhood.  ( Contributed by Roy F. Longton, 7-Aug-2005.) @)
    df-neigh @a |- neigh = { <. x , y >. | ( ( x C_ RR /\ y e. RR ) /\ E. z e.
      RR ( 0 < z /\ A. w e. RR ( ( 0 <_ w /\ w < z ) -> ( ( y + w ) e. x /\
      ( y - w ) e.  x ) ) ) ) } @.
  @}

  @{
    @d x y z w @.
    @( The notion of neighborhoods is a relation.  ( Contributed by Roy F.
       Longton, 7-Aug-2005.) @)
    neighrel @p |- Rel neigh @=
      ( vx vy vz vw cneigh wrel cv cr wss wcel wa cc0 clt wbr cle caddc co
      cmin wi wral wrex copab relopab wceq wb df-neigh releq ax-mp mpbir ) EFZA
      GZHIBGZHJKLCGZMNLDGZONUNUMMNKULUNPQUKJULUNRQUKJKSDHTKCHUAKZABUBZFZUOABUCE
      UPUDUJUQUEABCDUFEUPUGUHUI @.
      @( [ ?] @) @( [7-Aug-2005] @)
  @}

  @{
    @d S x y z w @.  @d A x y z w @.
    neigh.1 @e |- S e. _V @.
    neigh.2 @e |- A e. _V @.
    @( Express the predicate: ` S ` is a neighborhood of ` A ` .  ( Contributed
       by Roy F. Longton, 7-Aug-2005.) @)
    neighbr @p |- ( S neigh A <->
      ( ( S C_ RR /\ A e. RR ) /\ E. z e. RR ( 0 < z
      /\ A. w e. RR ( ( 0 <_ w /\ w < z ) -> ( ( A + w ) e. S /\ ( A - w ) e.
      S ) ) ) ) ) @=
      ( vx vy cv cr wss wcel wa cc0 clt wbr cle caddc co cmin wi wral wrex
      cneigh wceq sseq1 anbi1d eleq2 anbi12d imbi2d ralbidv anbi2d rexbidv
      eleq1 oveq1 eleq1d df-neigh brab ) GIZJKZHIZJLZMZNAIZOPZNBIZQPVFVDOPMZVA
      VFRSZUSLZVAVFTSZUSLZMZUAZBJUBZMZAJUCZMDJKZVBMZVEVGVHDLZVJDLZMZUAZBJUBZMZA
      JUCZMVQCJLZMZVEVGCVFRSZDLZCVFTSZDLZMZUAZBJUBZMZAJUCZMGHDCUDEFUSDUEZVCVRVP
      WEWQUTVQVBUSDJUFUGWQVOWDAJWQVNWCVEWQVMWBBJWQVLWAVGWQVIVSVKVTUSDVHUHUSDVJU
      HUIUJUKULUMUIVACUEZVRWGWEWPWRVBWFVQVACJUNULWRWDWOAJWRWCWNVEWRWBWMBJWRWAWL
      VGWRVSWIVTWKWRVHWHDVACVFRUOUPWRVJWJDVACVFTUOUPUIUJUKULUMUIGHABUQUR @.
      @( [ ?] @) @( [10-Aug-2005] @)
  @}

  @{
    @d A z w @.
    reneigh.1 @e |- A e. RR @.
    @( The set of real numbers acts as a neighborhood for every real number. @)
    reneigh @p |- RR neigh A @=
      ( vz vw cr cneigh wbr wss wcel wa cc0 cv clt cle caddc co cmin wi wral
      wrex reex elexi neighbr ssid pm3.2i c1 1re 0lt1 readdcl mpan
      resubcl jca a1d rgen wceq breq2 anbi2d imbi1d ralbidv anbi12d rspcev
      mp2an mpbir2anOLD )
      EAFGEEHZAEIZJKCLZMGZKDLZNGZVHVFMGZJZAVHOPEIZAVHQPEIZJZRZ
      DESZJZCETZCDAEUAAEBUBUCVDVEEUDBUEUFEIKUFMGZVIVHUFMGZJZVNRZDESZJZVRUGVSWCU
      HWBDEVHEIZVNWAWEVLVMVEWEVLBAVHUIUJVEWEVMBAVHUKUJULUMUNUEVQWDCUFEVFUFUOZVG
      VSVPWCVFUFKMUPWFVOWBDEWFVKWAVNWFVJVTVIVFUFVHMUPUQURUSUTVAVBVC @.
      @( [ ?] @) @( [8-Aug-2005] @)
  @}

    @c OpenROY @.

    @( Extend the definition of classes to include open sets.  ( Contributed by
      Roy F. Longton, 7-Aug-2005.) @)
    copen @a class OpenROY @.

  @{
    @d x y z @.
    @( Define the notion of an open set: "Open" is the class of all open sets.
      A set is open if all of its members each have a neighborhood completely
      contained within the set.  ( Contributed by Roy F. Longton,
      7-Aug-2005.) @)
    df-openROY @a |- OpenROY =
                     { x | A. y e. x E. z ( z C_ x /\ z neigh y ) } @.
  @}

    @c cont @.

    @( Extend the definition of classes to include function continuity.
      ( Contributed by Roy F. Longton, 7-Aug-2005.) @)
    ccont @a class cont @.

  @{
    @d f x y z @.
    @( Define the notion of function continuity: "cont" is a relation that
      relates a function to a (sub)domain on which it is continuous.  A
      function is continuous on a domain if and only if every open subset of
      its range has an open preimage under the function.  ( Contributed by Roy
      F. Longton, 7-Aug-2005.) @)
    df-cont @a |- cont = { <. f , x >. | ( f Fn x /\ A. y ( y C_ ( f " x ) ->
  ( OpenROY y -> ( E. z ( z C_ x /\ OpenROY z /\ y = ( f " z ) ) ) ) ) ) ) } @.
  @}

    @( Two nonnegative numbers compare the same as their squares.
       ( Contributed by Roy F. Longton, 8-Aug-2005.) @)
    lt2sqtROY @p |- ( ( A e. RR /\ B e. RR ) -> ( ( 0 <_ A /\ 0 <_ B ) ->
        ( A < B <-> ( A x. A ) < ( B x. B ) ) ) ) @=
      ( cr wcel cc0 cle wbr wa clt cmul co wb wi cif wceq breq2 anbi1d breq1
      oveq12 anidms breq1d bibi12d imbi12d anbi2d breq2d 0re elimel lt2msqi
      dedth2h ) ACDZBCDZEAFGZEBFGZHZABIGZAAJKZBBJKZIGZLZMEUJAENZFGZUMHZUTBIGZUT
      UTJKZUQIGZLZMVAEUKBENZFGZHZUTVGIGZVDVGVGJKZIGZLZMABEEAUTOZUNVBUSVFVNULVAU
      MAUTEFPQVNUOVCURVEAUTBIRVNUPVDUQIVNUPVDOAUTAUTJSTUAUBUCBVGOZVBVIVFVMVOUMV
      HVABVGEFPUDVOVCVJVEVLBVGUTIPVOUQVKVDIVOUQVKOBVGBVGJSTUEUBUCUTVGAECUFUGBEC
      UFUGUHUI @.
      @( [ ?] @) @( [8-Aug-2005] @)

  @{
    sqrlt.1 @e |- A e. RR @.
    sqrlt.2 @e |- B e. RR @.
    @( Square root is strictly monotonic.  ( Contributed by Roy F. Longton,
      8-Aug-2005.) @)
    sqrltROY @p |- ( ( 0 <_ A /\ 0 <_ B ) -> ( A < B <-> ( sqr ` A ) <
      ( sqr ` B ) ) ) @=
      ( cc0 cle wbr wa csqr cfv clt cmul co wb cr wcel wi lt2sqtROY sqrcli
      syl2anOLD sqrge0i syl2aniOLD pm2.43i sqrthi breqan12d
      bitr2d ) EAFGZEBFGZHZAIJZBI
      JZKGZUJUJLMZUKUKLMZKGZABKGUIULUONZUIEUJFGZEUKFGZUPUGUHUJOPUKOPUQURHUPQUGU
      HUJUKRACSBDSTACUABDUAUBUCUGUHUMAUNBKACUDBDUDUEUF @.
      @( [ ?] @) @( [8-Aug-2005] @)
  @}

    @( The square root of 2 is bounded by 1 and 2.  ( Contributed by Roy F.
       Longton, 8-Aug-2005.) @)
    sqr2gt1lt2ROY @p |- ( 1 < ( sqr ` 2 ) /\ ( sqr ` 2 ) < 2 ) @=
      ( c1 c2 csqr cfv clt wbr sqr1 1lt2 cc0 cle wb 0re 1re 0lt1 ltleii 2re
      2pos sqrltROY mp2an mpbi eqbrtrri c4 caddc co sqrlem15 2p2e4 breqtri 4re
      4pos sqr4 pm3.2i ) ABCDZEFULBEFACDZAULEGABEFZUMULEFZHIAJFIBJFZUNUOKIALMNO
      IBLPQOZABMPRSTUAULUBCDZBEBUBEFZULUREFZBBBUCUDUBEBBBPQPQPQUEUFUGUPIUBJFUSU
      TKUQIUBLUHUIOBUBPUHRSTUJUGUK @.
      @( [ ?] @) @( [8-Aug-2005] @)

  @{
    @d A w z @.  @d B w z @.
    neighre.1 @e |- A e. _V @.
    neighre.2 @e |- B e. _V @.
    @( Every neighborhood is a subset of ` RR ` .  ( Contributed by Roy F.
      Longton, 8-Aug-2005.) @)
    neighre @p |- ( A neigh B -> A C_ RR ) @=
      ( vz vw cneigh wbr cr wss wcel wa cc0 cv clt cle caddc co cmin wi wral
      wrex neighbr simplbi simpld ) ABGHZAIJZBIKZUFUGUHLMENZOHMFNZPHUJUIOHLBU
      JQRAKBUJSRAKLTFIUALEIUBEFBACDUCUDUE @.
      @( [ ?] @) @( [9-Aug-2005] @)
  @}

  @(
  @{
    @d A w z @.  @d B w z @.
    ncenre.1 @e |- B e. _V @.
    This was probably not provable with the old df-neigh.
    ncenre @p |- ( A neigh B -> B e. RR ) @=
      cA cB cneigh wbr cB cr wcel cB cr wcel wa wi cA cB cneigh wbr cB cr
      wcel wi
      cA cB cneigh wbr cB cr wcel cB cr wcel ? ? jca cA cB cneigh wbr cB
      cr wcel
      cB cr wcel wa wi cA cB cneigh wbr cB cr wcel wi cA cB cneigh wbr cB
       cr wcel
      anidmdbi biimpi ax-mp @.
  @}
  @)

  @{
    @v et @.
    preneighlem.wet @f wff et @.
    preneighlem.1 @e |- ( ph -> ( ps -> ( ch -> ta ) ) ) @.
    preneighlem.2 @e |- ( ph -> ( ps -> ( th -> et ) ) ) @.
    @( Technical lemma for ~ preneigh .  This lemma is unusual because it is of
       a different branch of mathmatics than its parent theorem (the
       propositional calculus vs. real number analysis). @)
    preneighlem @p |- ( ph -> ( ps -> ( ( ch /\ th ) -> ( ta /\ et ) ) ) )
      @=
      ( wa wi imp com12 adantr impcom adantl jca exp31 ) ABCDIZEFIABIZRIEFRSECS
      EJDSCEABCEJGKLMNRSFDSFJCSDFABDFJHKLONPQ @.
      @( [ ?] @) @( [9-Aug-2005] @)
  @}

  @{
    @d A x z w @.
    preneigh.1 @e |- A e. RR @.
    preneigh @p |- ( 0 < A -> { x e. RR | 0 < x } neigh A ) @=
      ( vz vw cc0 clt wbr cv cr crab wss wcel wa cle caddc co cmin wi wral
      wrex cneigh ssrab2 a1i jca c2 cdiv 2nn nnrei nngt0i gt0ne0ii redivcli
      divgt0i2i wal cab wsbcSBC wceq wex ovex spcev syl sbc5OLDSBC
      sylibr ax-sbcSBC sylib
      df-rab eleq2i ex preneighlem ax-gen df-ral mpbir ax-1 ax-17 19.21 mpbi
      pm3.2i breq2 anbi2d imbi1d ralbidv anbi12d imbi2d rspcev ax-mp 19.37v
      reex rabex elexi neighbr ) FBGHZFAIZGHZAJKZJLZBJMZNZFDIZGHZFEIZOHZWTWR
      GHZNZBWTPQZWNMZBWTRQZWNMZNZSZEJTZNZDJUAZNWNBUBHWKWQXLWKWOWPWOWKWMAJUCUDWP
      WKCUDUEWKXKSZDJUAZWKXLSBUFUGQZJMZWKFXOGHZXAWTXOGHZNZXHSZEJTZNZSZNXNXPYCBU
      FCUFUHUIZUFYDUFUHUJZUKULWKXQYABUFCYDYEUMWKXTSZEJTZWKYASYGWTJMZYFSZEUNYIEY
      HWKXAXRXEXGYHWKXAXESYHWKNZXAXEYJXANZXDWLJMWMNZAUOZMZXEYKYLAXDUPZYNYKWLXDU
      QYLNZAURZYOYK?YQ?YP?AXDBWTPUSZ?UTVAYLAXDYRVBVCYLAXDVDVEWNYMXDWMAJVFZVGVCV
      HVHYHWKXRXGSYJXRXGYJXRNZXFYMMZXGYTYLAXFUPZUUAYTWLXFUQYLNZAURZUUBYT?UUD?UU
      C?AXFBWTRUSZ?UTVAYLAXFUUEVBVCYLAXFVDVEWNYMXFYSVGVCVHVHVIVJYFEJVKVLWKXT?WK
      YHWKSZEUNZWKEJTWKUUFSZEUNWKUUGSUUHEWKYHVMVJWKUUFEWKEVNVOVPWKEJVKVCVOVPUEV
      QXMYCDXOJWRXOUQZXKYBWKUUIWSXQXJYAWRXOFGVRUUIXIXTEJUUIXCXSXHUUIXBXRXAWRXOW
      TGVRVSVTWAWBWCWDWEWKXK?WFVPUEDEBWNWMAJWGWHBJCWIWJVC @.
      @( [ ?] @) @( [9-Aug-2005] @)
  @}

  @{
    genneigh.1 @e |- A e. RR @.
    genneigh.2 @e |- B e. RR @.
    genneigh.3 @e |- C e. RR @.
    genneigh @p |- ( ( 0 < B /\ 0 < C ) -> { x e. RR |
      ( A - B ) < x /\ x < ( A + C ) } neigh A ) @=
      (  ) ? @.
  @}

  @{
    @d x y z w @.
    @( The class of all neighborhoods exists.
  ( Contributed by Roy F. Longton,
      29-Aug-2005.) @)
    neighex @p |- neigh e. _V @=
      ( vx vy vz vw cneigh cv cr wss wcel wa cc0 clt wbr cle caddc co cmin wi
      wral wrex copab cvv df-neigh cpw cxp reex pwex xpex simpl ssopab2i
      df-pw abeq2i anbi1i opabbii sseqtr4i df-xp ssexi
      eqeltri ) EAFZGHZBFZGIZJZK
      CFZLMKDFZNMVEVDLMJVAVEOPUSIVAVEQPUSIJRDGSJCGTZJZABUAZUBABCDUCVHGUDZGUEZVI
      GGUFUGUFUHVHUSVIIZVBJZABUAZVJVHVCABUAVMVGVCABVCVFUIUJVLVCABVKUTVBUTAVIAGU
      KULUMUNUOABVIGUPUOUQUR @.
      @( [ ?] @) @( [29-Aug-2005] @)
  @}

  @{
    @d x y z @.
    open @p |- ( x e. OpenROY <-> A. y e. x E. z ( z C_ x /\ z neigh y ) ) @=
      ( cv wss cneigh wbr wa wex wral copen df-openROY abeq2i ) CDZADZENBDFGHCI
      BOJAKABCLM @.
      @( [ ?] @) @( [10-Aug-2005] @)
  @}

    openex @p |- OpenROY e. _V @=
      (  ) ? @.

    reopen @p |- RR e. OpenROY @=
      (  ) ? @.

  @{
    openneigh.1 @e |- OpenROY A @.
    openneigh @p |- E. x e. RR A neigh x @=
      (  ) ? @.
  @}

$)

$( End $[ set-main.mm $] $)

$( Begin $[ set-deprec.mm $] $)


$(
###############################################################################
       ADDITIONAL MATERIAL ON GROUPS, RINGS, AND FIELDS (DEPRECATED)
###############################################################################

  This part contains an earlier development of groups, rings, and fields
  that was defined before extensible structures were introduced.

  Theorem ~ grpo2grp shows the relationship between the older group definition
  and the extensible structure definition.

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                 Additional material on group theory
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Definitions and basic properties for groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpOp $.
  $c GId $.
  $c inv $.
  $c /g $.
  $c ^g $.

  $( Extend class notation with the class of all group operations. $)
  cgr $a class GrpOp $.

  $( Extend class notation with a function mapping a group operation to the
     group's identity element. $)
  cgi $a class GId $.

  $( Extend class notation with a function mapping a group operation to the
     inverse function for the group. $)
  cgn $a class inv $.

  $( Extend class notation with a function mapping a group operation to the
     division (or subtraction) operation for the group. $)
  cgs $a class /g $.

  $( Extend class notation with a function mapping a group operation to the
     power operation for the group. $)
  cgx $a class ^g $.

  ${
    $d f g t u x y z $.
    $( Define the class of all group operations.  The base set for a group can
       be determined from its group operation.  Based on the definition in
       Exercise 28 of [Herstein] p. 54.  (Contributed by NM, 10-Oct-2006.)
       (New usage is discouraged.) $)
    df-grpo $a |- GrpOp = { g | E. t ( g : ( t X. t ) --> t
       /\ A. x e. t A. y e. t A. z e. t ( ( x g y ) g z ) = ( x g ( y g z ) )
   /\ E. u e. t A. x e. t ( ( u g x ) = x /\ E. y e. t ( y g x ) = u ) ) } $.

    $( Define a function that maps a group operation to the group's identity
       element.  (Contributed by FL, 5-Feb-2010.)  (Revised by Mario Carneiro,
       15-Dec-2013.)  (New usage is discouraged.) $)
    df-gid $a |- GId = ( g e. _V |-> ( iota_ u e. ran g A. x e. ran g
                        ( ( u g x ) = x /\ ( x g u ) = x ) ) ) $.

    $( Define a function that maps a group operation to the group's inverse
       function.  (Contributed by NM, 26-Oct-2006.)
       (New usage is discouraged.) $)
    df-ginv $a |- inv = ( g e. GrpOp |-> ( x e. ran g |->
                    ( iota_ z e. ran g ( z g x ) = ( GId ` g ) ) ) ) $.

    $( Define a function that maps a group operation to the group's division
       (or subtraction) operation.  (Contributed by NM, 15-Feb-2008.)
       (New usage is discouraged.) $)
    df-gdiv $a |- /g = ( g e. GrpOp |-> ( x e. ran g , y e. ran g |->
                         ( x g ( ( inv ` g ) ` y ) ) ) ) $.

    $( Define a function that maps a group operation to the group's power
       operation.  (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    df-gx $a |- ^g = ( g e. GrpOp |-> ( x e. ran g , y e. ZZ |->
      if ( y = 0 , ( GId ` g ) ,
        if ( 0 < y , ( seq 1 ( g , ( NN X. { x } ) ) ` y ) ,
          ( ( inv ` g ) ` ( seq 1 ( g , ( NN X. { x } ) ) ` -u y ) ) ) ) ) ) $.
  $}

  ${
    $d g n t u x y z G $.  $d g n t u x y z X $.
    isgrp.1 $e |- X = ran G $.
    $( The predicate "is a group operation."  Note that ` X ` is the base set
       of the group.  (Contributed by NM, 10-Oct-2006.)
       (New usage is discouraged.) $)
    isgrpo $p |- ( G e. A -> ( G e. GrpOp <-> ( G : ( X X. X ) --> X /\
       A. x e. X A. y e. X A. z e. X ( ( x G y ) G z ) = ( x G ( y G z ) )
   /\ E. u e. X A. x e. X ( ( u G x ) = x /\ E. y e. X ( y G x ) = u ) ) ) ) $=
      ( vt vg wcel cv wceq cxp wf co wral wrex wa oveq cgr crn w3a oveq1d eqtrd
      wex feq1 oveq2d eqeq12d ralbidv 2ralbidv eqeq1d rexbidv anbi12d 3anbi123d
      rexralbidv exbidv df-grpo elab2g simpl ralimi oveq2 id eqcom syl6bb rspcv
      wfo eqeq2d rspcev syld syl5 reximdv impcom ralrimiva anim2i sylibr eqcomd
      ex foov forn syl 3adant2 pm4.71ri exbii wb rnexg eqeq2i xpeq1 xpeq2 feq2d
      cvv feq3 bitrd raleq raleqbi1dv rexeq anbi2d rexeqbi1dv sylbir ceqsexgv )
      FEKZFUAKZILZFUBZMZXCXCNZXCFOZALZBLZFPZCLZFPZXHXIXKFPZFPZMZCXCQZBXCQZAXCQZ
      DLZXHFPZXHMZXIXHFPZXSMZBXCRZSZAXCQZDXCRZUCZSZIUFZGGNZGFOZXOCGQZBGQZAGQZYA
      YCBGRZSZAGQZDGRZUCZXAXBYHIUFZYJXFXCJLZOZXHXIUUBPZXKUUBPZXHXIXKUUBPZUUBPZM
      ZCXCQZBXCQAXCQZXSXHUUBPZXHMZXIXHUUBPZXSMZBXCRZSZAXCQDXCRZUCZIUFUUAJFUAEUU
      BFMZUURYHIUUSUUCXGUUJXRUUQYGXFXCUUBFUGUUSUUIXPABXCXCUUSUUHXOCXCUUSUUEXLUU
      GXNUUSUUEUUDXKFPXLUUDXKUUBFTUUSUUDXJXKFXHXIUUBFTUDUEUUSUUGXHUUFFPXNXHUUFU
      UBFTUUSUUFXMXHFXIXKUUBFTUHUEUIUJUKUUSUUPYEDAXCXCUUSUULYAUUOYDUUSUUKXTXHXS
      XHUUBFTULUUSUUNYCBXCUUSUUMYBXSXIXHUUBFTULUMUNUPUOUQABCDIJURUSYHYIIYHXEXGY
      GXEXRXGYGSZXFXCFVGZXEUUTXGXKXSXIFPZMZBXCRZDXCRZCXCQZSUVAYGUVFXGYGUVECXCXK
      XCKZYGUVEUVGYFUVDDXCYFYAAXCQZUVGUVDYEYAAXCYAYDUTVAUVGUVHXKXSXKFPZMZUVDYAU
      VJAXKXCXHXKMZYAUVIXKMUVJUVKXTUVIXHXKXHXKXSFVBUVKVCUIUVIXKVDVEVFUVGUVJUVDU
      VCUVJBXKXCXIXKMUVBUVIXKXIXKXSFVBVHVIVRVJVKVLVMVNVODBCXCXCXCFVSVPUVAXDXCXF
      XCFVTVQWAWBWCWDVEXAXDWKKYJYTWEFEWFYHYTIXDWKXEXCGMZYHYTWEGXDXCHWGUVLXGYLXR
      YOYGYSUVLXGYKXCFOYLUVLXFYKXCFUVLXFGXCNYKXCGXCWHXCGGWIUEWJXCGYKFWLWMXQYNAX
      CGXPYMBXCGXOCXCGWNWOWOYFYRDXCGYEYQAXCGUVLYDYPYAYCBXCGWPWQWOWRUOWSWTWAWM
      $.

    $( The predicate "is a group operation."  (Contributed by NM,
       23-Oct-2012.)  (New usage is discouraged.) $)
    isgrpo2 $p |- ( G e. A -> ( G e. GrpOp <-> ( G : ( X X. X ) --> X /\
       A. x e. X A. y e. X A. z e. X
         ( ( x G y ) e. X /\ ( ( x G y ) G z ) = ( x G ( y G z ) ) )
   /\ E. u e. X A. x e. X ( ( u G x ) = x /\ E. n e. X ( n G x ) = u ) ) ) ) $=
      ( wcel cv co wceq wral wrex wa w3a 3anass syl6bb ralbidva cgr cxp crn wfn
      wf isgrpo ffn ad2antrr simplr simpr fnovrn syl3anc syl6eleqr biantrurd wb
      ralbidv weq oveq1 eqeq1d cbvrexv anbi2i ralbii rexbii a1i anbi12d pm5.32i
      bitr4i ) GEJZGUAJZHHUBZHGUEZAKZBKZGLZCKZGLVLVMVOGLGLMZCHNZBHNZAHNZDKZVLGL
      VLMZVMVLGLZVTMZBHOZPZAHNZDHOZPZPZVKVNHJZVPPZCHNZBHNZAHNZWAFKZVLGLZVTMZFHO
      ZPZAHNZDHOZQZVHVIVKVSWGQWIABCDEGHIUFVKVSWGRSWIVKWNXAPZPXBVKWHXCVKVSWNWGXA
      VKVRWMAHVKVLHJZPZVQWLBHXEVMHJZPZVPWKCHXGWJVPXGVNGUCZHXGGVJUDZXDXFVNXHJVKX
      IXDXFVJHGUGUHVKXDXFUIXEXFUJHHVLVMGUKULIUMUNUPTTWGXAUOVKWFWTDHWEWSAHWDWRWA
      WCWQBFHBFUQWBWPVTVMWOVLGURUSUTVAVBVCVDVEVFVKWNXARVGS $.
  $}

  ${
    $d u x y z G $.  $d u x y z U $.  $d u x y z X $.  $d y N $.
    isgrpi.1 $e |- X e. _V $.
    isgrpi.2 $e |- G : ( X X. X ) --> X $.
    isgrpi.3 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                   ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $.
    isgrpi.4 $e |- U e. X $.
    isgrpi.5 $e |- ( x e. X -> ( U G x ) = x ) $.
    isgrpi.6 $e |- ( x e. X -> N e. X ) $.
    isgrpi.7 $e |- ( x e. X -> ( N G x ) = U ) $.
    $( Properties that determine a group operation.  Read ` N ` as
       ` N ( x ) ` .  (Contributed by NM, 4-Nov-2006.)
       (New usage is discouraged.) $)
    isgrpoi $p |- G e. GrpOp $=
      ( vu wcel co wceq wral wrex cgr cxp wf cv rgen3 eqeq1d rspcev syl2anc jca
      wa oveq1 rgen eqeq2 rexbidv anbi12d ralbidv mp2an cvv w3a wb xpex fex crn
      wfo eqcomd rspceov mp3an1 mpdan foov mpbir2an forn eqcomi isgrpo mpbir3an
      ax-mp ) EUAPZGGUBZGEUCZAUDZBUDZEQCUDZEQVSVTWAEQZEQRZCGSBGSAGSZOUDZVSEQZVS
      RZVTVSEQZWERZBGTZUJZAGSZOGTZIWCABCGGGJUEDGPZDVSEQZVSRZWHDRZBGTZUJZAGSZWMK
      WSAGVSGPZWPWRLXAFGPFVSEQZDRZWRMNWQXCBFGVTFRWHXBDVTFVSEUKUFUGUHUIULWLWTODG
      WEDRZWKWSAGXDWGWPWJWRXDWFWOVSWEDVSEUKUFXDWIWQBGWEDWHUMUNUOUPUGUQEURPZVPVR
      WDWMUSUTVRVQURPXEIGGHHVAVQGUREVBUQABCOUREGEVCZGVQGEVDZXFGRXGVRVSWBRCGTBGT
      ZAGSIXHAGXAVSWORZXHXAWOVSLVEWNXAXIXHKBCGGDVSVSEVFVGVHULBCAGGGEVIVJVQGEVKV
      OVLVMVOVN $.
  $}

  ${
    $d w x y z A $.  $d x y z B $.  $d z C $.  $d u w x y z G $.
    $d u w x y z X $.  $d y U $.
    grpfo.1 $e |- X = ran G $.
    $( A group operation maps onto the group's underlying set.  (Contributed by
       NM, 30-Oct-2006.)  (New usage is discouraged.) $)
    grpofo $p |- ( G e. GrpOp -> G : ( X X. X ) -onto-> X ) $=
      ( vx vy vz vu cgr wcel cxp wf crn wceq wa wfo cv co wral wrex w3a isgrpo
      ibi simp1d eqcomi jctir dffo2 sylibr ) AHIZBBJZBAKZALZBMZNUIBAOUHUJULUHUJ
      DPZEPZAQFPZAQUMUNUOAQAQMFBREBRDBRZGPZUMAQUMMUNUMAQUQMEBSNDBRGBSZUHUJUPURT
      DEFGHABCUAUBUCBUKCUDUEUIBAUFUG $.

    $( Closure law for a group operation.  (Contributed by NM, 10-Oct-2006.)
       (New usage is discouraged.) $)
    grpocl $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      ( cgr wcel cxp wf co wfo grpofo fof syl fovrn syl3an1 ) CFGZDDHZDCIZADGBD
      GABCJDGQRDCKSCDELRDCMNABDDDCOP $.

    $( A group has a left identity element, and every member has a left
       inverse.  (Contributed by NM, 2-Nov-2006.)
       (New usage is discouraged.) $)
    grpolidinv $p |- ( G e. GrpOp ->
         E. u e. X A. x e. X ( ( u G x ) = x /\ E. y e. X ( y G x ) = u ) ) $=
      ( vz cgr wcel cxp wf cv co wceq wral wrex wa w3a isgrpo ibi simp3d ) DHIZ
      EEJEDKZALZBLZDMGLZDMUDUEUFDMDMNGEOBEOAEOZCLZUDDMUDNUEUDDMUHNBEPQAEOCEPZUB
      UCUGUIRABGCHDEFSTUA $.

    $( The base set of a group is not empty.  (Contributed by Szymon
       Jaroszewicz, 3-Apr-2007.)  (New usage is discouraged.) $)
    grpon0 $p |- ( G e. GrpOp -> X =/= (/) ) $=
      ( vu vx vy cgr wcel cv co wceq wrex wa wral c0 wne grpolidinv rexn0 syl )
      AGHDIZEIZAJUAKFIUAAJTKFBLMEBNZDBLBOPEFDABCQUBDBRS $.

    $( A group operation is associative.  (Contributed by NM, 10-Oct-2006.)
       (New usage is discouraged.) $)
    grpoass $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
              ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      ( vx vy vz vu cgr wcel cv co wceq wral w3a oveq1 eqeq12d oveq2 wf wrex wa
      cxp isgrpo ibi simp2d oveq1d oveq2d rspc3v mpan9 ) DKLZGMZHMZDNZIMZDNZUMU
      NUPDNZDNZOZIEPHEPGEPZAELBELCELQABDNZCDNZABCDNZDNZOZULEEUDEDUAZVAJMZUMDNUM
      OUNUMDNVHOHEUBUCGEPJEUBZULVGVAVIQGHIJKDEFUEUFUGUTVFAUNDNZUPDNZAURDNZOVBUP
      DNZABUPDNZDNZOGHIABCEEEUMAOZUQVKUSVLVPUOVJUPDUMAUNDRUHUMAURDRSUNBOZVKVMVL
      VOVQVJVBUPDUNBADTUHVQURVNADUNBUPDRUISUPCOZVMVCVOVEUPCVBDTVRVNVDADUPCBDTUI
      SUJUK $.

    $( Lemma for ~ grpoidinv .  (Contributed by NM, 10-Oct-2006.)
       (New usage is discouraged.) $)
    grpoidinvlem1 $p |- ( ( ( G e. GrpOp /\ ( Y e. X /\ A e. X ) ) /\
                  ( ( Y G A ) = U /\ ( A G A ) = A ) ) -> ( U G A ) = U ) $=
      ( cgr wcel wa co wceq w3a id 3anidm23 grpoass sylan2 oveq1 ad2antrl oveq2
      adantr ad2antll simprl eqtrd 3eqtr3d ) CGHZEDHZADHZIZIZEACJZBKZAACJZAKZIZ
      IZUJACJZEULCJZBACJZBUIUPUQKZUNUHUEUFUGUGLZUSUFUGUTUTMNEAACDFOPTUKUPURKUIU
      MUJBACQRUOUQUJBUMUQUJKUIUKULAECSUAUIUKUMUBUCUD $.

    $( Lemma for ~ grpoidinv .  (Contributed by NM, 10-Oct-2006.)
       (New usage is discouraged.) $)
    grpoidinvlem2 $p |- ( ( ( G e. GrpOp /\ ( Y e. X /\ A e. X ) )
     /\ ( ( U G Y ) = Y /\ ( Y G A ) = U ) )
            -> ( ( A G Y ) G ( A G Y ) ) = ( A G Y ) ) $=
      ( cgr wcel wa co wceq w3a simprr simprl grpocl 3com23 3jca grpoass syldan
      3expb adantr oveq1 adantl simpl eqtr2d id 3anidm13 sylan2 sylan9eqr eqtrd
      eqcomd oveq2d ) CGHZEDHZADHZIZIZBECJZEKZEACJZBKZIZIZAECJZVDCJZAEVDCJZCJZV
      DUQVEVGKZVBUMUPUOUNVDDHZLVHUQUOUNVIUMUNUOMUMUNUONUMUNUOVIUMUOUNVIAECDFOPT
      QAEVDCDFRSUAVCVFEACVCEVFVBUQEUTECJZVFVBVJUREVAVJURKUSUTBECUBUCUSVAUDUEUPU
      MUNUOUNLZVJVFKUNUOVKVKUFUGEAECDFRUHUIUKULUJ $.

    ${
      $d w x y z U $.  $d w y ph $.  $d y ps $.
      grpidinvlem3.2 $e |- ( ph <-> A. x e. X ( U G x ) = x ) $.
      grpidinvlem3.3 $e |- ( ps <-> A. x e. X E. z e. X ( z G x ) = U ) $.
      $( Lemma for ~ grpoidinv .  (Contributed by NM, 11-Oct-2006.)
         (New usage is discouraged.) $)
      grpoidinvlem3 $p |- ( ( ( ( G e. GrpOp /\ U e. X ) /\ ( ph /\ ps ) ) /\
                  A e. X ) -> E. y e. X ( ( y G A ) = U /\ ( A G y ) = U ) ) $=
        ( vw wcel wa cv co wceq wrex wral cgr oveq1 eqeq1d cbvrexv ralbii bitri
        rexbidv rspccva sylanb adantll grpocl adantllr biimpi ad2antrl ad2antrr
        oveq2 3expa eqeq12d rspcva syl2anc adantr pm3.22 an31s adantlr adantlll
        id anim1i grpoidinvlem2 wi 3expb ad2ant2rl anass an32s ex grpoidinvlem1
        sylan2b syldan imp sylan exp43 rexlimdv syl5 mpand exp32 com34 impl mpd
        imp32 eqtr3d ancld reximdva ) HUANZGINZOZABOZOZFINZOZDPZFHQZGRZDISZXAFW
        SHQZGRZOZDISWOWQXBWNBWQXBABWSCPZHQZGRZDISZCITZWQXBBEPZXFHQZGRZEISZCITZX
        JLXNXICIXMXHEDIXKWSRXLXGGXKWSXFHUBUCUDUEUFXIXBCFIXFFRZXHXADIXPXGWTGXFFW
        SHUPUCUGUHUIUJUJWRXAXEDIWRWSINZOZXAXDXRXAXDXRXAOZGXCHQZXCGXRXTXCRZXAXRX
        CINZGXFHQZXFRZCITZYAWNWQXQYBWOWLWQXQYBWMWLWQXQYBFWSHIJUKZUQULULWPYEWQXQ
        AYEWNBAYEKUMUNUOYDYACXCIXFXCRZYCXTXFXCXFXCGHUPYGVFURUSUTVAXSXCXCHQXCRZX
        TGRZXSWLXQWQOZOZGWSHQZWSRZXAOYHXRYKXAWNWQXQYKWOWLWQXQYKWMXQWQWLYKYJWLVB
        VCULULVAXRYMXAWOWQXQYMWNWOXQYMWQAXQYMBAYEXQYMKYDYMCWSIXFWSRZYCYLXFWSXFW
        SGHUPYNVFURUHUIVDVDVEVGFGHIWSJVHUTXRYHYIVIZXAWPWQXQYOWNABWQXQOZYOVIWNAY
        PBYOWNAYPBYOVIWNAYPOOZYBBYOWLYPYBWMAWLWQXQYBYFVJZVKYBBOMPZXCHQZGRZMISZY
        QYOBYBYSXFHQZGRZMISZCITZUUBBXOUUFLXNUUECIXMUUDEMIXKYSRXLUUCGXKYSXFHUBUC
        UDUEUFUUEUUBCXCIYGUUDUUAMIYGUUCYTGXFXCYSHUPUCUGUSVPYQUUAYOMIYQYSINZUUAY
        HYIYQUUGOWLUUGYBOOZUUAYHOYIYQUUGUUHWLYPUUGUUHVIZWMAWLYPYBUUIYRWLYBOUUGU
        UHWLUUGYBUUHWLUUGOYBOUUHWLUUGYBVLUMVMVNVQVKVRXCGHIYSJVOVSVTWAWBWCWDWEWH
        WFVAWGWIVNWJWKWG $.
    $}

    $( Lemma for ~ grpoidinv .  (Contributed by NM, 14-Oct-2006.)
       (New usage is discouraged.) $)
    grpoidinvlem4 $p |- ( ( ( G e. GrpOp /\ A e. X ) /\ E. y e. X
             ( ( y G A ) = U /\ ( A G y ) = U ) ) -> ( A G U ) = ( U G A ) ) $=
      ( cgr wcel wa cv co wceq wrex simpll simplr simpr syl13anc oveq2 sylan9eq
      grpoass oveq1 sylan9req anasss exp31 rexlimdv imp ) DGHZBEHZIZAJZBDKZCLZB
      UJDKZCLZIZAEMBCDKZCBDKZLZUIUOURAEUIUJEHZUOURUIUSIZULUNURUTULIUNUPUMBDKZUQ
      UTULVABUKDKZUPUTUGUHUSUHVAVBLUGUHUSNUGUHUSOZUIUSPVCBUJBDEFTQUKCBDRSUMCBDU
      AUBUCUDUEUF $.

    $( A group has a left and right identity element, and every member has a
       left and right inverse.  (Contributed by NM, 14-Oct-2006.)
       (New usage is discouraged.) $)
    grpoidinv $p |- ( G e. GrpOp -> E. u e. X A. x e. X ( ( ( u G x ) = x /\
         ( x G u ) = x ) /\ E. y e. X ( ( y G x ) = u /\ ( x G y ) = u ) ) ) $=
      ( vz vw wcel cv co wceq wrex wa wral simpl ralimi id adantll adantl oveq2
      cgr grpolidinv eqeq12d rspccva sylan anim1i adantrr adantr ad2antlr simpr
      jca32 biid grpoidinvlem3 sylancom grpoidinvlem4 syl2anc eqtrd jca31 exp32
      ralrimiva reximdvai mpd ) DUBIZCJZGJZDKZVFLZHJVFDKVELHEMZNZGEOZCEMVEAJZDK
      ZVLLZVLVEDKZVLLZNBJZVLDKVELVLVQDKVELNBEMZNZAEOZCEMGHCDEFUCVDVKVTCEVDVEEIZ
      VKVTVDWAVKNZNZVSAEWCVLEIZNZVNVPVRWBWDVNVDVKWDVNWAVKVHGEOZWDVNVJVHGEVHVIPQ
      ZVHVNGVLEVFVLLZVGVMVFVLVFVLVEDUAWHRUDUEUFSSZWEVOVMVLWEVDWDNVRVOVMLWCVDWDV
      DWBPUGWCWDVDWANZWFVIGEOZNNVRWEWJWFWKWCWJWDVDWAWJVKWJRUHUIWBWFVDWDVKWFWAWG
      TUJWBWKVDWDVKWKWAVJVIGEVHVIUKQTUJULWFWKGBHVLVEDEFWFUMWKUMUNUOZBVLVEDEFUPU
      QWIURWLUSVAUTVBVC $.

    $( The left identity element of a group is unique.  Lemma 2.2.1(a) of
       [Herstein] p. 55.  (Contributed by NM, 14-Oct-2006.)
       (New usage is discouraged.) $)
    grpoideu $p |- ( G e. GrpOp -> E! u e. X A. x e. X ( u G x ) = x ) $=
      ( vw vz vy wcel cv co wceq wral weq wa wrex oveq2 id eqeq12d eqeq1d sylib
      cgr wi wreu grpoidinv simpll ralimi cbvralv adantl ad2antlr simpr anbi12d
      oveq1 rexbidv rspcva sylan2 grpoidinvlem4 syldan an32s adantllr ad2ant2rl
      adantll adantr ad2ant2lr 3eqtr3d mpand ralrimiva jca reximdva mpd ralbidv
      ex reu8 sylibr ) CUBIZBJZAJZCKZVQLZADMZFJZVQCKZVQLZADMZBFNZUCZFDMZOZBDPZV
      TBDUDVOVPGJZCKZWJLZWJVPCKWJLZOZHJZWJCKZVPLZWJWOCKZVPLZOZHDPZOZGDMZBDPWIGH
      BCDEUEVOXCWHBDVOVPDIZOZXCWHXEXCOZVTWGXCVTXEXCWLGDMVTXBWLGDWLWMXAUFUGWLVSG
      ADGANZWKVRWJVQWJVQVPCQXGRSUHUAZUIXFWFFDXFWADIZOZVTWDWEXCVTXEXIXHUJXJVTWDO
      ZWEXJXKOWAVPCKZVPWACKZVPWAXJXLXMLZXKVOXCXIXNXDVOXIXCXNVOXIOZXCWOWACKZVPLZ
      WAWOCKZVPLZOZHDPZXNXCXOXAGDMZYAXBXAGDWNXAUKUGXIYBYAVOXAYAGWADGFNZWTXTHDYC
      WQXQWSXSYCWPXPVPWJWAWOCQTYCWRXRVPWJWAWOCUMTULUNUOVBUPHWAVPCDEUQURUSUTVCXE
      XIXKXLVPLZXCXEWDYDXIVTXDWDYDVOWCYDAVPDABNZWBXLVQVPVQVPWACQYERSUOVBVAUTXIV
      TXMWALZXFWDVSYFAWADAFNZVRXMVQWAVQWAVPCQYGRSUOVDVEVLVFVGVHVLVIVJVTWDBFDWEV
      SWCADWEVRWBVQVPWAVQCUMTVKVMVN $.
  $}

  $( A group's range in terms of its domain.  (Contributed by NM, 6-Apr-2008.)
     (New usage is discouraged.) $)
  grporndm $p |- ( G e. GrpOp -> ran G = dom dom G ) $=
    ( cgr wcel crn cxp wfo cdm wceq eqid grpofo wf fof fdm dmeqd dmxpid syl6req
    syl ) ABCADZREZRAFZRAGZGZHARRIJTUBSGRTUASTSRAKUASHSRALSRAMQNROPQ $.

  $( The empty set is not a group.  (Contributed by NM, 25-Apr-2007.)
     (New usage is discouraged.) $)
  0ngrp $p |- -. (/) e. GrpOp $=
    ( c0 cgr wcel wne neirr crn rn0 eqcomi grpon0 mto ) ABCAADAEAAAFAGHIJ $.

  ${
    grprn.1 $e |- G e. GrpOp $.
    grprn.2 $e |- dom G = ( X X. X ) $.
    $( The range of a group operation.  Useful for satisfying group base set
       hypotheses of the form ` X = ran G ` .  (Contributed by NM,
       5-Nov-2006.)  (New usage is discouraged.) $)
    grporn $p |- X = ran G $=
      ( cxp wfn crn wceq wfun cdm cgr wcel wfo eqid grpofo fofun df-fn mpbir2an
      mp2b fofn wa fndmu xpid11 sylib mp2an ) ABBEZFZAAGZUHEZFZBUHHZUGAIZAJUFHA
      KLZUIUHAMZULCAUHUHNOZUIUHAPSDAUFQRUMUNUJCUOUIUHATSUGUJUAUFUIHUKUFUIAUBBUH
      UCUDUE $.
  $}

  ${
    $d g u x G $.  $d g u x X $.
    gidval.1 $e |- X = ran G $.
    $( The value of the identity element of a group.  (Contributed by Mario
       Carneiro, 15-Dec-2013.)  (New usage is discouraged.) $)
    gidval $p |- ( G e. V -> ( GId ` G ) =
             ( iota_ u e. X A. x e. X ( ( u G x ) = x /\ ( x G u ) = x ) ) ) $=
      ( vg wcel cvv cgi cfv cv co wceq wa wral crio crn oveq eqeq1d riotaeqbidv
      elex rneq syl6eqr anbi12d raleqbidv df-gid riotaex fvmpt syl ) CDHCIHCJKB
      LZALZCMZULNZULUKCMZULNZOZAEPZBEQZNCDUBGCUKULGLZMZULNZULUKUTMZULNZOZAUTRZP
      ZBVFQUSIJUTCNZVGURBVFEVHVFCREUTCUCFUDZVHVEUQAVFEVIVHVBUNVDUPVHVAUMULUKULU
      TCSTVHVCUOULULUKUTCSTUEUFUAABGUGURBEUHUIUJ $.
  $}

  ${
    $d g u x $.
    $( ` GId ` is a function.  (Contributed by FL, 5-Feb-2010.)  (Revised by
       Mario Carneiro, 15-Dec-2013.)  (New usage is discouraged.) $)
    fngid $p |- GId Fn _V $=
      ( vg vu vx cvv cv co wceq wa crn wral crio cgi riotaex df-gid fnmpti ) AD
      BEZCEZAEZFQGQPRFQGHCRIZJZBSKLTBSMCBANO $.
  $}

  ${
    $d u x y z A $.
    grpsn.1 $e |- A e. _V $.
    $( TODO - this is useless since we have ablosn - delete this
       if ever get an example of a non-Abelian group to go here. $)
    $( The group operation for the singleton group.  (Contributed by NM,
       4-Nov-2006.)  (New usage is discouraged.) $)
    grposn $p |- { <. <. A , A >. , A >. } e. GrpOp $=
      ( vx vy vz cop csn wf cv wcel wceq co elsn wa oveq2 oveq1 syl6eq sylan9eq
      eqtr4d sylbi snex cxp wf1o opex f1osn f1of ax-mp xpsn feq2i mpbir w3a cfv
      df-ov fvsn eqtri oveq1d sylan9eqr 3impa oveq2d 3impb syl3anb snid isgrpoi
      id a1i ) CDEAAAFZAFGZAAGZAUAVHVHUBZVHVGHVFGZVHVGHZVJVHVGUCVKVFAAAUDZBUEVJ
      VHVGUFUGVIVJVHVGAABBUHUIUJCIZVHJZVMAKZDIZVHJVPAKZEIZVHJVRAKZVMVPVGLZVRVGL
      ZVMVPVRVGLZVGLZKCAMZDAMEAMVOVQVSUKWAAWCVOVQVSWAAKVSVOVQNZWAVTAVGLZAVRAVTV
      GOWEWFAAVGLZAWEVTAAVGVOVQVTAVPVGLZAVMAVPVGPVQWHWGAVPAAVGOWGVFVGULAAAVGUMV
      FAVLBUNUOZQRUPWIQUQURVOVQVSWCAKVOVQVSNZWCAWBVGLZAVMAWBVGPWJWKWGAWJWBAAVGV
      QVSWBAVRVGLZAVPAVRVGPVSWLWGAVRAAVGOWIQRUSWIQRUTSVAABVBZVNVOAVMVGLZVMKWDVO
      WNAVMVOWNWGAVMAAVGOWIQZVOVDSTAVHJVNWMVEVNVOWNAKWDWOTVC $.
  $}

  ${
    $d x y A $.  $d g u x y G $.  $d u x y U $.  $d g u x y X $.
    grpoidval.1 $e |- X = ran G $.
    grpoidval.2 $e |- U = ( GId ` G ) $.
    $( Lemma for ~ grpoidcl and others.  (Contributed by NM, 5-Feb-2010.)
       (Proof shortened by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoidval $p |- ( G e. GrpOp -> U =
                     ( iota_ u e. X A. x e. X ( u G x ) = x ) ) $=
      ( vy cgr wcel cgi cv co wceq wral crio wa wrex simpl ralimi cfv gidval wi
      wreu w3a rgenw a1i grpoidinv reximi syl grpoideu 3jca reupick2 riotabidva
      wb sylan eqtr4d syl5eq ) DIJZCDKUAZBLZALZDMVBNZAEOZBEPZGUSUTVCVBVADMVBNZQ
      ZAEOZBEPVEABDIEFUBUSVDVHBEUSVHVDUCZBEOZVHBERZVDBEUDZUEVAEJVDVHUOUSVJVKVLV
      JUSVIBEVGVCAEVCVFSTUFUGUSVGHLZVBDMVANVBVMDMVANQHERZQZAEOZBERVKAHBDEFUHVPV
      HBEVOVGAEVGVNSTUIUJABDEFUKULVDVHBEUMUPUNUQUR $.

    $( The identity element of a group belongs to the group.  (Contributed by
       NM, 24-Oct-2006.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoidcl $p |- ( G e. GrpOp -> U e. X ) $=
      ( vu vx cgr wcel cv co wceq wral crio grpoidval wreu grpoideu riotacl syl
      eqeltrd ) BHIZAFJGJZBKUBLGCMZFCNZCGFABCDEOUAUCFCPUDCIGFBCDQUCFCRST $.

    $( A group's properties using the explicit identity element.  (Contributed
       by NM, 5-Feb-2010.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoidinv2 $p |- ( ( G e. GrpOp /\ A e. X ) -> ( ( ( U G A ) = A /\
         ( A G U ) = A ) /\ E. y e. X ( ( y G A ) = U /\ ( A G y ) = U ) ) ) $=
      ( vx vu wcel cv co wceq wa wrex wral oveq1 eqeq1d oveq2 anbi12d crab crio
      cgr grpoidval grpoideu riotacl2 syl eqeltrd wi w3a wb simpll ralimi rgenw
      wreu grpoidinv 3jca reupick2 sylan rabbidva eleqtrd eqeq2 rexbidv ralbidv
      a1i elrab sylib simprd id eqeq12d rspccva ) DUCJZCHKZDLZVMMZVMCDLZVMMZNZA
      KZVMDLZCMZVMVSDLZCMZNZAEOZNZHEPZBEJCBDLZBMZBCDLZBMZNZVSBDLZCMZBVSDLZCMZNZ
      AEOZNZVLCEJZWGVLCIKZVMDLZVMMZVMXADLZVMMZNZVTXAMZWBXAMZNZAEOZNZHEPZIEUAZJW
      TWGNVLCXCHEPZIEUAZXMVLCXNIEUBZXOHICDEFGUDVLXNIEUOZXPXOJHIDEFUEZXNIEUFUGUH
      VLXNXLIEVLXLXNUIZIEPZXLIEOZXQUJXAEJXNXLUKVLXTYAXQXTVLXSIEXKXCHEXCXEXJULUM
      UNVEHAIDEFUPXRUQXNXLIEURUSUTVAXLWGICEXACMZXKWFHEYBXFVRXJWEYBXCVOXEVQYBXBV
      NVMXACVMDQRYBXDVPVMXACVMDSRTYBXIWDAEYBXGWAXHWCXACVTVBXACWBVBTVCTVDVFVGVHW
      FWSHBEVMBMZVRWLWEWRYCVOWIVQWKYCVNWHVMBVMBCDSYCVIZVJYCVPWJVMBVMBCDQYDVJTYC
      WDWQAEYCWAWNWCWPYCVTWMCVMBVSDSRYCWBWOCVMBVSDQRTVCTVKUS $.

    $( The identity element of a group is a left identity.  (Contributed by NM,
       24-Oct-2006.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpolid $p |- ( ( G e. GrpOp /\ A e. X ) -> ( U G A ) = A ) $=
      ( vy cgr wcel wa co wceq cv wrex grpoidinv2 simpld ) CHIADIJZBACKALZABCKA
      LZQRSJGMZACKBLATCKBLJGDNGABCDEFOPP $.

    $( The identity element of a group is a right identity.  (Contributed by
       NM, 24-Oct-2006.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grporid $p |- ( ( G e. GrpOp /\ A e. X ) -> ( A G U ) = A ) $=
      ( vx cgr wcel wa co wceq cv wrex grpoidinv2 simplr syl ) CHIADIJBACKALZAB
      CKALZJGMZACKBLATCKBLJGDNZJSGABCDEFORSUAPQ $.
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d y G $.  $d y X $.
    grprcan.1 $e |- X = ran G $.
    $( Right cancellation law for groups.  (Contributed by NM, 26-Oct-2006.)
       (New usage is discouraged.) $)
    grporcan $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      ( vy wcel co wceq wrex adantl oveq1 grpoass adantrr 3eqtr3d oveq2 grporid
      wa ad2antrl cgr wb cv cgi cfv wi eqid grpoidinv2 simpr ad2ant2rl ad2antll
      reximi 3anassrs adantlrl 3exp2 adantllr adantrrl ad2antrr ad2ant2r adantr
      syl imp42 exp45 rexlimdv mpd impbid1 exp43 3imp2 ) DUAHZAEHZBEHZCEHZACDIZ
      BCDIZJZABJZUBZVIVJVKVLVQVIVJSZVKVLSZSZVOVPVTCGUCZDIZDUDUEZJZGEKZVOVPUFZVI
      VLWEVJVKVIVLSWCCDICJCWCDICJSZWACDIWCJZWDSZGEKZSWEGCWCDEFWCUGZUHWJWEWGWIWD
      GEWHWDUIULLVAUJVTWDWFGEVTWAEHZWDVOVPVTWLWDVOSSZSZAWCDIZBWCDIZABWNAWBDIZBW
      BDIZWOWPVTWLVOWQWRJWDVTWLVOSSVMWADIZVNWADIZWQWRVOWSWTJVTWLVMVNWADMUKVTWLW
      SWQJZVOVRVLWLXAVKVIVJVLWLXAACWADEFNUMUNOVTWLWTWRJZVOVIVSWLXBVJVIVKVLWLXBV
      IVKVLWLXBBCWADEFNUOVBUPOPUQWMWQWOJZVTWDXCWLVOWBWCADQTLWMWRWPJZVTWDXDWLVOW
      BWCBDQTLPVRWOAJVSWMAWCDEFWKRURVTWPBJZWMVIVKXEVJVLBWCDEFWKRUSUTPVCVDVEABCD
      MVFVGVH $.
  $}

  ${
    $d y z A $.  $d y z G $.  $d y z U $.  $d y z X $.
    grpinveu.1 $e |- X = ran G $.
    grpinveu.2 $e |- U = ( GId ` G ) $.
    $( The left inverse element of a group is unique.  Lemma 2.2.1(b) of
       [Herstein] p. 55.  (Contributed by NM, 27-Oct-2006.)
       (New usage is discouraged.) $)
    grpoinveu $p |- ( ( G e. GrpOp /\ A e. X ) -> E! y e. X ( y G A ) = U ) $=
      ( vz cgr wcel wa cv co wceq wi wral wrex wreu grpoidinv2 simpl reximi syl
      adantl eqtr3 grporcan syl5ib 3exp2 com24 imp41 an32s exp3a ancld reximdva
      w3a ralrimdva mpd oveq1 eqeq1d reu8 sylibr ) DIJZBEJZKZALZBDMZCNZHLZBDMZC
      NZVDVGNZOZHEPZKZAEQZVFAERVCVFAEQZVNVCCBDMBNBCDMBNKZVFBVDDMCNZKZAEQZKVOABC
      DEFGSVSVOVPVRVFAEVFVQTUAUCUBVCVFVMAEVCVDEJZKZVFVLWAVFVKHEWAVGEJZKVFVIVJVC
      WBVTVFVIKZVJOZVAVBWBVTWDVAVTWBVBWDVAVTWBVBWDWCVEVHNVAVTWBVBUNKVJVEVHCUDVD
      VGBDEFUEUFUGUHUIUJUKUOULUMUPVFVIAHEVJVEVHCVDVGBDUQURUSUT $.

    $( Two ways of saying that an element of a group is the identity element.
       (Contributed by Paul Chapman, 25-Feb-2008.)
       (New usage is discouraged.) $)
    grpoid $p |- ( ( G e. GrpOp /\ A e. X ) ->
                  ( A = U <-> ( A G A ) = A ) ) $=
      ( cgr wcel wa co wceq wb grpoidcl grporcan 3exp2 mpid pm2.43d imp grpolid
      wi eqeq2d bitr3d ) CGHZADHZIZAACJZBACJZKZABKZUFAKUCUDUHUILZUCUDUJUCUDBDHZ
      UDUJTBCDEFMUCUDUKUDUJABACDENOPQRUEUGAUFABCDEFSUAUB $.
  $}

  ${
    $d n x y A $.  $d y B $.  $d y C $.  $d f g n x y G $.  $d f g n x y X $.
    $d f g n x U $.
    grpinvfval.1 $e |- X = ran G $.
    grpinvfval.2 $e |- U = ( GId ` G ) $.
    grpinvfval.3 $e |- N = ( inv ` G ) $.
    $( The inverse function of a group.  (Contributed by NM, 26-Oct-2006.)
       (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoinvfval $p |- ( G e. GrpOp -> N = ( x e. X |->
                     ( iota_ y e. X ( y G x ) = U ) ) ) $=
      ( vg cgr wcel cgn cfv cv co wceq crio cvv cgi cmpt crn rnexg syl5eqel syl
      mptexg rneq syl6eqr oveq fveq2 eqeq12d riotaeqbidv mpteq12dv fvmptg mpdan
      df-ginv syl5eq ) DKLZEDMNZAFBOZAOZDPZCQZBFRZUAZIURVESLZUSVEQURFSLVFURFDUB
      ZSGDKUCUDAFVDSUFUEJDAJOZUBZUTVAVHPZVHTNZQZBVIRZUAVEKSMVHDQZAVIVMFVDVNVIVG
      FVHDUGGUHZVNVLVCBVIFVOVNVJVBVKCUTVAVHDUIVNVKDTNCVHDTUJHUHUKULUMABJUPUNUOU
      Q $.

    $( The inverse of a group element.  (Contributed by NM, 26-Oct-2006.)
       (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoinvval $p |- ( ( G e. GrpOp /\ A e. X ) ->
                    ( N ` A ) = ( iota_ y e. X ( y G A ) = U ) ) $=
      ( vx cgr wcel cfv cv co wceq crio cmpt grpoinvfval fveq1d oveq2 riotabidv
      eqeq1d eqid riotaex fvmpt sylan9eq ) DKLZBFLBEMBJFANZJNZDOZCPZAFQZRZMUIBD
      OZCPZAFQZUHBEUNJACDEFGHISTJBUMUQFUNUJBPZULUPAFURUKUOCUJBUIDUAUCUBUNUDUPAF
      UEUFUG $.
  $}

  ${
    $d y A $.  $d y G $.  $d y X $.
    grpinvcl.1 $e |- X = ran G $.
    grpinvcl.2 $e |- N = ( inv ` G ) $.
    $( A group element's inverse is a group element.  (Contributed by NM,
       27-Oct-2006.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoinvcl $p |- ( ( G e. GrpOp /\ A e. X ) -> ( N ` A ) e. X ) $=
      ( vy cgr wcel wa cfv cv co cgi wceq crio eqid grpoinvval wreu grpoinveu
      riotacl syl eqeltrd ) BHIADIJZACKGLABMBNKZOZGDPZDGAUEBCDEUEQZFRUDUFGDSUGD
      IGAUEBDEUHTUFGDUAUBUC $.
  $}

  ${
    $d y A $.  $d y G $.  $d y N $.  $d y U $.  $d y X $.
    grpinv.1 $e |- X = ran G $.
    grpinv.2 $e |- U = ( GId ` G ) $.
    grpinv.3 $e |- N = ( inv ` G ) $.
    $( The properties of a group element's inverse.  (Contributed by NM,
       27-Oct-2006.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoinv $p |- ( ( G e. GrpOp /\ A e. X ) ->
                 ( ( ( N ` A ) G A ) = U /\ ( A G ( N ` A ) ) = U ) ) $=
      ( vy cgr wcel wa cfv co wceq cv crab crio simprd eqeq1d wreu riotacl2 syl
      grpoinvval grpoinveu eqeltrd wi wral wrex w3a simpl rgenw grpoidinv2 3jca
      wb a1i reupick2 sylan rabbidva eleqtrd oveq1 oveq2 anbi12d elrab sylib )
      CJKAEKLZADMZEKZVGACNZBOZAVGCNZBOZLZVFVGIPZACNZBOZAVNCNZBOZLZIEQZKVHVMLVFV
      GVPIEQZVTVFVGVPIERZWAIABCDEFGHUDVFVPIEUAZWBWAKIABCEFGUEZVPIEUBUCUFVFVPVSI
      EVFVSVPUGZIEUHZVSIEUIZWCUJVNEKVPVSUOVFWFWGWCWFVFWEIEVPVRUKULUPVFBACNAOABC
      NAOLWGIABCEFGUMSWDUNVPVSIEUQURUSUTVSVMIVGEVNVGOZVPVJVRVLWHVOVIBVNVGACVATW
      HVQVKBVNVGACVBTVCVDVES $.

    $( The left inverse of a group element.  (Contributed by NM, 27-Oct-2006.)
       (New usage is discouraged.) $)
    grpolinv $p |- ( ( G e. GrpOp /\ A e. X ) -> ( ( N ` A ) G A ) = U ) $=
      ( cgr wcel wa cfv co wceq grpoinv simpld ) CIJAEJKADLZACMBNAQCMBNABCDEFGH
      OP $.

    $( The right inverse of a group element.  (Contributed by NM,
       27-Oct-2006.)  (New usage is discouraged.) $)
    grporinv $p |- ( ( G e. GrpOp /\ A e. X ) -> ( A G ( N ` A ) ) = U ) $=
      ( cgr wcel wa cfv co wceq grpoinv simprd ) CIJAEJKADLZACMBNAQCMBNABCDEFGH
      OP $.

    $( The inverse of a group element expressed in terms of the identity
       element.  (Contributed by NM, 27-Oct-2006.)
       (New usage is discouraged.) $)
    grpoinvid1 $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                    ( ( N ` A ) = B <-> ( A G B ) = U ) ) $=
      ( wcel w3a wceq co wa oveq2 adantl 3adant3 adantr eqtr3d syldan grpoinvcl
      cgr cfv grporinv grpolinv oveq1d adantrr simprl simprr 3jca grpoass 3impb
      grpolid 3adant2 grporid 3eqtr3rd impbida ) DUBJZAFJZBFJZKZAEUCZBLZABDMZCL
      ZVAVCNAVBDMZVDCVCVFVDLVAVBBADOPVAVFCLZVCURUSVGUTACDEFGHIUDQRSVAVENVBVDDMZ
      VBCDMZBVBVEVHVILVAVDCVBDOPVAVHBLVEVACBDMZVHBVAVBADMZBDMZVJVHURUSVLVJLUTUR
      USNVKCBDACDEFGHIUEUFQURUSUTVLVHLZURUSUTNZVBFJZUSUTKVMURVNNVOUSUTURUSVOUTA
      DEFGIUAZUGURUSUTUHURUSUTUIUJVBABDFGUKTULSURUTVJBLUSBCDFGHUMUNSRVAVIVBLZVE
      URUSVQUTURUSVOVQVPVBCDFGHUOTQRUPUQ $.

    $( The inverse of a group element expressed in terms of the identity
       element.  (Contributed by NM, 27-Oct-2006.)
       (New usage is discouraged.) $)
    grpoinvid2 $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                    ( ( N ` A ) = B <-> ( B G A ) = U ) ) $=
      ( cgr wcel w3a wceq co wa oveq1 adantl 3adant3 adantr syldan cfv grpolinv
      eqtr3d grpoinvcl grpolid eqcomd simprr simprl adantrr 3jca 3impb grporinv
      grpoass oveq2d grporid 3adant2 3eqtrd 3eqtr2d impbida ) DJKZAFKZBFKZLZAEU
      AZBMZBADNZCMZVCVEOVDADNZVFCVEVHVFMVCVDBADPQVCVHCMZVEUTVAVIVBACDEFGHIUBRSU
      CVCVGOVDCVDDNZVFVDDNZBVCVDVJMVGVCVJVDUTVAVJVDMZVBUTVAVDFKZVLADEFGIUDZVDCD
      FGHUETRUFSVGVKVJMVCVFCVDDPQVCVKBMVGVCVKBAVDDNZDNZBCDNZBUTVAVBVKVPMZUTVAVB
      OZVBVAVMLVRUTVSOVBVAVMUTVAVBUGUTVAVBUHUTVAVMVBVNUIUJBAVDDFGUMTUKUTVAVPVQM
      VBUTVAOVOCBDACDEFGHIULUNRUTVBVQBMVABCDFGHUOUPUQSURUS $.
  $}

  ${
    grpinvid.1 $e |- U = ( GId ` G ) $.
    grpinvid.2 $e |- N = ( inv ` G ) $.
    $( The inverse of the identity element of a group.  (Contributed by NM,
       4-Dec-2006.)  (New usage is discouraged.) $)
    grpoinvid $p |- ( G e. GrpOp -> ( N ` U ) = U ) $=
      ( cgr wcel cfv wceq co eqid grpoidcl grpolid mpdan wb grpoinvid1 mpd3an23
      crn mpbird ) BFGZACHAIZAABJAIZTABRZGZUBABUCUCKZDLZAABUCUEDMNTUDUDUAUBOUFU
      FAAABCUCUEDEPQS $.
  $}

  ${
    grplcan.1 $e |- X = ran G $.
    $( Left cancellation law for groups.  (Contributed by NM, 27-Oct-2006.)
       (New usage is discouraged.) $)
    grpolcan $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      ( wcel w3a wa co wceq cfv oveq2 eqid adantlr oveq1d adantrl simprr adantr
      3eqtr3d cgr cgn adantl cgi grpolinv grpoinvcl simprl 3jca grpoass anassrs
      wi syldan grpolid adantrr exp53 3imp2 impbid1 ) DUAGZAEGZBEGZCEGZHICADJZC
      BDJZKZABKZURUSUTVAVDVEUKURUSUTVAVDVEURUSIZUTVAIZIZVDICDUBLZLZVBDJZVJVCDJZ
      ABVDVKVLKVHVBVCVJDMUCVHVKAKZVDVFVAVMUTVFVAIZVJCDJZADJZDUDLZADJZVKAVNVOVQA
      DURVAVOVQKZUSCVQDVIEFVQNZVINZUEZOPURUSVAVPVKKZURUSVAIZVJEGZVAUSHWCURWDIWE
      VAUSURVAWEUSCDVIEFWAUFZQURUSVARURUSVAUGUHVJCADEFUIULUJVFVRAKVAAVQDEFVTUMS
      TQSVHVLBKZVDURVGWGUSURVGIZVOBDJZVQBDJZVLBWHVOVQBDURVAVSUTWBQPURVGWEVAUTHW
      IVLKWHWEVAUTURVAWEUTWFQURUTVARURUTVAUGUHVJCBDEFUIULURUTWJBKVABVQDEFVTUMUN
      TOSTUOUPABCDMUQ $.
  $}

  ${
    $d a b c .+ $.  $d a b c K $.
    grp2grp.a $e |- ( Base ` K ) = ran .+ $.
    grp2grp.p $e |- ( +g ` K ) = .+ $.
    grp2grp.g $e |- .+ e. GrpOp $.
    $( Convert a group operation to a group structure.  (Contributed by NM,
       25-Oct-2012.)  (Revised by Mario Carneiro, 6-Jan-2015.)
       (New usage is discouraged.) $)
    grpo2grp $p |- K e. Grp $=
      ( va vb vc crn cv cgn cfv cgi cbs eqcomi wcel co eqid wceq mpan cgr ax-mp
      cplusg grpocl mp3an1 grpoass grpoidcl grpolid grpoinvcl grpolinv isgrpi
      w3a ) FGHAIZABFJZAKLZLZAMLZBNLUMCOBUCLADOAUAPZUNUMPZGJZUMPZUNUTAQZUMPEUNU
      TAUMUMRZUDUEURUSVAHJZUMPULVBVDAQUNUTVDAQAQSEUNUTVDAUMVCUFTURUQUMPEUQAUMVC
      UQRZUGUBURUSUQUNAQUNSEUNUQAUMVCVEUHTURUSUPUMPEUNAUOUMVCUORZUITURUSUPUNAQU
      QSEUNUQAUOUMVCVEVFUJTUK $.
  $}

  $( (Commented out since it's not in use and not worth repairing, seeing as
     GrpOp is being deprecated. -MC 6-Jan-2015)
  @{
    @d a b c e m x y A @.  @d a b c e m x y G @.  @d a b c e m x y P @.
    @d a e m K @.
    grp2grpo.a @e |- A = ( Base ` K ) @.
    grp2grpo.p @e |- .+ = ( +g ` K ) @.
    grp2grpo.g @e |- G = ( x e. A , y e. A |-> ( x .+ y ) ) @.
    @( Convert a group structure to a group operation and vice-versa. @)
    grp2grpo @p |- ( K e. Grp <-> G e. GrpOp ) @=
      ( va vb vc ve vm wcel co wral wceq wa wrex cgrp cgr crn cxp wf wb cv ovex
      wfn fnmpt2i a1i isgrp2 simplbi simpl ralimi rr19.3v sylib syl oveq1 oveq2
      ovmpt2 eleq1d ralbidva ralbiia sylibr ffnov sylanbrc wfo grplidinv eqeq1d
      ancoms rexbidva adantl anbi12d rexbiia r19.12 eqcom eqeq2d rspcev syl5bi
      adantrd reximdv ralimia 3syl foov forn eqcomd xpeq12 anidms feq23 mpancom
      ex mpbid fndmu sylancr xpid11 biimpi adantr cbvral2v ad2antlr oveq1d rsp2
      ffn sylanbr sylan simplrl rspc2v impcom anassrs adantlrl syl2anc adantll
      imp eqtrd oveq2d eqeq12d 2ralbidva sylbi biimpa jca biimpri sylbir impbii
      biimpar rr19.28v ralbii r19.26-2 bitri 3bitr4i anbi12i eleq2 anbi1d rexeq
      raleqbi1dv anbi2d cvv cbs eqeltri isgrpo2 ibi rexeqbi1dv syl5bbr ibar w3a
      bitrd syl5bb cmpt2 cfv fvex mpt2ex eqid ax-mp 3anass bitr2i syl6bb biimpd
      syl5rbb 3impib ) FUAOZEUBOZUUSUUTUUSEUCZUVAUDZUVAEUEZUUSUUTUFUUSCCUDZCEUE
      ZUVCUUSEUVDUIZJUGZKUGZEPZCOZKCQZJCQZUVEUVFUUSABCCAUGZBUGZDPZEIUVMUVNDUHUJ
      ZUKUUSUVGUVHDPZCOZKCQZJCQZUVLUUSUVRUVQLUGZDPZUVGUVHUWADPZDPZRZSZLCQZKCQZJ
      CQZUVTUUSUWIMUGZUVGDPZUVGRZNUGZUVGDPZUWJRZNCTZSZJCQZMCTZCDMNFJKLGHULZUMUW
      HUVSJCUWHUVRLCQZKCQUVSUWGUXAKCUWFUVRLCUVRUWEUNUOUOUVRKLCUPUQUOURUVKUVSJCU
      VGCOZUVJUVRKCUXBUVHCOZSZUVIUVQCABUVGUVHCCUVOUVQEUVGUVNDPZUVMUVGUVNDUSZUVN
      UVHUVGDUTIUVGUVHDUHVAZVBZVCVDZVEJKCCCEVFVGZUUSCUVARZUVEUVCUFZUUSUVACUUSUV
      DCEVHZUVACRUUSUVEUVGUWJUVHEPZRZKCTZMCTZJCQZUXMUXJUUSUWJUVGEPZUVGRZUWMUVGE
      PZUWJRZNCTZSZJCQZMCTZUYDMCTZJCQUXRUUSUWSUYFJNMCDFGHVIUYEUWRMCUWJCOZUYDUWQ
      JCUYHUXBSZUXTUWLUYCUWPUYIUXSUWKUVGABUWJUVGCCUVOUWKEUWJUVNDPUVMUWJUVNDUSUV
      NUVGUWJDUTIUWJUVGDUHVAVJUXBUYCUWPUFUYHUXBUYBUWONCUXBUWMCOZSUYAUWNUWJUYJUX
      BUYAUWNRABUWMUVGCCUVOUWNEUWMUVNDPUVMUWMUVNDUSUVNUVGUWMDUTIUWMUVGDUHVAVKVJ
      VLVMVNVCVOZVEUYDMJCCVPUYGUXQJCUXBUYDUXPMCUXBUXTUXPUYCUXTUVGUXSRZUXBUXPUXS
      UVGVQUXBUYLUXPUXOUYLKUVGCUVHUVGRUXNUXSUVGUVHUVGUWJEUTVRVSWLVTWAWBWCWDMKJC
      CCEWEVGUVDCEWFURWGUVDUVBRZUXKUXLUXKUYMCUVACUVAWHWIUVDCUVBUVAEWJWKURWMUVCU
      USUVCUVIUVAOZUVIUWAEPZUVGUVHUWAEPZEPZRZSZLUVAQZKUVAQZJUVAQZUXTUYBNUVATZSZ
      JUVAQZMUVATZSZSZUUTUUSUWIUWSSZUVCVUHUWTUVCVUIVUGVUHUVCUXKVUIVUGUFUVCUYMUX
      KUVCUVFEUVBUIUYMUVPUVBUVAEXCUVDUVBEWNWOCUVAWPUQVUIUVJUYRSZLCQZKCQZJCQZUYF
      SUXKVUGVUMUWIUYFUWSUVLUYRLCQZKCQJCQZSZUVTUWELCQZKCQJCQZSZVUMUWIVUPVUSVUPU
      VTVURUVLUVTVUOUVLUVTUXIWQWRUVLVUOVURUVLUVMUVNEPZCOZBCQACQZVUOVURUFZUVJVVA
      UVMUVHEPZCOJKABCCUVGUVMRUVIVVDCUVGUVMUVHEUSVBUVHUVNRVVDVUTCUVHUVNUVMEUTVB
      WSZVVBVUNVUQJKCCVVBUXDSZUYRUWELCVVFUWACOZSZUYOUWBUYQUWDVVHUYOUVQUWAEPZUWB
      VVHUVIUVQUWAEUXDUVIUVQRVVBVVGUXGWTXAVVFUVRVVGVVIUWBRVVBUVLUXDUVRVVEUVLUXD
      SUVJUVRUVLUXDUVJUVJJKCCXBXMUXDUVJUVRUFUVLUXHVMWMXDABUVQUWACCUVOUWBEUVQUVN
      DPUVMUVQUVNDUSUVNUWAUVQDUTIUVQUWADUHVAXEXNVVHUYQUVGUYPDPZUWDVVHUXBUYPCOZU
      YQVVJRVVBUXBUXCVVGXFVVBUXCVVGVVKUXBVVBUXCVVGVVKUXCVVGSVVBVVKVVAVVKUVHUVNE
      PZCOABUVHUWACCUVMUVHRVUTVVLCUVMUVHUVNEUSVBUVNUWARVVLUYPCUVNUWAUVHEUTVBXGX
      HXIXJABUVGUYPCCUVOVVJEUXEUXFUVNUYPUVGDUTIUVGUYPDUHVAXKVVHUYPUWCUVGDUXDVVG
      UYPUWCRZVVBUXCVVGVVMUXBABUVHUWACCUVOUWCEUVHUVNDPUVMUVHUVNDUSUVNUWAUVHDUTI
      UVHUWADUHVAXLXLXOXNXPVCXQXRZXSXTVUSUVLVUOUVTUVLVURUVLUVTUXIYAWRUVTVUOVURU
      VTUVLVVCUXIVVNYBYDXTYCVUMUVJVUNSKCQZJCQVUPVULVVOJCUVJUYRKLCYEYFUVJVUNJKCC
      YGYHUWIUVRVUQSKCQZJCQVUSUWHVVPJCUVRUWEKLCYEYFUVRVUQJKCCYGYHYIUYKYJUXKVUMV
      UBUYFVUFVULVUAJCUVAVUKUYTKCUVAVUJUYSLCUVAUXKUVJUYNUYRCUVAUVIYKYLYNYNYNUYE
      VUEMCUVAUYDVUDJCUVAUXKUYCVUCUXTUYBNCUVAYMYOYNUUAVNUUBURZUVCVUGUUCUUEUUFUU
      TUVCVUBVUFUUDZVUHEYPOUUTVVRUFEABCCUVOUUGYPIABCCUVOCFYQUUHYPGFYQUUIYRZVVSU
      UJYRJKLMYPNEUVAUVAUUKZYSUULUVCVUBVUFUUMUUNUUOURYTUUTVVRUUSUUTVVRJKLMUBNEU
      VAVVTYSYTUVCVUBVUFUUSUVCVUGUUSUUSVUIUVCVUGUWTVVQUUQUUPUURURYC @.
      @( [29-Oct-2012] @)
  @}
  $)

  ${
    $d u v w x y z G $.  $d u v w x y z X $.  $d u v w x y z ph $.
    isgrp2d.1 $e |- ( ph -> X e. V ) $.
    isgrp2d.2 $e |- ( ph -> X =/= (/) ) $.
    isgrp2d.3 $e |- ( ph -> G : ( X X. X ) --> X ) $.
    isgrp2d.4 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) ) ->
                      ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $.
    isgrp2d.5 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
                      E. z e. X ( z G x ) = y ) $.
    isgrp2d.6 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
                     E. z e. X ( x G z ) = y ) $.
    $( An alternate way to show a group operation.  Exercise 1 of [Herstein]
       p. 57.  (Contributed by Mario Carneiro, 12-May-2014.)
       (New usage is discouraged.) $)
    isgrp2d $p |- ( ph -> G e. GrpOp ) $=
      ( vu wcel co wceq wral wrex wa vw vv cgr crn cxp wf cv c0 adantr anass1rs
      wfo wne eqcom rexbii sylib ralrimiva r19.2z syl2anc foov sylanbrc xpeq12d
      forn syl feq23d mpbird ralrimivvva raleqdv raleqbidv wex simpr ralrimivva
      n0 jca weq oveq2 eqeq1d rexbidv eqeq2 oveq1 cbvrexv syl6bb rspc2v ralbidv
      sylc rspccva sylan ad2ant2r ad3antrrr simplr simpllr simprr oveq1d oveq2d
      wi eqeq12d rspc3v syl3anc simprl eqtr3d anassrs syl5ibcom adantrl adantlr
      rexlimdva rspcv adantllr adantrr expr ralrimdva reximdva exlimddv rexeqdv
      mpd id anbi2d rexeqbidv cvv w3a wb xpexg fex eqid isgrpo mpbir3and ) AEUC
      OZEUDZYFUEZYFEUFZBUGZCUGZEPZDUGZEPZYIYJYLEPZEPZQZDYFRZCYFRZBYFRZNUGZYIEPZ
      YIQZYJYIEPZYTQZCYFSZTZBYFRZNYFSZAYHGGUEZGEUFZJAYGYFUUIGEAYFGYFGAUUIGEUKZY
      FGQAUUJYJYIYLEPZQZDGSZBGSZCGRUUKJAUUOCGAYJGOZTZGUHULZUUNBGRUUOAUURUUPIUIU
      UQUUNBGUUQYIGOZTUULYJQZDGSZUUNAUUSUUPUVAMUJUUTUUMDGUULYJUMUNUOUPUUNBGUQUR
      UPBDCGGGEUSUTUUIGEVBVCZUVBVAUVBVDVEAYSYPDGRZCGRZBGRZAYPBCDGGGKVFZAYRUVDBY
      FGUVBAYQUVCCYFGUVBAYPDYFGUVBVGVHVHVEAUUHUUBUUDCGSZTZBGRZNGSZAUAUGZGOZUVJU
      AAUURUVLUAVIIUAGVLUOAUVLTZYTUVKEPZUVKQZNGSZUVJUVMUVLUVLTYLYIEPZYJQZDGSZCG
      RZBGRZUVPUVMUVLUVLAUVLVJZUWBVMAUWAUVLAUVSBCGGLVKUIUVSUVPYLUVKEPZYJQZDGSZB
      CUVKUVKGGBUAVNZUVRUWDDGUWFUVQUWCYJYIUVKYLEVOVPVQCUAVNZUWEUWCUVKQZDGSUVPUW
      GUWDUWHDGYJUVKUWCVRVQUWHUVODNGDNVNUWCUVNUVKYLYTUVKEVSVPVTWAWBWDUVMUVOUVIN
      GUVMYTGOZTZUVOUVHBGUWJUUSUVOUVHUWJUUSUVOTTZUUBUVGUWKUVKUBUGZEPZYIQZUBGSZU
      UBUVMUUSUWOUWIUVOUVMUVKYLEPZYJQZDGSZCGRZUUSUWOAUVACGRZBGRUVLUWSAUVABCGGMV
      KUWTUWSBUVKGUWFUVAUWRCGUWFUUTUWQDGUWFUULUWPYJYIUVKYLEVSVPVQWCWEWFUWRUWOCY
      IGCBVNZUWRUWPYIQZDGSUWOUXAUWQUXBDGYJYIUWPVRVQUXBUWNDUBGDUBVNZUWPUWMYIYLUW
      LUVKEVOZVPVTWAWEWFWGUWJUVOUWOUUBWNUUSUWJUVOTZUWNUUBUBGUXEUWLGOZTYTUWMEPZU
      WMQZUWNUUBUWJUVOUXFUXHUWJUVOUXFTZTZUVNUWLEPZUXGUWMUXJUVEUXKUXGQZAUVEUVLUW
      IUXIUVFWHUXJUWIUVLUXFUVEUXLWNUVMUWIUXIWIAUVLUWIUXIWJUWJUVOUXFWKYPUXLYTYJE
      PZYLEPZYTYNEPZQUVNYLEPZYTUWPEPZQBCDYTUVKUWLGGGBNVNZYMUXNYOUXOUXRYKUXMYLEY
      IYTYJEVSWLYIYTYNEVSWOUWGUXNUXPUXOUXQUWGUXMUVNYLEYJUVKYTEVOWLUWGYNUWPYTEYJ
      UVKYLEVSWMWOUXCUXPUXKUXQUXGYLUWLUVNEVOUXCUWPUWMYTEUXDWMWOWPWQXMUXJUVNUVKU
      WLEUWJUVOUXFWRWLWSWTUWNUXGUUAUWMYIUWMYIYTEVOUWNXNWOXAXDXBXMUWJUUSUVGUVOAU
      WIUUSUVGUVLAUWITUUSTZUVQYTQZDGSZUVGUXSUWIUVTUYAAUWIUUSWIAUUSUVTUWIAUUSTUV
      SCGAUUSUUPUVSLWTUPXCUVSUYACYTGCNVNUVRUXTDGYJYTUVQVRVQXEWDUXTUUDDCGDCVNUVQ
      UUCYTYLYJYIEVSVPVTUOXFXGVMXHXIXJXMXKAUUGUVINYFGUVBAUUFUVHBYFGUVBAUUEUVGUU
      BAUUDCYFGUVBXLXOVHXPVEAEXQOZYEYHYSUUHXRXSAUUJUUIXQOZUYBJAGFOZUYDUYCHHGGFF
      XTURUUIGXQEYAURBCDNXQEYFYFYBYCVCYD $.
  $}

  ${
    $d x y z G $.  $d x y z X $.
    isgrp2i.1 $e |- X e. _V $.
    isgrp2i.2 $e |- X =/= (/) $.
    isgrp2i.3 $e |- G : ( X X. X ) --> X $.
    isgrp2i.4 $e |- ( ( x e. X /\ y e. X /\ z e. X ) ->
                    ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $.
    isgrp2i.5 $e |- ( ( x e. X /\ y e. X ) -> E. z e. X ( z G x ) = y ) $.
    isgrp2i.6 $e |- ( ( x e. X /\ y e. X ) -> E. z e. X ( x G z ) = y ) $.
    $( An alternate way to show a group operation.  Exercise 1 of [Herstein]
       p. 57.  (Contributed by NM, 5-Dec-2006.)  (Revised by Mario Carneiro,
       12-May-2014.)  (New usage is discouraged.) $)
    isgrp2i $p |- G e. GrpOp $=
      ( wcel wtru cvv a1i cv co wceq adantl wrex cgr c0 wne cxp wf isgrp2d trud
      w3a wa ) DUALMABCDNEENLMFOEUBUCMGOEEUDEDUEMHOAPZELZBPZELZCPZELUHUJULDQUND
      QUJULUNDQDQRMISUKUMUIZUNUJDQULRCETMJSUOUJUNDQULRCETMKSUFUG $.
  $}

  ${
    $d x y z G $.  $d x y N $.  $d x y z X $.
    grpasscan1.1 $e |- X = ran G $.
    grpasscan1.2 $e |- N = ( inv ` G ) $.
    $( An associative cancellation law for groups.  (Contributed by Paul
       Chapman, 25-Feb-2008.)  (New usage is discouraged.) $)
    grpoasscan1 $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                          ( A G ( ( N ` A ) G B ) ) = B ) $=
      ( cgr wcel w3a cfv co cgi wceq eqid grporinv 3adant3 oveq1d wa wi grpoass
      grpoinvcl 3exp2 imp mpd 3impia grpolid 3adant2 3eqtr3d ) CHIZAEIZBEIZJZAA
      DKZCLZBCLZCMKZBCLZAUNBCLCLZBUMUOUQBCUJUKUOUQNULAUQCDEFUQOZGPQRUJUKULUPUSN
      ZUJUKSUNEIZULVATZACDEFGUBUJUKVBVCTUJUKVBULVAAUNBCEFUAUCUDUEUFUJULURBNUKBU
      QCEFUTUGUHUI $.

    $( An associative cancellation law for groups.  (Contributed by Paul
       Chapman, 17-Apr-2009.)  (New usage is discouraged.) $)
    grpoasscan2 $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                       ( ( A G ( N ` B ) ) G B ) = A ) $=
      ( cgr wcel w3a cfv cgi wceq simp1 simp2 grpoinvcl 3adant2 simp3 grpoass
      co syl13anc eqid grpolinv oveq2d grporid 3adant3 3eqtrd ) CHIZAEIZBEIZJZA
      BDKZCTBCTZAULBCTZCTZACLKZCTZAUKUHUIULEIZUJUMUOMUHUIUJNUHUIUJOUHUJURUIBCDE
      FGPQUHUIUJRAULBCEFSUAUKUNUPACUHUJUNUPMUIBUPCDEFUPUBZGUCQUDUHUIUQAMUJAUPCE
      FUSUEUFUG $.

    $( Double inverse law for groups.  Lemma 2.2.1(c) of [Herstein] p. 55.
       (Contributed by NM, 27-Oct-2006.)  (New usage is discouraged.) $)
    grpo2inv $p |- ( ( G e. GrpOp /\ A e. X ) -> ( N ` ( N ` A ) ) = A ) $=
      ( cgr wcel wa cfv wceq cgi grpoinvcl eqid grporinv syldan grpolinv eqtr4d
      co w3a wb simpr 3jca grpolcan mpbid ) BGHZADHZIZACJZUICJZBSZUIABSZKZUJAKZ
      UHUKBLJZULUFUGUIDHZUKUOKABCDEFMZUIUOBCDEUONZFOPAUOBCDEURFQRUFUGUJDHZUGUPT
      UMUNUAUHUSUGUPUFUGUPUSUQUIBCDEFMPUFUGUBUQUCUJAUIBDEUDPUE $.

    $( Mapping of the inverse function of a group.  (Contributed by NM,
       29-Mar-2008.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpoinvf $p |- ( G e. GrpOp -> N : X -1-1-onto-> X ) $=
      ( vx vy cgr wcel wfn crn wceq cv cfv wral eqid grpoinvcl grpo2inv fveq2
      wa wi wf1o co cgi crio cmpt riotaex fnmpti grpoinvfval fneq1d mpbiri wrex
      cab fnrnfv syl eqcomd eqeq2d rspcev syl2anc ex simpr adantr eqeltrd exp31
      rexlimdv impbid abbi2dv eqtr4d eqeqan12d anandis syl5ib ralrimivva dff1o6
      wb syl3anbrc ) AHIZBCJZBKZCLFMZBNZGMZBNZLZVSWALZUAZGCOFCOCCBUBVPVQFCWAVSA
      UCAUDNZLZGCUEZUFZCJFCWHWIWGGCUGWIPUHVPCBWIFGWFABCDWFPEUIUJUKZVPVRWAVTLZFC
      ULZGUMZCVPVQVRWMLWJFGCBUNUOVPWLGCVPWACIZWLVPWNWLVPWNTZWBCIWAWBBNZLZWLWAAB
      CDEQWOWPWAWAABCDERZUPWKWQFWBCVSWBLVTWPWAVSWBBSUQURUSUTVPWKWNFCVPVSCIZWKWN
      VPWSTZWKTWAVTCWTWKVAWTVTCIWKVSABCDEQVBVCVDVEVFVGVHVPWEFGCCWCVTBNZWPLZVPWS
      WNTTWDVTWBBSVPWSWNXBWDVNWTWOXAVSWPWAVSABCDERWRVIVJVKVLFGCCBVMVO $.

    $( The inverse of the group operation reverses the arguments.  Lemma
       2.2.1(d) of [Herstein] p. 55.  (Contributed by NM, 27-Oct-2006.)
       (New usage is discouraged.) $)
    grpoinvop $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                   ( N ` ( A G B ) ) = ( ( N ` B ) G ( N ` A ) ) ) $=
      ( cgr wcel co cfv wceq grpoinvcl 3adant2 3adant3 syl3anc grpoass syl13anc
      grpocl grporinv w3a simp1 simp2 eqid oveq1d grpolid syldan 3eqtr3d oveq2d
      cgi simp3 3eqtrd wb grpoinvid1 mpbird ) CHIZAEIZBEIZUAZABCJZDKBDKZADKZCJZ
      LZUTVCCJZCUJKZLZUSVEABVCCJZCJZAVBCJZVFUSUPUQURVCEIZVEVILUPUQURUBZUPUQURUC
      UPUQURUKZUSUPVAEIZVBEIZVKVLUPURVNUQBCDEFGMNZUPUQVOURACDEFGMZOZVAVBCEFSPZA
      BVCCEFQRUSVHVBACUSBVACJZVBCJZVFVBCJZVHVBUSVTVFVBCUPURVTVFLUQBVFCDEFVFUDZG
      TNUEUSUPURVNVOWAVHLVLVMVPVRBVAVBCEFQRUPUQWBVBLZURUPUQVOWDVQVBVFCEFWCUFUGO
      UHUIUPUQVJVFLURAVFCDEFWCGTOULUSUPUTEIVKVDVGUMVLABCEFSVSUTVCVFCDEFWCGUNPUO
      $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d f g x y z G $.  $d f g x y z N $.
    $d f g x y z X $.
    grpdiv.1 $e |- X = ran G $.
    grpdiv.2 $e |- N = ( inv ` G ) $.
    grpdiv.3 $e |- D = ( /g ` G ) $.
    $( Group division (or subtraction) operation.  (Contributed by NM,
       15-Feb-2008.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpodivfval $p |- ( G e. GrpOp -> D = ( x e. X , y e. X |->
                       ( x G ( N ` y ) ) ) ) $=
      ( vg cgr wcel cgs cfv cv co cmpt2 cvv wceq cgn crn rnexg syl5eqel syl2anc
      mpt2exga rneq syl6eqr id eqidd fveq1d oveq123d mpt2eq123dv df-gdiv fvmptg
      fveq2 mpdan syl5eq ) DKLZCDMNZABFFAOZBOZENZDPZQZIURVDRLZUSVDSURFRLZVFVEUR
      FDUAZRGDKUBUCZVHABFFVCRRUEUDJDABJOZUAZVJUTVAVITNZNZVIPZQVDKRMVIDSZABVJVJV
      MFFVCVNVJVGFVIDUFGUGZVOVNUTUTVLVBVIDVNUHVNUTUIVNVAVKEVNVKDTNEVIDTUOHUGUJU
      KULABJUMUNUPUQ $.

    $( Group division (or subtraction) operation value.  (Contributed by NM,
       15-Feb-2008.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    grpodivval $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                   ( A D B ) = ( A G ( N ` B ) ) ) $=
      ( vx vy cgr wcel co cfv wceq wa cv cmpt2 grpodivfval oveqd oveq1 sylan9eq
      fveq2 oveq2d eqid ovex ovmpt2 3impb ) DLMZAFMZBFMZABCNZABEOZDNZPUJUKULQUM
      ABJKFFJRZKRZEOZDNZSZNUOUJCUTABJKCDEFGHITUAJKABFFUSUOUTAURDNUPAURDUBUQBPUR
      UNADUQBEUDUEUTUFAUNDUGUHUCUI $.

    $( Group division by an inverse.  (Contributed by NM, 15-Feb-2008.)
       (New usage is discouraged.) $)
    grpodivinv $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                   ( A D ( N ` B ) ) = ( A G B ) ) $=
      ( cgr wcel w3a cfv co wceq grpoinvcl 3adant2 grpodivval syld3an3 grpo2inv
      oveq2d eqtrd ) DJKZAFKZBFKZLZABEMZCNZAUGEMZDNZABDNUCUDUEUGFKZUHUJOUCUEUKU
      DBDEFGHPQAUGCDEFGHIRSUFUIBADUCUEUIBOUDBDEFGHTQUAUB $.

    $( Inverse of a group division.  (Contributed by NM, 24-Feb-2008.)
       (New usage is discouraged.) $)
    grpoinvdiv $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                   ( N ` ( A D B ) ) = ( B D A ) ) $=
      ( cgr wcel w3a co cfv grpodivval fveq2d wceq grpoinvcl 3adant2 grpoinvop
      syld3an3 grpo2inv oveq1d 3com23 eqtr4d 3eqtrd ) DJKZAFKZBFKZLZABCMZENABEN
      ZDMZENZULENZAENZDMZBACMZUJUKUMEABCDEFGHIOPUGUHUIULFKZUNUQQUGUIUSUHBDEFGHR
      SAULDEFGHTUAUJUQBUPDMZURUJUOBUPDUGUIUOBQUHBDEFGHUBSUCUGUIUHURUTQBACDEFGHI
      OUDUEUF $.
  $}

  ${
    $d x y z G $.  $d x y z X $.
    grpdivf.1 $e |- X = ran G $.
    grpdivf.3 $e |- D = ( /g ` G ) $.
    $( Mapping for group division.  (Contributed by NM, 10-Apr-2008.)  (Revised
       by Mario Carneiro, 15-Dec-2013.)  (New usage is discouraged.) $)
    grpodivf $p |- ( G e. GrpOp -> D : ( X X. X ) --> X ) $=
      ( vx vy cgr wcel cxp wf cv cgn cfv co cmpt2 wral eqid grpoinvcl 3adant2
      grpocl syld3an3 3expib ralrimivv fmpt2 sylib grpodivfval feq1d mpbird ) B
      HIZCCJZCAKUKCFGCCFLZGLZBMNZNZBOZPZKZUJUPCIZGCQFCQURUJUSFGCCUJULCIZUMCIZUS
      UJUTVAUOCIZUSUJVAVBUTUMBUNCDUNRZSTULUOBCDUAUBUCUDFGCCUPCUQUQRUEUFUJUKCAUQ
      FGABUNCDVCEUGUHUI $.

    $( Closure of group division (or subtraction) operation.  (Contributed by
       NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    grpodivcl $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) -> ( A D B ) e. X ) $=
      ( cgr wcel cxp wf co grpodivf fovrn syl3an1 ) DHIEEJECKAEIBEIABCLEICDEFGM
      ABEEECNO $.

    $( Double group division.  (Contributed by NM, 24-Feb-2008.)
       (New usage is discouraged.) $)
    grpodivdiv $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( A D ( B D C ) ) = ( A G ( C D B ) ) ) $=
      ( cgr wcel w3a wa co cgn cfv wceq simpl simpr1 grpodivcl 3adant3r1 oveq2d
      eqid grpodivval syl3anc grpoinvdiv eqtrd ) EIJZAFJZBFJZCFJZKZLZABCDMZDMZA
      UMENOZOZEMZACBDMZEMULUGUHUMFJZUNUQPUGUKQUGUHUIUJRUGUIUJUSUHBCDEFGHSTAUMDE
      UOFGUOUBZHUCUDULUPURAEUGUIUJUPURPUHBCDEUOFGUTHUETUAUF $.

    $( Associative-type law for multiplication and division.  (Contributed by
       NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    grpomuldivass $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A G B ) D C ) = ( A G ( B D C ) ) ) $=
      ( cgr wcel w3a wa co cgn cfv wceq simpr1 simpr2 eqid grpodivval grpoinvcl
      3ad2antr3 grpoass syldan grpocl 3adant3r3 simpr3 syl3anc 3adant3r1 oveq2d
      3jca simpl 3eqtr4d ) EIJZAFJZBFJZCFJZKZLZABEMZCENOZOZEMZABVBEMZEMZUTCDMZA
      BCDMZEMUNURUOUPVBFJZKVCVEPUSUOUPVHUNUOUPUQQUNUOUPUQRUNUOUQVHUPCEVAFGVASZU
      AUBUKABVBEFGUCUDUSUNUTFJZUQVFVCPUNURULUNUOUPVJUQABEFGUEUFUNUOUPUQUGUTCDEV
      AFGVIHTUHUSVGVDAEUNUPUQVGVDPUOBCDEVAFGVIHTUIUJUM $.

    ${
      grpdivid.3 $e |- U = ( GId ` G ) $.
      $( Division of a group member by itself.  (Contributed by NM,
         15-Feb-2008.)  (New usage is discouraged.) $)
      grpodivid $p |- ( ( G e. GrpOp /\ A e. X ) -> ( A D A ) = U ) $=
        ( cgr wcel wa co cgn cfv wceq eqid grpodivval 3anidm23 grporinv eqtrd )
        DIJZAEJZKAABLZAADMNZNDLZCUAUBUCUEOAABDUDEFUDPZGQRACDUDEFHUFST $.
    $}

    $( Cancellation law for group division.  ( ~ pncan analog.)  (Contributed
       by NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    grpopncan $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
        ( ( A G B ) D B ) = A ) $=
      ( cgr wcel w3a co cgi cfv wceq simp1 simp2 simp3 grpomuldivass syl13anc
      wa eqid grpodivid oveq2d 3adant2 grporid 3adant3 3eqtrd ) DHIZAEIZBEIZJZA
      BDKBCKZABBCKZDKZADLMZDKZAUKUHUIUJUJULUNNUHUIUJOUHUIUJPUHUIUJQZUQABBCDEFGR
      SUHUJUNUPNUIUHUJTUMUOADBCUODEFGUOUAZUBUCUDUHUIUPANUJAUODEFURUEUFUG $.

    $( Cancellation law for group division.  ( ~ npcan analog.)  (Contributed
       by NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    grponpcan $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
        ( ( A D B ) G B ) = A ) $=
      ( cgr wcel w3a co cgn cfv eqid grpodivval oveq1d wceq simp1 3adant2 eqtrd
      simp2 grpoinvcl simp3 grpoass syl13anc wa grpolinv oveq2d grporid 3adant3
      cgi ) DHIZAEIZBEIZJZABCKZBDKABDLMZMZDKZBDKZAUOUPUSBDABCDUQEFUQNZGOPUOUTAU
      RBDKZDKZAUOULUMUREIZUNUTVCQULUMUNRULUMUNUAULUNVDUMBDUQEFVAUBSULUMUNUCAURB
      DEFUDUEUOVCADUKMZDKZAULUNVCVFQUMULUNUFVBVEADBVEDUQEFVENZVAUGUHSULUMVFAQUN
      AVEDEFVGUIUJTTT $.

    $( Cancellation law for mixed addition and group division.  ( ~ pnpcan2
       analog.)  (Contributed by NM, 15-Feb-2008.)
       (New usage is discouraged.) $)
    grpopnpcan2 $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A G C ) D ( B G C ) ) = ( A D B ) ) $=
      ( wcel w3a co cfv wceq grpocl 3adant3r1 grpodivval syl3anc oveq2d 3adant2
      eqid cgr wa cgn simpl 3adant3r2 grpoinvop cgi grporinv oveq1d simp1 simp3
      grpoinvcl 3adant3 grpoass syl13anc grpolid syldan simpr1 simpr3 3ad2antr3
      3eqtr3d 3ad2antr2 3adant3r3 3eqtr4d 3eqtrd ) EUAIZAFIZBFIZCFIZJZUBZACEKZB
      CEKZDKZVLVMEUCLZLZEKZVLCVOLZBVOLZEKZEKZABDKZVKVFVLFIZVMFIZVNVQMVFVJUDZVFV
      GVIWCVHACEFGNUEVFVHVIWDVGBCEFGNOVLVMDEVOFGVOTZHPQVKVPVTVLEVFVHVIVPVTMVGBC
      EVOFGWFUFORVKACVTEKZEKZAVSEKZWAWBVKWGVSAEVFVHVIWGVSMVGVFVHVIJZCVREKZVSEKZ
      EUGLZVSEKZWGVSWJWKWMVSEVFVIWKWMMVHCWMEVOFGWMTZWFUHSUIWJVFVIVRFIZVSFIZWLWG
      MVFVHVIUJVFVHVIUKVFVIWPVHCEVOFGWFULZSVFVHWQVIBEVOFGWFULZUMCVRVSEFGUNUOVFV
      HWNVSMZVIVFVHWQWTWSVSWMEFGWOUPUQUMVAORVKVFVGVIVTFIZWAWHMWEVFVGVHVIURVFVGV
      HVIUSVKVFWPWQXAWEVFVGVIWPVHWRUTVFVGVHWQVIWSVBVRVSEFGNQACVTEFGUNUOVFVGVHWB
      WIMVIABDEVOFGWFHPVCVDVE $.

    $( Cancellation law for group division.  ( ~ nnncan2 analog.)  (Contributed
       by NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    grponnncan2 $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A D C ) D ( B D C ) ) = ( A D B ) ) $=
      ( cgr wcel w3a wa co cgn cfv wceq eqid grpodivval 3adant3r2 idd 3adant3r1
      oveq12d grpoinvcl ex 3anim123d imp grpopnpcan2 syldan eqtrd ) EIJZAFJZBFJ
      ZCFJZKZLZACDMZBCDMZDMACENOZOZEMZBUSEMZDMZABDMZUOUPUTUQVADUJUKUMUPUTPULACD
      EURFGURQZHRSUJULUMUQVAPUKBCDEURFGVDHRUAUBUJUNUKULUSFJZKZVBVCPUJUNVFUJUKUK
      ULULUMVEUJUKTUJULTUJUMVECEURFGVDUCUDUEUFABUSDEFGHUGUHUI $.

    $( Cancellation law for group division.  ( ~ npncan analog.)  (Contributed
       by NM, 24-Feb-2008.)  (New usage is discouraged.) $)
    grponpncan $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
             ( ( A D B ) G ( B D C ) ) = ( A D C ) ) $=
      ( cgr wcel w3a wa co wceq grpodivcl 3adant3r3 simpr2 simpr3 grpomuldivass
      3jca syldan grponpcan 3expb oveq1d 3adantr3 eqtr3d ) EIJZAFJZBFJZCFJZKZLZ
      ABDMZBEMZCDMZUMBCDMEMZACDMZUGUKUMFJZUIUJKUOUPNULURUIUJUGUHUIURUJABDEFGHOP
      UGUHUIUJQUGUHUIUJRTUMBCDEFGHSUAUGUHUIUOUQNUJUGUHUILLUNACDUGUHUIUNANABDEFG
      HUBUCUDUEUF $.

    $( Relationship between group division and group multiplication.
       (Contributed by Mario Carneiro, 11-Jul-2014.)
       (New usage is discouraged.) $)
    grpodiveq $p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                   ( ( A D B ) = C <-> ( C G B ) = A ) ) $=
      ( co wceq cgr wcel w3a wa eqcom wb simpl simpr3 grpodivcl 3adant3r3
      simpr2 grporcan syl13anc grponpcan eqeq2d bitr3d syl5bb ) ABDIZCJCUHJZEKL
      ZAFLZBFLZCFLZMZNZCBEIZAJZUHCOUOUPUHBEIZJZUIUQUOUJUMUHFLZULUSUIPUJUNQUJUKU
      LUMRUJUKULUTUMABDEFGHSTUJUKULUMUACUHBEFGUBUCUOURAUPUJUKULURAJUMABDEFGHUDT
      UEUFUG $.
  $}

  ${
    $d G f g x y z $.  $d N f g z $.  $d U f g x y z $.  $d X f g x y z $.
    $d A x y z $.  $d G x y z $.  $d K x y z $.  $d N x y z $.
    gxfval.1 $e |- X = ran G $.
    gxfval.2 $e |- U = ( GId ` G ) $.
    gxfval.3 $e |- N = ( inv ` G ) $.
    gxfval.4 $e |- P = ( ^g ` G ) $.
    $( The value of the group power operator function.  (Contributed by Paul
       Chapman, 17-Apr-2009.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    gxfval $p |- ( G e. GrpOp -> P = ( x e. X , y e. ZZ |->
        if ( y = 0 , U , if ( 0 < y , ( seq 1 ( G , ( NN X. { x } ) ) ` y ) ,
          ( N ` ( seq 1 ( G , ( NN X. { x } ) ) ` -u y ) ) ) ) ) ) $=
      ( vg cgr wcel cfv cz cv wceq cif cvv cgx cc0 clt wbr cn csn cxp cseq cneg
      c1 cmpt2 crn rnexg syl5eqel zex mpt2exga sylancl cgi cgn rneq eqidd fveq2
      syl6eqr seqeq2 fveq1d fveq12d ifeq12d mpt2eq123dv df-gx fvmptg syl5eq
      mpdan ) EMNZCEUAOZABGPBQZUBRZDUBVOUCUDZVOEUEAQUFUGZUJUHZOZVOUIZVSOZFOZSZS
      ZUKZKVMWFTNZVNWFRVMGTNPTNWGVMGEULZTHEMUMUNUOABGPWETTUPUQLEABLQZULZPVPWIUR
      OZVQVOWIVRUJUHZOZWAWLOZWIUSOZOZSZSZUKWFMTUAWIERZABWJPWRGPWEWSWJWHGWIEUTHV
      CWSPVAWSVPWKDWQWDWSWKEURODWIEURVBIVCWSVQWMVTWPWCWSVOWLVSWIEVRUJVDZVEWSWNW
      BWOFWSWOEUSOFWIEUSVBJVCWSWAWLVSWTVEVFVGVGVHABLVIVJVLVK $.

    $( The result of the group power operator.  (Contributed by Paul Chapman,
       17-Apr-2009.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    gxval $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) -> ( A P K ) =
      if ( K = 0 , U , if ( 0 < K , ( seq 1 ( G , ( NN X. { A } ) ) ` K ) ,
           ( N ` ( seq 1 ( G , ( NN X. { A } ) ) ` -u K ) ) ) ) ) $=
      ( vx vy wcel cz cc0 wceq clt cfv cif cgr co wbr cn csn c1 cseq cneg wa cv
      cmpt2 gxfval oveqd sneq xpeq2d seqeq3d fveq1d fveq2d ifeq12d ifeq2d eqeq1
      cxp breq2 fveq2 negeq ifbieq12d ifbieq2d eqid cgi cvv fvex eqeltri ovmpt2
      ifex sylan9eq 3impb ) DUANZAGNZEONZAEBUBZEPQZCPERUCZEDUDAUEZVBZUFUGZSZEUH
      ZWESZFSZTZTZQVQVRVSUIVTAELMGOMUJZPQZCPWLRUCZWLDUDLUJZUEZVBZUFUGZSZWLUHZWR
      SZFSZTZTZUKZUBWKVQBXEAELMBCDFGHIJKULUMLMAEGOXDWKXEWMCWNWLWESZWTWESZFSZTZT
      WOAQZWMXCXICXJWNWSXFXBXHXJWLWRWEXJWQWDDUFXJWPWCUDWOAUNUOUPZUQXJXAXGFXJWTW
      RWEXKUQURUSUTWLEQZWMWAXIWJCWLEPVAXLWNWBXFXHWFWIWLEPRVCWLEWEVDXLXGWHFXLWTW
      GWEWLEVEURURVFVGXEVHWACWJCDVISVJIDVIVKVLWBWFWIEWEVKWHFVKVNVNVMVOVP $.
  $}

  ${
    gxpval.1 $e |- X = ran G $.
    gxpval.2 $e |- P = ( ^g ` G ) $.
    $( The result of the group power operator when the exponent is positive.
       (Contributed by Paul Chapman, 17-Apr-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.)  (New usage is discouraged.) $)
    gxpval $p |- ( ( G e. GrpOp /\ A e. X /\ K e. NN ) ->
                   ( A P K ) = ( seq 1 ( G , ( NN X. { A } ) ) ` K ) ) $=
      ( cgr wcel cn w3a co cc0 wceq cgi cfv cif eqid 3ad2ant3 syl clt cseq cneg
      wbr csn cxp c1 cgn cz nnz gxval syl3an3 nnne0 neneqd iffalse nngt0 iftrue
      wn 3eqtrd ) CHIZAEIZDJIZKZADBLZDMNZCOPZMDUAUDZDCJAUEUFUGUBZPZDUCVHPCUHPZP
      ZQZQZVLVIVBUTVADUIIVDVMNDUJABVFCDVJEFVFRVJRGUKULVCVEURZVMVLNVBUTVNVAVBDMD
      UMUNSVEVFVLUOTVCVGVLVINVBUTVGVADUPSVGVIVKUQTUS $.
  $}

  ${
    gxnval.1 $e |- X = ran G $.
    gxnval.2 $e |- P = ( ^g ` G ) $.
    gxnval.3 $e |- N = ( inv ` G ) $.
    $( The result of the group power operator when the exponent is negative.
       (Contributed by Paul Chapman, 17-Apr-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.)  (New usage is discouraged.) $)
    gxnval $p |- ( ( G e. GrpOp /\ A e. X /\ ( K e. ZZ /\ K < 0 ) ) ->
        ( A P K ) = ( N ` ( seq 1 ( G , ( NN X. { A } ) ) ` -u K ) ) ) $=
      ( wcel cc0 clt wbr wceq cfv cif wn 0re iffalse syl cgr cz w3a cgi csn cxp
      wa co cn c1 cseq cneg eqid gxval 3adant3r ltnri breq1 mtbiri simp3r nsyl3
      cr wi zre ltnsym sylancl imp 3ad2ant3 3eqtrd ) CUAJZAFJZDUBJZDKLMZUGZUCZA
      DBUHZDKNZCUDOZKDLMZDCUIAUEUFUJUKZOZDULVSOEOZPZPZWBWAVIVJVKVOWCNVLABVQCDEF
      GVQUMIHUNUOVNVPQWCWBNVPVLVNVPVLKKLMKRUPDKKLUQURVIVJVKVLUSUTVPVQWBSTVNVRQZ
      WBWANVMVIWDVJVKVLWDVKDVAJKVAJVLWDVBDVCRDKVDVEVFVGVRVTWASTVH $.
  $}

  ${
    gx0.1 $e |- X = ran G $.
    gx0.2 $e |- U = ( GId ` G ) $.
    gx0.3 $e |- P = ( ^g ` G ) $.
    $( The result of the group power operator when the exponent is zero.
       (Contributed by Paul Chapman, 17-Apr-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.)  (New usage is discouraged.) $)
    gx0 $p |- ( ( G e. GrpOp /\ A e. X ) -> ( A P 0 ) = U ) $=
      ( cgr wcel wa cc0 co wceq clt wbr cn cfv cif eqid csn cxp c1 cseq cneg cz
      cgn 0z gxval mp3an3 iftrue ax-mp syl6eq ) DIJZAEJZKALBMZLLNZCLLOPLDQAUAUB
      UCUDZRLUEURRDUGRZRSZSZCUNUOLUFJUPVANUHABCDLUSEFGUSTHUIUJUQVACNLTUQCUTUKUL
      UM $.
  $}

  ${
    $d A g $.  $d G g $.
    gx1.1 $e |- X = ran G $.
    gx1.2 $e |- P = ( ^g ` G ) $.
    $( The result of the group power operator when the exponent is one.
       (Contributed by Paul Chapman, 17-Apr-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.)  (New usage is discouraged.) $)
    gx1 $p |- ( ( G e. GrpOp /\ A e. X ) -> ( A P 1 ) = A ) $=
      ( cgr wcel wa c1 co cn csn cxp cfv cseq wceq 1nn gxpval mp3an3 cz 1z seq1
      ax-mp syl6eq fvconst2g mpan2 adantl eqtrd ) CGHZADHZIZAJBKZJLAMNZOZAULUMJ
      CUNJPOZUOUJUKJLHZUMUPQRABCJDEFSTJUAHUPUOQUBCUNJUCUDUEUKUOAQZUJUKUQURRLAJD
      UFUGUHUI $.
  $}

  ${
    gxnn0neg.1 $e |- X = ran G $.
    gxnn0neg.2 $e |- N = ( inv ` G ) $.
    gxnn0neg.3 $e |- P = ( ^g ` G ) $.
    $( A negative group power is the inverse of the positive power (lemma with
       nonnegative exponent - use ~ gxneg instead).  (Contributed by Paul
       Chapman, 17-Apr-2009.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    gxnn0neg $p |- ( ( G e. GrpOp /\ A e. X /\ K e. NN0 ) ->
                     ( A P -u K ) = ( N ` ( A P K ) ) ) $=
      ( wcel cneg co cfv wceq cn cc0 wa clt fveq2d eqtr4d cgr cn0 elnn0 w3a csn
      wo cxp c1 cseq cz wbr nnnegz nngt0 nnre lt0neg2d mpbid jca gxnval syl3an3
      gxpval nncn negnegd 3ad2ant3 3expia cgi negeq neg0 syl6eq oveq2d eqid gx0
      sylan9eqr oveq2 grpoinvid adantr eqtrd ex jaod syl5bi 3impia ) CUAJZAFJZD
      UBJZADKZBLZADBLZEMZNZWCDOJZDPNZUFWAWBQZWHDUCWKWIWHWJWAWBWIWHWAWBWIUDZWEWD
      KZCOAUEUGUHUIZMZEMZWGWIWAWBWDUJJZWDPRUKZQWEWPNWIWQWRDULWIPDRUKWRDUMWIDDUN
      UOUPUQABCWDEFGIHURUSWLWFWOEWLWFDWNMZWOABCDFGIUTWIWAWOWSNWBWIWMDWNWIDDVAVB
      SVCTSTVDWKWJWHWKWJQWECVEMZWGWJWKWEAPBLZWTWJWDPABWJWDPKPDPVFVGVHVIABWTCFGW
      TVJZIVKZVLWJWKWGXAEMZWTWJWFXAEDPABVMSWKXDWTEMZWTWKXAWTEXCSWAXEWTNWBWTCEXB
      HVNVOVPVLTVQVRVSVT $.
  $}

  ${
    $d A g k m $.  $d G g k m $.  $d K g m $.  $d P k m $.  $d X k m $.
    gxnn0suc.1 $e |- X = ran G $.
    gxnn0suc.2 $e |- P = ( ^g ` G ) $.
    $( Induction on group power (lemma with nonnegative exponent - use ~ gxsuc
       instead).  (Contributed by Paul Chapman, 17-Apr-2009.)  (Revised by
       Mario Carneiro, 15-Dec-2013.)  (New usage is discouraged.) $)
    gxnn0suc $p |- ( ( G e. GrpOp /\ A e. X /\ K e. NN0 ) ->
                     ( A P ( K + 1 ) ) = ( ( A P K ) G A ) ) $=
      ( wcel c1 caddc co wceq cn cc0 wa cfv oveq2d oveq1d eqtrd adantr wo elnn0
      cgr cn0 w3a csn cxp cseq peano2nn gxpval syl3an3 fvconst2g sylan2 3adant1
      cuz seqp1 nnuz eleq2s 3ad2ant3 3eqtr4d 3expia cgi grpolid simpr gx0 0p1e1
      eqid syl6eq gx1 3eqtr4rd ex jaod syl5bi 3impia ) CUCHZAEHZDUDHZADIJKZBKZA
      DBKZACKZLZVQDMHZDNLZUAVOVPOZWBDUBWEWCWBWDVOVPWCWBVOVPWCUEZVSVRCMAUFUGZIUH
      ZPZWAWCVOVPVRMHZVSWILDUIZABCVREFGUJUKWFDWHPZVRWGPZCKZWLACKWIWAWFWMAWLCVPW
      CWMALZVOWCVPWJWOWKMAVREULUMUNQWCVOWIWNLZVPWPDIUOPMCWGIDUPUQURUSWFVTWLACAB
      CDEFGUJRUTSVAWEWDWBWEWDOZCVBPZACKZAWAVSWEWSALWDAWRCEFWRVGZVCTWQVTWRACWQVT
      ANBKZWRWQDNABWEWDVDZQWEXAWRLWDABWRCEFWTGVETSRWQVSAIBKZAWQVRIABWQVRNIJKIWQ
      DNIJXBRVFVHQWEXCALWDABCEFGVITSVJVKVLVMVN $.

    $( Closure of the group power operator.  (Contributed by Paul Chapman,
       17-Apr-2009.)  (New usage is discouraged.) $)
    gxcl $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) -> ( A P K ) e. X ) $=
      ( vm vk wcel co cv cc0 wa wceq oveq2 eleq1d cfv wi 3expia cgr cz c1 caddc
      cneg cgi eqid gx0 grpoidcl adantr eqeltrd cn0 w3a grpocl 3adant3 gxnn0suc
      3com23 sylibrd cn cgn nnnn0 gxnn0neg syl3an3 grpoinvcl 3ad2antl1 ex zindd
      3impia ) CUAJZAEJZDUBJADBKZEJZAHLZBKZEJAMBKZEJAILZBKZEJZAVPUEZBKZEJZAVPUC
      UDKZBKZEJZVLVIVJNZHIDVMMOVNVOEVMMABPQVMVPOVNVQEVMVPABPQVMWBOVNWCEVMWBABPQ
      VMVSOVNVTEVMVSABPQVMDOVNVKEVMDABPQWEVOCUFRZEABWFCEFWFUGZGUHVIWFEJVJWFCEFW
      GUIUJUKVIVJVPULJZVRWDSVIVJWHUMZVRVQACKZEJZWDVIVJVRWKSWHVIVJVRWKVIVRVJWKVQ
      ACEFUNUQTUOWIWCWJEABCVPEFGUPQURTVIVJVPUSJZVRWASVIVJWLUMZVRWAWMVRNVTVQCUTR
      ZRZEWMVTWOOZVRWLVIVJWHWPVPVAABCVPWNEFWNUGZGVBVCUJVIVJVRWOEJWLVQCWNEFWQVDV
      EUKVFTVGVH $.
  $}

  ${
    gxneg.1 $e |- X = ran G $.
    gxneg.2 $e |- N = ( inv ` G ) $.
    gxneg.3 $e |- P = ( ^g ` G ) $.
    $( A negative group power is the inverse of the positive power.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxneg $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) ->
                     ( A P -u K ) = ( N ` ( A P K ) ) ) $=
      ( wcel cz w3a cn0 cneg co cfv wceq wi wa gxnn0neg cgr 3expia exp3a 3impia
      3adant3l simp1 znegcl syl3an3 3adant3r grpo2inv syl2anc simp3l zcn negneg
      gxcl cc oveq2d 3syl eqtr3d fveq2d wo cr elznn0 simprbi 3ad2ant3 mpjaod )
      CUAJZAFJZDKJZLDMJZADNZBOZADBOZEPZQZVKMJZVGVHVIVJVORVGVHSZVIVJVOVGVHVIVJSV
      OVGVHVJVOVIABCDEFGHITUEUBUCUDVGVHVIVPVORVQVIVPVOVGVHVIVPSZVOVGVHVRLZVLEPZ
      EPZVLVNVSVGVLFJZWAVLQVGVHVRUFVGVHVIWBVPVIVGVHVKKJWBDUGABCVKFGIUOUHUIVLCEF
      GHUJUKVSVTVMEVSAVKNZBOZVTVMVGVHVPWDVTQVIABCVKEFGHITUEVSVIDUPJZWDVMQVGVHVI
      VPULDUMWEWCDABDUNUQURUSUTUSUBUCUDVIVGVJVPVAZVHVIDVBJWFDVCVDVEVF $.

    $( The inverse of a negative group power is the positive power.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxneg2 $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) ->
                   ( N ` ( A P -u K ) ) = ( A P K ) ) $=
      ( cgr wcel cz w3a cneg co cfv gxneg fveq2d wceq simp1 gxcl grpo2inv eqtrd
      syl2anc ) CJKZAFKZDLKZMZADNBOZEPADBOZEPZEPZUJUHUIUKEABCDEFGHIQRUHUEUJFKUL
      UJSUEUFUGTABCDFGIUAUJCEFGHUBUDUC $.

    $( The result of the group power operator when the exponent is minus one.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxm1 $p |- ( ( G e. GrpOp /\ A e. X ) -> ( A P -u 1 ) = ( N ` A ) ) $=
      ( cgr wcel wa c1 cneg co cfv cz wceq 1z gxneg mp3an3 gx1 fveq2d eqtrd ) C
      IJZAEJZKZALMBNZALBNZDOZADOUDUELPJUGUIQRABCLDEFGHSTUFUHADABCEFHUAUBUC $.
  $}

  ${
    $d A k m $.  $d G k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxcom.1 $e |- X = ran G $.
    gxcom.2 $e |- P = ( ^g ` G ) $.
    $( The group power operator commutes with the group operation.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxcom $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) ->
                  ( ( A P K ) G A ) = ( A G ( A P K ) ) ) $=
      ( wcel cz co wceq cc0 wa oveq2 oveq1d oveq2d eqeq12d cfv adantr syl3anc
      vm vk cgr cv cneg c1 caddc cgi eqid grpolid gx0 grporid eqtrd 3eqtr4d cn0
      wi nn0z simp1 simp2 gxcl grpoass syl13anc syl3an3 gxnn0suc eqeq1d biimpar
      w3a ex 3expia cn nnz cgn simpl1 simpl2 znegcl grpoinvcl syl2anc grpoinvop
      gxneg fveq2 adantl 3eqtr2rd 3eqtr2d grpoasscan1 grpocl grpoasscan2 eqtr3d
      syl5 zindd 3impia ) CUCHZAEHZDIHADBJZACJZAWMCJZKZAUAUDZBJZACJZAWRCJZKALBJ
      ZACJZAXACJZKAUBUDZBJZACJZAXECJZKZAXDUEZBJZACJZAXJCJZKZAXDUFUGJZBJZACJZAXO
      CJZKZWPWKWLMZUAUBDWQLKZWSXBWTXCXTWRXAACWQLABNZOXTWRXAACYAPQWQXDKZWSXFWTXG
      YBWRXEACWQXDABNZOYBWRXEACYCPQWQXNKZWSXPWTXQYDWRXOACWQXNABNZOYDWRXOACYEPQW
      QXIKZWSXKWTXLYFWRXJACWQXIABNZOYFWRXJACYGPQWQDKZWSWNWTWOYHWRWMACWQDABNZOYH
      WRWMACYIPQXSCUHRZACJAXBXCAYJCEFYJUIZUJXSXAYJACABYJCEFYKGUKZOXSXCAYJCJAXSX
      AYJACYLPAYJCEFYKULUMUNWKWLXDUOHZXHXRUPWKWLYMVGZXHXRYNXHMZXGACJZAXFCJZXPXQ
      YNYPYQKZXHYMWKWLXDIHZYRXDUQWKWLYSVGZWKWLXEEHZWLYRWKWLYSURWKWLYSUSZABCXDEF
      GUTZUUBAXEACEFVAVBVCSYOXOXGACYNXOXGKXHYNXOXFXGABCXDEFGVDZVEVFOYNXQYQKXHYN
      XOXFACUUDPSUNVHVIXDVJHYSXSXHXMUPZXDVKWKWLYSUUEYTXHXMYTXHMZXLACVLRZRZCJZAC
      JZXKXLUUFUUIXJACUUFUUIAXJUUHCJZCJZXJUUFWKWLXJEHZUUHEHZUUIUULKWKWLYSXHVMZW
      KWLYSXHVNZYTUUMXHYSWKWLXIIHUUMXDVOABCXIEFGUTVCSZUUFWKWLUUNUUOUUPACUUGEFUU
      GUIZVPVQAXJUUHCEFVAVBUUFUULAUUHXJCJZCJZXJUUFUUKUUSACUUFUUKXEUUGRZUUHCJZXG
      UUGRZUUSUUFXJUVAUUHCYTXJUVAKXHABCXDUUGEFUURGVSSZOUUFWKWLUUAUVCUVBKUUOUUPY
      TUUAXHUUCSZAXECUUGEFUURVRTUUFUUSUUHUVACJZXFUUGRZUVCUUFXJUVAUUHCUVDPUUFWKU
      UAWLUVGUVFKUUOUVEUUPXEACUUGEFUURVRTXHUVGUVCKYTXFXGUUGVTWAWBWCPUUFWKWLUUMU
      UTXJKUUOUUPUUQAXJCUUGEFUURWDTUMUMOUUFWKXLEHZWLUUJXLKUUOUUFWKWLUUMUVHUUOUU
      PUUQAXJCEFWETUUPXLACUUGEFUURWFTWGVHVIWHWIWJ $.
  $}

  ${
    $d A k m $.  $d G k m $.  $d K k m $.  $d N k m $.  $d P k m $.
    $d X k m $.
    gxinv.1 $e |- X = ran G $.
    gxinv.2 $e |- N = ( inv ` G ) $.
    gxinv.3 $e |- P = ( ^g ` G ) $.
    $( The group power operator commutes with the group inverse function.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxinv $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) ->
                  ( ( N ` A ) P K ) = ( N ` ( A P K ) ) ) $=
      ( wcel cfv co wceq cc0 wa oveq2 fveq2d eqeq12d adantr syld3an2 vm vk cneg
      cgr cz cv c1 caddc cgi grpoinvid gx0 grpoinvcl syldan 3eqtr4rd cn0 wi w3a
      eqid 3adant3 gxnn0suc nn0z gxcom syl3an3 eqtrd simp1 gxcl simp2 grpoinvop
      adantl syl3anc 3eqtr4d ex 3expia nnz gxneg simpr eqtr4d syl5 zindd 3impia
      cn ) CUDJZAFJZDUEJAEKZDBLZADBLZEKZMZWDUAUFZBLZAWIBLZEKZMWDNBLZANBLZEKZMWD
      UBUFZBLZAWPBLZEKZMZWDWPUCZBLZAXABLZEKZMZWDWPUGUHLZBLZAXFBLZEKZMZWHWBWCOZU
      AUBDWINMZWJWMWLWOWINWDBPXLWKWNEWINABPQRWIWPMZWJWQWLWSWIWPWDBPXMWKWREWIWPA
      BPQRWIXFMZWJXGWLXIWIXFWDBPXNWKXHEWIXFABPQRWIXAMZWJXBWLXDWIXAWDBPXOWKXCEWI
      XAABPQRWIDMZWJWEWLWGWIDWDBPXPWKWFEWIDABPQRXKCUIKZEKZXQWOWMWBXRXQMWCXQCEXQ
      URZHUJSXKWNXQEABXQCFGXSIUKQWBWCWDFJZWMXQMACEFGHULZWDBXQCFGXSIUKUMUNWBWCWP
      UOJZWTXJUPWBWCYBUQZWTXJYCWTOWDWQCLZWDWSCLZXGXIWTYDYEMYCWQWSWDCPVIYCXGYDMW
      TYCXGWQWDCLZYDWBXTWCYBXGYFMWBWCXTYBYAUSZWDBCWPFGIUTTWBXTWCYBYFYDMZYGYBWBX
      TWPUEJZYHWPVAZWDBCWPFGIVBVCTVDSYCXIYEMWTYCXIWRACLZEKZYEYCXHYKEABCWPFGIUTQ
      YCWBWRFJZWCYLYEMWBWCYBVEYBWBWCYIYMYJABCWPFGIVFVCWBWCYBVGWRACEFGHVHVJVDSVK
      VLVMWPWAJYIXKWTXEUPZWPVNWBWCYIYNWBWCYIUQZWTXEYOWTOZXBWQEKZXDYOXBYQMZWTWBX
      TWCYIYRWBWCXTYIYAUSWDBCWPEFGHIVOTSYPXCWQEYPXCWSWQYOXCWSMWTABCWPEFGHIVOSYO
      WTVPVQQVQVLVMVRVSVT $.

    $( The group power operator commutes with the group inverse function.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxinv2 $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) ->
                   ( N ` ( ( N ` A ) P K ) ) = ( A P K ) ) $=
      ( cgr wcel cz w3a cfv co wceq grpoinvcl 3adant3 gxinv syld3an2 grpo2inv
      oveq1d eqtr3d ) CJKZAFKZDLKZMZAENZENZDBOZUHDBOENZADBOUDUHFKZUEUFUJUKPUDUE
      ULUFACEFGHQRUHBCDEFGHISTUGUIADBUDUEUIAPUFACEFGHUARUBUC $.
  $}

  ${
    gxsuc.1 $e |- X = ran G $.
    gxsuc.2 $e |- P = ( ^g ` G ) $.
    $( Induction on group power.  (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxsuc $p |- ( ( G e. GrpOp /\ A e. X /\ K e. ZZ ) ->
                  ( A P ( K + 1 ) ) = ( ( A P K ) G A ) ) $=
      ( wcel cn0 c1 caddc co wceq cneg wa cfv syld3an3 syl2anc oveq2d cc cgr cz
      w3a cn wi gxnn0suc 3expia 3adant3 cgn simp3l gxcom simp1 peano2z syl gxcl
      eqid grpo2inv cmin nnm1nn0 adantl wb zcn ax-1cn negdi negcld negsub eqtrd
      sylancl eleq1d adantr mpbird syl3an3 oveq1d npcan gxneg 3eqtr3d grpoinvcl
      eqtr3d fveq2d simp2 grpoinvop syl3anc grpoasscan1 3eqtr2rd exp3a elznn0nn
      3impia wo cr simpr orim2i sylbi 3ad2ant3 mpjaod ) CUAHZAEHZDUBHZUCDIHZADJ
      KLZBLZADBLZACLZMZDNZUDHZWOWPWRXCUEWQWOWPWRXCABCDEFGUFUGUHWOWPWQXEXCUEWOWP
      OWQXEXCWOWPWQXEOZXCWOWPXFUCZXBAXACLZAACUIPZPZWTCLZCLZWTWOWPXFWQXBXHMWOWPW
      QXEUJZABCDEFGUKQXGXKXAACXGXJWTXIPZXIPZCLZXKXAXGXOWTXJCXGWOWTEHZXOWTMWOWPX
      FULZWOWPXFWSUBHZXQXGWQXSXMDUMZUNABCWSEFGUOQZWTCXIEFXIUPZUQRSXGXNACLZXIPZX
      AXIPZXIPZXPXAXGYCYEXIXGAWSNZBLZACLZAXDBLZYCYEXGAYGJKLZBLZYIYJXFWOWPYGIHZY
      LYIMXFYMXDJURLZIHZXEYOWQXDUSUTWQYMYOVAXEWQYGYNIWQYGXDJNKLZYNWQDTHJTHZYGYP
      MDVBZVCDJVDVHWQXDTHZYQYPYNMWQDYRVEZVCXDJVFVHVGZVIVJVKABCYGEFGUFVLXGWQYLYJ
      MXMWQYKXDABWQYKYNJKLZXDWQYGYNJKUUAVMWQYSYQUUBXDMYTVCXDJVNVHVGSUNVRXGYHXNA
      CWOWPXFWQYHXNMZXMWQWOWPXSUUCXTABCWSXIEFYBGVOVLQVMWOWPXFWQYJYEMXMABCDXIEFY
      BGVOQVPVSXGWOXNEHZWPYDXPMXRXGWOXQUUDXRYAWTCXIEFYBVQRWOWPXFVTXNACXIEFYBWAW
      BXGWOXAEHZYFXAMXRWOWPXFWQUUEXMABCDEFGUOQXACXIEFYBUQRVPVRSWOWPXFXQXLWTMYAA
      WTCXIEFYBWCQWDUGWEWGWQWOWRXEWHZWPWQWRDWIHZXEOZWHUUFDWFUUHXEWRUUGXEWJWKWLW
      MWN $.
  $}

  ${
    $d G k m $.  $d K k m $.  $d P k m $.  $d U k m $.
    gxid.1 $e |- U = ( GId ` G ) $.
    gxid.2 $e |- P = ( ^g ` G ) $.
    $( The identity element of a group to any power remains unchanged.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxid $p |- ( ( G e. GrpOp /\ K e. ZZ ) -> ( U P K ) = U ) $=
      ( vm vk wcel cz co wceq cv cc0 oveq2 eqeq1d eqid wi syl3anc cfv cgr caddc
      cneg c1 crn grpoidcl gx0 mpdan cn0 nn0z wa simpl simpr gxsuc gxcl grporid
      adantr syldan eqtr2d biimpd ex syl5 cn nnz w3a cgn gxneg syl3an2 3anidm12
      3adant3 fveq2 grpoinvid sylan9eqr 3adant2 eqtrd 3exp zindd imp ) CUAIZDJI
      BDAKZBLZBGMZAKZBLBNAKZBLZBHMZAKZBLZBWFUCZAKZBLZBWFUDUBKZAKZBLZWAVSGHDWBNL
      WCWDBWBNBAOPWBWFLWCWGBWBWFBAOPWBWLLWCWMBWBWLBAOPWBWILWCWJBWBWIBAOPWBDLWCV
      TBWBDBAOPVSBCUEZIZWEBCWOWOQZEUFZBABCWOWQEFUGUHWFUIIWFJIZVSWHWNRZWFUJVSWSW
      TVSWSUKZWHWNXAWGWMBXAWMWGBCKZWGXAVSWPWSWMXBLVSWSULZVSWPWSWRUQZVSWSUMZBACW
      FWOWQFUNSVSWSWGWOIZXBWGLXAVSWPWSXFXCXDXEBACWFWOWQFUOSWGBCWOWQEUPURUSPUTVA
      VBWFVCIWSVSWHWKRWFVDVSWSWHWKVSWSWHVEWJWGCVFTZTZBVSWSWJXHLZWHVSWSXIVSVSWPW
      SXIWRBACWFXGWOWQXGQZFVGVHVIVJVSWHXHBLWSWHVSXHBXGTBWGBXGVKBCXGEXJVLVMVNVOV
      PVBVQVR $.
  $}

  ${
    $d A k m $.  $d G k m $.  $d J k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxnn0add.1 $e |- X = ran G $.
    gxnn0add.2 $e |- P = ( ^g ` G ) $.
    $( The group power of a sum is the group product of the powers (lemma with
       nonnegative exponent - use ~ gxadd instead).  (Contributed by Paul
       Chapman, 17-Apr-2009.)  (New usage is discouraged.) $)
    gxnn0add $p |- ( ( G e. GrpOp /\ A e. X /\ ( J e. ZZ /\ K e. NN0 ) ) ->
                     ( A P ( J + K ) ) = ( ( A P J ) G ( A P K ) ) ) $=
      ( wcel wa caddc co wceq wi cc0 c1 oveq2 oveq2d eqeq12d imbi2d cgr cn0 w3a
      vm vk cz cv cgi cfv addid1d 3ad2ant3 gxcl eqid grporid ex 3ad2ant1 eqtr4d
      zcn mpd 3adant3 nn0z gxsuc 3adant3l adantr simpl1 3adant3r simpl2 grpoass
      gx0 syl13anc zaddcl syl3an3 oveq1 sylan9eq cc ax-1cn addass mp3an3 syl2an
      3eqtr2rd 3expia exp3a 3impia com12 a2d syl nn0ind imp3a ) CUAIZAFIZDUFIZE
      UBIZJADEKLZBLZADBLZAEBLZCLZMZWIWJJZWKWLWRWIWJWKWLWRNWLWIWJWKUCZWRWTADUDUG
      ZKLZBLZWOAXABLZCLZMZNWTADOKLZBLZWOAOBLZCLZMZNWTADUEUGZKLZBLZWOAXLBLZCLZMZ
      NZWTADXLPKLZKLZBLZWOAXSBLZCLZMZNZWTWRNUDUEEXAOMZXFXKWTYFXCXHXEXJYFXBXGABX
      AODKQRYFXDXIWOCXAOABQRSTXAXLMZXFXQWTYGXCXNXEXPYGXBXMABXAXLDKQRYGXDXOWOCXA
      XLABQRSTXAXSMZXFYDWTYHXCYAXEYCYHXBXTABXAXSDKQRYHXDYBWOCXAXSABQRSTXAEMZXFW
      RWTYIXCWNXEWQYIXBWMABXAEDKQRYIXDWPWOCXAEABQRSTWTXHWOCUHUIZCLZXJWTXHWOYKWK
      WIXHWOMWJWKXGDABWKDDURZUJRUKWTWOFIZYKWOMZABCDFGHULZWIWJYMYNNWKWIYMYNWOYJC
      FGYJUMZUNUOUPUSUQWIWJXJYKMWKWSXIYJWOCABYJCFGYPHVIRUTUQXLUBIXLUFIZXRYENXLV
      AYQWTXQYDWTYQXQYDNZWIWJWKYQYRNWSWKYQYRWIWJWKYQJZYRWIWJYSUCZXQYDYTXQJZYCXP
      ACLZAXMPKLZBLZYAUUAYCWOXOACLZCLZUUBYTYCUUFMZXQWIWJYQUUGWKWIWJYQUCYBUUEWOC
      ABCXLFGHVBRVCVDUUAWIYMXOFIZWJUUBUUFMWIWJYSXQVEYTYMXQWIWJWKYMYQYOVFVDYTUUH
      XQWIWJYQUUHWKABCXLFGHULVCVDWIWJYSXQVGWOXOACFGVHVJUQYTXQUUDXNACLZUUBYSWIWJ
      XMUFIUUDUUIMDXLVKABCXMFGHVBVLXNXPACVMVNUUAUUCXTABYTUUCXTMZXQYSWIUUJWJWKDV
      OIZXLVOIZUUJYQYLXLURUUKUULPVOIUUJVPDXLPVQVRVSUKVDRVTUOWAWBWCWDWEWFWGWDWAW
      HWC $.

    $( The group power of a sum is the group product of the powers.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxadd $p |- ( ( G e. GrpOp /\ A e. X /\ ( J e. ZZ /\ K e. ZZ ) ) ->
                  ( A P ( J + K ) ) = ( ( A P J ) G ( A P K ) ) ) $=
      ( wcel cz wa caddc co wceq wi 3expia 3impia syl3an3 cc eqtr3d cgr w3a cn0
      cneg gxnn0add exp3a adantr cgn cfv zaddcl adantrr gxcl simprl grpoasscan2
      simp1 eqid syl3anc gxneg oveq2d simprr jca zcn cmin addcl negsub sylancom
      pncan eqtrd syl2an 3ad2ant3 oveq1d expdimp wo cr elznn0 simprbi adantl ex
      mpjaod imp3a ) CUAIZAFIZDJIZEJIZKADELMZBMZADBMZAEBMZCMZNZWAWBKZWCWDWJWAWB
      WCWDWJOWAWBWCUBZWDWJWLWDKEUCIZWJEUDZUCIZWLWMWJOZWDWAWBWCWPWKWCWMWJWAWBWCW
      MKWJABCDEFGHUEPUFQUGWLWDWOWJWAWBWCWDWOKZWJOWKWCWQWJWAWBWCWQKZWJWAWBWRUBZW
      FWHCUHUIZUIZCMZWHCMZWFWIWSWAWFFIZWHFIZXCWFNWAWBWRUOWRWAWBWEJIZXDWCWDXFWOD
      EUJUKZABCWEFGHULRWRWAWBWDXEWCWDWOUMZABCEFGHULRWFWHCWTFGWTUPZUNUQWSXBWGWHC
      WSWFAWNBMZCMZXBWGWSXJXAWFCWRWAWBWDXJXANXHABCEWTFGXIHURRUSWSAWEWNLMZBMZXKW
      GWRWAWBXFWOKXMXKNWRXFWOXGWCWDWOUTVAABCWEWNFGHUERWRWAXMWGNWBWRXLDABWCDSIZE
      SIZXLDNWQDVBWDXOWOEVBUGXNXOKXLWEEVCMZDXNXOWESIXLXPNDEVDWEEVEVFDEVGVHVIUSV
      JTTVKTPUFQVLWDWMWOVMZWLWDEVNIXQEVOVPVQVSVRPVTQ $.
  $}

  ${
    gxsub.1 $e |- X = ran G $.
    gxsub.2 $e |- N = ( inv ` G ) $.
    gxsub.3 $e |- P = ( ^g ` G ) $.
    $( The group power of a difference is the group quotient of the powers.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxsub $p |- ( ( G e. GrpOp /\ A e. X /\ ( J e. ZZ /\ K e. ZZ ) ) ->
        ( A P ( J - K ) ) = ( ( A P J ) G ( N ` ( A P K ) ) ) ) $=
      ( cgr wcel cz wa w3a co wceq cc zcn oveq2d cneg caddc znegcl anim2i gxadd
      cmin cfv syl3an3 negsub syl2an 3ad2ant3 gxneg 3adant3l 3eqtr3d ) CKLZAGLZ
      DMLZEMLZNZOZADEUAZUBPZBPZADBPZAVABPZCPZADEUFPZBPVDAEBPFUGZCPUSUOUPUQVAMLZ
      NVCVFQURVIUQEUCUDABCDVAGHJUEUHUTVBVGABUSUOVBVGQZUPUQDRLERLVJURDSESDEUIUJU
      KTUTVEVHVDCUOUPURVEVHQUQABCEFGHIJULUMTUN $.
  $}

  ${
    $d A k m $.  $d G k m $.  $d J k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxnn0mul.1 $e |- X = ran G $.
    gxnn0mul.2 $e |- P = ( ^g ` G ) $.
    $( The group power of a product is the composition of the powers (lemma
       with nonnegative exponent - use ~ gxmul instead).  (Contributed by Paul
       Chapman, 17-Apr-2009.)  (New usage is discouraged.) $)
    gxnn0mul $p |- ( ( G e. GrpOp /\ A e. X /\ ( J e. ZZ /\ K e. NN0 ) ) ->
                     ( A P ( J x. K ) ) = ( ( A P J ) P K ) ) $=
      ( wcel wa cmul co wceq wi cc0 c1 caddc oveq2 oveq2d eqeq12d vm vk cgr cn0
      cz w3a cv imbi2d cgi cfv eqid gx0 3adant3 zcn 3ad2ant3 simp1 gxcl syl2anc
      mul01d 3eqtr4d oveq1 adantl nn0cn ax-1cn adddi mp3an3 mulid1 adantr eqtrd
      cc syl2an nn0z zmulcl sylan2 simpl jca gxadd syl3an3 3adant3r nn0zd gxsuc
      simp3r syl3anc ex 3expia exp3a 3impia com12 a2d nn0ind imp3a ) CUCIZAFIZD
      UEIZEUDIZJADEKLZBLZADBLZEBLZMZWLWMJZWNWOWTWLWMWNWOWTNWOWLWMWNUFZWTXBADUAU
      GZKLZBLZWRXCBLZMZNXBADOKLZBLZWROBLZMZNXBADUBUGZKLZBLZWRXLBLZMZNXBADXLPQLZ
      KLZBLZWRXQBLZMZNXBWTNUAUBEXCOMZXGXKXBYBXEXIXFXJYBXDXHABXCODKRSXCOWRBRTUHX
      CXLMZXGXPXBYCXEXNXFXOYCXDXMABXCXLDKRSXCXLWRBRTUHXCXQMZXGYAXBYDXEXSXFXTYDX
      DXRABXCXQDKRSXCXQWRBRTUHXCEMZXGWTXBYEXEWQXFWSYEXDWPABXCEDKRSXCEWRBRTUHXBA
      OBLZCUIUJZXIXJWLWMYFYGMWNABYGCFGYGUKZHULUMWNWLXIYFMWMWNXHOABWNDDUNZUSSUOX
      BWLWRFIZXJYGMWLWMWNUPABCDFGHUQZWRBYGCFGYHHULURUTXLUDIZXBXPYAXBYLXPYANZWLW
      MWNYLYMNXAWNYLYMWLWMWNYLJZYMWLWMYNUFZXPYAYOXPJXNWRCLZXOWRCLZXSXTXPYPYQMYO
      XNXOWRCVAVBYOXSYPMXPYOXSAXMDQLZBLZYPYNWLXSYSMWMYNXRYRABWNDVJIZXLVJIZXRYRM
      YLYIXLVCYTUUAJXRXMDPKLZQLZYRYTUUAPVJIXRUUCMVDDXLPVEVFYTUUCYRMUUAYTUUBDXMQ
      DVGSVHVIVKSUOYNWLWMXMUEIZWNJYSYPMYNUUDWNYLWNXLUEIZUUDXLVLDXLVMVNWNYLVOVPA
      BCXMDFGHVQVRVIVHYOXTYQMZXPYOWLYJUUEUUFWLWMYNUPWLWMWNYJYLYKVSYOXLWLWMWNYLW
      BVTWRBCXLFGHWAWCVHUTWDWEWFWGWHWIWJWHWEWKWG $.

    $( The group power of a product is the composition of the powers.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxmul $p |- ( ( G e. GrpOp /\ A e. X /\ ( J e. ZZ /\ K e. ZZ ) ) ->
                  ( A P ( J x. K ) ) = ( ( A P J ) P K ) ) $=
      ( wcel cz wa cmul co wceq wi w3a 3expia 3impia cfv syl3anc cgr cneg exp3a
      cn0 gxnn0mul adantr cgn znegcl simpr anim12i syl3an3 zcn mul2neg 3ad2ant3
      cc syl2an oveq2d eqid gxneg 3adant3r oveq1d 3eqtr3d simp1 simp3rl znegcld
      gxcl gxinv eqtrd fveq2d grpo2inv syl2anc 3eqtrd expdimp wo elznn0 simprbi
      cr adantl mpjaod ex imp3a ) CUAIZAFIZDJIZEJIZKADELMZBMZADBMZEBMZNZWBWCKZW
      DWEWJWBWCWDWEWJOWBWCWDPZWEWJWLWEKEUDIZWJEUBZUDIZWLWMWJOZWEWBWCWDWPWKWDWMW
      JWBWCWDWMKWJABCDEFGHUEQUCRUFWLWEWOWJWBWCWDWEWOKZWJOWKWDWQWJWBWCWDWQKZWJWB
      WCWRPZWGWHWNBMZCUGSZSZWIXASZXASZWIWSWGWHXASZWNBMZXBWSADUBZWNLMZBMZAXGBMZW
      NBMZWGXFWRWBWCXGJIZWOKXIXKNWDXLWQWODUHWEWOUIUJABCXGWNFGHUEUKWSXHWFABWRWBX
      HWFNZWCWDDUOIEUOIZXMWQDULWEXNWOEULUFDEUMUPUNUQWSXJXEWNBWBWCWDXJXENWQABCDX
      AFGXAURZHUSUTVAVBWSWBWHFIZWNJIXFXBNWBWCWRVCZWBWCWDXPWQABCDFGHVFUTZWSEWEWO
      WDWBWCVDZVEWHBCWNXAFGXOHVGTVHWSWTXCXAWSWBXPWEWTXCNXQXRXSWHBCEXAFGXOHUSTVI
      WSWBWIFIZXDWINXQWSWBXPWEXTXQXRXSWHBCEFGHVFTWICXAFGXOVJVKVLQUCRVMWEWMWOVNZ
      WLWEEVQIYAEVOVPVRVSVTQWAR $.
  $}

  ${
    gxmodid.1 $e |- X = ran G $.
    gxmodid.2 $e |- U = ( GId ` G ) $.
    gxmodid.3 $e |- P = ( ^g ` G ) $.
    $( Casting out powers of the identity element leaves the group power
       unchanged.  (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxmodid $p |- ( ( G e. GrpOp /\ ( K e. ZZ /\ M e. NN ) /\
      ( A e. X /\ ( A P M ) = U ) ) -> ( A P ( K mod M ) ) = ( A P K ) ) $=
      ( wcel cz wa co wceq cmul cr 3ad2ant2 oveq2d zcnd cgr cn w3a cmo cdiv cfl
      cfv cneg cmin caddc crp zre nnrp modval syl2an simpl nnz adantl cc0 nnne0
      wne nnre redivcl syl3an 3anidm23 flcld zmulcld negsubd simp3l znegcld jca
      simp1 gxadd syl3anc 3eqtr2d mulneg2d gxmul syl112anc 3ad2ant3 gxid 3eqtrd
      oveq1 syl2anc eqtr3d simp2l gxcl grporid ) DUAKZELKZFUBKZMZAGKZAFBNZCOZMZ
      UCZAEFUDNZBNZAEBNZAFEFUENZUFUGZPNZUHZBNZDNZWSCDNZWSWPWRAEXBUINZBNAEXCUJNZ
      BNZXEWPWQXGABWKWHWQXGOZWOWIEQKZFUKKXJWJEULZFUMEFUNUORSWPXHXGABWKWHXHXGOWO
      WKEXBWKEWIWJUPZTWKXBWKFXAWJFLKZWIFUQURZWKWTWIWJWTQKZWIXKWJFQKWJFUSVAXPXLF
      VBFUTEFVCVDVEVFZVGZTVHRSWPWHWLWIXCLKZMZXIXEOWHWKWOVLZWHWKWLWNVIZWKWHXTWOW
      KWIXSXMWKXBXRVJVKRABDEXCGHJVMVNVOWPXDCWSDWPAFXAUHZPNZBNZXDCWPYDXCABWKWHYD
      XCOWOWKFXAWKFXOTWKXAXQTVPRSWPYEWMYCBNZCYCBNZCWPWHWLXNYCLKZYEYFOYAYBWKWHXN
      WOXORWKWHYHWOWKXAXQVJRZABDFYCGHJVQVRWOWHYFYGOZWKWNYJWLWMCYCBWBURVSWPWHYHY
      GCOYAYIBCDYCIJVTWCWAWDSWPWHWSGKZXFWSOYAWPWHWLWIYKYAYBWHWIWJWOWEABDEGHJWFV
      NWSCDGHIWGWCWA $.
  $}

  ${
    resgrprn.1 $e |- H = ( G |` ( Y X. Y ) ) $.
    $( The underlying set of a group operation which is a restriction of a
       mapping.  (Contributed by Paul Chapman, 25-Mar-2008.)
       (New usage is discouraged.) $)
    resgrprn $p |- ( ( dom G = ( X X. X ) /\ H e. GrpOp /\ Y C_ X ) ->
                        Y = ran H ) $=
      ( cdm cxp wceq cgr wcel wss w3a crn cres dmeqi xpss12 anidms sseq2 sylib
      wa biimpar sylan2 ssdmres syl5eq 3adant2 wfo eqid grpofo fof fdm 3ad2ant2
      wf 3syl eqtr3d xpid11 ) AFZCCGZHZBIJZDCKZLZDDGZBMZVCGZHDVCHVABFZVBVDURUTV
      EVBHUSURUTTZVEAVBNZFZVBBVGEOVFVBUPKZVHVBHUTURVBUQKZVIUTVJDCDCPQURVIVJUPUQ
      VBRUAUBVBAUCSUDUEUSURVEVDHZUTUSVDVCBUFVDVCBULVKBVCVCUGUHVDVCBUIVDVCBUJUMU
      KUNDVCUOS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Definition and basic properties of Abelian groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c AbelOp $.

  $( Extend class notation with the class of all Abelian group operations. $)
  cablo $a class AbelOp $.

  ${
    $d g x y $.
    $( Define the class of all Abelian group operations.  (Contributed by NM,
       2-Nov-2006.)  (New usage is discouraged.) $)
    df-ablo $a |- AbelOp
     = { g e. GrpOp | A. x e. ran g A. y e. ran g ( x g y ) = ( y g x ) } $.
  $}

  ${
    $d g x y G $.  $d g x y X $.
    isabl.1 $e |- X = ran G $.
    $( The predicate "is an Abelian (commutative) group operation."
       (Contributed by NM, 2-Nov-2006.)  (New usage is discouraged.) $)
    isablo $p |- ( G e. AbelOp <-> ( G e. GrpOp /\
             A. x e. X A. y e. X ( x G y ) = ( y G x ) ) ) $=
      ( vg cv co wceq crn wral cgr cablo rneq syl6eqr raleq raleqbi1dv syl oveq
      wb eqeq12d 2ralbidv bitrd df-ablo elrab2 ) AGZBGZFGZHZUGUFUHHZIZBUHJZKZAU
      LKZUFUGCHZUGUFCHZIZBDKADKZFCLMUHCIZUNUKBDKZADKZURUSULDIUNVATUSULCJDUHCNEO
      UMUTAULDUKBULDPQRUSUKUQABDDUSUIUOUJUPUFUGUHCSUGUFUHCSUAUBUCABFUDUE $.
  $}

  ${
    $d x y G $.
    $( An Abelian group operation is a group operation.  (Contributed by NM,
       2-Nov-2006.)  (New usage is discouraged.) $)
    ablogrpo $p |- ( G e. AbelOp -> G e. GrpOp ) $=
      ( vx vy cablo wcel cgr cv co wceq crn wral eqid isablo simplbi ) ADEAFEBG
      ZCGZAHPOAHICAJZKBQKBCAQQLMN $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y X $.
    ablcom.1 $e |- X = ran G $.
    $( An Abelian group operation is commutative.  (Contributed by NM,
       2-Nov-2006.)  (New usage is discouraged.) $)
    ablocom $p |- ( ( G e. AbelOp /\ A e. X /\ B e. X ) ->
                 ( A G B ) = ( B G A ) ) $=
      ( vx vy cablo wcel co wceq cv wral cgr isablo simprbi oveq1 oveq2 eqeq12d
      wa rspc2v syl5com 3impib ) CHIZADIZBDIZABCJZBACJZKZUDFLZGLZCJZUKUJCJZKZGD
      MFDMZUEUFTUIUDCNIUOFGCDEOPUNUIAUKCJZUKACJZKFGABDDUJAKULUPUMUQUJAUKCQUJAUK
      CRSUKBKUPUGUQUHUKBACRUKBACQSUAUBUC $.

    $( Commutative/associative law for Abelian groups.  (Contributed by NM,
       26-Apr-2007.)  (New usage is discouraged.) $)
    ablo32 $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      ( cablo wcel w3a wa co wceq ablocom 3adant3r1 oveq2d cgr ablogrpo grpoass
      sylan 3ancomb sylan2b 3eqtr4d ) DGHZAEHZBEHZCEHZIZJZABCDKZDKZACBDKZDKZABD
      KCDKZACDKBDKZUHUIUKADUCUEUFUIUKLUDBCDEFMNOUCDPHZUGUMUJLDQZABCDEFRSUCUOUGU
      NULLZUPUGUOUDUFUEIUQUDUEUFTACBDEFRUASUB $.

    $( Commutative/associative law for Abelian groups.  (Contributed by NM,
       26-Apr-2007.)  (New usage is discouraged.) $)
    ablo4 $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X ) /\ ( C e. X /\
   D e. X ) ) -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      ( wcel wa wceq w3a simprlr simprrl 3jca syldan grpocl 3expb grpoass sylan
      co cablo simprll ablo32 oveq1d ablogrpo adantrr simprrr adantrlr adantrrr
      cgr 3eqtr3d 3impb ) EUAHZAFHZBFHZIZCFHZDFHZIZABETZCDETETZACETZBDETETZJUMU
      PUSIZIZUTCETZDETZVBBETZDETZVAVCVEVFVHDEUMVDUNUOUQKVFVHJVEUNUOUQUMUNUOUSUB
      UMUNUOUSLUMUPUQURMNABCEFGUCOUDUMEUJHZVDVGVAJZEUEZVJVDUTFHZUQURKVKVJVDIZVM
      UQURVJUPVMUSVJUNUOVMABEFGPQUFVJUPUQURMVJUPUQURUGZNUTCDEFGROSUMVJVDVIVCJZV
      LVJVDVBFHZUOURKVPVNVQUOURVJUPUQVQURVJUNUQVQUOVJUNUQVQACEFGPQUHUIVJUNUOUSL
      VONVBBDEFGROSUKUL $.
  $}

  ${
    $d x y G $.  $d x y X $.
    isabli.1 $e |- G e. GrpOp $.
    isabli.2 $e |- dom G = ( X X. X ) $.
    isabli.3 $e |- ( ( x e. X /\ y e. X ) -> ( x G y ) = ( y G x ) ) $.
    $( Properties that determine an Abelian group operation.  (Contributed by
       NM, 5-Nov-2006.)  (New usage is discouraged.) $)
    isabloi $p |- G e. AbelOp $=
      ( cablo wcel cgr cv co wceq wral rgen2a grporn isablo mpbir2an ) CHICJIAK
      ZBKZCLTSCLMZBDNADNEUAABDGOABCDCDEFPQR $.
  $}

  ${
    abldiv.1 $e |- X = ran G $.
    abldiv.3 $e |- D = ( /g ` G ) $.
    $( Law for group multiplication and division.  (Contributed by NM,
       15-Feb-2008.)  (New usage is discouraged.) $)
    ablomuldiv $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
     ( ( A G B ) D C ) = ( ( A D C ) G B ) ) $=
      ( cablo wcel w3a wa co wceq ablocom 3adant3r3 oveq1d 3ancoma cgr ablogrpo
      grpomuldivass sylan sylan2b simpr2 grpodivcl syl3an1 3adant3r2 jca syldan
      3expb 3eqtrd ) EIJZAFJZBFJZCFJZKZLZABEMZCDMBAEMZCDMZBACDMZEMZVABEMZUQURUS
      CDULUMUNURUSNUOABEFGOPQUPULUNUMUOKZUTVBNZUMUNUORULESJZVDVEETZBACDEFGHUAUB
      UCULUPUNVAFJZLVBVCNZUQUNVHULUMUNUOUDULUMUOVHUNULVFUMUOVHVGACDEFGHUEUFUGUH
      ULUNVHVIBVAEFGOUJUIUK $.

    $( Law for double group division.  (Contributed by NM, 29-Feb-2008.)
       (New usage is discouraged.) $)
    ablodivdiv $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
    ( A D ( B D C ) ) = ( ( A D B ) G C ) ) $=
      ( cablo wcel w3a wa co cgr wceq ablogrpo grpodivdiv 3ancomb grpomuldivass
      sylan ablomuldiv eqtr3d sylan2b eqtrd ) EIJZAFJZBFJZCFJZKZLABCDMDMZACBDME
      MZABDMCEMZUEENJZUIUJUKOEPZABCDEFGHQTUIUEUFUHUGKZUKULOUFUGUHRUEUOLACEMBDMZ
      UKULUEUMUOUPUKOUNACBDEFGHSTACBDEFGHUAUBUCUD $.

    $( Law for double group division.  (Contributed by NM, 29-Feb-2008.)
       (New usage is discouraged.) $)
    ablodivdiv4 $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
    ( ( A D B ) D C ) = ( A D ( B G C ) ) ) $=
      ( cablo wcel w3a wa co cgn cfv cgr wceq ablogrpo simpl grpodivcl syl3anc
      3adant3r3 simpr3 eqid grpodivval sylan simpr1 simpr2 simp3 grpoinvcl 3jca
      syl2an ablodivdiv syldan grpodivinv syl3an1 3adant3r1 oveq2d 3eqtr2d ) EI
      JZAFJZBFJZCFJZKZLZABDMZCDMZVFCENOZOZEMZABVIDMZDMZABCEMZDMUTEPJZVDVGVJQZER
      ZVNVDLVNVFFJZVCVOVNVDSVNVAVBVQVCABDEFGHTUBVNVAVBVCUCVFCDEVHFGVHUDZHUEUAUF
      UTVDVAVBVIFJZKVLVJQVEVAVBVSUTVAVBVCUGUTVAVBVCUHUTVNVCVSVDVPVAVBVCUICEVHFG
      VRUJULUKABVIDEFGHUMUNVEVKVMADUTVBVCVKVMQZVAUTVNVBVCVTVPBCDEVHFGVRHUOUPUQU
      RUS $.

    $( Swap the second and third terms in a double division.  (Contributed by
       NM, 29-Feb-2008.)  (New usage is discouraged.) $)
    ablodiv32 $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
   ( ( A D B ) D C ) = ( ( A D C ) D B ) ) $=
      ( cablo wcel w3a wa co wceq ablocom 3adant3r1 ablodivdiv4 3ancomb sylan2b
      oveq2d 3eqtr4d ) EIJZAFJZBFJZCFJZKZLZABCEMZDMACBEMZDMZABDMCDMACDMBDMZUGUH
      UIADUBUDUEUHUINUCBCEFGOPTABCDEFGHQUFUBUCUEUDKUKUJNUCUDUERACBDEFGHQSUA $.

    $( Cancellation law for group division.  ( ~ nnncan analog.)  (Contributed
       by NM, 29-Feb-2008.)  (New usage is discouraged.) $)
    ablonnncan $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A D ( B D C ) ) D C ) = ( A D B ) ) $=
      ( cablo wcel w3a wa wceq simpr1 cgr ablogrpo grpodivcl syl3an1 3adant3r1
      co simpr3 3jca ablodivdiv4 syldan grponpcan oveq2d eqtrd ) EIJZAFJZBFJZCF
      JZKZLZABCDTZDTCDTZAUNCETZDTZABDTUHULUIUNFJZUKKUOUQMUMUIURUKUHUIUJUKNUHUJU
      KURUIUHEOJZUJUKUREPZBCDEFGHQRSUHUIUJUKUAUBAUNCDEFGHUCUDUMUPBADUHUJUKUPBMZ
      UIUHUSUJUKVAUTBCDEFGHUERSUFUG $.

    $( Cancellation law for group division.  ( ~ nncan analog.)  (Contributed
       by NM, 7-Mar-2008.)  (New usage is discouraged.) $)
    ablonncan $p |- ( ( G e. AbelOp /\ A e. X /\ B e. X ) ->
             ( A D ( A D B ) ) = B ) $=
      ( cablo wcel w3a co cgi cfv wceq wa id 3anidm12 ablodivdiv sylan2 sylan
      3impb cgr ablogrpo eqid grpodivid 3adant3 oveq1d grpolid 3adant2 3eqtrd )
      DHIZAEIZBEIZJZAABCKCKZAACKZBDKZDLMZBDKZBUKULUMUOUQNZULUMOUKULULUMJZUTULUM
      VAVAPQAABCDEFGRSUAUNUPURBDUKULUPURNZUMUKDUBIZULVBDUCZACURDEFGURUDZUETUFUG
      UKUMUSBNZULUKVCUMVFVDBURDEFVEUHTUIUJ $.

    $( Cancellation law for group division.  ( ~ nnncan1 analog.)  (Contributed
       by NM, 7-Mar-2008.)  (New usage is discouraged.) $)
    ablonnncan1 $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A D B ) D ( A D C ) ) = ( C D B ) ) $=
      ( cablo wcel w3a wa wceq simpr1 simpr2 cgr ablogrpo grpodivcl 3adant3r2
      co syl3an1 3jca ablodiv32 syldan ablonncan oveq1d eqtrd ) EIJZAFJZBFJZCFJ
      ZKZLZABDTACDTZDTZAUNDTZBDTZCBDTUHULUIUJUNFJZKUOUQMUMUIUJURUHUIUJUKNUHUIUJ
      UKOUHUIUKURUJUHEPJUIUKUREQACDEFGHRUASUBABUNDEFGHUCUDUMUPCBDUHUIUKUPCMUJAC
      DEFGHUESUFUG $.
  $}

  ${
    $d A k m $.  $d B k m $.  $d G k m $.  $d K m $.  $d P k m $.  $d X k m $.
    gxdi.1 $e |- X = ran G $.
    gxdi.2 $e |- P = ( ^g ` G ) $.
    $( Distribution of group power over group operation for abelian groups.
       (Contributed by Paul Chapman, 17-Apr-2009.)
       (New usage is discouraged.) $)
    gxdi $p |- ( ( G e. AbelOp /\ ( A e. X /\ B e. X ) /\ K e. ZZ ) ->
                 ( ( A G B ) P K ) = ( ( A P K ) G ( B P K ) ) ) $=
      ( wcel wceq cc0 oveq2 oveq12d eqeq12d cfv 3ad2ant1 syl2anc eqtr4d syl3anc
      co vm vk cablo wa cz wi cv cneg caddc w3a cgi cgr ablogrpo grpocl syl3an1
      eqid gx0 grpoidcl syl grpolid simp2 simp3 cn0 gxsuc oveq1 3ad2ant3 simp11
      c1 nn0z gxcl ablo4 syl122anc 3eqtrd 3exp syl5 cn nnz cgn gxneg ablocom wb
      eqeq1 mpbird fveq2d grpoinvop zindd 3expb 3impia ) DUCIZAFIZBFIZUDEUEIZAB
      DTZECTZAECTZBECTZDTZJZWIWJWKWLWRUFWMUAUGZCTZAWSCTZBWSCTZDTZJWMKCTZAKCTZBK
      CTZDTZJWMUBUGZCTZAXHCTZBXHCTZDTZJZWMXHUHZCTZAXNCTZBXNCTZDTZJZWMXHVHUITZCT
      ZAXTCTZBXTCTZDTZJZWRWIWJWKUJZUAUBEWSKJZWTXDXCXGWSKWMCLYGXAXEXBXFDWSKACLWS
      KBCLMNWSXHJZWTXIXCXLWSXHWMCLYHXAXJXBXKDWSXHACLWSXHBCLMNWSXTJZWTYAXCYDWSXT
      WMCLYIXAYBXBYCDWSXTACLWSXTBCLMNWSXNJZWTXOXCXRWSXNWMCLYJXAXPXBXQDWSXNACLWS
      XNBCLMNWSEJZWTWNXCWQWSEWMCLYKXAWOXBWPDWSEACLWSEBCLMNYFXDDUKOZYLDTZXGYFXDY
      LYMYFDULIZWMFIZXDYLJWIWJYNWKDUMZPZWIYNWJWKYOYPABDFGUNUOZWMCYLDFGYLUPZHUQQ
      YFYNYLFIZYMYLJYQYFYNYTYQYLDFGYSURUSYLYLDFGYSUTQRYFXEYLXFYLDYFYNWJXEYLJYQW
      IWJWKVAZACYLDFGYSHUQQYFYNWKXFYLJYQWIWJWKVBZBCYLDFGYSHUQQMRXHVCIXHUEIZYFXM
      YEUFXHVIYFUUCXMYEYFUUCXMUJZYAXJADTZXKBDTZDTZYDUUDYAXIWMDTZXLWMDTZUUGUUDYN
      YOUUCYAUUHJYFUUCYNXMYQPZYFUUCYOXMYRPZYFUUCXMVAZWMCDXHFGHVDSXMYFUUHUUIJUUC
      XIXLWMDVEVFUUDWIXJFIZXKFIZWJWKUUIUUGJWIWJWKUUCXMVGZUUDYNWJUUCUUMUUJYFUUCW
      JXMUUAPZUULACDXHFGHVJSZUUDYNWKUUCUUNUUJYFUUCWKXMUUBPZUULBCDXHFGHVJSZUUPUU
      RXJXKABDFGVKVLVMUUDYBUUEYCUUFDUUDYNWJUUCYBUUEJUUJUUPUULACDXHFGHVDSUUDYNWK
      UUCYCUUFJUUJUURUULBCDXHFGHVDSMRVNVOXHVPIUUCYFXMXSUFXHVQYFUUCXMXSUUDXOXJDV
      ROZOZXKUUTOZDTZXRUUDXOXIUUTOZXKXJDTZUUTOZUVCUUDYNYOUUCXOUVDJUUJUUKUULWMCD
      XHUUTFGUUTUPZHVSSUUDXIUVEUUTUUDXIUVEJZXLUVEJZUUDWIUUMUUNUVIUUOUUQUUSXJXKD
      FGVTSXMYFUVHUVIWAUUCXIXLUVEWBVFWCWDUUDYNUUNUUMUVFUVCJUUJUUSUUQXKXJDUUTFGU
      VGWESVMUUDXPUVAXQUVBDUUDYNWJUUCXPUVAJUUJUUPUULACDXHUUTFGUVGHVSSUUDYNWKUUC
      XQUVBJUUJUURUULBCDXHUUTFGUVGHVSSMRVNVOWFWGWH $.
  $}

  ${
    $d ph u x y z $.  $d G u n x y z $.  $d X u n x y z $.  $d U u n x y z $.
    $d N n $.
    isgrpda.1 $e |- ( ph -> X e. _V ) $.
    isgrpda.2 $e |- ( ph -> G : ( X X. X ) --> X ) $.
    isgrpda.3 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) )
                            -> ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $.
    isgrpda.4 $e |- ( ph -> U e. X ) $.
    isgrpda.5 $e |- ( ( ph /\ x e. X ) -> ( U G x ) = x ) $.

    ${
      isgrpda.6 $e |- ( ( ph /\ x e. X ) -> E. n e. X ( n G x ) = U ) $.
      $( Properties that determine a group operation.  (Contributed by Jeff
         Madsen, 1-Dec-2009.)  (New usage is discouraged.) $)
      isgrpda $p |- ( ph -> G e. GrpOp ) $=
        ( vu co wceq wral wrex cvv cgr wcel crn cxp wf cv w3a ralrimivvva oveq1
        wa eqeq1d cbvrexv sylibr ralrimiva eqeq2 rexbidv anbi12d ralbidv rspcev
        jca syl2anc wfo adantr simpr rspceov syl3anc foov sylanbrc forn xpeq12d
        eqcomd feq23d raleqdv raleqbidv anbi2d rexeqbidv 3anbi123d mpbir3and wb
        syl rexeqdv xpexg fex eqid isgrpo mpbird ) AGUAUBZGUCZWHUDZWHGUEZBUFZCU
        FZGPDUFZGPWKWLWMGPZGPQZDWHRZCWHRZBWHRZOUFZWKGPZWKQZWLWKGPZWSQZCWHSZUJZB
        WHRZOWHSZUGZAXHHHUDZHGUEZWODHRZCHRZBHRZXAXCCHSZUJZBHRZOHSZJAWOBCDHHHKUH
        AEHUBZEWKGPZWKQZXBEQZCHSZUJZBHRZXQLAYCBHAWKHUBZUJZXTYBMYFFUFZWKGPZEQZFH
        SYBNYAYICFHWLYGQXBYHEWLYGWKGUIUKULUMUTUNXPYDOEHWSEQZXOYCBHYJXAXTXNYBYJW
        TXSWKWSEWKGUIUKYJXCYACHWSEXBUOUPUQURUSVAAWJXJWRXMXGXQAWIWHXIHGAWHHWHHAX
        IHGVBZWHHQAXJWKWNQDHSCHSZBHRYKJAYLBHYFXRYEWKXSQYLAXRYELVCAYEVDYFXSWKMVK
        CDHHEWKWKGVEVFUNCDBHHHGVGVHXIHGVIVTZYMVJYMVLAWQXLBWHHYMAWPXKCWHHYMAWODW
        HHYMVMVNVNAXFXPOWHHYMAXEXOBWHHYMAXDXNXAAXCCWHHYMWAVOVNVPVQVRAGTUBZWGXHV
        SAXJXITUBZYNJAHTUBZYPYOIIHHTTWBVAXIHTGWCVABCDOTGWHWHWDWEVTWF $.
    $}

    ${
      isgrpod.6 $e |- ( ( ph /\ x e. X ) -> N e. X ) $.
      isgrpod.7 $e |- ( ( ph /\ x e. X ) -> ( N G x ) = U ) $.
      $( Properties that determine a group operation.  (Renamed from ~ isgrpd
         to ~ isgrpod to prevent naming conflict. -NM 5-Jun-2013) (Contributed
         by Jeff Madsen, 1-Dec-2009.)  (New usage is discouraged.) $)
      isgrpod $p |- ( ph -> G e. GrpOp ) $=
        ( vn cv wcel co wceq wa wrex oveq1 eqeq1d rspcev syl2anc isgrpda ) ABCD
        EPFHIJKLMABQZHRUAGHRGUHFSZETZPQZUHFSZETZPHUBNOUMUJPGHUKGTULUIEUKGUHFUCU
        DUEUFUG $.
    $}

    ${
      isablda.6 $e |- ( ( ph /\ x e. X ) -> E. n e. X ( n G x ) = U ) $.
      isablda.7 $e |- ( ( ph /\ ( x e. X /\ y e. X ) )
                              -> ( x G y ) = ( y G x ) ) $.
      $( Properties that determine an Abelian group operation.  (Contributed by
         Jeff Madsen, 11-Jun-2010.)  (New usage is discouraged.) $)
      isabloda $p |- ( ph -> G e. AbelOp ) $=
        ( wcel cv co wceq cdm cgr crn wral cablo isgrpda wa grporndm syl cxp wf
        fdm dmeqd dmxpid syl6eq eqtrd eleq2d anbi12d ex sylbid ralrimivv isablo
        eqid sylanbrc ) AGUAPZBQZCQZGRVFVEGRSZCGUBZUCBVHUCGUDPABCDEFGHIJKLMNUEZ
        AVGBCVHVHAVEVHPZVFVHPZUFVEHPZVFHPZUFZVGAVJVLVKVMAVHHVEAVHGTZTZHAVDVHVPS
        VIGUGUHAVPHHUIZTHAVOVQAVQHGUJVOVQSJVQHGUKUHULHUMUNUOZUPAVHHVFVRUPUQAVNV
        GOURUSUTBCGVHVHVBVAVC $.
    $}

    ${
      isabld.6 $e |- ( ( ph /\ x e. X ) -> N e. X ) $.
      isabld.7 $e |- ( ( ph /\ x e. X ) -> ( N G x ) = U ) $.
      isabld.8 $e |- ( ( ph /\ ( x e. X /\ y e. X ) )
                                            -> ( x G y ) = ( y G x ) ) $.
      $( Properties that determine an Abelian group operation.  (Changed label
         from ~ isabld to ~ isablod -NM 6-Aug-2013.)  (Contributed by Jeff
         Madsen, 5-Dec-2009.)  (New usage is discouraged.) $)
      isablod $p |- ( ph -> G e. AbelOp ) $=
        ( vn cv wcel wceq wa co wrex oveq1 eqeq1d rspcev syl2anc isabloda ) ABC
        DEQFHIJKLMABRZHSUAGHSGUIFUBZETZQRZUIFUBZETZQHUCNOUNUKQGHULGTUMUJEULGUIF
        UDUEUFUGPUH $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Subgroups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SubGrpOp $.

  $( Extend class notation to include the class of subgroups. $)
  csubgo $a class SubGrpOp $.

  $( Define the set of subgroups of ` g ` .  (Contributed by Paul Chapman,
     3-Mar-2008.)  (New usage is discouraged.) $)
  df-subgo $a |- SubGrpOp = ( g e. GrpOp |-> ( GrpOp i^i ~P g ) ) $.

  ${
    $d G g h $.  $d H h $.
    $( The predicate "is a subgroup of ` G ` ."  (Contributed by Paul Chapman,
       3-Mar-2008.)  (Revised by Mario Carneiro, 12-Jul-2014.)
       (New usage is discouraged.) $)
    issubgo $p |- ( H e. ( SubGrpOp ` G ) <->
                   ( G e. GrpOp /\ H e. GrpOp /\ H C_ G ) ) $=
      ( vg cgr wcel csubgo cfv wa wss w3a cpw cin cvv inss2 pwexg ssexg sylancr
      wceq cv pm5.32i pweq ineq2d df-subgo fvmptg mpdan eleq2d elin elpwg bitri
      syl6bb cdm dmmptss elfvdm sseldi pm4.71ri 3anass 3bitr4i ) ADEZBAFGZEZHUR
      BDEZBAIZHZHUTURVAVBJURUTVCURUTBDAKZLZEZVCURUSVEBURVEMEZUSVERURVEVDIVDMEVG
      DVDNADOVEVDMPQCADCSZKZLZVEDMFVHARVIVDDVHAUAUBCUCZUDUEUFVFVABVDEZHVCBDVDUG
      VAVLVBBADUHTUIUJTUTURUTFUKDACDVJFVKULBAFUMUNUOURVAVBUPUQ $.
  $}

  ${
    subgores.1 $e |- W = ran H $.
    $( A subgroup operation is the restriction of its parent group operation to
       its underlying set.  (Contributed by Paul Chapman, 3-Mar-2008.)
       (New usage is discouraged.) $)
    subgores $p |- ( H e. ( SubGrpOp ` G ) -> H = ( G |` ( W X. W ) ) ) $=
      ( csubgo cfv wcel cxp cres wfun wss cdm wceq cgr crn issubgo simp1bi 3syl
      wfo grpofo fofun simp3bi wf simp2bi fof fdm eqimss2 fun2ssres syl3anc wfn
      eqid fofn fnresdm 4syl eqtr2d ) BAEFGZACCHZIZBUQIZBUPAJZBAKZUQBLZKZURUSMU
      PANGZAOZVEHZVEASUTUPVDBNGZVAABPZQAVEVEUKTVFVEAUARUPVDVGVAVHUBUPUQCBUCZVBU
      QMVCUPVGUQCBSZVIUPVDVGVAVHUDZBCDTZUQCBUERUQCBUFUQVBUGRUQABUHUIUPVGVJBUQUJ
      USBMVKVLUQCBULUQBUMUNUO $.

    $( The result of a subgroup operation is the same as the result of its
       parent operation.  (Contributed by Paul Chapman, 3-Mar-2008.)  (Revised
       by Mario Carneiro, 8-Jul-2014.)  (New usage is discouraged.) $)
    subgoov $p |- ( ( H e. ( SubGrpOp ` G ) /\ ( A e. W /\ B e. W ) ) ->
                   ( A H B ) = ( A G B ) ) $=
      ( csubgo cfv wcel wa co cxp cres subgores oveqd ovres sylan9eq ) DCGHIZAE
      IBEIJABDKABCEELMZKABCKRDSABCDEFNOABEECPQ $.
  $}

  ${
    subgornss.1 $e |- X = ran G $.
    subgornss.2 $e |- W = ran H $.
    $( The underlying set of a subgroup is a subset of its parent group's
       underlying set.  (Contributed by Paul Chapman, 3-Mar-2008.)
       (New usage is discouraged.) $)
    subgornss $p |- ( H e. ( SubGrpOp ` G ) -> W C_ X ) $=
      ( csubgo cfv wcel crn cxp cima cres subgores rneqd df-ima syl6eqr imassrn
      syl6eqss 3sstr4g ) BAGHIZBJZAJZCDUAUBACCKZLZUCUAUBAUDMZJUEUABUFABCFNOAUDP
      QAUDRSFET $.
  $}

  ${
    subgoid.1 $e |- U = ( GId ` G ) $.
    subgoid.2 $e |- T = ( GId ` H ) $.
    $( The identity element of a subgroup is the same as its parent's.
       (Contributed by Paul Chapman, 3-Mar-2008.)
       (New usage is discouraged.) $)
    subgoid $p |- ( H e. ( SubGrpOp ` G ) -> T = U ) $=
      ( csubgo cfv wcel wceq co crn id cgr wss issubgo simp2bi grpoidcl syl2anc
      eqid syl subgoov grpolid eqtr3d wb simp1bi subgornss sseldd grpoid mpbird
      syl12anc ) DCGHIZABJZAACKZAJZULAADKZUNAULULADLZIZURUPUNJULMULDNIZURULCNIZ
      USDCOZCDPZQZADUQUQTZFRUAZVEAACDUQVDUBUKULUSURUPAJVCVEAADUQVDFUCSUDULUTACL
      ZIUMUOUEULUTUSVAVBUFULUQVFACDUQVFVFTZVDUGVEUHABCVFVGEUISUJ $.
  $}

  ${
    subgoinv.1 $e |- W = ran H $.
    subgoinv.2 $e |- M = ( inv ` G ) $.
    subgoinv.3 $e |- N = ( inv ` H ) $.
    $( The inverse of a subgroup element is the same as its inverse in the
       parent group.  (Contributed by Mario Carneiro, 8-Jul-2014.)
       (New usage is discouraged.) $)
    subgoinv $p |- ( ( H e. ( SubGrpOp ` G ) /\ A e. W ) ->
                    ( N ` A ) = ( M ` A ) ) $=
      ( csubgo cfv wcel wceq co cgi cgr wss eqid sylan adantr wa grporinv simpl
      issubgo simp2bi grpoinvcl subgoov syl12anc subgoid 3eqtr3d crn wb simp1bi
      simpr subgornss sselda sseldd grpoinvid1 syl3anc mpbird eqcomd ) CBJKLZAF
      LZUAZADKZAEKZVDVEVFMZAVFBNZBOKZMZVDAVFCNZCOKZVHVIVBCPLZVCVKVLMVBBPLZVMCBQ
      ZBCUDZUEZAVLCEFGVLRZIUBSVDVBVCVFFLZVKVHMVBVCUCVBVCUNVBVMVCVSVQACEFGIUFSZA
      VFBCFGUGUHVBVLVIMVCVLVIBCVIRZVRUITUJVDVNABUKZLVFWBLVGVJULVBVNVCVBVNVMVOVP
      UMTVBFWBABCFWBWBRZGUOZUPVDFWBVFVBFWBQVCWDTVTUQAVFVIBDWBWCWAHURUSUTVA $.
  $}

  ${
    $d A x y $.  $d B y $.  $d G x y $.  $d H x y $.  $d Y x y $.
    issubgoilem.1 $e |- ( ( x e. Y /\ y e. Y ) -> ( x H y ) = ( x G y ) ) $.
    $( Lemma for ~ issubgoi .  (Contributed by Paul Chapman, 25-Feb-2008.)
       (New usage is discouraged.) $)
    issubgoilem $p |- ( ( A e. Y /\ B e. Y ) -> ( A H B ) = ( A G B ) ) $=
      ( cv co wceq oveq1 eqeq12d oveq2 vtocl2ga ) AIZBIZFJZPQEJZKCQFJZCQEJZKCDF
      JZCDEJZKABCDGGPCKRTSUAPCQFLPCQELMQDKTUBUAUCQDCFNQDCENMHO $.
  $}

  ${
    $d G a b $.  $d H a b x y $.  $d H b x y z $.  $d N a b y $.
    $d U a b x y $.  $d U b x y z $.  $d Y a b x y $.  $d Y b x y z $.
    issubgoi.1 $e |- G e. GrpOp $.
    issubgoi.2 $e |- X = ran G $.
    issubgoi.3 $e |- U = ( GId ` G ) $.
    issubgoi.4 $e |- N = ( inv ` G ) $.
    issubgoi.5 $e |- Y C_ X $.
    issubgoi.6 $e |- H = ( G |` ( Y X. Y ) ) $.
    issubgoi.7 $e |- ( ( x e. Y /\ y e. Y ) -> ( x G y ) e. Y ) $.
    issubgoi.8 $e |- U e. Y $.
    issubgoi.9 $e |- ( x e. Y -> ( N ` x ) e. Y ) $.
    $( Properties that determine a subgroup.  (Contributed by Paul Chapman,
       25-Feb-2008.)  (New usage is discouraged.) $)
    issubgoi $p |- H e. ( SubGrpOp ` G ) $=
      ( wcel co wceq vz va vb csubgo cfv cgr wss cv crn cvv rnexg ax-mp eqeltri
      ssexi cxp wf wfn wral cres wfo grpofo fof xpss12 mp2an fssres feq1i mpbir
      mp2b ffn oveqi ovres syl5eq issubgoilem eqeltrd rgen2a ffnov mpbir2an w3a
      oveq1d 3adant3 sylan 3impa oveq2d 3adant1 fovcl sylan2 3impb grpoass mpan
      sseli syl3an 3eqtr4d grpolid sylancr eqtrd mpancom grpolinv isgrpoi resss
      wa eqsstri issubgo mpbir3an ) EDUDUERDUFRZEUFREDUGIABUACEAUHZFUEZHHGGDUIZ
      UJJXDXGUJRIDUFUKULUMMUNHHUOZHEUPEXHUQZXEBUHZESZHRZBHURAHURXHGEUPZXIXMXHGD
      XHUSZUPZGGUOZGDUPZXHXPUGZXOXDXPGDUTXQIDGJVAXPGDVBVHHGUGZXSXRMMHGHGVCVDXPG
      XHDVEVDXHGEXNNVFVGXHGEVIULXLABHXEHRZXJHRZWTZXKXEXJDSZHUBUCXEXJDEHUBUHZHRU
      CUHZHRWTYDYEESYDYEXNSYDYEDSEXNYDYENVJYDYEHHDVKVLZVMZOVNZVOABHHHEVPVQZXTYA
      UAUHZHRZVRZXKYJDSZYCYJDSZXKYJESZXEXJYJESZESZXTYAYMYNTYKYBXKYCYJDYGVSVTXTY
      AYKYOYMTZYBXLYKYRYHUBUCXKYJDEHYFVMWAWBYLXEYPDSZXEXJYJDSZDSZYQYNYAYKYSUUAT
      XTYAYKWTZYPYTXEDUBUCXJYJDEHYFVMWCWDXTYAYKYQYSTZUUBXTYPHRUUCXJYJHHHEYIWEUB
      UCXEYPDEHYFVMWFWGXTXEGRZYAXJGRZYKYJGRZYNUUATZHGXEMWJZHGXJMWJHGYJMWJXDUUDU
      UEUUFVRUUGIXEXJYJDGJWHWIWKWLWLPXTCXEESZCXEDSZXECHRXTUUIUUJTPUBUCCXEDEHYFV
      MWIXTXDUUDUUJXETIUUHXECDGJKWMWNWOQXTXFXEESZXFXEDSZCXFHRXTUUKUULTQUBUCXFXE
      DEHYFVMWPXTXDUUDUULCTIUUHXECDFGJKLWQWNWOWREXNDNDXHWSXADEXBXC $.
  $}

  ${
    $d G x y $.  $d H x y $.
    $( A subgroup of an Abelian group is Abelian.  (Contributed by Paul
       Chapman, 25-Apr-2008.)  (New usage is discouraged.) $)
    subgoablo $p |- ( ( G e. AbelOp /\ H e. ( SubGrpOp ` G ) )
           -> H e. AbelOp ) $=
      ( vx vy cablo wcel csubgo cfv wa cv co wceq crn wral sseld isablo subgoov
      eqid cgr adantll simpr subgornss anim12d simprbi rsp2 syl sylan9r ancom2s
      wi imp 3eqtr4d ralrimivva wss issubgo simp2bi biimpri sylan syl2anc ) AEF
      ZBAGHFZIZUTCJZDJZBKZVCVBBKZLZDBMZNCVGNZBEFZUSUTUAVAVFCDVGVGVAVBVGFZVCVGFZ
      IZIVBVCAKZVCVBAKZVDVEVAVLVMVNLZUTVLVBAMZFZVCVPFZIZUSVOUTVJVQVKVRUTVGVPVBA
      BVGVPVPRZVGRZUBZOUTVGVPVCWBOUCUSVODVPNCVPNZVSVOUIUSASFZWCCDAVPVTPUDVOCDVP
      VPUEUFUGUJUTVLVDVMLUSVBVCABVGWAQTUTVLVEVNLZUSUTVKVJWEVCVBABVGWAQUHTUKULUT
      BSFZVHVIUTWDWFBAUMABUNUOVIWFVHICDBVGWAPUPUQUR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Operation properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ass $.

  $( Extend class notation with a device to add associativity to internal
     operations. $)
  cass $a class Ass $.

  ${
    $d g x y z $.
    $( A device to add associativity to various sorts of internal operations.
       The definition is meaningful when ` g ` is a magma at least.
       (Contributed by FL, 1-Nov-2009.)  (New usage is discouraged.) $)
    df-ass $a |- Ass = { g | A. x e. dom dom g A. y e. dom dom g
    A. z e. dom dom g ( ( x g y ) g z ) = ( x g ( y g z ) ) } $.
  $}

  $c ExId $.

  $( Extend class notation with the class of all the internal operations with
     an identity element. $)
  cexid $a class ExId $.

  ${
    $d g x y $.
    $( A device to add an identity element to various sorts of internal
       operations.  (Contributed by FL, 2-Nov-2009.)
       (New usage is discouraged.) $)
    df-exid $a |- ExId = { g | E. x e. dom dom g A. y e. dom dom g
    ( ( x g y ) = y /\ ( y g x ) = y ) } $.
  $}

  ${
    $d G g x y z $.  $d X g x y z $.
    isass.1 $e |- X = dom dom G $.
    $( The predicate "is an associative operation".  (Contributed by FL,
       1-Nov-2009.)  (New usage is discouraged.) $)
    isass $p |- ( G e. A -> ( G e. Ass <-> A. x e. X A. y e. X A. z e. X
      ( ( x G y ) G z ) = ( x G ( y G z ) ) ) ) $=
      ( vg cv co wceq cdm wral wcel w3a wi wal eleq2d oveq eqtrd cass 3anbi123d
      dmeq oveq1d oveq2d eqeq12d imbi12d albidv 2albidv r3al 3bitr4g eqcomi a1i
      dmeqd raleqdv raleqbidv 2ralbidv 3bitrd df-ass elab2g ) AIZBIZHIZJZCIZVCJ
      ZVAVBVEVCJZVCJZKZCVCLZLZMBVKMAVKMZVAVBEJZVEEJZVAVBVEEJZEJZKZCFMZBFMAFMZHE
      UADVCEKZVLVQCELZLZMZBWBMZAWBMZWCBFMZAFMVSVTVAVKNZVBVKNZVEVKNZOZVIPZCQZBQA
      QVAWBNZVBWBNZVEWBNZOZVQPZCQZBQAQVLWEVTWLWRABVTWKWQCVTWJWPVIVQVTWGWMWHWNWI
      WOVTVKWBVAVTVJWAVCEUCUNZRVTVKWBVBWSRVTVKWBVEWSRUBVTVFVNVHVPVTVFVMVEVCJVNV
      TVDVMVEVCVAVBVCESUDVMVEVCESTVTVHVAVOVCJVPVTVGVOVAVCVBVEVCESUEVAVOVCESTUFU
      GUHUIVIABCVKVKVKUJVQABCWBWBWBUJUKVTWDWFAWBFWBFKVTFWBGULUMZVTWCBWBFWTUOUPV
      TWCVRABFFVTVQCWBFWTUOUQURABCHUSUT $.
  $}

  ${
    $d G g x y $.  $d X g x y $.
    isexid.1 $e |- X = dom dom G $.
    $( The predicate ` G ` has a left and right identity element.  (Contributed
       by FL, 2-Nov-2009.)  (Revised by Mario Carneiro, 22-Dec-2013.)
       (New usage is discouraged.) $)
    isexid $p |- ( G e. A -> ( G e. ExId <-> E. x e. X A. y e. X
      ( ( x G y ) = y /\ ( y G x ) = y ) ) ) $=
      ( vg cv co wceq wa cdm wral wrex cexid dmeq dmeqd syl6eqr oveq eqeq1d
      anbi12d raleqbidv rexeqbidv df-exid elab2g ) AHZBHZGHZIZUGJZUGUFUHIZUGJZK
      ZBUHLZLZMZAUONUFUGDIZUGJZUGUFDIZUGJZKZBEMZAENGDOCUHDJZUPVBAUOEVCUODLZLEVC
      UNVDUHDPQFRZVCUMVABUOEVEVCUJURULUTVCUIUQUGUFUGUHDSTVCUKUSUGUGUFUHDSTUAUBU
      CABGUDUE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Group-like structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Magma $.

  $( Extend class notation with the class of all magmas. $)
  cmagm $a class Magma $.

  ${
    $d g t $.
    $( A magma is a binary internal operation.  (Contributed by FL,
       2-Nov-2009.)  (New usage is discouraged.) $)
    df-mgm $a |- Magma = { g | E. t g : ( t X. t ) --> t } $.
  $}

  ${
    $d G g t $.  $d X t $.
    ismgm.1 $e |- X = dom dom G $.
    $( The predicate "is a magma".  (Contributed by FL, 2-Nov-2009.)
       (New usage is discouraged.) $)
    ismgm $p |- ( G e. A -> ( G e. Magma <-> G : ( X X. X ) --> X ) ) $=
      ( vt vg wcel cmagm cv cdm wceq cxp wf wa wex c0 wi dmeq wb cvv exbidv f00
      feq1 df-mgm elab2g dm0 dmeqi eqtri syl6req syl adantr sylbi xpeq12 anidms
      feq23 mpancom eqeq1 imbi12d mpbiri wn fdm wne df-ne sylbir eqeq1d biimpcd
      dmxp eqcoms 3syl com12 pm2.61i pm4.71ri exbii syl6bb dmexg eqcomi xpeq12i
      feq23i ceqsexgv bitrd ) BAGZBHGZEIZBJZJZKZWCWCLZWCBMZNZEOZCCLZCBMZWAWBWHE
      OZWJWGWCFIZMZEOWMFBHAWNBKWOWHEWGWCWNBUCUAEFUDUEWHWIEWHWFWCPKZWHWFQZWPWQPP
      LZPBMZPWEKZQWSBPKZWRPKZNWTWRBUBXAWTXBXAWDPJZKZWTBPRXDWEXCJZPWDXCRXEXCPXCP
      UFUGUFUHUIUJUKULWPWHWSWFWTWGWRKZWPWHWSSWPXFWCPWCPUMUNWGWCWRPBUOUPWCPWEUQU
      RUSWHWPUTZWFWHWDWGKWEWGJZKXGWFQZWGWCBVAWDWGRXIXHWEXGXHWEKWFXGXHWCWEXGWCPV
      BXHWCKWCPVCWCWCVGVDVEVFVHVIVJVKVLVMVNWAWDTGWETGWJWLSBAVOWDTVOWHWLEWETWFWH
      WEWELZWEBMZWLWGXJKZWFWHXKSWFXLWCWEWCWEUMUNWGWCXJWEBUOUPXJWEWKCBWECWECCWED
      VPZXMVQXMVRVNVSVIVT $.
  $}

  ${
    clmgm.1 $e |- X = dom dom G $.
    $( Closure of a magma.  (Contributed by FL, 14-Sep-2010.)
       (New usage is discouraged.) $)
    clmgm $p |- ( ( G e. Magma /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      ( cmagm wcel co wi cxp wf ismgm fovrn 3exp syl6bi pm2.43i 3imp ) CFGZADGZ
      BDGZABCHDGZRSTUAIIZRRDDJDCKZUBFCDELUCSTUAABDDDCMNOPQ $.
  $}

  ${
    $d G u x y $.  $d X u x y $.
    opidon.1 $e |- X = dom dom G $.
    $( An operation with a left and right identity element is onto.
       (Contributed by FL, 2-Nov-2009.)  (Revised by Mario Carneiro,
       22-Dec-2013.)  (New usage is discouraged.) $)
    opidon $p |- ( G e. ( Magma i^i ExId ) ->
      G : ( X X. X ) -onto-> X ) $=
      ( vy vu vx cmagm cexid cin wcel cxp wf cv co wceq wrex wral wfo sseli syl
      inss1 ismgm ibi wa inss2 isexid biimpd sylc simpl ralimi oveq2 id eqeq12d
      rspcv eqeq1d syl5bb rspcev ex syld syl5 reximdv impcom ralrimiva sylanbrc
      eqcom foov ) AGHIZJZBBKZBALZDMZEMZFMZANZOZFBPZEBPZDBQZVIBARVHAGJZVJVGGAGH
      UASVSVJGABCUBUCTVHVNVMOZVMVLANVMOZUDZFBQZEBPZVRVHAHJZWEWDVGHAGHUESZWFWEWE
      WDEFHABCUFUGUHWDVQDBVKBJZWDVQWGWCVPEBWCVTFBQZWGVPWBVTFBVTWAUIUJWGWHVLVKAN
      ZVKOZVPVTWJFVKBVMVKOZVNWIVMVKVMVKVLAUKZWKULUMUNWGWJVPVOWJFVKBVOVNVKOWKWJV
      KVNVEWKVNWIVKWLUOUPUQURUSUTVAVBVCTEFDBBBAVFVD $.
  $}

  $( Range of an operation with a left and right identity element.
     (Contributed by FL, 2-Nov-2009.)  (New usage is discouraged.) $)
  rngopid $p |- ( G e. ( Magma i^i ExId ) -> ran G = dom dom G ) $=
    ( cmagm cexid cin wcel cdm cxp wfo crn wceq eqid opidon forn syl ) ABCDEAFF
    ZOGZOAHAIOJAOOKLPOAMN $.

  ${
    opidon2.1 $e |- X = ran G $.
    $( An operation with a left and right identity element is onto.
       (Contributed by FL, 2-Nov-2009.)  (New usage is discouraged.) $)
    opidon2 $p |- ( G e. ( Magma i^i ExId ) ->
      G : ( X X. X ) -onto-> X ) $=
      ( cmagm cexid cin wcel cdm cxp wfo eqid opidon wceq crn syl5req wb xpeq12
      forn anidms syl foeq2 foeq3 bitrd biimpd mpcom ) ADEFGAHHZUFIZUFAJZBBIZBA
      JZAUFUFKLUFBMZUHUJUHBANUFCUGUFAROUKUHUJUKUHUIUFAJZUJUKUGUIMZUHULPUKUMUFBU
      FBQSUGUIUFAUATUFBUIAUBUCUDUET $.

  $}

  ${
    $d G u x $.  $d X u x $.
    isexid2.1 $e |- X = ran G $.
    $( If ` G e. ( Magma i^i ExId ) ` , then it has a left and right identity
       element that belongs to the range of the operation.  (Contributed by FL,
       12-Dec-2009.)  (Revised by Mario Carneiro, 22-Dec-2013.)
       (New usage is discouraged.) $)
    isexid2 $p |- ( G e. ( Magma i^i ExId ) -> E. u e. X A. x e. X
      ( ( u G x ) = x /\ ( x G u ) = x ) ) $=
      ( crn wceq cmagm cexid cin wcel cv co wa wral wrex cdm raleq rexeqbi1dv
      wi rngopid elin isexid ibi adantl sylbi eqeq2 imbi12d syl5ibr mpcom com12
      eqid a1d sylibrd ax-mp ) DCFZGZCHIJKZBLZALZCMUTGUTUSCMUTGNZADOZBDPZTEUQUR
      VAAUPOZBUPPZVCURUQVEUPCQQZGZURUQVETZCUAURVHVGDVFGZVAAVFOZBVFPZTZURCHKZCIK
      ZNVLCHIUBVNVLVMVNVKVIVNVKBAICVFVFULUCUDUMUEUFVGUQVIVEVKUPVFDUGVDVJBUPVFVA
      AUPVFRSUHUIUJUKVBVDBDUPVAADUPRSUNUO $.
  $}

  ${
    $d G u x y $.  $d X u x y $.
    exidu1.1 $e |- X = ran G $.
    $( Unicity of the left and right identity element of a magma when it
       exists.  (Contributed by FL, 12-Dec-2009.)  (Revised by Mario Carneiro,
       22-Dec-2013.)  (New usage is discouraged.) $)
    exidu1 $p |- ( G e. ( Magma i^i ExId ) ->
      E! u e. X A. x e. X ( ( u G x ) = x /\ ( x G u ) = x ) ) $=
      ( vy wcel cv co wceq wa wral weq ralimi oveq2 id eqeq12d rspcv syl5 oveq1
      cmagm cexid cin wrex wreu isexid2 simpl simpr im2anan9r eqtr2 eqcomd syl6
      wi rgen2a a1i eqeq1d anbi12d ralbidv reu4 sylanbrc ) CUAUBUCGZBHZAHZCIZVC
      JZVCVBCIZVCJZKZADLZBDUDVIFHZVCCIZVCJZVCVJCIZVCJZKZADLZKZBFMZUMZFDLBDLZVIB
      DUEABCDEUFVTVAVSBFDVBDGZVJDGZKVQVBVJCIZVJJZWCVBJZKZVRWBVIWDWAVPWEVIVEADLW
      BWDVHVEADVEVGUGNVEWDAVJDAFMZVDWCVCVJVCVJVBCOWGPQRSVPVNADLWAWEVOVNADVLVNUH
      NVNWEAVBDABMZVMWCVCVBVCVBVJCTWHPQRSUIWFVJVBWCVJVBUJUKULUNUOVIVPBFDVRVHVOA
      DVRVEVLVGVNVRVDVKVCVBVJVCCTUPVRVFVMVCVBVJVCCOUPUQURUSUT $.
  $}

  ${
    $d G u x $.  $d X u x $.
    idrval.1 $e |- X = ran G $.
    idrval.2 $e |- U = ( GId ` G ) $.
    $( The value of the identity element.  (Contributed by FL, 12-Dec-2009.)
       (Revised by Mario Carneiro, 22-Dec-2013.)
       (New usage is discouraged.) $)
    idrval $p |- ( G e. A -> U = ( iota_ u e. X
                   A. x e. X ( ( u G x ) = x /\ ( x G u ) = x ) ) ) $=
      ( wcel cgi cfv cv co wceq wa wral crio gidval syl5eq ) ECIDEJKBLZALZEMUAN
      UATEMUANOAFPBFQHABECFGRS $.
  $}

  ${
    $d G u x $.  $d X u x $.
    iorlid.1 $e |- X = ran G $.
    iorlid.2 $e |- U = ( GId ` G ) $.
    $( A magma right and left identity belongs to the underlying set of the
       operation.  (Contributed by FL, 12-Dec-2009.)  (Revised by Mario
       Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    iorlid $p |- ( G e. ( Magma i^i ExId ) -> U e. X ) $=
      ( vu vx cmagm cexid cin wcel cv co wceq wa wral crio idrval wreu exidu1
      riotacl syl eqeltrd ) BHIJZKZAFLZGLZBMUGNUGUFBMUGNOGCPZFCQZCGFUDABCDERUEU
      HFCSUICKGFBCDTUHFCUAUBUC $.
  $}

  ${
    $d A x $.  $d G u x y $.  $d U u x y $.  $d X u x y $.
    cmpidelt.1 $e |- X = ran G $.
    cmpidelt.2 $e |- U = ( GId ` G ) $.
    $( A magma right and left identity element keeps the other elements
       unchanged.  (Contributed by FL, 12-Dec-2009.)  (Revised by Mario
       Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    cmpidelt $p |- ( ( G e. ( Magma i^i ExId ) /\ A e. X ) ->
      ( ( U G A ) = A /\ ( A G U ) = A ) ) $=
      ( vx vu cmagm wcel cv co wceq wa wral oveq1 eqeq1d oveq2 anbi12d eqeq12d
      cexid cin crio idrval eqcomd wreu wb iorlid exidu1 ralbidv riota2 syl2anc
      mpbird id rspccva sylan ) CIUAUBZJZBGKZCLZUSMZUSBCLZUSMZNZGDOZADJBACLZAMZ
      ABCLZAMZNZURVEHKZUSCLZUSMZUSVKCLZUSMZNZGDOZHDUCZBMZURBVRGHUQBCDEFUDUEURBD
      JVQHDUFVEVSUGBCDEFUHGHCDEUIVQVEHDBVKBMZVPVDGDVTVMVAVOVCVTVLUTUSVKBUSCPQVT
      VNVBUSVKBUSCRQSUJUKULUMVDVJGADUSAMZVAVGVCVIWAUTVFUSAUSABCRWAUNZTWAVBVHUSA
      USABCPWBTSUOUP $.
  $}

  $c SemiGrp $.

  $( Extend class notation with the class of all semi-groups. $)
  csem $a class SemiGrp $.

  $( A semi-group is an associative magma.  (Contributed by FL, 2-Nov-2009.)
     (New usage is discouraged.) $)
  df-sgr $a |- SemiGrp = ( Magma i^i Ass ) $.

  $( A semi-group is a magma.  (Contributed by FL, 2-Nov-2009.)
     (New usage is discouraged.) $)
  smgrpismgm $p |- ( G e. SemiGrp -> G e. Magma ) $=
    ( cmagm wcel cass cin csem elin simplbi df-sgr eleq2s ) ABCZABDEZFALCKADCAB
    DGHIJ $.

  $( A semi-group is associative.  (Contributed by FL, 2-Nov-2009.)
     (New usage is discouraged.) $)
  smgrpisass $p |- ( G e. SemiGrp -> G e. Ass ) $=
    ( cass wcel cmagm cin csem elin simprbi df-sgr eleq2s ) ABCZADBEZFALCADCKAD
    BGHIJ $.

  ${
    $d G x y z $.  $d X x y z $.
    issmgrp.1 $e |- X = dom dom G $.
    $( The predicate "is a semi-group".  (Contributed by FL, 2-Nov-2009.)
       (New usage is discouraged.) $)
    issmgrp $p |- ( G e. A -> ( G e. SemiGrp
       <-> ( G : ( X X. X ) --> X /\ A. x e. X A. y e. X A. z e. X
         ( ( x G y ) G z ) = ( x G ( y G z ) ) ) ) ) $=
      ( csem wcel cmagm cass cin cxp wf cv co wceq wral wa syl5bb df-sgr eleq2i
      elin ismgm isass anbi12d ) EHIEJKLZIZEDIZFFMFENZAOZBOZEPCOZEPUKULUMEPEPQC
      FRBFRAFRZSZHUGEUAUBUHEJIZEKIZSUIUOEJKUCUIUPUJUQUNDEFGUDABCDEFGUEUFTT $.
  $}

  ${
    $d G x y z $.  $d X x y z $.
    smgrpmgm.1 $e |- X = dom dom G $.
    $( A semi-group is a magma.  (Contributed by FL, 2-Nov-2009.)
       (New usage is discouraged.) $)
    smgrpmgm $p |- ( G e. SemiGrp -> G : ( X X. X ) --> X ) $=
      ( vx vy vz csem wcel cxp wf cv co wceq wral issmgrp simpl syl6bi pm2.43i
      wa ) AGHZBBIBAJZTTUADKZEKZALFKZALUBUCUDALALMFBNEBNDBNZSUADEFGABCOUAUEPQR
      $.
  $}

  ${
    $d G x y z $.  $d X x y z $.
    smgrpass.1 $e |- X = dom dom G $.
    $( A semi-group is associative.  (Contributed by FL, 2-Nov-2009.)
       (New usage is discouraged.) $)
    smgrpass $p |- ( G e. SemiGrp ->
      A. x e. X A. y e. X A. z e. X ( ( x G y ) G z ) = ( x G ( y G z ) ) ) $=
      ( csem wcel cv co wceq wral cxp wf wa issmgrp simpr syl6bi pm2.43i ) DGHZ
      AIZBIZDJCIZDJUAUBUCDJDJKCELBELAELZTTEEMEDNZUDOUDABCGDEFPUEUDQRS $.
  $}

  $c MndOp $.

  $( Extend class notation with the class of all monoids. $)
  cmndo $a class MndOp $.

  $( A monoid is a semi-group with an identity element.  (Contributed by FL,
     2-Nov-2009.)  (New usage is discouraged.) $)
  df-mndo $a |- MndOp = ( SemiGrp i^i ExId ) $.

  $( A monoid is a semi-group.  (Contributed by FL, 2-Nov-2009.)
     (New usage is discouraged.) $)
  mndoissmgrp $p |- ( G e. MndOp -> G e. SemiGrp ) $=
    ( csem wcel cexid cin cmndo elin simplbi df-mndo eleq2s ) ABCZABDEZFALCKADC
    ABDGHIJ $.

  $( A monoid has an identity element.  (Contributed by FL, 2-Nov-2009.)
     (New usage is discouraged.) $)
  mndoisexid $p |- ( G e. MndOp -> G e. ExId ) $=
    ( cexid wcel csem cin cmndo elin simprbi df-mndo eleq2s ) ABCZADBEZFALCADCK
    ADBGHIJ $.

  $( A monoid is a magma.  (Contributed by FL, 2-Nov-2009.)
     (New usage is discouraged.) $)
  mndoismgm $p |- ( G e. MndOp -> G e. Magma ) $=
    ( cmndo wcel csem cmagm mndoissmgrp smgrpismgm syl ) ABCADCAECAFAGH $.

  $( A monoid is a magma with an identity element.  (Contributed by FL,
     18-Feb-2010.)  (New usage is discouraged.) $)
  mndomgmid $p |- ( G e. MndOp -> G e. ( Magma i^i ExId ) ) $=
    ( cmndo wcel cmagm cexid cin mndoismgm mndoisexid elin sylanbrc ) ABCADCAEC
    ADEFCAGAHADEIJ $.

  ${
    $d G x y $.  $d X x y $.
    ismndo.1 $e |- X = dom dom G $.
    $( The predicate "is a monoid".  (Contributed by FL, 2-Nov-2009.)  (Revised
       by Mario Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    ismndo $p |- ( G e. A -> ( G e. MndOp
     <-> ( G e. SemiGrp /\ E. x e. X A. y e. X
      ( ( x G y ) = y /\ ( y G x ) = y ) ) ) ) $=
      ( cmndo wcel csem cexid cin cv co wceq wa wral wrex df-mndo eleq2i syl5bb
      elin isexid anbi2d ) DGHDIJKZHZDCHZDIHZALZBLZDMUINUIUHDMUINOBEPAEQZOZGUDD
      RSUEUGDJHZOUFUKDIJUAUFULUJUGABCDEFUBUCTT $.
  $}

  ${
    $d G x y z $.  $d X x y z $.
    ismndo1.1 $e |- X = dom dom G $.
    $( The predicate "is a monoid".  (Contributed by FL, 2-Nov-2009.)  (Revised
       by Mario Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    ismndo1 $p |- ( G e. A -> ( G e. MndOp <->
      ( G : ( X X. X ) --> X /\
        A. x e. X A. y e. X A. z e. X
          ( ( x G y ) G z ) = ( x G ( y G z ) ) /\
        E. x e. X A. y e. X
         ( ( x G y ) = y /\ ( y G x ) = y ) ) ) ) $=
      ( wcel cmndo csem cv co wceq wa wral wrex cxp wf w3a ad2antrl ismndo 3jca
      smgrpmgm smgrpass simprr 3simpa issmgrp syl5ibr imp simpr3 impbida bitrd
      jca ) EDHZEIHEJHZAKZBKZELZUQMUQUPELUQMNBFOAFPZNZFFQFERZURCKZELUPUQVBELELM
      CFOBFOAFOZUSSZABDEFGUAUNUTVDUNUTNVAVCUSUOVAUNUSEFGUCTUOVCUNUSABCEFGUDTUNU
      OUSUEUBUNVDNUOUSUNVDUOVDUOUNVAVCNVAVCUSUFABCDEFGUGUHUIUNVAVCUSUJUMUKUL $.
  $}

  ${
    $d G x y z $.  $d X x y z $.
    ismndo2.1 $e |- X = ran G $.
    $( The predicate "is a monoid".  (Contributed by FL, 2-Nov-2009.)  (Revised
       by Mario Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    ismndo2 $p |- ( G e. A -> ( G e. MndOp <->
      ( G : ( X X. X ) --> X /\
        A. x e. X A. y e. X A. z e. X
          ( ( x G y ) G z ) = ( x G ( y G z ) ) /\
        E. x e. X A. y e. X
         ( ( x G y ) = y /\ ( y G x ) = y ) ) ) ) $=
      ( wcel cdm wceq cxp wf cv co wral wrex w3a wi a1i wb cmndo wa cmagm cexid
      crn cin mndomgmid rngopid syl syl5eq dmxpid syl6req 3ad2ant1 eqid ismndo1
      fdm dmeqd xpid11 biimpri feq23 mpancom raleq raleqbi1dv rexeqbi1dv bibi2d
      3anbi123d syl5ibrcom pm5.21ndd ) EDHZFEIZIZJZEUAHZFFKZFELZAMZBMZENZCMZENV
      PVQVSENENJZCFOZBFOZAFOZVRVQJVQVPENVQJUBZBFOZAFPZQZVMVLRVIVMFEUEZVKGVMEUCU
      DUFHWHVKJEUGEUHUIUJSWGVLRVIVOWCVLWFVOVKVNIFVOVJVNVNFEUPUQFUKULUMSVIVMWGTV
      LVMVKVKKZVKELZVTCVKOZBVKOZAVKOZWDBVKOZAVKPZQZTABCDEVKVKUNUOVLWGWPVMVLVOWJ
      WCWMWFWOVNWIJZVLVOWJTWQVLFVKURUSVNFWIVKEUTVAWBWLAFVKWAWKBFVKVTCFVKVBVCVCW
      EWNAFVKWDBFVKVBVDVFVEVGVH $.
  $}

  ${
    $d G w x y z $.
    $( A group is a monoid.  (Contributed by FL, 2-Nov-2009.)  (Revised by
       Mario Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    grpomndo $p |- ( G e. GrpOp -> G e. MndOp ) $=
      ( vx vy vz vw cgr wcel cmndo crn cxp wf cv co wceq wral wrex wa w3a eqid
      wi isgrpo biimpd grpoidinv simpl ralimi reximi biimprcd 3exp impcom com3l
      ismndo2 syl mpcom exp3acom3r a1i com13 3imp syli pm2.43i ) AFGZAHGZUTUTAI
      ZVBJVBAKZBLZCLZAMZDLZAMVDVEVGAMAMNDVBOCVBOBVBOZELZVDAMVDNVEVDAMZVINCVBPQB
      VBOEVBPZRZVAUTUTVLBCDEFAVBVBSZUAUBVCVHVKUTVATZVKVHVCVNVHVCVNTTVKUTVHVCVAV
      FVENVJVENQZVIVEAMVDNVEVIAMVDNQEVBPZQZCVBOZBVBPZUTVHVCQZVATZCEBAVBVMUCVSVO
      CVBOZBVBPZUTWATVRWBBVBVQVOCVBVOVPUDUEUFVTWCUTVAVCVHWCVNTVCVHWCVNUTVAVCVHW
      CRBCDFAVBVMUKUGUHUIUJULUMUNUOUPUQURUS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of Abelian groups
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d u x y z A $.
    ablsn.1 $e |- A e. _V $.
    $( The Abelian group operation for the singleton group.  (Contributed by
       NM, 5-Nov-2006.)  (New usage is discouraged.) $)
    ablosn $p |- { <. <. A , A >. , A >. } e. AbelOp $=
      ( vx vy cop csn grposn cdm cxp dmsnop xpsn eqtr4i cv wcel wceq co elsn wa
      oveq12 oveq2 oveq1 sylan9eq eqtr4d syl2anb isabloi ) CDAAEZAEFZAFZABGUGHU
      FFUHUHIUFABJAABBKLCMZUHNUIAOZDMZAOZUIUKUGPZUKUIUGPZOUKUHNCAQDAQUJULRUMAAU
      GPZUNUIAUKAUGSUJULUNUKAUGPUOUIAUKUGTUKAAUGUAUBUCUDUE $.

    $( The identity element of the trivial group.  (Contributed by FL,
       21-Jun-2010.)  (Proof shortened by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    gidsn $p |- ( GId ` { <. <. A , A >. , A >. } ) = A $=
      ( cop csn cgr wcel cgi wceq grposn opex rnsnop eqcomi eqid grpoidcl elsni
      cfv crn mp2b ) AACZACDZEFTGPZADZFUAAHABIUATUBTQUBSAAAJKLUAMNUAAOR $.

    $( The inverse function of the trivial group.  (Contributed by FL,
       21-Jun-2010.)  (Proof shortened by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    ginvsn $p |- ( inv ` { <. <. A , A >. , A >. } ) = ( _I |` { A } ) $=
      ( cid cfv cop csn cres cgn cvv wcel wceq fvi ax-mp opeq2i sneqi wf1o f1of
      wfn wf mp2b f1ovi ffn fnressn mp2an cgr grposn crn rnsnop eqcomi grpoinvf
      opex eqid fsn mpbi 3eqtr4ri ) AACDZEZFZAAEZFZCAFZGZUSAEFZHDZUQUSUPAAAIJZU
      PAKBAILMNOCIRZVEVBURKIICPIICSVFUAIICQIICUBTBIACUCUDVAVAVDSZVDUTKVCUEJVAVA
      VDPVGABUFVCVDVAVCUGVAUSAAAUKUHUIVDULUJVAVAVDQTAAVDBBUMUNUO $.
  $}

  ${
    $d x y z A $.
    $( Complex number addition is an Abelian group operation.  (Contributed by
       NM, 5-Nov-2006.)  (New usage is discouraged.) $)
    cnaddablo $p |- + e. AbelOp $=
      ( vx vy vz caddc cc cc0 cv cneg cnex ax-addf addass 0cn addid2 negcl wcel
      co wceq addcom mpdan negid eqtr3d isgrpoi cxp fdmi isabloi ) ABDEABCFDAGZ
      HZEIJUFBGZCGKLUFMUFNZUFEOZUFUGDPZUGUFDPZFUJUGEOUKULQUIUFUGRSUFTUAUBEEUCED
      JUDUFUHRUE $.

    $( The group identity element of complex number addition is zero.
       (Contributed by Steve Rodriguez, 3-Dec-2006.)  (Revised by Mario
       Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    cnid $p |- 0 = ( GId ` + ) $=
      ( vy vx caddc cgi cfv cv co wceq cc wral crio cc0 cgr wcel cablo ablogrpo
      cnaddablo ax-mp cxp ax-addf fdmi grporn eqid grpoidval addid2 rgen wb 0cn
      wreu grpoideu oveq1 eqeq1d ralbidv riota2 mp2an mpbi eqtr2i ) CDEZAFZBFZC
      GZUTHZBIJZAIKZLCMNZURVDHCONVEQCPRZBAURCICIVFIISICTUAUBZURUCUDRLUTCGZUTHZB
      IJZVDLHZVIBIUTUEUFLINVCAIUIZVJVKUGUHVEVLVFBACIVGUJRVCVJAILUSLHZVBVIBIVMVA
      VHUTUSLUTCUKULUMUNUOUPUQ $.

    $( Value of the group inverse of complex number addition.  (Contributed by
       Steve Rodriguez, 3-Dec-2006.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    addinv $p |- ( A e. CC -> ( ( inv ` + ) ` A ) = -u A ) $=
      ( vy cc wcel caddc cgn cfv cv co cc0 wceq crio cneg cgr cablo mpan eqeq1d
      0cn wreu mpbid cnaddablo ablogrpo ax-mp cxp ax-addf fdmi grporn cnid eqid
      grpoinvval cmin df-neg oveq1i npcan syl5eq wb negcl negeu mpan2 wa addcom
      reubidva oveq1 riota2 syl2anc eqtrd ) ACDZAEFGZGZBHZAEIZJKZBCLZAMZENDZVGV
      IVMKEODVOUAEUBUCZBAJEVHCECVPCCUDCEUEUFUGUHVHUIUJPVGVNAEIZJKZVMVNKZVGVQJAU
      KIZAEIZJVNVTAEAULUMJCDZVGWAJKRJAUNPUOVGVNCDVLBCSZVRVSUPAUQVGAVJEIZJKZBCSZ
      WCVGWBWFRBAJURUSVGWEVLBCVGVJCDUTWDVKJAVJVAQVBTVLVRBCVNVJVNKVKVQJVJVNAEVCQ
      VDVETVF $.

    $( The real numbers under addition comprise a subgroup of the complex
       numbers under addition.  (Contributed by Paul Chapman, 25-Apr-2008.)
       (New usage is discouraged.) $)
    readdsubgo $p |- ( + |` ( RR X. RR ) ) e. ( SubGrpOp ` + ) $=
      ( vx vy cc0 caddc cr cxp cres cgn cfv cablo wcel cnaddablo ablogrpo ax-mp
      cc cgr ax-addf fdmi eqid cv grporn cnid ax-resscn readdcl 0re cneg addinv
      wceq recn syl renegcl eqeltrd issubgoi ) ABCDDEEFGZDHIZOEDJKDPKLDMNZDOUPO
      OFODQRUAUBUOSUCUNSATZBTUDUEUQEKZUQUOIZUQUFZEURUQOKUSUTUHUQUIUQUGUJUQUKULU
      M $.

    $( The integers under addition comprise a subgroup of the complex numbers
       under addition.  (Contributed by Paul Chapman, 25-Apr-2008.)
       (New usage is discouraged.) $)
    zaddsubgo $p |- ( + |` ( ZZ X. ZZ ) ) e. ( SubGrpOp ` + ) $=
      ( vx vy cc0 caddc cz cxp cres cgn cfv cablo wcel cnaddablo ablogrpo ax-mp
      cc cgr ax-addf fdmi eqid cv grporn cnid zsscn zaddcl cneg wceq zcn addinv
      0z syl znegcl eqeltrd issubgoi ) ABCDDEEFGZDHIZOEDJKDPKLDMNZDOUPOOFODQRUA
      UBUOSUCUNSATZBTUDUIUQEKZUQUOIZUQUEZEURUQOKUSUTUFUQUGUQUHUJUQUKULUM $.

    $( Nonzero complex number multiplication is an Abelian group operation.
       (Contributed by Steve Rodriguez, 12-Feb-2007.)
       (New usage is discouraged.) $)
    ablomul $p |- ( x. |` ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) ) e. AbelOp $=
      ( vx vy vz cmul cc cc0 c1 cv co cvv wcel mulnzcnopr wa wceq ovres eldifsn
      wne jca sylibr eldifi csn cdif cres cdiv cnex difexg ax-mp mulcl ad2ant2r
      cxp w3a mulne0 syl2anb eqeltrd anim1i 3adant3 oveq1d mulass syl3an eqcomd
      3impa syl 3adant1 oveq2d fovcl sylan2 3impb 3eqtr3d 3eqtrd ax-1cn ax-1ne0
      eqeltrrd mpbir2an mulid2d eqtrd reccl recne0 sylbi mpancom recid2 isgrpoi
      mpan fdmi mulcom syl2an ancoms 3eqtr4d isabloi ) ABDEFUAZUBZWJUJZUCZWJABC
      GWLGAHZUDIZWJEJKWJJKUEEWIJUFUGLWMWJKZBHZWJKZCHZWJKZUKZWMWPWLIZWRWLIZXAWRD
      IZWMWPDIZWRDIZWMWPWRWLIZWLIZWTXAWJKZWSMZXBXCNWOWQWSXIWOWQMZXHWSXJXAXDWJWM
      WPWJWJDOZXJXDEKZXDFQZMZXDWJKWOWMEKZWMFQZMZWPEKZWPFQZMZXNWQWMEFPZWPEFPXQXT
      MXLXMXOXRXLXPXSWMWPUHUIWMWPULRUMXDEFPSUNUOVAXAWRWJWJDOVBWTXAXDWRDWOWQXAXD
      NWSXKUPUQWTXEWMWPWRDIZDIZWMXFDIZXGWOXOWQXRWSWREKXEYCNWMEWITZWPEWITZWREWIT
      WMWPWRURUSWTYBXFWMDWQWSYBXFNWOWQWSMZXFYBWPWRWJWJDOZUTVCZVDZWTYCWMYBWLIZYD
      XGWOWQWSYCYKNZYGWOYBWJKZYLYGXFYBWJYHWPWRWJWJWJWLLVEVLWOYMMYKYCWMYBWJWJDOU
      TVFVGYJWTYBXFWMWLYIVDVHVIVIGWJKZGEKGFQVJVKGEFPVMZWOGWMWLIZGWMDIZWMYNWOYPY
      QNYOGWMWJWJDOWBWOWMYEVNVOWOWNEKZWNFQZMZWNWJKZWOXQYTYAXQYRYSWMVPWMVQRVRWNE
      FPSZWOWNWMWLIZWNWMDIZGUUAWOUUCUUDNUUBWNWMWJWJDOVSWOXQUUDGNYAWMVTVRVOWAWKW
      JWLLWCXJXDWPWMDIZXAWPWMWLIZWOXOXRXDUUENWQYEYFWMWPWDWEXKWQWOUUFUUENWPWMWJW
      JDOWFWGWH $.

    $( The group identity element of nonzero complex number multiplication is
       one.  (Contributed by Steve Rodriguez, 23-Feb-2007.)  (Revised by Mario
       Carneiro, 17-Dec-2013.)  (New usage is discouraged.) $)
    mulid $p |- ( GId ` ( x. |` ( ( CC \ { 0 } ) X. ( CC \ { 0 } ) ) ) ) = 1 $=
      ( vy vx cmul cc cc0 csn cdif cxp cres cgi cfv cv co wceq wral crio c1 cgr
      wcel ax-mp cablo ablomul ablogrpo mulnzcnopr fdmi grporn grpoidval ax-1cn
      eqid wne ax-1ne0 eldifsn mpbir2an ovres mpan eldifi mulid2d eqtrd rgen wb
      wreu grpoideu oveq1 eqeq1d ralbidv riota2 mp2an mpbi eqtri ) CDEFZGZVKHZI
      ZJKZALZBLZVMMZVPNZBVKOZAVKPZQVMRSZVNVTNVMUASWAUBVMUCTZBAVNVMVKVMVKWBVLVKV
      MUDUEUFZVNUIUGTQVPVMMZVPNZBVKOZVTQNZWEBVKVPVKSZWDQVPCMZVPQVKSZWHWDWINWJQD
      SQEUJUHUKQDEULUMZQVPVKVKCUNUOWHVPVPDVJUPUQURUSWJVSAVKVAZWFWGUTWKWAWLWBBAV
      MVKWCVBTVSWFAVKQVOQNZVRWEBVKWMVQWDVPVOQVPVMVCVDVEVFVGVHVI $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Group homomorphism and isomorphism
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c GrpOpHom $.

  $( Extend class notation to include the class of group homomorphisms. $)
  cghom $a class GrpOpHom $.

  ${
    $d f g h s x y $.
    $( Define the set of group homomorphisms from ` g ` to ` h ` .
       (Contributed by Paul Chapman, 25-Feb-2008.)
       (New usage is discouraged.) $)
    df-ghom $a |- GrpOpHom = ( g e. GrpOp , h e. GrpOp |->
        { f | ( f : ran g --> ran h /\ A. x e. ran g A. y e. ran g
                     ( ( f ` x ) h ( f ` y ) ) = ( f ` ( x g y ) ) ) } ) $.
  $}

  $c GrpOpIso $.

  $( Extend class notation to include the class of group isomorphisms. $)
  cgiso $a class GrpOpIso $.

  ${
    $d f g h s $.
    $( Define the set of group isomorphisms from ` g ` to ` h ` .  (Contributed
       by Paul Chapman, 25-Feb-2008.)  (New usage is discouraged.) $)
    df-giso $a |- GrpOpIso = ( g e. GrpOp , h e. GrpOp |->
        { f e. ( g GrpOpHom h ) | f : ran g -1-1-onto-> ran h } ) $.
  $}

  ${
    $d f x y F $.  $d f g h x y G $.  $d f g h x y H $.  $d g h S $.
    elghomlem1.1 $e |- S = { f | ( f : ran G --> ran H /\ A. x e. ran G
      A. y e. ran G ( ( f ` x ) H ( f ` y ) ) = ( f ` ( x G y ) ) ) } $.
    $( Lemma for ~ elghom .  (Contributed by Paul Chapman, 25-Feb-2008.)
       (New usage is discouraged.) $)
    elghomlem1 $p |- ( ( G e. GrpOp /\ H e. GrpOp )
        -> ( G GrpOpHom H ) = S ) $=
      ( vg vh cgr wcel cvv co wceq crn cv cfv wral wf wa cghom rnexg fabexg cab
      syl2an rneq feq2d oveq fveq2d eqeq2d raleqbidv anbi12d abbidv wb feq3 syl
      eqeq1d 2ralbidv syl6eqr df-ghom ovmpt2g mpd3an3 ) EJKZFJKZCLKZEFUAMCNVCEO
      ZLKFOZLKVEVDEJUBFJUBAPZDPZQZBPZVIQZFMZVHVKEMZVIQZNZBVFRAVFRZDVFVGLLCGUCUE
      HIEFJJHPZOZIPZOZVISZVJVLVTMZVHVKVRMZVIQZNZBVSRZAVSRZTZDUDCUAVFWAVISZWCVON
      ZBVFRZAVFRZTZDUDZLVRENZWIWNDWPWBWJWHWMWPVSVFWAVIVREUFZUGWPWGWLAVSVFWQWPWF
      WKBVSVFWQWPWEVOWCWPWDVNVIVHVKVREUHUIUJUKUKULUMVTFNZWOVFVGVISZVQTZDUDCWRWN
      WTDWRWJWSWMVQWRWAVGNWJWSUNVTFUFWAVGVFVIUOUPWRWKVPABVFVFWRWCVMVOVJVLVTFUHU
      QURULUMGUSABDHIUTVAVB $.

    $( Lemma for ~ elghom .  (Contributed by Paul Chapman, 25-Feb-2008.)
       (New usage is discouraged.) $)
    elghomlem2 $p |- ( ( G e. GrpOp /\ H e. GrpOp ) -> ( F e. ( G GrpOpHom H )
    <-> ( F : ran G --> ran H /\ A. x e. ran G A. y e. ran G
          ( ( F ` x ) H ( F ` y ) ) = ( F ` ( x G y ) ) ) ) ) $=
      ( cgr wcel wa co crn wf cv cfv wceq wral cvv fveq1 elghomlem1 eleq2d elex
      cghom wb feq1 oveq12d eqeq12d 2ralbidv anbi12d elab2g biimpd mpcom wi fex
      rnexg expcom syl adantrd biimprd syli impbid2 adantr bitrd ) FIJZGIJZKZEF
      GUDLZJECJZFMZGMZENZAOZEPZBOZEPZGLZVMVOFLZEPZQZBVJRAVJRZKZVGVHCEABCDFGHUAU
      BVEVIWBUEVFVEVIWBESJZVIWBECUCWCVIWBVJVKDOZNZVMWDPZVOWDPZGLZVRWDPZQZBVJRAV
      JRZKWBDECSWDEQZWEVLWKWAVJVKWDEUFWLWJVTABVJVJWLWHVQWIVSWLWFVNWGVPGVMWDETVO
      WDETUGVRWDETUHUIUJHUKZULUMWBVEWCVIVEVLWCWAVEVJSJZVLWCUNFIUPVLWNWCVJVKSEUO
      UQURUSWCVIWBWMUTVAVBVCVD $.
  $}

  ${
    $d F f x y $.  $d G f x y $.  $d H f x y $.  $d X x y $.
    elghom.1 $e |- X = ran G $.
    elghom.2 $e |- W = ran H $.
    $( Membership in the set of group homomorphisms from ` G ` to ` H ` .
       (Contributed by Paul Chapman, 3-Mar-2008.)
       (New usage is discouraged.) $)
    elghom $p |- ( ( G e. GrpOp /\ H e. GrpOp ) ->
      ( F e. ( G GrpOpHom H ) <-> ( F : X --> W /\ A. x e. X A. y e. X
        ( ( F ` x ) H ( F ` y ) ) = ( F ` ( x G y ) ) ) ) ) $=
      ( vf cgr wcel wa co crn wf cv cfv wceq wral eqid elghomlem2 feq23i raleqi
      cghom cab raleqbii anbi12i syl6bbr ) DKLEKLMCDEUENLDOZEOZCPZAQZCRBQZCRENU
      MUNDNZCRSZBUJTZAUJTZMGFCPZUPBGTZAGTZMABUJUKJQZPUMVBRUNVBRENUOVBRSBUJTAUJT
      MJUFZJCDEVCUAUBUSULVAURGFUJUKCHIUCUTUQAGUJHUPBGUJHUDUGUHUI $.
  $}

  ${
    $d A x y $.  $d B y $.  $d F x y $.  $d G x y $.  $d H x y $.  $d X x y $.
    ghomlin.1 $e |- X = ran G $.
    $( Linearity of a group homomorphism.  (Contributed by Paul Chapman,
       3-Mar-2008.)  (New usage is discouraged.) $)
    ghomlin $p |- ( ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) /\
                      ( A e. X /\ B e. X ) ) ->
                    ( ( F ` A ) H ( F ` B ) ) = ( F ` ( A G B ) ) ) $=
      ( vx vy cgr wcel co cv cfv wceq wral wa fveq2 fveq2d eqeq12d cghom w3a wf
      crn eqid elghom biimp3a simprd oveq1d oveq1 oveq2d oveq2 rspc2v mpan9 ) D
      JKZEJKZCDEUALKZUBZHMZCNZIMZCNZELZUSVADLZCNZOZIFPHFPZAFKBFKQACNZBCNZELZABD
      LZCNZOZURFEUDZCUCZVGUOUPUQVOVGQHICDEVNFGVNUEUFUGUHVFVMVHVBELZAVADLZCNZOHI
      ABFFUSAOZVCVPVEVRVSUTVHVBEUSACRUIVSVDVQCUSAVADUJSTVABOZVPVJVRVLVTVBVIVHEV
      ABCRUKVTVQVKCVABADULSTUMUN $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.
    ghomid.1 $e |- U = ( GId ` G ) $.
    ghomid.2 $e |- T = ( GId ` H ) $.
    $( A group homomorphism maps identity element to identity element.
       (Contributed by Paul Chapman, 3-Mar-2008.)
       (New usage is discouraged.) $)
    ghomid $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
                   ( F ` U ) = T ) $=
      ( vx vy cgr wcel co cfv wceq crn wa eqid 3ad2ant1 mpdan cv cghom grpoidcl
      w3a jca ghomlin grpolid fveq2d eqtrd wb wf elghom biimp3a simpld ffvelrnd
      wral wi grpoid ex 3ad2ant2 mpd mpbird ) DJKZEJKZCDEUALKZUCZBCMZANZVFVFELZ
      VFNZVEVHBBDLZCMZVFVEBDOZKZVMPVHVKNVEVMVMVBVCVMVDBDVLVLQZFUBZRZVPUDBBCDEVL
      VNUESVBVCVKVFNVDVBVJBCVBVMVJBNVOBBDVLVNFUFSUGRUHVEVFEOZKZVGVIUIZVEVLVQBCV
      EVLVQCUJZHTZCMITZCMELWAWBDLCMNIVLUOHVLUOZVBVCVDVTWCPHICDEVQVLVNVQQZUKULUM
      VPUNVCVBVRVSUPVDVCVRVSVFAEVQWDGUQURUSUTVA $.
  $}

  ${
    $d w z C $.  $d b c w x y z F $.  $d c w x y z G $.  $d a b c w x y z ph $.
    $d w ch $.  $d a b c x y z H $.  $d b w x y z X $.  $d a b c w x y z Y $.
    $d w D $.  $d w x y z O $.
    ghgrp.1 $e |- ( ph -> F : X -onto-> Y ) $.
    ${
      ghgrplem1.2 $e |- ( ( ph /\ w e. X ) -> ps ) $.
      ghgrplem1.3 $e |- ( C = ( F ` w ) -> ( ch <-> ps ) ) $.
      $( Lemma for ~ ghgrp .  (Contributed by Paul Chapman, 25-Apr-2008.)
         (Revised by Mario Carneiro, 12-May-2014.)
         (New usage is discouraged.) $)
      ghgrplem1 $p |- ( ( ph /\ C e. Y ) -> ch ) $=
        ( wcel cv cfv wceq wrex wfo foelrn sylan wa syl5ibrcom rexlimdva syldan
        imp ) AEHLZEDMZFNOZDGPZCAGHFQUEUHIDGHEFRSAUHCAUGCDGAUFGLTCUGBJKUAUBUDUC
        $.
    $}

    ghgrp.2 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
                      ( F ` ( x G y ) ) = ( ( F ` x ) O ( F ` y ) ) ) $.
    ghgrp.3 $e |- H = ( O |` ( Y X. Y ) ) $.
    $( Lemma for ~ ghgrp .  (Contributed by Paul Chapman, 25-Apr-2008.)
       (Revised by Mario Carneiro, 12-May-2014.)
       (New usage is discouraged.) $)
    ghgrplem2 $p |- ( ( ph /\ ( C e. X /\ D e. X ) ) ->
                       ( F ` ( C G D ) ) = ( ( F ` C ) H ( F ` D ) ) ) $=
      ( vz vw wcel co cfv wceq wa cv wral ralrimivva oveq1 fveq2d fveq2 eqeq12d
      oveq1d oveq2 oveq2d cbvral2v sylib rspc2v mpan9 cxp cres oveqi wf wfo fof
      syl ffvelrn anim12dan sylan ovres syl5eq eqtr4d ) ADJQZEJQZUAZUAZDEGRZFSZ
      DFSZEFSZIRZVOVPHRZAOUBZPUBZGRZFSZVSFSZVTFSZIRZTZPJUCOJUCZVKVNVQTZABUBZCUB
      ZGRZFSZWIFSZWJFSZIRZTZCJUCBJUCWGAWPBCJJMUDWPWFVSWJGRZFSZWCWNIRZTBCOPJJWIV
      STZWLWRWOWSWTWKWQFWIVSWJGUEUFWTWMWCWNIWIVSFUGUIUHWJVTTZWRWBWSWEXAWQWAFWJV
      TVSGUJUFXAWNWDWCIWJVTFUGUKUHULUMWFWHDVTGRZFSZVOWDIRZTOPDEJJVSDTZWBXCWEXDX
      EWAXBFVSDVTGUEUFXEWCVOWDIVSDFUGUIUHVTETZXCVNXDVQXFXBVMFVTEDGUJUFXFWDVPVOI
      VTEFUGUKUHUNUOVLVRVOVPIKKUPUQZRZVQHXGVOVPNURVLVOKQZVPKQZUAZXHVQTAJKFUSZVK
      XKAJKFUTXLLJKFVAVBXLVIXIVJXJJKDFVCJKEFVCVDVEVOVPKKIVFVBVGVH $.

    ghgrp.4 $e |- X = ran G $.
    ghgrp.5 $e |- ( ph -> Y C_ A ) $.
    ghgrp.6 $e |- ( ph -> O Fn ( A X. A ) ) $.
    ${
      ghgrp.7 $e |- ( ph -> G e. GrpOp ) $.
      $( The image of a group ` G ` under a group homomorphism ` F ` is a
         group.  This is a stronger result than that usually found in the
         literature, since the target of the homomorphism (operator ` O ` in
         our model) need not have any of the properties of a group as a
         prerequisite.  (Contributed by Paul Chapman, 25-Apr-2008.)  (Revised
         by Mario Carneiro, 12-May-2014.)  (New usage is discouraged.) $)
      ghgrp $p |- ( ph -> H e. GrpOp ) $=
        ( wcel co wceq va vb vc vz cvv wfo crn cgr syl syl5eqel fornex sylc cgi
        rnexg cfv c0 wne wf fof eqid grpoidcl ffvelrnd ne0i cxp wfn cv wral wss
        cres xpss12 syl2anc fnssres fneq1i sylibr adantr ghgrplem2 grpocl 3expb
        wa sylan ffvelrnda syldan eqeltrrd anassrs oveq2 eleq1d ghgrplem1 oveq1
        ralrimiva ralbidv ffnov sylanbrc simprll simprlr simprr syl13anc fveq2d
        wi grpoass adantrr syl12anc syl3anc 3eqtr3d oveq1d oveq2d expr impancom
        simpl eqeq12d imbi2d 3imp2 cgs simprl grpodivcl grponpcan eqtr3d eqeq1d
        ex wrex rspcev cgn grpoinvcl grpoasscan1 jca eqeq2 rexbidv anbi12d impr
        simpld simprd isgrp2d ) AUAUBUCGUEJAIUERIJEUFZJUERAIFUGZUENAFUHRZYMUERQ
        FUHUNUIUJKIJUEEUKULAFUMUOZEUOZJRJUPUQAIJYOEAYLIJEURZKIJEUSUIZAYNYOIRQYO
        FINYOUTVAUIVBJYPVCUIAGJJVDZVEZUAVFZUBVFZGSZJRZUBJVGZUAJVGYSJGURAHYSVIZY
        SVEZYTAHDDVDZVEYSUUHVHZUUGPAJDVHZUUJUUIOOJDJDVJVKUUHYSHVLVKYSGUUFMVMVNA
        UUEUAJABVFZEUOZUUBGSZJRZUBJVGUUEBUUAEIJKAUUKIRZVSZUUNUBJUUPUULCVFZEUOZG
        SZJRZUUNCUUBEIJAYLUUOKVOAUUOUUQIRZUUTAUUOUVAVSZVSZUUKUUQFSZEUOZUUSJABCU
        UKUUQEFGHIJKLMVPZAUVBUVDIRZUVEJRAYNUVBUVGQYNUUOUVAUVGUUKUUQFINVQVRVTZAI
        JUVDEYRWAWBWCWDUUBUURTZUUMUUSJUUBUURUULGWEZWFWGWIUUAUULTZUUDUUNUBJUVKUU
        CUUMJUUAUULUUBGWHZWFWJWGWIUAUBJJJGWKWLAUUAJRZUUBJRZUCVFZJRZUUCUVOGSZUUA
        UUBUVOGSZGSZTZAUVMUVNUVPUVTWRZWRZAUVNUVPUUMUVOGSZUULUVRGSZTZWRZWRUWBBUU
        AEIJKAUVNUUOUWFAUUOUVPUUSUVOGSZUULUURUVOGSZGSZTZWRZWRUUOUWFWRCUUBEIJKAU
        UOUVAUWKAUUOUVAUWKAUVPUVBUWJAUVBUUSUDVFZEUOZGSZUULUURUWMGSZGSZTZWRUVBUW
        JWRUDUVOEIJKAUVBUWLIRZUWQAUVBUWRUWQAUVBUWRVSZVSZUVEUWMGSZUULUUQUWLFSZEU
        OZGSZUWNUWPUWTUVDUWLFSZEUOZUUKUXBFSZEUOZUXAUXDUWTUXEUXGEUWTYNUUOUVAUWRU
        XEUXGTAYNUWSQVOZAUUOUVAUWRWMZAUUOUVAUWRWNZAUVBUWRWOZUUKUUQUWLFINWSWPWQU
        WTAUVGUWRUXFUXATAUWSXHZAUVBUVGUWRUVHWTUXLABCUVDUWLEFGHIJKLMVPXAUWTAUUOU
        XBIRZUXHUXDTUXMUXJUWTYNUVAUWRUXNUXIUXKUXLUUQUWLFINVQXBABCUUKUXBEFGHIJKL
        MVPXAXCUWTUVEUUSUWMGAUVBUVEUUSTUWRUVFWTXDUWTUXCUWOUULGUWTAUVAUWRUXCUWOT
        UXMUXKUXLABCUUQUWLEFGHIJKLMVPXAXEXCXFXGUVOUWMTZUWJUWQUVBUXOUWGUWNUWIUWP
        UVOUWMUUSGWEUXOUWHUWOUULGUVOUWMUURGWEXEXIXJWGXGXFXGUVIUWFUWKUUOUVIUWEUW
        JUVPUVIUWCUWGUWDUWIUVIUUMUUSUVOGUVJXDUVIUVRUWHUULGUUBUURUVOGWHXEXIXJXJW
        GXGUVKUWAUWFUVNUVKUVTUWEUVPUVKUVQUWCUVSUWDUVKUUCUUMUVOGUVLXDUUAUULUVRGW
        HXIXJXJWGXRXKAUVMUVNVSVSZUVOUUAGSZUUBTZUCJXSZUUAUVOGSZUUBTZUCJXSZAUVMUV
        NUXSUYBVSZAUVNUVOUULGSZUUBTZUCJXSZUULUVOGSZUUBTZUCJXSZVSZWRUVNUYCWRBUUA
        EIJKAUVNUUOUYJAUUOUYDUURTZUCJXSZUYGUURTZUCJXSZVSZWRUUOUYJWRCUUBEIJKAUUO
        UVAUYOAUUOUVAUYOUVCUYLUYNUVCUUQUUKFXLUOZSZEUOZJRUYRUULGSZUURTZUYLUVCIJU
        YQEAYQUVBYRVOZUVCYNUVAUUOUYQIRZAYNUVBQVOZAUUOUVAWOZAUUOUVAXMZUUQUUKUYPF
        INUYPUTZXNXBZVBUVCUYQUUKFSZEUOZUYSUURUVCAVUBUUOVUIUYSTAUVBXHZVUGVUEABCU
        YQUUKEFGHIJKLMVPXAUVCVUHUUQEUVCYNUVAUUOVUHUUQTVUCVUDVUEUUQUUKUYPFINVUFX
        OXBWQXPUYKUYTUCUYRJUVOUYRTUYDUYSUURUVOUYRUULGWHXQXTVKUVCUUKFYAUOZUOZUUQ
        FSZEUOZJRUULVUNGSZUURTZUYNUVCIJVUMEVUAUVCYNVULIRZUVAVUMIRZVUCUVCYNUUOVU
        QVUCVUEUUKFVUKINVUKUTZYBVKVUDVULUUQFINVQXBZVBUVCUUKVUMFSZEUOZVUOUURUVCA
        UUOVURVVBVUOTVUJVUEVUTABCUUKVUMEFGHIJKLMVPXAUVCVVAUUQEUVCYNUUOUVAVVAUUQ
        TVUCVUEVUDUUKUUQFVUKINVUSYCXBWQXPUYMVUPUCVUNJUVOVUNTUYGVUOUURUVOVUNUULG
        WEXQXTVKYDXFXGUVIUYJUYOUUOUVIUYFUYLUYIUYNUVIUYEUYKUCJUUBUURUYDYEYFUVIUY
        HUYMUCJUUBUURUYGYEYFYGXJWGXGUVKUYCUYJUVNUVKUXSUYFUYBUYIUVKUXRUYEUCJUVKU
        XQUYDUUBUUAUULUVOGWEXQYFUVKUYAUYHUCJUVKUXTUYGUUBUUAUULUVOGWHXQYFYGXJWGY
        HZYIUXPUXSUYBVVCYJYK $.
    $}

    ghablo.7 $e |- ( ph -> G e. AbelOp ) $.
    $( The image of an Abelian group ` G ` under a group homomorphism ` F ` is
       an Abelian group (Contributed by Paul Chapman, 25-Apr-2008.)  (Revised
       by Mario Carneiro, 12-May-2014.)  (New usage is discouraged.) $)
    ghablo $p |- ( ph -> H e. AbelOp ) $=
      ( wcel co wceq va vb cgr cv crn wral cablo ablogrpo syl ghgrp cdm cxp wss
      wfn fndm resgrprn syl3anc eleq2d anbi12d biimpar cfv adantr simprl simprr
      wa wi ablocom fveq2d ghgrplem2 ancom2s 3eqtr3d oveq2 oveq1 eqeq12d imbi2d
      expr ghgrplem1 impancom impr syldan ralrimivva eqid isablo sylanbrc ) AGU
      CRZUAUDZUBUDZGSZWGWFGSZTZUBGUEZUFUAWKUFGUGRABCDEFGHIJKLMNOPAFUGRZFUCRQFUH
      UIUJZAWJUAUBWKWKAWFWKRZWGWKRZVEZWFJRZWGJRZVEZWJAWSWPAWQWNWRWOAJWKWFAHUKDD
      ULZTZWEJDUMJWKTAHWTUNXAPWTHUOUIWMOHGDJMUPUQZURAJWKWGXBURUSUTAWQWRWJAWRBUD
      ZEVAZWGGSZWGXDGSZTZVFWRWJVFBWFEIJKAWRXCIRZXGAXHXDCUDZEVAZGSZXJXDGSZTZVFXH
      XGVFCWGEIJKAXIIRZXHXMAXHXNXMAXHXNVEZVEZXCXIFSZEVAXIXCFSZEVAZXKXLXPXQXREXP
      WLXHXNXQXRTAWLXOQVBAXHXNVCAXHXNVDXCXIFINVGUQVHABCXCXIEFGHIJKLMVIAXNXHXSXL
      TABCXIXCEFGHIJKLMVIVJVKVJVPWGXJTZXGXMXHXTXEXKXFXLWGXJXDGVLWGXJXDGVMVNVOVQ
      VRWFXDTZWJXGWRYAWHXEWIXFWFXDWGGVMWFXDWGGVLVNVOVQVSVTWAUAUBGWKWKWBWCWD $.
  $}

  ${
    $d x y F $.  $d x y H $.  $d x y O $.  $d x y S $.  $d x y W $.
    $d x y Z $.  $d x y ph $.
    ghsubgo.1 $e |- ( ph -> S e. ( SubGrpOp ` G ) ) $.
    ghsubgo.2 $e |- X = ran G $.
    ghsubgo.3 $e |- ( ph -> F : X --> Y ) $.
    ghsubgo.4 $e |- ( ph -> Y C_ A ) $.
    ghsubgo.5 $e |- ( ph -> O Fn ( A X. A ) ) $.
    ghsubgo.6 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
                     ( F ` ( x G y ) ) = ( ( F ` x ) O ( F ` y ) ) ) $.
    ghsubgo.7 $e |- Z = ran S $.
    ghsubgo.8 $e |- W = ( F " Z ) $.
    ghsubgo.9 $e |- H = ( O |` ( W X. W ) ) $.
    $( The image of a subgroup ` S ` of group ` G ` under a group homomorphism
       ` F ` on ` G ` is a group, and furthermore is Abelian if ` S ` is
       Abelian.  (Contributed by Paul Chapman, 25-Apr-2008.)  (Revised by Mario
       Carneiro, 12-May-2014.)  (New usage is discouraged.) $)
    ghsubgolem $p |- ( ph -> ( H e. GrpOp /\
                      ( S e. AbelOp -> H e. AbelOp ) ) ) $=
      ( cgr wcel cablo cres cima wfun cdm wss wfo ffun syl csubgo cfv subgornss
      wi wf wceq fdm sseqtr4d fores syl2anc cv wa ssel2 anim12dan sylan issubgo
      syldan simp2bi grpocl 3expb fvres subgoov fveq2d oveqan12d adantl 3eqtr4d
      eqtrd cxp xpeq12i reseq2i eqtri crn imassrn frn syl5ss sstrd ghgrp adantr
      co adantlr wfn simpr ghablo ex jca ) AHUCUDEUEUDZHUEUDZUQABCDFMUFZEHIMFMU
      GZAFUHZMFUIZUJMXBXAUKZAKLFURZXCPKLFULUMAMKXDAEGUNUOUDZMKUJZNGEMKOTUPUMZAX
      FXDKUSPKLFUTUMVAMFVBVCZABVDZMUDZCVDZMUDZVEZVEZXKXMGWLZFUOZXKFUOZXMFUOZIWL
      ZXKXMEWLZXAUOZXKXAUOZXMXAUOZIWLZAXOXKKUDZXMKUDZVEZXRYAUSAXHXOYIXIXHXLYGXN
      YHMKXKVFMKXMVFVGVHSVJXPYCYBFUOZXRXPYBMUDZYCYJUSAEUCUDZXOYKAXGYLNXGGUCUDYL
      EGUJGEVIVKUMZYLXLXNYKXKXMEMTVLVMVHYBMFVNUMXPYBXQFAXGXOYBXQUSNXKXMGEMTVOVH
      VPVTXOYFYAUSAXLXNYDXSYEXTIXKMFVNXMMFVNVQVRVSZHIJJWAZUFIXBXBWAZUFUBYOYPIJX
      BJXBUAUAWBWCWDZTAXBLDAXBFWEZLFMWFAXFYRLUJPKLFWGUMWHQWIZRYMWJAWSWTAWSVEBCD
      XAEHIMXBAXEWSXJWKAXOYCYFUSWSYNWMYQTAXBDUJWSYSWKAIDDWAWNWSRWKAWSWOWPWQWR
      $.

    $( The image of a subgroup ` S ` of group ` G ` under a group homomorphism
       ` F ` on ` G ` is a group.  (Contributed by NM, 25-Apr-2008.)  (Revised
       by Mario Carneiro, 12-May-2014.)  (New usage is discouraged.) $)
    ghsubgo $p |- ( ph -> H e. GrpOp ) $=
      ( cgr wcel cablo wi ghsubgolem simpld ) AHUCUDEUEUDHUEUDUFABCDEFGHIJKLMNO
      PQRSTUAUBUGUH $.

    ghsubablo.10 $e |- ( ph -> S e. AbelOp ) $.
    $( The image of an Abelian subgroup ` S ` of group ` G ` under a group
       homomorphism ` F ` on ` G ` is an Abelian group.  (Contributed by Mario
       Carneiro, 12-May-2014.)  (New usage is discouraged.) $)
    ghsubablo $p |- ( ph -> H e. AbelOp ) $=
      ( cablo wcel cgr wi ghsubgolem simprd mpd ) AEUDUEZHUDUEZUCAHUFUEUKULUGAB
      CDEFGHIJKLMNOPQRSTUAUBUHUIUJ $.
  $}

  ${
    $d x y z A $.  $d x y z ph $.  $d x y z X $.
    efghgrp.1 $e |- S = { y | E. x e. X y = ( exp ` ( A x. x ) ) } $.
    efghgrp.2 $e |- G = ( x. |` ( S X. S ) ) $.
    efghgrp.3 $e |- ( ph -> A e. CC ) $.
    efghgrp.4 $e |- ( ph -> X C_ CC ) $.
    efghgrp.5 $e |- ( + |` ( X X. X ) ) e. ( SubGrpOp ` + ) $.
    $( The image of a subgroup of the group ` + ` , under the exponential
       function of a scaled complex number, is an Abelian group.  (Contributed
       by Paul Chapman, 25-Apr-2008.)  (Revised by Mario Carneiro,
       12-May-2014.)  (New usage is discouraged.) $)
    efghgrp $p |- ( ph -> G e. AbelOp ) $=
      ( cmul cc cfv caddc wceq eqid wcel a1i vz cv co ce cmpt cxp cres crn cima
      cablo cab rnmpt eqtr4i df-ima wss resmpt syl rneqd syl5eq cdm cgr ax-addf
      wrex fdmi csubgo cnaddablo mp2an ablogrpo resgrprn syl3anc imaeq2d eqtr3d
      subgoablo xpeq12d reseq2d ax-mp grporn wa mulcl efcl sylan fmptd ssid wfn
      wf ax-mulf ffn efgh 3expb ghsubablo eqeltrd ) AFMBNDBUBZMUCZUDOZUEZPGGUFU
      GZUHZUIZWRUFZUGZUJAFMEEUFZUGWTIAXAWSMAEWREWRAEBGWNUEZUHZWRECUBZWNQBGVCCUK
      XCHBCGWNXBXBRULUMAWOGUIZXCWRAXEWOGUGZUHXCWOGUNAXFXBAGNUOZXFXBQKBNGWNUPUQU
      RUSAGWQWOAPUTNNUFZQZWPVASZXGGWQQXIAXHNPVBVDZTAWPUJSZXJXLAPUJSZWPPVEOSZXLV
      FLPWPVMVGTZWPVHUQKPWPNGWPRVIVJVKVLUSZXPVNVOUSACUANWPWOPWTMWRNNWQXNALTPNXM
      PVASVFPVHVPXKVQABNWNNWOADNSZWLNSZWNNSZJXQXRVRWMNSXSDWLVSWMVTUQWAWORZWBNNU
      OANWCTMXHWDZAXHNMWEYAWFXHNMWGVPTAXQXDNSZUAUBZNSZVRXDYCPUCWOOXDWOOYCWOOMUC
      QZJXQYBYDYEBDXDYCWOXTWHWIWAWQRWRRWTRXOWJWK $.
  $}

  ${
    $d x y C $.
    circgrp.1 $e |- C = ( `' abs " { 1 } ) $.
    circgrp.2 $e |- T = ( x. |` ( C X. C ) ) $.
    $( The circle group ` T ` is an Abelian group.  (Contributed by Paul
       Chapman, 25-Mar-2008.)  (Revised by Mario Carneiro, 13-May-2014.)
       (New usage is discouraged.) $)
    circgrp $p |- T e. AbelOp $=
      ( vy vx cablo wcel wtru ci cr cv cmul co ce cfv cmpt wceq cc a1i crn wrex
      cab wfo eqid efifo ax-mp rnmpt eqtr3i ax-icn ax-resscn readdsubgo efghgrp
      forn wss trud ) BGHIEFJABKEKJELMNOPZQZUAZAFLUQREKUBFUCKAURUDUSAREAURURUEZ
      CUFKAURUNUGEFKUQURUTUHUIDJSHIUJTKSUOIUKTULUMUP $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Additional material on rings and fields
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RingOps $.

  $( Extend class notation with the class of all unital rings. $)
  crngo $a class RingOps $.

  ${
    $d g h x y z $.
    $( Define the class of all unital rings.  (Contributed by Jeffrey Hankins,
       21-Nov-2006.)  (New usage is discouraged.) $)
    df-rngo $a |- RingOps = { <. g , h >. | ( ( g e. AbelOp /\
                               h : ( ran g X. ran g ) --> ran g ) /\
            ( A. x e. ran g A. y e. ran g A. z e. ran g
              ( ( ( x h y ) h z ) = ( x h ( y h z ) ) /\
                ( x h ( y g z ) ) = ( ( x h y ) g ( x h z ) ) /\
                ( ( x g y ) h z ) = ( ( x h z ) g ( y h z ) ) ) /\
        E. x e. ran g A. y e. ran g ( ( x h y ) = y /\ ( y h x ) = y ) ) ) } $.
  $}

  ${
    $d g h x y z $.
    $( The class of all unital rings is a relation.  (Contributed by FL,
       31-Aug-2009.)  (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    relrngo $p |- Rel RingOps $=
      ( vg vh vx vy vz cv cablo wcel crn cxp wf wa wceq wral wrex crngo df-rngo
      co w3a relopabi ) AFZGHUAIZUBJUBBFZKLCFZDFZUCRZEFZUCRUDUEUGUCRZUCRMUDUEUG
      UARUCRUFUDUGUCRZUARMUDUEUARUGUCRUIUHUARMSEUBNDUBNCUBNUFUEMUEUDUCRUEMLDUBN
      CUBOLLABPCDEABQT $.
  $}

  ${
    $d g h x y z G $.  $d g h x y z H $.  $d g h x y z X $.
    isring.1 $e |- X = ran G $.
    $( The predicate "is a (unital) ring."  Definition of ring with unit in
       [Schechter] p. 187.  (Contributed by Jeffrey Hankins, 21-Nov-2006.)
       (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    isrngo $p |- ( H e. A -> ( <. G , H >. e. RingOps <->
      ( ( G e. AbelOp /\ H : ( X X. X ) --> X ) /\
        ( A. x e. X A. y e. X A. z e. X
          ( ( ( x H y ) H z ) = ( x H ( y H z ) ) /\
            ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) /\
            ( ( x G y ) H z ) = ( ( x H z ) G ( y H z ) ) ) /\
          E. x e. X A. y e. X ( ( x H y ) = y /\ ( y H x ) = y ) ) ) ) ) $=
      ( vg vh wcel crngo cablo wa cv co wceq wral oveqd oveq123d cvv cop cxp wf
      w3a wrex wi wbr df-br relrngo brrelexi sylbir a1i elex ad2antrr crn copab
      wb df-rngo eleq2i simpl simpr rneqd syl6eqr xpeq12d feq123d anbi12d eqidd
      eleq1d eqeq12d 3anbi123d raleqbidv eqeq1d rexeqbidv opelopabga pm5.21ndd
      syl5bb expcom ) FDKZEUAKZEFUBZLKZEMKZGGUCZGFUDZNZAOZBOZFPZCOZFPZWGWHWJFPZ
      FPZQZWGWHWJEPZFPZWIWGWJFPZEPZQZWGWHEPZWJFPZWQWLEPZQZUEZCGRZBGRZAGRZWIWHQZ
      WHWGFPZWHQZNZBGRZAGUFZNZNZWBVTUGVSWBEFLUHVTEFLUIEFLUJUKULUMXOVTUGVSWCVTWE
      XNEMUNUOUMVTVSWBXOURWBWAIOZMKZXPUPZXRUCZXRJOZUDZNZWGWHXTPZWJXTPZWGWHWJXTP
      ZXTPZQZWGWHWJXPPZXTPZYCWGWJXTPZXPPZQZWGWHXPPZWJXTPZYJYEXPPZQZUEZCXRRZBXRR
      ZAXRRZYCWHQZWHWGXTPZWHQZNZBXRRZAXRUFZNZNZIJUQZKVTVSNXOLUUIWAABCIJUSUTUUHX
      OIJEFUADXPEQZXTFQZNZYBWFUUGXNUULXQWCYAWEUULXPEMUUJUUKVAZVIUULXSWDXRGXTFUU
      JUUKVBZUULXRGXRGUULXREUPGUULXPEUUMVCHVDZUUOVEUUOVFVGUULYTXGUUFXMUULYSXFAX
      RGUUOUULYRXEBXRGUUOUULYQXDCXRGUUOUULYGWNYLWSYPXCUULYDWKYFWMUULYCWIWJWJXTF
      UUNUULXTFWGWHUUNSZUULWJVHZTUULWGWGYEWLXTFUUNUULWGVHZUULXTFWHWJUUNSZTVJUUL
      YIWPYKWRUULWGWGYHWOXTFUUNUURUULXPEWHWJUUMSTUULYCWIYJWQXPEUUMUUPUULXTFWGWJ
      UUNSZTVJUULYNXAYOXBUULYMWTWJWJXTFUUNUULXPEWGWHUUMSUUQTUULYJWQYEWLXPEUUMUU
      TUUSTVJVKVLVLVLUULUUEXLAXRGUUOUULUUDXKBXRGUUOUULUUAXHUUCXJUULYCWIWHUUPVMU
      ULUUBXIWHUULXTFWHWGUUNSVMVGVLVNVGVGVOVQVRVP $.
  $}

  ${
    $d ph x y z $.  $d G x y z $.  $d H x y z $.  $d X x y z $.  $d U x y $.
    isringod.1 $e |- ( ph -> G e. AbelOp ) $.
    isringod.2 $e |- ( ph -> X = ran G ) $.
    isringod.3 $e |- ( ph -> H : ( X X. X ) --> X ) $.
    isringod.4 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) )
                                  -> ( ( x H y ) H z ) = ( x H ( y H z ) ) ) $.
    isringod.5 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) )
                          -> ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) ) $.
    isringod.6 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) )
                          -> ( ( x G y ) H z ) = ( ( x H z ) G ( y H z ) ) ) $.
    isringod.7 $e |- ( ph -> U e. X ) $.
    isringod.8 $e |- ( ( ph /\ y e. X ) -> ( U H y ) = y ) $.
    isringod.9 $e |- ( ( ph /\ y e. X ) -> ( y H U ) = y ) $.
    $( Conditions that determine a ring.  (Changed label from ~ isrngd to
       ~ isrngod -NM 2-Aug-2013.)  (Contributed by Jeff Madsen, 19-Jun-2010.)
       (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    isrngod $p |- ( ph -> <. G , H >. e. RingOps ) $=
      ( wcel co wral cop crngo cablo crn cxp wf wa wceq w3a wrex xpeq12d feq23d
      mpbid 3jca ralrimivvva raleqdv raleqbidv jca ralrimiva oveq1 eqeq1d oveq2
      cv anbi12d ralbidv rspcev syl2anc rexeqbidv jca31 cvv rnexg syl xpexg fex
      wb eqid isrngo mpbird ) AFGUAUBRZFUCRZFUDZWAUEZWAGUFZUGBVCZCVCZGSZDVCZGSW
      DWEWGGSZGSUHZWDWEWGFSGSWFWDWGGSZFSUHZWDWEFSWGGSWJWHFSUHZUIZDWATZCWATZBWAT
      ZWFWEUHZWEWDGSZWEUHZUGZCWATZBWAUJZUGZUGZAVTWCXCIAHHUEZHGUFWCKAXEHWBWAGAHW
      AHWAJJUKJULUMZAWPXBAWMDHTZCHTZBHTWPAWMBCDHHHAWDHRWEHRZWGHRUIUGWIWKWLLMNUN
      UOAXHWOBHWAJAXGWNCHWAJAWMDHWAJUPUQUQUMAWTCHTZBHUJZXBAEHREWEGSZWEUHZWEEGSZ
      WEUHZUGZCHTZXKOAXPCHAXIUGXMXOPQURUSXJXQBEHWDEUHZWTXPCHXRWQXMWSXOXRWFXLWEW
      DEWEGUTVAXRWRXNWEWDEWEGVBVAVDVEVFVGAXJXABHWAJAWTCHWAJUPVHUMURVIAGVJRZVSXD
      VOAWCWBVJRZXSXFAWAVJRZYAXTAVTYAIFUCVKVLZYBWAWAVJVJVMVGWBWAVJGVNVGBCDVJFGW
      AWAVPVQVLVR $.
  $}

  ${
    $d u x y z G $.  $d u x y z H $.  $d u x y z X $.  $d u x y z A $.
    $d y z B $.  $d z C $.  $d u x R $.
    ringi.1 $e |- G = ( 1st ` R ) $.
    ringi.2 $e |- H = ( 2nd ` R ) $.
    ringi.3 $e |- X = ran G $.
    $( The properties of a unital ring.  (Contributed by Steve Rodriguez,
       8-Sep-2007.)  (Proof shortened by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    rngoi $p |- ( R e. RingOps -> ( ( G e. AbelOp /\ H : ( X X. X ) --> X ) /\
      ( A. x e. X A. y e. X A. z e. X
        ( ( ( x H y ) H z ) = ( x H ( y H z ) ) /\
          ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) /\
          ( ( x G y ) H z ) = ( ( x H z ) G ( y H z ) ) ) /\
        E. x e. X A. y e. X ( ( x H y ) = y /\ ( y H x ) = y ) ) ) ) $=
      ( crngo wcel cop wa cv co wceq wral cfv cvv cablo cxp wrex c1st c2nd wrel
      wf relrngo 1st2nd mpan opeq12i syl6reqr id eqeltrd wb fvex eqeltri isrngo
      w3a ax-mp sylib ) DKLZEFMZKLZEUALGGUBGFUGNAOZBOZFPZCOZFPVEVFVHFPZFPQVEVFV
      HEPFPVGVEVHFPZEPQVEVFEPVHFPVJVIEPQUSCGRBGRAGRVGVFQVFVEFPVFQNBGRAGUCNNZVBV
      CDKVBDDUDSZDUESZMZVCKUFVBDVNQUHDKUIUJEVLFVMHIUKULVBUMUNFTLVDVKUOFVMTIDUEU
      PUQABCTEFGJURUTVA $.

    $( Functionality of the multiplication operation of a ring.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    rngosm $p |- ( R e. RingOps -> H : ( X X. X ) --> X ) $=
      ( vx vy vz crngo wcel cablo cxp wf wa cv co wceq wral rngoi simpld simprd
      w3a wrex ) AKLZBMLZDDNDCOZUFUGUHPHQZIQZCRZJQZCRUIUJULCRZCRSUIUJULBRCRUKUI
      ULCRZBRSUIUJBRULCRUNUMBRSUDJDTIDTHDTUKUJSUJUICRUJSPIDTHDUEPHIJABCDEFGUAUB
      UC $.

    $( Closure of the multiplication operation of a ring.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngocl $p |- ( ( R e. RingOps /\ A e. X /\ B e. X ) -> ( A H B ) e. X ) $=
      ( crngo wcel cxp wf co rngosm fovrn syl3an1 ) CJKFFLFEMAFKBFKABENFKCDEFGH
      IOABFFFEPQ $.

    $( The multiplication operation of a unital ring has (one or more) identity
       elements.  (Contributed by Steve Rodriguez, 9-Sep-2007.)  (Revised by
       Mario Carneiro, 22-Dec-2013.)  (New usage is discouraged.) $)
    rngoid $p |- ( ( R e. RingOps /\ A e. X ) ->
                 E. u e. X ( ( u H A ) = A /\ ( A H u ) = A ) ) $=
      ( vx vy wcel cv co wceq wa wrex wral simprd eqeq12d crngo w3a cablo rngoi
      cxp wf r19.12 syl oveq2 id oveq1 anbi12d rexbidv rspccva sylan ) CUALZAMZ
      JMZENZUROZURUQENZUROZPZAFQZJFRZBFLUQBENZBOZBUQENZBOZPZAFQZUPVCJFRAFQZVEUP
      USKMZENUQURVMENZENOUQURVMDNENUSUQVMENZDNOUQURDNVMENVOVNDNOUBKFRJFRAFRZVLU
      PDUCLFFUEFEUFPVPVLPAJKCDEFGHIUDSSVCAJFFUGUHVDVKJBFURBOZVCVJAFVQUTVGVBVIVQ
      USVFURBURBUQEUIVQUJZTVQVAVHURBURBUQEUKVRTULUMUNUO $.

    $( The unit element of a ring is unique.  (Contributed by NM, 4-Apr-2009.)
       (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    rngoideu $p |- ( R e. RingOps ->
                 E! u e. X A. x e. X ( ( u H x ) = x /\ ( x H u ) = x ) ) $=
      ( vy wcel cv co wceq wa wral weq ralimi oveq2 id crngo wrex wi wreu cablo
      cxp w3a rngoi simprr simpl eqeq12d rspcv syl5 simpr oveq1 im2anan9r eqtr2
      wf syl eqcomd syl6 rgen2a jctir eqeq1d anbi12d ralbidv reu4 sylibr ) CUAK
      ZBLZALZEMZVKNZVKVJEMZVKNZOZAFPZBFUBZVQJLZVKEMZVKNZVKVSEMZVKNZOZAFPZOZBJQZ
      UCZJFPBFPZOVQBFUDVIVRWIVIDUEKFFUFFEUROZVLVSEMVJWBEMNVJVKVSDMEMVLVJVSEMZDM
      NVJVKDMVSEMWKWBDMNUGJFPAFPBFPZVROOVRBAJCDEFGHIUHWJWLVRUIUSWHBJFVJFKZVSFKZ
      OWFWKVSNZWKVJNZOZWGWNVQWOWMWEWPVQVMAFPWNWOVPVMAFVMVOUJRVMWOAVSFAJQZVLWKVK
      VSVKVSVJESWRTUKULUMWEWCAFPWMWPWDWCAFWAWCUNRWCWPAVJFABQZWBWKVKVJVKVJVSEUOW
      STUKULUMUPWQVSVJWKVSVJUQUTVAVBVCVQWEBJFWGVPWDAFWGVMWAVOWCWGVLVTVKVJVSVKEU
      OVDWGVNWBVKVJVSVKESVDVEVFVGVH $.

    $( Distributive law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)  (Revised by Mario
       Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    rngodi $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                     ( A H ( B G C ) ) = ( ( A H B ) G ( A H C ) ) ) $=
      ( vx vy vz wcel cv co wceq wral wa oveq1 crngo w3a cablo cxp rngoi simprd
      wrex simpld simp2 ralimi oveq12d eqeq12d oveq2d oveq2 oveq1d rspc3v mpan9
      wf syl5 ) DUANZKOZLOZFPZMOZFPVAVBVDFPZFPQZVAVBVDEPZFPZVCVAVDFPZEPZQZVAVBE
      PVDFPVIVEEPQZUBZMGRZLGRZKGRZAGNBGNCGNUBZABCEPZFPZABFPZACFPZEPZQZUTVPVCVBQ
      VBVAFPVBQSLGRKGUGZUTEUCNGGUDGFURSVPWDSKLMDEFGHIJUEUFUHVPVKMGRZLGRZKGRVQWC
      VOWFKGVNWELGVMVKMGVFVKVLUIUJUJUJVKWCAVGFPZAVBFPZAVDFPZEPZQABVDEPZFPZVTWIE
      PZQKLMABCGGGVAAQZVHWGVJWJVAAVGFTWNVCWHVIWIEVAAVBFTVAAVDFTUKULVBBQZWGWLWJW
      MWOVGWKAFVBBVDETUMWOWHVTWIEVBBAFUNUOULVDCQZWLVSWMWBWPWKVRAFVDCBEUNUMWPWIW
      AVTEVDCAFUNUMULUPUSUQ $.

    $( Distributive law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)  (Revised by Mario
       Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    rngodir $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                      ( ( A G B ) H C ) = ( ( A H C ) G ( B H C ) ) ) $=
      ( vx vy vz wcel cv co wceq wral wa oveq2 crngo w3a cablo cxp rngoi simprd
      wrex simpld simp3 ralimi oveq1 oveq1d eqeq12d oveq2d oveq12d rspc3v mpan9
      wf syl5 ) DUANZKOZLOZFPZMOZFPVAVBVDFPZFPQZVAVBVDEPFPVCVAVDFPZEPQZVAVBEPZV
      DFPZVGVEEPZQZUBZMGRZLGRZKGRZAGNBGNCGNUBZABEPZCFPZACFPZBCFPZEPZQZUTVPVCVBQ
      VBVAFPVBQSLGRKGUGZUTEUCNGGUDGFURSVPWDSKLMDEFGHIJUEUFUHVPVLMGRZLGRZKGRVQWC
      VOWFKGVNWELGVMVLMGVFVHVLUIUJUJUJVLWCAVBEPZVDFPZAVDFPZVEEPZQVRVDFPZWIBVDFP
      ZEPZQKLMABCGGGVAAQZVJWHVKWJWNVIWGVDFVAAVBEUKULWNVGWIVEEVAAVDFUKULUMVBBQZW
      HWKWJWMWOWGVRVDFVBBAETULWOVEWLWIEVBBVDFUKUNUMVDCQZWKVSWMWBVDCVRFTWPWIVTWL
      WAEVDCAFTVDCBFTUOUMUPUSUQ $.

    $( Associative law for the multiplication operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)  (Revised by Mario
       Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    rngoass $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                      ( ( A H B ) H C ) = ( A H ( B H C ) ) ) $=
      ( vx vy vz wcel cv co wceq wral wa ralimi crngo w3a wrex cablo cxp simprd
      wf rngoi simpld simp1 syl oveq1 oveq1d eqeq12d oveq2 oveq2d rspc3v mpan9
      ) DUANZKOZLOZFPZMOZFPZUTVAVCFPZFPZQZMGRZLGRZKGRZAGNBGNCGNUBABFPZCFPZABCFP
      ZFPZQZUSVGUTVAVCEPFPVBUTVCFPZEPQZUTVAEPVCFPVPVEEPQZUBZMGRZLGRZKGRZVJUSWBV
      BVAQVAUTFPVAQSLGRKGUCZUSEUDNGGUEGFUGSWBWCSKLMDEFGHIJUHUFUIWAVIKGVTVHLGVSV
      GMGVGVQVRUJTTTUKVGVOAVAFPZVCFPZAVEFPZQVKVCFPZABVCFPZFPZQKLMABCGGGUTAQZVDW
      EVFWFWJVBWDVCFUTAVAFULUMUTAVEFULUNVABQZWEWGWFWIWKWDVKVCFVABAFUOUMWKVEWHAF
      VABVCFULUPUNVCCQZWGVLWIVNVCCVKFUOWLWHVMAFVCCBFUOUPUNUQUR $.

    $( A ring element plus itself is two times the element.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.)  (Revised by Mario Carneiro,
       22-Dec-2013.)  (New usage is discouraged.) $)
    rngo2 $p |- ( ( R e. RingOps /\ A e. X ) ->
                  E. x e. X ( A G A ) = ( ( x G x ) H A ) ) $=
      ( crngo wcel wa cv co wceq wrex rngoid oveq12 anidms eqcomd simpll simplr
      simpr rngodir syl13anc eqeq2d syl5ibr adantrd reximdva mpd ) CJKZBFKZLZAM
      ZBENZBOZBUNENBOZLZAFPBBDNZUNUNDNBENZOZAFPABCDEFGHIQUMURVAAFUMUNFKZLZUPVAU
      QUPVAVCUSUOUODNZOUPVDUSUPVDUSOUOBUOBDRSTVCUTVDUSVCUKVBVBULUTVDOUKULVBUAUM
      VBUCZVEUKULVBUBUNUNBCDEFGHIUDUEUFUGUHUIUJ $.
  $}

  ${
    $d G x y z $.  $d R x y z $.
    ringabl.1 $e |- G = ( 1st ` R ) $.
    $( A ring's addition operation is an Abelian group operation.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    rngoablo $p |- ( R e. RingOps -> G e. AbelOp ) $=
      ( vx vy vz crngo wcel cablo crn cxp c2nd cfv wa cv wceq wral eqid simpld
      co wf w3a wrex rngoi ) AGHZBIHZBJZUGKUGALMZUAZUEUFUINDOZEOZUHTZFOZUHTUJUK
      UMUHTZUHTPUJUKUMBTUHTULUJUMUHTZBTPUJUKBTUMUHTUOUNBTPUBFUGQEUGQDUGQULUKPUK
      UJUHTUKPNEUGQDUGUCNDEFABUHUGCUHRUGRUDSS $.
  $}

  ${
    ringgrp.1 $e |- G = ( 1st ` R ) $.
    $( A ring's addition operation is a group operation.  (Contributed by Steve
       Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngogrpo $p |- ( R e. RingOps -> G e. GrpOp ) $=
      ( crngo wcel cablo cgr rngoablo ablogrpo syl ) ADEBFEBGEABCHBIJ $.
  $}

  ${
    ringgcl.1 $e |- G = ( 1st ` R ) $.
    ringgcl.2 $e |- X = ran G $.
    $( Closure law for the addition (group) operation of a ring.  (Contributed
       by Steve Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngogcl $p |- ( ( R e. RingOps /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      ( crngo wcel cgr co rngogrpo grpocl syl3an1 ) CHIDJIAEIBEIABDKEICDFLABDEG
      MN $.

    $( The addition operation of a ring is commutative.  (Contributed by Steve
       Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngocom $p |- ( ( R e. RingOps /\ A e. X /\ B e. X ) ->
                      ( A G B ) = ( B G A ) ) $=
      ( crngo wcel cablo co wceq rngoablo ablocom syl3an1 ) CHIDJIAEIBEIABDKBAD
      KLCDFMABDEGNO $.

    $( The addition operation of a ring is associative.  (Contributed by Steve
       Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngoaass $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                        ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      ( crngo wcel cgr w3a co wceq rngogrpo grpoass sylan ) DIJEKJAFJBFJCFJLABE
      MCEMABCEMEMNDEGOABCEFHPQ $.

    $( The addition operation of a ring is commutative.  (Contributed by Steve
       Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngoa32 $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                      ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      ( crngo wcel cablo w3a co wceq rngoablo ablo32 sylan ) DIJEKJAFJBFJCFJLAB
      EMCEMACEMBEMNDEGOABCEFHPQ $.

    $( Rearrangement of 4 terms in a sum of ring elements.  (Contributed by
       Steve Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngoa4 $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X ) /\
                   ( C e. X /\ D e. X ) ) ->
                     ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      ( crngo wcel cablo wa co wceq rngoablo ablo4 syl3an1 ) EJKFLKAGKBGKMCGKDG
      KMABFNCDFNFNACFNBDFNFNOEFHPABCDFGIQR $.

    $( Right cancellation law for the addition operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)
       (New usage is discouraged.) $)
    rngorcan $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                       ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      ( crngo wcel cgr w3a co wceq wb rngogrpo grporcan sylan ) DIJEKJAFJBFJCFJ
      LACEMBCEMNABNODEGPABCEFHQR $.

    $( Left cancellation law for the addition operation of a ring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)
       (New usage is discouraged.) $)
    rngolcan $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                       ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      ( crngo wcel cgr w3a co wceq wb rngogrpo grpolcan sylan ) DIJEKJAFJBFJCFJ
      LCAEMCBEMNABNODEGPABCEFHQR $.
  $}

  ${
    ring0cl.1 $e |- G = ( 1st ` R ) $.
    ring0cl.2 $e |- X = ran G $.
    ring0cl.3 $e |- Z = ( GId ` G ) $.
    $( A ring has an additive identity element.  (Contributed by Steve
       Rodriguez, 9-Sep-2007.)  (New usage is discouraged.) $)
    rngo0cl $p |- ( R e. RingOps -> Z e. X ) $=
      ( crngo wcel cgr rngogrpo grpoidcl syl ) AHIBJIDCIABEKDBCFGLM $.

    $( The additive identity of a ring is a right identity element.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)
       (New usage is discouraged.) $)
    rngo0rid $p |- ( ( R e. RingOps /\ A e. X ) -> ( A G Z ) = A ) $=
      ( crngo wcel cgr co wceq rngogrpo grporid sylan ) BIJCKJADJAECLAMBCFNAECD
      GHOP $.

    $( The additive identity of a ring is a left identity element.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)
       (New usage is discouraged.) $)
    rngo0lid $p |- ( ( R e. RingOps /\ A e. X ) -> ( Z G A ) = A ) $=
      ( crngo wcel cgr co wceq rngogrpo grpolid sylan ) BIJCKJADJEACLAMBCFNAECD
      GHOP $.
  $}

  ${
    ringlz.1 $e |- Z = ( GId ` G ) $.
    ringlz.2 $e |- X = ran G $.
    ringlz.3 $e |- G = ( 1st ` R ) $.
    ringlz.4 $e |- H = ( 2nd ` R ) $.
    $( The zero of a unital ring is a left absorbing element.  (Contributed by
       FL, 31-Aug-2009.)  (New usage is discouraged.) $)
    rngolz $p |- ( ( R e. RingOps /\ A e. X ) -> ( Z H A ) = Z ) $=
      ( crngo wcel wa co wceq cgr rngogrpo grpoidcl grpolid adantr mpdan oveq1d
      syl rngo0cl simpr 3jca rngodir syldan simpl rngocl syl3anc grporid eqcomd
      w3a syl2anc 3eqtr3d wb grpolcan syl13anc mpbid ) BKLZAELZMZFADNZVDCNZVDFC
      NZOZVDFOZVCFFCNZADNZVDVEVFVCVIFADVAVIFOZVBVACPLZVKBCIQZVLFELZVKFCEHGRFFCE
      HGSUAUCTUBVAVBVNVNVBUNVJVEOVCVNVNVBVAVNVBBCEFIHGUDTZVOVAVBUEZUFFFABCDEIJH
      UGUHVCVLVDELZVDVFOVAVLVBVMTZVCVAVNVBVQVAVBUIVOVPFABCDEIJHUJUKZVLVQMVFVDVD
      FCEHGULUMUOUPVCVLVQVNVQVGVHUQVRVSVOVSVDFVDCEHURUSUT $.

    $( The zero of a unital ring is a right absorbing element.  (Contributed by
       FL, 31-Aug-2009.)  (New usage is discouraged.) $)
    rngorz $p |- ( ( R e. RingOps /\ A e. X ) -> ( A H Z ) = Z ) $=
      ( crngo wcel wa co wceq cgr rngogrpo grpoidcl grpolid adantr mpdan oveq2d
      syl w3a simpr rngo0cl rngodi syldan rngocl mpd3an3 eqcomd syl2anc 3eqtr3d
      3jca wb grporcan syl13anc mpbid ) BKLZAELZMZAFDNZVBCNZFVBCNZOZVBFOZVAAFFC
      NZDNZVBVCVDVAVGFADUSVGFOZUTUSCPLZVIBCIQZVJFELZVIFCEHGRFFCEHGSUAUCTUBUSUTU
      TVLVLUDVHVCOVAUTVLVLUSUTUEUSVLUTBCEFIHGUFTZVMUNAFFBCDEIJHUGUHVAVJVBELZVBV
      DOUSVJUTVKTZUSUTVLVNVMAFBCDEIJHUIUJZVJVNMVDVBVBFCEHGSUKULUMVAVJVNVLVNVEVF
      UOVOVPVMVPVBFVBCEHUPUQUR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( The set of complex numbers is a (unital) ring.  (Contributed by Steve
       Rodriguez, 2-Feb-2007.)  (Revised by Mario Carneiro, 22-Dec-2013.)
       (New usage is discouraged.) $)
    cnrngo $p |- <. + , x. >. e. RingOps $=
      ( vx vy vz caddc cmul cop wcel cc wa cv co wceq w3a wral cnaddablo pm3.2i
      c1 eqeq1d cvv ax-mp crngo cablo cxp wrex ax-mulf mulass adddi adddir 3jca
      wf rgen3 ax-1cn mulid2 mulid1 jca rgen oveq1 oveq2 anbi12d ralbidv rspcev
      mp2an wb mulex cgr ablogrpo ax-addf fdmi grporn isrngo mpbir2an ) DEFUAGZ
      DUBGZHHUCZHEUJZIZAJZBJZEKZCJZEKVQVRVTEKZEKLZVQVRVTDKEKVSVQVTEKZDKLZVQVRDK
      VTEKWCWADKLZMZCHNBHNAHNZVSVRLZVRVQEKZVRLZIZBHNZAHUDZIZVMVOOUEPWGWMWFABCHH
      HVQHGVRHGZVTHGMWBWDWEVQVRVTUFVQVRVTUGVQVRVTUHUIUKQHGQVREKZVRLZVRQEKZVRLZI
      ZBHNZWMULWTBHWOWQWSVRUMVRUNUOUPWLXAAQHVQQLZWKWTBHXBWHWQWJWSXBVSWPVRVQQVRE
      UQRXBWIWRVRVQQVREURRUSUTVAVBPESGVLVPWNIVCVDABCSDEHDHVMDVEGODVFTVNHDVGVHVI
      VJTVK $.
  $}

  ${
    $d x y z A $.
    ringsn.1 $e |- A e. _V $.
    $( The _trivial_ or _zero_ ring defined on a singleton set ` { A } ` (see
       ~ http://en.wikipedia.org/wiki/Trivial&#x5F;ring ).  (Contributed by
       Steve Rodriguez, 10-Feb-2007.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    rngosn $p |- <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >.
                e. RingOps $=
      ( vx vy vz cop csn wcel wtru a1i wceq cv w3a adantl oveq12d syl6eq eqtr4d
      co elsni syl crngo cablo ablosn crn rnsnop eqcomi cgr cxp wfo wf ablogrpo
      opex grpofo fof 4syl wa 3anim123i simp1 simp2 cfv df-ov fvsn eqtri oveq1d
      simp3 oveq2d snid isrngod trud ) AAFZAFGZVKFUAHICDEAVKVKAGZVKUBHZIABUCJZV
      LVKUDZKIVOVLVJAAAULZUEUFZJIVMVKUGHVLVLUHZVLVKUIVRVLVKUJVNVKUKVKVLVQUMVRVL
      VKUNUOICLZVLHZDLZVLHZELZVLHZMZUPZVSAKZWAAKZWCAKZMZVSWAVKRZWCVKRZVSWAWCVKR
      ZVKRZKWEWJIVTWGWBWHWDWIVSASWAASZWCASUQNZWJWKVSWCWMVKWJWKAVSWJWKAAVKRZAWJV
      SAWAAVKWGWHWIURZWGWHWIUSZOWQVJVKUTAAAVKVAVJAVPBVBVCZPZWRQWJWCAWMWGWHWIVEZ
      WJWMWQAWJWAAWCAVKWSXBOWTPQZOTWFWJWNWKVSWCVKRZVKRKWPWJVSWKWMXDVKWJVSAWKWRX
      AQWJWAVSWCVKWJWAAVSWSWRQVDOTWFWJWLXDWMVKRKWPWJWKXDWCWMVKWJWAWCVSVKWJWAAWC
      WSXBQVFXCOTAVLHIABVGJWBAWAVKRZWAKIWBXEAWAWBXEWQAWBWAAAVKWOVFWTPWOQNWBWAAV
      KRZWAKIWBXFAWAWBXFWQAWBWAAAVKWOVDWTPWOQNVHVI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Division Rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c DivRingOps $.

  $( Extend class notation with the class of all division rings. $)
  cdrng $a class DivRingOps $.

  ${
    $d g h $.
    $( Define the class of all division rings (sometimes called skew fields).
       A division ring is a unital ring where every element except the additive
       identity has a multiplicative inverse.  (Contributed by NM,
       4-Apr-2009.)  (New usage is discouraged.) $)
    df-drngo $a |- DivRingOps = { <. g , h >. | ( <. g , h >. e. RingOps
       /\ ( h |` (
 ( ran g \ { ( GId ` g ) } ) X. ( ran g \ { ( GId ` g ) } ) ) ) e. GrpOp ) } $.
  $}

  ${
    $d g h H $.  $d g h R $.  $d g h X $.  $d g h Z $.
    drngi.1 $e |- G = ( 1st ` R ) $.
    drngi.2 $e |- H = ( 2nd ` R ) $.
    drngi.3 $e |- X = ran G $.
    drngi.4 $e |- Z = ( GId ` G ) $.
    $( The properties of a division ring.  (Contributed by NM, 4-Apr-2009.)
       (New usage is discouraged.) $)
    drngoi $p |- ( R e. DivRingOps -> ( R e. RingOps /\
        ( H |` ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. GrpOp ) ) $=
      ( vg vh cdrng wcel crngo cxp cgr wa cfv wceq eleq1d csn cdif cres c1st cv
      c2nd cop crn cgi copab opeq1 id syl6eqr rneqd fveq2d sneqd difeq12d xpeq2
      xpeq1 eqtrd reseq2d anbi12d anbi1d syl6reqr reseq1d anbi2d bitr4d elopabi
      syl opeq2 df-drngo eleq2s wrel relopabi 1st2nd mpan mpbird ) ALMZANMZCDEU
      AZUBZWAOZUCZPMZQAUDRZAUFRZUGZNMZWDQZWIAJUEZKUEZUGZNMZWKWJUHZWJUIRZUAZUBZW
      QOZUCZPMZQZJKUJLXAWEWKUGZNMZWKWBUCZPMZQZWIJKAWJWESZWMXCWTXEXGWLXBNWJWEWKU
      KTXGWSXDPXGWRWBWKXGWQWASZWRWBSXGWNDWPVTXGWNBUHDXGWJBXGWJWEBXGULFUMZUNHUMX
      GWOEXGWOBUIREXGWJBUIXIUOIUMUPUQXHWRWQWAOWBWQWAWQURWQWAWAUSUTVIVATVBWKWFSZ
      XFWHXEQWIXJXCWHXEXJXBWGNWKWFWEVJTVCXJWDXEWHXJWCXDPXJCWKWBXJWKWFCXJULGVDVE
      TVFVGVHJKVKZVLVRVSWHWDVRAWGNLVMVRAWGSXAJKLXKVNALVOVPTVCVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Star Fields
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c *-Fld $.

  $( Extend class notation with the class of all star fields. $)
  csfld $a class *-Fld $.

  ${
    $d f n r x y $.
    $( Define the class of all star fields, which are all division rings with
       involutions.  (Contributed by NM, 29-Aug-2010.)
       (New usage is discouraged.) $)
    df-sfld $a |- *-Fld = { <. r , n >. | ( r e. DivRingOps /\
   n : ran ( 1st ` r ) --> ran ( 1st ` r ) /\
   A. x e. dom n A. y e. dom n
       ( ( n ` ( x ( 1st ` r ) y ) ) = ( ( n ` x ) ( 1st ` r ) ( n ` y ) ) /\
         ( n ` ( x ( 2nd ` r ) y ) ) = ( ( n ` y ) ( 2nd ` r ) ( n ` x ) ) /\
         ( n ` ( n ` x ) ) = x ) ) } $.
  $}

$(
  @{
    @d g h H @.  @d g h R @.  @d g h X @.  @d g h Z @.
    sfldi.1 @e |- R = ( 1st ` F ) @.
    sfldi.2 @e |- N = ( 2nd ` F ) @.
    sfldi.3 @e |- G = ( 1st ` R ) @.
    sfldi.4 @e |- H = ( 2nd ` R ) @.
    sfldi.5 @e |- X = ran G @.
    sfldi.6 @e |- Z = ( GId ` G ) @.
    @( The properties of a star field. @)
    sfldi @p |- ( F e. *-Fld -> ( R e. DivRingOps /\
   N : X --> X /\
   A. x e. X A. y e. X
       ( ( N ` ( x G y ) ) = ( ( N ` x ) G ( N ` y ) ) /\
         ( N ` ( x H y ) ) = ( ( N ` y ) H ( N ` x ) ) /\
         ( N ` ( N ` x ) ) = x ) ) ) @=
      (  ) ? @.
      @( [ ?] @) @( [9-Jun-2009] @)
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Fields and Rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Com2 $.

  $( Extend class notation with a class that adds commutativity to various
     flavors of rings. $)
  ccm2 $a class Com2 $.

  ${
    $d g h a b $.
    $( A device to add commutativity to various sorts of rings.  I use
       ` ran g ` because I suppose ` g ` has a neutral element and therefore is
       onto.  (Contributed by FL, 6-Sep-2009.)  (New usage is discouraged.) $)
    df-com2 $a |- Com2 = { <. g , h >. | A. a e. ran g A. b e. ran g
     ( a h b ) = ( b h a ) } $.
  $}

  ${
    $d G a b x y $.  $d H a b x y $.
    $( A device to add commutativity to various sorts of rings.  (Contributed
       by FL, 6-Sep-2009.)  (New usage is discouraged.) $)
    iscom2 $p |- ( ( G e. A /\ H e. B ) -> ( <. G , H >. e. Com2 <->
     A. a e. ran G A. b e. ran G ( a H b ) = ( b H a ) ) ) $=
      ( vy vx wcel wa cop ccm2 cv co wceq crn wral copab df-com2 oveq raleqbidv
      a1i eleq2d rneq raleqdv eqeq12d 2ralbidv opelopabg bitrd ) CAIDBIJZCDKZLI
      UKEMZFMZGMZNZUMULUNNZOZFHMZPZQZEUSQZHGRZIULUMDNZUMULDNZOZFCPZQEVFQZUJLVBU
      KLVBOUJHGEFSUBUCVAUQFVFQZEVFQVGHGCDABURCOZUTVHEUSVFURCUDZVIUQFUSVFVJUEUAU
      NDOZUQVEEFVFVFVKUOVCUPVDULUMUNDTUMULUNDTUFUGUHUI $.
  $}

  $c Fld $.

  $( Extend class notation with the class of all fields. $)
  cfld $a class Fld $.

  $( Add alternate definition. Add Kennington's one (=/= the zero ring),
       and Mizar's one: ` ( GId `` G ) =/= ( GId `` H ) ` $)
  $( Definition of a field.  A field is a commutative division ring.
     (Contributed by FL, 6-Sep-2009.)  (Revised by Jeff Madsen, 10-Jun-2010.)
     (New usage is discouraged.) $)
  df-fld $a |- Fld = ( DivRingOps i^i Com2 ) $.

  $( A field is a division ring.  (Contributed by Jeff Madsen, 10-Jun-2010.)
     (Revised by Mario Carneiro, 15-Dec-2013.)  (New usage is discouraged.) $)
  flddivrng $p |- ( K e. Fld -> K e. DivRingOps ) $=
    ( cfld cdrng ccm2 cin df-fld inss1 eqsstri sseli ) BCABCDECFCDGHI $.

  ${
    rngn0.1 $e |- G = ( 1st ` R ) $.
    rngn0.2 $e |- X = ran G $.
    $( The base set of a ring is not empty.  (Contributed by FL, 24-Jan-2010.)
       (New usage is discouraged.) $)
    rngon0 $p |- ( R e. RingOps -> X =/= (/) ) $=
      ( crngo wcel cgr c0 wne rngogrpo grpon0 syl ) AFGBHGCIJABDKBCELM $.
  $}

  ${
    $d G u x y $.  $d X u x y $.
    $( The range of an internal operation with a left and right identity
       element equals its base set.  (Contributed by FL, 24-Jan-2010.)
       (Revised by Mario Carneiro, 22-Dec-2013.)
       (New usage is discouraged.) $)
    rngmgmbs4 $p |- ( ( G : ( X X. X ) --> X /\
      E. u e. X A. x e. X ( ( u G x ) = x /\ ( x G u ) = x ) )
         -> ran G = X ) $=
      ( vy cxp wf cv co wceq wa wral wrex wfo crn r19.12 wcel simpl eqcomd syl
      oveq2 eqeq2d rspcev ex syl5 reximdv ralimia anim2i foov sylibr forn ) DDF
      ZDCGZBHZAHZCIZUOJZUOUNCIUOJZKZADLBDMZKZULDCNZCODJVAUMUOUNEHZCIZJZEDMZBDMZ
      ADLZKVBUTVHUMUTUSBDMZADLVHUSBADDPVIVGADUODQZUSVFBDUSUOUPJZVJVFUSUPUOUQURR
      SVJVKVFVEVKEUODVCUOJVDUPUOVCUOUNCUAUBUCUDUEUFUGTUHBEADDDCUIUJULDCUKT $.
  $}

  ${
    rnplrnml0.1 $e |- H = ( 2nd ` R ) $.
    rnplrnml0.2 $e |- G = ( 1st ` R ) $.
    $( In a unital ring the domain of the first variable of the addition equals
       the domain of the first variable of the multiplication.  (Contributed by
       FL, 24-Jan-2010.)  (New usage is discouraged.) $)
    rngodm1dm2 $p |- ( R e. RingOps -> dom dom G = dom dom H ) $=
      ( crngo wcel crn cxp wfo cdm wceq cgr rngogrpo eqid grpofo syl rngosm fdm
      wf fof wi wa eqtr dmeqd expcom eqcoms syl5com sylc ) AFGZBHZUKIZUKBJZULUK
      CTZBKZKCKZKLZUJBMGUMABENBUKUKOZPQABCUKEDURRUMUOULLZUNUQUMULUKBTUSULUKBUAU
      LUKBSQUNUPULLUSUQUBZULUKCSUTULUPUSULUPLZUQUSVAUCUOUPUOULUPUDUEUFUGQUHUI
      $.

    $( In a unital ring the range of the addition equals the domain of the
       first variable of the multiplication.  (Contributed by FL,
       24-Jan-2010.)  (New usage is discouraged.) $)
    rngorn1 $p |- ( R e. RingOps -> ran G = dom dom H ) $=
      ( crngo wcel crn cdm cgr wceq rngogrpo grporndm syl rngodm1dm2 eqtrd ) AF
      GZBHZBIIZCIIQBJGRSKABELBMNABCDEOP $.

    ${
      $d G x y z $.  $d H x y z $.  $d R x $.
      $( In a unital ring the range of the addition equals the range of the
         multiplication.  (Contributed by FL, 24-Jan-2010.)
         (New usage is discouraged.) $)
      rngorn1eq $p |- ( R e. RingOps -> ran G = ran H ) $=
        ( vx vy vz crngo wcel crn cxp wf cv co wceq wa wral wrex eqid cablo w3a
        rngosm rngoi simprr syl rngmgmbs4 syl2anc eqcomd ) AIJZCKZBKZUJULULLULC
        MZFNZGNZCOZUOPUOUNCOUOPQGULRFULSZUKULPABCULEDULTZUCUJBUAJUMQZUPHNZCOUNU
        OUTCOZCOPUNUOUTBOCOUPUNUTCOZBOPUNUOBOUTCOVBVABOPUBHULRGULRFULRZUQQQUQFG
        HABCULEDURUDUSVCUQUEUFGFCULUGUHUI $.
    $}
  $}

  ${
    $d H x y z $.  $d R x y z $.
    unmnd.1 $e |- H = ( 2nd ` R ) $.
    $( In a unital ring the multiplication is a monoid.  (Contributed by FL,
       24-Jan-2010.)  (Revised by Mario Carneiro, 22-Dec-2013.)
       (New usage is discouraged.) $)
    rngomndo $p |- ( R e. RingOps -> H e. MndOp ) $=
      ( vx vy vz wcel cdm cxp wf cv co wceq wral wa wrex w3a eqid wb cvv rngosm
      crngo cmndo cfv crn rngoass ralrimivvva cablo rngoi simprd rngorn1 xpid11
      c1st biimpri feq23 raleq raleqbi1dv rexeqbi1dv 3anbi123d eqcoms mpbir3and
      mpancom syl c2nd fvex eleq1 mpbiri ismndo1 mp2b sylibr ) AUBGZBHHZVLIZVLB
      JZDKZEKZBLZFKZBLVOVPVRBLZBLMZFVLNZEVLNZDVLNZVQVPMVPVOBLVPMOZEVLNZDVLPZQZB
      UCGZVKWGAUMUDZUEZWJIZWJBJZVTFWJNZEWJNZDWJNZWDEWJNZDWJPZAWIBWJWIRZCWJRZUAV
      KVTDEFWJWJWJVOVPVRAWIBWJWRCWSUFUGVKVTVOVPVRWILBLVQVOVRBLZWILMVOVPWILVRBLW
      TVSWILMQFWJNEWJNDWJNZWQVKWIUHGWLOXAWQODEFAWIBWJWRCWSUIUJUJVKWJVLMWGWLWOWQ
      QSZAWIBCWRUKXBVLWJVLWJMZVNWLWCWOWFWQVMWKMZXCVNWLSXDXCVLWJULUNVMVLWKWJBUOV
      BWBWNDVLWJWAWMEVLWJVTFVLWJUPUQUQWEWPDVLWJWDEVLWJUPURUSUTVCVABAVDUDZMZBTGZ
      WHWGSCXFXGXETGAVDVEBXETVFVGDEFTBVLVLRVHVIVJ $.
  $}

  $( In a unital ring the addition is an abelian group.  (Contributed by FL,
     31-Aug-2009.)  (New usage is discouraged.) $)
  rngoablo2 $p |- ( <. G , H >. e. RingOps -> G e. AbelOp ) $=
    ( cop crngo wcel c1st cfv cablo wbr wceq cvv wa wrel relrngo brrelex12 mpan
    df-br op1stg syl sylbir eqid rngoablo eqeltrrd ) ABCZDEZUDFGZAHUEABDIZUFAJZ
    ABDQUGAKEBKELZUHDMUGUINABDOPABKKRSTUDUFUFUAUBUC $.

  ${
    uridm.1 $e |- H = ( 2nd ` R ) $.
    uridm.2 $e |- X = ran ( 1st ` R ) $.
    ${
      uridm.3 $e |- U = ( GId ` H ) $.
      $( The unit of a ring is an identity element for the multiplication.
         (Contributed by FL, 18-Feb-2010.)  (New usage is discouraged.) $)
      rngoidmlem $p |- ( ( R e. RingOps /\ A e. X ) ->
        ( ( U H A ) = A /\ ( A H U ) = A ) ) $=
        ( crngo wcel co wceq wa wi crn cmndo cmagm cexid eqid ex mndomgmid 3syl
        cin rngomndo cmpidelt c1st cfv wb rngorn1eq eqtr eleq2d imbi1d syl mpan
        simpl mpcom mpbird imp ) BIJZAEJZCADKALACDKALMZUSUTVANZADOZJZVANZUSDPJD
        QRUCJZVEBDFUDDUAVFVDVAACDVCVCSHUETUBBUFUGZOZVCLZUSVBVEUHZBVGDFVGSUIEVHL
        ZVIUSVJNZGVKVIMEVCLZVLEVHVCUJVMUSVJVMUSMZUTVDVAVNEVCAVMUSUOUKULTUMUNUPU
        QUR $.

      $( The unit of a ring is an identity element for the multiplication.
         (Contributed by FL, 18-Apr-2010.)  (New usage is discouraged.) $)
      rngolidm $p |- ( ( R e. RingOps /\ A e. X ) -> ( U H A ) = A ) $=
        ( crngo wcel wa co wceq rngoidmlem simpld ) BIJAEJKCADLAMACDLAMABCDEFGH
        NO $.
    $}

    ${
      uridm2.2 $e |- U = ( GId ` H ) $.
      $( The unit of a ring is an identity element for the multiplication.
         (Contributed by FL, 18-Apr-2010.)  (New usage is discouraged.) $)
      rngoridm $p |- ( ( R e. RingOps /\ A e. X ) -> ( A H U ) = A ) $=
        ( crngo wcel wa co wceq rngoidmlem simprd ) BIJAEJKCADLAMACDLAMABCDEFGH
        NO $.
    $}
  $}

  ${
    $d A x $.  $d R x $.  $d X x $.
    on1el3.1 $e |- G = ( 1st ` R ) $.
    on1el3.2 $e |- X = ran G $.
    $( The only unital ring with a base set consisting in one element is the
       zero ring.  (Contributed by FL, 13-Feb-2010.)  (Proof shortened by Mario
       Carneiro, 30-Apr-2015.)  (New usage is discouraged.) $)
    rngosn3 $p |- ( ( R e. RingOps /\ A e. B ) -> ( X = { A } <-> R =
       <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >. ) ) $=
      ( crngo wcel wa csn wceq cfv cop cxp wf adantr syl5ibcom cvv wb c2nd c1st
      cgr wfo rngogrpo grpofo fof 3syl xpeq12d feq23d cdm fdm syl eqcomd eqeq2d
      xpid11 syl6ib impbid simpr xpsng sylancom opex fsng sylancr 3bitrd eqeq1i
      id feq2d syl6bb anbi1d eqid rngosm sylibd pm4.71d wrel wss relrngo df-rel
      bitrd mpbi sseli eqop 3bitr4d ) CHIZABIZJZEAKZLZCUAMZAANZANKZLZJCUBMZWKLZ
      WLJZWHCWKWKNLZWFWHWNWLWFWHDWKLZWNWFWHWGWGOZWGDPZWJKZWGDPZWQWFWHWSWFEEOZED
      PZWHWSWDXCWEWDDUCIXBEDUDXCCDFUEDEGUFXBEDUGUHQZWHXBEWRWGDWHEWGEWGWHVGZXEUI
      ZXEUJRWFWSXBWRLZWHWFXBDUKZLWSXGWFXHXBWFXCXHXBLXDXBEDULUMUNWSXHWRXBWRWGDUL
      UOREWGUPUQURWFWRWTWGDWDWEWEWRWTLWDWEUSZAABBUTVAZVHWFWJSIZWEXAWQTAAVBZXIWJ
      ASBDVCVDVEDWMWKFVFVIVJWFWHWLWFWHWRWGWIPZWLWFXBEWIPZWHXMWDXNWECDWIEFWIVKGV
      LQWHXBEWRWGWIXFXEUJRWFXMWTWGWIPZWLWFWRWTWGWIXJVHWFXKWEXOWLTXLXIWJASBWIVCV
      DVSVMVNWFCSSOZIZWPWOTWDXQWEHXPCHVOHXPVPVQHVRVTWAQCWKWKSSWBUMWC $.

    ${
      $d A x $.  $d R x $.  $d X x $.
      $( The only unital ring with one element is the zero ring.  (Contributed
         by FL, 14-Feb-2010.)  (Revised by Mario Carneiro, 30-Apr-2015.)
         (New usage is discouraged.) $)
      rngosn4 $p |- ( ( R e. RingOps /\ A e. X ) -> ( X ~~ 1o <-> R =
       <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >. ) ) $=
        ( crngo wcel wa c1o cen wbr csn wceq cop wb en1eqsn ex ensn1g breq1
        syl5ibrcom impbid adantl rngosn3 bitrd ) BGHZADHZIDJKLZDAMZNZBAAOAOMZUK
        ONUGUHUJPUFUGUHUJUGUHUJADQRUGUHUJUIJKLADSDUIJKTUAUBUCADBCDEFUDUE $.
    $}

    ${
      on1el3.3 $e |- Z = ( GId ` G ) $.
      $( The only unital ring with one element is the zero ring.  (Contributed
         by FL, 15-Feb-2010.)  (New usage is discouraged.) $)
      rngosn6 $p |- ( R e. RingOps -> ( X ~~ 1o <-> R =
        <. { <. <. Z , Z >. , Z >. } , { <. <. Z , Z >. , Z >. } >. ) ) $=
        ( crngo wcel c1o cen wbr cop csn wceq wb rngo0cl rngosn4 mpdan ) AHIDCI
        CJKLADDMDMNZTMOPABCDEFGQDABCEFRS $.
    $}
  $}

  ${
    $d H u x $.  $d X u x $.
    ring1cl.1 $e |- X = ran ( 1st ` R ) $.
    ring1cl.2 $e |- H = ( 2nd ` R ) $.
    ring1cl.3 $e |- U = ( GId ` H ) $.
    $( The unit of a ring belongs to the base set.  (Contributed by FL,
       12-Feb-2010.)  (New usage is discouraged.) $)
    rngo1cl $p |- ( R e. RingOps -> U e. X ) $=
      ( crngo wcel c2nd cfv crn cmagm cexid wa cmndo syl eqid cgi wceq rngomndo
      cin eleq1i mndoismgm mndoisexid jca sylbi elin sylibr fveq2i eqtri iorlid
      c1st wb rngorn1eq eqtr eleq2d sylancr mpbird ) AHIZBDIZBAJKZLZIZUTVBMNUBI
      ZVDUTVBMIZVBNIZOZVEUTCPIZVHACFUAVIVBPIZVHCVBPFUCVJVFVGVBUDVBUEUFUGQVBMNUH
      UIBVBVCVCRBCSKVBSKGCVBSFUJUKULQUTDAUMKZLZTZVLVCTZVAVDUNEAVKVBVBRVKRUOVMVN
      ODVCBDVLVCUPUQURUS $.
  $}

  ${
    $d R x $.  $d U x $.  $d X x $.  $d Z x $.
    uznzr.1 $e |- G = ( 1st ` R ) $.
    uznzr.2 $e |- H = ( 2nd ` R ) $.
    uznzr.3 $e |- Z = ( GId ` G ) $.
    uznzr.4 $e |- U = ( GId ` H ) $.
    uznzr.5 $e |- X = ran G $.
    $( In a unital ring the zero equals the unity iff the ring is the zero
       ring.  (Contributed by FL, 14-Feb-2010.)  (New usage is discouraged.) $)
    rngoueqz $p |- ( R e. RingOps -> ( X ~~ 1o <-> U = Z ) ) $=
      ( vx wcel c1o wceq wi wa syl ex wral cen wbr rngo0cl csn en1eqsn crn c1st
      crngo rneqi rngo1cl eleq2 biimpd elsni syl6com eqcomi syl5com com23 mpcom
      cfv eleq2s c0 wne rngon0 cv oveq2 ralrimivw rngorz ralrimiva eqtri r19.26
      rngoridm eqtr eqcoms imp31 ralimi eqsn ensn1g breq1 syl5ibr syl6bir com3l
      co sylbir com24 mpd com13 impbid ) AUHMZENUAUBZBFOZFEMZWHWIWJPACEFGKIUCZW
      KWIWHWJWKWIWHWJPWKWIQEFUDZOZWHWJFEUEWHBCUFZMWNWJPZABDWOCAUGUSZGUIZHJUJWPB
      EWOWNBEMZBWMMZWJWNWSWTEWMBUKULBFUMUNEWOKUOUTRUPSUQUREVAVBZWHWJWIPACEGKVCW
      JWHXAWIWJLVDZBDWBZXBFDWBZOZLETZWHXAWIPZWJXELEBFXBDVEVFWHXDFOZLETZXFXGPZWH
      XHLEXBACDEFIKGHVGVHXCXBOZLETZWHXIXJPWHXKLEXBABDEHEWOWQUFKWRVIJVKVHXLXFXIW
      HXGXLXFXIWHXGPZPZXLXFQXKXEQZLETZXNXKXELEVJXPXIXMXPXIQXOXHQZLETZXMXOXHLEVJ
      XRXBFOZLETZXMXQXSLEXKXEXHXSXEXHXSPZPXBXCXBXCOZXEYAYBXEQXBXDOZYAXBXCXDVLYC
      XHXSXBXDFVLSRSVMVNVOXAXTWHWIXAXTWNWHWIPLEFVPWHWIWNWMNUAUBZWHWKYDWLFEVQREW
      MNUAVRVSVTWARWCSWCSWDURWEUPWFURWG $.
  $}

  ${
    $d G g h $.  $d H g h $.  $d x y $.
    $( The predicate "is a division ring".  (Contributed by FL, 6-Sep-2009.)
       (New usage is discouraged.) $)
    isdivrngo $p |- ( H e. A -> ( <. G , H >. e. DivRingOps
     <-> ( <. G , H >. e. RingOps /\ ( H |` (
       ( ran G \ { ( GId ` G ) } ) X. ( ran G \ { ( GId ` G ) } ) ) )
         e. GrpOp ) ) ) $=
      ( vx vy vg vh wcel cop cdrng crngo crn cgi cfv csn cres cgr wa cv eleq1d
      cdif cxp cvv wbr df-br df-drngo relopabi brrelexi sylbir anim1i rngoablo2
      ancoms cablo elex ad2antrl simpl copab eleq2i wceq opeq1 rneq fveq2 sneqd
      syl jca difeq12d xpeq12d reseq2d anbi12d reseq1 opelopabg syl5bb pm5.21nd
      opeq2 ) CAHZBCIZJHZVPKHZCBLZBMNZOZUAZWBUBZPZQHZRZBUCHZVORZVQVOWHVQWGVOVQB
      CJUDWGBCJUEBCJDSZESZIKHWJWILWIMNOUAZWKUBPQHRDEJDEUFUGUHUIUJULVOWFRWGVOVRW
      GVOWEVRBUMHWGBCUKBUMUNVDUOVOWFUPVEVQVPFSZGSZIZKHZWMWLLZWLMNZOZUAZWSUBZPZQ
      HZRZFGUQZHWHWFJXDVPFGUFURXCBWMIZKHZWMWCPZQHZRWFFGBCUCAWLBUSZWOXFXBXHXIWNX
      EKWLBWMUTTXIXAXGQXIWTWCWMXIWSWBWSWBXIWPVSWRWAWLBVAXIWQVTWLBMVBVCVFZXJVGVH
      TVIWMCUSZXFVRXHWEXKXEVPKWMCBVNTXKXGWDQWMCWCVJTVIVKVLVM $.
  $}

  ${
    zrdivrng.1 $e |- A e. _V $.
    $( The zero ring is not a division ring.  (Contributed by FL,
       24-Jan-2010.)  (Proof shortened by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    zrdivrng $p |- -.
      <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >.
         e. DivRingOps $=
      ( cop csn cdrng wcel c0 cgr 0ngrp crn cgi cfv cdif cres opex rnsnop gidsn
      cxp eqtri cvv sneqi difeq12i difid xpeq2i reseq2i res0 crngo wa isdivrngo
      xp0 wb snex ax-mp simprbi syl5eqelr mto ) AACZACZDZUSCZEFZGHFIVAGUSUSJZUS
      KLZDZMZVERZNZHVGUSGNGVFGUSVFVEGRGVEGVEVEADZVHMGVBVHVDVHUQAAAOPVCAABQUAUBV
      HUCSUDVEUJSUEUSUFSVAUTUGFZVGHFZUSTFVAVIVJUHUKURULTUSUSUIUMUNUOUP $.
  $}

  ${
    dvrunz.1 $e |- G = ( 1st ` R ) $.
    dvrunz.2 $e |- H = ( 2nd ` R ) $.
    dvrunz.3 $e |- X = ran G $.
    dvrunz.4 $e |- Z = ( GId ` G ) $.
    dvrunz.5 $e |- U = ( GId ` H ) $.
    $( In a division ring the unit is different from the zero.  (Contributed by
       FL, 14-Feb-2010.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    dvrunz $p |- ( R e. DivRingOps -> U =/= Z ) $=
      ( cdrng wcel cop csn wn cgi wceq wb syl wne cfv cvv fvex eqeltri zrdivrng
      c1o cen wbr crngo cdif cxp cres cgr drngoi simpld rngoueqz rngosn6 biimpd
      wi eleq1 syl6bi pm2.43a sylbird necon3bd mpi ) ALMZFFNFNOZVHNZLMZPBFUAFFC
      QUBUCJCQUDUEUFVGVJBFVGBFRZEUGUHUIZVJVGAUJMZVLVKSVGVMDEFOUKZVNULUMUNMACDEF
      GHIJUOUPZABCDEFGHJKIUQTVLVGVJVGVLAVIRZVGVJUTVGVMVLVPSVOACEFGIJURTVPVGVJAV
      ILVAUSVBVCVDVEVF $.
  $}

  ${
    zerdivemp.1 $e |- G = ( 1st ` R ) $.
    zerdivemp.2 $e |- H = ( 2nd ` R ) $.
    zerdivemp.3 $e |- Z = ( GId ` G ) $.
    zerdivemp.4 $e |- X = ran G $.
    zerdivemp.5 $e |- U = ( GId ` H ) $.
    ${
      $d A a $.  $d B a $.  $d H a $.  $d R a $.  $d X a $.  $d Z a $.
      $( In a unitary ring a left invertible element is not a zero divisor.
         (Contributed by FL, 18-Apr-2010.) $)
      zerdivemp1 $p |- ( ( R e. RingOps /\ A e. ( X \ Z ) /\
      E. a e. X ( a H A ) = U ) ->
         ( B e. X -> ( ( A H B ) = Z -> B = Z ) ) ) $=
        ( wcel co wceq wi w3a 3exp crngo cdif wrex oveq2 simpl1 simpr1 3ad2ant3
        cv wa eldifi adantl simpl3 rngoass syl13anc ex oveq1 rngorz 3adant3 crn
        eqtr c1st cfv rneqi eqtri 3adant2 simp1 simp2 simp3 3eqtr3d com14 com13
        rngolidm a1d sylc com15 com24 syl com25 com12 3imp syl6 3imp1 mpd 3exp1
        eqcoms syl5com rexlimiv ) CUAOZAGHUBOZIUHZAFPZDQZIGUCZBGOZABFPZHQZBHQZR
        RZWMWIWHWRWLWIWHWRRZRIGWJGOZWLWIWSWPWHWNWTWLWISZWQWPWJWOFPZWJHFPZQZWHWN
        XAWQRRWOHWJFUDWHXDWNXAWQWHXDWNSZXAUIZWKBFPZXBQZWQXFWHWTAGOZWNXHWHXDWNXA
        UEXEWTWLWIUFXAXIXEWIWTXIWLAGHUJUGUKWHXDWNXAULWJABCEFGJKMUMUNWHXDWNXAXHW
        QRXHXDWNXAWHWQXHXDXGXCQZWNXAWHWQRZRRXHXDXJXGXBXCUTUOXAWNXJXKWTWLWIWNXJX
        KRRZWLWTWIXLRZWLXGDBFPZQZWTXMRWKDBFUPXOXJWIWNWTXKXJWIWNWTXKRRRZRXNXGXNX
        GQZXJXPXQXJUIXNXCQZXPXNXGXCUTXRWTWNWIXKWHWTWNWIXRWQWHWTWNWIXRWQRZRZWHWT
        WNSXCHQZXNBQZXTWHWTYAWNWJCEFGHLMJKUQURWHWNYBWTBCDFGKGEUSCVAVBZUSMEYCJVC
        VDNVLVEWIYBYAXSXRYBYAWIWQXRYBYAWIWQRXRYBYASZWQWIYDXNXCBHXRYBYAVFXRYBYAV
        GXRYBYAVHVIVMTVJVKVNTVOVPVQUOWEVRVQVSVTVKWAVOWBWCWDWFVJTWGVKVT $.
    $}

    ${
      $d A a $.  $d R a $.  $d U a $.  $d X a $.  $d Z a $.
      $( In a unitary ring a left invertible element is different from zero iff
         ` 1 =/= 0 ` .  (Contributed by FL, 18-Apr-2010.) $)
      rngoridfz $p |- ( ( R e. RingOps /\ A e. X /\
         E. a e. X ( a H A ) = U ) -> ( A =/= Z <-> U =/= Z ) ) $=
        ( wcel co wceq w3a wi wa imp crngo cv wrex rngorz eqeq12 biimpd syl5com
        wb oveq2 ex com3l 3adant3 syl5 crn c1st cfv rneqi eqtri rngoridm expcom
        syl2anc 3ad2ant3 impbid 3exp1 rexlimiv com13 3imp necon3bid ) BUANZAFNZ
        HUBZAEOZCPZHFUCZQAGCGVIVJVNAGPZCGPZUHZVNVJVIVQVMVJVIVQRRHFVKFNZVMVJVIVQ
        VRVMVJQZVISZVOVPVOVLVKGEOZPZVTVPAGVKEUIVSVIWBVPRZVRVMVIWCRZVJVRVMWDVIVR
        VMWCVIVRVMWCRVIVRSWAGPZVMWCVKBDEFGKLIJUDVMWEWCVMWESWBVPVLCWAGUEUFUJUGUJ
        UKTULTUMVPACEOZAGEOZPZVTVOCGAEUIVSVIWHVORZVJVRVIWIRVMVIVJWIVIVJSWFAPZWG
        GPZWIABCEFJFDUNBUOUPZUNLDWLIUQURMUSABDEFGKLIJUDWJWKSWHVOWFAWGGUEUFVAUTV
        BTUMVCVDVEVFVGVH $.
    $}
  $}

$(
###############################################################################
               COMPLEX TOPOLOGICAL VECTOR SPACES (DEPRECATED)
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Complex vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CVecOLD $.

  $( Extend class notation with the class of all complex vector spaces. $)
  cvc $a class CVecOLD $.

  ${
    $d g s x y z $.
    $( Define the class of all complex vector spaces.  (Contributed by NM,
       3-Nov-2006.)  (New usage is discouraged.) $)
    df-vc $a |- CVecOLD = { <. g , s >. | ( g e. AbelOp /\
     s : ( CC X. ran g ) --> ran g /\ A. x e. ran g ( ( 1 s x ) = x /\
       A. y e. CC ( A. z e. ran g ( y s ( x g z ) ) = ( ( y s x ) g ( y s z ) )
         /\ A. z e. CC ( ( ( y + z ) s x ) = ( ( y s x ) g ( z s x ) ) /\
           ( ( y x. z ) s x ) = ( y s ( z s x ) ) ) ) ) ) } $.

    $( The class of all complex vector spaces is a relation.  (Contributed by
       NM, 17-Mar-2007.)  (New usage is discouraged.) $)
    vcrel $p |- Rel CVecOLD $=
      ( vg vs vx vy vz cv cablo wcel cc crn cxp wf c1 co wceq wral caddc wa w3a
      cmul cvc df-vc relopabi ) AFZGHIUDJZKUEBFZLMCFZUFNUGODFZUGEFZUDNUFNUHUGUF
      NZUHUIUFNUDNOEUEPUHUIQNUGUFNUJUIUGUFNZUDNOUHUITNUGUFNUHUKUFNOREIPRDIPRCUE
      PSABUACDEABUBUC $.
  $}

  ${
    $d g s w x y z G $.  $d g s w x y z S $.  $d g s W $.  $d g s w x y z X $.
    $d w x y z A $.  $d w x y z B $.  $d x y z C $.
    vci.1 $e |- G = ( 1st ` W ) $.
    vci.2 $e |- S = ( 2nd ` W ) $.
    vci.3 $e |- X = ran G $.
    $( The properties of a complex vector space, which is an Abelian group
       (i.e. the vectors, with the operation of vector addition) accompanied by
       a scalar multiplication operation on the field of complex numbers.  The
       variable ` W ` was chosen because ` _V ` is already used for the
       universal class.  (Contributed by NM, 3-Nov-2006.)
       (New usage is discouraged.) $)
    vci $p |- ( W e. CVecOLD ->
              ( G e. AbelOp /\
         S : ( CC X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. CC ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. CC ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) $=
      ( vg vs cc cv co wceq wral wa oveq ralbidv cablo wcel cxp wf c1 caddc w3a
      cmul crn copab cvc c1st cfv wb eqeq2i eleq1 rneq syl6eqr xpeq2 feq2d feq3
      bitrd syl oveq2d eqeq12d raleqbidv eqeq2d anbi1d anbi12d anbi2d 3anbi123d
      sylbir c2nd feq1 eqeq1d oveq12d eqtrd 3anbi23d elopabi df-vc eleq2s ) EUA
      UBZMGUCZGDUDZUEANZDOZWEPZBNZWECNZEOZDOZWHWEDOZWHWIDOZEOZPZCGQZWHWIUFOZWED
      OZWLWIWEDOZEOZPZWHWIUHOZWEDOZWHWSDOZPZRZCMQZRZBMQZRZAGQZUGZFKNZUAUBZMXMUI
      ZUCZXOLNZUDZUEWEXQOZWEPZWHWEWIXMOZXQOZWHWEXQOZWHWIXQOZXMOZPZCXOQZWQWEXQOZ
      YCWIWEXQOZXMOZPZXBWEXQOZWHYIXQOZPZRZCMQZRZBMQZRZAXOQZUGZKLUJUKUUAWBWCGXQU
      DZXTWHWJXQOZYCYDEOZPZCGQZYHYCYIEOZPZYNRZCMQZRZBMQZRZAGQZUGZXLKLFXMFULUMZP
      XMEPZUUAUUOUNEUUPXMHUOUUQXNWBXRUUBYTUUNXMEUAUPUUQXOGPZXRUUBUNUUQXOEUIGXME
      UQJURZUURXRWCXOXQUDUUBUURXPWCXOXQXOGMUSUTXOGWCXQVAVBVCUUQYSUUMAXOGUUSUUQY
      RUULXTUUQYQUUKBMUUQYGUUFYPUUJUUQYFUUECXOGUUSUUQYBUUCYEUUDUUQYAWJWHXQWEWIX
      MESVDYCYDXMESVEVFUUQYOUUICMUUQYKUUHYNUUQYJUUGYHYCYIXMESVGVHTVITVJVFVKVLXQ
      FVMUMZPXQDPZUUOXLUNDUUTXQIUOUVAUUBWDUUNXKWBWCGXQDVNUVAUUMXJAGUVAXTWGUULXI
      UVAXSWFWEUEWEXQDSVOUVAUUKXHBMUVAUUFWPUUJXGUVAUUEWOCGUVAUUCWKUUDWNWHWJXQDS
      UVAYCWLYDWMEWHWEXQDSZWHWIXQDSVPVETUVAUUIXFCMUVAUUHXAYNXEUVAYHWRUUGWTWQWEX
      QDSUVAYCWLYIWSEUVBWIWEXQDSZVPVEUVAYLXCYMXDXBWEXQDSUVAYMWHWSXQOXDUVAYIWSWH
      XQUVCVDWHWSXQDSVQVEVITVITVITVRVLVSABCKLVTWA $.

    $( Functionality of th scalar product of a complex vector space.
       (Contributed by NM, 3-Nov-2006.)  (New usage is discouraged.) $)
    vcsm $p |- ( W e. CVecOLD -> S : ( CC X. X ) --> X ) $=
      ( vx vy vz cvc wcel cablo cc cxp cv co wceq wral wa wf c1 cmul vci simp2d
      caddc ) CKLBMLNDODAUAUBHPZAQUGRIPZUGJPZBQAQUHUGAQZUHUIAQBQRJDSUHUIUFQUGAQ
      UJUIUGAQZBQRUHUIUCQUGAQUHUKAQRTJNSTINSTHDSHIJABCDEFGUDUE $.

    $( Closure of the scalar product of a complex vector space.  (Contributed
       by NM, 3-Nov-2006.)  (New usage is discouraged.) $)
    vccl $p |- ( ( W e. CVecOLD /\ A e. CC /\ B e. X ) -> ( A S B ) e. X ) $=
      ( cvc wcel cc cxp wf co vcsm fovrn syl3an1 ) EJKLFMFCNALKBFKABCOFKCDEFGHI
      PABFLFCQR $.

    $( Identity element for the scalar product of a complex vector space.
       (Contributed by NM, 3-Nov-2006.)  (New usage is discouraged.) $)
    vcid $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( 1 S A ) = A ) $=
      ( vx vy vz cvc wcel c1 cv co wceq wral cc wa cablo cxp caddc cmul w3a vci
      wf simpl ralimi 3ad2ant3 syl oveq2 id eqeq12d rspccva sylan ) DLMZNIOZBPZ
      URQZIERZAEMNABPZAQZUQCUAMZSEUBEBUGZUTJOZURKOZCPBPVFURBPZVFVGBPCPQKERVFVGU
      CPURBPVHVGURBPZCPQVFVGUDPURBPVFVIBPQTKSRTJSRZTZIERZUEVAIJKBCDEFGHUFVLVDVA
      VEVKUTIEUTVJUHUIUJUKUTVCIAEURAQZUSVBURAURANBULVMUMUNUOUP $.

    $( Distributive law for the scalar product of a complex vector space.
       (Contributed by NM, 3-Nov-2006.)  (New usage is discouraged.) $)
    vcdi $p |- ( ( W e. CVecOLD /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
       ( A S ( B G C ) ) = ( ( A S B ) G ( A S C ) ) ) $=
      ( vy vx vz cc wcel w3a co wceq wral oveq1 cvc wi cv cablo cxp wf c1 caddc
      cmul wa vci simpl ralimi adantl 3ad2ant3 syl oveq2d oveq2 eqeq12d oveq12d
      oveq1d rspc3v syl5 3com12 impcom ) ANOZBGOZCGOZPFUAOZABCEQZDQZABDQZACDQZE
      QZRZVGVFVHVIVOUBVIKUCZLUCZMUCZEQZDQZVPVQDQZVPVRDQZEQZRZMGSZKNSZLGSZVGVFVH
      PVOVIEUDOZNGUEGDUFZUGVQDQVQRZWEVPVRUHQVQDQWAVRVQDQZEQRVPVRUIQVQDQVPWKDQRU
      JMNSZUJZKNSZUJZLGSZPWGLKMDEFGHIJUKWPWHWGWIWOWFLGWNWFWJWMWEKNWEWLULUMUNUMU
      OUPWDVOVPBVREQZDQZVPBDQZWBEQZRAWQDQZVLAVRDQZEQZRLKMBACGNGVQBRZVTWRWCWTXDV
      SWQVPDVQBVRETUQXDWAWSWBEVQBVPDURVAUSVPARZWRXAWTXCVPAWQDTXEWSVLWBXBEVPABDT
      VPAVRDTUTUSVRCRZXAVKXCVNXFWQVJADVRCBEURUQXFXBVMVLEVRCADURUQUSVBVCVDVE $.

    $( Distributive law for the scalar product of a complex vector space.
       (Contributed by NM, 3-Nov-2006.)  (New usage is discouraged.) $)
    vcdir $p |- ( ( W e. CVecOLD /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A + B ) S C ) = ( ( A S C ) G ( B S C ) ) ) $=
      ( vy vz vx cc wcel caddc co wceq wral oveq2 w3a cvc wi cv cablo cxp wf c1
      cmul wa vci simpl ralimi adantl 3ad2ant3 syl oveq12d eqeq12d oveq1 oveq1d
      oveq2d rspc3v syl5 3coml impcom ) ANOZBNOZCGOZUAFUBOZABPQZCDQZACDQZBCDQZE
      QZRZVHVFVGVIVOUCVIKUDZLUDZPQZMUDZDQZVPVSDQZVQVSDQZEQZRZLNSZKNSZMGSZVHVFVG
      UAVOVIEUEOZNGUFGDUGZUHVSDQVSRZVPVSVQEQDQWAVPVQDQEQRLGSZWDVPVQUIQVSDQVPWBD
      QRZUJZLNSZUJZKNSZUJZMGSZUAWGMKLDEFGHIJUKWRWHWGWIWQWFMGWPWFWJWOWEKNWNWEWKW
      MWDLNWDWLULUMUNUMUNUMUOUPWDVOVRCDQZVPCDQZVQCDQZEQZRAVQPQZCDQZVLXAEQZRMKLC
      ABGNNVSCRZVTWSWCXBVSCVRDTXFWAWTWBXAEVSCVPDTVSCVQDTUQURVPARZWSXDXBXEXGVRXC
      CDVPAVQPUSUTXGWTVLXAEVPACDUSUTURVQBRZXDVKXEVNXHXCVJCDVQBAPTUTXHXAVMVLEVQB
      CDUSVAURVBVCVDVE $.

    $( Associative law for the scalar product of a complex vector space.
       (Contributed by NM, 3-Nov-2006.)  (New usage is discouraged.) $)
    vcass $p |- ( ( W e. CVecOLD /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A x. B ) S C ) = ( A S ( B S C ) ) ) $=
      ( vy vz vx cc wcel w3a cmul co wceq wral cvc wi cv cablo cxp wf caddc vci
      c1 wa simpr ralimi adantl 3ad2ant3 syl oveq2 oveq2d eqeq12d oveq1d rspc3v
      oveq1 syl5 3coml impcom ) ANOZBNOZCGOZPFUAOZABQRZCDRZABCDRZDRZSZVGVEVFVHV
      MUBVHKUCZLUCZQRZMUCZDRZVNVOVQDRZDRZSZLNTZKNTZMGTZVGVEVFPVMVHEUDOZNGUEGDUF
      ZUIVQDRVQSZVNVQVOERDRVNVQDRZVNVODRERSLGTZVNVOUGRVQDRWHVSERSZWAUJZLNTZUJZK
      NTZUJZMGTZPWDMKLDEFGHIJUHWPWEWDWFWOWCMGWNWCWGWMWBKNWLWBWIWKWALNWJWAUKULUM
      ULUMULUNUOWAVMVPCDRZVNVOCDRZDRZSAVOQRZCDRZAWRDRZSMKLCABGNNVQCSZVRWQVTWSVQ
      CVPDUPXCVSWRVNDVQCVODUPUQURVNASZWQXAWSXBXDVPWTCDVNAVOQVAUSVNAWRDVAURVOBSZ
      XAVJXBVLXEWTVICDVOBAQUPUSXEWRVKADVOBCDVAUQURUTVBVCVD $.

    $( A vector plus itself is two times the vector.  (Contributed by NM,
       1-Feb-2007.)  (New usage is discouraged.) $)
    vc2 $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( A G A ) = ( 2 S A ) ) $=
      ( cvc wcel wa c1 co c2 vcid oveq12d caddc df-2 oveq1i ax-1cn wceq mp3anr1
      cc vcdir mpanr1 syl5req eqtr3d ) DIJZAEJZKZLABMZUKCMZAACMNABMZUJUKAUKACAB
      CDEFGHOZUNPUJUMLLQMZABMZULNUOABRSUHLUCJZUIUPULUAZTUHUQUQUIURTLLABCDEFGHUD
      UBUEUFUG $.

    $( Subtractive distributive law for the scalar product of a complex vector
       space.  (Contributed by NM, 31-Jul-2007.)
       (New usage is discouraged.) $)
    vcsubdir $p |- ( ( W e. CVecOLD /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A - B ) S C ) = ( ( A S C ) G ( -u 1 S ( B S C ) ) ) ) $=
      ( cvc wcel cc w3a wa co cneg wceq oveq1d eqtr3d cmin c1 caddc negcl vcdir
      syl3anr2 negsub 3adant3 adantl cmul mulm1 ad2antrl vcass mp3anr1 3adantr1
      neg1cn oveq2d ) FKLZAMLZBMLZCGLZNZOZACDPZBQZCDPZEPZABUAPZCDPZVDUBQZBCDPDP
      ZEPVCAVEUCPZCDPZVGVIUTUSURVEMLVAVMVGRBUDAVECDEFGHIJUEUFVCVLVHCDVBVLVHRZUR
      USUTVNVAABUGUHUISTVCVFVKVDEURUTVAVFVKRUSURUTVAOOZVJBUJPZCDPZVFVKVOVPVECDU
      TVPVERURVABUKULSURVJMLUTVAVQVKRUPVJBCDEFGHIJUMUNTUOUQT $.
  $}

  ${
    $d x y z G $.  $d x y z W $.
    vcabl.1 $e |- G = ( 1st ` W ) $.
    $( Vector addition is an Abelian group operation.  (Contributed by NM,
       3-Nov-2006.)  (New usage is discouraged.) $)
    vcablo $p |- ( W e. CVecOLD -> G e. AbelOp ) $=
      ( vx vy vz cvc wcel cablo cc crn cxp c2nd cfv cv co wceq wral wa eqid vci
      wf c1 caddc cmul simp1d ) BGHAIHJAKZLUGBMNZUBUCDOZUHPUIQEOZUIFOZAPUHPUJUI
      UHPZUJUKUHPAPQFUGRUJUKUDPUIUHPULUKUIUHPZAPQUJUKUEPUIUHPUJUMUHPQSFJRSEJRSD
      UGRDEFUHABUGCUHTUGTUAUF $.

    $( Vector addition is a group operation.  (Contributed by NM, 4-Nov-2006.)
       (New usage is discouraged.) $)
    vcgrp $p |- ( W e. CVecOLD -> G e. GrpOp ) $=
      ( cvc wcel cablo cgr vcablo ablogrpo syl ) BDEAFEAGEABCHAIJ $.
  $}

  ${
    vcgcl.1 $e |- G = ( 1st ` W ) $.
    vcgcl.2 $e |- X = ran G $.
    $( Closure law for the vector addition (group) operation of a complex
       vector space.  (Contributed by NM, 1-Feb-2007.)
       (New usage is discouraged.) $)
    vcgcl $p |- ( ( W e. CVecOLD /\ A e. X /\ B e. X ) -> ( A G B ) e. X ) $=
      ( cvc wcel cgr co vcgrp grpocl syl3an1 ) DHICJIAEIBEIABCKEICDFLABCEGMN $.
  $}

  ${
    vccom.1 $e |- G = ( 1st ` W ) $.
    vccom.2 $e |- X = ran G $.
    $( Vector addition is commutative.  (Contributed by NM, 4-Nov-2006.)
       (New usage is discouraged.) $)
    vccom $p |- ( ( W e. CVecOLD /\ A e. X /\ B e. X ) ->
                ( A G B ) = ( B G A ) ) $=
      ( cvc wcel cablo co wceq vcablo ablocom syl3an1 ) DHICJIAEIBEIABCKBACKLCD
      FMABCEGNO $.

    $( Vector addition is associative.  (Contributed by NM, 4-Nov-2006.)
       (New usage is discouraged.) $)
    vcaass $p |- ( ( W e. CVecOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      ( cvc wcel cgr w3a co wceq vcgrp grpoass sylan ) EIJDKJAFJBFJCFJLABDMCDMA
      BCDMDMNDEGOABCDFHPQ $.

    $( Commutative/associative law that swaps the last two terms in a triple
       vector sum.  (Contributed by NM, 5-Aug-2007.)
       (New usage is discouraged.) $)
    vca32 $p |- ( ( W e. CVecOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
     ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      ( cvc wcel cablo w3a co wceq vcablo ablo32 sylan ) EIJDKJAFJBFJCFJLABDMCD
      MACDMBDMNDEGOABCDFHPQ $.

    $( Rearrangement of 4 terms in a vector sum.  (Contributed by NM,
       5-Aug-2007.)  (New usage is discouraged.) $)
    vca4 $p |- ( ( W e. CVecOLD /\ ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X )
      ) -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      ( cvc wcel cablo wa co wceq vcablo ablo4 syl3an1 ) FJKELKAGKBGKMCGKDGKMAB
      ENCDENENACENBDENENOEFHPABCDEGIQR $.

    $( Right cancellation law for vector addition.  (Contributed by NM,
       4-Nov-2006.)  (New usage is discouraged.) $)
    vcrcan $p |- ( ( W e. CVecOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      ( cvc wcel cgr w3a co wceq wb vcgrp grporcan sylan ) EIJDKJAFJBFJCFJLACDM
      BCDMNABNODEGPABCDFHQR $.

    $( Left cancellation law for vector addition.  (Contributed by NM,
       4-Nov-2006.)  (New usage is discouraged.) $)
    vclcan $p |- ( ( W e. CVecOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      ( cvc wcel cgr w3a co wceq wb vcgrp grpolcan sylan ) EIJDKJAFJBFJCFJLCADM
      CBDMNABNODEGPABCDFHQR $.
  $}

  ${
    vczcl.1 $e |- G = ( 1st ` W ) $.
    vczcl.2 $e |- X = ran G $.
    vczcl.3 $e |- Z = ( GId ` G ) $.
    $( The zero vector is a vector.  (Contributed by NM, 4-Nov-2006.)
       (New usage is discouraged.) $)
    vczcl $p |- ( W e. CVecOLD -> Z e. X ) $=
      ( cvc wcel cgr vcgrp grpoidcl syl ) BHIAJIDCIABEKDACFGLM $.

    $( The zero vector is a right identity element.  (Contributed by NM,
       4-Nov-2006.)  (New usage is discouraged.) $)
    vc0rid $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( A G Z ) = A ) $=
      ( cvc wcel cgr co wceq vcgrp grporid sylan ) CIJBKJADJAEBLAMBCFNAEBDGHOP
      $.

    $( The zero vector is a left identity element.  (Contributed by NM,
       26-Apr-2007.)  (New usage is discouraged.) $)
    vc0lid $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( Z G A ) = A ) $=
      ( cvc wcel cgr co wceq vcgrp grpolid sylan ) CIJBKJADJEABLAMBCFNAEBDGHOP
      $.
  $}

  ${
    vc0.1 $e |- G = ( 1st ` W ) $.
    vc0.2 $e |- S = ( 2nd ` W ) $.
    vc0.3 $e |- X = ran G $.
    vc0.4 $e |- Z = ( GId ` G ) $.
    $( Zero times a vector is the zero vector.  Equation 1a of [Kreyszig]
       p. 51.  (Contributed by NM, 4-Nov-2006.)  (New usage is discouraged.) $)
    vc0 $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( 0 S A ) = Z ) $=
      ( cvc wcel wa cc0 co wceq c1 ax-1cn cc 0cn vc0rid caddc oveq1i vcdir vcid
      addid1i mp3anr1 mpanr1 3eqtr3a oveq1d 3eqtr2rd w3a wb mp3an2 vczcl adantr
      vccl simpr 3jca vclcan syldan mpbid ) DKLZAELZMZANABOZCOZAFCOZPZVFFPZVEVH
      AQABOZVFCOZVGACDEFGIJUAVEQNUBOZABOZVKVLAVMQABQRUFUCVCNSLZVDVNVLPZTVCQSLVO
      VDVPRQNABCDEGHIUDUGUHABCDEGHIUEZUIVEVKAVFCVQUJUKVCVDVFELZFELZVDULVIVJUMVE
      VRVSVDVCVOVDVRTNABCDEGHIUQUNVCVSVDCDEFGIJUOUPVCVDURUSVFFACDEGIUTVAVB $.

    $( Anything times the zero vector is the zero vector.  Equation 1b of
       [Kreyszig] p. 51.  (Contributed by NM, 24-Nov-2006.)
       (New usage is discouraged.) $)
    vcz $p |- ( ( W e. CVecOLD /\ A e. CC ) -> ( A S Z ) = Z ) $=
      ( cvc wcel cc wa cc0 cmul co wceq vczcl anim2i ancoms vcass mp3anr2 mul01
      0cn syldan oveq1d vc0 mpdan sylan9eqr oveq2d adantr 3eqtr3rd ) DKLZAMLZNA
      OPQZFBQZAOFBQZBQZFAFBQZUNUOUOFELZNZUQUSRZUOUNVBUNVAUOCDEFGIJSZTUAUNUOOMLV
      AVCUEAOFBCDEGHIUBUCUFUOUNUQURFUOUPOFBAUDUGUNVAURFRVDFBCDEFGHIJUHUIZUJUNUS
      UTRUOUNURFABVEUKULUM $.
  $}

  ${
    vcm.1 $e |- G = ( 1st ` W ) $.
    vcm.2 $e |- S = ( 2nd ` W ) $.
    vcm.3 $e |- X = ran G $.
    vcm.4 $e |- M = ( inv ` G ) $.
    $( Minus 1 times a vector is the underlying group's inverse element.
       Equation 2 of [Kreyszig] p. 51.  (Contributed by NM, 25-Nov-2006.)
       (New usage is discouraged.) $)
    vcm $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( -u 1 S A ) = ( M ` A ) ) $=
      ( wcel c1 co cfv wceq cc neg1cn cc0 ax-1cn eqtr3d cvc cneg cgi cgr adantr
      wa vcgrp vccl eqid grporid syl2anc simpr grpoinvcl sylan grpoass syl13anc
      mp3an2 vcid oveq2d caddc negidi addcomli oveq1i vcdir mp3anr1 vc0 3eqtr3a
      mpanr1 oveq1d grporinv grpolid ) EUAKZAFKZUFZLUBZABMZCUCNZCMZVPADNZVNCUDK
      ZVPFKZVRVPOVLVTVMCEGUGZUEZVLVOPKZVMWAQVOABCEFGHIUHUQZVPVQCFIVQUIZUJUKVNVQ
      VSCMZVRVSVNVPAVSCMZCMZWGVRVNVPACMZVSCMZWIWGVNVTWAVMVSFKZWKWIOWCWEVLVMULVL
      VTVMWLWBACDFIJUMUNZVPAVSCFIUOUPVNWJVQVSCVNVPLABMZCMZWJVQVNWNAVPCABCEFGHIU
      RUSVNVOLUTMZABMZRABMWOVQWPRABLVORSQLSVAVBVCVLLPKZVMWQWOOZSVLWDWRVMWSQVOLA
      BCEFGHIVDVEVHABCEFVQGHIWFVFVGTVITVNWHVQVPCVLVTVMWHVQOWBAVQCDFIWFJVJUNUSTV
      NVTWLWGVSOWCWMVSVQCFIWFVKUKTT $.
  $}

  ${
    vcrinv.1 $e |- G = ( 1st ` W ) $.
    vcrinv.2 $e |- S = ( 2nd ` W ) $.
    vcrinv.3 $e |- X = ran G $.
    vcrinv.4 $e |- Z = ( GId ` G ) $.
    $( A vector minus itself.  (Contributed by NM, 4-Dec-2006.)
       (New usage is discouraged.) $)
    vcrinv $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( A G ( -u 1 S A ) ) = Z ) $=
      ( cvc wcel wa c1 cneg co cgn cfv eqid vcm oveq2d cgr vcgrp grporinv sylan
      wceq eqtrd ) DKLZAELZMZANOABPZCPAACQRZRZCPZFUJUKUMACABCULDEGHIULSZTUAUHCU
      BLUIUNFUFCDGUCAFCULEIJUOUDUEUG $.

    $( Minus a vector plus itself.  (Contributed by NM, 4-Dec-2006.)
       (New usage is discouraged.) $)
    vclinv $p |- ( ( W e. CVecOLD /\ A e. X ) -> ( ( -u 1 S A ) G A ) = Z ) $=
      ( cvc wcel wa c1 cneg co cgn cfv eqid vcm oveq1d cgr vcgrp grpolinv sylan
      wceq eqtrd ) DKLZAELZMZNOABPZACPACQRZRZACPZFUJUKUMACABCULDEGHIULSZTUAUHCU
      BLUIUNFUFCDGUCAFCULEIJUOUDUEUG $.
  $}

  ${
    vcni.1 $e |- G = ( 1st ` W ) $.
    vcni.2 $e |- S = ( 2nd ` W ) $.
    vcni.3 $e |- X = ran G $.
    $( Double negative of a vector.  (Contributed by NM, 6-Aug-2007.)
       (New usage is discouraged.) $)
    vcnegneg $p |- ( ( W e. CVecOLD /\ A e. X ) ->
                  ( -u 1 S ( -u 1 S A ) ) = A ) $=
      ( cvc wcel wa c1 cneg cmul co ax-1cn mul2negi 1t1e1 eqtri neg1cn cc vcass
      oveq1i wceq mp3anr1 mpanr1 vcid 3eqtr3a ) DIJZAEJZKLMZUKNOZABOZLABOUKUKAB
      OBOZAULLABULLLNOLLLPPQRSUCUIUKUAJZUJUMUNUDZTUIUOUOUJUPTUKUKABCDEFGHUBUEUF
      ABCDEFGHUGUH $.

    $( Distribution of negative over vector subtraction.  (Contributed by NM,
       6-Aug-2007.)  (New usage is discouraged.) $)
    vcnegsubdi2 $p |- ( ( W e. CVecOLD /\ A e. X /\ B e. X ) ->
              ( -u 1 S ( A G ( -u 1 S B ) ) ) = ( B G ( -u 1 S A ) ) ) $=
      ( cvc wcel w3a c1 cneg co wceq neg1cn vccl mp3an2 3adant2 cc vcdi mp3anr1
      3impb syld3an3 vcnegneg oveq2d 3adant3 vccom syld3an2 3eqtrd ) EJKZAFKZBF
      KZLZMNZAUPBCOZDOCOZUPACOZUPUQCOZDOZUSBDOZBUSDOZULUMUNUQFKZURVAPZULUNVDUMU
      LUPUAKZUNVDQUPBCDEFGHIRSTULUMVDVEULVFUMVDVEQUPAUQCDEFGHIUBUCUDUEUOUTBUSDU
      LUNUTBPUMBCDEFGHIUFTUGULUSFKZUMUNVBVCPULUMVGUNULVFUMVGQUPACDEFGHIRSUHUSBD
      EFGIUIUJUK $.

    $( Rearrangement of 4 terms in a mixed vector addition and subtraction.
       (Contributed by NM, 5-Aug-2007.)  (New usage is discouraged.) $)
    vcsub4 $p |- ( ( W e. CVecOLD /\ ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X
        )
              ) -> ( ( A G B ) G ( -u 1 S ( C G D ) ) ) =
            ( ( A G ( -u 1 S C ) ) G ( B G ( -u 1 S D ) ) ) ) $=
      ( cvc wcel wa co wceq neg1cn 3adant2 vccl mp3an2 w3a c1 cneg vcdi mp3anr1
      cc oveq2d anim12dan vca4 syld3an3 eqtrd ) GLMZAHMBHMNZCHMZDHMZNZUAZABFOZU
      BUCZCDFOEOZFOURUSCEOZUSDEOZFOZFOZAVAFOBVBFOFOZUQUTVCURFULUPUTVCPZUMULUSUF
      MZUNUOVFQUSCDEFGHIJKUDUERUGULUMUPVAHMZVBHMZNZVDVEPULUPVJUMULUNVHUOVIULVGU
      NVHQUSCEFGHIJKSTULVGUOVIQUSDEFGHIJKSTUHRABVAVBFGHIKUIUJUK $.
  $}

  ${
    $d g s x y z G $.  $d g s x y z S $.  $d g s x z X $.
    isvclem.1 $e |- X = ran G $.
    $( Lemma for ~ isvc .  (Contributed by NM, 31-May-2008.)
       (New usage is discouraged.) $)
    isvclem $p |- ( ( G e. _V /\ S e. _V ) -> ( <. G , S >. e. CVecOLD
     <-> ( G e. AbelOp /\ S : ( CC X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. CC ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. CC ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) ) $=
      ( vg vs wcel cv cc wf co wceq wral wa cvv oveq ralbidv cop cvc crn cxp c1
      cablo caddc cmul w3a copab df-vc eleq2i eleq1 wb rneq syl6eqr xpeq2 feq2d
      bitrd syl oveq2d eqeq12d raleqbidv eqeq2d anbi1d anbi12d anbi2d 3anbi123d
      feq3 feq1 eqeq1d oveq12d eqtrd 3anbi23d opelopabg syl5bb ) EDUAZUBJVQHKZU
      FJZLVRUCZUDZVTIKZMZUEAKZWBNZWDOZBKZWDCKZVRNZWBNZWGWDWBNZWGWHWBNZVRNZOZCVT
      PZWGWHUGNZWDWBNZWKWHWDWBNZVRNZOZWGWHUHNZWDWBNZWGWRWBNZOZQZCLPZQZBLPZQZAVT
      PZUIZHIUJZJERJDRJQEUFJZLFUDZFDMZUEWDDNZWDOZWGWDWHENZDNZWGWDDNZWGWHDNZENZO
      ZCFPZWPWDDNZXTWHWDDNZENZOZXAWDDNZWGYFDNZOZQZCLPZQZBLPZQZAFPZUIZUBXLVQABCH
      IUKULXKXMXNFWBMZWFWGXRWBNZWKWLENZOZCFPZWQWKWRENZOZXDQZCLPZQZBLPZQZAFPZUIY
      RHIEDRRVREOZVSXMWCYSXJUUKVREUFUMUULVTFOZWCYSUNUULVTEUCFVREUOGUPZUUMWCXNVT
      WBMYSUUMWAXNVTWBVTFLUQURVTFXNWBVIUSUTUULXIUUJAVTFUUNUULXHUUIWFUULXGUUHBLU
      ULWOUUCXFUUGUULWNUUBCVTFUUNUULWJYTWMUUAUULWIXRWGWBWDWHVRESVAWKWLVRESVBVCU
      ULXEUUFCLUULWTUUEXDUULWSUUDWQWKWRVRESVDVETVFTVGVCVHWBDOZYSXOUUKYQXMXNFWBD
      VJUUOUUJYPAFUUOWFXQUUIYOUUOWEXPWDUEWDWBDSVKUUOUUHYNBLUUOUUCYDUUGYMUUOUUBY
      CCFUUOYTXSUUAYBWGXRWBDSUUOWKXTWLYAEWGWDWBDSZWGWHWBDSVLVBTUUOUUFYLCLUUOUUE
      YHXDYKUUOWQYEUUDYGWPWDWBDSUUOWKXTWRYFEUUPWHWDWBDSZVLVBUUOXBYIXCYJXAWDWBDS
      UUOXCWGWRDNYJWGWRWBDSUUOWRYFWGDUUQVAVMVBVFTVFTVFTVNVOVP $.
  $}

  ${
    $d x y z G $.
    $( Lemma for ~ vcoprne .  (Contributed by NM, 31-May-2008.)
       (New usage is discouraged.) $)
    vcoprnelem $p |- ( <. G , G >. e. CVecOLD -> G : ( CC X. CC ) --> CC ) $=
      ( vx vy vz cvv wcel cop cvc cc cxp wf syl wa cv co wceq wral wb wfn mpbid
      wrel wss vcrel df-rel mpbi sseli opelxp1 cablo crn c1 caddc cmul w3a eqid
      isvclem anidms biimpa simpr cgr ablogrpo wfo grpofo fofn ffn fndmu syl2an
      c0 wne grpon0 xpcan2 adantr sylan xpeq2 feq2d feq3 bitrd 3adant3 mpancom
      ) AEFZAAGZHFZIIJZIAKZWAVTEEJZFVSHWDVTHUAHWDUBUCHUDUEUFAAEEUGLVSWAMAUHFZIA
      UIZJZWFAKZUJBNZAOWIPCNZWIDNZAOAOWJWIAOZWJWKAOAOPDWFQWJWKUKOWIAOWLWKWIAOZA
      OPWJWKULOWIAOWJWMAOPMDIQMCIQMBWFQZUMZWCVSWAWOVSWAWORBCDAAWFWFUNZUOUPUQWEW
      HWCWNWEWHMZWHWCWEWHURWQWFIPZWHWCRWEAUSFZWHWRAUTWSWHMWFWFJZWGPZWRWSAWTSZAW
      GSXAWHWSWTWFAVAXBAWFWPVBWTWFAVCLWGWFAVDWTWGAVEVFWSXAWRRZWHWSWFVGVHXCAWFWP
      VIWFIWFVJLVKTVLWRWHWBWFAKWCWRWGWBWFAWFIIVMVNWFIWBAVOVPLTVQLVR $.
  $}

  $( The operations of a complex vector space cannot be identical.
     (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
  vcoprne $p |- ( <. G , S >. e. CVecOLD -> G =/= S ) $=
    ( cop cvc wcel wceq c1 cc0 cfv co cvv cnex syl2anc oveqd crn cdm eqid mpdan
    cc eqtr3d wne wn ax-1ne0 df-ne mpbi c1st cgi cxp wf vcoprnelem xpex sylancl
    fex op1stg ax-1cn rneqd cgr vcgrp eqeltrrd grporndm syl dmeqd dmxpid syl6eq
    c2nd fdm 3eqtrd syl5eleqr vc0rid vcid op2ndg eqtr4d 3eqtr2d wb vczcl vclcan
    w3a 3jca mpbid oveq2d 0cn vcz mpan2 eqtrd mto opeq2 eleq1d mtbii necon2ai )
    BACZDEZBABAFZBBCZDEZWKWNGHFZGHUAWOUBUCGHUDUEWNHWMUFIZUGIZWPJZGHWNWRHWQBJZHG
    BJZGWNWPBHWQWNBKEZXAWPBFWNSSUHZSBUIZXBKEXABUJZSSLLUKXBSKBUMULZXEBBKKUNMZNWN
    WQGHBWNGWQWPJZGGWPJZFZWQGFZWNXGGGGWMVEIZJZXHWNGWPOZEZXGGFWNGSXMUOWNXMBOZBPZ
    PZSWNWPBXFUPWNBUQEXOXQFWNWPBUQXFWPWMWPQZURUSBUTVAWNXQXBPSWNXPXBWNXCXPXBFXDX
    BSBVFVAVBSVCVDVGZVHZGWPWMXMWQXRXMQZWQQZVIRWNXNXLGFXTGXKWPWMXMXRXKQZYAVJRWNX
    KWPGGWNXKBWPWNXAXAXKBFXEXEBBKKVKMZXFVLNVMWNWQXMEZXNXNVQXIXJVNWNYEXNXNWPWMXM
    WQXRYAYBVOXTXTVRWQGGWPWMXMXRYAVPRVSZVTZWNWQWTGWNHWQXKJZWQWTWNHSEYHWQFWAHXKW
    PWMXMWQXRYCYAYBWBWCWNYHWSWTWNXKBHWQYDNYGWDTYFTVGWNHXMEWRHFWNHSXMWAXSVHHWPWM
    XMWQXRYAYBVIRTWEWLWMWJDBABWFWGWHWI $.

  $( The components of a complex vector space are sets.  (Contributed by NM,
     31-May-2008.)  (New usage is discouraged.) $)
  vcex $p |- ( <. G , S >. e. CVecOLD -> ( G e. _V /\ S e. _V ) ) $=
    ( cop cvc wcel wbr cvv wa df-br wrel cxp wss vcrel df-rel mpbi brel sylbir
    ) BACDEBADFBGEAGEHBADIBAGGDDJDGGKLMDNOPQ $.

  ${
    $d x y z G $.  $d x y z S $.  $d x z X $.
    isvc.1 $e |- X = ran G $.
    $( The predicate "is a complex vector space."  (Contributed by NM,
       31-May-2008.)  (New usage is discouraged.) $)
    isvc $p |- ( <. G , S >. e. CVecOLD <-> ( G e. AbelOp /\
         S : ( CC X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. CC ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. CC ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) $=
      ( cop cvc wcel cvv wa cablo cc cxp cv co wceq wral cgr wf caddc cmul vcex
      c1 w3a elex adantr cnex ablogrpo crn rnexg syl5eqel syl xpexg sylancr fex
      sylan2 ancoms jca 3adant3 isvclem pm5.21nii ) EDHIJEKJZDKJZLZEMJZNFOZFDUA
      ZUEAPZDQVJRBPZVJCPZEQDQVKVJDQZVKVLDQEQRCFSVKVLUBQVJDQVMVLVJDQZEQRVKVLUCQV
      JDQVKVNDQRLCNSLBNSLAFSZUFDEUDVGVIVFVOVGVILVDVEVGVDVIEMUGUHVIVGVEVGVIVHKJZ
      VEVGNKJFKJZVPUIVGETJZVQEUJVRFEUKKGETULUMUNNFKKUOUPVHFKDUQURUSUTVAABCDEFGV
      BVC $.
  $}

  ${
    $d x y z G $.  $d x y z S $.  $d x y z X $.
    isvci.1 $e |- G e. AbelOp $.
    isvci.2 $e |- dom G = ( X X. X ) $.
    isvci.3 $e |- S : ( CC X. X ) --> X $.
    isvci.4 $e |- ( x e. X -> ( 1 S x ) = x ) $.
    isvci.5 $e |- ( ( y e. CC /\ x e. X /\ z e. X ) ->
                  ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) ) ) $.
    isvci.6 $e |- ( ( y e. CC /\ z e. CC /\ x e. X ) ->
                  ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) ) $.
    isvci.7 $e |- ( ( y e. CC /\ z e. CC /\ x e. X ) ->
                  ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) $.
    isvci.8 $e |- W = <. G , S >. $.
    $( Properties that determine a complex vector space.  (Contributed by NM,
       5-Nov-2006.)  (New usage is discouraged.) $)
    isvci $p |- W e. CVecOLD $=
      ( wcel cc co wceq wral cop cvc cablo cxp wf c1 cv caddc cmul 3com12 3expa
      wa ralrimiva w3a jca 3comr rgen cgr ablogrpo grporn isvc mpbir3an eqeltri
      ax-mp ) FEDUAZUBOVEUBPEUCPZQGUDGDUEUFAUGZDRVGSZBUGZVGCUGZERDRVIVGDRZVIVJD
      RERSZCGTZVIVJUHRVGDRVKVJVGDRZERSZVIVJUIRVGDRVIVNDRSZULZCQTZULZBQTZULZAGTH
      JWAAGVGGPZVHVTKWBVSBQWBVIQPZULZVMVRWDVLCGWBWCVJGPZVLWCWBWEVLLUJUKUMWDVQCQ
      WBWCVJQPZVQWCWFWBVQWCWFWBUNVOVPMNUOUPUKUMUOUMUOUQABCDEGEGVFEURPHEUSVDIUTV
      AVBVC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Examples of complex vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( The set of complex numbers is a complex vector space.  The vector
       operation is ` + ` , and the scalar product is ` x. ` .  (Contributed by
       NM, 5-Nov-2006.)  (New usage is discouraged.) $)
    cncvc $p |- <. + , x. >. e. CVecOLD $=
      ( vx vy vz cmul caddc cop cc cnaddablo cxp ax-addf fdmi ax-mulf cv mulid2
      adddi adddir mulass eqid isvci ) ABCDEEDFZGHGGIGEJKLAMZNBMZUACMZOUBUCUAPU
      BUCUAQTRS $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Normed complex vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c NrmCVec $.

  $c +v $.
  $c BaseSet $.
  $c .sOLD $.
  $c 0vec $.
  $c -v $.
  $c normCV $.

  $c IndMet $.

  $( Extend class notation with the class of all normed complex vector
     spaces. $)
  cnv $a class NrmCVec $.

  $( Extend class notation with vector addition in a normed complex vector
     space.  In the literature, the subscript "v" is omitted, but we need it to
     avoid ambiguity with complex number addition ` + ` ~ caddc . $)
  cpv $a class +v $.

  $( Extend class notation with the base set of a normed complex vector space.
     (Note that ` BaseSet ` is capitalized because, once it is fixed for a
     particular vector space ` U ` , it is not a function, unlike e.g.
     ` normCV ` .  This is our typical convention.)
     (New usage is discouraged.) $)
  cba $a class BaseSet $.

  $( Extend class notation with scalar multiplication in a normed complex
     vector space.  In the literature scalar multiplication is usually
     indicated by juxtaposition, but we need an explicit symbol to prevent
     ambiguity. $)
  cns $a class .sOLD $.

  $( Extend class notation with zero vector in a normed complex vector
     space. $)
  cn0v $a class 0vec $.

  $( Extend class notation with vector subtraction in a normed complex vector
     space. $)
  cnsb $a class -v $.

  $( Extend class notation with the norm function in a normed complex vector
     space.  In the literature, the norm of ` A ` is usually written "|| ` A `
     ||", but we use function notation to take advantage of our existing
     theorems about functions. $)
  cnmcv $a class normCV $.

  $( Extend class notation with the class of the induced metrics on normed
     complex vector spaces. $)
  cims $a class IndMet $.

  ${
    $d g s m n o t u w x y z $.  $d y G $.  $d y N $.  $d y S $.
    $( Define the class of all normed complex vector spaces.  (Contributed by
       NM, 11-Nov-2006.)  (New usage is discouraged.) $)
    df-nv $a |- NrmCVec = { <. <. g , s >. , n >. |
      ( <. g , s >. e. CVecOLD /\ n : ran g --> RR /\ A. x e. ran g
        ( ( ( n ` x ) = 0 -> x = ( GId ` g ) ) /\
          A. y e. CC ( n ` ( y s x ) ) = ( ( abs ` y ) x. ( n ` x ) ) /\
          A. y e. ran g ( n ` ( x g y ) ) <_ ( ( n ` x ) + ( n ` y ) ) ) ) } $.

    $( Structure of the class of all normed complex vectors spaces.
       (Contributed by NM, 28-Nov-2006.)  (Revised by Mario Carneiro,
       1-May-2015.)  (New usage is discouraged.) $)
    nvss $p |- NrmCVec C_ ( CVecOLD X. _V ) $=
      ( vw vg vs vn vx vy cv cop wceq cvc wcel cfv co wral w3a wa wex copab cvv
      cnv crn cr wf cc0 cgi wi cabs cmul cc caddc cle wbr cxp biimpar 3ad2antr1
      eleq1 exlimivv jctir ssopab2i coprab df-nv dfoprab2 eqtri df-xp 3sstr4i
      vex ) AGZBGZCGZHZIZVJJKZVHUAZUBDGZUCZEGZVNLZUDIVPVHUELIUFFGZVPVIMVNLVRUGL
      VQUHMIFUINVPVRVHMVNLVQVRVNLUJMUKULFVMNOEVMNZOZPZCQBQZADRZVGJKZVNSKZPZADRT
      JSUMWBWFADWBWDWEWAWDBCVKVOVLWDVSVKWDVLVGVJJUPUNUOUQDVFURUSTVTBCDUTWCEFBDC
      VAVTBCDAVBVCADJSVDVE $.

    $( A normed complex vector space is a vector space.  (Contributed by NM,
       5-Jun-2008.)  (Revised by Mario Carneiro, 1-May-2015.)
       (New usage is discouraged.) $)
    nvvcop $p |- ( <. W , N >. e. NrmCVec -> W e. CVecOLD ) $=
      ( cop cnv wcel cvc cvv cxp nvss sseli opelxp1 syl ) BACZDEMFGHZEBFEDNMIJB
      AFGKL $.

    $( Define vector addition on a normed complex vector space.  (Contributed
       by NM, 23-Apr-2007.)  (New usage is discouraged.) $)
    df-va $a |- +v = ( 1st o. 1st ) $.

    $( Define the base set of a normed complex vector space.  (Contributed by
       NM, 23-Apr-2007.)  (New usage is discouraged.) $)
    df-ba $a |- BaseSet = ( x e. _V |-> ran ( +v ` x ) ) $.

    $( Define scalar multiplication on a normed complex vector space.
       (Contributed by NM, 24-Apr-2007.)  (New usage is discouraged.) $)
    df-sm $a |- .sOLD = ( 2nd o. 1st ) $.

    $( Define the zero vector in a normed complex vector space.  (Contributed
       by NM, 24-Apr-2007.)  (New usage is discouraged.) $)
    df-0v $a |- 0vec = ( GId o. +v ) $.

    $( Define vector subtraction on a normed complex vector space.
       (Contributed by NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    df-vs $a |- -v = ( /g o. +v ) $.

    $( Define the norm function in a normed complex vector space.  (Contributed
       by NM, 25-Apr-2007.)  (New usage is discouraged.) $)
    df-nmcv $a |- normCV = 2nd $.

    $( Define the induced metric on a normed complex vector space.
       (Contributed by NM, 11-Sep-2007.)  (New usage is discouraged.) $)
    df-ims $a |- IndMet = ( u e. NrmCVec |->
                            ( ( normCV ` u ) o. ( -v ` u ) ) ) $.
  $}

  $( The class of all normed complex vectors spaces is a relation.
     (Contributed by NM, 14-Nov-2006.)  (New usage is discouraged.) $)
  nvrel $p |- Rel NrmCVec $=
    ( cnv cvc cvv cxp wss wrel nvss relxp relss mp2 ) ABCDZEKFAFGBCHAKIJ $.

  ${
    $d x y U $.
    vafval.2 $e |- G = ( +v ` U ) $.
    $( Value of the function for the vector addition (group) operation on a
       normed complex vector space.  (Contributed by NM, 23-Apr-2007.)
       (New usage is discouraged.) $)
    vafval $p |- G = ( 1st ` ( 1st ` U ) ) $=
      ( cpv cfv c1st cvv wcel wceq df-va fveq1i wf wfo fo1st fof ax-mp fvco3 c0
      ccom fvprc mpan syl5eq wn fveq2d 1st0 syl6req eqtrd pm2.61i eqtri ) BADEZ
      AFEZFEZCAGHZUJULIUMUJAFFSZEZULADUNJKGGFLZUMUOULIGGFMUPNGGFOPGGAFFQUAUBUMU
      CZUJRULADTUQULRFERUQUKRFAFTUDUEUFUGUHUI $.
  $}

  ${
    $d u U $.
    bafval.1 $e |- X = ( BaseSet ` U ) $.
    bafval.2 $e |- G = ( +v ` U ) $.
    $( Value of the function for the base set of a normed complex vector
       space.  (Contributed by NM, 23-Apr-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    bafval $p |- X = ran G $=
      ( vu cba cfv cpv crn cvv wcel wceq cv fveq2 rneqd df-ba fvex c0 fvprc rn0
      rnex fvmpt wn eqcomi 3eqtr4a pm2.61i rneqi 3eqtr4i ) AGHZAIHZJZCBJAKLZUJU
      LMFAFNZIHZJULKGUNAMUOUKUNAIOPFQUKAIRUBUCUMUDZSSJZUJULUQSUAUEAGTUPUKSAITPU
      FUGDBUKEUHUI $.
  $}

  ${
    $d u U $.
    smfval.4 $e |- S = ( .sOLD ` U ) $.
    $( Value of the function for the scalar multiplication operation on a
       normed complex vector space.  (Contributed by NM, 24-Apr-2007.)
       (New usage is discouraged.) $)
    smfval $p |- S = ( 2nd ` ( 1st ` U ) ) $=
      ( cns cfv c1st c2nd cvv wcel wceq ccom df-sm fveq1i wf wfo fo1st ax-mp c0
      fof fvprc fvco3 mpan syl5eq wn fveq2d 2nd0 syl6req eqtrd pm2.61i eqtri )
      ABDEZBFEZGEZCBHIZUKUMJUNUKBGFKZEZUMBDUOLMHHFNZUNUPUMJHHFOUQPHHFSQHHBGFUAU
      BUCUNUDZUKRUMBDTURUMRGERURULRGBFTUEUFUGUHUIUJ $.
  $}

  ${
    $d x y U $.  $d x y z w $.
    0vfval.2 $e |- G = ( +v ` U ) $.
    0vfval.5 $e |- Z = ( 0vec ` U ) $.
    $( Value of the function for the zero vector on a normed complex vector
       space.  (Contributed by NM, 24-Apr-2007.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    0vfval $p |- ( U e. V -> Z = ( GId ` G ) ) $=
      ( wcel cvv cgi cfv wceq elex cpv ccom wfn c1st crn wss wfo cn0v fo1st ssv
      fofn ax-mp fnco mp3an df-va fneq1i mpbir fvco2 df-0v fveq1i eqtri 3eqtr4g
      mpan fveq2i syl ) ACGAHGZDBIJZKACLURAIMNZJZAMJZIJZDUSMHOZURVAVCKVDPPNZHOZ
      PHOZVGPQZHRVFHHPSVGUAHHPUCUDZVIVHUBHHPPUEUFHMVEUGUHUIHIMAUJUODATJVAFATUTU
      KULUMBVBIEUPUNUQ $.
  $}

  ${
    $d x y U $.
    nmfval.6 $e |- N = ( normCV ` U ) $.
    $( Value of the norm function in a normed complex vector space.
       (Contributed by NM, 25-Apr-2007.)  (New usage is discouraged.) $)
    nmcvfval $p |- N = ( 2nd ` U ) $=
      ( cnmcv cfv c2nd df-nmcv fveq1i eqtri ) BADEAFECADFGHI $.
  $}

  ${
    nvop2.1 $e |- W = ( 1st ` U ) $.
    nvop2.6 $e |- N = ( normCV ` U ) $.
    $( A normed complex vector space is an ordered pair of a vector space and a
       norm operation.  (Contributed by NM, 28-Nov-2006.)
       (New usage is discouraged.) $)
    nvop2 $p |- ( U e. NrmCVec -> U = <. W , N >. ) $=
      ( cnv wcel c1st cfv c2nd cop wrel wceq nvrel 1st2nd mpan nmcvfval opeq12i
      syl6eqr ) AFGZAAHIZAJIZKZCBKFLTAUCMNAFOPCUABUBDABEQRS $.
  $}

  ${
    nvvop.1 $e |- W = ( 1st ` U ) $.
    nvvop.2 $e |- G = ( +v ` U ) $.
    nvvop.4 $e |- S = ( .sOLD ` U ) $.
    $( The vector space component of a normed complex vector space is an
       ordered pair of the underlying group and a scalar product.  (Contributed
       by NM, 28-Nov-2006.)  (New usage is discouraged.) $)
    nvvop $p |- ( U e. NrmCVec -> W = <. G , S >. ) $=
      ( cnv wcel c1st cfv c2nd cop cvc wrel wceq vcrel cvv fveq2i eqtr4i eleq1d
      cnmcv cxp nvss eqid nvop2 ibi sseldi opelxp1 1st2nd sylancr vafval smfval
      syl opeq12i syl6eqr ) BHIZDDJKZDLKZMZCAMUQNODNIZDUTPQUQDBUBKZMZNRUCZIVAUQ
      HVDVCUDUQVCHIUQBVCHBVBDEVBUEUFUAUGUHDVBNRUIUNDNUJUKCURAUSCBJKZJKURBCFULDV
      EJESTAVELKUSABGUMDVELESTUOUP $.
  $}

  ${
    $d g n s x y G $.  $d g n s x y N $.  $d g n s x y S $.  $d g n s x y X $.
    $d g n s Z $.
    isnvlem.1 $e |- X = ran G $.
    isnvlem.2 $e |- Z = ( GId ` G ) $.
    $( Lemma for ~ isnv .  (Contributed by NM, 11-Nov-2006.)
       (New usage is discouraged.) $)
    isnvlem $p |- ( ( G e. _V /\ S e. _V /\ N e. _V ) ->
                 ( <. <. G , S >. , N >. e. NrmCVec <-> ( <. G , S >. e.
        CVecOLD
        /\ N : X --> RR /\ A. x e. X ( ( ( N ` x ) = 0 -> x = Z )
           /\ A. y e. CC ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) /\
           A. y e. X ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) ) $=
      ( wcel cv cvc cr cfv wceq co cc wral w3a cvv vg vs vn cop cnv crn cc0 cgi
      wf wi cabs cmul caddc cle wbr coprab df-nv eleq2i opeq1 eleq1d rneq feq2d
      fveq2 eqeq2d imbi2d oveq fveq2d breq1d raleqbidv 3anbi13d 3anbi123d opeq2
      syl6eqr eqeq1d ralbidv 3anbi2d feq1 imbi1d oveq2d eqeq12d oveq12d breq12d
      fveq1 3anbi23d eloprabg syl5bb ) DCUDZEUDZUEJWHUAKZUBKZUDZLJZWIUFZMUCKZUI
      ZAKZWNNZUGOZWPWIUHNZOZUJZBKZWPWJPZWNNZXBUKNZWQULPZOZBQRZWPXBWIPZWNNZWQXBW
      NNZUMPZUNUOZBWMRZSZAWMRZSZUAUBUCUPZJDTJCTJETJSWGLJZFMEUIZWPENZUGOZWPGOZUJ
      ZXBWPCPZENZXEYAULPZOZBQRZWPXBDPZENZYAXBENZUMPZUNUOZBFRZSZAFRZSZUEXRWHABUA
      UCUBUQURXQDWJUDZLJZFMWNUIZWRYCUJZXHYJWNNZXLUNUOZBFRZSZAFRZSXSUUAUUBYEWNNZ
      XFOZBQRZUUESZAFRZSYRUAUBUCDCETTTWIDOZWLYTWOUUAXPUUGUUMWKYSLWIDWJUSUTUUMWM
      FMWNUUMWMDUFFWIDVAHVMZVBUUMXOUUFAWMFUUNUUMXAUUBXNUUEXHUUMWTYCWRUUMWSGWPUU
      MWSDUHNGWIDUHVCIVMVDVEUUMXMUUDBWMFUUNUUMXJUUCXLUNUUMXIYJWNWPXBWIDVFVGVHVI
      VJVIVKWJCOZYTXSUUGUULUUAUUOYSWGLWJCDVLUTUUOUUFUUKAFUUOXHUUJUUBUUEUUOXGUUI
      BQUUOXDUUHXFUUOXCYEWNXBWPWJCVFVGVNVOVPVOVJWNEOZUUAXTUULYQXSFMWNEVQUUPUUKY
      PAFUUPUUBYDUUJYIUUEYOUUPWRYBYCUUPWQYAUGWPWNEWCZVNVRUUPUUIYHBQUUPUUHYFXFYG
      YEWNEWCUUPWQYAXEULUUQVSVTVOUUPUUDYNBFUUPUUCYKXLYMUNYJWNEWCUUPWQYAXKYLUMUU
      QXBWNEWCWAWBVOVKVOWDWEWF $.
  $}

  ${
    $d x y G $.  $d x y S $.
    $( The components of a normed complex vector space are sets.  (Contributed
       by NM, 5-Jun-2008.)  (Revised by Mario Carneiro, 1-May-2015.)
       (New usage is discouraged.) $)
    nvex $p |- ( <. <. G , S >. , N >. e. NrmCVec
            -> ( G e. _V /\ S e. _V /\ N e. _V ) ) $=
      ( cop cnv wcel cvv wa w3a cvc nvvcop vcex syl nvss sseli opelxp2 sylanbrc
      cxp df-3an ) BADZCDZEFZBGFZAGFZHZCGFZUCUDUFIUBTJFUECTKABLMUBUAJGRZFUFEUGU
      ANOTCJGPMUCUDUFSQ $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    isnv.1 $e |- X = ran G $.
    isnv.2 $e |- Z = ( GId ` G ) $.
    $( The predicate "is a normed complex vector space."  (Contributed by NM,
       5-Jun-2008.)  (New usage is discouraged.) $)
    isnv $p |- ( <. <. G , S >. , N >. e. NrmCVec <-> ( <. G , S >. e. CVecOLD
        /\ N : X --> RR /\ A. x e. X ( ( ( N ` x ) = 0 -> x = Z )
           /\ A. y e. CC ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) /\
           A. y e. X ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) $=
      ( cop wcel cvv w3a cr cv cfv wceq co wral wa cnv cvc wf cc0 wi cabs caddc
      cmul cc cle wbr nvex vcex adantr crn simpld rnexg syl syl5eqel fex sylan2
      ancoms df-3an sylanbrc 3adant3 isnvlem pm5.21nii ) DCJZEJUAKDLKZCLKZELKZM
      ZVHUBKZFNEUCZAOZEPZUDQVOGQUEBOZVOCREPVQUFPVPUHRQBUISVOVQDREPVPVQEPUGRUJUK
      BFSMAFSZMCDEULVMVNVLVRVMVNTVIVJTZVKVLVMVSVNCDUMZUNVNVMVKVMVNFLKVKVMFDUOZL
      HVMVIWALKVMVIVJVTUPDLUQURUSFNLEUTVAVBVIVJVKVCVDVEABCDEFGHIVFVG $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    isnvi.5 $e |- X = ran G $.
    isnvi.6 $e |- Z = ( GId ` G ) $.
    isnvi.7 $e |- <. G , S >. e. CVecOLD $.
    isnvi.8 $e |- N : X --> RR $.
    isnvi.9 $e |- ( ( x e. X /\ ( N ` x ) = 0 ) -> x = Z ) $.
    isnvi.10 $e |- ( ( y e. CC /\ x e. X ) ->
                    ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) ) $.
    isnvi.11 $e |- ( ( x e. X /\ y e. X ) ->
                    ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) $.
    isnvi.12 $e |- U = <. <. G , S >. , N >. $.
    $( Properties that determine a normed complex vector space.  (Contributed
       by NM, 15-Apr-2007.)  (New usage is discouraged.) $)
    isnvi $p |- U e. NrmCVec $=
      ( wcel cfv wceq co cop cnv cvc cr wf cv cc0 wi cabs cmul cc caddc cle wbr
      wral w3a ex ancoms ralrimiva 3jca rgen isnv mpbir3an eqeltri ) DECUAZFUAZ
      UBPVFUBQVEUCQGUDFUEAUFZFRZUGSZVGHSZUHZBUFZVGCTFRVLUIRVHUJTSZBUKUOZVGVLETF
      RVHVLFRULTUMUNZBGUOZUPZAGUOKLVQAGVGGQZVKVNVPVRVIVJMUQVRVMBUKVLUKQVRVMNURU
      SVRVOBGOUSUTVAABCEFGHIJVBVCVD $.
  $}

  ${
    $d x y G $.  $d x y N $.  $d x U $.  $d x y S $.  $d x y X $.
    nvi.1 $e |- X = ( BaseSet ` U ) $.
    nvi.2 $e |- G = ( +v ` U ) $.
    nvi.4 $e |- S = ( .sOLD ` U ) $.
    nvi.5 $e |- Z = ( 0vec ` U ) $.
    nvi.6 $e |- N = ( normCV ` U ) $.
    $( The properties of a normed complex vector space, which is a vector space
       accompanied by a norm.  (Contributed by NM, 11-Nov-2006.)  (Revised by
       Mario Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    nvi $p |- ( U e. NrmCVec -> ( <. G , S >. e. CVecOLD /\ N : X --> RR /\
       A. x e. X ( ( ( N ` x ) = 0 -> x = Z )
           /\ A. y e. CC ( N ` ( y S x ) ) = ( ( abs ` y ) x. ( N ` x ) ) /\
              A. y e. X ( N ` ( x G y ) ) <_ ( ( N ` x ) + ( N ` y ) ) ) ) ) $=
      ( cnv wcel cfv wceq co wral w3a cop cvc cr wf cv cc0 wi cabs cc caddc cle
      cmul wbr c1st eqid nvop2 nvvop opeq1d eqtrd id eqeltrrd bafval isnv sylib
      cgi 0vfval eqeq2d imbi2d 3anbi1d ralbidv 3anbi3d mpbird ) DNOZECUAZUBOZGU
      CFUDZAUEZFPZUFQZVQHQZUGZBUEZVQCRFPWBUHPVRULRQBUISZVQWBERFPVRWBFPUJRUKUMBG
      SZTZAGSZTVOVPVSVQEVEPZQZUGZWCWDTZAGSZTZVMVNFUAZNOWLVMDWMNVMDDUNPZFUAWMDFW
      NWNUOZMUPVMWNVNFCDEWNWOJKUQURUSVMUTVAABCEFGWGDEGIJVBWGUOVCVDVMWFWKVOVPVMW
      EWJAGVMWAWIWCWDVMVTWHVSVMHWGVQDENHJLVFVGVHVIVJVKVL $.
  $}

  ${
    $d x y U $.  $d x y W $.
    nvvc.1 $e |- W = ( 1st ` U ) $.
    $( The vector space component of a normed complex vector space.
       (Contributed by NM, 28-Nov-2006.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    nvvc $p |- ( U e. NrmCVec -> W e. CVecOLD ) $=
      ( vx vy cnv wcel cpv cfv cns cop cvc eqid nvvop cba cr cv wceq co wral wf
      cnmcv cc0 cn0v wi cabs cmul cc caddc cle wbr w3a nvi simp1d eqeltrd ) AFG
      ZBAHIZAJIZKZLURAUQBCUQMZURMZNUPUSLGAOIZPAUBIZUADQZVCIZUCRVDAUDIZRUEEQZVDU
      RSVCIVGUFIVEUGSREUHTVDVGUQSVCIVEVGVCIUISUJUKEVBTULDVBTDEURAUQVCVBVFVBMUTV
      AVFMVCMUMUNUO $.
  $}

  ${
    nvabl.1 $e |- G = ( +v ` U ) $.
    $( The vector addition operation of a normed complex vector space is an
       Abelian group.  (Contributed by NM, 15-Feb-2008.)
       (New usage is discouraged.) $)
    nvablo $p |- ( U e. NrmCVec -> G e. AbelOp ) $=
      ( cnv wcel c1st cfv cvc cablo eqid nvvc vafval vcablo syl ) ADEAFGZHEBIEA
      OOJKBOABCLMN $.

    $( The vector addition operation of a normed complex vector space is a
       group.  (Contributed by NM, 15-Feb-2008.)
       (New usage is discouraged.) $)
    nvgrp $p |- ( U e. NrmCVec -> G e. GrpOp ) $=
      ( cnv wcel cablo cgr nvablo ablogrpo syl ) ADEBFEBGEABCHBIJ $.
  $}

  ${
    nvgf.1 $e |- X = ( BaseSet ` U ) $.
    nvgf.2 $e |- G = ( +v ` U ) $.
    $( Mapping for the vector addition operation.  (Contributed by NM,
       28-Jan-2008.)  (New usage is discouraged.) $)
    nvgf $p |- ( U e. NrmCVec -> G : ( X X. X ) --> X ) $=
      ( cnv wcel cgr cxp wfo wf nvgrp bafval grpofo fof 3syl ) AFGBHGCCIZCBJQCB
      KABELBCABCDEMNQCBOP $.
  $}

  ${
    nvsf.1 $e |- X = ( BaseSet ` U ) $.
    nvsf.4 $e |- S = ( .sOLD ` U ) $.
    $( Mapping for the scalar multiplication operation.  (Contributed by NM,
       28-Jan-2008.)  (New usage is discouraged.) $)
    nvsf $p |- ( U e. NrmCVec -> S : ( CC X. X ) --> X ) $=
      ( cnv wcel c1st cfv cvc cc cxp wf eqid nvvc cpv vafval smfval bafval vcsm
      syl ) BFGBHIZJGKCLCAMBUBUBNOABPIZUBCBUCUCNZQABERBUCCDUDSTUA $.
  $}

  ${
    nvgcl.1 $e |- X = ( BaseSet ` U ) $.
    nvgcl.2 $e |- G = ( +v ` U ) $.
    $( Closure law for the vector addition (group) operation of a normed
       complex vector space.  (Contributed by NM, 23-Apr-2007.)
       (New usage is discouraged.) $)
    nvgcl $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                    ( A G B ) e. X ) $=
      ( cnv wcel cgr co nvgrp bafval grpocl syl3an1 ) CHIDJIAEIBEIABDKEICDGLABD
      ECDEFGMNO $.

    $( The vector addition (group) operation is commutative.  (Contributed by
       NM, 4-Dec-2007.)  (New usage is discouraged.) $)
    nvcom $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A G B ) = ( B G A ) ) $=
      ( cnv wcel cablo co wceq nvablo bafval ablocom syl3an1 ) CHIDJIAEIBEIABDK
      BADKLCDGMABDECDEFGNOP $.

    $( The vector addition (group) operation is associative.  (Contributed by
       NM, 4-Dec-2007.)  (New usage is discouraged.) $)
    nvass $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
              ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      ( cnv wcel cgr w3a co wceq nvgrp bafval grpoass sylan ) DIJEKJAFJBFJCFJLA
      BEMCEMABCEMEMNDEHOABCEFDEFGHPQR $.

    $( Commutative/associative law for vector addition.  (Contributed by NM,
       14-Dec-2007.)  (New usage is discouraged.) $)
    nvadd12 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( A G ( B G C ) ) = ( B G ( A G C ) ) ) $=
      ( cnv wcel w3a wa co wceq nvcom 3adant3r3 oveq1d nvass 3ancoma sylan2b
      3eqtr3d ) DIJZAFJZBFJZCFJZKZLZABEMZCEMBAEMZCEMZABCEMEMBACEMEMZUGUHUICEUBU
      CUDUHUINUEABDEFGHOPQABCDEFGHRUFUBUDUCUEKUJUKNUCUDUESBACDEFGHRTUA $.

    $( Commutative/associative law for vector addition.  (Contributed by NM,
       27-Dec-2007.)  (New usage is discouraged.) $)
    nvadd32 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A G B ) G C ) = ( ( A G C ) G B ) ) $=
      ( cnv wcel cablo w3a co wceq nvablo bafval ablo32 sylan ) DIJEKJAFJBFJCFJ
      LABEMCEMACEMBEMNDEHOABCEFDEFGHPQR $.

    $( Right cancellation law for vector addition.  (Contributed by NM,
       4-Dec-2007.)  (New usage is discouraged.) $)
    nvrcan $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G C ) = ( B G C ) <-> A = B ) ) $=
      ( cnv wcel cgr w3a co wceq wb nvgrp bafval grporcan sylan ) DIJEKJAFJBFJC
      FJLACEMBCEMNABNODEHPABCEFDEFGHQRS $.

    $( Left cancellation law for vector addition.  (Contributed by NM,
       14-Dec-2007.)  (New usage is discouraged.) $)
    nvlcan $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C G A ) = ( C G B ) <-> A = B ) ) $=
      ( cnv wcel cgr w3a co wceq wb nvgrp bafval grpolcan sylan ) DIJEKJAFJBFJC
      FJLCAEMCBEMNABNODEHPABCEFDEFGHQRS $.

    $( Rearrangement of 4 terms in a vector sum.  (Contributed by NM,
       8-Feb-2008.)  (New usage is discouraged.) $)
    nvadd4 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X ) /\ ( C e. X /\
       D e. X ) ) -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) $=
      ( cnv wcel cablo wa co wceq nvablo bafval ablo4 syl3an1 ) EJKFLKAGKBGKMCG
      KDGKMABFNCDFNFNACFNBDFNFNOEFIPABCDFGEFGHIQRS $.
  $}

  ${
    nvscl.1 $e |- X = ( BaseSet ` U ) $.
    nvscl.4 $e |- S = ( .sOLD ` U ) $.
    $( Closure law for the scalar product operation of a normed complex vector
       space.  (Contributed by NM, 1-Feb-2007.)  (New usage is discouraged.) $)
    nvscl $p |- ( ( U e. NrmCVec /\ A e. CC /\ B e. X ) ->
                       ( A S B ) e. X ) $=
      ( cnv wcel c1st cfv cvc cc co eqid nvvc cpv vafval smfval bafval syl3an1
      vccl ) DHIDJKZLIAMIBEIABCNEIDUCUCOPABCDQKZUCEDUDUDOZRCDGSDUDEFUETUBUA $.

    $( Identity element for the scalar product of a normed complex vector
       space.  (Contributed by NM, 4-Dec-2007.)  (New usage is discouraged.) $)
    nvsid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( 1 S A ) = A ) $=
      ( cnv wcel c1st cfv cvc c1 co wceq eqid nvvc cpv vafval smfval bafval
      vcid sylan ) CGHCIJZKHADHLABMANCUCUCOPABCQJZUCDCUDUDOZRBCFSCUDDEUETUAUB
      $.

    $( Associative law for the scalar product of a normed complex vector
       space.  (Contributed by NM, 17-Nov-2007.)
       (New usage is discouraged.) $)
    nvsass $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A x. B ) S C ) = ( A S ( B S C ) ) ) $=
      ( cnv wcel c1st cfv cvc cc w3a cmul co wceq eqid nvvc vafval smfval vcass
      cpv bafval sylan ) EIJEKLZMJANJBNJCFJOABPQCDQABCDQDQREUGUGSTABCDEUDLZUGFE
      UHUHSZUADEHUBEUHFGUIUEUCUF $.

    $( Commutative law for the scalar product of a normed complex vector
       space.  (Contributed by NM, 14-Feb-2008.)
       (New usage is discouraged.) $)
    nvscom $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( A S ( B S C ) ) = ( B S ( A S C ) ) ) $=
      ( cnv wcel cc w3a wa cmul co wceq mulcom oveq1d 3adant3 nvsass 3ancoma
      adantl sylan2b 3eqtr3d ) EIJZAKJZBKJZCFJZLZMABNOZCDOZBANOZCDOZABCDODOBACD
      ODOZUIUKUMPZUEUFUGUOUHUFUGMUJULCDABQRSUBABCDEFGHTUIUEUGUFUHLUMUNPUFUGUHUA
      BACDEFGHTUCUD $.
  $}

  ${
    nvdi.1 $e |- X = ( BaseSet ` U ) $.
    nvdi.2 $e |- G = ( +v ` U ) $.
    nvdi.4 $e |- S = ( .sOLD ` U ) $.
    $( Distributive law for the scalar product of a complex vector space.
       (Contributed by NM, 4-Dec-2007.)  (New usage is discouraged.) $)
    nvdi $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
       ( A S ( B G C ) ) = ( ( A S B ) G ( A S C ) ) ) $=
      ( cnv wcel c1st cfv cvc cc w3a co wceq eqid nvvc vafval smfval vcdi sylan
      bafval ) EKLEMNZOLAPLBGLCGLQABCFRDRABDRACDRFRSEUGUGTUAABCDFUGGEFIUBDEJUCE
      FGHIUFUDUE $.

    $( Distributive law for the scalar product of a complex vector space.
       (Contributed by NM, 4-Dec-2007.)  (New usage is discouraged.) $)
    nvdir $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
      ( ( A + B ) S C ) = ( ( A S C ) G ( B S C ) ) ) $=
      ( cnv wcel c1st cfv cvc cc w3a caddc co wceq eqid nvvc vafval vcdir sylan
      smfval bafval ) EKLEMNZOLAPLBPLCGLQABRSCDSACDSBCDSFSTEUHUHUAUBABCDFUHGEFI
      UCDEJUFEFGHIUGUDUE $.

    $( A vector plus itself is two times the vector.  (Contributed by NM,
       9-Feb-2008.)  (New usage is discouraged.) $)
    nv2 $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A G A ) = ( 2 S A ) ) $=
      ( cnv wcel c1st cfv cvc co c2 wceq eqid nvvc vafval smfval bafval sylan
      vc2 ) CIJCKLZMJAEJAADNOABNPCUDUDQRABDUDECDGSBCHTCDEFGUAUCUB $.
  $}

  ${
    $d f g x y z $.
    vsfval.2 $e |- G = ( +v ` U ) $.
    vsfval.3 $e |- M = ( -v ` U ) $.
    $( Value of the function for the vector subtraction operation on a normed
       complex vector space.  (Contributed by NM, 15-Feb-2008.)  (Revised by
       Mario Carneiro, 27-Dec-2014.)  (New usage is discouraged.) $)
    vsfval $p |- M = ( /g ` G ) $=
      ( vg vx vy cnsb cfv cpv cgs cvv wcel wceq wf c1st c0 cgr cv df-vs wfo fof
      ccom fveq1i fo1st ax-mp fco mp2an df-va feq1i mpbir fvco3 mpan syl5eq cdm
      wn 0ngrp crn cgn co cmpt2 vex rnex mpt2ex df-gdiv dmmpti mtbir ndmfv mp1i
      eleq2i fvprc fveq2d 3eqtr4rd pm2.61i fveq2i 3eqtr4i ) AIJZAKJZLJZCBLJAMNZ
      VRVTOWAVRALKUDZJZVTAIWBUAUEMMKPZWAWCVTOWDMMQQUDZPZMMQPZWGWFMMQUBWGUFMMQUC
      UGZWHMMMQQUHUIMMKWEUJUKULMMALKUMUNUOWAUQZRLJZRVTVRRLUPZNZUQWJROWIWLRSNURW
      KSRFSGHFTZUSZWNGTHTWMUTJJWMVAZVBLGHWNWNWOWMFVCVDZWPVEGHFVFVGVKVHRLVIVJWIV
      SRLAKVLVMAIVLVNVOEBVSLDVPVQ $.
  $}

  ${
    nvzcl.1 $e |- X = ( BaseSet ` U ) $.
    nvzcl.6 $e |- Z = ( 0vec ` U ) $.
    $( Closure law for the zero vector of a normed complex vector space.
       (Contributed by NM, 27-Nov-2007.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    nvzcl $p |- ( U e. NrmCVec -> Z e. X ) $=
      ( cnv wcel cpv cfv cgi eqid 0vfval cgr nvgrp bafval grpoidcl syl eqeltrd
      ) AFGZCAHIZJIZBATFCTKZELSTMGUABGATUBNUATBATBDUBOUAKPQR $.
  $}

  ${
    nv0id.1 $e |- X = ( BaseSet ` U ) $.
    nv0id.2 $e |- G = ( +v ` U ) $.
    nv0id.6 $e |- Z = ( 0vec ` U ) $.
    $( The zero vector is a right identity element.  (Contributed by NM,
       28-Nov-2007.)  (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    nv0rid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A G Z ) = A ) $=
      ( cnv wcel wa co cgi cfv wceq 0vfval oveq2d adantr cgr nvgrp eqid grporid
      bafval sylan eqtrd ) BIJZADJZKAECLZACMNZCLZAUFUHUJOUGUFEUIACBCIEGHPQRUFCS
      JUGUJAOBCGTAUICDBCDFGUCUIUAUBUDUE $.

    $( The zero vector is a left identity element.  (Contributed by NM,
       28-Nov-2007.)  (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    nv0lid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( Z G A ) = A ) $=
      ( cnv wcel wa co cgi cfv wceq 0vfval oveq1d adantr cgr nvgrp eqid grpolid
      bafval sylan eqtrd ) BIJZADJZKEACLZCMNZACLZAUFUHUJOUGUFEUIACBCIEGHPQRUFCS
      JUGUJAOBCGTAUICDBCDFGUCUIUAUBUDUE $.
  $}

  ${
    nv0.1 $e |- X = ( BaseSet ` U ) $.
    nv0.4 $e |- S = ( .sOLD ` U ) $.
    nv0.6 $e |- Z = ( 0vec ` U ) $.
    $( Zero times a vector is the zero vector.  (Contributed by NM,
       27-Nov-2007.)  (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    nv0 $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( 0 S A ) = Z ) $=
      ( cnv wcel wa cc0 co cpv cfv cgi c1st cvc wceq eqid nvvc vafval vc0 sylan
      smfval bafval 0vfval adantr eqtr4d ) CIJZADJZKLABMZCNOZPOZEUJCQOZRJUKULUN
      SCUOUOTUAABUMUODUNCUMUMTZUBBCGUECUMDFUPUFUNTUCUDUJEUNSUKCUMIEUPHUGUHUI $.
  $}

  ${
    nvsz.4 $e |- S = ( .sOLD ` U ) $.
    nvsz.6 $e |- Z = ( 0vec ` U ) $.
    $( Anything times the zero vector is the zero vector.  (Contributed by NM,
       28-Nov-2007.)  (Revised by Mario Carneiro, 21-Dec-2013.)
       (New usage is discouraged.) $)
    nvsz $p |- ( ( U e. NrmCVec /\ A e. CC ) -> ( A S Z ) = Z ) $=
      ( cnv wcel cc wa cpv cfv cgi co c1st cvc wceq eqid nvvc cba vafval smfval
      bafval vcz sylan 0vfval adantr oveq2d 3eqtr4d ) CGHZAIHZJZACKLZMLZBNZUNAD
      BNDUJCOLZPHUKUOUNQCUPUPRSABUMUPCTLZUNCUMUMRZUABCEUBCUMUQUQRURUCUNRUDUEULD
      UNABUJDUNQUKCUMGDURFUFUGZUHUSUI $.
  $}

  ${
    nvinv.1 $e |- X = ( BaseSet ` U ) $.
    nvinv.2 $e |- G = ( +v ` U ) $.
    nvinv.4 $e |- S = ( .sOLD ` U ) $.
    nvinv.5 $e |- M = ( inv ` G ) $.
    $( Minus 1 times a vector is the underlying group's inverse element.
       Equation 2 of [Kreyszig] p. 51.  (Contributed by NM, 15-Feb-2008.)
       (New usage is discouraged.) $)
    nvinv $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( -u 1 S A ) = ( M ` A ) ) $=
      ( cnv wcel c1st cfv cvc c1 cneg co wceq eqid nvvc vafval smfval vcm sylan
      bafval ) CKLCMNZOLAFLPQABRAENSCUGUGTUAABDEUGFCDHUBBCIUCCDFGHUFJUDUE $.
  $}

  ${
    $d x G $.  $d x N $.  $d x U $.
    nvinvfval.2 $e |- G = ( +v ` U ) $.
    nvinvfval.4 $e |- S = ( .sOLD ` U ) $.
    nvinvfval.3 $e |- N = ( S o. `' ( 2nd |` ( { -u 1 } X. _V ) ) ) $.
    $( Function for the negative of a vector on a normed complex vector space,
       in terms of the underlying addition group inverse.  (We currently do not
       have a separate notation for the negative of a vector.)  (Contributed by
       NM, 27-Mar-2008.)  (New usage is discouraged.) $)
    nvinvfval $p |- ( U e. NrmCVec -> N = ( inv ` G ) ) $=
      ( vx cnv wcel cba cfv wf wfn cc eqid neg1cn sylancl ffn syl cgn cneg nvsf
      cxp c1 curry1f wf1o nvgrp bafval grpoinvf f1ofn 3syl cv wa co wceq adantr
      cgr curry1val nvinv eqtrd eqfnfvd ) BIJZHBKLZDCUALZVCVDVDDMZDVDNVCOVDUDZV
      DAMZUEUBZOJZVFABVDVDPZFUCZQOVDVIVDADGUFRVDVDDSTVCCURJVDVDVEUGVEVDNBCEUHCV
      EVDBCVDVKEUIVEPZUJVDVDVEUKULVCHUMZVDJZUNZVNDLZVIVNAUOZVNVELVPAVGNZVJVQVRU
      PVCVSVOVCVHVSVLVGVDASTUQQOVDVIVNADGUSRVNABCVEVDVKEFVMUTVAVB $.
  $}

  ${
    nvm.1 $e |- X = ( BaseSet ` U ) $.
    nvm.2 $e |- G = ( +v ` U ) $.
    nvm.3 $e |- M = ( -v ` U ) $.
    nvm.6 $e |- N = ( /g ` G ) $.
    $( Vector subtraction in terms of group division operation.  (Contributed
       by NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    nvm $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( A M B ) = ( A N B ) ) $=
      ( co wceq cnv wcel w3a cgs cfv vsfval eqtr4i oveqi a1i ) ABELABFLMCNOAGOB
      GOPEFABEDQRFCDEIJSKTUAUB $.
  $}

  ${
    $d x y G $.  $d x y U $.  $d x y X $.
    nvmval.1 $e |- X = ( BaseSet ` U ) $.
    nvmval.2 $e |- G = ( +v ` U ) $.
    nvmval.4 $e |- S = ( .sOLD ` U ) $.
    nvmval.3 $e |- M = ( -v ` U ) $.
    $( Value of vector subtraction on a normed complex vector space.
       (Contributed by NM, 11-Sep-2007.)  (New usage is discouraged.) $)
    nvmval $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A M B ) = ( A G ( -u 1 S B ) ) ) $=
      ( cnv wcel w3a cgs cfv co cgn wceq eqid cneg cgr nvgrp grpodivval syl3an1
      c1 bafval nvm nvinv 3adant2 oveq2d 3eqtr4d ) DLMZAGMZBGMZNZABEOPZQZABERPZ
      PZEQZABFQAUFUABCQZEQUMEUBMUNUOURVASDEIUCABUQEUSGDEGHIUGUSTZUQTZUDUEABDEFU
      QGHIKVDUHUPVBUTAEUMUOVBUTSUNBCDEUSGHIJVCUIUJUKUL $.

    $( Value of vector subtraction on a normed complex vector space.
       (Contributed by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    nvmval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A M B ) = ( ( -u 1 S B ) G A ) ) $=
      ( cnv wcel w3a co c1 cneg nvmval wceq cc neg1cn nvscl 3adant2 nvcom eqtrd
      mp3an2 syld3an3 ) DLMZAGMZBGMZNABFOAPQZBCOZEOZULAEOZABCDEFGHIJKRUHUIUJULG
      MZUMUNSUHUJUOUIUHUKTMUJUOUAUKBCDGHJUBUFUCAULDEGHIUDUGUE $.

    $( Value of the function for the vector subtraction operation on a normed
       complex vector space.  (Contributed by NM, 11-Sep-2007.)  (Revised by
       Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    nvmfval $p |- ( U e. NrmCVec -> M = ( x e. X , y e. X |->
                    ( x G ( -u 1 S y ) ) ) ) $=
      ( cnv wcel cv cgn cfv co cmpt2 c1 wceq cneg nvgrp bafval eqid grpodivfval
      cgr vsfval syl w3a nvinv 3adant2 oveq2d mpt2eq3dva eqtr4d ) DLMZFABGGANZB
      NZEOPZPZEQZRZABGGUPSUAUQCQZEQZRUOEUFMFVATDEIUBABFEURGDEGHIUCURUDZDEFIKUGU
      EUHUOABGGVCUTUOUPGMZUQGMZUIVBUSUPEUOVFVBUSTVEUQCDEURGHIJVDUJUKULUMUN $.
  $}

  ${
    nvzs.1 $e |- X = ( BaseSet ` U ) $.
    nvzs.3 $e |- M = ( -v ` U ) $.
    nvzs.4 $e |- S = ( .sOLD ` U ) $.
    nvzs.6 $e |- Z = ( 0vec ` U ) $.
    $( Two ways to express the negative of a vector.  (Contributed by NM,
       29-Feb-2008.)  (New usage is discouraged.) $)
    nvzs $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( Z M A ) = ( -u 1 S A ) ) $=
      ( cnv wcel wa co c1 cneg cpv cfv wceq simpl nvzcl adantr simpr syl3anc cc
      eqid nvmval neg1cn nvscl mp3an2 nv0lid syldan eqtrd ) CKLZAELZMZFADNZFOPZ
      ABNZCQRZNZUSUPUNFELZUOUQVASUNUOTUNVBUOCEFGJUAUBUNUOUCFABCUTDEGUTUFZIHUGUD
      UNUOUSELZVAUSSUNURUELUOVDUHURABCEGIUIUJUSCUTEFGVCJUKULUM $.
  $}

  ${
    $d x y U $.  $d x y X $.
    nvmf.1 $e |- X = ( BaseSet ` U ) $.
    nvmf.3 $e |- M = ( -v ` U ) $.
    $( Mapping for the vector subtraction operation.  (Contributed by NM,
       11-Sep-2007.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    nvmf $p |- ( U e. NrmCVec -> M : ( X X. X ) --> X ) $=
      ( vx vy cnv wcel cxp wf cv c1 cneg cns cfv co wral wa eqid cmpt2 simpl cc
      simprl neg1cn nvscl mp3an2 adantrl nvgcl syl3anc ralrimivva fmpt2 nvmfval
      cpv sylib feq1d mpbird ) AHIZCCJZCBKUSCFGCCFLZMNZGLZAOPZQZAUNPZQZUAZKZURV
      FCIZGCRFCRVHURVIFGCCURUTCIZVBCIZSZSURVJVDCIZVIURVLUBURVJVKUDURVKVMVJURVAU
      CIVKVMUEVAVBVCACDVCTZUFUGUHUTVDAVECDVETZUIUJUKFGCCVFCVGVGTULUOURUSCBVGFGV
      CAVEBCDVOVNEUMUPUQ $.

    $( Closure law for the vector subtraction operation of a normed complex
       vector space.  (Contributed by NM, 11-Sep-2007.)
       (New usage is discouraged.) $)
    nvmcl $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A M B ) e. X ) $=
      ( cnv wcel cxp wf co nvmf fovrn syl3an1 ) CHIEEJEDKAEIBEIABDLEICDEFGMABEE
      EDNO $.

    $( Cancellation law for vector subtraction.  ( ~ nnncan1 analog.)
       (Contributed by NM, 7-Mar-2008.)  (New usage is discouraged.) $)
    nvnnncan1 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A M B ) M ( A M C ) ) = ( C M B ) ) $=
      ( cnv wcel cpv cfv cablo w3a co wceq eqid nvablo bafval vsfval sylan
      ablonnncan1 ) DIJDKLZMJAFJBFJCFJNABEOACEOEOCBEOPDUCUCQZRABCEUCFDUCFGUDSDU
      CEUDHTUBUA $.

    $( Cancellation law for vector subtraction.  ( ~ nnncan2 analog.)
       (Contributed by NM, 15-Feb-2008.)  (New usage is discouraged.) $)
    nvnnncan2 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
         ( ( A M C ) M ( B M C ) ) = ( A M B ) ) $=
      ( cnv wcel cpv cfv cgr w3a co wceq eqid nvgrp bafval vsfval grponnncan2
      sylan ) DIJDKLZMJAFJBFJCFJNACEOBCEOEOABEOPDUCUCQZRABCEUCFDUCFGUDSDUCEUDHT
      UAUB $.
  $}

  ${
    nvmdi.1 $e |- X = ( BaseSet ` U ) $.
    nvmdi.3 $e |- M = ( -v ` U ) $.
    nvmdi.4 $e |- S = ( .sOLD ` U ) $.
    $( Distributive law for scalar product over subtraction.  (Contributed by
       NM, 14-Feb-2008.)  (New usage is discouraged.) $)
    nvmdi $p |- ( ( U e. NrmCVec /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
       ( A S ( B M C ) ) = ( ( A S B ) M ( A S C ) ) ) $=
      ( cnv wcel cc w3a co wceq neg1cn nvscl oveq2d nvmval wa c1 cpv cfv simpr1
      cneg simpr2 mp3an2 3ad2antr3 3jca eqid nvdi syldan mp3anr2 3adantr2 eqtrd
      nvscom 3adant3r1 simpl 3adant3r3 3adant3r2 syl3anc 3eqtr4d ) EKLZAMLZBGLZ
      CGLZNZUAZABUBUFZCDOZEUCUDZOZDOZABDOZVJACDOZDOZVLOZABCFOZDOVOVPFOZVIVNVOAV
      KDOZVLOZVRVDVHVEVFVKGLZNVNWBPVIVEVFWCVDVEVFVGUEVDVEVFVGUGVDVEVGWCVFVDVJML
      ZVGWCQVJCDEGHJRUHUIUJABVKDEVLGHVLUKZJULUMVIWAVQVOVLVDVEVGWAVQPZVFVDVEWDVG
      WFQAVJCDEGHJUQUNUOSUPVIVSVMADVDVFVGVSVMPVEBCDEVLFGHWEJITURSVIVDVOGLZVPGLZ
      VTVRPVDVHUSVDVEVFWGVGABDEGHJRUTVDVEVGWHVFACDEGHJRVAVOVPDEVLFGHWEJITVBVC
      $.
  $}

  ${
    nvnegneg.1 $e |- X = ( BaseSet ` U ) $.
    nvnegneg.4 $e |- S = ( .sOLD ` U ) $.
    $( Double negative of a vector.  (Contributed by NM, 4-Dec-2007.)
       (New usage is discouraged.) $)
    nvnegneg $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                  ( -u 1 S ( -u 1 S A ) ) = A ) $=
      ( cnv wcel wa c1 cneg co cpv cfv cgn wceq cc neg1cn eqid nvinv mp3an2 cgr
      nvscl syldan fveq2d nvgrp bafval grpo2inv sylan 3eqtrd ) CGHZADHZIZJKZUNA
      BLZBLZUOCMNZONZNZAURNZURNZAUKULUODHZUPUSPUKUNQHULVBRUNABCDEFUCUAUOBCUQURD
      EUQSZFURSZTUDUMUOUTURABCUQURDEVCFVDTUEUKUQUBHULVAAPCUQVCUFAUQURDCUQDEVCUG
      VDUHUIUJ $.
  $}

  ${
    nvmul0or.1 $e |- X = ( BaseSet ` U ) $.
    nvmul0or.4 $e |- S = ( .sOLD ` U ) $.
    nvmul0or.6 $e |- Z = ( 0vec ` U ) $.
    $( If a scalar product is zero, one of its factors must be zero.
       (Contributed by NM, 6-Dec-2007.)  (New usage is discouraged.) $)
    nvmul0or $p |- ( ( U e. NrmCVec /\ A e. CC /\ B e. X ) ->
                    ( ( A S B ) = Z <-> ( A = 0 \/ B = Z ) ) ) $=
      ( wcel cc co wceq cc0 wa c1 oveq2 3ad2antl2 3adant2 3eqtr3d cnv w3a wo wn
      wne df-ne cdiv ad2antlr recid2 oveq1d simpl1 reccl simpl2 simpl3 syl13anc
      cmul nvsass nvsid adantr adantlr nvsz anassrs 3adantl3 ex syl5bir orrd wi
      sylan2 nv0 oveq1 eqeq1d syl5ibrcom 3adant3 jaod impbid ) DUAJZAKJZBEJZUBZ
      ABCLZFMZANMZBFMZUCZVSWAWDVSWAOZWBWCWBUDANUEZWEWCANUFWEWFWCWEWFOPAUGLZVTCL
      ZWGFCLZBFWAWHWIMVSWFVTFWGCQUHVSWFWHBMWAVSWFOZWGAUPLZBCLZPBCLZWHBVQVPWFWLW
      MMVRVQWFOZWKPBCAUIUJRWJVPWGKJZVQVRWLWHMVPVQVRWFUKVQVPWFWOVRAULZRVPVQVRWFU
      MVPVQVRWFUNWGABCDEGHUQUOVSWMBMZWFVPVRWQVQBCDEGHURSUSTUTVSWFWIFMZWAVPVQWFW
      RVRVPVQWFWRWNVPWOWRWPWGCDFHIVAVHVBVCUTTVDVEVFVDVSWBWAWCVPVRWBWAVGVQVPVROW
      AWBNBCLZFMBCDEFGHIVIWBVTWSFANBCVJVKVLSVPVQWCWAVGVRVPVQOWAWCAFCLZFMACDFHIV
      AWCVTWTFBFACQVKVLVMVNVO $.
  $}

  ${
    nvrinv.1 $e |- X = ( BaseSet ` U ) $.
    nvrinv.2 $e |- G = ( +v ` U ) $.
    nvrinv.4 $e |- S = ( .sOLD ` U ) $.
    nvrinv.6 $e |- Z = ( 0vec ` U ) $.
    $( A vector minus itself.  (Contributed by NM, 4-Dec-2007.)  (Revised by
       Mario Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    nvrinv $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A G ( -u 1 S A ) ) = Z ) $=
      ( cnv wcel wa cgn cfv co cgi c1 wceq eqid cgr nvgrp bafval grporinv sylan
      cneg nvinv oveq2d 0vfval adantr 3eqtr4d ) CKLZAELZMZAADNOZOZDPZDQOZARUFAB
      PZDPFULDUALUMUQURSCDHUBAURDUOECDEGHUCURTUOTZUDUEUNUSUPADABCDUOEGHIUTUGUHU
      LFURSUMCDKFHJUIUJUK $.

    $( Minus a vector plus itself.  (Contributed by NM, 4-Dec-2007.)  (Revised
       by Mario Carneiro, 21-Dec-2013.)  (New usage is discouraged.) $)
    nvlinv $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( ( -u 1 S A ) G A ) = Z ) $=
      ( cnv wcel wa cgn cfv co cgi c1 wceq eqid cgr nvgrp bafval grpolinv sylan
      cneg nvinv oveq1d 0vfval adantr 3eqtr4d ) CKLZAELZMZADNOZOZADPZDQOZRUFABP
      ZADPFULDUALUMUQURSCDHUBAURDUOECDEGHUCURTUOTZUDUEUNUSUPADABCDUOEGHIUTUGUHU
      LFURSUMCDKFHJUIUJUK $.
  $}

  ${
    nvsubadd.1 $e |- X = ( BaseSet ` U ) $.
    nvsubadd.2 $e |- G = ( +v ` U ) $.
    nvsubadd.3 $e |- M = ( -v ` U ) $.
    $( Relationship between vector subtraction and addition.  (Contributed by
       NM, 14-Dec-2007.)  (New usage is discouraged.) $)
    nvsubadd $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                ( ( A M B ) = C <-> ( B G C ) = A ) ) $=
      ( wcel w3a wa co wceq cfv eqid 3adant3r3 eqeq1d 3jca cnv c1 cns nvmval wb
      cc neg1cn nvscl mp3an2 3adant2 nvgcl syld3an3 simpr3 simpr2 nvlcan syldan
      simprr simprl adantrl nvadd12 nvrinv oveq2d nv0rid 3eqtrd 3adantr3 bitr3d
      cneg cn0v adantrr eqcom syl6bb bitrd ) DUAKZAGKZBGKZCGKZLZMZABFNZCOAUBVGZ
      BDUCPZNZENZCOZBCENZAOZVRVSWCCVMVNVOVSWCOVPABWADEFGHIWAQZJUDRSVRWDAWEOZWFV
      RBWCENZWEOZWDWHVMVQWCGKZVPVOLWJWDUEVRWKVPVOVMVNVOWKVPVMVNVOWBGKZWKVMVOWLV
      NVMVTUFKVOWLUGVTBWADGHWGUHUIZUJAWBDEGHIUKULRVMVNVOVPUMVMVNVOVPUNTWCCBDEGH
      IUOUPVRWIAWEVMVNVOWIAOVPVMVNVOMZMZWIABWBENZENZADVHPZENZAVMWNVOVNWLLWIWQOW
      OVOVNWLVMVNVOUQVMVNVOURVMVOWLVNWMUSTBAWBDEGHIUTUPWOWPWRAEVMVOWPWROVNBWADE
      GWRHIWGWRQZVAUSVBVMVNWSAOVOADEGWRHIWTVCVIVDVESVFAWEVJVKVL $.

    $( Cancellation law for vector subtraction.  (Contributed by NM,
       27-Dec-2007.)  (New usage is discouraged.) $)
    nvpncan2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                 ( ( A G B ) M A ) = B ) $=
      ( cnv wcel w3a co c1 cneg cfv wceq eqid 3adant3 eqtrd simp1 nvgcl syl3anc
      cns simp2 nvmval simp3 neg1cn nvscl mp3an2 nvadd32 syl13anc nvrinv oveq1d
      cc cn0v nv0lid 3adant2 ) CJKZAFKZBFKZLZABDMZAEMZVCNOZACUDPZMZDMZBVBUSVCFK
      UTVDVHQUSUTVAUAZABCDFGHUBUSUTVAUEZVCAVFCDEFGHVFRZIUFUCVBVHAVGDMZBDMZBVBUS
      UTVAVGFKZVHVMQVIVJUSUTVAUGUSUTVNVAUSVEUOKUTVNUHVEAVFCFGVKUIUJSABVGCDFGHUK
      ULVBVMCUPPZBDMZBVBVLVOBDUSUTVLVOQVAAVFCDFVOGHVKVORZUMSUNUSVAVPBQUTBCDFVOG
      HVQUQURTTT $.

    $( Cancellation law for vector subtraction.  (Contributed by NM,
       24-Jan-2008.)  (New usage is discouraged.) $)
    nvpncan $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                 ( ( A G B ) M B ) = A ) $=
      ( cnv wcel co wceq w3a nvcom oveq1d nvpncan2 eqtr3d 3com23 ) CJKZBFKZAFKZ
      ABDLZBELZAMTUAUBNZBADLZBELUDAUEUFUCBEBACDFGHOPBACDEFGHIQRS $.

    $( Associative-type law for vector addition and subtraction.  (Contributed
       by NM, 24-Jan-2008.)  (New usage is discouraged.) $)
    nvaddsubass $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
              ( ( A G B ) M C ) = ( A G ( B M C ) ) ) $=
      ( cnv wcel cgr w3a co wceq nvgrp bafval vsfval grpomuldivass sylan ) DKLE
      MLAGLBGLCGLNABEOCFOABCFOEOPDEIQABCFEGDEGHIRDEFIJSTUA $.

    $( Commutative/associative law for vector addition and subtraction.
       (Contributed by NM, 24-Jan-2008.)  (New usage is discouraged.) $)
    nvaddsub $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
      ( ( A G B ) M C ) = ( ( A M C ) G B ) ) $=
      ( cnv wcel cablo w3a co wceq nvablo bafval vsfval ablomuldiv sylan ) DKLE
      MLAGLBGLCGLNABEOCFOACFOBEOPDEIQABCFEGDEGHIRDEFIJSTUA $.

    $( Cancellation law for a normed complex vector space.  (Contributed by NM,
       24-Jan-2008.)  (New usage is discouraged.) $)
    nvnpcan $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
         ( ( A M B ) G B ) = A ) $=
      ( cnv wcel w3a co wceq wa simprl simprr 3jca nvaddsub syldan 3impb eqtr3d
      nvpncan ) CJKZAFKZBFKZLABDMBEMZABEMBDMZAUDUEUFUGUHNZUDUEUFOZUEUFUFLUIUDUJ
      OUEUFUFUDUEUFPUDUEUFQZUKRABBCDEFGHISTUAABCDEFGHIUCUB $.

    $( Rearrangement of 4 terms in a mixed vector addition and subtraction.
       (Contributed by NM, 8-Feb-2008.)  (New usage is discouraged.) $)
    nvaddsub4 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X ) /\ ( C e. X /\
       D e. X ) ) -> ( ( A G B ) M ( C G D ) ) = ( ( A M C ) G ( B M D ) ) ) $=
      ( wcel wa co wceq neg1cn 3adant2 nvscl mp3an2 nvmval cnv w3a cneg cns cfv
      c1 cc eqid nvdi mp3anr1 oveq2d anim12dan syld3an3 eqtrd simp1 nvgcl 3expb
      3adant3 syl3anc 3adant3r 3adant2r 3adant3l 3adant2l oveq12d 3eqtr4d
      nvadd4 ) EUALZAHLZBHLZMZCHLZDHLZMZUBZABFNZUFUCZCDFNZEUDUEZNZFNZAVPCVRNZFN
      ZBVPDVRNZFNZFNZVOVQGNZACGNZBDGNZFNVNVTVOWAWCFNZFNZWEVNVSWIVOFVGVMVSWIOZVJ
      VGVPUGLZVKVLWKPVPCDVREFHIJVRUHZUIUJQUKVGVJVMWAHLZWCHLZMZWJWEOVGVMWPVJVGVK
      WNVLWOVGWLVKWNPVPCVREHIWMRSVGWLVLWOPVPDVREHIWMRSULQABWAWCEFHIJVFUMUNVNVGV
      OHLZVQHLZWFVTOVGVJVMUOVGVJWQVMVGVHVIWQABEFHIJUPUQURVGVMWRVJVGVKVLWRCDEFHI
      JUPUQQVOVQVREFGHIJWMKTUSVNWGWBWHWDFVGVHVMWGWBOZVIVGVHVKWSVLACVREFGHIJWMKT
      UTVAVGVIVMWHWDOZVHVGVIVLWTVKBDVREFGHIJWMKTVBVCVDVE $.
  $}

  ${
    nvsubsub23.1 $e |- X = ( BaseSet ` U ) $.
    nvsubsub23.3 $e |- M = ( -v ` U ) $.
    $( Swap subtrahend and result of vector subtraction.  (Contributed by NM,
       14-Dec-2007.)  (New usage is discouraged.) $)
    nvsubsub23 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                ( ( A M B ) = C <-> ( A M C ) = B ) ) $=
      ( cnv wcel w3a wa cpv cfv co wceq eqid nvcom 3adant3r1 nvsubadd eqeq1d wb
      3ancomb sylan2b 3bitr4d ) DIJZAFJZBFJZCFJZKZLZBCDMNZOZAPCBULOZAPZABEOCPAC
      EOBPZUKUMUNAUFUHUIUMUNPUGBCDULFGULQZRSUAABCDULEFGUQHTUJUFUGUIUHKUPUOUBUGU
      HUIUCACBDULEFGUQHTUDUE $.

    $( Cancellation law for a normed complex vector space.  (Contributed by NM,
       17-Dec-2007.)  (New usage is discouraged.) $)
    nvnncan $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
         ( A M ( A M B ) ) = B ) $=
      ( wcel co c1 wceq eqid nvmval neg1cn nvscl mp3an2 3adant2 syl13anc oveq2d
      cfv cnv w3a cneg cns cpv cn0v nvmcl syld3an3 cc simp1 a1i simp2 nvdi cmul
      wa ax-1cn mul2negi 1t1e1 eqtri oveq1i syl5eq nvsass mp3anr1 mpanr1 eqtr3d
      nvsid 3eqtr4d 3adant3 simp3 nvass nvrinv oveq1d 3eqtr2d nv0lid 3eqtrd ) C
      UAHZAEHZBEHZUBZAABDIZDIZAJUCZVTCUDTZIZCUETZIZCUFTZBWEIZBVPVQVRVTEHWAWFKAB
      CDEFGUGAVTWCCWEDEFWELZWCLZGMUHVSWFAWBAWCIZBWEIZWEIZAWKWEIZBWEIZWHVSWDWLAW
      EVSWBAWBBWCIZWEIZWCIZWKWBWPWCIZWEIZWDWLVSVPWBUIHZVQWPEHZWRWTKVPVQVRUJZXAV
      SNUKVPVQVRULZVPVRXBVQVPXAVRXBNWBBWCCEFWJOPQWBAWPWCCWEEFWIWJUMRVSVTWQWBWCA
      BWCCWEDEFWIWJGMSVSBWSWKWEVPVRBWSKVQVPVRUOZWBWBUNIZBWCIZBWSXEXGJBWCIBXFJBW
      CXFJJUNIJJJUPUPUQURUSUTBWCCEFWJVFVAVPXAVRXGWSKZNVPXAXAVRXHNWBWBBWCCEFWJVB
      VCVDVEQSVGSVSVPVQWKEHZVRWOWMKXCXDVPVQXIVRVPXAVQXINWBAWCCEFWJOPVHVPVQVRVIA
      WKBCWEEFWIVJRVSWNWGBWEVPVQWNWGKVRAWCCWEEWGFWIWJWGLZVKVHVLVMVPVRWHBKVQBCWE
      EWGFWIXJVNQVO $.
  $}

  ${
    nvmeq0.1 $e |- X = ( BaseSet ` U ) $.
    nvmeq0.3 $e |- M = ( -v ` U ) $.
    nvmeq0.5 $e |- Z = ( 0vec ` U ) $.
    $( The difference between two vectors is zero iff they are equal.
       (Contributed by NM, 24-Jan-2008.)  (New usage is discouraged.) $)
    nvmeq0 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
            ( ( A M B ) = Z <-> A = B ) ) $=
      ( cnv wcel w3a co cpv cfv wceq wb wa nvmcl 3expb nvzcl adantr simprr 3jca
      eqid nvrcan syldan 3impb nvnpcan nv0lid 3adant2 eqeq12d bitr3d ) CJKZAEKZ
      BEKZLZABDMZBCNOZMZFBUSMZPZURFPZABPUNUOUPVBVCQZUNUOUPRZUREKZFEKZUPLVDUNVER
      VFVGUPUNUOUPVFABCDEGHSTUNVGVECEFGIUAUBUNUOUPUCUDURFBCUSEGUSUEZUFUGUHUQUTA
      VABABCUSDEGVHHUIUNUPVABPUOBCUSEFGVHIUJUKULUM $.

    $( A vector minus itself is the zero vector.  (Contributed by NM,
       28-Jan-2008.)  (New usage is discouraged.) $)
    nvmid $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A M A ) = Z ) $=
      ( cnv wcel wa co wceq eqid wb nvmeq0 3anidm23 mpbiri ) BIJZADJZKAACLEMZAA
      MZANSTUAUBOAABCDEFGHPQR $.
  $}

  ${
    $d x y N $.  $d x y U $.  $d x y X $.
    nvf.1 $e |- X = ( BaseSet ` U ) $.
    nvf.6 $e |- N = ( normCV ` U ) $.
    $( Mapping for the norm function.  (Contributed by NM, 11-Nov-2006.)
       (New usage is discouraged.) $)
    nvf $p |- ( U e. NrmCVec -> N : X --> RR ) $=
      ( vx vy cnv wcel cpv cfv cns cop cvc cr cv wceq co wral eqid wf cn0v cabs
      cc0 wi cmul cc caddc cle wbr w3a nvi simp2d ) AHIAJKZALKZMNICOBUAFPZBKZUD
      QUPAUBKZQUEGPZUPUORBKUSUCKUQUFRQGUGSUPUSUNRBKUQUSBKUHRUIUJGCSUKFCSFGUOAUN
      BCURDUNTUOTURTEULUM $.

    $( The norm of a normed complex vector space is a real number.
       (Contributed by NM, 24-Nov-2006.)  (New usage is discouraged.) $)
    nvcl $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( N ` A ) e. RR ) $=
      ( cnv wcel cr nvf ffvelrnda ) BGHDIACBCDEFJK $.

    ${
      nvcli.9 $e |- U e. NrmCVec $.
      nvcli.7 $e |- A e. X $.
      $( The norm of a normed complex vector space is a real number.
         (Contributed by NM, 20-Apr-2007.)  (New usage is discouraged.) $)
      nvcli $p |- ( N ` A ) e. RR $=
        ( cnv wcel cfv cr nvcl mp2an ) BIJADJACKLJGHABCDEFMN $.
    $}
  $}

  ${
    nvdm.2 $e |- G = ( +v ` U ) $.
    nvdm.6 $e |- N = ( normCV ` U ) $.
    $( Two ways to express the set of vectors in a normed complex vector
       space.  (Contributed by NM, 31-Jan-2007.)
       (New usage is discouraged.) $)
    nvdm $p |- ( U e. NrmCVec -> ( X = dom N <-> X = ran G ) ) $=
      ( cnv wcel cdm crn cr wf wceq cba cfv eqid bafval eqcomi nvf fdm eqeq2d
      syl ) AGHZCIZBJZDUCUEKCLUDUEMACUEANOZUEABUFUFPEQRFSUEKCTUBUA $.
  $}

  ${
    $d y A $.  $d x y B $.  $d x y N $.  $d x y S $.  $d x y U $.  $d x y X $.
    nvs.1 $e |- X = ( BaseSet ` U ) $.
    nvs.4 $e |- S = ( .sOLD ` U ) $.
    nvs.6 $e |- N = ( normCV ` U ) $.
    $( Proportionality property of the norm of a scalar product in a normed
       complex vector space.  (Contributed by NM, 11-Nov-2006.)
       (New usage is discouraged.) $)
    nvs $p |- ( ( U e. NrmCVec /\ A e. CC /\ B e. X ) ->
               ( N ` ( A S B ) ) = ( ( abs ` A ) x. ( N ` B ) ) ) $=
      ( vy vx wcel cc co cfv cabs cmul wceq cv wral cnv wa cc0 wi cpv caddc cle
      cn0v wbr w3a cop cvc cr wf nvi simp3d simp2 ralimi syl oveq2 fveq2d fveq2
      eqid oveq2d eqeq12d oveq1 oveq1d rspc2v syl5 3impia 3com13 ) BFLZAMLZDUAL
      ZABCNZEOZAPOZBEOZQNZRZVLVMVNVTVNJSZKSZCNZEOZWAPOZWBEOZQNZRZJMTZKFTZVLVMUB
      VTVNWFUCRWBDUHOZRUDZWIWBWADUEOZNEOWFWAEOUFNUGUIJFTZUJZKFTZWJVNWMCUKULLFUM
      EUNWPKJCDWMEFWKGWMVCHWKVCIUOUPWOWIKFWLWIWNUQURUSWHVTWABCNZEOZWEVRQNZRKJBA
      FMWBBRZWDWRWGWSWTWCWQEWBBWACUTVAWTWFVRWEQWBBEVBVDVEWAARZWRVPWSVSXAWQVOEWA
      ABCVFVAXAWEVQVRQWAAPVBVGVEVHVIVJVK $.

    $( The norm of a scalar product with a nonnegative real.  (Contributed by
       NM, 1-Jan-2008.)  (New usage is discouraged.) $)
    nvsge0 $p |- ( ( U e. NrmCVec /\ ( A e. RR /\ 0 <_ A ) /\ B e. X ) ->
               ( N ` ( A S B ) ) = ( A x. ( N ` B ) ) ) $=
      ( cnv wcel cr cc0 cle wbr wa co cfv cmul wceq w3a cabs cc recn adantr nvs
      syl3an2 absid 3ad2ant2 oveq1d eqtrd ) DJKZALKZMANOZPZBFKZUAZABCQERZAUBRZB
      ERZSQZAUTSQUOULAUCKZUPURVATUMVBUNAUDUEABCDEFGHIUFUGUQUSAUTSUOULUSATUPAUHU
      IUJUK $.

    $( The norm of the negative of a vector.  (Contributed by NM,
       28-Nov-2006.)  (New usage is discouraged.) $)
    nvm1 $p |- ( ( U e. NrmCVec /\ A e. X ) ->
               ( N ` ( -u 1 S A ) ) = ( N ` A ) ) $=
      ( cnv wcel wa c1 cneg co cfv cabs cmul cc wceq neg1cn mp3an2 absnegi abs1
      nvs ax-1cn eqtri oveq1i nvcl recnd mulid2d syl5eq eqtrd ) CIJZAEJZKZLMZAB
      NDOZUPPOZADOZQNZUSUMUPRJUNUQUTSTUPABCDEFGHUDUAUOUTLUSQNUSURLUSQURLPOLLUEU
      BUCUFUGUOUSUOUSACDEFHUHUIUJUKUL $.
  $}

  ${
    nvdif.1 $e |- X = ( BaseSet ` U ) $.
    nvdif.2 $e |- G = ( +v ` U ) $.
    nvdif.4 $e |- S = ( .sOLD ` U ) $.
    nvdif.6 $e |- N = ( normCV ` U ) $.
    $( TODO - make this obsolete in favor of nvsub $)
    $( The norm of the difference between two vectors.  (Contributed by NM,
       1-Dec-2006.)  (New usage is discouraged.) $)
    nvdif $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( N ` ( A G ( -u 1 S B ) ) ) = ( N ` ( B G ( -u 1 S A ) ) ) ) $=
      ( wcel co cfv wceq neg1cn nvscl mp3an2 3adant3 syl3anc cnv w3a c1 cneg cc
      simp1 a1i simp3 nvdi syl13anc nvnegneg oveq2d 3adant2 simp2 3eqtrd fveq2d
      nvcom nvgcl nvm1 syl2anc eqtr3d ) DUALZAGLZBGLZUBZUCUDZBVFACMZEMZCMZFNZAV
      FBCMZEMZFNVHFNZVEVIVLFVEVIVKVFVGCMZEMZVKAEMZVLVEVBVFUELZVDVGGLZVIVOOVBVCV
      DUFZVQVEPUGVBVCVDUHZVBVCVRVDVBVQVCVRPVFACDGHJQRSZVFBVGCDEGHIJUIUJVEVNAVKE
      VBVCVNAOVDACDGHJUKSULVEVBVKGLZVCVPVLOVSVBVDWBVCVBVQVDWBPVFBCDGHJQRUMVBVCV
      DUNVKADEGHIUQTUOUPVEVBVHGLZVJVMOVSVEVBVDVRWCVSVTWABVGDEGHIURTVHCDFGHJKUSU
      TVA $.

    $( The norm of a vector plus the imaginary scalar product of another.
       (Contributed by NM, 2-Feb-2007.)  (New usage is discouraged.) $)
    nvpi $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( N ` ( A G ( _i S B ) ) ) = ( N ` ( B G ( -u _i S A ) ) ) ) $=
      ( wcel c1 ci co cfv cmul cneg ax-icn wceq cnv w3a cr simp1 mp3an2 3adant2
      nvscl nvgcl syld3an3 nvcl syl2anc recnd mulid2d cabs absnegi eqtri oveq1i
      cc absi negcli nvs simp2 nvdi mp3anr1 syl12anc mulneg1i ixi negeqi ax-1cn
      wa negnegi nvsass mpanr1 nvsid 3eqtr3a oveq2d 3adant3 nvcom 3eqtrd fveq2d
      syld3an2 eqtr3d syl5eqr ) DUALZAGLZBGLZUBZMANBCOZEOZFPZQOZWJBNRZACOZEOZFP
      ZWGWJWGWJWGWDWIGLZWJUCLWDWEWFUDZWDWEWFWHGLZWPWDWFWRWEWDNURLZWFWRSNBCDGHJU
      GUEUFZAWHDEGHIUHUIZWIDFGHKUJUKULUMWGWKWLUNPZWJQOZWOXBMWJQXBNUNPMNSUOUSUPU
      QWGWLWICOZFPZXCWOWGWDWPXEXCTZWQXAWDWLURLZWPXFNSUTZWLWICDFGHJKVAUEUKWGXDWN
      FWGXDWMWLWHCOZEOZWMBEOZWNWGWDWEWRXDXJTZWQWDWEWFVBWTWDXGWEWRXLXHWLAWHCDEGH
      IJVCVDVEWGXIBWMEWDWFXIBTWEWDWFVJWLNQOZBCOZMBCOXIBXMMBCXMNNQOZRZMNNSSVFXPM
      RZRMXOXQVGVHMVIVKUPUPUQWDWSWFXNXITZSWDXGWSWFXRXHWLNBCDGHJVLVDVMBCDGHJVNVO
      UFVPWDWMGLZWEWFXKWNTWDWEXSWFWDXGWEXSXHWLACDGHJUGUEVQWMBDEGHIVRWAVSVTWBWCW
      B $.
  $}

  ${
    nvsub.1 $e |- X = ( BaseSet ` U ) $.
    nvsub.3 $e |- M = ( -v ` U ) $.
    nvsub.6 $e |- N = ( normCV ` U ) $.
    $( The norm of the difference between two vectors.  (Contributed by NM,
       14-Dec-2007.)  (New usage is discouraged.) $)
    nvsub $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( N ` ( A M B ) ) = ( N ` ( B M A ) ) ) $=
      ( cnv wcel w3a c1 cneg cns cfv co eqid nvmval fveq2d nvdif 3com23 3eqtr4d
      cpv wceq ) CJKZAFKZBFKZLZAMNZBCOPZQCUDPZQZEPBUJAUKQULQZEPABDQZEPBADQZEPAB
      UKCULEFGULRZUKRZIUAUIUOUMEABUKCULDFGUQURHSTUIUPUNEUFUHUGUPUNUEBAUKCULDFGU
      QURHSUBTUC $.
  $}

  ${
    nvz0.5 $e |- Z = ( 0vec ` U ) $.
    nvz0.6 $e |- N = ( normCV ` U ) $.
    $( The norm of a zero vector is zero.  (Contributed by NM, 24-Nov-2006.)
       (New usage is discouraged.) $)
    nvz0 $p |- ( U e. NrmCVec -> ( N ` Z ) = 0 ) $=
      ( cnv wcel cc0 cns cfv co cmul cba wceq eqid nvzcl cr cle wa mpdan pm3.2i
      wbr 0re 0le0 nvsge0 mp3an2 nv0 fveq2d cc nvcl recnd mul02d 3eqtr3d ) AFGZ
      HCAIJZKZBJZHCBJZLKZURHUNCAMJZGZUQUSNZAUTCUTOZDPZUNHQGZHHRUBZSVAVBVEVFUCUD
      UAHCUOABUTVCUOOZEUEUFTUNUPCBUNVAUPCNVDCUOAUTCVCVGDUGTUHUNURUNVAURUIGVDUNV
      ASURCABUTVCEUJUKTULUM $.
  $}

  ${
    $d x A $.  $d x y N $.  $d x y U $.  $d x y X $.  $d x Z $.
    nvz.1 $e |- X = ( BaseSet ` U ) $.
    nvz.5 $e |- Z = ( 0vec ` U ) $.
    nvz.6 $e |- N = ( normCV ` U ) $.
    $( The norm of a vector is zero iff the vector is zero.  First part of
       Problem 2 of [Kreyszig] p. 64.  (Contributed by NM, 24-Nov-2006.)
       (New usage is discouraged.) $)
    nvz $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( ( N ` A ) = 0 <-> A = Z ) ) $=
      ( vx vy wcel cfv cc0 wceq wi cv co wral eqid fveq2 cnv wa cns cabs cc cpv
      cmul caddc cle wbr w3a cop cvc cr wf nvi simp3d simp1 ralimi eqeq1d eqeq1
      imbi12d rspccv 3syl imp nvz0 sylan9eqr ex adantr impbid ) BUAKZADKZUBACLZ
      MNZAENZVKVLVNVOOZVKIPZCLZMNZVQENZOZJPZVQBUCLZQCLWBUDLVRUGQNJUERZVQWBBUFLZ
      QCLVRWBCLUHQUIUJJDRZUKZIDRZWAIDRVLVPOVKWEWCULUMKDUNCUOWHIJWCBWECDEFWESWCS
      GHUPUQWGWAIDWAWDWFURUSWAVPIADVQANZVSVNVTVOWIVRVMMVQACTUTVQAEVAVBVCVDVEVKV
      OVNOVLVKVOVNVOVKVMECLMAECTBCEGHVFVGVHVIVJ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y N $.  $d x y U $.  $d x y X $.
    nvtri.1 $e |- X = ( BaseSet ` U ) $.
    nvtri.2 $e |- G = ( +v ` U ) $.
    nvtri.6 $e |- N = ( normCV ` U ) $.
    $( Triangle inequality for the norm of a normed complex vector space.
       (Contributed by NM, 11-Nov-2006.)  (Revised by Mario Carneiro,
       21-Dec-2013.)  (New usage is discouraged.) $)
    nvtri $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( N ` ( A G B ) ) <_ ( ( N ` A ) + ( N ` B ) ) ) $=
      ( vx vy wcel co cfv caddc cle wbr cv wral wceq cnv wa cn0v c1st c2nd cabs
      cc0 wi cmul cc w3a cop cvc cr wf cns eqid smfval eqcomi nvi simp3d ralimi
      simp3 syl oveq1 fveq2d fveq2 oveq1d oveq2 oveq2d rspc2v syl5 3impia 3comr
      breq12d ) AFLZBFLZCUALZABDMZENZAENZBENZOMZPQZVPVQVRWDVRJRZKRZDMZENZWEENZW
      FENZOMZPQZKFSZJFSZVPVQUBWDVRWIUGTWECUCNZTUHZWFWECUDNUENZMENWFUFNWIUIMTKUJ
      SZWMUKZJFSZWNVRDWQULUMLFUNEUOWTJKWQCDEFWOGHCUPNZWQXACXAUQURUSWOUQIUTVAWSW
      MJFWPWRWMVCVBVDWLWDAWFDMZENZWAWJOMZPQJKABFFWEATZWHXCWKXDPXEWGXBEWEAWFDVEV
      FXEWIWAWJOWEAEVGVHVOWFBTZXCVTXDWCPXFXBVSEWFBADVIVFXFWJWBWAOWFBEVGVJVOVKVL
      VMVN $.
  $}

  ${
    nvmtri.1 $e |- X = ( BaseSet ` U ) $.
    nvmtri.3 $e |- M = ( -v ` U ) $.
    nvmtri.6 $e |- N = ( normCV ` U ) $.
    $( Triangle inequality for the norm of a vector difference.  (Contributed
       by NM, 27-Dec-2007.)  (New usage is discouraged.) $)
    nvmtri $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( N ` ( A M B ) ) <_ ( ( N ` A ) + ( N ` B ) ) ) $=
      ( wcel c1 cfv co caddc cle neg1cn eqid mp3an2 3adant2 cmul cnv w3a cns cc
      cneg cpv wbr nvscl syld3an3 nvmval fveq2d wceq wa cabs nvs ax-1cn absnegi
      nvtri abs1 eqtri oveq1i nvcl recnd mulid2d syl5eq eqtr2d oveq2d 3brtr4d )
      CUAJZAFJZBFJZUBZAKUEZBCUCLZMZCUFLZMZELZAELZVOELZNMZABDMZELVSBELZNMOVIVJVK
      VOFJZVRWAOUGVIVKWDVJVIVMUDJZVKWDPVMBVNCFGVNQZUHRSAVOCVPEFGVPQZIURUIVLWBVQ
      EABVNCVPDFGWGWFHUJUKVLWCVTVSNVIVKWCVTULVJVIVKUMZVTVMUNLZWCTMZWCVIWEVKVTWJ
      ULPVMBVNCEFGWFIUORWHWJKWCTMWCWIKWCTWIKUNLKKUPUQUSUTVAWHWCWHWCBCEFGIVBVCVD
      VEVFSVGVH $.

    $( Triangle inequality for the norm of a vector difference.  (Contributed
       by NM, 24-Feb-2008.)  (New usage is discouraged.) $)
    nvmtri2 $p |- ( ( U e. NrmCVec /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
          ( N ` ( A M C ) ) <_ ( ( N ` ( A M B ) ) + ( N ` ( B M C ) ) ) ) $=
      ( cnv wcel w3a wa co cfv cpv caddc cle nvmcl cgr wceq nvgrp bafval vsfval
      eqid grponpncan sylan eqcomd fveq2d wbr simpl 3adant3r3 3adant3r1 syl3anc
      nvtri eqbrtrd ) DKLZAGLZBGLZCGLZMZNZACEOZFPABEOZBCEOZDQPZOZFPZVEFPVFFPROZ
      SVCVDVHFVCVHVDURVGUALVBVHVDUBDVGVGUFZUCABCEVGGDVGGHVKUDDVGEVKIUEUGUHUIUJV
      CURVEGLZVFGLZVIVJSUKURVBULURUSUTVLVAABDEGHITUMURUTVAVMUSBCDEGHITUNVEVFDVG
      FGHVKJUPUOUQ $.
  $}

  ${
    nvabs.1 $e |- X = ( BaseSet ` U ) $.
    nvabs.2 $e |- G = ( +v ` U ) $.
    nvabs.4 $e |- S = ( .sOLD ` U ) $.
    nvabs.6 $e |- N = ( normCV ` U ) $.
    $( Norm difference property of a normed complex vector space.  Problem 3 of
       [Kreyszig] p. 64.  (Contributed by NM, 4-Dec-2006.)
       (New usage is discouraged.) $)
    nvabs $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
       ( abs ` ( ( N ` A ) - ( N ` B ) ) ) <_ ( N ` ( A G ( -u 1 S B ) ) ) ) $=
      ( wcel cfv co cle wbr cr nvcl 3adant2 wceq cnv w3a cmin cabs nvdif negeqd
      c1 cneg 3adant3 simp1 neg1cn nvscl mp3an2 nvgcl syld3an3 syl2anc renegcld
      cc 3com23 caddc nvcom cn0v wa simprr adantrr simprl 3jca nvass 3impb eqid
      syldan nvlinv oveq2d nv0rid 3eqtrd eqtrd fveq2d eqbrtrrd subnegd breqtrrd
      nvtri recnd lesubd eqbrtrd simp2 simp3 syl13anc syld3an2 lesubaddd mpbird
      resubcld absled mpbir2and ) DUALZAGLZBGLZUBZAFMZBFMZUCNZUDMAUGUHZBCNZENZF
      MZOPXDUHZWTOPWTXDOPZWQXEBXAACNZENZFMZUHZWTOWQXDXIABCDEFGHIJKUEUFWQWSWRXJW
      NWPWSQLWOBDFGHKRSZWNWOWRQLWPADFGHKRUIZWQXIWQWNXHGLZXIQLWNWOWPUJZWNWPWOXMW
      NWPWOXGGLZXMWNWOXOWPWNXAURLZWOXOUKXAACDGHJULUMZSBXGDEGHIUNUOUSZXHDFGHKRUP
      ZUQWQWSWRXIUTNZWRXJUCNOWQAXHENZFMZWSXTOWQYABFWQYAXHAENZBWNWOWPXMYAYCTXRAX
      HDEGHIVAUOWQYCBXGAENZENZBDVBMZENZBWNWOWPYCYETZWNWOWPVCZWPXOWOUBYHWNYIVCWP
      XOWOWNWOWPVDWNWOXOWPXQVEWNWOWPVFVGBXGADEGHIVHVKVIWQYDYFBEWNWOYDYFTWPACDEG
      YFHIJYFVJZVLUIVMWNWPYGBTWOBDEGYFHIYJVNSVOVPVQWNWOWPXMYBXTOPXRAXHDEFGHIKWA
      UOVRWQWRXIWQWRXLWBWQXIXSWBVSVTWCWDWQXFWRXDWSUTNZOPWQXCBENZFMZWRYKOWQYLAFW
      QYLAXBBENZENZAYFENZAWQWNWOXBGLZWPYLYOTXNWNWOWPWEWNWPYQWOWNXPWPYQUKXABCDGH
      JULUMSZWNWOWPWFAXBBDEGHIVHWGWQYNYFAEWNWPYNYFTWOBCDEGYFHIJYJVLSVMWNWOYPATW
      PADEGYFHIYJVNUIVOVQWNXCGLZWOWPYMYKOPWNWOWPYQYSYRAXBDEGHIUNUOZXCBDEFGHIKWA
      WHVRWQWRWSXDXLXKWQWNYSXDQLXNYTXCDFGHKRUPZWIWJWQWTXDWQWRWSXLXKWKUUAWLWM $.
  $}

  ${
    nvge0.1 $e |- X = ( BaseSet ` U ) $.
    nvge0.6 $e |- N = ( normCV ` U ) $.
    $( The norm of a normed complex vector space is nonnegative.  Second part
       of Problem 2 of [Kreyszig] p. 64.  (Contributed by NM, 28-Nov-2006.)
       (New usage is discouraged.) $)
    nvge0 $p |- ( ( U e. NrmCVec /\ A e. X ) -> 0 <_ ( N ` A ) ) $=
      ( wcel wa c2 cr cfv cc0 wbr co cle jctil c1 caddc wceq eqid cnv cmul nvcl
      clt 2re cneg cns cpv cn0v nvz0 adantr ax-1cn negidi oveq1i nv0 syl5req cc
      neg1cn nvdir mp3anr1 mpanr1 nvsid oveq1d 3eqtrd fveq2d eqtr3d nvscl nvtri
      mp3an2 mpd3an3 eqbrtrd nvm1 oveq2d 2timesd eqtr4d breqtrd prodge0 syl2anc
      recnd 2pos ) BUAGZADGZHZIJGZACKZJGZHLIUDMZLIWEUBNZOMZHLWEOMWCWFWDABCDEFUC
      ZUEPWCWIWGWCLWEQUFZABUGKZNZCKZRNZWHOWCLAWMBUHKZNZCKZWOOWCBUIKZCKZLWRWAWTL
      SWBBCWSWSTZFUJUKWCWSWQCWCWSQWKRNZAWLNZQAWLNZWMWPNZWQWCXCLAWLNWSXBLAWLQULU
      MUNAWLBDWSEWLTZXAUOUPWAWKUQGZWBXCXESZURWAQUQGXGWBXHULQWKAWLBWPDEWPTZXFUSU
      TVAWCXDAWMWPAWLBDEXFVBVCVDVEVFWAWBWMDGZWRWOOMWAXGWBXJURWKAWLBDEXFVGVIAWMB
      WPCDEXIFVHVJVKWCWOWEWERNWHWCWNWEWERAWLBCDEXFFVLVMWCWEWCWEWJVSVNVOVPVTPIWE
      VQVR $.
  $}

  ${
    nvgt0.1 $e |- X = ( BaseSet ` U ) $.
    nvgt0.5 $e |- Z = ( 0vec ` U ) $.
    nvgt0.6 $e |- N = ( normCV ` U ) $.
    $( A nonzero norm is positive.  (Contributed by NM, 20-Nov-2007.)
       (New usage is discouraged.) $)
    nvgt0 $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                   ( A =/= Z <-> 0 < ( N ` A ) ) ) $=
      ( cnv wcel wa cfv cc0 wne clt wbr nvz necon3bid cr cle nvcl nvge0 syl2anc
      wb ne0gt0 bitr3d ) BIJADJKZACLZMNZAENMUHOPZUGUHMAEABCDEFGHQRUGUHSJMUHTPUI
      UJUDABCDFHUAABCDFHUBUHUEUCUF $.
  $}

  ${
    nv1.1 $e |- X = ( BaseSet ` U ) $.
    nv1.4 $e |- S = ( .sOLD ` U ) $.
    nv1.5 $e |- Z = ( 0vec ` U ) $.
    nv1.6 $e |- N = ( normCV ` U ) $.
    $( From any nonzero vector, construct a vector whose norm is one.
       (Contributed by NM, 6-Dec-2007.)  (New usage is discouraged.) $)
    nv1 $p |- ( ( U e. NrmCVec /\ A e. X /\ A =/= Z ) ->
               ( N ` ( ( 1 / ( N ` A ) ) S A ) ) = 1 ) $=
      ( wcel wne c1 cfv co cr cc0 cle wbr 3adant3 cnv cdiv cmul wceq simp1 nvcl
      w3a wa nvz necon3bid biimp3ar rereccld clt nvgt0 biimp3a 1re 0le1 mpanl12
      divge0 syl2anc simp2 nvsge0 syl121anc cc recnd recid2d eqtrd ) CUAKZAEKZA
      FLZUGZMADNZUBOZABODNZVMVLUCOZMVKVHVMPKQVMRSZVIVNVOUDVHVIVJUEVKVLVHVIVLPKZ
      VJACDEGJUFZTZVHVIVLQLVJVHVIUHZVLQAFACDEFGIJUIUJUKZULVKVQQVLUMSZVPVSVHVIVJ
      WBACDEFGIJUNUOMPKQMRSVQWBUHVPUPUQMVLUSURUTVHVIVJVAVMABCDEGHJVBVCVKVLVHVIV
      LVDKVJVTVLVRVETWAVFVG $.
  $}

  ${
    nvop.2 $e |- G = ( +v ` U ) $.
    nvop.4 $e |- S = ( .sOLD ` U ) $.
    nvop.6 $e |- N = ( normCV ` U ) $.
    $( A complex inner product space in terms of ordered pair components.
       (Contributed by NM, 11-Sep-2007.)  (New usage is discouraged.) $)
    nvop $p |- ( U e. NrmCVec -> U = <. <. G , S >. , N >. ) $=
      ( cnv wcel c1st cfv c2nd cop wrel wceq nvrel 1st2nd mpan nmcvfval opeq2i
      eqid nvvop opeq1d syl5eqr eqtrd ) BHIZBBJKZBLKZMZCAMZDMZHNUFBUIOPBHQRUFUI
      UGDMUKDUHUGBDGSTUFUGUJDABCUGUGUAEFUBUCUDUE $.
  $}

  $( TODO?  is this needed? $)
  $( The vector addition and scalar product operations are not identical.
     (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
  nvoprne $p |- ( <. <. G , S >. , N >. e. NrmCVec -> G =/= S ) $=
    ( cop cnv wcel cvc wne nvvcop vcoprne syl ) BADZCDEFLGFBAHCLIABJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Examples of normed complex vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    cnnv.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is a normed complex vector space.  The vector
       operation is ` + ` , the scalar product is ` x. ` , and the norm
       function is ` abs ` .  (Contributed by Steve Rodriguez, 3-Dec-2006.)
       (New usage is discouraged.) $)
    cnnv $p |- U e. NrmCVec $=
      ( vx vy cmul caddc cabs cc cc0 cablo cgr cnaddablo ablogrpo ax-mp ax-addf
      wcel cxp fdmi cv wceq grporn cnid cncvc abs00 biimpa absmul abstri isnvi
      absf cfv ) CDEAFGHIFHFJPFKPLFMNHHQHFORUAUBUCUICSZHPUKGUJITUKITUKUDUEDSZUK
      UFUKULUGBUH $.
  $}

  ${
    cnnvg.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The vector addition (group) operation of the normed complex vector space
       of complex numbers.  (Contributed by NM, 12-Jan-2008.)
       (New usage is discouraged.) $)
    cnnvg $p |- + = ( +v ` U ) $=
      ( cpv cfv c1st caddc cmul cop eqid vafval cabs fveq2i opex cc cr cvv wcel
      wf absf op1st cnex fex mp2an eqtri addex mulex 3eqtrri ) ACDZAEDZEDFGHZED
      FAUHUHIJUIUJEUIUJKHZEDUJAUKEBLUJKFGMNOKRNPQKPQSUANOPKUBUCTUDLFGUEUFTUG $.
  $}

  ${
    cnnvba.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The base set of the normed complex vector space of complex numbers.
       (Contributed by NM, 7-Nov-2007.)  (New usage is discouraged.) $)
    cnnvba $p |- CC = ( BaseSet ` U ) $=
      ( caddc crn cpv cfv cc cba cnnvg rneqi cablo cgr cnaddablo ablogrpo ax-mp
      wcel cxp ax-addf fdmi eqid grporn bafval 3eqtr4i ) CDAEFZDGAHFZCUDABIJCGC
      KPCLPMCNOGGQGCRSUAAUDUEUETUDTUBUC $.
  $}

  $( Derive the associative law for complex number addition ~ addass to
     demonstrate the use of ~ cnnv , ~ cnnvg , and ~ cnnvba .  (Contributed by
     NM, 12-Jan-2008.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  cnnvdemo $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) -> ( ( A + B ) + C ) =
      ( A + ( B + C ) ) ) $=
    ( caddc cmul cop cabs cnv wcel cc co wceq eqid cnnv cnnvba cnnvg nvass mpan
    w3a ) DEFGFZHIAJIBJICJISABDKCDKABCDKDKLTTMZNABCTDJTUAOTUAPQR $.

  ${
    cnnvs.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The scalar product operation of the normed complex vector space of
       complex numbers.  (Contributed by NM, 12-Jan-2008.)
       (New usage is discouraged.) $)
    cnnvs $p |- x. = ( .sOLD ` U ) $=
      ( cns cfv c1st c2nd caddc cmul cop eqid smfval cabs fveq2i opex cc cr cvv
      wf wcel absf cnex fex mp2an op1st eqtri addex mulex op2nd 3eqtrri ) ACDZA
      EDZFDGHIZFDHUJAUJJKUKULFUKULLIZEDULAUMEBMULLGHNOPLROQSLQSTUAOPQLUBUCUDUEM
      GHUFUGUHUI $.
  $}

  ${
    cnnvnm.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The norm operation of the normed complex vector space of complex
       numbers.  (Contributed by NM, 12-Jan-2008.)
       (New usage is discouraged.) $)
    cnnvnm $p |- abs = ( normCV ` U ) $=
      ( cnmcv cfv c2nd caddc cmul cop cabs eqid nmcvfval fveq2i opex cc cr wcel
      wf cvv absf cnex fex mp2an op2nd 3eqtrri ) ACDZAEDFGHZIHZEDIAUEUEJKAUGEBL
      UFIFGMNOIQNRPIRPSTNORIUAUBUCUD $.
  $}

  ${
    $d x y U $.
    cnnvm.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The vector subtraction operation of the normed complex vector space of
       complex numbers.  (Contributed by NM, 12-Jan-2008.)  (Revised by Mario
       Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    cnnvm $p |- - = ( -v ` U ) $=
      ( vx vy cc cv cmin co cmpt2 c1 cneg cmul caddc cnsb wcel wceq mulm1 ax-mp
      cfv wa adantl oveq2d negsub eqtr2d mpt2eq3ia cxp wfn wf subf ffn fnov cnv
      mpbi cnnv cnnvba cnnvg cnnvs eqid nvmfval 3eqtr4i ) CDEECFZDFZGHZIZCDEEVA
      JKVBLHZMHZIZGANSZCDEEVCVFVAEOZVBEOZTZVFVAVBKZMHVCVKVEVLVAMVJVEVLPVIVBQUAU
      BVAVBUCUDUEGEEUFZUGZGVDPVMEGUHVNUIVMEGUJRCDEEGUKUMAULOVHVGPABUNCDLAMVHEAB
      UOABUPABUQVHURUSRUT $.
  $}

  ${
    elimnv.1 $e |- X = ( BaseSet ` U ) $.
    elimnv.5 $e |- Z = ( 0vec ` U ) $.
    elimnv.9 $e |- U e. NrmCVec $.
    $( Hypothesis elimination lemma for normed complex vector spaces to assist
       weak deduction theorem.  (Contributed by NM, 16-May-2007.)
       (New usage is discouraged.) $)
    elimnv $p |- if ( A e. X , A , Z ) e. X $=
      ( cnv wcel nvzcl ax-mp elimel ) ADCBHIDCIGBCDEFJKL $.
  $}

  $( Hypothesis elimination lemma for normed complex vector spaces to assist
     weak deduction theorem.  (Contributed by NM, 16-May-2007.)
     (New usage is discouraged.) $)
  elimnvu $p |- if ( U e. NrmCVec , U , <. <. + , x. >. , abs >. )
                 e. NrmCVec $=
    ( caddc cmul cop cabs cnv eqid cnnv elimel ) ABCDEDZFJJGHI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Induced metric of a normed complex vector space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d u U $.
    imsval.3 $e |- M = ( -v ` U ) $.
    imsval.6 $e |- N = ( normCV ` U ) $.
    imsval.8 $e |- D = ( IndMet ` U ) $.
    $( Value of the induced metric of a normed complex vector space.
       (Contributed by NM, 11-Sep-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    imsval $p |- ( U e. NrmCVec -> D = ( N o. M ) ) $=
      ( vu cnv wcel cims cfv cnmcv cnsb ccom cv wceq fveq2 coeq12d fvex coeq12i
      df-ims coex fvmpt 3eqtr4g ) BIJBKLBMLZBNLZOZADCOHBHPZMLZUINLZOUHIKUIBQUJU
      FUKUGUIBMRUIBNRSHUBUFUGBMTBNTUCUDGDUFCUGFEUAUE $.
  $}

  ${
    imsdval.1 $e |- X = ( BaseSet ` U ) $.
    imsdval.3 $e |- M = ( -v ` U ) $.
    imsdval.6 $e |- N = ( normCV ` U ) $.
    imsdval.8 $e |- D = ( IndMet ` U ) $.
    $( Value of the induced metric (distance function) of a normed complex
       vector space.  Equation 1 of [Kreyszig] p. 59.  (Contributed by NM,
       11-Sep-2007.)  (Revised by Mario Carneiro, 27-Dec-2014.)
       (New usage is discouraged.) $)
    imsdval $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( N ` ( A M B ) ) ) $=
      ( cnv wcel w3a cop cfv co ccom wceq df-ov imsval 3ad2ant1 fveq1d cxp nvmf
      wf wa opelxpi fvco3 syl2an 3impb eqtrd fveq2i 3eqtr4g ) DLMZAGMZBGMZNZABO
      ZCPZUSEPZFPZABCQABEQZFPURUTUSFERZPZVBURUSCVDUOUPCVDSUQCDEFIJKUAUBUCUOUPUQ
      VEVBSZUOGGUDZGEUFUSVGMVFUPUQUGDEGHIUEABGGUHVGGUSFEUIUJUKULABCTVCVAFABETUM
      UN $.
  $}

  ${
    imsdval2.1 $e |- X = ( BaseSet ` U ) $.
    imsdval2.2 $e |- G = ( +v ` U ) $.
    imsdval2.4 $e |- S = ( .sOLD ` U ) $.
    imsdval2.6 $e |- N = ( normCV ` U ) $.
    imsdval2.8 $e |- D = ( IndMet ` U ) $.
    $( TODO $)
    $( Value of the distance function of the induced metric of a normed complex
       vector space.  Equation 1 of [Kreyszig] p. 59.  (Contributed by NM,
       28-Nov-2006.)  (New usage is discouraged.) $)
    imsdval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                  ( A D B ) = ( N ` ( A G ( -u 1 S B ) ) ) ) $=
      ( cnv wcel w3a co cnsb cfv c1 cneg eqid imsdval nvmval fveq2d eqtrd ) ENO
      AHOBHOPZABCQABERSZQZGSATUABDQFQZGSABCEUHGHIUHUBZLMUCUGUIUJGABDEFUHHIJKUKU
      DUEUF $.
  $}

  ${
    nvnd.1 $e |- X = ( BaseSet ` U ) $.
    nvnd.5 $e |- Z = ( 0vec ` U ) $.
    nvnd.6 $e |- N = ( normCV ` U ) $.
    nvnd.8 $e |- D = ( IndMet ` U ) $.
    $( The norm of a normed complex vector space expressed in terms of the
       distance function of its induced metric.  Problem 1 of [Kreyszig]
       p. 63.  (Contributed by NM, 4-Dec-2006.)  (New usage is discouraged.) $)
    nvnd $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( N ` A ) = ( A D Z ) ) $=
      ( cnv wcel wa co cnsb cfv wceq adantr eqid mpd3an3 nvzcl imsdval cneg cns
      c1 cpv nvmval cc neg1cn nvsz mpan2 oveq2d nv0rid 3eqtrd fveq2d eqtr2d ) C
      KLZAELZMZAFBNZAFCOPZNZDPZADPUQURFELZUTVCQUQVDURCEFGHUARZAFBCVADEGVASZIJUB
      TUSVBADUSVBAUEUCZFCUDPZNZCUFPZNZAFVJNZAUQURVDVBVKQVEAFVHCVJVAEGVJSZVHSZVF
      UGTUQVKVLQURUQVIFAVJUQVGUHLVIFQUIVGVHCFVNHUJUKULRACVJEFGVMHUMUNUOUP $.
  $}

  ${
    $d x y z U $.  $d x y z X $.
    imsdfn.1 $e |- X = ( BaseSet ` U ) $.
    imsdfn.8 $e |- D = ( IndMet ` U ) $.
    $( Mapping for the induced metric distance function of a normed complex
       vector space.  (Contributed by NM, 29-Nov-2006.)
       (New usage is discouraged.) $)
    imsdf $p |- ( U e. NrmCVec -> D : ( X X. X ) --> RR ) $=
      ( cnv wcel cxp cr wf cnmcv cfv cnsb ccom eqid nvf nvmf fco syl2anc imsval
      feq1d mpbird ) BFGZCCHZIAJUDIBKLZBMLZNZJZUCCIUEJUDCUFJUHBUECDUEOZPBUFCDUF
      OZQUDCIUEUFRSUCUDIAUGABUFUEUJUIETUAUB $.
  $}

  ${
    $d x y z D $.  $d x y z X $.
    imsmetlem.1 $e |- X = ( BaseSet ` U ) $.
    imsmetlem.2 $e |- G = ( +v ` U ) $.
    imsmetlem.7 $e |- M = ( inv ` G ) $.
    imsmetlem.4 $e |- S = ( .sOLD ` U ) $.
    imsmetlem.5 $e |- Z = ( 0vec ` U ) $.
    imsmetlem.6 $e |- N = ( normCV ` U ) $.
    imsmetlem.8 $e |- D = ( IndMet ` U ) $.
    imsmetlem.9 $e |- U e. NrmCVec $.
    $( Lemma for ~ imsmet .  (Contributed by NM, 29-Nov-2006.)
       (New usage is discouraged.) $)
    imsmetlem $p |- D e. ( Met ` X ) $=
      ( wcel co wceq mp3an1 vx vy vz cba cfv cvv eqeltri cnv cxp cr imsdf ax-mp
      fvex wf cv wa cc0 c1 cneg imsdval2 eqeq1d wb cc neg1cn nvscl nvgcl sylan2
      mp3an12 nvz sylancr nvzcl w3a nvrcan mpan mp3an2 simpl adantl simpr nvass
      sylancom syl3anc nvlinv oveq2d nv0rid adantr 3eqtrd nv0lid eqeq12d bitr3d
      3bitrd caddc cle wbr syl2anc 3adant3 3adant2 nvtri 3adant1 simp1 3ad2ant3
      oveq1d eqtr3d fveq2d eqtr4d nvdif eqtrd oveq12d 3brtr4d 3coml ismeti ) UA
      UBUCAGGCUDUEUFICUDUMUGCUHQZGGUIUJAUNPACGIOUKULUAUOZGQZUBUOZGQZUPZXLXNARZU
      QSXLURUSZXNBRZDRZFUEZUQSZXTHSZXLXNSZXPXQYAUQXKXMXOXQYASZPXLXNABCDFGIJLNOU
      TTZVAXPXKXTGQZYBYCVBPXOXMXSGQZYGXKXRVCQZXOYHPVDXRXNBCGILVEVHZXKXMYHYGPXLX
      SCDGIJVFTVGZXTCFGHIMNVIVJXPXTXNDRZHXNDRZSZYCYDXMXOYGYNYCVBZYKYGHGQZXOYOXK
      YPPCGHIMVKULXKYGYPXOVLYOPXTHXNCDGIJVMVNVOVTXPYLXLYMXNXPYLXLXSXNDRZDRZXLHD
      RZXLXPXMYHXOYLYRSZXMXOVPXOYHXMYJVQXMXOVRXKXMYHXOVLYTPXLXSXNCDGIJVSVNWAXPY
      QHXLDXOYQHSZXMXKXOUUAPXNBCDGHIJLMWBVNVQWCXMYSXLSZXOXKXMUUBPXLCDGHIJMWDVNZ
      WEWFXOYMXNSZXMXKXOUUDPXNCDGHIJMWGVNVQWHWIWJUCUOZGQZXMXOXQUUEXLARZUUEXNARZ
      WKRZWLWMUUFXMXOVLZXLXRUUEBRZDRZUUEXSDRZDRZFUEZUULFUEZUUMFUEZWKRZXQUUIWLUU
      JUULGQZUUMGQZUUOUURWLWMZUUFXMUUSXOUUFXMUPZXMUUKGQZUUSUUFXMVRZUUFUVCXMXKYI
      UUFUVCPVDXRUUEBCGILVEVHWEZXKXMUVCUUSPXLUUKCDGIJVFTWNWOZUUFXOUUTXMXOUUFYHU
      UTYJXKUUFYHUUTPUUEXSCDGIJVFTVGWPXKUUSUUTUVAPUULUUMCDFGIJNWQTWNUUJXQYAUUOX
      MXOYEUUFYFWRUUJUUNXTFUUJUULUUEDRZXSDRZUUNXTUUJUUSUUFYHUVHUUNSZUVFUUFXMXOW
      SXOUUFYHXMYJWTXKUUSUUFYHVLUVIPUULUUEXSCDGIJVSVNWAUUJUVGXLXSDUUFXMUVGXLSXO
      UVBUVGXLUUKUUEDRZDRZYSXLUVBXMUVCUUFUVGUVKSZUVDUVEUUFXMVPXKXMUVCUUFVLUVLPX
      LUUKUUECDGIJVSVNWAUVBUVJHXLDUUFUVJHSZXMXKUUFUVMPUUEBCDGHIJLMWBVNWEWCXMUUB
      UUFUUCVQWFWOXAXBXCXDUUJUUGUUPUUHUUQWKUUFXMUUGUUPSXOUVBUUGUUEXRXLBRDRFUEZU
      UPXKUUFXMUUGUVNSPUUEXLABCDFGIJLNOUTTXKUUFXMUVNUUPSPUUEXLBCDFGIJLNXETXFWOU
      UFXOUUHUUQSZXMXKUUFXOUVOPUUEXNABCDFGIJLNOUTTWPXGXHXIXJ $.
  $}

  ${
    imsmet.1 $e |- X = ( BaseSet ` U ) $.
    imsmet.8 $e |- D = ( IndMet ` U ) $.
    $( The induced metric of a normed complex vector space is a metric space.
       Part of Definition 2.2-1 of [Kreyszig] p. 58.  (Contributed by NM,
       4-Dec-2006.)  (Revised by Mario Carneiro, 10-Sep-2015.)
       (New usage is discouraged.) $)
    imsmet $p |- ( U e. NrmCVec -> D e. ( Met ` X ) ) $=
      ( cnv wcel cims cfv cme caddc cmul cop cabs cif wceq fveq2 syl5eq eqid
      cba fveq2d eleq12d cns cpv cnmcv cn0v elimnvu imsmetlem dedth syl5eqel
      cgn ) BFGZABHIZCJIZEULUMUNGULBKLMNMZOZHIZUPTIZJIZGBUOBUPPZUMUQUNUSBUPHQUT
      CURJUTCBTIURDBUPTQRUAUBUQUPUCIZUPUPUDIZVBUKIZUPUEIZURUPUFIZURSVBSVCSVASVE
      SVDSUQSBUGUHUIUJ $.

    $( The induced metric of a normed complex vector space is an extended
       metric space.  (Contributed by Mario Carneiro, 10-Sep-2015.)
       (New usage is discouraged.) $)
    imsxmet $p |- ( U e. NrmCVec -> D e. ( *Met ` X ) ) $=
      ( cnv wcel cme cfv cxmt imsmet metxmet syl ) BFGACHIGACJIGABCDEKACLM $.
  $}

  ${
    nvelbl.1 $e |- X = ( BaseSet ` U ) $.
    nvelbl.3 $e |- M = ( -v ` U ) $.
    nvelbl.6 $e |- N = ( normCV ` U ) $.
    nvelbl.8 $e |- D = ( IndMet ` U ) $.
    $( Membership of a vector in a ball.  (Contributed by NM, 27-Dec-2007.)
       (Revised by Mario Carneiro, 10-Jan-2014.)
       (New usage is discouraged.) $)
    nvelbl $p |- ( ( ( U e. NrmCVec /\ R e. RR+ ) /\ ( P e. X /\ A e. X ) ) ->
                   ( A e. ( P ( ball ` D ) R ) <-> ( N ` ( A M P ) ) < R ) ) $=
      ( cnv wcel crp wa cfv co clt wbr cbl cxmt cxr wb imsxmet rpxr elbl3 sylan
      anim12i wceq imsdval 3com23 3expb adantlr breq1d bitrd ) EMNZDONZPZCHNZAH
      NZPZPZACDBUAQRNZACBRZDSTZACFRGQZDSTUSBHUBQNZDUCNZPVBVDVFUDUQVHURVIBEHILUE
      DUFUIABCDHUGUHVCVEVGDSUQVBVEVGUJZURUQUTVAVJUQVAUTVJACBEFGHIJKLUKULUMUNUOU
      P $.
  $}

  ${
    nvelbl2.1 $e |- X = ( BaseSet ` U ) $.
    nvelbl2.2 $e |- G = ( +v ` U ) $.
    nvelbl2.6 $e |- N = ( normCV ` U ) $.
    nvelbl2.8 $e |- D = ( IndMet ` U ) $.
    $( Membership of an off-center vector in a ball.  (Contributed by NM,
       27-Dec-2007.)  (Revised by Mario Carneiro, 10-Jan-2014.)
       (New usage is discouraged.) $)
    nvelbl2 $p |- ( ( ( U e. NrmCVec /\ R e. RR+ ) /\ ( P e. X /\ A e. X ) ) ->
                   ( ( P G A ) e. ( P ( ball ` D ) R ) <-> ( N ` A ) < R ) ) $=
      ( wcel wa co cfv clt wbr 3expb adantlr cnv crp cbl cnsb simprl nvgcl eqid
      wb jca nvelbl syldan wceq nvpncan2 fveq2d breq1d bitrd ) EUAMZDUBMZNZCHMZ
      AHMZNZNZCAFOZCDBUCPOMZVDCEUDPZOZGPZDQRZAGPZDQRUSVBUTVDHMZNVEVIUHVCUTVKUSU
      TVAUEUQVBVKURUQUTVAVKCAEFHIJUFSTUIVDBCDEVFGHIVFUGZKLUJUKVCVHVJDQVCVGAGUQV
      BVGAULZURUQUTVAVMCAEFVFHIJVLUMSTUNUOUP $.
  $}

  ${
    nvlmcl.1 $e |- X = ( BaseSet ` U ) $.
    nvlmcl.2 $e |- D = ( IndMet ` U ) $.
    nvlmcl.3 $e |- J = ( MetOpen ` D ) $.
    $( Closure of the limit of a converging vector sequence.  (Contributed by
       NM, 26-Dec-2007.)  (Revised by Mario Carneiro, 10-Sep-2015.)
       (New usage is discouraged.) $)
    nvlmcl $p |- ( ( U e. NrmCVec /\ F ( ~~>t ` J ) P ) -> P e. X ) $=
      ( cnv wcel ctopon cfv clm wbr cxmt imsxmet mopntopon syl lmcl sylan ) CJK
      ZEFLMKZDBENMOBFKUBAFPMKUCACFGHQAEFIRSBDEFTUA $.

    $d k D $.  $d k F $.  $d k J $.  $d k P $.  $d k R $.  $d k U $.  $d k X $.
    $d k ph $.
    nvlmle.5 $e |- N = ( normCV ` U ) $.
    nvlmle.6 $e |- ( ph -> U e. NrmCVec ) $.
    nvlmle.7 $e |- ( ph -> F : NN --> X ) $.
    nvlmle.8 $e |- ( ph -> F ( ~~>t ` J ) P ) $.
    nvlmle.9 $e |- ( ph -> R e. RR ) $.
    nvlmle.10 $e |- ( ( ph /\ k e. NN ) -> ( N ` ( F ` k ) ) <_ R ) $.
    $( If the norm of each member of a converging sequence is less than or
       equal to a given amount, so is the norm of the convergence value.
       (Contributed by NM, 25-Dec-2007.)  (Revised by Mario Carneiro,
       5-May-2014.)  (New usage is discouraged.) $)
    nvlmle $p |- ( ph -> ( N ` P ) <_ R ) $=
      ( wcel cfv cn0v co cle cnv wceq clm nvlmcl syl2anc eqid nvnd cxmt imsxmet
      wbr syl nvzcl xmetsym syl3anc eqtrd c1 cn cz 1z a1i rexrd cv wa ffvelrnda
      nnuz adantr eqbrtrrd lmle eqbrtrd ) ACIUAZEUBUAZCBUCZDUDAVNCVOBUCZVPAEUET
      ZCJTZVNVQUFOAVRGCHUGUAUNVSOQBCEGHJKLMUHUIZCBEIJVOKVOUJZNLUKUIABJULUATZVSV
      OJTZVQVPUFAVRWBOBEJKLUMUOZVTAVRWCOEJVOKWAUPUOZCVOBJUQURUSABCVODFGHUTJVAVI
      MWDUTVBTAVCVDQWEADRVEAFVFZVATZVGZWFGUAZIUAZVOWIBUCZDUDWHWJWIVOBUCZWKWHVRW
      IJTZWJWLUFAVRWGOVJAVAJWFGPVHZWIBEIJVOKWANLUKUIWHWBWMWCWLWKUFAWBWGWDVJWNAW
      CWGWEVJWIVOBJUQURUSSVKVLVM $.
  $}

  ${
    $d t u v w x y z $.
    cnims.6 $e |- U = <. <. + , x. >. , abs >. $.
    cnims.7 $e |- D = ( abs o. - ) $.
    $( The metric induced on the complex numbers. ~ cnmet proves that it is a
       metric.  (Contributed by Steve Rodriguez, 5-Dec-2006.)  (Revised by NM,
       15-Jan-2008.)  (New usage is discouraged.) $)
    cnims $p |- D = ( IndMet ` U ) $=
      ( cabs cmin ccom cims cfv wcel wceq cnnv cnnvm cnnvnm imsval ax-mp eqtr4i
      cnv eqid ) AEFGZBHIZDBRJUATKBCLUABFEBCMBCNUASOPQ $.
  $}

  ${
    $d r s w x y z C $.  $d r s w x y z G $.  $d r s w x y z J $.
    $d r s w x y z U $.
    vacn.c $e |- C = ( IndMet ` U ) $.
    vacn.j $e |- J = ( MetOpen ` C ) $.
    vacn.g $e |- G = ( +v ` U ) $.
    $( Vector addition is jointly continuous in both arguments.  (Contributed
       by Jeffrey Hankins, 16-Jun-2009.)  (Revised by Mario Carneiro,
       10-Sep-2015.)  (New usage is discouraged.) $)
    vacn $p |- ( U e. NrmCVec -> G e. ( ( J tX J ) Cn J ) ) $=
      ( vz vw wcel co cfv cv clt wbr wa wral crp cr syl3anc vx vs vy vr cnv ctx
      ccn cba cxp wf wi wrex eqid nvgf c2 cdiv rphalfcl adantl caddc cme imsmet
      simplll syl simplrl adantr simprl metcl simplrr simprr ad2antlr lt2halves
      rpre cnsb cnmcv nvmcl nvtri wceq nvgcl imsdval nvaddsub4 syl122anc fveq2d
      eqtrd oveq12d 3brtr4d readdcld lelttr mpand syld ralrimivva breq2 anbi12d
      cle imbi1d 2ralbidv rspcev syl2anc ralrimiva wb imsxmet txmetcn mpbir2and
      cxmt ) BUEJZCDDUFKDUGKJZBUHLZXFUIXFCUJZUAMZHMZAKZUBMZNOZUCMZIMZAKZXKNOZPZ
      XHXMCKZXIXNCKZAKZUDMZNOZUKZIXFQHXFQZUBRULZUDRQZUCXFQUAXFQZBCXFXFUMZGUNXDY
      FUAUCXFXFXDXHXFJZXMXFJZPZPZYEUDRYLYARJZPZYAUOUPKZRJZXJYONOZXOYONOZPZYBUKZ
      IXFQHXFQZYEYMYPYLYAUQURYNYTHIXFXFYNXIXFJZXNXFJZPZPZYSXJXOUSKZYANOZYBUUEXJ
      SJZXOSJZYASJZYSUUGUKUUEAXFUTLJZYIUUBUUHUUEXDUUKXDYKYMUUDVBZABXFYHEVAVCZYN
      YIUUDXDYIYJYMVDVEZYNUUBUUCVFZXHXIAXFVGTZUUEUUKYJUUCUUIUUMYNYJUUDXDYIYJYMV
      HVEZYNUUBUUCVIZXMXNAXFVGTZYMUUJYLUUDYAVLVJZXJXOYAVKTUUEXTUUFWMOZUUGYBUUEX
      HXIBVMLZKZXMXNUVBKZCKZBVNLZLZUVCUVFLZUVDUVFLZUSKZXTUUFWMUUEXDUVCXFJZUVDXF
      JZUVGUVJWMOUULUUEXDYIUUBUVKUULUUNUUOXHXIBUVBXFYHUVBUMZVOTUUEXDYJUUCUVLUUL
      UUQUURXMXNBUVBXFYHUVMVOTUVCUVDBCUVFXFYHGUVFUMZVPTUUEXTXRXSUVBKZUVFLZUVGUU
      EXDXRXFJZXSXFJZXTUVPVQUULUUEXDYIYJUVQUULUUNUUQXHXMBCXFYHGVRTZUUEXDUUBUUCU
      VRUULUUOUURXIXNBCXFYHGVRTZXRXSABUVBUVFXFYHUVMUVNEVSTUUEUVOUVEUVFUUEXDYIYJ
      UUBUUCUVOUVEVQUULUUNUUQUUOUURXHXMXIXNBCUVBXFYHGUVMVTWAWBWCUUEXJUVHXOUVIUS
      UUEXDYIUUBXJUVHVQUULUUNUUOXHXIABUVBUVFXFYHUVMUVNEVSTUUEXDYJUUCXOUVIVQUULU
      UQUURXMXNABUVBUVFXFYHUVMUVNEVSTWDWEUUEXTSJZUUFSJUUJUVAUUGPYBUKUUEUUKUVQUV
      RUWAUUMUVSUVTXRXSAXFVGTUUEXJXOUUPUUSWFUUTXTUUFYAWGTWHWIWJYDUUAUBYORXKYOVQ
      ZYCYTHIXFXFUWBXQYSYBUWBXLYQXPYRXKYOXJNWKXKYOXONWKWLWNWOWPWQWRWJXDAXFXCLJZ
      UWCUWCXEXGYGPWSABXFYHEWTZUWDUWDUAUCUDUBIHAAACDDDXFXFXFFFFXATXB $.
  $}

  ${
    $d d e x y C $.  $d d e x y J $.  $d d e x y K $.  $d d e x y N $.
    $d d e x y U $.
    nmcvcn.1 $e |- N = ( normCV ` U ) $.
    nmcvcn.2 $e |- C = ( IndMet ` U ) $.
    nmcvcn.j $e |- J = ( MetOpen ` C ) $.
    nmcvcn.k $e |- K = ( topGen ` ran (,) ) $.
    $( The norm of a normed complex vector space is a continuous function.
       (Contributed by NM, 16-May-2007.)  (Proof shortened by Mario Carneiro,
       10-Jan-2014.)  (New usage is discouraged.) $)
    nmcvcn $p |- ( U e. NrmCVec -> N e. ( J Cn K ) ) $=
      ( vx vy vd ve wcel co cfv cr crp eqid wa cnv ccn cba wf clt wbr cabs cmin
      cv ccom cxp cres wi wral wrex nvf simprr cle w3a nvcl anim12d remet metcl
      ex cme mp3an1 syl6 3impib imsmet syl3an1 c1 cneg cns nvabs wceq remetdval
      cpv syl imsdval2 3brtr4d jca31 3expa rpre lelttr expdimp syl2an ralrimdva
      an32s impr breq2 imbi1d ralbidv rspcev syl2anc ralrimivva cxmt wb imsxmet
      rexmet cioo crn ctg cmopn tgioo eqtri metcn sylancl mpbir2and ) BUANZECDU
      BONZBUCPZQEUDZJUIZKUIZAOZLUIZUEUFZXMEPZXNEPZUGUHUJQQUKULZOZMUIZUEUFZUMZKX
      KUNZLRUOZMRUNJXKUNZBEXKXKSZFUPXIYFJMXKRXIXMXKNZYBRNZTTYJXOYBUEUFZYCUMZKXK
      UNZYFXIYIYJUQXIYIYJYMXIYITZYJYLKXKYNXNXKNZTZYJYLYPYAQNZXOQNZTZYAXOURUFZTZ
      YBQNZYLYJXIYIYOUUAXIYIYOUSZYQYRYTXIYIYOYQXIYIYOTXRQNZXSQNZTZYQXIYIUUDYOUU
      EXIYIUUDXMBEXKYHFUTVDXIYOUUEXNBEXKYHFUTVDVAZXTQVEPNUUDUUEYQXTXTSZVBXRXSXT
      QVCVFVGVHXIAXKVEPNYIYOYRABXKYHGVIXMXNAXKVCVJUUCXRXSUHOUGPZXMVKVLXNBVMPZOB
      VQPZOEPYAXOURXMXNUUJBUUKEXKYHUUKSZUUJSZFVNUUCUUFYAUUIVOXIYIYOUUFUUGVHXRXS
      XTUUHVPVRXMXNAUUJBUUKEXKYHUULUUMFGVSVTWAWBYBWCYSUUBYTYLYSUUBTYTYKYCYQYRUU
      BYTYKTYCUMYAXOYBWDWBWEWHWFVDWGWIYEYMLYBRXPYBVOZYDYLKXKUUNXQYKYCXPYBXOUEWJ
      WKWLWMWNWOXIAXKWPPNXTQWPPNXJXLYGTWQABXKYHGWRXTUUHWSJMLKAXTECDXKQHDWTXAXBP
      XTXCPZIXTUUOUUHUUOSXDXEXFXGXH $.
  $}

  ${
    nmcnc.1 $e |- N = ( normCV ` U ) $.
    nmcnc.2 $e |- C = ( IndMet ` U ) $.
    nmcnc.j $e |- J = ( MetOpen ` C ) $.
    nmcnc.k $e |- K = ( TopOpen ` CCfld ) $.
    $( The norm of a normed complex vector space is a continuous function to
       ` CC ` .  (For ` RR ` , see ~ nmcvcn .)  (Contributed by NM,
       12-Aug-2007.)  (New usage is discouraged.) $)
    nmcnc $p |- ( U e. NrmCVec -> N e. ( J Cn K ) ) $=
      ( cnv wcel cr crest co ccn ctop wss cnfldtop cnrest2r ax-mp tgioo2 eqcomi
      cioo crn ctg cfv nmcvcn sseldi ) BJKCDLMNZONZCDONZEDPKUJUKQDIRLCDSTABCUIE
      FGHUCUDUEUFUIDIUAUBUGUH $.
  $}

  ${
    $d r s w x y z C $.  $d r s w x y z J $.  $d s w z T $.  $d r x y U $.
    $d r s w x y z K $.  $d r s w x y z S $.  $d r s w x y z X $.
    smcn.c $e |- C = ( IndMet ` U ) $.
    smcn.j $e |- J = ( MetOpen ` C ) $.
    smcn.s $e |- S = ( .sOLD ` U ) $.
    smcn.k $e |- K = ( TopOpen ` CCfld ) $.
    ${
      smcn.x $e |- X = ( BaseSet ` U ) $.
      smcn.n $e |- N = ( normCV ` U ) $.
      smcn.u $e |- U e. NrmCVec $.
      smcn.t $e |- T = ( 1 / ( 1 + ( ( ( ( N ` y ) +
                         ( abs ` x ) ) + 1 ) / r ) ) ) $.
      $( Lemma for ~ smcn .  (Contributed by Mario Carneiro, 5-May-2014.)
         (Revised by Mario Carneiro, 10-Sep-2015.)
         (New usage is discouraged.) $)
      smcnlem $p |- S e. ( ( K tX J ) Cn J ) $=
        ( co vz vs vw ctx ccn wcel cc cxp wf cv cabs cmin ccom clt wbr wral crp
        wa wi wrex cnv nvsf ax-mp c1 cfv caddc cdiv cr simpr nvcl sylancr abscl
        1rp adantr readdcld cc0 cle nvge0 absge0 addge0d ge0p1rpd rpdivcl sylan
        rpaddcl rpreccld syl5eqel cme a1i simplll simpllr nvscl syl3anc simprll
        imsmet simprlr metcl rpre ad2antlr mettri syl13anc cmul abscld peano2re
        syl rpred remulcld cnsb eqid nvmcl abssubd wceq cnmetdval syl2anc eqtrd
        simprrl eqbrtrrd ltled eqbrtrd lemul1ad mulcomd breqtrd absge0d pncan3d
        subcld rpcnd recnd fveq2d abstrid 1re imsdval cneg neg1cn oveq2d oveq1d
        letrd nvs 3eqtr2d lelttrd breq2 cxmt ltaddrp recgt1d syl5eqbr lemul12ad
        mpbid leadd2dd simprrr le2addd cpv imsdval2 mulcl mulm1d negsubd nvsass
        nvdir 3eqtr3d nvmdi oveq12d ax-1cn addassd adddird rpne0d oveq2i simplr
        3brtr4d divrecd syl6reqr ltp1d addcomd ltdiv23d expr ralrimivva anbi12d
        imbi1d 2ralbidv rspcev ralrimiva rgen2 cnxmet imsxmet cnfldtopn txmetcn
        wb mp3an mpbir2an ) DHGUDTGUETUFZUGJUHJDUIZAUJZUAUJZUKULUMZTZUBUJZUNUOZ
        BUJZUCUJZCTZUWLUNUOZURZUWHUWNDTZUWIUWODTZCTZKUJZUNUOZUSZUCJUPUAUGUPZUBU
        QUTZKUQUPZBJUPAUGUPZFVAUFZUWGRDFJPNVBVCUXGABUGJUWHUGUFZUWNJUFZURZUXFKUQ
        UXLUXBUQUFZURZEUQUFZUWKEUNUOZUWPEUNUOZURZUXCUSZUCJUPUAUGUPZUXFUXNEVDVDU
        WNIVEZUWHUKVEZVFTZVDVFTZUXBVGTZVFTZVGTZUQSUXNUYFUXNVDUQUFUYEUQUFZUYFUQU
        FZVMUXLUYDUQUFUXMUYHUXLUYCUXLUYAUYBUXLUXIUXKUYAVHUFZRUXJUXKVIZUWNFIJPQV
        JZVKZUXJUYBVHUFZUXKUWHVLVNZVOUXLUYAUYBUYMUYOUXLUXIUXKVPUYAVQUOZRUYKUWNF
        IJPQVRZVKUXJVPUYBVQUOUXKUWHVSVNVTWAUYDUXBWBWCZVDUYEWDVKZWEWFZUXNUXSUAUC
        UGJUXNUWIUGUFZUWOJUFZURZUXRUXCUXNVUCUXRURZURZUXAUWSUWIUWNDTZCTZVUFUWTCT
        ZVFTZUXBVUECJWGVEUFZUWSJUFZUWTJUFZUXAVHUFVUJVUEUXIVUJRCFJPLWNVCWHZVUEUX
        IUXJUXKVUKUXIVUERWHZUXJUXKUXMVUDWIZUXJUXKUXMVUDWJZUWHUWNDFJPNWKWLZVUEUX
        IVUAVUBVULVUNUXNVUAVUBUXRWMZUXNVUAVUBUXRWOZUWIUWODFJPNWKWLZUWSUWTCJWPWL
        VUEVUGVUHVUEVUJVUKVUFJUFZVUGVHUFVUMVUQVUEUXIVUAUXKVVAVUNVURVUPUWIUWNDFJ
        PNWKWLZUWSVUFCJWPWLVUEVUJVVAVULVUHVHUFVUMVVBVUTVUFUWTCJWPWLVOZUXMUXBVHU
        FUXLVUDUXBWQWRZVUEVUJVUKVULVVAUXAVUIVQUOVUMVUQVUTVVBUWSUWTVUFCJWSWTVUEV
        UIUYDEXATZUXBVVCVUEUYDEVUEUYCVHUFUYDVHUFVUEUYAUYBVUEUXIUXKUYJRVUPUYLVKZ
        VUEUWHVUOXBZVOUYCXCXDZVUEEUXNUXOVUDUYTVNZXEZXFVVDVUEUWHUWIULTZUKVEZUYAX
        ATZUWIUKVEZUWNUWOFXGVEZTZIVEZXATZVFTUYAEXATZUYBVDVFTZEXATZVFTZVUIVVEVQV
        UEVVMVVRVVSVWAVUEVVLUYAVUEVVKVUEUWHUWIVUOVURYDZXBZVVFXFVUEVVNVVQVUEUWIV
        URXBZVUEUXIVVPJUFZVVQVHUFRVUEUXIUXKVUBVWFVUNVUPVUSUWNUWOFVVOJPVVOXHZXIW
        LZVVPFIJPQVJVKZXFVUEUYAEVVFVVJXFVUEVVTEVUEUYNVVTVHUFVVGUYBXCXDZVVJXFVUE
        VVMEUYAXATVVSVQVUEVVLEUYAVWDVVJVVFVUEUXIUXKUYPRVUPUYQVKVUEVVLUWIUWHULTZ
        UKVEZEVQVUEUWHUWIVUOVURXJZVUEVWLEVUEVWKVUEUWIUWHVURVUOYDZXBZVVJVUEUWKVW
        LEUNVUEUWKVVLVWLVUEUXJVUAUWKVVLXKVUOVURUWHUWIUWJUWJXHXLXMVWMXNUXNVUCUXP
        UXQXOXPXQZXRXSVUEEUYAVUEEVVIYEZVUEUYAVVFYFZXTYAVUEVVNVVTVVQEVWEVWJVWIVV
        JVUEUWIVURYBVUEUXIVWFVPVVQVQUORVWHVVPFIJPQVRVKVUEVVNUYBVWLVFTZVVTVWEVUE
        UYBVWLVVGVWOVOVWJVUEUWHVWKVFTZUKVEVVNVWSVQVUEVWTUWIUKVUEUWHUWIVUOVURYCY
        GVUEUWHVWKVUOVWNYHXPVUEVWLVDUYBVWOVDVHUFZVUEYIWHZVVGVUEVWLEVDVWOVVJVXBV
        WPVUEEVDVVJVXBVUEEUYGVDUNSVUEVDUYFUNUOZUYGVDUNUOVUEVXAUYHVXCYIUXNUYHVUD
        UYRVNZVDUYEUUAVKVUEUYFUXNUYIVUDUYSVNZUUBUUEUUCXQYOUUFYOVUEVVQEVWIVVJVUE
        UWPVVQEUNVUEUXIUXKVUBUWPVVQXKVUNVUPVUSUWNUWOCFVVOIJPVWGQLYJWLUXNVUCUXPU
        XQUUGXPXQUUDUUHVUEVUGVVMVUHVVRVFVUEVUGUWSVDYKZVUFDTZFUUIVEZTZIVEZVVKUWN
        DTZIVEZVVMVUEUXIVUKVVAVUGVXJXKVUNVUQVVBUWSVUFCDFVXHIJPVXHXHZNQLUUJWLVUE
        VXKVXIIVUEUWHVXFUWIXATZVFTZUWNDTZUWSVXNUWNDTZVXHTZVXKVXIVUEUXIUXJVXNUGU
        FZUXKVXPVXRXKVUNVUOVUEVXFUGUFZVUAVXSYLVURVXFUWIUUKVKVUPUWHVXNUWNDFVXHJP
        VXMNUUOWTVUEVXOVVKUWNDVUEVXOUWHUWIYKZVFTVVKVUEVXNVYAUWHVFVUEUWIVURUULYM
        VUEUWHUWIVUOVURUUMXNYNVUEVXQVXGUWSVXHVUEUXIVXTVUAUXKVXQVXGXKVUNVXTVUEYL
        WHVURVUPVXFUWIUWNDFJPNUUNWTYMUUPYGVUEUXIVVKUGUFUXKVXLVVMXKVUNVWCVUPVVKU
        WNDFIJPNQYPWLYQVUEVUHVUFUWTVVOTZIVEZUWIVVPDTZIVEZVVRVUEUXIVVAVULVUHVYCX
        KVUNVVBVUTVUFUWTCFVVOIJPVWGQLYJWLVUEVYDVYBIVUEUXIVUAUXKVUBVYDVYBXKVUNVU
        RVUPVUSUWIUWNUWODFVVOJPVWGNUUQWTYGVUEUXIVUAVWFVYEVVRXKVUNVURVWHUWIVVPDF
        IJPNQYPWLYQUURVUEVVEUYAVVTVFTZEXATVWBVUEUYDVYFEXAVUEUYAUYBVDVWRVUEUYBVV
        GYFVDUGUFVUEUUSWHZUUTYNVUEUYAVVTEVWRVUEVVTVWJYFVWQUVAXNUVEVUEVVEUYDUYFV
        GTZUXBUNVUEVYHUYDUYGXATVVEVUEUYDUYFVUEUYDVVHYFVUEUYFVXEYEVUEUYFVXEUVBUV
        FEUYGUYDXASUVCUVGVUEUYDUXBUYFVVHUXLUXMVUDUVDVXEVUEUYEUYEVDVFTUYFUNVUEUY
        EVUEUYEVXDXEUVHVUEUYEVDVUEUYEVXDYEVYGUVIYAUVJXRYRYRUVKUVLUXEUXTUBEUQUWL
        EXKZUXDUXSUAUCUGJVYIUWRUXRUXCVYIUWMUXPUWQUXQUWLEUWKUNYSUWLEUWPUNYSUVMUV
        NUVOUVPXMUVQUVRUWJUGYTVEUFCJYTVEUFZVYJUWFUWGUXHURUWCUVSUXIVYJRCFJPLUVTV
        CZVYKABKUBUCUAUWJCCDHGGUGJJHOUWAMMUWBUWDUWE $.
    $}

    $( Scalar multiplication is jointly continuous in both arguments.
       (Contributed by NM, 16-Jun-2009.)  (Revised by Mario Carneiro,
       5-May-2014.)  (New usage is discouraged.) $)
    smcn $p |- ( U e. NrmCVec -> S e. ( ( K tX J ) Cn J ) ) $=
      ( wcel ctx co ccn caddc cns cfv cims cmopn syl5eq eqid vx vy cnv cmul cop
      vr cabs cif wceq fveq2 fveq2d oveq2d oveq12d eleq12d c1 cv cnmcv cdiv cba
      elimnvu smcnlem dedth ) CUCJZBEDKLZDMLZJVCCNUDUEUGUEZUHZOPZEVGQPZRPZKLZVJ
      MLZJCVFCVGUIZBVHVEVLVMBCOPVHHCVGOUJSVMVDVKDVJMVMDVJEKVMDARPVJGVMAVIRVMACQ
      PVIFCVGQUJSUKSZULVNUMUNUAUBVIVHUOUOUBUPVGUQPZPUAUPUGPNLUONLUFUPURLNLURLZV
      GVJEVOVGUSPZUFVITVJTVHTIVQTVOTCUTVPTVAVB $.
  $}

  ${
    $d x y J $.  $d x y M $.  $d x y U $.
    vmcn.c $e |- C = ( IndMet ` U ) $.
    vmcn.j $e |- J = ( MetOpen ` C ) $.
    vmcn.m $e |- M = ( -v ` U ) $.
    $( Vector subtraction is jointly continuous in both arguments.
       (Contributed by Mario Carneiro, 6-May-2014.)
       (New usage is discouraged.) $)
    vmcn $p |- ( U e. NrmCVec -> M e. ( ( J tX J ) Cn J ) ) $=
      ( vx vy cnv wcel cba cfv cv co eqid ctopon cc a1i cnmpt22f cneg cns cmpt2
      cpv ctx ccn nvmfval cxmt imsxmet mopntopon syl cnmpt1st ccnfld cnfldtopon
      c1 ctopn neg1cn cnmpt2c cnmpt2nd smcn vacn eqeltrd ) BJKZDHIBLMZVDHNZUOUA
      ZINZBUBMZOZBUDMZOUCCCUEOCUFOHIVHBVJDVDVDPZVJPZVHPZGUGVCHIVEVIVJCCCCCVDVDV
      CAVDUHMKCVDQMKABVDVKEUIACVDFUJUKZVNVCHICCVDVDVNVNULVCHIVFVGVHCCUMUPMZCCVD
      VDVNVNVCHIVFCCVOVDVDRVNVNVORQMKVCVOVOPZUNSVFRKVCUQSURVCHICCVDVDVNVNUSAVHB
      CVOEFVMVPUTTABVJCEFVLVATVB $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Inner product
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c .iOLD $.

  $( Extend class notation with the class inner product functions. $)
  cdip $a class .iOLD $.

  ${
    $d k n p u w x y z $.
    $( Define a function that maps a complex normed vector space to its inner
       product operation in case its norm satisfies the parallelogram identity
       (otherwise the operation is still defined, but not meaningful).  Based
       on Exercise 4(a) of [ReedSimon] p. 63 and Theorem 6.44 of [Ponnusamy]
       p. 361.  Vector addition is ` ( 1st `` w ) ` , the scalar product is
       ` ( 2nd `` w ) ` , and the norm is ` n ` .  (Contributed by NM,
       10-Apr-2007.)  (New usage is discouraged.) $)
    df-dip $a |- .iOLD = ( u e. NrmCVec |->
      ( x e. ( BaseSet ` u ) , y e. ( BaseSet ` u ) |->
    ( sum_ k e. ( 1 ... 4 ) ( ( _i ^ k ) x. ( ( ( normCV ` u ) ` ( x ( +v ` u )
        ( ( _i ^ k ) ( .sOLD ` u ) y ) ) ) ^ 2 ) ) / 4 ) ) ) $.

$(
    df-dip $a |- .iOLD = { <. x , y >. | ( x e. NrmCVec /\ E. g E. s E. n
            ( x = <. <. g , s >. , n >. /\ y = { <. <. a , b >. , c >. |
            ( ( a e. dom n /\ b e. dom n ) /\ c = ( sum_ k e. ( 1 ... 4 )
             ( ( _i ^ k ) x. ( ( n ` ( a g ( ( _i ^ k ) s b ) ) ) ^ 2 ) )
              / 4 ) ) } ) ) } $.

    df-dip $a |- .iOLD = { <. x , y >. | ( x e. NrmCVec /\ E. g E. s E. n
            ( x = <. <. g , s >. , n >. /\ y = { <. <. a , b >. , c >. |
            ( ( a e. dom n /\ b e. dom n ) /\ c =
                ( ( ( ( ( n ` ( a g b ) ) ^ 2 ) +
                ( ( n ` ( a g ( -u 1 s b ) ) ) ^ 2 ) ) +
                ( _i x. ( ( ( n ` ( a g ( _i s b ) ) ) ^ 2 ) +
                ( ( n ` ( a g ( -u _i s b ) ) ) ^ 2 ) ) ) ) / 4 ) ) } ) ) } $.
$)
  $}

  ${
    $d k u x y G $.  $d k u x y N $.  $d k u x y S $.  $d k u x y U $.
    $d k x y A $.  $d k x y B $.  $d k u x y X $.
    dipfval.1 $e |- X = ( BaseSet ` U ) $.
    dipfval.2 $e |- G = ( +v ` U ) $.
    dipfval.4 $e |- S = ( .sOLD ` U ) $.
    dipfval.6 $e |- N = ( normCV ` U ) $.
    dipfval.7 $e |- P = ( .iOLD ` U ) $.
    $( The inner product function on a normed complex vector space.  The
       definition is meaningful for vector spaces that are also inner product
       spaces, i.e. satisfy the parallelogram law.  (Contributed by NM,
       10-Apr-2007.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    dipfval $p |- ( U e. NrmCVec -> P = ( x e. X , y e. X |->
      ( sum_ k e. ( 1 ... 4 ) ( ( _i ^ k ) x.
        ( ( N ` ( x G ( ( _i ^ k ) S y ) ) ) ^ 2 ) ) / 4 ) ) ) $=
      ( cfv c4 co cv cexp cba vu cnv wcel cdip c1 cfz ci c2 cmul csu cdiv cmpt2
      cns cpv cnmcv fveq2 syl6eqr eqidd oveqd oveq123d fveq12d oveq1d sumeq2sdv
      wceq oveq2d mpt2eq123dv df-dip cvv fvex eqeltri mpt2ex fvmpt syl5eq ) EUB
      UCCEUDOABIIUEPUFQZUGFRSQZARZVOBRZDQZGQZHOZUHSQZUIQZFUJZPUKQZULZNUAEABUARZ
      TOZWGVNVOVPVOVQWFUMOZQZWFUNOZQZWFUOOZOZUHSQZUIQZFUJZPUKQZULWEUBUDWFEVDZAB
      WGWGWQIIWDWRWGETOZIWFETUPJUQZWTWRWPWCPUKWRVNWOWBFWRWNWAVOUIWRWMVTUHSWRWKV
      SWLHWRWLEUOOHWFEUOUPMUQWRVPVPWIVRWJGWRWJEUNOGWFEUNUPKUQWRVPURWRWHDVOVQWRW
      HEUMODWFEUMUPLUQUSUTVAVBVEVCVBVFABUAFVGABIIWDIWSVHJETVIVJZXAVKVLVM $.

    $( Value of the inner product.  The definition is meaningful for normed
       complex vector spaces that are also inner product spaces, i.e. satisfy
       the parallelogram law, although for convenience we define it for any
       normed complex vector space.  The vector (group) addition operation is
       ` G ` , the scalar product is ` S ` , the norm is ` N ` , and the set of
       vectors is ` X ` .  Equation 6.45 of [Ponnusamy] p. 361.  (Contributed
       by NM, 31-Jan-2007.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    ipval $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A P B ) =
                ( sum_ k e. ( 1 ... 4 ) ( ( _i ^ k ) x. ( ( N ` ( A G
                    ( ( _i ^ k ) S B ) ) ) ^ 2 ) ) / 4 ) ) $=
      ( co c4 cexp c2 cmul cdiv vx vy cnv wcel c1 cfz ci cv cfv wceq wa dipfval
      cmpt2 oveqd oveq1 fveq2d oveq1d oveq2d sumeq2sdv oveq2 eqid ovex sylan9eq
      csu ovmpt2 3impb ) EUCUDZAIUDZBIUDZABCOZUEPUFOZUGFUHQOZAVLBDOZGOZHUIZRQOZ
      SOZFVDZPTOZUJVGVHVIUKVJABUAUBIIVKVLUAUHZVLUBUHZDOZGOZHUIZRQOZSOZFVDZPTOZU
      MZOVSVGCWIABUAUBCDEFGHIJKLMNULUNUAUBABIIWHVSWIVKVLAWBGOZHUIZRQOZSOZFVDZPT
      OVTAUJZWGWNPTWOVKWFWMFWOWEWLVLSWOWDWKRQWOWCWJHVTAWBGUOUPUQURUSUQWABUJZWNV
      RPTWPVKWMVQFWPWLVPVLSWPWKVORQWPWJVNHWPWBVMAGWABVLDUTURUPUQURUSUQWIVAVRPTV
      BVEVCVF $.

    $( Lemma for ~ ipval3 .  (Contributed by NM, 1-Feb-2007.)
       (New usage is discouraged.) $)
    ipval2lem2 $p |- ( ( ( U e. NrmCVec /\ A e. X /\ B e. X ) /\ C e. CC ) ->
               ( ( N ` ( A G ( C S B ) ) ) ^ 2 ) e. RR ) $=
      ( cnv wcel w3a cc wa co cfv cr simpl1 simpl2 nvscl 3expa 3adantl2 syl3anc
      3com23 nvgcl nvcl syl2anc resqcld ) FOPZAIPZBIPZQCRPZSZACBETZGTZHUAZURUNU
      TIPZVAUBPUNUOUPUQUCZURUNUOUSIPZVBVCUNUOUPUQUDUNUPUQVDUOUNUPUQVDUNUQUPVDCB
      EFIJLUEUIUFUGAUSFGIJKUJUHUTFHIJMUKULUM $.

    $( Lemma for ~ ipval3 .  (Contributed by NM, 1-Feb-2007.)
       (New usage is discouraged.) $)
    ipval2lem3 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( ( N ` ( A G B ) ) ^ 2 ) e. RR ) $=
      ( wcel c1 co cfv c2 cexp cr cnv w3a wa nvsid oveq2d fveq2d oveq1d 3adant2
      wceq cc ax-1cn ipval2lem2 mpan2 eqeltrrd ) EUANZAHNZBHNZUBZAOBDPZFPZGQZRS
      PZABFPZGQZRSPZTUOUQVBVEUIUPUOUQUCZVAVDRSVFUTVCGVFUSBAFBDEHIKUDUEUFUGUHURO
      UJNVBTNUKABOCDEFGHIJKLMULUMUN $.

    $( Lemma for ~ ipval3 .  (Contributed by NM, 1-Feb-2007.)
       (New usage is discouraged.) $)
    ipval2lem4 $p |- ( ( ( U e. NrmCVec /\ A e. X /\ B e. X ) /\ C e. CC ) ->
               ( ( N ` ( A G ( C S B ) ) ) ^ 2 ) e. CC ) $=
      ( cnv wcel w3a cc wa co cfv c2 cexp ipval2lem2 recnd ) FOPAIPBIPQCRPSACBE
      TGTHUAUBUCTABCDEFGHIJKLMNUDUE $.

    $( Expansion of the inner product value ~ ipval .  (Contributed by NM,
       31-Jan-2007.)  (Revised by Mario Carneiro, 5-May-2014.)
       (New usage is discouraged.) $)
    ipval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A P B )
               = ( ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) +
               ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u _i S B ) ) ) ^ 2 ) ) ) ) / 4 ) ) $=
      ( wcel co c1 ci cexp c2 cmul vk cnv w3a c4 cfz cv cfv csu cdiv cneg caddc
      cmin ipval cc ax-icn ipval2lem4 mpan2 mulcl sylancr neg1cn subcld negsubd
      negcli mulm1d oveq2d mulneg1 oveq12d mp3an1 syl2anc oveq1d sub32d 3eqtr4d
      eqtrd wceq subdi wa nvsid fveq2d 3adant2 ipval2lem3 recnd mulid2d cn nnuz
      c3 df-4 oveq2 i4 syl6eq cn0 nnnn0 expcl adantl sylan2 mulcld df-3 i3 df-2
      i2 cz 1z exp1 ax-mp fsum1 1nn jctil eqidd fsump1i simprd subadd23d eqtr4d
      addcomd ) EUBNZAHNZBHNZUCZABCOPUDUEOQUAUFZROZAXRBDOZFOZGUGZSROZTOZUAUHZUD
      UIOABFOZGUGZSROZAPUJZBDOZFOZGUGZSROZULOZQAQBDOZFOZGUGZSROZAQUJZBDOZFOZGUG
      ZSROZULOZTOZUKOZUDUIOABCDEUAFGHIJKLMUMXPYDUUEUDUIXPQYQTOZYHYLTOZUKOZYRUUB
      TOZUKOZPAPBDOZFOZGUGZSROZTOZUKOZUUDYLULOZYGUKOZYDUUEXPUUJUUQUUOYGUKXPUUFY
      LULOZQUUBTOZUJZUKOUUSUUTULOZUUJUUQXPUUSUUTXPUUFYLXPQUNNZYQUNNZUUFUNNZUOXP
      UVCUVDUOABQCDEFGHIJKLMUPUQZQYQURUSZXPYHUNNYLUNNUTABYHCDEFGHIJKLMUPUQZVAXP
      UVCUUBUNNZUUTUNNUOXPYRUNNUVIQUOVCABYRCDEFGHIJKLMUPUQZQUUBURUSZVBXPUUHUUSU
      UIUVAUKXPUUHUUFYLUJZUKOUUSXPUUGUVLUUFUKXPYLUVHVDVEXPUUFYLUVGUVHVBVMXPUVCU
      VIUUIUVAVNUOUVJQUUBVFUSVGXPUUQUUFUUTULOZYLULOUVBXPUUDUVMYLULXPUVDUVIUUDUV
      MVNZUVFUVJUVCUVDUVIUVNUOQYQUUBVOVHVIVJXPUUFUUTYLUVGUVKUVHVKVMVLXPUUOPYGTO
      YGXPUUNYGPTXMXOUUNYGVNXNXMXOVPZUUMYFSRUVOUULYEGUVOUUKBAFBDEHIKVQVEVRVJVSV
      EXPYGXPYGABCDEFGHIJKLMVTWAZWBVMVGXPUDWCNYDUUPVNXPYCUUOUUJUUPUAWEPUDWCWDWF
      XQUDVNZXRPYBUUNTUVQXRQUDROPXQUDQRWGWHWIZUVQYAUUMSRUVQXTUULGUVQXSUUKAFUVQX
      RPBDUVRVJVEVRVJVGXPXQWCNZVPXRYBUVSXRUNNZXPUVSUVCXQWJNUVTUOXQWKQXQWLUSZWMU
      VSXPUVTYBUNNUWAABXRCDEFGHIJKLMUPWNWOZXPYCUUIUUHUUJUASPWEWCWDWPXQWEVNZXRYR
      YBUUBTUWCXRQWEROYRXQWEQRWGWQWIZUWCYAUUASRUWCXTYTGUWCXSYSAFUWCXRYRBDUWDVJV
      EVRVJVGUWBXPYCUUGUUFUUHUAPPSWCWDWRXQSVNZXRYHYBYLTUWEXRQSROYHXQSQRWGWSWIZU
      WEYAYKSRUWEXTYJGUWEXSYIAFUWEXRYHBDUWFVJVEVRVJVGUWBXPPPUEOYCUAUHUUFVNZPWCN
      XPPWTNUVEUWGXAUVGYCUUFUAPXQPVNZXRQYBYQTUWHXRQPROZQXQPQRWGUVCUWIQVNUOQXBXC
      WIZUWHYAYPSRUWHXTYOGUWHXSYNAFUWHXRQBDUWJVJVEVRVJVGXDUSXEXFXPUUHXGXHXPUUJX
      GXHXPUUPXGXHXIXPUUEUUDYMUKOUURXPYMUUDXPYGYLUVPUVHVAXPUVCUUCUNNUUDUNNUOXPY
      QUUBUVFUVJVAQUUCURUSZXLXPUUDYLYGUWKUVHUVPXJXKVLVJVM $.

    $( Four times the inner product value ~ ipval3 , useful for simplifying
       certain proofs.  (Contributed by NM, 10-Apr-2007.)
       (New usage is discouraged.) $)
    4ipval2 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
        ( 4 x. ( A P B ) ) = ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) +
               ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
               ( ( N ` ( A G ( -u _i S B ) ) ) ^ 2 ) ) ) ) ) $=
      ( wcel c4 co cmul cfv ci cc cnv w3a c2 cexp cneg cmin caddc ipval2 oveq2d
      c1 cdiv wceq cr simp1 nvgcl nvcl syl2anc recnd sqcld neg1cn nvscl 3adant2
      mp3an2 syld3an3 subcld ax-icn negcli mulcl sylancr addcld cc0 wne 4cn 4re
      4pos gt0ne0ii divcan2 mp3an23 syl eqtrd ) EUANZAHNZBHNZUBZOABCPZQPOABFPZG
      RZUCUDPZAUJUEZBDPZFPZGRZUCUDPZUFPZSASBDPZFPZGRZUCUDPZASUEZBDPZFPZGRZUCUDP
      ZUFPZQPZUGPZOUKPZQPZXFWDWEXGOQABCDEFGHIJKLMUHUIWDXFTNZXHXFULZWDWNXEWDWHWM
      WDWGWDWGWDWAWFHNWGUMNWAWBWCUNZABEFHIJUOWFEGHILUPUQURUSWDWLWDWLWDWAWKHNZWL
      UMNXKWAWBWCWJHNZXLWAWCXMWBWAWITNWCXMUTWIBDEHIKVAVCVBAWJEFHIJUOVDWKEGHILUP
      UQURUSVEWDSTNZXDTNXETNVFWDWRXCWDWQWDWQWDWAWPHNZWQUMNXKWAWBWCWOHNZXOWAWCXP
      WBWAXNWCXPVFSBDEHIKVAVCVBAWOEFHIJUOVDWPEGHILUPUQURUSWDXBWDXBWDWAXAHNZXBUM
      NXKWAWBWCWTHNZXQWAWCXRWBWAWSTNWCXRSVFVGWSBDEHIKVAVCVBAWTEFHIJUOVDXAEGHILU
      PUQURUSVESXDVHVIVJXIOTNOVKVLXJVMOVNVOVPXFOVQVRVSVT $.

    ${
      ipval3.3 $e |- M = ( -v ` U ) $.
      $( Expansion of the inner product value ~ ipval .  (Contributed by NM,
         17-Nov-2007.)  (New usage is discouraged.) $)
      ipval3 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) -> ( A P B )
               = ( ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
               ( ( N ` ( A M B ) ) ^ 2 ) ) +
               ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
               ( ( N ` ( A M ( _i S B ) ) ) ^ 2 ) ) ) ) / 4 ) ) $=
        ( wcel co c2 cexp ci cnv w3a cfv c1 cneg cmin cmul caddc c4 cdiv ipval2
        nvmval fveq2d oveq1d oveq2d wceq cc ax-icn nvscl mp3an2 syld3an3 mulm1i
        3adant2 wa oveq1i neg1cn nvsass mp3anr1 mpanr1 syl5reqr oveq12d eqtr4d
        eqtrd ) EUAPZAIPZBIPZUBZABCQABFQHUCRSQZAUDUEZBDQFQZHUCZRSQZUFQZTATBDQZF
        QHUCRSQZATUEZBDQZFQZHUCZRSQZUFQZUGQZUHQZUIUJQVRABGQZHUCZRSQZUFQZTWEAWDG
        QZHUCZRSQZUFQZUGQZUHQZUIUJQABCDEFHIJKLMNUKVQXCWMUIUJVQWQWCXBWLUHVQWPWBV
        RUFVQWOWARSVQWNVTHABDEFGIJKLOULUMUNUOVQXAWKTUGVQWTWJWEUFVQWSWIRSVQWRWHH
        VQWRAVSWDDQZFQZWHVNVOVPWDIPZWRXEUPVNVPXFVOVNTUQPZVPXFURTBDEIJLUSUTVCAWD
        DEFGIJKLOULVAVQXDWGAFVNVPXDWGUPVOVNVPVDWGVSTUGQZBDQZXDXHWFBDTURVBVEVNXG
        VPXIXDUPZURVNVSUQPXGVPXJVFVSTBDEIJLVGVHVIVJVCUOVMUMUNUOUOVKUNVL $.

      $( Lemma for ~ ipval3 .  (Contributed by NM, 1-Feb-2008.)
         (New usage is discouraged.) $)
      ipval2lem5 $p |- ( ( ( U e. NrmCVec /\ A e. X /\ B e. X ) /\ C e. CC ) ->
                 ( ( N ` ( A M ( C S B ) ) ) ^ 2 ) e. RR ) $=
        ( cnv wcel w3a co cc wa cfv cr simpl1 simpl2 nvscl 3expa 3adantl2 nvmcl
        3com23 syl3anc nvcl syl2anc resqcld ) FQRZAJRZBJRZSCUARZUBZACBETZHTZIUC
        ZUTUPVBJRZVCUDRUPUQURUSUEZUTUPUQVAJRZVDVEUPUQURUSUFUPURUSVFUQUPURUSVFUP
        USURVFCBEFJKMUGUKUHUIAVAFHJKPUJULVBFIJKNUMUNUO $.

      $( Lemma for ~ ipval3 .  (Contributed by NM, 1-Feb-2008.)
         (New usage is discouraged.) $)
      ipval2lem6 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                 ( ( N ` ( A M B ) ) ^ 2 ) e. RR ) $=
        ( wcel c1 co c2 cexp cnv w3a cfv cr wceq wa nvsid oveq2d fveq2d 3adant2
        oveq1d cc ax-1cn ipval2lem5 mpan2 eqeltrrd ) EUAPZAIPZBIPZUBZAQBDRZGRZH
        UCZSTRZABGRZHUCZSTRZUDUQUSVDVGUEURUQUSUFZVCVFSTVHVBVEHVHVABAGBDEIJLUGUH
        UIUKUJUTQULPVDUDPUMABQCDEFGHIJKLMNOUNUOUP $.

      $( Four times the inner product value ~ ipval3 , useful for simplifying
         certain proofs.  (Contributed by NM, 1-Feb-2008.)
         (New usage is discouraged.) $)
      4ipval3 $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
          ( 4 x. ( A P B ) ) = ( ( ( ( N ` ( A G B ) ) ^ 2 ) -
                 ( ( N ` ( A M B ) ) ^ 2 ) ) +
                 ( _i x. ( ( ( N ` ( A G ( _i S B ) ) ) ^ 2 ) -
                 ( ( N ` ( A M ( _i S B ) ) ) ^ 2 ) ) ) ) ) $=
        ( wcel c4 co ci cc cnv w3a cmul cfv c2 cexp cmin caddc cdiv ipval3 wceq
        oveq2d ipval2lem3 recnd ipval2lem6 subcld ax-icn ipval2lem2 mpan2 mulcl
        ipval2lem5 sylancr addcld cc0 wne 4cn 4re 4pos gt0ne0ii divcan2 mp3an23
        cr syl eqtrd ) EUAPAIPBIPUBZQABCRZUCRQABFRHUDUEUFRZABGRHUDUEUFRZUGRZSAS
        BDRZFRHUDUEUFRZAVTGRHUDUEUFRZUGRZUCRZUHRZQUIRZUCRZWEVOVPWFQUCABCDEFGHIJ
        KLMNOUJULVOWETPZWGWEUKZVOVSWDVOVQVRVOVQABCDEFHIJKLMNUMUNVOVRABCDEFGHIJK
        LMNOUOUNUPVOSTPZWCTPWDTPUQVOWAWBVOWAVOWJWAVLPUQABSCDEFHIJKLMNURUSUNVOWB
        VOWJWBVLPUQABSCDEFGHIJKLMNOVAUSUNUPSWCUTVBVCWHQTPQVDVEWIVFQVGVHVIWEQVJV
        KVMVN $.
    $}
  $}

  ${
    $d k n p w x y z G $.  $d k n p w x y z N $.  $d k n p w x y z S $.
    $d k n p w x y z U $.  $d k x y z A $.  $d k x y z B $.  $d x y z X $.
    ipid.1 $e |- X = ( BaseSet ` U ) $.
    ipid.6 $e |- N = ( normCV ` U ) $.
    ipid.7 $e |- P = ( .iOLD ` U ) $.
    $( The inner product of a vector with itself is the square of the vector's
       norm.  Equation I4 of [Ponnusamy] p. 362.  (Contributed by NM,
       1-Feb-2007.)  (New usage is discouraged.) $)
    ipidsq $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                ( A P A ) = ( ( N ` A ) ^ 2 ) ) $=
      ( wcel co cfv c2 cexp c1 ci cmul caddc wceq cc0 cc cnv wa cpv cneg cns c4
      cmin cdiv eqid ipval2 3anidm23 nv2 fveq2d cr cle wbr ltleii pm3.2i nvsge0
      2re 0re 2pos mp3an2 eqtrd oveq1d nvcl cn0 2cn 2nn0 mulexp mp3an13 syl sq2
      recnd oveq1i syl6eq cn0v nvrinv nvz0 adantr sq0id oveq12d 4cn sqcld mulcl
      sylancr subid1d cabs csqr renegcli absreim ax-icn ax-1cn mulneg2i mulid1i
      1re mp2an negeqi eqtri oveq2i fveq2i sqneg 3eqtr3i 3eqtr2i negcli 3eqtr4a
      ax-mp addcli nvs nvdir mp3anr1 mpanr1 nvsid 3eqtr3d oveq2d w3a ipval2lem4
      mpan2 subidd mul01i addid1d wne 4re 4pos gt0ne0ii divcan3 mp3an23 3eqtr2d
      eqtr2d ) CUAIZAEIZUBZAABJZAACUCKZJZDKZLMJZANUDZACUEKZJYNJZDKZLMJZUGJZOAOA
      YSJZYNJZDKZLMJZAOUDZAYSJZYNJZDKZLMJZUGJZPJZQJZUFUHJZUFADKZLMJZPJZUFUHJZUU
      RYJYKYMUUPRAABYSCYNDEFYNUIZYSUIZGHUJUKYLUUSUUOUFUHYLUUOUUSSQJUUSYLUUCUUSU
      UNSQYLUUCUUSSUGJUUSYLYQUUSUUBSUGYLYQLUUQPJZLMJZUUSYLYPUVCLMYLYPLAYSJZDKZU
      VCYLYOUVEDAYSCYNEFUVAUVBULUMYJLUNIZSLUOUPZUBYKUVFUVCRUVGUVHUTSLVAUTVBUQUR
      LAYSCDEFUVBGUSVCVDVEYLUVDLLMJZUURPJZUUSYLUUQTIZUVDUVJRZYLUUQACDEFGVFVNZLT
      IUVKLVGIUVLVHVILUUQLVJVKVLUVIUFUURPVMVOVPVDYLUUAYLUUACVQKZDKZSYLYTUVNDAYS
      CYNEUVNFUVAUVBUVNUIZVRUMYJUVOSRYKCDUVNUVPGVSVTVDWAWBYLUUSYLUFTIZUURTIZUUS
      TIWCYLUUQUVMWDZUFUURWEWFZWGVDYLUUNOSPJSYLUUMSOPYLUUMUUGUUGUGJSYLUULUUGUUG
      UGYLUUKUUFLMYLNUUHQJZAYSJZDKZNOQJZAYSJZDKZUUKUUFYLUWAWHKZUUQPJZUWDWHKZUUQ
      PJZUWCUWFUWGUWIUUQPUWGNLMJZUWKQJZWIKZNONPJZQJZWHKZUWINOYRPJZQJZWHKZUWKYRL
      MJZQJZWIKZUWGUWMNUNIZYRUNIUWSUXBRWPNWPWJNYRWKWQUWRUWAWHUWQUUHNQUWQUWNUDUU
      HONWLWMWNUWNOOWLWOZWRWSWTXAUXAUWLWIUWTUWKUWKQNTIZUWTUWKRWMNXBXGWTXAXCUXCU
      XCUWPUWMRWPWPNNWKWQUWOUWDWHUWNONQUXDWTXAXDVOYJUWATIYKUWCUWHRNUUHWMOWLXEZX
      HUWAAYSCDEFUVBGXIVCYJUWDTIYKUWFUWJRNOWMWLXHUWDAYSCDEFUVBGXIVCXFYLUWBUUJDY
      LUWBNAYSJZUUIYNJZUUJYJUUHTIZYKUWBUXHRZUXFYJUXEUXIYKUXJWMNUUHAYSCYNEFUVAUV
      BXJXKXLYLUXGAUUIYNAYSCEFUVBXMZVEVDUMYLUWEUUEDYLUWEUXGUUDYNJZUUEYJOTIZYKUW
      EUXLRZWLYJUXEUXMYKUXNWMNOAYSCYNEFUVAUVBXJXKXLYLUXGAUUDYNUXKVEVDUMXNVEXOYL
      UUGYJYKUUGTIZYJYKYKXPUXMUXOWLAAOBYSCYNDEFUVAUVBGHXQXRUKXSVDXOOWLXTVPWBYLU
      USUVTYAYIVEYLUVRUUTUURRZUVSUVRUVQUFSYBUXPWCUFYCYDYEUURUFYFYGVLYH $.

    $( Norm expressed in terms of inner product.  (Contributed by NM,
       11-Sep-2007.)  (New usage is discouraged.) $)
    ipnm $p |- ( ( U e. NrmCVec /\ A e. X ) ->
                ( N ` A ) = ( sqr ` ( A P A ) ) ) $=
      ( cnv wcel wa co csqr cfv c2 cexp ipidsq fveq2d nvcl nvge0 sqrsqd eqtr2d
      ) CIJAEJKZAABLZMNADNZOPLZMNUEUCUDUFMABCDEFGHQRUCUEACDEFGSACDEFGTUAUB $.
  $}

  ${
    $d k A $.  $d k B $.  $d k x y U $.  $d k x y X $.
    ipcl.1 $e |- X = ( BaseSet ` U ) $.
    ipcl.7 $e |- P = ( .iOLD ` U ) $.
    $( An inner product is a complex number.  (Contributed by NM, 1-Feb-2007.)
       (Revised by Mario Carneiro, 5-May-2014.)  (New usage is discouraged.) $)
    dipcl $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( A P B ) e. CC ) $=
      ( vk cnv wcel w3a co c1 c4 cfz ci cexp cfv cc eqid cns cpv cnmcv cmul csu
      cv c2 cdiv ipval fzfid cn0 ax-icn elfznn nnnn0d sylancr adantl ipval2lem4
      wa expcl sylan2 mulcld fsumcl cc0 wne 4cn 4re 4pos gt0ne0ii divcl mp3an23
      syl eqeltrd ) DIJAEJBEJKZABCLMNOLZPHUFZQLZAVPBDUARZLDUBRZLDUCRZRUGQLZUDLZ
      HUEZNUHLZSABCVQDHVRVSEFVRTZVQTZVSTZGUIVMWBSJZWCSJZVMVNWAHVMMNUJVMVOVNJZUR
      VPVTWIVPSJZVMWIPSJVOUKJWJULWIVOVONUMUNPVOUSUOZUPWIVMWJVTSJWKABVPCVQDVRVSE
      FWDWEWFGUQUTVAVBWGNSJNVCVDWHVENVFVGVHWBNVIVJVKVL $.

    $( Mapping for the inner product operation.  (Contributed by NM,
       28-Jan-2008.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    ipf $p |- ( U e. NrmCVec -> P : ( X X. X ) --> CC ) $=
      ( vx vy vk cnv wcel cxp cc wf c4 co cv cexp cfv wral eqid c1 cfz ci cnmcv
      cns cpv c2 cmul csu cmpt2 w3a ipval dipcl eqeltrrd 3expib ralrimivv fmpt2
      cdiv sylib dipfval feq1d mpbird ) BIJZCCKZLAMVDLFGCCUANUBOUCHPQOZFPZVEGPZ
      BUERZOBUFRZOBUDRZRUGQOUHOHUINUROZUJZMZVCVKLJZGCSFCSVMVCVNFGCCVCVFCJZVGCJZ
      VNVCVOVPUKVFVGAOVKLVFVGAVHBHVIVJCDVITZVHTZVJTZEULVFVGABCDEUMUNUOUPFGCCVKL
      VLVLTUQUSVCVDLAVLFGAVHBHVIVJCDVQVRVSEUTVAVB $.

    $( The complex conjugate of an inner product reverses its arguments.
       Equation I1 of [Ponnusamy] p. 362.  (Contributed by NM, 1-Feb-2007.)
       (New usage is discouraged.) $)
    dipcj $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
               ( * ` ( A P B ) ) = ( B P A ) ) $=
      ( wcel co cfv c2 cexp cmin ci c4 cdiv wceq cc mpan2 cr cnv w3a ccj cpv c1
      cnmcv cneg cns cmul caddc eqid ipval2 fveq2d 3com23 ipval2lem3 ipval2lem4
      recnd neg1cn subcld ax-icn negcli sylancr addcld cc0 wne 4cn 4re gt0ne0ii
      mulcl 4pos cjdiv mp3an23 syl cjre ax-mp oveq2i ipval2lem2 resubcld cjreim
      syl2anc submul2 mp3an2 nvcom oveq1d nvdif oveq12d negsubdi2d eqcomd eqtrd
      nvpi oveq2d 3eqtrd syl5eq eqtr4d ) DUAHZAEHZBEHZUBZABCIZUCJABDUDJZIZDUFJZ
      JZKLIZAUEUGZBDUHJZIWTIXBJZKLIZMIZNANBXFIWTIXBJZKLIZANUGZBXFIWTIXBJZKLIZMI
      ZUIIZUJIZOPIZUCJZBACIZWRWSXRUCABCXFDWTXBEFWTUKZXFUKZXBUKZGULUMWRXTBAWTIZX
      BJZKLIZBXEAXFIWTIXBJZKLIZMIZNBNAXFIWTIXBJZKLIZBXLAXFIWTIXBJZKLIZMIZUIIZUJ
      IZOPIZXSWOWQWPXTYQQBACXFDWTXBEFYAYBYCGULUNWRXSXQUCJZOUCJZPIZYQWRXQRHZXSYT
      QZWRXIXPWRXDXHWRXDABCXFDWTXBEFYAYBYCGUOZUQWRXERHZXHRHURABXECXFDWTXBEFYAYB
      YCGUPSUSZWRNRHZXORHZXPRHUTWRXKXNWRUUFXKRHUTABNCXFDWTXBEFYAYBYCGUPSZWRXLRH
      ZXNRHNUTVAZABXLCXFDWTXBEFYAYBYCGUPSZUSZNXOVIVBVCUUAORHOVDVEUUBVFOVGVJVHXQ
      OVKVLVMWRYTYROPIYQYSOYRPOTHYSOQVGOVNVOVPWRYRYPOPWRYRXIXPMIZXINXOUGZUIIZUJ
      IZYPWRXITHXOTHYRUUMQWRXDXHUUCWRUUDXHTHURABXECXFDWTXBEFYAYBYCGVQSVRWRXKXNW
      RUUFXKTHUTABNCXFDWTXBEFYAYBYCGVQSWRUUIXNTHUUJABXLCXFDWTXBEFYAYBYCGVQSVRXI
      XOVSVTWRXIRHZUUGUUMUUPQZUUEUULUUQUUFUUGUURUTXINXOWAWBVTWRXIYIUUOYOUJWRXDY
      FXHYHMWRXCYEKLWRXAYDXBABDWTEFYAWCUMWDWRXGYGKLABXFDWTXBEFYAYBYCWEWDWFWRUUN
      YNNUIWRUUNXNXKMIYNWRXKXNUUHUUKWGWRXNYKXKYMMWRXMYJKLWRYJXMWOWQWPYJXMQBAXFD
      WTXBEFYAYBYCWJUNWHWDWRXJYLKLABXFDWTXBEFYAYBYCWJWDWFWIWKWFWLWDWMWIWNWN $.

    $( An inner product times its conjugate.  (Contributed by NM,
       23-Nov-2007.)  (New usage is discouraged.) $)
    ipipcj $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X ) ->
                ( ( A P B ) x. ( B P A ) ) = ( ( abs ` ( A P B ) ) ^ 2 ) ) $=
      ( cnv wcel w3a co cabs cfv c2 cexp ccj cmul dipcl absvalsqd dipcj oveq2d
      eqtr2d ) DHIAEIBEIJZABCKZLMNOKUDUDPMZQKUDBACKZQKUCUDABCDEFGRSUCUEUFUDQABC
      DEFGTUAUB $.

    $( Orthogonality (meaning inner product is 0) is commutative.  (Contributed
       by NM, 17-Apr-2008.)  (New usage is discouraged.) $)
    diporthcom $p |- ( ( U e. NrmCVec /\ A e. X /\ B e. X )
              -> ( ( A P B ) = 0 <-> ( B P A ) = 0 ) ) $=
      ( cnv wcel co cc0 wceq ccj cfv fveq2 cj0 syl6eq dipcj eqeq1d syl5ib w3a
      3com23 impbid ) DHIZAEIZBEIZUAZABCJZKLZBACJZKLZUIUHMNZKLUGUKUIULKMNZKUHKM
      OPQUGULUJKABCDEFGRSTUKUJMNZKLUGUIUKUNUMKUJKMOPQUGUNUHKUDUFUEUNUHLBACDEFGR
      UBSTUC $.
  $}

  ${
    dip0r.1 $e |- X = ( BaseSet ` U ) $.
    dip0r.5 $e |- Z = ( 0vec ` U ) $.
    dip0r.7 $e |- P = ( .iOLD ` U ) $.
    $( Inner product with a zero second argument.  (Contributed by NM,
       5-Feb-2007.)  (New usage is discouraged.) $)
    dip0r $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( A P Z ) = 0 ) $=
      ( wcel co cfv c2 cexp cmin ci caddc c4 cc0 wceq oveq2d cnv cpv cnmcv cneg
      wa c1 cns cmul cdiv nvzcl adantr eqid ipval2 mpd3an3 cc neg1cn nvsz mpan2
      fveq2d oveq1d ipval2lem3 recnd subidd ax-icn negcli eqtr4d w3a ipval2lem4
      eqtrd oveq12d mul01i oveq2i 00id eqtri syl6eq 4cn 4re 4pos gt0ne0ii div0i
      cr ) CUAIZADIZUEZAEBJZAECUBKZJZCUCKZKZLMJZAUFUDZECUGKZJZWFJZWHKZLMJZNJZOA
      OEWLJZWFJZWHKZLMJZAOUDZEWLJZWFJZWHKZLMJZNJZUHJZPJZQUIJZRWBWCEDIZWEXJSWBXK
      WCCDEFGUJUKZAEBWLCWFWHDFWFULZWLULZWHULZHUMUNWDXJRQUIJRWDXIRQUIWDXIRORUHJZ
      PJZRWDWQRXHXPPWDWQWJWJNJRWDWPWJWJNWDWOWILMWDWNWGWHWDWMEAWFWBWMESZWCWBWKUO
      IXRUPWKWLCEXNGUQURUKTUSUTTWDWJWDWJWBWCXKWJWAIXLAEBWLCWFWHDFXMXNXOHVAUNVBV
      CVIWDXGROUHWDXGXAXANJRWDXFXAXANWDXEWTLMWDXDWSWHWDXCWRAWFWBXCWRSWCWBXCEWRW
      BXBUOIXCESOVDVEXBWLCEXNGUQURWBOUOIZWRESVDOWLCEXNGUQURVFUKTUSUTTWDXAWBWCXK
      XAUOIZXLWBWCXKVGXSXTVDAEOBWLCWFWHDFXMXNXOHVHURUNVCVITVJXQRRPJRXPRRPOVDVKV
      LVMVNVOUTQVPQVQVRVSVTVOVI $.

    $( Inner product with a zero first argument.  Part of proof of Theorem 6.44
       of [Ponnusamy] p. 361.  (Contributed by NM, 5-Feb-2007.)
       (New usage is discouraged.) $)
    dip0l $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( Z P A ) = 0 ) $=
      ( cnv wcel wa co ccj cfv cc0 wceq nvzcl adantr dipcj mpd3an3 dip0r fveq2d
      cj0 syl6eq eqtr3d ) CIJZADJZKZAEBLZMNZEABLZOUFUGEDJZUJUKPUFULUGCDEFGQRAEB
      CDFHSTUHUJOMNOUHUIOMABCDEFGHUAUBUCUDUE $.

    $( The inner product of a vector with itself is zero iff the vector is
       zero.  Part of Definition 3.1-1 of [Kreyszig] p. 129.  (Contributed by
       NM, 24-Jan-2008.)  (New usage is discouraged.) $)
    ipz $p |- ( ( U e. NrmCVec /\ A e. X ) -> ( ( A P A ) = 0 <-> A = Z ) ) $=
      ( cnv wcel wa co cc0 wceq cnmcv cfv c2 cexp eqid ipidsq eqeq1d cc wb nvcl
      recnd sqeq0 syl nvz 3bitrd ) CIJADJKZAABLZMNACOPZPZQRLZMNZUMMNZAENUJUKUNM
      ABCULDFULSZHTUAUJUMUBJUOUPUCUJUMACULDFUQUDUEUMUFUGACULDEFGUQUHUI $.
  $}

  ${
    $d k x y z J $.  $d k x y z K $.  $d k x y z U $.
    dipcn.p $e |- P = ( .iOLD ` U ) $.
    dipcn.c $e |- C = ( IndMet ` U ) $.
    dipcn.j $e |- J = ( MetOpen ` C ) $.
    dipcn.k $e |- K = ( TopOpen ` CCfld ) $.
    $( Inner product is jointly continuous in both arguments.  (Contributed by
       NM, 21-Aug-2007.)  (Revised by Mario Carneiro, 10-Sep-2015.)
       (New usage is discouraged.) $)
    dipcn $p |- ( U e. NrmCVec -> P e. ( ( J tX J ) Cn K ) ) $=
      ( vx vy vk vz wcel cfv c4 co ccn cc a1i cnv cba c1 cfz ci cv cexp cns cpv
      cnmcv c2 cmul csu cdiv ctx eqid dipfval cxmt ctopon imsxmet mopntopon syl
      cmpt2 fzfid wa adantr cnfldtopon cn0 ax-icn cn elfznn adantl nnnn0d expcl
      sylancr cnmpt2c cnmpt1st cnmpt2nd smcn cnmpt22f vacn nmcnc cnmpt21f oveq1
      cmpt sqcn cnmpt21 mulcn fsum2cn cc0 wne 4cn nnne0i divccn mp2an eqeltrd
      4nn ) CUANZBJKCUBOZWSUCPUDQZUELUFZUGQZJUFZXBKUFZCUHOZQZCUIOZQZCUJOZOZUKUG
      QZULQZLUMZPUNQZVCDDUOQZERQJKBXECLXGXIWSWSUPZXGUPZXEUPZXIUPZFUQWRJKMXMMUFZ
      PUNQZXNDDEEWSWSSWRAWSURONDWSUSONZACWSXPGUTADWSHVAVBZYCWRJKWTXLLDEDWSWSIYC
      WRUCPVDYCWRXAWTNZVEZJKXBXKULDDEEEWSWSWRYBYDYCVFZYFYEJKXBDDEWSWSSYFYFESUSO
      NZYEEIVGZTZYEUESNXAVHNXBSNVIYEXAYDXAVJNWRXAPVKVLVMUEXAVNVOVPZYEJKMXJXTUKU
      GQZXKDDEEWSWSSYFYFYEJKXHXIDDDEWSWSYFYFYEJKXCXFXGDDDDDWSWSYFYFYEJKDDWSWSYF
      YFVQYEJKXBXDXEDDEDDWSWSYFYFYJYEJKDDWSWSYFYFVRWRXEEDUOQDRQNYDAXECDEGHXRIVS
      VFVTWRXGXODRQNYDACXGDGHXQWAVFVTWRXIDERQNYDACDEXIXSGHIWBVFWCYIMSYKWEEERQZN
      YEMEIWFTXTXJUKUGWDWGULEEUOQERQNYEEIWHTVTWIYGWRYHTMSYAWEYLNZWRPSNPWJWKYMWL
      PWQWMMPEIWNWOTXTXMPUNWDWGWP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SubSp $.

  $( Extend class notation with the class of all subspaces of complex normed
     vector spaces. $)
  css $a class SubSp $.

  ${
    $d u w $.
    $( Define the class of all subspaces of complex normed vector spaces.
       (Contributed by NM, 26-Jan-2008.)  (New usage is discouraged.) $)
    df-ssp $a |- SubSp = ( u e. NrmCVec |->
     { w e. NrmCVec | ( ( +v ` w ) C_ ( +v ` u ) /\ ( .sOLD ` w ) C_ ( .sOLD `
        u )
         /\ ( normCV ` w ) C_ ( normCV ` u ) ) } ) $.
  $}

  ${
    $d u w G $.  $d u w N $.  $d u w S $.  $d u w U $.
    sspval.g $e |- G = ( +v ` U ) $.
    sspval.s $e |- S = ( .sOLD ` U ) $.
    sspval.n $e |- N = ( normCV ` U ) $.
    sspval.h $e |- H = ( SubSp ` U ) $.
    $( The set of all subspaces of a normed complex vector space.  (Contributed
       by NM, 26-Jan-2008.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    sspval $p |- ( U e. NrmCVec -> H = { w e. NrmCVec | (
         ( +v ` w ) C_ G /\ ( .sOLD ` w ) C_ S /\ ( normCV ` w ) C_ N ) } ) $=
      ( vu cnv wcel cfv cpv wss cns cnmcv fveq2 fvex css cv crab syl6eqr sseq2d
      w3a wceq 3anbi123d rabbidv df-ssp cpw cxp cvv eqeltri pwex xpex rabss cop
      wi wa elpw opelxpi syl2anbr biimpri syl2an 3impa eqid nvop eleq1d syl5ibr
      mprgbir ssexi fvmpt syl5eq ) CLMECUANAUBZONZDPZVOQNZBPZVORNZFPZUFZALUCZJK
      CVPKUBZONZPZVRWDQNZPZVTWDRNZPZUFZALUCWCLUAWDCUGZWKWBALWLWFVQWHVSWJWAWLWED
      VPWLWECONZDWDCOSGUDUEWLWGBVRWLWGCQNZBWDCQSHUDUEWLWIFVTWLWICRNZFWDCRSIUDUE
      UHUIAKUJWCDUKZBUKZULZFUKZULZWRWSWPWQDDWMUMGCOTUNUOBBWNUMHCQTUNUOUPFFWOUMI
      CRTUNUOUPWCWTPWBVOWTMZUSALWBALWTUQWBXAVOLMZVPVRURZVTURZWTMZVQVSWAXEVQVSUT
      XCWRMZVTWSMZXEWAVQVPWPMVRWQMXFVSVPDVOOTVAVRBVOQTVAVPVRWPWQVBVCXGWAVTFVORT
      VAVDXCVTWRWSVBVEVFXBVOXDWTVRVOVPVTVPVGVRVGVTVGVHVIVJVKVLVMVN $.
  $}

  ${
    $d w F $.  $d w G $.  $d w M $.  $d w N $.  $d w R $.  $d w S $.  $d w U $.
    $d w W $.
    isssp.g $e |- G = ( +v ` U ) $.
    isssp.f $e |- F = ( +v ` W ) $.
    isssp.s $e |- S = ( .sOLD ` U ) $.
    isssp.r $e |- R = ( .sOLD ` W ) $.
    isssp.n $e |- N = ( normCV ` U ) $.
    isssp.m $e |- M = ( normCV ` W ) $.
    isssp.h $e |- H = ( SubSp ` U ) $.
    $( The predicate "is a subspace."  (Contributed by NM, 26-Jan-2008.)
       (New usage is discouraged.) $)
    isssp $p |- ( U e. NrmCVec -> ( W e. H <-> ( W e. NrmCVec /\ (
               F C_ G /\ R C_ S /\ M C_ N ) ) ) ) $=
      ( vw cnv cfv wss wcel cv cpv cns cnmcv crab wa sspval eleq2d wceq syl6eqr
      w3a fveq2 sseq1d 3anbi123d elrab syl6bb ) CRUAZIFUAIQUBZUCSZETZUSUDSZBTZU
      SUESZHTZULZQRUFZUAIRUADETZABTZGHTZULZUGURFVGIQBCEFHJLNPUHUIVFVKQIRUSIUJZV
      AVHVCVIVEVJVLUTDEVLUTIUCSDUSIUCUMKUKUNVLVBABVLVBIUDSAUSIUDUMMUKUNVLVDGHVL
      VDIUESGUSIUEUMOUKUNUOUPUQ $.
  $}

  ${
    sspid.h $e |- H = ( SubSp ` U ) $.
    $( A normed complex vector space is a subspace of itself.  (Contributed by
       NM, 8-Apr-2008.)  (New usage is discouraged.) $)
    sspid $p |- ( U e. NrmCVec -> U e. H ) $=
      ( cnv wcel cpv cfv wss cns cnmcv w3a ssid 3pm3.2i jctr eqid isssp mpbird
      wa ) ADEZABESAFGZTHZAIGZUBHZAJGZUDHZKZRSUFUAUCUETLUBLUDLMNUBUBATTBUDUDATO
      ZUGUBOZUHUDOZUICPQ $.
  $}

  ${
    sspnv.h $e |- H = ( SubSp ` U ) $.
    $( A subspace is a normed complex vector space.  (Contributed by NM,
       27-Jan-2008.)  (New usage is discouraged.) $)
    sspnv $p |- ( ( U e. NrmCVec /\ W e. H ) -> W e. NrmCVec ) $=
      ( cnv wcel cpv cfv wss cns cnmcv w3a eqid isssp simprbda ) AEFCBFCEFCGHZA
      GHZICJHZAJHZICKHZAKHZILRSAPQBTUACQMPMSMRMUAMTMDNO $.
  $}

  ${
    sspba.x $e |- X = ( BaseSet ` U ) $.
    sspba.y $e |- Y = ( BaseSet ` W ) $.
    sspba.h $e |- H = ( SubSp ` U ) $.
    $( The base set of a subspace is included in the parent base set.
       (Contributed by NM, 27-Jan-2008.)  (New usage is discouraged.) $)
    sspba $p |- ( ( U e. NrmCVec /\ W e. H ) -> Y C_ X ) $=
      ( cnv wcel wa cpv cfv crn wss cns cnmcv w3a eqid bafval isssp simp1d rnss
      simplbda syl 3sstr4g ) AIJZCBJZKZCLMZNZALMZNZEDUIUJULOZUKUMOUIUNCPMZAPMZO
      ZCQMZAQMZOZUGUHCIJUNUQUTRUOUPAUJULBURUSCULSZUJSZUPSUOSUSSURSHUAUDUBUJULUC
      UECUJEGVBTAULDFVATUF $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspg.y $e |- Y = ( BaseSet ` W ) $.
    sspg.g $e |- G = ( +v ` U ) $.
    sspg.f $e |- F = ( +v ` W ) $.
    sspg.h $e |- H = ( SubSp ` U ) $.
    $( Vector addition on a subspace is a restriction of vector addition on the
       parent space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspg $p |- ( ( U e. NrmCVec /\ W e. H ) -> F = ( G |` ( Y X. Y ) ) ) $=
      ( vx vy wcel wa wceq wfn wss cfv eqid syl cnv cxp cres cv co wral w3a cba
      wfun wf nvgf ffun funres adantr sspnv fnresdm cnmcv isssp simplbda simp1d
      ffn cns ssres eqsstr3d oprssov sylan eqcomd ralrimivva jctil sspba xpss12
      3jca wb syl2anc fnssres eqfnov mpbird ) AUAMZEDMZNZBCFFUBZUCZOZWAWAOZKUDZ
      LUDZBUEZWEWFWBUEZOZLFUFKFUFZNZVTWJWDVTWIKLFFVTWEFMWFFMNZNWHWGVTWBUIZBWAPZ
      BWBQZUGWLWHWGOVTWMWNWOVRWMVSVRCUIZWMVRAUHRZWQUBZWQCUJZWPACWQWQSZHUKZWRWQC
      ULTWACUMTUNVTWAFBUJZWNVTEUAMZXBADEJUOEBFGIUKTWAFBVATZVTBBWAUCZWBVTWNXEBOX
      DWABUPTVTBCQZXEWBQVTXFEVBRZAVBRZQZEUQRZAUQRZQZVRVSXCXFXIXLUGXGXHABCDXJXKE
      HIXHSXGSXKSXJSJURUSUTBCWAVCTVDVLWEWFFFWBBVEVFVGVHWASVIVTWNWBWAPZWCWKVMXDV
      TCWRPZWAWRQZXMVRXNVSVRWSXNXAWRWQCVATUNVTFWQQZXPXOADEWQFWTGJVJZXQFWQFWQVKV
      NWRWACVOVNKLFFFFBWBVPVNVQ $.

    $( Vector addition on a subspace in terms of vector addition on the parent
       space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspgval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A F B ) = ( A G B ) ) $=
      ( cnv wcel wa co cxp cres sspg oveqd ovres sylan9eq ) CMNGFNOZAHNBHNOABDP
      ABEHHQRZPABEPUCDUDABCDEFGHIJKLSTABHHEUAUB $.
  $}

  ${
    $d x y R $.  $d x y S $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    ssps.y $e |- Y = ( BaseSet ` W ) $.
    ssps.s $e |- S = ( .sOLD ` U ) $.
    ssps.r $e |- R = ( .sOLD ` W ) $.
    ssps.h $e |- H = ( SubSp ` U ) $.
    $( Scalar multiplication on a subspace is a restriction of scalar
       multiplication on the parent space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    ssps $p |- ( ( U e. NrmCVec /\ W e. H ) -> R = ( S |` ( CC X. Y ) ) ) $=
      ( vx vy wcel wa cc wceq wss cfv eqid syl cnv cxp cres cv co wral wfun wfn
      w3a cba wf nvsf ffun funres adantr sspnv ffn fnresdm cnmcv isssp simplbda
      cpv simp2d ssres eqsstr3d 3jca oprssov sylan eqcomd ralrimivva jctil ssid
      wb sspba xpss12 sylancr fnssres syl2anc eqfnov mpbird ) CUAMZEDMZNZABOFUB
      ZUCZPZWDWDPZKUDZLUDZAUEZWHWIWEUEZPZLFUFKOUFZNZWCWMWGWCWLKLOFWCWHOMWIFMNZN
      WKWJWCWEUGZAWDUHZAWEQZUIWOWKWJPWCWPWQWRWAWPWBWABUGZWPWAOCUJRZUBZWTBUKZWSB
      CWTWTSZHULZXAWTBUMTWDBUNTUOWCWDFAUKZWQWCEUAMZXECDEJUPAEFGIULTWDFAUQTZWCAA
      WDUCZWEWCWQXHAPXGWDAURTWCABQZXHWEQWCEVBRZCVBRZQZXIEUSRZCUSRZQZWAWBXFXLXIX
      OUIABCXJXKDXMXNEXKSXJSHIXNSXMSJUTVAVCABWDVDTVEVFWHWIOFWEAVGVHVIVJWDSVKWCW
      QWEWDUHZWFWNVMXGWCBXAUHZWDXAQZXPWAXQWBWAXBXQXDXAWTBUQTUOWCOOQFWTQXROVLCDE
      WTFXCGJVNOOFWTVOVPXAWDBVQVRKLOFOFAWEVSVRVT $.

    $( Scalar multiplication on a subspace in terms of scalar multiplication on
       the parent space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspsval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. CC /\ B e. Y ) ) ->
                    ( A R B ) = ( A S B ) ) $=
      ( cnv wcel wa cc co cxp cres ssps oveqd ovres sylan9eq ) EMNGFNOZAPNBHNOA
      BCQABDPHRSZQABDQUDCUEABCDEFGHIJKLTUAABPHDUBUC $.
  $}

  $( TODO - sspvallem doesn't save space yet, but might if another
     operation is added. $)
  $(
  @{
    @d x y F @.  @d x y G @.  @d x y H @.  @d x y U @.  @d x y W @.
    @d x y Y @.
    sspvallem.y @e |- Y = ( BaseSet ` W ) @.
    sspvallem.h @e |- H = ( SubSp ` U ) @.
    @{
      sspvallem.1 @e |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y )
         ) -> R = S ) @.
      sspvallem.2 @e |- ( ( W e. NrmCVec /\ A e. Y /\ B e. Y ) -> P = R ) @.
      sspvallem.3 @e |- ( ( U e. NrmCVec /\ A e. ( BaseSet ` U ) /\
          B e. ( BaseSet ` U ) ) -> Q = S ) @.
      @( Lemma for ~ sspmval and others. @)
      sspvallem @p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) )
          -> P = Q ) @=
       ( cnv wcel wa wceq 3expb sspnv sylanOLD cba cfv eqid sspba sseld anim12d
        imp adantlr syldan 3eqtr4d ) GPQZIHQZRZAJQZBJQZRZREFCDMIPQZURCESZUOUSUP
        UQUTNTGHILUAUBUOURAGUCUDZQZBVAQZRZDFSZUOURVDUOUPVBUQVCUOJVAAGHIVAJVAUEK
        LUFZUGUOJVABVFUGUHUIUMVDVEUNUMVBVCVEOTUJUKUL @.
        @( [ ?] @) @( [1-Feb-2008] @)
    @}

    @{
      sspmlem.1  @e |- ( ( ( U e. NrmCVec /\ W e. H ) /\ (
       x e. Y /\ y e. Y ) ) -> ( x F y ) = ( x G y ) ) @.
      sspmlem.2 @e |- ( W e. NrmCVec -> F : ( Y X. Y ) --> R ) @.
      sspmlem.3 @e |- ( U e. NrmCVec -> G : ( ( BaseSet ` U ) X.
               ( BaseSet ` U ) ) --> S ) @.
      @( Lemma for ~ sspm and others. @)
      sspmlem @p |- ( ( U e. NrmCVec /\ W e. H ) ->
            F = ( G |` ( Y X. Y ) ) ) @=
        ( cnv wcel wa cxp cres wceq cv co wral ovres adantl eqtr4d ex
        ralrimivv eqid jctil wfn wb eqfnov wf sspnv ffn 3syl cba cfv wss
   fnssres syl adantr sspba xpss12 anidms sylancOLD mpbird ) EPQZIHQZRZFGJJSZTZ
        UAZVMVMUAZAUBZBUBZFUCZVQVRVNUCZUAZBJUDAJUDZRZVLWBVPVLWAABJJVLVQJQVRJQRZ
        WAVLWDRVSVQVRGUCZVTMWDVTWEUAVLVQVRJJGUEUFUGUHUIVMUJUKFVMULZVNVMULZVOWCU
        MVLABJJJJFVNUNVLIPQVMCFUOWFEHILUPNVMCFUQURGEUSUTZWHSZULZVMWIVAZWGVLWIVM
        GVBVJWJVKVJWIDGUOWJOWIDGUQVCVDVLJWHVAZWKEHIWHJWHUJKLVEWLWKJWHJWHVFVGVCV
        HVHVI @.
        @( [ ?] @) @( [1-Feb-2008] @)
    @}
  @}
  $)

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspmlem.y $e |- Y = ( BaseSet ` W ) $.
    sspmlem.h $e |- H = ( SubSp ` U ) $.
    sspmlem.1 $e |- ( ( ( U e. NrmCVec /\ W e. H ) /\ (
             x e. Y /\ y e. Y ) ) -> ( x F y ) = ( x G y ) ) $.
    sspmlem.2 $e |- ( W e. NrmCVec -> F : ( Y X. Y ) --> R ) $.
    sspmlem.3 $e |- ( U e. NrmCVec -> G : ( ( BaseSet ` U ) X.
             ( BaseSet ` U ) ) --> S ) $.
    $( Lemma for ~ sspm and others.  (Contributed by NM, 1-Feb-2008.)
       (New usage is discouraged.) $)
    sspmlem $p |- ( ( U e. NrmCVec /\ W e. H ) -> F = ( G |` ( Y X. Y ) ) ) $=
      ( wcel wa wceq co wfn cnv cxp cres cv wral ovres adantl eqtr4d ralrimivva
      eqid jctil wb sspnv ffn 3syl cba cfv wss syl adantr sspba syl2anc fnssres
      wf xpss12 eqfnov mpbird ) EUAPZIHPZQZFGJJUBZUCZRZVKVKRZAUDZBUDZFSZVOVPVLS
      ZRZBJUEAJUEZQZVJVTVNVJVSABJJVJVOJPVPJPQZQVQVOVPGSZVRMWBVRWCRVJVOVPJJGUFUG
      UHUIVKUJUKVJFVKTZVLVKTZVMWAULVJIUAPVKCFVDWDEHILUMNVKCFUNUOVJGEUPUQZWFUBZT
      ZVKWGURZWEVHWHVIVHWGDGVDWHOWGDGUNUSUTVJJWFURZWJWIEHIWFJWFUJKLVAZWKJWFJWFV
      EVBWGVKGVCVBABJJJJFVLVFVBVG $.
  $}

  ${
    $d x y L $.  $d x y M $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspm.y $e |- Y = ( BaseSet ` W ) $.
    sspm.m $e |- M = ( -v ` U ) $.
    sspm.l $e |- L = ( -v ` W ) $.
    sspm.h $e |- H = ( SubSp ` U ) $.
    $( Vector addition on a subspace in terms of vector addition on the parent
       space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspmval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A L B ) = ( A M B ) ) $=
      ( cnv wcel wa cns cfv co wceq eqid c1 cpv wi sspnv cc neg1cn nvscl mp3an2
      cneg ex syl anim2d imp sspgval syldan sspsval mpanr1 adantrl oveq2d eqtrd
      nvmval 3expb sylan cba sspba sseld anim12d adantlr 3eqtr4d ) CMNZGDNZOZAH
      NZBHNZOZOZAUAUIZBGPQZRZGUBQZRZAVQBCPQZRZCUBQZRZABERZABFRZVPWAAVSWDRZWEVLV
      OVMVSHNZOZWAWHSVLVOWJVLVNWIVMVLGMNZVNWIUCCDGLUDZWKVNWIWKVQUENZVNWIUFVQBVR
      GHIVRTZUGUHUJUKULUMAVSCVTWDDGHIWDTZVTTZLUNUOVPVSWCAWDVLVNVSWCSZVMVLWMVNWQ
      UFVQBVRWBCDGHIWBTZWNLUPUQURUSUTVLWKVOWFWASZWLWKVMVNWSABVRGVTEHIWPWNKVAVBV
      CVLVOACVDQZNZBWTNZOZWGWESZVLVOXCVLVMXAVNXBVLHWTACDGWTHWTTZILVEZVFVLHWTBXF
      VFVGUMVJXCXDVKVJXAXBXDABWBCWDFWTXEWOWRJVAVBVHUOVI $.

    $( Vector subtraction on a subspace is a restriction of vector subtraction
       on the parent space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspm $p |- ( ( U e. NrmCVec /\ W e. H ) -> L = ( M |` ( Y X. Y ) ) ) $=
      ( vx vy cba cfv cv sspmval nvmf eqid sspmlem ) KLFAMNZACDBEFGJKOLOABCDEFG
      HIJPECFGIQADTTRHQS $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    sspz.z $e |- Z = ( 0vec ` U ) $.
    sspz.q $e |- Q = ( 0vec ` W ) $.
    sspz.h $e |- H = ( SubSp ` U ) $.
    $( The zero vector of a subspace is the same as the parent's.  (Contributed
       by NM, 28-Jan-2008.)  (New usage is discouraged.) $)
    sspz $p |- ( ( U e. NrmCVec /\ W e. H ) -> Q = Z ) $=
      ( cnv wcel wa cnsb cfv co cba wceq sspnv eqid syl nvmid nvzcl jca sspmval
      mpdan syl2anc sspba sseldd syldan 3eqtr3d ) BIJZDCJZKZAADLMZNZAABLMZNZAEU
      LADOMZJZURKZUNUPPULDIJZUSBCDHQZUTURURDUQAUQRZGUAZVCUBSAABCUMUODUQVBUORZUM
      RZHUCUDULUTURUNAPVAULUTURVAVCSZADUMUQAVBVEGTUEUJUKABOMZJUPEPULUQVGABCDVGU
      QVGRZVBHUFVFUGABUOVGEVHVDFTUHUI $.
  $}

  ${
    $d x H $.  $d x M $.  $d x N $.  $d x U $.  $d x W $.  $d x Y $.
    sspn.y $e |- Y = ( BaseSet ` W ) $.
    sspn.n $e |- N = ( normCV ` U ) $.
    sspn.m $e |- M = ( normCV ` W ) $.
    sspn.h $e |- H = ( SubSp ` U ) $.
    $( The norm on a subspace is a restriction of the norm on the parent
       space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspn $p |- ( ( U e. NrmCVec /\ W e. H ) -> M = ( N |` Y ) ) $=
      ( vx cnv wcel cr wfn syl cfv wss eqid wceq wa wf sspnv nvf ffn cba adantr
      cres fnssres syl2anc cv wfun cdm ffun funres ad2antrr fnresdm cpv cns w3a
      sspba isssp simplbda simp3d ssres eqsstr3d eleq2d biimpar funssfv syl3anc
      fdm sylan eqcomd eqfnfvd ) ALMZEBMZUAZKFCDFUHZVQFNCUBZCFOZVQELMZVSABEJUCZ
      ECFGIUDZPFNCUEPZVQDAUFQZOZFWERVRFOVOWFVPVOWENDUBZWFADWEWESZHUDZWENDUEPUGA
      BEWEFWHGJVAWEFDUIUJVQKUKZFMZUAZWJVRQZWJCQZWLVRULZCVRRZWJCUMZMZWMWNTVOWOVP
      WKVODULZWOVOWGWSWIWENDUNPFDUOPUPVQWPWKVQCCFUHZVRVQVTWTCTWDFCUQPVQCDRZWTVR
      RVQEURQZAURQZRZEUSQZAUSQZRZXAVOVPWAXDXGXAUTXEXFAXBXCBCDEXCSXBSXFSXESHIJVB
      VCVDCDFVEPVFUGVQWAWKWRWBWAWRWKWAWQFWJWAVSWQFTWCFNCVKPVGVHVLWJVRCVIVJVMVN
      $.

    $( The norm on a subspace in terms of the norm on the parent space.
       (Contributed by NM, 28-Jan-2008.)  (New usage is discouraged.) $)
    sspnval $p |- ( ( U e. NrmCVec /\ W e. H /\ A e. Y ) ->
                    ( M ` A ) = ( N ` A ) ) $=
      ( cnv wcel cfv wceq wa cres sspn fveq1d fvres sylan9eq 3impa ) BLMZFCMZAG
      MZADNZAENZOUCUDPZUEUFAEGQZNUGUHADUIBCDEFGHIJKRSAGETUAUB $.
  $}

  ${
    $d k A $.  $d k B $.  $d k x y H $.  $d x y P $.  $d x y Q $.
    $d k x y U $.  $d k x y W $.  $d k x y Y $.
    sspi.y $e |- Y = ( BaseSet ` W ) $.
    sspi.p $e |- P = ( .iOLD ` U ) $.
    sspi.q $e |- Q = ( .iOLD ` W ) $.
    sspi.h $e |- H = ( SubSp ` U ) $.
    $( The inner product on a subspace in terms of the inner product on the
       parent space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspival $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A Q B ) = ( A P B ) ) $=
      ( vk wcel wa c4 co cfv wceq eqid cnv c1 cfz ci cv cexp cns cpv cnmcv cmul
      c2 csu cdiv cn0 ax-icn elfznn nnnn0d expcl sylancr anim1i anim2i anass1rs
      cc sspnv nvscl 3expib anim2d imp nvgcl 3expb syldan sylan sspnval sspgval
      3expa wi syl sspsval adantrl oveq2d fveq2d sylan2 anassrs oveq1d sumeq2dv
      eqtrd ipval cba sspba sseld anim12d adantlr 3eqtr4d ) EUANZGFNZOZAHNZBHNZ
      OZOZUBPUCQZUDMUEZUFQZAXCBGUGRZQZGUHRZQZGUIRZRZUKUFQZUJQZMULZPUMQZXAXCAXCB
      EUGRZQZEUHRZQZEUIRZRZUKUFQZUJQZMULZPUMQZABDQZABCQZWTXLYBPUMWTXAXKYAMWTXBX
      ANZOZXJXTXCUJYGXIXSUKUFWPWSYFXIXSSZWSYFOWPWQXCVCNZWROZOZYHWQYFWRYKYFWROYJ
      WQYFYIWRYFUDVCNXBUNNYIUOYFXBXBPUPUQUDXBURUSUTVAVBWPYKOZXIXGXRRZXSWPYKXGHN
      ZXIYMSZWPGUANZYKYNEFGLVDZYPYKWQXEHNZOZYNYPYKYSYPYJYRWQYPYIWRYRXCBXDGHIXDT
      ZVEVFZVGVHYPWQYRYNAXEGXFHIXFTZVIVJVKVLWNWOYNYOXGEFXHXRGHIXRTZXHTZLVMVOVKY
      LXGXQXRYLXGAXEXPQZXQWPYKYSXGUUESWPYKYSWPYJYRWQWPYPYJYRVPYQUUAVQVGVHAXEEXF
      XPFGHIXPTZUUBLVNVKYLXEXOAXPWPYJXEXOSWQXCBXDXNEFGHIXNTZYTLVRVSVTWFWAWFWBWC
      WDVTWEWDWPYPWSYDXMSZYQYPWQWRUUHABDXDGMXFXHHIUUBYTUUDKWGVJVLWPWSAEWHRZNZBU
      UINZOZYEYCSZWPWSUULWPWQUUJWRUUKWPHUUIAEFGUUIHUUITZILWIZWJWPHUUIBUUOWJWKVH
      WNUULUUMWOWNUUJUUKUUMABCXNEMXPXRUUIUUNUUFUUGUUCJWGVJWLVKWM $.

    $( The inner product on a subspace is a restriction of the inner product on
       the parent space.  (Contributed by NM, 28-Jan-2008.)
       (New usage is discouraged.) $)
    sspi $p |- ( ( U e. NrmCVec /\ W e. H ) -> Q = ( P |` ( Y X. Y ) ) ) $=
      ( vx vy cc cv sspival ipf cba cfv eqid sspmlem ) KLMMCBADEFGJKNLNABCDEFGH
      IJOBEFGIPACCQRZUASHPT $.
  $}

  ${
    sspims.y $e |- Y = ( BaseSet ` W ) $.
    sspims.d $e |- D = ( IndMet ` U ) $.
    sspims.c $e |- C = ( IndMet ` W ) $.
    sspims.h $e |- H = ( SubSp ` U ) $.
    $d x y C $.  $d x y D $.  $d x y H $.  $d x y U $.  $d x y W $.
    $d x y Y $.
    $( The induced metric on a subspace in terms of the induced metric on the
       parent space.  (Contributed by NM, 1-Feb-2008.)
       (New usage is discouraged.) $)
    sspimsval $p |- ( ( ( U e. NrmCVec /\ W e. H ) /\ ( A e. Y /\ B e. Y ) ) ->
                    ( A C B ) = ( A D B ) ) $=
      ( cnv wcel wa cfv co wceq eqid 3expb cnsb cnmcv sspnv nvmcl sylan sspnval
      3expa syldan sspmval fveq2d eqtrd imsdval cba sspba sseld anim12d adantlr
      imp 3eqtr4d ) EMNZGFNZOZAHNZBHNZOZOZABGUAPZQZGUBPZPZABEUAPZQZEUBPZPZABCQZ
      ABDQZVFVJVHVMPZVNVBVEVHHNZVJVQRZVBGMNZVEVREFGLUCZVTVCVDVRABGVGHIVGSZUDTUE
      UTVAVRVSVHEFVIVMGHIVMSZVISZLUFUGUHVFVHVLVMABEFVGVKGHIVKSZWBLUIUJUKVBVTVEV
      OVJRZWAVTVCVDWFABCGVGVIHIWBWDKULTUEVBVEAEUMPZNZBWGNZOZVPVNRZVBVEWJVBVCWHV
      DWIVBHWGAEFGWGHWGSZILUNZUOVBHWGBWMUOUPURUTWJWKVAUTWHWIWKABDEVKVMWGWLWEWCJ
      ULTUQUHUS $.

    $( The induced metric on a subspace is a restriction of the induced metric
       on the parent space.  (Contributed by NM, 1-Feb-2008.)
       (New usage is discouraged.) $)
    sspims $p |- ( ( U e. NrmCVec /\ W e. H ) -> C = ( D |` ( Y X. Y ) ) ) $=
      ( vx vy cr cv sspimsval imsdf cba cfv eqid sspmlem ) KLMMCABDEFGJKNLNABCD
      EFGHIJOAEFGIPBCCQRZUASHPT $.
  $}

  $( Define the class of all complete subspaces of a complex normed vector
     space. $)
  $(
  $c CSubSp $.
  ccs $a class SubSp $.
  df-cs $a |- CSubSp = { <. u , s >. | ( u e. NrmCVec /\ s =
       ( ( SubSp ` u ) |^| CBan ) ) } $.
  $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                     Operators on complex vector spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definitions and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LnOp $.
  $c normOpOLD $.
  $c BLnOp $.
  $c 0op $.

  $( Extend class notation with the class of linear operators on normed complex
     vector spaces. $)
  clno $a class LnOp $.

  $( Extend class notation with the class of operator norms on normed complex
     vector spaces. $)
  cnmoo $a class normOpOLD $.

  $( Extend class notation with the class of bounded linear operators on normed
     complex vector spaces. $)
  cblo $a class BLnOp $.

  $( Extend class notation with the class of zero operators on normed complex
     vector spaces. $)
  c0o $a class 0op $.

  ${
    $d t u w x y z $.
    $( Define the class of linear operators between two normed complex vector
       spaces.  In the literature, an operator may be a partial function, i.e.
       the domain of an operator is not necessarily the entire vector space.
       However, since the domain of a linear operator is a vector subspace, we
       define it with a complete function for convenience and will use subset
       relations to specify the partial function case.  (Contributed by NM,
       6-Nov-2007.)  (New usage is discouraged.) $)
    df-lno $a |- LnOp = ( u e. NrmCVec , w e. NrmCVec |->
    { t e. ( ( BaseSet ` w ) ^m ( BaseSet ` u ) ) |
       A. x e. CC A. y e. ( BaseSet ` u ) A. z e. ( BaseSet ` u )
      ( t ` ( ( x ( .sOLD ` u ) y ) ( +v ` u ) z ) ) =
         ( ( x ( .sOLD ` w ) ( t ` y ) ) ( +v ` w ) ( t ` z ) ) } ) $.

    $( Define the norm of an operator between two normed complex vector
       spaces.  This definition produces an operator norm function for each
       pair of vector spaces ` <. u , w >. ` .  Based on definition of linear
       operator norm in [AkhiezerGlazman] p. 39, although we define it for all
       operators for convenience.  It isn't necessarily meaningful for
       nonlinear operators, since it doesn't take into account operator values
       at vectors with norm greater than 1.  See Equation 2 of [Kreyszig] p. 92
       for a definition that does (although it ignores the value at the zero
       vector).  However, operator norms are rarely if ever used for nonlinear
       operators.  (Contributed by NM, 6-Nov-2007.)
       (New usage is discouraged.) $)
    df-nmoo $a |- normOpOLD = ( u e. NrmCVec , w e. NrmCVec |->
                ( t e. ( ( BaseSet ` w ) ^m ( BaseSet ` u ) ) |->
        sup ( { x | E. z e. ( BaseSet ` u ) ( ( ( normCV ` u ) ` z ) <_ 1 /\
            x = ( ( normCV ` w ) ` ( t ` z ) ) ) } , RR* , < ) ) ) $.

    $( Define the class of bounded linear operators between two normed complex
       vector spaces.  (Contributed by NM, 6-Nov-2007.)
       (New usage is discouraged.) $)
    df-blo $a |- BLnOp = ( u e. NrmCVec , w e. NrmCVec |->
      { t e. ( u LnOp w ) | ( ( u normOpOLD w ) ` t ) < +oo } ) $.

    $( Define the zero operator between two normed complex vector spaces.
       (Contributed by NM, 28-Nov-2007.)  (New usage is discouraged.) $)
    df-0o $a |- 0op = ( u e. NrmCVec , w e. NrmCVec |->
                        ( ( BaseSet ` u ) X. { ( 0vec ` w ) } ) ) $.
  $}

  $c adj $.
  $( Adjoint of an operator. $)
  caj $a class adj $.

  $c HmOp $.
  $( Set of Hermitional (self-adjoint) operators. $)
  chmo $a class HmOp $.

  ${
    $d a o s t u w x y $.
    $( Define the adjoint of an operator (if it exists).  The domain of
       ` U adj W ` is the set of all operators from ` U ` to ` W ` that have an
       adjoint.  Definition 3.9-1 of [Kreyszig] p. 196, although we don't
       require that ` U ` and ` W ` be Hilbert spaces nor that the operators be
       linear.  Although we define it for any normed vector space for
       convenience, the definition is meaningful only for inner product
       spaces.  (Contributed by NM, 25-Jan-2008.)
       (New usage is discouraged.) $)
    df-aj $a |- adj = ( u e. NrmCVec , w e. NrmCVec |->
        { <. t , s >. | ( t : ( BaseSet ` u ) --> ( BaseSet ` w ) /\
                          s : ( BaseSet ` w ) --> ( BaseSet ` u ) /\
        A. x e. ( BaseSet ` u ) A. y e. ( BaseSet ` w )
          ( ( t ` x ) ( .iOLD ` w ) y ) = ( x ( .iOLD ` u ) ( s ` y ) ) ) } )
        $.

    $( Define the set of Hermitian (self-adjoint) operators on a normed complex
       vector space (normally a Hilbert space).  Although we define it for any
       normed vector space for convenience, the definition is meaningful only
       for inner product spaces.  (Contributed by NM, 26-Jan-2008.)
       (New usage is discouraged.) $)
    df-hmo $a |- HmOp = ( u e. NrmCVec |->
                { t e. dom ( u adj u ) | ( ( u adj u ) ` t ) = t } ) $.

$(
    @( Alternate definition of the set of Hermitian (self-adjoint) operators on
       a normed complex vector space (normally a Hilbert space). @)
    dfhm2 @p |- HmOp = { <. u , o >. | ( u e. NrmCVec /\ o = { t | ( t :
  ( BaseSet ` u ) --> ( BaseSet ` u ) /\ A. x e. ( BaseSet ` u ) A. y e.
  ( BaseSet ` u ) ( x ( .iOLD ` u ) ( t ` y ) ) = ( ( t ` x ) ( .iOLD ` u ) y )
       ) } ) } @=
      (  ) ? @.
      @( [ ?] @) @( [8-Feb-2008] @)
$)
  $}

  ${
    $d t u w x y z U $.  $d t u w x y z W $.  $d t u w y z X $.  $d t u w Y $.
    $d t u w G $.  $d t u w R $.  $d t u w H $.  $d t u w S $.
    $d t u w x y z T $.
    lnoval.1 $e |- X = ( BaseSet ` U ) $.
    lnoval.2 $e |- Y = ( BaseSet ` W ) $.
    lnoval.3 $e |- G = ( +v ` U ) $.
    lnoval.4 $e |- H = ( +v ` W ) $.
    lnoval.5 $e |- R = ( .sOLD ` U ) $.
    lnoval.6 $e |- S = ( .sOLD ` W ) $.
    lnoval.7 $e |- L = ( U LnOp W ) $.
    $( The set of linear operators between two normed complex vector spaces.
       (Contributed by NM, 6-Nov-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    lnoval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> L =
      { t e. ( Y ^m X ) | A. x e. CC A. y e. X A. z e. X
        ( t ` ( ( x R y ) G z ) ) = ( ( x S ( t ` y ) ) H ( t ` z ) ) } ) $=
      ( vu vw cnv wcel wa clno co cv cfv wceq wral cc cmap crab cns cpv syl6eqr
      cba fveq2 oveq2d oveqd oveq123d fveq2d eqeq1d raleqbidv ralbidv rabeqbidv
      eqidd oveq1d eqeq2d 2ralbidv df-lno ovex rabex ovmpt2 syl5eq ) GUCUDKUCUD
      UEJGKUFUGAUHZBUHZEUGZCUHZHUGZDUHZUIZVQVRWBUIZFUGZVTWBUIZIUGZUJZCLUKBLUKZA
      ULUKZDMLUMUGZUNZTUAUBGKUCUCVQVRUAUHZUOUIZUGZVTWMUPUIZUGZWBUIZVQWDUBUHZUOU
      IZUGZWFWSUPUIZUGZUJZCWMURUIZUKZBXEUKZAULUKZDWSURUIZXEUMUGZUNWLUFWCXCUJZCL
      UKZBLUKZAULUKZDXILUMUGZUNWMGUJZXHXNDXJXOXPXELXIUMXPXEGURUILWMGURUSNUQZUTX
      PXGXMAULXPXFXLBXELXQXPXDXKCXELXQXPWRWCXCXPWQWAWBXPWOVSVTVTWPHXPWPGUPUIHWM
      GUPUSPUQXPWNEVQVRXPWNGUOUIEWMGUOUSRUQVAXPVTVHVBVCVDVEVEVFVGWSKUJZXNWJDXOW
      KXRXIMLUMXRXIKURUIMWSKURUSOUQVIXRXMWIAULXRXKWHBCLLXRXCWGWCXRXAWEWFWFXBIXR
      XBKUPUIIWSKUPUSQUQXRWTFVQWDXRWTKUOUIFWSKUOUSSUQVAXRWFVHVBVJVKVFVGABCUBUAD
      VLWJDWKMLUMVMVNVOVP $.

    $( The predicate "is a linear operator."  (Contributed by NM, 4-Dec-2007.)
       (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    islno $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> ( T e. L <->
      ( T : X --> Y /\ A. x e. CC A. y e. X A. z e. X
      ( T ` ( ( x R y ) G z ) ) = ( ( x S ( T ` y ) ) H ( T ` z ) ) ) ) ) $=
      ( vw cnv wcel wa cv co cfv wceq wral cc cmap crab wf lnoval eleq2d oveq2d
      fveq1 oveq12d eqeq12d 2ralbidv ralbidv elrab cba cvv eqeltri elmap anbi1i
      fvex bitri syl6bb ) GUBUCKUBUCUDZFJUCFAUEZBUEZDUFCUEZHUFZUAUEZUGZVLVMVPUG
      ZEUFZVNVPUGZIUFZUHZCLUIBLUIZAUJUIZUAMLUKUFZULZUCZLMFUMZVOFUGZVLVMFUGZEUFZ
      VNFUGZIUFZUHZCLUIBLUIZAUJUIZUDZVKJWFFABCUADEGHIJKLMNOPQRSTUNUOWGFWEUCZWPU
      DWQWDWPUAFWEVPFUHZWCWOAUJWSWBWNBCLLWSVQWIWAWMVOVPFUQWSVSWKVTWLIWSVRWJVLEV
      MVPFUQUPVNVPFUQURUSUTVAVBWRWHWPMLFMKVCUGVDOKVCVHVELGVCUGVDNGVCVHVEVFVGVIV
      J $.

    $d t u w A $.  $d t w B $.  $d t C $.
    $( Basic linearity property of a linear operator.  (Contributed by NM,
       4-Dec-2007.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    lnolin $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
       ( A e. CC /\ B e. X /\ C e. X ) ) ->
      ( T ` ( ( A R B ) G C ) ) = ( ( A S ( T ` B ) ) H ( T ` C ) ) ) $=
      ( vu vw vt cnv wcel w3a cv co cfv wceq wral cc wf wa islno biimp3a simprd
      oveq1 oveq1d fveq2d eqeq12d oveq2 fveq2 oveq2d rspc3v mpan9 ) GUDUEZKUDUE
      ZFJUEZUFZUAUGZUBUGZDUHZUCUGZHUHZFUIZVKVLFUIZEUHZVNFUIZIUHZUJZUCLUKUBLUKUA
      ULUKZAULUEBLUECLUEUFABDUHZCHUHZFUIZABFUIZEUHZCFUIZIUHZUJZVJLMFUMZWBVGVHVI
      WKWBUNUAUBUCDEFGHIJKLMNOPQRSTUOUPUQWAWJAVLDUHZVNHUHZFUIZAVQEUHZVSIUHZUJWC
      VNHUHZFUIZWGVSIUHZUJUAUBUCABCULLLVKAUJZVPWNVTWPWTVOWMFWTVMWLVNHVKAVLDURUS
      UTWTVRWOVSIVKAVQEURUSVAVLBUJZWNWRWPWSXAWMWQFXAWLWCVNHVLBADVBUSUTXAWOWGVSI
      XAVQWFAEVLBFVCVDUSVAVNCUJZWRWEWSWIXBWQWDFVNCWCHVBUTXBVSWHWGIVNCFVCVDVAVEV
      F $.
  $}

  ${
    $d x y z T $.  $d x y z U $.  $d x y z W $.  $d x y z X $.
    lnof.1 $e |- X = ( BaseSet ` U ) $.
    lnof.2 $e |- Y = ( BaseSet ` W ) $.
    lnof.7 $e |- L = ( U LnOp W ) $.
    $( A linear operator is a mapping.  (Contributed by NM, 4-Dec-2007.)
       (Revised by Mario Carneiro, 18-Nov-2013.)
       (New usage is discouraged.) $)
    lnof $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) -> T : X --> Y ) $=
      ( vx vy vz cnv wcel cv cns cfv co wral eqid wf wa cpv wceq islno simprbda
      cc 3impa ) BMNZDMNZACNZEFAUAZUIUJUBUKULJOZKOZBPQZRLOZBUCQZRAQUMUNAQDPQZRU
      PAQDUCQZRUDLESKESJUGSJKLUOURABUQUSCDEFGHUQTUSTUOTURTIUEUFUH $.
  $}

  ${
    lno0.1 $e |- X = ( BaseSet ` U ) $.
    lno0.2 $e |- Y = ( BaseSet ` W ) $.
    lno0.5 $e |- Q = ( 0vec ` U ) $.
    lno0.z $e |- Z = ( 0vec ` W ) $.
    lno0.7 $e |- L = ( U LnOp W ) $.
    $( The value of a linear operator at zero is zero.  (Contributed by NM,
       4-Dec-2007.)  (Revised by Mario Carneiro, 18-Nov-2013.)
       (New usage is discouraged.) $)
    lno0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L )
         -> ( T ` Q ) = Z ) $=
      ( cnv wcel w3a cfv co wceq eqid c1 cneg cns cpv neg1cn a1i nvzcl 3ad2ant1
      cc 3jca lnolin mpdan nvlinv fveq2d simp2 lnof ffvelrnd syl2anc 3eqtr3d )
      CNOZENOZBDOZPZUAUBZACUCQZRACUDQZRZBQZVDABQZEUCQZRVIEUDQZRZVIHVCVDUIOZAFOZ
      VNPVHVLSVCVMVNVNVMVCUEUFUTVAVNVBCFAIKUGZUHZVPUJVDAAVEVJBCVFVKDEFGIJVFTZVK
      TZVETZVJTZMUKULUTVAVHVISVBUTVGABUTVNVGASVOAVECVFFAIVQVSKUMULUNUHVCVAVIGOV
      LHSUTVAVBUOVCFGABBCDEFGIJMUPVPUQVIVJEVKGHJVRVTLUMURUS $.
  $}

  ${
    $d x y z S $.  $d x y z T $.  $d x y z U $.  $d x y z X $.
    lnocoi.l $e |- L = ( U LnOp W ) $.
    lnocoi.m $e |- M = ( W LnOp X ) $.
    lnocoi.n $e |- N = ( U LnOp X ) $.
    lnocoi.u $e |- U e. NrmCVec $.
    lnocoi.w $e |- W e. NrmCVec $.
    lnocoi.x $e |- X e. NrmCVec $.
    lnocoi.s $e |- S e. L $.
    lnocoi.t $e |- T e. M $.
    $( The composition of two linear operators is linear.  (Contributed by NM,
       12-Jan-2008.)  (Revised by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    lnocoi $p |- ( T o. S ) e. N $=
      ( wcel cfv co eqid vx vy vz ccom cba wf cv cns cpv wceq wral cc cnv mp3an
      fco mp2an w3a wa nvscl mp3an1 nvgcl sylan 3impa fvco3 sylancr id ffvelrni
      lnof 3pm3.2i lnolin mpan syl3an fveq2d simp2 oveq2d simp3 3eqtr4rd eqtr4d
      oveq12d rgen3 wb islno mpbir2an ) BAUDZFQZCUERZHUERZWDUFZUAUGZUBUGZCUHRZS
      ZUCUGZCUIRZSZWDRZWIWJWDRZHUHRZSZWMWDRZHUIRZSZUJZUCWFUKUBWFUKUAULUKZGUERZW
      GBUFZWFXEAUFZWHGUMQZHUMQZBEQZXFMNPBGEHXEWGXETZWGTZJVHUNCUMQZXHADQZXGLMOAC
      DGWFXEWFTZXKIVHUNZWFXEWGBAUOUPXCUAUBUCULWFWFWIULQZWJWFQZWMWFQZUQZWPWOARZB
      RZXBXTXGWOWFQZWPYBUJXPXQXRXSYCXQXRURWLWFQZXSYCXMXQXRYDLWIWJWKCWFXOWKTZUSU
      TXMYDXSYCLWLWMCWNWFXOWNTZVAUTVBVCWFXEWOBAVDVEXTWIWJARZGUHRZSWMARZGUIRZSZB
      RZWIYGBRZWRSZYIBRZXASZYBXBXQXQXRYGXEQZXSYIXEQZYLYPUJZXQVFWFXEWJAXPVGWFXEW
      MAXPVGXHXIXJUQXQYQYRUQYSXHXIXJMNPVIWIYGYIYHWRBGYJXAEHXEWGXKXLYJTZXATZYHTZ
      WRTZJVJVKVLXTYAYKBXMXHXNUQXTYAYKUJXMXHXNLMOVIWIWJWMWKYHACWNYJDGWFXEXOXKYF
      YTYEUUBIVJVKVMXTWSYNWTYOXAXTWQYMWIWRXTXGXRWQYMUJXPXQXRXSVNWFXEWJBAVDVEVOX
      TXGXSWTYOUJXPXQXRXSVPWFXEWMBAVDVEVSVQVRVTXMXIWEWHXDURWALNUAUBUCWKWRWDCWNX
      AFHWFWGXOXLYFUUAYEUUCKWBUPWC $.
  $}

  ${
    lnoadd.1 $e |- X = ( BaseSet ` U ) $.
    lnoadd.5 $e |- G = ( +v ` U ) $.
    lnoadd.6 $e |- H = ( +v ` W ) $.
    lnoadd.7 $e |- L = ( U LnOp W ) $.
    $( Addition property of a linear operator.  (Contributed by NM,
       7-Dec-2007.)  (Revised by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    lnoadd $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
  ( A e. X /\ B e. X ) ) -> ( T ` ( A G B ) ) = ( ( T ` A ) H ( T ` B ) ) ) $=
      ( cnv wcel c1 cfv co wceq eqid w3a wa cns ax-1cn cba lnolin mp3anr1 simp1
      cc simpl nvsid syl2an oveq1d fveq2d simpl2 lnof ffvelrn syl2anc 3eqtr3d
      wf ) DNOZHNOZCGOZUAZAIOZBIOZUBZUBZPADUCQZRZBERZCQZPACQZHUCQZRZBCQZFRZABER
      ZCQVMVPFRVDPUIOVEVFVLVQSUDPABVIVNCDEFGHIHUEQZJVSTZKLVITZVNTZMUFUGVHVKVRCV
      HVJABEVDVAVEVJASVGVAVBVCUHVEVFUJZAVIDIJWAUKULUMUNVHVOVMVPFVHVBVMVSOZVOVMS
      VAVBVCVGUOVDIVSCUTVEWDVGCDGHIVSJVTMUPWCIVSACUQULVMVNHVSVTWBUKURUMUS $.
  $}

  ${
    lnosub.1 $e |- X = ( BaseSet ` U ) $.
    lnosub.5 $e |- M = ( -v ` U ) $.
    lnosub.6 $e |- N = ( -v ` W ) $.
    lnosub.7 $e |- L = ( U LnOp W ) $.
    $( Subtraction property of a linear operator.  (Contributed by NM,
       7-Dec-2007.)  (Revised by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    lnosub $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
  ( A e. X /\ B e. X ) ) -> ( T ` ( A M B ) ) = ( ( T ` A ) N ( T ` B ) ) ) $=
      ( cnv wcel wa cfv co wceq eqid w3a cneg cns cpv neg1cn cba lnolin mp3anr1
      c1 cc ancom2s nvmval2 3expb 3ad2antl1 fveq2d simpl2 wf lnof simpl ffvelrn
      syl2an simpr syl3anc 3eqtr4d ) DNOZHNOZCEOZUAZAIOZBIOZPZPZUIUBZBDUCQZRADU
      DQZRZCQZVMBCQZHUCQZRACQZHUDQZRZABFRZCQVTVRGRZVHVJVIVQWBSZVHVMUJOVJVIWEUEV
      MBAVNVSCDVOWAEHIHUFQZJWFTZVOTZWATZVNTZVSTZMUGUHUKVLWCVPCVEVFVKWCVPSZVGVEV
      IVJWLABVNDVOFIJWHWJKULUMUNUOVLVFVTWFOZVRWFOZWDWBSVEVFVGVKUPVHIWFCUQZVIWMV
      KCDEHIWFJWGMURZVIVJUSIWFACUTVAVHWOVJWNVKWPVIVJVBIWFBCUTVAVTVRVSHWAGWFWGWI
      WKLULVCVD $.
  $}

  ${
    lnomul.1 $e |- X = ( BaseSet ` U ) $.
    lnomul.5 $e |- R = ( .sOLD ` U ) $.
    lnomul.6 $e |- S = ( .sOLD ` W ) $.
    lnomul.7 $e |- L = ( U LnOp W ) $.
    $( Scalar multiplication property of a linear operator.  (Contributed by
       NM, 5-Dec-2007.)  (Revised by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    lnomul $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\
       ( A e. CC /\ B e. X ) ) -> ( T ` ( A R B ) ) = ( A S ( T ` B ) ) ) $=
      ( cnv wcel wa co cfv wceq eqid w3a cc cn0v cpv simpl simprl simprr simpl1
      nvzcl syl lnolin syl13anc nvscl syl3anc nv0rid syl2anc fveq2d lno0 oveq2d
      cba adantr simpl2 wf lnof ffvelrnd eqtrd 3eqtr3d ) FNOZHNOZEGOZUAZAUBOZBI
      OZPZPZABCQZFUCRZFUDRZQZERZABERZDQZVQERZHUDRZQZVPERWBVOVKVLVMVQIOZVTWESVKV
      NUEVKVLVMUFZVKVLVMUGZVOVHWFVHVIVJVNUHZFIVQJVQTZUIUJABVQCDEFVRWDGHIHUTRZJW
      KTZVRTZWDTZKLMUKULVOVSVPEVOVHVPIOZVSVPSWIVOVHVLVMWOWIWGWHABCFIJKUMUNVPFVR
      IVQJWMWJUOUPUQVOWEWBHUCRZWDQZWBVKWEWQSVNVKWCWPWBWDVQEFGHIWKWPJWLWJWPTZMUR
      USVAVOVIWBWKOZWQWBSVHVIVJVNVBZVOVIVLWAWKOWSWTWGVOIWKBEVKIWKEVCVNEFGHIWKJW
      LMVDVAWHVEAWADHWKWLLUMUNWBHWDWKWPWLWNWRUOUPVFVG $.
  $}

  ${
    nvo00.1 $e |- X = ( BaseSet ` U ) $.
    $( Two ways to express a zero operator.  (Contributed by NM, 27-Nov-2007.)
       (New usage is discouraged.) $)
    nvo00 $p |- ( ( U e. NrmCVec /\ T : X --> Y ) ->
                  ( T = ( X X. { Z } ) <-> ran T = { Z } ) ) $=
      ( wf wfn c0 wne csn cxp wceq crn wb cnv wcel ffn cn0v cfv eqid nvzcl ne0i
      syl fconst5 syl2anr ) CDAGACHCIJZACEKZLMANUHMOBPQZCDARUIBSTZCQUGBCUJFUJUA
      UBCUJUCUDCEAUEUF $.
  $}

  ${
    $d t u w x z U $.  $d t u w x z W $.  $d t u w z X $.  $d t u w x Y $.
    $d t u w L $.  $d t u w M $.  $d t x z T $.
    nmoofval.1 $e |- X = ( BaseSet ` U ) $.
    nmoofval.2 $e |- Y = ( BaseSet ` W ) $.
    nmoofval.3 $e |- L = ( normCV ` U ) $.
    nmoofval.4 $e |- M = ( normCV ` W ) $.
    nmoofval.6 $e |- N = ( U normOpOLD W ) $.
    $( The operator norm function.  (Contributed by NM, 6-Nov-2007.)  (Revised
       by Mario Carneiro, 16-Nov-2013.)  (New usage is discouraged.) $)
    nmoofval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> N =
       ( t e. ( Y ^m X ) |-> sup ( { x | E. z e. X
         ( ( L ` z ) <_ 1 /\ x = ( M ` ( t ` z ) ) ) } , RR* , < ) ) ) $=
      ( cmap cv cfv cba cnmcv vu vw cnv wcel wa cnmoo cle wbr wceq wrex cab cxr
      co c1 clt csup fveq2 syl6eqr oveq2d fveq1d breq1d anbi1d rexeqbidv abbidv
      cmpt supeq1d mpteq12dv oveq1d eqeq2d anbi2d rexbidv df-nmoo ovmpt2 syl5eq
      ovex mptex ) DUCUDHUCUDUEGDHUFUMCJIPUMZBQZERZUNUGUHZAQZVRCQRZFRZUIZUEZBIU
      JZAUKZULUOUPZVEZOUAUBDHUCUCCUBQZSRZUAQZSRZPUMZVRWLTRZRZUNUGUHZWAWBWJTRZRZ
      UIZUEZBWMUJZAUKZULUOUPZVEWIUFCWKIPUMZVTWTUEZBIUJZAUKZULUOUPZVEWLDUIZCWNXD
      XEXIXJWMIWKPXJWMDSRIWLDSUQKURZUSXJULXCXHUOXJXBXGAXJXAXFBWMIXKXJWQVTWTXJWP
      VSUNUGXJVRWOEXJWODTREWLDTUQMURUTVAVBVCVDVFVGWJHUIZCXEXIVQWHXLWKJIPXLWKHSR
      JWJHSUQLURVHXLULXHWGUOXLXGWFAXLXFWEBIXLWTWDVTXLWSWCWAXLWBWRFXLWRHTRFWJHTU
      QNURUTVIVJVKVDVFVGABUBUACVLCVQWHJIPVOVPVMVN $.

    $( The operator norm function.  (Contributed by NM, 27-Nov-2007.)  (Revised
       by Mario Carneiro, 16-Nov-2013.)  (New usage is discouraged.) $)
    nmooval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
      ( N ` T ) = sup ( { x | E. z e. X
        ( ( L ` z ) <_ 1 /\ x = ( M ` ( T ` z ) ) ) } , RR* , < ) ) $=
      ( vt cfv wceq cxr clt cnv wcel wf cv c1 cle wbr wa wrex cab csup cmap cba
      co cvv fvex eqeltri elmap cmpt nmoofval fveq1d fveq1 fveq2d eqeq2d anbi2d
      rexbidv abbidv supeq1d eqid xrltso supex fvmpt sylan9eq sylan2br 3impa )
      DUAUBZHUAUBZIJCUCZCGQZBUDZEQUEUFUGZAUDZVTCQZFQZRZUHZBIUIZAUJZSTUKZRZVRVPV
      QUHZCJIULUNZUBZWJJICJHUMQUOLHUMUPUQIDUMQUOKDUMUPUQURWKWMVSCPWLWAWBVTPUDZQ
      ZFQZRZUHZBIUIZAUJZSTUKZUSZQWIWKCGXBABPDEFGHIJKLMNOUTVAPCXAWIWLXBWNCRZSWTW
      HTXCWSWGAXCWRWFBIXCWQWEWAXCWPWDWBXCWOWCFVTWNCVBVCVDVEVFVGVHXBVISWHTVJVKVL
      VMVNVO $.
  $}

  ${
    $d x z T $.  $d x z W $.  $d x z X $.  $d x z Y $.
    nmosetre.2 $e |- Y = ( BaseSet ` W ) $.
    nmosetre.4 $e |- N = ( normCV ` W ) $.
    $( The set in the supremum of the operator norm definition ~ df-nmoo is a
       set of reals.  (Contributed by NM, 13-Nov-2007.)
       (New usage is discouraged.) $)
    nmosetre $p |- ( ( W e. NrmCVec /\ T : X --> Y ) -> {
     x | E. z e. X ( ( M ` z ) <_ 1 /\ x = ( N ` ( T ` z ) ) ) } C_ RR ) $=
      ( cnv wcel wf wa cv cfv c1 cle wbr cr wceq wrex ffvelrn nvcl sylan2 eleq1
      anassrs syl5ibr impcom adantrl exp31 rexlimdv abssdv ) FKLZGHCMZNZBOZDPQR
      SZAOZUQCPZEPZUAZNZBGUBATUPVCUSTLZBGUPUQGLZVCVDUPVENZVBVDURVBVFVDVFVDVBVAT
      LZUNUOVEVGUOVENUNUTHLVGGHUQCUCUTFEHIJUDUEUGUSVATUFUHUIUJUKULUM $.
  $}

  ${
    $d x y M $.  $d x y N $.  $d x y T $.  $d x y X $.  $d x y Z $.
    nmosetn0.1 $e |- X = ( BaseSet ` U ) $.
    nmosetn0.5 $e |- Z = ( 0vec ` U ) $.
    nmosetn0.4 $e |- M = ( normCV ` U ) $.
    $( The set in the supremum of the operator norm definition ~ df-nmoo is
       nonempty.  (Contributed by NM, 8-Dec-2007.)
       (New usage is discouraged.) $)
    nmosetn0 $p |- ( U e. NrmCVec -> ( N ` ( T ` Z ) ) e. { x | E. y e. X (
       ( M ` y ) <_ 1 /\ x = ( N ` ( T ` y ) ) ) } ) $=
      ( wcel cv cfv c1 cle wbr wceq wa wrex cnv cab cc0 nvz0 0le1 syl6eqbr eqid
      nvzcl jctir fveq2 breq1d fveq2d eqeq2d anbi12d rspcev syl2anc fvex anbi2d
      eqeq1 rexbidv elab sylibr ) DUALZBMZENZOPQZHCNZFNZVDCNZFNZRZSZBGTZVHVFAMZ
      VJRZSZBGTZAUBLVCHGLHENZOPQZVHVHRZSZVMDGHIJUHVCVSVTVCVRUCOPDEHJKUDUEUFVHUG
      UIVLWABHGVDHRZVFVSVKVTWBVEVROPVDHEUJUKWBVJVHVHWBVIVGFVDHCUJULUMUNUOUPVQVM
      AVHVGFUQVNVHRZVPVLBGWCVOVKVFVNVHVJUSURUTVAVB $.
  $}

  ${
    $d x z T $.  $d x z U $.  $d x z W $.  $d x z X $.  $d x z Y $.
    nmoxr.1 $e |- X = ( BaseSet ` U ) $.
    nmoxr.2 $e |- Y = ( BaseSet ` W ) $.
    nmoxr.3 $e |- N = ( U normOpOLD W ) $.
    $( The norm of an operator is an extended real.  (Contributed by NM,
       27-Nov-2007.)  (New usage is discouraged.) $)
    nmoxr $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
              ( N ` T ) e. RR* ) $=
      ( vz vx cnv wcel wf cfv cv cnmcv wa cxr eqid w3a c1 cle wbr wceq wrex cab
      clt csup nmooval wss nmosetre ressxr syl6ss supxrcl syl 3adant1 eqeltrd
      cr ) BLMZDLMZEFANZUAACOJPZBQOZOUBUCUDKPVCAODQOZOUERJEUFKUGZSUHUIZSKJABVDV
      ECDEFGHVDTVETZIUJVAVBVGSMZUTVAVBRZVFSUKVIVJVFUSSKJAVDVEDEFHVHULUMUNVFUOUP
      UQUR $.

    $( The norm of an operator is nonnegative.  (Contributed by NM,
       8-Dec-2007.)  (New usage is discouraged.) $)
    nmooge0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                  0 <_ ( N ` T ) ) $=
      ( vz vx cnv wcel cc0 cfv cnmcv cxr eqid cle wbr wf w3a cn0v 0xr a1i simp2
      cr nvzcl ffvelrn sylan2 3adant2 nvcl syl2anc rexrd nmoxr nvge0 cv c1 wceq
      ancoms wa wrex cab clt wss nmosetre ressxr syl6ss nmosetn0 supxrub syl2an
      csup 3impa 3comr nmooval breqtrrd xrletrd ) BLMZDLMZEFAUAZUBZNBUCOZAOZDPO
      ZOZACOZNQMWAUDUEWAWEWAVSWCFMZWEUGMVRVSVTUFZVRVTWGVSVTVRWGVRVTWBEMWGBEWBGW
      BRZUHEFWBAUIUJUTUKZWCDWDFHWDRZULUMUNABCDEFGHIUOWAVSWGNWESTWHWJWCDWDFHWKUP
      UMWAWEJUQZBPOZOURSTKUQWLAOWDOUSVAJEVBKVCZQVDVLZWFSVSVTVRWEWOSTZVSVTVRWPVS
      VTVAZWNQVEWEWNMWPVRWQWNUGQKJAWMWDDEFHWKVFVGVHKJABWMWDEWBGWIWMRZVIWNWEVJVK
      VMVNKJABWMWDCDEFGHWRWKIVOVPVQ $.

    $( The norm of an operator is either real or plus infinity.  (Contributed
       by NM, 8-Dec-2007.)  (New usage is discouraged.) $)
    nmorepnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                   ( ( N ` T ) e. RR <-> ( N ` T ) =/= +oo ) ) $=
      ( vz vx cnv wcel cv cnmcv cfv cr cpnf wne eqid wf w3a c1 cle wceq wa wrex
      wbr cab cxr clt csup wss nmosetre cn0v nmosetn0 ne0i syl supxrre2 syl2anr
      wb c0 3impb nmooval eleq1d neeq1d 3bitr4d ) BLMZDLMZEFAUAZUBZJNZBOPZPUCUD
      UHKNVLAPDOPZPUEUFJEUGKUIZUJUKULZQMZVPRSZACPZQMVSRSVHVIVJVQVRVAZVIVJUFVOQU
      MVOVBSZVTVHKJAVMVNDEFHVNTZUNVHBUOPZAPVNPZVOMWAKJABVMVNEWCGWCTVMTZUPVOWDUQ
      URVOUSUTVCVKVSVPQKJABVMVNCDEFGHWEWBIVDZVEVKVSVPRWFVFVG $.

    $( The norm of any operator is real iff it is less than plus infinity.
       (Contributed by NM, 8-Dec-2007.)  (New usage is discouraged.) $)
    nmoreltpnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                   ( ( N ` T ) e. RR <-> ( N ` T ) < +oo ) ) $=
      ( cnv wcel wf w3a cfv cr cpnf wne clt wbr nmorepnf cxr wceq wn wb nltpnft
      nmoxr syl necon2abid bitr4d ) BJKDJKEFALMZACNZOKUKPQUKPRSZABCDEFGHITUJULU
      KPUJUKUAKUKPUBULUCUDABCDEFGHIUFUKUEUGUHUI $.

    $( The norm of an operator is greater than minus infinity.  (Contributed by
       NM, 8-Dec-2007.)  (New usage is discouraged.) $)
    nmogtmnf $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) ->
                  -oo < ( N ` T ) ) $=
      ( cnv wcel wf w3a cfv cr cpnf wceq wn wb wo cmnf clt wbr wne df-ne syl6bb
      nmorepnf xor3 wa nbi2 simplbi sylbir mnfltxr 3syl ) BJKDJKEFALMZACNZOKZUP
      PQZRZSZUQURTZUAUPUBUCUOUQUPPUDUSABCDEFGHIUGUPPUEUFUTUQURSRZVAUQURUHVBVAUQ
      URUIRUQURUJUKULUPUMUN $.
  $}

  ${
    $d x y A $.  $d x y L $.  $d x y M $.  $d x y T $.  $d x y U $.
    $d x y W $.  $d x y X $.  $d x y Y $.
    nmolb.1 $e |- X = ( BaseSet ` U ) $.
    nmolb.2 $e |- Y = ( BaseSet ` W ) $.
    nmolb.l $e |- L = ( normCV ` U ) $.
    nmolb.m $e |- M = ( normCV ` W ) $.
    nmolb.3 $e |- N = ( U normOpOLD W ) $.
    $( A lower bound for an operator norm.  (Contributed by NM, 8-Dec-2007.)
       (New usage is discouraged.) $)
    nmoolb $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T : X --> Y ) /\
         ( A e. X /\ ( L ` A ) <_ 1 ) ) -> ( M ` ( T ` A ) ) <_ ( N ` T ) ) $=
      ( vy vx cfv cle wa wceq cnv wcel wf w3a c1 wbr cv wrex cab cxr clt wss cr
      nmosetre ressxr syl6ss 3adant1 fveq2 breq1d fveq2d eqeq2d anbi12d biantru
      csup eqid syl6bbr rspcev fvex eqeq1 anbi2d rexbidv sylibr supxrub nmooval
      elab syl2an adantr breqtrrd ) CUAUBZGUAUBZHIBUCZUDZAHUBADQZUERUFZSZSABQZE
      QZOUGZDQZUERUFZPUGZWHBQZEQZTZSZOHUHZPUIZUJUKVDZBFQZRWBWQUJULZWGWQUBZWGWRR
      UFWEVTWAWTVSVTWASWQUMUJPOBDEGHIKMUNUOUPUQWEWJWGWMTZSZOHUHZXAXCWDOAHWHATZX
      CWDWGWGTZSWDXEWJWDXBXFXEWIWCUERWHADURUSXEWMWGWGXEWLWFEWHABURUTVAVBXFWDWGV
      EVCVFVGWPXDPWGWFEVHWKWGTZWOXCOHXGWNXBWJWKWGWMVIVJVKVOVLWQWGVMVPWBWSWRTWEP
      OBCDEFGHIJKLMNVNVQVR $.
  $}

  ${
    $d x z A $.  $d f k r x y z L $.  $d x y U $.  $d x y W $.  $d k r x y Y $.
    $d f k r x y z M $.  $d f k r x y z T $.  $d f k r x y z X $.
    $d k r y N $.
    nmoubi.1 $e |- X = ( BaseSet ` U ) $.
    nmoubi.y $e |- Y = ( BaseSet ` W ) $.
    nmoubi.l $e |- L = ( normCV ` U ) $.
    nmoubi.m $e |- M = ( normCV ` W ) $.
    nmoubi.3 $e |- N = ( U normOpOLD W ) $.
    nmoubi.u $e |- U e. NrmCVec $.
    nmoubi.w $e |- W e. NrmCVec $.
    $( An upper bound for an operator norm.  (Contributed by NM, 11-Dec-2007.)
       (New usage is discouraged.) $)
    nmoubi $p |- ( ( T : X --> Y /\ A e. RR* ) -> ( ( N ` T ) <_ A <->
      A. x e. X ( ( L ` x ) <_ 1 -> ( M ` ( T ` x ) ) <_ A ) ) ) $=
      ( vz cle wi vy wf cxr wcel wa cfv wbr cv c1 wceq wrex cab wral clt wb cnv
      csup nmooval mp3an12 breq1d adantr wss cr nmosetre ressxr supxrleub sylan
      mpan syl6ss bitrd wal eqeq1 anbi2d rexbidv ralab ralcom4 ancomsimp impexp
      bitri albii breq1 imbi2d ceqsalv ralbii r19.23v 3bitr3i bitr4i syl6bb
      fvex ) IJCUBZBUCUDZUEZCGUFZBSUGZRUHZBSUGZRAUHZEUFUISUGZUAUHZWQCUFZFUFZUJZ
      UEZAIUKZUAULZUMZWRXABSUGZTZAIUMZWLWNXEUCUNUQZBSUGZXFWJWNXKUOWKWJWMXJBSDUP
      UDHUPUDZWJWMXJUJPQUAACDEFGHIJKLMNOURUSUTVAWJXEUCVBWKXKXFUOWJXEVCUCXLWJXEV
      CVBQUAACEFHIJLNVDVHVEVIRXEBVFVGVJXFWRWOXAUJZUEZAIUKZWPTZRVKZXIXDXOWPRUAWS
      WOUJZXCXNAIXRXBXMWRWSWOXAVLVMVNVOXNWPTZRVKZAIUMXSAIUMZRVKXIXQXSARIVPXTXHA
      IXTXMWRWPTZTZRVKXHXSYCRXSXMWRUEWPTYCWRXMWPVQXMWRWPVRVSVTYBXHRXAWTFWIXMWPX
      GWRWOXABSWAWBWCVSWDYAXPRXNWPAIWEVTWFWGWH $.

    $( An upper bound for an operator norm.  (Contributed by NM, 12-Dec-2007.)
       (New usage is discouraged.) $)
    nmoub3i $p |- ( ( T : X --> Y /\ A e. RR /\ A. x e. X
  ( M ` ( T ` x ) ) <_ ( A x. ( L ` x ) ) ) -> ( N ` T ) <_ ( abs ` A ) ) $=
      ( wcel cle wbr wf cr cv cfv cmul co wral cabs wa c1 cnv nvcl mpan remulcl
      wi sylan2 adantr recn abscld syl2an ad2antrr cc0 simpl nvge0 adantl leabs
      jca lemul1a syl31anc w3a 1re a1i absge0d 3jca lemul2a sylan recnd mulid1d
      wceq breqtrd letrd adantlll ffvelrn sylancr adantlr adantll ad2antlr letr
      syl3anc mpan2d ex com23 ralimdva imp wb rexrd nmoubi biimpar syldan 3impa
      cxr ) IJCUAZBUBRZAUCZCUDZFUDZBXDEUDZUEUFZSTZAIUGZCGUDBUHUDZSTZXBXCUIZXJXG
      UJSTZXFXKSTZUOZAIUGZXLXMXJXQXMXIXPAIXMXDIRZUIZXNXIXOXSXNXIXOUOXSXNUIXIXHX
      KSTZXOXCXRXNXTXBXCXRUIZXNUIZXHXKXGUEUFZXKYAXHUBRZXNXRXCXGUBRZYDDUKRZXRYEP
      XDDEIKMULUMZBXGUNUPZUQYAYCUBRZXNXCXKUBRZYEYIXRXCBBURZUSZYGXKXGUNUTUQXCYJX
      RXNYLVAYAXHYCSTZXNYAXCYJYEVBXGSTZUIZBXKSTZYMXCXRVCXCYJXRYLUQZXRYOXCXRYEYN
      YGYFXRYNPXDDEIKMVDUMVGVEXCYPXRBVFUQBXKXGVHVIUQYBYCXKUJUEUFZXKSYAYEUJUBRZY
      JVBXKSTZUIZVJXNYCYRSTYAYEYSUUAXRYEXCYGVEYSYAVKVLYAYJYTYQXCYTXRXCBYKVMUQVG
      VNXGUJXKVOVPXCYRXKVSXRXNXCXKXCXKYLVQVRVAVTWAWBXSXIXTUIXOUOZXNXSXFUBRZYDYJ
      UUBXBXRUUCXCXBXRUIHUKRXEJRUUCQIJXDCWCXEHFJLNULWDWEXCXRYDXBYHWFXCYJXBXRYLW
      GXFXHXKWHWIUQWJWKWLWMWNXMXLXQXCXBXKXARXLXQWOXCXKYLWPAXKCDEFGHIJKLMNOPQWQU
      PWRWSWT $.

    $( An upper bound for an operator norm.  (Contributed by NM, 11-Dec-2007.)
       (New usage is discouraged.) $)
    nmoub2i $p |- ( ( T : X --> Y /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. X
  ( M ` ( T ` x ) ) <_ ( A x. ( L ` x ) ) ) -> ( N ` T ) <_ A ) $=
      ( cle wbr cfv wf cr wcel cc0 wa cv cmul co wral w3a cabs nmoub3i 3adant2r
      wceq absid 3ad2ant2 breqtrd ) IJCUAZBUBUCZUDBRSZUEZAUFZCTFTBVBETUGUHRSAIU
      IZUJCGTZBUKTZBRURUSVCVDVERSUTABCDEFGHIJKLMNOPQULUMVAURVEBUNVCBUOUPUQ $.

    $( Two ways to express that an operator is bounded.  (Contributed by NM,
       11-Jan-2008.)  (New usage is discouraged.) $)
    nmobndi $p |- ( T : X --> Y -> ( ( N ` T ) e. RR <->
     E. r e. RR A. y e. X ( ( L ` y ) <_ 1 -> ( M ` ( T ` y ) ) <_ r ) ) ) $=
      ( cr wcel cle wf cfv cv wbr wrex c1 wral leid breq2 rspcev mpdan cxr cmnf
      wi wa clt cnv nmoxr mp3an12 adantr simprl nmogtmnf simprr xrre rexlimdvaa
      syl22anc impbid2 wb rexr nmoubi sylan2 rexbidva bitrd ) HIBUAZBFUBZRSZVOJ
      UCZTUDZJRUEZAUCZDUBUFTUDVTBUBEUBVQTUDUNAHUGZJRUEVNVPVSVPVOVOTUDZVSVOUHVRW
      BJVORVQVOVOTUIUJUKVNVRVPJRVNVQRSZVRUOZUOVOULSZWCUMVOUPUDZVRVPVNWEWDCUQSZG
      UQSZVNWEPQBCFGHIKLOURUSUTVNWCVRVAVNWFWDWGWHVNWFPQBCFGHIKLOVBUSUTVNWCVRVCV
      OVQVDVFVEVGVNVRWAJRWCVNVQULSVRWAVHVQVIAVQBCDEFGHIKLMNOPQVJVKVLVM $.

    $( Two ways two express that an operator is unbounded.  (Contributed by NM,
       11-Jan-2008.)  (New usage is discouraged.) $)
    nmounbi $p |- ( T : X --> Y -> ( ( N ` T ) = +oo <->
      A. r e. RR E. y e. X ( ( L ` y ) <_ 1 /\ r < ( M ` ( T ` y ) ) ) ) ) $=
      ( cfv cr wcel wf cv c1 cle wbr clt wa wrex wral cpnf wi wne wn nmobndi wb
      cnv nmorepnf mp3an12 ffvelrn nvcl sylancr lenlt sylan an32s imbi2d syl6bb
      imnan ralbidva ralnex rexbidva rexnal 3bitr3d necon4abid ) HIBUAZAUBZDRUC
      UDUEZJUBZVOBRZERZUFUEZUGZAHUHZJSUIZBFRZUJVNWDSTZVPVSVQUDUEZUKZAHUIZJSUHZW
      DUJULZWCUMZABCDEFGHIJKLMNOPQUNCUPTGUPTZVNWEWJUOPQBCFGHIKLOUQURVNWIWBUMZJS
      UHWKVNWHWMJSVNVQSTZUGZWHWAUMZAHUIWMWOWGWPAHWOVOHTZUGZWGVPVTUMZUKWPWRWFWSV
      PVNWQWNWFWSUOZVNWQUGZVSSTZWNWTXAWLVRITXBQHIVOBUSVRGEILNUTVAVSVQVBVCVDVEVP
      VTVGVFVHWAAHVIVFVJWBJSVKVFVLVM $.

    $( An unbounded operator determines an unbounded sequence.  (Contributed by
       NM, 11-Jan-2008.)  (Revised by Mario Carneiro, 7-Apr-2013.)
       (New usage is discouraged.) $)
    nmounbseqi $p |- ( ( T : X --> Y /\ ( N ` T ) = +oo ) ->
         E. f ( f : NN --> X /\ A. k e. NN ( ( L ` ( f ` k ) ) <_ 1 /\
          k < ( M ` ( T ` ( f ` k ) ) ) ) ) ) $=
      ( vy cfv cn wf cpnf wceq wa cv c1 cle wbr clt wrex cr wral nmounbi biimpa
      wex wcel nnre imim1i ralimi2 cba fvex eqeltri nnenom breq1d fveq2d breq2d
      cvv fveq2 anbi12d axcc4 3syl ) IJAUAZAGSUBUCZUDRUEZESZUFUGUHZDUEZVNASZFSZ
      UIUHZUDZRIUJZDUKULZWBDTULTICUEZUAVQWDSZESZUFUGUHZVQWEASZFSZUIUHZUDZDTULUD
      CUOVLVMWCRABEFGHIJDKLMNOPQUMUNWBWBDUKTVQTUPVQUKUPWBVQUQURUSWAWKRICDTIBUTS
      VGKBUTVAVBVCVNWEUCZVPWGVTWJWLVOWFUFUGVNWEEVHVDWLVSWIVQUIWLVRWHFVNWEAVHVEV
      FVIVJVK $.

    $( An unbounded operator determines an unbounded sequence.  (Contributed by
       NM, 11-Jan-2008.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nmounbseqiOLD $p |- ( ( T : X --> Y /\ ( N ` T ) = +oo ) ->
         E. f ( f : NN --> X /\ A. k e. NN ( ( L ` ( f ` k ) ) <_ 1 /\
          k < ( M ` ( T ` ( f ` k ) ) ) ) ) ) $=
      ( vy cfv cn wf cpnf wceq wa cv c1 cle wbr clt wrex cr wral nmounbi biimpa
      wex wcel nnre imim1i ralimi2 nnex fveq2 breq1d fveq2d breq2d anbi12d ac6s
      3syl ) IJAUAZAGSUBUCZUDRUEZESZUFUGUHZDUEZVJASZFSZUIUHZUDZRIUJZDUKULZVRDTU
      LTICUEZUAVMVTSZESZUFUGUHZVMWAASZFSZUIUHZUDZDTULUDCUOVHVIVSRABEFGHIJDKLMNO
      PQUMUNVRVRDUKTVMTUPVMUKUPVRVMUQURUSVQWGDRTICUTVJWAUCZVLWCVPWFWHVKWBUFUGVJ
      WAEVAVBWHVOWEVMUIWHVNWDFVJWAAVAVCVDVEVFVG $.

    $( A bounded sequence determines a bounded operator.  (Contributed by NM,
       18-Jan-2008.)  (Revised by Mario Carneiro, 7-Apr-2013.)
       (New usage is discouraged.) $)
    nmobndseqi $p |- ( ( T : X --> Y /\
         A. f ( ( f : NN --> X /\ A. k e. NN ( L ` ( f ` k ) ) <_ 1 ) ->
        E. k e. NN ( M ` ( T ` ( f ` k ) ) ) <_ k ) ) -> ( N ` T ) e. RR ) $=
      ( cn cfv wi vy wf cv c1 cle wbr wral wa wrex cr wcel impexp r19.35 imbi2i
      wal bitr4i albii wex cba cvv fvex eqeltri nnenom wceq fveq2 breq1d fveq2d
      wn imbi12d notbid axcc4 con3i dfrex2 alinexa dfral2 rexbii rexnal 3imtr4i
      bitri nnre anim1i reximi2 syl sylbi nmobndi syl5ibr imp ) IJAUBZRICUCZUBZ
      DUCZWISZESZUDUEUFZDRUGZUHWLASZFSZWKUEUFZDRUIZTZCUOZAGSUJUKZXAXBWHUAUCZESZ
      UDUEUFZXCASZFSZWKUEUFZTZUAIUGZDUJUIZXAWJWNWRTZDRUIZTZCUOZXKWTXNCWTWJWOWST
      ZTXNWJWOWSULXMXPWJWNWRDRUMUNUPUQXOXJDRUIZXKWJXLVHZDRUGZUHCURZVHZXIVHZUAIU
      IZDRUGZVHZXOXQYDXTYBXRUAICDRIBUSSUTKBUSVAVBVCXCWLVDZXIXLYFXEWNXHWRYFXDWMU
      DUEXCWLEVEVFYFXGWQWKUEYFXFWPFXCWLAVEVGVFVIVJVKVLXOWJXSVHZTZCUOYAXNYHCXMYG
      WJXLDRVMUNUQWJXSCVNVSXQYCVHZDRUIYEXJYIDRXIUAIVOVPYCDRVQVSVRXJXJDRUJWKRUKW
      KUJUKXJWKVTWAWBWCWDUAABEFGHIJDKLMNOPQWEWFWG $.

    $( A bounded sequence determines a bounded operator.  (Contributed by NM,
       18-Jan-2008.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    nmobndseqiOLD $p |- ( ( T : X --> Y /\
         A. f ( ( f : NN --> X /\ A. k e. NN ( L ` ( f ` k ) ) <_ 1 ) ->
        E. k e. NN ( M ` ( T ` ( f ` k ) ) ) <_ k ) ) -> ( N ` T ) e. RR ) $=
      ( cn cfv cle vy wf cv c1 wbr wral wa wrex wi cr wcel impexp r19.35 imbi2i
      wal bitr4i albii nnex wceq breq1d fveq2d imbi12d ac6n nnre anim1i reximi2
      fveq2 syl sylbi nmobndi syl5ibr imp ) IJAUBZRICUCZUBZDUCZVNSZESZUDTUEZDRU
      FZUGVQASZFSZVPTUEZDRUHZUIZCUOZAGSUJUKZWFWGVMUAUCZESZUDTUEZWHASZFSZVPTUEZU
      IZUAIUFZDUJUHZWFVOVSWCUIZDRUHZUIZCUOZWPWEWSCWEVOVTWDUIZUIWSVOVTWDULWRXAVO
      VSWCDRUMUNUPUQWTWODRUHWPWNWQDUARICURWHVQUSZWJVSWMWCXBWIVRUDTWHVQEVGUTXBWL
      WBVPTXBWKWAFWHVQAVGVAUTVBVCWOWODRUJVPRUKVPUJUKWOVPVDVEVFVHVIUAABEFGHIJDKL
      MNOPQVJVKVL $.
  $}

  ${
    $d t u w L $.  $d t u w N $.  $d t T $.  $d t u w U $.  $d t u w W $.
    bloval.3 $e |- N = ( U normOpOLD W ) $.
    bloval.4 $e |- L = ( U LnOp W ) $.
    bloval.5 $e |- B = ( U BLnOp W ) $.
    $( The class of bounded linear operators between two normed complex vector
       spaces.  (Contributed by NM, 6-Nov-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    bloval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) ->
                   B = { t e. L | ( N ` t ) < +oo } ) $=
      ( vu vw cnv co cv cfv cpnf clt wbr cnmoo clno wcel cblo crab oveq1 fveq1d
      wceq breq1d rabeqbidv oveq2 syl6eqr df-blo cvv ovex eqeltri ovmpt2 syl5eq
      wa rabex ) CLUAFLUAUQBCFUBMANZEOZPQRZADUCZIJKCFLLUSJNZKNZSMZOZPQRZAVCVDTM
      ZUCVBUBUSCVDSMZOZPQRZACVDTMZUCVCCUFZVGVKAVHVLVCCVDTUDVMVFVJPQVMUSVEVIVCCV
      DSUDUEUGUHVDFUFZVKVAAVLDVNVLCFTMZDVDFCTUIHUJVNVJUTPQVNUSVIEVNVICFSMEVDFCS
      UIGUJUEUGUHKJAUKVAADDVOULHCFTUMUNURUOUP $.

    $( The predicate "is a bounded linear operator."  (Contributed by NM,
       6-Nov-2007.)  (New usage is discouraged.) $)
    isblo $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> ( T e. B <->
      ( T e. L /\ ( N ` T ) < +oo ) ) ) $=
      ( vt cnv wcel wa cv cfv cpnf clt wbr crab bloval eleq2d wceq fveq2 breq1d
      elrab syl6bb ) CKLFKLMZBALBJNZEOZPQRZJDSZLBDLBEOZPQRZMUGAUKBJACDEFGHITUAU
      JUMJBDUHBUBUIULPQUHBEUCUDUEUF $.

    $( The predicate "is a bounded linear operator."  (Contributed by NM,
       8-Dec-2007.)  (New usage is discouraged.) $)
    isblo2 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> ( T e. B <->
      ( T e. L /\ ( N ` T ) e. RR ) ) ) $=
      ( cnv wcel wa cfv cpnf clt wbr cr isblo cba eqid lnof nmoreltpnf syld3an3
      wb wf 3expa pm5.32da bitr4d ) CJKZFJKZLZBAKBDKZBEMZNOPZLULUMQKZLABCDEFGHI
      RUKULUOUNUIUJULUOUNUDZUIUJULCSMZFSMZBUEUPBCDFUQURUQTZURTZHUABCEFUQURUSUTG
      UBUCUFUGUH $.
  $}

  ${
    bloln.4 $e |- L = ( U LnOp W ) $.
    bloln.5 $e |- B = ( U BLnOp W ) $.
    $( A bounded operator is a linear operator.  (Contributed by NM,
       8-Dec-2007.)  (New usage is discouraged.) $)
    bloln $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. B ) -> T e. L ) $=
      ( cnv wcel wa cnmoo co cfv cpnf clt wbr eqid isblo simprbda 3impa ) CHIZE
      HIZBAIZBDIZUAUBJUCUDBCEKLZMNOPABCDUEEUEQFGRST $.
  $}

  ${
    blof.1 $e |- X = ( BaseSet ` U ) $.
    blof.2 $e |- Y = ( BaseSet ` W ) $.
    blof.5 $e |- B = ( U BLnOp W ) $.
    $( A bounded operator is an operator.  (Contributed by NM, 8-Dec-2007.)
       (New usage is discouraged.) $)
    blof $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. B ) -> T : X --> Y ) $=
      ( cnv wcel clno co wf eqid bloln lnof syld3an3 ) CJKDJKBAKBCDLMZKEFBNABCS
      DSOZIPBCSDEFGHTQR $.
  $}

  ${
    nmblore.1 $e |- X = ( BaseSet ` U ) $.
    nmblore.2 $e |- Y = ( BaseSet ` W ) $.
    nmblore.3 $e |- N = ( U normOpOLD W ) $.
    nmblore.5 $e |- B = ( U BLnOp W ) $.
    $( The norm of a bounded operator is a real number.  (Contributed by NM,
       8-Dec-2007.)  (New usage is discouraged.) $)
    nmblore $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. B ) ->
                ( N ` T ) e. RR ) $=
      ( cnv wcel w3a cfv cr clt wbr syld3an3 wa cmnf cpnf wf blof nmogtmnf clno
      co eqid isblo simplbda 3impa cxr wb nmoxr xrrebnd syl mpbir2and ) CLMZELM
      ZBAMZNZBDOZPMZUAVBQRZVBUBQRZURUSUTFGBUCZVDABCEFGHIKUDZBCDEFGHIJUESURUSUTV
      EURUSTUTBCEUFUGZMVEABCVHDEJVHUHKUIUJUKVAVBULMZVCVDVETUMURUSUTVFVIVGBCDEFG
      HIJUNSVBUOUPUQ $.
  $}

  ${
    $d u w U $.  $d u w W $.  $d u w X $.  $d u w Z $.
    0oval.1 $e |- X = ( BaseSet ` U ) $.
    0oval.6 $e |- Z = ( 0vec ` W ) $.
    0oval.0 $e |- O = ( U 0op W ) $.
    $( The zero operator between two normed complex vector spaces.
       (Contributed by NM, 28-Nov-2007.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    0ofval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> O = ( X X. { Z } ) ) $=
      ( vu vw cnv wcel c0o csn cxp cv cba cfv cn0v wceq wa fveq2 syl6eqr xpeq1d
      co sneqd xpeq2d df-0o cvv fvex eqeltri snex xpex ovmpt2 syl5eq ) AKLCKLUA
      BACMUEDENZOZHIJACKKIPZQRZJPZSRZNZOUQMDVBOURATZUSDVBVCUSAQRZDURAQUBFUCUDUT
      CTZVBUPDVEVAEVEVACSREUTCSUBGUCUFUGJIUHDUPDVDUIFAQUJUKEULUMUNUO $.

    $( Value of the zero operator.  (Contributed by NM, 28-Nov-2007.)
       (New usage is discouraged.) $)
    0oval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ A e. X ) ->
            ( O ` A ) = Z ) $=
      ( cnv wcel w3a cfv csn cxp wceq wa 0ofval fveq1d cn0v 3adant3 cvv eqeltri
      fvex fvconst2 3ad2ant3 eqtrd ) BJKZDJKZAEKZLACMZAEFNOZMZFUHUIUKUMPUJUHUIQ
      ACULBCDEFGHIRSUAUJUHUMFPUIEFAFDTMUBHDTUDUCUEUFUG $.
  $}

  ${
    $d o u w U $.  $d o u w W $.  $d o u w X $.  $d o w Z $.
    0oo.1 $e |- X = ( BaseSet ` U ) $.
    0oo.2 $e |- Y = ( BaseSet ` W ) $.
    0oo.0 $e |- Z = ( U 0op W ) $.
    $( The zero operator is an operator.  (Contributed by NM, 28-Nov-2007.)
       (New usage is discouraged.) $)
    0oo $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> Z : X --> Y ) $=
      ( cnv wcel wa wf cn0v cfv csn cxp wss fvex fconst eqid nvzcl snssd adantl
      fss sylancr 0ofval feq1d mpbird ) AIJZBIJZKZCDELCDCBMNZOZPZLZUJUOUIUJCUMU
      NLUMDQUOCULBMRSUJULDBDULGULTZUAUBCUMDUNUDUEUCUKCDEUNAEBCULFUPHUFUGUH $.
  $}

  ${
    $d x y z U $.  $d x y z W $.  $d x y z Z $.
    0lno.0 $e |- Z = ( U 0op W ) $.
    0lno.7 $e |- L = ( U LnOp W ) $.
    $( The zero operator is linear.  (Contributed by NM, 28-Nov-2007.)
       (Revised by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    0lno $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> Z e. L ) $=
      ( vx vy vz wcel wa cfv cv co wceq wral cc eqid syl3anc 0oval cnv cba cn0v
      cns cpv 0oo simplll simpllr simplr simprl nvscl simprr nvgcl oveq12d nvsz
      oveq2d syl2anc oveq1d nvzcl syl nv0rid 3eqtrd eqtr4d ralrimivva ralrimiva
      wf islno mpbir2and ) AUAJZCUAJZKZDBJAUBLZCUBLZDVFGMZHMZAUDLZNZIMZAUELZNZD
      LZVNVODLZCUDLZNZVRDLZCUELZNZOZIVLPHVLPZGQPACVLVMDVLRZVMRZEUFVKWIGQVKVNQJZ
      KZWHHIVLVLWMVOVLJZVRVLJZKZKZWACUCLZWGWQVIVJVTVLJZWAWROVIVJWLWPUGZVIVJWLWP
      UHZWQVIVQVLJZWOWSWTWQVIWLWNXBWTVKWLWPUIZWMWNWOUJZVNVOVPAVLWJVPRZUKSWMWNWO
      ULZVQVRAVSVLWJVSRZUMSVTADCVLWRWJWRRZETSWQWGVNWRWCNZWRWFNWRWRWFNZWRWQWDXIW
      EWRWFWQWBWRVNWCWQVIVJWNWBWROWTXAXDVOADCVLWRWJXHETSUPWQVIVJWOWEWROWTXAXFVR
      ADCVLWRWJXHETSUNWQXIWRWRWFWQVJWLXIWROXAXCVNWCCWRWCRZXHUOUQURWQVJWRVMJZXJW
      ROXAWQVJXLXACVMWRWKXHUSUTWRCWFVMWRWKWFRZXHVAUQVBVCVDVEGHIVPWCDAVSWFBCVLVM
      WJWKXGXMXEXKFVGVH $.
  $}

  ${
    $d x z U $.  $d x z W $.  $d x z Z $.
    nmoo0.3 $e |- N = ( U normOpOLD W ) $.
    nmoo0.0 $e |- Z = ( U 0op W ) $.
    $( The operator norm of the zero operator.  (Contributed by NM,
       27-Nov-2007.)  (New usage is discouraged.) $)
    nmoo0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) ->
         ( N ` Z ) = 0 ) $=
      ( vz vx cnv wcel wa cfv cc0 cxr clt c1 cle wceq wrex eqid csn csup cv wbr
      cnmcv cba cab wf 0oo nmooval mpd3an3 df-sn cn0v nvzcl nvz0 syl6eqbr fveq2
      wb 0le1 breq1d rspcev syl2anc biantrurd adantr 0oval 3expa ad2antlr eqtrd
      fveq2d eqeq2d anbi2d rexbidva r19.41v syl6rbb bitrd abbidv syl5req xrltso
      supeq1d wor 0xr supsn mp2an syl6eq ) AIJZCIJZKZDBLZMUAZNOUBZMWGWHGUCZAUEL
      ZLZPQUDZHUCZWKDLZCUELZLZRZKZGAUFLZSZHUGZNOUBZWJWEWFXACUFLZDUHWHXDRACXAXED
      XATZXETZFUIHGDAWLWQBCXAXEXFXGWLTZWQTZEUJUKWGNXCWIOWGWIWOMRZHUGXCHMULWGXJX
      BHWGXJWNGXASZXJKZXBWEXJXLURWFWEXKXJWEAUMLZXAJXMWLLZPQUDZXKAXAXMXFXMTZUNWE
      XNMPQAWLXMXPXHUOUSUPWNXOGXMXAWKXMRWMXNPQWKXMWLUQUTVAVBVCVDWGXBWNXJKZGXASX
      LWGWTXQGXAWGWKXAJZKZWSXJWNXSWRMWOXSWRCUMLZWQLZMXSWPXTWQWEWFXRWPXTRWKADCXA
      XTXFXTTZFVEVFVIWFYAMRWEXRCWQXTYBXIUOVGVHVJVKVLWNXJGXAVMVNVOVPVQVSVHNOVTMN
      JWJMRVRWANMOWBWCWD $.
  $}

  ${
    0blo.0 $e |- Z = ( U 0op W ) $.
    0blo.7 $e |- B = ( U BLnOp W ) $.
    $( The zero operator is a bounded linear operator.  (Contributed by NM,
       8-Dec-2007.)  (New usage is discouraged.) $)
    0blo $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> Z e. B ) $=
      ( cnv wcel wa clno co cnmoo cfv cr eqid 0lno cc0 nmoo0 0re syl6eqel
      isblo2 mpbir2and ) BGHCGHIZDAHDBCJKZHDBCLKZMZNHBUDCDEUDOZPUCUFQNBUECDUEOZ
      ERSTADBUDUECUHUGFUAUB $.
  $}

  ${
    $d y z K $.  $d y z M $.  $d x N $.  $d z R $.  $d y z S $.  $d x y z T $.
    $d y z U $.  $d y z W $.  $d x y z X $.  $d y z Y $.  $d x Z $.
    nmlno0.3 $e |- N = ( U normOpOLD W ) $.
    nmlno0.0 $e |- Z = ( U 0op W ) $.
    nmlno0.7 $e |- L = ( U LnOp W ) $.
    ${
      nmlno0lem.u $e |- U e. NrmCVec $.
      nmlno0lem.w $e |- W e. NrmCVec $.
      nmlno0lem.l $e |- T e. L $.
      nmlno0lem.1 $e |- X = ( BaseSet ` U ) $.
      nmlno0lem.2 $e |- Y = ( BaseSet ` W ) $.
      nmlno0lem.r $e |- R = ( .sOLD ` U ) $.
      nmlno0lem.s $e |- S = ( .sOLD ` W ) $.
      nmlno0lem.p $e |- P = ( 0vec ` U ) $.
      nmlno0lem.q $e |- Q = ( 0vec ` W ) $.
      nmlno0lem.k $e |- K = ( normCV ` U ) $.
      nmlno0lem.m $e |- M = ( normCV ` W ) $.
      $( Lemma for ~ nmlno0i .  (Contributed by NM, 28-Nov-2007.)
         (New usage is discouraged.) $)
      nmlno0lem $p |- ( ( N ` T ) = 0 <-> T = Z ) $=
        ( vx vz vy cfv cc0 wceq cv wral wcel wa wne wn c1 cdiv co clt wbr wi cc
        cnv cr nvcl mpan recnd adantr wb fveq2 lno0 mp3an syl6eq syl6bi necon3d
        nvz recne0d simpr wo reccld wf lnof ffvelrni nvmul0or mp3an1 necon3abid
        imp syl2anc neanior syl6bbr mpbir2and nvscl nvgt0 sylancr ex adantl cle
        mpbid wrex cab cxr wss nmosetre mp2an ressxr sstri simpl necon3i sylan2
        nv1 1re syl6eqel w3a 3pm3.2i lnomul eqcomd fveq2d breq1d eqeq2d anbi12d
        csup eqle rspcev syl12anc fvex eqeq1 anbi2d rexbidv elab sylibr supxrub
        adantll wfn ffn ax-mp nmooval eqeq1i ad2antrr breqtrd 0re lenlt sylancl
        biimpi pm2.65d sylib 0oval mp3an12 eqtr4d ralrimiva eqfnfv nmoo0 impbii
        nne 0oo ) EJULZUMUNZENUNZUVAUIUOZEULZUVCNULZUNZUILUPZUVBUVAUVFUILUVAUVC
        LUQZURZUVDBUVEUVIUVDBUSZUTUVDBUNZUVIUVJUMVAUVCGULZVBVCZUVDDVCZIULZVDVEZ
        UVHUVJUVPVFUVAUVHUVJUVPUVHUVJURZUVNBUSZUVPUVQUVRUVMUMUSZUVJUVQUVLUVHUVL
        VGUQUVJUVHUVLFVHUQZUVHUVLVIUQRUVCFGLUAUGVJVKVLVMZUVHUVJUVLUMUSUVHUVLUMU
        VDBUVHUVLUMUNZUVCAUNZUVKUVTUVHUWBUWCVNRUVCFGLAUAUEUGWAVKUWCUVDAEULZBUVC
        AEVOUVTKVHUQZEHUQZUWDBUNRSTAEFHKLMBUAUBUEUFQVPVQVRZVSVTWLZWBUVHUVJWCUVQ
        UVRUVMUMUNUVKWDZUTUVSUVJURUVQUWIUVNBUVQUVMVGUQZUVDMUQZUVNBUNUWIVNZUVQUV
        LUWAUWHWEZUVHUWKUVJLMUVCEUVTUWEUWFLMEWFZRSTEFHKLMUAUBQWGVQZWHVMZUWEUWJU
        WKUWLSUVMUVDDKMBUBUDUFWIWJWMWKUVMUMUVDBWNWOWPUVQUWEUVNMUQZUVRUVPVNSUVQU
        WJUWKUWQUWMUWPUWEUWJUWKUWQSUVMUVDDKMUBUDWQWJWMZUVNKIMBUBUFUHWRWSXCWTXAU
        VIUVJUVPUTZUVIUVJURZUVOUMXBVEZUWSUWTUVOUJUOZGULZVAXBVEZUKUOZUXBEULZIULZ
        UNZURZUJLXDZUKXEZXFVDYFZUMXBUVHUVJUVOUXLXBVEZUVAUVQUXKXFXGUVOUXKUQZUXMU
        XKVIXFUWEUWNUXKVIXGSUWOUKUJEGIKLMUBUHXHXIXJXKUVQUXDUVOUXGUNZURZUJLXDZUX
        NUVQUVMUVCCVCZLUQZUXRGULZVAXBVEZUVOUXREULZIULZUNZUXQUVQUWJUVHUXSUWMUVHU
        VJXLZUVTUWJUVHUXSRUVMUVCCFLUAUCWQWJWMUVQUXTVIUQUXTVAUNZUYAUVQUXTVAVIUVJ
        UVHUVCAUSZUYFUVCAUVDBUWGXMUVTUVHUYGUYFRUVCCFGLAUAUCUEUGXOWJXNZXPXQUYHUX
        TVAYGWMUVQUVNUYBIUVQUYBUVNUVQUWJUVHUYBUVNUNZUWMUYEUVTUWEUWFXRUWJUVHURUY
        IUVTUWEUWFRSTXSUVMUVCCDEFHKLUAUCUDQXTVKWMYAYBUXPUYAUYDURUJUXRLUXBUXRUNZ
        UXDUYAUXOUYDUYJUXCUXTVAXBUXBUXRGVOYCUYJUXGUYCUVOUYJUXFUYBIUXBUXREVOYBYD
        YEYHYIUXJUXQUKUVOUVNIYJUXEUVOUNZUXIUXPUJLUYKUXHUXOUXDUXEUVOUXGYKYLYMYNY
        OUXKUVOYPWSYQUVAUXLUMUNZUVHUVJUVAUYLUUTUXLUMUVTUWEUWNUUTUXLUNRSUWOUKUJE
        FGIJKLMUAUBUGUHOUUAVQUUBUUHUUCUUDUVHUVJUXAUWSVNZUVAUVQUVOVIUQZUMVIUQUYM
        UVQUWEUWQUYNSUWRUVNKIMUBUHVJWSUUEUVOUMUUFUUGYQXCWTUUIUVDBUURUUJUVHUVEBU
        NZUVAUVTUWEUVHUYORSUVCFNKLBUAUFPUUKUULXAUUMUUNELYRZNLYRZUVBUVGVNUWNUYPU
        WOLMEYSYTLMNWFZUYQUVTUWEUYRRSFKLMNUAUBPUUSXILMNYSYTUILENUUOXIYOUVBUUTNJ
        ULZUMENJVOUVTUWEUYSUMUNRSFJKNOPUUPXIVRUUQ $.
    $}

    ${
      nmlno0i.u $e |- U e. NrmCVec $.
      nmlno0i.w $e |- W e. NrmCVec $.
      $( The norm of a linear operator is zero iff the operator is zero.
         (Contributed by NM, 6-Dec-2007.)  (New usage is discouraged.) $)
      nmlno0i $p |- ( T e. L -> ( ( N ` T ) = 0 <-> T = Z ) ) $=
        ( wcel cfv cc0 wceq wb cn0v cns cnmcv eqid cif fveq2 eqeq1d bibi12d cba
        eqeq1 cnv 0lno mp2an elimel nmlno0lem dedth ) ACLZADMZNOZAFOZPUMAFUAZDM
        ZNOZUQFOZPAFAUQOZUOUSUPUTVAUNURNAUQDUBUCAUQFUFUDBQMZEQMZBRMZERMZUQBBSMZ
        CESMZDEBUEMZEUEMZFGHIJKAFCBUGLEUGLFCLJKBCEFHIUHUIUJVHTVITVDTVETVBTVCTVF
        TVGTUKUL $.
    $}

    $( The norm of a linear operator is zero iff the operator is zero.
       (Contributed by NM, 24-Nov-2007.)  (New usage is discouraged.) $)
    nmlno0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) ->
       ( ( N ` T ) = 0 <-> T = Z ) ) $=
      ( wcel cfv cc0 wceq wb wi clno co cnmoo c0o oveq1 cnv caddc cmul cop cabs
      cif syl5eq eleq2d fveq1d eqeq1d eqeq2d bibi12d imbi12d oveq2 eqid elimnvu
      nmlno0i dedth2h 3impia ) BUAJZEUAJZACJZADKZLMZAFMZNZUTVAVBVFOAUTBUBUCUDUE
      UDZUFZEPQZJZAVHERQZKZLMZAVHESQZMZNZOAVHVAEVGUFZPQZJZAVHVQRQZKZLMZAVHVQSQZ
      MZNZOBEVGVGBVHMZVBVJVFVPWFCVIAWFCBEPQVIIBVHEPTUGUHWFVDVMVEVOWFVCVLLWFADVK
      WFDBERQVKGBVHERTUGUIUJWFFVNAWFFBESQVNHBVHESTUGUKULUMEVQMZVJVSVPWEWGVIVRAE
      VQVHPUNUHWGVMWBVOWDWGVLWALWGAVKVTEVQVHRUNUIUJWGVNWCAEVQVHSUNUKULUMAVHVRVT
      VQWCVTUOWCUOVRUOBUPEUPUQURUS $.
  $}

  ${
    $d x A $.  $d x K $.  $d x L $.  $d x M $.  $d x T $.  $d x U $.  $d x W $.
    $d x X $.
    nmlnoubi.1 $e |- X = ( BaseSet ` U ) $.
    nmlnoubi.z $e |- Z = ( 0vec ` U ) $.
    nmlnoubi.k $e |- K = ( normCV ` U ) $.
    nmlnoubi.m $e |- M = ( normCV ` W ) $.
    nmlnoubi.3 $e |- N = ( U normOpOLD W ) $.
    nmlnoubi.7 $e |- L = ( U LnOp W ) $.
    nmlnoubi.u $e |- U e. NrmCVec $.
    nmlnoubi.w $e |- W e. NrmCVec $.
    $( An upper bound for the operator norm of a linear operator, using only
       the properties of nonzero arguments.  (Contributed by NM, 1-Jan-2008.)
       (New usage is discouraged.) $)
    nmlnoubi $p |- ( ( T e. L /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. X ( x =/= Z
     -> ( M ` ( T ` x ) ) <_ ( A x. ( K ` x ) ) ) ) -> ( N ` T ) <_ A ) $=
      ( cc0 wcel cr cle wbr wa cv wne cfv cmul co wral wceq fveq2 fveq2d oveq2d
      wi breq12d id imp adantll 0le0 cn0v cnv cba eqid lno0 mp3an12 nvz0 syl6eq
      ax-mp adantr oveq2i recn mul01d syl5eq ad2antrl mpbiri pm2.61ne ex 3impia
      ralimdv wf lnof nmoub2i syl3an1 syld3an3 ) CFUAZBUBUAZTBUCUDZUEZAUFZKUGZW
      KCUHZGUHZBWKEUHZUIUJZUCUDZUPZAJUKZWQAJUKZCHUHBUCUDZWGWJWSWTWGWJUEZWRWQAJX
      BWRWQXBWRUEWQKCUHZGUHZBKEUHZUIUJZUCUDZWKKWKKULZWNXDWPXFUCXHWMXCGWKKCUMUNX
      HWOXEBUIWKKEUMUOUQWRWLWQXBWRWLWQWRURUSUTXBXGWRXBXGTTUCUDVAXBXDTXFTUCWGXDT
      ULWJWGXDIVBUHZGUHZTWGXCXIGDVCUAZIVCUAZWGXCXIULRSKCDFIJIVDUHZXILXMVEZMXIVE
      ZQVFVGUNXLXJTULSIGXIXOOVHVJVIVKWHXFTULWGWIWHXFBTUIUJTXETBUIXKXETULRDEKMNV
      HVJVLWHBBVMVNVOVPUQVQVKVRVSWAVTWGJXMCWBZWJWTXAXKXLWGXPRSCDFIJXMLXNQWCVGAB
      CDEGHIJXMLXNNOPRSWDWEWF $.
  $}

  ${
    nmlnogt0.3 $e |- N = ( U normOpOLD W ) $.
    nmlnogt0.0 $e |- Z = ( U 0op W ) $.
    nmlnogt0.7 $e |- L = ( U LnOp W ) $.
    $( The norm of a nonzero linear operator is positive.  (Contributed by NM,
       10-Dec-2007.)  (New usage is discouraged.) $)
    nmlnogt0 $p |- ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) ->
                   ( T =/= Z <-> 0 < ( N ` T ) ) ) $=
      ( cnv wcel w3a cfv cc0 wne clt wbr cba wb eqid nmlno0 necon3bid cxr nmoxr
      wf lnof cle nmooge0 wa wo 0xr xrlttri2 mpan2 adantr wn xrlenlt mpan biorf
      biimpa syl bitr4d syl2anc syld3an3 bitr3d ) BJKZEJKZACKZLZADMZNOZAFONVIPQ
      ZVHVINAFABCDEFGHIUAUBVEVFVGBRMZERMZAUEZVJVKSZABCEVLVMVLTZVMTZIUFVEVFVNLVI
      UCKZNVIUGQZVOABDEVLVMVPVQGUDABDEVLVMVPVQGUHVRVSUIZVJVINPQZVKUJZVKVRVJWBSZ
      VSVRNUCKZWCUKVINULUMUNVTWAUOZVKWBSVRVSWEWDVRVSWESUKNVIUPUQUSWAVKURUTVAVBV
      CVD $.
  $}

  ${
    $d x L $.  $d x T $.  $d x U $.  $d x W $.  $d x X $.
    lnon0.1 $e |- X = ( BaseSet ` U ) $.
    lnon0.6 $e |- Z = ( 0vec ` U ) $.
    lnon0.0 $e |- O = ( U 0op W ) $.
    lnon0.7 $e |- L = ( U LnOp W ) $.
    $( The domain of a nonzero linear operator contains a nonzero vector.
       (Contributed by NM, 15-Dec-2007.)  (New usage is discouraged.) $)
    lnon0 $p |- ( ( ( U e. NrmCVec /\ W e. NrmCVec /\ T e. L ) /\ T =/= O )
                   -> E. x e. X x =/= Z ) $=
      ( cnv wcel wne wn wceq wral bitr3i cfv w3a cv wrex ralnex nne ralbii cn0v
      csn cxp wfn wa fveq2 cba eqid lno0 sylan9eqr ex ralimdv wf ffn syl jctild
      fconstfv fconst2 syl6ib 0ofval 3adant3 eqeq2d sylibrd syl5bi necon1ad imp
      lnof fvex ) CMNZFMNZBDNZUAZBEOAUBZHOZAGUCZVRWABEWAPZVSHQZAGRZVRBEQZWBVTPZ
      AGRWDVTAGUDWFWCAGVSHUEUFSVRWDBGFUGTZUHZUIZQZWEVRWDBGUJZVSBTZWGQZAGRZUKZWJ
      VRWDWNWKVRWCWMAGVRWCWMWCVRWLHBTWGVSHBULHBCDFGFUMTZWGIWPUNZJWGUNZLUOUPUQUR
      VRGWPBUSWKBCDFGWPIWQLVMGWPBUTVAVBWOGWHBUSWJAGWGBVCGWGBFUGVNVDSVEVREWIBVOV
      PEWIQVQCEFGWGIWRKVFVGVHVIVJVKVL $.
  $}

  ${
    nmblolbi.1 $e |- X = ( BaseSet ` U ) $.
    nmblolbi.4 $e |- L = ( normCV ` U ) $.
    nmblolbi.5 $e |- M = ( normCV ` W ) $.
    nmblolbi.6 $e |- N = ( U normOpOLD W ) $.
    nmblolbi.7 $e |- B = ( U BLnOp W ) $.
    nmblolbi.u $e |- U e. NrmCVec $.
    nmblolbi.w $e |- W e. NrmCVec $.
    ${
      nmblolbii.b $e |- T e. B $.
      $( A lower bound for the norm of a bounded linear operator.  (Contributed
         by NM, 7-Dec-2007.)  (New usage is discouraged.) $)
      nmblolbii $p |- ( A e. X ->
                ( M ` ( T ` A ) ) <_ ( ( N ` T ) x. ( L ` A ) ) ) $=
        ( wcel cfv cc0 cmul co cle wbr cn0v wceq fveq2 fveq2d oveq2d breq12d wa
        wne cdiv c1 cns cr cba cnv nvcl mpan adantr eqid nvz necon3bid rereccld
        wb biimpar clt nvgt0 biimpa recgt0d wi 0re ltle sylancr mpd wf ffvelrni
        blof mp3an nvsge0 mp3an1 syl21anc cc recnd simpl clno w3a bloln 3pm3.2i
        lnomul syl2anc divrec2d 3eqtr4rd nvscl ancoms syldan nv1 nmoolb eqbrtrd
        eqle nmblore 3jca ledivmul2OLD mpbid 0le0 lno0 fveq2i nvz0 ax-mp oveq2i
        a1i eqtri recni mul01i 3brtr4i pm2.61ne ) AIRZACSZFSZCGSZAESZUAUBZUCUDZ
        DUESZCSZFSZYAYEESZUAUBZUCUDZAYEAYEUFZXTYGYCYIUCYKXSYFFAYECUGUHYKYBYHYAU
        AAYEEUGUIUJXRAYEULZUKZXTYBUMUBZYAUCUDZYDYMYNUNYBUMUBZADUOSZUBZCSZFSZYAU
        CYMYPXSHUOSZUBZFSZYPXTUAUBZYTYNYMYPUPRZTYPUCUDZXSHUQSZRZUUCUUDUFZYMYBXR
        YBUPRZYLDURRZXRUUJOADEIJKUSUTZVAZXRYBTULYLXRYBTAYEUUKXRYBTUFYKVFOADEIYE
        JYEVBZKVCUTVDVGZVEZYMTYPVHUDZUUFYMYBUUMXRYLTYBVHUDZUUKXRYLUURVFOADEIYEJ
        UUNKVIUTVJZVKYMTUPRUUEUUQUUFVLVMUUPTYPVNVOVPXRUUHYLIUUGACUUKHURRZCBRZIU
        UGCVQZOPQBCDHIUUGJUUGVBZNVSVTZVRZVAUUTUUEUUFUKUUHUUIPYPXSUUAHFUUGUVCUUA
        VBZLWAWBWCYMYSUUBFYMYPWDRZXRYSUUBUFZYMYPUUPWEZXRYLWFZUUKUUTCDHWGUBZRZWH
        UVGXRUKUVHUUKUUTUVLOPUUKUUTUVAUVLOPQBCDUVKHUVKVBZNWIVTZWJYPAYQUUACDUVKH
        IJYQVBZUVFUVMWKUTWLUHYMXTYBYMXTXRXTUPRZYLXRUUTUUHUVPPUVEXSHFUUGUVCLUSVO
        ZVAWEYMYBUUMWEUUOWMWNYMYRIRZYRESZUNUCUDZYTYAUCUDZYMUVGXRUVRUVIUVJUUKUVG
        XRUVROYPAYQDIJUVOWOWBZWLYMUVSUPRZUVSUNUFZUVTYMUUKUVRUWCOXRYLUVGUVRUVIUV
        GXRUVRUWBWPWQYRDEIJKUSVOUUKXRYLUWDOAYQDEIYEJUVOUUNKWRWBUVSUNXAWLUUKUUTU
        VBWHUVRUVTUKUWAUUKUUTUVBOPUVDWJYRCDEFGHIUUGJUVCKLMWSUTWLWTYMUVPUUJYAUPR
        ZWHZUURYOYDVFXRUWFYLXRUVPUUJUWEUVQUULUWEXRUUKUUTUVAUWEOPQBCDGHIUUGJUVCM
        NXBVTZXLXCVAUUSXTYBYAXDWLXEYJXRTTYGYIUCXFYGHUESZFSZTYFUWHFUUKUUTUVLYFUW
        HUFOPUVNYECDUVKHIUUGUWHJUVCUUNUWHVBZUVMXGVTXHUUTUWITUFPHFUWHUWJLXIXJXMY
        IYATUAUBTYHTYAUAUUKYHTUFODEYEUUNKXIXJXKYAYAUWGXNXOXMXPXLXQ $.
    $}

    $( A lower bound for the norm of a bounded linear operator.  (Contributed
       by NM, 10-Dec-2007.)  (New usage is discouraged.) $)
    nmblolbi $p |- ( ( T e. B /\ A e. X ) ->
              ( M ` ( T ` A ) ) <_ ( ( N ` T ) x. ( L ` A ) ) ) $=
      ( wcel cfv cmul co cle wbr c0o cif wceq fveq1 fveq2d fveq2 oveq1d breq12d
      wi imbi2d cnv eqid 0blo mp2an elimel nmblolbii dedth imp ) CBQZAIQZACRZFR
      ZCGRZAERZSTZUAUBZVAVBVHUKVBAVACDHUCTZUDZRZFRZVJGRZVFSTZUAUBZUKCVICVJUEZVH
      VOVBVPVDVLVGVNUAVPVCVKFACVJUFUGVPVEVMVFSCVJGUHUIUJULABVJDEFGHIJKLMNOPCVIB
      DUMQHUMQVIBQOPBDHVIVIUNNUOUPUQURUSUT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x L $.  $d x y M $.  $d x y N $.  $d x y T $.
    $d x y U $.  $d x y W $.  $d x y X $.
    isblo3i.1 $e |- X = ( BaseSet ` U ) $.
    isblo3i.m $e |- M = ( normCV ` U ) $.
    isblo3i.n $e |- N = ( normCV ` W ) $.
    isblo3i.4 $e |- L = ( U LnOp W ) $.
    isblo3i.5 $e |- B = ( U BLnOp W ) $.
    isblo3i.u $e |- U e. NrmCVec $.
    isblo3i.w $e |- W e. NrmCVec $.
    $( The predicate "is a bounded linear operator."  Definition 2.7-1 of
       [Kreyszig] p. 91.  (Contributed by NM, 11-Dec-2007.)
       (New usage is discouraged.) $)
    isblo3i $p |- ( T e. B <-> ( T e. L /\
          E. x e. RR A. y e. X ( N ` ( T ` y ) ) <_ ( x x. ( M ` y ) ) ) ) $=
      ( wcel cfv cr cv cmul co cle wbr wral wrex wa cnv bloln mp3an12 cnmoo cba
      eqid nmblore nmblolbi ralrimiva wceq oveq1 breq2d ralbidv syl2anc jca w3a
      rspcev cpnf clt simp1 wf lnof cabs cxr nmoxr 3ad2ant1 recn rexrd 3ad2ant2
      abscld pnfxr a1i nmoub3i ltpnf syl xrlelttrd syl3an1 isblo mp2an sylanbrc
      wb rexlimdv3a imp impbii ) DCRZDFRZBUAZDSHSZAUAZWOGSZUBUCZUDUEZBJUFZATUGZ
      UHWMWNXBEUIRZIUIRZWMWNPQCDEFINOUJUKWMDEIULUCZSZTRZWPXFWRUBUCZUDUEZBJUFZXB
      XCXDWMXGPQCDEXEIJIUMSZKXKUNZXEUNZOUOUKWMXIBJWOCDEGHXEIJKLMXMOPQUPUQXAXJAX
      FTWQXFURZWTXIBJXNWSXHWPUDWQXFWRUBUSUTVAVEVBVCWNXBWMWNXAWMATWNWQTRZXAVDWNX
      FVFVGUEZWMWNXOXAVHWNJXKDVIZXOXAXPXCXDWNXQPQDEFIJXKKXLNVJUKXQXOXAVDZXFWQVK
      SZVFXQXOXFVLRZXAXCXDXQXTPQDEXEIJXKKXLXMVMUKVNXOXQXSVLRXAXOXSXOWQWQVOVRZVP
      VQVFVLRXRVSVTBWQDEGHXEIJXKKXLLMXMPQWAXOXQXSVFVGUEZXAXOXSTRYBYAXSWBWCVQWDW
      EXCXDWMWNXPUHWIPQCDEFXEIXMNOWFWGWHWJWKWL $.

    $( Properties that determine a bounded linear operator.  (Contributed by
       NM, 13-Jan-2008.)  (New usage is discouraged.) $)
    blo3i $p |- ( ( T e. L /\ A e. RR /\ A. y e. X ( N ` ( T ` y ) ) <_
               ( A x. ( M ` y ) ) ) -> T e. B ) $=
      ( vx wcel cr cv cfv cmul co cle wbr wral wa wrex wceq oveq1 breq2d rspcev
      ralbidv isblo3i biimpri sylan2 3impb ) DFSZBTSZAUAZDUBHUBZBVAGUBZUCUDZUEU
      FZAJUGZDCSZUTVFUHUSVBRUAZVCUCUDZUEUFZAJUGZRTUIZVGVKVFRBTVHBUJZVJVEAJVMVIV
      DVBUEVHBVCUCUKULUNUMVGUSVLUHRACDEFGHIJKLMNOPQUOUPUQUR $.
  $}

  ${
    blometi.1 $e |- X = ( BaseSet ` U ) $.
    blometi.2 $e |- Y = ( BaseSet ` W ) $.
    blometi.8 $e |- C = ( IndMet ` U ) $.
    blometi.d $e |- D = ( IndMet ` W ) $.
    blometi.6 $e |- N = ( U normOpOLD W ) $.
    blometi.7 $e |- B = ( U BLnOp W ) $.
    blometi.u $e |- U e. NrmCVec $.
    blometi.w $e |- W e. NrmCVec $.
    $( Upper bound for the distance between the values of a bounded linear
       operator.  (Contributed by NM, 11-Dec-2007.)
       (New usage is discouraged.) $)
    blometi $p |- ( ( T e. B /\ P e. X /\ Q e. X ) ->
         ( ( T ` P ) D ( T ` Q ) ) <_ ( ( N ` T ) x. ( P C Q ) ) ) $=
      ( cfv wcel w3a cnsb co cnmcv cmul cle wbr wa cnv eqid nvmcl mp3an1 sylan2
      nmblolbi wceq blof mp3an12 ffvelrnda 3adant3 3adant2 imsdval syl2anc clno
      3impb wf bloln lnosub mp3anl1 mpanl1 syl3an1 fveq2d eqtr4d 3adant1 oveq2d
      3brtr4d ) FAUAZDJUAZEJUAZUBZDEGUCTZUDZFTZIUETZTZFHTZWBGUETZTZUFUDZDFTZEFT
      ZCUDZWFDEBUDZUFUDUGVQVRVSWEWIUGUHZVRVSUIZVQWBJUAZWNGUJUAZVRVSWPRDEGWAJLWA
      UKZULUMWBAFGWGWDHIJLWGUKZWDUKZPQRSUOUNVEVTWLWJWKIUCTZUDZWDTZWEVTWJKUAZWKK
      UAZWLXCUPZVQVRXDVSVQJKDFWQIUJUAZVQJKFVFRSAFGIJKLMQUQURZUSUTVQVSXEVRVQJKEF
      XHUSVAXGXDXEXFSWJWKCIXAWDKMXAUKZWTOVBUMVCVTWCXBWDVQFGIVDUDZUAZVRVSWCXBUPZ
      WQXGVQXKRSAFGXJIXJUKZQVGURXKVRVSXLXGXKWOXLSWQXGXKWOXLRDEFGXJWAXAIJLWRXIXM
      VHVIVJVEVKVLVMVTWMWHWFUFVRVSWMWHUPZVQWQVRVSXNRDEBGWAWGJLWRWSNVBUMVNVOVP
      $.
  $}

  ${
    $d w x y z B $.  $d w x y z C $.  $d w x y z D $.  $d x L $.  $d x y z P $.
    $d w x y z J $.  $d w x y z K $.  $d w x y z T $.  $d w x y z U $.
    $d w x y z W $.  $d x y z X $.
    blocni.8 $e |- C = ( IndMet ` U ) $.
    blocni.d $e |- D = ( IndMet ` W ) $.
    blocni.j $e |- J = ( MetOpen ` C ) $.
    blocni.k $e |- K = ( MetOpen ` D ) $.
    blocni.4 $e |- L = ( U LnOp W ) $.
    blocni.5 $e |- B = ( U BLnOp W ) $.
    blocni.u $e |- U e. NrmCVec $.
    blocni.w $e |- W e. NrmCVec $.
    blocni.l $e |- T e. L $.
    ${
      blocnilem.1 $e |- X = ( BaseSet ` U ) $.
      $( TODO - this needs to be broken up or shortened! $)
      $( Lemma for ~ blocni and ~ lnocni .  If a linear operator is continuous
         at any point, it is bounded.  (Contributed by NM, 17-Dec-2007.)
         (Revised by Mario Carneiro, 10-Jan-2014.)
         (New usage is discouraged.) $)
      blocnilem $p |- ( ( P e. X /\ T e. ( ( J CnP K ) ` P ) ) -> T e. B ) $=
        ( vz vx vy wcel ccnp co cfv wa cv cnmcv cmul cle wbr wral cr wrex c1 wi
        crp cxmt cba cnv imsxmet ax-mp eqid 1rp metcnpi3 mpanr2 mpanl12 rpreccl
        cdiv rpred ad2antlr cnsb wb wceq imsdval mp3an1 breq1d wf lnof ffvelrni
        mp3an syl2an 3pm3.2i lnosub mpan fveq2d eqtr4d imbi12d adantlr ralbidva
        w3a ancoms cn0v fveq2 oveq2d breq12d wne cns cpv simpll cc simpr adantr
        a1i nvcl cc0 clt nvgt0 biimpa elrpd rpdivcl rpcnd simprl nvscl nvpncan2
        syl3anc rprege0d nvsge0 rpcn ad2antrl recnd nvz biimpar adantl divcan1d
        necon3bid 3eqtrd rpre oveq1 syl syl2anc eqtrd rpcnne0 breq2d imp nvz0
        ex leidd eqbrtrd nvgcl rspcv sylancr 1re lemuldiv2d lnomul recdiv rpne0
        mpid eqtr2d 3bitr4d sylibd anassrs an32s lno0 fveq2i eqtri 0le0 eqbrtri
        divrec2d oveq2i mul01 syl5eq syl5breqr ad3antlr pm2.61ne sylbid ralbidv
        ralrimdva rspcev rexlimdva syl5 isblo3i mpbiran sylibr ) DKUEZEDGHUFUGU
        HUEZUIUBUJZEUHZJUKUHZUHZUCUJZUVTFUKUHZUHZULUGZUMUNZUBKUOZUCUPUQZEAUEZUV
        RUVSUWJUVSUWDDBUGZUDUJZUMUNZUWDEUHZDEUHZCUGZURUMUNZUSZUCKUOZUDUTUQZUVRU
        WJBKVAUHUEZCJVBUHZVAUHUEZUVSUXAFVCUEZUXBRBFKUALVDVEJVCUEZUXDSCJUXCUXCVF
        ZMVDVEUXBUXDUIUVSURUTUEUXAVGUDUCURBCDEGHKUXCNOVHVIVJUVRUWTUWJUDUTUVRUWM
        UTUEZUIZUWTUWJUXIUWTUIURUWMVLUGZUPUEZUWCUXJUWFULUGZUMUNZUBKUOZUWJUXHUXK
        UVRUWTUXHUXJUWMVKZVMVNUXIUWTUXNUXIUWTUWDDFVOUHZUGZUWEUHZUWMUMUNZUXQEUHZ
        UWBUHZURUMUNZUSZUCKUOZUXNUXIUWSUYCUCKUVRUWDKUEZUWSUYCVPZUXHUYEUVRUYFUYE
        UVRUIZUWNUXSUWRUYBUYGUWLUXRUWMUMUXEUYEUVRUWLUXRVQRUWDDBFUXPUWEKUAUXPVFZ
        UWEVFZLVRVSVTUYGUWQUYAURUMUYGUWQUWOUWPJVOUHZUGZUWBUHZUYAUYEUWOUXCUEZUWP
        UXCUEZUWQUYLVQZUVRKUXCUWDEUXEUXFEIUEZKUXCEWARSTEFIJKUXCUAUXGPWBWDZWCKUX
        CDEUYQWCUXFUYMUYNUYOSUWOUWPCJUYJUWBUXCUXGUYJVFZUWBVFZMVRVSWEUYGUXTUYKUW
        BUXEUXFUYPWNZUYGUXTUYKVQUXEUXFUYPRSTWFZUWDDEFIUXPUYJJKUAUYHUYRPWGWHWIWJ
        VTWKWOWLWMUXIUYDUXMUBKUXIUVTKUEZUIZUYDUXMVUCUYDUIUXMFWPUHZEUHZUWBUHZUXJ
        VUDUWEUHZULUGZUMUNZUVTVUDUVTVUDVQZUWCVUFUXLVUHUMVUJUWAVUEUWBUVTVUDEWQWI
        VUJUWFVUGUXJULUVTVUDUWEWQWRWSVUCUVTVUDWTZUYDUXMVUCVUKUIUYDUXMUXIVUBVUKU
        YDUXMUSUXIVUBVUKUIZUIZUYDDUWMUWFVLUGZUVTFXAUHZUGZFXBUHZUGZDUXPUGZEUHZUW
        BUHZURUMUNZUXMVUMUYDVUSUWEUHZUWMUMUNZVVBVUMVVCUWMUWMUMVUMVVCVUPUWEUHZVU
        NUWFULUGZUWMVUMVUSVUPUWEVUMUXEUVRVUPKUEZVUSVUPVQUXEVUMRXGZUVRUXHVULXCZV
        UMUXEVUNXDUEZVUBVVGVVHVUMVUNUXIUXHUWFUTUEZVUNUTUEVULUVRUXHXEZVULUWFVUBU
        WFUPUEZVUKUXEVUBVVMRUVTFUWEKUAUYIXHWHZXFVUBVUKXIUWFXJUNZUXEVUBVUKVVOVPR
        UVTFUWEKVUDUAVUDVFZUYIXKWHXLXMZUWMUWFXNWEZXOZUXIVUBVUKXPZVUNUVTVUOFKUAV
        UOVFZXQXSZDVUPFVUQUXPKUAVUQVFZUYHXRXSZWIVUMUXEVUNUPUEXIVUNUMUNUIZVUBVVE
        VVFVQVVHVUMVUNVVRXTZVVTVUNUVTVUOFUWEKUAVWAUYIYAXSVUMUWMUWFUXHUWMXDUEZUV
        RVULUWMYBVNZVUMUWFVUBVVMUXIVUKVVNYCYDZVULUWFXIWTZUXIVUBVWJVUKVUBUWFXIUV
        TVUDUXEVUBUWFXIVQVUJVPRUVTFUWEKVUDUAVVPUYIYEWHYIYFYGYHYJUXHUWMUWMUMUNUV
        RVULUXHUWMUWMYKUUAVNUUBVUMVURKUEZUYDVVDVVBUSZUSVUMUXEUVRVVGVWKVVHVVIVWB
        DVUPFVUQKUAVWCUUCXSUYCVWLUCVURKUWDVURVQZUXSVVDUYBVVBVWMUXRVVCUWMUMVWMUX
        QVUSUWEUWDVURDUXPYLZWIVTVWMUYAVVAURUMVWMUXTVUTUWBVWMUXQVUSEVWNWIWIVTWKU
        UDYMUUKVUMVUNUWCULUGZURUMUNUWCURVUNVLUGZUMUNVVBUXMVUMUWCURVUNVUBUWCUPUE
        ZUXIVUKVUBUXFUWAUXCUEZVWQSKUXCUVTEUYQWCZUWAJUWBUXCUXGUYSXHUUEYCURUPUEVU
        MUUFXGVVRUUGVUMVVAVWOURUMVUMVVAVUNUWAJXAUHZUGZUWBUHZVWOVUMVUTVXAUWBVUMV
        UTVUPEUHZVXAVUMVUSVUPEVWDWIVUMVVJVUBVXCVXAVQZVVSVVTUYTVVJVUBUIVXDVUAVUN
        UVTVUOVWTEFIJKUAVWAVWTVFZPUUHWHYNYOWIVUMUXFVWEVWRVXBVWOVQUXFVUMSXGVWFVU
        BVWRUXIVUKVWSYCVUNUWAVWTJUWBUXCUXGVXEUYSYAXSYOVTVUMUXLVWPUWCUMVUMVWPUWF
        UWMVLUGZUXLUXIUXHVVKVWPVXFVQZVULVVLVVQUXHVWGUWMXIWTZUIUWFXDUEVWJUIVXGVV
        KUWMYPUWFYPUWMUWFUUIWEWEVUMUWFUWMVWIVWHUXHVXHUVRVULUWMUUJVNUVBUULYQUUMU
        UNUUOYRUUPUXHVUIUVRVUBUYDUXHVUFXIVUHUMVUFXIXIUMVUFJWPUHZUWBUHZXIVUEVXIU
        WBUXEUXFUYPVUEVXIVQRSTVUDEFIJKUXCVXIUAUXGVVPVXIVFZPUUQWDUURUXFVXJXIVQSJ
        UWBVXIVXKUYSYSVEUUSUUTUVAUXHUXJXDUEZVUHXIVQUXHUXJUXOXOVXLVUHUXJXIULUGXI
        VUGXIUXJULUXEVUGXIVQRFUWEVUDVVPUYIYSVEUVCUXJUVDUVEYMUVFUVGUVHYTUVKUVIYR
        UWIUXNUCUXJUPUWDUXJVQZUWHUXMUBKVXMUWGUXLUWCUMUWDUXJUWFULYLYQUVJUVLYNYTU
        VMUVNYRUWKUYPUWJTUCUBAEFIUWEUWBJKUAUYIUYSPQRSUVOUVPUVQ $.
    $}

    $( A linear operator is continuous iff it is bounded.  Theorem 2.7-9(a) of
       [Kreyszig] p. 97.  (Contributed by NM, 18-Dec-2007.)  (Revised by Mario
       Carneiro, 10-Jan-2014.)  (New usage is discouraged.) $)
    blocni $p |- ( T e. ( J Cn K ) <-> T e. B ) $=
      ( wcel cfv vx vw vz vy ccn cn0v cba ccnp cnv eqid nvzcl ax-mp cxmt ctopon
      cme imsmet metxmet mopntopon toponunii cncnpi mpan2 blocnilem sylancr c0o
      co eleq1 wne wa wf cv clt wbr wral crp wrex cnmoo cdiv simprr cc0 nmblore
      wi cr mp3an12 wb nmlnogt0 biimpi anim12i elrp sylibr adantr rpdivcld cmul
      mp3an simprl metcl mp3an1 sylan simplrr ad2antrr ltmuldiv2 syl3anc cle id
      rpred ad2ant2r blometi 3expa lnof ffvelrni syl2an remulcl adantllr lelttr
      anassrs adantlrr mpand sylbird ralrimiva wceq breq2 imbi1d ralbidv rspcev
      syl2anc ralrimivva jctil metcn mp2an csn 0ofval cnconst2 eqeltri pm2.61ne
      cxp a1i impbii ) DFGUEVEZSZDASZYREUFTZEUGTZSZDYTFGUHVETSZYSEUISZUUBPEUUAY
      TUUAUJZYTUJUKULZYRUUBUUCUUFYTDFGUUAUUAFBUUAUMTSZFUUAUNTSZBUUAUOTSZUUGUUDU
      UIPBEUUAUUEJUPULZBUUAUQULZBFUUALURULZUSUTVAABCYTDEFGHIUUAJKLMNOPQRUUEVBVC
      YSYREIVDVEZYQSZDUUMDUUMYQVFYSDUUMVGZVHZUUAIUGTZDVIZUAVJZUBVJZBVEZUCVJZVKV
      LZUUSDTZUUTDTZCVEZUDVJZVKVLZWAZUBUUAVMZUCVNVOZUDVNVMUAUUAVMZVHZYRUUPUVLUU
      RUUPUVKUAUDUUAVNUUPUUSUUASZUVGVNSZVHZVHZUVGDEIVPVEZTZVQVEZVNSUVAUVTVKVLZU
      VHWAZUBUUAVMZUVKUVQUVGUVSUUPUVNUVOVRUUPUVSVNSZUVPUUPUVSWBSZVSUVSVKVLZVHZU
      WDYSUWEUUOUWFUUDIUISZYSUWEPQADEUVRIUUAUUQUUEUUQUJZUVRUJZOVTWCZUUOUWFUUDUW
      HDHSZUUOUWFWDPQRDEHUVRIUUMUWJUUMUJZNWEWMWFWGZUVSWHWIWJWKUVQUWBUBUUAUVQUUT
      UUASZVHZUWAUVSUVAWLVEZUVGVKVLZUVHUWPUVAWBSZUVGWBSZUWGUWRUWAWDUVQUVNUWOUWS
      UUPUVNUVOWNZUUIUVNUWOUWSUUJUUSUUTBUUAWOWPZWQUWPUVGUUPUVNUVOUWOWRXDZUUPUWG
      UVPUWOUWNWSUVAUVGUVSWTXAUWPUVFUWQXBVLZUWRUVHUVQYSUVNVHZUWOUXDYSUVNUXEUUOU
      VOUXEXCXEYSUVNUWOUXDABCUUSUUTDEUVRIUUAUUQUUEUWIJKUWJOPQXFXGWQUWPUVFWBSZUW
      QWBSZUWTUXDUWRVHUVHWAUVQUVNUWOUXFUXAUVNUVDUUQSZUVEUUQSZUXFUWOUUAUUQUUSDUU
      DUWHUWLUURPQRDEHIUUAUUQUUEUWINXHWMZXIUUAUUQUUTDUXJXICUUQUOTSZUXHUXIUXFUWH
      UXKQCIUUQUWIKUPULZUVDUVECUUQWOWPXJWQUUPUVNUWOUXGUVOYSUVNUWOUXGUUOYSUVNUWO
      UXGYSUWEUWSUXGUVNUWOVHUWKUXBUVSUVAXKXJXNXLXOUXCUVFUWQUVGXMXAXPXQXRUVJUWCU
      CUVTVNUVBUVTXSZUVIUWBUBUUAUXMUVCUWAUVHUVBUVTUVAVKXTYAYBYCYDYEUXJYFUUGCUUQ
      UMTSZYRUVMWDUUKUXKUXNUXLCUUQUQULZUAUDUCUBBCDFGUUAUUQLMYGYHWIUUNYSUUMUUAIU
      FTZYIYNZYQUUDUWHUUMUXQXSPQEUUMIUUAUXPUUEUXPUJZUWMYJYHUUHGUUQUNTSZUXPUUQSZ
      UXQYQSUULUXNUXSUXOCGUUQMURULUWHUXTQIUUQUXPUWIUXRUKULUXPFGUUAUUQYKWMYLYOYM
      YP $.

    ${
      lnocni.1 $e |- X = ( BaseSet ` U ) $.
      $( If a linear operator is continuous at any point, it is continuous
         everywhere.  Theorem 2.7-9(b) of [Kreyszig] p. 97.  (Contributed by
         NM, 18-Dec-2007.)  (New usage is discouraged.) $)
      lnocni $p |- ( ( P e. X /\ T e. ( ( J CnP K ) ` P ) ) ->
                T e. ( J Cn K ) ) $=
        ( wcel ccnp co cfv wa ccn blocnilem blocni sylibr ) DKUBEDGHUCUDUEUBUFE
        AUBEGHUGUDUBABCDEFGHIJKLMNOPQRSTUAUHABCEFGHIJLMNOPQRSTUIUJ $.
    $}
  $}

  ${
    blocn.8 $e |- C = ( IndMet ` U ) $.
    blocn.d $e |- D = ( IndMet ` W ) $.
    blocn.j $e |- J = ( MetOpen ` C ) $.
    blocn.k $e |- K = ( MetOpen ` D ) $.
    blocn.5 $e |- B = ( U BLnOp W ) $.
    blocn.u $e |- U e. NrmCVec $.
    blocn.w $e |- W e. NrmCVec $.
    ${
      blocn.4 $e |- L = ( U LnOp W ) $.
      $( A linear operator is continuous iff it is bounded.  Theorem 2.7-9(a)
         of [Kreyszig] p. 97.  (Contributed by NM, 25-Dec-2007.)
         (New usage is discouraged.) $)
      blocn $p |- ( T e. L -> ( T e. ( J Cn K ) <-> T e. B ) ) $=
        ( wcel co wb ccn c0o cif wceq eleq1 bibi12d cnv eqid 0lno elimel blocni
        mp2an dedth ) DHRZDFGUASZRZDARZTUNDEIUBSZUCZUORZUSARZTDURDUSUDUPUTUQVAD
        USUOUEDUSAUEUFABCUSEFGHIJKLMQNOPDURHEUGRIUGRURHROPEHIURURUHQUIULUJUKUM
        $.
    $}

    $( A bounded linear operator is continuous.  (Contributed by NM,
       25-Dec-2007.)  (New usage is discouraged.) $)
    blocn2 $p |- ( T e. B -> T e. ( J Cn K ) ) $=
      ( clno co wcel ccn cnv eqid bloln mp3an12 blocn biimprd mpcom ) DEHPQZRZD
      ARZDFGSQRZETRHTRUIUHNOADEUGHUGUAZMUBUCUHUJUIABCDEFGUGHIJKLMNOUKUDUEUF $.
  $}

  ${
    $d u w P $.  $d s t u w x y U $.  $d s t u w x y W $.  $d s t u w x X $.
    $d u w Q $.  $d s t u w y Y $.
    ajfval.1 $e |- X = ( BaseSet ` U ) $.
    ajfval.2 $e |- Y = ( BaseSet ` W ) $.
    ajfval.3 $e |- P = ( .iOLD ` U ) $.
    ajfval.4 $e |- Q = ( .iOLD ` W ) $.
    ajfval.5 $e |- A = ( U adj W ) $.
    $( The adjoint function.  (Contributed by NM, 25-Jan-2008.)  (Revised by
       Mario Carneiro, 16-Nov-2013.)  (New usage is discouraged.) $)
    ajfval $p |- ( ( U e. NrmCVec /\ W e. NrmCVec ) -> A =
     { <. t , s >. | ( t : X --> Y /\ s : Y --> X /\ A. x e. X A. y e. Y
    ( ( t ` x ) Q y ) = ( x P ( s ` y ) ) ) } ) $=
      ( co cv cfv cba vu vw cnv wcel wa caj wf wceq wral w3a copab cdip syl6eqr
      fveq2 feq2d eqidd feq23d oveqd eqeq2d raleqbidv 3anbi123d opabbidv eqeq1d
      ralbidv df-aj cmap cxp ovex xpex cvv fvex eqeltri anbi12i biimpri 3adant3
      elmap ssopab2i df-xp sseqtr4i ssexi ovmpt2 syl5eq ) GUCUDHUCUDUEDGHUFQIJC
      RZUGZJIKRZUGZARZWCSZBRZFQZWGWIWESZEQZUHZBJUIZAIUIZUJZCKUKZPUAUBGHUCUCUARZ
      TSZUBRZTSZWCUGZXAWSWEUGZWHWIWTULSZQZWGWKWRULSZQZUHZBXAUIZAWSUIZUJZCKUKWQU
      FIXAWCUGZXAIWEUGZXEWLUHZBXAUIZAIUIZUJZCKUKWRGUHZXKXQCKXRXBXLXCXMXJXPXRWSI
      XAWCXRWSGTSZIWRGTUNLUMZUOXRXAWSXAIWEXRXAUPXTUQXRXIXOAWSIXTXRXHXNBXAXRXGWL
      XEXRXFEWGWKXRXFGULSEWRGULUNNUMURUSVDUTVAVBWTHUHZXQWPCKYAXLWDXMWFXPWOYAIXA
      IJWCYAIUPYAXAHTSZJWTHTUNMUMZUQYAXAJIWEYCUOYAXOWNAIYAXNWMBXAJYCYAXEWJWLYAX
      DFWHWIYAXDHULSFWTHULUNOUMURVCUTVDVAVBABUBUACKVEWQJIVFQZIJVFQZVGZYDYEJIVFV
      HIJVFVHVIWQWCYDUDZWEYEUDZUEZCKUKYFWPYICKWDWFYIWOYIWDWFUEYGWDYHWFJIWCJYBVJ
      MHTVKVLZIXSVJLGTVKVLZVPIJWEYKYJVPVMVNVOVQCKYDYEVRVSVTWAWB $.
  $}

  ${
    $d o t u A $.  $d t T $.  $d o t u U $.
    hmoval.8 $e |- H = ( HmOp ` U ) $.
    hmoval.9 $e |- A = ( U adj U ) $.
    $( The set of Hermitian (self-adjoint) operators on a normed complex vector
       space.  (Contributed by NM, 26-Jan-2008.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    hmoval $p |- ( U e. NrmCVec -> H = { t e. dom A | ( A ` t ) = t } ) $=
      ( vu cnv wcel chmo cfv cv wceq cdm crab caj co oveq12 anidms syl6eqr ovex
      dmeqd fveq1d eqeq1d rabeqbidv df-hmo cvv eqeltri dmex rabex fvmpt syl5eq
      ) CHIDCJKALZBKZUMMZABNZOZEGCUMGLZURPQZKZUMMZAUSNZOUQHJURCMZVAUOAVBUPVCUSB
      VCUSCCPQZBVCUSVDMURCURCPRSFTZUBVCUTUNUMVCUMUSBVEUCUDUEGAUFUOAUPBBVDUGFCCP
      UAUHUIUJUKUL $.

    $( The predicate "is a hermitian operator."  (Contributed by NM,
       26-Jan-2008.)  (New usage is discouraged.) $)
    ishmo $p |- ( U e. NrmCVec ->
      ( T e. H <-> ( T e. dom A /\ ( A ` T ) = T ) ) ) $=
      ( vt cnv wcel cv cfv wceq cdm crab wa hmoval eleq2d fveq2 id eqeq12d
      elrab syl6bb ) CHIZBDIBGJZAKZUDLZGAMZNZIBUGIBAKZBLZOUCDUHBGACDEFPQUFUJGBU
      GUDBLZUEUIUDBUDBARUKSTUAUB $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                    Inner product (pre-Hilbert) spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CPreHilOLD $.

  $( Extend class notation with the class of all complex inner product spaces
     (also called pre-Hilbert spaces). $)
  ccphlo $a class CPreHilOLD $.

  ${
    $d g n s w x y $.
    $( Define the class of all complex inner product spaces.  An inner product
       space is a normed vector space whose norm satisfies the parallelogram
       law (a property that induces an inner product).  Based on Exercise 4(b)
       of [ReedSimon] p. 63.  The vector operation is ` g ` , the scalar
       product is ` s ` , and the norm is ` n ` .  An inner product space is
       also called a pre-Hilbert space.  (Contributed by NM, 2-Apr-2007.)
       (New usage is discouraged.) $)
    df-ph $a |- CPreHilOLD = ( NrmCVec i^i { <. <. g , s >. , n >. |
          A. x e. ran g A. y e. ran g
       ( ( ( n ` ( x g y ) ) ^ 2 ) + ( ( n ` ( x g ( -u 1 s y ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( n ` x ) ^ 2 ) + ( ( n ` y ) ^ 2 ) ) ) } ) $.

    $( Every complex inner product space is a normed complex vector space.
       (Contributed by NM, 2-Apr-2007.)  (New usage is discouraged.) $)
    phnv $p |- ( U e. CPreHilOLD -> U e. NrmCVec ) $=
      ( vx vy vg vn vs ccphlo cnv cv co cfv c2 cexp c1 cneg caddc cmul wceq crn
      wral coprab cin df-ph inss1 eqsstri sseli ) GHAGHBIZCIZDIZJEIZKLMJUGNOUHF
      IJUIJUJKLMJPJLUGUJKLMJUHUJKLMJPJQJRCUISZTBUKTDFEUAZUBHBCDEFUCHULUDUEUF $.

    $( The class of all complex inner product spaces is a relation.
       (Contributed by NM, 2-Apr-2007.)  (New usage is discouraged.) $)
    phrel $p |- Rel CPreHilOLD $=
      ( vx ccphlo cnv wss wrel cv phnv ssriv nvrel relss mp2 ) BCDCEBEABCAFGHIB
      CJK $.
  $}

  ${
    phnvi.1 $e |- U e. CPreHilOLD $.
    $( Every complex inner product space is a normed complex vector space.
       (Contributed by NM, 20-Nov-2007.)  (New usage is discouraged.) $)
    phnvi $p |- U e. NrmCVec $=
      ( ccphlo wcel cnv phnv ax-mp ) ACDAEDBAFG $.
  $}

  ${
    $d g n s x y G $.  $d g n s x y N $.  $d g n s x y S $.  $d g n s x y X $.
    $d g n s Z $.
    isphg.1 $e |- X = ran G $.
    $( The predicate "is a complex inner product space."  An inner product
       space is a normed vector space whose norm satisfies the parallelogram
       law.  The vector (group) addition operation is ` G ` , the scalar
       product is ` S ` , and the norm is ` N ` .  An inner product space is
       also called a pre-Hilbert space.  (Contributed by NM, 2-Apr-2007.)
       (New usage is discouraged.) $)
    isphg $p |- ( ( G e. A /\ S e. B /\ N e. C ) ->
  ( <. <. G , S >. , N >. e. CPreHilOLD <-> ( <. <. G , S >. , N >. e. NrmCVec
        /\
          A. x e. X A. y e. X
      ( ( ( N ` ( x G y ) ) ^ 2 ) + ( ( N ` ( x G ( -u 1 S y ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` x ) ^ 2 ) + ( ( N ` y ) ^ 2 ) ) ) ) ) ) $=
      ( wcel cv co cfv c2 cexp caddc wceq wral oveq1d vg vn cop ccphlo cnv cneg
      vs c1 cmul crn coprab wa w3a df-ph elin2 rneq syl6eqr oveq fveq2d oveq12d
      eqeq1d raleqbidv oveq2d 2ralbidv fveq1 eqeq12d eloprabg anbi2d syl5bb ) G
      FUCHUCZUDKVJUEKZVJALZBLZUALZMZUBLZNZOPMZVLUHUFZVMUGLZMZVNMZVPNZOPMZQMZOVL
      VPNZOPMZVMVPNZOPMZQMZUIMZRZBVNUJZSZAWMSZUAUGUBUKZKZULGCKFDKHEKUMZVKVLVMGM
      ZHNZOPMZVLVSVMFMZGMZHNZOPMZQMZOVLHNZOPMZVMHNZOPMZQMZUIMZRZBISAISZULVJUEWP
      UDABUAUBUGUNUOWRWQXNVKWOWSVPNZOPMZVLWAGMZVPNZOPMZQMZWKRZBISZAISXPXCVPNZOP
      MZQMZWKRZBISAISXNUAUGUBGFHCDEVNGRZWNYBAWMIYGWMGUJIVNGUPJUQZYGWLYABWMIYHYG
      WEXTWKYGVRXPWDXSQYGVQXOOPYGVOWSVPVLVMVNGURUSTYGWCXROPYGWBXQVPVLWAVNGURUST
      UTVAVBVBVTFRZYAYFABIIYIXTYEWKYIXSYDXPQYIXRYCOPYIXQXCVPYIWAXBVLGVSVMVTFURV
      CUSTVCVAVDVPHRZYFXMABIIYJYEXFWKXLYJXPXAYDXEQYJXOWTOPWSVPHVETYJYCXDOPXCVPH
      VETUTYJWJXKOUIYJWGXHWIXJQYJWFXGOPVLVPHVETYJWHXIOPVMVPHVETUTVCVFVDVGVHVI
      $.
  $}

  ${
    phop.2 $e |- G = ( +v ` U ) $.
    phop.4 $e |- S = ( .sOLD ` U ) $.
    phop.6 $e |- N = ( normCV ` U ) $.
    $( A complex inner product space in terms of ordered pair components.
       (Contributed by NM, 2-Apr-2007.)  (New usage is discouraged.) $)
    phop $p |- ( U e. CPreHilOLD -> U = <. <. G , S >. , N >. ) $=
      ( ccphlo wcel c1st cfv c2nd cop wrel wceq phrel 1st2nd mpan nmcvfval cvc
      opeq2i cnv phnv eqid nvvc vcrel vafval smfval opeq12i syl6eqr 3syl opeq1d
      syl5eqr eqtrd ) BHIZBBJKZBLKZMZCAMZDMZHNUOBUROPBHQRUOURUPDMUTDUQUPBDGSUAU
      OUPUSDUOBUBIUPTIZUPUSOBUCBUPUPUDUEVAUPUPJKZUPLKZMZUSTNVAUPVDOUFUPTQRCVBAV
      CBCEUGABFUHUIUJUKULUMUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of pre-Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    cncph.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is an inner product (pre-Hilbert) space.
       (Contributed by Steve Rodriguez, 28-Apr-2007.)  (Revised by Mario
       Carneiro, 7-Nov-2013.)  (New usage is discouraged.) $)
    cncph $p |- U e. CPreHilOLD $=
      ( vx vy caddc cmul cop cabs ccphlo wcel cv co c2 cexp wceq cc eqtrd recnd
      cfv cvv cnv c1 cneg wral eqid cnnv cmin mulm1 adantl oveq2d negsub fveq2d
      wa oveq1d ccj cre sqabsadd sqabssub oveq12d abscl sqcld addcl syl2an cjcl
      2cn mulcl sylan2 recl sylancr ppncand 2times eqcomd rgen2a wb addex mulex
      syl cr absf cnex fex mp2an cablo cgr cnaddablo ablogrpo ax-mp cxp ax-addf
      wf fdmi grporn isphg mp3an mpbir2an eqeltri ) AEFGHGZIBWQIJZWQUAJZCKZDKZE
      LHSMNLZWTUBUCXAFLZELZHSZMNLZELZMWTHSZMNLZXAHSZMNLZELZFLZOZDPUDCPUDZWQWQUE
      UFXNCDPWTPJZXAPJZUMZXGXBWTXAUGLZHSZMNLZELZXMXRXFYAXBEXRXEXTMNXRXDXSHXRXDW
      TXAUCZELXSXRXCYCWTEXQXCYCOXPXAUHUIUJWTXAUKQULUNUJXRYBXLXLELZXMXRYBXLMWTXA
      UOSZFLZUPSZFLZELZXLYHUGLZELYDXRXBYIYAYJEWTXAUQWTXAURUSXRXLYHXLXPXIPJXKPJX
      LPJZXQXPXHXPXHWTUTRVAXQXJXQXJXAUTRVAXIXKVBVCZXRMPJYGPJZYHPJVEXRYFPJZYMXQX
      PYEPJYNXAVDWTYEVFVGYNYGYFVHRVQMYGVFVIYLVJQXRYKYDXMOYLYKXMYDXLVKVLVQQQVMET
      JFTJHTJZWRWSXOUMVNVOVPPVRHWJPTJYOVSVTPVRTHWAWBCDTTTFEHPEPEWCJEWDJWEEWFWGP
      PWHPEWIWKWLWMWNWOWP $.
  $}

  ${
    elimph.1 $e |- X = ( BaseSet ` U ) $.
    elimph.5 $e |- Z = ( 0vec ` U ) $.
    elimph.6 $e |- U e. CPreHilOLD $.
    $( TODO - use elimnvOLD ? $)
    $( Hypothesis elimination lemma for complex inner product spaces to assist
       weak deduction theorem.  (Contributed by NM, 27-Apr-2007.)
       (New usage is discouraged.) $)
    elimph $p |- if ( A e. X , A , Z ) e. X $=
      ( phnvi elimnv ) ABCDEFBGHI $.
  $}

  $( TODO - use elimnvu ? $)
  $( Hypothesis elimination lemma for complex inner product spaces to assist
     weak deduction theorem.  (Contributed by NM, 6-May-2007.)
     (New usage is discouraged.) $)
  elimphu $p |- if ( U e. CPreHilOLD , U , <. <. + , x. >. , abs >. )
                 e. CPreHilOLD $=
    ( caddc cmul cop cabs ccphlo eqid cncph elimel ) ABCDEDZFJJGHI $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Properties of pre-Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y M $.  $d x y N $.  $d x y U $.
    $d x y X $.
    isph.1 $e |- X = ( BaseSet ` U ) $.
    isph.2 $e |- G = ( +v ` U ) $.
    isph.3 $e |- M = ( -v ` U ) $.
    isph.6 $e |- N = ( normCV ` U ) $.
    $( The predicate "is an inner product space."  (Contributed by NM,
       1-Feb-2008.)  (New usage is discouraged.) $)
    isph $p |- ( U e. CPreHilOLD <-> ( U e. NrmCVec /\ A. x e. X A. y e. X
      ( ( ( N ` ( x G y ) ) ^ 2 ) + ( ( N ` ( x M y ) ) ^ 2 ) ) = (
      2 x. ( ( ( N ` x ) ^ 2 ) + ( ( N ` y ) ^ 2 ) ) ) ) ) $=
      ( wcel co cfv c2 cexp caddc wceq wa cvv ccphlo cnv cmul wral phnv cns cop
      cv wb eqid nvop eleq1 c1 cneg cpv eqeltri cnmcv bafval isphg mp3an nvmval
      fvex 3expa fveq2d oveq1d oveq2d eqeq1d ralbidva pm5.32i anbi1d syl5bb syl
      syl5rbb bitrd bianabs biadan2 ) CUALZCUBLZAUHZBUHZDMFNOPMZVSVTEMZFNZOPMZQ
      MZOVSFNOPMVTFNOPMQMUCMZRZBGUDZAGUDZCUEVRVQWIVRCDCUFNZUGFUGZRZVQVRWISZUIWJ
      CDFIWJUJZKUKWLVQWKUALZWMCWKUAULWOWKUBLZWAVSUMUNVTWJMDMZFNZOPMZQMZWFRZBGUD
      ZAGUDZSZWLWMDTLWJTLFTLWOXDUIDCUONTICUOVBUPCUFVBFCUQNTKCUQVBUPABTTTWJDFGCD
      GHIURUSUTWMVRXCSWLXDVRWIXCVRWHXBAGVRVSGLZSZWGXABGXFVTGLZSZWEWTWFXHWDWSWAQ
      XHWCWROPXHWBWQFVRXEXGWBWQRVSVTWJCDEGHIWNJVAVCVDVEVFVGVHVHVIWLVRWPXCCWKUBU
      LVJVMVKVNVLVOVP $.

    $( The parallelogram law for an inner product space.  (Contributed by NM,
       2-Apr-2007.)  (New usage is discouraged.) $)
    phpar2 $p |- ( ( U e. CPreHilOLD /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A M B ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      ( vx co cfv c2 cexp caddc cmul wceq oveq1d vy ccphlo wcel w3a cv wral cnv
      isph simprbi 3ad2ant1 wi oveq1 fveq2d oveq12d fveq2 oveq2d eqeq12d rspc2v
      oveq2 3adant1 mpd ) CUBUCZAGUCZBGUCZUDLUEZUAUEZDMZFNZOPMZVEVFEMZFNZOPMZQM
      ZOVEFNZOPMZVFFNZOPMZQMZRMZSZUAGUFLGUFZABDMZFNZOPMZABEMZFNZOPMZQMZOAFNZOPM
      ZBFNZOPMZQMZRMZSZVBVCWAVDVBCUGUCWALUACDEFGHIJKUHUIUJVCVDWAWOUKVBVTWOAVFDM
      ZFNZOPMZAVFEMZFNZOPMZQMZOWJVQQMZRMZSLUAABGGVEASZVMXBVSXDXEVIWRVLXAQXEVHWQ
      OPXEVGWPFVEAVFDULUMTXEVKWTOPXEVJWSFVEAVFEULUMTUNXEVRXCORXEVOWJVQQXEVNWIOP
      VEAFUOTTUPUQVFBSZXBWHXDWNXFWRWDXAWGQXFWQWCOPXFWPWBFVFBADUSUMTXFWTWFOPXFWS
      WEFVFBAEUSUMTUNXFXCWMORXFVQWLWJQXFVPWKOPVFBFUOTUPUPUQURUTVA $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    phpar.1 $e |- X = ( BaseSet ` U ) $.
    phpar.2 $e |- G = ( +v ` U ) $.
    phpar.4 $e |- S = ( .sOLD ` U ) $.
    phpar.6 $e |- N = ( normCV ` U ) $.
    $( The parallelogram law for an inner product space.  (Contributed by NM,
       2-Apr-2007.)  (New usage is discouraged.) $)
    phpar $p |- ( ( U e. CPreHilOLD /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      ( wcel co cfv c2 cexp caddc cmul cvv oveq1d vx vy ccphlo w3a cv cneg wceq
      c1 wral c1st vafval fvex eqeltri c2nd smfval nmcvfval 3pm3.2i phop eleq1d
      cop ibi cnv bafval isphg simplbda sylancr 3ad2ant1 wi oveq1 oveq12d fveq2
      fveq2d oveq2d eqeq12d oveq2 rspc2v 3adant1 mpd ) DUCLZAGLZBGLZUDUAUEZUBUE
      ZEMZFNZOPMZWBUHUFZWCCMZEMZFNZOPMZQMZOWBFNZOPMZWCFNZOPMZQMZRMZUGZUBGUIUAGU
      IZABEMZFNZOPMZAWGBCMZEMZFNZOPMZQMZOAFNZOPMZBFNZOPMZQMZRMZUGZVSVTWTWAVSESL
      ZCSLZFSLZUDZECUTFUTZUCLZWTXPXQXREDUJNZUJNSDEIUKYBUJULUMCYBUNNSCDJUOYBUNUL
      UMFDUNNSDFKUPDUNULUMUQVSYAVSDXTUCCDEFIJKURUSVAXSYAXTVBLWTUAUBSSSCEFGDEGHI
      VCVDVEVFVGVTWAWTXOVHVSWSXOAWCEMZFNZOPMZAWHEMZFNZOPMZQMZOXJWPQMZRMZUGUAUBA
      BGGWBAUGZWLYIWRYKYLWFYEWKYHQYLWEYDOPYLWDYCFWBAWCEVIVLTYLWJYGOPYLWIYFFWBAW
      HEVIVLTVJYLWQYJORYLWNXJWPQYLWMXIOPWBAFVKTTVMVNWCBUGZYIXHYKXNYMYEXCYHXGQYM
      YDXBOPYMYCXAFWCBAEVOVLTYMYGXFOPYMYFXEFYMWHXDAEWCBWGCVOVMVLTVJYMYJXMORYMWP
      XLXJQYMWOXKOPWCBFVKTVMVMVNVPVQVR $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y G $.  $d x y N $.  $d x y S $.  $d x y X $.
    ip1i.1 $e |- X = ( BaseSet ` U ) $.
    ip1i.2 $e |- G = ( +v ` U ) $.
    ip1i.4 $e |- S = ( .sOLD ` U ) $.
    ip1i.7 $e |- P = ( .iOLD ` U ) $.
    ip1i.9 $e |- U e. CPreHilOLD $.
    ${
      ip1i.a $e |- A e. X $.
      ip1i.b $e |- B e. X $.
      ip1i.c $e |- C e. X $.
      ${
        ip1i.6 $e |- N = ( normCV ` U ) $.
        ip0i.j $e |- J e. CC $.
        $( A slight variant of Equation 6.46 of [Ponnusamy] p. 362, where ` J `
           is either 1 or -1 to represent +-1.  (Contributed by NM,
           23-Apr-2007.)  (New usage is discouraged.) $)
        ip0i $p |- ( ( ( ( N ` ( ( A G B ) G ( J S C ) ) ) ^ 2 ) -
             ( ( N ` ( ( A G B ) G ( -u J S C ) ) ) ^ 2 ) ) +
             ( ( ( N ` ( ( A G ( -u 1 S B ) ) G ( J S C ) ) ) ^ 2 ) -
           ( ( N ` ( ( A G ( -u 1 S B ) ) G ( -u J S C ) ) ) ^ 2 ) ) ) =
                ( 2 x. ( ( ( N ` ( A G ( J S C ) ) ) ^ 2 ) -
                ( ( N ` ( A G ( -u J S C ) ) ) ^ 2 ) ) ) $=
          ( c2 co cfv cexp cneg cmin cmul caddc c1 2cn phnvi cnv cc nvscl mp3an
          wcel nvgcl nvcli recni sqcli negcli subdii wceq mulcli pnpcan2 eqtr4i
          cablo w3a c1st cvc eqid nvvc vafval vcablo mp2b 3pm3.2i bafval ablo32
          fveq2i oveq1i neg1cn oveq12i ccphlo adddii 3eqtri addsub4i 3eqtr2ri
          mp2an phpar ) UAAHCEUBZGUBZIUCZUAUDUBZAHUEZCEUBZGUBZIUCZUAUDUBZUFUBUG
          UBZUAWMUGUBZUABIUCZUAUDUBZUGUBZUHUBZUAWRUGUBZXCUHUBZUFUBZABGUBZWJGUBZ
          IUCZUAUDUBZAUIUEZBEUBZGUBZWJGUBZIUCZUAUDUBZUHUBZXHWOGUBZIUCZUAUDUBZXN
          WOGUBZIUCZUAUDUBZUHUBZUFUBXKYAUFUBXQYDUFUBUHUBWSWTXEUFUBZXGUAWMWRUJWL
          WLWKFIJKSFOUKZFULUPZAJUPZWJJUPZWKJUPZYGPYHHUMUPCJUPZYJYGTRHCEFJKMUNUO
          ZAWJFGJKLUQUOZURUSUTZWQWQWPFIJKSYGYHYIWOJUPZWPJUPZYGPYHWNUMUPYLYPYGHT
          VARWNCEFJKMUNUOZAWOFGJKLUQUOZURUSUTZVBWTUMUPXEUMUPXCUMUPXGYFVCUAWMUJY
          OVDUAWRUJYTVDUAXBUJXAXABFIJKSYGQURUSUTZVDWTXEXCVEUOVFXRXDYEXFUFXRWKBG
          UBZIUCZUAUDUBZWKXMGUBZIUCZUAUDUBZUHUBZUAWMXBUHUBUGUBZXDXKUUDXQUUGUHXJ
          UUCUAUDXIUUBIGVGUPZYIBJUPZYJVHXIUUBVCYHFVIUCZVJUPUUJYGFUULUULVKVLGUUL
          FGLVMVNVOZYIUUKYJPQYMVPABWJGJFGJKLVQZVRWHVSVTXPUUFUAUDXOUUEIUUJYIXMJU
          PZYJVHXOUUEVCUUMYIUUOYJPYHXLUMUPUUKUUOYGWAQXLBEFJKMUNUOZYMVPAXMWJGJUU
          NVRWHVSVTWBFWCUPZYKUUKUUHUUIVCOYNQWKBEFGIJKLMSWIUOUAWMXBUJYOUUAWDWEYE
          WPBGUBZIUCZUAUDUBZWPXMGUBZIUCZUAUDUBZUHUBZUAWRXBUHUBUGUBZXFYAUUTYDUVC
          UHXTUUSUAUDXSUURIUUJYIUUKYPVHXSUURVCUUMYIUUKYPPQYRVPABWOGJUUNVRWHVSVT
          YCUVBUAUDYBUVAIUUJYIUUOYPVHYBUVAVCUUMYIUUOYPPUUPYRVPAXMWOGJUUNVRWHVSV
          TWBUUQYQUUKUVDUVEVCOYSQWPBEFGIJKLMSWIUOUAWRXBUJYTUUAWDWEWBXKXQYAYDXJX
          JXIFIJKSYGYHXHJUPZYJXIJUPYGYHYIUUKUVFYGPQABFGJKLUQUOZYMXHWJFGJKLUQUOU
          RUSUTXPXPXOFIJKSYGYHXNJUPZYJXOJUPYGYHYIUUOUVHYGPUUPAXMFGJKLUQUOZYMXNW
          JFGJKLUQUOURUSUTXTXTXSFIJKSYGYHUVFYPXSJUPYGUVGYRXHWOFGJKLUQUOURUSUTYC
          YCYBFIJKSYGYHUVHYPYBJUPYGUVIYRXNWOFGJKLUQUOURUSUTWFWG $.

        $( Lemma for ~ ip1i .  (Contributed by NM, 21-Apr-2007.)
           (New usage is discouraged.) $)
        ip1ilem $p |- ( ( ( A G B ) P C ) +
                         ( ( A G ( -u 1 S B ) ) P C ) ) = ( 2 x. ( A P C ) ) $=
          ( c4 co c1 cneg caddc cmul cdiv c2 cfv cexp cmin ci wcel wceq 4ipval2
          cnv phnvi mp3an oveq2i 2cn 4cn dipcl mul12i nvgcl nvcli resqcli recni
          cc ax-1cn negcli nvscl subcli ax-icn mulcli adddii nvsid mp2an fveq2i
          oveq1i oveq12i 3eqtr3i eqtr4i add4i eqtr2i 3eqtri 3eqtr3ri addcli 4re
          ip0i 4pos gt0ne0ii divcan3i ) UAABGUBZCDUBZAUCUDZBEUBZGUBZCDUBZUEUBZU
          FUBZUAUGUBUAUHACDUBZUFUBZUFUBZUAUGUBWSXBWTXCUAUGUHUAXAUFUBZUFUBUHACGU
          BZIUIZUHUJUBZAWOCEUBZGUBZIUIZUHUJUBZUKUBZULAULCEUBZGUBZIUIZUHUJUBZAUL
          UDZCEUBZGUBZIUIZUHUJUBZUKUBZUFUBZUEUBZUFUBZXCWTXDYDUHUFFUPUMZAJUMZCJU
          MZXDYDUNFOUQZPRACDEFGIJKLMSNUOURUSUHUAXAUTVAYFYGYHXAVHUMYIPRACDFJKNVB
          URZVCYEWMCGUBZIUIZUHUJUBZWMXHGUBZIUIZUHUJUBZUKUBZWQCGUBZIUIZUHUJUBZWQ
          XHGUBZIUIZUHUJUBZUKUBZUEUBZULWMXMGUBZIUIZUHUJUBZWMXRGUBZIUIZUHUJUBZUK
          UBZUFUBZULWQXMGUBZIUIZUHUJUBZWQXRGUBZIUIZUHUJUBZUKUBZUFUBZUEUBZUEUBZY
          QUUMUEUBZUUDUVAUEUBZUEUBZWTYEUHXLUFUBZUHYCUFUBZUEUBUVCUHXLYCUTXGXKXGX
          FXEFIJKSYIYFYGYHXEJUMYIPRACFGJKLVDURVEVFVGXKXJXIFIJKSYIYFYGXHJUMZXIJU
          MYIPYFWOVHUMZYHUVIYIUCVIVJZRWOCEFJKMVKURZAXHFGJKLVDURVEVFVGVLULYBVMXP
          YAXPXOXNFIJKSYIYFYGXMJUMZXNJUMYIPYFULVHUMYHUVMYIVMRULCEFJKMVKURZAXMFG
          JKLVDURVEVFVGYAXTXSFIJKSYIYFYGXRJUMZXSJUMYIPYFXQVHUMYHUVOYIULVMVJRXQC
          EFJKMVKURZAXRFGJKLVDURVEVFVGVLZVNVOUUEUVGUVBUVHUEWMUCCEUBZGUBZIUIZUHU
          JUBZYPUKUBZWQUVRGUBZIUIZUHUJUBZUUCUKUBZUEUBUHAUVRGUBZIUIZUHUJUBZXKUKU
          BZUFUBUUEUVGABCDEFGUCIJKLMNOPQRSVIWIUWBYQUWFUUDUEUWAYMYPUKUVTYLUHUJUV
          SYKIUVRCWMGYFYHUVRCUNYIRCEFJKMVPVQZUSVRVSVSUWEYTUUCUKUWDYSUHUJUWCYRIU
          VRCWQGUWKUSVRVSVSVTUWJXLUHUFUWIXGXKUKUWHXFUHUJUWGXEIUVRCAGUWKUSVRVSVS
          USWAULUULUUTUEUBZUFUBULUHYBUFUBZUFUBUVBUVHUWLUWMULUFABCDEFGULIJKLMNOP
          QRSVMWIUSULUULUUTVMUUHUUKUUHUUGUUFFIJKSYIYFWMJUMZUVMUUFJUMYIYFYGBJUMZ
          UWNYIPQABFGJKLVDURZUVNWMXMFGJKLVDURVEVFVGUUKUUJUUIFIJKSYIYFUWNUVOUUIJ
          UMYIUWPUVPWMXRFGJKLVDURVEVFVGVLZUUPUUSUUPUUOUUNFIJKSYIYFWQJUMZUVMUUNJ
          UMYIYFYGWPJUMZUWRYIPYFUVJUWOUWSYIUVKQWOBEFJKMVKURAWPFGJKLVDURZUVNWQXM
          FGJKLVDURVEVFVGUUSUURUUQFIJKSYIYFUWRUVOUUQJUMYIUWTUVPWQXRFGJKLVDURVEV
          FVGVLZVOULUHYBVMUTUVQVCWAVTWBYQUUDUUMUVAYMYPYMYLYKFIJKSYIYFUWNYHYKJUM
          YIUWPRWMCFGJKLVDURVEVFVGYPYOYNFIJKSYIYFUWNUVIYNJUMYIUWPUVLWMXHFGJKLVD
          URVEVFVGVLYTUUCYTYSYRFIJKSYIYFUWRYHYRJUMYIUWTRWQCFGJKLVDURVEVFVGUUCUU
          BUUAFIJKSYIYFUWRUVIUUAJUMYIUWTUVLWQXHFGJKLVDURVEVFVGVLULUULVMUWQVNULU
          UTVMUXAVNWCWTUAWNUFUBZUAWRUFUBZUEUBUVFUAWNWRVAYFUWNYHWNVHUMYIUWPRWMCD
          FJKNVBURZYFUWRYHWRVHUMYIUWTRWQCDFJKNVBURZVOUXBUVDUXCUVEUEYFUWNYHUXBUV
          DUNYIUWPRWMCDEFGIJKLMSNUOURYFUWRYHUXCUVEUNYIUWTRWQCDEFGIJKLMSNUOURVTW
          DWEWFVSWSUAWNWRUXDUXEWGVAUAWHWJWKZWLXBUAUHXAUTYJVNVAUXFWLWA $.
      $}

      $( Equation 6.47 of [Ponnusamy] p. 362.  (Contributed by NM,
         27-Apr-2007.)  (New usage is discouraged.) $)
      ip1i $p |- ( ( ( A G B ) P C ) +
                       ( ( A G ( -u 1 S B ) ) P C ) ) = ( 2 x. ( A P C ) ) $=
        ( c1 cnmcv cfv eqid ax-1cn ip1ilem ) ABCDEFGQFRSZHIJKLMNOPUCTUAUB $.
    $}

    ${
      ip2i.8 $e |- A e. X $.
      ip2i.9 $e |- B e. X $.
      $( Equation 6.48 of [Ponnusamy] p. 362.  (Contributed by NM,
         26-Apr-2007.)  (New usage is discouraged.) $)
      ip2i $p |- ( ( 2 S A ) P B ) = ( 2 x. ( A P B ) ) $=
        ( co c1 caddc cc0 wcel wceq c2 cneg cmul cnv cc phnvi nvgcl mp3an dipcl
        addid1i cn0v cfv eqid nvrinv mp2an oveq1i dip0l eqtri oveq2i w3a ax-1cn
        df-2 3pm3.2i nvdir nvsid oveq12i 3eqtr4ri ip1i ) UAADOZBCOZAAFOZBCOZAPU
        BADOFOZBCOZQOZUAABCOUCOVLRQOVLVOVJVLEUDSZVKGSZBGSZVLUESELUFZVPAGSZVTVQV
        SMMAAEFGHIUGUHNVKBCEGHKUIUHUJVNRVLQVNEUKULZBCOZRVMWABCVPVTVMWATVSMADEFG
        WAHIJWAUMZUNUOUPVPVRWBRTVSNBCEGWAHWCKUQUOURUSVIVKBCVIPPQOZADOZVKUAWDADV
        BUPWEPADOZWFFOZVKVPPUESZWHVTUTWEWGTVSWHWHVTVAVAMVCPPADEFGHIJVDUOWFAWFAF
        VPVTWFATVSMADEGHJVEUOZWIVFURURUPVGAABCDEFGHIJKLMMNVHUR $.
    $}

    ${
      ipdiri.8 $e |- A e. X $.
      ipdiri.9 $e |- B e. X $.
      ipdiri.10 $e |- C e. X $.
      $( Lemma for ~ ipdiri .  (Contributed by NM, 26-Apr-2007.)
         (New usage is discouraged.) $)
      ipdirilem $p |- ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) $=
        ( co wcel wceq mp2an c2 cdiv cmul cneg caddc 2cn 2ne0 recidi oveq1i cnv
        c1 w3a phnvi reccli nvgcl mp3an 3pm3.2i nvsass nvsid 3eqtr3i nvscl ip2i
        cc eqtr3i neg1cn ip1i cn0v cfv cablo wa c1st cvc eqid nvvc ax-mp vafval
        vcablo pm3.2i bafval ablo4 smfval vc2 nvrinv oveq12i nv0rid 3eqtri nvdi
        oveq2i eqtr4i ax-1cn divcan1i eqtri mulcomi mul2negi nv0lid 3eqtr2i
        1t1e1 ) ABGQZCDQZUAUKUAUBQZWREQZCDQUCQZXAWTAUKUDZBEQZGQZEQZGQZCDQZXAXCX
        FEQZGQZCDQZUEQACDQZBCDQZUEQUAXAEQZCDQWSXBXNWRCDUAWTUCQZWREQZUKWREQZXNWR
        XOUKWREUAUFUGUHUIFUJRZUAVCRZWTVCRZWRHRZULXPXNSFMUMZXSXTYAUFUAUFUGUNZXRA
        HRZBHRZYAYBNOABFGHIJUOUPZUQUAWTWREFHIKURTXRYAXQWRSYBYFWREFHIKUSTUTUIXAC
        DEFGHIJKLMXRXTYAXAHRYBYCYFWTWREFHIKVAUPZPVBVDXAXFCDEFGHIJKLMYGXRXTXEHRZ
        XFHRYBYCXRYDXDHRZYHYBNXRXCVCRZYEYIYBVEOXCBEFHIKVAUPZAXDFGHIJUOUPZWTXEEF
        HIKVAUPPVFXHXLXKXMUEXGACDWTWRXEGQZEQZWTUAUCQZAEQZXGAYNWTUAAEQZEQZYPYMYQ
        WTEYMAAGQZBXDGQZGQZYQFVGVHZGQZYQGVIRZYDYEVJZYDYIVJYMUUASFVKVHZVLRZUUDXR
        UUGYBFUUFUUFVMVNVOZGUUFFGJVPZVQVOZYDYENOVRZYDYINYKVRABAXDGHFGHIJVSZVTUP
        YSYQYTUUBGUUGYDYSYQSUUHNAEGUUFHUUIEFKWAZUULWBTXRYEYTUUBSYBOBEFGHUUBIJKU
        UBVMZWCTWDXRYQHRZUUCYQSYBXRXSYDUUOYBUFNUAAEFHIKVAUPYQFGHUUBIJUUNWETWFWH
        XRXTXSYDULYPYRSYBXTXSYDYCUFNUQWTUAAEFHIKURTWIXRXTYAYHULYNXGSYBXTYAYHYCY
        FYLUQWTWRXEEFGHIJKWGTYPUKAEQZAYOUKAEUKUAWJUFUGWKZUIXRYDUUPASYBNAEFHIKUS
        TWLUTUIXJBCDXJWTWRXCAEQZBGQZGQZEQZUKBEQZBXJXAWTUUSEQZGQZUVAXIUVCXAGXCWT
        UCQZXEEQZWTXCUCQZXEEQZXIUVCUVEUVGXEEXCWTVEYCWMUIXRYJXTYHULUVFXISYBYJXTY
        HVEYCYLUQXCWTXEEFHIKURTUVHWTXCXEEQZEQZUVCXRXTYJYHULUVHUVJSYBXTYJYHYCVEY
        LUQWTXCXEEFHIKURTUVIUUSWTEUVIUURXCXDEQZGQZUUSXRYJYDYIULUVIUVLSYBYJYDYIV
        ENYKUQXCAXDEFGHIJKWGTUVKBUURGXCXCUCQZBEQZUVBUVKBUVMUKBEUVMUKUKUCQUKUKUK
        WJWJWNWQWLUIXRYJYJYEULUVNUVKSYBYJYJYEVEVEOUQXCXCBEFHIKURTXRYEUVBBSYBOBE
        FHIKUSTZUTWHWLWHWLUTWHXRXTYAUUSHRZULUVAUVDSYBXTYAUVPYCYFXRUURHRZYEUVPYB
        XRYJYDUVQYBVENXCAEFHIKVAUPZOUURBFGHIJUOUPUQWTWRUUSEFGHIJKWGTWIUVAWTUABE
        QZEQZYOBEQZUVBUUTUVSWTEUUTAUURGQZBBGQZGQZUWCUVSUUDUUEUVQYEVJUUTUWDSUUJU
        UKUVQYEUVROVRABUURBGHUULVTUPUWDUUBUWCGQZUWCUWBUUBUWCGXRYDUWBUUBSYBNAEFG
        HUUBIJKUUNWCTUIXRUWCHRZUWEUWCSYBXRYEYEUWFYBOOBBFGHIJUOUPUWCFGHUUBIJUUNW
        OTWLUUGYEUWCUVSSUUHOBEGUUFHUUIUUMUULWBTWFWHXRXTXSYEULUWAUVTSYBXTXSYEYCU
        FOUQWTUABEFHIKURTYOUKBEUUQUIWPUVOWFUIWDWP $.
    $}

    $( Distributive law for inner product.  Equation I3 of [Ponnusamy] p. 362.
       (Contributed by NM, 27-Apr-2007.)  (New usage is discouraged.) $)
    ipdiri $p |- ( ( A e. X /\ B e. X /\ C e. X ) ->
                 ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) ) $=
      ( wcel co caddc wceq cif oveq1 oveq2 cn0v cfv oveq1d eqeq12d oveq12d eqid
      oveq2d elimph ipdirilem dedth3h ) AHNZBHNZCHNZABGOZCDOZACDOZBCDOZPOZQUKAF
      UAUBZRZBGOZCDOZUTCDOZUQPOZQUTULBUSRZGOZCDOZVCVECDOZPOZQVFUMCUSRZDOZUTVJDO
      ZVEVJDOZPOZQABCUSUSUSAUTQZUOVBURVDVOUNVACDAUTBGSUCVOUPVCUQPAUTCDSUCUDBVEQ
      ZVBVGVDVIVPVAVFCDBVEUTGTUCVPUQVHVCPBVECDSUGUDCVJQZVGVKVIVNCVJVFDTVQVCVLVH
      VMPCVJUTDTCVJVEDTUEUDUTVEVJDEFGHIJKLMAFHUSIUSUFZMUHBFHUSIVRMUHCFHUSIVRMUH
      UIUJ $.

    ${
      $d j k A $.  $d j k B $.  $d j k C $.  $d j N $.  $d j k P $.
      $d j k S $.  $d j k X $.
      ipasslem1.b $e |- B e. X $.
      $( Lemma for ~ ipassi .  Show the inner product associative law for
         nonnegative integers.  (Contributed by NM, 27-Apr-2007.)
         (New usage is discouraged.) $)
      ipasslem1 $p |- ( ( N e. NN0 /\ A e. X ) ->
                      ( ( N S A ) P B ) = ( N x. ( A P B ) ) ) $=
        ( wcel co cmul wceq cc0 oveq1 vj vk cn0 cv wi c1 caddc wa cc ax-1cn cnv
        nn0cn w3a phnvi nvdir mpan mp3an2 sylan nvsid adantl oveq2d eqtrd dipcl
        oveq1d mp3an13 nvscl mp3an1 ipdiri mp3an3 sylancom eqtr4d adddir syl2an
        mulid2d sylan9eq adantr exp31 a2d cn0v cfv eqid dip0l mp2an nv0 3eqtr4a
        mul02d eqeq12d imbi2d nn0indALT imp ) GUCOAHOZGADPZBCPZGABCPZQPZRZWKUAU
        DZADPZBCPZWQWNQPZRZUEWKSADPZBCPZSWNQPZRZUEWKUBUDZADPZBCPZXFWNQPZRZUEWKX
        FUFUGPZADPZBCPZXKWNQPZRZUEWKWPUEUAUBGXFUCOZWKXJXOXPWKXJXOXPWKUHZXJUHXMX
        IUFWNQPZUGPZXNXQXJXMXHXRUGPZXSXQXMXGAFPZBCPZXTXQXLYABCXQXLXGUFADPZFPZYA
        XPXFUIOZWKXLYDRZXFULZYEUFUIOZWKYFUJEUKOZYEYHWKUMYFEMUNZXFUFADEFHIJKUOUP
        UQURXQYCAXGFWKYCARZXPYIWKYKYJADEHIKUSUPUTVAVBVDXQXTXHWNUGPZYBXQXRWNXHUG
        WKXRWNRXPWKWNYIWKBHOZWNUIOZYJNABCEHILVCVEZVNUTVAXPWKXGHOZYBYLRZXPYEWKYP
        YGYIYEWKYPYJXFADEHIKVFVGURYPWKYMYQNXGABCDEFHIJKLMVHVIVJVKVKXHXIXRUGTVOX
        QXNXSRZXJXPYEYNYRWKYGYOYEYHYNYRUJXFUFWNVLUQVMVPVKVQVRWKEVSVTZBCPZSXCXDY
        IYMYTSRYJNBCEHYSIYSWAZLWBWCWKXBYSBCYIWKXBYSRYJADEHYSIKUUAWDUPVDWKWNYOWF
        WEWQSRZXAXEWKUUBWSXCWTXDUUBWRXBBCWQSADTVDWQSWNQTWGWHWQXFRZXAXJWKUUCWSXH
        WTXIUUCWRXGBCWQXFADTVDWQXFWNQTWGWHWQXKRZXAXOWKUUDWSXMWTXNUUDWRXLBCWQXKA
        DTVDWQXKWNQTWGWHWQGRZXAWPWKUUEWSWMWTWOUUEWRWLBCWQGADTVDWQGWNQTWGWHWIWJ
        $.

      $( Lemma for ~ ipassi .  Show the inner product associative law for
         nonpositive integers.  (Contributed by NM, 27-Apr-2007.)
         (New usage is discouraged.) $)
      ipasslem2 $p |- ( ( N e. NN0 /\ A e. X ) ->
              ( ( -u N S A ) P B ) = ( -u N x. ( A P B ) ) ) $=
        ( wcel co cmul cc cc0 wceq cn0 wa cneg nn0cn negcld phnvi dipcl mp3an13
        cnv mulcl syl2an nvscl mp3an1 sylan syl cmin caddc ax-1cn mulneg2 mpan2
        c1 mulid1 negeqd eqtr2d adantr oveq1d neg1cn nvsass mpan mp3an2 mp3an12
        w3a ipasslem1 sylan2 oveq2d negsubd mulneg1 adantl adddid ipdiri mp3an3
        eqtrd mpdan cn0v eqid nvrinv dip0l mp2an syl6eq eqtr3d mul01d sylan9eqr
        cfv 3eqtr2d subeq0d eqcomd ) GUAOZAHOZUBZGUCZABCPZQPZWTADPZBCPZWSXBXDWQ
        WTROZXAROZXBROWRWQGGUDZUEZEUIOZWRBHOZXFEMUFZNABCEHILUGUHZWTXAUJUKZWSXCH
        OZXDROZWQXEWRXNXHXIXEWRXNXKWTADEHIKULUMUNXIXNXJXOXKNXCBCEHILUGUHUOWSXBX
        DUPPXBGVAUCZADPZBCPZQPZUPPXBXSUCZUQPZSWSXDXSXBUPWSXDGXQDPZBCPZXSWSXCYBB
        CWQGROZWRXCYBTXGYDWRUBZXCGXPQPZADPZYBYEWTYFADYDWTYFTWRYDYFGVAQPZUCZWTYD
        VAROYFYITURGVAUSUTYDYHGGVBVCVDVEVFYDXPROZWRYGYBTZVGXIYDYJWRVLYKXKGXPADE
        HIKVHVIVJWBUNVFWRWQXQHOZYCXSTXIYJWRYLXKVGXPADEHIKULVKZXQBCDEFGHIJKLMNVM
        VNWBVOWSXBXSXMWQYDXRROZXSROWRXGWRYLYNYMXIYLXJYNXKNXQBCEHILUGUHUOZGXRUJU
        KVPWSXBWTXRQPZUQPZYASWSYPXTXBUQWQYDYNYPXTTWRXGYOGXRVQUKVOWSWTXAXRUQPZQP
        ZYQSWSWTXAXRWQXEWRXHVEWRXFWQXLVRWRYNWQYOVRVSWRWQYSWTSQPSWRYRSWTQWRAXQFP
        ZBCPZYRSWRYLUUAYRTZYMWRYLXJUUBNAXQBCDEFHIJKLMVTWAWCWRUUAEWDWMZBCPZSWRYT
        UUCBCXIWRYTUUCTXKADEFHUUCIJKUUCWEZWFVIVFXIXJUUDSTXKNBCEHUUCIUUELWGWHWIW
        JVOWQWTXHWKWLWJWJWNWOWP $.

      $( Lemma for ~ ipassi .  Show the inner product associative law for all
         integers.  (Contributed by NM, 27-Apr-2007.)
         (New usage is discouraged.) $)
      ipasslem3 $p |- ( ( N e. ZZ /\ A e. X ) ->
              ( ( N S A ) P B ) = ( N x. ( A P B ) ) ) $=
        ( wcel cn0 co cmul wceq oveq1d cz cr cn wa elznn0nn ipasslem1 ipasslem2
        cneg wo nnnn0 sylan adantll recn negnegd ad2antrr 3eqtr3d jaoian sylanb
        ) GUAOGPOZGUBOZGUHZUCOZUDZUIAHOZGADQZBCQZGABCQZRQZSZGUEUSVDVIVCABCDEFGH
        IJKLMNUFVCVDUDVAUHZADQZBCQZVJVGRQZVFVHVBVDVLVMSZUTVBVAPOVDVNVAUJABCDEFV
        AHIJKLMNUGUKULUTVLVFSVBVDUTVKVEBCUTVJGADUTGGUMUNZTTUOUTVMVHSVBVDUTVJGVG
        RVOTUOUPUQUR $.

      $( Lemma for ~ ipassi .  Show the inner product associative law for
         positive integer reciprocals.  (Contributed by NM, 27-Apr-2007.)
         (New usage is discouraged.) $)
      ipasslem4 $p |- ( ( N e. NN /\ A e. X ) ->
                  ( ( ( 1 / N ) S A ) P B ) = ( ( 1 / N ) x. ( A P B ) ) ) $=
        ( wcel c1 co cmul cc adantr cn wa cdiv nnrecre recnd phnvi nvscl mp3an1
        cnv sylan dipcl mp3an13 syl mulcl syl2an nncn cc0 recidd oveq1d mulid2d
        wne nnne0 sylan9eq wceq nvsid simpr w3a nvsass syl3anc eqtr3d cn0 nnnn0
        mpan ipasslem1 syl2anc 3eqtrd adantl mulassd mulcanad ) GUAOZAHOZUBZPGU
        CQZADQZBCQZWCABCQZRQZGWBWDHOZWESOZVTWCSOZWAWHVTWCGUDUEZEUIOZWJWAWHEMUFZ
        WCADEHIKUGUHUJZWLWHBHOZWIWMNWDBCEHILUKULUMVTWJWFSOZWGSOWAWKWLWAWOWPWMNA
        BCEHILUKULZWCWFUNUOVTGSOZWAGUPZTZVTGUQVAWAGVBZTWBGWCRQZWFRQZGWERQZGWGRQ
        WBXCWFGWDDQZBCQZXDVTWAXCPWFRQWFVTXBPWFRVTGWSXAURZUSWAWFWQUTVCWBAXEBCWBX
        BADQZAXEVTWAXHPADQZAVTXBPADXGUSWLWAXIAVDWMADEHIKVEVMVCWBWRWJWAXHXEVDZWT
        VTWJWAWKTZVTWAVFWLWRWJWAVGXJWMGWCADEHIKVHVMVIVJUSWBGVKOZWHXFXDVDVTXLWAG
        VLTWNWDBCDEFGHIJKLMNVNVOVPWBGWCWFWTXKWAWPVTWQVQVRVJVS $.

      $( Lemma for ~ ipassi .  Show the inner product associative law for
         rational numbers.  (Contributed by NM, 27-Apr-2007.)
         (New usage is discouraged.) $)
      ipasslem5 $p |- ( ( C e. QQ /\ A e. X ) ->
                  ( ( C S A ) P B ) = ( C x. ( A P B ) ) ) $=
        ( vj vk wcel co cmul wceq cq cv cdiv cn wrex cz wi elq wa w3a c1 cc zcn
        nnrecre recnd cnv phnvi dipcl mp3an13 mulass syl3an adantr nncn cc0 wne
        adantl nnne0 divrecd 3adant3 oveq1d nvsass eqtrd nvscl mp3an1 ipasslem3
        mpan sylan sylan2 3impb ipasslem4 3adant1 oveq2d 3eqtr4rd oveq1 eqeq12d
        id 3eqtrd syl5ibrcom 3expia com23 rexlimivv sylbi imp ) CUAQZAHQZCAERZB
        DRZCABDRZSRZTZWNCOUBZPUBZUCRZTZPUDUEOUFUEWOWTUGZOPCUHXDXEOPUFUDXAUFQZXB
        UDQZUIZWOXDWTXFXGWOXDWTUGXFXGWOUJZWTXDXCAERZBDRZXCWRSRZTXIXAUKXBUCRZSRZ
        WRSRZXAXMWRSRZSRZXLXKXFXAULQZXGXMULQZWOWRULQZXOXQTXAUMZXGXMXBUNUOZFUPQZ
        WOBHQXTFMUQZNABDFHILURUSXAXMWRUTVAXIXCXNWRSXFXGXCXNTWOXHXAXBXFXRXGYAVBX
        GXBULQXFXBVCVFXGXBVDVEXFXBVGVFVHVIZVJXIXKXAXMAERZERZBDRZXAYFBDRZSRZXQXI
        XJYGBDXIXJXNAERZYGXIXCXNAEYEVJXFXRXGXSWOWOYKYGTZYAYBWOWFYCXRXSWOUJYLYDX
        AXMAEFHIKVKVPVAVLVJXFXGWOYHYJTZXGWOUIXFYFHQZYMXGXSWOYNYBYCXSWOYNYDXMAEF
        HIKVMVNVQYFBDEFGXAHIJKLMNVOVRVSXIYIXPXASXGWOYIXPTXFABDEFGXBHIJKLMNVTWAW
        BWGWCXDWQXKWSXLXDWPXJBDCXCAEWDVJCXCWRSWDWEWHWIWJWKWLWM $.
    $}

    ${
      $d w B $.  $d x F $.  $d w K $.  $d w P $.  $d w S $.  $d w U $.
      $d w X $.  $d w x A $.
      ipasslem7.a $e |- A e. X $.
      ipasslem7.b $e |- B e. X $.
      ipasslem7.f $e |- F = ( w e. RR |->
                              ( ( ( w S A ) P B ) - ( w x. ( A P B ) ) ) ) $.
      ${
        ipasslem7.j $e |- J = ( topGen ` ran (,) ) $.
        ipasslem7.k $e |- K = ( TopOpen ` CCfld ) $.
        $( Lemma for ~ ipassi .  Show that
           ` ( ( w S A ) P B ) - ( w x. ( A P B ) ) ` is continuous on
           ` RR ` .  (Contributed by NM, 23-Aug-2007.)  (Revised by Mario
           Carneiro, 6-May-2014.)  (New usage is discouraged.) $)
        ipasslem7 $p |- F e. ( J Cn K ) $=
          ( cr cv co cmul cmin cmpt ccn wcel wtru cioo crn ctg cfv crest tgioo2
          eqtri ctopon cnfldtopon a1i wss ax-resscn cims cmopn cnmptid cxmt cnv
          cc phnvi eqid imsxmet ax-mp mopntopon mp1i cnmptc smcn cnmpt12f dipcn
          ctx dipcl mp3an mulcn subcn cnmpt1res trud eqeltri ) GAUBAUCZBEUDZCDU
          DZWGBCDUDZUEUDZUFUDZUGZIJUHUDZSWMWNUIUJAWLJIJVHUBIUKULUMUNJUBUOUDTJUA
          UPUQJVHURUNUIUJJUAUSUTZUBVHVAUJVBUTUJAWIWKUFJJJJVHWOUJAWHCDJFVCUNZVDU
          NZWQJVHWOUJAWGBEJJWQWQVHWOUJAJVHWOVEZUJABJWQVHKWOWPKVFUNUIZWQKURUNUIU
          JFVGUIZWSFPVIZWPFKLWPVJZVKVLWPWQKWQVJZVMVNZBKUIZUJQUTVOWTEJWQVSUDWQUH
          UDUIUJXAWPEFWQJXBXCNUAVPVNVQUJACJWQVHKWOXDCKUIZUJRUTVOWTDWQWQVSUDJUHU
          DUIUJXAWPDFWQJOXBXCUAVRVNVQUJAWGWJUEJJJJVHWOWRUJAWJJJVHVHWOWOWJVHUIZU
          JWTXEXFXGXAQRBCDFKLOVTWAUTVOUEJJVSUDJUHUDZUIUJJUAWBUTVQUFXHUIUJJUAWCU
          TVQWDWEWF $.
      $}

      $( Lemma for ~ ipassi .  By ~ ipasslem5 , ` F ` is 0 for all ` QQ ` ;
         since it is continuous and ` QQ ` is dense in ` RR ` by ~ qdensere2 ,
         we conclude ` F ` is 0 for all ` RR ` .  (Contributed by NM,
         24-Aug-2007.)  (Revised by Mario Carneiro, 6-May-2014.)
         (New usage is discouraged.) $)
      ipasslem8 $p |- F : RR --> { 0 } $=
        ( wcel cq co vx cc0 cc ccnv csn cima wss cioo crn ctg cfv ccl cr wf 0cn
        wceq cv wral cmul cmin qre oveq1 oveq1d oveq12d ovex fvmpt syl wa phnvi
        qcn cnv nvscl mp3an1 sylan dipcl mp3an13 ipasslem5 subeq0bd mpan2 eqtrd
        rgen wfun cdm wb funmpt2 qssre dmmpti sseqtr4i funconstss mpbi qdensere
        mp2an ccnfld ctopn ct1 ccn w3a cha eqid cnfldhaus haust1 ax-mp uniretop
        ipasslem7 cnfldtopon toponunii dnsconst mpanl12 mp3an ) UBUCRZSGUDUBUEZ
        UFUGZSUHUIUJUKZULUKUKUMUPZUMXKGUNZUOUAUQZGUKZUBUPZUASURZXLXRUASXPSRZXQX
        PBETZCDTZXPBCDTZUSTZUTTZUBXTXPUMRXQYEUPXPVAAXPAUQZBETZCDTZYFYCUSTZUTTZY
        EUMGYFXPUPZYHYBYIYDUTYKYGYACDYFXPBEVBVCYFXPYCUSVBVDQYBYDUTVEVFVGXTBIRZY
        EUBUPOXTYLVHZYBYDYMYAIRZYBUCRZXTXPUCRZYLYNXPVJFVKRZYPYLYNFNVIZXPBEFIJLV
        LVMVNYQYNCIRYOYRPYACDFIJMVOVPVGBCXPDEFHIJKLMNPVQVRVSVTWAGWBSGWCZUGXSXLW
        DAUMYJGQWESUMYSWFAUMYJGYHYIUTVEQWGWHUASUBGWIWLWJWKWMWNUKZWORZGXMYTWPTRX
        JXLXNWQXOYTWRRUUAYTYTWSZWTYTXAXBABCDEFGHXMYTIJKLMNOPQXMWSUUBXDSUBGXMYTU
        MUCXCUCYTYTUUBXEXFXGXHXI $.
    $}

    ${
      $d w A $.  $d w B $.  $d w C $.  $d w P $.  $d w S $.  $d w U $.
      $d w X $.
      ipasslem9.a $e |- A e. X $.
      ipasslem9.b $e |- B e. X $.
      $( Lemma for ~ ipassi .  Conclude from ~ ipasslem8 the inner product
         associative law for real numbers.  (Contributed by NM, 24-Aug-2007.)
         (New usage is discouraged.) $)
      ipasslem9 $p |- ( C e. RR ->
                  ( ( C S A ) P B ) = ( C x. ( A P B ) ) ) $=
        ( vw cr wcel co cc0 cmul cmin wceq cv cmpt cfv oveq1d oveq12d eqid ovex
        oveq1 fvmpt csn wf ipasslem8 fvconst mpan eqtr3d cc wb recn phnvi nvscl
        cnv mp3an13 dipcl syl mp3an mulcl mpan2 subeq0ad mpbid ) CQRZCAESZBDSZC
        ABDSZUASZUBSZTUCZVOVQUCZVMCPQPUDZAESZBDSZWAVPUASZUBSZUEZUFZVRTPCWEVRQWF
        WACUCZWCVOWDVQUBWHWBVNBDWACAEUKUGWACVPUAUKUHWFUIZVOVQUBUJULQTUMWFUNVMWG
        TUCPABDEFWFGHIJKLMNOWIUOQTCWFUPUQURVMCUSRZVSVTUTCVAWJVOVQWJVNHRZVOUSRZF
        VDRZWJAHRZWKFMVBZNCAEFHIKVCVEWMWKBHRZWLWOOVNBDFHILVFVEVGWJVPUSRZVQUSRWM
        WNWPWQWONOABDFHILVFVHCVPVIVJVKVGVL $.
    $}

    ${
      ipasslem10.a $e |- A e. X $.
      ipasslem10.b $e |- B e. X $.
      ipasslem10.6 $e |- N = ( normCV ` U ) $.
      $( Lemma for ~ ipassi .  Show the inner product associative law for the
         imaginary number ` _i ` .  (Contributed by NM, 24-Aug-2007.)
         (New usage is discouraged.) $)
      ipasslem10 $p |- ( ( _i S A ) P B ) = ( _i x. ( A P B ) ) $=
        ( ci co cmul wcel ccj cfv cneg c4 wceq c2 cexp c1 cmin caddc cnv ax-icn
        phnvi cc nvscl mp3an 4ipval2 4re recni negcli dipcl mul12i nvgcl neg1cn
        nvcli sqcli subcli mulcli addcomi adddii w3a nvsass mp2an oveq1i eqtr3i
        3pm3.2i ixi oveq2i fveq2i mulneg1i negeqi ax-1cn negnegi 3eqtri 3eqtr3i
        nvsid oveq12i mulm1i negsubdi2i eqtr2i mulassi eqtr4i mulcomli gt0ne0ii
        mulid2i eqtri 4pos mulcani mpbi dipcj cjmuli cr 1re renegcli cjrebi cji
        mul2negi ) BQADRZCRZUAUBZQUCZBACRZSRZUAUBZXHBCRZQABCRZSRZXIXMUAUDXISRZU
        DXMSRZUEXIXMUEXRBXHFRZGUBZUFUGRZBUHUCZXHDRZFRZGUBZUFUGRZUIRZQBQXHDRZFRZ
        GUBZUFUGRZBXKXHDRZFRZGUBZUFUGRZUIRZSRZUJRZXSEUKTZBHTZXHHTZXRYSUEEMUMZOY
        TQUNTZAHTZUUBUUCULNQADEHIKUOUPZBXHCDEFGHIJKPLUQUPXSXKUDXLSRZSRZYSUDXKXL
        UDURUSZQULUTZYTUUAUUEXLUNTUUCONBACEHILVAUPZVBYSXKBAFRZGUBZUFUGRZBYCADRZ
        FRZGUBZUFUGRZUIRZQYBBXKADRZFRZGUBZUFUGRZUIRZSRZUJRZSRZUUHYSYRYHUJRZUVGY
        HYRYBYGYAYAXTEGHIPUUCYTUUAUUBXTHTUUCOUUFBXHEFHIJVCUPVEUSVFZYFYFYEEGHIPU
        UCYTUUAYDHTZYEHTUUCOYTYCUNTZUUBUVJUUCVDUUFYCXHDEHIKUOUPBYDEFHIJVCUPVEUS
        VFVGQYQULYLYPYKYKYJEGHIPUUCYTUUAYIHTZYJHTUUCOYTUUDUUBUVLUUCULUUFQXHDEHI
        KUOUPBYIEFHIJVCUPVEUSVFYOYOYNEGHIPUUCYTUUAYMHTZYNHTUUCOYTXKUNTZUUBUVMUU
        CUUJUUFXKXHDEHIKUOUPBYMEFHIJVCUPVEUSVFVGVHVIUVGXKUUSSRZXKUVESRZUJRUVHXK
        UUSUVEUUJUUNUURUUMUUMUULEGHIPUUCYTUUAUUEUULHTUUCONBAEFHIJVCUPVEUSVFZUUQ
        UUQUUPEGHIPUUCYTUUAUUOHTZUUPHTUUCOYTUVKUUEUVRUUCVDNYCADEHIKUOUPBUUOEFHI
        JVCUPVEUSVFZVGZQUVDULYBUVCUVIUVBUVBUVAEGHIPUUCYTUUAUUTHTZUVAHTUUCOYTUVN
        UUEUWAUUCUUJNXKADEHIKUOUPBUUTEFHIJVCUPVEUSVFVGZVHVJYRUVOYHUVPUJYRQUURUU
        NUIRZSRZQYCSRZUUSSRZUVOYQUWCQSYLUURYPUUNUIYKUUQUFUGYJUUPGYIUUOBFQQSRZAD
        RZYIUUOYTUUDUUDUUEVKUWHYIUEUUCUUDUUDUUEULULNVPQQADEHIKVLVMUWGYCADVQVNVO
        VRVSVNYOUUMUFUGYNUULGYMABFXKQSRZADRZUHADRZYMAUWIUHADUWIUWGUCYCUCUHQQULU
        LVTUWGYCVQWAUHWBWCWDZVNYTUVNUUDUUEVKUWJYMUEUUCUVNUUDUUEUUJULNVPXKQADEHI
        KVLVMYTUUEUWKAUEUUCNADEHIKWFVMWEVRVSVNWGVRUWDQYCUUSSRZSRUWFUWCUWMQSUWMU
        USUCUWCUUSUVTWHUUNUURUVQUVSWIWJVRQYCUUSULVDUVTWKWLUWEXKUUSSYCQXKVDULQUL
        WHZWMVNWDYHUWIUVDSRZUVPYHUHUVDSRZUWOYHUVDUWPYGUVCYBUIYFUVBUFUGYEUVAGYDU
        UTBFYCQSRZADRZYDUUTYTUVKUUDUUEVKUWRYDUEUUCUVKUUDUUEVDULNVPYCQADEHIKVLVM
        UWQXKADUWNVNVOVRVSVNVRUVDUWBWOWLUWIUHUVDSUWLVNWLXKQUVDUUJULUWBWKWPWGWLW
        LUUGUVFXKSYTUUAUUEUUGUVFUEUUCONBACDEFGHIJKPLUQUPVRWLWLWLXIXMUDYTUUAUUBX
        IUNTUUCOUUFBXHCEHILVAUPXKXLUUJUUKVHUUIUDURWQWNWRWSVSYTUUAUUBXJXOUEUUCOU
        UFBXHCEHILWTUPXNXKUAUBZXLUAUBZSRXQXKXLUUJUUKXAUWSQUWTXPSUWQUAUBYCUAUBZQ
        UAUBZSRZUWSQYCQVDULXAUWQXKUAUWNVSUXCYCXKSRUHQSRQUXAYCUXBXKSYCXBTUXAYCUE
        UHXCXDYCVDXEWSXFWGUHQWBULXGQULWOWDWEYTUUAUUEUWTXPUEUUCONBACEHILWTUPWGWP
        WE $.
    $}

    ${
      $d x B $.  $d x y C $.  $d x y P $.
      ipasslem11.a $e |- A e. X $.
      ipasslem11.b $e |- B e. X $.
      $( TODO - proof got longer with axcnreOLD -> cnre because
         of mulcl - is it possible to rewrite it to shorten it? $)
      $( Lemma for ~ ipassi .  Show the inner product associative law for all
         complex numbers.  (Contributed by NM, 25-Aug-2007.)
         (New usage is discouraged.) $)
      ipasslem11 $p |- ( C e. CC ->
                  ( ( C S A ) P B ) = ( C x. ( A P B ) ) ) $=
        ( wcel ci cmul co wceq vx vy cc cv caddc cr wrex cnre wa ax-icn sylancr
        recn mulcom adantl oveq2d eqeq2d cnv phnvi nvscl mp3an13 sylancl ipdiri
        syl mulcl mp3an3 syl2an ipasslem9 mp3an w3a nvsass mp3an23 oveq1d dipcl
        mpan mulass cnmcv cfv ipasslem10 oveq2i syl6eqr 3eqtr4d oveqan12d eqtrd
        eqid nvdir adddir oveq1 eqeq12d syl5ibrcom sylbid rexlimivv ) CUCPCUAUD
        ZQUBUDZRSZUESZTZUBUFUGUAUFUGCAESZBDSZCABDSZRSZTZUAUBCUHWPXAUAUBUFUFWLUF
        PZWMUFPZUIZWPCWLWMQRSZUESZTZXAXDWOXFCXDWNXEWLUEXCWNXETZXBXCQUCPZWMUCPZX
        HUJWMULZQWMUMUKUNUOUPXDXAXGXFAESZBDSZXFWSRSZTXDWLAESZXEAESZGSZBDSZWLWSR
        SZXEWSRSZUESZXMXNXDXRXOBDSZXPBDSZUESZYAXBXOHPZXPHPZXRYDTZXCXBWLUCPZYEWL
        ULZFUQPZYHAHPZYEFMURZNWLAEFHIKUSUTVCXCXEUCPZYFXCXJXIYMXKUJWMQVDVAZYJYMY
        KYFYLNXEAEFHIKUSUTVCYEYFBHPZYGOXOXPBDEFGHIJKLMVBVEVFXBXCYBXSYCXTUEABWLD
        EFGHIJKLMNOVGXCWMQAESZESZBDSWMYPBDSZRSZYCXTYPBWMDEFGHIJKLMYJXIYKYPHPYLU
        JNQAEFHIKUSVHOVGXCXPYQBDXCXJXPYQTZXKXJXIYKYTUJNYJXJXIYKVIYTYLWMQAEFHIKV
        JVNVKVCVLXCXTWMQWSRSZRSZYSXCXJXTUUBTZXKXJXIWSUCPZUUCUJYJYKYOUUDYLNOABDF
        HILVMVHZWMQWSVOVKVCYRUUAWMRABDEFGFVPVQZHIJKLMNOUUFWDVRVSVTWAWBWCXDXLXQB
        DXBYHYMXLXQTZXCYIYNYHYMYKUUGNYJYHYMYKVIUUGYLWLXEAEFGHIJKWEVNVEVFVLXBYHY
        MXNYATZXCYIYNYHYMUUDUUHUUEWLXEWSWFVEVFWAXGWRXMWTXNXGWQXLBDCXFAEWGVLCXFW
        SRWGWHWIWJWKVC $.
    $}

    $( Associative law for inner product.  Equation I2 of [Ponnusamy] p. 363.
       (Contributed by NM, 25-Aug-2007.)  (New usage is discouraged.) $)
    ipassi $p |- ( ( A e. CC /\ B e. X /\ C e. X ) ->
                  ( ( A S B ) P C ) = ( A x. ( B P C ) ) ) $=
      ( wcel co cmul wceq wi cif oveq2 cc cn0v cfv oveq1d oveq2d eqeq12d imbi2d
      wa oveq1 eqid elimph ipasslem11 dedth2h com12 3impib ) AUANZBHNZCHNZABEOZ
      CDOZABCDOZPOZQZUQURUHUPVCUQURUPVCRUPAUQBFUBUCZSZEOZCDOZAVECDOZPOZQZRUPVFU
      RCVDSZDOZAVEVKDOZPOZQZRBCVDVDBVEQZVCVJUPVPUTVGVBVIVPUSVFCDBVEAETUDVPVAVHA
      PBVECDUIUEUFUGCVKQZVJVOUPVQVGVLVIVNCVKVFDTVQVHVMAPCVKVEDTUEUFUGVEVKADEFGH
      IJKLMBFHVDIVDUJZMUKCFHVDIVRMUKULUMUNUO $.
  $}

  ${
    dipdir.1 $e |- X = ( BaseSet ` U ) $.
    dipdir.2 $e |- G = ( +v ` U ) $.
    dipdir.7 $e |- P = ( .iOLD ` U ) $.
    $( Distributive law for inner product.  Equation I3 of [Ponnusamy] p. 362.
       (Contributed by NM, 25-Aug-2007.)  (New usage is discouraged.) $)
    dipdir $p |- ( ( U e. CPreHilOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) ) $=
      ( wcel co caddc wceq cba cfv cpv cdip oveqd eqid ccphlo w3a cmul cop cabs
      wi cif fveq2 syl5eq eleq2d 3anbi123d oveq1d eqtrd oveq12d eqeq12d imbi12d
      cns elimphu ipdiri dedth imp ) EUAKZAGKZBGKZCGKZUBZABFLZCDLZACDLZBCDLZMLZ
      NZVBVFVLUFAVBEMUCUDUEUDZUGZOPZKZBVOKZCVOKZUBZABVNQPZLZCVNRPZLZACWBLZBCWBL
      ZMLZNZUFEVMEVNNZVFVSVLWGWHVCVPVDVQVEVRWHGVOAWHGEOPVOHEVNOUHUIZUJWHGVOBWIU
      JWHGVOCWIUJUKWHVHWCVKWFWHVHWACDLWCWHVGWACDWHFVTABWHFEQPVTIEVNQUHUISULWHDW
      BWACWHDERPWBJEVNRUHUIZSUMWHVIWDVJWEMWHDWBACWJSWHDWBBCWJSUNUOUPABCWBVNUQPZ
      VNVTVOVOTVTTWKTWBTEURUSUTVA $.

    $( Distributive law for inner product.  (Contributed by NM, 20-Nov-2007.)
       (New usage is discouraged.) $)
    dipdi $p |- ( ( U e. CPreHilOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( A P ( B G C ) ) = ( ( A P B ) + ( A P C ) ) ) $=
      ( wcel w3a co caddc wceq id wa ccj cfv dipcj ccphlo 3com13 cnv phnv simpl
      3com12 dipdir sylan2 fveq2d nvgcl 3com23 3adant3r3 syl3anc sylan cc dipcl
      simpr3 3adant3r1 3adant3r2 cjaddd oveq12d eqtrd 3eqtr3d ) AGKZBGKZCGKZLEU
      AKZVFVEVDLZABCFMZDMZABDMZACDMZNMZOVFVEVDVHVHPUBVGVHQZVIADMZRSZBADMZCADMZN
      MZRSZVJVMVNVOVSRVHVGVEVFVDLZVOVSOVEVFVDWAWAPUFBCADEFGHIJUGUHUIVGEUCKZVHVP
      VJOZEUDZWBVHQZWBVIGKZVDWCWBVHUEWBVFVEWFVDWBVEVFWFBCEFGHIUJUKULWBVFVEVDUQV
      IADEGHJTUMUNVGWBVHVTVMOWDWEVTVQRSZVRRSZNMVMWEVQVRWBVEVDVQUOKVFBADEGHJUPUR
      WBVFVDVRUOKVECADEGHJUPUSUTWEWGVKWHVLNWBVEVDWGVKOVFBADEGHJTURWBVFVDWHVLOVE
      CADEGHJTUSVAVBUNVCUH $.
  $}

  ${
    ip2dii.1 $e |- X = ( BaseSet ` U ) $.
    ip2dii.2 $e |- G = ( +v ` U ) $.
    ip2dii.7 $e |- P = ( .iOLD ` U ) $.
    ip2dii.u $e |- U e. CPreHilOLD $.
    ip2dii.a $e |- A e. X $.
    ip2dii.b $e |- B e. X $.
    ip2dii.c $e |- C e. X $.
    ip2dii.d $e |- D e. X $.
    $( Inner product of two sums.  (Contributed by NM, 17-Apr-2008.)
       (New usage is discouraged.) $)
    ip2dii $p |- ( ( A G B ) P ( C G D ) )
                = ( ( ( A P C ) + ( B P D ) ) + ( ( A P D ) + ( B P C ) ) ) $=
      ( co caddc wcel mp3an ccphlo wceq 3pm3.2i dipdi mp2an oveq12i phnvi nvgcl
      w3a cnv dipdir cc dipcl add42i 3eqtr4i ) ACDGQZEQZBUPEQZRQZACEQZADEQZRQZB
      CEQZBDEQZRQZRQABGQUPEQZUTVDRQVAVCRQRQUQVBURVERFUASZAHSZCHSZDHSZUIUQVBUBLV
      HVIVJMOPUCACDEFGHIJKUDUEVGBHSZVIVJUIURVEUBLVKVIVJNOPUCBCDEFGHIJKUDUEUFVGV
      HVKUPHSZUIVFUSUBLVHVKVLMNFUJSZVIVJVLFLUGZOPCDFGHIJUHTUCABUPEFGHIJKUKUEUTV
      DVAVCVMVHVIUTULSVNMOACEFHIKUMTVMVKVJVDULSVNNPBDEFHIKUMTVMVHVJVAULSVNMPADE
      FHIKUMTVMVKVIVCULSVNNOBCEFHIKUMTUNUO $.
  $}

  ${
    ipass.1 $e |- X = ( BaseSet ` U ) $.
    ipass.4 $e |- S = ( .sOLD ` U ) $.
    ipass.7 $e |- P = ( .iOLD ` U ) $.
    $( Associative law for inner product.  Equation I2 of [Ponnusamy] p. 363.
       (Contributed by NM, 25-Aug-2007.)  (New usage is discouraged.) $)
    dipass $p |- ( ( U e. CPreHilOLD /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
                 ( ( A S B ) P C ) = ( A x. ( B P C ) ) ) $=
      ( wcel co cmul wceq cba cfv cns cdip fveq2 eqid ccphlo cc w3a wi cop cabs
      caddc cif syl5eq eleq2d oveqd oveq1d eqtrd oveq2d eqeq12d imbi12d elimphu
      3anbi23d cpv ipassi dedth imp ) FUAKZAUBKZBGKZCGKZUCZABELZCDLZABCDLZMLZNZ
      VCVGVLUDVDBVCFUGMUEUFUEZUHZOPZKZCVOKZUCZABVNQPZLZCVNRPZLZABCWALZMLZNZUDFV
      MFVNNZVGVRVLWEWFVEVPVFVQVDWFGVOBWFGFOPVOHFVNOSUIZUJWFGVOCWGUJURWFVIWBVKWD
      WFVIVTCDLWBWFVHVTCDWFEVSABWFEFQPVSIFVNQSUIUKULWFDWAVTCWFDFRPWAJFVNRSUIZUK
      UMWFVJWCAMWFDWABCWHUKUNUOUPABCWAVSVNVNUSPZVOVOTWITVSTWATFUQUTVAVB $.

    $( "Associative" law for second argument of inner product (compare
       ~ dipass ).  (Contributed by NM, 22-Nov-2007.)
       (New usage is discouraged.) $)
    dipassr $p |- ( ( U e. CPreHilOLD /\ ( A e. X /\ B e. CC /\ C e. X ) ) ->
                 ( A P ( B S C ) ) = ( ( * ` B ) x. ( A P C ) ) ) $=
      ( wcel cc w3a wa co ccj cfv cmul wceq dipcj ccphlo 3anrot dipass cnv phnv
      sylan2b fveq2d simpl nvscl 3adant3r1 simpr1 syl3anc sylan dipcl 3adant3r2
      simpr2 3com23 cjmuld oveq2d eqtrd 3eqtr3d ) FUAKZAGKZBLKZCGKZMZNZBCEOZADO
      ZPQZBCADOZROZPQZAVHDOZBPQZACDOZROZVGVIVLPVFVBVDVEVCMVIVLSVCVDVEUBBCADEFGH
      IJUCUFUGVBFUDKZVFVJVNSZFUEZVRVFNZVRVHGKZVCVSVRVFUHVRVDVEWBVCBCEFGHIUIUJVR
      VCVDVEUKVHADFGHJTULUMVBVRVFVMVQSVTWAVMVOVKPQZROVQWABVKVRVCVDVEUPVRVCVEVKL
      KZVDVRVEVCWDCADFGHJUNUQUOURWAWCVPVORVRVCVEWCVPSZVDVRVEVCWECADFGHJTUQUOUSU
      TUMVA $.

    $( "Associative" law for inner product.  Conjugate version of ~ dipassr .
       (Contributed by NM, 23-Nov-2007.)  (New usage is discouraged.) $)
    dipassr2 $p |- ( ( U e. CPreHilOLD /\ ( A e. X /\ B e. CC /\ C e. X ) ) ->
                 ( A P ( ( * ` B ) S C ) ) = ( B x. ( A P C ) ) ) $=
      ( ccphlo wcel cc w3a wa ccj cfv co cmul wceq cjcl dipassr syl3anr2 adantl
      cjcj 3ad2ant2 oveq1d eqtrd ) FKLZAGLZBMLZCGLZNZOZABPQZCERDRZUOPQZACDRZSRZ
      BURSRUKUJUIUOMLULUPUSTBUAAUOCDEFGHIJUBUCUNUQBURSUMUQBTZUIUKUJUTULBUEUFUDU
      GUH $.
  $}

  ${
    ipsubdir.1 $e |- X = ( BaseSet ` U ) $.
    ipsubdir.3 $e |- M = ( -v ` U ) $.
    ipsubdir.7 $e |- P = ( .iOLD ` U ) $.
    $( Distributive law for inner product subtraction.  (Contributed by NM,
       20-Nov-2007.)  (New usage is discouraged.) $)
    dipsubdir $p |- ( ( U e. CPreHilOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( ( A M B ) P C ) = ( ( A P C ) - ( B P C ) ) ) $=
      ( wcel w3a wa cneg cfv co caddc wceq cc sylan ccphlo cns cpv cmin idd cnv
      c1 phnv neg1cn nvscl mp3an2 ex 3anim123d imp dipdir syldan nvmval syl3an1
      eqid 3adant3r3 oveq1d cmul dipass mp3anr1 dipcl 3expb mulm1d eqtrd oveq2d
      3adantr1 3adant3r2 3adant3r1 negsubd eqtr2d 3eqtr4d ) EUAKZAGKZBGKZCGKZLZ
      MZAUGNZBEUBOZPZEUCOZPZCDPZACDPZWDCDPZQPZABFPZCDPWHBCDPZUDPZVPVTVQWDGKZVSL
      ZWGWJRVPVTWOVPVQVQVRWNVSVSVPVQUEVPVRWNVPEUFKZVRWNEUHZWPWBSKZVRWNUIWBBWCEG
      HWCUSZUJUKTULVPVSUEUMUNAWDCDEWEGHWEUSZJUOUPWAWKWFCDVPVQVRWKWFRZVSVPWPVQVR
      XAWQABWCEWEFGHWTWSIUQURUTVAWAWJWHWLNZQPZWMWAWIXBWHQVPVRVSWIXBRVQVPVRVSMZM
      ZWIWBWLVBPZXBVPWRVRVSWIXFRUIWBBCDWCEGHWSJVCVDXEWLVPWPXDWLSKZWQWPVRVSXGBCD
      EGHJVEZVFTVGVHVJVIVPWPVTXCWMRWQWPVTMWHWLWPVQVSWHSKVRACDEGHJVEVKWPVRVSXGVQ
      XHVLVMTVNVO $.

    $( Distributive law for inner product subtraction.  (Contributed by NM,
       20-Nov-2007.)  (New usage is discouraged.) $)
    dipsubdi $p |- ( ( U e. CPreHilOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                 ( A P ( B M C ) ) = ( ( A P B ) - ( A P C ) ) ) $=
      ( wcel w3a co cmin wceq id wa ccj cfv dipcj ccphlo 3com13 3com12 cnv phnv
      dipsubdir sylan2 fveq2d simpl nvmcl 3com23 3adant3r3 simpr3 syl3anc sylan
      cc dipcl 3adant3r1 3adant3r2 cjsub syl2anc oveq12d eqtrd 3eqtr3d ) AGKZBG
      KZCGKZLEUAKZVGVFVELZABCFMZDMZABDMZACDMZNMZOVGVFVEVIVIPUBVHVIQZVJADMZRSZBA
      DMZCADMZNMZRSZVKVNVOVPVTRVIVHVFVGVELZVPVTOVFVGVEWBWBPUCBCADEFGHIJUFUGUHVH
      EUDKZVIVQVKOZEUEZWCVIQZWCVJGKZVEWDWCVIUIWCVGVFWGVEWCVFVGWGBCEFGHIUJUKULWC
      VGVFVEUMVJADEGHJTUNUOVHWCVIWAVNOWEWFWAVRRSZVSRSZNMZVNWFVRUPKZVSUPKZWAWJOW
      CVFVEWKVGBADEGHJUQURWCVGVEWLVFCADEGHJUQUSVRVSUTVAWFWHVLWIVMNWCVFVEWHVLOVG
      BADEGHJTURWCVGVEWIVMOVFCADEGHJTUSVBVCUOVDUG $.
  $}

  ${
    pyth.1 $e |- X = ( BaseSet ` U ) $.
    pyth.2 $e |- G = ( +v ` U ) $.
    pyth.6 $e |- N = ( normCV ` U ) $.
    pyth.7 $e |- P = ( .iOLD ` U ) $.
    pythi.u $e |- U e. CPreHilOLD $.
    pythi.a $e |- A e. X $.
    pythi.b $e |- B e. X $.
    $( The Pythagorean theorem for an arbitrary complex inner product
       (pre-Hilbert) space ` U ` .  The square of the norm of the sum of two
       orthogonal vectors (i.e. whose inner product is 0) is the sum of the
       squares of their norms.  Problem 2 in [Kreyszig] p. 135.  (Contributed
       by NM, 17-Apr-2008.)  (New usage is discouraged.) $)
    pythi $p |- ( ( A P B ) = 0 -> ( ( N ` ( A G B ) ) ^ 2 )
        = ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) $=
      ( co cc0 wceq caddc wcel mp3an cfv c2 cexp ip2dii id cnv phnvi diporthcom
      wb biimpi oveq12d 00id syl6eq oveq2d cc dipcl addcli addid1i syl5eq nvgcl
      ipidsq mp2an oveq12i 3eqtr3g ) ABCOZPQZABEOZVGCOZAACOZBBCOZROZVGFUAUBUCOZ
      AFUAUBUCOZBFUAUBUCOZROVFVHVKVEBACOZROZROZVKABABCDEGHIKLMNMNUDVFVQVKPROVKV
      FVPPVKRVFVPPPROPVFVEPVOPRVFUEVFVOPQZDUFSZAGSZBGSZVFVRUIDLUGZMNABCDGHKUHTU
      JUKULUMUNVKVIVJVSVTVTVIUOSWBMMAACDGHKUPTVSWAWAVJUOSWBNNBBCDGHKUPTUQURUMUS
      VSVGGSZVHVLQWBVSVTWAWCWBMNABDEGHIUTTVGCDFGHJKVAVBVIVMVJVNRVSVTVIVMQWBMACD
      FGHJKVAVBVSWAVJVNQWBNBCDFGHJKVAVBVCVD $.
  $}

  ${
    siii.1 $e |- X = ( BaseSet ` U ) $.
    siii.6 $e |- N = ( normCV ` U ) $.
    siii.7 $e |- P = ( .iOLD ` U ) $.
    siii.9 $e |- U e. CPreHilOLD $.
    siii.a $e |- A e. X $.
    siii.b $e |- B e. X $.
    ${
      sii1.3 $e |- M = ( -v ` U ) $.
      sii1.4 $e |- S = ( .sOLD ` U ) $.
      sii1.c $e |- C e. CC $.
      sii1.r $e |- ( C x. ( A P B ) ) e. RR $.
      sii1.z $e |- 0 <_ ( C x. ( A P B ) ) $.
      $( Lemma for ~ sii .  (Contributed by NM, 23-Nov-2007.)
         (New usage is discouraged.) $)
      siilem1 $p |- ( ( B P A ) = ( C x. ( ( N ` B ) ^ 2 ) ) ->
                ( sqr ` ( ( A P B ) x. ( C x. ( ( N ` B ) ^ 2 ) ) ) ) <_
                       ( ( N ` A ) x. ( N ` B ) ) ) $=
        ( co cfv c2 cexp cmul wceq csqr cle wbr cc0 cmin ccj phnvi cnv cc cjcli
        nvscl mp3an nvmcl nvcli sqge0i ccphlo w3a 3pm3.2i dipsubdi mp2an ipidsq
        wcel dipass dipassr2 oveq2i eqtri recni sqcli dipcl mulcli sub4 oveq12i
        mp4an oveq1i subdii 3eqtr4i 3eqtr3i breqtri subeq0i oveq2 mul01i syl6eq
        dipsubdir sylbir oveq2d resqcli subcli subid1i syl5breq sylib cr pm3.2i
        subge0i wa lemul1a mpan syl sqmuli syl6breqr wb mulge0i remulcli sqrlei
        mulcomi mulassi fveq2i nvge0 sqrsqi ax-mp 3brtr3g ) BADUAZCBHUBZUCUDUAZ
        UEUAZUFZCABDUAZUEUAZXSUEUAZUGUBZAHUBZXRUEUAZUCUDUAZUGUBZYBXTUEUAZUGUBYG
        UHYAYDYHUHUIZYEYIUHUIZYAYDYFUCUDUAZXSUEUAZYHUHYAYCYMUHUIZYDYNUHUIZYAUJY
        MYCUKUAZUHUIYOYAUJYQCULUBZXQXTUKUAZUEUAZUKUAZYQUHUJAYRBEUAZGUAZHUBZUCUD
        UAZUUAUHUUDUUCFHIJKFMUMZFUNVHZAIVHZUUBIVHZUUCIVHZUUFNUUGYRUOVHZBIVHZUUI
        UUFCRUPZOYRBEFIJQUQURZAUUBFGIJPUSURZUTVAUUCUUCDUAZUUCADUAZUUCUUBDUAZUKU
        AZUUEUUAFVBVHZUUJUUHUUIVCUUPUUSUFMUUJUUHUUIUUONUUNVDUUCAUUBDFGIJPLVEVFU
        UGUUJUUPUUEUFUUFUUOUUCDFHIJKLVGVFYMYRXQUEUAZUKUAZYCUUBUUBDUAZUKUAZUKUAZ
        YQUVAYRXTUEUAZUKUAZUKUAZUUSUUAUVEUVBYCUVFUKUAZUKUAZUVHUVDUVIUVBUKUVCUVF
        YCUKUVCYRBUUBDUAZUEUAZUVFUUTUUKUULUUIVCUVCUVLUFMUUKUULUUIUUMOUUNVDYRBUU
        BDEFIJQLVIVFUVKXTYRUEUVKCBBDUAZUEUAZXTUUTUULCUOVHZUULVCUVKUVNUFMUULUVOU
        ULOROVDBCBDEFIJQLVJVFUVMXSCUEUUGUULUVMXSUFUUFOBDFHIJKLVGVFVKVLVKVLVKVKY
        MUOVHUVAUOVHYCUOVHUVFUOVHUVJUVHUFYFYFAFHIJKUUFNUTZVMZVNYRXQUUMUUGUULUUH
        XQUOVHUUFONBADFIJLVOURZVPYCSVMZYRXTUUMCXSRXRXRBFHIJKUUFOUTZVMZVNVPZVPYM
        UVAYCUVFVQVSVLUUQUVBUURUVDUKUUQAADUAZUUBADUAZUKUAZUVBUUTUUHUUIUUHVCUUQU
        WEUFMUUHUUIUUHNUUNNVDAUUBADFGIJPLWIVFUWCYMUWDUVAUKUUGUUHUWCYMUFUUFNADFH
        IJKLVGVFUUTUUKUULUUHVCUWDUVAUFMUUKUULUUHUUMONVDYRBADEFIJQLVIVFVRVLUURAU
        UBDUAZUVCUKUAZUVDUUTUUHUUIUUIVCUURUWGUFMUUHUUIUUINUUNUUNVDAUUBUUBDFGIJP
        LWIVFUWFYCUVCUKUUTUUHUVOUULVCUWFYCUFMUUHUVOUULNROVDACBDEFIJQLVJVFVTVLVR
        YTUVGYQUKYRXQXTUUMUVRUWBWAVKWBWCWDYAUUAYQUJUKUAYQYAYTUJYQUKYAYSUJUFZYTU
        JUFXQXTUVRUWBWEUWHYTYRUJUEUAUJYSUJYRUEWFYRUUMWGWHWJWKYQYMYCYMYFUVPWLZVM
        UVSWMWNWHWOYMYCUWISWSWPYCWQVHZYMWQVHZXSWQVHZUJXSUHUIZWTZVCYOYPUWJUWKUWN
        SUWIUWLUWMXRUVTWLZXRUVTVAZWRVDYCYMXSXAXBXCYFXRUVQUWAXDXEUJYDUHUIZUJYHUH
        UIYKYLXFUJYCUHUIUWMUWQTUWPYCXSSUWOXGVFYGYFXRUVPUVTXHZVAYDYHYCXSSUWOXHYG
        UWRWLXIVFWPYDYJUGYDYBCUEUAZXSUEUAYJYCUWSXSUECYBRUUGUUHUULYBUOVHUUFNOABD
        FIJLVOURZXJVTYBCXSUWTRXSUWOVMXKVLXLUJYGUHUIZYIYGUFUJYFUHUIZUJXRUHUIZUXA
        UUGUUHUXBUUFNAFHIJKXMVFUUGUULUXCUUFOBFHIJKXMVFYFXRUVPUVTXGVFYGUWRXNXOXP
        $.
    $}

    ${
      siii2.3 $e |- M = ( -v ` U ) $.
      siii2.4 $e |- S = ( .sOLD ` U ) $.
      $( Lemma for ~ sii .  (Contributed by NM, 24-Nov-2007.)
         (New usage is discouraged.) $)
      siilem2 $p |- ( ( C e. CC /\ ( C x. ( A P B ) ) e. RR /\
                           0 <_ ( C x. ( A P B ) ) ) ->
                ( ( B P A ) = ( C x. ( ( N ` B ) ^ 2 ) ) ->
                  ( sqr ` ( ( A P B ) x. ( C x. ( ( N ` B ) ^ 2 ) ) ) ) <_
                         ( ( N ` A ) x. ( N ` B ) ) ) ) $=
        ( co cmul cc0 cc wcel cr cle wbr w3a cfv c2 cexp wceq csqr wi cif oveq1
        eqeq2d oveq2d fveq2d breq1d imbi12d eleq1 eleq1d breq2d 3anbi123d phnvi
        0cn cnv dipcl mp3an mul02i eqeltri 0le0 breqtrri 3pm3.2i elimhyp simp1i
        0re simp2i simp3i siilem1 dedth ) CUAUBZCABDRZSRZUCUBZTWCUDUEZUFZBADRZC
        BHUGZUHUIRZSRZUJZWBWJSRZUKUGZAHUGWHSRZUDUEZULWGWFCTUMZWISRZUJZWBWQSRZUK
        UGZWNUDUEZULCTCWPUJZWKWRWOXAXBWJWQWGCWPWISUNZUOXBWMWTWNUDXBWLWSUKXBWJWQ
        WBSXCUPUQURUSABWPDEFGHIJKLMNOPQWPUAUBZWPWBSRZUCUBZTXEUDUEZWFXDXFXGUFTUA
        UBZTWBSRZUCUBZTXIUDUEZUFCTXBWAXDWDXFWEXGCWPUAUTXBWCXEUCCWPWBSUNZVAXBWCX
        ETUDXLVBVCTWPUJZXHXDXJXFXKXGTWPUAUTXMXIXEUCTWPWBSUNZVAXMXIXETUDXNVBVCXH
        XJXKVEXITUCWBFVFUBAIUBBIUBWBUAUBFMVDNOABDFIJLVGVHVIZVPVJTTXIUDVKXOVLVMV
        NZVOXDXFXGXPVQXDXFXGXPVRVSVT $.
    $}

    $( Inference from ~ sii .  (Contributed by NM, 20-Nov-2007.)
       (New usage is discouraged.) $)
    siii $p |- ( abs ` ( A P B ) ) <_ ( ( N ` A ) x. ( N ` B ) ) $=
      ( co cfv cmul cle wbr wceq cc0 wcel cabs cn0v oveq2 cnv phnvi dip0r mp2an
      eqid syl6eq abs00bd nvge0 nvcli mulge0i syl6eqbr wne cexp cdiv csqr recni
      c2 ccj sqeq0i wb nvz bitri necon3bii dipcl mp3an resqcli divcan1zi sylbir
      cc dipcj syl6eqr oveq2d fveq2d absval ax-mp syl6reqr eqcomd cr wi divclzi
      ipipcj mulcomli oveq1i wa div23 mp3an12 syl5reqr abscli redivclzi eqeltrd
      clt sqgt0i sqge0i divge0 mpanl12 sylancr breqtrrd cns siilem2 syl3anc mpd
      mpan cnsb eqbrtrd pm2.61ine ) ABCMZUANZAENZBENZOMZPQBDUBNZBXNRZXJSXMPXOXI
      XOXIAXNCMZSBXNACUCDUDTZAFTZXPSRDJUEZKACDFXNGXNUHZIUFUGUIUJSXKPQZSXLPQZSXM
      PQXQXRYAXSKADEFGHUKUGXQBFTZYBXSLBDEFGHUKUGXKXLADEFGHXSKULBDEFGHXSLULZUMUG
      UNBXNUOZXJXIBACMZXLUTUPMZUQMZYGOMZOMZURNZXMPYEYKXIXIVANZOMZURNZXJYEYJYMUR
      YEYIYLXIOYEYIYFYLYEYGSUOZYIYFRYGSBXNYGSRXLSRZXOXLXLYDUSVBXQYCYPXOVCXSLBDE
      FXNGXTHVDUGZVEVFZYFYGXQYCXRYFVLTZXSLKBACDFGIVGVHZYGXLYDVIZUSZVJVKZXQXRYCY
      LYFRXSKLABCDFGIVMVHVNVOVPXIVLTZXJYNRXQXRYCUUDXSKLABCDFGIVGVHZXIVQVRVSYEYF
      YIRZYKXMPQZYEYIYFUUCVTYEYHVLTZYHXIOMZWATSUUIPQUUFUUGWBYEYOUUHYRYFYGYTUUBW
      CVKYEUUIXJUTUPMZYGUQMZWAYEUUKYFXIOMZYGUQMZUUIUULUUJYGUQXIYFUUJUUEYTXQXRYC
      XIYFOMUUJRXSKLABCDFGIWDVHWEWFYEYOUUMUUIRZYRYGVLTZYOUUNUUBYSUUDUUOYOWGUUNY
      TUUEYFXIYGWHWIXEVKWJZYEYOUUKWATYRUUJYGXJXIUUEWKZVIZUUAWLVKWMYESUUKUUIPYEY
      GWATZSYGWNQZSUUKPQZUUAYEXLSUOUUTXLSBXNYQVFXLYDWOVKUUJWATSUUJPQUUSUUTWGUVA
      UURXJUUQWPUUJYGWQWRWSUUPWTABYHCDXANZDDXFNZEFGHIJKLUVCUHUVBUHXBXCXDXGXH $.
  $}

  ${
    sii.1 $e |- X = ( BaseSet ` U ) $.
    sii.6 $e |- N = ( normCV ` U ) $.
    sii.7 $e |- P = ( .iOLD ` U ) $.
    sii.9 $e |- U e. CPreHilOLD $.
    $( Schwarz inequality.  Part of Lemma 3-2.1(a) of [Kreyszig] p. 137.  This
       is also called the Cauchy-Schwarz inequality by some authors and
       Bunjakovaskij-Cauchy-Schwarz inequality by others.  See also theorems
       ~ bcseqi , ~ bcsiALT , ~ bcsiHIL , ~ csbren .  (Contributed by NM,
       12-Jan-2008.)  (New usage is discouraged.) $)
    sii $p |- ( ( A e. X /\ B e. X ) ->
               ( abs ` ( A P B ) ) <_ ( ( N ` A ) x. ( N ` B ) ) ) $=
      ( wcel co cabs cfv cmul cle wbr cif wceq fveq2d cn0v oveq1 oveq1d breq12d
      fveq2 oveq2 oveq2d eqid elimph siii dedth2h ) AFKZBFKZABCLZMNZAENZBENZOLZ
      PQULADUANZRZBCLZMNZUTENZUQOLZPQUTUMBUSRZCLZMNZVCVEENZOLZPQABUSUSAUTSZUOVB
      URVDPVJUNVAMAUTBCUBTVJUPVCUQOAUTEUEUCUDBVESZVBVGVDVIPVKVAVFMBVEUTCUFTVKUQ
      VHVCOBVEEUEUGUDUTVECDEFGHIJADFUSGUSUHZJUIBDFUSGVLJUIUJUK $.
  $}

  ${
    $d x y H $.  $d x y U $.  $d x y W $.
    sspph.h $e |- H = ( SubSp ` U ) $.
    $( A subspace of an inner product space is an inner product space.
       (Contributed by NM, 1-Feb-2008.)  (New usage is discouraged.) $)
    sspph $p |- ( ( U e. CPreHilOLD /\ W e. H ) -> W e. CPreHilOLD ) $=
      ( vx vy wcel wa cfv co c2 cexp caddc cmul wceq sylan sspnval 3expa oveq1d
      eqid ccphlo cnv cv cpv cnmcv cnsb cba wral phnv sspnv sspba sseld anim12d
      wi phpar2 3expb adantlr syldan nvgcl sspgval fveq2d eqtrd sspmval oveq12d
      imp nvmcl sylanl1 adantrr adantrl oveq2d 3eqtr4d ralrimivva isph sylanbrc
      ) AUAGZCBGZHZCUBGZEUCZFUCZCUDIZJZCUEIZIZKLJZVSVTCUFIZJZWCIZKLJZMJZKVSWCIZ
      KLJZVTWCIZKLJZMJZNJZOZFCUGIZUHEWRUHCUAGVOAUBGZVPVRAUIZABCDUJZPVQWQEFWRWRV
      QVSWRGZVTWRGZHZHZVSVTAUDIZJZAUEIZIZKLJZVSVTAUFIZJZXHIZKLJZMJZKVSXHIZKLJZV
      TXHIZKLJZMJZNJZWJWPVQXDVSAUGIZGZVTYBGZHZXOYAOZVQXDYEVOWSVPXDYEUNWTWSVPHZX
      BYCXCYDYGWRYBVSABCYBWRYBTZWRTZDUKZULYGWRYBVTYJULUMPVEVOYEYFVPVOYCYDYFVSVT
      AXFXKXHYBYHXFTZXKTZXHTZUOUPUQURVOWSVPXDWJXOOWTYGXDHZWEXJWIXNMYNWEWBXHIZKL
      JXJYNWDYOKLYGXDWBWRGZWDYOOZYGVRXDYPXAVRXBXCYPVSVTCWAWRYIWATZUSUPPWSVPYPYQ
      WBABWCXHCWRYIYMWCTZDQRURSYNYOXIKLYNWBXGXHVSVTAWAXFBCWRYIYKYRDUTVASVBYNWHX
      MKLYNWHWGXHIZXMYGXDWGWRGZWHYTOZYGVRXDUUAXAVRXBXCUUAVSVTCWFWRYIWFTZVFUPPWS
      VPUUAUUBWGABWCXHCWRYIYMYSDQRURYNWGXLXHVSVTABWFXKCWRYIYLUUCDVCVAVBSVDVGXEW
      OXTKNVOWSVPXDWOXTOWTYNWLXQWNXSMYNWKXPKLYGXBWKXPOZXCWSVPXBUUDVSABWCXHCWRYI
      YMYSDQRVHSYNWMXRKLYGXCWMXROZXBWSVPXCUUEVTABWCXHCWRYIYMYSDQRVISVDVGVJVKVLE
      FCWAWFWCWRYIYRUUCYSVMVN $.
  $}

  ${
    $d w x y z A $.  $d w y z C $.  $d w y z F $.  $d w x y z U $.
    $d w x y z X $.  $d x P $.  $d z B $.
    ipblnfi.1 $e |- X = ( BaseSet ` U ) $.
    ipblnfi.7 $e |- P = ( .iOLD ` U ) $.
    ipblnfi.9 $e |- U e. CPreHilOLD $.
    ipblnfi.c $e |- C = <. <. + , x. >. , abs >. $.
    ipblnfi.l $e |- B = ( U BLnOp C ) $.
    ipblnfi.f $e |- F = ( x e. X |-> ( x P A ) ) $.
    $( A function ` F ` generated by varying the first argument of an inner
       product (with its second argument a fixed vector ` A ` ) is a bounded
       linear functional, i.e. a bounded linear operator from the vector space
       to ` CC ` .  (Contributed by NM, 12-Jan-2008.)  (Revised by Mario
       Carneiro, 19-Nov-2013.)  (New usage is discouraged.) $)
    ipblnfi $p |- ( A e. X -> F e. B ) $=
      ( vz wcel co cfv cc wceq vy vw clno cnmcv cr cv cabs cmul cle wbr wral wf
      cns cpv caddc cnv phnvi dipcl mp3an1 ancoms fmptd wa eqid nvscl ad2ant2lr
      simprr simpll ccphlo w3a dipdir syl3anc simplr simprl ipassi oveq1d eqtrd
      mpan adantll nvgcl sylan anasss oveq1 ovex fvmpt ad2antrl oveq2d ad2antll
      syl oveq12d 3eqtr4d ralrimivva ralrimiva wb cnnv cnnvba cnnvg cnnvs islno
      mp2an sylanbrc sii adantl fveq2d recnd mulcom syl2an 3brtr4d cnnvnm blo3i
      nvcl ) BHPZGFDUCQZPZBFUDRZRZUEPZOUFZGRZUGRZXOXQXNRZUHQZUIUJZOHUKGCPXKHSGU
      LZUAUFZXQFUMRZQZUBUFZFUNRZQZGRZYDXRUHQZYGGRZUOQZTZUBHUKOHUKZUASUKZXMXKAHA
      UFZBEQZSGYQHPZXKYRSPZFUPPZYSXKYTFKUQZYQBEFHIJURUSUTNVAXKYOUASXKYDSPZVBZYN
      OUBHHUUDXQHPZYGHPZVBZVBZYIBEQZYDXQBEQZUHQZYGBEQZUOQZYJYMUUHUUIYFBEQZUULUO
      QZUUMUUHYFHPZUUFXKUUIUUOTZUUCUUEUUPXKUUFUUAUUCUUEUUPUUBYDXQYEFHIYEVCZVDUS
      ZVEUUDUUEUUFVFXKUUCUUGVGZFVHPUUPUUFXKVIUUQKYFYGBEFYHHIYHVCZJVJVQVKUUHUUNU
      UKUULUOUUHUUCUUEXKUUNUUKTXKUUCUUGVLUUDUUEUUFVMUUTYDXQBEYEFYHHIUVAUURJKVNV
      KVOVPUUHYIHPZYJUUITUUDUUEUUFUVBUUDUUEVBUUPUUFUVBUUCUUEUUPXKUUSVRUUAUUPUUF
      UVBUUBYFYGFYHHIUVAVSUSVTWAAYIYRUUIHGYQYIBEWBNYIBEWCWDWHUUHYKUUKYLUULUOUUH
      XRUUJYDUHUUEXRUUJTZUUDUUFAXQYRUUJHGYQXQBEWBNXQBEWCWDZWEWFUUFYLUULTUUDUUEA
      YGYRUULHGYQYGBEWBNYGBEWCWDWGWIWJWKWLUUADUPPXMYCYPVBWMUUBDLWNZUAOUBYEUHGFY
      HUOXLDHSIDLWOUVADLWPUURDLWQXLVCZWRWSWTUUAXKXPUUBBFXNHIXNVCZXJVQZXKYBOHXKU
      UEVBZUUJUGRZXTXOUHQZXSYAUIUUEXKUVJUVKUIUJXQBEFXNHIUVGJKXAUTUVIXRUUJUGUUEU
      VCXKUVDXBXCXKXOSPXTSPYAUVKTUUEXKXOUVHXDUUEXTUUAUUEXTUEPUUBXQFXNHIUVGXJVQX
      DXOXTXEXFXGWLOXOCGFXLXNUGDHIUVGDLXHUVFMUUBUVEXIVK $.
  $}

  ${
    $d x A $.  $d x B $.  $d s t x P $.  $d s t Q $.  $d x y S $.
    $d s t x y T $.  $d x U $.  $d s t x y X $.  $d s t x y Y $.
    ip2eqi.1 $e |- X = ( BaseSet ` U ) $.
    ip2eqi.7 $e |- P = ( .iOLD ` U ) $.
    ip2eqi.u $e |- U e. CPreHilOLD $.
    $( Two vectors are equal iff their inner products with all other vectors
       are equal.  (Contributed by NM, 24-Jan-2008.)
       (New usage is discouraged.) $)
    ip2eqi $p |- ( ( A e. X /\ B e. X ) -> ( A. x e. X ( x P A
                                               ) = ( x P B ) <-> A = B ) ) $=
      ( wcel co wceq cfv eqid mp3an1 oveq1 syl cc0 mpan wb wa cv wral cnv phnvi
      cnsb wi nvmcl eqeq12d rspcv cmin cn0v simpl simpr ccphlo dipsubdi syl3anc
      w3a eqeq1d bitr3d cc dipcl syl2anc sylancom subeq0ad nvmeq0 3bitr3d oveq2
      ipz sylibd ralrimivw impbid1 ) BFJZCFJZUAZAUBZBDKZVPCDKZLZAFUCZBCLZVOVTBC
      EUFMZKZBDKZWCCDKZLZWAVOWCFJZVTWFUGEUDJZVMVNWGEIUEZBCEWBFGWBNZUHOZVSWFAWCF
      VPWCLVQWDVRWEVPWCBDPVPWCCDPUIUJQVOWDWEUKKZRLZWCEULMZLZWFWAVOWCWCDKZRLZWMW
      OVOWPWLRVOWGVMVNWPWLLZWKVMVNUMZVMVNUNEUOJWGVMVNURWRIWCBCDEWBFGWJHUPSUQUSV
      OWGWQWOTZWKWHWGWTWIWCDEFWNGWNNZHVISQUTVOWDWEVOWGVMWDVAJZWKWSWHWGVMXBWIWCB
      DEFGHVBOVCVMVNWGWEVAJZWKWHWGVNXCWIWCCDEFGHVBOVDVEWHVMVNWOWATWIBCEWBFWNGWJ
      XAVFOVGVJWAVSAFBCVPDVHVKVL $.

    $( A condition implying that two operators are equal.  (Contributed by NM,
       25-Jan-2008.)  (New usage is discouraged.) $)
    phoeqi $p |- ( ( S : Y --> X /\ T : Y --> X ) -> ( A. x e. X A. y e.
      Y ( x P ( S ` y ) ) = ( x P ( T ` y ) ) <-> S = T ) ) $=
      ( cv cfv co wceq wral wf wa wcel wb ralcom ffvelrn ip2eqi syl2an anandirs
      ralbidva wfn ffn eqfnfv bitr4d syl5bb ) ALZBLZDMZCNULUMEMZCNOZBHPAGPUPAGP
      ZBHPZHGDQZHGEQZRZDEOZUPABGHUAVAURUNUOOZBHPZVBVAUQVCBHUSUTUMHSZUQVCTZUSVER
      UNGSUOGSVFUTVERHGUMDUBHGUMEUBAUNUOCFGIJKUCUDUEUFUSDHUGEHUGVBVDTUTHGDUHHGE
      UHBHDEUIUDUJUK $.

    $( Every operator has at most one adjoint.  (Contributed by NM,
       25-Jan-2008.)  (New usage is discouraged.) $)
    ajmoi $p |- E* s ( s : Y --> X /\
           A. x e. X A. y e. Y ( ( T ` x ) Q y ) = ( x P ( s ` y ) ) ) $=
      ( vt cv wf cfv co wceq wral wa wmo wi r19.26-2 eqtr2 ralimi sylbir phoeqi
      wal biimpa sylan2 an4s gen2 feq1 fveq1 oveq2d eqeq2d 2ralbidv anbi12d mo4
      mpbir ) HGINZOZANZEPBNZDQZVCVDVAPZCQZRZBHSAGSZTZIUAVJHGMNZOZVEVCVDVKPZCQZ
      RZBHSAGSZTZTVAVKRZUBZMUHIUHVSIMVBVLVIVPVRVIVPTZVBVLTZVGVNRZBHSZAGSZVRVTVH
      VOTZBHSZAGSWDVHVOABGHUCWFWCAGWEWBBHVEVGVNUDUEUEUFWAWDVRABCVAVKFGHJKLUGUIU
      JUKULVJVQIMVRVBVLVIVPHGVAVKUMVRVHVOABGHVRVGVNVEVRVFVMVCCVDVAVKUNUOUPUQURU
      SUT $.
  $}

  ${
    $d s t x y U $.  $d s t x y W $.
    ajfuni.5 $e |- A = ( U adj W ) $.
    ajfuni.u $e |- U e. CPreHilOLD $.
    ajfuni.w $e |- W e. NrmCVec $.
    $( The adjoint function is a function.  (Contributed by NM, 25-Jan-2008.)
       (New usage is discouraged.) $)
    ajfuni $p |- Fun A $=
      ( vt vs vx vy wfun cba cfv cv wf cdip co wceq wral eqid w3a copab funopab
      wmo wa ajmoi 3simpc moimi ax-mp mpgbir cnv wcel phnvi ajfval mp2an funeqi
      mpbir ) AKBLMZCLMZGNZOZUSURHNZOZINZUTMJNZCPMZQVDVEVBMBPMZQRJUSSIURSZUAZGH
      UBZKZVKVIHUDZGVIGHUCVCVHUEZHUDVLIJVGVFUTBURUSHURTZVGTZEUFVIVMHVAVCVHUGUHU
      IUJAVJBUKULCUKULAVJRBEUMFIJGAVGVFBCURUSHVNUSTVOVFTDUNUOUPUQ $.
  $}

  ${
    ajfun.5 $e |- A = ( U adj W ) $.
    $( The adjoint function is a function.  This is not immediately apparent
       from ~ df-aj but results from the uniqueness shown by ~ ajmoi .
       (Contributed by NM, 26-Jan-2008.)  (New usage is discouraged.) $)
    ajfun $p |- ( ( U e. CPreHilOLD /\ W e. NrmCVec ) -> Fun A ) $=
      ( ccphlo wcel cnv wfun caddc cmul cop cabs cif caj co oveq1 syl5eq funeqd
      wceq oveq2 eqid elimphu elimnvu ajfuni dedth2h ) BEFZCGFZAHUFBIJKLKZMZCNO
      ZHUIUGCUHMZNOZHBCUHUHBUISZAUJUMABCNOUJDBUICNPQRCUKSUJULCUKUINTRULUIUKULUA
      BUBCUCUDUE $.
  $}

  ${
    $d t P $.  $d t Q $.  $d s t x y T $.  $d s t x y U $.  $d s t x y W $.
    $d s t x y X $.  $d s t y Y $.
    ajval.1 $e |- X = ( BaseSet ` U ) $.
    ajval.2 $e |- Y = ( BaseSet ` W ) $.
    ajval.3 $e |- P = ( .iOLD ` U ) $.
    ajval.4 $e |- Q = ( .iOLD ` W ) $.
    ajval.5 $e |- A = ( U adj W ) $.
    $( Value of the adjoint function.  (Contributed by NM, 25-Jan-2008.)
       (New usage is discouraged.) $)
    ajval $p |- ( ( U e. CPreHilOLD /\ W e. NrmCVec /\ T : X --> Y ) ->
       ( A ` T ) = ( iota s ( s : Y --> X /\
          A. x e. X A. y e. Y ( ( T ` x ) Q y ) = ( x P ( s ` y ) ) ) ) ) $=
      ( wcel cfv wceq cvv vt ccphlo cnv wf w3a cv co wral copab cio phnv ajfval
      wa sylan fveq1d 3adant3 cba fvex eqeltri fex mpan2 eqid feq1 fveq1 oveq1d
      eqeq1d 2ralbidv 3anbi13d fvopab5 syl 3anass baib iotabidv eqtrd 3ad2ant3
      ) GUBQZHUCQZIJFUDZUEFCRZFIJUAUFZUDZJIKUFZUDZAUFZVTRZBUFZEUGZWDWFWBRDUGZSZ
      BJUHAIUHZUEZUAKUIZRZWCWDFRZWFEUGZWHSZBJUHAIUHZUMZKUJZVPVQVSWMSVRVPVQUMFCW
      LVPGUCQVQCWLSGUKABUACDEGHIJKLMNOPULUNUOUPVRVPWMWSSVQVRWMVRWCWQUEZKUJZWSVR
      FTQZWMXASVRITQXBIGUQRTLGUQURUSIJTFUTVAWKWTUAKFWLTWLVBVTFSZWAVRWJWQWCIJVTF
      VCXCWIWPABIJXCWGWOWHXCWEWNWFEWDVTFVDVEVFVGVHVIVJVRWTWRKWTVRWRVRWCWQVKVLVM
      VNVOVN $.
  $}


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Complex Banach spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CBan $.

  $( Extend class notation with the class of all complex Banach spaces. $)
  ccbn $a class CBan $.

  $( Define the class of all complex Banach spaces.  (Contributed by NM,
     5-Dec-2006.)  (New usage is discouraged.) $)
  df-cbn $a |- CBan = { u e. NrmCVec |
    ( IndMet ` u ) e. ( CMet ` ( BaseSet ` u ) ) } $.

  ${
    $d u D $.  $d u U $.  $d u X $.
    iscbn.x $e |- X = ( BaseSet ` U ) $.
    iscbn.8 $e |- D = ( IndMet ` U ) $.
    $( A complex Banach space is a normed complex vector space with a complete
       induced metric.  (Contributed by NM, 5-Dec-2006.)
       (New usage is discouraged.) $)
    iscbn $p |- ( U e. CBan <-> ( U e. NrmCVec /\ D e. ( CMet ` X ) ) ) $=
      ( vu cv cims cfv cba cms wcel cnv ccbn wceq syl6eqr fveq2d eleq12d df-cbn
      fveq2 elrab2 ) FGZHIZUBJIZKIZLACKIZLFBMNUBBOZUCAUEUFUGUCBHIAUBBHTEPUGUDCK
      UGUDBJICUBBJTDPQRFSUA $.

    $( The induced metric on complex Banach space is complete.  (Contributed by
       NM, 8-Sep-2007.)  (New usage is discouraged.) $)
    cbncms $p |- ( U e. CBan -> D e. ( CMet ` X ) ) $=
      ( ccbn wcel cnv cms cfv iscbn simprbi ) BFGBHGACIJGABCDEKL $.
  $}

  $( Every complex Banach space is a normed complex vector space.  (Contributed
     by NM, 17-Mar-2007.)  (New usage is discouraged.) $)
  bnnv $p |- ( U e. CBan -> U e. NrmCVec ) $=
    ( ccbn wcel cnv cims cfv cba cms eqid iscbn simplbi ) ABCADCAEFZAGFZHFCLAMM
    ILIJK $.

  $( The class of all complex Banach spaces is a relation.  (Contributed by NM,
     17-Mar-2007.)  (New usage is discouraged.) $)
  bnrel $p |- Rel CBan $=
    ( vx ccbn cnv wss wrel cv bnnv ssriv nvrel relss mp2 ) BCDCEBEABCAFGHIBCJK
    $.

  ${
    bnsscmcl.x $e |- X = ( BaseSet ` U ) $.
    bnsscmcl.d $e |- D = ( IndMet ` U ) $.
    bnsscmcl.j $e |- J = ( MetOpen ` D ) $.
    bnsscmcl.h $e |- H = ( SubSp ` U ) $.
    bnsscmcl.y $e |- Y = ( BaseSet ` W ) $.
    $( A subspace of a Banach space is a Banach space iff it is closed in the
       norm-induced metric of the parent space.  (Contributed by NM,
       1-Feb-2008.)  (New usage is discouraged.) $)
    bnsscmcl $p |- ( ( U e. CBan /\ W e. H ) -> ( W e. CBan <->
                Y e. ( Clsd ` J ) ) ) $=
      ( ccbn wcel cfv cms cnv wb sylan syl cims cres ccld bnnv sspnv eqid iscbn
      wa cxp baib wceq sspims eleq1d cbncms adantr cmetss 3bitrd ) BMNZECNZUHZE
      MNZEUAOZGPOZNZAGGUIUBZVCNZGDUCONZUTEQNZVAVDRURBQNZUSVHBUDZBCEKUESVAVHVDVB
      EGLVBUFZUGUJTUTVBVEVCURVIUSVBVEUKVJVBABCEGLIVKKULSUMUTAFPONZVFVGRURVLUSAB
      FHIUNUOADFGJUPTUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of complex Banach spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    cnbn.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is a complex Banach space.  (Contributed by
       Steve Rodriguez, 4-Jan-2007.)  (New usage is discouraged.) $)
    cnbn $p |- U e. CBan $=
      ( ccbn wcel cnv caddc cmul cop cabs cims cfv cc cnnv cmin ccom eqid cnims
      cms eqcomi cncmet cnnvba fveq2i iscbn mpbir2an ) ACDAEDFGHIHZJKZLRKDABMUF
      INOZUFUGUEUEPUGPQSTUFALABUAAJKUFAUEJBUBSUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Uniform Boundedness Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d c k n r x y z A $.  $d c k n r t x z D $.  $d k n t x y J $.
    $d d k t x z K $.  $d c d k m n r t u x y z N $.  $d t z P $.
    $d c k n r t x y ph $.  $d d t x z R $.  $d c d k m n r t u x y z T $.
    $d c d n r t x y z U $.  $d c d n r t x y W $.  $d c d k m n r t x y z X $.
    ubth.1 $e |- X = ( BaseSet ` U ) $.
    ubth.2 $e |- N = ( normCV ` W ) $.
    ${
      ubthlem.3 $e |- D = ( IndMet ` U ) $.
      ubthlem.4 $e |- J = ( MetOpen ` D ) $.
      ubthlem.5 $e |- U e. CBan $.
      ubthlem.6 $e |- W e. NrmCVec $.
      ubthlem.7 $e |- ( ph -> T C_ ( U BLnOp W ) ) $.
      ${
        ubthlem.8 $e |- ( ph -> A. x e. X E. c e. RR A. t e. T
                                ( N ` ( t ` x ) ) <_ c ) $.
        ubthlem.9 $e |- A = ( k e. NN |-> { z e. X |
                              A. t e. T ( N ` ( t ` z ) ) <_ k } ) $.
        $( Lemma for ~ ubth .  The function ` A ` exhibits a countable
           collection of sets that are closed, being the inverse image under
           ` t ` of the closed ball of radius ` k ` , and by assumption they
           cover ` X ` .  Thus, by the Baire Category theorem ~ bcth2 , for
           some ` n ` the set ` A `` n ` has an interior, meaning that there is
           a closed ball ` { z e. X | ( y D z ) <_ r } ` in the set.
           (Contributed by Mario Carneiro, 11-Jan-2014.)
           (New usage is discouraged.) $)
        ubthlem1 $p |- ( ph -> E. n e. NN E. y e. X E. r e. RR+
                        { z e. X | ( y D z ) <_ r } C_ ( A ` n ) ) $=
          ( cv cfv cnt c0 wne cn wrex co cle wbr crab wss crp ccld wf cuni wceq
          wral wcel wa rzal ralrimivw rabid2 sylibr eqcomd eleq1d iinrab adantl
          crn ciin ccnv cba cima cims cmopn cblo sselda ccn eqid ccbn cnv ax-mp
          bnnv blocn2 ctopon cxmt cms cme cbncms cmetmet metxmet mp2b mopntopon
          id wb imsxmet iscncl mp2an sylib syl simpld ffvelrnda biantrurd fveq2
          adantlr breq1d elrab syl6bbr pm5.32da fveq2d a1i wfn ffn cxr cr nvzcl
          mp3an12 clt wi simpr syl2an adantr sylancr ralimdva cvv elssuni sseld
          cn0v sylan rexlimdva mpd wex sstr2 ex elpreima 3bitr4d eqrdv ad2antlr
          3syl nnre rexrd nvnd xmetsym eqtr4d rabbiia blcld simprd imaeq2 rspcv
          mpan sylc eqeltrd ralrimiva iincld syl2anr eqeltrrd mopntop toponunii
          ctop topcld pm2.61ne fmptd cpw frn cldss2 syl6ss arch ltle impr an32s
          sspwuni nvcl simpllr simplrl letr syl3anc mpan2d eqeltri rabex fvmpt2
          expr fvex mpan2 eleq2d ralbidv syl6bb bicomd sylan9bbr fnfvelrn syl6d
          sylbird dfss3 eqssd ne0i mpanl12 syl2anc ffvelrn sseldi elpwid ntrss3
          bcth2 cbl ntropn mopni2 mp3an1 syl6sseqr cdiv ntrss2 syl5com ad2antrr
          c2 w3a jctil rphalfcl rpxrd rpxr rphalflt 3jca blsscls2 breq2 rabbidv
          sseq1d rspcev 3syld syldan jcad eximdv n0 df-rex 3imtr4g reximdva ) A
          KUGZFUHZLUIUHUHZUJUKZKULUMZCUGZDUGZGUNZPUGZUOUPZDOUQZUYSURZPUSUMZCOUM
          ZKULUMAULLUTUHZFVAZFVOZVBZOVCZVUBAJULVUDEUGZUHZMUHZJUGZUOUPZEHVDZDOUQ
          ZVULFAVUTULVEZVFZVVCVULVEOVULVEZHUJHUJVCZVVCOVULVVGOVVCVVGVVBDOVDOVVC
          VCVVGVVBDOVVAEHVGVHVVBDOVIVJVKVLVVEHUJUKZVFEHVVADOUQZVPZVVCVULVVHVVJV
          VCVCVVEVVAEDHOVMVNVVHVVHVVIVULVEZEHVDVVJVULVEVVEVVHWTVVEVVKEHVVEVUQHV
          EZVFZVVIVUQVQZVUCMUHZVUTUOUPZCNVRUHZUQZVSZVULVVMBVVIVVSVVMBUGZOVEZVVT
          VUQUHZMUHZVUTUOUPZVFZVWAVWBVVRVEZVFZVVTVVIVEZVVTVVSVEZVVMVWAVWDVWFVVM
          VWAVFZVWDVWBVVQVEZVWDVFVWFVWJVWKVWDVVMOVVQVVTVUQAVVLOVVQVUQVAZVVDAVVL
          VFZVWLVVNVVTVSZVULVEZBNVTUHZWAUHZUTUHZVDZVWMVUQINWBUNZVEZVWLVWSVFZAHV
          WTVUQUDWCVXAVUQLVWQWDUNVEZVXBVWTGVWPVUQILVWQNTVWPWEZUAVWQWEZVWTWEIWFV
          EZIWGVEZUBIWIWHZUCWJLOWKUHVEZVWQVVQWKUHVEZVXCVXBXAGOWLUHVEZVXIGOWMUHV
          EZGOWNUHVEVXKVXFVXLUBGIORTWOWHZGOWPGOWQWRZGLOUAWSWHZVWPVVQWLUHVEZVXJN
          WGVEZVXPUCVWPNVVQVVQWEZVXDXBWHZVWPVWQVVQVXEWSWHBVUQLVWQOVVQXCXDXEXFZX
          GZXKZXHXIVVPVWDCVWBVVQVUCVWBVCVVOVWCVUTUOVUCVWBMXJXLXMXNXOVWHVWEXAVVM
          VVAVWDDVVTOVUDVVTVCZVUSVWCVUTUOVYCVURVWBMVUDVVTVUQXJXPXLZXMXQVVMVWLVU
          QOXRVWIVWGXAVYBOVVQVUQXSOVVTVVRVUQUUAUUEUUBUUCVVMVVRVWRVEZVWSVVSVULVE
          ZVVMVUTXTVEZVYEVVMVUTVVDVUTYAVEZAVVLVUTUUFZUUDUUGVXPNYNUHZVVQVEZVYGVY
          EVXSVXQVYKUCNVVQVYJVXRVYJWEZYBWHZCVWPVYJVUTVVRVWQVVQVXEVVPVYJVUCVWPUN
          ZVUTUOUPCVVQVUCVVQVEZVVOVYNVUTUOVYOVVOVUCVYJVWPUNZVYNVXQVYOVVOVYPVCUC
          VUCVWPNMVVQVYJVXRVYLSVXDUUHUUPVXPVYKVYOVYNVYPVCVXSVYMVYJVUCVWPVVQUUIY
          CUUJXLUUKUULYCXFAVVLVWSVVDVWMVWLVWSVXTUUMXKVWOVYFBVVRVWRVVTVVRVCVWNVV
          SVULVVTVVRVVNUUNVLUUOUUQUURUUSEHVVILUUTUVAUVBVVFVVELUVEVEZVVFVXKVYQVX
          NGLOUAUVCWHZLOOLVXOUVDZUVFWHXQUVGUFUVHZAVUOOAVUNOUVIZURVUOOURAVUNVULW
          UAAVUMVUNVULURVYTULVULFUVJXFLOVYSUVKZUVLVUNOUVQXEAVVTVUOVEZBOVDZOVUOU
          RAVWCQUGZUOUPZEHVDZQYAUMZBOVDWUDUEAWUHWUCBOAVWAVFZWUGWUCQYAWUIWUEYAVE
          ZVFZWUEVUTYDUPZJULUMZWUGWUCYEZWUJWUMWUIWUEJUVMVNWUKWULWUNJULWUKVVDVFW
          ULWUGVWDEHVDZWUCWUKVVDWULWUGWUOYEWUKVVDWULVFZVFZWUFVWDEHWUQVVLVFZWUFW
          UEVUTUOUPZVWDWUQWUSVVLWUKVVDWULWUSWUKWUJVYHWULWUSYEVVDWUIWUJYFVYIWUEV
          UTUVNYGUVOYHWURVWCYAVEZWUJVYHWUFWUSVFVWDYEWUKVVLWUTWUPWUIVVLWUTWUJWUI
          VVLVFVXQVWKWUTUCAVVLVWAVWKVWMOVVQVVTVUQVYAXHUVPVWBNMVVQVXRSUVRYIXKXKW
          UIWUJWUPVVLUVSWURVVDVYHWUKVVDWULVVLUVTVYIXFVWCWUEVUTUWAUWBUWCYJUWGWUI
          VVDWUOWUCYEWUJWUIVVDVFWUOVVTVUTFUHZVEZWUCVVDWVBVWAWUOVFZWUIWUOVVDWVBV
          VTVVCVEWVCVVDWVAVVCVVTVVDVVCYKVEWVAVVCVCVVBDOOIVRUHYKRIVRUWHUWDUWEJUL
          VVCYKFUFUWFUWIUWJVVBWUODVVTOVYCVVAVWDEHVYDUWKXMUWLWUIWUOWVCWUIVWAWUOA
          VWAYFXIUWMUWNWUIFULXRZVVDWVBWUCYEAWVDVWAAVUMWVDVYTULVULFXSXFYHWVDVVDV
          FZWVAVUOVVTWVEWVAVUNVEWVAVUOURULVUTFUWOWVAVUNYLXFYMYOUWQXKUWPYPYQYPYJ
          YQBOVUOUWRVJUWSVXLOUJUKZVUMVUPVFVUBVXMVXGIYNUHZOVEWVFVXHIOWVGRWVGWEYB
          OWVGUWTWRGKLFOUAUXGUXAUXBAVUAVUKKULAUYRULVEZVFZVUCUYTVEZCYRVUCOVEZVUJ
          VFZCYRVUAVUKWVIWVJWVLCWVIWVJWVKVUJWVIUYTOVUCWVIVYQUYSOURZUYTOURZVYRAV
          UMWVHWVMVYTVUMWVHVFZUYSOWVOVULWUAUYSWUBULVULUYRFUXCUXDUXEYOZUYSLOVYSU
          XFYIYMWVIWVJVUJWVIWVJVFVUCVVTGUXHUHUNZUYTURZBUSUMZVUJWVIUYTLVEZWVJWVS
          WVIVYQWVMWVTVYRWVPUYSLOVYSUXIYIZVXKWVTWVJWVSVXNBUYTGVUCLOUAUXJUXKYOWV
          IWVJWVKWVSVUJYEWVIUYTOVUCWVIWVTWVNWWAWVTUYTLVBOUYTLYLVYSUXLXFWCWVIWVK
          VFZWVRVUJBUSWWBVVTUSVEZVFZWVRWVQUYSURZVUEVVTUXQUXMUNZUOUPZDOUQZUYSURZ
          VUJWVIWVRWWEYEWVKWWCWVIUYTUYSURZWVRWWEWVIVYQWVMWWJVYRWVPUYSLOVYSUXNYI
          WVQUYTUYSYSUXOUXPWWDWWHWVQURZWWEWWIYEWWBVXKWVKVFWWFXTVEZVVTXTVEZWWFVV
          TYDUPZUXRWWKWWCWWBWVKVXKWVIWVKYFVXNUXSWWCWWLWWMWWNWWCWWFVVTUXTZUYAVVT
          UYBVVTUYCUYDDGVUCWWFWWHVVTLOUAWWHWEUYEYGWWHWVQUYSYSXFWWDWWFUSVEZWWIVU
          JYEWWCWWPWWBWWOVNWWPWWIVUJVUIWWIPWWFUSVUFWWFVCZVUHWWHUYSWWQVUGWWGDOVU
          FWWFVUEUOUYFUYGUYHUYIYTXFUYJYPUYKYQYTUYLUYMCUYTUYNVUJCOUYOUYPUYQYQ $.

        ubthlem.10 $e |- ( ph -> K e. NN ) $.
        ubthlem.11 $e |- ( ph -> P e. X ) $.
        ubthlem.12 $e |- ( ph -> R e. RR+ ) $.
        ubthlem.13 $e |- ( ph -> { z e. X | ( P D z ) <_ R } C_ ( A ` K ) ) $.
        $( Lemma for ~ ubth .  Given that there is a closed ball
           ` B ( P , R ) ` in ` A `` K ` , for any ` x e. B ( 0 , 1 ) ` , we
           have ` P + R x. x e. B ( P , R ) ` and ` P e. B ( P , R ) ` , so
           both of these have ` norm ( t ( z ) ) <_ K ` and so ` norm ( t ( x `
           ` ) ) <_ ( norm ( t ( P ) ) + norm ( t ( P + R x. x ) ) ) / R <_ ( `
           ` K + K ) / R ` , which is our desired uniform bound.  (Contributed
           by Mario Carneiro, 11-Jan-2014.)  (New usage is discouraged.) $)
        ubthlem2 $p |- ( ph -> E. d e. RR A. t e. T
                         ( ( U normOpOLD W ) ` t ) <_ d ) $=
          ( caddc co cdiv cr wcel cv cnmoo cfv cle wbr wral wrex nnrpd rpaddcld
          rpdivcld rpred wa cnmcv c1 cns cpv crab wss rabss sylib ad2antrr ccbn
          wi cnv bnnv ax-mp a1i rpcnd simpr eqid nvscl syl3anc nvgcl wceq oveq2
          cc crp breq1d eleq1 imbi12d rspccv sylc cmul cnsb cxmt cms cme cbncms
          cmetmet metxmet mp2b xmetsym imsdval nvpncan2 fveq2d 3eqtrd cc0 eqtrd
          rprege0d nvsge0 mulid1d eqcomd breq12d nvcl mpan adantl wb cn ralbidv
          breq2 cba fveq2 elrab sylancr adantr ccld mopntopon ffvelrnd syl32anc
          syl ctopon syld ralrimiva syl2anc 1re lemul2d bitr4d rabbidv cvv fvex
          eqeltri rabex fvmpt eleq2d syl6bb 3imtr3d com12 ad2antlr xmet0 rpge0d
          rsp eqbrtrd sylanbrc sseldd eleqtrd simprd r19.21bi wf ccnv cima cims
          cmopn cblo sselda ccn blocn2 imsxmet iscncl mp2an simpld nnred le2add
          syl22anc mpan2d clno mp3an12 lnosub lnomul 3eqtr3d ffvelrnda eqbrtrrd
          bloln nvmtri remulcld readdcld letr mpand lemuldiv2d sylibd cxr rpxrd
          adantld nmoubi mpbird rspcev ) AMMULUMZHUNUMZUOUPDUQZJOURUMZUSZUXCUTV
          AZDIVBZUXFRUQZUTVAZDIVBZRUOVCAUXCAUXBHAMMAMUHVDZUXLVEZUJVFZVGAUXGDIAU
          XDIUPZVHZUXGBUQZJVIUSZUSZVJUTVAZUXQUXDUSZNUSZUXCUTVAZVSZBPVBZUXPUYDBP
          UXPUXQPUPZVHZUXTGHUXQJVKUSZUMZJVLUSZUMZPUPZUYKUXDUSZNUSZMUTVAZDIVBZVH
          ZUYCUYGGUYKFUMZHUTVAZUYKMEUSZUPZUXTUYQUYGGCUQZFUMZHUTVAZVUBUYTUPZVSZC
          PVBZUYLUYSVUAVSZAVUGUXOUYFAVUDCPVMZUYTVNVUGUKVUDCPUYTVOVPVQUYGJVTUPZG
          PUPZUYIPUPZUYLVUJUYGJVRUPZVUJUCJWAWBZWCZAVUKUXOUYFUIVQZUYGVUJHWLUPZUY
          FVULVUOUYGHAHWMUPUXOUYFUJVQZWDZUXPUYFWEZHUXQUYHJPSUYHWFZWGWHZGUYIJUYJ
          PSUYJWFZWIWHZVUFVUHCUYKPVUBUYKWJZVUDUYSVUEVUAVVEVUCUYRHUTVUBUYKGFWKWN
          VUBUYKUYTWOWPWQWRUYGUYSHUXSWSUMZHVJWSUMZUTVAUXTUYGUYRVVFHVVGUTUYGUYRU
          YIUXRUSZVVFUYGUYRUYKGFUMZUYKGJWTUSZUMZUXRUSZVVHUYGFPXAUSUPZVUKUYLUYRV
          VIWJVVMUYGFPXBUSUPZFPXCUSUPVVMVUMVVNUCFJPSUAXDWBFPXEFPXFXGZWCVUPVVDGU
          YKFPXHWHUYGVUJUYLVUKVVIVVLWJVUOVVDVUPUYKGFJVVJUXRPSVVJWFZUXRWFZUAXIWH
          UYGVVKUYIUXRUYGVUJVUKVULVVKUYIWJVUOVUPVVBGUYIJUYJVVJPSVVCVVPXJWHZXKXL
          UYGVUJHUOUPXMHUTVAVHZUYFVVHVVFWJVUOUYGHVURXOZVUTHUXQUYHJUXRPSVVAVVQXP
          WHXNUYGVVGHUYGHVUSXQXRXSUYGUXSVJHUYFUXSUOUPZUXPVUJUYFVWAVUNUXQJUXRPSV
          VQXTYAYBVJUOUPUYGUUAWCVURUUBUUCAVUAUYQYCUXOUYFAVUAUYKVUBUXDUSZNUSZMUT
          VAZDIVBZCPVMZUPUYQAUYTVWFUYKAMYDUPUYTVWFWJUHKMVWCKUQZUTVAZDIVBZCPVMVW
          FYDEVWGMWJZVWIVWECPVWJVWHVWDDIVWGMVWCUTYFYEUUDUGVWECPPJYGUSUUESJYGUUF
          UUGUUHUUIYPZUUJVWEUYPCUYKPVVEVWDUYODIVVEVWCUYNMUTVVEVWBUYMNVUBUYKUXDY
          HXKWNYEYIUUKVQUULUYGUYPUYCUYLUYGUYPUYOUYCUXOUYPUYOVSAUYFUYPUXOUYOUYOD
          IUUQUUMUUNUYGUYOHUYBWSUMZUXBUTVAZUYCUYGUYOUYNGUXDUSZNUSZULUMZUXBUTVAZ
          VWMUYGUYOVWOMUTVAZVWQUXPVWRUYFAVWRDIAVUKVWRDIVBZAGVWFUPVUKVWSVHAGUYTV
          WFAVUIUYTGUKAVUKGGFUMZHUTVAZGVUIUPUIAVWTXMHUTAVVMVUKVWTXMWJVVOUIGFPUU
          OYJAHUJUUPUURVUDVXACGPVUBGWJZVUCVWTHUTVUBGGFWKWNYIUUSUUTVWKUVAVWEVWSC
          GPVXBVWDVWRDIVXBVWCVWOMUTVXBVWBVWNNVUBGUXDYHXKWNYEYIVPUVBUVCYKUYGUYNU
          OUPZVWOUOUPZMUOUPZVXEUYOVWRVHVWQVSUYGOVTUPZUYMOYGUSZUPZVXCUDUYGPVXGUY
          KUXDUXPPVXGUXDUVDZUYFUXPVXIUXDUVEUXQUVFLYLUSUPBOUVGUSZUVHUSZYLUSVBZUX
          PUXDJOUVIUMZUPZVXIVXLVHZAIVXMUXDUEUVJZVXNUXDLVXKUVKUMUPZVXOVXMFVXJUXD
          JLVXKOUAVXJWFZUBVXKWFZVXMWFZVUNUDUVLLPYQUSUPZVXKVXGYQUSUPZVXQVXOYCVVM
          VYAVVOFLPUBYMWBVXFVXJVXGXAUSUPVYBUDVXJOVXGVXGWFZVXRUVMVXJVXKVXGVXSYMX
          GBUXDLVXKPVXGUVNUVOVPYPUVPZYKZVVDYNZUYMONVXGVYCTXTYJZUYGVXFVWNVXGUPZV
          XDUDUYGPVXGGUXDVYEVUPYNZVWNONVXGVYCTXTYJZAVXEUXOUYFAMUHUVQVQZVYKUYNVW
          OMMUVRUVSUVTUYGVWLVWPUTVAZVWQVWMUYGUYMVWNOWTUSZUMZNUSZVWLVWPUTUYGVYOH
          UYAOVKUSZUMZNUSZVWLUYGVYNVYQNUYGVVKUXDUSZUYIUXDUSZVYNVYQUYGVVKUYIUXDV
          VRXKUYGVUJVXFUXDJOUWAUMZUPZUYLVUKVYSVYNWJVUOVXFUYGUDWCZUXPWUBUYFUXPVX
          NWUBVXPVUJVXFVXNWUBVUNUDVXMUXDJWUAOWUAWFZVXTUWHUWBYPYKZVVDVUPUYKGUXDJ
          WUAVVJVYMOPSVVPVYMWFZWUDUWCYOUYGVUJVXFWUBVUQUYFVYTVYQWJVUOWUCWUEVUSVU
          THUXQUYHVYPUXDJWUAOPSVVAVYPWFZWUDUWDYOUWEXKUYGVXFVVSUYAVXGUPZVYRVWLWJ
          WUCVVTUXPPVXGUXQUXDVYDUWFZHUYAVYPONVXGVYCWUGTXPWHXNUYGVXFVXHVYHVYOVWP
          UTVAWUCVYFVYIUYMVWNOVYMNVXGVYCWUFTUWIWHUWGUYGVWLUOUPVWPUOUPUXBUOUPZVY
          LVWQVHVWMVSUYGHUYBUYGHVURVGUYGVXFWUHUYBUOUPUDWUIUYAONVXGVYCTXTYJZUWJU
          YGUYNVWOVYGVYJUWKAWUJUXOUYFAUXBUXMVGVQZVWLVWPUXBUWLWHUWMYRUYGUYBUXBHW
          UKWULVURUWNUWOYRUWRYRYSUXPVXIUXCUWPUPZUXGUYEYCVYDAWUMUXOAUXCUXNUWQYKB
          UXCUXDJUXRNUXEOPVXGSVYCVVQTUXEWFVUNUDUWSYTUWTYSUXKUXHRUXCUOUXIUXCWJUX
          JUXGDIUXIUXCUXFUTYFYEUXAYT $.
      $}

      $d d ph $.
      $( Lemma for ~ ubth .  Prove the reverse implication, using ~ nmblolbi .
         (Contributed by Mario Carneiro, 11-Jan-2014.)
         (New usage is discouraged.) $)
      ubthlem3 $p |- ( ph ->
                ( A. x e. X E. c e. RR A. t e. T ( N ` ( t ` x ) ) <_ c <->
                  E. d e. RR A. t e. T ( ( U normOpOLD W ) ` t ) <_ d ) ) $=
        ( cle vz vu vy vr vn vm vk cv cfv wbr wral cr wrex cnmoo co wceq fveq2d
        fveq1 breq1d cbvralv breq2 ralbidv syl5bb cbvrexv fveq2 rexralbidv crab
        wa cmpt wss crp cblo adantr simpr sylib cbvrabv rabbidv syl5eq ubthlem1
        cn cbvmptv wcel ad3antrrr ad2antrr simplrl simplrr simprl ubthlem2 expr
        simprr rexlimdva rexlimdvva mpd syl5bir cnmcv cmul ccbn bnnv ax-mp eqid
        ex cnv nvcl mpan remulcl syl2an wf sselda adantlr ad2ant2r blof mp3an12
        cba syl simplr ffvelrnd cxr cmnf clt simpllr nmogtmnf syl22anc ad2antlr
        nmoxr xrre syl2anc nmblolbi cc0 nvge0 jca lemul1a syl31anc letrd rspcev
        ralimdva ee12an ralrimdva impbid ) ABUHZCUHZUIZHUIZKUHZTUJZCEUKZKULUMZB
        JUKZYTFIUNUOZUIZLUHZTUJZCEUKZLULUMZUUGUAUHZUBUHZUIZHUIZUUJTUJZUBEUKZLUL
        UMZUAJUKZAUUMUUTUUFUABJUUTUUNYTUIZHUIZUUCTUJZCEUKZKULUMUUNYSUPZUUFUUSUV
        ELKULUUSUVCUUJTUJZCEUKUUJUUCUPZUVEUURUVGUBCEUUOYTUPZUUQUVCUUJTUVIUUPUVB
        HUUNUUOYTURUQUSUTUVHUVGUVDCEUUJUUCUVCTVAVBVCVDUVFUVDUUDKCULEUVFUVCUUBUU
        CTUVFUVBUUAHUUNYSYTVEUQUSVFVCUTZAUVAUUMAUVAVHZUCUHZUUNDUOUDUHZTUJUAJVGU
        EUHZUFVTUUJUUOUIZHUIZUFUHZTUJZUBEUKZLJVGZVIZUIVJZUDVKUMZUCJUMUEVTUMUUMU
        VKBUCUACUWADEFUGUEGHIJUDKMNOPQRAEFIVLUOZVJZUVASVMUVKUVAUUGAUVAVNUVJVOZU
        FUGVTUVTUVCUGUHZTUJZCEUKZUAJVGZUVQUWGUPZUVTUVCUVQTUJZCEUKZUAJVGUWJUVSUW
        MLUAJUVSUUJYTUIZHUIZUVQTUJZCEUKUUJUUNUPZUWMUVRUWPUBCEUVIUVPUWOUVQTUVIUV
        OUWNHUUJUUOYTURUQUSUTUWQUWPUWLCEUWQUWOUVCUVQTUWQUWNUVBHUUJUUNYTVEUQUSVB
        VCVPUWKUWMUWIUAJUWKUWLUWHCEUVQUWGUVCTVAVBVQVRWAZVSUVKUWCUUMUEUCVTJUVKUV
        NVTWBZUVLJWBZVHZVHZUWBUUMUDVKUXBUVMVKWBZUWBUUMUXBUXCUWBVHZVHBUACUWADUVL
        UVMEFUGGUVNHIJKLMNOPQRAUWEUVAUXAUXDSWCUVKUUGUXAUXDUWFWDUWRUVKUWSUWTUXDW
        EUVKUWSUWTUXDWFUXBUXCUWBWGUXBUXCUWBWJWHWIWKWLWMXAWNAUULUUGLULAUUJULWBZV
        HZUULUUFBJUXFYSJWBZVHZUUJYSFWOUIZUIZWPUOZULWBZUULUUBUXKTUJZCEUKZUUFUXFU
        XEUXJULWBZUXLUXGAUXEVNFXBWBZUXGUXOFWQWBUXPQFWRWSZYSFUXIJMUXIWTZXCXDZUUJ
        UXJXEXFZUXHUUKUXMCEUXHYTEWBZUUKUXMUXHUYAUUKVHZVHZUUBUUIUXJWPUOZUXKUYCUU
        AIXMUIZWBZUUBULWBZUYCJUYEYSYTUYCYTUWDWBZJUYEYTXGZUXFUYAUYHUXGUUKAUYAUYH
        UXEAEUWDYTSXHXIXJZUXPIXBWBZUYHUYIUXQRUWDYTFIJUYEMUYEWTZUWDWTZXKXLXNZUXF
        UXGUYBXOZXPUYKUYFUYGRUUAIHUYEUYLNXCXDXNUYCUUIULWBZUXOUYDULWBUYCUUIXQWBZ
        UXEXRUUIXSUJZUUKUYPUYCUYIUYQUYNUXPUYKUYIUYQUXQRYTFUUHIJUYEMUYLUUHWTZYDX
        LXNAUXEUXGUYBXTZUYCUYIUYRUYNUXPUYKUYIUYRUXQRYTFUUHIJUYEMUYLUYSYAXLXNUXH
        UYAUUKWJZUUIUUJYEYBZUXGUXOUXFUYBUXSYCUUIUXJXEYFUXHUXLUYBUXTVMUYCUYHUXGU
        UBUYDTUJUYJUYOYSUWDYTFUXIHUUHIJMUXRNUYSUYMUXQRYGYFUYCUYPUXEUXOYHUXJTUJZ
        VHZUUKUYDUXKTUJVUBUYTUXGVUDUXFUYBUXGUXOVUCUXSUXPUXGVUCUXQYSFUXIJMUXRYIX
        DYJYCVUAUUIUUJUXJYKYLYMWIYOUUEUXNKUXKULUUCUXKUPUUDUXMCEUUCUXKUUBTVAVBYN
        YPYQWKYR $.
    $}

    ubth.3 $e |- M = ( U normOpOLD W ) $.
    $( Uniform Boundedness Theorem, also called the Banach-Steinhaus Theorem.
       Let ` T ` be a collection of bounded linear operators on a Banach
       space.  If, for every vector ` x ` , the norms of the operators' values
       are bounded, then the operators' norms are also bounded.  Theorem 4.7-3
       of [Kreyszig] p. 249.  See also
       ~ http://en.wikipedia.org/wiki/Uniform_boundedness_principle .
       (Contributed by NM, 7-Nov-2007.)  (Proof shortened by Mario Carneiro,
       11-Jan-2014.)  (New usage is discouraged.) $)
    ubth $p |- ( ( U e. CBan /\ W e. NrmCVec /\ T C_ ( U BLnOp W ) ) ->
                 ( A. x e. X E. c e. RR A. t e. T ( N ` ( t ` x ) ) <_ c <->
                   E. d e. RR A. t e. T ( M ` t ) <_ d ) ) $=
      ( cblo co cfv cle wbr wral cr ccbn wcel cnv wss cv wrex wb caddc cmul cop
      wi cabs cif cba cnmoo cnmcv wceq oveq1 sseq2d fveq2 syl5eq raleqdv fveq1d
      breq1d rexralbidv bibi12d imbi12d oveq2 ralbidv cims cmopn elimel elimnvu
      eqid cnbn id ubthlem3 dedth2h 3impia ) DUAUBZGUCUBZCDGNOZUDZAUEBUEZPZFPZI
      UEZQRZBCSITUFZAHSZWDEPZJUEZQRZBCSJTUFZUGZVTWAWCWOUKCVTDUHUIUJULUJZUMZGNOZ
      UDZWIAWQUNPZSZWDWQGUOOZPZWLQRZBCSJTUFZUGZUKCWQWAGWPUMZNOZUDZWEXGUPPZPZWGQ
      RZBCSITUFZAWTSZWDWQXGUOOZPZWLQRZBCSJTUFZUGZUKDGWPWPDWQUQZWCWSWOXFXTWBWRCD
      WQGNURUSXTWJXAWNXEXTWIAHWTXTHDUNPWTKDWQUNUTVAVBXTWMXDJBTCXTWKXCWLQXTWDEXB
      XTEDGUOOXBMDWQGUOURVAVCVDVEVFVGGXGUQZWSXIXFXSYAWRXHCGXGWQNVHUSYAXAXNXEXRY
      AWIXMAWTYAWHXLIBTCYAWFXKWGQYAWEFXJYAFGUPPXJLGXGUPUTVAVCVDVEVIYAXDXQJBTCYA
      XCXPWLQYAWDXBXOGXGWQUOVHVCVDVEVFVGXIABWQVJPZCWQYBVKPZXJXGWTIJWTVNXJVNYBVN
      YCVNDWPUAWPWPVNVOVLGVMXIVPVQVRVS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Minimizing Vector Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j n x y F $.  $d k n w x y J $.  $d y K $.  $d y L $.  $d f j w x y M $.
    $d f j w x y N $.  $d f j k n w x y ph $.  $d w x R $.  $d f k n w x y S $.
    $d f j k n w x y A $.  $d f j k n w x y D $.  $d w x y U $.  $d w x y W $.
    $d n T $.  $d j k n w x X $.  $d f j k n w x y Y $.
    minveco.x $e |- X = ( BaseSet ` U ) $.
    minveco.m $e |- M = ( -v ` U ) $.
    minveco.n $e |- N = ( normCV ` U ) $.
    minveco.y $e |- Y = ( BaseSet ` W ) $.
    minveco.u $e |- ( ph -> U e. CPreHilOLD ) $.
    minveco.w $e |- ( ph -> W e. ( ( SubSp ` U ) i^i CBan ) ) $.
    minveco.a $e |- ( ph -> A e. X ) $.
    ${
      minveco.d $e |- D = ( IndMet ` U ) $.
      minveco.j $e |- J = ( MetOpen ` D ) $.
      minveco.r $e |- R = ran ( y e. Y |-> ( N ` ( A M y ) ) ) $.
      $( Lemma for ~ minveco .  The set of all distances from points of ` Y `
         to ` A ` are a nonempty set of nonnegative reals.  (Contributed by
         Mario Carneiro, 8-May-2014.)  (New usage is discouraged.) $)
      minvecolem1 $p |- ( ph ->
                         ( R C_ RR /\ R =/= (/) /\ A. w e. R 0 <_ w ) ) $=
        ( cr wss c0 wne cc0 cv cle wbr wral co cfv cmpt crn wf wcel wa cnv phnv
        ccphlo syl adantr css ccbn elin sylib simpld sspba syl2anc sselda nvmcl
        cin eqid syl3anc nvcl fmptd frn syl5eqss cdm cn0v simprd bnnv 3syl fvex
        dmmpti syl6eleqr ne0i wceq dm0rn0 eqeq1i bitr4i necon3bii ralrimiva cvv
        nvzcl nvge0 wb rgenw breq2 ralrnmpt ax-mp sylibr raleqi 3jca ) AFUDUEFU
        FUGZUHCUIZUJUKZCFULZAFBMDBUIZIUMZJUNZUOZUPZUDUCAMUDXNUQXOUDUEABMXMUDXNA
        XKMURZUSZGUTURZXLLURZXMUDURAXRXPAGVBURXRRGVAVCZVDZXQXRDLURZXKLURXSYAAYB
        XPTVDAMLXKAXRKGVEUNZURZMLUEXTAYDKVFURZAKYCVFVNURYDYEUSSKYCVFVGVHZVIGYCK
        LMNQYCVOVJVKVLDXKGILNOVMVPZXLGJLNPVQVKXNVOZVRMUDXNVSVCVTAXNWAZUFUGZXGAK
        WBUNZYIURYJAYKMYIAYEKUTURYKMURAYDYEYFWCKWDKMYKQYKVOWQWEBMXMXNXLJWFZYHWG
        WHYIYKWIVCYIUFFUFYIUFWJXOUFWJFUFWJXNWKFXOUFUCWLWMWNVHAXICXOULZXJAUHXMUJ
        UKZBMULZYMAYNBMXQXRXSYNYAYGXLGJLNPWRVKWOXMWPURZBMULYMYOWSYPBMYLWTXIYNBC
        MXMXNWPYHXHXMUHUJXAXBXCXDXICFXOUCXEXDXF $.

      minveco.s $e |- S = sup ( R , RR , `' < ) $.
      ${
        minvecolem2.1 $e |- ( ph -> B e. RR ) $.
        minvecolem2.2 $e |- ( ph -> 0 <_ B ) $.
        minvecolem2.3 $e |- ( ph -> K e. Y ) $.
        minvecolem2.4 $e |- ( ph -> L e. Y ) $.
        minvecolem2.5 $e |- ( ph -> ( ( A D K ) ^ 2 ) <_ ( ( S ^ 2 ) + B ) ) $.
        minvecolem2.6 $e |- ( ph -> ( ( A D L ) ^ 2 ) <_ ( ( S ^ 2 ) + B ) ) $.
        $( Lemma for ~ minveco .  Any two points ` K ` and ` L ` in ` Y ` are
           close to each other if they are close to the infimum of distance to
           ` A ` .  (Contributed by Mario Carneiro, 9-May-2014.)
           (New usage is discouraged.) $)
        minvecolem2 $p |- ( ph -> ( ( K D L ) ^ 2 ) <_ ( 4 x. B ) ) $=
          ( vx vw co c2 cexp c4 cmul cle wbr caddc c1 cdiv cpv cfv cns wcel 4re
          cr clt ccnv csup wss c0 wne cv wral cc0 minvecolem1 simp1d simp2d 0re
          wrex simp3d wceq breq1 ralbidv rspcev sylancr infmrcl syl3anc resqcld
          syl5eqel remulcl cme cnv ccphlo phnv syl imsmet css ccbn inss1 sseldi
          cin eqid sspba syl2anc sseldd metcl readdcld cc ax-1cn syl22anc nvgcl
          eqeltrrd nvmcl wb a1i mpbird fveq2d wa pm3.2i lemul2 mp3an3 mpbid 2re
          2pos 2cn oveq1i syl6eq syl13anc eqtr3d oveq12d oveq1d imsdval 3eqtr4d
          recnd halfcl mp1i sspgval sspnv sspsval nvscl nvcl infmrgelb syl31anc
          syl6breqr cmpt crn oveq2 eqeq2d sylancl fvex sylibr syl6eleqr infmrlb
          elrnmpti syl5eqbr le2sq2 4pos leadd1dd le2addd 2timesd breqtrrd sqmul
          phpar2 sq2 cabs nvs ltleii absid mp2an nvmdi 2ne0 recidi nvsid syl5eq
          nv2 nvsass nvaddsub4 syl122anc 3eqtr2d metsym nvnnncan1 2t2e4 mulassd
          oveq2d syl5eqr 3brtr4d letrd 4cn adddid breqtrd leadd2d ) AJKEUPZUQUR
          UPZUSDUTUPZVAVBUSGUQURUPZUTUPZUWSVCUPZUXBUWTVCUPZVAVBAUXCUSUXADVCUPZU
          TUPZUXDVAAUXCUSCVDUQVEUPZJKHVFVGZUPZHVHVGZUPZLUPZMVGZUQURUPZUTUPZUWSV
          CUPZUXFAUXBUWSAUSVKVIZUXAVKVIZUXBVKVIVJAGAGFVKVLVMVNZVKUGAFVKVOZFVPVQ
          ZUNVRZUOVRZVAVBZUOFVSZUNVKWEZUXSVKVIAUXTUYAVTUYCVAVBZUOFVSZABUOCEFHIL
          MNOPQRSTUAUBUCUDUEUFWAZWBZAUXTUYAUYHUYIWCZAVTVKVIZUYHUYFWDAUXTUYAUYHU
          YIWFZUYEUYHUNVTVKUYBVTWGUYDUYGUOFUYBVTUYCVAWHWIWJWKZUNUOFWLWMWOZWNZUS
          UXAWPWKZAUWRAEOWQVGVIZJOVIZKOVIZUWRVKVIAHWRVIZUYRAHWSVIZVUAUAHWTXAZEH
          OQUDXBXAZAPOJAVUANHXCVGZVIZPOVOVUCAVUEXDXGVUENVUEXDXEUBXFZHVUENOPQTVU
          EXHZXIXJZUJXKZAPOKVUIUKXKZJKEOXLWMWNZXMAUXOUWSAUXQUXNVKVIZUXOVKVIVJAU
          XMAVUAUXLOVIZUXMVKVIZVUCAVUACOVIZUXKOVIZVUNVUCUCAPOUXKVUIAUXGUXINVHVG
          ZUPZUXKPAVUAVUFUXGXNVIZUXIPVIZVUSUXKWGVUCVUGVDXNVIVUTAXOVDUUAUUBZAJKN
          VFVGZUPZUXIPAVUAVUFJPVIZKPVIZVVDUXIWGVUCVUGUJUKJKHVVCUXHVUENPTUXHXHZV
          VCXHZVUHUUCXPANWRVIZVVEVVFVVDPVIAVUAVUFVVIVUCVUGHVUENVUHUUDXJZUJUKJKN
          VVCPTVVHXQWMXRZUXGUXIVURUXJHVUENPTUXJXHZVURXHZVUHUUEXPAVVIVUTVVAVUSPV
          IVVJVVBVVKUXGUXIVURNPTVVMUUFWMXRZXKZCUXKHLOQRXSWMZUXLHMOQSUUGXJZWNZUS
          UXNWPWKZVULXMAUXQUXEVKVIZUXFVKVIVJAUXADUYPUHXMZUSUXEWPWKAUXBUXOUWSUYQ
          VVSVULAUXAUXNVAVBZUXBUXOVAVBZAGVKVIVTGVAVBVUOGUXMVAVBVWBUYOAVTUXSGVAA
          VTUXSVAVBZUYHUYMAUXTUYAUYFUYLVWDUYHXTUYJUYKUYNUYLAWDYAUNUOUOFVTUUHUUI
          YBUGUUJVVQAGUXSUXMVAUGAUXTUYFUXMFVIUXSUXMVAVBUYJUYNAUXMBPCBVRZLUPZMVG
          ZUUKZUULZFAUXMVWGWGZBPWEZUXMVWIVIAUXKPVIUXMUXMWGZVWKVVNUXMXHVWJVWLBUX
          KPVWEUXKWGZVWGUXMUXMVWMVWFUXLMVWEUXKCLUUMYCUUNWJUUOBPVWGUXMVWHVWHXHVW
          FMUUPUUTUUQUFUURUNUOUXMFUUSWMUVAGUXMUVBXPAUXRVUMVWBVWCXTZUYPVVRUXRVUM
          UXQVTUSVLVBZYDVWNUXQVWOVJUVCYEUXAUXNUSYFYGXJYHUVDAUQCJEUPZUQURUPZCKEU
          PZUQURUPZVCUPZUTUPZUQUQUXEUTUPZUTUPZUXPUXFVAAVWTVXBVAVBZVXAVXCVAVBZAV
          WTUXEUXEVCUPVXBVAAVWQVWSUXEUXEAVWPAUYRVUPUYSVWPVKVIVUDUCVUJCJEOXLWMWN
          ZAVWRAUYRVUPUYTVWRVKVIVUDUCVUKCKEOXLWMWNZVWAVWAULUMUVEAUXEAUXEVWAYTZU
          VFUVGAVWTVKVIZVXBVKVIZVXDVXEXTZAVWQVWSVXFVXGXMAUQVKVIZVVTVXJYIVWAUQUX
          EWPWKVXIVXJVXLVTUQVLVBZYDVXKVXLVXMYIYJYEVWTVXBUQYFYGXJYHACJLUPZCKLUPZ
          UXHUPZMVGZUQURUPZVXNVXOLUPZMVGZUQURUPZVCUPZUQVXNMVGZUQURUPZVXOMVGZUQU
          RUPZVCUPZUTUPZUXPVXAAVUBVXNOVIZVXOOVIZVYBVYHWGUAAVUAVUPUYSVYIVUCUCVUJ
          CJHLOQRXSWMAVUAVUPUYTVYJVUCUCVUKCKHLOQRXSWMVXNVXOHUXHLMOQVVGRSUVIWMAU
          XOVXRUWSVYAVCAUQUXMUTUPZUQURUPZUXOVXRAVYLUQUQURUPZUXNUTUPZUXOAUQXNVIZ
          UXMXNVIVYLVYNWGYKAUXMVVQYTUQUXMUVHWKVYMUSUXNUTUVJYLYMAVYKVXQUQURAUQUX
          LUXJUPZMVGZVYKVXQAVYQUQUVKVGZUXMUTUPZVYKAVUAVYOVUNVYQVYSWGVUCVYOAYKYA
          ZVVPUQUXLUXJHMOQVVLSUVLWMVYRUQUXMUTVXLVTUQVAVBVYRUQWGYIVTUQWDYIYJUVMU
          QUVNUVOYLYMAVYPVXPMAVYPUQCUXJUPZUQUXKUXJUPZLUPZCCUXHUPZUXILUPZVXPAVUA
          VYOVUPVUQVYPWUCWGVUCVYTUCVVOUQCUXKUXJHLOQRVVLUVPYNAWUDWUAUXIWUBLAVUAV
          UPWUDWUAWGVUCUCCUXJHUXHOQVVGVVLUWAXJAUQUXGUTUPZUXIUXJUPZUXIWUBAWUGVDU
          XIUXJUPZUXIWUFVDUXIUXJUQYKUVQUVRYLAVUAUXIOVIZWUHUXIWGVUCAVUAUYSUYTWUI
          VUCVUJVUKJKHUXHOQVVGXQWMZUXIUXJHOQVVLUVSXJUVTAVUAVYOVUTWUIWUGWUBWGVUC
          VYTVVBWUJUQUXGUXIUXJHOQVVLUWBYNYOYPAVUAVUPVUPUYSUYTWUEVXPWGVUCUCUCVUJ
          VUKCCJKHUXHLOQVVGRUWCUWDUWEYCYOYQYOAUWRVXTUQURAKJEUPZKJLUPZMVGZUWRVXT
          AVUAUYTUYSWUKWUMWGVUCVUKVUJKJEHLMOQRSUDYRWMAUYRUYSUYTUWRWUKWGVUDVUJVU
          KJKEOUWFWMAVXSWULMAVUAVUPUYSUYTVXSWULWGVUCUCVUJVUKCJKHLOQRUWGYNYCYSYQ
          YPAVWTVYGUQUTAVWQVYDVWSVYFVCAVWPVYCUQURAVUAVUPUYSVWPVYCWGVUCUCVUJCJEH
          LMOQRSUDYRWMYQAVWRVYEUQURAVUAVUPUYTVWRVYEWGVUCUCVUKCKEHLMOQRSUDYRWMYQ
          YPUWJYSAUXFUQUQUTUPZUXEUTUPVXCWUNUSUXEUTUWHYLAUQUQUXEVYTVYTVXHUWIUWKU
          WLUWMAUSUXADUSXNVIAUWNYAAUXAUYPYTADUHYTUWOUWPAUWSUWTUXBVULAUXQDVKVIUW
          TVKVIVJUHUSDWPWKUYQUWQYB $.
      $}

      ${
        minveco.f $e |- ( ph -> F : NN --> Y ) $.
        minveco.1 $e |- ( ( ph /\ n e. NN ) ->
            ( ( A D ( F ` n ) ) ^ 2 ) <_ ( ( S ^ 2 ) + ( 1 / n ) ) ) $.
        $( Lemma for ~ minveco .  The sequence formed by taking elements
           successively closer to the infimum is Cauchy.  (Contributed by Mario
           Carneiro, 8-May-2014.)  (New usage is discouraged.) $)
        minvecolem3 $p |- ( ph -> F e. ( Cau ` D ) ) $=
          ( vj vx vw cca cfv wcel cv co clt wbr cuz wral cn wrex crp wa c4 cexp
          c2 cdiv cfl c1 caddc cr cc0 cle cn0 4pos elrpii simpr rpexpcl sylancl
          4re rpdivcl sylancr rprege0 flge0nn0 nn0p1nn 4syl cmul cme ccphlo cnv
          cz 2z phnv imsmet 3syl ad2antrr wss css syl ccbn cin inss1 eqid sspba
          sseldi syl2anc adantr ffvelrnd sseldd nnuz uztrn2 sylan metcl syl3anc
          resqcld nnrpd rpreccld rpmulcl rpge0d ffvelrnda syldan ralrimiva wceq
          wf rpred fveq2 oveq2d oveq1d oveq2 breq12d wne w3a rspcev readdcld wb
          cc rpcnne0 mpbird eqidd rspcv sylc ccnv csup c0 minvecolem1 0re breq1
          ralbidv mpan 3anim3i infmrcl syl5eqel nnrecred eluzle adantl rpregt0d
          adantlr nngt0 jca lerec mpbid leadd2dd letrd minvecolem2 ax-mp recdiv
          flltp1 eqbrtrd ltrec1d pm3.2i ltmuldiv2 mp3an3 lelttrd ad2antlr lt2sq
          nnre metge0 syl21anc breq1d raleqbidv cxmt imsxmet 1z a1i fss iscauf
          ) AIDULUMUNUIUOZIUMZHUOZIUMZDUPZUJUOZUQURZHUWHUSUMZUTZUIVAVBZUJVCUTAU
          WQUJVCAUWMVCUNZVDZVEUWMVGVFUPZVHUPZVIUMZVJVKUPZVAUNZUXCIUMZUWKDUPZUWM
          UQURZHUXCUSUMZUTZUWQUWSUXAVCUNZUXAVLUNZVMUXAVNURVDUXBVOUNUXDUWSVEVCUN
          ZUWTVCUNZUXJVEWAVPVQZUWSUWRVGWLUNUXMAUWRVRWMUWMVGVSVTZVEUWTWBWCZUXAWD
          UXAWEUXBWFWGZUWSUXGHUXHUWSUWJUXHUNZVDZUXGUXFVGVFUPZUWTUQURZUXSUXTVEVJ
          UXCVHUPZWHUPZUWTUXSUXFUXSDNWIUMUNZUXENUNZUWKNUNZUXFVLUNZAUYDUWRUXRAGW
          JUNZGWKUNZUYDTGWNZDGNPUCWOWPWQZUXSONUXEAONWRZUWRUXRAUYIMGWSUMZUNUYLAU
          YHUYITUYJWTAUYMXAXBZUYMMUYMXAXCUAXFGUYMMNOPSUYMXDXEXGZWQZUXSVAOUXCIAV
          AOIYEZUWRUXRUGWQZUWSUXDUXRUXQXHZXIZXJZUXSONUWKUYPUXSVAOUWJIUYRUWSUXDU
          XRUWJVAUNZUXQVJUWJUXCVAXKXLXMZXIXJZUXEUWKDNXNXOZXPUXSUYCUXSUXLUYBVCUN
          ZUYCVCUNUXNUXSUXCUXSUXCUYSXQZXRVEUYBXSWCYFUXSUWTUWSUXMUXRUXOXHZYFZUXS
          BCUYBDEFGJUXEUWKKLMNOPQRSAUYHUWRUXRTWQAMUYNUNUWRUXRUAWQACNUNZUWRUXRUB
          WQZUCUDUEUFUXSUYBUWSVUFUXRUWSUXCUWSUXCUXQXQXRXHZYFZUXSUYBVULXTUYTUWSU
          XRVUBUWKOUNVUCUWSVAOUWJIAUYQUWRUGXHYAYBZUXSUXDCUWKDUPZVGVFUPZFVGVFUPZ
          VJUWJVHUPZVKUPZVNURZHVAUTZCUXEDUPZVGVFUPZVUQUYBVKUPZVNURZUYSAVVAUWRUX
          RAVUTHVAUHYCWQVUTVVEHUXCVAUWJUXCYDZVUPVVCVUSVVDVNVVFVUOVVBVGVFVVFUWKU
          XECDUWJUXCIYGYHYIVVFVURUYBVUQVKUWJUXCVJVHYJYHYKUUAUUBUXSVUPVUSVVDUXSV
          UOUXSUYDVUJUYFVUOVLUNUYKVUKUXSONUWKUYPVUNXJCUWKDNXNXOXPUXSVUQVURAVUQV
          LUNUWRUXRAFAFEVLUQUUCUUDZVLUFAEVLWRZEUUEYLZVMUKUOZVNURZUKEUTZYMVVHVVI
          UWMVVJVNURZUKEUTZUJVLVBZYMVVGVLUNABUKCDEGJKLMNOPQRSTUAUBUCUDUEUUFVVLV
          VOVVHVVIVMVLUNVVLVVOUUGVVNVVLUJVMVLUWMVMYDVVMVVKUKEUWMVMVVJVNUUHUUIYN
          UUJUUKUJUKEUULWPUUMXPWQZUXSUWJVUCUUNZYOUXSVUQUYBVVPVUMYOUWSUXRVUBVUTV
          UCAVUBVUTUWRUHUURYBUXSVURUYBVUQVVQVUMVVPUXSUXCUWJVNURZVURUYBVNURZUXRV
          VRUWSUXCUWJUUOUUPUXSUXCVLUNVMUXCUQURVDUWJVLUNZVMUWJUQURZVDZVVRVVSYPUX
          SUXCVUGUUQUXSVUBVWBVUCVUBVVTVWAUWJUVQUWJUUSUUTWTUXCUWJUVAXGUVBUVCUVDU
          VEUXSUYCUWTUQURZUYBUWTVEVHUPZUQURZUXSVWDUXCUXSUXMUXLVWDVCUNVUHUXNUWTV
          EWBVTVUGUXSVJVWDVHUPZUXAUXCUQUXSUWTYQUNUWTVMYLVDZVEYQUNVEVMYLVDZVWFUX
          AYDUXSUXMVWGVUHUWTYRWTUXLVWHUXNVEYRUVFUWTVEUVGVTUXSUXKUXAUXCUQURUXSUX
          AUWSUXJUXRUXPXHYFUXAUVHWTUVIUVJUXSUYBVLUNZUWTVLUNZVWCVWEYPZVUMVUIVWIV
          WJVEVLUNZVMVEUQURZVDVWKVWLVWMWAVPUVKUYBUWTVEUVLUVMXGYSUVNUXSUYGVMUXFV
          NURZUWMVLUNVMUWMVNURVDZUXGUYAYPVUEUXSUYDUYEUYFVWNUYKVUAVUDUXEUWKDNUVR
          XOUWRVWOAUXRUWMWDUVOUXFUWMUVPUVSYSYCUWPUXIUIUXCVAUWHUXCYDZUWNUXGHUWOU
          XHUWHUXCUSYGVWPUWLUXFUWMUQVWPUWIUXEUWKDUWHUXCIYGYIUVTUWAYNXGYCAUJUWKU
          WIDUIHIVJNVAXKAUYHUYIDNUWBUMUNTUYJDGNPUCUWCWPVJWLUNAUWDUWEAVUBVDUWKYT
          AUWHVAUNVDUWIYTAUYQUYLVANIYEUGUYOVAONIUWFXGUWGYS $.

        $( Lemma for ~ minveco . ` F ` is convergent in the subspace topology
           on ` Y ` .  (Contributed by Mario Carneiro, 7-May-2014.)
           (New usage is discouraged.) $)
        minvecolem4a $p |- ( ph -> F
                      ( ~~>t ` ( MetOpen ` ( D |` ( Y X. Y ) ) ) )
                      ( ( ~~>t ` ( MetOpen ` ( D |` ( Y X. Y ) ) ) ) ` F ) ) $=
          ( cxp cres cmopn cfv clm cdm wcel wbr cba cms cca cims cnv css ccphlo
          wceq phnv syl ccbn cin wa elin sylib simpld eqid sspims simprd cbncms
          syl2anc eqeltrrd minvecolem3 cxmt cn wf cme imsmet 3syl metxmet causs
          wb mpbid cmetcau cha wfun xmetres methaus lmfun funfvbrb ) AIDOOUIUJZ
          UKULZUMULZUNUOZIIWSULWSUPZAWQMUQULZURULZUOIWQUSULUOZWTAMUTULZWQXCAGVA
          UOZMGVBULZUOZXEWQVDAGVCUOZXFTGVEZVFAXHMVGUOZAMXGVGVHUOXHXKVIUAMXGVGVJ
          VKZVLXEDGXGMOSUCXEVMZXGVMVNVQAXKXEXCUOAXHXKXLVOXEMXBXBVMXMVPVFVRAIDUS
          ULUOZXDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHVSADNVTULUOZWAOIWBXNXDWHAD
          NWCULUOZXOAXIXFXPTXJDGNPUCWDWEDNWFVFZUGDINOWGVQWIWQIWRXBWRVMZWJVQAWRW
          KUOZWSWLWTXAWHAXOWQNOVHZVTULUOXSXQDONWMWQWRXTXRWNWEWRWOIWSWPWEWI $.

        $( Lemma for ~ minveco .  The convergent point of the cauchy sequence
           ` F ` is a member of the base space.  (Contributed by Mario
           Carneiro, 16-Jun-2014.)  (New usage is discouraged.) $)
        minvecolem4b $p |- ( ph -> ( ( ~~>t ` J ) ` F ) e. X ) $=
          ( clm cfv cnv wcel css wss ccphlo phnv syl ccbn cin elin sylib simpld
          wa eqid sspba syl2anc cxp cres wfun wbr wceq cha cxmt imsxmet methaus
          cmopn lmfun minvecolem4a crest co c1 cvv cn nnuz cba fvex eqeltri a1i
          ctop mopntop ctopon xmetres2 mopntopon lmcl cz 1z lmss metrest fveq2d
          breqd bitrd mpbird funbrfv sylc eqeltrd sseldd ) AONIJUIUJZUJZAGUKULZ
          MGUMUJZULZONUNZAGUOULXITGUPUQZAXKMURULZAMXJURUSULXKXNVCUAMXJURUTVAVBG
          XJMNOPSXJVDVEVFZAXHIDOOVGVHZVPUJZUIUJZUJZOAXGVIZIXSXGVJZXHXSVKAJVLULZ
          XTADNVMUJULZYBAXIYCXMDGNPUCVNUQZDJNUDVOUQJVQUQAYAIXSXRVJZABCDEFGHIJKL
          MNOPQRSTUAUBUCUDUEUFUGUHVRZAYAIXSJOVSVTZUIUJZVJYEAXSIJYGWAWBOWCYGVDWD
          OWBULAOMWEUJWBSMWEWFWGWHAYCJWIULYDDJNUDWJUQAXQOWKUJULZYEXSOULAXPOVMUJ
          ULZYIAYCXLYJYDXODONWLVFXPXQOXQVDZWMUQYFXSIXQOWNVFZWAWOULAWPWHUGWQAYHX
          RIXSAYGXQUIAYCXLYGXQVKYDXODXPJXQNOXPVDUDYKWRVFWSWTXAXBIXSXGXCXDYLXEXF
          $.

        $( Lemma for ~ minveco .  The infimum of the distances to ` A ` is a
           real number.  (Contributed by Mario Carneiro, 16-Jun-2014.)
           (New usage is discouraged.) $)
        minvecolem4c $p |- ( ph -> S e. RR ) $=
          ( vx vw cr clt ccnv csup wss c0 wne cv cle wral wrex wcel minvecolem1
          wbr cc0 simp1d simp2d 0re simp3d breq1 ralbidv rspcev sylancr infmrcl
          wceq syl3anc syl5eqel ) AFEUKULUMUNZUKUFAEUKUOZEUPUQZUIURZUJURZUSVDZU
          JEUTZUIUKVAZVRUKVBAVSVTVEWBUSVDZUJEUTZABUJCDEGJKLMNOPQRSTUAUBUCUDUEVC
          ZVFAVSVTWGWHVGAVEUKVBWGWEVHAVSVTWGWHVIWDWGUIVEUKWAVEVOWCWFUJEWAVEWBUS
          VJVKVLVMUIUJEVNVPVQ $.

        minveco.t $e |- T = ( 1 /
      ( ( ( ( ( A D ( ( ~~>t ` J ) ` F ) ) + S ) / 2 ) ^ 2 ) - ( S ^ 2 ) ) ) $.
        $( Lemma for ~ minveco .  The convergent point of the cauchy sequence
           ` F ` attains the minimum distance, and so is closer to ` A ` than
           any other point in ` Y ` .  (Contributed by Mario Carneiro,
           7-May-2014.)  (New usage is discouraged.) $)
        minvecolem4 $p |- ( ph -> E. x e. Y A. y e. Y
                          ( N ` ( A M x ) ) <_ ( N ` ( A M y ) ) ) $=
          ( vw clm cfv wcel co cv cle wbr wral wrex cxp cres wfun wceq cxmt cha
          cmopn ccphlo cnv phnv imsxmet methaus lmfun minvecolem4a crest c1 cvv
          3syl cn eqid nnuz cba fvex eqeltri a1i syl mopntop ctopon wss css cin
          ctop ccbn wa elin sylib simpld sspba syl2anc xmetres2 mopntopon cz 1z
          lmcl metrest fveq2d breqd bitrd mpbird funbrfv eqeltrd syl3anc adantr
          lmss sylc cr metcl clt caddc cdiv cc0 cexp crp readdcld resqcld recnd
          c2 2timesd breq1d wb 3bitr2d 0re ralbidv rspcev metge0 ad2antrr letrd
          cmul wf minvecolem4b imsdval imsmet minvecolem4c sselda nvmcl nvcl wn
          cme ltnled cfl cuz cn0 cmin rehalfcld resubcld ltadd1d 2pos ltmuldiv2
          2re pm3.2i ccnv c0 wne minvecolem1 simp3d simp1d simp2d breq1 sylancr
          csup infmrgelb syl31anc addge0d divge0 syl21anc lt2sqd posdifd 3bitrd
          syl6breqr biimpa rpreccld syl5eqel rprege0d flge0nn0 nn0p1nn breqtrrd
          elrpd rexrd simpll uztrn2 sylan fss ffvelrnda nnrecred rpred peano2re
          nnzd reflcl nnred fllep1 eluzle adantl syl5eqbrr 1re nngt0d syl122anc
          lediv23 mpbid leaddsub2d le2sqd lmle leadd2d lemuldiv2 mp3an3 biimpar
          syldan ex sylbird pm2.18d cmpt crn elrnmpt1 sylancl syl6eleqr infmrlb
          simpr syl5eqbr eqbrtrrd ralrimiva oveq2 ) AKLUMUNZUNZQUODUYMMUPZNUNZD
          CUQZMUPZNUNZURUSZCQUTZDBUQZMUPZNUNZUYRURUSZCQUTZBQVAAUYMKEQQVBVCZVHUN
          ZUMUNZUNZQAUYLVDZKVUIUYLUSZUYMVUIVEAEPVFUNUOZLVGUOVUJAIVIUOZIVJUOZVUL
          UBIVKZEIPRUEVLZVSZELPUFVMLVNVSAVUKKVUIVUHUSZACDEFGIJKLMNOPQRSTUAUBUCU
          DUEUFUGUHUIUJVOZAVUKKVUILQVPUPZUMUNZUSVURAVUIKLVUTVQVRQVTVUTWAWBQVRUO
          AQOWCUNVRUAOWCWDWEWFAVUNVULLWMUOAVUMVUNUBVUOWGZVUPELPUFWHVSAVUGQWIUNU
          OZVURVUIQUOAVUFQVFUNUOZVVCAVULQPWJZVVDVUQAVUNOIWKUNZUOZVVEVVBAVVGOWNU
          OZAOVVFWNWLUOVVGVVHWOUCOVVFWNWPWQWRIVVFOPQRUAVVFWAWSWTZEQPXAWTVUFVUGQ
          VUGWAZXBWGVUSVUIKVUGQXEWTZVQXCUOAXDWFUIXOAVVAVUHKVUIAVUTVUGUMAVULVVEV
          UTVUGVEVUQVVIEVUFLVUGPQVUFWAUFVVJXFWTXGXHXIXJZKVUIUYLXKXPZVVKXLAUYSCQ
          AUYPQUOZWOZDUYMEUPZUYOUYRURAVVPUYOVEZVVNAVUNDPUOZUYMPUOZVVQVVBUDACDEF
          GIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUUAZDUYMEIMNPRSTUEUUBXMXNVVOVVPGUYRA
          VVPXQUOZVVNAEPUUIUNUOZVVRVVSVWAAVUMVUNVWBUBVUOEIPRUEUUCVSZUDVVTDUYMEP
          XRXMZXNAGXQUOZVVNACDEFGIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUUDZXNVVOVUNUY
          QPUOZUYRXQUOAVUNVVNVVBXNZVVOVUNVVRUYPPUOVWGVWHAVVRVVNUDXNAQPUYPVVIUUE
          DUYPIMPRSUUFXMUYQINPRTUUGWTAVVPGURUSZVVNAVWIAVWIUUHGVVPXSUSZVWIAGVVPV
          WFVWDUUJAVWJVWIAVWJVVPVVPGXTUPZYHYAUPZURUSZVWIAVWJWOZEUYMDVWLJKLHUUKU
          NZVQXTUPZPVWPUULUNZVWQWAUFAVULVWJVUQXNVWNVWPVWNHXQUOZYBHURUSWOVWOUUMU
          OVWPVTUOZVWNHVWNHVQVWLYHYCUPZGYHYCUPZUUNUPZYAUPZYDUKVWNVXBVWNVXBAVXBX
          QUOZVWJAVWTVXAAVWLAVWKAVVPGVWDVWFYEZUUOZYFZAGVWFYFZUUPZXNAVWJYBVXBXSU
          SZAVWJGVWLXSUSZVXAVWTXSUSVXJAVWJGGXTUPZVWKXSUSYHGYSUPZVWKXSUSZVXKAGVV
          PGVWFVWDVWFUUQAVXMVXLVWKXSAGAGVWFYGYIYJAVWEVWKXQUOZYHXQUOZYBYHXSUSZWO
          ZVXNVXKYKVWFVXEVXRAVXPVXQUUTUURUVAZWFZGVWKYHUUSXMYLAGVWLVWFVXFAYBFXQX
          SUVBUVKZGURAYBVYAURUSZYBULUQZURUSZULFUTZAFXQWJZFUVCUVDZVYEACULDEFILMN
          OPQRSTUAUBUCUDUEUFUGUVEZUVFZAVYFVYGVUAVYCURUSZULFUTZBXQVAZYBXQUOZVYBV
          YEYKAVYFVYGVYEVYHUVGZAVYFVYGVYEVYHUVHAVYMVYEVYLYMVYIVYKVYEBYBXQVUAYBV
          EVYJVYDULFVUAYBVYCURUVIYNYOUVJZVYMAYMWFBULULFYBUVLUVMXJUHUVTZAVXOYBVW
          KURUSVXRYBVWLURUSZVXEAVVPGVWDVWFAVWBVVRVVSYBVVPURUSVWCUDVVTDUYMEPYPXM
          VYPUVNVXTVWKYHUVOUVPZUVQAVXAVWTVXHVXGUVRUVSUWAZUWHUWBUWCZUWDHUWEVWOUW
          FVSZUWRAKUYMUYLUSVWJAKVUIUYMUYLVVLVVMUWGXNAVVRVWJUDXNVWNVWLAVWLXQUOZV
          WJVXFXNUWIVWNJUQZVWQUOZWOZDWUCKUNZEUPZVWLURUSWUGYHYCUPZVWTURUSWUEWUHV
          XAVQWUCYAUPZXTUPZVWTWUEWUGWUEAWUCVTUOZWUGXQUOZAVWJWUDUWJZVWNVWSWUDWUK
          WUAVQWUCVWPVTWBUWKUWLZAWUKWOZVWBVVRWUFPUOZWULAVWBWUKVWCXNZAVVRWUKUDXN
          ZAVTPWUCKAVTQKYTVVEVTPKYTUIVVIVTQPKUWMWTUWNZDWUFEPXRXMWTZYFWUEVXAWUIW
          UEGAVWEVWJWUDVWFYQYFZWUEWUCWUNUWOZYEAVWTXQUOVWJWUDVXGYQZWUEAWUKWUHWUJ
          URUSWUMWUNUJWTWUEWUJVWTURUSWUIVXBURUSZWUEVXCWUCURUSZWVDWUEVXCHWUCURUK
          WUEHVWPWUCWUEHVWNHYDUOWUDVYTXNUWPZWUEVWRVWOXQUOVWPXQUOWVFHUWSVWOUWQVS
          WUEWUCWUNUWTZWUEVWRHVWPURUSWVFHUXAWGWUDVWPWUCURUSVWNVWPWUCUXBUXCYRUXD
          WUEVQXQUOZVXDVXJWUCXQUOYBWUCXSUSWVEWVDYKWVHWUEUXEWFAVXDVWJWUDVXIYQVWN
          VXJWUDVYSXNWVGWUEWUCWUNUXFVQVXBWUCUXHUXGUXIWUEVXAWUIVWTWVAWVBWVCUXJXJ
          YRWUEWUGVWLWUTAWUBVWJWUDVXFYQWUEAWUKYBWUGURUSZWUMWUNWUOVWBVVRWUPWVIWU
          QWURWUSDWUFEPYPXMWTAVYQVWJWUDVYRYQUXKXJUXLAVWIVWMAVWIVVPVVPXTUPZVWKUR
          USYHVVPYSUPZVWKURUSZVWMAVVPGVVPVWDVWFVWDUXMAWVKWVJVWKURAVVPAVVPVWDYGY
          IYJAVWAVXOWVLVWMYKZVWDVXEVWAVXOVXRWVMVXSVVPVWKYHUXNUXOWTYLUXPUXQUXRUX
          SUXTXNVVOGVYAUYRURUHVVOVYFVYLUYRFUOVYAUYRURUSAVYFVVNVYNXNAVYLVVNVYOXN
          VVOUYRCQUYRUYAZUYBZFVVOVVNUYRVRUOUYRWVOUOAVVNUYGUYQNWDCQUYRWVNVRWVNWA
          UYCUYDUGUYEBULUYRFUYFXMUYHYRUYIUYJVUEUYTBUYMQVUAUYMVEZVUDUYSCQWVPVUCU
          YOUYRURWVPVUBUYNNVUAUYMDMUYKXGYJYNYOWT $.
      $}

      $( Lemma for ~ minveco .  Discharge the assumption about the sequence
         ` F ` by applying countable choice ~ ax-cc .  (Contributed by Mario
         Carneiro, 9-May-2014.)  (New usage is discouraged.) $)
      minvecolem5 $p |- ( ph -> E. x e. Y A. y e. Y
                        ( N ` ( A M x ) ) <_ ( N ` ( A M y ) ) ) $=
        ( vf vn vw vk cn cv wf cfv co c2 cexp c1 cdiv caddc cle wbr wral wa wex
        wrex wcel csqr wn clt cc0 nnrecgt0 adantl nnrecre ccnv csup wss wne w3a
        cr c0 minvecolem1 adantr simp1d simp2d simp3d wceq breq1 ralbidv rspcev
        0re sylancr infmrcl syl3anc syl5eqel ltaddposd mpbid readdcld addgegt0d
        resqcld sqge0d elrpd rpge0d resqrth syl2anc breqtrrd rpsqrcld rpred a1i
        infmrgelb syl31anc mpbird syl6breqr sqrge0d lt2sqd ltnled breq2i syl5bb
        wb cmpt crn raleqi cvv fvex rgenw eqid breq2 ralrnmpt ax-mp bitri mtbid
        syl6bb rexnal syl ad2antrr ccbn breq1d oveq1d cba oveq2 oveq2d cnv phnv
        sylibr ccphlo css cin inss1 sseldi sspba sselda nvmcl nvcl letrid nvge0
        ord le2sqd notbid imsdval 3imtr4d reximdva mpd ralrimiva eqeltri nnenom
        bitrd axcc4 clm cmin simprl simprr fveq2 breq12d rspccva sylan exlimddv
        minvecolem4 ) AUJNUFUKZULZDUGUKZUVQUMZEUNZUOUPUNZGUOUPUNZUQUVSURUNZUSUN
        ZUTVAZUGUJVBZVCZDBUKZJUNKUMDCUKZJUNZKUMZUTVACNVBBNVEUFADUWJEUNZUOUPUNZU
        WEUTVAZCNVEZUGUJVBUWHUFVDAUWPUGUJAUVSUJVFZVCZUWEVGUMZUWLUTVAZVHZCNVEZUW
        PUWRUWTCNVBZVHUXBUWRUWSGUTVAZUXCUWRGUWSVIVAZUXDVHUWRUXEUWCUWSUOUPUNZVIV
        AUWRUWCUWEUXFVIUWRVJUWDVIVAZUWCUWEVIVAUWQUXGAUVSVKVLZUWRUWDUWCUWQUWDVSV
        FAUVSVMVLZUWRGUWRGFVSVIVNVOZVSUEUWRFVSVPZFVTVQZUWIUHUKZUTVAZUHFVBZBVSVE
        ZUXJVSVFUWRUXKUXLVJUXMUTVAZUHFVBZAUXKUXLUXRVRUWQACUHDEFHIJKLMNOPQRSTUAU
        BUCUDWAWBZWCZUWRUXKUXLUXRUXSWDZUWRVJVSVFZUXRUXPWJUWRUXKUXLUXRUXSWEZUXOU
        XRBVJVSUWIVJWFUXNUXQUHFUWIVJUXMUTWGWHWIWKZBUHFWLWMWNZWSZWOWPUWRUWEVSVFZ
        VJUWEUTVAUXFUWEWFZUWRUWCUWDUYFUXIWQZUWRUWEUWRUWEUYIUWRUWCUWDUYFUXIUWRGU
        YEWTUXHWRXAZXBZUWEXCXDZXEUWRGUWSUYEUWRUWSUWRUWEUYJXFXGZUWRVJUXJGUTUWRVJ
        UXJUTVAZUXRUYCUWRUXKUXLUXPUYBUYNUXRXRUXTUYAUYDUYBUWRWJXHBUHUHFVJXIXJXKU
        EXLUWRUWEUYIUYKXMZXNXKUWRGUWSUYEUYMXOWPUWRUXDUWSUXMUTVAZUHFVBZUXCUXDUWS
        UXJUTVAZUWRUYQGUXJUWSUTUEXPUWRUXKUXLUXPUWSVSVFZUYRUYQXRUXTUYAUYDUYMBUHU
        HFUWSXIXJXQUYQUYPUHCNUWLXSZXTZVBZUXCUYPUHFVUAUDYAUWLYBVFZCNVBVUBUXCXRVU
        CCNUWKKYCYDUYPUWTCUHNUWLUYTYBUYTYEUXMUWLUWSUTYFYGYHYIYKYJUWTCNYLUUCUWRU
        XAUWOCNUWRUWJNVFZVCZUWEUWLUOUPUNZUTVAZVHVUFUWEUTVAZUXAUWOVUEVUGVUHVUEUW
        EVUFUWRUYGVUDUYIWBVUEUWLVUEHUUAVFZUWKMVFZUWLVSVFAVUIUWQVUDAHUUDVFZVUISH
        UUBYMZYNZVUEVUIDMVFZUWJMVFZVUJVUMAVUNUWQVUDUAYNZUWRNMUWJANMVPZUWQAVUILH
        UUEUMZVFVUQVULAVURYOUUFZVURLVURYOUUGTUUHHVURLMNORVURYEUUIXDWBUUJZDUWJHJ
        MOPUUKWMZUWKHKMOQUULXDZWSUUMUUOVUEUWTVUGVUEUWTUXFVUFUTVAVUGVUEUWSUWLUWR
        UYSVUDUYMWBVVBUWRVJUWSUTVAVUDUYOWBVUEVUIVUJVJUWLUTVAVUMVVAUWKHKMOQUUNXD
        UUPVUEUXFUWEVUFUTUWRUYHVUDUYLWBYPUVEUUQVUEUWNVUFUWEUTVUEUWMUWLUOUPVUEVU
        IVUNVUOUWMUWLWFVUMVUPVUTDUWJEHJKMOPQUBUURWMYQYPUUSUUTUVAUVBUWOUWFCNUFUG
        UJNLYRUMYBRLYRYCUVCUVDUWJUVTWFZUWNUWBUWEUTVVCUWMUWAUOUPUWJUVTDEYSYQYPUV
        FYMAUWHVCZBCDEFGUQDUVQIUVGUMUMEUNGUSUNUOURUNUOUPUNUWCUVHUNURUNZHUIUVQIJ
        KLMNOPQRAVUKUWHSWBALVUSVFUWHTWBAVUNUWHUAWBUBUCUDUEAUVRUWGUVIVVDUWGUIUKZ
        UJVFDVVFUVQUMZEUNZUOUPUNZUWCUQVVFURUNZUSUNZUTVAZAUVRUWGUVJUWFVVLUGVVFUJ
        UVSVVFWFZUWBVVIUWEVVKUTVVMUWAVVHUOUPVVMUVTVVGDEUVSVVFUVQUVKYTYQVVMUWDVV
        JUWCUSUVSVVFUQURYSYTUVLUVMUVNVVEYEUVPUVO $.

      $( Lemma for ~ minveco .  Any minimal point is less than ` S ` away from
         ` A ` .  (Contributed by Mario Carneiro, 9-May-2014.)
         (New usage is discouraged.) $)
      minvecolem6 $p |- ( ( ph /\ x e. Y ) ->
        ( ( ( A D x ) ^ 2 ) <_ ( ( S ^ 2 ) + 0 ) <->
          A. y e. Y ( N ` ( A M x ) ) <_ ( N ` ( A M y ) ) ) ) $=
        ( vw cv wcel wa co cexp cc0 caddc cle wbr cfv wral cnv wceq ccphlo phnv
        c2 syl adantr css wss ccbn cin inss1 sseldi eqid syl2anc sselda imsdval
        sspba syl3anc oveq1d cr clt ccnv csup c0 wrex minvecolem1 simp1d simp2d
        wne w3a 0re simp3d breq1 ralbidv infmrcl syl5eqel resqcld recnd addid1d
        a1i rspcev breq12d nvmcl nvcl nvge0 infmrgelb syl31anc mpbird syl6breqr
        wb le2sqd breq2i syl5bb 3bitr2d cmpt crn raleqi cvv fvex rgenw ralrnmpt
        breq2 ax-mp bitri syl6bb ) ABUGZNUHZUIZDYDEUJZVBUKUJZGVBUKUJZULUMUJZUNU
        OZDYDJUJZKUPZUFUGZUNUOZUFFUQZYMDCUGJUJZKUPZUNUOZCNUQZYFYKYMVBUKUJZYIUNU
        OYMGUNUOZYPYFYHUUAYJYIUNYFYGYMVBUKYFHURUHZDMUHZYDMUHZYGYMUSAUUCYEAHUTUH
        UUCSHVAVCZVDZAUUDYEUAVDZANMYDAUUCLHVEUPZUHNMVFUUFAUUIVGVHUUILUUIVGVITVJ
        HUUILMNORUUIVKVOVLVMZDYDEHJKMOPQUBVNVPVQYFYIYFYIYFGYFGFVRVSVTWAZVRUEYFF
        VRVFZFWBWGZYDYNUNUOZUFFUQZBVRWCZUUKVRUHYFUULUUMULYNUNUOZUFFUQZAUULUUMUU
        RWHYEACUFDEFHIJKLMNOPQRSTUAUBUCUDWDVDZWEZYFUULUUMUURUUSWFZYFULVRUHZUURU
        UPUVBYFWIWRZYFUULUUMUURUUSWJZUUOUURBULVRYDULUSUUNUUQUFFYDULYNUNWKWLWSVL
        ZBUFFWMVPWNZWOWPWQWTYFYMGYFUUCYLMUHZYMVRUHZUUGYFUUCUUDUUEUVGUUGUUHUUJDY
        DHJMOPXAVPZYLHKMOQXBVLZUVFYFUUCUVGULYMUNUOUUGUVIYLHKMOQXCVLYFULUUKGUNYF
        ULUUKUNUOZUURUVDYFUULUUMUUPUVBUVKUURXHUUTUVAUVEUVCBUFUFFULXDXEXFUEXGXIU
        UBYMUUKUNUOZYFYPGUUKYMUNUEXJYFUULUUMUUPUVHUVLYPXHUUTUVAUVEUVJBUFUFFYMXD
        XEXKXLYPYOUFCNYRXMZXNZUQZYTYOUFFUVNUDXOYRXPUHZCNUQUVOYTXHUVPCNYQKXQXRYO
        YSCUFNYRUVMXPUVMVKYNYRYMUNXTXSYAYBYC $.

      $( Lemma for ~ minveco .  Since any two minimal points are distance zero
         away from each other, the minimal point is unique.  (Contributed by
         Mario Carneiro, 9-May-2014.)  (New usage is discouraged.) $)
      minvecolem7 $p |- ( ph -> E! x e. Y A. y e. Y
                        ( N ` ( A M x ) ) <_ ( N ` ( A M y ) ) ) $=
        ( vw cv co cfv cle wbr wral wrex wa wceq wreu minvecolem5 wcel cexp cc0
        wi c2 caddc c4 cmul ccphlo ad2antrr css ccbn cin cr 0re simplrl simplrr
        a1i simprl simprr minvecolem2 ex wb minvecolem6 adantrr adantrl anbi12d
        0le0 4cn mul01i breq2i cme cnv phnv syl adantr imsmet inss1 sseldi eqid
        wss sspba syl2anc sseldd syl3anc sqge0d biantrud resqcld letri3 sylancl
        metcl recnd sqeq0 meteq0 bitrd 3bitr2d syl5bb 3imtr3d ralrimivva fveq2d
        cc oveq2 breq1d ralbidv reu4 sylanbrc ) ADBUGZJUHZKUIZDCUGJUHKUIZUJUKZC
        NULZBNUMYIDUFUGZJUHZKUIZYGUJUKZCNULZUNZYDYJUOZVAZUFNULBNULYIBNUPABCDEFG
        HIJKLMNOPQRSTUAUBUCUDUEUQAYQBUFNNAYDNURZYJNURZUNZUNZDYDEUHVBUSUHGVBUSUH
        UTVCUHZUJUKZDYJEUHVBUSUHUUBUJUKZUNZYDYJEUHZVBUSUHZVDUTVEUHZUJUKZYOYPUUA
        UUEUUIUUAUUEUNZCDUTEFGHIYDYJJKLMNOPQRAHVFURZYTUUESVGALHVHUIZVIVJZURYTUU
        ETVGADMURYTUUEUAVGUBUCUDUEUTVKURZUUJVLVOUTUTUJUKUUJWEVOAYRYSUUEVMAYRYSU
        UEVNUUAUUCUUDVPUUAUUCUUDVQVRVSUUAUUCYIUUDYNAYRUUCYIVTYSABCDEFGHIJKLMNOP
        QRSTUAUBUCUDUEWAWBAYSUUDYNVTYRAUFCDEFGHIJKLMNOPQRSTUAUBUCUDUEWAWCWDUUIU
        UGUTUJUKZUUAYPUUHUTUUGUJVDWFWGWHUUAUUOUUOUTUUGUJUKZUNZUUGUTUOZYPUUAUUPU
        UOUUAUUFUUAEMWIUIURZYDMURZYJMURZUUFVKURUUAHWJURZUUSAUVBYTAUUKUVBSHWKWLZ
        WMEHMOUBWNWLZUUANMYDANMWRZYTAUVBLUULURUVEUVCAUUMUULLUULVIWOTWPHUULLMNOR
        UULWQWSWTWMZAYRYSVPXAZUUANMYJUVFAYRYSVQXAZYDYJEMXHXBZXCXDUUAUUGVKURUUNU
        URUUQVTUUAUUFUVIXEVLUUGUTXFXGUUAUURUUFUTUOZYPUUAUUFXRURUURUVJVTUUAUUFUV
        IXIUUFXJWLUUAUUSUUTUVAUVJYPVTUVDUVGUVHYDYJEMXKXBXLXMXNXOXPYIYNBUFNYPYHY
        MCNYPYFYLYGUJYPYEYKKYDYJDJXSXQXTYAYBYC $.
    $}

    $( Minimizing vector theorem, or the Hilbert projection theorem.  There is
       exactly one vector in a complete subspace ` W ` that minimizes the
       distance to an arbitrary vector ` A ` in a parent inner product space.
       Theorem 3.3-1 of [Kreyszig] p. 144, specialized to subspaces instead of
       convex subsets.  (Contributed by NM, 11-Apr-2008.)  (Proof shortened by
       Mario Carneiro, 9-May-2014.)  (New usage is discouraged.) $)
    minveco $p |- ( ph -> E! x e. Y A. y e. Y
                   ( N ` ( A M x ) ) <_ ( N ` ( A M y ) ) ) $=
      ( vj cfv eqid cims cv co cmpt crn cr clt ccnv csup cmopn weq oveq2 fveq2d
      cbvmptv rneqi minvecolem7 ) ABCDEUASZRJDRUBZFUCZGSZUDZUEZVBUFUGUHUIZEUQUJ
      SZFGHIJKLMNOPQUQTVDTVACJDCUBZFUCZGSZUDRCJUTVGRCUKUSVFGURVEDFULUMUNUOVCTUP
      $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                           Complex Hilbert spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Definition and basic properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CHilOLD $.

  $( Extend class notation with the class of all complex Hilbert spaces. $)
  chlo $a class CHilOLD $.

  $( Define the class of all complex Hilbert spaces.  A Hilbert space is a
     Banach space which is also an inner product space.  (Contributed by Steve
     Rodriguez, 28-Apr-2007.)  (New usage is discouraged.) $)
  df-hlo $a |- CHilOLD = ( CBan i^i CPreHilOLD ) $.

  $( The predicate "is a complex Hilbert space."  A Hilbert space is a Banach
     space which is also an inner product space, i.e. whose norm satisfies the
     parallelogram law.  (Contributed by Steve Rodriguez, 28-Apr-2007.)
     (New usage is discouraged.) $)
  ishlo $p |- ( U e. CHilOLD <-> ( U e. CBan /\ U e. CPreHilOLD ) ) $=
    ( ccbn ccphlo chlo df-hlo elin2 ) ABCDEF $.

  $( Every complex Hilbert space is a complex Banach space.  (Contributed by
     Steve Rodriguez, 28-Apr-2007.)  (New usage is discouraged.) $)
  hlobn $p |- ( U e. CHilOLD -> U e. CBan ) $=
    ( chlo wcel ccbn ccphlo ishlo simplbi ) ABCADCAECAFG $.

  $( Every complex Hilbert space is an inner product space (also called a
     pre-Hilbert space).  (Contributed by NM, 28-Apr-2007.)
     (New usage is discouraged.) $)
  hlph $p |- ( U e. CHilOLD -> U e. CPreHilOLD ) $=
    ( chlo wcel ccbn ccphlo ishlo simprbi ) ABCADCAECAFG $.

  $( The class of all complex Hilbert spaces is a relation.  (Contributed by
     NM, 17-Mar-2007.)  (New usage is discouraged.) $)
  hlrel $p |- Rel CHilOLD $=
    ( vx chlo ccbn wss wrel cv hlobn ssriv bnrel relss mp2 ) BCDCEBEABCAFGHIBCJ
    K $.

  $( Every complex Hilbert space is a normed complex vector space.
     (Contributed by NM, 17-Mar-2007.)  (New usage is discouraged.) $)
  hlnv $p |- ( U e. CHilOLD -> U e. NrmCVec ) $=
    ( chlo wcel ccbn cnv hlobn bnnv syl ) ABCADCAECAFAGH $.

  ${
    hlnvi.1 $e |- U e. CHilOLD $.
    $( Every complex Hilbert space is a normed complex vector space.
       (Contributed by NM, 6-Jun-2008.)  (New usage is discouraged.) $)
    hlnvi $p |- U e. NrmCVec $=
      ( chlo wcel cnv hlnv ax-mp ) ACDAEDBAFG $.
  $}

  ${
    hlvc.1 $e |- W = ( 1st ` U ) $.
    $( Every complex Hilbert space is a complex vector space.  (Contributed by
       NM, 7-Sep-2007.)  (New usage is discouraged.) $)
    hlvc $p |- ( U e. CHilOLD -> W e. CVecOLD ) $=
      ( chlo wcel cnv cvc hlnv nvvc syl ) ADEAFEBGEAHABCIJ $.
  $}

  ${
    hlcmet.x $e |- X = ( BaseSet ` U ) $.
    hlcmet.8 $e |- D = ( IndMet ` U ) $.
    $( The induced metric on a complex Hilbert space is complete.  (Contributed
       by NM, 8-Sep-2007.)  (New usage is discouraged.) $)
    hlcmet $p |- ( U e. CHilOLD -> D e. ( CMet ` X ) ) $=
      ( chlo wcel ccbn cms cfv hlobn cbncms syl ) BFGBHGACIJGBKABCDELM $.

    $( The induced metric on a complex Hilbert space.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlmet $p |- ( U e. CHilOLD -> D e. ( Met ` X ) ) $=
      ( chlo wcel cms cfv cme hlcmet cmetmet syl ) BFGACHIGACJIGABCDEKACLM $.
  $}

  ${
    hlpar2.1 $e |- X = ( BaseSet ` U ) $.
    hlpar2.2 $e |- G = ( +v ` U ) $.
    hlpar2.3 $e |- M = ( -v ` U ) $.
    hlpar2.6 $e |- N = ( normCV ` U ) $.
    $( The parallelogram law satified by Hilbert space vectors.  (Contributed
       by Steve Rodriguez, 28-Apr-2007.)  (New usage is discouraged.) $)
    hlpar2 $p |- ( ( U e. CHilOLD /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A M B ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      ( chlo wcel ccphlo co cfv c2 cexp caddc cmul wceq hlph phpar2 syl3an1 ) C
      LMCNMAGMBGMABDOFPQROABEOFPQROSOQAFPQROBFPQROSOTOUACUBABCDEFGHIJKUCUD $.
  $}

  ${
    hlpar.1 $e |- X = ( BaseSet ` U ) $.
    hlpar.2 $e |- G = ( +v ` U ) $.
    hlpar.4 $e |- S = ( .sOLD ` U ) $.
    hlpar.6 $e |- N = ( normCV ` U ) $.
    $( The parallelogram law satified by Hilbert space vectors.  (Contributed
       by Steve Rodriguez, 28-Apr-2007.)  (New usage is discouraged.) $)
    hlpar $p |- ( ( U e. CHilOLD /\ A e. X /\ B e. X ) ->
      ( ( ( N ` ( A G B ) ) ^ 2 ) + ( ( N ` ( A G ( -u 1 S B ) ) ) ^ 2 ) ) =
        ( 2 x. ( ( ( N ` A ) ^ 2 ) + ( ( N ` B ) ^ 2 ) ) ) ) $=
      ( chlo wcel ccphlo co cfv c2 cexp c1 caddc cneg cmul wceq phpar syl3an1
      hlph ) DLMDNMAGMBGMABEOFPQROASUABCOEOFPQROTOQAFPQROBFPQROTOUBOUCDUFABCDEF
      GHIJKUDUE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Standard axioms for a complex Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    hlex.1 $e |- X = ( BaseSet ` U ) $.
    $( The base set of a Hilbert space is a set.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlex $p |- X e. _V $=
      ( cba cfv cvv fvex eqeltri ) BADEFCADGH $.
  $}

  ${
    hladdf.1 $e |- X = ( BaseSet ` U ) $.
    hladdf.2 $e |- G = ( +v ` U ) $.
    $( Mapping for Hilbert space vector addition.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hladdf $p |- ( U e. CHilOLD -> G : ( X X. X ) --> X ) $=
      ( chlo wcel cnv cxp wf hlnv nvgf syl ) AFGAHGCCICBJAKABCDELM $.

    $( Hilbert space vector addition is commutative.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlcom $p |- ( ( U e. CHilOLD /\ A e. X /\ B e. X ) ->
                ( A G B ) = ( B G A ) ) $=
      ( chlo wcel cnv co wceq hlnv nvcom syl3an1 ) CHICJIAEIBEIABDKBADKLCMABCDE
      FGNO $.

    $( Hilbert space vector addition is associative.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlass $p |- ( ( U e. CHilOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                   ( ( A G B ) G C ) = ( A G ( B G C ) ) ) $=
      ( chlo wcel cnv w3a co wceq hlnv nvass sylan ) DIJDKJAFJBFJCFJLABEMCEMABC
      EMEMNDOABCDEFGHPQ $.
  $}

  ${
    hl0cl.1 $e |- X = ( BaseSet ` U ) $.
    hl0cl.5 $e |- Z = ( 0vec ` U ) $.
    $( The Hilbert space zero vector.  (Contributed by NM, 7-Sep-2007.)
       (New usage is discouraged.) $)
    hl0cl $p |- ( U e. CHilOLD -> Z e. X ) $=
      ( chlo wcel cnv hlnv nvzcl syl ) AFGAHGCBGAIABCDEJK $.
  $}

  ${
    hladdid.1 $e |- X = ( BaseSet ` U ) $.
    hladdid.2 $e |- G = ( +v ` U ) $.
    hladdid.5 $e |- Z = ( 0vec ` U ) $.
    $( Hilbert space addition with the zero vector.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hladdid $p |- ( ( U e. CHilOLD /\ A e. X ) -> ( A G Z ) = A ) $=
      ( chlo wcel cnv co wceq hlnv nv0rid sylan ) BIJBKJADJAECLAMBNABCDEFGHOP
      $.
  $}

  ${
    hlmulf.1 $e |- X = ( BaseSet ` U ) $.
    hlmulf.4 $e |- S = ( .sOLD ` U ) $.
    $( Mapping for Hilbert space scalar multiplication.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlmulf $p |- ( U e. CHilOLD -> S : ( CC X. X ) --> X ) $=
      ( chlo wcel cnv cc cxp wf hlnv nvsf syl ) BFGBHGICJCAKBLABCDEMN $.

    $( Hilbert space scalar multiplication by one.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlmulid $p |- ( ( U e. CHilOLD /\ A e. X ) -> ( 1 S A ) = A ) $=
      ( chlo wcel cnv c1 co wceq hlnv nvsid sylan ) CGHCIHADHJABKALCMABCDEFNO
      $.

    $( Hilbert space scalar multiplication associative law.  (Contributed by
       NM, 7-Sep-2007.)  (New usage is discouraged.) $)
    hlmulass $p |- ( ( U e. CHilOLD /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
                   ( ( A x. B ) S C ) = ( A S ( B S C ) ) ) $=
      ( chlo wcel cnv cc w3a cmul co wceq hlnv nvsass sylan ) EIJEKJALJBLJCFJMA
      BNOCDOABCDODOPEQABCDEFGHRS $.
  $}

  ${
    hldi.1 $e |- X = ( BaseSet ` U ) $.
    hldi.2 $e |- G = ( +v ` U ) $.
    hldi.4 $e |- S = ( .sOLD ` U ) $.
    $( Hilbert space scalar multiplication distributive law.  (Contributed by
       NM, 7-Sep-2007.)  (New usage is discouraged.) $)
    hldi $p |- ( ( U e. CHilOLD /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
                  ( A S ( B G C ) ) = ( ( A S B ) G ( A S C ) ) ) $=
      ( chlo wcel cnv cc w3a co wceq hlnv nvdi sylan ) EKLEMLANLBGLCGLOABCFPDPA
      BDPACDPFPQERABCDEFGHIJST $.

    $( Hilbert space scalar multiplication distributive law.  (Contributed by
       NM, 7-Sep-2007.)  (New usage is discouraged.) $)
    hldir $p |- ( ( U e. CHilOLD /\ ( A e. CC /\ B e. CC /\ C e. X ) ) ->
                  ( ( A + B ) S C ) = ( ( A S C ) G ( B S C ) ) ) $=
      ( chlo wcel cnv cc w3a caddc co wceq hlnv nvdir sylan ) EKLEMLANLBNLCGLOA
      BPQCDQACDQBCDQFQRESABCDEFGHIJTUA $.
  $}

  ${
    hlmul0.1 $e |- X = ( BaseSet ` U ) $.
    hlmul0.4 $e |- S = ( .sOLD ` U ) $.
    hlmul0.5 $e |- Z = ( 0vec ` U ) $.
    $( Hilbert space scalar multiplication by zero.  (Contributed by NM,
       7-Sep-2007.)  (New usage is discouraged.) $)
    hlmul0 $p |- ( ( U e. CHilOLD /\ A e. X ) -> ( 0 S A ) = Z ) $=
      ( chlo wcel cnv cc0 co wceq hlnv nv0 sylan ) CIJCKJADJLABMENCOABCDEFGHPQ
      $.
  $}

  ${
    hlipf.1 $e |- X = ( BaseSet ` U ) $.
    hlipf.7 $e |- P = ( .iOLD ` U ) $.
    $( Mapping for Hilbert space inner product.  (Contributed by NM,
       19-Nov-2007.)  (New usage is discouraged.) $)
    hlipf $p |- ( U e. CHilOLD -> P : ( X X. X ) --> CC ) $=
      ( chlo wcel cnv cxp cc wf hlnv ipf syl ) BFGBHGCCIJAKBLABCDEMN $.

    $( Conjugate law for Hilbert space inner product.  (Contributed by NM,
       8-Sep-2007.)  (New usage is discouraged.) $)
    hlipcj $p |- ( ( U e. CHilOLD /\ A e. X /\ B e. X ) ->
                  ( A P B ) = ( * ` ( B P A ) ) ) $=
      ( chlo wcel w3a co ccj cfv wceq cnv hlnv dipcj syl3an1 3com23 eqcomd ) DH
      IZAEIZBEIZJBACKLMZABCKZUAUCUBUDUENZUADOIUCUBUFDPBACDEFGQRST $.
  $}

  ${
    hlipdir.1 $e |- X = ( BaseSet ` U ) $.
    hlipdir.2 $e |- G = ( +v ` U ) $.
    hlipdir.7 $e |- P = ( .iOLD ` U ) $.
    $( Distributive law for Hilbert space inner product.  (Contributed by NM,
       8-Sep-2007.)  (New usage is discouraged.) $)
    hlipdir $p |- ( ( U e. CHilOLD /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A G B ) P C ) = ( ( A P C ) + ( B P C ) ) ) $=
      ( chlo wcel ccphlo w3a co caddc wceq hlph dipdir sylan ) EKLEMLAGLBGLCGLN
      ABFOCDOACDOBCDOPOQERABCDEFGHIJST $.
  $}

  ${
    hlipass.1 $e |- X = ( BaseSet ` U ) $.
    hlipass.4 $e |- S = ( .sOLD ` U ) $.
    hlipass.7 $e |- P = ( .iOLD ` U ) $.
    $( Associative law for Hilbert space inner product.  (Contributed by NM,
       8-Sep-2007.)  (New usage is discouraged.) $)
    hlipass $p |- ( ( U e. CHilOLD /\ ( A e. CC /\ B e. X /\ C e. X ) ) ->
                  ( ( A S B ) P C ) = ( A x. ( B P C ) ) ) $=
      ( chlo wcel ccphlo cc w3a co cmul wceq hlph dipass sylan ) FKLFMLANLBGLCG
      LOABEPCDPABCDPQPRFSABCDEFGHIJTUA $.
  $}

  ${
    hlipgt0.1 $e |- X = ( BaseSet ` U ) $.
    hlipgt0.5 $e |- Z = ( 0vec ` U ) $.
    hlipgt0.7 $e |- P = ( .iOLD ` U ) $.
    $( The inner product of a Hilbert space vector by itself is positive.
       (Contributed by NM, 8-Sep-2007.)  (New usage is discouraged.) $)
    hlipgt0 $p |- ( ( U e. CHilOLD /\ A e. X /\ A =/= Z ) -> 0 < ( A P A ) ) $=
      ( chlo wcel cnv wne cc0 co clt wbr hlnv cfv 3adant3 wceq cnmcv c2 cexp cr
      w3a eqid nvcl wa nvz biimpd necon3d 3impia sqgt0d ipidsq breqtrrd syl3an1
      ) CIJCKJZADJZAELZMAABNZOPCQUQURUSUEZMACUARZRZUBUCNZUTOVAVCUQURVCUDJUSACVB
      DFVBUFZUGSUQURUSVCMLUQURUHZVCMAEVFVCMTAETACVBDEFGVEUIUJUKULUMUQURUTVDTUSA
      BCVBDFVEHUNSUOUP $.
  $}

  ${
    hlcompl.1 $e |- D = ( IndMet ` U ) $.
    hlcompl.2 $e |- J = ( MetOpen ` D ) $.
    $( Completeness of a Hilbert space.  (Contributed by NM, 8-Sep-2007.)
       (Revised by Mario Carneiro, 9-May-2014.)  (New usage is discouraged.) $)
    hlcompl $p |- ( ( U e. CHilOLD /\ F e. ( Cau ` D ) ) ->
                    F e. dom ( ~~>t ` J ) ) $=
      ( chlo wcel cba cfv cms cca clm cdm eqid hlcmet cmetcau sylan ) BGHABIJZK
      JHCALJHCDMJNHABSSOEPACDSFQR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Examples of complex Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    cnhl.6 $e |- U = <. <. + , x. >. , abs >. $.
    $( The set of complex numbers is a complex Hilbert space.  (Contributed by
       Steve Rodriguez, 28-Apr-2007.)  (New usage is discouraged.) $)
    cnchl $p |- U e. CHilOLD $=
      ( chlo wcel ccbn ccphlo cnbn cncph ishlo mpbir2an ) ACDAEDAFDABGABHAIJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)
  ${
    ssphl.h $e |- H = ( SubSp ` U ) $.
    $( A Banach subspace of an inner product space is a Hilbert space.
       (Contributed by NM, 11-Apr-2008.)  (New usage is discouraged.) $)
    ssphl $p |- ( ( U e. CPreHilOLD /\ W e. H /\ W e. CBan )
        -> W e. CHilOLD ) $=
      ( ccphlo wcel ccbn w3a chlo simp3 sspph 3adant3 ishlo sylanbrc ) AEFZCBFZ
      CGFZHQCEFZCIFOPQJOPRQABCDKLCMN $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Self-adjoint operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Hellinger-Toeplitz Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w y F $.  $d w x y z K $.  $d w x y z N $.  $d w z P $.  $d w x y z W $.
    $d w x y z ph $.  $d u v w x y z T $.  $d u v w x y z U $.  $d w x y z X $.
    htth.1 $e |- X = ( BaseSet ` U ) $.
    htth.2 $e |- P = ( .iOLD ` U ) $.
    htth.3 $e |- L = ( U LnOp U ) $.
    htth.4 $e |- B = ( U BLnOp U ) $.
    ${
      htthlem.5 $e |- N = ( normCV ` U ) $.
      htthlem.6 $e |- U e. CHilOLD $.
      htthlem.7 $e |- W = <. <. + , x. >. , abs >. $.
      htthlem.8 $e |- ( ph -> T e. L ) $.
      htthlem.9 $e |- ( ph -> A. x e. X A. y e. X
                        ( x P ( T ` y ) ) = ( ( T ` x ) P y ) ) $.
      htthlem.10 $e |- F = ( z e. X |-> ( w e. X |-> ( w P ( T ` z ) ) ) ) $.
      htthlem.11 $e |- K = ( F " { z e. X | ( N ` z ) <_ 1 } ) $.
      $( Lemma for ~ htth .  The collection ` K ` , which consists of functions
         ` F ( z ) ( w ) = <. w | T ( z ) >. = <. T ( w ) | z >. ` for each
         ` z ` in the unit ball, is a collection of bounded linear functions by
         ~ ipblnfi , so by the Uniform Boundedness theorem ~ ubth , there is a
         uniform bound ` y ` on ` || F ( x ) || ` for all ` x ` in the unit
         ball.  Then ` | T ( x ) | ^ 2 = <. T ( x ) | T ( x ) >. = F ( x ) ( `
         ` T ( x ) ) <_ y | T ( x ) | ` , so ` | T ( x ) | <_ y ` and ` T ` is
         bounded.  (Contributed by NM, 11-Jan-2008.)  (Revised by Mario
         Carneiro, 23-Aug-2014.)  (New usage is discouraged.) $)
      htthlem $p |- ( ph -> T e. B ) $=
        ( wcel cnmoo co cfv cpnf clt wbr cr cv c1 cle wi wral wrex wa cnv hlnvi
        cabs lnof mp3an12 syl ffvelrnda nvcl wceq crab wfun cima cblo cmpt chlo
        wf sylancr ccphlo hlph ax-mp eqid ipblnfi fmptd ffun adantr id syl6eleq
        fvelima syl2an weq fveq2 breq1d elrab oveq2d mpteq2dv hlex mptex fveq1d
        ex fvmpt oveq1 ovex sylan9eqr ad2ant2lr rsp2 impl adantrr eqtrd cmul cc
        fveq2d simpl dipcl mp3an1 abscld mpan ad2antrl remulcld sii cc0 1re a1i
        nvge0 jca simprr lemul2a syl31anc recnd letrd syl5ibcom syld syl2anc wb
        wss mpbid ad2ant2r mpd 0re expr mulid1d breqtrd eqbrtrd fveq1 rexlimdva
        sylan2b ralrimiv breq2 ralbidv rspcev ralrimiva crn imassrn eqsstri frn
        syl5ss ccbn hlobn cnnv cnnvnm ubth simpr sylibr cdm fdm eleq2d funfvima
        biimpar sylan syldan syl6eleqr cnnvba nmblore simplr cexp adantl ipidsq
        rspcv c2 resqcl sqge0 absidd sqvald 3eqtrd nmblolbi eqbrtrrd w3a lemul1
        lemul1ad biimprd 3expia expdimp syl21anc mpid blof nmooge0 breq1 mpjaod
        wo leloe com23 ralrimdva reximdva nmobndi mpbird ltpnf isblo sylanbrc
        mp2an ) AHLUGZHIIUHUIZUJZUKULUMZHFUGZUCAUXLUNUGZUXMAUXOBUOZMUJZUPUQUMZU
        XPHUJZMUJZCUOZUQUMZURZBOUSZCUNUTZAEUOZINUHUIZUJZUYAUQUMZEKUSZCUNUTZUYEA
        UXPUYFUJZVDUJZDUOZUQUMZEKUSZDUNUTZBOUSZUYKAUYQBOAUXPOUGZVAZUXTUNUGZUYMU
        XTUQUMZEKUSZUYQUYTIVBUGZUXSOUGZVUAIUAVCZAOOUXPHAUXJOOHVQZUCVUDVUDUXJVUG
        VUFVUFHILIOOPPRVEVFVGZVHZUXSIMOPTVIVRZUYTVUBEKUYTUYFKUGZUYAJUJZUYFVJZCU
        YNMUJZUPUQUMZDOVKZUTZVUBUYTVUKVUQUYTJVLZUYFJVUPVMZUGVUQVUKAVURUYSAOINVN
        UIZJVQZVURADOEOUYFUYNHUJZGUIZVOZVUTJAUYNOUGVAVVBOUGVVDVUTUGAOOUYNHVUHVH
        EVVBVUTNGIVVDOPQIVPUGZIVSUGUAIVTWAZUBVUTWBZVVDWBWCVGUEWDZOVUTJWEVGZWFVU
        KUYFKVUSVUKWGUFWHCUYFVUPJWIWJWTUYTVUMVUBCVUPUYTUYAVUPUGZVAUXPVULUJZVDUJ
        ZUXTUQUMZVUMVUBVVJUYTUYAOUGZUYAMUJZUPUQUMZVAZVVMVUOVVPDUYAODCWKZVUNVVOU
        PUQUYNUYAMWLWMWNUYTVVQVAZVVLUXSUYAGUIZVDUJZUXTUQVVSVVKVVTVDVVSVVKUXPUYA
        HUJZGUIZVVTUYSVVNVVKVWCVJAVVPVVNUYSVVKUXPEOUYFVWBGUIZVOZUJVWCVVNUXPVULV
        WEDUYAVVDVWEOJVVREOVVCVWDVVRVVBVWBUYFGUYNUYAHWLWOWPUEEOVWDIOPWQZWRXAWSE
        UXPVWDVWCOVWEUYFUXPVWBGXBVWEWBUXPVWBGXCXAXDXEUYTVVNVWCVVTVJZVVPAUYSVVNV
        WGAVWGCOUSBOUSUYSVVNVAVWGURUDVWGBCOOXFVGXGXHXIXLVVSVWAUXTVVOXJUIZUXTVVS
        VVTUYTVUEVVNVVTXKUGZVVQVUIVVNVVPXMZVUDVUEVVNVWIVUFUXSUYAGIOPQXNXOWJXPVV
        SUXTVVOUYTVUAVVQVUJWFZVVNVVOUNUGZUYTVVPVUDVVNVWLVUFUYAIMOPTVIXQXRZXSVWK
        UYTVUEVVNVWAVWHUQUMVVQVUIVWJUXSUYAGIMOPTQVVFXTWJVVSVWHUXTUPXJUIZUXTUQVV
        SVWLUPUNUGZVUAYAUXTUQUMZVAZVVPVWHVWNUQUMVWMVWOVVSYBYCUYTVWQVVQUYTVUAVWP
        VUJUYTVUDVUEVWPVUFVUIUXSIMOPTYDZVRYEWFUYTVVNVVPYFVVOUPUXTYGYHVVSUXTVVSU
        XTVWKYIUUAUUBYJUUCUUFVUMVVLUYMUXTUQVUMVVKUYLVDUXPVULUYFUUDXLWMYKUUEYLUU
        GUYPVUCDUXTUNUYNUXTVJUYOVUBEKUYNUXTUYMUQUUHUUIUUJYMUUKAKVUTYOZUYRUYKYNZ
        AKJUULZVUTKVUSVXAUFJVUPUUMUUNAVVAVXAVUTYOVVHOVUTJUUOVGUUPIUUQUGZNVBUGZV
        WSVWTVVEVXBUAIUURWANUBUUSZBEKIUYGVDNODCPNUBUUTZUYGWBZUVAVFVGYPAUYJUYDCU
        NAUYAUNUGZVAZUYJUYCBOVXHUYSVAUXRUYJUYBVXHUYSUXRUYJUYBURVXHUYSUXRVAZVAZU
        YJUXPJUJZUYGUJZUYAUQUMZUYBVXJVXKKUGUYJVXMURVXJVXKVUSKVXJUXPVUPUGZVXKVUS
        UGZVXJVXIVXNVXHVXIUVBVUOUXRDUXPODBWKZVUNUXQUPUQUYNUXPMWLWMWNUVCAUYSVXNV
        XOURZVXGUXRAUYSUXPJUVDZUGZVXQAVXSUYSAVXROUXPAVVAVXROVJVVHOVUTJUVEVGUVFU
        VHAVURVXSVXQVVIVUPUXPJUVGUVIUVJYQYRUFUVKUYIVXMEVXKKUYFVXKVJUYHVXLUYAUQU
        YFVXKUYGWLWMUVRVGVXHUYSVXMUYBURUXRVXHUYSVXMUYBVXHUYSVXMVAZVAZYAUXTULUMZ
        UYBYAUXTVJZVYAVYBUXTUXTXJUIZUYAUXTXJUIZUQUMZUYBVYAVYDVXLUXTXJUIZVYEVYAU
        XTUXTAUYSVUAVXGVXMVUJYQZVYHXSVYAVXLUXTAUYSVXLUNUGZVXGVXMUYTVXKVUTUGZVYI
        AOVUTUXPJVVHVHZVUDVXCVYJVYIVUFVXDVUTVXKIUYGNOXKPNUBUVLZVXFVVGUVMVFVGYQZ
        VYHXSVYAUYAUXTAVXGVXTUVNZVYHXSVYAUXSVXKUJZVDUJZVYDVYGUQVYAVYPUXTUVSUVOU
        IZVDUJZVYQVYDVYAVYOVYQVDVYAVYOUXSUXSGUIZVYQAUYSVYOVYSVJVXGVXMUYTVYOUXSE
        OUYFUXSGUIZVOZUJZVYSUYTUXSVXKWUAUYSVXKWUAVJADUXPVVDWUAOJVXPEOVVCVYTVXPV
        VBUXSUYFGUYNUXPHWLWOWPUEEOVYTVWFWRXAUVPWSUYTVUEWUBVYSVJVUIEUXSVYTVYSOWU
        AUYFUXSUXSGXBWUAWBUXSUXSGXCXAVGXIYQVYAVUDVUEVYSVYQVJVUFAUYSVUEVXGVXMVUI
        YQZUXSGIMOPTQUVQVRXIXLVYAVUAVYRVYQVJVYHVUAVYQUXTUVTUXTUWAUWBVGVYAUXTVYA
        UXTVYHYIUWCUWDVYAVYJVUEVYPVYGUQUMAUYSVYJVXGVXMVYKYQWUCUXSVUTVXKIMVDUYGN
        OPTVXEVXFVVGVUFVXDUWEYMUWFVYAVXLUYAUXTVYMVYNVYHVYAVUDVUEVWPVUFWUCVWRVRZ
        VXHUYSVXMYFZUWIYJVYAVUAVXGVUAVYBVYFUYBURZURVYHVYNVYHVUAVXGVAVUAVYBWUFVU
        AVXGVUAVYBVAZWUFVUAVXGWUGUWGUYBVYFUXTUYAUXTUWHUWJUWKUWLUWMUWNVYAYAUYAUQ
        UMVYCUYBVYAYAVXLUYAYAUNUGZVYAYSYCVYMVYNVYAOXKVXKVQZYAVXLUQUMZAUYSWUIVXG
        VXMUYTVYJWUIVYKVUDVXCVYJWUIVUFVXDVUTVXKINOXKPVYLVVGUWOVFVGYQVUDVXCWUIWU
        JVUFVXDVXKIUYGNOXKPVYLVXFUWPVFVGWUEYJYAUXTUYAUQUWQYKVYAVWPVYBVYCUWSZWUD
        VYAWUHVUAVWPWUKYNYSVYHYAUXTUWTVRYPUWRYTXHYLYTUXAUXBUXCYRAVUGUXOUYEYNVUH
        BHIMMUXKIOOCPPTTUXKWBZVUFVUFUXDVGUXEUXLUXFVGVUDVUDUXNUXJUXMVAYNVUFVUFFH
        ILUXKIWULRSUXGUXIUXH $.
    $}

    $( Hellinger-Toeplitz Theorem: any self-adjoint linear operator defined on
       all of Hilbert space is bounded.  Theorem 10.1-1 of [Kreyszig] p. 525.
       Discovered by E. Hellinger and O. Toeplitz in 1910, "it aroused both
       admiration and puzzlement since the theorem establishes a relation
       between properties of two different kinds, namely, the properties of
       being defined everywhere and being bounded."  (Contributed by NM,
       11-Jan-2008.)  (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    htth $p |- ( ( U e. CHilOLD /\ T e. L /\
        A. x e. X A. y e. X ( x P ( T ` y ) ) = ( ( T ` x ) P y ) ) ->
      T e. B ) $=
      ( vw cv cfv co wceq wral fveq2 eqid vu vv vz chlo wcel wa caddc cmul cabs
      wi cop cif clno cdip cba cblo oveq12 anidms syl5eq eleq2d oveqd raleqbidv
      eqeq12d anbi12d imbi12d cmpt cnmcv c1 cle wbr crab cima cnchl simpl simpr
      elimel oveq1 oveq1d oveq2d oveq2 cbvral2v cbvmptv mpteq2dv breq1d cbvrabv
      sylib imaeq2i htthlem dedth 3impib ) FUDUEZEGUEZANZBNZEOZDPZWMEOZWNDPZQZB
      HRZAHRZECUEZWKWLXAUFZXBUJEWKFUGUHUKUIUKZULZXEUMPZUEZWMWOXEUNOZPZWQWNXHPZQ
      ZBXEUOOZRZAXLRZUFZEXEXEUPPZUEZUJFXDFXEQZXCXOXBXQXRWLXGXAXNXRGXFEXRGFFUMPZ
      XFKXRXSXFQFXEFXEUMUQURUSUTXRWTXMAHXLXRHFUOOXLIFXEUOSUSZXRWSXKBHXLXTXRWPXI
      WRXJXRDXHWMWOXRDFUNOXHJFXEUNSUSZVAXRDXHWQWNYAVAVCVBVBVDXRCXPEXRCFFUPPZXPL
      XRYBXPQFXEFXEUPUQURUSUTVEXOUAUBUCMXPXHEXEAXLBXLWNWQXHPZVFZVFZYEWMXEVGOZOZ
      VHVIVJZAXLVKZVLXFYFXDXLXLTXHTXFTXPTYFTFXDUDXDXDTZVMVPYJXGXNVNXOXNUANZUBNZ
      EOZXHPZYKEOZYLXHPZQZUBXLRUAXLRXGXNVOXKYQYKWOXHPZYOWNXHPZQABUAUBXLXLWMYKQZ
      XIYRXJYSWMYKWOXHVQYTWQYOWNXHWMYKESVRVCWNYLQZYRYNYSYPUUAWOYMYKXHWNYLESVSWN
      YLYOXHVTVCWAWFAUCXLYDMXLMNZUCNZEOZXHPZVFZWMUUCQZYDMXLUUBWQXHPZVFUUFBMXLYC
      UUHWNUUBWQXHVQWBUUGMXLUUHUUEUUGWQUUDUUBXHWMUUCESVSWCUSWBYIUUCYFOZVHVIVJZU
      CXLVKYEYHUUJAUCXLUUGYGUUIVHVIWMUUCYFSWDWEWGWHWIWJ $.
  $}

$( End $[ set-deprec.mm $] $)

$( Begin $[ set-typeset.mm $] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
       Appendix:  Typesetting definitions for the tokens in this file
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$( $t

/* The '$ t' (no space between '$' and 't') token indicates the beginning
    of the typesetting definition section, embedded in a Metamath
    comment.  There may only be one per source file, and the typesetting
    section ends with the end of the Metamath comment.  The typesetting
    section uses C-style comment delimiters.  Todo:  Allow multiple
    typesetting comments */

/* These are the LaTeX and HTML definitions in the order the tokens are
    introduced in $c or $v statements.  See HELP TEX or HELP HTML in the
    Metamath program. */

/* Note that the ALT= fields in htmldefs should be preceded by a space.  This
   ensures that a screen copy from the web page will have a space between
   symbols. */
/* Math font table with XITS and LaTeX defs:
   http://meeting.contextgarden.net/2011/talks/day3_05_ulrik_opentype/Samples/
           unimath-symbols.pdf */


/******* Web page format settings *******/

/* Custom CSS for Unicode fonts */
/* The woff font file was obtained from
   http://fred-wang.github.io/MathFonts/XITS/xits-math.woff 28-Aug-2015 */
htmlcss '<STYLE TYPE="text/css">\n' +
    '<!--\n' +
    '  .set { color: red; }\n' +
    '  .wff { color: blue; }\n' +
    '  .class { color: #C3C; }\n' +
    '  .symvar { border-bottom:1px dotted;color:#C3C}\n' +
    '  .typecode { color: gray }\n' +
    '  .hidden { color: gray }\n' +
    '  @font-face {\n' +
    '    font-family: XITSMath-Regular;\n' +
    '    src: url(xits-math.woff);\n' +
    '  }\n' +
    '  .math { font-family: XITSMath-Regular }\n' +
    '-->\n' +
    '</STYLE>\n' +
    '<LINK href="mmset.css" title="mmset"\n' +
    '    rel="stylesheet" type="text/css">\n' +
    '<LINK href="mmsetalt.css" title="mmsetalt"\n' +
    '    rel="alternate stylesheet" type="text/css">';

/* Tag(s) for the main SPAN surrounding all Unicode math */
htmlfont 'CLASS=math';

/* Page title, home page link */
htmltitle "Metamath Proof Explorer";
htmlhome '<A HREF="mmset.html"><FONT SIZE=-2 FACE=sans-serif>' +
    '<IMG SRC="mm.gif" BORDER=0 ALT='  +
    '"Home" HEIGHT=32 WIDTH=32 ALIGN=MIDDLE STYLE="margin-bottom:0px">' +
    'Home</FONT></A>';
/* Optional file where bibliographic references are kept */
/* If specified, e.g. "mmset.html", Metamath will hyperlink all strings of the
   form "[rrr]" (where "rrr" has no whitespace) to "mmset.html#rrr" */
/* A warning will be given if the file "mmset.html" with the bibliographical
   references is not present.  It is read in order to check existence of
   the references. */
htmlbibliography "mmset.html";

/* Page title, home page link */
/* These are the variables used for the Hilbert Space extension to
   set.mm. */
exthtmltitle "Hilbert Space Explorer";
exthtmlhome '<A HREF="mmhil.html"><FONT SIZE=-2 FACE=sans-serif>' +
    '<IMG SRC="atomic.gif" BORDER=0 ALT='  +
    '"Home" HEIGHT=32 WIDTH=32 ALIGN=MIDDLE STYLE="margin-bottom:0px">' +
    'Home</FONT></A>';
/* The variable "exthtmllabel" means that all states including
   and after this label should use the "ext..." variables. */
exthtmllabel "chil";
/* A warning will be given if the file with the bibliographical references
   is not present. */
exthtmlbibliography "mmhil.html";

/* Variable color key at the bottom of each proof table */
htmlvarcolor '<SPAN CLASS=wff STYLE="color:blue;font-style:normal">wff</SPAN> '
    + '<SPAN CLASS=set STYLE="color:red;font-style:normal">set</SPAN> '
    + '<SPAN CLASS=class STYLE="color:#C3C;font-style:normal">class</SPAN>';

/* GIF and Unicode HTML directories - these are used for the GIF version to
   crosslink to the Unicode version and vice-versa */
htmldir "../mpegif/";
althtmldir "../mpeuni/";


/******* Symbol definitions *******/

htmldef "(" as "<IMG SRC='lp.gif' WIDTH=5 HEIGHT=19 ALT=' (' TITLE='('>";
  althtmldef "(" as "(";
  latexdef "(" as "(";
htmldef ")" as "<IMG SRC='rp.gif' WIDTH=5 HEIGHT=19 ALT=' )' TITLE=')'>";
  althtmldef ")" as ")";
  latexdef ")" as ")";
htmldef "->" as
    " <IMG SRC='to.gif' WIDTH=15 HEIGHT=19 ALT=' -&gt;' TITLE='-&gt;'> ";
  althtmldef "->" as ' &rarr; ';
  latexdef "->" as "\rightarrow";
htmldef "-." as
    "<IMG SRC='lnot.gif' WIDTH=10 HEIGHT=19 ALT=' -.' TITLE='-.'> ";
  althtmldef "-." as '&not; ';
  latexdef "-." as "\lnot";
htmldef "wff" as
    "<IMG SRC='_wff.gif' WIDTH=24 HEIGHT=19 ALT=' wff' TITLE='wff'> ";
  althtmldef "wff" as
    '<SPAN CLASS=typecode STYLE="color:gray">wff </SPAN>'; /* was #00CC00 */
  latexdef "wff" as "{\rm wff}";
htmldef "|-" as
    "<IMG SRC='_vdash.gif' WIDTH=10 HEIGHT=19 ALT=' |-' TITLE='|-'> ";
  althtmldef "|-" as
    '<SPAN CLASS=hidden STYLE="color:gray">&#8866; </SPAN>'; /* &vdash; */
    /* Without sans-serif, way too big in FF3 */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|-" as "\vdash";
htmldef "ph" as
    "<IMG SRC='_varphi.gif' WIDTH=11 HEIGHT=19 ALT=' ph' TITLE='ph'>";
  /* althtmldef "ph" as '<FONT COLOR="#0000FF">&#x1D711;</SPAN>'; */
  althtmldef "ph" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D711;</SPAN>';
  latexdef "ph" as "\varphi";
htmldef "ps" as "<IMG SRC='_psi.gif' WIDTH=12 HEIGHT=19 ALT=' ps' TITLE='ps'>";
  althtmldef "ps" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D713;</SPAN>';
  latexdef "ps" as "\psi";
htmldef "ch" as "<IMG SRC='_chi.gif' WIDTH=12 HEIGHT=19 ALT=' ch' TITLE='ch'>";
  althtmldef "ch" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D712;</SPAN>';
  latexdef "ch" as "\chi";
htmldef "th" as
    "<IMG SRC='_theta.gif' WIDTH=8 HEIGHT=19 ALT=' th' TITLE='th'>";
  althtmldef "th" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D703;</SPAN>';
  latexdef "th" as "\theta";
htmldef "ta" as "<IMG SRC='_tau.gif' WIDTH=10 HEIGHT=19 ALT=' ta' TITLE='ta'>";
  althtmldef "ta" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D70F;</SPAN>';
  latexdef "ta" as "\tau";
htmldef "et" as "<IMG SRC='_eta.gif' WIDTH=9 HEIGHT=19 ALT=' et' TITLE='et'>";
  althtmldef "et" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D702;</SPAN>';
  latexdef "et" as "\eta";
htmldef "ze" as "<IMG SRC='_zeta.gif' WIDTH=9 HEIGHT=19 ALT=' ze' TITLE='ze'>";
  althtmldef "ze" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D701;</SPAN>';
  latexdef "ze" as "\zeta";
htmldef "si" as
    "<IMG SRC='_sigma.gif' WIDTH=10 HEIGHT=19 ALT=' si' TITLE='si'>";
  althtmldef "si" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70E;</SPAN>';
  latexdef "si" as "\sigma";
htmldef "rh" as "<IMG SRC='_rho.gif' WIDTH=9 HEIGHT=19 ALT=' rh' TITLE='rh'>";
  althtmldef "rh" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D70C;</SPAN>';
  latexdef "rh" as "\rho";
htmldef "mu" as "<IMG SRC='_mu.gif' WIDTH=10 HEIGHT=19 ALT=' mu' TITLE='mu'>";
  althtmldef "mu" as '<SPAN CLASS=wff STYLE="color:blue">&#x1D707;</SPAN>';
  latexdef "mu" as "\mu";
htmldef "la" as
    "<IMG SRC='_lambda.gif' WIDTH=9 HEIGHT=19 ALT=' la' TITLE='la'>";
  althtmldef "la" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D706;</SPAN>';
  latexdef "la" as "\lambda";
htmldef "ka" as
    "<IMG SRC='_kappa.gif' WIDTH=9 HEIGHT=19 ALT=' ka' TITLE='ka'>";
  althtmldef "ka" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D705;</SPAN>';
  latexdef "ka" as "\kappa";
htmldef "<->" as " <IMG SRC='leftrightarrow.gif' WIDTH=15 HEIGHT=19 " +
    "ALT=' &lt;-&gt;' TITLE='&lt;-&gt;'> ";
  althtmldef "<->" as ' &harr; ';
  latexdef "<->" as "\leftrightarrow";
htmldef "\/" as
     " <IMG SRC='vee.gif' WIDTH=11 HEIGHT=19 ALT=' \/' TITLE='\/'> ";
  althtmldef "\/" as ' &or; ' ;
    /* althtmldef "\/" as ' <FONT FACE=sans-serif>&#8897;</FONT> ' ; */
    /* was &or; - changed to match font of &and; replacement */
    /* Changed back 6-Mar-2012 NM */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "\/" as "\vee";
htmldef "/\" as
    " <IMG SRC='wedge.gif' WIDTH=11 HEIGHT=19 ALT=' /\' TITLE='/\'> ";
  althtmldef "/\" as ' &and; ';
    /* althtmldef "/\" as ' <FONT FACE=sans-serif>&#8896;</FONT> '; */
    /* was &and; which is circle in Mozilla on WinXP Pro (but not Home) */
    /* Changed back 6-Mar-2012 NM */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "/\" as "\wedge";
htmldef "-/\" as
    " <IMG SRC='barwedge.gif' WIDTH=9 HEIGHT=19 ALT=' -/\' TITLE='-/\'> ";
  althtmldef "-/\" as ' &#8892; ';
    /*althtmldef "-/\" as " &#8892; "; */ /* too-high font bug in FF */
    /* barwedge, U022BC, alias ISOAMSB barwed, ['nand'] */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "-/\" as "\barwedge";
htmldef "\/_" as
    " <IMG SRC='veebar.gif' WIDTH=9 HEIGHT=19 ALT=' \/_' TITLE='\/_'> ";
  althtmldef "\/_" as " &#8891; ";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "\/_" as "\veebar";
htmldef "T." as
    " <IMG SRC='top.gif' WIDTH=11 HEIGHT=19 ALT=' T.' TITLE='T.'> ";
  althtmldef "T." as ' &#x22A4; ';
  latexdef "T." as "\top";
htmldef "F." as
    " <IMG SRC='perp.gif' WIDTH=11 HEIGHT=19 ALT=' F.' TITLE='F.'> ";
  althtmldef "F." as ' &perp; ';
  latexdef "F." as "\bot";
htmldef "hadd" as "hadd";
  althtmldef "hadd" as "hadd";
  latexdef "hadd" as "\mbox{hadd}";
htmldef "cadd" as "cadd";
  althtmldef "cadd" as "cadd";
  latexdef "cadd" as "\mbox{cadd}";
htmldef "A." as
    "<IMG SRC='forall.gif' WIDTH=10 HEIGHT=19 ALT=' A.' TITLE='A.'>";
  althtmldef "A." as '&forall;'; /* &#8704; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "A." as "\forall";
htmldef "set" as
    "<IMG SRC='_set.gif' WIDTH=20 HEIGHT=19 ALT=' set' TITLE='set'> ";
  althtmldef "set" as '<SPAN CLASS=typecode STYLE="color:gray">set </SPAN>';
  latexdef "set" as "{\rm set}";
htmldef "x" as "<IMG SRC='_x.gif' WIDTH=10 HEIGHT=19 ALT=' x' TITLE='x'>";
  /* http://www.unicode.org/charts/PDF/U1D400.pdf has math italic Unicode */
  althtmldef "x" as '<SPAN CLASS=set STYLE="color:red">&#x1D465;</SPAN>';
  latexdef "x" as "x";
htmldef "y" as "<IMG SRC='_y.gif' WIDTH=9 HEIGHT=19 ALT=' y' TITLE='y'>";
  althtmldef "y" as '<SPAN CLASS=set STYLE="color:red">&#x1D466;</SPAN>';
  latexdef "y" as "y";
htmldef "z" as "<IMG SRC='_z.gif' WIDTH=9 HEIGHT=19 ALT=' z' TITLE='z'>";
  althtmldef "z" as '<SPAN CLASS=set STYLE="color:red">&#x1D467;</SPAN>';
  latexdef "z" as "z";
htmldef "w" as "<IMG SRC='_w.gif' WIDTH=12 HEIGHT=19 ALT=' w' TITLE='w'>";
  althtmldef "w" as '<SPAN CLASS=set STYLE="color:red">&#x1D464;</SPAN>';
  latexdef "w" as "w";
htmldef "v" as "<IMG SRC='_v.gif' WIDTH=9 HEIGHT=19 ALT=' v' TITLE='v'>";
  althtmldef "v" as '<SPAN CLASS=set STYLE="color:red">&#x1D463;</SPAN>';
  latexdef "v" as "v";
htmldef "u" as "<IMG SRC='_u.gif' WIDTH=10 HEIGHT=19 ALT=' u' TITLE='u'>";
  althtmldef "u" as '<SPAN CLASS=set STYLE="color:red">&#x1D462;</SPAN>';
  latexdef "u" as "u";
htmldef "t" as "<IMG SRC='_t.gif' WIDTH=7 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "t" as '<SPAN CLASS=set STYLE="color:red">&#x1D461;</SPAN>';
  latexdef "t" as "t";
htmldef "E." as
    "<IMG SRC='exists.gif' WIDTH=9 HEIGHT=19 ALT=' E.' TITLE='E.'>";
  althtmldef "E." as '&exist;'; /* &#8707; */
    /* Without sans-serif, bad in Opera and way too big in FF3 */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "E." as "\exists";
htmldef "F/" as
    "<IMG SRC='finv.gif' WIDTH=9 HEIGHT=19 ALT=' F/' TITLE='F/'>";
  althtmldef "F/" as "&#8498;";
  latexdef "F/" as "\Finv";
htmldef "class" as
    "<IMG SRC='_class.gif' WIDTH=32 HEIGHT=19 ALT=' class' TITLE='class'> ";
  althtmldef "class" as
    '<SPAN CLASS=typecode STYLE="color:gray">class </SPAN>';
  latexdef "class" as "{\rm class}";
htmldef "=" as " <IMG SRC='eq.gif' WIDTH=12 HEIGHT=19 ALT=' =' TITLE='='> ";
  althtmldef "=" as ' = '; /* &equals; */
  latexdef "=" as "=";
htmldef "e." as " <IMG SRC='in.gif' WIDTH=10 HEIGHT=19 ALT=' e.' TITLE='e.'> ";
  althtmldef "e." as ' &isin; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "e." as "\in";
htmldef "[" as "<IMG SRC='lbrack.gif' WIDTH=5 HEIGHT=19 ALT=' [' TITLE='['>";
  althtmldef "[" as '['; /* &lsqb; */
  latexdef "[" as "[";
htmldef "/" as
    " <IMG SRC='solidus.gif' WIDTH=6 HEIGHT=19 ALT=' /' TITLE='/'> ";
  althtmldef "/" as ' / '; /* &sol; */
  latexdef "/" as "/";
htmldef "]" as "<IMG SRC='rbrack.gif' WIDTH=5 HEIGHT=19 ALT=' ]' TITLE=']'>";
  althtmldef "]" as ']'; /* &rsqb; */
  latexdef "]" as "]";
htmldef "E!" as "<IMG SRC='_e1.gif' WIDTH=12 HEIGHT=19 ALT=' E!' TITLE='E!'>";
  althtmldef "E!" as '&exist;!';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "E!" as "\exists{!}";
htmldef "E*" as "<IMG SRC='_em1.gif' WIDTH=15 HEIGHT=19 ALT=' E*' TITLE='E*'>";
  althtmldef "E*" as '&exist;*';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "E*" as "\exists^\ast";
htmldef "{" as "<IMG SRC='lbrace.gif' WIDTH=6 HEIGHT=19 ALT=' {' TITLE='{'>";
  althtmldef "{" as '{'; /* &lcub; */
  latexdef "{" as "\{";
htmldef "|" as " <IMG SRC='vert.gif' WIDTH=3 HEIGHT=19 ALT=' |' TITLE='|'> ";
  althtmldef "|" as ' &#8739; '; /* &vertbar; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|" as "|";
htmldef "}" as "<IMG SRC='rbrace.gif' WIDTH=6 HEIGHT=19 ALT=' }' TITLE='}'>";
  althtmldef "}" as '}'; /* &rcub; */
  latexdef "}" as "\}";
htmldef "F/_" as
    "<IMG SRC='_finvbar.gif' WIDTH=9 HEIGHT=19 ALT=' F/_' TITLE='F/_'>";
  althtmldef "F/_" as "<U>&#8498;</U>";
  latexdef "F/_" as "\underline{\Finv}";
htmldef "CondEq" as "CondEq";
  althtmldef "CondEq" as "CondEq";
  latexdef "CondEq" as "\mbox{CondEq}";
htmldef "./\" as
    " <IMG SRC='_.wedge.gif' WIDTH=11 HEIGHT=19 ALT=' ./\' TITLE='./\'> ";
  althtmldef "./\" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&and;</SPAN> ';
  latexdef "./\" as "\wedge";
htmldef ".\/" as
    " <IMG SRC='_.vee.gif' WIDTH=11 HEIGHT=19 ALT=' .\/' TITLE='.\/'> ";
  althtmldef ".\/" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&or;</SPAN> ';
  latexdef ".\/" as "\vee";
htmldef ".<_" as
    " <IMG SRC='_.le.gif' WIDTH=11 HEIGHT=19 ALT=' .&lt;_' TITLE='.&lt;_'> ";
  althtmldef ".<_" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&le;</SPAN> ';
  latexdef ".<_" as "\le";
htmldef ".<" as     /* Symbol as variable */
    " <IMG SRC='_.lt.gif' WIDTH=11 HEIGHT=19 ALT=' .&lt;' TITLE='.&lt;'> ";
  althtmldef ".<" as
    /* This is how to put a dotted box around the symbol: */
    /* border means box around symbol; border-bottom underlines symbol */
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&lt;</SPAN> ';
    /* Todo: can this STYLE sequence be done with a CLASS? */
    /* Move the underline down 3px so it isn't too close to symbol */
    /*
    ' <SPAN STYLE="vertical-align:-3px">' +
    '<SPAN CLASS=symvar STYLE="text-decoration:underline dotted;color:#C3C">' +
    '<SPAN STYLE="vertical-align:3px">&lt;</SPAN></SPAN></SPAN> ';
    */
  latexdef ".<" as "<";
htmldef ".+" as
    " <IMG SRC='_.plus.gif' WIDTH=13 HEIGHT=19 ALT=' .+' TITLE='.+'> ";
  althtmldef ".+" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '+</SPAN> ';
  latexdef ".+" as "+";
htmldef ".-" as
    " <IMG SRC='_.minus.gif' WIDTH=11 HEIGHT=19 ALT=' .-' TITLE='.-'> ";
  althtmldef ".-" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&minus;</SPAN> ';
  latexdef ".-" as "-";
htmldef ".X." as
    " <IMG SRC='_.times.gif' WIDTH=9 HEIGHT=19 ALT=' .X.' TITLE='.X.'> ";
  althtmldef ".X." as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&times;</SPAN> ';
  latexdef ".X." as "\times";
htmldef "./" as
    " <IMG SRC='_.solidus.gif' WIDTH=8 HEIGHT=19 ALT=' ./' TITLE='./'> ";
  althtmldef "./" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '/</SPAN> ';
  latexdef "./" as "/";
htmldef ".^" as
    " <IMG SRC='_.uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' .^' TITLE='.^'> ";
  althtmldef ".^" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&uarr;</SPAN> ';
  latexdef ".^" as "\uparrow";
htmldef ".0." as
    " <IMG SRC='_.0.gif' WIDTH=8 HEIGHT=19 ALT=' .0.' TITLE='.0.'> ";
  althtmldef ".0." as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '0</SPAN> ';
  latexdef ".0." as "0";
htmldef ".1." as
    " <IMG SRC='_.1.gif' WIDTH=7 HEIGHT=19 ALT=' .1.' TITLE='.1.'> ";
  althtmldef ".1." as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '1</SPAN> ';
  latexdef ".1." as "1";
htmldef ".||" as
    " <IMG SRC='_.parallel.gif' WIDTH=5 HEIGHT=19 ALT=' .||' TITLE='.||'> ";
  althtmldef ".||" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#8741;</SPAN> ';
  latexdef ".||" as "\parallel";
htmldef ".~" as
    " <IMG SRC='_.sim.gif' WIDTH=13 HEIGHT=19 ALT=' .~' TITLE='.~'> ";
  althtmldef ".~" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x223C;</SPAN> ';
  latexdef ".~" as "\sim";
htmldef "._|_" as
    " <IMG SRC='_.perp.gif' WIDTH=11 HEIGHT=19 ALT=' ._|_' TITLE='._|_'> ";
  althtmldef "._|_" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#8869;</SPAN> ';
  latexdef "._|_" as "\perp";
htmldef ".+^" as
    " <IMG SRC='_.plushat.gif' WIDTH=11 HEIGHT=19 ALT=' .+^' TITLE='.+^'> ";
  althtmldef ".+^" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x2A23;</SPAN> ';       /* &plusacir; */
  latexdef ".+^" as "\hat{+}";
htmldef ".+b" as
    " <IMG SRC='_.plusb.gif' WIDTH=14 HEIGHT=19 ALT=' .+b' TITLE='.+b'> ";
  althtmldef ".+b" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x271A;</SPAN> ';
  latexdef ".+b" as "\boldsymbol{+}";
htmldef ".(+)" as
    " <IMG SRC='_.oplus.gif' WIDTH=13 HEIGHT=19 ALT=' .(+)' TITLE='.(+)'> ";
  althtmldef ".(+)" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x2295;</SPAN> ';
  latexdef ".(+)" as "\oplus";
htmldef ".*" as
    " <IMG SRC='_.ast.gif' WIDTH=7 HEIGHT=19 ALT=' .*' TITLE='.*'> ";
  althtmldef ".*" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&lowast;</SPAN> ';
  latexdef ".*" as "\ast";
htmldef ".x." as
    " <IMG SRC='_.cdot.gif' WIDTH=4 HEIGHT=19 ALT=' .x.' TITLE='.x.'> ";
  althtmldef ".x." as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&middot;</SPAN> ';
  latexdef ".x." as "\cdot";
htmldef ".xb" as
    " <IMG SRC='_.bullet.gif' WIDTH=8 HEIGHT=19 ALT=' .xb' TITLE='.xb'> ";
  althtmldef ".xb" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x2219;</SPAN> ';
  latexdef ".xb" as "\bullet";
htmldef ".," as
    " <IMG SRC='_.comma.gif' WIDTH=4 HEIGHT=19 ALT=' .,' TITLE='.,'> ";
  althtmldef ".," as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    ',</SPAN> ';
  latexdef ".," as ",";
htmldef ".(x)" as
    " <IMG SRC='_.otimes.gif' WIDTH=13 HEIGHT=19 ALT=' .(x)' TITLE='.(x)'> ";
  althtmldef ".(x)" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x2297;</SPAN> ';
  latexdef ".(x)" as "\otimes";
htmldef ".0b" as
    " <IMG SRC='_.bf0.gif' WIDTH=9 HEIGHT=19 ALT=' .0b' TITLE='.0b'> ";
  althtmldef ".0b" as
    ' <SPAN CLASS=symvar STYLE="border-bottom:1px dotted;color:#C3C">' +
    '&#x1D7CE</SPAN> ';
  latexdef ".0b" as "\mbox{\boldmath$0$}";
htmldef "A" as "<IMG SRC='_ca.gif' WIDTH=11 HEIGHT=19 ALT=' A' TITLE='A'>";
  althtmldef "A" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;</SPAN>';
  latexdef "A" as "A";
htmldef "B" as "<IMG SRC='_cb.gif' WIDTH=12 HEIGHT=19 ALT=' B' TITLE='B'>";
  althtmldef "B" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;</SPAN>';
  latexdef "B" as "B";
htmldef "C" as "<IMG SRC='_cc.gif' WIDTH=12 HEIGHT=19 ALT=' C' TITLE='C'>";
  althtmldef "C" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;</SPAN>';
  latexdef "C" as "C";
htmldef "D" as "<IMG SRC='_cd.gif' WIDTH=12 HEIGHT=19 ALT=' D' TITLE='D'>";
  althtmldef "D" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;</SPAN>';
  latexdef "D" as "D";
htmldef "P" as "<IMG SRC='_cp.gif' WIDTH=12 HEIGHT=19 ALT=' P' TITLE='P'>";
  althtmldef "P" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D443;</SPAN>';
  latexdef "P" as "P";
htmldef "Q" as "<IMG SRC='_cq.gif' WIDTH=12 HEIGHT=19 ALT=' Q' TITLE='Q'>";
  althtmldef "Q" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D444;</SPAN>';
  latexdef "Q" as "Q";
htmldef "R" as "<IMG SRC='_cr.gif' WIDTH=12 HEIGHT=19 ALT=' R' TITLE='R'>";
  althtmldef "R" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D445;</SPAN>';
  latexdef "R" as "R";
htmldef "S" as "<IMG SRC='_cs.gif' WIDTH=11 HEIGHT=19 ALT=' S' TITLE='S'>";
  althtmldef "S" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;</SPAN>';
  latexdef "S" as "S";
htmldef "T" as "<IMG SRC='_ct.gif' WIDTH=12 HEIGHT=19 ALT=' T' TITLE='T'>";
  althtmldef "T" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D447;</SPAN>';
  latexdef "T" as "T";
htmldef "U" as "<IMG SRC='_cu.gif' WIDTH=12 HEIGHT=19 ALT=' U' TITLE='U'>";
  althtmldef "U" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D448;</SPAN>';
  latexdef "U" as "U";
htmldef "e" as "<IMG SRC='_e.gif' WIDTH=8 HEIGHT=19 ALT=' e' TITLE='e'>";
  althtmldef "e" as '<SPAN CLASS=set STYLE="color:red">&#x1D452;</SPAN>';
  latexdef "e" as "e";
htmldef "f" as "<IMG SRC='_f.gif' WIDTH=9 HEIGHT=19 ALT=' f' TITLE='f'>";
  althtmldef "f" as '<SPAN CLASS=set STYLE="color:red">&#x1D453;</SPAN>';
  latexdef "f" as "f";
htmldef "g" as "<IMG SRC='_g.gif' WIDTH=9 HEIGHT=19 ALT=' g' TITLE='g'>";
  althtmldef "g" as '<SPAN CLASS=set STYLE="color:red">&#x1D454;</SPAN>';
  latexdef "g" as "g";
htmldef "h" as "<IMG SRC='_h.gif' WIDTH=10 HEIGHT=19 ALT=' h' TITLE='h'>";
  althtmldef "h" as '<SPAN CLASS=set STYLE="color:red">&#x210E;</SPAN>';
  latexdef "h" as "h";
htmldef "i" as "<IMG SRC='_i.gif' WIDTH=6 HEIGHT=19 ALT=' i' TITLE='i'>";
  althtmldef "i" as '<SPAN CLASS=set STYLE="color:red">&#x1D456;</SPAN>';
  latexdef "i" as "i";
htmldef "j" as "<IMG SRC='_j.gif' WIDTH=7 HEIGHT=19 ALT=' j' TITLE='j'>";
  althtmldef "j" as '<SPAN CLASS=set STYLE="color:red">&#x1D457;</SPAN>';
  latexdef "j" as "j";
htmldef "k" as "<IMG SRC='_k.gif' WIDTH=9 HEIGHT=19 ALT=' k' TITLE='k'>";
  althtmldef "k" as '<SPAN CLASS=set STYLE="color:red">&#x1D458;</SPAN>';
  latexdef "k" as "k";
htmldef "m" as "<IMG SRC='_m.gif' WIDTH=14 HEIGHT=19 ALT=' m' TITLE='m'>";
  althtmldef "m" as '<SPAN CLASS=set STYLE="color:red">&#x1D45A;</SPAN>';
  latexdef "m" as "m";
htmldef "n" as "<IMG SRC='_n.gif' WIDTH=10 HEIGHT=19 ALT=' n' TITLE='n'>";
  althtmldef "n" as '<SPAN CLASS=set STYLE="color:red">&#x1D45B;</SPAN>';
  latexdef "n" as "n";
htmldef "o" as "<IMG SRC='_o.gif' WIDTH=8 HEIGHT=19 ALT=' o' TITLE='o'>";
  althtmldef "o" as '<SPAN CLASS=set STYLE="color:red">&#x1D45C;</SPAN>';
  latexdef "o" as "o";
htmldef "E" as "<IMG SRC='_ce.gif' WIDTH=13 HEIGHT=19 ALT=' E' TITLE='E'>";
  althtmldef "E" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D438;</SPAN>';
  latexdef "E" as "E";
htmldef "F" as "<IMG SRC='_cf.gif' WIDTH=13 HEIGHT=19 ALT=' F' TITLE='F'>";
  althtmldef "F" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;</SPAN>';
  latexdef "F" as "F";
htmldef "G" as "<IMG SRC='_cg.gif' WIDTH=12 HEIGHT=19 ALT=' G' TITLE='G'>";
  althtmldef "G" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;</SPAN>';
  latexdef "G" as "G";
htmldef "H" as "<IMG SRC='_ch.gif' WIDTH=14 HEIGHT=19 ALT=' H' TITLE='H'>";
  althtmldef "H" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;</SPAN>';
  latexdef "H" as "H";
htmldef "I" as "<IMG SRC='_ci.gif' WIDTH=8 HEIGHT=19 ALT=' I' TITLE='I'>";
  althtmldef "I" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;</SPAN>';
  latexdef "I" as "I";
htmldef "J" as "<IMG SRC='_cj.gif' WIDTH=10 HEIGHT=19 ALT=' J' TITLE='J'>";
  althtmldef "J" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43D;</SPAN>';
  latexdef "J" as "J";
htmldef "K" as "<IMG SRC='_ck.gif' WIDTH=14 HEIGHT=19 ALT=' K' TITLE='K'>";
  althtmldef "K" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43E;</SPAN>';
  latexdef "K" as "K";
htmldef "L" as "<IMG SRC='_cl.gif' WIDTH=10 HEIGHT=19 ALT=' L' TITLE='L'>";
  althtmldef "L" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;</SPAN>';
  latexdef "L" as "L";
htmldef "M" as "<IMG SRC='_cm.gif' WIDTH=15 HEIGHT=19 ALT=' M' TITLE='M'>";
  althtmldef "M" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;</SPAN>';
  latexdef "M" as "M";
htmldef "N" as "<IMG SRC='_cn.gif' WIDTH=14 HEIGHT=19 ALT=' N' TITLE='N'>";
  althtmldef "N" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D441;</SPAN>';
  latexdef "N" as "N";
htmldef "V" as "<IMG SRC='_cv.gif' WIDTH=12 HEIGHT=19 ALT=' V' TITLE='V'>";
  althtmldef "V" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;</SPAN>';
  latexdef "V" as "V";
htmldef "W" as "<IMG SRC='_cw.gif' WIDTH=16 HEIGHT=19 ALT=' W' TITLE='W'>";
  althtmldef "W" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44A;</SPAN>';
  latexdef "W" as "W";
htmldef "X" as "<IMG SRC='_cx.gif' WIDTH=13 HEIGHT=19 ALT=' X' TITLE='X'>";
  althtmldef "X" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44B;</SPAN>';
  latexdef "X" as "X";
htmldef "Y" as "<IMG SRC='_cy.gif' WIDTH=12 HEIGHT=19 ALT=' Y' TITLE='Y'>";
  althtmldef "Y" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44C;</SPAN>';
  latexdef "Y" as "Y";
htmldef "Z" as "<IMG SRC='_cz.gif' WIDTH=11 HEIGHT=19 ALT=' Z' TITLE='Z'>";
  althtmldef "Z" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44D;</SPAN>';
  latexdef "Z" as "Z";
htmldef "O" as "<IMG SRC='_co.gif' WIDTH=12 HEIGHT=19 ALT=' O' TITLE='O'>";
  althtmldef "O" as '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;</SPAN>';
  latexdef "O" as "O";
htmldef "s" as "<IMG SRC='_s.gif' WIDTH=7 HEIGHT=19 ALT=' s' TITLE='s'>";
  althtmldef "s" as '<SPAN CLASS=set STYLE="color:red">&#x1D460;</SPAN>';
  latexdef "s" as "s";
htmldef "r" as "<IMG SRC='_r.gif' WIDTH=8 HEIGHT=19 ALT=' r' TITLE='r'>";
  althtmldef "r" as '<SPAN CLASS=set STYLE="color:red">&#x1D45F;</SPAN>';
  latexdef "r" as "r";
htmldef "q" as "<IMG SRC='_q.gif' WIDTH=8 HEIGHT=19 ALT=' q' TITLE='q'>";
  althtmldef "q" as '<SPAN CLASS=set STYLE="color:red">&#x1D45E;</SPAN>';
  latexdef "q" as "q";
htmldef "p" as "<IMG SRC='_p.gif' WIDTH=10 HEIGHT=19 ALT=' p' TITLE='p'>";
  althtmldef "p" as '<SPAN CLASS=set STYLE="color:red">&#x1D45D;</SPAN>';
  latexdef "p" as "p";
htmldef "a" as "<IMG SRC='_a.gif' WIDTH=9 HEIGHT=19 ALT=' a' TITLE='a'>";
  althtmldef "a" as '<SPAN CLASS=set STYLE="color:red">&#x1D44E;</SPAN>';
  latexdef "a" as "a";
htmldef "b" as "<IMG SRC='_b.gif' WIDTH=8 HEIGHT=19 ALT=' b' TITLE='b'>";
  althtmldef "b" as '<SPAN CLASS=set STYLE="color:red">&#x1D44F;</SPAN>';
  latexdef "b" as "b";
htmldef "c" as "<IMG SRC='_c.gif' WIDTH=7 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "c" as '<SPAN CLASS=set STYLE="color:red">&#x1D450;</SPAN>';
  latexdef "c" as "c";
htmldef "d" as "<IMG SRC='_d.gif' WIDTH=9 HEIGHT=19 ALT=' d' TITLE='d'>";
  althtmldef "d" as '<SPAN CLASS=set STYLE="color:red">&#x1D451;</SPAN>';
  latexdef "d" as "d";
htmldef "l" as "<IMG SRC='_l.gif' WIDTH=6 HEIGHT=19 ALT=' l' TITLE='l'>";
  althtmldef "l" as '<SPAN CLASS=set STYLE="color:red">&#x1D459;</SPAN>';
  latexdef "l" as "l";
htmldef "=/=" as
    " <IMG SRC='ne.gif' WIDTH=12 HEIGHT=19 ALT=' =/=' TITLE='=/='> ";
  althtmldef "=/=" as ' &ne; ';
  latexdef "=/=" as "\ne";
htmldef "e/" as
    " <IMG SRC='notin.gif' WIDTH=10 HEIGHT=19 ALT=' e/' TITLE='e/'> ";
  althtmldef "e/" as ' &notin; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "e/" as "\notin";
htmldef "_V" as "<IMG SRC='rmcv.gif' WIDTH=10 HEIGHT=19 ALT=' _V' TITLE='_V'>";
  althtmldef "_V" as 'V';
  latexdef "_V" as "{\rm V}";
htmldef "[." as
    "<IMG SRC='_dlbrack.gif' WIDTH=7 HEIGHT=19 ALT=' [.' TITLE='[.'>";
  /* althtmldef "[." as '&#x298F;'; */   /* corner tick */
  /* althtmldef "[." as '[&#803;'; */  /* combining dot below */
  althtmldef "[." as '<B>[</B>'; /* 6-Aug-2018 nm */
  /* \underaccent is in accents package */
  latexdef "[." as "\underaccent{\dot}{[}";
htmldef "]." as
    "<IMG SRC='_drbrack.gif' WIDTH=6 HEIGHT=19 ALT=' ].' TITLE='].'>";
  /* althtmldef "]." as '&#x298E;'; */   /* corner tick */
  /* althtmldef "]." as ']&#803;'; */  /* combining dot below */
  althtmldef "]." as '<B>]</B>'; /* 6-Aug-2018 nm */
  latexdef "]." as "\underaccent{\dot}{]}";
htmldef "[_" as
    "<IMG SRC='_ulbrack.gif' WIDTH=7 HEIGHT=19 ALT=' [_' TITLE='[_'>";
  althtmldef "[_" as '<B>&#x298B;</B>'; /* left sq brack w underbar */
  latexdef "[_" as "\underline{[}";
htmldef "]_" as
    "<IMG SRC='_urbrack.gif' WIDTH=6 HEIGHT=19 ALT=' ]_' TITLE=']_'>";
  althtmldef "]_" as '<B>&#x298C;</B>'; /* right sq brack w underbar */
  latexdef "]_" as "\underline{]}";
htmldef "\" as
    " <IMG SRC='setminus.gif' WIDTH=8 HEIGHT=19 ALT=' \' TITLE='\'> ";
  althtmldef "\" as ' &#8726; '; /* &setmn; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "\" as "\setminus";
htmldef "u." as
    " <IMG SRC='cup.gif' WIDTH=10 HEIGHT=19 ALT=' u.' TITLE='u.'> ";
  althtmldef "u." as ' &cup; ';
  latexdef "u." as "\cup";
htmldef "i^i" as
    " <IMG SRC='cap.gif' WIDTH=10 HEIGHT=19 ALT=' i^i' TITLE='i^i'> ";
  althtmldef "i^i" as ' &cap; ';
  latexdef "i^i" as "\cap";
htmldef "C_" as
    " <IMG SRC='subseteq.gif' WIDTH=12 HEIGHT=19 ALT=' C_' TITLE='C_'> ";
  althtmldef "C_" as ' &#8838; '; /* &subE; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "C_" as "\subseteq";
htmldef "C." as
    " <IMG SRC='subset.gif' WIDTH=12 HEIGHT=19 ALT=' C.' TITLE='C.'> ";
  althtmldef "C." as ' &sub; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "C." as "\subset";
htmldef "(/)" as
    "<IMG SRC='varnothing.gif' WIDTH=11 HEIGHT=19 ALT=' (/)' TITLE='(/)'>";
  althtmldef "(/)" as '&empty;';
    /*althtmldef "(/)" as '&empty;';*/ /* =&#8709 */ /* bad in Opera */
    /*althtmldef "(/)" as '&#8960;';*/
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "(/)" as "\varnothing";
htmldef "if" as "<IMG SRC='_if.gif' WIDTH=11 HEIGHT=19 ALT=' if' TITLE='if'>";
  althtmldef "if" as ' if';
  latexdef "if" as "{\rm if}";
htmldef "," as "<IMG SRC='comma.gif' WIDTH=4 HEIGHT=19 ALT=' ,' TITLE=','> ";
  althtmldef "," as ', ';
  latexdef "," as ",";
htmldef "~P" as "<IMG SRC='scrp.gif' WIDTH=16 HEIGHT=19 ALT=' ~P' TITLE='~P'>";
  /* althtmldef "~P" as '<FONT FACE=sans-serif>&weierp;</FONT>'; */
  /* althtmldef "~P" as '&weierp;'; */ /* 2-Jan-2016 reverted sans-serif */
  /* 14-Jan-2016 script P is now available in upper Unicode */
  /* 4-Aug-2016 NM Put space after ~P, needed for e.g. ncanth where it
     overlapped the _V */
  althtmldef "~P" as '&#119979; ';
  latexdef "~P" as "{\cal P}";
htmldef "<." as
    "<IMG SRC='langle.gif' WIDTH=4 HEIGHT=19 ALT=' &lt;.' TITLE='&lt;.'>";
    /* The Unicode below doesn't always work on Firefox and Chrome on Windows,
       so revert to the image above */
  althtmldef "<." as '&lang;'; /* &#9001; */
    /* 2-Jan-2016 restored Unicode; reverted sans-serif */
  latexdef "<." as "\langle";
htmldef ">." as
    "<IMG SRC='rangle.gif' WIDTH=4 HEIGHT=19 ALT=' &gt;.' TITLE='&gt;.'>";
    /* The Unicode below doesn't always work on Firefox and Chrome on Windows,
       so revert to the image above */
  althtmldef ">." as '&rang;'; /* &#9002; */
    /* 2-Jan-2016 restored Unicode; reverted sans-serif */
  latexdef ">." as "\rangle";
htmldef "U." as
    "<IMG SRC='bigcup.gif' WIDTH=13 HEIGHT=19 ALT=' U.' TITLE='U.'>";
  /* 20-Sep-2017 nm Add space after U. in althtmldef to improve "U. ran" */
  althtmldef "U." as '<FONT SIZE="+1">&cup;</FONT> '; /* &xcup; */
    /* xcup does not render, and #8899 renders as a small bold cup, on
       Mozilla 1.7.3 on Windows XP */
    /*althtmldef "U." as '&#8899;';*/ /* &xcup; */
  latexdef "U." as "\bigcup";
htmldef "|^|" as
    "<IMG SRC='bigcap.gif' WIDTH=13 HEIGHT=19 ALT=' |^|' TITLE='|^|'>";
  /* 20-Sep-2017 nm Add space after |^| in althtmldef to improve "|^| ran" */
  althtmldef "|^|" as '<FONT SIZE="+1">&cap;</FONT> '; /* &xcap; */
    /*althtmldef "|^|" as '&#8898;';*/ /* &xcap; */
  latexdef "|^|" as "\bigcap";
htmldef "U_" as
    "<IMG SRC='_cupbar.gif' WIDTH=13 HEIGHT=19 ALT=' U_' TITLE='U_'>";
  /* 20-Sep-2017 nm Add space after U_ in althtmldef to improve "U_ ran" */
  althtmldef "U_" as '<U><FONT SIZE="+1">&cup;</FONT></U> '; /* &xcup; */
  latexdef "U_" as "\underline{\bigcup}";
htmldef "|^|_" as
    "<IMG SRC='_capbar.gif' WIDTH=13 HEIGHT=19 ALT=' |^|_' TITLE='|^|_'>";
  /* 20-Sep-2017 nm Add space after |^|_ in althtmldef to improve "|^|_ ran" */
  althtmldef "|^|_" as '<U><FONT SIZE="+1">&cap;</FONT></U> '; /* &xcap; */
  latexdef "|^|_" as "\underline{\bigcap}";
htmldef "Disj_" as "<u>Disj</u> ";
  althtmldef "Disj_" as "<u>Disj</u> ";
  latexdef "Disj_" as "\operatorname{\underline{Disj}}";
htmldef "|->" as " <IMG SRC='mapsto.gif' WIDTH=15 HEIGHT=19 ALT=' |-&gt;'" +
    " TITLE='|-&gt;'> ";
  althtmldef "|->" as ' &#8614; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|->" as "\mapsto";
htmldef "Tr" as
    "<IMG SRC='_ctr.gif' WIDTH=16 HEIGHT=19 ALT=' Tr' TITLE='Tr'> ";
  althtmldef "Tr" as 'Tr ';
  latexdef "Tr" as "{\rm Tr}";
htmldef "_E" as
    " <IMG SRC='rmce.gif' WIDTH=9 HEIGHT=19 ALT=' _E' TITLE='_E'> ";
  althtmldef "_E" as ' E ';
  latexdef "_E" as "{\rm E}";
htmldef "_I" as
    " <IMG SRC='rmci.gif' WIDTH=4 HEIGHT=19 ALT=' _I' TITLE='_I'> ";
  althtmldef "_I" as ' I ';
  latexdef "_I" as "{\rm I}";
htmldef "Po" as
    " <IMG SRC='_po.gif' WIDTH=16 HEIGHT=19 ALT=' Po' TITLE='Po'> ";
  althtmldef "Po" as ' Po ';
  latexdef "Po" as "{\rm Po}";
htmldef "Or" as
    " <IMG SRC='_or.gif' WIDTH=18 HEIGHT=19 ALT=' Or' TITLE='Or'> ";
  althtmldef "Or" as ' Or ';
  latexdef "Or" as "{\rm Or}";
htmldef "Fr" as
    " <IMG SRC='_fr.gif' WIDTH=15 HEIGHT=19 ALT=' Fr' TITLE='Fr'> ";
  althtmldef "Fr" as ' Fr ';
  latexdef "Fr" as "{\rm Fr}";
htmldef "Se" as ' Se ';
  althtmldef "Se" as ' Se ';
  latexdef "Se" as "{\rm Se}";
htmldef "We" as
    " <IMG SRC='_we.gif' WIDTH=21 HEIGHT=19 ALT=' We' TITLE='We'> ";
  althtmldef "We" as ' We ';
  latexdef "We" as "{\rm We}";
htmldef "Ord" as
    "<IMG SRC='_ord.gif' WIDTH=26 HEIGHT=19 ALT=' Ord' TITLE='Ord'> ";
  althtmldef "Ord" as 'Ord ';
  latexdef "Ord" as "{\rm Ord}";
htmldef "On" as "<IMG SRC='_on.gif' WIDTH=20 HEIGHT=19 ALT=' On' TITLE='On'>";
  althtmldef "On" as 'On';
  latexdef "On" as "{\rm On}";
htmldef "Lim" as
    "<IMG SRC='_lim.gif' WIDTH=26 HEIGHT=19 ALT=' Lim' TITLE='Lim'> ";
  althtmldef "Lim" as 'Lim ';
  latexdef "Lim" as "{\rm Lim}";
htmldef "suc" as
    "<IMG SRC='_suc.gif' WIDTH=22 HEIGHT=19 ALT=' suc' TITLE='suc'> ";
  althtmldef "suc" as 'suc ';
  latexdef "suc" as "{\rm suc}";
htmldef "om" as
    "<IMG SRC='omega.gif' WIDTH=11 HEIGHT=19 ALT=' om' TITLE='om'>";
  /*althtmldef "om" as '&omega;';*/
  althtmldef "om" as '&#x1D714;'; /* math italic omega */
  latexdef "om" as "\omega";
htmldef "X." as
    " <IMG SRC='times.gif' WIDTH=9 HEIGHT=19 ALT=' X.' TITLE='X.'> ";
  althtmldef "X." as ' &times; ';
  latexdef "X." as "\times";
htmldef "`'" as "<IMG SRC='_cnv.gif' WIDTH=10 HEIGHT=19 ALT=" + '"' + " `'" +
    '"' + "TITLE=" + '"' + "`'" + '"' + ">";
  althtmldef "`'" as '<FONT SIZE="-1"><SUP>&#9697;</SUP></FONT>'; /* or 8995 */
  latexdef "`'" as "{}^{\smallsmile}";
htmldef "dom" as
    "<IMG SRC='_dom.gif' WIDTH=26 HEIGHT=19 ALT=' dom' TITLE='dom'> ";
  althtmldef "dom" as 'dom ';
  latexdef "dom" as "{\rm dom}";
htmldef "ran" as
    "<IMG SRC='_ran.gif' WIDTH=22 HEIGHT=19 ALT=' ran' TITLE='ran'> ";
  althtmldef "ran" as 'ran ';
  latexdef "ran" as "{\rm ran}";
htmldef "|`" as " <IMG SRC='restriction.gif' WIDTH=5 HEIGHT=19 ALT=' |`'" +
    " TITLE='|`'> ";
  althtmldef "|`" as ' &#8638; '; /* &uharr; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|`" as "\restriction";
htmldef '"' as "<IMG SRC='backquote.gif' WIDTH=7 HEIGHT=19 ALT=' " + '"' +
    "' TITLE='" + '"' + "'>";
  althtmldef '"' as ' &ldquo; '; /* &#8220; */
  latexdef '"' as "``";
htmldef "o." as
    " <IMG SRC='circ.gif' WIDTH=8 HEIGHT=19 ALT=' o.' TITLE='o.'> ";
  althtmldef "o." as ' &#8728; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "o." as "\circ";
htmldef "Rel" as
    "<IMG SRC='_rel.gif' WIDTH=22 HEIGHT=19 ALT=' Rel' TITLE='Rel'> ";
  althtmldef "Rel" as 'Rel ';
  latexdef "Rel" as "{\rm Rel}";
htmldef "Fun" as
    "<IMG SRC='_fun.gif' WIDTH=25 HEIGHT=19 ALT=' Fun' TITLE='Fun'> ";
  althtmldef "Fun" as 'Fun ';
  latexdef "Fun" as "{\rm Fun}";
htmldef "Fn" as
    " <IMG SRC='_fn.gif' WIDTH=17 HEIGHT=19 ALT=' Fn' TITLE='Fn'> ";
  althtmldef "Fn" as ' Fn ';
  latexdef "Fn" as "{\rm Fn}";
htmldef ":" as "<IMG SRC='colon.gif' WIDTH=4 HEIGHT=19 ALT=' :' TITLE=':'>";
  althtmldef ":" as ':';
  latexdef ":" as ":";
htmldef "-->" as
  "<IMG SRC='longrightarrow.gif' WIDTH=23 HEIGHT=19 " +
    "ALT=' --&gt;' TITLE='--&gt;'>";
  /* althtmldef "-->" as '&ndash;&rarr;'; */
  althtmldef "-->" as '&#x27F6;';
    /* &#xAD;&#x2010;&ndash;&mdash;&minus; (possible symbols test) */
  latexdef "-->" as "\longrightarrow";
htmldef "-1-1->" as "<IMG SRC='onetoone.gif' WIDTH=23 HEIGHT=19 " +
    "ALT=' -1-1-&gt;' TITLE='-1-1-&gt;'>";
  althtmldef "-1-1->" as
    '&ndash;<FONT SIZE=-2 FACE=sans-serif>1-1</FONT>&rarr;';
  latexdef "-1-1->" as
    "\raisebox{.5ex}{${\textstyle{\:}_{\mbox{\footnotesize\rm 1" +
    "\tt -\rm 1}}}\atop{\textstyle{" +
    "\longrightarrow}\atop{\textstyle{}^{\mbox{\footnotesize\rm {\ }}}}}$}";
htmldef "-onto->" as
    "<IMG SRC='onto.gif' WIDTH=23 HEIGHT=19 " +
    "ALT=' -onto-&gt;' TITLE='-onto-&gt;'>";
  althtmldef "-onto->" as
    '&ndash;<FONT SIZE=-2 FACE=sans-serif>onto</FONT>&rarr;';
  latexdef "-onto->" as
    "\raisebox{.5ex}{${\textstyle{\:}_{\mbox{\footnotesize\rm {\ }}}}" +
    "\atop{\textstyle{" +
    "\longrightarrow}\atop{\textstyle{}^{\mbox{\footnotesize\rm onto}}}}$}";
htmldef "-1-1-onto->" as "<IMG SRC='onetooneonto.gif' WIDTH=23 HEIGHT=19 " +
    "ALT=' -1-1-onto-&gt;' TITLE='-1-1-onto-&gt;'>";
  althtmldef "-1-1-onto->" as '&ndash;<FONT SIZE=-2 '
    + 'FACE=sans-serif>1-1</FONT>-<FONT SIZE=-2 '
    + 'FACE=sans-serif>onto</FONT>&rarr;';
  latexdef "-1-1-onto->" as
    "\raisebox{.5ex}{${\textstyle{\:}_{\mbox{\footnotesize\rm 1" +
    "\tt -\rm 1}}}\atop{\textstyle{" +
    "\longrightarrow}\atop{\textstyle{}^{\mbox{\footnotesize\rm onto}}}}$}";
htmldef "`" as
    "<IMG SRC='backtick.gif' WIDTH=4 HEIGHT=19 ALT=' ` ' TITLE='` '>";
    /* Above, IE7 _printing_ is corrupted by '`'; use '` ' which works */
  /*althtmldef "`" as ' &lsquo;';*/
  /* I took out the leading space to make e.g. ( log ` A ) look better.
     I added the leading space a long time ago because the quote overlapped
     the character to its left, making it sometimes hidden, but that seems
     to be no longer a problem with the XITS font. - 29-Aug-2017 nm */
  althtmldef "`" as '&lsquo;';
  latexdef "`" as "`";
htmldef "Isom" as
    " <IMG SRC='_isom.gif' WIDTH=30 HEIGHT=19 ALT=' Isom' TITLE='Isom'> ";
  althtmldef "Isom" as ' Isom ';
  latexdef "Isom" as "{\rm Isom}";
htmldef "oF" as
    " <IMG SRC='circ.gif' WIDTH=8 HEIGHT=19 ALT=' o' TITLE='o'>" +
    "<IMG SRC='subf.gif' WIDTH=6 HEIGHT=19 ALT=' F' TITLE='F'>";
  althtmldef "oF" as " &#8728;<SUB>&#x1D453;</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "oF" as "\circ_f";
htmldef "oR" as
    " <IMG SRC='circ.gif' WIDTH=8 HEIGHT=19 ALT=' o' TITLE='o'>" +
    "<IMG SRC='subr.gif' WIDTH=5 HEIGHT=19 ALT=' R' TITLE='R'>";
  althtmldef "oR" as " &#8728;<SUB>&#x1D45F;</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "oR" as "\circ_r";
htmldef "1st" as
    "<IMG SRC='_1st.gif' WIDTH=15 HEIGHT=19 ALT=' 1st' TITLE='1st'>";
  althtmldef "1st" as '1<SUP>st</SUP> ';
  latexdef "1st" as "1^{\rm st}";
htmldef "2nd" as
    "<IMG SRC='_2nd.gif' WIDTH=21 HEIGHT=19 ALT=' 2nd' TITLE='2nd'>";
  althtmldef "2nd" as '2<SUP>nd</SUP> ';
  latexdef "2nd" as "2^{\rm nd}";
htmldef "tpos" as "tpos ";
  althtmldef "tpos" as 'tpos ';
  latexdef "tpos" as "{\rm tpos}";
htmldef "curry" as "curry ";
  althtmldef "curry" as 'curry ';
  latexdef "curry" as "{\rm curry}";
htmldef "uncurry" as "uncurry ";
  althtmldef "uncurry" as 'uncurry ';
  latexdef "uncurry" as "{\rm uncurry}";
htmldef "[C.]" as
    " [<IMG SRC='subset.gif' WIDTH=12 HEIGHT=19 ALT=' C.' TITLE='C.'>] ";
  althtmldef "[C.]" as " [<B>&sub;</B>] ";
  latexdef "[C.]" as "{\rm [C.]}";
/*
htmldef "iota" as
    "<IMG SRC='iota.gif' WIDTH=6 HEIGHT=19 ALT=' iota' TITLE='iota'>";
  althtmldef "iota" as '<FONT SIZE="+1">&iota;</FONT>';
  latexdef "iota" as "\iota";
*/
/* 30-Nov-2013 changed to rotated iota */
htmldef "iota" as
    "<IMG SRC='riota.gif' WIDTH=6 HEIGHT=19 ALT=' iota' TITLE='iota'>";
  althtmldef "iota" as '&#8489;';
  latexdef "iota" as "\mathrm{\rotatebox[origin=C]{180}{$\iota$}}";
htmldef "Smo" as
    "<IMG SRC='_smo.gif' WIDTH=27 HEIGHT=19 ALT=' Smo' TITLE='Smo'> ";
  althtmldef "Smo" as "Smo ";
  latexdef "Smo" as "{\rm Smo}";
htmldef "recs" as "recs";
  althtmldef "recs" as "recs";
  latexdef "recs" as "\mathrm{recs}";
htmldef "rec" as
    "<IMG SRC='_rec.gif' WIDTH=21 HEIGHT=19 ALT=' rec' TITLE='rec'>";
  althtmldef "rec" as 'rec';
  latexdef "rec" as "{\rm rec}";
htmldef "seqom" as "seq<SUB>&#x1D714;</SUB>";
  althtmldef "seqom" as "seq<SUB>&#x1D714;</SUB>";
  latexdef "seqom" as "{\rm seqom}";
htmldef "1o" as "<IMG SRC='_1o.gif' WIDTH=13 HEIGHT=19 ALT=' 1o' TITLE='1o'>";
  althtmldef "1o" as '1<SUB>&#x1D45C;</SUB>';
  latexdef "1o" as "1_o";
htmldef "2o" as "<IMG SRC='_2o.gif' WIDTH=14 HEIGHT=19 ALT=' 2o' TITLE='2o'>";
  althtmldef "2o" as '2<SUB>&#x1D45C;</SUB>';
  latexdef "2o" as "2_o";
htmldef "3o" as "<IMG SRC='_3o.gif' WIDTH=14 HEIGHT=19 ALT=' 3o' TITLE='3o'>";
  althtmldef "3o" as "3<SUB>&#x1D45C;</SUB>"; latexdef "3o" as "3_o";
htmldef "4o" as "<IMG SRC='_4o.gif' WIDTH=15 HEIGHT=19 ALT=' 4o' TITLE='4o'>";
  althtmldef "4o" as "4<SUB>&#x1D45C;</SUB>"; latexdef "4o" as "4_o";
htmldef "+o" as
    " <IMG SRC='_plo.gif' WIDTH=18 HEIGHT=19 ALT=' +o' TITLE='+o'> ";
  althtmldef "+o" as ' +<SUB>&#x1D45C;</SUB> ';
  latexdef "+o" as "+_o";
htmldef ".o" as
    " <IMG SRC='_cdo.gif' WIDTH=10 HEIGHT=19 ALT=' .o' TITLE='.o'> ";
  althtmldef ".o" as ' &middot;<SUB>&#x1D45C;</SUB> ';
  latexdef ".o" as "\cdot_o";
htmldef "^o" as
    " <IMG SRC='_hato.gif' WIDTH=11 HEIGHT=19 ALT=' ^o' TITLE='^o'> ";
  althtmldef "^o" as ' &uarr;<SUB>&#x1D45C;</SUB> ';
  latexdef "^o" as "\uparrow_o"; /*
  latexdef "^o" as "\hat{\ }_o"; */
htmldef "Er" as
    " <IMG SRC='_er.gif' WIDTH=16 HEIGHT=19 ALT=' Er' TITLE='Er'> ";
  althtmldef "Er" as ' Er ';
  latexdef "Er" as "{\rm Er}";
htmldef "/." as
    "<IMG SRC='diagup.gif' WIDTH=14 HEIGHT=19 ALT=' /.' TITLE='/.'>";
  althtmldef "/." as ' <B>/</B> ';
  latexdef "/." as "\diagup";
htmldef "^m" as
    " <IMG SRC='_hatm.gif' WIDTH=15 HEIGHT=19 ALT=' ^m' TITLE='^m'> ";
  althtmldef "^m" as ' &uarr;<SUB>&#x1D45A;</SUB> ';
  latexdef "^m" as "\uparrow_m";
htmldef "^pm" as
    " <IMG SRC='_hatpm.gif' WIDTH=21 HEIGHT=19 ALT=' ^pm' TITLE='^pm'> ";
  althtmldef "^pm" as ' &uarr;<SUB><I>pm</I></SUB> ';
  latexdef "^pm" as "\uparrow_{pm}";
htmldef "X_" as
    "<IMG SRC='_bigtimes.gif' WIDTH=11 HEIGHT=19 ALT=' X_' TITLE='X_'>";
  althtmldef "X_" as '<FONT SIZE="+1">X</FONT>';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "X_" as "\mbox{\large\boldmath$\times$}";
htmldef "~~" as
    " <IMG SRC='approx.gif' WIDTH=13 HEIGHT=19 ALT=' ~~' TITLE='~~'> ";
  althtmldef "~~" as ' &#8776; '; /* &ap; */
  latexdef "~~" as "\approx";
htmldef "~<_" as
   " <IMG SRC='preccurlyeq.gif' WIDTH=11 HEIGHT=19 " +
    "ALT=' ~&lt;_' TITLE='~&lt;_'> ";
  althtmldef "~<_" as ' &#8828; '; /* &prcue; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~<_" as "\preccurlyeq";
htmldef "~<" as
    " <IMG SRC='prec.gif' WIDTH=11 HEIGHT=19 ALT=' ~&lt;' TITLE='~&lt;'> ";
  althtmldef "~<" as ' &#8826; '; /* &pr; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~<" as "\prec";
htmldef "Fin" as
    "<IMG SRC='_fin.gif' WIDTH=21 HEIGHT=19 ALT=' Fin' TITLE='Fin'>";
  althtmldef "Fin" as 'Fin';
  latexdef "Fin" as "{\rm Fin}";
htmldef "Undef" as
    "<IMG SRC='_undef.gif' WIDTH=39 HEIGHT=19 ALT=' Undef' TITLE='Undef'>";
  althtmldef "Undef" as "Undef";
  latexdef "Undef" as "{\rm Undef}";
htmldef "iota_" as
    "<IMG SRC='_riotabar.gif' WIDTH=6 HEIGHT=19 ALT=' iota_' TITLE='iota_'>";
  althtmldef "iota_" as '<U>&#8489;</U> ';
  latexdef "iota_" as
      "\underline{\mathrm{\rotatebox[origin=C]{180}{$\iota$}}}";
htmldef "fi" as
    "<IMG SRC='_fi.gif' WIDTH=10 HEIGHT=19 ALT=' fi' TITLE='fi'>";
  althtmldef "fi" as "fi";
  latexdef "fi" as "{\rm fi}";
htmldef "sup" as
    "<IMG SRC='_sup.gif' WIDTH=22 HEIGHT=19 ALT=' sup' TITLE='sup'>";
  althtmldef "sup" as 'sup';
  latexdef "sup" as "{\rm sup}";
htmldef "OrdIso" as "OrdIso";
  althtmldef "OrdIso" as 'OrdIso';
  latexdef "OrdIso" as "{\rm OrdIso}";
/* the standard symbol for this is \aleph, but that collides */
htmldef "har" as "har";
  althtmldef "har" as "har";
  latexdef "har" as "{\rm har}";
htmldef "~<_*" as " <IMG SRC='preccurlyeq.gif' WIDTH=11 HEIGHT=19 " +
   "ALT=' ~&lt;_' TITLE='~&lt;_'><SUP>*</SUP> ";
  althtmldef "~<_*" as ' &#8828;<SUP>*</SUP> ';
  /* &prcue; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~<_*" as "\preccurlyeq^*";
htmldef "CNF" as " CNF ";
  althtmldef "CNF" as " CNF ";
  latexdef "CNF" as " {\rm CNF} ";
htmldef "TC" as
    "<IMG SRC='_tc.gif' WIDTH=20 HEIGHT=19 ALT=' TC' TITLE='TC'>";
  althtmldef "TC" as "TC";
  latexdef "TC" as "{\rm TC}";
htmldef "R1" as "<IMG SRC='_r1.gif' WIDTH=15 HEIGHT=19 ALT=' R1' TITLE='R1'>";
  althtmldef "R1" as '&#x1D445;<SUB>1</SUB>';
  latexdef "R1" as "R_1";
htmldef "rank" as
    "<IMG SRC='_rank.gif' WIDTH=30 HEIGHT=19 ALT=' rank' TITLE='rank'>";
  althtmldef "rank" as 'rank';
  latexdef "rank" as "{\rm rank}";
htmldef "card" as
    "<IMG SRC='_card.gif' WIDTH=30 HEIGHT=19 ALT=' card' TITLE='card'>";
  althtmldef "card" as 'card';
  latexdef "card" as "{\rm card}";
htmldef "aleph" as
    "<IMG SRC='varaleph.gif' WIDTH=12 HEIGHT=19 ALT=' aleph' TITLE='aleph'>";
  althtmldef "aleph" as '&#8501;'; /* &aleph; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "aleph" as "\aleph";
htmldef "cf" as
    "<IMG SRC='_cofin.gif' WIDTH=14 HEIGHT=19 ALT=' cf' TITLE='cf'>";
  althtmldef "cf" as 'cf';
  latexdef "cf" as "{\rm cf}";
htmldef "AC_" as '<U>AC</U> ';
  althtmldef "AC_" as '<U>AC</U> ';
  latexdef "AC_" as "\underline{\rm AC}";
htmldef "CHOICE" as "<SMALL>CHOICE</SMALL>";
  althtmldef "CHOICE" as "<SMALL>CHOICE</SMALL>";
  latexdef "CHOICE" as "\mathrm{CHOICE}";
htmldef "+c" as
    " <IMG SRC='_plc.gif' WIDTH=17 HEIGHT=19 ALT=' +c' TITLE='+c'> ";
  althtmldef "+c" as ' +<SUB>&#x1D450;</SUB> ';
  latexdef "+c" as "+_c";
htmldef "Fin1a" as "Fin<SUP>Ia</SUP>";
  althtmldef "Fin1a" as "Fin<SUP>Ia</SUP>";
  latexdef "Fin1a" as "{\rm Fin1a}";
htmldef "Fin2" as "Fin<SUP>II</SUP>";
  althtmldef "Fin2" as "Fin<SUP>II</SUP>";
  latexdef "Fin2" as "{\rm Fin2}";
htmldef "Fin3" as "Fin<SUP>III</SUP>";
  althtmldef "Fin3" as "Fin<SUP>III</SUP>";
  latexdef "Fin3" as "{\rm Fin3}";
htmldef "Fin4" as "Fin<SUP>IV</SUP>";
  althtmldef "Fin4" as "Fin<SUP>IV</SUP>";
  latexdef "Fin4" as "{\rm Fin4}";
htmldef "Fin5" as "Fin<SUP>V</SUP>";
  althtmldef "Fin5" as "Fin<SUP>V</SUP>";
  latexdef "Fin5" as "{\rm Fin5}";
htmldef "Fin6" as "Fin<SUP>VI</SUP>";
  althtmldef "Fin6" as "Fin<SUP>VI</SUP>";
  latexdef "Fin6" as "{\rm Fin6}";
htmldef "Fin7" as "Fin<SUP>VII</SUP>";
  althtmldef "Fin7" as "Fin<SUP>VII</SUP>";
  latexdef "Fin7" as "{\rm Fin7}";
htmldef "GCH" as "GCH";
  althtmldef "GCH" as "GCH";
  latexdef "GCH" as "{\rm GCH}";
htmldef "WUni" as "WUni";
  althtmldef "WUni" as "WUni";
  latexdef "WUni" as "{\rm WUni}";
htmldef "wUniCl" as "wUniCl";
  althtmldef "wUniCl" as "wUniCl";
  latexdef "wUniCl" as "{\rm wUniCl}";
htmldef "InaccW" as
    "<IMG SRC='_inacc.gif' WIDTH=34 HEIGHT=19 ALT=' Inacc' TITLE='Inacc'>" +
    "<IMG SRC='subw.gif' WIDTH=7 HEIGHT=19 ALT=' W' TITLE='W'>";
  althtmldef "InaccW" as " Inacc<SUB>&#x1D464;</SUB> ";
  latexdef "InaccW" as "{\rm Inacc}_w";
htmldef "Inacc" as
    "<IMG SRC='_inacc.gif' WIDTH=34 HEIGHT=19 ALT=' Inacc' TITLE='Inacc'>";
  althtmldef "Inacc" as "Inacc";
  latexdef "Inacc" as "{\rm Inacc}";
htmldef "Tarski" as
    "<IMG SRC='_tarski.gif' WIDTH=40 HEIGHT=19 ALT=' Tarski' TITLE='Tarski'>";
  althtmldef "Tarski" as "Tarski";
  latexdef "Tarski" as "{\rm Tarski}";
htmldef "Univ" as
    "<IMG SRC='_univ.gif' WIDTH=30 HEIGHT=19 ALT=' Univ' TITLE='Univ'>";
  althtmldef "Univ" as "Univ";
  latexdef "Univ" as "{\rm Univ}";
htmldef "tarskiMap" as "<IMG SRC='_tarskimap.gif' WIDTH=66 HEIGHT=19 " +
    "ALT=' tarskiMap' TITLE='tarskiMap'>";
  althtmldef "tarskiMap" as "tarskiMap";
  latexdef "tarskiMap" as "{\rm tarskiMap}";
htmldef "N." as "<IMG SRC='caln.gif' WIDTH=17 HEIGHT=19 ALT=' N.' TITLE='N.'>";
  althtmldef "N." as '<I><B>N</B></I>';
  latexdef "N." as "{\cal N}";
htmldef "+N" as
    " <IMG SRC='_pln.gif' WIDTH=22 HEIGHT=19 ALT=' +N' TITLE='+N'> ";
  althtmldef "+N" as ' +<I><SUB><B>N</B></SUB></I> ';
  latexdef "+N" as "+_{\cal N}";
htmldef ".N" as
    " <IMG SRC='_cdn.gif' WIDTH=14 HEIGHT=19 ALT=' .N' TITLE='.N'> ";
  althtmldef ".N" as ' &middot;<I><SUB><B>N</B></SUB></I> ';
  latexdef ".N" as "\cdot_{\cal N}";
htmldef "<N" as
    " <IMG SRC='_ltn.gif' WIDTH=21 HEIGHT=19 ALT=' &lt;N' TITLE='&lt;N'> ";
  althtmldef "<N" as ' &lt;<I><SUB><B>N</B></SUB></I> ';
  latexdef "<N" as "<_{\cal N}";
htmldef "+pQ" as
    " <IMG SRC='_plpq.gif' WIDTH=28 HEIGHT=19 ALT=' +pQ' TITLE='+pQ'> ";
  althtmldef "+pQ" as ' +<I><SUB>p<B>Q</B></SUB></I> ';
  latexdef "+pQ" as "+_{p{\cal Q}}";
htmldef ".pQ" as
    " <IMG SRC='_cdpq.gif' WIDTH=19 HEIGHT=19 ALT=' .pQ' TITLE='.pQ'> ";
  althtmldef ".pQ" as ' &middot;<I><SUB>p<B>Q</B></SUB></I> ';
  latexdef ".pQ" as "\cdot_{p{\cal Q}}";
htmldef "<pQ" as
    " <IMG SRC='_ltpq.gif' WIDTH=27 HEIGHT=19 ALT=' &lt;pQ' TITLE='&lt;pQ'> ";
  althtmldef "<pQ" as ' &lt;<I><SUB>p<B>Q</B></SUB></I> ';
  latexdef "<pQ" as "<_{p{\cal Q}}";
htmldef "~Q" as
    " <IMG SRC='_simq.gif' WIDTH=21 HEIGHT=19 ALT=' ~Q' TITLE='~Q'> ";
  althtmldef "~Q" as ' ~<I><SUB><B>Q</B></SUB></I> ';
  latexdef "~Q" as "\sim_{\cal Q}";
htmldef "Q." as "<IMG SRC='calq.gif' WIDTH=12 HEIGHT=19 ALT=' Q.' TITLE='Q.'>";
  althtmldef "Q." as '<I><B>Q</B></I>';
  latexdef "Q." as "{\cal Q}";
htmldef "1Q" as "<IMG SRC='_1q.gif' WIDTH=16 HEIGHT=19 ALT=' 1Q' TITLE='1Q'>";
  althtmldef "1Q" as '1<I><SUB><B>Q</B></SUB></I>';
  latexdef "1Q" as "1_{\cal Q}";
htmldef "/Q" as "<IMG SRC='_erq.gif' WIDTH=17 HEIGHT=19 ALT=' /Q' TITLE='/Q'>";
  althtmldef "/Q" as '[<I><B>Q</B></I>]';
  latexdef "/Q" as "[{\cal Q}]";
htmldef "+Q" as
    " <IMG SRC='_plq.gif' WIDTH=21 HEIGHT=19 ALT=' +Q' TITLE='+Q'> ";
  althtmldef "+Q" as ' +<I><SUB><B>Q</B></SUB></I> ';
  latexdef "+Q" as "+_{\cal Q}";
htmldef ".Q" as
    " <IMG SRC='_cdq.gif' WIDTH=13 HEIGHT=19 ALT=' .Q' TITLE='.Q'> ";
  althtmldef ".Q" as ' &middot;<I><SUB><B>Q</B></SUB></I> ';
  latexdef ".Q" as "\cdot_{\cal Q}";
htmldef "*Q" as
    "<IMG SRC='_astq.gif' WIDTH=16 HEIGHT=19 ALT=' *Q' TITLE='*Q'>";
  althtmldef "*Q" as '*<I><SUB><B>Q</B></SUB></I>';
  latexdef "*Q" as "\ast_{\cal Q}";
htmldef "<Q" as
    " <IMG SRC='_ltq.gif' WIDTH=20 HEIGHT=19 ALT=' &lt;Q' TITLE='&lt;Q'> ";
  althtmldef "<Q" as ' &lt;<I><SUB><B>Q</B></SUB></I> ';
  latexdef "<Q" as "<_{\cal Q}";
htmldef "P." as "<IMG SRC='calp.gif' WIDTH=13 HEIGHT=19 ALT=' P.' TITLE='P.'>";
  althtmldef "P." as '<I><B>P</B></I>';
  latexdef "P." as "{\cal P}";
htmldef "1P" as "<IMG SRC='_1p.gif' WIDTH=15 HEIGHT=19 ALT=' 1P' TITLE='1P'>";
  althtmldef "1P" as '1<I><SUB><B>P</B></SUB></I>';
  latexdef "1P" as "1_{\cal P}";
htmldef "+P." as
    " <IMG SRC='_plp.gif' WIDTH=22 HEIGHT=19 ALT=' +P.' TITLE='+P.'> ";
  althtmldef "+P." as ' +<I><SUB><B>P</B></SUB></I> ';
  latexdef "+P." as "+_{\cal P}";
htmldef ".P." as
    " <IMG SRC='_cdp.gif' WIDTH=13 HEIGHT=19 ALT=' .P.' TITLE='.P.'> ";
  althtmldef ".P." as ' &middot;<I><SUB><B>P</B></SUB></I> ';
  latexdef ".P." as "\cdot_{\cal P}";
htmldef "<P" as
    " <IMG SRC='_ltp.gif' WIDTH=19 HEIGHT=19 ALT=' &lt;P' TITLE='&lt;P'> ";
  althtmldef "<P" as '&lt;<I><SUB><B>P</B></SUB></I> ';
  latexdef "<P" as "<_{\cal P}";
htmldef "+pR" as
    " <IMG SRC='_plpr.gif' WIDTH=28 HEIGHT=19 ALT=' +pR' TITLE='+pR'> ";
  althtmldef "+pR" as ' +<I><SUB>p<B>R</B></SUB></I> ';
  latexdef "+pR" as "+_{p{\cal R}}";
htmldef ".pR" as
    " <IMG SRC='_cdpr.gif' WIDTH=19 HEIGHT=19 ALT=' .pR' TITLE='.pR'> ";
  althtmldef ".pR" as ' &middot;<I><SUB>p<B>R</B></SUB></I> ';
  latexdef ".pR" as "._{p{\cal R}}";
htmldef "~R" as
    " <IMG SRC='_simr.gif' WIDTH=23 HEIGHT=19 ALT=' ~R' TITLE='~R'> ";
  althtmldef "~R" as ' ~<I><SUB><B>R</B></SUB></I> ';
  latexdef "~R" as "\sim_{\cal R}";
htmldef "R." as "<IMG SRC='calr.gif' WIDTH=15 HEIGHT=19 ALT=' R.' TITLE='R.'>";
  althtmldef "R." as '<I><B>R</B></I>';
  latexdef "R." as "{\cal R}";
htmldef "0R" as "<IMG SRC='_0r.gif' WIDTH=18 HEIGHT=19 ALT=' 0R' TITLE='0R'>";
  althtmldef "0R" as '0<I><SUB><B>R</B></SUB></I>';
  latexdef "0R" as "0_{\cal R}";
htmldef "1R" as "<IMG SRC='_1cr.gif' WIDTH=16 HEIGHT=19 ALT=' 1R' TITLE='1R'>";
  althtmldef "1R" as '1<I><SUB><B>R</B></SUB></I>';
  latexdef "1R" as "1_{\cal R}";
htmldef "-1R" as
    "<IMG SRC='_m1r.gif' WIDTH=22 HEIGHT=19 ALT=' -1R' TITLE='-1R'>";
  althtmldef "-1R" as '-1<I><SUB><B>R</B></SUB></I>';
  latexdef "-1R" as "-1_{\cal R}";
htmldef "+R" as
    " <IMG SRC='_plr.gif' WIDTH=23 HEIGHT=19 ALT=' +R' TITLE='+R'> ";
  althtmldef "+R" as ' +<I><SUB><B>R</B></SUB></I> ';
  latexdef "+R" as "+_{\cal R}";
htmldef ".R" as
    " <IMG SRC='_cdcr.gif' WIDTH=14 HEIGHT=19 ALT=' .R' TITLE='.R'> ";
  althtmldef ".R" as ' &middot;<I><SUB><B>R</B></SUB></I> ';
  latexdef ".R" as "\cdot_{\cal R}";
htmldef "<R" as
    " <IMG SRC='_ltr.gif' WIDTH=20 HEIGHT=19 ALT=' &lt;R' TITLE='&lt;R'> ";
  althtmldef "<R" as ' &lt;<I><SUB><B>R</B></SUB></I> ';
  latexdef "<R" as "<_{\cal R}";
htmldef "<RR" as
    " <IMG SRC='_ltbbr.gif' WIDTH=20 HEIGHT=19 ALT=' &lt;RR' TITLE='&lt;RR'> ";
  althtmldef "<RR" as ' &lt;<SUB>&#8477;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "<RR" as "<_\mathbb{R}";
htmldef "CC" as "<IMG SRC='bbc.gif' WIDTH=12 HEIGHT=19 ALT=' CC' TITLE='CC'>";
  althtmldef "CC" as '&#8450;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "CC" as "\mathbb{C}";
htmldef "RR" as "<IMG SRC='bbr.gif' WIDTH=13 HEIGHT=19 ALT=' RR' TITLE='RR'>";
  althtmldef "RR" as '&#8477;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "RR" as "\mathbb{R}";
    /*latexdef "" as "_{10}";*/
    /*latexdef "" as "";*/
    /* suppress base 10 suffix */
htmldef "0" as "<IMG SRC='0.gif' WIDTH=8 HEIGHT=19 ALT=' 0' TITLE='0'>";
  althtmldef "0" as '0';
  latexdef "0" as "0";
htmldef "1" as "<IMG SRC='1.gif' WIDTH=7 HEIGHT=19 ALT=' 1' TITLE='1'>";
  althtmldef "1" as '1';
  latexdef "1" as "1";
htmldef "_i" as "<IMG SRC='rmi.gif' WIDTH=4 HEIGHT=19 ALT=' _i' TITLE='_i'>";
  althtmldef "_i" as 'i';
  latexdef "_i" as "{\rm i}";
htmldef "+" as " <IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'> ";
  althtmldef "+" as ' + ';
  latexdef "+" as "+";
htmldef "x." as
    " <IMG SRC='cdot.gif' WIDTH=4 HEIGHT=19 ALT=' x.' TITLE='x.'> ";
  althtmldef "x." as ' &middot; '; /* what is &#xb7; ? */
  latexdef "x." as "\cdot";
htmldef "<_" as
    " <IMG SRC='le.gif' WIDTH=11 HEIGHT=19 ALT=' &lt;_' TITLE='&lt;_'> ";
  althtmldef "<_" as ' &le; ';
  latexdef "<_" as "\le";
htmldef "+oo" as " <IMG SRC='_pinf.gif' WIDTH=29 HEIGHT=19 ALT=' +oo' " +
    "TITLE='+oo'>";
  althtmldef "+oo" as ' +&infin;';
  latexdef "+oo" as "+\infty";
htmldef "-oo" as " <IMG SRC='_minf.gif' WIDTH=24 HEIGHT=19 ALT=' -oo' " +
    "TITLE='-oo'>";
  althtmldef "-oo" as ' -&infin;';
  latexdef "-oo" as "-\infty";
htmldef "RR*" as "<IMG SRC='_bbrast.gif' WIDTH=18 HEIGHT=19 ALT=' RR*' " +
    "TITLE='RR*'>";
  althtmldef "RR*" as '&#8477;<SUP>*</SUP>';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "RR*" as "\mathbb{R}^*";
htmldef "<" as
    " <IMG SRC='lt.gif' WIDTH=11 HEIGHT=19 ALT=' &lt;' TITLE='&lt;'> ";
  althtmldef "<" as ' &lt; ';
  latexdef "<" as "<";
htmldef "-" as
    " <IMG SRC='minus.gif' WIDTH=11 HEIGHT=19 ALT=' -' TITLE='-'> ";
  althtmldef "-" as ' &minus; ';
  latexdef "-" as "-";
htmldef "-u" as
    "<IMG SRC='shortminus.gif' WIDTH=8 HEIGHT=19 ALT=' -u' TITLE='-u'>";
    /* use standard minus sign */
  althtmldef "-u" as '-';
  latexdef "-u" as "\textrm{-}"; /* short minus */
    /*latexdef "-u" as "-_u";*/
htmldef "NN" as "<IMG SRC='bbn.gif' WIDTH=12 HEIGHT=19 ALT=' NN' TITLE='NN'>";
  althtmldef "NN" as '&#8469;'; /* &Nopf; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "NN" as "\mathbb{N}";
htmldef "NN0" as
    "<IMG SRC='_bbn0.gif' WIDTH=19 HEIGHT=19 ALT=' NN0' TITLE='NN0'>";
  althtmldef "NN0" as '&#8469;<SUB>0</SUB>';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "NN0" as "\mathbb{N}_0";
htmldef "ZZ" as "<IMG SRC='bbz.gif' WIDTH=11 HEIGHT=19 ALT=' ZZ' TITLE='ZZ'>";
  althtmldef "ZZ" as '&#8484;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "ZZ" as "\mathbb{Z}";
htmldef "QQ" as "<IMG SRC='bbq.gif' WIDTH=13 HEIGHT=19 ALT=' QQ' TITLE='QQ'>";
  althtmldef "QQ" as '&#8474;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "QQ" as "\mathbb{Q}";
htmldef "RR+" as "<IMG SRC='_bbrplus.gif' WIDTH=20 HEIGHT=19 ALT=' RR+' " +
    "TITLE='RR+'>";
  althtmldef "RR+" as '&#8477;<SUP>+</SUP>';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "RR+" as "\mathbb{R}^+";
htmldef "2" as "<IMG SRC='2.gif' WIDTH=8 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "2" as '2';
  latexdef "2" as "2";
htmldef "3" as "<IMG SRC='3.gif' WIDTH=8 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "3" as '3';
  latexdef "3" as "3";
htmldef "4" as "<IMG SRC='4.gif' WIDTH=9 HEIGHT=19 ALT=' 4' TITLE='4'>";
  althtmldef "4" as '4';
  latexdef "4" as "4";
htmldef "5" as "<IMG SRC='5.gif' WIDTH=8 HEIGHT=19 ALT=' 5' TITLE='5'>";
  althtmldef "5" as '5';
  latexdef "5" as "5";
htmldef "6" as "<IMG SRC='6.gif' WIDTH=8 HEIGHT=19 ALT=' 6' TITLE='6'>";
  althtmldef "6" as '6';
  latexdef "6" as "6";
htmldef "7" as "<IMG SRC='7.gif' WIDTH=9 HEIGHT=19 ALT=' 7' TITLE='7'>";
  althtmldef "7" as '7';
  latexdef "7" as "7";
htmldef "8" as "<IMG SRC='8.gif' WIDTH=8 HEIGHT=19 ALT=' 8' TITLE='8'>";
  althtmldef "8" as '8';
  latexdef "8" as "8";
htmldef "9" as "<IMG SRC='9.gif' WIDTH=8 HEIGHT=19 ALT=' 9' TITLE='9'>";
  althtmldef "9" as '9';
  latexdef "9" as "9";
htmldef "10" as "<IMG SRC='_10.gif' WIDTH=14 HEIGHT=19 ALT=' 10' TITLE='10'>";
  althtmldef "10" as '10';
  latexdef "10" as "10";
htmldef ";" as '<FONT COLOR="#808080">;</FONT>';
  althtmldef ";" as '<SPAN CLASS=hidden STYLE="color:gray">;</SPAN>';
  latexdef ";" as "{\rm;}";
htmldef "ZZ>=" as "<IMG SRC='_bbzge.gif' WIDTH=20 HEIGHT=19 " +
    "ALT=' ZZ&gt;=' TITLE='ZZ&gt;='>";
  althtmldef "ZZ>=" as "&#8484;<SUB>&ge;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "ZZ>=" as "\mathbb{Z}_\ge";
htmldef "-e" as " <IMG SRC='shortminus.gif' WIDTH=8 HEIGHT=19 ALT=' -' " +
    "TITLE='-'><IMG SRC='sube.gif' WIDTH=6 HEIGHT=19 ALT=' e' TITLE='e'>";
  althtmldef "-e" as '-';
  latexdef "-e" as "\textrm{-}";
htmldef "+e" as "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>" +
    "<IMG SRC='sube.gif' WIDTH=6 HEIGHT=19 ALT=' e' TITLE='e'>";
  althtmldef "+e" as " +<SUB>&#x1D452;</SUB> ";
  latexdef "+e" as "+_e";
htmldef "*e" as "<IMG SRC='cdot.gif' WIDTH=4 HEIGHT=19 ALT=' x' TITLE='x'>" +
    "<IMG SRC='sube.gif' WIDTH=6 HEIGHT=19 ALT=' e' TITLE='e'>";
  althtmldef "*e" as  " &middot;<SUB>e</SUB> ";
  latexdef "*e" as "\cdot_e";
htmldef "(,)" as
    "<IMG SRC='_ioo.gif' WIDTH=13 HEIGHT=19 ALT=' (,)' TITLE='(,)'>";
  althtmldef "(,)" as "(,)";
  latexdef "(,)" as "(,)";
htmldef "(,]" as
    "<IMG SRC='_ioc.gif' WIDTH=12 HEIGHT=19 ALT=' (,]' TITLE='(,]'>";
  althtmldef "(,]" as "(,]";
  latexdef "(,]" as "(,]";
htmldef "[,)" as
    "<IMG SRC='_ico.gif' WIDTH=13 HEIGHT=19 ALT=' [,)' TITLE='[,)'>";
  althtmldef "[,)" as "[,)";
  latexdef "[,)" as "[,)";
htmldef "[,]" as
    "<IMG SRC='_icc.gif' WIDTH=12 HEIGHT=19 ALT=' [,]' TITLE='[,]'>";
  althtmldef "[,]" as "[,]";
  latexdef "[,]" as "[,]";
htmldef "..." as "<IMG SRC='ldots.gif' WIDTH=18 HEIGHT=19 " +
    "ALT=' ...' TITLE='...'>";
  althtmldef "..." as "...";
  latexdef "..." as "\ldots";
htmldef "..^" as "..^";
  althtmldef "..^" as "..^";
  latexdef "..^" as "..\^";
htmldef "|_" as "<IMG SRC='lfloor.gif' WIDTH=6 HEIGHT=19 ALT=' |_' " +
    "TITLE='|_'>";
  althtmldef "|_" as '&#8970;';
  latexdef "|_" as "\lfloor";
htmldef "mod" as " <IMG SRC='_mod.gif' WIDTH=29 HEIGHT=19 ALT=' mod' " +
    "TITLE='mod'> ";
  althtmldef "mod" as ' mod ';
  latexdef "mod" as "{\rm mod}";
htmldef "==" as " <IMG SRC='equiv.gif' WIDTH=12 HEIGHT=19 ALT=' ==' " +
    "TITLE='=='> ";
  althtmldef "==" as "&equiv;"; /* 2263 */
  latexdef "==" as "\equiv";
htmldef "seq" as " <IMG SRC='_seq.gif' WIDTH=22 HEIGHT=19 ALT=' seq' " +
    "TITLE='seq'> ";
  althtmldef "seq" as 'seq';
  latexdef "seq" as "{\rm seq}";
/*
htmldef "seq1" as " <IMG SRC='_seq1.gif' WIDTH=26 HEIGHT=19 ALT=' seq1' " +
    "TITLE='seq1'> ";
  althtmldef "seq1" as 'seq<SUB>1</SUB>';
  latexdef "seq1" as "{\rm seq}_1";
htmldef "seqz" as
    " <IMG SRC='_seq.gif' WIDTH=22 HEIGHT=19 ALT=' seq' TITLE='seq'>" +
    "<IMG SRC='__subbbz.gif' WIDTH=8 HEIGHT=19 ALT=' z' TITLE='z'> ";
  althtmldef "seqz" as 'seq<SUB><FONT FACE=sans-serif>&#8484;</FONT></SUB>';
  latexdef "seqz" as "{\rm seq}_\mathbb{Z}";
htmldef "seq0" as " <IMG SRC='_seq0.gif' WIDTH=27 HEIGHT=19 ALT=' seq0' " +
    "TITLE='seq0'> ";
  althtmldef "seq0" as 'seq<SUB>0</SUB>';
  latexdef "seq0" as "{\rm seq}_0";
*/
htmldef "^" as "<IMG SRC='uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' ^' TITLE='^'>";
  althtmldef "^" as '&uarr;';
  latexdef "^" as "\uparrow"; /*
  latexdef "^" as "\widehat{\ }"; */
htmldef "!" as "<IMG SRC='bang.gif' WIDTH=3 HEIGHT=19 ALT=' !' TITLE='!'>";
  althtmldef "!" as '!';
  latexdef "!" as "{!}";
htmldef "_C" as
    " <IMG SRC='rmcc.gif' WIDTH=10 HEIGHT=19 ALT=' _C' TITLE='_C'> ";
  althtmldef "_C" as 'C';
  latexdef "_C" as "{\rm C}";
htmldef "#" as
    "<IMG SRC='octothorpe.gif' WIDTH=13 HEIGHT=19 ALT=' #' TITLE='#'>";
  althtmldef "#" as "#";
  latexdef "#" as "#";
htmldef "shift" as " <IMG SRC='_shift.gif' WIDTH=30 HEIGHT=19 ALT=' shift' " +
    "TITLE='shift'> ";
  althtmldef "shift" as 'shift';
  latexdef "shift" as "{\rm shift}";
htmldef "Re" as "<IMG SRC='re.gif' WIDTH=12 HEIGHT=19 ALT=' Re' TITLE='Re'>";
  althtmldef "Re" as '&real;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "Re" as "\Re";
htmldef "Im" as "<IMG SRC='im.gif' WIDTH=12 HEIGHT=19 ALT=' Im' TITLE='Im'>";
  althtmldef "Im" as '&image;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "Im" as "\Im";
htmldef "*" as "<IMG SRC='ast.gif' WIDTH=7 HEIGHT=19 ALT=' *' TITLE='*'>";
  althtmldef "*" as '&lowast;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "*" as "*";
htmldef "sqr" as
    "<IMG SRC='surd.gif' WIDTH=14 HEIGHT=19 ALT=' sqr' TITLE='sqr'>";
  althtmldef "sqr" as '&radic;';
  latexdef "sqr" as "\surd";
htmldef "abs" as
    "<IMG SRC='_abs.gif' WIDTH=22 HEIGHT=19 ALT=' abs' TITLE='abs'>";
  althtmldef "abs" as 'abs';
  latexdef "abs" as "{\rm abs}";
htmldef "+-" as
    "<IMG SRC='pm.gif' WIDTH=14 HEIGHT=19 ALT=' pm' TITLE='pm'>";
  althtmldef "+-" as '&plusmn;';
  latexdef "+-" as "\pm";
htmldef "limsup" as
    "<IMG SRC='_limsup.gif' WIDTH=44 HEIGHT=19 ALT=' limsup' TITLE='limsup'>";
  althtmldef "limsup" as 'lim sup';
  latexdef "limsup" as "\limsup";
htmldef "~~>" as " <IMG SRC='rightsquigarrow.gif' WIDTH=15 HEIGHT=19 " +
    "ALT=' ~~&gt;' TITLE='~~&gt;'> ";
  althtmldef "~~>" as ' &#8669; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~~>" as '\rightsquigarrow';
htmldef "~~>r" as " <IMG SRC='rightsquigarrow.gif' WIDTH=15 HEIGHT=19 " +
    "ALT=' ~~&gt;' TITLE='~~&gt;'><IMG SRC='subr.gif' WIDTH=5 HEIGHT=19 " +
    "ALT=' r' TITLE='r'> ";
  althtmldef "~~>r" as
    ' &#8669;<SUB>&#x1D45F;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~~>r" as '\rightsquigarrow_r';
htmldef "O(1)" as "<IMG SRC='co.gif' WIDTH=12 HEIGHT=19 ALT=' O' TITLE='O'>" +
    "<IMG SRC='lp.gif' WIDTH=5 HEIGHT=19 ALT=' (' TITLE='('>" +
    "<IMG SRC='1.gif' WIDTH=7 HEIGHT=19 ALT=' 1' TITLE='1'>" +
    "<IMG SRC='rp.gif' WIDTH=5 HEIGHT=19 ALT=' )' TITLE=')'>";
  althtmldef "O(1)" as '&#x1D442;(1)';
  latexdef "O(1)" as "O(1)";
htmldef "<_O(1)" as
    "<IMG SRC='le.gif' WIDTH=11 HEIGHT=19 ALT=' &lt;_' TITLE='&lt;_'>" +
    "<IMG SRC='co.gif' WIDTH=12 HEIGHT=19 ALT=' O' TITLE='O'>" +
    "<IMG SRC='lp.gif' WIDTH=5 HEIGHT=19 ALT=' (' TITLE='('>" +
    "<IMG SRC='1.gif' WIDTH=7 HEIGHT=19 ALT=' 1' TITLE='1'>" +
    "<IMG SRC='rp.gif' WIDTH=5 HEIGHT=19 ALT=' )' TITLE=')'>";
  althtmldef "<_O(1)" as '&le;&#x1D442;(1)';
  latexdef "<_O(1)" as "\le O(1)";
htmldef "sum_" as "<IMG SRC='csigma.gif' WIDTH=11 HEIGHT=19 " +
    "ALT=' sum_' TITLE='sum_'>";
  althtmldef "sum_" as "&Sigma;";
  latexdef "sum_" as "\Sigma";
htmldef "exp" as
    "<IMG SRC='_exp.gif' WIDTH=24 HEIGHT=19 ALT=' exp' TITLE='exp'>";
  althtmldef "exp" as "exp";
  latexdef "exp" as "\exp";
htmldef "_e" as "<IMG SRC='rme.gif' WIDTH=7 HEIGHT=19 ALT=' _e' TITLE='_e'>";
  althtmldef "_e" as "e";
  latexdef "_e" as "{\rm e}";
htmldef "sin" as
    "<IMG SRC='_sin.gif' WIDTH=19 HEIGHT=19 ALT=' sin' TITLE='sin'>";
  althtmldef "sin" as "sin";
  latexdef "sin" as "\sin";
htmldef "cos" as
    "<IMG SRC='_cos.gif' WIDTH=21 HEIGHT=19 ALT=' cos' TITLE='cos'>";
  althtmldef "cos" as "cos";
  latexdef "cos" as "\cos";
htmldef "tan" as
    "<IMG SRC='_tan.gif' WIDTH=22 HEIGHT=19 ALT=' tan' TITLE='tan'>";
  althtmldef "tan" as "tan";
  latexdef "tan" as "\tan";
htmldef "pi" as "<IMG SRC='pi.gif' WIDTH=10 HEIGHT=19 ALT=' pi' TITLE='pi'>";
  althtmldef "pi" as "&#x1D70B;"; /* math italic pi */
  latexdef "pi" as "\pi";
htmldef "||" as " <IMG SRC='parallel.gif' WIDTH=5 HEIGHT=19 " +
    "ALT=' ||' TITLE='||'> ";
  althtmldef "||" as ' &#8741; ';
  latexdef "||" as " \parallel ";
htmldef "bits" as "bits";
  althtmldef "bits" as "bits";
  latexdef "bits" as "\mbox{bits}";
htmldef "sadd" as " sadd ";
  althtmldef "sadd" as " sadd ";
  latexdef "sadd" as "\mbox{sadd}";
htmldef "smul" as " smul ";
  althtmldef "smul" as " smul ";
  latexdef "smul" as "\mbox{smul}";
htmldef "gcd" as
    " <IMG SRC='_gcd.gif' WIDTH=23 HEIGHT=19 ALT=' gcd' TITLE='gcd'> ";
  althtmldef "gcd" as " gcd ";
  latexdef "gcd" as "\,{\rm gcd}\,";
htmldef "Prime" as
    "<IMG SRC='bbp.gif' WIDTH=11 HEIGHT=19 ALT=' Prime' TITLE='Prime'>";
  althtmldef "Prime" as "&#8473;";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "Prime" as "\mathbb{P}";
htmldef "odZ" as
    "<IMG SRC='_od.gif' WIDTH=15 HEIGHT=19 ALT=' od' TITLE='od'>" +
    "<IMG SRC='__subbbz.gif' WIDTH=8 HEIGHT=19 ALT=' Z' TITLE='Z'>";
  althtmldef "odZ" as "od<SUB>&#8484;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "odZ" as "{\rm od}_{\Bbb Z}";
htmldef "phi" as
    "<IMG SRC='phi.gif' WIDTH=10 HEIGHT=19 ALT=' phi' TITLE='phi'>";
  althtmldef "phi" as '&#981;';
  latexdef "phi" as "\phi";
htmldef "pCnt" as
    " <IMG SRC='_pcnt.gif' WIDTH=32 HEIGHT=19 ALT=' pCnt' TITLE='pCnt'> ";
  althtmldef "pCnt" as " pCnt ";
  latexdef "pCnt" as "\,{\rm pCnt}\,";
htmldef "Z[i]" as
    "<IMG SRC='bbz.gif' WIDTH=11 HEIGHT=19 ALT=' ZZ' TITLE='ZZ'>" +
    "<IMG SRC='lbrack.gif' WIDTH=5 HEIGHT=19 ALT=' [' TITLE='['>" +
    "<IMG SRC='rmi.gif' WIDTH=4 HEIGHT=19 ALT=' _i' TITLE='_i'>" +
    "<IMG SRC='rbrack.gif' WIDTH=5 HEIGHT=19 ALT=' ]' TITLE=']'>";
  althtmldef "Z[i]" as '&#8484;[i]';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "Z[i]" as "\mathbb{Z}[{\rm i}]";
htmldef "AP" as "AP";
  althtmldef "AP" as "AP";
  latexdef "AP" as "{\rm AP}";
htmldef "MonoAP" as " MonoAP ";
  althtmldef "MonoAP" as " MonoAP ";
  latexdef "MonoAP" as " {\rm MonoAP} ";
htmldef "PolyAP" as " PolyAP ";
  althtmldef "PolyAP" as " PolyAP ";
  latexdef "PolyAP" as " {\rm PolyAP} ";
htmldef "Ramsey" as " Ramsey ";
  althtmldef "Ramsey" as " Ramsey ";
  latexdef "Ramsey" as " {\rm Ramsey} ";
htmldef "Struct" as " Struct ";
  althtmldef "Struct" as " Struct ";
  latexdef "Struct" as " {\rm Struct} ";
htmldef "ndx" as
    "<IMG SRC='_ndx.gif' WIDTH=24 HEIGHT=19 ALT=' ndx' TITLE='ndx'>";
  althtmldef "ndx" as "ndx";
  latexdef "ndx" as "{\rm ndx}";
htmldef "sSet" as " sSet "; althtmldef "sSet" as " sSet ";
  latexdef "sSet" as "{\rm sSet}";
htmldef "Slot" as "Slot ";
  althtmldef "Slot" as "Slot ";
  latexdef "Slot" as "{\rm Slot} ";
htmldef "Base" as
    "<IMG SRC='_base.gif' WIDTH=30 HEIGHT=19 ALT=' Base' TITLE='Base'>";
  althtmldef "Base" as "Base";
  latexdef "Base" as "{\rm Base}";
htmldef "|`s" as " &#8638;<SUB>s</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  althtmldef "|`s" as " &#8638;<SUB>s</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|`s" as "\restriction_s";
htmldef "+g" as
    "<IMG SRC='_plusg.gif' WIDTH=19 HEIGHT=19 ALT=' +g' TITLE='+g'> ";
  althtmldef "+g" as "+<SUB>g</SUB>";
  latexdef "+g" as "+_{\rm g}";
htmldef ".r" as "<IMG SRC='_cdr.gif' WIDTH=10 HEIGHT=19 ALT=' .r' TITLE='.r'>";
  althtmldef ".r" as ".<SUB>r</SUB>";
  latexdef ".r" as "._{\rm r}";
htmldef "*r" as "<IMG SRC='ast.gif' WIDTH=7 HEIGHT=19 ALT=' *' TITLE='*'>" +
    "<IMG SRC='subr.gif' WIDTH=5 HEIGHT=19 ALT=' r' TITLE='r'>";
  althtmldef "*r" as "*<SUB>&#x1D45F;</SUB>";
  latexdef "*r" as "\ast_r";
htmldef "Scalar" as "Scalar";
  althtmldef "Scalar" as "Scalar";
  latexdef "Scalar" as "{\rm Scalar}";
htmldef ".s" as "<IMG SRC='_cds.gif' WIDTH=9 HEIGHT=19 ALT=' .s' TITLE='.s'>";
  althtmldef ".s" as ' <B>&middot;</B><SUB>&#x1D460;</SUB> ';
  latexdef ".s" as '\cdot_s';
htmldef ".i" as "<IMG SRC='_cdi.gif' WIDTH=7 HEIGHT=19 ALT=' .i' TITLE='.i'>";
  althtmldef ".i" as '<B>&middot;</B><SUB>&#x1D456;</SUB>';
  latexdef ".i" as '\cdot_i';
htmldef "TopSet" as "TopSet";
  althtmldef "TopSet" as "TopSet";
  latexdef "TopSet" as "{\rm TopSet}";
htmldef "le" as
    "<IMG SRC='_rmle.gif' WIDTH=11 HEIGHT=19 ALT=' le' TITLE='le'>";
  althtmldef "le" as "le";
  latexdef "le" as "{\rm le}";
htmldef "oc" as "<IMG SRC='_oc.gif' WIDTH=14 HEIGHT=19 ALT=' oc' TITLE='oc'>";
  althtmldef "oc" as "oc";
  latexdef "oc" as "{\rm oc}";
htmldef "dist" as
    "<IMG SRC='_dist.gif' WIDTH=24 HEIGHT=19 ALT=' dist' TITLE='dist'>";
  althtmldef "dist" as "dist";
  latexdef "dist" as "{\rm dist}";
htmldef "UnifSet" as
    "<IMG SRC='_unif.gif' WIDTH=28 HEIGHT=19 ALT=' UnifSet' TITLE='UnifSet'>";
  althtmldef "UnifSet" as "UnifSet";
  latexdef "UnifSet" as "{\rm UnifSet}";
htmldef "Hom" as
    " <IMG SRC='_hom.gif' WIDTH=27 HEIGHT=19 ALT=' Hom' TITLE='Hom'> ";
  althtmldef "Hom" as " Hom ";
  latexdef "Hom" as "{\rm Hom}";
htmldef "comp" as "comp";
  althtmldef "comp" as "comp";
  latexdef "comp" as "{\rm comp}";
htmldef "|`t" as " &#8638;<SUB>t</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  althtmldef "|`t" as " &#8638;<SUB>t</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|`t" as "\restriction_t";
htmldef "TopOpen" as
  "<IMG SRC='_topopen.gif' WIDTH=57 HEIGHT=19 ALT=' TopOpen' TITLE='TopOpen'>";
  althtmldef "TopOpen" as "TopOpen";
  latexdef "TopOpen" as "{\rm TopOpen}";
htmldef "topGen" as
    "<IMG SRC='_topgen.gif' WIDTH=47 HEIGHT=19 ALT=' topGen' TITLE='topGen'>";
  althtmldef "topGen" as "topGen";
  latexdef "topGen" as "{\rm topGen}";
htmldef "Xt_" as
    "<IMG SRC='_prodt.gif' WIDTH=17 HEIGHT=19 ALT=' Xt_' TITLE='Xt_'>";
  althtmldef "Xt_" as "&prod;<SUB>t</SUB>";
  latexdef "Xt_" as "\prod_t";
htmldef "Xs_" as "<IMG SRC='_bigtimes.gif' WIDTH=11 HEIGHT=19 ALT=' X_' " +
    "TITLE='X_'><sub><i>s</i></sub>";
  althtmldef "Xs_" as
    "<FONT SIZE='+1' FACE=sans-serif>X</FONT><sub><i>s</i></sub>";
  latexdef "Xs_" as "\mbox{\large\boldmath$\times$}_s";
htmldef "^s" as " <IMG SRC='uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' ^' " +
    "TITLE='^'><sub><i>s</i></sub> ";
  althtmldef "^s" as ' &uarr;<sub><i>s</i></sub> ';
  latexdef "^s" as " \uparrow_s ";
htmldef "ordTop" as "ordTop";
  althtmldef "ordTop" as "ordTop";
  latexdef "ordTop" as "{\rm ordTop}";
htmldef "RR*s" as
    "<IMG SRC='_bbrast.gif' WIDTH=18 HEIGHT=19 ALT=' RR*' TITLE='RR*'>" +
    "<IMG SRC='subs.gif' WIDTH=6 HEIGHT=19 ALT=' s' TITLE='s'>";
  althtmldef "RR*s" as
    '&#8477;<SUP>*</SUP><SUB>&#x1D460;</SUB>';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "RR*s" as "\mathbb{R}^*_s";
htmldef "0g" as "<IMG SRC='_0g.gif' WIDTH=14 HEIGHT=19 ALT=' 0g' TITLE='0g'>";
  althtmldef "0g" as "0<SUB>g</SUB>";
  latexdef "0g" as "0_{\rm g}";
htmldef "gsum" as " <IMG SRC='csigma.gif' WIDTH=11 HEIGHT=19 " +
    "ALT=' gsum' TITLE='gsum'><sub><i>g</i></sub> ";
  althtmldef "gsum" as " &Sigma;<sub><i>g</i></sub> ";
  latexdef "gsum" as " \Sigma_g ";
htmldef '"s' as " <IMG SRC='backquote.gif' WIDTH=7 HEIGHT=19 ALT=' " + '"' +
    "' TITLE='" + '"' + "'><sub><i>s</i></sub> ";
  althtmldef '"s' as ' &ldquo;<sub><i>s</i></sub> ';
  latexdef '"s' as "``_s";
htmldef "/s" as " <IMG SRC='diagup.gif' WIDTH=14 HEIGHT=19 ALT=' /.' " +
    "TITLE='/.'><sub><i>s</i></sub> ";
  althtmldef "/s" as " /<sub><i>s</i></sub> ";
  latexdef "/s" as " \diagup_s ";
htmldef "qTop" as " qTop "; althtmldef "qTop" as " qTop ";
  latexdef "qTop" as "{\rm qTop}";
htmldef "Xs." as " <IMG SRC='times.gif' WIDTH=9 HEIGHT=19 ALT=' X.' " +
    "TITLE='X.'><sub><i>s</i></sub> ";
  althtmldef "Xs." as ' &times;<sub><i>s</i></sub> ';
  latexdef "Xs." as "\times_s";
htmldef "Cat" as
    "<IMG SRC='_cat.gif' WIDTH=24 HEIGHT=19 ALT=' Cat' TITLE='Cat'>";
  althtmldef "Cat" as "Cat";
  latexdef "Cat" as "{\rm Cat}";
htmldef "Id" as "<IMG SRC='_id.gif' WIDTH=12 HEIGHT=19 ALT=' Id' TITLE='Id'>";
  althtmldef "Id" as "Id";
  latexdef "Id" as "{\rm Id}";
htmldef "Homf" as
    " <IMG SRC='_hom.gif' WIDTH=27 HEIGHT=19 ALT=' Hom' TITLE='Hom'>" +
    "<sub><i>f</i></sub> ";
  althtmldef "Homf" as " Hom<sub><i>f</i></sub> ";
  latexdef "Homf" as "{\rm Hom}";
htmldef "comf" as "comp<sub><i>f</i></sub>";
  althtmldef "comf" as "comp<sub><i>f</i></sub>";
  latexdef "comf" as "{\rm comp}_f";
htmldef "oppCat" as "oppCat";
  althtmldef "oppCat" as "oppCat";
  latexdef "oppCat" as "{\rm oppCat}";
htmldef "Mono" as "Mono"; althtmldef "Mono" as "Mono";
  latexdef "Mono" as "{\rm Mono}";
htmldef "Epi" as "Epi"; althtmldef "Epi" as "Epi";
  latexdef "Epi" as "{\rm Epi}";
htmldef "Sect" as "Sect"; althtmldef "Sect" as "Sect";
  latexdef "Sect" as "{\rm Sect}";
htmldef "Inv" as "Inv"; althtmldef "Inv" as "Inv";
  latexdef "Inv" as "{\rm Inv}";
htmldef "Iso" as
    " <IMG SRC='_iso.gif' WIDTH=17 HEIGHT=19 ALT=' Iso' TITLE='Iso'> ";
  althtmldef "Iso" as "Iso";
  latexdef "Iso" as "{\rm Iso}";
htmldef "C_cat" as
    " <IMG SRC='subseteq.gif' WIDTH=12 HEIGHT=19 ALT=' C_' TITLE='C_'>" +
    "<SUB>cat</SUB> ";
  althtmldef "C_cat" as ' &#8838;<SUB>cat</SUB> '; /* &subE; */
  latexdef "C_cat" as "\subseteq_{cat}";
htmldef "|`cat" as " <IMG SRC='restriction.gif' WIDTH=5 HEIGHT=19 ALT=' |`'" +
    " TITLE='|`'><SUB>cat</SUB> ";
  althtmldef "|`cat" as " &#8638;<SUB>cat</SUB> ";
  latexdef "|`cat" as "\restriction_{cat}";
htmldef "Subcat" as "Subcat"; althtmldef "Subcat" as "Subcat";
  latexdef "Subcat" as "{\rm Subcat}";
htmldef "Func" as
    " <IMG SRC='_func.gif' WIDTH=32 HEIGHT=19 ALT=' Func' TITLE='Func'> ";
  althtmldef "Func" as " Func ";
  latexdef "Func" as " {\rm Func} ";
htmldef "idFunc" as "id<sub><i>func</i></sub>";
  althtmldef "idFunc" as "id<sub><i>func</i></sub>";
  latexdef "idFunc" as "{\rm id}_{func}";
htmldef "o.func" as
    " <IMG SRC='circ.gif' WIDTH=8 HEIGHT=19 ALT=' o.' TITLE='o.'>" +
    "<sub><i>func</i></sub> ";
  althtmldef "o.func" as ' &#8728;<sub><i>func</i></sub> ';
  latexdef "o.func" as "\circ_{func}";
htmldef "|`f" as " <IMG SRC='restriction.gif' WIDTH=5 HEIGHT=19 ALT=' |`'" +
    " TITLE='|`'><SUB><i>f</i></SUB> ";
  althtmldef "|`f" as " &#8638;<SUB><i>f</i></SUB> ";
  latexdef "|`f" as "\restriction_f";
htmldef "Full" as " Full "; althtmldef "Full" as " Full ";
  latexdef "Full" as "{\rm Full}";
htmldef "Faith" as " Faith "; althtmldef "Faith" as " Faith ";
  latexdef "Faith" as "{\rm Faith}";
htmldef "Nat" as " Nat "; althtmldef "Nat" as " Nat ";
  latexdef "Nat" as "{\rm Nat}";
htmldef "FuncCat" as " FuncCat "; althtmldef "FuncCat" as " FuncCat ";
  latexdef "FuncCat" as " {\rm FuncCat} ";
htmldef "DiagFunc" as "&Delta;<sub>func</sub>";
  althtmldef "DiagFunc" as "&Delta;<sub>func</sub>";
  latexdef "DiagFunc" as "\Delta_{func}";
htmldef "domA" as
    "<IMG SRC='_dom.gif' WIDTH=26 HEIGHT=19 ALT='dom' TITLE='dom'>" +
    "<IMG SRC='suba.gif' WIDTH=7 HEIGHT=19 ALT='A' TITLE='A'>";
  althtmldef "domA" as 'dom<sub><i>a</i></sub>';
  latexdef "domA" as "{\rm dom}_a";
htmldef "codA" as 'cod<sub><i>a</i></sub>';
  althtmldef "codA" as 'cod<sub><i>a</i></sub>';
  latexdef "codA" as "{\rm cod}_a";
htmldef "Arrow" as "Nat"; althtmldef "Arrow" as "Arrow";
  latexdef "Arrow" as "{\rm Arrow}";
htmldef "HomA" as 'Hom<sub><i>a</i></sub>';
  althtmldef "HomA" as 'Hom<sub><i>a</i></sub>';
  latexdef "HomA" as "{\rm Hom}_a";
htmldef "IdA" as 'Id<sub><i>a</i></sub>';
  althtmldef "IdA" as 'Id<sub><i>a</i></sub>';
  latexdef "IdA" as "{\rm Id}_a";
htmldef "compA" as 'comp<sub><i>a</i></sub>';
  althtmldef "compA" as 'comp<sub><i>a</i></sub>';
  latexdef "compA" as "{\rm comp}_a";
htmldef "SetCat" as
    "<IMG SRC='_setcat.gif' WIDTH=45 HEIGHT=19 ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "SetCat" as "SetCat";
  latexdef "SetCat" as "{\rm SetCat}";
htmldef "CatCat" as "CatCat"; althtmldef "CatCat" as "CatCat";
  latexdef "CatCat" as "{\rm CatCat}";
htmldef "Xc." as " <IMG SRC='times.gif' WIDTH=9 HEIGHT=19 ALT=' X.' " +
    "TITLE='X.'><sub><i>c</i></sub> ";
  althtmldef "Xc." as ' &times;<sub><i>c</i></sub> ';
  latexdef "Xc." as "\times_c";
htmldef "1stF" as
    " <IMG SRC='_1st.gif' WIDTH=15 HEIGHT=19 ALT=' 1st' TITLE='1st'>" +
    "<sub><i>F</i></sub> ";
  althtmldef "1stF" as ' 1<SUP>st</SUP><sub><i>F</i></sub> ';
  latexdef "1stF" as " 1^{\rm st}{}_F ";
htmldef "2ndF" as
    " <IMG SRC='_2nd.gif' WIDTH=21 HEIGHT=19 ALT=' 2nd' TITLE='2nd'>" +
    "<sub><i>F</i></sub> ";
  althtmldef "2ndF" as ' 2<SUP>nd</SUP><sub><i>F</i></sub> ';
  latexdef "2ndF" as " 2^{\rm nd}{}_F ";
htmldef "pairF" as ' &lang;,&rang;<sub><i>F</i></sub> ';
  althtmldef "pairF" as ' &lang;,&rang;<sub><i>F</i></sub> ';
  latexdef "pairF" as " \langle,\rangle_F ";
htmldef "evalF" as ' eval<sub><i>F</i></sub> ';
  althtmldef "evalF" as ' eval<sub><i>F</i></sub> ';
  latexdef "evalF" as " {\rm eval}_F ";
htmldef "curryF" as ' curry<sub><i>F</i></sub> ';
  althtmldef "curryF" as ' curry<sub><i>F</i></sub> ';
  latexdef "curryF" as " {\rm curry}_F ";
htmldef "uncurryF" as ' uncurry<sub><i>F</i></sub> ';
  althtmldef "uncurryF" as ' uncurry<sub><i>F</i></sub> ';
  latexdef "uncurryF" as " {\rm uncurry}_F ";
htmldef "HomF" as 'Hom<sub><i>F</i></sub>';
  althtmldef "HomF" as 'Hom<sub><i>F</i></sub>';
  latexdef "HomF" as "{\rm Hom}_F";
htmldef "Yon" as "Yon"; althtmldef "Yon" as "Yon";
  latexdef "Yon" as "{\rm Yon}";
htmldef "Preset" as
   " <IMG SRC='_preset.gif' WIDTH=41 HEIGHT=19 ALT=' Preset' TITLE='Preset'> ";
  althtmldef "Preset" as " Preset ";
  latexdef "Preset" as "{\rm Preset}";
htmldef "Dirset" as "Dirset";
  althtmldef "Dirset" as "Dirset";
  latexdef "Dirset" as "\mathrm{Dirset}";
htmldef "Poset" as
    "<IMG SRC='_poset.gif' WIDTH=35 HEIGHT=19 ALT=' Poset' TITLE='Poset'>";
  althtmldef "Poset" as "Poset";
  latexdef "Poset" as "{\rm Poset}";
htmldef "lt" as
    "<IMG SRC='_rmlt.gif' WIDTH=10 HEIGHT=19 ALT=' lt' TITLE='lt'>";
  althtmldef "lt" as "lt";
  latexdef "lt" as "{\rm lt}";
htmldef "lub" as
    "<IMG SRC='_lub.gif' WIDTH=20 HEIGHT=19 ALT=' lub' TITLE='lub'>";
  althtmldef "lub" as "lub";
  latexdef "lub" as "{\rm lub}";
htmldef "glb" as
    "<IMG SRC='_glb.gif' WIDTH=20 HEIGHT=19 ALT=' glb' TITLE='glb'>";
  althtmldef "glb" as "glb";
  latexdef "glb" as "{\rm glb}";
htmldef "join" as
    "<IMG SRC='_join.gif' WIDTH=25 HEIGHT=19 ALT=' join' TITLE='join'>";
  althtmldef "join" as "join";
  latexdef "join" as "{\rm join}";
htmldef "meet" as
    "<IMG SRC='_meet.gif' WIDTH=32 HEIGHT=19 ALT=' meet' TITLE='meet'>";
  althtmldef "meet" as "meet";
  latexdef "meet" as "{\rm meet}";
htmldef "Toset" as "Toset";
  althtmldef "Toset" as "Toset";
  latexdef "Toset" as "{\rm Toset}";
htmldef "1." as
    "<IMG SRC='_1dot.gif' WIDTH=10 HEIGHT=19 ALT=' 1.' TITLE='1.'>";
  althtmldef "1." as "1.";
  latexdef "1." as "1.";
htmldef "0." as
    "<IMG SRC='_0dot.gif' WIDTH=11 HEIGHT=19 ALT=' 0.' TITLE='0.'>";
  althtmldef "0." as "0.";
  latexdef "0." as "0.";
htmldef "Lat" as
    "<IMG SRC='_lat.gif' WIDTH=23 HEIGHT=19 ALT=' Lat' TITLE='Lat'>";
  althtmldef "Lat" as "Lat";
  latexdef "Lat" as "{\rm Lat}";
htmldef "CLat" as
    "<IMG SRC='_clat.gif' WIDTH=33 HEIGHT=19 ALT=' CLat' TITLE='CLat'>";
  althtmldef "CLat" as "CLat";
  latexdef "CLat" as "{\rm CLat}";
htmldef "ODual" as "ODual";
  althtmldef "ODual" as "ODual";
  latexdef "ODual" as "\mathrm{ODual}";
htmldef "toInc" as "toInc";
  althtmldef "toInc" as "toInc";
  latexdef "toInc" as "\mathrm{toInc}";
htmldef "DLat" as "DLat";
  althtmldef "DLat" as "DLat";
  latexdef "DLat" as "\mathrm{DLat}";
htmldef "PosetRel" as
    "<IMG SRC='_posetrel.gif' WIDTH=56 HEIGHT=19 " +
    "ALT=' PosetRel' TITLE='PosetRel'>";
  althtmldef "PosetRel" as "PosetRel";
  latexdef "PosetRel" as "{\rm PosetRel}";
htmldef "TosetRel" as " <IMG SRC='_tosetrel.gif' WIDTH=55 HEIGHT=19 " +
    "ALT=' TosetRel' TITLE='TosetRel'> ";
  althtmldef "TosetRel" as " TosetRel ";
  latexdef "TosetRel" as "{\rm TosetRel}";
/* obsolete as of 28-Aug-2018.  -NM
htmldef "supw" as
    " <IMG SRC='_sup.gif' WIDTH=22 HEIGHT=19 ALT=' sup' TITLE='sup'>" +
    "<IMG SRC='subrmw.gif' WIDTH=10 HEIGHT=19 ALT=' w' TITLE='w'> ";
  althtmldef "supw" as " sup<SUB>w</SUB> ";
  latexdef "supw" as "{\rm sup}_{\rm w}";
htmldef "infw" as
    " <IMG SRC='_inf.gif' WIDTH=18 HEIGHT=19 ALT=' inf' TITLE='inf'>" +
    "<IMG SRC='subrmw.gif' WIDTH=10 HEIGHT=19 ALT=' w' TITLE='w'> ";
  althtmldef "infw" as " inf<SUB>w</SUB> ";
  latexdef "infw" as "{\rm inf}_{\rm w}";
htmldef "LatRel" as
    "<IMG SRC='_latrel.gif' WIDTH=44 HEIGHT=19 ALT=' LatRel' TITLE='LatRel'>";
  althtmldef "LatRel" as "LatRel";
  latexdef "LatRel" as "{\rm LatRel}";
*/
htmldef "DirRel" as
    "<IMG SRC='_dirrel.gif' WIDTH=41 HEIGHT=19 ALT=' DirRel' TITLE='DirRel'>";
  althtmldef "DirRel" as "DirRel";
  latexdef "DirRel" as "{\rm DirRel}";
htmldef "tail" as
    "<IMG SRC='_tail.gif' WIDTH=22 HEIGHT=19 ALT=' tail' TITLE='tail'>";
  althtmldef "tail" as "tail";
  latexdef "tail" as "{\rm tail}";
htmldef "Mnd" as
    "<IMG SRC='_mnd.gif' WIDTH=28 HEIGHT=19 ALT=' Mnd' TITLE='Mnd'>";
  althtmldef "Mnd" as "Mnd";
  latexdef "Mnd" as "{\rm Mnd}";
htmldef "Grp" as
    "<IMG SRC='_grp.gif' WIDTH=25 HEIGHT=19 ALT=' Grp' TITLE='Grp'>";
  althtmldef "Grp" as "Grp";
  latexdef "Grp" as "{\rm Grp}";
htmldef "invg" as "<IMG SRC='_inv.gif' WIDTH=19 HEIGHT=19 ALT=' inv' " +
    "TITLE='inv'><IMG SRC='subg.gif' WIDTH=7 HEIGHT=19 ALT=' g' TITLE='g'>";
  althtmldef "invg" as "inv<SUB>g</SUB>";
  latexdef "invg" as "{\rm inv}_{\rm g}";
htmldef "+f" as "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>" +
    "<IMG SRC='subf.gif' WIDTH=6 HEIGHT=19 ALT=' f' TITLE='f'>";
  althtmldef "+f" as '+<SUB>&#x1D453;</SUB>';
  latexdef "+f" as "+_f";
htmldef "-g" as
    "<IMG SRC='_minusg.gif' WIDTH=17 HEIGHT=19 ALT=' -g' TITLE='-g'>";
  althtmldef "-g" as "-<SUB>g</SUB>";
  latexdef "-g" as "-_{\rm g}";
htmldef ".g" as ".<SUB>g</SUB>";
  althtmldef ".g" as ".<SUB>g</SUB>";
  latexdef ".g" as "\cdot_{\rm g}";
htmldef "MndHom" as " MndHom "; althtmldef "MndHom" as " MndHom ";
  latexdef "MndHom" as " {\rm MndHom} ";
htmldef "SubMnd" as "SubMnd"; althtmldef "SubMnd" as "SubMnd";
  latexdef "SubMnd" as "{\rm SubMnd}";
htmldef "Word" as "Word ";
  althtmldef "Word" as "Word ";
  latexdef "Word" as "\mathrm{Word }";
htmldef "concat" as " concat ";
  althtmldef "concat" as " concat ";
  latexdef "concat" as "\mathrm{ concat }";
htmldef '<"' as
    "<IMG SRC='langle.gif' WIDTH=4 HEIGHT=19 ALT=' &lt;' TITLE='&lt;'>" +
    "<IMG SRC='backquote.gif' WIDTH=7 HEIGHT=19 ALT='" + '"' +
      "' TITLE='" + '"' + "'>";
  althtmldef '<"' as '&lang;&ldquo;'; /* &#9001;&#8220; */
  latexdef '<"' as "\langle``";
htmldef '">' as
    "<IMG SRC='quote.gif' WIDTH=7 HEIGHT=19 ALT=' " + '"' +
      "' TITLE='" + '"' + "'>" +
    "<IMG SRC='rangle.gif' WIDTH=4 HEIGHT=19 ALT='&gt;' TITLE='&gt;'>";
  althtmldef '">' as '&rdquo;&rang;'; /* &#8221;&#9002; */
  latexdef '">' as "''\rangle";
htmldef "substr" as " substr ";
  althtmldef "substr" as " substr ";
  latexdef "substr" as "\mathrm{ substr }";
htmldef "splice" as " splice ";
  althtmldef "splice" as " splice ";
  latexdef "splice" as "\mathrm{ splice }";
htmldef "reverse" as "reverse";
  althtmldef "reverse" as "reverse";
  latexdef "reverse" as "\mathrm{reverse}";
htmldef "freeMnd" as "freeMnd"; althtmldef "freeMnd" as "freeMnd";
  latexdef "freeMnd" as "{\rm freeMnd}";
htmldef "varFMnd" as "var<SUB><I>FMnd</I></SUB>";
  althtmldef "varFMnd" as "var<SUB><I>FMnd</I></SUB>";
  latexdef "varFMnd" as "{\rm var}_{FMnd}";
htmldef "~QG" as " ~<sub><i>QG</i></sub> ";
  althtmldef "~QG" as " ~<sub><i>QG</i></sub> ";
  latexdef "~QG" as " \sim_{QG} ";
htmldef "SubGrp" as "SubGrp"; althtmldef "SubGrp" as "SubGrp";
  latexdef "SubGrp" as "{\rm SubGrp}";
htmldef "NrmSGrp" as "NrmSGrp"; althtmldef "NrmSGrp" as "NrmSGrp";
  latexdef "NrmSGrp" as "{\rm NrmSGrp}";
htmldef "GrpHom" as
   " <IMG SRC='_grphom.gif' WIDTH=54 HEIGHT=19 ALT=' GrpHom' TITLE='GrpHom'> ";
  althtmldef "GrpHom" as " GrpHom ";
  latexdef "GrpHom" as "{\rm GrpHom}";
htmldef "GrpIso" as " GrpIso ";
  althtmldef "GrpIso" as " GrpIso ";
  latexdef "GrpIso" as "{\rm GrpIso}";
htmldef "~=g" as " <IMG SRC='simeq.gif' WIDTH=26 HEIGHT=19 " +
    "ALT=' ~=ph' TITLE='~=ph'><SUB>&#x1D454;</SUB> ";
  althtmldef "~=g" as " &#8771;<SUB>&#x1D454;</SUB> ";
  latexdef "~=g" as "\simeq_{g}";
htmldef "GrpAct" as
   " <IMG SRC='_grpact.gif' WIDTH=48 HEIGHT=19 ALT=' GrpAct' TITLE='GrpAct'> ";
  althtmldef "GrpAct" as " GrpAct ";
  latexdef "GrpAct" as "{\rm GrpAct}";
htmldef "SymGrp" as
    "<IMG SRC='_symgrp.gif' WIDTH=53 HEIGHT=19 ALT=' SymGrp' TITLE='SymGrp'>";
  althtmldef "SymGrp" as "SymGrp";
  latexdef "SymGrp" as "{\rm SymGrp}";
htmldef "od" as "<IMG SRC='_od.gif' WIDTH=15 HEIGHT=19 ALT=' od' TITLE='od'>";
  althtmldef "od" as "od";
  latexdef "od" as "\rm{od}";
htmldef "gEx" as "gEx";
  althtmldef "gEx" as "gEx";
  latexdef "gEx" as "{\rm gEx}";
htmldef "pGrp" as " pGrp ";
  althtmldef "pGrp" as " pGrp ";
  latexdef "pGrp" as "{\rm pGrp}";
htmldef "pSyl" as " pSyl ";
  althtmldef "pSyl" as " pSyl ";
  latexdef "pSyl" as "{\rm pSyl}";
htmldef "~FG" as " ~<sub><i>FG</i></sub> ";
  althtmldef "~FG" as " ~<sub><i>FG</i></sub> ";
  latexdef "~FG" as " \sim_{FG} ";
htmldef "freeGrp" as "freeGrp"; althtmldef "freeGrp" as "freeGrp";
  latexdef "freeGrp" as "{\rm freeGrp}";
htmldef "varFGrp" as "var<SUB><I>FGrp</I></SUB>";
  althtmldef "varFGrp" as "var<SUB><I>FGrp</I></SUB>";
  latexdef "varFGrp" as "{\rm var}_{FGrp}";
htmldef "CMnd" as "CMnd";
  althtmldef "CMnd" as "CMnd";
  latexdef "CMnd" as "{\rm CMnd}";
htmldef "CycGrp" as "CycGrp";
  althtmldef "CycGrp" as "CycGrp";
  latexdef "CycGrp" as "{\rm CycGrp}";
htmldef "DProd" as " DProd ";
  althtmldef "DProd" as " DProd ";
  latexdef "DProd" as "{\rm DProd }";
htmldef "dProj" as "dProj";
  althtmldef "dProj" as "dProj";
  latexdef "dProj" as "{\rm dProj}";
htmldef "Abel" as
    "<IMG SRC='_abel.gif' WIDTH=28 HEIGHT=19 ALT=' Abel' TITLE='Abel'>";
  althtmldef "Abel" as "Abel";
  latexdef "Abel" as "{\rm Abel}";
htmldef "oppG" as "opp<sub><i>g</i></sub>";
  althtmldef "oppG" as "opp<sub><i>g</i></sub>";
  latexdef "oppG" as "{\rm opp}_g";
htmldef "mulGrp" as "mulGrp";
  althtmldef "mulGrp" as "mulGrp";
  latexdef "mulGrp" as "{\rm mulGrp}";
htmldef "Ring" as
    "<IMG SRC='_ring.gif' WIDTH=30 HEIGHT=19 ALT=' Ring' TITLE='Ring'>";
  althtmldef "Ring" as "Ring";
  latexdef "Ring" as "{\rm Ring}";
htmldef "CRing" as
    "<IMG SRC='_cring.gif' WIDTH=40 HEIGHT=19 ALT=' CRing' TITLE='CRing'>";
  althtmldef "CRing" as "CRing";
  latexdef "CRing" as "{\rm CRing}";
htmldef "1r" as "<IMG SRC='_1r.gif' WIDTH=13 HEIGHT=19 ALT=' 1r' TITLE='1r'>";
  althtmldef "1r" as "1<SUB>r</SUB>";
  latexdef "1r" as "1_{\rm r}{\rm }";
htmldef "oppR" as "opp<sub><i>r</i></sub>";
  althtmldef "oppR" as "opp<sub><i>r</i></sub>";
  latexdef "oppR" as "{\rm opp}_r";
htmldef "||r" as "<IMG SRC='parallel.gif' WIDTH=5 HEIGHT=19 ALT=' ||' " +
    "TITLE='||'><sub><i>r</i></sub>";
  althtmldef "||r" as "&#8741;<sub><i>r</i></sub>";
  latexdef "||r" as "\parallel_r";
htmldef "Unit" as "Unit"; althtmldef "Unit" as "Unit";
  latexdef "Unit" as "{\rm Unit}";
htmldef "Irred" as "Irred"; althtmldef "Irred" as "Irred";
  latexdef "Irred" as "{\rm Irred}";
htmldef "invr" as
    "<IMG SRC='_invr.gif' WIDTH=23 HEIGHT=19 ALT=' invr' TITLE='invr'>";
  althtmldef "invr" as "inv<SUB>r</SUB>";
  latexdef "invr" as "{\rm inv}_r";
htmldef "/r" as "/<SUB>r</SUB>";
  althtmldef "/r" as "/<SUB>r</SUB>";
  latexdef "/r" as "/_r";
htmldef "RingHom" as " RingHom "; althtmldef "RingHom" as " RingHom ";
  latexdef "RingHom" as " {\rm RingHom} ";
htmldef "RingIso" as " RingIso "; althtmldef "RingIso" as " RingIso ";
  latexdef "RingIso" as " {\rm RingIso} ";
htmldef "DivRing" as
  "<IMG SRC='_divring.gif' WIDTH=52 HEIGHT=19 ALT=' DivRing' TITLE='DivRing'>";
  althtmldef "DivRing" as "DivRing";
  latexdef "DivRing" as "{\rm DivRing}";
htmldef "Field" as "Field";
  althtmldef "Field" as "Field";
  latexdef "Field" as "\mathrm{Field}";
htmldef "SubRing" as "SubRing"; althtmldef "SubRing" as "SubRing";
  latexdef "SubRing" as "{\rm SubRing}";
htmldef "RingSpan" as "RingSpan";
  althtmldef "RingSpan" as "RingSpan";
  latexdef "RingSpan" as "{\rm RingSpan}";
htmldef "AbsVal" as "AbsVal";
  althtmldef "AbsVal" as "AbsVal";
  latexdef "AbsVal" as "{\rm AbsVal}";
htmldef "*Ring" as "<IMG SRC='_astring.gif' " +
    "WIDTH=41 HEIGHT=19 ALT=' *Ring' TITLE='*Ring'>";
  althtmldef "*Ring" as "*-Ring";
  latexdef "*Ring" as "\ast{\rm -Ring}";
htmldef "*rf" as "<IMG SRC='ast.gif' WIDTH=7 HEIGHT=19 ALT=' *' TITLE='*'>" +
    "<IMG SRC='subr.gif' WIDTH=5 HEIGHT=19 ALT=' r' TITLE='r'>" +
    "<IMG SRC='subf.gif' WIDTH=6 HEIGHT=19 ALT=' f' TITLE='f'>";
  althtmldef "*rf" as "*<SUB><I>rf</I></SUB>";
  latexdef "*rf" as "\ast_{rf}";
htmldef "LMod" as
    "<IMG SRC='_lmod.gif' WIDTH=36 HEIGHT=19 ALT=' LMod' TITLE='LMod'>";
  althtmldef "LMod" as "LMod";
  latexdef "LMod" as "{\rm LMod}";
htmldef ".sf" as
    "<IMG SRC='_cds.gif' WIDTH=9 HEIGHT=19 ALT=' .s' TITLE='.s'>" +
    "<IMG SRC='subf.gif' WIDTH=6 HEIGHT=19 ALT=' f' TITLE='f'>";
  althtmldef ".sf" as ' <B>&middot;</B><SUB><I>sf</I></SUB> ';
  latexdef ".sf" as '\cdot_{sf}';
htmldef "LSubSp" as
    "<IMG SRC='_lsubsp.gif' WIDTH=49 HEIGHT=19 ALT=' LSubSp' TITLE='LSubSp'>";
  althtmldef "LSubSp" as "LSubSp";
  latexdef "LSubSp" as "{\rm LSubSp}";
htmldef "LSpan" as
    "<IMG SRC='_lspan.gif' WIDTH=41 HEIGHT=19 ALT=' LSpan' TITLE='LSpan'>";
  althtmldef "LSpan" as "LSpan";
  latexdef "LSpan" as "{\rm LSpan}";
htmldef "LMHom" as " LMHom ";
  althtmldef "LMHom" as " LMHom ";
  latexdef "LMHom" as "{\rm LMHom}";
htmldef "LMIso" as " LMIso ";
  althtmldef "LMIso" as " LMIso ";
  latexdef "LMIso" as "{\rm LMIso}";
htmldef "~=m" as " <IMG SRC='simeq.gif' WIDTH=26 HEIGHT=19 " +
    "ALT=' ~=ph' TITLE='~=ph'><SUB>&#x1D45A;</SUB> ";
  althtmldef "~=m" as " &#8771;<SUB>&#x1D45A;</SUB> ";
  latexdef "~=m" as "\simeq_{m}";
htmldef "LBasis" as "LBasis";
  althtmldef "LBasis" as "LBasis";
  latexdef "LBasis" as "{\rm LBasis}";
htmldef "LSSum" as
    "<IMG SRC='_lssum.gif' WIDTH=45 HEIGHT=19 ALT=' LSSum' TITLE='LSSum'>";
  althtmldef "LSSum" as "LSSum";
  latexdef "LSSum" as "{\rm LSSum}";
htmldef "proj1" as
    "<IMG SRC='_proj.gif' WIDTH=24 HEIGHT=19 ALT=' proj' TITLE='proj'>" +
    "<IMG SRC='sub1.gif' WIDTH=4 HEIGHT=19 ALT=' 1' TITLE='1'>";
  althtmldef "proj1" as 'proj<SUB>1</SUB>';
  latexdef "proj1" as '{\rm proj}_1';
htmldef "LVec" as
    "<IMG SRC='_lvec.gif' WIDTH=33 HEIGHT=19 ALT=' LVec' TITLE='LVec'>";
  althtmldef "LVec" as "LVec";
  latexdef "LVec" as "{\rm LVec}";
htmldef "subringAlg" as " subringAlg ";
  althtmldef "subringAlg" as " subringAlg ";
  latexdef "subringAlg" as "{\rm subringAlg}";
htmldef "ringLMod" as "ringLMod";
  althtmldef "ringLMod" as "ringLMod";
  latexdef "ringLMod" as "{\rm ringLMod}";
htmldef "RSpan" as "RSpan"; althtmldef "RSpan" as "RSpan";
  latexdef "RSpan" as "{\rm RSpan}";
htmldef "LIdeal" as "LIdeal";
  althtmldef "LIdeal" as "LIdeal";
  latexdef "LIdeal" as "{\rm LIdeal}";
htmldef "2Ideal" as "2Ideal";
  althtmldef "2Ideal" as "2Ideal";
  latexdef "2Ideal" as "{\rm 2Ideal}";
htmldef "LPIdeal" as "LPIdeal";
  althtmldef "LPIdeal" as "LPIdeal";
  latexdef "LPIdeal" as "{\rm LPIdeal}";
/*
htmldef "Top1c" as "Top1c";
  althtmldef "Top1c" as "Top1c";
  latexdef "Top1c" as "{\rm Top1c}";
htmldef "Top2c" as "Top2c";
  althtmldef "Top2c" as "Top2c";
  latexdef "Top2c" as "{\rm Top2c}";
*/
htmldef "LPIR" as "LPIR";
  althtmldef "LPIR" as "LPIR";
  latexdef "LPIR" as "{\rm LPIR}";
htmldef "NzRing" as "NzRing";
  althtmldef "NzRing" as "NzRing";
  latexdef "NzRing" as "{\rm NzRing}";
htmldef "RLReg" as "RLReg";
  althtmldef "RLReg" as "RLReg";
  latexdef "RLReg" as "\mathrm{RLReg}";
htmldef "Domn" as "Domn";
  althtmldef "Domn" as "Domn";
  latexdef "Domn" as "\mathrm{Domn}";
htmldef "IDomn" as "IDomn";
  althtmldef "IDomn" as "IDomn";
  latexdef "IDomn" as "\mathrm{IDomn}";
htmldef "PID" as "PID";
  althtmldef "PID" as "PID";
  latexdef "PID" as "\mathrm{PID}";
htmldef "AssAlg" as "AssAlg"; althtmldef "AssAlg" as "AssAlg";
  latexdef "AssAlg" as "{\rm AssAlg}";
htmldef "AlgSpan" as "AlgSpan"; althtmldef "AlgSpan" as "AlgSpan";
  latexdef "AlgSpan" as "{\rm AlgSpan}";
htmldef "algSc" as "algSc";
  althtmldef "algSc" as "algSc";
  latexdef "algSc" as "{\rm algSc}";
htmldef "mPwSer" as " mPwSer "; althtmldef "mPwSer" as " mPwSer ";
  latexdef "mPwSer" as " {\rm mPwSer} ";
htmldef "mVar" as " mVar "; althtmldef "mVar" as " mVar ";
  latexdef "mVar" as " {\rm mVar} ";
htmldef "mPoly" as " mPoly "; althtmldef "mPoly" as " mPoly ";
  latexdef "mPoly" as " {\rm mPoly} ";
htmldef "evalSub" as " evalSub "; althtmldef "evalSub" as " evalSub ";
  latexdef "evalSub" as " {\rm evalSub} ";
htmldef "eval" as " eval "; althtmldef "eval" as " eval ";
  latexdef "eval" as " {\rm eval} ";
htmldef "mHomP" as " mHomP "; althtmldef "mHomP" as " mHomP ";
  latexdef "mHomP" as " {\rm mHomP} ";
htmldef "mPSDer" as " mPSDer "; althtmldef "mPSDer" as " mPSDer ";
  latexdef "mPSDer" as " {\rm mPSDer} ";
htmldef "<bag" as " <IMG SRC='lt.gif' WIDTH=11 HEIGHT=19 ALT=' &lt;' " +
    "TITLE='&lt;'><sub>bag</sub> ";
  althtmldef "<bag" as " &lt;<sub>bag</sub> ";
  latexdef "<bag" as "<_{\rm bag}";
htmldef "ordPwSer" as " ordPwSer "; althtmldef "ordPwSer" as " ordPwSer ";
  latexdef "ordPwSer" as "{\rm ordPwSer}";
htmldef "selectVars" as " selectVars ";
  althtmldef "selectVars" as " selectVars ";
  latexdef "selectVars" as " {\rm selectVars} ";
htmldef "mDeg" as " mDeg "; althtmldef "mDeg" as " mDeg ";
  latexdef "mDeg" as " {\rm mDeg} ";
htmldef "AlgInd" as " AlgInd "; althtmldef "AlgInd" as " AlgInd ";
  latexdef "AlgInd" as " {\rm AlgInd} ";
htmldef "PwSer1" as "PwSer<sub>1</sub>";
  althtmldef "PwSer1" as "PwSer<sub>1</sub>";
  latexdef "PwSer1" as "{\rm PwSer}_1";
htmldef "var1" as "var<sub>1</sub>"; althtmldef "var1" as "var<sub>1</sub>";
  latexdef "var1" as "{\rm var}_1";
htmldef "Poly1" as "Poly<sub>1</sub>";
  althtmldef "Poly1" as "Poly<sub>1</sub>";
  latexdef "Poly1" as "{\rm Poly}_1";
htmldef "evalSub1" as " evalSub<sub>1</sub> ";
  althtmldef "evalSub1" as " evalSub<sub>1</sub> ";
  latexdef "evalSub1" as " {\rm evalSub}_1 ";
htmldef "eval1" as "eval<sub>1</sub>";
  althtmldef "eval1" as "eval<sub>1</sub>";
  latexdef "eval1" as "{\rm eval}_1";
htmldef "deg1" as " deg<sub>1</sub> ";
  althtmldef "deg1" as " deg<sub>1</sub> ";
  latexdef "deg1" as " {\rm deg}_1 ";
htmldef "coe1" as "coe<sub>1</sub>"; althtmldef "coe1" as "coe<sub>1</sub>";
  latexdef "coe1" as "{\rm coe}_1";
htmldef "toPoly1" as "toPoly<sub>1</sub>";
  althtmldef "toPoly1" as "toPoly<sub>1</sub>";
  latexdef "toPoly1" as "{\rm toPoly}_1";
htmldef "*Met" as
    "<IMG SRC='infty.gif' WIDTH=17 HEIGHT=19 ALT=' *' TITLE='*'>" +
    "<IMG SRC='_met.gif' WIDTH=25 HEIGHT=19 ALT=' Met' TITLE='Met'>";
  althtmldef "*Met" as "&infin;Met";
  latexdef "*Met" as "\infty{\rm Met}";
htmldef "Met" as
    "<IMG SRC='_met.gif' WIDTH=25 HEIGHT=19 ALT=' Met' TITLE='Met'>";
  althtmldef "Met" as "Met";
  latexdef "Met" as "{\rm Met}";
htmldef "ball" as
    "<IMG SRC='_ball.gif' WIDTH=24 HEIGHT=19 ALT=' ball' TITLE='ball'>";
  althtmldef "ball" as "ball";
  latexdef "ball" as "{\rm ball}";
htmldef "MetOpen" as
  "<IMG SRC='_metopen.gif' WIDTH=59 HEIGHT=19 ALT=' MetOpen' TITLE='MetOpen'>";
  althtmldef "MetOpen" as "MetOpen";
  latexdef "MetOpen" as "{\rm MetOpen}";
htmldef "CCfld" as "&#8450;<SUB>fld</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  althtmldef "CCfld" as "&#8450;<SUB>fld</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "CCfld" as "{\rm CCfld}";
htmldef "ZRHom" as
    "<IMG SRC='bbz.gif' WIDTH=13 HEIGHT=19 ALT=' Z' TITLE='Z'>RHom";
  althtmldef "ZRHom" as "&#8484;RHom";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "ZRHom" as "{\rm ZRHom}";
htmldef "ZMod" as
    "<IMG SRC='bbz.gif' WIDTH=13 HEIGHT=19 ALT=' Z' TITLE='Z'>Mod";
  althtmldef "ZMod" as "&#8484;Mod";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "ZMod" as "{\rm ZMod}";
htmldef "chr" as "chr";
  althtmldef "chr" as "chr";
  latexdef "chr" as "\mathrm{chr}";
htmldef "Z/nZ" as "&#8484;/<i>n</i>&#8484;";
    /* 2-Jan-2016 reverted sans-serif */
  althtmldef "Z/nZ" as "&#8484;/<i>n</i>&#8484;";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "Z/nZ" as "{\rm Z/nZ}";
htmldef "PreHil" as
    "<IMG SRC='_prehil.gif' WIDTH=40 HEIGHT=19 ALT=' PreHil' TITLE='PreHil'>";
  althtmldef "PreHil" as "PreHil";
  latexdef "PreHil" as "{\rm PreHil}";
htmldef ".if" as
    "<IMG SRC='_cdi.gif' WIDTH=7 HEIGHT=19 ALT=' .i' TITLE='.i'>" +
    "<IMG SRC='subf.gif' WIDTH=6 HEIGHT=19 ALT=' f' TITLE='f'>";
  althtmldef ".if" as '<B>&middot;</B><SUB><I>if</I></SUB>';
  latexdef ".if" as '\cdot_{if}';
htmldef "ocv" as
    "<IMG SRC='_ocv.gif' WIDTH=22 HEIGHT=19 ALT=' ocv' TITLE='ocv'>";
  althtmldef "ocv" as "ocv";
  latexdef "ocv" as "{\rm ocv}";
htmldef "CSubSp" as
    "<IMG SRC='_csubsp.gif' WIDTH=50 HEIGHT=19 ALT=' CSubSp' TITLE='CSubSp'>";
  althtmldef "CSubSp" as "CSubSp";
  latexdef "CSubSp" as "{\rm CSubSp}";
htmldef "toHL" as "toHL"; althtmldef "toHL" as "toHL";
  latexdef "toHL" as "{\rm toHL}";
htmldef "proj" as
    "<IMG SRC='_proj.gif' WIDTH=24 HEIGHT=19 ALT=' proj' TITLE='proj'>";
  althtmldef "proj" as 'proj';
  latexdef "proj" as '{\rm proj}';
htmldef "Hil" as
    "<IMG SRC='_hil.gif' WIDTH=18 HEIGHT=19 ALT=' Hil' TITLE='Hil'>";
  althtmldef "Hil" as "Hil";
  latexdef "Hil" as "{\rm Hil}";
htmldef "OBasis" as "OBasis"; althtmldef "OBasis" as "OBasis";
  latexdef "OBasis" as "{\rm OBasis}";
htmldef "Moore" as "Moore";
  althtmldef "Moore" as "Moore";
  latexdef "Moore" as "\mathrm{Moore}";
htmldef "mrCls" as "mrCls";
  althtmldef "mrCls" as "mrCls";
  latexdef "mrCls" as "\mathrm{mrCls}";
htmldef "mrInd" as "mrInd";
  althtmldef "mrInd" as "mrInd";
  latexdef "mrInd" as "\mathrm{mrInd}";
htmldef "ACS" as "ACS";
  althtmldef "ACS" as "ACS";
  latexdef "ACS" as "\mathrm{ACS}";
htmldef "Top" as
    "<IMG SRC='_top.gif' WIDTH=23 HEIGHT=19 ALT=' Top' TITLE='Top'>";
  althtmldef "Top" as "Top";
  latexdef "Top" as "{\rm Top}";
htmldef "TopOn" as "TopOn";
  althtmldef "TopOn" as "TopOn";
  latexdef "TopOn" as "\mathrm{TopOn}";
htmldef "TopSpOLD" as
    "<IMG SRC='_topsp.gif' WIDTH=41 HEIGHT=19 ALT=' TopSp' TITLE='TopSp'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "TopSpOLD" as "TopSp<SUB>OLD</SUB>";
  latexdef "TopSpOLD" as "{\rm TopSp_{OLD}}";
htmldef "TopSp" as
    "<IMG SRC='_topsp.gif' WIDTH=41 HEIGHT=19 ALT=' TopSp' TITLE='TopSp'>";
  althtmldef "TopSp" as "TopSp";
  latexdef "TopSp" as "{\rm TopSp}";
htmldef "TopBases" as
    "<IMG SRC='_topbases.gif' WIDTH=59 HEIGHT=19 " +
    "ALT=' TopBases' TITLE='TopBases'>";
  althtmldef "TopBases" as "TopBases";
  latexdef "TopBases" as "{\rm TopBases}";
htmldef "int" as
    "<IMG SRC='_int.gif' WIDTH=18 HEIGHT=19 ALT=' int' TITLE='int'>";
  althtmldef "int" as "int";
  latexdef "int" as "{\rm int}";
htmldef "cls" as
    "<IMG SRC='_cls.gif' WIDTH=17 HEIGHT=19 ALT=' cls' TITLE='cls'>";
  althtmldef "cls" as "cls";
  latexdef "cls" as "{\rm cls}";
htmldef "Clsd" as
    "<IMG SRC='_clsd.gif' WIDTH=28 HEIGHT=19 ALT=' Clsd' TITLE='Clsd'>";
  althtmldef "Clsd" as "Clsd";
  latexdef "Clsd" as "{\rm Clsd}";
htmldef "nei" as
    "<IMG SRC='_nei.gif' WIDTH=19 HEIGHT=19 ALT=' nei' TITLE='nei'>";
  althtmldef "nei" as "nei";
  latexdef "nei" as "{\rm nei}";
htmldef "limPt" as
    "<IMG SRC='_limpt.gif' WIDTH=35 HEIGHT=19 ALT=' limPt' TITLE='limPt'>";
  althtmldef "limPt" as "limPt";
  latexdef "limPt" as "{\rm limPt}";
htmldef "Perf" as "Perf";
  althtmldef "Perf" as "Perf";
  latexdef "Perf" as "{\rm Perf}";
htmldef "Cn" as
    " <IMG SRC='_cnf.gif' WIDTH=18 HEIGHT=19 ALT=' Cn' TITLE='Cn'> ";
  althtmldef "Cn" as " Cn ";
  latexdef "Cn" as "{\rm Cn}";
htmldef "CnP" as
    " <IMG SRC='_cnp.gif' WIDTH=27 HEIGHT=19 ALT=' CnP' TITLE='CnP'> ";
  althtmldef "CnP" as " CnP ";
  latexdef "CnP" as "{\rm CnP}";
htmldef "~~>t" as "<IMG SRC='rightsquigarrow.gif' WIDTH=15 HEIGHT=19 " +
    "ALT=' ~~&gt;' TITLE='~~&gt;'>" +
    "<IMG SRC='subt.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "~~>t" as
    "&#8669;<SUB>&#x1D461;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~~>t" as "\rightsquigarrow_t";
htmldef "Kol2" as
    "<IMG SRC='_kol2.gif' WIDTH=27 HEIGHT=19 ALT=' Kol2' TITLE='Kol2'>";
  althtmldef "Kol2" as "Kol2";
  latexdef "Kol2" as "{\rm Kol2}";
htmldef "Fre" as
    "<IMG SRC='_fre.gif' WIDTH=22 HEIGHT=19 ALT=' Fre' TITLE='Fre'>";
  althtmldef "Fre" as "Fre";
  latexdef "Fre" as "{\rm Fre}";
htmldef "Haus" as
    "<IMG SRC='_haus.gif' WIDTH=32 HEIGHT=19 ALT=' Haus' TITLE='Haus'>";
  althtmldef "Haus" as "Haus";
  latexdef "Haus" as "{\rm Haus}";
htmldef "Reg" as
    "<IMG SRC='_reg.gif' WIDTH=25 HEIGHT=19 ALT=' Reg' TITLE='Reg'>";
  althtmldef "Reg" as "Reg";
  latexdef "Reg" as "{\rm Reg}";
htmldef "Nrm" as
    "<IMG SRC='_nrm.gif' WIDTH=28 HEIGHT=19 ALT=' Nrm' TITLE='Nrm'>";
  althtmldef "Nrm" as "Nrm";
  latexdef "Nrm" as "{\rm Nrm}";
htmldef "CNrm" as "CNrm"; althtmldef "CNrm" as "CNrm";
  latexdef "CNrm" as "{\rm CNrm}";
htmldef "PNrm" as "PNrm"; althtmldef "PNrm" as "PNrm";
  latexdef "PNrm" as "{\rm PNrm}";
htmldef "Comp" as
    "<IMG SRC='_comp.gif' WIDTH=37 HEIGHT=19 ALT=' Comp' TITLE='Comp'>";
  althtmldef "Comp" as "Comp";
  latexdef "Comp" as "{\rm Comp}";
htmldef "Con" as
    "<IMG SRC='_con.gif' WIDTH=25 HEIGHT=19 ALT=' Con' TITLE='Con'>";
  althtmldef "Con" as "Con";
  latexdef "Con" as "{\rm Con}";
htmldef "1stc" as "<IMG SRC='_1stc.gif' WIDTH=25 HEIGHT=19 ALT=' 1stc'" +
    " TITLE='1stc'>";
  althtmldef "1stc" as "1<SUP>st</SUP>&#x1D714;"; /* math italic omega */
  latexdef "1stc" as "1^{\rm st}\omega";
htmldef "2ndc" as "<IMG SRC='_2ndc.gif' WIDTH=31 HEIGHT=19 ALT=' 2ndc'" +
    " TITLE='2ndc'>";
  althtmldef "2ndc" as "2<SUP>nd</SUP>&#x1D714;";
  latexdef "2ndc" as "2^{\rm nd}\omega";
htmldef "Locally" as "Locally "; althtmldef "Locally" as "Locally ";
  latexdef "Locally" as "{\rm Locally}";
htmldef "N-Locally" as "&#x1D45B;Locally ";
  althtmldef "N-Locally" as "&#x1D45B;-Locally ";
  latexdef "N-Locally" as "n\mbox{-Locally}";
htmldef "kGen" as "&#x1D458;Gen"; althtmldef "kGen" as "&#x1D458;Gen";
  latexdef "kGen" as "k{\rm Gen}";
htmldef "tX" as
    " <IMG SRC='_timest.gif' WIDTH=14 HEIGHT=19 ALT=' tX' TITLE='tX'> ";
  althtmldef "tX" as " &times;<SUB>t</SUB> ";
  latexdef "tX" as "\times_t";
htmldef "^ko" as
    " <IMG SRC='uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' ^' TITLE='^'>" +
    "<IMG SRC='subk.gif' WIDTH=7 HEIGHT=19 ALT=' k' TITLE='k'>" +
    "<IMG SRC='subo.gif' WIDTH=6 HEIGHT=19 ALT=' o' TITLE='o'> ";
  althtmldef "^ko" as " ^<SUB><I>ko</I></SUB> ";
  latexdef "^ko" as "\uparrow_{ko}";
htmldef "KQ" as "KQ"; althtmldef "KQ" as "KQ";
  latexdef "KQ" as "{\rm KQ}";
htmldef "Homeo" as
    " <IMG SRC='_homeo.gif' WIDTH=43 HEIGHT=19 ALT=' Homeo' TITLE='Homeo'> ";
  althtmldef "Homeo" as " Homeo ";
  latexdef "Homeo" as "{\rm Homeo}";
htmldef "~=" as
    " <IMG SRC='simeq.gif' WIDTH=13 HEIGHT=19 ALT=' ~=' TITLE='~='> ";
  althtmldef "~=" as " &#8771; ";
  latexdef "~=" as "\simeq";
htmldef "fBas" as
    "<IMG SRC='_fbas.gif' WIDTH=29 HEIGHT=19 ALT=' fBas' TITLE='fBas'>";
  althtmldef "fBas" as "fBas";
  latexdef "fBas" as "{\rm fBas}";
htmldef "filGen" as
    "<IMG SRC='_filgen.gif' WIDTH=40 HEIGHT=19 ALT=' filGen' TITLE='filGen'>";
  althtmldef "filGen" as "filGen";
  latexdef "filGen" as "{\rm filGen}";
htmldef "Fil" as
    "<IMG SRC='_fil.gif' WIDTH=17 HEIGHT=19 ALT=' Fil' TITLE='Fil'>";
  althtmldef "Fil" as "Fil";
  latexdef "Fil" as "{\rm Fil}";
htmldef "UFil" as
    "<IMG SRC='_ufil.gif' WIDTH=27 HEIGHT=19 ALT=' UFil' TITLE='UFil'>";
  althtmldef "UFil" as "UFil";
  latexdef "UFil" as "{\rm UFil}";
htmldef "UFL" as "UFL";
  althtmldef "UFL" as "UFL";
  latexdef "UFL" as "{\rm UFL}";
htmldef "FilMap" as
   " <IMG SRC='_filmap.gif' WIDTH=45 HEIGHT=19 ALT=' FilMap' TITLE='FilMap'> ";
  althtmldef "FilMap" as " FilMap ";
  latexdef "FilMap" as "{\rm FilMap}";
htmldef "fLimf" as
    " <IMG SRC='_flimf.gif' WIDTH=37 HEIGHT=19 ALT=' fLimf' TITLE='fLimf'> ";
  althtmldef "fLimf" as " fLimf ";
  latexdef "fLimf" as "{\rm fLimf}";
htmldef "fLim" as
    " <IMG SRC='_flim.gif' WIDTH=31 HEIGHT=19 ALT=' fLim' TITLE='fLim'> ";
  althtmldef "fLim" as " fLim ";
  latexdef "fLim" as "{\rm fLim}";
htmldef "fClus" as
    " <IMG SRC='_fclus.gif' WIDTH=34 HEIGHT=19 ALT=' fClus' TITLE='fClus'> ";
  althtmldef "fClus" as " fClus ";
  latexdef "fClus" as "{\rm fClus}";
htmldef "fClusf" as
   " <IMG SRC='_fclusf.gif' WIDTH=40 HEIGHT=19 ALT=' fClusf' TITLE='fClusf'> ";
  althtmldef "fClusf" as " fClusf ";
  latexdef "fClusf" as "{\rm fClusf}";
htmldef "TopMnd" as "TopMnd"; althtmldef "TopMnd" as "TopMnd";
  latexdef "TopMnd" as "{\rm TopMnd}";
htmldef "TopGrp" as
    "<IMG SRC='_topgrp.gif' WIDTH=48 HEIGHT=19 ALT=' TopGrp' TITLE='TopGrp'>";
  althtmldef "TopGrp" as "TopGrp";
  latexdef "TopGrp" as "{\rm TopGrp}";
htmldef "tsums" as " tsums ";
  althtmldef "tsums" as " tsums ";
  latexdef "tsums" as "{\rm tsums}";
htmldef "TopRing" as
    "<IMG SRC='_topring.gif' WIDTH=53 HEIGHT=19 " +
    "ALT=' TopRing' TITLE='TopRing'>";
  althtmldef "TopRing" as "TopRing";
  latexdef "TopRing" as "{\rm TopRing}";
htmldef "TopDRing" as "TopDRing"; althtmldef "TopDRing" as "TopDRing";
  latexdef "TopDRing" as "{\rm TopDRing}";
htmldef "TopMod" as "TopMod"; althtmldef "TopMod" as "TopMod";
  latexdef "TopMod" as "{\rm TopMod}";
htmldef "TopVec" as
    "<IMG SRC='_topvec.gif' WIDTH=43 HEIGHT=19 ALT=' TopVec' TITLE='TopVec'>";
  althtmldef "TopVec" as "TopVec";
  latexdef "TopVec" as "{\rm TopVec}";
htmldef "*MetSp" as
    "<IMG SRC='infty.gif' WIDTH=17 HEIGHT=19 ALT=' *' TITLE='*'>" +
    "<IMG SRC='_metsp.gif' WIDTH=41 HEIGHT=19 ALT=' MetSp' TITLE='MetSp'>";
  althtmldef "*MetSp" as "&infin;MetSp";
  latexdef "*MetSp" as "\infty{\rm MetSp}";
htmldef "MetSp" as
    "<IMG SRC='_metsp.gif' WIDTH=41 HEIGHT=19 ALT=' MetSp' TITLE='MetSp'>";
  althtmldef "MetSp" as "MetSp";
  latexdef "MetSp" as "{\rm MetSp}";
htmldef "toMetSp" as "toMetSp"; althtmldef "toMetSp" as "toMetSp";
  latexdef "toMetSp" as "{\rm toMetSp}";
htmldef "norm" as "<IMG SRC='_norm.gif' WIDTH=32 HEIGHT=19 ALT=' norm' " +
    "TITLE='norm'>";
  althtmldef "norm" as 'norm';
  latexdef "norm" as '{\rm norm}';
htmldef "NrmGrp" as "NrmGrp"; althtmldef "NrmGrp" as "NrmGrp";
  latexdef "NrmGrp" as "{\rm NrmGrp}";
htmldef "toNrmGrp" as " toNrmGrp "; althtmldef "toNrmGrp" as " toNrmGrp ";
  latexdef "toNrmGrp" as " {\rm toNrmGrp} ";
htmldef "NrmRing" as "NrmRing"; althtmldef "NrmRing" as "NrmRing";
  latexdef "NrmRing" as "{\rm NrmRing}";
htmldef "NrmMod" as "NrmMod"; althtmldef "NrmMod" as "NrmMod";
  latexdef "NrmMod" as "{\rm NrmMod}";
htmldef "NrmVec" as "NrmVec"; althtmldef "NrmVec" as "NrmVec";
  latexdef "NrmVec" as "{\rm NrmVec}";
htmldef "normOp" as
    "<IMG SRC='_normop.gif' WIDTH=52 HEIGHT=19 ALT=' normOp' TITLE='normOp'>";
  althtmldef "normOp" as " normOp ";
  latexdef "normOp" as "{\rm normOp}";
htmldef "NGHom" as " NGHom ";
  althtmldef "NGHom" as " NGHom ";
  latexdef "NGHom" as "{\rm NGHom}";
htmldef "NMHom" as " NMHom ";
  althtmldef "NMHom" as " NMHom ";
  latexdef "NMHom" as "{\rm NMHom}";
htmldef "II" as "<IMG SRC='bbi.gif' WIDTH=7 HEIGHT=19 ALT=' II' TITLE='II'>";
  althtmldef "II" as "II";
  latexdef "II" as "{\rm II}";
htmldef "-cn->" as "<IMG SRC='_cnmap.gif' WIDTH=23 HEIGHT=19 " +
    "ALT=' -cn-&gt;' TITLE='-cn-&gt;'>";
  althtmldef "-cn->" as '&ndash;<FONT SIZE=-1 FACE=sans-serif>cn</FONT>&rarr;';
  latexdef "-cn->" as
    "\raisebox{.5ex}{${\textstyle{\:}_{\mbox{\footnotesize\rm cn" +
    "}}}\atop{\textstyle{" +
    "\longrightarrow}\atop{\textstyle{}^{\mbox{\footnotesize\rm {\ }}}}}$}";
htmldef "Htpy" as " Htpy ";
  althtmldef "Htpy" as " Htpy ";
  latexdef "Htpy" as "{\rm Htpy}";
htmldef "PHtpy" as
    "<IMG SRC='_phtpy.gif' WIDTH=41 HEIGHT=19 ALT=' PHtpy' TITLE='PHtpy'>";
  althtmldef "PHtpy" as "PHtpy";
  latexdef "PHtpy" as "{\rm PHtpy}";
htmldef "~=ph" as
    " <IMG SRC='_simeqph.gif' WIDTH=26 HEIGHT=19 ALT=' ~=ph' TITLE='~=ph'> ";
  althtmldef "~=ph" as " &#8771;<SUB><I>ph</I></SUB>";
  latexdef "~=ph" as "\simeq_{ph}";
/*
htmldef "pi1b" as
    "<IMG SRC='pi.gif' WIDTH=10 HEIGHT=19 ALT=' pi' TITLE='pi'>" +
    "<IMG SRC='sub1.gif' WIDTH=4 HEIGHT=19 ALT=' 1' TITLE='1'>" +
    "<IMG SRC='subb.gif' WIDTH=6 HEIGHT=19 ALT=' b' TITLE='b'>";
  althtmldef "pi1b" as "<I>&pi;<SUB>1b</SUB></I>";
  latexdef "pi1b" as "\pi_{1b}";
*/
htmldef "*p" as
    "<IMG SRC='_astp.gif' WIDTH=14 HEIGHT=19 ALT=' *p' TITLE='*p'>";
  althtmldef "*p" as "*<SUB>&#x1D45D;</SUB>";
  latexdef "*p" as "*_p";
htmldef "Om1" as
    " <IMG SRC='comega.gif' WIDTH=11 HEIGHT=19 ALT=' Om' TITLE='Om'>" +
    "<IMG SRC='sub1.gif' WIDTH=4 HEIGHT=19 ALT=' 1' TITLE='1'> ";
  althtmldef "Om1" as " &Omega;<SUB>1</SUB> ";
  latexdef "Om1" as "\Omega_1";
htmldef "OmN" as
    " <IMG SRC='comega.gif' WIDTH=11 HEIGHT=19 ALT=' Om' TITLE='Om'>" +
    "<IMG SRC='subn.gif' WIDTH=6 HEIGHT=19 ALT=' N' TITLE='N'> ";
  althtmldef "OmN" as " &Omega;<SUB>&#x1D45B;</SUB> ";
  latexdef "OmN" as "\Omega_n";
htmldef "pi1" as
    " <IMG SRC='pi.gif' WIDTH=10 HEIGHT=19 ALT=' pi' TITLE='pi'>" +
    "<IMG SRC='sub1.gif' WIDTH=4 HEIGHT=19 ALT=' 1' TITLE='1'> ";
  althtmldef "pi1" as " <I>&pi;</I><SUB>1</SUB> ";
  latexdef "pi1" as "\pi_1";
htmldef "piN" as
    " <IMG SRC='pi.gif' WIDTH=10 HEIGHT=19 ALT=' pi' TITLE='pi'>" +
    "<IMG SRC='subn.gif' WIDTH=6 HEIGHT=19 ALT=' N' TITLE='N'> ";
  althtmldef "piN" as " <I>&pi;<SUB>n</SUB></I> ";
  latexdef "piN" as "\pi_n";
/*
htmldef "~~>m" as "<IMG SRC='_squigm.gif' WIDTH=25 HEIGHT=19 " +
    "ALT=' ~~&gt;m' TITLE='~~&gt;m'>";
  althtmldef "~~>m" as '<FONT FACE=sans-serif>&#8669;<SUB>m</SUB></FONT>';
  latexdef "~~>m" as "\rightsquigarrow_{\rm m}";
*/
htmldef "CMod" as "CMod"; althtmldef "CMod" as "CMod";
  latexdef "CMod" as "{\rm CMod}";
htmldef "CPreHil" as
  "<IMG SRC='_cprehil.gif' WIDTH=50 HEIGHT=19 ALT=' CPreHil' TITLE='CPreHil'>";
  althtmldef "CPreHil" as "CPreHil";
  latexdef "CPreHil" as "{\rm CPreHil}";
htmldef "toCHil" as "toCHil"; althtmldef "toCHil" as "toCHil";
  latexdef "toCHil" as "{\rm toCHil}";
htmldef "CauFil" as "CauFil"; althtmldef "CauFil" as "CauFil";
  latexdef "CauFil" as "{\rm CauFil}";
htmldef "Cau" as
    "<IMG SRC='_cau.gif' WIDTH=26 HEIGHT=19 ALT=' Cau' TITLE='Cau'>";
  althtmldef "Cau" as "Cau";
  latexdef "Cau" as "{\rm Cau}";
htmldef "CMet" as
    "<IMG SRC='_cmet.gif' WIDTH=35 HEIGHT=19 ALT=' CMet' TITLE='CMet'>";
  althtmldef "CMet" as "CMet";
  latexdef "CMet" as "{\rm CMet}";
htmldef "CMetSp" as "CMetSp"; althtmldef "CMetSp" as "CMetSp";
  latexdef "CMetSp" as "{\rm CMetSp}";
htmldef "Ban" as "Ban"; althtmldef "Ban" as "Ban";
  latexdef "Ban" as "{\rm Ban}";
htmldef "CHil" as
    "<IMG SRC='_chil.gif' WIDTH=28 HEIGHT=19 ALT=' CHil' TITLE='CHil'>";
  althtmldef "CHil" as "CHil";
  latexdef "CHil" as "{\rm CHil}";
htmldef "vol*" as
    "<IMG SRC='_vol.gif' WIDTH=19 HEIGHT=19 ALT=' vol' TITLE='vol'>" +
    "<IMG SRC='supast.gif' WIDTH=6 HEIGHT=19 ALT=' *' TITLE='*'>";
  althtmldef "vol*" as "vol*";
  latexdef "vol*" as "{\rm vol*}";
htmldef "vol" as
    "<IMG SRC='_vol.gif' WIDTH=19 HEIGHT=19 ALT=' vol' TITLE='vol'>";
  althtmldef "vol" as "vol";
  latexdef "vol" as "{\rm vol}";
htmldef "MblFn" as "MblFn";
  althtmldef "MblFn" as "MblFn"; latexdef "MblFn" as "{\rm MblFn}";
htmldef "L^1" as
    "<IMG SRC='cl.gif' WIDTH=10 HEIGHT=19 ALT=' L' TITLE='L'>" +
    "<IMG SRC='sup1.gif' WIDTH=4 HEIGHT=19 ALT=' ^1' TITLE='^1'>";
  althtmldef "L^1" as "&#x1D43F;<SUP>1</SUP>";
  latexdef "L^1" as "L^1";
htmldef "S.1" as
    "<IMG SRC='_int1.gif' WIDTH=11 HEIGHT=19 ALT=' S.1' TITLE='S.1'>";
  althtmldef "S.1" as "&int;<SUB>1</SUB>";
  latexdef "S.1" as "\int_2";
htmldef "S.2" as
    "<IMG SRC='_int2.gif' WIDTH=13 HEIGHT=19 ALT=' S.2' TITLE='S.2'>";
  althtmldef "S.2" as "&int;<SUB>2</SUB>";
  latexdef "S.2" as "\int_2";
htmldef "S." as "<IMG SRC='int.gif' WIDTH=10 HEIGHT=19 ALT=' S.' TITLE='S.'>";
  althtmldef "S." as "&int;";
  latexdef "S." as "\int";
htmldef "S_" as "<IMG SRC='int.gif' WIDTH=10 HEIGHT=19 ALT=' S_' TITLE='S_'>_";
  althtmldef "S_" as "&#x2A1C;";
  latexdef "S_" as "\int";
htmldef "_d" as " <IMG SRC='rmd.gif' WIDTH=8 HEIGHT=19 ALT=' _d' TITLE='_d'>";
  althtmldef "_d" as " d";
  latexdef "_d" as "\,{\rm d}";
htmldef "0p" as "<IMG SRC='0.gif' WIDTH=8 HEIGHT=19 ALT=' 0' TITLE='0'>" +
    "<IMG SRC='subp.gif' WIDTH=7 HEIGHT=19 ALT=' p' TITLE='p'>";
  althtmldef "0p" as "0<SUB>&#x1D45D;</SUB>";
  latexdef "0p" as "0_p";
htmldef "_D" as
    " <IMG SRC='rmcd.gif' WIDTH=10 HEIGHT=19 ALT=' _D' TITLE='_D'> ";
  althtmldef "_D" as " D ";
  latexdef "_D" as "{\rm D}";
htmldef "limCC" as
    " lim<IMG SRC='bbc.gif' WIDTH=12 HEIGHT=19 ALT=' CC' TITLE='CC'> ";
  althtmldef "limCC" as " lim<sub>&#8450;</sub> ";
  latexdef "limCC" as "{\rm lim}_\mathbb{C}";
htmldef "Dn" as
    " <IMG SRC='rmcd.gif' WIDTH=10 HEIGHT=19 ALT=' D' TITLE='D'>" +
    "<IMG SRC='supn.gif' WIDTH=6 HEIGHT=19 ALT=' n' TITLE='n'>";
  althtmldef "Dn" as "D<SUP>&#x1D45B;</SUP>";
  latexdef "Dn" as "{\rm D}^n";
htmldef "C^n" as "<IMG SRC='cc.gif' WIDTH=12 HEIGHT=19 ALT=' C' TITLE='C'>" +
    "<IMG SRC='supn.gif' WIDTH=6 HEIGHT=19 ALT=' ^n' TITLE='^n'>";
  althtmldef "C^n" as "<I>C<SUP>n</SUP></I>";
  latexdef "C^n" as "C^n";
htmldef "Monic1p" as "Monic<sub>1p</sub>";
  althtmldef "Monic1p" as "Monic<sub>1p</sub>";
  latexdef "Monic1p" as "{\rm Monic}_{1p}";
htmldef "Unic1p" as "Unic<sub>1p</sub>";
  althtmldef "Unic1p" as "Unic<sub>1p</sub>";
  latexdef "Unic1p" as "{\rm Unic}_{1p}";
htmldef "quot1p" as "quot<sub>1p</sub>";
  althtmldef "quot1p" as "quot<sub>1p</sub>";
  latexdef "quot1p" as "{\rm quot}_{1p}";
htmldef "rem1p" as "rem<sub>1p</sub>";
  althtmldef "rem1p" as "rem<sub>1p</sub>";
  latexdef "rem1p" as "{\rm rem}_{1p}";
htmldef "idlGen1p" as "idlGen<sub>1p</sub>";
  althtmldef "idlGen1p" as "idlGen<sub>1p</sub>";
  latexdef "idlGen1p" as "{\rm idlGen}_{1p}";
htmldef "Poly" as "Poly";
  althtmldef "Poly" as "Poly";
  latexdef "Poly" as "\rm{Poly}";
htmldef "Xp" as "<IMG SRC='cx.gif' WIDTH=13 HEIGHT=19 ALT=' X' TITLE='X'>" +
    "<IMG SRC='subp.gif' WIDTH=7 HEIGHT=19 ALT=' p' TITLE='p'>";
  althtmldef "Xp" as "<I>X<SUB>p</SUB></I>";
  latexdef "Xp" as "X_p";
htmldef "coeff" as "coeff";
  althtmldef "coeff" as "coeff";
  latexdef "coeff" as "\rm{coeff}";
htmldef "deg" as "deg";
  althtmldef "deg" as "deg";
  latexdef "deg" as "\rm{deg}";
htmldef "quot" as " quot ";
  althtmldef "quot" as " quot ";
  latexdef "quot" as "\rm{quot}";
htmldef "AA" as "<IMG SRC='bba.gif' WIDTH=13 HEIGHT=19 ALT=' AA' TITLE='AA'>";
  althtmldef "AA" as '&#120120;';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "AA" as "\mathbb{A}";
htmldef "Tayl" as " Tayl ";
  althtmldef "Tayl" as " Tayl ";
  latexdef "Tayl" as "\rm{Tayl}";
htmldef "Ana" as "Ana";
  althtmldef "Ana" as "Ana";
  latexdef "Ana" as "\rm{Ana}";
htmldef "~~>u" as "<IMG SRC='rightsquigarrow.gif' WIDTH=15 HEIGHT=19 " +
    "ALT=' ~~&gt;' TITLE='~~&gt;'>" +
    "<IMG SRC='subu.gif' WIDTH=6 HEIGHT=19 ALT=' u' TITLE='u'>";
  althtmldef "~~>u" as
    "&#8669;<SUB>&#x1D462;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~~>u" as "\rightsquigarrow_u";
htmldef "log" as
    "<IMG SRC='_log.gif' WIDTH=20 HEIGHT=19 ALT=' log' TITLE='log'>";
  althtmldef "log" as "log";
  latexdef "log" as "\log";
htmldef "^c" as
    " <IMG SRC='uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' ^' TITLE='^'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'> ";
  althtmldef "^c" as "&uarr;<SUB>&#x1D450;</SUB>";
  latexdef "^c" as "\uparrow_c";
htmldef "arcsin" as "arcsin";
  althtmldef "arcsin" as "arcsin";
  latexdef "arcsin" as "\arcsin";
htmldef "arccos" as "arccos";
  althtmldef "arccos" as "arccos";
  latexdef "arccos" as "\arccos";
htmldef "arctan" as "arctan";
  althtmldef "arctan" as "arctan";
  latexdef "arctan" as "\arctan";
htmldef "area" as "area";
  althtmldef "area" as "area";
  latexdef "area" as "{\rm area}";
htmldef "gamma" as
    "<IMG SRC='gamma.gif' WIDTH=11 HEIGHT=19 ALT=' gamma' TITLE='gamma'>";
  althtmldef "gamma" as "&gamma;";
  latexdef "gamma" as "\gamma";
htmldef "theta" as
    "<IMG SRC='theta.gif' WIDTH=8 HEIGHT=19 ALT=' theta' TITLE='theta'>";
  althtmldef "theta" as "&theta;";
  latexdef "theta" as "\theta";
htmldef "Lam" as "&Lambda;";
  althtmldef "Lam" as "&Lambda;";
  latexdef "Lam" as "\Lambda";
htmldef "psi" as "&psi;";
  althtmldef "psi" as "&psi;";
  latexdef "psi" as "\psi";
htmldef "ppi" as "<U>&pi;</U>";
  althtmldef "ppi" as "<U>&pi;</U>";
  latexdef "ppi" as "\pi";
htmldef "mmu" as
    "<IMG SRC='mu.gif' WIDTH=10 HEIGHT=19 ALT=' mmu' TITLE='mmu'>";
  althtmldef "mmu" as "&mu;";
  latexdef "mmu" as "\mu";
htmldef "sigma" as
    " <IMG SRC='sigma.gif' WIDTH=10 HEIGHT=19 ALT=' sigma' TITLE='sigma'> ";
  althtmldef "sigma" as " &sigma; ";
  latexdef "sigma" as " \sigma ";
htmldef "DChr" as "DChr";
  althtmldef "DChr" as "DChr";
  latexdef "DChr" as "{\rm DChr}";
htmldef "/L" as
    " <IMG SRC='solidus.gif' WIDTH=6 HEIGHT=19 ALT=' /' TITLE='/'>" +
    "<IMG SRC='subcl.gif' WIDTH=8 HEIGHT=19 ALT=' L' TITLE='L'>";
  althtmldef "/L" as " /<sub><i>L</i></sub> ";
  latexdef "/L" as " /_L ";

/* Graph theory */
htmldef "UHGrph" as ' UHGrph ';
 althtmldef "UHGrph" as ' UHGrph ';
 latexdef "UHGrph" as "{\rm UHGrph}";
htmldef "UMGrph" as " UMGrph "; althtmldef "UMGrph" as " UMGrph ";
  latexdef "UMGrph" as " {\rm UMGrph} ";
htmldef "USLGrph" as ' USLGrph ';
 althtmldef "USLGrph" as ' USLGrph ';
 latexdef "USLGrph" as "{\rm USLGrph}";
htmldef "USGrph" as " USGrph ";
 althtmldef "USGrph" as " USGrph ";
 latexdef "USGrph" as " {\rm USGrph} ";
htmldef "Neighbors" as ' Neighbors ';
 althtmldef "Neighbors" as ' Neighbors ';
 latexdef "Neighbors" as "{\rm Neighbors}";
htmldef "ComplUSGrph" as ' ComplUSGrph ';
 althtmldef "ComplUSGrph" as ' ComplUSGrph ';
 latexdef "ComplUSGrph" as "{\rm ComplUSGrph}";
htmldef "UnivVertex" as ' UnivVertex ';
 althtmldef "UnivVertex" as ' UnivVertex ';
 latexdef "UnivVertex" as "{\rm UnivVertex}";
htmldef "VDeg" as " VDeg "; althtmldef "VDeg" as " VDeg ";
  latexdef "VDeg" as " {\rm VDeg} ";
htmldef "Walks" as " Walks "; althtmldef "Walks" as " Walks ";
  latexdef "Walks" as " {\rm Walks} ";
htmldef "Trails" as " Trails "; althtmldef "Trails" as " Trails ";
  latexdef "Trails" as " {\rm Trails} ";
htmldef "Paths" as " Paths "; althtmldef "Paths" as " Paths ";
  latexdef "Paths" as " {\rm Paths} ";
htmldef "SPaths" as " SPaths "; althtmldef "SPaths" as " SPaths ";
  latexdef "SPaths" as " {\rm SPaths} ";
htmldef "WalkOn" as " WalkOn "; althtmldef "WalkOn" as " WalkOn ";
  latexdef "WalkOn" as " {\rm WalkOn} ";
htmldef "TrailOn" as " TrailOn "; althtmldef "TrailOn" as " TrailOn ";
  latexdef "TrailOn" as " {\rm TrailOn} ";
htmldef "PathOn" as " PathOn "; althtmldef "PathOn" as " PathOn ";
  latexdef "PathOn" as " {\rm PathOn} ";
htmldef "SPathOn" as ' SPathOn ';
 althtmldef "SPathOn" as ' SPathOn ';
 latexdef "SPathOn" as "{\rm SPathOn}";
htmldef "Circuits" as " Circuits "; althtmldef "Circuits" as " Circuits ";
  latexdef "Circuits" as " {\rm Circuits} ";
htmldef "Cycles" as " Cycles "; althtmldef "Cycles" as " Cycles ";
  latexdef "Cycles" as " {\rm Cycles} ";
htmldef "ConnGrph" as ' ConnGrph ';
 althtmldef "ConnGrph" as ' ConnGrph ';
 latexdef "ConnGrph" as "{\rm ConnGrph}";

htmldef "Plig" as
    "<IMG SRC='_plig.gif' WIDTH=25 HEIGHT=19 ALT=' Plig' TITLE='Plig'>";
  althtmldef "Plig" as "Plig";
  latexdef "Plig" as "{\rm Plig}";
htmldef "RPrime" as "RPrime"; althtmldef "RPrime" as "RPrime";
  latexdef "RPrime" as "{\rm RPrime}";
/*
htmldef "UFD" as "UFD"; althtmldef "UFD" as "UFD";
  latexdef "UFD" as "{\rm UFD}";
*/
htmldef "t+" as "<IMG SRC='t.gif' WIDTH=7 HEIGHT=19 ALT=' t' TITLE='t'>" +
    "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>";
  althtmldef "t+" as "t+";
  latexdef "t+" as "{\rm t}+";
htmldef "t*" as "<IMG SRC='t.gif' WIDTH=7 HEIGHT=19 ALT=' t' TITLE='t'>" +
    "<IMG SRC='ast.gif' WIDTH=7 HEIGHT=19 ALT=' *' TITLE='*'>";
  althtmldef "t*" as "t*";
  latexdef "t*" as "{\rm t}*";
htmldef "GrpOp" as
    "<IMG SRC='_grpop.gif' WIDTH=44 HEIGHT=19 ALT=' GrpOp' TITLE='GrpOp'>";
  althtmldef "GrpOp" as "GrpOp";
  latexdef "GrpOp" as "{\rm GrpOp}";
htmldef "GId" as "GId";
  althtmldef "GId" as "GId";
  latexdef "GId" as "{\rm GId}";
htmldef "inv" as
    "<IMG SRC='_inv.gif' WIDTH=19 HEIGHT=19 ALT=' inv' TITLE='inv'>";
  althtmldef "inv" as "inv";
  latexdef "inv" as "{\rm inv}";
htmldef "/g" as " <IMG SRC='_divg.gif' WIDTH=11 HEIGHT=19 ALT=' /g' " +
    "TITLE='/g'> ";
  althtmldef "/g" as " /<SUB>&#x1D454;</SUB> ";
  latexdef "/g" as "/_g";
htmldef "^g" as
    "<IMG SRC='_hatg.gif' WIDTH=11 HEIGHT=19 ALT=' ^g' TITLE='^g'>";
  althtmldef "^g" as "&uarr;<SUB>&#x1D454;</SUB>";
  latexdef "^g" as "\uparrow_g";
htmldef "AbelOp" as
    "<IMG SRC='_abelop.gif' WIDTH=47 HEIGHT=19 ALT=' AbelOp' TITLE='AbelOp'>";
  althtmldef "AbelOp" as "AbelOp";
  latexdef "AbelOp" as "{\rm AbelOp}";
htmldef "SubGrpOp" as
    "<IMG SRC='_subgrpop.gif' WIDTH=68 HEIGHT=19 " +
    "ALT=' SubGrpOp' TITLE='SubGrpOp'>";
  althtmldef "SubGrpOp" as "SubGrpOp";
  latexdef "SubGrpOp" as "{\rm SubGrpOp}";
htmldef "Ass" as
    "<IMG SRC='_ass.gif' WIDTH=22 HEIGHT=19 ALT=' Ass' TITLE='Ass'>";
  althtmldef "Ass" as "Ass";
  latexdef "Ass" as "{\rm Ass}";
htmldef "ExId" as
    " <IMG SRC='_exid.gif' WIDTH=29 HEIGHT=19 ALT=' ExId' TITLE='ExId'> ";
  althtmldef "ExId" as " ExId ";
  latexdef "ExId" as "{\rm ExId}";
htmldef "Magma" as
    "<IMG SRC='_magma.gif' WIDTH=48 HEIGHT=19 ALT=' Magma' TITLE='Magma'>";
  althtmldef "Magma" as "Magma";
  latexdef "Magma" as "{\rm Magma}";
htmldef "SemiGrp" as
  "<IMG SRC='_semigrp.gif' WIDTH=56 HEIGHT=19 ALT=' SemiGrp' TITLE='SemiGrp'>";
  althtmldef "SemiGrp" as "SemiGrp";
  latexdef "SemiGrp" as "{\rm SemiGrp}";
htmldef "MndOp" as "MndOp";
  althtmldef "MndOp" as "MndOp";
  latexdef "MndOp" as "{\rm MndOp}";
htmldef "GrpOpHom" as " GrpOpHom ";
  althtmldef "GrpOpHom" as " GrpOpHom ";
  latexdef "GrpOpHom" as "{\rm GrpOpHom}";
htmldef "GrpOpIso" as
    " <IMG SRC='_grpiso.gif' WIDTH=42 HEIGHT=19 " +
    "ALT=' GrpOpIso' TITLE='GrpOpIso'> ";
  althtmldef "GrpOpIso" as " GrpOpIso ";
  latexdef "GrpOpIso" as "{\rm GrpOpIso}";
htmldef "RingOps" as
  "<IMG SRC='_ringops.gif' WIDTH=55 HEIGHT=19 ALT=' RingOps' TITLE='RingOps'>";
  althtmldef "RingOps" as "RingOps";
  latexdef "RingOps" as "{\rm RingOps}";
htmldef "DivRingOps" as "<IMG SRC='_divringops.gif' WIDTH=77 HEIGHT=19" +
      " ALT=' DivRingOps' TITLE='DivRingOps'>";
  althtmldef "DivRingOps" as "DivRingOps";
  latexdef "DivRingOps" as "{\rm DivRingOps}";
htmldef "*-Fld" as
    "<IMG SRC='_astfld.gif' WIDTH=32 HEIGHT=19 ALT=' *-Fld' TITLE='*-Fld'>";
  althtmldef "*-Fld" as "*-Fld";
  latexdef "*-Fld" as "\ast-{\rm Fld}";
htmldef "Com2" as
    "<IMG SRC='_com2.gif' WIDTH=35 HEIGHT=19 ALT=' Com2' TITLE='Com2'>";
  althtmldef "Com2" as "Com2";
  latexdef "Com2" as "{\rm Com2}";
htmldef "Fld" as
    "<IMG SRC='_fld.gif' WIDTH=21 HEIGHT=19 ALT=' Fld' TITLE='Fld'>";
  althtmldef "Fld" as "Fld";
  latexdef "Fld" as "{\rm Fld}";
htmldef "CVecOLD" as
    "<IMG SRC='_cvec.gif' WIDTH=34 HEIGHT=19 ALT=' CVec' TITLE='CVec'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "CVecOLD" as "CVec<SUB>OLD</SUB>";
  latexdef "CVecOLD" as "{\rm CVec_{OLD}}";
htmldef "NrmCVec" as
  "<IMG SRC='_nrmcvec.gif' WIDTH=62 HEIGHT=19 ALT=' NrmCVec' TITLE='NrmCVec'>";
  althtmldef "NrmCVec" as "NrmCVec";
  latexdef "NrmCVec" as "{\rm NrmCVec}";
htmldef "+v" as "<IMG SRC='_plv.gif' WIDTH=19 HEIGHT=19 ALT=' +v' TITLE='+v'>";
  althtmldef "+v" as ' +<SUB>&#x1D463;</SUB> ';
  latexdef "+v" as '+_v';
htmldef "BaseSet" as
  "<IMG SRC='_baseset.gif' WIDTH=51 HEIGHT=19 ALT=' BaseSet' TITLE='BaseSet'>";
  althtmldef "BaseSet" as "BaseSet";
  latexdef "BaseSet" as "{\rm BaseSet}";
htmldef ".sOLD" as
    "<IMG SRC='_cds.gif' WIDTH=9 HEIGHT=19 ALT=' .s' TITLE='.s'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef ".sOLD" as ' <B>&middot;</B><SUB>&#x1D460;OLD</SUB> ';
  latexdef ".sOLD" as '\cdot_{s{\rm OLD}}';
htmldef "0vec" as
    "<IMG SRC='_0vec.gif' WIDTH=25 HEIGHT=19 ALT=' 0vec' TITLE='0vec'>";
  althtmldef "0vec" as '0<SUB>vec</SUB>';
  latexdef "0vec" as '0_{\rm vec}';
htmldef "-v" as "<IMG SRC='_mv.gif' WIDTH=17 HEIGHT=19 ALT=' -v' TITLE='-v'>";
  althtmldef "-v" as ' &minus;<SUB>&#x1D463;</SUB> ';
  latexdef "-v" as '-_v';
htmldef "normCV" as "<IMG SRC='_norm.gif' WIDTH=32 HEIGHT=19 ALT=' norm' " +
    "TITLE='norm'><SUB>CV</SUB>";
  althtmldef "normCV" as 'norm<SUB>CV</SUB>';
  latexdef "normCV" as '{\rm norm_{CV}}';
    /* 24-Apr-2007 nm These need images. */
htmldef "IndMet" as
    "<IMG SRC='_indmet.gif' WIDTH=45 HEIGHT=19 ALT=' IndMet' TITLE='IndMet'>";
  althtmldef "IndMet" as "IndMet";
  latexdef "IndMet" as "{\rm IndMet}";
htmldef ".iOLD" as
    "<IMG SRC='_cdi.gif' WIDTH=7 HEIGHT=19 ALT=' .i' TITLE='.i'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef ".iOLD" as '<B>&middot;</B><SUB>&#x1D456;OLD</SUB>';
  latexdef ".iOLD" as '\cdot_{i{\rm OLD}}';
htmldef "SubSp" as
    "<IMG SRC='_subsp.gif' WIDTH=40 HEIGHT=19 ALT=' SubSp' TITLE='SubSp'>";
  althtmldef "SubSp" as "SubSp";
  latexdef "SubSp" as "{\rm SubSp}";
htmldef "LnOp" as
    " <IMG SRC='_lnop.gif' WIDTH=36 HEIGHT=19 ALT=' LnOp' TITLE='LnOp'> ";
  althtmldef "LnOp" as " LnOp ";
  latexdef "LnOp" as "{\rm LnOp}";
htmldef "normOpOLD" as
    "<IMG SRC='_normop.gif' WIDTH=52 HEIGHT=19 ALT=' normOp' TITLE='normOp'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "normOpOLD" as " normOp<SUB>OLD</SUB> ";
  latexdef "normOpOLD" as "{\rm normOp_{OLD}}";
htmldef "BLnOp" as
    " <IMG SRC='_blnop.gif' WIDTH=45 HEIGHT=19 ALT=' BLnOp' TITLE='BLnOp'> ";
  althtmldef "BLnOp" as " BLnOp ";
  latexdef "BLnOp" as "{\rm BLnOp}";
htmldef "0op" as
    " <IMG SRC='_0op.gif' WIDTH=21 HEIGHT=19 ALT=' 0op' TITLE='0op'> ";
  althtmldef "0op" as " 0<SUB>op</SUB> ";
  latexdef "0op" as "0_\mathrm{op}";
htmldef "adj" as
    "<IMG SRC='_adj.gif' WIDTH=20 HEIGHT=19 ALT=' adj' TITLE='adj'>";
  althtmldef "adj" as "adj";
  latexdef "adj" as "{\rm adj}";
htmldef "HmOp" as
    "<IMG SRC='_hmop.gif' WIDTH=41 HEIGHT=19 ALT=' HmOp' TITLE='HmOp'>";
  althtmldef "HmOp" as "HmOp";
  latexdef "HmOp" as "{\rm HmOp}";
htmldef "CPreHilOLD" as
    "<IMG SRC='_cprehil.gif' WIDTH=50 HEIGHT=19 " +
    "ALT=' CPreHil' TITLE='CPreHil'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "CPreHilOLD" as "CPreHil<SUB>OLD</SUB>";
  latexdef "CPreHilOLD" as "{\rm CPreHil_{OLD}}";
htmldef "CBan" as
    "<IMG SRC='_cban.gif' WIDTH=35 HEIGHT=19 ALT=' CBan' TITLE='CBan'>";
  althtmldef "CBan" as "CBan";
  latexdef "CBan" as "{\rm CBan}";
htmldef "CHilOLD" as
    "<IMG SRC='_chil.gif' WIDTH=28 HEIGHT=19 ALT=' CHil' TITLE='CHil'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "CHilOLD" as "CHil<SUB>OLD</SUB>";
  latexdef "CHilOLD" as "{\rm CHil_{OLD}}";
    /* Hilbert space */
htmldef "~H" as "<IMG SRC='scrh.gif' WIDTH=19 HEIGHT=19 ALT=' ~H' TITLE='~H'>";
  althtmldef "~H" as ' &#8459;';
    /* 8459 is script H; 8460 is fraktur H */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "~H" as '\mathscr{H}';
htmldef "+h" as
    " <IMG SRC='_pvh.gif' WIDTH=18 HEIGHT=19 ALT=' +h' TITLE='+h'> ";
  althtmldef "+h" as ' +<SUB>&#x210E;</SUB> ';
  latexdef "+h" as '+_h';
htmldef ".h" as
    " <IMG SRC='_cdh.gif' WIDTH=9 HEIGHT=19 ALT=' .h' TITLE='.h'> ";
  althtmldef ".h" as ' <B>&middot;</B><SUB>&#x210E;</SUB> ';
  latexdef ".h" as '\cdot_h';
htmldef "0h" as "<IMG SRC='_0vh.gif' WIDTH=14 HEIGHT=19 ALT=' 0h' TITLE='0h'>";
  althtmldef "0h" as '0<SUB>&#x210E;</SUB>';
  latexdef "0h" as '0_h';
htmldef "-h" as
    " <IMG SRC='_mvh.gif' WIDTH=16 HEIGHT=19 ALT=' -h' TITLE='-h'> ";
  althtmldef "-h" as ' &minus;<SUB>&#x210E;</SUB> ';
  latexdef "-h" as '-_h';
htmldef ".ih" as " <IMG SRC='_cdih.gif' WIDTH=13 HEIGHT=19 ALT=' .ih' " +
    "TITLE='.ih'> ";
  althtmldef ".ih" as ' <B>&middot;</B><SUB><I>ih</I></SUB> ';
  latexdef ".ih" as '\cdot_{ih}';
htmldef "normh" as "<IMG SRC='_normh.gif' WIDTH=38 HEIGHT=19 ALT=' normh' " +
    "TITLE='normh'>";
  althtmldef "normh" as 'norm<SUB>&#x210E;</SUB>';
  latexdef "normh" as '{\rm norm}_h';
htmldef "Cauchy" as "<IMG SRC='_cauchy.gif' WIDTH=47 HEIGHT=19 " +
    "ALT=' Cauchy' TITLE='Cauchy'>";
  althtmldef "Cauchy" as 'Cauchy';
  latexdef "Cauchy" as '{\rm Cauchy}';
htmldef "~~>v" as " <IMG SRC='_squigv.gif' WIDTH=21 HEIGHT=19 " +
    "ALT=' ~~&gt;v' TITLE='~~&gt;v'> ";
  althtmldef "~~>v" as
    ' &#8669;<SUB>&#x1D463;</SUB> ';
    /* 24-Sep-2017 reverted sans-serif */
  latexdef "~~>v" as '\rightsquigarrow_v';
htmldef "SH" as "<IMG SRC='_sh.gif' WIDTH=24 HEIGHT=19 ALT=' SH' TITLE='SH'>";
  althtmldef "SH" as
    ' <I><B>S</B></I><SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "SH" as '\mathscr{S}_\mathscr{H}';
htmldef "CH" as
    "<IMG SRC='_scrch.gif' WIDTH=22 HEIGHT=19 ALT=' CH' TITLE='CH'>";
  althtmldef "CH" as
    ' <I><B>C</B></I><SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "CH" as '\mathscr{C}_\mathscr{H}';
htmldef "_|_" as
    "<IMG SRC='perp.gif' WIDTH=11 HEIGHT=19 ALT=' _|_' TITLE='_|_'>";
  althtmldef "_|_" as '&#8869;'; /* &bottom; */
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "_|_" as '\perp';
htmldef "+H" as
    " <IMG SRC='_plh.gif' WIDTH=24 HEIGHT=19 ALT=' +H' TITLE='+H'> ";
  althtmldef "+H" as ' +<SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "+H" as '+_\mathscr{H}';
htmldef "span" as
    "<IMG SRC='_span.gif' WIDTH=31 HEIGHT=19 ALT=' span' TITLE='span'>";
  althtmldef "span" as 'span';
  latexdef "span" as '{\rm span}';
htmldef "vH" as
    " <IMG SRC='_veeh.gif' WIDTH=21 HEIGHT=19 ALT=' vH' TITLE='vH'> ";
  althtmldef "vH" as ' &or;<SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "vH" as '\vee_\mathscr{H}';
htmldef "\/H" as
    " <IMG SRC='_bigveeh.gif' WIDTH=23 HEIGHT=19 ALT=' \/H' TITLE='\/H'> ";
  althtmldef "\/H" as ' <FONT SIZE="+1">&or;' +
    '</FONT><SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "\/H" as '\bigvee_\mathscr{H}';
htmldef "0H" as "<IMG SRC='_0h.gif' WIDTH=20 HEIGHT=19 ALT=' 0H' TITLE='0H'>";
  althtmldef "0H" as '0<SUB>&#8459;</SUB>';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "0H" as '0_\mathscr{H}';
htmldef "C_H" as
    " <IMG SRC='_cch.gif' WIDTH=23 HEIGHT=19 ALT=' C_H' TITLE='C_H'> ";
  althtmldef "C_H" as
    ' &#x1D436;<SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "C_H" as 'C_\mathscr{H}';
htmldef "projh" as
    "<IMG SRC='_proj.gif' WIDTH=24 HEIGHT=19 ALT=' proj' TITLE='proj'>" +
    " <IMG SRC='subh.gif' WIDTH=6 HEIGHT=19 ALT=' h' TITLE='h'>";
  althtmldef "projh" as 'proj<SUB>&#x210E;</SUB>';
  latexdef "projh" as '{\rm proj}_h';
htmldef "0hop" as
    "<IMG SRC='_0hop.gif' WIDTH=28 HEIGHT=19 ALT=' 0hop' TITLE='0hop'>";
  althtmldef "0hop" as ' 0<SUB>hop</SUB> ';
  latexdef "0hop" as "0_\mathrm{hop}";
htmldef "Iop" as
    " <IMG SRC='_iop.gif' WIDTH=18 HEIGHT=19 ALT=' Iop' TITLE='Iop'> ";
  althtmldef "Iop" as ' I<SUB>op</SUB> ';
  latexdef "Iop" as "I_\mathrm{op}";
htmldef "+op" as
    " <IMG SRC='_plop.gif' WIDTH=25 HEIGHT=19 ALT=' +op' TITLE='+op'> ";
  althtmldef "+op" as ' +<SUB>op</SUB> ';
  latexdef "+op" as '+_\mathrm{op}';
htmldef ".op" as
    " <IMG SRC='_cdop.gif' WIDTH=16 HEIGHT=19 ALT=' .op' TITLE='.op'> ";
  althtmldef ".op" as ' <B>&middot;</B><SUB>op</SUB> ';
  latexdef ".op" as '\cdot_\mathrm{op}';
htmldef "-op" as
    " <IMG SRC='_mop.gif' WIDTH=23 HEIGHT=19 ALT=' -op' TITLE='-op'> ";
  althtmldef "-op" as ' &minus;<SUB>op</SUB> ';
  latexdef "-op" as '-_\mathrm{op}';
htmldef "+fn" as
    " <IMG SRC='_plfn.gif' WIDTH=24 HEIGHT=19 ALT=' +fn' TITLE='+fn'> ";
  althtmldef "+fn" as ' +<SUB>fn</SUB> ';
  latexdef "+fn" as '+_\mathrm{fn}';
htmldef ".fn" as
    " <IMG SRC='_cdfn.gif' WIDTH=15 HEIGHT=19 ALT=' .fn' TITLE='.fn'> ";
  althtmldef ".fn" as ' <B>&middot;</B><SUB>fn</SUB> ';
  latexdef ".fn" as '\cdot_\mathrm{fn}';
htmldef "normop" as
  "<IMG SRC='_normsubop.gif' WIDTH=45 HEIGHT=19 ALT=' normop' TITLE='normop'>";
  althtmldef "normop" as 'norm<SUB>op</SUB>';
  latexdef "normop" as '{\rm norm}_{\rm op}';
htmldef "ConOp" as
    "<IMG SRC='_conop.gif' WIDTH=44 HEIGHT=19 ALT=' ConOp' TITLE='ConOp'>";
  althtmldef "ConOp" as 'ConOp';
  latexdef "ConOp" as '{\rm ConOp}';
htmldef "LinOp" as
    "<IMG SRC='_linop.gif' WIDTH=40 HEIGHT=19 ALT=' LinOp' TITLE='LinOp'>";
  althtmldef "LinOp" as 'LinOp';
  latexdef "LinOp" as '{\rm LinOp}';
htmldef "BndLinOp" as
    "<IMG SRC='_bndlinop.gif' WIDTH=65 HEIGHT=19 " +
    "ALT=' BndLinOp' TITLE='BndLinOp'>";
  althtmldef "BndLinOp" as 'BndLinOp';
  latexdef "BndLinOp" as '{\rm BndLinOp}';
htmldef "UniOp" as
    "<IMG SRC='_uniop.gif' WIDTH=41 HEIGHT=19 ALT=' UniOp' TITLE='UniOp'>";
  althtmldef "UniOp" as 'UniOp';
  latexdef "UniOp" as '{\rm UniOp}';
htmldef "HrmOp" as
    "<IMG SRC='_hrmop.gif' WIDTH=47 HEIGHT=19 ALT=' HrmOp' TITLE='HrmOp'>";
  althtmldef "HrmOp" as 'HrmOp';
  latexdef "HrmOp" as '{\rm HrmOp}';
htmldef "normfn" as
    "<IMG SRC='_normfn.gif' WIDTH=43 HEIGHT=19 ALT=' normfn' TITLE='normfn'>";
  althtmldef "normfn" as 'norm<SUB>fn</SUB>';
  latexdef "normfn" as '{\rm norm}_{\rm fn}';
htmldef "null" as
    "<IMG SRC='_null.gif' WIDTH=24 HEIGHT=19 ALT=' null' TITLE='null'>";
  althtmldef "null" as 'null';
  latexdef "null" as '{\rm null}';
htmldef "ConFn" as
    "<IMG SRC='_confn.gif' WIDTH=42 HEIGHT=19 ALT=' ConFn' TITLE='ConFn'>";
  althtmldef "ConFn" as 'ConFn';
  latexdef "ConFn" as '{\rm ConFn}';
htmldef "LinFn" as
    "<IMG SRC='_linfn.gif' WIDTH=38 HEIGHT=19 ALT=' LinFn' TITLE='LinFn'>";
  althtmldef "LinFn" as 'LinFn';
  latexdef "LinFn" as '{\rm LinFn}';
htmldef "adjh" as
    "<IMG SRC='_adjh.gif' WIDTH=26 HEIGHT=19 ALT=' adjh' TITLE='adjh'>";
  althtmldef "adjh" as 'adj<SUB>&#x210E;</SUB>';
  latexdef "adjh" as '{\rm adj}_h';
htmldef "bra" as
    "<IMG SRC='_bra.gif' WIDTH=22 HEIGHT=19 ALT=' bra' TITLE='bra'>";
  althtmldef "bra" as 'bra';
  latexdef "bra" as '{\rm bra}';
htmldef "ketbra" as
   " <IMG SRC='_ketbra.gif' WIDTH=43 HEIGHT=19 ALT=' ketbra' TITLE='ketbra'> ";
  althtmldef "ketbra" as ' ketbra ';
  latexdef "ketbra" as '{\rm ketbra}';
htmldef "<_op" as
   " <IMG SRC='_leop.gif' WIDTH=24 HEIGHT=19 ALT=' <_op' TITLE='<_op'> ";
  althtmldef "<_op" as " &le;<SUB>op</SUB> ";
  latexdef "<_op" as '\le_{\rm op}';
htmldef "eigvec" as
    "<IMG SRC='_eigvec.gif' WIDTH=41 HEIGHT=19 ALT=' eigvec' TITLE='eigvec'>";
  althtmldef "eigvec" as 'eigvec';
  latexdef "eigvec" as '{\rm eigvec}';
htmldef "eigval" as
    "<IMG SRC='_eigval.gif' WIDTH=39 HEIGHT=19 ALT=' eigval' TITLE='eigval'>";
  althtmldef "eigval" as 'eigval';
  latexdef "eigval" as '{\rm eigval}';
htmldef "Lambda" as
    "<IMG SRC='clambda.gif' WIDTH=11 HEIGHT=19 ALT=' Lambda' TITLE='Lambda'>";
  althtmldef "Lambda" as 'Lambda';
  latexdef "Lambda" as '\Lambda';
htmldef "States" as
    "<IMG SRC='_states.gif' WIDTH=40 HEIGHT=19 ALT=' States' TITLE='States'>";
  althtmldef "States" as 'States';
  latexdef "States" as '{\rm States}';
    /* These don't have images. */
htmldef "CHStates" as
    "<IMG SRC='_chstates.gif' WIDTH=61 HEIGHT=19 " +
    "ALT=' CHStates' TITLE='CHStates'>";
  althtmldef "CHStates" as 'CHStates';
  latexdef "CHStates" as '{\rm CHStates}';
htmldef "HAtoms" as 'HAtoms';
  althtmldef "HAtoms" as 'HAtoms';
  latexdef "HAtoms" as '{\rm HAtoms}';
htmldef "<oH" as
    " <IMG SRC='_ldh.gif' WIDTH=25 HEIGHT=19 ALT=' &lt;oH' TITLE='&lt;oH'> ";
  althtmldef "<oH" as
    ' &#8918;<SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "<oH" as '\lessdot_\mathscr{H}';
htmldef "MH" as
    " <IMG SRC='_mh.gif' WIDTH=27 HEIGHT=19 ALT=' MH' TITLE='MH'> ";
  althtmldef "MH" as ' &#x1D440;<SUB>&#8459;</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "MH" as 'M_\mathscr{H}';
htmldef "MH*" as
    " <IMG SRC='_mhast.gif' WIDTH=27 HEIGHT=19 ALT=' MH*' TITLE='MH*'> ";
  althtmldef "MH*" as ' &#x1D440;<SUB>&#8459;</SUB><SUP>*</SUP> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "MH*" as 'M_\mathscr{H}^*';

/* stuff to be sorted into the right places above: */

/* htmldef, althtmldef, latexdef for mathboxes */
/* Note the "Mathbox of" instead of "Mathbox for" to make searching easier. */

/* Mathbox of Thierry Arnoux */
htmldef "<<<" as "&lt;&lt;&lt;";
  althtmldef "<<<" as "&#x22D8;";
  latexdef "<<<" as "{\rm <<<}";
htmldef "Archi" as "Archi";
  althtmldef "Archi" as "Archi";
  latexdef "Archi" as "{\rm Archi}";
htmldef "oMnd" as "oMnd";
  althtmldef "oMnd" as "oMnd";
  latexdef "oMnd" as "{\rm oMnd}";
htmldef "oGrp" as "oGrp";
  althtmldef "oGrp" as "oGrp";
  latexdef "oGrp" as "{\rm oGrp}";
htmldef "oRing" as "oRing";
  althtmldef "oRing" as "oRing";
  latexdef "oRing" as "{\rm oRing}";
htmldef "oField" as "oField";
  althtmldef "oField" as "oField";
  latexdef "oField" as "{\rm oField}";
htmldef "SRing" as "SRing";
  althtmldef "SRing" as "SRing";
  latexdef "SRing" as "{\rm SRing}";
htmldef "SLMod" as "SLMod";
  althtmldef "SLMod" as "SLMod";
  latexdef "SLMod" as "{\rm SLMod}";
htmldef "|`v" as " &#8638;<SUB>v</SUB> ";
  althtmldef "|`v" as " &#8638;<SUB>v</SUB> ";
  latexdef "|`v" as "\restriction_v";
htmldef "RRExt" as " &#8477;Ext ";
  althtmldef "RRExt" as " &#8477;Ext ";
  latexdef "RRExt" as "\mathbb{R}{\rm Ext}";
htmldef "PsMet" as "PsMet";
  althtmldef "PsMet" as "PsMet";
  latexdef "PsMet" as "{\rm PsMet}";
htmldef "~Met" as "~Met";
  althtmldef "~Met" as "~<SUB>Met</SUB>";
  latexdef "~Met" as "~_{\rm Met}";
htmldef "pstoMet" as "pstoMet";
  althtmldef "pstoMet" as "pstoMet";
  latexdef "pstoMet" as "{\rm pstoMet}";
htmldef "HCmp" as "HCmp";
  althtmldef "HCmp" as "HCmp";
  latexdef "HCmp" as "{\rm HCmp}";
htmldef "CnExt" as "CnExt";
  althtmldef "CnExt" as "CnExt";
  latexdef "CnExt" as "{\rm CnExt}";
htmldef "UnifOn" as "UnifOn";
  althtmldef "UnifOn" as "UnifOn";
  latexdef "UnifOn" as "{\rm UnifOn}";
htmldef "UnifSt" as "UnifSt";
  althtmldef "UnifSt" as "UnifSt";
  latexdef "UnifSt" as "{\rm UnifSt}";
htmldef "UnifSp" as "UnifSp";
  althtmldef "UnifSp" as "UnifSp";
  latexdef "UnifSp" as "{\rm UnifSp}";
htmldef "toUnifSp" as "toUnifSp";
  althtmldef "toUnifSp" as "toUnifSp";
  latexdef "toUnifSp" as "{\rm toUnifSp}";
htmldef "unifTop" as "unifTop";
  althtmldef "unifTop" as "unifTop";
  latexdef "unifTop" as "{\rm unifTop}";
htmldef "uCn" as " Cn<SUB>u</SUB>";
  althtmldef "uCn" as " Cn<SUB>u</SUB>";
  latexdef "uCn" as "{\rm Cn_u}";
htmldef "CauFilU" as "CauFil<SUB>u</SUB>";
  althtmldef "CauFilU" as "CauFil<SUB>u</SUB>";
  latexdef "CauFilU" as "{\rm CauFil_u}";
htmldef "CUnifSp" as "CUnifSp";
  althtmldef "CUnifSp" as "CUnifSp";
  latexdef "CUnifSp" as "{\rm CUnifSp}";
htmldef "metUnif" as "metUnif";
  althtmldef "metUnif" as "metUnif";
  latexdef "metUnif" as "{\rm metUnif}";
htmldef "metUnifOLD" as "metUnif<SUB>OLD</SUB>";
  althtmldef "metUnifOLD" as "metUnif<SUB>OLD</SUB>";
  latexdef "metUnifOLD" as "{\rm metUnif}_{OLD}";
htmldef "/e" as " /<SUB>&#x1D452;</SUB> ";
  althtmldef "/e" as " /<SUB>&#x1D452;</SUB> ";
  latexdef "/e" as '/_e';
htmldef "sum*" as "&Sigma;<SUP>*</SUP>";
  althtmldef "sum*" as "&Sigma;<SUP>*</SUP>";
  latexdef "sum*" as "\Sigma^*";
htmldef "oFC" as "&#8728;<SUB>&#x1D453;/&#x1D450;</SUB>";
  althtmldef "oFC" as "&#8728;<SUB>&#x1D453;/&#x1D450;</SUB>";
  latexdef "oFC" as "\circ_f/c";
htmldef "sigAlgebra" as "sigAlgebra";
  althtmldef "sigAlgebra" as "sigAlgebra";
  latexdef "sigAlgebra" as "{\rm sigAlgebra}";
htmldef "sigaGen" as "sigaGen";
  althtmldef "sigaGen" as "sigaGen";
  latexdef "sigaGen" as "{\rm sigaGen}";
htmldef "BrSiga" as "&#x1D505;<SUB>&#8477;</SUB>";
  althtmldef "BrSiga" as "&#x1D505;<SUB>&#8477;</SUB>";
  latexdef "BrSiga" as "\mathfrak{B}_\mathbb{R}";
htmldef "sX" as " &times;<SUB>s</SUB> ";
  althtmldef "sX" as " &times;<SUB>s</SUB> ";
  latexdef "sX" as "\times_s";
htmldef "measures" as "measures";
  althtmldef "measures" as "measures";
  latexdef "measures" as "{\rm measures}";
htmldef "MblFnM" as "MblFnM";
  althtmldef "MblFnM" as "MblFnM";
  latexdef "MblFnM" as "{\rm MblFnM}";
htmldef "ae" as "a.e.";
  althtmldef "ae" as "a.e.";
  latexdef "ae" as "{\rm a.e.}";
htmldef "~ae" as "~ a.e.";
  althtmldef "~ae" as "~ a.e.";
  latexdef "~ae" as "{\rm ~ a.e.}";
htmldef "QQHom" as "QQHom";
  althtmldef "QQHom" as "&#8474;Hom";
  latexdef "QQHom" as "\mathbb{Q}{\rm Hom}";
htmldef "RRHom" as "RRHom";
  althtmldef "RRHom" as "&#8477;Hom";
  latexdef "RRHom" as "\mathbb{R}{\rm Hom}";
htmldef "RR*Hom" as "RR<SUP>*</SUP>Hom";
  althtmldef "RR*Hom" as "&#8477;<SUP>*</SUP>Hom";
  latexdef "RR*Hom" as "\mathbb{R}^*{\rm Hom}";
htmldef "itgm" as "itgm";
  althtmldef "itgm" as "itgm";
  latexdef "itgm" as "{\rm itgm}";
htmldef "sitg" as "sitg";
  althtmldef "sitg" as "sitg";
  latexdef "sitg" as "{\rm sitg}";
htmldef "sitm" as "sitm";
  althtmldef "sitm" as "sitm";
  latexdef "sitm" as "{\rm sitm}";
htmldef "Prob" as "Prob";
  althtmldef "Prob" as "Prob";
  latexdef "Prob" as "{\rm Prob}";
htmldef "cprob" as "cprob";
  althtmldef "cprob" as "cprob";
  latexdef "cprob" as "{\rm cprob}";
htmldef "rRndVar" as "rRndVar";
  althtmldef "rRndVar" as "rRndVar";
  latexdef "rRndVar" as "{\rm rRndVar}";
htmldef "_Ind" as "&#x1D7ED;";
  althtmldef "_Ind" as "&#x1D7ED;";
  latexdef "_Ind" as "\mathsfbf{1}";
htmldef "oRVC" as "&#8728;<SUB>RV/&#x1D450;</SUB>";
  althtmldef "oRVC" as "&#8728;<SUB>RV/&#x1D450;</SUB>";
  latexdef "oRVC" as "\circ_RV/c";
/* End of Thierry Arnoux's mathbox */

/* Mathbox of Mario Carneiro */
htmldef "zeta" as
    "<IMG SRC='zeta.gif' WIDTH=9 HEIGHT=19 ALT=' zeta' TITLE='zeta'>";
  althtmldef "zeta" as "&zeta;";
  latexdef "zeta" as "\zeta";
htmldef "_G" as
    "<IMG SRC='cgamma.gif' WIDTH=10 HEIGHT=19 ALT=' _G' TITLE='_G'>";
  althtmldef "_G" as "&Gamma;";
  latexdef "_G" as "\Gamma";
htmldef "log_G" as
    "<IMG SRC='_log.gif' WIDTH=20 HEIGHT=19 ALT=' log' TITLE='log'> " +
    "<IMG SRC='cgamma.gif' WIDTH=10 HEIGHT=19 ALT=' _G' TITLE='_G'>";
  althtmldef "log_G" as "log &Gamma;";
  latexdef "log_G" as "\log\Gamma";
htmldef "1/_G" as
    "1/<IMG SRC='cgamma.gif' WIDTH=10 HEIGHT=19 ALT=' _G' TITLE='_G'>";
  althtmldef "1/_G" as "1/&Gamma;";
  latexdef "1/_G" as "1/\Gamma";
htmldef "Retr" as " Retr "; althtmldef "Retr" as " Retr ";
  latexdef "Retr" as "{\rm Retr}";
htmldef "PCon" as "PCon"; althtmldef "PCon" as "PCon";
  latexdef "PCon" as " {\rm PCon} ";
htmldef "SCon" as "SCon"; althtmldef "SCon" as "SCon";
  latexdef "SCon" as "{\rm SCon}";
htmldef "CovMap" as " CovMap "; althtmldef "CovMap" as " CovMap ";
  latexdef "CovMap" as " {\rm CovMap} ";
htmldef "EulPaths" as " EulPaths "; althtmldef "EulPaths" as " EulPaths ";
  latexdef "EulPaths" as " {\rm EulPaths} ";
htmldef "e.g" as
    " <IMG SRC='_ing.gif' WIDTH=17 HEIGHT=19 ALT=' e.g' TITLE='e.g'> ";
  althtmldef "e.g" as "&isin;<SUB>&#x1D454;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "e.g" as "\in_g";
htmldef "|g" as
    " <IMG SRC='barwedge.gif' WIDTH=9 HEIGHT=19 ALT=' |' TITLE='|'>" +
    "<IMG SRC='subg.gif' WIDTH=7 HEIGHT=19 ALT=' g' TITLE='g'> ";
  althtmldef "|g" as "&#8892;<SUB>&#x1D454;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "|g" as "\barwedge_g";
htmldef "A.g" as
    "<IMG SRC='_forallg.gif' WIDTH=14 HEIGHT=19 ALT=' A.g' TITLE='A.g'>";
  althtmldef "A.g" as
    "&forall;<SUB>&#x1D454;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "A.g" as "\forall_g";
htmldef "=g" as
    " <IMG SRC='_eqg.gif' WIDTH=19 HEIGHT=19 ALT=' =g' TITLE='=g'> ";
  althtmldef "=g" as "=<SUB>&#x1D454;</SUB>"; latexdef "=g" as "=_g";
htmldef "/\g" as
    " <IMG SRC='_wedgeg.gif' WIDTH=18 HEIGHT=19 ALT=' /\g' TITLE='/\g'> ";
  althtmldef "/\g" as "&and;<SUB>&#x1D454;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "/\g" as "\wedge_g";
htmldef "-.g" as
    "<IMG SRC='_lnotg.gif' WIDTH=17 HEIGHT=19 ALT=' -.g' TITLE='-.g'>";
  althtmldef "-.g" as "&not;<SUB>&#x1D454;</SUB>"; latexdef "-.g" as "\lnot_g";
htmldef "->g" as
    " <IMG SRC='_tog.gif' WIDTH=20 HEIGHT=19 ALT=' -&gt;g' TITLE='-&gt;g'> ";
  althtmldef "->g" as
    " &rarr;<SUB>&#x1D454;</SUB> "; latexdef "->g" as "\to_g";
htmldef "<->g" as " <IMG SRC='_lrarrg.gif' WIDTH=20 HEIGHT=19 " +
    "ALT=' &lt;-&gt;g' TITLE='&lt;-&gt;g'> ";
  althtmldef "<->g" as " &harr;<SUB>&#x1D454;</SUB> ";
  latexdef "<->g" as "\leftrightarrow_g";
htmldef "\/g" as
    " <IMG SRC='_veeg.gif' WIDTH=15 HEIGHT=19 ALT=' \/g' TITLE='\/g'> ";
  althtmldef "\/g" as " &or;<SUB>&#x1D454;</SUB> ";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "\/g" as "\vee_g";
htmldef "E.g" as
    "<IMG SRC='_existsg.gif' WIDTH=16 HEIGHT=19 ALT=' E.g' TITLE='E.g'>";
  althtmldef "E.g" as
    "&exist;<SUB>&#x1D454;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "E.g" as "\exists_g";
htmldef "Fmla" as
    "<IMG SRC='_fmla.gif' WIDTH=33 HEIGHT=19 ALT=' Fmla' TITLE='Fmla'>";
  althtmldef "Fmla" as "Fmla"; latexdef "Fmla" as "{\rm Fmla}";
htmldef "Sat" as
    " <IMG SRC='_sat.gif' WIDTH=22 HEIGHT=19 ALT=' Sat' TITLE='Sat'> ";
  althtmldef "Sat" as " Sat "; latexdef "Sat" as "{\rm Sat}";
htmldef "SatE" as
    " <IMG SRC='_sat.gif' WIDTH=22 HEIGHT=19 ALT=' Sat' TITLE='Sat'>" +
    "<IMG SRC='subin.gif' WIDTH=7 HEIGHT=19 ALT=' E' TITLE='E'> ";
  althtmldef "SatE" as " Sat<SUB>&isin;</SUB> ";
  latexdef "SatE" as "{\rm Sat}_\in";
htmldef "|=" as
    " <IMG SRC='models.gif' WIDTH=12 HEIGHT=19 ALT=' |=' TITLE='|='> ";
  althtmldef "|=" as "&#8871;"; latexdef "|=" as "\models";
htmldef "AxExt" as
    "<IMG SRC='_axext.gif' WIDTH=41 HEIGHT=19 ALT=' AxExt' TITLE='AxExt'>";
  althtmldef "AxExt" as "AxExt"; latexdef "AxExt" as "{\rm AxExt}";
htmldef "AxRep" as
    "<IMG SRC='_axrep.gif' WIDTH=43 HEIGHT=19 ALT=' AxRep' TITLE='AxRep'>";
  althtmldef "AxRep" as "AxRep"; latexdef "AxRep" as "{\rm AxRep}";
htmldef "AxPow" as
    "<IMG SRC='_axpow.gif' WIDTH=46 HEIGHT=19 ALT=' AxPow' TITLE='AxPow'>";
  althtmldef "AxPow" as "AxPow"; latexdef "AxPow" as "{\rm AxPow}";
htmldef "AxUn" as
    "<IMG SRC='_axun.gif' WIDTH=36 HEIGHT=19 ALT=' AxUn' TITLE='AxUn'>";
  althtmldef "AxUn" as "AxUn"; latexdef "AxUn" as "{\rm AxUn}";
htmldef "AxReg" as
    "<IMG SRC='_axreg.gif' WIDTH=43 HEIGHT=19 ALT=' AxReg' TITLE='AxReg'>";
  althtmldef "AxReg" as "AxReg"; latexdef "AxReg" as "{\rm AxReg}";
htmldef "AxInf" as
    "<IMG SRC='_axinf.gif' WIDTH=36 HEIGHT=19 ALT=' AxInf' TITLE='AxInf'>";
  althtmldef "AxInf" as "AxInf"; latexdef "AxInf" as "{\rm AxInf}";
htmldef "ZF" as
    "<IMG SRC='_zf.gif' WIDTH=19 HEIGHT=19 ALT=' ZF' TITLE='ZF'>";
  althtmldef "ZF" as "<FONT FACE=sans-serif><B>ZF</B></FONT>";
  latexdef "ZF" as "{\sf ZF}";
htmldef "IntgRing" as " IntgRing "; althtmldef "IntgRing" as " IntgRing ";
  latexdef "IntgRing" as " {\rm IntgRing} ";
htmldef "cplMetSp" as " cplMetSp "; althtmldef "cplMetSp" as " cplMetSp ";
  latexdef "cplMetSp" as " {\rm cplMetSp} ";
htmldef "HomLimB" as " HomLimB "; althtmldef "HomLimB" as " HomLimB ";
  latexdef "HomLimB" as " {\rm HomLimB} ";
htmldef "HomLim" as " HomLim "; althtmldef "HomLim" as " HomLim ";
  latexdef "HomLim" as " {\rm HomLim} ";
htmldef "polyFld" as " polyFld "; althtmldef "polyFld" as " polyFld ";
  latexdef "polyFld" as " {\rm polyFld} ";
htmldef "splitFld1" as " splitFld<sub>1</sub> ";
  althtmldef "splitFld1" as " splitFld<sub>1</sub> ";
  latexdef "splitFld1" as " {\rm splitFld}_1 ";
htmldef "splitFld" as " splitFld "; althtmldef "splitFld" as " splitFld ";
  latexdef "splitFld" as " {\rm splitFld} ";
htmldef "polySplitLim" as " polySplitLim ";
  althtmldef "polySplitLim" as " polySplitLim ";
  latexdef "polySplitLim" as " {\rm polySplitLim} ";
htmldef "ZRing" as "ZRing"; althtmldef "ZRing" as "ZRing";
  latexdef "ZRing" as "{\rm ZRing}";
htmldef "GF" as " GF "; althtmldef "GF" as " GF ";
  latexdef "GF" as " {\rm GF} ";
htmldef "GF_oo" as "GF<sub>&infin;</sub>";
  althtmldef "GF_oo" as "GF<sub>&infin;</sub>";
  latexdef "GF_oo" as "{\rm GF}_\infty";
htmldef "~Qp" as "~Qp"; althtmldef "~Qp" as "~Qp";
  latexdef "~Qp" as "\sim_{\Bbb Qp}";
htmldef "/Qp" as "/Qp"; althtmldef "/Qp" as "/Qp";
  latexdef "/Qp" as "/_{\Bbb Qp}";
htmldef "Qp" as "Qp"; althtmldef "Qp" as "Qp";
  latexdef "Qp" as "\Bbb Q_p";
htmldef "Zp" as "Zp"; althtmldef "Zp" as "Zp";
  latexdef "Zp" as "\Bbb Z_p";
htmldef "_Qp" as "_Qp"; althtmldef "_Qp" as "_Qp";
  latexdef "_Qp" as "\overline{\Bbb Q_p}";
htmldef "Cp" as "Cp"; althtmldef "Cp" as "Cp";
  latexdef "Cp" as "\Bbb C_p";

/* End of Mario Carneiro's mathbox */

/* Mathbox of Paul Chapman */
/* End of Paul Chapman's mathbox */

/* Mathbox of Drahflow */
htmldef "^r" as
    "<IMG SRC='uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' ^' TITLE='^'>" +
    "<IMG SRC='r.gif' WIDTH=8 HEIGHT=19 ALT=' r' TITLE='r'>" ;
  althtmldef "^r" as '&uarr;r';
  latexdef "^r" as "\uparrow_r";
htmldef "t*rec" as "<IMG SRC='t.gif' WIDTH=7 HEIGHT=19 ALT=' t' TITLE='t'>" +
    "<IMG SRC='ast.gif' WIDTH=7 HEIGHT=19 ALT=' *' TITLE='*'>" + "rec";
  althtmldef "t*rec" as "t*rec";
  latexdef "t*rec" as "{{\rm t}*}_{\rm rec}";
/* End of Drahflow's mathbox */

/* Mathbox of Scott Fenton */
htmldef "Pred" as
    "<IMG SRC='_pred.gif' WIDTH=30 HEIGHT=19 ALT=' Pred' TITLE='Pred'>";
  althtmldef "Pred" as "Pred";
  latexdef "Pred" as "{\rm Pred}";
htmldef "TrPred" as
    "<IMG SRC='_trpred.gif' WIDTH=44 HEIGHT=19 ALT=' TrPred' TITLE='TrPred'>";
  althtmldef "TrPred" as "TrPred";
  latexdef "TrPred" as "{\rm TrPred}";
htmldef "wrecs" as "wrecs";
  althtmldef "wrecs" as "wrecs";
  latexdef "wrecs" as "{\rm wrecs}";
htmldef "wsuc" as "wsuc";
  althtmldef "wsuc" as "wsuc";
  latexdef "wsuc" as "{\rm wsuc}";
htmldef "WLim" as "WLim";
  althtmldef "WLim" as "WLim";
  latexdef "WLim" as "{\rm WLim}";
htmldef "No" as "<IMG SRC='_no.gif' WIDTH=17 HEIGHT=19 ALT=' No' TITLE='No'>";
  althtmldef "No" as '<FONT FACE=sans-serif> No </FONT>';
  latexdef "No" as "{\rm No}";
htmldef "<s" as
    "<IMG SRC='lt.gif' WIDTH=11 HEIGHT=19 ALT=' &lt;' TITLE='&lt;'>" +
    "<IMG SRC='subs.gif' WIDTH=6 HEIGHT=19 ALT=' s' TITLE='s'>";
  althtmldef "<s" as " &lt;s ";
  latexdef "<s" as "{<_s}";
htmldef "bday" as
    "<IMG SRC='_bday.gif' WIDTH=32 HEIGHT=19 ALT=' bday' TITLE='bday'>";
  althtmldef "bday" as '<FONT FACE=sans-serif> bday </FONT>';
  latexdef "bday" as "{\rm bday}";
htmldef "(++)" as "(++)";
  althtmldef "(++)" as "(++)";
  latexdef "(++)" as "(++)";
htmldef "(x)" as
    " <IMG SRC='otimes.gif' WIDTH=13 HEIGHT=19 ALT=' (x)' TITLE='(x)'> ";
  althtmldef "(x)" as " &#x2297; ";
  latexdef "(x)" as "\otimes";
/*
htmldef "(+)" as
    " <IMG SRC='oplus.gif' WIDTH=13 HEIGHT=19 ALT=' (+)' TITLE='(+)'> ";
  althtmldef "(+)" as " &#x2295; ";
  latexdef "(+)" as "\oplus";
*/
htmldef "Bigcup" as
    "<IMG SRC='_bigcup.gif' WIDTH=44 HEIGHT=19 ALT=' Bigcup' TITLE='Bigcup'>";
  althtmldef "Bigcup" as '<FONT FACE=sans-serif> Bigcup </FONT>';
  latexdef "Bigcup" as "{\rm Bigcup}";
htmldef "SSet" as
    "<IMG SRC='_sset.gif' WIDTH=29 HEIGHT=19 ALT=' SSet' TITLE='SSet'>";
  althtmldef "SSet" as '<FONT FACE=sans-serif> SSet </FONT>';
  latexdef "SSet" as "{\rm SSet}";
htmldef "Trans" as
    "<IMG SRC='_trans.gif' WIDTH=38 HEIGHT=19 ALT=' Trans' TITLE='Trans'>";
  althtmldef "Trans" as '<FONT FACE=sans-serif> Trans </FONT>';
  latexdef "Trans" as "{\rm Trans}";
htmldef "Limits" as
    "<IMG SRC='_limits.gif' WIDTH=41 HEIGHT=19 ALT=' Limits' TITLE='Limits'>";
  althtmldef "Limits" as '<FONT FACE=sans-serif> Limits </FONT>';
  latexdef "Limits" as "{\rm Limits}";
htmldef "Fix" as
    "<IMG SRC='_fix.gif' WIDTH=21 HEIGHT=19 ALT=' Fix' TITLE='Fix'>";
  althtmldef "Fix" as '<FONT FACE=sans-serif> Fix </FONT>';
  latexdef "Fix" as "{\rm Fix}";
htmldef "Funs" as
    "<IMG SRC='_funs.gif' WIDTH=31 HEIGHT=19 ALT=' Funs' TITLE='Funs'>";
  althtmldef "Funs" as '<FONT FACE=sans-serif> Funs </FONT>';
  latexdef "Funs" as "{\rm Funs}";
htmldef "Singleton" as "Singleton";
  althtmldef "Singleton" as "Singleton";
  latexdef "Singleton" as "Singleton";
htmldef "Singletons" as "<IMG SRC='_singletons.gif' WIDTH=66 HEIGHT=19 " +
    "ALT=' Singletons' TITLE='Singletons'>";
  althtmldef "Singletons" as '<FONT FACE=sans-serif> Singletons </FONT>';
  latexdef "Singletons" as "{\rm Singletons}";
htmldef "Image" as "Image";
  althtmldef "Image" as "Image";
  latexdef "Image" as "{\rm Image}";
htmldef "Cart" as "Cart";
  althtmldef "Cart" as "Cart";
  latexdef "Cart" as "{\rm Cart}";
htmldef "Img" as "Img";
  althtmldef "Img" as "Img";
  latexdef "Img" as "{\rm Img}";
htmldef "Domain" as "Domain";
  althtmldef "Domain" as "Domain";
  latexdef "Domain" as "{\rm Domain}";
htmldef "Range" as "Range";
  althtmldef "Range" as "Range";
  latexdef "Range" as "{\rm Range}";
htmldef "pprod" as "pprod";
  althtmldef "pprod" as "pprod";
  latexdef "pprod" as "{\rm pprod}";
htmldef "Apply" as "Apply";
  althtmldef "Apply" as "Apply";
  latexdef "Apply" as "{\rm Apply}";
htmldef "Cup" as "Cup";
  althtmldef "Cup" as "Cup";
  latexdef "Cup" as "{\rm Cup}";
htmldef "Cap" as "Cap";
  althtmldef "Cap" as "Cap";
  latexdef "Cap" as "{\rm Cap}";
htmldef "Succ" as "Succ";
  althtmldef "Succ" as "Succ";
  latexdef "Succ" as "{\rm Succ}";
htmldef "Funpart" as "Funpart";
  althtmldef "Funpart" as "Funpart";
  latexdef "Funpart" as "{\rm Funpart}";
htmldef "FullFun" as "FullFun";
  althtmldef "FullFun" as "FullFun";
  latexdef "FullFun" as "{\rm FullFun}";
htmldef "Restrict" as "Restrict";
  althtmldef "Restrict" as "Restrict";
  latexdef "Restrict" as "{\rm Restrict}";
htmldef "LB" as "LB";
  althtmldef "LB" as "LB";
  latexdef "LB" as "{\rm LB}";
htmldef "UB" as "UB";
  althtmldef "UB" as "UB";
  latexdef "UB" as "{\rm UB}";
htmldef "<<" as
  "<IMG SRC='llangle.gif' WIDTH=6 HEIGHT=19 ALT=' &lt;&lt;' TITLE='&lt;&lt;'>";
  althtmldef "<<" as "&#10218;";
  latexdef "<<" as "\langle\langle";
htmldef ">>" as
  "<IMG SRC='rrangle.gif' WIDTH=6 HEIGHT=19 ALT=' &gt;&gt;' TITLE='&gt;&gt;'>";
  althtmldef ">>" as "&#10219;";
  latexdef ">>" as "\rangle\rangle";
htmldef "XX." as
    " <IMG SRC='_ttimes.gif' WIDTH=18 HEIGHT=19 ALT=' XX.' TITLE='XX.'> ";
  althtmldef "XX." as ' &times;&times; ';
  latexdef "XX." as "\times\times";
htmldef "EE" as "<IMG SRC='bbe.gif' WIDTH=11 HEIGHT=19 ALT=' EE' TITLE='EE'>";
  althtmldef "EE" as " &#x1D53C ";
/*
htmldef "EE" as " <FONT FACE=sans-serif>&Eopf;</FONT> ";
  althtmldef "EE" as " <FONT FACE=sans-serif>&#x1D53C</FONT> ";
*/
  latexdef "EE" as "\mathbb{E}";
htmldef "Btwn" as
    " <IMG SRC='_btwn.gif' WIDTH=35 HEIGHT=19 ALT=' Btwn' TITLE='Btwn'> ";
  althtmldef "Btwn" as " Btwn ";
  latexdef "Btwn" as "{\rm Btwn}";
htmldef "Cgr" as "Cgr";
  althtmldef "Cgr" as "Cgr";
  latexdef "Cgr" as "{\rm Cgr}";
htmldef "OuterFiveSeg" as " <IMG SRC='_outerfiveseg.gif' WIDTH=89 HEIGHT=19 " +
    "ALT=' OuterFiveSeg' TITLE='OuterFiveSeg'> ";
  althtmldef "OuterFiveSeg" as " OuterFiveSeg ";
  latexdef "OuterFiveSeg" as "{\bb OuterFiveSeg}";
htmldef "TransportTo" as "TransportTo";
  althtmldef "TransportTo" as "TransportTo";
  latexdef "TransportTo" as "{\rm TransportTo}";
htmldef "InnerFiveSeg" as " <IMG SRC='_innerfiveseg.gif' WIDTH=84 HEIGHT=19 " +
    "ALT=' InnerFiveSeg' TITLE='InnerFiveSeg'> ";
  althtmldef "InnerFiveSeg" as " InnerFiveSeg ";
  latexdef "InnerFiveSeg" as "{\bb InnerFiveSeg}";
htmldef "Cgr3" as "Cgr3";
  althtmldef "Cgr3" as "Cgr3";
  latexdef "Cgr3" as "{\rm Cgr3}";
htmldef "Colinear" as " <IMG SRC='_colinear.gif' WIDTH=54 HEIGHT=19 " +
    "ALT=' Colinear' TITLE='Colinear'> ";
  althtmldef "Colinear" as " Colinear ";
  latexdef "Colinear" as "{\bb Colinear}";
htmldef "FiveSeg" as " <IMG SRC='_fiveseg.gif' WIDTH=51 HEIGHT=19 " +
    "ALT=' FiveSeg' TITLE='FiveSeg'> ";
  althtmldef "FiveSeg" as " FiveSeg ";
  latexdef "FiveSeg" as "{\bb FiveSeg}";
/*
htmldef "==3" as
    " <IMG SRC='equiv.gif' WIDTH=12 HEIGHT=19 ALT=' ==' TITLE='=='>" +
    "<IMG SRC='sub3.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'> ";
  althtmldef "==3" as " &#x2261;&#x2083; ";
  latexdef "==3" as "\equiv_3";
*/
htmldef "Seg<_" as " <IMG SRC='_segle.gif' WIDTH=30 HEIGHT=19 " +
    "ALT=' Seg&lt;_' TITLE='Seg&lt;_'> ";
  althtmldef "Seg<_" as " Seg<SUB>&le;</SUB> ";
  latexdef "Seg<_" as "{\bb Seg}_\le";
htmldef "OutsideOf" as "OutsideOf";
  althtmldef "OutsideOf" as "OutsideOf";
  latexdef "OutsideOf" as "{\rm OutsideOf}";
htmldef "Line" as "Line";
  althtmldef "Line" as "Line";
  latexdef "Line" as "{\rm Line}";
htmldef "LinesEE" as "LinesEE";
  althtmldef "LinesEE" as "LinesEE";
  latexdef "LinesEE" as "{\rm LinesEE}";
htmldef "Ray" as "Ray";
  althtmldef "Ray" as "Ray";
  latexdef "Ray" as "{\rm Ray}";
htmldef "BernPoly" as " BernPoly ";
  althtmldef "BernPoly" as " BernPoly ";
  latexdef "BernPoly" as "{\rm BernPoly}";

htmldef "Hf" as " Hf ";
  althtmldef "Hf" as " Hf ";
  latexdef "Hf" as "{\rm Hf}";

htmldef "prod_" as "<IMG SRC='prod.gif' WIDTH=12 HEIGHT=19 " +
    "ALT=' prod_' TITLE='prod_'>";
  althtmldef "prod_" as "&#x220F";
  latexdef "prod_" as "\prod";

htmldef "FallFac" as " FallFac ";
  althtmldef "FallFac" as " FallFac ";
  latexdef "FallFac" as "{\rm FallFac}";

htmldef "RiseFac" as " RiseFac ";
  althtmldef "RiseFac" as " RiseFac ";
  latexdef "RiseFac" as "{\rm RiseFac}";

/* End of Scott Fenton's mathbox */


/* Mathbox of Jeff Hankins */

/* Mathbox of Anthony Hart */

/* Mathbox of Jeff Hoffman */
htmldef "gcdOLD" as
    "<IMG SRC='_gcd.gif' WIDTH=23 HEIGHT=19 ALT=' gcd' TITLE='gcd'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "gcdOLD" as " gcd<SUB>OLD</SUB> ";
  latexdef "gcdOLD" as "{\rm gcd_{OLD}}";


/***** Commented out to due to removal of FL's mathbox ******
       For recovery, note that "*" was changed to "@" everywhere.
/@ Mathbox of FL @/
htmldef "A1" as
    "<IMG SRC='_bnj_ca1.gif' WIDTH=16 HEIGHT=19 ALT=' A1' TITLE='A1'>";
  althtmldef "A1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;<SUB>1</SUB></SPAN>';
  latexdef "A1" as "A_1";
htmldef "A2" as "<IMG SRC='_ca.gif' WIDTH=11 HEIGHT=19 ALT=' A' TITLE='A'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "A2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;<SUB>2</SUB></SPAN>';
  latexdef "A2" as "A_2";
htmldef "B1" as
    "<IMG SRC='_bnj_cb1.gif' WIDTH=17 HEIGHT=19 ALT=' B1' TITLE='B1'>";
  althtmldef "B1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;<SUB>1</SUB></SPAN>';
  latexdef "B1" as "B_1";
htmldef "B2" as "<IMG SRC='_cb.gif' WIDTH=12 HEIGHT=19 ALT=' B' TITLE='B'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "B2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;<SUB>2</SUB></SPAN>';
  latexdef "B2" as "B_2";
htmldef "C1" as
    "<IMG SRC='_bnj_cc1.gif' WIDTH=17 HEIGHT=19 ALT=' C1' TITLE='C1'>";
  althtmldef "C1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;<SUB>1</SUB></SPAN>';
  latexdef "C1" as "C_1";
htmldef "C2" as "<IMG SRC='_cc.gif' WIDTH=12 HEIGHT=19 ALT=' C' TITLE='C'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "C2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;<SUB>2</SUB></SPAN>';
  latexdef "C2" as "C_2";
htmldef "D1" as
    "<IMG SRC='_bnj_cd1.gif' WIDTH=17 HEIGHT=19 ALT=' D1' TITLE='D1'>";
  althtmldef "D1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;<SUB>1</SUB></SPAN>';
  latexdef "D1" as "D_1";
htmldef "D2" as "<IMG SRC='_cd.gif' WIDTH=12 HEIGHT=19 ALT=' D' TITLE='D'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "D2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;<SUB>2</SUB></SPAN>';
  latexdef "D2" as "D_2";
htmldef "F1" as
    "<IMG SRC='_bnj_cf1.gif' WIDTH=18 HEIGHT=19 ALT=' F1' TITLE='F1'>";
  althtmldef "F1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;<SUB>1</SUB></SPAN>';
  latexdef "F1" as "F_1";
htmldef "F2" as "<IMG SRC='_cf.gif' WIDTH=13 HEIGHT=19 ALT=' F' TITLE='F'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "F2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;<SUB>2</SUB></SPAN>';
  latexdef "F2" as "F_2";
htmldef "F3" as "<IMG SRC='_cf.gif' WIDTH=13 HEIGHT=19 ALT=' F' TITLE='F'>" +
    "<IMG SRC='__sub3p.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "F3" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;<SUB>3</SUB></SPAN>';
  latexdef "F3" as "F_3";
htmldef "G1" as
    "<IMG SRC='_bnj_cg1.gif' WIDTH=17 HEIGHT=19 ALT=' G1' TITLE='G1'>";
  althtmldef "G1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;<SUB>1</SUB></SPAN>';
  latexdef "G1" as "G_1";
htmldef "G2" as "<IMG SRC='_cg.gif' WIDTH=12 HEIGHT=19 ALT=' G' TITLE='G'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "G2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;<SUB>2</SUB></SPAN>';
  latexdef "G2" as "G_2";
htmldef "H1" as
    "<IMG SRC='_bnj_ch1.gif' WIDTH=19 HEIGHT=19 ALT=' H1' TITLE='H1'>";
  althtmldef "H1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;<SUB>1</SUB></SPAN>';
  latexdef "H1" as "H_1";
htmldef "H2" as "<IMG SRC='_ch.gif' WIDTH=14 HEIGHT=19 ALT=' H' TITLE='H'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "H2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;<SUB>2</SUB></SPAN>';
  latexdef "H2" as "H_2";
htmldef "I1" as
    "<IMG SRC='_bnj_ci1.gif' WIDTH=13 HEIGHT=19 ALT=' I1' TITLE='I1'>";
  althtmldef "I1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;<SUB>1</SUB></SPAN>';
  latexdef "I1" as "I_1";
htmldef "I2" as "<IMG SRC='_ci.gif' WIDTH=8 HEIGHT=19 ALT=' I' TITLE='I'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "I2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;<SUB>2</SUB></SPAN>';
  latexdef "I2" as "I_2";
htmldef "L1" as
    "<IMG SRC='_bnj_cl1.gif' WIDTH=15 HEIGHT=19 ALT=' L1' TITLE='L1'>";
  althtmldef "L1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;<SUB>1</SUB></SPAN>';
  latexdef "L1" as "L_1";
htmldef "L2" as "<IMG SRC='_cl.gif' WIDTH=10 HEIGHT=19 ALT=' L' TITLE='L'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "L2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;<SUB>2</SUB></SPAN>';
  latexdef "L2" as "L_2";
htmldef "L3" as "<IMG SRC='_cl.gif' WIDTH=10 HEIGHT=19 ALT=' L' TITLE='L'>" +
    "<IMG SRC='__sub3p.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "L3" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;<SUB>3</SUB></SPAN>';
  latexdef "L3" as "L_3";
htmldef "M1" as
    "<IMG SRC='_bnj_cm1.gif' WIDTH=20 HEIGHT=19 ALT=' M1' TITLE='M1'>";
  althtmldef "M1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;<SUB>1</SUB></SPAN>';
  latexdef "M1" as "M_1";
htmldef "M2" as "<IMG SRC='_cm.gif' WIDTH=15 HEIGHT=19 ALT=' M' TITLE='M'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "M2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;<SUB>2</SUB></SPAN>';
  latexdef "M2" as "M_2";
htmldef "O1" as
    "<IMG SRC='_bnj_co1.gif' WIDTH=17 HEIGHT=19 ALT=' O1' TITLE='O1'>";
  althtmldef "O1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;<SUB>1</SUB></SPAN>';
  latexdef "O1" as "O_1";
htmldef "O2" as "<IMG SRC='_co.gif' WIDTH=12 HEIGHT=19 ALT=' O' TITLE='O'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "O2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;<SUB>2</SUB></SPAN>';
  latexdef "O2" as "O_2";
htmldef "Ro1" as "<IMG SRC='_cro.gif' WIDTH=19 HEIGHT=19 ALT=' Ro' TITLE='Ro'>"
    + "<IMG SRC='__sub1p.gif' WIDTH=4 HEIGHT=19 ALT=' 1' TITLE='1'>";
  althtmldef "Ro1" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>Ro<SUB>1</SUB></I></SPAN>';
  latexdef "Ro1" as "Ro_1";
htmldef "Ro2" as "<IMG SRC='_cro.gif' WIDTH=19 HEIGHT=19 ALT=' Ro' TITLE='Ro'>"
    + "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "Ro2" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>Ro<SUB>2</SUB></I></SPAN>';
  latexdef "Ro2" as "Ro_2";
htmldef "S1" as
    "<IMG SRC='_bnj_cs1.gif' WIDTH=16 HEIGHT=19 ALT=' S1' TITLE='S1'>";
  althtmldef "S1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;<SUB>1</SUB></SPAN>';
  latexdef "S1" as "S_1";
htmldef "S2" as "<IMG SRC='_cs.gif' WIDTH=11 HEIGHT=19 ALT=' S' TITLE='S'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "S2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;<SUB>2</SUB></SPAN>';
  latexdef "S2" as "S_2";
htmldef "V1" as
    "<IMG SRC='_bnj_cv1.gif' WIDTH=17 HEIGHT=19 ALT=' V1' TITLE='V1'>";
  althtmldef "V1" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;<SUB>1</SUB></SPAN>';
  latexdef "V1" as "V_1";
htmldef "V2" as "<IMG SRC='_cv.gif' WIDTH=12 HEIGHT=19 ALT=' V' TITLE='V'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "V2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;<SUB>2</SUB></SPAN>';
  latexdef "V2" as "V_2";
htmldef "V3" as "<IMG SRC='_cv.gif' WIDTH=12 HEIGHT=19 ALT=' V' TITLE='V'>" +
    "<IMG SRC='__sub3p.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "V3" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;<SUB>2</SUB></SPAN>';
  latexdef "V3" as "V_3";
htmldef "W2" as "<IMG SRC='_cw.gif' WIDTH=16 HEIGHT=19 ALT=' W' TITLE='W'>" +
    "<IMG SRC='__sub2p.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "W2" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44A;<SUB>2</SUB></SPAN>';
  latexdef "W2" as "W_2";

htmldef "+t" as "<IMG SRC='_plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>"
    + "<IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "+t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>+<SUB>t</SUB> </I></SPAN>';
  latexdef "+t" as "+_t";
htmldef "-t" as "<IMG SRC='_minus.gif' WIDTH=11 HEIGHT=19 ALT=' -' TITLE='-'>"
    + "<IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "-t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>-<SUB>t</SUB> </I></SPAN>';
  latexdef "-t" as "-_t";
htmldef ".t" as "<IMG SRC='_cdot.gif' WIDTH=4 HEIGHT=19 ALT=' .' TITLE='.'>" +
    "<IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef ".t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.<SUB>t</SUB> </I></SPAN>';
  latexdef ".t" as "._t";
htmldef "/t" as "<IMG SRC='_solidus.gif' WIDTH=6 HEIGHT=19 ALT=' /' " +
    "TITLE='/'><IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "/t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>/<SUB>t</SUB> </I></SPAN>';
  latexdef "/t" as "/_t";
htmldef "~t" as "<IMG SRC='_sim.gif' WIDTH=13 HEIGHT=19 ALT=' ~' TITLE='~'>" +
    "<IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "~t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>~<SUB>t</SUB> </I></SPAN>';
  latexdef "~t" as "~_t";
htmldef "0t" as "<IMG SRC='_0.gif' WIDTH=8 HEIGHT=19 ALT=' 0' TITLE='0'>" +
    "<IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "0t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>0<SUB>t</SUB> </I></SPAN>';
  latexdef "0t" as "0_t";
htmldef "1t" as "<IMG SRC='_1.gif' WIDTH=7 HEIGHT=19 ALT=' 1' TITLE='1'>" +
    "<IMG SRC='__subtp.gif' WIDTH=5 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef "1t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>1<SUB>t</SUB> </I></SPAN>';
  latexdef "1t" as "1_t";

htmldef "+w" as "<IMG SRC='_plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>"
    + "<IMG SRC='__subwp.gif' WIDTH=7 HEIGHT=19 ALT=' w' TITLE='w'>";
  althtmldef "+w" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>+<SUB>w</SUB> </I></SPAN>';
  latexdef "+w" as "+_w";
htmldef "-w" as "<IMG SRC='_minus.gif' WIDTH=11 HEIGHT=19 ALT=' -' TITLE='-'>"
    + "<IMG SRC='__subwp.gif' WIDTH=7 HEIGHT=19 ALT=' w' TITLE='w'>";
  althtmldef "-w" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>-<SUB>w</SUB> </I></SPAN>';
  latexdef "-w" as "-_w";
htmldef ".w" as "<IMG SRC='_cdot.gif' WIDTH=4 HEIGHT=19 ALT=' .' TITLE='.'>" +
    "<IMG SRC='__subwp.gif' WIDTH=7 HEIGHT=19 ALT=' w' TITLE='w'>";
  althtmldef ".w" as
   '<SPAN CLASS=class STYLE="color:#C3C"><I>.<SUB>w</SUB> </I></SPAN>';
  latexdef ".w" as "._w";
htmldef "0w" as "<IMG SRC='_0.gif' WIDTH=8 HEIGHT=19 ALT=' 0' TITLE='0'>" +
    "<IMG SRC='__subwp.gif' WIDTH=7 HEIGHT=19 ALT=' w' TITLE='w'>";
  althtmldef "0w" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>0<SUB>w</SUB> </I></SPAN>';
  latexdef "0w" as "0_w";
htmldef "~w" as "<IMG SRC='_sim.gif' WIDTH=13 HEIGHT=19 ALT=' ~' TITLE='~'>" +
    "<IMG SRC='__subwp.gif' WIDTH=7 HEIGHT=19 ALT=' w' TITLE='w'>";
  althtmldef "~w" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>~<SUB>w</SUB> </I></SPAN>';
  latexdef "~w" as "~_w";
htmldef "<_a" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>&le<SUB>a</SUB> </I></SPAN>';
  althtmldef "<_a" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>&le;<SUB>a</SUB> </I></SPAN>';
  latexdef "<_a" as "\le";
htmldef "<_b" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>&le<SUB>b</SUB> </I></SPAN>';
  althtmldef "<_b" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>&le;<SUB>b</SUB> </I></SPAN>';
  latexdef "<_b" as "\le";

htmldef "o'" as "<IMG SRC='_bnj_oPrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " o'_" + '"' + " TITLE=" + '"' + "o'_" + '"' + ">";
  althtmldef "o'" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;&prime;</SPAN>';
  latexdef "o'"  as "o'";
htmldef "s'" as "<IMG SRC='_bnj_sPrime.gif' WIDTH=11 HEIGHT=19" +
    " ALT=" + '"' + " s'" + '"' + " TITLE=" + '"' + "s'" + '"' + ">";
  althtmldef "s'" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D460;&prime;</SPAN>';
  latexdef "s'" as "s'";
htmldef "v'" as "<IMG SRC='_bnj_vPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " v'" + '"' + " TITLE=" + '"' + "v'" + '"' + ">";
  althtmldef "v'" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D463;&prime;</SPAN>';
  latexdef "v'" as "v'";
htmldef 'o"' as "<IMG SRC='_bnj_oPrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' o" + '"' + "'TITLE='o" + '"' + "'>";
  althtmldef 'o"' as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;&Prime;</SPAN>';
  latexdef 'o"' as "o''";
htmldef 's"' as "<IMG SRC='_bnj_sPrimePrime.gif' WIDTH=14 HEIGHT=19 " +
    " ALT=' s" + '"' + "'TITLE='s" + '"' + "'>";
  althtmldef 's"' as
    '<SPAN CLASS=set STYLE="color:red">&#x1D460;&Prime;</SPAN>';
  latexdef 's"' as "s''";
htmldef 'v"' as "<IMG SRC='_bnj_vPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' v" + '"' + "'TITLE='v" + '"' + "'>";
  althtmldef 'v"' as
    '<SPAN CLASS=set STYLE="color:red">&#x1D463;&Prime;</SPAN>';
  latexdef 'v"' as "v''";
htmldef "a0" as
    "<IMG SRC='_bnj_a0.gif' WIDTH=16 HEIGHT=19 ALT=' a0' TITLE='a0'>";
  althtmldef "a0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44E;<SUB>0</SUB></SPAN>';
  latexdef "a0"  as "a_0";
htmldef "b0" as
    "<IMG SRC='_bnj_b0.gif' WIDTH=15 HEIGHT=19 ALT=' b0' TITLE='b0'>";
  althtmldef "b0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44F;<SUB>0</SUB></SPAN>';
  latexdef "b0"  as "b_0";
htmldef "o0" as
    "<IMG SRC='_bnj_o0.gif' WIDTH=15 HEIGHT=19 ALT=' o0' TITLE='o0'>";
  althtmldef "o0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;<SUB>0</SUB></SPAN>';
  latexdef "o0"  as "o_0";
htmldef "a1" as
    "<IMG SRC='_bnj_a1.gif' WIDTH=14 HEIGHT=19 ALT=' a1' TITLE='a1'>";
  althtmldef "a1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44E;<SUB>1</SUB></SPAN>';
  latexdef "a1"  as "a_1";
htmldef "b1" as
    "<IMG SRC='_bnj_b1.gif' WIDTH=13 HEIGHT=19 ALT=' b1' TITLE='b1'>";
  althtmldef "b1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44F;<SUB>1</SUB></SPAN>';
  latexdef "b1"  as "b_1";
htmldef "o1" as
    "<IMG SRC='_bnj_o1.gif' WIDTH=13 HEIGHT=19 ALT=' o1' TITLE='o1'>";
  althtmldef "o1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;<SUB>1</SUB></SPAN>';
  latexdef "o1"  as "o_1";
htmldef "v2"  as "<IMG SRC='_v.gif' WIDTH=9 HEIGHT=19 ALT=' v' TITLE='v'>" +
    "<IMG SRC='__sub2r.gif' WIDTH=6 HEIGHT=19 ALT=' 2' TITLE='2'>";
  althtmldef "v2"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D463;<SUB>2</SUB></SPAN>';
  latexdef "v2"  as "v_2";

htmldef "[.]" as
    "<IMG SRC='wbox.gif' WIDTH=11 HEIGHT=19 ALT=' [.]' TITLE='[.]'>";
  althtmldef "[.]" as "&#9723;";
  latexdef "[.]" as "\Box";
htmldef "<>" as
    "<IMG SRC='wdiamond.gif' WIDTH=13 HEIGHT=19 " +
    "ALT=' &lt;&gt;' TITLE='&lt;&gt;'>";
  althtmldef "<>" as "&#9671;";
  latexdef "<>" as "\Diamond";
htmldef "()" as
    "<IMG SRC='circ.gif' WIDTH=8 HEIGHT=19 ALT=' ()' TITLE='()'>";
  althtmldef "()" as "&#9675;";
  latexdef "()" as "\bigcirc";
htmldef "until" as
    " <IMG SRC='_until.gif' WIDTH=30 HEIGHT=19 ALT=' until' TITLE='until'> ";
  althtmldef "until" as " until ";
  latexdef "until" as "{\rm until}";
htmldef "pr" as
    " <IMG SRC='_pr.gif' WIDTH=14 HEIGHT=19 ALT=' pr' TITLE='pr'> ";
  althtmldef "pr" as " pr ";
  latexdef "pr" as "{\rm pr}";
htmldef "prj" as
    " <IMG SRC='_prj.gif' WIDTH=17 HEIGHT=19 ALT=' prj' TITLE='prj'> ";
  althtmldef "prj" as " prj ";
  latexdef "prj" as "{\rm prj}";
htmldef "cset" as
    "<IMG SRC='_cset.gif' WIDTH=26 HEIGHT=19 ALT=' cset' TITLE='cset'>";
  althtmldef "cset" as "cset";
  latexdef "cset" as "{\rm cset}";
htmldef "LatAlg" as
    "<IMG SRC='_latalg.gif' WIDTH=45 HEIGHT=19 ALT=' LatAlg' TITLE='LatAlg'>";
  althtmldef "LatAlg" as "LatAlg";
  latexdef "LatAlg" as "{\rm LatAlg}";
htmldef "cur1" as
    "<IMG SRC='_cur1.gif' WIDTH=25 HEIGHT=19 ALT=' cur1' TITLE='cur1'>";
  althtmldef "cur1" as "cur1";
  latexdef "cur1" as "{\rm cur1}";
htmldef "cur2" as
    "<IMG SRC='_cur2.gif' WIDTH=27 HEIGHT=19 ALT=' cur2' TITLE='cur2'>";
  althtmldef "cur2" as "cur2";
  latexdef "cur2" as "{\rm cur2}";
htmldef "OrHom" as
    " <IMG SRC='_orhom.gif' WIDTH=46 HEIGHT=19 ALT=' OrHom' TITLE='OrHom'> ";
  althtmldef "OrHom" as " OrHom ";
  latexdef "OrHom" as "{\rm OrHom}";
htmldef "OrIso" as
    " <IMG SRC='_oriso.gif' WIDTH=34 HEIGHT=19 ALT=' OrIso' TITLE='OrIso'> ";
  althtmldef "OrIso" as " OrIso ";
  latexdef "OrIso" as "{\rm OrIso}";
htmldef "mxl" as
    "<IMG SRC='_mxl.gif' WIDTH=24 HEIGHT=19 ALT=' mxl' TITLE='mxl'>";
  althtmldef "mxl" as "mxl";
  latexdef "mxl" as "{\rm mxl}";
htmldef "mnl" as
    "<IMG SRC='_mnl.gif' WIDTH=24 HEIGHT=19 ALT=' mnl' TITLE='mnl'>";
  althtmldef "mnl" as "mnl";
  latexdef "mnl" as "{\rm mnl}";
htmldef "ub" as
    " <IMG SRC='_ub.gif' WIDTH=16 HEIGHT=19 ALT=' ub' TITLE='ub'> ";
  althtmldef "ub" as " ub ";
  latexdef "ub" as "{\rm ub}";
htmldef "lb" as "<IMG SRC='_lb.gif' WIDTH=12 HEIGHT=19 ALT=' lb' TITLE='lb'>";
  althtmldef "lb" as "lb";
  latexdef "lb" as "{\rm lb}";
htmldef "PresetRel" as "PresetRel";
  althtmldef "PresetRel" as "PresetRel";
  latexdef "PresetRel" as "{\rm PresetRel}";
htmldef "ge" as "<IMG SRC='_ge.gif' WIDTH=14 HEIGHT=19 ALT=' ge' TITLE='ge'>";
  althtmldef "ge" as "ge";
  latexdef "ge" as "{\rm ge}";
htmldef "leR" as "leR";
  althtmldef "leR" as "leR";
  latexdef "leR" as "{\rm leR}";
htmldef "AntiDir" as
    "<IMG SRC='_antidir.gif' WIDTH=48 HEIGHT=19 " +
    "ALT=' AntiDir' TITLE='AntiDir'>";
  althtmldef "AntiDir" as "AntiDir";
  latexdef "AntiDir" as "{\rm AntiDir}";
htmldef "BndLat" as
    "<IMG SRC='_bndlat.gif' WIDTH=48 HEIGHT=19 ALT=' BndLat' TITLE='BndLat'>";
  althtmldef "BndLat" as "BndLat";
  latexdef "BndLat" as "{\rm BndLat}";
htmldef "gprod_" as "<IMG SRC='prod.gif' WIDTH=12 HEIGHT=19 " +
    "ALT=' gprod_' TITLE='gprod_'>";
  althtmldef "gprod_" as "gprod_";
  latexdef "gprod_" as "\Pi";
htmldef "prod2_" as "<U>prod2</U>";
  althtmldef "prod2_" as "<U>prod2</U>";
  latexdef "prod2_" as "\underline{\rm prod2}";
htmldef "prod3_" as "<U>prod3</U>";
  althtmldef "prod3_" as "<U>prod3</U>";
  latexdef "prod3_" as "\underline{\rm prod3}";
htmldef "Com1" as
    "<IMG SRC='_com1.gif' WIDTH=33 HEIGHT=19 ALT=' Com1' TITLE='Com1'>";
  althtmldef "Com1" as "Com1";
  latexdef "Com1" as "{\rm Com1}";
htmldef "^md" as
    "<IMG SRC='uparrow.gif' WIDTH=7 HEIGHT=19 ALT=' ^' TITLE='^'>" +
    "<IMG SRC='_submd.gif' WIDTH=17 HEIGHT=19 ALT=' md' TITLE='md'>";
  althtmldef "^md" as "^<SUB><I>md</I></SUB>";
  latexdef "^md" as "\uparrow_{md}";
htmldef "SubSemiGrp" as "<IMG SRC='_subsemigrp.gif' WIDTH=80 HEIGHT=19 " +
    "ALT=' SubSemiGrp' TITLE='SubSemiGrp'>";
  althtmldef "SubSemiGrp" as "SubSemiGrp";
  latexdef "SubSemiGrp" as "{\rm SubSemiGrp}";
htmldef "subSemiGrpGen" as " <IMG SRC='_subsemigrpgen.gif' " +
    "WIDTH=104 HEIGHT=19 ALT=' subSemiGrpGen' TITLE='subSemiGrpGen'> ";
  althtmldef "subSemiGrpGen" as "subSemiGrpGen";
  latexdef "subSemiGrpGen" as "{\rm subSemiGrpGen}";
htmldef "SemiGrpHom" as "<IMG SRC='_semigrphom.gif' WIDTH=85 HEIGHT=19 " +
    "ALT=' SemiGrpHom' TITLE='SemiGrpHom'>";
  althtmldef "SemiGrpHom" as "SemiGrpHom";
  latexdef "SemiGrpHom" as "{\rm SemiGrpHom}";
htmldef "FreeSemiGrp" as "<IMG SRC='_freesemigrp.gif' WIDTH=85 HEIGHT=19 " +
    "ALT=' FreeSemiGrp' TITLE='FreeSemiGrp'>";
  althtmldef "FreeSemiGrp" as "FreeSemiGrp";
  latexdef "FreeSemiGrp" as "{\rm FreeSemiGrp}";
htmldef "Tofld" as
    " <IMG SRC='_tofld.gif' WIDTH=33 HEIGHT=19 ALT=' Tofld' TITLE='Tofld'> ";
  althtmldef "Tofld" as " Tofld ";
  latexdef "Tofld" as "{\rm Tofld}";
htmldef "zeroDiv" as
    " <IMG SRC='_zerodiv.gif' WIDTH=48 HEIGHT=19 " +
    "ALT=' zeroDiv' TITLE='zeroDiv'> ";
  althtmldef "zeroDiv" as " zeroDiv ";
  latexdef "zeroDiv" as "{\rm zeroDiv}";
htmldef "IdlNEW" as "IdlNEW";
  althtmldef "IdlNEW" as "IdlNEW";
  latexdef "IdlNEW" as "{\rm IdlNEW}";
htmldef "Action" as
    "<IMG SRC='_action.gif' WIDTH=41 HEIGHT=19 ALT=' Action' TITLE='Action'>";
  althtmldef "Action" as "Action";
  latexdef "Action" as "{\rm Action}";
/@
htmldef "GrpWOp" as
    "<IMG SRC='_grpwop.gif' WIDTH=59 HEIGHT=19 ALT=' GrpWOp' TITLE='GrpWOp'>";
  althtmldef "GrpWOp" as "GrpWOp";
  latexdef "GrpWOp" as "{\rm GrpWOp}";
@/
htmldef "Vec" as
    " <IMG SRC='_vec.gif' WIDTH=22 HEIGHT=19 ALT=' Vec' TITLE='Vec'> ";
  althtmldef "Vec" as " Vec ";
  latexdef "Vec" as "{\rm Vec}";
htmldef "SubVec" as
    "<IMG SRC='_subvec.gif' WIDTH=44 HEIGHT=19 ALT=' SubVec' TITLE='SubVec'>";
  althtmldef "SubVec" as "SubVec";
  latexdef "SubVec" as "{\rm SubVec}";
htmldef "RVec" as
    " <IMG SRC='_rvec.gif' WIDTH=34 HEIGHT=19 ALT=' RVec' TITLE='RVec'> ";
  althtmldef "RVec" as " RVec ";
  latexdef "RVec" as "{\rm RVec}";
htmldef "+m" as "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>" +
    "<IMG SRC='subm.gif' WIDTH=10 HEIGHT=19 ALT=' m' TITLE='m'>";
  althtmldef "+m" as "+<SUB>&#x1D45A;</SUB>";
  latexdef "+m" as "+_{m}";
htmldef "xm" as "<IMG SRC='times.gif' WIDTH=9 HEIGHT=19 ALT=' x' TITLE='x'>" +
    "<IMG SRC='subm.gif' WIDTH=10 HEIGHT=19 ALT=' m' TITLE='m'>";
  althtmldef "xm" as " &times;<SUB>&#x1D45A;</SUB> ";
  latexdef "xm" as "\times_{m}";
htmldef ".m" as "<IMG SRC='cdot.gif' WIDTH=4 HEIGHT=19 ALT=' x' TITLE='x'>" +
    "<IMG SRC='subm.gif' WIDTH=10 HEIGHT=19 ALT=' m' TITLE='m'>";
  althtmldef ".m" as " &middot;<SUB>&#x1D45A;</SUB> ";
  latexdef ".m" as "\cdot_{m}";
htmldef "RAffSp" as
   " <IMG SRC='_raffsp.gif' WIDTH=48 HEIGHT=19 ALT=' RAffSp' TITLE='RAffSp'> ";
  althtmldef "RAffSp" as " RAffSp ";
  latexdef "RAffSp" as "{\rm RAffSp}";
/@
htmldef "dst" as "dst";
  althtmldef "dst" as "dst";
  latexdef "dst" as "{\rm dst}";
htmldef "absv" as "absv";
  althtmldef "absv" as "absv";
  latexdef "absv" as "{\rm absv}";
htmldef "nrm" as "nrm";
  althtmldef "nrm" as "nrm";
  latexdef "nrm" as "{\rm nrm}";
@/
htmldef "topX" as
    " <IMG SRC='_topx.gif' WIDTH=31 HEIGHT=19 ALT=' topX' TITLE='topX'> ";
  althtmldef "topX" as " topX ";
  latexdef "topX" as "{\rm topX}";
htmldef "fLimfrs" as " <IMG SRC='_flimfrs.gif' WIDTH=49 HEIGHT=19 " +
    "ALT=' fLimfrs' TITLE='fLimfrs'> ";
  althtmldef "fLimfrs" as " fLimfrs ";
  latexdef "fLimfrs" as "fLimfrs";
htmldef "IsolatedPt" as "<IMG SRC='_isolatedpt.gif' WIDTH=65 HEIGHT=19 " +
    "ALT=' IsolatedPt' TITLE='IsolatedPt'>";
  althtmldef "IsolatedPt" as "IsolatedPt";
  latexdef "IsolatedPt" as "IsolatedPt";
htmldef "UnifSpOLD" as
    "<IMG SRC='_unifsp.gif' WIDTH=44 HEIGHT=19 ALT=' UnifSp' TITLE='UnifSp'>";
  althtmldef "UnifSpOLD" as "UnifSp";
  latexdef "UnifSpOLD" as "{\rm UnifSp}";
htmldef "opfn" as
    " <IMG SRC='_opfn.gif' WIDTH=29 HEIGHT=19 ALT=' opfn' TITLE='opfn'> ";
  althtmldef "opfn" as " opfn ";
  latexdef "opfn" as "{\rm opfn}";
htmldef "TopFld" as
    "<IMG SRC='_topfld.gif' WIDTH=44 HEIGHT=19 ALT=' TopFld' TITLE='TopFld'>";
  althtmldef "TopFld" as " TopFld ";
  latexdef "TopFld" as "{\rm TopFld}";
htmldef "sup_" as
    " <IMG SRC='_sup.gif' WIDTH=22 HEIGHT=19 ALT=' sup' TITLE='sup'>" +
    "<IMG SRC='subminus.gif' WIDTH=9 HEIGHT=19 ALT=' _' TITLE='_'> ";
  althtmldef "sup_" as " sup_ ";
  latexdef "sup_" as "{\rm sup}_{-}";
htmldef "inf_" as
    " <IMG SRC='_inf.gif' WIDTH=18 HEIGHT=19 ALT=' inf' TITLE='inf'>" +
    "<IMG SRC='subminus.gif' WIDTH=9 HEIGHT=19 ALT=' _' TITLE='_'> ";
  althtmldef "inf_" as " inf_ ";
  latexdef "inf_" as "{\rm inf}_{-}";
htmldef "Frf" as
    "<IMG SRC='_frf.gif' WIDTH=21 HEIGHT=19 ALT=' Frf' TITLE='Frf'>";
  althtmldef "Frf" as "Frf";
  latexdef "Frf" as "{\rm Frf}";
htmldef "+cv" as " <IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' " +
    "TITLE='+'><IMG SRC='_subcv.gif' WIDTH=12 HEIGHT=19 ALT=' cv' " +
    "TITLE='cv'>";
  althtmldef "+cv" as "+cv";
  latexdef "+cv" as "+_{cv}";
htmldef "0cv" as "<IMG SRC='0.gif' WIDTH=8 HEIGHT=19 ALT=' 0' TITLE='0'>" +
    "<IMG SRC='_subcv.gif' WIDTH=12 HEIGHT=19 ALT=' cv' TITLE='cv'>";
  althtmldef "0cv" as "0cv";
  latexdef "0cv" as "0_{cv}";
htmldef "-cv" as " <IMG SRC='minus.gif' WIDTH=11 HEIGHT=19 ALT=' -' " +
   "TITLE='-'><IMG SRC='_subcv.gif' WIDTH=12 HEIGHT=19 ALT=' cv' TITLE='cv'> ";
  althtmldef "-cv" as " -<SUB><I>cv</I></SUB> ";
  latexdef "-cv" as "-_{cv}";
htmldef "-ucv" as
    "<IMG SRC='shortminus.gif' WIDTH=8 HEIGHT=19 ALT=' -' TITLE='-'>" +
    "<IMG SRC='_subcv.gif' WIDTH=12 HEIGHT=19 ALT=' cv' TITLE='cv'>";
  althtmldef "-ucv" as "-<SUB><I>cv</I></SUB>";
  latexdef "-ucv" as "-u_{cv}";
htmldef ".cv" as "<IMG SRC='cdot.gif' WIDTH=4 HEIGHT=19 ALT=' .' TITLE='.'>" +
    "<IMG SRC='_subcv.gif' WIDTH=12 HEIGHT=19 ALT=' cv' TITLE='cv'>";
  althtmldef ".cv" as "&middot;<SUB><I>cv</I></SUB>";
  latexdef ".cv" as "\cdot_{cv}";
htmldef "/cv" as "<IMG SRC='solidus.gif' WIDTH=6 HEIGHT=19 ALT=' /' " +
    "TITLE='/'><IMG SRC='_subcv.gif' WIDTH=12 HEIGHT=19 ALT=' cv' TITLE='cv'>";
  althtmldef "/cv" as "/<SUB><I>cv</I></SUB>";
  latexdef "/cv" as "/_{cv}";
htmldef "Intvl" as
    "<IMG SRC='_intvl.gif' WIDTH=29 HEIGHT=19 ALT=' Intvl' TITLE='Intvl'>";
  althtmldef "Intvl" as "Intvl";
  latexdef "Intvl" as "{\rm Intvl}";
htmldef "der" as
    "<IMG SRC='_der.gif' WIDTH=21 HEIGHT=19 ALT=' der' TITLE='der'>";
  althtmldef "der" as "der";
  latexdef "der" as "{\rm der}";
htmldef "Dgra" as
    "<IMG SRC='_dgra.gif' WIDTH=33 HEIGHT=19 ALT=' Dgra' TITLE='Dgra'>";
  althtmldef "Dgra" as " Dgra ";
  latexdef "Dgra" as "{\rm Dgra}";
htmldef "Alg" as
    " <IMG SRC='_alg.gif' WIDTH=22 HEIGHT=19 ALT=' Alg' TITLE='Alg'> ";
  althtmldef "Alg" as " Alg ";
  latexdef "Alg" as "{\rm Alg}";
htmldef "dom_" as
    "<IMG SRC='_domu.gif' WIDTH=26 HEIGHT=19 ALT=' dom_' TITLE='dom_'>";
  althtmldef "dom_" as "<U>dom</U>";
  latexdef "dom_" as "\underline{\rm dom}";
htmldef "cod_" as
    "<IMG SRC='_codu.gif' WIDTH=22 HEIGHT=19 ALT=' cod_' TITLE='cod_'>";
  althtmldef "cod_" as "<U>cod</U>";
  latexdef "cod_" as "\underline{\rm cod}";
htmldef "id_" as
    "<IMG SRC='_idu.gif' WIDTH=12 HEIGHT=19 ALT=' id_' TITLE='id_'>";
  althtmldef "id_" as "<U>id</U>";
  latexdef "id_" as "\underline{\rm id}";
htmldef "o_" as "<IMG SRC='_ou.gif' WIDTH=7 HEIGHT=19 ALT=' o_' TITLE='o_'>";
  althtmldef "o_" as "<U>o</U>";
  latexdef "o_" as "\underline{\rm o}";
htmldef "Ded" as
    "<IMG SRC='_ded.gif' WIDTH=25 HEIGHT=19 ALT=' Ded' TITLE='Ded'>";
  althtmldef "Ded" as " Ded ";
  latexdef "Ded" as "{\rm Ded}";
htmldef "CatOLD" as
    " <IMG SRC='_cat.gif' WIDTH=24 HEIGHT=19 ALT=' Cat' TITLE='Cat'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'> ";
  althtmldef "CatOLD" as " Cat<SUB>OLD</SUB> ";
  latexdef "CatOLD" as "{\rm Cat_{OLD}}";
htmldef "hom" as
    "<IMG SRC='_hom.gif' WIDTH=27 HEIGHT=19 ALT=' hom' TITLE='hom'>";
  althtmldef "hom" as " hom ";
  latexdef "hom" as "{\rm hom}";
htmldef "Epic" as "Epic";
  althtmldef "Epic" as "Epic";
  latexdef "Epic" as "{\rm Epic}";
htmldef "MonoOLD" as " Mono<SUB>OLD</SUB> ";
  althtmldef "MonoOLD" as " Mono<SUB>OLD</SUB> ";
  latexdef "MonoOLD" as "{\rm Mono_{OLD}}";
htmldef "IsoOLD" as
    " <IMG SRC='_iso.gif' WIDTH=17 HEIGHT=19 ALT=' Iso' TITLE='Iso'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'> ";
  althtmldef "IsoOLD" as " Iso<SUB>OLD</SUB> ";
  latexdef "IsoOLD" as "{\rm Iso_{OLD}}";
htmldef "cinvOLD" as
    "<IMG SRC='_cinv.gif' WIDTH=27 HEIGHT=19 ALT=' cinv' TITLE='cinv'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "cinvOLD" as " cinv<SUB>OLD</SUB> ";
  latexdef "cinvOLD" as "{\rm cinv_{OLD}}";
/@ Duplicate removed by NM 17-Jul-2012 @/
/@ htmldef "id_" as "<U>id</U>";
  althtmldef "id_" as "<U>id</U>";
  latexdef "id_" as "\underline{\rm id}"; @/
htmldef "FuncOLD" as
    "<IMG SRC='_func.gif' WIDTH=32 HEIGHT=19 ALT=' Func' TITLE='Func'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "FuncOLD" as " Func<SUB>OLD</SUB> ";
  latexdef "FuncOLD" as "{\rm Func_{OLD}}";
htmldef "Isofunc" as
    " <IMG SRC='_isofunc.gif' WIDTH=45 HEIGHT=19 " +
    "ALT=' Isofunc' TITLE='Isofunc'> ";
  althtmldef "Isofunc" as " Isofunc ";
  latexdef "Isofunc" as "{\rm Isofunc}";
htmldef "SubCat" as
   " <IMG SRC='_subcat.gif' WIDTH=48 HEIGHT=19 ALT=' SubCat' TITLE='SubCat'> ";
  althtmldef "SubCat" as " SubCat ";
  latexdef "SubCat" as "{\rm SubCat}";
htmldef "InitObj" as
    " <IMG SRC='_initobj.gif' WIDTH=46 HEIGHT=19 " +
    "ALT=' InitObj' TITLE='InitObj'> ";
  althtmldef "InitObj" as " InitObj ";
  latexdef "InitObj" as "{\rm InitObj}";
htmldef "TermObj" as
    " <IMG SRC='_termobj.gif' WIDTH=56 HEIGHT=19 " +
    "ALT=' TermObj' TITLE='TermObj'> ";
  althtmldef "TermObj" as " TermObj ";
  latexdef "TermObj" as "{\rm TermObj}";
htmldef "Source" as
   " <IMG SRC='_source.gif' WIDTH=43 HEIGHT=19 ALT=' Source' TITLE='Source'> ";
  althtmldef "Source" as " Source ";
  latexdef "Source" as "{\rm Source}";
htmldef "Sink" as
    " <IMG SRC='_sink.gif' WIDTH=28 HEIGHT=19 ALT=' Sink' TITLE='Sink'> ";
  althtmldef "Sink" as " Sink ";
  latexdef "Sink" as "{\rm Sink}";
htmldef "Natural" as
    " <IMG SRC='_natural.gif' WIDTH=50 HEIGHT=19 " +
    "ALT=' Natural' TITLE='Natural'> ";
  althtmldef "Natural" as " Natural ";
  latexdef "Natural" as "{\rm Natural}";
htmldef "LimCat" as
   " <IMG SRC='_limcat.gif' WIDTH=49 HEIGHT=19 ALT=' LimCat' TITLE='LimCat'> ";
  althtmldef "LimCat" as " LimCat ";
  latexdef "LimCat" as "{\rm LimCat}";

htmldef "ProdObj" as " <IMG SRC='cdot.gif' " +
    "WIDTH=4 HEIGHT=19 ALT=' Prod' TITLE='Prod'>" +
    "<IMG SRC='_subobj.gif' WIDTH=18 HEIGHT=19 ALT=' Obj' TITLE='Obj'> ";
  althtmldef "ProdObj" as " ProdObj ";
  latexdef "ProdObj" as "\cdot_{\it obj}";
htmldef "SumObj" as " <IMG SRC='plus.gif' " +
    "WIDTH=13 HEIGHT=19 ALT=' Sum' TITLE='Sum'>" +
    "<IMG SRC='_subobj.gif' WIDTH=18 HEIGHT=19 ALT=' Obj' TITLE='Obj'> ";
  althtmldef "SumObj" as " +<SUB><I>Obj</I></SUB> ";
  latexdef "SumObj" as "+_{\it obj}";

htmldef "tar" as
    "<IMG SRC='_tar.gif' WIDTH=20 HEIGHT=19 ALT=' tar' TITLE='tar'>";
  althtmldef "tar" as "tar";
  latexdef "tar" as "{\rm tar}";
htmldef "tr" as "<IMG SRC='_tr.gif' WIDTH=12 HEIGHT=19 ALT=' tr' TITLE='tr'>";
  althtmldef "tr" as "tr";
  latexdef "tr" as "{\rm tr}";
htmldef ".Morphism" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.Morphism </I></SPAN>';
  althtmldef ".Morphism" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.Morphism </I></SPAN>';
  latexdef ".Morphism" as ".Morphism";
htmldef ".Object" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.Object </I></SPAN>';
  althtmldef ".Object" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.Object </I></SPAN>';
  latexdef ".Object" as ".Object";
htmldef ".graph" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.graph </I></SPAN>';
  althtmldef ".graph" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.graph </I></SPAN>';
  latexdef ".graph" as ".graph";
htmldef ".dom" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.dom </I></SPAN>';
  althtmldef ".dom" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.dom </I></SPAN>';
  latexdef ".dom" as ".dom";
htmldef ".cod" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.cod </I></SPAN>';
  althtmldef ".cod" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.cod </I></SPAN>';
  latexdef ".cod" as ".cod";
htmldef ".id" as '<SPAN CLASS=class STYLE="color:#C3C"><I>.id </I></SPAN>';
  althtmldef ".id" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>.id </I></SPAN>';
  latexdef ".id" as ".id";

htmldef "MorphismSetCat" as
    "<IMG SRC='_morphism.gif' WIDTH=63 HEIGHT=19 " +
    "ALT=' Morphism' TITLE='Morphism'>" +
    "<IMG SRC='_subsetcat.gif' WIDTH=34 HEIGHT=19 " +
    "ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "MorphismSetCat" as "Morphism<SUB>SetCat</SUB>";
  latexdef "MorphismSetCat" as "Morphism_{\rm SetCat}";
htmldef "domSetCat" as
    "<IMG SRC='_dom.gif' WIDTH=26 HEIGHT=19 ALT=' dom' TITLE='dom'>" +
    "<IMG SRC='_subsetcat.gif' WIDTH=34 HEIGHT=19 " +
    "ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "domSetCat" as "dom<SUB>SetCat</SUB>";
  latexdef "domSetCat" as "dom_{\rm SetCat}";
htmldef "graphSetCat" as
  "<IMG SRC='_graph.gif' WIDTH=38 HEIGHT=19 ALT=' graph' TITLE='graph'>" +
  "<IMG SRC='_subsetcat.gif' WIDTH=34 HEIGHT=19 ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "graphSetCat" as "graph<SUB>SetCat</SUB>";
  latexdef "graphSetCat" as "graph_{\rm SetCat}";
htmldef "codSetCat" as "<IMG SRC='_cod.gif' WIDTH=22 HEIGHT=19 " +
    "ALT=' cod' TITLE='cod'><IMG SRC='_subsetcat.gif' WIDTH=34 HEIGHT=19 " +
    "ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "codSetCat" as "cod<SUB>SetCat</SUB>";
  latexdef "codSetCat" as "cod_{\rm SetCat}";
htmldef "IdSetCat" as
    "<IMG SRC='_id.gif' WIDTH=12 HEIGHT=19 ALT=' Id' TITLE='Id'>" +
    "<IMG SRC='_subsetcat.gif' WIDTH=34 HEIGHT=19 " +
    "ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "IdSetCat" as "Id<SUB>SetCat</SUB>";
  latexdef "IdSetCat" as "Id_{\rm SetCat}";
htmldef "roSetCat" as
    "<IMG SRC='_ro.gif' WIDTH=13 HEIGHT=19 ALT=' ro' TITLE='ro'>" +
    "<IMG SRC='_subsetcat.gif' WIDTH=34 HEIGHT=19 " +
    "ALT=' SetCat' TITLE='SetCat'>";
  althtmldef "roSetCat" as "ro<SUB>SetCat</SUB>";
  latexdef "roSetCat" as "ro_{\rm SetCat}";
htmldef "SetCatOLD" as
    "<IMG SRC='_setcat.gif' WIDTH=45 HEIGHT=19 ALT=' SetCat' TITLE='SetCat'>" +
    "<IMG SRC='_old.gif' WIDTH=23 HEIGHT=19 ALT=' OLD' TITLE='OLD'>";
  althtmldef "SetCatOLD" as "SetCat<SUB>OLD</SUB>";
  latexdef "SetCatOLD" as "{\rm SetCat_{OLD}}";
htmldef "line" as
    "<IMG SRC='_line.gif' WIDTH=23 HEIGHT=19 ALT=' line' TITLE='line'>";
  althtmldef "line" as "line";
  latexdef "line" as "{\rm line}";
htmldef "seg" as
    "<IMG SRC='_seg.gif' WIDTH=21 HEIGHT=19 ALT=' seg' TITLE='seg'>";
  althtmldef "seg" as "seg";
  latexdef "seg" as "{\rm seg}";
htmldef "Kleene" as
    "<IMG SRC='_kleene.gif' WIDTH=43 HEIGHT=19 ALT=' Kleene' TITLE='Kleene'>";
  althtmldef "Kleene" as "Kleene";
  latexdef "Kleene" as "{\rm Kleene}";
htmldef "Words" as
    " <IMG SRC='_words.gif' WIDTH=40 HEIGHT=19 ALT=' Words' TITLE='Words'> ";
  althtmldef "Words" as " Words ";
  latexdef "Words" as "{\rm Words}";
htmldef "IndCls" as
   " <IMG SRC='_indcls.gif' WIDTH=40 HEIGHT=19 ALT=' IndCls' TITLE='IndCls'> ";
  althtmldef "IndCls" as " IndCls ";
  latexdef "IndCls" as "{\rm IndCls}";
/@
htmldef "IndClsBu" as
    "<IMG SRC='_indclsbu.gif' WIDTH=57 HEIGHT=19 " +
    "ALT=' IndClsBu' TITLE='IndClsBu'>";
  althtmldef "IndClsBu" as "IndClsBu";
  latexdef "IndClsBu" as "{\rm IndClsBu}";
@/
htmldef "Grammar" as
    "<IMG SRC='_grammar.gif' WIDTH=63 HEIGHT=19 " +
    "ALT=' Grammar' TITLE='Grammar'>";
  althtmldef "Grammar" as "Grammar";
  latexdef "Grammar" as "{\rm Grammar}";
htmldef "sym" as
    "<IMG SRC='_sym.gif' WIDTH=26 HEIGHT=19 ALT=' sym' TITLE='sym'>";
  althtmldef "sym" as "sym";
  latexdef "sym" as "{\rm sym}";
htmldef "prdct" as
    "<IMG SRC='_prdct.gif' WIDTH=35 HEIGHT=19 ALT=' prdct' TITLE='prdct'>";
  althtmldef "prdct" as "prdct";
  latexdef "prdct" as "{\rm prdct}";
htmldef "conc" as
    " <IMG SRC='_conc.gif' WIDTH=29 HEIGHT=19 ALT=' conc' TITLE='conc'> ";
  althtmldef "conc" as " conc ";
  latexdef "conc" as "{\rm conc}";
htmldef "-.c" as
    " <IMG SRC='lnot.gif' WIDTH=10 HEIGHT=19 ALT=' -.' TITLE='-.'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "-.c" as "&not;<SUB>&#x1D450;</SUB>";
  latexdef "-.c" as "-._{c}";
htmldef "/\c" as
    " <IMG SRC='wedge.gif' WIDTH=11 HEIGHT=19 ALT=' /\' TITLE='/\'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "/\c" as " /\<SUB>&#x1D450;</SUB> ";
  latexdef "/\c" as "\wedge_{c}";
htmldef "\/c" as
    " <IMG SRC='vee.gif' WIDTH=11 HEIGHT=19 ALT=' \/' TITLE='\/'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "\/c" as " \/<SUB>&#x1D450;</SUB> ";
  latexdef "\/c" as "\vee_{c}";
htmldef "=>c" as
    " <IMG SRC='to.gif' WIDTH=15 HEIGHT=19 ALT=' =&gt;' TITLE='=&gt;'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "=>c" as " &rarr;<SUB>&#x1D450;</SUB> ";
  latexdef "=>c" as "\rightarrow_{c}";
htmldef "<=>c" as
    " <IMG SRC='leftrightarrow.gif' WIDTH=15 HEIGHT=19 ALT=' &lt;=&gt;' " +
    "TITLE='&lt;=&gt;'><IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 " +
    "ALT=' c' TITLE='c'>";
  althtmldef "<=>c" as " &harr;<SUB>&#x1D450;</SUB> ";
  latexdef "<=>c" as "\leftrightarrow_{c}";
htmldef "_|_c" as
    "<IMG SRC='perp.gif' WIDTH=11 HEIGHT=19 ALT=' _|_' TITLE='_|_'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "_|_c" as
    "&#8869;<SUB>&#x1D450;</SUB>";
    /@ 2-Jan-2016 reverted sans-serif @/
  latexdef "_|_c" as "\perp_c";
htmldef "phc" as
    "<IMG SRC='_ph.gif' WIDTH=16 HEIGHT=19 ALT=' ph' TITLE='ph'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "phc" as "ph<SUB>&#x1D450;</SUB>";
  latexdef "phc" as "{\rm ph}_c";
htmldef "psc" as
    "<IMG SRC='_ps.gif' WIDTH=14 HEIGHT=19 ALT=' ps' TITLE='ps'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "psc" as "ps<SUB>&#x1D450;</SUB>";
  latexdef "psc" as "{\rm ps}_c";
htmldef "Pc" as
    "<IMG SRC='rmcp.gif' WIDTH=9 HEIGHT=19 ALT=' P' TITLE='P'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "Pc" as "P<SUB>&#x1D450;</SUB>";
  latexdef "Pc" as "{\rm P}_c";
htmldef "notc" as
    "<IMG SRC='_not.gif' WIDTH=21 HEIGHT=19 ALT=' not' TITLE='not'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "notc" as "not<SUB>&#x1D450;</SUB>";
  latexdef "notc" as "{\rm not}_c";
htmldef "andc" as
    "<IMG SRC='_and.gif' WIDTH=24 HEIGHT=19 ALT=' and' TITLE='and'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "andc" as "and<SUB>&#x1D450;</SUB>";
  latexdef "andc" as "{\rm and}_c";
htmldef "ors" as
    "<IMG SRC='__or.gif' WIDTH=13 HEIGHT=19 ALT=' or' TITLE='or'>" +
    "<IMG SRC='subs.gif' WIDTH=6 HEIGHT=19 ALT=' s' TITLE='s'>";
  althtmldef "ors" as "or<SUB>&#x1D460;</SUB>";
  latexdef "ors" as "{\rm or}_c";
htmldef "impc" as
    "<IMG SRC='_imp.gif' WIDTH=24 HEIGHT=19 ALT=' imp' TITLE='imp'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "impc" as "imp<SUB>&#x1D450;</SUB>";
  latexdef "impc" as "{\rm imp}_c";
htmldef "bic" as
    "<IMG SRC='_bi.gif' WIDTH=12 HEIGHT=19 ALT=' bi' TITLE='bi'>" +
    "<IMG SRC='subc.gif' WIDTH=6 HEIGHT=19 ALT=' c' TITLE='c'>";
  althtmldef "bic" as "bi<SUB>&#x1D450;</SUB>";
  latexdef "bic" as "{\rm bi}_c";
htmldef "Prop" as
    "<IMG SRC='_prop.gif' WIDTH=30 HEIGHT=19 ALT=' Prop' TITLE='Prop'>";
  althtmldef "Prop" as "Prop";
  latexdef "Prop" as "{\rm Prop}";
htmldef "derv" as
    "<IMG SRC='_derv.gif' WIDTH=29 HEIGHT=19 ALT=' derv' TITLE='derv'>";
  althtmldef "derv" as "derv";
  latexdef "derv" as "{\rm derv}";
htmldef "PPoints" as "PPoints";
  althtmldef "PPoints" as "PPoints";
  latexdef "PPoints" as "{\rm PPoints}";
htmldef "PLines" as "PLines";
  althtmldef "PLines" as "PLines";
  latexdef "PLines" as "{\rm PLines}";
htmldef "Ig" as "Ig";
  althtmldef "Ig" as "Ig";
  latexdef "Ig" as "{\rm Ig}";
htmldef "coln" as "coln";
  althtmldef "coln" as "coln";
  latexdef "coln" as "{\rm coln}";
htmldef "con" as "con";
  althtmldef "con" as "con";
  latexdef "con" as "{\rm con}";
/@
htmldef "||g" as "||g";
  althtmldef "||g" as "||g";
  latexdef "||g" as "{\rm ||g}";
@/
htmldef "Ibg" as "Ibg";
  althtmldef "Ibg" as "Ibg";
  latexdef "Ibg" as "{\rm Ibg}";
htmldef "btw" as "btw";
  althtmldef "btw" as "btw";
  latexdef "btw" as "{\rm btw}";
htmldef "Segments" as "Segments";
  althtmldef "Segments" as "Segments";
  latexdef "Segments" as "{\rm Segments}";
htmldef "ray" as "ray";
  althtmldef "ray" as "ray";
  latexdef "ray" as "{\rm ray}";
htmldef "convex" as "convex";
  althtmldef "convex" as "convex";
  latexdef "convex" as "{\rm convex}";
htmldef "Ibcg" as "Ibcg";
  althtmldef "Ibcg" as "Ibcg";
  latexdef "Ibcg" as "{\rm Ibcg}";
htmldef "angc" as "angc";
  althtmldef "angc" as "angc";
  latexdef "angc" as "{\rm angc}";
htmldef "segc" as "segc";
  althtmldef "segc" as "segc";
  latexdef "segc" as "{\rm segc}";
htmldef "slices" as "slices";
  althtmldef "slices" as "slices";
  latexdef "slices" as "{\rm slices}";
htmldef "Cut" as "Cut";
  althtmldef "Cut" as "Cut";
  latexdef "Cut" as "{\rm Cut}";
htmldef "Neug" as "Neug";
  althtmldef "Neug" as "Neug";
  latexdef "Neug" as "{\rm Neug}";
htmldef "Circle" as "Circle";
  althtmldef "Circle" as "Circle";
  latexdef "Circle" as "{\rm Circle}";
htmldef "angle" as "angle";
  althtmldef "angle" as "angle";
  latexdef "angle" as "{\rm angle}";
htmldef "triangle" as "triangle";
  althtmldef "triangle" as "triangle";
  latexdef "triangle" as "{\rm triangle}";
htmldef "dWords" as "dWords";
  althtmldef "dWords" as "dWords";
  latexdef "dWords" as "{\rm dWords}";
htmldef "ss" as "ss";
  althtmldef "ss" as "ss";
  latexdef "ss" as "{\rm ss}";
htmldef "trcng" as "trcng";
  althtmldef "trcng" as "trcng";
  latexdef "trcng" as "{\rm trcng}";
htmldef "Halfplane" as "Halfplane";
  althtmldef "Halfplane" as "Halfplane";
  latexdef "Halfplane" as "{\rm Halfplane}";
htmldef "angtrg" as "angtrg";
  althtmldef "angtrg" as "angtrg";
  latexdef "angtrg" as "{\rm angtrg}";
htmldef "segtrg" as "segtrg";
  althtmldef "segtrg" as "segtrg";
  latexdef "segtrg" as "{\rm segtrg}";
htmldef ".~s" as
    " <IMG SRC='_.sim.gif' WIDTH=13 HEIGHT=19 ALT=' .~' TITLE='.~'> " +
    "<IMG SRC='subs.gif' WIDTH=6 HEIGHT=19 ALT=' s' TITLE='s'>";
  althtmldef ".~s" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>~<SUB>s</SUB> </I></SPAN>';
  latexdef ".~s" as "\sim_s";
htmldef ".~a" as
    " <IMG SRC='_.sim.gif' WIDTH=13 HEIGHT=19 ALT=' .~' TITLE='.~'> " +
    "<IMG SRC='suba.gif' WIDTH=6 HEIGHT=19 ALT=' a' TITLE='a'>";
  althtmldef ".~a" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>~<SUB>a</SUB> </I></SPAN>';
  latexdef ".~a" as "\sim_a";
htmldef ".~t" as
    " <IMG SRC='_.sim.gif' WIDTH=13 HEIGHT=19 ALT=' .~' TITLE='.~'> " +
    "<IMG SRC='subt.gif' WIDTH=6 HEIGHT=19 ALT=' t' TITLE='t'>";
  althtmldef ".~t" as
    '<SPAN CLASS=class STYLE="color:#C3C"><I>~<SUB>t</SUB> </I></SPAN>';
  latexdef ".~t" as "\sim_t";
/@ End of mathbox of FL @/
******* end of commenting out due to removal of FL's mathbox ******/


/* Mathbox of Jeff Madsen */
htmldef "Fne" as
    "<IMG SRC='_fne.gif' WIDTH=24 HEIGHT=19 ALT=' Fne' TITLE='Fne'>";
  althtmldef "Fne" as "Fne";
  latexdef "Fne" as "{\rm Fne}";
htmldef "Ref" as
    "<IMG SRC='_ref.gif' WIDTH=23 HEIGHT=19 ALT=' Ref' TITLE='Ref'>";
  althtmldef "Ref" as "Ref";
  latexdef "Ref" as "{\rm Ref}";
htmldef "PtFin" as
    "<IMG SRC='_ptfin.gif' WIDTH=36 HEIGHT=19 ALT=' PtFin' TITLE='PtFin'>";
  althtmldef "PtFin" as "PtFin";
  latexdef "PtFin" as "{\rm PtFin}";
htmldef "LocFin" as
    "<IMG SRC='_locfin.gif' WIDTH=44 HEIGHT=19 ALT=' LocFin' TITLE='LocFin'>";
  althtmldef "LocFin" as "LocFin";
  latexdef "LocFin" as "{\rm LocFin}";
htmldef "TotBnd" as
    "<IMG SRC='_totbnd.gif' WIDTH=46 HEIGHT=19 ALT=' TotBnd' TITLE='TotBnd'>";
  althtmldef "TotBnd" as "TotBnd";
  latexdef "TotBnd" as "{\rm TotBnd}";
htmldef "Bnd" as
    "<IMG SRC='_bnd.gif' WIDTH=25 HEIGHT=19 ALT=' Bnd' TITLE='Bnd'>";
  althtmldef "Bnd" as "Bnd";
  latexdef "Bnd" as "{\rm Bnd}";
htmldef "Ismty" as
    " <IMG SRC='_ismty.gif' WIDTH=36 HEIGHT=19 ALT=' Ismty' TITLE='Ismty'> ";
  althtmldef "Ismty" as " Ismty ";
  latexdef "Ismty" as "{\rm Ismty}";
htmldef "Rn" as
    "<IMG SRC='_bbrn.gif' WIDTH=19 HEIGHT=19 ALT=' Rn' TITLE='Rn'>";
  althtmldef "Rn" as "&#8477;<I><SUP>n</SUP></I>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "Rn" as "\mathbb{R}^n";
htmldef "RngHom" as
   " <IMG SRC='_rnghom.gif' WIDTH=55 HEIGHT=19 ALT=' RngHom' TITLE='RngHom'> ";
  althtmldef "RngHom" as " RngHom ";
  latexdef "RngHom" as "{\rm RngHom}";
htmldef "RngIso" as
   " <IMG SRC='_rngiso.gif' WIDTH=43 HEIGHT=19 ALT=' RngIso' TITLE='RngIso'> ";
  althtmldef "RngIso" as " RngIso ";
  latexdef "RngIso" as "{\rm RngIso}";
htmldef "~=r" as
    " <IMG SRC='_simeqr.gif' WIDTH=18 HEIGHT=19 ALT=' ~=r' TITLE='~=r'> ";
  althtmldef "~=r" as " &#8771;<SUB>&#x1D45F;</SUB> ";
  latexdef "~=r" as "\simeq_r";
htmldef "CRingOps" as "CRingOps";
  althtmldef "CRingOps" as "CRingOps";
  latexdef "CRingOps" as "{\rm CRingOps}";
htmldef "Idl" as
    "<IMG SRC='_idl.gif' WIDTH=16 HEIGHT=19 ALT=' Idl' TITLE='Idl'>";
  althtmldef "Idl" as "Idl";
  latexdef "Idl" as "{\rm Idl}";
htmldef "PrIdl" as
    "<IMG SRC='_pridl.gif' WIDTH=31 HEIGHT=19 ALT=' PrIdl' TITLE='PrIdl'>";
  althtmldef "PrIdl" as "PrIdl";
  latexdef "PrIdl" as "{\rm PrIdl}";
htmldef "MaxIdl" as
    "<IMG SRC='_maxidl.gif' WIDTH=44 HEIGHT=19 ALT=' MaxIdl' TITLE='MaxIdl'>";
  althtmldef "MaxIdl" as "MaxIdl";
  latexdef "MaxIdl" as "{\rm MaxIdl}";
htmldef "PrRing" as
    "<IMG SRC='_prring.gif' WIDTH=45 HEIGHT=19 ALT=' PrRing' TITLE='PrRing'>";
  althtmldef "PrRing" as "PrRing";
  latexdef "PrRing" as "{\rm PrRing}";
htmldef "Dmn" as
    "<IMG SRC='_dmn.gif' WIDTH=30 HEIGHT=19 ALT=' Dmn' TITLE='Dmn'>";
  althtmldef "Dmn" as "Dmn";
  latexdef "Dmn" as "{\rm Dmn}";
htmldef "IdlGen" as
   " <IMG SRC='_idlgen.gif' WIDTH=42 HEIGHT=19 ALT=' IdlGen' TITLE='IdlGen'> ";
  althtmldef "IdlGen" as " IdlGen ";
  latexdef "IdlGen" as "{\rm IdlGen}";


/* Mathbox of Rodolfo Medina */
htmldef "Prt" as
    "<IMG SRC='_prt.gif' WIDTH=21 HEIGHT=19 ALT=' Prt' TITLE='Prt'> ";
  althtmldef "Prt" as "Prt ";
  latexdef "Prt" as "{\rm Prt}";

/* Mathbox of Stefan O'Rear */
htmldef "NoeACS" as "NoeACS";
  althtmldef "NoeACS" as "NoeACS";
  latexdef "NoeACS" as "\mathrm{NoeACS}";
htmldef "mzPolyCld" as "mzPolyCld";
  althtmldef "mzPolyCld" as "mzPolyCld";
  latexdef "mzPolyCld" as "{\rm mzPolyCld}";
htmldef "mzPoly" as "mzPoly";
  althtmldef "mzPoly" as "mzPoly";
  latexdef "mzPoly" as "{\rm mzPoly}";
htmldef "Dioph" as "Dioph";
  althtmldef "Dioph" as "Dioph";
  latexdef "Dioph" as "{\rm Dioph}";
htmldef "numer" as "numer";
  althtmldef "numer" as "numer";
  latexdef "numer" as "{\rm numer}";
htmldef "denom" as "denom";
  althtmldef "denom" as "denom";
  latexdef "denom" as "{\rm denom}";
htmldef "Pell1QR" as "Pell1QR";
  althtmldef "Pell1QR" as "Pell1QR";
  latexdef "Pell1QR" as "{\rm Pell1QR}";
htmldef "Pell14QR" as "Pell14QR";
  althtmldef "Pell14QR" as "Pell14QR";
  latexdef "Pell14QR" as "{\rm Pell14QR}";
htmldef "Pell1234QR" as "Pell1234QR";
  althtmldef "Pell1234QR" as "Pell1234QR";
  latexdef "Pell1234QR" as "{\rm Pell1234QR}";
htmldef "PellFund" as "PellFund";
  althtmldef "PellFund" as "PellFund";
  latexdef "PellFund" as "{\rm PellFund}";
htmldef "[]NN" as "&#x25FB;<SUB><I>NN</I></SUB>";
  althtmldef "[]NN" as "&#x25FB;<SUB><I>NN</I></SUB>";
  latexdef "[]NN" as "{\rm []NN}";
htmldef "rmX" as " X<SUB>rm</SUB> ";
  althtmldef "rmX" as " X<SUB>rm</SUB> ";
  latexdef "rmX" as "{\rm rmX}";
htmldef "rmY" as " Y<SUB>rm</SUB> ";
  althtmldef "rmY" as " Y<SUB>rm</SUB> ";
  latexdef "rmY" as "{\rm rmY}";
htmldef "LFinGen" as "LFinGen";
  althtmldef "LFinGen" as "LFinGen";
  latexdef "LFinGen" as "{\rm LFinGen}";
htmldef "LNoeM" as "LNoeM";
  althtmldef "LNoeM" as "LNoeM";
  latexdef "LNoeM" as "{\rm LNoeM}";
htmldef "(+)m" as " <IMG SRC='oplus.gif' WIDTH=13 HEIGHT=19 " +
    "ALT=' (+)' TITLE='(+)'><SUB>m</SUB> ";
  althtmldef "(+)m" as " &#x2295;<SUB>m</SUB> ";
  latexdef "(+)m" as "\oplus_{m}";
htmldef "freeLMod" as " freeLMod ";
  althtmldef "freeLMod" as " freeLMod ";
  latexdef "freeLMod" as "{\rm freeLMod}";
htmldef "unitVec" as " unitVec ";
  althtmldef "unitVec" as " unitVec ";
  latexdef "unitVec" as "{\rm unitVec}";
htmldef "LIndF" as " LIndF ";
  althtmldef "LIndF" as " LIndF ";
  latexdef "LIndF" as " {\rm LIndF} ";
htmldef "LIndS" as "LIndS";
  althtmldef "LIndS" as "LIndS";
  latexdef "LIndS" as "{\rm LIndS}";
htmldef "LNoeR" as "LNoeR";
  althtmldef "LNoeR" as "LNoeR";
  latexdef "LNoeR" as "{\rm LNoeR}";
htmldef "ldgIdlSeq" as "ldgIdlSeq";
  althtmldef "ldgIdlSeq" as "ldgIdlSeq";
  latexdef "ldgIdlSeq" as "\mathrm{ldgIdlSeq}";
htmldef "Monic" as
    " <IMG SRC='_monic.gif' WIDTH=38 HEIGHT=19 ALT=' Monic' TITLE='Monic'> ";
  althtmldef "Monic" as " Monic ";
  latexdef "Monic" as "{\rm Monic}";
htmldef "Poly<" as " Poly<sub>&lt;</sub> ";
  althtmldef "Poly<" as " Poly<sub>&lt;</sub> ";
  latexdef "Poly<" as "{\rm Poly<}";
htmldef "degAA" as "deg<SUB>AA</SUB>";
  althtmldef "degAA" as "deg<SUB>AA</SUB>";
  latexdef "degAA" as "{\rm degAA}";
htmldef "minPolyAA" as "minPolyAA";
  althtmldef "minPolyAA" as "minPolyAA";
  latexdef "minPolyAA" as "{\rm minPolyAA}";
htmldef "_ZZ" as "<SPAN STYLE='text-decoration: overline;'>&#8484;</SPAN>";
    /* 2-Jan-2016 reverted sans-serif */
  althtmldef "_ZZ" as
                 "<SPAN STYLE='text-decoration: overline;'>&#8484;</SPAN>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "_ZZ" as "{\rm _ZZ}";
htmldef "IntgOver" as "IntgOver";
  althtmldef "IntgOver" as "IntgOver";
  latexdef "IntgOver" as "{\rm IntgOver}";
htmldef "pmTrsp" as "pmTrsp";
  althtmldef "pmTrsp" as "pmTrsp";
  latexdef "pmTrsp" as "\mathrm{pmTrsp}";
htmldef "pmSgn" as "pmSgn";
  althtmldef "pmSgn" as "pmSgn";
  latexdef "pmSgn" as "\mathrm{pmSgn}";
htmldef "maMul" as " maMul ";
  althtmldef "maMul" as " maMul ";
  latexdef "maMul" as " \mathrm{maMul} ";
htmldef "Mat" as " Mat ";
  althtmldef "Mat" as " Mat ";
  latexdef "Mat" as " \mathrm{Mat} ";
htmldef "maDet" as " maDet ";
  althtmldef "maDet" as " maDet ";
  latexdef "maDet" as " \mathrm{maDet} ";
htmldef "maAdju" as " maAdju ";
  althtmldef "maAdju" as " maAdju ";
  latexdef "maAdju" as " \mathrm{maAdju} ";
htmldef "MEndo" as "MEndo";
  althtmldef "MEndo" as "MEndo";
  latexdef "MEndo" as "\mathrm{MEndo}";
htmldef "SubDRing" as "SubDRing";
  althtmldef "SubDRing" as "SubDRing";
  latexdef "SubDRing" as "\mathrm{SubDRing}";
htmldef "Cntr" as "Cntr";
  althtmldef "Cntr" as "Cntr";
  latexdef "Cntr" as "\mathrm{Cntr}";
htmldef "Cntz" as "Cntz";
  althtmldef "Cntz" as "Cntz";
  latexdef "Cntz" as "\mathrm{Cntz}";
htmldef "CytP" as "CytP";
  althtmldef "CytP" as "CytP";
  latexdef "CytP" as "\mathrm{CytP}";
htmldef "TopSep" as "TopSep";
  althtmldef "TopSep" as "TopSep";
  latexdef "TopSep" as "{\rm TopSep}";
htmldef "TopLnd" as "TopLnd";
  althtmldef "TopLnd" as "TopLnd";
  latexdef "TopLnd" as "{\rm TopLnd}";
/* End of mathbox of Stefan O'Rear */


/* Mathbox of Steve Rodriguez */
/* End of mathbox of Steve Rodriguez */


/* Mathbox of Andrew Salmon */
/* geometry proposal */
htmldef "+r" as "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>" +
    "<IMG SRC='subr.gif' WIDTH=5 HEIGHT=19 ALT=' r' TITLE='r'>";
  althtmldef "+r" as "+<SUB>&#x1D45F;</SUB>";
  latexdef "+r" as "+_r";
htmldef "-r" as
    "<IMG SRC='minus.gif' WIDTH=11 HEIGHT=19 ALT=' -' TITLE='-'>" +
    "<IMG SRC='subr.gif' WIDTH=5 HEIGHT=19 ALT=' r' TITLE='r'>";
  althtmldef "-r" as "-<SUB>&#x1D45F;</SUB>";
  latexdef "-r" as "-_r";
htmldef ".v" as "<IMG SRC='cdot.gif' WIDTH=4 HEIGHT=19 ALT=' .' TITLE='.'>" +
    "<IMG SRC='subv.gif' WIDTH=6 HEIGHT=19 ALT=' v' TITLE='v'>";
  althtmldef ".v" as ".<SUB>&#x1D463;</SUB>";
  latexdef ".v" as "._v";
htmldef "PtDf" as
    "<IMG SRC='_ptdf.gif' WIDTH=31 HEIGHT=19 ALT=' PtDf' TITLE='PtDf'>";
  althtmldef "PtDf" as "PtDf";
  latexdef "PtDf" as "PtDf";
htmldef "RR3" as
    "<IMG SRC='bbr.gif' WIDTH=13 HEIGHT=19 ALT=' RR' TITLE='RR'>" +
    "<IMG SRC='sup3.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "RR3" as "RR3";
  latexdef "RR3" as "RR3";
/*
htmldef "plane3" as
    "<IMG SRC='_plane.gif' WIDTH=35 HEIGHT=19 ALT=' plane' TITLE='plane'>" +
    "<IMG SRC='sup3.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "plane3" as "plane3";
  latexdef "plane3" as "plane3";
*/
htmldef "line3" as
    "<IMG SRC='_line.gif' WIDTH=23 HEIGHT=19 ALT=' line' TITLE='line'>" +
    "<IMG SRC='sup3.gif' WIDTH=6 HEIGHT=19 ALT=' 3' TITLE='3'>";
  althtmldef "line3" as "line3";
  latexdef "line3" as "line3";

/* Mathbox of Jarvin Udandy */
htmldef "jph" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jph</I></SPAN>';
 althtmldef "jph" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jph</I></SPAN>';
 latexdef "jph" as "\rm{jph}";
htmldef "jps" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jps</I></SPAN>';
 althtmldef "jps" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jps</I></SPAN>';
 latexdef "jps" as "\rm{jps}";
htmldef "jch" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jch</I></SPAN>';
 althtmldef "jch" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jch</I></SPAN>';
 latexdef "jch" as "\rm{jch}";
htmldef "jth" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jth</I></SPAN>';
 althtmldef "jth" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jth</I></SPAN>';
 latexdef "jth" as "\rm{jth}";
htmldef "jta" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jta</I></SPAN>';
 althtmldef "jta" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jta</I></SPAN>';
 latexdef "jta" as "\rm{jta}";
htmldef "jet" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jet</I></SPAN>';
 althtmldef "jet" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jet</I></SPAN>';
 latexdef "jet" as "\rm{jet}";
htmldef "jze" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jze</I></SPAN>';
 althtmldef "jze" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jze</I></SPAN>';
 latexdef "jze" as "\rm{jze}";
htmldef "jsi" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jps</I></SPAN>';
 althtmldef "jsi" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jps</I></SPAN>';
 latexdef "jsi" as "\rm{jsi}";
htmldef "jrh" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jrh</I></SPAN>';
 althtmldef "jrh" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jrh</I></SPAN>';
 latexdef "jrh" as "\rm{jrh}";
htmldef "jmu" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jmu</I></SPAN>';
 althtmldef "jmu" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jmu</I></SPAN>';
 latexdef "jmu" as "\rm{jmu}";
htmldef "jla" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jla</I></SPAN>';
 althtmldef "jla" as
  '<SPAN CLASS=wff STYLE="color:blue"><I>jla</I></SPAN>';
 latexdef "jla" as "\rm{jla}";
/* End of Jarvin Udandy's mathbox */

/* Mathbox of Alexander van der Vekens */
htmldef "defAt" as ' defAt ';
 althtmldef "defAt" as ' defAt ';
 latexdef "defAt" as "{\rm defAt}";
htmldef "'''" as '&#39&#39&#39';
 althtmldef "'''" as '&#39&#39&#39';
 latexdef "'''" as "\textquoteright\textquoteright\textquoteright";
htmldef "((" as ' ((';
 althtmldef "((" as ' ((';
 latexdef "((" as " ((";
htmldef "))" as ')) ';
 althtmldef "))" as ')) ';
 latexdef "))" as ")) ";
htmldef "CyclShift" as ' CyclShift ';
 althtmldef "CyclShift" as ' CyclShift ';
 latexdef "CyclShift" as "{\rm CyclShift}";
htmldef "LastS" as ' LastS ';
 althtmldef "LastS" as ' LastS ';
 latexdef "LastS" as "{\rm LastS}";
htmldef "WWalks" as ' WWalks ';
 althtmldef "WWalks" as ' WWalks ';
 latexdef "WWalks" as "{\rm WWalks}";
htmldef "WWalksN" as ' WWalksN ';
 althtmldef "WWalksN" as ' WWalksN ';
 latexdef "WWalksN" as "{\rm WWalksN}";
htmldef "2WalksOt" as ' 2WalksOt ';
 althtmldef "2WalksOt" as ' 2WalksOt ';
 latexdef "2WalksOt" as "{\rm 2WalksOt}";
htmldef "2WalksOnOt" as ' 2WalksOnOt ';
 althtmldef "2WalksOnOt" as ' 2WalksOnOt ';
 latexdef "2WalksOnOt" as "{\rm 2WalksOnOt}";
htmldef "2SPathOnOt" as ' 2SPathOnOt ';
 althtmldef "2SPathOnOt" as ' 2SPathOnOt ';
 latexdef "2SPathOnOt" as "{\rm 2SPathOnOt}";
htmldef "2SPathsOt" as ' 2SPathOnOt ';
 althtmldef "2SPathsOt" as ' 2SPathsOt ';
 latexdef "2SPathsOt" as "{\rm 2SPathsOt}";
htmldef "RegUSGrph" as ' RegUSGrph ';
 althtmldef "RegUSGrph" as ' RegUSGrph ';
 latexdef "RegUSGrph" as "{\rm RegUSGrph}";
htmldef "RegGrph" as ' RegGrph ';
 althtmldef "RegGrph" as ' RegGrph ';
 latexdef "RegGrph" as "{\rm RegGrph}";
htmldef "FriendGrph" as ' FriendGrph ';
 althtmldef "FriendGrph" as ' FriendGrph ';
 latexdef "FriendGrph" as "{\rm FriendGrph}";
/* End of Alexander van der Vekens's mathbox */

/* Mathbox of David A. Wheeler */
htmldef ">_" as
    " <IMG SRC='ge.gif' WIDTH=11 HEIGHT=19 ALT=' &gt;_' TITLE='&gt;_'> ";
  althtmldef ">_" as ' &ge; ';
  latexdef ">_" as "\ge";
htmldef ">" as
    " <IMG SRC='gt.gif' WIDTH=11 HEIGHT=19 ALT=' &gt;' TITLE='&gt;'> ";
  althtmldef ">" as ' &gt; ';
  latexdef ">" as ">";
/*
htmldef "sinh" as
    "<IMG SRC='_sinh.gif' WIDTH=20 HEIGHT=19 ALT=' sinh' TITLE='sinh'>";
*/
htmldef "sinh" as "sinh";
  althtmldef "sinh" as "sinh";
  latexdef "sinh" as "\sinh";
/*
htmldef "cosh" as
    "<IMG SRC='_cosh.gif' WIDTH=20 HEIGHT=19 ALT=' cosh' TITLE='cosh'>";
*/
htmldef "cosh" as "cosh";
  althtmldef "cosh" as "cosh";
  latexdef "cosh" as "\cosh";
/*
htmldef "tanh" as
    "<IMG SRC='_tanh.gif' WIDTH=20 HEIGHT=19 ALT=' tanh' TITLE='tanh'>";
*/
htmldef "tanh" as "tanh";
  althtmldef "tanh" as "tanh";
  latexdef "tanh" as "\tanh";
htmldef "sec" as
    "<IMG SRC='_sec.gif' WIDTH=20 HEIGHT=19 ALT=' sec' TITLE='sec'>";
  althtmldef "sec" as "sec";
  latexdef "sec" as "\sec";
htmldef "csc" as
    "<IMG SRC='_csc.gif' WIDTH=20 HEIGHT=19 ALT=' csc' TITLE='csc'>";
  althtmldef "csc" as "csc";
  latexdef "csc" as "\csc";
htmldef "cot" as
    "<IMG SRC='_cot.gif' WIDTH=20 HEIGHT=19 ALT=' cot' TITLE='cot'>";
  althtmldef "cot" as "cot";
  latexdef "cot" as "\cot";
/*
htmldef "_" as
    "<IMG SRC='underscore.gif' WIDTH=20 HEIGHT=19 ALT=' _' TITLE='_'>";
*/
htmldef "_" as '<FONT COLOR="#808080">_</FONT>';
  althtmldef "_" as '<SPAN CLASS=hidden STYLE="color:gray">_</SPAN>';
  latexdef "_" as "\_";
htmldef "." as
    "<IMG SRC='period.gif' WIDTH=20 HEIGHT=19 ALT=' period' TITLE='period'>";
  althtmldef "." as ".";
  latexdef "." as "\.";
/*
htmldef "sgn" as
    "<IMG SRC='sgn.gif' WIDTH=20 HEIGHT=19 ALT=' sgn' TITLE='sgn'>";
*/
htmldef "sgn" as "sgn";
  althtmldef "sgn" as "sgn";
  latexdef "sgn" as "sgn";
/*
htmldef "ceiling" as
   "<IMG SRC='ceiling.gif' WIDTH=20 HEIGHT=19 ALT=' ceiling' TITLE='ceiling'>";
*/
htmldef "ceiling" as "&#8968;";
  althtmldef "ceiling" as "&#8968;";
  latexdef "ceiling" as "ceiling";
htmldef "logb" as "logb";
  althtmldef "logb" as "logb";
  latexdef "logb" as "logb";
htmldef "log_" as "log_";
  althtmldef "log_" as "log_";
  latexdef "log_" as "log_";

/* Mathbox of Alan Sare */
htmldef "(." as
    "<IMG SRC='period.gif' WIDTH=4 HEIGHT=19 ALT=' (.' TITLE='(.'>";
althtmldef "(." as
'<SPAN STYLE="color:#00CD00">&#40;&#160;&#160;&#160;</SPAN>';
/* This puts 0 white spaces before the left parenthesis(&#40) and 3 white
   spaces after. Here the parenthesis shall be colored bright green, the same
   color as the arrow. Here we are trying to use green parentheses instead of
   green periods. The reasoning is that parenthesis are better because its more
   consistent
   with a) conventional metamath notation so the User understands it better;
   b) Because these parentheses are now bright green, that sufficiently
   distinguishes these parentheses from the parentheses used to parse the
   wffs. The green parentheses are notation of the Virtual Deduction "mediator"
   notation. */
latexdef "(." as ".";
htmldef ")." as
    "<IMG SRC='period.gif' WIDTH=4 HEIGHT=19 ALT=' ).' TITLE=').'>";
althtmldef ")." as
'<SPAN STYLE="color:#00CD00">&#160;&#160;&#160;&#41;</SPAN>';
/* This puts 3 white spaces before the right parenthesis(&#41) and 0 white
   spaces after. Here the parenthesis shall be colored bright green, the same
   color as the arrow. Here we are trying to use green parentheses instead of
   green periods. The reasoning is that parenthesis are better because its more
   consistent
   with a) conventional metamath notation so the User understands it better;
   b) Because these parentheses are now bright green, that sufficiently
   distinguishes these parentheses from the parentheses used to parse the
   wffs. The green parentheses are notation of the Virtual Deduction "mediator"
   notation. */
latexdef ")." as ".";
htmldef "->." as " <IMG SRC='blacktriangleright.gif' " +
    "WIDTH=11 HEIGHT=19 ALT=' -&gt;.' TITLE='-&gt;.'> ";
althtmldef "->." as
  '<SPAN STYLE="color:#00CD00"><FONT FACE=veranda>' +
  '&#160;&#160;&#160;&#9654;&#160;&#160;&#160;</FONT></SPAN>';
/* This should work better than the one above because we put white spaces
   around the arrow. It is better with an equal number of white spaces on each
   side of the arrow. The bright green for the virtual deduction notation
   works well. */
latexdef "->." as "\blacktriangleright";
htmldef "->.." as " <IMG SRC='__tobold.gif' " +
    "WIDTH=15 HEIGHT=19 ALT=' -&gt;..' TITLE='-&gt;..'> ";
  althtmldef "->.." as " <B>&rarr;</B> ";
  latexdef "->.." as "\mbox{\boldmath $\rightarrow$}}";
htmldef ",." as
    "<IMG SRC='comma.gif' WIDTH=4 HEIGHT=19 ALT=' ,.' TITLE=',.'>";
althtmldef ",." as
    '<SPAN STYLE="color:#00CD00"><FONT SIZE=4>' +
    '&#160;&#160;&#160;&#44;&#160;&#160;&#160;</FONT></SPAN>';
/* This color is green3. It is brighter and lighter than Irish flag. It is
   bright enough to stand out and it is not too light
   to be seen. It is clearly distinguishable from black. */
latexdef ",." as " , ";
/* End of Alan Sare's mathbox */


/* Mathbox of Jonathan Ben-Naim */
htmldef "ph'" as "<IMG SRC='_bnj_phiPrime.gif'   WIDTH=15 HEIGHT=19" +
       " ALT=" + '"' + " ph'" + '"' + " TITLE=" + '"' + "ph'" + '"' + ">";
htmldef "ps'" as "<IMG SRC='_bnj_psiPrime.gif'   WIDTH=16 HEIGHT=19" +
       " ALT=" + '"' + " ps'" + '"' + " TITLE=" + '"' + "ps'" + '"' + ">";
htmldef "ch'" as "<IMG SRC='_bnj_chiPrime.gif'   WIDTH=16 HEIGHT=19" +
       " ALT=" + '"' + " ch'" + '"' + " TITLE=" + '"' + "ch'" + '"' + ">";
htmldef "th'" as "<IMG SRC='_bnj_thetaPrime.gif' WIDTH=12 HEIGHT=19" +
       " ALT=" + '"' + " th'" + '"' + " TITLE=" + '"' + "th'" + '"' + ">";
htmldef "ta'" as "<IMG SRC='_bnj_tauPrime.gif'   WIDTH=14 HEIGHT=19" +
       " ALT=" + '"' + " ta'" + '"' + " TITLE=" + '"' + "ta'" + '"' + ">";
htmldef "et'" as "<IMG SRC='_bnj_etaPrime.gif'   WIDTH=13 HEIGHT=19" +
       " ALT=" + '"' + " et'" + '"' + " TITLE=" + '"' + "et'" + '"' + ">";
htmldef "ze'" as "<IMG SRC='_bnj_zetaPrime.gif'  WIDTH=13 HEIGHT=19" +
       " ALT=" + '"' + " ze'" + '"' + " TITLE=" + '"' + "ze'" + '"' + ">";
htmldef "si'" as "<IMG SRC='_bnj_sigmaPrime.gif' WIDTH=14 HEIGHT=19" +
       " ALT=" + '"' + " si'" + '"' + " TITLE=" + '"' + "si'" + '"' + ">";
htmldef "rh'" as "<IMG SRC='_bnj_rhoPrime.gif'   WIDTH=13 HEIGHT=19" +
       " ALT=" + '"' + " rh'" + '"' + " TITLE=" + '"' + "rh'" + '"' + ">";
althtmldef "ph'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D711;&prime;</SPAN>';
althtmldef "ps'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D713;&prime;</SPAN>';
althtmldef "ch'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D712;&prime;</SPAN>';
althtmldef "th'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D703;&prime;</SPAN>';
althtmldef "ta'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70F;&prime;</SPAN>';
althtmldef "et'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D702;&prime;</SPAN>';
althtmldef "ze'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D701;&prime;</SPAN>';
althtmldef "si'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70E;&prime;</SPAN>';
althtmldef "rh'" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70C;&prime;</SPAN>';
latexdef "ph'" as "\varphi'";
latexdef "ps'" as "\psi'";
latexdef "ch'" as "\chi'";
latexdef "th'" as "\theta'";
latexdef "ta'" as "\tau'";
latexdef "et'" as "\eta'";
latexdef "ze'" as "\zeta'";
latexdef "si'" as "\sigma'";
latexdef "rh'" as "\rho'";
htmldef 'ph"' as "<IMG SRC='_bnj_phiPrimePrime.gif'   WIDTH=18 HEIGHT=19" +
      " ALT=' ph" + '"' + "' TITLE='ph" + '"' + "'>";
htmldef 'ps"' as "<IMG SRC='_bnj_psiPrimePrime.gif'   WIDTH=19 HEIGHT=19" +
      " ALT=' ps" + '"' + "' TITLE='ps" + '"' + "'>";
htmldef 'ch"' as "<IMG SRC='_bnj_chiPrimePrime.gif'   WIDTH=19 HEIGHT=19" +
      " ALT=' ch" + '"' + "' TITLE='ch" + '"' + "'>";
htmldef 'th"' as "<IMG SRC='_bnj_thetaPrimePrime.gif' WIDTH=15 HEIGHT=19" +
      " ALT=' th" + '"' + "' TITLE='th" + '"' + "'>";
htmldef 'ta"' as "<IMG SRC='_bnj_tauPrimePrime.gif'   WIDTH=17 HEIGHT=19" +
      " ALT=' ta" + '"' + "' TITLE='ta" + '"' + "'>";
htmldef 'et"' as "<IMG SRC='_bnj_etaPrimePrime.gif'   WIDTH=16 HEIGHT=19" +
      " ALT=' et" + '"' + "' TITLE='et" + '"' + "'>";
htmldef 'ze"' as "<IMG SRC='_bnj_zetaPrimePrime.gif'  WIDTH=16 HEIGHT=19" +
      " ALT=' ze" + '"' + "' TITLE='ze" + '"' + "'>";
htmldef 'si"' as "<IMG SRC='_bnj_sigmaPrimePrime.gif' WIDTH=17 HEIGHT=19" +
      " ALT=' si" + '"' + "' TITLE='si" + '"' + "'>";
htmldef 'rh"' as "<IMG SRC='_bnj_rhoPrimePrime.gif'   WIDTH=16 HEIGHT=19" +
      " ALT=' rh" + '"' + "' TITLE='rh" + '"' + "'>";
althtmldef 'ph"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D711;&Prime;</SPAN>';
althtmldef 'ps"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D713;&Prime;</SPAN>';
althtmldef 'ch"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D712;&Prime;</SPAN>';
althtmldef 'th"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D703;&Prime;</SPAN>';
althtmldef 'ta"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70F;&Prime;</SPAN>';
althtmldef 'et"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D702;&Prime;</SPAN>';
althtmldef 'ze"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D701;&Prime;</SPAN>';
althtmldef 'si"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70E;&Prime;</SPAN>';
althtmldef 'rh"' as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70C;&Prime;</SPAN>';
latexdef 'ph"' as "\varphi''";
latexdef 'ps"' as "\psi''";
latexdef 'ch"' as "\chi''";
latexdef 'th"' as "\theta''";
latexdef 'ta"' as "\tau''";
latexdef 'et"' as "\eta''";
latexdef 'ze"' as "\zeta''";
latexdef 'si"' as "\sigma''";
latexdef 'rh"' as "\rho''";
htmldef "ph0"  as "<IMG SRC='_bnj_phi0.gif'   WIDTH=18 HEIGHT=19" +
    " ALT=' ph0' TITLE='ph0'>";
htmldef "ps0"  as "<IMG SRC='_bnj_psi0.gif'   WIDTH=19 HEIGHT=19" +
    " ALT=' ps0' TITLE='ps0'>";
htmldef "ch0_" as "<IMG SRC='_bnj_chi0.gif'   WIDTH=19 HEIGHT=19" +
    " ALT=' ch0_' TITLE='ch0_'>";
htmldef "th0"  as "<IMG SRC='_bnj_theta0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' th0' TITLE='th0'>";
htmldef "ta0"  as "<IMG SRC='_bnj_tau0.gif'   WIDTH=17 HEIGHT=19" +
    " ALT=' ta0' TITLE='ta0'>";
htmldef "et0"  as "<IMG SRC='_bnj_eta0.gif'   WIDTH=16 HEIGHT=19" +
    " ALT=' et0' TITLE='et0'>";
htmldef "ze0"  as "<IMG SRC='_bnj_zeta0.gif'  WIDTH=16 HEIGHT=19" +
    " ALT=' ze0' TITLE='ze0'>";
htmldef "si0"  as "<IMG SRC='_bnj_sigma0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' si0' TITLE='si0'>";
htmldef "rh0"  as "<IMG SRC='_bnj_rho0.gif'   WIDTH=16 HEIGHT=19" +
    " ALT=' rh0' TITLE='rh0'>";
althtmldef "ph0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D711;<SUB>0</SUB></SPAN>';
althtmldef "ps0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D713;<SUB>0</SUB></SPAN>';
althtmldef "ch0_" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D712;<SUB>0</SUB></SPAN>';
althtmldef "th0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D703;<SUB>0</SUB></SPAN>';
althtmldef "ta0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70F;<SUB>0</SUB></SPAN>';
althtmldef "et0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D702;<SUB>0</SUB></SPAN>';
althtmldef "ze0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D701;<SUB>0</SUB></SPAN>';
althtmldef "si0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70E;<SUB>0</SUB></SPAN>';
althtmldef "rh0"  as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70C;<SUB>0</SUB></SPAN>';
latexdef "ph0"  as "\varphi_0";
latexdef "ps0"  as "\psi_0";
latexdef "ch0_" as "\chi_0";
latexdef "th0"  as "\theta_0";
latexdef "ta0"  as "\tau_0";
latexdef "et0"  as "\eta_0";
latexdef "ze0"  as "\zeta_0";
latexdef "si0"  as "\sigma_0";
latexdef "rh0"  as "\rho_0";
htmldef "ph1" as "<IMG SRC='_bnj_phi1.gif'   WIDTH=16 HEIGHT=19" +
    " ALT=' ph1' TITLE='ph1'>";
htmldef "ps1" as "<IMG SRC='_bnj_psi1.gif'   WIDTH=17 HEIGHT=19" +
    " ALT=' ps1' TITLE='ps1'>";
htmldef "ch1" as "<IMG SRC='_bnj_chi1.gif'   WIDTH=17 HEIGHT=19" +
    " ALT=' ch1' TITLE='ch1'>";
htmldef "th1" as "<IMG SRC='_bnj_theta1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' th1' TITLE='th1'>";
htmldef "ta1" as "<IMG SRC='_bnj_tau1.gif'   WIDTH=15 HEIGHT=19" +
    " ALT=' ta1' TITLE='ta1'>";
htmldef "et1" as "<IMG SRC='_bnj_eta1.gif'   WIDTH=14 HEIGHT=19" +
    " ALT=' et1' TITLE='et1'>";
htmldef "ze1" as "<IMG SRC='_bnj_zeta1.gif'  WIDTH=14 HEIGHT=19" +
    " ALT=' ze1' TITLE='ze1'>";
htmldef "si1" as "<IMG SRC='_bnj_sigma1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' si1' TITLE='si1'>";
htmldef "rh1" as "<IMG SRC='_bnj_rho1.gif'   WIDTH=14 HEIGHT=19" +
    " ALT=' rh1' TITLE='rh1'>";
althtmldef "ph1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D711;<SUB>1</SUB></SPAN>';
althtmldef "ps1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D713;<SUB>1</SUB></SPAN>';
althtmldef "ch1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D712;<SUB>1</SUB></SPAN>';
althtmldef "th1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D703;<SUB>1</SUB></SPAN>';
althtmldef "ta1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70F;<SUB>1</SUB></SPAN>';
althtmldef "et1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D702;<SUB>1</SUB></SPAN>';
althtmldef "ze1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D701;<SUB>1</SUB></SPAN>';
althtmldef "si1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70E;<SUB>1</SUB></SPAN>';
althtmldef "rh1" as
    '<SPAN CLASS=wff STYLE="color:blue">&#x1D70C;<SUB>1</SUB></SPAN>';
latexdef "ph1" as "\varphi_1";
latexdef "ps1" as "\psi_1";
latexdef "ch1" as "\chi_1";
latexdef "th1" as "\theta_1";
latexdef "ta1" as "\tau_1";
latexdef "et1" as "\eta_1";
latexdef "ze1" as "\zeta_1";
latexdef "si1" as "\sigma_1";
latexdef "rh1" as "\rho_1";
htmldef "a'" as "<IMG SRC='_bnj_aPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " a'" + '"' + " TITLE=" + '"' + "a'" + '"' + ">";
htmldef "b'" as "<IMG SRC='_bnj_bPrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " b'" + '"' + " TITLE=" + '"' + "b'" + '"' + ">";
htmldef "c'" as "<IMG SRC='_bnj_cPrime.gif' WIDTH=11 HEIGHT=19" +
    " ALT=" + '"' + " c'" + '"' + " TITLE=" + '"' + "c'" + '"' + ">";
htmldef "d'" as "<IMG SRC='_bnj_dPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " d'" + '"' + " TITLE=" + '"' + "d'" + '"' + ">";
htmldef "e'" as "<IMG SRC='_bnj_ePrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " e'" + '"' + " TITLE=" + '"' + "e'" + '"' + ">";
htmldef "f'" as "<IMG SRC='_bnj_fPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " f'" + '"' + " TITLE=" + '"' + "f'" + '"' + ">";
htmldef "g'" as "<IMG SRC='_bnj_gPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " g'" + '"' + " TITLE=" + '"' + "g'" + '"' + ">";
htmldef "h'" as "<IMG SRC='_bnj_hPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " h'" + '"' + " TITLE=" + '"' + "h'" + '"' + ">";
htmldef "i'" as "<IMG SRC='_bnj_iPrime.gif' WIDTH=10 HEIGHT=19" +
    " ALT=" + '"' + " i'" + '"' + " TITLE=" + '"' + "i'" + '"' + ">";
htmldef "j'" as "<IMG SRC='_bnj_jPrime.gif' WIDTH=11 HEIGHT=19" +
    " ALT=" + '"' + " j'" + '"' + " TITLE=" + '"' + "j'" + '"' + ">";
htmldef "k'" as "<IMG SRC='_bnj_kPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " k'" + '"' + " TITLE=" + '"' + "k'" + '"' + ">";
htmldef "l'" as "<IMG SRC='_bnj_lPrime.gif' WIDTH=9  HEIGHT=19" +
    " ALT=" + '"' + " l'" + '"' + " TITLE=" + '"' + "l'" + '"' + ">";
htmldef "m'" as "<IMG SRC='_bnj_mPrime.gif' WIDTH=18 HEIGHT=19" +
    " ALT=" + '"' + " m'" + '"' + " TITLE=" + '"' + "m'" + '"' + ">";
htmldef "n'" as "<IMG SRC='_bnj_nPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " n'" + '"' + " TITLE=" + '"' + "n'" + '"' + ">";
htmldef "o'_" as "<IMG SRC='_bnj_oPrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " o'_" + '"' + " TITLE=" + '"' + "o'_" + '"' + ">";
htmldef "p'" as "<IMG SRC='_bnj_pPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " p'" + '"' + " TITLE=" + '"' + "p'" + '"' + ">";
htmldef "q'" as "<IMG SRC='_bnj_qPrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " q'" + '"' + " TITLE=" + '"' + "q'" + '"' + ">";
htmldef "r'" as "<IMG SRC='_bnj_rPrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " r'" + '"' + " TITLE=" + '"' + "r'" + '"' + ">";
htmldef "s'_" as "<IMG SRC='_bnj_sPrime.gif' WIDTH=11 HEIGHT=19" +
    " ALT=" + '"' + " s'" + '"' + " TITLE=" + '"' + "s'" + '"' + ">";
htmldef "t'" as "<IMG SRC='_bnj_tPrime.gif' WIDTH=11 HEIGHT=19" +
    " ALT=" + '"' + " t'" + '"' + " TITLE=" + '"' + "t'" + '"' + ">";
htmldef "u'" as "<IMG SRC='_bnj_uPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " u'" + '"' + " TITLE=" + '"' + "u'" + '"' + ">";
htmldef "v'_" as "<IMG SRC='_bnj_vPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " v'" + '"' + " TITLE=" + '"' + "v'" + '"' + ">";
htmldef "w'" as "<IMG SRC='_bnj_wPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " w'" + '"' + " TITLE=" + '"' + "w'" + '"' + ">";
htmldef "x'" as "<IMG SRC='_bnj_xPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " x'" + '"' + " TITLE=" + '"' + "x'" + '"' + ">";
htmldef "y'" as "<IMG SRC='_bnj_yPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " y'" + '"' + " TITLE=" + '"' + "y'" + '"' + ">";
htmldef "z'" as "<IMG SRC='_bnj_zPrime.gif' WIDTH=13 HEIGHT=19" +
    " ALT=" + '"' + " z'" + '"' + " TITLE=" + '"' + "z'" + '"' + ">";
althtmldef "a'" as '<SPAN CLASS=set STYLE="color:red">&#x1D44E;&prime;</SPAN>';
althtmldef "b'" as '<SPAN CLASS=set STYLE="color:red">&#x1D44F;&prime;</SPAN>';
althtmldef "c'" as '<SPAN CLASS=set STYLE="color:red">&#x1D450;&prime;</SPAN>';
althtmldef "d'" as '<SPAN CLASS=set STYLE="color:red">&#x1D451;&prime;</SPAN>';
althtmldef "e'" as '<SPAN CLASS=set STYLE="color:red">&#x1D452;&prime;</SPAN>';
althtmldef "f'" as '<SPAN CLASS=set STYLE="color:red">&#x1D453;&prime;</SPAN>';
althtmldef "g'" as '<SPAN CLASS=set STYLE="color:red">&#x1D454;&prime;</SPAN>';
althtmldef "h'" as '<SPAN CLASS=set STYLE="color:red">&#x210E;&prime;</SPAN>';
althtmldef "i'" as '<SPAN CLASS=set STYLE="color:red">&#x1D456;&prime;</SPAN>';
althtmldef "j'" as '<SPAN CLASS=set STYLE="color:red">&#x1D457;&prime;</SPAN>';
althtmldef "k'" as '<SPAN CLASS=set STYLE="color:red">&#x1D458;&prime;</SPAN>';
althtmldef "l'" as '<SPAN CLASS=set STYLE="color:red">&#x1D459;&prime;</SPAN>';
althtmldef "m'" as '<SPAN CLASS=set STYLE="color:red">&#x1D45A;&prime;</SPAN>';
althtmldef "n'" as '<SPAN CLASS=set STYLE="color:red">&#x1D45B;&prime;</SPAN>';
althtmldef "o'_" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;&prime;</SPAN>';
althtmldef "p'" as '<SPAN CLASS=set STYLE="color:red">&#x1D45D;&prime;</SPAN>';
althtmldef "q'" as '<SPAN CLASS=set STYLE="color:red">&#x1D45E;&prime;</SPAN>';
althtmldef "r'" as '<SPAN CLASS=set STYLE="color:red">&#x1D45F;&prime;</SPAN>';
althtmldef "s'_" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D460;&prime;</SPAN>';
althtmldef "t'" as '<SPAN CLASS=set STYLE="color:red">&#x1D461;&prime;</SPAN>';
althtmldef "u'" as '<SPAN CLASS=set STYLE="color:red">&#x1D462;&prime;</SPAN>';
althtmldef "v'_" as
     '<SPAN CLASS=set STYLE="color:red">&#x1D463;&prime;</SPAN>';
althtmldef "w'" as '<SPAN CLASS=set STYLE="color:red">&#x1D464;&prime;</SPAN>';
althtmldef "x'" as '<SPAN CLASS=set STYLE="color:red">&#x1D465;&prime;</SPAN>';
althtmldef "y'" as '<SPAN CLASS=set STYLE="color:red">&#x1D466;&prime;</SPAN>';
althtmldef "z'" as '<SPAN CLASS=set STYLE="color:red">&#x1D467;&prime;</SPAN>';
latexdef "a'" as "a'";
latexdef "b'" as "b'";
latexdef "c'" as "c'";
latexdef "d'" as "d'";
latexdef "e'" as "e'";
latexdef "f'" as "f'";
latexdef "g'" as "g'";
latexdef "h'" as "h'";
latexdef "i'" as "i'";
latexdef "j'" as "j'";
latexdef "k'" as "k'";
latexdef "l'" as "l'";
latexdef "m'" as "m'";
latexdef "n'" as "n'";
latexdef "o'_" as "o'";
latexdef "p'" as "p'";
latexdef "q'" as "q'";
latexdef "r'" as "r'";
latexdef "s'_" as "s'";
latexdef "t'" as "t'";
latexdef "u'" as "u'";
latexdef "v'_" as "v'";
latexdef "w'" as "w'";
latexdef "x'" as "x'";
latexdef "y'" as "y'";
latexdef "z'" as "z'";
htmldef 'a"' as "<IMG SRC='_bnj_aPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' a" + '"' + "' TITLE='a" + '"' + "'>";
htmldef 'b"' as "<IMG SRC='_bnj_bPrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' b" + '"' + "' TITLE='b" + '"' + "'>";
htmldef 'c"' as "<IMG SRC='_bnj_cPrimePrime.gif' WIDTH=14 HEIGHT=19 " +
      " ALT=' c" + '"' + "' TITLE='c" + '"' + "'>";
htmldef 'd"' as "<IMG SRC='_bnj_dPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' d" + '"' + "' TITLE='d" + '"' + "'>";
htmldef 'e"' as "<IMG SRC='_bnj_ePrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' e" + '"' + "' TITLE='e" + '"' + "'>";
htmldef 'f"' as "<IMG SRC='_bnj_fPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' f" + '"' + "' TITLE='f" + '"' + "'>";
htmldef 'g"' as "<IMG SRC='_bnj_gPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' g" + '"' + "' TITLE='g" + '"' + "'>";
htmldef 'h"' as "<IMG SRC='_bnj_hPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' h" + '"' + "'TITLE='h" + '"' + "'>";
htmldef 'i"' as "<IMG SRC='_bnj_iPrimePrime.gif' WIDTH=13 HEIGHT=19 " +
      " ALT=' i" + '"' + "' TITLE='i" + '"' + "'>";
htmldef 'j"' as "<IMG SRC='_bnj_jPrimePrime.gif' WIDTH=14 HEIGHT=19 " +
      " ALT=' j" + '"' + "' TITLE='j" + '"' + "'>";
htmldef 'k"' as "<IMG SRC='_bnj_kPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' k" + '"' + "' TITLE='k" + '"' + "'>";
htmldef 'l"' as "<IMG SRC='_bnj_lPrimePrime.gif' WIDTH=12 HEIGHT=19 " +
      " ALT=' l" + '"' + "'TITLE='l" + '"' + "'>";
htmldef 'm"' as "<IMG SRC='_bnj_mPrimePrime.gif' WIDTH=21 HEIGHT=19 " +
      " ALT=' m" + '"' + "' TITLE='m" + '"' + "'>";
htmldef 'n"' as "<IMG SRC='_bnj_nPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' n" + '"' + "' TITLE='n" + '"' + "'>";
htmldef 'o"_' as "<IMG SRC='_bnj_oPrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' o" + '"' + "'TITLE='o" + '"' + "'>";
htmldef 'p"' as "<IMG SRC='_bnj_pPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' p" + '"' + "'TITLE='p" + '"' + "'>";
htmldef 'q"' as "<IMG SRC='_bnj_qPrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' q" + '"' + "'TITLE='q" + '"' + "'>";
htmldef 'r"' as "<IMG SRC='_bnj_rPrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' r" + '"' + "'TITLE='r" + '"' + "'>";
htmldef 's"_' as "<IMG SRC='_bnj_sPrimePrime.gif' WIDTH=14 HEIGHT=19 " +
      " ALT=' s" + '"' + "'TITLE='s" + '"' + "'>";
htmldef 't"' as "<IMG SRC='_bnj_tPrimePrime.gif' WIDTH=14 HEIGHT=19 " +
      " ALT=' t" + '"' + "'TITLE='t" + '"' + "'>";
htmldef 'u"' as "<IMG SRC='_bnj_uPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' u" + '"' + "'TITLE='u" + '"' + "'>";
htmldef 'v"_' as "<IMG SRC='_bnj_vPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' v" + '"' + "'TITLE='v" + '"' + "'>";
htmldef 'w"' as "<IMG SRC='_bnj_wPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' w" + '"' + "'TITLE='w" + '"' + "'>";
htmldef 'x"' as "<IMG SRC='_bnj_xPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' x" + '"' + "'TITLE='x" + '"' + "'>";
htmldef 'y"' as "<IMG SRC='_bnj_yPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' y" + '"' + "'TITLE='y" + '"' + "'>";
htmldef 'z"' as "<IMG SRC='_bnj_zPrimePrime.gif' WIDTH=16 HEIGHT=19 " +
      " ALT=' z" + '"' + "'TITLE='z" + '"' + "'>";
althtmldef 'a"' as '<SPAN CLASS=set STYLE="color:red">&#x1D44E;&Prime;</SPAN>';
althtmldef 'b"' as '<SPAN CLASS=set STYLE="color:red">&#x1D44F;&Prime;</SPAN>';
althtmldef 'c"' as '<SPAN CLASS=set STYLE="color:red">&#x1D450;&Prime;</SPAN>';
althtmldef 'd"' as '<SPAN CLASS=set STYLE="color:red">&#x1D451;&Prime;</SPAN>';
althtmldef 'e"' as '<SPAN CLASS=set STYLE="color:red">&#x1D452;&Prime;</SPAN>';
althtmldef 'f"' as '<SPAN CLASS=set STYLE="color:red">&#x1D453;&Prime;</SPAN>';
althtmldef 'g"' as '<SPAN CLASS=set STYLE="color:red">&#x1D454;&Prime;</SPAN>';
althtmldef 'h"' as '<SPAN CLASS=set STYLE="color:red">&#x210E;&Prime;</SPAN>';
althtmldef 'i"' as '<SPAN CLASS=set STYLE="color:red">&#x1D456;&Prime;</SPAN>';
althtmldef 'j"' as '<SPAN CLASS=set STYLE="color:red">&#x1D457;&Prime;</SPAN>';
althtmldef 'k"' as '<SPAN CLASS=set STYLE="color:red">&#x1D458;&Prime;</SPAN>';
althtmldef 'l"' as '<SPAN CLASS=set STYLE="color:red">&#x1D459;&Prime;</SPAN>';
althtmldef 'm"' as '<SPAN CLASS=set STYLE="color:red">&#x1D45A;&Prime;</SPAN>';
althtmldef 'n"' as '<SPAN CLASS=set STYLE="color:red">&#x1D45B;&Prime;</SPAN>';
althtmldef 'o"_' as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;&Prime;</SPAN>';
althtmldef 'p"' as '<SPAN CLASS=set STYLE="color:red">&#x1D45D;&Prime;</SPAN>';
althtmldef 'q"' as '<SPAN CLASS=set STYLE="color:red">&#x1D45E;&Prime;</SPAN>';
althtmldef 'r"' as '<SPAN CLASS=set STYLE="color:red">&#x1D45F;&Prime;</SPAN>';
althtmldef 's"_' as
    '<SPAN CLASS=set STYLE="color:red">&#x1D460;&Prime;</SPAN>';
althtmldef 't"' as '<SPAN CLASS=set STYLE="color:red">&#x1D461;&Prime;</SPAN>';
althtmldef 'u"' as '<SPAN CLASS=set STYLE="color:red">&#x1D462;&Prime;</SPAN>';
althtmldef 'v"_' as
    '<SPAN CLASS=set STYLE="color:red">&#x1D463;&Prime;</SPAN>';
althtmldef 'w"' as '<SPAN CLASS=set STYLE="color:red">&#x1D464;&Prime;</SPAN>';
althtmldef 'x"' as '<SPAN CLASS=set STYLE="color:red">&#x1D465;&Prime;</SPAN>';
althtmldef 'y"' as '<SPAN CLASS=set STYLE="color:red">&#x1D466;&Prime;</SPAN>';
althtmldef 'z"' as '<SPAN CLASS=set STYLE="color:red">&#x1D467;&Prime;</SPAN>';
latexdef 'a"' as "a''";
latexdef 'b"' as "b''";
latexdef 'c"' as "c''";
latexdef 'd"' as "d''";
latexdef 'e"' as "e''";
latexdef 'f"' as "f''";
latexdef 'g"' as "g''";
latexdef 'h"' as "h''";
latexdef 'i"' as "i''";
latexdef 'j"' as "j''";
latexdef 'k"' as "k''";
latexdef 'l"' as "l''";
latexdef 'm"' as "m''";
latexdef 'n"' as "n''";
latexdef 'o"_' as "o''";
latexdef 'p"' as "p''";
latexdef 'q"' as "q''";
latexdef 'r"' as "r''";
latexdef 's"_' as "s''";
latexdef 't"' as "t''";
latexdef 'u"' as "u''";
latexdef 'v"_' as "v''";
latexdef 'w"' as "w''";
latexdef 'x"' as "x''";
latexdef 'y"' as "y''";
latexdef 'z"' as "z''";
htmldef "a0_"  as "<IMG SRC='_bnj_a0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' a0' TITLE='a0'>";
htmldef "b0_"  as "<IMG SRC='_bnj_b0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' b0' TITLE='b0'>";
htmldef "c0_" as "<IMG SRC='_bnj_c0.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' c0' TITLE='c0'>";
htmldef "d0"  as "<IMG SRC='_bnj_d0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' d0' TITLE='d0'>";
htmldef "e0"  as "<IMG SRC='_bnj_e0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' e0' TITLE='e0'>";
htmldef "f0_" as "<IMG SRC='_bnj_f0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' f0_' TITLE='f0_'>";
htmldef "g0"  as "<IMG SRC='_bnj_g0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' g0' TITLE='g0'>";
htmldef "h0"  as "<IMG SRC='_bnj_h0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' h0' TITLE='h0'>";
htmldef "i0"  as "<IMG SRC='_bnj_i0.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' i0' TITLE='i0'>";
htmldef "j0"  as "<IMG SRC='_bnj_j0.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' j0' TITLE='j0'>";
htmldef "k0"  as "<IMG SRC='_bnj_k0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' k0' TITLE='k0'>";
htmldef "l0"  as "<IMG SRC='_bnj_l0.gif' WIDTH=12 HEIGHT=19" +
    " ALT=' l0' TITLE='l0'>";
htmldef "m0"  as "<IMG SRC='_bnj_m0.gif' WIDTH=21 HEIGHT=19" +
    " ALT=' m0' TITLE='m0'>";
htmldef "n0_" as "<IMG SRC='_bnj_n0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' n0_' TITLE='n0_'>";
htmldef "o0_"  as "<IMG SRC='_bnj_o0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' o0_' TITLE='o0_'>";
htmldef "p0"  as "<IMG SRC='_bnj_p0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' p0' TITLE='p0'>";
htmldef "q0"  as "<IMG SRC='_bnj_q0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' q0' TITLE='q0'>";
htmldef "r0"  as "<IMG SRC='_bnj_r0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' r0' TITLE='r0'>";
htmldef "s0"  as "<IMG SRC='_bnj_s0.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' s0' TITLE='s0'>";
htmldef "t0"  as "<IMG SRC='_bnj_t0.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' t0' TITLE='t0'>";
htmldef "u0"  as "<IMG SRC='_bnj_u0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' u0' TITLE='u0'>";
htmldef "v0"  as "<IMG SRC='_bnj_v0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' v0' TITLE='v0'>";
htmldef "w0"  as "<IMG SRC='_bnj_w0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' w0' TITLE='w0'>";
htmldef "x0"  as "<IMG SRC='_bnj_x0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' x0' TITLE='x0'>";
htmldef "y0"  as "<IMG SRC='_bnj_y0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' y0' TITLE='y0'>";
htmldef "z0"  as "<IMG SRC='_bnj_z0.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' z0' TITLE='z0'>";
althtmldef "a0_"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44E;<SUB>0</SUB></SPAN>';
althtmldef "b0_"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44F;<SUB>0</SUB></SPAN>';
althtmldef "c0_" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D450;<SUB>0</SUB></SPAN>';
althtmldef "d0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D451;<SUB>0</SUB></SPAN>';
althtmldef "e0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D452;<SUB>0</SUB></SPAN>';
althtmldef "f0_" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D453;<SUB>0</SUB></SPAN>';
althtmldef "g0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D454;<SUB>0</SUB></SPAN>';
althtmldef "h0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x210E;<SUB>0</SUB></SPAN>';
althtmldef "i0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D456;<SUB>0</SUB></SPAN>';
althtmldef "j0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D457;<SUB>0</SUB></SPAN>';
althtmldef "k0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D458;<SUB>0</SUB></SPAN>';
althtmldef "l0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D459;<SUB>0</SUB></SPAN>';
althtmldef "m0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45A;<SUB>0</SUB></SPAN>';
althtmldef "n0_" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45B;<SUB>0</SUB></SPAN>';
althtmldef "o0_"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;<SUB>0</SUB></SPAN>';
althtmldef "p0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45D;<SUB>0</SUB></SPAN>';
althtmldef "q0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45E;<SUB>0</SUB></SPAN>';
althtmldef "r0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45F;<SUB>0</SUB></SPAN>';
althtmldef "s0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D460;<SUB>0</SUB></SPAN>';
althtmldef "t0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D461;<SUB>0</SUB></SPAN>';
althtmldef "u0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D462;<SUB>0</SUB></SPAN>';
althtmldef "v0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D463;<SUB>0</SUB></SPAN>';
althtmldef "w0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D464;<SUB>0</SUB></SPAN>';
althtmldef "x0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D465;<SUB>0</SUB></SPAN>';
althtmldef "y0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D466;<SUB>0</SUB></SPAN>';
althtmldef "z0"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D467;<SUB>0</SUB></SPAN>';
latexdef "a0_"  as "a_0";
latexdef "b0_"  as "b_0";
latexdef "c0_" as "c_0";
latexdef "d0"  as "d_0";
latexdef "e0"  as "e_0";
latexdef "f0_" as "f_0";
latexdef "g0"  as "g_0";
latexdef "h0"  as "h_0";
latexdef "i0"  as "i_0";
latexdef "j0"  as "j_0";
latexdef "k0"  as "k_0";
latexdef "l0"  as "l_0";
latexdef "m0"  as "m_0";
latexdef "n0_" as "n_0";
latexdef "o0_"  as "o_0";
latexdef "p0"  as "p_0";
latexdef "q0"  as "q_0";
latexdef "r0"  as "r_0";
latexdef "s0"  as "s_0";
latexdef "t0"  as "t_0";
latexdef "u0"  as "u_0";
latexdef "v0"  as "v_0";
latexdef "w0"  as "w_0";
latexdef "x0"  as "x_0";
latexdef "y0"  as "y_0";
latexdef "z0"  as "z_0";
htmldef "a1_"  as "<IMG SRC='_bnj_a1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' a1' TITLE='a1'>";
htmldef "b1_"  as "<IMG SRC='_bnj_b1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' b1' TITLE='b1'>";
htmldef "c1_" as "<IMG SRC='_bnj_c1.gif' WIDTH=12 HEIGHT=19" +
    " ALT=' c1_' TITLE='c1_'>";
htmldef "d1"  as "<IMG SRC='_bnj_d1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' d1' TITLE='d1'>";
htmldef "e1"  as "<IMG SRC='_bnj_e1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' e1' TITLE='e1'>";
htmldef "f1"  as "<IMG SRC='_bnj_f1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' f1' TITLE='f1'>";
htmldef "g1"  as "<IMG SRC='_bnj_g1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' g1' TITLE='g1'>";
htmldef "h1"  as "<IMG SRC='_bnj_h1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' h1' TITLE='h1'>";
htmldef "i1"  as "<IMG SRC='_bnj_i1.gif' WIDTH=11 HEIGHT=19" +
    " ALT=' i1' TITLE='i1'>";
htmldef "j1"  as "<IMG SRC='_bnj_j1.gif' WIDTH=12 HEIGHT=19" +
    " ALT=' j1' TITLE='j1'>";
htmldef "k1"  as "<IMG SRC='_bnj_k1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' k1' TITLE='k1'>";
htmldef "l1"  as "<IMG SRC='_bnj_l1.gif' WIDTH=10 HEIGHT=19" +
    " ALT=' l1' TITLE='l1'>";
htmldef "m1"  as "<IMG SRC='_bnj_m1.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' m1' TITLE='m1'>";
htmldef "n1"  as "<IMG SRC='_bnj_n1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' n1' TITLE='n1'>";
htmldef "o1_"  as "<IMG SRC='_bnj_o1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' o1_' TITLE='o1_'>";
htmldef "p1"  as "<IMG SRC='_bnj_p1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' p1' TITLE='p1'>";
htmldef "q1"  as "<IMG SRC='_bnj_q1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' q1' TITLE='q1'>";
htmldef "r1"  as "<IMG SRC='_bnj_r1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' r1' TITLE='r1'>";
htmldef "s1"  as "<IMG SRC='_bnj_s1.gif' WIDTH=12 HEIGHT=19" +
    " ALT=' s1' TITLE='s1'>";
htmldef "t1"  as "<IMG SRC='_bnj_t1.gif' WIDTH=12 HEIGHT=19" +
    " ALT=' t1' TITLE='t1'>";
htmldef "u1"  as "<IMG SRC='_bnj_u1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' u1' TITLE='u1'>";
htmldef "v1"  as "<IMG SRC='_bnj_v1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' v1' TITLE='v1'>";
htmldef "w1"  as "<IMG SRC='_bnj_w1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' w1' TITLE='w1'>";
htmldef "x1"  as "<IMG SRC='_bnj_x1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' x1' TITLE='x1'>";
htmldef "y1"  as "<IMG SRC='_bnj_y1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' y1' TITLE='y1'>";
htmldef "z1"  as "<IMG SRC='_bnj_z1.gif' WIDTH=14 HEIGHT=19" +
    " ALT=' z1' TITLE='z1'>";
althtmldef "a1_"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44E;<SUB>1</SUB></SPAN>';
althtmldef "b1_"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D44F;<SUB>1</SUB></SPAN>';
althtmldef "c1_" as
    '<SPAN CLASS=set STYLE="color:red">&#x1D450;<SUB>1</SUB></SPAN>';
althtmldef "d1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D451;<SUB>1</SUB></SPAN>';
althtmldef "e1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D452;<SUB>1</SUB></SPAN>';
althtmldef "f1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D453;<SUB>1</SUB></SPAN>';
althtmldef "g1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D454;<SUB>1</SUB></SPAN>';
althtmldef "h1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x210E;<SUB>1</SUB></SPAN>';
althtmldef "i1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D456;<SUB>1</SUB></SPAN>';
althtmldef "j1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D457;<SUB>1</SUB></SPAN>';
althtmldef "k1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D458;<SUB>1</SUB></SPAN>';
althtmldef "l1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D459;<SUB>1</SUB></SPAN>';
althtmldef "m1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45A;<SUB>1</SUB></SPAN>';
althtmldef "n1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45B;<SUB>1</SUB></SPAN>';
althtmldef "o1_"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45C;<SUB>1</SUB></SPAN>';
althtmldef "p1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45D;<SUB>1</SUB></SPAN>';
althtmldef "q1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45E;<SUB>1</SUB></SPAN>';
althtmldef "r1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D45F;<SUB>1</SUB></SPAN>';
althtmldef "s1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D460;<SUB>1</SUB></SPAN>';
althtmldef "t1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D461;<SUB>1</SUB></SPAN>';
althtmldef "u1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D462;<SUB>1</SUB></SPAN>';
althtmldef "v1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D463;<SUB>1</SUB></SPAN>';
althtmldef "w1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D464;<SUB>1</SUB></SPAN>';
althtmldef "x1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D465;<SUB>1</SUB></SPAN>';
althtmldef "y1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D466;<SUB>1</SUB></SPAN>';
althtmldef "z1"  as
    '<SPAN CLASS=set STYLE="color:red">&#x1D467;<SUB>1</SUB></SPAN>';
latexdef "a1_"  as "a_1";
latexdef "b1_"  as "b_1";
latexdef "c1_" as "c_1";
latexdef "d1"  as "d_1";
latexdef "e1"  as "e_1";
latexdef "f1"  as "f_1";
latexdef "g1"  as "g_1";
latexdef "h1"  as "h_1";
latexdef "i1"  as "i_1";
latexdef "j1"  as "j_1";
latexdef "k1"  as "k_1";
latexdef "l1"  as "l_1";
latexdef "m1"  as "m_1";
latexdef "n1"  as "n_1";
latexdef "o1_"  as "o_1";
latexdef "p1"  as "p_1";
latexdef "q1"  as "q_1";
latexdef "r1"  as "r_1";
latexdef "s1"  as "s_1";
latexdef "t1"  as "t_1";
latexdef "u1"  as "u_1";
latexdef "v1"  as "v_1";
latexdef "w1"  as "w_1";
latexdef "x1"  as "x_1";
latexdef "y1"  as "y_1";
latexdef "z1"  as "z_1";
htmldef "A'" as "<IMG SRC='_bnj_caPrime.gif' WIDTH=15 HEIGHT=19" +
    " ALT=" + '"' + " A'" + '"' + " TITLE=" + '"' + "A'" + '"' + ">";
htmldef "B'" as "<IMG SRC='_bnj_cbPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " B'" + '"' + " TITLE=" + '"' + "B'" + '"' + ">";
htmldef "C'" as "<IMG SRC='_bnj_ccPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " C'" + '"' + " TITLE=" + '"' + "C'" + '"' + ">";
htmldef "D'" as "<IMG SRC='_bnj_cdPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " D'" + '"' + " TITLE=" + '"' + "D'" + '"' + ">";
htmldef "E'" as "<IMG SRC='_bnj_cePrime.gif' WIDTH=17 HEIGHT=19" +
    " ALT=" + '"' + " E'" + '"' + " TITLE=" + '"' + "E'" + '"' + ">";
htmldef "F'" as "<IMG SRC='_bnj_cfPrime.gif' WIDTH=17 HEIGHT=19" +
    " ALT=" + '"' + " F'" + '"' + " TITLE=" + '"' + "F'" + '"' + ">";
htmldef "G'" as "<IMG SRC='_bnj_cgPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " G'" + '"' + " TITLE=" + '"' + "G'" + '"' + ">";
htmldef "H'" as "<IMG SRC='_bnj_chPrime.gif' WIDTH=18 HEIGHT=19" +
    " ALT=" + '"' + " H'" + '"' + " TITLE=" + '"' + "H'" + '"' + ">";
htmldef "I'" as "<IMG SRC='_bnj_ciPrime.gif' WIDTH=12 HEIGHT=19" +
    " ALT=" + '"' + " I'" + '"' + " TITLE=" + '"' + "I'" + '"' + ">";
htmldef "J'" as "<IMG SRC='_bnj_cjPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " J'" + '"' + " TITLE=" + '"' + "J'" + '"' + ">";
htmldef "K'" as "<IMG SRC='_bnj_ckPrime.gif' WIDTH=18 HEIGHT=19" +
    " ALT=" + '"' + " K'" + '"' + " TITLE=" + '"' + "K'" + '"' + ">";
htmldef "L'" as "<IMG SRC='_bnj_clPrime.gif' WIDTH=14 HEIGHT=19" +
    " ALT=" + '"' + " L'" + '"' + " TITLE=" + '"' + "L'" + '"' + ">";
htmldef "M'" as "<IMG SRC='_bnj_cmPrime.gif' WIDTH=19 HEIGHT=19" +
    " ALT=" + '"' + " M'" + '"' + " TITLE=" + '"' + "M'" + '"' + ">";
htmldef "N'" as "<IMG SRC='_bnj_cnPrime.gif' WIDTH=18 HEIGHT=19" +
    " ALT=" + '"' + " N'" + '"' + " TITLE=" + '"' + "N'" + '"' + ">";
htmldef "O'" as "<IMG SRC='_bnj_coPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " O'" + '"' + " TITLE=" + '"' + "O'" + '"' + ">";
htmldef "P'" as "<IMG SRC='_bnj_cpPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " P'" + '"' + " TITLE=" + '"' + "P'" + '"' + ">";
htmldef "Q'" as "<IMG SRC='_bnj_cqPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " Q'" + '"' + " TITLE=" + '"' + "Q'" + '"' + ">";
htmldef "R'" as "<IMG SRC='_bnj_crPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " R'" + '"' + " TITLE=" + '"' + "R'" + '"' + ">";
htmldef "S'" as "<IMG SRC='_bnj_csPrime.gif' WIDTH=15 HEIGHT=19" +
    " ALT=" + '"' + " S'" + '"' + " TITLE=" + '"' + "S'" + '"' + ">";
htmldef "T'" as "<IMG SRC='_bnj_ctPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " T'" + '"' + " TITLE=" + '"' + "T'" + '"' + ">";
htmldef "U'" as "<IMG SRC='_bnj_cuPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " U'" + '"' + " TITLE=" + '"' + "U'" + '"' + ">";
htmldef "V'" as "<IMG SRC='_bnj_cvPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " V'" + '"' + " TITLE=" + '"' + "V'" + '"' + ">";
htmldef "W'" as "<IMG SRC='_bnj_cwPrime.gif' WIDTH=20 HEIGHT=19" +
    " ALT=" + '"' + " W'" + '"' + " TITLE=" + '"' + "W'" + '"' + ">";
htmldef "X'" as "<IMG SRC='_bnj_cxPrime.gif' WIDTH=17 HEIGHT=19" +
    " ALT=" + '"' + " X'" + '"' + " TITLE=" + '"' + "X'" + '"' + ">";
htmldef "Y'" as "<IMG SRC='_bnj_cyPrime.gif' WIDTH=16 HEIGHT=19" +
    " ALT=" + '"' + " Y'" + '"' + " TITLE=" + '"' + "Y'" + '"' + ">";
htmldef "Z'" as "<IMG SRC='_bnj_czPrime.gif' WIDTH=15 HEIGHT=19" +
    " ALT=" + '"' + " Z'" + '"' + " TITLE=" + '"' + "Z'" + '"' + ">";
althtmldef "A'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;&prime;</SPAN>';
althtmldef "B'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;&prime;</SPAN>';
althtmldef "C'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;&prime;</SPAN>';
althtmldef "D'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;&prime;</SPAN>';
althtmldef "E'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D438;&prime;</SPAN>';
althtmldef "F'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;&prime;</SPAN>';
althtmldef "G'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;&prime;</SPAN>';
althtmldef "H'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;&prime;</SPAN>';
althtmldef "I'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;&prime;</SPAN>';
althtmldef "J'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43D;&prime;</SPAN>';
althtmldef "K'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43E;&prime;</SPAN>';
althtmldef "L'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;&prime;</SPAN>';
althtmldef "M'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;&prime;</SPAN>';
althtmldef "N'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D441;&prime;</SPAN>';
althtmldef "O'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;&prime;</SPAN>';
althtmldef "P'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D443;&prime;</SPAN>';
althtmldef "Q'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D444;&prime;</SPAN>';
althtmldef "R'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D445;&prime;</SPAN>';
althtmldef "S'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;&prime;</SPAN>';
althtmldef "T'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D447;&prime;</SPAN>';
althtmldef "U'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D448;&prime;</SPAN>';
althtmldef "V'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;&prime;</SPAN>';
althtmldef "W'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44A;&prime;</SPAN>';
althtmldef "X'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44B;&prime;</SPAN>';
althtmldef "Y'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44C;&prime;</SPAN>';
althtmldef "Z'" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44D;&prime;</SPAN>';
latexdef "A'" as "A'";
latexdef "B'" as "B'";
latexdef "C'" as "C'";
latexdef "D'" as "D'";
latexdef "E'" as "E'";
latexdef "F'" as "F'";
latexdef "G'" as "G'";
latexdef "H'" as "H'";
latexdef "I'" as "I'";
latexdef "J'" as "J'";
latexdef "K'" as "K'";
latexdef "L'" as "L'";
latexdef "M'" as "M'";
latexdef "N'" as "N'";
latexdef "O'" as "O'";
latexdef "P'" as "P'";
latexdef "Q'" as "Q'";
latexdef "R'" as "R'";
latexdef "S'" as "S'";
latexdef "T'" as "T'";
latexdef "U'" as "U'";
latexdef "V'" as "V'";
latexdef "W'" as "W'";
latexdef "X'" as "X'";
latexdef "Y'" as "Y'";
latexdef "Z'" as "Z'";
htmldef 'A"' as "<IMG SRC='_bnj_caPrimePrime.gif' WIDTH=18 HEIGHT=19 " +
      " ALT=' A" + '"' + "'TITLE='A" + '"' + "'>";
htmldef 'B"' as "<IMG SRC='_bnj_cbPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' B" + '"' + "'TITLE='B" + '"' + "'>";
htmldef 'C"' as "<IMG SRC='_bnj_ccPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' C" + '"' + "'TITLE='C" + '"' + "'>";
htmldef 'D"' as "<IMG SRC='_bnj_cdPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' D" + '"' + "'TITLE='D" + '"' + "'>";
htmldef 'E"' as "<IMG SRC='_bnj_cePrimePrime.gif' WIDTH=20 HEIGHT=19 " +
      " ALT=' E" + '"' + "'TITLE='E" + '"' + "'>";
htmldef 'F"' as "<IMG SRC='_bnj_cfPrimePrime.gif' WIDTH=20 HEIGHT=19 " +
      " ALT=' F" + '"' + "'TITLE='F" + '"' + "'>";
htmldef 'G"' as "<IMG SRC='_bnj_cgPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' G" + '"' + "'TITLE='G" + '"' + "'>";
htmldef 'H"' as "<IMG SRC='_bnj_chPrimePrime.gif' WIDTH=21 HEIGHT=19 " +
      " ALT=' H" + '"' + "'TITLE='H" + '"' + "'>";
htmldef 'I"' as "<IMG SRC='_bnj_ciPrimePrime.gif' WIDTH=15 HEIGHT=19 " +
      " ALT=' I" + '"' + "'TITLE='I" + '"' + "'>";
htmldef 'J"' as "<IMG SRC='_bnj_cjPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' J" + '"' + "'TITLE='J" + '"' + "'>";
htmldef 'K"' as "<IMG SRC='_bnj_ckPrimePrime.gif' WIDTH=21 HEIGHT=19 " +
      " ALT=' K" + '"' + "'TITLE='K" + '"' + "'>";
htmldef 'L"' as "<IMG SRC='_bnj_clPrimePrime.gif' WIDTH=17 HEIGHT=19 " +
      " ALT=' L" + '"' + "'TITLE='L" + '"' + "'>";
htmldef 'M"' as "<IMG SRC='_bnj_cmPrimePrime.gif' WIDTH=22 HEIGHT=19 " +
      " ALT=' M" + '"' + "'TITLE='M" + '"' + "'>";
htmldef 'N"' as "<IMG SRC='_bnj_cnPrimePrime.gif' WIDTH=21 HEIGHT=19 " +
      " ALT=' N" + '"' + "'TITLE='N" + '"' + "'>";
htmldef 'O"' as "<IMG SRC='_bnj_coPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' O" + '"' + "'TITLE='O" + '"' + "'>";
htmldef 'P"' as "<IMG SRC='_bnj_cpPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' P" + '"' + "'TITLE='P" + '"' + "'>";
htmldef 'Q"' as "<IMG SRC='_bnj_cqPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' Q" + '"' + "'TITLE='Q" + '"' + "'>";
htmldef 'R"' as "<IMG SRC='_bnj_crPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' R" + '"' + "'TITLE='R" + '"' + "'>";
htmldef 'S"' as "<IMG SRC='_bnj_csPrimePrime.gif' WIDTH=18 HEIGHT=19 " +
      " ALT=' S" + '"' + "'TITLE='S" + '"' + "'>";
htmldef 'T"' as "<IMG SRC='_bnj_ctPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' T" + '"' + "'TITLE='T" + '"' + "'>";
htmldef 'U"' as "<IMG SRC='_bnj_cuPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' U" + '"' + "'TITLE='U" + '"' + "'>";
htmldef 'V"' as "<IMG SRC='_bnj_cvPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' V" + '"' + "'TITLE='V" + '"' + "'>";
htmldef 'W"' as "<IMG SRC='_bnj_cwPrimePrime.gif' WIDTH=23 HEIGHT=19 " +
      " ALT=' W" + '"' + "'TITLE='W" + '"' + "'>";
htmldef 'X"' as "<IMG SRC='_bnj_cxPrimePrime.gif' WIDTH=20 HEIGHT=19 " +
      " ALT=' X" + '"' + "'TITLE='X" + '"' + "'>";
htmldef 'Y"' as "<IMG SRC='_bnj_cyPrimePrime.gif' WIDTH=19 HEIGHT=19 " +
      " ALT=' Y" + '"' + "'TITLE='Y" + '"' + "'>";
htmldef 'Z"' as "<IMG SRC='_bnj_czPrimePrime.gif' WIDTH=18 HEIGHT=19 " +
      " ALT=' Z" + '"' + "'TITLE='Z" + '"' + "'>";
althtmldef 'A"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;&Prime;</SPAN>';
althtmldef 'B"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;&Prime;</SPAN>';
althtmldef 'C"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;&Prime;</SPAN>';
althtmldef 'D"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;&Prime;</SPAN>';
althtmldef 'E"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D438;&Prime;</SPAN>';
althtmldef 'F"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;&Prime;</SPAN>';
althtmldef 'G"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;&Prime;</SPAN>';
althtmldef 'H"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;&Prime;</SPAN>';
althtmldef 'I"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;&Prime;</SPAN>';
althtmldef 'J"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43D;&Prime;</SPAN>';
althtmldef 'K"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43E;&Prime;</SPAN>';
althtmldef 'L"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;&Prime;</SPAN>';
althtmldef 'M"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;&Prime;</SPAN>';
althtmldef 'N"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D441;&Prime;</SPAN>';
althtmldef 'O"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;&Prime;</SPAN>';
althtmldef 'P"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D443;&Prime;</SPAN>';
althtmldef 'Q"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D444;&Prime;</SPAN>';
althtmldef 'R"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D445;&Prime;</SPAN>';
althtmldef 'S"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;&Prime;</SPAN>';
althtmldef 'T"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D447;&Prime;</SPAN>';
althtmldef 'U"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D448;&Prime;</SPAN>';
althtmldef 'V"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;&Prime;</SPAN>';
althtmldef 'W"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44A;&Prime;</SPAN>';
althtmldef 'X"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44B;&Prime;</SPAN>';
althtmldef 'Y"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44C;&Prime;</SPAN>';
althtmldef 'Z"' as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44D;&Prime;</SPAN>';
latexdef 'A"' as "A''";
latexdef 'B"' as "B''";
latexdef 'C"' as "C''";
latexdef 'D"' as "D''";
latexdef 'E"' as "E''";
latexdef 'F"' as "F''";
latexdef 'G"' as "G''";
latexdef 'H"' as "H''";
latexdef 'I"' as "I''";
latexdef 'J"' as "J''";
latexdef 'K"' as "K''";
latexdef 'L"' as "L''";
latexdef 'M"' as "M''";
latexdef 'N"' as "N''";
latexdef 'O"' as "O''";
latexdef 'P"' as "P''";
latexdef 'Q"' as "Q''";
latexdef 'R"' as "R''";
latexdef 'S"' as "S''";
latexdef 'T"' as "T''";
latexdef 'U"' as "U''";
latexdef 'V"' as "V''";
latexdef 'W"' as "W''";
latexdef 'X"' as "X''";
latexdef 'Y"' as "Y''";
latexdef 'Z"' as "Z''";
htmldef "A0" as "<IMG SRC='_bnj_ca0.gif' WIDTH=18 HEIGHT=19" +
    " ALT=' A0' TITLE='A0'>";
htmldef "B0" as "<IMG SRC='_bnj_cb0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' B0' TITLE='B0'>";
htmldef "C0" as "<IMG SRC='_bnj_cc0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' C0' TITLE='C0'>";
htmldef "D0" as "<IMG SRC='_bnj_cd0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' D0' TITLE='D0'>";
htmldef "E0" as "<IMG SRC='_bnj_ce0.gif' WIDTH=20 HEIGHT=19" +
    " ALT=' E0' TITLE='E0'>";
htmldef "F0" as "<IMG SRC='_bnj_cf0.gif' WIDTH=20 HEIGHT=19" +
    " ALT=' F0' TITLE='F0'>";
htmldef "G0" as "<IMG SRC='_bnj_cg0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' G0' TITLE='G0'>";
htmldef "H0" as "<IMG SRC='_bnj_ch0.gif' WIDTH=21 HEIGHT=19" +
    " ALT=' H0' TITLE='H0'>";
htmldef "I0" as "<IMG SRC='_bnj_ci0.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' I0' TITLE='I0'>";
htmldef "J0" as "<IMG SRC='_bnj_cj0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' J0' TITLE='J0'>";
htmldef "K0" as "<IMG SRC='_bnj_ck0.gif' WIDTH=21 HEIGHT=19" +
    " ALT=' K0' TITLE='K0'>";
htmldef "L0" as "<IMG SRC='_bnj_cl0.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' L0' TITLE='L0'>";
htmldef "M0" as "<IMG SRC='_bnj_cm0.gif' WIDTH=22 HEIGHT=19" +
    " ALT=' M0' TITLE='M0'>";
htmldef "N0" as "<IMG SRC='_bnj_cn0.gif' WIDTH=21 HEIGHT=19" +
    " ALT=' N0' TITLE='N0'>";
htmldef "O0" as "<IMG SRC='_bnj_co0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' O0' TITLE='O0'>";
htmldef "P0" as "<IMG SRC='_bnj_cp0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' P0' TITLE='P0'>";
htmldef "Q0" as "<IMG SRC='_bnj_cq0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' Q0' TITLE='Q0'>";
htmldef "R0" as "<IMG SRC='_bnj_cr0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' R0' TITLE='R0'>";
htmldef "S0" as "<IMG SRC='_bnj_cs0.gif' WIDTH=18 HEIGHT=19" +
    " ALT=' S0' TITLE='S0'>";
htmldef "T0" as "<IMG SRC='_bnj_ct0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' T0' TITLE='T0'>";
htmldef "U0" as "<IMG SRC='_bnj_cu0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' U0' TITLE='U0'>";
htmldef "V0" as "<IMG SRC='_bnj_cv0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' V0' TITLE='V0'>";
htmldef "W0" as "<IMG SRC='_bnj_cw0.gif' WIDTH=23 HEIGHT=19" +
    " ALT=' W0' TITLE='W0'>";
htmldef "X0" as "<IMG SRC='_bnj_cx0.gif' WIDTH=20 HEIGHT=19" +
    " ALT=' X0' TITLE='X0'>";
htmldef "Y0" as "<IMG SRC='_bnj_cy0.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' Y0' TITLE='Y0'>";
htmldef "Z0" as "<IMG SRC='_bnj_cz0.gif' WIDTH=18 HEIGHT=19" +
    " ALT=' Z0' TITLE='Z0'>";
althtmldef "A0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;<SUB>0</SUB></SPAN>';
althtmldef "B0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;<SUB>0</SUB></SPAN>';
althtmldef "C0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;<SUB>0</SUB></SPAN>';
althtmldef "D0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;<SUB>0</SUB></SPAN>';
althtmldef "E0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D438;<SUB>0</SUB></SPAN>';
althtmldef "F0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;<SUB>0</SUB></SPAN>';
althtmldef "G0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;<SUB>0</SUB></SPAN>';
althtmldef "H0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;<SUB>0</SUB></SPAN>';
althtmldef "I0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;<SUB>0</SUB></SPAN>';
althtmldef "J0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43D;<SUB>0</SUB></SPAN>';
althtmldef "K0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43E;<SUB>0</SUB></SPAN>';
althtmldef "L0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;<SUB>0</SUB></SPAN>';
althtmldef "M0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;<SUB>0</SUB></SPAN>';
althtmldef "N0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D441;<SUB>0</SUB></SPAN>';
althtmldef "O0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;<SUB>0</SUB></SPAN>';
althtmldef "P0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D443;<SUB>0</SUB></SPAN>';
althtmldef "Q0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D444;<SUB>0</SUB></SPAN>';
althtmldef "R0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D445;<SUB>0</SUB></SPAN>';
althtmldef "S0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;<SUB>0</SUB></SPAN>';
althtmldef "T0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D447;<SUB>0</SUB></SPAN>';
althtmldef "U0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D448;<SUB>0</SUB></SPAN>';
althtmldef "V0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;<SUB>0</SUB></SPAN>';
althtmldef "W0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44A;<SUB>0</SUB></SPAN>';
althtmldef "X0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44B;<SUB>0</SUB></SPAN>';
althtmldef "Y0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44C;<SUB>0</SUB></SPAN>';
althtmldef "Z0" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44D;<SUB>0</SUB></SPAN>';
latexdef "A0" as "A_0";
latexdef "B0" as "B_0";
latexdef "C0" as "C_0";
latexdef "D0" as "D_0";
latexdef "E0" as "E_0";
latexdef "F0" as "F_0";
latexdef "G0" as "G_0";
latexdef "H0" as "H_0";
latexdef "I0" as "I_0";
latexdef "J0" as "J_0";
latexdef "K0" as "K_0";
latexdef "L0" as "L_0";
latexdef "M0" as "M_0";
latexdef "N0" as "N_0";
latexdef "O0" as "O_0";
latexdef "P0" as "P_0";
latexdef "Q0" as "Q_0";
latexdef "R0" as "R_0";
latexdef "S0" as "S_0";
latexdef "T0" as "T_0";
latexdef "U0" as "U_0";
latexdef "V0" as "V_0";
latexdef "W0" as "W_0";
latexdef "X0" as "X_0";
latexdef "Y0" as "Y_0";
latexdef "Z0" as "Z_0";
htmldef "A1_"  as "<IMG SRC='_bnj_ca1.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' A1' TITLE='A1'>";
htmldef "B1_"  as "<IMG SRC='_bnj_cb1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' B1' TITLE='B1'>";
htmldef "C1_"  as "<IMG SRC='_bnj_cc1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' C1' TITLE='C1'>";
htmldef "D1_"  as "<IMG SRC='_bnj_cd1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' D1' TITLE='D1'>";
htmldef "E1"  as "<IMG SRC='_bnj_ce1.gif' WIDTH=18 HEIGHT=19" +
    " ALT=' E1' TITLE='E1'>";
htmldef "F1_"  as "<IMG SRC='_bnj_cf1.gif' WIDTH=18 HEIGHT=19" +
    " ALT=' F1' TITLE='F1'>";
htmldef "G1_"  as "<IMG SRC='_bnj_cg1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' G1' TITLE='G1'>";
htmldef "H1_"  as "<IMG SRC='_bnj_ch1.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' H1' TITLE='H1'>";
htmldef "I1_"  as "<IMG SRC='_bnj_ci1.gif' WIDTH=13 HEIGHT=19" +
    " ALT=' I1' TITLE='I1'>";
htmldef "J1"  as "<IMG SRC='_bnj_cj1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' J1' TITLE='J1'>";
htmldef "K1"  as "<IMG SRC='_bnj_ck1.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' K1' TITLE='K1'>";
htmldef "L1_"  as "<IMG SRC='_bnj_cl1.gif' WIDTH=15 HEIGHT=19" +
    " ALT=' L1' TITLE='L1'>";
htmldef "M1_"  as "<IMG SRC='_bnj_cm1.gif' WIDTH=20 HEIGHT=19" +
    " ALT=' M1' TITLE='M1'>";
htmldef "N1"  as "<IMG SRC='_bnj_cn1.gif' WIDTH=19 HEIGHT=19" +
    " ALT=' N1' TITLE='N1'>";
htmldef "O1_"  as "<IMG SRC='_bnj_co1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' O1_' TITLE='O1_'>";
htmldef "P1"  as "<IMG SRC='_bnj_cp1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' P1' TITLE='P1'>";
htmldef "Q1"  as "<IMG SRC='_bnj_cq1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' Q1' TITLE='Q1'>";
htmldef "R1_" as "<IMG SRC='_bnj_cr1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' R1_' TITLE='R1_'>";
htmldef "S1_"  as "<IMG SRC='_bnj_cs1.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' S1' TITLE='S1'>";
htmldef "T1"  as "<IMG SRC='_bnj_ct1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' T1' TITLE='T1'>";
htmldef "U1"  as "<IMG SRC='_bnj_cu1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' U1' TITLE='U1'>";
htmldef "V1_"  as "<IMG SRC='_bnj_cv1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' V1' TITLE='V1'>";
htmldef "W1"  as "<IMG SRC='_bnj_cw1.gif' WIDTH=21 HEIGHT=19" +
    " ALT=' W1' TITLE='W1'>";
htmldef "X1"  as "<IMG SRC='_bnj_cx1.gif' WIDTH=18 HEIGHT=19" +
    " ALT=' X1' TITLE='X1'>";
htmldef "Y1"  as "<IMG SRC='_bnj_cy1.gif' WIDTH=17 HEIGHT=19" +
    " ALT=' Y1' TITLE='Y1'>";
htmldef "Z1"  as "<IMG SRC='_bnj_cz1.gif' WIDTH=16 HEIGHT=19" +
    " ALT=' Z1' TITLE='Z1'>";
althtmldef "A1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D434;<SUB>1</SUB></SPAN>';
althtmldef "B1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D435;<SUB>1</SUB></SPAN>';
althtmldef "C1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D436;<SUB>1</SUB></SPAN>';
althtmldef "D1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D437;<SUB>1</SUB></SPAN>';
althtmldef "E1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D438;<SUB>1</SUB></SPAN>';
althtmldef "F1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D439;<SUB>1</SUB></SPAN>';
althtmldef "G1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43A;<SUB>1</SUB></SPAN>';
althtmldef "H1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43B;<SUB>1</SUB></SPAN>';
althtmldef "I1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43C;<SUB>1</SUB></SPAN>';
althtmldef "J1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43D;<SUB>1</SUB></SPAN>';
althtmldef "K1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43E;<SUB>1</SUB></SPAN>';
althtmldef "L1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D43F;<SUB>1</SUB></SPAN>';
althtmldef "M1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D440;<SUB>1</SUB></SPAN>';
althtmldef "N1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D441;<SUB>1</SUB></SPAN>';
althtmldef "O1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D442;<SUB>1</SUB></SPAN>';
althtmldef "P1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D443;<SUB>1</SUB></SPAN>';
althtmldef "Q1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D444;<SUB>1</SUB></SPAN>';
althtmldef "R1_" as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D445;<SUB>1</SUB></SPAN>';
althtmldef "S1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D446;<SUB>1</SUB></SPAN>';
althtmldef "T1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D447;<SUB>1</SUB></SPAN>';
althtmldef "U1"  as
   '<SPAN CLASS=class STYLE="color:#C3C">&#x1D448;<SUB>1</SUB></SPAN>';
althtmldef "V1_"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D449;<SUB>1</SUB></SPAN>';
althtmldef "W1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44A;<SUB>1</SUB></SPAN>';
althtmldef "X1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44B;<SUB>1</SUB></SPAN>';
althtmldef "Y1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44C;<SUB>1</SUB></SPAN>';
althtmldef "Z1"  as
    '<SPAN CLASS=class STYLE="color:#C3C">&#x1D44D;<SUB>1</SUB></SPAN>';
latexdef "A1_"  as "A_1";
latexdef "B1_"  as "B_1";
latexdef "C1_"  as "C_1";
latexdef "D1_"  as "D_1";
latexdef "E1"  as "E_1";
latexdef "F1_"  as "F_1";
latexdef "G1_"  as "G_1";
latexdef "H1_"  as "H_1";
latexdef "I1_"  as "I_1";
latexdef "J1"  as "J_1";
latexdef "K1"  as "K_1";
latexdef "L1_"  as "L_1";
latexdef "M1_"  as "M_1";
latexdef "N1"  as "N_1";
latexdef "O1_"  as "O_1";
latexdef "P1"  as "P_1";
latexdef "Q1"  as "Q_1";
latexdef "R1_" as "R_1";
latexdef "S1_"  as "S_1";
latexdef "T1"  as "T_1";
latexdef "U1"  as "U_1";
latexdef "V1_"  as "V_1";
latexdef "W1"  as "W_1";
latexdef "X1"  as "X_1";
latexdef "Y1"  as "Y_1";
latexdef "Z1"  as "Z_1";
/*
htmldef "_fns" as
    " <IMG SRC='_fns.gif' WIDTH=19 HEIGHT=19 ALT=' fns' TITLE='fns'> ";
  althtmldef "_fns" as " fns ";
  latexdef "_fns" as "{\rm fns\;}";
*/
htmldef "_pred" as
    " <IMG SRC='_pred.gif' WIDTH=30 HEIGHT=19 ALT=' pred' TITLE='pred'>";
  althtmldef "_pred" as " pred";
  latexdef "_pred" as "{\rm pred}";
htmldef "_Se" as
    " <IMG SRC='_cse.gif' WIDTH=15 HEIGHT=19 ALT=' Se' TITLE='Se'> ";
  althtmldef "_Se" as " Se ";
  latexdef "_Se" as "{\rm \;Se\;}";
htmldef "_FrSe" as
    " <IMG SRC='_frse.gif' WIDTH=30 HEIGHT=19 ALT=' FrSe' TITLE='FrSe'> ";
  althtmldef "_FrSe" as " FrSe ";
  latexdef "_FrSe" as "{\rm \;FrSe\;}";
htmldef "_trCl" as
    " <IMG SRC='_trcl.gif' WIDTH=26 HEIGHT=19 ALT=' trCl' TITLE='trCl'>";
  althtmldef "_trCl" as " trCl";
  latexdef "_trCl" as "{\rm trCl}";
htmldef "_TrFo" as
    " <IMG SRC='_trfo.gif' WIDTH=32 HEIGHT=19 ALT=' TrFo' TITLE='TrFo'>";
  althtmldef "_TrFo" as " TrFo";
  latexdef "_TrFo" as "{\rm TrFo}";
/* End of Jonathan Ben-Naim's mathbox */

/* Mathbox of Norm Megill */
htmldef "LSAtoms" as "LSAtoms";
  althtmldef "LSAtoms" as "LSAtoms";
  latexdef "LSAtoms" as "{\rm LSAtoms}";
htmldef "LSHyp" as "LSHyp";
  althtmldef "LSHyp" as "LSHyp";
  latexdef "LSHyp" as "{\rm LSHyp}";
htmldef "<oL" as
    " <IMG SRC='lessdot.gif' WIDTH=11 HEIGHT=19 "
    + "ALT=' &lt;oL' TITLE='&lt;oL'><SUB>L</SUB> ";
  althtmldef "<oL" as ' &#8918;<SUB>L</SUB> ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "<oL" as "\lessdot_{\rm L}";
htmldef "LFnl" as "LFnl";
  althtmldef "LFnl" as "LFnl";
  latexdef "LFnl" as "{\rm LFnl}";
htmldef "LKer" as "LKer";
  althtmldef "LKer" as "LKer";
  latexdef "LKer" as "{\rm LKer}";
htmldef "LDual" as "LDual";
  althtmldef "LDual" as "LDual";
  latexdef "LDual" as "{\rm LDual}";
htmldef "OP" as "<IMG SRC='_op.gif' WIDTH=20 HEIGHT=19 ALT=' OP' TITLE='OP'>";
  althtmldef "OP" as "OP";
  latexdef "OP" as "{\rm OP}";
htmldef "cm" as
    "<IMG SRC='_rmcm.gif' WIDTH=19 HEIGHT=19 ALT=' cm' TITLE='cm'>";
  althtmldef "cm" as "cm";
  latexdef "cm" as "{\rm cm}";
htmldef "OL" as "<IMG SRC='_ol.gif' WIDTH=20 HEIGHT=19 ALT=' OL' TITLE='OL'>";
  althtmldef "OL" as "OL";
  latexdef "OL" as "{\rm OL}";
htmldef "OML" as
    "<IMG SRC='_oml.gif' WIDTH=32 HEIGHT=19 ALT=' OML' TITLE='OML'>";
  althtmldef "OML" as "OML";
  latexdef "OML" as "{\rm OML}";
htmldef "<o" as
    " <IMG SRC='lessdot.gif' WIDTH=11 HEIGHT=19 "
    + "ALT=' &lt;o' TITLE='&lt;o'> ";
  althtmldef "<o" as ' &#8918; ';
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "<o" as '\lessdot';
htmldef "Atoms" as
    "<IMG SRC='_atoms.gif' WIDTH=41 HEIGHT=19 ALT=' Atoms' TITLE='Atoms'>";
  althtmldef "Atoms" as "Atoms";
  latexdef "Atoms" as "{\rm Atoms}";
htmldef "AtLat" as
    "<IMG SRC='_atlat.gif' WIDTH=39 HEIGHT=19 ALT=' AtLat' TITLE='AtLat'>";
  althtmldef "AtLat" as "AtLat";
  latexdef "AtLat" as "{\rm AtLat}";
/*
htmldef "AtsLat" as "AtsLat"; althtmldef "AtsLat" as "AtsLat";
*/
htmldef "CvLat" as
    "<IMG SRC='_cvlat.gif' WIDTH=41 HEIGHT=19 ALT=' CvLat' TITLE='CvLat'>";
  althtmldef "CvLat" as "CvLat";
  latexdef "CvLat" as "{\rm CvLat}";
htmldef "HL" as "<IMG SRC='_hl.gif' WIDTH=19 HEIGHT=19 ALT=' HL' TITLE='HL'>";
  althtmldef "HL" as "HL";
  latexdef "HL" as "{\rm HL}";
/*
htmldef "ser" as "ser";
  althtmldef "ser" as "ser";
  latexdef "ser" as "{\rm ser}";
htmldef "fcard" as "fcard"; althtmldef "fcard" as "fcard";
htmldef "idsumf" as "idsumf"; althtmldef "idsumf" as "idsumf";
htmldef "idsum" as "idsum"; althtmldef "idsum" as "idsum";
htmldef "C_rng" as "C_rng"; althtmldef "C_rng" as "C_rng";
htmldef "-vNEW" as "-vNEW"; althtmldef "-vNEW" as "-vNEW";
htmldef "RVecNEW" as "RVecNEW"; althtmldef "RVecNEW" as "RVecNEW";
htmldef "+ss" as
    "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>" +
    "<IMG SRC='_subss.gif' WIDTH=10 HEIGHT=19 ALT=' ss' TITLE='ss'>";
  althtmldef "+ss" as "+<SUB>ss</SUB>";
  latexdef "+ss" as "+_{\rm ss}";
htmldef "SubSpNEW" as "SubSpNEW"; althtmldef "SubSpNEW" as "SubSpNEW";
htmldef "spanNEW" as "spanNEW"; althtmldef "spanNEW" as "spanNEW";
htmldef "o+" as "o+"; althtmldef "o+" as "o+";
htmldef "Ev" as "Ev"; althtmldef "Ev" as "Ev";
htmldef "/v" as "/v"; althtmldef "/v" as "/v";
htmldef "normv" as "normv"; althtmldef "normv" as "normv";
*/
htmldef "LLines" as
    "<IMG SRC='_llines.gif' WIDTH=43 HEIGHT=19 ALT=' LLines' TITLE='LLines'>";
  althtmldef "LLines" as "LLines";
  latexdef "LLines" as "{\rm LLines}";
htmldef "LPlanes" as
  "<IMG SRC='_lplanes.gif' WIDTH=51 HEIGHT=19 ALT=' LPlanes' TITLE='LPlanes'>";
  althtmldef "LPlanes" as "LPlanes";
  latexdef "LPlanes" as "{\rm LPlanes}";
htmldef "LVols" as
    "<IMG SRC='_lvols.gif' WIDTH=36 HEIGHT=19 ALT=' LVols' TITLE='LVols'>";
  althtmldef "LVols" as "LVols";
  latexdef "LVols" as "{\rm LVols}";
htmldef "Lines" as
    "<IMG SRC='_lines.gif' WIDTH=34 HEIGHT=19 ALT=' Lines' TITLE='Lines'>";
  althtmldef "Lines" as "Lines";
  latexdef "Lines" as "{\rm Lines}";
htmldef "Points" as
    "<IMG SRC='_points.gif' WIDTH=40 HEIGHT=19 ALT=' Points' TITLE='Points'>";
  althtmldef "Points" as "Points";
  latexdef "Points" as "{\rm Points}";
htmldef "PSubSp" as
    "<IMG SRC='_psubsp.gif' WIDTH=49 HEIGHT=19 ALT=' PSubSp' TITLE='PSubSp'>";
  althtmldef "PSubSp" as "PSubSp";
  latexdef "PSubSp" as "{\rm PSubSp}";
htmldef "pmap" as
    "<IMG SRC='_pmap.gif' WIDTH=36 HEIGHT=19 ALT=' pmap' TITLE='pmap'>";
  althtmldef "pmap" as "pmap";
  latexdef "pmap" as "{\rm pmap}";
htmldef "+P" as
    "<IMG SRC='plus.gif' WIDTH=13 HEIGHT=19 ALT=' +' TITLE='+'>" +
    "<IMG SRC='subcp.gif' WIDTH=8 HEIGHT=19 ALT=' P' TITLE='P'>";
  althtmldef "+P" as "+<SUB>&#x1D443;</SUB>";
  latexdef "+P" as "+_P";
htmldef "PCl" as
    "<IMG SRC='_pcl.gif' WIDTH=23 HEIGHT=19 ALT=' PCl' TITLE='PCl'>";
  althtmldef "PCl" as "PCl";
  latexdef "PCl" as "{\rm PCl}";
htmldef "_|_P" as
    "<IMG SRC='perp.gif' WIDTH=11 HEIGHT=19 ALT=' _|_' TITLE='_|_'>" +
    "<IMG SRC='subcp.gif' WIDTH=8 HEIGHT=19 ALT=' P' TITLE='P'>";
  althtmldef "_|_P" as "&#8869;<SUB>&#x1D443;</SUB>";
    /* 2-Jan-2016 reverted sans-serif */
  latexdef "_|_P" as "\perp_P";
htmldef "PSubCl" as
    "<IMG SRC='_psubcl.gif' WIDTH=47 HEIGHT=19 ALT=' PSubCl' TITLE='PSubCl'>";
  althtmldef "PSubCl" as "PSubCl";
  latexdef "PSubCl" as "{\rm PSubCl}";
/*
htmldef "sumP" as "sumP"; althtmldef "sumP" as "sumP";
htmldef "Indep" as "Indep"; althtmldef "Indep" as "Indep";
htmldef "BasesP" as "BasesP"; althtmldef "BasesP" as "BasesP";
htmldef "rankP" as "rankP"; althtmldef "rankP" as "rankP";
htmldef "PHyp" as "PHyp"; althtmldef "PHyp" as "PHyp";
htmldef "ww" as "ww"; althtmldef "ww" as "ww";
*/
htmldef "LHyp" as
    "<IMG SRC='_lhyp.gif' WIDTH=35 HEIGHT=19 ALT=' LHyp' TITLE='LHyp'>";
  althtmldef "LHyp" as "LHyp";
  latexdef "LHyp" as "{\rm LHyp}";
htmldef "LAut" as
    "<IMG SRC='_laut.gif' WIDTH=33 HEIGHT=19 ALT=' LAut' TITLE='LAut'>";
  althtmldef "LAut" as "LAut";
  latexdef "LAut" as "{\rm LAut}";
htmldef "WAtoms" as
    "<IMG SRC='_watoms.gif' WIDTH=53 HEIGHT=19 ALT=' WAtoms' TITLE='WAtoms'>";
  althtmldef "WAtoms" as "WAtoms";
  latexdef "WAtoms" as "{\rm WAtoms}";
htmldef "PAut" as
    "<IMG SRC='_paut.gif' WIDTH=30 HEIGHT=19 ALT=' PAut' TITLE='PAut'>";
  althtmldef "PAut" as "PAut";
  latexdef "PAut" as "{\rm PAut}";
htmldef "LDil" as
    "<IMG SRC='_ldil.gif' WIDTH=27 HEIGHT=19 ALT=' LDil' TITLE='LDil'>";
  althtmldef "LDil" as "LDil";
  latexdef "LDil" as "{\rm LDil}";
htmldef "LTrn" as
    "<IMG SRC='_ltrn.gif' WIDTH=33 HEIGHT=19 ALT=' LTrn' TITLE='LTrn'>";
  althtmldef "LTrn" as "LTrn";
  latexdef "LTrn" as "{\rm LTrn}";
htmldef "Dil" as
    "<IMG SRC='_dil.gif' WIDTH=18 HEIGHT=19 ALT=' Dil' TITLE='Dil'>";
  althtmldef "Dil" as "Dil";
  latexdef "Dil" as "{\rm Dil}";
htmldef "Trn" as
    "<IMG SRC='_trn.gif' WIDTH=23 HEIGHT=19 ALT=' Trn' TITLE='Trn'>";
  althtmldef "Trn" as "Trn";
  latexdef "Trn" as "{\rm Trn}";
/*
htmldef "trP" as "trP"; althtmldef "trP" as "trP";
*/
htmldef "trL" as
    "<IMG SRC='_trl.gif' WIDTH=21 HEIGHT=19 ALT=' trL' TITLE='trL'>";
  althtmldef "trL" as "trL";
  latexdef "trL" as "{\rm trL}";
htmldef "TGrp" as
    "<IMG SRC='_tgrp.gif' WIDTH=35 HEIGHT=19 ALT=' TGrp' TITLE='TGrp'>";
  althtmldef "TGrp" as "TGrp";
  latexdef "TGrp" as "{\rm TGrp}";
htmldef "TEndo" as
    "<IMG SRC='_tendo.gif' WIDTH=42 HEIGHT=19 ALT=' TEndo' TITLE='TEndo'>";
  althtmldef "TEndo" as "TEndo";
  latexdef "TEndo" as "{\rm TEndo}";
htmldef "EDRing" as
    "<IMG SRC='_edring.gif' WIDTH=49 HEIGHT=19 ALT=' EDRing' TITLE='EDRing'>";
  althtmldef "EDRing" as "EDRing";
  latexdef "EDRing" as "{\rm EDRing}";
htmldef "EDRingR" as
    "<IMG SRC='_edring.gif' WIDTH=49 HEIGHT=19 ALT=' EDRing' TITLE='EDRing'>" +
    "<IMG SRC='subcr.gif' WIDTH=9 HEIGHT=19 ALT=' R' TITLE='R'>";
  althtmldef "EDRingR" as "EDRing<SUB>R</SUB>";
  latexdef "EDRingR" as "{\rm EDRing}_R";
htmldef "DVecA" as
    "<IMG SRC='_dveca.gif' WIDTH=44 HEIGHT=19 ALT=' DVecA' TITLE='DVecA'>";
  althtmldef "DVecA" as "DVecA";
  latexdef "DVecA" as "{\rm DVecA}";
htmldef "DIsoA" as
    "<IMG SRC='_disoa.gif' WIDTH=37 HEIGHT=19 ALT=' DIsoA' TITLE='DIsoA'>";
  althtmldef "DIsoA" as "DIsoA";
  latexdef "DIsoA" as "{\rm DIsoA}";
htmldef "DVecH" as
    "<IMG SRC='_dvech.gif' WIDTH=44 HEIGHT=19 ALT=' DVecH' TITLE='DVecH'>";
  althtmldef "DVecH" as "DVecH";
  latexdef "DVecH" as "{\rm DVecH}";
htmldef "ocA" as
    "<IMG SRC='_oca.gif' WIDTH=24 HEIGHT=19 ALT=' ocA' TITLE='ocA'>";
  althtmldef "ocA" as "ocA";
  latexdef "ocA" as "{\rm ocA}";
htmldef "vA" as "<IMG SRC='_va.gif' WIDTH=16 HEIGHT=19 ALT=' vA' TITLE='vA'>";
  althtmldef "vA" as "vA";
  latexdef "vA" as "{\rm vA}";
htmldef "DIsoB" as
    "<IMG SRC='_disob.gif' WIDTH=36 HEIGHT=19 ALT=' DIsoB' TITLE='DIsoB'>";
  althtmldef "DIsoB" as "DIsoB";
  latexdef "DIsoB" as "{\rm DIsoB}";
htmldef "DIsoC" as
    "<IMG SRC='_disoc.gif' WIDTH=37 HEIGHT=19 ALT=' DIsoC' TITLE='DIsoC'>";
  althtmldef "DIsoC" as "DIsoC";
  latexdef "DIsoC" as "{\rm DIsoC}";
htmldef "DIsoH" as
    "<IMG SRC='_disoh.gif' WIDTH=37 HEIGHT=19 ALT=' DIsoH' TITLE='DIsoH'>";
  althtmldef "DIsoH" as "DIsoH";
  latexdef "DIsoH" as "{\rm DIsoH}";
htmldef "ocH" as
    "<IMG SRC='_och.gif' WIDTH=24 HEIGHT=19 ALT=' ocH' TITLE='ocH'>";
  althtmldef "ocH" as "ocH";
  latexdef "ocH" as "{\rm ocH}";
htmldef "joinH" as "joinH";
  althtmldef "joinH" as "joinH";
  latexdef "joinH" as "{\rm joinH}";
htmldef "LPol" as "LPol";
  althtmldef "LPol" as "LPol";
  latexdef "LPol" as "{\rm LPol}";
htmldef "LCDual" as "LCDual";
  althtmldef "LCDual" as "LCDual";
  latexdef "LCDual" as "{\rm LCDual}";
htmldef "mapd" as "mapd";
  althtmldef "mapd" as "mapd";
  latexdef "mapd" as "{\rm mapd}";
htmldef "HVMap" as "HVMap";
  althtmldef "HVMap" as "HVMap";
  latexdef "HVMap" as "{\rm HVMap}";
/*
htmldef "eImage" as "eImage";
  althtmldef "eImage" as "eImage";
  latexdef "eImage" as "{\rm eImage}";
*/
htmldef "HDMap1" as "HDMap1";
  althtmldef "HDMap1" as "HDMap1";
  latexdef "HDMap1" as "{\rm HDMap1}";
htmldef "HDMap" as "HDMap";
  althtmldef "HDMap" as "HDMap";
  latexdef "HDMap" as "{\rm HDMap}";
htmldef "HGMap" as "HGMap";
  althtmldef "HGMap" as "HGMap";
  latexdef "HGMap" as "{\rm HGMap}";
htmldef "HLHil" as "HLHil";
  althtmldef "HLHil" as "HLHil";
  latexdef "HLHil" as "{\rm HLHil}";
/*
htmldef "*HRing" as "*HRing";
  althtmldef "*HRing" as "*HRing";
  latexdef "*HRing" as "\ast{\rm HRing}";
htmldef "hmap" as "hmap";
  althtmldef "hmap" as "hmap";
  latexdef "hmap" as "{\rm hmap}";
htmldef "gmap" as "gmap";
  althtmldef "gmap" as "gmap";
  latexdef "gmap" as "{\rm gmap}";
htmldef "mapd" as "mapd";
  althtmldef "mapd" as "mapd";
  latexdef "mapd" as "{\rm mapd}";
htmldef "GrpEndo" as "GrpEndo"; althtmldef "GrpEndo" as "GrpEndo";
htmldef "DVecAEndo" as "DVecAEndo"; althtmldef "DVecAEndo" as "DVecAEndo";
htmldef "ERing" as "ERing"; althtmldef "ERing" as "ERing";
htmldef "TPEndo" as "TPEndo"; althtmldef "TPEndo" as "TPEndo";
htmldef "DRing" as "DRing"; althtmldef "DRing" as "DRing";
htmldef "DVecA" as "DVecA"; althtmldef "DVecA" as "DVecA";
htmldef "DVIsoPre" as "DVIsoPre"; althtmldef "DVIsoPre" as "DVIsoPre";
htmldef "DVecB" as "DVecB"; althtmldef "DVecB" as "DVecB";
htmldef "DVecH" as "DVecH"; althtmldef "DVecH" as "DVecH";
htmldef "ee" as "ee"; althtmldef "ee" as "ee";
htmldef "DVIsoA" as "DVIsoA"; althtmldef "DVIsoA" as "DVIsoA";
htmldef "qtr" as "qtr"; althtmldef "qtr" as "qtr";
htmldef "DVIsoB" as "DVIsoB"; althtmldef "DVIsoB" as "DVIsoB";
htmldef "DVIsoC" as "DVIsoC"; althtmldef "DVIsoC" as "DVIsoC";
htmldef "DVIsoH" as "DVIsoH"; althtmldef "DVIsoH" as "DVIsoH";
htmldef "S_|_" as "S_|_"; althtmldef "S_|_" as "S_|_";
htmldef "Ropp" as "Ropp"; althtmldef "Ropp" as "Ropp";
htmldef "Vldual" as "Vldual"; althtmldef "Vldual" as "Vldual";
htmldef "vecdom" as "vecdom"; althtmldef "vecdom" as "vecdom";
htmldef "ker" as "ker"; althtmldef "ker" as "ker";
htmldef "mapd" as "mapd"; althtmldef "mapd" as "mapd";
htmldef "eimage" as "eimage"; althtmldef "eimage" as "eimage";
htmldef "hmap" as "hmap"; althtmldef "hmap" as "hmap";
htmldef "gmap" as "gmap"; althtmldef "gmap" as "gmap";
htmldef "HLtoHil" as "HLtoHil"; althtmldef "HLtoHil" as "HLtoHil";
*/


/* End of typesetting definition section */
$)

$( End $[ set-typeset.mm $] $)


$( Begin $[ set-hilsp.mm $] $)

$(
###############################################################################
                 COMPLEX HILBERT SPACE EXPLORER (DEPRECATED)
###############################################################################

  This part contains the definitions and theorems used by the Hilbert
  Space Explorer ~ http://us.metamath.org/mpeuni/mmhil.html .  Because it
  axiomatizes a single complex Hilbert space whose existence is assumed,
  its usefulness is limited.  For example, it cannot work with real or
  quaternion Hilbert spaces and it cannot study relationships between two
  Hilbert spaces.  More information can be found on the Hilbert Space
  Explorer page.  Future development should work with general Hilbert
  spaces as defined by ~ df-hil .

$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Axiomatization of complex pre-Hilbert spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $( Include set.mm as the starting point (commented out since it's above) $)
  $( $[ set.mm $] $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Basic Hilbert space definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Axioms for a Hilbert space $)
  $( We assume we've constructed a fixed constant class ` ~H ` and
     associated operations, and we postulate their properties. $)

  $c ~H $.
  $c +h $.
  $c .h $.
  $c 0h $.
  $c -h $.
  $c .ih $.
  $c normh $.

  $c Cauchy $.
  $c ~~>v $.
  $c SH $.
  $c CH $.
  $c _|_ $.
  $c +H $.
  $c span $.
  $c vH $.
  $c \/H $.
  $c 0H $.
  $c C_H $.
  $c projh $.
  $c 0hop $.
  $c Iop $.
  $c +op $.
  $c .op $.
  $c -op $.
  $c +fn $.
  $c .fn $.
  $c normop $.
  $c ConOp $.
  $c LinOp $.
  $c BndLinOp $.
  $c UniOp $.
  $c HrmOp $.
  $c normfn $.
  $c null $.
  $c ConFn $.
  $c LinFn $.
  $c adjh $.
  $c bra $.
  $c ketbra $.
  $c <_op $.
  $c eigvec $.
  $c eigval $.
  $c Lambda $.
  $c States $.
  $c CHStates $.
  $c HAtoms $.
  $c <oH $.
  $c MH $.
  $c MH* $.
  $( Extend class notation with Hilbert vector space. $)
  chil $a class ~H $.

  $( Extend class notation with vector addition in Hilbert space.  In the
     literature, the subscript "v" is omitted, but we need it to avoid
     ambiguity with complex number addition ` + ` ~ caddc . $)
  cva $a class +h $.
  $( Extend class notation with scalar multiplication in Hilbert space.  In the
     literature scalar multiplication is usually indicated by juxtaposition,
     but we need an explicit symbol to prevent ambiguity. $)
  csm $a class .h $.
  $( Extend class notation with inner (scalar) product in Hilbert space.  In
     the literature, the inner product of ` A ` and ` B ` is usually written
     ` <. A , B >. ` but our operation notation allows us to use existing
     theorems about operations and also eliminates ambiguity with the
     definition of an ordered pair ~ df-op . $)
  csp $a class .ih $.

  $( $j primitive 'cva' 'csm' 'csp'; $)

  $( Extend class notation with the norm function in Hilbert space.  In the
     literature, the norm of ` A ` is usually written "|| ` A ` ||", but we use
     function notation to take advantage of our existing theorems about
     functions. $)
  cno $a class normh $.
  $( Extend class notation with zero vector in Hilbert space. $)
  c0v $a class 0h $.
  $( Extend class notation with vector subtraction in Hilbert space. $)
  cmv $a class -h $.
  $( Extend class notation with set of Cauchy sequences in Hilbert space. $)
  ccau $a class Cauchy $.
  $( Extend class notation with convergence relation in Hilbert space. $)
  chli $a class ~~>v $.
  $( Extend class notation with set of subspaces of a Hilbert space. $)
  csh $a class SH $.
  $( Extend class notation with set of closed subspaces of a Hilbert space. $)
  cch $a class CH $.
  $( Extend class notation with orthogonal complement in ` CH ` . $)
  cort $a class _|_ $.
  $( Extend class notation with subspace sum in ` CH ` . $)
  cph $a class +H $.
  $( Extend class notation with subspace span in ` CH ` . $)
  cspn $a class span $.
  $( Extend class notation with join in ` CH ` . $)
  chj $a class vH $.
  $( Extend class notation with supremum of a collection in ` CH ` . $)
  chsup $a class \/H $.
  $( Extend class notation with zero of ` CH ` . $)
  c0h $a class 0H $.
  $( Extend class notation with the commutes relation on a Hilbert lattice. $)
  ccm $a class C_H $.
  $( Extend class notation with set of projections on a Hilbert space. $)
  cpjh $a class projh $.
  $( Extend class notation with sum of Hilbert space operators. $)
  chos $a class +op $.
  $( Extend class notation with scalar product of a Hilbert space operator. $)
  chot $a class .op $.
  $( Extend class notation with difference of Hilbert space operators. $)
  chod $a class -op $.
  $( Extend class notation with sum of Hilbert space functionals. $)
  chfs $a class +fn $.
  $( Extend class notation with scalar product of Hilbert space functional. $)
  chft $a class .fn $.
  $( Extend class notation with the Hilbert space zero operator. $)
  ch0o $a class 0hop $.
  $( Extend class notation with Hilbert space identity operator. $)
  chio $a class Iop $.
  $( Extend class notation with the operator norm function. $)
  cnop $a class normop $.
  $( Extend class notation with set of continuous Hilbert space operators. $)
  ccop $a class ConOp $.
  $( Extend class notation with set of linear Hilbert space operators. $)
  clo $a class LinOp $.
  $( Extend class notation with set of bounded linear operators. $)
  cbo $a class BndLinOp $.
  $( Extend class notation with set of unitary Hilbert space operators. $)
  cuo $a class UniOp $.
  $( Extend class notation with set of Hermitian Hilbert space operators. $)
  cho $a class HrmOp $.
  $( Extend class notation with the functional norm function. $)
  cnmf $a class normfn $.
  $( Extend class notation with the functional nullspace function. $)
  cnl $a class null $.
  $( Extend class notation with set of continuous Hilbert space functionals. $)
  ccnfn $a class ConFn $.
  $( Extend class notation with set of linear Hilbert space functionals. $)
  clf $a class LinFn $.
  $( Extend class notation with Hilbert space adjoint function. $)
  cado $a class adjh $.
  $( Extend class notation with the bra of a vector in Dirac bra-ket
     notation. $)
  cbr $a class bra $.
  $( Extend class notation with the outer product of two vectors in Dirac
     bra-ket notation. $)
  ck $a class ketbra $.
  $( Extend class notation with positive operator ordering. $)
  cleo $a class <_op $.
  $( Extend class notation with Hilbert space eigenvector function. $)
  cei $a class eigvec $.
  $( Extend class notation with Hilbert space eigenvalue function. $)
  cel $a class eigval $.
  $( Extend class notation with the spectrum of an operator. $)
  cspc $a class Lambda $.
  $( Extend class notation with set of states on a Hilbert lattice. $)
  cst $a class States $.
  $( Extend class notation with set of Hilbert-space-valued states on a Hilbert
     lattice. $)
  chst $a class CHStates $.
  $( Extend class notation with the covers relation on a Hilbert lattice. $)
  ccv $a class <oH $.
  $( Extend class notation with set of atoms on a Hilbert lattice. $)
  cat $a class HAtoms $.
  $( Extend class notation with the modular pair relation on a Hilbert
     lattice. $)
  cmd $a class MH $.
  $( Extend class notation with the dual modular pair relation on a Hilbert
     lattice. $)
  cdmd $a class MH* $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Preliminary ZFC lemmas
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( To convert to pure ZFC, put the definitions of ` +h ` , ` .h ` ,
     and ` .ih ` here. $)

  $( Define the function for the norm of a vector of Hilbert space.  See
     ~ normval for its value and ~ normcl for its closure.  Theorems
     ~ norm-i-i , ~ norm-ii-i , and ~ norm-iii-i show it has the expected
     properties of a norm.  In the literature, the norm of ` A ` is usually
     written "|| ` A ` ||", but we use function notation to take advantage of
     our existing theorems about functions.  Definition of norm in [Beran]
     p. 96.  (Contributed by NM, 6-Jun-2008.)  (New usage is discouraged.) $)
  df-hnorm $a |- normh = ( x e. dom dom .ih |-> ( sqr ` ( x .ih x ) ) ) $.

  $( Define base set of Hilbert space, for use if we want to develop Hilbert
     space independently from the axioms (see comments in ~ ax-hilex ).  Note
     that ` ~H ` is considered a primitive in the Hilbert space axioms below,
     and we don't use this definition outside of this section.  This definition
     can be proved independently from those axioms as theorem ~ hhba .
     (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
  df-hba $a |- ~H = ( BaseSet ` <. <. +h , .h >. , normh >. ) $.

  $( Define the zero vector of Hilbert space.  Note that ` 0vec ` is considered
     a primitive in the Hilbert space axioms below, and we don't use this
     definition outside of this section.  It is proved from the axioms as
     theorem ~ hh0v .  (Contributed by NM, 31-May-2008.)
     (New usage is discouraged.) $)
  df-h0v $a |- 0h = ( 0vec ` <. <. +h , .h >. , normh >. ) $.

  ${
    $d x y $.
    $( Define vector subtraction.  See ~ hvsubvali for its value and ~ hvsubcli
       for its closure.  (Contributed by NM, 6-Jun-2008.)
       (New usage is discouraged.) $)
    df-hvsub $a |- -h = ( x e. ~H , y e. ~H |-> ( x +h ( -u 1 .h y ) ) ) $.
  $}

  ${
    $d x y z f w $.
    $( Define the limit relation for Hilbert space.  See ~ hlimi for its
       relational expression.  Note that ` f : NN --> ~H ` is an infinite
       sequence of vectors, i.e. a mapping from integers to vectors.
       Definition of converge in [Beran] p. 96.  (Contributed by NM,
       6-Jun-2008.)  (New usage is discouraged.) $)
    df-hlim $a |- ~~>v = { <. f , w >. | ( ( f : NN --> ~H /\ w e. ~H ) /\
          A. x e. RR+ E. y e. NN A. z e. ( ZZ>= ` y )
                ( normh ` ( ( f ` z ) -h w ) ) < x ) } $.
  $}

  ${
    $d x y z w f $.
    $( Define the set of Cauchy sequences on a Hilbert space.  See ~ hcau for
       its membership relation.  Note that ` f : NN --> ~H ` is an infinite
       sequence of vectors, i.e. a mapping from integers to vectors.
       Definition of Cauchy sequence in [Beran] p. 96.  (Contributed by NM,
       6-Jun-2008.)  (New usage is discouraged.) $)
    df-hcau $a |- Cauchy = { f e. ( ~H ^m NN ) |
          A. x e. RR+ E. y e. NN A. z e. ( ZZ>= ` y )
             ( normh ` ( ( f ` y ) -h ( f ` z ) ) ) < x } $.
  $}

  ${
    h2h.1 $e |- U = <. <. +h , .h >. , normh >. $.
    h2h.2 $e |- U e. NrmCVec $.
    $( The group (addition) operation of Hilbert space.  (Contributed by NM,
       31-May-2008.)  (New usage is discouraged.) $)
    h2hva $p |- +h = ( +v ` U ) $=
      ( cva csm cop cno cpv cfv c1st eqid vafval opex cvv wcel cnv w3a eqeltrri
      op1st fveq2i nvex ax-mp simp3i simp1i simp2i 3eqtrri eqtr4i ) DDEFZGFZHIZ
      AHIUJUIJIZJIUHJIDUIUJUJKLUKUHJUHGDEMDNOZENOZGNOZUIPOULUMUNQAUIPBCREDGUAUB
      ZUCSTDEULUMUNUOUDULUMUNUOUESUFAUIHBTUG $.

    $( The scalar product operation of Hilbert space.  (Contributed by NM,
       31-May-2008.)  (New usage is discouraged.) $)
    h2hsm $p |- .h = ( .sOLD ` U ) $=
      ( csm cva cop cno cns cfv c1st c2nd eqid smfval opex cvv cnv w3a eqeltrri
      wcel fveq2i nvex ax-mp simp3i op1st simp1i simp2i op2nd 3eqtrri eqtr4i )
      DEDFZGFZHIZAHIULUKJIZKIUJKIDULUKULLMUMUJKUJGEDNEOSZDOSZGOSZUKPSUNUOUPQAUK
      PBCRDEGUAUBZUCUDTEDUNUOUPUQUEUNUOUPUQUFUGUHAUKHBTUI $.

    $( The norm function of Hilbert space.  (Contributed by NM, 5-Jun-2008.)
       (New usage is discouraged.) $)
    h2hnm $p |- normh = ( normCV ` U ) $=
      ( cnmcv cfv cva csm cop cno c2nd eqid nmcvfval opex cvv wcel cnv eqeltrri
      fveq2i w3a nvex ax-mp simp3i op2nd 3eqtrri ) ADEFGHZIHZDEZUFJEIAUFDBRUFUG
      UGKLUEIFGMFNOZGNOZINOZUFPOUHUIUJSAUFPBCQGFITUAUBUCUD $.

    ${
      $d x y U $.
      h2h.4 $e |- ~H = ( BaseSet ` U ) $.
      $( The vector subtraction operation of Hilbert space.  (Contributed by
         NM, 6-Jun-2008.)  (Revised by Mario Carneiro, 23-Dec-2013.)
         (New usage is discouraged.) $)
      h2hvs $p |- -h = ( -v ` U ) $=
        ( vx vy cmv chil cv c1 cneg csm co cva cmpt2 cnsb cfv df-hvsub cnv wcel
        wceq h2hva h2hsm eqid nvmfval ax-mp eqtr4i ) GEFHHEIJKFILMNMOZAPQZEFRAS
        TUIUHUACEFLANUIHDABCUBABCUCUIUDUEUFUG $.
    $}

    ${
      h2hm.4 $e |- ~H = ( BaseSet ` U ) $.
      h2hm.5 $e |- D = ( IndMet ` U ) $.
      $( Value of the distance function of the metric space of Hilbert space.
         (Contributed by NM, 6-Jun-2008.)  (New usage is discouraged.) $)
      h2hmetdval $p |- ( ( A e. ~H /\ B e. ~H )
                  -> ( A D B ) = ( normh ` ( A -h B ) ) ) $=
        ( cnv wcel chil co cmv cno cfv wceq h2hvs h2hnm imsdval mp3an1 ) DIJAKJ
        BKJABCLABMLNOPFABCDMNKGDEFGQDEFRHST $.
    $}
  $}

  ${
    $d f j k x D $.
    h2hc.1 $e |- U = <. <. +h , .h >. , normh >. $.
    h2hc.2 $e |- U e. NrmCVec $.
    h2hc.3 $e |- ~H = ( BaseSet ` U ) $.
    h2hc.4 $e |- D = ( IndMet ` U ) $.
    $( The Cauchy sequences of Hilbert space.  (Contributed by NM,
       6-Jun-2008.)  (Revised by Mario Carneiro, 13-May-2014.)
       (New usage is discouraged.) $)
    h2hcau $p |- Cauchy = ( ( Cau ` D ) i^i ( ~H ^m NN ) ) $=
      ( vj vf vk vx cv cfv co clt wral cn crp chil wcel wa cmv cno wbr cuz wrex
      cmap crab cab ccau cca df-rab df-hcau elin ancom wf wb hlex nnex elmap c1
      cin nnuz cnv cxmt imsxmet mp1i cz 1z a1i eqidd iscauf wceq ffvelrn adantr
      uztrn2 sylan2 anassrs h2hmetdval syl2anc breq1d ralbidva rexbidva ralbidv
      id bitrd sylbi pm5.32i 3bitri abbi2i 3eqtr4i ) GKZHKZLZIKZWLLZUAMUBLZJKZN
      UCZIWKUDLZOZGPUEZJQOZHRPUFMZUGWLXCSZXBTZHUHUIAUJLZXCVAZXBHXCUKJGIHULXEHXG
      WLXGSWLXFSZXDTXDXHTXEWLXFXCUMXHXDUNXDXHXBXDPRWLUOZXHXBUPRPWLBREUQURUSXIXH
      WMWOAMZWQNUCZIWSOZGPUEZJQOXBXIJWOWMAGIWLUTRPVBBVCSARVDLSXIDABREFVEVFUTVGS
      XIVHVIXIWNPSZTWOVJXIWKPSZTZWMVJXIWDVKXIXMXAJQXIXLWTGPXPXKWRIWSXPWNWSSZTZX
      JWPWQNXRWMRSZWORSZXJWPVLXPXSXQPRWKWLVMVNXIXOXQXTXOXQTXIXNXTUTWNWKPVBVOPRW
      NWLVMVPVQWMWOABCDEFVRVSVTWAWBWCWEWFWGWHWIWJ $.
  $}

  ${
    $d f x y J $.  $d f j k x y D $.
    h2hl.1 $e |- U = <. <. +h , .h >. , normh >. $.
    h2hl.2 $e |- U e. NrmCVec $.
    h2hl.3 $e |- ~H = ( BaseSet ` U ) $.
    h2hl.4 $e |- D = ( IndMet ` U ) $.
    h2hl.5 $e |- J = ( MetOpen ` D ) $.
    $( The limit sequences of Hilbert space.  (Contributed by NM, 6-Jun-2008.)
       (Revised by Mario Carneiro, 13-May-2014.)
       (New usage is discouraged.) $)
    h2hlm $p |- ~~>v = ( ( ~~>t ` J ) |` ( ~H ^m NN ) ) $=
      ( vf vx vk vy vj chli cfv chil cn cv wcel wa clm cmap co cres cmv cno clt
      wf wbr cuz wral crp df-hlim relopabi relres cop copab eleq2i opabid ancom
      wrex hlex nnex elmap anbi1i df-br c1 cnv cxmt imsxmet mp1i nnuz cz 1z a1i
      eqidd id lmmbrf uztrn2 wceq ffvelrn h2hmetdval sylan breq1d an32s anassrs
      wb ralbidva rexbidva ralbidv pm5.32da bitrd syl5bbr pm5.32i 3bitrri anass
      sylan2 vex opelres 3bitr4i 3bitri eqrelriiv ) IJNCUAOZPQUBUCZUDZQPIRZUHZJ
      RZPSZTZKRZXFOZXHUEUCUFOZLRZUGUIZKMRZUJOZUKZMQVAZLULUKZTZIJNLMKJIUMZUNXCXD
      UOXFXHUPZNSYCYAIJUQZSYAYCXESZNYDYCYBURYAIJUSXGXIXTTZTZYCXCSZXFXDSZTZYAYEY
      JYIYHTXGYHTYGYHYIUTYIXGYHPQXFBPFVBVCVDVEXGYHYFYHXFXHXCUIZXGYFXFXHXCVFXGYK
      XIXLXHAUCZXNUGUIZKXQUKZMQVAZLULUKZTYFXGLXLAXHMKXFCVGPQHBVHSAPVIOSXGEABPFG
      VJVKVLVGVMSXGVNVOXGXKQSZTZXLVPXGVQVRXGXIYPXTXJYOXSLULXJYNXRMQXJXPQSZTYMXO
      KXQXJYSXKXQSZYMXOWGZYSYTTXJYQUUAVGXKXPQVLVSXGYQXIUUAYRXITYLXMXNUGYRXLPSXI
      YLXMVTQPXKXFWAXLXHABDEFGWBWCWDWEWQWFWHWIWJWKWLWMWNWOXGXIXTWPXFXHXCXDJWRWS
      WTXAXB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Derive the Hilbert space axioms from ZFC set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Before introducing the 18 axioms for Hilbert space, we first prove them
  as the conclusions of theorems ~ axhilex-zf through ~ axhcompl-zf , using ZFC
  set theory only.  These show that if we are given a known, fixed Hilbert
  space ` U = <. <. +h , .h >. , normh >. ` that satisfies their
  hypotheses, then we can derive the Hilbert space axioms as theorems of
  ZFC set theory.  In practice, in order to use these theorems to convert
  the Hilbert Space explorer to a ZFC-only subtheory, we would also have
  to provide definitions for the 3 (otherwise primitive) class constants
  ` +h ` , ` .h ` , and ` .ih ` before ~ df-hnorm above.  See also the
  comment in ~ ax-hilex .

$)

  ${
    $d x y F $.  $d x y U $.
    axhil.1 $e |- U = <. <. +h , .h >. , normh >. $.
    axhil.2 $e |- U e. CHilOLD $.
    $( Derive axiom ~ ax-hilex from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhilex-zf $p |- ~H e. _V $=
      ( cva csm cop cno chil df-hba hlex ) DEFGFHIJ $.

    $( Derive axiom ~ ax-hfvadd from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhfvadd-zf $p |- +h : ( ~H X. ~H ) --> ~H $=
      ( chlo wcel chil cxp cva wf csm cop cno cba cfv df-hba fveq2i hlnvi h2hva
      eqtr4i hladdf ax-mp ) ADEFFGFHICAHFFHJKLKZMNAMNOAUBMBPSABACQRTUA $.

    $( Derive axiom ~ ax-hvcom from Hilbert space under ZF set theory.
       (Contributed by NM, 27-May-2008.)  (New usage is discouraged.) $)
    axhvcom-zf $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h B ) = ( B +h A ) ) $=
      ( chlo wcel chil cva wceq csm cop cno cba cfv df-hba fveq2i eqtr4i hlnvi
      co h2hva hlcom mp3an1 ) CFGAHGBHGABITBAITJEABCIHHIKLMLZNOCNOPCUDNDQRCDCES
      UAUBUC $.

    $( Derive axiom ~ ax-hvass from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvass-zf $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( ( A +h B ) +h C )
      = ( A +h ( B +h C ) ) ) $=
      ( chlo wcel chil w3a cva co wceq csm cop cno cba cfv df-hba fveq2i eqtr4i
      hlnvi h2hva hlass mpan ) DGHAIHBIHCIHJABKLCKLABCKLKLMFABCDKIIKNOPOZQRDQRS
      DUFQETUADEDFUBUCUDUE $.

    $( Derive axiom ~ ax-hv0cl from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhv0cl-zf $p |- 0h e. ~H $=
      ( chlo wcel c0v chil cva csm cop cno cba df-hba fveq2i eqtr4i cn0v df-h0v
      cfv hl0cl ax-mp ) ADEFGECAGFGHIJKJZLRALRMAUALBNOFUAPRAPRQAUAPBNOST $.

    $( Derive axiom ~ ax-hvaddid from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvaddid-zf $p |- ( A e. ~H -> ( A +h 0h ) = A ) $=
      ( chlo wcel chil c0v cva co wceq csm cop cno cba cfv df-hba fveq2i eqtr4i
      cn0v hlnvi h2hva df-h0v hladdid mpan ) BEFAGFAHIJAKDABIGHGILMNMZOPBOPQBUF
      OCRSBCBDUAUBHUFTPBTPUCBUFTCRSUDUE $.

    $( Derive axiom ~ ax-hfvmul from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhfvmul-zf $p |- .h : ( CC X. ~H ) --> ~H $=
      ( chlo wcel cc chil cxp csm wf cva cop cno cba df-hba fveq2i eqtr4i hlnvi
      cfv h2hsm hlmulf ax-mp ) ADEFGHGIJCIAGGKILMLZNSANSOAUCNBPQABACRTUAUB $.

    $( Derive axiom ~ ax-hvmulid from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvmulid-zf $p |- ( A e. ~H -> ( 1 .h A ) = A ) $=
      ( chlo wcel chil c1 csm co cva cop cno cba cfv df-hba fveq2i eqtr4i hlnvi
      wceq h2hsm hlmulid mpan ) BEFAGFHAIJATDAIBGGKILMLZNOBNOPBUDNCQRBCBDSUAUBU
      C $.

    $( Derive axiom ~ ax-hvmulass from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvmulass-zf $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H )
      -> ( ( A x. B ) .h C ) = ( A .h ( B .h C ) ) ) $=
      ( chlo wcel cc chil w3a cmul co csm wceq cva cop cno cba cfv df-hba hlnvi
      fveq2i eqtr4i h2hsm hlmulass mpan ) DGHAIHBIHCJHKABLMCNMABCNMNMOFABCNDJJP
      NQRQZSTDSTUADUHSEUCUDDEDFUBUEUFUG $.

    $( Derive axiom ~ ax-hvdistr1 from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvdistr1-zf $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H )
      -> ( A .h ( B +h C ) ) = ( ( A .h B ) +h ( A .h C ) ) ) $=
      ( chlo wcel cc chil w3a cva co csm wceq cop cno cba cfv df-hba hlnvi hldi
      fveq2i eqtr4i h2hva h2hsm mpan ) DGHAIHBJHCJHKABCLMNMABNMACNMLMOFABCNDLJJ
      LNPQPZRSDRSTDUHREUCUDDEDFUAZUEDEUIUFUBUG $.

    $( Derive axiom ~ ax-hvdistr2 from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvdistr2-zf $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H )
      -> ( ( A + B ) .h C ) = ( ( A .h C ) +h ( B .h C ) ) ) $=
      ( chlo wcel cc chil w3a caddc co csm cva wceq cop cno cba cfv hlnvi h2hva
      df-hba fveq2i eqtr4i h2hsm hldir mpan ) DGHAIHBIHCJHKABLMCNMACNMBCNMOMPFA
      BCNDOJJONQRQZSTDSTUCDUISEUDUEDEDFUAZUBDEUJUFUGUH $.

    $( Derive axiom ~ ax-hvmul0 from Hilbert space under ZF set theory.
       (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
    axhvmul0-zf $p |- ( A e. ~H -> ( 0 .h A ) = 0h ) $=
      ( chlo wcel chil cc0 csm c0v wceq cva cop cno cba cfv fveq2i eqtr4i cn0v
      co df-hba hlnvi h2hsm df-h0v hlmul0 mpan ) BEFAGFHAITJKDAIBGJGLIMNMZOPBOP
      UABUGOCQRBCBDUBUCJUGSPBSPUDBUGSCQRUEUF $.

    ${
      axhfi.1 $e |- .ih = ( .iOLD ` U ) $.
      $( Derive axiom ~ ax-hfi from Hilbert space under ZF set theory.
         (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
      axhfi-zf $p |- .ih : ( ~H X. ~H ) --> CC $=
        ( chlo wcel chil cxp cc csp wf cva csm cop cno cba df-hba fveq2i eqtr4i
        cfv hlipf ax-mp ) AEFGGHIJKCJAGGLMNONZPTAPTQAUCPBRSDUAUB $.

      $( Derive axiom ~ ax-his1 from Hilbert space under ZF set theory.
         (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
      axhis1-zf $p |- ( ( A e. ~H /\ B e. ~H )
        -> ( A .ih B ) = ( * ` ( B .ih A ) ) ) $=
        ( chlo wcel chil csp co ccj cfv wceq cva csm cop cno cba df-hba fveq2i
        eqtr4i hlipcj mp3an1 ) CGHAIHBIHABJKBAJKLMNEABJCIIOPQRQZSMCSMTCUESDUAUB
        FUCUD $.

      $( Derive axiom ~ ax-his2 from Hilbert space under ZF set theory.
         (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
      axhis2-zf $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H )
        -> ( ( A +h B ) .ih C ) = ( ( A .ih C ) + ( B .ih C ) ) ) $=
        ( chlo wcel chil w3a cva co csp caddc wceq csm cop cba cfv df-hba hlnvi
        cno fveq2i eqtr4i h2hva hlipdir mpan ) DHIAJIBJICJIKABLMCNMACNMBCNMOMPF
        ABCNDLJJLQRUCRZSTDSTUADUISEUDUEDEDFUBUFGUGUH $.

      $( Derive axiom ~ ax-his3 from Hilbert space under ZF set theory.
         (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
      axhis3-zf $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H )
        -> ( ( A .h B ) .ih C ) = ( A x. ( B .ih C ) ) ) $=
        ( chlo wcel cc chil w3a csm co csp cmul wceq cop cba cfv cva cno df-hba
        fveq2i eqtr4i hlnvi h2hsm hlipass mpan ) DHIAJIBKICKILABMNCONABCONPNQFA
        BCOMDKKUAMRUBRZSTDSTUCDUJSEUDUEDEDFUFUGGUHUI $.

      $( Derive axiom ~ ax-his4 from Hilbert space under ZF set theory.
         (Contributed by NM, 31-May-2008.)  (New usage is discouraged.) $)
      axhis4-zf $p |- ( ( A e. ~H /\ A =/= 0h ) -> 0 < ( A .ih A ) ) $=
        ( chlo wcel chil c0v wne cc0 csp co clt cop cba cfv fveq2i eqtr4i cn0v
        wbr cva csm cno df-hba df-h0v hlipgt0 mp3an1 ) BFGAHGAIJKAALMNUADALBHIH
        UBUCOUDOZPQBPQUEBUIPCRSIUITQBTQUFBUITCRSEUGUH $.
    $}

    $( Derive axiom ~ ax-hcompl from Hilbert space under ZF set theory.
       (Contributed by NM, 6-Jun-2008.)  (Revised by Mario Carneiro,
       13-May-2014.)  (New usage is discouraged.) $)
    axhcompl-zf $p |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $=
      ( cv chli wbr chil wrex cims cfv cca wcel wa wex cop eqid wb cba cmap cin
      cn co ccau cmopn clm chlo simpl hlcompl sylancr eldm2g adantr mpbid df-br
      cdm wi ctopon cnv cxmt cva csm cno df-hba fveq2i eqtr4i imsxmet mopntopon
      hlnvi mp2b lmcl mpan a1i cres h2hlm breqi brres ancom 3bitri baib biimprd
      vex adantl jcad syl5bir eximdv mpd elin df-rex 3imtr4i h2hcau eleq2s ) CA
      FZGHZAIJZCBKLZMLZIUCUAUDZUBZUECWQNZCWRNZOZWMINZWNOZAPZCWSNWOXBCWMQWPUFLZU
      GLZNZAPZXEXBCXGUPNZXIXBBUHNWTXJEWTXAUIWPBCXFWPRZXFRZUJUKWTXJXISXAACXGWQUL
      UMUNXBXHXDAXHCWMXGHZXBXDCWMXGUOXBXMXCWNXMXCUQXBXFIURLNZXMXCBUSNWPIUTLNXNB
      EVIZWPBIIVAVBQVCQZTLBTLVDBXPTDVEVFZXKVGWPXFIXLVHVJWMCXFIVKVLVMXBWNXMXAWNX
      MSWTWNXAXMWNCWMXGWRVNZHXMXAOXAXMOCWMGXRWPBXFDXOXQXKXLVOVPCWMXGWRAWBVQXMXA
      VRVSVTWCWAWDWEWFWGCWQWRWHWNAIWIWJWPBDXOXQXKWKWL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Introduce the vector space axioms for a Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Here we introduce the axioms a complex Hilbert space, which is the foundation
  for quantum mechanics and quantum field theory.  The 18 axioms for a complex
  Hilbert space consist of ~ ax-hilex , ~ ax-hfvadd , ~ ax-hvcom , ~ ax-hvass ,
  ~ ax-hv0cl , ~ ax-hvaddid , ~ ax-hfvmul , ~ ax-hvmulid , ~ ax-hvmulass ,
  ~ ax-hvdistr1 , ~ ax-hvdistr2 , ~ ax-hvmul0 , ~ ax-hfi , ~ ax-his1 ,
  ~ ax-his2 , ~ ax-his3 , ~ ax-his4 , and ~ ax-hcompl .

  The axioms specify the properties of 5 primitive symbols, ` ~H ` , ` +h ` ,
  ` .h ` , ` 0h ` , and ` .ih ` .

  If we can prove in ZFC set theory that a class
  ` U = <. <. +h , .h >. , normh >. ` is a complex Hilbert space, i.e. that
  ` U e. CHilOLD ` , then these axioms can be proved as theorems ~ axhilex-zf ,
  ~ axhfvadd-zf , ~ axhvcom-zf , ~ axhvass-zf , ~ axhv0cl-zf , ~ axhvaddid-zf ,
  ~ axhfvmul-zf , ~ axhvmulid-zf , ~ axhvmulass-zf , ~ axhvdistr1-zf ,
  ~ axhvdistr2-zf , ~ axhvmul0-zf , ~ axhfi-zf , ~ axhis1-zf , ~ axhis2-zf ,
  ~ axhis3-zf , ~ axhis4-zf , and ~ axhcompl-zf respectively.  In that case,
  the theorems of the Hilbert Space Explorer will become theorems of ZFC set
  theory.  See also the comments in ~ axhilex-zf .

$)

  $( This is our first axiom for a complex Hilbert space, which is the
     foundation for quantum mechanics and quantum field theory.  We assume that
     there exists a primitive class, ` ~H ` , which contains objects called
     vectors.  (Contributed by NM, 16-Aug-1999.)
     (New usage is discouraged.) $)
  ax-hilex $a |- ~H e. _V $.

  $( Vector addition is an operation on ` ~H ` .  (Contributed by NM,
     16-Aug-1999.)  (New usage is discouraged.) $)
  ax-hfvadd $a |- +h : ( ~H X. ~H ) --> ~H $.

  $( Vector addition is commutative.  (Contributed by NM, 3-Sep-1999.)
     (New usage is discouraged.) $)
  ax-hvcom $a |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h B ) = ( B +h A ) ) $.

  $( Vector addition is associative.  (Contributed by NM, 3-Sep-1999.)
     (New usage is discouraged.) $)
  ax-hvass $a |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                 ( ( A +h B ) +h C ) = ( A +h ( B +h C ) ) ) $.

  $( The zero vector is in the vector space.  (Contributed by NM,
     29-May-1999.)  (New usage is discouraged.) $)
  ax-hv0cl $a |- 0h e. ~H $.

  $( Addition with the zero vector.  (Contributed by NM, 16-Aug-1999.)
     (New usage is discouraged.) $)
  ax-hvaddid $a |- ( A e. ~H -> ( A +h 0h ) = A ) $.

  $( Scalar multiplication is an operation on ` CC ` and ` ~H ` .  (Contributed
     by NM, 16-Aug-1999.)  (New usage is discouraged.) $)
  ax-hfvmul $a |- .h : ( CC X. ~H ) --> ~H $.

  $( Scalar multiplication by one.  (Contributed by NM, 30-May-1999.)
     (New usage is discouraged.) $)
  ax-hvmulid $a |- ( A e. ~H -> ( 1 .h A ) = A ) $.

  $( Scalar multiplication associative law.  (Contributed by NM, 30-May-1999.)
     (New usage is discouraged.) $)
  ax-hvmulass $a |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) ->
                 ( ( A x. B ) .h C ) = ( A .h ( B .h C ) ) ) $.

  $( Scalar multiplication distributive law.  (Contributed by NM, 3-Sep-1999.)
     (New usage is discouraged.) $)
  ax-hvdistr1 $a |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( A .h ( B +h C ) ) = ( ( A .h B ) +h ( A .h C ) ) ) $.

  $( Scalar multiplication distributive law.  (Contributed by NM,
     30-May-1999.)  (New usage is discouraged.) $)
  ax-hvdistr2 $a |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) ->
                ( ( A + B ) .h C ) = ( ( A .h C ) +h ( B .h C ) ) ) $.

  $( Scalar multiplication by zero.  We can derive the existence of the
     negative of a vector from this axiom (see ~ hvsubid and ~ hvsubval ).
     (Contributed by NM, 29-May-1999.)  (New usage is discouraged.) $)
  ax-hvmul0 $a |- ( A e. ~H -> ( 0 .h A ) = 0h ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Vector operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The Hilbert space scalar product operation is a set.  (Contributed by NM,
     17-Apr-2007.)  (New usage is discouraged.) $)
  hvmulex $p |- .h e. _V $=
    ( cc chil cxp csm wf cvv wcel ax-hfvmul cnex ax-hilex xpex fex mp2an ) ABCZ
    BDENFGDFGHABIJKNBFDLM $.

  $( Closure of vector addition.  (Contributed by NM, 18-Apr-2007.)
     (New usage is discouraged.) $)
  hvaddcl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h B ) e. ~H ) $=
    ( chil cva ax-hfvadd fovcl ) ABCCCDEF $.

  $( Closure of scalar multiplication.  (Contributed by NM, 19-Apr-2007.)
     (New usage is discouraged.) $)
  hvmulcl $p |- ( ( A e. CC /\ B e. ~H ) -> ( A .h B ) e. ~H ) $=
    ( chil cc csm ax-hfvmul fovcl ) ABCDCEFG $.

  ${
    hvmulcl.1 $e |- A e. CC $.
    hvmulcl.2 $e |- B e. ~H $.
    $( Closure inference for scalar multiplication.  (Contributed by NM,
       1-Aug-1999.)  (New usage is discouraged.) $)
    hvmulcli $p |- ( A .h B ) e. ~H $=
      ( cc wcel chil csm co hvmulcl mp2an ) AEFBGFABHIGFCDABJK $.
  $}

  ${
    $d x y $.
    $( Mapping domain and codomain of vector subtraction.  (Contributed by NM,
       6-Sep-2007.)  (New usage is discouraged.) $)
    hvsubf $p |- -h : ( ~H X. ~H ) --> ~H $=
      ( vx vy cv c1 cneg csm co cva chil wcel wral cxp cmv wf cc neg1cn hvmulcl
      mpan hvaddcl sylan2 rgen2a df-hvsub fmpt2 mpbi ) ACZDEZBCZFGZHGZIJZBIKAIK
      IILIMNUJABIUGIJZUEIJUHIJZUJUFOJUKULPUFUGQRUEUHSTUAABIIUIIMABUBUCUD $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Value of vector subtraction.  (Contributed by NM, 5-Sep-1999.)  (Revised
       by Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    hvsubval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                    ( A -h B ) = ( A +h ( -u 1 .h B ) ) ) $=
      ( vx vy chil cv c1 cneg csm cva cmv oveq1 wceq oveq2 oveq2d df-hvsub ovex
      co ovmpt2 ) CDABEECFZGHZDFZIRZJRAUABIRZJRKAUCJRTAUCJLUBBMUCUDAJUBBUAINOCD
      PAUDJQS $.
  $}

  $( Closure of vector subtraction.  (Contributed by NM, 17-Aug-1999.)
     (New usage is discouraged.) $)
  hvsubcl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A -h B ) e. ~H ) $=
    ( chil wcel wa cmv co c1 cneg csm hvsubval cc neg1cn hvmulcl hvaddcl sylan2
    cva mpan eqeltrd ) ACDZBCDZEABFGAHIZBJGZQGZCABKUATUCCDZUDCDUBLDUAUEMUBBNRAU
    COPS $.

  ${
    hvaddcl.1 $e |- A e. ~H $.
    hvaddcl.2 $e |- B e. ~H $.
    $( Closure of vector addition.  (Contributed by NM, 1-Aug-1999.)
       (New usage is discouraged.) $)
    hvaddcli $p |- ( A +h B ) e. ~H $=
      ( chil wcel cva co hvaddcl mp2an ) AEFBEFABGHEFCDABIJ $.

    $( Commutation of vector addition.  (Contributed by NM, 3-Sep-1999.)
       (New usage is discouraged.) $)
    hvcomi $p |- ( A +h B ) = ( B +h A ) $=
      ( chil wcel cva co wceq ax-hvcom mp2an ) AEFBEFABGHBAGHICDABJK $.

    $( Value of vector subtraction definition.  (Contributed by NM,
       3-Sep-1999.)  (New usage is discouraged.) $)
    hvsubvali $p |- ( A -h B ) = ( A +h ( -u 1 .h B ) ) $=
      ( chil wcel cmv co c1 cneg csm cva wceq hvsubval mp2an ) AEFBEFABGHAIJBKH
      LHMCDABNO $.

    $( Closure of vector subtraction.  (Contributed by NM, 2-Aug-1999.)
       (New usage is discouraged.) $)
    hvsubcli $p |- ( A -h B ) e. ~H $=
      ( chil wcel cmv co hvsubcl mp2an ) AEFBEFABGHEFCDABIJ $.
  $}

  $( Addition with the zero vector.  (Contributed by NM, 18-Oct-1999.)
     (New usage is discouraged.) $)
  hvaddid2 $p |- ( A e. ~H -> ( 0h +h A ) = A ) $=
    ( chil wcel c0v cva co wceq ax-hv0cl ax-hvcom mpan2 ax-hvaddid eqtr3d ) ABC
    ZADEFZDAEFZAMDBCNOGHADIJAKL $.

  $( Scalar multiplication with the zero vector.  (Contributed by NM,
     30-May-1999.)  (New usage is discouraged.) $)
  hvmul0 $p |- ( A e. CC -> ( A .h 0h ) = 0h ) $=
    ( cc wcel c0v cc0 csm cmul mul01 oveq1d chil wceq ax-hv0cl ax-hvmul0 syl6eq
    co ax-mp 0cn ax-hvmulass mp3an23 eqtr3d oveq2i syl6req ) ABCZDAEDFOZFOZADFO
    UCAEGOZDFOZDUEUCUGUDDUCUFEDFAHIDJCZUDDKLDMPZNUCEBCUHUGUEKQLAEDRSTUDDAFUIUAU
    B $.

  $( If a scalar product is zero, one of its factors must be zero.
     (Contributed by NM, 19-May-2005.)  (New usage is discouraged.) $)
  hvmul0or $p |- ( ( A e. CC /\ B e. ~H ) ->
                  ( ( A .h B ) = 0h <-> ( A = 0 \/ B = 0h ) ) ) $=
    ( cc wcel wa csm co c0v wceq c1 oveq2 ad2antlr adantlr 3eqtr3d hvmul0 ex wi
    cc0 eqeq1d syl5ibrcom chil wo wn df-ne cdiv cmul recid2 oveq1d reccl simpll
    wne simplr ax-hvmulass syl3anc ax-hvmulid syl syl5bir orrd ax-hvmul0 adantl
    oveq1 adantr jaod impbid ) ACDZBUADZEZABFGZHIZARIZBHIZUBZVGVIVLVGVIEZVJVKVJ
    UCARUKZVMVKARUDVMVNVKVMVNEJAUEGZVHFGZVOHFGZBHVIVPVQIVGVNVHHVOFKLVGVNVPBIVIV
    GVNEZVOAUFGZBFGZJBFGZVPBVEVNVTWAIVFVEVNEZVSJBFAUGUHMVRVOCDZVEVFVTVPIVEVNWCV
    FAUIZMVEVFVNUJVEVFVNULVOABUMUNVFWABIVEVNBUOLNMVGVNVQHIZVIVEVNWEVFWBWCWEWDVO
    OUPMMNPUQURPVGVJVIVKVFVJVIQVEVFVIVJRBFGZHIBUSVJVHWFHARBFVASTUTVEVKVIQVFVEVI
    VKAHFGZHIAOVKVHWGHBHAFKSTVBVCVD $.

  $( Subtraction of a vector from itself.  (Contributed by NM, 30-May-1999.)
     (New usage is discouraged.) $)
  hvsubid $p |- ( A e. ~H -> ( A -h A ) = 0h ) $=
    ( chil wcel cmv co cc0 csm c0v cneg caddc cva ax-hvmulid oveq1d wceq ax-1cn
    c1 cc neg1cn ax-hvdistr2 mp3an12 hvsubval anidms negidi oveq1i syl6eq eqtrd
    3eqtr4rd ax-hvmul0 ) ABCZAADEZFAGEZHUIUJPPIZJEZAGEZUKUIPAGEZULAGEZKEZAUPKEZ
    UNUJUIUOAUPKALMPQCULQCUIUNUQNORPULASTUIUJURNAAUAUBUGUMFAGPOUCUDUEAUHUF $.

  $( Addition of negative of a vector to itself.  (Contributed by NM,
     4-Jun-2004.)  (New usage is discouraged.) $)
  hvnegid $p |- ( A e. ~H -> ( A +h ( -u 1 .h A ) ) = 0h ) $=
    ( chil wcel cmv co c1 cneg csm cva c0v wceq hvsubval anidms hvsubid eqtr3d
    ) ABCZAADEZAFGAHEIEZJPQRKAALMANO $.

  $( Two ways to express the negative of a vector.  (Contributed by NM,
     23-May-2005.)  (New usage is discouraged.) $)
  hv2neg $p |- ( A e. ~H -> ( 0h -h A ) = ( -u 1 .h A ) ) $=
    ( chil wcel c0v cmv cneg csm cva wceq ax-hv0cl hvsubval mpan neg1cn hvmulcl
    co c1 cc hvaddid2 syl eqtrd ) ABCZDAEOZDPFZAGOZHOZUDDBCUAUBUEIJDAKLUAUDBCZU
    EUDIUCQCUAUFMUCANLUDRST $.

  ${
    hvaddid2.1 $e |- A e. ~H $.
    $( Addition with the zero vector.  (Contributed by NM, 18-Aug-1999.)
       (New usage is discouraged.) $)
    hvaddid2i $p |- ( 0h +h A ) = A $=
      ( chil wcel c0v cva co wceq hvaddid2 ax-mp ) ACDEAFGAHBAIJ $.

    $( Addition of negative of a vector to itself.  (Contributed by NM,
       18-Aug-1999.)  (New usage is discouraged.) $)
    hvnegidi $p |- ( A +h ( -u 1 .h A ) ) = 0h $=
      ( chil wcel c1 cneg csm co cva c0v wceq hvnegid ax-mp ) ACDAEFAGHIHJKBALM
      $.

    $( Two ways to express the negative of a vector.  (Contributed by NM,
       31-Oct-1999.)  (New usage is discouraged.) $)
    hv2negi $p |- ( 0h -h A ) = ( -u 1 .h A ) $=
      ( chil wcel c0v cmv co c1 cneg csm wceq hv2neg ax-mp ) ACDEAFGHIAJGKBALM
      $.
  $}

  $( Convert minus one times a scalar product to the negative of the scalar.
     (Contributed by NM, 4-Jun-2004.)  (New usage is discouraged.) $)
  hvm1neg $p |- ( ( A e. CC /\ B e. ~H ) ->
                 ( -u 1 .h ( A .h B ) ) = ( -u A .h B ) ) $=
    ( cc wcel chil wa c1 cneg cmul co csm wceq neg1cn ax-hvmulass mp3an1 adantr
    mulm1 oveq1d eqtr3d ) ACDZBEDZFZGHZAIJZBKJZUCABKJKJZAHZBKJUCCDTUAUEUFLMUCAB
    NOUBUDUGBKTUDUGLUAAQPRS $.

  $( Value of vector addition in terms of vector subtraction.  (Contributed by
     NM, 10-Jun-2006.)  (New usage is discouraged.) $)
  hvaddsubval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( A +h B ) = ( A -h ( -u 1 .h B ) ) ) $=
    ( chil wcel wa c1 cneg csm cmv cva wceq neg1cn hvmulcl mpan hvsubval sylan2
    co cc hvm1neg ax-1cn negnegi oveq1i syl6eq ax-hvmulid adantl oveq2d eqtr2d
    eqtrd ) ACDZBCDZEZAFGZBHQZIQZAULUMHQZJQZABJQUJUIUMCDZUNUPKULRDZUJUQLULBMNAU
    MOPUKUOBAJUJUOBKUIUJUOFBHQZBUJUOULGZBHQZUSURUJUOVAKLULBSNUTFBHFTUAUBUCBUDUH
    UEUFUG $.

  $( Commutative/associative law.  (Contributed by NM, 16-Oct-1999.)
     (New usage is discouraged.) $)
  hvadd32 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
               ( ( A +h B ) +h C ) = ( ( A +h C ) +h B ) ) $=
    ( chil wcel w3a cva co wceq ax-hvcom oveq2d 3adant1 ax-hvass 3com23 3eqtr4d
    wa ) ADEZBDEZCDEZFABCGHZGHZACBGHZGHZABGHCGHACGHBGHZRSUAUCIQRSPTUBAGBCJKLABC
    MQSRUDUCIACBMNO $.

  $( Commutative/associative law.  (Contributed by NM, 19-Oct-1999.)
     (New usage is discouraged.) $)
  hvadd12 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
               ( A +h ( B +h C ) ) = ( B +h ( A +h C ) ) ) $=
    ( chil wcel w3a cva co wceq ax-hvcom oveq1d 3adant3 ax-hvass 3com12 3eqtr3d
    wa ) ADEZBDEZCDEZFABGHZCGHZBAGHZCGHZABCGHGHBACGHGHZQRUAUCISQRPTUBCGABJKLABC
    MRQSUCUDIBACMNO $.

  $( Hilbert vector space addition law.  (Contributed by NM, 16-Oct-1999.)
     (New usage is discouraged.) $)
  hvadd4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
               ( ( A +h B ) +h ( C +h D ) ) = ( ( A +h C ) +h ( B +h D ) ) ) $=
    ( chil wcel wa cva co wceq w3a hvadd32 3expa adantrr hvaddcl ax-hvass 3expb
    oveq1d sylan an4s 3eqtr3d ) AEFZBEFZGZCEFZDEFZGZGABHIZCHIZDHIZACHIZBHIZDHIZ
    UHCDHIHIZUKBDHIHIZUDUEUJUMJZUFUBUCUEUPUBUCUEKUIULDHABCLRMNUDUHEFZUGUJUNJZAB
    OUQUEUFURUHCDPQSUBUEUCUFUMUOJZUBUEGUKEFZUCUFGUSACOUTUCUFUSUKBDPQSTUA $.

  $( Hilbert vector space addition/subtraction law.  (Contributed by NM,
     17-Oct-1999.)  (New usage is discouraged.) $)
  hvsub4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
               ( ( A +h B ) -h ( C +h D ) ) = ( ( A -h C ) +h ( B -h D ) ) ) $=
    ( chil wcel wa cva cmv csm wceq hvaddcl hvsubval neg1cn hvmulcl mpan anim2i
    co c1 eqtr4d cneg syl2an ad2ant2r ad2ant2l ax-hvdistr1 mp3an1 adantl oveq2d
    oveq12d cc anim12i an4s hvadd4 syl ) AEFZBEFZGZCEFZDEFZGZGZABHRZCDHRZIRZVBS
    UAZVCJRZHRZACIRZBDIRZHRZUQVBEFVCEFVDVGKUTABLCDLVBVCMUBVAVJAVECJRZHRZBVEDJRZ
    HRZHRZVGVAVHVLVIVNHUOURVHVLKUPUSACMUCUPUSVIVNKUOURBDMUDUIVAVGVBVKVMHRZHRZVO
    VAVFVPVBHUTVFVPKZUQVEUJFZURUSVRNVECDUEUFUGUHVAUOVKEFZGZUPVMEFZGZGZVOVQKUOUR
    UPUSWDUOURGWAUPUSGWCURVTUOVSURVTNVECOPQUSWBUPVSUSWBNVEDOPQUKULAVKBVMUMUNTTT
    $.

  $( Commutative/associative law.  (Contributed by NM, 19-Oct-1999.)
     (New usage is discouraged.) $)
  hvaddsub12 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
               ( A +h ( B -h C ) ) = ( B +h ( A -h C ) ) ) $=
    ( chil wcel w3a c1 cneg csm co cva cmv wceq cc neg1cn hvmulcl mpan hvsubval
    wa oveq2d hvadd12 syl3an3 3adant1 3adant2 3eqtr4d ) ADEZBDEZCDEZFABGHZCIJZK
    JZKJZBAUJKJZKJZABCLJZKJZBACLJZKJZUHUFUGUJDEZULUNMUINEUHUSOUICPQABUJUAUBUGUH
    UPULMUFUGUHSUOUKAKBCRTUCUFUHURUNMUGUFUHSUQUMBKACRTUDUE $.

  $( Addition/subtraction cancellation law for vectors in Hilbert space.
     (Contributed by NM, 7-Jun-2004.)  (New usage is discouraged.) $)
  hvpncan $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( A +h B ) -h B ) = A ) $=
    ( chil wcel wa cva co cmv c1 cneg csm wceq hvaddcl hvsubval sylancom neg1cn
    cc hvmulcl mpan c0v ancli ax-hvass 3expb sylan2 oveq2d ax-hvaddid sylan9eqr
    hvnegid 3eqtrd ) ACDZBCDZEABFGZBHGZULIJZBKGZFGZABUOFGZFGZAUJUKULCDUMUPLABMU
    LBNOUKUJUKUOCDZEUPURLZUKUSUNQDUKUSPUNBRSUAUJUKUSUTABUOUBUCUDUKUJURATFGAUKUQ
    TAFBUHUEAUFUGUI $.

  $( Addition/subtraction cancellation law for vectors in Hilbert space.
     (Contributed by NM, 7-Jun-2004.)  (New usage is discouraged.) $)
  hvpncan2 $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( A +h B ) -h A ) = B ) $=
    ( chil wcel cva co cmv wceq wa ax-hvcom oveq1d hvpncan eqtr3d ancoms ) BCDZ
    ACDZABEFZAGFZBHOPIZBAEFZAGFRBSTQAGBAJKBALMN $.

  $( Associativity of sum and difference of Hilbert space vectors.
     (Contributed by NM, 27-Aug-2004.)  (New usage is discouraged.) $)
  hvaddsubass $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( ( A +h B ) -h C )
                     = ( A +h ( B -h C ) ) ) $=
    ( chil wcel w3a cva co c1 cneg csm cmv wceq cc neg1cn hvmulcl mpan ax-hvass
    syl3an3 hvsubval wa hvaddcl sylan 3impa 3adant1 oveq2d 3eqtr4d ) ADEZBDEZCD
    EZFZABGHZIJZCKHZGHZABUNGHZGHZULCLHZABCLHZGHUJUHUIUNDEZUOUQMUMNEUJUTOUMCPQAB
    UNRSUHUIUJURUOMZUHUIUAULDEUJVAABUBULCTUCUDUKUSUPAGUIUJUSUPMUHBCTUEUFUG $.

  $( Subtraction and addition of equal Hilbert space vectors.  (Contributed by
     NM, 27-Aug-2004.)  (New usage is discouraged.) $)
  hvpncan3 $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A +h ( B -h A ) ) = B ) $=
    ( chil wcel wa cva co cmv wceq hvaddsubass 3anidm13 hvpncan2 eqtr3d ) ACDZB
    CDZEABFGAHGZABAHGFGZBNOPQIABAJKABLM $.

  $( Scalar multiplication commutative law.  (Contributed by NM, 19-May-2005.)
     (New usage is discouraged.) $)
  hvmulcom $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) ->
                 ( A .h ( B .h C ) ) = ( B .h ( A .h C ) ) ) $=
    ( cc wcel chil w3a cmul co wceq wa mulcom oveq1d 3adant3 ax-hvmulass 3com12
    csm 3eqtr3d ) ADEZBDEZCFEZGABHIZCQIZBAHIZCQIZABCQIQIBACQIQIZSTUCUEJUASTKUBU
    DCQABLMNABCOTSUAUEUFJBACOPR $.

  $( Hilbert vector space associative law for subtraction.  (Contributed by
     Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
  hvsubass $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                   ( ( A -h B ) -h C ) = ( A -h ( B +h C ) ) ) $=
    ( chil wcel w3a c1 cneg csm co cva cmv wceq cc neg1cn hvmulcl mpan hvsubval
    3adant1 eqtr4d hvaddsubass syl3an2 3adant3 oveq1d simp1 hvaddcl ax-hvdistr1
    syl2anc sylan mp3an1 oveq2d 3eqtr4d ) ADEZBDEZCDEZFZAGHZBIJZKJZCLJZAURCLJZK
    JZABLJZCLJABCKJZLJZUNUMURDEZUOUTVBMUQNEZUNVFOUQBPQZAURCUAUBUPVCUSCLUMUNVCUS
    MUOABRUCUDUPVEAUQVDIJZKJZVBUPUMVDDEZVEVJMUMUNUOUEUNUOVKUMBCUFSAVDRUHUPVAVIA
    KUPVAURUQCIJKJZVIUNUOVAVLMZUMUNVFUOVMVHURCRUISUNUOVIVLMZUMVGUNUOVNOUQBCUGUJ
    STUKTUL $.

  $( Hilbert vector space commutative/associative law.  (Contributed by Mario
     Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
  hvsub32 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h B ) -h C ) = ( ( A -h C ) -h B ) ) $=
    ( chil wcel w3a cva co wceq ax-hvcom 3adant1 oveq2d hvsubass 3com23 3eqtr4d
    cmv ) ADEZBDEZCDEZFZABCGHZPHACBGHZPHZABPHCPHACPHBPHZTUAUBAPRSUAUBIQBCJKLABC
    MQSRUDUCIACBMNO $.

  ${
    hvmulcom.1 $e |- A e. CC $.
    hvmulcom.2 $e |- B e. CC $.
    hvmulcom.3 $e |- C e. ~H $.
    $( Scalar multiplication associative law.  (Contributed by NM,
       3-Sep-1999.)  (New usage is discouraged.) $)
    hvmulassi $p |- ( ( A x. B ) .h C ) = ( A .h ( B .h C ) ) $=
      ( cc wcel chil cmul co csm wceq ax-hvmulass mp3an ) AGHBGHCIHABJKCLKABCLK
      LKMDEFABCNO $.

    $( Scalar multiplication commutative law.  (Contributed by NM,
       3-Sep-1999.)  (New usage is discouraged.) $)
    hvmulcomi $p |- ( A .h ( B .h C ) ) = ( B .h ( A .h C ) ) $=
      ( cc wcel chil csm co wceq hvmulcom mp3an ) AGHBGHCIHABCJKJKBACJKJKLDEFAB
      CMN $.

    $( Double negative in scalar multiplication.  (Contributed by NM,
       3-Sep-1999.)  (New usage is discouraged.) $)
    hvmul2negi $p |- ( -u A .h ( -u B .h C ) ) = ( A .h ( B .h C ) ) $=
      ( cneg cmul co csm mul2negi oveq1i negcli hvmulassi 3eqtr3i ) AGZBGZHIZCJ
      IABHIZCJIPQCJIJIABCJIJIRSCJABDEKLPQCADMBEMFNABCDEFNO $.
  $}

  $( Scalar multiplication distributive law for subtraction.  (Contributed by
     NM, 19-May-2005.)  (New usage is discouraged.) $)
  hvsubdistr1 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                    ( A .h ( B -h C ) ) = ( ( A .h B ) -h ( A .h C ) ) ) $=
    ( cc wcel chil w3a cneg csm cva cmv wceq neg1cn hvmulcl mpan oveq2d 3adant2
    c1 co hvsubval ax-hvdistr1 syl3an3 wa hvmulcom mp3an2 eqtrd 3adant1 3adant3
    syl2anc 3eqtr4d ) ADEZBFEZCFEZGZABRHZCISZJSZISZABISZUOACISZISZJSZABCKSZISUS
    UTKSZUNURUSAUPISZJSZVBUMUKULUPFEZURVFLUODEZUMVGMUOCNOABUPUAUBUKUMVFVBLULUKU
    MUCVEVAUSJUKVHUMVEVALMAUOCUDUEPQUFUNVCUQAIULUMVCUQLUKBCTUGPUNUSFEZUTFEZVDVB
    LUKULVIUMABNUHUKUMVJULACNQUSUTTUIUJ $.

  $( Scalar multiplication distributive law for subtraction.  (Contributed by
     NM, 19-May-2005.)  (New usage is discouraged.) $)
  hvsubdistr2 $p |- ( ( A e. CC /\ B e. CC /\ C e. ~H ) -> ( ( A - B ) .h C
      ) = ( ( A .h C ) -h ( B .h C ) ) ) $=
    ( cc wcel chil w3a csm co cmv c1 cneg cva cmin wceq hvmulcl 3adant2 3adant1
    oveq1d eqtr3d hvsubval syl2anc cmul adantr neg1cn ax-hvmulass mp3an1 oveq2d
    wa mulm1 caddc negcl ax-hvdistr2 syl3an2 negsub 3adant3 3eqtr2rd ) ADEZBDEZ
    CFEZGZACHIZBCHIZJIZVBKLZVCHIZMIZVBBLZCHIZMIZABNIZCHIZVAVBFEZVCFEZVDVGOURUTV
    MUSACPQUSUTVNURBCPRVBVCUAUBVAVIVFVBMUSUTVIVFOURUSUTUIVEBUCIZCHIZVIVFUSVPVIO
    UTUSVOVHCHBUJSUDVEDEUSUTVPVFOUEVEBCUFUGTRUHVAAVHUKIZCHIZVJVLUSURVHDEUTVRVJO
    BULAVHCUMUNVAVQVKCHURUSVQVKOUTABUOUPSTUQ $.

  ${
    hvdistr1.1 $e |- A e. CC $.
    hvdistr1.2 $e |- B e. ~H $.
    hvdistr1.3 $e |- C e. ~H $.
    $( Scalar multiplication distributive law.  (Contributed by NM,
       3-Sep-1999.)  (New usage is discouraged.) $)
    hvdistr1i $p |- ( A .h ( B +h C ) ) = ( ( A .h B ) +h ( A .h C ) ) $=
      ( cc wcel chil cva co csm wceq ax-hvdistr1 mp3an ) AGHBIHCIHABCJKLKABLKAC
      LKJKMDEFABCNO $.

    $( Scalar multiplication distributive law.  (Contributed by NM,
       3-Sep-1999.)  (New usage is discouraged.) $)
    hvsubdistr1i $p |- ( A .h ( B -h C ) ) = ( ( A .h B ) -h ( A .h C ) ) $=
      ( cc wcel chil cmv co csm wceq hvsubdistr1 mp3an ) AGHBIHCIHABCJKLKABLKAC
      LKJKMDEFABCNO $.
  $}

  ${
    hvass.1 $e |- A e. ~H $.
    hvass.2 $e |- B e. ~H $.
    hvass.3 $e |- C e. ~H $.
    $( Hilbert vector space associative law.  (Contributed by NM, 3-Sep-1999.)
       (New usage is discouraged.) $)
    hvassi $p |- ( ( A +h B ) +h C ) = ( A +h ( B +h C ) ) $=
      ( chil wcel cva co wceq ax-hvass mp3an ) AGHBGHCGHABIJCIJABCIJIJKDEFABCLM
      $.

    $( Hilbert vector space commutative/associative law.  (Contributed by NM,
       18-Aug-1999.)  (New usage is discouraged.) $)
    hvadd32i $p |- ( ( A +h B ) +h C ) = ( ( A +h C ) +h B ) $=
      ( chil wcel cva co wceq hvadd32 mp3an ) AGHBGHCGHABIJCIJACIJBIJKDEFABCLM
      $.

    $( Hilbert vector space associative law for subtraction.  (Contributed by
       NM, 7-Oct-1999.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    hvsubassi $p |- ( ( A -h B ) -h C ) = ( A -h ( B +h C ) ) $=
      ( chil wcel cmv co cva wceq hvsubass mp3an ) AGHBGHCGHABIJCIJABCKJIJLDEFA
      BCMN $.

    $( Hilbert vector space commutative/associative law.  (Contributed by NM,
       7-Oct-1999.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    hvsub32i $p |- ( ( A -h B ) -h C ) = ( ( A -h C ) -h B ) $=
      ( chil wcel cmv co wceq hvsub32 mp3an ) AGHBGHCGHABIJCIJACIJBIJKDEFABCLM
      $.

    $( Hilbert vector space commutative/associative law.  (Contributed by NM,
       11-Sep-1999.)  (New usage is discouraged.) $)
    hvadd12i $p |- ( A +h ( B +h C ) ) = ( B +h ( A +h C ) ) $=
      ( cva co hvcomi oveq1i hvassi 3eqtr3i ) ABGHZCGHBAGHZCGHABCGHGHBACGHGHMNC
      GABDEIJABCDEFKBACEDFKL $.

    ${
      hvadd4.4 $e |- D e. ~H $.
      $( Hilbert vector space addition law.  (Contributed by NM, 3-Sep-1999.)
         (New usage is discouraged.) $)
      hvadd4i $p |- ( ( A +h B ) +h ( C +h D ) ) =
                   ( ( A +h C ) +h ( B +h D ) ) $=
        ( chil wcel cva co wceq hvadd4 mp4an ) AIJBIJCIJDIJABKLCDKLKLACKLBDKLKL
        MEFGHABCDNO $.

      $( Hilbert vector space addition law.  (Contributed by NM, 31-Oct-1999.)
         (New usage is discouraged.) $)
      hvsubsub4i $p |- ( ( A -h B ) -h ( C -h D ) ) =
                      ( ( A -h C ) -h ( B -h D ) ) $=
        ( csm cva cmv neg1cn hvmulcli hvdistr1i oveq2i 3eqtr4i hvaddcli oveq12i
        co hvsubvali c1 cneg hvadd4i ) AUAUBZBISZJSZCUDDISZJSZKSZAUDCISZJSZBUGJ
        SZKSZABKSZCDKSZKSACKSZBDKSZKSUFUDUHISZJSZUKUDULISZJSZUIUMUFUJUDUGISZJSZ
        JSUKUEVBJSZJSUSVAAUEUJVBEUDBLFMZUDCLGMZUDUGLUDDLHMZMUCURVCUFJUDCUGLGVGN
        OUTVDUKJUDBUGLFVGNOPUFUHAUEEVEQCUGGVGQTUKULAUJEVFQBUGFVGQTPUNUFUOUHKABE
        FTCDGHTRUPUKUQULKACEGTBDFHTRP $.
    $}
  $}

  $( Hilbert vector space addition/subtraction law.  (Contributed by NM,
     2-Apr-2000.)  (New usage is discouraged.) $)
  hvsubsub4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) )
            -> ( ( A -h B ) -h ( C -h D ) ) = ( ( A -h C ) -h ( B -h D ) ) ) $=
    ( chil wcel cmv co wceq c0v cif oveq1 oveq1d eqeq12d oveq2d ax-hv0cl elimel
    oveq2 hvsubsub4i dedth4h ) AEFZBEFZCEFZDEFZABGHZCDGHZGHZACGHZBDGHZGHZIUAAJK
    ZBGHZUFGHZUKCGHZUIGHZIUKUBBJKZGHZUFGHZUNUPDGHZGHZIUQUCCJKZDGHZGHZUKVAGHZUSG
    HZIUQVAUDDJKZGHZGHZVDUPVFGHZGHZIABCDJJJJAUKIZUGUMUJUOVKUEULUFGAUKBGLMVKUHUN
    UIGAUKCGLMNBUPIZUMURUOUTVLULUQUFGBUPUKGRMVLUIUSUNGBUPDGLONCVAIZURVCUTVEVMUF
    VBUQGCVADGLOVMUNVDUSGCVAUKGRMNDVFIZVCVHVEVJVNVBVGUQGDVFVAGROVNUSVIVDGDVFUPG
    RONUKUPVAVFAJEPQBJEPQCJEPQDJEPQST $.

  $( Two times a vector.  (Contributed by NM, 22-Jun-2006.)
     (New usage is discouraged.) $)
  hv2times $p |- ( A e. ~H -> ( 2 .h A ) = ( A +h A ) ) $=
    ( chil wcel c2 csm co cva caddc df-2 oveq1i wceq ax-1cn ax-hvdistr2 mp3an12
    c1 cc syl5eq ax-hvdistr1 mp3an1 anidms hvaddcl ax-hvmulid syl 3eqtr2d ) ABC
    ZDAEFZOAEFZUGGFZOAAGFZEFZUIUEUFOOHFZAEFZUHDUKAEIJOPCZUMUEULUHKLLOOAMNQUEUJU
    HKZUMUEUEUNLOAARSTUEUIBCZUJUIKUEUOAAUATUIUBUCUD $.

  ${
    hvnegdi.1 $e |- A e. ~H $.
    hvnegdi.2 $e |- B e. ~H $.
    $( Distribution of negative over subtraction.  (Contributed by NM,
       31-Oct-1999.)  (New usage is discouraged.) $)
    hvnegdii $p |- ( -u 1 .h ( A -h B ) ) = ( B -h A ) $=
      ( cneg cmv csm cva hvsubvali oveq2i neg1cn hvmulcli hvdistr1i cmul ax-1cn
      c1 co mul2negi 1t1e1 oveq1i eqtri hvmulassi chil ax-hvmulid ax-mp 3eqtr3i
      wcel wceq hvcomi 3eqtr4i 3eqtri ) PEZABFQZGQULAULBGQZHQZGQULAGQZULUNGQZHQ
      ZBAFQZUMUOULGABCDIJULAUNKCULBKDLZMUQUPHQBUPHQURUSUQBUPHULULNQZBGQPBGQZUQB
      VAPBGVAPPNQPPPOORSUATULULBKKDUBBUCUGVBBUHDBUDUEUFTUPUQULAKCLULUNKUTLUIBAD
      CIUJUK $.

    $( If the difference between two vectors is zero, they are equal.
       (Contributed by NM, 18-Aug-1999.)  (New usage is discouraged.) $)
    hvsubeq0i $p |- ( ( A -h B ) = 0h <-> A = B ) $=
      ( cmv co c0v wceq c1 cneg csm cva hvsubvali eqeq1i oveq1 sylbi chil ax-mp
      wcel eqtri neg1cn hvmulcli hvadd32i hvnegidi ax-hvaddid hvaddid2i 3eqtr3g
      hvassi oveq2i hvsubid syl6eq impbii ) ABEFZGHZABHZUNAIJZBKFZLFZBLFZGBLFZA
      BUNURGHUSUTHUMURGABCDMNURGBLOPUSABLFUQLFZAAUQBCUPBUADUBZDUCVAABUQLFZLFZAA
      BUQCDVBUHVDAGLFZAVCGALBDUDUIAQSVEAHCAUERTTTBDUFUGUOUMBBEFZGABBEOBQSVFGHDB
      UJRUKUL $.

    $( Vector cancellation law.  (Contributed by NM, 3-Sep-1999.)
       (New usage is discouraged.) $)
    hvsubcan2i $p |- ( ( A +h B ) +h ( A -h B ) ) = ( 2 .h A ) $=
      ( cva co cmv c1 cneg csm c2 hvsubvali oveq2i c0v hvmulcli chil wcel ax-mp
      wceq eqtri neg1cn hvadd4i hv2times eqcomi hvnegidi oveq12i 2cn ax-hvaddid
      ) ABEFZABGFZEFUIAHIZBJFZEFZEFZKAJFZUJUMUIEABCDLMUNUONEFZUOUNAAEFZBULEFZEF
      UPABAULCDCUKBUADOUBUQUOURNEUOUQAPQUOUQSCAUCRUDBDUEUFTUOPQUPUOSKAUGCOUOUHR
      TT $.

    ${
      hvaddcan.3 $e |- C e. ~H $.
      $( Cancellation law for vector addition.  (Contributed by NM,
         11-Sep-1999.)  (New usage is discouraged.) $)
      hvaddcani $p |- ( ( A +h B ) = ( A +h C ) <-> B = C ) $=
        ( cva co wceq c1 cneg csm c0v neg1cn hvmulcli hvadd32i oveq1i hvaddid2i
        oveq1 3eqtri hvnegidi 3eqtr3g oveq2 impbii ) ABGHZACGHZIZBCIUGUEJKZALHZ
        GHZUFUIGHZBCUEUFUIGSUJAUIGHZBGHMBGHBABUIDEUHANDOZPULMBGADUAZQBERTUKULCG
        HMCGHCACUIDFUMPULMCGUNQCFRTUBBCAGUCUD $.

      $( Relationship between vector subtraction and addition.  (Contributed by
         NM, 11-Sep-1999.)  (New usage is discouraged.) $)
      hvsubaddi $p |- ( ( A -h B ) = C <-> ( B +h C ) = A ) $=
        ( cmv co wceq c1 cneg csm cva hvsubvali eqeq1i neg1cn hvmulcli hvadd12i
        c0v hvnegidi oveq2i chil wcel ax-hvaddid ax-mp hvaddcli hvaddcani eqcom
        3eqtri 3bitr3i bitri ) ABGHZCIAJKZBLHZMHZCIZBCMHZAIZULUOCABDENOBUOMHZUQ
        IAUQIUPURUSAUQUSABUNMHZMHASMHZABAUNEDUMBPEQZRUTSAMBETUAAUBUCVAAIDAUDUEU
        IOBUOCEAUNDVBUFFUGAUQUHUJUK $.
    $}
  $}

  $( Distribution of negative over subtraction.  (Contributed by NM,
     2-Apr-2000.)  (New usage is discouraged.) $)
  hvnegdi $p |- ( ( A e. ~H /\ B e. ~H ) ->
                ( -u 1 .h ( A -h B ) ) = ( B -h A ) ) $=
    ( chil wcel c1 cneg cmv co csm wceq c0v oveq1 oveq2d oveq2 eqeq12d ax-hv0cl
    cif elimel hvnegdii dedth2h ) ACDZBCDZEFZABGHZIHZBAGHZJUCUAAKQZBGHZIHZBUGGH
    ZJUCUGUBBKQZGHZIHZUKUGGHZJABKKAUGJZUEUIUFUJUOUDUHUCIAUGBGLMAUGBGNOBUKJZUIUM
    UJUNUPUHULUCIBUKUGGNMBUKUGGLOUGUKAKCPRBKCPRST $.

  $( If the difference between two vectors is zero, they are equal.
     (Contributed by NM, 23-Oct-1999.)  (New usage is discouraged.) $)
  hvsubeq0 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( A -h B ) = 0h <-> A = B ) ) $=
    ( chil wcel cmv co c0v wceq wb cif oveq1 eqeq1 bibi12d oveq2 eqeq2 ax-hv0cl
    eqeq1d elimel hvsubeq0i dedth2h ) ACDZBCDZABEFZGHZABHZIUAAGJZBEFZGHZUFBHZIU
    FUBBGJZEFZGHZUFUJHZIABGGAUFHZUDUHUEUIUNUCUGGAUFBEKQAUFBLMBUJHZUHULUIUMUOUGU
    KGBUJUFENQBUJUFOMUFUJAGCPRBGCPRST $.

  $( If the sum of two vectors is zero, one is the negative of the other.
     (Contributed by NM, 10-Jun-2006.)  (New usage is discouraged.) $)
  hvaddeq0 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( A +h B ) = 0h <-> A = ( -u 1 .h B ) ) ) $=
    ( chil wcel wa cva co c0v wceq c1 cneg csm cmv hvaddsubval eqeq1d wb neg1cn
    cc hvmulcl mpan hvsubeq0 sylan2 bitrd ) ACDZBCDZEZABFGZHIAJKZBLGZMGZHIZAUII
    ZUFUGUJHABNOUEUDUICDZUKULPUHRDUEUMQUHBSTAUIUAUBUC $.

  $( Cancellation law for vector addition.  (Contributed by NM, 18-May-2005.)
     (New usage is discouraged.) $)
  hvaddcan $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A +h B ) = ( A +h C ) <-> B = C ) ) $=
    ( chil wcel cva co wceq wb c0v cif oveq1 eqeq12d bibi1d oveq2 eqeq1 bibi12d
    eqeq1d ax-hv0cl elimel eqeq2d eqeq2 hvaddcani dedth3h ) ADEZBDEZCDEZABFGZAC
    FGZHZBCHZIUEAJKZBFGZULCFGZHZUKIULUFBJKZFGZUNHZUPCHZIUQULUGCJKZFGZHZUPUTHZIA
    BCJJJAULHZUJUOUKVDUHUMUIUNAULBFLAULCFLMNBUPHZUOURUKUSVEUMUQUNBUPULFORBUPCPQ
    CUTHZURVBUSVCVFUNVAUQCUTULFOUACUTUPUBQULUPUTAJDSTBJDSTCJDSTUCUD $.

  $( Cancellation law for vector addition.  (Contributed by NM, 18-May-2005.)
     (New usage is discouraged.) $)
  hvaddcan2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A +h C ) = ( B +h C ) <-> A = B ) ) $=
    ( chil wcel cva co wceq wb ax-hvcom 3adant3 3adant2 eqeq12d hvaddcan bitr3d
    w3a 3coml ) CDEZADEZBDEZACFGZBCFGZHZABHZIRSTPZCAFGZCBFGZHUCUDUEUFUAUGUBRSUF
    UAHTCAJKRTUGUBHSCBJLMCABNOQ $.

  $( Cancellation law for scalar multiplication.  (Contributed by NM,
     19-May-2005.)  (New usage is discouraged.) $)
  hvmulcan $p |- ( ( ( A e. CC /\ A =/= 0 ) /\ B e. ~H /\ C e. ~H )
               -> ( ( A .h B ) = ( A .h C ) <-> B = C ) ) $=
    ( cc wcel cc0 wne wa chil w3a cmv co c0v wo csm wb 3adant3 hvsubeq0 hvmulcl
    wceq df-ne biorf sylbi ad2antlr 3adant1 hvsubdistr1 eqeq1d hvsubcl hvmul0or
    wn sylan2 3impb 3adant2 syl2anc 3bitr3d 3adant1r 3bitr3rd ) ADEZAFGZHZBIEZC
    IEZJBCKLZMTZAFTZVDNZBCTZABOLZACOLZTZUTVAVDVFPZVBUSVKURVAUSVEUJVKAFUAVEVDUBU
    CUDQVAVBVDVGPUTBCRUEURVAVBVFVJPUSURVAVBJZAVCOLZMTZVHVIKLZMTZVFVJVLVMVOMABCU
    FUGURVAVBVNVFPZVAVBHURVCIEVQBCUHAVCUIUKULVLVHIEZVIIEZVPVJPURVAVRVBABSQURVBV
    SVAACSUMVHVIRUNUOUPUQ $.

  $( Cancellation law for scalar multiplication.  (Contributed by NM,
     19-May-2005.)  (New usage is discouraged.) $)
  hvmulcan2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. ~H /\ C =/= 0h ) ) ->
                  ( ( A .h C ) = ( B .h C ) <-> A = B ) ) $=
    ( cc wcel chil c0v wne wa w3a csm co cmv wb hvmulcl 3adant1 3adant3r bitr3d
    wceq wo 3adant2 hvsubeq0 syl2anc cmin cc0 hvsubdistr2 eqeq1d subcl hvmul0or
    sylan 3impa df-ne biorf orcom syl6bb sylbi ad2antll subeq0 3adant3 3bitr2d
    wn ) ADEZBDEZCFEZCGHZIZJZACKLZBCKLZMLZGSZVHVISZABSZVBVCVDVKVLNZVEVBVCVDJZVH
    FEZVIFEZVNVBVDVPVCACOUAVCVDVQVBBCOPVHVIUBUCQVGVKABUDLZUESZCGSZTZVSVMVBVCVDV
    KWANVEVOVRCKLZGSZVKWAVOWBVJGABCUFUGVBVCVDWCWANZVBVCIVRDEVDWDABUHVRCUIUJUKRQ
    VCVFVSWANZVBVEWEVCVDVEVTVAZWECGULWFVSVTVSTWAVTVSUMVTVSUNUOUPUQPVBVCVSVMNVFA
    BURUSUTR $.

  $( Cancellation law for vector addition.  (Contributed by NM, 18-May-2005.)
     (New usage is discouraged.) $)
  hvsubcan $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h B ) = ( A -h C ) <-> B = C ) ) $=
    ( chil wcel w3a cmv co wceq c1 cneg csm cva hvsubval 3adant3 3adant2 neg1cn
    wb hvmulcl mpan eqeq12d cc hvaddcan syl3an3 syl3an2 cc0 wne ax-1ne0 negne0i
    wa ax-1cn pm3.2i hvmulcan mp3an1 3adant1 3bitrd ) ADEZBDEZCDEZFZABGHZACGHZI
    AJKZBLHZMHZAVCCLHZMHZIZVDVFIZBCIZUTVAVEVBVGUQURVAVEIUSABNOUQUSVBVGIURACNPUA
    URUQVDDEZUSVHVIRZVCUBEZURVKQVCBSTUSUQVKVFDEZVLVMUSVNQVCCSTAVDVFUCUDUEURUSVI
    VJRZUQVMVCUFUGZUJURUSVOVMVPQJUKUHUIULVCBCUMUNUOUP $.

  $( Cancellation law for vector addition.  (Contributed by NM, 18-May-2005.)
     (New usage is discouraged.) $)
  hvsubcan2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h C ) = ( B -h C ) <-> A = B ) ) $=
    ( chil wcel cmv co wceq wb w3a cneg csm hvsubcl 3adant3 3adant2 cc0 hvnegdi
    c1 cc wne wa neg1cn ax-1cn ax-1ne0 negne0i pm3.2i hvmulcan syl2anc hvsubcan
    mp3an1 eqeq12d 3bitr3d 3coml ) CDEZADEZBDEZACFGZBCFGZHZABHZIUNUOUPJZRKZCAFG
    ZLGZVBCBFGZLGZHZVCVEHZUSUTVAVCDEZVEDEZVGVHIZUNUOVIUPCAMNUNUPVJUOCBMOVBSEZVB
    PTZUAVIVJVKVLVMUBRUCUDUEUFVBVCVEUGUJUHVAVDUQVFURUNUOVDUQHUPCAQNUNUPVFURHUOC
    BQOUKCABUIULUM $.

  $( Subtraction of a zero vector.  (Contributed by NM, 2-Apr-2000.)
     (New usage is discouraged.) $)
  hvsub0 $p |- ( A e. ~H -> ( A -h 0h ) = A ) $=
    ( chil wcel c0v cmv co cva c1 cneg csm wceq ax-hv0cl hvsubval neg1cn hvmul0
    mpan2 cc ax-mp oveq2i syl6eq ax-hvaddid eqtrd ) ABCZADEFZADGFZAUCUDAHIZDJFZ
    GFZUEUCDBCUDUHKLADMPUGDAGUFQCUGDKNUFORSTAUAUB $.

  $( Relationship between vector subtraction and addition.  (Contributed by NM,
     30-Oct-1999.)  (New usage is discouraged.) $)
  hvsubadd $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( A -h B ) = C <-> ( B +h C ) = A ) ) $=
    ( chil wcel cmv co cva wb c0v cif oveq1 eqeq1d eqeq2 bibi12d oveq2 ax-hv0cl
    wceq elimel hvsubaddi dedth3h ) ADEZBDEZCDEZABFGZCRZBCHGZARZIUBAJKZBFGZCRZU
    GUIRZIUIUCBJKZFGZCRZUMCHGZUIRZIUNUDCJKZRZUMURHGZUIRZIABCJJJAUIRZUFUKUHULVBU
    EUJCAUIBFLMAUIUGNOBUMRZUKUOULUQVCUJUNCBUMUIFPMVCUGUPUIBUMCHLMOCURRZUOUSUQVA
    CURUNNVDUPUTUICURUMHPMOUIUMURAJDQSBJDQSCJDQSTUA $.

  $( Hilbert vector space addition/subtraction law.  (Contributed by NM,
     18-May-2005.)  (New usage is discouraged.) $)
  hvaddsub4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
          ( ( A +h B ) = ( C +h D ) <-> ( A -h C ) = ( D -h B ) ) ) $=
    ( chil wcel wa cva co cmv wceq hvaddcl ancoms hvsub4 syldan hvsubid hvsubcl
    c0v syl 3eqtrd wb adantr adantl ad2ant2lr hvsubcan2 syl3anc anim2i ad2antlr
    simpr oveq2d ax-hvaddid adantlr adantrr simpl anim1i oveq1d adantll eqeq12d
    ad2antrr hvaddid2 bitr3d ) AEFZBEFZGZCEFZDEFZGZGZABHIZCBHIZJIZCDHIZVJJIZKZV
    IVLKZACJIZDBJIZKVHVIEFZVLEFZVJEFZVNVOUAVDVRVGABLUBVGVSVDCDLUCVCVEVTVBVFVEVC
    VTCBLMUDVIVLVJUEUFVHVKVPVMVQVDVEVKVPKVFVDVEGZVKVPBBJIZHIZVPRHIZVPVDVEVEVCGZ
    VKWCKVEVDWEVDVCVEVBVCUIUGMABCBNOWAWBRVPHVCWBRKVBVEBPUHUJVBVEWDVPKZVCVBVEGVP
    EFWFACQVPUKSULTUMVCVGVMVQKZVBVGVCWGVGVCGZVMCCJIZVQHIZRVQHIZVQVGVCWEVMWJKVGV
    EVCVEVFUNUOCDCBNOWHWIRVQHVEWIRKVFVCCPUSUPVFVCWKVQKZVEVFVCGVQEFWLDBQVQUTSUQT
    MUQURVA $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Inner product postulates for a Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Inner product maps pairs from ` ~H ` to ` CC ` .  (Contributed by NM,
     17-Nov-2007.)  (New usage is discouraged.) $)
  ax-hfi $a |- .ih : ( ~H X. ~H ) --> CC $.

  $( Closure of inner product.  (Contributed by NM, 17-Nov-2007.)
     (New usage is discouraged.) $)
  hicl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A .ih B ) e. CC ) $=
    ( cc chil csp ax-hfi fovcl ) ABCDDEFG $.

  ${
    hicl.1 $e |- A e. ~H $.
    hicl.2 $e |- B e. ~H $.
    $( Closure inference for inner product.  (Contributed by NM, 1-Aug-1999.)
       (New usage is discouraged.) $)
    hicli $p |- ( A .ih B ) e. CC $=
      ( chil wcel csp co cc hicl mp2an ) AEFBEFABGHIFCDABJK $.
  $}

  $( Conjugate law for inner product.  Postulate (S1) of [Beran] p. 95.  Note
     that ` * `` x ` is the complex conjugate ~ cjval of ` x ` .  In the
     literature, the inner product of ` A ` and ` B ` is usually written
     ` <. A , B >. ` , but our operation notation ~ co allows us to use
     existing theorems about operations and also avoids a clash with the
     definition of an ordered pair ~ df-op .  Physicists use ` <. B | A >. ` ,
     called Dirac bra-ket notation, to represent this operation; see comments
     in ~ df-bra .  (Contributed by NM, 29-Jul-1999.)
     (New usage is discouraged.) $)
  ax-his1 $a |- ( ( A e. ~H /\ B e. ~H ) ->
                ( A .ih B ) = ( * ` ( B .ih A ) ) ) $.

  $( Distributive law for inner product.  Postulate (S2) of [Beran] p. 95.
     (Contributed by NM, 31-Jul-1999.)  (New usage is discouraged.) $)
  ax-his2 $a |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( ( A +h B ) .ih C ) = ( ( A .ih C ) + ( B .ih C ) ) ) $.

  $( Associative law for inner product.  Postulate (S3) of [Beran] p. 95.
     Warning:  Mathematics textbooks usually use our version of the axiom.
     Physics textbooks, on the other hand, usually replace the left-hand side
     with ` ( B .ih ( A .h C ) ) ` (e.g.  Equation 1.21b of [Hughes] p. 44;
     Definition (iii) of [ReedSimon] p. 36).  See the comments in ~ df-bra for
     why the physics definition is swapped.  (Contributed by NM, 29-May-1999.)
     (New usage is discouraged.) $)
  ax-his3 $a |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( ( A .h B ) .ih C ) = ( A x. ( B .ih C ) ) ) $.

  $( Identity law for inner product.  Postulate (S4) of [Beran] p. 95.
     (Contributed by NM, 29-May-1999.)  (New usage is discouraged.) $)
  ax-his4 $a |- ( ( A e. ~H /\ A =/= 0h ) -> 0 < ( A .ih A ) ) $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                      Inner product and norms
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Inner product
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Associative law for inner product.  Lemma 3.1(S5) of [Beran] p. 95.
     (Contributed by NM, 29-Jul-1999.)  (New usage is discouraged.) $)
  his5 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( B .ih ( A .h C ) ) = ( ( * ` A ) x. ( B .ih C ) ) ) $=
    ( cc wcel chil w3a csm co csp ccj cmul wceq wa hvmulcl ax-his1 sylan2 3impb
    cfv 3com23 3com12 ax-his3 fveq2d hicl cjmul 3adant1 oveq2d eqtr4d 3eqtrd )
    ADEZBFEZCFEZGZBACHIZJIZUNBJIZKSZACBJIZLIZKSZAKSZBCJIZLIZUKUJULUOUQMZUKUJULV
    DUJULNUKUNFEVDACOBUNPQRUAUMUPUSKUJULUKUPUSMACBUBTUCUMUTVAURKSZLIZVCUJULUKUT
    VFMZUJULUKVGULUKNUJURDEVGCBUDAURUEQRTUMVBVEVALUKULVBVEMUJBCPUFUGUHUI $.

  $( Associative law for inner product.  (Contributed by NM, 13-Feb-2006.)
     (New usage is discouraged.) $)
  his52 $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( B .ih ( ( * ` A ) .h C ) ) = ( A x. ( B .ih C ) ) ) $=
    ( cc wcel chil w3a ccj cfv csm co cmul wceq cjcl his5 syl3an1 cjcj 3ad2ant1
    csp oveq1d eqtrd ) ADEZBFEZCFEZGBAHIZCJKSKZUEHIZBCSKZLKZAUHLKZUBUEDEUCUDUFU
    IMANUEBCOPUBUCUIUJMUDUBUGAUHLAQTRUA $.

  $( Move scalar multiplication to outside of inner product.  (Contributed by
     Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
  his35 $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                ( ( A .h C ) .ih ( B .h D ) ) =
                  ( ( A x. ( * ` B ) ) x. ( C .ih D ) ) ) $=
    ( cc wcel wa chil csm co csp cmul ccj wceq his5 3expb adantll oveq2d simpll
    cfv simprl hvmulcl ad2ant2l ax-his3 syl3anc ad2antlr adantl mulassd 3eqtr4d
    cjcl hicl ) AEFZBEFZGZCHFZDHFZGZGZACBDIJZKJZLJZABMTZCDKJZLJZLJACIJUSKJZAVBL
    JVCLJURUTVDALUMUQUTVDNZULUMUOUPVFBCDOPQRURULUOUSHFZVEVANULUMUQSZUNUOUPUAUMU
    PVGULUOBDUBUCACUSUDUEURAVBVCVHUMVBEFULUQBUJUFUQVCEFUNCDUKUGUHUI $.

  ${
    his35.1 $e |- A e. CC $.
    his35.2 $e |- B e. CC $.
    his35.3 $e |- C e. ~H $.
    his35.4 $e |- D e. ~H $.
    $( Move scalar multiplication to outside of inner product.  (Contributed by
       NM, 1-Jul-2005.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    his35i $p |- ( ( A .h C ) .ih ( B .h D ) ) =
              ( ( A x. ( * ` B ) ) x. ( C .ih D ) ) $=
      ( cc wcel chil csm co csp ccj cfv cmul wceq his35 mp4an ) AIJBIJCKJDKJACL
      MBDLMNMABOPQMCDNMQMREFGHABCDST $.
  $}

  $( Distributive law for inner product.  Lemma 3.1(S7) of [Beran] p. 95.
     (Contributed by NM, 31-Jul-1999.)  (New usage is discouraged.) $)
  his7 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( A .ih ( B +h C ) ) = ( ( A .ih B ) + ( A .ih C ) ) ) $=
    ( chil wcel w3a cva co csp ccj caddc wceq ax-his2 fveq2d wa cc hicl ax-his1
    cfv cjadd syl2an 3impdir eqtrd 3comr hvaddcl sylan2 3adant3 3adant2 oveq12d
    3impb 3eqtr4d ) ADEZBDEZCDEZFZBCGHZAIHZJSZBAIHZJSZCAIHZJSZKHZAUPIHZABIHZACI
    HZKHUMUNULURVCLUMUNULFZURUSVAKHZJSZVCVGUQVHJBCAMNUMULUNVIVCLZUMULOUSPEVAPEV
    JUNULOBAQCAQUSVATUAUBUCUDULUMUNVDURLZUMUNOULUPDEVKBCUEAUPRUFUJUOVEUTVFVBKUL
    UMVEUTLUNABRUGULUNVFVBLUMACRUHUIUK $.

  $( Distributive/associative law for inner product, useful for linearity
     proofs.  (Contributed by NM, 10-May-2005.)  (New usage is discouraged.) $)
  hiassdi $p |- ( ( ( A e. CC /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
    ( ( ( A .h B ) +h C ) .ih D ) = ( ( A x. ( B .ih D ) ) + ( C .ih D ) ) ) $=
    ( cc wcel chil wa csm cva csp caddc cmul wceq hvmulcl ax-his2 3expb ax-his3
    co sylan 3expa adantrl oveq1d eqtrd ) AEFZBGFZHZCGFZDGFZHZHZABISZCJSDKSZULD
    KSZCDKSZLSZABDKSMSZUOLSUGULGFZUJUMUPNZABOURUHUIUSULCDPQTUKUNUQUOLUGUIUNUQNZ
    UHUEUFUIUTABDRUAUBUCUD $.

  $( Distributive law for inner product of vector subtraction.  (Contributed by
     NM, 16-Nov-1999.)  (New usage is discouraged.) $)
  his2sub $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( ( A -h B ) .ih C ) = ( ( A .ih C ) - ( B .ih C ) ) ) $=
    ( chil wcel w3a cmv co csp c1 cneg csm caddc wceq wa cc neg1cn hicl 3adant1
    eqtrd cva cmin hvsubval oveq1d 3adant3 hvmulcl mpan ax-his2 syl3an2 ax-his3
    cmul mp3an1 mulm1d oveq2d 3adant2 negsubd 3eqtrd ) ADEZBDEZCDEZFZABGHZCIHZA
    JKZBLHZUAHZCIHZACIHZBCIHZKZMHZVHVIUBHURUSVCVGNUTURUSOVBVFCIABUCUDUEVAVGVHVE
    CIHZMHZVKUSURVEDEZUTVGVMNVDPEZUSVNQVDBUFUGAVECUHUIUSUTVMVKNURUSUTOZVLVJVHMV
    PVLVDVIUKHZVJVOUSUTVLVQNQVDBCUJULVPVIBCRZUMTUNSTVAVHVIURUTVHPEUSACRUOUSUTVI
    PEURVRSUPUQ $.

  $( Distributive law for inner product of vector subtraction.  (Contributed by
     NM, 13-Feb-2006.)  (New usage is discouraged.) $)
  his2sub2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                ( A .ih ( B -h C ) ) = ( ( A .ih B ) - ( A .ih C ) ) ) $=
    ( chil wcel w3a cmv co csp ccj cfv cmin wceq his2sub fveq2d wa hicl ax-his1
    cc cjsub syl2an 3impdir eqtrd 3comr hvsubcl 3adant3 3adant2 oveq12d 3eqtr4d
    sylan2 3impb ) ADEZBDEZCDEZFZBCGHZAIHZJKZBAIHZJKZCAIHZJKZLHZAUPIHZABIHZACIH
    ZLHUMUNULURVCMUMUNULFZURUSVALHZJKZVCVGUQVHJBCANOUMULUNVIVCMZUMULPUSSEVASEVJ
    UNULPBAQCAQUSVATUAUBUCUDULUMUNVDURMZUMUNPULUPDEVKBCUEAUPRUJUKUOVEUTVFVBLULU
    MVEUTMUNABRUFULUNVFVBMUMACRUGUHUI $.

  $( A necessary and sufficient condition for an inner product to be real.
     (Contributed by NM, 2-Jul-2005.)  (New usage is discouraged.) $)
  hire $p |- ( ( A e. ~H /\ B e. ~H ) ->
              ( ( A .ih B ) e. RR <-> ( A .ih B ) = ( B .ih A ) ) ) $=
    ( chil wcel wa csp co cr ccj cfv wceq cc wb hicl cjreb eqcom syl6bb ax-his1
    syl ancoms eqeq2d bitr4d ) ACDZBCDZEZABFGZHDZUFUFIJZKZUFBAFGZKUEUGUHUFKZUIU
    EUFLDUGUKMABNUFOSUHUFPQUEUJUHUFUDUCUJUHKBARTUAUB $.

  $( Real closure of inner product with self.  (Contributed by NM,
     29-May-1999.)  (New usage is discouraged.) $)
  hiidrcl $p |- ( A e. ~H -> ( A .ih A ) e. RR ) $=
    ( chil wcel csp co cr wa wceq eqid hire mpbiri anidms ) ABCZAADEZFCZMMGONNH
    NIAAJKL $.

  $( Inner product with the 0 vector.  (Contributed by NM, 29-May-1999.)
     (New usage is discouraged.) $)
  hi01 $p |- ( A e. ~H -> ( 0h .ih A ) = 0 ) $=
    ( chil wcel c0v csp co cc0 cmul csm wceq ax-hv0cl ax-hvmul0 ax-mp oveq1i cc
    0cn ax-his3 mp3an12 syl5eqr hicl mpan mul02d eqtrd ) ABCZDAEFZGUEHFZGUDUEGD
    IFZAEFZUFUGDAEDBCZUGDJKDLMNGOCUIUDUHUFJPKGDAQRSUDUEUIUDUEOCKDATUAUBUC $.

  $( Inner product with the 0 vector.  (Contributed by NM, 13-Oct-1999.)
     (New usage is discouraged.) $)
  hi02 $p |- ( A e. ~H -> ( A .ih 0h ) = 0 ) $=
    ( chil wcel c0v csp ccj cfv cc0 wceq ax-hv0cl ax-his1 mpan2 hi01 fveq2d cj0
    co syl6eq eqtrd ) ABCZADEPZDAEPZFGZHSDBCTUBIJADKLSUBHFGHSUAHFAMNOQR $.

  $( Inner product with self is not negative.  (Contributed by NM,
     29-May-1999.)  (New usage is discouraged.) $)
  hiidge0 $p |- ( A e. ~H -> 0 <_ ( A .ih A ) ) $=
    ( chil wcel cc0 csp co cle wbr clt wceq wo c0v pm2.1 df-ne ax-his4 sylan2br
    wn wne ex cr wa oveq1 hi01 sylan9eqr eqcomd orim12d mpi 0re hiidrcl sylancr
    wb leloe mpbird ) ABCZDAAEFZGHZDUOIHZDUOJZKZUNALJZQZUTKUSUTMUNVAUQUTURUNVAU
    QVAUNALRUQALNAOPSUNUTURUNUTUAUODUTUNUOLAEFDALAEUBAUCUDUESUFUGUNDTCUOTCUPUSU
    KUHAUIDUOULUJUM $.

  $( Zero inner product with self means vector is zero.  Lemma 3.1(S6) of
     [Beran] p. 95.  (Contributed by NM, 27-Jul-1999.)
     (New usage is discouraged.) $)
  his6 $p |- ( A e. ~H -> ( ( A .ih A ) = 0 <-> A = 0h ) ) $=
    ( chil wcel csp co cc0 wceq c0v wne wa ax-his4 gt0ne0d necon4d oveq1 eqeq1d
    ex hi01 syl5ibrcom impbid ) ABCZAADEZFGZAHGZTAHUAFTAHIZUAFITUDJUAAKLPMTUBUC
    HADEZFGAQUCUAUEFAHADNORS $.

  ${
    his1.1 $e |- A e. ~H $.
    his1.2 $e |- B e. ~H $.
    $( Conjugate law for inner product.  Postulate (S1) of [Beran] p. 95.
       (Contributed by NM, 15-May-2005.)  (New usage is discouraged.) $)
    his1i $p |- ( A .ih B ) = ( * ` ( B .ih A ) ) $=
      ( chil wcel csp co ccj cfv wceq ax-his1 mp2an ) AEFBEFABGHBAGHIJKCDABLM
      $.
  $}

  $( Commuted inner products have the same absolute values.  (Contributed by
     NM, 26-May-2006.)  (New usage is discouraged.) $)
  abshicom $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( abs ` ( A .ih B ) ) = ( abs ` ( B .ih A ) ) ) $=
    ( chil wcel wa csp co cabs cfv ccj ax-his1 fveq2d hicl ancoms abscjd eqtrd
    cc ) ACDZBCDZEZABFGZHIBAFGZJIZHIUBHITUAUCHABKLTUBSRUBQDBAMNOP $.

  ${
    $d x A $.
    $( A vector whose inner product is always zero is zero.  (Contributed by
       NM, 24-Oct-1999.)  (New usage is discouraged.) $)
    hial0 $p |- ( A e. ~H -> ( A. x e. ~H ( A .ih x ) = 0 <-> A = 0h ) ) $=
      ( chil wcel cv csp co cc0 wceq wral c0v oveq2 eqeq1d rspcv his6 sylibd wi
      oveq1 hi01 sylan9eq ex a1i ralrimdv impbid ) BCDZBAEZFGZHIZACJZBKIZUEUIBB
      FGZHIZUJUHULABCUFBIUGUKHUFBBFLMNBOPUEUJUHACUJUFCDZUHQQUEUJUMUHUJUMUGKUFFG
      HBKUFFRUFSTUAUBUCUD $.

    $( A vector whose inner product is always zero is zero.  (Contributed by
       NM, 28-Jan-2006.)  (New usage is discouraged.) $)
    hial02 $p |- ( A e. ~H -> ( A. x e. ~H ( x .ih A ) = 0 <-> A = 0h ) ) $=
      ( chil wcel cv csp co cc0 wceq wral c0v oveq1 eqeq1d rspcv his6 sylibd wi
      oveq2 hi02 sylan9eq ex a1i ralrimdv impbid ) BCDZAEZBFGZHIZACJZBKIZUEUIBB
      FGZHIZUJUHULABCUFBIUGUKHUFBBFLMNBOPUEUJUHACUJUFCDZUHQQUEUJUMUHUJUMUGUFKFG
      HBKUFFRUFSTUAUBUCUD $.
  $}

  ${
    hisubcom.1 $e |- A e. ~H $.
    hisubcom.2 $e |- B e. ~H $.
    hisubcom.3 $e |- C e. ~H $.
    hisubcom.4 $e |- D e. ~H $.
    $( Two vector subtractions simultaneously commute in an inner product.
       (Contributed by NM, 1-Jul-2005.)  (New usage is discouraged.) $)
    hisubcomi $p |- ( ( A -h B ) .ih ( C -h D ) ) =
                   ( ( B -h A ) .ih ( D -h C ) ) $=
      ( c1 cneg cmv co csm csp hvnegdii cmul neg1cn hvsubcli ax-1cn 3eqtri wcel
      oveq12i ccj cfv his35i wceq 1re renegcli cjre ax-mp oveq2i mul2negi 1t1e1
      cr oveq1i hicli mulid2i eqtr3i ) IJZBAKLZMLZUSDCKLZMLZNLZABKLZCDKLZNLUTVB
      NLZVAVEVCVFNBAFEODCHGOUBVDUSUSUCUDZPLZVGPLIVGPLVGUSUSUTVBQQBAFERZDCHGRZUE
      VIIVGPVIUSUSPLIIPLIVHUSUSPUSUNUAVHUSUFIUGUHUSUIUJUKIISSULUMTUOVGUTVBVJVKU
      PUQTUR $.
  $}

  $( Lemma used to prove equality of vectors.  (Contributed by NM,
     16-Nov-1999.)  (New usage is discouraged.) $)
  hi2eq $p |- ( ( A e. ~H /\ B e. ~H ) ->
               ( ( A .ih ( A -h B ) ) = ( B .ih ( A -h B ) ) <-> A = B ) ) $=
    ( chil wcel wa cmv co csp cmin cc0 wceq hvsubcl his2sub mpd3an3 eqeq1d his6
    c0v wb cc hicl syl bitr3d syldan simpr syl2anc subeq0ad hvsubeq0 3bitr3d )
    ACDZBCDZEZAABFGZHGZBULHGZIGZJKZULQKZUMUNKABKUKULULHGZJKZUPUQUKURUOJUIUJULCD
    ZURUOKABLZABULMNOUKUTUSUQRVAULPUAUBUKUMUNUIUJUTUMSDVAAULTUCUKUJUTUNSDUIUJUD
    VABULTUEUFABUGUH $.

  ${
    $d x A $.  $d x B $.
    $( Two vectors whose inner product is always equal are equal.  (Contributed
       by NM, 16-Nov-1999.)  (New usage is discouraged.) $)
    hial2eq $p |- ( ( A e. ~H /\ B e. ~H ) ->
                   ( A. x e. ~H ( A .ih x ) = ( B .ih x ) <-> A = B ) ) $=
      ( chil wcel wa cv csp co wceq wral cmv wi hvsubcl oveq2 eqeq12d rspcv syl
      hi2eq sylibd oveq1 ralrimivw impbid1 ) BDECDEFZBAGZHIZCUEHIZJZADKZBCJZUDU
      IBBCLIZHIZCUKHIZJZUJUDUKDEUIUNMBCNUHUNAUKDUEUKJUFULUGUMUEUKBHOUEUKCHOPQRB
      CSTUJUHADBCUEHUAUBUC $.

    $( Two vectors whose inner product is always equal are equal.  (Contributed
       by NM, 28-Jan-2006.)  (New usage is discouraged.) $)
    hial2eq2 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                   ( A. x e. ~H ( x .ih A ) = ( x .ih B ) <-> A = B ) ) $=
      ( chil wcel wa cv csp co wceq wral wb ccj cfv ax-his1 eqeqan12d cc ancoms
      hicl cj11 syl2an bitr2d anandirs ralbidva hial2eq bitrd ) BDEZCDEZFZAGZBH
      IZUJCHIZJZADKBUJHIZCUJHIZJZADKBCJUIUMUPADUGUHUJDEZUMUPLUGUQFZUHUQFZFUPUKM
      NZULMNZJZUMURUSUNUTUOVABUJOCUJOPURUKQEZULQEZVBUMLUSUQUGVCUJBSRUQUHVDUJCSR
      UKULTUAUBUCUDABCUEUF $.
  $}

  $( Orthogonality commutes.  (Contributed by NM, 10-Oct-1999.)
     (New usage is discouraged.) $)
  orthcom $p |- ( ( A e. ~H /\ B e. ~H ) ->
                ( ( A .ih B ) = 0 <-> ( B .ih A ) = 0 ) ) $=
    ( chil wcel wa csp cc0 wceq ccj cfv fveq2 cj0 syl6eq ax-his1 ancoms syl5ibr
    co eqeq1d impbid ) ACDZBCDZEZABFQZGHZBAFQZGHZUDUFUBUCIJZGHUDUGGIJZGUCGIKLMU
    BUEUGGUATUEUGHBANORPUFUDUBUEIJZGHUFUIUHGUEGIKLMUBUCUIGABNRPS $.

  ${
    normlem1.1 $e |- S e. CC $.
    normlem1.2 $e |- F e. ~H $.
    normlem1.3 $e |- G e. ~H $.
    $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
       [Beran] p. 97.  (Contributed by NM, 7-Oct-1999.)
       (New usage is discouraged.) $)
    normlem0 $p |- ( ( F -h ( S .h G ) ) .ih
                         ( F -h ( S .h G ) ) ) =
                ( ( ( F .ih F ) + ( -u ( * ` S ) x. ( F .ih G ) ) ) +
  ( ( -u S x. ( G .ih F ) ) + ( ( S x. ( * ` S ) ) x. ( G .ih G ) ) ) ) $=
      ( csm co csp cneg cva caddc cmul oveq1i oveq2i chil wcel wceq mp3an eqtri
      cmv ccj cfv hvmulcli hvsubvali mulm1i neg1cn eqtr3i eqtr4i oveq12i negcli
      c1 hvmulassi hvaddcli ax-his2 his7 his5 cjnegi ax-his3 hicli cjcli mulcli
      cc adddii mulassi mul2negi 3eqtri ) BACGHZUAHZVIIHBAJZCGHZKHZVLIHZBVLIHZV
      KVLIHZLHZBBIHZAUBUCZJZBCIHZMHZLHZVJCBIHZMHZAVRMHZCCIHZMHZLHZLHVIVLVIVLIVI
      BULJZVHGHZKHVLBVHEACDFUDUEVKWJBKWIAMHZCGHVKWJWKVJCGADUFNWIACUGDFUMUHOUIZW
      LUJBPQZVKPQZVLPQZVMVPREVJCADUKZFUDZBVKEWQUNZBVKVLUOSVNWBVOWHLVNVQBVKIHZLH
      ZWBWMWMWNVNWTREEWQBBVKUPSWSWAVQLWSVJUBUCZVTMHZWAVJVCQZWMCPQZWSXBRWPEFVJBC
      UQSXAVSVTMADURZNTOTVOVJCVLIHZMHZVJWCXAWFMHZLHZMHZWHXCXDWOVOXGRWPFWRVJCVLU
      SSXFXIVJMXFWCCVKIHZLHZXIXDWMWNXFXLRFEWQCBVKUPSXKXHWCLXCXDXDXKXHRWPFFVJCCU
      QSOTOXJWDVJXHMHZLHWHVJWCXHWPCBFEUTXAWFVJWPVAZCCFFUTZVBVDXMWGWDLVJXAMHZWFM
      HXMWGVJXAWFWPXNXOVEXPWEWFMXPVJVSMHWEXAVSVJMXEOAVRDADVAVFTNUHOTVGUJVG $.

    ${
      normlem1.4 $e |- R e. RR $.
      normlem1.5 $e |- ( abs ` S ) = 1 $.
      $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
         [Beran] p. 97.  (Contributed by NM, 22-Aug-1999.)
         (New usage is discouraged.) $)
      normlem1 $p |- ( ( F -h ( ( S x. R ) .h G ) ) .ih
                         ( F -h ( ( S x. R ) .h G ) ) ) =
                ( ( ( F .ih F ) + ( ( ( * ` S ) x. -u R ) x. ( F .ih G ) ) ) +
  ( ( ( S x. -u R ) x. ( G .ih F ) ) + ( ( R ^ 2 ) x. ( G .ih G ) ) ) ) $=
        ( cmul co csp cfv cneg caddc c2 cexp oveq2i eqtri c1 csm cmv ccj mulcli
        recni normlem0 cjmuli cr wcel wceq cjrebi negeqi mulneg2i eqtr4i oveq1i
        mpbi cjcli eqcomi mul4i cabs absvalsqi 3eqtr3i oveq12i mulid2i sqvali
        sq1 ) CBAJKZDUAKUBKZVHLKCCLKZVGUCMZNZCDLKZJKZOKZVGNZDCLKZJKZVGVJJKZDDLK
        ZJKZOKZOKVIBUCMZANZJKZVLJKZOKZBWCJKZVPJKZAPQKZVSJKZOKZOKVGCDBAEAHUEZUDF
        GUFVNWFWAWKOVMWEVIOVKWDVLJVKWBAJKZNWDVJWMVJWBAUCMZJKZWMBAEWLUGZWNAWBJAU
        HUIWNAUJHAWLUKUPZRSULWBABEUQZWLUMUNUORVQWHVTWJOVOWGVPJWGVOBAEWLUMURUOVR
        WIVSJVRAAJKZWIVRVGWOJKZWSVJWOVGJWPRWTBWBJKZAWNJKZJKZWSBAWBWNEWLWRAWLUQU
        SXCTWSJKWSXATXBWSJBUTMZPQKTPQKXATXDTPQIUOBEVAVFVBWNAAJWQRVCWSAAWLWLUDVD
        SSSAWLVEUNUOVCVCS $.
    $}

    ${
      normlem2.4 $e |- B = -u ( ( ( * ` S ) x. ( F .ih G ) ) +
                    ( S x. ( G .ih F ) ) ) $.
      $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
         [Beran] p. 97.  (Contributed by NM, 27-Jul-1999.)
         (New usage is discouraged.) $)
      normlem2 $p |- B e. RR $=
        ( ccj cfv csp co cmul caddc cr hicli mulcli his1i oveq12i eqtr4i cjaddi
        cneg wcel wceq cjcli cjcji eqcomi cjmuli oveq2i addcomi addcli renegcli
        cjrebi mpbir eqeltri ) ABIJZCDKLZMLZBDCKLZMLZNLZUBOHVAVAOUCVAIJZVAUDVBU
        TURNLZVAVBURIJZUTIJZNLVCURUTUPUQBEUEZCDFGPZQZBUSEDCGFPZQZUAUTVDURVENUTU
        PIJZUQIJZMLVDBVKUSVLMVKBBEUFUGDCGFRSUPUQVFVGUHTURUPUSIJZMLVEUQVMUPMCDFG
        RUIBUSEVIUHTSTURUTVHVJUJTVAURUTVHVJUKUMUNULUO $.

      normlem3.5 $e |- A = ( G .ih G ) $.
      normlem3.6 $e |- C = ( F .ih F ) $.
      ${
        normlem3.7 $e |- R e. RR $.
        $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
           [Beran] p. 97.  (Contributed by NM, 21-Aug-1999.)
           (New usage is discouraged.) $)
        normlem3 $p |- ( ( ( A x. ( R ^ 2 ) ) + ( B x. R ) ) + C ) =
                ( ( ( F .ih F ) + ( ( ( * ` S ) x. -u R ) x. ( F .ih G ) ) ) +
  ( ( ( S x. -u R ) x. ( G .ih F ) ) + ( ( R ^ 2 ) x. ( G .ih G ) ) ) ) $=
          ( co cmul caddc csp hicli mulcli c2 cexp ccj cneg eqeltri recni sqcli
          cfv cc normlem2 addcomi cjcli addcli mulneg1i oveq1i mulneg2i 3eqtr4i
          negcli adddiri mul32i oveq12i 3eqtri oveq2i mulcomli addassi ) CADUAU
          BOZPOZBDPOZQOZQOFFROZEUCUHZDUDZPOZFGROZPOZEVLPOZGFROZPOZVFGGROZPOZQOZ
          QOZQOVICQOVJVOQOWAQOCVJVIWBQMVIVHVGQOVOVRQOZVTQOWBVGVHAVFAVSUILGGJJSZ
          UEZDDNUFZUGZTZBDBBEFGHIJKUJUFWFTZUKVHWCVGVTQVHVKVNPOZEVQPOZQOZVLPOZWJ
          VLPOZWKVLPOZQOWCWLUDZDPOWLDPOUDVHWMWLDWJWKVKVNEHULZFGIJSZTZEVQHGFJISZ
          TZUMZWFUNBWPDPKUOWLDXBWFUPUQWJWKVLWSXADWFURZUSWNVOWOVRQVKVNVLWQWRXCUT
          EVQVLHWTXCUTVAVBVFAVTWGWEAVSVFPLVCVDVAVOVRVTVMVNVKVLWQXCTWRTZVPVQEVLH
          XCTWTTZVFVSWGWDTZVEVBVAVICVGVHWHWIUMCVJUIMFFIISZUEUKVJVOWAXGXDVRVTXEX
          FUMVEUQ $.
      $}

      ${
        normlem4.7 $e |- R e. RR $.
        normlem4.8 $e |- ( abs ` S ) = 1 $.
        $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
           [Beran] p. 97.  (Contributed by NM, 29-Jul-1999.)
           (New usage is discouraged.) $)
        normlem4 $p |- ( ( F -h ( ( S x. R ) .h G ) ) .ih
                       ( F -h ( ( S x. R ) .h G ) ) ) =
                       ( ( ( A x. ( R ^ 2 ) ) + ( B x. R ) ) + C ) $=
          ( cmul co csm csp caddc cmv ccj cneg c2 cexp normlem1 normlem3 eqtr4i
          cfv ) FEDPQGRQUAQZUJSQFFSQEUBUIDUCZPQFGSQPQTQEUKPQGFSQPQDUDUEQZGGSQPQ
          TQTQAULPQBDPQTQCTQDEFGHIJNOUFABCDEFGHIJKLMNUGUH $.

        $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
           [Beran] p. 97.  (Contributed by NM, 10-Aug-1999.)
           (New usage is discouraged.) $)
        normlem5 $p |- 0 <_
                       ( ( ( A x. ( R ^ 2 ) ) + ( B x. R ) ) + C ) $=
          ( cc0 cmul co caddc cle csm cmv csp cexp chil wcel wbr recni hvmulcli
          c2 mulcli hvsubcli hiidge0 ax-mp normlem4 breqtri ) PFEDQRZGUARZUBRZU
          SUCRZADUJUDRQRBDQRSRCSRTUSUEUFPUTTUGFURIUQGEDHDNUHUKJUIULUSUMUNABCDEF
          GHIJKLMNOUOUP $.
      $}

      $d x A $.  $d x B $.  $d x C $.
      normlem6.7 $e |- ( abs ` S ) = 1 $.
      $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
         [Beran] p. 97.  (Contributed by NM, 2-Aug-1999.)  (Revised by Mario
         Carneiro, 4-Jun-2014.)  (New usage is discouraged.) $)
      normlem6 $p |- ( abs ` B ) <_
                       ( 2 x. ( ( sqr ` A ) x. ( sqr ` C ) ) ) $=
        ( co cmul cle wbr cc0 cr wcel vx c2 cexp csqr cfv c4 cabs cmin wtru csp
        caddc chil hiidrcl ax-mp eqeltri a1i normlem2 cv cif oveq1 oveq2d oveq2
        wceq oveq12d oveq1d breq2d 0re elimel normlem5 dedth discr trud resqcli
        adantl 4re remulcli lesubadd2i mpbi recni addid1i breqtri sqge0i ltleii
        4pos hiidge0 breqtrri mulge0i mp2an sqrlei absrei sqrmulii sqr4 oveq12i
        wb eqtr2i 3brtr4i ) BUBUCNZUDUEZUFACONZONZUDUEZBUGUEUBAUDUECUDUEONZONZP
        WQWTPQZWRXAPQZWQWTRUKNZWTPWQWTUHNRPQZWQXFPQXGUIUAABCASTUIAFFUJNZSKFULTZ
        XHSTIFUMUNUOZUPBSTUIBDEFGHIJUQZUPCSTUICEEUJNZSLEULTZXLSTHEUMUNUOZUPUAUR
        ZSTZRAXOUBUCNZONZBXOONZUKNZCUKNZPQZUIXPYBRAXPXORUSZUBUCNZONZBYCONZUKNZC
        UKNZPQXORXOYCVCZYAYHRPYIXTYGCUKYIXRYEXSYFUKYIXQYDAOXOYCUBUCUTVAXOYCBOVB
        VDVEVFABCYCDEFGHIJKLXORSVGVHMVIVJVNVKVLWQWTRBXKVMZUFWSVOACXJXNVPZVPZVGV
        QVRWTWTYLVSVTWARWQPQRWTPQZXDXEWNBXKWBRUFPQRWSPQZYMRUFVGVOWDWCZRAPQRCPQY
        NRXHAPXIRXHPQIFWEUNKWFZRXLCPXMRXLPQHEWEUNLWFZACXJXNWGWHZUFWSVOYKWGWHWQW
        TYJYLWIWHVRBXKWJXAUFUDUEZWSUDUEZONXCUFWSVOYKYOYRWKYSUBYTXBOWLACXJXNYPYQ
        WKWMWOWP $.
    $}
    normlem7.4 $e |- ( abs ` S ) = 1 $.
    $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
       [Beran] p. 97.  (Contributed by NM, 11-Aug-1999.)
       (New usage is discouraged.) $)
    normlem7 $p |- ( ( ( * ` S ) x. ( F .ih G ) ) + ( S x. ( G .ih F ) ) ) <_
                ( 2 x. ( ( sqr ` ( G .ih G ) ) x. ( sqr ` ( F .ih F ) ) ) ) $=
      ( cfv csp co cmul cabs cle wbr c2 csqr cr wcel eqid hicli ccj caddc cjcli
      cneg normlem2 mulcli addcli negrebi mpbi leabsi absnegi breqtrri normlem6
      negcli abscli 2re chil cc0 hiidge0 ax-mp sqrcli mp2b remulcli letri mp2an
      hiidrcl ) AUAHZBCIJZKJZACBIJZKJZUBJZVLUDZLHZMNVNOCCIJZPHZBBIJZPHZKJZKJZMN
      VLVTMNVLVLLHVNMVLVMQRVLQRVMABCDEFVMSZUEVLVIVKVGVHADUCBCEFTUFAVJDCBFETUFUG
      ZUHUIZUJVLWBUKULVOVMVQABCDEFWAVOSVQSGUMVLVNVTWCVMVLWBUNUOOVSUPVPVRCUQRZUR
      VOMNVPQRFCUSVOWDVOQRFCVFUTVAVBBUQRZURVQMNVRQREBUSVQWEVQQREBVFUTVAVBVCVCVD
      VE $.
  $}

  ${
    normlem8.1 $e |- A e. ~H $.
    normlem8.2 $e |- B e. ~H $.
    normlem8.3 $e |- C e. ~H $.
    normlem8.4 $e |- D e. ~H $.
    $( Lemma used to derive properties of norm.  (Contributed by NM,
       30-Jun-2005.)  (New usage is discouraged.) $)
    normlem8 $p |- ( ( A +h B ) .ih ( C +h D ) ) =
        ( ( ( A .ih C ) + ( B .ih D ) ) + ( ( A .ih D ) + ( B .ih C ) ) ) $=
      ( cva co csp caddc chil wcel wceq his7 mp3an oveq12i hvaddcli hicli
      ax-his2 add42i 3eqtr4i ) ACDIJZKJZBUDKJZLJZACKJZADKJZLJZBCKJZBDKJZLJZLJAB
      IJUDKJZUHULLJUIUKLJLJUEUJUFUMLAMNZCMNZDMNZUEUJOEGHACDPQBMNZUPUQUFUMOFGHBC
      DPQRUOURUDMNUNUGOEFCDGHSABUDUAQUHULUIUKACEGTBDFHTADEHTBCFGTUBUC $.

    $( Lemma used to derive properties of norm.  (Contributed by NM,
       30-Jun-2005.)  (New usage is discouraged.) $)
    normlem9 $p |- ( ( A -h B ) .ih ( C -h D ) ) =
        ( ( ( A .ih C ) + ( B .ih D ) ) - ( ( A .ih D ) + ( B .ih C ) ) ) $=
      ( co csp c1 cneg caddc neg1cn cmul wcel chil wceq mp3an 3eqtri cmv csm cc
      cva cmin hvsubvali oveq12i hvmulcli normlem8 ccj cfv his5 oveq2i renegcli
      ax-his3 1re cjre ax-mp ax-1cn mul2negi mulid2i oveq1i cjcli hicli mulassi
      cr 3eqtr3i mulm1i eqtri negdii eqtr4i addcli negsubi ) ABUAIZCDUAIZJIAKLZ
      BUBIZUDIZCVPDUBIZUDIZJIACJIZVQVSJIZMIZAVSJIZVQCJIZMIZMIZWABDJIZMIZADJIZBC
      JIZMIZUEIZVNVRVOVTJABEFUFCDGHUFUGAVQCVSEVPBNFUHGVPDNHUHZUIWGWIWLLZMIWMWCW
      IWFWOMWBWHWAMWBVPBVSJIZOIZVPVPUJUKZWHOIZOIZWHVPUCPZBQPZVSQPWBWQRNFWNVPBVS
      UOSWPWSVPOXAXBDQPZWPWSRNFHVPBDULSUMVPWROIZWHOIKWHOIWTWHXDKWHOXDVPVPOIKKOI
      KWRVPVPOVPVFPWRVPRKUPUNVPUQURZUMKKUSUSUTKUSVATVBVPWRWHNVPNVCBDFHVDZVEWHXF
      VAVGTUMWFWJLZWKLZMIWOWDXGWEXHMWDWRWJOIZVPWJOIXGXAAQPXCWDXIRNEHVPADULSWRVP
      WJOXEVBWJADEHVDZVHTWEVPWKOIZXHXAXBCQPWEXKRNFGVPBCUOSWKBCFGVDZVHVIUGWJWKXJ
      XLVJVKUGWIWLWAWHACEGVDXFVLWJWKXJXLVLVMVIT $.
  $}

  ${
    normlem7t.1 $e |- A e. ~H $.
    normlem7t.2 $e |- B e. ~H $.
    $( Lemma used to derive properties of norm.  Part of Theorem 3.3(ii) of
       [Beran] p. 97.  (Contributed by NM, 11-Oct-1999.)
       (New usage is discouraged.) $)
    normlem7tALT $p |- ( ( S e. CC /\ ( abs ` S ) = 1 ) ->
              ( ( ( * ` S ) x. ( A .ih B ) ) + ( S x. ( B .ih A ) ) ) <_
              ( 2 x. ( ( sqr ` ( B .ih B ) ) x. ( sqr ` ( A .ih A ) ) ) ) ) $=
      ( cc wcel cabs cfv c1 wceq wa ccj csp co cmul caddc csqr cle fveq2 c2 wbr
      cif oveq1d oveq1 oveq12d breq1d eqeq1d anbi12d ax-1cn abs1 pm3.2i elimhyp
      eleq1 simpli simpri normlem7 dedth ) CFGZCHIZJKZLZCMIZABNOZPOZCBANOZPOZQO
      ZUABBNORIAANORIPOPOZSUBVBCJUCZMIZVDPOZVJVFPOZQOZVISUBCJCVJKZVHVNVISVOVEVL
      VGVMQVOVCVKVDPCVJMTUDCVJVFPUEUFUGVJABVJFGZVJHIZJKZVBVPVRLJFGZJHIZJKZLCJVO
      USVPVAVRCVJFUNVOUTVQJCVJHTUHUIJVJKZVSVPWAVRJVJFUNWBVTVQJJVJHTUHUIVSWAUJUK
      ULUMZUODEVPVRWCUPUQUR $.

    $( Equality case of Bunjakovaskij-Cauchy-Schwarz inequality.  Specifically,
       in the equality case the two vectors are collinear.  Compare
       ~ bcsiHIL .  (Contributed by NM, 16-Jul-2001.)
       (New usage is discouraged.) $)
    bcseqi $p |- ( ( ( A .ih B ) x. ( B .ih A ) ) = ( ( A .ih A ) x.
             ( B .ih B ) ) <-> ( ( B .ih B ) .h A ) = ( ( A .ih B ) .h B ) ) $=
      ( csp co cmul wceq cc0 caddc hicli wcel chil mp3an ax-his3 oveq12i mulcli
      his5 mulcomi 3eqtri csm cmv c0v hvmulcli normlem9 oveq1 eqcomd ccj cfv cc
      cmin hiidrcl cjre mp2b oveq1i eqtr4i his1i eqcomi mulassi mul32i 3eqtr4ri
      cr 3eqtr4g oveq12d oveq1d addcli subidi syl6eq syl5eq hvsubcli his6 ax-mp
      a1i wb sylib hvsubeq0i impbii ) ABEFZBAEFZGFZAAEFZBBEFZGFZHZWBAUAFZVRBUAF
      ZHZWDWEWFUBFZUCHZWGWDWHWHEFZIHZWIWDWJWEWEEFZWFWFEFZJFZWEWFEFZWFWEEFZJFZUK
      FZIWEWFWEWFWBABBDDKZCUDZVRBABCDKZDUDZWTXBUEWDWRWQWQUKFIWDWNWQWQUKWDWLWOWM
      WPJWDWCWBGFZVTWBGFZWLWOWDXDXCVTWCWBGUFUGWLWBUHUIZWEAEFZGFZWBWBWAGFZGFZXCW
      BUJLZWEMLZAMLZWLXGHWSWTCWBWEARNXEWBXFXHGBMLZWBVBLXEWBHDBULWBUMUNZXJXLXLXF
      XHHWSCCWBAAONZPXIXHWBGFXCWBXHWSWBWAWSAACCKZQSWCXHWBGWAWBXPWSSZUOUPTWOVRUH
      UIZWEBEFZGFZVSWBVRGFZGFZXDVRUJLZXKXMWOXTHXAWTDVRWEBRNXRVSXSYAGVSXRBADCUQU
      RZXJXLXMXSYAHWSCDWBABONPYBYAVSGFWBVTGFZXDVSYABADCKZWBVRWSXAQSWBVRVSWSXAYF
      USWBVTWSVRVSXAYFQZSTTVCWMWPHWDXEWFAEFZGFZYEWPWMXEWBYHVTGXNYCXMXLYHVTHXADC
      VRBAONZPXJWFMLZXLWPYIHWSXBCWBWFARNWMXRWFBEFZGFZVSVRWBGFZGFZYEYCYKXMWMYMHX
      AXBDVRWFBRNXRVSYLYNGYDYCXMXMYLYNHXADDVRBBONPYOYNVSGFXDYEVSYNYFVRWBXAWSQSV
      RWBVSXAWSYFUTVTWBYGWSSTTVAVMVDVEWQWOWPWEWFWTXBKWFWEXBWTKVFVGVHVIWHMLWKWIV
      NWEWFWTXBVJWHVKVLVOWEWFWTXBVPVOWGWCVTWGXFYHWCVTWEWFAEUFWCXHXFXQXOUPYHVTYJ
      URVCUGVQ $.
  $}

  $( Lemma used to derive properties of norm.  Part of Remark 3.4(B) of [Beran]
     p. 98.  (Contributed by NM, 10-May-2005.)  (New usage is discouraged.) $)
  normlem9at $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( A -h B ) .ih ( A -h B ) ) =
      ( ( ( A .ih A ) + ( B .ih B ) ) - ( ( A .ih B ) + ( B .ih A ) ) ) ) $=
    ( chil wcel cmv co csp caddc cmin wceq c0v cif oveq1 oveq12d oveq1d eqeq12d
    id oveq2 ax-hv0cl elimel oveq2d normlem9 dedth2h ) ACDZBCDZABEFZUFGFZAAGFZB
    BGFZHFZABGFZBAGFZHFZIFZJUDAKLZBEFZUPGFZUOUOGFZUIHFZUOBGFZBUOGFZHFZIFZJUOUEB
    KLZEFZVEGFZURVDVDGFZHFZUOVDGFZVDUOGFZHFZIFZJABKKAUOJZUGUQUNVCVMUFUPUFUPGAUO
    BEMZVNNVMUJUSUMVBIVMUHURUIHVMAUOAUOGVMQZVONOVMUKUTULVAHAUOBGMAUOBGRNNPBVDJZ
    UQVFVCVLVPUPVEUPVEGBVDUOERZVQNVPUSVHVBVKIVPUIVGURHVPBVDBVDGVPQZVRNUAVPUTVIV
    AVJHBVDUOGRBVDUOGMNNPUOVDUOVDAKCSTZBKCSTZVSVTUBUC $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Norms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Alternate definition of the norm of a vector of Hilbert space.
       Definition of norm in [Beran] p. 96.  (Contributed by NM, 6-Jun-2008.)
       (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    dfhnorm2 $p |- normh = ( x e. ~H |-> ( sqr ` ( x .ih x ) ) ) $=
      ( cno csp cdm cv co csqr cfv cmpt chil df-hnorm cxp cc ax-hfi fdmi dmxpid
      dmeqi eqtr2i eqid mpteq12i eqtr4i ) BACDZDZAEZUDCFGHZIAJUEIAKAJUEUCUEUCJJ
      LZDJUBUFUFMCNOQJPRUESTUA $.

    $( The norm function maps from Hilbert space to reals.  (Contributed by NM,
       6-Sep-2007.)  (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    normf $p |- normh : ~H --> RR $=
      ( vx chil cr cv csp csqr cfv dfhnorm2 wcel hiidrcl hiidge0 resqrcld fmpti
      co cno ) ABCADZPENZFGOAHPBIQPJPKLM $.
  $}

  ${
    $d x A $.
    $( The value of the norm of a vector in Hilbert space.  Definition of norm
       in [Beran] p. 96.  In the literature, the norm of ` A ` is usually
       written as "|| ` A ` ||", but we use function value notation to take
       advantage of our existing theorems about functions.  (Contributed by NM,
       29-May-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    normval $p |- ( A e. ~H -> ( normh ` A ) = ( sqr ` ( A .ih A ) ) ) $=
      ( vx cv csp co csqr cfv chil cno wceq oveq12 anidms fveq2d dfhnorm2 fvmpt
      fvex ) BABCZQDEZFGAADEZFGHIQAJZRSFTRSJQAQADKLMBNSFPO $.
  $}

  $( Real closure of the norm of a vector.  (Contributed by NM, 29-May-1999.)
     (New usage is discouraged.) $)
  normcl $p |- ( A e. ~H -> ( normh ` A ) e. RR ) $=
    ( chil cr cno normf ffvelrni ) BCADEF $.

  $( The norm of a vector is nonnegative.  (Contributed by NM, 29-May-1999.)
     (New usage is discouraged.) $)
  normge0 $p |- ( A e. ~H -> 0 <_ ( normh ` A ) ) $=
    ( chil wcel cc0 csp co cfv cno cle hiidrcl hiidge0 sqrge0d normval breqtrrd
    csqr ) ABCZDAAEFZOGAHGIPQAJAKLAMN $.

  $( The norm of nonzero vector is positive.  (Contributed by NM,
     10-Apr-2006.)  (New usage is discouraged.) $)
  normgt0 $p |- ( A e. ~H -> ( A =/= 0h <-> 0 < ( normh ` A ) ) ) $=
    ( chil wcel c0v wne cc0 csp co csqr cfv clt wbr cno wa cr hiidrcl adantr ex
    wceq wn ax-his4 sqrgt0 syl2anc hi01 sylan9eqr fveq2d sqr0 syl6eq wb hiidge0
    oveq1 resqrcld 0re lttri3 sylancl simpr syl6bi syld necon2ad impbid normval
    breq2d bitr4d ) ABCZADEZFAAGHZIJZKLZFAMJZKLVDVEVHVDVEVHVDVENVFOCZFVFKLVHVDV
    JVEAPZQAUAVFUBUCRVDVHADVDADSZVGFSZVHTZVDVLVMVDVLNZVGFIJFVOVFFIVLVDVFDAGHFAD
    AGUKAUDUEUFUGUHRVDVMVGFKLTZVNNZVNVDVGOCFOCVMVQUIVDVFVKAUJULUMVGFUNUOVPVNUPU
    QURUSUTVDVIVGFKAVAVBVC $.

  $( The norm of a zero vector.  (Contributed by NM, 30-May-1999.)
     (New usage is discouraged.) $)
  norm0 $p |- ( normh ` 0h ) = 0 $=
    ( c0v cno cfv csp co csqr chil wcel wceq ax-hv0cl normval ax-mp hi01 fveq2d
    cc0 sqr0 3eqtri ) ABCZAADEZFCZOFCZOAGHZRTIJAKLUBTUAIJUBSOFAMNLPQ $.

  $( Theorem 3.3(i) of [Beran] p. 97.  (Contributed by NM, 29-Jul-1999.)
     (New usage is discouraged.) $)
  norm-i $p |- ( A e. ~H -> ( ( normh ` A ) = 0 <-> A = 0h ) ) $=
    ( chil wcel c0v wceq cno cfv cc0 wne clt wbr normgt0 cle normcl normge0 0re
    cr wb leltne mp3an1 syl2anc bitrd necon4bid bicomd ) ABCZADEAFGZHEUEADUFHUE
    ADIHUFJKZUFHIZALUEUFQCZHUFMKZUGUHRZANAOHQCUIUJUKPHUFSTUAUBUCUD $.

  $( A norm is nonzero iff its argument is a nonzero vector.  (Contributed by
     NM, 11-Mar-2006.)  (New usage is discouraged.) $)
  normne0 $p |- ( A e. ~H -> ( ( normh ` A ) =/= 0 <-> A =/= 0h ) ) $=
    ( chil wcel cno cfv cc0 c0v norm-i necon3bid ) ABCADEFAGAHI $.

  ${
    normcl.1 $e |- A e. ~H $.
    $( Real closure of the norm of a vector.  (Contributed by NM,
       30-Sep-1999.)  (New usage is discouraged.) $)
    normcli $p |- ( normh ` A ) e. RR $=
      ( chil wcel cno cfv cr normcl ax-mp ) ACDAEFGDBAHI $.

    $( The square of a norm.  (Contributed by NM, 21-Aug-1999.)
       (New usage is discouraged.) $)
    normsqi $p |- ( ( normh ` A ) ^ 2 ) = ( A .ih A ) $=
      ( cno cfv c2 cexp co csp csqr chil wcel wceq normval ax-mp oveq1i cc0 cle
      wbr hiidge0 cr hiidrcl sqsqri eqtri ) ACDZEFGAAHGZIDZEFGZUEUDUFEFAJKZUDUF
      LBAMNOPUEQRZUGUELUHUIBASNUEUHUETKBAUANUBNUC $.

    $( Theorem 3.3(i) of [Beran] p. 97.  (Contributed by NM, 5-Sep-1999.)
       (New usage is discouraged.) $)
    norm-i-i $p |- ( ( normh ` A ) = 0 <-> A = 0h ) $=
      ( chil wcel cno cfv cc0 wceq c0v wb norm-i ax-mp ) ACDAEFGHAIHJBAKL $.
  $}

  $( The square of a norm.  (Contributed by NM, 12-May-2005.)
     (New usage is discouraged.) $)
  normsq $p |- ( A e. ~H -> ( ( normh ` A ) ^ 2 ) = ( A .ih A ) ) $=
    ( chil wcel cno cfv c2 cexp co csp wceq c0v fveq2 oveq1d id oveq12d eqeq12d
    cif ax-hv0cl elimel normsqi dedth ) ABCZADEZFGHZAAIHZJUBAKQZDEZFGHZUFUFIHZJ
    AKAUFJZUDUHUEUIUJUCUGFGAUFDLMUJAUFAUFIUJNZUKOPUFAKBRSTUA $.

  ${
    normsub0.1 $e |- A e. ~H $.
    normsub0.2 $e |- B e. ~H $.
    $( Two vectors are equal iff the norm of their difference is zero.
       (Contributed by NM, 18-Aug-1999.)  (New usage is discouraged.) $)
    normsub0i $p |- ( ( normh ` ( A -h B ) ) = 0 <-> A = B ) $=
      ( cmv co cno cfv cc0 wceq c0v hvsubcli norm-i-i hvsubeq0i bitri ) ABEFZGH
      IJPKJABJPABCDLMABCDNO $.
  $}

  $( Two vectors are equal iff the norm of their difference is zero.
     (Contributed by NM, 18-Aug-1999.)  (New usage is discouraged.) $)
  normsub0 $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( normh ` ( A -h B ) ) = 0 <-> A = B ) ) $=
    ( chil wcel cmv co cno cfv cc0 wb c0v cif oveq1 fveq2d eqeq1d eqeq1 bibi12d
    wceq ax-hv0cl elimel oveq2 eqeq2 normsub0i dedth2h ) ACDZBCDZABEFZGHZIRZABR
    ZJUEAKLZBEFZGHZIRZUKBRZJUKUFBKLZEFZGHZIRZUKUPRZJABKKAUKRZUIUNUJUOVAUHUMIVAU
    GULGAUKBEMNOAUKBPQBUPRZUNUSUOUTVBUMURIVBULUQGBUPUKEUANOBUPUKUBQUKUPAKCSTBKC
    STUCUD $.

  ${
    norm-ii.1 $e |- A e. ~H $.
    norm-ii.2 $e |- B e. ~H $.
    $( Triangle inequality for norms.  Theorem 3.3(ii) of [Beran] p. 97.
       (Contributed by NM, 11-Aug-1999.)  (New usage is discouraged.) $)
    norm-ii-i $p |- ( normh ` ( A +h B ) ) <_
                  ( ( normh ` A ) + ( normh ` B ) ) $=
      ( co csp csqr cfv caddc cle c2 wbr cmul c1 cr wcel wceq ax-1cn cc0 ax-mp
      cva cno cexp ccj 1re cjrebi mpbi oveq1i hicli mulid2i eqtri abs1 normlem7
      oveq12i eqbrtrri cneg eqid normlem2 cjcli mulcli addcli eqeltrri 2re chil
      negrebi hiidge0 hiidrcl sqrcli remulcli readdcli leadd2i normlem8 addcomi
      oveq2i recni binom2i 2cn add32i sqsqri 3eqtri 3brtr4i wb hvaddcli resqcli
      sqcli sqge0i sqrlei mp2an sqrge0i addge0i sqrsqi breqtri normval ) ABUAEZ
      WNFEZGHZAAFEZGHZBBFEZGHZIEZWNUBHZAUBHZBUBHZIEJWPXAKUCEZGHZXAJWOXEJLZWPXFJ
      LZWQWSIEZBAFEZABFEZIEZIEZXIKWRWTMEZMEZIEZWOXEJXLXOJLXMXPJLNUDHZXJMEZNXKME
      ZIEZXLXOJXRXJXSXKIXRNXJMEXJXQNXJMNOPXQNQUENRUFUGUHXJBADCUIZUJUKXKABCDUIZU
      JUNZNBARDCULUMUOXLXOXIXTXLOYCXTUPZOPXTOPYDNBARDCYDUQURXTXRXSXQXJNRUSYAUTN
      XKRYBUTVAVEUGVBKXNVCWRWTSWQJLZWROPAVDPZYECAVFTZWQYFWQOPCAVGTZVHTZSWSJLZWT
      OPBVDPZYJDBVFTZWSYKWSOPDBVGTZVHTZVIVIWQWSYHYMVJVKUGWOXIXKXJIEZIEXMABABCDC
      DVLYOXLXIIXKXJYBYAVMVNUKXEWRKUCEZXOIEWTKUCEZIEYPYQIEZXOIEXPWRWTWRYIVOZWTY
      NVOZVPYPXOYQWRYSWEKXNVQWRWTYSYTUTUTWTYTWEVRYRXIXOIYPWQYQWSIYEYPWQQYGWQYHV
      STYJYQWSQYLWSYMVSTUNUHVTWASWOJLZSXEJLXGXHWBWNVDPZUUAABCDWCZWNVFTXAWRWTYIY
      NVJZWFWOXEUUBWOOPUUCWNVGTXAUUDWDWGWHUGSXAJLZXFXAQSWRJLZSWTJLZUUEYEUUFYGWQ
      YHWITYJUUGYLWSYMWITWRWTYIYNWJWHXAUUDWKTWLUUBXBWPQUUCWNWMTXCWRXDWTIYFXCWRQ
      CAWMTYKXDWTQDBWMTUNWA $.
  $}

  $( Triangle inequality for norms.  Theorem 3.3(ii) of [Beran] p. 97.
     (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
  norm-ii $p |- ( ( A e. ~H /\ B e. ~H ) ->
               ( normh ` ( A +h B ) ) <_ ( ( normh ` A ) + ( normh ` B ) ) ) $=
    ( chil wcel cva co cno cfv caddc cle wbr c0v cif oveq1 fveq2d fveq2 breq12d
    wceq ax-hv0cl elimel oveq1d oveq2 oveq2d norm-ii-i dedth2h ) ACDZBCDZABEFZG
    HZAGHZBGHZIFZJKUFALMZBEFZGHZUMGHZUKIFZJKUMUGBLMZEFZGHZUPURGHZIFZJKABLLAUMRZ
    UIUOULUQJVCUHUNGAUMBENOVCUJUPUKIAUMGPUAQBURRZUOUTUQVBJVDUNUSGBURUMEUBOVDUKV
    AUPIBURGPUCQUMURALCSTBLCSTUDUE $.

  ${
    norm-iii.1 $e |- A e. CC $.
    norm-iii.2 $e |- B e. ~H $.
    $( Theorem 3.3(iii) of [Beran] p. 97.  (Contributed by NM, 29-Jul-1999.)
       (New usage is discouraged.) $)
    norm-iii-i $p |- ( normh ` ( A .h B ) )
         = ( ( abs ` A ) x. ( normh ` B ) ) $=
      ( csm co csp csqr cfv ccj cmul cabs his35i fveq2i chil wcel ax-mp normval
      cno wceq cjmulrcli cr hiidrcl cjmulge0i cc0 cle hiidge0 sqrmulii hvmulcli
      wbr eqtri cc absval oveq12i 3eqtr4i ) ABEFZUPGFZHIZAAJIKFZHIZBBGFZHIZKFZU
      PSIZALIZBSIZKFURUSVAKFZHIVCUQVGHAABBCCDDMNUSVAACUABOPZVAUBPDBUCQACUDVHUEV
      AUFUJDBUGQUHUKUPOPVDURTABCDUIUPRQVEUTVFVBKAULPVEUTTCAUMQVHVFVBTDBRQUNUO
      $.
  $}

  $( Theorem 3.3(iii) of [Beran] p. 97.  (Contributed by NM, 25-Oct-1999.)
     (New usage is discouraged.) $)
  norm-iii $p |- ( ( A e. CC /\ B e. ~H )
             -> ( normh ` ( A .h B ) ) = ( ( abs ` A ) x. ( normh ` B ) ) ) $=
    ( cc wcel chil csm co cno cfv cabs cmul wceq cc0 cif c0v oveq1 fveq2d fveq2
    eqeq12d elimel oveq1d oveq2 oveq2d 0cn ax-hv0cl norm-iii-i dedth2h ) ACDZBE
    DZABFGZHIZAJIZBHIZKGZLUHAMNZBFGZHIZUOJIZUMKGZLUOUIBONZFGZHIZURUTHIZKGZLABMO
    AUOLZUKUQUNUSVEUJUPHAUOBFPQVEULURUMKAUOJRUASBUTLZUQVBUSVDVFUPVAHBUTUOFUBQVF
    UMVCURKBUTHRUCSUOUTAMCUDTBOEUETUFUG $.

  ${
    normsub.1 $e |- A e. ~H $.
    normsub.2 $e |- B e. ~H $.
    $( Negative doesn't change the norm of a Hilbert space vector.
       (Contributed by NM, 11-Aug-1999.)  (New usage is discouraged.) $)
    normsubi $p |- ( normh ` ( A -h B ) ) = ( normh ` ( B -h A ) ) $=
      ( c1 cneg cmv csm cno cfv cabs neg1cn hvsubcli norm-iii-i hvnegdii fveq2i
      co cmul ax-1cn eqtri absnegi abs1 oveq1i normcli recni mulid2i 3eqtr3i )
      EFZBAGQZHQZIJUHKJZUIIJZRQZABGQZIJULUHUILBADCMZNUJUNIBADCOPUMEULRQULUKEULR
      UKEKJEESUAUBTUCULULUIUOUDUEUFTUG $.

    $( Analogy to Pythagorean theorem for orthogonal vectors.  Remark 3.4(C) of
       [Beran] p. 98.  (Contributed by NM, 17-Oct-1999.)
       (New usage is discouraged.) $)
    normpythi $p |- ( ( A .ih B ) = 0 -> ( ( normh ` ( A +h B ) ) ^ 2 ) =
                   ( ( ( normh ` A ) ^ 2 ) + ( ( normh ` B ) ^ 2 ) ) ) $=
      ( csp co cc0 wceq cva caddc cno c2 cexp normlem8 chil wcel syl6eq normsqi
      cfv hicli id wb orthcom mp2an biimpi oveq12d oveq2d addcli addid1i syl5eq
      00id hvaddcli oveq12i 3eqtr4g ) ABEFZGHZABIFZUQEFZAAEFZBBEFZJFZUQKSLMFAKS
      LMFZBKSLMFZJFUPURVAUOBAEFZJFZJFZVAABABCDCDNUPVFVAGJFVAUPVEGVAJUPVEGGJFGUP
      UOGVDGJUPUAUPVDGHZAOPBOPUPVGUBCDABUCUDUEUFUKQUGVAUSUTAACCTBBDDTUHUIQUJUQA
      BCDULRVBUSVCUTJACRBDRUMUN $.
  $}

  $( Swapping order of subtraction doesn't change the norm of a vector.
     (Contributed by NM, 14-Aug-1999.)  (New usage is discouraged.) $)
  normsub $p |- ( ( A e. ~H /\ B e. ~H ) ->
                 ( normh ` ( A -h B ) ) = ( normh ` ( B -h A ) ) ) $=
    ( chil wcel cmv co cno cfv wceq c0v cif oveq1 fveq2d oveq2 eqeq12d ax-hv0cl
    elimel normsubi dedth2h ) ACDZBCDZABEFZGHZBAEFZGHZITAJKZBEFZGHZBUFEFZGHZIUF
    UABJKZEFZGHZUKUFEFZGHZIABJJAUFIZUCUHUEUJUPUBUGGAUFBELMUPUDUIGAUFBENMOBUKIZU
    HUMUJUOUQUGULGBUKUFENMUQUIUNGBUKUFELMOUFUKAJCPQBJCPQRS $.

  $( The norm of a vector equals the norm of its negative.  (Contributed by NM,
     23-May-2005.)  (New usage is discouraged.) $)
  normneg $p |- ( A e. ~H ->
                 ( normh ` ( -u 1 .h A ) ) = ( normh ` A ) ) $=
    ( chil wcel c0v cmv co cno cfv cneg csm wceq ax-hv0cl normsub hv2neg fveq2d
    c1 mpan hvsub0 3eqtr3d ) ABCZDAEFZGHZADEFZGHZPIAJFZGHAGHDBCTUBUDKLDAMQTUAUE
    GANOTUCAGAROS $.

  $( Analogy to Pythagorean theorem for orthogonal vectors.  Remark 3.4(C) of
     [Beran] p. 98.  (Contributed by NM, 17-Oct-1999.)
     (New usage is discouraged.) $)
  normpyth $p |- ( ( A e. ~H /\ B e. ~H ) ->
                 ( ( A .ih B ) = 0 -> ( ( normh ` ( A +h B ) ) ^ 2 ) =
                 ( ( ( normh ` A ) ^ 2 ) + ( ( normh ` B ) ^ 2 ) ) ) ) $=
    ( chil wcel csp co cc0 wceq cva cno cfv c2 cexp caddc c0v cif eqeq1d oveq1d
    wi oveq1 fveq2d fveq2 eqeq12d imbi12d oveq2 oveq2d elimel normpythi dedth2h
    ax-hv0cl ) ACDZBCDZABEFZGHZABIFZJKZLMFZAJKZLMFZBJKZLMFZNFZHZSUKAOPZBEFZGHZV
    DBIFZJKZLMFZVDJKZLMFZVANFZHZSVDULBOPZEFZGHZVDVNIFZJKZLMFZVKVNJKZLMFZNFZHZSA
    BOOAVDHZUNVFVCVMWDUMVEGAVDBETQWDUQVIVBVLWDUPVHLMWDUOVGJAVDBITUARWDUSVKVANWD
    URVJLMAVDJUBRRUCUDBVNHZVFVPVMWCWEVEVOGBVNVDEUEQWEVIVSVLWBWEVHVRLMWEVGVQJBVN
    VDIUEUARWEVAWAVKNWEUTVTLMBVNJUBRUFUCUDVDVNAOCUJUGBOCUJUGUHUI $.

  $( Corollary to Pythagorean theorem for orthogonal vectors.  Remark 3.4(C) of
     [Beran] p. 98.  (Contributed by NM, 26-Oct-1999.)
     (New usage is discouraged.) $)
  normpyc $p |- ( ( A e. ~H /\ B e. ~H ) ->
            ( ( A .ih B ) = 0 -> ( normh ` A ) <_ ( normh ` ( A +h B ) ) ) ) $=
    ( chil wcel wa co cc0 wceq cno cfv cexp cle wbr caddc normcl resqcld adantr
    c2 cr syl csp cva recnd addid1d sqge0d adantl wb 0re leadd2 mp3an1 eqbrtrrd
    syl2anr mpbid normpyth imp breqtrrd ex hvaddcl normge0 le2sqd sylibrd ) ACD
    ZBCDZEZABUAFGHZAIJZRKFZABUBFZIJZRKFZLMZVFVILMVDVEVKVDVEEVGVGBIJZRKFZNFZVJLV
    DVGVNLMVEVDVGGNFZVGVNLVBVOVGHVCVBVGVBVGVBVFAOZPZUCUDQVDGVMLMZVOVNLMZVCVRVBV
    CVLBOZUEUFVCVMSDZVGSDZVRVSUGZVBVCVLVTPVQGSDWAWBWCUHGVMVGUIUJULUMUKQVDVEVJVN
    HABUNUOUPUQVDVFVIVBVFSDVCVPQVDVHCDZVISDABURZVHOTVBGVFLMVCAUSQVDWDGVILMWEVHU
    STUTVA $.

  ${
    norm3dif.1 $e |- A e. ~H $.
    norm3dif.2 $e |- B e. ~H $.
    norm3dif.3 $e |- C e. ~H $.
    $( Norm of differences around common element.  Part of Lemma 3.6 of [Beran]
       p. 101.  (Contributed by NM, 16-Aug-1999.)
       (New usage is discouraged.) $)
    norm3difi $p |- ( normh ` ( A -h B ) ) <_ ( ( normh ` ( A -h C ) ) +
                   ( normh ` ( C -h B ) ) ) $=
      ( cmv co cno cfv cva csm hvsubvali neg1cn hvmulcli hvassi c0v hvcomi chil
      wcel caddc cle c1 cneg oveq12i hvaddcli wceq hvsubid ax-mp 3eqtr2i oveq1i
      ax-hv0cl ax-hvaddid 3eqtri eqtr3i oveq2i eqtr4i fveq2i hvsubcli norm-ii-i
      eqbrtri ) ABGHZIJACGHZCBGHZKHZIJVCIJVDIJUAHUBVBVEIVBAUCUDZBLHZKHZVEABDEMV
      EAVFCLHZKHZCVGKHZKHAVIVKKHZKHVHVCVJVDVKKACDFMCBFEMUEAVIVKDVFCNFOZCVGFVFBN
      EOZUFPVLVGAKVICKHZVGKHZVLVGVICVGVMFVNPVPQVGKHVGQKHZVGVOQVGKVOCVIKHCCGHZQV
      ICVMFRCCFFMCSTVRQUGFCUHUIUJUKQVGULVNRVGSTVQVGUGVNVGUMUIUNUOUPUNUQURVCVDAC
      DFUSCBFEUSUTVA $.

    $( Norm of differences around common element.  Part of Lemma 3.6 of [Beran]
       p. 101.  (Contributed by NM, 30-Sep-1999.)
       (New usage is discouraged.) $)
    norm3adifii $p |- ( abs ` ( ( normh ` ( A -h C ) ) -
         ( normh ` ( B -h C ) ) ) ) <_ ( normh ` ( A -h B ) ) $=
      ( cmv co cno cfv cmin cle wbr cneg hvsubcli normcli recni caddc norm3difi
      lesubaddi cabs negsubdi2i normsubi oveq1i breqtri eqbrtri lenegcon1i mpbi
      mpbir resubcli abslei mpbir2an ) ACGHZIJZBCGHZIJZKHZUAJABGHZIJZLMUSNUQLMZ
      UQUSLMZUQNZUSLMUTVBUPUNKHZUSLUNUPUNUMACDFOPZQUPUOBCEFOPZQUBVCUSLMUPUSUNRH
      ZLMUPBAGHIJZUNRHVFLBCAEFDSVGUSUNRBAEDUCUDUEUPUNUSVEVDURABDEOPZTUIUFUQUSUN
      UPVDVEUJZVHUGUHVAUNUSUPRHLMACBDFESUNUPUSVDVEVHTUIUQUSVIVHUKUL $.

    ${
      norm3lem.4 $e |- D e. RR $.
      $( Lemma involving norm of differences in Hilbert space.  (Contributed by
         NM, 18-Aug-1999.)  (New usage is discouraged.) $)
      norm3lem $p |- ( ( ( normh ` ( A -h C ) ) < ( D / 2 ) /\
                         ( normh ` ( C -h B ) ) < ( D / 2 ) ) ->
                         ( normh ` ( A -h B ) ) < D ) $=
        ( cmv co cno cfv c2 clt wbr caddc hvsubcli normcli readdcli recni cdiv
        wa cle norm3difi rehalfcli lt2addi lelttri sylancr 2timesi 2cn divcan2i
        cmul 2ne0 eqtr3i syl6breq ) ACIJZKLZDMUAJZNOCBIJZKLZURNOUBZABIJZKLZURUR
        PJZDNVAVCUQUTPJZUCOVEVDNOVCVDNOABCEFGUDUQUTURURUPACEGQRZUSCBGFQRZDHUEZV
        HUFVCVEVDVBABEFQRUQUTVFVGSURURVHVHSUGUHMURULJVDDURURVHTUIDMDHTUJUMUKUNU
        O $.
    $}
  $}

  $( Norm of differences around common element.  Part of Lemma 3.6 of [Beran]
     p. 101.  (Contributed by NM, 20-Apr-2006.)  (New usage is discouraged.) $)
  norm3dif $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( normh ` ( A -h B ) )
                  <_ ( ( normh ` ( A -h C ) ) + ( normh ` ( C -h B ) ) ) ) $=
    ( chil wcel cmv co cno cfv caddc cle wbr c0v cif wceq oveq1 fveq2d ax-hv0cl
    oveq2 elimel oveq1d breq12d oveq2d oveq12d breq2d norm3difi dedth3h ) ADEZB
    DEZCDEZABFGZHIZACFGZHIZCBFGZHIZJGZKLUHAMNZBFGZHIZURCFGZHIZUPJGZKLURUIBMNZFG
    ZHIZVBCVDFGZHIZJGZKLVFURUJCMNZFGZHIZVJVDFGZHIZJGZKLABCMMMAUROZULUTUQVCKVPUK
    USHAURBFPQVPUNVBUPJVPUMVAHAURCFPQUAUBBVDOZUTVFVCVIKVQUSVEHBVDURFSQVQUPVHVBJ
    VQUOVGHBVDCFSQUCUBCVJOZVIVOVFKVRVBVLVHVNJVRVAVKHCVJURFSQVRVGVMHCVJVDFPQUDUE
    URVDVJAMDRTBMDRTCMDRTUFUG $.

  $( Norm of differences around common element.  (Contributed by NM,
     18-Apr-2007.)  (New usage is discouraged.) $)
  norm3dif2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( normh ` ( A -h B )
                  ) <_ ( ( normh ` ( C -h A ) ) + ( normh ` ( C -h B ) ) ) ) $=
    ( chil wcel w3a cmv cno cfv caddc cle norm3dif wceq normsub 3adant2 breqtrd
    co oveq1d ) ADEZBDEZCDEZFZABGQHIACGQHIZCBGQHIZJQCAGQHIZUDJQKABCLUBUCUEUDJSU
    AUCUEMTACNORP $.

  $( Lemma involving norm of differences in Hilbert space.  (Contributed by NM,
     18-Aug-1999.)  (New usage is discouraged.) $)
  norm3lemt $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\
                   D e. RR ) ) -> (
          ( ( normh ` ( A -h C ) ) < ( D / 2 ) /\
            ( normh ` ( C -h B ) ) < ( D / 2 ) ) ->
            ( normh ` ( A -h B ) ) < D ) ) $=
    ( chil wcel cmv co cno cfv c2 clt wbr wa wi c0v cif wceq fveq2d breq1d cdiv
    cr oveq1 anbi1d imbi12d oveq2 anbi2d anbi12d imbi1d breq2d breq2 elimel 2re
    ax-hv0cl norm3lem dedth4h ) AEFZBEFZCEFZDUBFZACGHZIJZDKUAHZLMZCBGHZIJZVCLMZ
    NZABGHZIJZDLMZOUQAPQZCGHZIJZVCLMZVGNZVLBGHZIJZDLMZOVOCURBPQZGHZIJZVCLMZNZVL
    VTGHZIJZDLMZOVLUSCPQZGHZIJZVCLMZWHVTGHZIJZVCLMZNZWGOWJUTDKQZKUAHZLMZWMWQLMZ
    NZWFWPLMZOABCDPPPKAVLRZVHVPVKVSXBVDVOVGXBVBVNVCLXBVAVMIAVLCGUCSTUDXBVJVRDLX
    BVIVQIAVLBGUCSTUEBVTRZVPWDVSWGXCVGWCVOXCVFWBVCLXCVEWAIBVTCGUFSTUGXCVRWFDLXC
    VQWEIBVTVLGUFSTUECWHRZWDWOWGXDVOWKWCWNXDVNWJVCLXDVMWIICWHVLGUFSTXDWBWMVCLXD
    WAWLICWHVTGUCSTUHUIDWPRZWOWTWGXAXEWKWRWNWSXEVCWQWJLDWPKUAUCZUJXEVCWQWMLXFUJ
    UHDWPWFLUKUEVLVTWHWPAPEUNULBPEUNULCPEUNULDKUBUMULUOUP $.

  ${
    norm3adift.1 $e |- C e. ~H $.
    $( Norm of differences around common element.  Part of Lemma 3.6 of [Beran]
       p. 101.  (Contributed by NM, 3-Oct-1999.)
       (New usage is discouraged.) $)
    norm3adifi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( abs ` ( ( normh ` ( A -h C ) ) -
         ( normh ` ( B -h C ) ) ) ) <_ ( normh ` ( A -h B ) ) ) $=
      ( chil wcel cmv co cno cfv cmin cabs cle wbr c0v cif oveq1 fveq2d breq12d
      wceq oveq1d oveq2d oveq2 ax-hv0cl elimel norm3adifii dedth2h ) AEFZBEFZAC
      GHZIJZBCGHZIJZKHZLJZABGHZIJZMNUHAOPZCGHZIJZUMKHZLJZURBGHZIJZMNUTUIBOPZCGH
      ZIJZKHZLJZURVEGHZIJZMNABOOAURTZUOVBUQVDMVLUNVALVLUKUTUMKVLUJUSIAURCGQRUAR
      VLUPVCIAURBGQRSBVETZVBVIVDVKMVMVAVHLVMUMVGUTKVMULVFIBVECGQRUBRVMVCVJIBVEU
      RGUCRSURVECAOEUDUEBOEUDUEDUFUG $.
  $}

  ${
    normpar.1 $e |- A e. ~H $.
    normpar.2 $e |- B e. ~H $.
    $( Parallelogram law for norms.  Remark 3.4(B) of [Beran] p. 98.
       (Contributed by NM, 21-Aug-1999.)  (New usage is discouraged.) $)
    normpari $p |- ( ( ( normh ` ( A -h B ) ) ^ 2 ) +
                    ( ( normh ` ( A +h B ) ) ^ 2 ) ) =
                  ( ( 2 x. ( ( normh ` A ) ^ 2 ) ) +
                    ( 2 x. ( ( normh ` B ) ^ 2 ) ) ) $=
      ( co cno cfv c2 cexp caddc csp normsqi oveq12i oveq2i hicli 2timesi eqtri
      cmul addcli eqtr4i cmv cva hvsubcli hvaddcli cneg normlem9 negsubi negcli
      cmin normlem8 add42i cc0 negidi addid1i add4i 3eqtri ) ABUAEZFGHIEZABUBEZ
      FGHIEZJEUQUQKEZUSUSKEZJEZHAFGHIEZREZHBFGHIEZREZJEZURVAUTVBJUQABCDUCLUSABC
      DUDLMVHAAKEZVIJEZBBKEZVKJEZJEZVCVEVJVGVLJVEHVIREVJVDVIHRACLNVIAACCOZPQVGH
      VKREVLVFVKHRBDLNVKBBDDOZPQMVCVIVKJEZABKEZBAKEZJEZUEZJEZVPVSJEZJEVPVPJEZVS
      VTJEZJEZVMVAWAVBWBJVAVPVSUIEWAABABCDCDUFVPVSVIVKVNVOSZVQVRABCDOBADCOSZUGT
      ABABCDCDUJMVPVTVPVSWFVSWGUHWFWGUKWEWCULJEWCVMWDULWCJVSWGUMNWCVPVPWFWFSUNV
      IVKVIVKVNVOVNVOUOUPUPTT $.
  $}

  $( Parallelogram law for norms.  Remark 3.4(B) of [Beran] p. 98.
     (Contributed by NM, 15-Apr-2007.)  (New usage is discouraged.) $)
  normpar $p |- ( ( A e. ~H /\ B e. ~H ) ->
          ( ( ( normh ` ( A -h B ) ) ^ 2 ) + ( ( normh ` ( A +h B ) ) ^ 2 ) ) =
       ( ( 2 x. ( ( normh ` A ) ^ 2 ) ) + ( 2 x. ( ( normh ` B ) ^ 2 ) ) ) ) $=
    ( chil wcel cmv co cno cfv c2 cexp cva caddc cmul wceq c0v cif oveq1 fveq2d
    oveq1d oveq2d oveq12d fveq2 eqeq12d oveq2 ax-hv0cl elimel normpari dedth2h
    ) ACDZBCDZABEFZGHZIJFZABKFZGHZIJFZLFZIAGHZIJFZMFZIBGHZIJFZMFZLFZNUIAOPZBEFZ
    GHZIJFZVEBKFZGHZIJFZLFZIVEGHZIJFZMFZVCLFZNVEUJBOPZEFZGHZIJFZVEVQKFZGHZIJFZL
    FZVOIVQGHZIJFZMFZLFZNABOOAVENZUQVLVDVPWIUMVHUPVKLWIULVGIJWIUKVFGAVEBEQRSWIU
    OVJIJWIUNVIGAVEBKQRSUAWIUTVOVCLWIUSVNIMWIURVMIJAVEGUBSTSUCBVQNZVLWDVPWHWJVH
    VTVKWCLWJVGVSIJWJVFVRGBVQVEEUDRSWJVJWBIJWJVIWAGBVQVEKUDRSUAWJVCWGVOLWJVBWFI
    MWJVAWEIJBVQGUBSTTUCVEVQAOCUEUFBOCUEUFUGUH $.

  ${
    normpar2.1 $e |- A e. ~H $.
    normpar2.2 $e |- B e. ~H $.
    normpar2.3 $e |- C e. ~H $.
    $( Corollary of parallelogram law for norms.  Part of Lemma 3.6 of [Beran]
       p. 100.  (Contributed by NM, 5-Oct-1999.)
       (New usage is discouraged.) $)
    normpar2i $p |- ( ( normh ` ( A -h B ) ) ^ 2 ) =
                   ( ( ( 2 x. ( ( normh ` ( A -h C ) ) ^ 2 ) ) +
                       ( 2 x. ( ( normh ` ( B -h C ) ) ^ 2 ) ) )
          - ( ( normh ` ( ( A +h B ) -h ( 2 .h C ) ) ) ^ 2 ) ) $=
      ( c2 cmv co cno cfv cexp cmul caddc cva csm 2cn c4 cdiv oveq1i cmin recni
      2re hvsubcli normcli resqcli remulcli readdcli hvaddcli hvmulcli 4cn 2ne0
      mulcli divdiri addcomi cabs cneg neg1cn hvadd32i hvsubvali hvcomi oveq12i
      hvnegdii hvsubcan2i eqtr4i 3eqtr4i hvsubdistr1i fveq2i norm-iii-i cc0 cle
      c1 eqtri wbr wceq 0re 2pos ltleii absidi ax-mp 3eqtri sqmuli sq2 normpari
      divcan3i div23i 4d2e2 3eqtr3i subaddrii eqcomi ) GACHIZJKZGLIZMIZGBCHIZJK
      ZGLIZMIZNIZABOIZGCPIZHIZJKZGLIZUAIABHIZJKZGLIZWSXDXGWSWNWRGWMUCWLWKACDFUD
      ZUEZUFZUGGWQUCWPWOBCEFUDZUEZUFZUGUHUBXDXCXBWTXAABDEUIZGCQFUJZUDZUEUFUBZXG
      XFXEABDEUDZUEUFUBZRWMMIZRWQMIZNIZGSIZXTGSIZYAGSIZNIXDXGNIZWSXTYAGRWMUKWMX
      JUBZUMZRWQUKWQXMUBZUMZQULUNYCGXDMIZGXGMIZNIZGSIYKGSIZYLGSIZNIYFYBYMGSYBXB
      XEHIZJKZGLIZXBXEOIZJKZGLIZNIZYMYBYAXTNIUUBXTYAYHYJUOYRYAUUAXTNYRGWPMIZGLI
      GGLIZWQMIYAYQUUCGLYQGWOPIZJKGUPKZWPMIUUCYPUUEJXBVLUQZXEPIZOIZGBPIZXAHIZYP
      UUEWTUUGXAPIZOIZUUHOIWTUUHOIZUULOIZUUIUUKWTUULUUHXNUUGXAURXOUJZUUGXEURXRU
      JUSXBUUMUUHOWTXAXNXOUTZTUUKUUJUULOIUUOUUJXAGBQEUJXOUTUUNUUJUULOUUNBAOIZBA
      HIZOIUUJWTUURUUHUUSOABDEVAABDEVCVBBAEDVDVMTVEVFXBXEXPXRUTGBCQEFVGVFVHGWOQ
      XKVIUUFGWPMVJGVKVNUUFGVOVJGVPUCVQVRGUCVSVTZTWATGWPQWPXLUBWBUUDRWQMWCTWAUU
      AGWLMIZGLIUUDWMMIXTYTUVAGLYTGWKPIZJKUUFWLMIUVAYSUVBJUUMXEOIZGAPIZXAHIZYSU
      VBWTXEOIZUULOIUVDUULOIUVCUVEUVFUVDUULOABDEVDTWTUULXEXNUUPXRUSUVDXAGAQDUJX
      OUTVFXBUUMXEOUUQTGACQDFVGVFVHGWKQXHVIUUFGWLMUUTTWATGWLQWLXIUBWBUUDRWMMWCT
      WAVBVEXBXEXPXRWDVMTYKYLGGXDQXQUMGXGQXSUMQULUNYNXDYOXGNXDGXQQULWEXGGXSQULW
      EVBWAYDWNYEWRNYDRGSIZWMMIWNRWMGUKYGQULWFUVGGWMMWGTVMYEUVGWQMIWRRWQGUKYIQU
      LWFUVGGWQMWGTVMVBWHWIWJ $.
  $}

  ${
    polid2.1 $e |- A e. ~H $.
    polid2.2 $e |- B e. ~H $.
    polid2.3 $e |- C e. ~H $.
    polid2.4 $e |- D e. ~H $.
    $( Generalized polarization identity.  Generalization of Exercise 4(a) of
       [ReedSimon] p. 63.  (Contributed by NM, 30-Jun-2005.)
       (New usage is discouraged.) $)
    polid2i $p |- ( A .ih B ) = ( ( ( ( ( A +h C ) .ih ( D +h B ) ) -
                ( ( A -h C ) .ih ( D -h B ) ) ) +
       ( _i x. ( ( ( A +h ( _i .h C ) ) .ih ( D +h ( _i .h B ) ) ) -
               ( ( A -h ( _i .h C ) ) .ih ( D -h ( _i .h B ) ) ) ) ) ) / 4 ) $=
      ( c4 csp co cmul cmin ci caddc hicli c2 addcli wcel ax-icn cva cmv subcli
      cdiv csm 4cn 4re 4pos gt0ne0ii divcan3i 2cn adddii cc wceq ppncan 2timesi
      mp3an eqtr4i oveq2i mulassi 2t2e4 oveq1i 3eqtr2ri pnncani oveq12i 3eqtr4i
      normlem8 normlem9 cneg hvmulcli ccj cfv chil his5 cji eqtri eqtr3i 3eqtri
      ax-his3 negcli mulcli mul12i c1 ixi negeqi ax-1cn negnegi mulid2i 3eqtr3i
      mulneg2i mulm1i negsubi 3eqtr2i ) IABJKZLKZIUDKWNACUAKDBUAKJKZACUBKDBUBKJ
      KZMKZNANCUEKZUAKDNBUEKZUAKJKZAWSUBKDWTUBKJKZMKZLKZOKZIUDKWNIABEFPZUFIUGUH
      UIUJWOXEIUDQWNCDJKZOKZWNXGMKZOKZLKZQXHLKZQXILKZOKWOXEQXHXIUKWNXGXFCDGHPZR
      ZWNXGXFXNUCULXKQQWNLKZLKQQLKZWNLKWOXJXPQLXJWNWNOKZXPWNUMSZXGUMSXSXJXRUNXF
      XNXFWNXGWNUOUQWNXFUPURUSQQWNUKUKXFUTXQIWNLVAVBVCWRXLXDXMOADJKZCBJKZOKZXHO
      KZYBXHMKZMKXHXHOKWRXLYBXHXHXTYAADEHPZCBGFPRXOXOVDWPYCWQYDMACDBEGHFVGACDBE
      GHFVHVEXHXOUPVFXDNQNVIZWNLKZNXGLKZOKZLKZLKQNYILKZLKXMXCYJNLXCXTWSWTJKZOKZ
      AWTJKZWSDJKZOKZOKZYMYPMKZMKYPYPOKZYJXAYQXBYRMAWSDWTENCTGVJZHNBTFVJZVGAWSD
      WTEYTHUUAVHVEYMYPYPXTYLYEWSWTYTUUAPRYNYOAWTEUUAPWSDYTHPRZUUBVDQYPLKYSYJYP
      UUBUPYPYIQLYNYGYOYHOYNNVKVLZWNLKZYGNUMSZAVMSBVMSYNUUDUNTEFNABVNUQUUCYFWNL
      VOVBVPUUECVMSDVMSYOYHUNTGHNCDVSUQVEUSVQVRUSQNYIUKTYGYHYFWNNTVTZXFWAZNXGTX
      NWAZRWBYKXIQLYKNYGLKZNYHLKZOKWNXGVIZOKXINYGYHTUUGUUHULUUIWNUUJUUKONYFLKZW
      NLKWCWNLKUUIWNUULWCWNLUULNNLKZVIWCVIZVIWCNNTTWJUUMUUNWDWEWCWFWGVRVBNYFWNT
      UUFXFUTWNXFWHWIUUMXGLKUUNXGLKUUJUUKUUMUUNXGLWDVBNNXGTTXNUTXGXNWKWIVEWNXGX
      FXNWLVRUSWMVEVFVBVQ $.
  $}

  ${
    polid.1 $e |- A e. ~H $.
    polid.2 $e |- B e. ~H $.
    $( Polarization identity.  Recovers inner product from norm.  Exercise 4(a)
       of [ReedSimon] p. 63.  The outermost operation is + instead of - due to
       our mathematicians' (rather than physicists') version of axiom
       ~ ax-his3 .  (Contributed by NM, 30-Jun-2005.)
       (New usage is discouraged.) $)
    polidi $p |- ( A .ih B ) = ( ( ( ( ( normh ` ( A +h B ) ) ^ 2 ) -
                ( ( normh ` ( A -h B ) ) ^ 2 ) ) +
       ( _i x. ( ( ( normh ` ( A +h ( _i .h B ) ) ) ^ 2 ) -
                ( ( normh ` ( A -h ( _i .h B ) ) ) ^ 2 ) ) ) ) / 4 ) $=
      ( csp co cva cmv cmin ci cmul caddc c4 cdiv cno cfv cexp normsqi oveq12i
      c2 csm polid2i hvaddcli hvsubcli ax-icn hvmulcli oveq2i oveq1i eqtr4i ) A
      BEFABGFZUJEFZABHFZULEFZIFZJAJBUAFZGFZUPEFZAUOHFZUREFZIFZKFZLFZMNFUJOPTQFZ
      ULOPTQFZIFZJUPOPTQFZUROPTQFZIFZKFZLFZMNFABBACDDCUBVJVBMNVEUNVIVALVCUKVDUM
      IUJABCDUCRULABCDUDRSVHUTJKVFUQVGUSIUPAUOCJBUEDUFZUCRURAUOCVKUDRSUGSUHUI
      $.
  $}

  $( Polarization identity.  Recovers inner product from norm.  Exercise 4(a)
     of [ReedSimon] p. 63.  The outermost operation is + instead of - due to
     our mathematicians' (rather than physicists') version of axiom
     ~ ax-his3 .  (Contributed by NM, 17-Nov-2007.)
     (New usage is discouraged.) $)
  polid $p |- ( ( A e. ~H /\ B e. ~H ) ->
           ( A .ih B ) = ( ( ( ( ( normh ` ( A +h B ) ) ^ 2 ) -
              ( ( normh ` ( A -h B ) ) ^ 2 ) ) +
       ( _i x. ( ( ( normh ` ( A +h ( _i .h B ) ) ) ^ 2 ) -
                ( ( normh ` ( A -h ( _i .h B ) ) ) ^ 2 ) ) ) ) / 4 ) ) $=
    ( csp co cva cno cfv c2 cexp cmv cmin ci cmul caddc cdiv c0v fveq2d oveq12d
    c4 oveq1d chil wcel csm wceq cif oveq1 oveq2d eqeq12d oveq2 ax-hv0cl elimel
    polidi dedth2h ) AUAUBZBUAUBZABCDZABEDZFGZHIDZABJDZFGZHIDZKDZLALBUCDZEDZFGZ
    HIDZAVDJDZFGZHIDZKDZMDZNDZSODZUDUNAPUEZBCDZVOBEDZFGZHIDZVOBJDZFGZHIDZKDZLVO
    VDEDZFGZHIDZVOVDJDZFGZHIDZKDZMDZNDZSODZUDVOUOBPUEZCDZVOWNEDZFGZHIDZVOWNJDZF
    GZHIDZKDZLVOLWNUCDZEDZFGZHIDZVOXCJDZFGZHIDZKDZMDZNDZSODZUDABPPAVOUDZUPVPVNW
    MAVOBCUFXNVMWLSOXNVCWCVLWKNXNUSVSVBWBKXNURVRHIXNUQVQFAVOBEUFQTXNVAWAHIXNUTV
    TFAVOBJUFQTRXNVKWJLMXNVGWFVJWIKXNVFWEHIXNVEWDFAVOVDEUFQTXNVIWHHIXNVHWGFAVOV
    DJUFQTRUGRTUHBWNUDZVPWOWMXMBWNVOCUIXOWLXLSOXOWCXBWKXKNXOVSWRWBXAKXOVRWQHIXO
    VQWPFBWNVOEUIQTXOWAWTHIXOVTWSFBWNVOJUIQTRXOWJXJLMXOWFXFWIXIKXOWEXEHIXOWDXDF
    XOVDXCVOEBWNLUCUIZUGQTXOWHXHHIXOWGXGFXOVDXCVOJXPUGQTRUGRTUHVOWNAPUAUJUKBPUA
    UJUKULUM $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Relate Hilbert space to normed complex vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Hilbert space vector addition is an Abelian group operation.
       (Contributed by NM, 15-Apr-2007.)  (New usage is discouraged.) $)
    hilablo $p |- +h e. AbelOp $=
      ( vx vy vz cva chil c0v c1 cv csm co ax-hilex ax-hfvadd ax-hvass ax-hv0cl
      cneg hvaddid2 cc wcel neg1cn ax-hvcom hvmulcl mpan wceq mpancom eqtrd cxp
      hvnegid isgrpoi fdmi isabloi ) ABDEABCFDGOZAHZIJZEKLULBHZCHMNULPUKQRULERZ
      UMERZSUKULUAUBZUOUMULDJZULUMDJZFUPUOURUSUCUQUMULTUDULUGUEUHEEUFEDLUIULUNT
      UJ $.

    $( The group identity element of Hilbert space vector addition is the zero
       vector.  (Contributed by NM, 16-Apr-2007.)
       (New usage is discouraged.) $)
    hilid $p |- ( GId ` +h ) = 0h $=
      ( vy vx cva cgi cfv cv co wceq chil wral crio c0v cgr wcel cablo ablogrpo
      hilablo ax-mp cxp ax-hfvadd fdmi grporn eqid grpoidval hvaddid2 rgen wreu
      wb ax-hv0cl grpoideu oveq1 eqeq1d ralbidv riota2 mp2an mpbi eqtri ) CDEZA
      FZBFZCGZUTHZBIJZAIKZLCMNZURVDHCONVEQCPRZBAURCICIVFIISICTUAUBZURUCUDRLUTCG
      ZUTHZBIJZVDLHZVIBIUTUEUFLINVCAIUGZVJVKUHUIVEVLVFBACIVGUJRVCVJAILUSLHZVBVI
      BIVMVAVHUTUSLUTCUKULUMUNUOUPUQ $.

    $( Hilbert space is a complex vector space.  Vector addition is ` +h ` ,
       and scalar product is ` .h ` .  (Contributed by NM, 15-Apr-2007.)
       (New usage is discouraged.) $)
    hilvc $p |- <. +h , .h >. e. CVecOLD $=
      ( vx vy vz csm cva cop chil hilablo cxp ax-hfvadd ax-hfvmul cv ax-hvmulid
      fdmi ax-hvdistr1 ax-hvdistr2 ax-hvmulass eqid isvci ) ABCDEEDFZGHGGIGEJNK
      ALZMBLZUACLZOUBUCUAPUBUCUAQTRS $.
  $}

  ${
    $d x U $.
    hilnorm.5 $e |- ~H = ( BaseSet ` U ) $.
    hilnorm.2 $e |- .ih = ( .iOLD ` U ) $.
    hilnorm.9 $e |- U e. NrmCVec $.
    $( Hilbert space norm in terms of vector space norm.  (Contributed by NM,
       11-Sep-2007.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    hilnormi $p |- normh = ( normCV ` U ) $=
      ( vx chil cv cnmcv cfv cmpt csp co csqr cno cnv wcel wceq eqid ipnm mpan
      mpteq2ia cr nvf feqmptd ax-mp dfhnorm2 3eqtr4ri ) EFEGZAHIZIZJZEFUHUHKLMI
      ZJUINEFUJULAOPZUHFPUJULQDUHKAUIFBUIRZCSTUAUMUIUKQDUMEFUBUIAUIFBUNUCUDUEEU
      FUG $.
  $}

  ${
    hilhh.1 $e |- ~H = ( BaseSet ` U ) $.
    hilhh.2 $e |- +h = ( +v ` U ) $.
    hilhh.3 $e |- .h = ( .sOLD ` U ) $.
    hilhh.5 $e |- .ih = ( .iOLD ` U ) $.
    hilhh.9 $e |- U e. NrmCVec $.
    $( Deduce the structure of Hilbert space from its components.  (Contributed
       by NM, 10-Apr-2008.)  (New usage is discouraged.) $)
    hilhhi $p |- U = <. <. +h , .h >. , normh >. $=
      ( cnv wcel cva csm cop cno wceq hilnormi nvop ax-mp ) AGHAIJKLKMFJAILCDAB
      EFNOP $.
  $}

  ${
    $d k v w x y z U $.
    hhnv.1 $e |- U = <. <. +h , .h >. , normh >. $.
    $( Hilbert space is a normed complex vector space.  (Contributed by NM,
       17-Nov-2007.)  (New usage is discouraged.) $)
    hhnv $p |- U e. NrmCVec $=
      ( vx csm cva cno chil c0v cablo wcel cgr hilablo ablogrpo ax-mp ax-hfvadd
      vy cxp cfv cv wceq fdmi grporn cgi hilid eqcomi hilvc normf norm-i biimpa
      cc0 norm-iii norm-ii isnvi ) CPDAEFGHEGEIJEKJLEMNGGQGEOUAUBEUCRHUDUEUFUGC
      SZGJUNFRUJTUNHTUNUHUIPSZUNUKUNUOULBUM $.

    $( The group (addition) operation of Hilbert space.  (Contributed by NM,
       17-Nov-2007.)  (New usage is discouraged.) $)
    hhva $p |- +h = ( +v ` U ) $=
      ( hhnv h2hva ) ABABCD $.

    $( The base set of Hilbert space.  This theorem provides an independent
       proof of ~ df-hba (see comments in that definition).  (Contributed by
       NM, 17-Nov-2007.)  (New usage is discouraged.) $)
    hhba $p |- ~H = ( BaseSet ` U ) $=
      ( chil cva crn cba cfv cablo wcel cgr hilablo ablogrpo cxp ax-hfvadd fdmi
      ax-mp grporn eqid hhva bafval eqtr4i ) CDEAFGZDCDHIDJIKDLPCCMCDNOQADUBUBR
      ABSTUA $.

    $( The zero vector of Hilbert space.  (Contributed by NM, 17-Nov-2007.)
       (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    hh0v $p |- 0h = ( 0vec ` U ) $=
      ( cn0v cfv cpv cgi cva wcel wceq hhnv eqid 0vfval ax-mp hhva fveq2i hilid
      c0v cnv 3eqtr2ri ) ACDZAEDZFDZGFDQARHTUBIABJAUARTUAKTKLMGUAFABNOPS $.

    $( The scalar product operation of Hilbert space.  (Contributed by NM,
       17-Nov-2007.)  (New usage is discouraged.) $)
    hhsm $p |- .h = ( .sOLD ` U ) $=
      ( hhnv h2hsm ) ABABCD $.

    $( The vector subtraction operation of Hilbert space.  (Contributed by NM,
       13-Dec-2007.)  (New usage is discouraged.) $)
    hhvs $p |- -h = ( -v ` U ) $=
      ( hhnv hhba h2hvs ) ABABCABDE $.

    $( The norm function of Hilbert space.  (Contributed by NM, 17-Nov-2007.)
       (New usage is discouraged.) $)
    hhnm $p |- normh = ( normCV ` U ) $=
      ( hhnv h2hnm ) ABABCD $.

    ${
      hhims.2 $e |- D = ( normh o. -h ) $.
      $( The induced metric of Hilbert space.  (Contributed by NM,
         17-Nov-2007.)  (New usage is discouraged.) $)
      hhims $p |- D = ( IndMet ` U ) $=
        ( cno cmv ccom cims cfv cnv wcel wceq hhnv hhvs hhnm eqid imsval eqtr4i
        ax-mp ) AEFGZBHIZDBJKUATLBCMUABFEBCNBCOUAPQSR $.
    $}

    ${
      hhims2.2 $e |- D = ( IndMet ` U ) $.
      $( Hilbert space distance metric.  (Contributed by NM, 10-Apr-2008.)
         (New usage is discouraged.) $)
      hhims2 $p |- D = ( normh o. -h ) $=
        ( cims cfv cno cmv ccom eqid hhims eqtr4i ) ABEFGHIZDMBCMJKL $.

      $( The induced metric of Hilbert space.  (Contributed by NM,
         10-Apr-2008.)  (New usage is discouraged.) $)
      hhmet $p |- D e. ( Met ` ~H ) $=
        ( cnv wcel chil cme cfv hhnv hhba imsmet ax-mp ) BEFAGHIFBCJABGBCKDLM
        $.

      $( The induced metric of Hilbert space.  (Contributed by Mario Carneiro,
         10-Sep-2015.)  (New usage is discouraged.) $)
      hhxmet $p |- D e. ( *Met ` ~H ) $=
        ( chil cme cfv wcel cxmt hhmet metxmet ax-mp ) AEFGHAEIGHABCDJAEKL $.

      $( Value of the distance function of the metric space of Hilbert space.
         (Contributed by NM, 10-Apr-2008.)  (New usage is discouraged.) $)
      hhmetdval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( A D B ) = ( normh ` ( A -h B ) ) ) $=
        ( hhnv hhba h2hmetdval ) ABCDEDEGDEHFI $.
    $}

    $( The inner product operation of Hilbert space.  (Contributed by NM,
       17-Nov-2007.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    hhip $p |- .ih = ( .iOLD ` U ) $=
      ( vx vy csp cfv wceq cv co chil wral wcel cva cno c2 cexp cmv cmin ci cc
      cdip wa csm cmul caddc c4 cdiv polid hhnv hhba hhva hhsm hhnm eqid ipval3
      cnv hhvs mp3an1 eqtr4d rgen2a cxp wf wb ax-hfi ipf wfn ffn eqfnov2 syl2an
      ax-mp mp2an mpbir ) EAUAFZGZCHZDHZEIZVOVPVMIZGZDJKCJKZVSCDJVOJLZVPJLZUBVQ
      VOVPMINFOPIVOVPQINFOPIRISVOSVPUCIZMINFOPIVOWCQINFOPIRIUDIUEIUFUGIZVRVOVPU
      HAUPLZWAWBVRWDGABUIZVOVPVMUCAMQNJABUJZABUKABULABUMVMUNZABUQUOURUSUTJJVAZT
      EVBZWITVMVBZVNVTVCZVDWEWKWFVMAJWGWHVEVJWJEWIVFVMWIVFWLWKWITEVGWITVMVGCDJJ
      EVMVHVIVKVL $.

    $( The Hilbert space of the Hilbert Space Explorer is an inner product
       space.  (Contributed by NM, 24-Nov-2007.)
       (New usage is discouraged.) $)
    hhph $p |- U e. CPreHilOLD $=
      ( vx vy ccphlo wcel cva csm cno co cfv cexp caddc chil normcl recnd sqcld
      c2 cc cvv cop cnv cv c1 cneg cmul wceq wral eqid hhnv wa normpar hvsubval
      cmv fveq2d oveq1d oveq2d cr hvaddcl syl hvsubcl addcomd eqtr3d 2cn mp3an1
      adddi syl2an 3eqtr4d rgen2a wb cablo hilablo elexi hvmulex normf ax-hilex
      fex mp2an w3a eleq1i cgr ablogrpo ax-mp cxp ax-hfvadd grporn isphg syl5bb
      wf fdmi mp3an mpbir2an ) AEFZGHUAIUAZUBFZCUCZDUCZGJZIKZRLJZWPUDUEWQHJGJZI
      KZRLJZMJZRWPIKZRLJZWQIKZRLJZMJUFJZUGZDNUHCNUHZWNWNUIUJXJCDNWPNFZWQNFZUKZW
      PWQUNJZIKZRLJZWTMJZRXFUFJRXHUFJMJZXDXIWPWQULXNWTXQMJXDXRXNXQXCWTMXNXPXBRL
      XNXOXAIWPWQUMUOUPUQXNWTXQXNWSXNWSXNWRNFWSURFWPWQUSWROUTPQXNXPXNXONFZXPSFW
      PWQVAXTXPXOOPUTQVBVCXLXFSFZXHSFZXIXSUGZXMXLXEXLXEWPOPQXMXGXMXGWQOPQRSFYAY
      BYCVDRXFXHVFVEVGVHVIGTFZHTFZITFZWMWOXKUKZVJGVKVLVMVNNURIWINTFYFVOVPNURTIV
      QVRWMWNEFYDYEYFVSYGAWNEBVTCDTTTHGINGNGVKFGWAFVLGWBWCNNWDNGWEWJWFWGWHWKWL
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Bunjakovaskij-Cauchy-Schwarz inequality
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    bcs.1 $e |- A e. ~H $.
    bcs.2 $e |- B e. ~H $.
    $( Bunjakovaskij-Cauchy-Schwarz inequality.  Remark 3.4 of [Beran] p. 98.
       (Contributed by NM, 11-Oct-1999.)  (New usage is discouraged.) $)
    bcsiALT $p |- ( abs ` ( A .ih B ) )
          <_ ( ( normh ` A ) x. ( normh ` B ) ) $=
      ( csp co cc0 wceq cabs cfv cmul cle wbr wcel ax-mp c2 caddc cc c1 cr abs0
      cno fveq2 chil normge0 normcli mulge0i mp2an eqbrtri syl6eqbr wn csqr wne
      df-ne cdiv ccj his1i oveq2i hicli abslem2 syl5req abs00i necon3bii abscli
      wa recni divclzi divreczi fveq2d recclzi absmul sylancr rerecclzi clt 0re
      mpan jctil absgt0i bitri recgt0i sylbi absidd oveq2d eqtrd recidzi 3eqtrd
      ltle sylc jca sylbir normlem7tALT eqbrtrd normval oveq12i mulcomli breq2i
      syl 2pos hiidge0 hiidrcl sqrcli mp2b remulcli 2re lemul2i sylibr pm2.61i
      wb ) ABEFZGHZXIIJZAUBJZBUBJZKFZLMZXJXKGIJZXNLXIGIUCXPGXNLUAGXLLMZGXMLMZGX
      NLMAUDNZXQCAUEOBUDNZXRDBUEOXLXMACUFZBDUFZUGUHUIUJXJUKZPXKKFZPBBEFZULJZAAE
      FZULJZKFZKFZLMZXOYCXIGUMZYKXIGUNYLYDXIXKUOFZUPJXIKFZYMBAEFZKFZQFZYJLYLYQY
      NYMXIUPJZKFZQFZYDYPYSYNQYOYRYMKBADCUQURURXIRNZYLYTYDHABCDUSZXIUTVPVAYLYMR
      NZYMIJZSHZVEZYQYJLMYLXKGUMZUUFXKGXIGXIUUBVBVCZUUGUUCUUEXIXKUUBXKXIUUBVDZV
      FZVGUUGUUDXISXKUOFZKFZIJZXKUUKKFZSUUGYMUULIXIXKUUBUUJVHVIUUGUUMXKUUKIJZKF
      ZUUNUUGUUAUUKRNUUMUUPHUUBXKUUJVJXIUUKVKVLUUGUUOUUKXKKUUGUUKXKUUIVMZUUGGTN
      ZUUKTNZVEGUUKVNMZGUUKLMUUGUUSUURUUQVOVQUUGGXKVNMZUUTUUGYLUVAUUHXIUUBVRVSX
      KUUIVTWAGUUKWGWHWBWCWDXKUUJWEWFWIWJABYMCDWKWQWLWJXOXKYILMZYKXNYIXKLXMXLYI
      XMYBVFXLYAVFXMYFXLYHKXTXMYFHDBWMOXSXLYHHCAWMOWNWOWPGPVNMUVBYKXHWRXKYIPUUI
      YFYHXTGYELMYFTNDBWSYEXTYETNDBWTOXAXBXSGYGLMYHTNCAWSYGXSYGTNCAWTOXAXBXCXDX
      EOVSXFXG $.

    $( Bunjakovaskij-Cauchy-Schwarz inequality.  Remark 3.4 of [Beran] p. 98.
       (Proved from ZFC version.)  (Contributed by NM, 24-Nov-2007.)
       (New usage is discouraged.) $)
    bcsiHIL $p |- ( abs ` ( A .ih B ) )
         <_ ( ( normh ` A ) x. ( normh ` B ) ) $=
      ( csp cva csm cop cno chil df-hba eqid hhnm hhip hhph siii ) ABEFGHIHZIJK
      QQLZMQRNQROCDP $.
  $}

  $( Bunjakovaskij-Cauchy-Schwarz inequality.  Remark 3.4 of [Beran] p. 98.
     (Contributed by NM, 16-Feb-2006.)  (New usage is discouraged.) $)
  bcs $p |- ( ( A e. ~H /\ B e. ~H ) ->
             ( abs ` ( A .ih B ) ) <_ ( ( normh ` A ) x. ( normh ` B ) ) ) $=
    ( chil wcel csp cabs cfv cno cmul cle wbr c0v cif wceq fveq2d fveq2 breq12d
    co ax-hv0cl elimel oveq1 oveq1d oveq2 oveq2d bcsiHIL dedth2h ) ACDZBCDZABER
    ZFGZAHGZBHGZIRZJKUGALMZBERZFGZUNHGZULIRZJKUNUHBLMZERZFGZUQUSHGZIRZJKABLLAUN
    NZUJUPUMURJVDUIUOFAUNBEUAOVDUKUQULIAUNHPUBQBUSNZUPVAURVCJVEUOUTFBUSUNEUCOVE
    ULVBUQIBUSHPUDQUNUSALCSTBLCSTUEUF $.

  $( Corollary of the Bunjakovaskij-Cauchy-Schwarz inequality ~ bcsiHIL .
     (Contributed by NM, 24-May-2006.)  (New usage is discouraged.) $)
  bcs2 $p |- ( ( A e. ~H /\ B e. ~H /\ ( normh ` A ) <_ 1 ) ->
             ( abs ` ( A .ih B ) ) <_ ( normh ` B ) ) $=
    ( chil wcel cno cfv c1 cle wbr w3a co cabs cmul cr wa hicl 3adant3 3ad2ant2
    csp normcl abscld remulcl syl2an bcs cc0 3ad2ant1 normge0 jca simp3 lemul1a
    1re mp3anl2 syl21anc wceq recnd mulid2d breqtrd letrd ) ACDZBCDZAEFZGHIZJZA
    BSKZLFZVABEFZMKZVFUSUTVENDVBUSUTOVDABPUAQUSUTVGNDZVBUSVANDZVFNDZVHUTATZBTZV
    AVFUBUCQUTUSVJVBVLRZUSUTVEVGHIVBABUDQVCVGGVFMKZVFHVCVIVJUEVFHIZOZVBVGVNHIZU
    SUTVIVBVKUFVCVJVOVMUTUSVOVBBUGRUHUSUTVBUIVIGNDVPVBVQUKVAGVFUJULUMUTUSVNVFUN
    VBUTVFUTVFVLUOUPRUQUR $.

  $( Corollary of the Bunjakovaskij-Cauchy-Schwarz inequality ~ bcsiHIL .
     (Contributed by NM, 26-May-2006.)  (New usage is discouraged.) $)
  bcs3 $p |- ( ( A e. ~H /\ B e. ~H /\ ( normh ` B ) <_ 1 ) ->
             ( abs ` ( A .ih B ) ) <_ ( normh ` A ) ) $=
    ( chil wcel cno cfv c1 cle wbr w3a csp co cabs wceq abshicom 3adant3 3com12
    bcs2 eqbrtrd ) ACDZBCDZBEFGHIZJABKLMFZBAKLMFZAEFZHTUAUCUDNUBABOPUATUBUDUEHI
    BARQS $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                     Cauchy sequences and completeness axiom
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Cauchy sequences and limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z f F $.  $d x y z A $.
    $( Member of the set of Cauchy sequences on a Hilbert space.  Definition
       for Cauchy sequence in [Beran] p. 96.  (Contributed by NM,
       16-Aug-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hcau $p |- ( F e. Cauchy <-> ( F : NN --> ~H /\
          A. x e. RR+ E. y e. NN A. z e. ( ZZ>= ` y )
             ( normh ` ( ( F ` y ) -h ( F ` z ) ) ) < x ) ) $=
      ( vf ccau wcel chil cn co cv cfv cmv cno clt wbr wral wrex crp wa cmap wf
      cuz wceq oveq12d fveq2d breq1d rexralbidv ralbidv df-hcau elrab2 ax-hilex
      fveq1 nnex elmap anbi1i bitri ) DFGDHIUAJZGZBKZDLZCKZDLZMJZNLZAKZOPZCUTUC
      LZQBIRZASQZTIHDUBZVJTUTEKZLZVBVLLZMJZNLZVFOPZCVHQBIRZASQVJEDURFVLDUDZVRVI
      ASVSVQVGBCIVHVSVPVEVFOVSVOVDNVSVMVAVNVCMUTVLDUMVBVLDUMUEUFUGUHUIABCEUJUKU
      SVKVJHIDULUNUOUPUQ $.

    $( A Cauchy sequences on a Hilbert space is a sequence.  (Contributed by
       NM, 16-Aug-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hcauseq $p |- ( F e. Cauchy -> F : NN --> ~H ) $=
      ( vy vz vx ccau wcel cn chil wf cv cfv cmv cno clt wbr cuz wral wrex crp
      co hcau simplbi ) AEFGHAIBJZAKCJAKLTMKDJNOCUCPKQBGRDSQDBCAUAUB $.

    $( A Cauchy sequence on a Hilbert space converges.  (Contributed by NM,
       16-Aug-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hcaucvg $p |- ( ( F e. Cauchy /\ A e. RR+ ) -> E. y e. NN
           A. z e. ( ZZ>= ` y ) ( normh ` ( ( F ` y ) -h ( F ` z ) ) ) < A ) $=
      ( vx ccau wcel cv cfv cmv co cno clt wbr cuz wral cn wrex crp chil breq2
      wf hcau simprbi wceq rexralbidv rspccva sylan ) DFGZAHZDIBHDIJKLIZEHZMNZB
      UJOIZPAQRZESPZCSGUKCMNZBUNPAQRZUIQTDUBUPEABDUCUDUOURECSULCUEUMUQABQUNULCU
      KMUAUFUGUH $.

    $( A sequence on a Hilbert space is a Cauchy sequence if it converges.
       (Contributed by NM, 16-Aug-1999.)  (Revised by Mario Carneiro,
       14-May-2014.)  (New usage is discouraged.) $)
    seq1hcau $p |- ( F : NN --> ~H -> ( F e. Cauchy <->
          A. x e. RR+ E. y e. NN A. z e. ( ZZ>= ` y )
             ( normh ` ( ( F ` y ) -h ( F ` z ) ) ) < x ) ) $=
      ( ccau wcel cn chil wf cv cfv cmv co cno clt wbr cuz wral wrex crp hcau
      baib ) DEFGHDIBJZDKCJDKLMNKAJOPCUCQKRBGSATRABCDUAUB $.
  $}

  ${
    $d x y z w f F $.  $d x y z w f A $.  $d x y z B $.
    hlim.1 $e |- A e. _V $.
    $( Express the predicate:  The limit of vector sequence ` F ` in a Hilbert
       space is ` A ` , i.e. ` F ` converges to ` A ` .  This means that for
       any real ` x ` , no matter how small, there always exists an integer
       ` y ` such that the norm of any later vector in the sequence minus the
       limit is less than ` x ` .  Definition of converge in [Beran] p. 96.
       (Contributed by NM, 16-Aug-1999.)  (Revised by Mario Carneiro,
       14-May-2014.)  (New usage is discouraged.) $)
    hlimi $p |- ( F ~~>v A <-> ( ( F : NN --> ~H /\ A e. ~H ) /\
          A. x e. RR+ E. y e. NN A. z e. ( ZZ>= ` y )
                ( normh ` ( ( F ` z ) -h A ) ) < x ) ) $=
      ( vf vw chli wbr cvv wcel cn chil wa cv cfv cmv wral wceq wf cno clt wrex
      co cuz crp df-hlim relopabi brrelexi nnex mpan2 ad2antrr wb feq1 bi2anan9
      fex eleq1 fveq1 oveq12 fveq2d breq1d rexralbidv ralbidv anbi12d pm5.21nii
      sylan brabga ) EDIJZEKLZMNEUAZDNLZOZCPZEQZDRUEZUBQZAPZUCJZCBPUFQZSBMUDZAU
      GSZOZEDIMNGPZUAZHPZNLZOZVNWDQZWFRUEZUBQZVRUCJZCVTSBMUDZAUGSZOZGHIABCHGUHZ
      UIUJVKVJVLWBVKMKLVJUKMNKEUQULUMVJDKLVIWCUNFWOWCGHEDIKKWDETZWFDTZOZWHVMWNW
      BWQWEVKWRWGVLMNWDEUOWFDNURUPWSWMWAAUGWSWLVSBCMVTWSWKVQVRUCWSWJVPUBWQWIVOT
      WRWJVPTVNWDEUSWIVOWFDRUTVGVAVBVCVDVEWPVHULVF $.

    $( A sequence with a limit on a Hilbert space is a sequence.  (Contributed
       by NM, 16-Aug-1999.)  (New usage is discouraged.) $)
    hlimseqi $p |- ( F ~~>v A -> F : NN --> ~H ) $=
      ( vz vx vy chli wbr cn chil wf wcel wa cv cfv cmv co cno clt wral cuz crp
      wrex hlimi simplbi simpld ) BAGHZIJBKZAJLZUGUHUIMDNBOAPQROENSHDFNUAOTFIUC
      EUBTEFDABCUDUEUF $.

    $( Closure of the limit of a sequence on Hilbert space.  (Contributed by
       NM, 16-Aug-1999.)  (New usage is discouraged.) $)
    hlimveci $p |- ( F ~~>v A -> A e. ~H ) $=
      ( vz vx vy chli wbr cn chil wf wcel wa cv cfv cmv co cno clt wral cuz crp
      wrex hlimi simplbi simprd ) BAGHZIJBKZAJLZUGUHUIMDNBOAPQROENSHDFNUAOTFIUC
      EUBTEFDABCUDUEUF $.

    $( Convergence of a sequence on a Hilbert space.  (Contributed by NM,
       16-Aug-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hlimconvi $p |- ( ( F ~~>v A /\ B e. RR+ ) ->
      E. y e. NN A. z e. ( ZZ>= ` y ) ( normh ` ( ( F ` z ) -h A ) ) < B ) $=
      ( vx chli wbr cv cfv cmv co clt wral cn wrex crp wcel chil cno wf simprbi
      cuz wa hlimi wceq breq2 rexralbidv rspccva sylan ) ECHIZBJEKCLMUAKZGJZNIZ
      BAJUDKZOAPQZGROZDRSUMDNIZBUPOAPQZULPTEUBCTSUEURGABCEFUFUCUQUTGDRUNDUGUOUS
      ABPUPUNDUMNUHUIUJUK $.
  $}

  ${
    $d x y z w f F $.  $d x y z w f A $.
    $( The limit of a sequence on a Hilbert space.  (Contributed by NM,
       16-Aug-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hlim2 $p |- ( ( F : NN --> ~H /\ A e. ~H ) -> ( F ~~>v A <->
          A. x e. RR+ E. y e. NN A. z e. ( ZZ>= ` y )
                ( normh ` ( ( F ` z ) -h A ) ) < x ) ) $=
      ( vw chil wcel cn chli wbr cv cfv cmv co cno clt wral wrex crp wf wb wceq
      cuz wi breq2 oveq2 fveq2d breq1d rexralbidv ralbidv bibi12d imbi2d wa vex
      hlimi baib expcom vtoclga impcom ) DGHIGEUAZEDJKZCLEMZDNOZPMZALZQKZCBLUDM
      ZRBISZATRZUBZVAEFLZJKZVCVLNOZPMZVFQKZCVHRBISZATRZUBZUEVAVKUEFDGVLDUCZVSVK
      VAVTVMVBVRVJVLDEJUFVTVQVIATVTVPVGBCIVHVTVOVEVFQVTVNVDPVLDVCNUGUHUIUJUKULU
      MVAVLGHZVSVMVAWAUNVRABCVLEFUOUPUQURUSUT $.
  $}

  ${
    $d n F $.  $d n G $.  $d n ph $.
    hlimadd.3 $e |- ( ph -> F : NN --> ~H ) $.
    hlimadd.4 $e |- ( ph -> G : NN --> ~H ) $.
    hlimadd.5 $e |- ( ph -> F ~~>v A ) $.
    hlimadd.6 $e |- ( ph -> G ~~>v B ) $.
    hlimadd.7 $e |- H = ( n e. NN |-> ( ( F ` n ) +h ( G ` n ) ) ) $.
    $( Limit of the sum of two sequences in a Hilbert vector space.
       (Contributed by Mario Carneiro, 19-May-2014.)
       (New usage is discouraged.) $)
    hlimadd $p |- ( ph -> H ~~>v ( A +h B ) ) $=
      ( cva co cfv wbr chil cn wcel chli cno cmv ccom cmopn clm cmap c1 nnuz cz
      a1i cxmt ctopon csm cop eqid hhims hhxmet mopntopon mp1i cres hhnv df-hba
      1z h2hlm resss eqsstri ssbri syl cnv ctx ccn hhva vacn lmcn2 wf ffvelrnda
      cv wa hvaddcl syl2anc fmptd ax-hilex nnex elmap breqi ovex brres sylanbrc
      sylibr bitri ) AGBCMNZUAUBUCZUDOZUEOZPZGQRUFNZSZGWKTPZABCDEFGWMWMUGWMMQQR
      UHUGUISAVCUJWLQUKOSWMQULOSAWLMUMUNUAUNZWSUOZWLWSWTWLUOUPZUQWLWMQWMUOZURUS
      ZXCHIAEBTPEBWNPJTWNEBTWNWPUTZWNWLWSWMWTWSWTVAZVBXAXBVDZWNWPVEVFZVGVHAFCTP
      FCWNPKTWNFCXGVGVHWSVISMWMWMVJNWMVKNSAXEWLWSMWMXAXBWSWTVLVMUSLVNARQGVOWQAD
      RDVQZEOZXHFOZMNZQGAXHRSVRXIQSXJQSXKQSARQXHEHVPARQXHFIVPXIXJVSVTLWAQRGWBWC
      WDWIWRGWKXDPWOWQVRGWKTXDXFWEGWKWNWPBCMWFWGWJWH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Derivation of the completeness axiom from ZF set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    hilmet.1 $e |- D = ( normh o. -h ) $.
    $( The Hilbert space norm determines a metric space.  (Contributed by NM,
       17-Apr-2007.)  (New usage is discouraged.) $)
    hilmet $p |- D e. ( Met ` ~H ) $=
      ( cva csm cop cno eqid hhims hhmet ) ACDEFEZJGZAJKBHI $.

    $( The Hilbert space norm determines a metric space.  (Contributed by Mario
       Carneiro, 10-Sep-2015.)  (New usage is discouraged.) $)
    hilxmet $p |- D e. ( *Met ` ~H ) $=
      ( chil cme cfv wcel cxmt hilmet metxmet ax-mp ) ACDEFACGEFABHACIJ $.

    $( Value of the distance function of the metric space of Hilbert space.
       (Contributed by NM, 17-Apr-2007.)  (New usage is discouraged.) $)
    hilmetdval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( A D B ) = ( normh ` ( A -h B ) ) ) $=
      ( cva csm cop cno eqid hhims hhmetdval ) ABCEFGHGZLIZCLMDJK $.
  $}

  ${
    $d x y z U $.
    hilims.1 $e |- ~H = ( BaseSet ` U ) $.
    hilims.2 $e |- +h = ( +v ` U ) $.
    hilims.3 $e |- .h = ( .sOLD ` U ) $.
    hilims.5 $e |- .ih = ( .iOLD ` U ) $.
    hilims.8 $e |- D = ( IndMet ` U ) $.
    hilims.9 $e |- U e. NrmCVec $.
    $( Hilbert space distance metric.  (Contributed by NM, 13-Sep-2007.)
       (New usage is discouraged.) $)
    hilims $p |- D = ( normh o. -h ) $=
      ( hilhhi hhims2 ) ABBCDEFHIGJ $.
  $}

  ${
    hhlm.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhlm.2 $e |- D = ( IndMet ` U ) $.
    $( The Cauchy sequences of Hilbert space.  (Contributed by NM,
       19-Nov-2007.)  (New usage is discouraged.) $)
    hhcau $p |- Cauchy = ( ( Cau ` D ) i^i ( ~H ^m NN ) ) $=
      ( hhnv hhba h2hcau ) ABCBCEBCFDG $.

    hhlm.3 $e |- J = ( MetOpen ` D ) $.
    $( The limit sequences of Hilbert space.  (Contributed by NM,
       19-Nov-2007.)  (New usage is discouraged.) $)
    hhlm $p |- ~~>v = ( ( ~~>t ` J ) |` ( ~H ^m NN ) ) $=
      ( hhnv hhba h2hlm ) ABCDBDGBDHEFI $.

    $d x F $.
    hhcmpl.c $e |- ( F e. ( Cau ` D ) -> E. x e. ~H F ( ~~>t ` J ) x ) $.
    $( Lemma used for derivation of the completeness axiom ~ ax-hcompl from ZFC
       Hilbert space theory.  (Contributed by NM, 9-Apr-2008.)
       (New usage is discouraged.) $)
    hhcmpl $p |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $=
      ( cca cfv chil cn wcel wbr wa wrex ccau chli 3imtr4i co cin cv clm anim1i
      cmap elin r19.41v hhcau eleq2i cres hhlm breqi vex brres bitri rexbii ) D
      BJKZLMUFUAZUBZNZDAUCZEUDKZOZDUSNZPZALQZDRNDVBSOZALQDURNZVEPVDALQZVEPVAVGV
      IVJVEIUEDURUSUGVDVEALUHTRUTDBCFGUIUJVHVFALVHDVBVCUSUKZOVFDVBSVKBCEFGHULUM
      DVBVCUSAUNUOUPUQT $.
  $}

  ${
    $d x F $.
    hilcompl.1 $e |- ~H = ( BaseSet ` U ) $.
    hilcompl.2 $e |- +h = ( +v ` U ) $.
    hilcompl.3 $e |- .h = ( .sOLD ` U ) $.
    hilcompl.4 $e |- .ih = ( .iOLD ` U ) $.
    hilcompl.5 $e |- D = ( IndMet ` U ) $.
    hilcompl.6 $e |- J = ( MetOpen ` D ) $.
    hilcompl.7 $e |- U e. CHilOLD $.
    hilcompl.8 $e |- ( F e. ( Cau ` D ) -> E. x e. ~H F ( ~~>t ` J ) x ) $.
    $( Lemma used for derivation of the completeness axiom ~ ax-hcompl from ZFC
       Hilbert space theory.  The first 5 hypotheses would be satisfied by the
       definitions described in ~ ax-hilex ; the 6th would be satisfied by
       ~ eqid ; the 7th by a given fixed Hilbert space; and the last by theorem
       ~ hlcompl .  (Contributed by NM, 13-Sep-2007.)  (Revised by Mario
       Carneiro, 14-May-2014.)  (New usage is discouraged.) $)
    hilcompl $p |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $=
      ( hlnvi hilhhi hhcmpl ) ABCDECFGHICLNOJKMP $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Completeness postulate for a Hilbert space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F x $.
    $( Completeness of a Hilbert space.  (Contributed by NM, 7-Aug-2000.)
       (New usage is discouraged.) $)
    ax-hcompl $a |- ( F e. Cauchy -> E. x e. ~H F ~~>v x ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Relate Hilbert space to ZFC pre-Hilbert and Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f j k t u v w x y z D $.
    hhcms.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhcms.2 $e |- D = ( IndMet ` U ) $.
    $( The Hilbert space induced metric determines a complete metric space.
       (Contributed by NM, 10-Apr-2008.)  (Proof shortened by Mario Carneiro,
       14-May-2014.)  (New usage is discouraged.) $)
    hhcms $p |- D e. ( CMet ` ~H ) $=
      ( vf vx cmopn cfv chil eqid hhmet cv wcel cn wa chli wbr ccau bitri vex
      cca wf wrex clm cdm cmap cin hhcau eleq2i elin ax-hilex nnex elmap anbi2i
      co ax-hcompl sylbir cres hhlm breqi brres breldm sylbi rexlimivw iscmet3i
      adantr syl ) AEAGHZIVHJZABCDKELZAUAHZMZNIVJUBZOZVJFLZPQZFIUCZVJVHUDHZUEMZ
      VNVJRMZVQVTVJVKINUFUOZUGZMZVNRWBVJABCDUHUIWCVLVJWAMZOVNVJVKWAUJWDVMVLINVJ
      UKULUMUNSSFVJUPUQVPVSFIVPVJVOVRQZWDOZVSVPVJVOVRWAURZQWFVJVOPWGABVHCDVIUSU
      TVJVOVRWAFTZVASWEVSWDVJVOVRETWHVBVFVCVDVGVE $.
  $}

  ${
    hhhl.1 $e |- U = <. <. +h , .h >. , normh >. $.
    $( The Hilbert space structure is a complex Hilbert space.  (Contributed by
       NM, 10-Apr-2008.)  (New usage is discouraged.) $)
    hhhl $p |- U e. CHilOLD $=
      ( chlo wcel ccbn ccphlo cnv cims chil hhnv eqid hhcms hhba iscbn mpbir2an
      cfv cms hhph ishlo ) ACDAEDZAFDTAGDAHPZIQPDABJUAABUAKZLUAAIABMUBNOABRASO
      $.
  $}

  ${
    hilcms.1 $e |- D = ( normh o. -h ) $.
    $( The Hilbert space norm determines a complete metric space.  (Contributed
       by NM, 17-Apr-2007.)  (New usage is discouraged.) $)
    hilcms $p |- D e. ( CMet ` ~H ) $=
      ( cva csm cop cno eqid hhims hhcms ) ACDEFEZJGZAJKBHI $.
  $}

  ${
    $d x y z $.
    $( The Hilbert space of the Hilbert Space Explorer is a complex Hilbert
       space.  (Contributed by Steve Rodriguez, 29-Apr-2007.)
       (New usage is discouraged.) $)
    hilhl $p |- <. <. +h , .h >. , normh >. e. CHilOLD $=
      ( cva csm cop cno eqid hhhl ) ABCDCZGEF $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                        Subspaces and projections
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the set of subspaces of a Hilbert space.  See ~ issh for its
     membership relation.  Basically, a subspace is a subset of a Hilbert space
     that acts like a vector space.  From Definition of [Beran] p. 95.
     (Contributed by Mario Carneiro, 23-Dec-2013.)
     (New usage is discouraged.) $)
  df-sh $a |- SH = { h e. ~P ~H | ( 0h e. h /\
              ( +h " ( h X. h ) ) C_ h /\ ( .h " ( CC X. h ) ) C_ h ) } $.

  ${
    $d h x y H $.
    $( Subspace ` H ` of a Hilbert space.  A subspace is a subset of Hilbert
       space which contains the zero vector and is closed under vector addition
       and scalar multiplication.  (Contributed by Mario Carneiro,
       23-Dec-2013.)  (New usage is discouraged.) $)
    issh $p |- ( H e. SH <-> ( ( H C_ ~H /\ 0h e. H ) /\
               ( ( +h " ( H X. H ) ) C_ H /\ ( .h " ( CC X. H ) ) C_ H ) ) ) $=
      ( vh chil cpw wcel c0v cva cxp cima wss csm cc w3a wa csh ax-hilex 3anass
      elpw2 imaeq2d sseq12d anbi12i cv wceq eleq2 xpeq12d xpeq2 3anbi123d df-sh
      id elrab2 anass 3bitr4i ) ACDZEZFAEZGAAHZIZAJZKLAHZIZAJZMZNACJZUOURVANZNZ
      NAOEVCUONVDNUNVCVBVEACPRUOURVAQUAFBUBZEZGVFVFHZIZVFJZKLVFHZIZVFJZMVBBAUMO
      VFAUCZVGUOVJURVMVAVFAFUDVNVIUQVFAVNVHUPGVNVFAVFAVNUIZVOUESVOTVNVLUTVFAVNV
      KUSKVFALUFSVOTUGBUHUJVCUOVDUKUL $.

    $( Subspace ` H ` of a Hilbert space.  A subspace is a subset of Hilbert
       space which contains the zero vector and is closed under vector addition
       and scalar multiplication.  Definition of [Beran] p. 95.  (Contributed
       by NM, 16-Aug-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    issh2 $p |- ( H e. SH <-> ( ( H C_ ~H /\ 0h e. H ) /\
                  ( A. x e. H A. y e. H ( x +h y ) e. H /\
                    A. x e. CC A. y e. H ( x .h y ) e. H ) ) ) $=
      ( wcel chil wss wa cva cxp cima csm cc cv co wral wb wfun cdm ax-hfvadd
      wf csh c0v issh ffun ax-mp xpss12 anidms fdmi syl6sseqr sylancr ax-hfvmul
      funimassov xpss2 anbi12d adantr pm5.32i bitri ) CUADCEFZUBCDZGZHCCIZJCFZK
      LCIZJCFZGZGUTAMZBMZHNCDBCOACOZVFVGKNCDBCOALOZGZGCUCUTVEVJURVEVJPUSURVBVHV
      DVIURHQZVAHRZFVBVHPEEIZEHTVKSVMEHUDUEURVAVMVLURVAVMFCECEUFUGVMEHSUHUIABCC
      CHULUJURKQZVCKRZFVDVIPLEIZEKTVNUKVPEKUDUEURVCVPVOCELUMVPEKUKUHUIABLCCKULU
      JUNUOUPUQ $.
  $}

  $( A subspace is a subset of Hilbert space.  (Contributed by NM,
     9-Oct-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
     (New usage is discouraged.) $)
  shss $p |- ( H e. SH -> H C_ ~H ) $=
    ( csh wcel chil wss c0v wa cva cxp cima csm cc issh simplbi simpld ) ABCZAD
    EZFACZPQRGHAAIJAEKLAIJAEGAMNO $.

  $( A member of a subspace of a Hilbert space is a vector.  (Contributed by
     NM, 14-Dec-2004.)  (New usage is discouraged.) $)
  shel $p |- ( ( H e. SH /\ A e. H ) -> A e. ~H ) $=
    ( csh wcel chil shss sselda ) BCDBEABFG $.

  $( The set of subspaces of a Hilbert space exists (is a set).  (Contributed
     by NM, 23-Oct-1999.)  (New usage is discouraged.) $)
  shex $p |- SH e. _V $=
    ( vx csh chil cpw ax-hilex pwex wcel wss shss vex elpw sylibr ssriv ssexi
    cv ) BCDZCEFABPAOZBGQCHQPGQIQCAJKLMN $.

  ${
    shssi.1 $e |- H e. SH $.
    $( A closed subspace of a Hilbert space is a subset of Hilbert space.
       (Contributed by NM, 6-Oct-1999.)  (New usage is discouraged.) $)
    shssii $p |- H C_ ~H $=
      ( csh wcel chil wss shss ax-mp ) ACDAEFBAGH $.

    $( A member of a subspace of a Hilbert space is a vector.  (Contributed by
       NM, 6-Oct-1999.)  (New usage is discouraged.) $)
    sheli $p |- ( A e. H -> A e. ~H ) $=
      ( chil shssii sseli ) BDABCEF $.

    ${
      sheli.1 $e |- A e. H $.
      $( A member of a subspace of a Hilbert space is a vector.  (Contributed
         by NM, 6-Oct-1999.)  (New usage is discouraged.) $)
      shelii $p |- A e. ~H $=
        ( chil shssii sselii ) BEABCFDG $.
    $}
  $}

  $( The zero vector belongs to any subspace of a Hilbert space.  (Contributed
     by NM, 11-Oct-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
     (New usage is discouraged.) $)
  sh0 $p |- ( H e. SH -> 0h e. H ) $=
    ( csh wcel chil wss c0v wa cva cxp cima csm cc issh simplbi simprd ) ABCZAD
    EZFACZPQRGHAAIJAEKLAIJAEGAMNO $.

  ${
    $d x y A $.  $d x y H $.  $d y B $.
    $( Closure of vector addition in a subspace of a Hilbert space.
       (Contributed by NM, 13-Sep-1999.)  (New usage is discouraged.) $)
    shaddcl $p |- ( ( H e. SH /\ A e. H /\ B e. H ) -> ( A +h B ) e. H ) $=
      ( vx vy csh wcel cva co cv wral wa csm cc chil wss c0v issh2 wceq eleq1d
      simprbi simpld oveq1 oveq2 rspc2v syl5com 3impib ) CFGZACGZBCGZABHIZCGZUH
      DJZEJZHIZCGZECKDCKZUIUJLULUHUQUMUNMICGECKDNKZUHCOPQCGLUQURLDECRUAUBUPULAU
      NHIZCGDEABCCUMASUOUSCUMAUNHUCTUNBSUSUKCUNBAHUDTUEUFUG $.

    $( Closure of vector scalar multiplication in a subspace of a Hilbert
       space.  (Contributed by NM, 13-Sep-1999.)
       (New usage is discouraged.) $)
    shmulcl $p |- ( ( H e. SH /\ A e. CC /\ B e. H ) -> ( A .h B ) e. H ) $=
      ( vx vy csh wcel cc csm co cv wral wa cva chil wss c0v issh2 wceq eleq1d
      simprbi simprd oveq1 oveq2 rspc2v syl5com 3impib ) CFGZAHGZBCGZABIJZCGZUH
      DKZEKZIJZCGZECLDHLZUIUJMULUHUMUNNJCGECLDCLZUQUHCOPQCGMURUQMDECRUAUBUPULAU
      NIJZCGDEABHCUMASUOUSCUMAUNIUCTUNBSUSUKCUNBAIUDTUEUFUG $.

    $( Closure of vector scalar multiplication in a subspace of a Hilbert
       space.  (Contributed by NM, 13-Sep-1999.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    shmulclOLD $p |- ( H e. SH ->
                   ( ( A e. CC /\ B e. H ) -> ( A .h B ) e. H ) ) $=
      ( vx vy csh wcel cv csm co wral cc wa cva chil wss c0v issh2 wceq eleq1d
      simprbi simprd oveq1 oveq2 rspc2v syl5com ) CFGZDHZEHZIJZCGZECKDLKZALGBCG
      MABIJZCGZUGUHUINJCGECKDCKZULUGCOPQCGMUOULMDECRUAUBUKUNAUIIJZCGDEABLCUHASU
      JUPCUHAUIIUCTUIBSUPUMCUIBAIUDTUEUF $.

    $(
    @( Reversal of subtraction remains a member of a subspace of a Hilbert
       space. @)
    shsubrclt @p  |- ( H e. SH -> ( ( A e. ~H /\ B e. ~H ) ->
                    ( ( A -h B ) e. H <-> ( B -h A ) e. H ) ) ) @=
?@.
    $)

    $( Subspace ` H ` of a Hilbert space.  (Contributed by NM, 16-Aug-1999.)
       (New usage is discouraged.) $)
    issh3 $p |- ( H C_ ~H -> ( H e. SH <-> ( 0h e. H /\
                  ( A. x e. H A. y e. H ( x +h y ) e. H /\
                    A. x e. CC A. y e. H ( x .h y ) e. H ) ) ) ) $=
      ( csh wcel chil wss c0v wa cv cva co wral csm cc issh2 anass baib syl5bb
      ) CDECFGZHCEZIAJZBJZKLCEBCMACMUBUCNLCEBCMAOMIZIZTUAUDIZABCPUETUFTUAUDQRS
      $.
  $}

  $( Closure of vector subtraction in a subspace of a Hilbert space.
     (Contributed by NM, 18-Oct-1999.)  (New usage is discouraged.) $)
  shsubcl $p |- ( ( H e. SH /\ A e. H /\ B e. H ) -> ( A -h B ) e. H ) $=
    ( csh wcel w3a cmv co c1 cneg csm cva chil wceq shss sseld anim12d hvsubval
    wa 3impib syl cc neg1cn shmulcl mp3an2 3adant2 shaddcl syld3an3 eqeltrd ) C
    DEZACEZBCEZFZABGHZAIJZBKHZLHZCUMAMEZBMEZSZUNUQNUJUKULUTUJUKURULUSUJCMACOZPU
    JCMBVAPQTABRUAUJUKULUPCEZUQCEUJULVBUKUJUOUBEULVBUCUOBCUDUEUFAUPCUGUHUI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Closed subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the set of closed subspaces of a Hilbert space.  A closed subspace
     is one in which the limit of every convergent sequence in the subspace
     belongs to the subspace.  For its membership relation, see ~ isch .  From
     Definition of [Beran] p. 107.  Alternate definitions are given by ~ isch2
     and ~ isch3 .  (Contributed by NM, 17-Aug-1999.)
     (New usage is discouraged.) $)
  df-ch $a |- CH = { h e. SH | ( ~~>v " ( h ^m NN ) ) C_ h } $.

  ${
    $d h H $.
    $( Closed subspace ` H ` of a Hilbert space.  (Contributed by NM,
       17-Aug-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    isch $p |- ( H e. CH <-> ( H e. SH /\ ( ~~>v " ( H ^m NN ) ) C_ H ) ) $=
      ( vh chli cv cn cmap co cima wss csh cch wceq oveq1 imaeq2d sseq12d df-ch
      id elrab2 ) CBDZEFGZHZSICAEFGZHZAIBAJKSALZUAUCSAUDTUBCSAEFMNUDQOBPR $.
  $}

  ${
    $d x f H $.
    $( Closed subspace ` H ` of a Hilbert space.  Definition of [Beran]
       p. 107.  (Contributed by NM, 17-Aug-1999.)  (Revised by Mario Carneiro,
       23-Dec-2013.)  (New usage is discouraged.) $)
    isch2 $p |- ( H e. CH <-> ( H e. SH /\ A. f A. x ( ( f : NN --> H /\
        f ~~>v x ) -> x e. H ) ) ) $=
      ( cch wcel csh chli cn cmap co cima wss wa cv wf wi wal bitr4i bitri cvv
      wbr isch alcom wex 19.23v vex elima2 imbi1i albii dfss2 nnex elmapg mpan2
      wb anbi1d imbi1d 2albidv syl5bbr pm5.32i ) CDECFEZGCHIJZKZCLZMUTHCBNZOZVD
      ANZGUAZMZVFCEZPZAQBQZMCUBUTVCVKVCVDVAEZVGMZVIPZAQBQZUTVKVOVNBQZAQZVCVNBAU
      CVQVFVBEZVIPZAQVCVPVSAVPVMBUDZVIPVSVMVIBUEVRVTVIBVFGVAAUFUGUHRUIAVBCUJRSU
      TVNVJBAUTVMVHVIUTVLVEVGUTHTEVLVEUNUKCHVDFTULUMUOUPUQURUSS $.
  $}

  $( A closed subspace is a subspace.  (Contributed by NM, 19-Oct-1999.)
     (Revised by Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
  chsh $p |- ( H e. CH -> H e. SH ) $=
    ( cch wcel csh chli cn cmap co cima wss isch simplbi ) ABCADCEAFGHIAJAKL $.

  $( Closed subspaces are subspaces in a Hilbert space.  (Contributed by NM,
     29-May-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
     (New usage is discouraged.) $)
  chsssh $p |- CH C_ SH $=
    ( vx cch csh cv chsh ssriv ) ABCADEF $.

  $( The set of closed subspaces of a Hilbert space exists (is a set).
     (Contributed by NM, 23-Oct-1999.)  (New usage is discouraged.) $)
  chex $p |- CH e. _V $=
    ( cch csh shex chsssh ssexi ) ABCDE $.

  ${
    chshi.1 $e |- H e. CH $.
    $( A closed subspace is a subspace.  (Contributed by NM, 19-Oct-1999.)
       (New usage is discouraged.) $)
    chshii $p |- H e. SH $=
      ( cch wcel csh chsh ax-mp ) ACDAEDBAFG $.
  $}

  ${
    $d x y H $.
    $( The zero vector belongs to any closed subspace of a Hilbert space.
       (Contributed by NM, 24-Aug-1999.)  (New usage is discouraged.) $)
    ch0 $p |- ( H e. CH -> 0h e. H ) $=
      ( cch wcel csh c0v chsh sh0 syl ) ABCADCEACAFAGH $.

    $( A closed subspace of a Hilbert space is a subset of Hilbert space.
       (Contributed by NM, 24-Aug-1999.)  (New usage is discouraged.) $)
    chss $p |- ( H e. CH -> H C_ ~H ) $=
      ( cch wcel csh chil wss chsh shss syl ) ABCADCAEFAGAHI $.

  $}

  $( A member of a closed subspace of a Hilbert space is a vector.
     (Contributed by NM, 15-Dec-2004.)  (New usage is discouraged.) $)
  chel $p |- ( ( H e. CH /\ A e. H ) -> A e. ~H ) $=
    ( cch wcel chil chss sselda ) BCDBEABFG $.

  ${
    chssi.1 $e |- H e. CH $.
    $( A closed subspace of a Hilbert space is a subset of Hilbert space.
       (Contributed by NM, 6-Oct-1999.)  (New usage is discouraged.) $)
    chssii $p |- H C_ ~H $=
      ( chshii shssii ) AABCD $.

    $( A member of a closed subspace of a Hilbert space is a vector.
       (Contributed by NM, 6-Oct-1999.)  (New usage is discouraged.) $)
    cheli $p |- ( A e. H -> A e. ~H ) $=
      ( chil chssii sseli ) BDABCEF $.

    ${
      cheli.1 $e |- A e. H $.
      $( A member of a closed subspace of a Hilbert space is a vector.
         (Contributed by NM, 6-Oct-1999.)  (New usage is discouraged.) $)
      chelii $p |- A e. ~H $=
        ( chil chssii sselii ) BEABCFDG $.
    $}
  $}

  ${
    $d x f F $.  $d x f H $.  $d x A $.
    chlim.1 $e |- A e. _V $.
    $( The limit property of a closed subspace of a Hilbert space.
       (Contributed by NM, 14-Sep-1999.)  (New usage is discouraged.) $)
    chlimi $p |- ( ( H e. CH /\ F : NN --> H /\ F ~~>v A ) -> A e. H ) $=
      ( vf vx cch wcel cn wf chli wbr cv wa wi wal csh cvv wceq syl simprbi fex
      isch2 nnex mpan2 adantr feq1 breq1 imbi1d albidv spcgv breq2 anbi2d eleq1
      anbi12d imbi12d spcv syl6 pm2.43b 3impib ) CGHZICBJZBAKLZACHZVAICEMZJZVEF
      MZKLZNZVGCHZOZFPZEPZVBVCNZVDOZVACQHVMFECUCUAVMVNVDVNBRHZVMVOOVBVPVCVBIRHV
      PUDICRBUBUEUFVPVMVBBVGKLZNZVJOZFPZVOVLVTEBRVEBSZVKVSFWAVIVRVJWAVFVBVHVQIC
      VEBUGVEBVGKUHUOUIUJUKVSVOFADVGASZVRVNVJVDWBVQVCVBVGABKULUMVGACUNUPUQURTUS
      TUT $.
  $}

  ${
    $d x y z $.
    $( The zero sequence in Hilbert space converges to the zero vector.
       (Contributed by NM, 17-Aug-1999.)  (Proof shortened by Mario Carneiro,
       14-May-2014.)  (New usage is discouraged.) $)
    hlim0 $p |- ( NN X. { 0h } ) ~~>v 0h $=
      ( cn c0v csn cxp chli wbr cva csm cop cno cims cfv cmopn clm chil cmap c1
      wcel eqid ax-hv0cl co ctopon cz cxmt hhxmet mopntopon ax-mp 1z nnuz mp3an
      lmconst wf fconst6 ax-hilex nnex elmap mpbir cres breqi elexi brres bitri
      wa hhlm mpbir2an ) ABCDZBEFZVFBGHIJIZKLZMLZNLZFZVFOAPUAZRZVJOUBLRZBORQUCR
      VLVIOUDLRVOVIVHVHSZVISZUEVIVJOVJSZUFUGTUHBVJQOAUIUKUJVNAOVFULABOTUMOAVFUN
      UOUPUQVGVFBVKVMURZFVLVNVCVFBEVSVIVHVJVPVQVRVDUSVFBVKVMBOTUTVAVBVE $.
  $}

  ${
    $d x F $.
    $( If a sequence in Hilbert space subset converges to a limit, it is a
       Cauchy sequence.  (Contributed by NM, 17-Aug-1999.)  (Proof shortened by
       Mario Carneiro, 14-May-2014.)  (New usage is discouraged.) $)
    hlimcaui $p |- ( F ~~>v A -> F e. Cauchy ) $=
      ( chli wbr cdm ccau cva csm cop cno cims cfv cca chil cin eqid ax-mp wrel
      wss eqsstri cn cmap cmopn clm cres hhlm resss dmss cxmt wcel hhxmet lmcau
      co sstri dmeqi dmres eqtri inss1 ssini hhcau sseqtr4i relres releqi mpbir
      releldmi sseldi ) BACDCEZFBVGGHIJIZKLZMLZNUAUBUMZOFVGVJVKVGVIUCLZUDLZEZVJ
      CVMSVGVNSCVMVKUEZVMVIVHVLVHPZVIPZVLPZUFZVMVKUGTCVMUHQVINUILUJVNVJSVIVHVPV
      QUKVIVLNVRULQUNVGVKVNOZVKVGVOEVTCVOVSUOVMVKUPUQVKVNURTUSVIVHVPVQUTVABACCR
      VORVMVKVBCVOVSVCVDVEVF $.
  $}

  $( Function-like behavior of the convergence relation.  (Contributed by Mario
     Carneiro, 14-May-2014.)  (New usage is discouraged.) $)
  hlimf $p |- ~~>v : dom ~~>v --> ~H $=
    ( vx chli cdm chil wf wfn cfv wcel wral wfun cva csm cop cno cims cmopn clm
    cv eqid ax-mp cn cmap cres cxmt cha hhxmet methaus lmfun mp2b funres funeqi
    co hhlm mpbir funfn mpbi wbr wb funfvbrb fvex hlimveci sylbi ffnfv mpbir2an
    rgen ) BCZDBEBVFFZARZBGZDHZAVFIBJZVGVKKLMNMZOGZPGZQGZDUAUBULZUCZJZVOJZVRVMD
    UDGHVNUEHVSVMVLVLSZVMSZUFVMVNDVNSZUGVNUHUIVPVOUJTBVQVMVLVNVTWAWBUMUKUNZBUOU
    PVJAVFVHVFHZVHVIBUQZVJVKWDWEURWCVHBUSTVIVHVHBUTVAVBVEAVFDBVCVD $.

  ${
    $d x y z w v A $.  $d x y z w v B $.  $d x y z w v F $.
    $( A Hilbert space sequence converges to at most one limit.  (Contributed
       by NM, 19-Aug-1999.)  (Revised by Mario Carneiro, 2-May-2015.)
       (New usage is discouraged.) $)
    hlimuni $p |- ( ( F ~~>v A /\ F ~~>v B ) -> A = B ) $=
      ( chli wbr cfv cdm chil wf wfun wceq wi hlimf ffun funbrfv mp2b sylan9req
      ) CADEZCBDEZACDFZBDGZHDIZDJZRTAKLMUAHDNZCADOPUBUCSTBKLMUDCBDOPQ $.
  $}

  ${
    $d x y F $.  $d x y H $.
    $( The limit of a Hilbert space sequence is unique.  (Contributed by NM,
       19-Aug-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hlimreui $p |- ( E. x e. H F ~~>v x <-> E! x e. H F ~~>v x ) $=
      ( vy cv chli wbr wrex wa wi wral wreu hlimuni rgen2w biantru breq2 bitr4i
      weq reu4 ) BAEZFGZACHZUBUABDEZFGZIADRJZDCKACKZIUAACLUFUBUEADCCTUCBMNOUAUD
      ADCTUCBFPSQ $.

    $( The limit of a Hilbert space sequence is unique.  (Contributed by NM,
       19-Aug-1999.)  (Proof shortened by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    hlimeui $p |- ( E. x F ~~>v x <-> E! x F ~~>v x ) $=
      ( cv chli wbr cvv wrex wreu wex weu hlimreui rexv reuv 3bitr3i ) BACDEZAF
      GOAFHOAIOAJABFKOALOAMN $.
  $}

  ${
    $d x f H $.
    $( A Hilbert subspace is closed iff it is complete.  A complete subspace is
       one in which every Cauchy sequence of vectors in the subspace converges
       to a member of the subspace (Definition of complete subspace in [Beran]
       p. 96).  Remark 3.12 of [Beran] p. 107.  (Contributed by NM,
       24-Dec-2001.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    isch3 $p |- ( H e. CH <-> ( H e. SH /\ A. f e. Cauchy
                  ( f : NN --> H -> E. x e. H f ~~>v x ) ) ) $=
      ( cch wcel csh cv wa wi wal wrex ccau wex chil rexex syl nfv nfim bitri
      ex cn wf chli wbr isch2 ax-hcompl 19.29 sylan2 id imp an12s simprr eximdv
      jca com12 df-rex syl6ibr nfre1 bi2.04 hlimcaui imim1i weu hlimeui exancom
      sylib biimpi eupick syl2anc imim2i sylbi imp3a alrimi impbii albii df-ral
      wral syli bitr4i anbi2i ) CDECFEZUACBGZUBZWAAGZUCUDZHZWCCEZIZAJZBJZHVTWBW
      DACKZIZBLVPZHABCUEWIWLVTWIWALEZWKIZBJWLWHWNBWHWNWHWMWKWHWMHWGWDHZAMZWKWMW
      HWDAMZWPWMWDANKWQAWAUFWDANOPWGWDAUGUHWPWBWFWDHZAMZWJWBWPWSWBWOWRAWBWOWRWB
      WOHWFWDWGWBWDWFWGWEWFWGUIUJUKWBWGWDULUNTUMUOWDACUPZUQPTWNWGAWMWKAWMAQWBWJ
      AWBAQWDACURRRWNWBWDWFWNWBWMWJIZIWBWDWFIZIWMWBWJUSXAXBWBWDXAWJWFWDWMWJWCWA
      UTVAWJWDAVBZWDWFHAMZXBWJWQXCWDACOAWAVCVEWJXDWJWSXDWTWFWDAVDSVFWDWFAVGVHVQ
      VIVJVKVLVMVNWKBLVOVRVSS $.
  $}

  ${
    $d x f H $.  $d x f F $.
    $( Completeness of a closed subspace of Hilbert space.  (Contributed by NM,
       4-Oct-1999.)  (New usage is discouraged.) $)
    chcompl $p |- ( ( H e. CH /\ F e. Cauchy /\ F : NN --> H ) ->
                      E. x e. H F ~~>v x ) $=
      ( vf cch wcel ccau cn wf cv chli wbr wrex wi wral isch3 simprbi wceq feq1
      csh breq1 rexbidv imbi12d rspccv syl 3imp ) CEFZBGFZHCBIZBAJZKLZACMZUGHCD
      JZIZUMUJKLZACMZNZDGOZUHUIULNZNUGCTFURADCPQUQUSDBGUMBRZUNUIUPULHCUMBSUTUOU
      KACUMBUJKUAUBUCUDUEUF $.
  $}

  ${
    $d x y f $.
    $( The unit Hilbert lattice element (which is all of Hilbert space) belongs
       to the Hilbert lattice.  Part of Proposition 1 of [Kalmbach] p. 65.
       (Contributed by NM, 6-Sep-1999.)  (New usage is discouraged.) $)
    helch $p |- ~H e. CH $=
      ( vf vx vy chil cch wcel csh cn cv wf chli wbr wa wi wal co wral mpbir2an
      cc pm3.2i wss c0v cva csm ax-hv0cl hvaddcl rgen2a hvmulcl rgen2 issh2 vex
      ssid hlimveci adantl gen2 isch2 ) DEFDGFZHDAIZJZURBIZKLZMUTDFZNZBOAOUQDDU
      AZUBDFZMUTCIZUCPDFZCDQBDQZUTVFUDPDFZCDQBSQZMVDVEDULUETVHVJVGBCDUTVFUFUGVI
      BCSDUTVFUHUITBCDUJRVCABVAVBUSUTURBUKUMUNUOBADUPR $.
  $}

  $( Hilbert space is a subspace of Hilbert space.  (Contributed by NM,
     2-Jun-2004.)  (New usage is discouraged.) $)
  helsh $p |- ~H e. SH $=
    ( chil helch chshii ) ABC $.

  $( Subspaces are subsets of Hilbert space.  (Contributed by NM,
     24-Nov-2004.)  (New usage is discouraged.) $)
  shsspwh $p |- SH C_ ~P ~H $=
    ( vx csh cuni cpw chil pwuni wcel cv wss wral wceq helsh shss ssunieq mp2an
    rgen pweqi sseqtr4i ) BBCZDEDBFESEBGAHZEIZABJESKLUAABTMPAEBNOQR $.

  $( Closed subspaces are subsets of Hilbert space.  (Contributed by NM,
     24-Nov-2004.)  (New usage is discouraged.) $)
  chsspwh $p |- CH C_ ~P ~H $=
    ( cch csh chil cpw chsssh shsspwh sstri ) ABCDEFG $.

  ${
    $d x y f $.
    $( The zero subspace belongs to the set of closed subspaces of Hilbert
       space.  (Contributed by NM, 14-Oct-1999.)
       (New usage is discouraged.) $)
    hsn0elch $p |- { 0h } e. CH $=
      ( vf vx vy c0v wcel cn cv chli wbr wa wal chil cva co csm ax-hv0cl pm3.2i
      wral cc wceq csn cch csh wf wi wss snssi ax-mp snid elsn oveq12 hvaddid2i
      elexi syl6eq ovex elsnc sylibr syl2anb rgen2a oveq2 sylan9eqr rgen2 issh2
      hvmul0 sylan2b mpbir2an wb fconst2 hlim0 breq1 mpbiri sylbi hlimuni sylan
      cxp eleq1d mpbii gen2 isch2 ) DUAZUBEVTUCEZFVTAGZUDZWBBGZHIZJZWDVTEZUEZBK
      AKWAVTLUFZDVTEZJWDCGZMNZVTEZCVTRBVTRZWDWKONZVTEZCVTRBSRZJWIWJDLEWIPDLUGUH
      DDLPUMZUIZQWNWQWMBCVTWGWDDTZWKDTZWMWKVTEZBDUJCDUJZWTXAJZWLDTWMXDWLDDMNDWD
      DWKDMUKDPULUNWLDWDWKMUOUPUQURUSWPBCSVTXBWDSEZXAWPXCXEXAJWODTWPXAXEWOWDDON
      DWKDWDOUTWDVDVAWODWDWKOUOUPUQVEVBQBCVTVCVFWHABWFWJWGWSWCWBDHIZWEWJWGVGWCW
      BFVTVOZTZXFFDWBWRVHXHXFXGDHIVIWBXGDHVJVKVLXFWEJDWDVTDWDWBVMVPVNVQVRBAVTVS
      VF $.
  $}

  $( From any nonzero Hilbert space vector, construct a vector whose norm is
     1.  (Contributed by NM, 7-Feb-2006.)  (New usage is discouraged.) $)
  norm1 $p |- ( ( A e. ~H /\ A =/= 0h ) ->
               ( normh ` ( ( 1 / ( normh ` A ) ) .h A ) ) = 1 ) $=
    ( chil wcel c0v wne wa c1 cno cfv cdiv co cmul cc cr adantr cc0 syl2anc wbr
    recnd cle csm cabs wceq normne0 biimpar rereccld simpl norm-iii clt normgt0
    normcl biimpa 1re 0le1 divge0 mpanl12 absidd oveq1d recid2d 3eqtrd ) ABCZAD
    EZFZGAHIZJKZAUAKHIZVEUBIZVDLKZVEVDLKGVCVEMCVAVFVHUCVCVEVCVDVAVDNCZVBAUKZOZV
    AVDPEVBAUDUEZUFZSVAVBUGVEAUHQVCVGVEVDLVCVEVMVCVIPVDUIRZPVETRZVKVAVBVNAUJULG
    NCPGTRVIVNFVOUMUNGVDUOUPQUQURVCVDVAVDMCVBVAVDVJSOVLUSUT $.

  ${
    $d x z H $.  $d y z H $.
    norm1ex.1 $e |- H e. SH $.
    $( A normalized vector exists in a subspace iff the subspace has a nonzero
       vector.  (Contributed by NM, 9-Apr-2006.)
       (New usage is discouraged.) $)
    norm1exi $p |- ( E. x e. H x =/= 0h <-> E. y e. H ( normh ` y ) = 1 ) $=
      ( vz cv c0v wne wrex cno cfv c1 wceq neeq1 cbvrexv wcel co chil syl cc0
      wa cdiv cc cr sheli normcl adantr wb normne0 biimpar rereccld recnd simpl
      csm csh shmulcl mp3an1 syl2anc norm1 sylan fveq2 eqeq1d rexlimiva ax-1ne0
      rspcev wn df-ne mpbi eqeq1 mtbiri norm-i necon3bbid syl5ib reximia impbii
      sylib bitri ) AFZGHZACIEFZGHZECIZBFZJKZLMZBCIZVSWAAECVRVTGNOWBWFWAWFECVTC
      PZWAUAZLVTJKZUBQZVTUNQZCPZWKJKZLMZWFWHWJUCPZWGWLWHWJWHWIWGWIUDPZWAWGVTRPZ
      WPVTCDUEZVTUFSUGWGWITHZWAWGWQWSWAUHWRVTUISUJUKULWGWAUMCUOPWOWGWLDWJVTCUPU
      QURWGWQWAWNWRVTUSUTWEWNBWKCWCWKMWDWMLWCWKJVAVBVEURVCWFWCGHZBCIWBWEWTBCWEW
      DTMZVFWCCPZWTWEXALTMZLTHXCVFVDLTVGVHWDLTVIVJXBXAWCGXBWCRPXAWCGMUHWCCDUEWC
      VKSVLVMVNWTWABECWCVTGNOVPVOVQ $.
  $}

  ${
    $d x z $.  $d y z $.
    $( A normalized vector can exist only iff the Hilbert space has a nonzero
       vector.  (Contributed by NM, 21-Jan-2006.)
       (New usage is discouraged.) $)
    norm1hex $p |- ( E. x e. ~H x =/= 0h <-> E. y e. ~H ( normh ` y ) = 1 ) $=
      ( chil helsh norm1exi ) ABCDE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Orthocomplements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Define orthogonal complement of a subset (usually a subspace) of Hilbert
       space.  The orthogonal complement is the set of all vectors orthogonal
       to all vectors in the subset.  See ~ ocval and ~ chocvali for its
       value.  Textbooks usually denote this unary operation with the symbol
       ` _|_ ` as a small superscript, although Mittelstaedt uses the symbol as
       a prefix operation.  Here we define a function (prefix operation)
       ` _|_ ` rather than introducing a new syntactical form.  This lets us
       take advantage of the theorems about functions that we already have
       proved under set theory.  Definition of [Mittelstaedt] p. 9.
       (Contributed by NM, 7-Aug-2000.)  (New usage is discouraged.) $)
    df-oc $a |- _|_ = ( x e. ~P ~H |->
                        { y e. ~H | A. z e. x ( y .ih z ) = 0 } ) $.
  $}

  $( Define the zero for closed subspaces of Hilbert space.  See ~ h0elch for
     closure law.  (Contributed by NM, 30-May-1999.)
     (New usage is discouraged.) $)
  df-ch0 $a |- 0H = { 0h } $.

  $( Membership in zero for closed subspaces of Hilbert space.  (Contributed by
     NM, 6-Apr-2001.)  (New usage is discouraged.) $)
  elch0 $p |- ( A e. 0H <-> A = 0h ) $=
    ( c0h wcel c0v csn wceq df-ch0 eleq2i chil ax-hv0cl elexi elsnc2 bitri ) AB
    CADEZCADFBNAGHADDIJKLM $.

  $( The zero subspace is a closed subspace.  Part of Proposition 1 of
     [Kalmbach] p. 65.  (Contributed by NM, 30-May-1999.)
     (New usage is discouraged.) $)
  h0elch $p |- 0H e. CH $=
    ( c0h c0v csn cch df-ch0 hsn0elch eqeltri ) ABCDEFG $.

  $( The zero subspace is a subspace of Hilbert space.  (Contributed by NM,
     2-Jun-2004.)  (New usage is discouraged.) $)
  h0elsh $p |- 0H e. SH $=
    ( c0h h0elch chshii ) ABC $.

  ${
    hhss.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    $( The vector addition operation on a subspace.  (Contributed by NM,
       8-Apr-2008.)  (New usage is discouraged.) $)
    hhssva $p |- ( +h |` ( H X. H ) ) = ( +v ` W ) $=
      ( cpv cfv c1st cva cxp cres csm cop cno fveq2i chil cvv resex op1st cablo
      cr wcel cc eqid vafval opex normf ax-hilex fex mp2an eqtri hilablo resexg
      wf ax-mp hvmulex 3eqtrri ) BDEZBFEZFEGAAHZIZJUAAHZIZKZFEUSBUPUPUBUCUQVBFU
      QVBLAIZKZFEVBBVDFCMVBVCUSVAUDLANSLULNOTLOTUEUFNSOLUGUHPQUIMUSVAGRTUSOTUJG
      URRUKUMJUTUNPQUO $.

    $( The scalar multiplication operation on a subspace.  (Contributed by NM,
       8-Apr-2008.)  (New usage is discouraged.) $)
    hhsssm $p |- ( .h |` ( CC X. H ) ) = ( .sOLD ` W ) $=
      ( cns cfv c1st c2nd cva cxp cres csm cop cno fveq2i chil wcel resex cablo
      cr cvv cc eqid smfval opex wf normf ax-hilex fex mp2an op1st eqtri resexg
      hilablo ax-mp hvmulex op2nd 3eqtrri ) BDEZBFEZGEHAAIZJZKUAAIZJZLZGEVCURBU
      RUBUCUSVDGUSVDMAJZLZFEVDBVFFCNVDVEVAVCUDMAOSMUEOTPMTPUFUGOSTMUHUIQUJUKNVA
      VCHRPVATPUMHUTRULUNKVBUOQUPUQ $.

    $( The norm operation on a subspace.  (Contributed by NM, 8-Apr-2008.)
       (New usage is discouraged.) $)
    hhssnm $p |- ( normh |` H ) = ( normCV ` W ) $=
      ( cnmcv cfv c2nd cva cxp cres csm cc cop cno eqid nmcvfval fveq2i chil cr
      cvv wcel opex wf normf ax-hilex fex mp2an resex op2nd 3eqtrri ) BDEZBFEGA
      AHIZJKAHIZLZMAIZLZFEUNBUJUJNOBUOFCPUMUNUKULUAMAQRMUBQSTMSTUCUDQRSMUEUFUGU
      HUI $.
  $}

  ${
    $d x y H $.
    hhssabl.1 $e |- H e. SH $.
    $( Abelian group property of subspace addition.  (Contributed by NM,
       9-Apr-2008.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    hhssabloi $p |- ( +h |` ( H X. H ) ) e. AbelOp $=
      ( vx vy cva cxp cres cgr wcel wss cfv c0v csm chil ax-mp cop eqid wceq co
      cc csubgo w3a c2nd c1 cneg csn cvv ccnv cablo hilablo ablogrpo cno df-hba
      ccom hhva bafval cgi hilid eqcomi cnv cgn hhnv hhsm nvinvfval csh shaddcl
      shssii cv mp3an1 sh0 wfn wf ax-hfvmul ffn curry1val mp2an shmulcl mp3an12
      neg1cn syl5eqel issubgoi issubgo mpbi simp2i cdm xpss12 ax-hfvadd ssdmres
      fdmi sseqtr4i wa sheli ax-hvcom syl2an ovres ancoms 3eqtr4d isabloi ) CDE
      AAFZGZAEHIZWTHIZWTEJZWTEUAKIXAXBXCUBCDLEWTMUCUDUEZUFUGFGUHUNZNAEUIIXAUJEU
      KOEMPULPZENUMXFXFQZUOZUPEUQKLURUSXFUTIXEEVAKRXFXGVBMXFEXEXHXFXGVCXEQZVDOA
      BVGZWTQAVEIZCVHZAIZDVHZAIZXLXNESZAIBXLXNAVFVIXKLAIBAVJOXMXLXEKZXDXLMSZAMT
      NFZVKZXDTIZXQXRRXSNMVLXTVMXSNMVNOVSTNXDXLMXEXIVOVPXKYAXMXRAIBVSXDXLAVQVRV
      TWAEWTWBWCWDWSEWEZJWTWEWSRWSNNFZYBANJZYDWSYCJXJXJANANWFVPYCNEWGWIWJWSEWHW
      CXMXOWKXPXNXLESZXLXNWTSXNXLWTSZXMXLNIXNNIXPYERXOXLABWLXNABWLXLXNWMWNXLXNA
      AEWOXOXMYFYERXNXLAAEWOWPWQWR $.
  $}

  $( Abelian group property of subspace addition.  (Contributed by NM,
     9-Apr-2008.)  (New usage is discouraged.) $)
  hhssablo $p |- ( H e. SH -> ( +h |` ( H X. H ) ) e. AbelOp ) $=
    ( csh wcel cva cxp cres cablo chil cif wceq xpeq1 xpeq2 eqtrd reseq2d helsh
    eleq1d elimel hhssabloi dedth ) ABCZDAAEZFZGCDTAHIZUCEZFZGCAHAUCJZUBUEGUFUA
    UDDUFUAUCAEUDAUCAKAUCUCLMNPUCAHBOQRS $.

  ${
    $d x y z H $.
    hhssnvt.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    ${
      hhssnv.2 $e |- H e. SH $.
      $( Normed complex vector space property of a subspace.  (Contributed by
         NM, 26-Mar-2008.)  (New usage is discouraged.) $)
      hhssnv $p |- W e. NrmCVec $=
        ( vx vy csm cc cva cno c0v wcel wss wceq chil mp2an cfv co ovres eqtrd
        cxp cres cablo cgr hhssabloi ablogrpo ax-mp cdm shssii xpss12 ax-hfvadd
        vz fdmi sseqtr4i ssdmres grporn cgi csh sh0 ax-hv0cl hvaddid2i eqtri wb
        mpbi eqid grpoid mpbir cop wf wfn crn ax-hfvmul ffn ssid fnssres ovelrn
        cv wrex wa shmulcl mp3an1 eqeltrd eleq1 syl5ibrcom rexlimivv sylbi df-f
        ssriv mpbir2an c1 ax-1cn sheli ax-hvmulid syl w3a id ax-hvdistr1 syl3an
        mpan 3adant1 oveq2d shaddcl sylan2 3impb 3adant3 3adant2 oveq12d ovresd
        3eqtr4d caddc ax-hvdistr2 syl3an3 addcl sylan 3impa cmul ax-hvmulass cr
        mulcl isvci normf fssres fvres eqeq1d norm-i bitrd biimpa cabs norm-iii
        cc0 fveq2d adantl cle wbr norm-ii syl2an oveqan12d 3brtr4d isnvi ) EFGH
        AUAZUBZBIAAUAZUBZJAUBZAKUUCAUUCUCLUUCUDLZADUEZUUCUFUGZUUBIUHZMUUCUHUUBN
        UUBOOUAZUUHAOMZUUJUUBUUIMADUIZUUKAOAOUJPUUIOIUKUMUNUUBIUOVDZUPZKUUCUQQZ
        NZKKUUCRZKNZUUPKKIRZKKALZUUSUUPUURNAURLZUUSDAUSUGZUVAKKAAISPKUTVAVBUUEU
        USUUOUUQVCUUGUVAKUUNUUCAUUMUUNVEVFPVGEFULUUAUUCUUCUUAVHZAUUFUULYTAUUAVI
        UUAYTVJZUUAVKZAMGHOUAZVJZYTUVEMZUVCUVEOGVIUVFVLUVEOGVMUGHHMUUJUVGHVNUUK
        HHAOUJPUVEYTGVOPZULUVDAULVQZUVDLZUVIEVQZFVQZUUARZNZFAVREHVRZUVIALZUVCUV
        JUVOVCUVHEFHAUVIUUAVPUGUVNUVPEFHAUVKHLZUVLALZVSZUVPUVNUVMALUVSUVMUVKUVL
        GRZAUVKUVLHAGSUUTUVQUVRUVTALDUVKUVLAVTWAWBUVIUVMAWCWDWEWFWHYTAUUAWGWIUV
        KALZWJUVKUUARZWJUVKGRZUVKWJHLUWAUWBUWCNWKWJUVKHAGSWSUWAUVKOLZUWCUVKNUVK
        ADWLZUVKWMWNTUVLHLZUWAUVPWOZUVLUVKUVIIRZGRZUVLUVKGRZUVLUVIGRZIRZUVLUVKU
        VIUUCRZUUARZUVLUVKUUARZUVLUVIUUARZUUCRZUWFUWFUWAUWDUVPUVIOLUWIUWLNUWFWP
        UWEUVIADWLUVLUVKUVIWQWRUWGUWNUVLUWHUUARZUWIUWGUWMUWHUVLUUAUWAUVPUWMUWHN
        UWFUVKUVIAAISWTXAUWFUWAUVPUWRUWINZUWAUVPVSUWFUWHALZUWSUUTUWAUVPUWTDUVKU
        VIAXBWAUVLUWHHAGSXCXDTUWGUWQUWJUWKUUCRUWLUWGUWOUWJUWPUWKUUCUWFUWAUWOUWJ
        NZUVPUVLUVKHAGSZXEUWFUVPUWPUWKNUWAUVLUVIHAGSXFXGUWGUWJUWKIAUWFUWAUWJALZ
        UVPUUTUWFUWAUXCDUVLUVKAVTWAZXEUWFUVPUWKALZUWAUUTUWFUVPUXEDUVLUVIAVTWAXF
        XHTXIUWFUVIHLZUWAWOZUVLUVIXJRZUVKGRZUWJUVIUVKGRZIRZUXHUVKUUARZUWOUVIUVK
        UUARZUUCRZUWAUWFUXFUWDUXIUXKNUWEUVLUVIUVKXKXLUWFUXFUWAUXLUXINZUWFUXFVSZ
        UXHHLUWAUXOUVLUVIXMUXHUVKHAGSXNXOUXGUXNUWJUXJUUCRUXKUXGUWOUWJUXMUXJUUCU
        WFUWAUXAUXFUXBXFUXFUWAUXMUXJNUWFUVIUVKHAGSWTZXGUXGUWJUXJIAUWFUWAUXCUXFU
        XDXFUXFUWAUXJALZUWFUUTUXFUWAUXRDUVIUVKAVTWAZWTXHTXIUXGUVLUVIXPRZUVKGRZU
        VLUXJGRZUXTUVKUUARZUVLUXMUUARZUWAUWFUXFUWDUYAUYBNUWEUVLUVIUVKXQXLUWFUXF
        UWAUYCUYANZUXPUXTHLUWAUYEUVLUVIXSUXTUVKHAGSXNXOUXGUYDUVLUXJUUARZUYBUXGU
        XMUXJUVLUUAUXQXAUWFUXFUWAUYFUYBNZUXFUWAVSUWFUXRUYGUXSUVLUXJHAGSXCXDTXIU
        VBVEXTOXRJVIUUJAXRUUDVIYAUUKOXRAJYBPUWAUVKUUDQZYJNZUVKKNZUWAUYIUVKJQZYJ
        NZUYJUWAUYHUYKYJUVKAJYCZYDUWAUWDUYLUYJVCUWEUVKYEWNYFYGUWFUWAVSZUWJJQZUV
        LYHQZUYKXPRZUWOUUDQZUYPUYHXPRUWAUWFUWDUYOUYQNUWEUVLUVKYIXCUYNUYRUWJUUDQ
        ZUYOUYNUWOUWJUUDUXBYKUYNUXCUYSUYONUXDUWJAJYCWNTUYNUYHUYKUYPXPUWAUYHUYKN
        UWFUYMYLXAXIUWAUVRVSZUVKUVLIRZJQZUYKUVLJQZXJRZUVKUVLUUCRZUUDQZUYHUVLUUD
        QZXJRYMUWAUWDUVLOLVUBVUDYMYNUVRUWEUVLADWLUVKUVLYOYPUYTVUFVUAUUDQZVUBUYT
        VUEVUAUUDUVKUVLAAISYKUYTVUAALZVUHVUBNUUTUWAUVRVUIDUVKUVLAXBWAVUAAJYCWNT
        UWAUVRUYHUYKVUGVUCXJUYMUVLAJYCYQYRCYS $.
    $}

    $( Normed complex vector space property of a subspace.  (Contributed by NM,
       9-Apr-2008.)  (New usage is discouraged.) $)
    hhssnvt $p |- ( H e. SH -> W e. NrmCVec ) $=
      ( csh wcel cnv cva c0h cif cxp cres csm cc cop wceq xpeq1 reseq2d opeq12d
      cno xpeq2 eqtrd reseq2 syl5eq eleq1d eqid h0elsh elimel hhssnv dedth ) AD
      EZBFEGUJAHIZUKJZKZLMUKJZKZNZSUKKZNZFEAHAUKOZBURFUSBGAAJZKZLMAJZKZNZSAKZNU
      RCUSVDUPVEUQUSVAUMVCUOUSUTULGUSUTUKAJULAUKAPAUKUKTUAQUSVBUNLAUKMTQRAUKSUB
      RUCUDUKURURUEAHDUFUGUHUI $.
  $}

  ${
    $d x y z H $.
    hhsst.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhsst.2 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    $( A member of ` SH ` is a subspace.  (Contributed by NM, 6-Apr-2008.)
       (New usage is discouraged.) $)
    hhsst $p |- ( H e. SH -> W e. ( SubSp ` U ) ) $=
      ( csh wcel cnv cva cxp cres wss csm cc cno w3a wa css cfv resss hhnv hhva
      hhssnvt 3pm3.2i jctir wb hhssva hhsm hhsssm hhnm hhssnm eqid isssp sylibr
      ax-mp ) BFGZCHGZIBBJZKZILZMNBJZKZMLZOBKZOLZPZQZCARSZGZUPUQVFBCEUCUTVCVEIU
      RTMVATOBTUDUEAHGVIVGUFADUAVBMAUSIVHVDOCADUBBCEUGADUHBCEUIADUJBCEUKVHULUMU
      OUN $.

    ${
      hhssp3.3 $e |- W e. ( SubSp ` U ) $.
      hhssp3.4 $e |- H C_ ~H $.
      $( Lemma for ~ hhsssh .  (Contributed by NM, 10-Apr-2008.)
         (New usage is discouraged.) $)
      hhshsslem1 $p |- H = ( BaseSet ` W ) $=
        ( cfv cpv eqid cdm wcel mp2an cxp cva cno c1st chil cvv eqtri wceq hhnv
        cba crn bafval cnv cgr css sspnv nvgrp grporndm mp2b cres csm cc fveq2i
        cop vafval opex cr wf normf ax-hilex fex resex op1st cablo resexg ax-mp
        hilablo hvmulex dmeqi wss xpss12 ax-hfvadd fdmi sseqtr4i ssdmres dmxpid
        mpbi eqcomi ) CUCHZBWBCIHZUDZBCWCWBWBJWCJZUEWDWCKZKZBCUFLZWCUGLWDWGUAAU
        FLCAUHHZLWHADUBFAWICWIJUIMCWCWEUJWCUKULWGBBNZKBWFWJWFOWJUMZKZWJWCWKWCWK
        UNUOBNZUMZUQZPBUMZUQZIHZWKCWQIEUPWRWQQHZQHZWKWQWRWRJURWTWOQHWKWSWOQWOWP
        WKWNUSPBRUTPVARSLPSLVBVCRUTSPVDMVEVFUPWKWNOVGLWKSLVJOWJVGVHVIUNWMVKVEVF
        TTTVLWJOKZVMWLWJUAWJRRNZXABRVMZXCWJXBVMGGBRBRVNMXBROVOVPVQWJOVRVTTVLBVS
        TTTWA $.

      $( Lemma for ~ hhsssh .  (Contributed by NM, 6-Apr-2008.)
         (New usage is discouraged.) $)
      hhshsslem2 $p |- H e. SH $=
        ( vx vy wcel c0v wa cv cva co wral cc cfv wceq eqid csh wss csm cnv css
        chil cn0v hhnv hh0v sspz mp2an sspnv nvzcl hhshsslem1 eleqtrri eqeltrri
        cba ax-mp pm3.2i hhva sspgval mpanl12 nvgcl mp3an1 eqeltrrd rgen2a hhsm
        cpv cns sspsval nvscl rgen2 issh2 mpbir2an ) BUAJBUFUBZKBJZLHMZIMZNOZBJ
        ZIBPHBPZVQVRUCOZBJZIBPHQPZLVOVPGCUGRZKBAUDJZCAUERZJZWEKSADUHZFWEAWGCKAD
        UIWETZWGTZUJUKWECUQRZBCUDJZWEWLJWFWHWMWIFAWGCWKULUKZCWLWEWLTWJUMURABCDE
        FGUNZUOUPUSWAWDVTHIBVQBJZVRBJZLZVQVRCVHRZOZVSBWFWHWRWTVSSWIFVQVRAWSNWGC
        BWOADUTWSTZWKVAVBWMWPWQWTBJWNVQVRCWSBWOXAVCVDVEVFWCHIQBVQQJZWQLZVQVRCVI
        RZOZWBBWFWHXCXEWBSWIFVQVRXDUCAWGCBWOADVGXDTZWKVJVBWMXBWQXEBJWNVQVRXDCBW
        OXFVKVDVEVLUSHIBVMVN $.
    $}

    $( The predicate " ` H ` is a subspace of Hilbert space."  (Contributed by
       NM, 25-Mar-2008.)  (New usage is discouraged.) $)
    hhsssh $p |- ( H e. SH <-> ( W e. ( SubSp ` U ) /\ H C_ ~H ) ) $=
      ( csh wcel chil wss cva cxp cres csm cop cno wceq xpeq2 reseq2d opeq12d
      cc css cfv hhsst shss jca cif eleq1 eqid xpeq1 eqtrd reseq2 syl5eq eleq1d
      wa sseq1 anbi12d wf wfn ax-hfvadd fnresdm mp2b ax-hfvmul opeq12i cr normf
      ffn eqtr4i cnv hhnv sspid ax-mp eqeltri ssid pm3.2i elimhyp simpli simpri
      hhshsslem2 dedth impbii ) BFGZCAUAUBZGZBHIZUNZWAWCWDABCDEUCBUDUEWEWAWEBHU
      FZFGBHBWFFUGAWFJWFWFKZLZMTWFKZLZNZOWFLZNZDWMUHWMWBGZWFHIZWEWNWOUNJHHKZLZM
      THKZLZNZOHLZNZWBGZHHIZUNBHBWFPZWCWNWDWOXECWMWBXECJBBKZLZMTBKZLZNZOBLZNWME
      XEXJWKXKWLXEXGWHXIWJXEXFWGJXEXFWFBKWGBWFBUIBWFWFQUJRXEXHWIMBWFTQRSBWFOUKS
      ULUMBWFHUOUPHWFPZXCWNXDWOXLXBWMWBXLWTWKXAWLXLWQWHWSWJXLWPWGJXLWPWFHKWGHWF
      HUIHWFWFQUJRXLWRWIMHWFTQRSHWFOUKSUMHWFHUOUPXCXDXBAWBXBJMNZONAWTXMXAOWQJWS
      MWPHJUQJWPURWQJPUSWPHJVFWPJUTVAWRHMUQMWRURWSMPVBWRHMVFWRMUTVAVCHVDOUQOHUR
      XAOPVEHVDOVFHOUTVAVCDVGAVHGAWBGADVIAWBWBUHVJVKVLHVMVNVOZVPWNWOXNVQVRVSVT
      $.
  $}

  ${
    $d x y H $.
    hhsssh2.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    $( The predicate " ` H ` is a subspace of Hilbert space."  (Contributed by
       NM, 8-Apr-2008.)  (New usage is discouraged.) $)
    hhsssh2 $p |- ( H e. SH <-> ( W e. NrmCVec /\ H C_ ~H ) ) $=
      ( csh wcel cva csm cop cno css cfv chil wss wa cnv eqid hhsssh cres resss
      cxp cc 3pm3.2i wb hhnv hhva hhssva hhsm hhsssm hhnm hhssnm isssp mpbiran2
      w3a ax-mp anbi1i bitri ) ADEBFGHIHZJKZEZALMZNBOEZUTNUQABUQPZCQUSVAUTUSVAF
      AATZRZFMZGUAATZRZGMZIARZIMZUMZVEVHVJFVCSGVFSIASUBUQOEUSVAVKNUCUQVBUDVGGUQ
      VDFURVIIBUQVBUEABCUFUQVBUGABCUHUQVBUIABCUJURPUKUNULUOUP $.

    ${
      hhssba.2 $e |- H e. SH $.
      $( The base set of a subspace.  (Contributed by NM, 10-Apr-2008.)
         (New usage is discouraged.) $)
      hhssba $p |- H = ( BaseSet ` W ) $=
        ( cva csm cop cno eqid csh wcel css cfv hhsst ax-mp shssii hhshsslem1 )
        EFGHGZABRIZCAJKBRLMKDRABSCNOADPQ $.

      $( The vector subtraction operation on a subspace.  (Contributed by NM,
         10-Apr-2008.)  (New usage is discouraged.) $)
      hhssvs $p |- ( -h |` ( H X. H ) ) = ( -v ` W ) $=
        ( cnsb cfv cmv cxp cres cva csm cop cno cnv wcel css wceq eqid hhnv csh
        hhsst ax-mp hhssba hhvs sspm mp2an eqcomi ) BEFZGAAHIZJKLMLZNOBUJPFZOZU
        HUIQUJUJRZSATOULDUJABUMCUAUBUJUKUHGBAABCDUCUJUMUDUHRUKRUEUFUG $.

      $( Mapping of the vector subtraction operation on a subspace.
         (Contributed by NM, 10-Apr-2008.)  (New usage is discouraged.) $)
      hhssvsf $p |- ( -h |` ( H X. H ) ) : ( H X. H ) --> H $=
        ( cnv wcel cxp cmv cres wf hhssnv hhssba hhssvs nvmf ax-mp ) BEFAAGZAHP
        IZJABCDKBQAABCDLABCDMNO $.

      $( Inner product space property of a subspace.  (Contributed by NM,
         10-Apr-2008.)  (New usage is discouraged.) $)
      hhssph $p |- W e. CPreHilOLD $=
        ( cva csm cop cno ccphlo wcel css cfv eqid hhph hhsst ax-mp sspph mp2an
        csh ) EFGHGZIJBTKLZJZBIJTTMZNASJUBDTABUCCOPTUABUAMQR $.
    $}

    ${
      hhssims.2 $e |- H e. SH $.
      hhssims.3 $e |- D = ( ( normh o. -h ) |` ( H X. H ) ) $.
      $( Induced metric of a subspace.  (Contributed by NM, 10-Apr-2008.)
         (New usage is discouraged.) $)
      hhssims $p |- D = ( IndMet ` W ) $=
        ( cno cmv ccom cxp cres cims cfv wcel wceq hhssnv hhssvs ax-mp eqtr4i
        cnv hhssnm eqid imsval resco crn wss wf hhssvsf frn cores ) AGHIBBJZKZC
        LMZFUMGBKZHUKKZIZULCTNUMUPOBCDEPUMCUOUNBCDEQBCDUAUMUBUCRULGUOIZUPGHUKUD
        UOUEBUFZUPUQOUKBUOUGURBCDEUHUKBUOUIRGUOBUJRSSS $.
    $}
  $}

  ${
    hhssims2.1 $e |- W =
   <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. , ( normh |` H ) >. $.
    hhssims2.3 $e |- D = ( IndMet ` W ) $.
    ${
      hhssims2.2 $e |- H e. SH $.
      $( Induced metric of a subspace.  (Contributed by NM, 10-Apr-2008.)
         (New usage is discouraged.) $)
      hhssims2 $p |- D = ( ( normh o. -h ) |` ( H X. H ) ) $=
        ( cims cfv cno cmv ccom cxp cres eqid hhssims eqtr4i ) ACGHIJKBBLMZEQBC
        DFQNOP $.

      $( Induced metric of a subspace.  (Contributed by NM, 10-Apr-2008.)
         (New usage is discouraged.) $)
      hhssmet $p |- D e. ( Met ` H ) $=
        ( cnv wcel cme cfv hhssnv hhssba imsmet ax-mp ) CGHABIJHBCDFKACBBCDFLEM
        N $.

      $( Value of the distance function of the metric space of a subspace.
         (Contributed by NM, 10-Apr-2008.)  (New usage is discouraged.) $)
      hhssmetdval $p |- ( ( A e. H /\ B e. H )
         -> ( A D B ) = ( normh ` ( A -h B ) ) ) $=
        ( wcel wa co cmv cxp cres cno cfv cnv wceq hhssnv mp3an1 hhssba imsdval
        hhssvs hhssnm ovres fveq2d csh shsubcl fvres syl 3eqtrd ) ADIZBDIZJZABC
        KZABLDDMNZKZODNZPZABLKZURPZUTOPZEQIULUMUOUSRDEFHSABCEUPURDDEFHUADEFHUCD
        EFUDGUBTUNUQUTURABDDLUEUFUNUTDIZVAVBRDUGIULUMVCHABDUHTUTDOUIUJUK $.
    $}

    ${
      $d f j k x y D $.  $d f j k x y H $.
      hhsscms.3 $e |- H e. CH $.
      $( The induced metric of a closed subspace is complete.  (Contributed by
         NM, 10-Apr-2008.)  (Revised by Mario Carneiro, 14-May-2014.)
         (New usage is discouraged.) $)
      hhsscms $p |- D e. ( CMet ` H ) $=
        ( vf vx cmopn cfv eqid cv cca wcel cn wf chli clm wbr chil hhssmet ccom
        chshii wa cdm cno cmv ccau wrex cmap cxp simpl hhssims2 fveq2i syl6eleq
        co cres cxmt hilxmet simpr causs sylancr mpbird wss chssii fss ax-hilex
        wb sylancl nnex elmap sylibr cva csm cop hhims hhcau sylanbrc ax-hcompl
        elin2 vex rexlimivw 3syl wfun hlimf ffun funfvbrb mp2b sylib hhlm resss
        breldm eqsstri ssbri syl c1 cch crest wceq metrest eqcomi nnuz a1i ctop
        mp2an mopntop mp1i fvex chlimi syl3anc cz 1z lmss mpbid iscmet3i ) AGAI
        JZBXPKZABCDEBFUCZUAGLZAMJZNZOBXSPZUDZXSXSQJZXPRJZSZXSYEUENYCXSYDUFUGUBZ
        IJZRJZSZYFYCXSYDQSZYJYCXSQUEZNZYKYCXSUHNZXSHLZQSZHTUIYMYCXSYGMJZNZXSTOU
        JUPZNZYNYCYRXSYGBBUKUQZMJZNZYCXSXTUUBYAYBULAUUAMABCDEXRUMZUNUOYCYGTURJN
        ZYBYRUUCVHYGYGKZUSZYAYBUTZYGXSTBVAVBVCYCOTXSPZYTYCYBBTVDZUUIUUHBFVEZOBT
        XSVFVITOXSVGVJVKVLXSYQYSUHYGVMVNVOUFVOZUULKZYGUULUUMUUFVPZVQVTVRHXSVSYP
        YMHTXSYOQGWAZHWAWLWBWCYLTQPQWDYMYKVHWEYLTQWFXSQWGWHWIZQYIXSYDQYIYSUQYIY
        GUULYHUUMUUNYHKZWJYIYSWKWMWNWOYCYDXSYHXPWPWQBOYHBWRUPZXPUUEUUJUURXPWSUU
        GUUKYGAYHXPTBUUDUUQXQWTXEXAXBBWQNZYCFXCZUUEYHXDNYCUUGYGYHTUUQXFXGYCUUSY
        BYKYDBNUUTUUHUUPYDXSBXSQXHZXIXJWPXKNYCXLXCUUHXMXNXSYDYEUUOUVAWLWOXO $.
    $}
  $}

  ${
    hhssbn.1 $e |- W = <. <. ( +h |` ( H X. H ) ) , ( .h |` ( CC X. H ) ) >. ,
               ( normh |` H ) >. $.
    hhssbn.2 $e |- H e. CH $.
    $( Banach space property of a closed subspace.  (Contributed by NM,
       10-Apr-2008.)  (New usage is discouraged.) $)
    hhssbn $p |- W e. CBan $=
      ( ccbn wcel cnv cims cfv chshii hhssnv eqid hhsscms hhssba iscbn mpbir2an
      cms ) BEFBGFBHIZAQIFABCADJZKRABCRLZDMRBAABCSNTOP $.

    $( Hilbert space property of a closed subspace.  (Contributed by NM,
       10-Apr-2008.)  (New usage is discouraged.) $)
    hhsshl $p |- W e. CHilOLD $=
      ( chlo wcel ccbn ccphlo hhssbn chshii hhssph ishlo mpbir2an ) BEFBGFBHFAB
      CDIABCADJKBLM $.
  $}

  ${
    $d x y z H $.  $d x y z A $.  $d x y B $.
    $( Value of orthogonal complement of a subset of Hilbert space.
       (Contributed by NM, 7-Aug-2000.)  (Revised by Mario Carneiro,
       23-Dec-2013.)  (New usage is discouraged.) $)
    ocval $p |- ( H C_ ~H -> ( _|_ ` H ) =
        { x e. ~H | A. y e. H ( x .ih y ) = 0 } ) $=
      ( vz chil wss cpw wcel cort cfv cv csp cc0 wceq wral ax-hilex elpw2 raleq
      co crab rabbidv df-oc rabex fvmpt sylbir ) CEFCEGZHCIJAKBKLSMNZBCOZAETZNC
      EPQDCUGBDKZOZAETUIUFIUJCNUKUHAEUGBUJCRUADABUBUHAEPUCUDUE $.

    $( Membership in orthogonal complement of H subset.  (Contributed by NM,
       7-Aug-2000.)  (New usage is discouraged.) $)
    ocel $p |- ( H C_ ~H -> ( A e. ( _|_ ` H ) <-> ( A e. ~H /\
                  A. x e. H ( A .ih x ) = 0 ) ) ) $=
      ( vy chil wss cort cfv wcel cv csp co cc0 wceq wral wa ocval eleq2d oveq1
      crab eqeq1d ralbidv elrab syl6bb ) CEFZBCGHZIBDJZAJZKLZMNZACOZDETZIBEIBUH
      KLZMNZACOZPUEUFULBDACQRUKUODBEUGBNZUJUNACUPUIUMMUGBUHKSUAUBUCUD $.

    $( Membership in orthogonal complement of H subspace.  (Contributed by NM,
       9-Oct-1999.)  (New usage is discouraged.) $)
    shocel $p |- ( H e. SH -> ( A e. ( _|_ ` H ) <-> ( A e. ~H /\
                  A. x e. H ( A .ih x ) = 0 ) ) ) $=
      ( csh wcel chil wss cort cfv cv csp co cc0 wceq wral wa wb shss ocel syl
      ) CDECFGBCHIEBFEBAJKLMNACOPQCRABCST $.

    $( The orthogonal complement of a subspace is a subspace.  Part of Remark
       3.12 of [Beran] p. 107.  (Contributed by NM, 7-Aug-2000.)
       (New usage is discouraged.) $)
    ocsh $p |- ( A C_ ~H -> ( _|_ ` A ) e. SH ) $=
      ( vx vy vz chil c0v wcel wa cv co wral cc csp cc0 wceq syl6 ocel wi caddc
      cmul wss cort cfv cva csm csh crab ssrab2 syl6eqss ssel ralrimiv ax-hv0cl
      ocval hi01 jctil mpbird jca ssel2 ax-his2 3expa oveq12 syl6eq sylan9eq ex
      00id ancoms sylan an32s ralimdva imdistanda hvaddcl anim1i anbi12d r19.26
      an4 anbi2i bitr4i syl6bb ralrimivv mul01 oveq2 eqeq1d syl5ibrcom ad2antrl
      3imtr4d w3a ax-his3 sylibrd hvmulcl anbi2d anass syl6bbr issh2 sylanbrc
      wb ) AEUAZAUBUCZEUAZFWQGZHBIZCIZUDJZWQGZCWQKBWQKZWTXAUEJZWQGZCWQKBLKZHWQU
      FGWPWRWSWPWQWTXAMJNOCAKZBEUGEBCAUMXHBEUHUIWPWSFEGZFXAMJNOZCAKZHWPXKXIWPXJ
      CAWPXAAGXAEGZXJAEXAUJXAUNPUKULUOCFAQUPUQWPXDXGWPXCBCWQWQWPWTEGZXLHZWTDIZM
      JZNOZXAXOMJZNOZHZDAKZHZXBEGZXBXOMJZNOZDAKZHZWTWQGZXAWQGZHZXCWPYBXNYFHYGWP
      XNYAYFWPXNHXTYEDAWPXOAGZXNXTYERZWPYKHZXOEGZXNYLAEXOURZXNYNYLXNYNHZXTYEYPX
      TYDXPXRSJZNXMXLYNYDYQOWTXAXOUSUTXTYQNNSJNXPNXRNSVAVEVBVCVDVFVGVHVIVJXNYCY
      FWTXAVKVLPWPYJXMXQDAKZHZXLXSDAKZHZHZYBWPYHYSYIUUADWTAQDXAAQZVMUUBXNYRYTHZ
      HYBXMYRXLYTVOYAUUDXNXQXSDAVNVPVQVRDXBAQWEVSWPXFBCLWQWPWTLGZXLHZYTHZXEEGZX
      EXOMJZNOZDAKZHZUUEYIHZXFWPUUGUUFUUKHUULWPUUFYTUUKWPUUFHXSUUJDAWPYKUUFXSUU
      JRZYMYNUUFUUNYOYNUUFHXSWTXRTJZNOZUUJUUEXSUUPRYNXLUUEUUPXSWTNTJZNOWTVTXSUU
      OUUQNXRNWTTWAWBWCWDUUFYNUUJUUPWOZUUEXLYNUURUUEXLYNWFUUIUUONWTXAXOWGWBUTVF
      WHVGVHVIVJUUFUUHUUKWTXAWIVLPWPUUMUUEUUAHUUGWPYIUUAUUEUUCWJUUEXLYTWKWLDXEA
      QWEVSUQBCWQWMWN $.

    $( The orthogonal complement of a subspace is a subspace.  Part of Remark
       3.12 of [Beran] p. 107.  (Contributed by NM, 10-Oct-1999.)
       (New usage is discouraged.) $)
    shocsh $p |- ( A e. SH -> ( _|_ ` A ) e. SH ) $=
      ( csh wcel chil wss cort cfv shss ocsh syl ) ABCADEAFGBCAHAIJ $.

    $( An orthogonal complement is a subset of Hilbert space.  (Contributed by
       NM, 9-Aug-2000.)  (New usage is discouraged.) $)
    ocss $p |- ( A C_ ~H -> ( _|_ ` A ) C_ ~H ) $=
      ( chil wss cort cfv csh wcel ocsh shss syl ) ABCADEZFGKBCAHKIJ $.

    $( An orthogonal complement is a subset of Hilbert space.  (Contributed by
       NM, 11-Oct-1999.)  (New usage is discouraged.) $)
    shocss $p |- ( A e. SH -> ( _|_ ` A ) C_ ~H ) $=
      ( csh wcel chil wss cort cfv shss ocss syl ) ABCADEAFGDEAHAIJ $.

    $( Contraposition law for orthogonal complement.  (Contributed by NM,
       8-Aug-2000.)  (New usage is discouraged.) $)
    occon $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
                 ( A C_ B -> ( _|_ ` B ) C_ ( _|_ ` A ) ) ) $=
      ( vx vy chil wss wa cort cfv cv csp co wceq wral crab wi ssralv ralrimivw
      cc0 ocval ss2rab sylibr adantl ad2antlr ad2antrr 3sstr4d ex ) AEFZBEFZGZA
      BFZBHIZAHIZFUJUKGCJDJKLSMZDBNZCEOZUNDANZCEOZULUMUKUPURFZUJUKUOUQPZCENUSUK
      UTCEUNDABQRUOUQCEUAUBUCUIULUPMUHUKCDBTUDUHUMURMUIUKCDATUEUFUG $.

    $( Double contraposition for orthogonal complement.  (Contributed by NM,
       22-Jul-2001.)  (New usage is discouraged.) $)
    occon2 $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
              ( A C_ B -> ( _|_ ` ( _|_ ` A ) ) C_ ( _|_ ` ( _|_ ` B ) ) ) ) $=
      ( chil wss wa cort cfv ocss anim12ci occon sylsyld ) ACDZBCDZEBFGZCDZAFGZ
      CDZEABDNPDPFGNFGDLQMOAHBHIABJNPJK $.

    ${
      occon2.1 $e |- A C_ ~H $.
      occon2.2 $e |- B C_ ~H $.
      $( Double contraposition for orthogonal complement.  (Contributed by NM,
         9-Aug-2000.)  (New usage is discouraged.) $)
      occon2i $p |- ( A C_ B ->
                   ( _|_ ` ( _|_ ` A ) ) C_ ( _|_ ` ( _|_ ` B ) ) ) $=
        ( chil wss cort cfv wi occon2 mp2an ) AEFBEFABFAGHGHBGHGHFICDABJK $.
    $}

    $( The zero vector belongs to an orthogonal complement of a Hilbert
       subspace.  (Contributed by NM, 11-Oct-1999.)
       (New usage is discouraged.) $)
    oc0 $p |- ( H e. SH -> 0h e. ( _|_ ` H ) ) $=
      ( csh wcel cort cfv c0v shocsh sh0 syl ) ABCADEZBCFJCAGJHI $.

    $( Members of a subset and its complement are orthogonal.  (Contributed by
       NM, 9-Aug-2000.)  (New usage is discouraged.) $)
    ocorth $p |- ( H C_ ~H -> ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
                 ( A .ih B ) = 0 ) ) $=
      ( vx chil wss wcel cort cfv wa csp co cc0 wceq cv wral simplbda adantl wi
      ocel oveq2 eqeq1d rspcv ad2antlr ssel2 ocss sselda orthcom syl2an sylibrd
      wb mpd anandis ex ) CEFZACGZBCHIZGZJABKLMNZUOUPURUSUOUPJZUOURJZJZBDOZKLZM
      NZDCPZUSVAVFUTUOURBEGZVFDBCTQRVBVFBAKLZMNZUSUPVFVISUOVAVEVIDACVCANVDVHMVC
      ABKUAUBUCUDUTAEGVGUSVIUKVACEAUEUOUQEBCUFUGABUHUIUJULUMUN $.

    $( Members of a subspace and its complement are orthogonal.  (Contributed
       by NM, 10-Oct-1999.)  (New usage is discouraged.) $)
    shocorth $p |- ( H e. SH -> ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
                 ( A .ih B ) = 0 ) ) $=
      ( csh wcel chil wss cort cfv wa csp co cc0 wceq wi shss ocorth syl ) CDEC
      FGACEBCHIEJABKLMNOCPABCQR $.

    $( Inclusion in complement of complement.  Part of Proposition 1 of
       [Kalmbach] p. 65.  (Contributed by NM, 9-Aug-2000.)
       (New usage is discouraged.) $)
    ococss $p |- ( A C_ ~H -> A C_ ( _|_ ` ( _|_ ` A ) ) ) $=
      ( vy vx chil wss cort cfv cv wcel csp co cc0 wceq wral wa ocorth ralrimdv
      ssel exp3a jcad wb ocss ocel syl sylibrd ssrdv ) ADEZBAAFGZFGZUGBHZAIZUJD
      IZUJCHZJKLMZCUHNZOZUJUIIZUGUKULUOADUJRUGUKUNCUHUGUKUMUHIUNUJUMAPSQTUGUHDE
      UQUPUAAUBCUJUHUCUDUEUF $.

    $( Inclusion in complement of complement.  Part of Proposition 1 of
       [Kalmbach] p. 65.  (Contributed by NM, 10-Oct-1999.)
       (New usage is discouraged.) $)
    shococss $p |- ( A e. SH -> A C_ ( _|_ ` ( _|_ ` A ) ) ) $=
      ( csh wcel chil wss cort cfv shss ococss syl ) ABCADEAAFGFGEAHAIJ $.

    $( Members of orthogonal subspaces are orthogonal.  (Contributed by NM,
       17-Oct-1999.)  (New usage is discouraged.) $)
    shorth $p |- ( H e. SH -> ( G C_ ( _|_ ` H ) ->
        ( ( A e. G /\ B e. H ) -> ( A .ih B ) = 0 ) ) ) $=
      ( csh wcel cort cfv wss wa csp cc0 wceq ssel anim1d imp ancomd chil sseld
      co shocorth wb shss shocss anim12d orthcom syl mpbid sylan2 exp32 ) DEFZC
      DGHZIZACFZBDFZJZABKTLMZUMUPJZUKUOAULFZJZUQURUSUOUMUPUSUOJUMUNUSUOCULANOPQ
      UKUTJZBAKTLMZUQUKUTVBBADUAPVABRFZARFZJZVBUQUBUKUTVEUKUOVCUSVDUKDRBDUCSUKU
      LRADUDSUEPBAUFUGUHUIUJ $.

    $( Intersection of a Hilbert subspace and its complement.  Part of
       Proposition 1 of [Kalmbach] p. 65.  (Contributed by NM, 11-Oct-1999.)
       (New usage is discouraged.) $)
    ocin $p |- ( A e. SH -> ( A i^i ( _|_ ` A ) ) = 0H ) $=
      ( vx vy csh wcel cort cfv cin c0h cv wa c0v wceq chil csp co cc0 wi eleq1
      wral shocel oveq2 eqeq1d rspccv biimpd sylan9r syl6bi com23 imp3a sh0 oc0
      his6 jca anbi12d syl5ibrcom impbid elin elch0 3bitr4g eqrdv ) ADEZBAAFGZH
      ZIVABJZAEZVDVBEZKZVDLMZVDVCEVDIEVAVGVHVAVEVFVHVAVFVEVHVAVFVDNEZVDCJZOPZQM
      ZCATZKVEVHRCVDAUAVMVEVDVDOPZQMZVIVHVLVOCVDAVJVDMVKVNQVJVDVDOUBUCUDVIVOVHV
      DULUEUFUGUHUIVAVGVHLAEZLVBEZKVAVPVQAUJAUKUMVHVEVPVFVQVDLASVDLVBSUNUOUPVDA
      VBUQVDURUSUT $.

    $( Hilbert lattice contraposition law.  (Contributed by Mario Carneiro,
       18-May-2014.)  (New usage is discouraged.) $)
    occon3 $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
                     ( A C_ ( _|_ ` B ) <-> B C_ ( _|_ ` A ) ) ) $=
      ( chil wss wa cort cfv ococss adantl wi occon sylan2 sstr2 sylsyld adantr
      ocss id syl2anr impbid ) ACDZBCDZEZABFGZDZBAFGZDZUBBUCFGZDZUDUGUEDZUFUAUH
      TBHIUATUCCDUDUIJBPAUCKLBUGUEMNUBAUEFGZDZUFUJUCDZUDTUKUAAHOUAUAUECDUFULJTU
      AQAPBUEKRAUJUCMNS $.
  $}

  $( A nonzero vector in the complement of a subspace does not belong to the
     subspace.  (Contributed by NM, 10-Apr-2006.)
     (New usage is discouraged.) $)
  ocnel $p |- ( ( H e. SH /\ A e. ( _|_ ` H ) /\ A =/= 0h ) -> -. A e. H ) $=
    ( csh wcel cort cfv c0v wne wn c0h wceq cin elin ocin eleq2d biimpd syl5bir
    wa wi exp3acom23 imp elch0 syl6ib necon3ad 3impia ) BCDZABEFZDZAGHABDZIUFUH
    RZUIAGUJUIAJDZAGKUFUHUIUKSUFUIUHUKUIUHRABUGLZDZUFUKABUGMUFUMUKUFULJABNOPQTU
    AAUBUCUDUE $.

  ${
    $d x y A $.
    chocval.1 $e |- A e. CH $.
    $( Value of the orthogonal complement of a Hilbert lattice element.  The
       orthogonal complement of ` A ` is the set of vectors that are orthogonal
       to all vectors in ` A ` .  (Contributed by NM, 8-Aug-2004.)
       (New usage is discouraged.) $)
    chocvali $p |- ( _|_ ` A ) = { x e. ~H | A. y e. A ( x .ih y ) = 0 } $=
      ( chil wss cort cfv cv csp co cc0 wceq wral crab chssii ocval ax-mp ) CEF
      CGHAIBIJKLMBCNAEOMCDPABCQR $.
  $}

  ${
    shuni.1 $e |- ( ph -> H e. SH ) $.
    shuni.2 $e |- ( ph -> K e. SH ) $.
    shuni.3 $e |- ( ph -> ( H i^i K ) = 0H ) $.
    shuni.4 $e |- ( ph -> A e. H ) $.
    shuni.5 $e |- ( ph -> B e. K ) $.
    shuni.6 $e |- ( ph -> C e. H ) $.
    shuni.7 $e |- ( ph -> D e. K ) $.
    shuni.8 $e |- ( ph -> ( A +h B ) = ( C +h D ) ) $.
    $( Two subspaces with trivial intersection have a unique decomposition of
       the elements of the subspace sum.  (Contributed by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    shuni $p |- ( ph -> ( A = C /\ B = D ) ) $=
      ( wceq co wcel chil syl2anc cmv c0v c0h cin csh shsubcl syl3anc hvaddsub4
      wb shel syl22anc mpbid eqeltrd elin sylanbrc eleqtrd elch0 sylib hvsubeq0
      cva eqtr3d eqcomd jca ) ABDPZCEPABDUAQZUBPZVDAVEUCRVFAVEFGUDZUCAVEFRZVEGR
      VEVGRAFUERZBFRZDFRZVHHKMBDFUFUGAVEECUAQZGABCUTQDEUTQPZVEVLPZOABSRZCSRZDSR
      ZESRZVMVNUIAVIVJVOHKBFUJTZAGUERZCGRZVPILCGUJTZAVIVKVQHMDFUJTZAVTEGRZVRINE
      GUJTZBCDEUHUKULZAVTWDWAVLGRINLECGUFUGUMVEFGUNUOJUPVEUQURZAVOVQVFVDUIVSWCB
      DUSTULAECAVLUBPZECPZAVEVLUBWFWGVAAVRVPWHWIUIWEWBECUSTULVBVC $.
  $}

  ${
    chocuni.1 $e |- H e. CH $.
    $( Lemma for uniqueness part of Projection Theorem.  Theorem 3.7(i) of
       [Beran] p. 102 (uniqueness part).  (Contributed by NM, 23-Oct-1999.)
       (Proof shortened by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    chocunii $p |- ( ( ( A e. H /\ B e. ( _|_ ` H ) ) /\
                    ( C e. H /\ D e. ( _|_ ` H ) ) ) ->
            ( ( R = ( A +h B ) /\ R = ( C +h D ) ) -> ( A = C /\ B = D ) ) ) $=
      ( wcel cort cfv wa cva co wceq csh chshii a1i shocsh mp1i cin c0h simplll
      ocin simpllr simplrl simplrr eqtr2 adantl shuni ex ) AFHZBFIJZHZKZCFHZDUL
      HZKZKZEABLMZNECDLMZNKZACNBDNKURVAKZABCDFULFOHZVBFGPZQVCULOHVBVDFRSVCFULTU
      ANVBVDFUCSUKUMUQVAUBUKUMUQVAUDUNUOUPVAUEUNUOUPVAUFVAUSUTNUREUSUTUGUHUIUJ
      $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d w x y z C $.
    $( Projection Theorem, uniqueness part.  Any two disjoint subspaces yield a
       unique decomposition of vectors into each subspace.  (Contributed by
       Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    pjhthmo $p |- ( ( A e. SH /\ B e. SH /\ ( A i^i B ) = 0H ) ->
                   E* x ( x e. A /\ E. y e. B C = ( x +h y ) ) ) $=
      ( vz vw csh wcel cin c0h wceq cv cva co wrex wa wal syl5bir eqeq2d w3a wi
      wmo reeanv simpll1 simpll2 simpll3 simplrl simprll simplrr simprlr eqtr3d
      simprrl simprrr shuni simpld exp32 rexlimdvv expimpd alrimivv eleq1 oveq1
      an4 rexbidv oveq2 cbvrexv syl6bb anbi12d mo4 sylibr ) CHIZDHIZCDJKLZUAZAM
      ZCIZEVOBMZNOZLZBDPZQZFMZCIZEWBGMZNOZLZGDPZQZQZVOWBLZUBZFRARWAAUCVNWKAFWIV
      PWCQZVTWGQZQVNWJVPWCVTWGVCVNWLWMWJWMVSWFQZGDPBDPVNWLQZWJVSWFBGDDUDWOWNWJB
      GDDWOVQDIZWDDIZQZWNWJWOWRWNQZQZWJVQWDLZWTVOVQWBWDCDVKVLVMWLWSUEVKVLVMWLWS
      UFVKVLVMWLWSUGVNVPWCWSUHWOWPWQWNUIVNVPWCWSUJWOWPWQWNUKWTEVRWEWOWRVSWFUMWO
      WRVSWFUNULUOUPUQURSUSSUTWAWHAFWJVPWCVTWGVOWBCVAWJVTEWBVQNOZLZBDPWGWJVSXCB
      DWJVRXBEVOWBVQNVBTVDXCWFBGDXAXBWEEVQWDWBNVETVFVGVHVIVJ $.
  $}

  ${
    $d k x B $.  $d k x F $.  $d k x ph $.  $d x A $.
    occl.1 $e |- ( ph -> A C_ ~H ) $.
    occl.2 $e |- ( ph -> F e. Cauchy ) $.
    occl.3 $e |- ( ph -> F : NN --> ( _|_ ` A ) ) $.
    occl.4 $e |- ( ph -> B e. A ) $.
    $( Lemma for ~ occl .  (Contributed by NM, 7-Aug-2000.)  (Revised by Mario
       Carneiro, 14-May-2014.)  (New usage is discouraged.) $)
    occllem $p |- ( ph -> ( ( ~~>v ` F ) .ih B ) = 0 ) $=
      ( vx chli cfv csp co cc0 cn wcel eqid a1i chil wceq vk csn cxp ccnfld cha
      ctopn cnfldhaus cv cmpt ccom clm cno cmv cmopn wbr cdm ccau ax-hcompl wfn
      wrex wf hlimf ffn ax-mp fnbr mpan rexlimivw 3syl wfun ffun funfvbrb sylib
      mp2b cmap cres cva csm cop hhims hhlm resss eqsstri ssbri syl cxmt ctopon
      wb hilxmet mopntopon mp1i cnmptid sseldd cnmptc cnv ctx ccn hhnv cnmpt12f
      hhip dipcn lmcn wral wa cort ffvelrnda wss ocel adantr mpbid simpld oveq1
      ovex fvmpt simprd oveq2 eqeq1d rspcv sylc eqtrd ocss fss fvco3 sylan c0ex
      syl2anc fvconst2 adantl 3eqtr4d fnmpti fnfco fconst eqfnfv sylancl mpbird
      ralrimiva fvex hlimveci 3brtr3d cc c1 cnfldtopon 0cn nnuz lmconst syl3anc
      cz 1z lmmo ) ADJKZCLMZNONUBZUCZUDUFKZUUMUEPAUUMUUMQZUGRAISIUHZCLMZUIZDUJZ
      UUIUUQKZUULUUJUUMUKKZAUUIDUUQULUMUJZUNKZUUMADUUIJUOZDUUIUVBUKKZUOADJUPZPZ
      UVCADUQPDUUOJUOZISUTUVFFIDURUVGUVFISJUVEUSZUVGUVFUVESJVAZUVHVBUVESJVCVDUV
      EDUUOJVEVFVGVHUVIJVIUVFUVCWGVBUVESJVJDJVKVMVLZJUVDDUUIJUVDSOVNMZVOUVDUVAV
      PVQVRULVRZUVBUVLQZUVAUVLUVMUVAQZVSZUVBQZVTUVDUVKWAWBWCWDAIUUOCLUVBUVBUVBU
      UMSUVASWEKPUVBSWFKPAUVAUVNWHUVAUVBSUVPWIWJZAIUVBSUVQWKAICUVBUVBSSUVQUVQAB
      SCEHWLWMUVLWNPLUVBUVBWOMUUMWPMPAUVLUVMWQUVALUVLUVBUUMUVLUVMWSUVOUVPUUNWTW
      JWRXAAUURUULTZUAUHZUURKZUVSUULKZTZUAOXBZAUWBUAOAUVSOPZXCZUVSDKZUUQKZNUVTU
      WAUWEUWGUWFCLMZNUWEUWFSPZUWGUWHTUWEUWIUWFUUOLMZNTZIBXBZUWEUWFBXDKZPZUWIUW
      LXCZAOUWMUVSDGXEAUWNUWOWGZUWDABSXFZUWPEIUWFBXGWDXHXIZXJIUWFUUPUWHSUUQUUOU
      WFCLXKUUQQZUWFCLXLXMWDUWECBPZUWLUWHNTZAUWTUWDHXHUWEUWIUWLUWRXNUWKUXAICBUU
      OCTUWJUWHNUUOCUWFLXOXPXQXRXSAOSDVAZUWDUVTUWGTAOUWMDVAUWMSXFZUXBGAUWQUXCEB
      XTWDOUWMSDYAYEZOSUVSUUQDYBYCUWDUWANTAONUVSYDYFYGYHYOAUUROUSZUULOUSZUVRUWC
      WGAUUQSUSZUXBUXEUXGAISUUPUUQUUOCLXLUWSYIRUXDSOUUQDYJYEOUUKUULVAUXFONYDYKO
      UUKUULVCVDUAOUURUULYLYMYNAUVCUUISPUUSUUJTUVJUUIDDJYPYQIUUIUUPUUJSUUQUUOUU
      ICLXKUWSUUICLXLXMVHYRAUUMYSWFKPZNYSPZYTUUFPZUULNUUTUOUXHAUUMUUNUUARUXIAUU
      BRUXJAUUGRNUUMYTYSOUUCUUDUUEUUH $.
  $}

  ${
    $d f x A $.
    $( Closure of complement of Hilbert subset.  Part of Remark 3.12 of [Beran]
       p. 107.  (Contributed by NM, 8-Aug-2000.)  (Proof shortened by Mario
       Carneiro, 14-May-2014.)  (New usage is discouraged.) $)
    occl $p |- ( A C_ ~H -> ( _|_ ` A ) e. CH ) $=
      ( vf vx chil wss cfv wcel cv wf chli wbr wrex ccau wral vex syl ralrimiva
      wa hlimf wb cort csh cn wi cch ocsh csp co cc0 ax-hcompl breldm rexlimivw
      wceq ad2antlr ffvelrni simplll simpllr simplr simpr occllem ocel ad2antrr
      cdm mpbir2and wfun ffun funfvbrb mp2b sylib breq2 rspcev syl2anc ex isch3
      sylanbrc ) ADEZAUAFZUBGUCVQBHZIZVRCHZJKZCVQLZUDZBMNVQUEGAUFVPWCBMVPVRMGZR
      ZVSWBWEVSRZVRJFZVQGZVRWGJKZWBWFWHWGDGZWGVTUGUHUIUMZCANZWFVRJVCZGZWJWDWNVP
      VSWDWACDLWNCVRUJWAWNCDVRVTJBOCOUKULPUNZWMDVRJSUOPWFWKCAWFVTAGZRAVTVRVPWDV
      SWPUPVPWDVSWPUQWEVSWPURWFWPUSUTQVPWHWJWLRTWDVSCWGAVAVBVDWFWNWIWOWMDJIJVEW
      NWITSWMDJVFVRJVGVHVIWAWICWGVQVTWGVRJVJVKVLVMQCBVQVNVO $.
  $}

  $( Closure of complement of Hilbert subspace.  Part of Remark 3.12 of [Beran]
     p. 107.  (Contributed by NM, 13-Oct-1999.)  (New usage is discouraged.) $)
  shoccl $p |- ( A e. SH -> ( _|_ ` A ) e. CH ) $=
    ( csh wcel chil wss cort cfv cch shss occl syl ) ABCADEAFGHCAIAJK $.

  $( Closure of complement of Hilbert subspace.  Part of Remark 3.12 of [Beran]
     p. 107.  (Contributed by NM, 22-Jul-2001.)  (New usage is discouraged.) $)
  choccl $p |- ( A e. CH -> ( _|_ ` A ) e. CH ) $=
    ( cch wcel csh cort cfv chsh shoccl syl ) ABCADCAEFBCAGAHI $.

  ${
    choccl.1 $e |- A e. CH $.
    $( Closure of ` CH ` orthocomplement.  (Contributed by NM, 29-Jul-1999.)
       (New usage is discouraged.) $)
    choccli $p |- ( _|_ ` A ) e. CH $=
      ( cch wcel cort cfv choccl ax-mp ) ACDAEFCDBAGH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Subspace sum, span, lattice join, lattice supremum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Define subspace sum in ` SH ` .  See ~ shsval , ~ shsval2i , and
       ~ shsval3i for its value.  (Contributed by NM, 16-Oct-1999.)
       (New usage is discouraged.) $)
    df-shs $a |- +H = ( x e. SH , y e. SH |-> ( +h " ( x X. y ) ) ) $.

    $( Define the linear span of a subset of Hilbert space.  Definition of span
       in [Schechter] p. 276.  See ~ spanval for its value.  (Contributed by
       NM, 2-Jun-2004.)  (New usage is discouraged.) $)
    df-span $a |- span = ( x e. ~P ~H |-> |^| { y e. SH | x C_ y } ) $.

    $( Define Hilbert lattice join.  See ~ chjval for its value and ~ chjcl for
       its closure law.  Note that we define it over all Hilbert space subsets
       to allow proving more general theorems.  Even for general subsets the
       join belongs to ` CH ` ; see ~ sshjcl .  (Contributed by NM,
       1-Nov-2000.)  (New usage is discouraged.) $)
    df-chj $a |- vH = ( x e. ~P ~H , y e. ~P ~H |->
                        ( _|_ ` ( _|_ ` ( x u. y ) ) ) ) $.
  $}

  $( Define the supremum of a set of Hilbert lattice elements.  See ~ chsupval2
     for its value.  We actually define the supremum for an arbitrary
     collection of Hilbert space subsets, not just elements of the Hilbert
     lattice ` CH ` , to allow more general theorems.  Even for general subsets
     the supremum still a Hilbert lattice element; see ~ hsupcl .  (Contributed
     by NM, 9-Dec-2003.)  (New usage is discouraged.) $)
  df-chsup $a |- \/H = ( x e. ~P ~P ~H |-> ( _|_ ` ( _|_ ` U. x ) ) ) $.

  ${
    $d f x y z A $.  $d x y z B $.  $d x y z C $.  $d x y D $.
    $( Value of subspace sum of two Hilbert space subspaces.  Definition of
       subspace sum in [Kalmbach] p. 65.  (Contributed by NM, 16-Oct-1999.)
       (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    shsval $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) =
                     ( +h " ( A X. B ) ) ) $=
      ( vx vy csh cva cv cxp cima cph wceq xpeq12 imaeq2d df-shs cablo wcel cvv
      wa hilablo imaexg ax-mp ovmpt2a ) CDABEEFCGZDGZHZIFABHZIZJUCAKUDBKRUEUFFU
      CAUDBLMCDNFOPUGQPSFUFOTUAUB $.

    $( The subspace sum is a subset of Hilbert space.  (Contributed by Mario
       Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    shsss $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) C_ ~H ) $=
      ( csh wcel wa cph co cva cxp cima shsval crn imassrn wf wss ax-hfvadd frn
      chil ax-mp sstri syl6eqss ) ACDBCDEABFGHABIZJZRABKUCHLZRHUBMRRIZRHNUDROPU
      ERHQSTUA $.

    $( Membership in the subspace sum of two Hilbert subspaces.  (Contributed
       by NM, 14-Dec-2004.)  (Revised by Mario Carneiro, 29-Jan-2014.)
       (New usage is discouraged.) $)
    shsel $p |- ( ( A e. SH /\ B e. SH ) -> ( C e. ( A +H B ) <->
                 E. x e. A E. y e. B C = ( x +h y ) ) ) $=
      ( csh wcel wa cph co cva cxp cima cv wceq wrex shsval chil wss shss wb wf
      eleq2d wfn ax-hfvadd ffn ax-mp xpss12 syl2an ovelimab sylancr bitrd ) CFG
      ZDFGZHZECDIJZGEKCDLZMZGZEANBNKJOBDPACPZUOUPURECDQUCUOKRRLZUDZUQVASZUSUTUA
      VARKUBVBUEVARKUFUGUMCRSDRSVCUNCTDTCRDRUHUIABVACDEKUJUKUL $.

    $( Membership in the subspace sum of two Hilbert subspaces, using vector
       subtraction.  (Contributed by NM, 20-Jan-2007.)
       (New usage is discouraged.) $)
    shsel3 $p |- ( ( A e. SH /\ B e. SH ) -> ( C e. ( A +H B ) <->
                 E. x e. A E. y e. B C = ( x -h y ) ) ) $=
      ( vz csh wcel wa co cv cva wceq wrex cmv csm id chil shel syl2an shsel c1
      cph cneg hvaddsubval an4s anassrs sylan9eqr neg1cn shmulcl mp3an2 adantll
      cc oveq2 eqeq2d rspcev sylan syldan ex rexlimdva hvsubval impbid rexbidva
      adantlr bitrd ) CGHZDGHZIZECDUCJHEAKZFKZLJZMZFDNZACNEVIBKZOJZMZBDNZACNAFC
      DEUAVHVMVQACVHVICHZIZVMVQVSVLVQFDVSVJDHZIZVLVQWAVLEVIUBUDZVJPJZOJZMZVQVLW
      AEVKWDVLQVHVRVTVKWDMZVFVRVGVTWFVFVRIZVIRHZVJRHWFVGVTIVICSZVJDSVIVJUETUFUG
      UHWAWCDHZWEVQVHVTWJVRVGVTWJVFVGWBUMHZVTWJUIWBVJDUJUKULVDVPWEBWCDVNWCMVOWD
      EVNWCVIOUNUOUPUQURUSUTVSVPVMBDVSVNDHZIZVPVMWMVPEVIWBVNPJZLJZMZVMVPWMEVOWO
      VPQVHVRWLVOWOMZVFVRVGWLWQWGWHVNRHWQVGWLIWIVNDSVIVNVATUFUGUHWMWNDHZWPVMVHW
      LWRVRVGWLWRVFVGWKWLWRUIWBVNDUJUKULVDVLWPFWNDVJWNMVKWOEVJWNVILUNUOUPUQURUS
      UTVBVCVE $.

    ${
      shscl.1 $e |- A e. SH $.
      shscl.2 $e |- B e. SH $.
      $( Membership in subspace sum.  (Contributed by NM, 4-May-2000.)
         (New usage is discouraged.) $)
      shseli $p |- ( C e. ( A +H B )
                 <-> E. x e. A E. y e. B C = ( x +h y ) ) $=
        ( csh wcel cph co cv cva wceq wrex wb shsel mp2an ) CHIDHIECDJKIEALBLMK
        NBDOACOPFGABCDEQR $.

      $d x y z w f g v u A $.  $d x y z w f g v u B $.
      $( Closure of subspace sum.  (Contributed by NM, 15-Oct-1999.)  (Revised
         by Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
      shscli $p |- ( A +H B ) e. SH $=
        ( vx vy vf vg vv vu co wcel chil c0v wa cv cva csm wceq wrex vz cph csh
        vw wss cc shsss mp2an sh0 ax-mp ax-hv0cl hvaddid2i eqcomi rspceov mp3an
        wral shseli mpbir pm3.2i shaddcl mp3an1 ad2ant2r ad2ant2l sheli anim12i
        wi oveq12 hvadd4 syl2an eqtr4d syl3anc ancoms exp43 rexlimivv com3l imp
        an4s syl2anb sylibr rgen2a shmulcl adantrr adantrl ad2antll ax-hvdistr1
        oveq2 adantl id syl3an 3expb adantrrr eqtrd exp42 impcom rgen2 mpbir2an
        sylan2b issh2 ) ABUBKZUCLWSMUEZNWSLZOEPZFPZQKZWSLZFWSUPEWSUPZXBXCRKZWSL
        ZFWSUPEUFUPZOWTXAAUCLZBUCLZWTCDABUGUHXANXDSFBTEATZNALZNBLZNNNQKZSXLXJXM
        CAUIUJXKXNDBUIUJXONNUKULUMEFABNNNQUNUOEFABNCDUQURUSXFXIXEEFWSXBWSLZXCWS
        LZOXDGPHPQKZSHBTGATZXEXPXBUAPZUDPZQKZSZUDBTUAATZXCIPZJPZQKZSZJBTIATZXSX
        QUAUDABXBCDUQIJABXCCDUQZYDYIXSYCYIXSVFUAUDABYIXTALZYABLZOZYCXSYHYMYCXSV
        FVFIJABYEALZYFBLZOZYHYMYCXSYMYCOZYPYHOZXSYQYROZXTYEQKZALZYAYFQKZBLZXDYT
        UUBQKZSXSYMYPUUAYCYHYKYNUUAYLYOXJYKYNUUACXTYEAUTVAVBVBYMYPUUCYCYHYLYOUU
        CYKYNXKYLYOUUCDYAYFBUTVAVCVBYSXDYBYGQKZUUDYCYHXDUUESYMYPXBYBXCYGQVGVCYM
        YPUUDUUESZYCYHYKYNYLYOUUFYKYNOXTMLZYEMLZOYAMLZYFMLZOUUFYLYOOYKUUGYNUUHX
        TACVDYEACVDZVEYLUUIYOUUJYABDVDYFBDVDZVEXTYEYAYFVHVIVQVBVJGHABYTUUBXDQUN
        VKVLVMVNVOVNVPVRGHABXDCDUQVSVTXHEFUFWSXBUFLZXQOXGXRSHBTGATZXHXQUUMYIUUN
        YJYIUUMUUNYHUUMUUNVFZIJABYNYOYHUUOVFYNYOYHUUMUUNUUMYNYOYHOZOZUUNUUMUUQO
        ZXBYERKZALZXBYFRKZBLZXGUUSUVAQKZSUUNUUMYNUUTUUPXJUUMYNUUTCXBYEAWAVAWBUU
        MUUPUVBYNUUMYOUVBYHXKUUMYOUVBDXBYFBWAVAWBWCUURXGXBYGRKZUVCUUPXGUVDSZUUM
        YNYHUVEYOXCYGXBRWFWGWDUUMYNYOUVDUVCSZYHUUMYNYOUVFUUMUUMYNUUHYOUUJUVFUUM
        WHUUKUULXBYEYFWEWIWJWKWLGHABUUSUVAXGQUNVKVLWMVPVNWNWQGHABXGCDUQVSWOUSEF
        WSWRWP $.
    $}

    $( Closure of subspace sum.  (Contributed by NM, 15-Dec-2004.)
       (New usage is discouraged.) $)
    shscl $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) e. SH ) $=
      ( csh wcel cph co chil cif oveq1 eleq1d oveq2 helsh elimel shscli dedth2h
      wceq ) ACDZBCDZABEFZCDQAGHZBEFZCDTRBGHZEFZCDABGGATPSUACATBEIJBUBPUAUCCBUB
      TEKJTUBAGCLMBGCLMNO $.

    $( Commutative law for subspace sum.  (Contributed by NM, 15-Dec-2004.)
       (New usage is discouraged.) $)
    shscom $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) = ( B +H A ) ) $=
      ( vx vy vz csh wcel wa cph co cv cva wceq wrex chil shel anim12i ax-hvcom
      an4s shsel syl eqeq2d 2rexbidva rexcom syl6bb wb ancoms 3bitr4d eqrdv ) A
      FGZBFGZHZCABIJZBAIJZULCKZDKZEKZLJZMZEBNDANZUOUQUPLJZMZDANEBNZUOUMGUOUNGZU
      LUTVBEBNDANVCULUSVBDEABULUPAGZUQBGZHHZURVAUOVGUPOGZUQOGZHZURVAMUJVEUKVFVJ
      UJVEHVHUKVFHVIUPAPUQBPQSUPUQRUAUBUCVBDEABUDUEDEABUOTUKUJVDVCUFEDBAUOTUGUH
      UI $.

    $( Vector sum belongs to subspace sum.  (Contributed by NM, 15-Dec-2004.)
       (New usage is discouraged.) $)
    shsva $p |- ( ( A e. SH /\ B e. SH ) -> ( ( C e. A /\ D e. B ) ->
                 ( C +h D ) e. ( A +H B ) ) ) $=
      ( vx vy wcel wa cva co cph cv wceq wrex eqid rspceov mp3an3 shsel syl5ibr
      csh ) CAGZDBGZHCDIJZABKJGATGBTGHUCELFLIJMFBNEANZUAUBUCUCMUDUCOEFABCDUCIPQ
      EFABUCRS $.

    $( A subspace sum contains a member of one of its subspaces.  (Contributed
       by NM, 15-Dec-2004.)  (New usage is discouraged.) $)
    shsel1 $p |- ( ( A e. SH /\ B e. SH ) ->
                  ( C e. A -> C e. ( A +H B ) ) ) $=
      ( csh wcel wa cph co c0v cva wceq chil shel ax-hvaddid syl adantlr adantl
      sh0 shsva mpan2d imp eqeltrrd ex ) ADEZBDEZFZCAEZCABGHZEUFUGFCIJHZCUHUDUG
      UICKZUEUDUGFCLEUJCAMCNOPUFUGUIUHEZUFUGIBEZUKUEULUDBRQABCISTUAUBUC $.

    $( A subspace sum contains a member of one of its subspaces.  (Contributed
       by NM, 15-Dec-2004.)  (New usage is discouraged.) $)
    shsel2 $p |- ( ( A e. SH /\ B e. SH ) ->
                 ( C e. B -> C e. ( A +H B ) ) ) $=
      ( csh wcel wa cph co wi shsel1 ancoms shscom eleq2d sylibrd ) ADEZBDEZFZC
      BEZCBAGHZEZCABGHZEPORTIBACJKQUASCABLMN $.

    $( Vector subtraction belongs to subspace sum.  (Contributed by NM,
       15-Dec-2004.)  (New usage is discouraged.) $)
    shsvs $p |- ( ( A e. SH /\ B e. SH ) ->
                ( ( C e. A /\ D e. B ) -> ( C -h D ) e. ( A +H B ) ) ) $=
      ( csh wcel wa cph w3a cmv shscl a1d shsel1 adantrd shsel2 adantld shsubcl
      co 3jcad syl6 ) AEFBEFGZCAFZDBFZGZABHRZEFZCUEFZDUEFZICDJRUEFUAUDUFUGUHUAU
      FUDABKLUAUBUGUCABCMNUAUCUHUBABDOPSCDUEQT $.

    $( Subspace sum is an upper bound of its arguments.  (Contributed by NM,
       14-Dec-2004.)  (New usage is discouraged.) $)
    shsub1 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( A +H B ) ) $=
      ( vx csh wcel wa cph co cv shsel1 ssrdv ) ADEBDEFCAABGHABCIJK $.

    $( Subspace sum is an upper bound of its arguments.  (Contributed by NM,
       17-Dec-2004.)  (New usage is discouraged.) $)
    shsub2 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( B +H A ) ) $=
      ( csh wcel wa cph co shsub1 shscom sseqtrd ) ACDBCDEAABFGBAFGABHABIJ $.

    $( The orthocomplement of the zero subspace is the unit subspace.
       (Contributed by NM, 15-Oct-1999.)  (New usage is discouraged.) $)
    choc0 $p |- ( _|_ ` 0H ) = ~H $=
      ( vx vy c0h cort cfv chil cv wcel csp co cc0 wceq wral wa csh wb wi bitri
      c0v wal h0elsh shocel ax-mp hi02 df-ral elch0 imbi1i albii ax-hv0cl elexi
      oveq2 eqeq1d ceqsalv sylibr abai mpbiran2 eqriv ) ACDEZFAGZURHZUSFHZUSBGZ
      IJZKLZBCMZNZVACOHUTVFPUABUSCUBUCVFVAVAVEQVAUSSIJZKLZVEUSUDVEVBCHZVDQZBTZV
      HVDBCUEVKVBSLZVDQZBTVHVJVMBVIVLVDVBUFUGUHVDVHBSSFUIUJVLVCVGKVBSUSIUKULUMR
      RUNVAVEUOUPRUQ $.

    $( The orthocomplement of the unit subspace is the zero subspace.  Does not
       require Axiom of Choice.  (Contributed by NM, 24-Oct-1999.)
       (New usage is discouraged.) $)
    choc1 $p |- ( _|_ ` ~H ) = 0H $=
      ( vx vy chil cort cfv c0h cv wcel c0v wceq csp co cc0 wral wa helsh ax-mp
      csh wb wss shocel simprbi shocss sseli hial0 syl mpbid elch0 sylibr ssriv
      h0elsh shococss choc0 fveq2i sseqtri eqssi ) CDEZFAUQFAGZUQHZURIJZURFHUSU
      RBGKLMJBCNZUTUSURCHZVACRHZUSVBVAOSPBURCUAQUBUSVBVAUTSUQCURVCUQCTPCUCQUDBU
      RUEUFUGURUHUIUJFFDEZDEZUQFRHFVETUKFULQVDCDUMUNUOUP $.

    ${
      $d x y $.
      $( Orthogonal complement of the empty set.  (Contributed by NM,
         31-Oct-2000.)  (New usage is discouraged.) $)
      chocnul $p |- ( _|_ ` (/) ) = ~H $=
        ( vx vy c0 cort cfv chil cv wcel csp co cc0 wceq wral ral0 wss 0ss ocel
        wa wb ax-mp mpbiran2 eqriv ) ACDEZFAGZUCHZUDFHZUDBGIJKLZBCMZUGBNCFOUEUF
        UHRSFPBUDCQTUAUB $.
    $}

    ${
      shintcl.1 $e |- ( A C_ SH /\ A =/= (/) ) $.
      $( Closure of intersection of a non-empty subset of ` SH ` .
         (Contributed by NM, 14-Oct-1999.)  (New usage is discouraged.) $)
      shintcli $p |- |^| A e. SH $=
        ( vx vy vz csh wcel chil wss c0v wa cv cva co wral csm syl elint2 com12
        cc cint c0 wne simpri wex n0 intss1 simpli sseli shss sstrd sylbi ax-mp
        exlimiv ax-hv0cl elexi sh0 mprgbir pm3.2i elinti shaddcl syl3an1 3expib
        syl2and ralrimiv sylibr rgen2a shmulcl sylan2d rgen2 issh2 mpbir2an
        ovex ) AUAZFGVNHIZJVNGZKCLZDLZMNZVNGZDVNOCVNOZVQVRPNZVNGZDVNOCTOZKVOVPA
        UBUCZVOAFIZWEBUDWEELZAGZEUEVOEAUFWHVOEWHVNWGHWGAUGWHWGFGZWGHIAFWGWFWEBU
        HUIZWGUJQUKUNULUMVPJWGGZEAEJAJHUOUPRWHWIWKWJWGUQQURUSWAWDVTCDVNVQVNGZVR
        VNGZKZVSWGGZEAOVTWNWOEAWHWNWOWHWLVQWGGZWMVRWGGZWOWLWHWPVQAWGUTSWMWHWQVR
        AWGUTSZWHWPWQWOWHWIWPWQWOWJVQVRWGVAVBVCVDSVEEVSAVQVRMVMRVFVGWCCDTVNVQTG
        ZWMKZWBWGGZEAOWCWTXAEAWHWTXAWHWMWQWSXAWRWHWSWQXAWHWIWSWQXAWJVQVRWGVHVBV
        CVISVEEWBAVQVRPVMRVFVJUSCDVNVKVL $.
    $}

    $( The intersection of a non-empty set of subspaces is a subspace.
       (Contributed by NM, 2-Jun-2004.)  (New usage is discouraged.) $)
    shintcl $p |- ( ( A C_ SH /\ A =/= (/) ) -> |^| A e. SH ) $=
      ( csh wss c0 wne cint wcel cif wceq inteq eleq1d sseq1 neeq1 anbi12d ssid
      wa c0h h0elsh ne0i ax-mp pm3.2i elimhyp shintcli dedth ) ABCZADEZPZAFZBGU
      GABHZFZBGABAUIIZUHUJBAUIJKUIUGUIBCZUIDEZPBBCZBDEZPABUKUEULUFUMAUIBLAUIDMN
      BUIIUNULUOUMBUIBLBUIDMNUNUOBOQBGUORBQSTUAUBUCUD $.

    ${
      chintcl.1 $e |- ( A C_ CH /\ A =/= (/) ) $.
      $( The intersection of a non-empty set of closed subspaces is a closed
         subspace.  (Contributed by NM, 14-Oct-1999.)
         (New usage is discouraged.) $)
      chintcli $p |- |^| A e. CH $=
        ( vf vx vy cint cch wcel csh cn cv wf chli wbr wa wi wal wss c0 wral
        simpli chsssh sstri simpri pm3.2i shintcli sseli chlimi 3exp com3r syl5
        wne vex imp ralimdva fint elint2 3imtr4g impcom gen2 isch2 mpbir2an ) A
        FZGHVCIHJVCCKZLZVDDKZMNZOVFVCHZPZDQCQAAIRASULZAGIAGRZVJBUAZUBUCVKVJBUDZ
        UEUFVICDVGVEVHVGJEKZVDLZEATVFVNHZEATVEVHVGVOVPEAVGVNAHZVOVPPZVQVNGHZVGV
        RAGVNVLUGVSVOVGVPVSVOVGVPVFVDVNDUMZUHUIUJUKUNUOEJAVDVMUPEVFAVTUQURUSUTD
        CVCVAVB $.
    $}

    $( The intersection (infimum) of a non-empty subset of ` CH ` belongs to
       ` CH ` .  Part of Theorem 3.13 of [Beran] p. 108.  Also part of
       Definition 3.4-1 in [MegPav2000] p. 2345 (PDF p. 8).  (Contributed by
       NM, 14-Oct-1999.)  (New usage is discouraged.) $)
    chintcl $p |- ( ( A C_ CH /\ A =/= (/) ) -> |^| A e. CH ) $=
      ( cch wss c0 wne cint wcel cif wceq inteq eleq1d sseq1 neeq1 anbi12d ssid
      wa c0h h0elch ne0i ax-mp pm3.2i elimhyp chintcli dedth ) ABCZADEZPZAFZBGU
      GABHZFZBGABAUIIZUHUJBAUIJKUIUGUIBCZUIDEZPBBCZBDEZPABUKUEULUFUMAUIBLAUIDMN
      BUIIUNULUOUMBUIBLBUIDMNUNUOBOQBGUORBQSTUAUBUCUD $.

    $( Value of the linear span of a subset of Hilbert space.  The span is the
       intersection of all subspaces constraining the subset.  Definition of
       span in [Schechter] p. 276.  (Contributed by NM, 2-Jun-2004.)  (Revised
       by Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    spanval $p |- ( A C_ ~H -> ( span ` A ) = |^| { x e. SH | A C_ x } ) $=
      ( vy chil wss cpw wcel csh crab cint cvv cspn wceq ax-hilex elpw2 biimpri
      cv cfv wrex helsh sseq2 rspcev mpan intexrab sylib rabbidv inteqd df-span
      sseq1 fvmptg syl2anc ) BDEZBDFZGZBAQZEZAHIZJZKGZBLRURMUNULBDNOPULUPAHSZUS
      DHGULUTTUPULADHUODBUAUBUCUPAHUDUECBCQZUOEZAHIZJURUMKLVABMZVCUQVDVBUPAHVAB
      UOUIUFUGCAUHUJUK $.

    $( Value of supremum of set of subsets of Hilbert space.  For an alternate
       version of the value, see ~ hsupval2 .  (Contributed by NM,
       9-Dec-2003.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    hsupval $p |- ( A C_ ~P ~H -> ( \/H ` A ) = ( _|_ ` ( _|_ ` U. A ) ) ) $=
      ( vx chil cpw wss wcel chsup cfv cuni cort wceq ax-hilex pwex elpw2 unieq
      cv fveq2d df-chsup fvex fvmpt sylbir ) ACDZEAUBDZFAGHAIZJHZJHZKAUBCLMNBAB
      PZIZJHZJHUFUCGUGAKZUIUEJUJUHUDJUGAOQQBRUEJSTUA $.

    $( The value of the supremum of a set of closed subspaces of Hilbert
       space.  For an alternate version of the value, see ~ chsupval2 .
       (Contributed by NM, 13-Aug-2002.)  (New usage is discouraged.) $)
    chsupval $p |- ( A C_ CH -> ( \/H ` A ) = ( _|_ ` ( _|_ ` U. A ) ) ) $=
      ( cch wss chil cpw chsup cfv cuni cort wceq chsspwh sstr2 mpi hsupval syl
      ) ABCZADEZCZAFGAHIGIGJPBQCRKABQLMANO $.

    $( The span of a subset of Hilbert space is a subspace.  (Contributed by
       NM, 2-Jun-2004.)  (New usage is discouraged.) $)
    spancl $p |- ( A C_ ~H -> ( span ` A ) e. SH ) $=
      ( vx chil wss cspn cfv cv csh crab cint spanval c0 wcel ssrab2 wrex helsh
      wne sseq2 rspcev mpan rabn0 sylibr shintcl sylancr eqeltrd ) ACDZAEFABGZD
      ZBHIZJZHBAKUFUIHDUILQZUJHMUHBHNUFUHBHOZUKCHMUFULPUHUFBCHUGCARSTUHBHUAUBUI
      UCUDUE $.

    $( A member of a span is a vector.  (Contributed by NM, 17-Dec-2004.)
       (New usage is discouraged.) $)
    elspancl $p |- ( ( A C_ ~H /\ B e. ( span ` A ) ) -> B e. ~H ) $=
      ( chil wss cspn cfv csh wcel spancl shel sylan ) ACDAEFZGHBLHBCHAIBLJK $.

    $( Closure of the subspace supremum of set of subsets of Hilbert space.
       (Contributed by NM, 26-Nov-2004.)  (New usage is discouraged.) $)
    shsupcl $p |- ( A C_ ~P ~H -> ( span ` U. A ) e. SH ) $=
      ( chil cpw wss cuni cspn cfv csh wcel uniss unipw syl6sseq spancl syl ) A
      BCZDZAEZBDQFGHIPQOEBAOJBKLQMN $.

    $( Closure of supremum of set of subsets of Hilbert space.  Note that the
       supremum belongs to ` CH ` even if the subsets do not.  (Contributed by
       NM, 10-Nov-1999.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    hsupcl $p |- ( A C_ ~P ~H -> ( \/H ` A ) e. CH ) $=
      ( chil cpw wss chsup cfv cuni cort cch hsupval wcel sspwuni ocss occl syl
      sylbi eqeltrd ) ABCDZAEFAGZHFZHFZIAJRSBDZUAIKZABLUBTBDUCSMTNOPQ $.

    $( Closure of supremum of subset of ` CH ` .  Definition of supremum in
       Proposition 1 of [Kalmbach] p. 65.  Shows that ` CH ` is a complete
       lattice.  Also part of Definition 3.4-1 in [MegPav2000] p. 2345 (PDF
       p. 8).  (Contributed by NM, 10-Nov-1999.)
       (New usage is discouraged.) $)
    chsupcl $p |- ( A C_ CH -> ( \/H ` A ) e. CH ) $=
      ( cch wss chil cpw chsup cfv wcel chsspwh sstr2 mpi hsupcl syl ) ABCZADEZ
      CZAFGBHNBOCPIABOJKALM $.

    $( Subset relation for supremum of Hilbert space subsets.  (Contributed by
       NM, 24-Nov-2004.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    hsupss $p |- ( ( A C_ ~P ~H /\ B C_ ~P ~H ) ->
                  ( A C_ B -> ( \/H ` A ) C_ ( \/H ` B ) ) ) $=
      ( chil cpw wss cuni cort cfv chsup uniss sspwuni occon2 syl2anb syl5 wceq
      wa wi hsupval adantr adantl sseq12d sylibrd ) ACDZEZBUCEZPZABEZAFZGHGHZBF
      ZGHGHZEZAIHZBIHZEUGUHUJEZUFULABJUDUHCEUJCEUOULQUEACKBCKUHUJLMNUFUMUIUNUKU
      DUMUIOUEARSUEUNUKOUDBRTUAUB $.

    $( Subset relation for supremum of subset of ` CH ` .  (Contributed by NM,
       13-Aug-2002.)  (New usage is discouraged.) $)
    chsupss $p |- ( ( A C_ CH /\ B C_ CH ) ->
                  ( A C_ B -> ( \/H ` A ) C_ ( \/H ` B ) ) ) $=
      ( cch wss chil cpw chsup cfv wi chsspwh sstr2 mpi hsupss syl2an ) ACDZAEF
      ZDZBPDZABDAGHBGHDIBCDZOCPDZQJACPKLSTRJBCPKLABMN $.

    $( The union of a set of Hilbert space subsets is smaller than its
       supremum.  (Contributed by NM, 24-Nov-2004.)  (Revised by Mario
       Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    hsupunss $p |- ( A C_ ~P ~H -> U. A C_ ( \/H ` A ) ) $=
      ( chil cpw wss cuni cort cfv chsup sspwuni ococss sylbi hsupval sseqtr4d
      ) ABCDZAEZOFGFGZAHGNOBDOPDABIOJKALM $.

    $( The union of a set of closed subspaces is smaller than its supremum.
       (Contributed by NM, 14-Aug-2002.)  (New usage is discouraged.) $)
    chsupunss $p |- ( A C_ CH -> U. A C_ ( \/H ` A ) ) $=
      ( cch wss chil cpw cuni chsup cfv chsspwh sstr mpan2 hsupunss syl ) ABCZA
      DEZCZAFAGHCNBOCPIABOJKALM $.

    $( A subset of Hilbert space is included in its span.  (Contributed by NM,
       2-Jun-2004.)  (New usage is discouraged.) $)
    spanss2 $p |- ( A C_ ~H -> A C_ ( span ` A ) ) $=
      ( vx chil wss cv csh crab cint cspn cfv ssintub spanval syl5sseqr ) ACDAB
      EDBFGHAAIJBAFKBALM $.

    $( The union of a set of subspaces is smaller than its supremum.
       (Contributed by NM, 26-Nov-2004.)  (New usage is discouraged.) $)
    shsupunss $p |- ( A C_ SH -> U. A C_ ( span ` U. A ) ) $=
      ( csh wss cuni chil cspn cfv cpw shsspwh sstr mpan2 unissd unipw syl6sseq
      spanss2 syl ) ABCZADZECRRFGCQREHZDEQASQBSCASCIABSJKLEMNROP $.

    $( A subspace of Hilbert space is its own span.  (Contributed by NM,
       2-Jun-2004.)  (New usage is discouraged.) $)
    spanid $p |- ( A e. SH -> ( span ` A ) = A ) $=
      ( vx csh wcel cspn cfv cv wss crab cint chil wceq shss spanval syl intmin
      eqtrd ) ACDZAEFZABGHBCIJZARAKHSTLAMBANOBACPQ $.

    $( Ordering relationship for the spans of subsets of Hilbert space.
       (Contributed by NM, 2-Jun-2004.)  (New usage is discouraged.) $)
    spanss $p |- ( ( B C_ ~H /\ A C_ B ) -> ( span ` A ) C_ ( span ` B ) ) $=
      ( vx chil wss wa cv csh crab cint cspn cfv wi wral sstr2 ralrimivw ss2rab
      syl wceq spanval sylibr intss adantl sstr ancoms adantr 3sstr4d ) BDEZABE
      ZFZACGZEZCHIZJZBUKEZCHIZJZAKLZBKLZUIUNUQEZUHUIUPUMEZUTUIUOULMZCHNVAUIVBCH
      ABUKOPUOULCHQUAUPUMUBRUCUJADEZURUNSUIUHVCABDUDUECATRUHUSUQSUICBTUFUG $.

    $( The span of a subset of Hilbert space is less than or equal to its
       closure (double orthogonal complement).  (Contributed by NM,
       3-Jun-2004.)  (New usage is discouraged.) $)
    spanssoc $p |- ( A C_ ~H -> ( span ` A ) C_ ( _|_ ` ( _|_ ` A ) ) ) $=
      ( chil wss cspn cfv cort ocss ococss spanss syl2anc wcel wceq ocsh spanid
      syl csh 3syl sseqtrd ) ABCZADEZAFEZFEZDEZUBSUBBCZAUBCTUCCSUABCZUDAGZUAGOA
      HAUBIJSUEUBPKUCUBLUFUAMUBNQR $.

    $( Value of join for subsets of Hilbert space.  (Contributed by NM,
       1-Nov-2000.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    sshjval $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) =
        ( _|_ ` ( _|_ ` ( A u. B ) ) ) ) $=
      ( vx vy chil wss cpw wcel chj co cun cort cfv ax-hilex elpw2 cv wa uneq12
      wceq fveq2d df-chj fvex ovmpt2a syl2anbr ) AEFAEGZHBUEHABIJABKZLMZLMZSBEF
      AENOBENOCDABUEUECPZDPZKZLMZLMUHIUIASUJBSQZULUGLUMUKUFLUIAUJBRTTCDUAUGLUBU
      CUD $.

    $( Value of join in ` SH ` .  (Contributed by NM, 9-Aug-2000.)
       (New usage is discouraged.) $)
    shjval $p |- ( ( A e. SH /\ B e. SH ) -> ( A vH B ) =
        ( _|_ ` ( _|_ ` ( A u. B ) ) ) ) $=
      ( csh wcel chil wss chj co cun cort cfv wceq shss sshjval syl2an ) ACDAEF
      BEFABGHABIJKJKLBCDAMBMABNO $.

    $( Value of join in ` CH ` .  (Contributed by NM, 9-Aug-2000.)
       (New usage is discouraged.) $)
    chjval $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH B ) =
        ( _|_ ` ( _|_ ` ( A u. B ) ) ) ) $=
      ( cch wcel csh chj co cun cort cfv wceq chsh shjval syl2an ) ACDAEDBEDABF
      GABHIJIJKBCDALBLABMN $.

    ${
      chjval.1 $e |- A e. CH $.
      chjval.2 $e |- B e. CH $.
      $( Value of join in ` CH ` .  (Contributed by NM, 9-Aug-2000.)
         (New usage is discouraged.) $)
      chjvali $p |- ( A vH B ) = ( _|_ ` ( _|_ ` ( A u. B ) ) ) $=
        ( cch wcel chj co cun cort cfv wceq chjval mp2an ) AEFBEFABGHABIJKJKLCD
        ABMN $.
    $}

    $( Value of join for subsets of Hilbert space in terms of supremum: the
       join is the supremum of its two arguments.  Based on the definition of
       join in [Beran] p. 3.  For later convenience we prove a general version
       that works for any subset of Hilbert space, not just the elements of the
       lattice ` CH ` .  (Contributed by NM, 2-Mar-2004.)  (Revised by Mario
       Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    sshjval3 $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) =
                          ( \/H ` { A , B } ) ) $=
      ( chil wss wa cpr cuni cort cfv cun chsup chj co wcel wceq ax-hilex elpw2
      cpw syl2anbr fveq2d uniprg prssi hsupval syl sshjval 3eqtr4rd ) ACDZBCDZE
      ZABFZGZHIZHIZABJZHIZHIUJKIZABLMUIULUOHUIUKUNHUGACRZNZBUQNZUKUNOUHACPQZBCP
      QZABUQUQUASTTUIUJUQDZUPUMOUGURUSVBUHUTVAABUQUBSUJUCUDABUEUF $.

    $( Closure of join for subsets of Hilbert space.  (Contributed by NM,
       1-Nov-2000.)  (New usage is discouraged.) $)
    sshjcl $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) e. CH ) $=
      ( chil wss wa chj co cun cort cfv cch sshjval wcel unss ocss occl eqeltrd
      syl sylbi ) ACDBCDEZABFGABHZIJZIJZKABLTUACDZUCKMZABCNUDUBCDUEUAOUBPRSQ $.

    $( Closure of join in ` SH ` .  (Contributed by NM, 2-Nov-1999.)
       (New usage is discouraged.) $)
    shjcl $p |- ( ( A e. SH /\ B e. SH ) -> ( A vH B ) e. CH ) $=
      ( csh wcel chil wss chj co cch shss sshjcl syl2an ) ACDAEFBEFABGHIDBCDAJB
      JABKL $.

    $( Closure of join in ` CH ` .  (Contributed by NM, 2-Nov-1999.)
       (New usage is discouraged.) $)
    chjcl $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH B ) e. CH ) $=
      ( cch wcel csh chj co chsh shjcl syl2an ) ACDAEDBEDABFGCDBCDAHBHABIJ $.

    $( Commutative law for Hilbert lattice join of subspaces.  (Contributed by
       NM, 22-Jun-2004.)  (New usage is discouraged.) $)
    shjcom $p |- ( ( A e. SH /\ B e. SH ) -> ( A vH B ) = ( B vH A ) ) $=
      ( csh wcel wa chj co cun cort cfv shjval wceq ancoms fveq2i syl6eq eqtr4d
      uncom ) ACDZBCDZEZABFGABHZIJZIJZBAFGZABKTUDBAHZIJZIJZUCSRUDUGLBAKMUFUBIUE
      UAIBAQNNOP $.

    $( Subset implies subset of subspace sum.  (Contributed by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    shless $p |- ( ( ( A e. SH /\ B e. SH /\ C e. SH ) /\ A C_ B ) ->
                   ( A +H C ) C_ ( B +H C ) ) $=
      ( vx vy vz csh wcel w3a wss wa cph co cv cva wceq wrex wb shsel syl2anc
      wi ssrexv adantl simpl1 simpl3 simpl2 3imtr4d ssrdv ) AGHZBGHZCGHZIZABJZK
      ZDACLMZBCLMZUNDNZENFNOMPFCQZEAQZUREBQZUQUOHZUQUPHZUMUSUTUAULUREABUBUCUNUI
      UKVAUSRUIUJUKUMUDUIUJUKUMUEZEFACUQSTUNUJUKVBUTRUIUJUKUMUFVCEFBCUQSTUGUH
      $.

    $( Add disjunct to both sides of Hilbert subspace ordering.  (Contributed
       by NM, 22-Jun-2004.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    shlej1 $p |- ( ( ( A e. SH /\ B e. SH /\ C e. SH ) /\
                 A C_ B ) -> ( A vH C ) C_ ( B vH C ) ) $=
      ( csh wcel w3a wss wa cun cort cfv chj chil shss syl unssd syl2anc shjval
      co wceq simpr unss1 wi simpl1 simpl3 simpl2 occon2 syl5 mpd 3sstr4d ) ADE
      ZBDEZCDEZFZABGZHZACIZJKJKZBCIZJKJKZACLSZBCLSZUPUOURUTGZUNUOUAUOUQUSGZUPVC
      ABCUBUPUQMGUSMGVDVCUCUPACMUPUKAMGUKULUMUOUDZANOUPUMCMGUKULUMUOUEZCNOZPUPB
      CMUPULBMGUKULUMUOUFZBNOVGPUQUSUGQUHUIUPUKUMVAURTVEVFACRQUPULUMVBUTTVHVFBC
      RQUJ $.

    $( Add disjunct to both sides of Hilbert subspace ordering.  (Contributed
       by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
    shlej2 $p |- ( ( ( A e. SH /\ B e. SH /\ C e. SH ) /\
                 A C_ B ) -> ( C vH A ) C_ ( C vH B ) ) $=
      ( csh wcel w3a wss wa chj co shlej1 shjcom 3adant2 adantr 3adant1 3sstr3d
      wceq ) ADEZBDEZCDEZFZABGZHACIJZBCIJZCAIJZCBIJZABCKUAUCUEQZUBRTUGSACLMNUAU
      DUFQZUBSTUHRBCLONP $.

    shincl.1 $e |- A e. SH $.
    shincl.2 $e |- B e. SH $.
    $( Closure of intersection of two subspaces.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    shincli $p |- ( A i^i B ) e. SH $=
      ( cpr cint cin csh elexi intpr wss c0 wne wcel wa prss mpbi prnz shintcli
      pm3.2i eqeltrri ) ABEZFABGHABAHCIZBHDIZJUBUBHKZUBLMAHNZBHNZOUEUFUGCDTABHU
      CUDPQABUCRTSUA $.

    $( Commutative law for subspace sum.  (Contributed by NM, 17-Oct-1999.)
       (New usage is discouraged.) $)
    shscomi $p |- ( A +H B ) = ( B +H A ) $=
      ( csh wcel cph co wceq shscom mp2an ) AEFBEFABGHBAGHICDABJK $.

    $( Vector sum belongs to subspace sum.  (Contributed by NM, 17-Oct-1999.)
       (New usage is discouraged.) $)
    shsvai $p |- ( ( C e. A /\ D e. B ) -> ( C +h D ) e. ( A +H B ) ) $=
      ( csh wcel wa cva co cph wi shsva mp2an ) AGHBGHCAHDBHICDJKABLKHMEFABCDNO
      $.

    $( A subspace sum contains a member of one of its subspaces.  (Contributed
       by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
    shsel1i $p |- ( C e. A -> C e. ( A +H B ) ) $=
      ( csh wcel cph co wi shsel1 mp2an ) AFGBFGCAGCABHIGJDEABCKL $.

    $( A subspace sum contains a member of one of its subspaces.  (Contributed
       by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
    shsel2i $p |- ( C e. B -> C e. ( A +H B ) ) $=
      ( csh wcel cph co wi shsel2 mp2an ) AFGBFGCBGCABHIGJDEABCKL $.

    $( Vector subtraction belongs to subspace sum.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    shsvsi $p |- ( ( C e. A /\ D e. B ) -> ( C -h D ) e. ( A +H B ) ) $=
      ( csh wcel wa cmv co cph wi shsvs mp2an ) AGHBGHCAHDBHICDJKABLKHMEFABCDNO
      $.

    $( Union is smaller than subspace sum.  (Contributed by NM, 18-Oct-1999.)
       (New usage is discouraged.) $)
    shunssi $p |- ( A u. B ) C_ ( A +H B ) $=
      ( vx vy vz co cv wcel cva wceq wrex c0v sheli eqcomd syl csh sh0 ax-mp wo
      cun chil ax-hvaddid rspceov mp3an2 mpdan hvaddid2 mp3an1 jaoi elun shseli
      cph 3imtr4i ssriv ) EABUBZABUMHZEIZAJZURBJZUAURFIGIKHLGBMFAMZURUPJURUQJUS
      VAUTUSURURNKHZLZVAUSURUCJZVCURACOVDVBURURUDPQUSNBJZVCVABRJVEDBSTFGABURNUR
      KUEUFUGUTURNURKHZLZVAUTVDVGURBDOVDVFURURUHPQNAJZUTVGVAARJVHCASTFGABNURURK
      UEUIUGUJURABUKFGABURCDULUNUO $.

    $( Union is smaller than Hilbert lattice join.  (Contributed by NM,
       11-Jun-2004.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    shunssji $p |- ( A u. B ) C_ ( A vH B ) $=
      ( cun cort cfv chj co chil wss shssii unssi ococss ax-mp wcel wceq shjval
      csh mp2an sseqtr4i ) ABEZUBFGFGZABHIZUBJKUBUCKABJACLBDLMUBNOASPBSPUDUCQCD
      ABRTUA $.

    $( Subspace sum is smaller than Hilbert lattice join.  Remark in [Kalmbach]
       p. 65.  (Contributed by NM, 19-Oct-1999.)  (Revised by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    shsleji $p |- ( A +H B ) C_ ( A vH B ) $=
      ( vx vy vz cph co chj cv wcel cva wceq wrex shseli wa sstri sseli csh cun
      wi ssun1 shunssji ssun2 cch shjcl chshii shaddcl mp3an1 syl2an eleq1a syl
      mp2an rexlimivv sylbi ssriv ) EABHIZABJIZEKZURLUTFKZGKZMIZNZGBOFAOUTUSLZF
      GABUTCDPVDVEFGABVAALZVBBLZQVCUSLZVDVEUBVFVAUSLZVBUSLZVHVGAUSVAAABUAZUSABU
      CABCDUDZRSBUSVBBVKUSBAUEVLRSUSTLVIVJVHUSATLBTLUSUFLCDABUGUNUHVAVBUSUIUJUK
      VCUSUTULUMUOUPUQ $.

    $( Commutative law for join in ` SH ` .  (Contributed by NM, 19-Oct-1999.)
       (New usage is discouraged.) $)
    shjcomi $p |- ( A vH B ) = ( B vH A ) $=
      ( csh wcel chj co wceq shjcom mp2an ) AEFBEFABGHBAGHICDABJK $.

    $( Subspace sum is an upper bound of its arguments.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    shsub1i $p |- A C_ ( A +H B ) $=
      ( vx cph co cv shsel1i ssriv ) EAABFGABEHCDIJ $.

    $( Subspace sum is an upper bound of its arguments.  (Contributed by NM,
       17-Dec-2004.)  (New usage is discouraged.) $)
    shsub2i $p |- A C_ ( B +H A ) $=
      ( vx cph co cv shsel2i ssriv ) EABAFGBAEHDCIJ $.

    $( Hilbert lattice join is an upper bound of two subspaces.  (Contributed
       by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
    shub1i $p |- A C_ ( A vH B ) $=
      ( cph co chj shsub1i shsleji sstri ) AABEFABGFABCDHABCDIJ $.

    $( Closure of ` CH ` join.  (Contributed by NM, 19-Oct-1999.)
       (New usage is discouraged.) $)
    shjcli $p |- ( A vH B ) e. CH $=
      ( csh wcel chj co cch shjcl mp2an ) AEFBEFABGHIFCDABJK $.

    $( ` SH ` closure of join.  (Contributed by NM, 5-May-2000.)
       (New usage is discouraged.) $)
    shjshcli $p |- ( A vH B ) e. SH $=
      ( chj co shjcli chshii ) ABEFABCDGH $.

    shless.1 $e |- C e. SH $.
    $( Subset implies subset of subspace sum.  (Contributed by NM,
       18-Nov-2000.)  (New usage is discouraged.) $)
    shlessi $p |- ( A C_ B -> ( A +H C ) C_ ( B +H C ) ) $=
      ( csh wcel wss cph co wi w3a shless ex mp3an ) AGHZBGHZCGHZABIZACJKBCJKIZ
      LDEFQRSMTUAABCNOP $.

    $( Add disjunct to both sides of Hilbert subspace ordering.  (Contributed
       by NM, 19-Oct-1999.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    shlej1i $p |- ( A C_ B -> ( A vH C ) C_ ( B vH C ) ) $=
      ( csh wcel wss chj co wi w3a shlej1 ex mp3an ) AGHZBGHZCGHZABIZACJKBCJKIZ
      LDEFQRSMTUAABCNOP $.

    $( Add disjunct to both sides of Hilbert subspace ordering.  (Contributed
       by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
    shlej2i $p |- ( A C_ B -> ( C vH A ) C_ ( C vH B ) ) $=
      ( wss chj co shlej1i shjcomi 3sstr4g ) ABGACHIBCHICAHICBHIABCDEFJCAFDKCBF
      EKL $.
  $}

  $( Subspace sum is smaller than subspace join.  Remark in [Kalmbach] p. 65.
     (Contributed by NM, 12-Jul-2004.)  (New usage is discouraged.) $)
  shslej $p |- ( ( A e. SH /\ B e. SH ) -> ( A +H B ) C_ ( A vH B ) ) $=
    ( csh wcel cph co chj wss chil cif oveq1 sseq12d oveq2 helsh elimel shsleji
    wceq dedth2h ) ACDZBCDZABEFZABGFZHSAIJZBEFZUCBGFZHUCTBIJZEFZUCUFGFZHABIIAUC
    QUAUDUBUEAUCBEKAUCBGKLBUFQUDUGUEUHBUFUCEMBUFUCGMLUCUFAICNOBICNOPR $.

  $( Closure of intersection of two subspaces.  (Contributed by NM,
     24-Jun-2004.)  (New usage is discouraged.) $)
  shincl $p |- ( ( A e. SH /\ B e. SH ) -> ( A i^i B ) e. SH ) $=
    ( csh wcel cin chil wceq ineq1 eleq1d ineq2 helsh elimel shincli dedth2h
    cif ) ACDZBCDZABEZCDPAFOZBEZCDSQBFOZEZCDABFFASGRTCASBHIBUAGTUBCBUASJISUAAFC
    KLBFCKLMN $.

  $( Hilbert lattice join is an upper bound of two subspaces.  (Contributed by
     NM, 22-Jun-2004.)  (New usage is discouraged.) $)
  shub1 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( A vH B ) ) $=
    ( csh wcel wa cph co chj shsub1 shslej sstrd ) ACDBCDEAABFGABHGABIABJK $.

  $( A subspace is a subset of its Hilbert lattice join with another.
     (Contributed by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
  shub2 $p |- ( ( A e. SH /\ B e. SH ) -> A C_ ( B vH A ) ) $=
    ( csh wcel wa chj co shub1 shjcom sseqtrd ) ACDBCDEAABFGBAFGABHABIJ $.

  ${
    $d x y z A $.
    shsidm.1 $e |- A e. SH $.
    $( Idempotent law for Hilbert subspace sum.  (Contributed by NM,
       6-Jun-2004.)  (New usage is discouraged.) $)
    shsidmi $p |- ( A +H A ) = A $=
      ( vx vy vz cph co wcel cva wceq wrex shseli csh shaddcl mp3an1 syl5ibrcom
      cv wa eleq1 rexlimivv sylbi ssriv shsub1i eqssi ) AAFGZACUEACQZUEHUFDQZEQ
      ZIGZJZEAKDAKUFAHZDEAAUFBBLUJUKDEAAUGAHZUHAHZRUKUJUIAHZAMHULUMUNBUGUHANOUF
      UIASPTUAUBAABBUCUD $.
  $}

  ${
    shslub.1 $e |- A e. SH $.
    shslub.2 $e |- B e. SH $.
    shslub.3 $e |- C e. SH $.
    $( The least upper bound law for Hilbert subspace sum.  (Contributed by NM,
       15-Jun-2004.)  (New usage is discouraged.) $)
    shslubi $p |- ( ( A C_ C /\ B C_ C ) <-> ( A +H B ) C_ C ) $=
      ( wss wa cph co shlessi shscomi syl6sseq shsidmi sylan9ss shsub1i shsub2i
      sstr mpan jca impbii ) ACGZBCGZHABIJZCGZUBUCUDBCIJZCUBUDCBIJUFACBDFEKCBFE
      LMUCUFCCIJCBCCEFFKCFNMOUEUBUCAUDGUEUBABDEPAUDCRSBUDGUEUCBAEDQBUDCRSTUA $.
  $}

  ${
    $d x A $.  $d x B $.
    shlesb1.1 $e |- A e. SH $.
    shlesb1.2 $e |- B e. SH $.
    $( Hilbert lattice ordering in terms of subspace sum.  (Contributed by NM,
       23-Nov-2004.)  (New usage is discouraged.) $)
    shlesb1i $p |- ( A C_ B <-> ( A +H B ) = B ) $=
      ( wss cph wceq ssid biantrur shslubi shsub2i eqss mpbiran2 shscomi sseq1i
      wa co bitr2i 3bitri ) ABEZBBEZTPBAFQZBEZABFQZBGZUATBHIBABDCDJUEUDBEZUCUEU
      FBUDEBADCKUDBLMUDUBBABCDNORS $.

    $( An alternate way to express subspace sum.  (Contributed by NM,
       25-Nov-2004.)  (New usage is discouraged.) $)
    shsval2i $p |- ( A +H B ) = |^| { x e. SH | ( A u. B ) C_ x } $=
      ( cph co cun cv wss csh crab cint wa ssun1 ssintub sstri ssun2 wcel mp2an
      pm3.2i c0 wne ssrab2 wrex shscli shunssi sseq2 rspcev rabn0 mpbir shintcl
      shslubi mpbi elrab mpbir2an intss1 ax-mp eqssi ) BCFGZBCHZAIZJZAKLZMZBVEJ
      ZCVEJZNUTVEJVFVGBVAVEBCOAVAKPZQCVAVECBRVHQUABCVEDEVDKJVDUBUCZVEKSVCAKUDVI
      VCAKUEZUTKSZVAUTJZVJBCDEUFZBCDEUGZVCVLAUTKVBUTVAUHZUITVCAKUJUKVDULTUMUNUT
      VDSZVEUTJVPVKVLVMVNVCVLAUTKVOUOUPUTVDUQURUS $.

    $( An alternate way to express subspace sum.  (Contributed by NM,
       25-Nov-2004.)  (New usage is discouraged.) $)
    shsval3i $p |- ( A +H B ) = ( span ` ( A u. B ) ) $=
      ( vx cph co cun cv wss csh crab cint cspn shsval2i chil wceq shssii unssi
      cfv spanval ax-mp eqtr4i ) ABFGABHZEIJEKLMZUDNTZEABCDOUDPJUFUEQABPACRBDRS
      EUDUAUBUC $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    shmod.1 $e |- A e. SH $.
    shmod.2 $e |- B e. SH $.
    shmod.3 $e |- C e. SH $.
    $( The modular law holds for subspace sum.  Similar to part of Theorem 16.9
       of [MaedaMaeda] p. 70.  (Contributed by NM, 23-Nov-2004.)
       (New usage is discouraged.) $)
    shmodsi $p |- ( A C_ C -> ( ( A +H B ) i^i C ) C_ ( A +H ( B i^i C ) ) ) $=
      ( vz vx vy cph co cin cv wcel wa elin wceq wi chil sheli wss cva wrex cmv
      shseli wb w3a hvsubadd syl3an eqcom syl6bb 3expb shsvsi syl6eleq shlesb1i
      shscomi biimpi eleq2d syl5ib eleq1 biimpd sylan9 anim2d syl6ibr ex ancoms
      com13 anasss sylbird imp shincli shsvai syl5ibr exp3a com12 ad2antrl syld
      exp31 rexlimdvv syl5bi imp3a ssrdv ) ACUAZGABJKZCLZABCLZJKZGMZWENWHWDNZWH
      CNZOWCWHWGNZWHWDCPWCWIWJWKWJWIWCWKWIWHHMZIMZUBKZQZIBUCHAUCWJWCWKRZHIABWHD
      EUEWJWOWPHIABWJWLANZWMBNZOZWOWPWJWSOZWOOWCWMWFNZWKWTWOWCXARZWTWOWHWLUDKZW
      MQZXBWJWQWRXDWOUFWJWQWRUGXDWNWHQZWOWJWHSNWQWLSNWRWMSNXDXEUFWHCFTWLADTWMBE
      TWHWLWMUHUIWNWHUJUKULWJWQWRXDXBRZWRWJWQOZXFWCXDWRXGOZXAWCXDXHXARWCXDOZXHW
      RWMCNZOXAXIXGXJWRWCXGXCCNZXDXJXGXCACJKZNWCXKXGXCCAJKXLCAWHWLFDUMCAFDUPUNW
      CXLCXCWCXLCQACDFUOUQURUSXDXKXJXCWMCUTVAVBVCWMBCPVDVEVGVFVHVIVJWTWOXAWKRZW
      QWOXMRWJWRWOWQXMWOWQXAWKWQXAOWKWOWNWGNAWFWLWMDBCEFVKVLWHWNWGUTVMVNVOVPVJV
      QVRVSVTVGWAVTWB $.

    $( The modular law is implied by the closure of subspace sum.  Part of
       proof of Theorem 16.9 of [MaedaMaeda] p. 70.  (Contributed by NM,
       23-Nov-2004.)  (New usage is discouraged.) $)
    shmodi $p |- ( ( ( A +H B ) = ( A vH B ) /\ A C_ C ) ->
                ( ( A vH B ) i^i C ) C_ ( A vH ( B i^i C ) ) ) $=
      ( cph co chj wceq wss cin shmodsi ineq1 sseq1d syl5ib imp shincli shsleji
      wa syl6ss ) ABGHZABIHZJZACKZTUCCLZABCLZGHZAUGIHUDUEUFUHKZUEUBCLZUHKUDUIAB
      CDEFMUDUJUFUHUBUCCNOPQAUGDBCEFRSUA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projection theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z A $.  $d x B $.  $d x C $.  $d w x y z H $.  $d x T $.
    pjhth.1 $e |- H e. CH $.
    pjhth.2 $e |- ( ph -> A e. ~H ) $.
    ${
      pjhth.3 $e |- ( ph -> B e. H ) $.
      pjhth.4 $e |- ( ph -> C e. H ) $.
      pjhth.5 $e |- ( ph -> A. x e. H ( normh ` ( A -h B ) ) <_
                     ( normh ` ( A -h x ) ) ) $.
      pjhth.6 $e |- T = ( ( ( A -h B ) .ih C ) / ( ( C .ih C ) + 1 ) ) $.
      $( Lemma for ~ pjhth .  (Contributed by NM, 10-Oct-1999.)  (Revised by
         Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
      pjhthlem1 $p |- ( ph -> ( ( A -h B ) .ih C ) = 0 ) $=
        ( co wcel cc0 wceq cle cmul cdiv cmv csp chil cheli syl hvsubcl syl2anc
        cc hicl cabs cfv abscld recnd c2 cexp wbr cr caddc clt resqcld renegcld
        cneg hiidrcl 2re readdcl sylancl 0re a1i peano2re hiidge0 ltp1d lelttrd
        c1 ax-1cn addass mp3an23 df-2 oveq2i syl6reqr breqtrrd csm cno cmin cva
        lttrd cv wral csh chshii ge0p1rpd rpne0d divcld shmulcl syl3anc shaddcl
        syl5eqel oveq2 fveq2d breq2d rspcv hvsubass normcl normge0 letrd le2sqd
        sylc mpbid subge0d mpbird crp rpexpcl rerpdivcld remulcld negcld pncand
        cz normsq his2sub his2sub2 oveq1d subcld eqeltrd subsub4d adddid oveq2d
        ccj cjcld mulcomd absvalsqd fveq2i eqtrd syl5eq 3eqtr4rd 3eqtrd oveq12d
        2z div23d wb eqtr3d syl22anc his5 divassd cjdivd sqvald divcan5d eqtr2d
        cjred his35 absdivd rpge0d absidd sqdivd 3eqtr3d pncan2 3eqtr4d negsubd
        hire subdid addcomd 3eqtr2d mulneg2d ge0divd mulneg12 prodge02 le0neg1d
        sqge0d wa letri3 mpbir2and sqeq0d abs00d ) ACDUANZEUBNZAUVLUCOZEUCOZUVM
        UHOACUCOZDUCOZUVNIADGOZUVQJDGHUDUEZCDUFUGZAEGOZUVOKEGHUDUEZUVLEUIUGZAUV
        MUJUKZAUWDAUVMUWCULZUMZAUWDUNUONZPQZUWGPRUPZPUWGRUPZAUWIPUWGVBZRUPZAUWK
        UQOEEUBNZUNURNZUQOZPUWNUSUPPUWKUWNSNZRUPUWLAUWGAUWDUWEUTZVAAUWMUQOZUNUQ
        OUWOAUVOUWRUWBEVCUEZVDUWMUNVEVFZAPUWMVMURNZUWNPUQOZAVGVHZAUWRUXAUQOUWSU
        WMVIUEZUWTAPUWMUXAUXCUWSUXDAUVOPUWMRUPUWBEVJUEZAUWMUWSVKVLAUXAUXAVMURNZ
        UWNUSAUXAUXDVKAUXFUWMVMVMURNZURNZUWNAUWMUHOZUXFUXHQZAUWMUWSUMZUXIVMUHOZ
        UXLUXJVNVNUWMVMVMVOVPUEUNUXGUWMURVQVRVSZVTWEAPUWGUWNVBZSNZUWPRAPUXORUPP
        UXOUXAUNUONZTNZRUPAPUVLFEWANZUANZWBUKZUNUONZUVLWBUKZUNUONZWCNZUXQRAPUYD
        RUPUYCUYARUPZAUYBUXTRUPUYEAUYBCDUXRWDNZUANZWBUKZUXTRAUYFGOZUYBCBWFZUANZ
        WBUKZRUPZBGWGUYBUYHRUPZAGWHOZUVRUXRGOZUYIUYOAGHWIVHZJAUYOFUHOZUWAUYPUYQ
        AFUVMUXATNZUHMAUVMUXAUWCAUXAUXDUMZAUXAAUWMUWSUXEWJZWKZWLWPZKFEGWMWNZDUX
        RGWOWNLUYMUYNBUYFGUYJUYFQZUYLUYHUYBRVUEUYKUYGWBUYJUYFCUAWQWRWSWTXFAUXSU
        YGWBAUVPUVQUXRUCOZUXSUYGQIUVSAUYPVUFVUDUXRGHUDUEZCDUXRXAWNWRVTZAUYBUXTA
        UVNUYBUQOUVTUVLXBUEZAUXSUCOZUXTUQOAUVNVUFVUJUVTVUGUVLUXRUFUGZUXSXBUEZAU
        VNPUYBRUPUVTUVLXCUEZAPUYBUXTUXCVUIVULVUMVUHXDXEXGAUYAUYCAUXTVULUTAUYBVU
        IUTXHXIAUWGUXPTNZUWNSNZVBZUVLUVLUBNZURNZVUQWCNVUPUYDUXQAVUPVUQAVUOAVUOA
        VUNUWNAUWGUXPUWQAUXAXJOUNXPOUXPXJOVUAYPUXAUNXKVFZXLZUWTXMUMZXNZAUVNUVNV
        UQUHOUVTUVTUVLUVLUIUGZXOAUYAVURUYCVUQWCAUYAVUQVUOWCNZVUQVUPURNVURAUYAUX
        SUXSUBNZUVLUXSUBNZUXRUXSUBNZWCNZVVDAVUJUYAVVEQVUKUXSXQUEAUVNVUFVUJVVEVV
        HQUVTVUGVUKUVLUXRUXSXRWNAVVHVUQUVLUXRUBNZWCNZVVGWCNVUQVVIVVGURNZWCNVVDA
        VVFVVJVVGWCAUVNUVNVUFVVFVVJQUVTUVTVUGUVLUVLUXRXSWNXTAVUQVVIVVGVVCAUVNVU
        FVVIUHOUVTVUGUVLUXRUIUGAVVGUXRUVLUBNZUXRUXRUBNZWCNZUHAVUFUVNVUFVVGVVNQV
        UGUVTVUGUXRUVLUXRXSWNZAVVLVVMAVUFUVNVVLUHOVUGUVTUXRUVLUIUGAVUFVUFVVMUHO
        VUGVUGUXRUXRUIUGYAYBYCAVVKVUOVUQWCAVUNUXFSNVUNUXASNZVUNVMSNZURNVUOVVKAV
        UNUXAVMAVUNVUTUMZUYTUXLAVNVHYDAUWNUXFVUNSUXMYEAVVIVVPVVGVVQURAVVIUWGUXA
        TNZUWGUXASNZUXPTNZVVPAVVIFYFUKZUVMSNZUVMVWBSNZVVSAUYRUVNUVOVVIVWCQVUCUV
        TUWBFUVLEUUAWNAVWBUVMAFVUCYGUWCYHAUVMUVMYFUKZSNZUXATNUVMVWEUXATNZSNVVSV
        WDAUVMVWEUXAUWCAUVMUWCYGUYTVUBUUBAUWGVWFUXATAUVMUWCYIXTAVWBVWGUVMSAVWBU
        YSYFUKZVWGFUYSYFMYJAVWHVWEUXAYFUKZTNVWGAUVMUXAUWCUYTVUBUUCAVWIUXAVWETAU
        XAUXDUUGYEYKYLYEYMYNAVWAUXAUWGSNZUXAUXASNZTNVVSAVVTVWJUXPVWKTAUWGUXAAUW
        GUWQUMZUYTYHAUXAUYTUUDYOAUWGUXAUXAVWLUYTUYTVUBVUBUUEUUFAUWGUXAUXPVWLUYT
        AUXPAUXAUXDUTUMZAUXPVUSWKZYQYNZAVVNVVPVUNUWMSNZWCNZVVGVVQAVVLVVPVVMVWPW
        CAVVIVVLVVPAVVIUQOZVVIVVLQZAVVIVVPUQVWOAVUNUXAVUTUXDXMYBAUVNVUFVWRVWSYR
        UVTVUGUVLUXRUUQUGXGVWOYSAVVMFVWBSNZUWMSNZVWPAUYRUYRUVOUVOVVMVXAQVUCVUCU
        WBUWBFFEEUUHYTAVWTVUNUWMSAFUJUKZUNUONUWDUXATNZUNUONVWTVUNAVXBVXCUNUOAVX
        BUYSUJUKZVXCFUYSUJMYJAVXDUWDUXAUJUKZTNVXCAUVMUXAUWCUYTVUBUUIAVXEUXAUWDT
        AUXAUXDAUXAVUAUUJUUKYEYKYLXTAFVUCYIAUWDUXAUWFUYTVUBUULUUMXTYKYOVVOAVUNU
        XAUWMWCNZSNVVQVWQAVXFVMVUNSAUXIUXLVXFVMQUXKVNUWMVMUUNVFYEAVUNUXAUWMVVRU
        YTUXKUURYSUUOYOYMYEYNYNAVUQVUOVVCVVAUUPAVUQVUPVVCVVBUUSUUTAUVNUYCVUQQUV
        TUVLXQUEYOAUXQVUNUXNSNVUPAUWGUXNUXPVWLAUXNAUWNUWTVAZUMVWMVWNYQAVUNUWNVV
        RAUWNUWTUMZUVAYKYMVTAUXOUXPAUWGUXNUWQVXGXMVUSUVBXIAUWGUHOUWNUHOUWPUXOQV
        WLVXHUWGUWNUVCUGVTUWKUWNUVDYTAUWGUWQUVEXIAUWDUWEUVFAUWGUQOUXBUWHUWIUWJU
        VGYRUWQVGUWGPUVHVFUVIUVJUVK $.
    $}

    $d x y z ph $.
    $( Lemma for ~ pjhth .  (Contributed by NM, 10-Oct-1999.)  (Revised by
       Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    pjhthlem2 $p |- ( ph -> E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      ( vz cv cmv co cno cfv wrex cva wceq cop chil wcel wa wral cort wreu cres
      cle wbr csm cxp cc df-hba eqid hhvs hhnm chshii hhssba ccphlo a1i css cin
      hhph ccbn csh hhsst ax-mp hhssbn elin mpbir2an minveco reurex syl csp cc0
      adantr cheli ad2antrl hvsubcl syl2anc c1 caddc cdiv simplrl simpr simplrr
      pjhthlem1 ralrimiva wb shocel sylanbrc hvpncan3 eqcomd eqeq2d rspcev expr
      oveq2 reximdva mpd ) ADBIZJKZLMDHIJKLMUEUFHEUAZBENZDWQCIZOKZPZCEUBMZNZBEN
      AWSBEUCWTABHDOUGQLQZJLOEEUHUDUGUIEUHUDQLEUDQZREUJXFXFUKZULXFXHUMEXGXGUKZE
      FUNZUOXFUPSAXFXHUTUQXGXFURMZVAUSSZAXLXGXKSZXGVASEVBSZXMXJXFEXGXHXIVCVDEXG
      XIFVEXGXKVAVFVGUQGVHWSBEVIVJAWSXEBEAWQESZWSXEAXOWSTZTZWRXDSZDWQWROKZPZXEX
      QWRRSZWRXAVKKZVLPZCEUAZXRXQDRSZWQRSZYAAYEXPGVMZXOYFAWSWQEFVNVOZDWQVPVQXQY
      CCEXQXAESZTHDWQXAYBXAXAVKKVRVSKVTKZEFXQYEYIYGVMAXOWSYIWAXQYIWBAXOWSYIWCYJ
      UKWDWEXNXRYAYDTWFXJCWREWGVDWHXQXSDXQYFYEXSDPYHYGWQDWIVQWJXCXTCWRXDXAWRPXB
      XSDXAWRWQOWNWKWLVQWMWOWP $.
  $}

  ${
    $d x y z H $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       uniquely into a member ` x ` of a closed subspace ` H ` and a member
       ` y ` of the complement of the subspace.  Theorem 3.7(i) of [Beran]
       p. 102 (existence part).  (Contributed by NM, 23-Oct-1999.)  (Revised by
       Mario Carneiro, 14-May-2014.)  (New usage is discouraged.) $)
    pjhth $p |- ( H e. CH -> ( H +H ( _|_ ` H ) ) = ~H ) $=
      ( vx vy vz cch wcel cort cfv cph co chil csh wss chsh shocsh syl2anc wceq
      cv wrex wi syl shsss cva cif fveq2 rexeqdv rexeqbi1dv imbi2d helch elimel
      id pjhthlem2 dedth wb shsel sylibrd ssrdv eqssd ) AEFZAAGHZIJZKUSALFZUTLF
      ZVAKMANZUSVBVCVDAOUAZAUTUBPUSBKVAUSBRZKFZVFCRDRUCJQZDUTSZCASZVFVAFZUSVGVJ
      TVGVHDUSAKUDZGHZSZCVLSZTAKAVLQZVJVOVGVIVNCAVLVPVHDUTVMAVLGUEUFUGUHVGCDVFV
      LAKEUIUJVGUKULUMUSVBVCVKVJUNVDVECDAUTVFUOPUPUQUR $.
  $}

  ${
    $d x y A $.  $d x y H $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       uniquely into a member ` x ` of a closed subspace ` H ` and a member
       ` y ` of the complement of the subspace.  Theorem 3.7(i) of [Beran]
       p. 102.  See ~ pjhtheu2 for the uniqueness of ` y ` .  (Contributed by
       NM, 23-Oct-1999.)  (Revised by Mario Carneiro, 14-May-2014.)
       (New usage is discouraged.) $)
    pjhtheu $p |- ( ( H e. CH /\ A e. ~H ) ->
                   E! x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      ( cch wcel chil wa cv cva co wceq cort cfv wrex wmo wreu cph csh syl chsh
      pjhth eleq2d wb shocsh syl2anc bitr3d biimpa cin c0h ocin pjhthmo syl3anc
      shsel adantr wrmo reu5 df-rmo anbi2i bitri sylanbrc ) DEFZCGFZHCAIZBIJKLB
      DMNZOZADOZVDDFVFHAPZVFADQZVBVCVGVBCDVERKZFZVCVGVBVJGCDUBUCVBDSFZVESFZVKVG
      UDDUAZVBVLVMVNDUETZABDVECUNUFUGUHVBVHVCVBVLVMDVEUIUJLZVHVNVOVBVLVPVNDUKTA
      BDVECULUMUOVIVGVFADUPZHVGVHHVFADUQVQVHVGVFADURUSUTVA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d h x y z $.
    $( Define the projection function on a Hilbert space, as a mapping from the
       Hilbert lattice to a function on Hilbert space.  Every closed subspace
       is associated with a unique projection function.  Remark in [Kalmbach]
       p. 66, adopted as a definition. ` ( projh `` H ) `` A ` is the
       projection of vector ` A ` onto closed subspace ` H ` .  Note that the
       range of ` projh ` is the set of all projection operators, so
       ` T e. ran projh ` means that ` T ` is a projection operator.
       (Contributed by NM, 23-Oct-1999.)  (New usage is discouraged.) $)
    df-pjh $a |- projh = ( h e. CH |-> ( x e. ~H |->
           ( iota_ z e. h E. y e. ( _|_ ` h ) x = ( z +h y ) ) ) ) $.
  $}

  ${
    $d h x y z H $.  $d x y z A $.  $d x y z B $.
    $( The value of the projection map.  (Contributed by NM, 23-Oct-1999.)
       (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    pjhfval $p |- ( H e. CH -> ( projh ` H ) = ( x e. ~H |->
           ( iota_ z e. H E. y e. ( _|_ ` H ) x = ( z +h y ) ) ) ) $=
      ( vh chil cv cva co wceq cort cfv wrex crio cmpt cch cpjh fveq2 rexeqdv
      id riotaeqbidv mpteq2dv df-pjh ax-hilex mptex fvmpt ) EDAFAGCGBGHIJZBEGZK
      LZMZCUHNZOAFUGBDKLZMZCDNZOPQUHDJZAFUKUNUOUJUMCUHDUOTUOUGBUIULUHDKRSUAUBAB
      CEUCAFUNUDUEUF $.

    $( Value of a projection.  (Contributed by NM, 23-Oct-1999.)  (Revised by
       Mario Carneiro, 15-Dec-2013.)  (New usage is discouraged.) $)
    pjhval $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( projh ` H ) ` A ) =
             ( iota_ x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) ) $=
      ( vz cch wcel chil cpjh cfv cv co wceq cort wrex crio cmpt pjhfval fveq1d
      cva eqeq1 rexbidv riotabidv eqid riotaex fvmpt sylan9eq ) DFGZCHGCDIJZJCE
      HEKZAKBKTLZMZBDNJZOZADPZQZJCUKMZBUMOZADPZUHCUIUPEBADRSECUOUSHUPUJCMZUNURA
      DUTULUQBUMUJCUKUAUBUCUPUDURADUEUFUG $.

    $( Equality with a projection.  This version of ~ pjeq does not assume the
       Axiom of Choice via ~ pjhth .  (Contributed by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    pjpreeq $p |- ( ( H e. CH /\ A e. ( H +H ( _|_ ` H ) ) ) ->
                    ( ( ( projh ` H ) ` A ) = B <->
                      ( B e. H /\ E. x e. ( _|_ ` H ) A = ( B +h x ) ) ) ) $=
      ( vy cch wcel cort cfv co wa cv cva wceq wrex csh wb syl syl2anc chil cph
      crio cpjh wreu wmo chsh shocsh biimpa cin c0h ocin pjhthmo syl3anc adantr
      shsel wrmo reu5 df-rmo anbi2i bitri sylanbrc eleq1 syl5ibcom pm4.71rd wss
      riotacl shsss sselda pjhval syldan eqeq1d id oveq1 eqeq2d rexbidv syl2anr
      riota2 pm5.32da 3bitr4d ) DFGZBDDHIZUAJZGZKZBELZALZMJZNZAWAOZEDUBZCNZCDGZ
      WKKBDUCIIZCNWLBCWFMJZNZAWAOZKWDWKWLWDWJDGZWKWLWDWIEDUDZWQWDWIEDOZWEDGWIKE
      UEZWRVTWCWSVTDPGZWAPGZWCWSQDUFZVTXAXBXCDUGRZEADWABUOSUHVTWTWCVTXAXBDWAUIU
      JNZWTXCXDVTXAXEXCDUKREADWABULUMUNWRWSWIEDUPZKWSWTKWIEDUQXFWTWSWIEDURUSUTV
      AZWIEDVFRWJCDVBVCVDWDWMWJCVTWCBTGWMWJNVTWBTBVTXAXBWBTVEXCXDDWAVGSVHEABDVI
      VJVKWDWLWPWKWLWLWRWPWKQWDWLVLXGWIWPEDCWECNZWHWOAWAXHWGWNBWECWFMVMVNVOVQVP
      VRVS $.

    $( Equality with a projection.  (Contributed by NM, 20-Jan-2007.)  (Revised
       by Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    pjeq $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( ( projh ` H ) ` A ) = B <->
                ( B e. H /\ E. x e. ( _|_ ` H ) A = ( B +h x ) ) ) ) $=
      ( cch wcel chil cort cfv cph co cpjh wceq cv cva wrex wa wb pjhth eleq2d
      biimpar pjpreeq syldan ) DEFZBGFZBDDHIZJKZFZBDLIICMCDFBCANOKMAUFPQRUDUHUE
      UDUGGBDSTUAABCDUBUC $.

    $( Closure of a projection in its subspace.  If we consider this together
       with ~ axpjpj to be axioms, the need for the ~ ax-hcompl can often be
       avoided for the kinds of theorems we are interested in here.  An
       interesting project is to see how far we can go by using them in place
       of it.  In particular, we can prove the orthomodular law ~ pjomli .)
       (Contributed by NM, 23-Oct-1999.)  (Revised by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    axpjcl $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( projh ` H ) ` A ) e. H ) $=
      ( vx cch wcel chil wa cpjh cfv cv cva co wceq cort wrex eqid mpbii simpld
      pjeq ) BDEAFEGZABHIIZBEZAUACJKLMCBNIOZTUAUAMUBUCGUAPCAUABSQR $.

$(
    @( Closure of projection, as an axiom.  Can be used to replace ~ axpjcl
       for studies of the Hilbert space completeness axiom. @)
    ax-pjcl @a |- ( ( H e. CH /\ A e. ~H ) -> ( ( projh ` H ) ` A ) e. H ) @.
$)
  $}

  $( Closure of a projection in Hilbert space.  (Contributed by NM,
     30-Oct-1999.)  (New usage is discouraged.) $)
  pjhcl $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( projh ` H ) ` A ) e. ~H ) $=
    ( cch wcel chil wa cpjh cfv wss chss adantr axpjcl sseldd ) BCDZAEDZFBEABGH
    HNBEIOBJKABLM $.

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Properties of Hilbert subspaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Orthomodular law
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    omlsilem.1 $e |- G e. SH $.
    omlsilem.2 $e |- H e. SH $.
    omlsilem.3 $e |- G C_ H $.
    omlsilem.4 $e |- ( H i^i ( _|_ ` G ) ) = 0H $.
    omlsilem.5 $e |- A e. H $.
    omlsilem.6 $e |- B e. G $.
    omlsilem.7 $e |- C e. ( _|_ ` G ) $.
    $( Lemma for orthomodular law in the Hilbert lattice.  (Contributed by NM,
       14-Oct-1999.)  (New usage is discouraged.) $)
    omlsilem $p |- ( A = ( B +h C ) -> A e. G ) $=
      ( cva co wceq wcel c0v shelii chil csh cfv cmv wss shocss ax-mp hvsubaddi
      cort sselii eqcom bitri shsubcl mp3an eleq1 sylbir wa cin c0h eleq2i elin
      mpbii 3bitr3i biimpi sylancl oveq2d ax-hvaddid syl6eq syl6eqel mpbird
      elch0 ) ABCMNZOZADPVJDPVKVJBDVKVJBQMNZBVKCQBMVKCEPZCDUGUAZPZCQOZVKABUBNZC
      OZVMVRVJAOVKABCAEGJRBDFKRZVNSCDTPVNSUCFDUDUELUHUFVJAUIUJVRVQEPZVMETPAEPBE
      PVTGJDEBHKUHABEUKULVQCEUMUTUNLVMVOUOZVPCEVNUPZPCUQPWAVPWBUQCIURCEVNUSCVIV
      AVBVCVDBSPVLBOVSBVEUEVFKVGAVJDUMVH $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    omlsi.1 $e |- A e. CH $.
    omlsi.2 $e |- B e. SH $.
    omlsi.3 $e |- A C_ B $.
    omlsi.4 $e |- ( B i^i ( _|_ ` A ) ) = 0H $.
    $( Subspace inference form of orthomodular law in the Hilbert lattice.
       (Contributed by NM, 14-Oct-1999.)  (Revised by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    omlsii $p |- A = B $=
      ( vx vy vz cv wcel cva co wceq wi c0v cif csh ax-mp elimel cort cfv sheli
      pjhthlem2 wa eqeq1 eleq1 imbi12d oveq1 eqeq2d imbi1d oveq2 chshii sh0 cch
      wrex ch0 shocsh omlsilem dedth3h 3expia rexlimdv rexlimdva ssriv eqssi
      mpd ) ABEGBAGJZBKZVGHJZIJZLMZNZIAUAUBZUPZHAUPVGAKZVHHIVGACVGBDUCUDVHVNVOH
      AVHVIAKZUEVLVOIVMVHVPVJVMKZVLVOOZVHVPVQVRVHVGPQZVKNZVSAKZOVSVPVIPQZVJLMZN
      ZWAOVSWBVQVJPQZLMZNZWAOVGVIVJPPPVGVSNVLVTVOWAVGVSVKUFVGVSAUGUHVIWBNZVTWDW
      AWHVKWCVSVIWBVJLUIUJUKVJWENZWDWGWAWIWCWFVSVJWEWBLULUJUKVSWBWEABACUMZDEFVG
      PBBRKPBKDBUNSTVIPAAUOKPAKCAUQSTVJPVMVMRKZPVMKARKWKWJAURSVMUNSTUSUTVAVBVCV
      FVDVE $.
  $}

  ${
    omls.1 $e |- A e. CH $.
    omls.2 $e |- B e. SH $.
    $( Subspace form of orthomodular law in the Hilbert lattice.  Compare the
       orthomodular law in Theorem 2(ii) of [Kalmbach] p. 22.  (Contributed by
       NM, 14-Oct-1999.)  (New usage is discouraged.) $)
    omlsi $p |- ( ( A C_ B /\ ( B i^i ( _|_ ` A ) ) = 0H ) -> A = B ) $=
      ( wss cort cfv cin c0h wa cif keepel csh h0elsh sseq1 fveq2 ineq2d eqeq1d
      wceq anbi12d eqeq1 eqeq2 cch h0elch sseq2 ineq1 ssid wcel ax-mp elimhyp2v
      ocin pm3.2i simpli simpri omlsii dedth2v ) ABEZBAFGZHZISZJZABSVAAIKZBSVBV
      ABIKZSABIIAVBBUABVCVBUBVBVCVAAIUCCUDLVABIMDNLVBVCEZVCVBFGZHZISZVAVBBEZBVE
      HZISZJVDVGJIIEZIIFGZHZISZJVBIEZIVEHZISZJABIIAVBSZUQVHUTVJAVBBOVRUSVIIVRUR
      VEBAVBFPQRTBVCSZVHVDVJVGBVCVBUEVSVIVFIBVCVEUFRTIVBSZVKVOVNVQIVBIOVTVMVPIV
      TVLVEIIVBFPQRTIVCSZVOVDVQVGIVCVBUEWAVPVFIIVCVEUFRTVKVNIUGIMUHVNNIUKUIULUJ
      ZUMVDVGWBUNUOUP $.
  $}

  ${
    $d x y z A $.
    ococ.1 $e |- A e. CH $.
    $( Complement of complement of a closed subspace of Hilbert space.  Theorem
       3.7(ii) of [Beran] p. 102.  (Contributed by NM, 11-Oct-1999.)
       (New usage is discouraged.) $)
    ococi $p |- ( _|_ ` ( _|_ ` A ) ) = A $=
      ( cort cfv csh wcel chshii shocsh ax-mp wss shococss cin incom wceq eqtri
      c0h ocin omlsii eqcomi ) AACDZCDZAUABTEFZUAEFAEFZUBABGZAHIZTHIUCAUAJUDAKI
      UATLTUALZPUATMUBUFPNUETQIORS $.
  $}

  ${
    $d x y z A $.
    $( Complement of complement of a closed subspace of Hilbert space.  Theorem
       3.7(ii) of [Beran] p. 102.  (Contributed by NM, 11-Oct-1999.)
       (New usage is discouraged.) $)
    ococ $p |- ( A e. CH -> ( _|_ ` ( _|_ ` A ) ) = A ) $=
      ( cch wcel cort cfv wceq chil cif fveq2 fveq2d eqeq12d helch elimel ococi
      id dedth ) ABCZADEZDEZAFQAGHZDEZDEZTFAGATFZSUBATUCRUADATDIJUCOKTAGBLMNP
      $.
  $}

  $( Alternate definition of the Hilbert lattice.  (Contributed by NM,
     8-Aug-2000.)  (Revised by Mario Carneiro, 23-Dec-2013.)
     (New usage is discouraged.) $)
  dfch2 $p |- CH = { x e. ~P ~H | ( _|_ ` ( _|_ ` x ) ) = x } $=
    ( cch cv chil cpw wcel cort cfv wceq cab crab wss chss ococ occl 3syl eleq1
    wa jca syl5ib impcom impbii vex elpw anbi1i bitr4i abbi2i df-rab eqtr4i ) B
    ACZDEZFZUJGHZGHZUJIZRZAJUOAUKKUPABUJBFZUJDLZUORZUPUQUSUQURUOUJMUJNSUOURUQUR
    UNBFZUOUQURUMBFUMDLUTUJOUMMUMOPUNUJBQTUAUBULURUOUJDAUCUDUEUFUGUOAUKUHUI $.

  ${
    $d x y A $.  $d x B $.
    $( The double complement is the smallest closed subspace containing a
       subset of Hilbert space.  Remark 3.12(B) of [Beran] p. 107.
       (Contributed by NM, 8-Aug-2000.)  (New usage is discouraged.) $)
    ococin $p |- ( A C_ ~H ->
                  ( _|_ ` ( _|_ ` A ) ) = |^| { x e. CH | A C_ x } ) $=
      ( chil wss cort cfv cv cch crab cint wcel helch sseq2 elrab sylibr intss1
      wa syl ocss occon jctl jca ssintub wi mpdan mpi sylc wceq wne ssrab2 wrex
      rspcev mpan rabn0 chintcl sylancr ococ sseqtrd occl ococss sylanbrc eqssd
      c0 ) BCDZBEFZEFZBAGZDZAHIZJZVDVFVJEFZEFZVJVDVKCDZVECDZQVKVEDZVFVLDVDVMVNV
      DVJCDZVMVDCVIKZVPVDCHKZVDQVQVDVRLUAVHVDACHVGCBMZNOCVIPRZVJSRBSZUBVDBVJDZV
      OABHUCVDVPWBVOUDVTBVJTUEUFVKVETUGVDVJHKZVLVJUHVDVIHDVIVCUIZWCVHAHUJVDVHAH
      UKZWDVRVDWELVHVDACHVSULUMVHAHUNOVIUOUPVJUQRURVDVFVIKZVJVFDVDVFHKZBVFDZWFV
      DVNWGWAVEUSRBUTVHWHAVFHVGVFBMNVAVFVIPRVB $.

    $( Alternate definition of supremum of a subset of the Hilbert lattice.
       Definition of supremum in Proposition 1 of [Kalmbach] p. 65.  We
       actually define it on any collection of Hilbert space subsets, not just
       the Hilbert lattice ` CH ` , to allow more general theorems.
       (Contributed by NM, 13-Aug-2002.)  (New usage is discouraged.) $)
    hsupval2 $p |- ( A C_ ~P ~H ->
                    ( \/H ` A ) = |^| { x e. CH | U. A C_ x } ) $=
      ( chil cpw wss cfv cuni cort cv cch crab cint hsupval wceq sspwuni ococin
      chsup sylbi eqtrd ) BCDEZBQFBGZHFHFZUAAIEAJKLZBMTUACEUBUCNBCOAUAPRS $.

    $( The value of the supremum of a set of closed subspaces of Hilbert
       space.  Definition of supremum in Proposition 1 of [Kalmbach] p. 65.
       (Contributed by NM, 13-Aug-2002.)  (New usage is discouraged.) $)
    chsupval2 $p |- ( A C_ CH ->
                    ( \/H ` A ) = |^| { x e. CH | U. A C_ x } ) $=
      ( cch wss chil cpw chsup cfv cuni cv crab cint chsspwh sstr2 mpi hsupval2
      wceq syl ) BCDZBEFZDZBGHBIAJDACKLQSCTDUAMBCTNOABPR $.

    $( Value of join in the set of closed subspaces of Hilbert space ` CH ` .
       (Contributed by NM, 1-Nov-2000.)  (Revised by Mario Carneiro,
       23-Dec-2013.)  (New usage is discouraged.) $)
    sshjval2 $p |- ( ( A C_ ~H /\ B C_ ~H ) -> ( A vH B ) =
                     |^| { x e. CH | ( A u. B ) C_ x } ) $=
      ( chil wss wa chj co cun cort cfv cch crab cint sshjval wceq ococin sylbi
      cv unss eqtrd ) BDECDEFZBCGHBCIZJKJKZUCASEALMNZBCOUBUCDEUDUEPBCDTAUCQRUA
      $.

    $( A subspace is the supremum of all smaller subspaces.  (Contributed by
       NM, 13-Aug-2002.)  (New usage is discouraged.) $)
    chsupid $p |- ( A e. CH -> ( \/H ` { x e. CH | x C_ A } ) = A ) $=
      ( vy cch wcel cv wss crab chsup cfv cuni cint wceq ssrab2 chsupval2 ax-mp
      unimax sseq1d rabbidv inteqd intmin eqtrd syl5eq ) BDEZAFBGZADHZIJZUFKZCF
      ZGZCDHZLZBUFDGUGULMUEADNCUFOPUDULBUIGZCDHZLBUDUKUNUDUJUMCDUDUHBUIABDQRSTC
      BDUAUBUC $.

    $( Value of supremum of subset of ` CH ` on a singleton.  (Contributed by
       NM, 13-Aug-2002.)  (New usage is discouraged.) $)
    chsupsn $p |- ( A e. CH -> ( \/H ` { A } ) = A ) $=
      ( vx cch wcel csn chsup cfv cuni cv wss crab cint wceq snssi chsupval2 wa
      syl unisng eqimss ancli sseq2 elrab sylibr intss1 ssintub syl6eqssr eqssd
      eqtrd ) ACDZAEZFGZUJHZBIZJZBCKZLZAUIUJCJUKUPMACNBUJOQUIUPAUIAUODZUPAJUIUI
      ULAJZPUQUIURUIULAMURACRZULASQTUNURBACUMAULUAUBUCAUOUDQUIAULUPUSBULCUEUFUG
      UH $.
  $}

  $( Hilbert lattice join is the least upper bound (among Hilbert lattice
     elements) of two subspaces.  (Contributed by NM, 15-Jun-2004.)
     (New usage is discouraged.) $)
  shlub $p |- ( ( A e. SH /\ B e. SH /\ C e. CH ) ->
               ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) ) $=
    ( csh wcel cch w3a wss wa chj cort cfv chil shss 3ad2ant3 syl2anc wceq sstr
    syl sylan co cun unss wi simp1 simp2 unssd chss occon2 syl5bi shjval eqcomd
    ococ sseq12d sylibrd shub1 shub2 jca ex impbid ) ADEZBDEZCFEZGZACHZBCHZIZAB
    JUAZCHZVDVGABUBZKLKLZCKLKLZHZVIVGVJCHZVDVMABCUCVDVJMHCMHZVNVMUDVDABMVDVAAMH
    VAVBVCUEZANSVDVBBMHVAVBVCUFZBNSUGVCVAVOVBCUHOVJCUIPUJVDVHVKCVLVDVAVBVHVKQVP
    VQABUKPVDVLCVCVAVLCQVBCUMOULUNUOVDVIVGVDVIIVEVFVDAVHHZVIVEVDVAVBVRVPVQABUPP
    AVHCRTVDBVHHZVIVFVDVBVAVSVQVPBAUQPBVHCRTURUSUT $.

  ${
    shlub.1 $e |- A e. SH $.
    shlub.2 $e |- B e. SH $.
    shlub.3 $e |- C e. CH $.
    $( Hilbert lattice join is the least upper bound (among Hilbert lattice
       elements) of two subspaces.  (Contributed by NM, 11-Jun-2004.)
       (New usage is discouraged.) $)
    shlubi $p |- ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) $=
      ( csh wcel cch wss wa chj co wb shlub mp3an ) AGHBGHCIHACJBCJKABLMCJNDEFA
      BCOP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y H $.
    $( Uniqueness of ` y ` for the projection theorem.  (Contributed by NM,
       6-Nov-1999.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    pjhtheu2 $p |- ( ( H e. CH /\ A e. ~H ) ->
                   E! y e. ( _|_ ` H ) E. x e. H A = ( x +h y ) ) $=
      ( cch wcel chil wa cv cva co wceq cort wrex wreu choccl sylan adantr chel
      cfv pjhtheu simpll ococ rexeqdv ax-hvcom syl2anc eqeq2d rexbidva reubidva
      syl bitrd mpbid ) DEFZCGFZHZCBIZAIZJKZLZADMTZMTZNZBUTOZCUQUPJKZLZADNZBUTO
      UMUTEFZUNVCDPZBACUTUAQUOVBVFBUTUOUPUTFZHZVBUSADNVFVJUSAVADVJUMVADLUMUNVIU
      BZDUCUJUDVJUSVEADVJUQDFZHZURVDCVMUPGFZUQGFZURVDLVJVNVLUOVGVIVNUMVGUNVHRUP
      UTSQRVJUMVLVOVKUQDSQUPUQUEUFUGUHUKUIUL $.
  $}

  ${
    pjcl.1 $e |- H e. CH $.
    $( Closure of a projection in its subspace.  (Contributed by NM,
       7-Oct-2000.)  (New usage is discouraged.) $)
    pjcli $p |- ( A e. ~H -> ( ( projh ` H ) ` A ) e. H ) $=
      ( cch wcel chil cpjh cfv axpjcl mpan ) BDEAFEABGHHBECABIJ $.

    $( Closure of a projection in Hilbert space.  (Contributed by NM,
       7-Oct-2000.)  (New usage is discouraged.) $)
    pjhcli $p |- ( A e. ~H -> ( ( projh ` H ) ` A ) e. ~H ) $=
      ( cch wcel chil cpjh cfv pjhcl mpan ) BDEAFEABGHHFECABIJ $.
  $}

  ${
    $d x y A $.  $d x y H $.  $d x y ph $.
    pjpjpre.1 $e |- ( ph -> H e. CH ) $.
    pjpjpre.2 $e |- ( ph -> A e. ( H +H ( _|_ ` H ) ) ) $.
    $( Decomposition of a vector into projections.  This formulation of
       ~ axpjpj avoids ~ pjhth .  (Contributed by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    pjpjpre $p |- ( ph ->
          A = ( ( ( projh ` H ) ` A ) +h ( ( projh ` ( _|_ ` H ) ) ` A ) ) ) $=
      ( vx vy cva co wceq cfv wrex cph wcel csh wb syl syl2anc wa adantr cv cch
      cort cpjh chsh shocsh shsel simprr simprll simprlr rspe pjpreeq mpbir2and
      mpbid wss shococss sseldd chil shel ax-hvcom eqtrd choccl shless syl31anc
      shscom sseqtr4d oveq12d eqtr4d exp32 rexlimdvv mpd ) ABFUAZGUAZHIZJZGCUCK
      ZLZFCLZBBCUDKKZBVPUDKKZHIZJZABCVPMIZNZVREACONZVPONZWDVRPACUBNZWEDCUEZQZAW
      EWFWICUFZQZFGCVPBUGRUNAVOWBFGCVPAVLCNZVMVPNZSZVOWBAWNVOSZSZBVNWAAWNVOUHZW
      PVSVLVTVMHWPVSVLJZWLVQAWLWMVOUIZWPWMVOVQAWLWMVOUJZWQVOGVPUKRAWRWLVQSPZWOA
      WGWDXADEGBVLCULRTUMWPVTVMJZWMBVMVLHIZJZFVPUCKZLZWTWPVLXENXDXFWPCXEVLACXEU
      OZWOAWEXGWICUPQZTWSUQWPBVNXCWQWPVLURNZVMURNZVNXCJWPWEWLXIWPWGWEAWGWODTWHQ
      ZWSVLCUSRWPWFWMXJWPWEWFXKWJQWTVMVPUSRVLVMUTRVAXDFXEUKRAXBWMXFSPZWOAVPUBNZ
      BVPXEMIZNXLAWGXMDCVBQAWCXNBAWCXEVPMIZXNAWEXEONZWFXGWCXOUOWIAWFXPWKVPUFQZW
      KXHCXEVPVCVDAWFXPXNXOJWKXQVPXEVERVFEUQFBVMVPULRTUMVGVHVIVJVK $.
  $}

  $( Decomposition of a vector into projections.  See comment in ~ axpjcl .
     (Contributed by NM, 26-Oct-1999.)  (Revised by Mario Carneiro,
     15-May-2014.)  (New usage is discouraged.) $)
  axpjpj $p |- ( ( H e. CH /\ A e. ~H ) ->
          A = ( ( ( projh ` H ) ` A ) +h ( ( projh ` ( _|_ ` H ) ) ` A ) ) ) $=
    ( cch wcel chil wa simpl cort cfv cph co pjhth eleq2d biimpar pjpjpre ) BCD
    ZAEDZFABPQGPABBHIJKZDQPREABLMNO $.

  ${
    $d x y z A $.  $d x y z H $.
    pjcli.1 $e |- H e. CH $.
    pjcli.2 $e |- A e. ~H $.
    $( Closure of a projection in its subspace.  (Contributed by NM,
       30-Oct-1999.)  (New usage is discouraged.) $)
    pjclii $p |- ( ( projh ` H ) ` A ) e. H $=
      ( chil wcel cpjh cfv pjcli ax-mp ) AEFABGHHBFDABCIJ $.

    $( Closure of a projection in Hilbert space.  (Contributed by NM,
       30-Oct-1999.)  (New usage is discouraged.) $)
    pjhclii $p |- ( ( projh ` H ) ` A ) e. ~H $=
      ( chil wcel cpjh cfv pjhcli ax-mp ) AEFABGHHEFDABCIJ $.

    $( Decomposition of a vector into projections.  (Contributed by NM,
       26-Oct-1999.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    pjpj0i $p |- A = ( ( ( projh ` H ) ` A ) +h
                ( ( projh ` ( _|_ ` H ) ) ` A ) ) $=
      ( cch wcel chil cpjh cfv cort cva co wceq axpjpj mp2an ) BEFAGFAABHIIABJI
      HIIKLMCDABNO $.
  $}

$(
  @( Decomposition of a vector into projections, as an axiom.  Can be used to
     replace ~ axpjpj in studies of the Hilbert space completeness axiom. @)
  ax-pjpj @a |- ( ( H e. CH /\ A e. ~H ) ->
         A = ( ( ( projh ` H ) ` A ) +h ( ( projh ` ( _|_ ` H ) ) ` A ) ) ) @.
$)

  ${
    $d x y A $.  $d x y H $.
    pjpj.1 $e |- H e. CH $.
    pjpj.2 $e |- A e. ~H $.
    $( Decomposition of a vector into projections.  (Contributed by NM,
       6-Nov-1999.)  (New usage is discouraged.) $)
    pjpji $p |- A = ( ( ( projh ` H ) ` A ) +h
               ( ( projh ` ( _|_ ` H ) ) ` A ) ) $=
      ( pjpj0i ) ABCDE $.
  $}

  ${
    $d x y A $.  $d x y H $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       into a member ` x ` of a closed subspace ` H ` and a member ` y ` of the
       complement of the subspace.  Theorem 3.7(i) of [Beran] p. 102 (existence
       part).  (Contributed by NM, 6-Nov-1999.)  (New usage is discouraged.) $)
    pjpjhth $p |- ( ( H e. CH /\ A e. ~H ) ->
                E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) ) $=
      ( cch wcel chil wa cpjh cfv cort cva co wceq cv wrex axpjcl choccl axpjpj
      sylan rspceov syl3anc ) DEFZCGFZHCDIJJZDFCDKJZIJJZUFFZCUEUGLMNCAOBOLMNBUF
      PADPCDQUCUFEFUDUHDRCUFQTCDSABDUFUEUGCLUAUB $.
  $}

  ${
    $d x y A $.  $d x y H $.
    pjpjhth.1 $e |- A e. ~H $.
    pjpjhth.2 $e |- H e. CH $.
    $( Projection Theorem:  Any Hilbert space vector ` A ` can be decomposed
       into a member ` x ` of a closed subspace ` H ` and a member ` y ` of the
       complement of the subspace.  Theorem 3.7(i) of [Beran] p. 102 (existence
       part).  (Contributed by NM, 6-Nov-1999.)  (New usage is discouraged.) $)
    pjpjhthi $p |- E. x e. H E. y e. ( _|_ ` H ) A = ( x +h y ) $=
      ( cch wcel chil cv cva co wceq cort cfv wrex pjpjhth mp2an ) DGHCIHCAJBJK
      LMBDNOPADPFEABCDQR $.
  $}

  $( Orthocomplement projection in terms of projection.  (Contributed by NM,
     5-Nov-1999.)  (New usage is discouraged.) $)
  pjop $p |- ( ( H e. CH /\ A e. ~H )
     -> ( ( projh ` ( _|_ ` H ) ) ` A ) = ( A -h ( ( projh ` H ) ` A ) ) ) $=
    ( cch wcel chil wa cpjh cfv cmv co cort wceq cva axpjpj eqcomd simpr choccl
    wb pjhcl sylan hvsubadd syl3anc mpbird ) BCDZAEDZFZAABGHHZIJZABKHZGHHZUFUHU
    JLZUGUJMJZALZUFAULABNOUFUEUGEDUJEDZUKUMRUDUEPABSUDUICDUEUNBQAUISTAUGUJUAUBU
    CO $.

  $( Projection in terms of orthocomplement projection.  (Contributed by NM,
     5-Nov-1999.)  (New usage is discouraged.) $)
  pjpo $p |- ( ( H e. CH /\ A e. ~H )
      -> ( ( projh ` H ) ` A ) = ( A -h ( ( projh ` ( _|_ ` H ) ) ` A ) ) ) $=
    ( cch wcel chil wa cort cfv cpjh cmv co wceq cva choccl pjhcl sylan syl2anc
    ax-hvcom axpjpj eqtr4d wb simpr hvsubadd syl3anc mpbird eqcomd ) BCDZAEDZFZ
    AABGHZIHHZJKZABIHHZUIULUMLZUKUMMKZALZUIUOUMUKMKZAUIUKEDZUMEDZUOUQLUGUJCDUHU
    RBNAUJOPZABOZUKUMRQABSTUIUHURUSUNUPUAUGUHUBUTVAAUKUMUCUDUEUF $.

  ${
    pjop.1 $e |- H e. CH $.
    pjop.2 $e |- A e. ~H $.
    $( Orthocomplement projection in terms of projection.  (Contributed by NM,
       31-Oct-1999.)  (New usage is discouraged.) $)
    pjopi $p |- ( ( projh ` ( _|_ ` H ) ) ` A ) =
               ( A -h ( ( projh ` H ) ` A ) ) $=
      ( cch wcel chil cort cfv cpjh cmv co wceq pjop mp2an ) BEFAGFABHIJIIAABJI
      IKLMCDABNO $.

    $( Projection in terms of orthocomplement projection.  (Contributed by NM,
       31-Oct-1999.)  (New usage is discouraged.) $)
    pjpoi $p |- ( ( projh ` H ) ` A ) =
               ( A -h ( ( projh ` ( _|_ ` H ) ) ` A ) ) $=
      ( cch wcel chil cpjh cfv cort cmv co wceq pjpo mp2an ) BEFAGFABHIIAABJIHI
      IKLMCDABNO $.

    $( Projection of a vector in the orthocomplement of the projection
       subspace.  (Contributed by NM, 27-Oct-1999.)
       (New usage is discouraged.) $)
    pjoc1i $p |- ( A e. H <-> ( ( projh ` ( _|_ ` H ) ) ` A ) = 0h ) $=
      ( wcel cort cfv cpjh c0v wceq c0h cin wa cmv pjopi csh pjclii ax-mp cva
      co chshii shsubcl mp3an13 syl5eqel choccli jctir elin ocin syl6eleq elch0
      sylibr sylib pjpji oveq2 syl5eq pjhclii ax-hvaddid syl6eq syl6eqel impbii
      chil ) ABEZABFGZHGGZIJZVBVDKEVEVBVDBVCLZKVBVDBEZVDVCEZMVDVFEVBVGVHVBVDAAB
      HGGZNTZBABCDOBPEZVBVIBEVJBEBCUAZABCDQZAVIBUBUCUDAVCBCUEDQUFVDBVCUGUKVKVFK
      JVLBUHRUIVDUJULVEAVIBVEAVIISTZVIVEAVIVDSTVNABCDUMVDIVISUNUOVIVAEVNVIJABCD
      UPVIUQRURVMUSUT $.

    $( Projection of a vector in the projection subspace.  Lemma 4.4(ii) of
       [Beran] p. 111.  (Contributed by NM, 27-Oct-1999.)
       (New usage is discouraged.) $)
    pjchi $p |- ( A e. H <-> ( ( projh ` H ) ` A ) = A ) $=
      ( wcel cpjh cfv wceq c0v cva co chil pjhclii ax-hvaddid ax-mp cort pjoc1i
      pjpji biimpi oveq2d syl5req syl5eqr pjclii eleq1 mpbii impbii ) ABEZABFGG
      ZAHZUGUHUHIJKZAUHLEUJUHHABCDMUHNOUGAUHABPGFGGZJKUJABCDRUGUKIUHJUGUKIHABCD
      QSTUAUBUIUHBEUGABCDUCUHABUDUEUF $.
  $}

  $( The part of a vector that belongs to the orthocomplemented space.
     (Contributed by NM, 11-Apr-2006.)  (New usage is discouraged.) $)
  pjoccl $p |- ( ( H e. CH /\ A e. ~H ) ->
          ( A -h ( ( projh ` H ) ` A ) ) e. ( _|_ ` H ) ) $=
    ( cch wcel chil wa cort cfv cpjh cmv co pjop choccl axpjcl sylan eqeltrrd )
    BCDZAEDZFABGHZIHHZAABIHHJKSABLQSCDRTSDBMASNOP $.

  $( Projection of a vector in the orthocomplement of the projection subspace.
     (Contributed by NM, 6-Nov-1999.)  (New usage is discouraged.) $)
  pjoc1 $p |- ( ( H e. CH /\ A e. ~H ) ->
               ( A e. H <-> ( ( projh ` ( _|_ ` H ) ) ` A ) = 0h ) ) $=
    ( cch wcel chil cort cfv cpjh c0v wceq cif eleq2 fveq2 fveq2d fveq1d eqeq1d
    wb bibi12d eleq1 elimel helch ax-hv0cl pjoc1i dedth2h ) BCDZAEDZABDZABFGZHG
    ZGZIJZQAUEBEKZDZAULFGZHGZGZIJZQUFAIKZULDZURUOGZIJZQBAEIBULJZUGUMUKUQBULALVB
    UJUPIVBAUIUOVBUHUNHBULFMNOPRAURJZUMUSUQVAAURULSVCUPUTIAURUOMPRURULBECUATAIE
    UBTUCUD $.

  ${
    $d x A $.  $d x B $.
    pjoml.1 $e |- A e. CH $.
    pjoml.2 $e |- B e. SH $.
    $( Subspace form of orthomodular law in the Hilbert lattice.  Compare the
       orthomodular law in Theorem 2(ii) of [Kalmbach] p. 22.  Derived using
       projections; compare ~ omlsi .  (Contributed by NM, 6-Nov-1999.)
       (New usage is discouraged.) $)
    pjomli $p |- ( ( A C_ B /\ ( B i^i ( _|_ ` A ) ) = 0H ) -> A = B ) $=
      ( omlsi ) ABCDE $.
  $}

  $( Subspace form of orthomodular law in the Hilbert lattice.  Compare the
     orthomodular law in Theorem 2(ii) of [Kalmbach] p. 22.  Derived using
     projections; compare ~ omlsi .  (Contributed by NM, 14-Jun-2006.)
     (New usage is discouraged.) $)
  pjoml $p |- ( ( ( A e. CH /\ B e. SH ) /\
               ( A C_ B /\ ( B i^i ( _|_ ` A ) ) = 0H ) ) -> A = B ) $=
    ( cch wcel csh wa wss cort cfv cin c0h wceq cif sseq1 fveq2 anbi12d imbi12d
    wi eqeq1d elimel ineq2d eqeq1 sseq2 ineq1 h0elch h0elsh pjomli dedth2h imp
    eqeq2 ) ACDZBEDZFABGZBAHIZJZKLZFZABLZUKULUQURRUKAKMZBGZBUSHIZJZKLZFZUSBLZRU
    SULBKMZGZVFVAJZKLZFZUSVFLZRABKKAUSLZUQVDURVEVLUMUTUPVCAUSBNVLUOVBKVLUNVABAU
    SHOUASPAUSBUBQBVFLZVDVJVEVKVMUTVGVCVIBVFUSUCVMVBVHKBVFVAUDSPBVFUSUJQUSVFAKC
    UETBKEUFTUGUHUI $.

  ${
    pjococ.1 $e |- H e. CH $.
    $( Proof of orthocomplement theorem using projections.  Compare ~ ococ .
       (Contributed by NM, 5-Nov-1999.)  (New usage is discouraged.) $)
    pjococi $p |- ( _|_ ` ( _|_ ` H ) ) = H $=
      ( ococi ) ABC $.
  $}

  ${
    pjoc2.1 $e |- H e. CH $.
    pjoc2.2 $e |- A e. ~H $.
    $( Projection of a vector in the orthocomplement of the projection
       subspace.  Lemma 4.4(iii) of [Beran] p. 111.  (Contributed by NM,
       27-Oct-1999.)  (New usage is discouraged.) $)
    pjoc2i $p |- ( A e. ( _|_ ` H ) <-> ( ( projh ` H ) ` A ) = 0h ) $=
      ( cort cfv wcel cpjh c0v wceq choccli pjoc1i pjococi fveq2i fveq1i eqeq1i
      bitri ) ABEFZGAREFZHFZFZIJABHFZFZIJARBCKDLUAUCIATUBSBHBCMNOPQ $.
  $}

  $( Projection of a vector in the orthocomplement of the projection subspace.
     Lemma 4.4(iii) of [Beran] p. 111.  (Contributed by NM, 24-Apr-2006.)
     (New usage is discouraged.) $)
  pjoc2 $p |- ( ( H e. CH /\ A e. ~H ) ->
               ( A e. ( _|_ ` H ) <-> ( ( projh ` H ) ` A ) = 0h ) ) $=
    ( cch wcel chil cort cfv cpjh c0v wceq c0h cif eleq2d fveq1d eqeq1d bibi12d
    wb fveq2 eleq1 elimel h0elch ax-hv0cl pjoc2i dedth2h ) BCDZAEDZABFGZDZABHGZ
    GZIJZQAUEBKLZFGZDZAULHGZGZIJZQUFAILZUMDZURUOGZIJZQBAKIBULJZUHUNUKUQVBUGUMAB
    ULFRMVBUJUPIVBAUIUOBULHRNOPAURJZUNUSUQVAAURUMSVCUPUTIAURUOROPURULBKCUATAIEU
    BTUCUD $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Hilbert lattice operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The zero subspace is the smallest subspace.  (Contributed by NM,
     3-Jun-2004.)  (New usage is discouraged.) $)
  sh0le $p |- ( A e. SH -> 0H C_ A ) $=
    ( csh wcel c0h c0v csn df-ch0 sh0 snssd syl5eqss ) ABCZDEFAGKEAAHIJ $.

  $( The zero subspace is the smallest member of ` CH ` .  (Contributed by NM,
     14-Aug-2002.)  (New usage is discouraged.) $)
  ch0le $p |- ( A e. CH -> 0H C_ A ) $=
    ( cch wcel csh c0h wss chsh sh0le syl ) ABCADCEAFAGAHI $.

  $( No subspace is smaller than the zero subspace.  (Contributed by NM,
     24-Nov-2004.)  (New usage is discouraged.) $)
  shle0 $p |- ( A e. SH -> ( A C_ 0H <-> A = 0H ) ) $=
    ( csh wcel c0h wss wa wceq sh0le biantrud eqss syl6bbr ) ABCZADEZMDAEZFADGL
    NMAHIADJK $.

  $( No Hilbert lattice element is smaller than zero.  (Contributed by NM,
     14-Aug-2002.)  (New usage is discouraged.) $)
  chle0 $p |- ( A e. CH -> ( A C_ 0H <-> A = 0H ) ) $=
    ( cch wcel csh c0h wss wceq wb chsh shle0 syl ) ABCADCAEFAEGHAIAJK $.

  $( A Hilbert lattice element that is not a subset of another is nonzero.
     (Contributed by NM, 30-Jun-2004.)  (New usage is discouraged.) $)
  chnlen0 $p |- ( B e. CH -> ( -. A C_ B -> -. A = 0H ) ) $=
    ( cch wcel c0h wceq wss ch0le sseq1 syl5ibrcom con3d ) BCDZAEFZABGZLNMEBGBH
    AEBIJK $.

  $( The zero subspace is a proper subset of nonzero Hilbert lattice elements.
     (Contributed by NM, 9-Jun-2004.)  (New usage is discouraged.) $)
  ch0pss $p |- ( A e. CH -> ( 0H C. A <-> A =/= 0H ) ) $=
    ( cch wcel c0h wne wss wpss necom ch0le biantrurd syl5bbr df-pss syl6rbbr
    wa ) ABCZADEZDAFZDAEZNZDAGPROSDAHOQRAIJKDALM $.

  $( The intersection of orthogonal subspaces is the zero subspace.
     (Contributed by NM, 24-Jun-2004.)  (New usage is discouraged.) $)
  orthin $p |- ( ( A e. SH /\ B e. SH ) ->
               ( A C_ ( _|_ ` B ) -> ( A i^i B ) = 0H ) ) $=
    ( csh wcel wa cort cfv wss cin c0h wceq wi ssrin incom syl6sseq ocin sseq2d
    syl5ib adantl shincl sh0le syl jctird eqss syl6ibr ) ACDZBCDZEZABFGZHZABIZJ
    HZJUKHZEUKJKUHUJULUMUGUJULLUFUJUKBUIIZHUGULUJUKUIBIUNAUIBMUIBNOUGUNJUKBPQRS
    UHUKCDUMABTUKUAUBUCUKJUDUE $.

  $( The lattice join of a subset with its orthocomplement is the whole space.
     (Contributed by Mario Carneiro, 15-May-2014.)
     (New usage is discouraged.) $)
  ssjo $p |- ( A C_ ~H -> ( A vH ( _|_ ` A ) ) = ~H ) $=
    ( chil wss cort cfv chj co cun wceq ocss sshjval mpdan c0h cin wi occon mpi
    csh wcel ocsh ssun1 ancli unss sylib ssun2 syl2anc ssind ocin sseqtrd sh0le
    wa syl 3syl eqssd fveq2d choc0 syl6eq eqtrd ) ABCZAADEZFGZAUTHZDEZDEZBUSUTB
    CZVAVDIAJZAUTKLUSVDMDEBUSVCMDUSVCMUSVCUTUTDEZNZMUSVCUTVGUSAVBCZVCUTCZAUTUAU
    SVBBCZVIVJOUSUSVEUKVKUSVEVFUBAUTBUCUDZAVBPLQUSUTVBCZVCVGCZUTAUEUSVEVKVMVNOV
    FVLUTVBPUFQUGUSUTRSVHMIATUTUHULUIUSVKVCRSMVCCVLVBTVCUJUMUNUOUPUQUR $.

  ${
    $d x y A $.
    shne0.1 $e |- A e. SH $.
    $( A nonzero subspace has a nonzero vector.  (Contributed by NM,
       25-Feb-2006.)  (New usage is discouraged.) $)
    shne0i $p |- ( A =/= 0H <-> E. x e. A x =/= 0h ) $=
      ( c0h wne wceq wn cv wcel wrex c0v df-ne wa wex wss df-rex nss csh shle0
      wb ax-mp notbii 3bitr2ri elch0 necon3bbii rexbii 3bitri ) BDEBDFZGZAHZDIZ
      GZABJZUJKEZABJBDLUMUJBIULMANBDOZGUIULABPABDQUOUHBRIUOUHTCBSUAUBUCULUNABUK
      UJKUJUDUEUFUG $.

    $( Hilbert subspace sum with the zero subspace.  (Contributed by NM,
       14-Jan-2005.)  (New usage is discouraged.) $)
    shs0i $p |- ( A +H 0H ) = A $=
      ( c0h cph co cun cspn cfv h0elsh shsval3i wss wceq csh wcel sh0le ssequn2
      ax-mp mpbi fveq2i spanid 3eqtri ) ACDEACFZGHAGHZAACBIJUBAGCAKZUBALAMNZUDB
      AOQCAPRSUEUCALBATQUA $.

    ${
      shs00.2 $e |- B e. SH $.
      $( Two subspaces are zero iff their join is zero.  (Contributed by NM,
         7-Aug-2004.)  (New usage is discouraged.) $)
      shs00i $p |- ( ( A = 0H /\ B = 0H ) <-> ( A +H B ) = 0H ) $=
        ( c0h wceq wa cph co oveq12 h0elsh wss sseq2 mpbii csh wcel shle0 ax-mp
        wb sylib shs0i syl6eq shsub1i shsub2i jca impbii ) AEFZBEFZGZABHIZEFZUI
        UJEEHIEAEBEHJEKUAUBUKUGUHUKAELZUGUKAUJLULABCDUCUJEAMNAOPULUGSCAQRTUKBEL
        ZUHUKBUJLUMBADCUDUJEBMNBOPUMUHSDBQRTUEUF $.
    $}
  $}

  ${
    $d x y A $.
    ch0le.1 $e |- A e. CH $.
    $( The closed subspace zero is the smallest member of ` CH ` .
       (Contributed by NM, 15-Oct-1999.)  (New usage is discouraged.) $)
    ch0lei $p |- 0H C_ A $=
      ( cch wcel c0h wss ch0le ax-mp ) ACDEAFBAGH $.

    $( No Hilbert closed subspace is smaller than zero.  (Contributed by NM,
       7-Apr-2001.)  (New usage is discouraged.) $)
    chle0i $p |- ( A C_ 0H <-> A = 0H ) $=
      ( cch wcel c0h wss wceq wb chle0 ax-mp ) ACDAEFAEGHBAIJ $.

    $( A nonzero closed subspace has a nonzero vector.  (Contributed by NM,
       25-Feb-2006.)  (New usage is discouraged.) $)
    chne0i $p |- ( A =/= 0H <-> E. x e. A x =/= 0h ) $=
      ( chshii shne0i ) ABBCDE $.

    $( Intersection of a closed subspace and its orthocomplement.  Part of
       Proposition 1 of [Kalmbach] p. 65.  (Contributed by NM, 11-Oct-1999.)
       (New usage is discouraged.) $)
    chocini $p |- ( A i^i ( _|_ ` A ) ) = 0H $=
      ( csh wcel cort cfv cin c0h wceq chshii ocin ax-mp ) ACDAAEFGHIABJAKL $.

    $( Join with lattice zero in ` CH ` .  (Contributed by NM, 15-Oct-1999.)
       (New usage is discouraged.) $)
    chj0i $p |- ( A vH 0H ) = A $=
      ( c0h chj cun cort cfv h0elch chjvali wss wceq ch0lei ssequn2 mpbi fveq2i
      co pjococi 3eqtri ) ACDPACEZFGZFGAFGZFGAACBHITUAFSAFCAJSAKABLCAMNOOABQR
      $.

    $( Meet with lattice one in ` CH ` .  (Contributed by NM, 24-Oct-1999.)
       (New usage is discouraged.) $)
    chm1i $p |- ( A i^i ~H ) = A $=
      ( chil wss cin wceq chssii df-ss mpbi ) ACDACEAFABGACHI $.

    ${
      $d x y B $.  $d x y C $.
      chjcl.2 $e |- B e. CH $.
      $( Closure of ` CH ` join.  (Contributed by NM, 29-Jul-1999.)
         (New usage is discouraged.) $)
      chjcli $p |- ( A vH B ) e. CH $=
        ( chshii shjcli ) ABACEBDEF $.

      $( Subspace sum is smaller than subspace join.  Remark in [Kalmbach]
         p. 65.  (Contributed by NM, 17-Oct-1999.)
         (New usage is discouraged.) $)
      chsleji $p |- ( A +H B ) C_ ( A vH B ) $=
        ( chshii shsleji ) ABACEBDEF $.

      $( Membership in subspace sum.  (Contributed by NM, 19-Oct-1999.)
         (New usage is discouraged.) $)
      chseli $p |- ( C e. ( A +H B )
           <-> E. x e. A E. y e. B C = ( x +h y ) ) $=
        ( chshii shseli ) ABCDECFHDGHI $.

      $( Closure of Hilbert lattice intersection.  (Contributed by NM,
         15-Oct-1999.)  (New usage is discouraged.) $)
      chincli $p |- ( A i^i B ) e. CH $=
        ( cpr cint cin cch elexi intpr wss c0 wne wcel wa pm3.2i prss mpbi prnz
        chintcli eqeltrri ) ABEZFABGHABAHCIZBHDIZJUBUBHKZUBLMAHNZBHNZOUEUFUGCDP
        ABHUCUDQRABUCSPTUA $.

      $( Hilbert lattice contraposition law.  (Contributed by NM,
         15-Oct-1999.)  (New usage is discouraged.) $)
      chsscon3i $p |- ( A C_ B <-> ( _|_ ` B ) C_ ( _|_ ` A ) ) $=
        ( wss cort cfv chil chssii occon mp2an choccli pjococi 3sstr3g impbii
        wi ) ABEZBFGZAFGZEZAHEBHEQTPACIBDIABJKTSFGZRFGZABRHESHETUAUBEPRBDLISACL
        IRSJKACMBDMNO $.

      $( Hilbert lattice contraposition law.  (Contributed by NM,
         15-Oct-1999.)  (New usage is discouraged.) $)
      chsscon1i $p |- ( ( _|_ ` A ) C_ B <-> ( _|_ ` B ) C_ A ) $=
        ( cort cfv wss choccli chsscon3i pjococi sseq2i bitri ) AEFZBGBEFZMEFZG
        NAGMBACHDIOANACJKL $.

      $( Hilbert lattice contraposition law.  (Contributed by NM,
         15-Oct-1999.)  (New usage is discouraged.) $)
      chsscon2i $p |- ( A C_ ( _|_ ` B ) <-> B C_ ( _|_ ` A ) ) $=
        ( chil wss cort cfv wb chssii occon3 mp2an ) AEFBEFABGHFBAGHFIACJBDJABK
        L $.

      $( Hilbert lattice contraposition law.  (Contributed by NM,
         24-Jun-2004.)  (New usage is discouraged.) $)
      chcon2i $p |- ( A = ( _|_ ` B ) <-> B = ( _|_ ` A ) ) $=
        ( cort cfv wss wa wceq chsscon2i chsscon1i anbi12i eqss 3bitr4i ) ABEFZ
        GZOAGZHBAEFZGZRBGZHAOIBRIPSQTABCDJBADCKLAOMBRMN $.

      $( Hilbert lattice contraposition law.  (Contributed by NM,
         15-Jun-2006.)  (New usage is discouraged.) $)
      chcon1i $p |- ( ( _|_ ` A ) = B <-> ( _|_ ` B ) = A ) $=
        ( cort cfv wceq chcon2i eqcom 3bitr4i ) BAEFZGABEFZGKBGLAGBADCHKBILAIJ
        $.

      $( Hilbert lattice contraposition law.  (Contributed by NM,
         24-Jun-2004.)  (New usage is discouraged.) $)
      chcon3i $p |- ( A = B <-> ( _|_ ` B ) = ( _|_ ` A ) ) $=
        ( wss wa cort cfv wceq chsscon3i anbi12i eqss 3bitr4i ) ABEZBAEZFBGHZAG
        HZEZQPEZFABIPQINROSABCDJBADCJKABLPQLM $.

      $( Union is smaller than ` CH ` join.  (Contributed by NM, 15-Oct-1999.)
         (New usage is discouraged.) $)
      chunssji $p |- ( A u. B ) C_ ( A vH B ) $=
        ( chshii shunssji ) ABACEBDEF $.

      $( Commutative law for join in ` CH ` .  (Contributed by NM,
         14-Oct-1999.)  (New usage is discouraged.) $)
      chjcomi $p |- ( A vH B ) = ( B vH A ) $=
        ( chshii shjcomi ) ABACEBDEF $.

      $( ` CH ` join is an upper bound of two elements.  (Contributed by NM,
         15-Oct-1999.)  (New usage is discouraged.) $)
      chub1i $p |- A C_ ( A vH B ) $=
        ( chshii shub1i ) ABACEBDEF $.

      $( ` CH ` join is an upper bound of two elements.  (Contributed by NM,
         5-Nov-2000.)  (New usage is discouraged.) $)
      chub2i $p |- A C_ ( B vH A ) $=
        ( chj co chub1i chjcomi sseqtri ) AABEFBAEFABCDGABCDHI $.

      ${
        $d x y C $.
        chlub.1 $e |- C e. CH $.
        $( Hilbert lattice join is the least upper bound of two elements.
           (Contributed by NM, 11-Jun-2004.)  (New usage is discouraged.) $)
        chlubi $p |- ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) $=
          ( chshii shlubi ) ABCADGBEGFH $.

        $( Hilbert lattice join is the least upper bound of two elements (one
           direction of ~ chlubi ).  (Contributed by NM, 15-Oct-1999.)
           (New usage is discouraged.) $)
        chlubii $p |- ( ( A C_ C /\ B C_ C ) -> ( A vH B ) C_ C ) $=
          ( wss wa chj co chlubi biimpi ) ACGBCGHABIJCGABCDEFKL $.

        $( Add join to both sides of a Hilbert lattice ordering.  (Contributed
           by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
        chlej1i $p |- ( A C_ B -> ( A vH C ) C_ ( B vH C ) ) $=
          ( chshii shlej1i ) ABCADGBEGCFGH $.

        $( Add join to both sides of a Hilbert lattice ordering.  (Contributed
           by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
        chlej2i $p |- ( A C_ B -> ( C vH A ) C_ ( C vH B ) ) $=
          ( chshii shlej2i ) ABCADGBEGCFGH $.

        ${
          chlej12.4 $e |- D e. CH $.
          $( Add join to both sides of a Hilbert lattice ordering.
             (Contributed by NM, 19-Oct-1999.)  (New usage is discouraged.) $)
          chlej12i $p |- ( ( A C_ B /\ C C_ D ) ->
                       ( A vH C ) C_ ( B vH D ) ) $=
            ( wss chj co chlej1i chlej2i sylan9ss ) ABICDIACJKBCJKBDJKABCEFGLCD
            BGHFMN $.
        $}
      $}

      $( Hilbert lattice ordering in terms of join.  (Contributed by NM,
         15-Oct-1999.)  (New usage is discouraged.) $)
      chlejb1i $p |- ( A C_ B <-> ( A vH B ) = B ) $=
        ( wss chj co wceq wa ssid chlubii mpan2 chub2i jctir eqss sylibr chub1i
        eqimss syl5ss impbii ) ABEZABFGZBHZUAUBBEZBUBEZIUCUAUDUEUABBEUDBJABBCDD
        KLBADCMNUBBOPUCAUBBABCDQUBBRST $.

      $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmm1i $p |- ( _|_ ` ( A i^i B ) ) = ( ( _|_ ` A ) vH ( _|_ ` B ) ) $=
        ( cin cort cfv chj co choccli chub1i chjcli chsscon1i mpbi chub2i ssini
        wss chincli inss1 chsscon3i inss2 chlubii mp2an eqssi ) ABEZFGZAFGZBFGZ
        HIZUIFGZUEQUFUIQUJABUGUIQUJAQUGUHACJZBDJZKAUICUGUHUKULLZMNUHUIQUJBQUHUG
        ULUKOBUIDUMMNPUIUEUMABCDRZMNUGUFQZUHUFQZUIUFQUEAQUOABSUEAUNCTNUEBQUPABU
        AUEBUNDTNUGUHUFUKULUEUNJUBUCUD $.

      $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmm2i $p |- ( _|_ ` ( ( _|_ ` A ) i^i B ) ) = ( A vH ( _|_ ` B ) ) $=
        ( cort cfv cin chj co choccli chdmm1i pjococi oveq1i eqtri ) AEFZBGEFOE
        FZBEFZHIAQHIOBACJDKPAQHACLMN $.

      $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmm3i $p |- ( _|_ ` ( A i^i ( _|_ ` B ) ) ) = ( ( _|_ ` A ) vH B ) $=
        ( cort cfv cin chj co choccli chdmm1i pjococi oveq2i eqtri ) ABEFZGEFAE
        FZOEFZHIPBHIAOCBDJKQBPHBDLMN $.

      $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmm4i $p |- ( _|_ ` ( ( _|_ ` A ) i^i ( _|_ ` B ) ) ) = ( A vH B ) $=
        ( cort cfv cin chj co choccli chdmm2i pjococi oveq2i eqtri ) AEFBEFZGEF
        AOEFZHIABHIAOCBDJKPBAHBDLMN $.

      $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmj1i $p |- ( _|_ ` ( A vH B ) ) = ( ( _|_ ` A ) i^i ( _|_ ` B ) ) $=
        ( cort cfv cin chj co chdmm4i fveq2i choccli chincli pjococi eqtr3i ) A
        EFZBEFZGZEFZEFABHIZEFRSTEABCDJKRPQACLBDLMNO $.

      $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmj2i $p |- ( _|_ ` ( ( _|_ ` A ) vH B ) ) = ( A i^i ( _|_ ` B ) ) $=
        ( cort cfv chj co cin choccli chdmj1i pjococi ineq1i eqtri ) AEFZBGHEFO
        EFZBEFZIAQIOBACJDKPAQACLMN $.

      $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmj3i $p |- ( _|_ ` ( A vH ( _|_ ` B ) ) ) = ( ( _|_ ` A ) i^i B ) $=
        ( cort cfv chj co cin choccli chdmj1i pjococi ineq2i eqtri ) ABEFZGHEFA
        EFZOEFZIPBIAOCBDJKQBPBDLMN $.

      $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
         21-Jun-2004.)  (New usage is discouraged.) $)
      chdmj4i $p |- ( _|_ ` ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) = ( A i^i B ) $=
        ( cort cfv chj co cin choccli chdmj2i pjococi ineq2i eqtri ) AEFBEFZGHE
        FAOEFZIABIAOCBDJKPBABDLMN $.

      $( Equivalent expressions for "not less than" in the Hilbert lattice.
         (Contributed by NM, 5-Jun-2004.)  (New usage is discouraged.) $)
      chnlei $p |- ( -. B C_ A <-> A C. ( A vH B ) ) $=
        ( chj co wceq wn wss wpss chub1i biantrur chlejb1i eqcom chjcomi eqeq2i
        wa 3bitri notbii dfpss2 3bitr4i ) AABEFZGZHZAUBIZUDQBAIZHAUBJUEUDABCDKL
        UFUCUFBAEFZAGAUGGUCBADCMUGANUGUBABADCOPRSAUBTUA $.

      ${
        chjass.3 $e |- C e. CH $.
        $( Associative law for Hilbert lattice join.  From definition of
           lattice in [Kalmbach] p. 14.  (Contributed by NM, 10-Jun-2004.)
           (New usage is discouraged.) $)
        chjassi $p |- ( ( A vH B ) vH C ) = ( A vH ( B vH C ) ) $=
          ( chj cort cfv cin inass chdmj1i ineq1i ineq2i 3eqtr4i fveq2i chdmm4i
          co chjcli 3eqtr3i ) ABGRZHIZCHIZJZHIAHIZBCGRZHIZJZHIUACGRAUFGRUDUHHUE
          BHIZJZUCJUEUIUCJZJUDUHUEUIUCKUBUJUCABDELMUGUKUEBCEFLNOPUACABDESFQAUFD
          BCEFSQT $.
      $}

      $( Two Hilbert lattice elements are zero iff their join is zero.
         (Contributed by NM, 7-Aug-2004.)  (New usage is discouraged.) $)
      chj00i $p |- ( ( A = 0H /\ B = 0H ) <-> ( A vH B ) = 0H ) $=
        ( c0h wceq wa chj co oveq12 h0elch chj0i syl6eq wss chub1i sseq2 chle0i
        mpbii sylib chub2i jca impbii ) AEFZBEFZGZABHIZEFZUEUFEEHIEAEBEHJEKLMUG
        UCUDUGAENZUCUGAUFNUHABCDOUFEAPRACQSUGBENZUDUGBUFNUIBADCTUFEBPRBDQSUAUB
        $.
    $}

    $( The join of a closed subspace and its orthocomplement.  (Contributed by
       NM, 24-Oct-1999.)  (New usage is discouraged.) $)
    chjoi $p |- ( A vH ( _|_ ` A ) ) = ~H $=
      ( chil wss cort cfv chj co wceq chssii ssjo ax-mp ) ACDAAEFGHCIABJAKL $.

    $( Join with Hilbert lattice unit.  (Contributed by NM, 6-Aug-2004.)
       (New usage is discouraged.) $)
    chj1i $p |- ( A vH ~H ) = ~H $=
      ( chil chj co helch chjcli chssii chub2i eqssi ) ACDEZCKACBFGHCAFBIJ $.

    $( Meet with Hilbert lattice zero.  (Contributed by NM, 6-Aug-2004.)
       (New usage is discouraged.) $)
    chm0i $p |- ( A i^i 0H ) = 0H $=
      ( c0h cin inss2 ch0lei ssid ssini eqssi ) ACDCACECACABFCGHI $.

  $}

  $( Meet with Hilbert lattice zero.  (Contributed by NM, 14-Jun-2006.)
     (New usage is discouraged.) $)
  chm0 $p |- ( A e. CH -> ( A i^i 0H ) = 0H ) $=
    ( cch wcel c0h cin wceq cif ineq1 eqeq1d h0elch elimel chm0i dedth ) ABCZAD
    EZDFNADGZDEZDFADAPFOQDAPDHIPADBJKLM $.

  ${
    shjshs.1 $e |- A e. SH $.
    shjshs.2 $e |- B e. SH $.
    $( Hilbert lattice join equals the double orthocomplement of subspace sum.
       (Contributed by NM, 27-Nov-2004.)  (New usage is discouraged.) $)
    shjshsi $p |- ( A vH B ) = ( _|_ ` ( _|_ ` ( A +H B ) ) ) $=
      ( chj cph cort cfv cun csh wcel wceq shjval mp2an wss shunssi chil shssii
      co ax-mp unssi shscli occon2i eqsstri shsleji wi shjcli chssii occon occl
      cch chsscon1i mpbi eqssi ) ABESZABFSZGHZGHZUOABIZGHGHZURAJKBJKUOUTLCDABMN
      USUPOUTUROABCDPUSUPABQACRBDRUAUPABCDUBRZUCTUDUOGHUQOZURUOOUPUOOZVBABCDUEU
      PQOZUOQOVCVBUFVAUOABCDUGZUHUPUOUINTUOUQVEVDUQUKKVAUPUJTULUMUN $.

    $( A closed subspace sum equals Hilbert lattice join.  Part of Lemma 31.1.5
       of [MaedaMaeda] p. 136.  (Contributed by NM, 30-Nov-2004.)
       (New usage is discouraged.) $)
    shjshseli $p |- ( ( A +H B ) e. CH <-> ( A +H B ) = ( A vH B ) ) $=
      ( cph cch wcel chj wceq cort cfv shjshsi ococ syl5req shjcli eleq1 mpbiri
      co impbii ) ABERZFGZTABHRZIZUAUBTJKJKTABCDLTMNUCUAUBFGABCDOTUBFPQS $.
  $}

  ${
    $d x A $.
    $( A nonzero closed subspace has a nonzero vector.  (Contributed by NM,
       25-Feb-2006.)  (New usage is discouraged.) $)
    chne0 $p |- ( A e. CH -> ( A =/= 0H <-> E. x e. A x =/= 0h ) ) $=
      ( cch wcel c0h wne cv c0v wrex cif wceq neeq1 rexeq bibi12d h0elch elimel
      wb chne0i dedth ) BCDZBEFZAGHFZABIZQTBEJZEFZUBAUDIZQBEBUDKUAUEUCUFBUDELUB
      ABUDMNAUDBECOPRS $.
  $}

  $( Intersection of a closed subspace and its orthocomplement.  Part of
     Proposition 1 of [Kalmbach] p. 65.  (Contributed by NM, 13-Jun-2006.)
     (New usage is discouraged.) $)
  chocin $p |- ( A e. CH -> ( A i^i ( _|_ ` A ) ) = 0H ) $=
    ( cch wcel cort cfv cin c0h wceq cif id fveq2 ineq12d eqeq1d h0elch chocini
    elimel dedth ) ABCZAADEZFZGHRAGIZUADEZFZGHAGAUAHZTUCGUDAUASUBUDJAUADKLMUAAG
    BNPOQ $.

  $( A closed subspace less than its orthocomplement is zero.  (Contributed by
     NM, 14-Jun-2006.)  (New usage is discouraged.) $)
  chssoc $p |- ( A e. CH -> ( A C_ ( _|_ ` A ) <-> A = 0H ) ) $=
    ( cch wcel cort cfv wss c0h inidm sslin syl5eqssr chocin sseq2d chle0 bitrd
    wceq cin syl5ib wa simpr choccl ch0le syl adantr eqsstrd ex impbid ) ABCZAA
    DEZFZAGOZUIAAUHPZFZUGUJUIAAAPUKAHAUHAIJUGULAGFUJUGUKGAAKLAMNQUGUJUIUGUJRAGU
    HUGUJSUGGUHFZUJUGUHBCUMATUHUAUBUCUDUEUF $.

  $( Join with Hilbert lattice zero.  (Contributed by NM, 22-Jun-2004.)
     (New usage is discouraged.) $)
  chj0 $p |- ( A e. CH -> ( A vH 0H ) = A ) $=
    ( cch wcel c0h chj co wceq cif oveq1 id eqeq12d h0elch elimel chj0i dedth )
    ABCZADEFZAGPADHZDEFZRGADARGZQSARARDEITJKRADBLMNO $.

  $( Subspace sum is smaller than subspace join.  Remark in [Kalmbach] p. 65.
     (Contributed by NM, 12-Jul-2004.)  (New usage is discouraged.) $)
  chslej $p |- ( ( A e. CH /\ B e. CH ) -> ( A +H B ) C_ ( A vH B ) ) $=
    ( cch wcel csh cph co chj wss chsh shslej syl2an ) ACDAEDBEDABFGABHGIBCDAJB
    JABKL $.

  $( Closure of Hilbert lattice intersection.  (Contributed by NM,
     15-Jun-2004.)  (New usage is discouraged.) $)
  chincl $p |- ( ( A e. CH /\ B e. CH ) -> ( A i^i B ) e. CH ) $=
    ( cch wcel cin chil wceq ineq1 eleq1d ineq2 helch elimel chincli dedth2h
    cif ) ACDZBCDZABEZCDPAFOZBEZCDSQBFOZEZCDABFFASGRTCASBHIBUAGTUBCBUASJISUAAFC
    KLBFCKLMN $.

  $( Hilbert lattice contraposition law.  (Contributed by NM, 12-Jun-2004.)
     (New usage is discouraged.) $)
  chsscon3 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C_ B <-> ( _|_ ` B ) C_ ( _|_ ` A ) ) ) $=
    ( cch wcel wss cort cfv wb chil cif sseq1 fveq2 sseq2d bibi12d sseq2 sseq1d
    wceq helch elimel chsscon3i dedth2h ) ACDZBCDZABEZBFGZAFGZEZHUBAIJZBEZUEUHF
    GZEZHUHUCBIJZEZULFGZUJEZHABIIAUHQZUDUIUGUKAUHBKUPUFUJUEAUHFLMNBULQZUIUMUKUO
    BULUHOUQUEUNUJBULFLPNUHULAICRSBICRSTUA $.

  $( Hilbert lattice contraposition law.  (Contributed by NM, 21-Jun-2004.)
     (New usage is discouraged.) $)
  chsscon1 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( ( _|_ ` A ) C_ B <-> ( _|_ ` B ) C_ A ) ) $=
    ( cch wcel wa cort cfv wss wb choccl chsscon3 sylan wceq ococ adantr sseq2d
    bitrd ) ACDZBCDZEZAFGZBHZBFGZUAFGZHZUCAHRUACDSUBUEIAJUABKLTUDAUCRUDAMSANOPQ
    $.

  $( Hilbert lattice contraposition law.  (Contributed by NM, 21-Jun-2004.)
     (New usage is discouraged.) $)
  chsscon2 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C_ ( _|_ ` B ) <-> B C_ ( _|_ ` A ) ) ) $=
    ( cch wcel chil wss cort cfv wb chss occon3 syl2an ) ACDAEFBEFABGHFBAGHFIBC
    DAJBJABKL $.

  $( Hilbert lattice contraposition law for strict ordering.  (Contributed by
     NM, 12-Jun-2004.)  (New usage is discouraged.) $)
  chpsscon3 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C. B <-> ( _|_ ` B ) C. ( _|_ ` A ) ) ) $=
    ( cch wcel wa wss wn cort cfv wpss chsscon3 wb ancoms notbid anbi12d dfpss3
    3bitr4g ) ACDZBCDZEZABFZBAFZGZEBHIZAHIZFZUEUDFZGZEABJUDUEJTUAUFUCUHABKTUBUG
    SRUBUGLBAKMNOABPUDUEPQ $.

  $( Hilbert lattice contraposition law for strict ordering.  (Contributed by
     NM, 12-Jun-2004.)  (New usage is discouraged.) $)
  chpsscon1 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( ( _|_ ` A ) C. B <-> ( _|_ ` B ) C. A ) ) $=
    ( cch wcel wa cort cfv wpss choccl chpsscon3 sylan wceq ococ adantr psseq2d
    wb bitrd ) ACDZBCDZEZAFGZBHZBFGZUAFGZHZUCAHRUACDSUBUEPAIUABJKTUDAUCRUDALSAM
    NOQ $.

  $( Hilbert lattice contraposition law for strict ordering.  (Contributed by
     NM, 12-Jun-2004.)  (New usage is discouraged.) $)
  chpsscon2 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( A C. ( _|_ ` B ) <-> B C. ( _|_ ` A ) ) ) $=
    ( cch wcel wa cort wpss wb choccl chpsscon3 sylan2 wceq ococ adantl psseq1d
    cfv bitrd ) ACDZBCDZEZABFPZGZUAFPZAFPZGZBUDGSRUACDUBUEHBIAUAJKTUCBUDSUCBLRB
    MNOQ $.

  $( Commutative law for Hilbert lattice join.  (Contributed by NM,
     12-Jun-2004.)  (New usage is discouraged.) $)
  chjcom $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH B ) = ( B vH A ) ) $=
    ( cch wcel csh chj co wceq chsh shjcom syl2an ) ACDAEDBEDABFGBAFGHBCDAIBIAB
    JK $.

  $( Hilbert lattice join is greater than or equal to its first argument.
     (Contributed by NM, 12-Jun-2004.)  (New usage is discouraged.) $)
  chub1 $p |- ( ( A e. CH /\ B e. CH ) -> A C_ ( A vH B ) ) $=
    ( cch wcel csh chj co wss chsh shub1 syl2an ) ACDAEDBEDAABFGHBCDAIBIABJK $.

  $( Hilbert lattice join is greater than or equal to its second argument.
     (Contributed by NM, 12-Jun-2004.)  (New usage is discouraged.) $)
  chub2 $p |- ( ( A e. CH /\ B e. CH ) -> A C_ ( B vH A ) ) $=
    ( cch wcel wa chj co chub1 chjcom sseqtrd ) ACDBCDEAABFGBAFGABHABIJ $.

  $( Hilbert lattice join is the least upper bound of two elements.
     (Contributed by NM, 12-Jun-2004.)  (New usage is discouraged.) $)
  chlub $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
               ( ( A C_ C /\ B C_ C ) <-> ( A vH B ) C_ C ) ) $=
    ( cch wcel csh wss wa chj co wb chsh shlub syl3an2 syl3an1 ) ADEAFEZBDEZCDE
    ZACGBCGHABIJCGKZALQPBFERSBLABCMNO $.

  $( Add join to both sides of Hilbert lattice ordering.  (Contributed by NM,
     22-Jun-2004.)  (New usage is discouraged.) $)
  chlej1 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
                A C_ B ) -> ( A vH C ) C_ ( B vH C ) ) $=
    ( cch wcel csh wss chj co chsh shlej1 syl3anl ) ADEAFEBDEBFECDECFEABGACHIBC
    HIGAJBJCJABCKL $.

  $( Add join to both sides of Hilbert lattice ordering.  (Contributed by NM,
     22-Jun-2004.)  (New usage is discouraged.) $)
  chlej2 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
                A C_ B ) -> ( C vH A ) C_ ( C vH B ) ) $=
    ( cch wcel csh wss chj co chsh shlej2 syl3anl ) ADEAFEBDEBFECDECFEABGCAHICB
    HIGAJBJCJABCKL $.

  $( Hilbert lattice ordering in terms of join.  (Contributed by NM,
     30-Jun-2004.)  (New usage is discouraged.) $)
  chlejb1 $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_ B <-> ( A vH B ) = B ) ) $=
    ( cch wcel wss chj co wceq wb c0h sseq1 oveq1 eqeq1d bibi12d sseq2 oveq2 id
    cif h0elch elimel eqeq12d chlejb1i dedth2h ) ACDZBCDZABEZABFGZBHZIUDAJRZBEZ
    UIBFGZBHZIUIUEBJRZEZUIUMFGZUMHZIABJJAUIHZUFUJUHULAUIBKUQUGUKBAUIBFLMNBUMHZU
    JUNULUPBUMUIOURUKUOBUMBUMUIFPURQUANUIUMAJCSTBJCSTUBUC $.

  $( Hilbert lattice ordering in terms of join.  (Contributed by NM,
     2-Jul-2004.)  (New usage is discouraged.) $)
  chlejb2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_ B <-> ( B vH A ) = B ) ) $=
    ( cch wcel wa wss chj co wceq chlejb1 chjcom eqeq1d bitrd ) ACDBCDEZABFABGH
    ZBIBAGHZBIABJNOPBABKLM $.

  $( Equivalent expressions for "not less than" in the Hilbert lattice.
     (Contributed by NM, 9-Jun-2004.)  (New usage is discouraged.) $)
  chnle $p |- ( ( A e. CH /\ B e. CH ) ->
               ( -. B C_ A <-> A C. ( A vH B ) ) ) $=
    ( cch wcel wss wn chj co wpss wb c0h cif wceq sseq2 notbid id oveq1 bibi12d
    h0elch elimel psseq12d sseq1 oveq2 psseq2d chnlei dedth2h ) ACDZBCDZBAEZFZA
    ABGHZIZJBUGAKLZEZFZUMUMBGHZIZJUHBKLZUMEZFZUMUMURGHZIZJABKKAUMMZUJUOULUQVCUI
    UNAUMBNOVCAUMUKUPVCPAUMBGQUARBURMZUOUTUQVBVDUNUSBURUMUBOVDUPVAUMBURUMGUCUDR
    UMURAKCSTBKCSTUEUF $.

  $( The join of a closed subspace and its orthocomplement is all of Hilbert
     space.  (Contributed by NM, 31-Oct-2005.)  (New usage is discouraged.) $)
  chjo $p |- ( A e. CH -> ( A vH ( _|_ ` A ) ) = ~H ) $=
    ( cch wcel cort cfv chj co chil wceq cif id fveq2 eqeq1d helch elimel chjoi
    oveq12d dedth ) ABCZAADEZFGZHISAHJZUBDEZFGZHIAHAUBIZUAUDHUEAUBTUCFUEKAUBDLQ
    MUBAHBNOPR $.

  $( Hilbert lattice absorption law.  From definition of lattice in [Kalmbach]
     p. 14.  (Contributed by NM, 15-Jun-2004.)  (New usage is discouraged.) $)
  chabs1 $p |- ( ( A e. CH /\ B e. CH ) -> ( A vH ( A i^i B ) ) = A ) $=
    ( cch wcel wa cin chj co wss ssid inss1 pm3.2i wb simpl chlub syl3anc mpbii
    chincl chub1 syldan eqssd ) ACDZBCDZEZAABFZGHZAUDAAIZUEAIZEZUFAIZUGUHAJABKL
    UDUBUECDZUBUIUJMUBUCNZABRZULAUEAOPQUBUCUKAUFIUMAUESTUA $.

  $( Hilbert lattice absorption law.  From definition of lattice in [Kalmbach]
     p. 14.  (Contributed by NM, 16-Jun-2004.)  (New usage is discouraged.) $)
  chabs2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A i^i ( A vH B ) ) = A ) $=
    ( cch wcel wa chj co cin wceq chub1 ssid jctil ssin sylib inss1 eqss sylibr
    wss ) ACDBCDEZAABFGZHZARZAUARZEUAAISUCUBSAARZATRZEUCSUEUDABJAKLAATMNATOLUAA
    PQ $.

  ${
    chabs.1 $e |- A e. CH $.
    chabs.2 $e |- B e. CH $.
    $( Hilbert lattice absorption law.  From definition of lattice in
       [Kalmbach] p. 14.  (Contributed by NM, 10-Jun-2004.)
       (New usage is discouraged.) $)
    chabs1i $p |- ( A vH ( A i^i B ) ) = A $=
      ( cch wcel cin chj co wceq chabs1 mp2an ) AEFBEFAABGHIAJCDABKL $.

    $( Hilbert lattice absorption law.  From definition of lattice in
       [Kalmbach] p. 14.  (Contributed by NM, 16-Jun-2004.)
       (New usage is discouraged.) $)
    chabs2i $p |- ( A i^i ( A vH B ) ) = A $=
      ( cch wcel chj co cin wceq chabs2 mp2an ) AEFBEFAABGHIAJCDABKL $.
  $}

  $( Idempotent law for Hilbert lattice join.  (Contributed by NM,
     26-Jun-2004.)  (New usage is discouraged.) $)
  chjidm $p |- ( A e. CH -> ( A vH A ) = A ) $=
    ( cch wcel chj co cin inidm oveq2i wceq chabs1 anidms syl5eqr ) ABCZAADEAAA
    FZDEZANAADAGHMOAIAAJKL $.

  ${
    chjidm.1 $e |- A e. CH $.
    $( Idempotent law for Hilbert lattice join.  (Contributed by NM,
       15-Jun-2004.)  (New usage is discouraged.) $)
    chjidmi $p |- ( A vH A ) = A $=
      ( cch wcel chj co wceq chjidm ax-mp ) ACDAAEFAGBAHI $.
  $}

  ${
    chj12.1 $e |- A e. CH $.
    chj12.2 $e |- B e. CH $.
    chj12.3 $e |- C e. CH $.
    $( A rearrangement of Hilbert lattice join.  (Contributed by NM,
       29-Apr-2006.)  (New usage is discouraged.) $)
    chj12i $p |- ( A vH ( B vH C ) ) = ( B vH ( A vH C ) ) $=
      ( chj co chjcomi oveq1i chjassi 3eqtr3i ) ABGHZCGHBAGHZCGHABCGHGHBACGHGHM
      NCGABDEIJABCDEFKBACEDFKL $.

    ${
      chj4.4 $e |- D e. CH $.
      $( Rearrangement of the join of 4 Hilbert lattice elements.  (Contributed
         by NM, 29-Apr-2006.)  (New usage is discouraged.) $)
      chj4i $p |- ( ( A vH B ) vH ( C vH D ) ) =
                 ( ( A vH C ) vH ( B vH D ) ) $=
        ( chj co chj12i oveq2i chjcli chjassi 3eqtr4i ) ABCDIJZIJZIJACBDIJZIJZI
        JABIJPIJACIJRIJQSAIBCDFGHKLABPEFCDGHMNACREGBDFHMNO $.
    $}

    $( Hilbert lattice join distributes over itself.  (Contributed by NM,
       29-Apr-2006.)  (New usage is discouraged.) $)
    chjjdiri $p |- ( ( A vH B ) vH C ) = ( ( A vH C ) vH ( B vH C ) ) $=
      ( chj co chjidmi oveq2i chj4i eqtr3i ) ABGHZCCGHZGHMCGHACGHBCGHGHNCMGCFIJ
      ABCCDEFFKL $.
  $}

  $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmm1 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A i^i B ) ) = ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) $=
    ( cch wcel cin cort cfv chj wceq chil cif ineq1 fveq2d fveq2 oveq1d eqeq12d
    co ineq2 helch elimel oveq2d chdmm1i dedth2h ) ACDZBCDZABEZFGZAFGZBFGZHQZIU
    DAJKZBEZFGZUKFGZUIHQZIUKUEBJKZEZFGZUNUPFGZHQZIABJJAUKIZUGUMUJUOVAUFULFAUKBL
    MVAUHUNUIHAUKFNOPBUPIZUMURUOUTVBULUQFBUPUKRMVBUIUSUNHBUPFNUAPUKUPAJCSTBJCST
    UBUC $.

  $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmm2 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) i^i B ) ) = ( A vH ( _|_ ` B ) ) ) $=
    ( cch wcel wa cort cfv cin chj wceq choccl chdmm1 sylan adantr oveq1d eqtrd
    co ococ ) ACDZBCDZEZAFGZBHFGZUBFGZBFGZIQZAUEIQSUBCDTUCUFJAKUBBLMUAUDAUEISUD
    AJTARNOP $.

  $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmm3 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A i^i ( _|_ ` B ) ) ) = ( ( _|_ ` A ) vH B ) ) $=
    ( cch wcel wa cort cfv cin chj wceq choccl chdmm1 sylan2 ococ adantl oveq2d
    co eqtrd ) ACDZBCDZEZABFGZHFGZAFGZUBFGZIQZUDBIQTSUBCDUCUFJBKAUBLMUAUEBUDITU
    EBJSBNOPR $.

  $( De Morgan's law for meet in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmm4 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) i^i ( _|_ ` B ) ) ) = ( A vH B ) ) $=
    ( cch wcel wa cort cfv cin chj wceq choccl chdmm2 sylan2 ococ adantl oveq2d
    co eqtrd ) ACDZBCDZEZAFGBFGZHFGZAUBFGZIQZABIQTSUBCDUCUEJBKAUBLMUAUDBAITUDBJ
    SBNOPR $.

  $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmj1 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A vH B ) ) = ( ( _|_ ` A ) i^i ( _|_ ` B ) ) ) $=
    ( cch wcel wa cort cfv cin chj chdmm4 fveq2d wceq choccl chincl syl2an ococ
    co syl eqtr3d ) ACDZBCDZEZAFGZBFGZHZFGZFGZABIQZFGUEUBUFUHFABJKUBUECDZUGUELT
    UCCDUDCDUIUAAMBMUCUDNOUEPRS $.

  $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmj2 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) vH B ) ) = ( A i^i ( _|_ ` B ) ) ) $=
    ( cch wcel wa cort cfv chj cin wceq choccl chdmj1 sylan ineq1d adantr eqtrd
    co ococ ) ACDZBCDZEAFGZBHQFGZUAFGZBFGZIZAUDIZSUACDTUBUEJAKUABLMSUEUFJTSUCAU
    DARNOP $.

  $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmj3 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( A vH ( _|_ ` B ) ) ) = ( ( _|_ ` A ) i^i B ) ) $=
    ( cch wcel wa cort cfv chj cin wceq choccl chdmj1 sylan2 ococ adantl ineq2d
    co eqtrd ) ACDZBCDZEZABFGZHQFGZAFGZUBFGZIZUDBITSUBCDUCUFJBKAUBLMUAUEBUDTUEB
    JSBNOPR $.

  $( De Morgan's law for join in a Hilbert lattice.  (Contributed by NM,
     21-Jun-2004.)  (New usage is discouraged.) $)
  chdmj4 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( _|_ ` ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) = ( A i^i B ) ) $=
    ( cch wcel wa cort cfv chj cin wceq choccl chdmj2 sylan2 ococ adantl ineq2d
    co eqtrd ) ACDZBCDZEZAFGBFGZHQFGZAUBFGZIZABITSUBCDUCUEJBKAUBLMUAUDBATUDBJSB
    NOPR $.

  $( Associative law for Hilbert lattice join.  From definition of lattice in
     [Kalmbach] p. 14.  (Contributed by NM, 10-Jun-2004.)
     (New usage is discouraged.) $)
  chjass $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
                ( ( A vH B ) vH C ) = ( A vH ( B vH C ) ) ) $=
    ( cch wcel chj wceq chil cif oveq1 oveq1d eqeq12d oveq2 oveq2d helch elimel
    co chjassi dedth3h ) ADEZBDEZCDEZABFQZCFQZABCFQZFQZGTAHIZBFQZCFQZUGUEFQZGUG
    UABHIZFQZCFQZUGUKCFQZFQZGULUBCHIZFQZUGUKUPFQZFQZGABCHHHAUGGZUDUIUFUJUTUCUHC
    FAUGBFJKAUGUEFJLBUKGZUIUMUJUOVAUHULCFBUKUGFMKVAUEUNUGFBUKCFJNLCUPGZUMUQUOUS
    CUPULFMVBUNURUGFCUPUKFMNLUGUKUPAHDOPBHDOPCHDOPRS $.

  $( A rearrangement of Hilbert lattice join.  (Contributed by NM,
     15-Jun-2006.)  (New usage is discouraged.) $)
  chj12 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
              ( A vH ( B vH C ) ) = ( B vH ( A vH C ) ) ) $=
    ( cch wcel w3a chj co wceq chjcom 3adant3 oveq1d chjass 3com12 3eqtr3d ) AD
    EZBDEZCDEZFZABGHZCGHBAGHZCGHZABCGHGHBACGHGHZSTUACGPQTUAIRABJKLABCMQPRUBUCIB
    ACMNO $.

  $( Rearrangement of the join of 4 Hilbert lattice elements.  (Contributed by
     NM, 15-Jun-2006.)  (New usage is discouraged.) $)
  chj4 $p |- ( ( ( A e. CH /\ B e. CH ) /\ ( C e. CH /\ D e. CH ) ) ->
              ( ( A vH B ) vH ( C vH D ) ) = ( ( A vH C ) vH ( B vH D ) ) ) $=
    ( cch wcel wa chj wceq chj12 3expb adantll oveq2d chjcl chjass 3expa sylan2
    co an4s 3eqtr4d ) AEFZBEFZGZCEFZDEFZGZGZABCDHRZHRZHRZACBDHRZHRZHRZABHRUHHRZ
    ACHRUKHRZUGUIULAHUBUFUIULIZUAUBUDUEUPBCDJKLMUFUCUHEFZUNUJIZCDNUAUBUQURABUHO
    PQUAUDUBUEUOUMIZUBUEGUAUDGUKEFZUSBDNUAUDUTUSACUKOPQST $.

  ${
    ledi.1 $e |- A e. CH $.
    ledi.2 $e |- B e. CH $.
    ledi.3 $e |- C e. CH $.
    $( An ortholattice is distributive in one ordering direction.  (Contributed
       by NM, 6-Aug-2004.)  (New usage is discouraged.) $)
    ledii $p |- ( ( A i^i B ) vH ( A i^i C ) ) C_ ( A i^i ( B vH C ) ) $=
      ( cin chj co wss inss1 chincli chlubii mp2an inss2 chlej12i ssini ) ABGZA
      CGZHIZABCHIZRAJSAJTAJABKACKRSAABDELZACDFLZDMNRBJSCJTUAJABOACORBSCUBEUCFPN
      Q $.

    $( An ortholattice is distributive in one ordering direction.  (Contributed
       by NM, 27-Apr-2006.)  (New usage is discouraged.) $)
    lediri $p |- ( ( A i^i C ) vH ( B i^i C ) ) C_ ( ( A vH B ) i^i C ) $=
      ( cin chj co ledii incom oveq12i 3sstr4i ) CAGZCBGZHICABHIZGACGZBCGZHIPCG
      CABFDEJQNROHACKBCKLPCKM $.

    $( An ortholattice is distributive in one ordering direction (join
       version).  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    lejdii $p |- ( A vH ( B i^i C ) ) C_ ( ( A vH B ) i^i ( A vH C ) ) $=
      ( cin chj wss chub1i ssini inss1 chub2i sstri inss2 chincli chjcli chlubi
      co wa bicomi mpbir2an ) ABCGZHSABHSZACHSZGZIZAUFIZUCUFIZAUDUEABDEJACDFJKU
      CUDUEUCBUDBCLBAEDMNUCCUEBCOCAFDMNKUHUITUGAUCUFDBCEFPUDUEABDEQACDFQPRUAUB
      $.

    $( An ortholattice is distributive in one ordering direction (join
       version).  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    lejdiri $p |- ( ( A i^i B ) vH C ) C_ ( ( A vH C ) i^i ( B vH C ) ) $=
      ( cin chj co lejdii chincli chjcomi ineq12i 3sstr4i ) CABGZHICAHIZCBHIZGO
      CHIACHIZBCHIZGCABFDEJOCABDEKFLRPSQACDFLBCEFLMN $.
  $}

  $( An ortholattice is distributive in one ordering direction.  (Contributed
     by NM, 14-Jun-2006.)  (New usage is discouraged.) $)
  ledi $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
              ( ( A i^i B ) vH ( A i^i C ) ) C_ ( A i^i ( B vH C ) ) ) $=
    ( cch wcel cin chj co wss c0h cif ineq1 oveq12d sseq12d ineq2 oveq1d ineq2d
    wceq h0elch elimel oveq1 oveq2d oveq2 ledii dedth3h ) ADEZBDEZCDEZABFZACFZG
    HZABCGHZFZIUFAJKZBFZUNCFZGHZUNULFZIUNUGBJKZFZUPGHZUNUSCGHZFZIUTUNUHCJKZFZGH
    ZUNUSVDGHZFZIABCJJJAUNRZUKUQUMURVIUIUOUJUPGAUNBLAUNCLMAUNULLNBUSRZUQVAURVCV
    JUOUTUPGBUSUNOPVJULVBUNBUSCGUAQNCVDRZVAVFVCVHVKUPVEUTGCVDUNOUBVKVBVGUNCVDUS
    GUCQNUNUSVDAJDSTBJDSTCJDSTUDUE $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Span (cont.) and one-dimensional subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The span of the singleton of the zero vector is the zero subspace.
     (Contributed by NM, 14-Jan-2005.)  (New usage is discouraged.) $)
  spansn0 $p |- ( span ` { 0h } ) = 0H $=
    ( c0h cspn cfv c0v csn df-ch0 fveq2i wcel wceq h0elsh spanid ax-mp eqtr3i
    csh ) ABCZDEZBCAAPBFGANHOAIJAKLM $.

  $( The span of the empty set is the zero subspace.  Remark 11.6.e of
     [Schechter] p. 276.  (Contributed by NM, 3-Jun-2004.)
     (New usage is discouraged.) $)
  span0 $p |- ( span ` (/) ) = 0H $=
    ( cspn cfv c0h chil wss h0elsh shssii 0ss spanss mp2an csh wcel wceq spanid
    c0 ax-mp sseqtri spancl sh0le eqssi ) OABZCUACABZCCDEOCEUAUBECFGCHOCIJCKLUB
    CMFCNPQUAKLZCUAEODEUCDHORPUASPT $.

  ${
    $d x A $.  $d x B $.
    elspan.1 $e |- B e. _V $.
    $( Membership in the span of a subset of Hilbert space.  (Contributed by
       NM, 2-Jun-2004.)  (New usage is discouraged.) $)
    elspani $p |- ( A C_ ~H ->
                ( B e. ( span ` A ) <-> A. x e. SH ( A C_ x -> B e. x ) ) ) $=
      ( chil wss cspn cfv wcel cv csh crab cint wi wral spanval eleq2d elintrab
      syl6bb ) BEFZCBGHZICBAJZFZAKLMZIUCCUBINAKOTUAUDCABPQUCACKDRS $.

  $}

  ${
    spanun.1 $e |- A C_ ~H $.
    spanun.2 $e |- B C_ ~H $.
    $d x y z w A $.  $d x y z w B $.
    $( The span of a union is the subspace sum of spans.  (Contributed by NM,
       2-Jun-2004.)  (New usage is discouraged.) $)
    spanuni $p |- ( span ` ( A u. B ) ) = ( ( span ` A ) +H ( span ` B ) ) $=
      ( vx vz vw vy cspn cfv chil wss csh wcel ax-mp cv wa wel wi wral co mp2an
      cun spancl shscli shssii spanss2 unss12 shunssi sstri spanss wceq sseqtri
      cph spanid cva wex wrex shseli bitri wb vex elspani anbi12i r19.26 bitr4i
      r2ex sylanb unss prth syl5bir shaddcl 3expib sylan9r eleq1 biimprd sylan9
      r19.27av expl ralimia unssi sylibr syl exlimivv sylbi ssriv eqssi ) ABUCZ
      IJZAIJZBIJZUNUAZWIWLIJZWLWLKLWHWLLWIWMLWLWJWKAKLZWJMNCAUDOZBKLZWKMNDBUDOZ
      UEZUFWHWJWKUCZWLAWJLZBWKLZWHWSLWNWTCAUGOWPXADBUGOAWJBWKUHUBWJWKWOWQUIUJWH
      WLUKUBWLMNWMWLULWRWLUOOUMEWLWIEPZWLNZFPZWJNZGPZWKNZQZXBXDXFUPUAZULZQZGUQF
      UQZXBWINZXCXJGWKURFWJURXLFGWJWKXBWOWQUSXJFGWJWKVGUTXKXMFGXKAHPZLZFHRZSZBX
      NLZGHRZSZQZXJQZHMTZXMXHYAHMTZXJYCXHXQHMTZXTHMTZQYDXEYEXGYFWNXEYEVACHAXDFV
      BVCOWPXGYFVADHBXFGVBVCOVDXQXTHMVEVFYAXJHMVRVHYCWHXNLZEHRZSZHMTZXMYBYIHMXN
      MNZYAXJYIYKYAQYGXIXNNZXJYHYAYGXPXSQZYKYLYGXOXRQYAYMABXNVIXOXPXRXSVJVKYKXP
      XSYLXDXFXNVLVMVNXJYHYLXBXIXNVOVPVQVSVTWHKLXMYJVAABKCDWAHWHXBEVBVCOWBWCWDW
      EWFWG $.
  $}

  $( The span of a union is the subspace sum of spans.  (Contributed by NM,
     9-Jun-2006.)  (New usage is discouraged.) $)
  spanun $p |- ( ( A C_ ~H /\ B C_ ~H ) ->
                ( span ` ( A u. B ) ) = ( ( span ` A ) +H ( span ` B ) ) ) $=
    ( chil wss cun cspn cfv cph co wceq uneq1 fveq2d fveq2 oveq1d eqeq12d uneq2
    cif oveq2d sseq1 elimhyp ssid spanuni dedth2h ) ACDZBCDZABEZFGZAFGZBFGZHIZJ
    UDACQZBEZFGZUKFGZUIHIZJUKUEBCQZEZFGZUNUPFGZHIZJABCCAUKJZUGUMUJUOVAUFULFAUKB
    KLVAUHUNUIHAUKFMNOBUPJZUMURUOUTVBULUQFBUPUKPLVBUIUSUNHBUPFMROUKUPUDUKCDCCDZ
    ACAUKCSCUKCSCUAZTUEUPCDVCBCBUPCSCUPCSVDTUBUC $.

  ${
    sshjococ.1 $e |- A C_ ~H $.
    sshjococ.2 $e |- B C_ ~H $.
    $( The join of two Hilbert space subsets (not necessarily closed subspaces)
       equals the join of their closures (double orthocomplements).
       (Contributed by NM, 1-Jun-2004.)  (Revised by Mario Carneiro,
       15-May-2014.)  (New usage is discouraged.) $)
    sshhococi $p |- ( A vH B ) =
                 ( ( _|_ ` ( _|_ ` A ) ) vH ( _|_ ` ( _|_ ` B ) ) ) $=
      ( chj co cort cfv cun wss chil ococss ax-mp mp2an cch wcel choccli chssii
      unssi occon2i unss12 occl wceq sshjval chjvali 3sstr4i ssun1 sstri sshjcl
      sseqtr4i ssun2 chlubii ococi sseqtri eqssi ) ABEFZAGHZGHZBGHZGHZEFZABIZGH
      GHZURUTIZGHGHZUPVAVBVDJZVCVEJAURJZBUTJZVFAKJZVGCALMBKJZVHDBLMAURBUTUANVBV
      DABKCDSZURUTKURUQVIUQOPCAUBMQZRUTUSVJUSOPDBUBMQZRSTMVIVJUPVCUCCDABUDNZURU
      TVLVMUEUFVAUPGHZGHZUPURVPJZUTVPJZVAVPJAUPJVQAVCUPAVBVCABUGVBKJVBVCJVKVBLM
      ZUHVNUJAUPCUPVIVJUPOPCDABUINZRZTMBUPJVRBVCUPBVBVCBAUKVSUHVNUJBUPDWATMURUT
      VPVLVMVOUPVTQQULNUPVTUMUNUO $.
  $}

  $( Hilbert space has a nonzero vector iff it is not trivial.  (Contributed by
     NM, 24-Feb-2006.)  (New usage is discouraged.) $)
  hne0 $p |- ( ~H =/= 0H <-> E. x e. ~H x =/= 0h ) $=
    ( chil helch chne0i ) ABCD $.

  $( The supremum of the empty set.  (Contributed by NM, 13-Aug-2002.)
     (New usage is discouraged.) $)
  chsup0 $p |- ( \/H ` (/) ) = 0H $=
    ( c0 chsup cfv c0h wss wceq csn 0ss cch wi h0elch snssi ax-mp chsupss mp2an
    wcel chsupsn sseqtri chsupcl chle0i mpbi ) ABCZDEUBDFUBDGZBCZDAUCEZUBUDEZUC
    HAIEZUCIEZUEUFJIHZDIPZUHKDILMAUCNOMUJUDDFKDQMRUBUGUBIPUIASMTUA $.

  ${
    $d x A $.  $d x B $.
    h1deot.1 $e |- B e. ~H $.
    $( Membership in orthocomplement of 1-dimensional subspace.  (Contributed
       by NM, 7-Jul-2001.)  (New usage is discouraged.) $)
    h1deoi $p |- ( A e. ( _|_ ` { B } ) <->
                 ( A e. ~H /\ ( A .ih B ) = 0 ) ) $=
      ( vx csn cort cfv wcel chil cv csp co cc0 wceq wral wa wss wb snssi ocel
      mp2b elexi oveq2 eqeq1d ralsn anbi2i bitri ) ABEZFGHZAIHZADJZKLZMNZDUHOZP
      ZUJABKLZMNZPBIHUHIQUIUORCBISDAUHTUAUNUQUJUMUQDBBICUBUKBNULUPMUKBAKUCUDUEU
      FUG $.

    $( Membership in 1-dimensional subspace.  (Contributed by NM, 7-Jul-2001.)
       (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    h1dei $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
    ( A e. ~H /\ A. x e. ~H ( ( B .ih x ) = 0 -> ( A .ih x ) = 0 ) ) ) $=
      ( csn cort cfv wcel chil cv csp co cc0 wceq wral wa wi wss wb bitri snssi
      occl mp2b chssii ax-mp h1deoi orthcom mpan2 pm5.32i imbi1i impexp ralbii2
      cch ocel anbi2i ) BCEZFGZFGHZBIHZBAJZKLMNZAUQOZPZUSCUTKLMNZVAQZAIOZPUQIRU
      RVCSUQCIHZUPIRUQUMHDCIUAUPUBUCUDABUQUNUEVBVFUSVAVEAUQIUTUQHZVAQUTIHZVDPZV
      AQVIVEQVHVJVAVHVIUTCKLMNZPVJUTCDUFVIVKVDVIVGVKVDSDUTCUGUHUITUJVIVDVAUKTUL
      UOT $.
  $}

  $( A generating vector belongs to the 1-dimensional subspace it generates.
     (Contributed by NM, 22-Jul-2001.)  (New usage is discouraged.) $)
  h1did $p |- ( A e. ~H -> A e. ( _|_ ` ( _|_ ` { A } ) ) ) $=
    ( chil wcel csn cort cfv wss snssi ococss syl snssg mpbird ) ABCZAADZEFEFZC
    NOGZMNBGPABHNIJAOBKL $.

  $( A nonzero vector generates a (nonzero) 1-dimensional subspace.
     (Contributed by NM, 22-Jul-2001.)  (New usage is discouraged.) $)
  h1dn0 $p |- ( ( A e. ~H /\ A =/= 0h ) ->
              ( _|_ ` ( _|_ ` { A } ) ) =/= 0H ) $=
    ( chil wcel c0v wne csn cort cfv h1did eleq2 syl5ibcom elch0 syl6ib necon3d
    c0h wceq imp ) ABCZADEAFGHGHZOERSOADRSOPZAOCZADPRASCTUAAISOAJKALMNQ $.

  ${
    $d x A $.  $d x B $.
    h1de2.1 $e |- A e. ~H $.
    h1de2.2 $e |- B e. ~H $.
    $( Membership in 1-dimensional subspace.  All members are collinear with
       the generating vector.  (Contributed by NM, 17-Jul-2001.)
       (New usage is discouraged.) $)
    h1de2i $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) ->
                ( ( B .ih B ) .h A ) = ( ( A .ih B ) .h B ) ) $=
      ( vx cort cfv wcel csp co cmul wceq csm cmin cc0 chil hicli mp3an ax-his3
      wi csn cmv hvmulcli his2sub cc mulcomi eqtri oveq12i eqtr2i 3eqtr4i mpbir
      subeq0i cv wral h1dei mpbiran hvsubcli oveq2 imbi12d rspcv ax-mp sylbi wb
      eqeq1d orthcom mp2an 3imtr4g mpi syl5eq mulcli sylib eqcomd bcseqi ) ABUA
      FGFGHZABIJZBAIJZKJZAAIJZBBIJZKJZLVSAMJZVOBMJZLVNVTVQVNVTVQNJZOLVTVQLVNWCW
      AWBUBJZAIJZOWEWAAIJZWBAIJZNJZWCWAPHZWBPHZAPHZWEWHLVSABBDDQZCUCZVOBABCDQZD
      UCZCWAWBAUDRWFVTWGVQNWFVSVRKJZVTVSUEHZWKWKWFWPLWLCCVSAASRVSVRWLAACCQZUFUG
      VOUEHZBPHZWKWGVQLWNDCVOBASRUHUIVNWDBIJZOLZWEOLZXAWABIJZWBBIJZNJZOWIWJWTXA
      XFLWMWODWAWBBUDRXFOLXDXELVSVOKJZVOVSKJZXDXEVSVOWLWNUFWQWKWTXDXGLWLCDVSABS
      RWSWTWTXEXHLWNDDVOBBSRUJXDXEWABWMDQWBBWODQULUKUGVNBWDIJZOLZAWDIJZOLZXBXCV
      NBEUMZIJZOLZAXMIJZOLZTZEPUNZXJXLTZVNWKXSCEABDUOUPWDPHZXSXTTWAWBWMWOUQZXRX
      TEWDPXMWDLZXOXJXQXLYCXNXIOXMWDBIURVDYCXPXKOXMWDAIURVDUSUTVAVBYAWTXBXJVCYB
      DWDBVEVFYAWKXCXLVCYBCWDAVEVFVGVHVIVTVQVRVSWRWLVJVOVPWNBADCQVJULVKVLABCDVM
      VK $.

    $( Membership in 1-dimensional subspace.  All members are collinear with
       the generating vector.  (Contributed by NM, 19-Jul-2001.)  (Revised by
       Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    h1de2bi $p |- ( B =/= 0h -> ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
                A = ( ( ( A .ih B ) / ( B .ih B ) ) .h B ) ) ) $=
      ( c0v wne csp co cc0 cort wcel csm wceq chil ax-mp c1 cmul cc syl eqtr3d
      csn cfv cdiv wb his6 necon3bii wa h1de2i adantl hicli recclzi ax-hvmulass
      oveq2d mp3an23 ax-1cn divcan1zi oveq1d ax-hvmulid syl6eq sylancl divreczi
      adantr mulcom eqtr4d ex divclzi csh wss cch snss mpbi occl choccli chshii
      elexi h1did shmulcl mp3an13 eleq1 syl5ibrcom impbid sylbir ) BEFBBGHZIFZA
      BUAZJUBZJUBZKZAABGHZWCUCHZBLHZMZUDWCIBEBNKZWCIMBEMUDDBUEOUFWDWHWLWDWHWLWD
      WHUGZPWCUCHZWIBLHZLHZAWKWNWOWCALHZLHZWQAWNWRWPWOLWHWRWPMWDABCDUHUIUMWDWSA
      MWHWDWSPALHZAWDWOWCQHZALHZWSWTWDWORKZXBWSMZWCBBDDUJZUKZXCWCRKANKZXDXECWOW
      CAULUNSWDXAPALPWCUOXEUPUQTXGWTAMCAUROUSVBTWDWQWKMWHWDWOWIQHZBLHZWQWKWDXCX
      IWQMZXFXCWIRKZWMXJABCDUJZDWOWIBULUNSWDXHWJBLWDXHWIWOQHZWJWDXCXKXHXMMXFXLW
      OWIVCUTWIWCXLXEVAVDUQTVBTVEWDWHWLWKWGKZWDWJRKZXNWIWCXLXEVFWGVGKXOBWGKZXNW
      GWFWENVHZWFVIKWMXQDBNBNDVOVJVKWEVLOVMVNWMXPDBVPOWJBWGVQVRSAWKWGVSVTWAWB
      $.

    $( Lemma for ~ h1de2ci .  (Contributed by NM, 19-Jul-2001.)  (Revised by
       Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    h1de2ctlem $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
                 E. x e. CC A = ( x .h B ) ) $=
      ( csn cort cfv wcel csm co wceq cc c0v cc0 fveq2d chil ax-mp oveq1 eqeq2d
      cv wrex wi sneq eleq2d elexi elsnc hsn0elch ococi eleq2i ax-hvmul0 eqeq2i
      3bitr4ri syl6rbbr 0cn rspcev mpan syl6bir wne cdiv h1de2bi his6 necon3bii
      csp wb hicli divclzi sylbir sylan sylbid pm2.61ine csh wss cch snssi occl
      ex choccli chshii h1did shmulcl mp3an13 eleq1 syl5ibrcom rexlimiv impbii
      mp2b ) BCFZGHZGHZIZBAUAZCJKZLZAMUBZWKWOUCCNCNLZWKBOCJKZLZWOWPWKBNFZGHZGHZ
      IZWRWPWJXABWPWIWTGWPWHWSGCNUDPPUEBWSIBNLXBWRBNBQDUFUGXAWSBWSUHUIUJWQNBCQI
      ZWQNLECUKRULUMUNOMIWRWOUOWNWRAOMWLOLWMWQBWLOCJSTUPUQURCNUSZWKBBCVDKZCCVDK
      ZUTKZCJKZLZWOBCDEVAXDXIWOXDXGMIZXIWOXDXFOUSXJXFOCNXCXFOLWPVEECVBRVCXEXFBC
      DEVFCCEEVFVGVHWNXIAXGMWLXGLWMXHBWLXGCJSTUPVIVQVJVKWNWKAMWLMIZWKWNWMWJIZWJ
      VLIXKCWJIZXLWJWIXCWHQVMWIVNIECQVOWHVPWGVRVSXCXMECVTRWLCWJWAWBBWMWJWCWDWEW
      F $.
  $}

  ${
    $d x A $.  $d x B $.
    h1de2ct.1 $e |- B e. ~H $.
    $( Membership in 1-dimensional subspace.  All members are collinear with
       the generating vector.  (Contributed by NM, 21-Jul-2001.)  (Revised by
       Mario Carneiro, 15-May-2014.)  (New usage is discouraged.) $)
    h1de2ci $p |- ( A e. ( _|_ ` ( _|_ ` { B } ) ) <->
                 E. x e. CC A = ( x .h B ) ) $=
      ( csn cort cfv wcel chil cv csm co wceq cc wrex wss cch eleq1 wb c0v occl
      snssi choccli cheli hvmulcl mpan2 syl5ibrcom rexlimiv cif rexbidv bibi12d
      mp2b eqeq1 ax-hv0cl elimel h1de2ctlem dedth pm5.21nii ) BCEZFGZFGZHZBIHZB
      AJZCKLZMZANOZBVAUTCIHZUSIPUTQHDCIUBUSUAULUCUDVFVCANVDNHZVCVFVEIHZVIVHVJDV
      DCUEUFBVEIRUGUHVCVBVGSVCBTUIZVAHZVKVEMZANOZSBTBVKMZVBVLVGVNBVKVARVOVFVMAN
      BVKVEUMUJUKAVKCBTIUNUODUPUQUR $.
  $}

  ${
    $d x y z A $.  $d x B $.
    spansn.1 $e |- A e. ~H $.
    $( The span of a singleton in Hilbert space equals its closure.
       (Contributed by NM, 3-Jun-2004.)  (New usage is discouraged.) $)
    spansni $p |- ( span ` { A } ) = ( _|_ ` ( _|_ ` { A } ) ) $=
      ( vx vz vy csn cspn cfv cort chil wcel wss snssi spanssoc mp2b cv csm csh
      cc wi co wceq wrex wral wa elexi snss shmulcl 3expia ancoms syl5bir eleq1
      imbi2d syl5ibrcom ralrimdva rexlimiv h1de2ci wb vex elspani 3imtr4i ssriv
      eqssi ) AFZGHZVDIHIHZAJKZVDJLZVEVFLBAJMZVDNOCVFVECPZDPZAQUAZUBZDSUCVDEPZL
      ZVJVNKZTZERUDZVJVFKVJVEKZVMVRDSVKSKZVMVQERVTVNRKZUEZVQVMVOVLVNKZTVOAVNKZW
      BWCAVNAJBUFUGWAVTWDWCTWAVTWDWCVKAVNUHUIUJUKVMVPWCVOVJVLVNULUMUNUOUPDVJABU
      QVGVHVSVRURBVIEVDVJCUSUTOVAVBVC $.

    $( Membership in the span of a singleton.  (Contributed by NM,
       3-Jun-2004.)  (New usage is discouraged.) $)
    elspansni $p |- ( B e. ( span ` { A } ) <-> E. x e. CC B = ( x .h A ) ) $=
      ( csn cspn cfv wcel cort cv csm co wceq wrex spansni eleq2i h1de2ci bitri
      cc ) CBEZFGZHCTIGIGZHCAJBKLMASNUAUBCBDOPACBDQR $.
  $}

  $( The span of a singleton in Hilbert space equals its closure.  (Contributed
     by NM, 4-Jun-2004.)  (New usage is discouraged.) $)
  spansn $p |- ( A e. ~H -> ( span ` { A } ) = ( _|_ ` ( _|_ ` { A } ) ) ) $=
    ( chil wcel csn cspn cfv cort wceq c0v sneq fveq2d eqeq12d ax-hv0cl spansni
    cif elimel dedth ) ABCZADZEFZSGFZGFZHRAIOZDZEFZUDGFZGFZHAIAUCHZTUEUBUGUHSUD
    EAUCJZKUHUAUFGUHSUDGUIKKLUCAIBMPNQ $.

  $( The span of a Hilbert space singleton belongs to the Hilbert lattice.
     (Contributed by NM, 9-Jun-2004.)  (New usage is discouraged.) $)
  spansnch $p |- ( A e. ~H -> ( span ` { A } ) e. CH ) $=
    ( chil wcel csn cspn cfv cort cch spansn wss snssi occl choccl 3syl eqeltrd
    ) ABCZADZEFQGFZGFZHAIPQBJRHCSHCABKQLRMNO $.

  $( The span of a Hilbert space singleton is a subspace.  (Contributed by NM,
     17-Dec-2004.)  (New usage is discouraged.) $)
  spansnsh $p |- ( A e. ~H -> ( span ` { A } ) e. SH ) $=
    ( chil wcel csn cspn cfv cch csh spansnch chsh syl ) ABCADEFZGCLHCAILJK $.

  ${
    spansnch.1 $e |- A e. ~H $.
    $( The span of a singleton in Hilbert space is a closed subspace.
       (Contributed by NM, 3-Jun-2004.)  (New usage is discouraged.) $)
    spansnchi $p |- ( span ` { A } ) e. CH $=
      ( chil wcel csn cspn cfv cch spansnch ax-mp ) ACDAEFGHDBAIJ $.
  $}

  $( A vector belongs to the span of its singleton.  (Contributed by NM,
     3-Jun-2004.)  (New usage is discouraged.) $)
  spansnid $p |- ( A e. ~H -> A e. ( span ` { A } ) ) $=
    ( chil wcel csn cort cfv cspn h1did spansn eleqtrrd ) ABCAADZEFEFKGFAHAIJ
    $.

  $( A scalar product with a vector belongs to the span of its singleton.
     (Contributed by NM, 3-Jun-2004.)  (New usage is discouraged.) $)
  spansnmul $p |- ( ( A e. ~H /\ B e. CC ) ->
                  ( B .h A ) e. ( span ` { A } ) ) $=
    ( cc wcel chil csm co csn cspn cfv csh spansnsh spansnid jca shmulcl 3com12
    wa 3expb sylan2 ancoms ) BCDZAEDZBAFGAHIJZDZUBUAUCKDZAUCDZQUDUBUEUFALAMNUAU
    EUFUDUEUAUFUDBAUCOPRST $.

  $( A member of a span of a singleton is a vector.  (Contributed by NM,
     17-Dec-2004.)  (New usage is discouraged.) $)
  elspansncl $p |- ( ( A e. ~H /\ B e. ( span ` { A } ) ) -> B e. ~H ) $=
    ( chil wcel csn wss cspn cfv snssi elspancl sylan ) ACDAEZCFBLGHDBCDACILBJK
    $.

  ${
    $d x A $.  $d x B $.
    $( Membership in the span of a singleton.  (Contributed by NM,
       5-Jun-2004.)  (New usage is discouraged.) $)
    elspansn $p |- ( A e. ~H ->
                   ( B e. ( span ` { A } ) <-> E. x e. CC B = ( x .h A ) ) ) $=
      ( chil wcel csn cspn cfv cv csm co wceq cc wrex wb c0v sneq fveq2d eleq2d
      cif oveq2 eqeq2d rexbidv bibi12d ax-hv0cl elimel elspansni dedth ) BDEZCB
      FZGHZEZCAIZBJKZLZAMNZOCUIBPTZFZGHZEZCUMUQJKZLZAMNZOBPBUQLZULUTUPVCVDUKUSC
      VDUJURGBUQQRSVDUOVBAMVDUNVACBUQUMJUAUBUCUDAUQCBPDUEUFUGUH $.
  $}

  $( Membership in the span of a singleton.  All members are collinear with the
     generating vector.  (Contributed by NM, 5-Jun-2004.)
     (New usage is discouraged.) $)
  elspansn2 $p |- ( ( A e. ~H /\ B e. ~H /\ B =/= 0h ) ->
  ( A e. ( span ` { B } ) <-> A = ( ( ( A .ih B ) / ( B .ih B ) ) .h B ) ) ) $=
    ( chil wcel c0v wne csn cfv cort csp co cdiv csm wceq wb eleq2d wi id oveq1
    cif w3a cspn spansn 3ad2ant2 eleq1 oveq1d eqeq12d bibi12d imbi2d neeq1 sneq
    fveq2d oveq2 oveq12d eqeq2d imbi12d ax-hv0cl elimel h1de2bi dedth2h 3impia
    eqtrd bitrd ) ACDZBCDZBEFZUAABGZUBHZDZAVGIHZIHZDZAABJKZBBJKZLKZBMKZNZVEVDVI
    VLOVFVEVHVKABUCPUDVDVEVFVLVQOZVDVEVFVRQVFVDAETZVKDZVSVSBJKZVNLKZBMKZNZOZQVE
    BETZEFZVSWFGZIHZIHZDZVSVSWFJKZWFWFJKZLKZWFMKZNZOZQABEEAVSNZVRWEVFWRVLVTVQWD
    AVSVKUEWRAVSVPWCWRRWRVOWBBMWRVMWAVNLAVSBJSUFUFUGUHUIBWFNZVFWGWEWQBWFEUJWSVT
    WKWDWPWSVKWJVSWSVJWIIWSVGWHIBWFUKULULPWSWCWOVSWSWBWNBWFMWSWAWLVNWMLBWFVSJUM
    WSVNWFBJKWMBWFBJSBWFWFJUMVBUNWSRUNUOUHUPVSWFAECUQURBECUQURUSUTVAVC $.

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( The singletons of collinear vectors have the same span.  (Contributed by
       NM, 6-Jun-2004.)  (New usage is discouraged.) $)
    spansncol $p |- ( ( A e. ~H /\ B e. CC /\ B =/= 0 ) ->
                    ( span ` { ( B .h A ) } ) = ( span ` { A } ) ) $=
      ( vx vy vz chil wcel cc csm co csn cspn cfv cv wceq wrex wi cmul eqeq2d
      wa cc0 wne w3a mulcl ancoms adantll ax-hvmulass 3com13 3expa oveq1 rspcev
      biimprd ee12an rexlimdva 3adant3 cdiv divcl adantlr simprl simplr syl3anc
      3expb divcan1 oveq1d eqtr3d exp43 com4l 3imp rexlimdv wb hvmulcl elspansn
      impbid syl 3ad2ant1 3bitr4d eqrdv ) AFGZBHGZBUAUBZUCZCBAIJZKLMZAKLMZWACNZ
      DNZWBIJZOZDHPZWEENZAIJZOZEHPZWEWCGZWEWDGZWAWIWMVRVSWIWMQVTVRVSTZWHWMDHWPW
      FHGZTZWFBRJZHGZWHWEWSAIJZOZWMVSWQWTVRWQVSWTWFBUDUEUFWRXBWHWRXAWGWEVRVSWQX
      AWGOZWQVSVRXCWFBAUGUHUISULWLXBEWSHWJWSOWKXAWEWJWSAIUJSUKUMUNUOWAWLWIEHVRV
      SVTWJHGZWLWIQZQXDVRVSVTXEXDVRVSVTXEXDVRTZVSVTTZTZWJBUPJZHGZWLWEXIWBIJZOZW
      IXDXGXJVRXDVSVTXJWJBUQVBURZXHXLWLXHXKWKWEXHXIBRJZAIJZXKWKXHXJVSVRXOXKOXMX
      FVSVTUSXDVRXGUTXIBAUGVAXHXNWJAIXDXGXNWJOZVRXDVSVTXPWJBVCVBURVDVESULWHXLDX
      IHWFXIOWGXKWEWFXIWBIUJSUKUMVFVGVHVIVMVRVSWNWIVJZVTWPWBFGZXQVSVRXRBAVKUEDW
      BWEVLVNUOVRVSWOWMVJVTEAWEVLVOVPVQ $.
  $}

  $( Membership relation implied by equality of spans.  (Contributed by NM,
     6-Jun-2004.)  (New usage is discouraged.) $)
  spansneleqi $p |- ( A e. ~H ->
        ( ( span ` { A } ) = ( span ` { B } ) -> A e. ( span ` { B } ) ) ) $=
    ( chil wcel csn cspn cfv wceq spansnid eleq2 syl5ibcom ) ACDAAEFGZDLBEFGZHA
    MDAILMAJK $.

  ${
    $d x A $.  $d x B $.
    $( Membership relation that implies equality of spans.  (Contributed by NM,
       6-Jun-2004.)  (New usage is discouraged.) $)
    spansneleq $p |- ( ( B e. ~H /\ A =/= 0h ) ->
         ( A e. ( span ` { B } ) -> ( span ` { A } ) = ( span ` { B } ) ) ) $=
      ( vx chil wcel c0v wne wa csn cspn cfv csm co wceq cc adantr wi cc0 com23
      ex cv wrex wb elspansn sneq fveq2d ad2antll oveq1 ax-hvmul0 eqeq1 biimprd
      sylan9eqr sylan9 imp3a spansncol 3expia syld exp4b imp43 eqtrd rexlimdvaa
      necon3d sylbid ) BDEZAFGZHZABIJKZEZACUAZBLMZNZCOUBZAIZJKZVGNZVDVHVLUCVECB
      AUDPVFVKVOCOVFVIOEZVKHHVNVJIZJKZVGVKVNVRNVFVPVKVMVQJAVJUEUFUGVDVEVPVKVRVG
      NZVDVPVEVKVSQVDVPVEVKVSVDVPHVEVKHZVIRGZVSVDVTWAQVPVDVEVKWAVDVKVEWAVDVKVEW
      AQVDVKHVIRAFVDVIRNZVJFNZVKAFNZVDWBWCWBVDVJRBLMFVIRBLUHBUIULTVKWDWCAVJFUJU
      KUMVBTSUNPVDVPWAVSBVIUOUPUQURSUSUTVAVC $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( The span of the singleton of an element of a subspace is included in the
       subspace.  (Contributed by NM, 5-Jun-2004.)
       (New usage is discouraged.) $)
    spansnss $p |- ( ( A e. SH /\ B e. A ) -> ( span ` { B } ) C_ A ) $=
      ( vx vy csh wcel wa csn cspn cfv cv csm co wceq cc wrex chil wb syl wi
      shel elspansn w3a shmulcl eleq1a 3exp com23 imp rexlimdv sylbid ssrdv ) A
      EFZBAFZGZCBHIJZAUNCKZUOFZUPDKZBLMZNZDOPZUPAFZUNBQFUQVARBAUADBUPUBSUNUTVBD
      OULUMUROFZUTVBTZTULVCUMVDULVCUMVDULVCUMUCUSAFVDURBAUDUSAUPUESUFUGUHUIUJUK
      $.
  $}

  $( A member of the span of the singleton of a vector is a member of a
     subspace containing the vector.  (Contributed by NM, 16-Dec-2004.)
     (New usage is discouraged.) $)
  elspansn3 $p |- ( ( A e. SH /\ B e. A /\ C e. ( span ` { B } ) ) ->
                   C e. A ) $=
    ( csh wcel csn cspn cfv wa spansnss sseld 3impia ) ADEZBAEZCBFGHZECAEMNIOAC
    ABJKL $.

  $( A span membership condition implying two vectors belong to the same
     subspace.  (Contributed by NM, 17-Dec-2004.)
     (New usage is discouraged.) $)
  elspansn4 $p |- ( ( ( A e. SH /\ B e. ~H ) /\
         ( C e. ( span ` { B } ) /\ C =/= 0h ) ) -> ( B e. A <-> C e. A ) ) $=
    ( csh wcel chil wa csn cspn cfv c0v wne wi elspansn3 3exp ad2ant2r spansnid
    com23 imp ad2antrr wceq spansneleq eleqtrrd 3expia exp4b com24 exp4a impbid
    syl5 imp43 ) ADEZBFEZGCBHIJZEZCKLZGGBAEZCAEZUKUNUPUQMZULUOUKUNURUKUPUNUQUKU
    PUNUQABCNORSPUKULUNUOUQUPMZUKUNULUOUSMUKUNULUOUSUKUQULUOGZUNUPUKUQUTUNUPUTU
    NGZBCHIJZEZUKUQGUPVABUMVBULBUMEUOUNBQTUTUNVBUMUACBUBSUCUKUQVCUPACBNUDUIUEUF
    UGRUJUH $.

  $( A vector belonging to both a subspace and the span of the singleton of a
     vector not in it must be zero.  (Contributed by NM, 17-Dec-2004.)
     (New usage is discouraged.) $)
  elspansn5 $p |- ( A e. SH -> ( ( ( B e. ~H /\ -. B e. A ) /\
         ( C e. ( span ` { B } ) /\ C e. A ) ) -> C = 0h ) ) $=
    ( csh wcel chil wn csn cspn cfv wa c0v wi wne elspansn4 biimprd exp32 com34
    wceq imp32 necon1bd exp31 imp4c ) ADEZBFEZBAEZGZCBHIJEZCAEZKZCLSZUDUEUJUGUK
    UDUEUJUGUKMUDUEKZUJKUFCLULUHUICLNZUFMULUHUMUIUFULUHUMUIUFMULUHUMKKUFUIABCOP
    QRTUAUBRUC $.

  $( The span of the singleton of an element of a subspace is included in the
     subspace.  (Contributed by NM, 16-Dec-2004.)
     (New usage is discouraged.) $)
  spansnss2 $p |- ( ( A e. SH /\ B e. ~H ) ->
                   ( B e. A <-> ( span ` { B } ) C_ A ) ) $=
    ( csh wcel chil wa csn cspn cfv wi spansnss ex adantr spansnid ssel syl5com
    wss adantl impbid ) ACDZBEDZFBADZBGHIZAQZTUBUDJUATUBUDABKLMUAUDUBJTUABUCDUD
    UBBNUCABOPRS $.

  ${
    $d x A $.  $d x B $.
    $( Cancellation-type law that "extracts" a vector ` A ` from its inner
       product with a proportional vector ` B ` .  (Contributed by NM,
       18-Mar-2006.)  (New usage is discouraged.) $)
    normcan $p |- ( ( B e. ~H /\ B =/= 0h /\ A e. ( span ` { B } ) ) ->
            ( ( ( A .ih B ) / ( ( normh ` B ) ^ 2 ) ) .h B ) = A ) $=
      ( vx chil wcel c0v wne csn cfv csp co cdiv csm wceq wa cc adantr ad2antrr
      simpr cc0 cspn cno c2 cexp cv wrex wb elspansn cmul oveq1 ax-his3 syl3anc
      simpl sylan9eqr normsq oveq12d adantllr hicl anidms his6 biimpar divcan4d
      necon3bid eqtrd oveq1d eqtr4d exp31 rexlimdv sylbid 3impia ) BDEZBFGZABHU
      AIEZABJKZBUBIUCUDKZLKZBMKZANZVKVLOZVMACUEZBMKZNZCPUFZVRVKVMWCUGVLCBAUHQVS
      WBVRCPVSVTPEZWBVRVSWDOZWBOZVQWAAWFVPVTBMWFVPVTBBJKZUIKZWGLKZVTVKWDWBVPWIN
      VLVKWDOZWBOVNWHVOWGLWBWJVNWABJKZWHAWABJUJWJWDVKVKWKWHNVKWDSVKWDUMZWLVTBBU
      KULUNVKVOWGNWDWBBUORUPUQWEWIVTNWBWEVTWGVSWDSVKWGPEZVLWDVKWMBBURUSRVSWGTGZ
      WDVKWNVLVKWGTBFBUTVCVAQVBQVDVEWEWBSVFVGVHVIVJ $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( A projection on the span of a singleton.  (The proof ws shortened by
       Mario Carneiro, 15-Dec-2013.)  (Contributed by NM, 28-May-2006.)
       (Revised by Mario Carneiro, 15-Dec-2013.)
       (New usage is discouraged.) $)
    pjspansn $p |- ( ( A e. ~H /\ B e. ~H /\ A =/= 0h ) -> ( ( projh ` ( span `
        { A } ) ) ` B ) = ( ( ( B .ih A ) / ( ( normh ` A ) ^ 2 ) ) .h A ) ) $=
      ( vy chil wcel cfv co wceq csp cdiv csm cch 3ad2ant1 wa syl2anc caddc cc0
      adantr sylan syl3anc c0v wne w3a csn cspn cpjh cva cno cexp cort spansnch
      cv wrex simp2 eqid pjeq mpbii simprd oveq1 ad2antll pjhcl choccl syl chel
      simpl1 ax-his2 csh spansnsh spansnid simpr shocorth 3impib orthcom syldan
      c2 wb mpbid 3ad2antl1 oveq2d cc hicl addid1d 3eqtrd adantrr oveq1d simpl3
      eqtrd axpjcl normcan eqtr2d rexlimddv ) ADEZBDEZAUAUBZUCZBBAUDUEFZUFFFZCU
      LZUGGZHZWQBAIGZAUHFVOUIGZJGZAKGZHCWPUJFZWOWPLEZWMWTCXEUMZWLWMXFWNAUKZMZWL
      WMWNUNZXFWMNZWQWPEZXGXKWQWQHXLXGNWQUOCBWQWPUPUQUROWOWRXEEZWTNZNZXDWQAIGZX
      BJGZAKGZWQXOXCXQAKXOXAXPXBJXOXAWSAIGZXPWTXAXSHWOXMBWSAIUSUTWOXMXSXPHWTWOX
      MNZXSXPWRAIGZPGZXPQPGXPXTWQDEZWRDEZWLXSYBHWOYCXMWOXFWMYCXIXJBWPVAORZWOXEL
      EZXMYDWLWMYFWNWLXFYFXHWPVBVCZMWRXEVDZSWLWMWNXMVEZWQWRAVFTXTYAQXPPWLWMXMYA
      QHZWNWLXMNZAWRIGQHZYJYKWPVGEZAWPEZXMYLWLYMXMAVHRWLYNXMAVIRWLXMVJYMYNXMYLA
      WRWPVKVLTWLXMYDYLYJVPWLYFXMYDYGYHSAWRVMVNVQVRVSXTXPXTYCWLXPVTEYEYIWQAWAOW
      BWCWDWGWEWEXOWLWNXLXRWQHWLWMWNXNVEWLWMWNXNWFWOXLXNWOXFWMXLXIXJBWPWHORWQAW
      ITWJWK $.
  $}

  ${
    spansnpj.1 $e |- A C_ ~H $.
    spansnpj.2 $e |- B e. ~H $.
    $( A subset of Hilbert space is orthogonal to the span of the singleton of
       a projection onto its orthocomplement.  (Contributed by NM,
       4-Jun-2004.)  (Revised by Mario Carneiro, 15-May-2014.)
       (New usage is discouraged.) $)
    spansnpji $p |- A C_
                 ( _|_ ` ( span ` { ( ( projh ` ( _|_ ` A ) ) ` B ) } ) ) $=
      ( cort cfv cpjh csn cspn chil wss ococss ax-mp cch wcel occl chssii snssi
      pjclii spanss mp2an csh chshii spanid sseqtri pjhclii spansnchi chsscon3i
      wceq mpbi sstri ) AAEFZEFZBULGFFZHZIFZEFZAJKZAUMKCALMUPULKUMUQKUPULIFZULU
      LJKUOULKZUPUSKULURULNOCAPMZQUNULOUTBULVADSUNULRMUOULTUAULUBOUSULUIULVAUCU
      LUDMUEUPULUNBULVADUFUGVAUHUJUK $.
  $}

  ${
    $d x y z w v u A $.  $d x y z w v u B $.
    spanunsn.1 $e |- A e. CH $.
    spanunsn.2 $e |- B e. ~H $.
    $( The span of the union of a closed subspace with a singleton equals the
       span of its union with an orthogonal singleton.  (Contributed by NM,
       3-Jun-2004.)  (New usage is discouraged.) $)
    spanunsni $p |- ( span ` ( A u. { B } ) ) =
             ( span ` ( A u. { ( ( projh ` ( _|_ ` A ) ) ` B ) } ) ) $=
      ( vy vz vw vv vu cfv cph co cv wcel cva wceq wrex chil csm cc vx csn cspn
      cort cpjh cun chshii wss csh snssi spancl mp2b shseli wi elspansni pjclii
      wa shmulcl mp3an13 shaddcl syl3an3 mp3an1 choccli pjhclii spansnmul pjpji
      mpan adantl oveq2i ax-hvdistr1 mp3an23 syl5eq oveq2d cheli mpan2 ax-hvass
      hvmulcl jca 3expb syl2an eqtr4d rspceov syl3anc sylibr oveq2 eqeq2d eleq1
      biimpa biimparc exp43 rexlimdv syl5bi rexlimiv sylbi negcl syl3an2 ancoms
      cneg syl c0v c1 hvm1neg hvnegid sylancl ax-hvcom syl2anc 3eqtr3d hvaddid2
      oveq1d hvaddcl anim12i hvadd4 impbii chssii spanuni spanid oveq1i 3eqtr4i
      eqriv ax-mp eqtri ) ABUBZUCJZKLZABAUDJZUEJJZUBZUCJZKLZAYBUFUCJZAYGUFUCJZU
      AYDYIUAMZYDNZYLYINZYMYLEMZFMZOLZPZFYCQZEAQYNEFAYCYLACUGZBRNZYBRUHZYCUINDB
      RUJZYBUKULZUMYSYNEAYOANZYRYNFYCYPYCNYPGMZBSLZPZGTQUUEYRYNUNZGBYPDUOUUEUUH
      UUIGTUUEUUFTNZUUHYRYNUUEUUJUQZYOUUGOLZYINZYLUULPZYNUUHYRUQUUKUULHMIMOLZPI
      YHQHAQZUUMUUKYOUUFBAUEJJZSLZOLZANZUUFYFSLZYHNZUULUUSUVAOLZPUUPAUINZUUEUUJ
      UUTYTUUJUVDUUEUURANZUUTUVDUUJUUQANZUVEYTBACDUPZUUFUUQAURUSYOUURAUTVAVBUUJ
      UVBUUEYFRNZUUJUVBBYEACVCDVDZYFUUFVEVGVHUUKUULYOUURUVAOLZOLZUVCUUKUUGUVJYO
      OUUJUUGUVJPUUEUUJUUGUUFUUQYFOLZSLZUVJBUVLUUFSBACDVFVIUUJUUQRNZUVHUVMUVJPB
      ACDVDZUVIUUFUUQYFVJVKVLVHZVMUUEYORNZUURRNZUVARNZUQUVCUVKPZUUJYOACVNZUUJUV
      RUVSUUJUVNUVRUVOUUFUUQVQVOZUUJUVHUVSUVIUUFYFVQVOZVRUVQUVRUVSUVTYOUURUVAVP
      VSVTWAHIAYHUUSUVAUULOWBWCHIAYHUULYTUVHYGRUHZYHUINUVIYFRUJZYGUKULZUMWDUUHY
      RUUNUUHYQUULYLYPUUGYOOWEWFWHUUNYNUUMYLUULYIWGWIVTWJWKWLWKWMWNYNYRFYHQZEAQ
      YMEFAYHYLYTUWFUMUWGYMEAUUEYRYMFYHYPYHNYPUVAPZGTQUUEYRYMUNZGYFYPUVIUOUUEUW
      HUWIGTUUEUUJUWHYRYMUUKYOUVAOLZYDNZYLUWJPZYMUWHYRUQUUKUWJUUOPIYCQHAQZUWKUU
      KUUFWRZUUQSLZYOOLZANZUUGYCNZUWJUWPUUGOLZPUWMUUJUUEUWQUVDUUJUUEUWQYTUUJUVD
      UWOANZUUEUWQUUJUWNTNZUWTUUFWOZUVDUXAUVFUWTYTUVGUWNUUQAURUSWSUWOYOAUTWPVBW
      QUUJUWRUUEUUAUUJUWRDBUUFVEVGVHUUKUWJUWPUVJOLZUWSUUKWTUWJOLZUWOUUROLZUWJOL
      ZUWJUXCUUKWTUXEUWJOUUJWTUXEPUUEUUJUURXAWRUURSLZOLZUURUWOOLZWTUXEUUJUXGUWO
      UUROUUJUVNUXGUWOPUVOUUFUUQXBVOVMUUJUVRUXHWTPUWBUURXCWSUUJUVRUWORNZUXIUXEP
      UWBUUJUXAUVNUXJUXBUVOUWNUUQVQXDZUURUWOXEXFXGVHXIUUKUWJRNZUXDUWJPUUEUVQUVS
      UXLUUJUWAUWCYOUVAXJVTUWJXHWSUUKUXJUVRUQZUVQUVSUQUXFUXCPUUJUXMUUEUUJUXJUVR
      UXKUWBVRVHUUEUVQUUJUVSUWAUWCXKUWOUURYOUVAXLXFXGUUKUUGUVJUWPOUVPVMWAHIAYCU
      WPUUGUWJOWBWCHIAYCUWJYTUUDUMWDUWHYRUWLUWHYQUWJYLYPUVAYOOWEWFWHUWLYMUWKYLU
      WJYDWGWIVTWJWKWLWKWMWNXMXSYJAUCJZYCKLYDAYBACXNZUUAUUBDUUCXTXOUXNAYCKUVDUX
      NAPYTAXPXTZXQYAYKUXNYHKLYIAYGUXOUVHUWDUVIUWEXTXOUXNAYHKUXPXQYAXR $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The span of a pair of vectors.  (Contributed by NM, 9-Jun-2006.)
       (New usage is discouraged.) $)
    spanpr $p |- ( ( A e. ~H /\ B e. ~H ) ->
                 ( span ` { ( A +h B ) } ) C_ ( span ` { A , B } ) ) $=
      ( vx chil wcel wa cva csn cspn cfv cph csh spansnsh syl2an adantr anim12i
      co spansnid wss snssi cpr cv shscl shsva simpr elspansn3 syl3anc ex ssrdv
      sylc cun df-pr fveq2i wceq spanun syl5req sseqtrd ) ADEZBDEZFZABGQZHIJZAH
      ZIJZBHZIJZKQZABUAZIJZUTCVBVGUTCUBZVBEZVJVGEZUTVKFVGLEZVAVGEZVKVLUTVMVKURV
      DLEZVFLEZVMUSAMZBMZVDVFUCNOUTVNVKUTVOVPFAVDEZBVFEZFVNURVOUSVPVQVRPURVSUSV
      TARBRPVDVFABUDUJOUTVKUEVGVAVJUFUGUHUIUTVIVCVEUKZIJZVGVHWAIABULUMURVCDSVED
      SWBVGUNUSADTBDTVCVEUONUPUQ $.
  $}

  ${
    $d x y A $.  $d x y B $.
    h1datom.1 $e |- A e. CH $.
    h1datom.2 $e |- B e. ~H $.
    $( A 1-dimensional subspace is an atom.  (Contributed by NM, 20-Jul-2001.)
       (New usage is discouraged.) $)
    h1datomi $p |- ( A C_ ( _|_ ` ( _|_ ` { B } ) ) ->
                  ( A = ( _|_ ` ( _|_ ` { B } ) ) \/ A = 0H ) ) $=
      ( vx vy cort cfv wss wne c0h wceq wi wa wcel c0v csm co cc cc0 wo cv wrex
      csn chne0i ssel h1de2ci oveq1 chil ax-hvmul0 ax-mp syl6eq syl5ibr necon3d
      eqeq1 adantl c1 cdiv reccl csh chshii shmulcl mp3an1 ex adantr oveq2 cmul
      simpl ax-hvmulass mp3an3 recid2 oveq1d eqtr3d ax-hvmulid sylan9eqr eleq1d
      syl syl2anc sylibd exp31 com23 imp syld com3r exp3a rexlimdv syl5bi snssi
      sylcom chssii occon2i ococi syl6sseq syl6 anc2li eqss syl6ibr neor sylibr
      necon1d ) ABUDZGHGHZIZAXBJAKLZMAXBLZXDUAXCAKAXBXCAKJZXCXBAIZNXEXCXFXGXCXF
      BAOZXGXFEUBZPJZEAUCXCXHEACUEXCXJXHEAXCXIAOZXIXBOZXJXHMZAXBXIUFXLXIFUBZBQR
      ZLZFSUCXKXMFXIBDUGXKXPXMFSXKXNSOZXPXMXQXPNZXJXKXHXRXJXNTJZXKXHMZXPXJXSMXQ
      XPXNTXIPXNTLZXIPLXPXOPLYAXOTBQRZPXNTBQUHBUIOZYBPLDBUJUKULXIXOPUOUMUNUPXQX
      PXSXTMXQXSXPXTXQXSXPXTXQXSNZXPNZXKUQXNURRZXIQRZAOZXHYDXKYHMZXPYDYFSOZYIXN
      USZYJXKYHAUTOYJXKYHACVAYFXIAVBVCVDVQVEYEYGBAXPYDYGYFXOQRZBXIXOYFQVFYDYLUQ
      BQRZBYDYFXNVGRZBQRZYLYMYDYJXQYOYLLZYKXQXSVHYJXQYCYPDYFXNBVIVJVRYDYNUQBQXN
      VKVLVMYCYMBLDBVNUKULVOVPVSVTWAWBWCWDWEWFWGWIWFWGXHXBAGHGHZAXHXAAIXBYQIBAW
      HXAAYCXAUIIDBUIWHUKACWJWKVQACWLWMWNWOAXBWPWQWTXDAXBWRWS $.
  $}

  $( A 1-dimensional subspace is an atom.  (Contributed by NM, 22-Jul-2001.)
     (New usage is discouraged.) $)
  h1datom $p |- ( ( A e. CH /\ B e. ~H ) ->
                ( A C_ ( _|_ ` ( _|_ ` { B } ) ) ->
                ( A = ( _|_ ` ( _|_ ` { B } ) ) \/ A = 0H ) ) ) $=
    ( cch wcel chil csn cort cfv wss wceq c0h wo wi cif c0v sseq1 eqeq1 imbi12d
    fveq2d elimel orbi12d sseq2d eqeq2d orbi1d h0elch ax-hv0cl h1datomi dedth2h
    sneq ) ACDZBEDZABFZGHZGHZIZAUNJZAKJZLZMUJAKNZUNIZUSUNJZUSKJZLZMUSUKBONZFZGH
    ZGHZIZUSVGJZVBLZMABKOAUSJZUOUTURVCAUSUNPVKUPVAUQVBAUSUNQAUSKQUARBVDJZUTVHVC
    VJVLUNVGUSVLUMVFGVLULVEGBVDUISSZUBVLVAVIVBVLUNVGUSVMUCUDRUSVDAKCUETBOEUFTUG
    UH $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Commutes relation for Hilbert lattice elements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Define the commutes relation (on the Hilbert lattice).  Definition of
       commutes in [Kalmbach] p. 20, who uses the notation xCy for "x commutes
       with y."  See ~ cmbri for membership relation.  (Contributed by NM,
       14-Jun-2004.)  (New usage is discouraged.) $)
    df-cm $a |- C_H = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
                x = ( ( x i^i y ) vH ( x i^i ( _|_ ` y ) ) ) ) } $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Binary relation expressing ` A ` commutes with ` B ` .  Definition of
       commutes in [Kalmbach] p. 20.  (Contributed by NM, 14-Jun-2004.)
       (New usage is discouraged.) $)
    cmbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_H B <->
               A = ( ( A i^i B ) vH ( A i^i ( _|_ ` B ) ) ) ) ) $=
      ( vx vy cch wcel wa ccm wbr cin cort cfv co wceq cv eleq1 oveq12d anbi12d
      chj ineq1 anbi1d id eqeq12d anbi2d ineq2 fveq2 ineq2d df-cm brabg bianabs
      eqeq2d ) AEFZBEFZGZABHIAABJZABKLZJZSMZNZCOZEFZDOZEFZGZUTUTVBJZUTVBKLZJZSM
      ZNZGULVCGZAAVBJZAVFJZSMZNZGUNUSGCDABEEHUTANZVDVJVIVNVOVAULVCUTAEPUAVOUTAV
      HVMVOUBVOVEVKVGVLSUTAVBTUTAVFTQUCRVBBNZVJUNVNUSVPVCUMULVBBEPUDVPVMURAVPVK
      UOVLUQSVBBAUEVPVFUPAVBBKUFUGQUKRCDUHUIUJ $.
  $}

  ${
    $d x A $.  $d x B $.
    pjoml2.1 $e |- A e. CH $.
    pjoml2.2 $e |- B e. CH $.
    $( Variation of orthomodular law.  Definition in [Kalmbach] p. 22.
       (Contributed by NM, 31-Oct-2000.)  (New usage is discouraged.) $)
    pjoml2i $p |- ( A C_ B -> ( A vH ( ( _|_ ` A ) i^i B ) ) = B ) $=
      ( wss cort cfv cin chj co c0h inss2 choccli chincli chlubii mpan2 chdmj1i
      wceq ineq2i incom ineq1i inass chocini 3eqtr3i eqtri chjcli chshii pjomli
      sylancl ) ABEZAAFGZBHZIJZBEZBUMFGZHZKRUMBRUJULBEUNUKBLAULBCUKBACMDNZDOPUP
      BUKULFGZHZHZKUOUSBAULCUQQSBUKHZURHULURHUTKVAULURBUKTUABUKURUBULUQUCUDUEUM
      BAULCUQUFBDUGUHUI $.

    $( Variation of orthomodular law.  (Contributed by NM, 24-Jun-2004.)
       (New usage is discouraged.) $)
    pjoml3i $p |- ( B C_ A -> ( A i^i ( ( _|_ ` A ) vH B ) ) = B ) $=
      ( cort cfv wss cin chj co choccli pjoml2i chsscon3i eqcom chincli chdmj2i
      wceq chdmm4i ineq2i eqtri eqeq1i chjcli chcon2i 3bitr3i 3imtr4i ) AEFZBEF
      ZGUFUFEFZUGHZIJZUGQZBAGAUFBIJZHZBQZUFUGACKZBDKZLBADCMUJEFZBQBUQQUNUKUQBNU
      QUMBUQAUIEFZHUMAUICUHUGUFUOKUPOZPURULAUFBUODRSTUABUJDUFUIUOUSUBUCUDUE $.

    $( Variation of orthomodular law.  (Contributed by NM, 6-Dec-2000.)
       (New usage is discouraged.) $)
    pjoml4i $p |- ( A vH ( B i^i ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) ) =
                 ( A vH B ) $=
      ( cort cfv chj cin wss inss1 choccli chjcli chincli chlej2i ax-mp chdmm1i
      co chub1i ineq1i incom eqtri oveq2i inss2 pjoml2i eqtr3i chlej1i eqsstr3i
      wceq chlubii mp2an eqssi ) ABAEFZBEFZGQZHZGQZABGQZUOBIUPUQIBUNJUOBABUNDUL
      UMACKBDKLMZDCNOAUPIBUPIUQUPIAUOCURRBABHZUOGQZUPUSUSEFZBHZGQZUTBVBUOUSGVBU
      NBHUOVAUNBABCDPSUNBTUAUBUSBIVCBUHABUCUSBABCDMZDUDOUEUSAIUTUPIABJUSAUOVDCU
      RUFOUGABUPCDAUOCURLUIUJUK $.

    $( The orthomodular law.  Remark in [Kalmbach] p. 22.  (Contributed by NM,
       12-Jun-2006.)  (New usage is discouraged.) $)
    pjoml5i $p |- ( A vH ( ( _|_ ` A ) i^i ( A vH B ) ) ) = ( A vH B ) $=
      ( chj co wss cort cfv cin wceq chub1i chjcli pjoml2i ax-mp ) AABEFZGAAHIP
      JEFPKABCDLAPCABCDMNO $.

    $( An equivalent of the orthomodular law.  Theorem 29.13(e) of [MaedaMaeda]
       p. 132.  (Contributed by NM, 30-May-2004.)
       (New usage is discouraged.) $)
    pjoml6i $p |- ( A C_ B ->
                  E. x e. CH ( A C_ ( _|_ ` x ) /\ ( A vH x ) = B ) ) $=
      ( wss cort cfv cin cch wcel chj co wceq wa wrex choccli chincli pjoml2i
      cv chub1i chdmm2i sseqtr4i jctil fveq2 sseq2d oveq2 eqeq1d anbi12d rspcev
      sylancr ) BCFZBGHZCIZJKBUNGHZFZBUNLMZCNZOZBATZGHZFZBUTLMZCNZOZAJPUMCBDQER
      ULURUPBCDESBBCGHZLMUOBVFDCEQUABCDEUBUCUDVEUSAUNJUTUNNZVBUPVDURVGVAUOBUTUN
      GUEUFVGVCUQCUTUNBLUGUHUIUJUK $.

    $( Binary relation expressing the commutes relation.  Definition of
       commutes in [Kalmbach] p. 20.  (Contributed by NM, 6-Aug-2004.)
       (New usage is discouraged.) $)
    cmbri $p |- ( A C_H B <-> A = ( ( A i^i B ) vH ( A i^i ( _|_ ` B ) ) ) ) $=
      ( cch wcel ccm wbr cin cort cfv chj co wceq wb cmbr mp2an ) AEFBEFABGHAAB
      IABJKILMNOCDABPQ $.

    $( Commutation is symmetric.  Theorem 3.4 of [Beran] p. 45.  (Contributed
       by NM, 3-Nov-2000.)  (New usage is discouraged.) $)
    cmcmlem $p |- ( A C_H B -> B C_H A ) $=
      ( cin cort cfv chj wceq ccm wbr wss choccli chub2i chdmj4i oveq12i chjcli
      co incom cmbri sseqin2 mpbi ineq2i chdmm1i ineq1i 3eqtr4ri chdmj2i eqeq2i
      inass biimpri fveq2d syl6req ineq1d syl5eq oveq2d chincli pjoml2i 3eqtr3g
      inss2 ax-mp 3imtr4i ) AABEZABFGZEZHRZIZBBAEZBAFGZEZHRZIABJKBAJKVFVBVBFGZB
      EZHRZVBVHBEZHRBVJVFVLVNVBHVFVLVHVCHRZVHBHRZEZBEZVNVOVPBEZEVOBEVRVLVSBVOBV
      PLVSBIBVHDACMZNBVPUAUBUCVOVPBUIVKVOBABCDUDUEUFVFVQVHBVFVHVOFGZVPFGZHRZFGV
      QVFAWCFAWCIVFWCVEAWAVBWBVDHABCDOABCDUGPUHUJUKVOVPVHVCVTBDMQVHBVTDQOULUMUN
      UOVBBLVMBIABUSVBBABCDUPDUQUTVBVGVNVIHABSVHBSPURABCDTBADCTVA $.

    $( Commutation is symmetric.  Theorem 2(v) of [Kalmbach] p. 22.
       (Contributed by NM, 4-Nov-2000.)  (New usage is discouraged.) $)
    cmcmi $p |- ( A C_H B <-> B C_H A ) $=
      ( ccm wbr cmcmlem impbii ) ABEFBAEFABCDGBADCGH $.

    $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39.
       (Contributed by NM, 4-Nov-2000.)  (New usage is discouraged.) $)
    cmcm2i $p |- ( A C_H B <-> A C_H ( _|_ ` B ) ) $=
      ( cin cort cfv chj co wceq ccm wbr chincli choccli chjcomi pjococi ineq2i
      oveq2i eqtr4i cmbri eqeq2i 3bitr4i ) AABEZABFGZEZHIZJAUEAUDFGZEZHIZJABKLA
      UDKLUFUIAUFUEUCHIUIUCUEABCDMAUDCBDNZMOUHUCUEHUGBABDPQRSUAABCDTAUDCUJTUB
      $.

    $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23.
       (Contributed by NM, 4-Nov-2000.)  (New usage is discouraged.) $)
    cmcm3i $p |- ( A C_H B <-> ( _|_ ` A ) C_H B ) $=
      ( ccm wbr cort cfv cmcm2i cmcmi choccli 3bitr4i ) BAEFBAGHZEFABEFMBEFBADC
      IABCDJMBACKDJL $.

    $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23.
       (Contributed by NM, 7-Aug-2004.)  (New usage is discouraged.) $)
    cmcm4i $p |- ( A C_H B <-> ( _|_ ` A ) C_H ( _|_ ` B ) ) $=
      ( ccm wbr cort cfv cmcm2i choccli cmcm3i bitri ) ABEFABGHZEFAGHMEFABCDIAM
      CBDJKL $.

    $( Alternate definition of the commutes relation.  Remark in [Kalmbach]
       p. 23.  (Contributed by NM, 7-Aug-2004.)  (New usage is discouraged.) $)
    cmbr2i $p |- ( A C_H B <-> A = ( ( A vH B ) i^i ( A vH ( _|_ ` B ) ) ) ) $=
      ( ccm wbr cort cfv cin chj wceq cmcm4i choccli cmbri eqcom chjcli chincli
      co chcon3i chdmj1i chdmm1i oveq12i eqtri eqeq2i 3bitrri 3bitri ) ABEFAGHZ
      BGHZEFUGUGUHIZUGUHGHIZJRZKZAABJRZAUHJRZIZKZABCDLUGUHACMBDMZNUPUOAKUGUOGHZ
      KULAUOOUOAUMUNABCDPZAUHCUQPZQCSURUKUGURUMGHZUNGHZJRUKUMUNUSUTUAVAUIVBUJJA
      BCDTAUHCUQTUBUCUDUEUF $.

    ${
      cmcmi.1 $e |- A C_H B $.
      $( Commutation is symmetric.  Theorem 2(v) of [Kalmbach] p. 22.
         (Contributed by NM, 7-Aug-2004.)  (New usage is discouraged.) $)
      cmcmii $p |- B C_H A $=
        ( ccm wbr cmcmi mpbi ) ABFGBAFGEABCDHI $.

      $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39.
         (Contributed by NM, 7-Aug-2004.)  (New usage is discouraged.) $)
      cmcm2ii $p |- A C_H ( _|_ ` B ) $=
        ( ccm wbr cort cfv cmcm2i mpbi ) ABFGABHIFGEABCDJK $.

      $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23.
         (Contributed by NM, 7-Aug-2004.)  (New usage is discouraged.) $)
      cmcm3ii $p |- ( _|_ ` A ) C_H B $=
        ( ccm wbr cort cfv cmcm3i mpbi ) ABFGAHIBFGEABCDJK $.
    $}

    $( Alternate definition for the commutes relation.  Lemma 3 of [Kalmbach]
       p. 23.  (Contributed by NM, 6-Dec-2000.)  (New usage is discouraged.) $)
    cmbr3i $p |- ( A C_H B
             <-> ( A i^i ( ( _|_ ` A ) vH B ) ) = ( A i^i B ) ) $=
      ( ccm wbr cort cfv chj co wceq cmcmi cmbr2i chjcomi ineq2i choccli eqtr3i
      cin sylbi chincli bitri ineq2 inass chabs2i eqtri ineq12i syl6req pjoml2i
      wss inss1 ax-mp chdmm3i incom eqeq1i oveq1 syl5eq cmbri sylibr impbii ) A
      BEFZAAGHZBIJZRZABRZKZUTBBAIJZBVAIJZRZKZVEUTBAEFVIABCDLBADCMUAVIVDAVHRZVCB
      VHAUBAVFRZVGRVJVCAVFVGUCVKAVGVBVKAABIJZRAVFVLABADCNOABCDUDUEBVADACPNUFQUG
      SVEAVDABGHZRZIJZKUTVEAVNGHZARZVNIJZVOVNVQIJZAVRVNAUIVSAKAVMUJVNAAVMCBDPTZ
      CUHUKVNVQVTVPAVNVTPCTNQVEVQVDKVRVOKVCVQVDAVPRVCVQVPVBAABCDULOAVPUMQUNVQVD
      VNIUOSUPABCDUQURUS $.

    $( Alternate definition for the commutes relation.  (Contributed by NM,
       6-Dec-2000.)  (New usage is discouraged.) $)
    cmbr4i $p |- ( A C_H B <-> ( A i^i ( ( _|_ ` A ) vH B ) ) C_ B ) $=
      ( ccm wbr cort cfv chj co cin wceq wss cmbr3i inss2 sseq1 mpbiri wa inss1
      jctl ssin sylib choccli chub2i sslin ax-mp jctir eqss sylibr impbii bitri
      ) ABEFAAGHZBIJZKZABKZLZUNBMZABCDNUPUQUPUQUOBMABOUNUOBPQUQUNUOMZUOUNMZRUPU
      QURUSUQUNAMZUQRURUQUTAUMSTUNABUAUBBUMMUSBULDACUCUDBUMAUEUFUGUNUOUHUIUJUK
      $.

    $( Comparable Hilbert lattice elements commute.  Theorem 2.3(iii) of
       [Beran] p. 40.  (Contributed by NM, 16-Jan-2005.)
       (New usage is discouraged.) $)
    lecmi $p |- ( A C_ B -> A C_H B ) $=
      ( wss cort cfv chj co cin ccm wbr ssinss1 cmbr4i sylibr ) ABEAAFGBHIZJBEA
      BKLAPBMABCDNO $.

    ${
      lecmi.1 $e |- A C_ B $.
      $( Comparable Hilbert lattice elements commute.  Theorem 2.3(iii) of
         [Beran] p. 40.  (Contributed by NM, 7-Aug-2004.)
         (New usage is discouraged.) $)
      lecmii $p |- A C_H B $=
        ( wss ccm wbr lecmi ax-mp ) ABFABGHEABCDIJ $.
    $}

    $( A Hilbert lattice element commutes with its join.  (Contributed by NM,
       7-Aug-2004.)  (New usage is discouraged.) $)
    cmj1i $p |- A C_H ( A vH B ) $=
      ( chj co chjcli chub1i lecmii ) AABEFCABCDGABCDHI $.

    $( A Hilbert lattice element commutes with its join.  (Contributed by NM,
       7-Aug-2004.)  (New usage is discouraged.) $)
    cmj2i $p |- B C_H ( A vH B ) $=
      ( chj co chjcli chub2i lecmii ) BABEFDABCDGBADCHI $.

    $( A Hilbert lattice element commutes with its meet.  (Contributed by NM,
       7-Aug-2004.)  (New usage is discouraged.) $)
    cmm1i $p |- A C_H ( A i^i B ) $=
      ( cin chincli inss1 lecmii cmcmii ) ABEZAABCDFZCJAKCABGHI $.

    $( A Hilbert lattice element commutes with its meet.  (Contributed by NM,
       7-Aug-2004.)  (New usage is discouraged.) $)
    cmm2i $p |- B C_H ( A i^i B ) $=
      ( cin ccm cmm1i incom breqtri ) BBAEABEFBADCGBAHI $.
  $}

  $( Alternate definition for the commutes relation.  Lemma 3 of [Kalmbach]
     p. 23.  (Contributed by NM, 14-Jun-2006.)  (New usage is discouraged.) $)
  cmbr3 $p |- ( ( A e. CH /\ B e. CH ) ->
              ( A C_H B <-> ( A i^i ( ( _|_ ` A ) vH B ) ) = ( A i^i B ) ) ) $=
    ( cch wcel ccm wbr cort cfv chj co cin wceq wb c0h cif breq1 eqeq12d h0elch
    bibi12d elimel fveq2 oveq1d ineq12d ineq1 breq2 oveq2 ineq2d cmbr3i dedth2h
    id ineq2 ) ACDZBCDZABEFZAAGHZBIJZKZABKZLZMULANOZBEFZUTUTGHZBIJZKZUTBKZLZMUT
    UMBNOZEFZUTVBVGIJZKZUTVGKZLZMABNNAUTLZUNVAUSVFAUTBEPVMUQVDURVEVMAUTUPVCVMUJ
    VMUOVBBIAUTGUAUBUCAUTBUDQSBVGLZVAVHVFVLBVGUTEUEVNVDVJVEVKVNVCVIUTBVGVBIUFUG
    BVGUTUKQSUTVGANCRTBNCRTUHUI $.

  $( The zero Hilbert lattice element commutes with every element.
     (Contributed by NM, 16-Jun-2006.)  (New usage is discouraged.) $)
  cm0 $p |- ( A e. CH -> 0H C_H A ) $=
    ( cch wcel c0h ccm wbr cort cfv chj cin wceq h0elch choccli chjcl mpan chm0
    co syl eqtr4d incom 3eqtr4g wb cmbr3 mpbird ) ABCZDAEFZDDGHZAIQZJZDAJZKZUEU
    HDJZADJZUIUJUEULDUMUEUHBCZULDKUGBCUEUNDLMUGANOUHPRAPSDUHTDATUADBCUEUFUKUBLD
    AUCOUD $.

  ${
    cmid.1 $e |- A e. CH $.
    $( The commutes relation is reflexive.  (Contributed by NM, 7-Aug-2004.)
       (New usage is discouraged.) $)
    cmidi $p |- A C_H A $=
      ( ssid lecmii ) AABBACD $.
  $}

  $( Variation of orthomodular law.  Definition in [Kalmbach] p. 22.
     (Contributed by NM, 13-Jun-2006.)  (New usage is discouraged.) $)
  pjoml2 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) ->
                ( A vH ( ( _|_ ` A ) i^i B ) ) = B ) $=
    ( cch wcel wss cort cfv cin chj co wi c0h cif sseq1 id fveq2 imbi12d h0elch
    wceq elimel ineq1d oveq12d eqeq1d sseq2 ineq2 oveq2d eqeq12d pjoml2i 3impia
    dedth2h ) ACDZBCDZABEZAAFGZBHZIJZBSZUKULUMUQKUKALMZBEZURURFGZBHZIJZBSZKURUL
    BLMZEZURUTVDHZIJZVDSZKABLLAURSZUMUSUQVCAURBNVIUPVBBVIAURUOVAIVIOVIUNUTBAURF
    PUAUBUCQBVDSZUSVEVCVHBVDURUDVJVBVGBVDVJVAVFURIBVDUTUEUFVJOUGQURVDALCRTBLCRT
    UHUJUI $.

  $( Variation of orthomodular law.  (Contributed by NM, 24-Jun-2004.)
     (New usage is discouraged.) $)
  pjoml3 $p |- ( ( A e. CH /\ B e. CH ) ->
                ( B C_ A -> ( A i^i ( ( _|_ ` A ) vH B ) ) = B ) ) $=
    ( cch wcel wss cort cfv chj co cin wceq wi cif sseq2 id fveq2 imbi12d helch
    chil elimel oveq1d ineq12d eqeq1d sseq1 ineq2d eqeq12d pjoml3i dedth2h
    oveq2 ) ACDZBCDZBAEZAAFGZBHIZJZBKZLBUJASMZEZUQUQFGZBHIZJZBKZLUKBSMZUQEZUQUS
    VCHIZJZVCKZLABSSAUQKZULURUPVBAUQBNVHUOVABVHAUQUNUTVHOVHUMUSBHAUQFPUAUBUCQBV
    CKZURVDVBVGBVCUQUDVIVAVFBVCVIUTVEUQBVCUSHUIUEVIOUFQUQVCASCRTBSCRTUGUH $.

  $( The orthomodular law.  Remark in [Kalmbach] p. 22.  (Contributed by NM,
     12-Jun-2006.)  (New usage is discouraged.) $)
  pjoml5 $p |- ( ( A e. CH /\ B e. CH ) ->
             ( A vH ( ( _|_ ` A ) i^i ( A vH B ) ) ) = ( A vH B ) ) $=
    ( cch wcel wa chj co wss cort cfv cin wceq simpl chjcl chub1 pjoml2 syl3anc
    ) ACDZBCDZERABFGZCDATHAAIJTKFGTLRSMABNABOATPQ $.

  $( Commutation is symmetric.  Theorem 2(v) of [Kalmbach] p. 22.  (Contributed
     by NM, 13-Jun-2006.)  (New usage is discouraged.) $)
  cmcm $p |- ( ( A e. CH /\ B e. CH ) -> ( A C_H B <-> B C_H A ) ) $=
    ( cch wcel ccm wbr wb c0h cif wceq breq1 breq2 bibi12d h0elch cmcmi dedth2h
    elimel ) ACDZBCDZABEFZBAEFZGRAHIZBEFZBUBEFZGUBSBHIZEFZUEUBEFZGABHHAUBJTUCUA
    UDAUBBEKAUBBELMBUEJUCUFUDUGBUEUBELBUEUBEKMUBUEAHCNQBHCNQOP $.

  $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23.
     (Contributed by NM, 13-Jun-2006.)  (New usage is discouraged.) $)
  cmcm3 $p |- ( ( A e. CH /\ B e. CH ) ->
               ( A C_H B <-> ( _|_ ` A ) C_H B ) ) $=
    ( cch wcel ccm wbr cort cfv wb c0h cif wceq breq1 fveq2 breq1d breq2 h0elch
    bibi12d elimel cmcm3i dedth2h ) ACDZBCDZABEFZAGHZBEFZIUBAJKZBEFZUGGHZBEFZIU
    GUCBJKZEFZUIUKEFZIABJJAUGLZUDUHUFUJAUGBEMUNUEUIBEAUGGNORBUKLUHULUJUMBUKUGEP
    BUKUIEPRUGUKAJCQSBJCQSTUA $.

  $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39.
     (Contributed by NM, 14-Jun-2006.)  (New usage is discouraged.) $)
  cmcm2 $p |- ( ( A e. CH /\ B e. CH ) ->
               ( A C_H B <-> A C_H ( _|_ ` B ) ) ) $=
    ( cch wcel wa ccm wbr cort cfv wb cmcm3 ancoms cmcm choccl sylan2 3bitr4d )
    ACDZBCDZEBAFGZBHIZAFGZABFGATFGZRQSUAJBAKLABMRQTCDUBUAJBNATMOP $.

  $( Comparable Hilbert lattice elements commute.  Theorem 2.3(iii) of [Beran]
     p. 40.  (Contributed by NM, 13-Jun-2006.)  (New usage is discouraged.) $)
  lecm $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) -> A C_H B ) $=
    ( cch wcel wss ccm wbr c0h cif wceq sseq1 breq1 imbi12d sseq2 h0elch elimel
    wi breq2 lecmi dedth2h 3impia ) ACDZBCDZABEZABFGZUBUCUDUEQUBAHIZBEZUFBFGZQU
    FUCBHIZEZUFUIFGZQABHHAUFJUDUGUEUHAUFBKAUFBFLMBUIJUGUJUHUKBUIUFNBUIUFFRMUFUI
    AHCOPBHCOPSTUA $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Foulis-Holland theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
     lattice elements commute, the triple is distributive.  First of two
     parts.  Theorem 5 of [Kalmbach] p. 25.  (Contributed by NM, 14-Jun-2006.)
     (New usage is discouraged.) $)
  fh1 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A C_H B /\ A C_H C ) )
             -> ( A i^i ( B vH C ) ) = ( ( A i^i B ) vH ( A i^i C ) ) ) $=
    ( cch wcel ccm wbr wa cin chj cort cfv c0h wceq chincl sylan2 adantr ineq2d
    co eqtrd w3a csh wss chjcl syl2an anandis chsh syl jca 3impb ledi incom a1i
    chdmj1 chdmm1 ineqan12d ineq12d 3impdi inass cmcm2 wb choccl cmbr3 3adantl3
    bitrd biimpa adantrr 3adantl2 adantrl inindi syl5eq in12 syl6eq chocin chm0
    3eqtr4g eqtr3d sylan9eqr pjoml syl12anc eqcomd ) ADEZBDEZCDEZUAZABFGZACFGZH
    ZHZABIZACIZJSZABCJSZIZWIWLDEZWNUBEZHZWLWNUCZWNWLKLZIZMNWLWNNWEWQWHWBWCWDWQW
    BWCWDHZHZWOWPWBWCWDWOWBWCHZWJDEZWKDEZWOWBWDHZABOZACOZWJWKUDUEUFXBWNDEZWPXAW
    BWMDEZXIBCUDZAWMOPWNUGUHUIUJQWEWRWHABCUKQWIWTWMAIZAKLZBKLZJSZXMCKLZJSZIZIZM
    WEWTXSNZWHWBWCWDXTXCXFHZWNXLWSXRWNXLNYAAWMULUMYAWSWJKLZWKKLZIZXRXCXDXEWSYDN
    XFXGXHWJWKUNUEXCXFYBXOYCXQABUOACUOUPTUQURQWIXSAWMXNXPIZIZIZMWIXSWMAYEIZIZYG
    WIXSWMAXRIZIYIWMAXRUSWIYJYHWMWIAXOIZAXQIZIAXNIZAXPIZIYJYHWIYKYMYLYNWEWFYKYM
    NZWGWBWCWFYOWDXCWFYOXCWFAXNFGZYOABUTWCWBXNDEYPYOVABVBAXNVCPVEVFVDVGWEWGYLYN
    NZWFWBWDWGYQWCXFWGYQXFWGAXPFGZYQACUTWDWBXPDEYRYQVACVBAXPVCPVEVFVHVIUQAXOXQV
    JAXNXPVJVPRVKWMAYEVLVMWEYGMNZWHWBWCWDYSXAWBYGAMIMXAYFMAXAWMWMKLZIZYFMXAYTYE
    WMBCUNRXAXJUUAMNXKWMVNUHVQRAVOVRUJQTTWLWNVSVTWA $.

  $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
     lattice elements commute, the triple is distributive.  Second of two
     parts.  Theorem 5 of [Kalmbach] p. 25.  (Contributed by NM, 14-Jun-2006.)
     (New usage is discouraged.) $)
  fh2 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( B C_H A /\ B C_H C ) )
             -> ( A i^i ( B vH C ) ) = ( ( A i^i B ) vH ( A i^i C ) ) ) $=
    ( cch wcel ccm wbr wa cin chj co cort cfv c0h wceq chincl syl adantr ineq1d
    eqtrd w3a csh wss chjcl syl2an anandis sylan2 chsh 3impb ledi chdmj1 chdmm1
    jca 3impdi ineq2d in4 cmcm2 cmcm choccl cmbr3 3bitr3d biimpa incom 3adantl3
    wb syl6eq adantrr syl5eq oveq1d 3ad2ant2 cmcm3 sylan bitrd 3adantl1 adantrl
    ococ eqtr3d inass in12 eqtr4i chocin 3adant2 chm0 pjoml syl12anc eqcomd ) A
    DEZBDEZCDEZUAZBAFGZBCFGZHZHZABIZACIZJKZABCJKZIZWNWQDEZWSUBEZHZWQWSUCZWSWQLM
    ZIZNOWQWSOWJXBWMWGWHWIXBWGWHWIHZHZWTXAWGWHWIWTWGWHHZWODEZWPDEZWTWGWIHZABPZA
    CPZWOWPUDUEUFXGWSDEZXAXFWGWRDEXNBCUDAWRPUGWSUHQUMUIRWJXCWMABCUJRWNXEBLMZWRI
    ZAWPLMZIZIZNWNXEXOAIZWRXQIZIZXSWNXEWSALMXOJKZXQIZIZYBWJXEYEOWMWJXDYDWSWGWHW
    IXDYDOXHXKHZXDWOLMZXQIZYDXHXIXJXDYHOXKXLXMWOWPUKUEYFYGYCXQXHYGYCOXKABULRSTU
    NUORWNYEAYCIZYAIYBAWRYCXQUPWNYIXTYAWJWKYIXTOZWLWGWHWKYJWIXHWKHYIAXOIZXTXHWK
    YIYKOZXHABFGAXOFGZWKYLABUQABURWHWGXODEZYMYLVEBUSZAXOUTUGVAVBAXOVCVFVDVGSVHT
    XOAWRXQUPVFWNXSXOCIZXRIZNWNXPYPXRWNXOXOLMZCJKZIZXPYPWJYTXPOZWMWHWGUUAWIWHYS
    WRXOWHYRBCJBVPVIUOVJRWJWLYTYPOZWKWHWIWLUUBWGXFWLUUBXFWLXOCFGZUUBBCVKWHYNWIU
    UCUUBVEYOXOCUTVLVMVBVNVOVQSWJYQNOWMWJYQXONIZNWGWIYQUUDOWHXKYQXOCXRIZIUUDXOC
    XRVRXKUUENXOXKUUEWPXQIZNUUEACXQIIUUFCAXQVSACXQVRVTXKXJUUFNOXMWPWAQVHUOVHWBW
    HWGUUDNOZWIWHYNUUGYOXOWCQVJTRTTWQWSWDWEWF $.

  $( A lattice element that commutes with two others also commutes with their
     join.  Theorem 4.2 of [Beran] p. 49.  (Contributed by NM, 15-Jun-2006.)
     (New usage is discouraged.) $)
  cm2j $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A C_H B /\ A C_H C ) )
             -> A C_H ( B vH C ) ) $=
    ( cch wcel ccm wbr wa chj co cin wceq cmcm ancoms bitrd biimpa incom chincl
    wb cmbr w3a cort cfv oveq12i syl6eq 3adantl3 adantrr adantrl oveq12d choccl
    3adantl2 sylan jca chj4 syl2an 3impdi adantr syl5reqr 3anim1i cmcm3 3adant3
    fh1 3adant2 anbi12d syl2anc 3eqtrd ex chjcl sylan2 3impb sylibrd imp ) ADEZ
    BDEZCDEZUAZABFGZACFGZHZABCIJZFGZVPVSVTVTAKZVTAUBUCZKZIJZLZWAVPVSWFVPVSHZVTA
    BKZWCBKZIJZACKZWCCKZIJZIJZWHWKIJZWIWLIJZIJZWEWGBWJCWMIVPVQBWJLZVRVMVNVQWRVO
    VMVNHZVQHBBAKZBWCKZIJZWJWSVQBXBLZWSVQBAFGZXCABMVNVMXDXCSBATNOPWTWHXAWIIBAQB
    WCQUDUEUFUGVPVRCWMLZVQVMVOVRXEVNVMVOHZVRHCCAKZCWCKZIJZWMXFVRCXILZXFVRCAFGZX
    JACMVOVMXKXJSCATNOPXGWKXHWLICAQCWCQUDUEUKUHUIVPWNWQLZVSVMVNVOXLWSWHDEZWIDEZ
    HWKDEZWLDEZHXLXFWSXMXNABRVMWCDEZVNXNAUJZWCBRULUMXFXOXPACRVMXQVOXPXRWCCRULUM
    WHWIWKWLUNUOUPUQWGWOWBWPWDIWGWBAVTKWOAVTQABCVBURWGWDWCVTKZWPWCVTQWGXQVNVOUA
    ZWCBFGZWCCFGZHZXSWPLVPXTVSVMXQVNVOXRUSUQVPVSYCVPVQYAVRYBVMVNVQYASVOABUTVAVM
    VOVRYBSVNACUTVCVDPWCBCVBVEURUIVFVGVMVNVOWAWFSZVNVOHVMVTDEZYDBCVHVMYEHWAVTAF
    GZWFAVTMYEVMYFWFSVTATNOVIVJVKVL $.

  ${
    fh1.1 $e |- A e. CH $.
    fh1.2 $e |- B e. CH $.
    fh1.3 $e |- C e. CH $.
    fh1.4 $e |- A C_H B $.
    fh1.5 $e |- A C_H C $.
    $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
       lattice elements commute, the triple is distributive.  First of two
       parts.  Theorem 5 of [Kalmbach] p. 25.  (Contributed by NM,
       7-Aug-2004.)  (New usage is discouraged.) $)
    fh1i $p |- ( A i^i ( B vH C ) ) = ( ( A i^i B ) vH ( A i^i C ) ) $=
      ( cch wcel w3a ccm wbr wa chj co cin wceq 3pm3.2i pm3.2i fh1 mp2an ) AIJZ
      BIJZCIJZKABLMZACLMZNABCOPQABQACQOPRUCUDUEDEFSUFUGGHTABCUAUB $.

    $( Foulis-Holland Theorem.  If any 2 pairs in a triple of orthomodular
       lattice elements commute, the triple is distributive.  Second of two
       parts.  Theorem 5 of [Kalmbach] p. 25.  (Contributed by NM,
       7-Aug-2004.)  (New usage is discouraged.) $)
    fh2i $p |- ( B i^i ( A vH C ) ) = ( ( B i^i A ) vH ( B i^i C ) ) $=
      ( cch wcel w3a ccm wbr wa chj co cin wceq 3pm3.2i pm3.2i fh2 mp2an ) BIJZ
      AIJZCIJZKABLMZACLMZNBACOPQBAQBCQOPRUCUDUEEDFSUFUGGHTBACUAUB $.

    $( Variation of the Foulis-Holland Theorem.  (Contributed by NM,
       16-Jan-2005.)  (New usage is discouraged.) $)
    fh3i $p |- ( A vH ( B i^i C ) ) = ( ( A vH B ) i^i ( A vH C ) ) $=
      ( cin chj co wceq cort cfv choccli cmcm3ii cmcm2ii chdmm1i chdmj1i chjcli
      fh1i ineq2i oveq12i 3eqtr4ri chincli 3eqtr4i chcon3i mpbir ) ABCIZJKZABJK
      ZACJKZIZLUMMNZUJMNZLUKMNZULMNZJKZAMNZUIMNZIZUNUOUSBMNZCMNZJKZIUSVBIZUSVCI
      ZJKVAURUSVBVCADOZBEOCFOUSBVGEABDEGPQUSCVGFACDFHPQUAUTVDUSBCEFRUBUPVEUQVFJ
      ABDESACDFSUCUDUKULABDETZACDFTZRAUIDBCEFUEZSUFUJUMAUIDVJTUKULVHVIUEUGUH $.

    $( Variation of the Foulis-Holland Theorem.  (Contributed by NM,
       16-Jan-2005.)  (New usage is discouraged.) $)
    fh4i $p |- ( B vH ( A i^i C ) ) = ( ( B vH A ) i^i ( B vH C ) ) $=
      ( cin chj co wceq cort cfv choccli cmcm3ii cmcm2ii chdmm1i chdmj1i chjcli
      fh2i ineq2i oveq12i 3eqtr4ri chincli 3eqtr4i chcon3i mpbir ) BACIZJKZBAJK
      ZBCJKZIZLUMMNZUJMNZLUKMNZULMNZJKZBMNZUIMNZIZUNUOUSAMNZCMNZJKZIUSVBIZUSVCI
      ZJKVAURVBUSVCADOZBEOCFOVBBVGEABDEGPQVBCVGFACDFHPQUAUTVDUSACDFRUBUPVEUQVFJ
      BAEDSBCEFSUCUDUKULBAEDTZBCEFTZRBUIEACDFUEZSUFUJUMBUIEVJTUKULVHVIUEUGUH $.

    $( A lattice element that commutes with two others also commutes with their
       join.  Theorem 4.2 of [Beran] p. 49.  (Contributed by NM, 11-May-2009.)
       (New usage is discouraged.) $)
    cm2ji $p |- A C_H ( B vH C ) $=
      ( cch wcel w3a ccm wbr wa chj co 3pm3.2i pm3.2i cm2j mp2an ) AIJZBIJZCIJZ
      KABLMZACLMZNABCOPLMUAUBUCDEFQUDUEGHRABCST $.

    $( A lattice element that commutes with two others also commutes with their
       meet.  Theorem 4.2 of [Beran] p. 49.  (Contributed by NM, 11-May-2009.)
       (New usage is discouraged.) $)
    cm2mi $p |- A C_H ( B i^i C ) $=
      ( cin ccm wbr cort cfv chj co choccli cmcm2ii cm2ji chdmm1i breqtrri
      chincli cmcm2i mpbir ) ABCIZJKAUDLMZJKABLMZCLMZNOUEJAUFUGDBEPCFPABDEGQACD
      FHQRBCEFSTAUDDBCEFUAUBUC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Quantum Logic Explorer axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    qlax1.1 $e |- A e. CH $.
    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-1" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlax1i $p |- A = ( _|_ ` ( _|_ ` A ) ) $=
      ( cort cfv ococi eqcomi ) ACDCDAABEF $.
  $}

  ${
    qlax.1 $e |- A e. CH $.
    qlax.2 $e |- B e. CH $.
    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-2" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlax2i $p |- ( A vH B ) = ( B vH A ) $=
      ( chjcomi ) ABCDE $.

    ${
      qlax.3 $e |- C e. CH $.
      $( One of the equations showing ` CH ` is an ortholattice.  (This
         corresponds to axiom "ax-3" in the Quantum Logic Explorer.)
         (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
      qlax3i $p |- ( ( A vH B ) vH C ) = ( A vH ( B vH C ) ) $=
        ( chjassi ) ABCDEFG $.
    $}

    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-4" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlax4i $p |- ( A vH ( B vH ( _|_ ` B ) ) ) = ( B vH ( _|_ ` B ) ) $=
      ( chil chj co cort cfv chj1i chjoi oveq2i 3eqtr4i ) AEFGEABBHIFGZFGNACJNE
      AFBDKZLOM $.

    $( One of the equations showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-5" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlax5i $p |- ( A vH ( _|_ ` ( ( _|_ ` A ) vH B ) ) ) = A $=
      ( cort cfv chj co cin chdmj2i oveq2i choccli chabs1i eqtri ) AAEFBGHEFZGH
      AABEFZIZGHAOQAGABCDJKAPCBDLMN $.
  $}

  ${
    qlaxr1.1 $e |- A e. CH $.
    qlaxr1.2 $e |- B e. CH $.
    qlaxr1.3 $e |- A = B $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r1" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlaxr1i $p |- B = A $=
      ( eqcomi ) ABEF $.
  $}

  ${
    qlaxr2.1 $e |- A e. CH $.
    qlaxr2.2 $e |- B e. CH $.
    qlaxr2.3 $e |- C e. CH $.
    qlaxr2.4 $e |- A = B $.
    qlaxr2.5 $e |- B = C $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r2" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlaxr2i $p |- A = C $=
      ( eqtri ) ABCGHI $.
  $}

  ${
    qlaxr4.1 $e |- A e. CH $.
    qlaxr4.2 $e |- B e. CH $.
    qlaxr4.3 $e |- A = B $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r4" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlaxr4i $p |- ( _|_ ` A ) = ( _|_ ` B ) $=
      ( cort fveq2i ) ABFEG $.
  $}

  ${
    qlaxr5.1 $e |- A e. CH $.
    qlaxr5.2 $e |- B e. CH $.
    qlaxr5.3 $e |- C e. CH $.
    qlaxr5.4 $e |- A = B $.
    $( One of the conditions showing ` CH ` is an ortholattice.  (This
       corresponds to axiom "ax-r5" in the Quantum Logic Explorer.)
       (Contributed by NM, 4-Aug-2004.)  (New usage is discouraged.) $)
    qlaxr5i $p |- ( A vH C ) = ( B vH C ) $=
      ( chj oveq1i ) ABCHGI $.
  $}

  ${
    qlaxr3.1 $e |- A e. CH $.
    qlaxr3.2 $e |- B e. CH $.
    qlaxr3.3 $e |- C e. CH $.
    qlaxr3.4 $e |- ( C vH ( _|_ ` C ) ) =
        ( ( _|_ ` ( ( _|_ ` A ) vH ( _|_ ` B ) ) ) vH ( _|_ ` ( A vH B ) ) ) $.
    $( A variation of the orthomodular law, showing ` CH ` is an orthomodular
       lattice.  (This corresponds to axiom "ax-r3" in the Quantum Logic
       Explorer.)  (Contributed by NM, 7-Aug-2004.)
       (New usage is discouraged.) $)
    qlaxr3i $p |- A = B $=
      ( chj chjcli cort cfv cin c0h wceq choccli cmcmii cmcm2ii eqtr3i chincli
      co chshii chub1i incom cmj1i cmj2i fh1i chil chjoi chdmm1i 3eqtr4i h0elch
      wa choc0 chcon3i mpbir chj00i simpli omlsii chub2i simpri eqtr4i ) AABHTZ
      BAVBDVBABDEIZUAZABDEUBVBAJKZLZMNZVBBJKZLZMNZVGVJULVFVIHTZMNVEVHHTZVBLZVKM
      VBVLLVMVKVBVLUCVBVEVHVCADOZBEOZVBAVCDAVBDVCABDEUDPQVBBVCEBVBEVCABDEUEPQUF
      RVMMNMJKZVMJKZNUGVLJKVBJKHTZVPVQCCJKHTUGVRCFUHGRUMVLVBVEVHVNVOIZVCUIUJVMM
      VLVBVSVCSUKUNUORVFVIVBVEVCVNSVBVHVCVOSUPUOZUQURBVBEVDBAEDUSVGVJVTUTURVA
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Orthogonal subspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f j n u x y z A $.  $d z C $.  $d j k x y z F $.  $d f j k n x y z ph $.
    $d f n u x y z B $.  $d k x y G $.  $d j k n u x y z H $.  $d n z N $.
    chscl.1 $e |- ( ph -> A e. CH ) $.
    chscl.2 $e |- ( ph -> B e. CH ) $.
    chscl.3 $e |- ( ph -> B C_ ( _|_ ` A ) ) $.
    ${
      chscl.4 $e |- ( ph -> H : NN --> ( A +H B ) ) $.
      chscl.5 $e |- ( ph -> H ~~>v u ) $.
      chscl.6 $e |- F = ( n e. NN |-> ( ( projh ` A ) ` ( H ` n ) ) ) $.
      $( Lemma for ~ chscl .  (Contributed by Mario Carneiro, 19-May-2014.)
         (New usage is discouraged.) $)
      chscllem1 $p |- ( ph -> F : NN --> A ) $=
        ( vx cn cfv wcel co wceq cph cv cpjh wa cva cort wrex eqid wb ffvelrnda
        cch adantr csh wss chsh syl shocsh shless shscom syl2anc 3sstr4d sselda
        syl31anc syldan pjpreeq mpbii simpld fmptd ) AEOEUAZGPZCUBPPZCFAVHOQZUC
        ZVJCQZVIVJNUAUDRSNCUEPZUFZVLVJVJSZVMVOUCZVJUGVLCUJQZVICVNTRZQZVPVQUHAVR
        VKHUKAVKVICDTRZQVTAOWAVHGKUIAWAVSVIADCTRZVNCTRZWAVSADULQZVNULQZCULQZDVN
        UMWBWCUMADUJQWDIDUNUOZAWFWEAVRWFHCUNUOZCUPUOZWHJDVNCUQVBAWFWDWAWBSWHWGC
        DURUSAWFWEVSWCSWHWICVNURUSUTVAVCNVIVJCVDUSVEVFMVG $.

      $( Lemma for ~ chscl .  (Contributed by Mario Carneiro, 19-May-2014.)
         (New usage is discouraged.) $)
      chscllem2 $p |- ( ph -> F e. dom ~~>v ) $=
        ( wcel chil cn cfv co syl wceq vx vj vk ccau cv chli wbr cdm wf cmv cno
        wrex clt cuz wral crp wss chscllem1 cch fss syl2anc wa hlimcaui hcaucvg
        chss sylan wi c1 nnuz uztrn2 adantll cle c2 cexp caddc cc0 cph csh chsh
        cr shscl adantr ffvelrnda sseldd adantrr simprr ffvelrnd hvsubcl normcl
        shss sqge0d resqcld addge01d cva csp shsubcl syl3anc hvsubsub4 syl22anc
        mpbid cort ocsh cpjh fveq2 fveq2d fvex eqcomd adantl wb shless syl31anc
        fvmpt shscom 3sstr4d pjpreeq simprd sselda hvsubadd eqcom mpbird risset
        3bitr4g rexbidva sylibr anbi2d oveq12d imbi12d adantrl eqeltrd shocorth
        eleq1 eleq1d chvarv mp2and normpyth mpd hvpncan3 oveq1d normge0 adantlr
        eqtr3d breqtrd le2sqd ad2antlr lelttr anassrs syldan ralimdva ralrimiva
        rpre mpand reximdva hcau sylanbrc ax-hcompl wfn ffn fnbr mpan rexlimivw
        hlimf ax-mp 3syl ) AFUDNZFUAUEZUFUGZUAOULFUFUHZNZAPOFUIZUBUEZFQZUCUEZFQ
        ZUJRZUKQZUVEUMUGZUCUVJUNQZUOZUBPULZUAUPUOUVDAPCFUIZCOUQZUVIABCDEFGHIJKL
        MURZACUSNZUWAHCVESZPCOFUTVAAUVSUAUPAUVEUPNZVBZUVJGQZUVLGQZUJRZUKQZUVEUM
        UGZUCUVQUOZUBPULZUVSAGUDNZUWEUWMAGBUEZUFUGUWNLUWOGVCSUBUCUVEGVDVFUWFUWL
        UVRUBPUWFUVJPNZVBZUWKUVPUCUVQUWQUVLUVQNZUVLPNZUWKUVPVGZUWPUWRUWSUWFVHUV
        LUVJPVIVJVKUWFUWPUWSUWTUWFUWPUWSVBZVBZUVOUWJVLUGZUWKUVPAUXAUXCUWEAUXAVB
        ZUXCUVOVMVNRZUWJVMVNRZVLUGUXDUXEUXEUWIUVNUJRZUKQZVMVNRZVORZUXFVLUXDVPUX
        IVLUGUXEUXJVLUGUXDUXHUXDUXGONZUXHVTNUXDUWIONZUVNONZUXKUXDUWGONZUWHONZUX
        LAUWPUXNUWSAUWPVBZCDVQRZOUWGAUXQOUQZUWPAUXQVRNZUXRACVRNZDVRNZUXSAUWCUXT
        HCVSSZADUSNUYAIDVSSZCDWAVAUXQWJSZWBAPUXQUVJGKWCZWDZWEZUXDPOUVLGAPOGUIZU
        XAAPUXQGUIUXRUYHKUYDPUXQOGUTVAWBAUWPUWSWFZWGZUWGUWHWHVAZUXDUVKONZUVMONZ
        UXMAUWPUYLUWSUXPCOUVKAUWAUWPUWDWBAPCUVJFUWBWCZWDZWEZUXDCOUVMAUWAUXAUWDW
        BZUXDPCUVLFAUVTUXAUWBWBUYIWGZWDZUVKUVMWHVAZUWIUVNWHVAZUXGWISZWKUXDUXEUX
        IUXDUVOUXDUXMUVOVTNZUYTUVNWISZWLUXDUXHVUBWLWMWTUXDUVNUXGWNRZUKQZVMVNRZU
        XJUXFUXDUVNUXGWORVPTZVUGUXJTZUXDUVNCNZUXGCXAQZNZVUHUXDUXTUVKCNZUVMCNVUJ
        AUXTUXAUYBWBZAUWPVUMUWSUYNWEUYRUVKUVMCWPWQUXDUXGUWGUVKUJRZUWHUVMUJRZUJR
        ZVUKUXDUXNUXOUYLUYMUXGVUQTUYGUYJUYPUYSUWGUWHUVKUVMWRWSUXDVUKVRNZVUOVUKN
        ZVUPVUKNZVUQVUKNUXDUWAVURUYQCXBZSAUWPVUSUWSUXPUVEVUOTZUAVUKULZVUSUXPVVC
        UWGUVKUVEWNRZTZUAVUKULZUXPVUMVVFUXPUWGCXCQZQZUVKTZVUMVVFVBZUWPVVIAUWPUV
        KVVHEUVJEUEZGQZVVGQVVHPFVVKUVJTVVLUWGVVGVVKUVJGXDXEMUWGVVGXFXLXGXHUXPUW
        CUWGCVUKVQRZNVVIVVJXIAUWCUWPHWBUXPUXQVVMUWGAUXQVVMUQUWPADCVQRZVUKCVQRZU
        XQVVMAUYAVURUXTDVUKUQVVNVVOUQUYCAUWAVURUWDVVASZUYBJDVUKCXJXKAUXTUYAUXQV
        VNTUYBUYCCDXMVAAUXTVURVVMVVOTUYBVVPCVUKXMVAXNWBUYEWDUAUWGUVKCXOVAWTXPUX
        PVVBVVEUAVUKUXPUVEVUKNZVBZVUOUVETZVVDUWGTZVVBVVEVVRUXNUYLUVEONVVSVVTXIU
        XPUXNVVQUYFWBUXPUYLVVQUYOWBUXPVUKOUVEAVUKOUQZUWPAVURVWAVVPVUKWJSWBXQUWG
        UVKUVEXRWQUVEVUOXSUWGVVDXSYBYCXTUAVUOVUKYAYDZWEAUWSVUTUWPUXPVUSVGAUWSVB
        ZVUTVGUBUCUVJUVLTZUXPVWCVUSVUTVWDUWPUWSAUVJUVLPYKYEVWDVUOVUPVUKVWDUWGUW
        HUVKUVMUJUVJUVLGXDUVJUVLFXDYFYLYGVWBYMYHVUOVUPVUKWPWQYIUXDUXTVUJVULVBVU
        HVGVUNUVNUXGCYJSYNUXDUXMUXKVUHVUIVGUYTVUAUVNUXGYOVAYPUXDVUFUWJVMVNUXDVU
        EUWIUKUXDUXMUXLVUEUWITUYTUYKUVNUWIYQVAXEYRUUAUUBUXDUVOUWJVUDUXDUXLUWJVT
        NZUYKUWIWISZUXDUXMVPUVOVLUGUYTUVNYSSUXDUXLVPUWJVLUGUYKUWIYSSUUCXTYTUXBV
        UCVWEUVEVTNZUXCUWKVBUVPVGAUXAVUCUWEVUDYTAUXAVWEUWEVWFYTUWEVWGAUXAUVEUUJ
        UUDUVOUWJUVEUUEWQUUKUUFUUGUUHUULYPUUIUAUBUCFUUMUUNUAFUUOUVFUVHUAOUFUVGU
        UPZUVFUVHUVGOUFUIVWHUVAUVGOUFUUQUVBUVGFUVEUFUURUUSUUTUVC $.

      ${
        chscllem3.7 $e |- ( ph -> N e. NN ) $.
        chscllem3.8 $e |- ( ph -> C e. A ) $.
        chscllem3.9 $e |- ( ph -> D e. B ) $.
        chscllem3.10 $e |- ( ph -> ( H ` N ) = ( C +h D ) ) $.
        $( Lemma for ~ chscl .  (Contributed by Mario Carneiro, 19-May-2014.)
           (New usage is discouraged.) $)
        chscllem3 $p |- ( ph -> C = ( F ` N ) ) $=
          ( vz cfv cv co wceq cort wcel wrex cpjh wa cn fveq2 fveq2d fvex fvmpt
          cva syl eqcomd cch cph wb csh wss chsh shocsh shless syl31anc syl2anc
          shscom 3sstr4d ffvelrnd sseldd pjpreeq mpbid simprd cin c0h chscllem1
          adantr ocin simprl simprr eqtr3d shuni simpld rexlimddv ) AJIUBZJHUBZ
          UAUCZUPUDZUEZEWHUEZUACUFUBZAWHCUGZWKUAWMUHZAWGCUIUBZUBZWHUEZWNWOUJZAW
          HWQAJUKUGWHWQUEQGJGUCZIUBZWPUBWQUKHWTJUEXAWGWPWTJIULUMPWGWPUNUOUQURAC
          USUGZWGCWMUTUDZUGWRWSVAKACDUTUDZXCWGADCUTUDZWMCUTUDZXDXCADVBUGZWMVBUG
          ZCVBUGZDWMVCZXEXFVCADUSUGXGLDVDUQZAXIXHAXBXIKCVDUQZCVEUQZXLMDWMCVFVGA
          XIXGXDXEUEXLXKCDVIVHAXIXHXCXFUEXLXMCWMVIVHVJAUKXDJINQVKVLUAWGWHCVMVHV
          NVOAWIWMUGZWKUJZUJZWLFWIUEXPEFWHWICWMAXIXOXLVSAXHXOXMVSACWMVPVQUEZXOA
          XIXQXLCVTUQVSAECUGXORVSXPDWMFAXJXOMVSAFDUGXOSVSVLAWNXOAUKCJHABCDGHIKL
          MNOPVRQVKVSAXNWKWAXPWGEFUPUDZWJAWGXRUEXOTVSAXNWKWBWCWDWEWF $.
      $}

      chscl.7 $e |- G = ( n e. NN |-> ( ( projh ` B ) ` ( H ` n ) ) ) $.
      $( Lemma for ~ chscl .  (Contributed by Mario Carneiro, 19-May-2014.)
         (New usage is discouraged.) $)
      chscllem4 $p |- ( ph -> u e. ( A +H B ) ) $=
        ( chli chil cn wcel syl vk vx vy cv cfv cva co cph wfun wbr wceq cdm wf
        hlimf ffun ax-mp funbrfv mpsyl cmpt feqmptd wrex ffvelrnda csh cch chsh
        wa wb shsel syl2anc biimpa syldan w3a simp3 simp1l simp1r simp2l simp2r
        cort wss chscllem3 chsscon2 mpbid shscom feq3 shss sseldd eqtrd oveq12d
        ax-hvcom rexlimdvv mpd mpteq2dva chscllem1 fss chscllem2 funfvbrb sylib
        3exp eqid hlimadd eqbrtrd eqtr3d chlimi syl3anc wi shsva mp2and eqeltrd
        fvex ) ABUDZFPUEZGPUEZUFUGZCDUHUGZAHPUEZXJXMPUIZAHXJPUJZXOXJUKPULZQPUMX
        PUNXRQPUOUPZMHXJPUQURXPAHXMPUJXOXMUKXSAHUARUAUDZFUEZXTGUEZUFUGZUSZXMPAH
        UARXTHUEZUSYDAUARXNHLUTAUARYEYCAXTRSZVFZYEUBUDZUCUDZUFUGZUKZUCDVAUBCVAZ
        YEYCUKZAYFYEXNSZYLARXNXTHLVBAYNYLACVCSZDVCSZYNYLVGACVDSZYOICVETZADVDSZY
        PJDVETZUBUCCDYEVHVIVJVKYGYKYMUBUCCDYGYHCSZYIDSZVFZYKYMYGUUCYKVLZYEYJYCY
        GUUCYKVMZUUDYHYAYIYBUFUUDBCDYHYIEFHXTUUDAYQAYFUUCYKVNZITZUUDAYSUUFJTZUU
        DADCVRUEVSZUUFKTUUDARXNHUMZUUFLTUUDAXQUUFMTZNAYFUUCYKVOZYGUUAUUBYKVPZYG
        UUAUUBYKVQZUUEVTUUDBDCYIYHEGHXTUUHUUGUUDACDVRUEVSZUUFAUUIUUOKAYSYQUUIUU
        OVGJIDCWAVIWBZTUUDARDCUHUGZHUMZUUFAUUJUURLAXNUUQUKZUUJUURVGAYOYPUUSYRYT
        CDWCVIXNUUQRHWDTWBZTUUKOUULUUNUUMUUDYEYJYIYHUFUGZUUEUUDYHQSYIQSYJUVAUKU
        UDCQYHUUDACQVSZUUFAYOUVBYRCWETZTUUMWFUUDDQYIUUDADQVSZUUFAYPUVDYTDWETZTU
        UNWFYHYIWIVIWGVTWHWGWRWJWKWLWGAXKXLUAFGYDARCFUMZUVBRQFUMABCDEFHIJKLMNWM
        ZUVCRCQFWNVIARDGUMZUVDRQGUMABDCEGHJIUUPUUTMOWMZUVERDQGWNVIAFXRSZFXKPUJZ
        ABCDEFHIJKLMNWOXPUVJUVKVGXSFPWPUPWQZAGXRSZGXLPUJZABDCEGHJIUUPUUTMOWOXPU
        VMUVNVGXSGPWPUPWQZYDWSWTXAHXMPUQURXBAXKCSZXLDSZXMXNSZAYQUVFUVKUVPIUVGUV
        LXKFCFPXIXCXDAYSUVHUVNUVQJUVIUVOXLGDGPXIXCXDAYOYPUVPUVQVFUVRXEYRYTCDXKX
        LXFVIXGXH $.
    $}

    $( The subspace sum of two closed orthogonal spaces is closed.
       (Contributed by NM, 19-Oct-1999.)  (Proof shortened by Mario Carneiro,
       19-May-2014.)  (New usage is discouraged.) $)
    chscl $p |- ( ph -> ( A +H B ) e. CH ) $=
      ( vf vz vx csh wcel cn cv wa wal cch chsh syl cfv adantr cph co wf wbr wi
      chli shscl syl2anc cpjh cmpt cort wss simprl simprr chscllem4 ex alrimivv
      eqid isch2 sylanbrc ) ABCUAUBZJKZLVAGMZUCZVCHMZUFUDZNZVEVAKZUEZHOGOVAPKAB
      JKZCJKZVBABPKZVJDBQRACPKZVKECQRBCUGUHAVIGHAVGVHAVGNHBCIILIMVCSZBUISSUJZIL
      VNCUISSUJZVCAVLVGDTAVMVGETACBUKSULVGFTAVDVFUMAVDVFUNVOURVPURUOUPUQHGVAUSU
      T $.
  $}

  ${
    osum.1 $e |- A e. CH $.
    osum.2 $e |- B e. CH $.
    $( If two closed subspaces of a Hilbert space are orthogonal, their
       subspace sum equals their subspace join.  Lemma 3 of [Kalmbach] p. 67.
       Note that the (countable) Axiom of Choice is used for this proof via
       ~ pjhth , although "the hard part" of this proof, ~ chscl , requires no
       choice.  (Contributed by NM, 28-Oct-1999.)  (Revised by Mario Carneiro,
       19-May-2014.)  (New usage is discouraged.) $)
    osumi $p |- ( A C_ ( _|_ ` B ) -> ( A +H B ) = ( A vH B ) ) $=
      ( cort cfv wss cph co cch wcel chj wceq a1i chsscon2i biimpi chscl chshii
      shjshseli sylib ) ABEFGZABHIZJKUBABLIMUAABAJKUACNBJKUADNUABAEFGABCDOPQABA
      CRBDRST $.

    $( Corollary of ~ osumi .  (Contributed by NM, 5-Nov-2000.)
       (New usage is discouraged.) $)
    osumcori $p |- ( ( A i^i B ) +H ( A i^i ( _|_ ` B ) ) ) =
                  ( ( A i^i B ) vH ( A i^i ( _|_ ` B ) ) ) $=
      ( cin cort cfv wss cph co chj inss2 choccli chub2i sstri chdmm3i sseqtr4i
      wceq chincli osumi ax-mp ) ABEZABFGZEZFGZHUBUDIJUBUDKJRUBAFGZBKJZUEUBBUGA
      BLBUFDACMNOABCDPQUBUDABCDSAUCCBDMSTUA $.

    $( Corollary of ~ osumi , showing it holds under the weaker hypothesis that
       ` A ` and ` B ` commute.  (Contributed by NM, 6-Dec-2000.)
       (New usage is discouraged.) $)
    osumcor2i $p |- ( A C_H B ->
                   ( A +H B ) = ( A vH B ) ) $=
      ( ccm wbr cph co chj wss wceq cort cfv cin choccli chjcli chincli chjcomi
      eqtri chshii cmcm2i cmbr4i bitri osumi ineq2i oveq1i pjoml4i eqeq2i inss1
      wa shlessi ax-mp sseq1 mpbii sylbi syl chsleji jctil eqss sylibr ) ABEFZA
      BGHZABIHZJZVCVBJZUJVBVCKVAVEVDVAAALMZBLMZIHZNZVGJZVEVAAVGEFVJABCDUAAVGCBD
      OZUBUCVJVIBGHZVIBIHZKZVEVIBAVHCVFVGACOZVKPQZDUDVNVLVCKZVEVMVCVLVMBAVGVFIH
      ZNZIHZVCVMVSBIHVTVIVSBIVHVRAVFVGVOVKRUEUFVSBAVRCVGVFVKVOPQDRSVTBAIHVCBADC
      UGBADCRSSUHVQVLVBJZVEVIAJWAAVHUIVIABVIVPTACTBDTUKULVLVCVBUMUNUOUPUOABCDUQ
      URVBVCUSUT $.
  $}

  $( If two closed subspaces of a Hilbert space are orthogonal, their subspace
     sum equals their subspace join.  Lemma 3 of [Kalmbach] p. 67.
     (Contributed by NM, 31-Oct-2005.)  (New usage is discouraged.) $)
  osum $p |- ( ( A e. CH /\ B e. CH /\ A C_ ( _|_ ` B ) ) ->
             ( A +H B ) = ( A vH B ) ) $=
    ( cch wcel cort cfv wss cph co chj wceq wi chil oveq1 eqeq12d imbi12d oveq2
    cif helch elimel sseq1 fveq2 sseq2d osumi dedth2h 3impia ) ACDZBCDZABEFZGZA
    BHIZABJIZKZUGUHUJUMLUGAMRZUIGZUNBHIZUNBJIZKZLUNUHBMRZEFZGZUNUSHIZUNUSJIZKZL
    ABMMAUNKZUJUOUMURAUNUIUAVEUKUPULUQAUNBHNAUNBJNOPBUSKZUOVAURVDVFUIUTUNBUSEUB
    UCVFUPVBUQVCBUSUNHQBUSUNJQOPUNUSAMCSTBMCSTUDUEUF $.

  ${
    spansnj.1 $e |- A e. CH $.
    spansnj.2 $e |- B e. ~H $.
    $( The subspace sum of a closed subspace and a one-dimensional subspace
       equals their join.  (Proof suggested by Eric Schechter 1-Jun-2004.)
       (Contributed by NM, 1-Jun-2004.)  (New usage is discouraged.) $)
    spansnji $p |- ( A +H ( span ` { B } ) ) = ( A vH ( span ` { B } ) ) $=
      ( csn cspn cfv chj co cph cort chshii spansnchi cun chil wcel snssi ax-mp
      wss spanuni shjshsi cpjh cch chssii choccli pjhclii wceq spanid spansnpji
      csh oveq1i osumi 3eqtrri spanunsni eqtr4i chjcli eqeltri ococi eqtr2i ) A
      BEZFGZHIAVAJIZKGKGVBAVAACLZVABDMLUAVBVBABAKGZUBGGZEZFGZHIZUCVHAUTNFGZAFGZ
      VAJIVBVHAVFNFGZVIVKVJVGJIAVGJIZVHAVFACUDZVEOPVFOSBVDACUEDUFZVEOQRTVJAVGJA
      UJPVJAUGVCAUHRZUKAVGKGSVLVHUGABVMDUIAVGCVEVNMZULRUMABCDUNUOAUTVMBOPUTOSDB
      OQRTVJAVAJVOUKUMAVGCVPUPUQURUS $.
  $}

  $( The subspace sum of a closed subspace and a one-dimensional subspace
     equals their join.  (Contributed by NM, 4-Jun-2004.)
     (New usage is discouraged.) $)
  spansnj $p |- ( ( A e. CH /\ B e. ~H ) ->
              ( A +H ( span ` { B } ) ) = ( A vH ( span ` { B } ) ) ) $=
    ( cch wcel chil csn cspn cfv cph chj wceq cif c0v oveq1 eqeq12d sneq fveq2d
    co oveq2d elimel helch ax-hv0cl spansnji dedth2h ) ACDZBEDZABFZGHZIRZAUHJRZ
    KUEAELZUHIRZUKUHJRZKUKUFBMLZFZGHZIRZUKUPJRZKABEMAUKKUIULUJUMAUKUHINAUKUHJNO
    BUNKZULUQUMURUSUHUPUKIUSUGUOGBUNPQZSUSUHUPUKJUTSOUKUNAECUATBMEUBTUCUD $.

  $( The subspace sum of a closed subspace and a one-dimensional subspace is
     closed.  (Contributed by NM, 17-Dec-2004.)  (New usage is discouraged.) $)
  spansnscl $p |- ( ( A e. CH /\ B e. ~H ) ->
              ( A +H ( span ` { B } ) ) e. CH ) $=
    ( cch wcel chil wa csn cfv cph co chj spansnj spansnch chjcl sylan2 eqeltrd
    cspn ) ACDZBEDZFABGQHZIJATKJZCABLSRTCDUACDBMATNOP $.

  $( The sum of two vectors belong to the span of one of them iff the other
     vector also belongs.  (Contributed by NM, 1-Nov-2005.)
     (New usage is discouraged.) $)
  sumspansn $p |- ( ( A e. ~H /\ B e. ~H ) ->
           ( ( A +h B ) e. ( span ` { A } ) <-> B e. ( span ` { A } ) ) ) $=
    ( chil wcel wa cva co csn cspn cfv cmv wi csh spansnsh adantr simpr shsubcl
    spansnid syl3anc ex hvpncan2 eleq1d sylibd shaddcl 3expia syl2anc impbid )
    ACDZBCDZEZABFGZAHIJZDZBULDZUJUMUKAKGZULDZUNUHUMUPLUIUHUMUPUHUMEULMDZUMAULDZ
    UPUHUQUMANZOUHUMPUHURUMARZOUKAULQSTOUJUOBULABUAUBUCUHUNUMLZUIUHUQURVAUSUTUQ
    URUNUMABULUDUEUFOUG $.

  ${
    $d x A $.  $d x B $.
    spansnm0.1 $e |- A e. ~H $.
    spansnm0.2 $e |- B e. ~H $.
    $( The meet of different one-dimensional subspaces is the zero subspace.
       (Contributed by NM, 1-Nov-2005.)  (New usage is discouraged.) $)
    spansnm0i $p |- ( -. A e. ( span ` { B } ) ->
                   ( ( span ` { A } ) i^i ( span ` { B } ) ) = 0H ) $=
      ( vx csn cspn cfv wcel wn cin c0h wss wceq cv wa c0v chil csh spansnchi
      wi chshii elspansn5 ax-mp mpanl1 ex elin elch0 3imtr4g ssrdv chle0i sylib
      chincli ) ABFGHZIJZAFGHZUNKZLMUQLNUOEUQLUOEOZUPIURUNIPZURQNZURUQIURLIUOUS
      UTARIZUOUSUTCUNSIVAUOPUSPUTUAUNBDTZUBUNAURUCUDUEUFURUPUNUGURUHUIUJUQUPUNA
      CTVBUMUKUL $.
  $}

  ${
    nonbool.1 $e |- A e. ~H $.
    nonbool.2 $e |- B e. ~H $.
    nonbool.3 $e |- F = ( span ` { A } ) $.
    nonbool.4 $e |- G = ( span ` { B } ) $.
    nonbool.5 $e |- H = ( span ` { ( A +h B ) } ) $.
    $( A Hilbert lattice with two or more dimensions fails the distributive law
       and therefore cannot be a Boolean algebra.  This counterexample
       demonstrates a condition where ` ( ( H i^i F ) vH ( H i^i G ) ) = 0H `
       but ` ( H i^i ( F vH G ) ) =/= 0H ` .  The antecedent specifies that the
       vectors ` A ` and ` B ` are nonzero and non-colinear.  The last three
       hypotheses assign one-dimensional subspaces to ` F ` , ` G ` , and
       ` H ` .  (Contributed by NM, 1-Nov-2005.)
       (New usage is discouraged.) $)
    nonbooli $p |- ( -. ( A e. G \/ B e. F ) ->
                  ( H i^i ( F vH G ) ) =/= ( ( H i^i F ) vH ( H i^i G ) ) ) $=
      ( wcel wn chj co cin wceq c0h csn cspn ax-mp wa wne cva cfv chil hvaddcli
      wo c0v spansnid eleqtrri cph spansnchi chshii eqeltri shsvai mp2an sselii
      csh shsleji elin mpbir2an eleq2 mpbii elch0 sylib cch ch0 syl6eqel eleq2i
      wb sumspansn bitr4i sylibr con3i adantl ineq12i spansnm0i sylnbi 3bitr4ri
      syl5eq hvcomi eleq1i oveqan12rd h0elch chj0i syl6eq eqeq2 notbid biimparc
      syl2anc ioran df-ne 3imtr4i ) ADKZLZBCKZLZUAZECDMNZOZECOZEDOZMNZPZLZWNWPU
      GLWTXCUBWRWTQPZLZXCQPZXEWQXGWOXFWPXFABUCNZARSUDZKZWPXFXIUHXJXFXIQKZXIUHPX
      FXIWTKZXLXMXIEKXIWSKXIXIRSUDZEXIUEKXIXNKABFGUFZXIUITJUJCDUKNZWSXICDCXJURH
      XJAFULZUMUNZDBRSUDZURIXSBGULUMUNZUSACKBDKXIXPKAXJCAUEKZAXJKFAUITHUJBXSDBU
      EKZBXSKGBUITIUJCDABXRXTUOUPUQXIEWSUTVAWTQXIVBVCXIVDVEXJVFKUHXJKXQXJVGTVHW
      PBXJKZXKCXJBHVIYAYBXKYCVJFGABVKUPVLZVMVNVOWRXCQQMNQWQWOXAQXBQMWQXAXNXJOZQ
      EXNCXJJHVPWPXKYEQPYDXIAXOFVQVRVTWOXBXNXSOZQEXNDXSJIVPWNXIXSKZYFQPBAUCNZXS
      KZAXSKZYGWNYBYAYIYJVJGFBAVKUPXIYHXSABFGWAWBDXSAIVIVSXIBXOGVQVRVTWCQWDWEWF
      XHXEXGXHXDXFXCQWTWGWHWIWJWNWPWKWTXCWLWM $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    spansncv.1 $e |- A e. CH $.
    spansncv.2 $e |- B e. CH $.
    spansncv.3 $e |- C e. ~H $.
    $( Hilbert space has the covering property (using spans of singletons to
       represent atoms).  Exercise 5 of [Kalmbach] p. 153.  (Contributed by NM,
       7-Jun-2004.)  (New usage is discouraged.) $)
    spansncvi $p |- ( ( A C. B /\ B C_ ( A vH ( span ` { C } ) ) ) ->
                   B = ( A vH ( span ` { C } ) ) ) $=
      ( vx vy vz co wss wa wi cv wcel cva wceq chil imp c0v wpss csn cspn simpr
      cfv chj pssss adantr wn wex pssnel ssel2 wrex cph eleq2i spansnchi chseli
      spansnji bitr3i cmv eleq1 biimpac sselda csh chshii shsubcl mp3an1 syl2an
      exp43 com14 imp45 cheli hvpncan2 eleq1d anandis exp45 imp41 adantrr oveq2
      syl5ib wne ax-hvaddid syl eqeq2d eleq1a sylbid impancom necon3bd spansnss
      sylan9eqr mpan spansneleq sseq1d ancoms exp44 com12 adantrl mpd rexlimivv
      sylan2 sylbi anandirs expimpd exlimdv syl5 pm2.43d impcom chlubii syl2anc
      ex eqssd ) ABUAZBACUBUCUEZUFJZKZLZBXNXLXOUDXPABKZXMBKZXNBKXLXQXOABUGZUHXO
      XLXRXOXLXRXOXLXLXRMXLGNZBOZXTAOZUIZLZGUJXOXLLZXRGABUKYEYDXRGYEYAYCXRXOXLY
      AYCXRMZXOYALZXLYALZYFYGXTXNOZYHYFMZBXNXTULYIXTHNZINZPJZQZIXMUMHAUMZYJYIXT
      AXMUNJZOYOYPXNXTACDFURUOHIAXMXTDCFUPZUQUSYNYJHIAXMYKAOZYLXMOZLZYNYHYCXRYT
      YNLZYHYCLLYLBOZXRUUAYHUUBYCYRYSYNYHUUBYRYSYNYHUUBYRYSYNYHLZUUBYTYRUUCLZUU
      BUUDYMYKUTJZBOZYTUUBYRYNXLYAUUFYAYNXLYRUUFYAYNXLYRUUFYAYNLYMBOZYKBOZUUFXL
      YRLYNYAUUGXTYMBVAVBXLABYKXSVCBVDOZUUGUUHUUFBEVEZYMYKBVFVGVHVIVJVKYTUUEYLB
      YRYKROZYLROUUEYLQYSYKADVLZYLXMYQVLYKYLVMVHVNVTSVOVPVQVRUUAYCUUBXRMZYHYRYS
      YNYCUUMYSYRYNYCUUMMMYSYRYNYCUUMYRYNLZYCLYSYLTWAZUUMUUNYCUUOUUNYBYLTYRYLTQ
      ZYNYBYRUUPLZYNXTYKQZYBUUQYMYKXTUUPYRYMYKTPJZYKYLTYKPVSYRUUKUUSYKQUULYKWBW
      CWJWDYRUURYBMUUPYKAXTWEUHWFWGWHSUUOYSUUMUUBYLUBUCUEZBKZUUOYSLZXRUUIUUBUVA
      UUJBYLWIWKUVBUUTXMBUUOYSUUTXMQZCROUUOYSUVCMFYLCWLWKSWMVTWNWTWOWPVQWQWRVIW
      SXAWCSXBXCXDXEXJXFXGAXMBDYQEXHXIXK $.
  $}

  $( Hilbert space has the covering property (using spans of singletons to
     represent atoms).  Exercise 5 of [Kalmbach] p. 153.  (Contributed by NM,
     9-Jun-2004.)  (New usage is discouraged.) $)
  spansncv $p |- ( ( A e. CH /\ B e. CH /\ C e. ~H ) ->
                  ( ( A C. B /\ B C_ ( A vH ( span ` { C } ) ) )
                 -> B = ( A vH ( span ` { C } ) ) ) ) $=
    ( cch wcel chil wpss csn cspn cfv chj co wss wa wceq cif c0v imbi12d elimel
    wi psseq1 oveq1 sseq2d anbi12d eqeq2d psseq2 sseq1 eqeq1 sneq fveq2d oveq2d
    anbi2d helch ax-hv0cl spansncvi dedth3h ) ADEZBDEZCFEZABGZBACHZIJZKLZMZNZBV
    COZTUQAFPZBGZBVGVBKLZMZNZBVIOZTVGURBFPZGZVMVIMZNZVMVIOZTVNVMVGUSCQPZHZIJZKL
    ZMZNZVMWAOZTABCFFQAVGOZVEVKVFVLWEUTVHVDVJAVGBUAWEVCVIBAVGVBKUBZUCUDWEVCVIBW
    FUERBVMOZVKVPVLVQWGVHVNVJVOBVMVGUFBVMVIUGUDBVMVIUHRCVROZVPWCVQWDWHVOWBVNWHV
    IWAVMWHVBVTVGKWHVAVSICVRUIUJUKZUCULWHVIWAVMWIUERVGVMVRAFDUMSBFDUMSCQFUNSUOU
    P $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Orthoarguesian laws 5OA and 3OA
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    5oalem1.1 $e |- A e. SH $.
    5oalem1.2 $e |- B e. SH $.
    5oalem1.3 $e |- C e. SH $.
    5oalem1.4 $e |- R e. SH $.
    $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 1-Apr-2000.)
       (New usage is discouraged.) $)
    5oalem1 $p |- ( ( ( ( x e. A /\ y e. B ) /\ v = ( x +h y ) ) /\
                  ( z e. C /\ ( x -h z ) e. R ) ) ->
                  v e. ( B +H ( A i^i ( C +H R ) ) ) ) $=
      ( cv wcel wa cva co wceq cmv cph cin simplll chil sheli adantr hvaddsub12
      ad2antrr 3anidm23 oveq2d ax-hvaddid sylan9eqr eqtr3d syl2an shsvai adantl
      c0v hvsubid eqeltrrd elin sylanbrc simpllr shscli shincli shscomi syl2anc
      syl6eleq wb eleq1 ad2antlr mpbird ) AMZENZBMZFNZOZDMZVKVMPQZRZOZCMZGNZVKV
      TSQZHNZOZOZVPFEGHTQZUAZTQZNZVQWHNZWEVKWGNZVNWJWEVLVKWFNWKVLVNVRWDUBWEVTWB
      PQZVKWFVSVKUCNZVTUCNZWLVKRWDVLWMVNVRVKEIUDUGWAWNWCVTGKUDUEWMWNOVKVTVTSQZP
      QZWLVKWMWNWPWLRVKVTVTUFUHWNWMWPVKUPPQVKWNWOUPVKPVTUQUIVKUJUKULUMWDWLWFNVS
      GHVTWBKLUNUOURVKEWFUSUTVLVNVRWDVAWKVNOVQWGFTQWHWGFVKVMEWFIGHKLVBVCZJUNWGF
      WQJVDVFVEVRWIWJVGVOWDVPVQWHVHVIVJ $.
  $}

  ${
    5oalem2.1 $e |- A e. SH $.
    5oalem2.2 $e |- B e. SH $.
    5oalem2.3 $e |- C e. SH $.
    5oalem2.4 $e |- D e. SH $.
    $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 2-Apr-2000.)
       (New usage is discouraged.) $)
    5oalem2 $p |- ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) ) /\
                  ( x +h y ) = ( z +h w ) ) ->
                  ( x -h z ) e. ( ( A +H C ) i^i ( B +H D ) ) ) $=
      ( cv wcel wa cva co wceq cmv chil shsvsi ad2ant2r adantr ancoms syl6eleqr
      cph cin shscomi ad2ant2l wb sheli anim12i adantl c0v anim2i hvsub4 syldan
      oveq1 simpr hvsubid oveq2d ad2antlr hvsubcl ax-hvaddid syl adantlr 3eqtrd
      adantrr simpl anim1i syl2anc oveq1d ad2antrl adantrl adantll eleq1d sylan
      hvaddid2 3eqtr3d mpbird elin sylanbrc ) AMZENZBMZFNZOZCMZGNZDMZHNZOZOZWCW
      EPQZWHWJPQZRZOZWCWHSQZEGUFQZNZWRFHUFQZNZWRWSXAUGNWMWTWPWDWIWTWFWKEGWCWHIK
      UAUBUCWQXBWJWESQZXANZWMXDWPWFWKXDWDWIWFWKOXCHFUFQZXAWKWFXCXENHFWJWELJUAUD
      FHJLUHUEUIUCWMWCTNZWETNZOZWHTNZWJTNZOZOZWPXBXDUJWGXHWLXKWDXFWFXGWCEIUKWEF
      JUKULWIXIWKXJWHGKUKWJHLUKULULXLWPOZWRXCXAXMWNWHWEPQZSQZWOXNSQZWRXCWPXOXPR
      XLWNWOXNSURUMXLXOWRRZWPXHXIXQXJXHXIOXOWRWEWESQZPQZWRUNPQZWRXHXIXIXGOZXOXS
      RXIXHYAXHXGXIXFXGUSUOUDWCWEWHWEUPUQXGXSXTRXFXIXGXRUNWRPWEUTVAVBXFXIXTWRRZ
      XGXFXIOWRTNYBWCWHVCWRVDVEVFVGVHUCXLXPXCRZWPXGXKYCXFXGXKOZXPWHWHSQZXCPQZUN
      XCPQZXCYDXKYAXPYFRXGXKUSXKXGYAXKXIXGXIXJVIVJUDWHWJWHWEUPVKXIYFYGRXGXJXIYE
      UNXCPWHUTVLVMXGXJYGXCRZXIXJXGYHXJXGOXCTNYHWJWEVCXCVRVEUDVNVGVOUCVSVPVQVTW
      RWSXAWAWB $.
  $}

  ${
    5oalem3.1 $e |- A e. SH $.
    5oalem3.2 $e |- B e. SH $.
    5oalem3.3 $e |- C e. SH $.
    5oalem3.4 $e |- D e. SH $.
    5oalem3.5 $e |- F e. SH $.
    5oalem3.6 $e |- G e. SH $.
    $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 2-Apr-2000.)
       (New usage is discouraged.) $)
    5oalem3 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) )
                    /\ ( f e. F /\ g e. G ) ) /\
                  ( ( x +h y ) = ( f +h g ) /\ ( z +h w ) = ( f +h g ) ) ) ->
                  ( x -h z ) e. ( ( ( A +H F ) i^i ( B +H G ) ) +H
                    ( ( C +H F ) i^i ( D +H G ) ) ) ) $=
      ( wa co cv wcel cva wceq cmv cph cin anandir 5oalem2 anim12i an4s shincli
      sylanb shscli shsvsi syl chil sheli adantr hvsubsub4 anandirs c0v hvsubid
      wb oveq2d hvsubcl hvsub0 sylan9eqr eqtrd syl2an eleq1d mpbid ) AUAZEUBZBU
      AZFUBZSZCUAZGUBZDUAZHUBZSZSZIUAZKUBZJUAZLUBZSZSZVMVOUCTWDWFUCTZUDZVRVTUCT
      WJUDZSZSZVMWDUETZVRWDUETZUETZEKUFTZFLUFTZUGZGKUFTZHLUFTZUGZUFTZUBZVMVRUET
      ZXDUBZWNWOWTUBZWPXCUBZSZXEWIVQWHSZWBWHSZSWMXJVQWBWHUHXKWKXLWLXJXKWKSXHXLW
      LSXIABIJEFKLMNQRUICDIJGHKLOPQRUIUJUKUMWTXCWOWPWRWSEKMQUNFLNRUNULXAXBGKOQU
      NHLPRUNULUOUPWIXEXGVDWMWIWQXFXDWCVMUQUBZVRUQUBZSZWDUQUBZWQXFUDWHVQXMWBXNV
      NXMVPVMEMURUSVSXNWAVRGOURUSUJWEXPWGWDKQURUSXOXPSWQXFWDWDUETZUETZXFXMXNXPW
      QXRUDVMWDVRWDUTVAXPXOXRXFVBUETZXFXPXQVBXFUEWDVCVEXOXFUQUBXSXFUDVMVRVFXFVG
      UPVHVIVJVKUSVL $.

    $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 2-Apr-2000.)
       (New usage is discouraged.) $)
    5oalem4 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) )
                    /\ ( f e. F /\ g e. G ) ) /\
                  ( ( x +h y ) = ( f +h g ) /\ ( z +h w ) = ( f +h g ) ) ) ->
                  ( x -h z ) e. ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                    ( ( ( A +H F ) i^i ( B +H G ) ) +H
                      ( ( C +H F ) i^i ( D +H G ) ) ) ) ) $=
      ( wcel co cv wa cva wceq cmv cph cin eqtr3 5oalem2 sylan2 adantlr 5oalem3
      elin sylanbrc ) AUAZESBUAZFSUBCUAZGSDUAZHSUBUBZIUAZKSJUAZLSUBZUBUOUPUCTZU
      TVAUCTZUDUQURUCTZVDUDUBZUBUOUQUETZEGUFTFHUFTUGZSZVGEKUFTFLUFTUGGKUFTHLUFT
      UGUFTZSVGVHVJUGSUSVFVIVBVFUSVCVEUDVIVCVEVDUHABCDEFGHMNOPUIUJUKABCDEFGHIJK
      LMNOPQRULVGVHVJUMUN $.
  $}

  ${
    5oalem5.1 $e |- A e. SH $.
    5oalem5.2 $e |- B e. SH $.
    5oalem5.3 $e |- C e. SH $.
    5oalem5.4 $e |- D e. SH $.
    5oalem5.5 $e |- F e. SH $.
    5oalem5.6 $e |- G e. SH $.
    5oalem5.7 $e |- R e. SH $.
    5oalem5.8 $e |- S e. SH $.
    $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 2-May-2000.)
       (New usage is discouraged.) $)
    5oalem5 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ ( z e. C /\ w e. D ) )
                    /\ ( ( f e. F /\ g e. G ) /\ ( v e. R /\ u e. S ) ) ) /\
             ( ( ( x +h y ) = ( v +h u ) /\ ( z +h w ) = ( v +h u ) ) /\
                 ( f +h g ) = ( v +h u ) ) ) ->
                  ( x -h z ) e.
                 ( ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                     ( ( ( A +H R ) i^i ( B +H S ) ) +H
                       ( ( C +H R ) i^i ( D +H S ) ) ) )
                i^i ( ( ( ( A +H F ) i^i ( B +H G ) ) i^i
                        ( ( ( A +H R ) i^i ( B +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) )
                   +H ( ( ( C +H F ) i^i ( D +H G ) ) i^i
                        ( ( ( C +H R ) i^i ( D +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) ) ) ) ) $=
      ( cv wcel wa cva wceq cmv cph cin simpr anim2i simpl 5oalem4 syl2an sheli
      co adantr anim12i hvsubsub4 anandirs c0v hvsubid oveq2d hvsubcl sylan9eqr
      chil hvsub0 syl eqtrd adantrr anandir sylib simprr jca anim1i an4s sylanb
      shscli shincli shsvsi eqeltrrd elin sylanbrc ) AUEZGUFZBUEZHUFZUGZCUEZIUF
      ZDUEZJUFZUGZUGZMUEZOUFZNUEZPUFZUGZEUEZKUFFUEZLUFUGZUGZUGZWGWIUHUSXCXDUHUS
      ZUIZWLWNUHUSXHUIZUGZWRWTUHUSXHUIZUGZUGZWGWLUJUSZGIUKUSHJUKUSULGKUKUSZHLUK
      USZULZIKUKUSZJLUKUSZULZUKUSULZUFZXOGOUKUSZHPUKUSZULZXROKUKUSZPLUKUSZULZUK
      USZULZIOUKUSZJPUKUSZULZYAYIUKUSZULZUKUSZUFXOYBYQULUFXGWQXEUGXKYCXMXFXEWQX
      BXEUMUNXKXLUOABCDGHIJEFKLQRSTUCUDUPUQXNWGWRUJUSZWLWRUJUSZUJUSZXOYQXGYTXOU
      IZXMWQXBUUAXEWQWGVIUFZWLVIUFZUGZWRVIUFZUUAXBWKUUBWPUUCWHUUBWJWGGQURUTWMUU
      CWOWLISURUTVAWSUUEXAWROUAURUTUUDUUEUGYTXOWRWRUJUSZUJUSZXOUUBUUCUUEYTUUGUI
      WGWRWLWRVBVCUUEUUDUUGXOVDUJUSZXOUUEUUFVDXOUJWRVEVFUUDXOVIUFUUHXOUIWGWLVGX
      OVJVKVHVLUQVMUTXNYRYKUFZYSYPUFZUGZYTYQUFXGWKXBUGZWPXBUGZUGZXEUGZXIXLUGZXJ
      XLUGZUGZUUKXMXGUUNXEXGWQXBUGUUNXFXBWQXBXEUOUNWKWPXBVNVOWQXBXEVPVQXMUUPUUQ
      XKXIXLXIXJUOVRXKXJXLXIXJUMVRVQUUOUULXEUGZUUMXEUGZUGUURUUKUULUUMXEVNUUSUUP
      UUTUUQUUKUUSUUPUGUUIUUTUUQUGUUJABMNGHOPEFKLQRUAUBUCUDUPCDMNIJOPEFKLSTUAUB
      UCUDUPVAVSVTUQYKYPYRYSYFYJYDYEGOQUAWAHPRUBWAWBXRYIXPXQGKQUCWAHLRUDWAWBYGY
      HOKUAUCWAPLUBUDWAWBZWAWBYNYOYLYMIOSUAWAJPTUBWAWBYAYIXSXTIKSUCWAJLTUDWAWBU
      VAWAWBWCVKWDXOYBYQWEWF $.

    $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 4-May-2000.)
       (New usage is discouraged.) $)
    5oalem6 $p |- ( ( ( ( ( x e. A /\ y e. B ) /\ h = ( x +h y ) ) /\
                        ( ( z e. C /\ w e. D ) /\ h = ( z +h w ) ) ) /\
                      ( ( ( f e. F /\ g e. G ) /\ h = ( f +h g ) ) /\
                        ( ( v e. R /\ u e. S ) /\ h = ( v +h u ) ) ) ) ->
           h e. ( B +H ( A i^i ( C +H
                 ( ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                     ( ( ( A +H R ) i^i ( B +H S ) ) +H
                       ( ( C +H R ) i^i ( D +H S ) ) ) )
                i^i ( ( ( ( A +H F ) i^i ( B +H G ) ) i^i
                        ( ( ( A +H R ) i^i ( B +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) )
                   +H ( ( ( C +H F ) i^i ( D +H G ) ) i^i
                        ( ( ( C +H R ) i^i ( D +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) ) ) ) ) ) ) ) $=
      ( cv wcel wa cva co wceq cmv cph cin an4 eqeq1 biimpcd anim12d exp3acom3r
      imp32 anim2i an4s syl2anb 5oalem5 syl shscli shincli 5oalem1 expr adantrr
      wi adantr mpd ) AUFZGUGBUFZHUGUHZOUFZVNVOUIUJZUKZUHZCUFZIUGZDUFZJUGZUHZVQ
      WAWCUIUJZUKZUHUHZMUFZPUGNUFZQUGUHZVQWIWJUIUJZUKZUHEUFZKUGFUFZLUGUHZVQWNWO
      UIUJZUKZUHUHZUHZVNWAULUJGIUMUJZHJUMUJZUNZGKUMUJZHLUMUJZUNZIKUMUJZJLUMUJZU
      NZUMUJZUNZGPUMUJZHQUMUJZUNZXFPKUMUJZQLUMUJZUNZUMUJZUNZIPUMUJZJQUMUJZUNZXI
      XQUMUJZUNZUMUJZUNZUGZVQHGIYFUMUJUNUMUJUGZWTVPWEUHZWKWPUHZUHZVRWQUKZWFWQUK
      ZUHZWLWQUKZUHZUHZYGWHYIVSWGUHZUHYJWMWRUHZUHYQWSVPVSWEWGUOWKWMWPWRUOYIYJYR
      YSYQYRYSUHYPYKYRWMWRYPWRYRWMYPWRYRYNWMYOWRVSYLWGYMVSWRYLVQVRWQUPUQWGWRYMV
      QWFWQUPUQURWMWRYOVQWLWQUPUQURUSUTVAVBVCABCDEFGHIJKLMNPQRSTUAUBUCUDUEVDVEW
      HYGYHVKZWSVTWEYTWGVTWBYTWDVTWBYGYHABCOGHIYFRSTXKYEXCXJXAXBGIRTVFHJSUAVFVG
      XFXIXDXEGKRUDVFHLSUEVFVGZXGXHIKTUDVFJLUAUEVFVGZVFVGXSYDXNXRXLXMGPRUBVFHQS
      UCVFVGXFXQUUAXOXPPKUBUDVFQLUCUEVFVGZVFVGYBYCXTYAIPTUBVFJQUAUCVFVGXIXQUUBU
      UCVFVGVFVGVHVIVJVJVLVM $.

    ${
      $d A h f g u v w x y z $.  $d B h f g u v w x y z $.
      $d C h f g u v w x y z $.  $d D h f g u v w x y z $.
      $d F h f g u v w x y z $.  $d G h f g u v w x y z $.
      $d R h f g u v w x y z $.  $d S h f g u v w x y z $.
      $( Lemma for orthoarguesian law 5OA. (Contributed by NM, 4-May-2000.)
         (New usage is discouraged.) $)
      5oalem7 $p |- ( ( ( A +H B ) i^i ( C +H D ) ) i^i
              ( ( F +H G ) i^i ( R +H S ) ) ) C_ ( B +H ( A i^i ( C +H
                 ( ( ( ( A +H C ) i^i ( B +H D ) ) i^i
                     ( ( ( A +H R ) i^i ( B +H S ) ) +H
                       ( ( C +H R ) i^i ( D +H S ) ) ) )
                i^i ( ( ( ( A +H F ) i^i ( B +H G ) ) i^i
                        ( ( ( A +H R ) i^i ( B +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) )
                   +H ( ( ( C +H F ) i^i ( D +H G ) ) i^i
                        ( ( ( C +H R ) i^i ( D +H S ) ) +H
                          ( ( F +H R ) i^i ( G +H S ) ) ) ) ) ) ) ) ) $=
        ( cph co wa wex vh vx vy vz vw vf vg vv cin wcel cva wceq ee4anv exrot4
        vu 2exbii bitri elin wrex shseli r2ex anbi12i 3bitr4ri 5oalem6 exlimivv
        cv bitr4i sylbi ssriv ) UAABQRZCDQRZUIZGHQRZEFQRZUIZUIZBACACQRBDQRUIAEQ
        RBFQRUIZCEQRDFQRUIZQRUIAGQRBHQRUIVQGEQRHFQRUIZQRUICGQRDHQRUIVRVSQRUIQRU
        IQRUIQRZUAVFZVPUJZUBVFZAUJUCVFZBUJSWAWCWDUKRULZSZUDVFZCUJUEVFZDUJSWAWGW
        HUKRULZSZSZUFVFZGUJUGVFZHUJSWAWLWMUKRULZSZUHVFZEUJUOVFZFUJSWAWPWQUKRULZ
        SZSZSZUOTUHTZUGTUFTZUETUDTZUCTUBTZWAVTUJZWKUETUDTZWTUOTUHTZSZUGTUFTZUCT
        UBTXGUCTUBTZXHUGTUFTZSZXEWBXGXHUBUCUFUGUMXDXJUBUCXDXBUETUDTZUGTUFTXJXBU
        DUEUFUGUNXNXIUFUGWKWTUDUEUHUOUMUPUQUPWBWAVLUJZWAVOUJZSXMWAVLVOURXKXOXLX
        PWAVJUJZWAVKUJZSWFUCTUBTZWJUETUDTZSXOXKXQXSXRXTXQWEUCBUSUBAUSXSUBUCABWA
        IJUTWEUBUCABVAUQXRWIUEDUSUDCUSXTUDUECDWAKLUTWIUDUECDVAUQVBWAVJVKURWFWJU
        BUCUDUEUMVCWAVMUJZWAVNUJZSWOUGTUFTZWSUOTUHTZSXPXLYAYCYBYDYAWNUGHUSUFGUS
        YCUFUGGHWAMNUTWNUFUGGHVAUQYBWRUOFUSUHEUSYDUHUOEFWAOPUTWRUHUOEFVAUQVBWAV
        MVNURWOWSUFUGUHUOUMVCVBVGVCXDXFUBUCXCXFUDUEXBXFUFUGXAXFUHUOUBUCUDUEUHUO
        ABCDEFUFUGUAGHIJKLMNOPVDVEVEVEVEVHVI $.
    $}
  $}

  ${
    5oa.1 $e |- A e. CH $.
    5oa.2 $e |- B e. CH $.
    5oa.3 $e |- C e. CH $.
    5oa.4 $e |- D e. CH $.
    5oa.5 $e |- F e. CH $.
    5oa.6 $e |- G e. CH $.
    5oa.7 $e |- R e. CH $.
    5oa.8 $e |- S e. CH $.
    5oa.9 $e |- A C_ ( _|_ ` B ) $.
    5oa.10 $e |- C C_ ( _|_ ` D ) $.
    5oa.11 $e |- F C_ ( _|_ ` G ) $.
    5oa.12 $e |- R C_ ( _|_ ` S ) $.
    $( Orthoarguesian law 5OA. This 8-variable inference is called 5OA because
       it can be converted to a 5-variable equation (see Quantum Logic
       Explorer).  (Contributed by NM, 5-May-2000.)
       (New usage is discouraged.) $)
    5oai $p |- ( ( ( A vH B ) i^i ( C vH D ) ) i^i
            ( ( F vH G ) i^i ( R vH S ) ) ) C_ ( B vH ( A i^i ( C vH
               ( ( ( ( A vH C ) i^i ( B vH D ) ) i^i
                   ( ( ( A vH R ) i^i ( B vH S ) ) vH
                     ( ( C vH R ) i^i ( D vH S ) ) ) )
              i^i ( ( ( ( A vH F ) i^i ( B vH G ) ) i^i
                      ( ( ( A vH R ) i^i ( B vH S ) ) vH
                        ( ( F vH R ) i^i ( G vH S ) ) ) )
                 vH ( ( ( C vH F ) i^i ( D vH G ) ) i^i
                      ( ( ( C vH R ) i^i ( D vH S ) ) vH
                        ( ( F vH R ) i^i ( G vH S ) ) ) ) ) ) ) ) ) $=
      ( chj co cin cph cort cfv wss osumi ax-mp ineq12i chshii 5oalem7 eqsstr3i
      shscli shincli shsleji chsleji ss2in mp2an shjshcli shlej2i shlej1i sstri
      wceq chjcli chincli shjcli sslin ) ABUAUBZCDUAUBZUCZGHUAUBZEFUAUBZUCZUCZB
      ACACUDUBZBDUDUBZUCZAEUDUBZBFUDUBZUCZCEUDUBZDFUDUBZUCZUDUBZUCZAGUDUBZBHUDU
      BZUCZWAGEUDUBZHFUDUBZUCZUDUBZUCZCGUDUBZDHUDUBZUCZWDWLUDUBZUCZUDUBZUCZUDUB
      ZUCZUDUBZBACACUAUBZBDUAUBZUCZAEUAUBZBFUAUBZUCZCEUAUBZDFUAUBZUCZUAUBZUCZAG
      UAUBZBHUAUBZUCZXJGEUAUBZHFUAUBZUCZUAUBZUCZCGUAUBZDHUAUBZUCZXMYAUAUBZUCZUA
      UBZUCZUAUBZUCZUAUBZVOABUDUBZCDUDUBZUCZGHUDUBZEFUDUBZUCZUCXDYPVKYSVNYNVIYO
      VJABUEUFUGYNVIVDQABIJUHUICDUEUFUGYOVJVDRCDKLUHUIUJYQVLYRVMGHUEUFUGYQVLVDS
      GHMNUHUIEFUEUFUGYRVMVDTEFOPUHUIUJUJABCDEFGHAIUKZBJUKZCKUKZDLUKZGMUKZHNUKZ
      EOUKZFPUKZULUMXDBXCUAUBZYMBXCUUAAXBYTCXAUUBWFWTVRWEVPVQACYTUUBUNBDUUAUUCU
      NUOWAWDVSVTAEYTUUFUNBFUUAUUGUNUOZWBWCCEUUBUUFUNDFUUCUUGUNUOZUNUOWNWSWIWMW
      GWHAGYTUUDUNBHUUAUUEUNUOWAWLUUIWJWKGEUUDUUFUNHFUUEUUGUNUOZUNUOZWQWRWOWPCG
      UUBUUDUNDHUUCUUEUNUOWDWLUUJUUKUNUOZUNUOZUNUOZUPXCYLUGZUUHYMUGXBYKUGUUPXBC
      XAUAUBZYKCXAUUBUUNUPXAYJUGZUUQYKUGWFXOUGZWTYIUGUURVRXGUGZWEXNUGUUSVPXEUGV
      QXFUGUUTACIKUQBDJLUQVPXEVQXFURUSWEWAWDUAUBZXNWAWDUUIUUJUPUVAWAXMUAUBZXNWD
      XMUGZUVAUVBUGWBXKUGWCXLUGUVCCEKOUQDFLPUQWBXKWCXLURUSZWDXMWAUUJXKXLCEUUBUU
      FUTDFUUCUUGUTUOZUUIVAUIWAXJUGZUVBXNUGVSXHUGVTXIUGUVFAEIOUQBFJPUQVSXHVTXIU
      RUSZWAXJXMUUIXHXIAEYTUUFUTBFUUAUUGUTUOZUVEVBUIVCVCVRXGWEXNURUSWTWNWSUAUBZ
      YIWNWSUULUUMUPUVIWNYHUAUBZYIWSYHUGZUVIUVJUGWQYFUGZWRYGUGUVKWOYDUGWPYEUGUV
      LCGKMUQDHLNUQWOYDWPYEURUSWRWDWLUAUBZYGWDWLUUJUUKUPUVMWDYAUAUBZYGWLYAUGZUV
      MUVNUGWJXSUGWKXTUGUVOGEMOUQHFNPUQWJXSWKXTURUSZWLYAWDUUKXSXTGEUUDUUFUTHFUU
      EUUGUTUOZUUJVAUIUVCUVNYGUGUVDWDXMYAUUJUVEUVQVBUIVCVCWQYFWRYGURUSWSYHWNUUM
      YFYGYFYDYECGKMVEDHLNVEVFUKXMYAUVEUVQUTUOZUULVAUIWNYCUGZUVJYIUGWIXRUGZWMYB
      UGUVSWGXPUGWHXQUGUVTAGIMUQBHJNUQWGXPWHXQURUSWMWAWLUAUBZYBWAWLUUIUUKUPUWAW
      AYAUAUBZYBUVOUWAUWBUGUVPWLYAWAUUKUVQUUIVAUIUVFUWBYBUGUVGWAXJYAUUIUVHUVQVB
      UIVCVCWIXRWMYBURUSWNYCYHUULXRYBXRXPXQAGIMVEBHJNVEVFUKXJYAUVHUVQUTUOZUVRVB
      UIVCVCWFXOWTYIURUSXAYJCUUNXOYIXOXGXNXEXFACIKVEBDJLVEVFXJXMUVHUVEVGVFUKYCY
      HUWCUVRUTUOZUUBVAUIVCXBYKAVHUIXCYLBUUOAYKYTCYJUUBUWDUTUOUUAVAUIVCVC $.
  $}

  ${
    $d x y z w v B $.  $d x y z w v C $.  $d x y z w v R $.  $d x y z w v S $.
    3oalem1.1 $e |- B e. CH $.
    3oalem1.2 $e |- C e. CH $.
    3oalem1.3 $e |- R e. CH $.
    3oalem1.4 $e |- S e. CH $.
    $( Lemma for 3OA (weak) orthoarguesian law.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    3oalem1 $p |- ( ( ( ( x e. B /\ y e. R ) /\ v = ( x +h y ) ) /\
                  ( ( z e. C /\ w e. S ) /\ v = ( z +h w ) ) ) ->
                 ( ( ( x e. ~H /\ y e. ~H ) /\ v e. ~H ) /\
                  ( z e. ~H /\ w e. ~H ) ) ) $=
      ( cv wcel wa cva chil cheli anim12i co hvaddcl eleq1 syl5ibrcom imdistani
      wceq sylan adantr ) ANZFOZBNZHOZPZENZUIUKQUAZUFZPUIROZUKROZPZUNROZPZCNZGO
      ZDNZIOZPZUNVBVDQUAUFZPVBROZVDROZPZUMUSUPVAUJUQULURUIFJSUKHLSTUSUPUTUSUTUP
      UOROUIUKUBUNUORUCUDUEUGVFVJVGVCVHVEVIVBGKSVDIMSTUHT $.

    $( Lemma for 3OA (weak) orthoarguesian law.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    3oalem2 $p |- ( ( ( ( x e. B /\ y e. R ) /\ v = ( x +h y ) ) /\
                  ( ( z e. C /\ w e. S ) /\ v = ( z +h w ) ) ) ->
            v e. ( B +H ( R i^i ( S +H ( ( B +H C ) i^i ( R +H S ) ) ) ) ) ) $=
      ( wcel wa cva co wceq cmv c0v cph simplll simpllr chil 3oalem1 hvaddsub12
      cin 3anidm23 hvsubid oveq2d ax-hvaddid sylan9eqr ad2ant2l adantlr simprlr
      cv eqtr3d syl eqtr2 oveq1d anim1i hvsub4 syldan ad2antrr hvsubcl hvaddid2
      simpl adantll 3eqtrd simpr anim2i syl2anc ad2antll ancoms adantrr 3eqtr3d
      ad2ant2rl simpll chshii shsvsi shscomi syl2an simplr elin sylanbrc shscli
      syl6eleqr eqeltrd shincli shsvai eqeltrrd wb eleq1 ad2antlr mpbird ) AUPZ
      FNZBUPZHNZOZEUPZWPWRPQZRZOZCUPZGNZDUPZINZOZXAXEXGPQZRZOZOZXAFHIFGUAQZHIUA
      QZUGZUAQZUGZUAQZNZXBXSNZXMWQWRXRNZYAWQWSXCXLUBXMWSWRXQNYBWQWSXCXLUCXMXGWR
      XGSQZPQZWRXQXMWPUDNZWRUDNZOZXAUDNZOXEUDNZXGUDNZOZOZYDWRRZABCDEFGHIJKLMUEZ
      YGYKYMYHYFYJYMYEYIYFYJOZWRXGXGSQZPQZYDWRYFYJYQYDRWRXGXGUFUHYJYFYQWRTPQWRY
      JYPTWRPXGUIZUJWRUKULUQUMUNURXMXHYCXPNZYDXQNXDXFXHXKUOXMYCXNNYCXONZYSXMYCX
      EWPSQZXNXMXBWPXGPQZSQZXJUUBSQZYCUUAXCXKUUCUUDRWTXIXCXKOXBXJUUBSXAXBXJUSUT
      UMXMYLUUCYCRZYNYGYJUUEYHYIYGYJOZUUCWPWPSQZYCPQZTYCPQZYCYGYJYEYJOZUUCUUHRY
      GYEYJYEYFVGVAWPWRWPXGVBVCUUFUUGTYCPYEUUGTRYFYJWPUIVDUTYFYJUUIYCRZYEYOYCUD
      NUUKWRXGVEYCVFURVHVIVQURXMYLUUDUUARZYNYGYKUULYHYEYKUULYFYEYKOZUUDUUAYPPQZ
      UUATPQZUUAUUMYKUUJUUDUUNRYEYKVJYKYJYEYIYJVJVKXEXGWPXGVBVLUUMYPTUUAPYJYPTR
      YEYIYRVMUJYEYIUUOUUARZYJYIYEUUPYIYEOUUAUDNUUPXEWPVEUUAUKURVNVOVIUNUNURVPX
      DWQXFUUAXNNXLWQWSXCVRXFXHXKVRWQXFOUUAGFUAQZXNXFWQUUAUUQNGFXEWPGKVSZFJVSZV
      TVNFGUUSUURWAWGWBWHXDWSXHYTXLWQWSXCWCXFXHXKWCHIWRXGHLVSZIMVSZVTWBYCXNXOWD
      WEIXPXGYCUVAXNXOFGUUSUURWFHIUUTUVAWFWIZWJVLWKWRHXQWDWEFXRWPWRUUSHXQUUTIXP
      UVAUVBWFWIWJVLXCXTYAWLWTXLXAXBXSWMWNWO $.

    $( Lemma for 3OA (weak) orthoarguesian law.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    3oalem3 $p |- ( ( B +H R ) i^i ( C +H S ) ) C_
                   ( B +H ( R i^i ( S +H ( ( B +H C ) i^i ( R +H S ) ) ) ) ) $=
      ( vv vx vy vz vw cph co cv wcel wa wex wrex cin wceq chseli bitri anbi12i
      cva r2ex elin ee4anv 3bitr4i 3oalem2 exlimivv sylbi ssriv ) IACNOZBDNOZUA
      ZACDABNOCDNOUANOUANOZIPZUQQZJPZAQKPZCQRUSVAVBUFOUBZRZLPZBQMPZDQRUSVEVFUFO
      UBZRZRZMSLSZKSJSZUSURQZUSUOQZUSUPQZRVDKSJSZVHMSLSZRUTVKVMVOVNVPVMVCKCTJAT
      VOJKACUSEGUCVCJKACUGUDVNVGMDTLBTVPLMBDUSFHUCVGLMBDUGUDUEUSUOUPUHVDVHJKLMU
      IUJVJVLJKVIVLLMJKLMIABCDEFGHUKULULUMUN $.
  $}

  ${
    3oalem4.3 $e |- R = ( ( _|_ ` B ) i^i ( B vH A ) ) $.
    $( Lemma for 3OA (weak) orthoarguesian law.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    3oalem4 $p |- R C_ ( _|_ ` B ) $=
      ( cort cfv chj co cin inss1 eqsstri ) CBEFZBAGHZILDLMJK $.
  $}

  ${
    3oa.1 $e |- A e. CH $.
    3oa.2 $e |- B e. CH $.
    3oa.3 $e |- C e. CH $.
    3oa.4 $e |- R = ( ( _|_ ` B ) i^i ( B vH A ) ) $.
    3oa.5 $e |- S = ( ( _|_ ` C ) i^i ( C vH A ) ) $.
    $( Lemma for 3OA (weak) orthoarguesian law.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    3oalem5 $p |- ( ( B +H R ) i^i ( C +H S ) ) =
                  ( ( B vH R ) i^i ( C vH S ) ) $=
      ( cph co chj cort cfv wss wceq 3oalem4 cin chshii choccli chincli eqeltri
      cch chjcli osumi ax-mp shscomi chjcomi 3eqtr4i ineq12i ) BDKLZBDMLZCEKLZC
      EMLZDBKLZDBMLZULUMDBNOZPUPUQQABDIRDBDURBAMLZSUDIURUSBGUABAGFUEUBUCZGUFUGB
      DBGTDUTTUHBDGUTUIUJECKLZECMLZUNUOECNOZPVAVBQACEJRECEVCCAMLZSUDJVCVDCHUACA
      HFUEUBUCZHUFUGCECHTEVETUHCEHVEUIUJUK $.

    $( Lemma for 3OA (weak) orthoarguesian law.  (Contributed by NM,
       19-Oct-1999.)  (New usage is discouraged.) $)
    3oalem6 $p |- ( B +H ( R i^i ( S +H ( ( B +H C ) i^i ( R +H S ) ) ) ) ) C_
                  ( B vH ( R i^i ( S vH ( ( B vH C ) i^i ( R vH S ) ) ) ) ) $=
      ( cph co cin chj chshii chjcli chincli shscli wss ax-mp cfv choccli ssrin
      cort cch eqeltri shincli shsleji chsleji sslin sstri shlej2i ) BDEBCKLZDE
      KLZMZKLZMZKLBUQNLZBDEBCNLZDENLZMZNLZMZNLZBUQBGOZDUPDDBUDUAZBANLZMUEIVFVGB
      GUBBAGFPQUFZOZEUOEECUDUAZCANLZMUEJVJVKCHUBCAHFPQUFZOZUMUNBCVECHORDEVIVMRU
      GZRUGZUHUQVCSZURVDSUPVBSVPUPEUONLZVBEUOVMVNUHUOVASVQVBSUOUSUNMZVAUMUSSUOV
      RSBCGHUIUMUSUNUCTUNUTSVRVASDEVHVLUIUNUTUSUJTUKUOVAEVNVAUSUTBCGHPDEVHVLPQZ
      OVMULTUKUPVBDUJTUQVCBVOVCDVBVHEVAVLVSPQOVEULTUK $.

    $( 3OA (weak) orthoarguesian law.  Equation IV of [GodowskiGreechie]
       p. 249.  (Contributed by NM, 19-Oct-1999.)
       (New usage is discouraged.) $)
    3oai $p |- ( ( B vH R ) i^i ( C vH S ) ) C_
                  ( B vH ( R i^i ( S vH ( ( B vH C ) i^i ( R vH S ) ) ) ) ) $=
      ( chj co cin cph cort cfv cch choccli chjcli chincli 3oalem5 eqsstr3i
      eqeltri 3oalem3 3oalem6 sstri ) BDKLCEKLMBDNLCENLMZBDEBCKLDEKLMKLMKLZABCD
      EFGHIJUAUGBDEBCNLDENLMNLMNLUHBCDEGHDBOPZBAKLZMQIUIUJBGRBAGFSTUCECOPZCAKLZ
      MQJUKULCHRCAHFSTUCUDABCDEFGHIJUEUFUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    pjorth.1 $e |- A e. ~H $.
    pjorth.2 $e |- B e. ~H $.
    $( Projection components on orthocomplemented subspaces are orthogonal.
       (Contributed by NM, 26-Oct-1999.)  (New usage is discouraged.) $)
    pjorthi $p |- ( H e. CH
      -> ( ( ( projh ` H ) ` A ) .ih ( ( projh ` ( _|_ ` H ) ) ` B ) ) = 0 ) $=
      ( cch wcel csh cpjh cfv cort wa csp co cc0 wceq chsh chil axpjcl mpan2
      choccl sylancl jca shocorth sylc ) CFGZCHGACIJJZCGZBCKJZIJJZUIGZLUGUJMNOP
      CQUFUHUKUFARGUHDACSTUFUIFGBRGUKCUAEBUISUBUCUGUJCUDUE $.
  $}

  $( Property of identity projection.  Remark in [Beran] p. 111.  (Contributed
     by NM, 28-Oct-1999.)  (New usage is discouraged.) $)
  pjch1 $p |- ( A e. ~H -> ( ( projh ` ~H ) ` A ) = A ) $=
    ( chil wcel cpjh cfv wceq wb c0v eleq1 fveq2 eqeq12d bibi12d helch ax-hv0cl
    cif id elimel pjchi dedth ibi ) ABCZABDEZEZAFZUAUAUDGUAAHOZBCZUEUBEZUEFZGAH
    AUEFZUAUFUDUHAUEBIUIUCUGAUEAUEUBJUIPKLUEBMAHBNQRST $.

  $( The orthogonal projection.  Lemma 4.4(i) of [Beran] p. 111.  (Contributed
     by NM, 30-Oct-1999.)  (New usage is discouraged.) $)
  pjo $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( projh ` ( _|_ ` H ) ) ` A ) =
             ( ( ( projh ` ~H ) ` A ) -h ( ( projh ` H ) ` A ) ) ) $=
    ( cch wcel chil wa cpjh cfv cmv co cort wceq cva pjch1 adantl axpjpj eqtr2d
    wb helch pjhcl pjcli choccl sylan hvsubadd syl3anc mpbird eqcomd ) BCDZAEDZ
    FZAEGHHZABGHHZIJZABKHZGHHZUJUMUOLZULUOMJZUKLZUJUKAUQUIUKALUHANOABPQUJUKEDZU
    LEDUOEDZUPURRUIUSUHAESUAOABTUHUNCDUIUTBUBAUNTUCUKULUOUDUEUFUG $.

  ${
    pjidm.1 $e |- H e. CH $.
    $( Component of a projection.  (Contributed by NM, 31-Oct-1999.)  (Revised
       by Mario Carneiro, 19-May-2014.)  (New usage is discouraged.) $)
    pjcompi $p |- ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
                 ( ( projh ` H ) ` ( A +h B ) ) = A ) $=
      ( wcel cort cfv wa cva co cpjh wceq cch chil cheli choccli hvaddcl syl2an
      sylancr axpjcl axpjpj eqid wi simpl simpr chocunii syl22anc mpan2i simpld
      mpd ) ACEZBCFGZEZHZABIJZCKGGZALZUOULKGGZBLZUNUOUPURIJLZUQUSHZUNCMEZUONEZU
      TDUKANEBNEVCUMACDOBULCDPZOABQRZUOCUASUNUTUOUOLZVAUOUBUNUPCEZURULEZUKUMUTV
      FHVAUCUNVBVCVGDVEUOCTSUNULMEVCVHVDVEUOULTSUKUMUDUKUMUEUPURABUOCDUFUGUHUJU
      I $.

    pjidm.2 $e |- A e. ~H $.
    $( A projection is idempotent.  Property (ii) of [Beran] p. 109.
       (Contributed by NM, 28-Oct-1999.)  (New usage is discouraged.) $)
    pjidmi $p |- ( ( projh ` H ) ` ( ( projh ` H ) ` A ) ) =
               ( ( projh ` H ) ` A ) $=
      ( cpjh cfv wcel wceq pjclii pjhclii pjchi mpbi ) ABEFZFZBGNMFNHABCDINBCAB
      CDJKL $.

    ${
      pjadj.3 $e |- B e. ~H $.
      $( A projection is self-adjoint.  Property (i) of [Beran] p. 109.
         (Contributed by NM, 30-Oct-1999.)  (New usage is discouraged.) $)
      pjadjii $p |- ( ( ( projh ` H ) ` A ) .ih B ) =
                  ( A .ih ( ( projh ` H ) ` B ) ) $=
        ( cpjh cfv cva csp caddc ccj cc0 wcel wceq pjorthi ax-mp pjhclii chil
        co cort cch fveq2i cj0 eqtri choccli his1i 3eqtr4ri oveq2i his7 ax-his2
        mp3an 3eqtr4i pjpji oveq1i ) ACGHZHZBUPHZBCUAHZGHZHZITZJTZUQAUTHZITZURJ
        TZUQBJTAURJTUQURJTZUQVAJTZKTZVGVDURJTZKTZVCVFVHVJVGKURVDJTZLHZMVJVHVMML
        HMVLMLCUBNZVLMODBACFEPQUCUDUEVDURAUSCDUFZERZBCDFRZUGVNVHMODABCEFPQUHUIU
        QSNZURSNZVASNVCVIOACDERZVQBUSVOFRUQURVAUJULVRVDSNVSVFVKOVTVPVQUQVDURUKU
        LUMBVBUQJBCDFUNUIAVEURJACDEUNUOUM $.

      $( Projection of vector sum is sum of projections.  (Contributed by NM,
         31-Oct-1999.)  (New usage is discouraged.) $)
      pjaddii $p |- ( ( projh ` H ) ` ( A +h B ) ) =
                  ( ( ( projh ` H ) ` A ) +h ( ( projh ` H ) ` B ) ) $=
        ( cva co cpjh cfv cort pjpji pjhclii eqtri wcel csh chshii pjclii mp3an
        shaddcl oveq12i choccli hvadd4i fveq2i wceq pjcompi mp2an ) ABGHZCIJZJA
        UIJZBUIJZGHZACKJZIJZJZBUNJZGHZGHZUIJZULUHURUIUHUJUOGHZUKUPGHZGHURAUTBVA
        GACDELBCDFLUAUJUOUKUPACDEMAUMCDUBZEMBCDFMBUMVBFMUCNUDULCOZUQUMOZUSULUEC
        POUJCOUKCOVCCDQACDERBCDFRUJUKCTSUMPOUOUMOUPUMOVDUMVBQAUMVBERBUMVBFRUOUP
        UMTSULUQCDUFUGN $.
    $}

    $( The inner product of a projection and its argument is the square of the
       norm of the projection.  Remark in [Halmos] p. 44.  (Contributed by NM,
       13-Aug-2000.)  (New usage is discouraged.) $)
    pjinormii $p |- ( ( ( projh ` H ) ` A ) .ih A ) =
                 ( ( normh ` ( ( projh ` H ) ` A ) ) ^ 2 ) $=
      ( cpjh cfv cno c2 cexp csp pjhclii normsqi pjadjii pjidmi oveq1i 3eqtr2ri
      co ) ABEFZFZGFHIQSSJQSRFZAJQSAJQSABCDKZLSABCUADMTSAJABCDNOP $.

    ${
      pjmul.3 $e |- C e. CC $.
      $( Projection of (scalar) product is product of projection.  (Contributed
         by NM, 31-Oct-1999.)  (New usage is discouraged.) $)
      pjmulii $p |- ( ( projh ` H ) ` ( C .h A ) ) =
                  ( C .h ( ( projh ` H ) ` A ) ) $=
        ( csm co cpjh cfv cort cva pjhclii eqtri wcel csh chshii pjclii shmulcl
        mp3an pjpji oveq2i choccli hvdistr1i fveq2i wceq cc pjcompi mp2an ) BAG
        HZCIJZJBAUKJZGHZBACKJZIJJZGHZLHZUKJZUMUJUQUKUJBULUOLHZGHUQAUSBGACDEUAUB
        BULUOFACDEMAUNCDUCZEMUDNUEUMCOZUPUNOZURUMUFCPOBUGOZULCOVACDQFACDERBULCS
        TUNPOVCUOUNOVBUNUTQFAUNUTERBUOUNSTUMUPCDUHUIN $.
    $}

    ${
      pjsub.3 $e |- B e. ~H $.
      $( Projection of vector difference is difference of projections.
         (Contributed by NM, 31-Oct-1999.)  (New usage is discouraged.) $)
      pjsubii $p |- ( ( projh ` H ) ` ( A -h B ) ) =
                  ( ( ( projh ` H ) ` A ) -h ( ( projh ` H ) ` B ) ) $=
        ( c1 cneg csm co cva cpjh cfv neg1cn hvmulcli pjaddii pjmulii hvsubvali
        cmv pjhclii oveq2i eqtri fveq2i 3eqtr4i ) AGHZBIJZKJZCLMZMZAUHMZUEBUHMZ
        IJZKJZABSJZUHMUJUKSJUIUJUFUHMZKJUMAUFCDEUEBNFOPUOULUJKBUECDFNQUAUBUNUGU
        HABEFRUCUJUKACDETBCDFTRUD $.
    $}

    ${
      pjsslem.1 $e |- G e. CH $.
      $( Lemma for subset relationships of projections.  (Contributed by NM,
         31-Oct-1999.)  (New usage is discouraged.) $)
      pjsslem $p |- ( ( ( projh ` ( _|_ ` H ) ) ` A ) -h
                      ( ( projh ` ( _|_ ` G ) ) ` A ) ) =
                    ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) ) $=
        ( cort cfv cpjh cmv co c0v chil cch wcel wceq pjo mp2an pjhclii 3eqtri
        cneg csm oveq12i helch pjclii hvsubsub4i hvsubid ax-mp hvsubcli hv2negi
        c1 oveq1i hvnegdii ) ACGHIHHZABGHIHHZJKZLACIHHZABIHHZJKZJKZUKUAUSUBKURU
        QJKUPAMIHHZUQJKZVAURJKZJKVAVAJKZUSJKUTUNVBUOVCJCNOAMOZUNVBPDEACQRBNOVEU
        OVCPFEABQRUCVAUQVAURAMUDEUEZACDESZVFABFESZUFVDLUSJVAMOVDLPVFVAUGUHULTUS
        UQURVGVHUIUJUQURVGVHUMT $.

      $( Subset relationship for projections.  Theorem 4.5(i)->(ii) of [Beran]
         p. 112.  (Contributed by NM, 31-Oct-1999.)
         (New usage is discouraged.) $)
      pjss2i $p |- ( H C_ G -> ( ( projh ` H ) ` ( ( projh ` G ) ` A ) ) =
                 ( ( projh ` H ) ` A ) ) $=
        ( wss cort cfv cpjh cmv co wcel wceq choccli pjclii chsscon3i c0v bitri
        pjhclii ssel mpi sylbi csh chshii shsubcl mp3an1 sylancr pjsslem eleq1i
        hvsubcli pjoc2i pjsubii eqeq1i hvsubeq0i pjidmi eqeq2i 3bitrri sylibr )
        CBGZACHIZJIIZABHIZJIIZKLZVAMZABJIIZCJIZIZAVHIZNZUTVBVAMZVDVAMZVFAVACDOZ
        EPUTVCVAGZVMCBDFQVOVDVCMVMAVCBFOEPVCVAVDUAUBUCVAUDMVLVMVFVAVNUEVBVDVAUF
        UGUHVFVGVJKLZVHIZRNZVIVJVHIZNZVKVFVPVAMVRVEVPVAABCDEFUIUJVPCDVGVJABFETZ
        ACDETZUKULSVRVIVSKLZRNVTVQWCRVGVJCDWAWBUMUNVIVSVGCDWATVJCDWBTUOSVSVJVIA
        CDEUPUQURUS $.

      $( Projection meet property.  Remark in [Kalmbach] p. 66.  Also Theorem
         4.5(i)->(iv) of [Beran] p. 112.  (Contributed by NM, 31-Oct-1999.)
         (New usage is discouraged.) $)
      pjssmii $p |- ( H C_ G -> ( ( ( projh ` G ) ` A )
    -h ( ( projh ` H ) ` A ) ) = ( ( projh ` ( G i^i ( _|_ ` H ) ) ) ` A ) ) $=
        ( wss cort cfv cpjh cmv co pjhclii csm c0v wceq ax-mp wcel pjclii eqtri
        cin choccli chincli pjsubii c1 cneg cva hvsubvali inss1 pjss2i shococss
        chshii inss2 chsscon3i mpbi sstri sselii pjoc2i oveq2i cc neg1cn hvmul0
        csh oveq12i chil ax-hvaddid wa mpi shsubcl mp3an1 sylancr pjsslem sylbi
        ssel syl5eqelr jca elin hvsubcli pjchi bitr3i sylib syl5reqr ) CBGZABCH
        IZUAZJIZIZABJIIZACJIIZKLZWFIZWJWKWHWFIZWIWFIZKLZWGWHWIWEBWDFCDUBZUCZABF
        EMZACDEMZUDWNWLUEUFZWMNLZUGLZWGWLWMWHWEWPWQMWIWEWPWRMUHXAWGOUGLZWGWLWGW
        TOUGWEBGWLWGPBWDUIABWEWPEFUJQWTWSONLZOWMOWSNWIWEHIZRWMOPCXDWICWDHIZXDCV
        CRCXEGCDULCUKQWEWDGXEXDGBWDUMWEWDWPWOUNUOUPACDESZUQWIWEWPWRURUOUSWSUTRX
        COPVAWSVBQTVDWGVERXBWGPAWEWPEMWGVFQTTTWCWJBRZWJWDRZVGZWKWJPZWCXGXHWCWHB
        RZWIBRZXGABFESWCWICRXLXFCBWIVNVHBVCRXKXLXGBFULWHWIBVIVJVKWCWJAWDJIIZABH
        IZJIIZKLZWDABCDEFVLWCXNWDGZXPWDRZCBDFUNXQXMWDRZXOWDRZXRAWDWOESXQXOXNRXT
        AXNBFUBESXNWDXOVNVHWDVCRXSXTXRWDWOULXMXOWDVIVJVKVMVOVPXIWJWERXJWJBWDVQW
        JWEWPWHWIWQWRVRVSVTWAWB $.

      $( Theorem 4.5(iv)->(v) of [Beran] p. 112.  (Contributed by NM,
         13-Aug-2000.)  (New usage is discouraged.) $)
      pjssge0ii $p |- ( ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) )
                    = ( ( projh ` ( G i^i ( _|_ ` H ) ) ) ` A ) ->
   0 <_ ( ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) ) .ih A ) ) $=
        ( cpjh cfv cmv co cort cin wceq cc0 cno c2 cexp csp cle choccli chincli
        pjhclii normcli sqge0i oveq1 pjinormii syl6eq syl5breqr ) ABGHHACGHHIJZ
        ABCKHZLZGHHZMZNULOHZPQJZUIARJZSUNULAUKBUJFCDTUAZEUBUCUDUMUPULARJUOUIULA
        RUEAUKUQEUFUGUH $.

      $( Theorem 4.5(v)<->(vi) of [Beran] p. 112.  (Contributed by NM,
         13-Aug-2000.)  (New usage is discouraged.) $)
      pjdifnormii $p |- ( 0 <_
            ( ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) ) .ih A )
          <->
    ( normh ` ( ( projh ` H ) ` A ) ) <_ ( normh ` ( ( projh ` G ) ` A ) ) ) $=
        ( cc0 cpjh cfv cno c2 cexp co cmin cle wbr csp pjhclii chil wcel breq2i
        normcli resqcli subge0i wceq his2sub mp3an pjinormii oveq12i wb normge0
        cmv eqtri ax-mp le2sqi mp2an 3bitr4i ) GABHIIZJIZKLMZACHIIZJIZKLMZNMZOP
        VCUTOPZGURVAULMAQMZOPVBUSOPZUTVCUSURABFERZUBZUCVBVAACDERZUBZUCUDVFVDGOV
        FURAQMZVAAQMZNMZVDURSTZVASTZASTVFVNUEVHVJEURVAAUFUGVLUTVMVCNABFEUHACDEU
        HUIUMUAGVBOPZGUSOPZVGVEUJVPVQVJVAUKUNVOVRVHURUKUNVBUSVKVIUOUPUQ $.

      $( The projection on a subspace join is the sum of the projections.
         (Contributed by NM, 1-Nov-1999.)  (New usage is discouraged.) $)
      pjcji $p |- ( H C_ ( _|_ ` G ) -> ( ( projh ` ( H vH G ) ) ` A ) =
                ( ( ( projh ` H ) ` A ) +h ( ( projh ` G ) ` A ) ) ) $=
        ( cort cfv wss cpjh cva chj cmv choccli oveq2i pjhclii chil wcel eqtr4i
        co cin pjssmii oveq2d cneg csm pjpoi hvnegdii hvaddsub12 mp3an hvsubcli
        wceq hvsubvali chjcomi chdmm4i fveq2i fveq1i chincli pjopi eqtri eqcomd
        c1 3eqtr4g ) CBGHZIZACJHHZABJHHZKTZACBLTZJHZHZVDAAVCJHHZVEMTZMTZAAVCCGH
        ZUAZJHHZMTZVGVJVDVLVPAMAVCCDEBFNZUBUCVGAVAUDVLUETZKTZVMVGVEAVKMTZKTZVTV
        FWAVEKABFEUFOVTAVEVKMTZKTZWBVSWCAKVKVEAVCVREPZACDEPZUGOVEQRAQRVKQRWBWDU
        KWFEWEVEAVKUHUISSAVLEVKVEWEWFUJULSVJAVOGHZJHZHVQAVIWHVHWGJVHBCLTWGCBDFU
        MBCFDUNSUOUPAVOVCVNVRCDNUQEURUSVBUT $.
    $}
  $}

  ${
    pjadjt.1 $e |- H e. CH $.
    $( A projection is self-adjoint.  Property (i) of [Beran] p. 109.
       (Contributed by NM, 6-Oct-2000.)  (New usage is discouraged.) $)
    pjadji $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( ( projh ` H ) ` A ) .ih B ) =
                  ( A .ih ( ( projh ` H ) ` B ) ) ) $=
      ( chil wcel cpjh cfv csp co wceq c0v cif fveq2 oveq1d oveq1 eqeq12d oveq2
      ax-hv0cl elimel oveq2d pjadjii dedth2h ) AEFZBEFZACGHZHZBIJZABUFHZIJZKUDA
      LMZUFHZBIJZUKUIIJZKULUEBLMZIJZUKUOUFHZIJZKABLLAUKKZUHUMUJUNUSUGULBIAUKUFN
      OAUKUIIPQBUOKZUMUPUNURBUOULIRUTUIUQUKIBUOUFNUAQUKUOCDALESTBLESTUBUC $.

    $( Projection of vector sum is sum of projections.  (Contributed by NM,
       14-Nov-2000.)  (New usage is discouraged.) $)
    pjaddi $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( projh ` H ) ` ( A +h B ) ) =
                ( ( ( projh ` H ) ` A ) +h ( ( projh ` H ) ` B ) ) ) $=
      ( chil wcel cva cpjh cfv wceq c0v cif oveq1 fveq2d fveq2 eqeq12d ax-hv0cl
      co oveq1d elimel oveq2 oveq2d pjaddii dedth2h ) AEFZBEFZABGRZCHIZIZAUHIZB
      UHIZGRZJUEAKLZBGRZUHIZUMUHIZUKGRZJUMUFBKLZGRZUHIZUPURUHIZGRZJABKKAUMJZUIU
      OULUQVCUGUNUHAUMBGMNVCUJUPUKGAUMUHOSPBURJZUOUTUQVBVDUNUSUHBURUMGUANVDUKVA
      UPGBURUHOUBPUMURCDAKEQTBKEQTUCUD $.

    $( The inner product of a projection and its argument is the square of the
       norm of the projection.  Remark in [Halmos] p. 44.  (Contributed by NM,
       2-Jun-2006.)  (New usage is discouraged.) $)
    pjinormi $p |- ( A e. ~H -> ( ( ( projh ` H ) ` A ) .ih A ) =
                 ( ( normh ` ( ( projh ` H ) ` A ) ) ^ 2 ) ) $=
      ( chil wcel cpjh cfv csp co cno c2 cexp wceq c0v cif fveq2 oveq12d fveq2d
      id oveq1d eqeq12d ax-hv0cl elimel pjinormii dedth ) ADEZABFGZGZAHIZUHJGZK
      LIZMUFANOZUGGZULHIZUMJGZKLIZMANAULMZUIUNUKUPUQUHUMAULHAULUGPZUQSQUQUJUOKL
      UQUHUMJURRTUAULBCANDUBUCUDUE $.

    $( Projection of vector difference is difference of projections.
       (Contributed by NM, 14-Nov-2000.)  (New usage is discouraged.) $)
    pjsubi $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( projh ` H ) ` ( A -h B ) ) =
                ( ( ( projh ` H ) ` A ) -h ( ( projh ` H ) ` B ) ) ) $=
      ( chil wcel cmv cpjh cfv wceq c0v cif oveq1 fveq2d fveq2 eqeq12d ax-hv0cl
      co oveq1d elimel oveq2 oveq2d pjsubii dedth2h ) AEFZBEFZABGRZCHIZIZAUHIZB
      UHIZGRZJUEAKLZBGRZUHIZUMUHIZUKGRZJUMUFBKLZGRZUHIZUPURUHIZGRZJABKKAUMJZUIU
      OULUQVCUGUNUHAUMBGMNVCUJUPUKGAUMUHOSPBURJZUOUTUQVBVDUNUSUHBURUMGUANVDUKVA
      UPGBURUHOUBPUMURCDAKEQTBKEQTUCUD $.

    $( Projection of scalar product is scalar product of projection.
       (Contributed by NM, 26-Nov-2000.)  (New usage is discouraged.) $)
    pjmuli $p |- ( ( A e. CC /\ B e. ~H ) -> ( ( projh ` H ) ` ( A .h B ) ) =
                ( A .h ( ( projh ` H ) ` B ) ) ) $=
      ( cc wcel chil csm co cpjh cfv wceq cc0 cif c0v oveq1 fveq2d oveq2 elimel
      eqeq12d fveq2 oveq2d ax-hv0cl 0cn pjmulii dedth2h ) AEFZBGFZABHIZCJKZKZAB
      UJKZHIZLUGAMNZBHIZUJKZUNULHIZLUNUHBONZHIZUJKZUNURUJKZHIZLABMOAUNLZUKUPUMU
      QVCUIUOUJAUNBHPQAUNULHPTBURLZUPUTUQVBVDUOUSUJBURUNHRQVDULVAUNHBURUJUAUBTU
      RUNCDBOGUCSAMEUDSUEUF $.

    $( The inner product of a projection and its argument is nonnegative.
       (Contributed by NM, 2-Jun-2006.)  (New usage is discouraged.) $)
    pjige0i $p |- ( A e. ~H -> 0 <_ ( ( ( projh ` H ) ` A ) .ih A ) ) $=
      ( chil wcel cc0 cpjh cfv cno c2 cexp co csp cle cr pjhcli normcl pjinormi
      syl sqge0d breqtrrd ) ADEZFABGHHZIHZJKLUCAMLNUBUDUBUCDEUDOEABCPUCQSTABCRU
      A $.
  $}

  $( The inner product of a projection and its argument is nonnegative.
     (Contributed by NM, 2-Jun-2006.)  (New usage is discouraged.) $)
  pjige0 $p |- ( ( H e. CH /\ A e. ~H ) ->
                0 <_ ( ( ( projh ` H ) ` A ) .ih A ) ) $=
    ( cch wcel chil cc0 cpjh cfv csp co cle wbr wi c0h wceq fveq2 fveq1d oveq1d
    cif breq2d imbi2d h0elch elimel pjige0i dedth imp ) BCDZAEDZFABGHZHZAIJZKLZ
    UGUHULMUHFAUGBNSZGHZHZAIJZKLZMBNBUMOZULUQUHURUKUPFKURUJUOAIURAUIUNBUMGPQRTU
    AAUMBNCUBUCUDUEUF $.

  $( The projection on a subspace join is the sum of the projections.
     (Contributed by NM, 1-Nov-1999.)  (New usage is discouraged.) $)
  pjcjt2 $p |- ( ( H e. CH /\ G e. CH /\ A e. ~H ) ->
            ( H C_ ( _|_ ` G ) -> ( ( projh ` ( H vH G ) ) ` A ) =
            ( ( ( projh ` H ) ` A ) +h ( ( projh ` G ) ` A ) ) ) ) $=
    ( cch wcel chil cort cfv wss chj co cpjh cva wceq wi cif c0v fveq1d eqeq12d
    fveq2 sseq1 oveq1 fveq2d oveq1d imbi12d sseq2d oveq2d oveq12d imbi2d elimel
    oveq2 helch ax-hv0cl pjcji dedth3h ) CDEZBDEZAFEZCBGHZIZACBJKZLHZHZACLHZHZA
    BLHZHZMKZNZOUPCFPZUSIZAVJBJKZLHZHZAVJLHZHZVGMKZNZOVJUQBFPZGHZIZAVJVSJKZLHZH
    ZVPAVSLHZHZMKZNZOWAURAQPZWCHZWIVOHZWIWEHZMKZNZOCBAFFQCVJNZUTVKVIVRCVJUSUAWO
    VCVNVHVQWOAVBVMWOVAVLLCVJBJUBUCRWOVEVPVGMWOAVDVOCVJLTRUDSUEBVSNZVKWAVRWHWPU
    SVTVJBVSGTUFWPVNWDVQWGWPAVMWCWPVLWBLBVSVJJUKUCRWPVGWFVPMWPAVFWEBVSLTRUGSUEA
    WINZWHWNWAWQWDWJWGWMAWIWCTWQVPWKWFWLMAWIVOTAWIWETUHSUIWIVSVJCFDULUJAQFUMUJB
    FDULUJUNUO $.

  ${
    pj0.1 $e |- H e. CH $.
    $( The projection of the zero vector.  (Contributed by NM, 31-Oct-1999.)
       (New usage is discouraged.) $)
    pj0i $p |- ( ( projh ` H ) ` 0h ) = 0h $=
      ( c0v cort cfv wcel cpjh wceq csh chshii oc0 ax-mp ax-hv0cl pjoc2i mpbi )
      CADEFZCAGEECHAIFPABJAKLCABMNO $.
  $}

  $( Projection of a vector in the projection subspace.  Lemma 4.4(ii) of
     [Beran] p. 111.  (Contributed by NM, 30-Oct-1999.)
     (New usage is discouraged.) $)
  pjch $p |- ( ( H e. CH /\ A e. ~H ) ->
              ( A e. H <-> ( ( projh ` H ) ` A ) = A ) ) $=
    ( cch wcel chil cpjh cfv wb cif c0v eleq2 fveq2 fveq1d eqeq1d bibi12d eleq1
    wceq id eqeq12d elimel helch ax-hv0cl pjchi dedth2h ) BCDZAEDZABDZABFGZGZAQ
    ZHAUEBEIZDZAUKFGZGZAQZHUFAJIZUKDZUPUMGZUPQZHBAEJBUKQZUGULUJUOBUKAKUTUIUNAUT
    AUHUMBUKFLMNOAUPQZULUQUOUSAUPUKPVAUNURAUPAUPUMLVARSOUPUKBECUATAJEUBTUCUD $.

  $( The projection of a vector in the projection subspace is itself.
     (Contributed by NM, 9-Apr-2006.)  (New usage is discouraged.) $)
  pjid $p |- ( ( H e. CH /\ A e. H ) -> ( ( projh ` H ) ` A ) = A ) $=
    ( cch wcel chil wa cpjh cfv wceq simpl chel jca pjch biimpa sylancom ) BCDZ
    ABDZPAEDZFZABGHHAIZPQFPRPQJABKLSQTABMNO $.

  ${
    $d x H $.
    $( The set of vectors belonging to the subspace of a projection.  Part of
       Theorem 26.2 of [Halmos] p. 44.  (Contributed by NM, 11-Apr-2006.)
       (New usage is discouraged.) $)
    pjvec $p |- ( H e. CH -> H = { x e. ~H | ( ( projh ` H ) ` x ) = x } ) $=
      ( cch wcel chil cin cv cpjh cfv wceq crab wss chss sseqin2 pjch rabbi2dva
      sylib eqtr3d ) BCDZEBFZBAGZBHIIUAJZAEKSBELTBJBMBENQSUBAEBUABOPR $.

    $( The set of vectors belonging to the orthocomplemented subspace of a
       projection.  Second part of Theorem 27.3 of [Halmos] p. 45.
       (Contributed by NM, 24-Apr-2006.)  (New usage is discouraged.) $)
    pjocvec $p |- ( H e. CH -> ( _|_ ` H ) =
                   { x e. ~H | ( ( projh ` H ) ` x ) = 0h } ) $=
      ( cch wcel chil cort cfv cin cv cpjh c0v wceq crab wss choccl syl sseqin2
      chss sylib pjoc2 rabbi2dva eqtr3d ) BCDZEBFGZHZUDAIZBJGGKLZAEMUCUDENZUEUD
      LUCUDCDUHBOUDRPUDEQSUCUGAEUDUFBTUAUB $.
  $}

  ${
    pjocin.1 $e |- G e. CH $.
    pjocin.2 $e |- H e. CH $.
    $( Membership of projection in orthocomplement of intersection.
       (Contributed by NM, 21-Apr-2001.)  (New usage is discouraged.) $)
    pjocini $p |- ( A e. ( _|_ ` ( G i^i H ) ) ->
                 ( ( projh ` G ) ` A ) e. ( _|_ ` ( G i^i H ) ) ) $=
      ( cin cort cfv wcel cpjh cmv cch chil wceq chincli choccli cheli pjpo wss
      co sylancr inss1 chsscon3i mpbi pjcli syl sseldi csh chshii shsubcl mpdan
      mp3an1 eqeltrd ) ABCFZGHZIZABJHHZAABGHZJHHZKTZUOUPBLIAMIZUQUTNDAUOUNBCDEO
      ZPZQZABRUAUPUSUOIZUTUOIZUPURUOUSUNBSURUOSBCUBUNBVBDUCUDUPVAUSURIVDAURBDPU
      EUFUGUOUHIUPVEVFUOVCUIAUSUOUJULUKUM $.

    $( Membership of projection in an intersection.  (Contributed by NM,
       22-Apr-2001.)  (New usage is discouraged.) $)
    pjini $p |- ( A e. ( G i^i H ) ->
                 ( ( projh ` G ) ` A ) e. ( G i^i H ) ) $=
      ( cin wcel cpjh cfv cch wceq inss1 sseli pjid sylancr eleq1d ibir ) ABCFZ
      GZABHIIZRGSTARSBJGABGTAKDRBABCLMABNOPQ $.
  $}

  ${
    $d x y z w G $.  $d x y z w H $.
    pjjs.1 $e |- G e. CH $.
    pjjs.2 $e |- H e. SH $.
    $( A sufficient condition for subspace join to be equal to subspace sum.
       (Contributed by NM, 29-May-2004.)  (New usage is discouraged.) $)
    pjjsi $p |- ( A. x e. ( G vH H ) ( ( projh ` ( _|_ ` G ) ) ` x ) e. H ->
               ( G vH H ) = ( G +H H ) ) $=
      ( vw vy vz cv cort cfv cpjh wcel co wss wa wceq cva wrex sylibr chj fveq2
      wral cph eleq1d rspcv chil chshii shjcli cheli pjcli anim1i axpjpj adantr
      cch mpan jca sylan rspceov 3expa shseli ex syld com12 ssrdv shsleji jctir
      syl eqss ) AIZBJKLKZKZCMZABCUANZUCZVNBCUDNZOZVPVNOZPVNVPQVOVQVRVOFVNVPFIZ
      VNMZVOVSVPMZVTVOVSVKKZCMZWAVMWCAVSVNVJVSQVLWBCVJVSVKUBUEUFVTWCWAVTWCPZVSG
      IHIRNQHCSGBSZWAWDVSBLKKZBMZWCPZVSWFWBRNQZPZWEVTVSUGMZWCWJVSVNBCBDUHZEUIUJ
      WKWCPWHWIWKWGWCVSBDUKULWKWIWCBUOMWKWIDVSBUMUPUNUQURWGWCWIWEGHBCWFWBVSRUSU
      TVHGHBCVSWLEVATVBVCVDVEBCWLEVFVGVNVPVIT $.
  $}

  ${
    $d x y z H $.
    pjfn.1 $e |- H e. CH $.
    $( Functionality of a projection.  (Contributed by NM, 30-Oct-1999.)
       (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    pjfni $p |- ( projh ` H ) Fn ~H $=
      ( vx vy vz chil cv cva wceq cort cfv wrex crio cpjh riotaex cch wcel cmpt
      co pjhfval ax-mp fnmpti ) CFCGDGEGHSIEAJKLZDAMZANKZUCDAOAPQUECFUDRIBCEDAT
      UAUB $.

    $( The range of a projection.  Part of Theorem 26.2 of [Halmos] p. 44.
       (Contributed by NM, 30-Oct-1999.)  (Revised by Mario Carneiro,
       10-Sep-2015.)  (New usage is discouraged.) $)
    pjrni $p |- ran ( projh ` H ) = H $=
      ( vx vy cpjh cfv crn chil wf wss wfn wcel wral pjfni pjcli ffnfv mpbir2an
      cv rgen frn ax-mp cch wceq pjid mpan cheli fnfvelrn eqeltrrd ssriv eqssi
      sylancr ) AEFZGZAHAULIZUMAJUNULHKZCRZULFALZCHMABNZUQCHUPABOSCHAULPQHAULTU
      ADAUMDRZALZUSULFZUSUMAUBLUTVAUSUCBUSAUDUEUTUOUSHLVAUMLURUSABUFHUSULUGUKUH
      UIUJ $.

    $( A projection maps onto its subspace.  (Contributed by NM, 24-Apr-2006.)
       (New usage is discouraged.) $)
    pjfoi $p |- ( projh ` H ) : ~H -onto-> H $=
      ( chil cpjh cfv wfo wfn crn wceq pjfni pjrni df-fo mpbir2an ) CAADEZFNCGN
      HAIABJABKCANLM $.

    $( The mapping of a projection.  (Contributed by NM, 11-Nov-2000.)
       (New usage is discouraged.) $)
    pjfi $p |- ( projh ` H ) : ~H --> ~H $=
      ( chil cpjh cfv wf wfn crn wss pjfni pjrni chssii eqsstri df-f mpbir2an )
      CCADEZFPCGPHZCIABJQACABKABLMCCPNO $.

    $( The value of a projection in terms of components.  (Contributed by NM,
       28-Nov-2000.)  (New usage is discouraged.) $)
    pjvi $p |- ( ( A e. H /\ B e. ( _|_ ` H ) ) ->
               ( ( projh ` H ) ` ( A +h B ) ) = A ) $=
      ( pjcompi ) ABCDE $.
  $}

  $( A projection maps onto its subspace.  (Contributed by NM, 24-Apr-2006.)
     (New usage is discouraged.) $)
  pjhfo $p |- ( H e. CH -> ( projh ` H ) : ~H -onto-> H ) $=
    ( cch wcel chil cpjh cfv wfo c0h cif wb fveq2 foeq1 syl foeq3 h0elch elimel
    wceq pjfoi dedth2v ) ABCZDAAEFZGZDATAHIZEFZGZDUCUDGAAHHAUCQUAUDQUBUEJAUCEKD
    AUAUDLMAUCDUDNUCAHBOPRS $.

  $( The range of a projection.  Part of Theorem 26.2 of [Halmos] p. 44.
     (Contributed by NM, 24-Apr-2006.)  (New usage is discouraged.) $)
  pjrn $p |- ( H e. CH -> ran ( projh ` H ) = H ) $=
    ( cch wcel chil cpjh cfv wfo crn wceq pjhfo forn syl ) ABCDAAEFZGMHAIAJDAMK
    L $.

  $( The mapping of a projection.  (Contributed by NM, 24-Apr-2006.)
     (New usage is discouraged.) $)
  pjhf $p |- ( H e. CH -> ( projh ` H ) : ~H --> ~H ) $=
    ( cch wcel chil cpjh cfv wf wss wfo pjhfo fof syl chss fss syl2anc ) ABCZDA
    AEFZGZADHDDQGPDAQIRAJDAQKLAMDADQNO $.

  $( Functionality of a projection.  (Contributed by NM, 30-May-2006.)
     (New usage is discouraged.) $)
  pjfn $p |- ( H e. CH -> ( projh ` H ) Fn ~H ) $=
    ( cch wcel chil cpjh cfv wf wfn pjhf ffn syl ) ABCDDAEFZGLDHAIDDLJK $.

  ${
    pjsumt.1 $e |- G e. CH $.
    pjsumt.2 $e |- H e. CH $.
    $( The projection on a subspace sum is the sum of the projections.
       (Contributed by NM, 11-Nov-2000.)  (New usage is discouraged.) $)
    pjsumi $p |- ( A e. ~H ->
            ( G C_ ( _|_ ` H ) -> ( ( projh ` ( G +H H ) ) ` A ) =
            ( ( ( projh ` G ) ` A ) +h ( ( projh ` H ) ` A ) ) ) ) $=
      ( chil wcel cort cfv wss cph co cpjh cva wceq wa chj osumi fveq2d cch imp
      fveq1d adantl wi pjcjt2 mp3an12 eqtrd ex ) AFGZBCHIJZABCKLZMIZIZABMIIACMI
      INLZOUIUJPUMABCQLZMIZIZUNUJUMUQOUIUJAULUPUJUKUOMBCDERSUBUCUIUJUQUNOZBTGCT
      GUIUJURUDDEACBUEUFUAUGUH $.

    $( One-to-one correspondence of projection and subspace.  (Contributed by
       NM, 26-Nov-2000.)  (New usage is discouraged.) $)
    pj11i $p |- ( ( projh ` G ) = ( projh ` H ) <-> G = H ) $=
      ( cpjh cfv wceq crn rneq pjrni 3eqtr3g fveq2 impbii ) AEFZBEFZGZABGPNHOHA
      BNOIACJBDJKABELM $.

    $( Vector decomposition into sum of projections on orthogonal subspaces.
       (Contributed by NM, 21-Jun-2006.)  (New usage is discouraged.) $)
    pjdsi $p |- ( ( A e. ( G vH H ) /\ G C_ ( _|_ ` H ) ) ->
               A = ( ( ( projh ` G ) ` A ) +h ( ( projh ` H ) ` A ) ) ) $=
      ( chj co wcel cort cfv wss wa cph cpjh cva osumi fveq2d fveq1d cch wceq
      chjcli pjid mpan sylan9eqr chil cheli pjsumi imp sylan eqtr3d ) ABCFGZHZB
      CIJKZLABCMGZNJZJZAABNJJACNJJOGZUMULUPAUKNJZJZAUMAUOURUMUNUKNBCDEPQRUKSHUL
      USATBCDEUAZAUKUBUCUDULAUEHZUMUPUQTZAUKUTUFVAUMVBABCDEUGUHUIUJ $.
  $}

  ${
    pjds3.1 $e |- F e. CH $.
    pjds3.2 $e |- G e. CH $.
    pjds3.3 $e |- H e. CH $.
    $( Vector decomposition into sum of projections on orthogonal subspaces.
       (Contributed by NM, 22-Jun-2006.)  (New usage is discouraged.) $)
    pjds3i $p |- ( ( ( A e. ( ( F vH G ) vH H ) /\ F C_ ( _|_ ` G ) ) /\
     ( F C_ ( _|_ ` H ) /\ G C_ ( _|_ ` H ) ) ) -> A = ( ( ( ( projh ` F ) ` A
        )
                +h ( ( projh ` G ) ` A ) ) +h ( ( projh ` H ) ` A ) ) ) $=
      ( chj co wcel cort cfv wss wa cpjh cva cph wceq chjcli oveq1d simpl pjdsi
      choccli chlubii syl2an osumi fveq2d fveq1d ad2antlr chil cheli pjsumi imp
      sylan adantr 3eqtr2d ) ABCHIZDHIZJZBCKLMZNZBDKLZMCVBMNZNAAUQOLZLZADOLLZPI
      ZABCQIZOLZLZVFPIZABOLLACOLLPIZVFPIZVAUSUQVBMAVGRVCUSUTUABCVBEFDGUCUDAUQDB
      CEFSZGUBUEUTVKVGRUSVCUTVJVEVFPUTAVIVDUTVHUQOBCEFUFUGUHTUIVAVKVMRVCVAVJVLV
      FPUSAUJJZUTVJVLRZAURUQDVNGSUKVOUTVPABCEFULUMUNTUOUP $.
  $}

  $( One-to-one correspondence of projection and subspace.  (Contributed by NM,
     24-Apr-2006.)  (New usage is discouraged.) $)
  pj11 $p |- ( ( G e. CH /\ H e. CH ) ->
              ( ( projh ` G ) = ( projh ` H ) <-> G = H ) ) $=
    ( cch wcel cpjh cfv wceq wb c0h cif fveq2 eqeq1d eqeq1 bibi12d eqeq2d eqeq2
    h0elch elimel pj11i dedth2h ) ACDZBCDZAEFZBEFZGZABGZHUAAIJZEFZUDGZUGBGZHUHU
    BBIJZEFZGZUGUKGZHABIIAUGGZUEUIUFUJUOUCUHUDAUGEKLAUGBMNBUKGZUIUMUJUNUPUDULUH
    BUKEKOBUKUGPNUGUKAICQRBICQRST $.

  ${
    $d h x y z $.
    $( Functionality of the projection function.  (Contributed by NM,
       24-Apr-2006.)  (New usage is discouraged.) $)
    pjmfn $p |- projh Fn CH $=
      ( vh vx vz vy cch chil cv cva wceq cort cfv wrex crio cmpt ax-hilex mptex
      co cpjh df-pjh fnmpti ) AEBFBGCGDGHQIDAGZJKLCUAMZNRBFUBOPBDCAST $.

    $( The projector function maps one-to-one into the set of Hilbert space
       operators.  (Contributed by NM, 24-Apr-2006.)
       (New usage is discouraged.) $)
    pjmf1 $p |- projh : CH -1-1-> ( ~H ^m ~H ) $=
      ( vx vy cch chil cmap co cpjh wf1 wf cv cfv wceq wral wfn wcel pjmfn pjhf
      wi ax-hilex mpbir2an elmap sylibr rgen ffnfv wa pj11 biimpd rgen2a dff13
      ) CDDEFZGHCUJGIZAJZGKZBJZGKLZULUNLZRZBCMACMUKGCNUMUJOZACMPURACULCOZDDUMIU
      RULQDDUMSSUAUBUCACUJGUDTUQABCUSUNCOUEUOUPULUNUFUGUHABCUJGUIT $.
  $}

  $( The inner product of projections on orthogonal subspaces vanishes.
     (Contributed by NM, 30-Jun-2006.)  (New usage is discouraged.) $)
  pjoi0 $p |- ( ( ( G e. CH /\ H e. CH /\ A e. ~H ) /\ G C_ ( _|_ ` H ) ) ->
               ( ( ( projh ` G ) ` A ) .ih ( ( projh ` H ) ` A ) ) = 0 ) $=
    ( cch wcel chil w3a cort cfv wss cpjh crn wceq wa pjrn adantr pjfn fnfvelrn
    wfn sylan csp co cc0 fveq2d adantl sseq12d biimpar 3adantl3 id eqeltrd chsh
    csh syl 3ad2ant2 simpr 3adant2 3adant1 jca shorth syl3c syldan ) BDEZCDEZAF
    EZGZBCHIZJZBKIZLZCKIZLZHIZJZAVHIZAVJIZUAUBUCMZVBVCVGVMVDVBVCNZVMVGVQVIBVLVF
    VBVIBMVCBOPVCVLVFMVBVCVKCHCOZUDUEUFUGUHVEVMNVKULEZVMVNVIEZVOVKEZNZVPVEVSVMV
    CVBVSVDVCVKDEVSVCVKCDVRVCUIUJVKUKUMUNPVEVMUOVEWBVMVEVTWAVBVDVTVCVBVHFSVDVTB
    QFAVHRTUPVCVDWAVBVCVJFSVDWACQFAVJRTUQURPVNVOVIVKUSUTVA $.

  ${
    pjoi0.1 $e |- G e. CH $.
    pjoi0.2 $e |- H e. CH $.
    pjoi0.3 $e |- A e. ~H $.
    $( The inner product of projections on orthogonal subspaces vanishes.
       (Contributed by NM, 1-Nov-1999.)  (New usage is discouraged.) $)
    pjoi0i $p |- ( G C_ ( _|_ ` H ) ->
                ( ( ( projh ` G ) ` A ) .ih ( ( projh ` H ) ` A ) ) = 0 ) $=
      ( cch wcel chil w3a cort cfv wss cpjh csp co cc0 wceq 3pm3.2i pjoi0 mpan
      ) BGHZCGHZAIHZJBCKLMABNLLACNLLOPQRUBUCUDDEFSABCTUA $.

    $( Pythagorean theorem for projections on orthogonal subspaces.
       (Contributed by NM, 1-Nov-1999.)  (New usage is discouraged.) $)
    pjopythi $p |- ( G C_ ( _|_ ` H ) ->
       ( ( normh ` ( ( ( projh ` G ) ` A ) +h ( ( projh ` H ) ` A ) ) ) ^ 2 ) =
                 ( ( ( normh ` ( ( projh ` G ) ` A ) ) ^ 2 ) +
                   ( ( normh ` ( ( projh ` H ) ` A ) ) ^ 2 ) ) ) $=
      ( cort cfv wss cpjh csp co cc0 wceq cva cno c2 cexp caddc pjhclii pjoi0i
      normpythi syl ) BCGHIABJHHZACJHHZKLMNUDUEOLPHQRLUDPHQRLUEPHQRLSLNABCDEFUA
      UDUEABDFTACEFTUBUC $.
  $}

  $( Pythagorean theorem for projections on orthogonal subspaces.  (Contributed
     by NM, 2-Nov-1999.)  (New usage is discouraged.) $)
  pjopyth $p |- ( ( H e. CH /\ G e. CH /\ A e. ~H ) -> ( H C_ ( _|_ ` G ) ->
       ( ( normh ` ( ( ( projh ` H ) ` A ) +h ( ( projh ` G ) ` A ) ) ) ^ 2 ) =
                 ( ( ( normh ` ( ( projh ` H ) ` A ) ) ^ 2 ) +
                   ( ( normh ` ( ( projh ` G ) ` A ) ) ^ 2 ) ) ) ) $=
    ( cch wcel chil cort cfv cpjh cva co cno c2 cexp caddc wceq wi fveq2 oveq1d
    fveq2d wss cif c0v sseq1 fveq1d eqeq12d imbi12d sseq2d oveq2d oveq12d helch
    imbi2d elimel ax-hv0cl pjopythi dedth3h ) CDEZBDEZAFEZCBGHZUAZACIHZHZABIHZH
    ZJKZLHZMNKZVCLHZMNKZVELHZMNKZOKZPZQUQCFUBZUTUAZAVOIHZHZVEJKZLHZMNKZVRLHZMNK
    ZVLOKZPZQVOURBFUBZGHZUAZVRAWFIHZHZJKZLHZMNKZWCWJLHZMNKZOKZPZQWHUSAUCUBZVQHZ
    WRWIHZJKZLHZMNKZWSLHZMNKZWTLHZMNKZOKZPZQCBAFFUCCVOPZVAVPVNWECVOUTUDXJVHWAVM
    WDXJVGVTMNXJVFVSLXJVCVRVEJXJAVBVQCVOIRUEZSTSXJVJWCVLOXJVIWBMNXJVCVRLXKTSSUF
    UGBWFPZVPWHWEWQXLUTWGVOBWFGRUHXLWAWMWDWPXLVTWLMNXLVSWKLXLVEWJVRJXLAVDWIBWFI
    RUEZUITSXLVLWOWCOXLVKWNMNXLVEWJLXMTSUIUFUGAWRPZWQXIWHXNWMXCWPXHXNWLXBMNXNWK
    XALXNVRWSWJWTJAWRVQRZAWRWIRZUJTSXNWCXEWOXGOXNWBXDMNXNVRWSLXOTSXNWNXFMNXNWJW
    TLXPTSUJUFULWRVOWFCFDUKUMBFDUKUMAUCFUNUMUOUP $.

  ${
    pjnorm.1 $e |- H e. CH $.
    pjnorm.2 $e |- A e. ~H $.
    $( The norm of the projection is less than or equal to the norm.
       (Contributed by NM, 27-Oct-1999.)  (New usage is discouraged.) $)
    pjnormi $p |- ( normh ` ( ( projh ` H ) ` A ) ) <_ ( normh ` A ) $=
      ( cpjh cfv cno cort cva co cle chil wcel csp cc0 wceq wbr pjhclii choccli
      wa pm3.2i cch pjorthi ax-mp normpyc mp2 pjpji fveq2i breqtrri ) ABEFFZGFZ
      UJABHFZEFFZIJZGFZAGFKUJLMZUMLMZTUJUMNJOPZUKUOKQUPUQABCDRAULBCSDRUABUBMURC
      AABDDUCUDUJUMUEUFAUNGABCDUGUHUI $.

    $( Pythagorean theorem for projections.  (Contributed by NM, 27-Oct-1999.)
       (New usage is discouraged.) $)
    pjpythi $p |- ( ( normh ` A ) ^ 2 ) =
                 ( ( ( normh ` ( ( projh ` H ) ` A ) ) ^ 2 ) +
                   ( ( normh ` ( ( projh ` ( _|_ ` H ) ) ` A ) ) ^ 2 ) ) $=
      ( cno cfv c2 cexp co cpjh cort cva caddc pjpji fveq2i oveq1i csh wcel wss
      wceq chshii shococss choccli pjopythi mp2b eqtri ) AEFZGHIABJFFZABKFZJFFZ
      LIZEFZGHIZUHEFGHIUJEFGHIMIZUGULGHAUKEABCDNOPBQRBUIKFSUMUNTBCUABUBABUICBCU
      CDUDUEUF $.

    $( If a vector does not belong to subspace, the norm of its projection is
       less than its norm.  (Contributed by NM, 27-Oct-1999.)
       (New usage is discouraged.) $)
    pjneli $p |- ( -. A e. H <->
                ( normh ` ( ( projh ` H ) ` A ) ) < ( normh ` A ) ) $=
      ( cno cfv cpjh cle wbr wcel wceq c2 cexp caddc normcli chil normge0 ax-mp
      co cc0 wne wa wn clt pjnormi biantrur cort c0v pjoc1i pjpythi sq0 pjhclii
      oveq2i resqcli recni addid1i eqtr2i eqeq12i choccli sqcli addcani wb 0le0
      0cn 0re sq11i mp2an norm-i-i 3bitri bitr2i necon3bbii ltleni 3bitr4i ) AE
      FZABGFFZEFZUAZVPVNHIZVQUBABJZUCVPVNUDIVRVQABCDUEUFVSVNVPVSABUGFZGFFZUHKZV
      NLMSZVPLMSZKZVNVPKZABCDUIWEWDWAEFZLMSZNSZWDTLMSZNSZKZWBWCWIWDWKABCDUJWKWD
      TNSWDWJTWDNUKUMWDWDVPVOABCDULZOZUNUOZUPUQURWLWHWJKZWGTKZWBWDWHWJWOWHWGWAA
      VTBCUSDULZOZUNUOTVDUTVATWGHIZTTHIWPWQVBWAPJWTWRWAQRVCWGTWSVEVFVGWAWRVHVIV
      JTVNHIZTVPHIZWEWFVBAPJXADAQRVOPJXBWMVOQRVNVPADOZWNVFVGVIVKVPVNWNXCVLVM $.
  $}

  $( The norm of the projection is less than or equal to the norm.
     (Contributed by NM, 28-Oct-1999.)  (New usage is discouraged.) $)
  pjnorm $p |- ( ( H e. CH /\ A e. ~H ) ->
                ( normh ` ( ( projh ` H ) ` A ) ) <_ ( normh ` A ) ) $=
    ( cch wcel chil cpjh cfv cno cle wbr cif fveq2 fveq1d fveq2d breq1d breq12d
    c0v wceq helch elimel ax-hv0cl pjnormi dedth2h ) BCDZAEDZABFGZGZHGZAHGZIJAU
    DBEKZFGZGZHGZUIIJUEAQKZUKGZHGZUNHGZIJBAEQBUJRZUHUMUIIURUGULHURAUFUKBUJFLMNO
    AUNRZUMUPUIUQIUSULUOHAUNUKLNAUNHLPUNUJBECSTAQEUATUBUC $.

  $( Pythagorean theorem for projectors.  (Contributed by NM, 11-Apr-2006.)
     (New usage is discouraged.) $)
  pjpyth $p |- ( ( H e. CH /\ A e. ~H ) -> ( ( normh ` A ) ^ 2 ) =
               ( ( ( normh ` ( ( projh ` H ) ` A ) ) ^ 2 ) +
                 ( ( normh ` ( ( projh ` ( _|_ ` H ) ) ` A ) ) ^ 2 ) ) ) $=
    ( cch wcel chil cno cfv c2 cexp co cpjh cort caddc wceq fveq2 fveq1d fveq2d
    cif c0v oveq1d oveq12d eqeq2d eqeq12d helch elimel ax-hv0cl pjpythi dedth2h
    ) BCDZAEDZAFGZHIJZABKGZGZFGZHIJZABLGZKGZGZFGZHIJZMJZNULAUIBERZKGZGZFGZHIJZA
    VCLGZKGZGZFGZHIJZMJZNUJASRZFGZHIJZVNVDGZFGZHIJZVNVIGZFGZHIJZMJZNBAESBVCNZVB
    VMULWDUPVGVAVLMWDUOVFHIWDUNVEFWDAUMVDBVCKOPQTWDUTVKHIWDUSVJFWDAURVIWDUQVHKB
    VCLOQPQTUAUBAVNNZULVPVMWCWEUKVOHIAVNFOTWEVGVSVLWBMWEVFVRHIWEVEVQFAVNVDOQTWE
    VKWAHIWEVJVTFAVNVIOQTUAUCVNVCBECUDUEASEUFUEUGUH $.

  $( If a vector does not belong to subspace, the norm of its projection is
     less than its norm.  (Contributed by NM, 2-Nov-1999.)
     (New usage is discouraged.) $)
  pjnel $p |- ( ( H e. CH /\ A e. ~H ) -> ( -. A e. H <->
              ( normh ` ( ( projh ` H ) ` A ) ) < ( normh ` A ) ) ) $=
    ( cch wcel chil wn cpjh cfv cno clt wbr wb cif c0v wceq notbid fveq2 fveq2d
    bibi12d elimel eleq2 fveq1d breq1d eleq1 breq12d ax-hv0cl pjneli dedth2h
    helch ) BCDZAEDZABDZFZABGHZHZIHZAIHZJKZLAUJBEMZDZFZAUSGHZHZIHZUQJKZLUKANMZU
    SDZFZVFVBHZIHZVFIHZJKZLBAENBUSOZUMVAURVEVMULUTBUSAUAPVMUPVDUQJVMUOVCIVMAUNV
    BBUSGQUBRUCSAVFOZVAVHVEVLVNUTVGAVFUSUDPVNVDVJUQVKJVNVCVIIAVFVBQRAVFIQUESVFU
    SBECUITANEUFTUGUH $.

  $( A vector belongs to the subspace of a projection iff the norm of its
     projection equals its norm.  This and ~ pjch yield Theorem 26.3 of
     [Halmos] p. 44.  (Contributed by NM, 7-Apr-2001.)
     (New usage is discouraged.) $)
  pjnorm2 $p |- ( ( H e. CH /\ A e. ~H ) -> ( A e. H <->
              ( normh ` ( ( projh ` H ) ` A ) ) = ( normh ` A ) ) ) $=
    ( cch wcel chil wa cpjh cfv cno wceq cle wbr clt wn pjhcl normcl syl adantl
    cr eqleltd pjnorm biantrurd pjnel con1bid 3bitr2rd ) BCDZAEDZFZABGHHZIHZAIH
    ZJUJUKKLZUJUKMLZNZFUNABDZUHUJUKUHUIEDUJSDABOUIPQUGUKSDUFAPRTUHULUNABUAUBUHU
    OUMABUCUDUE $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Mayet's equation E_3
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x B $.  $d x D $.  $d x G $.  $d x X $.  $d x Y $.
    mayete3.a $e |- A e. CH $.
    mayete3.b $e |- B e. CH $.
    mayete3.c $e |- C e. CH $.
    mayete3.d $e |- D e. CH $.
    mayete3.f $e |- F e. CH $.
    mayete3.g $e |- G e. CH $.
    mayete3.ac $e |- A C_ ( _|_ ` C ) $.
    mayete3.af $e |- A C_ ( _|_ ` F ) $.
    mayete3.cf $e |- C C_ ( _|_ ` F ) $.
    mayete3.ab $e |- A C_ ( _|_ ` B ) $.
    mayete3.cd $e |- C C_ ( _|_ ` D ) $.
    mayete3.fg $e |- F C_ ( _|_ ` G ) $.
    mayete3.x $e |- X = ( ( A vH C ) vH F ) $.
    mayete3.y $e |- Y = ( ( ( A vH B ) i^i ( C vH D ) ) i^i ( F vH G ) ) $.
    mayete3.z $e |- Z = ( ( B vH D ) vH G ) $.
    $( Mayet's equation E_3.  Part of Theorem 4.1 of [Mayet3] p. 1223.
       (Contributed by NM, 22-Jun-2006.)  (New usage is discouraged.) $)
    mayete3i $p |- ( X i^i Y ) C_ Z $=
      ( vx cin chj co cph cv wcel c1 c2 cdiv csm chil wceq wa elin chjcli cheli
      eleq2s adantr sylbi ax-hvmulid cmul cc0 wne 2cn 2ne0 recid2 oveq1i reccli
      cc mp2an ax-hvmulass mp3an12 syl5eqr eqtr3d syl cpjh cfv cva cmv hv2times
      oveq1d inss2 sseli elin2 cort pjdsi mpan2 oveqan12d inss1 pjhcli syl22anc
      hvadd4 3syl eqtrd hvaddcl syl2anc 3eqtrd syl6eleq mpanr12 sylancl oveq12d
      pjds3i hvmulcl mpan hvpncan mpancom hvpncan2 chshii shsvai shscli eqeltrd
      wss pjcli csh shmulcl ssriv chsleji shlessi ax-mp sstri sseqtr4i ) GHUFZB
      DUGUHZFUGUHZIYGYHFUIUHZYIYGBDUIUHZFUIUHZYJUEYGYLUEUJZYGUKZYMULUMUNUHZUMYM
      UOUHZUOUHZYLYNYMUPUKZYMYQUQYNYMGUKZYMHUKZURYRYMGHUSYSYRYTYRYMACUGUHZEUGUH
      ZGYMUUBUUAEACJLUTNUTVAUBVBVCVDZYRULYMUOUHZYMYQYMVEYRUUDYOUMVFUHZYMUOUHZYQ
      UUEULYMUOUMVNUKZUMVGVHUUEULUQVIVJUMVKVOVLYOVNUKZUUGYRUUFYQUQUMVIVJVMZVIYO
      UMYMVPVQVRVSVTYNYPYLUKZYQYLUKZYNYPYMBWAWBWBZYMDWAWBWBZWCUHZYMFWAWBWBZWCUH
      ZYLYNYMAWAWBWBZYMCWAWBWBZWCUHZYMEWAWBWBZWCUHZUUPWCUHZUVAWDUHZYPUUPYNYPYMW
      CUHZYMWDUHZUVCYPYNUVDUVBYMUVAWDYNUVDYMYMWCUHZYMWCUHZUUSUUNWCUHZUUTUUOWCUH
      ZWCUHZUVBYNYRUVDUVGUQUUCYRYPUVFYMWCYMWEWFVTYNYTUVGUVJUQZYGHYMGHWGWHYTYMAB
      UGUHZCDUGUHZUFZUKZYMEFUGUHZUKZURUVKYMUVNUVPHUCWIUVOUVQUVFUVHYMUVIWCUVOUVF
      UUQUULWCUHZUURUUMWCUHZWCUHZUVHUVOYMUVLUKZYMUVMUKZURUVFUVTUQYMUVLUVMUSUWAU
      WBYMUVRYMUVSWCUWAABWJWBXQYMUVRUQSYMABJKWKWLUWBCDWJWBXQYMUVSUQTYMCDLMWKWLW
      MVDUVOUWAYRUVTUVHUQZUVNUVLYMUVLUVMWNWHYMUVLABJKUTVAYRUUQUPUKZUULUPUKZUURU
      PUKZUUMUPUKZUWCYMAJWOZYMBKWOZYMCLWOZYMDMWOZUUQUULUURUUMWQWPWRWSUVQEFWJWBX
      QYMUVIUQUAYMEFNOWKWLWMVDVTYNYRUVJUVBUQZUUCYRUUSUPUKZUUNUPUKZUUTUPUKZUUOUP
      UKZUWLYRUWDUWFUWMUWHUWJUUQUURWTXAZYRUWEUWGUWNUWIUWKUULUUMWTXAZYMENWOZYMFO
      WOZUUSUUNUUTUUOWQWPVTXBYNYMUUBUKZACWJWBXQZYMUVAUQZYNYMGUUBYGGYMGHWNWHUBXC
      PUXAUXBURAEWJWBZXQCUXDXQUXCQRYMACEJLNXGXDXEXFYNYRUVEYPUQZUUCYPUPUKZYRUXEU
      UGYRUXFVIUMYMXHXIYPYMXJXKVTVSYNYRUVCUUPUQZUUCYRUVAUPUKZUUPUPUKZUXGYRUWMUW
      OUXHUWQUWSUUSUUTWTXAYRUWNUWPUXIUWRUWTUUNUUOWTXAUVAUUPXLXAVTVSYNYRUUPYLUKZ
      UUCYRUUNYKUKZUUOFUKUXJYRUULBUKUUMDUKUXKYMBKXRYMDMXRBDUULUUMBKXMZDMXMZXNXA
      YMFOXRYKFUUNUUOBDUXLUXMXOZFOXMZXNXAVTXPYLXSUKUUHUUJUUKYKFUXNUXOXOUUIYOYPY
      LXTVQVTXPYAYKYHXQYLYJXQBDKMYBYKYHFUXNYHBDKMUTZXMUXOYCYDYEYHFUXPOYBYEUDYF
      $.
  $}

  ${
    $d x D $.  $d x F $.  $d x G $.  $d x R $.  $d x S $.
    mayete3OLD.1 $e |- A e. CH $.
    mayete3OLD.2 $e |- B e. CH $.
    mayete3OLD.3 $e |- C e. CH $.
    mayete3OLD.4 $e |- D e. CH $.
    mayete3OLD.5 $e |- F e. CH $.
    mayete3OLD.6 $e |- G e. CH $.
    mayete3OLD.7 $e |- A C_ ( _|_ ` B ) $.
    mayete3OLD.8 $e |- A C_ ( _|_ ` C ) $.
    mayete3OLD.9 $e |- B C_ ( _|_ ` C ) $.
    mayete3OLD.10 $e |- A C_ ( _|_ ` D ) $.
    mayete3OLD.11 $e |- B C_ ( _|_ ` F ) $.
    mayete3OLD.12 $e |- C C_ ( _|_ ` G ) $.
    mayete3OLD.13 $e |- R = ( ( A vH B ) vH C ) $.
    mayete3OLD.14 $e |- S = ( ( ( A vH D ) i^i ( B vH F ) ) i^i ( C vH G ) ) $.
    mayete3OLD.15 $e |- T = ( ( D vH F ) vH G ) $.
    $( Mayet's equation E_3.  Part of Theorem 4.1 of [Mayet3] p. 7.
       (Contributed by NM, 22-Jun-2006.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    mayete3iOLD $p |- ( R i^i S ) C_ T $=
      ( vx cin chj co cph cv wcel c1 c2 cdiv csm chil wceq wa elin eleq2i cheli
      chjcli sylbi adantr ax-hvmulid cmul cc0 wne 2cn 2ne0 recid2 oveq1i reccli
      cc mp2an ax-hvmulass mp3an12 syl5eqr eqtr3d syl cpjh cfv cva cmv hv2times
      oveq1d inss2 sseli bitri cort pjdsi mpan2 oveqan12d inss1 pjhcli syl22anc
      wss hvadd4 hvaddcl syl2anc 3eqtrd syl6eleq pjds3i mpanr12 oveq12d hvmulcl
      eqtrd hvpncan mpancom hvpncan2 3eqtr3d pjcli chshii shsvai shscli eqeltrd
      mpan csh wi shmulclOLD ax-mp ssriv chsleji shlessi sstri sseqtr4i ) EFUFZ
      DHUGUHZIUGUHZGYGYHIUIUHZYIYGDHUIUHZIUIUHZYJUEYGYLUEUJZYGUKZYMULUMUNUHZUMY
      MUOUHZUOUHZYLYNYMUPUKZYMYQUQYNYMEUKZYMFUKZURYRYMEFUSYSYRYTYSYMABUGUHZCUGU
      HZUKZYREUUBYMUBUTYMUUBUUACABJKVBLVBVAVCVDVCZYRULYMUOUHZYMYQYMVEYRUUEYOUMV
      FUHZYMUOUHZYQUUFULYMUOUMVNUKZUMVGVHUUFULUQVIVJUMVKVOVLYOVNUKZUUHYRUUGYQUQ
      UMVIVJVMZVIYOUMYMVPVQVRVSVTYNYPYLUKZYQYLUKZYNYPYMDWAWBWBZYMHWAWBWBZWCUHZY
      MIWAWBWBZWCUHZYLYNYPYMWCUHZYMWDUHZYMAWAWBWBZYMBWAWBWBZWCUHZYMCWAWBWBZWCUH
      ZUUQWCUHZUVDWDUHZYPUUQYNUURUVEYMUVDWDYNUURYMYMWCUHZYMWCUHZUVBUUOWCUHZUVCU
      UPWCUHZWCUHZUVEYNYRUURUVHUQUUDYRYPUVGYMWCYMWEWFVTYNYTUVHUVKUQZYGFYMEFWGWH
      YTYMADUGUHZBHUGUHZUFZUKZYMCIUGUHZUKZURZUVLYTYMUVOUVQUFZUKUVSFUVTYMUCUTYMU
      VOUVQUSWIUVPUVRUVGUVIYMUVJWCUVPUVGUUTUUMWCUHZUVAUUNWCUHZWCUHZUVIUVPYMUVMU
      KZYMUVNUKZURUVGUWCUQYMUVMUVNUSUWDUWEYMUWAYMUWBWCUWDADWJWBWQYMUWAUQSYMADJM
      WKWLUWEBHWJWBWQYMUWBUQTYMBHKNWKWLWMVCUVPYRUWCUVIUQZUVPUWDYRUVOUVMYMUVMUVN
      WNWHYMUVMADJMVBVAVTYRUUTUPUKZUUMUPUKZUVAUPUKZUUNUPUKZUWFYMAJWOZYMDMWOZYMB
      KWOZYMHNWOZUUTUUMUVAUUNWRWPVTXGUVRCIWJWBWQYMUVJUQUAYMCILOWKWLWMVCVTYNYRUV
      KUVEUQZUUDYRUVBUPUKZUUOUPUKZUVCUPUKZUUPUPUKZUWOYRUWGUWIUWPUWKUWMUUTUVAWSW
      TZYRUWHUWJUWQUWLUWNUUMUUNWSWTZYMCLWOZYMIOWOZUVBUUOUVCUUPWRWPVTXAYNUUCYMUV
      DUQZYNYMEUUBYGEYMEFWNWHUBXBUUCABWJWBWQZUXDPUUCUXEURACWJWBZWQBUXFWQUXDQRYM
      ABCJKLXCXDWLVTXEYNYRUUSYPUQZUUDYPUPUKZYRUXGUUHYRUXHVIUMYMXFXQYPYMXHXIVTYN
      YRUVFUUQUQZUUDYRUVDUPUKZUUQUPUKZUXIYRUWPUWRUXJUWTUXBUVBUVCWSWTYRUWQUWSUXK
      UXAUXCUUOUUPWSWTUVDUUQXJWTVTXKYNYRUUQYLUKZUUDYRUUOYKUKZUUPIUKUXLYRUUMDUKU
      UNHUKUXMYMDMXLYMHNXLDHUUMUUNDMXMZHNXMZXNWTYMIOXLYKIUUOUUPDHUXNUXOXOZIOXMZ
      XNWTVTXPUUIUUKUULUUJYLXRUKUUIUUKURUULXSYKIUXPUXQXOYOYPYLXTYAXQVTXPYBYKYHW
      QYLYJWQDHMNYCYKYHIUXPYHDHMNVBZXMUXQYDYAYEYHIUXROYCYEUDYF $.
  $}

  ${
    mayetes3.a $e |- A e. CH $.
    mayetes3.b $e |- B e. CH $.
    mayetes3.c $e |- C e. CH $.
    mayetes3.d $e |- D e. CH $.
    mayetes3.f $e |- F e. CH $.
    mayetes3.g $e |- G e. CH $.
    mayetes3.r $e |- R e. CH $.
    mayetes3.ac $e |- A C_ ( _|_ ` C ) $.
    mayetes3.af $e |- A C_ ( _|_ ` F ) $.
    mayetes3.cf $e |- C C_ ( _|_ ` F ) $.
    mayetes3.ab $e |- A C_ ( _|_ ` B ) $.
    mayetes3.cd $e |- C C_ ( _|_ ` D ) $.
    mayetes3.fg $e |- F C_ ( _|_ ` G ) $.
    mayetes3.rx $e |- R C_ ( _|_ ` X ) $.
    mayetes3.x $e |- X = ( ( A vH C ) vH F ) $.
    mayetes3.y $e |- Y = ( ( ( A vH B ) i^i ( C vH D ) ) i^i ( F vH G ) ) $.
    mayetes3.z $e |- Z = ( ( B vH D ) vH G ) $.
    $( Mayet's equation E^*_3, derived from E_3.  Solution, for n = 3, to open
       problem in Remark (b) after Theorem 7.1 of [Mayet3] p. 1240.
       (Contributed by NM, 10-May-2009.)  (New usage is discouraged.) $)
    mayetes3i $p |- ( ( X vH R ) i^i Y ) C_ ( Z vH R ) $=
      ( chj co cin wss chjcli chjcomi eqimssi chub1i chjassi chub2i sstri ss2in
      sseqtri mp2an chincli ccm wbr cfv cch eqeltri choccli lecmii cmcm2i mpbir
      cort breqtri cm2mi fh3i ineq1i ineq2i eqtr2i sseqtr4i chsscon3i chsscon2i
      eqtri mpbi ssini chdmj1i chjjdiri oveq1i mayete3i chlubii ineq12i 3sstr4i
      eqid ) ACUHUIZFUHUIZEUHUIZABUHUIZCDUHUIZUJZFGUHUIZUJZUJZBDUHUIZGUHUIZEUHU
      IZHEUHUIZIUJJEUHUIXAEWNABEUHUIZUHUIZCDEUHUIZUHUIZUJZFGEUHUIZUHUIZUJZUJZUH
      UIZXDXAEWNUHUIZEXGUHUIZEXIUHUIZUJZEXLUHUIZUJZUJZXOWOXPUKWTYAUKZXAYBUKWOXP
      WNEWMFACKMULZOULZQUMUNWRXSUKZWSXTUKYCWPXQUKWQXRUKYFWPXGXQWPWPEUHUIXGWPEAB
      KLULQUOABEKLQUPUTXGEAXFKBELQULZULZQUQURWQXIXRWQWQEUHUIXIWQECDMNULQUOCDEMN
      QUPUTXIECXHMDENQULZULZQUQURWPXQWQXRUSVAWSXLXTWSWSEUHUIXLWSEFGOPULQUOFGEOP
      QUPUTXLEFXKOGEPQULZULZQUQURWRXSWSXTUSVAWOXPWTYAUSVAXOXPEXMUHUIZUJYBEWNXMQ
      YEXJXLXGXIYHYJVBZYLVBZEHWNVCEHVCVDEHVLVEZVCVDEYPQHHWNVFUEYEVGZVHUDVIEHQYQ
      VJVKUEVMEXJXLQYNYLEXGXIQYHYJEXGQYHEXFXGEBQLUQXFAYGKUQURVIZEXIQYJEXHXIEDQN
      UQXHCYIMUQURVIZVNZEXLQYLEXKXLEGQPUQXKFYKOUQURVIZVNVOYMYAXPYMEXJUHUIZXTUJY
      AEXJXLQYNYLYTUUAVOUUBXSXTEXGXIQYHYJYRYSVOVPWBVQVRUTEXDUKXNXDUKXOXDUKEXCQX
      BGBDLNULZPULZUQAXFCXHFXKWNXMXDKYGMYIOYKRSTABVLVEZEVLVEZUJXFVLVEAUUEUUFUAE
      AVLVEZUKAUUFUKEYPUUGUDAHUKYPUUGUKAWMHACKMUOWMWNHWMFYDOUOUEVSZURAHKYQVTWCU
      REAQKWAWCWDBELQWEVSCDVLVEZUUFUJXHVLVECUUIUUFUBECVLVEZUKCUUFUKEYPUUJUDCHUK
      YPUUJUKCWMHCAMKUQUUHURCHMYQVTWCURECQMWAWCWDDENQWEVSFGVLVEZUUFUJXKVLVEFUUK
      UUFUCEFVLVEZUKFUUFUKEYPUULUDFHUKYPUULUKFWNHFWMOYDUQUEVSFHOYQVTWCUREFQOWAW
      CWDGEPQWEVSWNWLXMWLXDXBEUHUIZXKUHUIXFXHUHUIZXKUHUIXBGEUUCPQWFUUMUUNXKUHBD
      ELNQWFWGWBWHEXNXDQWNXMYEYOVBXCEUUDQULWIVAURXEWOIWTHWNEUHUEWGUFWJJXCEUHUGW
      GWK $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                          Operators on Hilbert spaces
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Operator sum, difference, and scalar multiplication
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  _Note on operators_.  Unlike some authors, we use the term "operator" to
  mean any function from ` ~H ` to ` ~H ` .  This is the definition of
  operator in [Hughes] p. 14, the definition of operator in
  [AkhiezerGlazman] p. 30, and the definition of operator in [Goldberg]
  p. 10.  For Reed and Simon, an operator is linear (definition of
  operator in [ReedSimon] p. 2).  For Halmos, an operator is bounded and
  linear (definition of operator in [Halmos] p. 35).  For Kalmbach and
  Beran, an operator is continuous and linear (definition of operator in
  [Kalmbach] p. 353; definition of operator in [Beran] p. 99).  Note that
  "bounded and linear" and "continuous and linear" are equivalent by
  ~ lncnbd .

$)

  ${
    $d f g h x y $.
    $( Define the sum of two Hilbert space operators.  Definition of [Beran]
       p. 111.  (Contributed by NM, 9-Nov-2000.)
       (New usage is discouraged.) $)
    df-hosum $a |- +op = ( f e. ( ~H ^m ~H ) , g e. ( ~H ^m ~H ) |->
          ( x e. ~H |-> ( ( f ` x ) +h ( g ` x ) ) ) ) $.

    $( Define the scalar product with a Hilbert space operator.  Definition of
       [Beran] p. 111.  (Contributed by NM, 20-Feb-2006.)
       (New usage is discouraged.) $)
    df-homul $a |- .op = ( f e. CC , g e. ( ~H ^m ~H ) |->
          ( x e. ~H |-> ( f .h ( g ` x ) ) ) ) $.

$(
    @( Define the difference of two Hilbert space operators.  Definition of
       [Beran] p. 111. @)
    df-hodif @a |- -op = { <. <. f , g >. , h >. | ( ( f : ~H --> ~H /\
          g : ~H --> ~H ) /\ h = ( f +op ( -u 1 .op g ) ) ) } @.
$)

    $( Define the difference of two Hilbert space operators.  Definition of
       [Beran] p. 111.  (Contributed by NM, 9-Nov-2000.)
       (New usage is discouraged.) $)
    df-hodif $a |- -op = ( f e. ( ~H ^m ~H ) , g e. ( ~H ^m ~H ) |->
          ( x e. ~H |-> ( ( f ` x ) -h ( g ` x ) ) ) ) $.

    $( Define the sum of two Hilbert space functionals.  Definition of [Beran]
       p. 111.  Note that unlike some authors, we define a functional as any
       function from ` ~H ` to ` CC ` , not just linear (or bounded linear)
       ones.  (Contributed by NM, 23-May-2006.)  (New usage is discouraged.) $)
    df-hfsum $a |- +fn = ( f e. ( CC ^m ~H ) , g e. ( CC ^m ~H ) |->
          ( x e. ~H |-> ( ( f ` x ) + ( g ` x ) ) ) ) $.

    $( Define the scalar product with a Hilbert space functional.  Definition
       of [Beran] p. 111.  (Contributed by NM, 23-May-2006.)
       (New usage is discouraged.) $)
    df-hfmul $a |- .fn = ( f e. CC , g e. ( CC ^m ~H ) |->
          ( x e. ~H |-> ( f x. ( g ` x ) ) ) ) $.
  $}

  ${
    $d f g h x y A $.  $d x y f g h S $.  $d x y f g h T $.
    $( Value of the sum of two Hilbert space operators.  (Contributed by NM,
       9-Nov-2000.)  (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    hosmval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( S +op T ) =
                    ( x e. ~H |-> ( ( S ` x ) +h ( T ` x ) ) ) ) $=
      ( vf vg chil wf cmap co wcel chos cv cfv cva cmpt ax-hilex elmap mpteq2dv
      wceq fveq1 oveq1d oveq2d df-hosum mptex ovmpt2 syl2anbr ) FFBGBFFHIZJCUGJ
      BCKIAFALZBMZUHCMZNIZOZSFFCGFFBPPQFFCPPQDEBCUGUGAFUHDLZMZUHELZMZNIZOULKAFU
      IUPNIZOUMBSZAFUQURUSUNUIUPNUHUMBTUARUOCSZAFURUKUTUPUJUINUHUOCTUBRADEUCAFU
      KPUDUEUF $.

    $( Value of the scalar product with a Hilbert space operator.  (Contributed
       by NM, 20-Feb-2006.)  (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    hommval $p |- ( ( A e. CC /\ T : ~H --> ~H ) -> ( A .op T ) =
                    ( x e. ~H |-> ( A .h ( T ` x ) ) ) ) $=
      ( vf vg chil wf cc wcel cmap co chot cfv csm cmpt ax-hilex elmap mpteq2dv
      cv wceq oveq1 fveq1 oveq2d df-homul mptex ovmpt2 sylan2br ) FFCGBHICFFJKZ
      IBCLKAFBASZCMZNKZOZTFFCPPQDEBCHUHAFDSZUIESZMZNKZOULLAFBUONKZOUMBTAFUPUQUM
      BUONUARUNCTZAFUQUKURUOUJBNUIUNCUBUCRADEUDAFUKPUEUFUG $.

    $( Value of the difference of two Hilbert space operators.  (Contributed by
       NM, 9-Nov-2000.)  (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    hodmval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( S -op T ) =
                    ( x e. ~H |-> ( ( S ` x ) -h ( T ` x ) ) ) ) $=
      ( vf vg chil wf cmap co wcel chod cv cfv cmv cmpt ax-hilex elmap mpteq2dv
      wceq fveq1 oveq1d oveq2d df-hodif mptex ovmpt2 syl2anbr ) FFBGBFFHIZJCUGJ
      BCKIAFALZBMZUHCMZNIZOZSFFCGFFBPPQFFCPPQDEBCUGUGAFUHDLZMZUHELZMZNIZOULKAFU
      IUPNIZOUMBSZAFUQURUSUNUIUPNUHUMBTUARUOCSZAFURUKUTUPUJUINUHUOCTUBRADEUCAFU
      KPUDUEUF $.

    $( Value of the sum of two Hilbert space functionals.  (Contributed by NM,
       23-May-2006.)  (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    hfsmval $p |- ( ( S : ~H --> CC /\ T : ~H --> CC ) -> ( S +fn T ) =
                    ( x e. ~H |-> ( ( S ` x ) + ( T ` x ) ) ) ) $=
      ( vf vg chil cc wf co wcel chfs caddc cmpt wceq cnex ax-hilex elmap fveq1
      cv cfv cmap oveq1d mpteq2dv oveq2d df-hfsum mptex ovmpt2 syl2anbr ) FGBHB
      GFUAIZJCUIJBCKIAFASZBTZUJCTZLIZMZNFGCHGFBOPQGFCOPQDEBCUIUIAFUJDSZTZUJESZT
      ZLIZMUNKAFUKURLIZMUOBNZAFUSUTVAUPUKURLUJUOBRUBUCUQCNZAFUTUMVBURULUKLUJUQC
      RUDUCADEUEAFUMPUFUGUH $.

    $( Value of the scalar product with a Hilbert space functional.
       (Contributed by NM, 23-May-2006.)  (Revised by Mario Carneiro,
       23-Aug-2014.)  (New usage is discouraged.) $)
    hfmmval $p |- ( ( A e. CC /\ T : ~H --> CC ) -> ( A .fn T ) =
                    ( x e. ~H |-> ( A x. ( T ` x ) ) ) ) $=
      ( vf vg chil cc wf wcel cmap co chft cfv cmul cmpt wceq ax-hilex mpteq2dv
      cv cnex elmap oveq1 fveq1 oveq2d df-hfmul mptex ovmpt2 sylan2br ) FGCHBGI
      CGFJKZIBCLKAFBASZCMZNKZOZPGFCTQUADEBCGUIAFDSZUJESZMZNKZOUMLAFBUPNKZOUNBPA
      FUQURUNBUPNUBRUOCPZAFURULUSUPUKBNUJUOCUCUDRADEUEAFULQUFUGUH $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y S $.  $d x y T $.
    $( Value of the sum of two Hilbert space operators.  (Contributed by NM,
       10-Nov-2000.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    hosval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ A e. ~H ) ->
        ( ( S +op T ) ` A ) = ( ( S ` A ) +h ( T ` A ) ) ) $=
      ( vx chil wf wcel chos co cfv cva wceq wa cv hosmval fveq1d fveq2 oveq12d
      cmpt eqid ovex fvmpt sylan9eq 3impa ) EEBFZEECFZAEGZABCHIZJZABJZACJZKIZLU
      EUFMZUGUIADEDNZBJZUNCJZKIZSZJULUMAUHURDBCOPDAUQULEURUNALUOUJUPUKKUNABQUNA
      CQRURTUJUKKUAUBUCUD $.

    $( Value of the scalar product with a Hilbert space operator.  (Contributed
       by NM, 20-Feb-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    homval $p |- ( ( A e. CC /\ T : ~H --> ~H /\ B e. ~H ) ->
        ( ( A .op T ) ` B ) = ( A .h ( T ` B ) ) ) $=
      ( vx cc wcel chil wf chot co cfv csm wceq wa cv cmpt hommval fveq1d fveq2
      oveq2d eqid ovex fvmpt sylan9eq 3impa ) AEFZGGCHZBGFZBACIJZKZABCKZLJZMUFU
      GNZUHUJBDGADOZCKZLJZPZKULUMBUIUQDACQRDBUPULGUQUNBMUOUKALUNBCSTUQUAAUKLUBU
      CUDUE $.

    $( Value of the difference of two Hilbert space operators.  (Contributed by
       NM, 10-Nov-2000.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    hodval $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ A e. ~H ) ->
        ( ( S -op T ) ` A ) = ( ( S ` A ) -h ( T ` A ) ) ) $=
      ( vx chil wf wcel chod co cfv cmv wceq wa cv hodmval fveq1d fveq2 oveq12d
      cmpt eqid ovex fvmpt sylan9eq 3impa ) EEBFZEECFZAEGZABCHIZJZABJZACJZKIZLU
      EUFMZUGUIADEDNZBJZUNCJZKIZSZJULUMAUHURDBCOPDAUQULEURUNALUOUJUPUKKUNABQUNA
      CQRURTUJUKKUAUBUCUD $.

    $( Value of the sum of two Hilbert space functionals.  (Contributed by NM,
       23-May-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    hfsval $p |- ( ( S : ~H --> CC /\ T : ~H --> CC /\ A e. ~H ) ->
        ( ( S +fn T ) ` A ) = ( ( S ` A ) + ( T ` A ) ) ) $=
      ( vx chil cc wf wcel chfs co caddc wceq wa cv cmpt hfsmval fveq1d oveq12d
      cfv fveq2 eqid ovex fvmpt sylan9eq 3impa ) EFBGZEFCGZAEHZABCIJZSZABSZACSZ
      KJZLUFUGMZUHUJADEDNZBSZUOCSZKJZOZSUMUNAUIUSDBCPQDAURUMEUSUOALUPUKUQULKUOA
      BTUOACTRUSUAUKULKUBUCUDUE $.

    $( Value of the scalar product with a Hilbert space functional.
       (Contributed by NM, 23-May-2006.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    hfmval $p |- ( ( A e. CC /\ T : ~H --> CC /\ B e. ~H ) ->
        ( ( A .fn T ) ` B ) = ( A x. ( T ` B ) ) ) $=
      ( vx cc wcel chil wf chft co cfv cmul wceq wa cv cmpt fveq1d fveq2 oveq2d
      hfmmval eqid ovex fvmpt sylan9eq 3impa ) AEFZGECHZBGFZBACIJZKZABCKZLJZMUF
      UGNZUHUJBDGADOZCKZLJZPZKULUMBUIUQDACTQDBUPULGUQUNBMUOUKALUNBCRSUQUAAUKLUB
      UCUDUE $.
  $}

  $( Closure of the sum of two Hilbert space operators.  (Contributed by NM,
     12-Nov-2000.)  (New usage is discouraged.) $)
  hoscl $p |- ( ( ( S : ~H --> ~H /\ T : ~H --> ~H ) /\ A e. ~H ) ->
      ( ( S +op T ) ` A ) e. ~H ) $=
    ( chil wf wa wcel chos co cfv cva wceq hosval 3expa ffvelrn anim12i hvaddcl
    anandirs syl eqeltrd ) DDBEZDDCEZFADGZFZABCHIJZABJZACJZKIZDUAUBUCUEUHLABCMN
    UDUFDGZUGDGZFZUHDGUAUBUCUKUAUCFUIUBUCFUJDDABODDACOPRUFUGQST $.

  $( Closure of the scalar product of a Hilbert space operator.  (Contributed
     by NM, 20-Feb-2006.)  (New usage is discouraged.) $)
  homcl $p |- ( ( A e. CC /\ T : ~H --> ~H /\ B e. ~H ) ->
      ( ( A .op T ) ` B ) e. ~H ) $=
    ( cc wcel chil wf w3a co cfv csm homval wa ffvelrn anim2i 3impb hvmulcl syl
    chot eqeltrd ) ADEZFFCGZBFEZHZBACSIJABCJZKIZFABCLUDUAUEFEZMZUFFEUAUBUCUHUBU
    CMUGUAFFBCNOPAUEQRT $.

  $( Closure of the difference of two Hilbert space operators.  (Contributed by
     NM, 15-Nov-2002.)  (New usage is discouraged.) $)
  hodcl $p |- ( ( ( S : ~H --> ~H /\ T : ~H --> ~H ) /\ A e. ~H ) ->
      ( ( S -op T ) ` A ) e. ~H ) $=
    ( chil wcel chod cfv w3a cmv hodval ffvelrn 3adant2 3adant1 hvsubcl syl2anc
    wf co eqeltrd 3expa ) DDBPZDDCPZADEZABCFQGZDETUAUBHZUCABGZACGZIQZDABCJUDUED
    EZUFDEZUGDETUBUHUADDABKLUAUBUITDDACKMUEUFNORS $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
            Zero and identity operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Define the Hilbert space zero operator.  See ~ df0op2 for alternate
     definition.  (Contributed by NM, 7-Feb-2006.)
     (New usage is discouraged.) $)
  df-h0op $a |- 0hop = ( projh ` 0H ) $.

  $( Define the Hilbert space identity operator.  See ~ dfiop2 for alternate
     definition.  (Contributed by NM, 15-Nov-2000.)
     (New usage is discouraged.) $)
  df-iop $a |- Iop = ( projh ` ~H ) $.

  $( Value of the zero Hilbert space operator (null projector).  Remark in
     [Beran] p. 111.  (Contributed by NM, 7-Feb-2006.)
     (New usage is discouraged.) $)
  ho0val $p |- ( A e. ~H -> ( 0hop ` A ) = 0h ) $=
    ( chil wcel ch0o cfv cpjh cmv co c0v c0h choc1 fveq2i df-h0op eqtr4i fveq1i
    cort cch wceq helch pjo mpan syl5eqr pjhcli hvsubid syl eqtrd ) ABCZADEZABF
    EEZUIGHZIUGUHABPEZFEZEZUJAULDULJFEDUKJFKLMNOBQCUGUMUJRSABTUAUBUGUIBCUJIRABS
    UCUIUDUEUF $.

  $( Functionality of the zero Hilbert space operator.  (Contributed by NM,
     10-Mar-2006.)  (New usage is discouraged.) $)
  ho0f $p |- 0hop : ~H --> ~H $=
    ( chil ch0o wf c0h cpjh cfv h0elch pjfi df-h0op feq1i mpbir ) AABCAADEFZCDG
    HAABLIJK $.

  $( Alternate definition of Hilbert space zero operator.  (Contributed by NM,
     7-Aug-2006.)  (New usage is discouraged.) $)
  df0op2 $p |- 0hop = ( ~H X. 0H ) $=
    ( vx ch0o chil c0v csn cxp c0h wf wceq wfn cv cfv wral ho0f ffn ho0val rgen
    ax-mp fconstfv mpbir2an ax-hv0cl elexi fconst2 mpbi df-ch0 xpeq2i eqtr4i )
    BCDEZFZCGFCUHBHZBUIIUJBCJZAKZBLDIZACMCCBHUKNCCBORUMACULPQACDBSTCDBDCUAUBUCU
    DGUHCUEUFUG $.

  $( Alternate definition of Hilbert space identity operator.  (Contributed by
     NM, 7-Aug-2006.)  (New usage is discouraged.) $)
  dfiop2 $p |- Iop = ( _I |` ~H ) $=
    ( vx chio chil cpjh cfv cid cres df-iop wfn wceq helch pjfni fnresi wa wral
    cv wcel pjch1 fvresi eqtr4d rgen eqfnfv mpbiri mp2an eqtri ) BCDEZFCGZHUFCI
    ZUGCIZUFUGJZCKLCMUHUINUJAPZUFEZUKUGEZJZACOUNACUKCQULUKUMUKRCUKSTUAACUFUGUBU
    CUDUE $.

  $( Functionality of the Hilbert space identity operator.  (Contributed by NM,
     8-Aug-2006.)  (New usage is discouraged.) $)
  hoif $p |- Iop : ~H -1-1-onto-> ~H $=
    ( chil chio wf1o cid cres f1oi wceq wb dfiop2 f1oeq1 ax-mp mpbir ) AABCZAAD
    AEZCZAFBNGMOHIAABNJKL $.

  $( The value of the Hilbert space identity operator.  (Contributed by NM,
     8-Aug-2006.)  (New usage is discouraged.) $)
  hoival $p |- ( A e. ~H -> ( Iop ` A ) = A ) $=
    ( chil wcel chio cfv cpjh df-iop fveq1i pjch1 syl5eq ) ABCADEABFEZEAADKGHAI
    J $.

  $( Composition with the Hilbert space identity operator.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  hoico1 $p |- ( T : ~H --> ~H -> ( T o. Iop ) = T ) $=
    ( chil wf chio ccom cid cres dfiop2 coeq2i fcoi1 syl5eq ) BBACADEAFBGZEADLA
    HIBBAJK $.

  $( Composition with the Hilbert space identity operator.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  hoico2 $p |- ( T : ~H --> ~H -> ( Iop o. T ) = T ) $=
    ( chil wf chio ccom cid cres dfiop2 coeq1i fcoi2 syl5eq ) BBACDAEFBGZAEADLA
    HIBBAJK $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Operations on Hilbert space operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y S $.  $d x y T $.
    $( The sum of Hilbert space operators is an operator.  (Contributed by NM,
       21-Feb-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    hoaddcl $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( S +op T ) : ~H --> ~H ) $=
      ( vx chil wf wa chos co cfv cva cmpt wcel ffvelrn adantlr adantll hvaddcl
      cv syl2anc eqid fmptd hosmval feq1d mpbird ) DDAEZDDBEZFZDDABGHZEDDCDCQZA
      IZUHBIZJHZKZEUFCDUKDULUFUHDLZFUIDLZUJDLZUKDLUDUMUNUEDDUHAMNUEUMUOUDDDUHBM
      OUIUJPRULSTUFDDUGULCABUAUBUC $.

    $( The scalar product of a Hilbert space operator is an operator.
       (Contributed by NM, 21-Feb-2006.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    homulcl $p |- ( ( A e. CC /\ T : ~H --> ~H ) ->
                   ( A .op T ) : ~H --> ~H ) $=
      ( vx cc wcel chil wf wa chot co cv cfv csm ffvelrn hvmulcl sylan2 anassrs
      cmpt eqid fmptd hommval feq1d mpbird ) ADEZFFBGZHZFFABIJZGFFCFACKZBLZMJZR
      ZGUFCFUJFUKUDUEUHFEZUJFEZUEULHUDUIFEUMFFUHBNAUIOPQUKSTUFFFUGUKCABUAUBUC
      $.
  $}

  ${
    $d x T $.  $d x U $.
    $( Equality of Hilbert space operators.  (Contributed by NM, 12-Aug-2006.)
       (New usage is discouraged.) $)
    hoeq $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                ( A. x e. ~H ( T ` x ) = ( U ` x ) <-> T = U ) ) $=
      ( chil wf wfn cv cfv wceq wral wb ffn wa eqfnfv bicomd syl2an ) DDBEBDFZC
      DFZAGZBHSCHIADJZBCIZKDDCEDDBLDDCLQRMUATADBCNOP $.
  $}

  ${
    $d x y S $.  $d x y T $.
    hoeq.1 $e |- S : ~H --> ~H $.
    hoeq.2 $e |- T : ~H --> ~H $.
    $( Equality of Hilbert space operators.  (Contributed by NM, 14-Nov-2000.)
       (New usage is discouraged.) $)
    hoeqi $p |- ( A. x e. ~H ( S ` x ) = ( T ` x ) <-> S = T ) $=
      ( chil wf cv cfv wceq wral wb hoeq mp2an ) FFBGFFCGAHZBIOCIJAFKBCJLDEABCM
      N $.

    $( Closure of Hilbert space operator sum.  (Contributed by NM,
       12-Nov-2000.)  (New usage is discouraged.) $)
    hoscli $p |- ( A e. ~H -> ( ( S +op T ) ` A ) e. ~H ) $=
      ( chil wf wcel chos co cfv hoscl mpanl12 ) FFBGFFCGAFHABCIJKFHDEABCLM $.

    $( Closure of Hilbert space operator difference.  (Contributed by NM,
       12-Nov-2000.)  (New usage is discouraged.) $)
    hodcli $p |- ( A e. ~H -> ( ( S -op T ) ` A ) e. ~H ) $=
      ( chil wf wcel chod co cfv hodcl mpanl12 ) FFBGFFCGAFHABCIJKFHDEABCLM $.

    $( Composition of Hilbert space operators.  (Contributed by NM,
       12-Nov-2000.)  (New usage is discouraged.) $)
    hocoi $p |- ( A e. ~H -> ( ( S o. T ) ` A ) = ( S ` ( T ` A ) ) ) $=
      ( chil wf wcel ccom cfv wceq fvco3 mpan ) FFCGAFHABCIJACJBJKEFFABCLM $.

    $( Closure of composition of Hilbert space operators.  (Contributed by NM,
       12-Nov-2000.)  (New usage is discouraged.) $)
    hococli $p |- ( A e. ~H -> ( ( S o. T ) ` A ) e. ~H ) $=
      ( chil wcel ccom cfv hocoi ffvelrni syl eqeltrd ) AFGZABCHIACIZBIZFABCDEJ
      NOFGPFGFFACEKFFOBDKLM $.

    $( Mapping of composition of Hilbert space operators.  (Contributed by NM,
       14-Nov-2000.)  (New usage is discouraged.) $)
    hocofi $p |- ( S o. T ) : ~H --> ~H $=
      ( chil wf ccom fco mp2an ) EEAFEEBFEEABGFCDEEEABHI $.

    $( Functionality of composition of Hilbert space operators.  (Contributed
       by NM, 12-Nov-2000.)  (New usage is discouraged.) $)
    hocofni $p |- ( S o. T ) Fn ~H $=
      ( chil ccom wf wfn hocofi ffn ax-mp ) EEABFZGLEHABCDIEELJK $.

    $( Mapping of sum of Hilbert space operators.  (Contributed by NM,
       14-Nov-2000.)  (New usage is discouraged.) $)
    hoaddcli $p |- ( S +op T ) : ~H --> ~H $=
      ( chil wf chos co hoaddcl mp2an ) EEAFEEBFEEABGHFCDABIJ $.

    $( Mapping of difference of Hilbert space operators.  (Contributed by NM,
       14-Nov-2000.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    hosubcli $p |- ( S -op T ) : ~H --> ~H $=
      ( vx chil cv cfv co chod wf cmpt wceq hodmval mp2an wcel ffvelrni hvsubcl
      cmv syl2anc fmpti ) EFFEGZAHZUBBHZSIZABJIZFFAKFFBKUFEFUELMCDEABNOUBFPUCFP
      UDFPUEFPFFUBACQFFUBBDQUCUDRTUA $.

    $( Functionality of sum of Hilbert space operators.  (Contributed by NM,
       14-Nov-2000.)  (New usage is discouraged.) $)
    hoaddfni $p |- ( S +op T ) Fn ~H $=
      ( chil chos co wf wfn hoaddcli ffn ax-mp ) EEABFGZHMEIABCDJEEMKL $.

    $( Functionality of difference of Hilbert space operators.  (Contributed by
       NM, 2-Jun-2006.)  (New usage is discouraged.) $)
    hosubfni $p |- ( S -op T ) Fn ~H $=
      ( chil chod co wf wfn hosubcli ffn ax-mp ) EEABFGZHMEIABCDJEEMKL $.

    $( Commutativity of sum of Hilbert space operators.  (Contributed by NM,
       15-Nov-2000.)  (New usage is discouraged.) $)
    hoaddcomi $p |- ( S +op T ) = ( T +op S ) $=
      ( vx cv chos cfv wceq chil wral wcel cva ffvelrni ax-hvcom hosval mp3an12
      co wf hoaddcli syl2anc 3eqtr4d rgen hoeqi mpbi ) EFZABGRZHZUFBAGRZHZIZEJK
      UGUIIUKEJUFJLZUFAHZUFBHZMRZUNUMMRZUHUJULUMJLUNJLUOUPIJJUFACNJJUFBDNUMUNOU
      AJJASZJJBSZULUHUOICDUFABPQURUQULUJUPIDCUFBAPQUBUCEUGUIABCDTBADCTUDUE $.
  $}

  $( Mapping of difference of Hilbert space operators.  (Contributed by NM,
     23-Aug-2006.)  (New usage is discouraged.) $)
  hosubcl $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
              ( S -op T ) : ~H --> ~H ) $=
    ( chil wf chod ch0o cif wceq oveq1 feq1d oveq2 ho0f elimf hosubcli dedth2h
    co ) CCADZCCBDZCCABEPZDCCQAFGZBEPZDCCTRBFGZEPZDABFFATHCCSUAATBEIJBUBHCCUAUC
    BUBTEKJTUBCCAFLMCCBFLMNO $.

  $( Commutativity of sum of Hilbert space operators.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  hoaddcom $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( S +op T ) = ( T +op S ) ) $=
    ( chil wf chos co wceq ch0o cif oveq1 oveq2 eqeq12d elimf hoaddcomi dedth2h
    ho0f ) CCADZCCBDZABEFZBAEFZGQAHIZBEFZBUAEFZGUARBHIZEFZUDUAEFZGABHHAUAGSUBTU
    CAUABEJAUABEKLBUDGUBUEUCUFBUDUAEKBUDUAEJLUAUDCCAHPMCCBHPMNO $.

  ${
    $d x R $.  $d x S $.  $d x T $.
    hods.1 $e |- R : ~H --> ~H $.
    hods.2 $e |- S : ~H --> ~H $.
    hods.3 $e |- T : ~H --> ~H $.
    $( Relationship between Hilbert space operator difference and sum.
       (Contributed by NM, 17-Nov-2000.)  (New usage is discouraged.) $)
    hodsi $p |- ( ( R -op S ) = T <-> ( S +op T ) = R ) $=
      ( vx cv chod co cfv wceq chil wral wcel ffvelrni wf mp3an12 eqeq1d hoeqi
      chos cmv cva wb hvsubadd syl3anc hodval 3bitr4d ralbiia hosubcli hoaddcli
      hosval 3bitr3i ) GHZABIJZKZUNCKZLZGMNUNBCUAJZKZUNAKZLZGMNUOCLUSALURVBGMUN
      MOZVAUNBKZUBJZUQLZVDUQUCJZVALZURVBVCVAMOVDMOUQMOVFVHUDMMUNADPMMUNBEPMMUNC
      FPVAVDUQUEUFVCUPVEUQMMAQMMBQZVCUPVELDEUNABUGRSVCUTVGVAVIMMCQVCUTVGLEFUNBC
      ULRSUHUIGUOCABDEUJFTGUSABCEFUKDTUM $.

    $( Associativity of sum of Hilbert space operators.  (Contributed by NM,
       26-Nov-2000.)  (New usage is discouraged.) $)
    hoaddassi $p |- ( ( R +op S ) +op T ) = ( R +op ( S +op T ) ) $=
      ( vx chos cfv wceq chil wcel cva hosval mp3an12 hoaddcli ffvelrni 3eqtr4d
      co wf cv wral oveq1d oveq2d ax-hvass syl3anc rgen hoeqi mpbi ) GUAZABHSZC
      HSZIZUJABCHSZHSZIZJZGKUBULUOJUQGKUJKLZUJUKIZUJCIZMSZUJAIZUJBIZMSZUTMSZUMU
      PURUSVDUTMKKATZKKBTZURUSVDJDEUJABNOUCKKUKTKKCTZURUMVAJABDEPZFUJUKCNOURVBU
      JUNIZMSZVBVCUTMSZMSZUPVEURVJVLVBMVGVHURVJVLJEFUJBCNOUDVFKKUNTURUPVKJDBCEF
      PZUJAUNNOURVBKLVCKLUTKLVEVMJKKUJADQKKUJBEQKKUJCFQVBVCUTUEUFRRUGGULUOUKCVI
      FPAUNDVNPUHUI $.

    $( Commutative/associative law for Hilbert space operator sum that swaps
       the first two terms.  (Contributed by NM, 27-Aug-2004.)
       (New usage is discouraged.) $)
    hoadd12i $p |- ( R +op ( S +op T ) ) = ( S +op ( R +op T ) ) $=
      ( chos co hoaddcomi oveq1i hoaddassi 3eqtr3i ) ABGHZCGHBAGHZCGHABCGHGHBAC
      GHGHMNCGABDEIJABCDEFKBACEDFKL $.

    $( Commutative/associative law for Hilbert space operator sum that swaps
       the second and third terms.  (Contributed by NM, 27-Jul-2006.)
       (New usage is discouraged.) $)
    hoadd32i $p |- ( ( R +op S ) +op T ) = ( ( R +op T ) +op S ) $=
      ( chos co hoaddcomi oveq2i hoaddassi 3eqtr4i ) ABCGHZGHACBGHZGHABGHCGHACG
      HBGHMNAGBCEFIJABCDEFKACBDFEKL $.

    $( Distributive law for Hilbert space operator sum.  (Contributed by NM,
       26-Nov-2000.)  (New usage is discouraged.) $)
    hocadddiri $p |- ( ( R +op S ) o. T ) = ( ( R o. T ) +op ( S o. T ) ) $=
      ( vx chos co ccom cfv wceq chil wcel hoaddcli hocoi cva wf hocofi eqtr4d
      cv wral hosval mp3an12 ffvelrni syl oveq12d rgen hoeqi mpbi ) GUAZABHIZCJ
      ZKZUKACJZBCJZHIZKZLZGMUBUMUQLUSGMUKMNZUNUKCKZULKZURUKULCABDEOZFPUTURUKUOK
      ZUKUPKZQIZVBMMUORMMUPRUTURVFLACDFSZBCEFSZUKUOUPUCUDUTVBVAAKZVABKZQIZVFUTV
      AMNZVBVKLZMMUKCFUEMMARMMBRVLVMDEVAABUCUDUFUTVDVIVEVJQUKACDFPUKBCEFPUGTTTU
      HGUMUQULCVCFSUOUPVGVHOUIUJ $.

    $( Distributive law for Hilbert space operator difference.  (Contributed by
       NM, 26-Nov-2000.)  (New usage is discouraged.) $)
    hocsubdiri $p |- ( ( R -op S ) o. T ) = ( ( R o. T ) -op ( S o. T ) ) $=
      ( vx chod co ccom cfv wceq chil wcel hosubcli hocoi cmv wf hocofi eqtr4d
      cv wral hodval mp3an12 ffvelrni syl oveq12d rgen hoeqi mpbi ) GUAZABHIZCJ
      ZKZUKACJZBCJZHIZKZLZGMUBUMUQLUSGMUKMNZUNUKCKZULKZURUKULCABDEOZFPUTURUKUOK
      ZUKUPKZQIZVBMMUORMMUPRUTURVFLACDFSZBCEFSZUKUOUPUCUDUTVBVAAKZVABKZQIZVFUTV
      AMNZVBVKLZMMUKCFUEMMARMMBRVLVMDEVAABUCUDUFUTVDVIVEVJQUKACDFPUKBCEFPUGTTTU
      HGUMUQULCVCFSUOUPVGVHOUIUJ $.

    $( Double composition of Hilbert space operators.  (Contributed by NM,
       1-Dec-2000.)  (New usage is discouraged.) $)
    ho2coi $p |- ( A e. ~H -> ( ( ( R o. S ) o. T ) ` A ) =
                 ( R ` ( S ` ( T ` A ) ) ) ) $=
      ( chil wcel ccom cfv hocofi hocoi wceq ffvelrni syl eqtrd ) AHIZABCJZDJKA
      DKZSKZTCKBKZASDBCEFLGMRTHIUAUBNHHADGOTBCEFMPQ $.
  $}

  $( Associativity of sum of Hilbert space operators.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  hoaddass $p |- ( ( R : ~H --> ~H /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( ( R +op S ) +op T ) = ( R +op ( S +op T ) ) ) $=
    ( chil wf chos co wceq ch0o cif oveq1 oveq1d eqeq12d oveq2 oveq2d hoaddassi
    ho0f elimf dedth3h ) DDAEZDDBEZDDCEZABFGZCFGZABCFGZFGZHTAIJZBFGZCFGZUGUEFGZ
    HUGUABIJZFGZCFGZUGUKCFGZFGZHULUBCIJZFGZUGUKUPFGZFGZHABCIIIAUGHZUDUIUFUJUTUC
    UHCFAUGBFKLAUGUEFKMBUKHZUIUMUJUOVAUHULCFBUKUGFNLVAUEUNUGFBUKCFKOMCUPHZUMUQU
    OUSCUPULFNVBUNURUGFCUPUKFNOMUGUKUPDDAIQRDDBIQRDDCIQRPS $.

  $( Commutative/associative law for Hilbert space operator sum that swaps the
     second and third terms.  (Contributed by NM, 24-Aug-2006.)
     (New usage is discouraged.) $)
  hoadd32 $p |- ( ( R : ~H --> ~H /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( ( R +op S ) +op T ) = ( ( R +op T ) +op S ) ) $=
    ( chil wf w3a chos co wceq hoaddcom 3adant1 oveq2d hoaddass 3com23 3eqtr4d
    ) DDAEZDDBEZDDCEZFZABCGHZGHACBGHZGHZABGHCGHACGHBGHZSTUAAGQRTUAIPBCJKLABCMPR
    QUCUBIACBMNO $.

  $( Rearrangement of 4 terms in a sum of Hilbert space operators.
     (Contributed by NM, 24-Aug-2006.)  (New usage is discouraged.) $)
  hoadd4 $p |- ( ( ( R : ~H --> ~H /\ S : ~H --> ~H ) /\
      ( T : ~H --> ~H /\ U : ~H --> ~H ) ) -> ( ( R +op S ) +op ( T +op U ) ) =
                ( ( R +op T ) +op ( S +op U ) ) ) $=
    ( chil wf wa chos co wceq w3a hoadd32 oveq1d 3expa adantrr hoaddcl hoaddass
    3expb sylan an4s 3eqtr3d ) EEAFZEEBFZGZEECFZEEDFZGZGABHIZCHIZDHIZACHIZBHIZD
    HIZUHCDHIHIZUKBDHIHIZUDUEUJUMJZUFUBUCUEUPUBUCUEKUIULDHABCLMNOUDEEUHFZUGUJUN
    JZABPUQUEUFURUHCDQRSUBUEUCUFUMUOJZUBUEGEEUKFZUCUFGUSACPUTUCUFUSUKBDQRSTUA
    $.

  $( Distributive law for Hilbert space operator difference.  (Contributed by
     NM, 23-Aug-2006.)  (New usage is discouraged.) $)
  hocsubdir $p |- ( ( R : ~H --> ~H /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( ( R -op S ) o. T ) = ( ( R o. T ) -op ( S o. T ) ) ) $=
    ( chil wf chod co ccom wceq ch0o cif oveq1 coeq1d coeq1 eqeq12d oveq2 coeq2
    oveq1d ho0f elimf oveq2d oveq12d hocsubdiri dedth3h ) DDAEZDDBEZDDCEZABFGZC
    HZACHZBCHZFGZIUEAJKZBFGZCHZUMCHZUKFGZIUMUFBJKZFGZCHZUPURCHZFGZIUSUGCJKZHZUM
    VCHZURVCHZFGZIABCJJJAUMIZUIUOULUQVHUHUNCAUMBFLMVHUJUPUKFAUMCNROBURIZUOUTUQV
    BVIUNUSCBURUMFPMVIUKVAUPFBURCNUAOCVCIZUTVDVBVGCVCUSQVJUPVEVAVFFCVCUMQCVCURQ
    UBOUMURVCDDAJSTDDBJSTDDCJSTUCUD $.

  ${
    $d x T $.
    hoaddid1.1 $e |- T : ~H --> ~H $.
    $( Sum of a Hilbert space operator with the zero operator.  (Contributed by
       NM, 15-Nov-2000.)  (New usage is discouraged.) $)
    hoaddid1i $p |- ( T +op 0hop ) = T $=
      ( vx cv ch0o chos co cfv wceq chil wral wcel cva wf hosval mp3an12 ho0val
      c0v ho0f oveq2d ffvelrni ax-hvaddid syl 3eqtrd rgen hoaddcli hoeqi mpbi )
      CDZAEFGZHZUIAHZIZCJKUJAIUMCJUIJLZUKULUIEHZMGZULRMGZULJJANJJENUNUKUPIBSUIA
      EOPUNUORULMUIQTUNULJLUQULIJJUIABUAULUBUCUDUECUJAAEBSUFBUGUH $.

    $( Difference of a Hilbert space operator from itself.  (Contributed by NM,
       10-Mar-2006.)  (New usage is discouraged.) $)
    hodidi $p |- ( T -op T ) = 0hop $=
      ( chod co ch0o wceq chos hoaddid1i ho0f hodsi mpbir ) AACDEFAEGDAFABHAAEB
      BIJK $.

    $( Composition of the zero operator and a Hilbert space operator.
       (Contributed by NM, 9-Aug-2006.)  (New usage is discouraged.) $)
    ho0coi $p |- ( 0hop o. T ) = 0hop $=
      ( vx ch0o ccom cfv wceq chil wral wcel c0v ffvelrni ho0val syl ho0f hocoi
      cv 3eqtr4d rgen hocofi hoeqi mpbi ) CQZDAEZFZUCDFZGZCHIUDDGUGCHUCHJZUCAFZ
      DFZKUEUFUHUIHJUJKGHHUCABLUIMNUCDAOBPUCMRSCUDDDAOBTOUAUB $.

    $( Composition of Hilbert space operator with unit identity.  (Contributed
       by NM, 15-Nov-2000.)  (New usage is discouraged.) $)
    hoid1i $p |- ( T o. Iop ) = T $=
      ( vx chio ccom chil cpjh df-iop coeq2i cv wceq wral wcel helch pjfi hocoi
      cfv pjch1 fveq2d eqtrd rgen hocofi hoeqi mpbi eqtri ) ADEAFGQZEZADUFAHICJ
      ZUGQZUHAQZKZCFLUGAKUKCFUHFMZUIUHUFQZAQUJUHAUFBFNOZPULUMUHAUHRSTUACUGAAUFB
      UNUBBUCUDUE $.

    $( Composition of Hilbert space operator with unit identity.  (Contributed
       by NM, 15-Nov-2000.)  (New usage is discouraged.) $)
    hoid1ri $p |- ( Iop o. T ) = T $=
      ( vx chio ccom chil cpjh df-iop coeq1i cv wceq wral wcel helch pjfi hocoi
      cfv ffvelrni pjch1 syl eqtrd rgen hocofi hoeqi mpbi eqtri ) DAEFGQZAEZADU
      GAHICJZUHQZUIAQZKZCFLUHAKULCFUIFMZUJUKUGQZUKUIUGAFNOZBPUMUKFMUNUKKFFUIABR
      UKSTUAUBCUHAUGAUOBUCBUDUEUF $.
  $}

  $( Sum of a Hilbert space operator with the zero operator.  (Contributed by
     NM, 25-Jul-2006.)  (New usage is discouraged.) $)
  hoaddid1 $p |- ( T : ~H --> ~H -> ( T +op 0hop ) = T ) $=
    ( chil wf ch0o chos co wceq cif oveq1 id eqeq12d ho0f elimf hoaddid1i dedth
    ) BBACZADEFZAGPADHZDEFZRGADARGZQSARARDEITJKRBBADLMNO $.

  $( Difference of a Hilbert space operator from itself.  (Contributed by NM,
     23-Jul-2006.)  (New usage is discouraged.) $)
  hodid $p |- ( T : ~H --> ~H -> ( T -op T ) = 0hop ) $=
    ( chil wf chod co ch0o wceq cif id oveq12d eqeq1d ho0f elimf hodidi dedth )
    BBACZAADEZFGPAFHZRDEZFGAFARGZQSFTARARDTIZUAJKRBBAFLMNO $.

  $( A Hilbert space operator is not empty.  (Contributed by NM, 24-Mar-2006.)
     (New usage is discouraged.) $)
  hon0 $p |- ( T : ~H --> ~H -> -. T = (/) ) $=
    ( chil wf c0 wceq c0v wn ax-hv0cl n0i ax-mp wfn fn0 wi ffn fndmu ex syl5bir
    wcel syl mtoi ) BBACZADEZBDEZFBRUCGHBFIJUBADKZUAUCALUAABKZUDUCMBBANUEUDUCBD
    AOPSQT $.

  ${
    $d x S $.  $d x T $.
    hodseq.2 $e |- S : ~H --> ~H $.
    hodseq.3 $e |- T : ~H --> ~H $.
    $( Subtraction and addition of equal Hilbert space operators.  (Contributed
       by NM, 27-Aug-2004.)  (New usage is discouraged.) $)
    hodseqi $p |- ( S +op ( T -op S ) ) = T $=
      ( chod co wceq chos eqid hosubcli hodsi mpbi ) BAEFZMGAMHFBGMIBAMDCBADCJK
      L $.

    $( Subtraction of Hilbert space operators expressed in terms of difference
       from zero.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    ho0subi $p |- ( S -op T ) = ( S +op ( 0hop -op T ) ) $=
      ( chod co ch0o chos wceq ho0f hosubcli hoadd12i oveq2i hoaddid1i hoaddcli
      hodseqi 3eqtri hodsi mpbir ) ABEFAGBEFZHFZIBUAHFZAIUBABTHFZHFAGHFABATDCGB
      JDKZLUCGAHBGDJPMACNQABUACDATCUDORS $.

    $( Relationship between Hilbert operator addition and subtraction.
       (Contributed by NM, 24-Aug-2006.)  (New usage is discouraged.) $)
    honegsubi $p |- ( S +op ( -u 1 .op T ) ) = ( S -op T ) $=
      ( vx cv c1 cneg chot co cfv wceq chil wcel cva wf neg1cn mp3an12 ffvelrni
      eqtr4d chos chod wral cmv cc homulcl mp2an hosval hvsubval syl2anc homval
      csm oveq2d hodval rgen hoaddcli hosubcli hoeqi mpbi ) EFZAGHZBIJZUAJZKZUT
      ABUBJZKZLZEMUCVCVELVGEMUTMNZVDUTAKZUTBKZUDJZVFVHVDVIUTVBKZOJZVKMMAPZMMVBP
      ZVHVDVMLCVAUENZMMBPZVOQDVABUFUGZUTAVBUHRVHVKVIVAVJULJZOJZVMVHVIMNVJMNVKVT
      LMMUTACSMMUTBDSVIVJUIUJVHVLVSVIOVPVQVHVLVSLQDVAUTBUKRUMTTVNVQVHVFVKLCDUTA
      BUNRTUOEVCVEAVBCVRUPABCDUQURUS $.

$(
    @( Distributive law for Hilbert space operators. @)
    hosdi @p |- ( A e. CC ->
                 ( A .op ( S +op T ) ) = ( ( A .op S ) +op ( A .op T ) ) ) @=
?@.

    @( Distributive law for Hilbert space operators. @)
    hoddii @p |- ( A e. CC ->
                 ( A .op ( S -op T ) ) = ( ( A .op S ) -op ( A .op T ) ) ) @=
?@.
$)
  $}

  $( Subtraction of Hilbert space operators expressed in terms of difference
     from zero.  (Contributed by NM, 25-Jul-2006.)
     (New usage is discouraged.) $)
  ho0sub $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
                ( S -op T ) = ( S +op ( 0hop -op T ) ) ) $=
    ( chil wf chod co ch0o chos wceq cif oveq1 eqeq12d oveq2 ho0f elimf ho0subi
    oveq2d dedth2h ) CCADZCCBDZABEFZAGBEFZHFZISAGJZBEFZUDUBHFZIUDTBGJZEFZUDGUGE
    FZHFZIABGGAUDIUAUEUCUFAUDBEKAUDUBHKLBUGIZUEUHUFUJBUGUDEMUKUBUIUDHBUGGEMQLUD
    UGCCAGNOCCBGNOPR $.

  $( The zero operator subtracted from a Hilbert space operator.  (Contributed
     by NM, 25-Jul-2006.)  (New usage is discouraged.) $)
  hosubid1 $p |- ( T : ~H --> ~H -> ( T -op 0hop ) = T ) $=
    ( chil wf ch0o chod co chos wceq ho0sub mpan2 hodidi oveq2i hoaddid1 syl5eq
    ho0f eqtrd ) BBACZADEFZADDEFZGFZAQBBDCRTHOADIJQTADGFASDAGDOKLAMNP $.

  $( Relationship between Hilbert space operator addition and subtraction.
     (Contributed by NM, 24-Aug-2006.)  (New usage is discouraged.) $)
  honegsub $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                ( T +op ( -u 1 .op U ) ) = ( T -op U ) ) $=
    ( chil wf c1 cneg chot co chos chod wceq ch0o cif oveq1 eqeq12d oveq2d ho0f
    oveq2 elimf honegsubi dedth2h ) CCADZCCBDZAEFZBGHZIHZABJHZKUBALMZUEIHZUHBJH
    ZKUHUDUCBLMZGHZIHZUHUKJHZKABLLAUHKUFUIUGUJAUHUEINAUHBJNOBUKKZUIUMUJUNUOUEUL
    UHIBUKUDGRPBUKUHJROUHUKCCALQSCCBLQSTUA $.

  ${
    $d x A $.  $d x B $.  $d x T $.  $d x U $.
    $( An operator equals its scalar product with one.  (Contributed by NM,
       12-Aug-2006.)  (New usage is discouraged.) $)
    homulid2 $p |- ( T : ~H --> ~H -> ( 1 .op T ) = T ) $=
      ( vx chil wf cv c1 chot co cfv wceq wral wcel wa csm ax-1cn homval mp3an1
      cc ffvelrn ax-hvmulid syl eqtrd ralrimiva homulcl mpan hoeq mpancom mpbid
      wb ) CCADZBEZFAGHZIZUKAIZJZBCKZULAJZUJUOBCUJUKCLZMZUMFUNNHZUNFRLZUJURUMUT
      JOFUKAPQUSUNCLUTUNJCCUKASUNTUAUBUCCCULDZUJUPUQUIVAUJVBOFAUDUEBULAUFUGUH
      $.

    $( Associative law for scalar product and composition of operators.
       (Contributed by NM, 13-Aug-2006.)  (New usage is discouraged.) $)
    homco1 $p |- ( ( A e. CC /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( A .op T ) o. U ) = ( A .op ( T o. U ) ) ) $=
      ( vx wcel chil wf chot co ccom cfv wceq csm fvco3 3ad2antl3 homval eqtr4d
      wa fco 3impb cc w3a wral oveq2d ffvelrn syl3an3 3expa exp43 3imp1 syl3an2
      cv wi 3expia imp ralrimiva homulcl sylan 3impa sylan2 hoeq syl2anc mpbid
      wb ) AUAEZFFBGZFFCGZUBZDUKZABHIZCJZKZVHABCJZHIZKZLZDFUCZVJVMLZVGVODFVGVHF
      EZRZVKAVHVLKZMIZVNVSVKVHCKZVIKZWAVFVDVRVKWCLVEFFVHVICNOVSWAAWBBKZMIZWCVSV
      TWDAMVFVDVRVTWDLVEFFVHBCNOUDVDVEVFVRWCWELZVDVEVFVRWFVDVEVFVRRZWFWGVDVEWBF
      EWFFFVHCUEAWBBPUFUGUHUIQQVGVRVNWALZVDVEVFVRWHULVDVEVFRZVRWHWIVDFFVLGZVRWH
      FFFBCSZAVHVLPUJUMTUNQUOVGFFVJGZFFVMGZVPVQVCVDVEVFWLVDVERFFVIGVFWLABUPFFFV
      ICSUQURVDVEVFWMWIVDWJWMWKAVLUPUSTDVJVMUTVAVB $.

    $( Scalar product associative law for Hilbert space operators.
       (Contributed by NM, 12-Aug-2006.)  (New usage is discouraged.) $)
    homulass $p |- ( ( A e. CC /\ B e. CC /\ T : ~H --> ~H ) ->
                  ( ( A x. B ) .op T ) = ( A .op ( B .op T ) ) ) $=
      ( vx cc wcel chil wf w3a co chot cfv wceq wa csm wi homval 3expia homulcl
      eqtr4d cv cmul wral mulcl syl3an1 3impa imp oveq2d 3expa 3adantl1 ffvelrn
      ax-hvmulass syl3an3 exp43 3imp1 syl3an2 3impb ralrimiva sylan sylan2 hoeq
      wb syl2anc mpbid ) AEFZBEFZGGCHZIZDUAZABUBJZCKJZLZVIABCKJZKJZLZMZDGUCZVKV
      NMZVHVPDGVHVIGFZNZVLAVIVMLZOJZVOVTVLVJVICLZOJZWBVHVSVLWDMZVEVFVGVSWEPVEVF
      NZVGVSWEWFVJEFZVGVSWEABUDZVJVICQUERUFUGVTWBABWCOJZOJZWDVFVGVSWBWJMZVEVFVG
      VSWKVFVGVSIWAWIAOBVICQUHUIUJVEVFVGVSWDWJMZVEVFVGVSWLVEVFVGVSNZWLWMVEVFWCG
      FWLGGVICUKABWCULUMUIUNUOTTVHVSVOWBMZVEVFVGVSWNPVEVFVGNZVSWNWOVEGGVMHZVSWN
      BCSZAVIVMQUPRUQUGTURVHGGVKHZGGVNHZVQVRVBVEVFVGWRWFWGVGWRWHVJCSUSUFVEVFVGW
      SWOVEWPWSWQAVMSUTUQDVKVNVAVCVD $.

    $( Scalar product distributive law for Hilbert space operators.
       (Contributed by NM, 12-Aug-2006.)  (New usage is discouraged.) $)
    hoadddi $p |- ( ( A e. CC /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                 ( A .op ( T +op U ) ) = ( ( A .op T ) +op ( A .op U ) ) ) $=
      ( vx wcel chil wf w3a chos co chot cfv wceq csm cva ffvelrn 3expa homulcl
      wa homval cc cv wral simpl1 3ad2antl2 3ad2antl3 ax-hvdistr1 hosval oveq2d
      syl3anc 3adantl1 3adantl3 3adantl2 oveq12d 3eqtr4d hoaddcl anim2i anim12i
      3impb sylan 3impdi ralrimiva wb sylan2 syl2an hoeq syl2anc mpbid ) AUAEZF
      FBGZFFCGZHZDUBZABCIJZKJZLZVMABKJZACKJZIJZLZMZDFUCZVOVSMZVLWADFVLVMFEZSZAV
      MVNLZNJZVMVQLZVMVRLZOJZVPVTWEAVMBLZVMCLZOJZNJZAWKNJZAWLNJZOJZWGWJWEVIWKFE
      ZWLFEZWNWQMVIVJVKWDUDVJVIWDWRVKFFVMBPUEVKVIWDWSVJFFVMCPUFAWKWLUGUJVJVKWDW
      GWNMZVIVJVKWDWTVJVKWDHWFWMANVMBCUHUIQUKWEWHWOWIWPOVIVJWDWHWOMZVKVIVJWDXAA
      VMBTQULVIVKWDWIWPMZVJVIVKWDXBAVMCTQUMUNUOVLVIFFVNGZSZWDVPWGMZVIVJVKXDVJVK
      SZXCVIBCUPZUQUSVIXCWDXEAVMVNTQUTVLFFVQGZFFVRGZSZWDVTWJMZVIVJVKXJVIVJSZXHV
      IVKSZXIABRZACRZURVAXHXIWDXKVMVQVRUHQUTUOVBVLFFVOGZFFVSGZWBWCVCVIVJVKXPXFV
      IXCXPXGAVNRVDUSVIVJVKXQXLXHXIXQXMXNXOVQVRUPVEVADVOVSVFVGVH $.

    $( Scalar product reverse distributive law for Hilbert space operators.
       (Contributed by NM, 25-Aug-2006.)  (New usage is discouraged.) $)
    hoadddir $p |- ( ( A e. CC /\ B e. CC /\ T : ~H --> ~H ) ->
                 ( ( A + B ) .op T ) = ( ( A .op T ) +op ( B .op T ) ) ) $=
      ( vx cc wcel chil wf co chot cfv wceq cva csm homval 3expa eqtr4d homulcl
      wa sylan w3a caddc chos wral addcl anim1i 3impa 3adantl2 3adantl1 oveq12d
      cv ffvelrn ax-hvdistr2 syl3an3 3exp exp4a 3imp1 anim12i 3impdir ralrimiva
      hosval wb hoaddcl syl2an hoeq syl2anc mpbid ) AEFZBEFZGGCHZUAZDUKZABUBIZC
      JIZKZVLACJIZBCJIZUCIZKZLZDGUDZVNVRLZVKVTDGVKVLGFZSZVOVLVPKZVLVQKZMIZVSWDV
      OVMVLCKZNIZWGVKVMEFZVJSZWCVOWILZVHVIVJWKVHVISZWJVJABUEZUFUGWJVJWCWLVMVLCO
      PTWDWGAWHNIZBWHNIZMIZWIWDWEWOWFWPMVHVJWCWEWOLZVIVHVJWCWRAVLCOPUHVIVJWCWFW
      PLZVHVIVJWCWSBVLCOPUIUJVHVIVJWCWIWQLZVHVIVJWCWTVHVIVJWCSZWTXAVHVIWHGFWTGG
      VLCULABWHUMUNUOUPUQQQVKGGVPHZGGVQHZSZWCVSWGLZVHVJVIXDVHVJSZXBVIVJSZXCACRZ
      BCRZURUSXBXCWCXEVLVPVQVAPTQUTVKGGVNHZGGVRHZWAWBVBVHVIVJXJWMWJVJXJWNVMCRTU
      GVHVJVIXKXFXBXCXKXGXHXIVPVQVCVDUSDVNVRVEVFVG $.
  $}

  $( Swap first and second factors in a nested operator scalar product.
     (Contributed by NM, 12-Aug-2006.)  (New usage is discouraged.) $)
  homul12 $p |- ( ( A e. CC /\ B e. CC /\ T : ~H --> ~H ) ->
                ( A .op ( B .op T ) ) = ( B .op ( A .op T ) ) ) $=
    ( cc wcel chil wf w3a cmul co chot wa mulcom oveq1d 3adant3 homulass 3com12
    wceq 3eqtr3d ) ADEZBDEZFFCGZHABIJZCKJZBAIJZCKJZABCKJKJBACKJKJZTUAUDUFRUBTUA
    LUCUECKABMNOABCPUATUBUFUGRBACPQS $.

  $( Double negative of a Hilbert space operator.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  honegneg $p |- ( T : ~H --> ~H -> ( -u 1 .op ( -u 1 .op T ) ) = T ) $=
    ( chil wf c1 cneg cmul co chot ax-1cn mul2negi 1t1e1 eqtri oveq1i wcel wceq
    cc neg1cn homulass mp3an12 homulid2 3eqtr3a ) BBACZDEZUCFGZAHGZDAHGUCUCAHGH
    GZAUDDAHUDDDFGDDDIIJKLMUCPNZUGUBUEUFOQQUCUCARSATUA $.

  $( Relationship between operator subtraction and negative.  (Contributed by
     NM, 25-Aug-2006.)  (New usage is discouraged.) $)
  hosubneg $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( T -op ( -u 1 .op U ) ) = ( T +op U ) ) $=
    ( chil wf wa c1 cneg chot co chos chod wceq cc wcel neg1cn homulcl honegsub
    mpan sylan2 honegneg oveq2d adantl eqtr3d ) CCADZCCBDZEAFGZUFBHIZHIZJIZAUGK
    IZABJIZUEUDCCUGDZUIUJLUFMNUEULOUFBPRAUGQSUEUIUKLUDUEUHBAJBTUAUBUC $.

  $( Scalar product distributive law for operator difference.  (Contributed by
     NM, 12-Aug-2006.)  (New usage is discouraged.) $)
  hosubdi $p |- ( ( A e. CC /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
               ( A .op ( T -op U ) ) = ( ( A .op T ) -op ( A .op U ) ) ) $=
    ( cc wcel chil wf w3a c1 cneg chot co chos chod wceq neg1cn oveq2d honegsub
    homulcl wa mpan hoadddi syl3an3 homul12 mp3an2 3adant2 eqtrd 3adant1 syl2an
    3impdi 3eqtr3d ) ADEZFFBGZFFCGZHZABIJZCKLZMLZKLZABKLZUPACKLZKLZMLZABCNLZKLZ
    UTVANLZUOUSUTAUQKLZMLZVCUNULUMFFUQGZUSVHOUPDEZUNVIPUPCSUAABUQUBUCUOVGVBUTMU
    LUNVGVBOZUMULVJUNVKPAUPCUDUEUFQUGUMUNUSVEOULUMUNTURVDAKBCRQUHULUMUNVCVFOZUL
    UMTFFUTGFFVAGVLULUNTABSACSUTVARUIUJUK $.

  $( Distribution of negative over addition.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  honegdi $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
          ( -u 1 .op ( T +op U ) ) = ( ( -u 1 .op T ) +op ( -u 1 .op U ) ) ) $=
    ( c1 cneg cc wcel chil wf chos co chot wceq neg1cn hoadddi mp3an1 ) CDZEFGG
    AHGGBHPABIJKJPAKJPBKJIJLMPABNO $.

  $( Distribution of negative over subtraction.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  honegsubdi $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                    ( -u 1 .op ( T -op U ) ) = ( ( -u 1 .op T ) +op U ) ) $=
    ( chil wf wa c1 cneg chot co chos chod wceq wcel neg1cn homulcl mpan sylan2
    cc honegdi oveq2d honegsub honegneg adantl 3eqtr3d ) CCADZCCBDZEZFGZAUHBHIZ
    JIZHIZUHAHIZUHUIHIZJIZUHABKIZHIULBJIUFUECCUIDZUKUNLUHRMUFUPNUHBOPAUISQUGUJU
    OUHHABUATUGUMBULJUFUMBLUEBUBUCTUD $.

  $( Distribution of negative over subtraction.  (Contributed by NM,
     24-Aug-2006.)  (New usage is discouraged.) $)
  honegsubdi2 $p |- ( ( T : ~H --> ~H /\ U : ~H --> ~H ) ->
                     ( -u 1 .op ( T -op U ) ) = ( U -op T ) ) $=
    ( chil wf wa c1 cneg chod co chot chos honegsubdi wceq cc wcel homulcl mpan
    neg1cn hoaddcom sylan honegsub ancoms 3eqtrd ) CCADZCCBDZEFGZABHIJIUFAJIZBK
    IZBUGKIZBAHIZABLUDCCUGDZUEUHUIMUFNOUDUKRUFAPQUGBSTUEUDUIUJMBAUAUBUC $.

  $( Law for double subtraction of Hilbert space operators.  (Contributed by
     NM, 24-Aug-2006.)  (New usage is discouraged.) $)
  hosubsub2 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( S -op ( T -op U ) ) = ( S +op ( U -op T ) ) ) $=
    ( chil wf w3a c1 cneg chod co chot chos wceq wa honegsub sylan2 honegsubdi2
    hosubcl 3impb oveq2d 3adant1 eqtr3d ) DDAEZDDBEZDDCEZFAGHBCIJZKJZLJZAUFIJZA
    CBIJZLJZUCUDUEUHUIMZUDUENZUCDDUFEULBCRAUFOPSUDUEUHUKMUCUMUGUJALBCQTUAUB $.

  $( Rearrangement of 4 terms in a mixed addition and subtraction of Hilbert
     space operators.  (Contributed by NM, 24-Aug-2006.)
     (New usage is discouraged.) $)
  hosub4 $p |- ( ( ( R : ~H --> ~H /\ S : ~H --> ~H ) /\
      ( T : ~H --> ~H /\ U : ~H --> ~H ) ) -> ( ( R +op S ) -op ( T +op U ) ) =
                ( ( R -op T ) +op ( S -op U ) ) ) $=
    ( chil wf wa chos co c1 cneg chot chod wceq honegdi neg1cn homulcl honegsub
    mpan hoaddcl adantl oveq2d wcel anim12i hoadd4 sylan2 eqtrd syl2an ad2ant2r
    cc ad2ant2l oveq12d 3eqtr3d ) EEAFZEEBFZGZEECFZEEDFZGZGZABHIZJKZCDHIZLIZHIZ
    AVBCLIZHIZBVBDLIZHIZHIZVAVCMIZACMIZBDMIZHIUTVEVAVFVHHIZHIZVJUTVDVNVAHUSVDVN
    NUPCDOUAUBUSUPEEVFFZEEVHFZGVOVJNUQVPURVQVBUJUCZUQVPPVBCQSVRURVQPVBDQSUDABVF
    VHUEUFUGUPEEVAFEEVCFVEVKNUSABTCDTVAVCRUHUTVGVLVIVMHUNUQVGVLNUOURACRUIUOURVI
    VMNUNUQBDRUKULUM $.

  $( Rearrangement of 4 terms in a mixed addition and subtraction of Hilbert
     space operators.  (Contributed by NM, 24-Aug-2006.)
     (New usage is discouraged.) $)
  hosubadd4 $p |- ( ( ( R : ~H --> ~H /\ S : ~H --> ~H ) /\
      ( T : ~H --> ~H /\ U : ~H --> ~H ) ) -> ( ( R -op S ) -op ( T -op U ) ) =
                ( ( R +op U ) -op ( S +op T ) ) ) $=
    ( chil wf wa chod co chos hosubcl hosubsub2 3expb sylan hosub4 an42s eqtr4d
    wceq ) EEAFZEEBFZGZEECFZEEDFZGZGABHIZCDHIHIZUEDCHIJIZADJIBCJIHIZUAEEUEFZUDU
    FUGRZABKUIUBUCUJUECDLMNSUCTUBUHUGRADBCOPQ $.

  $( Associative-type law for addition and subtraction of Hilbert space
     operators.  (Contributed by NM, 25-Aug-2006.)
     (New usage is discouraged.) $)
  hoaddsubass $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( S +op T ) -op U ) = ( S +op ( T -op U ) ) ) $=
    ( chil wf chos co ch0o chod wceq ho0f hosubcl mpan hoaddass syl3an3 hoaddcl
    w3a wa ho0sub sylan 3impa 3adant1 oveq2d 3eqtr4d ) DDAEZDDBEZDDCEZQZABFGZHC
    IGZFGZABUJFGZFGZUICIGZABCIGZFGUGUEUFDDUJEZUKUMJDDHEUGUPKHCLMABUJNOUEUFUGUNU
    KJZUEUFRDDUIEUGUQABPUICSTUAUHUOULAFUFUGUOULJUEBCSUBUCUD $.

  $( Law for operator addition and subtraction of Hilbert space operators.
     (Contributed by NM, 25-Aug-2006.)  (New usage is discouraged.) $)
  hoaddsub $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( S +op T ) -op U ) = ( ( S -op U ) +op T ) ) $=
    ( chil wf w3a chos co chod wa hoaddcom oveq1d 3adant3 hoaddsubass 3com12 wi
    wceq hosubcl ex syl5 exp3a com12 3imp 3eqtrd ) DDAEZDDBEZDDCEZFABGHZCIHZBAG
    HZCIHZBACIHZGHZULBGHZUEUFUIUKQUGUEUFJUHUJCIABKLMUFUEUGUKUMQBACNOUEUFUGUMUNQ
    ZUFUEUGUOPUFUEUGUOUEUGJDDULEZUFUOACRUFUPUOBULKSTUAUBUCUD $.

  $( Law for double subtraction of Hilbert space operators.  (Contributed by
     NM, 25-Aug-2006.)  (New usage is discouraged.) $)
  hosubsub $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( S -op ( T -op U ) ) = ( ( S -op T ) +op U ) ) $=
    ( chil wf w3a chod co chos hosubsub2 wceq hoaddsubass hoaddsub eqtr3d eqtrd
    3com23 ) DDAEZDDBEZDDCEZFABCGHGHACBGHIHZABGHCIHZABCJQSRTUAKQSRFACIHBGHTUAAC
    BLACBMNPO $.

  $( Law for double subtraction of Hilbert space operators.  (Contributed by
     NM, 25-Aug-2006.)  (New usage is discouraged.) $)
  hosubsub4 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H /\ U : ~H --> ~H ) ->
                  ( ( S -op T ) -op U ) = ( S -op ( T +op U ) ) ) $=
    ( chil wf w3a c1 cneg chot chod chos wceq wcel neg1cn homulcl mpan hosubsub
    co cc syl3an3 hosubneg 3adant1 oveq2d hosubcl honegsub sylan 3impa 3eqtr3rd
    wa ) DDAEZDDBEZDDCEZFZABGHZCIRZJRZJRZABJRZUOKRZABCKRZJRURCJRZULUJUKDDUOEZUQ
    USLUNSMULVBNUNCOPABUOQTUMUPUTAJUKULUPUTLUJBCUAUBUCUJUKULUSVALZUJUKUIDDUREUL
    VCABUDURCUEUFUGUH $.

  $( Two times a Hilbert space operator.  (Contributed by NM, 26-Aug-2006.)
     (New usage is discouraged.) $)
  ho2times $p |- ( T : ~H --> ~H -> ( 2 .op T ) = ( T +op T ) ) $=
    ( chil wf c2 chot co c1 chos caddc df-2 oveq1i cc wcel wceq ax-1cn hoadddir
    mp3an12 syl5eq hoadddi anidms mp3an1 hoaddcl homulid2 syl 3eqtr2d ) BBACZDA
    EFZGAEFZUHHFZGAAHFZEFZUJUFUGGGIFZAEFZUIDULAEJKGLMZUNUFUMUINOOGGAPQRUFUKUINZ
    UNUFUFUOOGAASUATUFBBUJCZUKUJNUFUPAAUBTUJUCUDUE $.

  ${
    hoaddsubass.1 $e |- R : ~H --> ~H $.
    hoaddsubass.2 $e |- S : ~H --> ~H $.
    hoaddsubass.3 $e |- T : ~H --> ~H $.
    $( Associativity of sum and difference of Hilbert space operators.
       (Contributed by NM, 27-Aug-2004.)  (New usage is discouraged.) $)
    hoaddsubassi $p |- ( ( R +op S ) -op T ) = ( R +op ( S -op T ) ) $=
      ( chil wf chos co chod wceq hoaddsubass mp3an ) GGAHGGBHGGCHABIJCKJABCKJI
      JLDEFABCMN $.

    $( Law for sum and difference of Hilbert space operators.  (Contributed by
       NM, 27-Aug-2004.)  (New usage is discouraged.) $)
    hoaddsubi $p |- ( ( R +op S ) -op T ) = ( ( R -op T ) +op S ) $=
      ( chos co chod hoaddcomi oveq1i hoaddsubassi hosubcli 3eqtri ) ABGHZCIHBA
      GHZCIHBACIHZGHQBGHOPCIABDEJKBACEDFLBQEACDFMJN $.
  $}

  ${
    hosd1.2 $e |- T : ~H --> ~H $.
    hosd1.3 $e |- U : ~H --> ~H $.
    $( Hilbert space operator sum expressed in terms of difference.
       (Contributed by NM, 27-Aug-2004.)  (New usage is discouraged.) $)
    hosd1i $p |- ( T +op U ) = ( T -op ( 0hop -op U ) ) $=
      ( ch0o chod co chos wceq hosubcli hoaddcomi hoaddsubassi eqtr4i hoaddid1i
      ho0f hoaddcli oveq1i hoaddsubi hodseqi 3eqtri hodsi mpbir eqcomi ) AEBFGZ
      FGZABHGZUEUFIUDUFHGZAIUGUFEHGZBFGZUFBFGZAUGUFUDHGUIUDUFEBODJZABCDPZKUFEBU
      LODLMUHUFBFUFULNQUJABFGZBHGBUMHGAABBCDDRUMBABCDJDKBADCSTTAUDUFCUKULUAUBUC
      $.

    $( Hilbert space operator sum expressed in terms of difference.
       (Contributed by NM, 27-Aug-2004.)  (New usage is discouraged.) $)
    hosd2i $p |- ( T +op U ) = ( T -op ( ( U -op U ) -op U ) ) $=
      ( chos co ch0o chod hosd1i hodidi oveq1i oveq2i eqtr4i ) ABEFAGBHFZHFABBH
      FZBHFZHFABCDIPNAHOGBHBDJKLM $.

    $( Hilbert space operator cancellation law.  (Contributed by NM,
       10-Mar-2006.)  (New usage is discouraged.) $)
    hopncani $p |- ( ( T +op U ) -op U ) = T $=
      ( chos co chod ch0o hoaddsubassi hodidi oveq2i hoaddid1i 3eqtri ) ABEFBGF
      ABBGFZEFAHEFAABBCDDINHAEBDJKACLM $.

    $( Hilbert space operator cancellation law.  (Contributed by NM,
       11-Mar-2006.)  (New usage is discouraged.) $)
    honpcani $p |- ( ( T -op U ) +op U ) = T $=
      ( chos co chod hoaddsubi hopncani eqtr3i ) ABEFBGFABGFBEFAABBCDDHABCDIJ
      $.

    $( If the difference between two operators is zero, they are equal.
       (Contributed by NM, 27-Jul-2006.)  (New usage is discouraged.) $)
    hosubeq0i $p |- ( ( T -op U ) = 0hop <-> T = U ) $=
      ( chod co ch0o wceq c1 cneg chot chos honegsubi eqeq1i oveq1 sylbir eqtri
      chil wf hoaddid1i cc wcel neg1cn homulcl hoadd32i hoaddassi hodidi oveq2i
      mp2an ho0f hoaddcomi 3eqtr3g syl6eq impbii ) ABEFZGHZABHZUPAIJZBKFZLFZBLF
      ZGBLFZABUPUTGHVAVBHUTUOGABCDMNUTGBLOPVAABLFUSLFZAAUSBCURUAUBRRBSRRUSSUCDU
      RBUDUIZDUEVCABUSLFZLFZAABUSCDVDUFVFAGLFAVEGALVEBBEFZGBBDDMBDUGZQUHACTQQQV
      BBGLFBGBUJDUKBDTQULUQUOVGGABBEOVHUMUN $.
  $}

  ${
    honpncan.1 $e |- R : ~H --> ~H $.
    honpncan.2 $e |- S : ~H --> ~H $.
    honpncan.3 $e |- T : ~H --> ~H $.
    $( Hilbert space operator cancellation law.  (Contributed by NM,
       11-Mar-2006.)  (New usage is discouraged.) $)
    honpncani $p |- ( ( R -op S ) +op ( S -op T ) ) = ( R -op T ) $=
      ( chod co chos hosubcli hoaddsubassi honpcani oveq1i eqtr3i ) ABGHZBIHZCG
      HOBCGHIHACGHOBCABDEJEFKPACGABDELMN $.
  $}

  ${
    $d x y T $.
    ho0.1 $e |- T : ~H --> ~H $.
    $( A condition implying that a Hilbert space operator is identically zero.
       Lemma 3.2(S8) of [Beran] p. 95.  (Contributed by NM, 28-Jan-2006.)
       (New usage is discouraged.) $)
    ho01i $p |- ( A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = 0 <->
               T = 0hop ) $=
      ( chil c0v csn cxp wceq cv cfv wral ch0o wfn wb wf ffn ax-mp c0h wcel csp
      co ax-hv0cl elexi fconst eqfnfv mp2an df0op2 df-ch0 xpeq2i eqtri ffvelrni
      cc0 eqeq2i hial0 syl fvconst2 eqeq2d bitr4d ralbiia 3bitr4ri ) CEFGZHZIZA
      JZCKZVEVCKZIZAELZCMIVFBJUAUBUMIBELZAELCENZVCENZVDVIOEECPVKDEECQREVBVCPVLE
      FFEUCUDZUEEVBVCQRAECVCUFUGMVCCMESHVCUHSVBEUIUJUKUNVJVHAEVEETZVJVFFIZVHVNV
      FETVJVOOEEVECDULBVFUOUPVNVGFVFEFVEVMUQURUSUTVA $.

    $( A condition implying that a Hilbert space operator is identically zero.
       Lemma 3.2(S10) of [Beran] p. 95.  (Contributed by NM, 28-Jan-2006.)
       (New usage is discouraged.) $)
    ho02i $p |- ( A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = 0 <->
               T = 0hop ) $=
      ( cv cfv csp co cc0 wceq chil wral ch0o ralcom wcel wb ffvelrni c0v hial0
      hial02 bitr4d syl ralbiia ho01i 3bitri ) AEZBEZCFZGHIJZBKLAKLUIAKLZBKLUHU
      FGHIJAKLZBKLCMJUIABKKNUJUKBKUGKOUHKOZUJUKPKKUGCDQULUJUHRJUKAUHTAUHSUAUBUC
      BACDUDUE $.
  $}

  ${
    $d x y z S $.  $d u v x y z T $.
    $( A condition implying that two Hilbert space operators are equal.  Lemma
       3.2(S9) of [Beran] p. 95.  (Contributed by NM, 15-Feb-2006.)
       (New usage is discouraged.) $)
    hoeq1 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( A. x e. ~H
          A. y e. ~H ( ( S ` x ) .ih y ) = ( ( T ` x ) .ih y ) <-> S = T ) ) $=
      ( chil wf wa cv cfv csp co wceq wral wcel ffvelrn hial2eq syl2an wfn ffn
      wb anandirs ralbidva eqfnfv bitr4d ) EECFZEEDFZGZAHZCIZBHZJKUHDIZUJJKLBEM
      ZAEMUIUKLZAEMZCDLZUGULUMAEUEUFUHENZULUMTZUEUPGUIENUKENUQUFUPGEEUHCOEEUHDO
      BUIUKPQUAUBUECERDERUOUNTUFEECSEEDSAECDUCQUD $.

    $( A condition implying that two Hilbert space operators are equal.  Lemma
       3.2(S11) of [Beran] p. 95.  (Contributed by NM, 15-Feb-2006.)
       (New usage is discouraged.) $)
    hoeq2 $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) -> ( A. x e. ~H
          A. y e. ~H ( x .ih ( S ` y ) ) = ( x .ih ( T ` y ) ) <-> S = T ) ) $=
      ( chil wf wa cv cfv csp co wceq wral ralcom wcel ffvelrn hial2eq2 hial2eq
      wb a1i bitr4d syl2an anandirs ralbidva hoeq1 3bitrd ) EECFZEEDFZGZAHZBHZC
      IZJKUJUKDIZJKLZBEMAEMZUNAEMZBEMZULUJJKUMUJJKLAEMZBEMCDLUOUQSUIUNABEENTUIU
      PURBEUGUHUKEOZUPURSZUGUSGULEOZUMEOZUTUHUSGEEUKCPEEUKDPVAVBGUPULUMLURAULUM
      QAULUMRUAUBUCUDBACDUEUF $.

    $( Every Hilbert space operator has at most one adjoint.  (Contributed by
       NM, 18-Feb-2006.)  (New usage is discouraged.) $)
    adjmo $p |- E* u ( u : ~H --> ~H /\
           A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( u ` x ) .ih y ) ) $=
      ( vv chil cv wf cfv csp co wceq wral wa wmo wi wal r19.26-2 eqtr2 ralimi
      sylbir hoeq1 biimpa sylan2 an4s gen2 fveq1 oveq1d eqeq2d 2ralbidv anbi12d
      feq1 mo4 mpbir ) FFCGZHZAGZBGZDIJKZUQUOIZURJKZLZBFMAFMZNZCOVDFFEGZHZUSUQV
      EIZURJKZLZBFMAFMZNZNUOVELZPZEQCQVMCEUPVFVCVJVLVCVJNZUPVFNZVAVHLZBFMZAFMZV
      LVNVBVINZBFMZAFMVRVBVIABFFRVTVQAFVSVPBFUSVAVHSTTUAVOVRVLABUOVEUBUCUDUEUFV
      DVKCEVLUPVFVCVJFFUOVEULVLVBVIABFFVLVAVHUSVLUTVGURJUQUOVEUGUHUIUJUKUMUN $.

    $( Symmetry property of an adjoint.  (Contributed by NM, 18-Feb-2006.)
       (New usage is discouraged.) $)
    adjsym $p |- ( ( S : ~H --> ~H /\ T : ~H --> ~H ) ->
          ( A. x e. ~H A. y e. ~H ( x .ih ( S ` y ) ) = ( ( T ` x ) .ih y ) <->
         A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( S ` x ) .ih y ) ) ) $=
      ( vz chil wf wa cv cfv csp co wceq wral wcel wb eqeq12d weq fveq2 cbvralv
      ccj ffvelrn ax-his1 sylan adantrl sylan2 adantll ancoms hicl cj11 syl2anc
      cc bitr2d an4s anassrs eqcom syl6bb ralbidva ralcom oveq2d ralbidv bitr4i
      oveq2 oveq1 oveq1d ralbii 3bitri syl6rbbr ) FFCGZFFDGZHZAIZBIZDJZKLZVLCJZ
      VMKLZMZBFNZAFNVMVPKLZVNVLKLZMZBFNZAFNZVLVMCJZKLZVLDJZVMKLZMZBFNAFNZVKVSWC
      AFVKVLFOZHZVRWBBFWLVMFOZHVRWAVTMZWBVKWKWMVRWNPZVIWKVJWMWOVIWKHZVJWMHZHZWN
      VOUAJZVQUAJZMZVRWQWPWNXAPWQWPHWAWSVTWTWQWKWAWSMZVIWQVNFOZWKXBFFVMDUBZVNVL
      UCUDUEWMWPVTWTMZVJWPWMVPFOZXEFFVLCUBZVMVPUCUFUGQUHWRVOULOZVQULOZXAVRPWKWQ
      XHVIWQWKXCXHXDVLVNUIUFUGWPWMXIVJWPXFWMXIXGVPVMUIUDUEVOVQUJUKUMUNUOWAVTUPU
      QURURWJVLEIZCJZKLZWGXJKLZMZAFNZEFNZVMXKKLZVNXJKLZMZBFNZEFNWDWJWIAFNZBFNXP
      WIABFFUSXOYAEBFEBRZXNWIAFYBXLWFXMWHYBXKWEVLKXJVMCSUTXJVMWGKVCQVATVBXOXTEF
      XNXSABFABRZXLXQXMXRVLVMXKKVDYCWGVNXJKVLVMDSVEQTVFXTWCEAFEARZXSWBBFYDXQVTX
      RWAYDXKVPVMKXJVLCSUTXJVLVNKVCQVATVGVH $.
  $}

  ${
    eigre.1 $e |- A e. ~H $.
    eigre.2 $e |- B e. CC $.
    $( A necessary and sufficient condition (that holds when ` T ` is a
       Hermitian operator) for an eigenvalue ` B ` to be real.  Generalization
       of Equation 1.30 of [Hughes] p. 49.  (Contributed by NM, 21-Jan-2005.)
       (New usage is discouraged.) $)
    eigrei $p |- ( ( ( T ` A ) = ( B .h A ) /\ A =/= 0h ) ->
                 ( ( A .ih ( T ` A ) ) = ( ( T ` A ) .ih A ) <-> B e. RR ) ) $=
      ( cfv csm co wceq c0v wne wa csp ccj wcel cmul cc mp3an syl6eq cc0 cr clt
      oveq2 chil his5 oveq1 ax-his3 eqeq12d wb hicli ax-his4 mpan gt0ne0d cjcli
      wbr mulcan2 mp3an12 sylancr sylan9bb cjrebi syl6bbr ) ACFZBAGHZIZAJKZLAVB
      MHZVBAMHZIZBNFZBIZBUAOVDVHVIAAMHZPHZBVKPHZIZVEVJVDVFVLVGVMVDVFAVCMHZVLVBV
      CAMUCBQOZAUDOZVQVOVLIEDDBAAUERSVDVGVCAMHZVMVBVCAMUFVPVQVQVRVMIEDDBAAUGRSU
      HVEVKQOZVKTKZVNVJUIZAADDUJVEVKVQVETVKUBUODAUKULUMVIQOVPVSVTLWABEUNEVIBVKU
      PUQURUSBEUTVA $.
  $}

  $( A necessary and sufficient condition (that holds when ` T ` is a Hermitian
     operator) for an eigenvalue ` B ` to be real.  Generalization of Equation
     1.30 of [Hughes] p. 49.  (Contributed by NM, 19-Mar-2006.)
     (New usage is discouraged.) $)
  eigre $p |- ( ( ( A e. ~H /\ B e. CC ) /\ ( ( T ` A ) = ( B .h A ) /\ A =/=
       0h ) ) -> ( ( A .ih ( T ` A ) ) = ( ( T ` A ) .ih A ) <-> B e. RR ) ) $=
    ( chil wcel cc wa cfv csm co wceq c0v wne csp cr wb wi cif cc0 eqeq12d 0cn
    fveq2 oveq2 neeq1 anbi12d oveq12d bibi1d imbi12d oveq1 eqeq2d anbi1d bibi2d
    id eleq1 ax-hv0cl elimel eigrei dedth2h imp ) ADEZBFEZGACHZBAIJZKZALMZGZAVB
    NJZVBANJZKZBOEZPZUTVAVFVKQUTALRZCHZBVLIJZKZVLLMZGZVLVMNJZVMVLNJZKZVJPZQVMVA
    BSRZVLIJZKZVPGZVTWBOEZPZQABLSAVLKZVFVQVKWAWHVDVOVEVPWHVBVMVCVNAVLCUBZAVLBIU
    CTAVLLUDUEWHVIVTVJWHVGVRVHVSWHAVLVBVMNWHUMZWIUFWHVBVMAVLNWIWJUFTUGUHBWBKZVQ
    WEWAWGWKVOWDVPWKVNWCVMBWBVLIUIUJUKWKVJWFVTBWBOUNULUHVLWBCALDUOUPBSFUAUPUQUR
    US $.

  ${
    eigpos.1 $e |- A e. ~H $.
    eigpos.2 $e |- B e. CC $.
    $( A sufficient condition (first conjunct pair, that holds when ` T ` is a
       positive operator) for an eigenvalue ` B ` (second conjunct pair) to be
       nonnegative.  Remark (ii) in [Hughes] p. 137.  (Contributed by NM,
       2-Jul-2005.)  (New usage is discouraged.) $)
    eigposi $p |- ( ( ( ( A .ih ( T ` A ) ) e. RR /\ 0 <_ ( A .ih ( T ` A ) ) )
      /\ ( ( T ` A ) = ( B .h A ) /\ A =/= 0h ) ) -> ( B e. RR /\ 0 <_ B ) ) $=
      ( cfv csp co cr wcel cc0 cle wbr wa csm wceq wb chil bitrd cmul c0v oveq2
      eleq1d oveq1 eqeq12d hvmulcli hire syl6rbbr adantr eigrei biimpac adantlr
      wne mp2an clt ax-his4 mpan ad2antll simplr ad2antrl ccj his5 mp3an oveq1d
      cc cjred syl5eq eqtrd breqtrd hiidrcl ax-mp prodge02 mpanl2 syl12anc jca
      ) AACFZGHZIJZKVQLMZNZVPBAOHZPZAUAUMZNZNZBIJZKBLMZVRWDWFVSWDVRWFWDVRVQVPAG
      HZPZWFWBVRWIQWCWBVRAWAGHZIJZWIWBVQWJIVPWAAGUBZUCWBWIWJWAAGHZPZWKWBVQWJWHW
      MWLVPWAAGUDUEARJZWARJWKWNQDBAEDUFAWAUGUNUHSUIABCDEUJSUKULZWEWFKAAGHZUOMZK
      BWQTHZLMZWGWPWCWRVTWBWOWCWRDAUPUQURWEKVQWSLVRVSWDUSWEVQWJWSWBVQWJPVTWCWLU
      TWEWJBVAFZWQTHZWSBVEJWOWOWJXBPEDDBAAVBVCWEXABWQTWEBWPVFVDVGVHVIWFWQIJZWRW
      TNWGWOXCDAVJVKBWQVLVMVNVO $.
  $}

  ${
    eigorthi.1 $e |- A e. ~H $.
    eigorthi.2 $e |- B e. ~H $.
    eigorthi.3 $e |- C e. CC $.
    eigorthi.4 $e |- D e. CC $.
    $( A necessary and sufficient condition (that holds when ` T ` is a
       Hermitian operator) for two eigenvectors ` A ` and ` B ` to be
       orthogonal.  Generalization of Equation 1.31 of [Hughes] p. 49.
       (Contributed by NM, 23-Jan-2005.)  (New usage is discouraged.) $)
    eigorthi $p |- ( ( ( ( T ` A ) = ( C .h A ) /\ ( T ` B ) = ( D .h B ) )
                     /\ C =/= ( * ` D ) ) ->
         ( ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) <-> ( A .ih B ) = 0 ) ) $=
      ( cfv csm co wceq csp cmul cc0 oveq2 cc wcel syl6eq wa ccj wne chil mp3an
      his5 oveq1 ax-his3 eqeqan12rd wb hicli cjcli mulcan2 mp3an12 eqcom syl6bb
      mpan biimpcd necon1d com12 mul01i eqtr4i eqtr4d impbid1 sylan9bb ) AEJZCA
      KLZMZBEJZDBKLZMZUAAVINLZVFBNLZMDUBJZABNLZOLZCVOOLZMZCVNUCZVOPMZVKVHVLVPVM
      VQVKVLAVJNLZVPVIVJANQDRSAUDSZBUDSZWAVPMIFGDABUFUETVHVMVGBNLZVQVFVGBNUGCRS
      ZWBWCWDVQMHFGCABUHUETUIVSVRVTVRVSVTVRVOPCVNVOPUCZVRCVNMZWFVRVNCMZWGVORSZW
      FVRWHUJZABFGUKVNRSWEWIWFUAWJDIULZHVNCVOUMUNUQVNCUOUPURUSUTVTVPVNPOLZVQVOP
      VNOQVTVQCPOLZWLVOPCOQWMPWLCHVAVNWKVAVBTVCVDVE $.
  $}

  $( A necessary and sufficient condition (that holds when ` T ` is a Hermitian
     operator) for two eigenvectors ` A ` and ` B ` to be orthogonal.
     Generalization of Equation 1.31 of [Hughes] p. 49.  (Contributed by NM,
     23-Mar-2006.)  (New usage is discouraged.) $)
  eigorth $p |- ( ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. CC /\ D e. CC ) ) /\
                 ( ( ( T ` A ) = ( C .h A ) /\ ( T ` B ) = ( D .h B ) )
                   /\ C =/= ( * ` D ) ) ) ->
         ( ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) <-> ( A .ih B ) = 0 ) ) $=
    ( chil wcel wa cc cfv csm co wceq csp cc0 wi c0v cif oveq2 eqeq12d wb fveq2
    ccj anbi1d oveq1 oveq1d eqeq1d bibi12d imbi12d anbi2d oveq2d eqeq2d anbi12d
    wne neeq1 imbi1d neeq2d ax-hv0cl elimel 0cn eigorthi dedth4h imp ) AFGZBFGZ
    HCIGZDIGZHHAEJZCAKLZMZBEJZDBKLZMZHZCDUCJZUNZHZAVKNLZVHBNLZMZABNLZOMZUAZVDVE
    VFVGVQWCPVDAQRZEJZCWDKLZMZVMHZVPHZWDVKNLZWEBNLZMZWDBNLZOMZUAZPWGVEBQRZEJZDW
    PKLZMZHZVPHZWDWQNLZWEWPNLZMZWDWPNLZOMZUAZPWEVFCORZWDKLZMZWSHZXHVOUNZHZXGPXJ
    WQVGDORZWPKLZMZHZXHXNUCJZUNZHZXGPABCDQQOOAWDMZVQWIWCWOYAVNWHVPYAVJWGVMYAVHW
    EVIWFAWDEUBZAWDCKSTUDUDYAVTWLWBWNYAVRWJVSWKAWDVKNUEYAVHWEBNYBUFTYAWAWMOAWDB
    NUEUGUHUIBWPMZWIXAWOXGYCWHWTVPYCVMWSWGYCVKWQVLWRBWPEUBZBWPDKSTUJUDYCWLXDWNX
    FYCWJXBWKXCYCVKWQWDNYDUKBWPWENSTYCWMXEOBWPWDNSUGUHUICXHMZXAXMXGYEWTXKVPXLYE
    WGXJWSYEWFXIWECXHWDKUEULUDCXHVOUOUMUPDXNMZXMXTXGYFXKXQXLXSYFWSXPXJYFWRXOWQD
    XNWPKUEULUJYFVOXRXHDXNUCUBUQUMUPWDWPXHXNEAQFURUSBQFURUSCOIUTUSDOIUTUSVAVBVC
    $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Linear, continuous, bounded, Hermitian, unitary operators and norms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z $.
    $( Define the norm of a Hilbert space operator.  (Contributed by NM,
       18-Jan-2006.)  (New usage is discouraged.) $)
    df-nmop $a |- normop = ( t e. ( ~H ^m ~H ) |-> sup (
       { x | E. z e. ~H ( ( normh ` z ) <_ 1 /\ x = ( normh ` ( t ` z ) ) ) } ,
              RR* , < ) ) $.

    $( Define the set of continuous operators on Hilbert space.  For every
       "epsilon" ( ` y ` ) there is a "delta" ( ` z ` ) such that...
       (Contributed by NM, 28-Jan-2006.)  (New usage is discouraged.) $)
    df-cnop $a |- ConOp = { t e. ( ~H ^m ~H ) | A. x e. ~H A. y e. RR+
                E. z e. RR+ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
                ( normh ` ( ( t ` w ) -h ( t ` x ) ) ) < y ) } $.

    $( Define the set of linear operators on Hilbert space.  (See ~ df-hosum
       for definition of operator.)  (Contributed by NM, 18-Jan-2006.)
       (New usage is discouraged.) $)
    df-lnop $a |- LinOp = { t e. ( ~H ^m ~H ) |
           A. x e. CC A. y e. ~H A. z e. ~H
       ( t ` ( ( x .h y ) +h z ) ) = ( ( x .h ( t ` y ) ) +h ( t ` z ) ) } $.

    $( Define the set of bounded linear Hilbert space operators.  (See
       ~ df-hosum for definition of operator.)  (Contributed by NM,
       18-Jan-2006.)  (New usage is discouraged.) $)
    df-bdop $a |- BndLinOp = { t e. LinOp | ( normop ` t ) < +oo } $.

    $( Define the set of unitary operators on Hilbert space.  (Contributed by
       NM, 18-Jan-2006.)  (New usage is discouraged.) $)
    df-unop $a |- UniOp = { t | ( t : ~H -onto-> ~H /\
         A. x e. ~H A. y e. ~H ( ( t ` x ) .ih ( t ` y ) ) = ( x .ih y ) ) } $.

    $( Define the set of Hermitian operators on Hilbert space.  Some books call
       these "symmetric operators" and others call them "self-adjoint
       operators," sometimes with slightly different technical meanings.
       (Contributed by NM, 18-Jan-2006.)  (New usage is discouraged.) $)
    df-hmop $a |- HrmOp = { t e. ( ~H ^m ~H ) | A. x e. ~H A. y e. ~H
                   ( x .ih ( t ` y ) ) = ( ( t ` x ) .ih y ) } $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Linear and continuous functionals and norms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Define the norm of a Hilbert space functional.  (Contributed by NM,
       11-Feb-2006.)  (New usage is discouraged.) $)
    df-nmfn $a |- normfn = ( t e. ( CC ^m ~H ) |-> sup (
         { x | E. z e. ~H ( ( normh ` z ) <_ 1 /\ x = ( abs ` ( t ` z ) ) ) } ,
              RR* , < ) ) $.

    $( Define the null space of a Hilbert space functional.  (Contributed by
       NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    df-nlfn $a |- null = ( t e. ( CC ^m ~H ) |-> ( `' t " { 0 } ) ) $.

    $( Define the set of continuous functionals on Hilbert space.  For every
       "epsilon" ( ` y ` ) there is a "delta" ( ` z ` ) such that...
       (Contributed by NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    df-cnfn $a |- ConFn = { t e. ( CC ^m ~H ) | A. x e. ~H A. y e. RR+
      E. z e. RR+ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
      ( abs ` ( ( t ` w ) - ( t ` x ) ) ) < y ) } $.

    $( Define the set of linear functionals on Hilbert space.  (Contributed by
       NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    df-lnfn $a |- LinFn = { t e. ( CC ^m ~H ) |
           A. x e. CC A. y e. ~H A. z e. ~H
       ( t ` ( ( x .h y ) +h z ) ) = ( ( x x. ( t ` y ) ) + ( t ` z ) ) } $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Adjoint
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Define the adjoint of a Hilbert space operator (if it exists).  The
       domain of ` adjh ` is the set of all adjoint operators.  Definition of
       adjoint in [Kalmbach2] p. 8.  Unlike Kalmbach (and most authors), we do
       not demand that the operator be linear, but instead show (in ~ adjbdln )
       that the adjoint exists for a bounded linear operator.  (Contributed by
       NM, 20-Feb-2006.)  (New usage is discouraged.) $)
    df-adjh $a |- adjh = { <. t , u >. | ( t : ~H --> ~H /\ u : ~H --> ~H /\
         A. x e. ~H A. y e. ~H ( ( t ` x ) .ih y ) = ( x .ih ( u ` y ) ) ) } $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Dirac bra-ket notation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Define the bra of a vector used by Dirac notation.  Based on definition
       of bra in [Prugovecki] p. 186 (p. 180 in 1971 edition).  In Dirac
       bra-ket notation, ` <. A | B >. ` is a complex number equal to the inner
       product ` ( B .ih A ) ` .  But physicists like to talk about the
       individual components ` <. A | ` and ` | B >. ` , called bra and ket
       respectively.  In order for their properties to make sense formally, we
       define the ket ` | B >. ` as the vector ` B ` itself, and the bra
       ` <. A | ` as a functional from ` ~H ` to ` CC ` .  We represent the
       Dirac notation ` <. A | B >. ` by ` ( ( bra `` A ) `` B ) ` ; see
       ~ braval .  The reversal of the inner product arguments not only makes
       the bra-ket behavior consistent with physics literature (see comments
       under ~ ax-his3 ) but is also required in order for the associative law
       ~ kbass2 to work.

       Our definition of bra and the associated outer product ~ df-kb differs
       from, but is equivalent to, a common approach in the literature that
       makes use of mappings to a dual space.  Our approach eliminates the need
       to have a parallel development of this dual space and instead keeps
       everything in Hilbert space.

       _For an extensive discussion about how our notation maps to the bra-ket
       notation in physics textbooks, see
       ~ http://us.metamath.org/mpeuni/mmnotes.txt , under the 17-May-2006
       entry_.  (Contributed by NM, 15-May-2006.)
       (New usage is discouraged.) $)
    df-bra $a |- bra = ( x e. ~H |-> ( y e. ~H |-> ( y .ih x ) ) ) $.

    $( Define a commuted bra and ket juxtaposition used by Dirac notation.  In
       Dirac notation, ` | A >. ` ` <. B | ` is an operator known as the outer
       product of ` A ` and ` B ` , which we represent by ` ( A ketbra B ) ` .
       Based on Equation 8.1 of [Prugovecki] p. 376.  This definition, combined
       with definition ~ df-bra , allows any legal juxtaposition of bras and
       kets to make sense formally and also to obey the associative law when
       mapped back to Dirac notation.  (Contributed by NM, 15-May-2006.)
       (New usage is discouraged.) $)
    df-kb $a |- ketbra = ( x e. ~H , y e. ~H |->
                          ( z e. ~H |-> ( ( z .ih y ) .h x ) ) ) $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Positive operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Define positive operator ordering.  Definition VI.1 of [Retherford]
       p. 49.  Note that ` ( ~H X. 0H ) <_op T ` means that ` T ` is a positive
       operator.  (Contributed by NM, 23-Jul-2006.)
       (New usage is discouraged.) $)
    df-leop $a |- <_op = { <. t , u >. | ( ( u -op t ) e. HrmOp /\
               A. x e. ~H 0 <_ ( ( ( u -op t ) ` x ) .ih x ) ) } $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Eigenvectors, eigenvalues, spectrum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Define the eigenvector function.  Theorem ~ eleigveccl shows that
       ` eigvec `` T ` , the set of eigenvectors of Hilbert space operator
       ` T ` , are Hilbert space vectors.  (Contributed by NM, 11-Mar-2006.)
       (New usage is discouraged.) $)
    df-eigvec $a |- eigvec = ( t e. ( ~H ^m ~H ) |->
         { x e. ( ~H \ 0H ) | E. z e. CC ( t ` x ) = ( z .h x ) } ) $.

    $( Define the eigenvalue function.  The range of ` eigval `` T ` is the set
       of eigenvalues of Hilbert space operator ` T ` .  Theorem ~ eigvalcl
       shows that ` ( eigval `` T ) `` A ` , the eigenvalue associated with
       eigenvector ` A ` , is a complex number.  (Contributed by NM,
       11-Mar-2006.)  (New usage is discouraged.) $)
    df-eigval $a |- eigval = ( t e. ( ~H ^m ~H ) |->
                     ( x e. ( eigvec ` t ) |->
                   ( ( ( t ` x ) .ih x ) / ( ( normh ` x ) ^ 2 ) ) ) ) $.

    $( Define the spectrum of an operator.  Definition of spectrum in [Halmos]
       p. 50.  (Contributed by NM, 11-Apr-2006.)
       (New usage is discouraged.) $)
    df-spec $a |- Lambda = ( t e. ( ~H ^m ~H ) |->
        { x e. CC | -. ( t -op ( x .op ( _I |` ~H ) ) ) : ~H -1-1-> ~H } ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Theorems about operators and functionals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t u v w x y z T $.
    $( Value of the norm of a Hilbert space operator.  (Contributed by NM,
       18-Jan-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    nmopval $p |- ( T : ~H --> ~H -> ( normop ` T ) = sup ( { x | E. y e. ~H
         ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } , RR* , < ) ) $=
      ( vt cv cno cfv c1 cle wbr wceq chil wrex cab cxr clt csup cnop ax-hilex
      wa xrltso supex fveq1 fveq2d eqeq2d anbi2d rexbidv abbidv supeq1d df-nmop
      fvmptmap ) DCBEZFGHIJZAEZULDEZGZFGZKZTZBLMZANZOPQUMUNULCGZFGZKZTZBLMZANZO
      PQLLROVGPUAUBSSUOCKZOVAVGPVHUTVFAVHUSVEBLVHURVDUMVHUQVCUNVHUPVBFULUOCUCUD
      UEUFUGUHUIABDUJUK $.

    $( Property defining a continuous Hilbert space operator.  (Contributed by
       NM, 28-Jan-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    elcnop $p |- ( T e. ConOp <-> ( T : ~H --> ~H /\ A. x e. ~H A. y e. RR+
                   E. z e. RR+ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
                     ( normh ` ( ( T ` w ) -h ( T ` x ) ) ) < y ) ) ) $=
      ( vt ccop wcel chil co cv cmv cno cfv clt wbr wi wral crp wrex cmap wa wf
      wceq fveq1 oveq12d fveq2d breq1d imbi2d rexralbidv 2ralbidv df-cnop elmap
      elrab2 ax-hilex anbi1i bitri ) EGHEIIUAJZHZDKZAKZLJMNCKOPZUTENZVAENZLJZMN
      ZBKZOPZQZDIRCSTZBSRAIRZUBIIEUCZVKUBVBUTFKZNZVAVMNZLJZMNZVGOPZQZDIRCSTZBSR
      AIRVKFEURGVMEUDZVTVJABISWAVSVICDSIWAVRVHVBWAVQVFVGOWAVPVEMWAVNVCVOVDLUTVM
      EUEVAVMEUEUFUGUHUIUJUKABCDFULUNUSVLVKIIEUOUOUMUPUQ $.

    $( Property defining a linear Hilbert space operator.  (Contributed by NM,
       18-Jan-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    ellnop $p |- ( T e. LinOp <-> ( T : ~H --> ~H /\
        A. x e. CC A. y e. ~H A. z e. ~H
       ( T ` ( ( x .h y ) +h z ) ) = ( ( x .h ( T ` y ) ) +h ( T ` z ) ) ) ) $=
      ( vt clo wcel chil cmap co cv csm cva cfv wceq wral cc wa fveq1 ax-hilex
      oveq2d oveq12d eqeq12d ralbidv 2ralbidv df-lnop elrab2 elmap anbi1i bitri
      wf ) DFGDHHIJZGZAKZBKZLJCKZMJZDNZUNUODNZLJZUPDNZMJZOZCHPZBHPAQPZRHHDUKZVE
      RUQEKZNZUNUOVGNZLJZUPVGNZMJZOZCHPZBHPAQPVEEDULFVGDOZVNVDABQHVOVMVCCHVOVHU
      RVLVBUQVGDSVOVJUTVKVAMVOVIUSUNLUOVGDSUAUPVGDSUBUCUDUEABCEUFUGUMVFVEHHDTTU
      HUIUJ $.

    $( A linear Hilbert space operator is a Hilbert space operator.
       (Contributed by NM, 18-Jan-2006.)  (New usage is discouraged.) $)
    lnopf $p |- ( T e. LinOp -> T : ~H --> ~H ) $=
      ( vx vy vz clo wcel chil wf cv csm co cva cfv wceq wral cc ellnop simplbi
      ) AEFGGAHBIZCIZJKDIZLKAMSTAMJKUAAMLKNDGOCGOBPOBCDAQR $.

    $( Property defining a bounded linear Hilbert space operator.  (Contributed
       by NM, 18-Jan-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    elbdop $p |- ( T e. BndLinOp <->
                  ( T e. LinOp /\ ( normop ` T ) < +oo ) ) $=
      ( vt cv cnop cfv cpnf clt wbr clo cbo wceq fveq2 breq1d df-bdop elrab2 )
      BCZDEZFGHADEZFGHBAIJPAKQRFGPADLMBNO $.

    $( A bounded linear Hilbert space operator is a linear operator.
       (Contributed by NM, 18-Feb-2006.)  (New usage is discouraged.) $)
    bdopln $p |- ( T e. BndLinOp -> T e. LinOp ) $=
      ( cbo wcel clo cnop cfv cpnf clt wbr elbdop simplbi ) ABCADCAEFGHIAJK $.

    $( A bounded linear Hilbert space operator is a Hilbert space operator.
       (Contributed by NM, 2-Feb-2006.)  (New usage is discouraged.) $)
    bdopf $p |- ( T e. BndLinOp -> T : ~H --> ~H ) $=
      ( cbo wcel clo chil wf bdopln lnopf syl ) ABCADCEEAFAGAHI $.

    $( The set in the supremum of the operator norm definition ~ df-nmop is a
       set of reals.  (Contributed by NM, 2-Feb-2006.)
       (New usage is discouraged.) $)
    nmopsetretALT $p |- ( T : ~H --> ~H -> { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } C_ RR ) $=
      ( chil wf cv cno cfv c1 cle wbr wceq wa wrex cr wcel ffvelrn normcl eleq1
      syl syl5ibr impcom adantrl exp31 rexlimdv abssdv ) DDCEZBFZGHIJKZAFZUHCHZ
      GHZLZMZBDNAOUGUNUJOPZBDUGUHDPZUNUOUGUPMZUMUOUIUMUQUOUQUOUMULOPZUQUKDPURDD
      UHCQUKRTUJULOSUAUBUCUDUEUF $.

    $( The set in the supremum of the operator norm definition ~ df-nmop is a
       set of reals.  (Contributed by NM, 2-Feb-2006.)
       (New usage is discouraged.) $)
    nmopsetretHIL $p |- ( T : ~H --> ~H -> { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } C_ RR ) $=
      ( cva csm cop cno cnv wcel chil wf cv cfv c1 cle wbr wceq wa wrex cab wss
      cr eqid hhnv df-hba hhnm nmosetre mpan ) DEFGFZHIJJCKBLZGMNOPALUJCMGMQRBJ
      SATUBUAUIUIUCZUDABCGGUIJJUEUIUKUFUGUH $.

    $( The set in the supremum of the operator norm definition ~ df-nmop is
       nonempty.  (Contributed by NM, 9-Feb-2006.)
       (New usage is discouraged.) $)
    nmopsetn0 $p |- ( normh ` ( T ` 0h ) ) e.
      { x | E. y e. ~H ( ( normh ` y ) <_ 1 /\ x = ( normh ` ( T ` y ) ) ) } $=
      ( c0v cfv cno cv c1 cle wbr wceq wa chil wrex cab wcel ax-hv0cl cc0 norm0
      fveq2 0le1 eqbrtri pm3.2i breq1d fveq2d eqeq2d anbi12d rspcev mp2an eqeq1
      eqid fvex anbi2d rexbidv elab mpbir ) DCEZFEZBGZFEZHIJZAGZUSCEZFEZKZLZBMN
      ZAOPVAURVDKZLZBMNZDMPDFEZHIJZURURKZLZVJQVLVMVKRHISUAUBURUKUCVIVNBDMUSDKZV
      AVLVHVMVOUTVKHIUSDFTUDVOVDURURVOVCUQFUSDCTUEUFUGUHUIVGVJAURUQFULVBURKZVFV
      IBMVPVEVHVAVBURVDUJUMUNUOUP $.

    $( The norm of a Hilbert space operator is an extended real.  (Contributed
       by NM, 9-Feb-2006.)  (New usage is discouraged.) $)
    nmopxr $p |- ( T : ~H --> ~H -> ( normop ` T ) e. RR* ) $=
      ( vy vx chil wf cnop cfv cv cno c1 cle wbr wceq wrex cab cxr csup nmopval
      wa clt wss wcel cr nmopsetretHIL ressxr syl6ss supxrcl syl eqeltrd ) DDAE
      ZAFGBHZIGJKLCHUKAGIGMSBDNCOZPTQZPCBARUJULPUAUMPUBUJULUCPCBAUDUEUFULUGUHUI
      $.

    $( The norm of a Hilbert space operator is either real or plus infinity.
       (Contributed by NM, 5-Feb-2006.)  (New usage is discouraged.) $)
    nmoprepnf $p |- ( T : ~H --> ~H ->
                   ( ( normop ` T ) e. RR <-> ( normop ` T ) =/= +oo ) ) $=
      ( vy vx chil wf cv cno cfv c1 cle wbr wceq wa wrex cab cxr wcel cpnf wne
      cr clt csup cnop wss c0 wb nmopsetretHIL c0v nmopsetn0 ne0i ax-mp sylancl
      supxrre2 nmopval eleq1d neeq1d 3bitr4d ) DDAEZBFZGHIJKCFUSAHGHLMBDNCOZPUA
      UBZTQZVARSZAUCHZTQVDRSURUTTUDUTUESZVBVCUFCBAUGUHAHGHZUTQVECBAUIUTVFUJUKUT
      UMULURVDVATCBAUNZUOURVDVARVGUPUQ $.

    $( The norm of a Hilbert space operator is not minus infinity.
       (Contributed by NM, 2-Feb-2006.)  (New usage is discouraged.) $)
    nmopgtmnf $p |- ( T : ~H --> ~H -> -oo < ( normop ` T ) ) $=
      ( chil wf cnop cfv cr wcel cpnf wceq wn wb wo clt wbr wne nmoprepnf df-ne
      cmnf syl6bb xor3 wa nbi2 simplbi sylbir mnfltxr 3syl ) BBACZADEZFGZUHHIZJ
      ZKZUIUJLZRUHMNUGUIUHHOUKAPUHHQSULUIUJKJZUMUIUJTUNUMUIUJUAJUIUJUBUCUDUHUEU
      F $.

    $( The norm of a Hilbert space operator is real iff it is less than
       infinity.  (Contributed by NM, 14-Feb-2006.)
       (New usage is discouraged.) $)
    nmopreltpnf $p |- ( T : ~H --> ~H ->
                   ( ( normop ` T ) e. RR <-> ( normop ` T ) < +oo ) ) $=
      ( chil wf cnop cfv cr wcel cpnf wne clt wbr nmoprepnf cxr wceq wn nltpnft
      wb nmopxr syl necon2abid bitr4d ) BBACZADEZFGUCHIUCHJKZALUBUDUCHUBUCMGUCH
      NUDOQARUCPSTUA $.

    $( The norm of a bounded operator is a real number.  (Contributed by NM,
       29-Jan-2006.)  (New usage is discouraged.) $)
    nmopre $p |- ( T e. BndLinOp -> ( normop ` T ) e. RR ) $=
      ( cbo wcel cnop cfv cr cmnf clt wbr cpnf chil wf nmopgtmnf syl clo elbdop
      bdopf simprbi cxr wa wb nmopxr xrrebnd 3syl mpbir2and ) ABCZADEZFCZGUGHIZ
      UGJHIZUFKKALZUIAQZAMNUFAOCUJAPRUFUKUGSCUHUIUJTUAULAUBUGUCUDUE $.

    $( Property defining a bounded linear Hilbert space operator.  (Contributed
       by NM, 14-Feb-2006.)  (New usage is discouraged.) $)
    elbdop2 $p |- ( T e. BndLinOp <->
                   ( T e. LinOp /\ ( normop ` T ) e. RR ) ) $=
      ( cbo wcel clo cnop cfv cpnf clt wbr wa cr elbdop wf wb lnopf nmopreltpnf
      chil syl pm5.32i bitr4i ) ABCADCZAEFZGHIZJUAUBKCZJALUAUDUCUAQQAMUDUCNAOAP
      RST $.

    $( Property defining a unitary Hilbert space operator.  (Contributed by NM,
       18-Jan-2006.)  (New usage is discouraged.) $)
    elunop $p |- ( T e. UniOp <-> ( T : ~H -onto-> ~H /\
        A. x e. ~H A. y e. ~H ( ( T ` x ) .ih ( T ` y ) ) = ( x .ih y ) ) ) $=
      ( vt cuo wcel cvv chil wfo cv cfv csp co wceq wral wa elex wf fof fveq1
      ax-hilex fex sylancl adantr foeq1 oveq12d eqeq1d 2ralbidv anbi12d df-unop
      elab2g pm5.21nii ) CEFCGFZHHCIZAJZCKZBJZCKZLMZUOUQLMZNZBHOAHOZPZCEQUNUMVB
      UNHHCRHGFUMHHCSUAHHGCUBUCUDHHDJZIZUOVDKZUQVDKZLMZUTNZBHOAHOZPVCDCEGVDCNZV
      EUNVJVBHHVDCUEVKVIVAABHHVKVHUSUTVKVFUPVGURLUOVDCTUQVDCTUFUGUHUIABDUJUKUL
      $.

    $( Property defining a Hermitian Hilbert space operator.  (Contributed by
       NM, 18-Jan-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    elhmop $p |- ( T e. HrmOp <-> ( T : ~H --> ~H /\ A. x e. ~H A. y e. ~H
                   ( x .ih ( T ` y ) ) = ( ( T ` x ) .ih y ) ) ) $=
      ( vt cho wcel chil cmap co cv cfv csp wceq wral wa wf fveq1 oveq2d oveq1d
      ax-hilex eqeq12d 2ralbidv df-hmop elrab2 elmap anbi1i bitri ) CEFCGGHIZFZ
      AJZBJZCKZLIZUJCKZUKLIZMZBGNAGNZOGGCPZUQOUJUKDJZKZLIZUJUSKZUKLIZMZBGNAGNUQ
      DCUHEUSCMZVDUPABGGVEVAUMVCUOVEUTULUJLUKUSCQRVEVBUNUKLUJUSCQSUAUBABDUCUDUI
      URUQGGCTTUEUFUG $.

    $( A Hermitian operator is a Hilbert space operator (mapping).
       (Contributed by NM, 19-Mar-2006.)  (New usage is discouraged.) $)
    hmopf $p |- ( T e. HrmOp -> T : ~H --> ~H ) $=
      ( vx vy cho wcel chil wf cv cfv csp co wceq wral elhmop simplbi ) ADEFFAG
      BHZCHZAIJKPAIQJKLCFMBFMBCANO $.

    $( The class of Hermitian operators is a set.  (Contributed by NM,
       17-Aug-2006.)  (New usage is discouraged.) $)
    hmopex $p |- HrmOp e. _V $=
      ( vt chil cmap co ovex cv wcel wf hmopf ax-hilex elmap sylibr ssriv ssexi
      cho ) OBBCDZBBCEAOPAFZOGBBQHQPGQIBBQJJKLMN $.

    $( Value of the norm of a Hilbert space functional.  (Contributed by NM,
       11-Feb-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    nmfnval $p |- ( T : ~H --> CC -> ( normfn ` T ) = sup ( { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( abs ` ( T ` y ) ) ) } , RR* , < ) ) $=
      ( vt cv cno cfv c1 cle wbr cabs wceq wa chil wrex cab cxr clt csup cc
      cnmf xrltso supex ax-hilex cnex fveq1 fveq2d eqeq2d anbi2d rexbidv abbidv
      supeq1d df-nmfn fvmptmap ) DCBEZFGHIJZAEZUODEZGZKGZLZMZBNOZAPZQRSUPUQUOCG
      ZKGZLZMZBNOZAPZQRSNTUAQVJRUBUCUDUEURCLZQVDVJRVKVCVIAVKVBVHBNVKVAVGUPVKUTV
      FUQVKUSVEKUOURCUFUGUHUIUJUKULABDUMUN $.

    $( The set in the supremum of the functional norm definition ~ df-nmfn is a
       set of reals.  (Contributed by NM, 14-Feb-2006.)
       (New usage is discouraged.) $)
    nmfnsetre $p |- ( T : ~H --> CC -> { x | E. y e. ~H
           ( ( normh ` y ) <_ 1 /\ x = ( abs ` ( T ` y ) ) ) } C_ RR ) $=
      ( chil cc wf cv cno cfv c1 cle wbr cabs wceq wa wrex wcel ffvelrn abscld
      cr eleq1 syl5ibr impcom adantrl exp31 rexlimdv abssdv ) DECFZBGZHIJKLZAGZ
      UICIZMIZNZOZBDPATUHUOUKTQZBDUHUIDQZUOUPUHUQOZUNUPUJUNURUPURUPUNUMTQURULDE
      UICRSUKUMTUAUBUCUDUEUFUG $.

    $( The set in the supremum of the functional norm definition ~ df-nmfn is
       nonempty.  (Contributed by NM, 14-Feb-2006.)
       (New usage is discouraged.) $)
    nmfnsetn0 $p |- ( abs ` ( T ` 0h ) ) e.
      { x | E. y e. ~H ( ( normh ` y ) <_ 1 /\ x = ( abs ` ( T ` y ) ) ) } $=
      ( c0v cfv cabs cv cno c1 cle wbr wceq wa chil wrex cab ax-hv0cl cc0 fveq2
      wcel norm0 eqbrtri pm3.2i breq1d fveq2d eqeq2d anbi12d rspcev mp2an eqeq1
      0le1 eqid fvex anbi2d rexbidv elab mpbir ) DCEZFEZBGZHEZIJKZAGZUTCEZFEZLZ
      MZBNOZAPTVBUSVELZMZBNOZDNTDHEZIJKZUSUSLZMZVKQVMVNVLRIJUAUKUBUSULUCVJVOBDN
      UTDLZVBVMVIVNVPVAVLIJUTDHSUDVPVEUSUSVPVDURFUTDCSUEUFUGUHUIVHVKAUSURFUMVCU
      SLZVGVJBNVQVFVIVBVCUSVEUJUNUOUPUQ $.

    $( The norm of any Hilbert space functional is an extended real.
       (Contributed by NM, 9-Feb-2006.)  (New usage is discouraged.) $)
    nmfnxr $p |- ( T : ~H --> CC -> ( normfn ` T ) e. RR* ) $=
      ( vy vx chil cc wf cnmf cfv cv cno c1 cle wbr cabs wceq wrex cab cxr clt
      wa csup nmfnval wss wcel cr nmfnsetre ressxr syl6ss supxrcl syl eqeltrd )
      DEAFZAGHBIZJHKLMCIUMAHNHOTBDPCQZRSUAZRCBAUBULUNRUCUORUDULUNUERCBAUFUGUHUN
      UIUJUK $.

    $( The norm of a Hilbert space functional is either real or plus infinity.
       (Contributed by NM, 8-Dec-2007.)  (New usage is discouraged.) $)
    nmfnrepnf $p |- ( T : ~H --> CC ->
                   ( ( normfn ` T ) e. RR <-> ( normfn ` T ) =/= +oo ) ) $=
      ( vy vx chil cc wf cv cno cfv c1 cle wbr cabs wceq wa wrex wcel cpnf wne
      cr cab cxr clt csup cnmf wss c0 wb nmfnsetre c0v nmfnsetn0 ax-mp supxrre2
      ne0i sylancl nmfnval eleq1d neeq1d 3bitr4d ) DEAFZBGZHIJKLCGVAAIMINOBDPCU
      AZUBUCUDZTQZVCRSZAUEIZTQVFRSUTVBTUFVBUGSZVDVEUHCBAUIUJAIMIZVBQVGCBAUKVBVH
      UNULVBUMUOUTVFVCTCBAUPZUQUTVFVCRVIURUS $.

    $( Value of the null space of a Hilbert space functional.  (Contributed by
       NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    nlfnval $p |- ( T : ~H --> CC -> ( null ` T ) = ( `' T " { 0 } ) ) $=
      ( vt chil cc wf cmap co wcel cnl cfv ccnv cc0 csn cima wceq cnex ax-hilex
      elmap cvv cnvexg imaexg syl cv cnveq imaeq1d df-nlfn fvmptg mpdan sylbir
      ) CDAEADCFGZHZAIJAKZLMZNZOZDCAPQRUKUNSHZUOUKULSHUPAUJTULUMSUAUBBABUCZKZUM
      NUNUJSIUQAOURULUMUQAUDUEBUFUGUHUI $.

    $( Property defining a continuous functional.  (Contributed by NM,
       11-Feb-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    elcnfn $p |- ( T e. ConFn <-> ( T : ~H --> CC /\ A. x e. ~H A. y e. RR+
                   E. z e. RR+ A. w e. ~H ( ( normh ` ( w -h x ) ) < z ->
                     ( abs ` ( ( T ` w ) - ( T ` x ) ) ) < y ) ) ) $=
      ( vt ccnfn wcel cc chil co cv cfv clt wbr cmin cabs wi wral crp cmap wrex
      cmv cno wa wf wceq fveq1 oveq12d fveq2d breq1d imbi2d rexralbidv 2ralbidv
      df-cnfn elrab2 cnex ax-hilex elmap anbi1i bitri ) EGHEIJUAKZHZDLZALZUCKUD
      MCLNOZVDEMZVEEMZPKZQMZBLZNOZRZDJSCTUBZBTSAJSZUEJIEUFZVOUEVFVDFLZMZVEVQMZP
      KZQMZVKNOZRZDJSCTUBZBTSAJSVOFEVBGVQEUGZWDVNABJTWEWCVMCDTJWEWBVLVFWEWAVJVK
      NWEVTVIQWEVRVGVSVHPVDVQEUHVEVQEUHUIUJUKULUMUNABCDFUOUPVCVPVOIJEUQURUSUTVA
      $.

    $( Property defining a linear functional.  (Contributed by NM,
       11-Feb-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    ellnfn $p |- ( T e. LinFn <-> ( T : ~H --> CC /\
        A. x e. CC A. y e. ~H A. z e. ~H
       ( T ` ( ( x .h y ) +h z ) ) = ( ( x x. ( T ` y ) ) + ( T ` z ) ) ) ) $=
      ( vt clf wcel cc chil cmap co cv csm cfv cmul caddc wceq wral wa fveq1 wf
      cva oveq2d oveq12d eqeq12d ralbidv 2ralbidv df-lnfn elrab2 ax-hilex elmap
      cnex anbi1i bitri ) DFGDHIJKZGZALZBLZMKCLZUBKZDNZUQURDNZOKZUSDNZPKZQZCIRZ
      BIRAHRZSIHDUAZVHSUTELZNZUQURVJNZOKZUSVJNZPKZQZCIRZBIRAHRVHEDUOFVJDQZVQVGA
      BHIVRVPVFCIVRVKVAVOVEUTVJDTVRVMVCVNVDPVRVLVBUQOURVJDTUCUSVJDTUDUEUFUGABCE
      UHUIUPVIVHHIDULUJUKUMUN $.

    $( A linear Hilbert space functional is a functional.  (Contributed by NM,
       25-Apr-2006.)  (New usage is discouraged.) $)
    lnfnf $p |- ( T e. LinFn -> T : ~H --> CC ) $=
      ( vx vy vz clf wcel chil cc wf cv csm cva cfv cmul caddc wceq wral ellnfn
      co simplbi ) AEFGHAIBJZCJZKSDJZLSAMUAUBAMNSUCAMOSPDGQCGQBHQBCDART $.

    $( Alternate definition of the adjoint of a Hilbert space operator.
       (Contributed by NM, 20-Feb-2006.)  (New usage is discouraged.) $)
    dfadj2 $p |- adjh = { <. t , u >. | ( t : ~H --> ~H /\ u : ~H --> ~H /\
         A. x e. ~H A. y e. ~H ( x .ih ( t ` y ) ) = ( ( u ` x ) .ih y ) ) } $=
      ( cado chil cv wf cfv csp co wceq wral w3a copab df-adjh wa adjsym df-3an
      eqcom 2ralbii syl6rbbr pm5.32i 3bitr4i opabbii eqtri ) EFFDGZHZFFCGZHZAGZ
      UGIBGZJKZUKULUIIJKZLZBFMAFMZNZDCOUHUJUKULUGIJKUKUIIULJKLBFMAFMZNZDCOABCDP
      UQUSDCUHUJQZUPQUTURQUQUSUTUPURUTURUNUMLZBFMAFMUPABUGUIRUOVAABFFUMUNTUAUBU
      CUHUJUPSUHUJURSUDUEUF $.

    $( Functionality of the adjoint function.  (Contributed by NM,
       15-Feb-2006.)  (New usage is discouraged.) $)
    funadj $p |- Fun adjh $=
      ( vt vu vx vy cado wfun chil cv wf cfv csp co wceq wral w3a copab funopab
      wmo wa adjmo 3simpc moimi ax-mp mpgbir dfadj2 funeqi mpbir ) EFGGAHZIZGGB
      HZIZCHZDHZUHJKLULUJJUMKLMDGNCGNZOZABPZFZUQUOBRZAUOABQUKUNSZBRURCDBUHTUOUS
      BUIUKUNUAUBUCUDEUPCDBAUEUFUG $.

    $( The domain of the adjoint function is a subset of the maps from ` ~H `
       to ` ~H ` .  (Contributed by NM, 15-Feb-2006.)
       (New usage is discouraged.) $)
    dmadjss $p |- dom adjh C_ ( ~H ^m ~H ) $=
      ( vt vu vx vy cado cdm cv chil cmap co wcel wf cfv csp wceq wral wa copab
      w3a ax-hilex dfadj2 3anass elmap anbi1i bitr4i opabbii dmopabss eqsstri
      eqtri dmeqi ) EFAGZHHIJZKZHHBGZLZCGZDGZUKMNJUPUNMUQNJODHPCHPZQZQZABRZFULE
      VAEHHUKLZUOURSZABRVACDBAUAVCUTABVCVBUSQUTVBUOURUBUMVBUSHHUKTTUCUDUEUFUIUJ
      USABULUGUH $.

    $( A member of the domain of the adjoint function is a Hilbert space
       operator.  (Contributed by NM, 15-Feb-2006.)
       (New usage is discouraged.) $)
    dmadjop $p |- ( T e. dom adjh -> T : ~H --> ~H ) $=
      ( cado cdm wcel chil cmap co wf dmadjss sseli ax-hilex elmap sylib ) ABCZ
      DAEEFGZDEEAHNOAIJEEAKKLM $.

    $( Elementhood in the domain of the adjoint function.  (Contributed by
       Mario Carneiro, 11-Sep-2015.)  (Revised by Mario Carneiro,
       24-Dec-2016.)  (New usage is discouraged.) $)
    adjeu $p |- ( T : ~H --> ~H -> ( T e. dom adjh <-> E! u e. ( ~H ^m ~H )
       A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( u ` x ) .ih y ) ) ) $=
      ( vt chil wf cado cdm wcel cv cfv csp co wceq wral wa wex cvv ax-hilex wb
      cmap wreu fex2 mp3an23 feq1 oveq2d eqeq1d 2ralbidv 3anbi13d 3anass syl6bb
      w3a fveq1 exbidv 19.42v copab cab dfadj2 dmeqi dmopab eqtri baibd mpancom
      elab2g weu df-reu elmap anbi1i eubii wmo adjmo mpbiran2 3bitri syl6bbr
      eu5 ) FFDGZDHIZJZFFCKZGZAKZBKZDLZMNZWBVTLWCMNZOZBFPAFPZQZCRZWHCFFUBNZUCZD
      SJZVQVSWJUAVQFSJZWNWMTTFFDSSUDUEWMVSVQWJFFEKZGZWAWBWCWOLZMNZWFOZBFPAFPZUM
      ZCRZVQWJQZEDVRSWODOZXBVQWIQZCRXCXDXAXECXDXAVQWAWHUMXEXDWPVQWTWHWAFFWODUFX
      DWSWGABFFXDWRWEWFXDWQWDWBMWCWODUNUGUHUIUJVQWAWHUKULUOVQWICUPULVRXAECUQZIX
      BEURHXFABCEUSUTXAECVAVBVEVCVDWLVTWKJZWHQZCVFWICVFZWJWHCWKVGXHWICXGWAWHFFV
      TTTVHVIVJXIWJWICVKABCDVLWICVPVMVNVO $.

    $( Value of the adjoint function for ` T ` in the domain of ` adjh ` .
       (Contributed by NM, 19-Feb-2006.)  (Revised by Mario Carneiro,
       24-Dec-2016.)  (New usage is discouraged.) $)
    adjval $p |- ( T e. dom adjh -> ( adjh ` T ) = ( iota_ u e. ( ~H ^m ~H )
       A. x e. ~H A. y e. ~H ( x .ih ( T ` y ) ) = ( ( u ` x ) .ih y ) ) ) $=
      ( vt cado wcel cv chil co cfv csp wceq wral wa cio wf w3a ax-hilex syl wb
      cdm cmap crio dmadjop biantrurd elmap anbi1i 3anass 3bitr4g iotabidv wreu
      adjeu riotaiota dfadj2 feq1 fveq1 oveq2d eqeq1d 2ralbidv 3anbi13d fvopab5
      ibi 3eqtr4rd ) DFUBZGZCHZIIUCJZGZAHZBHZDKZLJZVJVGKVKLJZMZBINAINZOZCPZIIDQ
      ZIIVGQZVPRZCPVPCVHUDZDFKVFVQWACVFVTVPOZVSWCOVQWAVFVSWCDUEZUFVIVTVPIIVGSSU
      GUHVSVTVPUIUJUKVFVPCVHULZWBVRMVFWEVFVSVFWEUAWDABCDUMTVCVPCVHUNTIIEHZQZVTV
      JVKWFKZLJZVNMZBINAINZRWAECDFVEABCEUOWFDMZWGVSWKVPVTIIWFDUPWLWJVOABIIWLWIV
      MVNWLWHVLVJLVKWFDUQURUSUTVAVBVD $.

    $( Value of the adjoint function.  (Contributed by NM, 19-Feb-2006.)
       (New usage is discouraged.) $)
    adjval2 $p |- ( T e. dom adjh -> ( adjh ` T ) = ( iota_ u e. ( ~H ^m ~H )
      A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( u ` y ) ) ) ) $=
      ( cado cdm wcel cfv cv csp co wceq chil wral cmap crio adjval wf dmadjop
      wb elmapi wa adjsym eqcom 2ralbii syl6bb syl2an riotabidva eqtrd ) DEFGZD
      EHAIZBIZDHJKUKCIZHULJKLBMNAMNZCMMOKZPUKDHULJKZUKULUMHJKZLZBMNAMNZCUOPABCD
      QUJUNUSCUOUJMMDRZMMUMRZUNUSTUMUOGDSUMMMUAUTVAUBUNUQUPLZBMNAMNUSABDUMUCVBU
      RABMMUQUPUDUEUFUGUHUI $.

    $( The adjoint function equals its converse.  (Contributed by NM,
       15-Feb-2006.)  (New usage is discouraged.) $)
    cnvadj $p |- `' adjh = adjh $=
      ( vu vt vx vy chil cv wf cfv csp co wceq wral w3a copab ccnv cado wa wcel
      wb ccj cnvopab 3ancoma ffvelrn ax-his1 sylan adantrl adantll eqeq12d hicl
      sylan2 ancoms cc cj11 syl2anc bitr2d anassrs eqcom syl6bb ralbidva ralcom
      an4s pm5.32i df-3an 3bitr4i bitri opabbii eqtri dfadj2 cnveqi 3eqtr4i ) E
      EAFZGZEEBFZGZCFZDFZVKHZIJZVOVMHZVPIJZKZDELZCELZMZABNZOZVNVLVPVSIJZVQVOIJZ
      KZCELDELZMZBANZPOPWFWDBANWLWDABUAWDWKBAWDVNVLWCMZWKVLVNWCUBVNVLQZWCQWNWJQ
      WMWKWNWCWJWNWCWIDELZCELWJWNWBWOCEWNVOERZQZWAWIDEWQVPERZQWAWHWGKZWIWNWPWRW
      AWSSZVNWPVLWRWTVNWPQZVLWRQZQZWSVRTHZVTTHZKZWAXBXAWSXFSXBXAQWHXDWGXEXBWPWH
      XDKZVNXBVQERZWPXGEEVPVKUCZVQVOUDUEUFWRXAWGXEKZVLXAWRVSERZXJEEVOVMUCZVPVSU
      DUJUGUHUKXCVRULRZVTULRZXFWASWPXBXMVNXBWPXHXMXIVOVQUIUJUGXAWRXNVLXAXKWRXNX
      LVSVPUIUEUFVRVTUMUNUOVAUPWHWGUQURUSUSWICDEEUTURVBVNVLWCVCVNVLWJVCVDVEVFVG
      PWECDBAVHVIDCABVHVJ $.

    $( The converse of the adjoint function is a function.  (Contributed by NM,
       25-Jan-2006.)  (New usage is discouraged.) $)
    funcnvadj $p |- Fun `' adjh $=
      ( cado ccnv wfun funadj cnvadj funeqi mpbir ) ABZCACDHAEFG $.

    $( The adjoint function maps one-to-one onto its domain.  (Contributed by
       NM, 15-Feb-2006.)  (New usage is discouraged.) $)
    adj1o $p |- adjh : dom adjh -1-1-onto-> dom adjh $=
      ( cado cdm wf1o wfn ccnv wfun crn wceq funadj funfn mpbi funcnvadj cnvadj
      df-rn dmeqi eqtri dff1o2 mpbir3an ) ABZSACASDZAEZFAGZSHAFTIAJKLUBUABSANUA
      AMOPSSAQR $.

    $( The adjoint of an operator belongs to the adjoint function's domain.
       (Contributed by NM, 15-Feb-2006.)  (New usage is discouraged.) $)
    dmadjrn $p |- ( T e. dom adjh -> ( adjh ` T ) e. dom adjh ) $=
      ( cado cdm wf1o wf adj1o f1of ax-mp ffvelrni ) BCZJABJJBDJJBEFJJBGHI $.

    $( The set of eigenvectors of a Hilbert space operator.  (Contributed by
       NM, 11-Mar-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    eigvecval $p |- ( T : ~H --> ~H -> ( eigvec ` T ) =
           { x e. ( ~H \ 0H ) | E. y e. CC ( T ` x ) = ( y .h x ) } ) $=
      ( vt cv cfv csm wceq wrex chil c0h cdif crab cei cvv wcel ax-hilex difexg
      co cc ax-mp rabex fveq1 eqeq1d rexbidv rabbidv df-eigvec fvmptmap ) DCAEZ
      DEZFZBEUIGSZHZBTIZAJKLZMUICFZULHZBTIZAUOMJJNURAUOJOPUOOPQJKORUAUBQQUJCHZU
      NURAUOUSUMUQBTUSUKUPULUIUJCUCUDUEUFABDUGUH $.

    $( The eigenvalues of eigenvectors of a Hilbert space operator.
       (Contributed by NM, 11-Mar-2006.)  (New usage is discouraged.) $)
    eigvalfval $p |- ( T : ~H --> ~H -> ( eigval ` T ) = ( x e. ( eigvec ` T )
                    |-> ( ( ( T ` x ) .ih x ) / ( ( normh ` x ) ^ 2 ) ) ) ) $=
      ( vt cv cei cfv csp co cno c2 cexp cdiv cmpt chil cel fvex mptex ax-hilex
      wceq oveq1d fveq2 fveq1 mpteq12dv df-eigval fvmptmap ) CBACDZEFZADZUFFZUH
      GHZUHIFJKHZLHZMABEFZUHBFZUHGHZUKLHZMNNOAUMUPBEPQRRUFBSZAUGULUMUPUFBEUAUQU
      JUOUKLUQUIUNUHGUHUFBUBTTUCACUDUE $.

    $( The value of the spectrum of an operator.  (Contributed by NM,
       11-Apr-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    specval $p |- ( T : ~H --> ~H -> ( Lambda ` T ) = { x e. CC |
                   -. ( T -op ( x .op ( _I |` ~H ) ) ) : ~H -1-1-> ~H } ) $=
      ( vt chil cv cid cres chot co chod wf1 wn cc crab cspc cnex ax-hilex wceq
      rabex wb oveq1 f1eq1 syl notbid rabbidv df-spec fvmptmap ) CBDDCEZAEFDGHI
      ZJIZKZLZAMNDDBUIJIZKZLZAMNDDOUOAMPSQQUHBRZULUOAMUPUKUNUPUJUMRUKUNTUHBUIJU
      ADDUJUMUBUCUDUEACUFUG $.

    $( The spectrum of an operator is a set of complex numbers.  (Contributed
       by NM, 11-Apr-2006.)  (New usage is discouraged.) $)
    speccl $p |- ( T : ~H --> ~H -> ( Lambda ` T ) C_ CC ) $=
      ( vx chil wf cspc cfv cv cid cres chot co chod wf1 wn crab specval ssrab2
      cc syl6eqss ) CCADAEFCCABGHCIJKLKMNZBRORBAPTBRQS $.
  $}

  ${
    $d t x y z U $.
    hhlno.1 $e |- U = <. <. +h , .h >. , normh >. $.
    hhlno.2 $e |- L = ( U LnOp U ) $.
    $( The linear operators of Hilbert space.  (Contributed by NM,
       19-Nov-2007.)  (Revised by Mario Carneiro, 19-Nov-2013.)
       (New usage is discouraged.) $)
    hhlnoi $p |- LinOp = L $=
      ( vx vy vz vt clo cv csm co cva cfv wceq chil wral cc cmap crab wcel hhnv
      df-lnop cnv hhba hhva hhsm lnoval mp2an eqtr4i ) IEJZFJZKLGJZMLHJZNUKULUN
      NKLUMUNNMLOGPQFPQERQHPPSLTZBEFGHUCAUDUAZUPBUOOACUBZUQEFGHKKAMMBAPPACUEZUR
      ACUFZUSACUGZUTDUHUIUJ $.
  $}

  ${
    $d t x y z U $.
    hhnmo.1 $e |- U = <. <. +h , .h >. , normh >. $.
    ${
      hhnmo.2 $e |- N = ( U normOpOLD U ) $.
      $( The norm of an operator in Hilbert space.  (Contributed by NM,
         19-Nov-2007.)  (Revised by Mario Carneiro, 17-Nov-2013.)
         (New usage is discouraged.) $)
      hhnmoi $p |- normop = N $=
        ( vt vy vx cnop chil cmap co cv cno cfv c1 cle wbr wceq wa wrex cab cxr
        clt csup cmpt df-nmop cnv wcel hhnv hhba hhnm nmoofval mp2an eqtr4i ) H
        EIIJKFLZMNOPQGLUOELNMNRSFITGUAUBUCUDUEZBGFEUFAUGUHZUQBUPRACUIZURGFEAMMB
        AIIACUJZUSACUKZUTDULUMUN $.
    $}

    ${
      hhblo.2 $e |- B = ( U BLnOp U ) $.
      $( A bounded linear operator in Hilbert space.  (Contributed by NM,
         19-Nov-2007.)  (Revised by Mario Carneiro, 19-Nov-2013.)
         (New usage is discouraged.) $)
      hhbloi $p |- BndLinOp = B $=
        ( vx cbo cv cnop cfv cpnf clt wbr clo crab df-bdop cnv wcel wceq eqid
        co hhnv cnmoo hhnmoi clno hhlnoi bloval mp2an eqtr4i ) FEGHIJKLEMNZAEOB
        PQZUJAUIRBCUAZUKEABMHBBBBUBTZCULSUCBBBUDTZCUMSUEDUFUGUH $.
    $}

    ${
      hh0o.2 $e |- Z = ( U 0op U ) $.
      $( The zero operator in Hilbert space.  (Contributed by NM, 7-Dec-2007.)
         (New usage is discouraged.) $)
      hh0oi $p |- 0hop = Z $=
        ( chil c0h cxp cba cfv cn0v csn ch0o hhba c0v df-ch0 hh0v sneqi xpeq12i
        eqtri eqid df0op2 cnv wcel wceq hhnv 0ofval mp2an 3eqtr4i ) EFGAHIZAJIZ
        KZGZLBEUIFUKACMFNKUKONUJACPQSRUAAUBUCZUMBULUDACUEZUNABAUIUJUITUJTDUFUGU
        H $.
    $}
  $}

  ${
    $d w x y z D $.  $d t w x y z J $.  $d t w x y z K $.
    hhcn.1 $e |- D = ( normh o. -h ) $.
    hhcn.2 $e |- J = ( MetOpen ` D ) $.
    $( The continuous operators of Hilbert space.  (Contributed by Mario
       Carneiro, 19-May-2014.)  (New usage is discouraged.) $)
    hhcno $p |- ConOp = ( J Cn J ) $=
      ( vw vx vz vt vy cv cmv co cno cfv clt chil wral crp wcel wa wi wrex cmap
      wbr crab cab ccop df-rab df-cnop wf wceq hilmetdval normsub eqtrd adantll
      ccn breq1d ffvelrn anim12dan syl anassrs imbi12d ralbidva rexbidv ralbidv
      pm5.32i cxmt wb hilxmet metcn mp2an ax-hilex elmap anbi1i 3bitr4i 3eqtr4i
      abbi2i ) EJZFJZKLMNZGJZOUDZVRHJZNZVSWCNZKLMNZIJZOUDZUAZEPQZGRUBZIRQZFPQZH
      PPUCLZUEWCWNSZWMTZHUFUGBBUPLZWMHWNUHFIGEHUIWPHWQPPWCUJZVSVRALZWAOUDZWEWDA
      LZWGOUDZUAZEPQZGRUBZIRQZFPQZTZWRWMTWCWQSZWPWRXGWMWRXFWLFPWRVSPSZTZXEWKIRX
      KXDWJGRXKXCWIEPXKVRPSZTZWTWBXBWHXMWSVTWAOXJXLWSVTUKWRXJXLTZWSVSVRKLMNVTVS
      VRACULVSVRUMUNUOUQXMXAWFWGOWRXJXLXAWFUKZWRXNTWEPSZWDPSZTZXOWRXJXPXLXQPPVS
      WCURPPVRWCURUSXRXAWEWDKLMNWFWEWDACULWEWDUMUNUTVAUQVBVCVDVEVCVFAPVGNSZXSXI
      XHVHACVIZXTFIGEAAWCBBPPDDVJVKWOWRWMPPWCVLVLVMVNVOVQVP $.

    hhcn.4 $e |- K = ( TopOpen ` CCfld ) $.
    $( The continuous functionals of Hilbert space.  (Contributed by Mario
       Carneiro, 19-May-2014.)  (New usage is discouraged.) $)
    hhcnf $p |- ConFn = ( J Cn K ) $=
      ( vw vx vz vt vy co cfv clt chil wral crp cc wcel wa cv cmv cno cmin cabs
      wbr wi wrex cmap crab cab ccnfn df-rab df-cnfn wf ccom hilmetdval normsub
      ccn wceq eqtrd adantll breq1d ffvelrn anim12dan eqid cnmetdval abssub syl
      anassrs imbi12d ralbidva rexbidv ralbidv pm5.32i cxmt wb cnxmet cnfldtopn
      hilxmet metcn mp2an cnex ax-hilex elmap anbi1i 3bitr4i abbi2i 3eqtr4i ) G
      UAZHUAZUBLUCMZIUAZNUFZWJJUAZMZWKWOMZUDLUEMZKUAZNUFZUGZGOPZIQUHZKQPZHOPZJR
      OUILZUJWOXFSZXETZJUKULBCUSLZXEJXFUMHKIGJUNXHJXIORWOUOZWKWJALZWMNUFZWQWPUE
      UDUPZLZWSNUFZUGZGOPZIQUHZKQPZHOPZTZXJXETWOXISZXHXJXTXEXJXSXDHOXJWKOSZTZXR
      XCKQYDXQXBIQYDXPXAGOYDWJOSZTZXLWNXOWTYFXKWLWMNYCYEXKWLUTXJYCYETZXKWKWJUBL
      UCMWLWKWJADUQWKWJURVAVBVCYFXNWRWSNXJYCYEXNWRUTZXJYGTWQRSZWPRSZTZYHXJYCYIY
      EYJORWKWOVDORWJWOVDVEYKXNWQWPUDLUEMWRWQWPXMXMVFVGWQWPVHVAVIVJVCVKVLVMVNVL
      VOAOVPMSXMRVPMSYBYAVQADVTVRHKIGAXMWOBCORECFVSWAWBXGXJXEROWOWCWDWEWFWGWHWI
      $.
  $}

  $( The adjoint of an operator belongs to the adjoint function's domain.
     (Note: the converse is dependent on our definition of function value,
     since it uses ~ ndmfv .)  (Contributed by NM, 19-Feb-2006.)
     (New usage is discouraged.) $)
  dmadjrnb $p |- ( T e. dom adjh <-> ( adjh ` T ) e. dom adjh ) $=
    ( cado cdm wcel cfv dmadjrn wn c0 chil wf wceq c0v ax-hv0cl n0i ax-mp eqcom
    mtbir dm0 eqeq1i mto fdm dmadjop ndmfv eleq1d mtbiri con4i impbii ) ABCZDZA
    BEZUHDZAFUIUKUIGZUKHUHDZUMIIHJZUNHCZIKZUPHIKZUQIHKZLIDURGMILNOHIPQUOHIRSQII
    HUATHUBTULUJHUHABUCUDUEUFUG $.

  ${
    $d t w x y z A $.  $d t w x y z B $.  $d x y z C $.  $d w x y z S $.
    $d x y z w T $.
    $( A lower bound for an operator norm.  (Contributed by NM, 7-Feb-2006.)
       (New usage is discouraged.) $)
    nmoplb $p |- ( ( T : ~H --> ~H /\ A e. ~H /\ ( normh ` A ) <_ 1 ) ->
                  ( normh ` ( T ` A ) ) <_ ( normop ` T ) ) $=
      ( vy vx chil wf wcel cno cfv c1 cle wbr w3a cv wceq wa cxr 3ad2ant1 fveq2
      wrex cab clt csup wss cr nmopsetretHIL ressxr syl6ss breq1d fveq2d eqeq2d
      cnop anbi12d eqid biantru syl6bbr rspcev fvex eqeq1 anbi2d rexbidv sylibr
      elab 3adant1 supxrub syl2anc nmopval breqtrrd ) EEBFZAEGZAHIZJKLZMZABIZHI
      ZCNZHIZJKLZDNZVPBIZHIZOZPZCETZDUAZQUBUCZBULIZKVMWEQUDZVOWEGZVOWFKLVIVJWHV
      LVIWEUEQDCBUFUGUHRVJVLWIVIVJVLPVRVOWAOZPZCETZWIWKVLCAEVPAOZWKVLVOVOOZPVLW
      MVRVLWJWNWMVQVKJKVPAHSUIWMWAVOVOWMVTVNHVPABSUJUKUMWNVLVOUNUOUPUQWDWLDVOVN
      HURVSVOOZWCWKCEWOWBWJVRVSVOWAUSUTVAVCVBVDWEVOVEVFVIVJWGWFOVLDCBVGRVH $.

    $( An upper bound for an operator norm.  (Contributed by NM, 7-Mar-2006.)
       (New usage is discouraged.) $)
    nmopub $p |- ( ( T : ~H --> ~H /\ A e. RR* ) -> ( ( normop ` T ) <_ A <->
      A. x e. ~H ( ( normh ` x ) <_ 1 -> ( normh ` ( T ` x ) ) <_ A ) ) ) $=
      ( vy vz chil wf cxr wa cfv cle wbr cv cno wceq wrex wi wral wal albii cab
      wcel cnop c1 clt nmopval adantr breq1d wss wb nmopsetretALT ressxr syl6ss
      cr supxrleub sylan ancom eqeq1 anbi1d syl5bb rexbidv ralab ralcom4 impexp
      csup fvex breq1 imbi2d ceqsalv bitri ralbii r19.23v 3bitr3i bitr4i syl6bb
      bitrd ) FFCGZBHUBZIZCUCJZBKLAMZNJUDKLZDMZWACJZNJZOZIZAFPZDUAZHUEVEZBKLZWB
      WEBKLZQZAFRZVSVTWJBKVQVTWJOVRDACUFUGUHVSWKEMZBKLZEWIRZWNVQWIHUIVRWKWQUJVQ
      WIUNHDACUKULUMEWIBUOUPWQWOWEOZWBIZAFPZWPQZESZWNWHWTWPEDWCWOOZWGWSAFWGWFWB
      IXCWSWBWFUQXCWFWRWBWCWOWEURUSUTVAVBWSWPQZESZAFRXDAFRZESWNXBXDAEFVCXEWMAFX
      EWRWBWPQZQZESWMXDXHEWRWBWPVDTXGWMEWEWDNVFWRWPWLWBWOWEBKVGVHVIVJVKXFXAEWSW
      PAFVLTVMVNVOVP $.

    $( An upper bound for an operator norm.  (Contributed by NM, 12-Apr-2006.)
       (New usage is discouraged.) $)
    nmopub2tALT $p |- ( ( T : ~H --> ~H /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. ~H
  ( normh ` ( T ` x ) ) <_ ( A x. ( normh ` x ) ) ) -> ( normop ` T ) <_ A ) $=
      ( chil cr wcel cle wbr wa cfv cno cmul co wral c1 wi normcl sylan2 adantr
      adantlr wf cc0 cv cnop ad2antlr simpllr 1re lemul2a mp3anl2 syl21anc wceq
      ax-1rid ad2antrl ad2antrr breqtrd ffvelrn remulcl adantll simplrl syl3anc
      simpr syl letr mpan2d ex com23 ralimdva imp wb rexr nmopub biimpar syldan
      cxr 3impa ) DDCUAZBEFZUBBGHZIZAUCZCJZKJZBVTKJZLMZGHZADNZCUDJBGHZVPVSIZWFW
      COGHZWBBGHZPZADNZWGWHWFWLWHWEWKADWHVTDFZIZWIWEWJWNWIWEWJPWNWIIZWEWDBGHZWJ
      WOWDBOLMZBGWOWCEFZVSWIWDWQGHZWMWRWHWIVTQZUEVPVSWMWIUFWNWIVAWROEFVSWIWSUGW
      COBUHUIUJWHWQBUKZWMWIVQXAVPVRBULUMUNUOWNWEWPIWJPZWIWNWBEFZWDEFZVQXBVPWMXC
      VSVPWMIWADFXCDDVTCUPWAQVBTVSWMXDVPVQWMXDVRWMVQWRXDWTBWCUQRTURVPVQVRWMUSWB
      WDBVCUTSVDVEVFVGVHWHWGWLVSVPBVNFZWGWLVIVQXEVRBVJSABCVKRVLVMVO $.

    $( An upper bound for an operator norm.  (Contributed by NM, 13-Dec-2007.)
       (New usage is discouraged.) $)
    nmopub2tHIL $p |- ( ( T : ~H --> ~H /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. ~H
  ( normh ` ( T ` x ) ) <_ ( A x. ( normh ` x ) ) ) -> ( normop ` T ) <_ A ) $=
      ( cva csm cop cno cnop chil df-hba eqid hhnm cnmoo co hhnmoi hhnv nmoub2i
      ) ABCDEFGFZGGHRIIJJRRKZLZTRRRMNZSUAKORSPZUBQ $.

    $( The norm of any Hilbert space operator is nonnegative.  (Contributed by
       NM, 9-Feb-2006.)  (New usage is discouraged.) $)
    nmopge0 $p |- ( T : ~H --> ~H -> 0 <_ ( normop ` T ) ) $=
      ( chil wf cc0 c0v cfv cno cle wbr cnop ax-hv0cl ffvelrn mpan2 normge0 syl
      wcel c1 norm0 0le1 cxr eqbrtri nmoplb wa wi cr normcl rexrd nmopxr xrletr
      mp3an23 0xr mp3an1 syl2anc mp2and ) BBACZDEAFZGFZHIZUQAJFZHIZDUSHIZUOUPBP
      ZURUOEBPZVBKBBEALMZUPNOUOVCEGFZQHIUTKVEDQHRSUAEAUBUJUOUQTPZUSTPZURUTUCVAU
      DZUOUQUOVBUQUEPVDUPUFOUGAUHDTPVFVGVHUKDUQUSUIULUMUN $.

    $( A linear Hilbert space operator that is not identically zero has a
       positive norm.  (Contributed by NM, 9-Feb-2006.)
       (New usage is discouraged.) $)
    nmopgt0 $p |- ( T : ~H --> ~H ->
                  ( ( normop ` T ) =/= 0 <-> 0 < ( normop ` T ) ) ) $=
      ( chil wf cc0 cnop cfv clt wbr wne cxr cle wb nmopxr nmopge0 0xr xrleltne
      wcel mp3an1 syl2anc bicomd ) BBACZDAEFZGHZUBDIZUAUBJQZDUBKHZUCUDLZAMANDJQ
      UEUFUGODUBPRST $.

    $( Basic continuity property of a continuous Hilbert space operator.
       (Contributed by NM, 2-Feb-2006.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    cnopc $p |- ( ( T e. ConOp /\ A e. ~H /\ B e. RR+ ) ->
               E. x e. RR+ A. y e. ~H ( ( normh ` ( y -h A ) ) < x ->
               ( normh ` ( ( T ` y ) -h ( T ` A ) ) ) < B ) ) $=
      ( vz vw wcel chil crp cv cmv co cno cfv clt wbr wi wral wrex wa wf elcnop
      simprbi oveq2 fveq2d breq1d fveq2 oveq2d imbi12d rexralbidv imbi2d rspc2v
      ccop wceq breq2 syl5com 3impib ) EUNHZCIHZDJHZBKZCLMZNOZAKZPQZVBEOZCEOZLM
      ZNOZDPQZRZBISAJTZUSVBFKZLMZNOZVEPQZVGVNEOZLMZNOZGKZPQZRZBISAJTZGJSFISZUTV
      AUAVMUSIIEUBWEFGABEUCUDWDVMVFVJWAPQZRZBISAJTFGCDIJVNCUOZWCWGABJIWHVQVFWBW
      FWHVPVDVEPWHVOVCNVNCVBLUEUFUGWHVTVJWAPWHVSVINWHVRVHVGLVNCEUHUIUFUGUJUKWAD
      UOZWGVLABJIWIWFVKVFWADVJPUPULUKUMUQUR $.

    $( Basic linearity property of a linear Hilbert space operator.
       (Contributed by NM, 22-Jan-2006.)  (New usage is discouraged.) $)
    lnopl $p |- ( ( ( T e. LinOp /\ A e. CC ) /\ ( B e. ~H /\ C e. ~H ) ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A .h ( T ` B ) ) +h ( T ` C ) ) ) $=
      ( vx vy vz wcel cc chil csm co cva cfv wceq cv wral oveq1d fveq2d eqeq12d
      clo wa wi w3a ellnop simprbi oveq1 oveq2 fveq2 oveq2d rspc3v 3expb impcom
      wf syl5 anassrs ) DUAHZAIHZBJHZCJHZUBZABKLZCMLZDNZABDNZKLZCDNZMLZOZURVAUB
      UQVIURUSUTUQVIUCUQEPZFPZKLZGPZMLZDNZVJVKDNZKLZVMDNZMLZOZGJQFJQEIQZURUSUTU
      DVIUQJJDUNWAEFGDUEUFVTVIAVKKLZVMMLZDNZAVPKLZVRMLZOVBVMMLZDNZVFVRMLZOEFGAB
      CIJJVJAOZVOWDVSWFWJVNWCDWJVLWBVMMVJAVKKUGRSWJVQWEVRMVJAVPKUGRTVKBOZWDWHWF
      WIWKWCWGDWKWBVBVMMVKBAKUHRSWKWEVFVRMWKVPVEAKVKBDUIUJRTVMCOZWHVDWIVHWLWGVC
      DVMCVBMUHSWLVRVGVFMVMCDUIUJTUKUOULUMUP $.

    $( Basic inner product property of a unitary operator.  (Contributed by NM,
       22-Jan-2006.)  (New usage is discouraged.) $)
    unop $p |- ( ( T e. UniOp /\ A e. ~H /\ B e. ~H ) ->
                ( ( T ` A ) .ih ( T ` B ) ) = ( A .ih B ) ) $=
      ( vx vy cuo wcel chil w3a cv cfv csp wceq wral wfo elunop simprbi eqeq12d
      co fveq2 3ad2ant1 wi oveq1d oveq1 oveq2d oveq2 rspc2v 3adant1 mpd ) CFGZA
      HGZBHGZIDJZCKZEJZCKZLSZUMUOLSZMZEHNDHNZACKZBCKZLSZABLSZMZUJUKUTULUJHHCOUT
      DECPQUAUKULUTVEUBUJUSVEVAUPLSZAUOLSZMDEABHHUMAMZUQVFURVGVHUNVAUPLUMACTUCU
      MAUOLUDRUOBMZVFVCVGVDVIUPVBVALUOBCTUEUOBALUFRUGUHUI $.

    $( A unitary operator in Hilbert space is one-to-one and onto.
       (Contributed by NM, 22-Jan-2006.)  (New usage is discouraged.) $)
    unopf1o $p |- ( T e. UniOp -> T : ~H -1-1-onto-> ~H ) $=
      ( vx vy wcel chil cv cfv wceq wral csp co syl cmv caddc cmin unop oveq12d
      wa cc0 wb cuo wf1 wfo wf1o wf elunop simplbi fof 3anidm23 3adant3 3adant2
      wi 3com23 3expb ffvelrn anim12dan sylan normlem9at adantl 3eqtr4rd eqeq1d
      w3a hvsubcl his6 hvsubeq0 bitrd 3bitr3rd biimpd ralrimivva dff13 sylanbrc
      c0v df-f1o ) AUADZEEAUBZEEAUCZEEAUDVNEEAUEZBFZAGZCFZAGZHZVRVTHZULZCEIBEIV
      OVNVPVQVNVPVSWAJKZVRVTJKZHCEIBEIBCAUFUGZEEAUHLZVNWDBCEEVNVREDZVTEDZRZRZWB
      WCWLVRVTMKZWMJKZSHZVSWAMKZWPJKZSHZWCWBWLWNWQSWLVSVSJKZWAWAJKZNKZWEWAVSJKZ
      NKZOKZVRVRJKZVTVTJKZNKZWFVTVRJKZNKZOKZWQWNVNWIWJXDXJHVNWIWJVBZXAXGXCXIOXK
      WSXEWTXFNVNWIWSXEHZWJVNWIXLVRVRAPUIUJVNWJWTXFHZWIVNWJXMVTVTAPUIUKQXKWEWFX
      BXHNVRVTAPVNWJWIXBXHHVTVRAPUMQQUNWLVSEDZWAEDZRZWQXDHVNVQWKXPWHVQWIXNWJXOE
      EVRAUOEEVTAUOUPUQZVSWAURLWKWNXJHVNVRVTURUSUTVAWKWOWCTVNWKWOWMVLHZWCWKWMED
      WOXRTVRVTVCWMVDLVRVTVEVFUSWLXPWRWBTXQXPWRWPVLHZWBXPWPEDWRXSTVSWAVCWPVDLVS
      WAVEVFLVGVHVIBCEEAVJVKWGEEAVMVK $.

    $( A unitary operator is idempotent in the norm.  (Contributed by NM,
       25-Feb-2006.)  (New usage is discouraged.) $)
    unopnorm $p |- ( ( T e. UniOp /\ A e. ~H ) ->
                ( normh ` ( T ` A ) ) = ( normh ` A ) ) $=
      ( wcel chil cfv cno cr syl normcl adantl cc0 cle wbr normge0 co cexp wceq
      csp c2 normsq cuo wa wf1o wf unopf1o f1of ffvelrnda unop 3anidm23 3eqtr4d
      sq11d ) BUACZADCZUBZABEZFEZAFEZUNUODCZUPGCULDDABULDDBUCDDBUDBUEDDBUFHUGZU
      OIHUMUQGCULAIJUNURKUPLMUSUONHUMKUQLMULANJUNUOUOROZAAROZUPSPOZUQSPOZULUMUT
      VAQAABUHUIUNURVBUTQUSUOTHUMVCVAQULATJUJUK $.

    $( The inverse (converse) of a unitary operator in Hilbert space is
       unitary.  Theorem in [AkhiezerGlazman] p. 72.  (Contributed by NM,
       22-Jan-2006.)  (New usage is discouraged.) $)
    cnvunop $p |- ( T e. UniOp -> `' T e. UniOp ) $=
      ( vx vy cuo wcel chil ccnv cv cfv csp co wceq wral wf1o ffvelrnda adantrr
      syl wa adantrl f1ocnvfv2 wfo unopf1o f1ocnv f1ofo wf unop syl3anc oveq12d
      simpl fof sylan eqtr3d ralrimivva elunop sylanbrc ) ADEZFFAGZUAZBHZUQIZCH
      ZUQIZJKZUSVAJKZLZCFMBFMUQDEUPFFANZURAUBZVFFFUQNURFFAUCFFUQUDQQZUPVEBCFFUP
      USFEZVAFEZRZRZUTAIZVBAIZJKZVCVDVLUPUTFEZVBFEZVOVCLUPVKUIUPVIVPVJUPFFUSUQU
      PURFFUQUEVHFFUQUJQZOPUPVJVQVIUPFFVAUQVROSUTVBAUFUGUPVFVKVOVDLVGVFVKRVMUSV
      NVAJVFVIVMUSLVJFFUSATPVFVJVNVALVIFFVAATSUHUKULUMBCUQUNUO $.

    $( The inverse (converse) of a unitary operator is its adjoint.  Equation 2
       of [AkhiezerGlazman] p. 72.  (Contributed by NM, 22-Jan-2006.)
       (New usage is discouraged.) $)
    unopadj $p |- ( ( T e. UniOp /\ A e. ~H /\ B e. ~H ) ->
                  ( ( T ` A ) .ih B ) = ( A .ih ( `' T ` B ) ) ) $=
      ( cuo wcel chil w3a cfv ccnv co wceq wf1o unopf1o f1ocnvfv2 sylan 3adant2
      csp oveq2d wf f1ocnv f1of 3syl ffvelrnda unop syld3an3 eqtr3d ) CDEZAFEZB
      FEZGZACHZBCIZHZCHZQJZUKBQJAUMQJZUJUNBUKQUGUIUNBKZUHUGFFCLZUIUQCMZFFBCNOPR
      UGUHUIUMFEZUOUPKUGUIUTUHUGFFBULUGURFFULLFFULSUSFFCTFFULUAUBUCPAUMCUDUEUF
      $.

    $( A unitary operator is linear.  Theorem in [AkhiezerGlazman] p. 72.
       (Contributed by NM, 22-Jan-2006.)  (New usage is discouraged.) $)
    unoplin $p |- ( T e. UniOp -> T e. LinOp ) $=
      ( vx vy vz vw wcel chil cv co cfv wceq wral cc wa csp cmul adantr unopadj
      caddc ad2antrr cuo csm cva clo wf1o unopf1o f1of syl ccnv simplll hvmulcl
      hvaddcl sylan adantll syl3anc simprl simprr simplr cnvunop 3syl ffvelrnda
      wf simpr adantlr adantllr hiassdi syl22anc adantrl 3expa adantlrl oveq12d
      oveq2d eqtr2d 3eqtrd ralrimiva wb ffvelrn anassrs syl2anc hial2eq sylanl1
      sylan2 an12s mpbid ralrimivva ellnop sylanbrc ) AUAFZGGAVBZBHZCHZUBIZDHZU
      CIZAJZWJWKAJZUBIZWMAJZUCIZKZDGLZCGLBMLAUDFWHGGAUEWIAUFGGAUGUHZWHXABCMGWHW
      JMFZWKGFZNZNZWTDGXFWMGFZNZWOEHZOIZWSXIOIZKZEGLZWTXHXLEGXHXIGFZNZXJWNXIAUI
      ZJZOIZWJWKXQOIZPIZWMXQOIZSIZXKXOWHWNGFZXNXJXRKWHXEXGXNUJXHYCXNXEXGYCWHXEW
      LGFXGYCWJWKUKWLWMULUMZUNQXHXNVCZWNXIARUOXOXCXDXGXQGFZXRYBKXFXCXGXNWHXCXDU
      PTZXFXDXGXNWHXCXDUQTXFXGXNURWHXGXNYFXEWHXNYFXGWHGGXIXPWHXPUAFGGXPUEGGXPVB
      AUSXPUFGGXPUGUTVAVDVEWJWKWMXQVFVGXOXKWJWPXIOIZPIZWRXIOIZSIZYBXOXCWPGFZWRG
      FZXNXKYKKYGXFYLXGXNWHXDYLXCWHGGWKAXBVAVHTWHXGXNYMXEWHXGNYMXNWHGGWMAXBVAQV
      EYEWJWPWRXIVFVGXOYIXTYJYASXFXNYIXTKZXGWHXDXNYNXCWHXDNXNNYHXSWJPWHXDXNYHXS
      KWKXIARVIVLVJVDWHXGXNYJYAKZXEWHXGXNYOWMXIARVIVEVKVMVNVOWHWIXEXGXMWTVPZXBW
      IXENZXGNZWOGFZWSGFZYPWIXEXGYSXEXGNWIYCYSYDGGWNAVQWBVRYRWQGFZYMYTYQUUAXGXC
      WIXDUUAWIXDNXCYLUUAGGWKAVQWJWPUKWBWCQWIXGYMXEGGWMAVQVDWQWRULVSEWOWSVTVSWA
      WDVOWEBCDAWFWG $.

    $( The composition of two unitary operators is unitary.  (Contributed by
       NM, 22-Jan-2006.)  (New usage is discouraged.) $)
    counop $p |- ( ( S e. UniOp /\ T e. UniOp ) -> ( S o. T ) e. UniOp ) $=
      ( vx vy cuo wcel wa chil cv cfv csp co wceq wral unopf1o syl2an syl fvco3
      wf1o ffvelrn ccom wfo f1oco f1ofo wf adantl simpl simpr oveq12d anim12dan
      f1of sylan 3expb sylan2 anassrs adantll 3eqtrd ralrimivva elunop sylanbrc
      unop ) AEFZBEFZGZHHABUAZUBZCIZVEJZDIZVEJZKLZVGVIKLZMZDHNCHNVEEFVDHHVESZVF
      VBHHASHHBSZVNVCAOBOZHHHABUCPHHVEUDQVDVMCDHHVDVGHFZVIHFZGZGZVKVGBJZAJZVIBJ
      ZAJZKLZWAWCKLZVLVTVHWBVJWDKVDHHBUEZVQVHWBMVSVCWGVBVCVOWGVPHHBUKQZUFZVQVRU
      GHHVGABRPVDWGVRVJWDMVSWIVQVRUHHHVIABRPUIVBVCVSWEWFMZVCVSGVBWAHFZWCHFZGZWJ
      VCWGVSWMWHWGVQWKVRWLHHVGBTHHVIBTUJULVBWKWLWJWAWCAVAUMUNUOVCVSWFVLMZVBVCVQ
      VRWNVGVIBVAUMUPUQURCDVEUSUT $.

    $( Basic inner product property of a Hermitian operator.  (Contributed by
       NM, 19-Mar-2006.)  (New usage is discouraged.) $)
    hmop $p |- ( ( T e. HrmOp /\ A e. ~H /\ B e. ~H ) ->
                ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) ) $=
      ( vx vy cho wcel chil w3a cv cfv csp co wceq wral wf elhmop simprbi fveq2
      eqeq12d 3ad2ant1 wi oveq1 oveq1d oveq2d oveq2 rspc2v 3adant1 mpd ) CFGZAH
      GZBHGZIDJZEJZCKZLMZUMCKZUNLMZNZEHODHOZABCKZLMZACKZBLMZNZUJUKUTULUJHHCPUTD
      ECQRUAUKULUTVEUBUJUSVEAUOLMZVCUNLMZNDEABHHUMANZUPVFURVGUMAUOLUCVHUQVCUNLU
      MACSUDTUNBNZVFVBVGVDVIUOVAALUNBCSUEUNBVCLUFTUGUHUI $.

    $( The inner product of the value and argument of a Hermitian operator is
       real.  (Contributed by NM, 23-Jul-2006.)  (New usage is discouraged.) $)
    hmopre $p |- ( ( T e. HrmOp /\ A e. ~H ) -> ( ( T ` A ) .ih A ) e. RR ) $=
      ( cho wcel chil wa cfv co cr wceq hmop 3anidm23 eqcomd wb hmopf ffvelrnda
      csp hire sylancom mpbird ) BCDZAEDZFZABGZAQHZIDZUEAUDQHZJZUCUGUEUAUBUGUEJ
      AABKLMUAUBUDEDUFUHNUAEEABBOPUDARST $.

    $( A lower bound for a functional norm.  (Contributed by NM, 14-Feb-2006.)
       (New usage is discouraged.) $)
    nmfnlb $p |- ( ( T : ~H --> CC /\ A e. ~H /\ ( normh ` A ) <_ 1 ) ->
                  ( abs ` ( T ` A ) ) <_ ( normfn ` T ) ) $=
      ( vy vx chil cc wcel cno cfv c1 cle wbr cabs cv wceq wa wrex cxr 3ad2ant1
      fveq2 wf w3a cab clt csup cr nmfnsetre ressxr syl6ss breq1d fveq2d eqeq2d
      cnmf anbi12d eqid biantru syl6bbr rspcev fvex eqeq1 anbi2d rexbidv sylibr
      wss elab 3adant1 supxrub syl2anc nmfnval breqtrrd ) EFBUAZAEGZAHIZJKLZUBZ
      ABIZMIZCNZHIZJKLZDNZVRBIZMIZOZPZCEQZDUCZRUDUEZBUMIZKVOWGRVDZVQWGGZVQWHKLV
      KVLWJVNVKWGUFRDCBUGUHUISVLVNWKVKVLVNPVTVQWCOZPZCEQZWKWMVNCAEVRAOZWMVNVQVQ
      OZPVNWOVTVNWLWPWOVSVMJKVRAHTUJWOWCVQVQWOWBVPMVRABTUKULUNWPVNVQUOUPUQURWFW
      NDVQVPMUSWAVQOZWEWMCEWQWDWLVTWAVQWCUTVAVBVEVCVFWGVQVGVHVKVLWIWHOVNDCBVISV
      J $.

    $( An upper bound for the norm of a functional.  (Contributed by NM,
       24-May-2006.)  (Revised by Mario Carneiro, 7-Sep-2014.)
       (New usage is discouraged.) $)
    nmfnleub $p |- ( ( T : ~H --> CC /\ A e. RR* ) -> ( ( normfn ` T ) <_ A <->
      A. x e. ~H ( ( normh ` x ) <_ 1 -> ( abs ` ( T ` x ) ) <_ A ) ) ) $=
      ( vy vz chil cc cxr wa cfv cle wbr cv cabs wceq wrex wi wral wal albii wf
      wcel cnmf cno c1 cab clt nmfnval adantr breq1d wss wb cr nmfnsetre ressxr
      csup syl6ss supxrleub sylan ancom eqeq1 anbi1d rexbidv ralab ralcom4 fvex
      syl5bb impexp breq1 imbi2d ceqsalv ralbii r19.23v 3bitr3i bitr4i syl6bb
      bitri bitrd ) FGCUAZBHUBZIZCUCJZBKLAMZUDJUEKLZDMZWCCJZNJZOZIZAFPZDUFZHUGU
      PZBKLZWDWGBKLZQZAFRZWAWBWLBKVSWBWLOVTDACUHUIUJWAWMEMZBKLZEWKRZWPVSWKHUKVT
      WMWSULVSWKUMHDACUNUOUQEWKBURUSWSWQWGOZWDIZAFPZWRQZESZWPWJXBWREDWEWQOZWIXA
      AFWIWHWDIXEXAWDWHUTXEWHWTWDWEWQWGVAVBVGVCVDXAWRQZESZAFRXFAFRZESWPXDXFAEFV
      EXGWOAFXGWTWDWRQZQZESWOXFXJEWTWDWRVHTXIWOEWGWFNVFWTWRWNWDWQWGBKVIVJVKVQVL
      XHXCEXAWRAFVMTVNVOVPVR $.

    $( An upper bound for the norm of a functional.  (Contributed by NM,
       24-May-2006.)  (New usage is discouraged.) $)
    nmfnleub2 $p |- ( ( T : ~H --> CC /\ ( A e. RR /\ 0 <_ A ) /\ A. x e. ~H
    ( abs ` ( T ` x ) ) <_ ( A x. ( normh ` x ) ) ) -> ( normfn ` T ) <_ A ) $=
      ( chil cc wf cr wcel cle wbr wa cfv cmul co wral c1 adantlr sylan2 adantr
      wi cc0 cv cabs cno cnmf normcl ad2antlr simpllr simpr 1re lemul2a mp3anl2
      syl21anc ax-1rid ad2antrl ad2antrr breqtrd ffvelrn abscld remulcl adantll
      wceq simplrl syl3anc mpan2d ex com23 ralimdva imp cxr wb nmfnleub biimpar
      letr rexr syldan 3impa ) DECFZBGHZUABIJZKZAUBZCLZUCLZBWBUDLZMNZIJZADOZCUE
      LBIJZVRWAKZWHWEPIJZWDBIJZTZADOZWIWJWHWNWJWGWMADWJWBDHZKZWKWGWLWPWKWGWLTWP
      WKKZWGWFBIJZWLWQWFBPMNZBIWQWEGHZWAWKWFWSIJZWOWTWJWKWBUFZUGVRWAWOWKUHWPWKU
      IWTPGHWAWKXAUJWEPBUKULUMWJWSBVBZWOWKVSXCVRVTBUNUOUPUQWPWGWRKWLTZWKWPWDGHZ
      WFGHZVSXDVRWOXEWAVRWOKWCDEWBCURUSQWAWOXFVRVSWOXFVTWOVSWTXFXBBWEUTRQVAVRVS
      VTWOVCWDWFBVNVDSVEVFVGVHVIWJWIWNWAVRBVJHZWIWNVKVSXGVTBVOSABCVLRVMVPVQ $.

    $( The norm of any Hilbert space functional is nonnegative.  (Contributed
       by NM, 24-May-2006.)  (New usage is discouraged.) $)
    nmfnge0 $p |- ( T : ~H --> CC -> 0 <_ ( normfn ` T ) ) $=
      ( chil cc wf cc0 c0v cfv cabs cle wbr cnmf ax-hv0cl ffvelrn mpan2 absge0d
      wcel cno c1 norm0 cxr 0le1 eqbrtri nmfnlb mp3an23 wa wi abscld nmfnxr 0xr
      rexrd xrletr mp3an1 syl2anc mp2and ) BCADZEFAGZHGZIJZUQAKGZIJZEUSIJZUOUPU
      OFBPZUPCPLBCFAMNZOUOVBFQGZRIJUTLVDERISUAUBFAUCUDUOUQTPZUSTPZURUTUEVAUFZUO
      UQUOUPVCUGUJAUHETPVEVFVGUIEUQUSUKULUMUN $.

    $( Membership in the null space of a Hilbert space functional.
       (Contributed by NM, 11-Feb-2006.)  (Revised by Mario Carneiro,
       17-Nov-2013.)  (New usage is discouraged.) $)
    elnlfn $p |- ( T : ~H --> CC ->
                   ( A e. ( null ` T ) <-> ( A e. ~H /\ ( T ` A ) = 0 ) ) ) $=
      ( vx chil cc wf cnl cfv wcel wa cc0 wceq cdm ccnv csn nlfnval wb wi bitrd
      cima cnvimass syl6eqss fdm sseqtrd sseld pm4.71rd eleq2d adantr wfn eleq1
      ffn fveq2 eqeq1d bibi12d imbi2d wbr fnbrfvb 0cn vex eliniseg ax-mp expcom
      cv syl6rbbr vtoclga mpan9 pm5.32da ) DEBFZABGHZIZADIZVJJVKABHZKLZJVHVJVKV
      HVIDAVHVIBMZDVHVIBNKOZTZVNBPZBVOUAUBDEBUCUDUEUFVHVKVJVMVHVKJVJAVPIZVMVHVJ
      VRQVKVHVIVPAVQUGUHVHBDUIZVKVRVMQZDEBUKVSCVCZVPIZWABHZKLZQZRVSVTRCADWAALZW
      EVTVSWFWBVRWDVMWAAVPUJWFWCVLKWAABULUMUNUOVSWADIZWEVSWGJWDWAKBUPZWBDWAKBUQ
      KEIWBWHQURBKWAECUSUTVAVDVBVEVFSVGS $.

    $( Membership in the null space of a Hilbert space functional.
       (Contributed by NM, 11-Feb-2006.)  (Revised by Mario Carneiro,
       17-Nov-2013.)  (New usage is discouraged.) $)
    elnlfn2 $p |- ( ( T : ~H --> CC /\ A e. ( null ` T ) ) ->
                   ( T ` A ) = 0 ) $=
      ( chil cc wf cnl cfv wcel cc0 wceq elnlfn simplbda ) CDBEABFGHACHABGIJABK
      L $.

    $( Basic continuity property of a continuous functional.  (Contributed by
       NM, 11-Feb-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    cnfnc $p |- ( ( T e. ConFn /\ A e. ~H /\ B e. RR+ ) ->
                  E. x e. RR+ A. y e. ~H ( ( normh ` ( y -h A ) ) < x ->
                    ( abs ` ( ( T ` y ) - ( T ` A ) ) ) < B ) ) $=
      ( vz vw wcel chil crp cv cmv co cno cfv clt wbr cmin cabs wral ccnfn wrex
      wi wa cc elcnfn simprbi wceq oveq2 fveq2d breq1d fveq2 imbi12d rexralbidv
      wf oveq2d breq2 imbi2d rspc2v syl5com 3impib ) EUAHZCIHZDJHZBKZCLMZNOZAKZ
      PQZVEEOZCEOZRMZSOZDPQZUCZBITAJUBZVBVEFKZLMZNOZVHPQZVJVQEOZRMZSOZGKZPQZUCZ
      BITAJUBZGJTFITZVCVDUDVPVBIUEEUOWHFGABEUFUGWGVPVIVMWDPQZUCZBITAJUBFGCDIJVQ
      CUHZWFWJABJIWKVTVIWEWIWKVSVGVHPWKVRVFNVQCVELUIUJUKWKWCVMWDPWKWBVLSWKWAVKV
      JRVQCEULUPUJUKUMUNWDDUHZWJVOABJIWLWIVNVIWDDVMPUQURUNUSUTVA $.

    $( Basic linearity property of a linear functional.  (Contributed by NM,
       11-Feb-2006.)  (New usage is discouraged.) $)
    lnfnl $p |- ( ( ( T e. LinFn /\ A e. CC ) /\ ( B e. ~H /\ C e. ~H ) ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A x. ( T ` B ) ) + ( T ` C ) ) ) $=
      ( vx vy vz wcel cc chil csm co cva cfv cmul caddc wceq cv wral oveq1d clf
      wa wi w3a wf ellnfn simprbi oveq1 fveq2d eqeq12d oveq2 oveq2d rspc3v syl5
      fveq2 3expb impcom anassrs ) DUAHZAIHZBJHZCJHZUBZABKLZCMLZDNZABDNZOLZCDNZ
      PLZQZUTVCUBUSVKUTVAVBUSVKUCUSERZFRZKLZGRZMLZDNZVLVMDNZOLZVODNZPLZQZGJSFJS
      EISZUTVAVBUDVKUSJIDUEWCEFGDUFUGWBVKAVMKLZVOMLZDNZAVROLZVTPLZQVDVOMLZDNZVH
      VTPLZQEFGABCIJJVLAQZVQWFWAWHWLVPWEDWLVNWDVOMVLAVMKUHTUIWLVSWGVTPVLAVROUHT
      UJVMBQZWFWJWHWKWMWEWIDWMWDVDVOMVMBAKUKTUIWMWGVHVTPWMVRVGAOVMBDUOULTUJVOCQ
      ZWJVFWKVJWNWIVEDVOCVDMUKUIWNVTVIVHPVOCDUOULUJUMUNUPUQUR $.

    $( Closure of the adjoint of a Hilbert space operator.  (Contributed by NM,
       17-Jun-2006.)  (New usage is discouraged.) $)
    adjcl $p |- ( ( T e. dom adjh /\ A e. ~H ) ->
                 ( ( adjh ` T ) ` A ) e. ~H ) $=
      ( cado cdm wcel chil cfv wf dmadjrn dmadjop syl ffvelrnda ) BCDZEZFFABCGZ
      NOMEFFOHBIOJKL $.

    $( Property of an adjoint Hilbert space operator.  (Contributed by NM,
       15-Feb-2006.)  (New usage is discouraged.) $)
    adj1 $p |- ( ( T e. dom adjh /\ A e. ~H /\ B e. ~H ) ->
               ( A .ih ( T ` B ) ) = ( ( ( adjh ` T ) ` A ) .ih B ) ) $=
      ( vx vy vz vw cado wcel chil cfv csp co wceq cv wral wf w3a cvv feq1 wfun
      cdm wa cop copab funadj funfvop mpan dfadj2 syl6eleq wb fvex fveq1 oveq2d
      eqeq1d 2ralbidv 3anbi13d oveq1d eqeq2d opelopabg mpan2 mpbid simp3d oveq1
      3anbi23d fveq2 eqeq12d oveq2 rspc2v syl5com 3impib ) CHUBZIZAJIZBJIZABCKZ
      LMZACHKZKZBLMZNZVMDOZEOZCKZLMZWBVRKZWCLMZNZEJPDJPZVNVOUCWAVMJJCQZJJVRQZWI
      VMCVRUDZJJFOZQZJJGOZQZWBWCWMKZLMZWBWOKZWCLMZNZEJPDJPZRZFGUEZIZWJWKWIRZVMW
      LHXDHUAVMWLHIUFCHUGUHDEGFUIUJVMVRSIXEXFUKCHULXCWJWPWEWTNZEJPDJPZRXFFGCVRV
      LSWMCNZWNWJXBXHWPJJWMCTXIXAXGDEJJXIWRWEWTXIWQWDWBLWCWMCUMUNUOUPUQWOVRNZWP
      WKXHWIWJJJWOVRTXJXGWHDEJJXJWTWGWEXJWSWFWCLWBWOVRUMURUSUPVEUTVAVBVCWHWAAWD
      LMZVSWCLMZNDEABJJWBANZWEXKWGXLWBAWDLVDXMWFVSWCLWBAVRVFURVGWCBNZXKVQXLVTXN
      WDVPALWCBCVFUNWCBVSLVHVGVIVJVK $.

    $( Property of an adjoint Hilbert space operator.  (Contributed by NM,
       15-Feb-2006.)  (New usage is discouraged.) $)
    adj2 $p |- ( ( T e. dom adjh /\ A e. ~H /\ B e. ~H ) ->
                ( ( T ` A ) .ih B ) = ( A .ih ( ( adjh ` T ) ` B ) ) ) $=
      ( cado cdm wcel chil cfv csp co wceq w3a ccj adj1 dmadjop ax-his1 syl2anc
      simp2 cc hicl ffvelrnda 3adant2 adjcl 3adant3 simp3 3eqtr3d wb cj11 mpbid
      3com23 ) CDEFZBGFZAGFZACHZBIJZABCDHHZIJZKZUKULUMLZUOMHZUQMHZKZURUSBUNIJZU
      PAIJZUTVABACNUSULUNGFZVCUTKUKULUMRZUKUMVEULUKGGACCOUAUBZBUNPQUSUPGFZUMVDV
      AKUKULVHUMBCUCUDZUKULUMUEZUPAPQUFUSUOSFZUQSFZVBURUGUSVEULVKVGVFUNBTQUSUMV
      HVLVJVIAUPTQUOUQUHQUIUJ $.

    $( A property that determines the adjoint of a Hilbert space operator.
       (Contributed by NM, 20-Feb-2006.)  (New usage is discouraged.) $)
    adjeq $p |- ( ( T : ~H --> ~H /\ S : ~H --> ~H /\ A. x e. ~H A. y e. ~H
           ( ( T ` x ) .ih y ) = ( x .ih ( S ` y ) ) ) -> ( adjh ` T ) = S ) $=
      ( vz vw cado chil wf cv cfv csp co wceq wral w3a wcel cvv ax-hilex fex wa
      wfun cop funadj copab df-adjh eleq2i wb mpan2 feq1 oveq1d eqeq1d 2ralbidv
      fveq1 3anbi13d oveq2d eqeq2d 3anbi23d syl2an syl5bb df-3an baibr biimp3ar
      opelopabg bitr4d funopfv mpsyl ) GUBHHDIZHHCIZAJZDKZBJZLMZVJVLCKZLMZNZBHO
      AHOZPZDCUCZGQZDGKCNUDVHVIVTVQVHVIUAZVTVRVQVTVSHHEJZIZHHFJZIZVJWBKZVLLMZVJ
      VLWDKZLMZNZBHOAHOZPZEFUEZQZWAVRGWMVSABFEUFUGVHDRQZCRQZWNVRUHVIVHHRQZWOSHH
      RDTUIVIWQWPSHHRCTUIWLVHWEVMWINZBHOAHOZPVREFDCRRWBDNZWCVHWKWSWEHHWBDUJWTWJ
      WRABHHWTWGVMWIWTWFVKVLLVJWBDUNUKULUMUOWDCNZWEVIWSVQVHHHWDCUJXAWRVPABHHXAW
      IVOVMXAWHVNVJLVLWDCUNUPUQUMURVDUSUTVRWAVQVHVIVQVAVBVEVCDCGVFVG $.

    $( Double adjoint.  Theorem 3.11(iv) of [Beran] p. 106.  (Contributed by
       NM, 15-Feb-2006.)  (New usage is discouraged.) $)
    adjadj $p |- ( T e. dom adjh -> ( adjh ` ( adjh ` T ) ) = T ) $=
      ( vx vy cado cdm wcel cv cfv csp wceq chil wral adj2 dmadjrn adj1 syl3an1
      co w3a wf dmadjop eqtr2d 3expib ralrimivv wb 3syl hoeq1 syl2anc mpbid ) A
      DEZFZBGZADHZDHZHCGZIQZUKAHUNIQZJZCKLBKLZUMAJZUJUQBCKKUJUKKFZUNKFZUQUJUTVA
      RUPUKUNULHIQZUOUKUNAMUJULUIFZUTVAVBUOJANZUKUNULOPUAUBUCUJKKUMSZKKASURUSUD
      UJVCUMUIFVEVDULNUMTUEATBCUMAUFUGUH $.

    $( Value of the value of the adjoint function.  (Contributed by NM,
       22-Feb-2006.)  (Proof shortened by Mario Carneiro, 10-Sep-2015.)
       (New usage is discouraged.) $)
    adjvalval $p |- ( ( T e. dom adjh /\ A e. ~H ) -> ( ( adjh ` T ) ` A ) =
            ( iota_ w e. ~H A. x e. ~H ( ( T ` x ) .ih A ) = ( x .ih w ) ) ) $=
      ( cado cdm wcel chil wa cv cfv csp co wceq wral crio adjcl eqcom adantr
      wb adj2 3com23 3expa eqeq2d syl5bb ralbidva simpr hial2eq2 syl2anc riota5
      bitrd eqcomd ) DEFGZCHGZIZAJZDKCLMZUPBJZLMZNZAHOZBHPCDEKKZUOVABHVBCDQZUOU
      RHGZIZVAUSUPVBLMZNZAHOZURVBNZUOVAVHTVDUOUTVGAHUTUSUQNUOUPHGZIZVGUQUSRVKUQ
      VFUSUMUNVJUQVFNZUMVJUNVLUPCDUAUBUCUDUEUFSVEVDVBHGZVHVITUOVDUGUOVMVDVCSAUR
      VBUHUIUKUJUL $.

    $( The adjoint of a unitary operator is its inverse (converse).  Equation 2
       of [AkhiezerGlazman] p. 72.  (Contributed by NM, 23-Feb-2006.)
       (New usage is discouraged.) $)
    unopadj2 $p |- ( T e. UniOp -> ( adjh ` T ) = `' T ) $=
      ( vx vy cuo wcel chil wf ccnv cv cfv csp wceq wral cado clo unoplin lnopf
      co syl cnvunop 3syl unopadj 3expib ralrimivv adjeq syl3anc ) ADEZFFAGZFFA
      HZGZBIZAJCIZKRUKULUIJKRLZCFMBFMANJUILUGAOEUHAPAQSUGUIDEUIOEUJATUIPUIQUAUG
      UMBCFFUGUKFEULFEUMUKULAUBUCUDBCUIAUEUF $.

    $( A Hermitian operator is self-adjoint.  (Contributed by NM,
       24-Mar-2006.)  (New usage is discouraged.) $)
    hmopadj $p |- ( T e. HrmOp -> ( adjh ` T ) = T ) $=
      ( vx vy cho wcel chil wf cv cfv csp co wceq wral cado hmopf eqcomd 3expib
      w3a hmop ralrimivv adjeq syl3anc ) ADEZFFAGZUDBHZAICHZJKZUEUFAIJKZLZCFMBF
      MANIALAOZUJUCUIBCFFUCUEFEZUFFEZUIUCUKULRUHUGUEUFASPQTBCAAUAUB $.

    $( Every Hermitian operator has an adjoint.  (Contributed by NM,
       24-Mar-2006.)  (New usage is discouraged.) $)
    hmdmadj $p |- ( T e. HrmOp -> T e. dom adjh ) $=
      ( cho wcel cado cfv c0 wceq cdm chil wf wn hon0 syl hmopadj eqeq1d mtbird
      hmopf ndmfv nsyl2 ) ABCZADEZFGZADHCTUBAFGZTIIAJUCKAQALMTUAAFANOPADRS $.

    $( An operator is Hermitian iff it is self-adjoint.  Definition of
       Hermitian in [Halmos] p. 41.  (Contributed by NM, 9-Apr-2006.)
       (New usage is discouraged.) $)
    hmopadj2 $p |- ( T e. dom adjh -> ( T e. HrmOp <-> ( adjh ` T ) = T ) ) $=
      ( vx vy cado cdm wcel cho cfv wceq hmopadj wa chil wf cv csp wral dmadjop
      co adantr adj1 3expb adantlr fveq1 oveq1d ad2antlr ralrimivva sylanbrc ex
      eqtrd elhmop impbid2 ) ADEFZAGFZADHZAIZAJULUOUMULUOKZLLAMZBNZCNZAHORZURAH
      ZUSORZIZCLPBLPUMULUQUOAQSUPVCBCLLUPURLFZUSLFZKZKUTURUNHZUSORZVBULVFUTVHIZ
      UOULVDVEVIURUSATUAUBUOVHVBIULVFUOVGVAUSOURUNAUCUDUEUIUFBCAUJUGUHUK $.

    $( A Hermitian operator is linear.  (Contributed by NM, 24-Mar-2006.)
       (New usage is discouraged.) $)
    hmoplin $p |- ( T e. HrmOp -> T e. LinOp ) $=
      ( vx vy vz vw wcel chil cv co cfv wceq wral cc csp cmul caddc adantr hmop
      wa w3a cho csm cva clo hmopf simplll hvmulcl hvaddcl sylan adantll eqcomd
      wf simpr syl3anc simprl ad2antrr simprr simplr ffvelrnda adantlr adantllr
      hiassdi syl22anc adantrl 3expa oveq2d adantlrl eqtr2d 3eqtrd ralrimiva wb
      oveq12d ffvelrn sylan2 anassrs an12s syl2anc hial2eq sylanl1 mpbid ellnop
      ralrimivva sylanbrc ) AUAFZGGAULZBHZCHZUBIZDHZUCIZAJZWFWGAJZUBIZWIAJZUCIZ
      KZDGLZCGLBMLAUDFAUEZWDWQBCMGWDWFMFZWGGFZSZSZWPDGXBWIGFZSZWKEHZNIZWOXENIZK
      ZEGLZWPXDXHEGXDXEGFZSZXFWJXEAJZNIZWFWGXLNIZOIZWIXLNIZPIZXGXKWDWJGFZXJXFXM
      KWDXAXCXJUFXDXRXJXAXCXRWDXAWHGFXCXRWFWGUGWHWIUHUIZUJQXDXJUMZWDXRXJTXMXFWJ
      XEARUKUNXKWSWTXCXLGFZXMXQKXBWSXCXJWDWSWTUOUPZXBWTXCXJWDWSWTUQUPXBXCXJURWD
      XCXJYAXAWDXJYAXCWDGGXEAWRUSUTVAWFWGWIXLVBVCXKXGWFWLXENIZOIZWNXENIZPIZXQXK
      WSWLGFZWNGFZXJXGYFKYBXBYGXCXJWDWTYGWSWDGGWGAWRUSVDUPWDXCXJYHXAWDXCSYHXJWD
      GGWIAWRUSQVAXTWFWLWNXEVBVCXKYDXOYEXPPXBXJYDXOKZXCWDWTXJYIWSWDWTSXJSYCXNWF
      OWDWTXJYCXNKWDWTXJTXNYCWGXEARUKVEVFVGUTWDXCXJYEXPKZXAWDXCXJYJWDXCXJTXPYEW
      IXEARUKVEVAVLVHVIVJWDWEXAXCXIWPVKZWRWEXASZXCSZWKGFZWOGFZYKWEXAXCYNXAXCSWE
      XRYNXSGGWJAVMVNVOYMWMGFZYHYOYLYPXCWSWEWTYPWEWTSWSYGYPGGWGAVMWFWLUGVNVPQWE
      XCYHXAGGWIAVMUTWMWNUHVQEWKWOVRVQVSVTVJWBBCDAWAWC $.

    $( The bra of a vector, expressed as ` <. A | ` in Dirac notation.  See
       ~ df-bra .  (Contributed by NM, 15-May-2006.)  (Revised by Mario
       Carneiro, 23-Aug-2014.)  (New usage is discouraged.) $)
    brafval $p |- ( A e. ~H ->
            ( bra ` A ) = ( x e. ~H |-> ( x .ih A ) ) ) $=
      ( vy chil cv csp cmpt cbr wceq oveq2 mpteq2dv df-bra ax-hilex mptex fvmpt
      co ) CBADAEZCEZFPZGADQBFPZGDHRBIADSTRBQFJKCALADTMNO $.

    $( A bra-ket juxtaposition, expressed as ` <. A | B >. ` in Dirac notation,
       equals the inner product of the vectors.  Based on definition of bra in
       [Prugovecki] p. 186.  (Contributed by NM, 15-May-2006.)  (Revised by
       Mario Carneiro, 17-Nov-2013.)  (New usage is discouraged.) $)
    braval $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( bra ` A ) ` B ) = ( B .ih A ) ) $=
      ( vx chil wcel cbr cfv cv co cmpt brafval fveq1d oveq1 eqid ovex sylan9eq
      csp fvmpt ) ADEZBDEBAFGZGBCDCHZAQIZJZGBAQIZSBTUCCAKLCBUBUDDUCUABAQMUCNBAQ
      ORP $.

    $( Linearity property of bra for addition.  (Contributed by NM,
       23-May-2006.)  (New usage is discouraged.) $)
    braadd $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) -> ( ( bra ` A ) `
              ( B +h C ) ) = ( ( ( bra ` A ) ` B ) + ( ( bra ` A ) ` C ) ) ) $=
      ( chil wcel w3a cva co csp caddc cbr wceq ax-his2 3comr wa hvaddcl braval
      cfv sylan2 3impb 3adant3 3adant2 oveq12d 3eqtr4d ) ADEZBDEZCDEZFZBCGHZAIH
      ZBAIHZCAIHZJHZUIAKRZRZBUNRZCUNRZJHUFUGUEUJUMLBCAMNUEUFUGUOUJLZUFUGOUEUIDE
      URBCPAUIQSTUHUPUKUQULJUEUFUPUKLUGABQUAUEUGUQULLUFACQUBUCUD $.

    $( Linearity property of bra for multiplication.  (Contributed by NM,
       23-May-2006.)  (New usage is discouraged.) $)
    bramul $p |- ( ( A e. ~H /\ B e. CC /\ C e. ~H ) -> ( ( bra ` A ) `
              ( B .h C ) ) = ( B x. ( ( bra ` A ) ` C ) ) ) $=
      ( chil wcel cc w3a csm csp cmul cbr cfv wceq ax-his3 3comr hvmulcl braval
      co wa sylan2 3impb 3adant2 oveq2d 3eqtr4d ) ADEZBFEZCDEZGZBCHRZAIRZBCAIRZ
      JRZUIAKLZLZBCUMLZJRUFUGUEUJULMBCANOUEUFUGUNUJMZUFUGSUEUIDEUPBCPAUIQTUAUHU
      OUKBJUEUGUOUKMUFACQUBUCUD $.

    $( The bra function is a functional.  (Contributed by NM, 23-May-2006.)
       (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    brafn $p |- ( A e. ~H -> ( bra ` A ) : ~H --> CC ) $=
      ( vx chil wcel cc cbr cfv wf cv csp co cmpt hicl eqid fmptd brafval feq1d
      ancoms mpbird ) ACDZCEAFGZHCEBCBIZAJKZLZHTBCUCEUDUBCDTUCEDUBAMRUDNOTCEUAU
      DBAPQS $.

    $( The Dirac bra function is a linear functional.  (Contributed by NM,
       23-May-2006.)  (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    bralnfn $p |- ( A e. ~H -> ( bra ` A ) e. LinFn ) $=
      ( vx vy vz chil wcel cc cbr cfv wf cv csm co cva cmul caddc wceq wral clf
      wa brafn simpll hvmulcl simprr braadd syl3anc bramul 3expa adantrr oveq1d
      ad2ant2lr eqtrd ralrimivva ralrimiva ellnfn sylanbrc ) AEFZEGAHIZJBKZCKZL
      MZDKZNMURIZUSUTURIOMZVBURIZPMZQZDERCERZBGRURSFAUAUQVHBGUQUSGFZTZVGCDEEVJU
      TEFZVBEFZTZTZVCVAURIZVEPMZVFVNUQVAEFZVLVCVPQUQVIVMUBVIVKVQUQVLUSUTUCUKVJV
      KVLUDAVAVBUEUFVNVOVDVEPVJVKVOVDQZVLUQVIVKVRAUSUTUGUHUIUJULUMUNBCDURUOUP
      $.

    $( Closure of the bra function.  (Contributed by NM, 23-May-2006.)
       (New usage is discouraged.) $)
    bracl $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( bra ` A ) ` B ) e. CC ) $=
      ( chil wcel cc cbr cfv brafn ffvelrnda ) ACDCEBAFGAHI $.

    $( The Dirac bra of the zero vector.  (Contributed by NM, 25-May-2006.)
       (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    bra0 $p |- ( bra ` 0h ) = ( ~H X. { 0 } ) $=
      ( vx c0v cbr cfv chil cc0 cmpt csn cxp wcel wceq ax-hv0cl cv brafval hi02
      csp co mpteq2ia syl6eq ax-mp fconstmpt eqtr4i ) BCDZAEFGZEFHIBEJZUCUDKLUE
      UCAEAMZBPQZGUDABNAEUGFUFORSTAEFUAUB $.

    $( Anti-linearity property of bra functional for multiplication.
       (Contributed by NM, 31-May-2006.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    brafnmul $p |- ( ( A e. CC /\ B e. ~H ) ->
                    ( bra ` ( A .h B ) ) = ( ( * ` A ) .fn ( bra ` B ) ) ) $=
      ( vx cc wcel chil wa csm co cbr cfv csp cmpt ccj chft wceq hvmulcl eqtr4d
      cv cmul brafval syl wf cjcl brafn hfmmval syl2an his5 3expa an32s adantll
      braval oveq2d mpteq2dva ) ADEZBFEZGZABHIZJKZCFCSZURLIZMZANKZBJKZOIZUQURFE
      USVBPABQCURUAUBUQVECFVCUTVDKZTIZMZVBUOVCDEFDVDUCVEVHPUPAUDBUECVCVDUFUGUQC
      FVAVGUQUTFEZGZVAVCUTBLIZTIZVGUOVIUPVAVLPZUOVIUPVMAUTBUHUIUJVJVFVKVCTUPVIV
      FVKPUOBUTULUKUMRUNRR $.

    $( The outer product of two vectors, expressed as ` | A >. ` ` <. B | ` in
       Dirac notation.  See ~ df-kb .  (Contributed by NM, 15-May-2006.)
       (Revised by Mario Carneiro, 23-Aug-2014.)
       (New usage is discouraged.) $)
    kbfval $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A ketbra B ) =
                ( x e. ~H |-> ( ( x .ih B ) .h A ) ) ) $=
      ( vy vz chil cv csp co csm cmpt wceq oveq2 mpteq2dv oveq1d df-kb ax-hilex
      ck mptex ovmpt2 ) DEBCFFAFAGZEGZHIZDGZJIZKAFUACHIZBJIZKRAFUCBJIZKUDBLAFUE
      UHUDBUCJMNUBCLZAFUHUGUIUCUFBJUBCUAHMONDEAPAFUGQST $.

    $( The outer product of two vectors, expressed as ` | A >. ` ` <. B | ` in
       Dirac notation, is an operator.  (Contributed by NM, 30-May-2006.)
       (Revised by Mario Carneiro, 16-Nov-2013.)
       (New usage is discouraged.) $)
    kbop $p |- ( ( A e. ~H /\ B e. ~H ) -> ( A ketbra B ) : ~H --> ~H ) $=
      ( vx chil wcel wa ck co wf cv csp csm cmpt hicl hvmulcl sylan an31s fmptd
      cc eqid kbfval feq1d mpbird ) ADEZBDEZFZDDABGHZIDDCDCJZBKHZALHZMZIUFCDUJD
      UKUHDEZUEUDUJDEZULUEFUISEUDUMUHBNUIAOPQUKTRUFDDUGUKCABUAUBUC $.

    $( The value of the operator resulting from the outer product ` | A >. `
       ` <. B | ` of two vectors.  Equation 8.1 of [Prugovecki] p. 376.
       (Contributed by NM, 15-May-2006.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    kbval $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                 ( ( A ketbra B ) ` C ) = ( ( C .ih B ) .h A ) ) $=
      ( vx chil wcel ck co cfv csp csm wceq wa cv cmpt kbfval fveq1d oveq1 eqid
      oveq1d ovex fvmpt sylan9eq 3impa ) AEFZBEFZCEFZCABGHZIZCBJHZAKHZLUEUFMZUG
      UICDEDNZBJHZAKHZOZIUKULCUHUPDABPQDCUOUKEUPUMCLUNUJAKUMCBJRTUPSUJAKUAUBUCU
      D $.

    $( Multiplication property of outer product.  (Contributed by NM,
       31-May-2006.)  (New usage is discouraged.) $)
    kbmul $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
                ( ( A .h B ) ketbra C ) = ( B ketbra ( ( * ` A ) .h C ) ) ) $=
      ( vx cc wcel chil w3a csm co ck csp cmpt wceq hvmulcl kbfval syl2anc cmul
      syl3anc eqtr4d cv ccj cfv 3adant3 simp3 simp2 cjcl 3ad2ant1 wa simpr hicl
      simpl3 simpl1 simpl2 ax-hvmulass mulcomd his52 oveq1d eqtr3d mpteq2dva )
      AEFZBGFZCGFZHZABIJZCKJZDGDUAZCLJZVEIJZMZBAUBUCZCIJZKJZVDVEGFZVCVFVJNVAVBV
      NVCABOUDVAVBVCUEZDVECPQVDVMDGVGVLLJZBIJZMZVJVDVBVLGFZVMVRNVAVBVCUFVDVKEFZ
      VCVSVAVBVTVCAUGUHVOVKCOQDBVLPQVDDGVIVQVDVGGFZUIZVHARJZBIJZVIVQWBVHEFZVAVB
      WDVINWBWAVCWEVDWAUJZVAVBVCWAULZVGCUKQZVAVBVCWAUMZVAVBVCWAUNVHABUOSWBWCVPB
      IWBWCAVHRJZVPWBVHAWHWIUPWBVAWAVCVPWJNWIWFWGAVGCUQSTURUSUTTT $.

    $( If a vector ` A ` has norm 1, the outer product ` | A >. ` ` <. A | ` is
       the projector onto the subspace spanned by ` A ` .
       ~ http://en.wikipedia.org/wiki/Bra-ket#Linear%5Foperators .
       (Contributed by NM, 30-May-2006.)  (New usage is discouraged.) $)
    kbpj $p |- ( ( A e. ~H /\ ( normh ` A ) = 1 ) -> ( A ketbra A ) =
                ( projh ` ( span ` { A } ) ) ) $=
      ( vx chil wcel cno cfv c1 wceq wa ck cexp cdiv csm wne cc0 adantr wfn syl
      co c2 csn cspn cpjh cv wral csp oveq1 sq1 syl6eq oveq2d hicl ancoms div1d
      sylan9eqr an32s oveq1d c0v simpll simpr ax-1ne0 mpbiri normne0 syl5ib imp
      cc neeq1 pjspansn syl3anc kbval 3anidm12 adantlr 3eqtr4rd ralrimiva wb wf
      kbop anidms ffn cch spansnch pjfn eqfnfv syl2anc mpbird ) ACDZAEFZGHZIZAA
      JSZAUAUBFZUCFZHZBUDZWIFZWMWKFZHZBCUEZWHWPBCWHWMCDZIZWMAUFSZWFTKSZLSZAMSZW
      TAMSZWOWNWSXBWTAMWEWRWGXBWTHWGWEWRIZXBWTGLSWTWGXAGWTLWGXAGTKSGWFGTKUGUHUI
      UJXEWTWRWEWTVEDWMAUKULUMUNUOUPWSWEWRAUQNZWOXCHWEWGWRURWHWRUSWHXFWRWEWGXFW
      GWFONZWEXFWGXGGONUTWFGOVFVAAVBVCVDPAWMVGVHWEWRWNXDHZWGWEWRXHAAWMVIVJVKVLV
      MWEWLWQVNZWGWEWICQZWKCQZXIWECCWIVOZXJWEXLAAVPVQCCWIVRRWEWJVSDXKAVTWJWARBC
      WIWKWBWCPWD $.

    $( Membership in the set of eigenvectors of a Hilbert space operator.
       (Contributed by NM, 11-Mar-2006.)  (Revised by Mario Carneiro,
       16-Nov-2013.)  (New usage is discouraged.) $)
    eleigvec $p |- ( T : ~H --> ~H -> ( A e. ( eigvec ` T ) <->
            ( A e. ~H /\ A =/= 0h /\ E. x e. CC ( T ` A ) = ( x .h A ) ) ) ) $=
      ( vy chil wf cei cfv wcel cv csm co wceq cc wrex c0h cdif crab c0v wa wne
      w3a eigvecval eleq2d wn eldif elch0 necon3bbii anbi2i bitri fveq2 eqeq12d
      anbi1i oveq2 rexbidv elrab df-3an 3bitr4i syl6bb ) EECFZBCGHZIBDJZCHZAJZV
      BKLZMZANOZDEPQZRZIZBEIZBSUAZBCHZVDBKLZMZANOZUBZUTVAVIBDACUCUDBVHIZVPTVKVL
      TZVPTVJVQVRVSVPVRVKBPIZUEZTVSBEPUFWAVLVKVTBSBUGUHUIUJUMVGVPDBVHVBBMZVFVOA
      NWBVCVMVEVNVBBCUKVBBVDKUNULUOUPVKVLVPUQURUS $.

    $( Membership in the set of eigenvectors of a Hilbert space operator.
       (Contributed by NM, 18-Mar-2006.)  (New usage is discouraged.) $)
    eleigvec2 $p |- ( T : ~H --> ~H -> ( A e. ( eigvec ` T ) <->
            ( A e. ~H /\ A =/= 0h /\ ( T ` A ) e. ( span ` { A } ) ) ) ) $=
      ( vx chil wf cei cfv wcel c0v wne cv csm co wceq cc wrex w3a csn df-3an
      wa cspn eleigvec wb elspansn adantr pm5.32i 3bitr4i syl6bbr ) DDBEABFGHAD
      HZAIJZABGZCKALMNCOPZQZUIUJUKARUAGHZQZCABUBUIUJTZUNTUPULTUOUMUPUNULUIUNULU
      CUJCAUKUDUEUFUIUJUNSUIUJULSUGUH $.

    $( Closure of an eigenvector of a Hilbert space operator.  (Contributed by
       NM, 23-Mar-2006.)  (New usage is discouraged.) $)
    eleigveccl $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) ) ->
                      A e. ~H ) $=
      ( chil wf cei cfv wcel wa c0v wne csn cspn w3a eleigvec2 biimpa simp1d )
      CCBDZABEFGZHACGZAIJZABFAKLFGZQRSTUAMABNOP $.

    $( The eigenvalue of an eigenvector of a Hilbert space operator.
       (Contributed by NM, 11-Mar-2006.)  (New usage is discouraged.) $)
    eigvalval $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) ) ->
  ( ( eigval ` T ) ` A ) = ( ( ( T ` A ) .ih A ) / ( ( normh ` A ) ^ 2 ) ) ) $=
      ( vx chil wf cei cfv wcel cel cv csp co cno c2 cexp cdiv eigvalfval fveq2
      cmpt oveq12d fveq1d wceq id oveq1d eqid ovex fvmpt sylan9eq ) DDBEZABFGZH
      ABIGZGACUJCJZBGZULKLZULMGZNOLZPLZSZGABGZAKLZAMGZNOLZPLZUIAUKURCBQUACAUQVC
      UJURULAUBZUNUTUPVBPVDUMUSULAKULABRVDUCTVDUOVANOULAMRUDTURUEUTVBPUFUGUH $.

    $( An eigenvalue is a complex number.  (Contributed by NM, 11-Mar-2006.)
       (New usage is discouraged.) $)
    eigvalcl $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) )
     -> ( ( eigval ` T ) ` A ) e. CC ) $=
      ( vx chil wf cei cfv wcel wa cel csp co cno c2 cexp cc syl wne cc0 biimpa
      cdiv eigvalval eleigveccl ffvelrn hicl sylancom syldan normcl recnd sqcld
      c0v cv csm wceq wrex w3a eleigvec wb sqne0 normne0 bitr2d 3adant3 eqeltrd
      divcld ) DDBEZABFGHZIZABJGGABGZAKLZAMGZNOLZUALPABUBVGVIVKVEVFADHZVIPHZABU
      CZVEVLVHDHVMDDABUDVHAUEUFUGVGVJVGVLVJPHZVNVLVJAUHUIZQUJVGVLAUKRZVHCULAUML
      UNCPUOZUPZVKSRZVEVFVSCABUQTVLVQVTVRVLVQVTVLVTVJSRZVQVLVOVTWAURVPVJUSQAUTV
      ATVBQVDVC $.

    $( Property of an eigenvector.  (Contributed by NM, 12-Mar-2006.)
       (New usage is discouraged.) $)
    eigvec1 $p |- ( ( T : ~H --> ~H /\ A e. ( eigvec ` T ) ) ->
            ( ( T ` A ) = ( ( ( eigval ` T ) ` A ) .h A ) /\ A =/= 0h ) ) $=
      ( chil wf cei cfv wcel wa cel csm co wceq c0v wne csp cexp cdiv eigvalval
      cno c2 oveq1d csn cspn w3a eleigvec2 biimpa normcan syl eqtr2d simp2d jca
      ) CCBDZABEFGZHZABFZABIFFZAJKZLAMNZUNUQUOAOKASFTPKQKZAJKZUOUNUPUSAJABRUAUN
      ACGZURUOAUBUCFGZUDZUTUOLULUMVCABUEUFZUOAUGUHUIUNVAURVBVDUJUK $.

    $( The eigenvalues of a Hermitian operator are real.  Equation 1.30 of
       [Hughes] p. 49.  (Contributed by NM, 19-Mar-2006.)
       (New usage is discouraged.) $)
    eighmre $p |- ( ( T e. HrmOp /\ A e. ( eigvec ` T ) ) ->
                    ( ( eigval ` T ) ` A ) e. RR ) $=
      ( cho wcel cei cfv wa chil cel cc csm co wceq c0v wne csp cr wf jca sylan
      hmopf eleigveccl eigvalcl eigvec1 hmop 3expb syldan eigre biimpa syl2anc
      ) BCDZABEFDZGAHDZABIFFZJDZGZABFZUNAKLMANOGZGZAUQPLUQAPLMZUNQDZUKHHBRZULUS
      BUAZVBULGZUPURVDUMUOABUBZABUCSABUDSTUKULUMUMGZUTUKVBULVFVCVDUMUMVEVESTUKU
      MUMUTAABUEUFUGUSUTVAAUNBUHUIUJ $.

    $( Eigenvectors of a Hermitian operator with distinct eigenvalues are
       orthogonal.  Equation 1.31 of [Hughes] p. 49.  (Contributed by NM,
       23-Mar-2006.)  (New usage is discouraged.) $)
    eighmorth $p |- ( ( ( T e. HrmOp /\ A e. ( eigvec ` T ) ) /\
                     ( B e. ( eigvec ` T ) /\
                  ( ( eigval ` T ) ` A ) =/= ( ( eigval ` T ) ` B ) ) ) ->
                     ( A .ih B ) = 0 ) $=
      ( wcel cfv wa wne chil cc csm co wceq csp eleigveccl sylan adantr adantlr
      jca eighmre adantrr cho cei cel ccj cc0 wf hmopf recnd c0v eigvec1 simpld
      cjred neeq2d biimpar anasss simpll hmop syl3anc eigorth biimpa syl21anc )
      CUADZACUBEZDZFZBVCDZACUCEZEZBVGEZGZFZFZAHDZBHDZFZVHIDZVIIDZFZFZACEZVHAJKL
      ZBCEZVIBJKLZFZVHVIUDEZGZFZAWBMKVTBMKLZABMKUELZVEVFVSVJVEVFFZVOVRWJVMVNVEV
      MVFVBHHCUFZVDVMCUGZACNOPZVBVFVNVDVBWKVFVNWLBCNOQZRWJVPVQVEVPVFVEVHACSUHPV
      BVFVQVDVBVFFZVIBCSZUHQRRTVLWDWFVEVFWDVJWJWAWCVEWAVFVBWKVDWAWLWKVDFWAAUIGA
      CUJUKOPVBVFWCVDVBWKVFWCWLWKVFFWCBUIGBCUJUKOQRTVBVKWFVDVBVFVJWFWOWFVJWOWEV
      IVHWOVIWPULUMUNUOQRVEVFWHVJWJVBVMVNWHVBVDVFUPWMWNABCUQURTVSWGFWHWIABVHVIC
      USUTVA $.
  $}

  ${
    $d x y T $.
    nmopneg.1 $e |- T : ~H --> ~H $.
    $( Value of the norm of the negative of a Hilbert space operator.  Unlike
       ~ nmophmi , the operator does not have to be bounded.  (Contributed by
       NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    nmopnegi $p |- ( normop ` ( -u 1 .op T ) ) = ( normop ` T ) $=
      ( vy vx cv cno cfv c1 co wceq wa chil wrex cab cxr clt csup cnop wcel wf
      cle wbr cneg chot csm neg1cn homval mp3an12 fveq2d ffvelrni normneg eqtrd
      cc syl eqeq2d anbi2d rexbiia abbii supeq1i homulcl mp2an nmopval 3eqtr4i
      ax-mp ) CEZFGHUAUBZDEZVEHUCZAUDIZGZFGZJZKZCLMZDNZOPQZVFVGVEAGZFGZJZKZCLMZ
      DNZOPQZVIRGZARGZOVOWBPVNWADVMVTCLVELSZVLVSVFWFVKVRVGWFVKVHVQUEIZFGZVRWFVJ
      WGFVHUMSZLLATZWFVJWGJUFBVHVEAUGUHUIWFVQLSWHVRJLLVEABUJVQUKUNULUOUPUQURUSL
      LVITZWDVPJWIWJWKUFBVHAUTVADCVIVBVDWJWEWCJBDCAVBVDVC $.
  $}

  $( The value of a linear Hilbert space operator at zero is zero.  Remark in
     [Beran] p. 99.  (Contributed by NM, 13-Aug-2006.)
     (New usage is discouraged.) $)
  lnop0 $p |- ( T e. LinOp -> ( T ` 0h ) = 0h ) $=
    ( clo wcel c0v cfv cmv co cva c1 csm chil wceq ax-hv0cl hvmulcli ax-hvmulid
    ax-1cn ax-mp mpan2 syl oveq1d ax-hvaddid eqtri fveq2i cc wa mpanr12 syl5eqr
    lnopl wf lnopf ffvelrn eqtrd hvsubid hvpncan anidms 3eqtr3rd ) ABCZDAEZURFG
    ZURURHGZURFGZDURUQURUTURFUQURIURJGZURHGZUTUQURIDJGZDHGZAEZVCVEDAVEVDDVDKCVE
    VDLIDPMNVDUAQDKCZVDDLMDOQUBUCUQIUDCZVFVCLZPUQVHUEVGVGVIMMIDDAUHUFRUGUQVBURU
    RHUQURKCZVBURLUQKKAUIZVJAUJVKVGVJMKKDAUKRSZUROSTULTUQVJUSDLVLURUMSUQVJVAURL
    ZVLVJVMURURUNUOSUP $.

  $( Multiplicative property of a linear Hilbert space operator.  (Contributed
     by NM, 13-Aug-2006.)  (New usage is discouraged.) $)
  lnopmul $p |- ( ( T e. LinOp /\ A e. CC /\ B e. ~H ) ->
       ( T ` ( A .h B ) ) = ( A .h ( T ` B ) ) ) $=
    ( clo wcel cc chil w3a csm co c0v cva cfv wceq wa ax-hv0cl lnopl ax-hvaddid
    hvmulcl syl mpanr2 3impa 3adant1 fveq2d lnop0 oveq2d lnopf ffvelrnda sylan2
    3ad2ant1 3impb 3com12 eqtrd 3eqtr3d ) CDEZAFEZBGEZHZABIJZKLJZCMZABCMZIJZKCM
    ZLJZUSCMVCUOUPUQVAVENZUOUPOUQKGEVFPABKCQUAUBURUTUSCUPUQUTUSNZUOUPUQOUSGEVGA
    BSUSRTUCUDURVEVCKLJZVCUOUPVEVHNUQUOVDKVCLCUEUFUJURVCGEZVHVCNUPUOUQVIUPUOUQV
    IUOUQOUPVBGEVIUOGGBCCUGUHAVBSUIUKULVCRTUMUN $.

  ${
    lnopl.1 $e |- T e. LinOp $.
    $( Basic scalar product property of a linear Hilbert space operator.
       (Contributed by NM, 23-Jan-2006.)  (New usage is discouraged.) $)
    lnopli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A .h ( T ` B ) ) +h ( T ` C ) ) ) $=
      ( cc wcel chil csm co cva cfv wceq clo wa lnopl mpanl1 3impb ) AFGZBHGZCH
      GZABIJCKJDLABDLIJCDLKJMZDNGSTUAOUBEABCDPQR $.

    $( A linear Hilbert space operator is a Hilbert space operator.
       (Contributed by NM, 23-Jan-2006.)  (New usage is discouraged.) $)
    lnopfi $p |- T : ~H --> ~H $=
      ( clo wcel chil wf lnopf ax-mp ) ACDEEAFBAGH $.

    $( The value of a linear Hilbert space operator at zero is zero.  Remark in
       [Beran] p. 99.  (Contributed by NM, 11-May-2005.)
       (New usage is discouraged.) $)
    lnop0i $p |- ( T ` 0h ) = 0h $=
      ( clo wcel c0v cfv wceq lnop0 ax-mp ) ACDEAFEGBAHI $.

    $( Additive property of a linear Hilbert space operator.  (Contributed by
       NM, 11-May-2005.)  (New usage is discouraged.) $)
    lnopaddi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A +h B ) ) = ( ( T ` A ) +h ( T ` B ) ) ) $=
      ( chil wcel wa c1 csm cva cfv wceq ax-1cn lnopli mp3an1 ax-hvmulid oveq1d
      co cc adantr fveq2d lnopfi ffvelrni syl 3eqtr3d ) AEFZBEFZGZHAIRZBJRZCKZH
      ACKZIRZBCKZJRZABJRZCKZULUNJRHSFUFUGUKUOLMHABCDNOUFUKUQLUGUFUJUPCUFUIABJAP
      QUATUHUMULUNJUFUMULLZUGUFULEFUREEACCDUBUCULPUDTQUE $.

    $( Multiplicative property of a linear Hilbert space operator.
       (Contributed by NM, 11-May-2005.)  (New usage is discouraged.) $)
    lnopmuli $p |- ( ( A e. CC /\ B e. ~H ) ->
         ( T ` ( A .h B ) ) = ( A .h ( T ` B ) ) ) $=
      ( clo wcel cc chil csm co cfv wceq lnopmul mp3an1 ) CEFAGFBHFABIJCKABCKIJ
      LDABCMN $.

    $( Sum/product property of a linear Hilbert space operator.  (Contributed
       by NM, 1-Jul-2005.)  (New usage is discouraged.) $)
    lnopaddmuli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( B +h ( A .h C ) ) ) = ( ( T ` B ) +h ( A .h ( T ` C ) ) ) ) $=
      ( cc wcel chil w3a csm co cva cfv wa hvmulcl lnopaddi sylan2 3impb 3com12
      wceq lnopmuli 3adant2 oveq2d eqtrd ) AFGZBHGZCHGZIZBACJKZLKDMZBDMZUIDMZLK
      ZUKACDMJKZLKUFUEUGUJUMTZUFUEUGUOUEUGNUFUIHGUOACOBUIDEPQRSUHULUNUKLUEUGULU
      NTUFACDEUAUBUCUD $.

    $( Subtraction property for a linear Hilbert space operator.  (Contributed
       by NM, 1-Jul-2005.)  (New usage is discouraged.) $)
    lnopsubi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A -h B ) ) = ( ( T ` A ) -h ( T ` B ) ) ) $=
      ( chil wcel wa c1 cneg csm co cva cfv cc wceq neg1cn lnopaddmuli hvsubval
      cmv ffvelrni mp3an1 fveq2d lnopfi syl2an 3eqtr4d ) AEFZBEFZGZAHIZBJKLKZCM
      ZACMZUIBCMZJKLKZABSKZCMULUMSKZUINFUFUGUKUNOPUIABCDQUAUHUOUJCABRUBUFULEFUM
      EFUPUNOUGEEACCDUCZTEEBCUQTULUMRUDUE $.

    $( Subtraction/product property of a linear Hilbert space operator.
       (Contributed by NM, 2-Jul-2005.)  (New usage is discouraged.) $)
    lnopsubmuli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( B -h ( A .h C ) ) ) = ( ( T ` B ) -h ( A .h ( T ` C ) ) ) ) $=
      ( cc wcel chil w3a csm co cmv cfv wa hvmulcl lnopsubi sylan2 3impb 3com12
      wceq lnopmuli oveq2d 3adant2 eqtrd ) AFGZBHGZCHGZIBACJKZLKDMZBDMZUHDMZLKZ
      UJACDMJKZLKZUFUEUGUIULTZUFUEUGUOUEUGNZUFUHHGUOACOBUHDEPQRSUEUGULUNTUFUPUK
      UMUJLACDEUAUBUCUD $.

    $( Product/subtraction property of a linear Hilbert space operator.
       (Contributed by NM, 2-Jul-2005.)  (New usage is discouraged.) $)
    lnopmulsubi $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( ( A .h B ) -h C ) ) = ( ( A .h ( T ` B ) ) -h ( T ` C ) ) ) $=
      ( cc wcel chil w3a csm co cmv cfv wceq wa hvmulcl lnopsubi sylan lnopmuli
      3impa 3adant3 oveq1d eqtrd ) AFGZBHGZCHGZIZABJKZCLKDMZUHDMZCDMZLKZABDMJKZ
      UKLKUDUEUFUIULNZUDUEOUHHGUFUNABPUHCDEQRTUGUJUMUKLUDUEUJUMNUFABDESUAUBUC
      $.
  $}

  ${
    $d x A $.  $d x T $.  $d x U $.
    $( Move a scalar product out of a composition of operators.  The operator
       ` T ` must be linear, unlike ~ homco1 that works for any operators.
       (Contributed by NM, 13-Aug-2006.)  (New usage is discouraged.) $)
    homco2 $p |- ( ( A e. CC /\ T e. LinOp /\ U : ~H --> ~H ) ->
                  ( T o. ( A .op U ) ) = ( A .op ( T o. U ) ) ) $=
      ( vx wcel chil wf chot co ccom cfv wceq csm syl3anc homulcl fvco3 syl2anc
      homval fco 3eqtr4d cc clo w3a cv wral wa simpl1 simpl3 simpr fveq2d sylan
      3adant2 oveq2d lnopf 3ad2ant2 simp3 adantr ffvelrnda lnopmul ralrimiva wb
      simpl2 simp1 hoeq mpbid ) AUAEZBUBEZFFCGZUCZDUDZBACHIZJZKZVJABCJZHIZKZLZD
      FUEZVLVOLZVIVQDFVIVJFEZUFZVJVKKZBKZAVJCKZMIZBKZVMVPWAWBWEBWAVFVHVTWBWELVF
      VGVHVTUGZVFVGVHVTUHZVIVTUIZAVJCRNUJVIFFVKGZVTVMWCLVFVHWJVGACOULZFFVJBVKPU
      KWAAVJVNKZMIZAWDBKZMIZVPWFWAWLWNAMWAVHVTWLWNLWHWIFFVJBCPQUMWAVFFFVNGZVTVP
      WMLWGVIWPVTVIFFBGZVHWPVGVFWQVHBUNUOZVFVGVHUPZFFFBCSQZUQWIAVJVNRNWAVGVFWDF
      EWFWOLVFVGVHVTVBWGVIFFVJCWSURAWDBUSNTTUTVIFFVLGZFFVOGZVRVSVAVIWQWJXAWRWKF
      FFBVKSQVIVFWPXBVFVGVHVCWTAVNOQDVLVOVDQVE $.
  $}

  ${
    $d x y z w $.
    $( The identity function (restricted to Hilbert space) is a unitary
       operator.  (Contributed by NM, 21-Jan-2006.)
       (New usage is discouraged.) $)
    idunop $p |- ( _I |` ~H ) e. UniOp $=
      ( vx vy cid chil cres cuo wcel wfo cv cfv wceq wral wf1o f1oi f1ofo ax-mp
      csp co fvresi oveqan12d rgen2a elunop mpbir2an ) CDEZFGDDUDHZAIZUDJZBIZUD
      JZQRUFUHQRKZBDLADLDDUDMUEDNDDUDOPUJABDUFDGUHDGUGUFUIUHQDUFSDUHSTUAABUDUBU
      C $.

    $( The identically zero function is a continuous Hilbert space operator.
       (Contributed by NM, 7-Feb-2006.)  (New usage is discouraged.) $)
    0cnop $p |- 0hop e. ConOp $=
      ( vw vx vz vy ch0o wcel chil cv cmv cno cfv clt wbr wral crp cc0 c0v wceq
      co c1 ccop wf wi wrex ho0f 1rp ho0val oveqan12rd adantlr ax-hv0cl hvsubid
      wa ax-mp syl6eq fveq2d norm0 rpgt0 ad2antlr eqbrtrd a1d ralrimiva ralbidv
      breq2 imbi1d rspcev sylancr rgen2 elcnop mpbir2an ) EUAFGGEUBAHZBHZISJKZC
      HZLMZVJEKZVKEKZISZJKZDHZLMZUCZAGNZCOUDZDONBGNUEWCBDGOVKGFZVSOFZULZTOFVLTL
      MZVTUCZAGNZWCUFWFWHAGWFVJGFZULZVTWGWKVRPVSLWKVRQJKPWKVQQJWKVQQQISZQWDWJVQ
      WLRWEWJWDVOQVPQIVJUGVKUGUHUIQGFWLQRUJQUKUMUNUOUPUNWEPVSLMWDWJVSUQURUSUTVA
      WBWICTOVMTRZWAWHAGWMVNWGVTVMTVLLVCVDVBVEVFVGBDCAEVHVI $.

    $( The identically zero function is a continuous Hilbert space functional.
       (Contributed by NM, 7-Feb-2006.)  (New usage is discouraged.) $)
    0cnfn $p |- ( ~H X. { 0 } ) e. ConFn $=
      ( vw vx vz vy chil cc0 wcel cc cv co cfv clt wbr cmin cabs wi wral crp c1
      0cn csn cxp ccnfn wf cmv cno wrex fconst6 wa 1rp wceq fvconst2 oveqan12rd
      c0ex adantlr subidi syl6eq fveq2d abs0 rpgt0 ad2antlr a1d ralrimiva breq2
      eqbrtrd imbi1d ralbidv rspcev sylancr rgen2 elcnfn mpbir2an ) EFUAUBZUCGE
      HVMUDAIZBIZUEJUFKZCIZLMZVNVMKZVOVMKZNJZOKZDIZLMZPZAEQZCRUGZDRQBEQEFHTUHWG
      BDERVOEGZWCRGZUIZSRGVPSLMZWDPZAEQZWGUJWJWLAEWJVNEGZUIZWDWKWOWBFWCLWOWBFOK
      FWOWAFOWOWAFFNJZFWHWNWAWPUKWIWNWHVSFVTFNEFVNUNULEFVOUNULUMUOFTUPUQURUSUQW
      IFWCLMWHWNWCUTVAVEVBVCWFWMCSRVQSUKZWEWLAEWQVRWKWDVQSVPLVDVFVGVHVIVJBDCAVM
      VKVL $.

    $( The identity function (restricted to Hilbert space) is a continuous
       operator.  (Contributed by NM, 7-Feb-2006.)
       (New usage is discouraged.) $)
    idcnop $p |- ( _I |` ~H ) e. ConOp $=
      ( vw vx vz vy cid chil cres ccop wcel cv cmv co cno cfv clt wbr wi fvresi
      wral crp wf wrex wf1o f1oi f1of ax-mp id oveqan12rd fveq2d breq1d biimprd
      ralrimiva weq breq2 imbi1d ralbidv rspcev syl2anr rgen2 elcnop mpbir2an
      wa ) EFGZHIFFVCUAZAJZBJZKLZMNZCJZOPZVEVCNZVFVCNZKLZMNZDJZOPZQZAFSZCTUBZDT
      SBFSFFVCUCVDFUDFFVCUEUFVSBDFTVOTIZVTVHVOOPZVPQZAFSZVSVFFIZVTUGWDWBAFWDVEF
      IZVBZVPWAWFVNVHVOOWFVMVGMWEWDVKVEVLVFKFVERFVFRUHUIUJUKULVRWCCVOTCDUMZVQWB
      AFWGVJWAVPVIVOVHOUNUOUPUQURUSBDCAVCUTVA $.

    $( The Hilbert space identity operator is a Hermitian operator.
       (Contributed by NM, 22-Apr-2006.)  (New usage is discouraged.) $)
    idhmop $p |- Iop e. HrmOp $=
      ( vx vy chio cho wcel chil wf cv cfv csp wceq wral wf1o hoif ax-mp hoival
      co f1of eqcomd oveqan12d rgen2a elhmop mpbir2an ) CDEFFCGZAHZBHZCIZJQUECI
      ZUFJQKZBFLAFLFFCMUDNFFCROUIABFUEFEZUFFEUEUHUGUFJUJUHUEUEPSUFPTUAABCUBUC
      $.

    $( The identically zero function is a Hermitian operator.  (Contributed by
       NM, 8-Aug-2006.)  (New usage is discouraged.) $)
    0hmop $p |- 0hop e. HrmOp $=
      ( vx vy ch0o cho wcel chil wf cv cfv csp co wceq wral ho0f cc0 c0v ho0val
      wa oveq2d hi02 sylan9eqr oveq1d sylan9eq eqtr4d rgen2a elhmop mpbir2an
      hi01 ) CDEFFCGAHZBHZCIZJKZUICIZUJJKZLZBFMAFMNUOABFUIFEZUJFEZRULOUNUQUPULU
      IPJKOUQUKPUIJUJQSUITUAUPUQUNPUJJKOUPUMPUJJUIQUBUJUHUCUDUEABCUFUG $.

    $( The identically zero function is a linear Hilbert space operator.
       (Contributed by NM, 7-Feb-2006.)  (New usage is discouraged.) $)
    0lnop $p |- 0hop e. LinOp $=
      ( ch0o cho wcel clo 0hmop hmoplin ax-mp ) ABCADCEAFG $.

    $( The identically zero function is a linear Hilbert space functional.
       (Contributed by NM, 14-Feb-2006.)  (New usage is discouraged.) $)
    0lnfn $p |- ( ~H X. { 0 } ) e. LinFn $=
      ( vx vy vz chil cc0 csn cxp clf wcel cc cv co cfv cmul caddc wceq wral wa
      c0ex fvconst2 wf csm cva 0cn fconst6 hvmulcl hvaddcl syl oveq2d sylan9eqr
      sylan mul01 oveqan12d 00id syl6eq eqtr4d 3impa rgen3 ellnfn mpbir2an ) DE
      FGZHIDJVAUAAKZBKZUBLZCKZUCLZVAMZVBVCVAMZNLZVEVAMZOLZPZCDQBDQAJQDEJUDUEVLA
      BCJDDVBJIZVCDIZVEDIZVLVMVNRZVORZVGEVKVQVFDIZVGEPVPVDDIVOVRVBVCUFVDVEUGUKD
      EVFSTUHVQVKEEOLEVPVOVIEVJEOVNVMVIVBENLEVNVHEVBNDEVCSTUIVBULUJDEVESTUMUNUO
      UPUQURABCVAUSUT $.

    $( The norm of the zero operator is zero.  (Contributed by NM,
       8-Feb-2006.)  (New usage is discouraged.) $)
    nmop0 $p |- ( normop ` 0hop ) = 0 $=
      ( vy vx ch0o cfv cv cno c1 cle wbr wceq wa chil wrex cab cxr clt csup cc0
      wcel c0v cnop csn wf ho0f nmopval ax-mp ho0val fveq2d norm0 syl6eq eqeq2d
      anbi2d rexbiia 0le1 fveq2 breq1d rspcev mp2an r19.41v mpbiran bitri abbii
      ax-hv0cl df-sn eqtr4i supeq1i wor xrltso 0xr supsn 3eqtri ) CUADZAEZFDZGH
      IZBEZVMCDZFDZJZKZALMZBNZOPQZRUBZOPQZRLLCUCVLWCJUDBACUEUFOWBWDPWBVPRJZBNWD
      WAWFBWAVOWFKZALMZWFVTWGALVMLSZVSWFVOWIVRRVPWIVRTFDZRWIVQTFVMUGUHUIUJUKULU
      MWHVOALMZWFTLSRGHIZWKVCUNVOWLATLVMTJZVNRGHWMVNWJRVMTFUOUIUJUPUQURVOWFALUS
      UTVAVBBRVDVEVFOPVGROSWERJVHVIORPVJURVK $.

    $( The norm of the identically zero functional is zero.  (Contributed by
       NM, 25-Apr-2006.)  (New usage is discouraged.) $)
    nmfn0 $p |- ( normfn ` ( ~H X. { 0 } ) ) = 0 $=
      ( vy vx chil cc0 cfv cv cno c1 cle wbr cabs wceq wa wrex cab cxr clt csup
      wcel c0v csn cxp cnmf cc wf 0lnfn lnfnf nmfnval mp2b c0ex fvconst2 fveq2d
      abs0 syl6eq eqeq2d anbi2d rexbiia ax-hv0cl 0le1 fveq2 norm0 breq1d rspcev
      clf mp2an r19.41v mpbiran bitri abbii df-sn eqtr4i supeq1i wor xrltso 0xr
      supsn 3eqtri ) CDUAZUBZUCEZAFZGEZHIJZBFZWAVSEZKEZLZMZACNZBOZPQRZVRPQRZDVS
      VDSCUDVSUEVTWKLUFVSUGBAVSUHUIPWJVRQWJWDDLZBOVRWIWMBWIWCWMMZACNZWMWHWNACWA
      CSZWGWMWCWPWFDWDWPWFDKEDWPWEDKCDWAUJUKULUMUNUOUPUQWOWCACNZWMTCSDHIJZWQURU
      SWCWRATCWATLZWBDHIWSWBTGEDWATGUTVAUNVBVCVEWCWMACVFVGVHVIBDVJVKVLPQVMDPSWL
      DLVNVOPDQVPVEVQ $.
  $}

  ${
    $d x y T $.
    $( A Hermitian operator is a bounded linear operator (Hellinger-Toeplitz
       Theorem).  (Contributed by NM, 18-Jan-2008.)
       (New usage is discouraged.) $)
    hmopbdoptHIL $p |- ( T e. HrmOp -> T e. BndLinOp ) $=
      ( vx vy cho wcel clo cv cfv csp co wceq chil wral cbo hmoplin hmop 3expib
      ralrimivv cop eqid cva csm chlo hilhl df-hba hhip clno hhlnoi cblo hhbloi
      cno htth mp3an1 syl2anc ) ADEZAFEZBGZCGZAHIJUQAHURIJKZCLMBLMZANEZAOUOUSBC
      LLUOUQLEURLEUSUQURAPQRUAUBSUKSZUCEUPUTVAUDBCNIAVBFLUEVBVBTZUFVBVBVBUGJZVC
      VDTUHVBVBUIJZVBVCVETUJULUMUN $.
  $}

  ${
    $d x R $.  $d x S $.  $d x T $.
    hoddi.1 $e |- R e. LinOp $.
    hoddi.2 $e |- S : ~H --> ~H $.
    hoddi.3 $e |- T : ~H --> ~H $.
    $( Distributive law for Hilbert space operator difference.  (Interestingly,
       the reverse distributive law ~ hocsubdiri does not require linearity.)
       (Contributed by NM, 11-Mar-2006.)  (New usage is discouraged.) $)
    hoddii $p |- ( R o. ( S -op T ) ) = ( ( R o. S ) -op ( R o. T ) ) $=
      ( vx chod co ccom cfv wceq chil wcel cmv ffvelrni wf hodval hocoi hocofi
      wral lnopsubi syl2anc mp3an12 fveq2d lnopfi oveq12d 3eqtr4d hosubcli rgen
      cv hoeqi mpbi ) GUKZABCHIZJZKZUNABJZACJZHIZKZLZGMUAUPUTLVBGMUNMNZUNUOKZAK
      ZUNURKZUNUSKZOIZUQVAVCUNBKZUNCKZOIZAKZVIAKZVJAKZOIZVEVHVCVIMNVJMNVLVOLMMU
      NBEPMMUNCFPVIVJADUBUCVCVDVKAMMBQMMCQVCVDVKLEFUNBCRUDUEVCVFVMVGVNOUNABADUF
      ZESUNACVPFSUGUHUNAUOVPBCEFUIZSMMURQMMUSQVCVAVHLABVPETZACVPFTZUNURUSRUDUHU
      JGUPUTAUOVPVQTURUSVRVSUIULUM $.
  $}

  $( Distributive law for Hilbert space operator difference.  (Interestingly,
     the reverse distributive law ~ hocsubdiri does not require linearity.)
     (Contributed by NM, 23-Aug-2006.)  (New usage is discouraged.) $)
  hoddi $p |- ( ( R e. LinOp /\ S : ~H --> ~H /\ T : ~H --> ~H ) ->
              ( R o. ( S -op T ) ) = ( ( R o. S ) -op ( R o. T ) ) ) $=
    ( clo wcel chil wf chod co ccom wceq cif coeq1 oveq12d eqeq12d coeq2d coeq2
    ch0o ho0f elimf oveq1 oveq1d oveq2 oveq2d 0lnop elimel hoddii dedth3h ) ADE
    ZFFBGZFFCGZABCHIZJZABJZACJZHIZKUIARLZULJZUQBJZUQCJZHIZKUQUJBRLZCHIZJZUQVBJZ
    UTHIZKUQVBUKCRLZHIZJZVEUQVGJZHIZKABCRRRAUQKZUMURUPVAAUQULMVLUNUSUOUTHAUQBMA
    UQCMNOBVBKZURVDVAVFVMULVCUQBVBCHUAPVMUSVEUTHBVBUQQUBOCVGKZVDVIVFVKVNVCVHUQC
    VGVBHUCPVNUTVJVEHCVGUQQUDOUQVBVGARDUEUFFFBRSTFFCRSTUGUH $.

  $( The norm of any operator on the trivial Hilbert space is zero.  (This is
     the reason we need ` ~H =/= 0H ` in ~ nmopun .)  (Contributed by NM,
     24-Feb-2006.)  (New usage is discouraged.) $)
  nmop0h $p |- ( ( ~H = 0H /\ T : ~H --> ~H ) -> ( normop ` T ) = 0 ) $=
    ( chil c0h wceq wf wa cnop cfv ch0o cc0 c0v csn wb df-ch0 eqeq2i feq3 sylbi
    cxp ax-hv0cl elexi fconst2 df0op2 xpeq2i bitr4i syl6bb biimpa fveq2d syl6eq
    eqtri nmop0 ) BCDZBBAEZFZAGHIGHJUMAIGUKULAIDZUKULBKLZAEZUNUKBUODULUPMCUOBNO
    BUOBAPQUPABUORZDUNBKAKBSTUAIUQAIBCRUQUBCUOBNUCUIOUDUEUFUGUJUH $.

  $( The identity function (restricted to Hilbert space) is a linear operator.
     (Contributed by NM, 24-Jan-2006.)  (New usage is discouraged.) $)
  idlnop $p |- ( _I |` ~H ) e. LinOp $=
    ( cid chil cres cuo wcel clo idunop unoplin ax-mp ) ABCZDEJFEGJHI $.

  $( The identically zero operator is bounded.  (Contributed by NM,
     14-Feb-2006.)  (New usage is discouraged.) $)
  0bdop $p |- 0hop e. BndLinOp $=
    ( ch0o cbo wcel clo cnop cfv cpnf clt wbr 0lnop cc0 nmop0 0re ltpnf eqbrtri
    cr ax-mp elbdop mpbir2an ) ABCADCAEFZGHIJTKGHLKPCKGHIMKNQOARS $.

  ${
    $d x y $.
    $( Adjoint of the zero operator.  (Contributed by NM, 20-Feb-2006.)
       (New usage is discouraged.) $)
    adj0 $p |- ( adjh ` 0hop ) = 0hop $=
      ( vx vy chil ch0o wf cv cfv csp co wceq wral cado ho0f wcel wa cc0 ho0val
      c0v oveq1d hi01 sylan9eq oveq2d hi02 sylan9eqr eqtr4d rgen2a adjeq mp3an
      ) CCDEZUIAFZDGZBFZHIZUJULDGZHIZJZBCKACKDLGDJMMUPABCUJCNZULCNZOUMPUOUQURUM
      RULHIPUQUKRULHUJQSULTUAURUQUOUJRHIPURUNRUJHULQUBUJUCUDUEUFABDDUGUH $.
  $}

  ${
    $d x y z T $.
    nmlnop0.1 $e |- T e. LinOp $.
    $( A linear operator with a zero norm is identically zero.  (Contributed by
       NM, 8-Feb-2006.)  (New usage is discouraged.) $)
    nmlnop0iALT $p |- ( ( normop ` T ) = 0 <-> T = 0hop ) $=
      ( vx vz vy cfv cc0 wceq ch0o chil wcel wa c0v wne c1 cno wbr syl2anc cle
      cr cnop cv wral wn cdiv co csm clt wi cc normcl recnd adantr norm-i fveq2
      lnop0i syl6eq syl6bi necon3d recne0d simpr wo wb reccld ffvelrni hvmul0or
      imp lnopfi necon3abid neanior syl6bbr mpbir2and hvmulcl normgt0 syl mpbid
      ex adantl wrex cab cxr csup wss wf nmopsetretHIL ax-mp ressxr sstri simpl
      necon3i sylan2 syl6eqel eqle lnopmuli eqcomd fveq2d breq1d eqeq2d anbi12d
      norm1 1re rspcev syl12anc fvex anbi2d rexbidv elab sylibr supxrub sylancr
      eqeq1 adantll nmopval eqeq1i biimpi breqtrd 0re lenlt sylancl pm2.65d nne
      ad2antrr sylib ho0val eqtr4d ralrimiva wfn ho0f eqfnfv mp2an nmop0 impbii
      ffn ) AUAFZGHZAIHZYOCUBZAFZYQIFZHZCJUCZYPYOYTCJYOYQJKZLZYRMYSUUCYRMNZUDYR
      MHZUUCUUDGOYQPFZUEUFZYRUGUFZPFZUHQZUUBUUDUUJUIYOUUBUUDUUJUUBUUDLZUUHMNZUU
      JUUKUULUUGGNZUUDUUKUUFUUBUUFUJKUUDUUBUUFYQUKULUMZUUBUUDUUFGNUUBUUFGYRMUUB
      UUFGHYQMHZUUEYQUNUUOYRMAFMYQMAUOABUPUQZURUSVGZUTUUBUUDVAUUKUULUUGGHUUEVBZ
      UDUUMUUDLUUKUURUUHMUUKUUGUJKZYRJKZUUHMHUURVCUUKUUFUUNUUQVDZUUBUUTUUDJJYQA
      ABVHZVEUMZUUGYRVFRVIUUGGYRMVJVKVLUUKUUHJKZUULUUJVCUUKUUSUUTUVDUVAUVCUUGYR
      VMRZUUHVNVOVPVQVRUUCUUDUUJUDZUUCUUDLZUUIGSQZUVFUVGUUIDUBZPFZOSQZEUBZUVIAF
      ZPFZHZLZDJVSZEVTZWAUHWBZGSUUBUUDUUIUVSSQZYOUUKUVRWAWCUUIUVRKZUVTUVRTWAJJA
      WDZUVRTWCUVBEDAWEWFWGWHUUKUVKUUIUVNHZLZDJVSZUWAUUKUUGYQUGUFZJKZUWFPFZOSQZ
      UUIUWFAFZPFZHZUWEUUKUUSUUBUWGUVAUUBUUDWIZUUGYQVMRUUKUWHTKUWHOHZUWIUUKUWHO
      TUUDUUBYQMNUWNYQMYRMUUPWJYQWTWKZXAWLUWOUWHOWMRUUKUUHUWJPUUKUWJUUHUUKUUSUU
      BUWJUUHHUVAUWMUUGYQABWNRWOWPUWDUWIUWLLDUWFJUVIUWFHZUVKUWIUWCUWLUWPUVJUWHO
      SUVIUWFPUOWQUWPUVNUWKUUIUWPUVMUWJPUVIUWFAUOWPWRWSXBXCUVQUWEEUUIUUHPXDUVLU
      UIHZUVPUWDDJUWQUVOUWCUVKUVLUUIUVNXKXEXFXGXHUVRUUIXIXJXLYOUVSGHZUUBUUDYOUW
      RYNUVSGUWBYNUVSHUVBEDAXMWFXNXOYBXPUUBUUDUVHUVFVCZYOUUKUUITKZGTKUWSUUKUVDU
      WTUVEUUHUKVOXQUUIGXRXSXLVPVQXTYRMYAYCUUBYSMHYOYQYDVRYEYFAJYGZIJYGZYPUUAVC
      UWBUXAUVBJJAYMWFJJIWDUXBYHJJIYMWFCJAIYIYJXHYPYNIUAFGAIUAUOYKUQYL $.

    $( A linear operator with a zero norm is identically zero.  (Contributed by
       NM, 18-Jan-2008.)  (New usage is discouraged.) $)
    nmlnop0iHIL $p |- ( ( normop ` T ) = 0 <-> T = 0hop ) $=
      ( clo wcel cnop cfv cc0 wceq ch0o wb cva csm cop cno cnmoo co eqid hhnmoi
      c0o hh0oi clno hhlnoi hhnv nmlno0i ax-mp ) ACDAEFGHAIHJBAKLMNMZCEUFIUFUFU
      FOPZUFQZUGQRUFUFUFSPZUHUIQTUFUFUFUAPZUHUJQUBUFUHUCZUKUDUE $.

    $( A linear Hilbert space operator that is not identically zero has a
       positive norm.  (Contributed by NM, 9-Feb-2006.)
       (New usage is discouraged.) $)
    nmlnopgt0i $p |- ( T =/= 0hop <-> 0 < ( normop ` T ) ) $=
      ( ch0o wne cnop cfv cc0 clt wbr nmlnop0iHIL necon3bii chil lnopfi nmopgt0
      wf wb ax-mp bitr3i ) ACDAEFZGDZGSHIZSGACABJKLLAOTUAPABMANQR $.
  $}

  $( A linear operator with a zero norm is identically zero.  (Contributed by
     NM, 12-Aug-2006.)  (New usage is discouraged.) $)
  nmlnop0 $p |- ( T e. LinOp -> ( ( normop ` T ) = 0 <-> T = 0hop ) ) $=
    ( clo wcel cnop cfv cc0 wceq wb cif fveq2 eqeq1d eqeq1 bibi12d 0lnop elimel
    ch0o nmlnop0iHIL dedth ) ABCZADEZFGZAPGZHSAPIZDEZFGZUCPGZHAPAUCGZUAUEUBUFUG
    TUDFAUCDJKAUCPLMUCAPBNOQR $.

  $( A linear operator with a nonzero norm is nonzero.  (Contributed by NM,
     12-Aug-2006.)  (New usage is discouraged.) $)
  nmlnopne0 $p |- ( T e. LinOp -> ( ( normop ` T ) =/= 0 <-> T =/= 0hop ) ) $=
    ( clo wcel cnop cfv cc0 ch0o nmlnop0 necon3bid ) ABCADEFAGAHI $.

  ${
    $d x y z A $.  $d x y z T $.
    lnopm.1 $e |- T e. LinOp $.
    $( The scalar product of a linear operator is a linear operator.
       (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    lnopmi $p |- ( A e. CC -> ( A .op T ) e. LinOp ) $=
      ( vx vy vz cc wcel chil co wf cv csm cva cfv wceq wral wa homval mp3an2
      chot clo lnopfi homulcl mpan2 hvmulcl hvaddcl sylan sylan2 id ax-hvdistr1
      ffvelrni syl3an 3expb lnopli 3expa oveq2d adantl adantrl hvmulcom syl3an3
      eqtr4d oveqan12d anandis 3eqtr4rd ralrimdv ralrimivv ellnop sylanbrc
      exp32 ) AGHZIIABUAJZKZDLZELZMJZFLZNJZVLOZVNVOVLOZMJZVQVLOZNJZPZFIQZEIQDGQ
      VLUBHVKIIBKZVMBCUCZABUDUEVKWEDEGIVKVNGHZVOIHZRZWDFIVKWJVQIHZWDVKWJWKRZRZV
      SAVRBOZMJZWCWLVKVRIHZVSWOPZWJVPIHWKWPVNVOUFVPVQUGUHVKWFWPWQWGAVRBSTUIWMAV
      NVOBOZMJZVQBOZNJZMJZAWSMJZAWTMJZNJZWOWCVKWJWKXBXEPZVKVKWJWSIHZWKWTIHXFVKU
      JWIWHWRIHZXGIIVOBWGULZVNWRUFUIIIVQBWGULAWSWTUKUMUNWLWOXBPVKWLWNXAAMWHWIWK
      WNXAPVNVOVQBCUOUPUQURVKWJWKWCXEPVKWJRZVKWKRWAXCWBXDNXJWAVNAWRMJZMJZXCXJVT
      XKVNMVKWIVTXKPZWHVKWFWIXMWGAVOBSTUSUQVKWHWIXCXLPZWIVKWHXHXNXIAVNWRUTVAUNV
      BVKWFWKWBXDPWGAVQBSTVCVDVEVBVJVFVGDEFVLVHVI $.
  $}

  ${
    $d x y z S $.  $d x y z T $.
    lnopco.1 $e |- S e. LinOp $.
    lnopco.2 $e |- T e. LinOp $.
    $( The sum of two linear operators is linear.  (Contributed by NM,
       10-Mar-2006.)  (New usage is discouraged.) $)
    lnophsi $p |- ( S +op T ) e. LinOp $=
      ( vx vy vz co wcel chil wf cv csm cva cfv wceq wral cc wa ffvelrni lnopfi
      chos clo hoaddcli hvmulcl lnopaddi oveq12d sylan syl anim12i hvadd4 eqtrd
      syl2anc hvaddcl hosval mp3an12 jca ax-hvdistr1 3expb sylan2 oveq2d adantl
      lnopmuli 3eqtr4d oveqan12d ralrimiva rgen2 ellnop mpbir2an ) ABUBHZUCIJJV
      JKELZFLZMHZGLZNHZVJOZVKVLVJOZMHZVNVJOZNHZPZGJQZFJQERQABACUAZBDUAZUDWBEFRJ
      VKRIZVLJIZSZWAGJWGVNJIZSZVOAOZVOBOZNHZVMAOZVMBOZNHZVNAOZVNBOZNHZNHZVPVTWI
      WLWMWPNHZWNWQNHZNHZWSWGVMJIZWHWLXBPVKVLUEZXCWHSWJWTWKXANVMVNACUFVMVNBDUFU
      GUHWIWMJIZWPJIZSWNJIZWQJIZSXBWSPWGXEWHXFWGXCXEXDJJVMAWCTUIJJVNAWCTUJWGXGW
      HXHWGXCXGXDJJVMBWDTUIJJVNBWDTUJWMWPWNWQUKUMULWIVOJIZVPWLPZWGXCWHXIXDVMVNU
      NUHJJAKZJJBKZXIXJWCWDVOABUOUPUIWGWHVRWOVSWRNWGVKVLAOZVLBOZNHZMHZVKXMMHZVK
      XNMHZNHZVRWOWFWEXMJIZXNJIZSXPXSPZWFXTYAJJVLAWCTJJVLBWDTUQWEXTYAYBVKXMXNUR
      USUTWFVRXPPWEWFVQXOVKMXKXLWFVQXOPWCWDVLABUOUPVAVBWGWMXQWNXRNVKVLACVCVKVLB
      DVCUGVDXKXLWHVSWRPWCWDVNABUOUPVEVDVFVGEFGVJVHVI $.

    $( The difference of two linear operators is linear.  (Contributed by NM,
       27-Jul-2006.)  (New usage is discouraged.) $)
    lnophdi $p |- ( S -op T ) e. LinOp $=
      ( c1 cneg chot co chos chod clo lnopfi honegsubi wcel neg1cn lnopmi ax-mp
      cc lnophsi eqeltrri ) AEFZBGHZIHABJHKABACLBDLMAUBCUARNUBKNOUABDPQST $.

    $( The composition of two linear operators is linear.  (Contributed by NM,
       8-Mar-2006.)  (New usage is discouraged.) $)
    lnopcoi $p |- ( S o. T ) e. LinOp $=
      ( vx vy vz wcel chil cv csm co cva cfv wceq wral cc lnopfi wa hocoi wf id
      ccom clo hocofi lnopli fveq2d ffvelrni syl3an eqtrd 3expa hvmulcl hvaddcl
      w3a sylan syl oveq2d adantl oveqan12d 3eqtr4d 3impa rgen3 ellnop mpbir2an
      ) ABUCZUDHIIVEUAEJZFJZKLZGJZMLZVENZVFVGVENZKLZVIVENZMLZOZGIPFIPEQPABACRZB
      DRZUEVPEFGQIIVFQHZVGIHZVIIHZVPVSVTSZWASZVJBNZANZVFVGBNZANZKLZVIBNZANZMLZV
      KVOVSVTWAWEWKOVSVTWAUNZWEVFWFKLWIMLZANZWKWLWDWMAVFVGVIBDUFUGVSVSVTWFIHWAW
      IIHWNWKOVSUBIIVGBVRUHIIVIBVRUHVFWFWIACUFUIUJUKWCVJIHZVKWEOWBVHIHWAWOVFVGU
      LVHVIUMUOVJABVQVRTUPWBWAVMWHVNWJMVTVMWHOVSVTVLWGVFKVGABVQVRTUQURVIABVQVRT
      USUTVAVBEFGVEVCVD $.

    $( The composition of a linear operator with one whose norm is zero.
       (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    lnopco0i $p |- ( ( normop ` T ) = 0 -> ( normop ` ( S o. T ) ) = 0 ) $=
      ( vx ch0o wceq ccom cnop cfv cc0 chil wfn wf lnopcoi lnopfi ffn ax-mp c0v
      ho0f coeq2 cv wral wb 0lnop eqfnfv mp2an wcel ho0val fveq2d lnop0i syl6eq
      hocoi 3eqtr4d mprgbir nmlnop0iHIL 3imtr4i ) BFGZABHZFGBIJKGUSIJKGURUSAFHZ
      FBFAUAUTFGZEUBZUTJZVBFJZGZELUTLMZFLMZVAVEELUCUDLLUTNVFUTAFCUEOPLLUTQRLLFN
      VGTLLFQRELUTFUFUGVBLUHZVDAJZSVCVDVHVISAJSVHVDSAVBUIZUJACUKULVBAFACPTUMVJU
      NUOULBDUPUSABCDOUPUQ $.
  $}

  ${
    $d x y z T $.
    lnopeq0.1 $e |- T e. LinOp $.
    ${
      lnopeq0lem1.2 $e |- A e. ~H $.
      lnopeq0lem1.3 $e |- B e. ~H $.
      $( Lemma for ~ lnopeq0i .  Apply the generalized polarization identity
         ~ polid2i to the quadratic form ` ( ( T `` x ) , x ) ` .  (Contributed
         by NM, 26-Jul-2006.)  (New usage is discouraged.) $)
      lnopeq0lem1 $p |- ( ( T ` A ) .ih B ) =
             ( ( ( ( ( T ` ( A +h B ) ) .ih ( A +h B ) ) -
                   ( ( T ` ( A -h B ) ) .ih ( A -h B ) ) ) + ( _i x.
        ( ( ( T ` ( A +h ( _i .h B ) ) ) .ih ( A +h ( _i .h B ) ) ) -
      ( ( T ` ( A -h ( _i .h B ) ) ) .ih ( A -h ( _i .h B ) ) ) ) ) ) / 4 ) $=
        ( cfv csp co cva cmv cmin ci cmul caddc c4 chil wcel wceq oveq1i lnopfi
        cdiv ffvelrni ax-mp polid2i lnopaddi mp2an lnopsubi oveq12i lnopaddmuli
        csm cc ax-icn mp3an lnopsubmuli oveq2i eqtr4i ) ACGZBHIURBCGZJIZABJIZHI
        ZURUSKIZABKIZHIZLIZMURMUSUKIZJIZAMBUKIZJIZHIZURVGKIZAVIKIZHIZLIZNIZOIZP
        UBIVACGZVAHIZVDCGZVDHIZLIZMVJCGZVJHIZVMCGZVMHIZLIZNIZOIZPUBIURBUSAAQRZU
        RQREQQACCDUAZUCUDFBQRZUSQRFQQBCWKUCUDEUEWIVQPUBWBVFWHVPOVSVBWAVELVRUTVA
        HWJWLVRUTSEFABCDUFUGTVTVCVDHWJWLVTVCSEFABCDUHUGTUIWGVOMNWDVKWFVNLWCVHVJ
        HMULRZWJWLWCVHSUMEFMABCDUJUNTWEVLVMHWMWJWLWEVLSUMEFMABCDUOUNTUIUPUITUQ
        $.
    $}

    $( Lemma for ~ lnopeq0i .  (Contributed by NM, 26-Jul-2006.)
       (New usage is discouraged.) $)
    lnopeq0lem2 $p |- ( ( A e. ~H /\ B e. ~H ) -> ( ( T ` A ) .ih B ) =
           ( ( ( ( ( T ` ( A +h B ) ) .ih ( A +h B ) ) -
                 ( ( T ` ( A -h B ) ) .ih ( A -h B ) ) ) + ( _i x.
      ( ( ( T ` ( A +h ( _i .h B ) ) ) .ih ( A +h ( _i .h B ) ) ) -
     ( ( T ` ( A -h ( _i .h B ) ) ) .ih ( A -h ( _i .h B ) ) ) ) ) ) / 4 ) ) $=
      ( chil cfv csp co cva cmv cmin ci cmul caddc cdiv wceq c0v fveq2d oveq12d
      c4 wcel csm fveq2 oveq1d oveq1 oveq2d eqeq12d ax-hv0cl elimel lnopeq0lem1
      cif oveq2 dedth2h ) AEUAZBEUAZACFZBGHZABIHZCFZURGHZABJHZCFZVAGHZKHZLALBUB
      HZIHZCFZVFGHZAVEJHZCFZVIGHZKHZMHZNHZTOHZPUNAQUKZCFZBGHZVPBIHZCFZVSGHZVPBJ
      HZCFZWBGHZKHZLVPVEIHZCFZWFGHZVPVEJHZCFZWIGHZKHZMHZNHZTOHZPVQUOBQUKZGHZVPW
      PIHZCFZWRGHZVPWPJHZCFZXAGHZKHZLVPLWPUBHZIHZCFZXFGHZVPXEJHZCFZXIGHZKHZMHZN
      HZTOHZPABQQAVPPZUQVRVOWOXPUPVQBGAVPCUCUDXPVNWNTOXPVDWEVMWMNXPUTWAVCWDKXPU
      SVTURVSGXPURVSCAVPBIUEZRXQSXPVBWCVAWBGXPVAWBCAVPBJUEZRXRSSXPVLWLLMXPVHWHV
      KWKKXPVGWGVFWFGXPVFWFCAVPVEIUEZRXSSXPVJWJVIWIGXPVIWICAVPVEJUEZRXTSSUFSUDU
      GBWPPZVRWQWOXOBWPVQGULYAWNXNTOYAWEXDWMXMNYAWAWTWDXCKYAVTWSVSWRGYAVSWRCBWP
      VPIULZRYBSYAWCXBWBXAGYAWBXACBWPVPJULZRYCSSYAWLXLLMYAWHXHWKXKKYAWGXGWFXFGY
      AWFXFCYAVEXEVPIBWPLUBULZUFZRYESYAWJXJWIXIGYAWIXICYAVEXEVPJYDUFZRYFSSUFSUD
      UGVPWPCDAQEUHUIBQEUHUIUJUM $.

    $( A condition implying that a linear Hilbert space operator is identically
       zero.  Unlike ~ ho01i for arbitrary operators, when the operator is
       linear we need to consider only the values of the quadratic form
       ` ( T `` x ) .ih x ) ` .  (Contributed by NM, 26-Jul-2006.)
       (New usage is discouraged.) $)
    lnopeq0i $p |- ( A. x e. ~H ( ( T ` x ) .ih x ) = 0 <-> T = 0hop ) $=
      ( vy vz cfv csp co cc0 wceq chil wcel cmin ci fveq2 oveq12d sylan2 syl6eq
      c4 id cv wral ch0o cva cmv csm cmul caddc cdiv lnopeq0lem2 adantl hvaddcl
      wa eqeq1d rspccva hvsubcl 0cn subidi cc ax-icn hvmulcl mpan oveq2d mul01i
      00id oveq1d 4cn 4re 4pos gt0ne0ii div0i eqtrd ralrimivva lnopfi ho01i c0v
      sylib fveq1 ho0val sylan9eq hi01 ralrimiva impbii ) AUAZBFZWDGHZIJZAKUBZB
      UCJZWHDUAZBFEUAZGHZIJZEKUBDKUBWIWHWMDEKKWHWJKLZWKKLZUMZUMZWLWJWKUDHZBFZWR
      GHZWJWKUEHZBFZXAGHZMHZNWJNWKUFHZUDHZBFZXFGHZWJXEUEHZBFZXIGHZMHZUGHZUHHZSU
      IHZIWPWLXOJWHWJWKBCUJUKWQXOISUIHIWQXNISUIWQXNIIUHHIWQXDIXMIUHWQXDIIMHZIWQ
      WTIXCIMWPWHWRKLWTIJZWJWKULWGXQAWRKWDWRJZWFWTIXRWEWSWDWRGWDWRBOXRTPUNUOQWP
      WHXAKLXCIJZWJWKUPWGXSAXAKWDXAJZWFXCIXTWEXBWDXAGWDXABOXTTPUNUOQPIUQURZRWQX
      MNIUGHIWQXLINUGWQXLXPIWQXHIXKIMWPWHXFKLZXHIJZWOWNXEKLZYBNUSLWOYDUTNWKVAVB
      ZWJXEULQWGYCAXFKWDXFJZWFXHIYFWEXGWDXFGWDXFBOYFTPUNUOQWPWHXIKLZXKIJZWOWNYD
      YGYEWJXEUPQWGYHAXIKWDXIJZWFXKIYIWEXJWDXIGWDXIBOYITPUNUOQPYARVCNUTVDRPVERV
      FSVGSVHVIVJVKRVLVMDEBBCVNVOVQWIWGAKWIWDKLZUMZWFVPWDGHZIYKWEVPWDGWIYJWEWDU
      CFVPWDBUCVRWDVSVTVFYJYLIJWIWDWAUKVLWBWC $.
  $}

  ${
    $d x T $.  $d x U $.
    lnopeq.1 $e |- T e. LinOp $.
    lnopeq.2 $e |- U e. LinOp $.
    $( Two linear Hilbert space operators are equal iff their quadratic forms
       are equal.  (Contributed by NM, 27-Jul-2006.)
       (New usage is discouraged.) $)
    lnopeqi $p |- ( A. x e. ~H ( ( T ` x ) .ih x ) = ( ( U ` x ) .ih x ) <->
                  T = U ) $=
      ( cv cfv csp co wceq chil wral cc0 wcel cc lnopfi ffvelrni hicl mpancom
      wf chod ch0o subeq0ad cmv hodval mp3an12 oveq1d id his2sub syl3anc eqtr2d
      cmin eqeq1d bitr3d ralbiia lnophdi lnopeq0i hosubeq0i 3bitri ) AFZBGZUTHI
      ZUTCGZUTHIZJZAKLUTBCUAIZGZUTHIZMJZAKLVFUBJBCJVEVIAKUTKNZVBVDULIZMJVEVIVJV
      BVDVAKNZVJVBONKKUTBBDPZQZVAUTRSVCKNZVJVDONKKUTCCEPZQZVCUTRSUCVJVKVHMVJVHV
      AVCUDIZUTHIZVKVJVGVRUTHKKBTKKCTVJVGVRJVMVPUTBCUEUFUGVJVLVOVJVSVKJVNVQVJUH
      VAVCUTUIUJUKUMUNUOAVFBCDEUPUQBCVMVPURUS $.
  $}

  ${
    $d x T $.  $d x U $.
    $( Two linear Hilbert space operators are equal iff their quadratic forms
       are equal.  (Contributed by NM, 27-Jul-2006.)
       (New usage is discouraged.) $)
    lnopeq $p |- ( ( T e. LinOp /\ U e. LinOp ) ->
        ( A. x e. ~H ( ( T ` x ) .ih x ) = ( ( U ` x ) .ih x ) <-> T = U ) ) $=
      ( clo wcel cfv csp co wceq chil wral wb ch0o fveq1 oveq1d ralbidv bibi12d
      cif 0lnop elimel cv eqeq1d eqeq1 eqeq2d eqeq2 lnopeqi dedth2h ) BDEZCDEZA
      UAZBFZUJGHZUJCFZUJGHZIZAJKZBCIZLUJUHBMRZFZUJGHZUNIZAJKZURCIZLUTUJUICMRZFZ
      UJGHZIZAJKZURVDIZLBCMMBURIZUPVBUQVCVJUOVAAJVJULUTUNVJUKUSUJGUJBURNOUBPBUR
      CUCQCVDIZVBVHVCVIVKVAVGAJVKUNVFUTVKUMVEUJGUJCVDNOUDPCVDURUEQAURVDBMDSTCMD
      STUFUG $.
  $}

  ${
    $d y A $.  $d y B $.  $d y C $.  $d x y T $.
    lnopunilem.1 $e |- T e. LinOp $.
    lnopunilem.2 $e |- A. x e. ~H ( normh ` ( T ` x ) ) = ( normh ` x ) $.
    lnopunilem.3 $e |- A e. ~H $.
    lnopunilem.4 $e |- B e. ~H $.
    ${
      lnopunilem1.5 $e |- C e. CC $.
      $( Lemma for ~ lnopunii .  (Contributed by NM, 14-May-2005.)
         (New usage is discouraged.) $)
      lnopunilem1 $p |- ( Re ` ( C x. ( ( T ` A ) .ih ( T ` B ) ) ) ) =
                      ( Re ` ( C x. ( A .ih B ) ) ) $=
        ( vy cfv csp co cmul caddc wcel wceq chil mp3an cre c2 cdiv cc ffvelrni
        ccj lnopfi ax-mp hicli mulcli reval cv cno fveq2 fveq2d eqeq12d cbvralv
        wral mpbi cexp oveq1 normsq syl syl5ib ralimia oveq12d rspcv mp2 oveq2i
        id oveq12i oveq1i add42i csm cva hvmulcli hvaddcli ax-his2 ax-his3 his7
        cjcli his5 eqtri adddii 3eqtri cjmuli his1i eqtr4i lnopli eqtr3i addcli
        3eqtrri addcani ) DBELZCELZMNZONZUALZWQWQUFLZPNZUBUCNZDBCMNZONZUALZWQUD
        QWRXARDWPJWNWOBSQZWNSQZHSSBEEFUGZUEUHZCSQZWOSQZISSCEXGUEUHZUIZUJZWQUKUH
        XDXCXCUFLZPNZUBUCNZXAXCUDQXDXPRDXBJBCHIUIZUJZXCUKUHWTXOUBUCDDUFLZBBMNZO
        NZONZCCMNZPNZWTPNZYDXOPNZRWTXORDXSWNWNMNZONZONZWOWOMNZPNZWTPNZYEYFYKYDW
        TPYIYBYJYCPYHYADOYGXTXSOXEKULZELZYNMNZYMYMMNZRZKSURZYGXTRZHYNUMLZYMUMLZ
        RZKSURZYRAULZELZUMLZUUDUMLZRZASURUUCGUUHUUBAKSUUDYMRZUUFYTUUGUUAUUIUUEY
        NUMUUDYMEUNUOUUDYMUMUNUPUQUSUUBYQKSUUBYTUBUTNZUUAUBUTNZRYMSQZYQYTUUAUBU
        TVAUULUUJYOUUKYPUULYNSQUUJYORSSYMEXGUEYNVBVCYMVBUPVDVEUHZYQYSKBSYMBRZYO
        YGYPXTUUNYNWNYNWNMYMBEUNZUUOVFUUNYMBYMBMUUNVJZUUPVFUPVGVHVIVIXIYRYJYCRZ
        IUUMYQUUQKCSYMCRZYOYJYPYCUURYNWOYNWOMYMCEUNZUUSVFUURYMCYMCMUURVJZUUTVFU
        PVGVHVKVLYLYIWQPNZWSYJPNZPNZYFYIYJWQWSDYHJXSYGDJWAZWNWNXHXHUIUJZUJWOWOX
        KXKUIXMWQXMWAZVMYFYBXCPNZXNYCPNZPNZUVCYBYCXCXNDYAJXSXTUVDBBHHUIUJZUJZCC
        IIUIZXRXCXRWAZVMUVIDBVNNZCVONZELZUVPMNZDWNVNNZUVRWOVONZMNZWOUVSMNZPNZUV
        CUVQUVOUVOMNZUVNUVOMNZCUVOMNZPNZUVIUVOSQZYRUVQUWCRZUVNCDBJHVPZIVQZUUMYQ
        UWHKUVOSYMUVORZYOUVQYPUWCUWKYNUVPYNUVPMYMUVOEUNZUWLVFUWKYMUVOYMUVOMUWKV
        JZUWMVFUPVGVHUVNSQZXIUWGUWCUWFRUWIIUWJUVNCUVOVRTUWDUVGUWEUVHPUWDDBUVOMN
        ZONZDYAXBPNZONUVGDUDQZXEUWGUWDUWPRJHUWJDBUVOVSTUWOUWQDOUWOBUVNMNZXBPNZU
        WQXEUWNXIUWOUWTRHUWIIBUVNCVTTUWSYAXBPUWRXEXEUWSYARJHHDBBWBTVLWCVIDYAXBJ
        UVJXQWDWEUWECUVNMNZYCPNZUVHXIUWNXIUWEUXBRIUWIICUVNCVTTUXAXNYCPUXAXSCBMN
        ZONZXNUWRXIXEUXAUXDRJIHDCBWBTXNXSXBUFLZONUXDDXBJXQWFUXCUXEXSOCBIHWGVIWH
        WHVLWCVKWLUVQUVSUVSMNZUWBUVPUVSUVPUVSMUWRXEXIUVPUVSRJHIDBCEFWITZUXGVKUV
        RSQZXJUVSSQZUXFUWBRDWNJXHVPZXKUVRWOUXJXKVQZUVRWOUVSVRTWCUVTUVAUWAUVBPUV
        TDWNUVSMNZONZDYHWPPNZONUVAUWRXFUXIUVTUXMRJXHUXKDWNUVSVSTUXLUXNDOUXLWNUV
        RMNZWPPNZUXNXFUXHXJUXLUXPRXHUXJXKWNUVRWOVTTUXOYHWPPUWRXFXFUXOYHRJXHXHDW
        NWNWBTVLWCVIDYHWPJUVEXLWDWEUWAWOUVRMNZYJPNZUVBXJUXHXJUWAUXRRXKUXJXKWOUV
        RWOVTTUXQWSYJPUXQXSWOWNMNZONZWSUWRXJXFUXQUXTRJXKXHDWOWNWBTWSXSWPUFLZONU
        XTDWPJXLWFUXSUYAXSOWOWNXKXHWGVIWHWHVLWCVKWLWHWHWJYDWTXOYBYCUVKUVLWKWQWS
        XMUVFWKXCXNXRUVMWKWMUSVLWHWH $.
    $}

    $( Lemma for ~ lnopunii .  (Contributed by NM, 12-May-2005.)
       (New usage is discouraged.) $)
    lnopunilem2 $p |- ( ( T ` A ) .ih ( T ` B ) ) = ( A .ih B ) $=
      ( vy cfv csp co cmul cre wceq cc wcel cc0 oveq1 chil wral cif eqeq12d 0cn
      cv fveq2d elimel lnopunilem1 dedth rgen lnopfi ffvelrni ax-mp hicli recan
      wb mp2an mpbi ) IUEZBDJZCDJZKLZMLZNJZUSBCKLZMLZNJZOZIPUAZVBVEOZVHIPUSPQZV
      HVKUSRUBZVBMLZNJZVLVEMLZNJZOUSRUSVLOZVDVNVGVPVQVCVMNUSVLVBMSUFVQVFVONUSVL
      VEMSUFUCABCVLDEFGHUSRPUDUGUHUIUJVBPQVEPQVIVJUPUTVABTQUTTQGTTBDDEUKZULUMCT
      QVATQHTTCDVRULUMUNBCGHUNIVBVEUOUQUR $.
  $}

  ${
    $d x y T $.
    lnopuni.1 $e |- T e. LinOp $.
    lnopuni.2 $e |- T : ~H -onto-> ~H $.
    lnopuni.3 $e |- A. x e. ~H ( normh ` ( T ` x ) ) = ( normh ` x ) $.
    $( If a linear operator (whose range is ` ~H ` ) is idempotent in the norm,
       the operator is unitary.  Similar to theorem in [AkhiezerGlazman]
       p. 73.  (Contributed by NM, 23-Jan-2006.)
       (New usage is discouraged.) $)
    lnopunii $p |- T e. UniOp $=
      ( vy wcel chil cv cfv csp wceq wral c0v cif fveq2 eqeq12d ax-hv0cl elimel
      co cuo wfo oveq1d oveq1 oveq2d lnopunilem2 dedth2h rgen2a elunop mpbir2an
      oveq2 ) BUAGHHBUBAIZBJZFIZBJZKTZULUNKTZLZFHMAHMDURAFHULHGZUNHGZURUSULNOZB
      JZUOKTZVAUNKTZLVBUTUNNOZBJZKTZVAVEKTZLULUNNNULVALZUPVCUQVDVIUMVBUOKULVABP
      UCULVAUNKUDQUNVELZVCVGVDVHVJUOVFVBKUNVEBPUEUNVEVAKUKQAVAVEBCEULNHRSUNNHRS
      UFUGUHAFBUIUJ $.
  $}

  ${
    $d w x y z T $.
    $( An operator is unitary iff it is linear, onto, and idempotent in the
       norm.  Similar to theorem in [AkhiezerGlazman] p. 73, and its converse.
       (Contributed by NM, 24-Feb-2006.)  (New usage is discouraged.) $)
    elunop2 $p |- ( T e. UniOp <-> ( T e. LinOp /\ T : ~H -onto-> ~H /\
                 A. x e. ~H ( normh ` ( T ` x ) ) = ( normh ` x ) ) ) $=
      ( vy cuo wcel clo chil wfo cv cfv cno wceq wral w3a csp eleq1 foeq1 fveq2
      co fveq2d unoplin elunop simplbi unopnorm ralrimiva 3jca cid cres eqeq12d
      cif cbvralv fveq1 eqeq1d ralbidv syl5bb 3anbi123d idlnop wf1o f1ofo ax-mp
      f1oi fvresi 3pm3.2i elimhyp simp1i simp2i simp3i lnopunii dedth impbii
      rgen ) BDEZBFEZGGBHZAIZBJZKJZVOKJZLZAGMZNZVLVMVNVTBUAVLVNVPCIZBJZOSVOWBOS
      LCGMAGMACBUBUCVLVSAGVOBUDUEUFWAVLWABUGGUHZUJZDEBWDBWEDPCWEWEFEZGGWEHZWBWE
      JZKJZWBKJZLZCGMZWAWFWGWLNWDFEZGGWDHZWBWDJZKJZWJLZCGMZNBWDBWELZVMWFVNWGVTW
      LBWEFPGGBWEQVTWCKJZWJLZCGMWSWLVSXAACGVOWBLZVQWTVRWJXBVPWCKVOWBBRTVOWBKRUI
      UKWSXAWKCGWSWTWIWJWSWCWHKWBBWEULTUMUNUOUPWDWELZWMWFWNWGWRWLWDWEFPGGWDWEQX
      CWQWKCGXCWPWIWJXCWOWHKWBWDWEULTUMUNUPWMWNWRUQGGWDURWNGVAGGWDUSUTWQCGWBGEW
      OWBKGWBVBTVKVCVDZVEWFWGWLXDVFWFWGWLXDVGVHVIVJ $.

    $( Norm of a unitary Hilbert space operator.  (Contributed by NM,
       25-Feb-2006.)  (New usage is discouraged.) $)
    nmopun $p |- ( ( ~H =/= 0H /\ T e. UniOp ) -> ( normop ` T ) = 1 ) $=
      ( vy vx vz vw chil wcel wa cfv cv c1 cle wbr wceq wrex cxr clt syl adantl
      cr c0h wne cuo cnop cno cab csup wf clo unoplin lnopf nmopval wss wral wi
      nmopsetretHIL ressxr syl6ss 1re rexri jctir vex eqeq1 anbi2d rexbidv elab
      unopnorm eqeq2d breq1 biimparc syl6bi rexlimdva imp sylan2b ralrimiva c0v
      hne0 norm1hex bitri biimpi adantr 1le1 mpbiri a1i eqeq2 mpbid eqcomd jcad
      wb ex adantll reximdva mpd 1ex sylibr breq2 rspcev sylan supxr2 syl12anc
      eqtrd ) FUAUBZAUCGZHZAUDIZBJZUEIZKLMZCJZXFAIUEIZNZHZBFOZCUFZPQUGZKXCXEXON
      ZXBXCFFAUHZXPXCAUIGXQAUJAUKRZCBAULRSXDXNPUMZKPGZHDJZKLMZDXNUNZYAKQMZYAEJZ
      QMZEXNOZUOZDTUNXOKNXDXSXTXCXSXBXCXQXSXRXQXNTPCBAUPUQURRSKUSUTVAXCYCXBXCYB
      DXNYAXNGXCXHYAXJNZHZBFOZYBXMYKCYADVBXIYANZXLYJBFYLXKYIXHXIYAXJVCVDVEVFXCY
      KYBXCYJYBBFXCXFFGZHZYJXHYAXGNZHYBYNYIYOXHYNXJXGYAXFAVGZVHVDYOYBXHYAXGKLVI
      VJVKVLVMVNVOSXDYHDTXDYATGZHZYDYGYRKXNGZYDYGXDYSYQXDXHKXJNZHZBFOZYSXDXGKNZ
      BFOZUUBXBUUDXCXBUUDXBXFVPUBBFOUUDBVQBBVRVSVTWAXDUUCUUABFXCYMUUCUUAUOXBYNU
      UCXHYTUUCXHUOYNUUCXHKKLMWBXGKKLVIWCWDYNUUCYTYNUUCHZXJKUUEXJXGNZXJKNZYNUUF
      UUCYPWAUUCUUFUUGWIYNXGKXJWESWFWGWJWHWKWLWMXMUUBCKWNXIKNZXLUUABFUUHXKYTXHX
      IKXJVCVDVEVFWOWAYFYDEKXNYEKYAQWPWQWRWJVODEXNKWSWTXA $.
  $}

  $( A unitary operator is a bounded linear operator.  (Contributed by NM,
     10-Mar-2006.)  (New usage is discouraged.) $)
  unopbd $p |- ( T e. UniOp -> T e. BndLinOp ) $=
    ( cuo wcel clo cnop cfv cr cbo unoplin chil c0h wceq wf wf1o unopf1o syl wa
    f1of cc0 syl6eqel nmop0h 0re sylan2 wn wne df-ne nmopun 1re sylanbr elbdop2
    c1 pm2.61ian sylanbrc ) ABCZADCAEFZGCZAHCAIJKLZUNUPUNUQJJAMZUPUNJJANURAOJJA
    RPUQURQUOSGAUAUBTUCUQUDJKUEZUNUPJKUFUSUNQUOUKGAUGUHTUIULAUJUM $.

  ${
    $d x A $.  $d x B $.  $d x y z T $.
    lnophmlem.1 $e |- A e. ~H $.
    lnophmlem.2 $e |- B e. ~H $.
    lnophmlem.3 $e |- T e. LinOp $.
    lnophmlem.4 $e |- A. x e. ~H ( x .ih ( T ` x ) ) e. RR $.
    $( Lemma for ~ lnophmi .  (Contributed by NM, 24-Jan-2006.)
       (New usage is discouraged.) $)
    lnophmlem1 $p |- ( A .ih ( T ` A ) ) e. RR $=
      ( chil wcel cv cfv csp co cr wral wceq id fveq2 oveq12d eleq1d rspcv mp2
      ) BIJAKZUDDLZMNZOJZAIPBBDLZMNZOJZEHUGUJABIUDBQZUFUIOUKUDBUEUHMUKRUDBDSTUA
      UBUC $.

    $( Lemma for ~ lnophmi .  (Contributed by NM, 24-Jan-2006.)
       (New usage is discouraged.) $)
    lnophmlem2 $p |- ( A .ih ( T ` B ) ) = ( ( T ` A ) .ih B ) $=
      ( cva co cfv csp ci csm cmul c4 chil oveq2i ax-icn c1 cmv cmin caddc cdiv
      ccj wcel lnopfi ffvelrni ax-mp polid2i hvcomi wceq lnopaddi mp2an oveq12i
      eqtr4i hisubcomi lnopsubi hvmulcli hvsubcli his35i hvsubdistr1i hvsubvali
      cneg hvmulassi ixi ax-1cn mul2negi 3eqtri oveq1i neg1cn mulcli ax-hvmulid
      1t1e1 3eqtr3i eqtr3i eqtri fveq2i lnopmuli lnopaddmuli mp3an cji mulneg2i
      cc negeqi negnegi lnophmlem1 recni mulid2i hvdistr1i hvaddcli lnopmulsubi
      3eqtr4i cc0 wne 4pos gt0ne0ii resubcli addcli cjdivi cr cjreim negsubdi2i
      4re negsubi lnopsubmuli cjre 3eqtrri his1i ) BCIJZBDKZCDKZIJZLJZBCUAJZXKX
      LUAJZLJZUBJZMBMCNJZIJZXKMXLNJZIJZLJZBXSUAJZXKYAUAJZLJZUBJZOJZUCJZPUDJZCXK
      LJZUEKZBXLLJXKCLJYLXJXJDKZLJZXOXODKZLJZUBJZMYDYDDKZLJZXTXTDKZLJZUBJZOJZUC
      JZPUDJZUEKZUUDUEKZPUEKZUDJZYJYKUUEUEYKCBIJZXLXKIJZLJZCBUAJXLXKUAJLJZUBJZM
      CMBNJZIJZXLMXKNJZIJZLJZCUUOUAJXLUUQUAJLJZUBJZOJZUCJZPUDJUUECXKBXLFBQUFZXK
      QUFEQQBDDGUGZUHUIZECQUFZXLQUFFQQCDUVEUHUIZUJUVCUUDPUDUUNYQUVBUUCUCUULYNUU
      MYPUBUUJXJUUKYMLCBFEUKUUKXMYMXLXKUVHUVFUKUVDUVGYMXMULEFBCDGUMUNZUPUOUUMXQ
      YPCBXLXKFEUVHUVFUQYOXPXOLUVDUVGYOXPULEFBCDGURUNRZUPUOUVAUUBMOUUSYSUUTUUAU
      BMYDNJZMYRNJZLJMMUEKZOJZYSOJZUUSYSMMYDYRSSBXSEMCSFUSZUTZYDQUFZYRQUFUVQQQY
      DDUVEUHUIVAUVKUUPUVLUURLUVKUUOMXSNJZUAJZUUOCIJZUUPMBXSSEUVPVBUVTUUOTVDZUV
      SNJZIJUWAUUOUVSMBSEUSZMXSSUVPUSVCUWCCUUOIUWBMMOJZCNJZNJZUWCCUWFUVSUWBNMMC
      SSFVEZRUWBUWEOJZCNJTCNJZUWGCUWITCNUWIUWBUWBOJTTOJTUWEUWBUWBOVFRTTVGVGVHVN
      VIVJUWBUWECVKMMSSVLFVEUVGUWJCULFCVMUIVOVPRVQUUOCUWDFUKVIZUVKDKZUUPDKZUVLU
      URUVKUUPDUWKVRMWDUFZUVRUWLUVLULSUVQMYDDGVSUNUWNUVGUVDUWMUURULSFEMCBDGVTWA
      VOUOUVOTYSOJYSUVNTYSOUVNMMVDZOJUWEVDZTUVMUWOMOWBRMMSSWCUWPUWBVDTUWEUWBVFW
      ETVGWFVQVIZVJYSYSAYDBDUVQEGHWGZWHZWIVQVOUUTMXTNJZMYTNJZLJZUVNUUAOJZUUAUUT
      UUOCUAJZUUQXLUAJZLJUXBCUUOXLUUQFUWDUVHMXKSUVFUSUQUWTUXDUXAUXELUUOUVSIJUUO
      UWBCNJZIJUWTUXDUVSUXFUUOIUWFUVSUXFUWHUWEUWBCNVFVJVPRMBXSSEUVPWJUUOCUWDFVC
      WMZUWTDKZUXDDKZUXAUXEUWTUXDDUXGVRUWNXTQUFZUXHUXAULSBXSEUVPWKZMXTDGVSUNUWN
      UVDUVGUXIUXEULSEFMBCDGWLWAVOUOUPMMXTYTSSUXKUXJYTQUFUXKQQXTDUVEUHUIVAUXCTU
      UAOJUUAUVNTUUAOUWQVJUUAUUAAXTBDUXKEGHWGZWHZWIVQVIUORUOVJVQVRPWNWOUUFUUIUL
      PXDWPWQUUDPYQUUCYQYNYPAXJBDBCEFWKEGHWGAXOBDBCEFUTEGHWGWRZWHZMUUBSUUBYSUUA
      UWRUXLWRZWHZVLWSPXDWHWTUIUUGYIUUHPUDUUGYQUUCVDZUCJZYQMUUAYSUBJZOJZUCJYIUU
      GYQUUCUBJZUXSYQXAUFUUBXAUFUUGUYBULUXNUXPYQUUBXBUNYQUUCUXOMUUBSUUBYSUUAUWR
      AXTCDUXKFGHWGWRWHVLXEUPUXRUYAYQUCMUUBVDZOJUXRUYAMUUBSUXQWCUYCUXTMOYSUUAUW
      SUXMXCRVPRYQXRUYAYHUCYNXNYPXQUBYMXMXJLUVIRUVJUOUXTYGMOUUAYCYSYFUBYTYBXTLU
      WNUVDUVGYTYBULSEFMBCDGVTWARYRYEYDLUWNUVDUVGYRYEULSEFMBCDGXFWARUORUOVIPXAU
      FUUHPULXDPXGUIUOXHBXLCXKEUVHFUVFUJXKCUVFFXIWM $.
  $}

  ${
    $d x y z T $.
    lnophm.1 $e |- T e. LinOp $.
    lnophm.2 $e |- A. x e. ~H ( x .ih ( T ` x ) ) e. RR $.
    $( A linear operator is Hermitian if ` x .ih ( T `` x ) ` takes only real
       values.  Remark in [ReedSimon] p. 195.  (Contributed by NM,
       24-Jan-2006.)  (New usage is discouraged.) $)
    lnophmi $p |- T e. HrmOp $=
      ( vy vz wcel chil cv cfv csp co wceq wral c0v cif eqeq12d ax-hv0cl elimel
      fveq2 cho wf lnopfi oveq1 oveq1d oveq2d oveq2 lnophmlem2 dedth2h mpbir2an
      rgen2a elhmop ) BUAGHHBUBEIZFIZBJZKLZUMBJZUNKLZMZFHNEHNBCUCUSEFHUMHGZUNHG
      ZUSUTUMOPZUOKLZVBBJZUNKLZMVBVAUNOPZBJZKLZVDVFKLZMUMUNOOUMVBMZUPVCURVEUMVB
      UOKUDVJUQVDUNKUMVBBTUEQUNVFMZVCVHVEVIVKUOVGVBKUNVFBTUFUNVFVDKUGQAVBVFBUMO
      HRSUNOHRSCDUHUIUKEFBULUJ $.
  $}

  ${
    $d x y A $.  $d x y T $.  $d x y U $.
    $( A linear operator is Hermitian if ` x .ih ( T `` x ) ` takes only real
       values.  Remark in [ReedSimon] p. 195.  (Contributed by NM,
       24-Jan-2006.)  (New usage is discouraged.) $)
    lnophm $p |- ( ( T e. LinOp /\ A. x e. ~H ( x .ih ( T ` x ) ) e. RR ) ->
                   T e. HrmOp ) $=
      ( vy clo wcel cv cfv csp co cr chil wral wa cho eleq1 eleq1d fveq1 oveq2d
      wceq ralbidv cid cres cif id oveq12d cbvralv syl5bb anbi12d idlnop fvresi
      fveq2 hiidrcl eqeltrd rgen pm3.2i elimhyp simpli simpri lnophmi dedth ) B
      DEZAFZVBBGZHIZJEZAKLZMZBNEVGBUAKUBZUCZNEBVHBVINOCVIVIDEZCFZVKVIGZHIZJEZCK
      LZVGVJVOMVHDEZVKVKVHGZHIZJEZCKLZMBVHBVISZVAVJVFVOBVIDOVFVKVKBGZHIZJEZCKLW
      AVOVEWDACKVBVKSZVDWCJWEVBVKVCWBHWEUDVBVKBUKUEPUFWAWDVNCKWAWCVMJWAWBVLVKHV
      KBVIQRPTUGUHVHVISZVPVJVTVOVHVIDOWFVSVNCKWFVRVMJWFVQVLVKHVKVHVIQRPTUHVPVTU
      IVSCKVKKEZVRVKVKHIJWGVQVKVKHKVKUJRVKULUMUNUOUPZUQVJVOWHURUSUT $.

    $( The sum of two Hermitian operators is Hermitian.  (Contributed by NM,
       23-Jul-2006.)  (New usage is discouraged.) $)
    hmops $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T +op U ) e. HrmOp ) $=
      ( vx vy cho wcel wa chil co wf cfv csp wceq wral hmopf caddc hmop ffvelrn
      cv 3expb chos hoaddcl syl2an oveqan12d anandirs anim12i cva hosval oveq2d
      3expa adantrl simprl ad2ant2rl ad2ant2l his7 syl3anc eqtrd oveq1d adantrr
      w3a ad2ant2r ad2ant2lr simprr ax-his2 3eqtr4d ralrimivva elhmop sylanbrc
      sylan ) AEFZBEFZGZHHABUAIZJZCSZDSZVMKZLIZVOVMKZVPLIZMZDHNCHNVMEFVJHHAJZHH
      BJZVNVKAOZBOZABUBUCVLWACDHHVLVOHFZVPHFZGZGVOVPAKZLIZVOVPBKZLIZPIZVOAKZVPL
      IZVOBKZVPLIZPIZVRVTVJVKWHWMWRMVJWHGVKWHGWJWOWLWQPVJWFWGWJWOMVOVPAQTVKWFWG
      WLWQMVOVPBQTUDUEVLWBWCGZWHVRWMMVJWBVKWCWDWEUFZWSWHGZVRVOWIWKUGIZLIZWMWSWG
      VRXCMZWFWBWCWGXDWBWCWGUTVQXBVOLVPABUHUIUJUKXAWFWIHFZWKHFZXCWMMWSWFWGULWBW
      GXEWCWFHHVPARUMWCWGXFWBWFHHVPBRUNVOWIWKUOUPUQVIVLWSWHVTWRMWTXAVTWNWPUGIZV
      PLIZWRWSWFVTXHMZWGWBWCWFXIWBWCWFUTVSXGVPLVOABUHURUJUSXAWNHFZWPHFZWGXHWRMW
      BWFXJWCWGHHVOARVAWCWFXKWBWGHHVOBRVBWSWFWGVCWNWPVPVDUPUQVIVEVFCDVMVGVH $.

    $( The scalar product of a Hermitian operator with a real is Hermitian.
       (Contributed by NM, 23-Jul-2006.)  (New usage is discouraged.) $)
    hmopm $p |- ( ( A e. RR /\ T e. HrmOp ) -> ( A .op T ) e. HrmOp ) $=
      ( vx vy wcel cho wa chil co wf cv cfv csp wceq wral cmul csm homval 3expa
      ffvelrn cr chot recn hmopf homulcl syl2an ccj cjre hmop oveqan12d anassrs
      cc 3expb anim12i adantrl oveq2d simpll simprl ad2ant2l his5 syl3anc eqtrd
      sylan adantrr oveq1d ad2ant2lr simprr ax-his3 3eqtr4d ralrimivva sylanbrc
      elhmop ) AUAEZBFEZGZHHABUBIZJZCKZDKZVPLZMIZVRVPLZVSMIZNZDHOCHOVPFEVMAULEZ
      HHBJZVQVNAUCZBUDZABUEUFVOWDCDHHVOVRHEZVSHEZGZGAUGLZVRVSBLZMIZPIZAVRBLZVSM
      IZPIZWAWCVMVNWKWOWRNVMVNWKGWLAWNWQPAUHVNWIWJWNWQNVRVSBUIUMUJUKVOWEWFGZWKW
      AWONVMWEVNWFWGWHUNZWSWKGZWAVRAWMQIZMIZWOXAVTXBVRMWSWJVTXBNZWIWEWFWJXDAVSB
      RSUOUPXAWEWIWMHEZXCWONWEWFWKUQZWSWIWJURWFWJXEWEWIHHVSBTUSAVRWMUTVAVBVCVOW
      SWKWCWRNWTXAWCAWPQIZVSMIZWRXAWBXGVSMWSWIWBXGNZWJWEWFWIXIAVRBRSVDVEXAWEWPH
      EZWJXHWRNXFWFWIXJWEWJHHVRBTVFWSWIWJVGAWPVSVHVAVBVCVIVJCDVPVLVK $.

    $( The difference of two Hermitian operators is Hermitian.  (Contributed by
       NM, 23-Jul-2006.)  (New usage is discouraged.) $)
    hmopd $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T -op U ) e. HrmOp ) $=
      ( wcel wa c1 cneg chot co chos chod chil wf wceq hmopf honegsub syl2an cr
      cho 1re renegcli hmopm mpan hmops sylan2 eqeltrrd ) ARCZBRCZDAEFZBGHZIHZA
      BJHZRUFKKALKKBLUJUKMUGANBNABOPUGUFUIRCZUJRCUHQCUGULESTUHBUAUBAUIUCUDUE $.

    $( The composition of two commuting Hermitian operators is Hermitian.
       (Contributed by NM, 22-Aug-2006.)  (New usage is discouraged.) $)
    hmopco $p |- ( ( T e. HrmOp /\ U e. HrmOp /\ ( T o. U ) = ( U o. T ) ) ->
                   ( T o. U ) e. HrmOp ) $=
      ( vx vy cho wcel ccom wceq chil wf cv cfv co wral hmopf wa fvco3 ad2ant2l
      csp sylan w3a fco syl2an 3adant3 oveq2d simpll simprl hmop syl3anc simplr
      ffvelrnda ad2ant2r simprr 3eqtrd oveq1d eqtr4d 3adantl3 adantr ralrimivva
      fveq1 3ad2ant3 elhmop sylanbrc ) AEFZBEFZABGZBAGZHZUAZIIVFJZCKZDKZVFLZSMZ
      VKVFLZVLSMZHZDINCINVFEFVDVEVJVHVDIIAJZIIBJZVJVEAOZBOZIIIABUBUCUDVIVQCDIIV
      IVKIFZVLIFZPZPVNVKVGLZVLSMZVPVDVEWDVNWFHVHVDVEPZWDPZVNVKALZBLZVLSMZWFWHVN
      VKVLBLZALZSMZWIWLSMZWKVEWCVNWNHVDWBVEWCPVMWMVKSVEVSWCVMWMHWAIIVLABQTUERWH
      VDWBWLIFZWNWOHVDVEWDUFWGWBWCUGVEWCWPVDWBVEIIVLBWAUKRVKWLAUHUIWHVEWIIFZWCW
      OWKHVDVEWDUJVDWBWQVEWCVDIIVKAVTUKULWGWBWCUMWIVLBUHUIUNVDWBWFWKHVEWCVDWBPW
      EWJVLSVDVRWBWEWJHVTIIVKBAQTUOULUPUQVIVPWFHZWDVHVDWRVEVHVOWEVLSVKVFVGUTUOV
      AURUPUSCDVFVBVC $.
  $}

  ${
    nmbdoplb.1 $e |- T e. BndLinOp $.
    $( A lower bound for the norm of a bounded linear operator.  (Contributed
       by NM, 14-Feb-2006.)  (New usage is discouraged.) $)
    nmbdoplbi $p |- ( A e. ~H ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
      ( chil wcel cfv cno cmul co cle wbr c0v c1 cr normcl adantr recnd syl2anc
      wceq cc0 cnop fveq2 fveq2d oveq2d breq12d wne wa csm cbo clo bdopln ax-mp
      cdiv lnopfi ffvelrni syl normne0 biimpar divrec2d rereccld simpl lnopmuli
      cabs norm-iii clt normgt0 biimpa recgt0d 0re ltle mpan sylc absidd oveq1d
      cc wi 3eqtrrd eqtrd hvmulcl norm1 eqle wf nmoplb mp3an1 eqbrtrd wb nmopre
      a1i ledivmul2 syl112anc mpbid 0le0 lnop0i fveq2i norm0 eqtri oveq2i recni
      mul01i 3brtr4i pm2.61ne ) ADEZABFZGFZBUAFZAGFZHIZJKZLBFZGFZXELGFZHIZJKZAL
      ALSZXDXJXGXLJXNXCXIGALBUBUCXNXFXKXEHALGUBUDUEXBALUFZUGZXDXFUMIZXEJKZXHXPX
      QMXFUMIZAUHIZBFZGFZXEJXPXQXSXDHIZYBXPXDXFXPXDXBXDNEZXOXBXCDEZYDDDABBBUIEZ
      BUJECBUKULZUNZUOZXCOUPPZQXPXFXBXFNEZXOAOPZQXBXFTUFXOAUQURZUSXPYBXSXCUHIZG
      FZXSVCFZXDHIZYCXPYAYNGXPXSVOEZXBYAYNSXPXSXPXFYLYMUTZQZXBXOVAZXSABYGVBRUCX
      PYRYEYOYQSYTXBYEXOYIPXSXCVDRXPYPXSXDHXPXSYSXPXSNEZTXSVEKZTXSJKZYSXPXFYLXB
      XOTXFVEKZAVFVGZVHTNEUUBUUCUUDVPVITXSVJVKVLVMVNVQVRXPXTDEZXTGFZMJKZYBXEJKZ
      XPYRXBUUGYTUUAXSAVSRZXPUUHNEZUUHMSUUIXPUUGUULUUKXTOUPAVTUUHMWARDDBWBUUGUU
      IUUJYHXTBWCWDRWEXPYDXENEZYKUUEXRXHWFYJUUMXPYFUUMCBWGULZWHYLUUFXDXEXFWIWJW
      KXMXBTTXJXLJWLXJXKTXILGBYGWMWNWOWPXLXETHITXKTXEHWOWQXEXEUUNWRWSWPWTWHXA
      $.
  $}

  $( A lower bound for the norm of a bounded linear Hilbert space operator.
     (Contributed by NM, 18-Feb-2006.)  (New usage is discouraged.) $)
  nmbdoplb $p |- ( ( T e. BndLinOp /\ A e. ~H ) ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
    ( cbo wcel chil cfv cno cnop cmul co cle wbr wi ch0o cif fveq1 fveq2d fveq2
    wceq oveq1d breq12d imbi2d 0bdop elimel nmbdoplbi dedth imp ) BCDZAEDZABFZG
    FZBHFZAGFZIJZKLZUHUIUOMUIAUHBNOZFZGFZUPHFZUMIJZKLZMBNBUPSZUOVAUIVBUKURUNUTK
    VBUJUQGABUPPQVBULUSUMIBUPHRTUAUBAUPBNCUCUDUEUFUG $.

  ${
    $d m n x y z N $.  $d m n x y z T $.
    nmcex.1 $e |- E. y e. RR+ A. z e. ~H
                    ( ( normh ` z ) < y -> ( N ` ( T ` z ) ) < 1 ) $.
    nmcex.2 $e |- ( S ` T ) = sup ( { m | E. x e. ~H
      ( ( normh ` x ) <_ 1 /\ m = ( N ` ( T ` x ) ) ) } , RR* , < ) $.
    nmcex.3 $e |- ( x e. ~H -> ( N ` ( T ` x ) ) e. RR ) $.
    nmcex.4 $e |- ( N ` ( T ` 0h ) ) = 0 $.
    nmcex.5 $e |- ( ( ( y / 2 ) e. RR+ /\ x e. ~H ) ->
   ( ( y / 2 ) x. ( N ` ( T ` x ) ) ) = ( N ` ( T ` ( ( y / 2 ) .h x ) ) ) ) $.
    $( Lemma for ~ nmcopexi and ~ nmcfnexi .  The norm of a continuous linear
       Hilbert space operator or functional exists.  Theorem 3.5(i) of [Beran]
       p. 99.  (Contributed by Mario Carneiro, 17-Nov-2013.)  (Proof shortened
       by Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    nmcexi $p |- ( S ` T ) e. RR $=
      ( cfv c1 cle wbr wceq chil cr wcel vn cv cno wa wrex cab clt csup cxr wss
      c0 wne wral eleq1 syl5ibrcom imp adantrl rexlimiva abssi cc0 c0v ax-hv0cl
      norm0 0le1 eqbrtri eqcomi pm3.2i fveq2 breq1d fveq2d eqeq2d anbi12d mp2an
      rspcev c0ex eqeq1 anbi2d rexbidv elab mpbir ne0i ax-mp wi crp c2 cdiv wal
      co 2rp rpdivcl mpan rpred adantr csm rpre rehalfcld recnd hvmulcl syl2anc
      cc simprl normcl syl cmul simprr ad2antrl 1re rphalfcl lemul2d mpbid cabs
      rpcn norm-iii sylan absidd oveq1d eqtr2d mulid1d 3brtr3d rphalflt lelttrd
      a1i rpge0 imbi12d rspcv mpid ltmuldiv2d rprecred ltle sylbid rpne0 recdiv
      2cn 2ne0 mpanr12 breq2d 3imtr3d syld an32s mp3an anassrs rexlimdva imbi2d
      breq1 expimpd alrimiv ralab breq2 albidv syl5bb supxrre suprcl eqeltri
      eqtri ) EDMZAUBZUCMZNOPZFUBZUUPEMZGMZQZUDZARUEZFUFZSUGUHZSUUOUVEUIUGUHZUV
      FIUVESUJZUVEUKULZUAUBZCUBZOPZUAUVEUMZCSUEZUVGUVFQUVDFSUVCUUSSTZARUUPRTZUV
      BUVOUURUVPUVBUVOUVPUVOUVBUVASTZJUUSUVASUNUOUPUQURUSZUTUVETZUVIUVSUURUTUVA
      QZUDZARUEZVARTVAUCMZNOPZUTVAEMZGMZQZUDZUWBVBUWDUWGUWCUTNOVCVDVEUWFUTKVFVG
      UWAUWHAVARUUPVAQZUURUWDUVTUWGUWIUUQUWCNOUUPVAUCVHVIUWIUVAUWFUTUWIUUTUWEGU
      UPVAEVHVJVKVLVNVMUVDUWBFUTVOUUSUTQZUVCUWAARUWJUVBUVTUURUUSUTUVAVPVQVRVSVT
      UVEUTWAWBZUVKUCMZBUBZUGPZUVKEMZGMZNUGPZWCZCRUMZBWDUEUVNHUWSUVNBWDUWMWDTZU
      WSUDZWEUWMWFWHZSTZUURUVJUVAQZUDZARUEZUVJUXBOPZWCZUAWGZUVNUWTUXCUWSUWTUXBW
      EWDTUWTUXBWDTWIWEUWMWJWKWLWMUXAUXHUAUXAUXEUXGARUXAUVPUDZUURUXDUXGUXJUURUD
      UXGUXDUVAUXBOPZUXAUVPUURUXKUWTUVPUURUDZUWSUXKUWTUXLUDZUWSUXKUXMUWSUWMWEWF
      WHZUUPWNWHZEMZGMZNUGPZUXKUXMUWSUXOUCMZUWMUGPZUXRUXMUXSUXNUWMUXMUXORTZUXSS
      TUXMUXNWTTZUVPUYAUXMUXNUXMUWMUWTUWMSTUXLUWMWOWMZWPZWQZUWTUVPUURXAZUXNUUPW
      RWSZUXOXBXCUYDUYCUXMUXNUUQXDWHZUXNNXDWHZUXSUXNOUXMUURUYHUYIOPUWTUVPUURXEU
      XMUUQNUXNUVPUUQSTUWTUURUUPXBXFNSTUXMXGYBZUWTUXNWDTZUXLUWMXHWMZXIXJUXMUYKU
      VPUYHUXSQUYLUYFUYKUVPUDUXSUXNXKMZUUQXDWHZUYHUYKUYBUVPUXSUYNQUXNXLUXNUUPXM
      XNUYKUYNUYHQUVPUYKUYMUXNUUQXDUYKUXNUXNWOUXNYCXOXPWMXQWSUXMUXNUYEXRXSUWTUX
      NUWMUGPUXLUWMXTWMYAUXMUYAUWSUXTUXRWCZWCUYGUWRUYOCUXORUVKUXOQZUWNUXTUWQUXR
      UYPUWLUXSUWMUGUVKUXOUCVHVIUYPUWPUXQNUGUYPUWOUXPGUVKUXOEVHVJVIYDYEXCYFUXMU
      XNUVAXDWHZNUGPZUVANUXNWFWHZOPZUXRUXKUXMUYRUVAUYSUGPZUYTUXMUVANUXNUVPUVQUW
      TUURJXFZUYJUYLYGUXMUVQUYSSTVUAUYTWCVUBUXMUXNUYLYHUVAUYSYIWSYJUXMUYQUXQNUG
      UXMUYKUVPUYQUXQQUYLUYFLWSVIUXMUYSUXBUVAOUWTUYSUXBQZUXLUWTUWMWTTZUWMUTULZV
      UCUWMXLUWMYKVUDVUEUDWEWTTWEUTULVUCYMYNUWMWEYLYOWSWMYPYQYRUPYSUUAUVJUVAUXB
      OUUDUOUUEUUBUUFUVMUXICUXBSUVMUXFUVLWCZUAWGUVKUXBQZUXIUVDUXFUVLUAFUUSUVJQZ
      UVCUXEARVUHUVBUXDUURUUSUVJUVAVPVQVRUUGVUGVUFUXHUAVUGUVLUXGUXFUVKUXBUVJOUU
      HUUCUUIUUJVNWSURWBZCUAUVEUUKYTUUNUVHUVIUVNUVFSTUVRUWKVUICUAUVEUULYTUUM $.
  $}

  ${
    $d m x y z T $.
    nmcopex.1 $e |- T e. LinOp $.
    nmcopex.2 $e |- T e. ConOp $.
    $( The norm of a continuous linear Hilbert space operator exists.  Theorem
       3.5(i) of [Beran] p. 99.  (Contributed by NM, 5-Feb-2006.)  (Proof
       shortened by Mario Carneiro, 17-Nov-2013.)
       (New usage is discouraged.) $)
    nmcopexi $p |- ( normop ` T ) e. RR $=
      ( vx vy vz vm cno cv c0v cmv co cfv clt wbr c1 chil crp wcel wceq cnop wi
      wral wrex ccop ax-hv0cl cnopc hvsub0 fveq2d breq1d lnop0i oveq2i ffvelrni
      1rp mp3an lnopfi syl syl5eq imbi12d ralbiia rexbii mpbi wf cle wa cab cxr
      csup nmopval ax-mp cr normcl cc0 fveq2i norm0 eqtri c2 cdiv csm cabs cmul
      cc rpcn lnopmuli sylan norm-iii syl2an rpge0 absidd adantr oveq1d 3eqtrrd
      rpre nmcexi ) DEFUAAGHFIZJKLZHMZEIZNOZWOAMZJAMZKLZHMZPNOZUBZFQUCZERUDZWOH
      MZWRNOZWTHMZPNOZUBZFQUCZERUDAUESJQSPRSXGCUFUNEFJPAUGUOXFXMERXEXLFQWOQSZWS
      XIXDXKXNWQXHWRNXNWPWOHWOUHUIUJXNXCXJPNXNXBWTHXNXBWTJKLZWTXAJWTKABUKZULXNW
      TQSXOWTTQQWOAABUPZUMWTUHUQURUIUJUSUTVAVBQQAVCAUAMDIZHMPVDOGIXRAMZHMZTVEDQ
      UDGVFVGNVHTXQGDAVIVJXRQSZXSQSZXTVKSQQXRAXQUMZXSVLUQXAHMJHMVMXAJHXPVNVOVPW
      RVQVRLZRSZYAVEZYDXRVSLAMZHMYDXSVSLZHMZYDVTMZXTWALZYDXTWALYFYGYHHYEYDWBSZY
      AYGYHTYDWCZYDXRABWDWEUIYEYLYBYIYKTYAYMYCYDXSWFWGYFYJYDXTWAYEYJYDTYAYEYDYD
      WMYDWHWIWJWKWLWN $.

    $( A lower bound for the norm of a continuous linear operator.  Theorem
       3.5(ii) of [Beran] p. 99.  (Contributed by NM, 7-Feb-2006.)  (Revised by
       Mario Carneiro, 17-Nov-2013.)  (New usage is discouraged.) $)
    nmcoplbi $p |- ( A e. ~H ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
      ( chil wcel cfv cno cmul co cle wbr c0v wceq cc0 syl6eq c1 normcl syl2anc
      cr cnop 0le0 a1i fveq2 lnop0i fveq2d norm0 oveq2d nmcopexi mul01i 3brtr4d
      recni adantl wne wa cdiv csm cabs adantr normne0 biimpar rereccld normgt0
      clt biimpa recgt0d wi 0re ltle mpan absidd oveq1d cc recnd simpl lnopmuli
      sylc lnopfi ffvelrni norm-iii eqtrd syl divrec2d 3eqtr4rd hvmulcl eqle wf
      norm1 nmoplb mp3an1 eqbrtrd wb ledivmul2 syl112anc mpbid pm2.61dane ) AEF
      ZABGZHGZBUAGZAHGZIJZKLZAMAMNZXCWQXDOOWSXBKOOKLXDUBUCXDWSMHGZOXDWRMHXDWRMB
      GMAMBUDBCUEPUFUGPXDXBWTOIJOXDXAOWTIXDXAXEOAMHUDUGPUHWTWTBCDUIZULUJPUKUMWQ
      AMUNZUOZWSXAUPJZWTKLZXCXHXIQXAUPJZAUQJZBGZHGZWTKXHXKURGZWSIJZXKWSIJXNXIXH
      XOXKWSIXHXKXHXAWQXATFZXGARUSZWQXAOUNXGAUTVAZVBZXHXKTFZOXKVDLZOXKKLZXTXHXA
      XRWQXGOXAVDLZAVCVEZVFOTFYAYBYCVGVHOXKVIVJVQVKVLXHXNXKWRUQJZHGZXPXHXMYFHXH
      XKVMFZWQXMYFNXHXKXTVNZWQXGVOZXKABCVPSUFXHYHWREFZYGXPNYIWQYKXGEEABBCVRZVSZ
      USXKWRVTSWAXHWSXAXHWSWQWSTFZXGWQYKYNYMWRRWBUSZVNXHXAXRVNXSWCWDXHXLEFZXLHG
      ZQKLZXNWTKLZXHYHWQYPYIYJXKAWESZXHYQTFZYQQNYRXHYPUUAYTXLRWBAWHYQQWFSEEBWGY
      PYRYSYLXLBWIWJSWKXHYNWTTFZXQYDXJXCWLYOUUBXHXFUCXRYEWSWTXAWMWNWOWP $.
  $}

  $( The norm of a continuous linear Hilbert space operator exists.  Theorem
     3.5(i) of [Beran] p. 99.  (Contributed by NM, 7-Feb-2006.)
     (New usage is discouraged.) $)
  nmcopex $p |- ( ( T e. LinOp /\ T e. ConOp ) -> ( normop ` T ) e. RR ) $=
    ( clo wcel ccop wa cin cnop cfv cr elin cid chil cres cif wceq fveq2 eleq1d
    idlnop idcnop mpbir2an elimel mpbi simpli simpri nmcopexi dedth sylbir ) AB
    CADCEABDFZCZAGHZICZABDJUIUKUIAKLMZNZGHZICAULAUMOUJUNIAUMGPQUMUMBCZUMDCZUMUH
    CUOUPEAULUHULUHCULBCULDCRSULBDJTUAUMBDJUBZUCUOUPUQUDUEUFUG $.

  $( A lower bound for the norm of a continuous linear Hilbert space operator.
     Theorem 3.5(ii) of [Beran] p. 99.  (Contributed by NM, 7-Feb-2006.)
     (New usage is discouraged.) $)
  nmcoplb $p |- ( ( T e. LinOp /\ T e. ConOp /\ A e. ~H ) ->
              ( normh ` ( T ` A ) ) <_ ( ( normop ` T ) x. ( normh ` A ) ) ) $=
    ( clo wcel ccop chil cfv cno cnop cmul co cle wbr wa cin elin cid cres cif
    wi wceq fveq1 fveq2d fveq2 oveq1d imbi2d idlnop idcnop mpbir2an elimel mpbi
    breq12d simpli simpri nmcoplbi dedth imp sylanbr 3impa ) BCDZBEDZAFDZABGZHG
    ZBIGZAHGZJKZLMZUTVANBCEOZDZVBVHBCEPVJVBVHVJVBVHTVBAVJBQFRZSZGZHGZVLIGZVFJKZ
    LMZTBVKBVLUAZVHVQVBVRVDVNVGVPLVRVCVMHABVLUBUCVRVEVOVFJBVLIUDUEULUFAVLVLCDZV
    LEDZVLVIDVSVTNBVKVIVKVIDVKCDVKEDUGUHVKCEPUIUJVLCEPUKZUMVSVTWAUNUOUPUQURUS
    $.

  ${
    $d x A $.  $d x T $.
    nmophm.1 $e |- T e. BndLinOp $.
    $( The norm of the scalar product of a bounded linear operator.
       (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    nmophmi $p |- ( A e. CC ->
              ( normop ` ( A .op T ) ) = ( ( abs ` A ) x. ( normop ` T ) ) ) $=
      ( vx wcel co cfv cabs cmul wceq cle wbr cno chil wa adantr cr cc0 syl wb
      cc chot cnop cv c1 wi wral csm wf cbo bdopf homval mp3an2 fveq2d ffvelrni
      ax-mp norm-iii sylan2 eqtrd normcl ad2antlr absge0 ad2antrr nmoplb mp3an1
      jca adantll nmopre lemul2a mp3anl2 syl21anc eqbrtrd ralrimiva cxr homulcl
      abscl mpan2 remulcl sylancl rexrd nmopub syl2anc mpbird fveq2 abs0 syl6eq
      ex oveq1d recni mul02i adantl nmopge0 wne syl3an1 3expa eqbrtrrd adantllr
      cdiv clt cmnf nmopxr nmopgtmnf syl22anc absgt0 biimpa lemuldiv2 syl112anc
      xrre mpbid abs00 necon3bid biimpar redivcld sylancr a1i letri3d mpbir2and
      pm2.61dane ) AUAEZABUBFZUCGZAHGZBUCGZIFZJYAYDKLZYDYAKLZXSYEDUDZMGUEKLZYGX
      TGZMGZYDKLZUFZDNUGZXSYLDNXSYGNEZOZYHYKYOYHOZYJYBYGBGZMGZIFZYDKYOYJYSJYHYO
      YJAYQUHFZMGZYSYOYIYTMXSNNBUIZYNYIYTJBUJEZUUBCBUKUPZAYGBULUMUNYNXSYQNEZUUA
      YSJNNYGBUUDUOZAYQUQURUSPZYPYRQEZYBQEZRYBKLZOZYRYCKLZYSYDKLZYNUUHXSYHYNUUE
      UUHUUFYQUTSZVAXSUUKYNYHXSUUIUUJAVPZAVBVFVCYNYHUULXSUUBYNYHUULUUDYGBVDVEVG
      UUHYCQEZUUKUULUUMUUCUUPCBVHUPZYRYCYBVIVJVKVLWGVMXSNNXTUIZYDVNEYEYMTXSUUBU
      URUUDABVOVQZXSYDXSUUIUUPYDQEZUUOUUQYBYCVRVSZVTDYDXTWAWBWCZXSYFARXSARJZOYD
      RYAKUVCYDRJXSUVCYDRYCIFRUVCYBRYCIUVCYBRHGRARHWDWEWFWHYCYCUUQWIWJWFWKXSRYA
      KLZUVCXSUURUVDUUSXTWLSPVLXSARWMZOZYFYCYAYBWRFZKLZUVFUVHYHYRUVGKLZUFZDNUGZ
      UVFUVJDNUVFYNOZYHUVIUVLYHOYSYAKLZUVIXSYNYHUVMUVEYPYJYSYAKUUGXSYNYHYJYAKLZ
      XSUURYNYHUVNUUSYGXTVDWNWOWPWQUVLUVMUVITZYHUVLUUHYAQEZUUIRYBWSLZUVOYNUUHUV
      FUUNWKXSUVPUVEYNXSYAVNEZUUTWTYAWSLZYEUVPXSUURUVRUUSXTXASUVAXSUURUVSUUSXTX
      BSUVBYAYDXHXCZVCXSUUIUVEYNUUOVCUVFUVQYNXSUVEUVQAXDXEZPYRYAYBXFXGPXIWGVMUV
      FUUBUVGVNEUVHUVKTUUDUVFUVGUVFYAYBXSUVPUVEUVTPZXSUUIUVEUUOPZXSYBRWMUVEXSYB
      RARAXJXKXLXMVTDUVGBWAXNWCUVFUUPUVPUUIUVQYFUVHTUUPUVFUUQXOUWBUWCUWAYCYAYBX
      FXGWCXRXSYAYDUVTUVAXPXQ $.

    $( The scalar product of a bounded linear operator is a bounded linear
       operator.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    bdophmi $p |- ( A e. CC -> ( A .op T ) e. BndLinOp ) $=
      ( cc wcel chot co clo cnop cfv cr cbo bdopln ax-mp lnopmi cabs cmul abscl
      nmophmi nmopre remulcl sylancl eqeltrd elbdop2 sylanbrc ) ADEZABFGZHEUGIJ
      ZKEUGLEABBLEZBHECBMNOUFUHAPJZBIJZQGZKABCSUFUJKEUKKEZULKEARUIUMCBTNUJUKUAU
      BUCUGUDUE $.
  $}

  ${
    $d n w x y z N $.  $d n y M $.  $d n w x y z T $.  $d x y S $.  $d y C $.
    lncon.1 $e |- ( T e. C -> S e. RR ) $.
    lncon.2 $e |- ( ( T e. C /\ y e. ~H ) ->
                    ( N ` ( T ` y ) ) <_ ( S x. ( normh ` y ) ) ) $.
    lncon.3 $e |- ( T e. C <-> A. x e. ~H A. z e. RR+ E. y e. RR+ A. w e. ~H
   ( ( normh ` ( w -h x ) ) < y -> ( N ` ( ( T ` w ) M ( T ` x ) ) ) < z ) ) $.
    lncon.4 $e |- ( y e. ~H -> ( N ` ( T ` y ) ) e. RR ) $.
    lncon.5 $e |- ( ( w e. ~H /\ x e. ~H ) ->
                    ( T ` ( w -h x ) ) = ( ( T ` w ) M ( T ` x ) ) ) $.
    $( Lemma for ~ lnopconi and ~ lnfnconi .  (Contributed by NM, 7-Feb-2006.)
       (New usage is discouraged.) $)
    lnconi $p |- ( T e. C <->
     E. x e. RR A. y e. ~H ( N ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) $=
      ( wcel cfv wbr chil cr wa vn cv cno cmul co cle wral wrex ralrimiva oveq1
      wceq breq2d ralbidv rspcev syl2anc cn arch adantr wi nnre simplll simpllr
      clt normcl adantl cc0 normge0 ltle imp lemul1ad simpll syl2an simplr letr
      remulcl syl3anc mpan2d ralimdva impancom an32s reximdva mpd rexlimiva cmv
      sylan2 crp cdiv simprr nnrpd rpdivcld simprll hvsubcl fveq2 fveq2d oveq2d
      breq12d rspcva sylan eleq1d vtoclga simprlr rpred lelttr adantlr mpand wb
      syl nnrp rpregt0d ltmuldiv2 breq1d 3imtr3d breq2 imbi1d ralrimivva sylibr
      anassrs impbii ) GEOZBUBZGPZIPZAUBZXTUCPZUDUEZUFQZBRUGZASUHZXSFSOYBFYDUDU
      EZUFQZBRUGZYHJXSYJBRKUIYGYKAFSYCFUKZYFYJBRYLYEYIYBUFYCFYDUDUJULUMUNUOYHYB
      UAUBZYDUDUEZUFQZBRUGZUAUPUHZXSYGYQASYCSOZYGTZYCYMVCQZUAUPUHZYQYRUUAYGYCUA
      UQURYSYTYPUAUPYMUPOZYSYMSOZYTYPUSZYMUTZYRUUCYGUUDYRUUCTZYTYGYPUUFYTTZYFYO
      BRUUGXTROZTZYFYEYNUFQZYOUUIYCYMYDYRUUCYTUUHVAYRUUCYTUUHVBUUHYDSOZUUGXTVDZ
      VEUUHVFYDUFQUUGXTVGVEUUGYCYMUFQZUUHUUFYTUUMYCYMVHVIURVJUUIYBSOZYESOZYNSOZ
      YFUUJTYOUSUUHUUNUUGMVEUUGYRUUKUUOUUHYRUUCYTVKUULYCYDVOVLUUGUUCUUKUUPUUHYR
      UUCYTVMUULYMYDVOVLYBYEYNVNVPVQVRVSVTWEWAWBWCYQDUBZYCWDUEZUCPZXTVCQZUUQGPY
      CGPHUEZIPZCUBZVCQZUSZDRUGZBWFUHZCWFUGARUGZXSYPUVHUAUPUUBYPTZUVGACRWFUVIYC
      ROZUVCWFOZTZTZUVCYMWGUEZWFOUUSUVNVCQZUVDUSZDRUGZUVGUVMUVCYMUVIUVJUVKWHUVM
      YMUUBYPUVLVKWIWJUVMUVPDRUVIUVLUUQROZUVPUVIUVLUVRTZTZYMUUSUDUEZUVCVCQZUURG
      PZIPZUVCVCQZUVOUVDUVTUWDUWAUFQZUWBUWEUUBUVSYPUWFUUBUVSTZUURROZYPUWFUWGUVR
      UVJUWHUUBUVLUVRWHZUUBUVJUVKUVRWKZUUQYCWLUOZYOUWFBUURRXTUURUKZYBUWDYNUWAUF
      UWLYAUWCIXTUURGWMWNZUWLYDUUSYMUDXTUURUCWMWOWPWQWRVTUUBUVSUWFUWBTUWEUSZYPU
      WGUWDSOZUWASOZUVCSOZUWNUWGUWHUWOUWKUUNUWOBUURRUWLYBUWDSUWMWSMWTXGUWGUUCUU
      SSOZUWPUUBUUCUVSUUEURUWGUWHUWRUWKUURVDXGZYMUUSVOUOUWGUVCUUBUVJUVKUVRXAXBZ
      UWDUWAUVCXCVPXDXEUUBUVSUWBUVOXFZYPUWGUWRUWQUUCVFYMVCQTZUXAUWSUWTUUBUXBUVS
      UUBYMYMXHXIURUUSUVCYMXJVPXDUVTUWDUVBUVCVCUVTUWCUVAIUUBUVSUWCUVAUKZYPUWGUV
      RUVJUXCUWIUWJNUOXDWNXKXLXQUIUVFUVQBUVNWFXTUVNUKZUVEUVPDRUXDUUTUVOUVDXTUVN
      UUSVCXMXNUMUNUOXOWCLXPXGXR $.
  $}

  ${
    $d n w x y z T $.
    lnopcon.1 $e |- T e. LinOp $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is linear.
       Theorem 3.5(iii) of [Beran] p. 99.  (Contributed by NM, 7-Feb-2006.)
       (Proof shortened by Mario Carneiro, 17-Nov-2013.)
       (New usage is discouraged.) $)
    lnopconi $p |- ( T e. ConOp <->
     E. x e. RR A. y e. ~H ( normh ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) $=
      ( vz vw ccop cnop cfv cmv cno wcel cr cv chil co wbr clt wral crp nmcopex
      clo mpan cmul cle nmcoplb mp3an1 wf wi wrex lnopfi elcnop ffvelrni normcl
      mpbiran syl lnopsubi lnconi ) ABEFGCHIZCJKCUBLZCGLZUSMLDCUAUCUTVABNZOLZVB
      CIZKIZUSVBKIUDPUEQDVBCUFUGVAOOCUHFNZANZJPKIVBRQVFCIVGCIJPKIENRQUIFOSBTUJE
      TSAOSCDUKZAEBFCULUOVCVDOLVEMLOOVBCVHUMVDUNUPVFVGCDUQUR $.
  $}

  ${
    $d x y T $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is linear.
       Theorem 3.5(iii) of [Beran] p. 99.  (Contributed by NM, 14-Feb-2006.)
       (New usage is discouraged.) $)
    lnopcon $p |- ( T e. LinOp -> ( T e. ConOp <->
   E. x e. RR A. y e. ~H ( normh ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) ) $=
      ( clo wcel ccop cv cfv cno cmul co cle wbr chil wral cr wrex wb cid cres
      cif wceq eleq1 fveq1 fveq2d breq1d rexralbidv bibi12d idlnop elimel dedth
      lnopconi ) CDEZCFEZBGZCHZIHZAGUOIHJKZLMZBNOAPQZRUMCSNTZUAZFEZUOVBHZIHZURL
      MZBNOAPQZRCVACVBUBZUNVCUTVGCVBFUCVHUSVFABPNVHUQVEURLVHUPVDIUOCVBUDUEUFUGU
      HABVBCVADUIUJULUK $.

    $( A linear operator is continuous iff it is bounded.  (Contributed by NM,
       14-Feb-2006.)  (New usage is discouraged.) $)
    lnopcnbd $p |- ( T e. LinOp -> ( T e. ConOp <-> T e. BndLinOp ) ) $=
      ( vy vx clo wcel ccop cbo cnop cfv cr nmcopex ex cv cno cmul cle wbr chil
      co wral elbdop2 baibr sylibd wrex nmopre nmbdoplb ralrimiva oveq1 ralbidv
      wceq breq2d rspcev syl2anc lnopcon syl5ibr impbid ) ADEZAFEZAGEZUQURAHIZJ
      EZUSUQURVAAKLUSUQVAAUAUBUCUSURUQBMZAINIZCMZVBNIZOSZPQZBRTZCJUDZUSVAVCUTVE
      OSZPQZBRTZVIAUEUSVKBRVBAUFUGVHVLCUTJVDUTUJZVGVKBRVMVFVJVCPVDUTVEOUHUKUIUL
      UMCBAUNUOUP $.
  $}

  $( A continuous linear operator is a bounded linear operator.  This theorem
     justifies our use of "bounded linear" as an interchangeable condition for
     "continuous linear" used in some textbook proofs.  (Contributed by NM,
     18-Feb-2006.)  (New usage is discouraged.) $)
  lncnopbd $p |- ( T e. ( LinOp i^i ConOp ) <-> T e. BndLinOp ) $=
    ( clo ccop cin wcel wa cbo lnopcnbd biimpa bdopln biimparc mpdan jca impbii
    elin bitri ) ABCDEABEZACEZFZAGEZABCOSTQRTAHZITQRAJZTQRUBQRTUAKLMNP $.

  $( A continuous linear operator is a bounded linear operator.  (Contributed
     by NM, 18-Feb-2006.)  (New usage is discouraged.) $)
  lncnbd $p |- ( LinOp i^i ConOp ) = BndLinOp $=
    ( vt clo ccop cin cbo cv lncnopbd eqriv ) ABCDEAFGH $.

  $( A linear operator is continuous iff it is bounded.  (Contributed by NM,
     14-Feb-2006.)  (New usage is discouraged.) $)
  lnopcnre $p |- ( T e. LinOp -> ( T e. ConOp <-> ( normop ` T ) e. RR ) ) $=
    ( clo wcel ccop cbo cnop cfv cr lnopcnbd elbdop2 baib bitrd ) ABCZADCAECZAF
    GHCZAINMOAJKL $.

  ${
    $d x y z T $.
    lnfnl.1 $e |- T e. LinFn $.
    $( Basic property of a linear Hilbert space functional.  (Contributed by
       NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    lnfnli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( ( A .h B ) +h C ) ) = ( ( A x. ( T ` B ) ) + ( T ` C ) ) ) $=
      ( cc wcel chil csm co cva cfv cmul caddc wceq clf wa lnfnl mpanl1 3impb )
      AFGZBHGZCHGZABIJCKJDLABDLMJCDLNJOZDPGUAUBUCQUDEABCDRST $.

    $( A linear Hilbert space functional is a functional.  (Contributed by NM,
       11-Feb-2006.)  (New usage is discouraged.) $)
    lnfnfi $p |- T : ~H --> CC $=
      ( clf wcel chil cc wf lnfnf ax-mp ) ACDEFAGBAHI $.

    $( The value of a linear Hilbert space functional at zero is zero.  Remark
       in [Beran] p. 99.  (Contributed by NM, 11-Feb-2006.)
       (New usage is discouraged.) $)
    lnfn0i $p |- ( T ` 0h ) = 0 $=
      ( c0v cfv caddc co cmin cc0 wcel wceq chil ax-hv0cl lnfnfi ffvelrni ax-mp
      cc c1 ax-1cn eqtr3i oveq1i pncan mp2an cmul csm cva lnfnli mp3an hvmulcli
      ax-hvaddid ax-hvmulid eqtri fveq2i mulid2i subidi ) CADZUOEFZUOGFZUOHUOPI
      ZURUQUOJCKIZURLKPCAABMNOZUTUOUOUAUBUOUOGFUQHUOUPUOGQUOUCFZUOEFZUOUPQCUDFZ
      CUEFZADZVBUOQPIUSUSVEVBJRLLQCCABUFUGVDCAVDVCCVCKIVDVCJQCRLUHVCUIOUSVCCJLC
      UJOUKULSVAUOUOEUOUTUMTSTUOUTUNSS $.

    $( Additive property of a linear Hilbert space functional.  (Contributed by
       NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    lnfnaddi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A +h B ) ) = ( ( T ` A ) + ( T ` B ) ) ) $=
      ( chil wcel wa c1 csm cva cfv cmul caddc wceq ax-1cn lnfnli oveq1d adantr
      co cc mp3an1 ax-hvmulid fveq2d lnfnfi ffvelrni mulid2d 3eqtr3d ) AEFZBEFZ
      GZHAISZBJSZCKZHACKZLSZBCKZMSZABJSZCKZUNUPMSHTFUHUIUMUQNOHABCDPUAUHUMUSNUI
      UHULURCUHUKABJAUBQUCRUJUOUNUPMUHUOUNNUIUHUNETACCDUDUEUFRQUG $.

    $( Multiplicative property of a linear Hilbert space functional.
       (Contributed by NM, 11-Feb-2006.)  (New usage is discouraged.) $)
    lnfnmuli $p |- ( ( A e. CC /\ B e. ~H ) ->
         ( T ` ( A .h B ) ) = ( A x. ( T ` B ) ) ) $=
      ( cc wcel chil wa csm co c0v cva cfv cmul wceq ax-hv0cl lnfnli mp3an3 cc0
      caddc hvmulcl ax-hvaddid syl fveq2d lnfn0i oveq2i lnfnfi ffvelrni addid1d
      mulcl sylan2 syl5eq 3eqtr3d ) AEFZBGFZHZABIJZKLJZCMZABCMZNJZKCMZTJZUQCMVA
      UNUOKGFUSVCOPABKCDQRUPURUQCUPUQGFURUQOABUAUQUBUCUDUPVCVASTJVAVBSVATCDUEUF
      UPVAUOUNUTEFVAEFGEBCCDUGUHAUTUJUKUIULUM $.

    $( Sum/product property of a linear Hilbert space functional.  (Contributed
       by NM, 13-Feb-2006.)  (New usage is discouraged.) $)
    lnfnaddmuli $p |- ( ( A e. CC /\ B e. ~H /\ C e. ~H ) ->
         ( T ` ( B +h ( A .h C ) ) ) = ( ( T ` B ) + ( A x. ( T ` C ) ) ) ) $=
      ( cc wcel chil w3a csm co cva cfv caddc cmul wceq hvmulcl lnfnaddi sylan2
      wa 3impb 3com12 lnfnmuli 3adant2 oveq2d eqtrd ) AFGZBHGZCHGZIZBACJKZLKDMZ
      BDMZUKDMZNKZUMACDMOKZNKUHUGUIULUOPZUHUGUIUQUGUITUHUKHGUQACQBUKDERSUAUBUJU
      NUPUMNUGUIUNUPPUHACDEUCUDUEUF $.

    $( Subtraction property for a linear Hilbert space functional.
       (Contributed by NM, 13-Feb-2006.)  (New usage is discouraged.) $)
    lnfnsubi $p |- ( ( A e. ~H /\ B e. ~H ) ->
         ( T ` ( A -h B ) ) = ( ( T ` A ) - ( T ` B ) ) ) $=
      ( chil wcel wa c1 cneg csm co cva cfv cmul caddc cmv cmin wceq ffvelrni
      cc neg1cn mp3an1 hvsubval fveq2d lnfnfi mulm1 oveq2d adantl negsub eqtr2d
      lnfnaddmuli syl2an 3eqtr4d ) AEFZBEFZGZAHIZBJKLKZCMZACMZUQBCMZNKZOKZABPKZ
      CMUTVAQKZUQTFUNUOUSVCRUAUQABCDUKUBUPVDURCABUCUDUNUTTFZVATFZVEVCRUOETACCDU
      EZSETBCVHSVFVGGVCUTVAIZOKZVEVGVCVJRVFVGVBVIUTOVAUFUGUHUTVAUIUJULUM $.
  $}

  $( The value of a linear Hilbert space functional at zero is zero.  Remark in
     [Beran] p. 99.  (Contributed by NM, 25-Apr-2006.)
     (New usage is discouraged.) $)
  lnfn0 $p |- ( T e. LinFn -> ( T ` 0h ) = 0 ) $=
    ( clf wcel c0v cfv cc0 wceq chil csn fveq1 eqeq1d 0lnfn elimel lnfn0i dedth
    cxp cif ) ABCZDAEZFGDRAHFIPZQZEZFGATAUAGSUBFDAUAJKUAATBLMNO $.

  $( Multiplicative property of a linear Hilbert space functional.
     (Contributed by NM, 30-May-2006.)  (New usage is discouraged.) $)
  lnfnmul $p |- ( ( T e. LinFn /\ A e. CC /\ B e. ~H ) ->
                 ( T ` ( A .h B ) ) = ( A x. ( T ` B ) ) ) $=
    ( clf wcel cc chil csm co cfv cmul wceq wa wi cc0 csn cxp cif fveq1 oveq2d
    eqeq12d imbi2d 0lnfn elimel lnfnmuli dedth 3impib ) CDEZAFEZBGEZABHIZCJZABC
    JZKIZLZUHUIUJMZUONUPUKUHCGOPQZRZJZABURJZKIZLZNCUQCURLZUOVBUPVCULUSUNVAUKCUR
    SVCUMUTAKBCURSTUAUBABURCUQDUCUDUEUFUG $.

  ${
    nmbdfnlb.1 $e |- ( T e. LinFn /\ ( normfn ` T ) e. RR ) $.
    $( A lower bound for the norm of a bounded linear functional.  (Contributed
       by NM, 25-Apr-2006.)  (New usage is discouraged.) $)
    nmbdfnlbi $p |- ( A e. ~H ->
                ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
      ( chil wcel cfv cabs cno cmul co cle wbr c0v wceq cr c1 cc adantr syl2anc
      cc0 cnmf fveq2 clf simpli lnfn0i syl6eq abs00bd norm0 oveq2d simpri recni
      0le0 mul01i syl6req syl5breq eqbrtrd adantl wne wa cdiv csm lnfnfi abscld
      ffvelrni normcl normne0 biimpar divrec2d rereccld lnfnmuli fveq2d absmuld
      recnd simpl clt normgt0 biimpa recgt0d wi ltle mpan absidd oveq1d 3eqtrrd
      0re sylc eqtrd hvmulcl norm1 eqle wf nmfnlb mp3an1 wb ledivmul2 syl112anc
      syl a1i mpbid pm2.61dane ) ADEZABFZGFZBUAFZAHFZIJZKLZAMAMNZXGXAXHXCTXFKXH
      XBXHXBMBFTAMBUBBBUCEZXDOEZCUDZUEUFUGXHTTXFKULXHXFXDTIJTXHXETXDIXHXEMHFTAM
      HUBUHUFUIXDXDXIXJCUJZUKUMUNUOUPUQXAAMURZUSZXCXEUTJZXDKLZXGXNXOPXEUTJZAVAJ
      ZBFZGFZXDKXNXOXQXCIJZXTXNXCXEXNXCXAXCOEZXMXAXBDQABBXKVBZVDZVCRZVMXNXEXAXE
      OEZXMAVERZVMXAXETURXMAVFVGZVHXNXTXQXBIJZGFXQGFZXCIJYAXNXSYIGXNXQQEZXAXSYI
      NXNXQXNXEYGYHVIZVMZXAXMVNZXQABXKVJSVKXNXQXBYMXAXBQEXMYDRVLXNYJXQXCIXNXQYL
      XNXQOEZTXQVOLZTXQKLZYLXNXEYGXAXMTXEVOLZAVPVQZVRTOEYOYPYQVSWETXQVTWAWFWBWC
      WDWGXNXRDEZXRHFZPKLZXTXDKLZXNYKXAYTYMYNXQAWHSZXNUUAOEZUUAPNUUBXNYTUUEUUDX
      RVEWQAWIUUAPWJSDQBWKYTUUBUUCYCXRBWLWMSUPXNYBXJYFYRXPXGWNYEXJXNXLWRYGYSXCX
      DXEWOWPWSWT $.
  $}

  $( A lower bound for the norm of a bounded linear functional.  (Contributed
     by NM, 25-Apr-2006.)  (New usage is discouraged.) $)
  nmbdfnlb $p |- ( ( T e. LinFn /\ ( normfn ` T ) e. RR /\ A e. ~H ) ->
              ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
    ( clf wcel cnmf cfv cr chil cabs cmul co cle wbr wa wi cc0 wceq fveq2 eleq1
    eleq1d cno csn cxp cif fveq1 fveq2d oveq1d breq12d imbi2d anbi12d 0lnfn 0re
    nmfn0 eqeltri pm3.2i elimhyp nmbdfnlbi dedth 3impia ) BCDZBEFZGDZAHDZABFZIF
    ZVAAUAFZJKZLMZUTVBNZVCVHOVCAVIBHPUBUCZUDZFZIFZVKEFZVFJKZLMZOBVJBVKQZVHVPVCV
    QVEVMVGVOLVQVDVLIABVKUEUFVQVAVNVFJBVKERZUGUHUIAVKVIVKCDZVNGDZNVJCDZVJEFZGDZ
    NBVJVQUTVSVBVTBVKCSVQVAVNGVRTUJVJVKQZWAVSWCVTVJVKCSWDWBVNGVJVKERTUJWAWCUKWB
    PGUMULUNUOUPUQURUS $.

  ${
    $d m x y z T $.
    nmcfnex.1 $e |- T e. LinFn $.
    nmcfnex.2 $e |- T e. ConFn $.
    $( The norm of a continuous linear Hilbert space functional exists.
       Theorem 3.5(i) of [Beran] p. 99.  (Contributed by NM, 14-Feb-2006.)
       (Proof shortened by Mario Carneiro, 17-Nov-2013.)
       (New usage is discouraged.) $)
    nmcfnexi $p |- ( normfn ` T ) e. RR $=
      ( vx vy vz vm cabs cv co cfv clt wbr c1 chil crp wcel cc0 cc wceq c0v cmv
      cnmf cno cmin wi wral ccnfn ax-hv0cl 1rp cnfnc mp3an hvsub0 fveq2d breq1d
      wrex lnfn0i oveq2i lnfnfi ffvelrni subid1d syl5eq imbi12d ralbiia mpbi wf
      rexbii cle wa cab cxr csup nmfnval ax-mp abscld fveq2i abs0 eqtri c2 cdiv
      cmul rpcn lnfnmuli sylan absmul syl2an rpge0 absidd adantr oveq1d 3eqtrrd
      csm rpre nmcexi ) DEFUCAGHFIZUAUBJZUDKZEIZLMZWOAKZUAAKZUEJZHKZNLMZUFZFOUG
      ZEPUPZWOUDKZWRLMZWTHKZNLMZUFZFOUGZEPUPAUHQUAOQNPQXGCUIUJEFUANAUKULXFXMEPX
      EXLFOWOOQZWSXIXDXKXNWQXHWRLXNWPWOUDWOUMUNUOXNXCXJNLXNXBWTHXNXBWTRUEJWTXAR
      WTUEABUQZURXNWTOSWOAABUSZUTVAVBUNUOVCVDVGVEOSAVFAUCKDIZUDKNVHMGIXQAKZHKZT
      VIDOUPGVJVKLVLTXPGDAVMVNXQOQZXROSXQAXPUTZVOXAHKRHKRXARHXOVPVQVRWRVSVTJZPQ
      ZXTVIZYBXQWLJAKZHKYBXRWAJZHKZYBHKZXSWAJZYBXSWAJYDYEYFHYCYBSQZXTYEYFTYBWBZ
      YBXQABWCWDUNYCYJXRSQYGYITXTYKYAYBXRWEWFYDYHYBXSWAYCYHYBTXTYCYBYBWMYBWGWHW
      IWJWKWN $.

    $( A lower bound for the norm of a continuous linear functional.  Theorem
       3.5(ii) of [Beran] p. 99.  (Contributed by NM, 14-Feb-2006.)
       (New usage is discouraged.) $)
    nmcfnlbi $p |- ( A e. ~H ->
                ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
      ( chil wcel c0v wceq cfv cabs cno cmul co cle wbr cc0 c1 cr cc syl2anc wn
      cnmf fveq2 lnfn0i syl6eq abs00bd 0le0 norm0 oveq2d nmcfnexi recni syl6req
      mul01i syl5breq eqbrtrd adantl wa csm lnfnfi ffvelrni abscld adantr recnd
      cdiv normcl norm-i notbid biimpar divrec2d rereccld simpl lnfnmuli fveq2d
      neneqad absmuld clt wne df-ne normgt0 syl5bbr biimpa recgt0d wi ltle mpan
      0re sylc absidd oveq1d 3eqtrrd eqtrd hvmulcl syl norm1 sylan2br wf nmfnlb
      eqle mp3an1 wb a1i ledivmul2 syl112anc mpbid pm2.61dan ) AEFZAGHZABIZJIZB
      UBIZAKIZLMZNOZXGXMXFXGXIPXLNXGXHXGXHGBIPAGBUCBCUDUEUFXGPPXLNUGXGXLXJPLMPX
      GXKPXJLXGXKGKIPAGKUCUHUEUIXJXJBCDUJZUKUMULUNUOUPXFXGUAZUQZXIXKVDMZXJNOZXM
      XPXQQXKVDMZAURMZBIZJIZXJNXPXQXSXILMZYBXPXIXKXPXIXFXIRFZXOXFXHESABBCUSZUTZ
      VAVBZVCXPXKXFXKRFZXOAVEVBZVCXPXKPXFXKPHZUAXOXFYJXGAVFVGVHVNZVIXPYBXSXHLMZ
      JIXSJIZXILMYCXPYAYLJXPXSSFZXFYAYLHXPXSXPXKYIYKVJZVCZXFXOVKZXSABCVLTVMXPXS
      XHYPXFXHSFXOYFVBVOXPYMXSXILXPXSYOXPXSRFZPXSVPOZPXSNOZYOXPXKYIXFXOPXKVPOZX
      OAGVQZXFUUAAGVRZAVSVTWAZWBPRFYRYSYTWCWFPXSWDWEWGWHWIWJWKXPXTEFZXTKIZQNOZY
      BXJNOZXPYNXFUUEYPYQXSAWLTZXPUUFRFZUUFQHZUUGXPUUEUUJUUIXTVEWMXOXFUUBUUKUUC
      AWNWOUUFQWRTESBWPUUEUUGUUHYEXTBWQWSTUOXPYDXJRFZYHUUAXRXMWTYGUULXPXNXAYIUU
      DXIXJXKXBXCXDXE $.
  $}

  $( The norm of a continuous linear Hilbert space functional exists.  Theorem
     3.5(i) of [Beran] p. 99.  (Contributed by NM, 14-Feb-2006.)
     (New usage is discouraged.) $)
  nmcfnex $p |- ( ( T e. LinFn /\ T e. ConFn ) -> ( normfn ` T ) e. RR ) $=
    ( clf wcel ccnfn wa cin cnmf cfv cr elin chil cc0 csn cxp wceq fveq2 eleq1d
    cif 0lnfn 0cnfn mpbir2an elimel mpbi simpli simpri nmcfnexi dedth sylbir )
    ABCADCEABDFZCZAGHZICZABDJUJULUJAKLMNZRZGHZICAUMAUNOUKUOIAUNGPQUNUNBCZUNDCZU
    NUICUPUQEAUMUIUMUICUMBCUMDCSTUMBDJUAUBUNBDJUCZUDUPUQURUEUFUGUH $.

  $( A lower bound of the norm of a continuous linear Hilbert space
     functional.  Theorem 3.5(ii) of [Beran] p. 99.  (Contributed by NM,
     14-Feb-2006.)  (New usage is discouraged.) $)
  nmcfnlb $p |- ( ( T e. LinFn /\ T e. ConFn /\ A e. ~H ) ->
                ( abs ` ( T ` A ) ) <_ ( ( normfn ` T ) x. ( normh ` A ) ) ) $=
    ( clf wcel ccnfn chil cfv cabs cnmf cno cmul co cle wbr wa cin elin cc0 csn
    wi cxp cif wceq fveq1 fveq2d fveq2 oveq1d breq12d imbi2d 0lnfn 0cnfn elimel
    mpbir2an mpbi simpli simpri nmcfnlbi dedth imp sylanbr 3impa ) BCDZBEDZAFDZ
    ABGZHGZBIGZAJGZKLZMNZVBVCOBCEPZDZVDVJBCEQVLVDVJVLVDVJTVDAVLBFRSUAZUBZGZHGZV
    NIGZVHKLZMNZTBVMBVNUCZVJVSVDVTVFVPVIVRMVTVEVOHABVNUDUEVTVGVQVHKBVNIUFUGUHUI
    AVNVNCDZVNEDZVNVKDWAWBOBVMVKVMVKDVMCDVMEDUJUKVMCEQUMULVNCEQUNZUOWAWBWCUPUQU
    RUSUTVA $.

  ${
    $d x y z w v u T $.
    lnfncon.1 $e |- T e. LinFn $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is linear.
       Theorem 3.5(iii) of [Beran] p. 99.  (Contributed by NM, 14-Feb-2006.)
       (Proof shortened by Mario Carneiro, 17-Nov-2013.)
       (New usage is discouraged.) $)
    lnfnconi $p |- ( T e. ConFn <->
       E. x e. RR A. y e. ~H ( abs ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) $=
      ( vz vw ccnfn cfv cmin cabs wcel cv chil cno co wbr cc clt wral crp cr wf
      cnmf clf nmcfnex mpan cmul cle nmcfnlb mp3an1 cmv wi wrex lnfnfi ffvelrni
      elcnfn mpbiran abscld lnfnsubi lnconi ) ABEFGCUCHZCIJCUDKZCGKZVAUAKDCUEUF
      VBVCBLZMKZVDCHZJHVAVDNHUGOUHPDVDCUIUJVCMQCUBFLZALZUKONHVDRPVGCHVHCHIOJHEL
      RPULFMSBTUMETSAMSCDUNZAEBFCUPUQVEVFMQVDCVIUOURVGVHCDUSUT $.
  $}

  ${
    $d x y T $.
    $( A condition equivalent to " ` T ` is continuous" when ` T ` is linear.
       Theorem 3.5(iii) of [Beran] p. 99.  (Contributed by NM, 16-Feb-2006.)
       (New usage is discouraged.) $)
    lnfncon $p |- ( T e. LinFn -> ( T e. ConFn <->
     E. x e. RR A. y e. ~H ( abs ` ( T ` y ) ) <_ ( x x. ( normh ` y ) ) ) ) $=
      ( clf wcel ccnfn cv cfv cabs cno cmul co cle wbr chil wral cr wrex wb cc0
      csn cxp wceq eleq1 fveq1 fveq2d breq1d rexralbidv bibi12d elimel lnfnconi
      cif 0lnfn dedth ) CDEZCFEZBGZCHZIHZAGUQJHKLZMNZBOPAQRZSUOCOTUAUBZULZFEZUQ
      VDHZIHZUTMNZBOPAQRZSCVCCVDUCZUPVEVBVICVDFUDVJVAVHABQOVJUSVGUTMVJURVFIUQCV
      DUEUFUGUHUIABVDCVCDUMUJUKUN $.

    $( A linear functional is continuous iff it is bounded.  (Contributed by
       NM, 25-Apr-2006.)  (New usage is discouraged.) $)
    lnfncnbd $p |- ( T e. LinFn ->
                    ( T e. ConFn <-> ( normfn ` T ) e. RR ) ) $=
      ( vy vx clf wcel ccnfn cnmf cfv cr nmcfnex ex cv cabs cno cmul co cle wbr
      chil wral wrex wa simpr nmbdfnlb 3expa ralrimiva wceq oveq1 breq2d rspcev
      ralbidv syl2anc lnfncon sylibrd impbid ) ADEZAFEZAGHZIEZUPUQUSAJKUPUSBLZA
      HMHZCLZUTNHZOPZQRZBSTZCIUAZUQUPUSVGUPUSUBZUSVAURVCOPZQRZBSTZVGUPUSUCVHVJB
      SUPUSUTSEVJUTAUDUEUFVFVKCURIVBURUGZVEVJBSVLVDVIVAQVBURVCOUHUIUKUJULKCBAUM
      UNUO $.
  $}

  ${
    $d u v x y T $.  $d u v x y A $.
    rnelsh.1 $e |- T e. LinOp $.
    ${
      imaelsh.2 $e |- A e. SH $.
      $( The image of a subspace under a linear operator is a subspace.
         (Contributed by Mario Carneiro, 19-May-2014.)
         (New usage is discouraged.) $)
      imaelshi $p |- ( T " A ) e. SH $=
        ( vu vv vx vy wcel chil wss c0v wa cv cva co wral ax-mp cfv mp2an cc wf
        cima csh csm crn imassrn lnopfi frn sstri lnop0i sh0 wfun cdm wi shssii
        ffun fdmi sseqtr4i funfvima2 eqeltrri pm3.2i wfn ffn wceq oveq1 ralbidv
        wb eleq1d ralima sheli lnopaddi syl2an shaddcl eqeltrrd ralrimiva oveq2
        mp3an1 syl sylibr mprgbir lnopmuli sylan2 shmulcl rgen issh2 mpbir2an )
        BAUCZUDIWHJKZLWHIZMENZFNZOPZWHIZFWHQZEWHQZWKWLUEPZWHIZFWHQZEUAQZMWIWJWH
        BUFZJBAUGJJBUBZXAJKBCUHZJJBUIRUJLBSZLWHBCUKLAIZXDWHIZAUDIZXEDAULRBUMZAB
        UNZKZXEXFUOXBXHXCJJBUQRZAJXIADUPZJJBXCURUSZALBUTTRVAVBWPWTWPGNZBSZWLOPZ
        WHIZFWHQZGABJVCZAJKZWPXRGAQVHXBXSXCJJBVDRZXLWOXREGJABWKXOVEZWNXQFWHYBWM
        XPWHWKXOWLOVFVIVGVJTXNAIZXOHNZBSZOPZWHIZHAQZXRYCYGHAYCYDAIZMZXNYDOPZBSZ
        YFWHYCXNJIYDJIZYLYFVEYIXNADVKYDADVKZXNYDBCVLVMYJYKAIZYLWHIZXGYCYIYODXNY
        DAVNVRXHXJYOYPUOXKXMAYKBUTTVSVOVPXSXTXRYHVHYAXLXQYGFHJABWLYEVEZXPYFWHWL
        YEXOOVQVIVJTVTWAWSEUAWKUAIZWKYEUEPZWHIZHAQZWSYRYTHAYRYIMZWKYDUEPZBSZYSW
        HYIYRYMUUDYSVEYNWKYDBCWBWCUUBUUCAIZUUDWHIZXGYRYIUUEDWKYDAWDVRXHXJUUEUUF
        UOXKXMAUUCBUTTVSVOVPXSXTWSUUAVHYAXLWRYTFHJABYQWQYSWHWLYEWKUEVQVIVJTVTWE
        VBEFWHWFWG $.
    $}

    $( The range of a linear operator is a subspace.  (Contributed by Mario
       Carneiro, 17-Nov-2013.)  (New usage is discouraged.) $)
    rnelshi $p |- ran T e. SH $=
      ( cdm cima crn imadmrn chil lnopfi fdmi helsh eqeltri imaelshi eqeltrri
      csh ) AACZDAENAFOABOGNGGAABHIJKLM $.
  $}

  ${
    $d x y T $.
    nlelsh.1 $e |- T e. LinFn $.
    $( The null space of a linear functional is a subspace.  (Contributed by
       NM, 11-Feb-2006.)  (Revised by Mario Carneiro, 17-Nov-2013.)
       (New usage is discouraged.) $)
    nlelshi $p |- ( null ` T ) e. SH $=
      ( vx vy cfv wcel c0v cv co wral cc wa chil cc0 wceq wb elnlfn ax-mp caddc
      cmul cnl csh cva csm ax-hv0cl lnfn0i wf lnfnfi mpbir2an cdm ccnv csn cima
      nlfnval cnvimass eqsstri sseqtri sseli hvaddcl lnfnaddi simprbi oveqan12d
      fdmi syl2an eqtrd 00id syl6eq sylanbrc rgen2 sylan2 lnfnmuli oveq2d mul01
      hvmulcl sylan9eqr pm3.2i wss issh3 ) AUAEZUBFZGVSFZCHZDHZUCIZVSFZDVSJCVSJ
      ZWBWCUDIZVSFZDVSJCKJZLZWAGMFZGAENOZUEABUFMKAUGZWAWKWLLPABUHZGAQRUIWFWIWEC
      DVSVSWBVSFZWCVSFZLZWDMFZWDAEZNOZWEWOWBMFZWCMFZWRWPVSMWBVSAUJZMVSAUKNULZUM
      ZXCWMVSXEOWNAUNRAXDUOUPMKAWNVCUQZURZVSMWCXFURZWBWCUSVDWQWSNNSIZNWQWSWBAEZ
      WCAEZSIZXIWOXAXBWSXLOWPXGXHWBWCABUTVDWOWPXJNXKNSWOXAXJNOZWMWOXAXMLPWNWBAQ
      RVAWPXBXKNOZWMWPXBXNLPWNWCAQRVAZVBVEVFVGWMWEWRWTLPWNWDAQRVHVIWHCDKVSWBKFZ
      WPLZWGMFZWGAEZNOZWHWPXPXBXRXHWBWCVNVJXQXSWBXKTIZNWPXPXBXSYAOXHWBWCABVKVJW
      PXPYAWBNTINWPXKNWBTXOVLWBVMVOVEWMWHXRXTLPWNWGAQRVHVIVPVSMVQVTWAWJLPXFCDVS
      VRRUI $.
  $}

  ${
    $d f n u v w x T $.
    nlelch.1 $e |- T e. LinFn $.
    nlelch.2 $e |- T e. ConFn $.
    $( The null space of a continuous linear functional is a closed subspace.
       Remark 3.8 of [Beran] p. 103.  (Contributed by NM, 11-Feb-2006.)  (Proof
       shortened by Mario Carneiro, 19-May-2014.)
       (New usage is discouraged.) $)
    nlelchi $p |- ( null ` T ) e. CH $=
      ( vf vx vn cfv wcel cn cv wf chli wbr wa chil cc0 wceq eqid a1i cc cnl wi
      cch csh wal nlelshi vex hlimveci adantl ccom ccnfld cha cnfldhaus cno cmv
      ctopn cmopn clm cmap co cres cva csm hhims hhlm resss eqsstri ssbri ccnfn
      cop ccn hhcnf eleqtri lmcn csn cxp lnfnfi ffvelrn adantlr elnlfn2 sylancr
      wral fvco3 c0ex fvconst2 3eqtr4d ralrimiva wfn ffn ax-mp wss simpl shssii
      wb fss sylancl fnfco fconst eqfnfv mpbird ctopon c1 cz cnfldtopon 1z nnuz
      0cn lmconst syl3anc eqbrtrd lmmo elnlfn sylanbrc gen2 isch2 mpbir2an ) AU
      AGZUCHXQUDHIXQDJZKZXREJZLMZNZXTXQHZUBZEUEDUEABUFZYDDEYBXTOHZXTAGZPQZYCYAY
      FXSXTXREUGUHUIYBYGPAXRUJZUKUPGZYJULHYBYJYJRZUMSYBXTXRAUNUOUJZUQGZYJYAXRXT
      YMURGZMXSLYNXRXTLYNOIUSUTZVAYNYLVBVCVJUNVJZYMYPRZYLYPYQYLRZVDYMRZVEYNYOVF
      VGVHUIAYMYJVKUTZHYBAVIYTCYLYMYJYRYSYKVLVMSVNYBYIIPVOZVPZPYJURGZYBYIUUBQZF
      JZYIGZUUEUUBGZQZFIWBZYBUUHFIYBUUEIHZNZUUEXRGZAGZPUUFUUGUUKOTAKZUULXQHZUUM
      PQABVQZXSUUJUUOYAIXQUUEXRVRVSUULAVTWAXSUUJUUFUUMQYAIXQUUEAXRWCVSUUJUUGPQY
      BIPUUEWDWEUIWFWGYBYIIWHZUUBIWHZUUDUUIWNYBAOWHZIOXRKZUUQUUNUUSUUPOTAWIWJYB
      XSXQOWKUUTXSYAWLXQYEWMIXQOXRWOWPOIAXRWQWAIUUAUUBKUURIPWDWRIUUAUUBWIWJFIYI
      UUBWSWPWTYBYJTXAGHZPTHZXBXCHZUUBPUUCMUVAYBYJYKXDSUVBYBXGSUVCYBXESPYJXBTIX
      FXHXIXJXKUUNYCYFYHNWNUUPXTAXLWJXMXNEDXQXOXP $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Riesz lemma
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( A continuous linear functional can be expressed as an inner product.
       Existence part of Theorem 3.9 of [Beran] p. 104.  (Contributed by NM,
       13-Feb-2006.)  (New usage is discouraged.) $)
    riesz3i $p |- E. w e. ~H A. v e. ~H ( T ` v ) = ( v .ih w ) $=
      ( cfv csp co wceq chil c0h c0v wcel wa cc0 cc adantr cmul cmin syl3anc vu
      cv wral wrex cnl cort ax-hv0cl wf lnfnfi fveq2 nlelchi ococi choc0 eleq2d
      3eqtr3g biimpar elnlfn2 sylancr hi02 adantl eqtr4d ralrimiva oveq2 eqeq2d
      ralbidv rspcev wne choccli chne0i cheli cdiv ccj csm ffvelrni hicl anidms
      wi his6 necon3bid divcld cjcld simpl hvmulcl syl2anc adantll sylan ancoms
      cmv his2sub simpr ax-his3 oveq12d eqtr2d hvsubcl lnfnsubi lnfnmuli mulcom
      sylan2 eqtrd mulcl syl2an subidd 3eqtrd wb elnlfn ax-mp wss chssii ocorth
      sylanbrc anassrs mulcld syl2anr subeq0ad mpbid adantlr jca divmul3 mpbird
      adantlll div23 simpll his52 eqtr3d ex mpdan rexlimiv sylbi pm2.61ine ) BU
      BZCFZYJAUBZGHZIZBJUCZAJUDZCUEFZUFFZKYRKIZLJMYKYJLGHZIZBJUCZYPUGYSUUABJYSY
      JJMZNZYKOYTUUDJPCUHZYJYQMZYKOICDUIZYSUUFUUCYSYQJYJYSYRUFFKUFFYQJYRKUFUJYQ
      CDEUKZULUMUOUNUPYJCUQURUUCYTOIYSYJUSUTVAVBYOUUBALJYLLIZYNUUABJUUIYMYTYKYL
      LYJGVCVDVEVFURYRKVGUAUBZLVGZUAYRUDYPUAYRYQUUHVHZVIUUKYPUAYRUUJYRMZUUJJMZU
      UKYPVQUUJYRUULVJUUMUUNNZUUKYPUUOUUKNZUUJCFZUUJUUJGHZVKHZVLFZUUJVMHZJMZYKY
      JUVAGHZIZBJUCZYPUUNUUKUVBUUMUUNUUKNZUUTPMUUNUVBUVFUUSUVFUUQUURUUNUUQPMZUU
      KJPUUJCUUGVNZQZUUNUURPMZUUKUUNUVJUUJUUJVOVPZQZUUNUUROVGZUUKUUNUUROUUJLUUJ
      VRVSUPZVTZWAUUNUUKWBUUTUUJWCWDWEUUPUVDBJUUPUUCNZUUQYJUUJGHZRHZUURVKHZYKUV
      CUVPUVSYKIZUVRYKUURRHZIZUUOUUCUWBUUKUUOUUCNZUVRUWASHZOIZUWBUWCUWDUUQYJVMH
      ZYKUUJVMHZWHHZUUJGHZOUUNUUCUWDUWIIUUMUUNUUCNZUWIUWFUUJGHZUWGUUJGHZSHZUWDU
      WJUWFJMZUWGJMZUUNUWIUWMIUUNUVGUUCUWNUVHUUQYJWCWFZUUCUUNUWOUUCYKPMZUUNUWOJ
      PYJCUUGVNZYKUUJWCWFWGZUUNUUCWBZUWFUWGUUJWITUWJUWKUVRUWLUWASUWJUVGUUCUUNUW
      KUVRIUUNUVGUUCUVHQZUUNUUCWJUWTUUQYJUUJWKTUWJUWQUUNUUNUWLUWAIUUCUWQUUNUWRU
      TUWTUWTYKUUJUUJWKTWLWMWEUUMUUNUUCUWIOIZUWJUUMUXBUWJUWHYQMZUUMUXBUWJUWHJMZ
      UWHCFZOIZUXCUWJUWNUWOUXDUWPUWSUWFUWGWNWDUWJUXEUWFCFZUWGCFZSHZUUQYKRHZUXJS
      HOUWJUWNUWOUXEUXIIUWPUWSUWFUWGCDWOWDUWJUXGUXJUXHUXJSUUNUVGUUCUXGUXJIUVHUU
      QYJCDWPWFUUCUUNUXHUXJIZUUCUWQUUNUXKUWRUWQUUNNUXHYKUUQRHZUXJYKUUJCDWPUUNUW
      QUVGUXLUXJIUVHYKUUQWQWRWSWFWGWLUWJUXJUUNUVGUWQUXJPMUUCUVHUWRUUQYKWTXAXBXC
      UUEUXCUXDUXFNXDUUGUWHCXEXFXJYQJXGUXCUUMNUXBVQYQUUHXHUWHUUJYQXIXFWFWGXKWSU
      UNUUCUWEUWBXDUUMUWJUVRUWAUWJUUQUVQUXAUUCUUNUVQPMZYJUUJVOWGZXLZUUCUWQUVJUW
      APMUUNUWRUVKYKUURWTXMXNWEXOXPUUNUUKUUCUVTUWBXDZUUMUVFUUCNZUVRPMZUWQUVJUVM
      NZUXPUUNUUCUXRUUKUXOXPUUCUWQUVFUWRUTUVFUXSUUCUVFUVJUVMUVLUVNXQQZUVRYKUURX
      RTXTXSUUNUUKUUCUVSUVCIUUMUXQUVSUUSUVQRHZUVCUXQUVGUXMUXSUVSUYAIUVFUVGUUCUV
      IQUUNUUCUXMUUKUXNXPUXTUUQUVQUURYATUXQUUSPMZUUCUUNUVCUYAIUVFUYBUUCUVOQUVFU
      UCWJUUNUUKUUCYBUUSYJUUJYCTVAXTYDVBYOUVEAUVAJYLUVAIZYNUVDBJUYCYMUVCYKYLUVA
      YJGVCVDVEVFWDYEYFYGYHYI $.

    $( A continuous linear functional can be expressed as an inner product.
       Uniqueness part of Theorem 3.9 of [Beran] p. 104.  (Contributed by NM,
       13-Feb-2006.)  (New usage is discouraged.) $)
    riesz4i $p |- E! w e. ~H A. v e. ~H ( T ` v ) = ( v .ih w ) $=
      ( vu cv cfv csp co wceq chil wral wa wi cmin cc0 wcel cc syl wreu riesz3i
      r19.26 oveq12 adantl lnfnfi ffvelrni subidd adantr eqtr3d ralimiaa sylbir
      wrex cmv hvsubcl oveq1 oveq12d eqeq1d rspcv cno c2 c0v normcl recnd sqeq0
      cexp wb norm-i bitrd normsq simpl simpr his2sub2 syl3anc hvsubeq0 3bitr3d
      eqtrd sylibd syl5 rgen2a oveq2 eqeq2d ralbidv reu4 mpbir2an ) BGZCHZWFAGZ
      IJZKZBLMZALUAWKALUMWKWGWFFGZIJZKZBLMZNZWHWLKZOZFLMALMABCDEUBWRAFLWPWIWMPJ
      ZQKZBLMZWHLRZWLLRZNZWQWPWJWNNZBLMXAWJWNBLUCXEWTBLWFLRZXENWGWGPJZWSQXEXGWS
      KXFWGWIWGWMPUDUEXFXGQKXEXFWGLSWFCCDUFUGUHUIUJUKULXDXAWHWLUNJZWHIJZXHWLIJZ
      PJZQKZWQXDXHLRZXAXLOWHWLUOZWTXLBXHLWFXHKZWSXKQXOWIXIWMXJPWFXHWHIUPWFXHWLI
      UPUQURUSTXDXHUTHZVAVFJZQKZXHVBKZXLWQXDXMXRXSVGXNXMXRXPQKZXSXMXPSRXRXTVGXM
      XPXHVCVDXPVETXHVHVITXDXQXKQXDXQXHXHIJZXKXDXMXQYAKXNXHVJTXDXMXBXCYAXKKXNXB
      XCVKXBXCVLXHWHWLVMVNVQURWHWLVOVPVRVSVTWKWOAFLWQWJWNBLWQWIWMWGWHWLWFIWAWBW
      CWDWE $.
  $}

  ${
    $d w v T $.
    $( A continuous linear functional can be expressed as an inner product.
       Uniqueness part of Theorem 3.9 of [Beran] p. 104.  See ~ riesz2 for the
       bounded linear functional version.  (Contributed by NM, 16-Feb-2006.)
       (New usage is discouraged.) $)
    riesz4 $p |- ( T e. ( LinFn i^i ConFn ) ->
                   E! w e. ~H A. v e. ~H ( T ` v ) = ( v .ih w ) ) $=
      ( clf ccnfn cin wcel cv cfv csp co wceq chil wral wreu cc0 csn cxp sselii
      cif fveq1 eqeq1d ralbidv reubidv inss1 0lnfn elin mpbir2an elimel riesz4i
      0cnfn inss2 dedth ) CDEFZGZBHZCIZUPAHJKZLZBMNZAMOUPUOCMPQRZTZIZURLZBMNZAM
      OCVACVBLZUTVEAMVFUSVDBMVFUQVCURUPCVBUAUBUCUDABVBUNDVBDEUECVAUNVAUNGVADGVA
      EGUFUKVADEUGUHUIZSUNEVBDEULVGSUJUM $.
  $}

  ${
    $d x y z T $.
    $( Part 1 of the Riesz representation theorem for bounded linear
       functionals.  A linear functional is bounded iff its value can be
       expressed as an inner product.  Part of Theorem 17.3 of [Halmos] p. 31.
       For part 2, see ~ riesz2 .  For the continuous linear functional
       version, see ~ riesz3i and ~ riesz4 .  (Contributed by NM,
       25-Apr-2006.)  (New usage is discouraged.) $)
    riesz1 $p |- ( T e. LinFn -> ( ( normfn ` T ) e. RR <->
                  E. y e. ~H A. x e. ~H ( T ` x ) = ( x .ih y ) ) ) $=
      ( vz clf wcel ccnfn cfv cr cv co wceq chil wral wrex wa cabs cmul cle wbr
      cnmf csp lnfncnbd cin cc0 csn cxp cif fveq1 eqeq1d rexralbidv inss1 0lnfn
      0cnfn mpbir2an elimel sselii inss2 riesz3i dedth sylbir cno normcl adantl
      elin ex wi fveq2 bcs cc recn mulcom syl2an breqtrd adantll adantr eqbrtrd
      an32s oveq1 breq2d ralbidv rspcev ee12an rexlimdva lnfncon sylibrd impbid
      ralimdva bitr3d ) CEFZCGFZCUAHIFAJZCHZWLBJZUBKZLZAMNZBMOZCUCWJWKWRWJWKWRW
      JWKPCEGUDZFZWRCEGVEWTWRWLWTCMUEUFUGZUHZHZWOLZAMNBMOCXACXBLZWPXDBAMMXEWMXC
      WOWLCXBUIUJUKBAXBWSEXBEGULCXAWSXAWSFXAEFXAGFUMUNXAEGVEUOUPZUQWSGXBEGURXFU
      QUSUTVAVFWJWRWMQHZDJZWLVBHZRKZSTZAMNZDIOZWKWJWQXMBMWJWNMFZPZWNVBHZIFZWQXG
      XPXIRKZSTZAMNZXMXNXQWJWNVCZVDXOWPXSAMWJWLMFZXNWPXSVGWJYBPXNPZWPXSYCWPPXGW
      OQHZXRSWPXGYDLYCWMWOQVHVDYCYDXRSTZWPYBXNYEWJYBXNPYDXIXPRKZXRSWLWNVIYBXIIF
      ZXQYFXRLZXNWLVCYAYGXIVJFXPVJFYHXQXIVKXPVKXIXPVLVMVMVNVOVPVQVFVRWHXLXTDXPI
      XHXPLZXKXSAMYIXJXRXGSXHXPXIRVSVTWAWBWCWDDACWEWFWGWI $.

    $( Part 2 of the Riesz representation theorem for bounded linear
       functionals.  The value of a bounded linear functional corresponds to a
       unique inner product.  Part of Theorem 17.3 of [Halmos] p. 31.  For part
       1, see ~ riesz1 .  (Contributed by NM, 25-Apr-2006.)
       (New usage is discouraged.) $)
    riesz2 $p |- ( ( T e. LinFn /\ ( normfn ` T ) e. RR ) ->
                   E! y e. ~H A. x e. ~H ( T ` x ) = ( x .ih y ) ) $=
      ( clf wcel cnmf cfv cr wa ccnfn cin csp wceq chil wral wreu elin lnfncnbd
      cv co pm5.32i bitri riesz4 sylbir ) CDEZCFGHEZIZCDJKEZASZCGUIBSLTMANOBNPU
      HUECJEZIUGCDJQUEUJUFCRUAUBBACUCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Adjoints (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g v w y z A $.  $d z B $.  $d f t w x z F $.  $d f g t v w x y z T $.
    $d f C $.  $d f v w x z G $.
    cnlnadjlem.1 $e |- T e. LinOp $.
    cnlnadjlem.2 $e |- T e. ConOp $.
    cnlnadjlem.3 $e |- G = ( g e. ~H |-> ( ( T ` g ) .ih y ) ) $.
    $( Lemma for ~ cnlnadji (Theorem 3.10 of [Beran] p. 104: every continuous
       linear operator has an adjoint).  The value of the auxiliary functional
       ` G ` .  (Contributed by NM, 16-Feb-2006.)
       (New usage is discouraged.) $)
    cnlnadjlem1 $p |- ( A e. ~H -> ( G ` A ) = ( ( T ` A ) .ih y ) ) $=
      ( cv cfv csp co chil wceq fveq2 oveq1d ovex fvmpt ) DBDIZCJZAIZKLBCJZUAKL
      MESBNTUBUAKSBCOPHUBUAKQR $.

    $( Lemma for ~ cnlnadji . ` G ` is a continuous linear functional.
       (Contributed by NM, 16-Feb-2006.)  (New usage is discouraged.) $)
    cnlnadjlem2 $p |- ( y e. ~H -> ( G e. LinFn /\ G e. ConFn ) ) $=
      ( vx vz chil wcel cc co cfv cmul wceq csp wa cle cr vw cv clf ccnfn caddc
      csm cva wral lnopfi ffvelrni hicl sylan ancoms fmptd hvmulcl w3a lnopaddi
      wf 3adant3 oveq1d id ax-his2 syl3an eqtrd 3comr 3expa sylanl2 cnlnadjlem1
      hvaddcl syl adantll ax-his3 syl3an2 3expb lnopmuli adantl oveq2d ad2antll
      3eqtr4rd oveqan12d 3eqtr4d ralrimiva ralrimivva ellnfn sylanbrc cabs wrex
      cno wbr cnop nmcopexi normcl remulcl sylancr adantr eqeltrd abscld syl2an
      bcs eqbrtrd cc0 normge0 nmcoplbi lemul1a syl31anc letrd recnd recni mul32
      fveq2d jca mp3an1 breqtrd breq2d ralbidv rspcev syl2anc wb lnfncon mpbird
      oveq1 ) AUBZJKZDUCKZDUDKZYCJLDURHUBZUAUBZUFMZIUBZUGMZDNZYFYGDNZOMZYIDNZUE
      MZPZIJUHZUAJUHHLUHYDYCCJCUBZBNZYBQMZLDYRJKZYCYTLKZUUAYSJKYCUUBJJYRBBEUIZU
      JYSYBUKULUMGUNYCYQHUALJYCYFLKZYGJKZRZRZYPIJUUGYIJKZRYJBNZYBQMZYHBNZYBQMZY
      IBNZYBQMZUEMZYKYOUUFYCYHJKZUUHUUJUUOPZYFYGUOZYCUUPUUHUUQUUPUUHYCUUQUUPUUH
      YCUPZUUJUUKUUMUGMZYBQMZUUOUUSUUIUUTYBQUUPUUHUUIUUTPYCYHYIBEUQUSUTUUPUUKJK
      UUHUUMJKZYCYCUVAUUOPJJYHBUUCUJJJYIBUUCUJZYCVAUUKUUMYBVBVCVDVEVFVGUUFUUHYK
      UUJPZYCUUFUUHRYJJKZUVDUUFUUPUUHUVEUURYHYIVIULAYJBCDEFGVHVJVKUUGUUHYMUULYN
      UUNUEUUGYFYGBNZUFMZYBQMZYFUVFYBQMZOMZUULYMYCUUDUUEUVHUVJPZUUDUUEYCUVKUUEU
      UDUVFJKYCUVKJJYGBUUCUJYFUVFYBVLVMVEVNUUFUULUVHPYCUUFUUKUVGYBQYFYGBEVOUTVP
      UUEYMUVJPYCUUDUUEYLUVIYFOAYGBCDEFGVHVQVRVSAYIBCDEFGVHZVTWAWBWCHUAIDWDWEZY
      CYEYNWFNZYFYIWHNZOMZSWIZIJUHZHTWGZYCBWJNZYBWHNZOMZTKZUVNUWBUVOOMZSWIZIJUH
      ZUVSYCUVTTKZUWATKZUWCBEFWKZYBWLZUVTUWAWMWNYCUWEIJUUHYCUWEUUHYCRZUVNUVTUVO
      OMZUWAOMZUWDSUWKUVNUUMWHNZUWAOMZUWMUWKYNUWKYNUUNLUUHYNUUNPYCUVLWOZUUHUVBY
      CUUNLKUVCUUMYBUKULWPWQUUHUWNTKZUWHUWOTKYCUUHUVBUWQUVCUUMWLVJZUWJUWNUWAWMW
      RUUHUWLTKZUWHUWMTKYCUUHUWGUVOTKUWSUWIYIWLZUVTUVOWMWNZUWJUWLUWAWMWRUWKUVNU
      UNWFNZUWOSUWKYNUUNWFUWPXJUUHUVBYCUXBUWOSWIUVCUUMYBWSULWTUWKUWQUWSUWHXAUWA
      SWIZRZUWNUWLSWIZUWOUWMSWIUUHUWQYCUWRWOUUHUWSYCUXAWOYCUXDUUHYCUWHUXCUWJYBX
      BXKVPUUHUXEYCYIBEFXCWOUWNUWLUWAXDXEXFUUHUVOLKZUWALKZUWMUWDPZYCUUHUVOUWTXG
      YCUWAUWJXGUVTLKUXFUXGUXHUVTUWIXHUVTUVOUWAXIXLWRXMUMWBUVRUWFHUWBTYFUWBPZUV
      QUWEIJUXIUVPUWDUVNSYFUWBUVOOYAXNXOXPXQYCYDYEUVSXRUVMHIDXSVJXTXK $.

    ${
      cnlnadjlem.4 $e |- B = ( iota_ w e. ~H A. v e. ~H ( ( T ` v ) .ih y )
                         = ( v .ih w ) ) $.
      $( Lemma for ~ cnlnadji .  By ~ riesz4 , ` B ` is the unique vector such
         that ` ( T `` v ) .ih y ) = ( v .ih w ) ` for all ` v ` .
         (Contributed by NM, 17-Feb-2006.)  (New usage is discouraged.) $)
      cnlnadjlem3 $p |- ( y e. ~H -> B e. ~H ) $=
        ( cv chil wcel cfv csp co wceq clf ccnfn wral crio wreu cin cnlnadjlem2
        elin sylibr riesz4 syl cnlnadjlem1 eqeq1d ralbiia reubii sylib syl5eqel
        wa riotacl ) ALZMNZDCLZEOURPQZUTBLPQZRZCMUAZBMUBZMKUSVDBMUCZVEMNUSUTGOZ
        VBRZCMUAZBMUCZVFUSGSTUDNZVJUSGSNGTNUPVKAEFGHIJUEGSTUFUGBCGUHUIVIVDBMVHV
        CCMUTMNVGVAVBAUTEFGHIJUJUKULUMUNVDBMUQUIUO $.

      cnlnadjlem.5 $e |- F = ( y e. ~H |-> B ) $.
      $( Lemma for ~ cnlnadji .  The values of auxiliary function ` F ` are
         vectors.  (Contributed by NM, 17-Feb-2006.)  (Proof shortened by Mario
         Carneiro, 10-Sep-2015.)  (New usage is discouraged.) $)
      cnlnadjlem4 $p |- ( A e. ~H -> ( F ` A ) e. ~H ) $=
        ( chil cnlnadjlem3 fmpti ffvelrni ) OODHAOOEHNABCEFGIJKLMPQR $.

      $( Lemma for ~ cnlnadji . ` F ` is an adjoint of ` T ` (later, we will
         show it is unique).  (Contributed by NM, 18-Feb-2006.)
         (New usage is discouraged.) $)
      cnlnadjlem5 $p |- ( ( A e. ~H /\ C e. ~H ) -> ( ( T ` C ) .ih A ) =
                        ( C .ih ( F ` A ) ) ) $=
        ( vf chil wcel csp wceq cv cfv co wral nfcv cmpt nfmpt1 nffv nfov nfeq2
        nfcxfr nfral oveq2 oveq2d eqeq12d ralbidv crab cvv crio riotaex eqeltri
        fveq2 fvmpt2 mpan2 oveq1d oveq1 cbvralv a1i cnlnadjlem1 ralbiia syl6bbr
        wb eqeq1d riotabiia eqtri clf ccnfn cin wreu wa cnlnadjlem2 elin sylibr
        riesz4 riotacl2 3syl syl5eqel eqeltrd eqeq2d elrab simprbi syl vtoclgaf
        syl5bb rspccva sylan ) DQRPUAZGUBZDSUCZWQDIUBZSUCZTZPQUDZFQRFGUBZDSUCZF
        WTSUCZTZWRAUAZSUCZWQXHIUBZSUCZTZPQUDZXCADQADUEZXBAPQAQUEAWSXAAWQWTSAWQU
        EASUEADIAIAQEUFOAQEUGUKXNUHUIUJULXHDTZXLXBPQXOXIWSXKXAXHDWRSUMXOXJWTWQS
        XHDIVBUNUOUPXHQRZXJWQJUBZWQBUAZSUCZTZPQUDZBQUQZRZXMXPXJEYBXPEURRXJETECU
        AZGUBZXHSUCZYDXRSUCZTZCQUDZBQUSZURNYIBQUTVAAQEURIOVCVDXPEYABQUSZYBEYJYK
        NYIYABQXRQRZYIXIXSTZPQUDZYAYIYNVLYLYHYMCPQYDWQTZYFXIYGXSYOYEWRXHSYDWQGV
        BVEYDWQXRSVFUOVGVHXTYMPQWQQRXQXIXSAWQGHJKLMVIVMVJZVKVNVOXPJVPVQVRRZYABQ
        VSYKYBRXPJVPRJVQRVTYQAGHJKLMWAJVPVQWBWCBPJWDYABQWEWFWGWHYCXJQRXMYAXMBXJ
        QYAYNXRXJTZXMYPYRYMXLPQYRXSXKXIXRXJWQSUMWIUPWNWJWKWLWMXBXGPFQWQFTZWSXEX
        AXFYSWRXDDSWQFGVBVEWQFWTSVFUOWOWP $.

      $( Lemma for ~ cnlnadji . ` F ` is linear.  (Contributed by NM,
         17-Feb-2006.)  (New usage is discouraged.) $)
      cnlnadjlem6 $p |- F e. LinOp $=
        ( vx wcel chil co cfv wceq csp vf vz vt clo wf csm cva wral cnlnadjlem3
        cv cc fmpti wa caddc lnopfi ffvelrni adantl hvmulcl simplr his7 syl3anc
        ad2antrr hvaddcl sylan cnlnadjlem5 ccj cmul simpll cnlnadjlem4 ad2antlr
        simpr adantll oveq2d eqtr4d adantlr oveq12d sylan2 3eqtr3d ralrimiva wb
        his5 syl syl2an hial2eq2 syl2anc mpbid rgen2 ellnop mpbir2an ) GUDOPPGU
        ENUJZUAUJZUFQZUBUJZUGQZGRZWJWKGRZUFQZWMGRZUGQZSZUBPUHZUAPUHNUKUHAPPDGMA
        BCDEFHIJKLUIULXANUAUKPWJUKOZWKPOZUMZWTUBPXDWMPOZUMZUCUJZWOTQZXGWSTQZSZU
        CPUHZWTXFXJUCPXFXGPOZUMZXGERZWNTQZXNWLTQZXNWMTQZUNQZXHXIXMXNPOZWLPOZXEX
        OXRSXLXSXFPPXGEEIUOUPZUQXDXTXEXLWJWKURZVBXDXEXLUSXNWLWMUTVAXFWNPOZXLXOX
        HSXDXTXEYCYBWLWMVCVDZABCWNDXGEFGHIJKLMVEVDXMXRXGWQTQZXGWRTQZUNQZXIXMXPY
        EXQYFUNXDXLXPYESXEXDXLUMZXPWJVFRZXNWKTQZVGQZYEYHXBXSXCXPYKSXBXCXLVHZXLX
        SXDYAUQXBXCXLUSWJXNWKWAVAYHYEYIXGWPTQZVGQZYKYHXBXLWPPOZYEYNSYLXDXLVKXCY
        OXBXLABCWKDEFGHIJKLMVIZVJWJXGWPWAVAYHYJYMYIVGXCXLYJYMSXBABCWKDXGEFGHIJK
        LMVEVLVMVNVNVOXEXLXQYFSXDABCWMDXGEFGHIJKLMVEVLVPXMXLWQPOZWRPOZXIYGSXFXL
        VKXDYQXEXLXCXBYOYQYPWJWPURVQZVBXEYRXDXLABCWMDEFGHIJKLMVIZVJXGWQWRUTVAVN
        VRVSXFWOPOZWSPOZXKWTVTXFYCUUAYDABCWNDEFGHIJKLMVIWBXDYQYRUUBXEYSYTWQWRVC
        WCUCWOWSWDWEWFVSWGNUAUBGWHWI $.

      $( Lemma for ~ cnlnadji .  Helper lemma to show that ` F ` is
         continuous.  (Contributed by NM, 18-Feb-2006.)
         (New usage is discouraged.) $)
      cnlnadjlem7 $p |- ( A e. ~H -> ( normh ` ( F ` A ) ) <_
                        ( ( normop ` T ) x. ( normh ` A ) ) ) $=
        ( wcel cfv co cle wbr cc0 chil cno cnop cmul breq1 wne cabs cnlnadjlem4
        wa csp lnopfi ffvelrni syl hicl mpancom abscld normcl remulcld nmcopexi
        cc remulcl sylancr bcs normge0 nmcoplbi lemul1ad letrd wceq cnlnadjlem5
        cr mpdan fveq2d hiidrcl hiidge0 absidd cexp normsq sqvald eqtr3d 3eqtrd
        c2 recnd recni mul32 mp3an1 syl2anc 3brtr3d adantr clt 0re leltne sylan
        wb biimpar lemul1 syl112anc mpbird wf nmopge0 mulge0 mpanl12 pm2.61ne
        ax-mp ) DUAOZDHPZUBPZFUCPZDUBPZUDQZRSZTXIRSZXFTXFTXIRUEXDXFTUFZUIZXJXFX
        FUDQZXIXFUDQZRSZXDXPXLXDXEFPZDUJQZUGPZXGXFUDQZXHUDQZXNXORXDXSXQUBPZXHUD
        QZYAXDXRXQUAOZXDXRUTOXDXEUAOZYDABCDEFGHIJKLMNUHZUAUAXEFFJUKZULUMZXQDUNU
        OUPXDYBXHXDYDYBVJOYHXQUQUMZDUQZURXDXTXHXDXGVJOZXFVJOZXTVJOFJKUSZXDYEYLY
        FXEUQZUMZXGXFVAVBZYJURYDXDXSYCRSYHXQDVCUOXDYBXTXHYIYPYJDVDZXDYEYBXTRSYF
        XEFJKVEUMVFVGXDXSXEXEUJQZUGPYRXNXDXRYRUGXDYEXRYRVHYFABCDEXEFGHIJKLMNVIV
        KVLXDYRXDYEYRVJOYFXEVMUMXDYETYRRSYFXEVNUMVOXDXFWAVPQZYRXNXDYEYSYRVHYFXE
        VQUMXDXFXDXFYOWBZVRVSVTXDXFUTOZXHUTOZYAXOVHZYTXDXHYJWBXGUTOUUAUUBUUCXGY
        MWCXGXFXHWDWEWFWGWHXMYLXIVJOZYLTXFWISZXJXPWMXDYLXLYOWHZXDUUDXLXDYKXHVJO
        ZUUDYMYJXGXHVAVBWHUUFXDYEXLUUEYFYEUUEXLYEYLTXFRSZUUEXLWMZYNXEVDTVJOYLUU
        HUUIWJTXFWKWEWFWNWLXFXIXFWOWPWQXDUUGTXHRSZXKYJYQYKTXGRSZUUGUUJUIXKYMUAU
        AFWRUUKYGFWSXCXGXHWTXAWFXB $.

      $( Lemma for ~ cnlnadji . ` F ` is continuous.  (Contributed by NM,
         17-Feb-2006.)  (New usage is discouraged.) $)
      cnlnadjlem8 $p |- F e. ConOp $=
        ( vz vx cfv cmul cle chil cr ccop wcel cv cno co wbr wral wrex nmcopexi
        cnop cnlnadjlem7 oveq1 breq2d ralbidv rspcev mp2an cnlnadjlem6 lnopconi
        rgen wceq mpbir ) GUAUBNUCZGPUDPZOUCZVBUDPZQUEZRUFZNSUGZOTUHZEUJPZTUBVC
        VJVEQUEZRUFZNSUGZVIEIJUIVLNSABCVBDEFGHIJKLMUKUSVHVMOVJTVDVJUTZVGVLNSVNV
        FVKVCRVDVJVEQULUMUNUOUPONGABCDEFGHIJKLMUQURVA $.

      $( Lemma for ~ cnlnadji . ` F ` provides an example showing the existence
         of a continuous linear adjoint.  (Contributed by NM, 18-Feb-2006.)
         (New usage is discouraged.) $)
      cnlnadjlem9 $p |- E. t e. ( LinOp i^i ConOp )
             A. x e. ~H A. z e. ~H ( ( T ` x ) .ih z ) = ( x .ih ( t ` z ) ) $=
        ( wcel csp chil wral clo ccop cin cfv wceq wrex cnlnadjlem6 cnlnadjlem8
        cv elin mpbir2an cnlnadjlem5 ancoms rgen2a fveq1 oveq2d eqeq2d 2ralbidv
        co rspcev mp2an ) JUAUBUCZQZAUIZHUDCUIZRUSZVDVEJUDZRUSZUEZCSTASTZVFVDVE
        FUIZUDZRUSZUEZCSTASTZFVBUFVCJUAQJUBQBDEGHIJKLMNOPUGBDEGHIJKLMNOPUHJUAUB
        UJUKVIACSVESQVDSQVIBDEVEGVDHIJKLMNOPULUMUNVOVJFJVBVKJUEZVNVIACSSVPVMVHV
        FVPVLVGVDRVEVKJUOUPUQURUTVA $.
    $}
  $}

  ${
    $d f g h t u v w x y z T $.
    cnlnadj.1 $e |- T e. LinOp $.
    cnlnadj.2 $e |- T e. ConOp $.
    $( Every continuous linear operator has an adjoint.  Theorem 3.10 of
       [Beran] p. 104.  (Contributed by NM, 18-Feb-2006.)
       (New usage is discouraged.) $)
    cnlnadji $p |- E. t e. ( LinOp i^i ConOp )
             A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) $=
      ( vz vw vv vf vg cv cfv csp co wceq chil wral cmpt eqid crio oveq2 eqeq2d
      ralbidv cbvriotav cnlnadjlem9 ) AGBHICILZDMGLZNOZUGJLZNOZPZIQRZJQUAZDKGQU
      NSZKQKLDMUHNOSZEFUPTUMUIUGHLZNOZPZIQRJHQUJUQPZULUSIQUTUKURUIUJUQUGNUBUCUD
      UEUOTUF $.

    $( Every continuous linear operator has a unique adjoint.  Theorem 3.10 of
       [Beran] p. 104.  (Contributed by NM, 18-Feb-2006.)
       (New usage is discouraged.) $)
    cnlnadjeui $p |- E! t e. ( LinOp i^i ConOp )
             A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) $=
      ( cv cfv csp co wceq chil wral clo ccop cin wf wa wmo wcel wreu wrex wrmo
      cnlnadji adjmo inss1 sseli lnopf syl simpl eqcom 2ralbii wb lnopfi adjsym
      mpan2 syl5bb biimpa jca sylan moimi df-rmo sylibr ax-mp reu5 mpbir2an ) A
      GZDHBGZIJZVGVHCGZHIJZKZBLMALMZCNOPZUAVMCVNUBVMCVNUCZABCDEFUDLLVJQZVGVHDHI
      JVGVJHVHIJKBLMALMZRZCSZVOABCDUEVSVJVNTZVMRZCSVOWAVRCVTVPVMVRVTVJNTVPVNNVJ
      NOUFUGVJUHUIVPVMRVPVQVPVMUJVPVMVQVMVKVIKZBLMALMZVPVQVLWBABLLVIVKUKULVPLLD
      QWCVQUMDEUNABVJDUOUPUQURUSUTVAVMCVNVBVCVDVMCVNVEVF $.
  $}

  ${
    $d t x y T $.
    $( Every continuous linear operator has a unique adjoint.  Theorem 3.10 of
       [Beran] p. 104.  (Contributed by NM, 19-Feb-2006.)
       (New usage is discouraged.) $)
    cnlnadjeu $p |- ( T e. ( LinOp i^i ConOp ) -> E! t e. ( LinOp i^i ConOp )
           A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) ) $=
      ( clo ccop cin wcel cv cfv csp wceq chil wral wreu ch0o cif fveq1 sselii
      co oveq1d eqeq1d 2ralbidv reubidv inss1 0lnop 0cnop mpbir2an elimel inss2
      elin cnlnadjeui dedth ) DEFGZHZAIZDJZBIZKTZUPURCIJKTZLZBMNAMNZCUNOUPUODPQ
      ZJZURKTZUTLZBMNAMNZCUNODPDVCLZVBVGCUNVHVAVFABMMVHUSVEUTVHUQVDURKUPDVCRUAU
      BUCUDABCVCUNEVCEFUEDPUNPUNHPEHPFHUFUGPEFUKUHUIZSUNFVCEFUJVISULUM $.

    $( Every continuous linear operator has an adjoint.  Theorem 3.10 of
       [Beran] p. 104.  (Contributed by NM, 18-Feb-2006.)
       (New usage is discouraged.) $)
    cnlnadj $p |- ( T e. ( LinOp i^i ConOp ) -> E. t e. ( LinOp i^i ConOp )
           A. x e. ~H A. y e. ~H ( ( T ` x ) .ih y ) = ( x .ih ( t ` y ) ) ) $=
      ( clo ccop cin wcel cfv csp wceq chil wral wreu wrex cnlnadjeu reurex syl
      cv co ) DEFGZHASZDIBSZJTUBUCCSIJTKBLMALMZCUANUDCUAOABCDPUDCUAQR $.
  $}

  ${
    $d t u v x y z $.
    $( Every continuous linear Hilbert space operator has an adjoint.
       (Contributed by NM, 18-Feb-2006.)  (New usage is discouraged.) $)
    cnlnssadj $p |- ( LinOp i^i ConOp ) C_ dom adjh $=
      ( vy vt vx vz vu vv clo ccop cado cv wcel wex cfv csp co wceq chil wf w3a
      wral cin cdm cop wa cnlnadj df-rex sylib inss1 sseli lnopf syl a1d wi a1i
      adantrd eqcom biimpi ralimi wb adjsym syl2anr syl5ib expimpd 3jcad dfadj2
      wrex copab eleq2i vex fveq1 oveq2d eqeq1d 2ralbidv 3anbi13d oveq1d eqeq2d
      feq1 3anbi23d opelopab bitr2i syl6ib eximdv mpd eldm2 sylibr ssriv ) AGHU
      AZIUBZAJZWGKZWIBJZUCZIKZBLZWIWHKWJWKWGKZCJZWIMDJZNOZWPWQWKMNOZPZDQTZCQTZU
      DZBLZWNWJXBBWGVFXDCDBWIUEXBBWGUFUGWJXCWMBWJXCQQWIRZQQWKRZWPWQWIMZNOZWPWKM
      ZWQNOZPZDQTCQTZSZWMWJXCXEXFXLWJXEXCWJWIGKXEWGGWIGHUHZUIWIUJUKZULWJWOXFXBW
      OXFUMWJWOWKGKXFWGGWKXNUIWKUJUKZUNUOWJWOXBXLXBWSWRPZDQTZCQTZWJWOUDXLXAXRCQ
      WTXQDQWTXQWRWSUPUQURURWOXFXEXSXLUSWJXPXOCDWKWIUTVAVBVCVDWMWLQQEJZRZQQFJZR
      ZWPWQXTMZNOZWPYBMZWQNOZPZDQTCQTZSZEFVGZKXMIYKWLCDFEVEVHYJXEYCXHYGPZDQTCQT
      ZSXMEFWIWKAVIZBVIXTWIPZYAXEYIYMYCQQXTWIVQYOYHYLCDQQYOYEXHYGYOYDXGWPNWQXTW
      IVJVKVLVMVNYBWKPZYCXFYMXLXEQQYBWKVQYPYLXKCDQQYPYGXJXHYPYFXIWQNWPYBWKVJVOV
      PVMVRVSVTWAWBWCBWIIYNWDWEWF $.
  $}

  $( Every bounded linear Hilbert space operator has an adjoint.  (Contributed
     by NM, 19-Feb-2006.)  (New usage is discouraged.) $)
  bdopssadj $p |- BndLinOp C_ dom adjh $=
    ( cbo clo ccop cin cado cdm lncnbd cnlnssadj eqsstr3i ) ABCDEFGHI $.

  $( Every bounded linear Hilbert space operator has an adjoint.  (Contributed
     by NM, 22-Feb-2006.)  (New usage is discouraged.) $)
  bdopadj $p |- ( T e. BndLinOp -> T e. dom adjh ) $=
    ( cbo cado cdm bdopssadj sseli ) BCDAEF $.

  ${
    $d t w x y z T $.
    $( The adjoint of a bounded linear operator is a bounded linear operator.
       (Contributed by NM, 19-Feb-2006.)  (New usage is discouraged.) $)
    adjbdln $p |- ( T e. BndLinOp -> ( adjh ` T ) e. BndLinOp ) $=
      ( vx vy vt cbo wcel cado cfv cv csp co wceq chil wral crio syl wrex wa wf
      wreu cmap cdm bdopadj adjval clo ccop cin cnlnadj lncnopbd lncnbd 3imtr3i
      rexeqi wb bdopf adjsym syl2an eqcom 2ralbii syl6bbr rexbidva mpbird adjeu
      mpbid wss wi ax-hilex elmap sylibr ssriv id rgenw riotass2 mpanl12 eqtr4d
      syl2anc a1i reuss syl3anc riotacl eqeltrd ) AEFZAGHZBIZCIZAHJKWCDIZHWDJKL
      CMNBMNZDEOZEWAWBWFDMMUAKZOZWGWAAGUBFZWBWILAUCZBCDAUDPWAWFDEQZWFDWHTZWGWIL
      ZWAWLWCAHWDJKZWCWDWEHJKZLZCMNBMNZDEQZAUEUFUGZFWRDWTQWAWSBCDAUHAUIWRDWTEUJ
      ULUKWAWFWRDEWAWEEFZRWFWPWOLZCMNBMNZWRWAMMASZMMWESZWFXCUMXAAUNZWEUNZBCAWEU
      OUPWQXBBCMMWOWPUQURUSUTVAZWAWJWMWKWAXDWJWMUMXFBCDAVBPVCZEWHVDZWFWFVEZDENW
      LWMRWNDEWHXAXEWEWHFXGMMWEVFVFVGVHVIZXKDEWFVJVKWFWFDEWHVLVMVOVNWAWFDETZWGE
      FWAXJWLWMXMXJWAXLVPXHXIWFDEWHVQVRWFDEVSPVT $.

    $( An operator is bounded and linear iff its adjoint is.  (Contributed by
       NM, 19-Feb-2006.)  (New usage is discouraged.) $)
    adjbdlnb $p |- ( T e. BndLinOp <-> ( adjh ` T ) e. BndLinOp ) $=
      ( cbo wcel cado cfv adjbdln bdopadj dmadjrnb sylibr wa ccnv cnvadj fveq1i
      cdm wf1o wceq adj1o simpl f1ocnvfv1 sylancr syl5eqr adantl mpancom impbii
      eqeltrrd ) ABCZADEZBCZAFADNZCZUHUFUHUGUICUJUGGAHIUJUHJZUGDEZABUKULUGDKZEZ
      AUGUMDLMUKUIUIDOUJUNAPQUJUHRUIUIADSTUAUHULBCUJUGFUBUEUCUD $.

    $( The mapping of adjoints of bounded linear operators is one-to-one onto.
       (Contributed by NM, 19-Feb-2006.)  (New usage is discouraged.) $)
    adjbd1o $p |- ( adjh |` BndLinOp ) : BndLinOp -1-1-onto-> BndLinOp $=
      ( vy vx cbo cado cima cres wf1o cdm wf1 adj1o f1of1 ax-mp wceq wb cv wcel
      wss wrex cfv bdopadj bdopssadj f1ores mp2an wbr vex elima fnbrfvb sylancr
      f1ofn rexbiia adjbdlnb eleq1 syl5bb biimpcd rexlimiv adjbdln adjadj fveq2
      wfn syl eqeq1d rspcev syl2anc impbii 3bitr2i eqriv f1oeq3 mpbi ) CDCEZDCF
      ZGZCCVJGZDHZVMDIZCVMQVKVMVMDGZVNJVMVMDKLUAVMVMCDUBUCVICMVKVLNAVICAOZVIPBO
      ZVPDUDZBCRVQDSZVPMZBCRZVPCPZBVPDCAUEUFVTVRBCVQCPZDVMUSZVQVMPVTVRNVOWDJVMV
      MDUILVQTVMVQVPDUGUHUJWAWBVTWBBCVTWCWBWCVSCPVTWBVQUKVSVPCULUMUNUOWBVPDSZCP
      WEDSZVPMZWAVPUPWBVPVMPWGVPTVPUQUTVTWGBWECVQWEMVSWFVPVQWEDURVAVBVCVDVEVFVI
      CCVJVGLVH $.

    $( The adjoint of an operator is linear.  Proposition 1 of
       [AkhiezerGlazman] p. 80.  (Contributed by NM, 17-Jun-2006.)
       (New usage is discouraged.) $)
    adjlnop $p |- ( T e. dom adjh -> ( adjh ` T ) e. LinOp ) $=
      ( vx vy vz vw wcel chil cfv cv co wceq wral cc wa csp caddc adjcl 3adant2
      syl3anc cmul cado cdm wf csm cva clo dmadjrn dmadjop syl w3a simp2 sylan2
      hvmulcl an12s adantrr adantrl his7 adj2 3adant3l oveq2d ffvelrnda 3adant3
      simp3l simp3r his5 3eqtr4d 3adant3r oveq12d adantr 3ad2ant3 hvaddcl sylan
      syl3an3 eqtr3d 3eqtr2rd 3com23 3expa ralrimiva wb syl2an anandis hial2eq2
      ccj syl2anc mpbid exp32 ralrimdv ralrimivv ellnop sylanbrc ) AUAUBZFZGGAU
      AHZUCZBIZCIZUDJZDIZUEJZWMHZWOWPWMHZUDJZWRWMHZUEJZKZDGLZCGLBMLWMUFFWLWMWKF
      WNAUGWMUHUIWLXFBCMGWLWOMFZWPGFZNZXEDGWLXIWRGFZXEWLXIXJNZNZEIZWTOJZXMXDOJZ
      KZEGLZXEXLXPEGWLXKXMGFZXPWLXRXKXPWLXRXKUJZXOXMXBOJZXMXCOJZPJZXMAHZWQOJZYC
      WROJZPJZXNXSXRXBGFZXCGFZXOYBKWLXRXKUKWLXKYGXRWLXIYGXJXGWLXHYGWLXHNXGXAGFZ
      YGWPAQZWOXAUMULUNZUORWLXKYHXRWLXJYHXIWRAQZUPRXMXBXCUQSXSYDXTYEYAPWLXRXIYD
      XTKXJWLXRXIUJZWOWCHZYCWPOJZTJZYNXMXAOJZTJZYDXTYMYOYQYNTWLXRXHYOYQKXGXMWPA
      URUSUTYMXGYCGFZXHYDYPKWLXRXGXHVCZWLXRYSXIWLGGXMAAUHVAZVBWLXRXGXHVDWOYCWPV
      ESYMXGXRYIXTYRKYTWLXRXIUKWLXIYIXRWLXHYIXGYJUPRWOXMXAVESVFVGWLXRXJYEYAKXIX
      MWRAURUSVHXSYCWSOJZYFXNXSYSWQGFZXJUUBYFKWLXRYSXKUUAVBXKWLUUCXRXIUUCXJWOWP
      UMZVIVJWLXRXIXJVDYCWQWRUQSXKWLXRWSGFZUUBXNKXIUUCXJUUEUUDWQWRVKVLZXMWSAURV
      MVNVOVPVQVRXLWTGFZXDGFZXQXEVSXKWLUUEUUGUUFWSAQULWLXIXJUUHWLXINYGYHUUHWLXJ
      NYKYLXBXCVKVTWAEWTXDWBWDWEWFWGWHBCDWMWIWJ $.

    $( Every operator with an adjoint is linear.  (Contributed by NM,
       17-Jun-2006.)  (New usage is discouraged.) $)
    adjsslnop $p |- dom adjh C_ LinOp $=
      ( vt cado cdm clo cv wcel cfv adjadj dmadjrn adjlnop syl eqeltrrd ssriv )
      ABCZDAEZNFZOBGZBGZODOHPQNFRDFOIQJKLM $.
  $}

  ${
    $d f g h u v w z A $.  $d f g h t u v w x y z T $.
    nmopadjle.1 $e |- T e. BndLinOp $.
    $( Property of the norm of an adjoint.  Part of proof of Theorem 3.10 of
       [Beran] p. 104.  (Contributed by NM, 22-Feb-2006.)
       (New usage is discouraged.) $)
    nmopadjlei $p |- ( A e. ~H -> ( normh ` ( ( adjh ` T ) ` A ) ) <_
                        ( ( normop ` T ) x. ( normh ` A ) ) ) $=
      ( vz vv vf vw vg chil wcel cfv cno cv csp co wceq wral sselii clo ccop
      cado crio cmpt cnop cmul cle cdm bdopssadj adjvalval oveq2 eqeq1d ralbidv
      cbo mpan riotabidv eqid riotaex fvmpt eqtr4d fveq2d inss1 lncnbd eleqtrri
      cin inss2 eqeq2d cbvriotav cnlnadjlem7 eqbrtrd ) AIJZABUAKKZLKADIEMZBKZDM
      ZNOZVLFMZNOZPZEIQZFIUBZUCZKZLKBUDKALKUEOUFVJVKWBLVJVKVMANOZVQPZEIQZFIUBZW
      BBUAUGZJVJVKWFPUMWGBUHCREFABUIUNDAVTWFIWAVNAPZVSWEFIWHVRWDEIWHVOWCVQVNAVM
      NUJUKULUOWAUPZWEFIUQURUSUTDGEAVTBHWAHIHMBKVNNOUCZSTVDZSBSTVABUMWKCVBVCZRW
      KTBSTVEWLRWJUPVSVOVLGMZNOZPZEIQFGIVPWMPZVRWOEIWPVQWNVOVPWMVLNUJVFULVGWIVH
      VI $.

    $( Lemma for ~ nmopadji .  (Contributed by NM, 22-Feb-2006.)
       (New usage is discouraged.) $)
    nmopadjlem $p |- ( normop ` ( adjh ` T ) ) <_ ( normop ` T ) $=
      ( vy cfv cnop cle wbr cno c1 chil wf wcel bdopf mp2b wa cmul co cr adantr
      cbo cado cv wi wral wb adjbdln nmopxr nmopub mp2an ffvelrni normcl nmopre
      cxr syl ax-mp remulcl sylancr 1re remulcli a1i nmopadjlei nmopge0 lemul2a
      cc0 pm3.2i mp3anl3 mpanl2 sylan letrd recni mulid1i syl6breq ex mprgbir )
      AUADZEDAEDZFGZCUBZHDZIFGZVRVODZHDZVPFGZUCZCJJJVOKZVPUMLZVQWDCJUDUEATLZVOT
      LWEBAUFVOMNZWGJJAKZWFBAMZAUGNCVPVOUHUIVRJLZVTWCWKVTOZWBVPIPQZVPFWLWBVPVSP
      QZWMWKWBRLZVTWKWAJLWOJJVRVOWHUJWAUKUNSWKWNRLZVTWKVPRLZVSRLZWPWGWQBAULUOZV
      RUKZVPVSUPUQSWMRLWLVPIWSURUSUTWKWBWNFGVTVRABVASWKWRVTWNWMFGZWTWRIRLZVTXAU
      RWRXBWQVDVPFGZOVTXAWQXCWSWGWIXCBWJAVBNVEVSIVPVCVFVGVHVIVPVPWSVJVKVLVMVN
      $.

    $( Property of the norm of an adjoint.  Theorem 3.11(v) of [Beran] p. 106.
       (Contributed by NM, 22-Feb-2006.)  (New usage is discouraged.) $)
    nmopadji $p |- ( normop ` ( adjh ` T ) ) = ( normop ` T ) $=
      ( cado cfv cnop wceq cle wbr nmopadjlem cdm wcel cbo bdopadj ax-mp adjadj
      fveq2i adjbdln eqbrtrri cr nmopre letri3i mpbir2an ) ACDZEDZAEDZFUDUEGHUE
      UDGHABIUCCDZEDUEUDGUFAEACJKZUFAFALKZUGBAMNAONPUCUHUCLKZBAQNZIRUDUEUIUDSKU
      JUCTNUHUESKBATNUAUB $.
  $}

  $( An operator is zero iff its adjoint is zero.  Theorem 3.11(i) of [Beran]
     p. 106.  (Contributed by NM, 20-Feb-2006.)  (New usage is discouraged.) $)
  adjeq0 $p |- ( T = 0hop <-> ( adjh ` T ) = 0hop ) $=
    ( ch0o wceq cado cfv fveq2 adj0 syl6eq cdm cbo bdopssadj 0bdop sselii eleq1
    wcel mpbiri dmadjrnb sylibr adjadj syl a1i 3eqtr3d impbii ) ABCZADEZBCZUDUE
    BDEZBABDFGHUFUEDEZUGABUEBDFUFADIZOZUHACUFUEUIOZUJUFUKBUIOJUIBKLMUEBUINPAQRA
    STUGBCUFGUAUBUC $.

  ${
    $d x y A $.  $d x y T $.
    $( The adjoint of the scalar product of an operator.  Theorem 3.11(ii) of
       [Beran] p. 106.  (Contributed by NM, 21-Feb-2006.)
       (New usage is discouraged.) $)
    adjmul $p |- ( ( A e. CC /\ T e. dom adjh ) ->
                 ( adjh ` ( A .op T ) ) = ( ( * ` A ) .op ( adjh ` T ) ) ) $=
      ( vx vy cc wcel cado wa chil chot co wf cfv csp wceq wral dmadjop homulcl
      cv cmul cdm ccj sylan2 cjcl dmadjrn syl syl2an csm adj2 adantll oveq2d wi
      3expb ax-his3 syl3an2 3exp exp3a imp43 simpll simprl adjcl ad2ant2l his52
      ffvelrnda syl3anc 3eqtr4d homval adantrr oveq1d syl3an adantrl ralrimivva
      3expa id adjeq ) AEFZBGUAZFZHZIIABJKZLZIIAUBMZBGMZJKZLZCSZVTMZDSZNKZWFWHW
      DMZNKZOZDIPCIPVTGMWDOVRVPIIBLZWABQZABRUCVPWBEFZIIWCLZWEVRAUDZVRWCVQFWPBUE
      WCQUFZWBWCRUGVSWLCDIIVSWFIFZWHIFZHZHZAWFBMZUHKZWHNKZWFWBWHWCMZUHKZNKZWIWK
      XBAXCWHNKZTKZAWFXFNKZTKZXEXHXBXIXKATVRXAXIXKOZVPVRWSWTXMWFWHBUIUMUJUKVPVR
      WSWTXEXJOZVPVRWSWTXNULVPVRWSHZWTXNXOVPXCIFWTXNVRIIWFBWNVDAXCWHUNUOUPUQURX
      BVPWSXFIFZXHXLOVPVRXAUSVSWSWTUTVRWTXPVPWSWHBVAVBAWFXFVCVEVFXBWGXDWHNVSWSW
      GXDOZWTVPVRWSXQVRVPWMWSXQWNAWFBVGUOVMVHVIXBWJXGWFNVSWTWJXGOZWSVPVRWTXRVPW
      OVRWPWTWTXRWQWRWTVNWBWHWCVGVJVMVKUKVFVLCDWDVTVOVE $.
  $}

  ${
    $d x y S $.  $d x y T $.
    $( The adjoint of the sum of two operators.  Theorem 3.11(iii) of [Beran]
       p. 106.  (Contributed by NM, 22-Feb-2006.)
       (New usage is discouraged.) $)
    adjadd $p |- ( ( S e. dom adjh /\ T e. dom adjh ) ->
                ( adjh ` ( S +op T ) ) = ( ( adjh ` S ) +op ( adjh ` T ) ) ) $=
      ( vx vy cado wcel wa chil chos co wf cfv cv csp wceq wral dmadjop hoaddcl
      caddc syl3anc cdm syl2an dmadjrn syl adj2 3expb adantlr adantll ffvelrnda
      oveq12d ad2ant2r ad2ant2lr simprr ax-his2 simprl adjcl ad2ant2rl ad2ant2l
      cva 3eqtr4rd anim12i hosval 3expa sylan adantrl oveq2d adantrr ralrimivva
      his7 oveq1d adjeq ) AEUAZFZBVLFZGZHHABIJZKZHHAELZBELZIJZKZCMZVPLZDMZNJZWB
      WDVTLZNJZOZDHPCHPVPELVTOVMHHAKZHHBKZVQVNAQZBQZABRUBVMHHVRKZHHVSKZWAVNVMVR
      VLFWMAUCVRQUDZVNVSVLFWNBUCVSQUDZVRVSRUBVOWHCDHHVOWBHFZWDHFZGZGZWBWDVRLZWD
      VSLZUSJZNJZWBALZWBBLZUSJZWDNJZWGWEWTXEWDNJZXFWDNJZSJZWBXANJZWBXBNJZSJZXHX
      DWTXIXLXJXMSVMWSXIXLOZVNVMWQWRXOWBWDAUEUFUGVNWSXJXMOZVMVNWQWRXPWBWDBUEUFU
      HUJWTXEHFZXFHFZWRXHXKOVMWQXQVNWRVMHHWBAWKUIUKVNWQXRVMWRVNHHWBBWLUIULVOWQW
      RUMXEXFWDUNTWTWQXAHFZXBHFZXDXNOVOWQWRUOVMWRXSVNWQWDAUPUQVNWRXTVMWQWDBUPUR
      WBXAXBVITUTWTWFXCWBNVOWRWFXCOZWQVOWMWNGWRYAVMWMVNWNWOWPVAWMWNWRYAWDVRVSVB
      VCVDVEVFWTWCXGWDNVOWQWCXGOZWRVOWIWJGWQYBVMWIVNWJWKWLVAWIWJWQYBWBABVBVCVDV
      GVJUTVHCDVTVPVKT $.
  $}

  ${
    $d x y z S $.  $d x y z T $.
    nmoptri.1 $e |- S e. BndLinOp $.
    nmoptri.2 $e |- T e. BndLinOp $.
    $( Triangle inequality for the norms of bounded linear operators.
       (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    nmoptrii $p |- ( normop ` ( S +op T ) ) <_
                  ( ( normop ` S ) + ( normop ` T ) ) $=
      ( vx co cnop cfv cle wbr cno chil wf wcel ax-mp cr wa normcl syl adantr
      chos caddc cv c1 wi cxr wral wb cbo bdopf hoaddcli nmopre readdcli nmopub
      rexri hoscli ffvelrni readdcld a1i cva wceq hosval mp3an12 fveq2d norm-ii
      mp2an syl2anc eqbrtrd nmoplb mp3an1 le2add mpanr12 mp2and letrd mprgbir
      ex ) ABUAFZGHAGHZBGHZUBFZIJZEUCZKHUDIJZWBVQHZKHZVTIJZUEZELLLVQMVTUFNWAWGE
      LUGUHABAUINZLLAMZCAUJOZBUINZLLBMZDBUJOZUKVTVRVSWHVRPNZCAULOZWKVSPNZDBULOZ
      UMZUOEVTVQUNVFWBLNZWCWFWSWCQZWEWBAHZKHZWBBHZKHZUBFZVTWSWEPNZWCWSWDLNXFWBA
      BWJWMUPWDRSTWSXEPNWCWSXBXDWSXALNZXBPNZLLWBAWJUQZXARSZWSXCLNZXDPNZLLWBBWMU
      QZXCRSZURTVTPNWTWRUSWSWEXEIJWCWSWEXAXCUTFZKHZXEIWSWDXOKWIWLWSWDXOVAWJWMWB
      ABVBVCVDWSXGXKXPXEIJXIXMXAXCVEVGVHTWTXBVRIJZXDVSIJZXEVTIJZWIWSWCXQWJWBAVI
      VJWLWSWCXRWMWBBVIVJWSXQXRQXSUEZWCWSXHXLXTXJXNXHXLQWNWPXTWOWQXBXDVRVSVKVLV
      GTVMVNVPVO $.

    $( Upper bound for the norm of the composition of two bounded linear
       operators.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    nmopcoi $p |- ( normop ` ( S o. T ) ) <_
                   ( ( normop ` S ) x. ( normop ` T ) ) $=
      ( cfv cmul co cle wbr cno c1 chil wcel ax-mp cr cc0 wceq adantrr eqtr4d
      wa vx ccom cnop cv wi wf cxr wral wb cbo clo bdopln lnopcoi lnopfi nmopre
      remulcli rexri nmopub mp2an 0le0 a1i lnopco0i nmlnop0iHIL sylib fveq1 c0v
      ch0o fveq2d ho0val norm0 syl6eq sylan9eq sylan oveq2 recni mul01i 3brtr4d
      adantr wn wne df-ne cdiv csm cabs cc ffvelrni normcl recnd divrec2 mp3an2
      syl ancoms rerecclzi clt bdopf nmopgt0 recgt0i sylbi 0re ltle mpan absidd
      sylc oveq1d recclzi norm-iii syl2an lnopmuli oveq2d adantl hvmulcl nmoplb
      hocoi mp3an1 mulid2i syl6breqr biimpi ledivmul2 syl112anc eqbrtrd syl2anc
      1re mpbird ad2antrl jctil syl3anc mpbid sylanbr pm2.61ian ex mprgbir ) AB
      UBZUCEZAUCEZBUCEZFGZHIZUAUDZJEKHIZYRYLEZJEZYPHIZUEZUALLLYLUFYPUGMYQUUCUAL
      UHUIYLABAUJMZAUKMCAULNZBUJMZBUKMDBULNZUMZUNZYPYNYOUUDYNOMZCAUONZUUFYOOMZD
      BUONZUPUQUAYPYLURUSYRLMZYSUUBYOPQZUUNYSTZUUBUUOUUNUUBYSUUOUUNTZPPUUAYPHPP
      HIUUQUTVAUUOYLVGQZUUNUUAPQUUOYMPQUURABUUEUUGVBYLUUHVCVDUURUUNUUAYRVGEZJEZ
      PUURYTUUSJYRYLVGVEVHUUNUUTVFJEPUUNUUSVFJYRVIVHVJVKVLVMUUOYPPQUUNUUOYPYNPF
      GPYOPYNFVNYNYNUUKVOVPVKVRVQRUUOVSYOPVTZUUPUUBYOPWAUVAUUPTZUUAYOWBGZYNHIZU
      UBUVBUVCKYOWBGZYRBEZWCGZAEZJEZYNHUVAUUNUVCUVIQYSUVAUUNTZUVCUVEYTWCGZJEZUV
      IUVJUVCUVEWDEZUUAFGZUVLUVJUVCUVEUUAFGZUVNUUNUVAUVCUVOQZUUNUUAWEMZUVAUVPUU
      NUUAUUNYTLMZUUAOMZLLYRYLUUIWFZYTWGWKZWHUVQYOWEMZUVAUVPYOUUMVOZUUAYOWIWJVM
      WLUVJUVMUVEUUAFUVAUVMUVEQUUNUVAUVEYOUUMWMZUVAUVEOMZPUVEWNIZPUVEHIZUWDUVAP
      YOWNIZUWFLLBUFZUVAUWHUIUUFUWIDBWONZBWPNZYOUUMWQWRPOMUWEUWFUWGUEWSPUVEWTXA
      XCXBVRZXDSUVAUVEWEMZUVRUVLUVNQUUNYOUWCXEZUVTUVEYTXFXGSUVJUVHUVKJUVJUVHUVE
      UVFAEZWCGZUVKUVAUWMUVFLMZUVHUWPQUUNUWNLLYRBUWJWFZUVEUVFAUUEXHXGUUNUVKUWPQ
      UVAUUNYTUWOUVEWCYRABUUDLLAUFZCAWONZUWJXMXIXJSVHSRUVBUVGLMZUVGJEZKHIZUVIYN
      HIZUVAUUNUXAYSUVAUWMUWQUXAUUNUWNUWRUVEUVFXKXGRUVBUXBUVFJEZYOWBGZKHUVAUUNU
      XBUXFQYSUVJUXBUVMUXEFGZUXFUVAUWMUWQUXBUXGQUUNUWNUWRUVEUVFXFXGUVJUXFUVEUXE
      FGZUXGUUNUVAUXFUXHQZUUNUXEWEMZUVAUXIUUNUXEUUNUWQUXEOMZUWRUVFWGWKZWHUXJUWB
      UVAUXIUWCUXEYOWIWJVMWLUVJUVMUVEUXEFUWLXDSSRUVBUXFKHIZUXEKYOFGZHIZUUPUXOUV
      AUUPUXEYOUXNHUWIUUNYSUXEYOHIUWJYRBXLXNYOUWCXOXPXJUVAUUNUXMUXOUIZYSUUNUVAU
      XPUUNUVATZUXKKOMZUULUWHUXPUUNUXKUVAUXLVRUXRUXQYBVAUULUXQUUMVAUVAUWHUUNUVA
      UWHUWKXQZXJUXEKYOXRXSWLRYCXTUWSUXAUXCUXDUWTUVGAXLXNYAXTUVBUVSUUJUULUWHTUV
      DUUBUIUUNUVSUVAYSUWAYDUUJUVBUUKVAUVBUWHUULUVAUWHUUPUXSVRUUMYEUUAYNYOXRYFY
      GYHYIYJYK $.

    $( The sum of two bounded linear operators is a bounded linear operator.
       (Contributed by NM, 9-Mar-2006.)  (New usage is discouraged.) $)
    bdophsi $p |- ( S +op T ) e. BndLinOp $=
      ( chos co cbo wcel clo cnop cfv cr bdopln ax-mp lnophsi wbr chil wf bdopf
      nmopre cxr caddc cmnf clt cle hoaddcli nmopxr readdcli nmopgtmnf nmoptrii
      xrre mp4an elbdop2 mpbir2an ) ABEFZGHUOIHUOJKZLHZABAGHZAIHCAMNBGHZBIHDBMN
      OUPUAHZAJKZBJKZUBFZLHUCUPUDPZUPVCUEPUQQQUORZUTABURQQARCASNUSQQBRDBSNUFZUO
      UGNVAVBURVALHCATNUSVBLHDBTNUHVEVDVFUOUINABCDUJUPVCUKULUOUMUN $.

    $( The difference between two bounded linear operators is bounded.
       (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    bdophdi $p |- ( S -op T ) e. BndLinOp $=
      ( c1 cneg chot co chos chod cbo wcel chil wf bdopf ax-mp honegsubi neg1cn
      cc bdophmi bdophsi eqeltrri ) AEFZBGHZIHABJHKABAKLMMANCAOPBKLMMBNDBOPQAUD
      CUCSLUDKLRUCBDTPUAUB $.

    $( The composition of two bounded linear operators is bounded.
       (Contributed by NM, 9-Mar-2006.)  (New usage is discouraged.) $)
    bdopcoi $p |- ( S o. T ) e. BndLinOp $=
      ( ccom cbo wcel clo cnop cfv cr bdopln ax-mp lnopcoi cxr cmul chil lnopfi
      wbr nmopre co cmnf clt cle hocofi nmopxr remulcli nmopgtmnf nmopcoi mp4an
      wf xrre elbdop2 mpbir2an ) ABEZFGUOHGUOIJZKGZABAFGZAHGCALMZBFGZBHGDBLMZNU
      POGZAIJZBIJZPUAZKGUBUPUCSZUPVEUDSUQQQUOUKZVBABAUSRBVARUEZUOUFMVCVDURVCKGC
      ATMUTVDKGDBTMUGVGVFVHUOUHMABCDUIUPVEULUJUOUMUN $.

    $( Triangle-type inequality for the norms of bounded linear operators.
       (Contributed by NM, 10-Mar-2006.)  (New usage is discouraged.) $)
    nmoptri2i $p |- ( ( normop ` S ) - ( normop ` T ) ) <_
                  ( normop ` ( S +op T ) ) $=
      ( cnop cfv cmin co chos cle wbr caddc wcel cbo ax-mp chil wf bdopf nmopre
      cr c1 cneg chot bdophsi cc neg1cn bdophmi nmoptrii chod hoaddcli hopncani
      honegsubi eqtri fveq2i nmopnegi oveq2i 3brtr3i lesubaddi mpbir ) AEFZBEFZ
      GHABIHZEFZJKUTVCVALHZJKVBUAUBZBUCHZIHZEFVCVFEFZLHUTVDJVBVFABCDUDZVEUEMVFN
      MUFVEBDUGOUHVGAEVGVBBUIHAVBBABANMZPPAQCAROZBNMZPPBQDBROZUJVMULABVKVMUKUMU
      NVHVAVCLBVMUOUPUQUTVAVCVJUTTMCASOVLVATMDBSOVBNMVCTMVIVBSOURUS $.

    $( The adjoint of a composition of bounded linear operators.  Theorem
       3.11(viii) of [Beran] p. 106.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    adjcoi $p |- ( adjh ` ( S o. T ) ) = ( ( adjh ` T ) o. ( adjh ` S ) ) $=
      ( vx vy cado cfv csp co wceq chil wcel cbo wf adjbdln bdopf ax-mp bdopadj
      mp2b cv ccom wral wa oveq2d adantl oveq1d adantr ffvelrni cdm adj2 mp3an1
      hocoi sylan sylan2 3eqtrd bdopcoi 3eqtr2rd rgen2a hocofi hoeq2 mp2an mpbi
      wb ) EUAZFUAZABUBZGHZHIJZVEVFBGHZAGHZUBZHZIJZKZFLUCELUCZVHVLKZVOEFLVELMZV
      FLMZUDZVNVEVFVKHZVJHZIJZVEVGHZVFIJZVIVSVNWCKVRVSVMWBVEIVFVJVKBNMZVJNMLLVJ
      ODBPVJQTZANMZVKNMLLVKOCAPVKQTZUMUEUFVTWEVEBHZAHZVFIJZWJWAIJZWCVRWEWLKVSVR
      WDWKVFIVEABWHLLAOCAQRWFLLBODBQRZUMUGUHVRWJLMZVSWLWMKZLLVEBWNUIAGUJZMZWOVS
      WPWHWRCASRWJVFAUKULUNVSVRWALMZWMWCKZLLVFVKWIUIBWQMZVRWSWTWFXADBSRVEWABUKU
      LUOUPVGWQMZVRVSWEVIKVGNMZXBABCDUQZVGSRVEVFVGUKULURUSLLVHOZLLVLOVPVQVDXCVH
      NMXEXDVGPVHQTVJVKWGWIUTEFVHVLVAVBVC $.
  $}

  ${
    $d x y S $.  $d x y T $.
    nmopcoadj.1 $e |- T e. BndLinOp $.
    $( The norm of an operator composed with its adjoint.  Part of Theorem
       3.11(vi) of [Beran] p. 106.  (Contributed by NM, 8-Mar-2006.)
       (New usage is discouraged.) $)
    nmopcoadji $p |- ( normop ` ( ( adjh ` T ) o. T ) )
                    = ( ( normop ` T ) ^ 2 ) $=
      ( vx cfv co wceq cle wbr cno c1 chil wcel ax-mp cr wa cmul adantr syl cc0
      mp2b cado ccom cnop c2 cexp cv wi wf cxr wral wb cbo adjbdlnb mpbi hocofi
      bdopf nmopre resqcli rexr nmopub mp2an hocoi fveq2d ffvelrni 3syl remulcl
      normcl sylancr remulcli a1i nmbdoplbi nmopge0 pm3.2i lemul2a mpanl2 sylan
      1re mp3anl3 recni mulid1i syl6breq letrd syl21anc eqbrtrd nmopadji oveq1i
      sqvali eqtr4i ex mprgbir csqr bdopcoi sqrcli csp cabs hicl mpancom abscld
      cc remulcld bcs hococli normge0 simpr mp3anl2 recnd mulid1d eqtr4d resqcl
      jca breqtrd sqge0 absidd normsq bdopadj adj2 mp3an1 adjadj fveq1i syl6req
      oveq2i eqtrd eqtr3d sqsqri 3brtr4d sqrge0i mpanr12 syl2anc mpbird breqtri
      cdm le2sq le2sqi letri3i mpbir2an ) AUADZAUBZUCDZAUCDZUDUEEZFYRYTGHZYTYRG
      HUUACUFZIDZJGHZUUBYQDZIDZYTGHZUGZCKKKYQUHZYTUILZUUAUUHCKUJUKYPAYPULLZKKYP
      UHZAULLZUUKBAUMUNZYPUPZMZUUMKKAUHZBAUPZMZUOZYTNLUUJYSUUMYSNLZBAUQMZURZYTU
      SMCYTYQUTVAUUBKLZUUDUUGUVDUUDOZUUFYPUCDZYSPEZYTGUVEUUFUUBADZYPDZIDZUVGGUV
      DUUFUVJFUUDUVDUUEUVIIUUBYPAUUPUUSVBVCZQUVEUVJUVFUVHIDZPEZUVGUVDUVJNLZUUDU
      VDUVHKLZUVIKLZUVNKKUUBAUUSVDZKKUVHYPUUPVDZUVIVGVEZQUVDUVMNLZUUDUVDUVFNLZU
      VLNLZUVTUUKUWAUUNYPUQMZUVDUVOUWBUVQUVHVGZRZUVFUVLVFVHQUVGNLUVEUVFYSUWCUVB
      VIVJUVDUVJUVMGHZUUDUVDUVOUWFUVQUVHYPUUNVKRQUVEUWBUVAUVLYSGHZUVMUVGGHZUVDU
      WBUUDUWEQZUVAUVEUVBVJZUVEUVLYSUUCPEZYSUWIUVDUWKNLZUUDUVDUVAUUCNLZUWLUVBUU
      BVGZYSUUCVFVHQUWJUVDUVLUWKGHUUDUUBABVKQUVEUWKYSJPEZYSGUVDUWMUUDUWKUWOGHZU
      WNUWMJNLZUUDUWPVQUWMUWQUVASYSGHZOUUDUWPUVAUWRUVBUUMUUQUWRBUURAVLTZVMUUCJY
      SVNVRVOVPYSYSUVBVSZVTWAWBUWBUVAUWASUVFGHZOUWGUWHUWAUXAUWCUUKUULUXAUUNUUOY
      PVLTVMUVLYSUVFVNVRWCWBWDUVGYSYSPEYTUVFYSYSPABWEWFYSUWTWGWHWAWIWJYTYRWKDZU
      DUEEZYRGYSUXBGHZYTUXCGHZUXDUUDUVLUXBGHZUGZCKUUQUXBUILZUXDUXGCKUJUKUUSSYRG
      HZUXBNLZUXHUUIUXIUUTYQVLZMZYRYQULLYRNLZYPAUUNBWLZYQUQMZWMZUXBUSTCUXBAUTVA
      UVDUUDUXFUVEUXFUVLUDUEEZUXCGHZUVEUVIUUBWNEZWODZYRUXQUXCGUVEUXTUVJUUCPEZYR
      UVDUXTNLUUDUVDUXSUVPUVDUXSWSLUVDUVOUVPUVQUVRRZUVIUUBWPWQWRQUVDUYANLUUDUVD
      UVJUUCUVSUWNWTQZUXMUVEUXOVJZUVDUXTUYAGHZUUDUVPUVDUYEUYBUVIUUBXAWQQUVEUYAU
      UFYRUYCUVDUUFNLZUUDUVDUUEKLUYFUUBYPAUUPUUSXBUUEVGRQZUYDUVEUYAUVJJPEZUUFGU
      VEUWMUVNSUVJGHZOZUUDUYAUYHGHZUVDUWMUUDUWNQUVDUYJUUDUVDUVNUYIUVSUVDUVOUVPU
      YIUVQUVRUVIXCVEXJQUVDUUDXDUWMUWQUYJUUDUYKVQUUCJUVJVNXEWCUVDUYHUUFFUUDUVDU
      YHUVJUUFUVDUVJUVDUVJUVSXFXGUVKXHQXKUVEUUFYRUUCPEZYRUYGUVDUYLNLZUUDUVDUXMU
      WMUYMUXOUWNYRUUCVFVHQUYDUVDUUFUYLGHUUDUUBYQUXNVKQUVEUYLYRJPEZYRGUVDUWMUUD
      UYLUYNGHZUWNUWMUWQUUDUYOVQUWMUWQUXMUXIOUUDUYOUXMUXIUXOUXLVMUUCJYRVNVRVOVP
      YRYRUXOVSVTWAWBWBWBUVDUXQUXTFUUDUVDUXQWODZUXQUXTUVDUVOUWBUYPUXQFUVQUWDUWB
      UXQUVLXIUVLXLXMVEUVDUXQUXSWOUVDUXQUVHUVHWNEZUXSUVDUVOUXQUYQFUVQUVHXNRUVDU
      XSUVHUUBYPUADZDZWNEZUYQUVOUVDUXSUYTFZUVQYPUAYKZLZUVOUVDVUAUUKVUCUUNYPXOMU
      VHUUBYPXPXQWQUYSUVHUVHWNUUBUYRAUUMAVUBLUYRAFBAXOAXRTXSYAXTYBVCYCQUXCYRFZU
      VEUUIUXIVUDUUTUXKYRUXOYDTZVJYEUVDUXFUXRUKZUUDUVDUWBSUVLGHZVUFUWEUVDUVOVUG
      UVQUVHXCRUWBVUGOUXJSUXBGHZVUFUUIUXIUXJUUTUXKUXPTZUUIUXIVUHUUTUXKYRUXOYFTZ
      UVLUXBYLYGYHQYIWIWJUWRVUHUXDUXEUKUWSVUJYSUXBUVBVUIYMVAUNVUEYJYRYTUXOUVCYN
      YO $.

    $( The norm of an operator composed with its adjoint.  Part of Theorem
       3.11(vi) of [Beran] p. 106.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    nmopcoadj2i $p |- ( normop ` ( T o. ( adjh ` T ) ) )
                    = ( ( normop ` T ) ^ 2 ) $=
      ( cado cfv ccom cnop c2 cexp co cbo wcel adjbdln ax-mp nmopcoadji bdopadj
      cdm wceq adjadj coeq1i fveq2i nmopadji oveq1i 3eqtr3i ) ACDZCDZUDEZFDUDFD
      ZGHIAUDEZFDAFDZGHIUDAJKZUDJKBALMNUFUHFUEAUDACPKZUEAQUJUKBAOMARMSTUGUIGHAB
      UAUBUC $.

    $( An operator composed with its adjoint is zero iff the operator is zero.
       Theorem 3.11(vii) of [Beran] p. 106.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    nmopcoadj0i $p |- ( ( T o. ( adjh ` T ) ) = 0hop <-> T = 0hop ) $=
      ( cado cfv ccom cnop cc0 wceq ch0o c2 cexp co nmopcoadj2i eqeq1i cbo wcel
      ax-mp clo bdopln nmlnop0iHIL cr nmopre recni sqeq0i bitri adjbdln lnopcoi
      3bitr3i ) AACDZEZFDZGHZAFDZGHZUJIHAIHULUMJKLZGHUNUKUOGABMNUMUMAOPZUMUAPBA
      UBQUCUDUEUJAUIUPARPBASQZUIOPZUIRPUPURBAUFQUISQUGTAUQTUH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Quantum computation error bound theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    unierr.1 $e |- F e. UniOp $.
    unierr.2 $e |- G e. UniOp $.
    unierr.3 $e |- S e. UniOp $.
    unierr.4 $e |- T e. UniOp $.
    $( If we approximate a chain of unitary transformations (quantum computer
       gates) ` F ` , ` G ` by other unitary transformations ` S ` , ` T ` ,
       the error increases at most additively.  Equation 4.73 of
       [NielsenChuang] p. 195.  (Contributed by NM, 10-Mar-2006.)
       (New usage is discouraged.) $)
    unierri $p |- ( normop ` ( ( F o. G ) -op ( S o. T ) ) ) <_
                 ( ( normop ` ( F -op S ) ) + ( normop ` ( G -op T ) ) ) $=
      ( co cnop cfv cle chil cc0 wf cbo wcel ax-mp cr nmopre ccom caddc wbr c0h
      chod wceq cuo unopbd bdopf hocofi hosubcli nmop0h mpan2 0le0 00id oveq12d
      breqtrri syl5breqr eqbrtrd wne cmul chos honpncani fveq2i bdopcoi bdophdi
      nmoptrii hocsubdiri nmopcoi eqbrtrri bdopln hoddii remulcli le2addi mp2an
      clo bdophsi readdcli letri c1 nmopun oveq2d mulid1i syl6eq oveq1d mulid2i
      recni syl5breq pm2.61ine ) CDUAZABUAZUEIZJKZCAUEIZJKZDBUEIZJKZUBIZLUCMUDM
      UDUFZWMNWRLWSMMWLOWMNUFWJWKCDCPQZMMCOCUGQWTECUHRZCUIRZDPQZMMDODUGQZXCFDUH
      RZDUIRZUJZABAPQZMMAOAUGQZXHGAUHRZAUIRZBPQZMMBOBUGQXLHBUHRZBUIRZUJZUKWLULU
      MWSNNNUBIZWRLNNXPLUNUOUQWSWONWQNUBWSMMWNOWONUFCAXBXKUKWNULUMWSMMWPOWQNUFD
      BXFXNUKWPULUMUPURUSMUDUTZWMWODJKZVAIZAJKZWQVAIZUBIZWRLWJADUAZUEIZYCWKUEIZ
      VBIZJKZWMYBLYFWLJWJYCWKXGADXKXFUJXOVCVDYGYDJKZYEJKZUBIZLUCYJYBLUCZYGYBLUC
      YDYEWJYCCDXAXEVEADXJXEVEZVFZYCWKYLABXJXMVEVFZVGYHXSLUCYIYALUCYKWNDUAZJKYH
      XSLYOYDJCADXBXKXFVHVDWNDCAXAXJVFZXEVIVJAWPUAZJKYIYALYQYEJADBXHAVPQXJAVKRX
      FXNVLVDAWPXJDBXEXMVFZVIVJYHYIXSYAYDPQYHSQYMYDTRZYEPQYISQYNYETRZWOXRWNPQWO
      SQYPWNTRZXCXRSQXEDTRVMZXTWQXHXTSQXJATRWPPQWQSQYRWPTRZVMZVNVOYGYJYBYFPQYGS
      QYDYEYMYNVQYFTRYHYIYSYTVRXSYAUUBUUDVRVSVOVJXQXSWOYAWQUBXQXSWOVTVAIWOXQXRV
      TWOVAXQXDXRVTUFFDWAUMWBWOWOUUAWGWCWDXQYAVTWQVAIWQXQXTVTWQVAXQXIXTVTUFGAWA
      UMWEWQWQUUCWGWFWDUPWHWI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Dirac bra-ket notation (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z w A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x S $.
    $d t u x y T $.  $d t u x U $.  $d t x y z $.
    $( The norm of the bra function.  (Contributed by NM, 24-May-2006.)
       (New usage is discouraged.) $)
    branmfn $p |- ( A e. ~H -> ( normfn ` ( bra ` A ) ) = ( normh ` A ) ) $=
      ( vy vx vz chil wcel cfv cno wceq c0v wa c1 cle wbr clt adantr cr co cmul
      cc0 vw cbr cnmf fveq2 fveq2d eqeq12d wne cv cabs wrex cab cxr cc wf brafn
      csup nmfnval syl wss wral wi nmfnsetre ressxr syl6ss normcl rexrd jca vex
      eqeq1 anbi2d rexbidv elab csp braval sylan9eqr bcs2 3expa ancom1s eqbrtrd
      exp41 imp4a rexlimdv imp sylan2b ralrimiva cdiv csm recnd normne0 biimpar
      reccld simpl hvmulcl syl2anc norm1 1le1 syl6eqbr ax-his3 syl3anc rereccld
      id hiidrcl remulcld eqeltrd normgt0 biimpa recgt0d ltle mpan sylc hiidge0
      0re mulge0d breqtrrd absidd recid2d oveq2d mul12d c2 sqvald normsq eqtr3d
      cexp eqtrd mulid1d 3eqtr3rd 3eqtr4rd breq1d oveq1 eqeq2d anbi12d syl12anc
      rspcev wb rexbidva mpbird fvex sylibr breq2 sylan adantlr ex supxr2 nmfn0
      csn cxp bra0 fveq2i norm0 3eqtr4i a1i pm2.61ne ) AEFZAUBGZUCGZAHGZIJUBGZU
      CGZJHGZIZAJAJIZUUOUURUUPUUSUVAUUNUUQUCAJUBUDUEAJHUDUFUUMAJUGZKZUUOBUHZHGZ
      LMNZCUHZUVDUUNGZUIGZIZKZBEUJZCUKZULOUPZUUPUUMUUOUVNIZUVBUUMEUMUUNUNZUVOAU
      OZCBUUNUQURPUVCUVMULUSZUUPULFZKZDUHZUUPMNZDUVMUTZUWAUUPONZUWAUAUHZONZUAUV
      MUJZVAZDQUTUVNUUPIUUMUVTUVBUUMUVRUVSUUMUVMQULUUMUVPUVMQUSUVQCBUUNVBURVCVD
      UUMUUPAVEZVFVGPUUMUWCUVBUUMUWBDUVMUWAUVMFUUMUVFUWAUVIIZKZBEUJZUWBUVLUWLCU
      WADVHUVGUWAIZUVKUWKBEUWMUVJUWJUVFUVGUWAUVIVIVJVKVLUUMUWLUWBUUMUWKUWBBEUUM
      UVDEFZUVFUWJUWBUUMUWNUVFUWJUWBUUMUWNKZUVFKZUWJKUWAUVDAVMRZUIGZUUPMUWJUWPU
      WAUVIUWRUWJXAUWOUVIUWRIUVFUWOUVHUWQUIAUVDVNUEZPVOUWPUWRUUPMNZUWJUWNUUMUVF
      UWTUWNUUMUVFUWTUVDAVPVQVRPVSVTWAWBWCWDWEPUVCUWHDQUVCUWAQFZKUWDUWGUVCUWDUW
      GUXAUVCUUPUVMFZUWDUWGUVCUVFUUPUVIIZKZBEUJZUXBUVCUXEUVFUUPUWRIZKZBEUJZUVCL
      UUPWFRZAWGRZEFZUXJHGZLMNZUUPUXJAVMRZUIGZIZUXHUVCUXIUMFZUUMUXKUVCUUPUUMUUP
      UMFUVBUUMUUPUWIWHZPZUUMUUPTUGUVBAWIWJZWKZUUMUVBWLZUXIAWMWNUVCUXLLLMAWOWPW
      QUVCUXNUXIAAVMRZSRZUXOUUPUVCUXQUUMUUMUXNUYDIUYAUYBUYBUXIAAWRWSZUVCUXNUVCU
      XNUYDQUYEUVCUXIUYCUVCUUPUUMUUPQFUVBUWIPZUXTWTZUUMUYCQFUVBAXBPZXCXDUVCTUYD
      UXNMUVCUXIUYCUYGUYHUVCUXIQFZTUXIONZTUXIMNZUYGUVCUUPUYFUUMUVBTUUPONAXEXFXG
      TQFUYIUYJUYKVAXLTUXIXHXIXJUUMTUYCMNUVBAXKPXMUYEXNXOUVCUUPUXIUUPSRZSRZUUPL
      SRZUYDUUPUVCUYLLUUPSUVCUUPUXSUXTXPXQUVCUYMUXIUUPUUPSRZSRUYDUVCUUPUXIUUPUX
      SUYAUXSXRUVCUYOUYCUXISUUMUYOUYCIUVBUUMUUPXSYCRUYOUYCUUMUUPUXRXTAYAYBPXQYD
      UUMUYNUUPIUVBUUMUUPUXRYEPYFYGUXGUXMUXPKBUXJEUVDUXJIZUVFUXMUXFUXPUYPUVEUXL
      LMUVDUXJHUDYHUYPUWRUXOUUPUYPUWQUXNUIUVDUXJAVMYIUEYJYKYMYLUUMUXEUXHYNUVBUU
      MUXDUXGBEUWOUXCUXFUVFUWOUVIUWRUUPUWSYJVJYOPYPUVLUXECUUPAHYQUVGUUPIZUVKUXD
      BEUYQUVJUXCUVFUVGUUPUVIVIVJVKVLYRUWFUWDUAUUPUVMUWEUUPUWAOYSYMYTUUAUUBWEDU
      AUVMUUPUUCYLYDUUTUUMETUUEUUFZUCGTUURUUSUUDUUQUYRUCUUGUUHUUIUUJUUKUUL $.

    $( The bra of a vector is a bounded functional.  (Contributed by NM,
       26-May-2006.)  (New usage is discouraged.) $)
    brabn $p |- ( A e. ~H -> ( normfn ` ( bra ` A ) ) e. RR ) $=
      ( chil wcel cbr cfv cnmf cno cr branmfn normcl eqeltrd ) ABCADEFEAGEHAIAJ
      K $.

    $( The set of bras equals the set of continuous linear functionals.
       (Contributed by NM, 26-May-2006.)  (New usage is discouraged.) $)
    rnbra $p |- ran bra = ( LinFn i^i ConFn ) $=
      ( vt vx vy cbr clf ccnfn cv wcel wa cnmf cfv cr wceq chil wrex wb wral wi
      wfn cc crn cin lnfncnbd pm5.32i elin co cmpt ax-hilex mptex df-bra fnmpti
      csp fvelrnb ax-mp bralnfn brabn jca eleq1 fveq2 eleq1d syl5ibcom rexlimiv
      anbi12d riesz1 biimpa braval eqtr3 ex syl ralimdva adantl wf brafn adantr
      lnfnf ffn eqfnfv syl2an syl2anr sylibrd reximdva mpd bitri 3bitr4ri eqriv
      impbii ) ADUAZEFUBZAGZEHZWIFHZIWJWIJKZLHZIZWIWHHWIWGHZWJWKWMWIUCUDWIEFUEW
      OBGZDKZWIMZBNOZWNDNSWOWSPBNCNCGZWPULUFZUGDCNXAUHUIBCUJUKBNWIDUMUNWSWNWRWN
      BNWPNHZWQEHZWQJKZLHZIWRWNXBXCXEWPUOWPUPUQWRXCWJXEWMWQWIEURWRXDWLLWQWIJUSU
      TVCVAVBWNWTWIKZXAMZCNQZBNOZWSWJWMXICBWIVDVEWNXHWRBNWNXBIXHWTWQKZXFMZCNQZW
      RXBXHXLRWNXBXGXKCNXBWTNHIXJXAMZXGXKRWPWTVFXMXGXKXJXFXAVGVHVIVJVKXBNTWQVLZ
      NTWIVLZWRXLPZWNWPVMWJXOWMWIVOVNXNWQNSWINSXPXONTWQVPNTWIVPCNWQWIVQVRVSVTWA
      WBWFWCWDWE $.

    $( The bra function maps vectors one-to-one onto the set of continuous
       linear functionals.  (Contributed by NM, 26-May-2006.)  (Proof shortened
       by Mario Carneiro, 16-Nov-2013.)  (New usage is discouraged.) $)
    bra11 $p |- bra : ~H -1-1-onto-> ( LinFn i^i ConFn ) $=
      ( vx vy vz chil clf ccnfn cin cbr wf1o wfn crn wceq cv cfv wral csp co wa
      wcel braval cmpt ax-hilex mptex df-bra fnmpti rnbra fveq1 adantlr adantll
      wi eqeq12d syl5ib ralrimdva hial2eq2 sylibd rgen2a dff1o6 mpbir3an ) DEFG
      ZHIHDJHKUSLAMZHNZBMZHNZLZUTVBLZUJZBDOADOADBDVBUTPQZUAHBDVGUBUCABUDUEUFVFA
      BDUTDSZVBDSZRZVDCMZUTPQZVKVBPQZLZCDOVEVJVDVNCDVDVKVANZVKVCNZLVJVKDSZRZVNV
      KVAVCUGVRVOVLVPVMVHVQVOVLLVIUTVKTUHVIVQVPVMLVHVBVKTUIUKULUMCUTVBUNUOUPABD
      USHUQUR $.

    $( A bra is a continuous linear functional.  (Contributed by NM,
       30-May-2006.)  (New usage is discouraged.) $)
    bracnln $p |- ( A e. ~H -> ( bra ` A ) e. ( LinFn i^i ConFn ) ) $=
      ( chil clf ccnfn cin cbr wf1o wf bra11 f1of ax-mp ffvelrni ) BCDEZAFBMFGB
      MFHIBMFJKL $.

    $( Value of the converse of the bra function.  Based on the Riesz Lemma
       ~ riesz4 , this very important theorem not only justifies the Dirac
       bra-ket notation, but allows us to extract a unique vector from any
       continuous linear functional from which the functional can be recovered;
       i.e. a single vector can "store" _all_ of the information contained in
       any entire continuous linear functional (mapping from ` ~H ` to
       ` CC ` ).  (Contributed by NM, 26-May-2006.)
       (New usage is discouraged.) $)
    cnvbraval $p |- ( T e. ( LinFn i^i ConFn ) ->
     ( `' bra ` T ) = ( iota_ y e. ~H A. x e. ~H ( T ` x ) = ( x .ih y ) ) ) $=
      ( clf wcel cv cfv csp co wceq chil wral cbr wa wb bra11 ax-mp adantr mpan
      adantll ccnfn cin crio ccnv wrex crn rnbra eleq2i biimpri wfn wf wf1o ffn
      f1of fvelrnb sylib wi f1ocnvfv oveq2d braval ancoms fveq1 adantl 3eqtr2rd
      imp exp31 rexlimdv mpd ralrimiva wreu f1ocnvdm riesz4 oveq2 eqeq2d riota2
      ralbidv syl2anc mpbid eqcomd ) CDUAUBZEZAFZCGZWBBFZHIZJZAKLZBKUCZCMUDGZWA
      WCWBWIHIZJZAKLZWHWIJZWAWKAKWAWBKEZNZWDMGZCJZBKUEZWKWAWRWNWACMUFZEZWRWTWAW
      SVTCUGUHUIMKUJZWTWROKVTMUKZXAKVTMULZXBPKVTMUNQKVTMUMQBKCMUOQUPRWOWQWKBKWO
      WDKEZWQWKWOXDNZWQNWJWEWBWPGZWCXDWQWJWEJWOXDWQNWIWDWBHXDWQWIWDJZXCXDWQXGUQ
      PKVTWDCMURSVEUSTXEXFWEJZWQWNXDXHWAXDWNXHWDWBUTVATRWQXFWCJXEWBWPCVBVCVDVFV
      GVHVIWAWIKEZWGBKVJWLWMOXCWAXIPKVTCMVKSBACVLWGWLBKWIWDWIJZWFWKAKXJWEWJWCWD
      WIWBHVMVNVPVOVQVRVS $.

    $( Closure of the converse of the bra function.  (Contributed by NM,
       26-May-2006.)  (New usage is discouraged.) $)
    cnvbracl $p |- ( T e. ( LinFn i^i ConFn ) -> ( `' bra ` T ) e. ~H ) $=
      ( chil clf ccnfn cin cbr wf1o wcel ccnv cfv bra11 f1ocnvdm mpan ) BCDEZFG
      ANHAFIJBHKBNAFLM $.

    $( The converse bra of the bra of a vector is the vector itself.
       (Contributed by NM, 30-May-2006.)  (New usage is discouraged.) $)
    cnvbrabra $p |- ( A e. ~H -> ( `' bra ` ( bra ` A ) ) = A ) $=
      ( chil clf ccnfn cin cbr wf1o wcel cfv ccnv wceq bra11 f1ocnvfv1 mpan ) B
      CDEZFGABHAFIFJIAKLBOAFMN $.

    $( The bra of the converse bra of a continuous linear functional.
       (Contributed by NM, 31-May-2006.)  (New usage is discouraged.) $)
    bracnvbra $p |- ( T e. ( LinFn i^i ConFn ) ->
                     ( bra ` ( `' bra ` T ) ) = T ) $=
      ( chil clf ccnfn cin cbr wf1o wcel ccnv cfv wceq bra11 f1ocnvfv2 mpan ) B
      CDEZFGAOHAFIJFJAKLBOAFMN $.

    $( The vector that a continuous linear functional is the bra of.
       (Contributed by NM, 26-May-2006.)  (New usage is discouraged.) $)
    bracnlnval $p |- ( T e. ( LinFn i^i ConFn ) ->
        T = ( bra ` ( iota_ y e. ~H A. x e. ~H ( T ` x ) = ( x .ih y ) ) ) ) $=
      ( clf ccnfn cin wcel cv cfv csp co wceq chil wral crio cbr ccnv cnvbraval
      wb cnvbracl eqeltrrd wf1o bra11 f1ocnvfvb mp3an1 mpancom mpbird eqcomd )
      CDEFZGZAHZCIUKBHJKLAMNBMOZPIZCUJUMCLZCPQIZULLZABCRZULMGZUJUNUPSZUJUOULMUQ
      CTUAMUIPUBURUJUSUCMUIULCPUDUEUFUGUH $.

    $( Multiplication property of the converse bra function.  (Contributed by
       NM, 31-May-2006.)  (New usage is discouraged.) $)
    cnvbramul $p |- ( ( A e. CC /\ T e. ( LinFn i^i ConFn ) ) ->
       ( `' bra ` ( A .fn T ) ) = ( ( * ` A ) .h ( `' bra ` T ) ) ) $=
      ( cc wcel clf ccnfn cin ccj cfv cbr ccnv csm chft chil wceq cnvbracl cjcl
      wa co eqtrd brafnmul sylan cjcj adantr oveq1d sylan2 oveq2d adantl fveq2d
      bracnvbra hvmulcl syl2an cnvbrabra syl eqtr3d ) ACDZBEFGDZRZAHIZBJKZIZLSZ
      JIZUTIZABMSZUTIVBURVCVEUTURVCAVAJIZMSZVEUQUPVANDZVCVGOBPZUPVHRZVCUSHIZVFM
      SZVGUPUSCDZVHVCVLOAQZUSVAUAUBVJVKAVFMUPVKAOVHAUCUDUETUFUQVGVEOUPUQVFBAMBU
      JUGUHTUIURVBNDZVDVBOUPVMVHVOUQVNVIUSVAUKULVBUMUNUO $.

    $( Dirac bra-ket associative law ` ( | A >. ` ` <. B | ) | C >. = `
       ` | A >. ( <. B | C >. ) ` i.e. the juxtaposition of an outer product
       with a ket equals a bra juxtaposed with an inner product.  Since
       ` <. B | C >. ` is a complex number, it is the first argument in the
       inner product ` .h ` that it is mapped to, although in Dirac notation it
       is placed after the ket.  (Contributed by NM, 15-May-2006.)
       (New usage is discouraged.) $)
    kbass1 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                 ( ( A ketbra B ) ` C ) = ( ( ( bra ` B ) ` C ) .h A ) ) $=
      ( chil wcel w3a ck co cfv csp csm kbval wceq braval 3adant1 oveq1d eqtr4d
      cbr ) ADEZBDEZCDEZFZCABGHICBJHZAKHCBRIIZAKHABCLUBUDUCAKTUAUDUCMSBCNOPQ $.

    $( Dirac bra-ket associative law ` ( <. A | B >. ) <. C | = `
       ` <. A | ( | B >. ` ` <. C | ) ` i.e. the juxtaposition of an inner
       product with a bra equals a ket juxtaposed with an outer product.
       (Contributed by NM, 23-May-2006.)  (New usage is discouraged.) $)
    kbass2 $p |- ( ( A e. ~H /\ B e. ~H /\ C e. ~H ) ->
                  ( ( ( bra ` A ) ` B ) .fn ( bra ` C ) ) =
                  ( ( bra ` A ) o. ( B ketbra C ) ) ) $=
      ( vx chil wcel cbr cfv co wfn cmul wceq wa cc wf brafn csp braval syl2anc
      syl3anc w3a chft ck ccom cmpt ovex eqid fnmpti bracl hfmmval syl2an 3impa
      cv fneq1d mpbiri kbop fco 3impb ffn syl simpl1 simpl2 simpl3 oveq12d hicl
      simpr eqeltrd hfmval csm ax-his3 3adant1 fvco3 sylan kbval fveq2d hvmulcl
      3eqtrd mulcomd 3eqtr4d eqfnfvd ) AEFZBEFZCEFZUAZDEBAGHZHZCGHZUBIZWEBCUCIZ
      UDZWDWHEJDEWFDUMZWGHZKIZUEZEJDEWMWNWFWLKUFWNUGUHWDEWHWNWAWBWCWHWNLZWAWBMW
      FNFZENWGOZWOWCABUICPZDWFWGUJUKULUNUOWDENWJOZWJEJWAWBWCWSWAENWEOEEWIOZWSWB
      WCMAPBCUPZEENWEWIUQUKURENWJUSUTWDWKEFZMZWMBAQIZWKCQIZKIZWKWHHZWKWJHZXCWFX
      DWLXEKXCWAWBWFXDLWAWBWCXBVAZWAWBWCXBVBZABRSZXCWCXBWLXELWAWBWCXBVCZWDXBVFZ
      CWKRSVDXCWPWQXBXGWMLXCWFXDNXKXCWBWAXDNFXJXIBAVESZVGXCWCWQXLWRUTXMWFWKWGVH
      TXCXEBVIIZAQIZXEXDKIZXHXFXCXENFZWBWAXPXQLXCXBWCXRXMXLWKCVESZXJXIXEBAVJTXC
      XHWKWIHZWEHZXOWEHZXPWDWTXBXHYALWBWCWTWAXAVKEEWKWEWIVLVMXCXTXOWEXCWBWCXBXT
      XOLXJXLXMBCWKVNTVOXCWAXOEFZYBXPLXIXCXRWBYCXSXJXEBVPSAXORSVQXCXDXEXNXSVRVS
      VSVT $.

    $( Dirac bra-ket associative law ` <. A | B >. ` ` <. C | D >. = `
       ` ( <. A | B >. ` ` <. C | ) | D >. ` .  (Contributed by NM,
       30-May-2006.)  (New usage is discouraged.) $)
    kbass3 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( ( bra ` A ) ` B ) x. ( ( bra ` C ) ` D ) ) =
         ( ( ( ( bra ` A ) ` B ) .fn ( bra ` C ) ) ` D ) ) $=
      ( chil wcel wa cbr cfv chft co cmul cc bracl adantr brafn ad2antrl simprr
      wf wceq hfmval syl3anc eqcomd ) AEFBEFGZCEFZDEFZGZGZDBAHIIZCHIZJKIZUIDUJI
      LKZUHUIMFZEMUJSZUFUKULTUDUMUGABNOUEUNUDUFCPQUDUEUFRUIDUJUAUBUC $.

    $( Dirac bra-ket associative law ` <. A | B >. ` ` <. C | D >. = `
       ` <. A | ( | B >. ` ` <. C | D >. ) ` .  (Contributed by NM,
       30-May-2006.)  (New usage is discouraged.) $)
    kbass4 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( ( bra ` A ) ` B ) x. ( ( bra ` C ) ` D ) ) =
            ( ( bra ` A ) ` ( ( ( bra ` C ) ` D ) .h B ) ) ) $=
      ( chil wcel wa cbr cfv cmul co csm cc wceq mulcom syl2an bralnfn ad2antrr
      bracl clf adantl simplr lnfnmul syl3anc eqtr4d ) AEFZBEFZGZCEFDEFGZGZBAHI
      ZIZDCHIIZJKZUMULJKZUMBLKUKIZUHULMFUMMFZUNUONUIABSCDSZULUMOPUJUKTFZUQUGUPU
      ONUFUSUGUIAQRUIUQUHURUAUFUGUIUBUMBUKUCUDUE $.

    $( Dirac bra-ket associative law ` ( | A >. ` ` <. B | ) ( | C >. `
       ` <. D | ) = ( ( | A >. ` ` <. B | ) | C >. ) <. D | ` .  (Contributed
       by NM, 30-May-2006.)  (New usage is discouraged.) $)
    kbass5 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( A ketbra B ) o. ( C ketbra D ) ) =
                  ( ( ( A ketbra B ) ` C ) ketbra D ) ) $=
      ( vx chil wcel wa ck co cfv wceq csp csm kbval cc syl2anc syl3anc wf kbop
      ccom wral 3expa adantll fveq2d simplll simpllr simpr simplrr hicl simplrl
      cv hvmulcl eqtrd adantl fvco3 sylan oveq2d ffvelrnda adantrr cmul ax-his3
      adantr oveq1d ax-hvmulass 3eqtr4d fco syl2an anasss wfn ffn eqfnfv mpbird
      ralrimiva wb ) AFGZBFGZHZCFGZDFGZHZHZABIJZCDIJZUAZCWCKZDIJZLZEULZWEKZWIWG
      KZLZEFUBZWBWLEFWBWIFGZHZWIWDKZWCKZWIDMJZCNJZBMJZANJZWJWKWOWQWSWCKZXAWOWPW
      SWCWAWNWPWSLZVRVSVTWNXCCDWIOUCUDUEWOVPVQWSFGZXBXALVPVQWAWNUFZVPVQWAWNUGZW
      OWRPGZVSXDWOWNVTXGWBWNUHZVRVSVTWNUIZWIDUJQZVRVSVTWNUKZWRCUMQABWSORUNWBFFW
      DSZWNWJWQLWAXLVRCDTZUOFFWIWCWDUPUQWOWRWFNJZWRCBMJZANJZNJZWKXAWOWFXPWRNWOV
      PVQVSWFXPLXEXFXKABCORURWOWFFGZVTWNWKXNLWBXRWNVRVSXRVTVRFFCWCABTZUSZUTVCXI
      XHWFDWIORWOXAWRXOVAJZANJZXQWOWTYAANWOXGVSVQWTYALXJXKXFWRCBVBRVDWOXGXOPGZV
      PYBXQLXJWOVSVQYCXKXFCBUJQXEWRXOAVERUNVFVFVNWBFFWESZFFWGSZWHWMVOZVRFFWCSXL
      YDWAXSXMFFFWCWDVGVHVRVSVTYEVRVSHXRVTYEXTWFDTUQVIYDWEFVJWGFVJYFYEFFWEVKFFW
      GVKEFWEWGVLVHQVM $.

    $( Dirac bra-ket associative law ` ( | A >. ` ` <. B | ) ( | C >. `
       ` <. D | ) = | A >. ` ` ( <. B | ( | C >. ` ` <. D | ) ) ` .
       (Contributed by NM, 30-May-2006.)  (New usage is discouraged.) $)
    kbass6 $p |- ( ( ( A e. ~H /\ B e. ~H ) /\ ( C e. ~H /\ D e. ~H ) ) ->
                  ( ( A ketbra B ) o. ( C ketbra D ) ) =
               ( A ketbra ( `' bra ` ( ( bra ` B ) o. ( C ketbra D ) ) ) ) ) $=
      ( chil wcel wa ck co ccom cfv csp csm cbr wceq ccj wi cc fveq2d eqtr2d ex
      ccnv kbass5 kbval 3expa adantrr oveq1d hicl kbmul syl3an1 3exp com13 chft
      imp43 clf ccnfn bracl bracnln cnvbramul syl2an braval cnvbrabra oveqan12d
      cin anasss kbass2 3expb adantll oveq2d eqtr4d 3eqtrd ) AEFZBEFZGZCEFZDEFZ
      GZGZABHIZCDHIZJCVSKZDHICBLIZAMIZDHIZABNKZVTJZNUBZKZHIZABCDUCVRWAWCDHVNVOW
      AWCOZVPVLVMVOWJABCUDUEUFUGVRWDAWBPKZDMIZHIZWIVLVMVOVPWDWMOZVOVMVLVPWNQZVO
      VMVLWOQVOVMGZVLVPWNWPWBRFVLVPWNCBUHWBADUIUJUKUAULUNVRWHWLAHVMVQWHWLOVLVMV
      QGZWLCWEKZDNKZUMIZWGKZWHVMVOVPWLXAOVMVOGZVPGXAWRPKZWSWGKZMIZWLXBWRRFWSUOU
      PVDFXAXEOVPBCUQDURWRWSUSUTXBVPXCWKXDDMXBWRWBPBCVASDVBVCTVEWQWTWFWGVMVOVPW
      TWFOBCDVFVGSTVHVIVJVK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Positive operators (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

    $( Ordering relation for positive operators.  Definition of positive
       operator ordering in [Kreyszig] p. 470.  (Contributed by NM,
       23-Jul-2006.)  (New usage is discouraged.) $)
    leopg $p |- ( ( T e. A /\ U e. B ) -> ( T <_op U <-> ( ( U -op T ) e.
                HrmOp /\ A. x e. ~H 0 <_ ( ( ( U -op T ) ` x ) .ih x ) ) ) ) $=
      ( vu vt cv chod co cho wcel cc0 cfv csp cle wbr chil wral wa oveq2 eleq1d
      cleo wceq fveq1d oveq1d breq2d ralbidv anbi12d oveq1 df-leop brabg ) FHZG
      HZIJZKLZMAHZUONZUQOJZPQZARSZTUMDIJZKLZMUQVBNZUQOJZPQZARSZTEDIJZKLZMUQVHNZ
      UQOJZPQZARSZTGFDEBCUCUNDUDZUPVCVAVGVNUOVBKUNDUMIUAZUBVNUTVFARVNUSVEMPVNUR
      VDUQOVNUQUOVBVOUEUFUGUHUIUMEUDZVCVIVGVMVPVBVHKUMEDIUJZUBVPVFVLARVPVEVKMPV
      PVDVJUQOVPUQVBVHVQUEUFUGUHUIAFGUKUL $.

    $( Ordering relation for operators.  Definition of positive operator
       ordering in [Kreyszig] p. 470.  (Contributed by NM, 23-Jul-2006.)
       (New usage is discouraged.) $)
    leop $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T <_op U <->
                A. x e. ~H 0 <_ ( ( ( U -op T ) ` x ) .ih x ) ) ) $=
      ( cho wcel wa cleo wbr chod co cc0 cv cfv csp cle chil leopg hmopd ancoms
      wral biantrurd bitr4d ) BDEZCDEZFZBCGHCBIJZDEZKALZUFMUHNJOHAPTZFUIADDBCQU
      EUGUIUDUCUGCBRSUAUB $.

    $( Ordering relation for operators.  Definition of operator ordering in
       [Young] p. 141.  (Contributed by NM, 23-Jul-2006.)
       (New usage is discouraged.) $)
    leop2 $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T <_op U <->
                A. x e. ~H ( ( T ` x ) .ih x ) <_ ( ( U ` x ) .ih x ) ) ) $=
      ( cho wcel wa wbr cc0 co cfv csp cle chil wral wceq hmopf ffvelrn adantll
      wf adantlr cleo cv chod leop anim12i cmv hodval 3com12 3expa oveq1d simpr
      cmin his2sub syl3anc eqtrd sylan breq2d cr hmopre subge0d bitrd ralbidva
      ) BDEZCDEZFZBCUAGHAUBZCBUCIJZVFKIZLGZAMNVFBJZVFKIZVFCJZVFKIZLGZAMNABCUDVE
      VIVNAMVEVFMEZFZVIHVMVKULIZLGVNVPVHVQHLVEMMBSZMMCSZFZVOVHVQOVCVRVDVSBPCPUE
      VTVOFZVHVLVJUFIZVFKIZVQWAVGWBVFKVRVSVOVGWBOZVSVRVOWDVFCBUGUHUIUJWAVLMEZVJ
      MEZVOWCVQOVSVOWEVRMMVFCQRVRVOWFVSMMVFBQTVTVOUKVLVJVFUMUNUOUPUQVPVMVKVDVOV
      MUREVCVFCUSRVCVOVKUREVDVFBUSTUTVAVBVA $.

    $( Operator ordering in terms of a positive operator.  Definition of
       operator ordering in [Retherford] p. 49.  (Contributed by NM,
       23-Jul-2006.)  (New usage is discouraged.) $)
    leop3 $p |- ( ( T e. HrmOp /\ U e. HrmOp ) -> ( T <_op U <->
                0hop <_op ( U -op T ) ) ) $=
      ( vx cho wcel wa cleo wbr cc0 cv chod cfv csp cle chil wral ch0o leop c0v
      co wb 0hmop hmopd ancoms leop2 sylancr ho0val oveq1d eqtrd breq1d ralbiia
      hi01 syl6rbb bitrd ) ADEZBDEZFZABGHICJZBAKTZLURMTZNHZCOPZQUSGHZCABRUQVCUR
      QLZURMTZUTNHZCOPZVBUQQDEUSDEZVCVGUAUBUPUOVHBAUCUDCQUSUEUFVFVACOUROEZVEIUT
      NVIVESURMTIVIVDSURMURUGUHURULUIUJUKUMUN $.

    $( Binary relation defining a positive operator.  Definition VI.1 of
       [Retherford] p. 49.  (Contributed by NM, 25-Jul-2006.)
       (New usage is discouraged.) $)
    leoppos $p |- ( T e. HrmOp -> ( 0hop <_op T <->
                A. x e. ~H 0 <_ ( ( T ` x ) .ih x ) ) ) $=
      ( cho wcel ch0o cleo wbr cc0 cv chod co cfv csp chil wral 0hmop leop mpan
      cle wb wf wceq hmopf hosubid1 syl fveq1d oveq1d breq2d ralbidv bitrd ) BC
      DZEBFGZHAIZBEJKZLZUMMKZSGZANOZHUMBLZUMMKZSGZANOECDUKULURTPAEBQRUKUQVAANUK
      UPUTHSUKUOUSUMMUKUMUNBUKNNBUAUNBUBBUCBUDUEUFUGUHUIUJ $.

    $( The ordering relation for operators is reflexive.  (Contributed by NM,
       24-Jul-2006.)  (New usage is discouraged.) $)
    leoprf2 $p |- ( T : ~H --> ~H -> T <_op T ) $=
      ( vx chil wf cleo wbr chod co cho wcel cc0 cfv csp cle ch0o wa c0v adantl
      wceq cvv wral hodid 0hmop syl6eqel 0le0 adantr fveq1d ho0val eqtrd oveq1d
      cv hi01 eqtr2d syl5breq ralrimiva wb ax-hilex fex mpan2 syl2anc mpbir2and
      leopg ) CCADZAAEFZAAGHZIJZKBUKZVELZVGMHZNFZBCUAZVCVEOIAUBZUCUDVCVJBCVCVGC
      JZPZKKVINUEVNVIQVGMHZKVNVHQVGMVNVHVGOLZQVNVGVEOVCVEOSVMVLUFUGVMVPQSVCVGUH
      RUIUJVMVOKSVCVGULRUMUNUOVCATJZVQVDVFVKPUPVCCTJVQUQCCTAURUSZVRBTTAAVBUTVA
      $.

    $( The ordering relation for operators is reflexive.  (Contributed by NM,
       23-Jul-2006.)  (New usage is discouraged.) $)
    leoprf $p |- ( T e. HrmOp -> T <_op T ) $=
      ( vx cho wcel cleo wbr cc0 cv chod co cfv csp cle chil wral c0v ch0o wceq
      wa adantl 0le0 wf hmopf hodid syl adantr fveq1d ho0val oveq1d hi01 eqtr2d
      eqtrd syl5breq ralrimiva wb leop anidms mpbird ) ACDZAAEFZGBHZAAIJZKZVALJ
      ZMFZBNOZUSVEBNUSVANDZSZGGVDMUAVHVDPVALJZGVHVCPVALVHVCVAQKZPVHVAVBQUSVBQRZ
      VGUSNNAUBVKAUCAUDUEUFUGVGVJPRUSVAUHTULUIVGVIGRUSVAUJTUKUMUNUSUTVFUOBAAUPU
      QUR $.

    $( The square of a Hermitian operator is positive.  (Contributed by NM,
       23-Aug-2006.)  (New usage is discouraged.) $)
    leopsq $p |- ( T e. HrmOp -> 0hop <_op ( T o. T ) ) $=
      ( vx cho wcel ch0o ccom cleo wbr cc0 cv cfv csp co cle chil wral wa hmopf
      syl wceq ffvelrnda hiidge0 simpl simpr hmop syl3anc wf fvco3 sylan oveq1d
      eqtr4d breqtrd ralrimiva wb eqid hmopco mp3an3 anidms leoppos mpbird ) AC
      DZEAAFZGHZIBJZVBKZVDLMZNHZBOPZVAVGBOVAVDODZQZIVDAKZVKLMZVFNVJVKODZIVLNHVA
      OOVDAARZUAZVKUBSVJVLVKAKZVDLMZVFVJVAVMVIVLVQTVAVIUCVOVAVIUDVKVDAUEUFVJVEV
      PVDLVAOOAUGVIVEVPTVNOOVDAAUHUIUJUKULUMVAVBCDZVCVHUNVAVRVAVAVBVBTVRVBUOAAU
      PUQURBVBUSSUT $.

    $( The zero operator is a positive operator.  (The literature calls it
       "positive," even though in some sense it is really "nonnegative.") Part
       of Example 12.2(i) in [Young] p. 142.  (Contributed by NM,
       23-Jul-2006.)  (New usage is discouraged.) $)
    0leop $p |- 0hop <_op 0hop $=
      ( ch0o cho wcel cleo wbr 0hmop leoprf ax-mp ) ABCAADEFAGH $.

    $( The identity operator is a positive operator.  Part of Example 12.2(i)
       in [Young] p. 142.  (Contributed by NM, 23-Jul-2006.)
       (New usage is discouraged.) $)
    idleop $p |- 0hop <_op Iop $=
      ( vx ch0o chio cleo wbr cv cfv csp co cle chil cho wcel wral 0hmop idhmop
      wb cc0 c0v oveq1d leop2 mp2an hiidge0 ho0val eqtrd hoival 3brtr4d mprgbir
      hi01 ) BCDEZAFZBGZUKHIZUKCGZUKHIZJEZAKBLMCLMUJUPAKNQOPABCUAUBUKKMZRUKUKHI
      UMUOJUKUCUQUMSUKHIRUQULSUKHUKUDTUKUIUEUQUNUKUKHUKUFTUGUH $.

    $( The sum of two positive operators is positive.  Exercise 1(i) of
       [Retherford] p. 49.  (Contributed by NM, 25-Jul-2006.)
       (New usage is discouraged.) $)
    leopadd $p |- ( ( ( T e. HrmOp /\ U e. HrmOp ) /\ ( 0hop <_op T
               /\ 0hop <_op U ) ) -> 0hop <_op ( T +op U ) ) $=
      ( vx cho wcel wa ch0o cleo wbr co cc0 cfv csp chil wral cr hmopre leoppos
      cle wceq chos cv r19.26 caddc wi addge0 ex syl2an anandirs wf anim12i cva
      hmopf w3a hosval oveq1d 3expa ffvelrn adantlr adantll simpr ax-his2 eqtrd
      syl3anc sylan breq2d sylibrd ralimdva syl5bir bi2anan9 wb syl 3imtr4d imp
      hmops ) ADEZBDEZFZGAHIZGBHIZFZGABUAJZHIZVRKCUBZALZWDMJZSIZCNOZKWDBLZWDMJZ
      SIZCNOZFZKWDWBLZWDMJZSIZCNOZWAWCWMWGWKFZCNOVRWQWGWKCNUCVRWRWPCNVRWDNEZFZW
      RKWFWJUDJZSIZWPVPVQWSWRXBUEZVPWSFWFPEZWJPEZXCVQWSFWDAQWDBQXDXEFWRXBWFWJUF
      UGUHUIWTWOXAKSVRNNAUJZNNBUJZFZWSWOXATVPXFVQXGAUMBUMUKXHWSFZWOWEWIULJZWDMJ
      ZXAXFXGWSWOXKTXFXGWSUNWNXJWDMWDABUOUPUQXIWENEZWINEZWSXKXATXFWSXLXGNNWDAUR
      USXGWSXMXFNNWDBURUTXHWSVAWEWIWDVBVDVCVEVFVGVHVIVPVSWHVQVTWLCARCBRVJVRWBDE
      WCWQVKABVOCWBRVLVMVN $.

    $( The scalar product of a nonnegative real and a positive operator is a
       positive operator.  Exercise 1(ii) of [Retherford] p. 49.  (Contributed
       by NM, 25-Jul-2006.)  (New usage is discouraged.) $)
    leopmuli $p |- ( ( ( A e. RR /\ T e. HrmOp ) /\ ( 0 <_ A /\
                0hop <_op T ) ) -> 0hop <_op ( A .op T ) ) $=
      ( vx cr wcel cho wa cc0 cle wbr ch0o cleo co cfv csp chil wral wb leoppos
      wceq chot cv cmul wi hmopre mulge0 sylanr1 expr an4s anassrs recn anim12i
      cc wf hmopf csm homval 3expa oveq1d ffvelrn adantll simpr ax-his3 syl3anc
      simpll eqtrd sylan breq2d adantlr sylibrd expimpd adantl anbi2d hmopm syl
      ralimdva 3imtr4d imp ) ADEZBFEZGZHAIJZKBLJZGZKABUAMZLJZWAWBHCUBZBNZWGOMZI
      JZCPQZGHWGWENZWGOMZIJZCPQZWDWFWAWBWKWOWAWBGZWJWNCPWPWGPEZGWJHAWIUCMZIJZWN
      WAWBWQWJWSUDZVSWBVTWQWTVSWBGZVTWQGZWJWSXBXAWIDEWJWSWGBUEAWIUFUGUHUIUJWAWQ
      WNWSRWBWAWQGWMWRHIWAAUMEZPPBUNZGZWQWMWRTVSXCVTXDAUKBUOULXEWQGZWMAWHUPMZWG
      OMZWRXFWLXGWGOXCXDWQWLXGTAWGBUQURUSXFXCWHPEZWQXHWRTXCXDWQVEXDWQXIXCPPWGBU
      TVAXEWQVBAWHWGVCVDVFVGVHVIVJVPVKWAWCWKWBVTWCWKRVSCBSVLVMWAWEFEWFWORABVNCW
      ESVOVQVR $.

    $( The scalar product of a positive real and a positive operator is a
       positive operator.  Exercise 1(ii) of [Retherford] p. 49.  (Contributed
       by NM, 23-Aug-2006.)  (New usage is discouraged.) $)
    leopmul $p |- ( ( A e. RR /\ T e. HrmOp /\ 0 < A ) ->
                ( 0hop <_op T <-> 0hop <_op ( A .op T ) ) ) $=
      ( cr wcel cho cc0 clt wbr ch0o cleo chot co wa cle adantr ltle 3adant2 c1
      0re wceq w3a 3simpa 3impia mp3an1 anim1i leopmuli syl2anc cdiv wne gt0ne0
      rereccl syldan hmopm 3adant3 recgt0 wi sylancr mpd jca31 anassrs sylan cc
      cmul recn recid2d oveq1d chil wf 3ad2ant1 hmopf 3ad2ant2 homulass syl3anc
      reccld homulid2 syl 3eqtr3d breqtrd impbida ) ACDZBEDZFAGHZUAZIBJHZIABKLZ
      JHZWCWDMVTWAMZFANHZWDMWFWCWGWDVTWAWBUBOWCWHWDVTWBWHWAFCDZVTWBWHSWIVTWBWHF
      APUCUDQUEABUFUGWCWFMIRAUHLZWEKLZBJWCWJCDZWEEDZMZFWJNHZMWFIWKJHZWCWLWMWOVT
      WBWLWAVTWBAFUIWLAUJZAUKULZQVTWAWMWBABUMUNVTWBWOWAVTWBMZFWJGHZWOAUOWSWIWLW
      TWOUPSWRFWJPUQURQUSWNWOWFWPWJWEUFUTVAWCWKBTWFWCWJAVCLZBKLZRBKLZWKBVTWBXBX
      CTWAWSXARBKWSAVTAVBDZWBAVDZOZWQVEVFQWCWJVBDZXDVGVGBVHZXBWKTVTWBXGWAWSAXFW
      QVNQVTWAXDWBXEVIWAVTXHWBBVJZVKWJABVLVMWAVTXCBTZWBWAXHXJXIBVOVPVKVQOVRVS
      $.

    $( Scalar product applied to operator ordering.  (Contributed by NM,
       12-Aug-2006.)  (New usage is discouraged.) $)
    leopmul2i $p |- ( ( ( A e. RR /\ T e. HrmOp /\ U e. HrmOp ) /\ ( 0 <_ A /\
                T <_op U ) ) -> ( A .op T ) <_op ( A .op U ) ) $=
      ( wcel cho wbr cleo chot co wa ch0o chod wi 3adant1 wb leop3 adantr hmopm
      chil wf w3a cc0 cle simp1 hmopd ancoms leopmuli syl2anc imp syl2an 3impdi
      cr exp32 wceq recn hmopf hosubdi syl3an 3com23 breq2d bitr4d 3imtr4d impr
      cc ) AULDZBEDZCEDZUAZUBAUCFZBCGFZABHIZACHIZGFZVHVIJKCBLIZGFZKAVNHIZGFZVJV
      MVHVIVOVQMZVHVEVNEDZVIVRMVEVFVGUDVFVGVSVEVGVFVSCBUEUFNVEVSJVIVOVQAVNUGUMU
      HUIVHVJVOOZVIVFVGVTVEBCPNQVHVMVQOVIVHVMKVLVKLIZGFZVQVEVFVGVMWBOZVEVFJVKED
      VLEDWCVEVGJABRACRVKVLPUJUKVHVPWAKGVEVGVFVPWAUNZVEAVDDVGSSCTVFSSBTWDAUOCUP
      BUPACBUQURUSUTVAQVBVC $.

    $( The positive operator ordering relation satisfies trichotomy.  Exercise
       1(iii) of [Retherford] p. 49.  (Contributed by NM, 25-Jul-2006.)
       (New usage is discouraged.) $)
    leoptri $p |- ( ( T e. HrmOp /\ U e. HrmOp ) ->
           ( ( T <_op U /\ U <_op T ) <-> T = U ) ) $=
      ( vx cho wcel wa cleo wbr cfv csp co cle chil wral leop2 wb cr hmopre clo
      wceq ancoms anbi12d adantlr adantll letri3d r19.26 syl6rbb hmoplin lnopeq
      cv ralbidva syl2an 3bitrd ) ADEZBDEZFZABGHZBAGHZFCUJZAIUSJKZUSBIUSJKZLHZC
      MNZVAUTLHZCMNZFZUTVATZCMNZABTZUPUQVCURVECABOUOUNURVEPCBAOUAUBUPVHVBVDFZCM
      NVFUPVGVJCMUPUSMEZFUTVAUNVKUTQEUOUSARUCUOVKVAQEUNUSBRUDUEUKVBVDCMUFUGUNAS
      EBSEVHVIPUOAUHBUHCABUIULUM $.

    $( The positive operator ordering relation is transitive.  Exercise 1(iv)
       of [Retherford] p. 49.  (Contributed by NM, 25-Jul-2006.)
       (New usage is discouraged.) $)
    leoptr $p |- ( ( ( S e. HrmOp /\ T e. HrmOp /\ U e. HrmOp ) /\
           ( S <_op T /\ T <_op U ) ) -> S <_op U ) $=
      ( vx cho wcel w3a cleo wbr wa cfv csp co cle chil wral cr hmopre wb leop2
      cv r19.26 wi letr syl3an ralimdva syl5bir 3adant3 3adant1 anbi12d 3adant2
      3anandirs 3imtr4d imp ) AEFZBEFZCEFZGZABHIZBCHIZJZACHIZURDUAZAKVCLMZVCBKV
      CLMZNIZDOPZVEVCCKVCLMZNIZDOPZJZVDVHNIZDOPZVAVBVKVFVIJZDOPURVMVFVIDOUBURVN
      VLDOUOUPUQVCOFZVNVLUCZUOVOJVDQFUPVOJVEQFUQVOJVHQFVPVCARVCBRVCCRVDVEVHUDUE
      ULUFUGURUSVGUTVJUOUPUSVGSUQDABTUHUPUQUTVJSUODBCTUIUJUOUQVBVMSUPDACTUKUMUN
      $.

    $( A bounded Hermitian operator is less than or equal to its norm times the
       identity operator.  (Contributed by NM, 11-Aug-2006.)
       (New usage is discouraged.) $)
    leopnmid $p |- ( ( T e. HrmOp /\ ( normop ` T ) e. RR ) ->
                    T <_op ( ( normop ` T ) .op Iop ) ) $=
      ( vx cho wcel cfv cr wa chio co wbr csp cle chil adantlr recnd sylan cmul
      adantl csm wceq cnop chot cleo wral cabs hmopre abscld idhmop hmopm mpan2
      cv adantll leabsd cno wf ffvelrn normcl syl remulcld bcs sylancom remulcl
      hmopf cc0 sylan2 normge0 jca cbo hmoplin elbdop2 biimpri nmbdoplb lemul1a
      clo syl31anc cc recn ad2antlr mulassd simpr ax-his3 syl3anc sqvald normsq
      cexp eqtr3d oveq2d eqtr4d wf1o hoif f1of mp1i homval hoival eqtrd breqtrd
      c2 oveq1d letrd ralrimiva wb leop2 mpbird ) ACDZAUAEZFDZGZAXEHUBIZUCJZBUK
      ZAEZXJKIZXJXHEZXJKIZLJZBMUDZXGXOBMXGXJMDZGZXLXLUEEZXNXDXQXLFDXFXJAUFZNXDX
      QXSFDXFXDXQGZXLYAXLXTOUGNZXFXQXNFDZXDXFXHCDZXQYCXFHCDYDUHXEHUIUJZXJXHUFPU
      LZXDXQXLXSLJXFYAXLXTUMNXRXSXKUNEZXJUNEZQIZXNYBXRYGYHXDXQYGFDZXFXDMMAUOZXQ
      YJAVCZYKXQGXKMDZYJMMXJAUPZXKUQURPNZXQYHFDZXGXJUQZRZUSYFXDXQXSYILJZXFXDXQY
      MYSXDYKXQYMYLYNPXKXJUTVANXRYIXEYHQIZYHQIZXNLXRYJYTFDZYPVDYHLJZGZYGYTLJZYI
      UUALJYOXFXQUUBXDXQXFYPUUBYQXEYHVBVEULXQUUDXGXQYPUUCYQXJVFVGRXGAVHDZXQUUEX
      DAVNDZXFUUFAVIUUFUUGXFGAVJVKPXJAVLPYGYTYHVMVOXRUUAXEXJSIZXJKIZXNXRUUAXEYH
      YHQIZQIZUUIXRXEYHYHXFXEVPDZXDXQXEVQVRZXRYHYROZUUNVSXRUUIXEXJXJKIZQIZUUKXR
      UULXQXQUUIUUPTUUMXGXQVTZUUQXEXJXJWAWBXQUUKUUPTXGXQUUJUUOXEQXQYHWQWEIUUJUU
      OXQYHXQYHYQOWCXJWDWFWGRWHWHXRXMUUHXJKXRXMXEXJHEZSIZUUHXRUULMMHUOZXQXMUUST
      UUMMMHWIUUTXRWJMMHWKWLUUQXEXJHWMWBXQUUSUUHTXGXQUURXJXESXJWNWGRWOWRWHWPWSW
      SWTXFXDYDXIXPXAYEBAXHXBVEXC $.

    $( A nonzero, bounded Hermitian operator divided by its norm is less than
       or equal to the identity operator.  (Contributed by NM, 12-Aug-2006.)
       (New usage is discouraged.) $)
    nmopleid $p |- ( ( T e. HrmOp /\ ( normop ` T ) e. RR /\ T =/= 0hop ) ->
                    ( ( 1 / ( normop ` T ) ) .op T ) <_op Iop ) $=
      ( cho wcel cr wne c1 co chot chio cleo wbr cc0 sylan adantlr adantll chil
      wa clt wf wceq cnop cfv ch0o clo hmoplin nmlnopne0 biimpar rereccl simpll
      cdiv cle idhmop hmopm mpan2 ad2antlr simplr nmopgt0 biimpa recgt0d wi 0re
      hmopf ltle sylancr mpd leopnmid adantr leopmul2i syl32anc recn cmul reccl
      simpl wf1o hoif f1of ax-mp homulass mp3an3 syl2anc recid2 oveq1d homulid2
      cc eqtr3d syl6eq breqtrd syldan 3impa ) ABCZAUAUBZDCZAUCEZFWKUJGZAHGZIJKZ
      WJWLQZWMWKLEZWPWJWMWRWLWJAUDCZWMWRAUEWSWRWMAUFUGMNWQWRQZWOWNWKIHGZHGZIJWT
      WNDCZWJXABCZLWNUKKZAXAJKZWOXBJKWLWRXCWJWKUHZOWJWLWRUIWLXDWJWRWLIBCXDULWKI
      UMUNUOWTLWNRKZXEWTWKWJWLWRUPWJWRLWKRKZWLWJPPASZWRXIAVBXJWRXIAUQURMNUSWLWR
      XHXEUTZWJWLWRQLDCXCXKVAXGLWNVCVDOVEWQXFWRAVFVGWNAXAVHVIWLWRXBITZWJWLWKWDC
      ZWRXLWKVJXMWRQZXBFIHGZIXNWNWKVKGZIHGZXBXOXNWNWDCZXMXQXBTZWKVLXMWRVMXRXMPP
      ISZXSPPIVNXTVOPPIVPVQZWNWKIVRVSVTXNXPFIHWKWAWBWEXTXOITYAIWCVQWFMOWGWHWI
      $.
  $}

  ${
    $d u v T $.
    opsqrlem1.1 $e |- T e. HrmOp $.
    opsqrlem1.2 $e |- ( normop ` T ) e. RR $.
    opsqrlem1.3 $e |- 0hop <_op T $.
    opsqrlem1.4 $e |- R = ( ( 1 / ( normop ` T ) ) .op T ) $.
    opsqrlem1.5 $e |- ( T =/= 0hop -> E. u e. HrmOp ( 0hop <_op u /\
                      ( u o. u ) = R ) ) $.
    $( Lemma for opsqri .  (Contributed by NM, 9-Aug-2006.)
       (New usage is discouraged.) $)
    opsqrlem1 $p |- ( T =/= 0hop ->
                   E. v e. HrmOp ( 0hop <_op v /\ ( v o. v ) = T ) ) $=
      ( ch0o wbr ccom wceq wa cho wcel chot co chil ax-mp wne cv cleo wrex cnop
      cfv csqr cr cc0 cle wf hmopf nmopge0 hmopm mpan ad2antlr sqrge0i leopmuli
      sqrcli mpanr1 mpanl1 ad2ant2lr cc recni homulcl syl homco1 mp3an1 syl2anc
      clo hmoplin homco2 oveq2d cmul sqrthi oveq1i fco homulass syl5reqr 3eqtrd
      mp3an12 c1 cdiv id syl6eq nmlnopne0 recidzi sylbir oveq1d rerecclzi recnd
      mp3an13 homulid2 mp1i 3eqtr3d sylan9eqr adantlr eqtrd adantrl breq2 coeq1
      wb coeq2 eqeq1d anbi12d rspcev syl12anc exp31 rexlimdv mpd ) DJUAZJBUBZUC
      KZXLXLLZCMZNZBOUDJAUBZUCKZXQXQLZDMZNZAOUDZIXKXPYBBOXKXLOPZXPYBXKYCNZXPNDU
      EUFZUGUFZXLQRZOPZJYGUCKZYGYGLZDMZYBYCYHXKXPYFUHPZYCYHUIYEUJKZYLSSDUKZYMDO
      PZYNEDULTZDUMTZYEFUSTZYFXLUNUOUPYCXMYIXKXOYLYCXMYIYRYLYCNUIYFUJKZXMYIYMYS
      YQYEFUQTYFXLURUTVAVBYDXOYKXMYDXONYJYEXNQRZDYCYJYTMXKXOYCYJYFXLYGLZQRZYFYF
      XNQRZQRZYTYCSSXLUKZSSYGUKZYJUUBMZXLULZYCUUEUUFUUHYFVCPZUUEUUFYFYRVDZYFXLV
      EUOVFUUIUUEUUFUUGUUJYFXLYGVGVHVIYCUUAUUCYFQYCXLVJPZUUEUUAUUCMZXLVKUUHUUIU
      UKUUEUULUUJYFXLXLVLVHVIVMYCYTYFYFVNRZXNQRZUUDUUMYEXNQYMUUMYEMYQYEFVOTVPYC
      SSXNUKZUUNUUDMZYCUUEUUEUUOUUHUUHSSSXLXLVQVIUUIUUIUUOUUPUUJUUJYFYFXNVRWAVF
      VSVTUPXKXOYTDMYCXOXKYTYEWBYEWCRZDQRZQRZDXOXNUURYEQXOXNCUURXOWDHWEVMXKYEUU
      QVNRZDQRZWBDQRZUUSDXKUUTWBDQXKYEUIUAZUUTWBMDVJPZUVCXKXBYOUVDEDVKTDWFTZYEY
      EFVDZWGWHWIXKUUQVCPZUVAUUSMZXKUUQXKUVCUUQUHPUVEYEFWJWHWKYEVCPUVGYNUVHUVFY
      PYEUUQDVRWLVFYNUVBDMXKYPDWMWNWOWPWQWRWSYAYIYKNAYGOXQYGMZXRYIXTYKXQYGJUCWT
      UVIXSYJDUVIXSYGXQLYJXQYGXQXAXQYGYGXCWRXDXEXFXGXHXIXJ $.
  $}

  ${
    $d j k F $.  $d w z G $.  $d j k N $.  $d w z S $.  $d u v w x y z T $.
    $d w z H $.
    opsqrlem2.1 $e |- T e. HrmOp $.
    opsqrlem2.2 $e |- S = ( x e. HrmOp , y e. HrmOp |->
          ( x +op ( ( 1 / 2 ) .op ( T -op ( x o. x ) ) ) ) ) $.
    opsqrlem2.3 $e |- F = seq 1 ( S , ( NN X. { 0hop } ) ) $.
    $( Lemma for opsqri . ` F `` N ` is the recursive function A_n (starting at
       n=1 instead of 0) of Theorem 9.4-2 of [Kreyszig] p. 476.  (Contributed
       by NM, 17-Aug-2006.)  (New usage is discouraged.) $)
    opsqrlem2 $p |- ( F ` 1 ) = 0hop $=
      ( c1 cfv cn ch0o csn cxp cseq fveq1i cz wcel wceq ax-mp 1z seq1 1nn 0hmop
      cho elexi fvconst2 3eqtri ) IEJICKLMNZIOZJZIUIJZLIEUJHPIQRUKULSUACUIIUBTI
      KRULLSUCKLILUEUDUFUGTUH $.

    $( Lemma for opsqri .  (Contributed by NM, 22-Aug-2006.)
       (New usage is discouraged.) $)
    opsqrlem3 $p |- ( ( G e. HrmOp /\ H e. HrmOp ) ->
              ( G S H ) = ( G +op ( ( 1 / 2 ) .op ( T -op ( G o. G ) ) ) ) ) $=
      ( vz vw cho cv co ccom chod chot chos oveq2d c1 cdiv wceq coeq12d oveq12d
      c2 id eqidd cmpt2 weq cbvmpt2v eqtri ovex ovmpt2 ) KLFGMMKNZUAUFUBOZDUOUO
      PZQOZROZSOZFUPDFFPZQOZROZSOZCVDUOFUCZUOFUSVCSVEUGZVEURVBUPRVEUQVADQVEUOFU
      OFVFVFUDTTUELNGUCVDUHCABMMANZUPDVGVGPZQOZROZSOZUIKLMMUTUIIABKLMMVKUTUTAKU
      JZVGUOVJUSSVLUGZVLVIURUPRVLVHUQDQVLVGUOVGUOVMVMUDTTUEBLUJUTUHUKULFVCSUMUN
      $.

    $( Lemma for opsqri .  (Contributed by NM, 17-Aug-2006.)
       (New usage is discouraged.) $)
    opsqrlem4 $p |- F : NN --> HrmOp $=
      ( vz vw cn cho wf ch0o c1 wtru wcel cv 0hmop co csn cxp cseq nnuz a1i cfv
      cz 1z elexi fvconst2 syl6eqel wa c2 cdiv ccom chod chot chos opsqrlem3 cr
      adantl 1re rehalfcli simpl eqidd hmopco syl3anc hmopd sylancr hmopm hmops
      wceq syldan eqeltrd seqf trud feq1i mpbir ) KLEMKLCKNUAUBZOUCZMZWAPIJCLVS
      OKUDOUGQPUHUEIRZKQZWBVSUFZLQPWCWDNLKNWBNLSUIUJSUKVAWBLQZJRZLQZULZWBWFCTZL
      QPWHWIWBOUMUNTZDWBWBUOZUPTZUQTZURTZLABCDEWBWFFGHUSWEWGWMLQZWNLQWHWJUTQWLL
      QZWOOVBVCWHDLQWKLQZWPFWHWEWEWKWKVLWQWEWGVDZWRWHWKVEWBWBVFVGDWKVHVIWJWLVJV
      IWBWMVKVMVNVAVOVPKLEVTHVQVR $.

    $( Lemma for opsqri .  (Contributed by NM, 17-Aug-2006.)
       (New usage is discouraged.) $)
    opsqrlem5 $p |- ( N e. NN -> ( F ` ( N + 1 ) ) =
  ( ( F ` N ) +op ( ( 1 / 2 ) .op ( T -op ( ( F ` N ) o. ( F ` N ) ) ) ) ) ) $=
      ( cn wcel c1 caddc co cfv ch0o wceq fveq1i cho 0hmop csn cxp c2 cdiv ccom
      chod chot chos cseq elnnuz seqp1 sylbi oveq1i opsqrlem4 ffvelrni peano2nn
      cuz 3eqtr4g elexi fvconst2 syl syl6eqel opsqrlem3 syl2anc eqtrd ) FJKZFLM
      NZEOZFEOZVGJPUAUBZOZCNZVILUCUDNDVIVIUEUFNUGNUHNZVFVGCVJLUIZOZFVNOZVKCNZVH
      VLVFFLUQOKVOVQQFUJCVJLFUKULVGEVNIRVIVPVKCFEVNIRUMURVFVISKVKSKVLVMQJSFEABC
      DEGHIUNUOVFVKPSVFVGJKVKPQFUPJPVGPSTUSUTVATVBABCDEVIVKGHIVCVDVE $.

    ${
      opsqrlem6.4 $e |- T <_op Iop $.
      $( Lemma for opsqri .  (Contributed by NM, 23-Aug-2006.)
         (New usage is discouraged.) $)
      opsqrlem6 $p |- ( N e. NN -> ( F ` N ) <_op Iop ) $=
        ( chio cleo co wceq wcel chod c2 chos syl chil vj vk cv cfv caddc fveq2
        wbr breq1d ch0o opsqrlem2 idleop eqbrtri chot ccom cho idhmop opsqrlem4
        c1 cn ffvelrni hmopd sylancr eqid hmopco mp3an3 syl2anc leopsq wb leop3
        mp2an mpbi wa leopadd mpanl2 mpanr2 cdiv wf 2cn hmopf homulcl ax-mp fco
        cc hosubcl hosubsub4 mp3an1 hoadd32 mp3an13 ho2times oveq1i hoaddsubass
        syl6eqr eqtr4d oveq1d hoaddcl mp3an23 3eqtr3d mpanr1 mpanl1 2ne0 reccli
        hosubadd4 hoadddi recidi homulass mp3an12 homulid2 3eqtr3a oveq2d eqtrd
        cmul 3eqtr4d hosubdi hocsubdir clo hmoplin hoid1i hoico2 oveq12d mp3an2
        hoddi a1i hoico1 syl12anc 3eqtr2d opsqrlem5 breqtrd peano2nn cr cc0 clt
        jctil 2re 2pos leopmul mpbird sylancl nn1suc ) UAUCZEUDZKLUGUREUDZKLUGU
        BUCZURUEMZEUDZKLUGZFEUDZKLUGUAUBFYSURNYTUUAKLYSUREUFUHYSUUCNYTUUDKLYSUU
        CEUFUHYSFNYTUUFKLYSFEUFUHUUAUIKLABCDEGHIUJUKULUUBUSOZUUEUIKUUDPMZLUGZUU
        GUUIUIQUUHUMMZLUGZUUGUIKUUBEUDZPMZUUMUNZKDPMZRMZUUJLUUGUUNUOOZUIUUNLUGZ
        UIUUPLUGZUUGUUMUOOZUUTUUQUUGKUOOZUULUOOZUUTUPUSUOUUBEABCDEGHIUQZUTZKUUL
        VAVBZUVEUUTUUTUUNUUNNUUQUUNVCUUMUUMVDVEVFUUGUUTUURUVEUUMVGSUUQUURUIUUOL
        UGZUUSDKLUGZUVFJDUOOZUVAUVGUVFVHGUPDKVIVJVKUUQUUOUOOZUURUVFVLUUSUVAUVHU
        VIUPGKDVAVJUUNUUOVMVNVOVFUUGKUULUULUNZQUULUMMZPMZRMZUUORMZQKUULURQVPMZD
        UVJPMZUMMZRMZPMZUMMZUUPUUJUUGUVNQKUMMZQUVRUMMZPMZUVTUUGUWAUVKPMUVPPMZUW
        AUVKUVPRMZPMZUVNUWCUUGTTUVKVQZTTUVPVQZUWDUWFNZUUGQWCOZTTUULVQZUWGVRUUGU
        VBUWKUVDUULVSSZQUULVTVBZUUGTTDVQZTTUVJVQZUWHUVHUWNGDVSWAZUUGUWKUWKUWOUW
        LUWLTTTUULUULWBVFZDUVJWDVBZTTUWAVQZUWGUWHUWIUWJTTKVQZUWSVRUVAUWTUPKVSWA
        ZQKVTVJZUWAUVKUVPWEWFVFUUGUVNUWAUVJRMZUVKDRMPMZUWDUUGUVMKRMZDPMZUXCUVKP
        MZDPMZUVNUXDUUGUXEUXGDPUUGUXEUWAUVLRMZUXGUUGUXEKKRMZUVLRMZUXIUUGTTUVLVQ
        ZUXEUXKNZUUGUWOUWGUXLUWQUWMUVJUVKWDVFZUWTUXLUWTUXMUXAUXAKUVLKWGWHSUWAUX
        JUVLRUWTUWAUXJNUXAKWIWAWJWLUUGUWOUWGUXGUXINZUWQUWMUWSUWOUWGUXOUXBUWAUVJ
        UVKWKWFVFWMWNUUGTTUVMVQZUXFUVNNZUUGUWTUXLUXPUXAUXNKUVLWOVBUXPUWTUWNUXQU
        XAUWPUVMKDWKWPSUUGTTUXCVQZUWGUXHUXDNZUUGUWSUWOUXRUXBUWQUWAUVJWOVBUWMUXR
        UWGUWNUXSUWPUXCUVKDWEVEVFWQUUGUWGUWOUWDUXDNZUWMUWQUWSUWGUWOUXTUXBUWSUWG
        VLUWNUWOUXTUWPUWAUVKDUVJXBWRWSVFWMUUGUWBUWEUWAPUUGUWBUVKQUVQUMMZRMZUWEU
        UGUWKTTUVQVQZUWBUYBNZUWLUUGUVOWCOZUWHUYCQVRWTXAZUWRUVOUVPVTVBZUWJUWKUYC
        UYDVRQUULUVQXCWFVFUUGUYAUVPUVKRUUGQUVOXKMZUVPUMMZURUVPUMMZUYAUVPUYHURUV
        PUMQVRWTXDWJUUGUWHUYIUYANZUWRUWJUYEUWHUYKVRUYFQUVOUVPXEXFSUUGUWHUYJUVPN
        UWRUVPXGSXHXIXJXIXLUUGTTUVRVQZUVTUWCNZUUGUWKUYCUYLUWLUYGUULUVQWOVFUWJUW
        TUYLUYMVRUXAQKUVRXMXFSWMUUGUUNUVMUUORUUGUUNKUUMUNZUULUUMUNZPMZUVMUUGUWK
        TTUUMVQZUUNUYPNZUWLUUGUWTUWKUYQUXAUWLKUULWDVBUWTUWKUYQUYRUXAKUULUUMXNWF
        VFUUGUYPKUVJRMZUULUULRMZPMZUYSUVKPMZUVMUUGUYPUUMUULUVJPMZPMZVUAUUGUYNUU
        MUYOVUCPUUGUYNKKUNZKUULUNZPMZUUMUUGUWKUYNVUGNZUWLKXOOZUWTUWKVUHUVAVUIUP
        KXPWAUXAKKUULYAXFSUUGVUEKVUFUULPVUEKNUUGKUXAXQYBUUGUWKVUFUULNUWLUULXRSX
        SXJUUGUYOUULKUNZUVJPMZVUCUUGUULXOOZUWKUYOVUKNZUUGUVBVULUVDUULXPSUWLVULU
        WTUWKVUMUXAUULKUULYAXTVFUUGVUJUULUVJPUUGUWKVUJUULNUWLUULYCSWNXJXSUUGUWT
        UWKVLUWKUWOVUDVUANUUGUWKUWTUWLUXAYLUWLUWQKUULUULUVJXBYDXJUUGUVKUYTUYSPU
        UGUWKUVKUYTNUWLUULWISXIUUGUWOUWGVUBUVMNZUWQUWMUWTUWOUWGVUNUXAKUVJUVKWKW
        FVFYEXJWNUUGUUHUVSQUMUUGUUDUVRKPABCDEUUBGHIYFXIXIXLYGUUGUUHUOOZUUIUUKVH
        ZUUGUVAUUDUOOZVUOUPUUGUUCUSOVUQUUBYHUSUOUUCEUVCUTSZKUUDVAVBQYIOVUOYJQYK
        UGVUPYMYNQUUHYOWHSYPUUGVUQUVAUUEUUIVHVURUPUUDKVIYQYPYR $.
    $}
  $}

$(
  @{
    opsqrlem8.1 @e |- T e. HrmOp @.
    opsqrlem8.2 @e |- 0hop <_op T @.
    opsqrlem8.3 @e |- T <_op Iop @.
    @( Lemma for ~ opsqri . @)
    opsqrlem8 @p |- E. u e. HrmOp ( 0hop <_op u /\
                    ( u o. u ) = T ) @=
      (  ) ? @.
      @( [ ?] @) @( [17-Aug-2006] @)
  @}

  @{
    @d u T @.
    @( Lemma for ~ opsqri . @)
    opsqrlem9 @p |- ( ( T e. HrmOp /\ 0hop <_op T /\ T <_op Iop ) ->
                 E. u e. HrmOp ( 0hop <_op u /\ ( u o. u ) = T ) ) @=
      ( cho wcel ch0o cleo wbr chio w3a cv ccom wceq wa wrex cif eqeq2 anbi2d
      rexbidv eleq1 breq2 breq1 3anbi123d 0hmop 0leop idleop 3pm3.2i elimhyp
      simp1i simp2i simp3i opsqrlem8 dedth ) BCDZEBFGZBHFGZIZEAJZFGZUQUQKZBL
      ZMZACNURUSUPBEOZLZMZACNBEBVBLZVAVDACVEUTVCURBVBUSPQRAVBVBCDZEVBFGZVBHFGZU
      PVFVGVHIECDZEEFGZEHFGZIBEVEUMVFUNVGUOVHBVBCSBVBEFTBVBHFUAUBEVBLVIVFVJVGVK
      VHEVBCSEVBEFTEVBHFUAUBVIVJVKUCUDUEUFUGZUHVFVGVHVLUIVFVGVHVLUJUKUL @.
      @( [ ?] @) @( [8-Aug-2006] @)
  @}

  @{
    @d u v T @.
    opsqr.1 @e |- T e. HrmOp @.
    opsqr.2 @e |- ( normop ` T ) e. RR @.
    opsqr.3 @e |- 0hop <_op T @.
    @( Square root lemma. @)
    opsqri @p |- E. u e. HrmOp ( 0hop <_op u /\
                    ( u o. u ) = T ) @=
      ( vv ch0o wceq cv cleo wbr ccom wa cho wrex eqid eqeq2 anbi2d rexbidv
      wne c1 cnop cfv cdiv co chot wcel chio opsqrlem9 cr cc0 clo hmoplin
      ax-mp nmlnop0iHIL biimpi necon3i rerecclzi syl hmopm mpan2 cle leopmuli
  mpanr2 mpanl2 clt wi 0re ltle mpan nmlnopgt0i recgt0i sylbi sylcOLD sylancOLD
    nmopleid mp3an12 syl3ancOLD opsqrlem1 adantl 0hmop 0leop ho0f ho0coi pm3.2i
      breq2 coeq1 coeq2 eqtrd eqeq1d anbi12d rspcev mp2an a1i pm2.61ne ) GGHZG
      AIZJKZWQWQLZBHZMZANOZGPWPXBWRWSGHZMZANOZBGBGHZXAXDANXFWTXCWRBGWSQRSBGTZXB
      WPAFUABUBUCZUDUEZBUFUEZBCDEXJPXJNUGZGXJJKZXJUHJKZGFIZJKXNXNLXJHMFNOXGFXJU
      IXGXIUJUGZXKXGXHUKTXOXHUKBGXHUKHXFBBNUGZBULUGCBUMUNZUOUPUQXHDURUSZXOXPXKC
      XIBUTVAUSXOUKXIVBKZXLXGXOXPXSXLCXOXPMXSGBJKXLEXIBVCVDVEXRXOUKXIVFKZXSXGUK
      UJUGXOXTXSVGVHUKXIVIVJXRXGUKXHVFKXTBXQVKXHDVLVMVNVOXPXHUJUGXGXMCDBVPVQVRV
      SVTXEWPGNUGGGJKZGGLZGHZMZXEWAYAYCWBGWCWDWEXDYDAGNWQGHZWRYAXCYCWQGGJWFYEWS
      YBGYEWSGWQLYBWQGWQWGWQGGWHWIWJWKWLWMWNWOUN @.
      @( [ ?] @) @( [8-Aug-2006] @)
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Projectors as operators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z H $.
    pjhmop.1 $e |- H e. CH $.
    $( A projector is a Hermitian operator.  (Contributed by NM, 24-Mar-2006.)
       (New usage is discouraged.) $)
    pjhmopi $p |- ( projh ` H ) e. HrmOp $=
      ( vx vy cpjh cfv cho wcel chil wf csp wceq wral pjfi pjadji eqcomd rgen2a
      cv co wa elhmop mpbir2an ) AEFZGHIIUCJCRZDRZUCFKSZUDUCFUEKSZLZDIMCIMABNUH
      CDIUDIHUEIHTUGUFUDUEABOPQCDUCUAUB $.

    $( A projector is a linear operator.  (Contributed by NM, 24-Mar-2006.)
       (New usage is discouraged.) $)
    pjlnopi $p |- ( projh ` H ) e. LinOp $=
      ( cpjh cfv cho wcel clo pjhmopi hmoplin ax-mp ) ACDZEFKGFABHKIJ $.

    $( The operator norm of a projector on a nonzero closed subspace is one.
       Part of Theorem 26.1 of [Halmos] p. 43.  (Contributed by NM,
       9-Apr-2006.)  (New usage is discouraged.) $)
    pjnmopi $p |- ( H =/= 0H -> ( normop ` ( projh ` H ) ) = 1 ) $=
      ( vy vx vz vw cfv cv cno c1 cle wbr wceq wa chil wrex cxr clt cr wcel c0h
      wne cpjh cnop cab csup wf pjfi nmopval ax-mp wral wi eqeq1 anbi2d rexbidv
      vex elab cch pjnorm mpan pjhcli normcl syl 1re mp3an3 syl2anc mpand breq1
      letr imp biimparc sylan expl rexlimiv sylbi rgen cheli adantr eqle fveq2d
      simpr eqtr2d jca32 reximi2 c0v chne0i chshii norm1exi bitri 3imtr4i breq2
      pjid 1ex rspcev ex ralrimivw wss nmopsetretHIL ressxr sstri rexri mpanl12
      supxr2 sylancr syl5eq ) AUAUBZAUCGZUDGZCHZIGZJKLZDHZXIXGGZIGZMZNZCOPZDUEZ
      QRUFZJOOXGUGZXHXSMABUHZDCXGUIUJXFEHZJKLZEXRUKZYBJRLZYBFHZRLZFXRPZULZESUKZ
      XSJMZYCEXRYBXRTXKYBXNMZNZCOPZYCXQYNDYBEUPXLYBMZXPYMCOYOXOYLXKXLYBXNUMUNUO
      UQYMYCCOXIOTZXKYLYCYPXKNXNJKLZYLYCYPXKYQYPXNXJKLZXKYQAURTZYPYRBXIAUSUTYPX
      NSTZXJSTZYRXKNYQULZYPXMOTYTXIABVAXMVBVCXIVBZYTUUAJSTUUBVDXNXJJVIVEVFVGVJY
      LYCYQYBXNJKVHVKVLVMVNVOVPXFYIESXFYEYHXFJXRTZYEYHXJJMZCAPZXKJXNMZNZCOPZXFU
      UDUUEUUHCAOXIATZUUENZYPXKUUGUUJYPUUEXIABVQZVRUUJUUAUUEXKUUJYPUUAUULUUCVCX
      JJVSVLUUKXNXJJUUJXNXJMUUEUUJXMXIIYSUUJXMXIMBXIAWLUTVTVRUUJUUEWAWBWCWDXFXI
      WEUBCAPUUFCABWFCCAABWGWHWIXQUUIDJWMXLJMZXPUUHCOUUMXOUUGXKXLJXNUMUNUOUQWJY
      GYEFJXRYFJYBRWKWNVLWOWPXRQWQJQTYDYJNYKXRSQXTXRSWQYADCXGWRUJWSWTJVDXAEFXRJ
      XCXBXDXE $.

    $( A projector is a bounded linear operator.  (Contributed by NM,
       3-Jun-2006.)  (New usage is discouraged.) $)
    pjbdlni $p |- ( projh ` H ) e. BndLinOp $=
      ( cpjh cfv cbo wcel clo cnop pjlnopi cch c0h wceq fveq2 fveq2d eleq1d wne
      cr c1 cc0 ch0o pjnmopi 1re adantl df-h0op fveq2i nmop0 eqtr3i 0re eqeltri
      syl6eqel a1i pm2.61ne ax-mp elbdop2 mpbir2an ) ACDZEFUPGFUPHDZQFZABIAJFZU
      RBUSURKCDZHDZQFZAKAKLZUQVAQVCUPUTHAKCMNOAKPZURUSVDUQRQABUAUBUJUCVBUSVASQT
      HDVASTUTHUDUEUFUGUHUIUKULUMUPUNUO $.
  $}

  $( A projection is a Hermitian operator.  (Contributed by NM, 24-Apr-2006.)
     (New usage is discouraged.) $)
  pjhmop $p |- ( H e. CH -> ( projh ` H ) e. HrmOp ) $=
    ( cch wcel cpjh cfv cho c0h wceq fveq2 eleq1d h0elch elimel pjhmopi dedth
    cif ) ABCZADEZFCPAGOZDEZFCAGARHQSFARDIJRAGBKLMN $.

  ${
    $d f k x y z T $.
    hmopidmch.1 $e |- T e. HrmOp $.
    hmopidmch.2 $e |- ( T o. T ) = T $.
    $( An idempotent Hermitian operator generates a closed subspace.  Part of
       proof of Theorem of [AkhiezerGlazman] p. 64.  (Contributed by NM,
       21-Apr-2006.)  (Proof shortened by Mario Carneiro, 19-May-2014.)
       (New usage is discouraged.) $)
    hmopidmchi $p |- ran T e. CH $=
      ( vf vx vy vk wcel cn cv wf ax-mp cfv cmv co c0v wceq chil eqid wb crn wa
      cch csh chli wbr wi wal cho clo hmoplin rnelshi csn cxp cno ccom cxmt cha
      cmopn hilxmet methaus mp1i cmpt clm cmap cres cva csm hhims resss eqsstri
      cop hhlm adantl ctopon mopntopon ccn lnopfi a1i feqmptd ccop hmopbdoptHIL
      ssbri cbo lnopcnbd mpbir eleqtri syl6eqelr cnmptid cnv ctx hhnv hhvs vmcn
      hhcno cnmpt12f lmcn wral wss simpl shssii sylancl ffvelrnda fveq2 oveq12d
      fss id ovex fvmpt syl wfn ffn eqeq12d ralrn fveq1i hocoi syl5reqr mprgbir
      ffvelrn adantlr rspccv mpsyl eqeltrd hvsubeq0 mpbird eqtrd fvco3 ax-hv0cl
      syl2anc elexi fvconst2 3eqtr4d ralrimiva fnmpti sylancr fconst eqfnfv vex
      fnfco c1 hlimveci 3brtr3d cz nnuz lmconst syl3anc ffvelrni mpbid fnfvelrn
      1z lmmo eqeltrrd gen2 isch2 mpbir2an ) AUAZUCHUUPUDHIUUPDJZKZUUQEJZUEUFZU
      BZUUSUUPHUGZEUHDUHAAUIHZAUJHZBAUKLZULZUVBDEUVAUUSAMZUUSUUPUVAUVGUUSNOZPQZ
      UVGUUSQZUVAUVHPIPUMZUNZUONUPZUSMZUVMRUQMHZUVNURHUVAUVMUVMSZUTZUVMUVNRUVNS
      ZVAVBUVAFRFJZAMZUVSNOZVCZUUQUPZUUSUWBMZUVLUVHUVNVDMZUVAUUSUUQUWBUVNUVNUUT
      UUQUUSUWEUFUURUEUWEUUQUUSUEUWERIVEOZVFUWEUVMVGVHVLUOVLZUVNUWGSZUVMUWGUWHU
      VPVIZUVRVMUWEUWFVJVKWCVNUVAFUVTUVSNUVNUVNUVNUVNRUVOUVNRVOMHZUVAUVQUVMUVNR
      UVRVPVBZUVAFRUVTVCAUVNUVNVQOZUVAFRRARRAKZUVAAUVEVRZVSVTAWAUWLAWAHZAWDHZUV
      CUWPBAWBLUVDUWOUWPTUVEAWELWFUVMUVNUVPUVRWOWGWHUVAFUVNRUWKWIUWGWJHNUVNUVNW
      KOUVNVQOHUVAUWGUWHWLUVMUWGUVNNUWIUVRUWGUWHWMWNVBWPWQUVAUWCUVLQZGJZUWCMZUW
      RUVLMZQZGIWRZUVAUXAGIUVAUWRIHZUBZUWRUUQMZUWBMZPUWSUWTUXDUXFUXEAMZUXENOZPU
      XDUXERHZUXFUXHQUVAIRUWRUUQUVAUURUUPRWSIRUUQKZUURUUTWTUUPUVFXAIUUPRUUQXFXB
      ZXCZFUXEUWAUXHRUWBUVSUXEQZUVTUXGUVSUXENUVSUXEAXDZUXMXGZXEUWBSZUXGUXENXHXI
      XJUXDUXHPQZUXGUXEQZUVTUVSQZFUUPWRZUXDUXEUUPHZUXRUXTUVGAMZUVGQZERARXKZUXTU
      YCERWRTUWMUYDUWNRRAXLLZUXSUYCFERAUVSUVGQZUVTUYBUVSUVGUVSUVGAXDUYFXGXMXNLU
      USRHZUVGUUSAAUPZMUYBUUSUYHACXOUUSAAUWNUWNXPXQXRUURUXCUYAUUTIUUPUWRUUQXSXT
      UXSUXRFUXEUUPUXMUVTUXGUVSUXEUXNUXOXMYAYBZUXDUXGRHUXIUXQUXRTUXDUXGUXERUYIU
      XLYCUXLUXGUXEYDYIYEYFUURUXCUWSUXFQUUTIUUPUWRUWBUUQYGXTUXCUWTPQUVAIPUWRPRY
      HYJZYKVNYLYMUVAUWCIXKZUVLIXKZUWQUXBTUVAUWBRXKUXJUYKFRUWAUWBUVTUVSNXHUXPYN
      UXKRIUWBUUQYSYOIUVKUVLKUYLIPUYJYPIUVKUVLXLLGIUWCUVLYQXBYEUVAUYGUWDUVHQUUT
      UYGUURUUSUUQEYRUUAVNZFUUSUWAUVHRUWBUVSUUSQZUVTUVGUVSUUSNUVSUUSAXDUYNXGXEU
      XPUVGUUSNXHXIXJUUBUVAUWJPRHZYTUUCHZUVLPUWEUFUWKUYOUVAYHVSUYPUVAUUJVSPUVNY
      TRIUUDUUEUUFUUKUVAUVGRHZUYGUVIUVJTUVAUYGUYQUYMRRUUSAUWNUUGXJUYMUVGUUSYDYI
      UUHUVAUYDUYGUVGUUPHUYEUYMRUUSAUUIYOUULUUMEDUUPUUNUUO $.

    $( An idempotent Hermitian operator is a projection operator.  Theorem 26.4
       of [Halmos] p. 44.  (Halmos seems to omit the proof that ` H ` is a
       closed subspace, which is not trivial as ~ hmopidmchi shows.)
       (Contributed by NM, 22-Apr-2006.)  (Revised by Mario Carneiro,
       19-May-2014.)  (New usage is discouraged.) $)
    hmopidmpji $p |- T = ( projh ` ran T ) $=
      ( vx vz vy cfv wceq cv chil wfn wral wb wcel ax-mp csp cc0 syl2anc cmin
      co crn cpjh wf cho clo hmoplin lnopfi ffn hmopidmchi pjfni eqfnfv cmv cva
      mp2an cort fnfvelrn mpan id ffvelrni hvsubcl simpl adantr his2sub syl3anc
      adantl hmop mp3an1 sylan2 ccom fveq1i hocoi syl5reqr oveq2d eqtr3d subidd
      wa cc hicl 3eqtrd ralrimiva oveq2 eqeq1d ralrn sylibr wss chssii sylanbrc
      ocel pjcompi hvpncan3 fveq2d mprgbir ) AAUAZUBGZHZDIZAGZWPWNGZHZDJAJKZWNJ
      KWOWSDJLMJJAUCWTAAUDNZAUENBAUFOUGZJJAUHOZWMABCUIZUJDJAWNUKUNWPJNZWQWPWQUL
      TZUMTZWNGZWQWRXEWQWMNZXFWMUOGNZXHWQHWTXEXIXCJWPAUPUQXEXFJNZXFEIZPTZQHZEWM
      LZXJXEXEWQJNZXKXEURZJJWPAXBUSZWPWQUTRXEXFFIZAGZPTZQHZFJLZXOXEYBFJXEXSJNZV
      PZYAWPXTPTZWQXTPTZSTZYFYFSTQYEXEXPXTJNZYAYHHXEYDVAXEXPYDXRVBYDYIXEJJXSAXB
      USZVEWPWQXTVCVDYEYGYFYFSYEWPXTAGZPTZYGYFYDXEYIYLYGHZYJXAXEYIYMBWPXTAVFVGV
      HYEYKXTWPPYDYKXTHXEYDXTXSAAVIZGYKXSYNACVJXSAAXBXBVKVLVEVMVNVMYEYFYDXEYIYF
      VQNYJWPXTVRVHVOVSVTWTXOYCMXCXNYBEFJAXLXTHXMYAQXLXTXFPWAWBWCOWDWMJWEXJXKXO
      VPMWMXDWFEXFWMWHOWGWQXFWMXDWIRXEXGWPWNXEXPXEXGWPHXRXQWQWPWJRWKVNWL $.
  $}

  ${
    $d x T $.
    $( An idempotent Hermitian operator generates a closed subspace.  Part of
       proof of Theorem of [AkhiezerGlazman] p. 64.  (Contributed by NM,
       24-Apr-2006.)  (New usage is discouraged.) $)
    hmopidmch $p |- ( ( T e. HrmOp /\ ( T o. T ) = T ) -> ran T e. CH ) $=
      ( cho wcel ccom wceq wa crn cch chio rneq eleq1d eleq1 id coeq12d eqeq12d
      cif anbi12d idhmop chil wf1o hoif f1of ax-mp hoid1i pm3.2i elimhyp simpli
      wf simpri hmopidmchi dedth ) ABCZAADZAEZFZAGZHCUOAIPZGZHCAIAUQEZUPURHAUQJ
      KUQUQBCZUQUQDZUQEZUOUTVBFIBCZIIDZIEZFAIUSULUTUNVBAUQBLUSUMVAAUQUSAUQAUQUS
      MZVFNVFOQIUQEZVCUTVEVBIUQBLVGVDVAIUQVGIUQIUQVGMZVHNVHOQVCVERISSITSSIUHUAS
      SIUBUCUDUEUFZUGUTVBVIUIUJUK $.

    $( An idempotent Hermitian operator is a projection operator.  Theorem 26.4
       of [Halmos] p. 44.  (Contributed by NM, 22-Apr-2006.)
       (New usage is discouraged.) $)
    hmopidmpj $p |- ( ( T e. HrmOp /\ ( T o. T ) = T ) ->
                    T = ( projh ` ran T ) ) $=
      ( cho wcel ccom wceq wa crn cpjh cfv chio cif rneq fveq2d eqeq12d coeq12d
      id eleq1 anbi12d idhmop chil wf1o wf hoif f1of ax-mp hoid1i pm3.2i simpli
      elimhyp simpri hmopidmpji dedth ) ABCZAADZAEZFZAAGZHIZEUPAJKZUSGZHIZEAJAU
      SEZAUSURVAVBPZVBUQUTHAUSLMNUSUSBCZUSUSDZUSEZUPVDVFFJBCZJJDZJEZFAJVBUMVDUO
      VFAUSBQVBUNVEAUSVBAUSAUSVCVCOVCNRJUSEZVGVDVIVFJUSBQVJVHVEJUSVJJUSJUSVJPZV
      KOVKNRVGVISJTTJUATTJUBUCTTJUDUEUFUGUIZUHVDVFVLUJUKUL $.
  $}

  ${
    $d x H $.  $d x S $.  $d x T $.
    pjsdi.1 $e |- H e. CH $.
    pjsdi.2 $e |- S : ~H --> ~H $.
    pjsdi.3 $e |- T : ~H --> ~H $.
    $( Distributive law for Hilbert space operator sum.  (Contributed by NM,
       12-Nov-2000.)  (New usage is discouraged.) $)
    pjsdii $p |- ( ( projh ` H ) o. ( S +op T ) ) =
                ( ( ( projh ` H ) o. S ) +op ( ( projh ` H ) o. T ) ) $=
      ( vx cfv chos co ccom wceq chil wcel cva ffvelrni wf hosval hocoi hocofi
      cv cpjh wral pjaddi syl2anc mp3an12 fveq2d oveq12d 3eqtr4d hoaddcli hoeqi
      pjfi rgen mpbi ) GUAZCUBHZABIJZKZHZUOUPAKZUPBKZIJZHZLZGMUCURVBLVDGMUOMNZU
      OUQHZUPHZUOUTHZUOVAHZOJZUSVCVEUOAHZUOBHZOJZUPHZVKUPHZVLUPHZOJZVGVJVEVKMNV
      LMNVNVQLMMUOAEPMMUOBFPVKVLCDUDUEVEVFVMUPMMAQMMBQVEVFVMLEFUOABRUFUGVEVHVOV
      IVPOUOUPACDULZESUOUPBVRFSUHUIUOUPUQVRABEFUJZSMMUTQMMVAQVEVCVJLUPAVRETZUPB
      VRFTZUOUTVARUFUIUMGURVBUPUQVRVSTUTVAVTWAUJUKUN $.

    $( Distributive law for Hilbert space operator difference.  (Contributed by
       NM, 24-Nov-2000.)  (New usage is discouraged.) $)
    pjddii $p |- ( ( projh ` H ) o. ( S -op T ) ) =
                ( ( ( projh ` H ) o. S ) -op ( ( projh ` H ) o. T ) ) $=
      ( vx cfv chod co ccom wceq chil wcel cmv ffvelrni wf hodval hocoi hocofi
      cv cpjh wral pjsubi syl2anc mp3an12 fveq2d oveq12d 3eqtr4d hosubcli hoeqi
      pjfi rgen mpbi ) GUAZCUBHZABIJZKZHZUOUPAKZUPBKZIJZHZLZGMUCURVBLVDGMUOMNZU
      OUQHZUPHZUOUTHZUOVAHZOJZUSVCVEUOAHZUOBHZOJZUPHZVKUPHZVLUPHZOJZVGVJVEVKMNV
      LMNVNVQLMMUOAEPMMUOBFPVKVLCDUDUEVEVFVMUPMMAQMMBQVEVFVMLEFUOABRUFUGVEVHVOV
      IVPOUOUPACDULZESUOUPBVRFSUHUIUOUPUQVRABEFUJZSMMUTQMMVAQVEVCVJLUPAVRETZUPB
      VRFTZUOUTVARUFUIUMGURVBUPUQVRVSTUTVAVTWAUJUKUN $.
  $}

  ${
    pjsdi2.1 $e |- H e. CH $.
    pjsdi2.2 $e |- R : ~H --> ~H $.
    pjsdi2.3 $e |- S : ~H --> ~H $.
    pjsdi2.4 $e |- T : ~H --> ~H $.
    $( Chained distributive law for Hilbert space operator difference.
       (Contributed by NM, 30-Nov-2000.)  (New usage is discouraged.) $)
    pjsdi2i $p |- ( ( R o. ( S +op T ) ) = ( ( R o. S ) +op ( R o. T ) )
     -> ( ( ( projh ` H ) o. R ) o. ( S +op T ) ) = ( ( ( ( projh ` H ) o. R )
         o. S ) +op ( ( ( projh ` H ) o. R ) o. T ) ) ) $=
      ( chos co ccom wceq cpjh cfv coeq2 hocofi pjsdii syl6eq coass oveq12i
      3eqtr4g ) ABCIJZKZABKZACKZIJZLZDMNZUCKZUHUDKZUHUEKZIJZUHAKZUBKUMBKZUMCKZI
      JUGUIUHUFKULUCUFUHOUDUEDEABFGPACFHPQRUHAUBSUNUJUOUKIUHABSUHACSTUA $.
  $}

  ${
    $d x y H $.  $d x y G $.
    pjco.1 $e |- G e. CH $.
    pjco.2 $e |- H e. CH $.
    $( Composition of projections.  (Contributed by NM, 16-Aug-2000.)
       (New usage is discouraged.) $)
    pjcoi $p |- ( A e. ~H -> ( ( ( projh ` G ) o. ( projh ` H ) ) ` A ) =
               ( ( projh ` G ) ` ( ( projh ` H ) ` A ) ) ) $=
      ( cpjh cfv pjfi hocoi ) ABFGCFGBDHCEHI $.

    $( Closure of composition of projections.  (Contributed by NM,
       29-Nov-2000.)  (New usage is discouraged.) $)
    pjcocli $p |- ( A e. ~H ->
                 ( ( ( projh ` G ) o. ( projh ` H ) ) ` A ) e. G ) $=
      ( chil wcel cpjh cfv ccom pjcoi pjhcli pjcli syl eqeltrd ) AFGZABHIZCHIZJ
      IARIZQIZBABCDEKPSFGTBGACELSBDMNO $.

    $( Closure of composition of projections.  (Contributed by NM,
       7-Oct-2000.)  (New usage is discouraged.) $)
    pjcohcli $p |- ( A e. ~H ->
                 ( ( ( projh ` G ) o. ( projh ` H ) ) ` A ) e. ~H ) $=
      ( cpjh cfv pjfi hococli ) ABFGCFGBDHCEHI $.

    $( Adjoint of composition of projections.  Special case of Theorem
       3.11(viii) of [Beran] p. 106.  (Contributed by NM, 6-Oct-2000.)
       (New usage is discouraged.) $)
    pjadjcoi $p |- ( ( A e. ~H /\ B e. ~H ) ->
                  ( ( ( ( projh ` G ) o. ( projh ` H ) ) ` A ) .ih B ) =
                  ( A .ih ( ( ( projh ` H ) o. ( projh ` G ) ) ` B ) ) ) $=
      ( chil wcel wa cpjh cfv csp co ccom wceq pjhcli pjadji sylan sylan2 pjcoi
      eqtrd oveq1d adantr oveq2d adantl 3eqtr4d ) AGHZBGHZIZADJKZKZCJKZKZBLMZAB
      ULKZUJKZLMZAULUJNKZBLMZABUJULNKZLMZUIUNUKUOLMZUQUGUKGHUHUNVBOADFPUKBCEQRU
      HUGUOGHVBUQOBCEPAUODFQSUAUGUSUNOUHUGURUMBLACDEFTUBUCUHVAUQOUGUHUTUPALBDCF
      ETUDUEUF $.

    $( Functionality of composition of projections.  (Contributed by NM,
       1-Oct-2000.)  (New usage is discouraged.) $)
    pjcofni $p |- ( ( projh ` G ) o. ( projh ` H ) ) Fn ~H $=
      ( cpjh cfv pjfi hocofni ) AEFBEFACGBDGH $.

    $( Subset relationship for projections.  Theorem 4.5(i)<->(iii) of [Beran]
       p. 112.  (Contributed by NM, 1-Oct-2000.)
       (New usage is discouraged.) $)
    pjss1coi $p |- ( G C_ H <->
                 ( ( projh ` H ) o. ( projh ` G ) ) = ( projh ` G ) ) $=
      ( vx wss cpjh cfv ccom wceq cv chil wral wcel pjcoi adantl pjfi crn pjrni
      wa cch pjcli ssel2 sylan2 pjid sylancr eqtrd ralrimiva hocofi hoeqi sylib
      rneq rncoss syl6eqssr 3sstr3g impbii ) ABFZBGHZAGHZIZUSJZUQEKZUTHZVBUSHZJ
      ZELMVAUQVEELUQVBLNZTZVCVDURHZVDVFVCVHJUQVBBADCOPVGBUANVDBNZVHVDJDVFUQVDAN
      VIVBACUBABVDUCUDVDBUEUFUGUHEUTUSURUSBDQACQZUIVJUJUKVAUSRZURRZABVAVKUTRVLU
      TUSULURUSUMUNACSBDSUOUP $.

    $( Subset relationship for projections.  Theorem 4.5(i)<->(ii) of [Beran]
       p. 112.  (Contributed by NM, 7-Oct-2000.)
       (New usage is discouraged.) $)
    pjss2coi $p |- ( G C_ H <->
                 ( ( projh ` G ) o. ( projh ` H ) ) = ( projh ` G ) ) $=
      ( vx vy cpjh cfv ccom wceq cv chil wral wcel wa wi c0v fveq2 csp co pjcoi
      wss adantl cif fveq2d eqeq12d imbi2d elimel pjss2i dedth impcom ralrimiva
      ax-hv0cl eqtrd hocofi hoeqi sylib oveq2d ad2antlr pjadjcoi adantlr pjadji
      pjfi fveq1 3eqtr4d exp31 ralrimdv wb pjcohcli pjhcli hial2eq sylibd com12
      syl2anc ralrimiv pjss1coi sylibr impbii ) ABUBZAGHZBGHZIZVTJZVSEKZWBHZWDV
      THZJZELMWCVSWGELVSWDLNZOWEWDWAHZVTHZWFWHWEWJJVSWDABCDUAUCWHVSWJWFJZWHVSWK
      PVSWHWDQUDZWAHZVTHZWLVTHZJZPWDQWDWLJZWKWPVSWQWJWNWFWOWQWIWMVTWDWLWARUEWDW
      LVTRUFUGWLBACWDQLUMUHDUIUJUKUNULEWBVTVTWAACVCZBDVCZUOWRUPUQWCWAVTIZVTJZVS
      WCWDWTHZWFJZELMXAWCXCELWHWCXCWHWCXBFKZSTZWFXDSTZJZFLMZXCWHWCXGFLWHWCXDLNZ
      XGWHWCOXIOWDXDWBHZSTZWDXDVTHZSTZXEXFWCXKXMJWHXIWCXJXLWDSXDWBVTVDURUSWHXIX
      EXKJWCWDXDBADCUTVAWHXIXFXMJWCWDXDACVBVAVEVFVGWHXBLNWFLNXHXCVHWDBADCVIWDAC
      VJFXBWFVKVNVLVMVOEWTVTWAVTWSWRUOWRUPUQABCDVPVQVR $.

    $( Projection meet property.  Remark in [Kalmbach] p. 66.  Also Theorem
       4.5(i)->(iv) of [Beran] p. 112.  (Contributed by NM, 26-Sep-2001.)
       (New usage is discouraged.) $)
    pjssmi $p |- ( A e. ~H -> ( H C_ G ->
               ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) )
                = ( ( projh ` ( G i^i ( _|_ ` H ) ) ) ` A ) ) ) $=
      ( chil wcel wss cpjh cfv cmv co cort cin wceq wi c0v cif fveq2 oveq12d
      eqeq12d imbi2d ax-hv0cl elimel pjssmii dedth ) AFGZCBHZABIJZJZACIJZJZKLZA
      BCMJNIJZJZOZPUHUGAQRZUIJZUQUKJZKLZUQUNJZOZPAQAUQOZUPVBUHVCUMUTUOVAVCUJURU
      LUSKAUQUISAUQUKSTAUQUNSUAUBUQBCEAQFUCUDDUEUF $.

    $( Theorem 4.5(iv)->(v) of [Beran] p. 112.  (Contributed by NM,
       26-Sep-2001.)  (New usage is discouraged.) $)
    pjssge0i $p |- ( A e. ~H ->
                 ( ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) )
                  = ( ( projh ` ( G i^i ( _|_ ` H ) ) ) ` A ) ->
       0 <_ ( ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) ) .ih A ) ) ) $=
      ( chil wcel cpjh cfv cmv co wceq cc0 csp cle wbr wi c0v fveq2 oveq12d cin
      cort cif eqeq12d id breq2d imbi12d ax-hv0cl elimel pjssge0ii dedth ) AFGZ
      ABHIZIZACHIZIZJKZABCUBIUAHIZIZLZMUQANKZOPZQULARUCZUMIZVCUOIZJKZVCURIZLZMV
      FVCNKZOPZQARAVCLZUTVHVBVJVKUQVFUSVGVKUNVDUPVEJAVCUMSAVCUOSTZAVCURSUDVKVAV
      IMOVKUQVFAVCNVLVKUETUFUGVCBCEARFUHUIDUJUK $.

    $( Theorem 4.5(v)<->(vi) of [Beran] p. 112.  (Contributed by NM,
       26-Sep-2001.)  (New usage is discouraged.) $)
    pjdifnormi $p |- ( A e. ~H -> ( 0 <_
                ( ( ( ( projh ` G ) ` A ) -h ( ( projh ` H ) ` A ) ) .ih A )
        <->
  ( normh ` ( ( projh ` H ) ` A ) ) <_ ( normh ` ( ( projh ` G ) ` A ) ) ) ) $=
      ( chil cc0 cpjh cfv cmv co csp cle wbr cno wb c0v fveq2 oveq12d fveq2d id
      wcel cif wceq breq2d breq12d bibi12d ax-hv0cl elimel pjdifnormii dedth )
      AFUBZGABHIZIZACHIZIZJKZALKZMNZUPOIZUNOIZMNZPGULAQUCZUMIZVCUOIZJKZVCLKZMNZ
      VEOIZVDOIZMNZPAQAVCUDZUSVHVBVKVLURVGGMVLUQVFAVCLVLUNVDUPVEJAVCUMRZAVCUORZ
      SVLUASUEVLUTVIVAVJMVLUPVEOVNTVLUNVDOVMTUFUGVCBCEAQFUHUIDUJUK $.

    $( Theorem 4.5(i)<->(vi) of [Beran] p. 112.  (Contributed by NM,
       26-Sep-2001.)  (New usage is discouraged.) $)
    pjnormssi $p |- ( G C_ H <-> A. x e. ~H ( normh ` ( ( projh ` G ) ` x ) )
        <_ ( normh ` ( ( projh ` H ) ` x ) ) ) $=
      ( wss cpjh cfv cno cle wbr chil wcel cc0 co wceq wi wa syl wb cv wral cmv
      csp cort cin pjssmi pjssge0i pjdifnormi sylibd com12 ralrimiv wal choccli
      syld cheli breq2 biimpac pjhcli normge0 normcl 0re letri3 biimprd sylancl
      cr sylan2i anabsi6 sylan2 expr c0v norm-i cch pjoc2 bitr4d adantr 3imtr3d
      mpan a2i syl5 pm2.43d alimi df-ral dfss2 3imtr4i chsscon3i sylibr impbii
      ex ) BCFZAUAZBGHHZIHZWKCGHHZIHZJKZALUBZWJWPALWKLMZWJWPWRWJNWNWLUCOZWKUDOJ
      KZWPWRWJWSWKCBUEHZUFGHHPWTWKCBEDUGWKCBEDUHUOWKCBEDUIUJUKULWQCUEHZXAFZWJWR
      WPQZAUMWKXBMZWKXAMZQZAUMWQXCXDXGAXDXEXFXEWRXDXGWKXBCEUNUPWRWPXGWRWPXGWRWP
      RWONPZWMNPZXEXFWRWPXHXIWPXHRWRWMNJKZXIXHWPXJWONWMJUQURWRXJXIWRWRXJNWMJKZX
      IWRWLLMZXKWKBDUSZWLUTSWRWMVFMZNVFMZXJXKRZXIQWRXLXNXMWLVASVBXNXORXIXPWMNVC
      VDVEVGVHVIVJWRXHXETWPWRXHWNVKPZXEWRWNLMXHXQTWKCEUSWNVLSCVMMWRXEXQTEWKCVNV
      RVOVPWRXIXFTWPWRXIWLVKPZXFWRXLXIXRTXMWLVLSBVMMWRXFXRTDWKBVNVRVOVPVQWIVSVT
      WAWBWPALWCAXBXAWDWEBCDEWFWGWH $.

    $( Composition of projections of orthogonal subspaces.  Part (i)->(iia) of
       Theorem 27.4 of [Halmos] p. 45.  (Contributed by NM, 6-Nov-2000.)
       (New usage is discouraged.) $)
    pjorthcoi $p |- ( G C_ ( _|_ ` H ) ->
                 ( ( projh ` G ) o. ( projh ` H ) ) = 0hop ) $=
      ( vx cort cfv wss cv cpjh ccom ch0o wceq chil wral wcel c0v adantl pjfi
      wa pjcli wi chsscon2i ssel sylbi syl5com cch pjhcli sylancr sylibd impcom
      wb pjoc2 pjcoi ho0val 3eqtr4d ralrimiva hocofi ho0f hoeqi sylib ) ABFGHZE
      IZAJGZBJGZKZGZVCLGZMZENOVFLMVBVIENVBVCNPZTVCVEGZVDGZQVGVHVJVBVLQMZVJVBVKA
      FGZPZVMVJVKBPZVBVOVCBDUAVBBVNHVPVOUBABCDUCBVNVKUDUEUFVJAUGPVKNPVOVMULCVCB
      DUHVKAUMUIUJUKVJVGVLMVBVCABCDUNRVJVHQMVBVCUORUPUQEVFLVDVEACSBDSURUSUTVA
      $.

    $( The projection of orthogonal subspaces is the sum of the projections.
       (Contributed by NM, 11-Nov-2000.)  (New usage is discouraged.) $)
    pjscji $p |- ( G C_ ( _|_ ` H ) -> ( projh ` ( G vH H ) ) =
              ( ( projh ` G ) +op ( projh ` H ) ) ) $=
      ( vx cort cfv wss cv chj co cpjh chos wceq chil wcel cch mp3an12 wf pjfi
      wa cva pjcjt2 impcom hosval adantl eqtr4d ralrimiva chjcli hoaddcli hoeqi
      wral wi sylib ) ABFGHZEIZABJKZLGZGZUPALGZBLGZMKZGZNZEOULURVBNUOVDEOUOUPOP
      ZUAUSUPUTGUPVAGUBKZVCVEUOUSVFNZAQPBQPVEUOVGUMCDUPBAUCRUDVEVCVFNZUOOOUTSOO
      VASVEVHACTZBDTZUPUTVAUERUFUGUHEURVBUQABCDUITUTVAVIVJUJUKUN $.

    $( The projection on a subspace sum is the sum of the projections.
       (Contributed by NM, 11-Nov-2000.)  (New usage is discouraged.) $)
    pjssumi $p |- ( G C_ ( _|_ ` H ) -> ( projh ` ( G +H H ) ) =
              ( ( projh ` G ) +op ( projh ` H ) ) ) $=
      ( cort cfv wss cph co cpjh chj chos osumi fveq2d pjscji eqtrd ) ABEFGZABH
      IZJFABKIZJFAJFBJFLIQRSJABCDMNABCDOP $.

    $( Projector ordering can be expressed by the subset relationship between
       their projection subspaces.  (i)<->(iii) of Theorem 29.2 of [Halmos]
       p. 48.  (Contributed by NM, 2-Jun-2006.)  (New usage is discouraged.) $)
    pjssposi $p |- ( A. x e. ~H
           0 <_ ( ( ( ( projh ` H ) -op ( projh ` G ) ) ` x ) .ih x )
        <-> G C_ H ) $=
      ( cc0 cpjh cfv co csp cle wbr chil wral cno wcel c2 cexp cmin syl cv chod
      wss cr pjhcli normcl resqcld subge0d cmv wf wceq hodval mp3an12 oveq1d id
      pjfi his2sub syl3anc oveq12d 3eqtrd breq2d normge0 le2sqd 3bitr4d ralbiia
      pjinormi pjnormssi bitr4i ) FAUAZCGHZBGHZUBIHZVIJIZKLZAMNVIVKHZOHZVIVJHZO
      HZKLZAMNBCUCVNVSAMVIMPZFVRQRIZVPQRIZSIZKLWBWAKLVNVSVTWAWBVTVRVTVQMPZVRUDP
      VICEUEZVQUFTZUGVTVPVTVOMPZVPUDPVIBDUEZVOUFTZUGUHVTVMWCFKVTVMVQVOUIIZVIJIZ
      VQVIJIZVOVIJIZSIZWCVTVLWJVIJMMVJUJMMVKUJVTVLWJUKCEUPBDUPVIVJVKULUMUNVTWDW
      GVTWKWNUKWEWHVTUOVQVOVIUQURVTWLWAWMWBSVICEVFVIBDVFUSUTVAVTVPVRWIWFVTWGFVP
      KLWHVOVBTVTWDFVRKLWEVQVBTVCVDVEABCDEVGVH $.

    $( The definition of projector ordering in [Halmos] p. 42 is equivalent to
       the definition of projector ordering in [Beran] p. 110.  (We will
       usually express projector ordering with the even simpler equivalent
       ` G C_ H ` ; see ~ pjssposi ).  (Contributed by NM, 2-Jun-2006.)
       (New usage is discouraged.) $)
    pjordi $p |- ( A. x e. ~H
        0 <_ ( ( ( ( projh ` H ) -op ( projh ` G ) ) ` x ) .ih x ) <->
        ( ( projh ` G ) " ~H ) C_ ( ( projh ` H ) " ~H ) ) $=
      ( cc0 cv cpjh cfv chod co csp chil wss cima wfo wceq pjfoi foima ax-mp
      cle wbr wral pjssposi sseq12i bitr4i ) FAGZCHIZBHIZJKIUGLKUAUBAMUCBCNUIMO
      ZUHMOZNABCDEUDUJBUKCMBUIPUJBQBDRMBUISTMCUHPUKCQCERMCUHSTUEUF $.

    $( The projection subspace of the difference between two projectors.  Part
       2 of Theorem 29.3 of [Halmos] p. 48 (shortened with ~ pjssposi ).
       (Contributed by NM, 2-Jun-2006.)  (New usage is discouraged.) $)
    pjssdif2i $p |- ( G C_ H <-> ( ( projh ` H ) -op ( projh ` G ) )
        = ( projh ` ( H i^i ( _|_ ` G ) ) ) ) $=
      ( vx cpjh cfv co wceq chil wral wa pjfi adantl ralrimiva wfn cc0 csp cle
      wf wss chod cort cin wcel cmv hodval mp3an12 pjssmi impcom eqtrd hosubfni
      cv wb choccli chincli pjfni eqfnfv mp2an sylibr wbr pjige0i oveq1d adantr
      fveq1 breqtrrd pjssposi sylib impbii ) ABUAZBFGZAFGZUBHZBAUCGZUDZFGZIZVJE
      UMZVMGZVRVPGZIZEJKZVQVJWAEJVJVRJUEZLVSVRVKGVRVLGUFHZVTWCVSWDIZVJJJVKTJJVL
      TWCWEBDMZACMZVRVKVLUGUHNWCVJWDVTIVRBADCUIUJUKOVMJPVPJPVQWBUNVKVLWFWGULVOB
      VNDACUOUPZUQEJVMVPURUSUTVQQVSVRRHZSVAZEJKVJVQWJEJVQWCLQVTVRRHZWISWCQWKSVA
      VQVRVOWHVBNVQWIWKIWCVQVSVTVRRVRVMVPVEVCVDVFOEABCDVGVHVI $.

    $( A necessary and sufficient condition for the difference between two
       projectors to be a projector.  Part 1 of Theorem 29.3 of [Halmos] p. 48
       (shortened with ~ pjssposi ).  (Contributed by NM, 2-Jun-2006.)
       (New usage is discouraged.) $)
    pjssdif1i $p |- ( G C_ H <->
                  ( ( projh ` H ) -op ( projh ` G ) ) e. ran projh ) $=
      ( vy vx cpjh cfv co wceq wcel cch pjmfn cc0 cv csp cle wbr chil wb mpbiri
      wss chod cort cin crn pjssdif2i choccli chincli fnfvelrn mp2an eleq1 wral
      wfn wrex fvelrnb ax-mp wa pjige0 adantlr oveq1d breq2d ad2antlr ralrimiva
      fveq1 mpbid rexlimiva sylbi pjssposi bitri sylib impbii ) ABUBZBGHAGHUCIZ
      BAUDHZUEZGHZJZVNGUFZKZABCDUGZVRVTVRVTVQVSKZGLUNZVPLKWBMBVODACUHUILVPGUJUK
      VNVQVSULUAVTNEOZVNHZWDPIZQRZESUMZVRVTFOZGHZVNJZFLUOZWHWCVTWLTMFLVNGUPUQWK
      WHFLWILKZWKURZWGESWNWDSKZURNWDWJHZWDPIZQRZWGWMWOWRWKWDWIUSUTWKWRWGTWMWOWK
      WQWFNQWKWPWEWDPWDWJVNVEVAVBVCVFVDVGVHWHVMVREABCDVIWAVJVKVLVJ $.
  $}

  ${
    $d u v w A $.  $d u v w B $.
    pjima.1 $e |- A e. SH $.
    pjima.2 $e |- B e. CH $.
    $( The image of a projection.  Lemma 5 in Daniel Lehmann, "A presentation
       of Quantum Logic based on an _and then_ connective"
       ~ http://www.arxiv.org/pdf/quant-ph/0701113 p. 20.  (Contributed by NM,
       20-Jan-2007.)  (New usage is discouraged.) $)
    pjimai $p |- ( ( projh ` B ) " A ) = ( ( A +H ( _|_ ` B ) ) i^i B ) $=
      ( vu vv vw cfv co cv wcel wa wceq wrex cva chil wb w3a cheli bitr4d sheli
      cpjh cima cort cph cin cmv cch pjeq sylancr ibar bicomd sylan9bbr choccli
      hvsubadd 3comr ax-hvcom 3adant2 eqeq1d syl3an eqcom 3bitr4g 3expa wfn wss
      rexbidva pjfni shssii fvelimab mp2an csh chshii shsel3 pm5.32ri crn pjrni
      imassrn sseqtri sseli pm4.71i elin 3bitr4i eqriv ) EBUBHZAUCZABUDHZUEIZBU
      FZEJZWEKZWIBKZLWIWGKZWKLWJWIWHKWKWJWLWKFJZWDHWIMZFANZWIWMGJZUGIZMZGWFNZFA
      NZWJWLWKWNWSFAWKWMAKZLZWNWMWIWPOIZMZGWFNZWSXAWNWKXELZWKXEXABUHKWMPKZWNXFQ
      DWMACUAZGWMWIBUIUJWKXEXFWKXEUKULUMXBWRXDGWFWKXAWPWFKZWRXDQWKXAXIRWQWIMZXC
      WMMZWRXDWKWIPKZXAXGXIWPPKZXJXKQWIBDSXHWPWFBDUNZSXLXGXMRZXJWPWIOIZWMMZXKXG
      XMXLXJXQQWMWPWIUOUPXOXCXPWMXLXMXCXPMXGWIWPUQURUSTUTWIWQVAWMXCVAVBVCVFTVFW
      DPVDAPVEWJWOQBDVGACVHFPAWIWDVIVJAVKKWFVKKWLWTQCWFXNVLFGAWFWIVMVJVBVNWJWKW
      EBWIWEWDVOBWDAVQBDVPVRVSVTWIWGBWAWBWC $.
  $}

  ${
    $d x H $.
    pjidmco.1 $e |- H e. CH $.
    $( A projection is idempotent.  Property (ii) of [Beran] p. 109.
       (Contributed by NM, 1-Oct-2000.)  (New usage is discouraged.) $)
    pjidmcoi $p |- ( ( projh ` H ) o. ( projh ` H ) ) = ( projh ` H ) $=
      ( wss cpjh cfv ccom wceq ssid pjss2coi mpbi ) AACADEZKFKGAHAABBIJ $.

    $( Composition of projections of a subspace and its orthocomplement.
       (Contributed by NM, 14-Nov-2000.)  (New usage is discouraged.) $)
    pjoccoi $p |- ( ( projh ` H ) o. ( projh ` ( _|_ ` H ) ) ) = 0hop $=
      ( chil wss cort cpjh ccom ch0o wceq chssii ococss choccli pjorthcoi mp2b
      cfv ) ACDAAEOZEODAFOPFOGHIABJAKAPBABLMN $.

    $( Subspace sum of projection and projection of orthocomplement.
       (Contributed by NM, 16-Nov-2000.)  (New usage is discouraged.) $)
    pjtoi $p |- ( ( projh ` H ) +op ( projh ` ( _|_ ` H ) ) )
        = ( projh ` ~H ) $=
      ( vx cv cpjh cfv cort chos co chil wceq wral wcel cva cch axpjpj pjch1 wf
      mpan pjfi choccli hosval mp3an12 3eqtr4rd rgen hoaddcli helch hoeqi mpbi
      ) CDZAEFZAGFZEFZHIZFZUJJEFZFZKZCJLUNUPKURCJUJJMZUJUJUKFUJUMFNIZUQUOAOMUSU
      JUTKBUJAPSUJQJJUKRJJUMRUSUOUTKABTZULABUATZUJUKUMUBUCUDUECUNUPUKUMVAVBUFJU
      GTUHUI $.

    $( Projection of orthocomplement.  First part of Theorem 27.3 of [Halmos]
       p. 45.  (Contributed by NM, 26-Nov-2000.)
       (New usage is discouraged.) $)
    pjoci $p |- ( ( projh ` ~H ) -op ( projh ` H ) )
        = ( projh ` ( _|_ ` H ) ) $=
      ( chil cpjh cfv chod cort wceq chos pjtoi helch pjfi choccli hodsi mpbir
      co ) CDEZADEZFPAGEZDEZHRTIPQHABJQRTCKLABLSABMLNO $.
  $}

  $( A projection operator is idempotent.  Property (ii) of [Beran] p. 109.
     (Contributed by NM, 24-Apr-2006.)  (New usage is discouraged.) $)
  pjidmco $p |- ( H e. CH ->
                 ( ( projh ` H ) o. ( projh ` H ) ) = ( projh ` H ) ) $=
    ( cch wcel cpjh cfv ccom wceq c0h cif fveq2 coeq12d eqeq12d h0elch pjidmcoi
    elimel dedth ) ABCZADEZRFZRGQAHIZDEZUAFZUAGAHATGZSUBRUAUCRUARUAATDJZUDKUDLT
    AHBMONP $.

  ${
    $d h t u x T $.
    $( Definition of projection operator in [Hughes] p. 47, except that we do
       not need linearity to be explicit by virtue of ~ hmoplin .  (Contributed
       by NM, 24-Apr-2006.)  (Revised by Mario Carneiro, 19-May-2014.)
       (New usage is discouraged.) $)
    dfpjop $p |- ( T e. ran projh <-> ( T e. HrmOp /\ ( T o. T ) = T ) ) $=
      ( vx cpjh crn wcel cho ccom wceq wa cv cfv cch wfn wb pjmfn fvelrnb ax-mp
      wrex pjhmop pjidmco jca eleq1 id coeq12d eqeq12d syl5ibcom rexlimiv sylbi
      anbi12d hmopidmpj hmopidmch fnfvelrn sylancr eqeltrd impbii ) ACDZEZAFEZA
      AGZAHZIZUQBJZCKZAHZBLRZVACLMZUQVENOBLACPQVDVABLVBLEZVCFEZVCVCGZVCHZIVDVAV
      GVHVJVBSVBTUAVDVHURVJUTVCAFUBVDVIUSVCAVDVCAVCAVDUCZVKUDVKUEUIUFUGUHVAAADZ
      CKZUPAUJVAVFVLLEVMUPEOAUKLVLCULUMUNUO $.

    $( Two ways to express the set of all projection operators.  (Contributed
       by NM, 24-Apr-2006.)  (Proof shortened by Mario Carneiro, 19-May-2014.)
       (New usage is discouraged.) $)
    pjhmopidm $p |- ran projh = { t e. HrmOp | ( t o. t ) = t } $=
      ( cpjh crn cv cho wcel ccom wceq wa cab crab dfpjop abbi2i df-rab eqtr4i
      ) BCZADZEFQQGQHZIZAJRAEKSAPQLMRAENO $.
  $}

  $( A projection operator is idempotent.  Part of Theorem 26.1 of [Halmos]
     p. 43.  (Contributed by NM, 24-Apr-2006.)  (New usage is discouraged.) $)
  elpjidm $p |- ( T e. ran projh -> ( T o. T ) = T ) $=
    ( cpjh crn wcel cho ccom wceq dfpjop simprbi ) ABCDAEDAAFAGAHI $.

  $( A projection operator is Hermitian.  Part of Theorem 26.1 of [Halmos]
     p. 43.  (Contributed by NM, 24-Apr-2006.)  (New usage is discouraged.) $)
  elpjhmop $p |- ( T e. ran projh -> T e. HrmOp ) $=
    ( cpjh crn wcel cho ccom wceq dfpjop simplbi ) ABCDAEDAAFAGAHI $.

  $( A projector is a positive operator.  (Contributed by NM, 27-Sep-2008.)
     (New usage is discouraged.) $)
  0leopj $p |- ( T e. ran projh -> 0hop <_op T ) $=
    ( cpjh crn wcel ch0o ccom cleo cho wbr elpjhmop leopsq syl elpjidm breqtrd
    ) ABCDZEAAFZAGOAHDEPGIAJAKLAMN $.

  $( A projector is self-adjoint.  Property (i) of [Beran] p. 109.
     (Contributed by NM, 3-Jun-2006.)  (New usage is discouraged.) $)
  pjadj2 $p |- ( T e. ran projh -> ( adjh ` T ) = T ) $=
    ( cpjh crn wcel cho cado cfv wceq elpjhmop hmopadj syl ) ABCDAEDAFGAHAIAJK
    $.

  $( A projector is self-adjoint.  Property (i) of [Beran] p. 109.
     (Contributed by NM, 20-Feb-2006.)  (New usage is discouraged.) $)
  pjadj3 $p |- ( H e. CH -> ( adjh ` ( projh ` H ) ) = ( projh ` H ) ) $=
    ( cch wcel cpjh cfv crn cado wceq wfn pjmfn fnfvelrn mpan pjadj2 syl ) ABCZ
    ADEZDFCZPGEPHDBIOQJBADKLPMN $.

  ${
    $d x y T $.
    $( Reconstruction of the subspace of a projection operator.  Part of
       Theorem 26.2 of [Halmos] p. 44.  (Contributed by NM, 24-Apr-2006.)
       (New usage is discouraged.) $)
    elpjch $p |- ( T e. ran projh -> ( ran T e. CH /\
                T = ( projh ` ran T ) ) ) $=
      ( cpjh crn wcel cho ccom wceq wa cch cfv dfpjop hmopidmch hmopidmpj sylbi
      jca ) ABCDAEDAAFAGHZACZIDZAQBJGZHAKPRSALAMON $.

    $( Reconstruction of the subspace of a projection operator.  (Contributed
       by NM, 24-Apr-2006.)  (Revised by Mario Carneiro, 19-May-2014.)
       (New usage is discouraged.) $)
    elpjrn $p |- ( T e. ran projh -> ran T = { x e. ~H | ( T ` x ) = x } ) $=
      ( vy cpjh crn wcel cv chil cfv wceq wa cab crab cch wss elpjch simpld syl
      sylan syl5ibcom chss sseld wrex wfn wb wf cho elpjhmop hmopf fvelrnb ccom
      fvco3 elpjidm adantr fveq1d eqtr3d fveq2 id eqeq12d rexlimdva sylbid jcad
      ffn fnfvelrn eleq1 expimpd impbid abbi2dv df-rab syl6eqr ) BDEFZBEZAGZHFZ
      VMBIZVMJZKZALVPAHMVKVQAVLVKVMVLFZVQVKVRVNVPVKVLHVMVKVLNFZVLHOVKVSBVLDIJBP
      QVLUARUBVKVRCGZBIZVMJZCHUCZVPVKBHUDZVRWCUEVKHHBUFZWDVKBUGFWEBUHBUIRZHHBVC
      RZCHVMBUJRVKWBVPCHVKVTHFZKZWABIZWAJWBVPWIVTBBUKZIZWJWAVKWEWHWLWJJWFHHVTBB
      ULSWIVTWKBVKWKBJWHBUMUNUOUPWBWJVOWAVMWAVMBUQWBURUSTUTVAVBVKVNVPVRVKVNKVOV
      LFZVPVRVKWDVNWMWGHVMBVDSVOVMVLVETVFVGVHVPAHVIVJ $.
  $}

  ${
    $d x H $.  $d x S $.  $d x T $.
    pjinvar.1 $e |- S : ~H --> ~H $.
    pjinvar.2 $e |- H e. CH $.
    pjinvar.3 $e |- T = ( projh ` H ) $.
    $( A closed subspace ` H ` with projection ` T ` is invariant under an
       operator ` S ` iff ` S T = T S T ` .  Theorem 27.1 of [Halmos] p. 45.
       (Contributed by NM, 24-Apr-2006.)  (New usage is discouraged.) $)
    pjinvari $p |- ( ( S o. T ) : ~H --> H <->
                  ( S o. T ) = ( T o. ( S o. T ) ) ) $=
      ( vx chil ccom wf wceq cv cfv wral wcel wa cpjh wfn mp2an hocofni ffvelrn
      fveq1i cch pjid sylancr syl5req fvco3 eqtr4d ralrimiva wb wss pjfoi ax-mp
      wfo fof feq1i mpbir chssii fss hocofi eqfnfv sylibr feq1 mpbiri impbii
      fco ) HCABIZJZVGBVGIZKZVHGLZVGMZVKVIMZKZGHNZVJVHVNGHVHVKHOPZVLVLBMZVMVPVQ
      VLCQMZMZVLVLBVRFUBVPCUCOVLCOVSVLKEHCVKVGUAVLCUDUEUFHCVKBVGUGUHUIVGHRVIHRV
      JVOUJABDHCBJZCHUKHHBJVTHCVRJZHCVRUNWACEULHCVRUOUMHCBVRFUPUQZCEURHCHBUSSZT
      BVGWCABDWCUTZTGHVGVIVASVBVJVHHCVIJZVTHHVGJWEWBWDHHCBVGVFSHCVGVIVCVDVE $.
  $}

  ${
    pjin1.1 $e |- G e. CH $.
    pjin1.2 $e |- H e. CH $.
    $( Lemma for Theorem 1.22 of Mittelstaedt, p. 20.  (Contributed by NM,
       22-Apr-2001.)  (New usage is discouraged.) $)
    pjin1i $p |- ( projh ` ( G i^i H ) ) =
                ( ( projh ` G ) o. ( projh ` ( G i^i H ) ) ) $=
      ( cpjh cfv cin ccom wss wceq inss1 chincli pjss1coi mpbi eqcomi ) AEFABGZ
      EFZHZQPAIRQJABKPAABCDLCMNO $.

    $( Lemma for Theorem 1.22 of Mittelstaedt, p. 20.  (Contributed by NM,
       22-Apr-2001.)  (New usage is discouraged.) $)
    pjin2i $p |- ( ( ( projh ` G ) = ( ( projh ` G ) o. ( projh ` H ) ) /\
                    ( projh ` H ) = ( ( projh ` H ) o. ( projh ` G ) ) ) <->
                ( projh ` G ) = ( projh ` H ) ) $=
      ( cpjh cfv ccom wceq wa wss eqss pjss2coi eqcom bitri anbi12i fveq2 sylbi
      bitr2i pjidmcoi coeq2 syl5eqr syl6req jca impbii ) AEFZUEBEFZGZHZUFUFUEGZ
      HZIZUEUFHZUKABHZULUMABJZBAJZIUKABKUNUHUOUJUNUGUEHUHABCDLUGUEMNUOUIUFHUJBA
      DCLUIUFMNORABEPQULUHUJULUEUEUEGUGACSUEUFUETUAULUIUFUFGUFUEUFUFTBDSUBUCUD
      $.
  $}

  ${
    pjin3.1 $e |- F e. CH $.
    pjin3.2 $e |- G e. CH $.
    pjin3.3 $e |- H e. CH $.
    $( Lemma for Theorem 1.22 of Mittelstaedt, p. 20.  (Contributed by NM,
       22-Apr-2001.)  (New usage is discouraged.) $)
    pjin3i $p |- ( ( ( projh ` F ) = ( ( projh ` F ) o. ( projh ` G ) ) /\
                    ( projh ` F ) = ( ( projh ` F ) o. ( projh ` H ) ) )
          <-> ( projh ` F ) = ( ( projh ` F ) o. ( projh ` ( G i^i H ) ) ) ) $=
      ( wss wa cin cpjh cfv ccom wceq ssin pjss2coi eqcom bitri anbi12i chincli
      3bitr3i ) ABGZACGZHABCIZGZAJKZUEBJKLZMZUEUECJKLZMZHUEUEUCJKLZMZABCNUAUGUB
      UIUAUFUEMUGABDEOUFUEPQUBUHUEMUIACDFOUHUEPQRUDUJUEMUKAUCDBCEFSOUJUEPQT $.
  $}

  ${
    $d x y G $.  $d x y H $.
    pjclem1.1 $e |- G e. CH $.
    pjclem1.2 $e |- H e. CH $.
    $( Lemma for projection commutation theorem.  (Contributed by NM,
       16-Nov-2000.)  (New usage is discouraged.) $)
    pjclem1 $p |- ( G C_H H
       -> ( ( projh ` G ) o. ( projh ` H ) ) = ( projh ` ( G i^i H ) ) ) $=
      ( cpjh cfv ccom cort chos co cin ch0o chj wceq sylbi chincli ax-mp eqeq2i
      wss pjfi ccm wbr cmbri fveq2 inss2 choccli chub2i chdmm3i sseqtr4i pjscji
      sstri coeq2 pjsdii pjss1coi mpbi pjorthcoi oveq12i hoaddid1i 3eqtri inss1
      syl6eq syl cmcm3i bitri chdmm4i chub1i chdmm2i oveq12d chil df-iop coeq2i
      chio hoid1i eqtr3i pjtoi hocofi eqtr2i 3eqtr3g ) ABUAUBZAEFZBEFZVTGZGZVTW
      AAHFZEFZGZGZIJZABKZEFZLIJZVTWAGZWJVSWCWJWGLIVSVTWIABHFZKZMJZEFZNZWCWJNZVS
      AWONWQABCDUCAWOEUDOWQVTWJWNEFZIJZNZWRWPWTVTWIWNHFZSWPWTNWIBXBABUEZBWDBMJX
      BBWDDACUFZUGABCDUHUIZUKWIWNABCDPZAWMCBDUFZPZUJQRXAWBWAWTGZNZWRVTWTWAULXJW
      BWJNZWRXIWJWBXIWAWJGZWAWSGZIJWKWJWJWSBDWIXFTZWNXHTUMXLWJXMLIWIBSXLWJNXCWI
      BXFDUNUOBXBSXMLNXEBWNDXHUPQUQWJXNURZUSRXKWCVTWJGZWJWBWJVTULWIASXPWJNABUTW
      IAXFCUNUOVAOVBOVBVSWDWDBKZWDWMKZMJZNZWGLNZVSWDBUAUBXTABCDVCWDBXDDUCVDXTWE
      XSEFZNZYAWDXSEUDYCWEXQEFZXREFZIJZNZYAYBYFWEXQXRHFZSYBYFNXQBYHWDBUEZBABMJY
      HBADCUGABCDVEUIZUKXQXRWDBXDDPZWDWMXDXGPZUJQRYGWFWAYFGZNZYAWEYFWAULYNWFYDN
      ZYAYMYDWFYMWAYDGZWAYEGZIJYDLIJYDYDYEBDXQYKTZXRYLTUMYPYDYQLIXQBSYPYDNYIXQB
      YKDUNUOBYHSYQLNYJBXRDYLUPQUQYDYRURUSRYOWGVTYDGZLWFYDVTULAXQHFZSYSLNAAWMMJ
      YTAWMCXGVFABCDVGUIAXQCYKUPQVAOVBOVBOVHWLVTWBWFIJZGWHWAUUAVTWAVIEFZGZWAUUA
      WAVLGUUCWAVLUUBWAVJVKWABDTZVMVNWAVTWEIJZGUUCUUAUUEUUBWAACVOVKVTWEBDACTZWD
      XDTZUMVNVNVKWBWFACWAVTUUDUUFVPWAWEUUDUUGVPUMVQXOVR $.

    $( Lemma for projection commutation theorem.  (Contributed by NM,
       17-Nov-2000.)  (New usage is discouraged.) $)
    pjclem2 $p |- ( G C_H H ->
       ( ( projh ` G ) o. ( projh ` H ) ) = ( ( projh ` H ) o. ( projh ` G ) )
        ) $=
      ( ccm wbr cin cpjh cfv ccom incom fveq2i pjclem1 wceq cmcmi sylbi 3eqtr4a
      ) ABEFZABGZHIBAGZHIZAHIZBHIZJUCUBJZSTHABKLABCDMRBAEFUDUANABCDOBADCMPQ $.

    $( Lemma for projection commutation theorem.  (Contributed by NM,
       26-Nov-2000.)  (New usage is discouraged.) $)
    pjclem3 $p |- ( ( ( projh ` G ) o. ( projh ` H ) ) =
                    ( ( projh ` H ) o. ( projh ` G ) ) ->
                     ( ( projh ` G ) o. ( projh ` ( _|_ ` H ) ) ) =
                     ( ( projh ` ( _|_ ` H ) ) o. ( projh ` G ) ) ) $=
      ( cpjh cfv ccom wceq chil chod cort chio df-iop coeq2i pjfi hoid1i eqtr3i
      co hoid1ri coeq1i 3eqtr2i oveq1i syl5eq pjddii hocsubdiri 3eqtr4g 3eqtr3g
      oveq2 helch pjoci ) AEFZBEFZGZULUKGZHZUKIEFZULJRZGZUQUKGZUKBKFEFZGUTUKGUO
      UKUPGZUMJRZUPUKGZUNJRZURUSUOVBVCUMJRVDVAVCUMJVAUKLUKGVCUKLGVAUKLUPUKMNUKA
      COZPQUKVESLUPUKMTUAUBUMUNVCJUHUCUPULACIUIOZBDOZUDUPULUKVFVGVEUEUFUQUTUKBD
      UJZNUQUTUKVHTUG $.

    $( Lemma for projection commutation theorem.  (Contributed by NM,
       2-Dec-2000.)  (New usage is discouraged.) $)
    pjclem4a $p |- ( A e. ( G i^i H ) ->
               ( ( ( projh ` G ) o. ( projh ` H ) ) ` A ) = A ) $=
      ( cin wcel wa cpjh cfv ccom wceq elin chil cheli adantl syl cch pjid mpan
      pjcoi wi eleq1 syl6bir eqeq2 sylibd impcom eqtrd sylbi ) ABCFGABGZACGZHZA
      BIJZCIJZKJZALABCMULUOAUNJZUMJZAULANGZUOUQLUKURUJACEOPABCDEUAQUKUJUQALZUKU
      PALZUJUSUBCRGUKUTEACSTUTUJUQUPLZUSUTUJUPBGZVAUPABUCBRGVBVADUPBSTUDUPAUQUE
      UFQUGUHUI $.

    $( Lemma for projection commutation theorem.  (Contributed by NM,
       26-Nov-2000.)  (New usage is discouraged.) $)
    pjclem4 $p |- ( ( ( projh ` G ) o. ( projh ` H ) ) =
                    ( ( projh ` H ) o. ( projh ` G ) ) ->
                     ( ( projh ` G ) o. ( projh ` H ) ) =
                     ( projh ` ( G i^i H ) ) ) $=
      ( vx vy cpjh cfv wceq chil wcel wa co cva adantl csp cmin syl c0v pjfi cv
      ccom cin wral cmv cort pjcocli fveq1 eleq1d syl5ibr imp elin sylanbrc cc0
      pjcohcli hvsubcl mpdan w3a simpl adantr chincli cheli 3jca his2sub oveq1d
      pjadjcoi sylan2 pjclem4a oveq2d sylan9eq anim12i hicl subidd 3eqtr2d expr
      eqtrd cc ralrimiv csh chshii shocel ax-mp pjvi syl2anc hvaddsub12 syl3anc
      wb hvsubid ax-hvaddid 3eqtrd fveq2d eqtr3d ralrimiva hocofi hoeqi sylib
      id ) AGHZBGHZUBZWSWRUBZIZEUAZWTHZXCABUCZGHZHZIZEJUDWTXFIXBXHEJXBXCJKZLZXD
      XCXDUEMZNMZXFHZXDXGXJXDXEKZXKXEUFHKZXMXDIXJXDAKZXDBKZXNXIXPXBXCABCDUGOXBX
      IXQXIXQXBXCXAHZBKXCBADCUGXBXDXRBXCWTXAUHZUIUJUKXDABULUMXJXKJKZXKFUAZPMZUN
      IZFXEUDZXOXIXTXBXIXDJKZXTXCABCDUOZXCXDUPUQOXJYCFXEXBXIYAXEKZYCXBXIYGLZLZY
      BXCYAPMZXDYAPMZQMZYKYKQMUNYIXIYEYAJKZURZYBYLIYHYNXBYHXIYEYMXIYGUSXIYEYGYF
      UTYGYMXIYAXEABCDVAZVBZOVCOXCXDYAVDRYIYKYJYKQXBYHYKXRYAPMZYJXBXDXRYAPXSVEY
      HYQXCYAWTHZPMZYJYGXIYMYQYSIYPXCYABADCVFVGYGYSYJIXIYGYRYAXCPYAABCDVHVIOVPV
      JVEYIYKYIYEYMLZYKVQKYHYTXBXIYEYGYMYFYPVKOXDYAVLRVMVNVOVRXEVSKXOXTYDLWGXEY
      OVTFXKXEWAWBUMXDXKXEYOWCWDXIXMXGIXBXIXLXCXFXIXLXCXDXDUEMZNMZXCSNMXCXIYEXI
      YEXLUUBIYFXIWQYFXDXCXDWEWFXIUUASXCNXIYEUUASIYFXDWHRVIXCWIWJWKOWLWMEWTXFWR
      WSACTBDTWNXEYOTWOWP $.

    $( Two subspaces commute iff their projections commute.  Lemma 4 of
       [Kalmbach] p. 67.  (Contributed by NM, 26-Nov-2000.)
       (New usage is discouraged.) $)
    pjci $p |- ( G C_H H <->
       ( ( projh ` G ) o. ( projh ` H ) ) = ( ( projh ` H ) o. ( projh ` G ) )
        ) $=
      ( cpjh cfv ccom wceq cin cort chj chos pjclem4 choccli chio coeq2i eqtr3i
      co pjfi chincli ccm wbr pjclem2 pjclem3 oveq12d chil df-iop hoid1i pjsdii
      syl pjtoi inss2 chub2i sstri chdmm3i sseqtr4i pjscji ax-mp 3eqtr4g chjcli
      wss pj11i sylib cmbri sylibr impbii ) ABUAUBZAEFZBEFZGZVIVHGHZABCDUCVKAAB
      IZABJFZIZKRZHZVGVKVHVOEFZHVPVKVJVHVMEFZGZLRZVLEFZVNEFZLRZVHVQVKVJWAVSWBLA
      BCDMVKVSVRVHGHVSWBHABCDUDAVMCBDNZMUJUEVHUFEFZGZVHVTVHOGWFVHOWEVHUGPVHACSU
      HQVHVIVRLRZGWFVTWGWEVHBDUKPVIVRACBDSVMWDSUIQQVLVNJFZVAVQWCHVLAJFZBKRZWHVL
      BWJABULBWIDACNUMUNABCDUOUPVLVNABCDTZAVMCWDTZUQURUSAVOCVLVNWKWLUTVBVCABCDV
      DVEVF $.

    $( A necessary and sufficient condition for the product of two projectors
       to be a projector is that the projectors commute.  Part 1 of Theorem 1
       of [AkhiezerGlazman] p. 65.  (Contributed by NM, 3-Jun-2006.)
       (New usage is discouraged.) $)
    pjcmul1i $p |- ( ( ( projh ` G ) o. ( projh ` H ) ) =
                   ( ( projh ` H ) o. ( projh ` G ) ) <->
                   ( ( projh ` G ) o. ( projh ` H ) ) e. ran projh ) $=
      ( cpjh cfv ccom wceq crn cin pjclem4 cch wfn pjmfn chincli pjbdlni pjadj3
      wcel cado ax-mp fnfvelrn syl6eqel adjcoi coeq12i pjadj2 syl5reqr impbii
      mp2an eqtri ) AEFZBEFZGZUKUJGZHZULEIZRZUNULABJZEFZUOABCDKELMUQLRURUORNABC
      DOLUQEUAUHUBUPUMULSFZULUSUKSFZUJSFZGUMUJUKACPBDPUCUTUKVAUJBLRUTUKHDBQTALR
      VAUJHCAQTUDUIULUEUFUG $.

    $( The projection subspace of the difference between two projectors.  Part
       2 of Theorem 1 of [AkhiezerGlazman] p. 65.  (Contributed by NM,
       3-Jun-2006.)  (New usage is discouraged.) $)
    pjcmul2i $p |- ( ( ( projh ` G ) o. ( projh ` H ) ) =
                   ( ( projh ` H ) o. ( projh ` G ) )
        <-> ( ( projh ` G ) o. ( projh ` H ) ) = ( projh ` ( G i^i H ) ) ) $=
      ( cpjh cfv ccom wceq cin pjclem4 crn cch wfn pjmfn chincli fnfvelrn mp2an
      wcel eleq1 mpbiri pjcmul1i sylibr impbii ) AEFZBEFZGZUEUDGHZUFABIZEFZHZAB
      CDJUJUFEKZRZUGUJULUIUKRZELMUHLRUMNABCDOLUHEPQUFUIUKSTABCDUAUBUC $.
  $}

  ${
    pjcohocl.1 $e |- H e. CH $.
    pjcohocl.2 $e |- T : ~H --> ~H $.
    $( Closure of composition of projection and Hilbert space operator.
       (Contributed by NM, 3-Dec-2000.)  (New usage is discouraged.) $)
    pjcohocli $p |- ( A e. ~H ->
         ( ( ( projh ` H ) o. T ) ` A ) e. H ) $=
      ( chil wcel cpjh cfv ccom pjfi hocoi ffvelrni pjcli syl eqeltrd ) AFGZACH
      IZBJIABIZRIZCARBCDKELQSFGTCGFFABEMSCDNOP $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y H $.
    pjadj2co.1 $e |- F e. CH $.
    pjadj2co.2 $e |- G e. CH $.
    pjadj2co.3 $e |- H e. CH $.
    $( Adjoint of double composition of projections.  Generalization of special
       case of Theorem 3.11(viii) of [Beran] p. 106.  (Contributed by NM,
       1-Dec-2000.)  (New usage is discouraged.) $)
    pjadj2coi $p |- ( ( A e. ~H /\ B e. ~H ) ->
      ( ( ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) ` A ) .ih B )
        =
 ( A .ih ( ( ( ( projh ` H ) o. ( projh ` G ) ) o. ( projh ` F ) ) ` B ) ) ) $=
      ( chil wcel wa cpjh cfv ccom csp co wceq pjfi hocofi hocoi pjadjcoi sylan
      pjhcli pjcohcli pjadji sylan2 oveq1d adantr fveq1i syl5eq oveq2d 3eqtr4d
      eqtrd coass adantl ) AIJZBIJZKZAELMZMZCLMZDLMZNZMZBOPZABVBVANZMZUSMZOPZAV
      CUSNMZBOPZABUSVBNVANZMZOPZURVEUTVGOPZVIUPUTIJUQVEVOQAEHUCUTBCDFGUAUBUQUPV
      GIJVOVIQBDCGFUDAVGEHUEUFUMUPVKVEQUQUPVJVDBOAVCUSVAVBCFRZDGRZSEHRZTUGUHUQV
      NVIQUPUQVMVHAOUQVMBUSVFNZMVHBVLVSUSVBVAUNUIBUSVFVRVBVAVQVPSTUJUKUOUL $.

    $( Closure of double composition of projections.  (Contributed by NM,
       2-Dec-2000.)  (New usage is discouraged.) $)
    pj2cocli $p |- ( A e. ~H
   -> ( ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) ` A ) e. F ) $=
      ( chil wcel cpjh cfv ccom pjfi ho2coi pjhcli pjcli 3syl eqeltrd ) AHIZABJ
      KZCJKZLDJKZLKAUBKZUAKZTKZBATUAUBBEMCFMDGMNSUCHIUDHIUEBIADGOUCCFOUDBEPQR
      $.

    $( Lemma for projection triplet theorem.  (Contributed by NM, 2-Dec-2000.)
       (New usage is discouraged.) $)
    pj3lem1 $p |- ( A e. ( ( F i^i G ) i^i H )
    -> ( ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) ` A ) = A ) $=
      ( cin wcel cpjh cfv ccom coass fveq1i wceq wa elin chil pjfi syl cheli wi
      adantr hocofi hocoi pjclem4a eleq1 pjid syl6bir eqeq2 sylibd impcom eqtrd
      cch mpan sylbi inass eleq2s syl5eq ) ABCHDHZIABJKZCJKZLDJKZLZKAVAVBVCLZLZ
      KZAAVDVFVAVBVCMNVGAOZABCDHZHZUTAVJIABIZAVIIZPZVHABVIQVMVGAVEKZVAKZAVMARIZ
      VGVOOVKVPVLABEUAUCAVAVEBESVBVCCFSDGSUDUETVLVKVOAOZVLVNAOZVKVQUBACDFGUFVRV
      KVOVNOZVQVRVKVNBIZVSVNABUGBUNIVTVSEVNBUHUOUIVNAVOUJUKTULUMUPBCDUQURUS $.

    $( Stronger projection triplet theorem.  (Contributed by NM, 2-Dec-2000.)
       (New usage is discouraged.) $)
    pj3si $p |- ( ( ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
                  ( ( ( projh ` H ) o. ( projh ` G ) ) o. ( projh ` F ) ) /\
         ran ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) C_ G ) ->
       ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
       ( projh ` ( ( F i^i G ) i^i H ) ) ) $=
      ( vx vy cpjh cfv ccom wceq wa chil wcel co cva adantl pjfi csp crn wss cv
      cin wral cmv cort pj2cocli wfn hocofi hocofni fnfvelrn mpan ssel syl5 imp
      elin sylanbrc adantll fveq1 eleq1d syl5ibr adantlr cc0 hococli mpdan cmin
      hvsubcl w3a simpl adantr chincli 3jca his2sub syl oveq1d pjadj2coi sylan2
      cheli pj3lem1 oveq2d eqtrd sylan9eq cc anim12i hicl 3eqtr2d expr ralrimiv
      subidd csh wb chshii shocel ax-mp pjvi syl2anc hvaddsub12 syl3anc hvsubid
      id c0v ax-hvaddid fveq2d eqtr3d ralrimiva hoeqi sylib ) AIJZBIJZKZCIJZKZX
      LXJKXIKZLZXMUAZBUBZMZGUCZXMJZXSABUDZCUDZIJZJZLZGNUEXMYCLXRYEGNXRXSNOZMZXT
      XSXTUFPZQPZYCJZXTYDYGXTYBOZYHYBUGJOZYJXTLYGXTYAOZXTCOZYKXQYFYMXOXQYFMXTAO
      ZXTBOZYMYFYOXQXSABCDEFUHRXQYFYPYFXTXPOZXQYPXMNUIYFYQXKXLXIXJADSBESUJZCFSZ
      UKNXSXMULUMXPBXTUNUOUPXTABUQURUSXOYFYNXQXOYFYNYFYNXOXSXNJZCOXSCBAFEDUHXOX
      TYTCXSXMXNUTZVAVBUPVCXTYACUQURYGYHNOZYHHUCZTPZVDLZHYBUEZYLYFUUBXRYFXTNOZU
      UBXSXKXLYRYSVEZXSXTVHVFRYGUUEHYBXRYFUUCYBOZUUEXRYFUUIMZMZUUDXSUUCTPZXTUUC
      TPZVGPZUUMUUMVGPVDUUKYFUUGUUCNOZVIZUUDUUNLUUJUUPXRUUJYFUUGUUOYFUUIVJYFUUG
      UUIUUHVKUUIUUOYFUUCYBYACABDEVLFVLZVSZRVMRXSXTUUCVNVOUUKUUMUULUUMVGXRUUJUU
      MYTUUCTPZUULXRXTYTUUCTXOXTYTLXQUUAVKVPUUJUUSXSUUCXMJZTPZUULUUIYFUUOUUSUVA
      LUURXSUUCCBAFEDVQVRUUIUVAUULLYFUUIUUTUUCXSTUUCABCDEFVTWARWBWCVPUUKUUMUUKU
      UGUUOMZUUMWDOUUJUVBXRYFUUGUUIUUOUUHUURWERXTUUCWFVOWJWGWHWIYBWKOYLUUBUUFMW
      LYBUUQWMHYHYBWNWOURXTYHYBUUQWPWQYFYJYDLXRYFYIXSYCYFYIXSXTXTUFPZQPZXSYFUUG
      YFUUGYIUVDLUUHYFXAUUHXTXSXTWRWSYFUVDXSXBQPXSYFUVCXBXSQYFUUGUVCXBLUUHXTWTV
      OWAXSXCWBWBXDRXEXFGXMYCXKXLYRYSUJYBUUQSXGXH $.

    $( Projection triplet theorem.  (Contributed by NM, 2-Dec-2000.)
       (New usage is discouraged.) $)
    pj3i $p |- ( ( ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
                  ( ( ( projh ` H ) o. ( projh ` G ) ) o. ( projh ` F ) ) /\
                  ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
                  ( ( ( projh ` G ) o. ( projh ` F ) ) o. ( projh ` H ) ) ) ->
       ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
       ( projh ` ( ( F i^i G ) i^i H ) ) ) $=
      ( cpjh cfv ccom crn wss cin coass eqeq1 mpbiri rneqd rncoss pjrni sseqtri
      wceq syl6eqss pj3si sylan2 ) AGHZBGHZICGHZIZUEUDIUFIZTZUGUFUEIUDITUGJZBKU
      GABLCLGHTUIUJUEUDUFIZIZJZBUIUGULUIUGULTUHULTUEUDUFMUGUHULNOPUMUEJBUEUKQBE
      RSUAABCDEFUBUC $.

    $( Projection triplet corollary.  (Contributed by NM, 2-Dec-2000.)
       (New usage is discouraged.) $)
    pj3cor1i $p |- ( ( ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) )
        =
                  ( ( ( projh ` H ) o. ( projh ` G ) ) o. ( projh ` F ) ) /\
                  ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
                  ( ( ( projh ` G ) o. ( projh ` F ) ) o. ( projh ` H ) ) ) ->
       ( ( ( projh ` F ) o. ( projh ` G ) ) o. ( projh ` H ) ) =
       ( ( ( projh ` H ) o. ( projh ` F ) ) o. ( projh ` G ) ) ) $=
      ( vx vy cpjh cfv ccom wceq wa chil wcel csp co ad2antlr pjfi hocofi fveq1
      cv wral oveq2d adantl chincli pjadji adantlr pj3i fveq1d oveq1d pjadj2coi
      cin 3eqtr4d exp31 ralrimdv wb hococli hial2eq sylibd com12 ralrimiv hoeqi
      syl2anc sylib ) AIJZBIJZKZCIJZKZVIVGKVFKLZVJVGVFKVIKZLZMZGUBZVJJZVOVIVFKZ
      VGKZJZLZGNUCVJVRLVNVTGNVONOZVNVTWAVNVPHUBZPQZVSWBPQZLZHNUCZVTWAVNWEHNWAVN
      WBNOZWEWAVNMWGMZVOWBVJJZPQZVOWBVLJZPQZWCWDVNWJWLLZWAWGVMWMVKVMWIWKVOPWBVJ
      VLUAUDUERWHVOABUMZCUMZIJZJZWBPQZVOWBWPJZPQZWCWJWAWGWRWTLVNVOWBWOWNCABDEUF
      FUFUGUHVNWCWRLWAWGVNVPWQWBPVNVOVJWPABCDEFUIZUJUKRVNWJWTLWAWGVNWIWSVOPVNWB
      VJWPXAUJUDRUNWAWGWDWLLVNVOWBCABFDEULUHUNUOUPWAVPNOVSNOWFVTUQVOVHVIVFVGADS
      ZBESZTZCFSZURVOVQVGVIVFXEXBTZXCURHVPVSUSVDUTVAVBGVJVRVHVIXDXETVQVGXFXCTVC
      VE $.
  $}

  ${
    pjs14.1 $e |- G e. CH $.
    pjs14.2 $e |- H e. CH $.
    $( Theorem S-14 of Watanabe, p. 486.  (Contributed by NM, 26-Sep-2001.)
       (New usage is discouraged.) $)
    pjs14i $p |- ( A e. ~H ->
                ( normh ` ( ( ( projh ` H ) o. ( projh ` G ) ) ` A ) )
                <_ ( normh ` ( ( projh ` G ) ` A ) ) ) $=
      ( chil wcel cpjh cfv ccom cno cle pjcoi fveq2d cch pjhcli sylancr eqbrtrd
      wbr pjnorm ) AFGZACHIZBHIZJIZKIAUCIZUBIZKIZUEKIZLUAUDUFKACBEDMNUACOGUEFGU
      GUHLSEABDPUECTQR $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                States on a Hilbert lattice and Godowski's equation
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      States on a Hilbert lattice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f x y $.
    $( Define the set of states on a Hilbert lattice.  Definition of [Kalmbach]
       p. 266.  (Contributed by NM, 23-Oct-1999.)
       (New usage is discouraged.) $)
    df-st $a |- States = { f e. ( ( 0 [,] 1 ) ^m CH ) | ( ( f ` ~H ) = 1 /\
          A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
            ( f ` ( x vH y ) ) = ( ( f ` x ) + ( f ` y ) ) ) ) } $.

    $( Define the set of complex Hilbert-space-valued states on a Hilbert
       lattice.  Definition of CH-states in [Mayet3] p. 9.  (Contributed by NM,
       25-Jun-2006.)  (New usage is discouraged.) $)
    df-hst $a |- CHStates = { f e. ( ~H ^m CH ) |
        ( ( normh ` ( f ` ~H ) ) = 1 /\ A. x e. CH A. y e. CH
          ( x C_ ( _|_ ` y ) -> ( ( ( f ` x ) .ih ( f ` y ) ) = 0 /\
              ( f ` ( x vH y ) ) = ( ( f ` x ) +h ( f ` y ) ) ) ) ) } $.
  $}

  ${
    $d x y z w f h H $.  $d x y z w A $.  $d x y f S $.  $d y B $.
    $( Property of a state.  (Contributed by NM, 23-Oct-1999.)  (Revised by
       Mario Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    isst $p |- ( S e. States <-> ( S : CH --> ( 0 [,] 1 ) /\
            ( S ` ~H ) = 1 /\ A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
            ( S ` ( x vH y ) ) = ( ( S ` x ) + ( S ` y ) ) ) ) ) $=
      ( vf cc0 c1 cicc co cch wcel chil cfv wceq cv caddc wi wral wa cst fveq1
      cmap cort wss chj wf ovex chex elmap anbi1i eqeq1d oveq12d eqeq12d imbi2d
      w3a 2ralbidv anbi12d df-st elrab2 3anass 3bitr4i ) CEFGHZIUAHZJZKCLZFMZAN
      ZBNZUBLUCZVFVGUDHZCLZVFCLZVGCLZOHZMZPZBIQAIQZRZRIVACUEZVQRCSJVRVEVPUNVCVR
      VQVAICEFGUFUGUHUIKDNZLZFMZVHVIVSLZVFVSLZVGVSLZOHZMZPZBIQAIQZRVQDCVBSVSCMZ
      WAVEWHVPWIVTVDFKVSCTUJWIWGVOABIIWIWFVNVHWIWBVJWEVMVIVSCTWIWCVKWDVLOVFVSCT
      VGVSCTUKULUMUOUPABDUQURVRVEVPUSUT $.

    $( Property of a complex Hilbert-space-valued state.  Definition of
       CH-states in [Mayet3] p. 9.  (Contributed by NM, 25-Jun-2006.)
       (New usage is discouraged.) $)
    ishst $p |- ( S e. CHStates <-> ( S : CH --> ~H /\
          ( normh ` ( S ` ~H ) ) = 1 /\
          A. x e. CH A. y e. CH ( x C_ ( _|_ ` y ) ->
          ( ( ( S ` x ) .ih ( S ` y ) ) = 0 /\
            ( S ` ( x vH y ) ) = ( ( S ` x ) +h ( S ` y ) ) ) ) ) ) $=
      ( vf chil cch co wcel cfv cno c1 wceq cv csp cc0 cva wa wi wral fveq1 wss
      cmap cort chj chst w3a ax-hilex chex anbi1i fveq2d eqeq1d oveq12d eqeq12d
      wf elmap anbi12d imbi2d 2ralbidv df-hst elrab2 3anass 3bitr4i ) CEFUBGZHZ
      ECIZJIZKLZAMZBMZUCIUAZVHCIZVICIZNGZOLZVHVIUDGZCIZVKVLPGZLZQZRZBFSAFSZQZQF
      ECUNZWBQCUEHWCVGWAUFVDWCWBEFCUGUHUOUIEDMZIZJIZKLZVJVHWDIZVIWDIZNGZOLZVOWD
      IZWHWIPGZLZQZRZBFSAFSZQWBDCVCUEWDCLZWGVGWQWAWRWFVFKWRWEVEJEWDCTUJUKWRWPVT
      ABFFWRWOVSVJWRWKVNWNVRWRWJVMOWRWHVKWIVLNVHWDCTZVIWDCTZULUKWRWLVPWMVQVOWDC
      TWRWHVKWIVLPWSWTULUMUPUQURUPABDUSUTWCVGWAVAVB $.

    $( ` [ 0 , 1 ] ` closure of the value of a state.  (Contributed by Mario
       Carneiro, 23-Dec-2013.)  (New usage is discouraged.) $)
    sticl $p |- ( S e. States -> ( A e. CH -> ( S ` A ) e. ( 0 [,] 1 ) ) ) $=
      ( vx vy cst wcel cch cc0 c1 cicc co wf cfv wi chil wceq cv cort wss wral
      chj caddc isst simp1bi ffvelrn ex syl ) BEFZGHIJKZBLZAGFZABMUIFZNUHUJOBMI
      PCQZDQZRMSUMUNUAKBMUMBMUNBMUBKPNDGTCGTCDBUCUDUJUKULGUIABUEUFUG $.

    $( Real closure of the value of a state.  (Contributed by NM,
       24-Oct-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    stcl $p |- ( S e. States -> ( A e. CH -> ( S ` A ) e. RR ) ) $=
      ( cst wcel cch cfv cc0 c1 cicc co cr sticl unitssre sseli syl6 ) BCDAEDAB
      FZGHIJZDPKDABLQKPMNO $.

    $( Closure of the value of a Hilbert-space-valued state.  (Contributed by
       NM, 25-Jun-2006.)  (New usage is discouraged.) $)
    hstcl $p |- ( ( S e. CHStates /\ A e. CH ) -> ( S ` A ) e. ~H ) $=
      ( vx vy chst wcel cch chil wf cfv cno c1 wceq cv cort wss csp co cc0 wral
      chj cva wa wi ishst simp1bi ffvelrnda ) BEFZGHABUHGHBIHBJKJLMCNZDNZOJPUIB
      JZUJBJZQRSMUIUJUARBJUKULUBRMUCUDDGTCGTCDBUEUFUG $.

    $( Unit value of a Hilbert-space-valued state.  (Contributed by NM,
       25-Jun-2006.)  (New usage is discouraged.) $)
    hst1a $p |- ( S e. CHStates -> ( normh ` ( S ` ~H ) ) = 1 ) $=
      ( vx vy chst wcel cch chil wf cfv cno c1 wceq cv cort wss csp co cc0 wral
      chj cva wa wi ishst simp2bi ) ADEFGAHGAIJIKLBMZCMZNIOUFAIZUGAIZPQRLUFUGTQ
      AIUHUIUAQLUBUCCFSBFSBCAUDUE $.

    $( Properties of a Hilbert-space-valued state.  (Contributed by NM,
       25-Jun-2006.)  (New usage is discouraged.) $)
    hstel2 $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH
       /\ A C_ ( _|_ ` B ) ) ) -> ( ( ( S ` A ) .ih ( S ` B ) ) = 0 /\
                    ( S ` ( A vH B ) ) = ( ( S ` A ) +h ( S ` B ) ) ) ) $=
      ( vx vy wcel cch wa cort cfv wss cv csp co cc0 wceq chj cva wi fveq2 chst
      wral chil wf cno ishst simp3bi ad2antrr sseq1 oveq1d eqeq1d oveq1 eqeq12d
      fveq2d anbi12d imbi12d sseq2d oveq2d oveq2 rspc2v com23 impr adantll mpd
      c1 ) CUAFZAGFZHBGFZABIJZKZHZHDLZELZIJZKZVLCJZVMCJZMNZOPZVLVMQNZCJZVPVQRNZ
      PZHZSZEGUBDGUBZACJZBCJZMNZOPZABQNZCJZWGWHRNZPZHZVFWFVGVKVFGUCCUDUCCJUEJVE
      PWFDECUFUGUHVGVKWFWOSZVFVGVHVJWPVGVHHWFVJWOWEVJWOSAVNKZWGVQMNZOPZAVMQNZCJ
      ZWGVQRNZPZHZSDEABGGVLAPZVOWQWDXDVLAVNUIXEVSWSWCXCXEVRWROXEVPWGVQMVLACTZUJ
      UKXEWAXAWBXBXEVTWTCVLAVMQULUNXEVPWGVQRXFUJUMUOUPVMBPZWQVJXDWOXGVNVIAVMBIT
      UQXGWSWJXCWNXGWRWIOXGVQWHWGMVMBCTZURUKXGXAWLXBWMXGWTWKCVMBAQUSUNXGVQWHWGR
      XHURUMUOUPUTVAVBVCVD $.

    $( Orthogonality property of a Hilbert-space-valued state.  This is a key
       feature distinguishing it from a real-valued state.  (Contributed by NM,
       25-Jun-2006.)  (New usage is discouraged.) $)
    hstorth $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH
       /\ A C_ ( _|_ ` B ) ) ) -> ( ( S ` A ) .ih ( S ` B ) ) = 0 ) $=
      ( chst wcel cch wa cort cfv wss csp co cc0 wceq chj cva hstel2 simpld ) C
      DEAFEGBFEABHIJGGACIZBCIZKLMNABOLCISTPLNABCQR $.

    $( Orthogonal sum property of a Hilbert-space-valued state.  (Contributed
       by NM, 25-Jun-2006.)  (New usage is discouraged.) $)
    hstosum $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH
                         /\ A C_ ( _|_ ` B ) ) ) ->
                    ( S ` ( A vH B ) ) = ( ( S ` A ) +h ( S ` B ) ) ) $=
      ( chst wcel cch wa cort cfv wss csp co cc0 wceq chj cva hstel2 simprd ) C
      DEAFEGBFEABHIJGGACIZBCIZKLMNABOLCISTPLNABCQR $.

    $( Sum of a Hilbert-space-valued state of a lattice element and its
       orthocomplement.  (Contributed by NM, 25-Jun-2006.)
       (New usage is discouraged.) $)
    hstoc $p |- ( ( S e. CHStates /\ A e. CH ) ->
                  ( ( S ` A ) +h ( S ` ( _|_ ` A ) ) ) = ( S ` ~H ) ) $=
      ( chst wcel cch cort cfv chj cva chil wss wceq choccl adantl csh shococss
      wa co chsh syl jca hstosum mpdan chjo fveq2d eqtr3d ) BCDZAEDZQZAAFGZHRZB
      GZABGUJBGIRZJBGZUIUJEDZAUJFGKZQULUMLUIUOUPUHUOUGAMNUHUPUGUHAODUPASAPTNUAA
      UJBUBUCUHULUNLUGUHUKJBAUDUENUF $.

    $( Sum of norms of a Hilbert-space-valued state.  (Contributed by NM,
       25-Jun-2006.)  (New usage is discouraged.) $)
    hstnmoc $p |- ( ( S e. CHStates /\ A e. CH ) -> ( ( ( normh `
         ( S ` A ) ) ^ 2 ) + ( ( normh ` ( S ` ( _|_ ` A ) ) ) ^ 2 ) ) = 1 ) $=
      ( chst wcel cch wa cfv cort cva co cno c2 cexp chil oveq1d wceq hstcl jca
      c1 adantl caddc hstoc fveq2d csp cc0 choccl wss csh chsh shococss hstorth
      sylan2 syl mpdan normpyth sylc hst1a sq1 syl6eq adantr 3eqtr3d ) BCDZAEDZ
      FZABGZAHGZBGZIJZKGZLMJZNBGZKGZLMJZVEKGLMJVGKGLMJUAJZSVDVIVLLMVDVHVKKABUBU
      COVDVENDZVGNDZFVEVGUDJUEPZVJVNPVDVOVPABQVCVBVFEDZVPAUFZVFBQULRVDVRAVFHGUG
      ZFVQVDVRVTVCVRVBVSTVCVTVBVCAUHDVTAUIAUJUMTRAVFBUKUNVEVGUOUPVBVMSPVCVBVMSL
      MJSVBVLSLMBUQOURUSUTVA $.

    $( The value of a state is nonnegative.  (Contributed by NM, 24-Oct-1999.)
       (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    stge0 $p |- ( S e. States -> ( A e. CH -> 0 <_ ( S ` A ) ) ) $=
      ( cst wcel cch cfv cc0 c1 cicc cle wbr sticl 0re 1re elicc2i simp2bi syl6
      co cr ) BCDAEDABFZGHIRDZGTJKZABLUATSDUBTHJKGHTMNOPQ $.

    $( The value of a state is less than or equal to one.  (Contributed by NM,
       24-Oct-1999.)  (Revised by Mario Carneiro, 23-Dec-2013.)
       (New usage is discouraged.) $)
    stle1 $p |- ( S e. States -> ( A e. CH -> ( S ` A ) <_ 1 ) ) $=
      ( cst wcel cch cfv cc0 c1 cicc cle wbr sticl 0re 1re elicc2i simp3bi syl6
      co cr ) BCDAEDABFZGHIRDZTHJKZABLUATSDGTJKUBGHTMNOPQ $.

    $( The norm of the value of a Hilbert-space-valued state is less than or
       equal to one.  (Contributed by NM, 25-Jun-2006.)
       (New usage is discouraged.) $)
    hstle1 $p |- ( ( S e. CHStates /\ A e. CH ) ->
                   ( normh ` ( S ` A ) ) <_ 1 ) $=
      ( wcel cch wa cfv cno c1 cle wbr c2 cexp co cc0 chil hstcl normcl resqcld
      cr syl chst caddc choccl sylan2 sqge0d addge01d mpbid hstnmoc sq1 syl6eqr
      cort breqtrd wb normge0 1re 0le1 le2sq mpanr12 syl2anc mpbird ) BUACZADCZ
      EZABFZGFZHIJZVEKLMZHKLMZIJZVCVGVGAUKFZBFZGFZKLMZUBMZVHIVCNVMIJVGVNIJVCVLV
      CVKOCZVLSCVBVAVJDCVOAUCVJBPUDVKQTZUEVCVGVMVCVEVCVDOCZVESCZABPZVDQTZRVCVLV
      PRUFUGVCVNHVHABUHUIUJULVCVRNVEIJZVFVIUMZVTVCVQWAVSVDUNTVRWAEHSCNHIJWBUOUP
      VEHUQURUSUT $.

    $( The norm of a Hilbert-space-valued state equals one iff the state value
       equals the state value of the lattice unit.  (Contributed by NM,
       25-Jun-2006.)  (New usage is discouraged.) $)
    hst1h $p |- ( ( S e. CHStates /\ A e. CH ) ->
                  ( ( normh ` ( S ` A ) ) = 1 <-> ( S ` A ) = ( S ` ~H ) ) ) $=
      ( wcel cfv cno c1 wceq chil c0v cva co syl adantr c2 cexp cc0 cmin eqtr3d
      caddc cc chst cch wa hstcl ax-hvaddid cort ax-1cn cr choccl sylan2 normcl
      resqcld recnd pncan2 sylancr oveq1 syl6req oveq1d hstnmoc sylan9eqr 1m1e0
      sq1 syl6eq ex wb sqeq0 norm-i bitrd sylibd imp oveq2d hstoc fveq2 impbida
      hst1a ) BUACZAUBCZUCZABDZEDZFGZVSHBDZGZVRWAUCZVSIJKZVSWBVRWEVSGZWAVRVSHCW
      FABUDVSUELMWDVSAUFDZBDZJKZWEWBWDWHIVSJVRWAWHIGZVRWAWHEDZNOKZPGZWJVRWAWMWD
      WLFFQKZPWDFWLSKZFQKZWLWNVRWPWLGZWAVRFTCWLTCWQUGVRWLVRWKVRWHHCZWKUHCVQVPWG
      UBCWRAUIWGBUDUJZWHUKLZULUMFWLUNUOMWDWOFFQWAVRWOVTNOKZWLSKFWAFXAWLSWAXAFNO
      KFVTFNOUPVBUQURABUSUTURRVAVCVDVRWMWKPGZWJVRWKTCWMXBVEVRWKWTUMWKVFLVRWRXBW
      JVEWSWHVGLVHVIVJVKVRWIWBGWAABVLMRRWCVRVTWBEDZFVSWBEVMVPXCFGVQBVOMUTVN $.

    $( The norm of a Hilbert-space-valued state equals zero iff the state value
       equals zero.  (Contributed by NM, 30-Jun-2006.)
       (New usage is discouraged.) $)
    hst0h $p |- ( ( S e. CHStates /\ A e. CH ) ->
                  ( ( normh ` ( S ` A ) ) = 0 <-> ( S ` A ) = 0h ) ) $=
      ( chst wcel cch wa cfv chil cno cc0 wceq c0v wb hstcl norm-i syl ) BCDAED
      FABGZHDQIGJKQLKMABNQOP $.

    $( Pythagorean property of a Hilbert-space-valued state for orthogonal
       vectors ` A ` and ` B ` .  (Contributed by NM, 26-Jun-2006.)
       (New usage is discouraged.) $)
    hstpyth $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH /\
               A C_ ( _|_ ` B ) ) ) -> ( ( normh ` ( S ` ( A vH B ) ) ) ^ 2 ) =
         ( ( ( normh ` ( S ` A ) ) ^ 2 ) + ( ( normh ` ( S ` B ) ) ^ 2 ) ) ) $=
      ( chst wcel cch wa cort cfv wss chj co cno cexp cva caddc chil wceq hstcl
      c2 hstosum fveq2d oveq1d csp cc0 adantr ad2ant2r hstorth normpyth syl3anc
      3impia eqtrd ) CDEZAFEZGZBFEZABHIJZGZGZABKLCIZMIZTNLACIZBCIZOLZMIZTNLZVBM
      ITNLVCMITNLPLZUSVAVETNUSUTVDMABCUAUBUCUSVBQEZVCQEZVBVCUDLUERZVFVGRZUOVHUR
      ACSUFUMUPVIUNUQBCSUGABCUHVHVIVJVKVBVCUIUKUJUL $.

    $( Ordering property of a Hilbert-space-valued state.  (Contributed by NM,
       26-Jun-2006.)  (New usage is discouraged.) $)
    hstle $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH /\ A C_ B ) )
                   -> ( normh ` ( S ` A ) ) <_ ( normh ` ( S ` B ) ) ) $=
      ( wcel cch wa cfv cno cle wbr c2 cexp co caddc adantlr syl sylan2 adantrr
      c1 cr chst wss cort wceq hstnmoc oveq2d hstcl normcl resqcld adantr recnd
      chil choccl add12d eqtr3d chj ococ sseq2d biimpar jca hstpyth cc0 anassrs
      chjcl normge0 hstle1 le2sq2 mpanr1 syl21anc syl6breq eqbrtrrd wb readdcld
      1re sq1 leadd2 mp3an2 syl2anc mpbid eqbrtrd leadd1 mp3an3 mpbird le2sq )
      CUADZAEDZFZBEDZABUBZFZFZACGZHGZBCGZHGZIJZWMKLMZWOKLMZIJZWKWSWQSNMZWRSNMZI
      JZWKWTWRWQBUCGZCGZHGZKLMZNMZNMZXAIWGWHWTXHUDWIWGWHFZWQWRXFNMZNMWTXHXIXJSW
      QNWEWHXJSUDWFBCUEOUFXIWQWRXFXIWQWGWQTDZWHWGWMWGWLULDZWMTDZACUGZWLUHPZUIUJ
      ZUKXIWRWEWHWRTDZWFWEWHFZWOXRWNULDZWOTDZBCUGZWNUHPZUIOZUKXIXFWEWHXFTDWFXRX
      EXRXDULDZXETDWHWEXCEDZYDBUMZXCCUGQXDUHPUIOZUKUNUORWKXGSIJZXHXAIJZWKAXCUPM
      ZCGZHGZKLMZXGSIWJWGYEAXCUCGZUBZFYMXGUDWJYEYOWHYEWIYFUJWHYOWIWHYNBABUQURUS
      UTAXCCVAQWGWHYMSIJWIXIYMSKLMZSIXIYLTDZVBYLIJZYLSIJZYMYPIJZXIYKULDZYQWEWFW
      HUUAWFWHFZWEYJEDZUUAWHWFYEUUCYFAXCVDQZYJCUGQVCZYKUHPXIUUAYRUUEYKVEPWEWFWH
      YSUUBWEUUCYSUUDYJCVFQVCYQYRFSTDZYSYTVNYLSVGVHVIVOVJRVKWGWHYHYIVLZWIXIXGTD
      ZXQUUGXIWQXFXPYGVMYCUUHUUFXQUUGVNXGSWRVPVQVRRVSVTWGWHWSXBVLZWIXIXKXQUUIXP
      YCXKXQUUFUUIVNWQWRSWAWBVRRWCWGWHWPWSVLZWIXIXMVBWMIJZFZXTVBWOIJZFZUUJWGUUL
      WHWGXMUUKXOWGXLUUKXNWLVEPUTUJWEWHUUNWFXRXTUUMYBXRXSUUMYAWNVEPUTOWMWOWDVRR
      WC $.

    $( Ordering property of a Hilbert-space-valued state.  (Contributed by NM,
       30-Jun-2006.)  (New usage is discouraged.) $)
    hstles $p |- ( ( ( S e. CHStates /\ A e. CH ) /\ ( B e. CH /\ A C_ B ) )
             -> ( ( normh ` ( S ` A ) ) = 1 -> ( normh ` ( S ` B ) ) = 1 ) ) $=
      ( chst wcel cch wa wss cfv cno wceq cle wbr simpr hstle eqbrtrrd ad2ant2r
      c1 adantr cr ex hstle1 jctild wb chil hstcl normcl 1re mpan2 3syl sylibrd
      letri3 ) CDEZAFEZGBFEZABHZGGZACIJIZRKZBCIZJIZRLMZRVALMZGZVARKZUQUSVCVBUQU
      SVCUQUSGURRVALUQUSNUQURVALMUSABCOSPUAUMUOVBUNUPBCUBQUCUMUOVEVDUDZUNUPUMUO
      GUTUEEVATEZVFBCUFUTUGVGRTEVFUHVARULUIUJQUK $.

    $( A Hilbert-space-valued state orthogonal to the state of the lattice unit
       is zero.  (Contributed by NM, 25-Jun-2006.)
       (New usage is discouraged.) $)
    hstoh $p |- ( ( S e. CHStates /\ A e. CH /\ ( ( S ` A ) .ih ( S ` ~H ) ) =
                  0 ) -> ( S ` A ) = 0h ) $=
      ( chst wcel cch cfv chil csp co cc0 wceq wa cort caddc hstcl syl recnd wb
      3adant3 mpbid w3a cno c0v c2 cexp cva choccl sylan2 syl3anc normsq eqcomd
      his7 wss ococ eqimss2 jca adantl hstorth mpdan oveq12d cr resqcld addid1d
      normcl 3eqtrrd hstoc oveq2d eqtrd id sylan9eq 3impa cc sqeq0 hst0h ) BCDZ
      AEDZABFZGBFZHIZJKZUAZVQUBFZJKZVQUCKZWAWBUDUEIZJKZWCVOVPVTWFVOVPLZVTWEVSJW
      GWEVQVQAMFZBFZUFIZHIZVSWGWKVQVQHIZVQWIHIZNIZWEJNIWEWGVQGDZWOWIGDZWKWNKABO
      ZWQVPVOWHEDZWPAUGZWHBOUHVQVQWIULUIWGWLWEWMJNWGWEWLWGWOWEWLKWQVQUJPUKWGWRA
      WHMFZUMZLZWMJKVPXBVOVPWRXAWSVPWTAKXAAUNAWTUOPUPUQAWHBURUSUTWGWEWGWEWGWBWG
      WOWBVADWQVQVDPZVBQVCVEWGWJVRVQHABVFVGVHVTVIVJVKVOVPWFWCRZVTWGWBVLDXDWGWBX
      CQWBVMPSTVOVPWCWDRVTABVNST $.

    $( A Hilbert-space-valued state is zero at the zero subspace.  (Contributed
       by NM, 30-Jun-2006.)  (New usage is discouraged.) $)
    hst0 $p |- ( S e. CHStates -> ( S ` 0H ) = 0h ) $=
      ( chst wcel c0h cfv chil csp co cc0 wceq c0v cch h0elch wa cort wss helch
      choccli ch0lei hstorth mpanr12 mpan2 hstoh mp3an2 mpdan ) ABCZDAEZFAEGHIJ
      ZUGKJZUFDLCZUHMUFUJNFLCDFOEZPUHQUKFQRSDFATUAUBUFUJUHUIMDAUCUDUE $.

    $( The value of a state at the full Hilbert space.  (Contributed by NM,
       23-Oct-1999.)  (New usage is discouraged.) $)
    sthil $p |- ( S e. States -> ( S ` ~H ) = 1 ) $=
      ( vx vy cst wcel cch cc0 c1 cicc co wf chil cfv wceq cv cort wss chj wral
      caddc wi isst simp2bi ) ADEFGHIJAKLAMHNBOZCOZPMQUDUERJAMUDAMUEAMTJNUACFSB
      FSBCAUBUC $.

    $( The value of a state on a join.  (Contributed by NM, 23-Oct-1999.)
       (New usage is discouraged.) $)
    stj $p |- ( S e. States ->
         ( ( ( A e. CH /\ B e. CH ) /\ A C_ ( _|_ ` B ) ) ->
         ( S ` ( A vH B ) ) = ( ( S ` A ) + ( S ` B ) ) ) ) $=
      ( vx vy wcel cch cort cfv wss chj co caddc wceq cv wi wral fveq2d fveq2
      c1 cst wa cc0 cicc wf chil isst simp3bi sseq1 oveq1 oveq1d eqeq12d sseq2d
      imbi12d oveq2 oveq2d rspc2v syl5com imp3a ) CUAFZAGFBGFUBZABHIZJZABKLZCIZ
      ACIZBCIZMLZNZUTDOZEOZHIZJZVJVKKLZCIZVJCIZVKCIZMLZNZPZEGQDGQZVAVCVIPZUTGUC
      TUDLCUEUFCITNWADECUGUHVTWBAVLJZAVKKLZCIZVFVQMLZNZPDEABGGVJANZVMWCVSWGVJAV
      LUIWHVOWEVRWFWHVNWDCVJAVKKUJRWHVPVFVQMVJACSUKULUNVKBNZWCVCWGVIWIVLVBAVKBH
      SUMWIWEVEWFVHWIWDVDCVKBAKUORWIVQVGVFMVKBCSUPULUNUQURUS $.
  $}

  ${
    sto1.1 $e |- A e. CH $.
    $( The state of a subspace plus the state of its orthocomplement.
       (Contributed by NM, 24-Oct-1999.)  (New usage is discouraged.) $)
    sto1i $p |- ( S e. States -> ( ( S ` A ) + ( S ` ( _|_ ` A ) ) ) = 1 ) $=
      ( cst wcel cort cfv chj co chil caddc c1 chjoi fveq2i cch wa wceq choccli
      wss pm3.2i csh chshii shococss ax-mp stj mp2ani sthil 3eqtr3a ) BDEZAAFGZ
      HIZBGZJBGABGUJBGKIZLUKJBACMNUIAOEZUJOEZPAUJFGSZULUMQUNUOCACRTAUAEUPACUBAU
      CUDAUJBUEUFBUGUH $.

    $( The state of the orthocomplement.  (Contributed by NM, 24-Oct-1999.)
       (New usage is discouraged.) $)
    sto2i $p |- ( S e. States ->
               ( S ` ( _|_ ` A ) ) = ( 1 - ( S ` A ) ) ) $=
      ( cst wcel c1 cfv cmin co cort wceq caddc sto1i cc wb cch stcl mpi recnd
      cr choccli ax-1cn subadd mp3an1 syl2anc mpbird eqcomd ) BDEZFABGZHIZAJGZB
      GZUHUJULKZUIULLIFKZABCMUHUINEZULNEZUMUNOZUHUIUHAPEUITECABQRSUHULUHUKPEULT
      EACUAUKBQRSFNEUOUPUQUBFUIULUCUDUEUFUG $.

    $( If a state is greater than or equal to 1, it is 1.  (Contributed by NM,
       11-Nov-1999.)  (New usage is discouraged.) $)
    stge1i $p |- ( S e. States ->
                ( 1 <_ ( S ` A ) <-> ( S ` A ) = 1 ) ) $=
      ( cst wcel c1 cfv cle wbr wceq wa cch stle1 mpi anim1i ex cr wb stcl 1re
      letri3 sylancl sylibrd 1le1 breq2 mpbiri impbid1 ) BDEZFABGZHIZUIFJZUHUJU
      IFHIZUJKZUKUHUJUMUHULUJUHALEZULCABMNOPUHUIQEZFQEUKUMRUHUNUOCABSNTUIFUAUBU
      CUKUJFFHIUDUIFFHUEUFUG $.

    $( If a state is less than or equal to 0, it is 0.  (Contributed by NM,
       11-Nov-1999.)  (New usage is discouraged.) $)
    stle0i $p |- ( S e. States ->
                ( ( S ` A ) <_ 0 <-> ( S ` A ) = 0 ) ) $=
      ( cst wcel cfv cc0 cle wbr wceq wa cch stge0 mpi anim2i expcom cr wb stcl
      0re letri3 sylancl sylibrd 0le0 breq1 mpbiri impbid1 ) BDEZABFZGHIZUIGJZU
      HUJUJGUIHIZKZUKUJUHUMUHULUJUHALEZULCABMNOPUHUIQEZGQEUKUMRUHUNUOCABSNTUIGU
      AUBUCUKUJGGHIUDUIGGHUEUFUG $.
  $}

  ${
    stle.1 $e |- A e. CH $.
    stle.2 $e |- B e. CH $.
    $( Ordering law for states.  (Contributed by NM, 24-Oct-1999.)
       (New usage is discouraged.) $)
    stlei $p |- ( S e. States -> ( A C_ B -> ( S ` A ) <_ ( S ` B ) ) ) $=
      ( wcel wss cfv cle wbr wa cort caddc co cch mpi c1 adantr cr stcl cst chj
      wceq csh chshii shococss ax-mp sstr2 choccli pm3.2i jctil stj syl5 chjcli
      imp stle1 sto1i breqtrrd eqbrtrrd w3a wb 3jca leadd1 syl mpbird ex ) CUAF
      ZABGZACHZBCHZIJZVGVHKZVKVIBLHZCHZMNZVJVNMNZIJZVLAVMUBNZCHZVOVPIVGVHVSVOUC
      ZVHAOFZVMOFZKZAVMLHZGZKVGVTVHWEWCVHBWDGZWEBUDFWFBEUEBUFUGABWDUHPWAWBDBEUI
      ZUJUKAVMCULUMUOVGVSVPIJVHVGVSQVPIVGVROFVSQIJAVMDWGUNVRCUPPBCEUQURRUSVLVIS
      FZVJSFZVNSFZUTZVKVQVAVGWKVHVGWHWIWJVGWAWHDACTPVGBOFWIEBCTPVGWBWJWGVMCTPVB
      RVIVJVNVCVDVEVF $.

    $( Ordering law for states.  (Contributed by NM, 24-Oct-1999.)
       (New usage is discouraged.) $)
    stlesi $p |- ( S e. States ->
                ( A C_ B -> ( ( S ` A ) = 1 -> ( S ` B ) = 1 ) ) ) $=
      ( cst wcel wss cfv c1 wceq wa cle wbr cch stle1 mpi adantr wb cr ad2antll
      stlei imp adantrr breq1 mpbid stcl 1re jctir letri3 syl mpbir2and exp32 )
      CFGZABHZACIZJKZBCIZJKZUNUOUQLZLZUSURJMNZJURMNZUNVBUTUNBOGZVBEBCPQRVAUPURM
      NZVCUNUOVEUQUNUOVEABCDEUBUCUDUQVEVCSUNUOUPJURMUEUAUFVAURTGZJTGZLZUSVBVCLS
      UNVHUTUNVFVGUNVDVFEBCUGQUHUIRURJUJUKULUM $.

    $( Join of components of Sasaki arrow ->1.  (Contributed by NM,
       24-Oct-1999.)  (New usage is discouraged.) $)
    stji1i $p |- ( S e. States -> ( S ` ( ( _|_ ` A ) vH ( A i^i B ) ) ) =
         ( ( S ` ( _|_ ` A ) ) + ( S ` ( A i^i B ) ) ) ) $=
      ( cst wcel cort cfv cch cin wa wss chj caddc wceq choccli chincli pm3.2i
      co inss1 chsscon3i mpbi stj mp2ani ) CFGAHIZJGZABKZJGZLUFUHHIMZUFUHNTCIUF
      CIUHCIOTPUGUIADQABDERZSUHAMUJABUAUHAUKDUBUCUFUHCUDUE $.

    $( State of component of unit meet.  (Contributed by NM, 11-Nov-1999.)
       (New usage is discouraged.) $)
    stm1i $p |- ( S e. States ->
               ( ( S ` ( A i^i B ) ) = 1 -> ( S ` A ) = 1 ) ) $=
      ( cst wcel cin cfv c1 cle wbr wss inss1 chincli stlei mpi breq1 syl5ibcom
      wceq stge1i sylibd ) CFGZABHZCIZJTZJACIZKLZUGJTUCUEUGKLZUFUHUCUDAMUIABNUD
      ACABDEODPQUEJUGKRSACDUAUB $.

    $( State of component of unit meet.  (Contributed by NM, 11-Nov-1999.)
       (New usage is discouraged.) $)
    stm1ri $p |- ( S e. States ->
               ( ( S ` ( A i^i B ) ) = 1 -> ( S ` B ) = 1 ) ) $=
      ( cin cfv c1 wceq cst wcel incom fveq2i eqeq1i stm1i syl5bi ) ABFZCGZHIBA
      FZCGZHICJKBCGHIRTHQSCABLMNBACEDOP $.

    $( Sum of states whose meet is 1.  (Contributed by NM, 11-Nov-1999.)
       (New usage is discouraged.) $)
    stm1addi $p |- ( S e. States -> ( ( S ` ( A i^i B ) ) = 1 ->
                  ( ( S ` A ) + ( S ` B ) ) = 2 ) ) $=
      ( cst wcel cin cfv c1 wceq wa caddc co c2 stm1i stm1ri jcad oveq12 df-2
      syl6eqr syl6 ) CFGZABHCIJKZACIZJKZBCIZJKZLZUEUGMNZOKUCUDUFUHABCDEPABCDEQR
      UIUJJJMNOUEJUGJMSTUAUB $.

    $( If the sum of 2 states is 2, then each state is 1.  (Contributed by NM,
       12-Nov-1999.)  (New usage is discouraged.) $)
    staddi $p |- ( S e. States -> ( ( ( S ` A ) + ( S ` B ) ) = 2 ->
                ( S ` A ) = 1 ) ) $=
      ( wcel cfv caddc co c2 wceq clt wbr wn c1 cr mpi wa cle 1re stcl readdcld
      cst wne cch ltne necomd sylan ex necon2bd stle1 leadd2dd adantr wi ltadd1
      a1i w3a biimpd syl3anc imp readdcl sylancl readdcli lelttr df-2 syl6breqr
      mp2and con3d wo wb leloe mpbid ord 3syld ) CUCFZACGZBCGZHIZJKVRJLMZNVPOLM
      ZNVPOKZVOVSVRJVOVSVRJUDZVOVRPFZVSWBVOVPVQVOAUEFZVPPFZDACUAQZVOBUEFZVQPFEB
      CUAQZUBZWCVSRJVRVRJUFUGUHUIUJVOVTVSVOVTVSVOVTRZVROOHIZJLWJVRVPOHIZSMZWLWK
      LMZVRWKLMZVOWMVTVOVQOVPWHOPFZVOTUPZWFVOWGVQOSMEBCUKQULUMVOVTWNVOWEWPWPVTW
      NUNWFWQWQWEWPWPUQVTWNVPOOUOURUSUTVOWMWNRWOUNZVTVOWCWLPFZWKPFZWRWIVOWEWPWS
      WFTVPOVAVBWTVOOOTTVCUPVRWLWKVDUSUMVGVEVFUIVHVOVTWAVOVPOSMZVTWAVIZVOWDXADA
      CUKQVOWEWPXAXBVJWFTVPOVKVBVLVMVN $.

    ${
      stm1add3.3 $e |- C e. CH $.
      $( Sum of states whose meet is 1.  (Contributed by NM, 11-Nov-1999.)
         (New usage is discouraged.) $)
      stm1add3i $p |- ( S e. States -> ( ( S ` ( ( A i^i B ) i^i C ) ) = 1 ->
                  ( ( ( S ` A ) + ( S ` B ) ) + ( S ` C ) ) = 3 ) ) $=
        ( cst wcel cin cfv c1 wceq caddc co c2 wa c3 chincli stm1i syld syl6eqr
        stm1addi stm1ri jcad oveq12 df-3 syl6 ) DHIZABJZCJDKLMZADKBDKNOZPMZCDKZ
        LMZQZULUNNOZRMUIUKUMUOUIUKUJDKLMUMUJCDABEFSZGTABDEFUCUAUJCDURGUDUEUPUQP
        LNORULPUNLNUFUGUBUH $.

      $( If the sum of 3 states is 3, then each state is 1.  (Contributed by
         NM, 13-Nov-1999.)  (New usage is discouraged.) $)
      stadd3i $p |- ( S e. States ->
  ( ( ( ( S ` A ) + ( S ` B ) ) + ( S ` C ) ) = 3 -> ( S ` A ) = 1 ) ) $=
        ( wcel cfv caddc co c3 wceq c1 cr mpi clt wbr cle 1re cst recnd addassd
        cch stcl eqeq1d wn eqcom wne wi readdcld 3re ltneOLD 3exp ee10 necon2bd
        syl5bi wa readdcli a1i stle1 le2addd leadd2dd adantr w3a ltadd1 syl3anc
        biimpd readdcl sylancl lelttr mp2and c2 df-3 df-2 oveq1i ax-1cn addassi
        imp 3eqtrri syl6breq ex con3d wo wb leloe mpbid ord 3syld sylbid ) DUAH
        ZADIZBDIZJKCDIZJKZLMWLWMWNJKZJKZLMZWLNMZWKWOWQLWKWLWMWNWKWLWKAUDHZWLOHZ
        EADUEPZUBWKWMWKBUDHZWMOHFBDUEPZUBWKWNWKCUDHZWNOHGCDUEPZUBUCUFWKWRWQLQRZ
        UGZWLNQRZUGWSWRLWQMWKXHWQLUHWKXGLWQWKWQOHZLOHZXGLWQUIZUJWKWLWPXBWKWMWNX
        DXFUKZUKZULXJXKXGXLWQLUMUNUOUPUQWKXIXGWKXIXGWKXIURZWQNNNJKZJKZLQXOWQWLX
        PJKZSRZXRXQQRZWQXQQRZWKXSXIWKWPXPWLXMXPOHZWKNNTTUSZUTZXBWKWMWNNNXDXFNOH
        ZWKTUTZYFWKXCWMNSRFBDVAPWKXEWNNSRGCDVAPVBVCVDWKXIXTWKXAYEYBXIXTUJXBYFYD
        XAYEYBVEXIXTWLNXPVFVHVGVSWKXSXTURYAUJZXIWKXJXROHZXQOHZYGXNWKXAYBYHXBYCW
        LXPVIVJYIWKNXPTYCUSUTWQXRXQVKVGVDVLLVMNJKXPNJKXQVNVMXPNJVOVPNNNVQVQVQVR
        VTWAWBWCWKXIWSWKWLNSRZXIWSWDZWKWTYJEADVAPWKXAYEYJYKWEXBTWLNWFVJWGWHWIWJ
        $.
    $}
  $}

  $( The state of the zero subspace.  (Contributed by NM, 24-Oct-1999.)
     (New usage is discouraged.) $)
  st0 $p |- ( S e. States -> ( S ` 0H ) = 0 ) $=
    ( cst wcel chil cort cfv c1 co c0h cc0 helch sto2i sthil oveq2d eqtrd choc1
    cmin fveq2i 1m1e0 3eqtr3g ) ABCZDEFZAFZGGQHZIAFJUAUCGDAFZQHUDDAKLUAUEGGQAMN
    OUBIAPRST $.

  ${
    $d u x A $.  $d u x B $.
    strlem1.1 $e |- A e. CH $.
    strlem1.2 $e |- B e. CH $.
    $( Lemma for strong state theorem: if closed subspace ` A ` is not
       contained in ` B ` , there is a unit vector ` u ` in their difference.
       (Contributed by NM, 25-Oct-1999.)  (New usage is discouraged.) $)
    strlem1 $p |- ( -. A C_ B -> E. u e. ( A \ B ) ( normh ` u ) = 1 ) $=
      ( vx wn wcel cno cfv c1 wceq co csm wa 3syl cc0 c0v syl cmul wss cdif wex
      cv wrex c0 neq0 ssdif0 xchnxbir cdiv cc wi cr eldifi cheli normcl cch ch0
      chil ax-mp eldifn mt2 eleq1 mtbiri con2i wb norm-i neneqad rereccld recnd
      mtbird csh chshii shmulcl mp3an1 ex recidd ax-hvmulass syl3anc ax-hvmulid
      oveq1d 3eqtr3d eleq1d sylibd con3d anim12d eldif 3imtr4g pm2.43i norm-iii
      cabs syl2anc clt wbr cle wne necon2ai normgt0 mpbid divge0 mpanl12 absidd
      1re 0le1 recid2d 3eqtrd fveq2 eqeq1d rspcev exlimiv sylbi ) BCUAZGFUDZBCU
      BZHZFUCZAUDZIJZKLZAXNUEZXNUFLXPXLFXNUGBCUHUIXOXTFXOKXMIJZUJMZXMNMZXNHZYCI
      JZKLZXTXOYDXOXMBHZXMCHZGZOYCBHZYCCHZGZOXOYDXOYGYJYIYLXOYBUKHZYGYJULXOYBXO
      YAXOYGXMUSHZYAUMHZXMBCUNZXMBDUOZXMUPPZXOYAQXOYAQLZXMRLZYTXOYTXORXNHZUUARC
      HZCUQHUUBECURUTRBCVAVBXMRXNVCVDZVEXOYGYNYSYTVFYPYQXMVGPVKVHZVIZVJZYMYGYJB
      VLHYMYGYJBDVMYBXMBVNVOVPSXOYKYHXOYKYAYCNMZCHZYHXOYAUKHZYKUUHULXOYAYRVJZUU
      IYKUUHCVLHUUIYKUUHCEVMYAYCCVNVOVPSXOUUGXMCXOYAYBTMZXMNMZKXMNMZUUGXMXOUUKK
      XMNXOYAUUJUUDVQWAXOUUIYMYNUULUUGLUUJUUFXOYGYNYPYQSZYAYBXMVRVSXOYGYNUUMXML
      YPYQXMVTPWBWCWDWEWFXMBCWGYCBCWGWHWIXOYEYBWKJZYATMZYBYATMKXOYMYNYEUUPLUUFU
      UNYBXMWJWLXOUUOYBYATXOYBUUEXOYOQYAWMWNZQYBWOWNZYRXOXMRWPZUUQXOXMRUUCWQXOY
      GYNUUSUUQVFYPYQXMWRPWSKUMHQKWOWNYOUUQOUURXCXDKYAWTXAWLXBWAXOYAUUJUUDXEXFX
      SYFAYCXNXQYCLXRYEKXQYCIXGXHXIWLXJXK $.
  $}

  ${
    $d x y C $.  $d x y u $.
    strlem2.1 $e |- S = ( x e. CH |->
                           ( ( normh ` ( ( projh ` x ) ` u ) ) ^ 2 ) ) $.
    $( Lemma for strong state theorem.  (Contributed by NM, 28-Oct-1999.)
       (New usage is discouraged.) $)
    strlem2 $p |- ( C e. CH ->
                  ( S ` C ) = ( ( normh ` ( ( projh ` C ) ` u ) ) ^ 2 ) ) $=
      ( cv cpjh cfv cno c2 cexp cch wceq fveq2 fveq1d fveq2d oveq1d ovex fvmpt
      co ) ACBFZAFZGHZHZIHZJKTUACGHZHZIHZJKTLDUBCMZUEUHJKUIUDUGIUIUAUCUFUBCGNOP
      QEUHJKRS $.
  $}

  ${
    $d x y z w u $.  $d z w S $.
    strlem3a.1 $e |- S = ( x e. CH |->
                           ( ( normh ` ( ( projh ` x ) ` u ) ) ^ 2 ) ) $.
    $( Lemma for strong state theorem: the function ` S ` , that maps a closed
       subspace to the square of the norm of its projection onto a unit vector,
       is a state.  (Contributed by NM, 28-Oct-1999.)
       (New usage is discouraged.) $)
    strlem3a $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) -> S e. States ) $=
      ( vz vw cv chil wcel cno cfv c1 wceq cch co cpjh c2 cexp cle wbr cc0 cicc
      wa wf cort wss chj caddc wi wral cst cr id simpl pjhcl syl2anr normcl syl
      resqcld sqge0d normge0 pjnorm simplr breqtrd w3a cn0 exple1 mpan2 syl3anc
      0re elicc2i syl3anbrc fmptd helch strlem2 ax-mp pjch1 fveq2d oveq1d oveq1
      1re sq1 syl6eq sylan9eq syl5eq cva pjcjt2 imp pjopyth eqtrd chjcl 3adant3
      2nn0 adantr 3simpa oveqan12d 3eqtr4d 3exp1 com3r ralrimdv ralrimiv isst )
      BGZHIZXCJKZLMZUCZNUALUBOZCUDHCKZLMEGZFGZUEKUFZXJXKUGOZCKZXJCKZXKCKZUHOZMZ
      UIZFNUJZENUJCUKIXGANXCAGZPKKZJKZQROZXHCXGYANIZUCZYDULIUAYDSTYDLSTZYDXHIYF
      YCYFYBHIZYCULIZYEYEXDYHXGYEUMZXDXFUNZXCYAUOUPZYBUQURZUSYFYCYMUTYFYIUAYCST
      ZYCLSTZYGYMYFYHYNYLYBVAURYFYCXELSYEYEXDYCXESTXGYJYKXCYAVBUPXDXFYEVCVDYIYN
      YOVEQVFIYGWMYCQVGVHVIUALYDVJWAVKVLDVMXGXIXCHPKKZJKZQROZLHNIXIYRMVNABHCDVO
      VPXDXFYRXEQROZLXDYQXEQRXDYPXCJXCVQVRVSXFYSLQROLXELQRVTWBWCWDWEXGXTENXGXJN
      IZXSFNXDYTXKNIZXSUIUIXFYTUUAXDXSYTUUAXDXLXRYTUUAXDVEZXLUCZXCXMPKKZJKZQROZ
      XCXJPKKZJKQROZXCXKPKKZJKQROZUHOZXNXQUUCUUFUUGUUIWFOZJKZQROZUUKUUCUUEUUMQR
      UUCUUDUULJUUBXLUUDUULMXCXKXJWGWHVRVSUUBXLUUNUUKMXCXKXJWIWHWJUUCXMNIZXNUUF
      MUUBUUOXLYTUUAUUOXDXJXKWKWLWNABXMCDVOURUUCYTUUAUCZXQUUKMUUBUUPXLYTUUAXDWO
      WNYTUUAXOUUHXPUUJUHABXJCDVOABXKCDVOWPURWQWRWSWNWTXAEFCXBVL $.
  $}

  ${
    $d x z w ph $.  $d z w S $.  $d x y u $.  $d y z w $.  $d x y A $.
    $d x y B $.
    strlem3.1 $e |- S = ( x e. CH |->
                          ( ( normh ` ( ( projh ` x ) ` u ) ) ^ 2 ) ) $.
    strlem3.2 $e |- ( ph <-> ( u e. ( A \ B ) /\ ( normh ` u ) = 1 ) ) $.
    strlem3.3 $e |- A e. CH $.
    strlem3.4 $e |- B e. CH $.
    $( Lemma for strong state theorem: the function ` S ` , that maps a closed
       subspace to the square of the norm of its projection onto a unit vector,
       is a state.  This lemma restates the hypotheses in a more convenient
       form to work with.  (Contributed by NM, 28-Oct-1999.)
       (New usage is discouraged.) $)
    strlem3 $p |- ( ph -> S e. States ) $=
      ( cv cdif wcel cno cfv c1 wceq wa cst chil cheli syl strlem3a sylan sylbi
      eldifi ) ACKZDELMZUGNOPQZRFSMZHUHUGTMZUIUJUHUGDMUKUGDEUFUGDIUAUBBCFGUCUDU
      E $.

    $( Lemma for strong state theorem.  (Contributed by NM, 2-Nov-1999.)
       (New usage is discouraged.) $)
    strlem4 $p |- ( ph -> ( S ` A ) = 1 ) $=
      ( cfv cv cpjh cno c2 cexp co c1 wcel wceq cch strlem2 cdif wa eldifi pjid
      ax-mp mpan fveq2d eqeq2 syl5ib mpan9 sylbi oveq1d sq1 syl6eq syl5eq ) ADF
      KZCLZDMKKZNKZOPQZRDUASZURVBTIBCDFGUBUGAVBROPQRAVAROPAUSDEUCSZUSNKZRTZUDVA
      RTZHVDUSDSZVFVGUSDEUEVHVAVETVFVGVHUTUSNVCVHUTUSTIUSDUFUHUIVERVAUJUKULUMUN
      UOUPUQ $.

    $( Lemma for strong state theorem.  (Contributed by NM, 2-Nov-1999.)
       (New usage is discouraged.) $)
    strlem5 $p |- ( ph -> ( S ` B ) < 1 ) $=
      ( wcel cno cfv c1 wceq wa clt wbr c2 cexp cv cdif co cch strlem2 ax-mp wn
      cpjh eldif chil cheli pjnel biimpa sylan sylbi breq2 syl5ib impcom eldifi
      wb mpan cc0 cle pjhcli normcl syl normge0 0le1 lt2sq mpanr12 syl2anc 3syl
      cr 1re adantr mpbid syl5eqbr sq1 syl6breq ) ACUAZDEUBKZVTLMZNOZPZEFMZNQRH
      WDWENSTUCZNQWDWEVTEUHMMZLMZSTUCZWFQEUDKZWEWIOJBCEFGUEUFWDWHNQRZWIWFQRZWCW
      AWKWAWHWBQRZWCWKWAVTDKZVTEKUGZPWMVTDEUIWNVTUJKZWOWMVTDIUKZWPWOWMWJWPWOWMU
      TJVTEULVAUMUNUOWBNWHQUPUQURWAWKWLUTZWCWAWNWPWRVTDEUSWQWPWHVMKZVBWHVCRZWRW
      PWGUJKZWSVTEJVDZWGVEVFWPXAWTXBWGVGVFWSWTPNVMKVBNVCRWRVNVHWHNVIVJVKVLVOVPV
      QVRVSUO $.

    $( Lemma for strong state theorem.  (Contributed by NM, 2-Nov-1999.)
       (New usage is discouraged.) $)
    strlem6 $p |- ( ph -> -. ( ( S ` A ) = 1 -> ( S ` B ) = 1 ) ) $=
      ( cfv c1 wceq wn wa wi strlem4 cst wcel cch cr strlem3 stcl strlem5 ltned
      ee10 neneqd jca annim sylib ) ADFKLMZEFKZLMZNZOUKUMPNAUKUNABCDEFGHIJQAULL
      AULLAFRSETSULUASABCDEFGHIJUBJEFUCUFABCDEFGHIJUDUEUGUHUKUMUIUJ $.
  $}

  ${
    $d x y u f A $.  $d x y u f B $.
    str.1 $e |- A e. CH $.
    str.2 $e |- B e. CH $.
    $( Strong state theorem.  The states on a Hilbert lattice define an
       ordering.  Remark in [Mayet] p. 370.  (Contributed by NM, 2-Nov-1999.)
       (New usage is discouraged.) $)
    stri $p |- ( A. f e. States ( ( f ` A ) = 1 -> ( f ` B ) = 1 ) ->
              A C_ B ) $=
      ( vu vx cv cfv c1 wceq wi cst wral wn wrex cno wcel fveq1 eqeq1d wss cdif
      dfral2 strlem1 wa cch cpjh c2 cexp cmpt eqid biid strlem3 strlem6 imbi12d
      co notbid rspcev syl2anc rexlimiva syl con1i sylbi ) ACHZIZJKZBVDIZJKZLZC
      MNVIOZCMPZOABUAZVICMUCVLVKVLOFHZQIJKZFABUBZPVKFABDEUDVNVKFVOVMVORVNUEZGUF
      VMGHUGIIQIUHUIUPUJZMRAVQIZJKZBVQIZJKZLZOZVKVPGFABVQVQUKZVPULZDEUMVPGFABVQ
      WDWEDEUNVJWCCVQMVDVQKZVIWBWFVFVSVHWAWFVEVRJAVDVQSTWFVGVTJBVDVQSTUOUQURUSU
      TVAVBVC $.

    $( Strong state theorem (bidirectional version).  (Contributed by NM,
       7-Apr-2001.)  (New usage is discouraged.) $)
    strb $p |- ( A. f e. States ( ( f ` A ) = 1 -> ( f ` B ) = 1 ) <->
              A C_ B ) $=
      ( cv cfv c1 wceq wi cst wral wss stri wcel stlesi com12 ralrimiv impbii )
      ACFZGHIBTGHIJZCKLABMZABCDENUBUACKTKOUBUAABTDEPQRS $.
  $}

  ${
    $d x y C $.  $d x y u $.
    hstrlem2.1 $e |- S = ( x e. CH |-> ( ( projh ` x ) ` u ) ) $.
    $( Lemma for strong set of CH states theorem.  (Contributed by NM,
       30-Jun-2006.)  (New usage is discouraged.) $)
    hstrlem2 $p |- ( C e. CH ->
                  ( S ` C ) = ( ( projh ` C ) ` u ) ) $=
      ( cv cpjh cfv cch wceq fveq2 fveq1d fvex fvmpt ) ACBFZAFZGHZHOCGHZHIDPCJO
      QRPCGKLEORMN $.
  $}

  ${
    $d x z w u $.  $d z w S $.  $d x y u $.  $d y z w $.
    hstrlem3a.1 $e |- S = ( x e. CH |-> ( ( projh ` x ) ` u ) ) $.
    $( Lemma for strong set of CH states theorem: the function ` S ` , that
       maps a closed subspace to the square of the norm of its projection onto
       a unit vector, is a state.  (Contributed by NM, 30-Jun-2006.)
       (New usage is discouraged.) $)
    hstrlem3a $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) -> S e. CHStates ) $=
      ( vz vw cv chil wcel cno cfv c1 wceq wa cch csp co cpjh hstrlem2 adantr
      wf cort wss cc0 chj cva wral chst pjhcl ancoms adantlr fmptd helch fveq2i
      wi ax-mp pjch1 fveq2d id sylan9eq syl5eq w3a oveqan12d pjoi0 eqtrd pjcjt2
      3adant3 imp chjcl syl 3eqtr4d jca 3exp1 com3r ralrimdv ralrimiv syl3anbrc
      ishst ) BGZHIZVSJKZLMZNZOHCUAHCKZJKZLMEGZFGZUBKUCZWFCKZWGCKZPQZUDMZWFWGUE
      QZCKZWIWJUFQZMZNZUOZFOUGZEOUGCUHIWCAOVSAGZRKKZHCVTWTOIZXAHIZWBXBVTXCVSWTU
      IUJUKDULWCWEVSHRKKZJKZLWDXDJHOIWDXDMUMABHCDSUPUNVTWBXEWALVTXDVSJVSUQURWBU
      SUTVAWCWSEOWCWFOIZWRFOVTXFWGOIZWRUOUOWBXFXGVTWRXFXGVTWHWQXFXGVTVBZWHNZWLW
      PXIWKVSWFRKKZVSWGRKKZPQZUDXHWKXLMZWHXFXGXMVTXFXGWIXJWJXKPABWFCDSZABWGCDSZ
      VCVGTVSWFWGVDVEXIVSWMRKKZXJXKUFQZWNWOXHWHXPXQMVSWGWFVFVHXHWNXPMZWHXFXGXRV
      TXFXGNWMOIXRWFWGVIABWMCDSVJVGTXHWOXQMZWHXFXGXSVTXFXGWIXJWJXKUFXNXOVCVGTVK
      VLVMVNTVOVPEFCVRVQ $.
  $}

  ${
    $d x z w ph $.  $d z w S $.  $d x y u $.  $d y z w $.  $d x y A $.
    $d x y B $.
    hstrlem3.1 $e |- S = ( x e. CH |-> ( ( projh ` x ) ` u ) ) $.
    hstrlem3.2 $e |- ( ph <-> ( u e. ( A \ B ) /\ ( normh ` u ) = 1 ) ) $.
    hstrlem3.3 $e |- A e. CH $.
    hstrlem3.4 $e |- B e. CH $.
    $( Lemma for strong set of CH states theorem: the function ` S ` , that
       maps a closed subspace to the square of the norm of its projection onto
       a unit vector, is a state.  This lemma restates the hypotheses in a more
       convenient form to work with.  (Contributed by NM, 30-Jun-2006.)
       (New usage is discouraged.) $)
    hstrlem3 $p |- ( ph -> S e. CHStates ) $=
      ( cv cdif wcel cno cfv c1 wceq wa chst chil eldifi cheli hstrlem3a sylan
      syl sylbi ) ACKZDELMZUGNOPQZRFSMZHUHUGTMZUIUJUHUGDMUKUGDEUAUGDIUBUEBCFGUC
      UDUF $.

    $( Lemma for strong set of CH states theorem.  (Contributed by NM,
       30-Jun-2006.)  (New usage is discouraged.) $)
    hstrlem4 $p |- ( ph -> ( normh ` ( S ` A ) ) = 1 ) $=
      ( cfv cno cv cpjh c1 cch wcel wceq hstrlem2 ax-mp fveq2i cdif eldifi pjid
      wa mpan fveq2d eqeq2 syl5ib mpan9 sylbi syl5eq ) ADFKZLKCMZDNKKZLKZOUMUOL
      DPQZUMUORIBCDFGSTUAAUNDEUBQZUNLKZORZUEUPORZHURUNDQZUTVAUNDEUCVBUPUSRUTVAV
      BUOUNLUQVBUOUNRIUNDUDUFUGUSOUPUHUIUJUKUL $.

    $( Lemma for strong set of CH states theorem.  (Contributed by NM,
       30-Jun-2006.)  (New usage is discouraged.) $)
    hstrlem5 $p |- ( ph -> ( normh ` ( S ` B ) ) < 1 ) $=
      ( cv wcel cno cfv c1 wceq wa clt wbr sylbi cdif cch hstrlem2 fveq2d ax-mp
      cpjh wn eldif chil cheli wb pjnel mpan biimpa sylan breq2 syl5ib syl5eqbr
      impcom ) ACKZDEUALZUTMNZOPZQZEFNZMNZORSHVDVFUTEUFNNZMNZOREUBLZVFVHPJVIVEV
      GMBCEFGUCUDUEVCVAVHORSZVAVHVBRSZVCVJVAUTDLZUTELUGZQVKUTDEUHVLUTUILZVMVKUT
      DIUJVNVMVKVIVNVMVKUKJUTEULUMUNUOTVBOVHRUPUQUSURT $.

    $( Lemma for strong set of CH states theorem.  (Contributed by NM,
       30-Jun-2006.)  (New usage is discouraged.) $)
    hstrlem6 $p |- ( ph -> -. ( ( normh ` ( S ` A ) ) = 1 ->
                    ( normh ` ( S ` B ) ) = 1 ) ) $=
      ( cfv cno c1 wceq wn wa wi hstrlem4 chil wcel chst hstrlem3 hstcl sylancl
      cr cch normcl syl hstrlem5 ltned neneqd jca annim sylib ) ADFKLKMNZEFKZLK
      ZMNZOZPUOURQOAUOUSABCDEFGHIJRAUQMAUQMAUPSTZUQUETAFUATEUFTUTABCDEFGHIJUBJE
      FUCUDUPUGUHABCDEFGHIJUIUJUKULUOURUMUN $.
  $}

  ${
    $d x y u f A $.  $d x y u f B $.
    hstr.1 $e |- A e. CH $.
    hstr.2 $e |- B e. CH $.
    $( Hilbert space admits a strong set of Hilbert-space-valued states
       (CH-states).  Theorem in [Mayet3] p. 10.  (Contributed by NM,
       30-Jun-2006.)  (New usage is discouraged.) $)
    hstri $p |- ( A. f e. CHStates ( ( normh ` ( f ` A ) ) = 1 ->
                ( normh ` ( f ` B ) ) = 1 ) -> A C_ B ) $=
      ( vu vx cv cfv cno c1 wceq wi chst wn wrex wcel fveq1 fveq2d eqeq1d con1i
      wral wss dfral2 cdif strlem1 wa cch cpjh cmpt eqid biid hstrlem3 hstrlem6
      imbi12d notbid rspcev syl2anc rexlimiva syl sylbi ) ACHZIZJIZKLZBVBIZJIZK
      LZMZCNUBVIOZCNPZOABUCZVICNUDVLVKVLOFHZJIKLZFABUEZPVKFABDEUFVNVKFVOVMVOQVN
      UGZGUHVMGHUIIIUJZNQAVQIZJIZKLZBVQIZJIZKLZMZOZVKVPGFABVQVQUKZVPULZDEUMVPGF
      ABVQWFWGDEUNVJWECVQNVBVQLZVIWDWHVEVTVHWCWHVDVSKWHVCVRJAVBVQRSTWHVGWBKWHVF
      WAJBVBVQRSTUOUPUQURUSUTUAVA $.

    $( Strong CH-state theorem (bidirectional version).  Theorem in [Mayet3]
       p. 10 and its converse.  (Contributed by NM, 30-Jun-2006.)
       (New usage is discouraged.) $)
    hstrbi $p |- ( A. f e. CHStates ( ( normh ` ( f ` A ) ) = 1 ->
              ( normh ` ( f ` B ) ) = 1 ) <-> A C_ B ) $=
      ( cv cfv cno c1 wceq wi chst wral wss hstri wcel cch wa hstles mpanr1
      mpanl2 expcom ralrimiv impbii ) ACFZGHGIJBUEGHGIJKZCLMABNZABCDEOUGUFCLUEL
      PZUGUFUHAQPZUGUFDUHUIRBQPUGUFEABUESTUAUBUCUD $.
  $}

  ${
    $d f A $.
    large.1 $e |- A e. CH $.
    $( A Hilbert lattice admits a largei set of states.  Remark in [Mayet]
       p. 370.  (Contributed by NM, 7-Apr-2001.)
       (New usage is discouraged.) $)
    largei $p |- ( -. A = 0H <-> E. f e. States ( f ` A ) = 1 ) $=
      ( cv cfv c1 wceq cst wrex c0h wn wral ralnex wi wss wcel cc0 wne ax-1ne0
      wb df-ne mpbi st0 eqeq1d syl6bb mtbiri mtt syl ralbiia h0elch strb chle0i
      eqcom 3bitri bitr3i con1bii ) ABDZEFGZBHIZAJGZUSKURKZBHLZUTURBHMVBURJUQEZ
      FGZNZBHLAJOUTVAVEBHUQHPZVDKVAVETVFVDFQGZFQRVGKSFQUAUBVFVDQFGVGVFVCQFUQUCU
      DQFUMUEUFVDURUGUHUIAJBCUJUKACULUNUOUP $.
  $}

  ${
    jplem1.1 $e |- A e. CH $.
    $( Lemma for Jauch-Piron theorem.  (Contributed by NM, 8-Apr-2001.)
       (New usage is discouraged.) $)
    jplem1 $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) ->
          ( u e. A <-> ( ( normh ` ( ( projh ` A ) ` u ) ) ^ 2 ) = 1 ) ) $=
      ( cv chil wcel cno cfv c1 wceq wa c2 cexp co wb cr cc0 cle wbr syl eqeq2i
      cpjh cch pjnorm2 mpan sylan9bb sq1 pjhcli normcl normge0 1re 0le1 mpanr12
      eqeq2 sq11 syl2anc syl5bbr adantr bitr4d ) ADZEFZUTGHZIJZKUTBFZUTBUBHHZGH
      ZIJZVFLMNZIJZVAVDVFVBJZVCVGBUCFVAVDVJOCUTBUDUEVBIVFUNUFVAVIVGOVCVIVHILMNZ
      JZVAVGVKIVHUGUAVAVFPFZQVFRSZVLVGOZVAVEEFZVMUTBCUHZVEUITVAVPVNVQVEUJTVMVNK
      IPFQIRSVOUKULVFIUOUMUPUQURUS $.
  $}

  ${
    $d x z w u $.  $d z w S $.  $d x y u $.  $d y z w $.  $d x y A $.
    $d x y B $.
    jp.1 $e |- S = ( x e. CH |-> ( ( normh ` ( ( projh ` x ) ` u ) ) ^ 2 ) ) $.
    jp.2 $e |- A e. CH $.
    $( Lemma for Jauch-Piron theorem.  (Contributed by NM, 8-Apr-2001.)
       (New usage is discouraged.) $)
    jplem2 $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) ->
                 ( u e. A <-> ( S ` A ) = 1 ) ) $=
      ( cv chil wcel cno cfv c1 wceq wa cpjh c2 cexp co jplem1 cch ax-mp eqeq1i
      strlem2 syl6bbr ) BGZHIUEJKLMNUECIUECOKKJKPQRZLMCDKZLMBCFSUGUFLCTIUGUFMFA
      BCDEUCUAUBUD $.

    ${
      jp.3 $e |- B e. CH $.
      $( The function ` S ` , that maps a closed subspace to the square of the
         norm of its projection onto a unit vector, is a Jauch-Piron state.
         Remark in [Mayet] p. 370.  (See ~ strlem3a for the proof that ` S ` is
         a state.)  (Contributed by NM, 8-Apr-2001.)
         (New usage is discouraged.) $)
      jpi $p |- ( ( u e. ~H /\ ( normh ` u ) = 1 ) -> ( ( ( S ` A ) = 1
               /\ ( S ` B ) = 1 ) <-> ( S ` ( A i^i B ) ) = 1 ) ) $=
        ( cv chil wcel cno cfv c1 wceq wa cin elin jplem2 anbi12d syl5bb bitr3d
        chincli ) BIZJKUDLMNOPZUDCDQZKZCEMNOZDEMNOZPZUFEMNOUGUDCKZUDDKZPUEUJUDC
        DRUEUKUHULUIABCEFGSABDEFHSTUAABUFEFCDGHUCSUB $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Godowski's equation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    golem1.1 $e |- A e. CH $.
    golem1.2 $e |- B e. CH $.
    golem1.3 $e |- C e. CH $.
    golem1.4 $e |- F = ( ( _|_ ` A ) vH ( A i^i B ) ) $.
    golem1.5 $e |- G = ( ( _|_ ` B ) vH ( B i^i C ) ) $.
    golem1.6 $e |- H = ( ( _|_ ` C ) vH ( C i^i A ) ) $.
    golem1.7 $e |- D = ( ( _|_ ` B ) vH ( B i^i A ) ) $.
    golem1.8 $e |- R = ( ( _|_ ` C ) vH ( C i^i B ) ) $.
    golem1.9 $e |- S = ( ( _|_ ` A ) vH ( A i^i C ) ) $.
    $( Lemma for Godowski's equation.  (Contributed by NM, 10-Nov-2002.)
       (New usage is discouraged.) $)
    golem1 $p |- ( f e. States -> ( ( ( f ` F ) + ( f ` G ) ) + ( f ` H ) ) =
                 ( ( ( f ` D ) + ( f ` R ) ) + ( f ` S ) ) ) $=
      ( caddc cv cst wcel cort cfv cin chj co cch cr choccli stcl recnd addassd
      mpi addcld addcomd eqtrd oveq1d chincli add4d 3eqtr4d stji1i incom fveq2i
      oveq12d oveq2i syl6eq oveq12i 3eqtr4g ) GUAZUBUCZAUDUEZABUFZUGUHZVKUEZBUD
      UEZBCUFZUGUHZVKUEZTUHZCUDUEZCAUFZUGUHZVKUEZTUHZVQBAUFZUGUHZVKUEZWBCBUFZUG
      UHZVKUEZTUHZVMACUFZUGUHZVKUEZTUHZHVKUEZIVKUEZTUHZJVKUEZTUHDVKUEZEVKUEZTUH
      ZFVKUEZTUHVLVMVKUEZVNVKUEZTUHZVQVKUEZVRVKUEZTUHZTUHZWBVKUEZWCVKUEZTUHZTUH
      ZXIXGTUHZXMXJTUHZTUHZXFXNTUHZTUHZWFWQVLXFXITUHZXGXJTUHZTUHZXOTUHZXIXMTUHZ
      YCTUHZXTTUHZXPYAVLYBXMTUHZYCXNTUHZTUHYFXFTUHZYJTUHYEYHVLYIYKYJTVLYIXFYFTU
      HYKVLXFXIXMVLXFVLVMUIUCXFUJUCAKUKVMVKULUOUMZVLXIVLVQUIUCXIUJUCBLUKVQVKULU
      OUMZVLXMVLWBUIUCXMUJUCCMUKWBVKULUOUMZUNVLXFYFYLVLXIXMYMYNUPZUQURUSVLYBYCX
      MXNVLXFXIYLYMUPVLXGXJVLXGVLVNUIUCXGUJUCABKLUTVNVKULUOUMZVLXJVLVRUIUCXJUJU
      CBCLMUTVRVKULUOUMZUPZYNVLXNVLWCUIUCXNUJUCCAMKUTWCVKULUOUMZVAVLYFYCXFXNYOY
      RYLYSVAVBVLXLYDXOTVLXFXGXIXJYLYPYMYQVAUSVLXSYGXTTVLXIXGXMXJYMYPYNYQVAUSVB
      VLWAXLWEXOTVLVPXHVTXKTABVKKLVCBCVKLMVCVFCAVKMKVCVFVLWMXSWPXTTVLWIXQWLXRTV
      LWIXIWGVKUEZTUHXQBAVKLKVCYTXGXITWGVNVKBAVDVEVGVHVLWLXMWJVKUEZTUHXRCBVKMLV
      CUUAXJXMTWJVRVKCBVDVEVGVHVFVLWPXFWNVKUEZTUHXTACVKKMVCUUBXNXFTWNWCVKACVDVE
      VGVHVFVBWTWAXAWETWRVPWSVTTHVOVKNVEIVSVKOVEVIJWDVKPVEVIXDWMXEWPTXBWIXCWLTD
      WHVKQVEEWKVKRVEVIFWOVKSVEVIVJ $.

    $( Lemma for Godowski's equation.  (Contributed by NM, 13-Nov-1999.)
       (New usage is discouraged.) $)
    golem2 $p |- ( f e. States ->
              ( ( f ` ( ( F i^i G ) i^i H ) ) = 1 -> ( f ` D ) = 1 ) ) $=
      ( cfv cv cst wcel cin c1 wceq caddc co c3 cort chj choccli chincli chjcli
      cch eqeltri stm1add3i golem1 eqeq1d sylibd stadd3i syld ) GUAZUBUCZHIUDJU
      DVCTUEUFZDVCTZEVCTUGUHFVCTUGUHZUIUFZVFUEUFVDVEHVCTIVCTUGUHJVCTUGUHZUIUFVH
      HIJVCHAUJTZABUDZUKUHUONVJVKAKULZABKLUMUNUPIBUJTZBCUDZUKUHUOOVMVNBLULZBCLM
      UMUNUPJCUJTZCAUDZUKUHUOPVPVQCMULZCAMKUMUNUPUQVDVIVGUIABCDEFGHIJKLMNOPQRSU
      RUSUTDEFVCDVMBAUDZUKUHUOQVMVSVOBALKUMUNUPEVPCBUDZUKUHUORVPVTVRCBMLUMUNUPF
      VJACUDZUKUHUOSVJWAVLACKMUMUNUPVAVB $.
  $}

  ${
    $d f F $.  $d f G $.  $d f H $.  $d f D $.
    goeq.1 $e |- A e. CH $.
    goeq.2 $e |- B e. CH $.
    goeq.3 $e |- C e. CH $.
    goeq.4 $e |- F = ( ( _|_ ` A ) vH ( A i^i B ) ) $.
    goeq.5 $e |- G = ( ( _|_ ` B ) vH ( B i^i C ) ) $.
    goeq.6 $e |- H = ( ( _|_ ` C ) vH ( C i^i A ) ) $.
    goeq.7 $e |- D = ( ( _|_ ` B ) vH ( B i^i A ) ) $.
    $( Godowski's equation, shown here as a variant equivalent to Equation SF
       of [Godowski] p. 730.  (Contributed by NM, 10-Nov-2002.)
       (New usage is discouraged.) $)
    goeqi $p |- ( ( F i^i G ) i^i H ) C_ D $=
      ( vf cin cfv chj co chincli cv c1 wceq wi wss cst cort cch choccli chjcli
      eqeltri stri eqid golem2 mprg ) EFPZGPZOUAZQUBUCDURQUBUCUDUQDUEOUFUQDOUPG
      EFEAUGQZABPZRSUHKUSUTAHUIABHITUJUKFBUGQZBCPZRSUHLVAVBBIUIZBCIJTUJUKTGCUGQ
      ZCAPZRSUHMVDVECJUICAJHTUJUKTDVABAPZRSUHNVAVFVCBAIHTUJUKULABCDVDCBPRSZUSAC
      PRSZOEFGHIJKLMNVGUMVHUMUNUO $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y S $.
    stcltr1.1 $e |- ( ph <-> ( S e. States /\ A. x e. CH A. y e. CH
                ( ( ( S ` x ) = 1 -> ( S ` y ) = 1 ) -> x C_ y ) ) ) $.
    stcltr1.2 $e |- A e. CH $.
    ${
      stcltr1.3 $e |- B e. CH $.
      $( Property of a strong classical state.  (Contributed by NM,
         24-Oct-1999.)  (New usage is discouraged.) $)
      stcltr1i $p |- ( ph ->
               ( ( ( S ` A ) = 1 -> ( S ` B ) = 1 ) -> A C_ B ) ) $=
        ( wcel cv cfv c1 wceq wi wss cch wral fveq2 eqeq1d cst wa sseq1 imbi12d
        imbi1d imbi2d sseq2 rspc2v mp2an adantl sylbi ) AFUAJZBKZFLZMNZCKZFLZMN
        ZOZUMUPPZOZCQRBQRZUBDFLZMNZEFLZMNZOZDEPZOZGVBVIULDQJEQJVBVIOHIVAVIVDURO
        ZDUPPZOBCDEQQUMDNZUSVJUTVKVLUOVDURVLUNVCMUMDFSTUEUMDUPUCUDUPENZVJVGVKVH
        VMURVFVDVMUQVEMUPEFSTUFUPEDUGUDUHUIUJUK $.
    $}

    $( Property of a strong classical state.  (Contributed by NM,
       24-Oct-1999.)  (New usage is discouraged.) $)
    stcltr2i $p |- ( ph -> ( ( S ` A ) = 1 -> A = ~H ) ) $=
      ( cfv c1 wceq chil wss wi ax-1 helch stcltr1i syl5 chssii eqss mpbiran
      syl6ibr ) ADEHIJZKDLZDKJZUBKEHIJZUBMAUCUBUENABCKDEFOGPQUDDKLUCDGRDKSTUA
      $.

    ${
      stcltrlem1.3 $e |- B e. CH $.
      $( Lemma for strong classical state theorem.  (Contributed by NM,
         24-Oct-1999.)  (New usage is discouraged.) $)
      stcltrlem1 $p |- ( ph -> ( ( S ` B ) = 1 ->
                    ( S ` ( ( _|_ ` A ) vH ( A i^i B ) ) ) = 1 ) ) $=
        ( cfv c1 wceq cin co caddc wcel cch syl chil eqtrd chj wa cst cv wi wss
        cort wral simplbi stji1i adantr stcltr2i imp ineq2 syl6eq fveq2d oveq2d
        chm1i cr choccli stcl mpi recnd addcomd sto1i ex ) AEFJKLZDUGJZDEMZUANF
        JZKLAVGUBZVJVHFJZVIFJZONZKAVJVNLZVGAFUCPZVOAVPBUDZFJKLCUDZFJKLUEVQVRUFU
        ECQUHBQUHGUIZDEFHIUJRUKVKVNVLDFJZONZKVKVMVTVLOVKVIDFVKESLZVIDLAVGWBABCE
        FGIULUMWBVIDSMDESDUNDHURUORUPUQVKVPWAKLAVPVGVSUKVPWAVTVLONKVPVLVTVPVLVP
        VHQPVLUSPDHUTVHFVAVBVCVPVTVPDQPVTUSPHDFVAVBVCVDDFHVETRTTVF $.

      $( Lemma for strong classical state theorem.  (Contributed by NM,
         24-Oct-1999.)  (New usage is discouraged.) $)
      stcltrlem2 $p |- ( ph -> B C_ ( ( _|_ ` A ) vH ( A i^i B ) ) ) $=
        ( cfv c1 wceq cort cin chj co wi wss stcltrlem1 choccli chjcli stcltr1i
        chincli mpd ) AEFJKLDMJZDENZOPZFJKLQEUGRABCDEFGHISABCEUGFGIUEUFDHTDEHIU
        CUAUBUD $.
    $}
  $}

  ${
    $d x y s A $.  $d x y s B $.
    stcltrth.1 $e |- A e. CH $.
    stcltrth.2 $e |- B e. CH $.
    stcltrth.3 $e |- E. s e. States A. x e. CH A. y e. CH
                ( ( ( s ` x ) = 1 -> ( s ` y ) = 1 ) -> x C_ y ) $.
    $( Theorem for classically strong set of states.  If there exists a
       "classically strong set of states" on lattice ` CH ` (or actually any
       ortholattice, which would have an identical proof), then any two
       elements of the lattice commute, i.e., the lattice is distributive.
       (Proof due to Mladen Pavicic.)  Theorem 3.3 of [MegPav2000] p. 2344.
       (Contributed by NM, 24-Oct-1999.)  (New usage is discouraged.) $)
    stcltrthi $p |- B C_ ( ( _|_ ` A ) vH ( A i^i B ) ) $=
      ( cv cfv c1 wceq wi wss cch wral cst wrex cort cin chj co wcel stcltrlem2
      wa biid rexlimiva ax-mp ) AIZEIZJKLBIZUJJKLMUIUKNMBOPAOPZEQRDCSJCDTUAUBNZ
      HULUMEQUJQUCULUEZABCDUJUNUFFGUDUGUH $.
  $}

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
           Cover relation, atoms, exchange axiom, and modular symmetry
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Covers relation; modular pairs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Define the covers relation (on the Hilbert lattice).  Definition 3.2.18
       of [PtakPulmannova] p. 68, whose notation we use.  Ptak/Pulmannova's
       notation ` A <oH B ` is read " ` B ` covers ` A ` " or " ` A ` is
       covered by ` B ` " , and it means that ` B ` is larger than ` A ` and
       there is nothing in between.  See ~ cvbr and ~ cvbr2 for membership
       relations.  (Contributed by NM, 4-Jun-2004.)
       (New usage is discouraged.) $)
    df-cv $a |- <oH = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
              ( x C. y /\ -. E. z e. CH ( x C. z /\ z C. y ) ) ) } $.

    $( Define the modular pair relation (on the Hilbert lattice).  Definition
       1.1 of [MaedaMaeda] p. 1, who use the notation (x,y)M for "the ordered
       pair <x,y> is a modular pair."  See ~ mdbr for membership relation.
       (Contributed by NM, 14-Jun-2004.)  (New usage is discouraged.) $)
    df-md $a |- MH = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
    A. z e. CH ( z C_ y -> ( ( z vH x ) i^i y ) = ( z vH ( x i^i y ) ) ) ) } $.

    $( Define the dual modular pair relation (on the Hilbert lattice).
       Definition 1.1 of [MaedaMaeda] p. 1, who use the notation (x,y)M* for
       "the ordered pair <x,y> is a dual modular pair."  See ~ dmdbr for
       membership relation.  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    df-dmd $a |- MH* = { <. x , y >. | ( ( x e. CH /\ y e. CH ) /\
    A. z e. CH ( y C_ z -> ( ( z i^i x ) vH y ) = ( z i^i ( x vH y ) ) ) ) } $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( Binary relation expressing ` B ` covers ` A ` , which means that ` B `
       is larger than ` A ` and there is nothing in between.  Definition 3.2.18
       of [PtakPulmannova] p. 68.  (Contributed by NM, 4-Jun-2004.)
       (New usage is discouraged.) $)
    cvbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A <oH B <->
              ( A C. B /\ -. E. x e. CH ( A C. x /\ x C. B ) ) ) ) $=
      ( vy vz cch wcel wa ccv wpss cv wrex wn wceq anbi1d psseq1 rexbidv notbid
      eleq1 anbi12d wbr anbi2d psseq2 df-cv brabg bianabs ) BFGZCFGZHZBCIUABCJZ
      BAKZJZUKCJZHZAFLZMZHZDKZFGZEKZFGZHZURUTJZURUKJZUKUTJZHZAFLZMZHZHUGVAHZBUT
      JZULVEHZAFLZMZHZHUIUQHDEBCFFIURBNZVBVJVIVOVPUSUGVAURBFSOVPVCVKVHVNURBUTPV
      PVGVMVPVFVLAFVPVDULVEURBUKPOQRTTUTCNZVJUIVOUQVQVAUHUGUTCFSUBVQVKUJVNUPUTC
      BUCVQVMUOVQVLUNAFVQVEUMULUTCUKUCUBQRTTDEAUDUEUF $.

    $( Binary relation expressing ` B ` covers ` A ` .  Definition of covers in
       [Kalmbach] p. 15.  (Contributed by NM, 9-Jun-2004.)
       (New usage is discouraged.) $)
    cvbr2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A <oH B <->
             ( A C. B /\ A. x e. CH ( ( A C. x /\ x C_ B ) -> x = B ) ) ) ) $=
      ( cch wcel wa ccv wbr wpss cv wrex wn wceq wi wral cvbr iman anass anbi2i
      wss dfpss2 bitr4i xchbinx ralbii ralnex bitri syl6bbr ) BDECDEFBCGHBCIZBA
      JZIZUICIZFZADKLZFUHUJUICTZFZUICMZNZADOZFABCPURUMUHURULLZADOUMUQUSADUQUOUP
      LZFZULUOUPQVAUJUNUTFZFULUJUNUTRUKVBUJUICUASUBUCUDULADUEUFSUG $.

    $( Contraposition law for the covers relation.  (Contributed by NM,
       12-Jun-2004.)  (New usage is discouraged.) $)
    cvcon3 $p |- ( ( A e. CH /\ B e. CH ) ->
                   ( A <oH B <-> ( _|_ ` B ) <oH ( _|_ ` A ) ) ) $=
      ( vx vy cch wcel wa wpss cv wrex wn cort cfv ccv wbr chpsscon3 wb adantlr
      anbi12d choccl ancoms adantll wi wceq psseq2 psseq1 rspcev ancomsd adantl
      sylan ex sylbid rexlimdva chpsscon1 chpsscon2 impbid cvbr syl2anr 3bitr4d
      notbid ) AEFZBEFZGZABHZACIZHZVEBHZGZCEJZKZGBLMZALMZHZVKDIZHZVNVLHZGZDEJZK
      ZGZABNOVKVLNOZVCVDVMVJVSABPVCVIVRVCVIVRVCVHVRCEVCVEEFZGZVHVELMZVLHZVKWDHZ
      GZVRWCVFWEVGWFVAWBVFWEQVBAVEPRVBWBVGWFQZVAWBVBWHVEBPUAUBSWBWGVRUCVCWBWFWE
      VRWBWFWEGZVRWBWDEFWIVRVETVQWIDWDEVNWDUDVOWFVPWEVNWDVKUEVNWDVLUFSUGUJUKUHU
      IULUMVCVQVIDEVCVNEFZGZVQVNLMZBHZAWLHZGZVIWKVOWMVPWNVBWJVOWMQVABVNUNUBVAWJ
      VPWNQZVBWJVAWPVNAUOUARSWJWOVIUCVCWJWNWMVIWJWNWMGZVIWJWLEFWQVIVNTVHWQCWLEV
      EWLUDVFWNVGWMVEWLAUEVEWLBUFSUGUJUKUHUIULUMUPUTSCABUQVBVKEFVLEFWAVTQVABTAT
      DVKVLUQURUS $.

    $( The covers relation implies proper subset.  (Contributed by NM,
       10-Jun-2004.)  (New usage is discouraged.) $)
    cvpss $p |- ( ( A e. CH /\ B e. CH ) -> ( A <oH B -> A C. B ) ) $=
      ( vx cch wcel wa ccv wbr wpss cv wrex wn cvbr simpl syl6bi ) ADEBDEFABGHA
      BIZACJZIQBIFCDKLZFPCABMPRNO $.

    $( The covers relation implies no in-betweenness.  (Contributed by NM,
       12-Jun-2004.)  (New usage is discouraged.) $)
    cvnbtwn $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <oH B ->
                  -. ( A C. C /\ C C. B ) ) ) $=
      ( vx cch wcel ccv wpss wa wn wi cv wrex cvbr psseq2 psseq1 anbi12d rspcev
      wbr wceq ex con3rr3 adantl syl6bi com23 3impia ) AEFZBEFZCEFZABGSZACHZCBH
      ZIZJZKUGUHIZUJUIUNUOUJABHZADLZHZUQBHZIZDEMZJZIUIUNKZDABNVBVCUPUIUMVAUIUMV
      AUTUMDCEUQCTURUKUSULUQCAOUQCBPQRUAUBUCUDUEUF $.
  $}

  $( The covers relation implies no in-betweenness.  (Contributed by NM,
     12-Jun-2004.)  (New usage is discouraged.) $)
  cvnbtwn2 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <oH B ->
                ( ( A C. C /\ C C_ B ) -> C = B ) ) ) $=
    ( cch wcel w3a ccv wbr wpss wa wn wss wceq cvnbtwn iman anass dfpss2 anbi2i
    wi bitr4i notbii bitr2i syl6ib ) ADEBDECDEFABGHACIZCBIZJZKZUDCBLZJZCBMZSZAB
    CNUKUIUJKZJZKUGUIUJOUMUFUMUDUHULJZJUFUDUHULPUEUNUDCBQRTUAUBUC $.

  $( The covers relation implies no in-betweenness.  (Contributed by NM,
     12-Jun-2004.)  (New usage is discouraged.) $)
  cvnbtwn3 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <oH B ->
                ( ( A C_ C /\ C C. B ) -> C = A ) ) ) $=
    ( cch wcel w3a ccv wbr wpss wa wn wss wceq cvnbtwn iman eqcom imbi2i dfpss2
    wi anbi1i an32 bitri notbii 3bitr4ri syl6ib ) ADEBDECDEFABGHACIZCBIZJZKZACL
    ZUGJZCAMZSZABCNUKACMZSUKUNKZJZKUMUIUKUNOULUNUKCAPQUHUPUHUJUOJZUGJUPUFUQUGAC
    RTUJUOUGUAUBUCUDUE $.

  $( The covers relation implies no in-betweenness.  Part of proof of Lemma
     7.5.1 of [MaedaMaeda] p. 31.  (Contributed by NM, 12-Jun-2004.)
     (New usage is discouraged.) $)
  cvnbtwn4 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) -> ( A <oH B ->
                ( ( A C_ C /\ C C_ B ) -> ( C = A \/ C = B ) ) ) ) $=
    ( cch wcel w3a ccv wbr wpss wa wn wss wceq wo wi cvnbtwn iman notbii dfpss2
    an4 ioran eqcom anbi1i bitri anbi2i anbi12i 3bitr4i bitr2i syl6ib ) ADEBDEC
    DEFABGHACIZCBIZJZKZACLZCBLZJZCAMZCBMZNZOZABCPUTUPUSKZJZKUMUPUSQVBULUPACMZKZ
    URKZJZJUNVDJZUOVEJZJVBULUNUOVDVETVAVFUPVAUQKZVEJVFUQURUAVIVDVEUQVCCAUBRUCUD
    UEUJVGUKVHACSCBSUFUGRUHUI $.

  $( The covers relation is not symmetric.  (Contributed by NM, 26-Jun-2004.)
     (New usage is discouraged.) $)
  cvnsym $p |- ( ( A e. CH /\ B e. CH ) -> ( A <oH B -> -. B <oH A ) ) $=
    ( cch wcel wa ccv wbr wpss wn cvpss ancoms pssn2lp imnani syl6 con2d syld
    wi ) ACDZBCDZEZABFGABHZBAFGZIABJTUBUATUBBAHZUAISRUBUCQBAJKUCUABALMNOP $.

  $( The covers relation is not reflexive.  (Contributed by NM, 26-Jun-2004.)
     (New usage is discouraged.) $)
  cvnref $p |- ( A e. CH -> -. A <oH A ) $=
    ( cch wcel ccv wbr wn wi cvnsym anidms pm2.01d ) ABCZAADEZKLLFGAAHIJ $.

  $( The covers relation is not transitive.  (Contributed by NM, 26-Jun-2004.)
     (New usage is discouraged.) $)
  cvntr $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
                ( ( A <oH B /\ B <oH C ) -> -. A <oH C ) ) $=
    ( cch wcel w3a ccv wpss wn wi cvpss 3adant3 3adant1 wa cvnbtwn 3com23 con2d
    wbr syl2and ) ADEZBDEZCDEZFZABGRZABHZBCGRZBCHZACGRZITUAUDUEJUBABKLUAUBUFUGJ
    TBCKMUCUHUEUGNZTUBUAUHUIIJACBOPQS $.

  ${
    $d x A $.  $d x B $.
    $( Hilbert space has the covering property (using spans of singletons to
       represent atoms).  Proposition 1(ii) of [Kalmbach] p. 153.  (Contributed
       by NM, 9-Jun-2004.)  (New usage is discouraged.) $)
    spansncv2 $p |- ( ( A e. CH /\ B e. ~H ) -> ( -. ( span ` { B } ) C_ A ->
                     A <oH ( A vH ( span ` { B } ) ) ) ) $=
      ( vx cch wcel chil wa csn cspn cfv chj co wpss cv wss wceq wi wral sylan2
      wb wn ccv spansncv 3exp com23 ralrimiv anim2i expcom spansnch chnle chjcl
      wbr imp cvbr2 syldan 3imtr4d ) ADEZBFEZGZAABHIJZKLZMZVBACNZMVCVAOGVCVAPQZ
      CDRZGZUTAOUAZAVAUBULZVBUSVFUSVEVBUSVDCDUQURVCDEZVDQUQVIURVDUQVIURVDAVCBUC
      UDUEUMUFUGUHURUQUTDEZVGVBTBUIZAUTUJSUQURVADEZVHVFTURUQVJVLVKAUTUKSCAVAUNU
      OUP $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x C $.
    $( Binary relation expressing ` <. A , B >. ` is a modular pair.
       Definition 1.1 of [MaedaMaeda] p. 1.  (Contributed by NM, 14-Jun-2004.)
       (New usage is discouraged.) $)
    mdbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <->
    A. x e. CH ( x C_ B -> ( ( x vH A ) i^i B ) = ( x vH ( A i^i B ) ) ) ) ) $=
      ( vy vz cch wcel wa cmd cv wss chj co cin wceq wral eleq1 oveq2d eqeq12d
      wi wbr anbi1d oveq2 ineq1d ineq1 imbi2d ralbidv anbi12d sseq2 ineq2 df-md
      anbi2d imbi12d brabg bianabs ) BFGZCFGZHZBCIUAAJZCKZUSBLMZCNZUSBCNZLMZOZT
      ZAFPZDJZFGZEJZFGZHZUSVJKZUSVHLMZVJNZUSVHVJNZLMZOZTZAFPZHUPVKHZVMVAVJNZUSB
      VJNZLMZOZTZAFPZHURVGHDEBCFFIVHBOZVLWAVTWGWHVIUPVKVHBFQUBWHVSWFAFWHVRWEVMW
      HVOWBVQWDWHVNVAVJVHBUSLUCUDWHVPWCUSLVHBVJUERSUFUGUHVJCOZWAURWGVGWIVKUQUPV
      JCFQULWIWFVFAFWIVMUTWEVEVJCUSUIWIWBVBWDVDVJCVAUJWIWCVCUSLVJCBUJRSUMUGUHDE
      AUKUNUO $.

    $( Consequence of the modular pair property.  (Contributed by NM,
       22-Jun-2004.)  (New usage is discouraged.) $)
    mdi $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A MH B /\
              C C_ B ) ) -> ( ( C vH A ) i^i B ) = ( C vH ( A i^i B ) ) ) $=
      ( vx cch wcel w3a cmd wbr wss chj co cin wceq wi wa cv wral mdbr oveq1
      biimpd sseq1 ineq1d eqeq12d imbi12d rspcv sylan9 3impa imp32 ) AEFZBEFZCE
      FZGABHIZCBJZCAKLZBMZCABMZKLZNZUJUKULUMUNUSOZOUJUKPZUMDQZBJZVBAKLZBMZVBUQK
      LZNZOZDERZULUTVAUMVIDABSUAVHUTDCEVBCNZVCUNVGUSVBCBUBVJVEUPVFURVJVDUOBVBCA
      KTUCVBCUQKTUDUEUFUGUHUI $.

    $( Binary relation expressing the modular pair property.  This version has
       a weaker constraint than ~ mdbr .  (Contributed by NM, 15-Jun-2004.)
       (New usage is discouraged.) $)
    mdbr2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <->
   A. x e. CH ( x C_ B -> ( ( x vH A ) i^i B ) C_ ( x vH ( A i^i B ) ) ) ) ) $=
      ( cch wcel wa cmd wbr cv wss chj co cin wceq wi wral mdbr ancoms chincl
      wb chub1 iba syl6bb syl5ibcom chub2 ssrin syl jctird adantlr simpr adantr
      ssin chjcl sylan an32s chlub syl3anc sylibd eqss rbaib syl6 pm5.74d bitrd
      ralbidva ) BDEZCDEZFZBCGHAIZCJZVHBKLZCMZVHBCMZKLZNZOZADPVIVKVMJZOZADPABCQ
      VGVOVQADVGVHDEZFZVIVNVPVSVIVMVKJZVNVPTVSVIVHVKJZVLVKJZFZVTVEVRVIWCOVFVEVR
      FZVIWAWBWDVHVJJZVIWAVRVEWEVHBUARVIWEWEVIFWAVIWEUBVHVJCULUCUDWDBVJJWBBVHUE
      BVJCUFUGUHUIVSVRVLDEZVKDEZWCVTTVGVRUJVGWFVRBCSUKVEVRVFWGWDVJDEZVFWGVRVEWH
      VHBUMRVJCSUNUOVHVLVKUPUQURVNVPVTVKVMUSUTVAVBVDVC $.

    $( Binary relation expressing the modular pair property.  This version
       quantifies an equality instead of an inference.  (Contributed by NM,
       6-Jul-2004.)  (New usage is discouraged.) $)
    mdbr3 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <-> A. x e. CH
         ( ( ( x i^i B ) vH A ) i^i B ) = ( ( x i^i B ) vH ( A i^i B ) ) ) ) $=
      ( vy cch wcel wa cv wss chj co cin wceq wral sseq1 ineq1d eqeq12d imbi12d
      wi oveq1 cmd wbr mdbr wb chincl inss2 rspcv mpii ex com3l ralrimdv biimpi
      syl dfss oveq1d biimprcd ralimi cbvralv sylib impbid1 adantl bitrd ) BEFZ
      CEFZGBCUAUBDHZCIZVEBJKZCLZVEBCLZJKZMZSZDENZAHZCLZBJKZCLZVOVIJKZMZAENZDBCU
      CVDVMVTUDVCVDVMVTVDVMVSAEVNEFZVDVMVSWAVDVMVSSZWAVDGVOEFZWBVNCUEWCVMVOCIZV
      SVNCUFVLWDVSSDVOEVEVOMZVFWDVKVSVEVOCOWEVHVQVJVRWEVGVPCVEVOBJTPVEVOVIJTQRU
      GUHUMUIUJUKVTVNCIZVNBJKZCLZVNVIJKZMZSZAENVMVSWKAEWFWJVSWFWHVQWIVRWFWGVPCW
      FVNVOBJWFVNVOMVNCUNULZUOPWFVNVOVIJWLUOQUPUQWKVLADEVNVEMZWFVFWJVKVNVECOWMW
      HVHWIVJWMWGVGCVNVEBJTPVNVEVIJTQRURUSUTVAVB $.

    $( Binary relation expressing the modular pair property.  This version
       quantifies an ordering instead of an inference.  (Contributed by NM,
       6-Jul-2004.)  (New usage is discouraged.) $)
    mdbr4 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <-> A. x e. CH
        ( ( ( x i^i B ) vH A ) i^i B ) C_ ( ( x i^i B ) vH ( A i^i B ) ) ) ) $=
      ( vy cch wcel wa cv wss chj co cin wral wceq sseq1 ineq1d sseq12d imbi12d
      wi oveq1 cmd wbr mdbr2 wb chincl inss2 rspcv mpii syl com3l ralrimdv dfss
      ex biimpi oveq1d biimprcd ralimi cbvralv sylib impbid1 adantl bitrd ) BEF
      ZCEFZGBCUAUBDHZCIZVEBJKZCLZVEBCLZJKZIZSZDEMZAHZCLZBJKZCLZVOVIJKZIZAEMZDBC
      UCVDVMVTUDVCVDVMVTVDVMVSAEVNEFZVDVMVSWAVDVMVSSZWAVDGVOEFZWBVNCUEWCVMVOCIZ
      VSVNCUFVLWDVSSDVOEVEVONZVFWDVKVSVEVOCOWEVHVQVJVRWEVGVPCVEVOBJTPVEVOVIJTQR
      UGUHUIUMUJUKVTVNCIZVNBJKZCLZVNVIJKZIZSZAEMVMVSWKAEWFWJVSWFWHVQWIVRWFWGVPC
      WFVNVOBJWFVNVONVNCULUNZUOPWFVNVOVIJWLUOQUPUQWKVLADEVNVENZWFVFWJVKVNVECOWM
      WHVHWIVJWMWGVGCVNVEBJTPVNVEVIJTQRURUSUTVAVB $.

    $( Binary relation expressing the dual modular pair property.  (Contributed
       by NM, 27-Apr-2006.)  (New usage is discouraged.) $)
    dmdbr $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
    A. x e. CH ( B C_ x -> ( ( x i^i A ) vH B ) = ( x i^i ( A vH B ) ) ) ) ) $=
      ( vy vz cch wcel wa cdmd cv wss cin chj co wceq wral eleq1 ineq2d eqeq12d
      wi wbr anbi1d ineq2 oveq1d oveq1 imbi2d ralbidv anbi2d sseq1 oveq2 df-dmd
      anbi12d imbi12d brabg bianabs ) BFGZCFGZHZBCIUACAJZKZUSBLZCMNZUSBCMNZLZOZ
      TZAFPZDJZFGZEJZFGZHZVJUSKZUSVHLZVJMNZUSVHVJMNZLZOZTZAFPZHUPVKHZVMVAVJMNZU
      SBVJMNZLZOZTZAFPZHURVGHDEBCFFIVHBOZVLWAVTWGWHVIUPVKVHBFQUBWHVSWFAFWHVRWEV
      MWHVOWBVQWDWHVNVAVJMVHBUSUCUDWHVPWCUSVHBVJMUERSUFUGULVJCOZWAURWGVGWIVKUQU
      PVJCFQUHWIWFVFAFWIVMUTWEVEVJCUSUIWIWBVBWDVDVJCVAMUJWIWCVCUSVJCBMUJRSUMUGU
      LDEAUKUNUO $.

    $( The dual modular pair property expressed in terms of the modular pair
       property, that hold in Hilbert lattices.  Remark 29.6 of [MaedaMaeda]
       p. 130.  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    dmdmd $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
                   ( _|_ ` A ) MH ( _|_ ` B ) ) ) $=
      ( vy vx cch wcel wa cort cfv wss chj co cin wceq wi eqeq12d choccl adantl
      wb eqtrd wral cmd wbr cdmd sseq1 oveq1 ineq1d imbi12d rspccv imim1i com12
      cv chsscon3 biimpd adantll fveq2 chjcl syl2an chdmm3 chdmj4 adantr oveq1d
      sylan anasss chincl chdmj2 sylan2 chdmm4 ineq2d ancoms imim12d syld com23
      syl5ib ex syl5 ralrimdv sseq2 ineq1 chsscon2 biimprd chdmj1 chdmm2 oveq2d
      impbid mdbr dmdbr 3bitr4rd ) AEFZBEFZGZCULZBHIZJZWLAHIZKLZWMMZWLWOWMMZKLZ
      NZOZCEUAZBDULZJZXCAMZBKLZXCABKLZMZNZOZDEUAZWOWMUBUCZABUDUCWKXBXKWKXBXJDEX
      BXCHIZEFZXMWMJZXMWOKLZWMMZXMWRKLZNZOZOZWKXCEFZXJOXAXTCXMEWLXMNZWNXOWTXSWL
      XMWMUEYCWQXQWSXRYCWPXPWMWLXMWOKUFUGWLXMWRKUFPUHUIWKYBYAXJWKYBYAXJOWKYBGZY
      AXTXJYBYAXTOWKYAYBXTYBXNXTXCQZUJUKRYDXDXOXSXIWJYBXDXOOWIWJYBGXDXOBXCUMUNU
      OXSXQHIZXRHIZNZYDXIXQXRHUPYBWKYHXISYBWKGZYFXFYGXHYBWIWJYFXFNYBWIGZWJGZYFX
      PHIZBKLZXFYJXPEFZWJYFYMNYBXNWOEFZYNWIYEAQZXMWOUQURXPBUSVCYKYLXEBKYJYLXENW
      JXCAUTVAVBTVDYIYGXCWRHIZMZXHWKYBWREFZYGYRNWIYOWMEFZYSWJYPBQZWOWMVEURXCWRV
      FVGYIYQXGXCWKYQXGNYBABVHRVITPVJVNVKVLVOVMVPVQWKXKXACEXKWLHIZEFZBUUBJZUUBA
      MZBKLZUUBXGMZNZOZOZWKWLEFZXAOXJUUIDUUBEXCUUBNZXDUUDXIUUHXCUUBBVRUULXFUUFX
      HUUGUULXEUUEBKXCUUBAVSVBXCUUBXGVSPUHUIWKUUKUUJXAWKUUKUUJXAOWKUUKGZUUJUUIX
      AUUKUUJUUIOWKUUJUUKUUIUUKUUCUUIWLQZUJUKRUUMWNUUDUUHWTWJUUKWNUUDOWIWJUUKGU
      UDWNBWLVTWAUOUUHUUFHIZUUGHIZNZUUMWTUUFUUGHUPUUKWKUUQWTSUUKWKGZUUOWQUUPWSU
      UKWIWJUUOWQNUUKWIGZWJGZUUOUUEHIZWMMZWQUUSUUEEFZWJUUOUVBNUUKUUCWIUVCUUNUUB
      AVEVCUUEBWBVCUUTUVAWPWMUUSUVAWPNWJWLAWCVAUGTVDUURUUPWLXGHIZKLZWSWKUUKXGEF
      UUPUVENABUQWLXGWCVGUURUVDWRWLKWKUVDWRNUUKABWBRWDTPVJVNVKVLVOVMVPVQWEWIYOY
      TXLXBSWJYPUUACWOWMWFURDABWGWH $.

    $( The modular pair property expressed in terms of the dual modular pair
       property.  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    mddmd $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <->
                   ( _|_ ` A ) MH* ( _|_ ` B ) ) ) $=
      ( cch wcel wa cort cfv cdmd wbr cmd wb choccl dmdmd syl2an ococ breqan12d
      bitr2d ) ACDZBCDZEAFGZBFGZHIZTFGZUAFGZJIZABJIRTCDUACDUBUEKSALBLTUAMNRSUCA
      UDBJAOBOPQ $.

    $( Consequence of the dual modular pair property.  (Contributed by NM,
       27-Apr-2006.)  (New usage is discouraged.) $)
    dmdi $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A MH* B /\
              B C_ C ) ) -> ( ( C i^i A ) vH B ) = ( C i^i ( A vH B ) ) ) $=
      ( vx cch wcel w3a cdmd wbr wss cin chj co wceq wi wa cv wral dmdbr ineq1
      biimpd sseq2 oveq1d eqeq12d imbi12d rspcv sylan9 3impa imp32 ) AEFZBEFZCE
      FZGABHIZBCJZCAKZBLMZCABLMZKZNZUJUKULUMUNUSOZOUJUKPZUMBDQZJZVBAKZBLMZVBUQK
      ZNZOZDERZULUTVAUMVIDABSUAVHUTDCEVBCNZVCUNVGUSVBCBUBVJVEUPVFURVJVDUOBLVBCA
      TUCVBCUQTUDUEUFUGUHUI $.

    $( Binary relation expressing the dual modular pair property.  This version
       has a weaker constraint than ~ dmdbr .  (Contributed by NM,
       30-Jun-2004.)  (New usage is discouraged.) $)
    dmdbr2 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
   A. x e. CH ( B C_ x -> ( x i^i ( A vH B ) ) C_ ( ( x i^i A ) vH B ) ) ) ) $=
      ( cch wcel wa cdmd wbr cv wss cin chj co wceq wi wral dmdbr w3a syl3anc
      wb chincl ancoms simplr simpr inss1 chlub biimpd mpani simpll inss2 mpan2
      adantlr chlej1 jctird ssin syl6ib eqss baib syl6 pm5.74d ralbidva bitrd )
      BDEZCDEZFZBCGHCAIZJZVFBKZCLMZVFBCLMZKZNZOZADPVGVKVIJZOZADPABCQVEVMVOADVEV
      FDEZFZVGVLVNVQVGVIVKJZVLVNTVQVGVIVFJZVIVJJZFVRVQVGVSVTVQVHDEZVDVPVGVSOVCV
      PWAVDVPVCWAVFBUAUBULZVCVDVPUCZVEVPUDWAVDVPRZVHVFJZVGVSVFBUEWDWEVGFVSVHCVF
      UFUGUHSVQWAVCVDVTWBVCVDVPUIWCWAVCVDRVHBJVTVFBUJVHBCUMUKSUNVIVFVJUOUPVLVRV
      NVIVKUQURUSUTVAVB $.

    $( Consequence of the dual modular pair property.  (Contributed by NM,
       14-Jan-2005.)  (New usage is discouraged.) $)
    dmdi2 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\ ( A MH* B /\ B C_ C
         ) ) -> ( C i^i ( A vH B ) ) C_ ( ( C i^i A ) vH B ) ) $=
      ( cch wcel w3a cdmd wbr wss wa cin chj co wceq dmdi eqimss2 syl ) ADEBDEC
      DEFABGHBCIJJCAKBLMZCABLMKZNSRIABCOSRPQ $.

    $( Binary relation expressing the dual modular pair property.  This version
       quantifies an equality instead of an inference.  (Contributed by NM,
       6-Jul-2004.)  (New usage is discouraged.) $)
    dmdbr3 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <-> A. x e. CH
           ( ( ( x vH B ) i^i A ) vH B ) = ( ( x vH B ) i^i ( A vH B ) ) ) ) $=
      ( vy cch wcel wa cv wss cin chj co wceq wral sseq2 oveq1d eqeq12d imbi12d
      wi ineq1 cdmd wbr dmdbr wb chub2 ancoms chjcl rspcv syl ex com3l ralrimdv
      chlejb2 biimpa ineq1d biimpd com23 ralimdva cbvralv syl6ib impbid adantl
      mpid bitrd ) BEFZCEFZGBCUAUBCDHZIZVGBJZCKLZVGBCKLZJZMZSZDENZAHZCKLZBJZCKL
      ZVQVKJZMZAENZDBCUCVFVOWBUDVEVFVOWBVFVOWAAEVPEFZVFVOWAWCVFVOWASWCVFGZVOCVQ
      IZWAVFWCWECVPUEUFWDVQEFVOWEWASZSVPCUGVNWFDVQEVGVQMZVHWEVMWAVGVQCOWGVJVSVL
      VTWGVIVRCKVGVQBTPVGVQVKTQRUHUIVCUJUKULVFWBCVPIZVPBJZCKLZVPVKJZMZSZAENVOVF
      WAWMAEVFWCGZWHWAWLWNWHWAWLSWNWHGZWAWLWOVSWJVTWKWOVRWICKWOVQVPBWNWHVQVPMCV
      PUMUNZUOPWOVQVPVKWPUOQUPUJUQURWMVNADEVPVGMZWHVHWLVMVPVGCOWQWJVJWKVLWQWIVI
      CKVPVGBTPVPVGVKTQRUSUTVAVBVD $.

    $( Binary relation expressing the dual modular pair property.  This version
       quantifies an ordering instead of an inference.  (Contributed by NM,
       6-Jul-2004.)  (New usage is discouraged.) $)
    dmdbr4 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <-> A. x e. CH
          ( ( x vH B ) i^i ( A vH B ) ) C_ ( ( ( x vH B ) i^i A ) vH B ) ) ) $=
      ( vy cch wcel wa cv wss chj co cin wral wceq sseq2 oveq1d sseq12d imbi12d
      wi ineq1 cdmd wbr dmdbr2 wb chub2 ancoms chjcl rspcv syl mpid ex ralrimdv
      com3l chlejb2 biimpa ineq1d biimpd ralimdva cbvralv syl6ib impbid adantl
      com23 bitrd ) BEFZCEFZGBCUAUBCDHZIZVGBCJKZLZVGBLZCJKZIZSZDEMZAHZCJKZVILZV
      QBLZCJKZIZAEMZDBCUCVFVOWBUDVEVFVOWBVFVOWAAEVPEFZVFVOWAWCVFVOWASWCVFGZVOCV
      QIZWAVFWCWECVPUEUFWDVQEFVOWEWASZSVPCUGVNWFDVQEVGVQNZVHWEVMWAVGVQCOWGVJVRV
      LVTVGVQVITWGVKVSCJVGVQBTPQRUHUIUJUKUMULVFWBCVPIZVPVILZVPBLZCJKZIZSZAEMVOV
      FWAWMAEVFWCGZWHWAWLWNWHWAWLSWNWHGZWAWLWOVRWIVTWKWOVQVPVIWNWHVQVPNCVPUNUOZ
      UPWOVSWJCJWOVQVPBWPUPPQUQUKVCURWMVNADEVPVGNZWHVHWLVMVPVGCOWQWIVJWKVLVPVGV
      ITWQWJVKCJVPVGBTPQRUSUTVAVBVD $.

    $( Consequence of the dual modular pair property.  (Contributed by NM,
       14-Jan-2005.)  (New usage is discouraged.) $)
    dmdi4 $p |- ( ( A e. CH /\ B e. CH /\ C e. CH ) ->
              ( A MH* B ->
         ( ( C vH B ) i^i ( A vH B ) ) C_ ( ( ( C vH B ) i^i A ) vH B ) ) ) $=
      ( vx cch wcel cdmd wbr chj co cin wi wa cv wral dmdbr4 biimpd wceq ineq1d
      wss oveq1 oveq1d sseq12d rspcv sylan9 3impa ) AEFZBEFZCEFZABGHZCBIJZABIJZ
      KZUKAKZBIJZTZLUGUHMZUJDNZBIJZULKZUSAKZBIJZTZDEOZUIUPUQUJVDDABPQVCUPDCEURC
      RZUTUMVBUOVEUSUKULURCBIUAZSVEVAUNBIVEUSUKAVFSUBUCUDUEUF $.

    $( Binary relation expressing the dual modular pair property.  (Contributed
       by NM, 15-Jan-2005.)  (New usage is discouraged.) $)
    dmdbr5 $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <->
    A. x e. CH ( x C_ ( A vH B ) -> x C_ ( ( ( x vH B ) i^i A ) vH B ) ) ) ) $=
      ( vy cch wcel wa cv chj co wss wi wral dmdbr4 ancoms ex com23 wceq adantr
      cin cdmd wbr chub1 ssin sstr2 sylbi sylan ralimdva adantl sylbid sseq1 id
      oveq1 ineq1d oveq1d sseq12d imbi12d rspccv chjcl chincl inss2 pm2.27 mpii
      adantll syl2anc syl chub2 ssind wb simplr mpbid inass incom chabs2 syl5eq
      chlejb2 ineq2d eqtrd sseq2d sylibd syl5 ralrimdv sylibrd impbid ) BEFZCEF
      ZGZBCUAUBZAHZBCIJZKZWIWICIJZBTZCIJZKZLZAEMZWGWHWLWJTZWNKZAEMZWQABCNWFWTWQ
      LWEWFWSWPAEWFWIEFZGZWKWSWOXBWKWSWOLZXBWIWLKZWKXCXAWFXDWICUCOXDWKGWIWRKXCW
      IWLWJUDWIWRWNUEUFUGPQUHUIUJWGWQDHZCIJZWJTZXFBTZCIJZKZDEMWHWGWQXJDEWQXGEFZ
      XGWJKZXGXGCIJZBTZCIJZKZLZLZWGXEEFZXJLWPXQAXGEWIXGRZWKXLWOXPWIXGWJUKXTWIXG
      WNXOXTULXTWMXNCIXTWLXMBWIXGCIUMUNUOUPUQURWGXSXRXJWGXSXRXJLWGXSGZXRXPXJYAX
      KXRXPLYAXFEFZWJEFZXKWFXSYBWEXSWFYBXECUSOVDWGYCXSBCUSSXFWJUTVEZXKXRXLXPXFW
      JVAXKXQVBVCVFYAXOXIXGYAXNXHCIYAXNXGBTZXHYAXMXGBYACXGKZXMXGRZYACXFWJWFXSCX
      FKWECXEVGVDWGCWJKZXSWFWEYHCBVGOSVHYAWFXKYFYGVIWEWFXSVJYDCXGVPVEVKUNWGYEXH
      RXSWGYEXFWJBTZTXHXFWJBVLWGYIBXFWGYIBWJTBWJBVMBCVNVOVQVOSVRUOVSVTPQWAWBDBC
      NWCWD $.

    $( Relationship between modular pairs and dual-modular pairs.  Lemma 1.2 of
       [MaedaMaeda] p. 1.  (Contributed by NM, 21-Jun-2004.)
       (New usage is discouraged.) $)
    mddmd2 $p |- ( A e. CH -> ( A. x e. CH A MH x <->
                A. x e. CH A MH* x ) ) $=
      ( vy cch wcel cv cmd wbr wral cin chj co wceq wi wa incom chjcom syl5reqr
      syl6bb ralbidva wss cdmd breq2 cbvralv ineq1d adantlr oveq1i chincl sylan
      mdbr eqeq12d eqcom imbi2d bitrd syl5bb ralcom dmdbr bitr4d ) BDEZBAFZGHZA
      DIZUTCFZUAZVCBJZUTKLZVCBUTKLZJZMZNZCDIZADIZBUTUBHZADIUSVBVJADIZCDIZVLVBBV
      CGHZCDIUSVOVAVPACDUTVCBGUCUDUSVPVNCDUSVCDEZOZVPVDUTBKLZVCJZUTBVCJZKLZMZNZ
      ADIVNABVCUJVRWDVJADVRUTDEZOZWCVIVDWFWCVHVFMVIWFVTVHWBVFUSWEVTVHMVQUSWEOZV
      HVGVCJVTVGVCPWGVGVSVCBUTQUERUFWFVFWAUTKLZWBWAVEUTKBVCPUGVRWADEWEWHWBMBVCU
      HWAUTQUIRUKVHVFULSUMTUNTUOVJCADDUPSUSVMVKADCBUTUQTUR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.
    $( A sublattice condition that transfers the modular pair property.
       Exercise 12 of [Kalmbach] p. 103.  Also Lemma 1.5.3 of [MaedaMaeda]
       p. 2.  (Contributed by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
    mdsl0 $p |- ( ( ( A e. CH /\ B e. CH ) /\ ( C e. CH /\ D e. CH ) ) -> (
  ( ( ( C C_ A /\ D C_ B ) /\ ( A i^i B ) = 0H ) /\ A MH B ) -> C MH D ) ) $=
      ( vx cch wcel wa wss cin c0h wceq cmd wbr chj co wi wral sstr2 ad2antlr
      cv com12 w3a chlej2 ss2in ex syl 3expia ad2ant2r imp43 adantrr oveq2 chj0
      ancoms sylan9eqr adantl chincl chub1 eqsstrd adantll anassrs adantrl syl6
      sylan com23 sylc an32s imim12d ralimdva wb mdbr2 ad2antrr 3imtr4d expimpd
      ) AFGZBFGZHZCFGZDFGZHZHZCAIZDBIZHZABJZKLZHZABMNZCDMNZWAWGHZEUAZBIZWKAOPZB
      JZWKWEOPZIZQZEFRZWKDIZWKCOPZDJZWKCDJZOPZIZQZEFRZWHWIWJWQXEEFWJWKFGZHWSWLW
      PXDWGWSWLQZWAXGWCXHWBWFWSWCWLWKDBSUBTTWAXGWGWPXDQZWAXGHZWGHXAWNIZWOXCIZXI
      XJWDXKWFWAXGWBWCXKVOVRXGWBWCXKQZQZQZVPVSVRVOXOVRVOXGXNVRVOXGUCZWBXMXPWBHW
      TWMIZXMCAWKUDXQWCXKWTWMDBUEUFUGUFUHUNUIUJUKXJWFXLWDWAXGWFXLVTXGWFHZXLVQVT
      XRHWOWKXCXRWOWKLVTWFXGWOWKKOPWKWEKWKOULWKUMUOUPVTXGWKXCIZWFVTXBFGZXGXSCDU
      QXGXTXSWKXBURUNVDUKUSUTVAVBXKWPXLXDXKWPXAWOIXLXDQXAWNWOSXAWOXCSVCVEVFVGVH
      VIVQWHWRVJVTWGEABVKVLVTWIXFVJVQWGECDVKTVMVN $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Ordering implies the modular pair property.  Remark in [MaedaMaeda]
       p. 1.  (Contributed by NM, 21-Jun-2004.)  (New usage is discouraged.) $)
    ssmd1 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) -> A MH B ) $=
      ( vx cch wcel wss cmd wbr wa cv chj co cin wi wral inss1 wceq dfss biimpi
      oveq2d syl5sseq a1d ralrimivw mdbr2 syl5ibr 3impia ) ADEZBDEZABFZABGHZUIU
      JUGUHICJZBFZUKAKLZBMZUKABMZKLZFZNZCDOUIURCDUIUQULUIUMUNUPUMBPUIAUOUKKUIAU
      OQABRSTUAUBUCCABUDUEUF $.

    $( Ordering implies the modular pair property.  Remark in [MaedaMaeda]
       p. 1.  (Contributed by NM, 21-Jun-2004.)  (New usage is discouraged.) $)
    ssmd2 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) -> B MH A ) $=
      ( vx cch wcel wss cmd wbr wa cv chj co wi wral inss2 chub2 syl5ss adantrl
      cin wceq simpl sseqin2 sylib adantl oveq2d sseqtr4d exp32 ralrimdv adantr
      a1d wb mdbr2 ancoms sylibrd 3impia ) ADEZBDEZABFZBAGHZUPUQIURCJZAFZUTBKLZ
      ASZUTBASZKLZFZMZCDNZUSUPURVHMUQUPURVGCDUPURUTDEZVGUPURVIIZIZVFVAVKVCUTAKL
      ZVEUPVIVCVLFURUPVIIVCAVLVBAOAUTPQRVKVDAUTKVJVDATZUPVJURVMURVIUAABUBUCUDUE
      UFUJUGUHUIUQUPUSVHUKCBAULUMUNUO $.
  $}

  $( Ordering implies the dual modular pair property.  Remark in [MaedaMaeda]
     p. 1.  (Contributed by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
  ssdmd1 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) ->
                  A MH* B ) $=
    ( cch wcel wss cdmd wbr wa cort cfv wi choccl ssmd2 3expia syl2anr chsscon3
    cmd dmdmd 3imtr4d 3impia ) ACDZBCDZABEZABFGZUAUBHBIJZAIJZEZUFUEQGZUCUDUBUEC
    DZUFCDZUGUHKUABLALUIUJUGUHUEUFMNOABPABRST $.

  $( Ordering implies the dual modular pair property.  Remark in [MaedaMaeda]
     p. 1.  (Contributed by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
  ssdmd2 $p |- ( ( A e. CH /\ B e. CH /\ A C_ B ) ->
               ( _|_ ` B ) MH ( _|_ ` A ) ) $=
    ( cch wcel wss cort cfv cmd wbr wa chsscon3 wi choccl 3expia syl2anr sylbid
    ssmd1 3impia ) ACDZBCDZABEZBFGZAFGZHIZSTJUAUBUCEZUDABKTUBCDZUCCDZUEUDLSBMAM
    UFUGUEUDUBUCQNOPR $.

  $( Sublattice mapping for a dual-modular pair.  Part of Theorem 1.3 of
     [MaedaMaeda] p. 2.  (Contributed by NM, 26-Apr-2006.)
     (New usage is discouraged.) $)
  dmdsl3 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
               ( B MH* A /\ A C_ C /\ C C_ ( A vH B ) ) ) ->
                   ( ( C i^i B ) vH A ) = C ) $=
    ( cch wcel w3a cdmd wbr wss chj co wa cin wceq wi dmdi exp32 imp32 3adantr3
    3com12 chjcom ineq2d 3adant3 df-ss biimpi sylan9req 3ad2antr3 eqtrd ) ADEZB
    DEZCDEZFZBAGHZACIZCABJKZIZFLCBMAJKZCBAJKZMZCULUMUNUQUSNZUPULUMUNUTUJUIUKUMU
    NUTOOUJUIUKFUMUNUTBACPQTRSULUMUPUSCNUNULUPUSCUOMZCUIUJVAUSNUKUIUJLUOURCABUA
    UBUCUPVACNCUOUDUEUFUGUH $.

  $( Sublattice mapping for a modular pair.  Part of Theorem 1.3 of
     [MaedaMaeda] p. 2.  (Contributed by NM, 26-Apr-2006.)
     (New usage is discouraged.) $)
  mdsl3 $p |- ( ( ( A e. CH /\ B e. CH /\ C e. CH ) /\
               ( A MH B /\ ( A i^i B ) C_ C /\ C C_ B ) ) ->
                   ( ( C vH A ) i^i B ) = C ) $=
    ( cch wcel w3a cmd wbr cin wss wa chj co wceq mdi 3adantr2 wb chlejb2 sylan
    chincl 3impa biimpa 3ad2antr2 eqtrd ) ADEZBDEZCDEZFZABGHZABIZCJZCBJZFKCALMB
    IZCUJLMZCUHUIULUMUNNUKABCOPUHUIUKUNCNZULUHUKUOUEUFUGUKUOQZUEUFKUJDEUGUPABTU
    JCRSUAUBUCUD $.

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    mdslle1.1 $e |- A e. CH $.
    mdslle1.2 $e |- B e. CH $.
    mdslle1.3 $e |- C e. CH $.
    mdslle1.4 $e |- D e. CH $.
    $( Order preservation of the one-to-one onto mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2.  (Contributed by NM,
       27-Apr-2006.)  (New usage is discouraged.) $)
    mdslle1i $p |- ( ( B MH* A /\ A C_ ( C i^i D ) /\ ( C vH D )
            C_ ( A vH B ) ) -> ( C C_ D <-> ( C i^i B ) C_ ( D i^i B ) ) ) $=
      ( cin wss chj co w3a chincli wceq wa bicomi simplbi cch wcel cdmd chlej1i
      wbr ssrin id ssin chjcli chlubi 3pm3.2i dmdsl3 mpan syl3an simprbi syl5ib
      sseq12d impbid2 ) BAUAUCZACDIJZCDKLABKLZJZMZCDJZCBIZDBIZJZCDBUDVEVCAKLZVD
      AKLZJVAVBVCVDACBGFNDBHFNEUBVAVFCVGDUQUQURACJZUTCUSJZVFCOZUQUEZURVHADJZVHV
      LPURACDUFQZRUTVIDUSJZVIVNPUTCDUSGHABEFUGUHQZRASTZBSTZCSTZMUQVHVIMVJVPVQVR
      EFGUIABCUJUKULUQUQURVLUTVNVGDOZVKURVHVLVMUMUTVIVNVOUMVPVQDSTZMUQVLVNMVSVP
      VQVTEFHUIABDUJUKULUOUNUP $.

    $( Order preservation of the one-to-one onto mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2.  (Contributed by NM,
       27-Apr-2006.)  (New usage is discouraged.) $)
    mdslle2i $p |- ( ( A MH B /\ ( A i^i B ) C_ ( C i^i D ) /\ ( C vH D )
            C_ B ) -> ( C C_ D <-> ( C vH A ) C_ ( D vH A ) ) ) $=
      ( cin wss chj co w3a wceq wa bicomi simplbi cch wcel 3pm3.2i cmd ssrin id
      wbr chlej1i ssin chlubi mdsl3 mpan syl3an simprbi sseq12d syl5ib impbid2
      ) ABUAUDZABIZCDIJZCDKLBJZMZCDJZCAKLZDAKLZJZCDAGHEUEVCVABIZVBBIZJUSUTVAVBB
      UBUSVDCVEDUOUOUQUPCJZURCBJZVDCNZUOUCZUQVFUPDJZVFVJOUQUPCDUFPZQURVGDBJZVGV
      LOURCDBGHFUGPZQARSZBRSZCRSZMUOVFVGMVHVNVOVPEFGTABCUHUIUJUOUOUQVJURVLVEDNZ
      VIUQVFVJVKUKURVGVLVMUKVNVODRSZMUOVJVLMVQVNVOVREFHTABDUHUIUJULUMUN $.

    $( Join preservation of the one-to-one onto mapping between the two
       sublattices in Lemma 1.3 of [MaedaMaeda] p. 2.  (Contributed by NM,
       27-Apr-2006.)  (New usage is discouraged.) $)
    mdslj1i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( A C_ ( C i^i D ) /\ ( C vH D ) C_ ( A vH B ) ) ) ->
                ( ( C vH D ) i^i B ) = ( ( C i^i B ) vH ( D i^i B ) ) ) $=
      ( wa cin wss chj co bicomi chjcli chlubi w3a wceq cch wcel cmd cdmd simpr
      ssin anbi12i simpl 3pm3.2i dmdsl3 mpan syl3an chincli chub1i chlej1i mp1i
      wbr eqsstr3d chub2i jca sylib ssrin syl syl6ss inss2 mpbir2an a1i sseqtrd
      adantr mdsl3 3expb sylan2b lediri eqssd ) ABUAUOZBAUBUOZIZACDJKZCDLMZABLM
      ZKZIZIZVQBJZCBJZDBJZLMZVTVOACKZADKZIZCVRKZDVRKZIZIWBWEKZVPWHVSWKWHVPACDUD
      NWKVSCDVRGHABEFOPNUEVOWHWKWLVOWHWKQZWBWEALMZBJZWEWMVQWNKZWBWOKWMCWNKZDWNK
      ZIWPWMWQWRWMCWCALMZWNVOVNWHWFWKWIWSCRZVMVNUCZWFWGUFWIWJUFASTZBSTZCSTZQVNW
      FWIQWTXBXCXDEFGUGABCUHUIUJWCWEKWSWNKWMWCWDCBGFUKZDBHFUKZULZWCWEAXEWCWDXEX
      FOZEUMUNUPWMDWDALMZWNVOVNWHWGWKWJXIDRZXAWFWGUCWIWJUCXBXCDSTZQVNWGWJQXJXBX
      CXKEFHUGABDUHUIUJWDWEKXIWNKWMWDWCXFXEUQWDWEAXFXHEUMUNUPURCDWNGHWEAXHEOPUS
      VQWNBUTVAVOVMWHABJZWEKZWKWEBKZWOWERZVMVNUFWFXMWGWFXLWCWEACBUTXGVBVGXNWKXN
      WCBKZWDBKZCBVCDBVCXPXQIXNWCWDBXEXFFPNVDVEXBXCWESTZQVMXMXNQXOXBXCXREFXHUGA
      BWEVHUIUJVFVIVJWEWBKWACDBGHFVKVEVL $.

    $( Meet preservation of the reverse mapping between the two sublattices in
       Lemma 1.3 of [MaedaMaeda] p. 2.  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    mdslj2i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( ( A i^i B ) C_ ( C i^i D ) /\ ( C vH D ) C_ B ) ) ->
                ( ( C i^i D ) vH A ) = ( ( C vH A ) i^i ( D vH A ) ) ) $=
      ( wa cin wss chj co w3a wceq simpr cch wcel chincli 3pm3.2i cmd cdmd ssin
      wbr lejdiri bicomi chlubi anbi12i chub2i chlej1i chjcomi syl6sseq ssinss1
      a1i ssini syl adantr chjcli dmdsl3 mpan syl3an inss1 ssrin ax-mp syl5sseq
      simpl mdsl3 inss2 ssind eqsstr3d 3expb sylan2b eqssd ) ABUAUDZBAUBUDZIZAB
      JZCDJZKZCDLMBKZIZIZVRALMZCALMZDALMZJZWCWFKWBCDAGHEUEUNWAVPVQCKZVQDKZIZCBK
      ZDBKZIZIWFWCKZVSWIVTWLWIVSVQCDUCUFWLVTCDBGHFUGUFUHVPWIWLWMVPWIWLNZWFWFBJZ
      ALMZWCVPVOWIAWFKZWLWFABLMZKZWPWFOZVNVOPWQWIAWDWEACEGUIADEHUIUOUNWJWSWKWJW
      DWRKWSWJWDBALMWRCBAGFEUJBAFEUKULWDWEWRUMUPUQAQRZBQRZWFQRZNVOWQWSNWTXAXBXC
      EFWDWECAGEURDAHEURSZTABWFUSUTVAWNWOVRKWPWCKWNWOCDWNWDBJZWOCWFWDKWOXEKWDWE
      VBWFWDBVCVDVPVNWIWGWLWJXECOZVNVOVFZWGWHVFWJWKVFXAXBCQRZNVNWGWJNXFXAXBXHEF
      GTABCVGUTVAVEWNWEBJZWODWFWEKWOXIKWDWEVHWFWEBVCVDVPVNWIWHWLWKXIDOZXGWGWHPW
      JWKPXAXBDQRZNVNWHWKNXJXAXBXKEFHTABDVGUTVAVEVIWOVRAWFBXDFSCDGHSEUJUPVJVKVL
      VM $.
  $}

  ${
    $d x y A $.  $d x y B $.
    mdsl.1 $e |- A e. CH $.
    mdsl.2 $e |- B e. CH $.
    $( If the modular pair property holds in a sublattice, it holds in the
       whole lattice.  Lemma 1.4 of [MaedaMaeda] p. 2.  (Contributed by NM,
       27-Apr-2006.)  (New usage is discouraged.) $)
    mdsl1i $p |- ( A. x e. CH ( ( ( A i^i B ) C_ x /\ x C_ ( A vH B ) ) ->
   ( x C_ B -> ( ( x vH A ) i^i B ) = ( x vH ( A i^i B ) ) ) ) <-> A MH B ) $=
      ( vy cin cv wss chj co wa wceq wi cch wral wcel sseq1 wb mp3an23 cmd sstr
      wbr sseq2 anbi12d oveq1 ineq1d eqeq12d imbi12d rspccv impexp bitr2i inss2
      chlub biimpd mpan2i chub2i mpan2 syl6 chub2 mpan jctild chjcl jcad chjass
      chincli chjcomi chabs1i oveq2i syl6eq chjidmi imim12d syl5bi syl5com mdbr
      eqtri ralrimiv mp2an sylibr ax-1 ralimi sylbi impbii ) BCGZAHZIZWEBCJKZIZ
      LZWECIZWEBJKZCGZWEWDJKZMZNZNZAOPZBCUAUCZWQFHZCIZWSBJKZCGZWSWDJKZMZNZFOPZW
      RWQXEFOWQXCOQZWDXCIZXCWGIZLZXCCIZXCBJKZCGZXCWDJKZMZNZNZNZWSOQZXEWPXQAXCOW
      EXCMZWIXJWOXPXTWFXHWHXIWEXCWDUDWEXCWGRUEXTWJXKWNXOWEXCCRXTWLXMWMXNXTWKXLC
      WEXCBJUFUGWEXCWDJUFUHUIUIUJXRXGXJLZXKLZXONZXSXEYCYAXPNXRYAXKXOUKXGXJXPUKU
      LXSWTYBXOXDXSWTYAXKXSWTXJXGXSWTXIXHXSWTXKXIXSWTWDCIZXKBCUMXSWTYDLZXKXSWDO
      QZCOQZYEXKSBCDEVFZEWSWDCUNTUOUPZXKCWGIXICBEDUQXCCWGUBURUSYFXSXHYHWDWSUTVA
      VBXSYFXGYHWSWDVCURVBYIVDXSXOXDXSXMXBXNXCXSXLXACXSXLWSWDBJKZJKZXAXSYFBOQZX
      LYKMYHDWSWDBVETYJBWSJYJBWDJKBWDBYHDVGBCDEVHVPVIVJUGXSXNWSWDWDJKZJKZXCXSYF
      YFXNYNMYHYHWSWDWDVETYMWDWSJWDYHVKVIVJUHUOVLVMVNVQYLYGWRXFSDEFBCVOVRVSWRWO
      AOPZWQYLYGWRYOSDEABCVOVRWOWPAOWOWIVTWAWBWC $.

    $( If the modular pair property holds in a sublattice, it holds in the
       whole lattice.  Lemma 1.4 of [MaedaMaeda] p. 2.  (Contributed by NM,
       28-Apr-2006.)  (New usage is discouraged.) $)
    mdsl2i $p |- ( A MH B <-> A. x e. CH ( ( ( A i^i B ) C_ x /\ x C_ B ) ->
                ( ( x vH A ) i^i B ) C_ ( x vH ( A i^i B ) ) ) ) $=
      ( cin cv wss wa chj co wi cch wral wceq wcel mpan2 wb syl6bb syl cmd sstr
      wbr chub2i pm4.71ri anbi2i anass bitr4i imbi1i chub1 ssin syl5ibcom chub2
      iba mpan ssrin jctird chjcl chincl chincli chlub mp3an2 mpdan sylibd eqss
      rbaib syl6 adantld pm5.74d syl5rbbr impexp ralbiia mdsl1i bitr2i ) BCFZAG
      ZHZVPCHZIZVPBJKZCFZVPVOJKZHZLZAMNVQVPBCJKZHZIZVRWAWBOZLLZAMNBCUAUCWDWIAMV
      PMPZWDWGVRIZWHLZWIWLVSWHLWJWDVSWKWHVSVQWFVRIZIWKVRWMVQVRWFVRCWEHWFCBEDUDV
      PCWEUBQUEUFVQWFVRUGUHUIWJVSWHWCWJVRWHWCRZVQWJVRWBWAHZWNWJVRVPWAHZVOWAHZIZ
      WOWJVRWPWQWJVPVTHZVRWPWJBMPZWSDVPBUJQVRWSWSVRIWPVRWSUNVPVTCUKSULWJBVTHZWQ
      WTWJXADBVPUMUOBVTCUPTUQWJWAMPZWRWORZWJVTMPZXBWJWTXDDVPBURQXDCMPXBEVTCUSQT
      WJVOMPXBXCBCDEUTVPVOWAVAVBVCVDWHWCWOWAWBVEVFVGVHVIVJWGVRWHVKSVLABCDEVMVN
      $.

    $( If the modular pair property holds in a sublattice, it holds in the
       whole lattice.  Lemma 1.4 of [MaedaMaeda] p. 2.  (Contributed by NM,
       24-Dec-2006.)  (New usage is discouraged.) $)
    mdsl2bi $p |- ( A MH B <-> A. x e. CH ( ( ( A i^i B ) C_ x /\ x C_ B ) ->
                ( ( x vH A ) i^i B ) = ( x vH ( A i^i B ) ) ) ) $=
      ( cmd wbr cin cv wss wa chj co wi cch wral wceq wcel wb adantr mdsl2i w3a
      chincli inss1 chlej2 mpan2 mp3an12 simpr inss2 jctir chlub mpbid biantrud
      mp3an23 ssind eqss syl6bbr ex adantld pm5.74d ralbiia bitri ) BCFGBCHZAIZ
      JZVDCJZKZVDBLMZCHZVDVCLMZJZNZAOPVGVIVJQZNZAOPABCDEUAVLVNAOVDORZVGVKVMVOVF
      VKVMSZVEVOVFVPVOVFKZVKVKVJVIJZKVMVQVRVKVQVJVHCVOVJVHJZVFVCORZBORZVOVSBCDE
      UCZDVTWAVOUBVCBJVSBCUDVCBVDUEUFUGTVQVFVCCJZKZVJCJZVQVFWCVOVFUHBCUIUJVOWDW
      ESZVFVOVTCORWFWBEVDVCCUKUNTULUOUMVIVJUPUQURUSUTVAVB $.

    $( The covering property implies the modular pair property.  Lemma 7.5.1 of
       [MaedaMaeda] p. 31.  (Contributed by NM, 16-Jun-2004.)
       (New usage is discouraged.) $)
    cvmdi $p |- ( ( A i^i B ) <oH B -> A MH B ) $=
      ( vx cin wbr wss chj co wa wceq wi cch chabs1i eqtri oveq1 ineq1d 3eqtr4a
      wcel ccv cv wral cmd anass chub2i mpan2 pm4.71ri anbi2i bitr4i wo chincli
      sstr cvnbtwn4 mp3an12 impcom chjcomi ineq1i chjidmi eqtr4i chabs2i oveq2i
      incom 3eqtr2i jaoi syl6 syl5bi exp4b ralrimiv mdsl1i sylib ) ABFZBUAGZVLE
      UBZHZVNABIJZHZKZVNBHZVNAIJZBFZVNVLIJZLZMMZENUCABUDGVMWDENVMVNNTZVRVSWCVRV
      SKZVOVSKZVMWEKZWCWFVOVQVSKZKWGVOVQVSUEVSWIVOVSVQVSBVPHVQBADCUFVNBVPUMUGUH
      UIUJWHWGVNVLLZVNBLZUKZWCWEVMWGWLMZVLNTBNTWEVMWMMABCDULZDVLBVNUNUOUPWJWCWK
      WJVLAIJZBFZVLVLIJZWAWBWPVLWQWOABWOAVLIJAVLAWNCUQABCDOPURVLWNUSUTWJVTWOBVN
      VLAIQRVNVLVLIQSWKBAIJZBFZBVLIJZWAWBWSBWRFZWTWRBVCXABBBAFZIJWTBADCVABADCOX
      BVLBIBAVCVBVDPWKVTWRBVNBAIQRVNBVLIQSVEVFVGVHVIEABCDVJVK $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    mdslmd.1 $e |- A e. CH $.
    mdslmd.2 $e |- B e. CH $.
    mdslmd.3 $e |- C e. CH $.
    mdslmd.4 $e |- D e. CH $.
    ${
      mdslmd1lem.5 $e |- R e. CH $.
      $( TODO.  This proof was done quickly and is inefficient.
         Need to use adantr, etc. earlier for unused antecendent pieces. $)
      $( Lemma for ~ mdslmd1i .  (Contributed by NM, 29-Apr-2006.)
         (New usage is discouraged.) $)
      mdslmd1lem1 $p |- ( ( ( A MH B /\ B MH* A ) /\ ( ( A C_ C /\ A C_
         D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) -> ( ( (
         R vH A ) C_ D -> ( ( ( R vH A ) vH C ) i^i D ) C_ ( ( R vH A ) vH ( C
         i^i D ) ) ) -> ( ( ( ( C i^i B ) i^i ( D i^i B ) ) C_ R /\ R C_ ( D
         i^i B ) ) -> ( ( R vH ( C i^i B ) ) i^i ( D i^i B ) ) C_ ( R vH ( ( C
         i^i B ) i^i ( D i^i B ) ) ) ) ) ) $=
        ( wa wss chj co cin wceq cch wcel ssin sylib cmd wbr wi chincli chlej1i
        cdmd simpr w3a 3pm3.2i dmdsl3 syl3an 3expb sseq2d syl5ib adantld imim1d
        mpan simpll ad2antlr chub2i jctil inss1 sstr mpan2 sylan ancoms adantll
        ad2ant2l chub1i jctir chjcli chlubi simprrl adantr jca mdslj1i syl12anc
        simplll simplrl ssrin syl inindir syl6sseq sstrd inss2 ad2antll syl3anc
        simprl mdsl3 oveq1d eqtr2d syl6eqr ssinss1 ad2antrl a1i oveq12d sseq12d
        ineq1d wb simpllr simplr sstri mdslle1i bitr4d exbiri a2d syld ) ABUAUB
        ZBAUFUBZKZACLZADLZKZCABMNZLZDXNLZKZKZKZEAMNZDLZXTCMNZDOZXTCDOZMNZLZUCCB
        OZDBOZOZELZEYHLZKZYFUCYLEYGMNZYHOZEYIMNZLZUCXSYLYAYFXSYKYAYJYKXTYHAMNZL
        XSYAEYHAJDBIGUDFUEXSYQDXTXJXMXQYQDPZXJXIXMXLXQXPYRXHXIUGXKXLUGXOXPUGAQR
        ZBQRZDQRZUHXIXLXPUHYRYSYTUUAFGIUIABDUJUQUKULUMUNUOUPXSYLYFYPXSYLYPYFXSY
        LKZYPYCBOZYEBOZLZYFUUBYNUUCYOUUDUUBYNYBBOZYHOUUCUUBYMUUFYHUUBUUFXTBOZYG
        MNZYMUUBXJAXTCOLZYBXNLZUUFUUHPXJXRYLURZUUBAXTLZXKKUUIUUBXKUULXRXKXJYLXK
        XLXQURUSAEFJUTZVAAXTCSTUUBXTXNLZXOKUUJUUBUUNXOUUBEXNLZAXNLZKUUNUUBUUOUU
        PXRYKUUOXJYJXQYKUUOXMXPYKUUOXOYKXPUUOYKEDLZXPUUOYKYHDLUUQDBVBEYHDVCVDED
        XNVCVEVFVGVGVHABFGVIVJEAXNJFABFGVKZVLTZXSXOYLXJXMXOXPVMVNVOXTCXNEAJFVKZ
        HUURVLTABXTCFGUUTHVPVQUUBUUGEYGMUUBXHABOZELZEBLZUUGEPZXHXIXRYLVRUUBUVAY
        IEUUBUVAYDBOZYIUUBAYDLZUVAUVELUUBXMUVFXJXMXQYLVSACDSTZAYDBVTWACDBWBZWCX
        SYJYKWHWDYKUVCXSYJYKYHBLUVCDBWEEYHBVCVDWFYSYTEQRZUHXHUVBUVCUHUVDYSYTUVI
        FGJUIABEWIUQWGZWJWKWRYBDBWBWLUUBUUDUUGUVEMNZYOUUBXJAXTYDOLZYEXNLZUUDUVK
        PUUKUUBUULUVFKUVLUUBUVFUULUVGUUMVAAXTYDSTUUBUUNYDXNLZKUVMUUBUUNUVNUUSXR
        UVNXJYLXOUVNXMXPCDXNWMWNUSVOXTYDXNUUTCDHIUDZUURVLTZABXTYDFGUUTUVOVPVQUU
        BUUGEUVEYIMUVJUVEYIPUUBUVHWOWPWKWQUUBXIAYCYEOLZYCYEMNXNLZYFUUEWSXHXIXRY
        LWTUUBAYCLZAYELZKUVQUUBUVSUVTUUBAYBLZXLKUVSUUBXLUWAXRXLXJYLXKXLXQXAUSAX
        TYBUUMXTCUUTHVIXBVAAYBDSTAXTYEUUMXTYDUUTUVOVIXBVJAYCYESTUUBYCXNLZUVMKUV
        RUUBUWBUVMXRUWBXJYLXPUWBXMXOYCDLXPUWBYBDWEYCDXNVCUQWFUSUVPVOYCYEXNYBDXT
        CUUTHVKIUDZXTYDUUTUVOVKZUURVLTABYCYEFGUWCUWDXCWGXDXEXFXG $.

      $( TODO.  This proof was done quickly and is inefficient.
         Need to use adantr, etc. earlier for unused antecendent pieces. $)
      $( Lemma for ~ mdslmd1i .  (Contributed by NM, 29-Apr-2006.)
         (New usage is discouraged.) $)
      mdslmd1lem2 $p |- ( ( ( A MH B /\ B MH* A ) /\ ( ( A C_
         C /\ A C_ D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) ->
         ( ( ( R i^i B ) C_ ( D i^i B ) -> ( ( ( R i^i B ) vH ( C i^i B ) ) i^i
         ( D i^i B ) ) C_ ( ( R i^i B ) vH ( ( C i^i B ) i^i ( D i^i B ) ) ) )
         -> ( ( ( C i^i D ) C_ R /\ R C_ D ) -> ( ( R vH C ) i^i D ) C_ ( R vH
         ( C i^i D ) ) ) ) ) $=
        ( cin wss chj co wa sstr ad2antlr ssind jca sylib wi cmd wbr cdmd ssrin
        adantl imim1i wb simpllr chub2i mpan2 ad2antrr simplr ssin sylbi adantr
        chincli ad2antll ancoms ad2ant2l adantll ssinss1 ad2antrl chjcli chlubi
        inss2 mpan mdslle1i syl3anc inindir wceq sylanb simplll simplrl mdslj1i
        ad2ant2r sylan2 anassrs ineq1d syl5req biimpi anim12i a1i oveq2d eqtr2d
        an4s sseq12d bitr4d exbiri a2d syl5 ) EBKZDBKZLZWLCBKZMNZWMKZWLWOWMKZMN
        ZLZUACDKZELZEDLZOZWTUAABUBUCZBAUDUCZOZACLZADLZOZCABMNZLZDXKLZOZOZOZXDEC
        MNZDKZEXAMNZLZUAXDWNWTXCWNXBEDBUEUFUGXPXDWTXTXPXDXTWTXPXDOZXTXRBKZXSBKZ
        LZWTYAXFAXRXSKLXRXSMNXKLZXTYDUHXEXFXOXDUIYAAXRXSYAAXQDXOAXQLZXGXDXHYFXI
        XNXHCXQLYFCEHJUJACXQPUKULQXOXIXGXDXHXIXNUMQRXOAXSLZXGXDXJYGXNXJAXALZYGA
        CDUNZYHXAXSLYGXAECDHIUQZJUJAXAXSPUKUOUPQRYAXRXKLZXSXKLZOYEYAYKYLXOYKXGX
        DXMYKXJXLXRDLXMYKXQDVFXRDXKPVGURQYAEXKLZXAXKLZOZYLYAYMYNXOXDYMXGXNXDYMX
        JXMXCYMXLXBXCXMYMEDXKPUSZUTVAZVAXOYNXGXDXLYNXJXMCDXKVBZVCQSEXAXKJYJABFG
        VDZVEZTSXRXSXKXQDECJHVDIUQZEXAJYJVDZYSVETABXRXSFGUUAUUBVHVIYAWQYBWSYCYA
        YBXQBKZWMKWQXQDBVJYAUUCWPWMXGXOXDUUCWPVKZXOXDOZXGAECKLZXQXKLZOUUDUUEUUF
        UUGUUEAECXJXBAELZXNXCXJYHXBUUHYIAXAEPVLZVPXHXIXNXDVMRUUEYMXLOUUGUUEYMXL
        YQXJXLXMXDVNSECXKJHYSVETSABECFGJHVOVQVRVSVTYAYCWLXABKZMNZWSXGXOXDYCUUKV
        KZUUEXGAEXAKLZYLOZUULXJXBXNXCUUNXJXBOZUUMXNXCOZYLUUOAEXAUUIXJYHXBXJYHYI
        WAUPRUUPYOYLUUPYMYNXMXCYMXLYPVAXLYNXMXCYRULSYTTWBWFABEXAFGJYJVOVQVRYAUU
        JWRWLMUUJWRVKYACDBVJWCWDWEWGWHWIWJWK $.
    $}

    $( Lemma for ~ mdslmd1i .  (Contributed by NM, 29-Apr-2006.)
       (New usage is discouraged.) $)
    mdslmd1lem3 $p |- ( ( x e. CH /\ ( ( A MH B /\ B MH* A ) /\ ( ( A C_ C /\ A
        C_ D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) ) -> ( ( (
        x vH A ) C_ D -> ( ( ( x vH A ) vH C ) i^i D ) C_ ( ( x vH A ) vH ( C
        i^i D ) ) ) -> ( ( ( ( C i^i B ) i^i ( D i^i B ) ) C_ x /\ x C_ ( D i^i
        B ) ) -> ( ( x vH ( C i^i B ) ) i^i ( D i^i B ) ) C_ ( x vH ( ( C i^i B
        ) i^i ( D i^i B ) ) ) ) ) ) $=
      ( cch wbr wa wss chj co cin wi c0h oveq1 imbi12d wcel cmd cdmd cif sseq1d
      wceq oveq1d ineq1d sseq12d sseq2 anbi12d imbi2d h0elch elimel mdslmd1lem1
      cv sseq1 dedth imp ) AUPZJUAZBCUBKCBUCKLBDMBEMLDBCNOZMEVBMLLLZUTBNOZEMZVD
      DNOZEPZVDDEPZNOZMZQZDCPZECPZPZUTMZUTVMMZLZUTVLNOZVMPZUTVNNOZMZQZQZVAVCWCQ
      VCVAUTRUDZBNOZEMZWEDNOZEPZWEVHNOZMZQZVNWDMZWDVMMZLZWDVLNOZVMPZWDVNNOZMZQZ
      QZQUTRUTWDUFZWCWTVCXAVKWKWBWSXAVEWFVJWJXAVDWEEUTWDBNSZUEXAVGWHVIWIXAVFWGE
      XAVDWEDNXBUGUHXAVDWEVHNXBUGUITXAVQWNWAWRXAVOWLVPWMUTWDVNUJUTWDVMUQUKXAVSW
      PVTWQXAVRWOVMUTWDVLNSUHUTWDVNNSUITTULBCDEWDFGHIUTRJUMUNUOURUS $.

    $( Lemma for ~ mdslmd1i .  (Contributed by NM, 29-Apr-2006.)
       (New usage is discouraged.) $)
    mdslmd1lem4 $p |- ( ( x e. CH /\ ( ( A MH B /\ B MH* A ) /\ ( ( A C_
       C /\ A C_ D ) /\ ( C C_ ( A vH B ) /\ D C_ ( A vH B ) ) ) ) ) -> ( ( ( x
       i^i B ) C_ ( D i^i B ) -> ( ( ( x i^i B ) vH ( C i^i B ) ) i^i ( D i^i B
       ) ) C_ ( ( x i^i B ) vH ( ( C i^i B ) i^i ( D i^i B ) ) ) ) -> ( ( ( C
       i^i D ) C_ x /\ x C_ D ) -> ( ( x vH C ) i^i D ) C_ ( x vH ( C i^i D ) )
       ) ) ) $=
      ( cch wbr wa wss chj co cin wi c0h oveq1d imbi12d wcel cmd cdmd cif ineq1
      wceq sseq1d ineq1d sseq12d sseq2 sseq1 anbi12d oveq1 imbi2d h0elch elimel
      cv mdslmd1lem2 dedth imp ) AUQZJUAZBCUBKCBUCKLBDMBEMLDBCNOZMEVCMLLLZVACPZ
      ECPZMZVEDCPZNOZVFPZVEVHVFPZNOZMZQZDEPZVAMZVAEMZLZVADNOZEPZVAVONOZMZQZQZVB
      VDWDQVDVBVARUDZCPZVFMZWFVHNOZVFPZWFVKNOZMZQZVOWEMZWEEMZLZWEDNOZEPZWEVONOZ
      MZQZQZQVARVAWEUFZWDXAVDXBVNWLWCWTXBVGWGVMWKXBVEWFVFVAWECUEZUGXBVJWIVLWJXB
      VIWHVFXBVEWFVHNXCSUHXBVEWFVKNXCSUITXBVRWOWBWSXBVPWMVQWNVAWEVOUJVAWEEUKULX
      BVTWQWAWRXBVSWPEVAWEDNUMUHVAWEVONUMUITTUNBCDEWEFGHIVARJUOUPURUSUT $.

    $( Preservation of the modular pair property in the one-to-one onto mapping
       between the two sublattices in Lemma 1.3 of [MaedaMaeda] p. 2 (meet
       version).  (Contributed by NM, 27-Apr-2006.)
       (New usage is discouraged.) $)
    mdslmd1i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( A C_ ( C i^i D ) /\ ( C vH D ) C_ ( A vH B ) ) ) ->
                ( C MH D <-> ( C i^i B ) MH ( D i^i B ) ) ) $=
      ( vy vx cin wss chj co wa wbr wi cch wral wcel cdmd wb ssin chjcli chlubi
      cmd anbi12i chjcl mpan2 wceq sseq1 oveq1 ineq1d sseq12d imbi12d rspcv syl
      cv adantr mdslmd1lem3 syld ex com3l ralrimdv mdbr2 chincli mdsl2i 3imtr4g
      mp2an chincl mdslmd1lem4 impbid sylan2br ) ACDKZLZCDMNABMNZLZOABUFPBAUAPO
      ZACLADLOZCVPLDVPLOZOZCDUFPZCBKZDBKZUFPZUBVSVOVTVQACDUCCDVPGHABEFUDUEUGVRW
      AOZWBWEWFIURZDLZWGCMNZDKZWGVNMNZLZQZIRSZWCWDKZJURZLWPWDLOWPWCMNWDKWPWOMNL
      QZJRSWBWEWFWNWQJRWPRTZWFWNWQWRWFWNWQQWRWFOZWNWPAMNZDLZWTCMNZDKZWTVNMNZLZQ
      ZWQWRWNXFQZWFWRWTRTZXGWRARTXHEWPAUHUIWMXFIWTRWGWTUJZWHXAWLXEWGWTDUKXIWJXC
      WKXDXIWIXBDWGWTCMULUMWGWTVNMULUNUOUPUQUSJABCDEFGHUTVAVBVCVDCRTDRTWBWNUBGH
      ICDVEVIJWCWDCBGFVFZDBHFVFZVGVHWFWGWDLZWGWCMNZWDKZWGWOMNZLZQZIRSZVNWPLWPDL
      OWPCMNDKWPVNMNLQZJRSWEWBWFXRXSJRWRWFXRXSWRWFXRXSQWSXRWPBKZWDLZXTWCMNZWDKZ
      XTWOMNZLZQZXSWRXRYFQZWFWRXTRTZYGWRBRTYHFWPBVJUIXQYFIXTRWGXTUJZXLYAXPYEWGX
      TWDUKYIXNYCXOYDYIXMYBWDWGXTWCMULUMWGXTWOMULUNUOUPUQUSJABCDEFGHVKVAVBVCVDW
      CRTWDRTWEXRUBXJXKIWCWDVEVIJCDGHVGVHVLVM $.

    $( Preservation of the modular pair property in the one-to-one onto mapping
       between the two sublattices in Lemma 1.3 of [MaedaMaeda] p. 2 (join
       version).  (Contributed by NM, 29-Apr-2006.)
       (New usage is discouraged.) $)
    mdslmd2i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( ( A i^i B ) C_ ( C i^i D ) /\ ( C vH D ) C_ B ) ) ->
                ( C MH D <-> ( C vH A ) MH ( D vH A ) ) ) $=
      ( cmd wbr wa cin wss chj co w3a sstr mpan cch wcel cdmd wb chjcli chlej1i
      chjjdiri chjcomi 3sstr3g adantl chub2i ssini jctil mdslmd1i wceq id inss1
      sylan2 mpan2 chub1i 3pm3.2i mdsl3 syl3an inss2 breq12d adantlr bitr2d
      3expb ) ABIJZBAUAJZKZABLZCDLZMZCDNOZBMZKZKCANOZDANOZIJZVPBLZVQBLZIJZCDIJZ
      VOVIAVPVQLMZVPVQNOZABNOZMZKVRWAUBVOWFWCVNWFVLVNVMANOBANOWDWEVMBACDGHUCFEU
      DCDAGHEUEBAFEUFUGUHAVPVQACEGUIADEHUIUJUKABVPVQEFCAGEUCDAHEUCULUPVGVOWAWBU
      BZVHVGVLVNWGVGVLVNPVSCVTDIVGVGVLVJCMZVNCBMZVSCUMZVGUNZVLVKCMWHCDUOVJVKCQU
      QCVMMVNWICDGHURCVMBQRASTZBSTZCSTZPVGWHWIPWJWLWMWNEFGUSABCUTRVAVGVGVLVJDMZ
      VNDBMZVTDUMZWKVLVKDMWOCDVBVJVKDQUQDVMMVNWPDCHGUIDVMBQRWLWMDSTZPVGWOWPPWQW
      LWMWREFHUSABDUTRVAVCVFVDVE $.

    $( Preservation of the dual modular pair property in the one-to-one onto
       mapping between the two sublattices in Lemma 1.3 of [MaedaMaeda] p. 2.
       (Contributed by NM, 29-Apr-2006.)  (New usage is discouraged.) $)
    mdsldmd1i $p |- ( ( ( A MH B /\ B MH* A ) /\
                ( A C_ ( C i^i D ) /\ ( C vH D ) C_ ( A vH B ) ) ) ->
                ( C MH* D <-> ( C i^i B ) MH* ( D i^i B ) ) ) $=
      ( cmd wbr wa cin wss chj co cort cfv wb cch wcel cdmd mddmd mp2an chincli
      dmdmd anbi12ci chsscon3i chdmm1i sseq1i bitri chdmj1i incom eqtri sseq12i
      chjcli choccli mdslmd2i syl2anb breq12i 3bitr4g ) ABIJZBAUAJZKZACDLZMZCDN
      OZABNOZMZKZKCPQZDPQZIJZVJBPQZNOZVKVMNOZIJZCDUAJZCBLZDBLZUAJZVCVMAPQZIJZWA
      VMUAJZKVMWALZVJVKLZMZVJVKNOZWAMZKVLVPRVIVAWCVBWBASTZBSTZVAWCREFABUBUCWJWI
      VBWBRFEBAUEUCUFVEWHVHWFVEVDPQZWAMWHAVDECDGHUDUGWKWGWACDGHUHUIUJVHVGPQZVFP
      QZMWFVFVGCDGHUOABEFUOUGWLWDWMWEWLWAVMLWDABEFUKWAVMULUMCDGHUKUNUJUFVMWAVJV
      KBFUPAEUPCGUPDHUPUQURCSTDSTVQVLRGHCDUEUCVTVRPQZVSPQZIJZVPVRSTVSSTVTWPRCBG
      FUDDBHFUDVRVSUEUCWNVNWOVOICBGFUHDBHFUHUSUJUT $.

    $( Modular pair conditions that imply the modular pair property in a
       sublattice.  Lemma 1.5.1 of [MaedaMaeda] p. 2.  (Contributed by NM,
       23-Dec-2006.)  (New usage is discouraged.) $)
    mdslmd3i $p |- ( ( ( A MH B /\ ( A i^i B ) MH C ) /\ ( ( A i^i C ) C_ D /\
                  D C_ A ) ) -> D MH ( B i^i C ) ) $=
      ( vx cmd wbr cin wa wss chj co cch wcel ssrin wceq cv wi wral w3a mp3an12
      chlej2 ex impcom syl adantll adantr ssin inass mdi mp3anl1 mpanl1 syl5eqr
      ineq1d adantrlr adantrrr chincli oveq2i syl6eq adantrll adantrrl sylan2br
      eqtrd ancoms an32s adantllr in12 inidm ineq2i eqtri syl5eqss anim12i eqss
      eqtr2i sylibr oveq2d ad3antlr sseqtrd ralrimiva wb mdbr2 mp2an ) ABJKZABL
      ZCJKZMZACLZDNZDANZMZMZIUAZBCLZNZWPDOPZWQLZWPDWQLZOPZNZUBZIQUCZDWQJKZWOXDI
      QWOWPQRZMZWRXCXHWRMZWTWPAOPZWQLZXBXHWTXKNZWRWNXGXLWJWMXGXLWLWMXGMWSXJNZXL
      XGWMXMDQRZAQRZXGWMXMUBHEXNXOXGUDWMXMDAWPUFUGUEUHWSXJWQSUIUJUJUKXIXKWPAWQL
      ZOPZXBWJXGWRXKXQTZWNWRWJXGMWPBNZWPCNZMZXRWPBCULWJYAXGXRXGWJYAMZXRXGYBMXKW
      PWHOPZCLZXQXGWJXSXKYDTZXTXGWGXSYEWIXGWGXSMZMZXKXJBLZCLYDXJBCUMYGYHYCCBQRZ
      XGYFYHYCTZFXOYIXGYFYJEABWPUNUOUPURUQUSUTXGWJXTYDXQTZXSXGWIXTYKWGXGWIXTMZM
      YDWPWHCLZOPZXQCQRZXGYLYDYNTZGWHQRYOXGYLYPABEFVAWHCWPUNUOUPYMXPWPOABCUMVBV
      CVDVEVGVHVIVFVJWNXQXBTWJXGWRWNXPXAWPOWNXPXANZXAXPNZMXPXATWLYQWMYRWLXPWKWQ
      LZXAYSACWQLZLXPACWQUMYTWQAYTBCCLZLWQCBCVKUUACBCVLVMVNVMVRWKDWQSVODAWQSVPX
      PXAVQVSVTWAVGWBUGWCXNWQQRXFXEWDHBCFGVAIDWQWEWFVS $.

    $( Modular pair condition that implies the modular pair property in a
       sublattice.  Lemma 1.5.2 of [MaedaMaeda] p. 2.  (Contributed by NM,
       24-Dec-2006.)  (New usage is discouraged.) $)
    mdslmd4i $p |- ( ( A MH B /\ ( ( A i^i B ) C_ C /\ C C_ A ) /\
                  ( ( A i^i B ) C_ D /\ D C_ B ) ) -> C MH D ) $=
      ( cmd wbr cin wss wa w3a simp1 cch wcel chincli ssmd1 3ad2ant3 sslin sstr
      mp3an12 adantr sylan ancoms 3adant1 simp2r mdslmd3i syl22anc wceq sseqin2
      ad2ant2rl biimpi adantl breqtrd ) ABIJZABKZCLZCALZMZURDLZDBLZMZNZCBDKZDIV
      EUQURDIJZADKZCLZUTCVFIJUQVAVDOVDUQVGVAVBVGVCURPQDPQVBVGABEFRHURDSUCUDTVAV
      DVIUQUSVCVIUTVBVCUSVIVCVHURLUSVIDBAUAVHURCUBUEUFUMUGUQUSUTVDUHABDCEFHGUIU
      JVDUQVFDUKZVAVCVJVBVCVJDBULUNUOTUP $.
  $}

  ${
    $d x A $.  $d c x B $.
    csmdsym.1 $e |- A e. CH $.
    csmdsym.2 $e |- B e. CH $.
    $( Cross-symmetry implies M-symmetry.  Theorem 1.9.1 of [MaedaMaeda] p. 3.
       (Contributed by NM, 24-Dec-2006.)  (New usage is discouraged.) $)
    csmdsymi $p |- ( ( A. c e. CH ( c MH B -> B MH* c ) /\ A MH B ) ->
                   B MH A ) $=
      ( vx cmd wbr cdmd wi cch wa cin wss chj co wceq wcel ad2antlr w3a cv wral
      incom sseq1i biimpri chjcom mpan2 ineq1d syl6eq id 3jca inss2 ssid pm3.2i
      a1i c0h cif sseq2 sseq1 anbi12d 3anbi2d breq1 imbi12d h0elch elimel dedth
      mdslmd4i com12 mp3an3 imp an32s adantlll breq2 rspccva adantlr adantr mpd
      simprr dmdi syl12anc chincli mpan oveq2i 3eqtr2d sylani ralrimiva mdsl2bi
      ex sylibr ) CUAZBGHZBWJIHZJZCKUBZABGHZLZBAMZFUAZNZWRANZLWRBOPZAMZWRWQOPZQ
      ZJZFKUBBAGHWPXEFKWSWPWRKRZLZABMZWRNZWTXDXIWSXHWQWRABUCZUDUEXGXIWTLZXDXGXK
      LZXBABWROPZMZXHWROPZXCXFXBXNQWPXKXFXBXMAMXNXFXAXMAXFBKRZXAXMQEWRBUFUGUHXM
      AUCUISXLXPXFAKRZTZBWRIHZWTXOXNQXFXRWPXKXFXPXFXQXPXFEUOXFUJXQXFDUOUKSXLWRB
      GHZXSWOXFXKXTWNWOXKXFXTWOXKLXFXTWOXKXHBNZBBNZLZXFXTJYAYBABULBUMUNXFWOXKYC
      TZXTXFYDXTJWOXHXFWRUPUQZNZYEANZLZYCTZYEBGHZJWRUPWRYEQZYDYIXTYJYKXKYHWOYCY
      KXIYFWTYGWRYEXHURWRYEAUSUTVAWRYEBGVBVCABYEBDEWRUPKVDVEEVGVFVHVIVJVKVLXGXT
      XSJZXKWNXFYLWOWMYLCWRKWJWRQWKXTWLXSWJWRBGVBWJWRBIVMVCVNVOVPVQXGXIWTVRBWRA
      VSVTXFXOXCQWPXKXFXOWRXHOPZXCXHKRXFXOYMQABDEWAXHWRUFWBXHWQWROXJWCUISWDWHWE
      WFFBAEDWGWI $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    mdexch.1 $e |- A e. CH $.
    mdexch.2 $e |- B e. CH $.
    mdexch.3 $e |- C e. CH $.
    $( An exchange lemma for modular pairs.  Lemma 1.6 of [MaedaMaeda] p. 2.
       (Contributed by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
    mdexchi $p |- ( ( A MH B /\ C MH ( A vH B ) /\ ( C i^i ( A vH B ) ) C_ A )
      -> ( ( C vH A ) MH B /\ ( ( C vH A ) i^i B ) = ( A i^i B ) ) ) $=
      ( vx cmd chj co cin wss w3a wceq wi cch wcel wa mp3an12 chjcom wbr chjass
      cv wral chjcli mpan2 chjcl mpan sylancl 3eqtr4d ineq1d inass incom ineq2i
      chjcomi chabs2i eqtri syl6eqr ad2antrr chlej2 mp3an23 mdi exp32 syl com23
      ex syld imp31 adantrr chincli chjidmi oveq1i 3eqtr3a eqtrd adantr sseqtrd
      imp ad2ant2rl eqsstrd ssrin adantrl chub2i ax-mp mpi sstrd exp31 ralrimiv
      com3r 3impb wb mdbr2 mp2an sylibr 3eqtr3ri ineq12i chub1i chlejb1i biimpi
      mp3an syl5eq sylan9eq syl5eqr 3adant1 jca ) ABHUAZCABIJZHUAZCXFKZALZMZCAI
      JZBHUAZXKBKZABKZNZXJGUCZBLZXPXKIJZBKZXPXMIJZLZOZGPUDZXLXJYBGPXEXGXIXPPQZY
      BOYDXQXEXGXIRZRZYAYDXQYFYAYDXQRZYFRXSXPAIJZBKZXTYGYEXSYILXEYGYERZXSAXPIJZ
      CIJZXFKZBKZYIYDXSYNNXQYEYDXSYLBKZYNYDXRYLBYDXKXPIJZCYKIJZXRYLCPQZAPQZYDYP
      YQNFDCAXPUBSYDXKPQZXRYPNCAFDUEZXPXKTUFYDYKPQZYRYLYQNYSYDUUBDAXPUGUHZFYKCT
      UIUJUKYNYLXFBKZKYOYLXFBULUUDBYLUUDBXFKZBXFBUMUUEBBAIJZKZBXFUUFBABDEUOUNZB
      AEDUPZUQUQUNUQURUSYJYMYHLYNYILYJYMYKXHIJZYHYGXGYMUUJNZXIYDXQXGUUKYDXQYKXF
      LZXGUUKOYDBPQZYSXQUULOEDYDUUMYSMXQUULXPBAUTVFVAYDXGUULUUKYDUUBXGUULUUKOOZ
      UUCYRXFPQZUUBUUNFABDEUEZYRUUOUUBMXGUULUUKCXFYKVBVCSVDVEVGVHVIYDXIUUJYHLXQ
      XGYDXIRUUJYKAIJZYHYDXIUUJUUQLZYDUUBXIUUROZUUCXHPQZYSUUBUUSCXFFUUPVJZDUUTY
      SUUBMXIUURXHAYKUTVFSVDVQYDUUQYHNXIYDUUQAYKIJZYHYDUUBYSUUQUVBNUUCDYKATUIYD
      AAIJZXPIJZYKUVBYHUVCAXPIADVKVLYSYSYDUVDUVBNDDAAXPUBSYSYDYKYHNDAXPTUHVMVNV
      OVPVRVSYMYHBVTVDVSWAYGXEYIXTLYEYGXERYIXPXNIJZXTYDXQXEYIUVENZYDXEXQUVFYSUU
      MYDXEXQUVFOODEYSUUMYDMXEXQUVFABXPVBVCSVEVHYDUVEXTLZXQXEYDXNXMLZUVGAXKLUVH
      ACDFWBAXKBVTWCXNPQZXMPQZYDUVHUVGOABDEVJXKBUUAEVJUVIUVJYDMUVHUVGXNXMXPUTVF
      SWDUSVSVIWEWFWHWIWGYTUUMXLYCWJUUAEGXKBWKWLWMXGXIXOXEYEXMACIJZUUDKZXNXKUVK
      BUUDCAFDUOUUEUUGUUDBUUHBXFUMUUIWNWOYEUVLUVKXFKZBKXNUVKXFBULYEUVMABXGXIUVM
      AXHIJZAXGAXFLZUVMUVNNZABDEWPYRUUOYSXGUVOUVPOOFUUPDYRUUOYSMXGUVOUVPCXFAVBV
      CWSWDXIUVNXHAIJZAAXHDUVAUOXIUVQANXHAUVADWQWRWTXAUKXBWTXCXD $.
  $}

  $( The covering property implies the modular pair property.  Lemma 7.5.1 of
     [MaedaMaeda] p. 31.  (Contributed by NM, 21-Jun-2004.)
     (New usage is discouraged.) $)
  cvmd $p |- ( ( A e. CH /\ B e. CH /\ ( A i^i B ) <oH B ) -> A MH B ) $=
    ( cch wcel cin ccv wbr cmd wi chil wceq ineq1 breq1d breq1 imbi12d ineq2 id
    cif helch elimel breq12d breq2 cvmdi dedth2h 3impia ) ACDZBCDZABEZBFGZABHGZ
    UFUGUIUJIUFAJRZBEZBFGZUKBHGZIUKUGBJRZEZUOFGZUKUOHGZIABJJAUKKZUIUMUJUNUSUHUL
    BFAUKBLMAUKBHNOBUOKZUMUQUNURUTULUPBUOFBUOUKPUTQUABUOUKHUBOUKUOAJCSTBJCSTUCU
    DUE $.

  $( The covering property implies the dual modular pair property.  Lemma 7.5.2
     of [MaedaMaeda] p. 31.  (Contributed by NM, 21-Jun-2004.)
     (New usage is discouraged.) $)
  cvdmd $p |- ( ( A e. CH /\ B e. CH /\ B <oH ( A vH B ) ) -> A MH* B ) $=
    ( cch wcel chj co ccv wbr cdmd wa cort cfv cin wi choccl cvmd 3expia syl2an
    cmd wb simpr chjcl cvcon3 syl2anc chdmj1 breq1d bitrd dmdmd 3imtr4d 3impia
    ) ACDZBCDZBABEFZGHZABIHZUKULJZAKLZBKLZMZURGHZUQURSHZUNUOUKUQCDZURCDZUTVANUL
    AOBOVBVCUTVAUQURPQRUPUNUMKLZURGHZUTUPULUMCDUNVETUKULUAABUBBUMUCUDUPVDUSURGA
    BUEUFUGABUHUIUJ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Atoms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Define the set of atoms in a Hilbert lattice.  An atom is a nonzero
       element of a lattice such that anything less than it is zero, i.e. it is
       the smallest nonzero element of the lattice.  Definition of atom in
       [Kalmbach] p. 15.  See ~ ela and ~ elat2 for membership relations.
       (Contributed by NM, 14-Aug-2002.)  (New usage is discouraged.) $)
    df-at $a |- HAtoms = { x e. CH | 0H <oH x } $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Atoms in a Hilbert lattice are the elements that cover the zero
       subspace.  Definition of atom in [Kalmbach] p. 15.  (Contributed by NM,
       9-Jun-2004.)  (New usage is discouraged.) $)
    ela $p |- ( A e. HAtoms <-> ( A e. CH /\ 0H <oH A ) ) $=
      ( vx c0h cv ccv wbr cch cat breq2 df-at elrab2 ) CBDZEFCAEFBAGHLACEIBJK
      $.

    $( Expanded membership relation for the set of atoms, i.e. the predicate
       "is an atom (of the Hilbert lattice)."  An atom is a nonzero element of
       a lattice such that anything less than it is zero, i.e. it is the
       smallest nonzero element of the lattice.  (Contributed by NM,
       9-Jun-2004.)  (New usage is discouraged.) $)
    elat2 $p |- ( A e. HAtoms <-> ( A e. CH /\ ( A =/= 0H /\
                 A. x e. CH ( x C_ A -> ( x = A \/ x = 0H ) ) ) ) ) $=
      ( cat wcel cch c0h ccv wbr wa wne cv wceq wo wi wral wpss wb ch0pss bitri
      wss ela h0elch cvbr2 mpan imbi1d imbi2d impexp bi2.04 neor imbi2i 3bitr4g
      orcom ralbiia a1i anbi12d bitr2d pm5.32i bitr4i ) BCDBEDZFBGHZIUSBFJZAKZB
      TZVBBLZVBFLZMZNZAEOZIZIBUAUSVIUTUSUTFBPZFVBPZVCIVDNZAEOZIZVIFEDUSUTVNQUBA
      FBUCUDUSVJVAVMVHBRVMVHQUSVLVGAEVBEDZVCVKVDNZNZVCVBFJZVDNZNVLVGVOVPVSVCVOV
      KVRVDVBRUEUFVLVKVCVDNNVQVKVCVDUGVKVCVDUHSVFVSVCVFVEVDMVSVDVEULVDVBFUISUJU
      KUMUNUOUPUQUR $.

    $( A Hilbert lattice element is an atom iff it covers the zero subspace.
       (Contributed by NM, 26-Jun-2004.)  (New usage is discouraged.) $)
    elatcv0 $p |- ( A e. CH -> ( A e. HAtoms <-> 0H <oH A ) ) $=
      ( cat wcel cch c0h ccv wbr ela baib ) ABCADCEAFGAHI $.

    $( An atom covers the zero subspace.  (Contributed by NM, 26-Jun-2004.)
       (New usage is discouraged.) $)
    atcv0 $p |- ( A e. HAtoms -> 0H <oH A ) $=
      ( cat wcel cch c0h ccv wbr ela simprbi ) ABCADCEAFGAHI $.

    $( Atoms are a subset of the Hilbert lattice.  (Contributed by NM,
       14-Aug-2002.)  (New usage is discouraged.) $)
    atssch $p |- HAtoms C_ CH $=
      ( vx cat c0h cv ccv wbr cch crab df-at ssrab2 eqsstri ) BCADEFZAGHGAILAGJ
      K $.

    $( An atom is a Hilbert lattice element.  (Contributed by NM,
       22-Jun-2004.)  (New usage is discouraged.) $)
    atelch $p |- ( A e. HAtoms -> A e. CH ) $=
      ( cat cch atssch sseli ) BCADE $.

    $( An atom is not the Hilbert lattice zero.  (Contributed by NM,
       13-Aug-2002.)  (New usage is discouraged.) $)
    atne0 $p |- ( A e. HAtoms -> A =/= 0H ) $=
      ( vx cat wcel cch c0h wne cv wss wceq wo wi wral wa elat2 simprl sylbi )
      ACDAEDZAFGZBHZAITAJTFJKLBEMZNNSBAORSUAPQ $.

    $( A lattice element smaller than an atom is either the atom or zero.
       (Contributed by NM, 25-Jun-2004.)  (New usage is discouraged.) $)
    atss $p |- ( ( A e. CH /\ B e. HAtoms ) ->
               ( A C_ B -> ( A = B \/ A = 0H ) ) ) $=
      ( vx cat wcel cch c0h wne cv wceq wo wi wral wa elat2 sseq1 eqeq1 orbi12d
      wss adantld imbi12d rspcv imp sylan2b ) BDEAFEZBFEZBGHZCIZBSZUHBJZUHGJZKZ
      LZCFMZNZNZABSZABJZAGJZKZLZCBOUEUPVAUEUOVAUFUEUNVAUGUMVACAFUHAJZUIUQULUTUH
      ABPVBUJURUKUSUHABQUHAGQRUAUBTTUCUD $.
  $}

  $( Two atoms in a subset relationship are equal.  (Contributed by NM,
     26-Jun-2004.)  (New usage is discouraged.) $)
  atsseq $p |- ( ( A e. HAtoms /\ B e. HAtoms ) -> ( A C_ B <-> A = B ) ) $=
    ( cat wcel wa wss wceq c0h wne atne0 ad2antrr wo cch wi atelch atss imp ord
    sylan necon1ad mpd ex eqimss impbid1 ) ACDZBCDZEZABFZABGZUGUHUIUGUHEZAHIZUI
    UEUKUFUHAJKUJUIAHUJUIAHGZUGUHUIULLZUEAMDUFUHUMNAOABPSQRTUAUBABUCUD $.

  $( A Hilbert lattice element covered by an atom must be the zero subspace.
     (Contributed by NM, 11-Jun-2004.)  (New usage is discouraged.) $)
  atcveq0 $p |- ( ( A e. CH /\ B e. HAtoms ) -> ( A <oH B <-> A = 0H ) ) $=
    ( cch wcel cat wa ccv wbr c0h wceq wpss wi atelch cvpss sylan2 ch0le adantr
    wss jctild atcv0 h0elch cvnbtwn3 mp3an1 sylan ancoms syld syl5ibrcom adantl
    mpd breq1 impbid ) ACDZBEDZFZABGHZAIJZUNUOIARZABKZFZUPUNUOURUQUMULBCDZUOURL
    BMZABNOULUQUMAPQSUMULUSUPLZUMULFIBGHZVBUMVCULBTZQUMUTULVCVBLZVAICDUTULVEUAI
    BAUBUCUDUIUEUFUMUPUOLULUMUOUPVCVDAIBGUJUGUHUK $.

  ${
    $d x A $.
    $( A 1-dimensional subspace is an atom.  (Contributed by NM, 22-Jul-2001.)
       (New usage is discouraged.) $)
    h1da $p |- ( ( A e. ~H /\ A =/= 0h ) ->
                ( _|_ ` ( _|_ ` { A } ) ) e. HAtoms ) $=
      ( vx chil wcel c0v wne wa csn cort cfv cch c0h cv wss wceq wo wi wral cat
      adantr snssi occl choccl h1dn0 h1datom expcom ralrimiv jca elat2 sylanbrc
      3syl ) ACDZAEFZGZAHZIJZIJZKDZUQLFZBMZUQNUTUQOUTLOPQZBKRZGUQSDULURUMULUOCN
      UPKDURACUAUOUBUPUCUKTUNUSVBAUDULVBUMULVABKUTKDULVAUTAUEUFUGTUHBUQUIUJ $.
  $}

  $( The span of the singleton of a vector is an atom.  (Contributed by NM,
     18-Dec-2004.)  (New usage is discouraged.) $)
  spansna $p |- ( ( A e. ~H /\ A =/= 0h ) -> ( span ` { A } ) e. HAtoms ) $=
    ( chil wcel c0v wne csn cspn cfv cort cat wceq spansn adantr h1da eqeltrd
    wa ) ABCZADEZPAFZGHZSIHIHZJQTUAKRALMANO $.

  $( A 1-dimensional subspace is less than or equal to any subspace containing
     its generating vector.  (Contributed by NM, 24-Nov-2004.)
     (New usage is discouraged.) $)
  sh1dle $p |- ( ( A e. SH /\ B e. A ) -> ( _|_ ` ( _|_ ` { B } ) ) C_ A ) $=
    ( csh wcel wa csn cort cfv cspn chil wceq shel spansn syl spansnss eqsstr3d
    ) ACDBADEZBFZGHGHZRIHZAQBJDTSKBALBMNABOP $.

  $( A 1-dimensional subspace is less than or equal to any member of ` CH `
     containing its generating vector.  (Contributed by NM, 30-May-2004.)
     (New usage is discouraged.) $)
  ch1dle $p |- ( ( A e. CH /\ B e. A ) -> ( _|_ ` ( _|_ ` { B } ) ) C_ A ) $=
    ( cch wcel csh csn cort cfv wss chsh sh1dle sylan ) ACDAEDBADBFGHGHAIAJABKL
    $.

  ${
    $d x y z A $.
    $( The 1-dimensional subspaces of Hilbert space are its atoms.  Part of
       Remark 10.3.5 of [BeltramettiCassinelli] p. 107.  (Contributed by NM,
       4-Jun-2004.)  (New usage is discouraged.) $)
    atom1d $p |- ( A e. HAtoms <->
                E. x e. ~H ( x =/= 0h /\ A = ( span ` { x } ) ) ) $=
      ( vy cat wcel cv wne cort cfv wceq wa chil wrex cch c0h wss wo wi adantrr
      nfv c0v csn cspn wral elat2 chne0 nfre1 nfim chel simprlr h1dn0 anasss wn
      sylan ch1dle snssi occl 3syl choccl sseq1 eqeq1 orbi12d imbi12d mpid impr
      rspcv adantrlr ord syl6ibr mt4d eqcomd rspe syl12anc exp44 rexlimd sylbid
      nne imp32 sylbi h1da eleq1 exp3acom3r imp3a rexlimiv impbii spansn eqeq2d
      syl5ibr anbi2d rexbiia bitr4i ) BDEZAFZUAGZBWMUBZHIZHIZJZKZALMZWNBWOUCIZJ
      ZKZALMWLWTWLBNEZBOGZCFZBPZXFBJZXFOJZQZRZCNUDZKKWTCBUEXDXEXLWTXDXEWNABMXLW
      TRZABUFXDWNXMABXDATXLWTAXLATWSALUGUHXDWMBEZWNXLWTXDXNWNKZXLKKZWMLEZWNWRWT
      XDXOXQXLXDXNXQWNWMBUIZSSXDXNWNXLUJXPWQBXPWQOGZWQBJZXDXOXSXLXDXNWNXSXDXNKZ
      XQWNXSXRWMUKUNULSXPXTUMWQOJZXSUMXPXTYBXDXNXLXTYBQZWNXDXNXLYCYAXLWQBPZYCBW
      MUOYAWPNEZWQNEXLYDYCRZRYAXQWOLPYEXRWMLUPWOUQURWPUSXKYFCWQNXFWQJZXGYDXJYCX
      FWQBUTYGXHXTXIYBXFWQBVAXFWQOVAVBVCVFURVDVEVGVHWQOVQVIVJVKWSALVLVMVNVOVPVR
      VSWSWLALXQWNWRWLWRXQWNWLXQWNKWLWRWQDEWMVTBWQDWAWHWBWCWDWEXCWSALXQXBWRWNXQ
      XAWQBWMWFWGWIWJWK $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Superposition principle
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d x y z B $.  $d v w x y z $.
    $( Superposition Principle.  If ` A ` and ` B ` are distinct atoms, there
       exists a third atom, distinct from ` A ` and ` B ` , that is the
       superposition of ` A ` and ` B ` .  Definition 3.4-3(a) in [MegPav2000]
       p. 2345 (PDF p. 8).  (Contributed by NM, 9-Jun-2006.)
       (New usage is discouraged.) $)
    superpos $p |- ( ( A e. HAtoms /\ B e. HAtoms /\ A =/= B )
        -> E. x e. HAtoms ( x =/= A /\ x =/= B /\ x C_ ( A vH B ) ) ) $=
      ( vy vz vw vv wcel wne co wrex cspn wceq wa chil wi wb adantr csm cc cneg
      cat chj wss w3a c0v csn cfv atom1d reeanv an4 neeq1 neeq2 sylan9bb adantl
      cv cva hvaddcl c1 hvaddeq0 fveq2d neg1cn ax-1cn ax-1ne0 negne0i spansncol
      cc0 mp3an23 sylan9eqr ex sylbid necon3d imp spansna syl2anc adantlr eqeq2
      biimpd spansneleqi syl elspansn caddc addcl mpan2 ad2antlr hvmulcl ancoms
      sneq simpll simplr hvsubadd syl3anc biimpar hvsubval sylancom ax-hvdistr2
      mp3an2 eqtr4d eqtr3d oveq1 eqeq2d rspcev rexlimdv syld sylibrd spansneleq
      cmv exp31 eqcom syl6ib sylan9r adantlrl adantrr adantll ax-hvcom adantlrr
      eqeq1d bitr4d adantrl cpr spanpr oveq12 cph cun df-pr fveq2i snssi spanun
      syl2an syl5eq cch spansnch sylan eqtr2d sseqtr4d sseq1 3anbi123d syl13anc
      spansnj expl syl5bi rexlimivv sylbir syl2anb 3impia ) BUBHZCUBHZBCIZAUPZB
      IZUUICIZUUIBCUCJZUDZUEZAUBKZUUFDUPZUFIZBUUPUGZLUHZMZNZDOKZEUPZUFIZCUVCUGZ
      LUHZMZNZEOKZUUHUUOPZUUGDBUIECUIUVBUVINUVAUVHNZEOKDOKUVJUVAUVHDEOOUJUVKUVJ
      DEOOUVKUUQUVDNZUUTUVGNZNUUPOHZUVCOHZNZUVJUUQUUTUVDUVGUKUVPUVLUVMUVJUVPUVL
      NZUVMNZUUHUUSUVFIZUUOUVMUUHUVSQUVQUUTUUHUUSCIUVGUVSBUUSCULCUVFUUSUMUNUOUV
      RUVSUUOUVRUVSNUUPUVCUQJZUGLUHZUBHZUWABIZUWACIZUWAUULUDZUUOUVQUVSUWBUVMUVP
      UVSUWBUVLUVPUVSNUVTOHZUVTUFIZUWBUVPUWFUVSUUPUVCURZRUVPUVSUWGUVPUVTUFUUSUV
      FUVPUVTUFMUUPUSUAZUVCSJZMZUUSUVFMZUUPUVCUTUVOUWKUWLPUVNUVOUWKUWLUWKUVOUUS
      UWJUGZLUHZUVFUWKUURUWMLUUPUWJWHVAUVOUWITHZUWIVGIUWNUVFMVBUSVCVDVEUVCUWIVF
      VHVIVJUOVKVLVMUVTVNVOVPVPUVRUVSUWCUVQUUTUVSUWCPZUVGUVPUVDUUTUWPUUQUVPUVDN
      ZUUTNUWABUUSUVFUUTUWABMZUWAUUSMZUWQUWLUUTUWRUWSBUUSUWAVQVRUWQUWSUVCUUSHZU
      WLUVPUWSUWTPUVDUVPUWSUVCFUPZUUPSJZMZFTKZUWTUVPUWSUVTUUSHZUXDUVPUWFUWSUXEP
      UWHUVTUUPVSVTUVPUXEUVTGUPZUUPSJZMZGTKZUXDUVNUXEUXIQUVOGUUPUVTWARUVPUXHUXD
      GTUVPUXFTHZUXHUXDUVPUXJNZUXHNZUXFUWIWBJZTHZUVCUXMUUPSJZMZUXDUXJUXNUVPUXHU
      XJUWOUXNVBUXFUWIWCWDZWEUXLUXGUUPXGJZUVCUXOUXKUXRUVCMZUXHUXKUXGOHZUVNUVOUX
      SUXHQUVNUXJUXTUVOUXJUVNUXTUXFUUPWFZWGVPUVNUVOUXJWIZUVNUVOUXJWJZUXGUUPUVCW
      KWLWMUXKUXRUXOMZUXHUVNUXJUYDUVOUXJUVNUYDUXJUVNNUXRUXGUWIUUPSJUQJZUXOUXJUV
      NUXTUXRUYEMUYAUXGUUPWNWOUXJUWOUVNUXOUYEMVBUXFUWIUUPWPWQWRWGVPRWSUXCUXPFUX
      MTUXAUXMMZUXBUXOUVCUXAUXMUUPSWTXAXBVOXHXCVKXDUVNUWTUXDQUVOFUUPUVCWARXERUV
      NUVDUWTUWLPUVOUVNUVDNUWTUVFUUSMUWLUVCUUPXFUVFUUSXIXJVPXDXKVLXLXMVMUVRUVSU
      WDUVQUVGUVSUWDPZUUTUVPUUQUVGUYGUVDUVPUUQNZUVGNUWACUUSUVFUVGUWACMZUWAUVFMZ
      UYHUWLUVGUYIUYJCUVFUWAVQVRUYHUYJUUPUVFHZUWLUVPUYJUYKPUUQUVPUYJUUPUXAUVCSJ
      ZMZFTKZUYKUVPUYJUVTUVFHZUYNUVPUWFUYJUYOPUWHUVTUVCVSVTUVPUYOUVTUXFUVCSJZMZ
      GTKZUYNUVOUYOUYRQUVNGUVCUVTWAUOUVPUYQUYNGTUVPUXJUYQUYNUXKUYQNZUXNUUPUXMUV
      CSJZMZUYNUXJUXNUVPUYQUXQWEUYSUYPUVCXGJZUUPUYTUXKVUBUUPMZUYQUXKVUCUVCUUPUQ
      JZUYPMZUYQUXKUYPOHZUVOUVNVUCVUEQUVOUXJVUFUVNUXJUVOVUFUXFUVCWFZWGXNUYCUYBU
      YPUVCUUPWKWLUXKUVTVUDUYPUVPUVTVUDMUXJUUPUVCXORXQXRWMUXKVUBUYTMZUYQUVOUXJV
      UHUVNUXJUVOVUHUXJUVONVUBUYPUWJUQJZUYTUXJUVOVUFVUBVUIMVUGUYPUVCWNWOUXJUWOU
      VOUYTVUIMVBUXFUWIUVCWPWQWRWGXNRWSUYMVUAFUXMTUYFUYLUYTUUPUXAUXMUVCSWTXAXBV
      OXHXCVKXDUVOUYKUYNQUVNFUVCUUPWAUOXERUVOUUQUYKUWLPUVNUUPUVCXFXNXDXKVLXPXSV
      MUVRUWEUVSUVPUVMUWEUVLUVPUVMNUWAUUPUVCXTZLUHZUULUVPUWAVUKUDUVMUUPUVCYARUV
      MUVPUULUUSUVFUCJZVUKBUUSCUVFUCYBUVPVUKUUSUVFYCJZVULUVPVUKUURUVEYDZLUHZVUM
      VUJVUNLUUPUVCYEYFUVNUUROUDUVEOUDVUOVUMMUVOUUPOYGUVCOYGUURUVEYHYIYJUVNUUSY
      KHUVOVUMVULMUUPYLUUSUVCYSYMYNVIYOVPRUUNUWCUWDUWEUEAUWAUBUUIUWAMUUJUWCUUKU
      WDUUMUWEUUIUWABULUUIUWACULUUIUWAUULYPYQXBYRVJVKYTUUAUUBUUCUUDUUE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Atoms, exchange and covering properties, atomicity
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.
    $( The Hilbert lattice has the covering property.  Proposition 1(ii) of
       [Kalmbach] p. 140 (and its converse).  (Contributed by NM,
       11-Jun-2004.)  (New usage is discouraged.) $)
    chcv1 $p |- ( ( A e. CH /\ B e. HAtoms ) ->
                ( -. B C_ A <-> A <oH ( A vH B ) ) ) $=
      ( vx cch wcel cat wa wss wn chj co ccv wbr cv c0v wne csn cspn chil wi
      wceq wrex atom1d spansncv2 sseq1 notbid breq2d imbi12d syl5ibrcom adantld
      cfv oveq2 rexlimdva sylan2b atelch wpss chjcl cvpss syldan sylibrd sylan2
      imp chnle impbid ) ADEZBFEZGBAHZIZAABJKZLMZVFVECNZOPZBVKQRUKZUAZGZCSUBZVH
      VJTZCBUCVEVPVQVEVOVQCSVEVKSEGZVNVQVLVRVQVNVMAHZIZAAVMJKZLMZTAVKUDVNVHVTVJ
      WBVNVGVSBVMAUEUFVNVIWAALBVMAJULUGUHUIUJUMVBUNVFVEBDEZVJVHTBUOVEWCGVJAVIUP
      ZVHVEWCVIDEVJWDTABUQAVIURUSABVCUTVAVD $.

    $( The Hilbert lattice has the covering property.  (Contributed by NM,
       11-Jun-2004.)  (New usage is discouraged.) $)
    chcv2 $p |- ( ( A e. CH /\ B e. HAtoms ) ->
                ( A C. ( A vH B ) <-> A <oH ( A vH B ) ) ) $=
      ( cch wcel cat wa wss wn chj co wpss ccv wbr wb atelch chnle sylan2 chcv1
      bitr3d ) ACDZBEDZFBAGHZAABIJZKZAUCLMUATBCDUBUDNBOABPQABRS $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The join of a closed subspace and an atom equals their subspace sum.
       Special case of remark in [Kalmbach] p. 65, stating that if ` A ` or
       ` B ` is finite dimensional, then this equality holds.  (Contributed by
       NM, 4-Jun-2004.)  (New usage is discouraged.) $)
    chjatom $p |- ( ( A e. CH /\ B e. HAtoms ) -> ( A +H B ) = ( A vH B ) ) $=
      ( vx cch wcel cat cph co chj wceq cv c0v wne csn cspn cfv wa chil oveq2
      wi wrex atom1d spansnj eqeq12d syl5ibr exp3a adantl com3l rexlimdv syl5bi
      imp ) ADEZBFEZABGHZABIHZJZUMCKZLMZBUQNOPZJZQZCRUAULUPCBUBULVAUPCRVAULUQRE
      ZUPUTULVBUPTTURUTULVBUPULVBQUPUTAUSGHZAUSIHZJAUQUCUTUNVCUOVDBUSAGSBUSAISU
      DUEUFUGUHUIUJUK $.
  $}

  ${
    $d x y A $.
    shatomic.1 $e |- A e. SH $.
    $( The lattice of Hilbert subspaces is atomic, i.e. any nonzero element is
       greater than or equal to some atom.  Part of proof of Theorem 16.9 of
       [MaedaMaeda] p. 70.  (Contributed by NM, 24-Nov-2004.)
       (New usage is discouraged.) $)
    shatomici $p |- ( A =/= 0H -> E. x e. HAtoms x C_ A ) $=
      ( vy c0h wne cv c0v wrex wss cat shne0i wcel csn cort cfv chil sheli h1da
      wa sylan csh sh1dle mpan adantr sseq1 rspcev syl2anc rexlimiva sylbi ) BE
      FDGZHFZDBIAGZBJZAKIZDBCLULUODBUKBMZULTUKNOPOPZKMZUQBJZUOUPUKQMULURUKBCRUK
      SUAUPUSULBUBMUPUSCBUKUCUDUEUNUSAUQKUMUQBUFUGUHUIUJ $.
  $}

  ${
    $d x y A $.
    hatomic.1 $e |- A e. CH $.
    $( The Hilbert lattice is atomic, i.e. any nonzero element is greater than
       or equal to some atom.  Remark in [Kalmbach] p. 140.  (Contributed by
       NM, 22-Jul-2001.)  (New usage is discouraged.) $)
    hatomici $p |- ( A =/= 0H -> E. x e. HAtoms x C_ A ) $=
      ( chshii shatomici ) ABBCDE $.
  $}

  ${
    $d x y A $.
    $( A Hilbert lattice is atomic, i.e. any nonzero element is greater than or
       equal to some atom.  Remark in [Kalmbach] p. 140.  Also Definition 3.4-2
       in [MegPav2000] p. 2345 (PDF p. 8).  (Contributed by NM, 24-Jun-2004.)
       (New usage is discouraged.) $)
    hatomic $p |- ( ( A e. CH /\ A =/= 0H ) -> E. x e. HAtoms x C_ A ) $=
      ( cch wcel c0h wne cv wss cat wrex wi cif wceq neeq1 sseq2 rexbidv h0elch
      imbi12d elimel hatomici dedth imp ) BCDZBEFZAGZBHZAIJZUCUDUGKUCBELZEFZUEU
      HHZAIJZKBEBUHMZUDUIUGUKBUHENULUFUJAIBUHUEOPRAUHBECQSTUAUB $.
  $}

  ${
    $d x y A $.
    shatomistic.1 $e |- A e. SH $.
    $( The lattice of Hilbert subspaces is atomistic, i.e. any element is the
       supremum of its atoms.  Part of proof of Theorem 16.9 of [MaedaMaeda]
       p. 70.  (Contributed by NM, 26-Nov-2004.)
       (New usage is discouraged.) $)
    shatomistici $p |- A = ( span ` U. { x e. HAtoms | x C_ A } ) $=
      ( vy wss cat crab cuni cspn cfv wcel c0v wceq chil csh spanid 3syl adantr
      cv mpan eleq1 wne wa sheli spansnsh spansna sylan spansnss sseq1 sylanbrc
      csn elrab elssuni cch atssch chsssh sstri rabss2 uniss mp2b unimax shssii
      ax-mp eqsstri spanss eqsstr3d spansnid syl sseldd spancl sh0 a1i pm2.61ne
      ssriv mp2an fveq2i eqtri sseqtri eqssi ) BASZBEZAFGZHZIJZDBWDDSZBKZWEWDKL
      WDKZWELWELWDUAWFWELUBZUCZWEUKIJZWDWEWIWJWJIJZWDWFWKWJMZWHWFWENKZWJOKWLWEB
      CUDZWEUEWJPQRWIWJWBKZWJWCEZWKWDEZWIWJFKZWJBEZWOWFWMWHWRWNWEUFUGWFWSWHBOKZ
      WFWSCBWEUHTRWAWSAWJFVTWJBUIULUJWJWBUMWCNEZWPWQWCWAAOGZHZNFOEWBXBEWCXCEZFU
      NOUOUPUQWAAFOURWBXBUSUTZXCBNWTXCBMCABOVAVCZBCVBVDZUQZWJWCVETQVFWFWEWJKZWH
      WFWMXIWNWEVGVHRVIWGWFXAWDOKWGXHWCVJWDVKUTVLVMVNWDXCIJZBXCNEXDWDXJEXGXEWCX
      CVEVOXJBIJZBXCBIXFVPWTXKBMCBPVCVQVRVS $.
  $}

  ${
    $d x y A $.
    hatomistic.1 $e |- A e. CH $.
    $( ` CH ` is atomistic, i.e. any element is the supremum of its atoms.
       Remark in [Kalmbach] p. 140.  (Contributed by NM, 14-Aug-2002.)
       (New usage is discouraged.) $)
    hatomistici $p |- A = ( \/H ` { x e. HAtoms | x C_ A } ) $=
      ( vy cv wss cat crab chsup cfv cch wcel ssrab2 ax-mp wa elrab wi wceq c0h
      wn atssch sstri chsupcl chshii atelch sseq1 3imtr4i ssriv chsupss chsupid
      anim1i mp2an sseqtri cort cin wrex elssuni sylbir chsupunss syl6ss ex wne
      cuni atne0 adantr ssin chocini sseq2i bitr2i wb chle0 syl5bbr biimpa expr
      syl necon3ad mpd syld imnan sylnib nrex choccli chincli hatomici necon1bi
      sylib omlsii eqcomi ) AEZBFZAGHZIJZBWLBWKKFZWLKLWKGKWJAGMUAUBZWKUCNZBCUDW
      LWJAKHZIJZBWKWPFZWLWQFZDWKWPDEZGLZWTBFZOZWTKLZXBOWTWKLZWTWPLXAXDXBWTUEZUK
      WJXBAWTGWIWTBUFZPZWJXBAWTKXGPUGUHWMWPKFWRWSQWNWJAKMWKWPUIULNBKLWQBRCABUJN
      UMWTBWLUNJZUOZFZDGUPZTXJSRXKDGXAXBWTXIFZOZXKXAXBXMTZQXNTXAXBWTWLFZXOXAXBX
      PXCWTWKVCZWLXCXEWTXQFXHWTWKUQURWMXQWLFWNWKUSNUTVAXAXPXOXAXPOZWTSVBZXOXAXS
      XPWTVDVEXRXMWTSXAXPXMWTSRZXAXPXMOZXTYAWTSFZXAXTYAWTWLXIUOZFYBWTWLXIVFYCSW
      TWLWOVGVHVIXAXDYBXTVJXFWTVKVOVLVMVNVPVQVAVRXBXMVSWFWTBXIVFVTWAXLXJSDXJBXI
      CWLWOWBWCWDWENWGWH $.
  $}

  ${
    $d x A $.  $d x B $.
    chpssat.1 $e |- A e. CH $.
    chpssat.2 $e |- B e. CH $.
    $( Two Hilbert lattice elements in a proper subset relationship imply the
       existence of an atom less than or equal to one but not the other.
       (Contributed by NM, 10-Jun-2004.)  (New usage is discouraged.) $)
    chpssati $p |- ( A C. B -> E. x e. HAtoms ( x C_ B /\ -. x C_ A ) ) $=
      ( wpss wss wn cat wral crab chsup cfv cch ssrab2 atssch sstri hatomistici
      wi sylbir cv wrex dfpss3 simprbi iman ralbii ss2rab chsupss mp2an 3sstr4g
      wa con3i dfrex2 sylibr syl ) BCFZCBGZHZAUAZCGZUSBGZHUKZAIUBZUPBCGURBCUCUD
      URVBHZAIJZHVCVEUQVEUTVASZAIJZUQVFVDAIUTVAUEUFVGUTAIKZVAAIKZGZUQUTVAAIUGVJ
      VHLMZVILMZCBVHNGVINGVJVKVLGSVHINUTAIOPQVIINVAAIOPQVHVIUHUIACERABDRUJTTULV
      BAIUMUNUO $.

    $( The Hilbert lattice is relatively atomic.  Remark 2 of [Kalmbach]
       p. 149.  (Contributed by NM, 11-Jun-2004.)
       (New usage is discouraged.) $)
    chrelati $p |- ( A C. B ->
                  E. x e. HAtoms ( A C. ( A vH x ) /\ ( A vH x ) C_ B ) ) $=
      ( wpss cv wss wn wa cat wrex chj co chpssati wcel ancom cch wb pssss mpan
      atelch chnle adantl chlub mp3an13 sylan9bb anbi12d syl2an syl5bb rexbidva
      ibar mpbid ) BCFZAGZCHZUOBHIZJZAKLBBUOMNZFZUSCHZJZAKLABCDEOUNURVBAKURUQUP
      JZUNUOKPZJVBUPUQQUNBCHZUORPZVCVBSVDBCTUOUBVEVFJUQUTUPVAVFUQUTSZVEBRPZVFVG
      DBUOUCUAUDVEUPVEUPJZVFVAVEUPULVHVFCRPVIVASDEBUOCUEUFUGUHUIUJUKUM $.

    $( A consequence of relative atomicity.  (Contributed by NM, 30-Jun-2004.)
       (New usage is discouraged.) $)
    chrelat2i $p |- ( -. A C_ B <-> E. x e. HAtoms ( x C_ A /\ -. x C_ B ) ) $=
      ( wss wn wa cat wrex wpss wcel cch wi wb syl6bir wo sylib con2i syl cv co
      cin nssinpss chj chincli chrelati atelch chlub mp3an13 simpr adantld ssin
      notbii chnle mpan syl5bb anbi12d pm3.21 pm4.55 imor 3bitr4ri adantrl jcad
      orcom reximia sylbi wral sstr2 com12 ralrimivw ralbii ralnex bitri impbii
      iman ) BCFZGZAUAZBFZVSCFZGZHZAIJZVRBCUCZBKZWDBCUDWFWEWEVSUEUBZKZWGBFZHZAI
      JWDAWEBBCDEUFZDUGWJWCAIVSILVSMLZWJWCNVSUHWLWJVTWBWLWIVTWHWLWIWEBFZVTHZVTW
      EMLZWLBMLWNWIOWKDWEVSBUIUJZWMVTUKPULWLWJVTWAHZGZWNHWBWLWRWHWNWIWRVSWEFZGZ
      WLWHWQWSVSBCUMUNWOWLWTWHOWKWEVSUOUPUQWPURWRVTWBWMWAWRVTHZWAVTWQNZXAGZWAVT
      USWQVTGZQXDWQQXCXBWQXDVEWQVTUTVTWQVAVBRSVCPVDTVFTVGVQWDVQVTWANZAIVHZWDGZV
      QXEAIVTVQWAVSBCVIVJVKXFWCGZAIVHXGXEXHAIVTWAVPVLWCAIVMVNRSVO $.

    $( If a Hilbert lattice element covers another, it equals the other joined
       with some atom.  This is a consequence of the relative atomicity of
       Hilbert space.  (Contributed by NM, 30-Nov-2004.)
       (New usage is discouraged.) $)
    cvati $p |- ( A <oH B -> E. x e. HAtoms ( A vH x ) = B ) $=
      ( ccv wbr cv chj co wpss wss wa cat wrex wceq cch wcel wi syl cvpss mp2an
      chrelati atelch chjcl sylancr cvnbtwn2 mp3an12 com12 reximdvai mpd ) BCFG
      ZBBAHZIJZKUNCLMZANOZUNCPZANOULBCKZUPBQRZCQRZULURSDEBCUAUBABCDEUCTULUOUQAN
      UMNRZULUOUQSZVAUNQRZULVBSZVAUSUMQRVCDUMUDBUMUEUFUSUTVCVDDEBCUNUGUHTUIUJUK
      $.

    $( An alternate way to express the covering property.  (Contributed by NM,
       30-Nov-2004.)  (New usage is discouraged.) $)
    cvbr4i $p |- ( A <oH B <-> ( A C. B /\ E. x e. HAtoms ( A vH x ) = B ) ) $=
      ( ccv wbr wpss cv chj co wceq cat wrex wa cch wcel wi wb adantl cvpss jca
      mp2an cvati chcv2 mpan adantr psseq2 breq2 3bitr3d biimpd ex rexlimdv imp
      com3r impbii ) BCFGZBCHZBAIZJKZCLZAMNZOUQURVBBPQZCPQUQURRDEBCUAUCABCDEUDU
      BURVBUQURVAUQAMUSMQZVAURUQVDVAURUQRVDVAOZURUQVEBUTHZBUTFGZURUQVDVFVGSZVAV
      CVDVHDBUSUEUFUGVAVFURSVDUTCBUHTVAVGUQSVDUTCBFUITUJUKULUOUMUNUP $.

    $( Lemma for ~ cvexchi .  (Contributed by NM, 10-Jun-2004.)
       (New usage is discouraged.) $)
    cvexchlem $p |- ( ( A i^i B ) <oH B -> A <oH ( A vH B ) ) $=
      ( vx wss wn wa cat ccv wbr chj co wpss cch wcel wi wb mpan wceq cin cvpss
      cv wrex chincli mp2an chpssati syl ssin ancom bitr3i baibr notbid biimpar
      chcv1 biimpa sylan2 adantrr atelch chabs1i oveq1i chjass mp3an12 syl5reqr
      adantr chnle inss2 biantrur chlub mp3an13 syl5bb chjcl com23 sylbid imp32
      anbi12d cvnbtwn2 oveq2d eqtr3d sylan breqtrd exp32 rexlimiv mpcom ) EUCZB
      FZWEABUAZFZGZHZEIUDZWGBJKZAABLMZJKZWLWGBNZWKWGOPZBOPZWLWOQABCDUEZDWGBUBUF
      EWGBWRDUGUHWJWLWNQEIWEIPZWJWLWNWSWJWLHZHAAWELMZWMJWSWJAXAJKZWLWJWSWEAFZGZ
      XBWFXDWIWFXCWHWHWFXCWHXCWFHWFXCHWEABUIXCWFUJUKULUMUNWSXDXBAOPZWSXDXBRCAWE
      UOSUPUQURWSWEOPZWTXAWMTWEUSXFWTHZAWGWELMZLMZXAWMXFXIXATWTXFXAAWGLMZWELMZX
      IXJAWELABCDUTVAXEWPXFXKXITCWRAWGWEVBVCVDVEXGXHBALXFWJWLXHBTZXFWJWGXHNZXHB
      FZHZWLXLQWJWIWFHXFXOWFWIUJXFWIXMWFXNWPXFWIXMRWRWGWEVFSWFWGBFZWFHZXFXNXPWF
      ABVGVHWPXFWQXQXNRWRDWGWEBVIVJVKVPVKXFWLXOXLXFXHOPZWLXOXLQQZWPXFXRWRWGWEVL
      SWPWQXRXSWRDWGBXHVQVCUHVMVNVOVRVSVTWAWBWCWD $.

    $( The Hilbert lattice satisfies the exchange axiom.  Proposition 1(iii) of
       [Kalmbach] p. 140 and its converse.  Originally proved by Garrett
       Birkhoff in 1933.  (Contributed by NM, 12-Jun-2004.)
       (New usage is discouraged.) $)
    cvexchi $p |- ( ( A i^i B ) <oH B <-> A <oH ( A vH B ) ) $=
      ( cin ccv wbr chj co cvexchlem cort cfv choccli eqtri 3imtr4i cch wcel wb
      cvcon3 mp2an chdmj1i breq1i chdmm1i chjcomi breq2i chjcli chincli impbii
      incom ) ABEZBFGZAABHIZFGZABCDJULKLZAKLZFGZBKLZUJKLZFGZUMUKUQUOEZUOFGUQUQU
      OHIZFGUPUSUQUOBDMZACMZJUNUTUOFUNUOUQEUTABCDUAUOUQUINUBURVAUQFURUOUQHIVAAB
      CDUCUOUQVCVBUDNUEOAPQULPQUMUPRCABCDUFAULSTUJPQBPQUKUSRABCDUGDUJBSTOUH $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A consequence of relative atomicity.  (Contributed by NM, 1-Jul-2004.)
       (New usage is discouraged.) $)
    chrelat2 $p |- ( ( A e. CH /\ B e. CH ) ->
                  ( -. A C_ B <-> E. x e. HAtoms ( x C_ A /\ -. x C_ B ) ) ) $=
      ( cch wcel wss wn wa cat wrex wb chil cif wceq notbid sseq2 rexbidv helch
      bibi12d elimel cv sseq1 anbi1d anbi2d chrelat2i dedth2h ) BDEZCDEZBCFZGZA
      UAZBFZUKCFZGZHZAIJZKUGBLMZCFZGZUKUQFZUNHZAIJZKUQUHCLMZFZGZUTUKVCFZGZHZAIJ
      ZKBCLLBUQNZUJUSUPVBVJUIURBUQCUBOVJUOVAAIVJULUTUNBUQUKPUCQSCVCNZUSVEVBVIVK
      URVDCVCUQPOVKVAVHAIVKUNVGUTVKUMVFCVCUKPOUDQSAUQVCBLDRTCLDRTUEUF $.

    $( A consequence of relative atomicity.  (Contributed by NM, 2-Jul-2004.)
       (New usage is discouraged.) $)
    chrelat3 $p |- ( ( A e. CH /\ B e. CH ) ->
                   ( A C_ B <-> A. x e. HAtoms ( x C_ A -> x C_ B ) ) ) $=
      ( cch wcel wa wss cv wn cat wral wrex chrelat2 dfrex2 syl6bb con4bid iman
      wi ralbii syl6bbr ) BDECDEFZBCGZAHZBGZUCCGZIFZIZAJKZUDUERZAJKUAUBUHUAUBIU
      FAJLUHIABCMUFAJNOPUIUGAJUDUEQST $.
  $}

  ${
    $d x A $.  $d x B $.
    chrelat3.1 $e |- A e. CH $.
    chrelat3.2 $e |- B e. CH $.
    $( A consequence of the relative atomicity of Hilbert space: the ordering
       of Hilbert lattice elements is completely determined by the atoms they
       majorize.  (Contributed by NM, 30-Jun-2004.)
       (New usage is discouraged.) $)
    chrelat3i $p |- ( A C_ B <-> A. x e. HAtoms ( x C_ A -> x C_ B ) ) $=
      ( cch wcel wss cv wi cat wral wb chrelat3 mp2an ) BFGCFGBCHAIZBHPCHJAKLMD
      EABCNO $.

    $( A consequence of relative atomicity.  Extensionality principle: two
       lattice elements are equal iff they majorize the same atoms.
       (Contributed by NM, 30-Jun-2004.)  (New usage is discouraged.) $)
    chrelat4i $p |- ( A = B <-> A. x e. HAtoms ( x C_ A <-> x C_ B ) ) $=
      ( wss wa cv wi cat wral wceq wb chrelat3i anbi12i eqss ralbiim 3bitr4i )
      BCFZCBFZGAHZBFZUACFZIAJKZUCUBIAJKZGBCLUBUCMAJKSUDTUEABCDENACBEDNOBCPUBUCA
      JQR $.
  $}

  $( The Hilbert lattice satisfies the exchange axiom.  Proposition 1(iii) of
     [Kalmbach] p. 140 and its converse.  Originally proved by Garrett Birkhoff
     in 1933.  (Contributed by NM, 21-Jun-2004.)
     (New usage is discouraged.) $)
  cvexch $p |- ( ( A e. CH /\ B e. CH ) ->
                ( ( A i^i B ) <oH B <-> A <oH ( A vH B ) ) ) $=
    ( cch wcel cin ccv wbr chj co wb chil cif wceq ineq1 breq1d breq12d bibi12d
    id helch elimel oveq1 ineq2 oveq2 breq2d cvexchi dedth2h ) ACDZBCDZABEZBFGZ
    AABHIZFGZJUGAKLZBEZBFGZUMUMBHIZFGZJUMUHBKLZEZURFGZUMUMURHIZFGZJABKKAUMMZUJU
    OULUQVCUIUNBFAUMBNOVCAUMUKUPFVCRAUMBHUAPQBURMZUOUTUQVBVDUNUSBURFBURUMUBVDRP
    VDUPVAUMFBURUMHUCUDQUMURAKCSTBKCSTUEUF $.

  $( The Hilbert lattice satisfies the covering property of Definition 7.4 of
     [MaedaMaeda] p. 31 and its converse.  (Contributed by NM, 21-Jun-2004.)
     (New usage is discouraged.) $)
  cvp $p |- ( ( A e. CH /\ B e. HAtoms ) ->
            ( ( A i^i B ) = 0H <-> A <oH ( A vH B ) ) ) $=
    ( cch wcel cat wa cin ccv wbr c0h wceq chj co atelch chincl sylan2 sylancom
    wb atcveq0 cvexch bitr3d ) ACDZBEDZFABGZBHIZUDJKZAABLMHIZUBUCUDCDZUEUFRUCUB
    BCDZUHBNZABOPUDBSQUCUBUIUEUGRUJABTPUA $.

  $( The meet of a Hilbert lattice element and an incomparable atom is the zero
     subspace.  (Contributed by NM, 30-Jun-2004.)
     (New usage is discouraged.) $)
  atnssm0 $p |- ( ( A e. CH /\ B e. HAtoms ) ->
             ( -. B C_ A <-> ( A i^i B ) = 0H ) ) $=
    ( cch wcel cat wa wss wn chj co ccv wbr cin c0h wceq chcv1 cvp bitr4d ) ACD
    BEDFBAGHAABIJKLABMNOABPABQR $.

  $( The meet of distinct atoms is the zero subspace.  (Contributed by NM,
     25-Jun-2004.)  (New usage is discouraged.) $)
  atnemeq0 $p |- ( ( A e. HAtoms /\ B e. HAtoms ) ->
             ( A =/= B <-> ( A i^i B ) = 0H ) ) $=
    ( cat wcel wa wss wn wne cin c0h wceq atsseq eqcom syl6bb ancoms necon3bbid
    wb cch atelch atnssm0 sylan bitr3d ) ACDZBCDZEZBAFZGZABHABIJKZUEUFABUDUCUFA
    BKZQUDUCEUFBAKUIBALBAMNOPUCARDUDUGUHQASABTUAUB $.

  $( The meet with an atom's superset is the atom.  (Contributed by NM,
     12-Jun-2006.)  (New usage is discouraged.) $)
  atssma $p |- ( ( A e. HAtoms /\ B e. CH ) ->
            ( A C_ B <-> ( A i^i B ) e. HAtoms ) ) $=
    ( cat wcel cch wa wss cin wi wceq df-ss biimpi eleq1d biimprcd adantr incom
    c0h wn eleq1i atne0 neneqd sylbi wb atnssm0 ancoms biimpd con1d syl5 impbid
    ) ACDZBEDZFZABGZABHZCDZUJUMUOIUKUMUOUJUMUNACUMUNAJABKLMNOUOBAHZQJZRZULUMUOU
    PCDZURUNUPCABPSUSUPQUPTUAUBULUMUQULUMRZUQUKUJUTUQUCBAUDUEUFUGUHUI $.

  $( Two atoms covering the zero subspace are equal.  (Contributed by NM,
     26-Jun-2004.)  (New usage is discouraged.) $)
  atcv0eq $p |- ( ( A e. HAtoms /\ B e. HAtoms ) ->
               ( 0H <oH ( A vH B ) <-> A = B ) ) $=
    ( cat wcel wa c0h chj co ccv wbr wne wn cin atnemeq0 cch wb atelch atcv0 wi
    wceq sylan adantr biantrurd 3bitrd chjcl h0elch mp3an1 syldan syl2an sylbid
    cvp cvntr necon4ad oveq1 chjidm syl sylan9eq eqcomd eleq1d ex adantl impbid
    ibd syl6com ) ACDZBCDZEZFABGHZIJZABTZVGVIABVGABKZFAIJZAVHIJZEZVILZVGVKABMFT
    ZVMVNABNVEAODZVFVPVMPAQZABUKUAVGVLVMVEVLVFARUBUCUDVEVQBODZVNVOSZVFVRBQZVQVS
    VHODZVTABUEFODVQWBVTUFFAVHULUGUHUIUJUMVFVJVISVEVJVFVHCDZVIVJVFWCVJVFVFWCPVJ
    VFEZBVHCWDVHBVJVFVHBBGHZBABBGUNVFVSWEBTWABUOUPUQURUSUTVCVHRVDVAVB $.

  $( Two atoms covering the zero subspace are equal.  (Contributed by NM,
     26-Jun-2004.)  (New usage is discouraged.) $)
  atcv1 $p |- ( ( ( A e. CH /\ B e. HAtoms /\ C e. HAtoms ) /\
                A <oH ( B vH C ) ) -> ( A = 0H <-> B = C ) ) $=
    ( cch wcel cat w3a chj co ccv wbr wa c0h wceq wi breq1 biimpd ex imp wb syl
    atcv0eq sylan9bbr com23 3adant1 atelch chjidm sylan9eq eqcomd eleq1d impcom
    oveq1 ibd atcveq0 sylan2 exp32 com34 3adant2 impbid ) ADEZBFEZCFEZGZABCHIZJ
    KZLAMNZBCNZVCVEVFVGOZVAVBVEVHOUTVAVBLZVFVEVGVIVFVEVGOVIVFLVEVGVFVEMVDJKVIVG
    AMVDJPBCUBUCQRUDUESVCVEVGVFOZUTVBVEVJOZVAUTVBVKUTVBVGVEVFUTVBVGVEVFOUTVBVGL
    ZLVEVFVLUTVDFEZVEVFTVGVBVMVGVBVMVGVBVBVMTVGVBLZCVDFVNVDCVGVBVDCCHIZCBCCHULV
    BCDEVOCNCUFCUGUAUHUIUJRUMUKAVDUNUOQUPUQSURSUS $.

  $( The Hilbert lattice satisfies the atom exchange property.  Proposition
     1(i) of [Kalmbach] p. 140.  A version of this theorem related to vector
     analysis was originally proved by Hermann Grassmann in 1862.  Also
     Definition 3.4-3(b) in [MegPav2000] p. 2345 (PDF p. 8) (use ~ atnemeq0 to
     obtain atom inequality).  (Contributed by NM, 27-Jun-2004.)
     (New usage is discouraged.) $)
  atexch $p |- ( ( A e. CH /\ B e. HAtoms /\ C e. HAtoms ) ->
            ( ( B C_ ( A vH C ) /\ ( A i^i B ) = 0H ) -> C C_ ( A vH B ) ) ) $=
    ( cch wcel cat w3a chj co wss wceq wa atelch sylan2 3adant2 wpss wi ccv wbr
    chjcl cin c0h chub2 ancoms adantr cvpss syldan sylbid 3adant3 adantld chub1
    cvp id a1d ancrd wb chlub syld3an3 sylibd syl3an adantrd jcad simp1 anim12d
    imp 3jca ancomsd psssstr syl6 chcv2 cvnbtwn2 sylsyld mpd sseqtr4d ex ) ADEZ
    BFEZCFEZGZBACHIZJZABUAUBKZLZCABHIZJVSWCLZCVTWDVSCVTJZWCVPVRWFVQVRVPCDEZWFCM
    ZWGVPWFCAUCUDNOUEWEAWDPZWDVTJZLZWDVTKZVSWCWKVSWCWIWJVSWBWIWAVPVQWBWIQVRVPVQ
    LWBAWDRSZWIABULVPVQWDDEZWMWIQVQVPBDEZWNBMZABTZNAWDUFUGUHUIZUJVSWAWJWBVPVPVQ
    WOVRWGWAWJQVPUMZWPWHVPWOWGGZWAAVTJZWALZWJWTWAXAWTXAWAVPWGXAWOACUKOUNUOVPWOW
    GVTDEZXBWJUPVPWGXCWOACTOZABVTUQURUSUTZVAVBVEVSWCWKWLQZVSVPXCWNGZWCAVTRSZXFV
    PVPVQWOVRWGXGWSWPWHWTVPXCWNVPWOWGVCXDVPWOWNWGWQUIVFUTVSWCAVTPZXHVSWCWKXIVSW
    BWAWKVSWBWIWAWJWRXEVDVGAWDVTVHVIVPVRXIXHUPVQACVJOUSAVTWDVKVLVEVMVNVO $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    atoml.1 $e |- A e. CH $.
    $( An assertion holding in atomic orthomodular lattices that is equivalent
       to the exchange axiom.  Proposition 3.2.17 of [PtakPulmannova] p. 66.
       (Contributed by NM, 24-Jun-2004.)  (New usage is discouraged.) $)
    atomli $p |- ( B e. HAtoms ->
                ( ( A vH B ) i^i ( _|_ ` A ) ) e. ( HAtoms u. { 0H } ) ) $=
      ( vx cat wcel chj co cort cin c0h wceq wa wss cch sylancr wi wb mpan imp
      cfv wo csn cun wne wrex atelch chjcl choccli chincl sylancl hatomic sylan
      cv inss2 mpan2 pjococi oveq1i ineq1i incom eqtr3i pjoml3 syl5eq ad2ant2lr
      syl2an inss1 chub1 adantr chlub mp3an1 sylan2 biimpd ancoms mpand adantrr
      sstr anim12i ad2antlr pm3.22 adantl csh chsh chshii orthin jca sylc exp3a
      atexch syl3c eqssd ineq1d eqtr3d eleq1d exp43 com24 imp31 ibd ex rexlimdv
      com23 mpd necon1bd orrd elun fvex inex2 elsnc orbi2i bitri sylibr ) BEFZA
      BGHZAIUAZJZEFZXNKLZUBZXNEKUCZUDFZXKXOXPXKXOXNKXKXNKUEZXOXKXTMZDUNZXNNZDEU
      FZXOXKXNOFZXTYDXKXLOFZXMOFZYEXKAOFZBOFZYFCBUGZABUHZPACUIZXLXMUJUKDXNULUMY
      AYCXODEYAYCYBEFZXOYAYCYMXOQYAYCMYMXOXKXTYCYMYMXORZQXKYMYCXTYNXKYMYCXTYNXK
      YMMZYCXTMZMZYBXNEYQAYBGHZXMJZYBXNYMYCYSYBLZXKXTYMYBOFZYBXMNZYTYCYBUGZYCXN
      XMNUUBXLXMUOYBXNXMVPUPZUUAUUBMZYSXMXMIUAZYBGHZJZYBUUGXMJYSUUHUUGYRXMUUFAY
      BGACUQURUSUUGXMUTVAUUAUUBUUHYBLZYGUUAUUBUUIQYLXMYBVBSTVCVEVDYQYRXLXMYQYRX
      LYOYCYRXLNZXTYCYOYBXLNZUUJYCXNXLNUUKXLXMVFYBXNXLVPUPZYOUUKUUJXKYIUUAUUKUU
      JQYMYJUUCYIUUAMAXLNZUUKUUJYIUUMUUAYHYIUUMCABVGSVHUUAYIUUMUUKMZUUJQUUAYIMU
      UNUUJYIUUAYFUUNUUJRZYHYIYFCYKSYHUUAYFUUOCAYBXLVIVJVKVLVMVNVETVKVOYQYIYROF
      ZMZAYRNZBYRNZXLYRNZYOUUQYPXKYIYMUUPYJYMYHUUAUUPCUUCAYBUHPVQVHYMUURXKYPYMY
      HUUAUURCUUCAYBVGPVRYQYMXKMZUUKAYBJZKLZMZUUSYOUVAYPXKYMVSVHYMYCUVDXKXTYMYC
      MUUKUVCYCUUKYMUULVTYMUUAUUBUVCYCUUCUUDUUEUVBYBAJZKAYBUTUUAUUBUVEKLZUUAYBW
      AFAWAFUUBUVFQYBWBACWCYBAWDUKTVCVEWEVDYHYMXKUVDUUSQCAYBBWHVJWFUUQUURUUSUUT
      UUQUURUUSMZUUTYHYIUUPUVGUUTRCABYRVIVJVLWGWIWJWKWLWMWNWOWPWQWRWTWSXAWRXBXC
      XSXOXNXRFZUBXQXNEXRXDUVHXPXOXNKXMXLAIXEXFXGXHXIXJ $.

    $( An assertion holding in atomic orthomodular lattices that is equivalent
       to the exchange axiom.  Proposition P8(ii) of [BeltramettiCassinelli1]
       p. 400.  (Contributed by NM, 12-Jun-2006.)
       (New usage is discouraged.) $)
    atoml2i $p |- ( ( B e. HAtoms /\ -. B C_ A ) ->
                ( ( A vH B ) i^i ( _|_ ` A ) ) e. HAtoms ) $=
      ( cat wcel wss wn chj co cort cfv cin c0h cch atelch pjoml5 sylancr incom
      wceq wo eqeq1i biimpi oveq2d chj0i syl6eq sylan9req ex wb chlejb2 sylancl
      sylibrd con3d csn cun atomli elun h0elch elexi elsnc2 orbi2i orcom 3bitri
      sylib ord syld imp ) BDEZBAFZGZABHIZAJKZLZDEZVGVIVLMSZGVMVGVNVHVGVNVJASZV
      HVGVNVOVGVNVJAVKVJLZHIZAVGANEZBNEZVQVJSCBOZABPQVNVQAMHIAVNVPMAHVNVPMSVLVP
      MVJVKRUAUBUCACUDUEUFUGVGVSVRVHVOUHVTCBAUIUJUKULVGVNVMVGVLDMUMZUNEZVNVMTZA
      BCUOWBVMVLWAEZTVMVNTWCVLDWAUPWDVNVMVLMMNUQURUSUTVMVNVAVBVCVDVEVF $.

    $( An ordering law for a Hilbert lattice atom and a commuting subspace.
       (Contributed by NM, 12-Jun-2006.)  (New usage is discouraged.) $)
    atordi $p |- ( ( B e. HAtoms /\ A C_H B ) ->
                ( B C_ A \/ B C_ ( _|_ ` A ) ) ) $=
      ( cat wcel ccm wbr wa wss cort cfv cin chj co cch c0h incom syl6eq adantr
      wceq wn atelch choccli chincl mpan chj0 syl h0elch chjcom sylancl chocini
      eqtr3d eqtri oveq1i syl6eqr w3a cmidi cmcm2ii mpanr1 mp3anl2 mpanl1 sylan
      fh2 eqtr4d atoml2i adantlr eqeltrd wb atssma mpan2 ad2antrr mpbird orrd
      ex ) BDEZABFGZHZBAIZBAJKZIZVQVRUAZVTVQWAHZVTBVSLZDEZWBWCABMNZVSLZDVQWCWFT
      WAVQWCVSWELZWFVOBOEZVPWCWGTBUBWHVPHWCVSALZVSBLZMNZWGWHWCWKTVPWHWCPWJMNZWK
      WHWJPMNZWCWLWHWMWJWCWHWJOEZWMWJTVSOEZWHWNACUCZVSBUDUEZWJUFUGVSBQRWHWNPOEW
      MWLTWQUHWJPUIUJULWIPWJMWIAVSLPVSAQACUKUMUNUOSWOWHVPWGWKTZWPWOAOEZWHVPWRCW
      OWSWHUPAVSFGVPWRAACCACUQURVSABVCUSUTVAVDVBVSWEQRSVOWAWFDEVPABCVEVFVGVOVTW
      DVHZVPWAVOWOWTWPBVSVIVJVKVLVNVM $.

    $( Lemma for ~ atcvati .  (Contributed by NM, 27-Jun-2004.)
       (New usage is discouraged.) $)
    atcvatlem $p |- ( ( ( B e. HAtoms /\ C e. HAtoms ) /\
        ( A =/= 0H /\ A C. ( B vH C ) ) ) -> ( -. B C_ A -> A e. HAtoms ) ) $=
      ( vx cat wcel wa c0h chj co wss wi ccv wceq cch wb atelch imp adantr wpss
      wne wn cv wrex hatomici wbr cin nssne2 adantrl atnemeq0 syl5ib cvp chjcom
      sylan2 breq2d bitrd sylan sylibd ancoms adantlr chub1 syl2an 3adant3 sstr
      pssss adantl incom syl5eq adantrr atexch syl3an1 mp2and simp1 simp3 chjcl
      w3a 3jca syl3an chlub syl mpbi2and 3adant2 anim12i syld3an3 mpbid syl3anl
      eqssd anassrs psseq2d ex ibd exp32 3expa an32s com34 imp45 simpr cvnbtwn3
      jca mp3an3 exp4a com23 imp4a eleq1d biimprcd exp4c pm2.43b rexlimdva syl5
      exp4d imp32 ) BFGZCFGZHZAIUBZABCJKZUAZBALUCZAFGZMZXPEUDZALZEFUEXOXRYAMZEA
      DUFXOYCYDEFXOYBFGZHZYCXRXSXTXOYEYCXRXSHZHZXTMZXOYEYIYEXOYEYHXTYFYHHZXTYEY
      JAYBFYJYBBYBJKZNUGZAYKUAZAYBOZYFYHYLXMYEYHYLMZXNYEXMYOYEXMHZYHYBBUHZIOZYL
      YHYBBUBZYPYRYCXSYSXRYBBAUIZUJYBBUKZULYEYBPGZXMYRYLQYBRZUUBXMHZYRYBYBBJKZN
      UGYLYBBUMUUDUUEYKYBNXMUUBBPGZUUEYKOBRZYBBUNUOUPUQURUSUTVASYFYCXRXSYMYFYCX
      SXRYMXMYEXNYCXSXRYMMZMMZXMYEXNUUIXMYEXNVQZYCXSUUHUUJYCXSHZHZXRYMUULXRXRYM
      QUULXRHXQYKAUUJUUKXRXQYKOUUJUUKXRHZHZXQYKUUNBYKLZCYKLZXQYKLZUUJUUOUUMXMYE
      UUOXNXMUUFUUBUUOYEUUGUUCBYBVBVCVDTUUNYBXQLZBYBUHZIOZUUPUUMUURUUJYCXRUURXS
      XRYCAXQLUURAXQVFYBAXQVEUOVAZVGUUJUUKUUTXRUULUUSYQIBYBVHUUJUUKYRXMYEUUKYRM
      ZXNYEXMUVBUUKYSYPYRYTUUAULUTVDSVIVJUUJUURUUTHUUPMZUUMXMUUFYEXNUVCUUGBYBCV
      KVLTVMUUJUUOUUPHUUQQZUUMUUJUUFCPGZYKPGZVQZUVDXMUUFYEUUBXNUVEUVGUUGUUCCRZU
      UFUUBUVEVQZUUFUVEUVFUUFUUBUVEVNUUFUUBUVEVOUUFUUBUVFUVEBYBVPZVDVRVSBCYKVTW
      ATWBXMUUFYEUUBXNUVEUUMYKXQLZUUGUUCUVHUVIUUMHBXQLZUURHZUVKUVIUVLUUMUURUUFU
      VEUVLUUBBCVBWCUVAWDUVIUVMUVKQZUUMUUFUUBUVEXQPGZUVNUUFUVEUVOUUBBCVPWCBYBXQ
      VTWETWFWGWHWIWJWKWLWMWNWOWPWQYFYCYLYMHYNMZYGYFYCUVPXMYEYCUVPMZXNXMYEHUUBU
      VFHZUVQXMUUFUUBUVRYEUUGUUCUUFUUBHUUBUVFUUFUUBWRUVJWTVCUVRYCYLYMYNUVRYLYCY
      MYNMUVRYLYCYMYNUUBUVFAPGYLYCYMHYNMMDYBYKAWSXAXBXCXDWAVASVJVMXEXFXGXHSXKXI
      XJXL $.

    $( A nonzero Hilbert lattice element less than the join of two atoms is an
       atom.  (Contributed by NM, 28-Jun-2004.)  (New usage is discouraged.) $)
    atcvati $p |- ( ( B e. HAtoms /\ C e. HAtoms ) ->
                 ( ( A =/= 0H /\ A C. ( B vH C ) ) -> A e. HAtoms ) ) $=
      ( cat wcel wa c0h chj co wpss wss wn atcvatlem wi cch atelch syl2an imp
      ex wne wceq chjcom psseq2d anbi2d sylbird ancoms wo wb chlub 3comr ssnpss
      w3a syl6bi con2d ianor syl6ib mp3an1 adantrl mpjaod ) BEFZCEFZGZAHUAZABCI
      JZKZGZAEFZVCVGGBALZMZVHCALZMZABCDNVCVGVLVHOZVBVAVGVMOVBVAGZVGVDACBIJZKZGZ
      VMVNVPVFVDVNVOVEAVBCPFZBPFZVOVEUBVACQZBQZCBUCRUDUEVNVQVMACBDNTUFUGSVCVFVJ
      VLUHZVDVCVFWBVAVSVRVFWBOZVBWAVTAPFZVSVRWCDWDVSVRUMZVFVIVKGZMWBWEWFVFWEWFV
      EALZVFMVSVRWDWFWGUIBCAUJUKVEAULUNUOVIVKUPUQURRSUSUTT $.

    $( A Hilbert lattice element covered by the join of two distinct atoms is
       an atom.  (Contributed by NM, 26-Jun-2004.)
       (New usage is discouraged.) $)
    atcvat2i $p |- ( ( B e. HAtoms /\ C e. HAtoms ) ->
                 ( ( -. B = C /\ A <oH ( B vH C ) ) -> A e. HAtoms ) ) $=
      ( cat wcel wa wceq wn chj co ccv wbr wi c0h wne cch wb atcv1 atelch chjcl
      mp3anl1 necon3abid wpss cvpss sylancr atcvati exp3acom23 syld imp sylbird
      syl2an ex com23 imp3a ) BEFZCEFZGZBCHZIZABCJKZLMZAEFZURVBUTVCURVBUTVCNURV
      BGZUTAOPZVCVDUSAOAQFZUPUQVBAOHUSRDABCSUBUCURVBVEVCNZURVBAVAUDZVGURVFVAQFZ
      VBVHNDUPBQFCQFVIUQBTCTBCUAULAVAUEUFURVEVHVCABCDUGUHUIUJUKUMUNUO $.
  $}

  $( An ordering law for a Hilbert lattice atom and a commuting subspace.
     (Contributed by NM, 12-Jun-2006.)  (New usage is discouraged.) $)
  atord $p |- ( ( A e. CH /\ B e. HAtoms /\ A C_H B ) ->
              ( B C_ A \/ B C_ ( _|_ ` A ) ) ) $=
    ( cch wcel cat ccm wbr wss cort cfv wo wa wi c0h cif wceq breq1 sseq2 fveq2
    anbi2d sseq2d orbi12d imbi12d h0elch elimel atordi dedth 3impib ) ACDZBEDZA
    BFGZBAHZBAIJZHZKZUIUJUKLZUOMUJUIANOZBFGZLZBUQHZBUQIJZHZKZMANAUQPZUPUSUOVCVD
    UKURUJAUQBFQTVDULUTUNVBAUQBRVDUMVABAUQISUAUBUCUQBANCUDUEUFUGUH $.

  $( A Hilbert lattice element covered by the join of two distinct atoms is an
     atom.  (Contributed by NM, 29-Jun-2004.)  (New usage is discouraged.) $)
  atcvat2 $p |- ( ( A e. CH /\ B e. HAtoms /\ C e. HAtoms ) ->
               ( ( -. B = C /\ A <oH ( B vH C ) ) -> A e. HAtoms ) ) $=
    ( cch wcel cat wceq wn chj co ccv wbr wa c0h cif breq1 anbi2d eleq1 imbi12d
    wi imbi2d h0elch elimel atcvat2i dedth 3impib ) ADEZBFEZCFEZBCGHZABCIJZKLZM
    ZAFEZTZUGUHUIMZUOTUPUJUGANOZUKKLZMZUQFEZTZTANAUQGZUOVAUPVBUMUSUNUTVBULURUJA
    UQUKKPQAUQFRSUAUQBCANDUBUCUDUEUF $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Irreducibility
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d p q r x A $.
    chirred.1 $e |- A e. CH $.
    $( Lemma for ~ chirredi .  (Contributed by NM, 14-Jun-2006.)
       (New usage is discouraged.) $)
    chirredlem1 $p |- ( ( ( p e. HAtoms /\ ( q e. CH /\ q C_ ( _|_ ` A ) ) )
     /\ ( ( r e. HAtoms /\ r C_ A ) /\ r C_ ( p vH q ) ) ) ->
       ( p i^i ( _|_ ` r ) ) = 0H ) $=
      ( cv cat wcel cch cort cfv wss wa chj co cin c0h wceq wi wb atelch biimpa
      chsscon3 mpan2 sylan sstr2 wn atne0 neneqd ad3antrrr simplr choccl chlej1
      syl5 syl 3exp1 syl5com imp42 adantllr adantlr sstrd chlejb2 sylanl1 an32s
      ancoms adantrl ad2antrr sseqtrd ex chssoc syld mtod sylanr1 atnssm0 incom
      biimpd eqeq1i syl6bb ad2ant2r sylibd exp43 adantr sylcom com4t imp3a
      imp43 ) DFZGHZCFZIHZWIAJKZLZMBFZGHZWMALZMZWMWGWINOZLZWGWMJKZPZQRZWHWJWLWP
      WRXASZSWLWPWHWJXBWLWPWIWSLZWHWJXBSSZWPWKWSLZWLXCWNWMIHZWOXEWMUAZXFWOXEXFA
      IHWOXETEWMAUCUDUBUEWIWKWSUFUNWNXCXDSWOWNXCWHWJXBWNXCMZWHWJMMWRWGWSLZUGZXA
      WHXHWGIHZWJWRXJSWGUAXHXKWJMZMZWRXJXMWRMZXIWMQRZWNXOUGXCXLWRWNWMQWMUHUIUJX
      NXIWMWSLZXOXNXIXPXNXIMZWMWSWINOZWSXQWMWQXRXMWRXIUKXMXIWQXRLZWRWNXLXIXSXCW
      NXKWJXIXSWNWSIHZXKWJXIXSSSWNXFXTXGWMULUOZXKXTWJXIXSWGWSWIUMUPUQURUSUTVAXM
      XRWSRZWRXIXHWJYBXKWNWJXCYBWNXTWJXCYBYAXTWJMXCYBWJXTXCYBTWIWSVBVEUBVCVDVFV
      GVHVIWNXPXOSZXCXLWRWNXFYCXGXFXPXOWMVJVPUOUJVKVLVIVMWNWHXJXATZXCWJWNXTWHYD
      YAXTWHMXJWSWGPZQRXAWSWGVNYEWTQWSWGVOVQVRUEVSVTWAWBWCWDWEWF $.

    $( Lemma for ~ chirredi .  (Contributed by NM, 15-Jun-2006.)
       (New usage is discouraged.) $)
    chirredlem2 $p |- ( ( ( ( p e. HAtoms /\ p C_ A ) /\ ( q e. CH /\
      q C_ ( _|_ ` A ) ) ) /\ ( ( r e. HAtoms /\ r C_ A ) /\ r C_ ( p vH q ) )
        )
                  -> ( ( _|_ ` r ) i^i ( p vH q ) ) = q ) $=
      ( cv wcel wss wa cch cort cfv chj co cin wceq adantr ccm wbr c0h ad2ant2r
      cat atelch chjcom sylan ineq2d w3a choccl syl id 3anim123i 3expa adantllr
      3com13 adantlrr adantrr simpll ad2antrl wb chsscon3 sylancl biimpa sylan2
      sstr adantll lecm syl3anc ad2ant2lr mpan2 an12s ancom2s wi syl3an2 3expia
      cmcm2 sylibrd mpd sylanl2 ancom1s an4s syl12anc sseqin2 sylib chirredlem1
      fh2 incom syl5eq oveq12d chj0 ad2antlr eqtrd 3eqtrd ) DFZUBGZWMAHZIZCFZJG
      ZWQAKLZHZIZIZBFZUBGZXCAHZIZXCWMWQMNZHZIZIZXCKLZXGOXKWQWMMNZOZXKWQOZXKWMOZ
      MNZWQXJXGXLXKXBXGXLPZXIWNWRXQWOWTWNWMJGZWRXQWMUCZWMWQUDUEUAQUFXJXKJGZWRXR
      UGZWQXKRSZWQWMRSZXMXPPXBXFYAXHXBXDYAXEWPWRXDYAWTWNWRXDYAWOWNWRXDYAXDWRWNY
      AXDXTWRWRWNXRXDXCJGZXTXCUCZXCUHUIZWRUJXSUKUNULUMUOUPUPXAXFYBWPXHXAXFIZWRX
      TWQXKHZYBWRWTXFUQXDXTXAXEYFURWTXFYHWRXFWTWSXKHZYHXDXEYIXDYDAJGZXEYIUSYEEX
      CAUTVAVBWQWSXKVDVCVEZWQXKVFVGVHXBYCXIWNWRWOWTYCWRWNWOWTIZYCWNWRXRYLYCXSWR
      XRIZYLIWQWMKLZHZYCXRYLYOWRXRWTWOYOWTXRWOYOXRWOIWTWSYNHZYOXRWOYPXRYJWOYPUS
      EWMAUTVIVBWQWSYNVDVCVJVKVEYMYOYCVLYLYMYOWQYNRSZYCWRXRYOYQXRWRYNJGYOYQWMUH
      WQYNVFVMVNWQWMVOVPQVQVRVSVTQXKWQWMWEWAXJXPWQTMNZWQXJXNWQXOTMXAXFXNWQPZWPX
      HYGYHYSYKWQXKWBWCVHXJXOWMXKOZTXKWMWFWNXAXIYTTPWOABCDEWDUMWGWHXAYRWQPZWPXI
      WRUUAWTWQWIQWJWKWL $.

    ${
      chirred.2 $e |- ( x e. CH -> A C_H x ) $.
      $( Lemma for ~ chirredi .  (Contributed by NM, 15-Jun-2006.)
         (New usage is discouraged.) $)
      chirredlem3 $p |- ( ( ( ( p e. HAtoms /\ p C_ A ) /\ ( q e. HAtoms /\
        q C_ ( _|_ ` A ) ) ) /\ ( r e. HAtoms /\ r C_ ( p vH q ) ) )
                    -> ( r C_ A -> r = p ) ) $=
        ( cv wcel wss wa chj co wceq wi cch c0h cin ccm wbr cat cort cfv atelch
        chirredlem2 oveq2d adantr chjcl ad2ant2r id pjoml2 syl3an 3com12 eqtr3d
        sylan 3expb ineq2d breq2 vtoclga anim12i mp3anl1 ancoms adantrr adantll
        fh1 mpdan 3eqtr3d sseqin2 biimpi ad2antlr adantl csh chsh chshii orthin
        incom sylancl imp syl5eq oveq12d ad2antrr ad3antrrr exp44 com34 sylanr1
        chj0 syl imp32 ) EHZUAIZWIBJZKZDHZUAIZWMBUBUCJZKKCHZUAIZWPWIWMLMZJZWPBJ
        ZWPWINZOZWNWLWMPIZWOWQWSXBOOWMUDWLXCWOKZKZWQWTWSXAXEWQWTWSXAXEWQWTKZWSK
        ZKZWPQLMZWIQLMZWPWIXHBWPRZBWMRZLMZBWIRZXLLMZXIXJXHBWPWMLMZRZBWRRZXMXOXH
        XPWRBXHWPWPUBUCWRRZLMZXPWRXHXSWMWPLBCDEFUEUFXEXFWSXTWRNZXFXEWSYAXFWPPIZ
        XEWRPIZWSWSYAWQYBWTWPUDZUGWJXCYCWKWOWJWIPIZXCYCWIUDZWIWMUHUOUIWSUJWPWRU
        KULUMUPUNUQXDXGXQXMNZWLXCXFYGWOWSXCWQYGWTWQXCYGWQYBXCYGYDYBXCKBWPSTZBWM
        STZKZYGYBYHXCYIBAHZSTZYHAWPPYKWPBSURGUSYLYIAWMPYKWMBSURGUSZUTBPIZYBXCYJ
        YGFBWPWMVEVAVFUOVBVCUIVDXEXRXONZXGWJXCYOWKWOWJYEXCYOYFYEXCKBWISTZYIKZYO
        YEYPXCYIYLYPAWIPYKWIBSURGUSYMUTYNYEXCYQYOFBWIWMVEVAVFUOUIUGVGXHXKWPXLQL
        XGXKWPNZXEWTYRWQWSWTYRWPBVHVIVJVKXDXLQNWLXGXDXLWMBRZQBWMVPXCWOYSQNZXCWM
        VLIBVLIWOYTOWMVMBFVNWMBVOVQVRVSVJZVTXHXNWIXLQLWLXNWINZXDXGWKUUBWJWKUUBW
        IBVHVIVKWAUUAVTVGXGXIWPNZXEWQUUCWTWSWQYBUUCYDWPWFWGWAVKWJXJWINZWKXDXGWJ
        YEUUDYFWIWFWGWBVGWCWDWEWH $.

      $( Lemma for ~ chirredi .  (Contributed by NM, 15-Jun-2006.)
         (New usage is discouraged.) $)
      chirredlem4 $p |- ( ( ( ( p e. HAtoms /\ p C_ A ) /\ ( q e. HAtoms /\
        q C_ ( _|_ ` A ) ) ) /\ ( r e. HAtoms /\
              r C_ ( p vH q ) ) ) -> ( r = p \/ r = q ) ) $=
        ( cv cat wcel wss wa cort cfv chj wceq ccm wbr cch atelch co wo vtoclga
        breq2 syl atordi mpdan ad2antrl chirredlem3 ococi sseq2i biimpri chjcom
        wi wb syl2an sseq2d anbi2d ad2ant2r choccli cmcm3 mpan mpbid ex sylbird
        sylanr2 imp ancom1s orim12d mpd ) EHZIJZVKBKZLZDHZIJZVOBMNZKZLZLZCHZIJZ
        WAVKVOOUAZKZLZLZWABKZWAVQKZUBZWAVKPZWAVOPZUBWBWIVTWDWBBWAQRZWIWBWASJWLW
        ATBAHZQRZWLAWASWMWABQUDGUCUEBWAFUFUGUHWFWGWJWHWKABCDEFGUIVSVNWEWHWKUNZV
        SVNLWEWOVMVSVLVKVQMNZKZWEWOUNWQVMWPBVKBFUJUKULVSVLWQLLZWEWBWAVOVKOUAZKZ
        LZWOVPVLXAWEUOVRWQVPVLLZWTWDWBXBWSWCWAVPVOSJVKSJWSWCPVLVOTVKTVOVKUMUPUQ
        URUSWRXAWOAVQCEDBFUTWMSJZWNVQWMQRZGBSJXCWNXDUOFBWMVAVBVCUIVDVEVFVGVHVIV
        J $.

      $( The Hilbert lattice is irreducible: any element that commutes with all
         elements must be zero or one.  Theorem 14.8.4 of
         [BeltramettiCassinelli] p. 166.  (Contributed by NM, 15-Jun-2006.)
         (New usage is discouraged.) $)
      chirredi $p |- ( A = 0H \/ A = ~H ) $=
        ( vp vq vr c0h wceq cort cfv wo wn wne wa cv wss cat wrex wcel hatomici
        chil eqid ioran anbi12i bitr4i choccli anim12i reeanv sylibr chj co w3a
        df-ne simpll simprl cch wb atelch chsscon3 sylancl biimpa sylan2 ancoms
        atne0 adantr sseq1 bicomd chssoc syl sylan9bbr an32s ex necon3d adantlr
        sstr mpd syldan adantrl superpos syl3anc df-3an neanior anbi1i bitri wi
        chirredlem4 anassrs pm2.24d com23 imp3a syl5bi rexlimdva an4s rexlimivv
        sylbi mt4 fveq2 ococi choc0 3eqtr3g orim2i ax-mp ) BHIZBJKZHIZLZXDBUBIZ
        LHHIZXGHUCXGMZBHNZXEHNZOZXIMZXJXDMZXFMZOXMXDXFUDXKXOXLXPBHUNXEHUNUEUFXM
        EPZBQZFPZXEQZOZFRSERSZXNXMXRERSZXTFRSZOYBXKYCXLYDEBCUAFXEBCUGUAUHXRXTEF
        RRUIUJYAXNEFRRXQRTZXSRTZOYAXNYEXRYFXTXNYEXROZYFXTOZOZGPZXQNZYJXSNZYJXQX
        SUKULQZUMZGRSZXNYIYEYFXQXSNZYOYEXRYHUOYGYFXTUPYGXTYPYFYGXTXSXQJKZQZYPXT
        YGYRYGXTXEYQQZYRYEXRYSYEXQUQTZBUQTXRYSURXQUSZCXQBUTVAVBXSXEYQVPVCVDYEYR
        YPXRYEYROZXQHNZYPYEUUCYRXQVEVFUUBXQXSXQHUUBXQXSIZXQHIZYEUUDYRUUEYEUUDOY
        RUUEUUDYRXQYQQZYEUUEUUDUUFYRXQXSYQVGVHYEYTUUFUUEURUUAXQVIVJVKVBVLVMVNVQ
        VOVRVSGXQXSVTWAYIYNXNGRYNYJXQIYJXSILZMZYMOZYIYJRTZOZXNYNYKYLOZYMOUUIYKY
        LYMWBUULUUHYMYJXQYJXSWCWDWEUUKUUHYMXNUUKYMUUHXNUUKYMUUHXNWFUUKYMOUUGXNY
        IUUJYMUUGABGFECDWGWHWIVMWJWKWLWMVQWNVMWOVJWPWQXFXHXDXFXEJKHJKBUBXEHJWRB
        CWSWTXAXBXC $.
    $}
  $}

  ${
    $d x y z A $.
    $( The Hilbert lattice is irreducible: any element that commutes with all
       elements must be zero or one.  Theorem 14.8.4 of [BeltramettiCassinelli]
       p. 166.  (Contributed by NM, 16-Jun-2006.)
       (New usage is discouraged.) $)
    chirred $p |- ( ( A e. CH /\ A. x e. CH A C_H x ) ->
                 ( A = 0H \/ A = ~H ) ) $=
      ( vy cch wcel cv ccm wbr wral wa c0h wceq chil wo eqeq1 eleq1 nfeq2 breq1
      nfcv ralbid cif orbi12d nfv nfra1 nfan nfif anbi12d h0elch pm3.2i elimhyp
      cm0 rgen simpli simpri nfbr breq2 rspc mpi chirredi dedth ) BDEZBAFZGHZAD
      IZJZBKLZBMLZNVEBKUAZKLZVHMLZNBKBVHLZVFVIVGVJBVHKOBVHMOUBCVHVHDEZVHVBGHZAD
      IZVEVLVNJKDEZKVBGHZADIZJBKVKVAVLVDVNBVHDPVKVCVMADABVHVEABKVAVDAVAAUCVCADU
      DUEABSAKSUFZQBVHVBGRTUGKVHLZVOVLVQVNKVHDPVSVPVMADAKVHVRQKVHVBGRTUGVOVQUHV
      PADVBUKULUIUJZUMCFZDEVNVHWAGHZVLVNVTUNVMWBAWADAVHWAGVRAGSAWASUOVBWAVHGUPU
      QURUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Atoms (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.  $d x B $.  $d x C $.
    atcvat3.1 $e |- A e. CH $.
    $( A condition implying that a certain lattice element is an atom.  Part of
       Lemma 3.2.20 of [PtakPulmannova] p. 68.  (Contributed by NM,
       2-Jul-2004.)  (New usage is discouraged.) $)
    atcvat3i $p |- ( ( B e. HAtoms /\ C e. HAtoms ) ->
          ( ( ( -. B = C /\ -. C C_ A ) /\ B C_ ( A vH C ) ) ->
          ( A i^i ( B vH C ) ) e. HAtoms ) ) $=
      ( cat wcel wa wceq wn wss chj co ccv wbr wi cch wb mpan atelch adantr cin
      biimpa ad2ant2lr anim12i chjcom oveq2d chjass mp3an1 ancoms eqtr4d adantl
      chcv1 simpl w3a chlej2 ex syl3anc imp eqsstrd chjidm syl ad2antlr sseqtrd
      chjcl simpr chub2 mp3anl3 syl21anc eqssd sylan breq2d mpbird jctil syl2an
      adantrl cvexch sylibrd chincl sylancr atcvat2 expdimp syld exp4b imp4c )
      BEFZCEFZGZBCHIZCAJIZBACKLZJZABCKLZUAZEFZWGWHWIWKWNWGWHGWIWKGZWMWLMNZWNWGW
      OWPOWHWGWOAAWLKLZMNZWPWGWOWRWGWOGWRAWJMNZWFWIWSWEWKWFWIWSAPFZWFWIWSQDACUL
      RUBUCWGWKWRWSQWIWGWKGWQWJAMWGBPFZCPFZGZWKWQWJHWEXAWFXBBSZCSZUDXCWKGZWQWJX
      FWQWJWJKLZWJXFWQWJBKLZXGXCWQXHHWKXCWQACBKLZKLZXHXCWLXIAKBCUEUFXBXAXHXJHZW
      TXBXAXKDACBUGUHUIUJTXCWKXHXGJZXCXAWJPFZXMWKXLOXAXBUMXBXMXAWTXBXMDACVDRZUK
      ZXOXAXMXMUNWKXLBWJWJUOUPUQURUSXBXGWJHZXAWKXBXMXPXNWJUTVAVBVCXCWJWQJZWKXCX
      BWLPFZCWLJZXQXAXBVEBCVDZXBXAXSCBVFUIXBXRWTXSXQDCWLAUOVGVHTVIVJVKVOVLUPWGW
      TXRGZWPWRQWEXAXBYAWFXDXEXCXRWTXTDVMVNAWLVPVAVQTWGWHWPWNWGWMPFZWEWFWHWPGWN
      OWEXAXBYBWFXDXEXCWTXRYBDXTAWLVRVSVNWEWFUMWEWFVEWMBCVTUQWAWBWCWD $.

    $( A condition implying existence of an atom with the properties shown.
       Lemma 3.2.20 of [PtakPulmannova] p. 68.  (Contributed by NM,
       2-Jul-2004.)  (New usage is discouraged.) $)
    atcvat4i $p |- ( ( B e. HAtoms /\ C e. HAtoms ) ->
          ( ( A =/= 0H /\ B C_ ( A vH C ) ) ->
          E. x e. HAtoms ( x C_ A /\ B C_ ( C vH x ) ) ) ) $=
      ( cat wcel wa wceq wss c0h chj co wi cch atelch syl2an sseq1 adantl cin
      wne cv wrex hatomici chub1 syl5ibr exp3a impcom exp3acom23 reximdvai syl5
      anim2d ex a1i com4l imp4a wb chlejb2 mpan2 biimpa sseq2d expl chub2 simpl
      jctird jctild oveq2 anbi12d rspcev syl adantrl exp31 wo wn simpr atcvat3i
      impl ioran w3a ad2antlr imp simpll 3jca inss2 chjcom syl5sseq adantr mpan
      atnssm0 inss1 sslin ax-mp incom sseqtri sseq2 mpbii chjcl sylancr syl2anc
      chincl chle0 syl5ib sylbid adantrr jca atexch sylc jctil jcad syl6 syl5bi
      syl7 ecase3d ) CFGZDFGZHZCDIZDBJZBKUAZCBDLMZJZHZAUBZBJZCDYCLMZJZHZAFUCZNZ
      XOXQYINXNXOXQXSYAYHYAXOXQXSYHXOXQXSYHNZNNYAXOXQYJXSYDAFUCXOXQHZYHABEUDYKY
      DYGAFYKYDYCFGZYGYKYLYFYDXQXOYLYFNXQXOYLYFXOYLHYFXQDYEJZXODOGZYCOGYMYLDPZY
      CPDYCUEQCDYERUFUGUHULUIUJUKUMUNUOUPSXPXRYBYHXPXRHZYAYHXSYPYAHXNCBJZCDCLMZ
      JZHZHZYHXPXRYAUUAXPXRYAHZYTXNXNCOGZYNUUBYTNXOCPZYOUUCYNHZUUBYQYSYNUUBYQNU
      UCYNXRYAYQYNXRHZYAYQUUFXTBCYNXRXTBIZYNBOGZXRUUGUQEDBURUSUTVAUTVBSCDVCVEQX
      NXOVDVFVQYGYTACFYCCIZYDYQYFYSYCCBRUUIYEYRCYCCDLVGVAVHVIVJVKVLYBYAXPXQXRVM
      VNZYHXSYAVOUUJXQVNZXRVNZHZXPYAYHNXQXRVRXPUUMYAYHXPUUMYAHZBCDLMZTZFGZUUPBJ
      ZCDUUPLMZJZHZHYHXPUUNUUQUVABCDEVPZXPUUNUVAXPUUNHZUUTUURUVCYNUUQXNVSUUPYRJ
      ZDUUPTZKIZHUUTUVCYNUUQXNXOYNXNUUNYOVTXPUUNUUQUVBWAXNXOUUNWBWCUVCUVDUVFXPU
      VDUUNXPUUOUUPYRBUUOWDXNUUCYNUUOYRIXOUUDYOCDWEQWFWGXPUUMUVFYAXPUULUVFUUKXP
      UULUVFXPUULBDTZKIZUVFXOUULUVHUQZXNUUHXOUVIEBDWIWHSUVHUVEKJZXPUVFUVHUVEUVG
      JUVJUVEDBTZUVGUURUVEUVKJBUUOWJZUUPBDWKWLDBWMWNUVGKUVEWOWPXPUVEOGZUVJUVFUQ
      XNUUCYNUVMXOUUDYOUUEYNUUPOGZUVMUUCYNVOUUEUUHUUOOGUVNECDWQBUUOWTWRDUUPWTWS
      QUVEXAVJXBXCWAVKXDXEDUUPCXFXGUVLXHUMXIYGUVAAUUPFYCUUPIZYDUURYFUUTYCUUPBRU
      VOYEUUSCYCUUPDLVGVAVHVIXJUGXKXLXM $.
  $}

  $( Two Hilbert lattice elements have the dual modular pair property if the
     first is an atom.  Theorem 7.6(c) of [MaedaMaeda] p. 31.  (Contributed by
     NM, 22-Jun-2004.)  (New usage is discouraged.) $)
  atdmd $p |- ( ( A e. HAtoms /\ B e. CH ) -> A MH* B ) $=
    ( cat wcel cch wa cin c0h wceq wbr chj co ccv wb ancoms 3expia sylan sylbid
    wi wn cdmd cvp atelch chjcom sylan2 breq2d bitrd wss atnssm0 con1bid ssdmd1
    cvdmd pm2.61d ) ACDZBEDZFZBAGHIZABUAJZUPUQBABKLZMJZURUOUNUQUTNUOUNFZUQBBAKL
    ZMJUTBAUBVAVBUSBMUNUOAEDZVBUSIAUCZBAUDUEUFUGOUNVCUOUTURSVDVCUOUTURABULPQRUP
    UQTABUHZURUPVEUQUOUNVETUQNBAUIOUJUNVCUOVEURSVDVCUOVEURABUKPQRUM $.

  ${
    $d x A $.  $d x B $.
    $( Two Hilbert lattice elements have the modular pair property if the first
       is an atom.  Theorem 7.6(b) of [MaedaMaeda] p. 31.  (Contributed by NM,
       22-Jun-2004.)  (New usage is discouraged.) $)
    atmd $p |- ( ( A e. HAtoms /\ B e. CH ) -> A MH B ) $=
      ( vx cat wcel cv cmd wbr cch wral atdmd ralrimiva wb atelch mddmd2 mpbird
      cdmd syl breq2 rspcv mpan9 ) ADEZACFZGHZCIJZBIEABGHZUBUEAUCQHZCIJZUBUGCIA
      UCKLUBAIEUEUHMANCAORPUDUFCBIUCBAGSTUA $.
  $}

  $( Two Hilbert lattice elements have the dual modular pair property if the
     second is an atom.  Part of Exercise 6 of [Kalmbach] p. 103.  (Contributed
     by NM, 22-Jun-2004.)  (New usage is discouraged.) $)
  atmd2 $p |- ( ( A e. CH /\ B e. HAtoms ) -> A MH B ) $=
    ( cch wcel cat cin c0h wceq cmd wbr chj ccv cvp atelch cvexch 3expia sylbid
    wa co wi sylbird sylan2 wn wss atnssm0 con1bid ssmd2 3com12 syl3an2 pm2.61d
    cvmd ) ACDZBEDZRZABFZGHZABIJZUNUPAABKSLJZUQABMUMULBCDZURUQTBNZULUSRURUOBLJZ
    UQABOULUSVAUQABUKPUAUBQUNUPUCBAUDZUQUNVBUPABUEUFULUMVBUQUMULUSVBUQUTUSULVBU
    QBAUGUHUIPQUJ $.

  ${
    atabs.1 $e |- A e. CH $.
    atabs.2 $e |- B e. CH $.
    $( Absorption of an incomparable atom.  Similar to Exercise 7.1 of
       [MaedaMaeda] p. 34.  (Contributed by NM, 15-Jul-2004.)
       (New usage is discouraged.) $)
    atabsi $p |- ( C e. HAtoms -> ( -. C C_ ( A vH B ) ->
                ( ( A vH C ) i^i B ) = ( A i^i B ) ) ) $=
      ( cat wcel chj co wss wn cin wceq wa inass incom cch wi c0h syl5eq ineq1i
      chjcomi chabs2i 3eqtri ineq2i eqtr2i chub1i cmd wbr atelch atmd mpan2 w3a
      chjcli mdi exp32 mp3an23 sylc mpi adantr atnssm0 mpan biimpa oveq2d chj0i
      wb syl6eq eqtrd ineq1d ex ) CFGZCABHIZJKZACHIZBLZABLZMVKVMNZVOVNVLLZBLZVP
      VSVNVLBLZLVOVNVLBOVTBVNVTBAHIZBLBWALBVLWABABDEUBUAWABPBAEDUCUDUEUFVQVRABV
      QVRACVLLZHIZAVKVRWCMZVMVKAVLJZWDABDEUGVKCQGZCVLUHUIZWEWDRZCUJVKVLQGZWGABD
      EUNZCVLUKULWFWIAQGZWGWHRWJDWFWIWKUMWGWEWDCVLAUOUPUQURUSUTVQWCASHIAVQWBSAH
      VQWBVLCLZSCVLPVKVMWLSMZWIVKVMWMVFWJVLCVAVBVCTVDADVEVGVHVITVJ $.

    $( Absorption of an incomparable atom.  (Contributed by NM, 18-Jul-2004.)
       (New usage is discouraged.) $)
    atabs2i $p |- ( C e. HAtoms -> ( -. C C_ ( A vH B ) ->
                ( ( A vH C ) i^i ( A vH B ) ) = A ) ) $=
      ( cat wcel chj co wss wn wceq chjcli atabsi chjassi chjidmi oveq1i eqtr3i
      cin sseq2i notbii chabs2i eqeq2i 3imtr3g ) CFGCAABHIZHIZJZKACHIUESZAUESZL
      CUEJZKUHALAUECDABDEMNUGUJUFUECAAHIZBHIUFUEAABDDEOUKABHADPQRTUAUIAUHABDEUB
      UCUD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Modular symmetry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d q r C $.  $d c p q r A $.  $d c p q r B $.
    mdsymlem1.1 $e |- A e. CH $.
    mdsymlem1.2 $e |- B e. CH $.
    mdsymlem1.3 $e |- C = ( A vH p ) $.
    $( Lemma for ~ mdsymi .  (Contributed by NM, 1-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem1 $p |- ( ( ( p e. CH /\ ( B i^i C ) C_ A ) /\
            ( B MH* A /\ p C_ ( A vH B ) ) ) -> p C_ A ) $=
      ( cv cch wcel cin wss wa chj co mpan2 syl6sseqr wceq mpan adantr cdmd wbr
      chub2 chjcomi sseq2i biimpi anim12i sylib ad2ant2rl chjcl syl5eqel anim2i
      ssin chub1 ancoms dmdi mp3anl1 mpanl1 syl2anc adantlr incom oveq1i chincl
      wb chlejb1 3syl biimpa syl5eq eqtr3d adantrr sseqtrd ) DHZIJZBCKZALZMZBAU
      AUBZVLABNOZLZMMVLCBANOZKZAVMVSVLWALZVOVQVMVSMVLCLZVLVTLZMWBVMWCVSWDVMVLAV
      LNOZCVMAIJZVLWELEVLAUCPGQVSWDVRVTVLABEFUDUEUFUGVLCVTUMUHUIVPVQWAARVSVPVQM
      CBKZANOZWAAVMVQWHWARZVOVMVQMCIJZVQACLZMZWIVMWJVQVMCWEIGWFVMWEIJEAVLUJSUKZ
      TVQVMWLVMWKVQVMAWECWFVMAWELEAVLUNSGQULUOWFWJWLWIEBIJZWFWJWLWIFBACUPUQURUS
      UTVPWHARVQVPWHVNANOZAWGVNANCBVAVBVMVOWOARZVMWJVNIJZVOWPVDZWMWNWJWQFBCVCSW
      QWFWREVNAVEPVFVGVHTVIVJVK $.

    $( Lemma for ~ mdsymi .  (Contributed by NM, 1-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem2 $p |- ( ( ( p e. HAtoms /\ ( B i^i C ) C_ A ) /\
         ( B MH* A /\ p C_ ( A vH B ) ) ) -> ( B =/= 0H -> E. r e. HAtoms
         E. q e. HAtoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) ) $=
      ( cv wss cat wrex wcel wa chj co cch atelch adantlr c0h wne cdmd hatomici
      cin wbr simplll chub1 syl2an mdsymlem1 sylanl1 adantr anim1i anass anasss
      jca sylib weq oveq1 sseq2d sseq1 anbi1d anbi12d rspcev syl2anc exp32 syl5
      reximdvai ) BUAUBDJZBKZDLMFJZLNZBCUEAKZOZBAUCUFVKABPQKOZOZVKEJZVIPQZKZVQA
      KZVJOZOZELMZDLMDBHUDVPVJWCDLVPVILNZVJWCVPWDVJOZOVLVKVKVIPQZKZVKAKZVJOZOZW
      CVLVMVOWEUGVPWDVJWJVPWDOZVJOWGWHOZVJOWJWKWLVJWKWGWHVNWDWGVOVLWDWGVMVLVKRN
      ZVIRNWGWDVKSZVISVKVIUHUITTVPWHWDVLWMVMVOWHWNABCFGHIUJUKULUPUMWGWHVJUNUQUO
      WBWJEVKLEFURZVSWGWAWIWOVRWFVKVQVKVIPUSUTWOVTWHVJVQVKAVAVBVCVDVEVFVHVG $.

    $( Lemma for ~ mdsymi .  (Contributed by NM, 2-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem3 $p |- ( ( ( ( p e. HAtoms /\ -. ( B i^i C ) C_ A ) /\
             p C_ ( A vH B ) ) /\ A =/= 0H )
        -> E. r e. HAtoms E. q e. HAtoms ( p C_ ( q vH r )
             /\ ( q C_ A /\ r C_ B ) ) ) $=
      ( cv cat wcel wss wa chj co wrex cch wi adantlr cin wn c0h wb atelch mpan
      wne chjcl syl5eqel chincl sylancr chrelat2 sylancl biimpa ad2antrr sseq2i
      ssin biimpi adantl sylbir atcvat4i exp4b com34 com23 imp4b sylan2 adantrr
      syl com12 imp nssne2 adantrl atnemeq0 ancoms syl5ib adantll adantr chjcom
      syl2an sseq2d atexch syl3an1 3com13 3expa exp3a sylbid exp31 com24 anasss
      wceq syld imp3a simprl a1i simpl ad2antrl jctird jcad reximdvai mpd exp32
      ) FJZKLZBCUAZAMUBZNZXBABOPMZNZAUCUGZNZDJZXDMZXKAMUBZNZDKQZXBEJZXKOPMZXPAM
      ZXKBMZNZNZEKQZDKQXFXOXGXIXCXEXOXCXDRLZARLZXEXOUDXCXBRLZYCXBUEZYEBRLCRLYCH
      YECAXBOPZRIYDYEYGRLGAXBUHUFUIBCUJUKVHGDXDAULUMUNUOXJXNYBDKXJXKKLZXNYBXJYH
      XNNZNZXRXKXBXPOPZMZNZEKQZYBXJYIYNXFXIYIYNSZXGXCXIYOXEYIXCXINZYNYHXLYPYNSZ
      XMXLYHXKYGMZYQXLXSXKCMZNZYRXKBCUQZYSYRXSYSYRCYGXKIUPURUSUTYHYRXCXIYNYHXCY
      RXIYNSYHXCXIYRYNYHXCXIYRYNEAXKXBGVAVBVCVDVEVFVGVITTVJYJYMYAEKXHYIXPKLZYMY
      ASSZXIXFYIUUCXGXCYIUUCXEXCYINZUUBYMYAUUDUUBYMNZXQXTXCYHXNUUEXQSXCYHNZXNUU
      BYMXQUUFYMUUBXNXQUUFXRYLUUBXNXQSZSUUFUUBYLXRUUGUUFUUBYLXRUUGSUUFUUBNZYLNZ
      XRXNXQUUIXRXNNZXPXKUAUCWJZXQUUHUUJUUKSZYLYHUUBUULXCUUJXPXKUGZYHUUBNUUKXRX
      MUUMXLXPXKAVKVLUUBYHUUMUUKUDXPXKVMVNVOVPVQUUHYLUUKXQSZUUHYLXKXPXBOPZMZUUN
      UUHYKUUOXKXCUUBYKUUOWJZYHXCYEXPRLZUUQUUBYFXPUEZXBXPVRVSTVTUUHUUPUUKXQXCYH
      UUBUUPUUKNXQSZUUBYHXCUUTUUBUURYHXCUUTUUSXPXKXBWAWBWCWDWEWFVJWKWEWGWHWLWHV
      EWIUUDUUEXRXSUUEXRSUUDUUBXRYLWMWNYIXSXCXLXSYHXMXLYTXSUUAXSYSWOUTWPUSWQWRW
      ETTTWSWTXAWSWT $.

    $( Lemma for ~ mdsymi .  This is the forward direction of Lemma 4(i) of
       [Maeda] p. 168.  (Contributed by NM, 2-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem4 $p |- ( p e. HAtoms -> ( ( B MH* A /\
          ( ( A =/= 0H /\ B =/= 0H ) /\ p C_ ( A vH B ) ) ) -> E. q e. HAtoms
              E. r e. HAtoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) ) $=
      ( cv cat c0h wne wa chj co wss wrex wi exp31 wcel wbr cin mdsymlem2 com4t
      cdmd ex com23 imp44 com3l wn mdsymlem3 anasss com3r ancoms adantlr adantl
      a1d pm2.61d rexcom syl6ib ) FJZKUAZBAUFUBZALMZBLMZNVBABOPQZNZNZVBEJZDJZOP
      QVJAQVKBQNNZEKRDKRZVLDKREKRVCBCUCAQZVIVMSVIVCVNVMVDVEVFVGVCVNVMSSZVDVFVGV
      OSSVEVDVGVFVOVDVGVFVOSVCVNVDVGNZVFVMVCVNVPVFVMSABCDEFGHIUDTUEUGUHURUIUJVI
      VCVNUKZVMVHVCVQVMSSZVDVEVGVRVFVGVEVRVCVQVGVENZVMVCVQVSVMVCVQNVGVEVMABCDEF
      GHIULUMTUNUOUPUQUJUSVLDEKKUTVA $.

    $( Lemma for ~ mdsymi .  (Contributed by NM, 2-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem5 $p |- ( ( q e. HAtoms /\ r e. HAtoms ) -> ( -. q = p ->
                    ( ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ->
                    ( ( ( c e. CH /\ A C_ c ) /\ p e. HAtoms ) ->
                    ( p C_ c -> p C_ ( ( c i^i B ) vH A ) ) ) ) ) ) $=
      ( cv wcel wa cch wss chj co wi adantrl adantrr cat wceq wn cin w3a c0h wb
      df-ne atnemeq0 syl5bbr anbi2d 3adant3 atelch atexch syl3an1 sylbid 3com23
      wne exp3a 3expa adantrd imp32 simplrl anim1i ancoms chub2 mpan sstr chub1
      sylan2 mpan2 anim12i anandirs adantll chjcl syl3an3 adantr chlejb2 biimpa
      chlub mpbid sseqtrd exp45 anasss syl2an adantlr syl7 imp44 sstrd ad2antlr
      ad2ant2lr simplrr adantl ssind chincl chlej1 syl3an2 3comr chlej2 mp3anl2
      ex sylanl2 adantllr sstr2 syl5com chjcom ad2antrr sseq1d sylibrd ad2antrl
      syld exp32 sylan imp31 mpd exp4d com34 imp4c com24 ) EKZUALZDKZUALZMZGKZN
      LZAYEOZMFKZUALZMYHXTYBPQZOZXTAOZYBBOZMZMZXTYHUBUCZYHYEOZYHYEBUDZAPQZOZRZY
      DYFYGYIYOYPUUARRZYDYFYIYGUUBYDYFYIYGUUBRYDYFYIMZMZYGYOYPUUAUUDYGYOYPMZMZY
      QYTUUDUUFYQMZMZYBYROZYTUUHYBYEBUUHYBXTYHPQZYEUUDUUFYBUUJOZYQUUDUUEUUKYGUU
      DYOYPUUKUUDYKYPUUKRZYNYDYIYKUULRZYFYAYCYIUUMYAYIYCUUMYAYIYCUEZYKYPUUKUUNY
      KYPMZYKXTYHUDUFUBZMZUUKYAYIUUOUUQUGYCYAYIMZYPUUPYKYPXTYHURUURUUPXTYHUHXTY
      HUIUJUKULYAXTNLZYIYCUUQUUKRXTUMZXTYHYBUNUOUPUSUQUTSVAVBSTUUDYGUUEYQUUJYEO
      ZUUEYLUUDYGYQUVARZYKYLYMYPVCYAUUCYGYLUVBRRZYCYAUUSYHNLZYFMZUVCUUCUUTYIYFU
      VEYIUVDYFYHUMVDVEUUSUVDYFUVCUUSUVDMZYFMZYGYLYQUVAUVGYGYLYQMZMMUUJYEAPQZYE
      UVGUVHUUJUVIOZYGUVGUVHMXTUVIOZYHUVIOZMZUVJYFUVHUVMUVFUVHYFUVMYLYQYFUVMYLY
      FMUVKYQYFMUVLYFYLAUVIOZUVKANLZYFUVNHAYEVFVGXTAUVIVHVJYFYQYEUVIOZUVLYFUVOU
      VPHYEAVIVKYHYEUVIVHVJVLVMVEVNUVGUVMUVJUGZUVHUUSUVDYFUVQYFUUSUVDUVINLZUVQY
      FUVOUVRHYEAVOVKXTYHUVIVTVPUTVQWASYFYGUVIYEUBZUVFUVHYFYGUVSUVOYFYGUVSUGHAY
      EVRVGVSWKWBWCWDWEWFWGWHWIUUGYMUUDUUEYMYGYQYKYLYMYPWLWJWMWNUUDUUFUUIYTRZYQ
      UUDUUEUVTYGUUDYOUVTYPUUDYKYNUVTUUDYKMYLUVTYMUUDYKYLUVTYDYFYKYLUVTRRZYIYDU
      USYBNLZMZYFUWAYAUUSYCUWBUUTYBUMVLUWCYFMZYKYLUVTUWDYKYLMMUUIYJYSOZYTUWDYLU
      UIUWERYKUWDYLMZUUIYBXTPQZYRXTPQZOZUWEUWDUUIUWIRZYLUUSUWBYFUWJUWBYFUUSUWJY
      FUWBYRNLZUUSUWJYFBNLUWKIYEBWOVKZUWBUWKUUSUEUUIUWIYBYRXTWPXAWQWRUTVQUWFUWI
      UWGYSOZUWEUWFUWHYSOZUWIUWMUUSYFYLUWNUWBYFUUSUWKYLUWNUWLUUSUVOUWKYLUWNHXTA
      YRWSWTXBXCUWGUWHYSXDXEUWFYJUWGYSUWCYJUWGUBYFYLXTYBXFXGXHXIXKSYKUWEYTRUWDY
      LYHYJYSXDXJXKXLXMTXNTWDTSTXOXLXPXLXQXRXS $.

    $( Lemma for ~ mdsymi .  This is the converse direction of Lemma 4(i) of
       [Maeda] p. 168, and is based on the proof of Theorem 1(d) to (e) of
       [Maeda] p. 167.  (Contributed by NM, 2-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem6 $p |- ( A. p e. HAtoms ( p C_ ( A vH B ) ->
      E. q e. HAtoms E. r e. HAtoms ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) )
        )
                   -> B MH* A ) $=
      ( vc cv chj co wss wa cat wi wral cch wcel wrex cin chjcomi sseq2i anbi2i
      cdmd wbr ssin bitri mdsymlem5 sseq1 chincl mpan2 chub2 sylancr sstr2 syl5
      weq syl6bi imp3a a1i com13 adantrr ad2ant2r adantll com12 exp3a rexlimivv
      pm2.61d2 imim2d com34 imp4b syl5bir ex ralimdva wb chjcl sylancl chrelat3
      chjcli syl2anc adantr sylibrd com3r ralrimiv dmdbr2 mp2an sylibr ) FKZABL
      MZNZWIEKZDKZLMNZWLANZWMBNZOZOZDPUAEPUAZQZFPRZAJKZNZXBBALMZUBZXBBUBZALMZNZ
      QZJSRZBAUFUGZXAXIJSXBSTZXCXAXHXLXCXAXHQXLXCOZXAWIXENZWIXGNZQZFPRZXHXMWTXP
      FPXMWIPTZOZWTXPXNWIXBNZWKOZXSWTOXOYAXTWIXDNZOXNWKYBXTWJXDWIABGHUCUDUEWIXB
      XDUHUIXSWTXTWKXOXSWTWKXTXOXSWSXTXOQZWKWSXSYCWRXSYCQZEDPPWLPTWMPTOEFURZWRY
      DQABCDEFJGHIUJYEWRXSYCWRXSOYEYCWQXSYEYCQZWNWOXMYFWPXRWOXLYFXCXTYEWOXLOZXO
      YEYGXOQQXTYEWOXLXOYEWOWIANZXLXOQWLWIAUKXLAXGNZYHXOXLASTZXFSTZYIGXLBSTZYKH
      XBBULUMZAXFUNUOWIAXGUPUQUSUTVAVBVCVDVEVFVGVIVHVFVJVKVLVMVNVOXLXHXQVPZXCXL
      XESTZXGSTZYNXLXDSTYOBAHGVTXBXDULUMXLYKYJYPYMGXFAVQVRFXEXGVSWAWBWCVNWDWEYL
      YJXKXJVPHGJBAWFWGWH $.

    $( Lemma for ~ mdsymi .  Lemma 4(i) of [Maeda] p. 168.  Note that Maeda's
       1965 definition of dual modular pair has reversed arguments compared to
       the later (1970) definition given in Remark 29.6 of [MaedaMaeda] p. 130,
       which is the one that we use.  (Contributed by NM, 3-Jul-2004.)
       (New usage is discouraged.) $)
    mdsymlem7 $p |- ( ( A =/= 0H /\ B =/= 0H ) ->
                    ( B MH* A <->
   A. p e. HAtoms ( p C_ ( A vH B ) -> E. q e. HAtoms E. r e. HAtoms
            ( p C_ ( q vH r ) /\ ( q C_ A /\ r C_ B ) ) ) ) ) $=
      ( c0h wne wa cdmd wbr cv chj co wss cat wrex wi wral wcel mdsymlem4 exp4d
      com13 ralrimdv mdsymlem6 impbid1 ) AJKBJKLZBAMNZFOZABPQRZULEOZDOZPQRUNARU
      OBRLLDSTESTZUAZFSUBUJUKUQFSULSUCZUKUJUQURUKUJUMUPABCDEFGHIUDUEUFUGABCDEFG
      HIUHUI $.

    $( Lemma for ~ mdsymi .  Lemma 4(ii) of [Maeda] p. 168.  (Contributed by
       NM, 3-Jul-2004.)  (New usage is discouraged.) $)
    mdsymlem8 $p |- ( ( A =/= 0H /\ B =/= 0H ) -> ( B MH* A <-> A MH* B ) ) $=
      ( vq vr c0h wne wa cv chj co wss cat wrex wb wcel wi wral cdmd wbr sseq2i
      chjcomi cch atelch chjcom syl2an sseq2d ancom a1i anbi12d 2rexbiia rexcom
      wceq bitri imbi12i ralbii mdsymlem7 eqid ancoms 3bitr4d ) AJKZBJKZLZDMZAB
      NOZPZVHHMZIMZNOZPZVKAPZVLBPZLZLZIQRHQRZUAZDQUBZVHBANOZPZVHVLVKNOZPZVPVOLZ
      LZHQRIQRZUAZDQUBZBAUCUDABUCUDZWAWJSVGVTWIDQVJWCVSWHVIWBVHABEFUFUEVSWGIQRH
      QRWHVRWGHIQQVKQTZVLQTZLZVNWEVQWFWNVMWDVHWLVKUGTVLUGTVMWDUQWMVKUHVLUHVKVLU
      IUJUKVQWFSWNVOVPULUMUNUOWGHIQQUPURUSUTUMABCIHDEFGVAVFVEWKWJSBABVHNOZHIDFE
      WOVBVAVCVD $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    mdsym.1 $e |- A e. CH $.
    mdsym.2 $e |- B e. CH $.
    $( M-symmetry of the Hilbert lattice.  Lemma 5 of [Maeda] p. 168.
       (Contributed by NM, 3-Jul-2004.)  (New usage is discouraged.) $)
    mdsymi $p |- ( A MH B <-> B MH A ) $=
      ( vx cort cfv c0h wceq cmd wbr wb wss wa chil fveq2 pjococi choc0 mp3an12
      chssii 3eqtr3g syl5sseqr cch wcel ssmd1 ssmd2 jca pm5.1 wo wn wne neanior
      3syl cdmd cv chj choccli eqid mdsymlem8 mddmd mp2an 3bitr4g sylbir ecase3
      co ) BFGZHIZAFGZHIZABJKZBAJKZLZVGABMZVJVKNZVLVGOABACTVGVFFGHFGZBOVFHFPBDQ
      RUAUBVMVJVKAUCUDZBUCUDZVMVJCDABUESVPVQVMVKCDABUFSUGVJVKUHZUMVIBAMZVNVLVIO
      BABDTVIVHFGVOAOVHHFPACQRUAUBVSVJVKVQVPVSVJDCBAUFSVQVPVSVKDCBAUESUGVRUMVGV
      IUIUJVFHUKVHHUKNZVLVFHVHHULVTVHVFUNKZVFVHUNKZVJVKVFVHVFEUOUPVEZEBDUQACUQW
      CURUSVPVQVJWALCDABUTVAVQVPVKWBLDCBAUTVAVBVCVD $.
  $}

  $( M-symmetry of the Hilbert lattice.  Lemma 5 of [Maeda] p. 168.
     (Contributed by NM, 6-Jul-2004.)  (New usage is discouraged.) $)
  mdsym $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH B <-> B MH A ) ) $=
    ( cch wcel cmd wbr wb chil cif wceq breq1 breq2 bibi12d helch elimel mdsymi
    dedth2h ) ACDZBCDZABEFZBAEFZGRAHIZBEFZBUBEFZGUBSBHIZEFZUEUBEFZGABHHAUBJTUCU
    AUDAUBBEKAUBBELMBUEJUCUFUDUGBUEUBELBUEUBEKMUBUEAHCNOBHCNOPQ $.

  $( Dual M-symmetry of the Hilbert lattice.  (Contributed by NM,
     25-Jul-2007.)  (New usage is discouraged.) $)
  dmdsym $p |- ( ( A e. CH /\ B e. CH ) -> ( A MH* B <-> B MH* A ) ) $=
    ( cch wcel wa cort cfv cmd cdmd wb choccl mdsym syl2an dmdmd ancoms 3bitr4d
    wbr ) ACDZBCDZEAFGZBFGZHQZUATHQZABIQBAIQZRTCDUACDUBUCJSAKBKTUALMABNSRUDUCJB
    ANOP $.

  $( Two Hilbert lattice elements have the dual modular pair property if the
     second is an atom.  (Contributed by NM, 6-Jul-2004.)
     (New usage is discouraged.) $)
  atdmd2 $p |- ( ( A e. CH /\ B e. HAtoms ) -> A MH* B ) $=
    ( cch wcel cat wa cdmd wbr atdmd ancoms wb atelch dmdsym sylan2 mpbird ) AC
    DZBEDZFABGHZBAGHZQPSBAIJQPBCDRSKBLABMNO $.

  ${
    $d x y z w A $.  $d x y z w B $.  $d y z w C $.
    sumdmdi.1 $e |- A e. CH $.
    sumdmdi.2 $e |- B e. CH $.
    $( If the subspace sum of two Hilbert lattice elements is closed, then the
       elements are a dual modular pair.  Remark in [MaedaMaeda] p. 139.
       (Contributed by NM, 12-Jul-2004.)  (New usage is discouraged.) $)
    sumdmdii $p |- ( ( A +H B ) = ( A vH B ) -> A MH* B ) $=
      ( vx vy vz vw co wceq cv wss cin wi cch wcel wa wrex csh wb cph wral cdmd
      chj wbr ineq2 adantr wel elin cva chseli cmv ssel2 chsh shsubcl 3exp syl7
      syl exp4a com23 imp41 adantlr chil chel cheli w3a hvsubadd ax-hvcom eqcom
      eqeq1d syl6bb 3adant1 bitrd 3com23 syl3an 3expa eleq1 syl6bir mpbid simpr
      imp jca exp31 reximdvai r19.42v syl6ib reximdva ancom bitri anass rexbii2
      anbi1i syl6ibr chshii shincl sylancl ad2antrr shsel sylibrd expimpd ssrdv
      syl5bi adantl eqsstr3d chincl mpan2 chslej ad2antrl sstrd ralrimiv dmdbr2
      exp32 mp2an sylibr ) ABUAIZABUDIZJZBEKZLZXRXPMZXRAMZBUDIZLZNZEOUBZABUCUEZ
      XQYDEOXQXROPZXSYCXQYGXSQZQZXTYABUAIZYBYIXTXRXOMZYJXQYKXTJYHXOXPXRUFUGYHYK
      YJLXQYHFYKYJFKZYKPFEUHZYLXOPZQYHYLYJPZYLXRXOUIYHYMYNYOYNYLGKZHKZUJIZJZHBR
      ZGARZYHYMQZYOGHABYLCDUKUUBUUAYTGYARZYOUUBUUAGEUHZYTQZGARUUCUUBYTUUEGAUUBY
      PAPZQZYTUUDYSQZHBRUUEUUGYSUUHHBUUGYQBPZYSUUHUUGUUIQZYSQZUUDYSUUKYLYQULIZX
      RPZUUDUUJUUMYSUUBUUIUUMUUFYGXSYMUUIUUMYGYMXSUUIUUMNYGYMXSUUIUUMXSUUIQHEUH
      ZYGYMUUMBXRYQUMYGXRSPZYMUUNUUMNNXRUNZUUOYMUUNUUMYLYQXRUOUPURUQUSUTVAVBUGU
      UJYSUUMUUDTZUUJYSUULYPJZUUQUUBUUFUUIUURYSTZUUBYLVCPZUUFYPVCPZUUIYQVCPZUUS
      YGYMUUTXSYLXRVDVBYPACVEYQBDVEUUTUVBUVAUUSUUTUVBUVAVFUURYQYPUJIZYLJZYSYLYQ
      YPVGUVBUVAUVDYSTUUTUVBUVAQZUVDYRYLJYSUVEUVCYRYLYQYPVHVJYRYLVIVKVLVMVNVOVP
      UULYPXRVQVRWAVSUUJYSVTWBWCWDUUDYSHBWEWFWGYTUUEGYAAYPYAPZYTQUUFUUDQZYTQUUF
      UUEQUVFUVGYTUVFUUDUUFQUVGYPXRAUIUUDUUFWHWIWLUUFUUDYTWJWIWKWMUUBYASPZBSPYO
      UUCTYGUVHXSYMYGUUOASPUVHUUPACWNXRAWOWPWQBDWNGHYABYLWRWPWSXBWTXBXAXCXDYGYJ
      YBLZXQXSYGYAOPZBOPZUVIYGAOPZUVJCXRAXEXFDYABXGWPXHXIXLXJUVLUVKYFYETCDEABXK
      XMXN $.

    $( Commuting subspaces form a modular pair.  (Contributed by NM,
       16-Jan-2005.)  (New usage is discouraged.) $)
    cmmdi $p |- ( A C_H B -> A MH B ) $=
      ( ccm wbr cort cfv cdmd cmd cph co chj cmcm4i choccli osumcor2i sylbi cch
      wceq wcel sumdmdii syl wb mddmd mp2an sylibr ) ABEFZAGHZBGHZIFZABJFZUGUHU
      IKLUHUIMLSZUJUGUHUIEFULABCDNUHUIACOZBDOZPQUHUIUMUNUAUBARTBRTUKUJUCCDABUDU
      EUF $.

    $( Commuting subspaces form a dual modular pair.  (Contributed by NM,
       25-Apr-2006.)  (New usage is discouraged.) $)
    cmdmdi $p |- ( A C_H B -> A MH* B ) $=
      ( cort cfv ccm wbr cmd cdmd choccli cmmdi cmcm4i wcel dmdmd mp2an 3imtr4i
      cch wb ) AEFZBEFZGHTUAIHZABGHABJHZTUAACKBDKLABCDMARNBRNUCUBSCDABOPQ $.

    $( Lemma for ~ sumdmdi .  The span of vector ` C ` not in the subspace sum
       is "trimmed off."  (Contributed by NM, 18-Dec-2004.)
       (New usage is discouraged.) $)
    sumdmdlem $p |- ( ( C e. ~H /\ -. C e. ( A +H B ) ) ->
                    ( ( B +H ( span ` { C } ) ) i^i A ) = ( B i^i A ) ) $=
      ( vz vw chil wcel co wa cv wi cva wceq csh wb c0v adantr exp32 vy cph csn
      cspn cfv cin elin wrex chshii spansnsh shsel sylancr cmv cheli elspansncl
      w3a hvsubadd eqcom syl6bb syl3an 3expa shsvsi eleq1 syl5ibcom com4r imp31
      wn sylbird adantrr shscli elspansn5 ax-mp mpdd oveq2 ax-hvaddid sylan9eqr
      adantl sylan eqeq2d adantll biimpac biimparc biimpri ancoms expr ad2antrl
      sylan2 mpd ex com23 com4l imp4c exp4a exp3a rexlimdvv sylbid imp4b syl5bi
      a1d ssrdv wss shsub1 ssrin syl eqssd ) CHIZCABUBJZIVGZKZBCUCUDUEZUBJZAUFZ
      BAUFZXIUAXLXMUALZXLIXNXKIZXNAIZKXIXNXMIZXNXKAUGXFXHXOXPXQXFXOXHXPXQMZXFXO
      XNFLZGLZNJZOZGXJUHFBUHZXHXRMZXFBPIZXJPIZXOYCQBEUIZCUJZFGBXJXNUKULXFYBYDFG
      BXJXFXSBIZXTXJIZKZYBYDXPXFYKYBKZXHXQXPYLXFXHXQMXPYLXFXHXQXPYIYJYBXIXQMZYB
      XPYIYJYMYBXPYIYJYMMYBXPYIKZKZXIYJXQYOXIYJXQMYOXIKZYJXTROZXQYPYJXTXGIZYQYO
      XFYJYRMZXHYBYNXFYSYNXFYJYBYRYNXFYJYBYRMYNXFYJKZKYBXNXSUMJZXTOZYRXPYIYTUUB
      YBQZXPXNHIZYIXSHIZYTXTHIZUUCXNADUNXSBEUNZCXTUOUUDUUEUUFUPUUBYAXNOYBXNXSXT
      UQYAXNURUSUTVAYNUUBYRMYTYNUUAXGIUUBYRABXNXSADUIZYGVBUUAXTXGVCVDSVHTVEVFVI
      XIYJYRYQMMYOXIYJYRYQXGPIXIYJYRKKYQMABUUHYGVJXGCXTVKVLTVQVMYOYJYQXQMZMXIYO
      UUIYJYBYNYQXQYBYNYQKZKXNXSOZXQUUJYBUUKYIYQYBUUKQXPYIYQKYAXSXNYIUUEYQYAXSO
      UUGYQUUEYAXSRNJXSXTRXSNVNXSVOVPVRVSVTWAYNUUKXQMYBYQXPYIUUKXQYIUUKKXPXNBIZ
      XQUUKUULYIXNXSBVCWBUULXPXQXQUULXPKXNBAUGWCWDWGWEWFWHWEWSSVMWIWJTWKWLWMWJW
      KWNWOWPWJWQWRWTXFXMXLXAZXHXFBXKXAZUUMXFYEYFUUNYGYHBXJXBULBXKAXCXDSXE $.

    $( Lemma for ~ sumdmdi .  (Contributed by NM, 23-Dec-2004.)
       (New usage is discouraged.) $)
    sumdmdlem2 $p |- ( A. x e. HAtoms ( ( x vH B ) i^i ( A vH B ) ) C_
                  ( ( ( x vH B ) i^i A ) vH B ) -> ( A +H B ) = ( A vH B ) ) $=
      ( chj co cin wss cat cph wa wceq wcel wi cspn c0v ineq1d oveq1d syl6eq vy
      cv wral chil chjcli cheli wn csn cfv csh spansnsh chshii sylancl spansnid
      shsub2 sseldd ad2antrl wne df-ne spansna sylan2br oveq1 sseq12d rspcv syl
      elin cch spansnj spansnch chjcom sylan2 eqtrd mpan adantr sylibrd expdimp
      wb com12 ssid sneq fveq2d spansn0 oveq2d shs0i inss1 chub2i ssini chincli
      c0h eqssi chjcomi chabs1i eqtri mpbiri pm2.61d2 adantrr sumdmdlem shsub2i
      syl6eqss adantl sstrd sseld syl5bir mpand exp32 com34 pm2.18 syl8 pm2.43d
      syl5 ssrdv chsleji jctil eqss sylibr ) AUBZCFGZBCFGZHZXQBHZCFGZIZAJUCZBCK
      GZXRIZXRYDIZLYDXRMYCYFYEYCUAXRYDYCUAUBZXRNZYGYDNZYHYGUDNZYCYHYIOZYGXRBCDE
      UEUFYCYJYHYIUGZYIOYIYCYJYLYHYIYCYJYLYKYCYJYLLZLZYGCYGUHZPUIZKGZNZYHYIYJYR
      YCYLYJYPYQYGYJYPUJNCUJNYPYQIYGUKCEULZYPCUOUMYGUNUPUQYRYHLYGYQXRHZNYNYIYGY
      QXRVFYNYTYDYGYNYTYQBHZCFGZYDYCYJYTUUBIZYLYCYJLYGQMZUUCYCYJUUDUGZUUCYJUUEL
      ZYCUUCUUFYCYPCFGZXRHZUUGBHZCFGZIZUUCUUFYPJNZYCUUKOUUEYJYGQURUULYGQUSYGUTV
      AYBUUKAYPJXPYPMZXSUUHYAUUJUUMXQUUGXRXPYPCFVBZRUUMXTUUICFUUMXQUUGBUUNRSVCV
      DVEYJUUCUUKVQUUEYJYTUUHUUBUUJYJYQUUGXRCVGNZYJYQUUGMEUUOYJLYQCYPFGZUUGCYGV
      HYJUUOYPVGNUUPUUGMYGVICYPVJVKVLVMZRYJUUAUUICFYJYQUUGBUUQRSVCVNVOVRVPUUDUU
      CCCICVSZUUDYTCUUBCUUDYTCXRHZCUUDYQCXRUUDYQCWIKGCUUDYPWICKUUDYPQUHZPUIWIUU
      DYOUUTPYGQVTWAWBTWCCYSWDTZRUUSCCXRWECCXRUURCBEDWFWGWJTUUDUUBCBHZCFGZCUUDU
      UAUVBCFUUDYQCBUVARSUVCCUVBFGCUVBCCBEDWHEWKCBEDWLWMZTVCWNWOWPYMUUBYDIYCYMU
      UBCYDYMUUBUVCCYMUUAUVBCFBCYGDEWQSUVDTCBYSBDULWRWSWTXAXBXCXDXEXFYIXGXHXJXI
      XKBCDEXLXMYDXRXNXO $.

    $( The subspace sum of two Hilbert lattice elements is closed iff the
       elements are a dual modular pair.  Theorem 2 of [Holland] p. 1519.
       (Contributed by NM, 14-Dec-2004.)  (New usage is discouraged.) $)
    sumdmdi $p |- ( ( A +H B ) = ( A vH B ) <-> A MH* B ) $=
      ( vx cph co chj wceq cdmd wbr sumdmdii cv cin wss cat wral cch wcel wb
      dmdbr4 mp2an atelch imim1i ralimi2 sylbi sumdmdlem2 syl impbii ) ABFGABHG
      ZIZABJKZABCDLULEMZBHGZUJNUNANBHGOZEPQZUKULUOERQZUPARSBRSULUQTCDEABUAUBUOU
      OERPUMPSUMRSUOUMUCUDUEUFEABCDUGUHUI $.

    $( Dual modular pair property in terms of atoms.  (Contributed by NM,
       15-Jan-2005.)  (New usage is discouraged.) $)
    dmdbr4ati $p |- ( A MH* B <-> A. x e. HAtoms
            ( ( x vH B ) i^i ( A vH B ) ) C_ ( ( ( x vH B ) i^i A ) vH B ) ) $=
      ( cdmd wbr cv chj co cin wss cat wral cch wcel wb dmdbr4 mp2an atelch cph
      imim1i ralimi2 sylbi wceq sumdmdlem2 sumdmdi sylib impbii ) BCFGZAHZCIJZB
      CIJZKULBKCIJLZAMNZUJUNAONZUOBOPCOPUJUPQDEABCRSUNUNAOMUKMPUKOPUNUKTUBUCUDU
      OBCUAJUMUEUJABCDEUFBCDEUGUHUI $.

    $( Dual modular pair property in terms of atoms.  (Contributed by NM,
       14-Jan-2005.)  (New usage is discouraged.) $)
    dmdbr5ati $p |- ( A MH* B <-> A. x e. HAtoms ( x C_ ( A vH B )
        -> x C_ ( ( ( x vH B ) i^i A ) vH B ) ) ) $=
      ( chj co wss cin wi cat wral wcel cch wceq wa sylancr adantr sylancl wb
      cdmd wbr cv atelch dmdi4 mp3an12 com12 syl5 ralrimiv cph wn chjcom ineq1d
      a1dd chjcomi ineq2i syl6eqr sseq2i notbii atabs2i imp eqtr3d chjcl chincl
      sylan2b chub2 eqsstrd ex biantrud pm4.83 ralbiia sumdmdlem2 sylbi sumdmdi
      syl6bb sylib impbii chub2i biantru chjcli chlub syl5bb ssid biantrur ssin
      mp3an23 bitri biimpa inss1 jctil eqss sylibr sseq1d mpan2 mp3an2 pm5.74da
      mpdan bitrd bitr4d syl ) BCUAUBZAUCZBCFGZHZXBCFGZXCIZXEBIZCFGZHZJZAKLZXDX
      BXHHZJZAKLXAXKXAXJAKXAXBKMZXIXDXNXBNMZXAXIXBUDZXOXAXIBNMZCNMZXOXAXIJDEBCX
      BUEUFUGUHUNUIXKBCUJGXCOZXAXKXIAKLXSXJXIAKXNXJXJXDUKZXIJZPXIXNYAXJXNXTXIXN
      XTPZXFCXHYBCXBFGZCBFGZIZXFCXNYEXFOXTXNYEXEYDIXFXNYCXEYDXNXRXOYCXEOEXPCXBU
      LQUMXCYDXEBCDEUOZUPUQRXTXNXBYDHZUKZYECOZXDYGXCYDXBYFURUSXNYHYICBXBEDUTVAV
      EVBXNCXHHZXTXNXRXGNMZYJEXNXENMZXQYKXNXOXRYLXPEXBCVCZSDXEBVDZSCXGVFZQRVGVH
      VIXDXIVJVOVKABCDEVLVMBCDEVNVPVQXJXMAKXNXOXJXMTXPXOXDXIXLXOXDPZXIXEXHHZXLY
      PXFXEXHYPXFXEHZXEXFHZPXFXEOYPYSYRXOXDYSXOXDXEXCHZYSXDXDCXCHZPZXOYTUUAXDCB
      EDVRVSXOXRXCNMUUBYTTEBCDEVTXBCXCWAWFWBYTXEXEHZYTPYSUUCYTXEWCWDXEXEXCWEWGV
      OWHXEXCWIWJXFXEWKWLWMXOXLYQTXDXOXLXLYJPZYQXOYJXLXOXRYKYJEXOYLXQYKXOXRYLEY
      MWNDYNSZYOQVIXOXHNMZUUDYQTZXOYKXRUUFUUEEXGCVCSXOXRUUFUUGEXBCXHWAWOWQWRRWS
      WPWTVKWG $.

    $( Dual modular pair property in terms of atoms.  The modular law takes the
       form of the shearing identity.  (Contributed by NM, 18-Jan-2005.)
       (New usage is discouraged.) $)
    dmdbr6ati $p |- ( A MH* B <-> A. x e. HAtoms
            ( ( A vH B ) i^i x ) = ( ( ( ( x vH B ) i^i A ) vH B ) i^i x ) ) $=
      ( cdmd wbr chj co cv cin wceq cat wral cch wcel wb dmdbr3 incom wss mp2an
      wa inass 3eqtri chabs2 mpan2 ineq2d syl5reqr adantr ineq1 adantl ralimiaa
      eqtr4d sylbi atelch imim1i ralimi2 syl wi inss1 sseq1 mpbiri df-ss biimpi
      syl5eq sseq1d syl5ibcom ralimi dmdbr5ati sylibr impbii ) BCFGZBCHIZAJZKZV
      NCHIZBKCHIZVNKZLZAMNZVLVSAONZVTVLVQVPVMKZLZAONZWABOPCOPZVLWDQDEABCRUAWCVS
      AOVNOPZWCUBVOWBVNKZVRWFVOWGLWCWFWGVMVNVPKZKZVOWIWHVMKVNWBKWGVMWHSVNVPVMUC
      VNWBSUDWFWHVNVMWFWEWHVNLEVNCUEUFUGUHUIWCVRWGLWFVQWBVNUJUKUMULUNVSVSAOMVNM
      PWFVSVNUOUPUQURVTVNVMTZVNVQTZUSZAMNVLVSWLAMVSVOVQTZWJWKVSWMVRVQTVQVNUTVOV
      RVQVAVBWJVOVNVQWJVOVNVMKZVNVMVNSWJWNVNLVNVMVCVDVEVFVGVHABCDEVIVJVK $.

    $( Dual modular pair property in terms of atoms.  (Contributed by NM,
       18-Jan-2005.)  (New usage is discouraged.) $)
    dmdbr7ati $p |- ( A MH* B <-> A. x e. HAtoms ( ( A vH B ) i^i x )
        C_ ( ( ( x vH B ) i^i A ) vH B ) ) $=
      ( cdmd wbr chj co cv cin wss cat wral dmdbr6ati inss1 sseq1 mpbiri ralimi
      wceq sylbi wi sseqin2 biimpi sseq1d biimpcd dmdbr5ati sylibr impbii ) BCF
      GZBCHIZAJZKZULCHIBKCHIZLZAMNZUJUMUNULKZTZAMNUPABCDEOURUOAMURUOUQUNLUNULPU
      MUQUNQRSUAUPULUKLZULUNLZUBZAMNUJUOVAAMUSUOUTUSUMULUNUSUMULTULUKUCUDUEUFSA
      BCDEUGUHUI $.
  $}

  ${
    mdoc1.1 $e |- A e. CH $.
    $( Orthocomplements form a modular pair.  (Contributed by NM,
       29-Apr-2006.)  (New usage is discouraged.) $)
    mdoc1i $p |- A MH ( _|_ ` A ) $=
      ( cort cfv ccm wbr cmd cmidi cmcm2ii choccli cmmdi ax-mp ) AACDZEFAMGFAAB
      BABHIAMBABJKL $.

    $( Orthocomplements form a modular pair.  (Contributed by NM,
       29-Apr-2006.)  (New usage is discouraged.) $)
    mdoc2i $p |- ( _|_ ` A ) MH A $=
      ( cort cfv cmd choccli mdoc1i ococi breqtri ) ACDZJCDAEJABFGABHI $.

    $( Orthocomplements form a dual modular pair.  (Contributed by NM,
       29-Apr-2006.)  (New usage is discouraged.) $)
    dmdoc1i $p |- A MH* ( _|_ ` A ) $=
      ( cort cfv ccm wbr cdmd cmidi cmcm2ii choccli cmdmdi ax-mp ) AACDZEFAMGFA
      ABBABHIAMBABJKL $.

    $( Orthocomplements form a dual modular pair.  (Contributed by NM,
       29-Apr-2006.)  (New usage is discouraged.) $)
    dmdoc2i $p |- ( _|_ ` A ) MH* A $=
      ( cort cfv cdmd choccli dmdoc1i ococi breqtri ) ACDZJCDAEJABFGABHI $.
  $}

  ${
    mdcompl.1 $e |- A e. CH $.
    mdcompl.2 $e |- B e. CH $.
    $( A condition equivalent to the modular pair property.  Part of proof of
       Theorem 1.14 of [MaedaMaeda] p. 4.  (Contributed by NM, 29-Apr-2006.)
       (New usage is discouraged.) $)
    mdcompli $p |- ( A MH B <-> ( A i^i ( _|_ ` ( A i^i B ) ) ) MH
                  ( B i^i ( _|_ ` ( A i^i B ) ) ) ) $=
      ( cin cort cfv cmd wbr cdmd wss chj co chincli mdoc1i dmdoc2i ssid chjcli
      wb chil chssii chjoi sseqtr4i choccli mdslmd1i mp4an ) ABEZUGFGZHIUHUGJIU
      GUGKABLMZUGUHLMZKABHIAUHEBUHEHISUGABCDNZOUGUKPUGQUITUJUIABCDRUAUGUKUBUCUG
      UHABUKUGUKUDCDUEUF $.

    $( A condition equivalent to the dual modular pair property.  (Contributed
       by NM, 29-Apr-2006.)  (New usage is discouraged.) $)
    dmdcompli $p |- ( A MH* B <-> ( A i^i ( _|_ ` ( A i^i B ) ) ) MH*
                  ( B i^i ( _|_ ` ( A i^i B ) ) ) ) $=
      ( cin cort cfv cmd wbr cdmd wss chj co chincli mdoc1i dmdoc2i ssid chjcli
      wb chil chssii chjoi sseqtr4i choccli mdsldmd1i mp4an ) ABEZUGFGZHIUHUGJI
      UGUGKABLMZUGUHLMZKABJIAUHEBUHEJISUGABCDNZOUGUKPUGQUITUJUIABCDRUAUGUKUBUCU
      GUHABUKUGUKUDCDUEUF $.
  $}

  ${
    $d x y A $.  $d x y B $.
    mddmdin0.1 $e |- A e. CH $.
    mddmdin0.2 $e |- B e. CH $.
    mddmdin0.3 $e |- A. x e. CH A. y e. CH ( ( x MH* y /\ ( x i^i y ) = 0H ) ->
                     x MH y ) $.
    $( If dual modular implies modular whenever meet is zero, then dual modular
       implies modular for arbitrary lattice elements.  This theorem is needed
       for the remark after Lemma 7 of [Holland] p. 1524 to hold.  (Contributed
       by NM, 29-Apr-2006.)  (New usage is discouraged.) $)
    mddmdin0i $p |- ( A MH* B -> A MH B ) $=
      ( cin cdmd wbr cmd c0h wceq chincli cv wa wi cch wral wcel inindir eqtr3i
      cfv chocini choccli breq1 ineq1 eqeq1d anbi12d imbi12d breq2 ineq2 rspc2v
      cort mp2an ax-mp mpan2 dmdcompli mdcompli 3imtr4i ) CCDHZUNUCZHZDVBHZIJZV
      CVDKJZCDIJCDKJVEVCVDHZLMZVFVAVBHVGLCDVBUAVACDEFNZUDUBAOZBOZIJZVJVKHZLMZPZ
      VJVKKJZQZBRSARSZVEVHPZVFQZGVCRTVDRTVRVTQCVBEVAVIUEZNDVBFWANVQVTVCVKIJZVCV
      KHZLMZPZVCVKKJZQABVCVDRRVJVCMZVOWEVPWFWGVLWBVNWDVJVCVKIUFWGVMWCLVJVCVKUGU
      HUIVJVCVKKUFUJVKVDMZWEVSWFVFWHWBVEWDVHVKVDVCIUKWHWCVGLVKVDVCULUHUIVKVDVCK
      UKUJUMUOUPUQCDEFURCDEFUSUT $.
  $}

  ${
    $d x y z w A $.  $d x y z w B $.  $d x y z w C $.
    cdjreu.1 $e |- A e. SH $.
    cdjreu.2 $e |- B e. SH $.
    $( A member of the sum of disjoint subspaces has a unique decomposition.
       Part of Lemma 5 of [Holland] p. 1520.  (Contributed by NM,
       20-May-2005.)  (New usage is discouraged.) $)
    cdjreui $p |- ( ( C e. ( A +H B ) /\ ( A i^i B ) = 0H ) ->
                 E! x e. A E. y e. B C = ( x +h y ) ) $=
      ( vz vw co wcel c0h wceq wa cv cva wrex wi chil sheli cph cin wral shseli
      weq wreu biimpi reeanv eqtr2 cmv wb anim12i hvaddsub4 syl2an an4s adantll
      shsubcl mp3an1 ancoms eleq1 syl5ibrcom adantl adantr jctild eleq2 syl5bbr
      csh elin ad2antrr sylibd elch0 hvsubeq0 syl5bb ad2antlr sylbid rexlimdvva
      c0v syl5 syl5bir ralrimivva oveq1 eqeq2d rexbidv oveq2 syl6bb reu4 sylibr
      cbvrexv ) ECDUAJKZCDUBZLMZNEAOZBOZPJZMZBDQZACQZWPEHOZIOZPJZMZIDQZNZAHUEZR
      ZHCUCACUCZNWPACUFWIWQWKXFWIWQABCDEFGUDUGWKXEAHCCXCWOXANZIDQBDQWKWLCKZWRCK
      ZNZNZXDWOXABIDDUHXKXGXDBIDDXGWNWTMZXKWMDKZWSDKZNZNZXDEWNWTUIXPXLWLWRUJJZW
      SWMUJJZMZXDXJXOXLXSUKZWKXHXMXIXNXTXHXMNWLSKZWMSKZNWRSKZWSSKZNXTXIXNNXHYAX
      MYBWLCFTZWMDGTULXIYCXNYDWRCFTZWSDGTULWLWMWRWSUMUNUOUPXPXSXQLKZXDXPXSXQCKZ
      XQDKZNZYGXJXOXSYJRWKXJXONXSYIYHXOXSYIRXJXOYIXSXRDKZXNXMYKDVGKXNXMYKGWSWMD
      UQURUSXQXRDUTVAVBXJYHXOCVGKXHXIYHFWLWRCUQURVCVDUPWKYJYGUKXJXOYJXQWJKWKYGX
      QCDVHWJLXQVEVFVIVJXJYGXDUKZWKXOXHYAYCYLXIYEYFYGXQVQMYAYCNXDXQVKWLWRVLVMUN
      VNVJVOVRVPVSVTULWPXBAHCXDWPEWRWMPJZMZBDQXBXDWOYNBDXDWNYMEWLWRWMPWAWBWCYNX
      ABIDBIUEYMWTEWMWSWRPWDWBWHWEWFWG $.
  $}

  ${
    $d x y z w A $.  $d x y z w v B $.
    cdj1.1 $e |- A e. SH $.
    cdj1.2 $e |- B e. SH $.
    $( Two ways to express " ` A ` and ` B ` are completely disjoint
       subspaces."  (1) => (2) in Lemma 5 of [Holland] p. 1520.  (Contributed
       by NM, 21-May-2005.)  (New usage is discouraged.) $)
    cdj1i $p |- ( E. w e. RR ( 0 < w /\ A. y e. A A. v e. B
      ( ( normh ` y ) + ( normh ` v ) ) <_ ( w x. ( normh ` ( y +h v ) ) ) ) ->
                    E. x e. RR ( 0 < x /\ A. y e. A A. z e. B
                    ( ( normh ` y ) = 1 -> x <_ ( normh ` ( y -h z ) ) ) ) ) $=
      ( cc0 wbr cno cfv co cle wa c1 wceq cr wcel cv clt caddc cva cmul wral wi
      cmv wrex cdiv wne gt0ne0 rereccl syldan adantrr recgt0 csm 1re a1i neg1cn
      cneg cc sheli hvmulcl sylancr normcl adantl readdcl adantr hvsubcl syl2an
      chil syl remulcl sylan2 anassrs normge0 addge01 mpan syl2anc ad2antlr csh
      wb biimpa shmulcl mp3an12 fveq2 oveq2d oveq2 fveq2d breq12d imp ad2ant2lr
      rspcv oveq1 ad2antll hvsubval adantll 3brtr4d ex adantllr simplll simpllr
      eqcoms letrd lediv1 mp3an1 syl12anc recnd recn ad3antrrr ad2antrr breqtrd
      sylibd divcan3d exp43 com23 ralrimdv ralimdva jca32 breq2 imbi2d 2ralbidv
      impr breq1 anbi12d rspcev syl6 rexlimiv ) JDUAZUBKZBUAZLMZEUAZLMZUCNZYJYL
      YNUDNZLMZUENZOKZEGUFZBFUFZPZJAUAZUBKZYMQRZUUDYLCUAZUHNZLMZOKZUGZCGUFBFUFZ
      PZASUIZDSYJSTZUUCQYJUJNZSTZJUUPUBKZUUFUUPUUIOKZUGZCGUFZBFUFZPZPZUUNUUOUUC
      UVDUUOUUCPUUQUURUVBUUOYKUUQUUBUUOYKYJJUKZUUQYJULZYJUMUNUOUUOYKUURUUBYJUPU
      OUUOYKUUBUVBUUOYKPZUUAUVABFUVGYLFTZPZUUAUUTCGUVIUUGGTZUUAUUTUVIUVJUUAUUFU
      USUVIUVJPZUUAUUFPZPUUPYJUUIUENZYJUJNZUUIOUVKUVLUUPUVNOKZUVKUVLQUVMOKZUVOU
      UOUVHUVJUVLUVPUGYKUUOUVHPZUVJPZUVLUVPUVRUVLPZQQQVAZUUGUQNZLMZUCNZUVMQSTZU
      VSURUSUVRUWCSTZUVLUVRUWDUWBSTZUWEURUVJUWFUVQUVJUWAVLTZUWFUVJUVTVBTZUUGVLT
      ZUWGUTUUGGIVCZUVTUUGVDVEZUWAVFVMZVGQUWBVHVEVIUVRUVMSTZUVLUUOUVHUVJUWMUVHU
      VJPZUUOUUISTZUWMUWNUUHVLTZUWOUVHYLVLTZUWIUWPUVJYLFHVCZUWJYLUUGVJVKZUUHVFZ
      VMZYJUUIVNZVOVPVIUVJQUWCOKZUVQUVLUVJUWFJUWBOKZUXCUWLUVJUWGUXDUWKUWAVQVMUW
      FUXDUXCUWDUWFUXDUXCWCURQUWBVRVSWDVTWAUVSYMUWBUCNZYJYLUWAUDNZLMZUENZUWCUVM
      OUVJUUAUXEUXHOKZUVQUUFUVJUUAUXIUVJUWAGTZUUAUXIUGGWBTUWHUVJUXJIUTUVTUUGGWE
      WFYTUXIEUWAGYNUWARZYPUXEYSUXHOUXKYOUWBYMUCYNUWALWGWHUXKYRUXGYJUEUXKYQUXFL
      YNUWAYLUDWIWJWHWKWNVMWLWMUUFUWCUXERZUVRUUAUXLQYMQYMUWBUCWOXDWPUVRUVMUXHRZ
      UVLUVHUVJUXMUUOUWNUUIUXGYJUEUWNUUHUXFLUVHUWQUWIUUHUXFRUVJUWRUWJYLUUGWQVKW
      JWHWRVIWSXEWTXAUVKUWMUUOYKUVPUVOWCZUVKUUOUWOUWMUUOYKUVHUVJXBZUVKUWPUWOUVH
      UVJUWPUVGUWSWRUWTVMUXBVTUXOUUOYKUVHUVJXCUWDUWMUVGUXNURQUVMYJXFXGXHXNWLUVK
      UVNUUIRUVLUVKUUIYJUVHUVJUUIVBTUVGUWNUUIUXAXIWRUUOYJVBTYKUVHUVJYJXJXKUVGUV
      EUVHUVJUVFXLXOVIXMXPXQXRXSYDXTWTUUMUVCAUUPSUUDUUPRZUUEUURUULUVBUUDUUPJUBY
      AUXPUUKUUTBCFGUXPUUJUUSUUFUUDUUPUUIOYEYBYCYFYGYHYI $.

    $( A property of " ` A ` and ` B ` are completely disjoint subspaces."
       Part of Lemma 5 of [Holland] p. 1520.  (Contributed by NM,
       23-May-2005.)  (New usage is discouraged.) $)
    cdj3lem1 $p |- ( E. x e. RR ( 0 < x /\ A. y e. A A. z e. B
      ( ( normh ` y ) + ( normh ` z ) ) <_ ( x x. ( normh ` ( y +h z ) ) ) ) ->
                    ( A i^i B ) = 0H ) $=
      ( cc0 wbr cno cfv caddc co cva cmul cle wa wceq wcel c2 vw cv clt cin c0h
      wral cr wss c0v c1 cneg csm wi csh cc neg1cn shmulcl mp3an12 anim2i sylbi
      elin fveq2 oveq1d oveq1 fveq2d oveq2d breq12d oveq2 rspc2v adantl chil wb
      syl shincli sheli normneg normcl recnd 2timesd eqtr4d hvnegid syl6eq recn
      norm0 mul01d sylan9eqr 2cn mul01i syl6eqr letri3 sylancl normge0 biantrud
      0re 2re 2pos pm3.2i lemul2 mp3an23 3bitr2rd norm-i sylan2 sylibd impancom
      bitrd elch0 syl6ibr ssrdv ex shle0 ax-mp syl6ib adantld rexlimiv ) HAUBZU
      CIZBUBZJKZCUBZJKZLMZXOXQXSNMZJKZOMZPIZCEUFBDUFZQDEUDZUERZAUGXOUGSZYFYHXPY
      IYFYGUEUHZYHYIYFYJYIYFQZUAYGUEYKUAUBZYGSZYLUIRZYLUESYIYMYFYNYIYMQYFYLJKZU
      JUKZYLULMZJKZLMZXOYLYQNMZJKZOMZPIZYNYMYFUUCUMZYIYMYLDSZYQESZQZUUDYMUUEYLE
      SZQUUGYLDEVAUUHUUFUUEEUNSYPUOSUUHUUFGUPYPYLEUQURUSUTYEUUCYOXTLMZXOYLXSNMZ
      JKZOMZPIBCYLYQDEXQYLRZYAUUIYDUULPUUMXRYOXTLXQYLJVBVCUUMYCUUKXOOUUMYBUUJJX
      QYLXSNVDVEVFVGXSYQRZUUIYSUULUUBPUUNXTYRYOLXSYQJVBVFUUNUUKUUAXOOUUNUUJYTJX
      SYQYLNVHVEVFVGVIVMVJYMYIYLVKSZUUCYNVLYLYGDEFGVNZVOYIUUOQZUUCTYOOMZTHOMZPI
      ZYNUUQYSUURUUBUUSPUUOYSUURRYIUUOYSYOYOLMUURUUOYRYOYOLYLVPVFUUOYOUUOYOYLVQ
      ZVRVSVTVJUUQUUBHUUSUUOYIUUBXOHOMHUUOUUAHXOOUUOUUAUIJKHUUOYTUIJYLWAVEWDWBV
      FYIXOXOWCWEWFTWGWHWIVGUUOUUTYNVLYIUUOUUTYOHRZYNUUOUVBYOHPIZHYOPIZQZUVCUUT
      UUOYOUGSZHUGSZUVBUVEVLUVAWNYOHWJWKUUOUVDUVCYLWLWMUUOUVFUVCUUTVLZUVAUVFUVG
      TUGSZHTUCIZQUVHWNUVIUVJWOWPWQYOHTWRWSVMWTYLXAXEVJXEXBXCXDYLXFXGXHXIYGUNSY
      JYHVLUUPYGXJXKXLXMXN $.
  $}

  ${
    $d x y z w v u t h A $.  $d x y z w v u t h B $.  $d x y z w v u C $.
    $d x y z w D $.
    cdj3lem2.1 $e |- A e. SH $.
    cdj3lem2.2 $e |- B e. SH $.
    ${
      $d v u t h S $.
      cdj3lem2.3 $e |- S = ( x e. ( A +H B ) |->
        ( iota_ z e. A E. w e. B x = ( z +h w ) ) ) $.
      $( Lemma for ~ cdj3i .  Value of the first-component function ` S ` .
         (Contributed by NM, 23-May-2005.)  (New usage is discouraged.) $)
      cdj3lem2 $p |- ( ( C e. A /\ D e. B /\ ( A i^i B ) = 0H ) ->
                    ( S ` ( C +h D ) ) = C ) $=
        ( wcel wceq cva co cv wrex crio rexbidv eqeq2d cin c0h w3a cfv wa eqeq1
        cph shsvai riotabidv riotaex fvmpt syl eqid oveq2 rspcev mpan2 3ad2ant2
        3adant3 wreu simp1 cdjreui sylan 3impa oveq1 riota2 syl2anc mpbid eqtrd
        wb ) FDLZGELZDEUAUBMZUCZFGNOZHUDZVNBPZCPZNOZMZCEQZBDRZFVJVKVOWAMZVLVJVK
        UEZVNDEUGOZLZWBDEFGIJUHZAVNAPZVRMZCEQZBDRWAWDHWGVNMZWIVTBDWJWHVSCEWGVNV
        RUFSUIKVTBDUJUKULURVMVNFVQNOZMZCEQZWAFMZVKVJWMVLVKVNVNMZWMVNUMWLWOCGEVQ
        GMWKVNVNVQGFNUNTUOUPUQVMVJVTBDUSZWMWNVIVJVKVLUTVJVKVLWPWCWEVLWPWFBCDEVN
        IJVAVBVCVTWMBDFVPFMZVSWLCEWQVRWKVNVPFVQNVDTSVEVFVGVH $.

      $( Lemma for ~ cdj3i .  Closure of the first-component function ` S ` .
         (Contributed by NM, 25-May-2005.)  (New usage is discouraged.) $)
      cdj3lem2a $p |- ( ( C e. ( A +H B ) /\ ( A i^i B ) = 0H ) ->
                    ( S ` C ) e. A ) $=
        ( vv vu cin wceq co wcel cfv cv wrex wa c0h cph cva shseli w3a cdj3lem2
        simp1 eqeltrd 3expa fveq2 eleq1d syl5ibr exp3a rexlimdvv syl5bi impcom
        com13 ) DEMUANZFDEUBOPZFGQZDPZUSFKRZLRZUCOZNZLESKDSURVAKLDEFHIUDURVEVAK
        LDEVEVBDPZVCEPZTZURVAVEVHURVAVHURTVAVEVDGQZDPZVFVGURVJVFVGURUEVIVBDABCD
        EVBVCGHIJUFVFVGURUGUHUIVEUTVIDFVDGUJUKULUMUQUNUOUP $.

      $( Lemma for ~ cdj3i .  The first-component function ` S ` is bounded if
         the subspaces are completely disjoint.  (Contributed by NM,
         26-May-2005.)  (New usage is discouraged.) $)
      cdj3lem2b $p |- ( E. v e. RR ( 0 < v /\ A. x e. A A. y e. B
      ( ( normh ` x ) + ( normh ` y ) ) <_ ( v x. ( normh ` ( x +h y ) ) ) ) ->
                    E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( S ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $=
        ( wbr cno cfv co cle wa cr wcel vt vh cin c0h wceq cc0 cv clt caddc cva
        cmul wral wrex cph cdj3lem1 wi shseli biimpi fveq2 oveq1d fveq2d oveq2d
        oveq1 breq12d oveq2 rspc2v cdj3lem2 3expa ad2ant2r sheli normge0 adantl
        chil syl wb normcl addge01 syl2an mpbid adantr ad2antrr readdcl hvaddcl
        remulcl sylan2 ancoms letr syl3anc mpand imp adantrl eqbrtrd syl5ibrcom
        an32s exp31 syld com14 com4t rexlimdvv syl5com ralrimdv anim2d reximdva
        com3l mpcom ) GHUCUDUEZUFEUGZUHMZAUGZNOZBUGZNOZUIPZXGXIXKUJPZNOZUKPZQMZ
        BHULAGULZRZESUMXHFUGZIOZNOZXGXTNOZUKPZQMZFGHUNPZULZRZESUMEABGHJKUOXFXSY
        HESXFXGSTZRZXRYGXHYJXRYEFYFXTYFTZYJXRYEYKXTUAUGZUBUGZUJPZUEZUBHUMUAGUMZ
        YJXRYEUPZYKYPUAUBGHXTJKUQURYJYOYQUAUBGHYOXRYJYLGTZYMHTZRZYEYTXRYJYOYEYT
        XRYLNOZYMNOZUIPZXGYNNOZUKPZQMZYJYOYEUPZUPXQUUFUUAXLUIPZXGYLXKUJPZNOZUKP
        ZQMABYLYMGHXIYLUEZXMUUHXPUUKQUULXJUUAXLUIXIYLNUSUTUULXOUUJXGUKUULXNUUIN
        XIYLXKUJVCVAVBVDXKYMUEZUUHUUCUUKUUEQUUMXLUUBUUAUIXKYMNUSVBUUMUUJUUDXGUK
        UUMUUIYNNXKYMYLUJVEVAVBVDVFYTUUFYJUUGYTUUFRZYJRZYEYOYNIOZNOZUUEQMUUOUUQ
        UUAUUEQYTXFUUQUUAUEUUFYIYTXFRUUPYLNYRYSXFUUPYLUEACDGHYLYMIJKLVGVHVAVIUU
        NYIUUAUUEQMZXFYTYIUUFUURYTYIRZUUFUURUUSUUAUUCQMZUUFUURYTUUTYIYTUFUUBQMZ
        UUTYSUVAYRYSYMVMTZUVAYMHKVJZYMVKVNVLYRUUASTZUUBSTZUVAUUTVOYSYRYLVMTZUVD
        YLGJVJZYLVPVNZYSUVBUVEUVCYMVPVNZUUAUUBVQVRVSVTUUSUVDUUCSTZUUESTZUUTUUFR
        UURUPYRUVDYSYIUVHWAYTUVJYIYRUVDUVEUVJYSUVHUVIUUAUUBWBVRVTYIYTUVKYTYIUUD
        STZUVKYTYNVMTZUVLYRUVFUVBUVMYSUVGUVCYLYMWCVRYNVPVNXGUUDWDWEWFUUAUUCUUEW
        GWHWIWJWNWKWLYOYBUUQYDUUEQYOYAUUPNXTYNIUSVAYOYCUUDXGUKXTYNNUSVBVDWMWOWP
        WQWRWSWTXDXAXBXCXE $.
    $}

    ${
      $d v u t h T $.
      cdj3lem3.3 $e |- T = ( x e. ( A +H B ) |->
        ( iota_ w e. B E. z e. A x = ( z +h w ) ) ) $.
      $( Lemma for ~ cdj3i .  Value of the second-component function ` T ` .
         (Contributed by NM, 23-May-2005.)  (New usage is discouraged.) $)
      cdj3lem3 $p |- ( ( C e. A /\ D e. B /\ ( A i^i B ) = 0H ) ->
                    ( T ` ( C +h D ) ) = D ) $=
        ( wcel cin c0h wceq cva co chil sheli cv cfv incom eqeq1i w3a wa syl2an
        ax-hvcom fveq2d 3adant3 cph wrex crio shscomi eqeq2d rexbidva riotabiia
        cmpt mpteq12i eqtr4i cdj3lem2 eqtr3d syl3an3b 3com12 ) GELZFDLZDEMZNOZF
        GPQZHUAZGOZVGVDVEEDMZNOZVJVFVKNDEUBUCVDVEVLUDGFPQZHUAZVIGVDVEVNVIOVLVDV
        EUEVMVHHVDGRLFRLVMVHOVEGEJSFDISGFUGUFUHUIACBEDGFHJIHADEUJQZATZBTZCTZPQZ
        OZBDUKZCEULZUQAEDUJQZVPVRVQPQZOZBDUKZCEULZUQKAWCWGVOWBEDJIUMWFWACEVRELZ
        WEVTBDWHVQDLZUEWDVSVPWHVRRLVQRLWDVSOWIVREJSVQDISVRVQUGUFUNUOUPURUSUTVAV
        BVC $.

      $( Lemma for ~ cdj3i .  Closure of the second-component function ` T ` .
         (Contributed by NM, 26-May-2005.)  (New usage is discouraged.) $)
      cdj3lem3a $p |- ( ( C e. ( A +H B ) /\ ( A i^i B ) = 0H ) ->
                    ( T ` C ) e. B ) $=
        ( vv vu cin wceq co wcel cfv cv wrex wa c0h cph cva shseli w3a cdj3lem3
        simp2 eqeltrd 3expa fveq2 eleq1d syl5ibr exp3a rexlimdvv syl5bi impcom
        com13 ) DEMUANZFDEUBOPZFGQZEPZUSFKRZLRZUCOZNZLESKDSURVAKLDEFHIUDURVEVAK
        LDEVEVBDPZVCEPZTZURVAVEVHURVAVHURTVAVEVDGQZEPZVFVGURVJVFVGURUEVIVCEABCD
        EVBVCGHIJUFVFVGURUGUHUIVEUTVIEFVDGUJUKULUMUQUNUOUP $.

      $( Lemma for ~ cdj3i .  The second-component function ` T ` is bounded if
         the subspaces are completely disjoint.  (Contributed by NM,
         31-May-2005.)  (New usage is discouraged.) $)
      cdj3lem3b $p |- ( E. v e. RR ( 0 < v /\ A. x e. A A. y e. B
      ( ( normh ` x ) + ( normh ` y ) ) <_ ( v x. ( normh ` ( x +h y ) ) ) ) ->
                    E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( T ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $=
        ( cno cfv co cva cmul cle wral wcel vt vh cc0 cv clt wbr caddc wrex cph
        wa cr wceq crio cmpt shscomi chil sheli ax-hvcom syl2an eqeq2d rexbidva
        riotabiia mpteq12i eqtr4i cdj3lem2b fveq2 oveq1d fveq2d oveq2d cbvral2v
        oveq1 breq12d oveq2 ralcom cc normcl syl addcom ralbidva ralbiia bitr2i
        recnd 3bitri anbi2i rexbii raleqi 3imtr4i ) UCEUDZUEUFZAUDZMNZBUDZMNZUG
        OZWHWJWLPOZMNZQOZRUFZBGSZAHSZUJZEUKUHWIFUDZINMNWHXBMNQORUFZFHGUIOZSZUJZ
        EUKUHWIWRBHSAGSZUJZEUKUHWIXCFGHUIOZSZUJZEUKUHABDCEFHGIKJIAXIWJCUDZDUDZP
        OZULZCGUHZDHUMZUNAXDWJXMXLPOZULZCGUHZDHUMZUNLAXDYAXIXQHGKJUOXTXPDHXMHTZ
        XSXOCGYBXLGTZUJXRXNWJYBXMUPTXLUPTXRXNULYCXMHKUQXLGJUQXMXLURUSUTVAVBVCVD
        VEXHXAEUKXGWTWIXGUAUDZMNZUBUDZMNZUGOZWHYDYFPOZMNZQOZRUFZUBHSUAGSYLUAGSU
        BHSZWTWRYLYEWMUGOZWHYDWLPOZMNZQOZRUFABUAUBGHWJYDULZWNYNWQYQRYRWKYEWMUGW
        JYDMVFVGYRWPYPWHQYRWOYOMWJYDWLPVKVHVIVLWLYFULZYNYHYQYKRYSWMYGYEUGWLYFMV
        FVIYSYPYJWHQYSYOYIMWLYFYDPVMVHVIVLVJYLUAUBGHVNWTWMWKUGOZWHWLWJPOZMNZQOZ
        RUFZBGSZAHSYMWSUUEAHWJHTZWRUUDBGUUFWLGTZUJZWNYTWQUUCRUUFWKVOTWMVOTWNYTU
        LUUGUUFWKUUFWJUPTZWKUKTWJHKUQZWJVPVQWBUUGWMUUGWLUPTZWMUKTWLGJUQZWLVPVQW
        BWKWMVRUSUUHWPUUBWHQUUHWOUUAMUUFUUIUUKWOUUAULUUGUUJUULWJWLURUSVHVIVLVSV
        TUUDYLWMYGUGOZWHWLYFPOZMNZQOZRUFABUBUAHGWJYFULZYTUUMUUCUUPRUUQWKYGWMUGW
        JYFMVFVIUUQUUBUUOWHQUUQUUAUUNMWJYFWLPVMVHVIVLWLYDULZUUMYHUUPYKRUURWMYEY
        GUGWLYDMVFVGUURUUOYJWHQUURUUNYIMWLYDYFPVKVHVIVLVJWAWCWDWEXKXFEUKXJXEWIX
        CFXIXDGHJKUOWFWDWEWG $.
    $}
  $}

  ${
    $d x y z w v u t h f g A $.  $d x y z w v u t h f g B $.
    $d v u t h f g S $.  $d v u t h f g T $.
    cdj3.1 $e |- A e. SH $.
    cdj3.2 $e |- B e. SH $.
    cdj3.3 $e |- S = ( x e. ( A +H B ) |->
                       ( iota_ z e. A E. w e. B x = ( z +h w ) ) ) $.
    cdj3.4 $e |- T = ( x e. ( A +H B ) |->
                       ( iota_ w e. B E. z e. A x = ( z +h w ) ) ) $.
    cdj3.5 $e |- ( ph <-> E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( S ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $.
    cdj3.6 $e |- ( ps <-> E. v e. RR ( 0 < v /\ A. u e. ( A +H B )
                      ( normh ` ( T ` u ) ) <_ ( v x. ( normh ` u ) ) ) ) $.
    $( Two ways to express " ` A ` and ` B ` are completely disjoint
       subspaces."  (1) <=> (3) in Lemma 5 of [Holland] p. 1520.  (Contributed
       by NM, 1-Jun-2005.)  (New usage is discouraged.) $)
    cdj3i $p |- ( E. v e. RR ( 0 < v /\ A. x e. A A. y e. B
      ( ( normh ` x ) + ( normh ` y ) ) <_ ( v x. ( normh ` ( x +h y ) ) ) )
         <-> ( ( A i^i B ) = 0H /\ ph /\ ps ) ) $=
      ( cle cr vf vg vt vh cc0 cv clt wbr cno cfv caddc co cva cmul wral wa cin
      wrex c0h wceq w3a cdj3lem1 cph cdj3lem2b sylibr cdj3lem3b weq breq2 oveq1
      3jca breq2d ralbidv anbi12d cbvrexv anbi12i reeanv bitr4i wcel an4 addgt0
      bitri wi adantl shsvai fveq2 fveq2d oveq2d breq12d rspcv anim12d syl chil
      sheli normcl anim12i hvaddcl syl2an remulcl sylan2 adantlr adantll le2add
      ex syl12anc wb cdj3lem2 breq1d cdj3lem3 3expa ancoms cc recn recnd adddir
      syl3an 3imtr4d ralrimdvva readdcl oveq1d cbvral2v 2ralbidv syl5bb syl2and
      syld oveq2 rspcev syl5bi rexlimdvva 3impib impbii ) UEGUFZUGUHZCUFZUIUJZD
      UFZUIUJZUKULZYKYMYOUMULZUIUJZUNULZSUHZDJUOCIUOZUPZGTURZIJUQUSUTZABVAUUDUU
      EABGCDIJMNVBUUDYLHUFZKUJZUIUJZYKUUFUIUJZUNULZSUHZHIJVCULZUOZUPZGTURZACDEF
      GHIJKMNOVDQVEUUDYLUUFLUJZUIUJZUUJSUHZHUULUOZUPZGTURZBCDEFGHIJLMNPVFRVEVJU
      UEABUUDABUPZUEUAUFZUGUHZUUHUVCUUIUNULZSUHZHUULUOZUPZUEUBUFZUGUHZUUQUVIUUI
      UNULZSUHZHUULUOZUPZUPZUBTURUATURZUUEUUDUVBUVHUATURZUVNUBTURZUPUVPAUVQBUVR
      AUUOUVQQUUNUVHGUATGUAVGZYLUVDUUMUVGYKUVCUEUGVHUVSUUKUVFHUULUVSUUJUVEUUHSY
      KUVCUUIUNVIVKVLVMVNWABUVAUVRRUUTUVNGUBTGUBVGZYLUVJUUSUVMYKUVIUEUGVHUVTUUR
      UVLHUULUVTUUJUVKUUQSYKUVIUUIUNVIVKVLVMVNWAVOUVHUVNUAUBTTVPVQUUEUVOUUDUAUB
      TTUVOUVDUVJUPZUVGUVMUPZUPUUEUVCTVRZUVITVRZUPZUPZUUDUVDUVGUVJUVMVSUWFUWAUE
      UVCUVIUKULZUGUHZUWBUCUFZUIUJZUDUFZUIUJZUKULZUWGUWIUWKUMULZUIUJZUNULZSUHZU
      DJUOUCIUOZUUDUWEUWAUWHWBUUEUWEUWAUWHUVCUVIVTXCWCUWFUWBUWQUCUDIJUWFUWIIVRZ
      UWKJVRZUPZUPZUWBUWNKUJZUIUJZUVCUWOUNULZSUHZUWNLUJZUIUJZUVIUWOUNULZSUHZUPZ
      UWQUXAUWBUXKWBZUWFUXAUWNUULVRZUXLIJUWIUWKMNWDUXMUVGUXFUVMUXJUVFUXFHUWNUUL
      UUFUWNUTZUUHUXDUVEUXESUXNUUGUXCUIUUFUWNKWEWFUXNUUIUWOUVCUNUUFUWNUIWEZWGWH
      WIUVLUXJHUWNUULUXNUUQUXHUVKUXISUXNUUPUXGUIUUFUWNLWEWFUXNUUIUWOUVIUNUXOWGW
      HWIWJWKWCUXBUWJUXESUHZUWLUXISUHZUPZUWMUXEUXIUKULZSUHZUXKUWQUWEUXAUXRUXTWB
      ZUUEUWEUXAUPZUWJTVRZUWLTVRZUPZUXETVRZUXITVRZUYAUXAUYEUWEUWSUYCUWTUYDUWSUW
      IWLVRZUYCUWIIMWMZUWIWNWKUWTUWKWLVRZUYDUWKJNWMZUWKWNWKWOWCUWCUXAUYFUWDUXAU
      WCUWOTVRZUYFUXAUWNWLVRZUYLUWSUYHUYJUYMUWTUYIUYKUWIUWKWPWQUWNWNWKZUVCUWOWR
      WSWTUWDUXAUYGUWCUXAUWDUYLUYGUYNUVIUWOWRWSXAUWJUWLUXEUXIXBXDXAUUEUXAUXKUXR
      XEZUWEUXAUUEUYOUWSUWTUUEUYOUWSUWTUUEVAZUXFUXPUXJUXQUYPUXDUWJUXESUYPUXCUWI
      UICEFIJUWIUWKKMNOXFWFXGUYPUXHUWLUXISUYPUXGUWKUICEFIJUWIUWKLMNPXHWFXGVMXIX
      JWTUWEUXAUWQUXTXEUUEUYBUWPUXSUWMSUWCUWDUXAUWPUXSUTZUWCUVCXKVRUWDUVIXKVRUX
      AUWOXKVRUYQUVCXLUVIXLUXAUWOUYNXMUVCUVIUWOXNXOXIVKXAXPYDXQUWEUWHUWRUPZUUDW
      BZUUEUWEUWGTVRZUYSUVCUVIXRUYTUYRUUDUUCUYRGUWGTYKUWGUTZYLUWHUUBUWRYKUWGUEU
      GVHUUBUWMYKUWOUNULZSUHZUDJUOUCIUOVUAUWRUUAVUCUWJYPUKULZYKUWIYOUMULZUIUJZU
      NULZSUHCDUCUDIJCUCVGZYQVUDYTVUGSVUHYNUWJYPUKYMUWIUIWEXSVUHYSVUFYKUNVUHYRV
      UEUIYMUWIYOUMVIWFWGWHDUDVGZVUDUWMVUGVUBSVUIYPUWLUWJUKYOUWKUIWEWGVUIVUFUWO
      YKUNVUIVUEUWNUIYOUWKUWIUMYEWFWGWHXTVUAVUCUWQUCUDIJVUAVUBUWPUWMSYKUWGUWOUN
      VIVKYAYBVMYFXCWKWCYCYGYHYGYIYJ $.
  $}

$( End $[ set-hilsp.mm $] $)


$( Begin $[ set-mbox.mm $] $)

$(
###############################################################################
                 SUPPLEMENTARY MATERIAL (USER'S MATHBOXES)
###############################################################################
$)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathboxes for user contributions
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Mathbox guidelines
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( (_This theorem is a dummy placeholder for these guidelines.  The name of
     this theorem, "mathbox", is hard-coded into the Metamath program to
     identify the start of the mathbox section for web page generation_.)

     A "mathbox" is a user-contributed section that is maintained by its
     contributor independently from the main part of set.mm.

     _For contributors_:

     By making a contribution, you agree to release it into the public domain,
     according to the statement at the beginning of set.mm.

     Mathboxes are provided to help keep your work synchronized with changes in
     set.mm, but they shouldn't be depended on as a permanent archive.  If you
     want to preserve your original contribution, it is your responsibility to
     keep your own copy of it along with the version of set.mm that works with
     it.

     _Guidelines_:

     1.  If at all possible, please use only 0-ary class constants for new
     definitions, for example as in ~ df-div .

     2.  Try to follow the style of the rest of set.mm.  Each $p and $a
     statement must be immediately preceded with the comment that will be shown
     on its web page description.  The metamath program command "write source
     set.mm /rewrap" will take care of wrapping comment lines and indentation
     conventions.  All mathbox content will be on public display and should
     hopefully reflect the overall quality of the website.

     3.  Before submitting a revised mathbox, please make sure it verifies
     against the current set.mm.

     4.  Mathboxes should be independent i.e. the proofs should verify with all
     other mathboxes removed.  If you need a theorem from another mathbox, that
     is fine (and encouraged), but let me know, so I can move the theorem to
     the main section.  One way avoid undesired accidental use of other mathbox
     theorems is to develop your mathbox using a modified set.mm that has
     mathboxes removed.

     _Notes_:

     1.  I may decide to move some theorems to the main part of set.mm for
     general use.  In that case, an author acknowledgment will be added to the
     description of the theorem.

     2.  I may make changes to mathboxes to maintain the overall quality of
     set.mm.  Normally I will let you know if a change might impact what you
     are working on.

     3.  If you use theorems from another user's mathbox, I don't provide
     assurance that they are based on correct or consistent $a statements.  (If
     you find such a problem, please let me know so it can be corrected.)
     (Contributed by NM, 20-Feb-2007.)  (New usage is discouraged.) $)
  mathbox $p |- x = x $=
    ( equid ) AB $.


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Stefan Allan
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  ${
    foo3.1 $e |- ph $.
    $( A theorem about the universal class.  (Contributed by Stefan Allan,
       9-Dec-2008.) $)
    foo3 $p |- _V = { x | ph } $=
      ( cvv weq cab df-v equid 2th abbii eqtri ) DBBEZBFABFBGLABLABHCIJK $.
  $}

  $( A partial converse to ~ 19.9t .  (Contributed by Stefan Allan,
     21-Dec-2008.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
  xfree $p |- ( A. x ( ph -> A. x ph ) <-> A. x ( E. x ph -> ph ) ) $=
    ( wal wi wnf wex df-nf nf3 bitr3i ) AABCDBCABEABFADBCABGABHI $.

  $( A partial converse to ~ 19.9t .  (Contributed by Stefan Allan,
     21-Dec-2008.) $)
  xfree2 $p |- ( A. x ( ph -> A. x ph ) <-> A. x ( -. ph -> A. x -. ph ) ) $=
    ( wal wi wex wn xfree df-ex imbi1i con1b bitri albii ) AABCDBCABEZADZBCAFZO
    BCZDZBCABGNQBNPFZADQMRAABHIPAJKLK $.

  $( A proof readability experiment for ~ addltmul .  (Contributed by Stefan
     Allan, 30-Oct-2010.)  (Proof modification is discouraged.) $)
  addltmulALT $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 2 < A /\ 2 < B ) )
              -> ( A + B ) < ( A x. B ) ) $=
    ( cr wcel wa c2 clt wbr c1 cmin co caddc cmul a1i syl3anc ax-1cn syl adantr
    wb wceq simpr 2re simpl 1re ltsub1 df-2 eqcomi subaddrii breq1i bitrd mpbid
    2cn anim12i an4s wi peano2rem anim1i mulgt1 ex cc recn mulsub breq2d biimpd
    jca mulid2i eqcom biimpi mp1i oveq2d mulid1 oveq12d readdcl remulcl syl2anc
    adantl ltaddsub2 ltadd1 bicomd sylbird 3syld mpd ) ACDZBCDZEZFAGHZFBGHZEZEZ
    IAIJKZGHZIBIJKZGHZEZABLKZABMKZGHZWCWFWDWGWNWCWFEZWKWDWGEZWMWRWFWKWCWFUAWRWF
    FIJKZWJGHZWKWRFCDZWCICDZWFXASXBWRUBNWCWFUCXCWRUDNFAIUEOXAWKSWRWTIWJGFIIULPP
    FIILKUFUGUHZUINUJUKWSWGWMWDWGUAWSWGWTWLGHZWMWSXBWDXCWGXESXBWSUBNWDWGUCXCWSU
    DNFBIUEOXEWMSWSWTIWLGXDUINUJUKUMUNWIWNIWJWLMKZGHZIWPIIMKZLKZAIMKZBIMKZLKZJK
    ZGHZWQWEWNXGUOWHWEWNXGWEWNEWJCDZWLCDZEZWNEXGWEXQWNWCXOWDXPAUPBUPUMUQWJWLURQ
    USRWEXGXNUOWHWEXGXNWEXFXMIGWEAUTDZIUTDZEZBUTDZXSEZEXFXMTWCXTWDYBWCXRXSAVAZX
    SWCPNVEWDYAXSBVAZXSWDPNVEUMAIBIVBQVCVDRWEXNWQUOWHWEXNIWPILKZWOJKZGHZWQWEYFX
    MIGWEYEXIWOXLJWEIXHWPLXHITZIXHTZWEIPVFYHYIXHIVGVHVIVJWEAXJBXKLWCAXJTZWDWCXR
    YJYCXRXJATZYJAVKYKYJXJAVGVHQQRWDBXKTZWCWDXKBTZYLWDYAYMYDBVKQYMYLXKBVGVHQVPV
    LVLVCWEYGWOILKYEGHZWQWEWOCDZXCYECDZYNYGSABVMZXCWEUDNZWEWPCDZXCYPABVNZYRWPIV
    MVOWOIYEVQOWEYNWQWEWQYNWEYOYSXCWQYNSYQYTYRWOWPIVROVSVDVTVTRWAWB $.

$( (End of Stefan Allan's mathbox.) $)


$( Begin $[ set-mbox-ta.mm $] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Thierry Arnoux
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$( Skip $[ set-main.mm $] $)

$( Begin $[ set-mbox-ta-basics.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Propositional Calculus - misc additions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    bian1d.1 $e |- ( ph -> ( ps <-> ( ch /\ th ) ) ) $.
    $( Adding a superfluous conjunct in a biconditionnal.  (Contributed by
       Thierry Arnoux, 26-Feb-2017.) $)
    bian1d $p |- ( ph -> ( ( ch /\ ps ) <-> ( ch /\ th ) ) ) $=
      ( wa biimpd adantld wi simpl a1i biimprd jcad impbid ) ACBFCDFZABOCABOEGH
      AOCBOCIACDJKABOELMN $.
  $}

  $( Distributive law for disjunction.  (Contributed by Thierry Arnoux,
     3-Jul-2017.) $)
  or3di $p |- ( ( ph \/ ( ps /\ ch /\ ta ) ) <->
                          ( ( ph \/ ps ) /\ ( ph \/ ch ) /\ ( ph \/ ta ) ) ) $=
    ( w3a wo wa df-3an orbi2i ordi anbi1i 3bitri bitr4i ) ABCDEZFZABFZACFZGZADF
    ZGZPQSEOABCGZDGZFAUAFZSGTNUBABCDHIAUADJUCRSABCJKLPQSHM $.

  $( Distributive law for disjunction.  (Contributed by Thierry Arnoux,
     3-Jul-2017.) $)
  or3dir $p |- ( ( ( ph /\ ps /\ ch ) \/ ta ) <->
              ( ( ph \/ ta ) /\ ( ps \/ ta ) /\ ( ch \/ ta ) ) ) $=
    ( w3a wo or3di orcom 3anbi123i 3bitr3i ) DABCEZFDAFZDBFZDCFZEKDFADFZBDFZCDF
    ZEDABCGDKHLOMPNQDAHDBHDCHIJ $.

  ${
    3o1cs.1 $e |- ( ( ph \/ ps \/ ch ) -> th ) $.
    $( Deduction eliminating disjunct.  (Contributed by Thierry Arnoux,
       19-Dec-2016.) $)
    3o1cs $p |- ( ph -> th ) $=
      ( wo w3o df-3or sylbir orcs ) ABDABFZCDKCFABCGDABCHEIJJ $.

    $( Deduction eliminating disjunct.  (Contributed by Thierry Arnoux,
       19-Dec-2016.) $)
    3o2cs $p |- ( ps -> th ) $=
      ( wo w3o df-3or sylbir orcs olcs ) ABDABFZCDLCFABCGDABCHEIJK $.

    $( Deduction eliminating disjunct.  (Contributed by Thierry Arnoux,
       19-Dec-2016.) $)
    3o3cs $p |- ( ch -> th ) $=
      ( wo w3o df-3or sylbir olcs ) ABFZCDKCFABCGDABCHEIJ $.
  $}

  ${
    adantl3r.1 $e |- ( ( ( ( ph /\ rh ) /\ mu ) /\ la ) -> ka ) $.
    $( Deduction adding 1 conjunct to antecedent.  (Contributed by Thierry
       Arnoux, 11-Feb-2018.) $)
    adantl3r $p |- ( ( ( ( ( ph /\ si ) /\ rh ) /\ mu ) /\ la ) -> ka ) $=
      ( wa wi ex adantllr imp ) ABHCHDHEFACDEFIBACHDHEFGJKL $.
  $}

  ${
    adantl4r.1 $e |- ( ( ( ( ( ph /\ si ) /\ rh ) /\ mu ) /\ la ) -> ka ) $.
    $( Deduction adding 1 conjunct to antecedent.  (Contributed by Thierry
       Arnoux, 11-Feb-2018.) $)
    adantl4r $p |- ( ( ( ( ( ( ph /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la )
      -> ka ) $=
      ( wa wi ex adantl3r imp ) ABICIDIEIFGABCDEFGJACIDIEIFGHKLM $.
  $}

  ${
    adantl5r.1 $e |- ( ( ( ( ( ( ph /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la )
      -> ka ) $.
    $( Deduction adding 1 conjunct to antecedent.  (Contributed by Thierry
       Arnoux, 11-Feb-2018.) $)
    adantl5r $p |- ( ( ( ( ( ( ( ph /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu )
      /\ la ) -> ka ) $=
      ( wa wi ex adantl4r imp ) ABJCJDJEJFJGHABCDEFGHKACJDJEJFJGHILMN $.
  $}

  ${
    adantl6r.1 $e |- ( ( ( ( ( ( ( ph /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu )
      /\ la ) -> ka ) $.
    $( Deduction adding 1 conjunct to antecedent.  (Contributed by Thierry
       Arnoux, 11-Feb-2018.) $)
    adantl6r $p |- ( ( ( ( ( ( ( ( ph /\ ta ) /\ et ) /\ ze ) /\ si ) /\ rh )
      /\ mu ) /\ la ) -> ka ) $=
      ( wa wi ex adantl5r imp ) ABKCKDKEKFKGKHIABCDEFGHILACKDKEKFKGKHIJMNO $.
  $}

  ${
    mpjao3dan.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    mpjao3dan.2 $e |- ( ( ph /\ th ) -> ch ) $.
    mpjao3dan.3 $e |- ( ( ph /\ ta ) -> ch ) $.
    mpjao3dan.4 $e |- ( ph -> ( ps \/ th \/ ta ) ) $.
    $( Eliminate a 3-way disjunction in a deduction.  (Contributed by Thierry
       Arnoux, 13-Apr-2018.) $)
    mpjao3dan $p |- ( ph -> ch ) $=
      ( wo jaodan w3o df-3or sylib mpjaodan ) ABDJZCEABCDFGKHABDELPEJIBDEMNO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Predicate Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Predicate Calculus - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y A $.  $d x y B $.  $d x y ph $.
    spc2ed.x $e |- F/ x ch $.
    spc2ed.y $e |- F/ y ch $.
    spc2ed.1 $e |- ( ( ph /\ ( x = A /\ y = B ) ) -> ( ps <-> ch ) ) $.
    $( Existential specialization with 2 quantifiers, using implicit
       substitution.  (Contributed by Thierry Arnoux, 23-Aug-2017.) $)
    spc2ed $p |- ( ( ph /\ ( A e. V /\ B e. W ) ) -> ( ch -> E. x E. y ps ) )
      $=
      ( wcel wa cv wceq wex wi elisset nfv anim12i eeanv sylibr anim2i biimparc
      nfan anass bicomi ancom anbi1i bitri imbi1i mpbi ex eximd impancom syl )
      AFHMZGIMZNZNADOFPZEOGPZNZEQZDQZNCBEQZDQZRUTVEAUTVADQZVBEQZNVEURVHUSVIDFHS
      EGISUAVAVBDEUBUCUDACVEVGACNZVDVFDACDADTJUFVJVCBEACEAETKUFVJVCBCAVCNZNZBRV
      JVCNZBRVKBCLUEVLVMBVLCANZVCNZVMVOVLCAVCUGUHVNVJVCCAUIUJUKULUMUNUOUOUPUQ
      $.

    $( Specialization with 2 quantifiers, using implicit substitution.
       (Contributed by Thierry Arnoux, 23-Aug-2017.) $)
    spc2d $p |- ( ( ph /\ ( A e. V /\ B e. W ) ) -> ( A. x A. y ps -> ch ) ) $=
      ( wal wn wex wcel wa nfn cv wceq 2nalexn con1bii notbid spc2ed syl5bir
      con1d ) BEMDMZBNZEODOZNAFHPGIPQQZCUGUIBDEUAUBUJCUIAUHCNDEFGHICDJRCEKRADSF
      TESGTQQBCLUCUDUFUE $.
  $}

  ${
    $d x y z A $.  $d x y z B $.
    $( A variable introduction law for class equality, deduction version.
       (Contributed by Thierry Arnoux, 2-Mar-2017.) $)
    eqvincg $p |- ( A e. V -> ( A = B <-> E. x ( x = A /\ x = B ) ) ) $=
      ( wcel wceq cv wa wex wi elisset ax-1 eqtr ex jca eximi pm3.43 3syl sylib
      19.37v eqtr2 exlimiv impbid1 ) BDEZBCFZAGZBFZUFCFZHZAIZUDUEUIJZAIZUEUJJUD
      UGAIUEUGJZUEUHJZHZAIULABDKUGUOAUGUMUNUGUELUGUEUHUFBCMNOPUOUKAUEUGUHQPRUEU
      IATSUIUEAUFBCUAUBUC $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Restricted quantification - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x ph $.
    reximddva.1 $e |- ( ( ph /\ ( x e. A /\ ps ) ) -> ch ) $.
    reximddva.2 $e |- ( ph -> E. x e. A ps ) $.
    $( Deduction from Theorem 19.22 of [Margaris] p. 90.  (Contributed by
       Thierry Arnoux, 7-Dec-2016.) $)
    reximddv $p |- ( ph -> E. x e. A ch ) $=
      ( wrex cv wcel expr reximdva mpd ) ABDEHCDEHGABCDEADIEJBCFKLM $.
  $}

  ${
    $d x y $.
    ralcom4f.1 $e |- F/_ y A $.
    $( Commutation of restricted and unrestricted universal quantifiers.
       (Contributed by NM, 26-Mar-2004.)  (Proof shortened by Andrew Salmon,
       8-Jun-2011.)  (Revised by Thierry Arnoux, 8-Mar-2017.) $)
    ralcom4f $p |- ( A. x e. A A. y ph <-> A. y A. x e. A ph ) $=
      ( cvv wral wal nfcv ralcomf ralv ralbii 3bitr3i ) ACFGZBDGABDGZCFGACHZBDG
      OCHABCDFEBFIJNPBDACKLOCKM $.

    $( Commutation of restricted and unrestricted existential quantifiers.
       (Contributed by NM, 12-Apr-2004.)  (Proof shortened by Andrew Salmon,
       8-Jun-2011.)  (Revised by Thierry Arnoux, 8-Mar-2017.) $)
    rexcom4f $p |- ( E. x e. A E. y ph <-> E. y E. x e. A ph ) $=
      ( cvv wrex wex nfcv rexcomf rexv rexbii 3bitr3i ) ACFGZBDGABDGZCFGACHZBDG
      OCHABCDFEBFIJNPBDACKLOCKM $.
  $}

  ${
    19.9d2rf.0 $e |- F/ y ph $.
    19.9d2rf.1 $e |- ( ph -> F/ x ps ) $.
    19.9d2rf.2 $e |- ( ph -> F/ y ps ) $.
    19.9d2rf.3 $e |- ( ph -> E. x e. A E. y e. B ps ) $.
    $( A deduction version of one direction of ~ 19.9 with two variables
       (Contributed by Thierry Arnoux, 20-Mar-2017.) $)
    19.9d2rf $p |- ( ph -> ps ) $=
      ( wex wrex rexex eximi 3syl nfexd 19.9d mpd ) ABDKZBASCKZSABDFLZCELUACKTJ
      UACEMUASCBDFMNOSACABCDGHPQRBADIQR $.
  $}

  ${
    $d y ph $.
    19.9d2r.1 $e |- ( ph -> F/ x ps ) $.
    19.9d2r.2 $e |- ( ph -> F/ y ps ) $.
    19.9d2r.3 $e |- ( ph -> E. x e. A E. y e. B ps ) $.
    $( A deduction version of one direction of ~ 19.9 with two variables
       (Contributed by Thierry Arnoux, 30-Jan-2017.) $)
    19.9d2r $p |- ( ph -> ps ) $=
      ( nfv 19.9d2rf ) ABCDEFADJGHIK $.
  $}

  ${
    $d x ps $.  $d y ps $.
    $( Restricted quantifier version of Theorem 19.41 of [Margaris] p. 90.
       Version with two quantifiers (Contributed by Thierry Arnoux,
       25-Jan-2017.) $)
    r19.41vv $p |- ( E. x e. A E. y e. B ( ph /\ ps )
                                      <-> ( E. x e. A E. y e. B ph /\ ps ) ) $=
      ( wa wrex r19.41v rexbii bitri ) ABGDFHZCEHADFHZBGZCEHMCEHBGLNCEABDFIJMBC
      EIK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Substitution (without distinct variables) - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d w y $.  $d w A $.  $d w x $.
    clelsb3f.1 $e |- F/_ y A $.
    $( Substitution applied to an atomic wff (class version of ~ elsb3 ).
       (Contributed by Rodolfo Medina, 28-Apr-2010.)  (Proof shortened by
       Andrew Salmon, 14-Jun-2011.)  (Revised by Thierry Arnoux,
       13-Mar-2017.) $)
    clelsb3f $p |- ( [ x / y ] y e. A <-> x e. A ) $=
      ( vw cv wcel wsb nfcri sbco2 nfv eleq1 sbie sbbii 3bitr3i ) EFZCGZEBHZBAH
      QEAHBFZCGZBAHAFZCGZQEABBECDIJRTBAQTEBTEKPSCLMNQUBEAUBEKPUACLMO $.
  $}

  ${
    $d x ph $.
    sbceqbid.1 $e |- ( ph -> A = B ) $.
    sbceqbid.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality theorem for class substitution.  (Contributed by Thierry
       Arnoux, 4-Sep-2018.) $)
    sbceqbid $p |- ( ph -> ( [. A / x ]. ps <-> [. B / x ]. ch ) ) $=
      ( cab wcel wsbc abbidv eleq12d df-sbc 3bitr4g ) AEBDIZJFCDIZJBDEKCDFKAEFP
      QGABCDHLMBDENCDFNO $.
  $}

  ${
    sbceqbidf.1 $e |- F/ x ph $.
    sbceqbidf.2 $e |- ( ph -> A = B ) $.
    sbceqbidf.3 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Equality theorem for class substitution.  (Contributed by Thierry
       Arnoux, 4-Sep-2018.) $)
    sbceqbidf $p |- ( ph -> ( [. A / x ]. ps <-> [. B / x ]. ch ) ) $=
      ( cab wcel wsbc abbid eleq12d df-sbc 3bitr4g ) AEBDJZKFCDJZKBDELCDFLAEFQR
      HABCDGIMNBDEOCDFOP $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Existential "at most one" - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y A $.
    $( "At most one" element in a set.  (Contributed by Thierry Arnoux,
       26-Jul-2018.) $)
    moel $p |- ( E* x x e. A <-> A. x e. A A. y e. A x = y ) $=
      ( cv wcel wceq wi wal wmo ralcom4 df-ral ralbii wa alcom eleq1 mo4 impexp
      wral albii bitr4i 3bitr4i 3bitr4ri ) BDZCEZADZUCFZGZBHZACRUGACRZBHZUFBCRZ
      ACRUECEZAIZUGABCJUKUHACUFBCKLULUDMUFGZBHAHUNAHZBHUMUJUNABNULUDABUEUCCOPUI
      UOBUIULUGGZAHUOUGACKUNUPAULUDUFQSTSUAUB $.
  $}

  ${
    $d i j x $.
    mo5f.1 $e |- F/ i ph $.
    mo5f.2 $e |- F/ j ph $.
    $( Alternate definition of "at most one."  (Contributed by Thierry Arnoux,
       1-Mar-2017.) $)
    mo5f $p |- ( E* x ph <->
                   A. i A. j ( ( [ i / x ] ph /\ [ j / x ] ph ) -> i = j ) ) $=
      ( wmo wsb wa weq wi wal mo3 nfsb nfan nfv nfim nfal sb8 sbim nfs1v bicomi
      sban sbf anbi2i bitr4i equsb3 imbi12i bitri sbalv albii 3bitri ) ABGAABDH
      ZIZBDJZKZDLZBLUQBCHZCLABCHZUMIZCDJZKZDLZCLABDFMUQBCUPCDUNUOCAUMCEABDCENOU
      OCPQRSURVCCUPVBBCDUPBCHUNBCHZUOBCHZKVBUNUOBCTVDUTVEVAVDUSUMBCHZIUTAUMBCUC
      UMVFUSVFUMUMBCABDUAUDUBUEUFCBDUGUHUIUJUKUL $.
  $}

  ${
    $d x y $.
    nmo.1 $e |- F/ y ph $.
    $( Negation of "at most one".  (Contributed by Thierry Arnoux,
       26-Feb-2017.) $)
    nmo $p |- ( -. E* x ph <-> A. y E. x ( ph /\ x =/= y ) ) $=
      ( wmo wn weq wi wal wex cv wne wa mo2 notbii alnex pm4.61 biid necon3bbii
      exnal anbi2i bitri exbii bitr3i albii 3bitr2i ) ABEZFABCGZHZBIZCJZFUJFZCI
      ABKZCKZLZMZBJZCIUGUKABCDNOUJCPULUQCULUIFZBJUQUIBTURUPBURAUHFZMUPAUHQUSUOA
      UHUMUNUHRSUAUBUCUDUEUF $.
  $}

  ${
    $d x ph $.
    moimd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( "At most one" is preserved through implication (notice wff reversal).
       (Contributed by Thierry Arnoux, 25-Feb-2017.) $)
    moimd $p |- ( ph -> ( E* x ch -> E* x ps ) ) $=
      ( wi wal wmo alrimiv moim syl ) ABCFZDGCDHBDHFALDEIBCDJK $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Equality's restricted existential "at most one" property.  (Contributed
       by Thierry Arnoux, 30-Mar-2018.) $)
    rmoeq $p |- ( A e. V -> E* x e. B x = A ) $=
      ( vy wcel cv wceq wi wral wex wrmo id rgenw imbi2d ralbidv spcegv mpi nfv
      eqeq2 rmo2 sylibr ) BDFZAGZBHZUDEGZHZIZACJZEKZUEACLUCUEUEIZACJZUJUKACUEMN
      UIULEBDUFBHZUHUKACUMUGUEUEUFBUDTOPQRUEAECUEESUAUB $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Existential uniqueness - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y A $.  $d x B $.
    $( A condition allowing swap of uniqueness and existential quantifiers.
       (Contributed by Thierry Arnoux, 7-Apr-2017.) $)
    2reuswap2 $p |- ( A. x e. A E* y ( y e. B /\ ph ) ->
                   ( E! x e. A E. y e. B ph -> E! y e. B E. x e. A ph ) ) $=
      ( cv wcel wa wmo wal wrex wreu wex weu df-reu r19.42v df-rex bitr3i bitri
      wi wral df-ral moanimv albii bitr4i 2euswap exbii eubii 3imtr4g sylbi
      an12 ) CFEGZAHZCIZBDUAZBFDGZUMHZCIZBJZACEKZBDLZABDKZCELZTUOUPUNTZBJUSUNBD
      UBURVDBUPUMCUCUDUEUSUQCMZBNZUQBMZCNZVAVCUQBCUFVAUPUTHZBNVFUTBDOVIVEBVIULU
      PAHZHZCMZVEVIVJCEKVLUPACEPVJCEQRVKUQCULUPAUKUGSUHSVCULVBHZCNVHVBCEOVMVGCV
      MUMBDKVGULABDPUMBDQRUHSUIUJ $.
  $}

  ${
    $d x y ph $.  $d x ps $.  $d x A $.  $d x y B $.  $d x y C $.
    reuxfr3d.1 $e |- ( ( ph /\ y e. C ) -> A e. B ) $.
    reuxfr3d.2 $e |- ( ( ph /\ x e. B ) -> E* y e. C x = A ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Cf. ~ reuxfr2d
       (Contributed by Thierry Arnoux, 7-Apr-2017.)  (Revised by Thierry
       Arnoux, 8-Oct-2017.) $)
    reuxfr3d $p |- ( ph
        -> ( E! x e. B E. y e. C ( x = A /\ ps ) <-> E! y e. C ps ) ) $=
      ( cv wceq wa wrex wreu wrmo wi wcel syl ancom wmo wral rmoan rmobii sylib
      ralrimiva 2reuswap 2reuswap2 moeq moani an12 bitri mobii mpbi a1i impbid1
      mprg wb biidd ceqsrexv reubidva bitrd ) ACJZEKZBLZDGMCFNZVDCFMZDGNZBDGNAV
      EVGAVDDGOZCFUAVEVGPAVHCFAVBFQZLZBVCLZDGOZVHVJVCDGOVLIVCBDGUBRVKVDDGBVCSUC
      UDUEVDCDFGUFRVIVDLZCTZVGVEPDGVDDCGFUGVNDJGQZVIBLZVCLZCTVNVCVPCCEUHUIVQVMC
      VQVCVPLVMVPVCSVCVIBUJUKULUMUNUPUOAVFBDGAVOLEFQVFBUQHBBCEFVCBURUSRUTVA $.
  $}

  ${
    $d x y ph $.  $d y ps $.  $d x ch $.  $d x A $.  $d x y B $.  $d x y C $.
    reuxfr4d.1 $e |- ( ( ph /\ y e. C ) -> A e. B ) $.
    reuxfr4d.2 $e |- ( ( ph /\ x e. B ) -> E! y e. C x = A ) $.
    reuxfr4d.3 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Cf. ~ reuxfrd
       (Contributed by Thierry Arnoux, 7-Apr-2017.) $)
    reuxfr4d $p |- ( ph -> ( E! x e. B ps <-> E! y e. C ch ) ) $=
      ( wreu cv wceq wa wrex wcel reurex syl bitrd biantrurd wb r19.41v rexbidv
      pm5.32da syl5bbr adantr reubidva wrmo reurmo reuxfr3d ) ABDGLDMZFNZCOZEHP
      ZDGLCEHLABUODGAULGQZOZBUMEHPZBOZUOUQURBUQUMEHLZURJUMEHRSUAAUSUOUBUPUSUMBO
      ZEHPAUOUMBEHUCAVAUNEHAUMBCKUEUDUFUGTUHACDEFGHIUQUTUMEHUIJUMEHUJSUKT $.
  $}

$(
  @{
    @d x y ph @.  @d x ps @.  @d x A @.  @d x B @.  @d x y C @.
    reuxfr3df.0 @e |- F/_ y B @.
    reuxfr3df.1 @e |- ( ( ph /\ y e. C ) -> A e. B ) @.
    reuxfr3df.2 @e |- ( ( ph /\ x e. B ) -> E* y e. C x = A ) @.
    @( Transfer existential uniqueness from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Cf. ~ reuxfr2d
       (Contributed by Thierry Arnoux, 7-Apr-2017.)  (Revised by Thierry
       Arnoux, 8-Oct-2017.)  (Revised by Thierry Arnoux, 30-Mar-2018.) @)
    reuxfr3df @p |- ( ph
        -> ( E! x e. B E. y e. C ( x = A /\ ps ) <-> E! y e. C ps ) ) @=
      ? @.
  @}
$)
  ${
    $d b x y $.  $d y A $.  $d b B $.  $d x b F $.  $d x b ph $.
    rexunirn.1 $e |- F = ( x e. A |-> B ) $.
    rexunirn.2 $e |- ( x e. A -> B e. V ) $.
    $( Restricted existential quantification over the union of the range of a
       function.  Cf. ~ rexrn and ~ eluni2 .  (Contributed by Thierry Arnoux,
       19-Sep-2017.) $)
    rexunirn $p |- ( E. x e. A E. y e. B ph -> E. y e. U. ran F ph ) $=
      ( vb wrex cv wcel wa wex crn cuni df-rex bitr4i exbii 19.42v anbi2i mpdan
      elrnmpt1 wceq eleq2 anbi1d rspcev sylan r19.41v sylib eximi eluni2 anbi1i
      bitri sylibr exlimiv sylbi ) ACEKZBDKZBLDMZCLZEMZANZNZCOZBOZACFPZQZKZUTVA
      USNZBOVGUSBDRVFVKBVFVAVDCOZNVKVAVDCUAUSVLVAACERUBSTSVFVJBVFVBJLZMZJVHKZAN
      ZCOZVJVEVPCVEVNANZJVHKZVPVAEVHMZVDVSVAEGMVTIBDEFGHUDUCVRVDJEVHVMEUEVNVCAV
      MEVBUFUGUHUIVNAJVHUJUKULVJVBVIMZANZCOVQACVIRWBVPCWAVOAJVBVHUMUNTUOUPUQUR
      $.
  $}

$(
  @{
    @( Restricted existential quantification for ordered pair abstract builders
       moving one condition outside of the abstract builder. @)
    reuopan @p |- ( E! p e. { <. x , y >. | ( ( x e. A /\ y e. B ) /\ ph ) } ps
      <-> E! p e. { <. x , y >. | ( x e. A /\ y e. B ) } ( ph /\ ps ) ) @=
      ? @.

    @( Restricted existential quantification for ordered pair abstract builders
       @)
    reuopab @p |- ( E! p e. { <. x , y >. | ( x e. A /\ y e. B ) } ph
      <-> ( E! x e. A E! y e. B ( p = <. x , y >. /\ ph )
         /\ A. x e. A E* y e. B ( p = <. x , y >. /\ ph ) ) ) @=
      ? @.
  @}
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Restricted "at most one" - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x y B $.  $d x y C $.  $d x y ph $.  $d y ps $.  $d x ch $.
    rmoxfrd.1 $e |- ( ( ph /\ y e. C ) -> A e. B ) $.
    rmoxfrd.2 $e |- ( ( ph /\ x e. B ) -> E! y e. C x = A ) $.
    rmoxfrd.3 $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer "at most one" restricted quantification from a variable ` x `
       to another variable ` y ` contained in expression ` A ` .  (Contributed
       by Thierry Arnoux, 7-Apr-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    rmoxfrdOLD $p |- ( ph ->
                       ( E* x ( x e. B /\ ps ) <-> E* y ( y e. C /\ ch ) ) ) $=
      ( cv wcel wa wex weu wi wmo wrex wreu wceq reurex rexxfrd df-rex reuxfr4d
      syl 3bitr3g df-reu imbi12d df-mo 3bitr4g ) ADLZGMZBNZDOZUNDPZQELHMCNZEOZU
      QEPZQUNDRUQERAUOURUPUSABDGSCEHSUOURABCDEFGHIAUMNULFUAZEHTUTEHSJUTEHUBUFKU
      CBDGUDCEHUDUGABDGTCEHTUPUSABCDEFGHIJKUEBDGUHCEHUHUGUIUNDUJUQEUJUK $.

    $( Transfer "at most one" restricted quantification from a variable ` x `
       to another variable ` y ` contained in expression ` A ` .  (Contributed
       by Thierry Arnoux, 7-Apr-2017.)  (Revised by Thierry Arnoux,
       8-Oct-2017.) $)
    rmoxfrd $p |- ( ph -> ( E* x e. B ps <-> E* y e. C ch ) ) $=
      ( cv wcel wa wmo wrmo wex weu wrex wreu wi wceq reurex syl rexxfrd df-rex
      3bitr3g reuxfr4d df-reu imbi12d df-mo 3bitr4g df-rmo ) ADLZGMZBNZDOZELHMC
      NZEOZBDGPCEHPAUPDQZUPDRZUAUREQZURERZUAUQUSAUTVBVAVCABDGSCEHSUTVBABCDEFGHI
      AUONUNFUBZEHTVDEHSJVDEHUCUDKUEBDGUFCEHUFUGABDGTCEHTVAVCABCDEFGHIJKUHBDGUI
      CEHUIUGUJUPDUKUREUKULBDGUMCEHUMUL $.
  $}

  ${
    ssrmo.1 $e |- F/_ x A $.
    ssrmo.2 $e |- F/_ x B $.
    $( "At most one" existential quantification restricted to a subclass.
       (Contributed by Thierry Arnoux, 8-Oct-2017.) $)
    ssrmo $p |- ( A C_ B -> ( E* x e. B ph -> E* x e. A ph ) ) $=
      ( wss cv wcel wa wmo wrmo wi wal dfss2f biimpi pm3.45 alimi moim df-rmo
      3syl 3imtr4g ) CDGZBHZDIZAJZBKZUDCIZAJZBKZABDLABCLUCUHUEMZBNZUIUFMZBNUGUJ
      MUCULBCDEFOPUKUMBUHUEAQRUIUFBSUAABDTABCTUB $.
  $}

  ${
    $d x y $.
    rmo3f.1 $e |- F/_ x A $.
    rmo3f.2 $e |- F/_ y A $.
    rmo3f.3 $e |- F/ y ph $.
    $( Restricted "at most one" using explicit substitution.  (Contributed by
       NM, 4-Nov-2012.)  (Revised by NM, 16-Jun-2017.)  (Revised by Thierry
       Arnoux, 8-Oct-2017.) $)
    rmo3f $p |- ( E* x e. A ph <->
               A. x e. A A. y e. A ( ( ph /\ [ y / x ] ph ) -> x = y ) ) $=
      ( cv wcel wa wsb wi wral wal anbi1i bitri 3bitri impexp albii df-ral wrmo
      wmo weq df-rmo sban clelsb3f anbi2i an4 ancom imbi1i nfcri r19.21 3bitr2i
      nfan mo3 3bitr4i ) ABDUABHDIZAJZBUBZAABCKZJZBCUCZLZCDMZBDMZABDUDURURBCKZJ
      ZVBLZCNZBNUQVDLZBNUSVEVIVJBVICHDIZUQVCLZLZCNVLCDMVJVHVMCVHVKUQJZVAJZVBLVN
      VCLVMVGVOVBVGURVKUTJZJUQVKJZVAJVOVFVPURVFUQBCKZUTJVPUQABCUEVRVKUTCBDEUFOP
      UGUQAVKUTUHVQVNVAUQVKUIOQUJVNVAVBRVKUQVCRQSVLCDTUQVCCDCBDFUKZULUMSURBCUQA
      CVSGUNUOVDBDTUPP $.
  $}

  ${
    $d x y $.  $d z A $.  $d y z ph $.  $d z ps $.
    rmo4f.1 $e |- F/_ x A $.
    rmo4f.2 $e |- F/_ y A $.
    rmo4f.3 $e |- F/ x ps $.
    rmo4f.4 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Restricted "at most one" using implicit substitution.  (Contributed by
       NM, 24-Oct-2006.)  (Revised by Thierry Arnoux, 11-Oct-2016.)  (Revised
       by Thierry Arnoux, 8-Mar-2017.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    rmo4fOLD $p |- ( E* x ( x e. A /\ ph ) <->
               A. x e. A A. y e. A ( ( ph /\ ps ) -> x = y ) ) $=
      ( cv wcel wa wi wal wral bitri imbi1i impexp albii df-ral wceq wmo anbi1i
      an4 ancom 3bitri nfcv nfel r19.21 3bitr2i wsb nfv nfan eleq1 anbi12d sbie
      mo3 anbi2i 2albii 3bitr4i ) CJZEKZALZDJZEKZBLZLZVAVDUAZMZDNZCNZVBABLZVHMZ
      DEOZMZCNVCCUBZVNCEOVJVOCVJVEVBVMMZMZDNVQDEOVOVIVRDVIVEVBLZVLLZVHMVSVMMVRV
      GVTVHVGVBVELZVLLVTVBAVEBUDWAVSVLVBVEUEUCPQVSVLVHRVEVBVMRUFSVQDETVBVMDEDVA
      EDVAUGGUHZUIUJSVPVCVCCDUKZLZVHMZDNCNVKVCCDVBADWBADULUMUQWEVICDWDVGVHWCVFV
      CVCVFCDVEBCCVDECVDUGFUHHUMVHVBVEABVAVDEUNIUOUPURQUSPVNCETUT $.

    $( Restricted "at most one" using implicit substitution.  (Contributed by
       NM, 24-Oct-2006.)  (Revised by Thierry Arnoux, 11-Oct-2016.)  (Revised
       by Thierry Arnoux, 8-Mar-2017.)  (Revised by Thierry Arnoux,
       8-Oct-2017.) $)
    rmo4f $p |- ( E* x e. A ph <->
               A. x e. A A. y e. A ( ( ph /\ ps ) -> x = y ) ) $=
      ( wrmo wsb wa weq wi wral nfv rmo3f sbie anbi2i imbi1i 2ralbii bitri ) AC
      EJAACDKZLZCDMZNZDEOCEOABLZUENZDEOCEOACDEFGADPQUFUHCDEEUDUGUEUCBAABCDHIRST
      UAUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        General Set Theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Class abstractions (a.k.a. class builders)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x ps $.
    ceqsexv2d.1 $e |- A e. _V $.
    ceqsexv2d.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    ceqsexv2d.3 $e |- ps $.
    $( Elimination of an existential quantifier, using implicit substitution.
       (Contributed by Thierry Arnoux, 10-Sep-2016.) $)
    ceqsexv2d $p |- E. x ph $=
      ( cv wceq wa wex ceqsexv biimpri simpr eximi mp2b ) BCHDIZAJZCKZACKGSBABC
      DEFLMRACQANOP $.
  $}

  ${
    $d x y $.  $d y A $.  $d y ph $.
    abeq2f.0 $e |- F/_ x A $.
    $( Equality of a class variable and a class abstraction.  In this version,
       the fact that ` x ` is a non-free variable in ` A ` is explicitely
       stated as a hypothesis.  (Contributed by Thierry Arnoux,
       11-May-2017.) $)
    abeq2f $p |- ( A = { x | ph } <-> A. x ( x e. A <-> ph ) ) $=
      ( vy cab wceq cv wcel wb wal nfcrii hbab1 cleqh abid bibi2i albii bitri )
      CABFZGBHZCIZTSIZJZBKUAAJZBKBECSBECDLABEMNUCUDBUBAUAABOPQR $.
  $}

  $( Abstract builder restricted to another restricted abstract builder
     (Contributed by Thierry Arnoux, 30-Aug-2017.) $)
  rabrab $p |- { x e. { x e. A | ph } | ps } = { x e. A | ( ph /\ ps ) } $=
    ( cv crab wcel wa cab rabid anbi1i anass bitri abbii df-rab 3eqtr4i ) CEZAC
    DFZGZBHZCIQDGZABHZHZCIBCRFUBCDFTUCCTUAAHZBHUCSUDBACDJKUAABLMNBCROUBCDOP $.

  ${
    $d x ph $.
    rabbidva2.1 $e |- ( ph -> ( ( x e. A /\ ps ) <-> ( x e. B /\ ch ) ) ) $.
    $( Equivalent wff's yield equal restricted class abstractions.
       (Contributed by Thierry Arnoux, 4-Feb-2017.) $)
    rabbidva2 $p |- ( ph -> { x e. A | ps } = { x e. B | ch } ) $=
      ( cv wcel wa cab crab abbidv df-rab 3eqtr4g ) ADHZEIBJZDKPFICJZDKBDELCDFL
      AQRDGMBDENCDFNO $.
  $}

  ${
    $d x y $.  $d y A $.  $d y ph $.
    rabid2f.1 $e |- F/_ x A $.
    $( An "identity" law for restricted class abstraction.  (Contributed by NM,
       9-Oct-2003.)  (Proof shortened by Andrew Salmon, 30-May-2011.)  (Revised
       by Thierry Arnoux, 13-Mar-2017.) $)
    rabid2f $p |- ( A = { x e. A | ph } <-> A. x e. A ph ) $=
      ( cv wcel wa cab wceq wi wal crab wral abeq2f pm4.71 bitr4i df-rab eqeq2i
      wb albii df-ral 3bitr4i ) CBECFZAGZBHZIZUCAJZBKZCABCLZIABCMUFUCUDSZBKUHUD
      BCDNUGUJBUCAOTPUIUECABCQRABCUAUB $.
  $}

  ${
    rabexgfGS.1 $e |- F/_ x A $.
    $( Separation Scheme in terms of a restricted class abstraction.  To be
       removed in profit of Glauco's equivalent version.  (Contributed by
       Thierry Arnoux, 11-May-2017.) $)
    rabexgfGS $p |- ( A e. V -> { x e. A | ph } e. _V ) $=
      ( wcel crab wss cvv cv wi nfrab1 dfss2f rabid simplbi mpgbir elex sylancr
      ssexg ) CDFABCGZCHZCIFTIFUABJZTFZUBCFZKBBTCABCLEMUCUDAABCNOPCDQTCISR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ps $.
    $( Membership in a restricted class abstraction, using implicit
       substitution.  (Closed theorem version of ~ elrab3 .)  (Contributed by
       Thierry Arnoux, 31-Aug-2017.) $)
    elrab3t $p |- ( ( A. x ( x = A -> ( ph <-> ps ) ) /\ A e. B ) ->
                                           ( A e. { x e. B | ph } <-> ps ) ) $=
      ( cv wceq wb wi wal wcel wa cab crab simpr nfa1 nfv nfan simpl 19.21bi
      eleq1 biimparc biantrurd bibi1d adantl mpbid alrimi elabgt syl2anc df-rab
      pm5.74da eleq2i bibi1i sylibr ) CFZDGZABHZIZCJZDEKZLZDUOEKZALZCMZKZBHZDAC
      ENZKZBHVAUTUPVCBHZIZCJVFUSUTOVAVJCUSUTCURCPUTCQRVAURVJVAURCUSUTSTUTURVJHU
      SUTUPUQVIUTUPLZAVCBVKVBAUPVBUTUODEUAUBUCUDUKUEUFUGVCBCDEUHUIVHVEBVGVDDACE
      UJULUMUN $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Image Sets
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d A x y $.
    abrexdomjm.1 $e |- ( y e. A -> E* x ph ) $.
    $( An indexed set is dominated by the indexing set.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    abrexdomjm $p |- ( A e. V -> { x | E. y e. A ph } ~<_ A ) $=
      ( wcel wrex cab cv wa copab crn cdom wex df-rex abbii wbr cvv wmo cdm wfn
      rnopab eqtr4i wss dmopabss ssexg mpan funopab wi moanimv mpbir mpgbir a1i
      wfun funfn sylib fnrndomg sylc ssdomg mpi domtr syl2anc syl5eqbr ) DEGZAC
      DHZBIZCJDGZAKZCBLZMZDNVGVICOZBIVKVFVLBACDPQVICBUCUDVEVKVJUAZNRZVMDNRZVKDN
      RVEVMSGZVJVMUBZVNVMDUEZVEVPACBDUFZVMDEUGUHVEVJUOZVQVTVEVTVIBTZCVICBUIWAVH
      ABTUJFVHABUKULUMUNVJUPUQVMSVJURUSVEVRVOVSVMDEUTVAVKVMDVBVCVD $.
  $}

  ${
    $d A x y $.  $d B x $.
    $( An indexed set is dominated by the indexing set.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    abrexdom2jm $p |- ( A e. V -> { x | E. y e. A x = B } ~<_ A ) $=
      ( cv wceq wmo wcel moeq a1i abrexdomjm ) AFDGZABCEMAHBFCIADJKL $.
  $}

  ${
    $d x y z w $.  $d y z w A $.  $d y z w B $.
    abrexexd.0 $e |- F/_ x A $.
    abrexexd.1 $e |- ( ph -> A e. _V ) $.
    $( Existence of a class abstraction of existentially restricted sets.
       (Contributed by Thierry Arnoux, 10-May-2017.) $)
    abrexexd $p |- ( ph -> { y | E. x e. A y = B } e. _V ) $=
      ( cv wceq wrex cab cmpt crn cvv wcel wa copab wex rnopab df-mpt rneqi cdm
      df-rex abbii 3eqtr4i wfun funmpt crab eqid dmmpt rabexgfGS syl5eqel funex
      sylancr rnexg 3syl syl5eqelr ) ACHEIZBDJZCKZBDELZMZNBHDOURPZBCQZMVCBRZCKV
      BUTVCBCSVAVDBCDETUAUSVECURBDUCUDUEADNOZVANOZVBNOGVFVAUFVAUBZNOVGBDEUGVFVH
      ENOZBDUHNBDEVAVAUIUJVIBDNFUKULNVAUMUNVANUOUPUQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y C $.
    elabreximd.1 $e |- F/ x ph $.
    elabreximd.2 $e |- F/ x ch $.
    elabreximd.3 $e |- ( A = B -> ( ch <-> ps ) ) $.
    elabreximd.4 $e |- ( ph -> A e. V ) $.
    elabreximd.5 $e |- ( ( ph /\ x e. C ) -> ps ) $.
    $( Class substitution in an image set.  (Contributed by Thierry Arnoux,
       30-Dec-2016.) $)
    elabreximd $p |- ( ( ph /\ A e. { y | E. x e. C y = B } ) -> ch ) $=
      ( cv wceq wrex cab wcel wa wb eqeq1 rexbidv elabg syl biimpa simpr adantr
      biimpar syl2anc exp31 rexlimd imp syldan ) AFEOZGPZDHQZERSZFGPZDHQZCAURUT
      AFISURUTUAMUQUTEFIUOFPUPUSDHUOFGUBUCUDUEUFAUTCAUSCDHJKADOHSZUSCAVATZUSTUS
      BCVBUSUGVBBUSNUHUSCBLUIUJUKULUMUN $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x ch $.  $d x ph $.
    elabreximdv.1 $e |- ( A = B -> ( ch <-> ps ) ) $.
    elabreximdv.2 $e |- ( ph -> A e. V ) $.
    elabreximdv.3 $e |- ( ( ph /\ x e. C ) -> ps ) $.
    $( Class substitution in an image set.  (Contributed by Thierry Arnoux,
       30-Dec-2016.) $)
    elabreximdv $p |- ( ( ph /\ A e. { y | E. x e. C y = B } ) -> ch ) $=
      ( nfv elabreximd ) ABCDEFGHIADMCDMJKLN $.
  $}

  ${
    abrexss.1 $e |- F/_ x C $.
    $d x y z $.  $d y z A $.  $d z C $.  $d y z B $.
    $( A necessary condition for an image set to be a subset.  (Contributed by
       Thierry Arnoux, 6-Feb-2017.) $)
    abrexss $p |- ( A. x e. A B e. C -> { y | E. x e. A y = B } C_ C ) $=
      ( vz wcel wral cv wceq wrex cab cvv nfra1 nfcri eleq1 vex a1i id r19.21bi
      elabreximd ex ssrdv ) DEHZACIZGBJDKACLBMZEUFGJZUGHUHEHZUFUEUIABUHDCNUEACO
      AGEFPUHDEQUHNHUFGRSUFUEACUFTUAUBUCUD $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Set relations and operations - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    eqri.1 $e |- F/_ x A $.
    eqri.2 $e |- F/_ x B $.
    eqri.3 $e |- ( x e. A <-> x e. B ) $.
    $( Infer equality of classes from equivalence of membership.  (Contributed
       by Thierry Arnoux, 7-Oct-2017.) $)
    eqri $p |- A = B $=
      ( wceq wtru nftru cv wcel wb a1i eqrd trud ) BCGHABCAIDEAJZBKPCKLHFMNO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x ph $.
    rabss3d.1 $e |- ( ( ph /\ ( x e. A /\ ps ) ) -> x e. B ) $.
    $( Subclass law for restricted abstraction.  (Contributed by Thierry
       Arnoux, 25-Sep-2017.) $)
    rabss3d $p |- ( ph -> { x e. A | ps } C_ { x e. B | ps } ) $=
      ( crab nfv nfrab1 cv wcel wa simprr jca ex rabid 3imtr4g ssrd ) ACBCDGZBC
      EGZACHBCDIBCEIACJZDKZBLZUAEKZBLZUASKUATKAUCUEAUCLUDBFAUBBMNOBCDPBCEPQR $.
  $}

  $( Intersection with an intersection (Contributed by Thierry Arnoux,
     27-Dec-2016.) $)
  inin $p |- ( A i^i ( A i^i B ) ) = ( A i^i B ) $=
    ( cin in13 inidm ineq2i incom 3eqtri ) AABCZCBAACZCBACIAABDJABAEFBAGH $.

  $( See ~ inundif (Contributed by Thierry Arnoux, 13-Sep-2017.) $)
  inindif $p |- ( ( A i^i C ) i^i ( A \ C ) ) = (/) $=
    ( cin wss cdif c0 wceq wo inss2 orci inss ax-mp inssdif0 mpbi ) ABCZACBDZOA
    BECFGOBDZABDZHPQRABIJOABKLOABMN $.

  $( If the difference of two sets is not empty, then the sets are not equal.
     (Contributed by Thierry Arnoux, 28-Feb-2017.) $)
  difneqnul $p |- ( ( A \ B ) =/= (/) -> A =/= B ) $=
    ( cdif c0 wceq wss eqimss ssdif0 sylib necon3i ) ABABCZDABEABFKDEABGABHIJ
    $.

  $( Rewriting an equation with set difference, without using quantifiers.
     (Contributed by Thierry Arnoux, 24-Sep-2017.) $)
  difeq $p |- ( ( A \ B ) = C <->
                         ( ( C i^i B ) = (/) /\ ( C u. B ) = ( A u. B ) ) ) $=
    ( cdif wceq cin c0 cun incom disjdif eqtr3i ineq1 syl5reqr undif1 uneq1 jca
    wa simpl disj3 difun2 eqcom bitri sylib difeq1 3eqtr3g eqeq1d adantl impbii
    wb mpbid ) ABDZCEZCBFZGEZCBHZABHZEZQZULUNUQULGUKBFZUMBUKFUSGBUKIBAJKUKCBLMU
    LUPUKBHUOABNUKCBOMPURCBDZCEZULURUNVAUNUQRUNCUTEVACBSCUTUAUBUCUQVAULUIUNUQUT
    UKCUQUOBDUPBDUTUKUOUPBUDCBTABTUEUFUGUJUH $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Unordered pairs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    elpreq.1 $e |- ( ph -> X e. { A , B } ) $.
    elpreq.2 $e |- ( ph -> Y e. { A , B } ) $.
    elpreq.3 $e |- ( ph -> ( X = A <-> Y = A ) ) $.
    $( Equality wihin a pair (Contributed by Thierry Arnoux, 23-Aug-2017.) $)
    elpreq $p |- ( ph -> X = Y ) $=
      ( wceq wa simpr biimpa eqtr4d wn cpr wcel wo elpri syl orcanai simpl 3syl
      notbid wi pm2.53 sylc pm2.61dan ) ADBIZDEIAUHJDBEAUHKAUHEBIZHLMAUHNZJZDCE
      AUHDCIZADBCOZPUHULQFDBCRSTUKAUINZECIZAUJUAAUJUNAUHUIHUCLAEUMPUIUOQUNUOUDG
      EBCRUIUOUEUBUFMUG $.
  $}

  ${
    preqsnd.1 $e |- ( ph -> A e. _V ) $.
    preqsnd.2 $e |- ( ph -> B e. _V ) $.
    preqsnd.3 $e |- ( ph -> C e. _V ) $.
    $( Equivalence for a pair equal to a singleton, deduction form.
       (Contributed by Thierry Arnoux, 27-Dec-2016.) $)
    preqsnd $p |- ( ph -> ( { A , B } = { C } <-> ( A = C /\ B = C ) ) ) $=
      ( cvv wcel cpr csn wceq wa wb dfsn2 eqeq2i wo preq12bg oridm syl6bb
      syl5bb syl22anc ) ABHIZCHIZDHIZUEBCJZDKZLZBDLCDLMZNEFGGUHUFDDJZLZUCUDMUEU
      EMMZUIUGUJUFDOPULUKUIUIQUIBCDDHHHHRUISTUAUB $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Conditional operator - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d a x $.  $d x C $.  $d x D $.  $d x X $.  $d x Y $.  $d x V $.  $d x W $.
    $d x ps $.  $d x ta $.  $d x th $.
    ifeqeqx.1 $e |- ( x = X -> A = C ) $.
    ifeqeqx.2 $e |- ( x = Y -> B = a ) $.
    ifeqeqx.3 $e |- ( x = X -> ( ch <-> th ) ) $.
    ifeqeqx.4 $e |- ( x = Y -> ( ch <-> ps ) ) $.
    ifeqeqx.5 $e |- ( ph -> a = C ) $.
    ifeqeqx.6 $e |- ( ( ph /\ ps ) -> th ) $.
    ifeqeqx.y $e |- ( ph -> Y e. V ) $.
    ifeqeqx.x $e |- ( ph -> X e. W ) $.
    $( An equality theorem tailored for ~ ballotlemsf1o (Contributed by Thierry
       Arnoux, 14-Apr-2017.) $)
    ifeqeqx $p |- ( ( ph /\ x = if ( ps , X , Y ) )
                                                  -> a = if ( ch , A , B ) ) $=
      ( cv wceq cif wa eqeq2 csb simplr wsbc simpll simpr sbceq1a biimpd dfsbcq
      sylc wi csbeq1 eqeq2d imbi12d wcel nfcvd csbiegf syl eqtr4d adantr eqcomd
      a1d wn pm3.24 wb sbcieg anbi1d mtbiri pm2.21d anass1rs ex csbeq1a biimprd
      imp ifbothda notbid nsyld anim2d mtoi expdimp ) CMUBZFUCZWFGUCZWFCFGUDZUC
      AEUBBKLUDZUCZUEZFGFWIWFUFGWIWFUFWLCUEZWKWFEWJFUGZUCZWGAWKCUHZWMACEWJUIZWO
      AWKCUJWMWKCWQWPWLCUKWKCWQCEWJULZUMUOBCEKUIZWFEKFUGZUCZUPCELUIZWFELFUGZUCZ
      UPWQWOUPAKLKWJUCZWSWQXAWOCEKWJUNZXEWTWNWFEKWJFUQURUSLWJUCZXBWQXDWOCELWJUN
      ZXGXCWNWFELWJFUQURUSABUEZXAWSXIWTWFAWTWFUCBAWTHWFAKJUTZWTHUCUAEKFHJXJEHVA
      NVBVCRVDVEVFVGABVHZUEZXBXDAXBXKXDAXBXKUEZXDAXMXDAXMBXKUEZBVIZAXBBXKALIUTZ
      XBBVJTCBELIQVKVCVLVMVNVSVOVPVTUOWKWGWOWKFWNWFEWJFVQURVRUOWLCVHZUEZWKWFEWJ
      GUGZUCZWHAWKXQUHZXRAWQVHZXTAWKXQUJXRWKXQYBYAWLXQUKWKXQYBWKCWQWRWAUMUOBWSV
      HZWFEKGUGZUCZUPXBVHZWFELGUGZUCZUPYBXTUPAKLXEYCYBYEXTXEWSWQXFWAXEYDXSWFEKW
      JGUQURUSXGYFYBYHXTXGXBWQXHWAXGYGXSWFELWJGUQURUSABYCYEABYCUEZYEAYIXNXOAYCX
      KBAYCDBAYCDVHAWSDAXJWSDVJUACDEKJPVKVCWAUMABDSVPWBWCWDVNWEXLYHYFXLYGWFAYGW
      FUCZXKAXPYJTELGWFIXPEWFVAOVBVCVEVFVGVTUOWKWHXTWKGXSWFEWJGVQURVRUOVT $.
  $}

  ${
    ifbieq12d2.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    ifbieq12d2.2 $e |- ( ( ph /\ ps ) -> A = C ) $.
    ifbieq12d2.3 $e |- ( ( ph /\ -. ps ) -> B = D ) $.
    $( Equivalence deduction for conditional operators.  (Contributed by
       Thierry Arnoux, 14-Feb-2017.) $)
    ifbieq12d2 $p |- ( ph -> if ( ps , A , B ) = if ( ch , C , D ) ) $=
      ( cif wceq wa wn wo syl6bi imp eqtr4d ex ancld iftrue iffalse orim12d mpi
      exmid notbid eqif sylibr eqcomd ) ACFGKZBDEKZABUJDLZMZBNZUJELZMZOZUJUKLAB
      UNOUQBUEABUMUNUPABULABULABMUJFDABUJFLZABCURHCFGUAPQIRSTAUNUOAUNUOAUNMUJGE
      AUNUJGLZAUNCNUSABCHUFCFGUBPQJRSTUCUDBUJDEUGUHUI $.
  $}

  $( Move a conditional outside of an operation (Contributed by Thierry Arnoux,
     25-Jan-2017.) $)
  ovif $p |- ( if ( ph , A , B ) F C ) = if ( ph , ( A F C ) , ( B F C ) ) $=
    ( cif co oveq1 ifsb ) ABCABCFZDEGBDEGCDEGJBDEHJCDEHI $.

  ${
    elimifd.1 $e |- ( ph -> ( if ( ps , A , B ) = A -> ( ch <-> th ) ) ) $.
    elimifd.2 $e |- ( ph -> ( if ( ps , A , B ) = B -> ( ch <-> ta ) ) ) $.
    $( Elimination of a conditional operator contained in a wff ` ch ` .
       (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
    elimifd $p |- ( ph -> ( ch <-> ( ( ps /\ th ) \/ ( -. ps /\ ta ) ) ) ) $=
      ( wn wo wa wb exmid biantrur a1i andir wceq syl5 pm5.32d iffalse orbi12d
      cif iftrue 3bitrd ) ACBBJZKZCLZBCLZUFCLZKZBDLZUFELZKCUHMAUGCBNOPUHUKMABUF
      CQPAUIULUJUMABCDBBFGUCZFRACDMBFGUDHSTAUFCEUFUNGRACEMBFGUAISTUBUE $.
  $}

  ${
    elim2if.1 $e |- ( if ( ph , A , if ( ps , B , C ) ) = A ->
                                                             ( ch <-> th ) ) $.
    elim2if.2 $e |- ( if ( ph , A , if ( ps , B , C ) ) = B ->
                                                             ( ch <-> ta ) ) $.
    elim2if.3 $e |- ( if ( ph , A , if ( ps , B , C ) ) = C ->
                                                             ( ch <-> et ) ) $.
    $( Elimination of two conditional operators contained in a wff ` ch ` .
       (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
    elim2if $p |- ( ch <-> ( ( ph /\ th ) \/
                       ( -. ph /\ ( ( ps /\ ta ) \/ ( -. ps /\ et ) ) ) ) ) $=
      ( wn wo wa cif wceq wb pm5.32i eqeq1d exmid biantrur andir iftrue iffalse
      syl syl6bir elimifd orbi12i 3bitri ) CAAMZNZCOACOZUKCOZNADOZUKBEOBMFONZOZ
      NULCAUAUBAUKCUCUMUOUNUQACDAAGBHIPZPZGQCDRAGURUDJUFSUKCUPUKBCEFHIUKURHQUSH
      QCERUKUSURHAGURUEZTKUGUKURIQUSIQCFRUKUSURIUTTLUGUHSUIUJ $.

    elim2ifim.1 $e |- ( ph -> th ) $.
    elim2ifim.2 $e |- ( ( -. ph /\ ps ) -> ta ) $.
    elim2ifim.3 $e |- ( ( -. ph /\ -. ps ) -> et ) $.
    $( Elimination of two conditional operators for an implication.
       (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
    elim2ifim $p |- ch $=
      ( wa wn wo ancli ex exmid pm4.42 ancld orim12i sylbi ax-mp elim2if mpbir
      imp ) CADPZAQZBEPZBQZFPZRZPZRZAUKRUQAUAAUJUKUPADMSUKUOUKUKBPZUKUMPZRUOUKB
      UBURULUSUNUKBULUKBEUKBENTUCUIUKUMUNUKUMFUKUMFOTUCUIUDUESUDUFABCDEFGHIJKLU
      GUH $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Indexed union - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y D $.  $d y ph $.
    iuneq12daf.1 $e |- F/ x ph $.
    iuneq12daf.2 $e |- F/_ x A $.
    iuneq12daf.3 $e |- F/_ x B $.
    iuneq12daf.4 $e |- ( ph -> A = B ) $.
    iuneq12daf.5 $e |- ( ( ph /\ x e. A ) -> C = D ) $.
    $( Equality deduction for indexed union, deduction version.  (Contributed
       by Thierry Arnoux, 13-Mar-2017.) $)
    iuneq12daf $p |- ( ph -> U_ x e. A C = U_ x e. B D ) $=
      ( vy cv wcel wrex wb ciun wceq cab df-iun wal eleq2d rexbida rexeqf bitrd
      wa syl alrimiv abbi eqeq12i bitr4i sylib ) ALMZENZBCOZUMFNZBDOZPZLUAZBCEQ
      ZBDFQZRZAURLAUOUPBCOZUQAUNUPBCGABMCNUFEFUMKUBUCACDRVCUQPJUPBCDHIUDUGUEUHU
      SUOLSZUQLSZRVBUOUQLUIUTVDVAVEBLCETBLDFTUJUKUL $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Subset equivalence for an indexed union.  (Contributed by Thierry
       Arnoux, 17-Oct-2016.) $)
    ssiun3 $p |- ( A. y e. C E. x e. A y e. B <-> C C_ U_ x e. A B ) $=
      ( ciun wss cv wcel wi wal wral wrex dfss2 df-ral eliun ralbii 3bitr2ri )
      EACDFZGBHZEITSIZJBKUABELTDIACMZBELBESNUABEOUAUBBEATCDPQR $.
  $}

  ${
    ssiun2sf.1 $e |- F/_ x A $.
    ssiun2sf.2 $e |- F/_ x C $.
    ssiun2sf.3 $e |- F/_ x D $.
    ssiun2sf.4 $e |- ( x = C -> B = D ) $.
    $( Subset relationship for an indexed union.  (Contributed by Thierry
       Arnoux, 31-Dec-2016.) $)
    ssiun2sf $p |- ( C e. A -> D C_ U_ x e. A B ) $=
      ( wcel ciun wss cv wi nfel nfiu1 nfss nfim wceq eleq1 imbi12d vtoclgf
      sseq1d ssiun2 pm2.43i ) DBJZEABCKZLZAMZBJZCUGLZNUFUHNADBGUFUHAADBGFOAEUGH
      ABCPQRUIDSZUJUFUKUHUIDBTULCEUGIUCUAABCUDUBUE $.
  $}

  ${
    $d i j n $.  $d j k n F $.  $d j k n ph $.
    iuninc.1 $e |- ( ph -> F Fn NN ) $.
    iuninc.2 $e |- ( ( ph /\ n e. NN ) -> ( F ` n ) C_ ( F ` ( n + 1 ) ) ) $.
    $( The union of an increasing collection of sets is its last element.
       (Contributed by Thierry Arnoux, 22-Jan-2017.) $)
    iuninc $p |- ( ( ph /\ i e. NN ) ->
      U_ n e. ( 1 ... i ) ( F ` n ) = ( F ` i ) ) $=
      ( vk wcel c1 cfz co cfv ciun wceq wi caddc iuneq1d fveq2 ax-mp cvv imbi2d
      vj cv cn oveq2 eqeq12d csn cz fzsn iuneq1 1ex iunxsn eqtri a1i cun simpll
      1z wa cuz elnnuz fzsuc sylbi iunxun uneq2i syl6eq syl simpr uneq1d simplr
      ovex wss wsb sbt sbim sban nfv sbf clelsb3 anbi12i bitr2i wsbc csb wb vex
      sbsbc sbcssg csbfv2g csbvarg fveq2i csbov1g oveq1i 3eqtri sseq12i 3bitrri
      imbi12i bitr4i mpbi ssequn1 sylib syl2anc 3eqtrd exp31 a2d nnind impcom )
      BUCZUDHACIXFJKZCUCZDLZMZXFDLZNZACIUBUCZJKZXIMZXMDLZNZOACIIJKZXIMZIDLZNZOA
      CIGUCZJKZXIMZYBDLZNZOACIYBIPKZJKZXIMZYGDLZNZOAXLOUBGXFXMINZXQYAAYLXOXSXPX
      TYLCXNXRXIXMIIJUEQXMIDRUFUAXMYBNZXQYFAYMXOYDXPYEYMCXNYCXIXMYBIJUEQXMYBDRU
      FUAXMYGNZXQYKAYNXOYIXPYJYNCXNYHXIXMYGIJUEQXMYGDRUFUAXMXFNZXQXLAYOXOXJXPXK
      YOCXNXGXIXMXFIJUEQXMXFDRUFUAYAAXSCIUGZXIMZXTXRYPNZXSYQNIUHHYRUQIUISCXRYPX
      IUJSCIXIXTUKXHIDRULUMUNYBUDHZAYFYKYSAYFYKYSAURZYFURZYIYDYJUOZYEYJUOZYJUUA
      YSYIUUBNYSAYFUPZYSYICYCYGUGZUOZXIMZUUBYSCYHUUFXIYSYBIUSLHYHUUFNYBUTIYBVAV
      BQUUGYDCUUEXIMZUOUUBCYCUUEXIVCUUHYJYDCYGXIYJYBIPVJXHYGDRULVDUMVEVFUUAYDYE
      YJYTYFVGVHUUAAYSUUCYJNZYSAYFVIUUDAYSURZYEYJVKZUUIAXHUDHZURZXIXHIPKZDLZVKZ
      OZCGVLZUUJUUKOZUUQCGFVMUURUUMCGVLZUUPCGVLZOUUSUUMUUPCGVNUUJUUTUUKUVAUUTAC
      GVLZUULCGVLZURUUJAUULCGVOUVBAUVCYSACGACVPVQGCUDVRVSVTUVAUUPCYBWAZCYBXIWBZ
      CYBUUOWBZVKZUUKUUPCGWEYBTHZUVDUVGWCGWDZCYBXIUUOTWFSUVEYEUVFYJUVECYBXHWBZD
      LZYEUVHUVEUVKNUVICYBXHTDWGSUVJYBDUVHUVJYBNUVICYBTWHSZWIUMUVFCYBUUNWBZDLZU
      VJIPKZDLYJUVHUVFUVNNUVICYBUUNTDWGSUVMUVODUVHUVMUVONUVICYBXHIPTWJSWIUVOYGD
      UVJYBIPUVLWKWIWLWMWNWOWPWQYEYJWRWSWTXAXBXCXDXE $.
  $}

  ${
    $d x A $.  $d x O $.
    $( The intersection of a set is the complement of the union of the
       complements.  (Contributed by Thierry Arnoux, 19-Dec-2016.) $)
    iundifdifd $p |- ( A C_ ~P O ->
      ( A =/= (/) -> |^| A = ( O \ U_ x e. A ( O \ x ) ) ) ) $=
      ( cpw wss c0 cint cv cdif ciun wceq wa ciin iundif2 intiin difeq2i eqtr4i
      wne cuni intssuni2 unipw syl6sseq dfss4 sylib syl5req ex ) BCDZEZBFRZBGZC
      ABCAHZIJZIZKUHUILZUMCCUJIZIZUJULUOCULCABUKMZIUOABCUKNUJUQCABOPQPUNUJCEUPU
      JKUNUJUGSCBUGTCUAUBUJCUCUDUEUF $.
  $}

  ${
    $d x A $.  $d x O $.
    iundifdif.o $e |- O e. _V $.
    iundifdif.2 $e |- A C_ ~P O $.
    $( The intersection of a set is the complement of the union of the
       complements.  TODO shorten using ~ iundifdifd (Contributed by Thierry
       Arnoux, 4-Sep-2016.) $)
    iundifdif $p |- ( A =/= (/) -> |^| A = ( O \ U_ x e. A ( O \ x ) ) ) $=
      ( c0 wne cv cdif ciun cint ciin iundif2 intiin difeq2i eqtr4i wss wceq wa
      cpw cuni jctl intssuni2 unipw sseq2i biimpi 3syl dfss4 sylib syl5req ) BF
      GZCABCAHZIJZICCBKZIZIZUNUMUOCUMCABULLZIUOABCULMUNUQCABNOPOUKUNCQZUPUNRUKB
      CTZQZUKSUNUSUAZQZURUKUTEUBBUSUCVBURVACUNCUDUEUFUGUNCUHUIUJ $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z C $.  $d x z D $.  $d x y F $.
    $d x y z ph $.
    iunrdx.1 $e |- ( ph -> F : A -onto-> C ) $.
    iunrdx.2 $e |- ( ( ph /\ y = ( F ` x ) ) -> D = B ) $.
    $( Re-index an indexed union.  (Contributed by Thierry Arnoux,
       6-Apr-2017.) $)
    iunrdx $p |- ( ph -> U_ x e. A B = U_ y e. C D ) $=
      ( vz cv wcel wrex cab ciun cfv wfo wf df-iun fof syl ffvelrnda wceq sylan
      foelrn wa eleq2d rexxfrd bicomd abbidv 3eqtr4g ) AKLZEMZBDNZKOUMGMZCFNZKO
      BDEPCFGPAUOUQKAUQUOAUPUNCBBLZHQZFDADFURHADFHRZDFHSIDFHUAUBUCAUTCLZFMVAUSU
      DZBDNIBDFVAHUFUEAVBUGGEUMJUHUIUJUKBKDETCKFGTUL $.
  $}

  ${
    $d A x y $.  $d B y $.  $d F x y $.
    $( Preimage of an indexed union.  (Contributed by Thierry Arnoux,
       27-Mar-2018.) $)
    iunpreima $p |- ( Fun F
      -> ( `' F " U_ x e. A B ) = U_ x e. A ( `' F " B ) ) $=
      ( vy wfun ccnv ciun cima cv cfv wcel cdm crab wrex wb a1i fncnvima2 sylbi
      wceq eliun rabbidv wfn funfn iunrab 3eqtr4d iuneq2d eqtr4d ) DFZDGZABCHZI
      ZABEJDKZCLZEDMZNZHZABUJCIZHUIUMUKLZEUONZUNABOZEUONZULUQUIUSVAEUOUSVAPUIAU
      MBCUAQUBUIDUOUCZULUTTDUDZEUOUKDRSUQVBTUIUNAEBUOUEQUFUIABURUPUIVCURUPTVDEU
      OCDRSUGUH $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Disjointness - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y A $.  $d x y B $.
    $( In case ` x ` is not free in ` B ` , disjointness is not so interesting
       since it reduces to cases where ` A ` is a singleton.  (Google Groups
       discussion with Peter Masza) (Contributed by Thierry Arnoux,
       26-Jul-2018.) $)
    disjnf $p |- ( Disj_ x e. A B <-> ( B = (/) \/ E* x x e. A ) ) $=
      ( vy wdisj c0 wceq cv wral wcel wmo cin eqidd disjor orcom ralbii r19.32v
      wo bitri 3bitri inidm eqeq1i orbi1i moel orbi2i bitr4i ) ABCEZCFGZAHZDHGZ
      DBIZABIZRZUHUIBJAKZRUGCCLZFGZULRZUMUGUJUPRZDBIZABIUPUKRZABIUQBCCADUJCMNUS
      UTABUSUPUJRZDBIUTURVADBUJUPOPUPUJDBQSPUPUKABQTUPUHULUOCFCUAUBUCSUNULUHADB
      UDUEUF $.
  $}

  ${
    $d x y z $.  $d y z A $.  $d z B $.  $d z C $.
    cbvdisjf.1 $e |- F/_ x A $.
    cbvdisjf.2 $e |- F/_ y B $.
    cbvdisjf.3 $e |- F/_ x C $.
    cbvdisjf.4 $e |- ( x = y -> B = C ) $.
    $( Change bound variables in a disjoint collection.  (Contributed by
       Thierry Arnoux, 6-Apr-2017.) $)
    cbvdisjf $p |- ( Disj_ x e. A B <-> Disj_ y e. A C ) $=
      ( vz cv wcel wrmo wal wdisj wa wmo nfcri nfan df-rmo nfv weq eleq1 eleq2d
      anbi12d cbvmo 3bitr4i albii df-disj ) JKZDLZACMZJNUJELZBCMZJNACDOBCEOULUN
      JAKZCLZUKPZAQBKZCLZUMPZBQULUNUQUTABUPUKBUPBUABJDGRSUSUMAABCFRAJEHRSABUBZU
      PUSUKUMUOURCUCVADEUJIUDUEUFUKACTUMBCTUGUHAJCDUIBJCEUIUG $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    disjss1f.1 $e |- F/_ x A $.
    disjss1f.2 $e |- F/_ x B $.
    $( A subset of a disjoint collection is disjoint.  (Contributed by Thierry
       Arnoux, 6-Apr-2017.) $)
    disjss1f $p |- ( A C_ B -> ( Disj_ x e. B C -> Disj_ x e. A C ) ) $=
      ( vy wss cv wcel wrmo wal wdisj ssrmo alimdv df-disj 3imtr4g ) BCHZGIDJZA
      CKZGLSABKZGLACDMABDMRTUAGSABCEFNOAGCDPAGBDPQ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A trivial partition into a subset and its complement.  (Contributed by
       Thierry Arnoux, 25-Dec-2016.) $)
    disjdifprg $p |- ( ( A e. V /\ B e. W ) ->
        Disj_ x e. { ( B \ A ) , A } x ) $=
      ( wcel wa c0 wceq cdif cpr wdisj simpr wb elex cvv 0ex mpbiri cin id dif0
      cv csn disjxsn eqidd a1i preqsnd adantr mpbir2and wne in0 disjprg syl3anc
      disjeq1d pm2.61dane ad2antlr difeq2 syl6eq preq12d adantl mpbird wn incom
      eqtr3i difexg ad2antrr wss ssid ssdifeq0 notbii nssne2 sylan2br pm2.61dan
      disjdif mpan ) BDFZCEFZGZBHIZACBJZBKZAUBZLZVRVSGWCACHKZWBLZVQWEVPVSVQWECH
      VQCHIZGZWEAHUCZWBLAHWBUDWGAWDWHWBWGWDWHIZWFHHIZVQWFMWGHUEVQWIWFWJGNWFVQCH
      HCEOZHPFZVQQUFZWMUGUHUIUNRVQCHUJZGZWECHSHIZCUKWOCPFZWLWNWEWPNVQWQWNWKUHWL
      WOQUFVQWNMACHWBCHPWBCITWBHITULUMRUOUPVSWCWENVRVSAWAWDWBVSVTCBHVSVTCHJCBHC
      UQCUAURVSTUSUNUTVAVRVSVBZGZWCVTBSZHIZBVTSWTHBVTVCBCVNVDWSVTPFZBPFZVTBUJZW
      CXANVQXBVPWRCBEVEUPVPXCVQWRBDOVFWRXDVRVTVTVGZWRXDVTVHWRXEBVTVGZVBXDXFVSBC
      VIVJVTBVTVKVLVOUTAVTBWBVTBPWBVTITWBBITULUMRVM $.
  $}

  ${
    $d x A $.  $d x B $.
    $( A trivial partition of a set into its difference and intersection with
       another set.  (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    disjdifprg2 $p |-
        ( A e. V -> Disj_ x e. { ( A \ B ) , ( A i^i B ) } x ) $=
      ( wcel cin cdif cpr wdisj cvv inex1g elex disjdifprg syl2anc difin preq1i
      cv wceq a1i disjeq1d mpbid ) BDEZABBCFZGZUCHZAQZIZABCGZUCHZUFIUBUCJEBJEUG
      BCDKBDLAUCBJJMNUBAUEUIUFUEUIRUBUDUHUCBCOPSTUA $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d z C $.  $d x z Y $.
    disjif.1 $e |- F/_ x C $.
    disjif.2 $e |- ( x = Y -> B = C ) $.
    $( Property of a disjoint collection: if ` B ( x ) = C ` and
       ` B ( Y ) = D ` , and ` x =/= Y ` , then ` B ` and ` C ` are disjoint.
       (Contributed by Thierry Arnoux, 30-Dec-2016.) $)
    disji2f $p |- ( ( Disj_ x e. A B /\ ( x e. A /\ Y e. A ) /\
      x =/= Y ) -> ( B i^i C ) = (/) ) $=
      ( vy vz cv wcel wa cin c0 wceq wo weq csb wral eqeq1d wdisj df-ne disjors
      wn equequ1 csbeq1 csbid syl6eq ineq1d orbi12d eqeq2 csbhypf ineq2d rspc2v
      wne nfcv syl5bi impcom ord 3impia ) ABCUAZAJZBKEBKLZVBEUOZCDMZNOZVDVBEOZU
      DVAVCLZVFVBEUBVHVGVFVCVAVGVFPZVAHIQZAHJZCRZAIJZCRZMZNOZPZIBSHBSVCVIABCHIU
      CVQVIAIQZCVNMZNOZPHIVBEBBHAQZVJVRVPVTHAIUEWAVOVSNWAVLCVNWAVLAVBCRCAVKVBCU
      FACUGUHUITUJVMEOZVRVGVTVFVMEVBUKWBVSVENWBVNDCAIECDAEUPFGULUMTUJUNUQURUSUQ
      UT $.

    $( Property of a disjoint collection: if ` B ( x ) ` and ` B ( Y ) = D `
       have a common element ` Z ` , then ` x = Y ` .  (Contributed by Thierry
       Arnoux, 30-Dec-2016.) $)
    disjif $p |- ( ( Disj_ x e. A B /\ ( x e. A /\ Y e. A ) /\
      ( Z e. B /\ Z e. C ) ) -> x = Y ) $=
      ( wcel wa wdisj cv cin c0 wne wceq inelcm disji2f 3expia necon1d syl3an3
      3impia ) FCIFDIJABCKZALZBIEBIJZCDMZNOZUDEPZFCDQUCUEUGUHUCUEJUDEUFNUCUEUDE
      OUFNPABCDEGHRSTUBUA $.
  $}

  ${
    $d i j x $.  $d x A $.  $d j x B $.  $d i x C $.
    disjorf.1 $e |- F/_ i A $.
    disjorf.2 $e |- F/_ j A $.
    disjorf.3 $e |- ( i = j -> B = C ) $.
    $( Two ways to say that a collection ` B ( i ) ` for ` i e. A ` is
       disjoint.  (Contributed by Thierry Arnoux, 8-Mar-2017.) $)
    disjorf $p |- ( Disj_ i e. A B <->
      A. i e. A A. j e. A ( i = j \/ ( B i^i C ) = (/) ) ) $=
      ( vx cv wcel wal wceq wo wral wi ralcom4 wex bitri bitr4i wrmo c0 df-disj
      wdisj cin wa wn orcom df-or neq0 exbii imbi1i 19.23v 3bitri ralbii eleq2d
      elin nfv rmo4f albii 3bitr4i ) DABUDIJZBKZDAUAZILZDJEJMZBCUEZUBMZNZEAOZDA
      OZDIABUCVCVBCKZUFZVFPZEAOZILZDAOVODAOZILVKVEVODIAQVJVPDAVJVNILZEAOVPVIVRE
      AVIVHVFNVHUGZVFPZVRVFVHUHVHVFUIVTVMIRZVFPVRVSWAVFVSVBVGKZIRWAIVGUJWBVMIVB
      BCUQUKSULVMVFIUMTUNUOVNEIAQSUOVDVQIVCVLDEAFGVLDURVFBCVBHUPUSUTVAT $.
  $}

  ${
    $d i j x $.  $d i j A $.  $d i j B $.
    disjorsf.1 $e |- F/_ x A $.
    $( Two ways to say that a collection ` B ( i ) ` for ` i e. A ` is
       disjoint.  (Contributed by Thierry Arnoux, 8-Mar-2017.) $)
    disjorsf $p |- ( Disj_ x e. A B <-> A. i e. A A. j e. A
      ( i = j \/ ( [_ i / x ]_ B i^i [_ j / x ]_ B ) = (/) ) ) $=
      ( wdisj cv csb wceq cin c0 wo wral nfcsb1v csbeq1a cbvdisjf csbeq1 disjor
      nfcv bitri ) ABCGDBADHZCIZGUBEHZJUCAUDCIZKLJMEBNDBNADBCUCFDCTAUBCOAUBCPQB
      UCUEDEAUBUDCRSUA $.
  $}

  ${
    $d x y z $.  $d y z A $.  $d y z B $.  $d z C $.  $d x z Y $.
    disjif2.1 $e |- F/_ x A $.
    disjif2.2 $e |- F/_ x C $.
    disjif2.3 $e |- ( x = Y -> B = C ) $.
    $( Property of a disjoint collection: if ` B ( x ) ` and ` B ( Y ) = D `
       have a common element ` Z ` , then ` x = Y ` .  (Contributed by Thierry
       Arnoux, 6-Apr-2017.) $)
    disjif2 $p |- ( ( Disj_ x e. A B /\ ( x e. A /\ Y e. A ) /\
      ( Z e. B /\ Z e. C ) ) -> x = Y ) $=
      ( vy vz wcel wa cv cin c0 wceq wo weq csb wdisj wne wral disjorsf equequ1
      inelcm csbeq1 csbid syl6eq ineq1d eqeq1d orbi12d eqeq2 nfcv ineq2d rspc2v
      csbhypf syl5bi impcom ord necon1ad 3impia syl3an3 ) FCLFDLMABCUAZANZBLEBL
      MZCDOZPUBZVEEQZFCDUFVDVFVHVIVDVFMZVIVGPVJVIVGPQZVFVDVIVKRZVDJKSZAJNZCTZAK
      NZCTZOZPQZRZKBUCJBUCVFVLABCJKGUDVTVLAKSZCVQOZPQZRJKVEEBBJASZVMWAVSWCJAKUE
      WDVRWBPWDVOCVQWDVOAVECTCAVNVECUGACUHUIUJUKULVPEQZWAVIWCVKVPEVEUMWEWBVGPWE
      VQDCAKECDAEUNHIUQUOUKULUPURUSUTVAVBVC $.
  $}

  ${
    $d i j x y z A $.  $d i j y z B $.
    $( Rewriting a disjoint collection into a partition of its image set
       (Contributed by Thierry Arnoux, 30-Dec-2016.) $)
    disjabrex $p |- ( Disj_ x e. A B
                                   -> Disj_ y e. { z | E. x e. A z = B } y ) $=
      ( vi vj wdisj cv wcel csb wa cab cuni wceq wral cvv vex simpllr syl nfcri
      wrex nfdisj1 nfcv nfv nfan nfab nfuni nfcsb1 nfeq1 nfral eqeq2 raleqbi1dv
      nfcsb1v a1i simplll simprl simplr simprr csbeq1a syl122anc simpr eqeltrrd
      csn disjif wb eleq2d mpbid jca impbida equcom syl6bb abbidv df-sn syl6eqr
      unieqd unisn syl6eq csbeq1 csbid ralrimiva elabreximd invdisj ) ADEHZAFIZ
      DJZGIZAWEEKZJZLZFMZNZEKZBIZOZGWNPZBCIEOADUBCMZPBWQWNHWDWPBWQWDWMEOZGEPWPA
      CWNEDQADEUCWOAGWNAWNUDAWMWNAWLEAWKWJAFWFWIAWFAUEAGWHAWEEUNZUAUFUGUHUIUJUK
      WOWRGWNEWNEWMULUMWNQJWDBRUOWDAIZDJZLZWRGEXBWGEJZLZWLWTOZWRXDWLWTVDZNWTXDW
      KXFXDWKWEWTOZFMXFXDWJXGFXDWJWTWEOZXGXDWJXHXDWJLWDXAWFXCWIXHWDXAXCWJUPWDXA
      XCWJSXDWFWIUQXBXCWJURXDWFWIUSADEWHWEWGWSAWEEUTZVEVAXDXHLZWFWIXJWTWEDXDXHV
      BZWDXAXCXHSVCXJXCWIXBXCXHURXJXHXCWIVFXKXHEWHWGXIVGTVHVIVJAFVKVLVMFWTVNVOV
      PWTARVQVRXEWMAWTEKEAWLWTEVSAEVTVRTWAWBWABGWQWNWMWCT $.
  $}

  ${
    $d i j x y z $.  $d i j y z A $.  $d i j y z B $.
    disjabrexf.1 $e |- F/_ x A $.
    $( Rewriting a disjoint collection into a partition of its image set
       (Contributed by Thierry Arnoux, 30-Dec-2016.)  (Revised by Thierry
       Arnoux, 9-Mar-2017.) $)
    disjabrexf $p |- ( Disj_ x e. A B
                                   -> Disj_ y e. { z | E. x e. A z = B } y ) $=
      ( vi vj wdisj cv wcel csb wa cab cuni wceq wral cvv nfcri syl wrex nfcsb1
      nfdisj1 nfcv nfcsb1v nfan nfab nfuni nfeq1 nfral eqeq2 raleqbi1dv vex a1i
      csn simplll simpllr simprl simplr simprr csbeq1a syl122anc simpr eqeltrrd
      disjif2 wb eleq2d mpbid impbida equcom syl6bb abbidv df-sn syl6eqr unieqd
      jca unisn syl6eq csbeq1 csbid ralrimiva elabreximd invdisj ) ADEIZAGJZDKZ
      HJZAWEELZKZMZGNZOZELZBJZPZHWNQZBCJEPADUACNZQBWQWNIWDWPBWQWDWMEPZHEQWPACWN
      EDRADEUCWOAHWNAWNUDAWMWNAWLEAWKWJAGWFWIAAGDFSAHWHAWEEUEZSUFUGUHUBUIUJWOWR
      HWNEWNEWMUKULWNRKWDBUMUNWDAJZDKZMZWRHEXBWGEKZMZWLWTPZWRXDWLWTUOZOWTXDWKXF
      XDWKWEWTPZGNXFXDWJXGGXDWJWTWEPZXGXDWJXHXDWJMWDXAWFXCWIXHWDXAXCWJUPWDXAXCW
      JUQXDWFWIURXBXCWJUSXDWFWIUTADEWHWEWGFWSAWEEVAZVEVBXDXHMZWFWIXJWTWEDXDXHVC
      ZWDXAXCXHUQVDXJXCWIXBXCXHUSXJXHXCWIVFXKXHEWHWGXIVGTVHVPVIAGVJVKVLGWTVMVNV
      OWTAUMVQVRXEWMAWTELEAWLWTEVSAEVTVRTWAWBWABHWQWNWMWCT $.
  $}

  ${
    $d x y z A $.  $d x y z F $.  $d y z B $.
    $( A preimage of a disjoint set is disjoint.  (Contributed by Thierry
       Arnoux, 7-Feb-2017.) $)
    disjpreima $p |- ( ( Fun F /\ Disj_ x e. A B )
                                              -> Disj_ x e. A ( `' F " B ) ) $=
      ( vy vz wdisj cima cv wceq csb cin c0 wo wral csbima12 cvv wcel csbconstg
      vex wfun ccnv inpreima imaeq2 ima0 syl6eq sylan9req ax-mp imaeq1i ineq12i
      ex eqtri eqeq1i syl6ibr orim2d ralimdv disjors 3imtr4g imp ) DUAZABCGZABD
      UBZCHZGZUTEIZFIZJZAVECKZAVFCKZLZMJZNZFBOZEBOVGAVEVCKZAVFVCKZLZMJZNZFBOZEB
      OVAVDUTVMVSEBUTVLVRFBUTVKVQVGUTVKVBVHHZVBVIHZLZMJZVQUTVKWCUTVKWBVBVJHZMVH
      VIDUCVKWDVBMHMVJMVBUDVBUEUFUGUKVPWBMVNVTVOWAVNAVEVBKZVHHVTAVECVBPWEVBVHVE
      QRWEVBJETAVEVBQSUHUIULVOAVFVBKZVIHWAAVFCVBPWFVBVIVFQRWFVBJFTAVFVBQSUHUIUL
      UJUMUNUOUPUPABCEFUQABVCEFUQURUS $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( If a collection is disjoint, so is the collection of the intersections
       with a given set.  (Contributed by Thierry Arnoux, 14-Feb-2017.) $)
    disjin $p |- ( Disj_ x e. B C -> Disj_ x e. B ( C i^i A ) ) $=
      ( vy cv wcel wrmo wal wdisj wa wi inss1 sseli anim2i ax-gen rmoimi2 alimi
      cin df-disj 3imtr4i ) EFZDGZACHZEIUBDBSZGZACHZEIACDJACUEJUDUGEUFUCACCAFCG
      ZUFKUHUCKLAUFUCUHUEDUBDBMNOPQRAECDTAECUETUA $.
  $}

  ${
    $d a c p q r x A $.  $d b d p q r y B $.  $d a c p C $.  $d b d p D $.
    $d q r x E $.  $d q r y F $.  $d q r ph $.
    disjxpin.1 $e |- ( x = ( 1st ` p ) -> C = E ) $.
    disjxpin.2 $e |- ( y = ( 2nd ` p ) -> D = F ) $.
    disjxpin.3 $e |- ( ph -> Disj_ x e. A C ) $.
    disjxpin.4 $e |- ( ph -> Disj_ y e. B D ) $.
    $( Derive a disjunction over a cross product from the disjunctions over its
       first and second elements.  (Contributed by Thierry Arnoux,
       9-Mar-2018.) $)
    disjxpin $p |- ( ph -> Disj_ p e. ( A X. B ) ( E i^i F ) ) $=
      ( wceq cin csb c0 wo wa vq vr va vc vb vd cv cxp wral wdisj wcel c1st cfv
      c2nd xp1st ad2antrl ad2antll simpl sylib eqeq1 csbeq1 ineq1d eqeq1d eqeq2
      disjors orbi12d ineq2d rspc2v syl5 imp syl21anc xp2nd jca anddi wb xpopth
      orass adantl biimpd wi wss inss2 csbin ineq12i in4 eqtri cvv vex csbnestg
      ax-mp fvex nfcv csbief csbeq2i fveq2 3eqtr3ri 3sstr4i sseq0 adantld inss1
      mpan a1i adantrd jaod orim12d mpd ralrimivva sylibr ) AUAUGZUBUGZOZJXIHIP
      ZQZJXJXLQZPZROZSZUBDEUHZUIUAXRUIJXRXLUJAXQUAUBXRXRAXIXRUKZXJXRUKZTZTZXIUL
      UMZXJULUMZOZXIUNUMZXJUNUMZOZTZYECYFGQZCYGGQZPZROZTZBYCFQZBYDFQZPZROZYHTZY
      RYMTZSZSZSZXQYBYIYNSUUASZUUCYBYEYRSZYHYMSZTUUDYBUUEUUFYBYCDUKZYDDUKZAUUEX
      SUUGAXTXIDEUOUPXTUUHAXSXJDEUOUQAYAURZUUGUUHTZAUUEAUCUGZUDUGZOZBUUKFQZBUUL
      FQZPZROZSZUDDUIUCDUIZUUJUUEABDFUJUUSMBDFUCUDVEUSUURUUEYCUULOZYOUUOPZROZSU
      CUDYCYDDDUUKYCOZUUMUUTUUQUVBUUKYCUULUTUVCUUPUVARUVCUUNYOUUOBUUKYCFVAVBVCV
      FUULYDOZUUTYEUVBYRUULYDYCVDUVDUVAYQRUVDUUOYPYOBUULYDFVAVGVCVFVHVIVJVKYBYF
      EUKZYGEUKZAUUFXSUVEAXTXIDEVLUPXTUVFAXSXJDEVLUQUUIUVEUVFTZAUUFAUEUGZUFUGZO
      ZCUVHGQZCUVIGQZPZROZSZUFEUIUEEUIZUVGUUFACEGUJUVPNCEGUEUFVEUSUVOUUFYFUVIOZ
      YJUVLPZROZSUEUFYFYGEEUVHYFOZUVJUVQUVNUVSUVHYFUVIUTUVTUVMUVRRUVTUVKYJUVLCU
      VHYFGVAVBVCVFUVIYGOZUVQYHUVSYMUVIYGYFVDUWAUVRYLRUWAUVLYKYJCUVIYGGVAVGVCVF
      VHVIVJVKVMYEYRYHYMVNUSYIYNUUAVQUSYBYIXKUUBXPYBYIXKYAYIXKVOAXIXJDEDEVPVRVS
      YBYNXPUUAYBYMXPYEYMXPVTYBXOYLWAYMXPJXIHQZJXJHQZPZJXIIQZJXJIQZPZPZUWGXOYLU
      WDUWGWBXOUWBUWEPZUWCUWFPZPUWHXMUWIXNUWJJXIHIWCJXJHIWCWDUWBUWEUWCUWFWEWFZY
      JUWEYKUWFJXICJUGZUNUMZGQZQZCJXIUWMQZGQZUWEYJXIWGUKZUWOUWQOUAWHZJCXIUWMGWG
      WIWJJXIUWNICUWMGIUWLUNWKCIWLLWMZWNUWPYFOUWQYJOJXIUWMYFUWSJYFWLUWLXIUNWOWM
      CUWPYFGVAWJWPJXJUWNQZCJXJUWMQZGQZUWFYKXJWGUKZUXAUXCOUBWHZJCXJUWMGWGWIWJJX
      JUWNIUWTWNUXBYGOUXCYKOJXJUWMYGUXEJYGWLUWLXJUNWOWMCUXBYGGVAWJWPWDWQXOYLWRX
      AXBZWSYBYSXPYTYBYRXPYHYRXPVTYBXOYQWAYRXPUWHUWDXOYQUWDUWGWTUWKYOUWBYPUWCJX
      IBUWLULUMZFQZQZBJXIUXGQZFQZUWBYOUWRUXIUXKOUWSJBXIUXGFWGWIWJJXIUXHHBUXGFHU
      WLULWKBHWLKWMZWNUXJYCOUXKYOOJXIUXGYCUWSJYCWLUWLXIULWOWMBUXJYCFVAWJWPJXJUX
      HQZBJXJUXGQZFQZUWCYPUXDUXMUXOOUXEJBXJUXGFWGWIWJJXJUXHHUXLWNUXNYDOUXOYPOJX
      JUXGYDUXEJYDWLUWLXJULWOWMBUXNYDFVAWJWPWDWQXOYQWRXAXBXCYBYMXPYRUXFWSXDXDXE
      XFXGJXRXLUAUBVEXH $.
  $}

  ${
    $d a b k m n x y $.  $d a b m x y A $.  $d a b m x y B $.  $d k n x N $.
    iundisjf.1 $e |- F/_ k A $.
    iundisjf.2 $e |- F/_ n B $.
    iundisjf.3 $e |- ( n = k -> A = B ) $.
    $( Rewrite a countable union as a disjoint union.  Cf. ~ iundisj
       (Contributed by Thierry Arnoux, 31-Dec-2016.) $)
    iundisjf $p |- U_ n e. NN A = U_ n e. NN ( A \ U_ k e. ( 1 ..^ n ) B ) $=
      ( vx vm cn ciun c1 cv cfzo wcel wrex cr clt nfcv nfcri cdif csb crab ccnv
      co csup wa cuz cfv wss wne ssrab2 nnuz sseqtri biimpri infmssuzcl sylancr
      c0 rabn0 nfrab1 nfsup nfcsb1 wceq csbeq1a eleq2d elrabf simpld simprd wbr
      sylib nnred ltnrd eliun nfrex nfrab nfbr ad2antrr elfzouz syl6eleqr simpr
      ad2antlr sylanbrc infmssuzle elfzolt2 lelttrd exp31 rexlimd syl5bi eldifd
      cle mtod csbeq1 nfeq2 nfov oveq2 eqidd iuneq12df difeq12d syl2anc nfcsb1v
      rspcev nfv nfiun nfdif iuneq1d cbvrex sylibr eldifi reximi impbii 3bitr4i
      eqriv ) HDJAKZDJACLDMZNUEZBKZUAZKZHMZAOZDJPZXSXQOZDJPZXSXMOXSXROYAYCYAXSD
      IMZAUBZCLYDNUEZBKZUAZOZIJPZYCYAXTDJUCZQRUDZUFZJOZXSDYMAUBZCLYMNUEZBKZUAZO
      ZYJYAYNXSYOOZYAYMYKOZYNYTUGYAYKLUHUIZUJZYKURUKZUUAYKJUUBXTDJULUMUNZUUDYAX
      TDJUSUOYKLUPUQXTYTDYMJDYKQYLXTDJUTDQSDYLSVAZDJSZDHYODYMAUUFVBTXNYMVCAYOXS
      DYMAVDVEVFVJZVGZYAXSYOYQYAYNYTUUHVHYAXSYQOZYMYMRVIZYAYMYAYMUUIVKZVLUUJXSB
      OZCYPPYAUUKCXSYPBVMYAUUMUUKCYPXTCDJCJSZCHAETZVNCYMYMRCYKQYLXTCDJUUOUUNVOC
      QSCYLSVAZCRSUUPVPYACMZYPOZUUMUUKYAUURUGZUUMUGZYMUUQYMYAYMQOUURUUMUULVQZUU
      TUUQUURUUQJOZYAUUMUURUUQUUBJUUQLYMVRUMVSWAZVKUVAUUTUUCUUQYKOZYMUUQWJVIUUE
      UUTUVBUUMUVDUVCUUSUUMVTXTUUMDUUQJDUUQSUUGDHBFTXNUUQVCABXSGVEVFWBUUQYKLWCU
      QUURUUQYMRVIYAUUMUUQLYMWDWAWEWFWGWHWKWIYIYSIYMJYDYMVCZYHYRXSUVEYEYOYGYQDY
      DYMAWLUVECYFYPBBCYDYMUUPWMCYFSCLYMNCLSCNSUUPWNYDYMLNWOUVEBWPWQWRVEXAWSYBY
      IDIJYBIXBDHYHDYEYGDYDAWTCDYFBDYFSFXCXDTXNYDVCZXQYHXSUVFAYEXPYGDYDAVDUVFCX
      OYFBXNYDLNWOXEWRVEXFXGYBXTDJXSAXPXHXIXJDXSJAVMDXSJXQVMXKXL $.

    $( A disjoint union is disjoint.  Cf. ~ iundisj2 (Contributed by Thierry
       Arnoux, 30-Dec-2016.) $)
    iundisj2f $p |- Disj_ n e. NN ( A \ U_ k e. ( 1 ..^ n ) B ) $=
      ( vx vy va vb cn c1 cv cfzo weq csb cin c0 wcel ciun cdif wdisj wceq wral
      co wo wtru tru eqeq12 csbeq1 ineqan12d eqeq1d orbi12d equcom syl6bb incom
      wa syl6eq cr wss nnssre a1i biidd cle wbr w3a wn wne necom df-ne bitri wb
      clt nnre id leltne syl3an wi vex nfcsb1v nfcv nfiun nfdif csbeq1a iuneq1d
      oveq2 difeq12d csbief ineq12i cuz cz simp1 nnuz syl6eleq simp2 nnzd simp3
      cfv elfzo2 syl3anbrc nfcsb csbhypf equcoms eqcomd ssiun2sf ssdifssd ssrin
      syl5eqss disjdif sseq0 sylancl 3expia 3adant3 sylbird syl5bir orrd adantl
      syl wlogle mpan rgen2a disjors mpbir ) DLACMDNZOUFZBUAZUBZUCHIPZDHNZYHQZD
      INZYHQZRZSUDZUGZILUEHLUEYPHILUHYJLTZYLLTZURZYPUIUHJKPZDJNZYHQZDKNZYHQZRZS
      UDZUGYPYPHIJKLJHPZKIPZURZYTYIUUFYOUUAYJUUCYLUJUUIUUEYNSUUGUUHUUBYKUUDYMDU
      UAYJYHUKDUUCYLYHUKULUMUNJIPZKHPZURZYTYIUUFYOUULYTIHPYIUUAYLUUCYJUJIHUOUPU
      ULUUEYNSUULUUEYMYKRYNUUJUUKUUBYMUUDYKDUUAYLYHUKDUUCYJYHUKULYMYKUQUSUMUNLU
      TVAUHVBVCUHYSURYPVDYQYRYJYLVEVFZVGZYPUHUUNYIYOYIVHZYLYJVIZUUNYOUUPYJYLVIU
      UOYLYJVJYJYLVKVLUUNUUPYJYLVNVFZYOYQYJUTTYRYLUTTUUMUUMUUQUUPVMYJVOYLVOUUMV
      PYJYLVQVRYQYRUUQYOVSUUMYQYRUUQYOYQYRUUQVGZYNCMYLOUFZBUAZDYLAQZUUTUBZRZVAU
      VCSUDYOUURYNDYJAQZCMYJOUFZBUAZUBZUVBRZUVCYKUVGYMUVBDYJYHUVGHVTDUVDUVFDYJA
      WACDUVEBDUVEWBFWCWDDHPZAUVDYGUVFDYJAWEUVICYFUVEBYEYJMOWGWFWHWIDYLYHUVBIVT
      DUVAUUTDYLAWACDUUSBDUUSWBFWCWDDIPZAUVAYGUUTDYLAWEUVJCYFUUSBYEYLMOWGWFWHWI
      WJUURUVGUUTVAUVHUVCVAUURUVDUUTUVFUURYJUUSTZUVDUUTVAUURYJMWKWSZTYLWLTUUQUV
      KUURYJLUVLYQYRUUQWMWNWOUURYLYQYRUUQWPWQYQYRUUQWRYJMYLWTXACUUSBYJUVDCUUSWB
      CYJWBZCDYJAUVMEXBCHPUVDBUVDBUDHCDHCNZABDUVNWBFGXCXDXEXFXSXGUVGUUTUVBXHXSX
      IUUTUVAXJYNUVCXKXLXMXNXOXPXQXRXTYAYBDLYHHIYCYD $.
  $}

  ${
    $d x y z A $.  $d y z B $.  $d x y z C $.  $d x z D $.  $d x y F $.
    $d x y z ph $.
    disjrdx.1 $e |- ( ph -> F : A -1-1-onto-> C ) $.
    disjrdx.2 $e |- ( ( ph /\ y = ( F ` x ) ) -> D = B ) $.
    $( Re-index a disjunct collection statement.  (Contributed by Thierry
       Arnoux, 7-Apr-2017.) $)
    disjrdx $p |- ( ph -> ( Disj_ x e. A B <-> Disj_ y e. C D ) ) $=
      ( vz cv wcel wrmo wal wdisj wa wceq wreu df-disj cfv wf1o wf f1of f1ofveu
      ffvelrnda sylan eqcom reubii sylib eleq2d rmoxfrd bicomd albidv 3bitr4g
      syl ) AKLZEMZBDNZKOUQGMZCFNZKOBDEPCFGPAUSVAKAVAUSAUTURCBBLZHUAZFDADFVBHAD
      FHUBZDFHUCIDFHUDUPUFACLZFMZQVCVERZBDSZVEVCRZBDSAVDVFVHIBDFVEHUEUGVGVIBDVC
      VEUHUIUJAVIQGEUQJUKULUMUNBKDETCKFGTUO $.
  $}

  ${
    $d z A $.  $d z B $.
    $( Two ways to say that two classes are disjoint (or equal).  (Contributed
       by Thierry Arnoux, 4-Oct-2016.) $)
    disjex $p |- ( ( E. z ( z e. A /\ z e. B ) -> A = B ) <->
      ( A = B \/ ( A i^i B ) = (/) ) ) $=
      ( wceq cv wcel wa wex wn wo cin c0 orcom wne cab df-in neeq1i abn0 bitr2i
      wi necon2bbii orbi2i imor 3bitr4ri ) BCDZAEZBFUFCFGZAHZIZJUIUEJUEBCKZLDZJ
      UHUETUEUIMUKUIUEUHUJLUJLNUGAOZLNUHUJULLABCPQUGARSUAUBUHUEUCUD $.

    disjexc.1 $e |- ( x = y -> A = B ) $.
    $( A variant of ~ disjex , applicable for more generic families.
       (Contributed by Thierry Arnoux, 4-Oct-2016.) $)
    disjexc $p |- ( ( E. z ( z e. A /\ z e. B ) -> x = y ) ->
      ( A = B \/ ( A i^i B ) = (/) ) ) $=
      ( cv wcel wa wex wceq wi cin c0 wo imim2i wn orcom wne cab neeq1i 3bitr4i
      df-in abn0 bitr2i necon2bbii orbi2i imor sylibr ) CGZDHUJEHIZCJZAGBGKZLUL
      DEKZLZUNDEMZNKZOZUMUNULFPUNULQZOUSUNOURUOUNUSRUQUSUNULUPNUPNSUKCTZNSULUPU
      TNCDEUCUAUKCUDUEUFUGULUNUHUBUI $.
  $}

  ${
    $d i j x A $.  $d i j B $.  $d i j x C $.  $d i j x M $.  $d i j x V $.
    disjunsn.s $e |- ( x = M -> B = C ) $.
    $( Append an element to a disjoint collection.  Similar to ~ ralunsn ,
       ~ gsumunsn , etc.  (Contributed by Thierry Arnoux, 28-Mar-2018.) $)
    disjunsn $p |- ( ( M e. V /\ -. M e. A ) -> ( Disj_ x e. ( A u. { M } ) B
      <-> ( Disj_ x e. A B /\ ( U_ x e. A B i^i C ) = (/) ) ) ) $=
      ( vi vj wa wceq cin c0 wo wral wb ineq1d eqeq1d ralbidv syl6bb wn csn cun
      wcel wdisj cv csb ciun disjors eqeq1 csbeq1 orbi12d ralunsn syl5bb ineq2d
      eqeq2 eqid orci biantru syl6bbr anbi12d bitrd r19.26 anbi1i bitr4i adantr
      orcom ralbii wrex r19.30 risset notbii biorf sylbi adantl syl5ibr syl5bir
      imp olc ralimi impbida nfv nfcv nfcsb1 nfin nfeq csbeq1a cbvral a1i iunss
      wss ss0b iunin1 eqeq1i 3bitr3ri bitri nfcvd csbiegf 3bitr4d bitr4d anbi2d
      eqcom rexbii incom anass anidm anbi2i ) EFUDZEBUDZUAZJZABEUBUCZCUEZABCUEZ
      HUFZEKZAXOCUGZAECUGZLZMKZNZHBOZJZEIUFZKZXRAYDCUGZLZMKZNZIBOZJZXNABCUHDLZM
      KZJZXHXMYKPXJXHXMXOYDKZXQYFLZMKZNZIBOZYAJZHBOZYJJZYKXHXMYRIXLOZHBOZYIIXLO
      ZJZUUBXMUUCHXLOXHUUFAXLCHIUIUUCUUEHBEFXPYRYIIXLXPYOYEYQYHXOEYDUJXPYPYGMXP
      XQXRYFAXOECUKQRULSUMUNXHUUDUUAUUEYJXHUUCYTHBYRYAIBEFYDEKZYOXPYQXTYDEXOUPU
      UGYPXSMUUGYFXRXQAYDECUKZUORULUMSXHUUEYJEEKZXRXRLZMKZNZJYJYIUULIBEFUUGYEUU
      IYHUUKYDEEUPUUGYGUUJMUUGYFXRXRUUHUORULUMUULYJUUIUUKEUQURUSUTVAVBUUAYCYJUU
      AYSHBOZYBJYCYSYAHBVCXNUUMYBABCHIUIVDVEVDTVFXKYKYNYMJZYNXKYCYNYJYMXKYBYMXN
      XKYBXTHBOZYMXKYBUUOXKYBUUOYBXTXPNZHBOZXKUUOUUPYAHBXTXPVGVHUUQUUOXKUUOXPHB
      VIZNZXTXPHBVJXKUUOUURUUONZUUSXJUUOUUTPZXHXJUURUAUVAXIUURHEBVKVLUURUUOVMVN
      VOUURUUOVGTVPVQVRUUOYBXKXTYAHBXTXPVSVTVOWAXHYMUUOPXJXHCDLZMKZABOZXQDLZMKZ
      HBOZYMUUOUVDUVGPXHUVCUVFAHBUVCHWBAUVEMAXQDAXOCAXOWCWDADWCZWEAMWCZWFAUFZXO
      KZUVBUVEMUVKCXQDAXOCWGQRWHWIYMUVDPXHYMUVBMWKZABOZUVDABUVBUHZMWKUVNMKUVMYM
      UVNWLABUVBMWJUVNYLMABDCWMWNWOUVLUVCABUVBWLVHWPWIZXHXTUVFHBXHXSUVEMXHXRDXQ
      AECDFXHADWQGWRZUORSWSVFWTXAXKYJYHIBOZYMXKYJUVQXKYJUVQYJYHYENZIBOZXKUVQUVR
      YIIBYHYEVGVHUVSUVQXKUVQYEIBVIZNZYHYEIBVJXKUVQUVTUVQNZUWAXJUVQUWBPZXHXJUVT
      UAUWCXIUVTXIUUGIBVIUVTIEBVKUUGYEIBYDEXBXCWPVLUVTUVQVMVNVOUVTUVQVGTVPVQVRU
      VQYJXKYHYIIBYHYEVSVTVOWAXHYMUVQPXJXHUVDDYFLZMKZIBOZYMUVQXHUVDYFDLZMKZIBOZ
      UWFUVDUWIPXHUVCUWHAIBUVCIWBAUWGMAYFDAYDCAYDWCWDUVHWEUVIWFUVJYDKZUVBUWGMUW
      JCYFDAYDCWGQRWHWIUWHUWEIBUWGUWDMYFDXDWNVHTUVOXHYHUWEIBXHYGUWDMXHXRDYFUVPQ
      RSWSVFWTVAUUNXNYMYMJZJYNXNYMYMXEUWKYMXNYMXFXGWPTVB $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Relations and Functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Relations - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d a b x y $.  $d a b R $.
    dfrel4.1 $e |- F/_ x R $.
    dfrel4.2 $e |- F/_ y R $.
    $( A relation can be expressed as the set of ordered pairs in it.  An
       analogue of ~ dffn5 for relations.  (Contributed by Mario Carneiro,
       16-Aug-2015.)  (Revised by Thierry Arnoux, 11-May-2017.) $)
    dfrel4 $p |- ( Rel R <-> R = { <. x , y >. | x R y } ) $=
      ( va vb wrel cv wbr copab wceq dfrel4v nfcv nfbr nfv breq12 cbvopab bitri
      eqeq2i ) CHCFIZGIZCJZFGKZLCAIZBIZCJZABKZLFGCMUDUHCUCUGFGABAUAUBCAUANDAUBN
      OBUAUBCBUANEBUBNOUGFPUGGPUAUEUBUFCQRTS $.
  $}

  $( The range of a pair of ordered pairs is the pair of second members.
     (Contributed by Thierry Arnoux, 3-Jan-2017.) $)
  rnpropg $p |- ( ( A e. V /\ B e. W )
    -> ran { <. A , C >. , <. B , D >. } = { C , D } ) $=
    ( wcel cop cpr crn csn cun df-pr rneqi wceq rnsnopg adantr adantl uneq12d
    wa rnun 3eqtr4g syl5eq ) AEGZBFGZTZACHZBDHZIZJUGKZUHKZLZJZCDIZUIULUGUHMNUFU
    JJZUKJZLCKZDKZLUMUNUFUOUQUPURUDUOUQOUEACEPQUEUPUROUDBDFPRSUJUKUACDMUBUC $.

  $( Restriction of a constant function (or other cross product) outside of its
     domain (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
  xpdisjres $p |- ( ( A i^i C ) = (/) -> ( ( A X. B ) |` C ) = (/) ) $=
    ( cin c0 wceq cxp cres cvv df-res xpdisj1 syl5eq ) ACDEFABGZCHMCIGDEMCJACBI
    KL $.

  $( Image of the difference with a cross product (Contributed by Thierry
     Arnoux, 13-Dec-2017.) $)
  imadifxp $p |- ( C C_ A ->
    ( ( R \ ( A X. B ) ) " C ) = ( ( R " C ) \ B ) ) $=
    ( wss cxp cdif cima wceq c0 imaeq2 syl6eq adantl wne cun cin syl5eq cvv crn
    ima0 difeq1d 0dif 3eqtr4a wa inundif imaeq1i imaundir eqtr3i difundir eqtri
    difeq1i inss2 imass1 ssdif mp2b xpima wn incom df-ss biimpi syl5eqr eqnetrd
    cif simpl df-ne iffalse 3syl difid syl5sseq cres df-ima df-res rneqi ineq1i
    ss0 syl xpss1 sslin rnss ssn0 ancoms inss1 ax-mp indif2 difxp2 3sstr4i mp1i
    sseqtrd disj2 sylibr ssdisj syl2anc disj3 sylib eqcomd uneq12d uncom eqtr2i
    rnxp un0 syl6reqr pm2.61dane ) CAEZDABFZGZCHZDCHZBGZIZCJCJIZXIXCXJXEJHJXFXH
    XETCJXEKXJXHJBGJXJXGJBXJXGDJHJCJDKDTLUABUBLUCMCJNZXCXIXKXCUDZXHJXFOZXFXLXHD
    XDPZCHZBGZXFBGZOZXMXHXOXFOZBGXRXGXSBXNXEOZCHXGXSXTDCDXDUEUFXNXECUGUHUKXOXFB
    UIUJXLXPJXQXFXLXPJEXPJIXLXDCHZBGZXPJXNXDEXOYAEXPYBEDXDULXNXDCUMXOYABUNUOXLY
    BBBGJXLYABBXLYAACPZJIZJBVCZBABCUPXLYCJNZYDUQZYEBIXLYCCJXCYCCIXKXCYCCAPZCCAU
    RXCYHCICAUSUTVAMXKXCVDVBYFYGYCJVEUTYDJBVFVGQUABVHLVIXPVOVPXLXFXQXLXFBPZJIXF
    XQIXLYIXECRFZPZSZBPZJXFYLBXFXECVJZSYLXECVKYNYKXECVLVMUJVNXLYLXEARFZPZSZEZYQ
    BPJIZYMJIXCYRXKXCYJYOEYKYPEYRCARVQYJYOXEVRYKYPVSVGMXLAJNZYSXCXKYTCAVTWAYTYQ
    RBGZEYSYTYQAUUAFZSZUUAYPUUBEYQUUCEYTYODPZXDGZYOXDGZYPUUBUUDYOEUUEUUFEYODWBU
    UDYOXDUNWCYOXEPYPUUEYOXEURYODXDWDUHARBWEWFYPUUBVSWGAUUAWSWHYQBWIWJVPYLYQBWK
    WLQXFBWMWNWOWPQXMXFJOXFJXFWQXFWTWRXAWAXB $.

  $( A relation (set) is finite if and only if both its domain and range are
     finite.  (Contributed by Thierry Arnoux, 27-Aug-2017.) $)
  relfi $p |- ( Rel A ->
                       ( A e. Fin <-> ( dom A e. Fin /\ ran A e. Fin ) ) ) $=
    ( wrel cfn wcel cdm crn wa wi dmfi rnfi jca a1i cxp adantl relssdmrn adantr
    wss xpfi ssfi syl2anc ex impbid ) ABZACDZAEZCDZAFZCDZGZUDUIHUCUDUFUHAIAJKLU
    CUIUDUCUIGUEUGMZCDZAUJQZUDUIUKUCUEUGRNUCULUIAOPUJASTUAUB $.

  $( Two things in a binary relation belong to the relation's domain.
     (Contributed by Thierry Arnoux, 29-Aug-2017.) $)
  brelg $p |- ( ( R C_ ( C X. D ) /\ A R B ) -> ( A e. C /\ B e. D ) ) $=
    ( cxp wss wbr wa wcel id ssbrd imp brxp sylib ) ECDFZGZABEHZIABPHZACJBDJIQR
    SQEPABQKLMABCDNO $.

  ${
    $d x y R $.
    $( Domain of an ordered-pair class abstraction.  (Contributed by Thierry
       Arnoux, 31-Aug-2017.) $)
    opabdm $p |- ( R = { <. x , y >. | ph } -> dom R = { x | E. y ph } ) $=
      ( copab wceq cdm cv wbr wex cab df-dm nfcv nfopab1 nfeq nfopab2 cop df-br
      wcel eleq2 opabid syl6bb syl5bb exbid abbid syl5eq ) DABCEZFZDGBHZCHZDIZC
      JZBKACJZBKBCDLUHULUMBBDUGBDMABCNOUHUKACCDUGCDMABCPOUKUIUJQZDSZUHAUIUJDRUH
      UOUNUGSADUGUNTABCUAUBUCUDUEUF $.

    $( Range of an ordered-pair class abstraction.  (Contributed by Thierry
       Arnoux, 31-Aug-2017.) $)
    opabrn $p |- ( R = { <. x , y >. | ph } -> ran R = { y | E. x ph } ) $=
      ( copab wceq crn cv wbr wex cab dfrn2 nfcv nfopab2 nfeq nfopab1 cop df-br
      wcel eleq2 opabid syl6bb syl5bb exbid abbid syl5eq ) DABCEZFZDGBHZCHZDIZB
      JZCKABJZCKBCDLUHULUMCCDUGCDMABCNOUHUKABBDUGBDMABCPOUKUIUJQZDSZUHAUIUJDRUH
      UOUNUGSADUGUNTABCUAUBUCUDUEUF $.
  $}


  ${
    $d x y z $.  $d z A $.  $d z B $.
    eqrelrd2.1 $e |- F/ x ph $.
    eqrelrd2.2 $e |- F/ y ph $.
    eqrelrd2.3 $e |- F/_ x A $.
    eqrelrd2.4 $e |- F/_ y A $.
    eqrelrd2.5 $e |- F/_ x B $.
    eqrelrd2.6 $e |- F/_ y B $.
    $( A subclass relationship depends only on a relation's ordered pairs.
       Theorem 3.2(i) of [Monk1] p. 33.  (Contributed by NM, 2-Aug-1994.)
       (Proof shortened by Andrew Salmon, 27-Aug-2011.)  (Revised by Thierry
       Arnoux, 6-Nov-2017.) $)
    ssrelf $p |- ( Rel A -> ( A C_ B <->
                A. x A. y ( <. x , y >. e. A -> <. x , y >. e. B ) ) ) $=
      ( vz wss cv wcel wi wal nfss alrimi nfel wrel cop ssel wceq wex nfv eleq1
      imbi12d biimprcd 2alimi nfcv nfim 19.23 albii bitri sylib com23 a2d alimd
      cvv cxp df-rel dfss2 elvv imbi2i 3bitri 3imtr4g com12 impbid2 ) DUAZDEMZB
      NCNUBZDOZVLEOZPZCQZBQZVKVPBBDEHJRVKVOCCDEIKRDEVLUCSSVQVJVKVQLNZDOZVRVLUDZ
      CUEZBUEZPZLQZVSVREOZPZLQVJVKVQWCWFLVQLUFVQVSWBWEVQWBVSWEVQVTWFPZCQZBQZWBW
      FPZVOWGBCVTWFVOVTVSVMWEVNVRVLDUGVRVLEUGUHUIUJWIWAWFPZBQWJWHWKBVTWFCVSWECC
      VRDCVRUKZITCVREWLKTULUMUNWAWFBVSWEBBVRDBVRUKZHTBVREWMJTULUMUOUPUQURUSVJDU
      TUTVAZMVSVRWNOZPZLQWDDVBLDWNVCWPWCLWOWBVSBCVRVDVEUNVFLDEVCVGVHVI $.

    eqrelrd2.7 $e |- ( ph -> ( <. x , y >. e. A <-> <. x , y >. e. B ) ) $.
    $( A version of ~ eqrelrdv2 with explicit non-free declarations.
       (Contributed by Thierry Arnoux, 28-Aug-2017.) $)
    eqrelrd2 $p |- ( ( ( Rel A /\ Rel B ) /\ ph ) -> A = B ) $=
      ( wrel wa cv wcel wb wal alrimi wss cop adantl wi ssrelf bi2anan9 2albiim
      wceq eqss 3bitr4g adantr mpbird ) DMZEMZNZANDEUGZBOCOUAZDPZUPEPZQZCRZBRZA
      VAUNAUTBFAUSCGLSSUBUNUOVAQAUNDETZEDTZNUQURUCCRBRZURUQUCCRBRZNUOVAULVBVDUM
      VCVEABCDEFGHIJKUDABCEDFGJKHIUDUEDEUHUQURBCUFUIUJUK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Functions - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( A different way to write ` F ` is a function.  (Contributed by Thierry
     Arnoux, 7-Dec-2016.) $)
  fdmrn $p |- ( Fun F <-> F : dom F --> ran F ) $=
    ( cdm crn wf wfn wfun wss ssid df-f mpbiran2 wceq eqid df-fn bitr2i ) ABZAC
    ZADZAOEZAFZQRPPGPHOPAIJRSOOKOLAOMJN $.

  $( An involution is a bijection.  (Contributed by Thierry Arnoux,
     7-Dec-2016.) $)
  nvof1o $p |- ( ( F Fn A /\ `' F = F ) -> F : A -1-1-onto-> A ) $=
    ( wfn ccnv wceq wa wf1 wfo wf1o wfun cdm crn fnfun fdmrn sylib adantr df-rn
    wf fndm sylanbrc syl5eq sylan9eqr feq23d mpbid wb funeq adantl mpbird df-f1
    dmeq simpl df-fo df-f1o ) BACZBDZBEZFZAABGZAABHZAABIUQAABRZUOJZURUQBKZBLZBR
    ZUTUNVDUPUNBJZVDABMZBNOPUQVBVCAABUNVBAEUPABSZPUPUNVCVBAUPVCUOKVBBQUOBUJUAVG
    UBZUCUDUQVAVEUNVEUPVFPUPVAVEUEUNUOBUFUGUHAABUITUQUNVCAEUSUNUPUKVHAABULTAABU
    MT $.

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x D $.  $d x y ph $.
    f1o3d.1 $e |- ( ph -> F = ( x e. A |-> C ) ) $.
    f1o3d.2 $e |- ( ( ph /\ x e. A ) -> C e. B ) $.
    f1o3d.3 $e |- ( ( ph /\ y e. B ) -> D e. A ) $.
    f1o3d.4 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) ->
                    ( x = D <-> y = C ) ) $.
    $( Describe an implicit one-to-one onto function.  (Contributed by Thierry
       Arnoux, 23-Apr-2017.) $)
    f1o3d $p |- ( ph -> ( F : A -1-1-onto-> B /\ `' F = ( y e. B |-> D ) ) ) $=
      ( ccnv wceq wfn wcel syl wa copab wi wf1o cmpt wral ralrimiva eqid fneq1d
      fnmpt mpbird cv eleq1a impr biimpar exp42 com34 imp32 jcai biimpa impbida
      com23 opabbidv df-mpt syl6eq cnveqd cnvopab a1i 3eqtr4d dff1o4 sylanbrc
      jca ) ADEHUAZHMZCEGUBZNAHDOZVKEOZVJAVMBDFUBZDOZAFEPZBDUCVPAVQBDJUDBDFVOEV
      OUEUGQADHVOIUFUHAVNVLEOZAGDPZCEUCVRAVSCEKUDCEGVLDVLUEUGQAEVKVLABUIZDPZCUI
      ZFNZRZCBSZWBEPZVTGNZRZCBSZVKVLAWDWHCBAWDWHAWDRWFWGAWAWCWFAWARVQWCWFTJFEWB
      UJQUKAWAWCWFWGTAWAWFWCWGAWAWFWCWGAWAWFRRZWGWCLULUMUNUOUPAWHRWAWCAWFWGWAAW
      FRVSWGWATKGDVTUJQUKAWFWGWAWCTAWFWAWGWCAWAWFWGWCTAWAWFWGWCWJWGWCLUQUMUSUNU
      OUPURUTAVKWDBCSZMWEAHWKAHVOWKIBCDFVAVBVCWDBCVDVBVLWINACBEGVAVEVFZUFUHDEHV
      GVHWLVI $.
  $}

  ${
    rinvbij.1 $e |- Fun F $.
    rinvbij.2 $e |- `' F = F $.
    rinvbij.3a $e |- ( F " A ) C_ B $.
    rinvbij.3b $e |- ( F " B ) C_ A $.
    rinvbij.4a $e |- A C_ dom F $.
    rinvbij.4b $e |- B C_ dom F $.
    $( Sufficient conditions for the restriction of an involution to be a
       bijection (Contributed by Thierry Arnoux, 7-Dec-2016.) $)
    rinvf1o $p |- ( F |` A ) : A -1-1-onto-> B $=
      ( cima cres wf1o cdm crn wf1 wss wfun mpbi mp2an wb wf fdmrn funeqi mpbir
      ccnv df-f1 mpbir2an f1ores funimass3 imaeq1i sseqtri eqssi f1oeq3 ax-mp
      wceq ) ACAJZCAKZLZABUQLZCMZCNZCOZAUTPURVBUTVACUAZCUEZQZCQZVCDCUBRVEVFDVDC
      EUCUDUTVACUFUGHUTVAACUHSUPBUOURUSTUPBFBVDAJZUPCBJAPZBVGPZGVFBUTPVHVITDIBA
      CUISRVDCAEUJUKULUPBAUQUMUNR $.
  $}

  ${
    $d x y z $.  $d y z A $.  $d y z F $.
    dfimafnf.1 $e |- F/_ x A $.
    dfimafnf.2 $e |- F/_ x F $.
    $( Alternate definition of the image of a function.  (Contributed by Raph
       Levien, 20-Nov-2006.)  (Revised by Thierry Arnoux, 24-Apr-2017.) $)
    dfimafnf $p |- ( ( Fun F /\ A C_ dom F ) ->
                  ( F " A ) = { y | E. x e. A y = ( F ` x ) } ) $=
      ( vz wfun cdm wss wa cima cv cfv wceq wrex cab wbr wcel nfcv ssel syl5bbr
      wb eqcom funbrfvb ex syl9r imp31 rexbidva abbidv dfima2 syl6reqr nffv nfv
      nfeq2 fveq2 eqeq2d cbvrexf abbii syl6eq ) DHZCDIZJZKZDCLZBMZGMZDNZOZGCPZB
      QZVFAMZDNZOZACPZBQVDVKVGVFDRZGCPZBQVEVDVJVQBVDVIVPGCVAVCVGCSZVIVPUCZVCVRV
      GVBSZVAVSCVBVGUAVAVTVSVIVHVFOVAVTKVPVHVFUDVGVFDUEUBUFUGUHUIUJGBDCUKULVJVO
      BVIVNGACGCTEAVFVHAVGDFAVGTUMUOVNGUNVGVLOVHVMVFVGVLDUPUQURUSUT $.
  $}

  ${
    $d w x y $.  $d w y A $.  $d y B $.  $d z y F $.
    funimass4f.1 $e |- F/_ x A $.
    funimass4f.2 $e |- F/_ x B $.
    funimass4f.3 $e |- F/_ x F $.
    $( use ~ ffnfvf $)
    $( Membership relation for the values of a function whose image is a
       subclass.  (Contributed by Thierry Arnoux, 24-Apr-2017.) $)
    funimass4f $p |- ( ( Fun F /\ A C_ dom F ) ->
                    ( ( F " A ) C_ B <-> A. x e. A ( F ` x ) e. B ) ) $=
      ( vy wfun cdm wss wa cima cv cfv wcel wral nfss nfan wceq nffun funfvima2
      nfdm nfima ssel sylan9 ralrimi cab dfimafnf adantr abrexss adantl eqsstrd
      wrex impbida ) DIZBDJZKZLZDBMZCKZANZDOZCPZABQZUSVALVDABUSVAAUPURAADGUAABU
      QEADGUCRSAUTCADBGEUDFRSUSVBBPVCUTPVAVDBVBDUBUTCVCUEUFUGUSVELUTHNVCTABUNHU
      HZCUSUTVFTVEAHBDEGUIUJVEVFCKUSAHBVCCFUKULUMUO $.
  $}

  ${
    $d x y ph $.  $d x C $.  $d x D $.  $d y A $.  $d y B $.
    mptcnv.1 $e |- ( ph -> ( ( x e. A /\ y = B ) <-> ( y e. C /\ x = D ) ) ) $.
    $( The converse of a mapping function.  (Contributed by Thierry Arnoux,
       16-Jan-2017.) $)
    mptcnv $p |- ( ph -> `' ( x e. A |-> B ) = ( y e. C |-> D ) ) $=
      ( cv wcel wceq wa copab ccnv cmpt cnvopab opabbidv syl5eq df-mpt cnveqi
      3eqtr4g ) ABIZDJCIZEKLZBCMZNZUCFJUBGKLZCBMZBDEOZNCFGOAUFUDCBMUHUDBCPAUDUG
      CBHQRUIUEBCDESTCBFGSUA $.
  $}

  $( Equality theorem for function predicate with domain.  (Contributed by
     Thierry Arnoux, 31-Jan-2017.) $)
  fneq12 $p |- ( ( F = G /\ A = B ) -> ( F Fn A <-> G Fn B ) ) $=
    ( wceq wa simpl simpr fneq12d ) CDEZABEZFABCDJKGJKHI $.

  $( Taking the converse image of a set can be limited to the range of the
     function used.  (Contributed by Thierry Arnoux, 21-Jan-2017.) $)
  fimacnvinrn $p |- ( Fun F -> ( `' F " A ) = ( `' F " ( A i^i ran F ) ) ) $=
    ( wfun ccnv crn cin cima cdm inpreima wf wceq wfo funforn fof sylbi fimacnv
    syl ineq2d cres cnvresima resdm2 funrel dfrel2 sylib syl5eq imaeq1d syl5eqr
    wrel cnveqd 3eqtrrd ) BCZBDZABEZFGULAGZULUMGZFUNBHZFZUNAUMBIUKUOUPUNUKUPUMB
    JZUOUPKUKUPUMBLURBMUPUMBNOUPUMBPQRUKUQBUPSZDZAGUNUPABTUKUTULAUKUSBUKUSULDZB
    BUAUKBUHVABKBUBBUCUDUEUIUFUGUJ $.

  $( Taking the converse image of a set can be limited to the range of the
     function used.  (Contributed by Thierry Arnoux, 17-Feb-2017.) $)
  fimacnvinrn2 $p |- ( ( Fun F /\ ran F C_ B ) ->
                                    ( `' F " A ) = ( `' F " ( A i^i B ) ) ) $=
    ( wfun crn wss ccnv cin cima inass wceq biimpi adantl ineq2d syl5eq imaeq2d
    wa dfss1 fimacnvinrn adantr 3eqtr4rd ) CDZCEZBFZQZCGZABHZUCHZIZUFAUCHZIZUFU
    GIZUFAIZUEUHUJUFUEUHABUCHZHUJABUCJUEUNUCAUDUNUCKZUBUDUOUCBRLMNOPUBULUIKUDUG
    CSTUBUMUKKUDACSTUA $.

  ${
    $d l A $.  $d l B $.  $d l W $.  $d k l Z $.  $d l ph $.
    suppss2f.p $e |- F/ k ph $.
    suppss2f.a $e |- F/_ k A $.
    suppss2f.w $e |- F/_ k W $.
    suppss2f.n $e |- ( ( ph /\ k e. ( A \ W ) ) -> B = Z ) $.
    $( Show that the support of a function is contained in a set.  (Contributed
       by Thierry Arnoux, 22-Jun-2017.) $)
    suppss2f $p |- ( ph -> ( `' ( k e. A |-> B ) " ( _V \ { Z } ) ) C_ W ) $=
      ( vl cvv cdif wcel crab wceq wa wi wsb bitri cmpt ccnv csn cima mptpreima
      eqid cv csb nfv nfcsb1v nfel1 csbeq1a eleq1d cbvrab wne eldifsni wn eldif
      nfcv sbt sbim sban sbf nfdif clelsb3f anbi12i wsbc sbsbc wb sbceq1g ax-mp
      vex imbi12i mpbi sylan2br expr necon1ad ss2rabdv cin dfin5 inss2 eqsstr3i
      syl5 syl6ss syl5eqss ) ADBCUAZUBLFUCMZUDCWGNZDBOZEDBCWGWFWFUFUEAWIDKUGZCU
      HZWGNZKBOZEWHWLDKBHKBUSWHKUIDWKWGDWJCUJUKDUGZWJPCWKWGDWJCULUMUNAWMWJENZKB
      OZEAWLWOKBWLWKFUOAWJBNZQZWOWKLFUPWRWOWKFAWQWOUQZWKFPZWQWSQAWJBEMZNZWTWJBE
      URAWNXANZQZCFPZRZDKSZAXBQZWTRZXFDKJUTXGXDDKSZXEDKSZRXIXDXEDKVAXJXHXKWTXJA
      DKSZXCDKSZQXHAXCDKVBXLAXMXBADKGVCKDXADBEHIVDVEVFTXKXEDWJVGZWTXEDKVHWJLNXN
      WTVIKVLDWJCFLVJVKTVMTVNVOVPVQWCVRWPBEVSEKBEVTBEWAWBWDWEWE $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y F $.  $d x y R $.  $d x y S $.
    fovcld.1 $e |- ( ph -> F : ( R X. S ) --> C ) $.
    $( Closure law for an operation.  (Contributed by NM, 19-Apr-2007.)
       (Revised by Thierry Arnoux, 17-Feb-2017.) $)
    fovcld $p |- ( ( ph /\ A e. R /\ B e. S ) -> ( A F B ) e. C ) $=
      ( vx vy wcel w3a wa cv co wral 3simpc cxp wceq eleq1d wf simprbi 3ad2ant1
      wfn ffnov syl oveq1 oveq2 rspc2v sylc ) ABEKZCFKZLUKULMINZJNZGOZDKZJFPIEP
      ZBCGOZDKZAUKULQAUKUQULAEFRZDGUAZUQHVAGUTUDUQIJEFDGUEUBUFUCUPUSBUNGOZDKIJB
      CEFUMBSUOVBDUMBUNGUGTUNCSVBURDUNCBGUHTUIUJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x F $.
    elovimad.1 $e |- ( ph -> A e. C ) $.
    elovimad.2 $e |- ( ph -> B e. D ) $.
    elovimad.3 $e |- Fun F $.
    elovimad.4 $e |- ( ph -> ( C X. D ) C_ dom F ) $.
    $( Elementhood of the image set of an operation value (Contributed by
       Thierry Arnoux, 13-Mar-2017.) $)
    elovimad $p |- ( ph -> ( A F B ) e. ( F " ( C X. D ) ) ) $=
      ( co cop cfv cxp cima df-ov wcel opelxpi syl2anc wfun cdm sseldd funfvima
      wi sylancr mpd syl5eqel ) ABCFKBCLZFMZFDENZOZBCFPAUHUJQZUIUKQZABDQCEQULGH
      BCDERSZAFTUHFUAZQULUMUDIAUJUOUHJUNUBUJUHFUCUEUFUG $.
  $}

  ${
    $d x y B $.  $d x y C $.  $d x y F $.  $d y G $.  $d x y .+ $.
    $d x y ph $.
    ofrn.1 $e |- ( ph -> F : A --> B ) $.
    ofrn.2 $e |- ( ph -> G : A --> B ) $.
    ofrn.3 $e |- ( ph -> .+ : ( B X. B ) --> C ) $.
    ofrn.4 $e |- ( ph -> A e. V ) $.
    $( The range of the function operation.  (Contributed by Thierry Arnoux,
       8-Jan-2017.) $)
    ofrn $p |- ( ph -> ran ( F oF .+ G ) C_ C ) $=
      ( vx vy co wf cv wcel wral syl cof crn wss cxp wfn ffnov simprbi r19.21bi
      wa anasss inidm off frn ) ABDFGEUAOZPUNUBDUCAMNBBBECCDFGHHAMQZCRZNQZCRUOU
      QEODRZAUPUIURNCAURNCSZMCACCUDZDEPZUSMCSZKVAEUTUEVBMNCCDEUFUGTUHUHUJIJLLBU
      KULBDUNUMT $.

    $d a z A $.  $d z B $.  $d a z F $.  $d a x z G $.  $d a z .+ $.
    $d a z ph $.  $d x y z a $.
    $( The range of the function operation.  (Contributed by Thierry Arnoux,
       21-Mar-2017.) $)
    ofrn2 $p |- ( ph -> ran ( F oF .+ G ) C_ ( .+ " ( ran F X. ran G ) ) ) $=
      ( vz va vx vy cv crn wcel syl cfv co wceq wrex cab cof cxp cima wa wfn wf
      ffn adantr simprl fnfvelrn syl2anc simprr rspceov syl3anc rexlimdvaa cmpt
      ss2abdv inidm eqidd offval rneqd eqid rnmpt syl6eq wss wb xpss12 ovelimab
      frn abbi2dv 3sstr4d ) AMQZNQZFUAZVRGUAZEUBZUCZNBUDZMUEZVQOQPQEUBUCPGRZUDO
      FRZUDZMUEFGEUFUBZRZEWFWEUGZUHZAWCWGMAWBWGNBAVRBSZWBUIZUIZVSWFSZVTWESZWBWG
      WNFBUJZWLWOAWQWMABCFUKZWQIBCFULTZUMAWLWBUNZBVRFUOUPWNGBUJZWLWPAXAWMABCGUK
      ZXAJBCGULTZUMWTBVRGUOUPAWLWBUQOPWFWEVSVTVQEURUSUTVBAWINBWAVAZRWDAWHXDANBB
      VSVTEBFGHHWSXCLLBVCAWLUIZVSVDXEVTVDVEVFNMBWAXDXDVGVHVIAWGMWKAECCUGZUJZWJX
      FVJZVQWKSWGVKAXFDEUKXGKXFDEULTAWFCVJZWECVJZXHAWRXIIBCFVNTAXBXJJBCGVNTWFCW
      ECVLUPOPXFWFWEVQEVMUPVOVP $.
  $}

  ${
    $d z A $.  $d z B $.  $d z C $.  $d y z G $.  $d x y z ph $.  $d x y S $.
    $d x y T $.  $d x y z F $.  $d x y z R $.  $d x y z U $.
    off2.1 $e |- ( ( ph /\ ( x e. S /\ y e. T ) ) -> ( x R y ) e. U ) $.
    off2.2 $e |- ( ph -> F : A --> S ) $.
    off2.3 $e |- ( ph -> G : B --> T ) $.
    off2.4 $e |- ( ph -> A e. V ) $.
    off2.5 $e |- ( ph -> B e. W ) $.
    off2.6 $e |- ( ph -> ( A i^i B ) = C ) $.
    $( The function operation produces a function - alternative form with all
       antecedents as deduction.  (Contributed by Thierry Arnoux,
       17-Feb-2017.) $)
    off2 $p |- ( ph -> ( F oF R G ) : C --> U ) $=
      ( vz cof co wf cv cfv cmpt wcel wa wral adantr cin inss1 syl6eqssr sselda
      ffvelrnd inss2 ralrimivva proplem2 syl21anc eqid fmptd wfn ffn syl offval
      eqidd mpteq1d eqtrd feq1d mpbird ) AFJKLGUBUCZUDFJUAFUAUEZKUFZVMLUFZGUCZU
      GZUDAUAFVPJVQAVMFUHZUIZVNHUHVOIUHBUECUEGUCJUHZCIUJBHUJZVPJUHVSDHVMKADHKUD
      ZVRPUKAFDVMAFDEULZDTDEUMUNUOUPVSEIVMLAEILUDZVRQUKAFEVMAFWCETDEUQUNUOUPAWA
      VRAVTBCHIOURUKBCHIJGVNVOUSUTVQVAVBAFJVLVQAVLUAWCVPUGVQAUADEVNVOGWCKLMNAWB
      KDVCPDHKVDVEAWDLEVCQEILVDVERSWCVAAVMDUHUIVNVGAVMEUHUIVOVGVFAUAWCFVPTVHVIV
      JVK $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.  $d x G $.  $d x R $.  $d x ph $.
    ofresid.1 $e |- ( ph -> F : A --> B ) $.
    ofresid.2 $e |- ( ph -> G : A --> B ) $.
    ofresid.3 $e |- ( ph -> A e. V ) $.
    $( Applying an operation restricted to the range of the functions does not
       change the function operation.  (Contributed by Thierry Arnoux,
       14-Feb-2018.) $)
    ofresid $p |- ( ph -> ( F oF R G ) = ( F oF ( R |` ( B X. B ) ) G ) ) $=
      ( vx cfv co cmpt cof wcel wa ffvelrnda syl df-ov cv cxp cres cop wceq jca
      opelxp sylibr fvres eqcomd 3eqtr4g mpteq2dva wfn ffn inidm offval 3eqtr4d
      wf eqidd ) AKBKUAZELZUTFLZDMZNKBVAVBDCCUBZUCZMZNEFDOMEFVEOMAKBVCVFAUTBPQZ
      VAVBUDZDLZVHVELZVCVFVGVJVIVGVHVDPZVJVIUEVGVACPZVBCPZQVKVGVLVMABCUTEHRABCU
      TFIRUFVAVBCCUGUHVHVDDUISUJVAVBDTVAVBVETUKULAKBBVAVBDBEFGGABCEUREBUMHBCEUN
      SZABCFURFBUMIBCFUNSZJJBUOZVGVAUSZVGVBUSZUPAKBBVAVBVEBEFGGVNVOJJVPVQVRUPUQ
      $.
  $}

  $(
    $d x y ph $. $d x C $. $d x D $. $d y A $. $d y B $.
    mptcnv.1 $e |- ( ph -> ( ( x e. A /\ y = B ) <-> ( y e. C /\ x = D ) ) ) $.
    #( The converse of a mapping function.
       (Contributed by Thierry Arnoux, 16-Jan-2017.) #)
    mptcnv   $p |- ( ph -> `' ( x e. A |-> B ) = ( y e. C |-> D ) ) $=
      ( cv wcel wceq wa copab ccnv cmpt cnvopab opabbidv eqtrd df-mpt
      a1i cnveqi 3eqtr4d ) ABIZDJCIZEKLZBCMZNZUDFJUCGKLZCBMZBDEOZNZCF
      GOZAUGUECBMZUIUGUMKAUEBCPTAUEUHCBHQRUKUGKAUJUFBCDESUATULUIKACBF
      GSTUB $.
      #( [16-Jan-2017] #)
  $)

  ${
    $d x y F $.  $d x y A $.  $d x B $.
    $( Preimage of a class union.  (Contributed by Thierry Arnoux,
       7-Feb-2017.) $)
    unipreima $p |- ( Fun F -> ( `' F " U. A ) = U_ x e. A ( `' F " x ) ) $=
      ( vy wfun cdm wfn ccnv cuni cima cv ciun wceq wcel wa wrex wb a1i 3bitr4d
      elpreima funfn cfv r19.42v bicomi eluni2 anbi2i rexbidv eliun eqrdv sylbi
      ) CECCFZGZCHZBIZJZABUMAKZJZLZMCUAULDUOURULDKZUKNZUSCUBZUNNZOZUSUQNZABPZUS
      UONUSURNZULUTVAUPNZABPZOZUTVGOZABPZVCVEVIVKQULVKVIUTVGABUCUDRVCVIQULVBVHU
      TAVABUEUFRULVDVJABUKUSUPCTUGSUKUSUNCTVFVEQULAUSBUQUHRSUIUJ $.
  $}

  ${
    $( The preimage of a subset is a subset of the preimage.  (Contributed by
       Brendan Leahy, 23-Sep-2017.) $)
    sspreima $p |- ( ( Fun F /\ A C_ B ) -> ( `' F " A ) C_ ( `' F " B ) ) $=
      ( wfun wss wa ccnv cima cin wceq inpreima biimpi imaeq2d sylan9req sylibr
      df-ss ) CDZABEZFCGZAHZSBHZIZTJTUAEQRUBSABIZHTABCKRUCASRUCAJABPLMNTUAPO $.
  $}

  $( Value of a function producing ordered pairs.  (Contributed by Thierry
     Arnoux, 3-Jan-2017.) $)
  opfv $p |- ( ( ( Fun F /\ ran F C_ ( _V X. _V ) ) /\ x e. dom F ) ->
             ( F ` x ) = <. ( ( 1st o. F ) ` x ) , ( ( 2nd o. F ) ` x ) >. ) $=
    ( wfun crn cvv cxp wss wa cv cdm wcel cfv c1st c2nd cop ccom simplr adantlr
    wceq fvco fvelrn sseldd 1st2ndb sylib opeq12d eqtr4d ) BCZBDZEEFZGZHAIZBJKZ
    HZUKBLZUNMLZUNNLZOZUKMBPLZUKNBPLZOZUMUNUIKUNUQSUMUHUIUNUGUJULQUGULUNUHKUJUK
    BUARUBUNUCUDUGULUTUQSUJUGULHURUOUSUPUKMBTUKNBTUERUF $.

  ${
    $d x F $.  $d x Y $.  $d x Z $.
    $( The preimage of a cross product is the intersection of the preimages of
       each component function.  (Contributed by Thierry Arnoux,
       6-Jun-2017.) $)
    xppreima $p |- ( ( Fun F /\ ran F C_ ( _V X. _V ) ) ->
      ( `' F " ( Y X. Z ) ) =
                   ( ( `' ( 1st o. F ) " Y ) i^i ( `' ( 2nd o. F ) " Z ) ) ) $=
      ( vx wfun cvv wss wa ccnv cima c1st wcel c2nd cdm crab cin wceq adantr wb
      cfv crn cxp ccom wfn funfn fncnvima2 sylbi cop fvco opeq12d eqeq2d eleq1d
      anbi12d elxp6 syl6rbbr adantlr opfv biantrurd wfo fo1st fofun ax-mp funco
      cv mpan ssv wf fof fdm mp2b sseqtr4i ssid funimass3 mpan2 mpbii syl6eleqr
      dmco fvimacnv syl2anc fo2nd 3bitr2d rabbidva eqtrd dfin5 ineq12i cnvimass
      sselda dmcoss sstri dfss1 mpbi inrab 3eqtr3ri syl6eq ) AEZAUAFFUBGZHZAIZB
      CUBZJZDVDZKAUCZIBJZLZXAMAUCZICJZLZHZDANZOZXCXFPZWQWTXAATZWSLZDXIOZXJWOWTX
      NQZWPWOAXIUDXOAUEDXIWSAUFUGRWQXMXHDXIWQXAXILZHZXMXLXAXBTZXAXETZUHZQZXRBLZ
      XSCLZHZHZYDXHWOXPXMYESWPWOXPHZYEXLXLKTZXLMTZUHZQZYGBLZYHCLZHZHXMYFYAYJYDY
      MYFXTYIXLYFXRYGXSYHXAKAUIZXAMAUIZUJUKYFYBYKYCYLYFXRYGBYNULYFXSYHCYOULUMUM
      XLBCUNUOUPXQYAYDDAUQURWOXPYDXHSWPYFYBXDYCXGYFXBEZXAXBNZLYBXDSWOYPXPKEZWOY
      PFFKUSZYRUTFFKVAVBKAVCVERYFXAWRKNZJZYQWOXIUUAXAWOAXIJZYTGZXIUUAGZUUBFYTUU
      BVFZYSFFKVGYTFQUTFFKVHFFKVIVJVKWOXIXIGZUUCUUDSXIVLZXIYTAVMVNVOWGKAVQVPXAB
      XBVRVSYFXEEZXAXENZLYCXGSWOUUHXPMEZWOUUHFFMUSZUUJVTFFMVAVBMAVCVERYFXAWRMNZ
      JZUUIWOXIUUMXAWOUUBUULGZXIUUMGZUUBFUULUUEUUKFFMVGUULFQVTFFMVHFFMVIVJVKWOU
      UFUUNUUOSUUGXIUULAVMVNVOWGMAVQVPXACXEVRVSUMUPWAWBWCXIXCPZXIXFPZPXDDXIOZXG
      DXIOZPXKXJUUPUURUUQUUSDXIXCWDDXIXFWDWEUUPXCUUQXFXCXIGUUPXCQXCYQXIXBBWFKAW
      HWIXCXIWJWKXFXIGUUQXFQXFUUIXIXECWFMAWHWIXFXIWJWKWEXDXGDXIWLWMWN $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x F $.  $d x G $.  $d x H $.
    $d x ph $.
    xppreima2.1 $e |- ( ph -> F : A --> B ) $.
    xppreima2.2 $e |- ( ph -> G : A --> C ) $.
    xppreima2.3 $e |- H = ( x e. A |-> <. ( F ` x ) , ( G ` x ) >. ) $.
    $( The preimage of a cross product is the intersection of the preimages of
       each component function.  (Contributed by Thierry Arnoux,
       7-Jun-2017.) $)
    xppreima2 $p |- ( ph -> ( `' H " ( Y X. Z ) ) =
                                         ( ( `' F " Y ) i^i ( `' G " Z ) ) ) $=
      ( ccnv cima c1st c2nd cvv wceq wfn cxp ccom cin crn wss cv cfv funmpt2 wf
      wfun cop wcel wa ffvelrnda opelxp sylanbrc fmptd frn xpss syl6ss xppreima
      syl sylancr wfo fo1st fofn ax-mp opex fnmpti ssv mp3an a1i ffn cdm adantr
      fnco simpr dmmpti syl6eleqr opfv syl21anc fvmpt2 syl2anc eqtr3d fvex opth
      sylib simpld eqfnfvd cnveqd imaeq1d fo2nd simprd ineq12d eqtrd ) AHNIJUAO
      ZPHUBZNZIOZQHUBZNZJOZUCZFNZIOZGNZJOZUCAHUJZHUDZRRUAZUEZWPXCSBCBUFZFUGZXLG
      UGZUKZHMUHZAXIDEUAZXJACXQHUIXIXQUEABCXOXQHAXLCULZUMZXMDULXNEULXOXQULZACDX
      LFKUNACEXLGLUNXMXNDEUOUPZMUQCXQHURVBDEUSUTZHIJVAVCAWSXEXBXGAWRXDIAWQFABCW
      QFWQCTZAPRTZHCTZXIRUEZYCRRPVDYDVERRPVFVGBCXOHXMXNVHZMVIZXIVJZRCPHVPVKVLAC
      DFUIFCTKCDFVMVBXSXLWQUGZXMSZXLWTUGZXNSZXSYJYLUKZXOSYKYMUMXSXLHUGZYNXOXSXH
      XKXLHVNZULYOYNSXHXSXPVLAXKXRYBVOXSXLCYPAXRVQZBCXOHYGMVRVSBHVTWAXSXRXTYOXO
      SYQYABCXOXQHMWBWCWDYJYLXMXNXLWQWEXLWTWEWFWGZWHWIWJWKAXAXFJAWTGABCWTGWTCTZ
      AQRTZYEYFYSRRQVDYTWLRRQVFVGYHYIRCQHVPVKVLACEGUIGCTLCEGVMVBXSYKYMYRWMWIWJW
      KWNWO $.
  $}

  ${
    $d x A $.  $d x B $.  $d x R $.  $d x S $.  $d x ph $.
    fmptapd.0a $e |- ( ph -> A e. _V ) $.
    fmptapd.0b $e |- ( ph -> B e. _V ) $.
    fmptapd.1 $e  |- ( ph -> ( R u. { A } ) = S ) $.
    fmptapd.2 $e  |- ( ( ph /\ x = A ) -> C = B ) $.
    $( Append an additional value to a function.  (Contributed by Thierry
       Arnoux, 3-Jan-2017.) $)
    fmptapd $p    |- ( ph ->
      ( ( x e. R |-> C ) u. { <. A , B >. } ) = ( x e. S |-> C ) ) $=
      ( cmpt cop csn cun cvv wcel wceq fmptsn syl2anc cv elsni sylan2 mpteq2dva
      eqtr4d uneq2d mptun a1i mpteq1d 3eqtr2d ) ABFELZCDMNZOUKBCNZELZOZBFUMOZEL
      ZBGELAULUNUKAULBUMDLZUNACPQDPQULURRHIBCDPPSTABUMEDBUAZUMQAUSCREDRUSCUBKUC
      UDUEUFUQUORABFUMEUGUHABUPGEJUIUJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x ph $.
    fmptpr.1 $e |- ( ph -> A e. V ) $.
    fmptpr.2 $e |- ( ph -> B e. W ) $.
    fmptpr.3 $e |- ( ph -> C e. X ) $.
    fmptpr.4 $e |- ( ph -> D e. Y ) $.
    fmptpr.5 $e |- ( ( ph /\ x = A ) -> E = C ) $.
    fmptpr.6 $e |- ( ( ph /\ x = B ) -> E = D ) $.
    $( Express a pair function in maps-to notation.  (Contributed by Thierry
       Arnoux, 3-Jan-2017.) $)
    fmptpr $p |- ( ph ->
      { <. A , C >. , <. B , D >. } = ( x e. { A , B } |-> E ) ) $=
      ( cun c0 wcel cop cpr csn cmpt wceq df-pr a1i uneq1i uncom un0 3eqtri cvv
      mpt0 elex syl eqtr3i fmptapd syl5eqr uneq1d eqcomi 3eqtrd ) ACEUAZDFUAZUB
      ZVBUCZVCUCZRZBCUCZGUDZVFRBCDUBZGUDVDVGUEAVBVCUFUGAVEVIVFAVEBSGUDZVERZVIVL
      SVERVESRVEVKSVEBGUMUHSVEUIVEUJUKABCEGSVHACHTCULTLCHUNUOAEJTEULTNEJUNUOSVH
      RZVHUEAVHSRVMVHVHSUIVHUJUPUGPUQURUSABDFGVHVJADITDULTMDIUNUOAFKTFULTOFKUNU
      OVHDUCRZVJUEAVJVNCDUFUTUGQUQVA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x F $.
    $( Condition for the membership in the union of the range of a function.
       (Contributed by Thierry Arnoux, 13-Nov-2016.) $)
    elunirn2 $p |- ( ( Fun F /\ B e. ( F ` A ) ) -> B e. U. ran F ) $=
      ( vx wfun cfv wcel wa crn cuni cdm wrex elfvdm wceq eleq2d rspcev mpancom
      cv fveq2 adantl wb elunirn adantr mpbird ) CEZBACFZGZHBCIJGZBDRZCFZGZDCKZ
      LZUGUMUEAULGUGUMBACMUKUGDAULUIANUJUFBUIACSOPQTUEUHUMUAUGDBCUBUCUD $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y V $.  $d y ps $.
    abfmpunirn.1 $e |- F = ( x e. V |-> { y | ph } ) $.
    abfmpunirn.2 $e |- { y | ph } e. _V $.
    abfmpunirn.3 $e |- ( y = B -> ( ph <-> ps ) ) $.
    $( Membership in a union of a mapping function-defined family of sets.
       (Contributed by Thierry Arnoux, 28-Sep-2016.) $)
    abfmpunirn $p |- ( B e. U. ran F <-> ( B e. _V /\ E. x e. V ps ) ) $=
      ( crn cuni wcel cvv wrex elex cab cv cfv wfn wb fnmpti fnunirn ax-mp wceq
      fvmpt2 mpan2 eleq2d rexbiia bitri elabg rexbidv syl5bb biadan2 ) EFKLZMZE
      NMZBCGOZEUOPUPEADQZMZCGOZUQURUPECRZFSZMZCGOZVAFGTUPVEUACGUSFIHUBCEFGUCUDV
      DUTCGVBGMZVCUSEVFUSNMVCUSUEICGUSNFHUFUGUHUIUJUQUTBCGABDENJUKULUMUN $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y V $.  $d y W $.  $d y ps $.
    rabfmpunirn.1 $e |- F = ( x e. V |-> { y e. W | ph } ) $.
    rabfmpunirn.2 $e |- W e. _V $.
    rabfmpunirn.3 $e |- ( y = B -> ( ph <-> ps ) ) $.
    $( Membership in a union of a mapping function-defined family of sets.
       (Contributed by Thierry Arnoux, 30-Sep-2016.) $)
    rabfmpunirn $p |- ( B e. U. ran F <-> E. x e. V ( B e. W /\ ps ) ) $=
      ( crn cuni wcel cvv wa wrex cv crab cmpt cab df-rab mpteq2i eqtri zfausab
      wceq eleq1 anbi12d abfmpunirn elex adantr rexlimivw pm4.71ri bitr4i ) EFL
      MNEONZEHNZBPZCGQZPURDRZHNZAPZUQCDEFGFCGADHSZTCGVADUAZTICGVBVCADHUBUCUDADH
      JUEUSEUFUTUPABUSEHUGKUHUIURUOUQUOCGUPUOBEHUJUKULUMUN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.  $d x y V $.  $d y W $.  $d x y ch $.
    $d x y ch $.  $d x y ph $.  $d z x $.
    abfmpeld.1 $e |- F = ( x e. V |-> { y | ps } ) $.
    abfmpeld.2 $e |- ( ph -> { y | ps } e. _V ) $.
    abfmpeld.3 $e |- ( ph -> ( ( x = A /\ y = B ) -> ( ps <-> ch ) ) ) $.
    $( Membership in an element of a mapping function-defined family of sets.
       (Contributed by Thierry Arnoux, 19-Oct-2016.) $)
    abfmpeld $p |- ( ph -> ( ( A e. V /\ B e. W ) ->
        ( B e. ( F ` A ) <-> ch ) ) ) $=
      ( wcel wa wb cab cvv wceq wal cfv wsbc alrimiv csbexg fvmpts sylan2 csbab
      csb syl6eq eleq2d adantl cv wi simpll ancomsd impl sbcied ex elabgt bitrd
      syl an13s ) AFINZGJNZOGFHUAZNZCPZVDVCAVGVDVCAOZOVFGBDFUBZEQZNZCVHVFVKPVDV
      HVEVJGVHVEDFBEQZUHZVJAVCVMRNZVEVMSAVLRNZDTVNAVODLUCDFVLRUDVADFVLIHRKUEUFB
      DEFUGUIUJUKVHVDEULGSZVICPZUMZETVKCPVHVREVHVPVQVHVPOBCDFIVCAVPUNVHVPDULFSZ
      BCPZAVPVSOVTUMVCAVSVPVTMUOUKUPUQURUCVICEGJUSUFUTVBUR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y F $.  $d x y V $.  $d y W $.  $d x y ps $.
    $d y W $.  $d z x $.
    abfmpel.1 $e |- F = ( x e. V |-> { y | ph } ) $.
    abfmpel.2 $e |- { y | ph } e. _V $.
    abfmpel.3 $e |- ( ( x = A /\ y = B ) -> ( ph <-> ps ) ) $.
    $( Membership in an element of a mapping function-defined family of sets.
       (Contributed by Thierry Arnoux, 19-Oct-2016.) $)
    abfmpel $p |- ( ( A e. V /\ B e. W ) -> ( B e. ( F ` A ) <-> ps ) ) $=
      ( wcel wa cab wb cvv wceq cv ancoms cfv wsbc csb csbex fvmpts mpan2 csbab
      syl6eq eleq2d adantr wi wal simpl adantll sbcied ex alrimiv elabgt sylan2
      bitrd ) EHMZFIMZNFEGUAZMZFACEUBZDOZMZBVAVDVGPVBVAVCVFFVAVCCEADOZUCZVFVAVI
      QMVCVIRCEVHKUDCEVHHGQJUEUFACDEUGUHUIUJVBVAVGBPZVAVBDSFRZVEBPZUKZDULVJVAVM
      DVAVKVLVAVKNABCEHVAVKUMVKCSERZABPZVAVNVKVOLTUNUOUPUQVEBDFIURUSTUT $.
  $}

  ${
    $d w x y z $.  $d w z A $.  $d w z A $.  $d w z B $.  $d w z C $.
    cbvmptf.1 $e |- F/_ x A $.
    cbvmptf.2 $e |- F/_ y A $.
    cbvmptf.3 $e |- F/_ y B $.
    cbvmptf.4 $e |- F/_ x C $.
    cbvmptf.5 $e |- ( x = y -> B = C ) $.
    $( Rule to change the bound variable in a maps-to function, using implicit
       substitution.  This version has bound-variable hypotheses in place of
       distinct variable conditions.  (Contributed by Thierry Arnoux,
       9-Mar-2017.) $)
    cbvmptf $p |- ( x e. A |-> B ) = ( y e. A |-> C ) $=
      ( vz vw cv wcel wceq wa copab cmpt nfv weq nfcri nfs1v nfan eleq1 sbequ12
      wsb anbi12d cbvopab1 nfeq2 nfsb eqeq2d sbhypf eqtri df-mpt 3eqtr4i ) AMZC
      NZKMZDOZPZAKQZBMZCNZUREOZPZBKQZACDRBCERVALMZCNZUSALUFZPZLKQVFUTVJAKLUTLSV
      HVIAALCFUAUSALUBUCALTUQVHUSVIUPVGCUDUSALUEUGUHVJVELKBVHVIBBLCGUAUSALBBURD
      HUIUJUCVELSLBTVHVCVIVDVGVBCUDUSVDALVBAUREIUIABTDEURJUKULUGUHUMAKCDUNBKCEU
      NUO $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y ph $.
    fmptdF.p $e |- F/ x ph $.
    fmptdF.a $e |- F/_ x A $.
    fmptdF.c $e |- F/_ x C $.
    fmptdF.1 $e |- ( ( ph /\ x e. A ) -> B e. C ) $.
    fmptdF.2 $e |- F = ( x e. A |-> B ) $.
    $( Domain and co-domain of the mapping operation; deduction form.  This
       version of ~ fmptd usex bound-variable hypothesis instead of distinct
       variable conditions.  (Contributed by Thierry Arnoux, 28-Mar-2017.) $)
    fmptdF $p |- ( ph -> F : A --> C ) $=
      ( vy wf cv csb wcel wa wsb bitri cvv cmpt wral sbimi sbf clelsb3f anbi12i
      sban wsbc sbsbc sbcel12 wceq vex csbconstgf eleq2i 3imtr3i ralrimiva nfcv
      ax-mp nfcsb1v csbeq1a cbvmptf fmpt sylib feq1i sylibr ) ACEBCDUAZMZCEFMAB
      LNZDOZEPZLCUBVGAVJLCABNCPZQZBLRZDEPZBLRZAVHCPZQZVJVLVNBLJUCVMABLRZVKBLRZQ
      VQAVKBLUGVRAVSVPABLGUDLBCHUEUFSVOVNBVHUHZVJVNBLUIVTVIBVHEOZPVJBVHDEUJWAEV
      IVHTPWAEUKLULBVHETIUMURUNSSUOUPLCEVIVFBLCDVIHLCUQLDUQBVHDUSBVHDUTVAVBVCCE
      FVFKVDVE $.
  $}

  ${
    $d x A $.  $d x C $.  $d x ph $.
    fmpt3d.1 $e |- ( ph -> F = ( x e. A |-> B ) ) $.
    fmpt3d.2 $e |- ( ( ph /\ x e. A ) -> B e. C ) $.
    $( Domain and co-domain of the mapping operation; deduction form.
       (Contributed by Thierry Arnoux, 4-Jun-2017.) $)
    fmpt3d $p |- ( ph -> F : A --> C ) $=
      ( wf cmpt eqid fmptd feq1d mpbird ) ACEFICEBCDJZIABCDEOHOKLACEFOGMN $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    resmptf.a $e |- F/_ x A $.
    resmptf.b $e |- F/_ x B $.
    $( Restriction of the mapping operation.  (Contributed by Thierry Arnoux,
       28-Mar-2017.) $)
    resmptf $p |- ( B C_ A -> ( ( x e. A |-> C ) |` B ) = ( x e. B |-> C ) ) $=
      ( vy wss cv cmpt cres resmpt nfcv nfcsb1v csbeq1a cbvmptf reseq1i 3eqtr4g
      csb ) CBHGBAGIZDSZJZCKGCUAJABDJZCKACDJGBCUALUCUBCAGBDUAEGBMGDMZATDNZATDOZ
      PQAGCDUAFGCMUDUEUFPR $.
  $}

  ${
    $d x y $.  $d y z A $.  $d y z B $.  $d y D $.  $d y z F $.
    fvmpt2f.0 $e |- F/_ x A $.
    $( Value of a function given by the "maps to" notation.  (Contributed by
       Thierry Arnoux, 9-Mar-2017.) $)
    fvmpt2f $p |- ( ( x e. A /\ B e. C ) -> ( ( x e. A |-> B ) ` x ) = B ) $=
      ( vy csb cmpt weq csbeq1 csbid syl6eq nfcv nfcsb1v csbeq1a cbvmptf fvmptg
      cv ) FARZAFRZCGZCBDABCHFAIUAASCGCATSCJACKLAFBCUAEFBMFCMATCNATCOPQ $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    mptfnf.0 $e |- F/_ x A $.
    $( The maps-to notation defines a function with domain.  (Contributed by
       Scott Fenton, 21-Mar-2011.)  (Revised by Thierry Arnoux,
       10-May-2017.) $)
    mptfnf $p |- ( A. x e. A B e. _V <-> ( x e. A |-> B ) Fn A ) $=
      ( vy wcel wral cv wceq wfn ralbii wex wmo wa wal wi albii df-ral 3bitr4ri
      cab cvv weu cmpt eueq r19.26 eu5 copab wfun cdm df-mpt fneq1i df-fn bitri
      moanimv funopab eqcom dmopab 19.42v abbii eqeq1i wb pm4.71 abeq2f 3bitr4i
      eqtri anbi12i ancom 3bitr2i bitr4i ) CUAFZABGEHCIZEUBZABGZABCUCZBJZVJVLAB
      ECUDKVKELZVKEMZNZABGVPABGZVQABGZNZVMVOVPVQABUEVLVRABVKEUFKVOAHBFZVKNZAEUG
      ZUHZWDUIZBIZNZVTVSNWAVOWDBJWHBVNWDAEBCUJUKWDBULUMVTWEVSWGWCEMZAOWBVQPZAOW
      EVTWIWJAWBVKEUNQWCAEUOVQABRSWBVPNZATZBIBWLIZWGVSWLBUPWFWLBWFWCELZATWLWCAE
      UQWNWKAWBVKEURUSVEUTWBVPPZAOWBWKVAZAOVSWMWOWPAWBVPVBQVPABRWKABDVCVDSVFVTV
      SVGVHSVI $.

    $( The maps-to notation defines a function with domain.  (Contributed by
       NM, 9-Apr-2013.)  (Revised by Thierry Arnoux, 10-May-2017.) $)
    fnmptf $p |- ( A. x e. A B e. V -> ( x e. A |-> B ) Fn A ) $=
      ( wcel wral cvv cmpt wfn elex ralimi mptfnf sylib ) CDFZABGCHFZABGABCIBJO
      PABCDKLABCEMN $.
  $}

  ${
    $d x y $.  $d y A $.  $d y F $.
    feqmptdf.1 $e |- F/_ x A $.
    feqmptdf.2 $e |- F/_ x F $.
    feqmptdf.3 $e |- ( ph -> F : A --> B ) $.
    $( Deduction form of ~ dffn5f .  (Contributed by Mario Carneiro,
       8-Jan-2015.)  (Revised by Thierry Arnoux, 10-May-2017.) $)
    feqmptdf $p |- ( ph -> F = ( x e. A |-> ( F ` x ) ) ) $=
      ( vy wf wfn cv cfv cmpt wceq ffn wcel wa copab wbr wrel fnrel nfcv dfrel4
      sylib nffn nfv fnbr pm4.71rd eqcom fnbrfvb syl5bb pm5.32da bitr4d opabbid
      ex eqtrd df-mpt syl6eqr 3syl ) ACDEJECKZEBCBLZEMZNZOHCDEPVAEVBCQZILZVCOZR
      ZBISZVDVAEVBVFETZBISZVIVAEUAEVKOCEUBBIEGIEUCUDUEVAVJVHBIBCEGFUFVAIUGVAVJV
      EVJRVHVAVJVEVAVJVECVBVFEUHUPUIVAVEVGVJVGVCVFOVAVERVJVFVCUJCVBVFEUKULUMUNU
      OUQBICVCURUSUT $.
  $}

  ${
    $d u v w x y z $.  $d u v w z A $.  $d u y B $.  $d u w z F $.
    $d u w z G $.  $d u y R $.  $d u x S $.  $d u v w y z T $.  $d u w z ph $.
    fmptcof2.1 $e |- F/_ x A $.
    fmptcof2.2 $e |- F/_ x B $.
    fmptcof2.3 $e |- F/ x ph $.
    fmptcof2.4 $e |- ( ph -> A. x e. A R e. B ) $.
    fmptcof2.5 $e |- ( ph -> F = ( x e. A |-> R ) ) $.
    fmptcof2.6 $e |- ( ph -> G = ( y e. B |-> S ) ) $.
    fmptcof2.7 $e |- ( y = R -> S = T ) $.
    $( Composition of two functions expressed as ordered-pair class
       abstractions.  (Contributed by FL, 21-Jun-2012.)  (Revised by Mario
       Carneiro, 24-Jul-2014.)  (Revised by Thierry Arnoux, 10-May-2017.) $)
    fmptcof2 $p |- ( ph -> ( G o. F ) = ( x e. A |-> T ) ) $=
      ( wa wcel wceq vz vw vu ccom cmpt relco wfun wrel funmpt funrel ax-mp wbr
      vv cv wex csb cop cfv wf r19.21bi eqid fmptdF mpbird ffun syl funbrfv imp
      feq1d sylan eqcomd a1d expimpd pm4.71rd exbidv fvex breq2 anbi12d ceqsexv
      breq1 cdm wb funfvbrb fdm eleq2d bitr3d fveq1d eqidd breq123d wi nffvmpt1
      nfcri nfcv nfmpt nfbr nfcsb1v nfeq2 nfbi nfim eleq1 breq1d csbeq1a eqeq2d
      fveq2 bibi12d imbi2d imbi12d cvv simpl eleq1d simpr adantr eqeq12d df-mpt
      vex brabga sylancl fvmpt2f syl2anc biantrurd expcom chvar impcom pm5.32da
      3bitr4d bitrd syl5bb opelco copab eleq2i nfv eqeq1 anbi2d opelopabf bitri
      nfan 3bitr4g eqrelrdv ) AUAUBJIUDZBDHUEZJIUFYSUGYSUHBDHUIYSUJUKAUAUNZUCUN
      ZIULZUUAUBUNZJULZRZUCUOZYTDSZUUCBYTHUPZTZRZYTUUCUQZYRSUUKYSSZAUUFUUAYTIUR
      ZTZUUERZUCUOZUUJAUUEUUOUCAUUEUUNAUUBUUDUUNAUUBRZUUNUUDUUQUUMUUAAIUGZUUBUU
      MUUATZADEIUSZUURAUUTDEBDFUEZUSABDFEUVAMKLAFESZBDNUTZUVAVAVBADEIUVAOVHVCZD
      EIVDVEZUURUUBUUSYTUUAIVFVGVIVJVKVLVMVNUUPYTUUMIULZUUMUUCJULZRZAUUJUUEUVHU
      CUUMYTIVOUUNUUBUVFUUDUVGUUAUUMYTIVPUUAUUMUUCJVSVQVRAUVHUUGYTUVAURZUUCCEGU
      EZULZRUUJAUVFUUGUVGUVKAYTIVTZSZUVFUUGAUURUVMUVFWAUVEYTIWBVEAUVLDYTAUUTUVL
      DTUVDDEIWCVEWDWEAUUMUVIUUCUUCJUVJAYTIUVAOWFPAUUCWGWHVQAUUGUVKUUIUUGAUVKUU
      IWAZBUNZDSZAUVOUVAURZUUCUVJULZUUCHTZWAZWIZWIUUGAUVNWIZWIBUAUUGUWBBBUADKWK
      ZAUVNBMUVKUUIBBUVIUUCUVJBDFYTWJBCEGLBGWLWMBUUCWLWNBUUCUUHBYTHWOZWPWQWRWRU
      VOYTTZUVPUUGUWAUWBUVOYTDWSZUWEUVTUVNAUWEUVRUVKUVSUUIUWEUVQUVIUUCUVJUVOYTU
      VAXCWTUWEHUUHUUCBYTHXAZXBXDXEXFAUVPUVTAUVPRZFUUCUVJULZUVBUVSRZUVRUVSUWHUV
      BUUCXGSUWIUWJWAUVCUBXNZCUNZESZUUAGTZRUWJCUCFUUCUVJEXGUWLFTZUUAUUCTZRZUWMU
      VBUWNUVSUWQUWLFEUWOUWPXHXIUWQUUAUUCGHUWOUWPXJUWOGHTUWPQXKXLVQCUCEGXMXOXPU
      WHUVQFUUCUVJUWHUVPUVBUVQFTAUVPXJUVCBDFEKXQXRWTUWHUVBUVSUVCXSYDXTYAYBYCYEY
      FYEUCYTUUCJIUAXNZUWKYGUULUUKUVPUMUNZHTZRZBUMYHZSUUJYSUXBUUKBUMDHXMYIUXAUU
      GUWSUUHTZRUUJBUMYTUUCUUGUXCBUWCBUWSUUHUWDWPYOUUJUMYJUWRUWKUWEUVPUUGUWTUXC
      UWFUWEHUUHUWSUWGXBVQUWSUUCTUXCUUIUUGUWSUUCUUHYKYLYMYNYPYQ $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x C $.  $d x y D $.  $d x E $.
    fcomptf.1 $e |- F/_ x B $.
    $( Express composition of two functions as a maps-to applying both in
       sequence.  This version has one less distinct variable restriction
       compared to ~ fcompt .  (Contributed by Thierry Arnoux, 30-Jun-2017.) $)
    fcomptf $p |- ( ( A : D --> E /\ B : C --> D ) -> ( A o. B ) = ( x e. C |->
        ( A ` ( B ` x ) ) ) ) $=
      ( vy wf wa cv cfv wcel nfcv nff wfn cmpt wceq ffn sylib ffvelrn ex adantl
      nfan adantll ralrimi dffn5f adantr dffn5 fveq2 fmptcof ) EFBIZDECIZJZAHDE
      AKZCLZHKZBLZUPBLCBUNUPEMZADULUMAAEFBABNAENZAFNOADECGADNUTOUDUNUODMZUSUMVA
      USULDEUOCUAUEUBUFUNCDPZCADUPQRUMVBULDECSUCADCGUGTUNBEPZBHEURQRULVCUMEFBSU
      HHEBUITUQUPBUJUK $.
  $}

  ${
    $d x A $.  $d y B $.  $d x y C $.  $d x y F $.  $d x ph $.
    cofmpt.1 $e |- ( ph -> F : C --> D ) $.
    cofmpt.2 $e |- ( ( ph /\ x e. A ) -> B e. C ) $.
    $( Express composition of a maps-to function with another function in a
       maps-to notation.  (Contributed by Thierry Arnoux, 29-Jun-2017.) $)
    cofmpt $p |- ( ph ->
                     ( F o. ( x e. A |-> B ) ) = ( x e. A |-> ( F ` B ) ) ) $=
      ( vy cv cfv cmpt eqidd feqmptd fveq2 fmptco ) ABJCEDJKZGLDGLBCDMZGIASNAJE
      FGHORDGPQ $.
  $}

  ${
    $d a x y A $.  $d a x y B $.  $d a x y C $.  $d a x y F $.  $d a x y G $.
    $d a N $.  $d a x y R $.  $d a x y ph $.
    ofoprabco.1 $e |- F/_ a M $.
    ofoprabco.2 $e |- ( ph -> F : A --> B ) $.
    ofoprabco.3 $e |- ( ph -> G : A --> C ) $.
    ofoprabco.4 $e |- ( ph -> A e. V ) $.
    ofoprabco.5 $e |- ( ph ->
                            M = ( a e. A |-> <. ( F ` a ) , ( G ` a ) >. ) ) $.
    ofoprabco.6 $e |- ( ph -> N = ( x e. B , y e. C |-> ( x R y ) ) ) $.
    $( Function operation as a composition with an operation.  (Contributed by
       Thierry Arnoux, 4-Jun-2017.) $)
    ofoprabco $p |- ( ph -> ( F oF R G ) = ( N o. M ) ) $=
      ( cvv cv cfv cmpt ccom cof wcel cop cxp ffvelrnda opelxpi syl2anc fvmpt2d
      co wa fveq2d df-ov a1i cmpt2 adantr simprl simprr oveq12d ovmpt2d 3eqtr2d
      wceq ovex mpteq2dva wf wral rgen2w eqid fmpt2 feq1d mpbiri fmpt3d fcomptf
      mpbi feqmptd offval2 3eqtr4rd ) AMDMUAZJUBZKUBZUCZMDWAHUBZWAIUBZGUMZUCKJU
      DZHIGUEUMAMDWCWGAWADUFZUNZWCWEWFUGZKUBZWEWFKUMZWGWJWBWKKAMDWKJEFUHZRWJWEE
      UFWFFUFWKWNUFADEWAHOUIZADFWAIPUIZWEWFEFUJUKZULUOWMWLVEWJWEWFKUPUQWJBCWEWF
      EFBUAZCUAZGUMZWGKTAKBCEFWTURZVEWISUSWJWRWEVEZWSWFVEZUNUNWRWEWSWFGWJXBXCUT
      WJXBXCVAVBWOWPWGTUFWJWEWFGVFUQVCVDVGAWNTKVHZDWNJVHWHWDVEAXDWNTXAVHZWTTUFZ
      CFVIBEVIXEXFBCEFWRWSGVFVJBCEFWTTXAXAVKVLVQAWNTKXASVMVNAMDWKWNJRWQVOMKJDWN
      TNVPUKAMDWEWFGHILEFQWOWPAMDEHOVRAMDFIPVRVSVT $.
  $}

  ${
    $d y z A $.  $d y z B $.  $d y z C $.  $d y F $.  $d y G $.  $d y ph $.
    $d x y z R $.
    offval2f.0 $e |- F/ x ph $.
    offval2f.a $e |- F/_ x A $.
    offval2f.1 $e |- ( ph -> A e. V ) $.
    offval2f.2 $e |- ( ( ph /\ x e. A ) -> B e. W ) $.
    offval2f.3 $e |- ( ( ph /\ x e. A ) -> C e. X ) $.
    offval2f.4 $e |- ( ph -> F = ( x e. A |-> B ) ) $.
    offval2f.5 $e |- ( ph -> G = ( x e. A |-> C ) ) $.
    $( The function operation expressed as a mapping.  (Contributed by Thierry
       Arnoux, 23-Jun-2017.) $)
    offval2f $p |- ( ph -> ( F oF R G ) = ( x e. A |-> ( B R C ) ) ) $=
      ( vy cmpt cof co cv cfv wfn wcel wral ex ralrimi fnmptf syl fneq1d mpbird
      inidm wa wceq adantr fveq1d offval nfcv nffvmpt1 nfov fveq2 oveq12d simpr
      cbvmptf fvmpt2f syl2anc mpteq2da syl5eq eqtrd ) AGHFUAUBSCSUCZBCDTZUDZVLB
      CETZUDZFUBZTZBCDEFUBZTZASCCVNVPFCGHIIAGCUEVMCUEZADJUFZBCUGWAAWBBCLABUCZCU
      FZWBOUHUIBCDJMUJUKACGVMQULUMAHCUEVOCUEZAEKUFZBCUGWEAWFBCLAWDWFPUHUIBCEKMU
      JUKACHVORULUMNNCUNAVLCUFZUOZVLGVMAGVMUPWGQUQURWHVLHVOAHVOUPWGRUQURUSAVRBC
      WCVMUDZWCVOUDZFUBZTVTSBCVQWKSCUTMBVNVPFBCDVLVABFUTBCEVLVAVBSWKUTVLWCUPVNW
      IVPWJFVLWCVMVCVLWCVOVCVDVFABCWKVSLAWDUOZWIDWJEFWLWDWBWIDUPAWDVEZOBCDJMVGV
      HWLWDWFWJEUPWMPBCEKMVGVHVDVIVJVK $.
  $}

  ${
    $d p q s x y A $.  $d s x y B $.  $d s x y C $.  $d p q D $.
    $d p q s x y F $.  $d p q s x y G $.  $d p q s x y R $.  $d p q s x y ph $.
    ofpreima.1 $e |- ( ph -> F : A --> B ) $.
    ofpreima.2 $e |- ( ph -> G : A --> C ) $.
    ofpreima.3 $e |- ( ph -> A e. V ) $.
    ofpreima.4 $e |- ( ph -> R Fn ( B X. C ) ) $.
    $( Express the preimage of a function operation as a union of preimages.
       (Contributed by Thierry Arnoux, 8-Mar-2018.) $)
    ofpreima $p |- ( ph -> ( `' ( F oF R G ) " D ) = U_ p e. ( `' R " D )
         ( ( `' F " { ( 1st ` p ) } ) i^i ( `' G " { ( 2nd ` p ) } ) ) ) $=
      ( vs vq cfv wceq wcel wa vx vy cof co ccnv cima cv cop cmpt c1st csn c2nd
      cin ciun ccom nfmpt1 eqidd cmpt2 fnov sylib ofoprabco cnveqd cnvco syl6eq
      cxp wfn imaeq1d imaco wbr wrex cab dfima2 vex brcnv cdm wfun wb funbrfv2b
      funmpt ax-mp opex dmmpti eleq2i anbi1i bitri fveq2 opeq12d eqeq1d pm5.32i
      eqid fvmpt 3bitri rexbii abbii nfv nfab1 nfcv eliun elin wf fniniseg 3syl
      ffn anbi12d anandi syl6bbr syl5bb adantr cnvimass fndm syl sselda 1st2nd2
      syl5sseq fvex opth syl6bb anbi2d bitr4d rexbidva abid syl5rbb eqrd syl5eq
      eqeq2 eqtrd ) AGHFUCUDZUEZEUFZOBOUGZGQZYJHQZUHZUIZUEZFUEZEUFZUFZJYQGUEJUG
      ZUJQZUKUFZHUEYSULQZUKUFZUMZUNZAYIYOYPUOZEUFYRAYHUUFEAYHFYNUOZUEUUFAYGUUGA
      UAUBBCDFGHYNFIOOBYMUPKLMAYNUQAFCDVEZVFZFUAUBCDUAUGUBUGFUDURRNUAUBCDFUSUTV
      AVBFYNVCVDVGYOYPEVHVDAYRYSPUGZYOVIZJYQVJZPVKZUUEJPYOYQVLAUUMUUJBSZUUJGQZU
      UJHQZUHZYSRZTZJYQVJZPVKZUUEUULUUTPUUKUUSJYQUUKUUJYSYNVIZUUNUUJYNQZYSRZTZU
      USYSUUJYNJVMPVMVNUVBUUJYNVOZSZUVDTZUVEYNVPUVBUVHVQOBYMVSUUJYSYNVRVTUVGUUN
      UVDUVFBUUJOBYMYNYKYLWAYNWJZWBWCWDWEUUNUVDUURUUNUVCUUQYSOUUJYMUUQBYNYJUUJR
      YKUUOYLUUPYJUUJGWFYJUUJHWFWGUVIUUOUUPWAWKWHWIWLWMWNAPUVAUUEAPWOUUTPWPPUUE
      WQUUJUUESUUJUUDSZJYQVJZAUUJUVASZJUUJYQUUDWRAUVKUUTUVLAUVJUUSJYQAYSYQSZTZU
      VJUUNUUOYTRZUUPUUBRZTZTZUUSAUVJUVRVQUVMUVJUUJUUASZUUJUUCSZTZAUVRUUJUUAUUC
      WSAUWAUUNUVOTZUUNUVPTZTUVRAUVSUWBUVTUWCABCGWTGBVFUVSUWBVQKBCGXCBYTUUJGXAX
      BABDHWTHBVFUVTUWCVQLBDHXCBUUBUUJHXAXBXDUUNUVOUVPXEXFXGXHUVNUURUVQUUNUVNUU
      RUUQYTUUBUHZRZUVQUVNYSUUHSYSUWDRUURUWEVQAYQUUHYSAFVOZYQUUHFEXIAUUIUWFUUHR
      NUUHFXJXKXNXLYSCDXMYSUWDUUQYEXBUUOUUPYTUUBUUJGXOUUJHXOXPXQXRXSXTUUTPYAXFY
      BYCYDYDYF $.

    $( Express the preimage of a function operation as a union of preimages.
       This version of ~ ofpreima iterates the union over a smaller set.
       (Contributed by Thierry Arnoux, 8-Mar-2018.) $)
    ofpreima2 $p |- ( ph -> ( `' ( F oF R G ) " D ) =
         U_ p e. ( ( `' R " D ) i^i ( ran F X. ran G ) )
         ( ( `' F " { ( 1st ` p ) } ) i^i ( `' G " { ( 2nd ` p ) } ) ) ) $=
      ( cin ciun wceq syl6eq c0 syl cof co ccnv cima crn cxp c1st cfv c2nd cdif
      cv csn cun ofpreima inundif iuneq1 ax-mp iunxun eqtr3i wral wcel wa wo wn
      simpr eldifbd cop wi difssd cdm cnvimass wfn fndm syl5sseq sselda 1st2nd2
      sstrd elxp6 biimpri ex con3d mpd ianor sylib disjsn orbi12i sylibr wf ffn
      3syl dffn3 fimacnvdisj ineq1 incom in0 eqtri ineq2 jaao syl2anc ralrimiva
      adantr iuneq2 iun0 uneq2d un0 eqtrd ) AGHFUAUBUCEUDZJFUCEUDZGUEZHUEZUFZOZ
      GUCJUKZUGUHZULZUDZHUCXMUIUHZULZUDZOZPZJXHXKUJZXTPZUMZYAAXGJXHXTPZYDABCDEF
      GHIJKLMNUNJXLYBUMZXTPZYEYDYFXHQYGYEQXHXKUOJYFXHXTUPUQJXLYBXTURUSRAYDYASUM
      YAAYCSYAAYCJYBSPZSAXTSQZJYBUTYCYHQAYIJYBAXMYBVAZVBZXIXOOSQZXJXROSQZVCZYIY
      KXNXIVAZVDZXQXJVAZVDZVCZYNYKYOYQVBZVDZYSYKXMXKVAZVDUUAYKXMXHXKAYJVEVFYKYT
      UUBYKXMCDUFZVAXMXNXQVGQZYTUUBVHAYBUUCXMAYBXHUUCAXHXKVIAFVJZXHUUCFEVKAFUUC
      VLUUEUUCQNUUCFVMTVNVQVOXMCDVPUUDYTUUBUUBUUDYTVBXMXIXJVRVSVTWJWAWBYOYQWCWD
      YLYPYMYRXIXNWEXJXQWEWFWGYKBXIGWHZBXJHWHZYNYIVHAUUFYJAGBVLZUUFABCGWHUUHKBC
      GWITBGWKWDXAAUUGYJAHBVLZUUGABDHWHUUILBDHWITBHWKWDXAUUFYLYIUUGYMUUFYLYIUUF
      YLVBXPSQZYIBXIXOGWLUUJXTSXSOZSXPSXSWMUUKXSSOSSXSWNXSWOWPRTVTUUGYMYIUUGYMV
      BXSSQZYIBXJXRHWLUULXTXPSOSXSSXPWQXPWORTVTWRWSWBWTJYBXTSXBTJYBXCRXDYAXERXF
      $.
  $}

  ${
    $d w x y z $.  $d w A $.  $d w B $.  $d y F $.  $d y z ph $.
    funcnvmpt.0 $e |- F/ x ph $.
    funcnvmpt.1 $e |- F/_ x A $.
    funcnvmpt.2 $e |- F/_ x F $.
    funcnvmpt.3 $e |- F = ( x e. A |-> B ) $.
    funcnvmpt.4 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    $( Condition for a function in maps-to notation to be single-rooted.
       (Contributed by Thierry Arnoux, 28-Feb-2017.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    funcnvmptOLD $p |- ( ph ->
              ( Fun `' F <-> A. y E* x ( x e. A /\ y = B ) ) ) $=
      ( wfun cv wmo wal wcel wceq wa wb ccnv wbr wrel relcnv nfcv nfcnv dffun6f
      mpbiran vex brcnv mobii albii bitri nfv cfv funmpt funeqi mpbir funbrfv2b
      cdm cmpt ax-mp cvv crab wral syl ex ralrimi rabid2f sylibr dmmpt syl6reqr
      eleq2d anbi1d syl5bb bian1d fveq1i simpr fvmpt2f syl2anc syl5eq eqeq2d wi
      elex biimpar funbrfvb sylancr eqcom bibi1i imbi2i bitr3d pm5.32d 3bitr4rd
      mpbi mobid albid ) FUAZMZBNZCNZFUBZBOZCPZAWSDQZWTERZSZBOZCPWRWTWSWQUBZBOZ
      CPZXCWRWQUCXJFUDCBWQCWQUEBFJUFUGUHXIXBCXHXABWTWSFCUIBUIUJUKULUMAXBXGCACUN
      AXAXFBHAXDXASXDWSFUOZWTRZSZXFXAAXAXDXLXAWSFUTZQZXLSZAXMFMZXAXPTXQBDEVAZMB
      DEUPFXRKUQURZWSWTFUSVBAXOXDXLAXNDWSADEVCQZBDVDZXNAXTBDVEDYARAXTBDHAXDXTAX
      DSZEGQZXTLEGWDVFVGVHXTBDIVIVJBDEFKVKVLVMZVNVOZVPAXDXEXAAXDXEXATYBWTXKRZXE
      XAYBXKEWTYBXKWSXRUOZEWSFXRKVQYBXDYCYGERAXDVRLBDEGIVSVTWAWBYBXLXATZWCYBYFX
      ATZWCYBXQXOYHXSAXOXDYDWEWSWTFWFWGYHYIYBXLYFXAXKWTWHWIWJWNWKVGWLYEWMWOWPVO
      $.

    $( Condition for a function in maps-to notation to be single-rooted.
       (Contributed by Thierry Arnoux, 28-Feb-2017.) $)
    funcnvmpt $p |- ( ph -> ( Fun `' F <-> A. y E* x e. A y = B ) ) $=
      ( wfun cv wbr wmo wal wceq wcel wa ccnv wrmo relcnv nfcnv dffun6f mpbiran
      wrel nfcv vex brcnv mobii albii bitri cfv cdm funmpt2 funbrfv2b ax-mp cvv
      wb crab wral elex syl ralrimi rabid2f sylibr dmmpt syl6reqr eleq2d anbi1d
      ex syl5bb bian1d simpr fveq1i fvmpt2f syl5eq syl2anc eqeq2d eqcom biimpar
      cmpt funbrfvb sylancr syl5bbr bitr3d pm5.32da mobid df-rmo syl6bbr albidv
      3bitr4rd ) FUAZMZBNZCNZFOZBPZCQZAWQERZBDUBZCQWOWQWPWNOZBPZCQZWTWOWNUGXEFU
      CCBWNCWNUHBFJUDUEUFXDWSCXCWRBWQWPFCUIBUIUJUKULUMAWSXBCAWSWPDSZXATZBPXBAWR
      XGBHAXFWRTXFWPFUNZWQRZTZXGWRAWRXFXIWRWPFUOZSZXITZAXJFMZWRXMUTBDEFKUPZWPWQ
      FUQURAXLXFXIAXKDWPADEUSSZBDVAZXKAXPBDVBDXQRAXPBDHAXFXPAXFTZEGSZXPLEGVCVDV
      LVEXPBDIVFVGBDEFKVHVIVJZVKVMZVNAXFXAWRXRWQXHRZXAWRXRXHEWQXRXFXSXHERAXFVOL
      XFXSTXHWPBDEWCZUNEWPFYCKVPBDEGIVQVRVSVTYBXIXRWRXHWQWAXRXNXLXIWRUTXOAXLXFX
      TWBWPWQFWDWEWFWGWHYAWMWIXABDWJWKWLVM $.

    ${
      $d y z A $.  $d y z B $.  $d x y C $.
      funcnv5mpt.1 $e |- ( x = z -> B = C ) $.
      $( Two ways to say that a function in maps-to notation is single-rooted.
         (Contributed by Thierry Arnoux, 1-Mar-2017.) $)
      funcnv5mpt $p |- ( ph -> ( Fun `' F <->
                                A. x e. A A. z e. A ( x = z \/ B =/= C ) ) ) $=
        ( vy cv wceq wal wral wi ccnv wfun wrmo wne wo funcnvmpt wa wcel wn wex
        nne eqvincg syl syl5bb imbi1d orcom df-or bitri 3bitr4g ralbidv ralcom4
        19.23v syl6bb ralbida nfcv nfv eqeq2d rmo4f albii bitr4i syl6bbr bitr4d
        wb ) AGUAUBOPZEQZBDUCZORZBPZCPQZEFUDZUEZCDSZBDSZABODEGHIJKLMUFAWCVOVNFQ
        ZUGZVSTZCDSZORZBDSZVQAWBWHBDIAVRDUHUGZWBWFORZCDSWHWJWAWKCDWJVTUIZVSTZWE
        OUJZVSTWAWKWJWLWNVSWLEFQZWJWNEFUKWJEHUHWOWNVMMOEFHULUMUNUOWAVTVSUEWMVSV
        TUPVTVSUQURWEVSOVBUSUTWFCODVAVCVDVQWGBDSZORWIVPWPOVOWDBCDJCDVEWDBVFVSEF
        VNNVGVHVIWGBODVAVJVKVL $.
    $}

    ${
      $d i j x $.  $d i j A $.  $d i j B $.  $d i F $.  $d x V $.  $d i j ph $.
      $( Two ways to say that a function in maps-to notation is single-rooted.
         (Contributed by Thierry Arnoux, 2-Mar-2017.) $)
      funcnv4mpt $p |- ( ph -> ( Fun `' F <->
        A. i e. A A. j e. A ( i = j \/ [_ i / x ]_ B =/= [_ j / x ]_ B ) ) ) $=
        ( cv csb nfcv cmpt wcel wa wsb nfcsb1v csbeq1a cbvmptf eqtri sbimi nfel
        nfv nfan weq eleq1 anbi2d sbie eleq1d 3imtr3i csbeq1 funcnv5mpt ) AEFCB
        ENZDOZBFNZDOGHAEUGECPZEGPGBCDQECURQLBECDURJUTEDPBUQDUAZBUQDUBZUCUDABNZC
        RZSZBETDHRZBETAUQCRZSZURHRZVEVFBEMUEVEVHBEAVGBIBUQCBUQPJUFUHBEUIZVDVGAV
        CUQCUJUKULVFVIBEBURHVABHPUFVJDURHVBUMULUNBUQUSDUOUP $.
    $}
  $}

  ${
    $d p q x y F $.  $d p q x y X $.
    $( Exactly one point of a function's graph has a given first element.
       (Contributed by Thierry Arnoux, 1-Apr-2018.) $)
    fgreu $p |- ( ( Fun F /\ X e. dom F ) -> E! p e. F X = ( 1st ` p ) ) $=
      ( vq wfun cdm wcel wa cv c1st cfv wceq wral wrex cop syl2anc simpr eqtr4d
      wb cvv wreu funfvop c2nd wrel simplll funrel simplr 1st2nd simpllr opeq1d
      syl eqeltrrd funopfvb biimpar syl21anc opeq12d fveq2d fvex mpan2 ad3antlr
      op1stg eqtr2d impbida ralrimiva eqeq2 bibi2d ralbidv rspcev reu6 sylibr )
      AEZBAFZGZHZBCIZJKZLZVODIZLZSZCAMZDANZVQCAUAVNBBAKZOZAGVQVOWDLZSZCAMZWBBAU
      BVNWFCAVNVOAGZHZVQWEWIVQHZVOVPVOUCKZOZWDWJAUDZWHVOWLLWJVKWMVKVMWHVQUEZAUF
      UKVNWHVQUGZVOAUHPZWJBVPWCWKWIVQQZWJVKVMBWKOZAGZWCWKLZWNVKVMWHVQUIWJVOWRAW
      JVOWLWRWPWJBVPWKWQUJRWOULVNWTWSBWKAUMUNUOUPRWIWEHZVPWDJKZBXAVOWDJWIWEQUQV
      MXBBLZVKWHWEVMWCTGXCBAURBWCVLTVAUSUTVBVCVDWAWGDWDAVRWDLZVTWFCAXDVSWEVQVRW
      DVOVEVFVGVHPVQCDAVIVJ $.
  $}

  ${
    $d p q r A $.  $d p q Y $.
    $( If the converse of a relation ` A ` is a function, exactly one point of
       its graph has a given second element (that is, function value)
       (Contributed by Thierry Arnoux, 1-Apr-2018.) $)
    fcnvgreu $p |- ( ( ( Rel A /\ Fun `' A ) /\ Y e. ran A )
      -> E! p e. A Y = ( 2nd ` p ) ) $=
      ( vq vr ccnv wa wcel cv c2nd cfv wceq wreu c1st wb csn cuni cxp syl simpr
      wrel wfun crn df-rn eleq2i fgreu adantll sylan2b cnvcnvss cnvssrndm sseli
      cdm cop dfdm4 xpeq12i syl6eleq 2nd1st eqcomd relcnv cnvf1olem simpld mpan
      mpdan sseldi adantl wral wrex adantr wss relssdmrn sselda syl12anc simplr
      simpl a1i ad2antlr simprd sneqd cnveqd ad2antrr 3eqtr2d impbida ralrimiva
      unieqd biidd eqeq2 bibi12d ralrimivw r19.21bi ralbidva rspcev reu6 sylibr
      syl2anc fvex op2ndd eqeq2d reuxfr4d mpbird ) AUAZAFZUBZGZBAUCZHZGBCIZJKZL
      ZCAMZBDIZNKZLZDXAMZXEXCBXAULZHZXMXDXNBAUDZUEXBXOXMWTXABDUFUGUHXCXIXMOXEXC
      XHXLCDXJJKZXKUMZAXAXJXAHZXRAHXCXSXAFZAXRAUIXSXRXJPZFZQZLZXRXTHZXSYCXRXSXJ
      XNXAUCZRZHYCXRLZXSXJXDAULZRZYGXAYJXJAUJUKXDXNYIYFXPAUNUOUPXJXNYFUQSZURZXA
      UAZXSYDGZYEAUSZYMYNGZYEXJXRPZFZQZLZXAXJXRUTZVAVBVCVDVEXCXFAHZGZXFXRLZXJEI
      ZLZOZDXAVFZEXAVGZUUDDXAMUUCXGXFNKUMZXAHZUUDXJUUJLZOZDXAVFZUUIUUCWTUUBUUJX
      FPZFZQZLZUUKXCWTUUBWTXBVNZVHZXCUUBTZUUCUUQUUJUUCXFYIXDRZHUUQUUJLZXCAUVBXF
      XCWTAUVBVIUUSAVJSVKXFYIXDUQSZURZWTUUBUURGGZUUKXFUUJPZFZQZLZAXFUUJUTZVAVLU
      UCUUMDXAUUCXSGZUUDUULUVLUUDGZXJYSUUQUUJUVMYMXSYDYTYMUVMYOVOUUCXSUUDVMXSYD
      UUCUUDYLVPYPYEYTUUAVQVLUVMUUPYRUVMUUOYQUVMXFXRUVLUUDTVRVSWDUUCUVCXSUUDUVD
      VTWAUVLUULGZXFUVIYCXRUUCUVJXSUULUUCWTUUBUURUVJUUTUVAUVEUVFUUKUVJUVKVQVLVT
      UVNYBUVHUVNYAUVGUVNXJUUJUVLUULTVRVSWDXSYHUUCUULYKVPWAWBWCUUHUUNEUUJXAUUEU
      UJLZUUGUUMDXAUVOUUGUUMOZDXAUVOUVPDXAUVOUUDUUDUUFUULUVOUUDWEUUEUUJXJWFWGWH
      WIWJWKWNUUDDEXAWLWMUUDXHXLOXCUUDXGXKBXQXKXFXJJWOXJNWOWPWQVEWRVHWS $.
  $}

  ${
    $d y z A $.  $d z B $.  $d z C $.  $d x y z D $.  $d z F $.
    rnmpt2ss.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( The range of an operation given by the "maps to" notation as a subset.
       (Contributed by Thierry Arnoux, 23-May-2017.) $)
    rnmpt2ss $p |- ( A. x e. A A. y e. B C e. D -> ran F C_ D ) $=
      ( vz wcel wral crn cv wceq wrex rnmpt2 abeq2i wa simpl simpr r19.29d2r wi
      eleq1 biimparc a1i rexlimivv syl ex syl5bi ssrdv ) EFJZBDKACKZIGLZFIMZUMJ
      UNENZBDOACOZULUNFJZUPIUMABICDEGHPQULUPUQULUPRZUKUORZBDOACOUQURUKUOABCDULU
      PSULUPTUAUSUQABCDUSUQUBAMCJBMDJRUOUQUKUNEFUCUDUEUFUGUHUIUJ $.
  $}

  $( Rewrite a function defined by parts, using a mapping and an if construct,
     into a union of functions on disjoint domains.  (Contributed by Thierry
     Arnoux, 30-Mar-2017.) $)
  partfun $p |- ( x e. A |-> if ( x e. B , C , D ) ) =
                ( ( x e. ( A i^i B ) |-> C ) u. ( x e. ( A \ B ) |-> D ) ) $=
    ( cin cdif cun cv wcel cmpt mptun inundif eqid mpteq12i wceq inss2 mpteq2ia
    cif syl sseli iftrue wn eldifn iffalse uneq12i 3eqtr3i ) ABCFZBCGZHZAIZCJZD
    ESZKAUHUMKZAUIUMKZHABUMKAUHDKZAUIEKZHAUHUIUMLAUJUMBUMBCMUMNOUNUPUOUQAUHUMDU
    KUHJULUMDPUHCUKBCQUAULDEUBTRAUIUMEUKUIJULUCUMEPUKBCUDULDEUETRUFUG $.

  ${
    $d x y z A $.  $d x y z R $.
    $( Alternative definition of the converse of a relation.  (Contributed by
       Thierry Arnoux, 31-Mar-2018.) $)
    dfcnv2 $p |- ( ran R C_ A ->
      `' R = U_ x e. A ( { x } X. ( `' R " { x } ) ) ) $=
      ( vz vy crn wss ccnv cv csn cima cxp ciun relcnv wrel wral wa vex syl6bbr
      wcel relxp rgenw reliun mpbir cop cdm opeldm df-rn syl6eleqr ssel2 sylan2
      ex pm4.71rd elimasn anbi2i wceq sneq imaeq2d opeliunxp2 eqrelrdv ) CFZBGZ
      DECHZABAIZJZVCVEKZLZMZCNVHOVGOZABPVIABVEVFUAUBABVGUCUDVBDIZEIZUEZVCTZVJBT
      ZVKVCVJJZKZTZQZVLVHTVBVMVNVMQVRVBVMVNVBVMVNVMVBVJVATVNVMVJVCUFVAVJVKVCDRZ
      ERZUGCUHUIVABVJUJUKULUMVQVMVNVCVJVKVSVTUNUOSABVFVJVKVPVDVJUPVEVOVCVDVJUQU
      RUSSUT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Operations - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d w x y z A $.  $d w y z B $.  $d w C $.  $d w z D $.
    mpt2mptxf.0 $e |- F/_ x C $.
    mpt2mptxf.1 $e |- F/_ y C $.
    mpt2mptxf.2 $e |- ( z = <. x , y >. -> C = D ) $.
    $( Express a two-argument function as a one-argument function, or
       vice-versa.  In this version ` B ( x ) ` is not assumed to be constant
       w.r.t ` x ` .  (Contributed by Mario Carneiro, 29-Dec-2014.)  (Revised
       by Thierry Arnoux, 31-Mar-2018.) $)
    mpt2mptxf $p |- ( z e. U_ x e. A ( { x } X. B ) |-> C ) =
      ( x e. A , y e. B |-> D ) $=
      ( vw cv wcel wceq wa copab wex nfcv nfeq eqtr4i csn cxp ciun cmpt2 df-mpt
      cmpt coprab df-mpt2 eliunxp anbi1i 19.41 exbii bitri anass eqeq2d pm5.32i
      cop anbi2d 2exbii 3bitr2i opabbii dfoprab2 ) CADALZUAEUBUCZFUFCLZVDMZKLZF
      NZOZCKPZABDEGUDZCKVDFUEVKVCDMBLZEMOZVGGNZOZABKUGZVJABKDEGUHVJVEVCVLUQNZVO
      OZBQAQZCKPVPVIVSCKVIVQVMOZBQZAQZVHOZVTVHOZBQZAQZVSVFWBVHABDEVEUIUJWFWAVHO
      ZAQWCWEWGAVTVHBBVGFBVGRISUKULWAVHAAVGFAVGRHSUKUMWDVRABWDVQVMVHOZOVRVQVMVH
      UNVQWHVOVQVHVNVMVQFGVGJUOURUPUMUSUTVAVOABKCVBTTT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
         Isomorphisms - misc. add.
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Two ways to write a strictly decreasing function on the reals.
     (Contributed by Thierry Arnoux, 6-Apr-2017.) $)
  gtiso $p |- ( ( A C_ RR* /\ B C_ RR* ) ->
    ( F Isom < , `' < ( A , B ) <-> F Isom <_ , `' <_ ( A , B ) ) ) $=
    ( cxr wss clt ccnv wiso cle cxp cin cdif eqid wceq df-le wrel dfrel2 ineq1i
    wb mpbi isocnv3 a1i cnveqi cnvdif cnvxp ltrel difeq12i 3eqtri indif1 xpss12
    wa eqtri anidms dfss1 sylib difeq1d syl5req adantr isoeq2 syl adantl isoeq3
    3bitrd isocnv2 isores2 isores1 bitri lerel ax-mp 3bitr3ri syl6bbr ) ADEZBDE
    ZUKZABFFGZCHZABIGZAAJZKZIBBJZKZCHZABIVQCHZVNVPABVRFLZVTVOLZCHZABVSWECHZWBVP
    WFSVNABWDWEFVOCWDMWEMUAUBVNWDVSNZWFWGSVLWHVMVLVSDDJZVRKZFLZWDVSWIFLZVRKWKVQ
    WLVRVQWIVOLZGWIGZVOGZLWLIWMOUCWIVOUDWNWIWOFDDUEFPWOFNUFFQTUGUHRWIVRFUIULVLW
    JVRFVLVRWIEZWJVRNVLWPADADUJUMVRWIUNUOUPUQURABWDWEVSCUSUTVNWEWANZWGWBSVMWQVL
    VMWAWIVTKZVOLZWEWAWMVTKWSIWMVTORWIVTVOUIULVMWRVTVOVMVTWIEZWRVTNVMWTBDBDUJUM
    VTWIUNUOUPUQVAABVSWEWACVBUTVCABVQICHZABVQGZVQCHZWBWCABVQICVDXAABVQWACHWBABV
    QICVEABVQWACVFVGXBINZXCWCSIPXDVHIQTABXBVQICUSVIVJVK $.

  ${
    $d x y A $.  $d w x y z B $.  $d x y C $.  $d w x y z D $.  $d w x y z G $.
    $d w x y z H $.  $d x y R $.  $d w x y z S $.  $d w x y z ph $.
    isoun.1 $e |- ( ph -> H Isom R , S ( A , B ) ) $.
    isoun.2 $e |- ( ph -> G Isom R , S ( C , D ) ) $.
    isoun.3 $e |- ( ( ph /\ x e. A /\ y e. C ) -> x R y ) $.
    isoun.4 $e |- ( ( ph /\ z e. B /\ w e. D ) -> z S w ) $.
    isoun.5 $e |- ( ( ph /\ x e. C /\ y e. A ) -> -. x R y ) $.
    isoun.6 $e |- ( ( ph /\ z e. D /\ w e. B ) -> -. z S w ) $.
    isoun.7 $e |- ( ph -> ( A i^i C ) = (/) ) $.
    isoun.8 $e |- ( ph -> ( B i^i D ) = (/) ) $.
    $( Infer an isomorphism from for a union of two isomorphisms.  (Contributed
       by Thierry Arnoux, 30-Mar-2017.) $)
    isoun $p |- ( ph -> ( H u. G ) Isom R , S ( ( A u. C ) , ( B u. D ) ) ) $=
      ( cun wf1o cv wbr cfv wb wral wiso cin c0 wceq isof1o f1oun syl22anc wcel
      syl wa wo elun isorel sylan wfn f1ofn adantr anim1i fvun1 syl3anc adantrr
      wi adantrl breq12d bitr4d anassrs 3expb 3expia ralrimiv ralrimiva wf f1of
      ffvelrnda breq1 breq2 rspc2v syl2anc fvun2 3brtr4d 2thd jaodan sylan2b ex
      mpd wn notbid mtbird 2falsed df-isom sylanbrc ) AFHUBZGIUBZMLUBZUCZBUDZCU
      DZJUEZXCXAUFZXDXAUFZKUEZUGZCWSUHZBWSUHWSWTJKXAUIAFGMUCZHILUCZFHUJUKULZGIU
      JUKULXBAFGJKMUIZXKNFGJKMUMUQZAHIJKLUIZXLOHIJKLUMUQZTUAFGHIMLUNUOAXJBWSAXC
      WSUPZURXICWSXRAXCFUPZXCHUPZUSXDWSUPZXIVJZXCFHUTAXSYBXTAXSURZYAXIYAYCXDFUP
      ZXDHUPZUSZXIXDFHUTZYCYDXIYEAXSYDXIAXSYDURZURZXEXCMUFZXDMUFZKUEZXHAXNYHXEY
      LUGNFGXCXDJKMVAVBYIXFYJXGYKKAXSXFYJULZYDYCMFVCZLHVCZXMXSURYMAYNXSAXKYNXOF
      GMVDUQZVEAYOXSAXLYOXQHILVDUQZVEAXMXSTVFFHMLXCVGVHZVIAYDXGYKULZXSAYDURYNYO
      XMYDURYSAYNYDYPVEAYOYDYQVEAXMYDTVFFHMLXDVGVHZVKVLVMVNAXSYEXIAXSYEURZURZXE
      XHAXSYEXEPVOUUBYJXDLUFZXFXGKUUBDUDZEUDZKUEZEIUHZDGUHZYJUUCKUEZAUUHUUAAUUG
      DGAUUDGUPZURUUFEIAUUJUUEIUPUUFQVPVQVRVEUUBYJGUPZUUCIUPZUUHUUIVJAXSUUKYEAF
      GXCMAXKFGMVSXOFGMVTUQZWAVIAYEUULXSAHIXDLAXLHILVSXQHILVTUQZWAVKUUFUUIYJUUE
      KUEDEYJUUCGIUUDYJUUEKWBUUEUUCYJKWCWDWEWLAXSYMYEYRVIAYEXGUUCULZXSAYEURYNYO
      XMYEURUUOAYNYEYPVEAYOYEYQVEAXMYETVFFHMLXDWFVHZVKWGWHVNWIWJWKAXTURZYAXIYAU
      UQYFXIYGUUQYDXIYEAXTYDXIAXTYDURZURZXEXHAXTYDXEWMRVOUUSXHXCLUFZYKKUEZUUSUU
      FWMZEGUHZDIUHZUVAWMZAUVDUURAUVCDIAUUDIUPZURUVBEGAUVFUUEGUPUVBSVPVQVRVEUUS
      UUTIUPZYKGUPZUVDUVEVJAXTUVGYDAHIXCLUUNWAVIAYDUVHXTAFGXDMUUMWAVKUVBUVEUUTU
      UEKUEZWMDEUUTYKIGUUDUUTULUUFUVIUUDUUTUUEKWBWNUUEYKULUVIUVAUUEYKUUTKWCWNWD
      WEWLUUSXFUUTXGYKKAXTXFUUTULZYDUUQYNYOXMXTURUVJAYNXTYPVEAYOXTYQVEAXMXTTVFF
      HMLXCWFVHZVIAYDYSXTYTVKVLWOWPVNAXTYEXIAXTYEURZURZXEUUTUUCKUEZXHAXPUVLXEUV
      NUGOHIXCXDJKLVAVBUVMXFUUTXGUUCKAXTUVJYEUVKVIAYEUUOXTUUPVKVLVMVNWIWJWKWIWJ
      VQVRBCWSWTJKXAWQWR $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
         Disjointness (additional proof requiring functions)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d i j x $.  $d i j A $.  $d i j B $.  $d x V $.  $d i j ph $.
    disjdsct.0 $e |- F/ x ph $.
    disjdsct.1 $e |- F/_ x A $.
    disjdsct.2 $e |- ( ( ph /\ x e. A ) -> B e. ( V \ { (/) } ) ) $.
    disjdsct.3 $e |- ( ph -> Disj_ x e. A B ) $.
    $( A disjoint collection is distinct, i.e. each set in this collection is
       different of all others, provided that it does not contain the empty set
       This can be expressed as "the converse of the mapping function is a
       function", or "the mapping function is single-rooted".  (Cf. ~ funcnv )
       (Contributed by Thierry Arnoux, 28-Feb-2017.) $)
    disjdsct $p |- ( ph -> Fun `' ( x e. A |-> B ) ) $=
      ( vi vj cv wceq csb wne wral wcel wa c0 wsb cmpt ccnv wfun wdisj disjorsf
      wo cin sylib r19.21bi w3a simpr3 csn cdif eldifsni syl sbimi sbf clelsb3f
      sban anbi12i bitri wsbc sbsbc sbcne12 csb0 neeq2i 3imtr3i 3ad2antr1 disj3
      3bitri biimpi neeq1d biimpa difneqnul 3anassrs ex orim2d ralrimiva nfmpt1
      syl2anc mpd eqid funcnv4mpt mpbird ) ABCDUAZUBUCJLZKLZMZBWFDNZBWGDNZOZUFZ
      KCPZJCPAWMJCAWFCQZRZWLKCWOWGCQZRZWHWIWJUGSMZUFZWLWOWSKCAWSKCPZJCABCDUDWTJ
      CPIBCDJKGUEUHUIUIWQWRWKWHWQWRWKAWNWPWRWKAWNWPWRUJRWRWISOZWKAWNWPWRUKAWPWN
      XAWRABLCQZRZBJTZDSOZBJTZWOXAXCXEBJXCDESULUMZQXEHDESUNUOUPXDABJTZXBBJTZRWO
      AXBBJUSXHAXIWNABJFUQJBCGURUTVAXFXEBWFVBWIBWFSNZOXAXEBJVCBWFDSVDXJSWIBWFVE
      VFVJVGVHWRXARWIWJUMZSOZWKWRXAXLWRWIXKSWRWIXKMWIWJVIVKVLVMWIWJVNUOVTVOVPVQ
      WAVRVRABCDJKWEXGFGBCDVSWEWBHWCWD $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
         First and second members of an ordered pair - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y z A $.  $d x y z B $.
    $( Definition for a restriction of the ` 1st ` (first member of an ordered
       pair) function.  (Contributed by Thierry Arnoux, 27-Sep-2017.) $)
    df1stres $p |- ( 1st |` ( A X. B ) ) = ( x e. A , y e. B |-> x ) $=
      ( vz c1st cxp cres cv wcel wa wceq coprab cvv df1st2 reseq1i resoprab cin
      cmpt2 resres incom xpss df-ss mpbi eqtr3i reseq2i 3eqtr3ri df-mpt2 eqtr4i
      wss eqtri ) FCDGZHZAIZCJBIDJKEIUNLZKABEMZABCDUNSUOABEMZULHFNNGZHZULHZUPUM
      UQUSULABEOPUOABECDQUTFURULRZHUMFURULTVAULFULURRZVAULULURUAULURUJVBULLCDUB
      ULURUCUDUEUFUKUGABECDUNUHUI $.

    $( Definition for a restriction of the ` 2nd ` (second member of an ordered
       pair) function.  (Contributed by Thierry Arnoux, 27-Sep-2017.) $)
    df2ndres $p |- ( 2nd |` ( A X. B ) ) = ( x e. A , y e. B |-> y ) $=
      ( vz c2nd cxp cres cv wcel wa wceq coprab cvv df2nd2 reseq1i resoprab cin
      cmpt2 resres incom xpss df-ss mpbi eqtr3i reseq2i 3eqtr3ri df-mpt2 eqtr4i
      wss eqtri ) FCDGZHZAICJBIZDJKEIUNLZKABEMZABCDUNSUOABEMZULHFNNGZHZULHZUPUM
      UQUSULABEOPUOABECDQUTFURULRZHUMFURULTVAULFULURRZVAULULURUAULURUJVBULLCDUB
      ULURUCUDUEUFUKUGABECDUNUHUI $.
  $}

  $( Value of the first-member function at non-pairs.  (Contributed by Thierry
     Arnoux, 22-Sep-2017.) $)
  1stnpr $p |- ( -. A e. ( _V X. _V ) -> ( 1st ` A ) = (/) ) $=
    ( cvv cxp wcel wn c1st cfv csn cdm cuni c0 1stval wne dmsnn0 biimpri unieqd
    necon1bi uni0 syl6eq syl5eq ) ABBCDZEZAFGAHIZJZKALUBUDKJKUBUCKUAUCKUAUCKMAN
    OQPRST $.

  $( Value of the second-member function at non-pairs.  (Contributed by Thierry
     Arnoux, 22-Sep-2017.) $)
  2ndnpr $p |- ( -. A e. ( _V X. _V ) -> ( 2nd ` A ) = (/) ) $=
    ( cvv cxp wcel wn c2nd cfv csn crn cuni c0 2ndval wne rnsnn0 biimpri unieqd
    necon1bi uni0 syl6eq syl5eq ) ABBCDZEZAFGAHIZJZKALUBUDKJKUBUCKUAUCKUAUCKMAN
    OQPRST $.

  ${
    $d w A $.  $d x y w B $.  $d x y w C $.
    $( TODO shorten like in proof for ~ 1stmbfm ! $)
    $( The preimage by ` 1st ` is a 'vertical band'.  (Contributed by Thierry
       Arnoux, 13-Oct-2017.) $)
    1stpreima $p |- ( A C_ B ->
      ( `' ( 1st |` ( B X. C ) ) " A ) = ( A X. C ) ) $=
      ( vw wss c1st cxp cres ccnv cima cv cfv wcel wa cvv a1i an12 anbi2i elxp7
      wb c2nd anass pm4.71d anbi1d 3bitr4d syl6rbbr syl6bb cin cnvresima eleq2i
      ssel elin vex wfo fo1st fofn elpreima mpbiran anbi1i 3bitri 3bitr4g eqrdv
      wfn mp2b ) ABEZDFBCGZHIAJZACGZVEDKZFLZAMZVIVFMZNZVIOOGMZVKVIUALCMZNNZVIVG
      MZVIVHMVEVMVKVNVONZNZVPVEVSVKVNVJBMZVONNZNZVMVEVKVTNZVRNZVKVTVRNZNZVSWBWD
      WFTVEVKVTVRUBPVEVKWCVRVEVKVTABVJUKUCUDWBWFTVEWAWEVKVNVTVOQRPUEVLWAVKVIBCS
      RUFVKVNVOQUGVQVIFIAJZVFUHZMVIWGMZVLNVMVGWHVIVFAFUIUJVIWGVFULWIVKVLWIVIOMZ
      VKDUMOOFUNFOVCWIWJVKNTUOOOFUPOVIAFUQVDURUSUTVIACSVAVB $.

    $( The preimage by ` 2nd ` is an 'horizontal band'.  (Contributed by
       Thierry Arnoux, 13-Oct-2017.) $)
    2ndpreima $p |- ( A C_ C ->
      ( `' ( 2nd |` ( B X. C ) ) " A ) = ( B X. A ) ) $=
      ( vw wss c2nd cxp cres ccnv cima cv cfv wcel wa cvv wb anass anbi1i elxp7
      a1i c1st ssel pm4.71rd anbi2d bicomi syl6rbbr ancom 3bitr3g cin cnvresima
      3bitrd eleq2i elin vex wfo wfn fo2nd fofn elpreima mpbiran 3bitri 3bitr4g
      mp2b eqrdv ) ACEZDFBCGZHIAJZBAGZVEDKZFLZAMZVIVFMZNZVIOOGMZVIUALBMZVKNNZVI
      VGMZVIVHMVEVLVKNZVNVONZVKNZVMVPVEVTVNVOVJCMZNNZVKNZVRVEVTVSWAVKNZNZVSWANZ
      VKNZWCVEVKWDVSVEVKWAACVJUBUCUDWEWGPVEWGWEVSWAVKQUETWGWCPVEWFWBVKVNVOWAQRT
      UKVLWBVKVIBCSRUFVLVKUGVNVOVKQUHVQVIFIAJZVFUIZMVIWHMZVLNVMVGWIVIVFAFUJULVI
      WHVFUMWJVKVLWJVIOMZVKDUNOOFUOFOUPWJWKVKNPUQOOFUROVIAFUSVCUTRVAVIBASVBVD
      $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y F $.
    $d x y G $.
    curry2ima.1 $e |- G = ( F o. `' ( 1st |` ( _V X. { C } ) ) ) $.
    $( The image of a curried function with a constant second argument.
       (Contributed by Thierry Arnoux, 25-Sep-2017.) $)
    curry2ima $p |- ( ( F Fn ( A X. B ) /\ C e. B /\ D C_ A ) ->
        ( G " D ) = { y | E. x e. D y = ( x F C ) } ) $=
      ( cxp wfn wss cv wceq wrex cab cvv wf syl2anc syl wcel w3a cima cfv simp1
      co wfun cdm dffn2 sylib simp2 curry2f ffun fdm sseqtr4d dfimafn curry2val
      simp3 3adant3 eqeq1d eqcom syl6bb rexbidv abbidv eqtrd ) GCDJZKZEDUAZFCLZ
      UBZHFUCZAMZHUDZBMZNZAFOZBPZVNVLEGUFZNZAFOZBPVJHUGZFHUHZLVKVQNVJCQHRZWAVJV
      FQGRZVHWCVJVGWDVGVHVIUEVFGUIUJVGVHVIUKCDEQGHIULSZCQHUMTVJFCWBVGVHVIURVJWC
      WBCNWECQHUNTUOABFHUPSVJVPVTBVJVOVSAFVJVOVRVNNVSVJVMVRVNVGVHVMVRNVICDEVLGH
      IUQUSUTVRVNVAVBVCVDVE $.
  $}

$(
  @{
    coswap.1 @e |- ( ( x = ( 1st ` p ) /\ y = ( 2nd ` p ) ) -> ( ps <-> ch ) ) @.
    coswap.2 @e |- ( ( x = ( 2nd ` p ) /\ y = ( 1st ` p ) ) -> ( ps <-> th ) ) @.
    coswap.3 @e |- ( ( ph /\ p e. A ) -> ch ) @.
    @( A scheme that can be used for swapping ` 1st ` and ` 2nd ` arguments
       in a proof. @)
    coswap @p |- ( ( ph /\ p e. `' A ) -> th ) @=
      ? @.
  @}
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Supremum - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z R $.  $d z ph $.
    supssd.0 $e |- ( ph -> R Or A ) $.
    supssd.1 $e |- ( ph -> B C_ C ) $.
    supssd.2 $e |- ( ph -> C C_ A ) $.
    supssd.3 $e |- ( ph -> E. x e. A ( A. y e. B -. x R y
                               /\ A. y e. A ( y R x -> E. z e. B y R z ) ) ) $.
    supssd.4 $e |- ( ph -> E. x e. A ( A. y e. C -. x R y
                               /\ A. y e. A ( y R x -> E. z e. C y R z ) ) ) $.
    $( Inequality deduction for supremum of a subset.  (Contributed by Thierry
       Arnoux, 21-Mar-2017.) $)
    supssd $p |- ( ph -> -. sup ( C , A , R ) R sup ( B , A , R ) ) $=
      ( csup wcel cv wbr wn wral supcl sseld supub syld ralrimiv supnub mp2and
      ) AGEHNZEOUGDPZHQRZDFSUGFEHNHQRABCDEGHIMTAUIDFAUHFOUHGOUIAFGUHJUAABCDEGUH
      HIMUBUCUDABCDEFUGHILUEUF $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Finite Sets
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.
    $( If a union is finite, then all its elements are finite.  See ~ unifi .
       (Contributed by Thierry Arnoux, 27-Aug-2017.) $)
    unifi3 $p |- ( U. A e. Fin -> A C_ Fin ) $=
      ( vx cuni cfn wcel cv wss elssuni ssfi ex syl5 ssrdv ) ACZDEZBADBFZAEOMGZ
      NODEZOAHNPQMOIJKL $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Countable Sets
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( ` NN ` is countable (Contributed by Thierry Arnoux, 29-Dec-2016.) $)
  nnct $p |- NN ~<_ om $=
    ( cn com cen wbr cdom nnenom endom ax-mp ) ABCDABEDFABGH $.

  $( A finite set is countable (weaker version of ~ isfinite ) (Contributed by
     Thierry Arnoux, 27-Mar-2018.) $)
  fict $p |- ( A e. Fin -> A ~<_ om ) $=
    ( cfn wcel com csdm wbr cdom isfinite sdomdom sylbi ) ABCADEFADGFAHADIJ $.

  ${
    $d f A $.
    $( TODO shorten using ` Rel ~<_ ` and ~ brrelexi ? $)
    $( A countable set is a set (Contributed by Thierry Arnoux,
       29-Dec-2016.) $)
    ctex $p  |- ( A ~<_ om -> A e. _V ) $=
      ( vf com cdom wbr wf1 wex cvv wcel brdomi cdm f1dm dmex syl6eqelr exlimiv
      cv vex syl ) ACDEACBPZFZBGAHIZACBJTUABTASKHACSLSBQMNOR $.
  $}

  $( Any subset of a countable set is countable (Contributed by Thierry Arnoux,
     31-Jan-2017.) $)
  ssct $p |- ( ( A C_ B /\ B ~<_ om ) -> A ~<_ om ) $=
    ( wss com cdom wbr cvv wcel wi ctex ssdomg syl impcom domtr sylancom ) ABCZ
    BDEFZABEFZADEFQPRQBGHPRIBJABGKLMABDNO $.

  $( The cartesian product of two countable sets is countable.  (Contributed by
     Thierry Arnoux, 24-Sep-2017.) $)
  xpct $p |- ( ( A ~<_ om /\ B ~<_ om ) -> ( A X. B ) ~<_ om ) $=
    ( com cdom wbr wa cxp cen cvv wcel ctex adantl simpl xpdom1g syl2anc xpdom2
    omex domtr xpomen domentr sylancl ) ACDEZBCDEZFZABGZCCGZDEZUFCHEUECDEUDUECB
    GZDEZUHUFDEZUGUDBIJZUBUIUCUKUBBKLUBUCMACBINOUCUJUBBCCQPLUEUHUFROSUEUFCTUA
    $.

  $( A singleton is countable (Contributed by Thierry Arnoux, 16-Sep-2016.) $)
  snct $p |- ( A e. V -> { A } ~<_ om ) $=
    ( wcel csn c1o cen wbr com cdom ensn1g c0 csdm peano1 ne0i ax-mp omex 0sdom
    wne mpbir 0sdom1dom mpbi endomtr sylancl ) ABCADZEFGEHIGZUDHIGABJKHLGZUEUFH
    KRZKHCUGMHKNOHPQSHTUAUDEHUBUC $.

  $( An unordered pair is countable (Contributed by Thierry Arnoux,
     16-Sep-2016.) $)
  prct $p |- ( ( A e. V /\ B e. W ) -> { A , B } ~<_ om ) $=
    ( wcel wa cpr csn cun com cdom df-pr wbr snct unctb syl2an syl5eqbr ) ACEZB
    DEZFABGAHZBHZIZJKABLRTJKMUAJKMUBJKMSACNBDNTUAOPQ $.

  $( If the domain of a function is countable, the function is countable.
     (Contributed by Thierry Arnoux, 29-Dec-2016.) $)
  fnct $p |- ( ( F Fn A /\ A ~<_ om ) -> F ~<_ om ) $=
    ( wfn com cdom wbr crn cxp cvv wcel wss ctex adantl cdm adantr sylc syl2anc
    wa sylancom domtr wfun wb fndm eleq1d fnfun funrnex xpexg simpl dffn3 sylib
    mpbird wf fssxp syl ssdomg cen xpdom1g omex fnrndomg xpdom2g sylancr xpomen
    domentr sylancl ) BACZADEFZRZBABGZHZEFZVIDEFZBDEFVGVIIJZBVIKZVJVGAIJZVHIJZV
    LVFVNVEALMZVGBNZIJZBUAZVOVGVRVNVPVEVRVNUBVFVEVQAIABUCUDOUKVEVSVFABUEOIBUFPZ
    AVHIIUGQVGAVHBULZVMVGVEWAVEVFUHZABUIUJAVHBUMUNBVIIUOPVGVIDDHZEFZWCDUPFVKVGV
    IDVHHZEFZWEWCEFZWDVEVFVOWFVTADVHIUQSVGDIJVHDEFZWGURVEVFVHAEFZWHVGVNVEWIVPWB
    AIBUSPVHADTSVHDDIUTVAVIWEWCTQVBVIWCDVCVDBVIDTQ $.

  ${
    $d x A $.
    $( The domain of a countable set is countable.  (Contributed by Thierry
       Arnoux, 29-Dec-2016.) $)
    dmct $p |- ( A ~<_ om -> dom A ~<_ om ) $=
      ( vx com cdom wbr cdm cvv cres dmresv wcel cv c1st cfv cmpt wfo wss resss
      ctex ee10 domtr ssexg sylancr crn wfn fvex eqid fnmpti dffn4 mpbi wrel wb
      wceq relres reldm foeq3 mpbir fodomg ssdomg mpancom syl2anc syl5eqbrr
      mp2b ) ACDEZAFAGHZFZCDAIVCVEVDDEZVDCDEZVECDEVCVDGJZVDVEBVDBKZLMZNZOZVFVCV
      DAPZAGJZVHAGQZARZVDAGUAUBVLVDVKUCZVKOZVKVDUDVRBVDVJVKVILUEVKUFUGVDVKUHUIV
      DUJVEVQULVLVRUKAGUMBVDUNVEVQVDVKUOVBUPVDVEGVKUQSVDADEZVCVGVCVNVMVSVPVOVDA
      GURSVDACTUSVEVDCTUTVA $.
  $}

  $( If a set is countable, so is its converse.  (Contributed by Thierry
     Arnoux, 29-Dec-2016.) $)
  cnvct $p |- ( A ~<_ om -> `' A ~<_ om ) $=
    ( ccnv cdom wbr com cen wrel cvv wcel relcnv ctex cnvexg syl cnven cnvcnvss
    sylancr wss ssdomg ee10 endomtr syl2anc domtr mpancom ) ABZACDZAECDZUDECDUF
    UDUDBZFDZUGACDZUEUFUDGUDHIZUHAJUFAHIZUJAKZAHLMUDHNPUFUKUGAQUIULAOUGAHRSUDUG
    ATUAUDAEUBUC $.

  $( The range of a countable set is countable.  (Contributed by Thierry
     Arnoux, 29-Dec-2016.) $)
  rnct $p |- ( A ~<_ om -> ran A ~<_ om ) $=
    ( com cdom wbr ccnv cdm crn cnvct dmct df-rn breq1i biimpri 3syl ) ABCDAEZB
    CDNFZBCDZAGZBCDZAHNIRPQOBCAJKLM $.

  $( The image by a function of a countable set is countable.  (Contributed by
     Thierry Arnoux, 27-Mar-2018.) $)
  fimact $p |- ( ( A ~<_ om /\ Fun F ) -> ( F " A ) ~<_ om ) $=
    ( com cdom wbr wfun wa cima cvv wcel ctex imadomg sylan simpl domtr syl2anc
    imp ) ACDEZBFZGBAHZADEZRTCDERAIJZSUAAKUBSUAAIBLQMRSNTACOP $.

  ${
    $d x y A $.  $d y B $.
    $( A countable mapping set is countable.  (Contributed by Thierry Arnoux,
       29-Dec-2016.) $)
    mptct $p |- ( A ~<_ om -> ( x e. A |-> B ) ~<_ om ) $=
      ( com cdom wbr cmpt wfun cdm funmpt cvv wcel wss ctex eqid dmmptss ssdomg
      ee10 domtr mpancom wfn funfn fnct sylanb sylancr ) BDEFZABCGZHZUGIZDEFZUG
      DEFZABCJUIBEFZUFUJUFBKLUIBMULBNABCUGUGOPUIBKQRUIBDSTUHUGUIUAUJUKUGUBUIUGU
      CUDUE $.

    ${
      $d z A $.  $d x z B $.  $d z C $.
      mpt2cti.1 $e |- A. x e. A A. y e. B C e. V $.
      $( An operation is countable if both its domains are countable.
         (Contributed by Thierry Arnoux, 17-Sep-2017.) $)
      mpt2cti $p |- ( ( A ~<_ om /\ B ~<_ om ) ->
                                          ( x e. A , y e. B |-> C ) ~<_ om ) $=
        ( com cdom wbr wa cmpt2 cxp wfn wcel wral eqid fnmpt2 ax-mp xpct fnct
        sylancr ) CHIJDHIJKABCDELZCDMZNZUDHIJUCHIJEFOBDPACPUEGABCDEUCFUCQRSCDTU
        DUCUAUB $.
    $}

    $( An image set of a countable set is countable.  (Contributed by Thierry
       Arnoux, 29-Dec-2016.) $)
    abrexct $p |- ( A ~<_ om -> { y | E. x e. A y = B } ~<_ om ) $=
      ( com cdom wbr cv wceq wrex cab cmpt crn eqid rnmpt 1stcrestlem syl5eqbrr
      ) CEFGBHDIACJBKACDLZMEFABCDRRNOACDPQ $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.
    mptctf.1 $e |- F/_ x A $.
    $( A countable mapping set is countable, using bound-variable hypotheses
       instead of distinct variable conditions.  (Contributed by Thierry
       Arnoux, 8-Mar-2017.) $)
    mptctf $p |- ( A ~<_ om -> ( x e. A |-> B ) ~<_ om ) $=
      ( com cdom wbr cmpt wfun cdm funmpt cvv wcel wss ctex crab eqid dmmpt cab
      eqsstri cv wa df-rab simpl ss2abi abid2f sseqtri ssdomg domtr mpancom wfn
      ee10 funfn fnct sylanb sylancr ) BEFGZABCHZIZURJZEFGZUREFGZABCKUTBFGZUQVA
      UQBLMUTBNVCBOUTCLMZABPZBABCURURQRVEAUABMZVDUBZASZBVDABUCVHVFASBVGVFAVFVDU
      DUEABDUFUGTTUTBLUHULUTBEUIUJUSURUTUKVAVBURUMUTURUNUOUP $.

    $( An image set of a countable set is countable, using bound-variable
       hypotheses instead of distinct variable conditions.  (Contributed by
       Thierry Arnoux, 8-Mar-2017.) $)
    abrexctf $p |- ( A ~<_ om -> { y | E. x e. A y = B } ~<_ om ) $=
      ( com cdom wbr cv wceq wrex cab cmpt crn eqid rnmpt mptctf rnct syl5eqbrr
      syl ) CFGHZBIDJACKBLACDMZNZFGABCDUBUBOPUAUBFGHUCFGHACDEQUBRTS $.
  $}

  ${
    $d a w x y z $.  $d a w ph $.  $d w ps $.
    cnvoprab.x $e |- F/ x ps $.
    cnvoprab.y $e |- F/ y ps $.
    cnvoprab.1 $e |- ( a = <. x , y >. -> ( ps <-> ph ) ) $.
    cnvoprab.2 $e |- ( ps -> a e. ( _V X. _V ) ) $.
    $( TODO - simplify with ~ dfoprab3 $)
    $( The converse of a class abstraction of nested ordered pairs.
       (Contributed by Thierry Arnoux, 17-Aug-2017.) $)
    cnvoprab $p |- `' { <. <. x , y >. , z >. | ph } = { <. z , a >. | ps } $=
      ( vw copab cv cop wceq wa wex excom cvv wcel ccnv coprab cab opeq1 eqeq2d
      wi opex anbi12d spcegv ax-mp eximi nfv nfan nfex 19.9 cxp adantl c1st cfv
      sylib c2nd wb eqcom anbi12i eqopi sylan2br bicomd syl spc2ed mp2ani mpcom
      fvex exlimiv impbii exbii bitr2i 3bitr2ri abbii df-oprab df-opab 3eqtr4ri
      ex cnveqi cnvopab eqtr3i ) BFELZUAACDEUBZUABEFLWFWGKMZCMZDMZNZEMZNZOZAPZE
      QDQZCQZKUCWHFMZWLNZOZBPZEQFQZKUCWGWFWQXBKXBXAFQZEQWODQZCQZEQZWQXAFERXEXCE
      XEXCXEXCCQXCXDXCCXDXCDQXCWOXCDWKSTWOXCUFWIWJUGXAWOFWKSWRWKOZWTWNBAXGWSWMW
      HWRWKWLUDUEIUHZUIUJUKXCDXADFWTBDWTDULHUMZUNUOUTUKXCCXACFWTBCWTCULGUMZUNUO
      UTXAXEFWRSSUPTZXAXEBXKWTJUQXKWRURUSZSTZWRVAUSZSTZXAXEUFZWRURVLWRVAVLXKXMX
      OPXPXKWOXACDXLXNSSXJXIXKWIXLOZWJXNOZPZPXGWOXAVBXSXKXLWIOZXNWJOZPXGXTXQYAX
      RXLWIVCXNWJVCVDWRWIWJSSVEVFXGXAWOXHVGVHVIWBVJVKVMVNVOWQXDEQZCQXFWPYBCWODE
      RVOXDCERVPVQVRACDEKVSBFEKVTWAWCBFEWDWE $.
  $}

  ${
    $d a x y z A $.  $d a x y z B $.  $d a z C $.  $d a x y z D $.
    $d a x y I $.  $d a x y J $.  $d a x y z ph $.
    f1od2.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    f1od2.2 $e |- ( ( ph /\ ( x e. A /\ y e. B ) ) -> C e. W ) $.
    f1od2.3 $e |- ( ( ph /\ z e. D ) -> ( I e. X /\ J e. Y ) ) $.
    f1od2.4 $e |- ( ph -> ( ( ( x e. A /\ y e. B ) /\ z = C ) <->
                            ( z e. D /\ ( x = I /\ y = J ) ) ) ) $.
    $( Describe an implicit one-to-one onto function of two variables.
       (Contributed by Thierry Arnoux, 17-Aug-2017.) $)
    f1od2 $p |- ( ph -> F : ( A X. B ) -1-1-onto-> D ) $=
      ( wa wsbc va cxp wfn ccnv wf1o wcel wral ralrimivva fnmpt2 syl cv opelxpi
      cop cmpt ralrimiva eqid fnmpt c1st cfv c2nd wceq copab elxp7 anbi1i anass
      csb sbcbidv sbcan wb fvex sbcg ax-mp sbcel1v anbi12i bitri sbceq2g sbcbii
      3bitri sbceq1g csbvarg eqeq1i 3bitr3g anbi2d syl5bb simprr adantrr sseldi
      xpss eqeltrd ex pm4.71rd eqop pm5.32i syl6rbb bitrd opabbidv coprab cmpt2
      cvv df-mpt2 eqtri cnveqi nfv nfcv nfcsb1 nfeq nfan nfcsb opelxp csbopeq1a
      syl6bb eqeq2d anbi12d adantr cnvoprab df-mpt 3eqtr4g fneq1d mpbird dff1o4
      eleq1 sseli sylanbrc ) AIEFUBZUCZIUDZHUCZYDHIUEAGLUFZCFUGBEUGYEAYHBCEFPUH
      BCEFGILOUIUJAYGDHJKUMZUNZHUCZAYIMNUBZUFZDHUGYKAYMDHADUKZHUFZSJMUFKNUFSYMQ
      JKMNULUJZUODHYIYJYLYJUPUQUJAHYFYJAUAUKZYDUFZYNBYQURUSZCYQUTUSZGVFZVFZVAZS
      ZDUAVBZYOYQYIVAZSZDUAVBYFYJAUUDUUGDUAUUDYQWSWSUBZUFZYSEUFZYTFUFZSZSZUUCSZ
      AUUGYRUUMUUCYQEFVCVDAUUNUUIYOYSJVAZYTKVAZSZSZSZUUGUUNUUIUULUUCSZSAUUSUUIU
      ULUUCVEAUUTUURUUIABUKZEUFZCUKZFUFZSZYNGVAZSZCYTTZBYSTZYOUVAJVAZUVCKVAZSZS
      ZCYTTZBYSTZUUTUURAUVHUVNBYSAUVGUVMCYTRVGVGUVIUVBUUKSZYNUUAVAZSZBYSTUVPBYS
      TZUVQBYSTZSUUTUVHUVRBYSUVHUVECYTTZUVFCYTTZSUVRUVEUVFCYTVHUWAUVPUWBUVQUWAU
      VBCYTTZUVDCYTTZSUVPUVBUVDCYTVHUWCUVBUWDUUKYTWSUFZUWCUVBVIYQUTVJZUVBCYTWSV
      KVLCYTFVMVNVOUWEUWBUVQVIUWFCYTYNGWSVPVLVNVOVQUVPUVQBYSVHUVSUULUVTUUCUVSUV
      BBYSTZUUKBYSTZSUULUVBUUKBYSVHUWGUUJUWHUUKBYSEVMYSWSUFZUWHUUKVIYQURVJZUUKB
      YSWSVKVLVNVOUWIUVTUUCVIUWJBYSYNUUAWSVPVLVNVRUVOYOUVJUUPSZSZBYSTZUURUVNUWL
      BYSUVNYOCYTTZUVLCYTTZSUWLYOUVLCYTVHUWNYOUWOUWKUWEUWNYOVIUWFYOCYTWSVKVLUWO
      UVJCYTTZUVKCYTTZSUWKUVJUVKCYTVHUWPUVJUWQUUPUWEUWPUVJVIUWFUVJCYTWSVKVLUWQC
      YTUVCVFZKVAZUUPUWEUWQUWSVIUWFCYTUVCKWSVSVLUWRYTKUWEUWRYTVAUWFCYTWSVTVLWAV
      OVNVOVNVOVQUWMYOBYSTZUWKBYSTZSUURYOUWKBYSVHUWTYOUXAUUQUWIUWTYOVIUWJYOBYSW
      SVKVLUXAUVJBYSTZUUPBYSTZSUUQUVJUUPBYSVHUXBUUOUXCUUPUXBBYSUVAVFZJVAZUUOUWI
      UXBUXEVIUWJBYSUVAJWSVSVLUXDYSJUWIUXDYSVAUWJBYSWSVTVLWAVOUWIUXCUUPVIUWJUUP
      BYSWSVKVLVNVOVNVOVOWBWCWDAUUGUUIUUGSUUSAUUGUUIAUUGUUIAUUGSZYLUUHYQMNWHUXF
      YQYIYLAYOUUFWEAYOYMUUFYPWFWIWGWJWKUUIUUGUURUUIUUFUUQYOYQJKWSWSWLWCWMWNWOW
      DWPYFUVGBCDWQZUDUUEIUXGIBCEFGWRUXGOBCDEFGWTXAXBUVGUUDBCDUAYRUUCBYRBXCBYNU
      UBBYNXDBYSUUABYSXDXEXFXGYRUUCCYRCXCCYNUUBCYNXDCBYSUUACYSXDCYTGCYTXDXEXHXF
      XGYQUVAUVCUMZVAZYRUVEUUCUVFUXIYRUXHYDUFUVEYQUXHYDYAUVAUVCEFXIXKUXIUUBGYNB
      CYQGXJXLXMYRUUIUUCYDUUHYQEFWHYBXNXOXADUAHYIXPXQXRXSYDHIXTYC $.
  $}


  ${
    $d f h G $.  $d f h R $.  $d f h S $.  $d f h T $.  $d f h ph $.
    fcobij.1 $e |- ( ph -> G : S -1-1-onto-> T ) $.
    fcobij.2 $e |- ( ph -> R e. U ) $.
    fcobij.3 $e |- ( ph -> S e. V ) $.
    fcobij.4 $e |- ( ph -> T e. W ) $.
    $( Composing functions with a bijection yields a bijection between sets of
       functions.  (Contributed by Thierry Arnoux, 25-Aug-2017.) $)
    fcobij $p |- ( ph -> ( f e. ( S ^m R ) |-> ( G o. f ) ) :
                                         ( S ^m R ) -1-1-onto-> ( T ^m R ) ) $=
      ( ccom wcel wa wf adantr syl2anc wceq vh cmap co ccnv cmpt eqid wf1o f1of
      cv syl elmapg biimpa fco mpbird f1ocnv 3syl cid cres simpr coeq2d syl6eqr
      wb coass simpll f1ococnv2 coeq1d simplrr 3eqtrrd f1ococnv1 simplrl impbid
      fcoi2 ex f1o2d ) AFUACBUBUCZDBUBUCZGFUIZNZGUDZUAUIZNZFVOVRUEZWBUFAVQVOOZP
      ZVRVPOZBDVRQZWDCDGQZBCVQQZWFAWGWCACDGUGZWGJCDGUHUJRAWCWHACHOZBEOZWCWHVBLK
      CBVQHEUKSULZBCDGVQUMSAWEWFVBZWCADIOZWKWMMKDBVRIEUKSRUNAVTVPOZPZWAVOOZBCWA
      QZWPDCVSQZBDVTQZWRAWSWOAWIDCVSUGWSJCDGUODCVSUHUPRAWOWTAWNWKWOWTVBMKDBVTIE
      UKSULZBDCVSVTUMSAWQWRVBZWOAWJWKXBLKCBWAHEUKSRUNAWCWOPZPZVQWATZVTVRTZXDXEX
      FXDXEPZVRGVSNZVTNZUQDURZVTNZVTXGVRGWANXIXGVQWAGXDXEUSUTGVSVTVCVAXGXHXJVTX
      GAWIXHXJTAXCXEVDZJCDGVEUPVFXGWTXKVTTXGAWOWTXLAWCWOXEVGXASBDVTVLUJVHVMXDXF
      XEXDXFPZWAVSGNZVQNZUQCURZVQNZVQXMWAVSVRNXOXMVTVRVSXDXFUSUTVSGVQVCVAXMXNXP
      VQXMAWIXNXPTAXCXFVDZJCDGVIUPVFXMWHXQVQTXMAWCWHXRAWCWOXFVJWLSBCVQVLUJVHVMV
      KVN $.

    $d f h O $.  $d f h Q $.  $d g h O $.  $d g h R $.  $d g h S $.  $d f X $.
    $d f Y $.
    fcobijfs.5 $e |- ( ph -> O e. S ) $.
    fcobijfs.6 $e |- Q = ( G ` O ) $.
    fcobijfs.7 $e |- X =
                      { g e. ( S ^m R ) | ( `' g " ( _V \ { O } ) ) e. Fin } $.
    fcobijfs.8 $e |- Y =
                      { h e. ( T ^m R ) | ( `' h " ( _V \ { Q } ) ) e. Fin } $.
    $( Composing finitely supported functions with a bijection yields a
       bijection between sets of finitely supported functions.  See also
       ~ mapfien .  (Contributed by Thierry Arnoux, 25-Aug-2017.) $)
    fcobijfs $p |- ( ph -> ( f e. X |-> ( G o. f ) ) : X -1-1-onto-> Y ) $=
      ( cv cid cres ccom cmpt wf1o ccnv cvv csn cdif cima cfn wcel cmap co crab
      nfcv nfv wceq eqidd imaeq1d eleq1d cbvrabcsf eqtr4i f1oi a1i elex mapfien
      cnveq syl wb ssrab2 eqsstri sseli wa coass f1of elmapi fco syl2an syl5eqr
      wf fcoi1 sylan2 mpteq2dva f1oeq1 mpbid ) ANOGNJGUDZUECUFZUGUGZUHZUIZNOGNJ
      WKUGZUHZUIZAICDCENOGWLJBKNHUDZUJZUKKULUMZUNZUOUPZHDCUQURZUSZIUDZUJZXAUNZU
      OUPZIXDUSUBXIXCIHXDXDHXDUTIXDUTXIHVAXCIVAXFWSVBZXDVCXJXHXBUOXJXGWTXAXFWSV
      LVDVEVFVGUCUACCWLUIACVHVIPACFUPCUKUPQCFVJVMZADLUPDUKUPRDLVJVMXKAEMUPEUKUP
      SEMVJVMTVKAWNWQVBWOWRVNAGNWMWPWKNUPAWKXDUPZWMWPVBNXDWKNXEXDUBXCHXDVOVPVQA
      XLVRZWMWPWLUGZWPJWKWLVSXMCEWPWEZXNWPVBADEJWEZCDWKWEXOXLADEJUIXPPDEJVTVMWK
      DCWACDEJWKWBWCCEWPWFVMWDWGWHNOWNWQWIVMWJ $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d y C $.  $d x y ph $.  $d y ps $.  $d x ch $.
    frabbijd.1 $e |- F = ( x e. A |-> C ) $.
    frabbijd.2 $e |- ( ph -> F : A -1-1-onto-> B ) $.
    frabbijd.3 $e |- ( ( ph /\ x e. A /\ y = C ) -> ( ch <-> ps ) ) $.
    $( Build a bijection between restricted abstract builders, given a
       bijection between the base classes, decduction version.  (Contributed by
       Thierry Arnoux, 17-Aug-2018.) $)
    frabbijd $p |- ( ph -> ( F |` { x e. A | ps } ) :
                               { x e. A | ps } -1-1-onto-> { y e. B | ch } ) $=
      ( crab ccnv cres wf1o syl wceq wb wcel wfun f1ofun funcnvcnv 3syl wf1 wss
      cima f1ocnv f1of1 ssrab2 f1ores sylancl mptpreima cv wa wi 3expia alrimiv
      wal wral f1of fmpt sylibr r19.21bi elrab3t syl2anc rabbidva syl5eq f1oeq3
      wf mpbid f1orescnv rescnvcnv f1oeq1 ax-mp sylib ) ABDFMZCEGMZINZNZVQOZPZV
      QVRIVQOZPZAVTUAZVRVQVSVROZPZWBAFGIPZIUAWEKFGIUBIUCUDAVRVSVRUGZWFPZWGAGFVS
      UEZVRGUFWJAGFVSPZWKAWHWLKFGIUHQGFVSUIQCEGUJGFVRVSUKULAWIVQRWJWGSAWIHVRTZD
      FMVQDFHVRIJUMAWMBDFADUNFTZUOZEUNHRZCBSZUPZEUSHGTZWMBSWOWREAWNWPWQLUQURAWS
      DFAFGIVJZWSDFUTAWHWTKFGIVAQDFGHIJVBVCVDCBEHGVEVFVGVHWIVQVRWFVIQVKVQVRVSVL
      VFWAWCRWBWDSIVQVMVQVRWAWCVNVOVP $.
  $}

  ${
    $d x A $.  $d x F $.  $d x Z $.  $d x ph $.
    suppss3.1 $e |- G = ( x e. A |-> B ) $.
    suppss3.2 $e |- ( ph -> F Fn A ) $.
    suppss3.3 $e |- ( ( ph /\ x e. A /\ ( F ` x ) = Z ) -> B = Z ) $.
    $( Deduce a function's support's inclusion in another function's support.
       (Contributed by Thierry Arnoux, 7-Sep-2017.) $)
    suppss3 $p |- ( ph ->
                    ( `' G " ( _V \ { Z } ) ) C_ ( `' F " ( _V \ { Z } ) ) ) $=
      ( ccnv cvv csn cdif cima cmpt wcel wa wceq wn cnveqi imaeq1i cv cfv simpl
      eldif simplbi adantl wfn wb elpreima syl baibd notbid biimpd expimpd fvex
      wne eldifsn mpbiran necon2bbii syl6ibr syl5bi syl3anc suppss2 syl5eqss
      imp ) AFKZLGMNZOBCDPZKZVIOEKVIOZVHVKVIFVJHUAUBACDBVLGABUCZCVLNQZRAVMCQZVM
      EUDZGSZDGSAVNUEVNVOAVNVOVMVLQZTZVMCVLUFZUGUHAVNVQVNVOVSRZAVQVTAWAVPVIQZTZ
      VQAVOVSWCAVORZVSWCWDVRWBAVRVOWBAECUIVRVOWBRUJICVMVIEUKULUMUNUOUPWBVPGWBVP
      LQVPGURVMEUQVPLGUSUTVAVBVCVGJVDVEVF $.
  $}

  ${
    ffs2.1 $e |- C = ( B \ { Z } ) $.
    $( Rewrite a function's support based with its range rather than the
       universal class.  See also ~ nn0supp for a more specific version.
       (Contributed by Thierry Arnoux, 27-Aug-2017.) $)
    ffs2 $p |- ( F : A --> B -> ( `' F " ( _V \ { Z } ) ) = ( `' F " C ) ) $=
      ( wf ccnv cvv cima csn cdif cdm crn dfdm4 dfrn4 eqtri wceq difpreima syl
      fdm syl5eqr fimacnv eqtr4d difeq1d wfun ffun imaeq2i syl5eq 3eqtr4d ) ABD
      GZDHZIJZULEKZJZLZULBJZUOLZULIUNLJZULCJZUKUMUQUOUKUMAUQUKUMDMZAVAULNUMDOUL
      PQABDUAUBABDUCUDUEUKDUFZUSUPRABDUGZIUNDSTUKVBUTURRVCVBUTULBUNLZJURCVDULFU
      HBUNDSUITUJ $.
  $}

  ${
    $d x A $.  $d x F $.  $d x Z $.
    ffsrn.0 $e |- ( ph -> F e. _V ) $.
    ffsrn.1 $e |- ( ph -> Fun F ) $.
    ffsrn.2 $e |- ( ph -> ( `' F " ( _V \ { Z } ) ) e. Fin ) $.
    $( The range of a finitely supported function is finite.  (Contributed by
       Thierry Arnoux, 27-Aug-2017.) $)
    ffsrn $p |- ( ph -> ran F e. Fin ) $=
      ( crn cvv cima cres cun cfn wss wceq eqtri reseq2i wfn sylancl wcel syl
      ccnv csn cdif undif1 ssv ssequn2 mpbi imaeq2i imaundi resundi eqtr3i wfun
      cdm dfdm4 dfrn4 wa df-fn fnresdm sylbir syl5reqr rneqd rnun a1i eqtrd wbr
      cdom wfo cnvimass fores fofn wi cnvexg imaexg 3syl fnrndomg domfi syl2anc
      mpd snfi cin df-ima funimacnv syl5eqr inss1 syl6eqss ssfi sylancr eqeltrd
      unfi ) ABGZBBUAZHCUBZUCZIZJZGZBWKWLIZJZGZKZLAWJWOWRKZGZWTABXAAXABWKHIZJZB
      BWKWMWLKZIZJZXDXAXFXCBXEHWKXEHWLKZHHWLUDWLHMXHHNWLUEWLHUFUGOUHPXGBWNWQKZJ
      XAXFXIBWKWMWLUIPBWNWQUJOUKABULZBUMZXCNZXDBNZEXKWKGXCBUNWKUOOXJXLUPBXCQXMB
      XCUQXCBURUSRUTVAXBWTNAWOWRVBVCVDAWPLSZWSLSZWTLSAWNLSWPWNVFVEZXNFAWOWNQZXP
      AWNBWNIZWOVGZXQAXJWNXKMXSEBWMVHWNBVIRWNXRWOVJTAWNHSZXQXPVKABHSWKHSXTDBHVL
      WKWMHVMVNWNHWOVOTVRWNWPVPVQAWLLSWSWLMXOCVSAWSWLWJVTZWLAWSBWQIZYABWQWAAXJY
      BYANEWLBWBTWCWLWJWDWEWLWSWFWGWPWSWIVQWH $.
  $}


  ${
    $d f g x A $.  $d f g x B $.  $d f g x C $.  $d f g x V $.  $d f g x W $.
    $d f g X $.  $d f g x Z $.
    resf1o.1 $e |- X = { f e. ( B ^m A ) | ( `' f " ( B \ { Z } ) ) C_ C } $.
    resf1o.2 $e |- F = ( f e. X |-> ( f |` C ) ) $.
    $( Restriction of functions to a superset of their support creates a
       bijection.  (Contributed by Thierry Arnoux, 12-Sep-2017.) $)
    resf1o $p |- ( ( ( A e. V /\ B e. W /\ C C_ A ) /\ Z e. B )
                                 -> F : X -1-1-onto-> ( B ^m C ) ) $=
      ( wcel wa cres cvv syl2anc wceq wf syl c0 vg vx wss w3a cmap cdif csn cxp
      co cv resexg adantl simpr difexg 3ad2ant1 snex xpexg sylancl adantr unexg
      cun adantlr ccnv cima rabeq2i anbi1i simprr simprll elmapi simp3 ad2antrr
      fssres simp2 simp1 ssexg elmapg mpbird eqeltrd biimpi reseq2d wfn fnresdm
      wb undif ffn 3syl eqtr2d resundi syl6eq wi eqcom imbi2i mpbi simprlr eqid
      cin ffs2 dfss1 3sstr4d simplr inundif fneq2i sylibr inindif a1i fnsuppres
      simpl syl3anc mpbid uneq12d eqtrd jca ad2ant2r fconstg snssi disjdif fun2
      ex fss syl21anc eqcomd feq12d biimpar cfv fveq1d ad3antlr fvun2 syl112anc
      fvconst 3eqtrd suppss eqsstr3d reseq1d res0 eqtr4i reseq2i 3eqtr4ri jca31
      fresaunres1 impbid syl5bb f1od ) AFLZBGLZCAUCZUDZIBLZMZDUAHBCUEUIZDUJZCNZ
      UAUJZACUFZIUGZUHZVAZEOOKUUJHLZUUKOLUUHUUJCHUKULUUFUULUUILZUUPOLZUUGUUFUUR
      MUURUUOOLZUUSUUFUURUMZUUFUUTUURUUFUUMOLZUUNOLUUTUUCUUDUVBUUEACFUNUOIUPUUM
      UUNOOUQURUSUULUUOUUIOUTPVBUUQUULUUKQZMUUJBAUEUIZLZUUJVCZBUUNUFZVDZCUCZMZU
      VCMZUUHUURUUJUUPQZMZUUQUVJUVCUVIDHUVDJVEVFUUHUVKUVMUUHUVKUVMUUHUVKMZUURUV
      LUVNUULUUKUUIUUHUVJUVCVGZUVNUUKUUILZCBUUKRZUVNABUUJRZUUEUVQUVNUVEUVRUUHUV
      EUVIUVCVHZUUJBAVIZSZUUFUUEUUGUVKUUCUUDUUEVJZVKZABCUUJVLPUUFUVPUVQWCZUUGUV
      KUUFUUDCOLZUWDUUCUUDUUEVMZUUFUUEUUCUWEUWBUUCUUDUUEVNZCAFVOPBCUUKGOVPPVKVQ
      VRUVNUUJUUKUUJUUMNZVAZUUPUVNUUJUUJCUUMVAZNZUWIUVNUWKUUJANZUUJUVNUUEUWKUWL
      QUWCUUEUWJAUUJUUEUWJAQZCAWDVSZVTSUVNUVRUUJAWAZUWLUUJQUWAABUUJWEZAUUJWBWFW
      GUUJCUUMWHWIUVNUUKUULUWHUUOUVNUVCWJUVNUUKUULQZWJUVOUVCUWQUVNUULUUKWKWLWMU
      VNUVFOUUNUFVDZACWPZUCZUWHUUOQZUVNUVHCUWRUWSUUHUVEUVIUVCWNUVNUVRUWRUVHQZUW
      AABUVGUUJIUVGWOWQZSUVNUUEUWSCQZUWCUUEUXDCAWRVSSWSUVNUVEUUGUWTUXAWCZUVSUUF
      UUGUVKWTUVEUUGMZUUJUWSUUMVAZWAZUWSUUMWPTQZUUGUXEUXFUWOUXHUXFUVEUVRUWOUVEU
      UGXGUVTUWPWFUXGAUUJACXAXBXCUXIUXFACXDXEUVEUUGUMUWSUUMUUJBIXFXHPXIXJXKXLXR
      UUHUVMUVKUUHUVMMZUVEUVIUVCUXJUUDUUCUVRUVEUUFUUDUUGUVMUWFVKUUFUUCUUGUVMUWG
      VKUXJUWJBUUPRZUVRUXJCBUULRZUUMBUUORZCUUMWPZTQZUXKUXJUURUXLUUFUURUURUUGUVL
      UVAXMUULBCVISZUXJUUGUXMUUFUUGUVMWTUUGUUMUUNUUORZUUNBUCUXMUUMIBXNZIBXOUUMU
      UNBUUOXSPSZUXOUXJCAXPZXECUUMBUULUUOXQXTUXJUWJABUUPUUJUXJUUJUUPUUHUURUVLVG
      ZYAUXJUUEUWMUUFUUEUUGUVMUWBVKUWNSYBXIZUUDUUCMUVEUVRBAUUJGFVPYCXTUXJUVHUWR
      CUXJUVRUXBUYBUXCSUXJABUBUUJCIUYBUXJUBUJZUUMLZMZUYCUUJYDUYCUUPYDZUYCUUOYDZ
      IUYEUYCUUJUUPUXJUVLUYDUYAUSYEUYEUULCWAZUUOUUMWAZUXOUYDUYFUYGQUYEUXLUYHUXJ
      UXLUYDUXPUSCBUULWESUYEUXQUYIUUGUXQUUFUVMUYDUXRYFZUUMUUNUUOWESUXOUYEUXTXEU
      XJUYDUMZCUUMUULUUOUYCYGYHUYEUXQUYDUYGIQUYJUYKUUMIUYCUUOYIPYJYKYLUXJUUKUUP
      CNZUULUXJUUJUUPCUYAYMUXJUXLUXMUULUXNNZUUOUXNNZQZUYLUULQUXPUXSUYOUXJUUOTNZ
      UULTNZUYNUYMUYPTUYQUUOYNUULYNYOUXNTUUOUXTYPUXNTUULUXTYPYQXECUUMBUULUUOYSX
      HWGYRXRYTUUAUUB $.
  $}

  ${
    $d f A $.  $d f B $.  $d f C $.
    maprnin.1 $e |- A e. _V $.
    maprnin.2 $e |- B e. _V $.
    $( Restricting the range of the mapping operator (Contributed by Thierry
       Arnoux, 30-Aug-2017.) $)
    maprnin $p |- ( ( B i^i C ) ^m A ) = { f e. ( B ^m A ) | ran f C_ C } $=
      ( cin cv wf cab cmap co wcel crn wss wa crab wfn wb ffn baibr syl pm5.32i
      df-f elmap anbi1i fin 3bitr4ri abbii inex1 mapval df-rab 3eqtr4i ) ABCGZD
      HZIZDJUOBAKLZMZUONCOZPZDJUNAKLUSDUQQUPUTDABUOIZUSPVAACUOIZPUTUPVAUSVBVAUO
      ARZUSVBSABUOTVBVCUSACUOUDUAUBUCURVAUSBAUOFEUEUFABCUOUGUHUIUNADBCFUJEUKUSD
      UQULUM $.
  $}

  ${
    $d w x y z A $.  $d w x y z F $.  $d x y R $.  $d w ph $.
    fpwrelmapffslem.1 $e |- A e. _V $.
    fpwrelmapffslem.2 $e |- B e. _V $.
    fpwrelmapffslem.3 $e |- ( ph -> F : A --> ~P B ) $.
    fpwrelmapffslem.4 $e |- ( ph ->
                        R = { <. x , y >. | ( x e. A /\ y e. ( F ` x ) ) } ) $.
    $( Lemma for ~ fpwrelmapffslem .  For this theorem, the sets ` A ` and
       ` B ` could be infinite, but the relation ` R ` itself is finite.
       (Contributed by Thierry Arnoux, 1-Sep-2017.) $)
    fpwrelmapffslem $p |- ( ph -> ( R e. Fin
              <-> ( ran F C_ Fin /\ ( `' F " ( _V \ { (/) } ) ) e. Fin ) ) ) $=
      ( vz cfn wcel wa wb wceq syl wex a1i vw cdm crn ccnv cvv c0 csn cdif cima
      wss wrel cfv copab relopab releq mpbiri relfi cab wrex cuni rexcom4 ancom
      cv exbii nfv fvex ceqsex bitr3i rexbii r19.42v 3bitr3ri df-rex bitr2i vex
      eleq2 biidd eleq1 anbi12d exbid elab eluniab 3bitr4g eleq1d adantr wi cpw
      eqrdv wf wfn ffn fnrnfv 3syl sylancl wfun ffun opabdm crab feqmptd cnveqd
      fex cmpt imaeq1d mptpreima syl6eq wne fnniniseg2 n0 rabbiia df-rab 19.42v
      eqid abbii eqtr4i 3eqtrd eqtr4d biimpa ffsrn eqeltrrd unifi unifi3 impbid
      3eqtr3d ex bitr4d opabrn sseq1d 3bitr4d pm5.32da anbi1d bitrd 3bitrd ) AF
      MNZFUBZMNZFUCZMNZOZGUDZUEUFUGUHZUIZMNZGUCZMUJZOZUUCUUAOZAFUKZYLYQPAFBVCZD
      NZCVCZUUGGULZNZOZBCUMZQZUUFKUUNUUFUUMUKUULBCUNFUUMUOUPRFUQRAYQYNUUCOUUDAY
      NYPUUCAYNOZUULBSZCURZMNZLVCZUUJQZBDUSZLURZMUJZYPUUCUUOUURUVBUTZMNZUVCAUUR
      UVEPYNAUUQUVDMAUAUUQUVDAUUHUAVCZUUJNZOZBSZUVFUUSNZUVAOZLSZUVFUUQNUVFUVDNU
      VIUVLPAUVLUVGBDUSZUVIUVJUUTOZLSZBDUSUVNBDUSZLSUVMUVLUVNBLDVAUVOUVGBDUVOUU
      TUVJOZLSUVGUVQUVNLUUTUVJVBVDUVJUVGLUUJUVGLVEUUGGVFUUSUUJUVFVOVGVHVIUVPUVK
      LUVJUUTBDVJVDVKUVGBDVLVMTUUPUVICUVFUAVNUUIUVFQZUULUVHBUVRBVEUVRUUHUUHUUKU
      VGUVRUUHVPUUIUVFUUJVQVRVSVTUVALUVFWAWBWGWCWDUUOUVCUVEUUOUVBMNZUVCUVEWEUUO
      UUBUVBMAUUBUVBQZYNADEWFZGWHZGDWIZUVTJDUWAGWJZBLDGWKWLWDZUUOGUFAGUENZYNAUW
      BDUENUWFJHDUWAUEGWTWMWDAGWNZYNAUWBUWGJDUWAGWORWDAYNUUAAYMYTMAYMUULCSZBURZ
      YTAUUNYMUWIQKUULBCFWPRAYTUUJYSNBDWQZUUKCSZBDWQZUWIAYTBDUUJXAZUDZYSUIUWJAY
      RUWNYSAGUWMABDUWAGJWRWSXBBDUUJYSUWMUWMXKXCXDZAYTUUJUFXEZBDWQZUWJUWLAUWBUW
      CYTUWQQJUWDBDUFGXFWLUWOUWQUWLQAUWPUWKBDUWPUWKPUUHCUUJXGTXHTYBUWLUWIQAUWLU
      UHUWKOZBURUWIUWKBDXIUWHUWRBUUHUUKCXJXLXMTXNXOWCZXPXQXRUVSUVCUVEUVBXSYCRUV
      EUVCWEUUOUVBXTTYAYDAYPUURPYNAYOUUQMAUUNYOUUQQKUULBCFYERWCWDUUOUUBUVBMUWEY
      FYGYHAYNUUAUUCUWSYIYJUUDUUEPAUUAUUCVBTYK $.
  $}

  ${
    $d f r x y A $.  $d f r x y B $.
    fpwrelmap.1 $e |- A e. _V $.
    fpwrelmap.2 $e |- B e. _V $.
    fpwrelmap.3 $e |- M = ( f e. ( ~P B ^m A ) |->
       { <. x , y >. | ( x e. A /\ y e. ( f ` x ) ) } ) $.
    $( Define a canonical mapping between functions from ` A ` into subsets of
       ` B ` and the relations with domain ` A ` and range within ` B ` .  Note
       that the same relation is used in ~ axdc2lem and ~ marypha2lem1 .
       (Contributed by Thierry Arnoux, 28-Aug-2017.) $)
    fpwrelmap $p |- M : ( ~P B ^m A ) -1-1-onto-> ~P ( A X. B ) $=
      ( wcel wa cvv a1i adantr ex wss wceq wb nfv nfan vr cpw cmap co wf1o wtru
      cxp cv cfv copab wbr crab cmpt wi wal cab simpr ffvelrnda elelpwi syl2anc
      elmapi alrimiv abss sylbir syl opabex3d adantl mptex imdistanda ssopab2dv
      ssex df-xp sseq12d mpbird vex elpwg ax-mp sylibr feqmptd nfcv nfeq df-rab
      nfopab1 nfopab2 adantlr imp cop df-br eleq2 opabid syl6bb syl5bb ad2antlr
      cdm elfvdm fdm eleqtrd pm4.71rd ad2antrr bitr4d bicomd biimpa jca adantld
      biimpd impbid abbid abid2 3eqtr2rd mpteq2da eqtrd ssrab2 ssexi mpbir eqid
      wf fmptd feq1d pwex elmapg mp2an wrel biimpi syl6ss df-rel relopab nfmpt1
      xpss nfrab1 nfmpt brelg sylan simpld simprd simpll fveq1d fvmpt2 syl21anc
      id nfci mpan2 sylan9eq eleq2d mpbir2and simplbda expimpd syl5bbr eqrelrd2
      rabid syl6bbr impbii f1od trud ) DUBZCUCUDZCDUGZUBZFUEUFEUAUUOUUQAUHZCJZB
      UHZUUREUHZUIZJZKZABUJZACUURUUTUAUHZUKZBDULZUMZFLLIUVAUUOJZUVELJUFUVJUVCAB
      CCLJZUVJGMUVJUUSKZUVCUUTDJZUNZBUOZUVCBUPZLJZUVLUVNBUVLUVCUVMUVLUVCKUVCUVB
      UUNJZUVMUVLUVCUQUVLUVRUVCUVJCUUNUURUVAUVAUUNCVAZURNUUTUVBDUSUTOZVBUVOUVPD
      PUVQUVCBDVCUVPDHVKVDVEVFVGUVILJUFUVFUUQJZKACUVHGVHMUVJUVFUVEQZKZUWAUVAUVI
      QZKZRUFUWCUWEUWCUWAUWDUWCUVFUUPPZUWAUWCUWFUVEUUSUVMKZABUJZPZUVJUWIUWBUVJU
      VDUWGABUVJUUSUVCUVMUVTVIVJNUWCUVFUVEUUPUWHUVJUWBUQUUPUWHQUWCABCDVLMVMVNUV
      FLJUWAUWFRUAVOUVFUUPLVPVQZVRUWCUVAACUVBUMZUVIUVJUVAUWKQUWBUVJACUUNUVAUVSV
      SNUWCACUVBUVHUVJUWBAUVJASAUVFUVEAUVFVTZUVDABWCZWATUWCUUSKZUVHUVMUVGKZBUPZ
      UVPUVBUVHUWPQUWNUVGBDWBMUWNUVCUWOBUWCUUSBUVJUWBBUVJBSBUVFUVEBUVFVTZUVDABW
      DZWATUUSBSZTUWNUVCUWOUWNUVCUWOUWNUVCKUVMUVGUWNUVCUVMUVJUUSUVNUWBUVTWEWFUW
      NUVCUVGUWNUVGUVCUWNUVGUVDUVCUWBUVGUVDRUVJUUSUVGUURUUTWGZUVFJZUWBUVDUURUUT
      UVFWHZUWBUXAUWTUVEJZUVDUVFUVEUWTWIUVDABWJZWKWLWMUVJUVCUVDRUWBUUSUVJUVCUUS
      UVJUVCUUSUVJUVCKUURUVAWNZCUVCUURUXEJUVJUUTUURUVAWOVGUVJUXECQZUVCUVJCUUNUV
      AXPZUXFUVSCUUNUVAWPVENWQOWRWSWTZXAXBXCOUWNUVGUVCUVMUWNUVGUVCUXHXEXDXFXGUV
      PUVBQUWNBUVBXHMXIXJXKXCUWEUVJUWBUWEUXGUVJUWEUXGCUUNUVIXPZUWAUXIUWDUWAACUV
      HUUNUVIUVHUUNJZUWAUUSKUXJUVHDPZUVGBDXLZUVHLJZUXJUXKRUVHDHUXLXMZUVHDLVPVQX
      NMUVIXOZXQNUWECUUNUVAUVIUWAUWDUQZXRVNUUNLJUVKUVJUXGRDHXSGUUNCUVALLXTYAVRU
      WEUVFYBZUVEYBZUWEUWBUWEUVFLLUGZPUXQUWEUVFUUPUXSUWAUWFUWDUWAUWFUWJYCZNCDYH
      YDUVFYEVRUXRUWEUVDABYFMUWEYSUWEABUVFUVEUWAUWDAUWAASAUVAUVIAUVAVTACUVHYGWA
      TUWAUWDBUWABSBUVAUVIBUVAVTBACUVHBACUWSYTUVGBDYIYJWATUWLUWQUWMUWRUWEUXAUVD
      UXCUXAUVGUWEUVDUXBUWEUVGUVDUWEUVGUVDUWEUVGKZUUSUVCUYAUUSUVMUWAUVGUWGUWDUW
      AUWFUVGUWGUXTUURUUTCDUVFYKYLWEZYMZUYAUVCUVMUVGUYAUUSUVMUYBYNUWEUVGUQUYAUW
      AUWDUUSUVCUWORUWAUWDUVGYOUWEUWDUVGUXPNUYCUWEUUSKZUVCUUTUVHJUWOUYDUVBUVHUU
      TUWEUUSUVBUURUVIUIZUVHUWEUURUVAUVIUXPYPUUSUXMUYEUVHQUXNACUVHLUVIUXOYQUUAU
      UBUUCUVGBDUUIWKZYRUUDXCOUWEUUSUVCUVGUYDUVCUVGUYDUVCUVMUVGUYFUUEOUUFXFUUGU
      XDUUJUUHYRXCUUKMUULUUM $.

    fpwrelmapffs.1 $e |- S = { f e. ( ( ~P B i^i Fin ) ^m A ) |
       ( `' f " ( _V \ { (/) } ) ) e. Fin } $.
    $( Define a canonical mapping between finite relations (finite subsets of a
       cartesian product) and functions with finite support into finite subsets
       (Contributed by Thierry Arnoux, 28-Aug-2017.) $)
    fpwrelmapffs $p |- ( M |` S ) : S -1-1-onto-> ( ~P ( A X. B ) i^i Fin ) $=
      ( vr cv cfn cvv wcel crab wf1o wceq wb crn wss ccnv c0 csn cdif cima cmap
      wa cpw co cxp cres cin wtru cfv copab fpwrelmap a1i wf simpl elmapg mp2an
      pwex sylib simpr fpwrelmapffslem 3adant1 frabbijd trud nfcv nfrab1 rabeqf
      maprnin ax-mp rabrab 3eqtri dfin5 f1oeq23 reseq2i f1oeq1 bitr2i mpbi ) FM
      ZUANUBZWDUCOUDUEUFUGNPZUIZFDUJZCUHUKZQZLMZNPZLCDULUJZQZGWJUMZRZEWMNUNZGEU
      MZRZWPUOWGWLFLWIWMAMZCPBMWTWDUPPUIABUQZGJWIWMGRUOABCDFGHIJURUSWDWIPZWKXAS
      ZWLWGTUOXBXCUIZABCDWKWDHIXDXBCWHWDUTZXBXCVAWHOPCOPXBXETDIVDZHWHCWDOOVBVCV
      EXBXCVFVGVHVIVJWSWJWNWRRZWPEWJSWQWNSWSXGTEWFFWHNUNCUHUKZQZWFFWEFWIQZQZWJK
      XHXJSXIXKSCWHNFHXFVNWFFXHXJFXHVKWEFWIVLVMVOWEWFFWIVPVQZLWMNVREWJWQWNWRVSV
      CWRWOSXGWPTEWJGXLVTWJWNWRWOWAVOWBWC $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
          Real and Complex Numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                      Complex addition - misc. additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Two complex which add up to zero are each other's negatives.  (Contributed
     by Thierry Arnoux, 2-May-2017.) $)
  addeq0 $p |- ( ( A e. CC /\ B e. CC ) -> ( ( A + B ) = 0 <-> A = -u B ) ) $=
    ( cneg wceq cc0 cmin co cc wcel wa caddc df-neg eqeq1i eqcom bitr3i 0cn a1i
    simpr simpl subadd2d syl5rbbr ) ABCZDZEBFGZADZAHIZBHIZJZABKGEDUEUBADUCUBUDA
    BLMUBANOUHEBAEHIUHPQUFUGRUFUGSTUA $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Ordering on reals - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d b c A $.  $d b c B $.  $d b c C $.
    lt2addrd.1 $e |- ( ph -> A e. RR ) $.
    lt2addrd.2 $e |- ( ph -> B e. RR ) $.
    lt2addrd.3 $e |- ( ph -> C e. RR ) $.
    lt2addrd.4 $e |- ( ph -> A < ( B + C ) ) $.
    $( If the right-side of a 'less-than' relationship is an addition, then we
       can express the left-side as an addition, too, where each term is
       respectively less than each term of the original right side.
       (Contributed by Thierry Arnoux, 15-Mar-2017.) $)
    lt2addrd $p |- ( ph -> E. b e. RR E. c e. RR
      ( A = ( b + c ) /\ b < B /\ c < C ) ) $=
      ( caddc co cmin cr wcel wceq clt wbr w3a resubcld cdiv readdcld rehalfcld
      c2 cv wrex recnd addcld subcld halfcld subsub4d oveq2d subadd23d 2halvesd
      cc eqeltrd addsubassd 3eqtr4d nncand 3eqtrrd crp wb difrp mpbid rphalfcld
      syl2anc ltsubrpd oveq1 eqeq2d breq1 3anbi12d 3anbi13d rspc2ev syl113anc
      oveq2 ) ACCDKLZBMLZUDUALZMLZNODVRMLZNOBVSVTKLZPZVSCQRZVTDQRZBEUEZFUEZKLZP
      ZWECQRZWFDQRZSZFNUFENUFACVRHAVQAVPBACDHIUBZGTUCZTADVRIWMTAWAVPVRVRKLZMLZV
      PVQMLBACVTVRMLZKLCDWNMLZKLWAWOAWPWQCKADVRVRADIUGZAVQAVPBACDACHUGZWRUHZABG
      UGZUIZUJZXCUKULACVRVTWSXCADVRWRXCUIUMACDWNWSWRAWNVQUOAVQXBUNZXBUPUQURAWNV
      QVPMXDULAVPBWTXAUSUTACVRHAVQABVPQRZVQVAOZJABNOVPNOXEXFVBGWLBVPVCVFVDVEZVG
      ADVRIXGVGWKWBWCWDSBVSWFKLZPZWCWJSEFVSVTNNWEVSPZWHXIWIWCWJXJWGXHBWEVSWFKVH
      VIWEVSCQVJVKWFVTPZXIWBWJWDWCXKXHWABWFVTVSKVOVIWFVTDQVJVLVMVN $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Extended reals - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( An extended real which is greater than plus infinity is plus infinity.
     (Contributed by Thierry Arnoux, 18-Dec-2016.) $)
  xgepnf $p |- ( A e. RR* -> ( +oo <_ A <-> A = +oo ) ) $=
    ( cxr wcel cpnf cle wbr clt wn wceq wb pnfxr xrlenlt mpan nltpnft bitr4d )
    ABCZDAEFZADGFHZADIDBCPQRJKDALMANO $.

  $( An extended real which is less than minus infinity is minus infinity.
     (Contributed by Thierry Arnoux, 18-Feb-2018.) $)
  xlemnf $p |- ( A e. RR* -> ( A <_ -oo <-> A = -oo ) ) $=
    ( cxr wcel cmnf cle wbr clt wn wceq wb mnfxr xrlenlt mpan2 ngtmnft bitr4d )
    ABCZADEFZDAGFHZADIPDBCQRJKADLMANO $.

  $( Trichotomy law for extended reals.  (Contributed by Thierry Arnoux,
     12-Sep-2017.) $)
  xrlelttric $p |- ( ( A e. RR* /\ B e. RR* ) -> ( A <_ B \/ B < A ) ) $=
    ( cxr wcel wa cle wbr clt wo wn pm2.1 xrlenlt orbi1d mpbiri ) ACDBCDEZABFGZ
    BAHGZIQJZQIQKOPRQABLMN $.

  $( Two extended reals which add up to zero are each other's negatives.
     (Contributed by Thierry Arnoux, 13-Jun-2017.) $)
  xaddeq0 $p |-
    ( ( A e. RR* /\ B e. RR* ) -> ( ( A +e B ) = 0 <-> A = -e B ) ) $=
    ( cxr wcel wa cxad cc0 wceq cxne cpnf cmnf syl simplr syl2anc oveq1d eqtr3d
    co simpr ex wne cr w3o wi elxr simpll rexrd xnegneg xnegcld xaddid2 xaddcom
    xpncan ancoms adantr 3eqtr3d xnegeq wn renepnf mp1i eqnetrd neneqd xaddpnf2
    0re con3and nne sylib xnegmnf syl6req eqtrd renemnf xaddmnf2 xnegpnf sylanb
    3jaoian xnegcl ad2antlr xnegid 3eqtrd impbid ) ACDZBCDZEZABFQZGHZABIZHZVSAU
    ADZAJHZAKHZUBVTWCWEUCZAUDWFVTWIWGWHWFVTEZWCWEWJWCEZAIZIZAWDWKVSWMAHWKAWFVTW
    CUEUFZAUGLWKWLBHWMWDHWKGWLFQZWLBWKWLCDWOWLHWKAWNUHWLUILWKWBWLFQBAFQZWLFQZWO
    BWKWBWPWLFWKVSVTWBWPHWNWFVTWCMABUJNOWKWBGWLFWJWCROWJWQBHZWCVTWFWRBAUKULUMUN
    PWLBUOLPSWGVTEZWCWEWSWCEZAJWDWGVTWCUEZWTWDKIZJWTBKHZWDXBHWTBKTZUPZXCWTVTJBF
    QZJHZUPXEWGVTWCMWTXFJWTXFGJWTWBXFGWTAJBFXAOWSWCRPGUADZGJTWTVBGUQURUSUTVTXDX
    GVTXDXGBVASVCNBKVDVEBKUOLVFVGVHSWHVTEZWCWEXIWCEZAKWDWHVTWCUEZXJWDJIZKXJBJHZ
    WDXLHXJBJTZUPZXMXJVTKBFQZKHZUPXOWHVTWCMXJXPKXJXPGKXJWBXPGXJAKBFXKOXIWCRPXHG
    KTXJVBGVIURUSUTVTXNXQVTXNXQBVJSVCNBJVDVEBJUOLVKVGVHSVMVLWAWEWCWAWEEZWBWDBFQ
    ZBWDFQZGXRAWDBFWAWEROXRWDCDZVTXSXTHVTYAVSWEBVNVOVSVTWEMWDBUJNVTXTGHVSWEBVPV
    OVQSVR $.

  ${
    $d y z A $.
    $( The infinimum of a set of extended reals containing minus infnity is
       minus infinity.  (Contributed by Thierry Arnoux, 18-Feb-2018.) $)
    infxrmnf $p |- ( ( A C_ RR* /\ -oo e. A ) -> sup ( A , RR* , `' < ) = -oo )
      $=
      ( cxr wss cmnf wcel wa clt ccnv csup cle wceq infmxrlb wb infmxrcl adantr
      wbr xlemnf syl mpbid ) ABCZDAEZFZABGHIZDJPZUCDKZADLUBUCBEZUDUEMTUFUAANOUC
      QRS $.
  $}

  $( The extended real numbers are unbounded below.  (Contributed by Thierry
     Arnoux, 18-Feb-2018.) $)
  xrinfm $p |- sup ( RR* , RR* , `' < ) = -oo $=
    ( cxr wss cmnf wcel clt ccnv csup wceq ssid mnfxr infxrmnf mp2an ) AABCADAA
    EFGCHAIJAKL $.

  ${
    le2halvesd.1 $e |- ( ph -> A e. RR ) $.
    le2halvesd.2 $e |- ( ph -> B e. RR ) $.
    le2halvesd.3 $e |- ( ph -> C e. RR ) $.
    le2halvesd.4 $e |- ( ph -> A <_ ( C / 2 ) ) $.
    le2halvesd.5 $e |- ( ph -> B <_ ( C / 2 ) ) $.
    $( A sum is less than the whole if each term is less than half.
       (Contributed by Thierry Arnoux, 29-Nov-2017.) $)
    le2halvesd $p |- ( ph -> ( A + B ) <_ C ) $=
      ( caddc co c2 cdiv cle rehalfcld le2addd recnd 2halvesd breqtrd ) ABCJKDL
      MKZTJKDNABCTTEFADGOZUAHIPADADGQRS $.
  $}


  $( A number is less than or equal to itself plus a nonnegative number.
     (Contributed by Thierry Arnoux, 28-Dec-2016.) $)
  xraddge02 $p |- ( ( A e. RR* /\ B e. RR* ) ->
    ( 0 <_ B -> A <_ ( A +e B ) ) ) $=
    ( cxr wcel wa cc0 cle wbr cxad co xrleid adantr simpl jctir xle2add mpancom
    wi 0xr mpand wb xaddid1 breq1d sylibd ) ACDZBCDZEZFBGHZAFIJZABIJZGHZAUIGHZU
    FAAGHZUGUJUDULUEAKLUDFCDZEUFULUGEUJQUFUDUMUDUEMRNAFABOPSUDUJUKTUEUDUHAUIGAU
    AUBLUC $.

  ${
    $d b c A $.  $d b c B $.  $d b c C $.
    xlt2addrd.1 $e |- ( ph -> A e. RR ) $.
    xlt2addrd.2 $e |- ( ph -> B e. RR* ) $.
    xlt2addrd.3 $e |- ( ph -> C e. RR* ) $.
    xlt2addrd.4 $e |- ( ph -> B =/= -oo ) $.
    xlt2addrd.5 $e |- ( ph -> C =/= -oo ) $.
    xlt2addrd.6 $e |- ( ph -> A < ( B +e C ) ) $.
    $( If the right-side of a 'less-than' relationship is an addition, then we
       can express the left-side as an addition, too, where each term is
       respectively less than each term of the original right side.
       (Contributed by Thierry Arnoux, 15-Mar-2017.) $)
    xlt2addrd $p |- ( ph -> E. b e. RR* E. c e. RR*
      ( A = ( b +e c ) /\ b < B /\ c < C ) ) $=
      ( cxad co wceq clt cxr wcel cc0 cr cv wbr w3a wrex cpnf wa rexrd ad2antrr
      0xr a1i xaddid1 eqcomd syl ltpnf simplr breqtrrd ax-mp simpr oveq1 eqeq2d
      0re breq1 3anbi12d oveq2 3anbi13d rspc2ev syl113anc wne c1 cxne 1re rexri
      xnegcld xaddcld cmnf renemnfd cneg cmin wo xrnepnf biimpi sylancom orcomd
      neneqd pm2.53 sylc rexsub sylancl resubcl eqeltrd rexneg renegcld xaddass
      wn syl222anc xaddcom syl2anc xnegid eqtrd oveq2d 3eqtrrd resubcld 3brtr4d
      ltm1d eqbrtrd pm2.61dane caddc rexadd breqtrd lt2addrd 3anbi1d sylibr wss
      2rexbiia wi ressxr ssrexv reximi 3syl ) ABEUAZFUAZMNZOZXTCPUBZYADPUBZUCZF
      QUDZEQUDZCUEACUEOZUFZYHDUEYJDUEOZUFZBQRZSQRZBBSMNZOZBCPUBZSDPUBZYHAYMYIYK
      ABGUGZUHZYNYLUIUJYLYMYPYTYMYOBBUKZULUMYLBUECPYLBTRZBUEPUBAUUBYIYKGUHBUNUM
      AYIYKUOUPYLSUEDPSUEPUBZYLSTRUUCVASUNUQUJYJYKURUPYFYPYQYRUCBBYAMNZOZYQYEUC
      EFBSQQXTBOZYCUUEYDYQYEUUFYBUUDBXTBYAMUSUTXTBCPVBVCYASOZUUEYPYEYRYQUUGUUDY
      OBYASBMVDUTYASDPVBVEVFVGYJDUEVHZUFZBDVIVJZMNZVJZMNZQRUUKQRZBUUMUUKMNZOZUU
      MCPUBZUUKDPUBZYHUUIBUULAYMYIUUHYSUHZUUIUUKUUIDUUJADQRZYIUUHIUHZUUIVIVIQRZ
      UUIVIVKVLZUJVMVNZVMZVNUVDUUIUUOBUULUUKMNZMNZYOBUUIYMBVOVHZUULQRZUULVOVHUU
      NUUKVOVHUUOUVGOUUSUUIBAUUBYIUUHGUHZVPUVEUUIUULUUIUULUUKVQZTUUIUUKTRZUULUV
      KOUUIUUKDVIVRNZTUUIDTRZVITRZUUKUVMOUUIDVOOZUVNVSZUVPWNZUVNUUIUVNUVPYJUUHU
      UTUVNUVPVSZUVAUUTUUHUFUVSDVTWAZWBWCUUIDVOADVOVHZYIUUHKUHWDUVPUVNWEZWFZVKD
      VIWGWHZUUIUVNUVOUVMTRUWCVKDVIWIWHZWJZUUKWKUMUUIUUKUWFWLWJVPUVDUUIUUKUWFVP
      BUULUUKWMWOUUIUVFSBMUUIUVFUUKUULMNZSUUIUVIUUNUVFUWGOUVEUVDUULUUKWPWQUUIUU
      NUWGSOUVDUUKWRUMWSWTUUIYMYOBOZUUSUUAUMXAUUIBUVMVRNZUEUUMCPUUIUWITRUWIUEPU
      BUUIBUVMUVJUWEXBUWIUNUMUUIUUMBUUKVRNZUWIUUIUUBUVLUUMUWJOUVJUWFBUUKWGWQUUI
      UUKUVMBVRUWDWTWSAYIUUHUOXCUUIUUKUVMDPUWDUUIDUWCXDXEYFUUPUUQUURUCBUUMYAMNZ
      OZUUQYEUCEFUUMUUKQQXTUUMOZYCUWLYDUUQYEUWMYBUWKBXTUUMYAMUSUTXTUUMCPVBVCYAU
      UKOZUWLUUPYEUURUUQUWNUWKUUOBYAUUKUUMMVDUTYAUUKDPVBVEVFVGXFACUEVHZUFZYHDUE
      UWPYKUFZCUUJMNZQRZBUWRVJZMNZQRZBUWRUXAMNZOZUWRCPUBZUXADPUBZYHUWQCUUJACQRZ
      UWOYKHUHZUWQVIUVBUWQUVCUJVMVNZUWQBUWTAYMUWOYKYSUHZUWQUWRUXIVMZVNZUWQUXCUX
      AUWRMNZBUWTUWRMNZMNZBUWQUWSUXBUXCUXMOUXIUXLUWRUXAWPWQUWQYMUVHUWTQRZUWTVOV
      HUWSUWRVOVHUXMUXOOUXJUWQBAUUBUWOYKGUHZVPUXKUWQUWTUWQUWTUWRVQZTUWQUWRTRZUW
      TUXROUWQUWRCVIVRNZTUWQCTRZUVOUWRUXTOUWQCVOOZUYAVSZUYBWNZUYAUWQUYAUYBUWQUX
      GUWOUYAUYBVSZUXHAUWOYKUOUXGUWOUFUYECVTWAZWQWCUWQCVOACVOVHZUWOYKJUHWDUYBUY
      AWEZWFZVKCVIWGWHZUWQUYAUVOUXTTRUYIVKCVIWIWHZWJZUWRWKUMUWQUWRUYLWLWJVPUXIU
      WQUWRUYLVPBUWTUWRWMWOUWQUXOYOBUWQUXNSBMUWQUXNUWRUWTMNZSUWQUXPUWSUXNUYMOUX
      KUXIUWTUWRWPWQUWQUWSUYMSOUXIUWRWRUMWSWTUWQYMUWHUXJUUAUMWSXAUWQUWRUXTCPUYJ
      UWQCUYIXDXEUWQBUXTVRNZUEUXADPUWQUYNTRUYNUEPUBUWQBUXTUXQUYKXBUYNUNUMUWQUXA
      BUWRVRNZUYNUWQUUBUXSUXAUYOOUXQUYLBUWRWGWQUWQUWRUXTBVRUYJWTWSUWPYKURXCYFUX
      DUXEUXFUCBUWRYAMNZOZUXEYEUCEFUWRUXAQQXTUWROZYCUYQYDUXEYEUYRYBUYPBXTUWRYAM
      USUTXTUWRCPVBVCYAUXAOZUYQUXDYEUXFUXEUYSUYPUXCBYAUXAUWRMVDUTYAUXADPVBVEVFV
      GUWPUUHUFZYFFTUDZETUDZYGETUDZYHUYTBXTYAXGNZOZYDYEUCZFTUDETUDVUBUYTBCDEFAU
      UBUWOUUHGUHUYTUYCUYDUYAUYTUYAUYBUYTUXGUWOUYEAUXGUWOUUHHUHAUWOUUHUOUYFWQWC
      UYTCVOAUYGUWOUUHJUHWDUYHWFZUYTUVQUVRUVNUYTUVNUVPUWPUUHUUTUVSAUUTUWOUUHIUH
      UVTWBWCUYTDVOAUWAUWOUUHKUHWDUWBWFZUYTBCDMNZCDXGNZPABVUIPUBUWOUUHLUHUYTUYA
      UVNVUIVUJOVUGVUHCDXHWQXIXJYFVUFEFTTXTTRYATRUFZYCVUEYDYEVUKYBVUDBXTYAXHUTX
      KXNXLVUAYGETTQXMZVUAYGXOXPYFFTQXQUQXRVULVUCYHXOXPYGETQXQUQXSXFXF $.
  $}

  ${
    $d x y z B $.  $d x y z C $.  $d z ph $.
    xrsupssd.1 $e |- ( ph -> B C_ C ) $.
    xrsupssd.2 $e |- ( ph -> C C_ RR* ) $.
    $( Inequality deduction for supremum of an extended real subset.
       (Contributed by Thierry Arnoux, 21-Mar-2017.) $)
    xrsupssd $p |- ( ph -> sup ( B , RR* , < ) <_ sup ( C , RR* , < ) ) $=
      ( vx vy vz cxr clt csup wbr wn wss cv wral wrex wi wa xrsupss cle wor a1i
      xrltso sstrd syl supssd wcel wb supcl xrlenlt syl2anc mpbird ) ABIJKZCIJK
      ZUALZUOUNJLMZAFGHIBCJIJUBAUDUCZDEABINFOZGOZJLMZGBPUTUSJLZUTHOJLZHBQRGIPSF
      IQABCIDEUEFGHBTUFZACINVAGCPVBVCHCQRGIPSFIQEFGHCTUFZUGAUNIUHUOIUHUPUQUIAFG
      HIBJURVDUJAFGHICJURVEUJUNUOUKULUM $.
  $}

  ${
    $d a b k u v w x y z X $.  $d a b k u v w x y z Y $.  $d k v w z Z $.
    $d k v w x y z ph $.
    xrofsup.1 $e |- ( ph -> X C_ RR* ) $.
    xrofsup.2 $e |- ( ph -> Y C_ RR* ) $.
    xrofsup.3 $e |- ( ph -> sup ( X , RR* , < ) =/= -oo ) $.
    xrofsup.4 $e |- ( ph -> sup ( Y , RR* , < ) =/= -oo ) $.
    xrofsup.5 $e |- ( ph -> Z = ( +e " ( X X. Y ) ) ) $.
    $( The supremum is preserved by extended addition set operation.  (provided
       minus infinity is not involved as it does not behave well with addition)
       (Contributed by Thierry Arnoux, 20-Mar-2017.) $)
    xrofsup $p |- ( ph -> sup ( Z , RR* , < ) =
      ( sup ( X , RR* , < ) +e sup ( Y , RR* , < ) ) ) $=
      ( vx vy va vb cxr clt cxad wcel wbr wrex wa vz vk vu vv vw wss csup co cv
      cle wral wi wceq cxp cima cfv sseld anim12d imp xaddcl syl ralrimivva cop
      cr fveq2 df-ov syl6eqr eleq1d ralxp sylibr wfun cdm wb xaddf ax-mp xpss12
      wf ffun syl2anc syl6sseqr funimass4 sylancr mpbird eqsstrd supxrcl eleq2d
      fdmi xaddcld pm5.32i nfvd ad2antrr simprl supxrub simprr xle2add syl22anc
      sseldd mp2and fvelima mpan adantl eqeq1d rexxp sylib ancom 2rexbii biimpa
      r19.29d2r breq1 reximi 19.9d2r sylbi ralrimiva w3a simplr simpr xlt2addrd
      cmnf wne nfv nfcv nfre1 nfan id ralrimivw adantr simplll simplr2 supxrlub
      syl21anc simpllr simplr3 reeanv sylanbrc ancoms 3anassrs ex reximdva mpd
      nfrex simplrr simp1d simp-4l simplrl simpld simprd xlt2add biimpar sylan2
      jca32 jca reximia 19.9d2rf elovimad breq2d rspcedv rexlimdvva supxr2 ) AD
      NUFBNOUGZCNOUGZPUHZNQUAUIZUVAUJRZUADUKUVBUVAORZUVBUBUIZORZUBDSZULZUAVDUKD
      NOUGUVAUMADPBCUNZUOZNIAUVJNUFZUCUIZPUPZNQZUCUVIUKZAJUIZKUIZPUHZNQZKCUKJBU
      KUVOAUVSJKBCAUVPBQZUVQCQZTZTUVPNQZUVQNQZTZUVSAUWBUWEAUVTUWCUWAUWDABNUVPEU
      QACNUVQFUQURUSUVPUVQUTVAVBUVNUVSUCJKBCUVLUVPUVQVCZUMZUVMUVRNUWGUVMUWFPUPU
      VRUVLUWFPVEUVPUVQPVFVGZVHVIVJAPVKZUVIPVLZUFZUVKUVOVMNNUNZNPVQUWIVNUWLNPVR
      VOZAUVIUWLUWJABNUFZCNUFZUVIUWLUFEFBNCNVPVSUWLNPVNWGVTZUCUVINPWAWBWCWDAUUS
      UUTAUWNUUSNQZEBWEZVAZAUWOUUTNQZFCWEZVAZWHAUVCUADAUVBDQZTAUVBUVJQZTZUVCAUX
      CUXDADUVJUVBIWFWIUXEUVCJKBCUXEUVCJWJUXEUVCKWJUXEUVRUVBUMZUVRUVAUJRZTZKCSZ
      JBSZUVCKCSZJBSUXEUXGUXFTZKCSJBSUXJUXEUXGUXFJKBCUXEUXGJKBCUXEUWBTZUVPUUSUJ
      RZUVQUUTUJRZUXGUXMUWNUVTUXNAUWNUXDUWBEWKZUXEUVTUWAWLZBUVPWMVSUXMUWOUWAUXO
      AUWOUXDUWBFWKZUXEUVTUWAWNZCUVQWMVSUXMUWCUWDUWQUWTUXNUXOTUXGULUXMBNUVPUXPU
      XQWQUXMCNUVQUXRUXSWQUXMUWNUWQUXPUWRVAUXMUWOUWTUXRUXAVAUVPUVQUUSUUTWOWPWRV
      BUXEUVMUVBUMZUCUVISZUXFKCSJBSUXDUYAAUWIUXDUYAUWMUCUVBUVIPWSWTXAUXTUXFUCJK
      BCUWGUVMUVRUVBUWHXBXCXDXHUXLUXHJKBCUXGUXFXEXFXDUXIUXKJBUXHUVCKCUXFUXGUVCU
      VRUVBUVAUJXIXGXJXJVAXKXLXMAUVHUAVDAUVBVDQZTZUVDUVGUYCUVDTZUVBUDUIZUEUIZPU
      HZORZUECSZUDBSZUVGUYDUWNUWOUVBLUIZMUIZPUHZUMZUYKUUSORZUYLUUTORZXNZMNSZLNS
      ZUYJAUWNUYBUVDEWKAUWOUYBUVDFWKUYDUVBUUSUUTLMAUYBUVDXOAUWQUYBUVDUWSWKAUWTU
      YBUVDUXBWKAUUSXRXSUYBUVDGWKAUUTXRXSUYBUVDHWKUYCUVDXPXQUWNUWOTZUYSTZUYJLMN
      NUYTUYSMUYTMXTUYRMLNMNYAUYQMNYBYTYCVUAUYJLWJVUAUYJMWJVUAUYTUYQTZMNSZLNSUY
      JMNSZLNSVUAUYTUYQLMNNUYTUYTMNUKZLNUKUYSUYTVUELNUYTUYTMNUYTYDYEYEYFUYTUYSX
      PXHVUCVUDLNUYKNQZVUBUYJMNVUFUYLNQZTZVUBUYJVUHVUBTZUYKUYEORZUYLUYFORZTZUEC
      SZUDBSZUYJVUBVUHVUNVUBVUHTZVUJUDBSZVUKUECSZVUNVUOUWNVUFUYOVUPUWNUWOUYQVUH
      YGVUBVUFVUGWLUYNUYOUYPUYTVUHYHUWNVUFTUYOVUPUDBUYKYIXGYJVUOUWOVUGUYPVUQUWN
      UWOUYQVUHYKVUBVUFVUGWNUYNUYOUYPUYTVUHYLUWOVUGTUYPVUQUECUYLYIXGYJVUJVUKUDU
      EBCYMYNYOVUIVUMUYIUDBVUIUYEBQZTZVULUYHUECVUSUYFCQZTZVULUYHVVAVULTZUYNVUHU
      YENQZUYFNQZTTZVULTZUYHVVBUYNUYOUYPVUIVURVUTVULUYQVUHUYTUYQVURVUTVULXNZUUA
      YPUUBVVBVVEVULVVBVUHVVCVVDVUHVUBVURVUTVULUUCVVBBNUYEVVBUWNUWOVUIVURVUTVUL
      UYTVUHUYTUYQVVGUUDYPZUUEVUIVURVUTVULYKWQVVBCNUYFVVBUWNUWOVVHUUFVUSVUTVULX
      OWQUUJVVAVULXPUUKVVFUYNUYMUYGORZUYHVVEVULVVIUYKUYLUYEUYFUUGUSUYNUYHVVIUVB
      UYMUYGOXIUUHUUIVSYQYRYRYSYQYRUULVAUUMYJAUYJUVGULUYBUVDAUYHUVGUDUEBCAVURVU
      TTZTZUVFUYHUBUYGDVVKUYGDQZUYGUVJQZVVKUYEUYFBCPAVURVUTWLAVURVUTWNUWMAUWKVV
      JUWPYFUUNAVVLVVMVMVVJADUVJUYGIWFYFWCVVKUVEUYGUMZTUVEUYGUVBOVVKVVNXPUUOUUP
      UUQWKYSYQXMUAUBDUVAUURWP $.
  $}

  ${
    $d x A $.
    $( The supremum of a non-empty set of extended reals which does not contain
       minus infinity is not minus infinity.  (Contributed by Thierry Arnoux,
       21-Mar-2017.) $)
    supxrnemnf $p |- ( ( A C_ RR* /\ A =/= (/) /\ -. -oo e. A ) ->
                     sup ( A , RR* , < ) =/= -oo ) $=
      ( vx cxr wss c0 wne cmnf wcel w3a clt csup wbr mnfxr a1i supxrcl 3ad2ant1
      wn wa biimprd sylc wrex simp1 jctir wceq simpl sselda simpr simplr nelneq
      cv syl2anc ngtmnft con1d reximdva0 3impa 3com23 supxrlub xrltne syl3anc )
      ACDZAEFZGAHQZIZGCHZACJKZCHZGVEJLZVEGFVDVCMNUTVAVFVBAOPVCUTVDRZGBUJZJLZBAU
      AZVGVCUTVDUTVAVBUBMUCUTVBVAVKUTVBVAVKUTVBRZVJBAVLVIAHZRZVICHZVIGUDZQZVJVL
      ACVIUTVBUEUFVNVMVBVQVLVMUGUTVBVMUHVIGAUIUKVOVJVPVOVPVJQVIULSUMTUNUOUPVHVG
      VKBAGUQSTGVEURUS $.
  $}

  ${
    $( The topology of the extended reals is Hausdorff.  (Contributed by
       Thierry Arnoux, 24-Mar-2017.) $)
    xrhaus $p |- ( ordTop ` <_ ) e. Haus $=
      ( cle ctsr wcel cordt cfv cha letsr ordthaus ax-mp ) ABCADEFCGAHI $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Real number intervals - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d a b w x A $.  $d a b w x B $.  $d a b w x C $.  $d a b w x D $.
    $( A closed-below, open-above interval is a subset of its closure.
       (Contributed by Thierry Arnoux, 25-Oct-2016.) $)
    icossicc $p |- ( A [,) B ) C_ ( A [,] B ) $=
      ( va vb vx vw cicc cle clt cico df-ico df-icc cxr wcel cv wa wbr ixxssixx
      idd xrltle ) CDEFABGHIHHJCDEKCDELAMNFOZMNPAUAHQSUABTR $.

    $( A closed-above, open-below interval is a subset of its closure.
       (Contributed by Thierry Arnoux, 1-Apr-2017.) $)
    iocssicc $p |- ( A (,] B ) C_ ( A [,] B ) $=
      ( va vb vx vw cicc clt cle cioc df-ioc df-icc cv xrltle cxr wcel ixxssixx
      wa wbr idd ) CDEFABGHIIIJCDEKCDELAFMZNUAOPBOPRUABISTQ $.

    $( An open interval is a subset of its closure-below.  (Contributed by
       Thierry Arnoux, 3-Mar-2017.) $)
    ioossico $p |- ( A (,) B ) C_ ( A [,) B ) $=
      ( va vb vx vw cico clt cle cioo df-ioo df-ico cv xrltle cxr wcel ixxssixx
      wa wbr idd ) CDEFABGHHIHJCDEKCDELAFMZNUAOPBOPRUABHSTQ $.

    $( Condition for a closed interval to be a subset of an open interval.
       (Contributed by Thierry Arnoux, 29-Mar-2017.) $)
    iocssioo $p |- ( ( ( A e. RR* /\ B e. RR* ) /\
      ( A <_ C /\ D < B ) ) -> ( C (,] D ) C_ ( A (,) B ) ) $=
      ( va vb vx vw cioc clt cle cioo df-ioo df-ioc cv xrlelttr ixxss12 ) EFGHA
      BCDIJJJKLKJEFGMEFGNACHOZPRDBPQ $.

    $( Condition for a closed interval to be a subset of an open interval.
       (Contributed by Thierry Arnoux, 29-Mar-2017.) $)
    icossioo $p |- ( ( ( A e. RR* /\ B e. RR* ) /\
      ( A < C /\ D <_ B ) ) -> ( C [,) D ) C_ ( A (,) B ) ) $=
      ( va vb vx vw cico clt cle cioo df-ioo df-ico cv xrltletr ixxss12 ) EFGHA
      BCDIJJKJLJKEFGMEFGNACHOZPRDBPQ $.

    $( Condition for an open interval to be a subset of an open interval.
       (Contributed by Thierry Arnoux, 26-Sep-2017.) $)
    ioossioo $p |- ( ( ( A e. RR* /\ B e. RR* ) /\
      ( A <_ C /\ D <_ B ) ) -> ( C (,) D ) C_ ( A (,) B ) ) $=
      ( va vb vx vw cioo clt cle df-ioo cv xrlelttr xrltletr ixxss12 ) EFGHABCD
      IJJJJIKKEFGLZQACHMZNRDBOP $.

    $( Disjoint joining an open interval with a closed below, open above
       interval to form a closed below, open above interval.  (Contributed by
       Thierry Arnoux, 26-Sep-2017.) $)
    joiniooico $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
      ( A < B /\ B <_ C ) ) -> ( ( ( A (,) B ) i^i ( B [,) C ) ) = (/)
      /\ ( ( A (,) B ) u. ( B [,) C ) ) = ( A (,) C ) ) ) $=
      ( va vb vx vw cxr wcel w3a clt wbr cle wa cioo co cico cin wceq xrltletr
      c0 cun df-ioo df-ico cv xrlenlt ixxdisj adantr ixxun jca ) AHIBHICHIJZABK
      LBCMLNZNABOPZBCQPZRUASZUMUNUBACOPSUKUOULDEFGABCQKKMKODEFUCZDEFUDZBGUEZUFZ
      UGUHDEFGABCQOKKMKOKMUPUQUSUPURBCTABURTUIUJ $.
  $}

  $( An element of a closed interval is more than or equal to its lower bound
     (Contributed by Thierry Arnoux, 23-Dec-2016.) $)
  iccgelb $p |- ( ( A e. RR* /\ B e. RR* /\ C e. ( A [,] B ) ) -> A <_ C ) $=
    ( cxr wcel cicc co cle wbr wa w3a elicc1 biimpa simp2d 3impa ) ADEZBDEZCABF
    GEZACHIZPQJZRJCDEZSCBHIZTRUASUBKABCLMNO $.

  ${
    $d a b x $.  $d a b x z A $.  $d a b x z B $.
    $( The closure of the open end of a left-open real interval.  (Contributed
       by Thierry Arnoux, 28-Mar-2017.) $)
    snunioc $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
                    ( { A } u. ( A (,] B ) ) = ( A [,] B ) ) $=
      ( va vb vz vx cxr wcel cle wbr w3a cicc co cioc cun csn wceq 3ad2ant1 clt
      wa iccid uneq1d simp1 simp2 xrleid df-icc df-ioc cv xrltnle xrletr simprr
      simp3 wi simpl1 simpl3 xrltle syl2anc mpd ex ixxun syl32anc eqtr3d ) AGHZ
      BGHZABIJZKZAALMZABNMZOZAPZVHOABLMZVFVGVJVHVCVDVGVJQVEAUARUBVFVCVCVDAAIJZV
      EVIVKQVCVDVEUCZVMVCVDVEUDVCVDVLVEAUERVCVDVEULCDEFAABNLIISILIICDEUFZCDEUGA
      FUHZUIVNVOABUJVCVCVOGHZKZVLAVOSJZTZAVOIJZVQVSTZVRVTVQVLVRUKWAVCVPVRVTUMVC
      VCVPVSUNVCVCVPVSUOAVOUPUQURUSUTVAVB $.
  $}

  $( A right-open interval does not contain its right endpoint.  (Contributed
     by Thierry Arnoux, 5-Apr-2017.) $)
  ubico $p |- ( ( A e. RR /\ B e. RR* ) -> -. B e. ( A [,) B ) ) $=
    ( cr wcel cxr wa co cle wbr clt w3a simp3 simp1 ltnrd pm2.65i elico2 mtbiri
    cico ) ACDBEDFBABRGDBCDZABHIZBBJIZKZUBUASTUALUBBSTUAMNOABBPQ $.

  $( Equality in terms of 'less than or equal to', 'less than'.  (Contributed
     by Thierry Arnoux, 5-Jul-2017.) $)
  xeqlelt $p |- ( ( A e. RR* /\ B e. RR* ) ->
               ( A = B <-> ( A <_ B /\ -. A < B ) ) ) $=
    ( cxr wcel wa wceq cle wbr clt wn xrletri3 wb xrlenlt ancoms anbi2d bitrd )
    ACDZBCDZEZABFABGHZBAGHZETABIHJZEABKSUAUBTRQUAUBLBAMNOP $.

  $( Relate elementhood to a closed interval with elementhood to the same
     closed-below, opened-above interval or to its upper bound.  (Contributed
     by Thierry Arnoux, 3-Jul-2017.) $)
  eliccelico $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
                    ( C e. ( A [,] B ) <-> ( C e. ( A [,) B ) \/ C = B ) ) ) $=
    ( cxr wcel cle wbr w3a co wn wa simpl1 simpl2 biimpa syl21anc syl2anc sylib
    wi syl22anc ex cicc cico wceq wo clt simprl elicc1 simp1d simp3d jca simprr
    simp2d elico1 notbid df-3an notbii imnan imp xeqlelt biimpar pm5.6 icossicc
    bitr4i simpr sseldi eqeltrd simpl3 breqtrrd xrleid syl eqbrtrd wb mpbir3and
    jaodan impbid ) ADEZBDEZABFGZHZCABUAIZEZCABUBIZEZCBUCZUDZVSWAWCJZKZWDRWAWER
    VSWGWDVSWGKZCDEZVQCBFGZCBUEGZJZWDWHVPVQWAWIVPVQVRWGLZVPVQVRWGMZVSWAWFUFZVPV
    QKZWAKZWIACFGZWJWPWAWIWRWJHZABCUGZNZUHOZWNWHVPVQWAWJWMWNWOWQWIWRWJXAUIOWHWP
    WFWIWRWLWHVPVQWMWNUJZVSWAWFUKXBWHWPWAWRXCWOWQWIWRWJXAULPWPWFKZWIWRKZWLXDWIW
    RWKHZJZXEWLRZWPWFXGWPWCXFABCUMUNNXGXEWKKZJXHXFXIWIWRWKUOUPXEWKUQVCQURSWIVQK
    WDWJWLKCBUSUTSTWAWCWDVAQVSWEWAVSWCWAWDVSWCKWBVTCABVBVSWCVDVEVSWDKZWAWIWRWJX
    JCBDVSWDVDZVPVQVRWDMZVFXJABCFVPVQVRWDVGXKVHXJCBBFXKXJVQBBFGXLBVIVJVKXJVPVQW
    AWSVLVPVQVRWDLXLWTPVMVNTVO $.

  $( Relate elementhood to a closed-below, opened-above interval with
     elementhood to the same opened interval or to its lower bound.
     (Contributed by Thierry Arnoux, 6-Jul-2017.) $)
  elicoelioo $p |- ( ( A e. RR* /\ B e. RR* /\ A < B ) ->
                    ( C e. ( A [,) B ) <-> ( C = A \/ C e. ( A (,) B ) ) ) ) $=
    ( cxr wcel clt wbr w3a co wceq wo wn wa wi cle simpl1 simpl2 biimpa syl2anc
    syl21anc cico cioo simprl elico1 simp1d simp2d simprr simp3d elioo1 3anan32
    jca notbid notbii imnan bitr4i sylib imp syl22anc xeqlelt biimpar ex syl6ib
    eqcom pm5.6 orcom simpr eqeltrd xrleid breqtrrd simpl3 eqbrtrd wb mpbir3and
    syl ioossico sseldi jaodan impbid ) ADEZBDEZABFGZHZCABUAIZEZCAJZCABUBIZEZKZ
    WBWDWGWEKZWHWBWDWGLZMZWENWDWINWBWKACJZWEWBWKWLWBWKMZVSCDEZACOGZACFGZLZWLVSV
    TWAWKPZWMVSVTWDWNWRVSVTWAWKQZWBWDWJUCZVSVTMZWDMZWNWOCBFGZXAWDWNWOXCHZABCUDZ
    RZUETZWMVSVTWDWOWRWSWTXBWNWOXCXFUFTWMXAWJWNXCWQWMVSVTWRWSUKZWBWDWJUGXGWMXAW
    DXCXHWTXBWNWOXCXFUHSXAWJMZWNXCMZWQXIWNWPXCHZLZXJWQNZXAWJXLXAWGXKABCUIULRXLX
    JWPMZLXMXKXNWNWPXCUJUMXJWPUNUOUPUQURVSWNMWLWOWQMACUSUTURVAACVCVBWDWGWEVDUPW
    GWEVEVBWBWHWDWBWEWDWGWBWEMZWDWNWOXCXOCADWBWEVFZVSVTWAWEPZVGXOAACOXOVSAAOGXQ
    AVHVNXPVIXOCABFXPVSVTWAWEVJVKXOVSVTWDXDVLXQVSVTWAWEQXESVMWBWGMWFWCCABVOWBWG
    VFVPVQVAVR $.

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Intersection between two opened below, closed above intervals sharing
       the same upper bound.  (Contributed by Thierry Arnoux, 7-Aug-2017.) $)
    iocinioc2 $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ A <_ B )
      -> ( ( A (,] C ) i^i ( B (,] C ) ) = ( B (,] C ) ) $=
      ( vx cxr wcel w3a cle wbr wa cioc co cin cv clt wb elioc1 syl2anc 3adant3
      bitr4d simpl1 simpl3 simpl2 anbi12d simp31 simp32 xrlelttrd simp33 3expia
      elin simp2 3jca pm4.71rd syl5bb eqrdv ) AEFZBEFZCEFZGZABHIZJZDACKLZBCKLZM
      ZVCVADNZVDFZVEEFZBVEOIZVECHIZGZVEVCFZVFVEVBFZVKJZVAVJVEVBVCUJVAVMVGAVEOIZ
      VIGZVJJVJVAVLVOVKVJVAUPURVLVOPUPUQURUTUAZUPUQURUTUBZACVEQRVAUQURVKVJPUPUQ
      URUTUCZVQBCVEQRZUDVAVJVOUSUTVJVOUSUTVJGZVGVNVIUSUTVGVHVIUEZVTABVEUSUTUPVJ
      VPSUSUTUQVJVRSWAUSUTVJUKUSUTVGVHVIUFUGUSUTVGVHVIUHULUIUMTUNVSTUO $.
  $}

  ${
    $d x A $.
    xrdifh.1 $e |- A e. RR* $.
    $( Set difference of a half-opened interval in the extended reals.
       (Contributed by Thierry Arnoux, 1-Aug-2017.) $)
    xrdifh $p |- ( RR* \ ( A [,] +oo ) ) = ( -oo [,) A ) $=
      ( vx cxr cpnf cicc co cdif cmnf wcel wn wa wbr cle wo w3a pm5.32i 3bitr4i
      wb mp2an cico clt biortn pnfge notnot sylib biorf syl orcom syl6bbr pnfxr
      cv w3o elicc1 notbii 3ianor 3orass 3bitri a1i 3bitr4rd mpan2 bitr4d eldif
      xrltnle 3anass mnfxr elico1 mnfle biantrurd eqriv ) CDAEFGZHZIAUAGZCULZDJ
      ZVNVKJZKZLVOVNAUBMZLZVNVLJVNVMJZVOVQVRVOVQAVNNMZKZVRVOWBVNENMZKZOZVOKZWEO
      ZWBVQVOWEUCVOWBWDWBOZWEVOWDKZWBWHSVOWCWIVNUDWCUEUFWDWBUGUHWBWDUIUJVQWGSVO
      VQVOWAWCPZKWFWBWDUMWGVPWJADJZEDJVPWJSBUKAEVNUNTUOVOWAWCUPWFWBWDUQURUSUTVO
      WKVRWBSBVNAVDVAVBQVNDVKVCVOIVNNMZVRPZVOWLVRLZLVTVSVOWLVRVEIDJWKVTWMSVFBIA
      VNVGTVOVRWNVOWLVRVNVHVIQRRVJ $.
  $}

  ${
    $( Relate intersection of two opened below, closed above intervals with the
       same upper bound with a conditional construct.  (Contributed by Thierry
       Arnoux, 7-Aug-2017.) $)
    iocinif $p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) ->
      ( ( A (,] C ) i^i ( B (,] C ) )
                                = if ( A < B , ( B (,] C ) , ( A (,] C ) ) ) $=
      ( cxr wcel w3a clt wbr cioc co cin wa wn wo cle iocinioc2 syldan ex ancld
      wceq cif exmid xrltle imp 3adantl3 simpl2 simpl1 xrlenlt biimpar syl21anc
      simpr 3ancoma incom syl5eqr sylanbr orim12d mpi eqif sylibr ) ADEZBDEZCDE
      ZFZABGHZACIJZBCIJZKZVFTZLZVDMZVGVETZLZNZVGVDVFVEUATVCVDVJNVMVDUBVCVDVIVJV
      LVCVDVHVCVDVHVCVDABOHZVHUTVAVDVNVBUTVALVDVNABUCUDUEABCPQRSVCVJVKVCVJVKVCV
      JBAOHZVKVCVJLVAUTVJVOUTVAVBVJUFUTVAVBVJUGVCVJUKVAUTLVOVJBAUHUIUJVCVAUTVBF
      ZVOVKVAUTVBULVPVOLVGVFVEKVEVFVEUMBACPUNUOQRSUPUQVDVGVFVEURUS $.
  $}

  $( The difference between two opened intervals sharing the same lower bound
     (Contributed by Thierry Arnoux, 26-Sep-2017.) $)
  difioo $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\ A < B )
            -> ( ( A (,) C ) \ ( A (,) B ) ) = ( B [,) C ) ) $=
    ( cxr wcel clt wbr wa cle cioo co wceq cin cun wss simpll1 adantr syl simpr
    c0 w3a cdif incom joiniooico anassrs simpld syl5eqr simprd uncom a1i simpl3
    xrleid ioossioo syl22anc ssequn2 sylib 3eqtr4d difeq sylanbrc simpl2 xrltle
    cico imp syl21anc ssdif0 ico0 biimpar eqtr4d wo xrlelttric syl2anc mpjaodan
    ) ADEZBDEZCDEZUAZABFGZHZBCIGZACJKZABJKZUBZBCVBKZLZCBFGZVRVSHZWCWAMZTLWCWANZ
    VTWANZLWDWFWGWAWCMZTWAWCUCWFWJTLZWAWCNZVTLZVPVQVSWKWMHABCUDUEZUFUGWFWLVTWHW
    IWFWKWMWNUHWHWLLWFWCWAUIUJWFWAVTOZWIVTLWFVMVOAAIGZVSWOVMVNVOVQVSPZVRVOVSVMV
    NVOVQUKZQWFVMWPWQAULZRVRVSSACABUMUNWAVTUOUPUQVTWAWCURUSVRWEHZWBTWCWTVTWAOZW
    BTLWTVMVNWPCBIGZXAVMVNVOVQWEPZVRVNWEVMVNVOVQUTZQZWTVMWPXCWSRWTVOVNWEXBVRVOW
    EWRQZXEVRWESVOVNHWEXBCBVAVCVDZABACUMUNVTWAVEUPWTVNVOXBWCTLZXEXFXGVNVOHXHXBB
    CVFVGVDVHVRVNVOVSWEVIXDWRBCVJVKVL $.

  $( The difference between two closed below, opened above intervals sharing
     the same upper bound (Contributed by Thierry Arnoux, 13-Oct-2017.) $)
  difico $p |- ( ( ( A e. RR* /\ B e. RR* /\ C e. RR* ) /\
    ( A <_ B /\ B <_ C ) ) -> ( ( A [,) C ) \ ( B [,) C ) ) = ( A [,) B ) ) $=
    ( cxr wcel w3a cle wbr wa cico co cdif cun cin c0 icodisj undif4 syl adantr
    wceq difid uneq2i un0 eqtri a1i icoun difeq1d 3eqtr3rd ) ADEBDECDEFZABGHBCG
    HIZIZABJKZBCJKZUMLZMZULUMMZUMLZULACJKZUMLUIUOUQTZUJUIULUMNOTUSABCPULUMUMQRS
    UOULTUKUOULOMULUNOULUMUAUBULUCUDUEUKUPURUMABCUFUGUH $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Finite intervals of integers - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Finite sets of sequential integers starting from a natural are a subset of
     the natural numbers.  (Contributed by Thierry Arnoux, 4-Aug-2017.) $)
  fzssnn $p |- ( M e. NN -> ( M ... N ) C_ NN ) $=
    ( cn wcel cfz co c1 wss cuz cfv fzss1 nnuz eleq2s fzssuz sseqtr4i syl6ss )
    ACDABEFZGBEFZCQRHAGIJZCAGBKLMRSCGBNLOP $.

  ${
    $d j N $.
    $( Upper set of the natural numbers.  (Contributed by Thierry Arnoux,
       22-Aug-2017.) $)
    nndiffz1 $p |- ( N e. NN0 -> ( NN \ ( 1 ... N ) ) = ( ZZ>= ` ( N + 1 ) ) )
      $=
      ( vj wcel cn c1 co caddc cz cle wbr wn wa baibd zred simpr bitrd pm5.32da
      wb a1i cc0 cn0 cfz cdif cuz cfv cv w3a 1z nn0z elfz1 3anass syl6bb notbid
      sylancr clt simpl ltnled zltp1le bitr3d sylan adantr cr 1re simpll nn0red
      readdcld simplr 0p1e1 nn0ge0d leadd1dd syl5eqbrr letrd ex pm4.71rd bicomd
      0re eldif elnnz1 anbi1i anass 3bitri peano2nn0 nn0zd eluz1 3bitr4d eqrdv
      syl ) AUACZBDEAUBFZUCZAEGFZUDUEZWHBUFZHCZEWMIJZWMWICZKZLZLZWNWKWMIJZLZWMW
      JCZWMWLCZWHWNWRWTWHWNLZWRWOWTLZWTXDWOWQWTXDWOLZWQWMAIJZKZWTXFWPXGXDWPWOXG
      WHWPWNWOXGLZWHWPWNWOXGUGZWNXILWHEHCAHCZWPXJRUHAUIZWMEAUJUNWNWOXGUKULMMUMX
      DXHWTRZWOWHXKWNXMXLXKWNLZAWMUOJXHWTXNAWMXNAXKWNUPNXNWMXKWNONUQAWMURUSUTVA
      PQXDWTXEXDWTWOXDWTWOXDWTLZEWKWMEVBCXOVCSZXOAEXOAWHWNWTVDZVEZXPVFXOWMWHWNW
      TVGNXOETEGFWKIVHXOTAETVBCXOVPSXRXPXOAXQVIVJVKXDWTOVLVMVNVOPQXBWSRWHXBWMDC
      ZWQLWNWOLZWQLWSWMDWIVQXSXTWQWMVRVSWNWOWQVTWASWHWKHCXCXARWHWKAWBWCWKWMWDWG
      WEWF $.
  $}

  ${
    $d n x y z A $.
    $( For any finite subset of ` NN ` , find a superset in the form of a set
       of sequential integers.  (Contributed by Thierry Arnoux,
       13-Sep-2017.) $)
    ssnnssfz $p |- ( A e. ( ~P NN i^i Fin ) -> E. n e. NN A C_ ( 1 ... n ) ) $=
      ( vx vy vz cn cfn wcel c1 cv cfz co wss wrex c0 wceq wa clt adantr wbr cr
      cpw cin 1nn simpr 0ss syl6eqss oveq2 sseq2d sylancr wne csup elin simplbi
      rspcev elpwid wor nnssre ltso mp2 a1i simprbi fisupcl syl13anc sseldd cuz
      soss cfv sselda nnuz syl6eleq cz cle nnzd wn wral wi fisup2g ssrexv supub
      sylc imp nnred lenltd mpbird eluz2 syl3anbrc eluzfz syl2anc ex pm2.61dane
      ssrdv ) AFUBZGUCHZAIBJZKLZMZBFNZAOWNAOPZQZIFHAIIKLZMZWRUDWTAOXAWNWSUEXAUF
      UGWQXBBIFWOIPWPXAAWOIIKUHUIUOUJWNAOUKZQZAFRULZFHAIXEKLZMZWRXDAFXEXDAFWNAW
      MHZXCWNXHAGHZAWMGUMZUNSUPZXDFRUQZXIXCAFMZXEAHZXLXDFUAMUARUQXLURUSFUARVGUT
      VAZWNXIXCWNXHXIXJVBSZWNXCUEZXKFARVCVDZVEXDCAXFXDCJZAHZXSXFHZXDXTQZXSIVFVH
      ZHXEXSVFVHHZYAYBXSFYCXDAFXSXKVIZVJVKYBXSVLHXEVLHXSXEVMTZYDYBXSYEVNYBXEYBA
      FXEXDXMXTXKSXDXNXTXRSVEZVNYBYFXEXSRTVOZXDXTYHXDCDEFAXSRXOXDXMXSDJZRTVODAV
      PYIXSRTYIEJRTEANVQDFVPQZCANZYJCFNXKXDXLXIXCXMYKXOXPXQXKCDEFARVRVDYJCAFVSW
      AVTWBYBXSXEYBXSYEWCYBXEYGWCWDWEXSXEWFWGXSIXEWHWIWJWLWQXGBXEFWOXEPWPXFAWOX
      EIKUHUIUOWIWK $.
  $}

  $( Split the last element of a finite set of sequential integers.  (more
     generic than ~ fzsuc ) (Contributed by Thierry Arnoux, 7-Nov-2016.) $)
  fzspl $p |- ( N e. ( ZZ>= ` M ) ->
                ( M ... N ) = ( ( M ... ( N - 1 ) ) u. { N } ) ) $=
    ( cuz cfv wcel cfz co c1 cmin caddc cun wceq csn wa cc eluzelz zcnd jca syl
    cz 1z a1i npcan syl2anc eleq1d ibir cle wbr eluzelre lem1d wb zsubcld eluz1
    mpbird fzsplit2 oveq1d fzsn eqtrd uneq2d eqeq2d mpbid ) BACDZEZABFGZABHIGZF
    GZVEHJGZBFGZKZLZVDVFBMZKZLVCVGVBEZBVECDEZNVJVCVMVNVCVMVCVGBVBVCBOEHOEVGBLVC
    BABPZQVCHHTEVCUAUBZQBHUCUDZUEUFVCVNBTEZVEBUGUHZNZVCVRVSVOVCBABUIUJRVCVETEVN
    VTUKVCBHVOVPULVEBUMSUNRVEABUOSVCVIVLVDVCVHVKVFVCVHBBFGZVKVCVGBBFVQUPVCVRWAV
    KLVOBUQSURUSUTVA $.

  ${
    $d x K $.  $d x M $.  $d x N $.
    $( Split a finite interval of integers into two parts.  (Contributed by
       Thierry Arnoux, 2-May-2017.) $)
    fzsplit3 $p |- ( K e. ( M ... N ) ->
      ( M ... N ) = ( ( M ... ( K - 1 ) ) u. ( K ... N ) ) ) $=
      ( vx cfz co wcel c1 wo wa wbr cr syl2anr cuz cfv cz elfzuz elfzuz3 adantl
      wb cmin cun cv cle clt elfzelz 1re a1i resubcld lelttric 1z zsubcld elfz5
      zred elfzuzb rbaib eluz syl2an zlem1lt 3bitrd orbi12d mpbird adantr caddc
      syl peano2uz recnd npcand eleq1d mpbid uztrn syl2anc sylanbrc jaodan elun
      impbida syl6bbr eqrdv ) ABCEFZGZDVSBAHUAFZEFZACEFZUBZVTDUCZVSGZWEWBGZWEWC
      GZIZWEWDGVTWFWIVTWFJZWIWEWAUDKZWAWEUEKZIZWFWELGWALGWMVTWFWEWEBCUFZUNVTAHV
      TAABCUFZUNZHLGVTUGUHZUIWEWAUJMWJWGWKWHWLWFWEBNOZGZWAPGWGWKTVTWEBCQVTAHWOH
      PGVTUKUHULWEBWAUMMWJWHWEANOZGZAWEUDKZWLWJCWENOZGZWHXATWFXDVTWEBCRSWHXAXDW
      EACUOUPVEVTAPGZWEPGZXAXBTWFWOWNAWEUQURVTXEXFXBWLTWFWOWNAWEUSURUTVAVBVTWGW
      FWHVTWGJZWSXDWFWGWSVTWEBWAQSXGCWTGZAXCGZXDVTXHWGABCRVCXGWAHVDFZXCGZXIXGWA
      XCGZXKWGXLVTWEBWARSWEWAVFVEVTXKXITWGVTXJAXCVTAHVTAWPVGVTHWQVGVHVIVCVJACWE
      VKVLWEBCUOZVMVTWHJWSXDWFWHXAAWRGWSVTWEACQABCQAWEBVKMWHXDVTWEACRSXMVMVNVPW
      EWBWCVOVQVR $.
  $}

  $( The proportion of one binomial coefficient to another with ` N ` decreased
     by 1.  (Contributed by Thierry Arnoux, 9-Nov-2016.) $)
  bcm1n $p |- ( ( K e. ( 0 ... ( N - 1 ) ) /\ N e. NN ) ->
    ( ( ( N - 1 ) _C K ) / ( N _C K ) ) = ( ( N - K ) / N ) ) $=
    ( cc0 c1 cmin co cfz wcel cn wa cbc cdiv wceq cmul cc wbr adantr clt mpbird
    nnne0d caddc bcp1n nnz zcnd adantl ax-1cn a1i npcand oveq1d oveq12d eqeq12d
    oveq2d syl5ib 3impia 3anidm13 wne wb crp cn0 cle elfznn0 simpr elfzelz zred
    nnnn0d cz elfzle2 zltlem1 syl2an ltled elfz2nn0 syl3anbrc bcrpcl syl subcld
    rpcnd cneg negsubdi2d resubcld recnd addid2d breqtrrd 0re ltsubaddd lt0ne0d
    cr negne0d eqnetrrd divcld rpcnne0d divmul2 syl3anc bccl2 recdivd 3eqtr3d )
    ACBDEFZGFHZBIHZJZDBAKFZWPAKFZLFZLFDBBAEFZLFZLFXAWTLFXCBLFWSXBXDDLWSXBXDMZWT
    XAXDNFZMZWQWRXGWQWRWQXGWQWPDUAFZAKFZXAXHXHAEFZLFZNFZMWSXGAWPUBWSXIWTXLXFWSX
    HBAKWSBDWRBOHWQWRBBUCZUDUEZDOHWSUFUGUHZUIWSXKXDXANWSXHBXJXCLXOWSXHBAEXOUIUJ
    ULUKUMUNUOWSWTOHXDOHXAOHXACUPZJXEXGUQWSWTWSACBGFHZWTURHWSAUSHZBUSHABUTPXQWQ
    XRWRAWPVAQWSBWQWRVBZVEWSABWSAWQAVFHZWRACWPVCZQVDZWSBWRBVFHZWQXMUEVDZWSABRPZ
    AWPUTPZWQYFWRACWPVGQWQXTYCYEYFUQWRYAXMABVHVISZVJABVKVLZABVMVNVPZWSBXCXNWSBA
    XNWQAOHWRWQAYAUDQZVOZWSABEFZVQXCCWSABYJXNVRWSYLWSYLWSABYBYDVSVTWSYLWSYLCRPA
    CBUAFZRPWSABYMRYGWSBXNWAWBWSABCYBYDCWFHWSWCUGWDSWEWGWHZWIWSXAWQXAURHWRAWPVM
    QZWJWTXDXAWKWLSULWSWTXAYIWSXAYOVPWSWTWSXQWTIHYHABWMVNTWQXPWRWQXAAWPWMTQWNWS
    BXCXNYKWSBXSTYNWNWO $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Half-open integer ranges - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d k m n x N $.  $d k m x A $.  $d m x B $.
    iundisj3.0 $e |- F/_ n B $.
    iundisj3.1 $e |- ( n = k -> A = B ) $.
    $( Rewrite a countable union as a disjoint union, finite version.  Cf.
       ~ iundisj (Contributed by Thierry Arnoux, 15-Feb-2017.) $)
    iundisjfi $p |- U_ n e. ( 1 ..^ N ) A =
      U_ n e. ( 1 ..^ N ) ( A \ U_ k e. ( 1 ..^ n ) B ) $=
      ( vx vm c1 cfzo co ciun cv wcel wrex cr cn nfcv wceq cdif csb crab ssrab2
      clt ccnv csup cuz cfv wss c0 wne fzossnn nnuz sseqtri sstri rabn0 biimpri
      infmssuzcl sylancr sseldi nfrab1 nfsup nfcsb1 nfcri csbeq1a eleq2d elrabf
      wa sylib simprd nnssre ltnrd eliun ad2antrr elfzouz2 fzoss2 sselda adantr
      wbr 3syl nnred cle simpr sylanbrc infmssuzle elfzolt2 ad2antlr lelttrd ex
      rexlimdva syl5bi mtod eldifd csbeq1 oveq2 iuneq1d difeq12d rspcev syl2anc
      nfv nfcsb1v nfiun nfdif cbvrex sylibr eldifi reximi impbii 3bitr4i eqriv
      ) HDJEKLZAMZDXLACJDNZKLZBMZUAZMZHNZAOZDXLPZXSXQOZDXLPZXSXMOXSXROYAYCYAXSD
      INZAUBZCJYDKLZBMZUAZOZIXLPZYCYAXTDXLUCZQUEUFZUGZXLOZXSDYMAUBZCJYMKLZBMZUA
      ZOZYJYAYKXLYMXTDXLUDZYAYKJUHUIZUJZYKUKULZYMYKOZYKXLUUAYTXLRUUAEUMZUNUOUPZ
      UUCYAXTDXLUQURYKJUSUTZVAZYAXSYOYQYAYNXSYOOZYAUUDYNUUIVIUUGXTUUIDYMXLDYKQY
      LXTDXLVBDQSDYLSVCZDXLSZDHYODYMAUUJVDVEXNYMTAYOXSDYMAVFVGVHVJVKYAXSYQOZYMY
      MUEVTZYAYMYAYKQYMYKRQYKXLRYTUUEUPVLUPUUGVAZVMUULXSBOZCYPPYAUUMCXSYPBVNYAU
      UOUUMCYPYACNZYPOZVIZUUOUUMUURUUOVIZYMUUPYMYAYMQOUUQUUOUUNVOZUUSUUPUUSXLRU
      UPUUEUURUUPXLOZUUOYAYPXLUUPYAYNEYMUHUIOYPXLUJUUHYMJEVPYMJEVQWAVRVSZVAWBUU
      TUUSUUBUUPYKOZYMUUPWCVTUUFUUSUVAUUOUVCUVBUURUUOWDXTUUODUUPXLDUUPSUUKDHBFV
      EXNUUPTABXSGVGVHWEUUPYKJWFUTUUQUUPYMUEVTYAUUOUUPJYMWGWHWIWJWKWLWMWNYIYSIY
      MXLYDYMTZYHYRXSUVDYEYOYGYQDYDYMAWOUVDCYFYPBYDYMJKWPWQWRVGWSWTYBYIDIXLYBIX
      ADHYHDYEYGDYDAXBCDYFBDYFSFXCXDVEXNYDTZXQYHXSUVEAYEXPYGDYDAVFUVECXOYFBXNYD
      JKWPWQWRVGXEXFYBXTDXLXSAXPXGXHXIDXSXLAVNDXSXLXQVNXJXK $.
  $}

  ${
    $d a b k n x y N $.  $d a b k m x y A $.  $d a b m x y B $.
    $d k m n x N $.
    iundisj2fi.0 $e |- F/_ n B $.
    iundisj2fi.1 $e |- ( n = k -> A = B ) $.
    $( A disjoint union is disjoint, finite version.  Cf. ~ iundisj2
       (Contributed by Thierry Arnoux, 16-Feb-2017.) $)
    iundisj2fi $p |- Disj_ n e. ( 1 ..^ N ) ( A \ U_ k e. ( 1 ..^ n ) B ) $=
      ( vx vy va vb c1 cfzo cv weq csb cin c0 wcel cr ciun cdif wdisj wceq wral
      co wo wtru tru eqeq12 csbeq1 ineqan12d eqeq1d orbi12d equcom syl6bb incom
      wa syl6eq wss cn fzossnn nnssre sstri a1i biidd cle wbr necom df-ne bitri
      w3a wn wne clt wb sseli id leltne syl3an nfcsb1v nfcv nfiun nfdif csbeq1a
      wi vex oveq2 iuneq1d difeq12d csbief ineq12i cuz cfv cz simp1 sseldi nnuz
      syl6eleq simp2 nnzd simp3 elfzo2 syl3anbrc csbhypf equcoms eqcomd ssiun2s
      syl ssdifssd ssrin syl5eqss disjdif sseq0 sylancl 3adant3 sylbird syl5bir
      3expia orrd adantl wlogle mpan rgen2a disjors mpbir ) DLEMUFZACLDNZMUFZBU
      AZUBZUCHIOZDHNZYKPZDINZYKPZQZRUDZUGZIYGUEHYGUEYSHIYGUHYMYGSZYOYGSZURZYSUI
      UHJKOZDJNZYKPZDKNZYKPZQZRUDZUGYSYSHIJKYGJHOZKIOZURZUUCYLUUIYRUUDYMUUFYOUJ
      UULUUHYQRUUJUUKUUEYNUUGYPDUUDYMYKUKDUUFYOYKUKULUMUNJIOZKHOZURZUUCYLUUIYRU
      UOUUCIHOYLUUDYOUUFYMUJIHUOUPUUOUUHYQRUUOUUHYPYNQYQUUMUUNUUEYPUUGYNDUUDYOY
      KUKDUUFYMYKUKULYPYNUQUSUMUNYGTUTUHYGVATEVBZVCVDZVEUHUUBURYSVFYTUUAYMYOVGV
      HZVLZYSUHUUSYLYRYLVMZYOYMVNZUUSYRUVAYMYOVNUUTYOYMVIYMYOVJVKUUSUVAYMYOVOVH
      ZYRYTYMTSUUAYOTSUURUURUVBUVAVPYGTYMUUQVQYGTYOUUQVQUURVRYMYOVSVTYTUUAUVBYR
      WFUURYTUUAUVBYRYTUUAUVBVLZYQCLYOMUFZBUAZDYOAPZUVEUBZQZUTUVHRUDYRUVCYQDYMA
      PZCLYMMUFZBUAZUBZUVGQZUVHYNUVLYPUVGDYMYKUVLHWGDUVIUVKDYMAWACDUVJBDUVJWBFW
      CWDDHOZAUVIYJUVKDYMAWEUVNCYIUVJBYHYMLMWHWIWJWKDYOYKUVGIWGDUVFUVEDYOAWACDU
      VDBDUVDWBFWCWDDIOZAUVFYJUVEDYOAWEUVOCYIUVDBYHYOLMWHWIWJWKWLUVCUVLUVEUTUVM
      UVHUTUVCUVIUVEUVKUVCYMUVDSZUVIUVEUTUVCYMLWMWNZSYOWOSUVBUVPUVCYMVAUVQUVCYG
      VAYMUUPYTUUAUVBWPWQWRWSUVCYOUVCYGVAYOUUPYTUUAUVBWTWQXAYTUUAUVBXBYMLYOXCXD
      CUVDBYMUVICHOUVIBUVIBUDHCDHCNZABDUVRWBFGXEXFXGXHXIXJUVLUVEUVGXKXIXLUVEUVF
      XMYQUVHXNXOXSXPXQXRXTYAYBYCYDDYGYKHIYEYF $.
  $}

  ${
    $d a b k n x y $.  $d a b k m x y A $.  $d a b m x y B $.  $d k n M $.
    $d k n x N $.
    iundisjcnt.0 $e |- F/_ n B $.
    iundisjcnt.1 $e |- ( n = k -> A = B ) $.
    iundisjcnt.2 $e |- ( ph -> ( N = NN \/ N = ( 1 ..^ M ) ) ) $.
    $( Rewrite a countable union as a disjoint union.  (Contributed by Thierry
       Arnoux, 16-Feb-2017.) $)
    iundisjcnt $p |- ( ph -> U_ n e. N A =
      U_ n e. N ( A \ U_ k e. ( 1 ..^ n ) B ) ) $=
      ( cn wceq ciun c1 cfzo co wa simpr iuneq1d 3eqtr4a cv cdif nfcv iundisjfi
      iundisjf mpjaodan ) AGKLZEGBMZEGBDNEUAOPCMUBZMZLGNFOPZLZAUGQZEKBMEKUIMUHU
      JBCDEDBUCHIUEUMEGKBAUGRZSUMEGKUIUNSTAULQZEUKBMEUKUIMUHUJBCDEFHIUDUOEGUKBA
      ULRZSUOEGUKUIUPSTJUF $.
  $}

  ${
    $d k n M $.  $d k A $.  $d n N $.
    iundisj2cnt.0 $e |- F/_ n B $.
    iundisj2cnt.1 $e |- ( n = k -> A = B ) $.
    iundisj2cnt.2 $e |- ( ph -> ( N = NN \/ N = ( 1 ..^ M ) ) ) $.
    $( A countable disjoint union is disjoint.  Cf. ~ iundisj2 (Contributed by
       Thierry Arnoux, 16-Feb-2017.) $)
    iundisj2cnt $p |- ( ph -> Disj_ n e. N ( A \ U_ k e. ( 1 ..^ n ) B ) ) $=
      ( cn wceq c1 cfzo co wo cv wdisj disjeq1 mpbiri ciun cdif nfcv iundisj2fi
      iundisj2f jaoi syl ) AGKLZGMFNOZLZPEGBDMEQNOCUAUBZRZJUHULUJUHULEKUKRBCDED
      BUCHIUEEGKUKSTUJULEUIUKRBCDEFHIUDEGUIUKSTUFUG $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
               The ` # ` (finite set size) function - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Restriction of the domain of the size function.  (Contributed by Thierry
     Arnoux, 31-Jan-2017.) $)
  hashresfn $p |- ( # |` A ) Fn A $=
    ( chash cvv cin cres wfn cn0 cpnf csn cun hashf ffn fnresin2 mp2b wceq inv1
    wf wb reseq2i fneq12 mp2an mpbi ) BACDZEZUCFZBAEZAFZCGHIJZBQBCFUEKCUHBLCABM
    NUDUFOUCAOUEUGRUCABAPZSUIUCAUDUFTUAUB $.

  $( Restriction of the domain of the size function.  (Contributed by Thierry
     Arnoux, 12-Jan-2017.) $)
  dmhashres $p |- dom ( # |` A ) = A $=
    ( chash cres cdm cin cvv dmres cn0 cpnf csn hashf fdmi ineq2i inv1 3eqtri
    cun ) BACDABDZEAFEABAGQFAFHIJPBKLMANO $.

  ${
    $d x y A $.  $d y ph $.
    hashiunf.1 $e |- F/ x ph $.
    hashiunf.3 $e |- ( ph -> A e. Fin ) $.
    hashunif.4 $e |- ( ph -> A C_ Fin ) $.
    hashunif.5 $e |- ( ph -> Disj_ x e. A x ) $.
    $( The cardinality of a disjoint finite union of finite sets.  Cf.
       ~ hashuni (Contributed by Thierry Arnoux, 17-Feb-2017.) $)
    hashunif $p |- ( ph -> ( # ` U. A ) = sum_ x e. A ( # ` x ) ) $=
      ( vy cuni chash cfv cv ciun csu uniiun fveq2i cfn wdisj wceq a1i cbvdisjv
      sselda id sylib hashiun cbviunv fveq2d fveq2 cbvsumv 3eqtr4d syl5eq ) ACI
      ZJKBCBLZMZJKZCUMJKZBNZULUNJBCOPAHCHLZMZJKCURJKZHNZUOUQAHCUREACQURFUBABCUM
      RHCURRGBHCUMURUMURSUCZUAUDUEAUNUSJUNUSSABHCUMURVBUFTUGUQVASACUPUTBHUMURJU
      HUITUJUK $.
  $}

  ${
    $d a n x A $.  $d i n $.
    $( Any set that is not finite contains subsets of arbitrarily large finite
       cardinality.  Cf. ~ isinf (Contributed by Thierry Arnoux,
       5-Jul-2017.) $)
    ishashinf $p |- ( -. A e. Fin -> A. n e. NN E. x e. ~P A ( # ` x ) = n ) $=
      ( va cfn wcel wn cv chash cfv wceq cn wa wex c1 cen wbr com syl eqtrd cpw
      wrex wss cfz co ccrd wral fzfid ficardom isinf breq2 anbi2d exbidv rspcva
      syl2anr wi vex elpw biimpri a1i hasheni adantl hashcard cn0 nnnn0 hashfz1
      ad2antlr ex anim12d eximdv mpd df-rex sylibr ralrimiva ) BEFGZAHZIJZCHZKZ
      ABUAZUBZCLVOVRLFZMZVPVTFZVSMZANZWAWCVPBUCZVPOVRUDUEZUFJZPQZMZANZWFWBWIRFZ
      WGVPDHZPQZMZANZDRUGWLVOWBWHEFZWMWBOVRUHZWHUISABDUJWQWLDWIRWNWIKZWPWKAWTWO
      WJWGWNWIVPPUKULUMUNUOWCWKWEAWCWGWDWJVSWGWDUPWCWDWGVPBAUQURUSUTWCWJVSWCWJM
      VQWIIJZVRWJVQXAKWCVPWIVAVBWBXAVRKVOWJWBXAWHIJZVRWBWRXAXBKWSWHVCSWBVRVDFXB
      VRKVRVEVRVFSTVGTVHVIVJVKVSAVTVLVMVN $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                      The greatest common divisor operator - misc. add
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Numerator and denominator of the negative (Contributed by Thierry Arnoux,
     27-Oct-2017.) $)
  numdenneg $p |- ( Q e. QQ -> ( ( numer ` -u Q ) = -u ( numer ` Q )
    /\ ( denom ` -u Q ) = ( denom ` Q ) ) ) $=
    ( cq wcel cneg cnumer cfv cz cdenom cn cgcd wceq cdiv qnegcl qnumcl znegcld
    co c1 wa qdencl eqtrd neggcd syl2anc qnumdencoprm qeqnumdivden negeqd nncnd
    nnzd zcnd nnne0d divnegd w3a qnumdenbi biimpa syl32anc ) ABCZADZBCZAEFZDZGC
    ZAHFZICZUSVAJPZQKZUPUSVALPZKZUPEFUSKUPHFVAKRZAMUOURANZOASZUOVCURVAJPZQUOURG
    CVAGCVCVJKVHUOVAVIUGURVAUAUBAUCTUOUPURVALPZDVEUOAVKAUDUEUOURVAUOURVHUHUOVAV
    IUFUOVAVIUIUJTUQUTVBUKVDVFRVGUPUSVAULUMUN $.

  $( Calculate the reduced form of a quotient using ` gcd ` .  This version
     extends ~ divnumden for the negative integers.  (Contributed by Thierry
     Arnoux, 25-Oct-2017.) $)
  divnumden2 $p |- ( ( A e. ZZ /\ B e. ZZ /\ -u B e. NN ) ->
       ( ( numer ` ( A / B ) ) = -u ( A / ( A gcd B ) )
      /\ ( denom ` ( A / B ) ) = -u ( B / ( A gcd B ) ) ) ) $=
    ( cz wcel cneg cdiv co cnumer cfv cgcd wceq cdenom cc0 wne zcnd syl 3adant2
    cq wa divneg2d cn zssq simp1 sseldi simp2 nnne0 3ad2ant3 neg0 neeq2i sylibr
    w3a neneqd 0cn a1i neg11ad mtbid neneqad qdivcl syl3anc qnumcl simpl gcdcld
    cc nn0cnd negcld wn intnand gcdeq0 necon3abid 3adant3 mpbird negne0d divcld
    wb fveq2d numdenneg simpld gcdneg oveq2d divnumden divnegd div2negd 3eqtr4d
    eqtrd 3eqtr3d neg11d eqtr4d simprd eqtr3d jca ) ACDZBCDZBEZUADZUKZABFGZHIZA
    ABJGZFGZEZKWPLIZBWRFGEZKWOWQAWREZFGZWTWOWQXDWOWQWOWPRDZWQCDWOARDBRDBMNXEWOC
    RAUBWKWLWNUCZUDWOCRBUBWKWLWNUEZUDWOBMWOWMMEZKBMKZWOWMXHWOWMMNZWMXHNWNWKXJWL
    WMUFUGXHMWMUHUIUJULWOBMWOBXGOZMVCDWOUMUNUOUPZUQZABURUSZWPUTPOWOAXCWKWNAVCDW
    LWKWNSZAWKWNVAOQZWOWRWOWRWOABXFXGVBVDZVEZWOWRXQWOWRMNZAMKZXISZVFZWOXIXTXLVG
    WKWLXSYBVNWNWKWLSYAWRMABVHVIVJVKZVLZVMWOWPEZHIZAWMFGZHIZWQEZXDEZWOYEYGHWOAB
    XPXKXMTZVOWOXEYFYIKZXNXEYLYELIZXAKZWPVPZVQPWOAAWMJGZFGZWSYHYJWOYPWRAFWKWLYP
    WRKWNABVRVJZVSWKWNYHYQKZWLXOYSYGLIZWMYPFGZKZAWMVTZVQQWOYJAEXCFGWSWOAXCXPXRY
    DWAWOAWRXPXQYCWBWDWCWEWFWOAWRXPXQYCTWGWOXABXCFGZXBWOYMYTXAUUDWOYEYGLYKVOWOX
    EYNXNXEYLYNYOWHPWOUUAWMWRFGZYTUUDWOYPWRWMFYRVSWKWNUUBWLXOYSUUBUUCWHQWOXBUUD
    UUEWOBWRXKXQYCTZWOBWRXKXQYCWAWIWCWEUUFWGWJ $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
          Integers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x y ph $.  $d y ps $.  $d x ch $.  $d x et $.  $d x th $.
    $d x ta $.
    nn0indd.1 $e |- ( x = 0 -> ( ps <-> ch ) ) $.
    nn0indd.2 $e |- ( x = y -> ( ps <-> th ) ) $.
    nn0indd.3 $e |- ( x = ( y + 1 ) -> ( ps <-> ta ) ) $.
    nn0indd.4 $e |- ( x = A -> ( ps <-> et ) ) $.
    nn0indd.5 $e |- ( ph -> ch ) $.
    nn0indd.6 $e |- ( ( ( ph /\ y e. NN0 ) /\ th ) -> ta ) $.
    $( Principle of Mathematical Induction (inference schema) on nonnegative
       integers, a deduction version.  (Contributed by Thierry Arnoux,
       23-Mar-2018.) $)
    nn0indd $p |- ( ( ph /\ A e. NN0 ) -> et ) $=
      ( cn0 wcel wi wceq imbi2d cv cc0 c1 caddc co wa ancoms a2d nn0ind impcom
      ex ) IPQAFABRACRADRAERAFRGHIGUAZUBSBCAJTULHUAZSBDAKTULUMUCUDUESBEALTULISB
      FAMTNUMPQZADEUNADERZAUNUOAUNUFDEOUKUGUKUHUIUJ $.
  $}

  ${
    $d n w x y z $.  $d x A $.  $d w z ph $.  $d x ch $.  $d x ps $.
    $d x ta $.  $d x th $.
    nnindf.x $e |- F/ y ph $.
    $( Substitutions. $)
    nnindf.1 $e |- ( x = 1 -> ( ph <-> ps ) ) $.
    nnindf.2 $e |- ( x = y -> ( ph <-> ch ) ) $.
    nnindf.3 $e |- ( x = ( y + 1 ) -> ( ph <-> th ) ) $.
    nnindf.4 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Basis. $)
    nnindf.5 $e |- ps $.
    $( Induction hypothesis. $)
    nnindf.6 $e |- ( y e. NN -> ( ch -> th ) ) $.
    $( Principle of Mathematical Induction, using a bound-variable hypothesis
       instead of distinct variables.  (Contributed by Thierry Arnoux,
       6-May-2018.) $)
    nnindf $p |- ( A e. NN -> ta ) $=
      ( vw cn wcel c1 elrab crab wa caddc wral wss 1nn mpbir2an elrabi peano2nn
      cv a1d anim12d 3imtr4g mpcom rgen nfcv nfrab nfv nfel wceq eleq1d cbvralf
      co oveq1 mpbi peano5nni mp2an sseli sylib simprd ) HQRZVKEVKHAFQUAZRVKEUB
      QVLHSVLRZPUJZSUCVCZVLRZPVLUDZQVLUEVMSQRBUFNABFSQJTUGGUJZSUCVCZVLRZGVLUDVQ
      VTGVLVRQRZVRVLRZVTAFVRQUHWAWACUBVSQRZDUBWBVTWAWAWCCDWAWCWAVRUIUKOULACFVRQ
      KTADFVSQLTUMUNUOVTVPGPVLAGFQIGQUPUQZPVLUPVTPURGVOVLGVOUPWDUSVRVNUTVSVOVLV
      RVNSUCVDVAVBVEPVLVFVGVHAEFHQMTVIVJ $.
  $}

  ${
    $d k m n ph $.  $d k m ps $.  $d k n ta $.  $d k n th $.  $d m n ch $.
    nn0min.0 $e |- ( n = 0 -> ( ps <-> ch ) ) $.
    nn0min.1 $e |- ( n = m -> ( ps <-> th ) ) $.
    nn0min.2 $e |- ( n = ( m + 1 ) -> ( ps <-> ta ) ) $.
    nn0min.3 $e |- ( ph -> -. ch ) $.
    nn0min.4 $e |- ( ph -> E. n e. NN ps ) $.
    $( Extracting the minimum positive integer for which a property ` ch ` does
       not hold.  This uses substitutions similar to ~ nn0ind .  (Contributed
       by Thierry Arnoux, 6-May-2018.) $)
    nn0min $p |- ( ph -> E. m e. NN0 ( -. th /\ ta ) ) $=
      ( vk wn cn0 wi cn c1 nfv wceq wa wral wrex adantr wsbc cv nfra1 nfan nfim
      wsb dfsbcq2 notbid imbi2d sbhypf caddc co sbequ12r wcel 0nn0 sbie syl5bbr
      cc0 wb oveq1 0p1e1 syl6eq 1nn eleq1 mpbiri sbcieg 3syl dfsbcq syl imbi12d
      bitr3d rspcv ax-mp mpan9 nfs1 sbequ12 cbvral nnnn0 rspc syl5bi a2d nnindf
      adantld rgen mpbi ralnex sylib pm2.65da imnan ralbii notbii dfrex2 sylibr
      r19.21v ) ADNZEUAZNZFOUBZNZWTFOUCAWSENZPZFOUBZNXCAXFBGQUCZAXGXFLUDAXFUAZB
      NZGQUBZXGNXHXIPZGQUBXHXJPXKGQXHBGMUJZNZPXHBGRUEZNZPXHWSPXHXDPXKMFGUFZXHXM
      FAXFFAFSXEFOUGUHXMFSUIMUFZRTZXMXOXHXRXLXNBGMRUKULUMXQFUFZTZXMWSXHXTXLDBDG
      MXSDGSZIUNULUMXQXSRUOUPZTZXMXDXHYCXLEBEGMYBEGSJUNULUMXQXPTZXMXIXHYDXLBBMG
      UQULUMACNZXFXOKVBOURXFYEXOPZPUSXEYFFVBOXSVBTZWSYEXDXOYGDCDBGFUJYGCBDGFYAI
      UTBCGFVBCGSHUNVAULYGEXNYGBGYBUEZEXNYGYBRTZYBQURZYHEVCYGYBVBRUOUPRXSVBRUOV
      DVEVFZYIYJRQURVGYBRQVHVIBEGYBQJVJVKYGYIYHXNVCYKBGYBRVLVMVOULVNVPVQVRXSQUR
      ZXHWSXDYLXFXEAXFXEFMUJZMOUBZYLXEXEYMFMOXEMSZXEFMYOVSXEFMVTWAYLXSOURYNXEPX
      SWBYMXEMXSOYOXEMFUQWCVMWDWGWEWFWHXHXIGQWRWIBGQWJWKWLXFXBXEXAFOWSEWMWNWOWK
      WTFOWPWQ $.
  $}

  ${
    ltesubnnd.1 $e |- ( ph -> M e. ZZ ) $.
    ltesubnnd.2 $e |- ( ph -> N e. NN ) $.
    $( Subtracting an integer number from another number decreases it.  See
       ~ ltsubrpd (Contributed by Thierry Arnoux, 18-Apr-2017.) $)
    ltesubnnd $p |- ( ph -> ( ( M + 1 ) - N ) <_ M ) $=
      ( c1 caddc co cmin cle zcnd cc wcel ax-1cn a1i nncnd addsubd clt wbr cz
      zred nnrpd ltsubrpd wb nnzd zsubcld zltp1le syl2anc mpbid eqbrtrd ) ABFGH
      CIHBCIHZFGHZBJABFCABDKFLMANOACEPQAUKBRSZULBJSZABCABDUAACEUBUCAUKTMBTMUMUN
      UDABCDACEUEUFDUKBUGUHUIUJ $.
  $}
$( End $[ set-mbox-ta-basics.mm $] $)
$( Begin $[ set-mbox-ta-xdiv.mm $] $)
$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Division in the extended real number system
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c /e $. $( Division of extended real numbers. $)

  $( Extend class notation to include division of extended reals. $)
  cxdiv $a class /e $.

  ${
    $d x y z $.
    $( Define division over extended real numbers.  (Contributed by Thierry
       Arnoux, 17-Dec-2016.) $)
    df-xdiv $a |- /e = ( x e. RR* , y e. ( RR \ { 0 } ) |->
                   ( iota_ z e. RR* ( y *e z ) = x ) ) $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y C $.
    $( Value of division: the (unique) element ` x ` such that
       ` ( B x. x ) = A ` .  This is meaningful only when ` B ` is nonzero.
       (Contributed by Thierry Arnoux, 17-Dec-2016.) $)
    xdivval $p |- ( ( A e. RR* /\ B e. RR /\ B =/= 0 ) ->
                   ( A /e B ) = ( iota_ x e. RR* ( B *e x ) = A ) ) $=
      ( vy vz cxr wcel cr cc0 wne cxdiv co cv cxmu wceq wa csn simpl riotabidva
      crio eldifsn eqeq2d oveq1d eqeq1d df-xdiv riotaex ovmpt2 sylan2br 3impb
      cdif ) BFGZCHGZCIJZBCKLCAMZNLZBOZAFTZOZULUMPUKCHIQUJZGURCHIUADEBCFUSEMZUN
      NLZDMZOZAFTUQKVABOZAFTVBBOZVCVDAFVEUNFGZPVBBVAVEVFRUBSUTCOZVDUPAFVGVFPZVA
      UOBVHUTCUNNVGVFRUCUDSDEAUEUPAFUFUGUHUI $.
  $}

  ${
    $d x y A $.  $d x y z $.
    $( Existence of reciprocal of nonzero real number.  (Contributed by Thierry
       Arnoux, 17-Dec-2016.) $)
    xrecex $p |- ( ( A e. RR /\ A =/= 0 ) -> E. x e. RR ( A *e x ) = 1 ) $=
      ( cr wcel cc0 wne wa cv cxmu co c1 wceq wrex cmul ax-rrecex rexmul eqeq1d
      wb wi ex adantr pm5.32d rexbidv2 mpbird ) BCDZBEFZGZBAHZIJZKLZACMBUHNJZKL
      ZACMABOUGUJULACCUGUHCDZUJULUEUMUJULRZSUFUEUMUNUEUMGUIUKKBUHPQTUAUBUCUD $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.
    xmulcand.1 $e |- ( ph -> A e. RR* ) $.
    xmulcand.2 $e |- ( ph -> B e. RR* ) $.
    xmulcand.3 $e |- ( ph -> C e. RR ) $.
    xmulcand.4 $e |- ( ph -> C =/= 0 ) $.
    $( Cancellation law for extended multiplication.  (Contributed by Thierry
       Arnoux, 17-Dec-2016.) $)
    xmulcand $p |- ( ph -> ( ( C *e A ) = ( C *e B ) <-> A = B ) ) $=
      ( vx cxmu co wceq c1 cr wcel syl2anc wa oveq2 cxr adantr cv wi cc0 xrecex
      wne wrex simprl rexrd xmulcom simprr eqtrd oveq1d xmulass syl3anc xmulid2
      syl 3eqtr3d eqeq12d syl5ib rexlimddv impbid1 ) ADBJKZDCJKZLZBCLZADIUAZJKZ
      MLZVDVEUBINADNOZDUCUEVHINUFGHIDUDPVDVFVBJKZVFVCJKZLAVFNOZVHQZQZVEVBVCVFJR
      VNVJBVKCVNVFDJKZBJKZMBJKZVJBVNVOMBJVNVOVGMVNVFSOZDSOZVOVGLVNVFAVLVHUGUHZV
      NDAVIVMGTUHZVFDUIPAVLVHUJUKZULVNVRVSBSOZVPVJLVTWAAWCVMETZVFDBUMUNVNWCVQBL
      WDBUOUPUQVNVOCJKZMCJKZVKCVNVOMCJWBULVNVRVSCSOZWEVKLVTWAAWGVMFTZVFDCUMUNVN
      WGWFCLWHCUOUPUQURUSUTBCDJRVA $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Existential uniqueness of reciprocals.  Theorem I.8 of [Apostol] p. 18.
       (Contributed by Thierry Arnoux, 17-Dec-2016.) $)
    xreceu $p |- ( ( A e. RR* /\ B e. RR /\ B =/= 0 ) ->
                  E! x e. RR* ( B *e x ) = A ) $=
      ( vy cxr wcel cr w3a cv cxmu co wceq wrex wa wi wral 3adant1 oveq2 eqeq1d
      c1 cc0 wne wreu ressxr xrecex ssrexv mpsyl simprl simpll xmulcld ad2antll
      wss oveq1 simplr rexrd xmulass syl3anc xmulid2 syl 3eqtr3d rspcev syl2anc
      rexlimdvaa 3adant3 eqtr3 simp1 simp2 simp3l simp3r xmulcand syl5ib expcom
      mpd 3expa ralrimivv reu4 sylanbrc ) BEFZCGFZCUAUBZHZCAIZJKZBLZAEMZWDCDIZJ
      KZBLZNZWBWFLZOZDEPAEPWDAEUCWAWGTLZDEMZWEGEULWAWLDGMZWMUDVSVTWNVRDCUEQWLDG
      EUFUGVRVSWMWEOVTVRVSNZWLWEDEWOWFEFZWLNZNZWFBJKZEFCWSJKZBLZWEWRWFBWOWPWLUH
      ZVRVSWQUIZUJWRWGBJKZTBJKZWTBWLXDXELWOWPWGTBJUMUKWRCEFWPVRXDWTLWRCVRVSWQUN
      UOXBXCCWFBUPUQWRVRXEBLXCBURUSUTWDXAAWSEWBWSLWCWTBWBWSCJRSVAVBVCVDVMWAWKAD
      EEVSVTWBEFZWPNZWKOVRXGVSVTNZWKXFWPXHWKWIWCWGLXFWPXHHZWJWCWGBVEXIWBWFCXFWP
      XHVFXFWPXHVGXFWPVSVTVHXFWPVSVTVIVJVKVNVLQVOWDWHADEWJWCWGBWBWFCJRSVPVQ $.
  $}

  ${
    $d x A $.  $d x B $.
    xdivcld.1 $e |- ( ph -> A e. RR* ) $.
    xdivcld.2 $e |- ( ph -> B e. RR ) $.
    xdivcld.3 $e |- ( ph -> B =/= 0 ) $.
    $( Closure law for the extended division.  (Contributed by Thierry Arnoux,
       15-Mar-2017.) $)
    xdivcld $p |- ( ph -> ( A /e B ) e. RR* ) $=
      ( vx cxdiv co cv cxmu wceq cxr crio wcel cr cc0 wne xdivval syl3anc wreu
      xreceu riotacl syl eqeltrd ) ABCHIZCGJKIBLZGMNZMABMOZCPOZCQRZUFUHLDEFGBCS
      TAUGGMUAZUHMOAUIUJUKULDEFGBCUBTUGGMUCUDUE $.
  $}

  ${
    $( Closure law for the extended division.  (Contributed by Thierry Arnoux,
       15-Mar-2017.) $)
    xdivcl $p |- ( ( A e. RR* /\ B e. RR /\ B =/= 0 ) -> ( A /e B ) e. RR* ) $=
      ( cxr wcel cr cc0 wne w3a simp1 simp2 simp3 xdivcld ) ACDZBEDZBFGZHABMNOI
      MNOJMNOKL $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Relationship between division and multiplication.  (Contributed by
       Thierry Arnoux, 24-Dec-2016.) $)
    xdivmul $p |- ( ( A e. RR* /\ B e. RR* /\ ( C e. RR /\ C =/= 0 ) )
                 -> ( ( A /e C ) = B <-> ( C *e B ) = A ) ) $=
      ( vx cxr wcel cr cc0 wne wa w3a cxdiv co wceq cv cxmu crio 3adant2 eqeq1d
      3expb xdivval wreu wb simp2 xreceu oveq2 riota2 syl2anc bitr4d ) AEFZBEFZ
      CGFZCHIZJZKZACLMZBNCDOZPMZANZDEQZBNZCBPMZANZUOUPUTBUJUNUPUTNZUKUJULUMVDDA
      CUATRSUOUKUSDEUBZVCVAUCUJUKUNUDUJUNVEUKUJULUMVEDACUETRUSVCDEBUQBNURVBAUQB
      CPUFSUGUHUI $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The extended real division operation when both arguments are real.
       (Contributed by Thierry Arnoux, 18-Dec-2016.) $)
    rexdiv $p |- ( ( A e. RR /\ B e. RR /\ B =/= 0 )
                                                 -> ( A /e B ) = ( A / B ) ) $=
      ( vx cr wcel w3a cmul co wceq crio cc wreu recn id syl eqeq1d syl2anc wss
      wi cxr cc0 wne cv cxdiv cdiv redivcl 3anim123i divcan2 oveq2 rspcev receu
      wrex wral wa ax-resscn rgenw riotass2 mpanl12 cxmu xdivval syl3an1 ressxr
      rexr a1i rexmul biimprd ralrimiva 3ad2ant2 xreceu syl22anc eqtr4d 3eqtr4d
      divval ) ADEZBDEZBUAUBZFZBCUCZGHZAIZCDJZVTCKJZABUDHZABUEHZVQVTCDULZVTCKLZ
      WAWBIZVQWDDEBWDGHZAIZWEABUFVQAKEZBKEZVPFZWIVNWJVOWKVPVPAMBMVPNUGZABUHOVTW
      ICWDDVRWDIVSWHAVRWDBGUIPUJQZVQWLWFWMCABUKODKRVTVTSZCDUMWEWFUNWGUOWOCDVTNU
      PVTVTCDKUQURQVQWCBVRUSHZAIZCTJZWAVNATEZVOVPWCWRIAVCZCABUTVAVQDTRZVTWQSZCD
      UMZWEWQCTLZWAWRIXAVQVBVDVOVNXCVPVOXBCDVOVRDEUNZWQVTXEWPVSABVRVEPVFVGVHWNV
      NWSVOVPXDWTCABVIVAVTWQCDTUQVJVKVQWLWDWBIWMCABVMOVL $.
  $}

  $( Relationship between division and reciprocal.  (Contributed by Thierry
     Arnoux, 5-Jul-2017.) $)
  xdivrec $p |- ( ( A e. RR* /\ B e. RR /\ B =/= 0 ) ->
                                          ( A /e B ) = ( A *e ( 1 /e B ) ) ) $=
    ( cxr wcel cr cc0 wne w3a cxdiv co c1 cxmu simp2 xmulcom syl2anc wb xdivmul
    wceq syl112anc eqtrd rexrd simp1 1re rexri a1i xdivcld xmulcld xmulass eqid
    simp3 syl3anc mpbii oveq2d 3eqtrd xmulid1 syl mpbird ) ACDZBEDZBFGZHZABIJAK
    BIJZLJZRZBVCLJZARZVAVEAKLJZAVAVEVCBLJZAVBBLJZLJZVGVABCDZVCCDZVEVHRVABURUSUT
    MZUAZVAAVBURUSUTUBZVAKBKCDZVAKUCUDUEZVMURUSUTUJZUFZUGZBVCNOVAURVBCDZVKVHVJR
    VOVSVNAVBBUHUKVAVIKALVAVIBVBLJZKVAWAVKVIWBRVSVNVBBNOVAVBVBRZWBKRZVBUIVAVPWA
    USUTWCWDPVQVSVMVRKVBBQSULTUMUNVAURVGARVOAUOUPTVAURVLUSUTVDVFPVOVTVMVRAVCBQS
    UQ $.

  $( A number divided by itself is one.  (Contributed by Thierry Arnoux,
     18-Dec-2016.) $)
  xdivid $p |- ( ( A e. RR /\ A =/= 0 ) -> ( A /e A ) = 1 ) $=
    ( cr wcel cc0 wne wa cxdiv co cdiv c1 wceq rexdiv 3anidm12 recn divid sylan
    cc eqtrd ) ABCZADEZFAAGHZAAIHZJSTUAUBKAALMSAQCTUBJKANAOPR $.

  $( Division into zero is zero.  (Contributed by Thierry Arnoux,
     18-Dec-2016.) $)
  xdiv0 $p |- ( ( A e. RR /\ A =/= 0 ) -> ( 0 /e A ) = 0 ) $=
    ( cr wcel cc0 wne wa cxdiv co cdiv wceq rexdiv mp3an1 recn div0 sylan eqtrd
    0re cc ) ABCZADEZFDAGHZDAIHZDDBCSTUAUBJQDAKLSARCTUBDJAMANOP $.

  $( Division into zero is zero.  (Contributed by Thierry Arnoux,
     18-Dec-2016.) $)
  xdiv0rp $p |- ( A e. RR+ -> ( 0 /e A ) = 0 ) $=
    ( crp wcel cr cc0 wne wa cxdiv co wceq rprene0 xdiv0 syl ) ABCADCAEFGEAHIEJ
    AKALM $.

  $( A positive real number divided by plus infinity is zero.
  The definition of /e needs to be extended to prove such a theorem.
  xdivrppnf @p |- ( A e. RR+ -> ( A /e +oo ) = 0 ) @=
    ? $)

  $( Membership in a closed interval of extended reals vs. the same open
     interval (Contributed by Thierry Arnoux, 18-Dec-2016.) $)
  eliccioo $p |- ( ( A e. RR* /\ B e. RR* /\ A <_ B ) ->
    ( C e. ( A [,] B ) <-> ( C = A \/ C e. ( A (,) B ) \/ C = B ) ) ) $=
    ( cxr wcel cle wbr w3a cicc co wceq w3o wa wo wb adantl adantr eleq1 mpbird
    cioo cpr cun prunioo eleq2d biimpar elun elprg orbi2d syl5bb 3orass 3orcoma
    mpbid bitr3i sylib lbicc2 ioossicc sseli ubicc2 3jaodan impbida ) ADEBDEABF
    GHZCABIJZEZCAKZCABTJZEZCBKZLZVAVCMZVFVDVGNZNZVHVICVEABUAZUBZEZVKVAVNVCVAVMV
    BCABUCUDUEVCVNVKOVAVNVFCVLEZNVCVKCVEVLUFVCVOVJVFCABVBUGUHUIPULVKVFVDVGLVHVF
    VDVGUJVFVDVGUKUMUNVAVDVCVFVGVAVDMVCAVBEZVAVPVDABUOQVDVCVPOVACAVBRPSVFVCVAVE
    VBCABUPUQPVAVGMVCBVBEZVAVQVGABURQVGVCVQOVACBVBRPSUSUT $.

  $( Elementhood in the set of nonnegative extended reals.  (Contributed by
     Thierry Arnoux, 18-Dec-2016.) $)
  elxrge02 $p |- ( A e. ( 0 [,] +oo ) <-> ( A = 0 \/ A e. RR+ \/ A = +oo ) ) $=
    ( cc0 cpnf cicc co wcel wceq cioo w3o crp cxr cle wbr 0xr pnfxr pnfge ax-mp
    wb eliccioo biid mp3an ioorp eleq2i 3orbi123i bitri ) ABCDEFZABGZABCHEZFZAC
    GZIZUGAJFZUJIBKFZCKFBCLMZUFUKRNOUMUNNBPQBCASUAUGUGUIULUJUJUGTUHJAUBUCUJTUDU
    E $.

  ${
    $d x A $.
    $( Plus infinity divided by a positive real number is plus infinity.
       (Contributed by Thierry Arnoux, 18-Dec-2016.) $)
    xdivpnfrp $p |- ( A e. RR+ -> ( +oo /e A ) = +oo ) $=
      ( vx crp wcel cpnf cxdiv co cv cxmu wceq cxr crio cc0 wa pnfxr syl cle wb
      wbr xgepnf wne w3a rprene0 jctil 3anass sylibr xdivval a1i xlemul2 mp3an1
      ancoms clt rpxr rpgt0 xmulpnf1 syl2anc adantr breq1d bitr2d xmulcl adantl
      cr sylan 3bitr3d riota5 eqtrd ) ACDZEAFGZABHZIGZEJZBKLZEVGEKDZAVBDZAMUAZU
      BZVHVLJVGVMVNVONZNVPVGVQVMAUCOUDVMVNVOUEUFBEAUGPVGVKBKEVMVGOUHVGVIKDZNZEV
      JQSZEVIQSZVKVIEJZVSWAAEIGZVJQSZVTVRVGWAWDRZVMVRVGWEOEVIAUIUJUKVSWCEVJQVGW
      CEJZVRVGAKDZMAULSWFAUMZAUNAUOUPUQURUSVSVJKDZVTVKRVGWGVRWIWHAVIUTVCVJTPVRW
      AWBRVGVITVAVDVEVF $.
  $}

  ${
    rpxdivcld.1 $e |- ( ph -> A e. RR+ ) $.
    rpxdivcld.2 $e |- ( ph -> B e. RR+ ) $.
    $( Closure law for extended division of positive reals.  (Contributed by
       Thierry Arnoux, 18-Dec-2016.) $)
    rpxdivcld $p |- ( ph -> ( A /e B ) e. RR+ ) $=
      ( cxdiv co cdiv crp cr wcel cc0 wceq rpred rpne0d rexdiv syl3anc rpdivcld
      wne eqeltrd ) ABCFGZBCHGZIABJKCJKCLSUAUBMABDNACENACEOBCPQABCDERT $.
  $}

  ${
    xrpxdivcld.1 $e |- ( ph -> A e. ( 0 [,] +oo ) ) $.
    xrpxdivcld.2 $e |- ( ph -> B e. RR+ ) $.
    $( Closure law for extended division of positive extended reals.
       (Contributed by Thierry Arnoux, 18-Dec-2016.) $)
    xrpxdivcld $p |- ( ph -> ( A /e B ) e. ( 0 [,] +oo ) ) $=
      ( cc0 wceq crp wcel cpnf w3o cxdiv co cicc elxrge02 sylib oveq1 sylan9eqr
      wa syl xdiv0rp biimpri 3o1cs simpr adantr rpxdivcld 3o2cs xdivpnfrp 3o3cs
      3jaodan mpdan ) ABFGZBHIZBJGZKZBCLMZFJNMZIZABUQIUODBOPAULURUMUNAULSUPFGZU
      RULAUPFCLMZFBFCLQACHIZUTFGECUATRUSUPHIZUPJGZURURUSVBVCKUPOUBZUCTAUMSZVBUR
      VEBCAUMUDAVAUMEUEUFUSVBVCURVDUGTAUNSVCURUNAUPJCLMZJBJCLQAVAVFJGECUHTRUSVB
      VCURVDUITUJUK $.
  $}

$(
  @{
    xltmul1d.1 @e |- ( ph -> A e. RR ) $@
    xltmul1d.2 @e |- ( ph -> B e. RR* ) $@
    xltmul1d.3 @e |- ( ph -> C e. ( 0 [,] +oo ) ) $@
    @( 'Less than' relationship between division and multiplication.
       (Contributed by Mario Carneiro, 28-May-2016.) @)
    xltdivmul2d @p |- ( ph -> ( ( A /e C ) < B <-> A < ( B *e C ) ) ) @=
      ? @.
  @}
$)

$( End $[ set-mbox-ta-xdiv.mm $] $)
$( Begin $[ set-mbox-ta-algtop.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Structure builders
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Structure builder restriction operator
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x .0. $.  $d x A $.  $d x B $.  $d x R $.  $d x S $.
    ress0g.s $e |- S = ( R |`s A ) $.
    ress0g.b $e |- B = ( Base ` R ) $.
    ress0g.0 $e |- .0. = ( 0g ` R ) $.
    $( ` 0g ` is unaffected by restriction.  This is a bit more generic than
       ~ submnd0 (Contributed by Thierry Arnoux, 23-Oct-2017.) $)
    ress0g $p |- ( ( R e. Mnd /\ .0. e. A /\ A C_ B ) -> .0. = ( 0g ` S ) ) $=
      ( vx cmnd wcel wss w3a cplusg cfv cbs wceq cvv co syl2anc eqeltri sylancl
      ressbas2 3ad2ant3 simp3 fvex ssexg eqid ressplusg syl simp2 simpl1 sselda
      cv wa mndlid mndrid grpidd ) CJKZEAKZABLZMZIACNOZDEVAUSADPOQUTABDCFGUCUDV
      BARKZVCDNOQVBVABRKVDUSUTVAUEZBCPORGCPUFUAABRUGUBAVCCDRFVCUHZUIUJUSUTVAUKV
      BIUNZAKZUOZUSVGBKZEVGVCSVGQUSUTVAVHULZVBABVGVEUMZBVCCVGEGVFHUPTVIUSVJVGEV
      CSVGQVKVLBVCCVGEGVFHUQTUR $.
  $}

  ${
    $d x y .+^ $.  $d x y A $.  $d x y B $.  $d x y H $.
    ressplusf.1 $e |- B = ( Base ` G ) $.
    ressplusf.2 $e |- H = ( G |`s A ) $.
    ressplusf.3 $e |- .+^ = ( +g ` G ) $.
    ressplusf.4 $e |- .+^ Fn ( B X. B ) $.
    ressplusf.5 $e |- A C_ B $.
    $( The group operation function ` +f ` of a structure's restriction is the
       operation function's restriction to the new base.  (Contributed by
       Thierry Arnoux, 26-Mar-2017.) $)
    ressplusf $p |- ( +f ` H ) = ( .+^ |` ( A X. A ) ) $=
      ( vx vy cv cmpt2 cxp cres cfv wceq cbs cvv co cplusf wss resmpt2 wfn fnov
      mp2an mpbi reseq1i ressbas2 ax-mp cplusg wcel fvex eqeltri eqid ressplusg
      ssexi eqtri plusffval 3eqtr4ri ) KLBBKMLMCUAZNZAAOZPZKLAAVBNZCVDPEUBQZABU
      CZVHVEVFRJJKLBBAAVBUDUGCVCVDCBBOUECVCRIKLBBCUFUHUIKLACVGEVHAESQRJABEDGFUJ
      UKCDULQZEULQZHATUMVIVJRABBDSQTFDSUNUOJURAVIDETGVIUPUQUKUSVGUPUTVA $.
  $}

  ${
    $d x .0. $.  $d x A $.  $d x B $.  $d x G $.  $d x H $.
    ressnm.1 $e |- H = ( G |`s A ) $.
    ressnm.2 $e |- B = ( Base ` G ) $.
    ressnm.3 $e |- .0. = ( 0g ` G ) $.
    ressnm.4 $e |- N = ( norm ` G ) $.
    $( The norm in a restricted structure.  (Contributed by Thierry Arnoux,
       8-Oct-2017.) $)
    ressnm $p |- ( ( G e. Mnd /\ .0. e. A /\ A C_ B )
                   -> ( N |` A ) = ( norm ` H ) ) $=
      ( vx wcel cds cfv cmpt cbs wceq 3ad2ant3 cvv eqid cmnd wss w3a cv co cres
      c0g cnm ressbas2 fvex eqeltri ssex ressds eqidd ress0g oveq123d mpteq12dv
      syl nmfval reseq1i resmpt syl5eq a1i 3eqtr4d ) CUALZFALZABUBZUCZKAKUDZFCM
      NZUEZOZKDPNZVIDUGNZDMNZUEZOZEAUFZDUHNZVHKAVKVMVPVGVEAVMQVFABDCGHUIRVHVIVI
      FVNVJVOVGVEVJVOQZVFVGASLVTABBCPNSHCPUJUKULAVJCDSGVJTZUMURRVHVIUNABCDFGHIU
      OUPUQVGVEVRVLQVFVGVRKBVKOZAUFVLEWBAKVJECBFJHIWAUSUTKBAVKVAVBRVSVQQVHKVOVS
      DVMVNVSTVMTVNTVOTUSVCVD $.
  $}

  ${
    $d x y B $.  $d f x y K $.  $d f x y L $.  $d f x y ph $.
    abvpropd2.1 $e |- ( ph -> ( Base ` K ) = ( Base ` L ) ) $.
    abvpropd2.2 $e |- ( ph -> ( +g ` K ) = ( +g ` L ) ) $.
    abvpropd2.3 $e |- ( ph -> ( .r ` K ) = ( .r ` L ) ) $.
    $( Weaker version of ~ abvpropd .  (Contributed by Thierry Arnoux,
       8-Nov-2017.) $)
    abvpropd2 $p |- ( ph -> ( AbsVal ` K ) = ( AbsVal ` L ) ) $=
      ( vx vy cbs cfv eqidd cv wcel wa cplusg proplem3 cmulr abvpropd ) AGHBIJZ
      BCASKDAGLSMHLSMNZGHBOJCOJEPATGHBQJCQJFPR $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     The opposite group
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    oppglt.1 $e |- O = ( oppG ` R ) $.
    ${
      oppgle.2 $e |- .<_ = ( le ` R ) $.
      $( less-than relation of an opposite group.  (Contributed by Thierry
         Arnoux, 13-Apr-2018.) $)
      oppgle $p |- .<_ = ( le ` O ) $=
        ( cple cfv c10 df-ple 10nn c2 2re 2lt10 gtneii oppglem eqtri ) BAFGCFGE
        AFHCDIJKHLMNOP $.
    $}

    ${
      oppglt.2 $e |- .< = ( lt ` R ) $.
      $( less-than relation of an opposite group.  (Contributed by Thierry
         Arnoux, 13-Apr-2018.) $)
      oppglt $p |- ( R e. V -> .< = ( lt ` O ) ) $=
        ( wcel cple cfv cid cdif cplt eqid pltfval cvv wceq fvex eqeltri oppgle
        coppg ax-mp syl6eqr ) ADGBAHIZJKZCLIZDBAUCUCMZFNCOGUEUDPCATIOEATQROUECU
        CAUCCEUFSUEMNUAUB $.
    $}
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Posets
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y F $.
    $( A Toset is a Poset.  (Contributed by Thierry Arnoux, 20-Jan-2018.) $)
    tospos $p |- ( F e. Toset -> F e. Poset ) $=
      ( vx vy ctos wcel cpo cv cple cfv wbr wo cbs wral eqid istos simplbi ) AD
      EAFEBGZCGZAHIZJRQSJKCALIZMBTMBCTASTNSNOP $.

    $d x y z A $.  $d x y z F $.
    $( The restriction of a Poset is a Poset.  (Contributed by Thierry Arnoux,
       20-Jan-2018.) $)
    resspos $p |- ( ( F e. Poset /\ A e. V ) -> ( F |`s A ) e. Poset ) $=
      ( vx vy vz cpo wcel wa cress cvv cv cple cfv wbr wi wral eqid ssralv breq
      co wceq w3a cbs ovex a1i wss ressbas inss2 syl6eqssr adantl ispos simprbi
      cin adantr ralimdv syld sylc wb ressle anbi12d imbi12d 3anbi123d 2ralbidv
      imbi1d ralbidv syl mpbid sylanbrc ) BGHZACHZIZBAJUAZKHZDLZVOVMMNZOZVOELZV
      POZVRVOVPOZIZVOVRUBZPZVSVRFLZVPOZIZVOWDVPOZPZUCZFVMUDNZQZEWJQDWJQZVMGHVNV
      LBAJUEUFVLVOVOBMNZOZVOVRWMOZVRVOWMOZIZWBPZWOVRWDWMOZIZVOWDWMOZPZUCZFWJQZE
      WJQZDWJQZWLVLWJBUDNZUGZXCFXGQZEXGQZDXGQZXFVKXHVJVKWJAXGUNXGAXGVMCBVMRZXGR
      ZUHAXGUIUJUKVJXKVKVJBKHXKDEFXGBWMXMWMRZULUMUOXHXKXEDXGQXFXHXJXEDXGXHXJXDE
      XGQXEXHXIXDEXGXCFWJXGSUPXDEWJXGSUQUPXEDWJXGSUQURVLWMVPUBZXFWLUSVKXOVJABWM
      CVMXLXNUTUKXOXDWKDEWJWJXOXCWIFWJXOWNVQWRWCXBWHVOVOWMVPTXOWQWAWBXOWOVSWPVT
      VOVRWMVPTZVRVOWMVPTVAVEXOWTWFXAWGXOWOVSWSWEXPVRWDWMVPTVAVOWDWMVPTVBVCVFVD
      VGVHDEFWJVMVPWJRVPRULVI $.

    $d x y V $.
    $( The restriction of a Toset is a Toset.  (Contributed by Thierry Arnoux,
       20-Jan-2018.) $)
    resstos $p |- ( ( F e. Toset /\ A e. V ) -> ( F |`s A ) e. Toset ) $=
      ( vx vy ctos wcel cpo cv cple cfv wbr wo cbs wral eqid adantl istos breqd
      ssralv wa cress co tospos resspos sylan wss cin ressbas syl6eqssr simprbi
      inss2 adantr ralimdv syld sylc wb ressle orbi12d 2ralbidv mpbid sylanbrc
      ) BFGZACGZUAZBAUBUCZHGZDIZEIZVFJKZLZVIVHVJLZMZEVFNKZODVNOZVFFGVCBHGZVDVGB
      UDABCUEUFVEVHVIBJKZLZVIVHVQLZMZEVNOZDVNOZVOVEVNBNKZUGZVTEWCOZDWCOZWBVDWDV
      CVDVNAWCUHWCAWCVFCBVFPZWCPZUIAWCULUJQVCWFVDVCVPWFDEWCBVQWHVQPZRUKUMWDWFWE
      DVNOWBWEDVNWCTWDWEWADVNVTEVNWCTUNUOUPVDWBVOUQVCVDVTVMDEVNVNVDVRVKVSVLVDVQ
      VJVHVIABVQCVFWGWIURZSVDVQVJVIVHWJSUSUTQVADEVNVFVJVNPVJPRVB $.
  $}

  ${
    $d x y B $.  $d x y X $.  $d y Y $.  $d x y .<_ $.
    tleile.b $e |- B = ( Base ` K ) $.
    tleile.l $e |- .<_ = ( le ` K ) $.
    $( In a Toset, two elements must compare.  (Contributed by Thierry Arnoux,
       11-Feb-2018.) $)
    tleile $p |- ( ( K e. Toset /\ X e. B /\ Y e. B )
      -> ( X .<_ Y \/ Y .<_ X ) ) $=
      ( vx vy ctos wcel w3a cv wbr wo wral wceq breq1 breq2 orbi12d simp2 simp3
      cpo istos simprbi 3ad2ant1 wa rspc2v imp syl21anc ) BJKZDAKZEAKZLULUMHMZI
      MZCNZUOUNCNZOZIAPHAPZDECNZEDCNZOZUKULUMUAUKULUMUBUKULUSUMUKBUCKUSHIABCFGU
      DUEUFULUMUGUSVBURVBDUOCNZUODCNZOHIDEAAUNDQUPVCUQVDUNDUOCRUNDUOCSTUOEQVCUT
      VDVAUOEDCSUOEDCRTUHUIUJ $.

    tltnle.s $e |- .< = ( lt ` K ) $.
    $( In a Toset, less-than is equivalent to not inverse less-than-or-equal
       see ~ pltnle .  (Contributed by Thierry Arnoux, 11-Feb-2018.) $)
    tltnle $p |- ( ( K e. Toset /\ X e. B /\ Y e. B )
      -> ( X .< Y <-> -. Y .<_ X ) ) $=
      ( ctos wcel w3a wbr wn wa cpo wb tospos pltval3 syl3an1 wo tleile syl6rbb
      ibar pm5.61 syl bitrd ) CJKZEAKZFAKZLZEFBMZEFDMZFEDMZNZOZUOUHCPKUIUJULUPQ
      CRABCDEFGHISTUKUMUNUAZUPUOQACDEFGHUBUQUOUQUOOUPUQUOUDUMUNUEUCUFUG $.
  $}

  ${
    tlt2.b $e |- B = ( Base ` K ) $.
    tlt2.e $e |- .<_ = ( le ` K ) $.
    tlt2.l $e |- .< = ( lt ` K ) $.
    $( In a Toset, two elements must compare.  (Contributed by Thierry Arnoux,
       13-Apr-2018.) $)
    tlt2 $p |- ( ( K e. Toset /\ X e. B /\ Y e. B )
      -> ( X .<_ Y \/ Y .< X ) ) $=
      ( ctos wcel w3a wbr wo wn exmidd wb tltnle 3com23 orbi2d mpbird ) CJKZEAK
      ZFAKZLZEFDMZFEBMZNUFUFOZNUEUFPUEUGUHUFUBUDUCUGUHQABCDFEGHIRSTUA $.
  $}

  ${
    tlt3.b $e |- B = ( Base ` K ) $.
    tlt3.l $e |- .< = ( lt ` K ) $.
    $( In a Toset, two elements must compare strictly, or be equal.
       (Contributed by Thierry Arnoux, 13-Apr-2018.) $)
    tlt3 $p |- ( ( K e. Toset /\ X e. B /\ Y e. B )
      -> ( X = Y \/ X .< Y \/ Y .< X ) ) $=
      ( ctos wcel w3a wceq wbr wo w3o cple cfv eqid tlt2 cpo wb pleval2 syl3an1
      tospos orcom syl6bb orbi1d mpbid df-3or sylibr ) CHIZDAIZEAIZJZDEKZDEBLZM
      ZEDBLZMZUNUOUQNUMDECOPZLZUQMURABCUSDEFUSQZGRUMUTUPUQUJCSIZUKULUTUPTCUCVBU
      KULJUTUOUNMUPABCUSDEFVAGUAUOUNUDUEUBUFUGUNUOUQUHUI $.
  $}

  ${
    $d a b c d .< $.  $d a b c d A $.  $d a b c d B $.  $d a b c K $.
    $d a b c ph $.
    toslub.b $e |- B = ( Base ` K ) $.
    toslub.l $e |- .< = ( lt ` K ) $.
    toslub.1 $e |- ( ph -> K e. Toset ) $.
    toslub.2 $e |- ( ph -> A C_ B ) $.
    toslub.3 $e |- ( ph -> E. a e. B
       ( A. b e. A -. a .< b /\ A. b e. B ( b .< a -> E. d e. A b .< d ) ) ) $.
    $( In a toset, the lowest upper bound ` lub ` , defined for partial orders
       is the supremum, ` sup ( A , B , .< ) ` , defined for total orders, if
       this supremum exists (these are the set.mm definition: lowest upper
       bound and supremum are normally synonymous) Note that the two
       definitions do not have the same value when there is no such supremum.
       In that case, ` sup ( A , B , .< ) ` will take the value ` (/) ` , but
       ` ( ( lub `` K ) `` A ) ` takes the value ` ( Undef `` B ) ` ,
       therefore, we restrict this theorem only to the case where this supremum
       exists, which is expressed by the last assumption.  (Contributed by
       Thierry Arnoux, 15-Feb-2018.) $)
    toslub $p |- ( ph -> ( ( lub ` K ) ` A ) = sup ( A , B , .< ) ) $=
      ( vc wbr wral wa wcel wn wb club cfv cv cple crio csup ctos wss wceq eqid
      lubval syl2anc wrex ad2antrr simplr adantr sselda tltnle syl3anc ralbidva
      wi con2bid simpll simpr sseldd syl3an1 3expa syl21anc breq2 notbid ralnex
      cbvralv bitri syl6bb adantlr imbi12d con34b syl6bbr breq1 rexbidv anbi12d
      syl riotabidva wor cid cres tosso ibi simpld supval2 eqtr4d eqtrd ) ABEUA
      UBZUBZGUCZFUCZEUDUBZOZGBPZWONUCZWQOZGBPZWPWTWQOZVAZNCPZQZFCUEZBCDUFZAEUGR
      ZBCUHZWNXGUIKLFGNUGCBWMEWQIWQUJZWMUJUKULAXGWPWODOZSZGBPZWOWPDOZWOHUCZDOZH
      BUMZVAZGCPZQZFCUEXHAXFYAFCAWPCRZQZWSXNXEXTYCWRXMGBYCWOBRZQZXLWRYEXIYBWOCR
      ZXLWRSTAXIYBYDKUNAYBYDUOYCBCWOAXJYBLUPUQCDEWQWPWOIXKJURUSVBUTYCXEWTWPDOZW
      TXPDOZHBUMZVAZNCPXTYCXDYJNCYCWTCRZQZXDYISZYGSZVAYJYLXBYMXCYNAYKXBYMTYBAYK
      QZXBWTWODOZSZGBPZYMYOXAYQGBYOYDQZAYKYFXAYQTAYKYDVCZAYKYDUOYSBCWOYSAXJYTLW
      BYOYDVDVEYOYFQYPXAAYKYFYPXASTZAXIYKYFUUAKCDEWQWTWOIXKJURVFVGVBVHUTYRYHSZH
      BPYMYQUUBGHBWOXPUIYPYHWOXPWTDVIVJVLYHHBVKVMVNVOYLYGXCYLXIYKYBYGXCSTAXIYBY
      KKUNYCYKVDAYBYKUOCDEWQWTWPIXKJURUSVBVPYGYIVQVRUTXSYJGNCWOWTUIZXOYGXRYIWOW
      TWPDVSUUCXQYHHBWOWTXPDVSVTVPVLVRWAWCAFGHCBDAXICDWDZKXIUUDWECWFWQUHZXIUUDU
      UEQCDEWQUGIXKJWGWHWIWBMWJWKWL $.
  $}


  ${
    $d a b c d .< $.  $d a b c d A $.  $d a b c d B $.  $d a b c K $.
    $d a b c ph $.
    tosglb.b $e |- B = ( Base ` K ) $.
    tosglb.l $e |- .< = ( lt ` K ) $.
    tosglb.1 $e |- ( ph -> K e. Toset ) $.
    tosglb.2 $e |- ( ph -> A C_ B ) $.
    tosglb.3 $e |- ( ph -> E. a e. B
       ( A. b e. A -. b .< a /\ A. b e. B ( a .< b -> E. d e. A d .< b ) ) ) $.
    $( Same theorem as ~ toslub , for infinimum.  (Contributed by Thierry
       Arnoux, 17-Feb-2018.) $)
    tosglb $p |- ( ph -> ( ( glb ` K ) ` A ) = sup ( A , B , `' .< ) ) $=
      ( wbr wral wa wcel wn wb cvv vc cglb cfv cv cple crio ccnv csup ctos wceq
      wss eqid glbval syl2anc wrex ad2antrr adantr sselda simplr tltnle syl3anc
      wi con2bid ralbidva simpll syl simpr sseldd syl3an1 3com23 3expa syl21anc
      breq1 notbid cbvralv ralnex syl6bb adantlr imbi12d con34b syl6bbr rexbidv
      bitri breq2 anbi12d vex brcnvg mp2an notbii ralbii rexbii imbi12i anbi12i
      riotabidva wor cid cres tosso ibi simpld cnvso sylib sylibr supval2 eqtrd
      eqtr4d ) ABEUBUCZUCZFUDZGUDZEUEUCZNZGBOZUAUDZXJXKNZGBOZXNXIXKNZVBZUACOZPZ
      FCUFZBCDUGZUHZAEUIQZBCUKZXHYAUJKLFGUAUICBXGEXKIXKULZXGULUMUNAYAXIXJYBNZRZ
      GBOZXJXIYBNZXJHUDZYBNZHBUOZVBZGCOZPZFCUFYCAXTYPFCAXICQZPZXTXJXIDNZRZGBOZX
      IXJDNZYKXJDNZHBUOZVBZGCOZPZYPYRXMUUAXSUUFYRXLYTGBYRXJBQZPZYSXLUUIYDXJCQZY
      QYSXLRSAYDYQUUHKUPYRBCXJAYEYQLUQURAYQUUHUSCDEXKXJXIIYFJUTVAVCVDYRXSXIXNDN
      ZYKXNDNZHBUOZVBZUACOUUFYRXRUUNUACYRXNCQZPZXRUUMRZUUKRZVBUUNUUPXPUUQXQUURA
      UUOXPUUQSYQAUUOPZXPXJXNDNZRZGBOZUUQUUSXOUVAGBUUSUUHPZAUUOUUJXOUVASAUUOUUH
      VEZAUUOUUHUSUVCBCXJUVCAYEUVDLVFUUSUUHVGVHUUSUUJPUUTXOAUUOUUJUUTXORSZAUUJU
      UOUVEAYDUUJUUOUVEKCDEXKXJXNIYFJUTVIVJVKVCVLVDUVBUULRZHBOUUQUVAUVFGHBXJYKU
      JUUTUULXJYKXNDVMVNVOUULHBVPWCVQVRUUPUUKXQUUPYDYQUUOUUKXQRSAYDYQUUOKUPAYQU
      UOUSYRUUOVGCDEXKXIXNIYFJUTVAVCVSUUKUUMVTWAVDUUEUUNGUACXJXNUJZUUBUUKUUDUUM
      XJXNXIDWDUVGUUCUULHBXJXNYKDWDWBVSVOWAWEYIUUAYOUUFYHYTGBYGYSXITQZXJTQZYGYS
      SFWFZGWFZXIXJTTDWGWHWIWJYNUUEGCYJUUBYMUUDUVIUVHYJUUBSUVKUVJXJXITTDWGWHYLU
      UCHBUVIYKTQYLUUCSUVKHWFXJYKTTDWGWHWKWLWJWMZWAWNAFGHCBYBAYDCYBWOZKYDCDWOZU
      VMYDUVNWPCWQXKUKZYDUVNUVOPCDEXKUIIYFJWRWSWTCDXAXBVFAUUGFCUOYPFCUOMYPUUGFC
      UVLWKXCXDXFXE $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Complete lattices
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    clatp0cl.b $e |- B = ( Base ` W ) $.
    clatp0cl.0 $e |- .0. = ( 0. ` W ) $.
    $( The poset zero of a complete lattice belongs to its base.  (Contributed
       by Thierry Arnoux, 17-Feb-2018.) $)
    clatp0cl $p |- ( W e. CLat -> .0. e. B ) $=
      ( ccla wcel cglb cfv eqid p0val wss ssid clatglbcl mpan2 eqeltrd ) BFGZCA
      BHIZIZAARBFCDRJZEKQAALSAGAMAARBDTNOP $.
  $}

  ${
    clatp1cl.b $e |- B = ( Base ` W ) $.
    clatp1cl.1 $e |- .1. = ( 1. ` W ) $.
    $( The poset one of a complete lattice belongs to its base.  (Contributed
       by Thierry Arnoux, 17-Feb-2018.) $)
    clatp1cl $p |- ( W e. CLat -> .1. e. B ) $=
      ( ccla wcel club cfv eqid p1val wss ssid clatlubcl mpan2 eqeltrd ) CFGZBA
      CHIZIZAARBCFDRJZEKQAALSAGAMAARCDTNOP $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Extended reals Structure - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Assume the scalar component of the extended real structure is the field of
     the real numbers (this has to be defined in the main body of set.mm)
     (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
  ax-xrssca $a |- ( CCfld |`s RR ) = ( Scalar ` RR*s ) $.

  $( Assume the scalar product of the extended real structure is the extended
     real number multiplication operation (this has to be defined in the main
     body of set.mm) (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
  ax-xrsvsca $a |- *e = ( .s ` RR*s ) $.

  $( The zero of the extended real numbers.  The extended real is not a group,
     as its addition is not associative.  (cf. ~ xaddass and ~ df-xrs ),
     however it has a zero.  (Contributed by Thierry Arnoux, 13-Jun-2017.) $)
  xrs0 $p |- 0 = ( 0g ` RR*s ) $=
    ( cc0 cxrs c0g cfv wceq wtru cxr cxad cbs xrsbas a1i cplusg xrsadd wcel 0xr
    vx cv co xaddid2 adantl xaddid1 grpidd trud ) ABCDEFPGHBAGBIDEFJKHBLDEFMKAG
    NFOKPQZGNZAUDHRUDEFUDSTUEUDAHRUDEFUDUATUBUC $.

  $( The "strictly less than" relation for the extended real structure.
     (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
  xrslt $p |- < = ( lt ` RR*s ) $=
    ( clt cle cid cdif cxrs cplt cfv dflt2 cvv wcel wceq xrsex xrsle eqid ax-mp
    pltfval eqtr4i ) ABCDZEFGZHEIJSRKLISEBMSNPOQ $.

  ${
    $d x B $.
    $( The inversion operation in the extended real numbers.  The extended real
       is not a group, as its addition is not associative.  (cf. ~ xaddass and
       ~ df-xrs ), however it has an inversion operation.  (Contributed by
       Thierry Arnoux, 13-Jun-2017.) $)
    xrsinvgval $p |- ( B e. RR* -> ( ( invg ` RR*s ) ` B ) = -e B ) $=
      ( vx cxr wcel cxrs cminusg cfv cxad cc0 wceq crio cxne xrsbas xrsadd xrs0
      cv co eqid grpinvval xnegcl wb xaddeq0 ancoms riota5 eqtrd ) ACDZAEFGZGBP
      ZAHQIJZBCKALZBCHEUGAIMNOUGRSUFUIBCUJATUHCDUFUIUHUJJUAUHAUBUCUDUE $.
  $}

  ${
    $d n A $.  $d m n x y B $.
    $( The "multiple" function in the extended real numbers structure.
       (Contributed by Thierry Arnoux, 14-Jun-2017.) $)
    xrsmulgzz $p |- ( ( A e. ZZ /\ B e. RR* ) ->
                                        ( A ( .g ` RR*s ) B ) = ( A *e B ) ) $=
      ( cxr wcel cxrs co cxmu wceq c1 oveq1 eqeq12d xrsbas wa cxad simpr oveq1d
      cc0 adantl cr a1i vn vm vx vy cz cmg cv cneg caddc xrs0 eqid mulg0 xmul02
      cfv eqtr4d cn0 cn simpll xrsadd mulgnnp1 syl2anc simpl eqtrd 0p1e1 syl6eq
      xaddid2 mulg1 3eqtr4rd elnn0 sylib mpjaodan adantr cle wbr nn0ssre ressxr
      wo sstri sseldi nn0ge0 ad2antlr 1re rexri 0le1 xadddi2r syl221anc xmulid2
      rexadd syl oveq2d 3eqtr3d 3eqtr4d exp31 cxne xnegeq cminusg mulgnegnn cvv
      ancoms xrsex wss ssid simp2 simp3 xaddcld mulgnnsubcl 3anidm12 xrsinvgval
      w3a nnssre sseli rexneg xmulneg1 eqtr3d zindd impcom ) BCDZAUEDABEUFUNZFZ
      ABGFZHZUAUGZBXRFZYBBGFZHQBXRFZQBGFZHUBUGZBXRFZYGBGFZHZYGUHZBXRFZYKBGFZHZY
      GIUIFZBXRFZYOBGFZHZYAXQUAUBAYBQHYCYEYDYFYBQBXRJYBQBGJKYBYGHYCYHYDYIYBYGBX
      RJYBYGBGJKYBYOHYCYPYDYQYBYOBXRJYBYOBGJKYBYKHYCYLYDYMYBYKBXRJYBYKBGJKYBAHY
      CXSYDXTYBABXRJYBABGJKXQYEQYFCXREBQLUJXRUKZULZBUMUOXQYGUPDZYJYRXQUUAMZYJMZ
      YHBNFZYIBNFZYPYQUUCYHYIBNUUBYJOPUUBYPUUDHZYJUUBYGUQDZUUFYGQHZUUBUUGMUUGXQ
      UUFUUBUUGOXQUUAUUGURCNXREYGBLYSUSUTVAUUBUUHMUUHXQUUFUUBUUHOXQUUAUUHURUUHX
      QMZQBNFZBUUDYPXQUUJBHUUHBVFRUUIYHQBNUUIYHYEQUUIYGQBXRUUHXQVBZPXQYEQHUUHYT
      RVCPUUIYPIBXRFZBUUIYOIBXRUUIYOQIUIFIUUIYGQIUIUUKPVDVEPXQUULBHUUHCXREBLYSV
      GRVCVHVAUUBUUAUUGUUHVQXQUUAOZYGVIVJVKVLUUCYGINFZBGFZYIIBGFZNFZYQUUEUUCYGC
      DZQYGVMVNZICDZQIVMVNZXQUUOUUQHUUCUPCYGUPSCVOVPVRUUBUUAYJUUMVLZVSUUAUUSXQY
      JYGVTWAUUTUUCIWBWCTUVAUUCWDTXQUUAYJURZYGIBWEWFUUCUUNYOBGUUCYGSDZISDZUUNYO
      HUUCUPSYGVOUVBVSUVEUUCWBTYGIWHVAPUUCUUPBYINUUCXQUUPBHUVCBWGWIWJWKWLWMXQUU
      GYJYNXQUUGMZYJMYHWNZYIWNZYLYMYJUVGUVHHUVFYHYIWORUVFYLUVGHYJUVFYLYHEWPUNZU
      NZUVGUUGXQYLUVJHCXREUVIYGBLYSUVIUKWQWSUVFYHCDZUVJUVGHUUGXQUVKUUGXQUVKUUGU
      CUDCNCXREYGWRBLYSUSEWRDUUGWTTCCXAUUGCXBTUUGUCUGZCDZUDUGZCDZXIUVLUVNUUGUVM
      UVOXCUUGUVMUVOXDXEXFXGWSYHXHWIVCVLUVFYMUVHHYJUVFYGWNZBGFZYMUVHUVFUVPYKBGU
      VFUVDUVPYKHUUGUVDXQUQSYGXJXKRYGXLWIPUVFUURXQUVQUVHHUVFUQCYGUQSCXJVPVRXQUU
      GOVSXQUUGVBYGBXMVAXNVLWLWMXOXP $.
  $}

  ${
    $d x y z $.
    $( The extended real numbers form a toset.  (Contributed by Thierry Arnoux,
       15-Feb-2018.) $)
    xrstos $p |- RR*s e. Toset $=
      ( vx vy vz cxrs ctos wcel cpo cv cle wbr wo cxr wral cvv wa rgen2a xrsbas
      wi xrsle mpbir2an wceq w3a xrleid ad2antrr xrletri3 biimprd adantr xrletr
      xrsex 3expa 3jca ralrimiva ispos xrletri istos ) DEFDGFZAHZBHZIJZURUQIJZK
      ZBLMALMUPDNFUQUQIJZUSUTOZUQURUAZRZUSURCHZIJOUQVFIJRZUBZCLMZBLMALMUIVIABLU
      QLFZURLFZOZVHCLVLVFLFZOVBVEVGVJVBVKVMUQUCUDVLVEVMVLVDVCUQURUEUFUGVJVKVMVG
      UQURVFUHUJUKULPABCLDIQSUMTVAABLUQURUNPABLDIQSUOT $.
  $}

  ${
    $d a b c x $.
    $( The extended real numbers form a complete lattice.  (Contributed by
       Thierry Arnoux, 15-Feb-2018.) $)
    xrsclat $p |- RR*s e. CLat $=
      ( vx va vb vc cxrs ccla wcel cpo cxr wss club cfv xrstos clt xrsbas xrslt
      cv csup eqeltrd eqid cglb wa wi wal ctos tospos ax-mp a1i xrsupss supxrcl
      id toslub ccnv xrinfmss tosglb infmxrcl jca ax-gen isclat mpbir2an ) EFGE
      HGZAQZIJZVBEKLZLZIGZVBEUALZLZIGZUBUCZAUDEUEGZVAMEUFUGVJAVCVFVIVCVEVBINRIV
      CVBINEBCDOPVKVCMUHZVCUKZBCDVBUIULVBUJSVCVHVBINUMRIVCVBINEBCDOPVLVMBCDVBUN
      UOVBUPSUQURIVDVGEAOVDTVGTUSUT $.
  $}

  ${
    $d x y z $.
    $( The poset 0 of the extended real numbers is minus infinity.
       (Contributed by Thierry Arnoux, 18-Feb-2018.) $)
    xrsp0 $p |- -oo = ( 0. ` RR*s ) $=
      ( vx vy vz cxrs cp0 cfv cxr cglb clt ccnv csup cmnf cvv wcel xrsex xrsbas
      wceq eqid p0val ax-mp wss ssid xrslt xrstos a1i id xrinfmss tosglb xrinfm
      ctos 3eqtrri ) DEFZGDHFZFZGGIJKZLDMNULUNQOGUMDMULPUMRULRSTGGUAZUNUOQGUBUP
      GGIDABCPUCDUJNUPUDUEUPUFABCGUGUHTUIUK $.

    $( The poset 1 of the extended real numbers is plus infinity.  (Contributed
       by Thierry Arnoux, 18-Feb-2018.) $)
    xrsp1 $p |- +oo = ( 1. ` RR*s ) $=
      ( vx vy vz cxrs cp1 cfv cxr club clt csup cpnf cvv wcel wceq xrsex xrsbas
      eqid p1val ax-mp wss ssid xrslt ctos xrstos a1i id xrsupss toslub 3eqtrri
      xrsup ) DEFZGDHFZFZGGIJZKDLMUKUMNOGULUKDLPULQUKQRSGGTZUMUNNGUAUOGGIDABCPU
      BDUCMUOUDUEUOUFABCGUGUHSUJUI $.
  $}

  ${
    ressmulgnn.1 $e |- H = ( G |`s A ) $.
    ressmulgnn.2 $e |- A C_ ( Base ` G ) $.
    ressmulgnn.3 $e |- .* = ( .g ` G ) $.
    ressmulgnn.4 $e |- I = ( invg ` G ) $.
    $( Values for the group multiple function in a restricted structure
       (Contributed by Thierry Arnoux, 12-Jun-2017.) $)
    ressmulgnn $p |-
                ( ( N e. NN /\ X e. A ) -> ( N ( .g ` H ) X ) = ( N .* X ) ) $=
      ( cn wcel cfv co c1 cbs wceq eqid ax-mp cmg csn cxp cseq wss ressbas2 cvv
      wa cplusg fvex ssexi ressplusg seqeq2 mulgnn simpr sseldi syldan eqtr4d )
      FLMZGAMZUHZFGCUANZOFBUINZLGUBUCZPUDZNZFGEOZACUINZVEVBCFGABQNZUEACQNRIAVIC
      BHVISZUFTVHSVBSVCVHRZVEVHVDPUDRAUGMVKAVIBQUJIUKAVCBCUGHVCSZULTVCVHVDPUMTU
      NUSUTGVIMVGVFRVAAVIGIUSUTUOUPVIVCVEEBFGVJVLJVESUNUQUR $.

    ressmulgnn0.4 $e |- ( 0g ` G ) = ( 0g ` H ) $.
    $( Values for the group multiple function in a restricted structure
       (Contributed by Thierry Arnoux, 14-Jun-2017.) $)
    ressmulgnn0 $p |-
               ( ( N e. NN0 /\ X e. A ) -> ( N ( .g ` H ) X ) = ( N .* X ) ) $=
      ( wcel wa cfv co wceq cc0 simpr eqid cn0 cn cmg simplr ressmulgnn syl2anc
      c0g cbs wss ressbas2 ax-mp mulg0 syl oveq1d sseldi eqtr4d wo elnn0 biimpi
      3eqtr4d adantr mpjaodan ) FUAMZGAMZNZFUBMZFGCUCOZPZFGEPZQZFRQZVEVFNVFVDVJ
      VEVFSVCVDVFUDABCDEFGHIJKUEUFVEVKNZVHRGEPZVIVLRGVGPZBUGOZVHVMVLVDVNVOQVCVD
      VKUDZAVGCGVOABUHOZUIACUHOQIAVQCBHVQTZUJUKLVGTULUMVLFRGVGVEVKSZUNVLGVQMVMV
      OQVLAVQGIVPUOVQEBGVOVRVOTJULUMUTVLFRGEVSUNUPVCVFVKUQZVDVCVTFURUSVAVB $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     The extended non-negative real numbers commutative monoid
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The base of the extended non-negative real numbers.  (Contributed by
     Thierry Arnoux, 30-Jan-2017.) $)
  xrge0base $p |- ( 0 [,] +oo ) = ( Base ` ( RR*s |`s ( 0 [,] +oo ) ) ) $=
    ( cc0 cpnf cicc cxr cin cxrs cress cbs cfv wss wceq iccssxr df-ss mpbi wcel
    co cvv ovex eqid xrsbas ressbas ax-mp eqtr3i ) ABCPZDEZUDFUDGPZHIZUDDJUEUDK
    ABLUDDMNUDQOUEUGKABCRUDDUFQFUFSTUAUBUC $.

  $( The zero of the extended non-negative real numbers monoid.  (Contributed
     by Thierry Arnoux, 30-Jan-2017.) $)
  xrge00 $p |- 0 = ( 0g ` ( RR*s |`s ( 0 [,] +oo ) ) ) $=
    ( cxrs cxr cmnf cdif cress co cmnd wcel cc0 cpnf cicc wss cfv wceq ax-mp wn
    wbr mpbi cin cvv csn c0g eqid xrs1mnd ccmn xrge0cmn cmnmnd cle wa clt mnflt
    cr 0re wb mnfxr 0xr xrltnle mp2an intnan elxrge0 mtbir difsn ssdif eqsstr3i
    iccssxr 0le0 mpbir2an cbs difss df-ss xrex difexg xrsbas ressbas xrs10 ovex
    eqtr3i ressress dfss incom eqtr2i oveq2i submnd0 mp4an ) ABCUAZDZEFZGHAIJKF
    ZEFZGHZWHWFLZIWHHZIWIUBMNWGWGUCZUDWIUEHWJUFWIUGOWHWHWEDZWFCWHHZPWNWHNWOCBHZ
    ICUHQZUIWQWPCIUJQZWQPZIULHWRUMIUKOWPIBHZWRWSUNUOUPCIUQURRUSCUTVACWHVBOWHBLW
    NWFLIJVEWHBWEVCOVDZWLWTIIUHQUPVFIUTVGWFWHWGWIIWFBSZWFWGVHMZWFBLXBWFNBWEVIWF
    BVJRWFTHZXBXCNBTHXDVKBWETVLOZWFBWGTAWMVMVNOVQWGWMVOWGWHEFZAWFWHSZEFZWIXDWHT
    HXFXHNXEIJKVPWFWHATTVRURXGWHAEWHWHWFSZXGWKWHXINXAWHWFVSRWHWFVTWAWBWAWCWD $.

  $( The additive law of the extended non-negative real numbers monoid is the
     addition in the extended real numbers.  (Contributed by Thierry Arnoux,
     20-Mar-2017.) $)
  xrge0plusg $p |- +e = ( +g ` ( RR*s |`s ( 0 [,] +oo ) ) ) $=
    ( cc0 cpnf cicc co cvv wcel cxad cxrs cress cplusg wceq ovex eqid ressplusg
    cfv xrsadd ax-mp ) ABCDZEFGHRIDZJOKABCLRGHSESMPNQ $.

  $( The lower-or-equal relation in the extended real numbers.  (Contributed by
     Thierry Arnoux, 14-Mar-2018.) $)
  xrge0le $p |- <_ = ( le ` ( RR*s |`s ( 0 [,] +oo ) ) ) $=
    ( cc0 cpnf cicc co cvv wcel cle cxrs cress cple wceq ovex eqid xrsle ressle
    cfv ax-mp ) ABCDZEFGHRIDZJPKABCLRHGESSMNOQ $.

  $( The group multiple function in the extended non-negative real numbers.
     (Contributed by Thierry Arnoux, 14-Jun-2017.) $)
  xrge0mulgnn0 $p |- ( ( A e. NN0 /\ B e. ( 0 [,] +oo ) ) ->
                  ( A ( .g ` ( RR*s |`s ( 0 [,] +oo ) ) ) B ) = ( A *e B ) ) $=
    ( cn0 wcel cc0 cpnf cicc co wa cxrs cress cmg cfv cxmu cminusg eqid cxr cbs
    iccssxr c0g xrsbas sseqtri xrs0 xrge00 eqtr3i ressmulgnn0 cz wceq xrsmulgzz
    nn0z sseli syl2an eqtrd ) ACDZBEFGHZDZIABJUOKHZLMHABJLMZHZABNHZUOJUQJOMZURA
    BUQPUOQJRMEFSZUAUBURPVAPEJTMUQTMUCUDUEUFUNAUGDBQDUSUTUHUPAUJUOQBVBUKABUIULU
    M $.

  $( Associativity of extended non-negative real addition.  (Contributed by
     Thierry Arnoux, 8-Jun-2017.) $)
  xrge0addass $p |- ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) /\
    C e. ( 0 [,] +oo ) ) -> ( ( A +e B ) +e C ) = ( A +e ( B +e C ) ) ) $=
    ( cc0 cpnf co wcel cxr cmnf wne cxad sseldi cle wbr wa elicc4 syl3anc mpbid
    wb simpld cicc w3a iccssxr simp1 0xr a1i pnfxr ge0nemnf syl2anc simp2 simp3
    wceq xaddass syl222anc ) ADEUAFZGZBUOGZCUOGZUBZAHGZAIJZBHGZBIJZCHGZCIJZABKF
    CKFABCKFKFULUSUOHADEUCZUPUQURUDZLZUSUTDAMNZVAVHUSVIAEMNZUSUPVIVJOZVGUSDHGZE
    HGZUTUPVKSVLUSUEUFZVMUSUGUFZVHDEAPQRTAUHUIUSUOHBVFUPUQURUJZLZUSVBDBMNZVCVQU
    SVRBEMNZUSUQVRVSOZVPUSVLVMVBUQVTSVNVOVQDEBPQRTBUHUIUSUOHCVFUPUQURUKZLZUSVDD
    CMNZVEWBUSWCCEMNZUSURWCWDOZWAUSVLVMVDURWESVNVOWBDECPQRTCUHUIABCUMUN $.

  $( An extended non-negative real cannot be minus infinity.  (Contributed by
     Thierry Arnoux, 9-Jun-2017.) $)
  xrge0neqmnf $p |- ( A e. ( 0 [,] +oo ) -> A =/= -oo ) $=
    ( cc0 cpnf cicc co wcel cmnf wn wceq cle wbr cxr w3a clt cr 0re mp2an con3i
    wb 0xr mnflt ax-mp mnfxr xrltnle mpbi simp2 pnfxr elicc1 biimpi mp2b nelneq
    mpan2 neneqad ) ABCDEZFZAGUOGUNFZHZAGIHBGJKZHZGLFZURGCJKZMZHUQGBNKZUSBOFVCP
    BUAUBUTBLFZVCUSSUCTGBUDQUEVBURUTURVAUFRUPVBUPVBVDCLFUPVBSTUGBCGUHQUIRUJAGUN
    UKULUM $.

  $( An extended real which is not a real is plus infinity.  (Contributed by
     Thierry Arnoux, 16-Oct-2017.) $)
  xrge0nre $p |- ( ( A e. ( 0 [,] +oo ) /\ -. A e. RR ) -> A = +oo ) $=
    ( cc0 cpnf cicc co wcel cr wceq cxr cmnf wne wo iccssxr xrge0neqmnf xrnemnf
    sseli wa biimpi syl2anc orcanai ) ABCDEZFZAGFZACHZUBAIFZAJKZUCUDLZUAIABCMPA
    NUEUFQUGAORST $.

  $( The sum of nonnegative and positive numbers is positive.  See ~ addgtge0
     (Contributed by Thierry Arnoux, 6-Jul-2017.) $)
  xrge0addgt0 $p |- ( ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) ) /\ 0 < A )
                                                         -> 0 < ( A +e B ) ) $=
    ( cc0 cpnf cicc co wcel wa clt wbr cxad wceq cxr 0xr xaddid1 simplr simplll
    a1i sseldi breq2d ax-mp simpr wi iccssxr simpllr xlt2add syl22anc syl5eqbrr
    mp2and oveq2 adantl syl bitr3d mpbird cle wo iccgelb syl3anc xrleloe biimpa
    pnfxr syl21anc mpjaodan ) ACDEFZGZBVDGZHZCAIJZHZCBIJZCABKFZIJZCBLZVIVJHZCCC
    KFZVKICMGZVOCLNCOUAVNVHVJVOVKIJZVGVHVJPVIVJUBVNVPVPAMGZBMGZVHVJHVQUCVPVNNRZ
    VTVNVDMACDUDZVEVFVHVJQSVNVDMBWAVEVFVHVJUESCCABUFUGUIUHVIVMHZVLVHVGVHVMPWBCA
    CKFZIJVLVHWBWCVKCIVMWCVKLVICBAKUJUKTWBWCACIWBVRWCALWBVDMAWAVEVFVHVMQSAOULTU
    MUNVIVPVSCBUOJZVJVMUPZVPVINRZVIVDMBWAVEVFVHPZSVIVPDMGZVFWDWFWHVIVARWGCDBUQU
    RVPVSHWDWECBUSUTVBVC $.

  $( Non-negative real numbers are real numbers.  (Contributed by Thierry
     Arnoux, 9-Sep-2018.) $)
  rge0ssre $p |- ( 0 [,) +oo ) C_ RR $=
    ( cc0 cpnf cico co cmnf cioo cxr wcel clt wbr cle wss mnfxr pnfxr 0re mnflt
    cr ax-mp pnfge icossioo mp4an ioomax sseqtri ) ABCDZEBFDZQEGHBGHZEAIJZBBKJZ
    UDUELMNAQHUGOAPRUFUHNBSREBABTUAUBUC $.

  $( Distributivity of extended non-negative real multiplication over
     addition.  (Contributed by Thierry Arnoux, 30-Jun-2017.) $)
  xrge0adddir $p |- ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) /\ C e.
    ( 0 [,] +oo ) ) -> ( ( A +e B ) *e C ) = ( ( A *e C ) +e ( B *e C ) ) ) $=
    ( cc0 cpnf co wcel w3a cxad cxmu wceq wa cxr sseldi syl3anc wbr syl2anc syl
    oveq1d 0xr cicc cico simpl1 simpl2 simpr iccssxr simp1 simp2 rge0ssre simp3
    cr xadddir clt simpll1 simpll2 xrge0addgt0 syl21anc xmulpnf1 oveq2 ad2antlr
    xaddcld cmnf wne simpll3 ge0xmulcl xrge0neqmnf xaddpnf2 eqtrd eqtr4d xmul02
    3eqtr4d oveq1 adantl xmulcld xaddid2 3eqtr3d 3eqtr4rd cle a1i pnfxr iccgelb
    wo xrleloe biimpa mpjaodan wb pnfge ax-mp eliccelico mp3an 3anbi3i simp3bi
    ) ADEUAFZGZBWMGZCWMGZHZCDEUBFZGZABIFZCJFZACJFZBCJFZIFZKZCEKZWQWSLZAMGZBMGZC
    UKGZXEXGWNWOWSXHWNWOWPWSUCZWNWOWPWSUDZWQWSUEZWNWOWSHZWMMADEUFZWNWOWSUGNOXGW
    NWOWSXIXKXLXMXNWMMBXOWNWOWSUHNOXGWNWOWSXJXKXLXMXNWRUKCUIWNWOWSUJNOABCULOWQX
    FLZDAUMPZXEDAKZXPXQLZXAEXCIFZXDXSWTEJFZEXAXTXSWTMGDWTUMPZYAEKXSABXSWMMAXOWN
    WOWPXFXQUNZNZXSWMMBXOWNWOWPXFXQUOZNVAXSWNWOXQYBYCYEXPXQUEZABUPUQWTURQXFXAYA
    KWQXQCEWTJUSUTXSXCMGZXCVBVCZXTEKXSWMMXCXOXSWOWPXCWMGZYEWNWOWPXFXQVDBCVEQZNX
    SYIYHYJXCVFRXCVGQVKXSXBEXCIXSXBAEJFZEXFXBYKKWQXQCEAJUSUTXSXHXQYKEKYDYFAURQV
    HSVIXPXRLZDBIFZCJFZDCJFZXCIFZXAXDYLXDXCYPYNYLYPDXCIFZXDXCYLYODXCIYLCMGYODKY
    LWMMCXOWNWOWPXFXRVDNZCVJRSYLYOXBXCIXRYOXBKXPDACJVLVMSZYLYGYQXCKYLBCYLWMMBXO
    WNWOWPXFXRUONZYRVNXCVORVPYSYLYMBCJYLXIYMBKYTBVORSVQXRYNXAKXPXRYMWTCJDABIVLS
    VMYSVPXPDMGZXHDAVRPZXQXRWBZUUAXPTVSZXPWMMAXOWNWOWPXFUCZNXPUUAEMGZWNUUBUUDUU
    FXPVTVSUUEDEAWAOUUAXHLUUBUUCDAWCWDUQWEWQWNWOWSXFWBZWPUUGWNWOUUAUUFDEVRPZWPU
    UGWFTVTUUAUUHTDWGWHDECWIWJWKWLWE $.

  $( Distributivity of extended non-negative real multiplication over
     addition.  (Contributed by Thierry Arnoux, 6-Sep-2018.) $)
  xrge0adddi $p |- ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) /\ C e.
    ( 0 [,] +oo ) ) -> ( C *e ( A +e B ) ) = ( ( C *e A ) +e ( C *e B ) ) ) $=
    ( cc0 cpnf cicc co wcel w3a cxad cxmu xrge0adddir wceq iccssxr simp1 sseldi
    cxr simp2 xmulcom syl2anc xaddcld simp3 oveq12d 3eqtr3d ) ADEFGZHZBUEHZCUEH
    ZIZABJGZCKGZACKGZBCKGZJGCUJKGZCAKGZCBKGZJGABCLUIUJQHCQHZUKUNMUIABUIUEQADENZ
    UFUGUHOPZUIUEQBURUFUGUHRPZUAUIUEQCURUFUGUHUBPZUJCSTUIULUOUMUPJUIAQHUQULUOMU
    SVAACSTUIBQHUQUMUPMUTVABCSTUCUD $.

  $( Extended non-negative real version of ~ npcan .  (Contributed by Thierry
     Arnoux, 9-Jun-2017.) $)
  xrge0npcan $p |- ( ( A e. ( 0 [,] +oo ) /\ B e. ( 0 [,] +oo ) /\ B <_ A ) ->
     ( ( A +e -e B ) +e B ) = A ) $=
    ( cc0 cpnf co wcel cle wbr wceq cxne wa cxr simpl1 sseldi simpr syl2anc syl
    cxad cmnf wne cicc w3a iccssxr simpl3 eqbrtrrd xgepnf biimpa xnegeq oveq12d
    pnfxr xnegid syl6eq oveq1d oveq2d xaddid2 mp1i 3eqtrd eqtr4d wn xrge0neqmnf
    ax-mp simpl2 xnegcld xnegneg sylan9req xnegmnf ex con3and neneqad syl222anc
    xaddass xnegcl xaddcom mpancom eqtrd xaddid1 sylan9eqr pm2.61dan ) ACDUAEZF
    ZBVSFZBAGHZUBZBDIZABJZREZBREZAIWCWDKZWGDAWHWGCBRECDREZDWHWFCBRWHWFDDJZREZCW
    HADWEWJRWHALFZDAGHZADIZWHVSLACDUCZVTWAWBWDMNWHBDAGWCWDOZVTWAWBWDUDUEWLWMWNA
    UFUGPZWHWDWEWJIWPBDUHQUIDLFZWKCIUJDUKVAULUMWHBDCRWPUNWRWIDIWHUJDUOUPUQWQURW
    CWDUSZKZWGAWEBREZREZAWTWLASTZWELFZWESTZBLFZBSTZWGXBIWTVSLAWOVTWAWBWSMZNZWTV
    TXCXHAUTQWTBWTVSLBWOVTWAWBWSVBZNZVCWTXFWSXEXKWCWSOXFWSKWESXFWESIZWDXFXLWDXF
    XLKBSJZDXFXLBWEJXMBVDWESUHVEVFULVGVHVIPXKWTWAXGXJBUTQAWEBVKVJWTWLXFXBAIXIXK
    XFWLXBACREAXFXACARXFXABWEREZCXDXFXAXNIBVLWEBVMVNBUKVOUNAVPVQPVOVR $.

  ${
    $d k x y A $.  $d x y B $.  $d k x y ph $.
    fsumrp0cl.1 $e |- ( ph -> A e. Fin ) $.
    fsumrp0cl.2 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,) +oo ) ) $.
    $( Closure of a finite sum of non-negative reals.  (Contributed by Thierry
       Arnoux, 25-Jun-2017.) $)
    fsumrp0cl $p |- ( ph -> sum_ k e. A B e. ( 0 [,) +oo ) ) $=
      ( cc0 cpnf cr rge0ssre wcel cxr cle wbr clt w3a wb 0xr pnfxr elico1 vx vy
      cico co cc wss ax-resscn sstri a1i cv caddc simprl sseldi simprr readdcld
      wa rexrd mp2an simp2bi syl addge0d ltpnf syl3anbrc 0re ax-mp lbico1 mp3an
      fsumcllem ) AUAUBBCGHUCUDZDVIUEUFAVIIUEJUGUHUIAUAUJZVIKZUBUJZVIKZUPUPZVJV
      LUKUDZLKZGVOMNZVOHONZVOVIKZVNVOVNVJVLVNVIIVJJAVKVMULZUMZVNVIIVLJAVKVMUNZU
      MZUOZUQVNVJVLWAWCVNVKGVJMNZVTVKVJLKZWEVJHONZGLKZHLKZVKWFWEWGPQRSGHVJTURUS
      UTVNVMGVLMNZWBVMVLLKZWJVLHONZWHWIVMWKWJWLPQRSGHVLTURUSUTVAVNVOIKVRWDVOVBU
      TWHWIVSVPVQVRPQRSGHVOTURVCEFGVIKZAWHWIGHONZWMRSGIKWNVDGVBVEGHVFVGUIVH $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Algebra
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Monoids Homomorphisms
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y F $.  $d x y M $.  $d x y N $.
    $( The image of an Abelian group by a group isomorphism is also Abelian.
       (Contributed by Thierry Arnoux, 8-Mar-2018.) $)
    abliso $p |- ( ( M e. Abel /\ F e. ( M GrpIso N ) ) -> N e. Abel ) $=
      ( vx vy cabel wcel cgim co wa cghm gimghm syl cv cplusg cfv wceq ad2antlr
      eqid syl3anc cgrp ccmn ghmgrp2 adantl cmnd cbs wral grpmnd ccnv simpll wf
      wf1o gimf1o f1ocnv f1of 3syl simprl ffvelrnd simprr ablcom gimcnv 3eqtr4d
      ghmlin fveq2d adantr grpcl f1ocnvfv2 syl2anc 3eqtr3d iscmn sylanbrc isabl
      ralrimivva ) BFGZABCHIGZJZCUAGZCUBGZCFGVOVQVNVOABCKIGVQBCALBCAUCMUDZVPCUE
      GZDNZENZCOPZIZWBWAWCIZQZECUFPZUGDWGUGVRVPVQVTVSCUHMVPWFDEWGWGVPWAWGGZWBWG
      GZJZJZWDAUIZPZAPZWEWLPZAPZWDWEWKWMWOAWKWAWLPZWBWLPZBOPZIZWRWQWSIZWMWOWKVN
      WQBUFPZGWRXBGWTXAQVNVOWJUJWKWGXBWAWLVOWGXBWLUKZVNWJVOXBWGAULZWGXBWLULXCXB
      WGBCAXBSZWGSZUMZXBWGAUNWGXBWLUOUPRZVPWHWIUQZURWKWGXBWBWLXHVPWHWIUSZURXBWS
      BWQWRXEWSSZUTTWKWLCBKIGZWHWIWMWTQWKWLCBHIGZXLVOXMVNWJBCAVARCBWLLMZXIXJWCW
      SCBWAWLWBWGXFWCSZXKVCTWKXLWIWHWOXAQXNXJXIWCWSCBWBWLWAWGXFXOXKVCTVBVDWKXDW
      DWGGZWNWDQVOXDVNWJXGRZWKVQWHWIXPVPVQWJVSVEZXIXJWGWCCWAWBXFXOVFTXBWGWDAVGV
      HWKXDWEWGGZWPWEQXQWKVQWIWHXSXRXJXIWGWCCWBWAXFXOVFTXBWGWEAVGVHVIVMDEWGWCCX
      FXOVJVKCVLVK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Ordered monoids and groups
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c oMnd $.
  $c oGrp $.

  $( Extend class notation with the class of all ordered monoids. $)
  comnd $a class oMnd $.

  $( Extend class notation with the class of all ordered groups. $)
  cogrp $a class oGrp $.

  ${
    $d a b c g l p v z $.
    $( Define class of all ordered monoids.  An ordered monoid is a monoid with
       a total ordering compatible with its operation.  (Contributed by Thierry
       Arnoux, 13-Mar-2018.) $)
    df-omnd $a |- oMnd = { g e. Mnd | [. ( Base ` g ) / v ].
      [. ( +g ` g ) / p ]. [. ( le ` g ) / l ]. ( g e. Toset /\
      A. a e. v A. b e. v A. c e. v ( a l b -> ( a p c ) l ( b p c ) ) ) } $.

    $( Define class of all ordered groups.  An ordered group is a group with a
       total ordering compatible with its operation.  (Contributed by Thierry
       Arnoux, 13-Mar-2018.) $)
    df-ogrp $a |- oGrp = ( Grp i^i oMnd ) $.
  $}

  ${
    $d a b c l m p v B $.  $d a b c l m p v M $.  $d l m p t .+ $.
    $d l m .<_ $.
    isomnd.0 $e |- B = ( Base ` M ) $.
    isomnd.1 $e |- .+ = ( +g ` M ) $.
    isomnd.2 $e |- .<_ = ( le ` M ) $.
    $( An ordered monoid is a monoid with a total ordering compatible with its
       operation.  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    isomnd $p |- ( M e. oMnd <-> ( M e. Mnd /\ M e. Toset /\
      A. a e. B A. b e. B A. c e. B ( a .<_ b -> ( a .+ c ) .<_ ( b .+ c ) )
      ) ) $=
      ( vl vp wcel cv wral wa cfv wsbc wceq cvv vm vv comnd cmnd ctos wbr co wi
      w3a cple cplusg cbs fvex a1i wb simpr fveq2 adantr eqtrd raleq raleqbi1dv
      syl6eqr anbi2d sbcbidv sbcied oveqd breq12d imbi2d ralbidv 2ralbidv bitrd
      biidd simpl fveq2d breqd imbi12d eleq1 anbi1d 3bitrd elrab2 3anass bitr4i
      syl df-omnd ) DUCMDUDMZDUEMZENZFNZCUFZWGGNZBUGZWHWJBUGZCUFZUHZGAOZFAOEAOZ
      PZPWEWFWPUIUANZUEMZWGWHKNZUFZWGWJLNZUGZWHWJXBUGZWTUFZUHZGUBNZOZFXGOZEXGOZ
      PZKWRUJQZRZLWRUKQZRZUBWRULQZRZWQUADUDUCWRDSZXQWSXAWKWLWTUFZUHZGAOZFAOEAOZ
      PZKXLRZWQXRXQWSXFGAOZFAOZEAOZPZKXLRZLXNRZYDXRXOYJUBXPTXPTMXRWRULUMUNXRXGX
      PSZPZXMYILXNYLXKYHKXLYLXJYGWSYLXGASXJYGUOYLXGDULQZAYLXGXPYMXRYKUPXRXPYMSY
      KWRDULUQURUSHVBXIYFEXGAXHYEFXGAXFGXGAUTVAVAWCVCVDVDVEXRYIYDLXNTXNTMXRWRUK
      UMUNXRXBXNSZPZYHYCKXLYOYGYBWSYOYEYAEFAAYOXFXTGAYOXEXSXAYOXCWKXDWLWTYOXBBW
      GWJYOXBDUKQZBYOXBXNYPXRYNUPXRXNYPSYNWRDUKUQURUSIVBZVFYOXBBWHWJYQVFVGVHVIV
      JVCVDVEVKXRYDYDWSWPPZWQXRYDVLXRYCYRKXLTXLTMXRWRUJUMUNXRWTXLSZPZYBWPWSYTYA
      WOEFAAYTXTWNGAYTXAWIXSWMYTWTCWGWHYTWTDUJQZCYTWTXLUUAXRYSUPYTWRDUJXRYSVMVN
      USJVBZVOYTWTCWKWLUUBVOVPVIVJVCVEXRWSWFWPWRDUEVQVRVSVKUBUALEFGKWDVTWEWFWPW
      AWB $.
  $}

  $( An ordered group is a group with a total ordering compatible with its
     operations.  (Contributed by Thierry Arnoux, 23-Mar-2018.) $)
  isogrp $p |- ( G e. oGrp <-> ( G e. Grp /\ G e. oMnd ) ) $=
    ( cgrp comnd cogrp df-ogrp elin2 ) ABCDEF $.

  $( An ordered group is a group.  (Contributed by Thierry Arnoux,
     9-Jul-2018.) $)
  ogrpgrp $p |- ( G e. oGrp -> G e. Grp ) $=
    ( cogrp wcel cgrp comnd isogrp simplbi ) ABCADCAECAFG $.

  ${
    $d a b c M $.
    $( An ordered monoid is a monoid.  (Contributed by Thierry Arnoux,
       13-Mar-2018.) $)
    omndmnd $p |- ( M e. oMnd -> M e. Mnd ) $=
      ( va vb vc comnd wcel cmnd ctos cv cple cfv wbr cplusg co cbs wral isomnd
      wi eqid simp1bi ) AEFAGFAHFBIZCIZAJKZLUADIZAMKZNUBUDUENUCLRDAOKZPCUFPBUFP
      UFUEUCABCDUFSUESUCSQT $.

    $( An ordered monoid is a totally ordered set.  (Contributed by Thierry
       Arnoux, 13-Mar-2018.) $)
    omndtos $p |- ( M e. oMnd -> M e. Toset ) $=
      ( va vb vc comnd wcel cmnd ctos cv cple cfv wbr cplusg co cbs wral isomnd
      wi eqid simp2bi ) AEFAGFAHFBIZCIZAJKZLUADIZAMKZNUBUDUENUCLRDAOKZPCUFPBUFP
      UFUEUCABCDUFSUESUCSQT $.

    $d a b c X $.  $d b c Y $.  $d c Z $.  $d a b c .+ $.  $d a b c .<_ $.
    $d a b c B $.
    omndadd.0 $e |- B = ( Base ` M ) $.
    omndadd.1 $e |- .<_ = ( le ` M ) $.
    omndadd.2 $e |- .+ = ( +g ` M ) $.
    $( In an ordered monoid, the ordering is compatible with group addition.
       (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    omndadd $p |- ( ( M e. oMnd /\ ( X e. B /\ Y e. B /\ Z e. B )
      /\ X .<_ Y ) -> ( X .+ Z ) .<_ ( Y .+ Z ) ) $=
      ( va vb vc wcel wbr co wi cv wral wceq comnd w3a cmnd ctos isomnd simp3bi
      breq1 oveq1 breq1d imbi12d breq2 breq2d breq12d imbi2d rspc3v syl5 impcom
      oveq2 3impia ) DUANZEANFANGANUBZEFCOZEGBPZFGBPZCOZVAUTVBVEQZUTKRZLRZCOZVG
      MRZBPZVHVJBPZCOZQZMASLASKASZVAVFUTDUCNDUDNVOABCDKLMHJIUEUFVNVFEVHCOZEVJBP
      ZVLCOZQVBVQFVJBPZCOZQKLMEFGAAAVGETZVIVPVMVRVGEVHCUGWAVKVQVLCVGEVJBUHUIUJV
      HFTZVPVBVRVTVHFECUKWBVLVSVQCVHFVJBUHULUJVJGTZVTVEVBWCVQVCVSVDCVJGEBURVJGF
      BURUMUNUOUPUQUS $.

    $( In a right ordered monoid, the ordering is compatible with group
       addition.  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    omndaddr $p |- ( ( ( oppG ` M ) e. oMnd /\ ( X e. B /\ Y e. B /\ Z e. B )
      /\ X .<_ Y ) -> ( Z .+ X ) .<_ ( Z .+ Y ) ) $=
      ( coppg cfv comnd wcel w3a wbr cplusg co eqid oppgplus oppgbas omndadd
      oppgle 3brtr3g ) DKLZMNEANFANGANOEFCPOEGUEQLZRFGUFRGEBRGFBRCAUFCUEEFGADUE
      UESZHUADCUEUGIUCUFSZUBBUFDUEEGJUGUHTBUFDUEFGJUGUHTUD $.

    ${
      omndadd2d.m $e |- ( ph -> M e. oMnd ) $.
      omndadd2d.w $e |- ( ph -> W e. B ) $.
      omndadd2d.x $e |- ( ph -> X e. B ) $.
      omndadd2d.y $e |- ( ph -> Y e. B ) $.
      omndadd2d.z $e |- ( ph -> Z e. B ) $.
      omndadd2d.1 $e |- ( ph -> X .<_ Z ) $.
      omndadd2d.2 $e |- ( ph -> Y .<_ W ) $.

      ${
        omndadd2d.c $e |- ( ph -> M e. CMnd ) $.
        $( In a commutative left ordered monoid, the ordering is compatible
           with monoid addition.  Double addition version (Contributed by
           Thierry Arnoux, 30-Jan-2018.) $)
        omndadd2d $p |- ( ph -> ( X .+ Y ) .<_ ( Z .+ W ) ) $=
          ( cpo wcel co w3a wbr comnd ctos omndtos tospos 3syl cmnd omndmnd syl
          mndcl syl3anc 3jca omndadd syl131anc ccmn cmncom 3brtr3d wa postr imp
          wceq syl22anc ) AEUAUBZGHCUCZBUBZIHCUCZBUBZIFCUCZBUBZUDZVHVJDUEZVJVLD
          UEZVHVLDUEZAEUFUBZEUGUBVGMEUHEUIUJAVIVKVMAEUKUBZGBUBZHBUBZVIAVRVSMEUL
          UMZOPBCEGHJLUNUOAVSIBUBZWAVKWBQPBCEIHJLUNUOAVSWCFBUBZVMWBQNBCEIFJLUNU
          OUPAVRVTWCWAGIDUEVOMOQPRBCDEGIHJKLUQURAHICUCZFICUCZVJVLDAVRWAWDWCHFDU
          EWEWFDUEMPNQSBCDEHFIJKLUQURAEUSUBZWAWCWEVJVETPQBCEHIJLUTUOAWGWDWCWFVL
          VETNQBCEFIJLUTUOVAVGVNVBVOVPVBVQBEDVHVJVLJKVCVDVF $.
      $}

      ${
        omndadd2rd.c $e |- ( ph -> ( oppG ` M ) e. oMnd ) $.
        $( In a left- and right- ordered monoid, the ordering is compatible
           with monoid addition.  Double addition version (Contributed by
           Thierry Arnoux, 2-May-2018.) $)
        omndadd2rd $p |- ( ph -> ( X .+ Y ) .<_ ( Z .+ W ) ) $=
          ( cpo wcel co w3a wbr comnd ctos omndtos tospos 3syl cmnd omndmnd syl
          mndcl syl3anc 3jca coppg omndaddr syl131anc omndadd wa postr syl22anc
          cfv imp ) AEUAUBZGHCUCZBUBZGFCUCZBUBZIFCUCZBUBZUDZVGVIDUEZVIVKDUEZVGV
          KDUEZAEUFUBZEUGUBVFMEUHEUIUJAVHVJVLAEUKUBZGBUBZHBUBZVHAVQVRMEULUMZOPB
          CEGHJLUNUOAVRVSFBUBZVJWAONBCEGFJLUNUOAVRIBUBZWBVLWAQNBCEIFJLUNUOUPAEU
          QVDUFUBVTWBVSHFDUEVNTPNOSBCDEHFGJKLURUSAVQVSWCWBGIDUEVOMOQNRBCDEGIFJK
          LUTUSVFVMVAVNVOVAVPBEDVGVIVKJKVBVEVC $.
      $}
    $}
  $}

  ${
    $d a b c A $.  $d a b c M $.
    $( A submonoid of an ordered monoid is also ordered.  (Contributed by
       Thierry Arnoux, 23-Mar-2018.) $)
    submomnd $p |- ( ( M e. oMnd /\ ( M |`s A ) e. Mnd )
      -> ( M |`s A ) e. oMnd ) $=
      ( va vb vc wcel co wa cv cfv wbr cbs wral w3a cvv adantr c0 wceq eqid syl
      comnd cress cmnd ctos cple cplusg wi simpr reldmress ovprc2 fveq2d adantl
      omndtos base0 syl6eqr wne c0g mndidcl ne0i ad2antlr neneqd condan resstos
      wn syl2anc simplll wss cin ressbas inss2 syl6eqssr simplr1 sseldd simplr2
      ad2antrr simplr3 3jca breqd biimpar omndadd syl3anc wb ressplusg breq123d
      ressle oveqd mpbid ex ralrimivvva isomnd sylibr ) BUAFZBAUBGZUCFZHZWNWMUD
      FZCIZDIZWMUEJZKZWQEIZWMUFJZGZWRXAXBGZWSKZUGZEWMLJZMDXGMCXGMZNWMUAFWOWNWPX
      HWLWNUHWOBUDFZAOFZWPWLXIWNBUMPWOXJXGQRWOXJVDZHZXGQLJZQXKXGXMRWOXKWMQLBAUB
      UIUJUKULUNUOXLXGQWNXGQUPZWLXKWNWMUQJZXGFXNXGWMXOXGSZXOSURXGXOUSTUTVAVBZAB
      OVCVEWOXFCDEXGXGXGWOWQXGFZWRXGFZXAXGFZNZHZWTXEYBWTHZWQXABUFJZGZWRXAYDGZBU
      EJZKZXEYCWLWQBLJZFZWRYIFZXAYIFZNWQWRYGKZYHWLWNYAWTVFYCYJYKYLYCXGYIWQWOXGY
      IVGZYAWTWOXJYNXQXJXGAYIVHYIAYIWMOBWMSZYISZVIAYIVJVKTVOZXRXSXTWOWTVLVMYCXG
      YIWRYQXRXSXTWOWTVNVMYCXGYIXAYQXRXSXTWOWTVPVMVQYBYMWTYBYGWSWQWRWOYGWSRZYAW
      OXJYRXQABYGOWMYOYGSZWEZTPVRVSYIYDYGBWQWRXAYPYSYDSZVTWAYBYHXEWBWTYBYEXCYFX
      DYGWSYBYDXBWQXAYBXJYDXBRWOXJYAXQPZAYDBWMOYOUUAWCTZWFYBXJYRUUBYTTYBYDXBWRX
      AUUCWFWDPWGWHWIVQXGXBWSWMCDEXPXBSWSSWJWK $.
  $}

  ${
    $d x y z $.
    $( The nonnegative extended real numbers form an ordered monoid.
       (Contributed by Thierry Arnoux, 22-Mar-2018.) $)
    xrge0omnd $p |- ( RR*s |`s ( 0 [,] +oo ) ) e. oMnd $=
      ( vx vy vz cxrs cc0 cpnf co wcel cv cle wbr cxad wi wral cvv wa w3a sseli
      cxr xrge0base cicc cress comnd cmnd ctos ccmn xrge0cmn cmnmnd cpo wo wceq
      ax-mp ovex iccssxr xrleid 3ad2ant1 xrletri3 biimprd syl2an 3adant3 xrletr
      syl syl3an 3jca rgen3 cple cfv eqid xrsle ressle mpbir2an anim12i xrletri
      ispos rgen2a istos xleadd1a ex xrge0plusg isomnd mpbir3an ) DEFUAGZUBGZUC
      HWCUDHZWCUEHZAIZBIZJKZWFCIZLGWGWILGJKZMZCWBNBWBNAWBNWCUFHWDUGWCUHULWEWCUI
      HZWHWGWFJKZUJZBWBNAWBNWLWCOHWFWFJKZWHWMPZWFWGUKZMZWHWGWIJKPWFWIJKMZQZCWBN
      BWBNAWBNDWBUBUMWTABCWBWBWBWFWBHZWGWBHZWIWBHZQWOWRWSXAXBWOXCXAWFSHZWOWBSWF
      EFUNZRZWFUOVBUPXAXBWRXCXAXDWGSHZWRXBXFWBSWGXERZXDXGPZWQWPWFWGUQURUSUTXAXD
      XBXGXCWISHZWSXFXHWBSWIXERZWFWGWIVAVCVDVEABCWBWCJTWBOHJWCVFVGUKEFUAUMWBDJO
      WCWCVHVIVJULZVNVKWNABWBXAXBPXIWNXAXDXBXGXFXHVLWFWGVMVBVOABWBWCJTXLVPVKWKA
      BCWBWBWBXAXDXBXGXCXJWKXFXHXKXDXGXJQWHWJWFWGWIVQVRVCVEWBLJWCABCTVSXLVTWA
      $.
  $}

  ${
    $d m n B $.  $d m n M $.  $d m n N $.  $d m n X $.  $d m n Y $.
    $d m n .0. $.  $d m n .<_ $.  $d m n .x. $.  $d m n ph $.
    omndmul.0 $e |- B = ( Base ` M ) $.
    omndmul.1 $e |- .<_ = ( le ` M ) $.
    ${
      omndmul2.2 $e |- .x. = ( .g ` M ) $.
      omndmul2.3 $e |- .0. = ( 0g ` M ) $.
      $( In an ordered monoid, the ordering is compatible with group power.
         This version does not require the monoid to be commutative.
         (Contributed by Thierry Arnoux, 23-Mar-2018.) $)
      omndmul2 $p |- ( ( M e. oMnd /\ ( X e. B /\ N e. NN0 ) /\ .0. .<_ X ) ->
        .0. .<_ ( N .x. X ) ) $=
        ( wcel cn0 wa wbr w3a co c1 wceq syl df-3an 3anass bitr3i anbi1i bitr4i
        vm vn comnd simplr cv cc0 caddc oveq1 breq2d cpo omndtos tospos omndmnd
        ctos mndidcl posref syl2anc ad3antrrr ad3antlr breqtrrd ad5antr simp-5r
        cmnd mulg0 mulgnn0cl syl3anc simpr32 1nn0 nn0addcld 3anassrs 3jca simpr
        a1i cplusg cfv simp-4l ad4antr simp-4r eqid syl131anc mndlid mulgnn0dir
        omndadd syl13anc cc ax-1cn simpr3 nn0cnd addcomd mulg1 3eqtr3rd 3brtr3d
        oveq1d adantr jca postr imp syl21anc nn0indd mpdan sylbi ) DUHLZFALZEML
        ZNZGFCOZPZXGXHNZXINZXKNZGEFBQZCOZXLXGXJNZXKNXOXGXJXKUAXNXRXKXNXGXHXIPXR
        XGXHXIUAXGXHXIUBUCUDUEXOXIXQXMXIXKUIXOGUFUJZFBQZCOGUKFBQZCOGUGUJZFBQZCO
        ZGYBRULQZFBQZCOZXQUFUGEXSUKSXTYAGCXSUKFBUMUNXSYBSXTYCGCXSYBFBUMUNXSYESX
        TYFGCXSYEFBUMUNXSESXTXPGCXSEFBUMUNXOGGYACXGGGCOZXHXIXKXGDUOLZGALZYHXGDU
        SLYIDUPDUQTZXGDVHLZYJDURZADGHKUTZTADCGHIVAVBVCXHYAGSXGXIXKABDFGHKJVIVDV
        EXOYBMLZNZYDNZYIYJYCALZYFALZPZYDYCYFCOZNZYGXGYIXHXIXKYOYDYKVFYQYJYRYSYQ
        YLYJXGYLXHXIXKYOYDYMVFZYNTYQYLYOXHYRUUCXOYOYDUIXGXHXIXKYOYDVGZABDYBFHJV
        JZVKYQYLYEMLZXHYSUUCXNXKYOYDUUFXGXHXIXKYOYDPZUUFXGXHXIUUGPNZYBRXKYOYDXH
        XIXGVLRMLZUUHVMVRVNVOVOUUDABDYEFHJVJVKVPYQYDUUAYPYDVQYPUUAYDYPGYCDVSVTZ
        QZFYCUUJQZYCYFCYPXGYJXHYRXKUUKUULCOXGXHXIXKYOWAYPYLYJXGYLXHXIXKYOYMWBZY
        NTXGXHXIXKYOWCZYPYLYOXHYRUUMXOYOVQZUUNUUEVKZXNXKYOUIAUUJCDGFYCHIUUJWDZW
        HWEYPYLYRUUKYCSUUMUUPAUUJDYCGHUUQKWFVBYPRYBULQZFBQZRFBQZYCUUJQZYFUULYPY
        LUUIYOXHUUSUVASUUMUUIYPVMVRUUOUUNAUUJBDRYBFHJUUQWGWIYPUURYEFBXMXIXKYOUU
        RYESXMXIXKYOPNZRYBRWJLUVBWKVRUVBYBXMXIXKYOWLWMWNVOWRYPUUTFYCUUJYPXHUUTF
        SUUNABDFHJWOTWRWPWQWSWTYIYTNUUBYGADCGYCYFHIXAXBXCXDXEXF $.
    $}

    ${
      omndmul3.m $e |- .x. = ( .g ` M ) $.
      omndmul3.0 $e |- .0. = ( 0g ` M ) $.
      omndmul3.o $e |- ( ph -> M e. oMnd ) $.
      omndmul3.1 $e |- ( ph -> N e. NN0 ) $.
      omndmul3.2 $e |- ( ph -> P e. NN0 ) $.
      omndmul3.3 $e |- ( ph -> N <_ P ) $.
      omndmul3.4 $e |- ( ph -> X e. B ) $.
      omndmul3.5 $e |- ( ph -> .0. .<_ X ) $.
      $( In an ordered monoid, the ordering is compatible with group power.
         This version does not require the monoid to be commutative.
         (Contributed by Thierry Arnoux, 23-Mar-2018.) $)
      omndmul3 $p |- ( ph -> ( N .x. X ) .<_ ( P .x. X ) ) $=
        ( wcel co cplusg cfv cmin comnd wbr cmnd omndmnd syl mndidcl cn0 cle wa
        nn0sub biimpa syl21anc mulgnn0cl omndmul2 syl121anc eqid syl131anc wceq
        syl3anc omndadd mndlid syl2anc mulgnn0dir syl13anc nn0cnd npcand oveq1d
        caddc eqtr3d 3brtr3d ) AIGHDUAZFUBUCZUAZCGUDUAZHDUAZVOVPUAZVOCHDUAZEAFU
        ETZIBTZVSBTZVOBTZIVSEUFZVQVTEUFNAFUGTZWCAWBWGNFUHUIZBFIJMUJUIAWGVRUKTZH
        BTZWDWHAGUKTZCUKTZGCULUFZWIOPQWKWLUMWMWIGCUNUOUPZRBDFVRHJLUQVCAWGWKWJWE
        WHORBDFGHJLUQVCZAWBWJWIIHEUFWFNRWNSBDEFVRHIJKLMURUSBVPEFIVSVOJKVPUTZVDV
        AAWGWEVQVOVBWHWOBVPFVOIJWPMVEVFAVRGVLUAZHDUAZVTWAAWGWIWKWJWRVTVBWHWNORB
        VPDFVRGHJLWPVGVHAWQCHDACGACPVIAGOVIVJVKVMVN $.
    $}

    ${
      omndmul.2 $e |- .x. = ( .g ` M ) $.
      omndmul.o $e |- ( ph -> M e. oMnd ) $.
      omndmul.c $e |- ( ph -> M e. CMnd ) $.
      omndmul.x $e |- ( ph -> X e. B ) $.
      omndmul.y $e |- ( ph -> Y e. B ) $.
      omndmul.n $e |- ( ph -> N e. NN0 ) $.
      omndmul.l $e |- ( ph -> X .<_ Y ) $.
      $( In a commutative ordered monoid, the ordering is compatible with group
         power.  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
      omndmul $p |- ( ph -> ( N .x. X ) .<_ ( N .x. Y ) ) $=
        ( wcel co wceq vm vn cn0 wbr cv cc0 c1 caddc oveq1 breq12d ctos omndtos
        cpo comnd tospos 3syl c0g cfv eqid mulg0 omndmnd mndidcl eqeltrd posref
        syl cmnd syl2anc wb wa adantr adantl eqtr4d breq1d mpbird cplusg simplr
        ad2antrr mulgnn0cl syl3anc simpr ccmn omndadd2d mulgnn0p1 3brtr4d mpdan
        nn0indd ) AFUCRFGCSZFHCSZDUDZPAUAUEZGCSZWJHCSZDUDUFGCSZUFHCSZDUDZUBUEZG
        CSZWPHCSZDUDZWPUGUHSZGCSZWTHCSZDUDWIUAUBFWJUFTWKWMWLWNDWJUFGCUIWJUFHCUI
        UJWJWPTWKWQWLWRDWJWPGCUIWJWPHCUIUJWJWTTWKXAWLXBDWJWTGCUIWJWTHCUIUJWJFTW
        KWGWLWHDWJFGCUIWJFHCUIUJAWOWNWNDUDZAEUMRZWNBRXCAEUNRZEUKRXDLEULEUOUPAWN
        EUQURZBAHBRZWNXFTZOBCEHXFIXFUSZKUTZVEAXEEVFRZXFBRLEVAZBEXFIXIVBUPVCBEDW
        NIJVDVGAGBRZXGWOXCVHNOXMXGVIZWMWNWNDXNWMXFWNXMWMXFTXGBCEGXFIXIKUTVJXGXH
        XMXJVKVLVMVGVNAWPUCRZVIZWSVIZWQGEVOURZSZWRHXRSZXAXBDXQBXRDEHWQGWRIJXRUS
        ZAXEXOWSLVQZAXGXOWSOVQZXQXKXOXMWQBRXQXEXKYBXLVEZAXOWSVPZAXMXOWSNVQZBCEW
        PGIKVRVSYFXQXKXOXGWRBRYDYEYCBCEWPHIKVRVSXPWSVTAGHDUDXOWSQVQAEWARXOWSMVQ
        WBXQXKXOXMXAXSTYDYEYFBXRCEWPGIKYAWCVSXQXKXOXGXBXTTYDYEYCBXRCEWPHIKYAWCV
        SWDWFWE $.
    $}
  $}

  ${
    ogrpsub.0 $e |- B = ( Base ` G ) $.
    ogrpsub.1 $e |- .<_ = ( le ` G ) $.
    ${
      ogrpinv.2 $e |- I = ( invg ` G ) $.
      ogrpinv.3 $e |- .0. = ( 0g ` G ) $.
      $( In an ordered group, the ordering is compatible with group inverse.
         (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
      ogrpinvOLD $p |- ( ( G e. oGrp /\ X e. B /\ .0. .<_ X )
        -> ( I ` X ) .<_ .0. ) $=
        ( cogrp wcel wbr w3a cfv cplusg co 3ad2ant1 syl2anc wceq isogrp simprbi
        comnd cgrp simplbi grpidcl syl simp2 grpinvcl simp3 eqid omndadd grplid
        syl131anc grprinv 3brtr3d ) BKLZEALZFEDMZNZFECOZBPOZQZEVAVBQZVAFDUTBUCL
        ZFALZURVAALZUSVCVDDMUQURVEUSUQBUDLZVEBUAZUBRUTVHVFUQURVHUSUQVHVEVIUERZA
        BFGJUFUGUQURUSUHZUTVHURVGVJVKABCEGIUISZUQURUSUJAVBDBFEVAGHVBUKZULUNUTVH
        VGVCVATVJVLAVBBVAFGVMJUMSUTVHURVDFTVJVKAVBBCEFGVMJIUOSUP $.

      $( In an ordered group, the ordering is compatible with group inverse.
         (Contributed by Thierry Arnoux, 3-Sep-2018.) $)
      ogrpinv0le $p |- ( ( G e. oGrp /\ X e. B )
        -> ( .0. .<_ X <-> ( I ` X ) .<_ .0. ) ) $=
        ( wcel wa wbr cfv co ad2antrr 3syl simplr syl2anc wceq cogrp comnd cgrp
        cplusg simprbi cmnd omndmnd mndidcl simplbi grpinvcl simpr eqid omndadd
        isogrp syl131anc grplid grprinv 3brtr3d grplinv impbida ) BUAKZEAKZLZFE
        DMZECNZFDMZVCVDLZFVEBUDNZOZEVEVHOZVEFDVGBUBKZFAKZVBVEAKZVDVIVJDMVAVKVBV
        DVABUCKZVKBUNZUEZPZVGVKBUFKZVLVQBUGZABFGJUHZQVAVBVDRZVGVNVBVMVAVNVBVDVA
        VNVKVOUIZPZWAABCEGIUJZSZVCVDUKAVHDBFEVEGHVHULZUMUOVGVNVMVIVETWCWEAVHBVE
        FGWFJUPSVGVNVBVJFTWCWAAVHBCEFGWFJIUQSURVCVFLZVEEVHOZFEVHOZFEDWGVKVMVLVB
        VFWHWIDMVAVKVBVFVPPZWGVNVBVMVAVNVBVFWBPZVAVBVFRZWDSWGVKVRVLWJVSVTQWLVCV
        FUKAVHDBVEFEGHWFUMUOWGVNVBWHFTWKWLAVHBCEFGWFJIUSSWGVNVBWIETWKWLAVHBEFGW
        FJUPSURUT $.
    $}

    ${
      ogrpsub.2 $e |- .- = ( -g ` G ) $.
      $( In an ordered group, the ordering is compatible with group subtraction
         (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
      ogrpsub $p |- ( ( G e. oGrp /\ ( X e. B /\ Y e. B /\ Z e. B )
        /\ X .<_ Y ) -> ( X .- Z ) .<_ ( Y .- Z ) ) $=
        ( wcel w3a wbr cfv co 3ad2ant1 eqid syl2anc wceq grpsubval cogrp cplusg
        cminusg comnd cgrp isogrp simprbi simp21 simp22 simplbi simp23 grpinvcl
        simp3 omndadd syl131anc 3brtr4d ) BUAKZEAKZFAKZGAKZLZEFCMZLZEGBUCNZNZBU
        BNZOZFVEVFOZEGDOZFGDOZCVCBUDKZURUSVEAKZVBVGVHCMUQVAVKVBUQBUEKZVKBUFZUGP
        UQURUSUTVBUHZUQURUSUTVBUIZVCVMUTVLUQVAVMVBUQVMVKVNUJPUQURUSUTVBUKZABVDG
        HVDQZULRUQVAVBUMAVFCBEFVEHIVFQZUNUOVCURUTVIVGSVOVQAVFBVDDEGHVSVRJTRVCUS
        UTVJVHSVPVQAVFBVDDFGHVSVRJTRUP $.
    $}
  $}

  ${
    ogrpaddlt.0 $e |- B = ( Base ` G ) $.
    ogrpaddlt.1 $e |- .< = ( lt ` G ) $.
    ogrpaddlt.2 $e |- .+ = ( +g ` G ) $.
    $( In an ordered group, strict ordering is compatible with group addition.
       (Contributed by Thierry Arnoux, 20-Jan-2018.) $)
    ogrpaddlt $p |- ( ( G e. oGrp /\ ( X e. B /\ Y e. B /\ Z e. B )
      /\ X .< Y ) -> ( X .+ Z ) .< ( Y .+ Z ) ) $=
      ( cogrp wcel w3a wbr co wne wa imp syl31anc cvv cple cfv comnd simp1 cgrp
      isogrp simprbi simp2 simp1d simp2d simp3 eqid pltle omndadd syl3anc pltne
      syl wceq wi simplbi grprcan biimpd sylan necon3d 3impia wb pltval mp3an23
      jca ovex 3ad2ant1 mpbird ) DKLZEALZFALZGALZMZEFCNZMZEGBOZFGBOZCNZVTWADUAU
      BZNZVTWAPZQZVSWDWEVSDUCLZVQEFWCNZWDVSVMWGVMVQVRUDZVMDUELZWGDUFZUGUQVMVQVR
      UHZVSVMVNVOVRWHWIVSVNVOVPWLUIZVSVNVOVPWLUJZVMVQVRUKZVMVNVOMZVRWHKAACDWCEF
      WCULZIUMRSABWCDEFGHWQJUNUOVSVMVQEFPZWEWIWLVSVMVNVOVRWRWIWMWNWOWPVRWRKAACD
      EFIUPRSVMVQWRWEVMVQQVTWAEFVMWJVQVTWAURZEFURZUSVMWJWGWKUTWJVQQWSWTABDEFGHJ
      VAVBVCVDVEUOVIVMVQWBWFVFZVRVMVTTLWATLXAEGBVJFGBVJKTTCDWCVTWAWQIVGVHVKVL
      $.

    $( In a right ordered group, strict ordering is compatible with group
       addition.  (Contributed by Thierry Arnoux, 3-Sep-2018.) $)
    ogrpaddltbi $p |- ( ( G e. oGrp /\ ( X e. B /\ Y e. B /\ Z e. B ) )
       -> ( X .< Y <-> ( X .+ Z ) .< ( Y .+ Z ) ) ) $=
      ( wcel wa wbr co ogrpaddlt cfv grpcl syl3anc syl2anc wceq cogrp w3a 3expa
      cminusg cgrp ogrpgrp syl simplr1 simplr3 simplr2 grpinvcl simpr syl131anc
      simpll eqid c0g grpass grprinv oveq2d grprid 3eqtrd breq12d mpbid impbida
      syl13anc ) DUAKZEAKZFAKZGAKZUBZLZEFCMZEGBNZFGBNZCMZVFVJVLVOABCDEFGHIJOUCV
      KVOLZVMGDUDPZPZBNZVNVRBNZCMZVLVPVFVMAKZVNAKZVRAKZVOWAVFVJVOUNZVPDUEKZVGVI
      WBVPVFWFWEDUFUGZVGVHVIVFVOUHZVGVHVIVFVOUIZABDEGHJQRVPWFVHVIWCWGVGVHVIVFVO
      UJZWIABDFGHJQRVPWFVIWDWGWIADVQGHVQUOZUKSZVKVOULABCDVMVNVRHIJOUMVPVSEVTFCV
      PVSEGVRBNZBNZEDUPPZBNZEVPWFVGVIWDVSWNTWGWHWIWLABDEGVRHJUQVEVPWMWOEBVPWFVI
      WMWOTWGWIABDVQGWOHJWOUOZWKURSZUSVPWFVGWPETWGWHABDEWOHJWQUTSVAVPVTFWMBNZFW
      OBNZFVPWFVHVIWDVTWSTWGWJWIWLABDFGVRHJUQVEVPWMWOFBWRUSVPWFVHWTFTWGWJABDFWO
      HJWQUTSVAVBVCVD $.

    ogrpaddltrd.1 $e |- ( ph -> G e. V ) $.
    ogrpaddltrd.2 $e |- ( ph -> ( oppG ` G ) e. oGrp ) $.
    ogrpaddltrd.3 $e |- ( ph -> X e. B ) $.
    ogrpaddltrd.4 $e |- ( ph -> Y e. B ) $.
    ogrpaddltrd.5 $e |- ( ph -> Z e. B ) $.
    ${
      ogrpaddltrd.6 $e |- ( ph -> X .< Y ) $.
      $( In a right ordered group, strict ordering is compatible with group
         addition.  (Contributed by Thierry Arnoux, 3-Sep-2018.) $)
      ogrpaddltrd $p |- ( ph -> ( Z .+ X ) .< ( Z .+ Y ) ) $=
        ( wbr wcel coppg cfv cplt cplusg cogrp wceq eqid oppglt syl breqd mpbid
        co oppgbas ogrpaddlt syl131anc oppgplus 3brtr3g mpbird ) AIGCULZIHCULZD
        SUSUTEUAUBZUCUBZSAGIVAUDUBZULZHIVCULZUSUTVBAVAUETGBTHBTIBTGHVBSZVDVEVBS
        NOPQAGHDSVFRADVBGHAEFTDVBUFMEDVAFVAUGZKUHUIZUJUKBVCVBVAGHIBEVAVGJUMVBUG
        VCUGZUNUOCVCEVAGILVGVIUPCVCEVAHILVGVIUPUQADVBUSUTVHUJUR $.
    $}

    $( In a right ordered group, strict ordering is compatible with group
       addition.  (Contributed by Thierry Arnoux, 4-Sep-2018.) $)
    ogrpaddltrbid $p |- ( ph -> ( X .< Y <-> ( Z .+ X ) .< ( Z .+ Y ) ) ) $=
      ( co wcel adantr wbr wa coppg cfv cogrp simpr ogrpaddltrd cminusg ogrpgrp
      cgrp syl w3a cplusg eqid oppgplus oppgbas grpcl syl5eqelr oppggrpb sylibr
      syl3anc grpinvcl syl2anc c0g wceq grplinv oveq1d syl13anc 3eqtr3d 3brtr3d
      grpass grplid impbida ) AGHDUAZIGCRZIHCRZDUAZAVNUBBCDEFGHIJKLAEFSZVNMTAEU
      CUDZUESZVNNTAGBSZVNOTAHBSZVNPTAIBSZVNQTAVNUFUGAVQUBZIEUHUDZUDZVOCRZWFVPCR
      ZGHDWDBCDEFVOVPWFJKLAVRVQMTAVTVQNTWDVSUJSZWAWCVOBSAWIVQAVTWINVSUIUKTZAWAV
      QOTZAWCVQQTZWIWAWCULVOGIVSUMUDZRBCWMEVSGILVSUNZWMUNZUOBWMVSGIBEVSWNJUPZWO
      UQURVAWDWIWBWCVPBSWJAWBVQPTZWLWIWBWCULVPHIWMRBCWMEVSHILWNWOUOBWMVSHIWPWOU
      QURVAWDEUJSZWCWFBSZWDWIWRWJEVSWNUSUTZWLBEWEIJWEUNZVBVCZAVQUFUGWDWFICRZGCR
      ZEVDUDZGCRZWGGWDXCXEGCWDWRWCXCXEVEWTWLBCEWEIXEJLXEUNZXAVFVCZVGWDWRWSWCWAX
      DWGVEWTXBWLWKBCEWFIGJLVKVHWDWRWAXFGVEWTWKBCEGXEJLXGVLVCVIWDXCHCRZXEHCRZWH
      HWDXCXEHCXHVGWDWRWSWCWBXIWHVEWTXBWLWQBCEWFIHJLVKVHWDWRWBXJHVEWTWQBCEHXEJL
      XGVLVCVIVJVM $.
  $}

  ${
    ogrpsublt.0 $e |- B = ( Base ` G ) $.
    ogrpsublt.1 $e |- .< = ( lt ` G ) $.
    ogrpsublt.2 $e |- .- = ( -g ` G ) $.
    $( In an ordered group, strict ordering is compatible with group addition.
       (Contributed by Thierry Arnoux, 3-Sep-2018.) $)
    ogrpsublt $p |- ( ( G e. oGrp /\ ( X e. B /\ Y e. B /\ Z e. B )
      /\ X .< Y ) -> ( X .- Z ) .< ( Y .- Z ) ) $=
      ( cogrp wcel w3a wbr co wne wa wb pltval syl3anc cple simp1 simp21 simp22
      simp23 simp3 eqid mpbid simpld ogrpsub syl131anc simprd cgrp wceq ogrpgrp
      cfv syl grpsubrcan syl13anc necon3bid mpbird jca grpsubcl ) CKLZEALZFALZG
      ALZMZEFBNZMZEGDOZFGDOZBNZVKVLCUAUPZNZVKVLPZQZVJVOVPVJVDVEVFVGEFVNNZVOVDVH
      VIUBZVDVEVFVGVIUCZVDVEVFVGVIUDZVDVEVFVGVIUEZVJVREFPZVJVIVRWCQZVDVHVIUFVJV
      DVEVFVIWDRVSVTWAKAABCVNEFVNUGZISTUHZUIACVNDEFGHWEJUJUKVJVPWCVJVRWCWFULVJV
      KVLEFVJCUMLZVEVFVGVKVLUNEFUNRVJVDWGVSCUOUQZVTWAWBACDEFGHJURUSUTVAVBVJVDVK
      ALZVLALZVMVQRVSVJWGVEVGWIWHVTWBACDEGHJVCTVJWGVFVGWJWHWAWBACDFGHJVCTKAABCV
      NVKVLWEISTVA $.
  $}

  ${
    ogrpinvlt.0 $e |- B = ( Base ` G ) $.
    ogrpinvlt.1 $e |- .< = ( lt ` G ) $.
    ogrpinvlt.2 $e |- I = ( invg ` G ) $.
    ${
      ogrpinv0lt.3 $e |- .0. = ( 0g ` G ) $.
      $( In an ordered group, the ordering is compatible with group inverse.
         (Contributed by Thierry Arnoux, 3-Sep-2018.) $)
      ogrpinv0lt $p |- ( ( G e. oGrp /\ X e. B )
        -> ( .0. .< X <-> ( I ` X ) .< .0. ) ) $=
        ( wcel wa wbr cfv co simpll syl simplr syl2anc wceq cplusg cgrp ogrpgrp
        cogrp grpidcl grpinvcl simpr ogrpaddlt syl131anc grplid grprinv 3brtr3d
        eqid 3syl grplinv impbida ) CUDKZEAKZLZFEBMZEDNZFBMZUSUTLZFVACUANZOZEVA
        VDOZVAFBVCUQFAKZURVAAKZUTVEVFBMUQURUTPZVCCUBKZVGVCUQVJVICUCZQZACFGJUEZQ
        UQURUTRZVCVJURVHVLVNACDEGIUFZSZUSUTUGAVDBCFEVAGHVDUMZUHUIVCVJVHVEVATVLV
        PAVDCVAFGVQJUJSVCVJURVFFTVLVNAVDCDEFGVQJIUKSULUSVBLZVAEVDOZFEVDOZFEBVRU
        QVHVGURVBVSVTBMUQURVBPZVRVJURVHVRUQVJWAVKQZUQURVBRZVOSVRUQVJVGWAVKVMUNW
        CUSVBUGAVDBCVAFEGHVQUHUIVRVJURVSFTWBWCAVDCDEFGVQJIUOSVRVJURVTETWBWCAVDC
        EFGVQJUJSULUP $.
    $}

    $( In an ordered group, the ordering is compatible with group inverse.
       (Contributed by Thierry Arnoux, 3-Sep-2018.) $)
    ogrpinvlt $p |- ( ( ( G e. oGrp /\ ( oppG ` G ) e. oGrp )
      /\ X e. B /\ Y e. B ) -> ( X .< Y <-> ( I ` Y ) .< ( I ` X ) ) ) $=
      ( cogrp wcel coppg cfv wbr co grpinvcl syl2anc eqid syl13anc wceq w3a c0g
      wa cplusg wb simp1l simp2 simp3 ogrpgrp ogrpaddltbi grprinv breq2d simp1r
      cgrp syl grpcl syl3anc grpidcl ogrpaddltrbid 3bitrd grplinv oveq1d grpass
      3syl grplid 3eqtr3d grprid breq12d bitrd ) CJKZCLMJKZUCZEAKZFAKZUAZEFBNZE
      DMZEFDMZCUDMZOZVSOZVQCUBMZVSOZBNZVRVQBNVOVPVTFVRVSOZBNZVTWBBNWDVOVJVMVNVR
      AKZVPWFUEVJVKVMVNUFZVLVMVNUGZVLVMVNUHZVOCUNKZVNWGVOVJWKWHCUIZUOZWJACDFGIP
      QZAVSBCEFVRGHVSRZUJSVOWEWBVTBVOWKVNWEWBTWMWJAVSCDFWBGWOWBRZIUKQULVOAVSBCJ
      VTWBVQGHWOWHVJVKVMVNUMVOWKVMWGVTAKWMWIWNAVSCEVRGWOUPUQVOVJWKWBAKWHWLACWBG
      WPURVDVOWKVMVQAKZWMWIACDEGIPQZUSUTVOWAVRWCVQBVOVQEVSOZVRVSOZWBVRVSOZWAVRV
      OWSWBVRVSVOWKVMWSWBTWMWIAVSCDEWBGWOWPIVAQVBVOWKWQVMWGWTWATWMWRWIWNAVSCVQE
      VRGWOVCSVOWKWGXAVRTWMWNAVSCVRWBGWOWPVEQVFVOWKWQWCVQTWMWRAVSCVQWBGWOWPVGQV
      HVI $.

  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    The Archimedean property for generic ordered algebraic structures
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c <<< $.
  $c Archi $.

  $( Class notation for the infinitesimal relation. $)
  cinftm $a class <<< $.

  $( Class notation for the Archimedean property. $)
  carchi $a class Archi $.

  ${
    $d n w x y $.
    $( Define the relation " ` x ` is infinitesimal with respect to ` y ` " for
       a structure ` w ` .  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    df-inftm $a |- <<< = ( w e. _V |-> { <. x , y >. | ( ( x e. ( Base ` w ) /\
      y e. ( Base ` w ) ) /\ ( ( 0g ` w ) ( lt ` w ) x /\
      A. n e. NN ( n ( .g ` w ) x ) ( lt ` w ) y ) ) } ) $.
  $}

  $( A structure said to be Archimedean if it has no infinitesimal elements.
     (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
  df-archi $a |- Archi = { w e. _V | ( <<< ` w ) = (/) } $.

  ${
    $d w x y B $.  $d n w x y W $.  $d n x y X $.  $d n x y Y $.
    $d w x y .< $.  $d w x y .x. $.  $d w x y .0. $.
    inftm.b $e |- B = ( Base ` W ) $.
    $( The infinitesimal relation for a structure ` W ` (Contributed by Thierry
       Arnoux, 30-Jan-2018.) $)
    inftmrel $p |- ( W e. V -> ( <<< ` W ) C_ ( B X. B ) ) $=
      ( vx vy vn vw wcel cfv cv wa c0g cplt wbr cmg cn cvv cbs fveq2 wral copab
      cinftm cxp wceq elex syl6eqr eleq2d anbi12d eqidd breq123d oveqd opabbidv
      co ralbidv df-inftm fvex eqeltri xpex opabssxp ssexi fvmpt syl syl6eqss )
      CBIZCUCJZEKZAIZFKZAIZLZCMJZVGCNJZOZGKZVGCPJZUNZVIVMOZGQUAZLZLZEFUBZAAUDZV
      ECRIVFWBUECBUFHCVGHKZSJZIZVIWEIZLZWDMJZVGWDNJZOZVOVGWDPJZUNZVIWJOZGQUAZLZ
      LZEFUBWBRUCWDCUEZWQWAEFWRWHVKWPVTWRWFVHWGVJWRWEAVGWRWECSJZAWDCSTDUGZUHWRW
      EAVIWTUHUIWRWKVNWOVSWRWIVLVGVGWJVMWDCMTWDCNTZWRVGUJUKWRWNVRGQWRWMVQVIVIWJ
      VMWRWLVPVOVGWDCPTULXAWRVIUJUKUOUIUIUMEFHGUPWBWCAAAWSRDCSUQURZXBUSVTEFAAUT
      ZVAVBVCXCVD $.

    inftm.0 $e |- .0. = ( 0g ` W ) $.
    inftm.x $e |- .x. = ( .g ` W ) $.
    inftm.l $e |- .< = ( lt ` W ) $.
    $( Express ` x ` is infinitesimal with respect to ` y ` for a structure
       ` W ` .  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    isinftm $p |- ( ( W e. V /\ X e. B /\ Y e. B ) ->
      ( X ( <<< ` W ) Y <-> ( .0. .< X /\ A. n e. NN ( n .x. X ) .< Y ) ) ) $=
      ( vx vy wcel cfv wbr wa cn vw w3a cinftm cv wral copab wceq elex 3ad2ant1
      co cvv cbs c0g cplt cmg fveq2 syl6eqr eleq2d anbi12d eqidd breq123d oveqd
      ralbidv opabbidv df-inftm cxp fvex eqeltri opabssxp ssexi fvmpt syl breqd
      xpex wb eleq1 bi2anan9 simpl breq2 oveq2d simpr breq12d eqid brabga bitrd
      3adant1 3simpc biantrurd bitr4d ) FEPZGAPZHAPZUBZGHFUCQZRZWKWLSZIGBRZDUDZ
      GCUJZHBRZDTUEZSZSZXBWMWOGHNUDZAPZOUDZAPZSZIXDBRZWRXDCUJZXFBRZDTUEZSZSZNOU
      FZRZXCWMWNXOGHWMFUKPZWNXOUGWJWKXQWLFEUHUIUAFXDUAUDZULQZPZXFXSPZSZXRUMQZXD
      XRUNQZRZWRXDXRUOQZUJZXFYDRZDTUEZSZSZNOUFXOUKUCXRFUGZYKXNNOYLYBXHYJXMYLXTX
      EYAXGYLXSAXDYLXSFULQZAXRFULUPJUQZURYLXSAXFYNURUSYLYEXIYIXLYLYCIXDXDYDBYLY
      CFUMQIXRFUMUPKUQYLYDFUNQBXRFUNUPMUQZYLXDUTVAYLYHXKDTYLYGXJXFXFYDBYLYFCWRX
      DYLYFFUOQCXRFUOUPLUQVBYOYLXFUTVAVCUSUSVDNOUADVEXOAAVFAAAYMUKJFULVGVHZYPVN
      XMNOAAVIVJVKVLVMWKWLXPXCVOWJXNXCNOGHXOAAXDGUGZXFHUGZSZXHWPXMXBYQXEWKYRXGW
      LXDGAVPXFHAVPVQYSXIWQXLXAYSYQXIWQVOYQYRVRZXDGIBVSVLYSXKWTDTYSXJWSXFHBYSXD
      GWRCYTVTYQYRWAWBVCUSUSXOWCWDWFWEWMWPXBWJWKWLWGWHWI $.
  $}

  ${
    $d x y B $.  $d x y w W $.
    isarchi.b $e |- B = ( Base ` W ) $.
    isarchi.0 $e |- .0. = ( 0g ` W ) $.
    isarchi.i $e |- .< = ( <<< ` W ) $.
    $( Express the predicate " ` W ` is Archimedean ".  (Contributed by Thierry
       Arnoux, 30-Jan-2018.) $)
    isarchi $p |- ( W e. V -> ( W e. Archi <-> A. x e. B A. y e. B -. x .< y )
      ) $=
      ( vw wcel carchi cinftm cfv c0 wceq cv wral wb wbr wn elex fveq2 df-archi
      cvv eqeq1d elrab2 baib syl cxp wss inftmrel cop ss0b ssrel2 syl5bbr breqi
      wi noel df-br bitri xchnxbir pm2.21i dfbi2 mpbiran2 2ralbii syl6bbr bitrd
      nbn ) FELZFMLZFNOZPQZARZBRZDUAZUBZBCSACSZVKFUFLZVLVNTFEUCVLVTVNKRZNOZPQVN
      KFUFMWAFQWBVMPWAFNUDUGKUEUHUIUJVKVMCCUKULZVNVSTCEFHUMWCVNVOVPUNZVMLZWDPLZ
      USZBCSACSZVSVNVMPULWCWHVMUOABCCVMPUPUQVRWGABCCVRWEWFTZWGWEWIVQWFWEWDUTZVJ
      VQVOVPVMUAWEVOVPDVMJURVOVPVMVAVBVCWIWGWFWEUSWFWEWJVDWEWFVEVFVBVGVHUJVI $.
  $}

  ${
    $d n A $.
    $( Plus infinity is an infinite for the completed real line, as any real
       number is infinitesimal compared to it.  (Contributed by Thierry Arnoux,
       1-Feb-2018.) $)
    pnfinf $p |- ( A e. RR+ -> A ( <<< ` RR*s ) +oo ) $=
      ( vn crp wcel cpnf cfv wbr cc0 clt co cn wa cr cxr adantr syl2anc eqeltrd
      cxrs syl cvv cinftm cv cmg wral rpgt0 cxmu wceq nnz adantl rpxr xrsmulgzz
      cz zred rpre cmul rexmul remulcl ltpnf ralrimiva jca wb xrsex xrsbas xrs0
      pnfxr eqid xrslt isinftm mp3an13 mpbird ) ACDZAERUAFGZHAIGZBUBZARUCFZJZEI
      GZBKUDZLZVKVMVRAUEVKVQBKVKVNKDZLZVPMDVQWAVPVNAUFJZMWAVNULDZANDZVPWBUGVTWC
      VKVNUHUIZVKWDVTAUJZOVNAUKPWAVNMDZAMDZWBMDWAVNWEUMVKWHVTAUNOWGWHLWBVNAUOJM
      VNAUPVNAUQQPQVPURSUSUTVKWDVLVSVAZWFRTDWDENDWIVBVENIVOBTRAEHVCVDVOVFVGVHVI
      SVJ $.
  $}

  ${
    $d x y $.
    $( The completed real line is not Archimedean.  (Contributed by Thierry
       Arnoux, 1-Feb-2018.) $)
    xrnarchi $p |- -. RR*s e. Archi $=
      ( vx vy cv cxrs cinftm cfv wbr cxr wrex carchi wcel wn c1 1re rexri pnfxr
      cpnf ax-mp wral cvv crp 1rp pnfinf breq1 breq2 mp3an rexnal dfrex2 rexbii
      rspc2ev wb xrsex cc0 xrsbas xrs0 eqid isarchi notbii 3bitr4i mpbi ) ACZBC
      ZDEFZGZBHIZAHIZDJKZLZMHKQHKMQVCGZVFMNOPMUAKVIUBMUCRVDVIMVBVCGABMQHHVAMVBV
      CUDVBQMVCUEUJUFVDLBHSZLZAHIVJAHSZLVFVHVJAHUGVEVKAHVDBHUHUIVGVLDTKVGVLUKUL
      ABHVCTDUMUNUOVCUPUQRURUSUT $.
  $}

  ${
    $d n x y B $.  $d n x y W $.
    isarchi2.b $e |- B = ( Base ` W ) $.
    isarchi2.0 $e |- .0. = ( 0g ` W ) $.
    isarchi2.x $e |- .x. = ( .g ` W ) $.
    isarchi2.l $e |- .<_ = ( le ` W ) $.
    isarchi2.t $e |- .< = ( lt ` W ) $.
    $( Alternative way to express the predicate " ` W ` is Archimedean ", for
       Tosets.  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    isarchi2 $p |- ( ( W e. Toset /\ W e. Grp ) -> ( W e. Archi <->
      A. x e. B A. y e. B ( .0. .< x -> E. n e. NN y .<_ ( n .x. x ) ) ) ) $=
      ( wcel wbr wn wral cn wb ctos cgrp wa carchi cv cinftm co wrex wi isarchi
      cfv eqid adantr w3a simpl1l cz simpl1r simpr simpl2 mulgcl syl3anc simpl3
      tltnle con2bid rexbidva imbi2d isinftm notbid rexnal imbi2i bitr2i syl6bb
      nnzd imnan 3adant1r bitr4d 3expb 2ralbidva ) HUAOZHUBOZUCZHUDOZAUEZBUEZHU
      FUKZPZQZBCRACRZIWCDPZWDFUEZWCEUGZGPZFSUHZUIZBCRACRVSWBWHTVTABCWEUAHIJKWEU
      LUJUMWAWNWGABCCWAWCCOZWDCOZWNWGTWAWOWPUNZWNWIWKWDDPZQZFSUHZUIZWGWQWMWTWIW
      QWLWSFSWQWJSOZUCZVSWKCOZWPWLWSTVSVTWOWPXBUOXCVTWJUPOWOXDVSVTWOWPXBUQXCWJW
      QXBURVMWAWOWPXBUSCEHWJWCJLUTVAWAWOWPXBVBVSXDWPUNWRWLCDHGWKWDJMNVCVDVAVEVF
      VSWOWPWGXATVTVSWOWPUNZWGWIWRFSRZUCZQZXAXEWFXGCDEFUAHWCWDIJKLNVGVHXAWIXFQZ
      UIXHWTXIWIWRFSVIVJWIXFVNVKVLVOVPVQVRVP $.
  $}

  ${
    $d m n x y $.  $d n x y B $.  $d n x y W $.  $d m n .< $.  $d m n .x. $.
    $d n .0. $.
    isarchi3.b $e |- B = ( Base ` W ) $.
    isarchi3.0 $e |- .0. = ( 0g ` W ) $.
    isarchi3.i $e |- .< = ( lt ` W ) $.
    isarchi3.x $e |- .x. = ( .g ` W ) $.
    $( This is the usual definition of the Archimedean property for an ordered
       group.  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    isarchi3 $p |- ( W e. oGrp -> ( W e. Archi <->
      A. x e. B A. y e. B ( .0. .< x -> E. n e. NN y .< ( n .x. x ) ) ) ) $=
      ( wcel wbr co cn syl wa c1 wceq vm cogrp carchi cv cple wrex wi wral ctos
      cfv cgrp comnd isogrp simprbi omndtos simplbi eqid isarchi2 syl2anc nfre1
      nfv nfan caddc simpr adantr peano2nnd cplusg simp-4l grpidcl 3syl simp-4r
      wb cz ad4antr nnzd mulgcl syl3anc simpllr ogrpaddlt syl131anc grplid nncn
      ax-1cn addcom mpan2 oveq1d cmnd grpmnd 1nn a1i mulgnndir syl13anc 3eqtrrd
      cc mulg1 3brtr3d tospos peano2zd plelttr impl mpdan oveq1 breq2d adantllr
      cpo r19.29af cbvrexv sylib pltle reximdva impbida pm5.74da ralbidva bitrd
      rspcev imp ) GUBMZGUCMZHAUDZDNZBUDZFUDZXSEOZGUEUJZNZFPUFZUGZBCUHZACUHZXTY
      AYCDNZFPUFZUGZBCUHZACUHXQGUIMZGUKMZXRYIVLXQGULMZYNXQYOYPGUMZUNGUOQZXQYOYP
      YQUPZABCDEFYDGHIJLYDUQZKURUSXQYHYMACXQXSCMZRZYGYLBCUUBYACMZRZXTYFYKUUDXTR
      ZYFYKUUEYFRZYAUAUDZXSEOZDNZUAPUFZYKUUFYEUUJFPUUEYFFUUEFVAYEFPUTVBUUEYBPMZ
      YEUUJYFUUEUUKRZYERZYBSVCOZPMYAUUNXSEOZDNZUUJUUMYBUULUUKYEUUEUUKVDZVEZVFUU
      MYCUUODNZUUPUUMHYCGVGUJZOZXSYCUUTOZYCUUODUUMXQHCMZUUAYCCMZXTUVAUVBDNUULXQ
      YEXQUUAUUCXTUUKVHZVEZUUMXQYOUVCUVFYSCGHIJVIVJUULUUAYEXQUUAUUCXTUUKVKZVEZU
      ULUVDYEUULYOYBVMMUUAUVDXQYOUUAUUCXTUUKYSVNZUULYBUUQVOZUVGCEGYBXSILVPVQZVE
      ZUUDXTUUKYEVRCUUTDGHXSYCIKUUTUQZVSVTUUMYOUVDUVAYCTUUMXQYOUVFYSQUVLCUUTGYC
      HIUVMJWAUSUUMUUOSYBVCOZXSEOZSXSEOZYCUUTOZUVBUUMUUKUUOUVOTUURUUKUUNUVNXSEU
      UKYBWNMZUUNUVNTZYBWBUVRSWNMUVSWCYBSWDWEQWFQUUMGWGMZSPMZUUKUUAUVOUVQTUUMXQ
      YOUVTUVFYSGWHVJUWAUUMWIWJUURUVHCUUTEGSYBXSILUVMWKWLUUMUVPXSYCUUTUUMUUAUVP
      XSTUVHCEGXSILWOQWFWMWPUULYEUUSUUPUULGXEMZUUCUVDUUOCMZYEUUSRUUPUGUULXQYNUW
      BUVEYRGWQVJUUBUUCXTUUKVRZUVKUULYOUUNVMMUUAUWCUVIUULYBUVJWRUVGCEGUUNXSILVP
      VQCDGYDYAYCUUOIYTKWSWLWTXAUUIUUPUAUUNPUUGUUNTUUHUUOYADUUGUUNXSEXBXCXOUSXD
      UUEYFVDXFUUIYJUAFPUUGYBTUUHYCYADUUGYBXSEXBXCXGXHUUEYKYFUUEYJYEFPUULXQUUCU
      VDYJYEUGUVEUWDUVKUBCCDGYDYAYCYTKXIVQXJXPXKXLXMXMXN $.
  $}

  ${
    $d m x y B $.  $d m x y W $.  $d m n x y X $.  $d m n y Y $.  $d m n ph $.
    $d m n x y .0. $.  $d m n x y .<_ $.  $d m n x y .< $.  $d m n x y .x. $.
    archirng.b $e |- B = ( Base ` W ) $.
    archirng.0 $e |- .0. = ( 0g ` W ) $.
    archirng.i $e |- .< = ( lt ` W ) $.
    archirng.l $e |- .<_ = ( le ` W ) $.
    archirng.x $e |- .x. = ( .g ` W ) $.
    archirng.1 $e |- ( ph -> W e. oGrp ) $.
    archirng.2 $e |- ( ph -> W e. Archi ) $.
    archirng.3 $e |- ( ph -> X e. B ) $.
    archirng.4 $e |- ( ph -> Y e. B ) $.
    archirng.5 $e |- ( ph -> .0. .< X ) $.
    ${
      archirng.6 $e |- ( ph -> .0. .< Y ) $.
      $( Property of Archimedean ordered groups, framing positive ` Y ` between
         multiples of ` X ` .  (Contributed by Thierry Arnoux, 12-Apr-2018.) $)
      archirng $p |- ( ph -> E. n e. NN0 ( ( n .x. X ) .< Y
        /\ Y .<_ ( ( n + 1 ) .x. X ) ) ) $=
        ( vm vx vy cv co wbr c1 caddc wa cn0 wrex wn cc0 wceq oveq1 breq2d ctos
        wcel wb cogrp comnd cgrp isogrp simprbi omndtos 3syl simplbi syl tltnle
        grpidcl syl3anc mpbid mulg0 mtbird cn wral jca carchi isarchi2 syl21anc
        wi biimpa breq2 oveq2 rexbidv imbi12d breq1 imbi2d rspc2v nn0min adantr
        imp cz simpr nn0zd mulgcl anbi1d rexbidva mpbird ) AEUEZHDUFZICUGZIXAUH
        UIUFZHDUFZFUGZUJZEUKULIXBFUGZUMZXFUJZEUKULAIUBUEZHDUFZFUGZIUNHDUFZFUGZX
        HXFEUBXKUNUOXLXNIFXKUNHDUPUQXKXAUOXLXBIFXKXAHDUPUQXKXDUOXLXEIFXKXDHDUPU
        QAXOIJFUGZAJICUGZXPUMZUAAGURUSZJBUSZIBUSZXQXRUTAGVAUSZGVBUSZXSPYBGVCUSZ
        YCGVDZVEGVFVGZAYDXTAYBYDPYBYDYCYEVHVIZBGJKLVKVISBCGFJIKNMVJVLVMAXNJIFAH
        BUSZXNJUORBDGHJKLOVNVIUQVOAYHYAUJZJUCUEZCUGZUDUEZXKYJDUFZFUGZUBVPULZWBZ
        UDBVQUCBVQZJHCUGZXMUBVPULZAYHYARSVRAXSYDGVSUSZYQYFYGQXSYDUJYTYQUCUDBCDU
        BFGJKLONMVTWCWATYIYQUJYRYSYIYQYRYSWBZYPUUAYRYLXLFUGZUBVPULZWBUCUDHIBBYJ
        HUOZYKYRYOUUCYJHJCWDUUDYNUUBUBVPUUDYMXLYLFYJHXKDWEUQWFWGYLIUOZUUCYSYRUU
        EUUBXMUBVPYLIXLFWHWFWIWJWMWMWAWKAXGXJEUKAXAUKUSZUJZXCXIXFUUGXSXBBUSZYAX
        CXIUTAXSUUFYFWLUUGYDXAWNUSYHUUHAYDUUFYGWLUUGXAAUUFWOWPAYHUUFRWLBDGXAHKO
        WQVLAYAUUFSWLBCGFXBIKNMVJVLWRWSWT $.
    $}

    archirngz.1 $e |- ( ph -> ( oppG ` W ) e. oGrp ) $.
    $( Property of Archimedean left and right ordered groups.  (Contributed by
       Thierry Arnoux, 6-May-2018.) $)
    archirngz $p |- ( ph -> E. n e. ZZ ( ( n .x. X ) .< Y
      /\ Y .<_ ( ( n + 1 ) .x. X ) ) ) $=
      ( vm wceq cv co wbr c1 caddc wa wrex cneg wcel 1nn0 nn0negzi cminusg cgrp
      cz cfv cogrp comnd isogrp simplbi syl 1z a1i mulgneg syl3anc mulg1 fveq2d
      eqid eqtrd ogrpinv0lt biimpa syl21anc eqbrtrd adantr breqtrrd cpo simprbi
      simpr ctos omndtos tospos grpidcl posref syl2anc cc0 ax-1cn subidi negeqi
      3syl cmin negsubdii neg0 3eqtr3i oveq1i mulg0 syl5eq 3brtr4d oveq1 breq1d
      jca oveq1d breq2d anbi12d rspcev sylancr cn0 c2 nn0ssz sseldi ad2antrr 2z
      znegcld zsubcld cc nn0cn zcnd negdi2d coppg mulgcl zaddcld addassd oveq2i
      peano2zd 3eqtrrd 3brtr3d w3a ogrpinvlt syl31anc eqbrtrrd ad4antr syl12anc
      addcld eqcomd wb negcld cvv biimpar archirng cplusg grplid syl6eq addcomd
      ogrpaddlt syl131anc mulgdir syl13anc grpinvcl posasymb syl32anc grpinvinv
      1p1e2 eqtr3d simplrr 3eqtr2rd addsubassd 2m1e1 syl6req negsubdid 3anassrs
      negeqd simp-4l adantrr negdi sylancl addid1d 3eqtrd wi ovex pltle wo tlt2
      imp mpjaodan carchi syldan r19.29a wss ssrexv mpsyl w3o tlt3 mpjao3dan )
      AIJUCZEUDZHDUEZICUFZIUWFUGUHUEZHDUEZFUFZUIZEUQUJZIJCUFZJICUFZAUWEUIZUGUKZ
      UQULUWQHDUEZICUFZIUWQUGUHUEZHDUEZFUFZUIZUWMUGUMUNUWPUWSUXBUWPUWRJICAUWRJC
      UFUWEAUWRHGUOURZURZJCAUWRUGHDUEZUXDURZUXEAGUPULZUGUQULZHBULZUWRUXGUCAGUSU
      LZUXHPUXKUXHGUTULZGVAZVBZVCZUXIAVDVERBDGUXDUGHKOUXDVJZVFVGAUXFHUXDAUXJUXF
      HUCZRBDGHKOVHZVCVIVKAUXKUXJJHCUFZUXEJCUFZPRTUXKUXJUIUXSUXTBCGUXDHJKMUXPLV
      LVMVNVOVPAUWEVTZVQUWPJJIUXAFAJJFUFZUWEAGVRULZJBULZUYBAGWAULZUYCAUXKUXLUYE
      PUXKUXHUXLUXMVSGWBWKZGWCZVCZAUXKUXHUYDPUXNBGJKLWDZWKZBGFJKNWEWFVPUYAAUXAJ
      UCUWEAUXAWGHDUEZJUWTWGHDUGUGWLUEZUKWGUKUWTWGUYLWGUGWHWIWJUGUGWHWHWMWNWOZW
      PAUXJUYKJUCRBDGHJKLOWQVCWRVPWSXBUWLUXCEUWQUQUWFUWQUCZUWHUWSUWKUXBUYNUWGUW
      RICUWFUWQHDWTXAUYNUWJUXAIFUYNUWIUWTHDUWFUWQUGUHWTXCXDXEXFXGAUWNUIZUBUDZHD
      UEZIUXDURZCUFZUYRUYPUGUHUEZHDUEZFUFZUIZUWMUBXHUYOUYPXHULZUIZVUCUIZVUAUYRF
      UFZUWMUYRVUACUFZVUFVUGUIZUYPUKZXIWLUEZUQULVUKHDUEZICUFZIVUKUGUHUEZHDUEZFU
      FZUWMVUIVUJXIVUIUYPVUEUYPUQULZVUCVUGVUEXHUQUYPXJUYOVUDVTZXKZXLXNXIUQULZVU
      IXMVEXOVUIVULUYTUKZHDUEZICVUEVULVVBCUFVUCVUGVUEUYPXIUHUEZUKZHDUEZVULVVBCV
      UEVVDVUKHDVUEUYPXIVUEVUDUYPXPULZVURUYPXQZVCZVUEXIVUTVUEXMVEZXRZXSZXCVUEVV
      CHDUEZUXDURZVUAUXDURZVVEVVBCVUEUXKGXTURUSULZUIZVUABULZVVLBULZVUAVVLCUFZVV
      MVVNCUFZVUEUXKVVOUYOUXKVUDAUXKUWNPVPZVPZUYOVVOVUDAVVOUWNUAVPZVPXBZVUEUXHU
      YTUQULZUXJVVQAUXHUWNVUDUXOXLZVUEUYPVUSYEZUYOUXJVUDAUXJUWNRVPZVPZBDGUYTHKO
      YAVGZVUEUXHVVCUQULZUXJVVRVWFVUEUYPXIVUSVVIYBZVWIBDGVVCHKOYAVGVUEJVUAGUUAU
      RZUEZHVUAVWMUEZVUAVVLCVUEUXKUYDUXJVVQUXSVWNVWOCUFVWBVUEUXHUYDVWFUYIVCVWIV
      WJUYOUXSVUDAUXSUWNTVPZVPBVWMCGJHVUAKMVWMVJZUUEUUFVUEUXHVVQVWNVUAUCVWFVWJB
      VWMGVUAJKVWQLUUBWFVUEVVLUGUYTUHUEZHDUEZUXFVUAVWMUEZVWOVUEVUDVVLVWSUCVURVU
      DVVCVWRHDVUDUYTUGUHUEZVVCVWRVUDVXAUYPUGUGUHUEZUHUEVVCVUDUYPUGUGVVGUGXPULZ
      VUDWHVEZVXDYCVXBXIUYPUHUUMYDUUCVUDUYTUGVUDUYPUGVVGVXDYNVXDUUDUUNXCVCVUEUX
      HUXIVWEUXJVWSVWTUCVWFUXIVUEVDVEVWGVWIBVWMDGUGUYTHKOVWQUUGUUHVUEUXFHVUAVWM
      VUEUXJUXQVWIUXRVCXCYFYGVVPVVQVVRYHVVSVVTBCGUXDVUAVVLKMUXPYIVMYJVUEUXHVWKU
      XJVVEVVMUCVWFVWLVWIBDGUXDVVCHKOUXPVFVGVUEUXHVWEUXJVVBVVNUCZVWFVWGVWIBDGUX
      DUYTHKOUXPVFVGZWSYKXLVUIVVBVVNUYRUXDURZIVUEVXEVUCVUGVXFXLVUIUYRVUAUXDVUIU
      YCUYRBULZVVQVUBVUGUYRVUAUCZAUYCUWNVUDVUCVUGUYHYLVUEVXHVUCVUGUYOVXHVUDAVXH
      UWNAUXHIBULZVXHUXOSBGUXDIKUXPUUIWFZVPZVPZXLVUEVVQVUCVUGVWJXLVUEUYSVUBVUGU
      UOVUFVUGVTUYCVXHVVQYHVUBVUGUIVXIBGFUYRVUAKNUUJVMUUKVIAVXGIUCZUWNVUDVUCVUG
      AUXHVXJVXNUXOSBGUXDIKUXPUULWFZYLUUPZVQVUIIVVBVUOFVXPVUEVVBVUOFUFVUCVUGVUE
      VUOVVBVUOFVUEVUNVVAHDVUEVVAVVCUGWLUEZUKVVDUGUHUEVUNVUEUYTVXQVUEVXQUYPXIUG
      WLUEZUHUEUYTVUEUYPXIUGVVHVVJVXCVUEWHVEZUUQVXRUGUYPUHUURYDUUSUVBVUEVVCUGVU
      EUYPXIVVHVVJYNVXSUUTVUEVVDVUKUGUHVVKXCYFXCVUEUYCVUOBULZVUOVUOFUFVUEUYEUYC
      AUYEUWNVUDUYFXLZUYGVCVUEUXHVUNUQULUXJVXTVWFVUEVUKVUEVUJXIVUEUYPVUSXNVVIXO
      YEVWIBDGVUNHKOYAVGBGFVUOKNWEWFYKXLVOUWLVUMVUPUIEVUKUQUWFVUKUCZUWHVUMUWKVU
      PVYBUWGVULICUWFVUKHDWTXAVYBUWJVUOIFVYBUWIVUNHDUWFVUKUGUHWTXCXDXEXFYMVUFVU
      HUIZVVAUQULVVBICUFZIVVAUGUHUEZHDUEZFUFZUWMVYCUYTVUEVWEVUCVUHVWGXLXNVYCVVN
      VXGVVBICVYCVVPVXHVVQVUHVVNVXGCUFZUYOVUDVUCVUHVVPUYOVUDVUCVUHYHZUIUXKVVOUY
      OUXKVYIVWAVPUYOVVOVYIVWCVPXBUVAVUEVXHVUCVUHVXMXLVUEVVQVUCVUHVWJXLVUFVUHVT
      VVPVXHVVQYHVUHVYHBCGUXDUYRVUAKMUXPYIVMYJVYCVVBVVNVUEVXEVUCVUHVXFXLYOAVXNU
      WNVUDVUCVUHVXOYLZYGVYCAIVYFCUFZVYGAUWNVUDVUCVUHUVCVYCVXGUYQUXDURZIVYFCVUF
      VXGVYLCUFZVUHVUEUYSVYMVUBVUEUYSVYMVUEVVPUYQBULZVXHUYSVYMYPVWDVUEUXHVUQUXJ
      VYNVWFVUSVWIBDGUYPHKOYAVGVXMBCGUXDUYQUYRKMUXPYIVGVMUVDVPVYJVYCVYFVYLVUEVY
      FVYLUCVUCVUHVUEVYFVUJHDUEZVYLVUEVUDVYFVYOUCVURVUDVYEVUJHDVUDVYEVUJUWQUHUE
      ZUGUHUEZVUJVUDVVAVYPUGUHVUDVVFVXCVVAVYPUCVVGWHUYPUGUVEUVFXCVUDVYQVUJUWTUH
      UEZVUJWGUHUEZVUJVUDVUJUWQUGVUDUYPVVGYQZVUDUGVXDYQVXDYCVYRVYSUCVUDUWTWGVUJ
      UHUYMYDVEVUDVUJVYTUVGUVHVKXCVCVUEUXHVUQUXJVYOVYLUCVWFVUSVWIBDGUXDUYPHKOUX
      PVFVGVKXLYOYGAVYKVYGAUXKVXJVYFYRULZVYKVYGUVIPSWUAAVYEHDUVJVEUSBYRCGFIVYFN
      MUVKVGUVNWFUWLVYDVYGUIEVVAUQUWFVVAUCZUWHVYDUWKVYGWUBUWGVVBICUWFVVAHDWTXAW
      UBUWJVYFIFWUBUWIVYEHDUWFVVAUGUHWTXCXDXEXFYMVUEVUGVUHUVLZVUCVUEUYEVVQVXHWU
      CVYAVWJVXMBCGFVUAUYRKNMUVMVGVPUVOUYOBCDUBFGHUYRJKLMNOVWAAGUVPULZUWNQVPVWH
      VXLVWPAUWNVXGJCUFZJUYRCUFZAWUEUWNAVXGIJCVXOXAYSAWUFWUEAUXKVXHWUFWUEYPPVXK
      BCGUXDUYRJKMUXPLVLWFYSUVQYTUVRXHUQUVSAUWOUIZUWLEXHUJUWMXJWUGBCDEFGHIJKLMN
      OAUXKUWOPVPAWUDUWOQVPAUXJUWORVPAVXJUWOSVPAUXSUWOTVPAUWOVTYTUWLEXHUQUVTUWA
      AUYEVXJUYDUWEUWNUWOUWBUYFSUYJBCGIJKMUWCVGUWD $.
  $}

  ${
    $d n x y B $.  $d n x y W $.  $d n x y X $.  $d n y Y $.  $d n x y .0. $.
    $d n x y .< $.  $d n x y .x. $.
    archiexdiv.b $e |- B = ( Base ` W ) $.
    archiexdiv.0 $e |- .0. = ( 0g ` W ) $.
    archiexdiv.i $e |- .< = ( lt ` W ) $.
    archiexdiv.x $e |- .x. = ( .g ` W ) $.
    $( In an Archimedean group, given two positive elements, there exists a
       "divisor" ` n ` .  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    archiexdiv $p |- ( ( ( W e. oGrp /\ W e. Archi ) /\ ( X e. B /\ Y e. B )
      /\ .0. .< X ) -> E. n e. NN Y .< ( n .x. X ) ) $=
      ( vx vy wcel wbr cv cn wrex wi cogrp carchi wa w3a co simp3 wral isarchi3
      biimpa 3ad2ant1 breq2 oveq2 breq2d rexbidv imbi12d imbi2d rspc2v 3ad2ant2
      wceq breq1 mpd ) EUAOZEUBOZUCZFAOGAOUCZHFBPZUDZVFGDQZFCUEZBPZDRSZVDVEVFUF
      VGHMQZBPZNQZVHVLCUEZBPZDRSZTZNAUGMAUGZVFVKTZVDVEVSVFVBVCVSMNABCDEHIJKLUHU
      IUJVEVDVSVTTVFVRVTVFVNVIBPZDRSZTMNFGAAVLFUSZVMVFVQWBVLFHBUKWCVPWADRWCVOVI
      VNBVLFVHCULUMUNUOVNGUSZWBVKVFWDWAVJDRVNGVIBUTUNUPUQURVAVA $.
  $}

  ${
    $d a b m n x y z $.  $d m n x y z B $.  $d m n x U $.  $d m n x y z W $.
    $d m n x X $.  $d m n x y z ph $.  $d m n x .x. $.  $d m n x .0. $.
    $d m n x .< $.  $d m x .<_ $.
    archiabllem.b $e |- B = ( Base ` W ) $.
    archiabllem.0 $e |- .0. = ( 0g ` W ) $.
    archiabllem.e $e |- .<_ = ( le ` W ) $.
    archiabllem.t $e |- .< = ( lt ` W ) $.
    archiabllem.m $e |- .x. = ( .g ` W ) $.
    archiabllem.g $e |- ( ph -> W e. oGrp ) $.
    archiabllem.a $e |- ( ph -> W e. Archi ) $.
    ${
      archiabllem1.u $e |- ( ph -> U e. B ) $.
      archiabllem1.p $e |- ( ph -> .0. .< U ) $.
      archiabllem1.s $e |- ( ( ph /\ x e. B /\ .0. .< x ) -> U .<_ x ) $.
      ${
        archiabllem1a.x $e |- ( ph -> X e. B ) $.
        archiabllem1a.c $e |- ( ph -> .0. .< X ) $.
        $( Lemma for ~ archiabl :  In case an archimedean group ` W ` admits a
           smallest positive element ` U ` , then any positive element ` X ` of
           ` W ` can be written as ` ( n .x. U ) ` with ` n e. NN ` .  Since
           the reciprocal holds for negative elements, ` W ` is then isomorphic
           to ` ZZ ` .  (Contributed by Thierry Arnoux, 12-Apr-2018.) $)
        archiabllem1a $p |- ( ph -> E. n e. NN X = ( n .x. U ) ) $=
          ( vm cv co wbr c1 caddc wa wceq cn wrex cn0 simplr cc elnn0nn simprbi
          wcel syl csg cfv cplusg ad2antrr mulg1 oveq1d cgrp cogrp comnd isogrp
          cz simplbi 1z a1i nn0zd eqid mulgdir syl13anc cpo ctos omndtos tospos
          3syl mulgcl syl3anc grpsubcl peano2zd simprr ogrpsub syl131anc nn0cnd
          cmin ax-1cn pncan2d mulgsubdir 3eqtr3d breqtrd wi wral 3expa grpsubid
          ralrimiva syl2anc simprl ogrpsublt eqbrtrrd breq2 imbi12d rspcv syl3c
          ex w3a posasymb biimpa syl32anc 3eqtr4rd grpnpcan addcom oveq1 eqeq2d
          rspcev archirng r19.29a ) AUDUEZFEUFZJDUGZJYDUHUIUFZFEUFZHUGZUJZJGUEZ
          FEUFZUKZGULUMZUDUNAYDUNUSZUJZYJUJZYGULUSZJYHUKZYNYQYOYRAYOYJUOZYOYDUP
          USZYRYDUQURUTYQJYEIVAVBZUFZYEIVCVBZUFZUHYDUIUFZFEUFZJYHYQUHFEUFZYEUUD
          UFZFYEUUDUFUUGUUEYQUUHFYEUUDYQFCUSZUUHFUKAUUJYOYJSVDZCEIFLPVEUTZVFYQI
          VGUSZUHVKUSZYDVKUSZUUJUUGUUIUKYQIVHUSZUUMAUUPYOYJQVDZUUPUUMIVIUSZIVJZ
          VLUTZUUNYQVMVNYQYDYTVOZUUKCUUDEIUHYDFLPUUDVPZVQVRYQUUCFYEUUDYQIVSUSZU
          UCCUSZUUJUUCFHUGZFUUCHUGZUUCFUKZYQUUPUVCUUQUUPUURIVTUSUVCUUPUUMUURUUS
          URIWAIWBWCUTYQUUMJCUSZYECUSZUVDUUTAUVHYOYJUBVDZYQUUMUUOUUJUVIUUTUVAUU
          KCEIYDFLPWDWEZCIUUBJYELUUBVPZWFWEZUUKYQUUCYHYEUUBUFZFHYQUUPUVHYHCUSZU
          VIYIUUCUVNHUGUUQUVJYQUUMYGVKUSZUUJUVOUUTYQYDUVAWGZUUKCEIYGFLPWDWEUVKY
          PYFYIWHCIHUUBJYHYELNUVLWIWJYQYGYDWLUFZFEUFZUUHUVNFYQUVRUHFEYQYDUHYQYD
          YTWKZUHUPUSZYQWMVNZWNVFYQUUMUVPUUOUUJUVSUVNUKUUTUVQUVAUUKCEIYGUUBYDFL
          PUVLWOVRUULWPWQYQUVDKBUEZDUGZFUWCHUGZWRZBCWSZKUUCDUGZUVFUVMAUWGYOYJAU
          WFBCAUWCCUSZUJUWDUWEAUWIUWDUWEUAWTXKXBVDYQYEYEUUBUFZKUUCDYQUUMUVIUWJK
          UKUUTUVKCIUUBYEKLMUVLXAXCYQUUPUVIUVHUVIYFUWJUUCDUGUUQUVKUVJUVKYPYFYIX
          DCDIUUBYEJYELOUVLXEWJXFUWFUWHUVFWRBUUCCUWCUUCUKUWDUWHUWEUVFUWCUUCKDXG
          UWCUUCFHXGXHXIXJUVCUVDUUJXLUVEUVFUJUVGCIHUUCFLNXMXNXOVFXPYQUUMUVHUVIU
          UEJUKUUTUVJUVKCUUDIUUBJYELUVBUVLXQWEYQUUFYGFEYQUWAUUAUUFYGUKUWBUVTUHY
          DXRXCVFWPYMYSGYGULYKYGUKYLYHJYKYGFEXSXTYAXCACDEUDHIFJKLMONPQRSUBTUCYB
          YC $.
      $}

      $( Lemma for ~ archiabl (Contributed by Thierry Arnoux, 13-Apr-2018.) $)
      archiabllem1b $p |- ( ( ph /\ y e. B ) -> E. n e. ZZ y = ( n .x. U ) ) $=
        ( vm cv wcel wa wceq co cz wrex wbr cc0 0z a1i simpr mulg0 syl ad2antrr
        eqtr4d oveq1 eqeq2d rspcev syl2anc w3a cminusg cfv cn cneg nnssz simplr
        sseldi znegcld 3ad2ant1 eqid mulgnegnn fveq2d cgrp cogrp isogrp simplbi
        comnd simp2 3eqtr2rd carchi simp1 syl3an1 grpinvcl cplusg grpidcl simp3
        grpinvinv ogrpaddlt syl131anc grprinv 3brtr3d archiabllem1a r19.29a wss
        grplid 3expa ssrexv mpsyl ctos simprbi omndtos 3syl adantr tlt3 syl3anc
        w3o mpjao3dan ) ACUCZDUDZUEZXKKUFZXKHUCZGFUGZUFZHUHUIZXKKEUJZKXKEUJZXMX
        NUEZUKUHUDZXKUKGFUGZUFZXRYBYAULUMYAXKKYCXMXNUNAYCKUFZXLXNAGDUDZYESDFJGK
        LMPUOUPUQURXQYDHUKUHXOUKUFXPYCXKXOUKGFUSUTVAVBAXLXSXRAXLXSVCZXKJVDVEZVE
        ZUBUCZGFUGZUFZXRUBVFYGYJVFUDZUEZYLUEZYJVGZUHUDXKYPGFUGZUFZXRYOYJYOVFUHY
        JVHYGYMYLVIZVJVKYOYQYKYHVEZYIYHVEZXKYOYMYFYQYTUFYSYGYFYMYLAXLYFXSSVLZUQ
        DFJYHYJGLPYHVMZVNVBYOYIYKYHYNYLUNVOYGUUAXKUFZYMYLYGJVPUDZXLUUDYGJVQUDZU
        UEAXLUUFXSQVLZUUFUUEJVTUDZJVRZVSZUPZAXLXSWAZDJYHXKLUUCWJVBUQWBXQYRHYPUH
        XOYPUFXPYQXKXOYPGFUSUTVAVBYGBDEFGUBIJYIKLMNOPUUGAXLJWCUDZXSRVLUUBAXLKGE
        UJZXSTVLYGABUCZDUDZKUUOEUJZGUUOIUJZAXLXSWDUAWEYGUUEXLYIDUDZUUKUULDJYHXK
        LUUCWFVBZYGXKYIJWGVEZUGZKYIUVAUGZKYIEYGUUFXLKDUDZUUSXSUVBUVCEUJUUGUULYG
        UUEUVDUUKDJKLMWHZUPUUTAXLXSWIDUVAEJXKKYILOUVAVMZWKWLYGUUEXLUVBKUFUUKUUL
        DUVAJYHXKKLUVFMUUCWMVBYGUUEUUSUVCYIUFUUKUUTDUVAJYIKLUVFMWRVBWNWOWPWSVFU
        HWQXMXTUEXQHVFUIZXRVHAXLXTUVGAXLXTVCZBDEFGHIJXKKLMNOPAXLUUFXTQVLAXLUUMX
        TRVLAXLYFXTSVLAXLUUNXTTVLUVHAUUPUUQUURAXLXTWDUAWEAXLXTWAAXLXTWIWOWSXQHV
        FUHWTXAXMJXBUDZXLUVDXNXSXTXIAUVIXLAUUFUUHUVIQUUFUUEUUHUUIXCJXDXEXFAXLUN
        AUVDXLAUUFUUEUVDQUUJUVEXEXFDEJXKKLOXGXHXJ $.

      $( Archimedean ordered groups with a minimal positive value are abelian.
         (Contributed by Thierry Arnoux, 13-Apr-2018.) $)
      archiabllem1 $p |- ( ph -> W e. Abel ) $=
        ( co vy vz vm vn cgrp wcel cv cplusg wceq wral cabel cogrp comnd isogrp
        cfv simplbi syl wa caddc simplr zcnd simpr addcomd oveq1d ad2antrr eqid
        cz mulgdir syl13anc 3eqtr3d adantlr adantr simpllr oveq12d 3eqtr4d wrex
        adantllr simplll simpr1r 3anassrs archiabllem1b syl2anc r19.29a adantrr
        ralrimivva isabl2 sylanbrc ) AHUEUFZUAUGZUBUGZHUHUOZTZWJWIWKTZUIZUBCUJU
        ACUJHUKUFAHULUFZWHOWOWHHUMUFHUNUPUQZAWNUAUBCCAWICUFZWJCUFZURZURZWIUCUGZ
        FETZUIZWNUCVGWTXAVGUFZURZXCURZWJUDUGZFETZUIZWNUDVGXFXGVGUFZURZXIURZXBXH
        WKTZXHXBWKTZWLWMXKXMXNUIZXIXEXJXOXCAXDXJXOWSAXDURZXJURZXAXGUSTZFETZXGXA
        USTZFETZXMXNXQXRXTFEXQXAXGXQXAAXDXJUTZVAXQXGXPXJVBZVAVCVDXQWHXDXJFCUFZX
        SXMUIAWHXDXJWPVEZYBYCAYDXDXJQVEZCWKEHXAXGFJNWKVFZVHVIXQWHXJXDYDYAXNUIYE
        YCYBYFCWKEHXGXAFJNYGVHVIVJVQVKVLXLWIXBWJXHWKXEXCXJXIVMZXKXIVBZVNXLWJXHW
        IXBWKYIYHVNVOXFAWRXIUDVGVPAWSXDXCVRAWSXDXCWRWQWRXDXCAVSVTABUBCDEFUDGHIJ
        KLMNOPQRSWAWBWCAWQXCUCVGVPWRABUACDEFUCGHIJKLMNOPQRSWAWDWCWEUAUBCWKHJYGW
        FWG $.
    $}

    ${
      $d m n t $.  $d a b c t B $.  $d a b c t W $.  $d a b c t X $.
      $d a b m n t Y $.  $d a b t ph $.  $d a b c t m n .+ $.
      $d a b c t m n .<_ $.  $d a b c t m n .< $.  $d a b c t .0. $.
      archiabllem2.1 $e |- .+ = ( +g ` W ) $.
      archiabllem2.2 $e |- ( ph -> ( oppG ` W ) e. oGrp ) $.
      archiabllem2.3 $e |- ( ( ph /\ a e. B /\ .0. .< a )
                                       -> E. b e. B ( .0. .< b /\ b .< a ) ) $.
      ${
        archiabllem2a.4 $e |- ( ph -> X e. B ) $.
        archiabllem2a.5 $e |- ( ph -> .0. .< X ) $.
        $( Lemma for ~ archiabl , which requires the group to be both left- and
           right-ordered.  (Contributed by Thierry Arnoux, 13-Apr-2018.) $)
        archiabllem2a $p |- ( ph
          -> E. c e. B ( .0. .< c /\ ( c .+ c ) .<_ X ) ) $=
          ( cv wbr wa wrex wcel simpllr simplrl simpr wceq breq2 oveq12d breq1d
          co id anbi12d rspcev syl12anc csg cfv cgrp cogrp simplll comnd isogrp
          simplbi 3syl eqid grpsubcl syl3anc grpsubid syl2anc simplrr ogrpsublt
          syl syl131anc eqbrtrrd coppg cplusg cplt grpaddsubass syl13anc oveq2d
          grpcl grprid 3eqtrd breqtrd oppglt breqd mpbid oppgbas mpbird 3brtr3g
          ogrpaddlt oppgplus grpnpcan cvv wi ovex a1i pltle mpd jca wo ad2antrr
          ctos simprbi omndtos simplr tlt2 wral 3expia ralrimiva anbi2d rexbidv
          mpjaodan imbi12d rspcv syl3c r19.29a ) AIKUEZDUFZYDHDUFZUGZILUEZDUFZY
          HYHCUQZHFUFZUGZLBUHZKBAYDBUIZUGZYGUGZYDYDCUQZHFUFZYMHYQDUFZYPYRUGYNYE
          YRYMAYNYGYRUJYOYEYFYRUKYPYRULYLYEYRUGLYDBYHYDUMZYIYEYKYRYHYDIDUNYTYJY
          QHFYTYHYDYHYDCYTURZUUAUOUPUSUTVAYPYSUGZHYDGVBVCZUQZBUIZIUUDDUFZUUDUUD
          CUQZHFUFZUGZYMUUBGVDUIZHBUIZYNUUEUUBAGVEUIZUUJAYNYGYSVFZRUULUUJGVGUIZ
          GVHZVIZVJZUUBAUUKUUMUCVRZAYNYGYSUJZBGUUCHYDMUUCVKZVLVMZUUBUUFUUHUUBYD
          YDUUCUQZIUUDDUUBUUJYNUVBIUMUUQUUSBGUUCYDIMNUUTVNVOZUUBUULYNUUKYNYFUVB
          UUDDUFUUBAUULUUMRVRZUUSUURUUSYOYEYFYSVPBDGUUCYDHYDMPUUTVQVSVTUUBUUGHD
          UFZUUHUUBUUGUUDYDCUQZHDUUBUUDUUDGWAVCZWBVCZUQZYDUUDUVHUQZUUGUVFDUUBUV
          IUVJDUFUVIUVJUVGWCVCZUFZUUBUVGVEUIZUUEYNUUEUUDYDUVKUFZUVLUUBAUVMUUMUA
          VRUVAUUSUVAUUBUUDYDDUFUVNUUBUUDYQYDUUCUQZYDDUUBUULUUKYQBUIZYNYSUUDUVO
          DUFUVDUURUUBUUJYNYNUVPUUQUUSUUSBCGYDYDMTWGZVMUUSYPYSULBDGUUCHYQYDMPUU
          TVQVSUUBUVOYDUVBCUQZYDICUQZYDUUBUUJYNYNYNUVOUVRUMUUQUUSUUSUUSBCGUUCYD
          YDYDMTUUTWDWEUUBUVBIYDCUVCWFUUBUUJYNUVSYDUMUUQUUSBCGYDIMTNWHVOWIWJUUB
          DUVKUUDYDUUBUUJDUVKUMUUQGDUVGVDUVGVKZPWKVRZWLWMBUVHUVKUVGUUDYDUUDBGUV
          GUVTMWNUVKVKUVHVKZWQVSUUBDUVKUVIUVJUWAWLWOCUVHGUVGUUDUUDTUVTUWBWRCUVH
          GUVGYDUUDTUVTUWBWRWPUUBUUJUUKYNUVFHUMUUQUURUUSBCGUUCHYDMTUUTWSVMWJUUB
          UUJUUGWTUIZUUKUVEUUHXAUUQUWCUUBUUDUUDCXBXCUURVDWTBDGFUUGHOPXDVMXEXFYL
          UUILUUDBYHUUDUMZYIUUFYKUUHYHUUDIDUNUWDYJUUGHFUWDYHUUDYHUUDCUWDURZUWEU
          OUPUSUTVOYPGXIUIZUVPUUKYRYSXGYPUULUUNUWFAUULYNYGRXHZUULUUJUUNUUOXJGXK
          VJYPUUJYNYNUVPYPUULUUJUWGUUPVRAYNYGXLZUWHUVQVMAUUKYNYGUCXHBDGFYQHMOPX
          MVMXSAUUKIJUEZDUFZYEYDUWIDUFZUGZKBUHZXAZJBXNIHDUFZYGKBUHZUCAUWNJBAUWI
          BUIUWJUWMUBXOXPUDUWNUWOUWPXAJHBUWIHUMZUWJUWOUWMUWPUWIHIDUNUWQUWLYGKBU
          WQUWKYFYEUWIHYDDUNXQXRXTYAYBYC $.
      $}

      ${
        archiabllem2b.4 $e |- ( ph -> X e. B ) $.
        archiabllem2b.5 $e |- ( ph -> Y e. B ) $.
        $( Lemma for ~ archiabl (Contributed by Thierry Arnoux, 1-May-2018.) $)
        archiabllem2c $p |- ( ph -> -. ( X .+ Y ) .< ( Y .+ X ) ) $=
          ( vt vn vm co wbr wa cv csg cfv wfal wcel simprr wn w3a c1 caddc cneg
          cz cminusg cogrp simpl1l syl simpl1r cgrp adantr comnd isogrp simplbi
          grpcl syl3anc syl2anc 3syl simpr2 1z a1i simp2 mulgcl simpr1 3ad2ant1
          zaddcld simprbi simpr3 simprd coppg omndadd2rd eqid ogrpsub syl131anc
          simpld c2 zcnd add4d wceq 1p1e2 oveq2i addcom oveq1d syl5eq 2cn simpr
          cc simpl addcld addcomd eqtr4d eqtr3d 2z mulgdir syl13anc eqtrd mulg2
          3eqtr3d breqtrd eqeltrrd grpsubval grpinvcl ogrpaddlt ogrpaddltrd cpo
          znegcld wi ctos omndtos tospos plttr mp2and eqbrtrd eqeltrd ogrpinvlt
          wb jca mpbid mulgneg cc0 wrex archirngz breqtrrd plelttr grpass negid
          grpsubcl oveq2d grprid 3anassrs carchi reeanv sylibr r19.29_2a tltnle
          mulg0 simp3 adantrr pm2.21dd 3adant1r grpsubid eqbrtrrd archiabllem2a
          3expa ogrpsublt r19.29a inegd ) AHICUHZIHCUHZDUIZAUVHUJZJUEUKZDUIZUVJ
          UVJCUHZUVGUVFGULUMZUHZFUIZUJZUNUEBUVIUVJBUOZUJZUVPUJUVOUNUVRUVKUVOUPU
          VRUVKUVOUQZUVOUVIUVQUVKUVSUVIUVQUVKURZUVNUVLDUIZUVSUVTUFUKZUVJEUHZHDU
          IZHUWBUSUTUHZUVJEUHZFUIZUJZUGUKZUVJEUHZIDUIZIUWIUSUTUHZUVJEUHZFUIZUJZ
          UJZUWAUFUGVBVBUVTUWBVBUOZUWIVBUOZUWPUWAUVTUWQUWRUWPURZUJZUVNUVLUWBUWI
          UTUHZUVJEUHZCUHZUXAVAZUVJEUHZCUHZUVLDUWTUVNUXCUVFGVCUMZUMZCUHZFUIZUXI
          UXFDUIZUVNUXFDUIZUWTUVNUXCUVFUVMUHZUXIFUWTUVNUWMUWFCUHZUVFUVMUHZUXMFU
          WTGVDUOZUVGBUOZUXNBUOZUVFBUOZUVGUXNFUIUVNUXOFUIUWTAUXPAUVHUVQUVKUWSVE
          ZRVFZUWTAUVHUXQUXTAUVHUVQUVKUWSVGUVIGVHUOZIBUOZHBUOZUXQUVIUXPUYBAUXPU
          VHRVIZUXPUYBGVJUOZGVKZVLZVFZAUYCUVHUDVIZAUYDUVHUCVIZBCGIHMTVMVNZVOZUW
          TUYBUWMBUOZUWFBUOZUXRUWTUXPUYBUYAUYHVFZUWTUYBUWLVBUOZUVQUYNUWTAUXPUYB
          UXTRUYHVPZUWTUWIUSUVTUWQUWRUWPVQZUSVBUOUWTVRVSZWDZUVTUVQUWSUVIUVQUVKV
          TZVIZBEGUWLUVJMQWAVNZUWTUYBUWEVBUOZUVQUYOUYRUWTUWBUSUVTUWQUWRUWPWBZUY
          TWDZVUCBEGUWEUVJMQWAVNZBCGUWMUWFMTVMVNZUWTUYBUYDUYCUXSUYPUVTUYDUWSUVI
          UVQUYDUVKUYKWCZVIZUVTUYCUWSUVIUVQUYCUVKUYJWCZVIZBCGHIMTVMZVNZUWTBCFGU
          WFIHUWMMOTUWTAUXPUYFUXTRUXPUYBUYFUYGWEZVPZVUHVUMVUKVUDUWTUWKUWNUWTUWH
          UWOUVTUWQUWRUWPWFZWGZWGUWTUWDUWGUWTUWHUWOVURWMZWGUWTAGWHUMZVDUOZVVAVJ
          UOZUXTUAVVBVVAVHUOVVCVVAVKWEVPWIBGFUVMUVGUXNUVFMOUVMWJZWKWLUWTUXNUXCU
          VFUVMUWTUWLUWEUTUHZUVJEUHZWNUVJEUHZUXBCUHZUXNUXCUWTVVFWNUXAUTUHZUVJEU
          HZVVHUWTVVEVVIUVJEUWTUWIUWBUTUHZUSUSUTUHZUTUHZVVEVVIUWTUWIUWBUSUSUWTU
          WIUYSWOZUWTUWBVUFWOZUWTUSUYTWOZVVPWPUWTUWIXEUOZUWBXEUOZVVMVVIWQVVNVVO
          VVQVVRUJZVVMUXAWNUTUHZVVIVVSVVMVVKWNUTUHVVTVVLWNVVKUTWRWSVVSVVKUXAWNU
          TUWIUWBWTXAXBVVSWNUXAWNXEUOVVSXCVSVVSUWBUWIVVQVVRXDVVQVVRXFXGXHXIVOXJ
          XAUWTUYBWNVBUOZUXAVBUOZUVQVVJVVHWQUYPVWAUWTXKVSUWTUWBUWIVUFUYSWDZVUCB
          CEGWNUXAUVJMQTXLXMXNUWTUYBUYQVUEUVQVVFUXNWQUYPVUAVUGVUCBCEGUWLUWEUVJM
          QTXLXMUWTVVGUVLUXBCUWTUVQVVGUVLWQVUCBCEGUVJMQTXOVFXAXPZXAXQUWTUXCBUOZ
          UXSUXMUXIWQUWTUXNUXCBVWDVUIXRZVUOBCGUXGUVMUXCUVFMTUXGWJZVVDXSVOXQUWTB
          CDGVDUXHUXEUXCMPTUYAUWTAVVBUXTUAVFZUWTUYBUXSUXHBUOZUYPVUOBGUXGUVFMVWG
          XTVOZUWTUYBUXDVBUOZUVQUXEBUOZUYPUWTUXAVWCYDZVUCBEGUXDUVJMQWAVNZVWFUWT
          UXHUXBUXGUMZUXEDUWTUXBUVFDUIZUXHVWODUIZUWTUXBUWCUWJCUHZUVFDUWTUYBUWQU
          WRUVQUXBVWRWQUYPVUFUYSVUCBCEGUWBUWIUVJMQTXLXMZUWTVWRHUWJCUHZDUIZVWTUV
          FDUIZVWRUVFDUIZUWTUXPUWCBUOZUYDUWJBUOZUWDVXAUYAUWTUYBUWQUVQVXDUYPVUFV
          UCBEGUWBUVJMQWAVNZVUKUWTUYBUWRUVQVXEUYPUYSVUCBEGUWIUVJMQWAVNZUWTUWDUW
          GVUTWMBCDGUWCHUWJMPTYAWLUWTBCDGVDUWJIHMPTUYAVWHVXGVUMVUKUWTUWKUWNVUSW
          MYBUWTGYCUOZVWRBUOZVWTBUOZUXSVXAVXBUJVXCYEUWTUYFGYFUOZVXHVUQGYGZGYHVP
          ZUWTUYBVXDVXEVXIUYPVXFVXGBCGUWCUWJMTVMVNZUWTUYBUYDVXEVXJUYPVUKVXGBCGH
          UWJMTVMVNVUOBDGVWRVWTUVFMPYIXMYJYKUWTUXPVVBUJUXBBUOZUXSVWPVWQYNUWTUXP
          VVBUYAVWHYOUWTUXBVWRBVWSVXNYLZVUOBDGUXGUXBUVFMPVWGYMVNYPUWTUYBVWBUVQU
          XEVWOWQUYPVWCVUCBEGUXGUXAUVJMQVWGYQVNUUAYBUWTVXHUVNBUOZUXIBUOZUXFBUOZ
          UXJUXKUJUXLYEVXMUWTUYBUXQUXSVXQUYPUYMVUOBGUVMUVGUVFMVVDUUEZVNUWTUYBVW
          EVWIVXRUYPVWFVWJBCGUXCUXHMTVMVNUWTUYBVWEVWLVXSUYPVWFVWNBCGUXCUXEMTVMV
          NBDGFUVNUXIUXFMOPUUBXMYJUWTUXFUVLUXBUXECUHZCUHZUVLUWTUYBUVLBUOZVXOVWL
          UXFVYBWQUYPUWTUYBUVQUVQVYCUYPVUCVUCBCGUVJUVJMTVMZVNZVXPVWNBCGUVLUXBUX
          EMTUUCXMUWTVYBUVLJCUHZUVLUWTVYAJUVLCUWTUXAUXDUTUHZUVJEUHZYRUVJEUHZVYA
          JUWTVYGYRUVJEUWTUXAXEUOVYGYRWQUWTUWBUWIVVOVVNXGUXAUUDVFXAUWTUYBVWBVWK
          UVQVYHVYAWQUYPVWCVWMVUCBCEGUXAUXDUVJMQTXLXMUWTUVQVYIJWQVUCBEGUVJJMNQU
          UNVFXPUUFUWTUYBVYCVYFUVLWQUYPVYEBCGUVLJMTNUUGVOXNXNXQUUHUVTUWHUFVBYSZ
          UWOUGVBYSZUJUWPUGVBYSUFVBYSUVTVYJVYKUVTBDEUFFGUVJHJMNPOQUVIUVQUXPUVKU
          YEWCZUVIUVQGUUIUOZUVKAVYMUVHSVIZWCZVUBVUJUVIUVQUVKUUOZUVIUVQVVBUVKAVV
          BUVHUAVIZWCZYTUVTBDEUGFGUVJIJMNPOQVYLVYOVUBVULVYPVYRYTYOUWHUWOUFUGVBV
          BUUJUUKUULUVTVXKVXQVYCUWAUVSYNUVTUXPUYFVXKVYLVUPVXLVPUVIUVQVXQUVKUVIU
          YBUXQUXSVXQUYIUYLUVIUYBUYDUYCUXSUYIUYKUYJVUNVNZVXTVNZWCUVTUYBUVQUVQVY
          CUVTUXPUYBVYLUYHVFVUBVUBVYDVNBDGFUVNUVLMOPUUMVNYPUVBUUPUUQUVIBCDEFGUV
          NJKLUEMNOPQUYEVYNTVYQAKUKZBUOJWUADUIJLUKZDUIWUBWUADUIUJLBYSUVHUBUURVY
          TUVIUVFUVFUVMUHZJUVNDUVIUYBUXSWUCJWQUYIVYSBGUVMUVFJMNVVDUUSVOUVIUXPUX
          SUXQUXSUVHWUCUVNDUIUYEVYSUYLVYSAUVHXDBDGUVMUVFUVGUVFMPVVDUVCWLUUTUVAU
          VDUVE $.

        $( Lemma for ~ archiabl (Contributed by Thierry Arnoux, 1-May-2018.) $)
        archiabllem2b $p |- ( ph -> ( X .+ Y ) = ( Y .+ X ) ) $=
          ( co wceq wbr archiabllem2c cminusg cfv cgrp wcel cogrp comnd simplbi
          isogrp syl eqid grpinvcl syl2anc coppg wa jca grpcl syl3anc ogrpinvlt
          grpinvadd breq12d bitrd mtbird ctos w3o simprbi omndtos 3syl ecase23d
          wb tlt3 ) AHICUEZIHCUEZUFZVSVTDUGZVTVSDUGZABCDEFGHIJKLMNOPQRSTUAUBUCU
          DUHAWCIGUIUJZUJZHWDUJZCUEZWFWECUEZDUGZABCDEFGWEWFJKLMNOPQRSTUAUBAGUKU
          LZIBULZWEBULAGUMULZWJRWLWJGUNULZGUPZUOUQZUDBGWDIMWDURZUSUTAWJHBULZWFB
          ULWOUCBGWDHMWPUSUTUHAWCVSWDUJZVTWDUJZDUGZWIAWLGVAUJUMULZVBVTBULZVSBUL
          ZWCWTVQAWLXARUAVCAWJWKWQXBWOUDUCBCGIHMTVDVEZAWJWQWKXCWOUCUDBCGHIMTVDV
          EZBDGWDVTVSMPWPVFVEAWRWGWSWHDAWJWQWKWRWGUFWOUCUDBCGWDHIMTWPVGVEAWJWKW
          QWSWHUFWOUDUCBCGWDIHMTWPVGVEVHVIVJAGVKULZXCXBWAWBWCVLAWLWMXFRWLWJWMWN
          VMGVNVOXEXDBDGVSVTMPVRVEVP $.
      $}

      $( Archimedean ordered groups with no minimal positive value are
         abelian.  (Contributed by Thierry Arnoux, 1-May-2018.) $)
      archiabllem2 $p |- ( ph -> W e. Abel ) $=
        ( vx vy cgrp wcel cv wceq wral cabel cogrp comnd isogrp simplbi syl w3a
        co 3ad2ant1 carchi coppg cfv wbr wrex simp1 syl3an1 simp2 archiabllem2b
        wa simp3 3expb ralrimivva isabl2 sylanbrc ) AGUCUDZUAUEZUBUEZCUOVNVMCUO
        UFZUBBUGUABUGGUHUDAGUIUDZVLPVPVLGUJUDGUKULUMAVOUAUBBBAVMBUDZVNBUDZVOAVQ
        VRUNZBCDEFGVMVNHIJKLMNOAVQVPVRPUPAVQGUQUDVRQUPRAVQGURUSUIUDVRSUPVSAIUEZ
        BUDHVTDUTHJUEZDUTWAVTDUTVFJBVAAVQVRVBTVCAVQVRVDAVQVRVGVEVHVIUAUBBCGKRVJ
        VK $.
    $}
  $}

  ${
    $d u v x y W $.
    $( Archimedean left- and right- ordered groups are Abelian.  (Contributed
       by Thierry Arnoux, 1-May-2018.) $)
    archiabl $p |- ( ( W e. oGrp /\ ( oppG ` W ) e. oGrp /\ W e. Archi )
      -> W e. Abel ) $=
      ( vu vx vv vy cogrp wcel cfv w3a cv wi wral wa wrex eqid simp2 wceq breq2
      wbr wn coppg carchi c0g cplt cple cbs cabel simpll1 simpll3 simplr simprl
      cmg simp1rr simp3 imbi12d rspcv imp syl21anc archiabllem1 adantllr imbi2d
      ralbidv anbi12d cbvrexv r19.29a cplusg simpl1 simpl3 simpl2 ralnex sylibr
      simpr breq1 sylib annim rexbii rexnal imbi2i ralbii notbid anbi2d rexbidv
      bitri imnan cbvralv r19.21bi syl6ib 3impia ctos wb 3ad2ant1 comnd simprbi
      cgrp isogrp omndtos syl tltnle bicomd 3com23 3expa rexbidva syl2anc mpbid
      archiabllem2 pm2.61dan ) AFGZAUAHFGZAUBGZIZAUCHZBJZAUDHZSZXKCJZXMSZXLXOAU
      EHZSZKZCAUFHZLZMZBXTNZAUGGZXJYCMZXKDJZXMSZXPYFXOXQSZKZCXTLZMZYDDXTXJYFXTG
      ZYKYDYCXJYLMZYKMZEXTXMAULHZYFXQAXKXTOZXKOZXQOZXMOZYOOZXGXHXIYLYKUHXGXHXIY
      LYKUIXJYLYKUJYMYGYJUKYNEJZXTGZXKUUAXMSZIUUBYJUUCYFUUAXQSZYNUUBUUCPYGYJYMU
      UBUUCUMYNUUBUUCUNUUBYJMUUCUUDUUBYJUUCUUDKZYIUUECUUAXTXOUUAQZXPUUCYHUUDXOU
      UAXKXMRZXOUUAYFXQRZUOUPUQUQURUSUTYEYCYKDXTNXJYCVLYBYKBDXTXLYFQZXNYGYAYJXL
      YFXKXMRZUUIXSYICXTUUIXRYHXPXLYFXOXQVMZVAVBVCVDVNVEXJYCTZMZXTAVFHZXMYOXQAX
      KDEYPYQYRYSYTXGXHXIUULVGZXGXHXIUULVHUUNOXGXHXIUULVIUUMYLYGIZUUCUUDTZMZEXT
      NZUUCUUAYFXMSZMZEXTNZUUMYLYGUUSUUMYLMYGXPYHTZMZCXTNZUUSUUMYGUVEKZDXTUUMXN
      XPXRTZMZCXTNZKZBXTLZUVFDXTLUUMYBTZBXTLZUVKUUMUULUVMXJUULVLYBBXTVJVKUVJUVL
      BXTUVJXNYATZKUVLUVIUVNXNUVIXSTZCXTNUVNUVHUVOCXTXPXRVOVPXSCXTVQWCVRXNYAWDW
      CVSVKUVJUVFBDXTUUIXNYGUVIUVEUUJUUIUVHUVDCXTUUIUVGUVCXPUUIXRYHUUKVTWAWBUOW
      EVNWFUVDUURCEXTUUFXPUUCUVCUUQUUGUUFYHUUDUUHVTVCVDWGWHUUPAWIGZYLUUSUVBWJUU
      PXGUVPUUMYLXGYGUUOWKXGAWLGZUVPXGAWNGUVQAWOWMAWPWQWQUUMYLYGPUVPYLMZUURUVAE
      XTUVRUUBMUUQUUTUUCUVPYLUUBUUQUUTWJZUVPUUBYLUVSUVPUUBYLIUUTUUQXTXMAXQUUAYF
      YPYRYSWRWSWTXAWAXBXCXDXEXF $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Semirings
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c SRing $.

  $( Extend class notation with the class of all semirings. $)
  csrg $a class SRing $.

  ${
    $d f n p r t x y z $.
    $( Define class of all semirings.  A semiring is a set equipped with two
       everywhere-defined internal operations, whose first one is an additive
       commutative monoid structure and the second one is a multiplicative
       monoid structure, and where the addition is left- and right-distributive
       for the multiplication.  Compared to the definition of a ring, this
       definition also adds that the additive identity is an absorbing element
       of the multiplivative law, as this cannot be deduced from the
       distributivity alone.  Definition of [Golan] p. 1.  (Contributed by
       Thierry Arnoux, 21-Mar-2018.) $)
    df-srg $a |- SRing = { f e. CMnd | ( ( mulGrp ` f ) e. Mnd /\
        [. ( Base ` f ) / r ]. [. ( +g ` f ) / p ]. [. ( .r ` f ) / t ].
        [. ( 0g ` f ) / n ]. A. x e. r ( A. y e. r A. z e. r
           ( ( x t ( y p z ) ) = ( ( x t y ) p ( x t z ) )
            /\ ( ( x p y ) t z ) = ( ( x t z ) p ( y t z ) ) )
            /\ ( ( n t x ) = n /\ ( x t n ) = n ) ) ) } $.
  $}

  ${
    $d b n p r t x y z .+ $.  $d b n p r t x y z .0. $.  $d r G $.
    $d b n p r t x y z .x. $.  $d b n p r t x y z B $.  $d b n p r t x y z R $.
    issrg.b $e |- B = ( Base ` R ) $.
    issrg.g $e |- G = ( mulGrp ` R ) $.
    issrg.p $e |- .+ = ( +g ` R ) $.
    issrg.t $e |- .x. = ( .r ` R ) $.
    issrg.0 $e |- .0. = ( 0g ` R ) $.
    $( The predicate "is a semiring."  (Contributed by Thierry Arnoux,
       21-Mar-2018.) $)
    issrg $p |- ( R e. SRing <-> ( R e. CMnd /\ G e. Mnd
      /\ A. x e. B ( A. y e. B A. z e. B
       ( ( x .x. ( y .+ z ) ) = ( ( x .x. y ) .+ ( x .x. z ) )
      /\ ( ( x .+ y ) .x. z ) = ( ( x .x. z ) .+ ( y .x. z ) ) )
      /\ ( ( .0. .x. x ) = .0. /\ ( x .x. .0. ) = .0. ) ) ) ) $=
      ( wcel cfv co wceq wa cvv vp vt vb vn vr ccmn cmgp cmnd cv wral wsbc csrg
      w3a eleq1i bicomi cbs eqeltri cplusg a1i cmulr c0g simplll simplr simpllr
      eqidd oveqd oveq123d eqeq12d anbi12d raleqbidv simpr sbcied sbcie anbi12i
      anbi2i fveq2 eleq1d syl6eqr biidd sbceqbid df-srg elrab2 3anass 3bitr4i
      fvex ) FUFOZFUGPZUHOZAUIZBUIZCUIZUAUIZQZUBUIZQZWIWJWNQZWIWKWNQZWLQZRZWIWJ
      WLQZWKWNQZWQWJWKWNQZWLQZRZSZCUCUIZUJZBXFUJZUDUIZWIWNQZXIRZWIXIWNQZXIRZSZS
      ZAXFUJZUDIUKZUBGUKZUAEUKZUCDUKZSZSWFHUHOZWIWJWKEQZGQZWIWJGQZWIWKGQZEQZRZW
      IWJEQZWKGQZYFWJWKGQZEQZRZSZCDUJZBDUJZIWIGQZIRZWIIGQZIRZSZSZADUJZSZSFULOWF
      YBUUCUMYAUUDWFWHYBXTUUCYBWHHWGUHKUNUOXSUUCUCDDFUPPZTJFUPWEUQXFDRZXRUUCUAE
      TETOUUFEFURPZTLFURWEUQUSUUFWLERZSZXQUUCUBGTGTOUUIGFUTPZTMFUTWEUQUSUUIWNGR
      ZSZXPUUCUDITITOUULIFVAPZTNFVAWEUQUSUULXIIRZSZXOUUBAXFDUUFUUHUUKUUNVBZUUOX
      HYPXNUUAUUOXGYOBXFDUUPUUOXEYNCXFDUUPUUOWSYHXDYMUUOWOYDWRYGUUOWIWIWMYCWNGU
      UIUUKUUNVCZUUOWIVEZUUOWLEWJWKUUFUUHUUKUUNVDZVFVGUUOWPYEWQYFWLEUUSUUOWNGWI
      WJUUQVFUUOWNGWIWKUUQVFZVGVHUUOXAYJXCYLUUOWTYIWKWKWNGUUQUUOWLEWIWJUUSVFUUO
      WKVEVGUUOWQYFXBYKWLEUUSUUTUUOWNGWJWKUUQVFVGVHVIVJVJUUOXKYRXMYTUUOXJYQXIIU
      UOXIIWIWIWNGUUQUULUUNVKZUURVGUVAVHUUOXLYSXIIUUOWIWIXIIWNGUUQUURUVAVGUVAVH
      VIVIVJVLVLVLVMVNVOUEUIZUGPZUHOZXPUDUVBVAPZUKZUBUVBUTPZUKZUAUVBURPZUKZUCUV
      BUPPZUKZSYAUEFUFULUVBFRZUVDWHUVLXTUVMUVCWGUHUVBFUGVPVQUVMUVJXSUCUVKDUVMUV
      KUUEDUVBFUPVPJVRUVMUVHXRUAUVIEUVMUVIUUGEUVBFURVPLVRUVMUVFXQUBUVGGUVMUVGUU
      JGUVBFUTVPMVRUVMXPXPUDUVEIUVMUVEUUMIUVBFVAVPNVRUVMXPVSVTVTVTVTVIABCUBUEUD
      UCUAWAWBWFYBUUCWCWD $.
  $}

  ${
    $d x y z R $.
    $( Any ring is also a semiring.  (Contributed by Thierry Arnoux,
       1-Apr-2018.) $)
    rngsrg $p |- ( R e. Ring -> R e. SRing ) $=
      ( vx vy vz crg wcel ccmn cmgp cfv cmnd cv cplusg co cmulr wceq wa cbs w3a
      wral eqid c0g csrg rngcmn cgrp isrng biimpi simp2d simp3d rnglz rngrz jca
      ralrimiva r19.26 sylanbrc 3jca issrg sylibr ) AEFZAGFZAHIZJFZBKZCKZDKZALI
      ZMANIZMVBVCVFMVBVDVFMZVEMOVBVCVEMVDVFMVGVCVDVFMVEMOPDAQIZSCVHSZAUAIZVBVFM
      VJOZVBVJVFMVJOZPZPBVHSZRAUBFURUSVAVNAUCURAUDFZVAVIBVHSZURVOVAVPRBCDVHVEAV
      FUTVHTZUTTZVETZVFTZUEUFZUGURVPVMBVHSVNURVOVAVPWAUHURVMBVHURVBVHFPVKVLVHAV
      FVBVJVQVTVJTZUIVHAVFVBVJVQVTWBUJUKULVIVMBVHUMUNUOBCDVHVEAVFUTVJVQVRVSVTWB
      UPUQ $.

    $( A semiring is a commutative monoid.  (Contributed by Thierry Arnoux,
       21-Mar-2018.) $)
    srgcmn $p |- ( R e. SRing -> R e. CMnd ) $=
      ( vx vy vz csrg wcel ccmn cmgp cfv cmnd cv cplusg cmulr wceq cbs wral c0g
      co wa eqid issrg simp1bi ) AEFAGFAHIZJFBKZCKZDKZALIZRAMIZRUDUEUHRUDUFUHRZ
      UGRNUDUEUGRUFUHRUIUEUFUHRUGRNSDAOIZPCUJPAQIZUDUHRUKNUDUKUHRUKNSSBUJPBCDUJ
      UGAUHUCUKUJTUCTUGTUHTUKTUAUB $.

    $( A semiring is a monoid.  (Contributed by Thierry Arnoux,
       21-Mar-2018.) $)
    srgmnd $p |- ( R e. SRing -> R e. Mnd ) $=
      ( csrg wcel ccmn cmnd srgcmn cmnmnd syl ) ABCADCAECAFAGH $.

    srgmgp.g $e |- G = ( mulGrp ` R ) $.
    $( A semiring is a monoid under multiplication.  (Contributed by Thierry
       Arnoux, 21-Mar-2018.) $)
    srgmgp $p |- ( R e. SRing -> G e. Mnd ) $=
      ( vx vy vz csrg wcel ccmn cmnd cv cplusg cfv co cmulr wceq cbs wral eqid
      wa c0g issrg simp2bi ) AGHAIHBJHDKZEKZFKZALMZNAOMZNUDUEUHNUDUFUHNZUGNPUDU
      EUGNUFUHNUIUEUFUHNUGNPTFAQMZREUJRAUAMZUDUHNUKPUDUKUHNUKPTTDUJRDEFUJUGAUHB
      UKUJSCUGSUHSUKSUBUC $.
  $}

  ${
    $d x y z B $.  $d x y z R $.  $d x y z .x. $.  $d x y z X $.  $d x y z Y $.
    $d x y z .+ $.  $d x y z Z $.
    srgi.b $e |- B = ( Base ` R ) $.
    srgi.p $e |- .+ = ( +g ` R ) $.
    srgi.t $e |- .x. = ( .r ` R ) $.
    $( Properties of a semiring.  (Contributed by NM, 26-Aug-2011.)  (Revised
       by Mario Carneiro, 6-Jan-2015.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    srgi $p |- ( ( R e. SRing /\ ( X e. B /\ Y e. B /\ Z e. B ) )
           -> ( ( X .x. ( Y .+ Z ) ) = ( ( X .x. Y ) .+ ( X .x. Z ) )
                /\ ( ( X .+ Y ) .x. Z ) = ( ( X .x. Z ) .+ ( Y .x. Z ) ) ) ) $=
      ( vx vy vz wcel wa co wceq cv wral rsp csrg w3a ccmn cmgp cmnd eqid issrg
      c0g simp3bi r19.21bi simpld ralrimiva adantr simpr1 simpr2 simpr3 caovdig
      cfv sylc simprd caovdirg jca ) CUANZEANFANGANUBOEFGBPDPEFDPEGDPZBPQEFBPGD
      PVDFGDPBPQVCKLMEFGABDBAVCKRZANZLRZANZMRZANZUBZOZVEVGVIBPDPVEVGDPVEVIDPZBP
      QZVEVGBPVIDPVMVGVIDPBPQZVLVNVOOZMASZVJVPVLVQLASZVHVQVLVRKASZVFVRVCVSVKVCV
      RKAVCVFOVRCUHURZVEDPVTQVEVTDPVTQOZVCVRWAOZKAVCCUCNCUDURZUENWBKASKLMABCDWC
      VTHWCUFIJVTUFUGUIUJUKULUMVCVFVHVJUNVRKATUSVCVFVHVJUOVQLATUSVCVFVHVJUPVPMA
      TUSZUKUQVCKLMEFGABDBAVLVNVOWDUTVAVB $.
  $}

  ${
    srgcl.b $e |- B = ( Base ` R ) $.
    srgcl.t $e |- .x. = ( .r ` R ) $.
    $( Closure of the multiplication operation of a semiring.  (Contributed by
       NM, 26-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    srgcl $p |- ( ( R e. SRing /\ X e. B /\ Y e. B ) -> ( X .x. Y ) e. B ) $=
      ( csrg wcel cmgp cfv cmnd co eqid srgmgp mgpbas mgpplusg mndcl syl3an1 )
      BHIBJKZLIDAIEAIDECMAIBTTNZOACTDEABTUAFPBCTUAGQRS $.

    $( Associative law for the multiplication operation of a semiring.
       (Contributed by NM, 27-Aug-2011.)  (Revised by Mario Carneiro,
       6-Jan-2015.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    srgass $p |- ( ( R e. SRing /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                      ( ( X .x. Y ) .x. Z ) = ( X .x. ( Y .x. Z ) ) ) $=
      ( csrg wcel cmgp cfv cmnd w3a co wceq eqid srgmgp mgpbas mgpplusg mndass
      sylan ) BIJBKLZMJDAJEAJFAJNDECOFCODEFCOCOPBUCUCQZRACUCDEFABUCUDGSBCUCUDHT
      UAUB $.

    $d u x B $.  $d u x R $.  $d u x .x. $.
    $( The unit element of a ring is unique.  (Contributed by NM,
       27-Aug-2011.)  (Revised by Mario Carneiro, 6-Jan-2015.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    srgideu $p |- ( R e. SRing ->
                E! u e. B A. x e. B ( ( u .x. x ) = x /\ ( x .x. u ) = x ) ) $=
      ( csrg wcel cmgp cfv cmnd cv co wceq wa wral wreu eqid srgmgp mndideu syl
      mgpbas mgpplusg ) DHIDJKZLIBMZAMZENUGOUGUFENUGOPACQBCRDUEUESZTABCEUECDUEU
      HFUCDEUEUHGUDUAUB $.
  $}

  ${
    srgdi.b $e |- B = ( Base ` R ) $.
    srgdi.p $e |- .+ = ( +g ` R ) $.
    srgdi.t $e |- .x. = ( .r ` R ) $.
    $( Distributive law for the multiplication operation of a semiring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)  (Revised by Thierry
       Arnoux, 1-Apr-2018.) $)
    srgdi $p |- ( ( R e. SRing /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                     ( X .x. ( Y .+ Z ) ) = ( ( X .x. Y ) .+ ( X .x. Z ) ) ) $=
      ( csrg wcel w3a wa co wceq srgi simpld ) CKLEALFALGALMNEFGBODOEFDOEGDOZBO
      PEFBOGDOSFGDOBOPABCDEFGHIJQR $.

    $( Distributive law for the multiplication operation of a semiring.
       (Contributed by Steve Rodriguez, 9-Sep-2007.)  (Revised by Thierry
       Arnoux, 1-Apr-2018.) $)
    srgdir $p |- ( ( R e. SRing /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
                     ( ( X .+ Y ) .x. Z ) = ( ( X .x. Z ) .+ ( Y .x. Z ) ) ) $=
      ( csrg wcel w3a wa co wceq srgi simprd ) CKLEALFALGALMNEFGBODOEFDOEGDOZBO
      PEFBOGDOSFGDOBOPABCDEFGHIJQR $.
  $}

  ${
    srgidcl.b $e |- B = ( Base ` R ) $.
    srgidcl.u $e |- .1. = ( 1r ` R ) $.
    $( The unit element of a semiring belongs to the base set of the semiring.
       (Contributed by NM, 27-Aug-2011.)  (Revised by Mario Carneiro,
       27-Dec-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    srgidcl $p |- ( R e. SRing -> .1. e. B ) $=
      ( csrg wcel cmgp cfv cmnd eqid srgmgp mgpbas rngidval mndidcl syl ) BFGBH
      IZJGCAGBQQKZLAQCABQRDMBCQRENOP $.
  $}

  ${
    srg0cl.b $e |- B = ( Base ` R ) $.
    srg0cl.z $e |- .0. = ( 0g ` R ) $.
    $( The zero element of a semiring belongs to its base set.  (Contributed by
       Mario Carneiro, 12-Jan-2014.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    srg0cl $p |- ( R e. SRing -> .0. e. B ) $=
      ( csrg wcel cmnd srgmnd mndidcl syl ) BFGBHGCAGBIABCDEJK $.
  $}

  ${
    $d x y B $.  $d x y I $.  $d x y R $.  $d x y .x. $.  $d x y .1. $.
    srgidm.b $e |- B = ( Base ` R ) $.
    srgidm.t $e |- .x. = ( .r ` R ) $.
    srgidm.u $e |- .1. = ( 1r ` R ) $.
    $( Lemma for ~ srglidm and ~ srgridm .  (Contributed by NM, 15-Sep-2011.)
       (Revised by Mario Carneiro, 27-Dec-2014.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    srgidmlem $p |- ( ( R e. SRing /\ X e. B )
           -> ( ( .1. .x. X ) = X /\ ( X .x. .1. ) = X ) ) $=
      ( csrg wcel cmgp cfv cmnd co wceq wa eqid srgmgp mgpbas mgpplusg rngidval
      mndlrid sylan ) BIJBKLZMJEAJDECNEOEDCNEOPBUDUDQZRACUDEDABUDUEFSBCUDUEGTBD
      UDUEHUAUBUC $.

    $( The unit element of a semiring is a left multiplicative identity.
       (Contributed by NM, 15-Sep-2011.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    srglidm $p |- ( ( R e. SRing /\ X e. B ) -> ( .1. .x. X ) = X ) $=
      ( csrg wcel wa co wceq srgidmlem simpld ) BIJEAJKDECLEMEDCLEMABCDEFGHNO
      $.

    $( The unit element of a semiring is a right multiplicative identity.
       (Contributed by NM, 15-Sep-2011.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    srgridm $p |- ( ( R e. SRing /\ X e. B ) -> ( X .x. .1. ) = X ) $=
      ( csrg wcel wa co wceq srgidmlem simprd ) BIJEAJKDECLEMEDCLEMABCDEFGHNO
      $.

    $( Properties showing that an element ` I ` is the unity element of a
       semiring.  (Contributed by NM, 7-Aug-2013.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    issrgid $p |- ( R e. SRing
      -> ( ( I e. B /\ A. x e. B ( ( I .x. x ) = x /\ ( x .x. I ) = x ) )
        <-> .1. = I ) ) $=
      ( vy csrg wcel cmgp cfv eqid mgpbas rngidval cv co wceq wa wral wreu wrex
      mgpplusg srgideu reurex syl ismgmid ) CKLZABDFJCMNZEBCUKUKOZGPCEUKULIQCDU
      KULHUEUJJRZARZDSUNTUNUMDSUNTUAABUBZJBUCUOJBUDAJBCDGHUFUOJBUGUHUI $.
  $}

  ${
    srgacl.b $e |- B = ( Base ` R ) $.
    srgacl.p $e |- .+ = ( +g ` R ) $.
    $( Closure of the addition operation of a semiring.  (Contributed by Mario
       Carneiro, 14-Jan-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    srgacl $p |- ( ( R e. SRing /\ X e. B /\ Y e. B ) -> ( X .+ Y ) e. B ) $=
      ( csrg wcel cmnd co srgmnd mndcl syl3an1 ) CHICJIDAIEAIDEBKAICLABCDEFGMN
      $.

    $( Commutativity of the additive group of a semiring.  (Contributed by
       Thierry Arnoux, 1-Apr-2018.) $)
    srgcom $p |- ( ( R e. SRing /\ X e. B /\ Y e. B ) ->
      ( X .+ Y ) = ( Y .+ X ) ) $=
      ( csrg wcel ccmn co wceq srgcmn cmncom syl3an1 ) CHICJIDAIEAIDEBKEDBKLCMA
      BCDEFGNO $.
  $}

  ${
    $d x y z B $.  $d x y z R $.  $d x X $.  $d x y z .x. $.  $d x y z .0. $.
    srgz.b $e |- B = ( Base ` R ) $.
    srgz.t $e |- .x. = ( .r ` R ) $.
    srgz.z $e |- .0. = ( 0g ` R ) $.
    $( The zero of a semiring is a right absorbing element.  (Contributed by
       Thierry Arnoux, 1-Apr-2018.) $)
    srgrz $p |- ( ( R e. SRing /\ X e. B ) -> ( X .x. .0. ) = .0. ) $=
      ( vx vy vz wcel cv co wceq wral wa cfv eqid simprd csrg cplusg ccmn issrg
      cmgp cmnd simp3bi r19.21bi ralrimiva oveq1 eqeq1d rspcv mpan9 ) BUALZIMZE
      CNZEOZIAPDALDECNZEOZUNUQIAUNUOALQZEUOCNEOZUQUTUOJMZKMZBUBRZNCNUOVBCNUOVCC
      NZVDNOUOVBVDNVCCNVEVBVCCNVDNOQKAPJAPZVAUQQZUNVFVGQZIAUNBUCLBUERZUFLVHIAPI
      JKAVDBCVIEFVISVDSGHUDUGUHTTUIUQUSIDAUODOUPUREUODECUJUKULUM $.

    $d x X $.  $d x Z $.  $d x ph $.
    srgisid.1 $e |- ( ph -> R e. SRing ) $.
    srgisid.2 $e |- ( ph -> Z e. B ) $.
    srgisid.3 $e |- ( ( ph /\ x e. B ) -> ( Z .x. x ) = Z ) $.
    $( In a semiring, the only absorbing element is the additive identity.
       Remark in [Golan] p. 1.  (Contributed by Thierry Arnoux, 1-May-2018.) $)
    srgisid $p |- ( ph -> Z = .0. ) $=
      ( co cv wceq wral ralrimiva csrg wcel srg0cl oveq2 eqeq1d rspcv mpd srgrz
      wi 3syl syl2anc eqtr3d ) AGFENZGFAGBOZENZGPZBCQZUKGPZAUNBCMRADSTZFCTUOUPU
      GKCDFHJUAUNUPBFCULFPUMUKGULFGEUBUCUDUHUEAUQGCTUKFPKLCDEGFHIJUFUIUJ $.
  $}

  ${
    $d x y z $.
    $( The natural numbers (including zero) form a semiring.  (Contributed by
       Thierry Arnoux, 1-May-2018.) $)
    nn0srg $p |- ( CCfld |`s NN0 ) e. SRing $=
      ( vx vy vz ccnfld cn0 co wcel cfv cmnd caddc cmul wceq wa wral ax-mp eqid
      cc0 cvv cc nn0sscn cress csrg ccmn cmgp csubmnd crg cnrng nn0subm submcmn
      cv rngcmn mp2an nn0ex mgpress wss c1 w3a nn0mulcl rgen2 3pm3.2i wb rngmgp
      cnfldbas mgpbas cnfld1 rngidval cnfldmul mgpplusg issubm submmnd eqeltrri
      1nn0 mpbir simpl nn0cn syl simprl sseldi simprr adddid adddird ralrimivva
      jca mul02d mul01d rgen cbs ressbas2 cnfldadd ressplusg cmulr ressmulr c0g
      cplusg rngmnd 0nn0 cnfld0 ress0g mp3an issrg mpbir3an ) DEUAFZUBGXBUCGZXB
      UDHZIGAUJZBUJZCUJZJFKFXEXFKFZXEXGKFZJFLZXEXFJFXGKFXIXFXGKFJFLZMZCENBENZQX
      EKFQLZXEQKFQLZMZMZAENDUCGZEDUEHGXCDUFGZXRUGDUKOZUHEDXBXBPZUIULDUDHZEUAFZX
      DIXRERGZYCXDLXTUMEDXBYBUCRYAYBPZUNULEYBUEHGZYCIGYFESUOZUPEGZXHEGZBENAENZU
      QZYGYHYJTVLYIABEEXEXFURUSUTYBIGZYFYKVAXSYLUGDYBYEVBOABSKEYBUPSDYBYEVCVDDU
      PYBYEVEVFDKYBYEVGVHVIOVMEYCYBYCPVJOVKXQAEXEEGZXMXPYMXLBCEEYMXFEGZXGEGZMZM
      ZXJXKYQXEXFXGYQYMXESGYMYPVNXEVOZVPZYQESXFTYMYNYOVQVRZYQESXGTYMYNYOVSVRZVT
      YQXEXFXGYSYTUUAWAWCWBYMXNXOYMXEYRWDYMXEYRWEWCWCWFABCEJXBKXDQYGEXBWGHLTESX
      BDYAVCWHOXDPYDJXBWNHLUMEJDXBRYAWIWJOYDKXBWKHLUMEDXBKRYAVGWLODIGZQEGYGQXBW
      MHLXSUUBUGDWOOWPTESDXBQYAVCWQWRWSWTXA $.
  $}

  ${
    $d x y z $.
    $( The non-negative real numbers form a semiring.  (Contributed by Thierry
       Arnoux, 6-Sep-2018.) $)
    rge0srg $p |- ( CCfld |`s ( 0 [,) +oo ) ) e. SRing $=
      ( vx vy vz ccnfld cc0 cpnf co wcel cfv cmnd caddc cmul wceq wa wral ax-mp
      cc cnfldbas c1 cvv cico cress csrg ccmn cmgp csubmnd crg cnrng rngcmn wss
      cv w3a cr rge0ssre ax-resscn sstri cxr clt wbr 0xr pnfxr 0re ltpnf lbico1
      mp3an ge0addcl rgen2 3pm3.2i wb rngmnd cnfld0 cnfldadd mpbir eqid submcmn
      issubm mp2an cle 1re 0le1 elico2 mpbir3an ge0mulcl rngmgp mgpbas rngidval
      cnfld1 cnfldmul mgpplusg mp2b submmnd simpll sseldi simplr adddid adddird
      simpr jca ralrimiva sseli mul02d mul01d rgen cbs ressbas2 cnfldex mgpress
      jca32 ovex cplusg ressplusg cmulr ressmulr c0g ress0g issrg ) DEFUAGZUBGZ
      UCHXRUDHZDUEIZXQUBGZJHZAUKZBUKZCUKZKGLGYCYDLGZYCYELGZKGMZYCYDKGZYELGYGYDY
      ELGKGMZNZCXQOZBXQOZEYCLGEMZYCELGEMZNNZAXQODUDHZXQDUFIHZXSDUGHZYQUHDUIPYRX
      QQUJZEXQHZYIXQHZBXQOAXQOZULZYTUUAUUCXQUMQUNUOUPZEUQHFUQHZEFURUSZUUAUTVAEU
      MHZUUGVBEVCPEFVDVEZUUBABXQXQYCYDVFVGVHDJHZYRUUDVIYSUUJUHDVJPZABQKXQDERVKV
      LVPPVMXQDXRXRVNZVOVQXQXTUFIHZYBUUMYTSXQHZYFXQHZBXQOAXQOZULZYTUUNUUPUUEUUN
      SUMHZESVRUSZSFURUSZVSVTUURUUTVSSVCPUUHUUFUUNUURUUSUUTULVIVBVAEFSWAVQWBUUO
      ABXQXQYCYDWCVGVHYSXTJHUUMUUQVIUHDXTXTVNZWDABQLXQXTSQDXTUVARWEDSXTUVAWGWFD
      LXTUVAWHWIVPWJVMXQYAXTYAVNWKPYPAXQYCXQHZYMYNYOUVBYLBXQUVBYDXQHZNZYKCXQUVD
      YEXQHZNZYHYJUVFYCYDYEUVFXQQYCUUEUVBUVCUVEWLWMZUVFXQQYDUUEUVBUVCUVEWNWMZUV
      FXQQYEUUEUVDUVEWQWMZWOUVFYCYDYEUVGUVHUVIWPWRWSWSUVBYCXQQYCUUEWTZXAUVBYCUV
      JXBXHXCABCXQKXRLYAEYTXQXRXDIMUUEXQQXRDUULRXEPDTHXQTHZYAXRUEIMXFEFUAXIZXQD
      XRXTTTUULUVAXGVQUVKKXRXJIMUVLXQKDXRTUULVLXKPUVKLXRXLIMUVLXQDXRLTUULWHXMPU
      UJUUAYTEXRXNIMUUKUUIUUEXQQDXREUULRVKXOVEXPWB $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Semiring left modules
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c SLMod $.

  $( Extend class notation with class of all semimodules. $)
  cslmd $a class SLMod $.

  ${
    $d a f g k p q r s t v w x y $.
    $( Define the class of all (left) modules over semirings, i.e. semimodules,
       which are generalizations of left modules.  A semimodule is a
       commutative monoid (=vectors) together with a semiring (=scalars) and a
       left scalar product connecting them. ` ( 0 [,] +oo ) ` for example is
       not a full fledged left module, but is a semimodule.  Definition of
       [Golan] p. 149.  (Contributed by Thierry Arnoux, 21-Mar-2018.) $)
    df-slmd $a |- SLMod = { g e. CMnd | [. ( Base ` g ) / v ].
      [. ( +g ` g ) / a ]. [. ( .s ` g ) / s ]. [. ( Scalar ` g ) / f ].
      [. ( Base ` f ) / k ]. [. ( +g ` f ) / p ]. [. ( .r ` f ) / t ].
      ( f e. SRing /\ A. q e. k A. r e. k A. x e. v A. w e. v
                ( ( ( r s w ) e. v
                 /\ ( r s ( w a x ) ) = ( ( r s w ) a ( r s x ) )
                 /\ ( ( q p r ) s w ) = ( ( q s w ) a ( r s w ) )
               ) /\ ( ( ( q t r ) s w ) = ( q s ( r s w ) )
                 /\ ( ( 1r ` f ) s w ) = w
                 /\ ( ( 0g ` f ) s w ) = ( 0g ` g ) ) ) ) } $.
  $}

  ${
    $d a f g k p q r s t v w x .X. $.  $d a f g k p q r s v w x .+ $.
    $d a f g k p q r s v w x .+^ $.  $d a f g k p q r s v w x .1. $.
    $d a f g k p q r s v w x .x. $.  $d a f g k p q r s t v w x F $.
    $d a f g k p q r s v w x K $.  $d a f g k p q r s v w x V $.
    $d a f g q r s v w x W $.  $d g q r w x .0. $.  $d g q r w x O $.
    $d q r w x Q $.  $d r w x R $.  $d w x X $.  $d w Y $.
    isslmd.v $e |- V = ( Base ` W ) $.
    isslmd.a $e |- .+ = ( +g ` W ) $.
    isslmd.s $e |- .x. = ( .s ` W ) $.
    isslmd.0 $e |- .0. = ( 0g ` W ) $.
    isslmd.f $e |- F = ( Scalar ` W ) $.
    isslmd.k $e |- K = ( Base ` F ) $.
    isslmd.p $e |- .+^ = ( +g ` F ) $.
    isslmd.t $e |- .X. = ( .r ` F ) $.
    isslmd.u $e |- .1. = ( 1r ` F ) $.
    isslmd.o $e |- O = ( 0g ` F ) $.
    $( The predicate "is a semimodule".  (Contributed by NM, 4-Nov-2013.)
       (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    isslmd $p |- ( W e. SLMod <->
      ( W e. CMnd /\ F e. SRing /\ A. q e. K A. r e. K A. x e. V A. w e. V
                ( ( ( r .x. w ) e. V
                 /\ ( r .x. ( w .+ x ) ) = ( ( r .x. w ) .+ ( r .x. x ) )
                 /\ ( ( q .+^ r ) .x. w ) = ( ( q .x. w ) .+ ( r .x. w ) )
               ) /\ ( ( ( q .X. r ) .x. w ) = ( q .x. ( r .x. w ) )
                 /\ ( .1. .x. w ) = w
                 /\ ( O .x. w ) = .0. ) ) ) ) $=
      ( vf vs vv va vp vt vg vk cslmd wcel ccmn csrg cv co wceq w3a wa wral cur
      cfv c0g cmulr wsbc cplusg csca cvsca fvex simp1 simp2 oveqd oveq1d eqeq1d
      cbs 3anbi3d simp3 3anbi1d anbi12d 2ralbidv raleqbidv anbi2d sbc3ie eleq1d
      simpr fveq2d simpl oveq12d eqeq12d eqidd oveq123d 3anbi123d syl5bb sbc2ie
      eleq2d oveq2d eqeq2d anbi1d syl6eqr eleq12d df-slmd elrab2 3anass bitr4i
      fveq2 ) LUNUOLUPUOZHUQUOZNURZBURZEUSZKUOZXKXLAURZCUSZEUSZXMXKXOEUSZCUSZUT
      ZOURZXKDUSZXLEUSZYAXLEUSZXMCUSZUTZVAZYAXKFUSZXLEUSZYAXMEUSZUTZGXLEUSZXLUT
      ZJXLEUSZMUTZVAZVBZBKVCZAKVCZNIVCZOIVCZVBZVBXIXJUUAVAUFURZUQUOZXKXLUGURZUS
      ZUHURZUOZXKXLXOUIURZUSZUUEUSZUUFXKXOUUEUSZUUIUSZUTZYAXKUJURZUSZXLUUEUSZYA
      XLUUEUSZUUFUUIUSZUTZVAZYAXKUKURZUSZXLUUEUSZYAUUFUUEUSZUTZUUCVDVEZXLUUEUSZ
      XLUTZUUCVFVEZXLUUEUSZULURZVFVEZUTZVAZVBZBUUGVCAUUGVCZNUMURZVCZOUVRVCZVBZU
      KUUCVGVEZVHUJUUCVIVEZVHUMUUCVRVEZVHZUFUVLVJVEZVHUGUVLVKVEZVHZUIUVLVIVEZVH
      UHUVLVRVEZVHZUUBULLUPUNUWKUWFUQUOZXKXLUWGUSZUWJUOZXKXLXOUWIUSZUWGUSZUWMXK
      XOUWGUSZUWIUSZUTZYAXKUWFVIVEZUSZXLUWGUSZYAXLUWGUSZUWMUWIUSZUTZVAZYAXKUWFV
      GVEZUSZXLUWGUSZYAUWMUWGUSZUTZUWFVDVEZXLUWGUSZXLUTZUWFVFVEZXLUWGUSZUVMUTZV
      AZVBZBUWJVCZAUWJVCZNUWFVRVEZVCZOUYBVCZVBZUVLLUTZUUBUWHUYEUHUIUWJUWIUVLVRV
      LUVLVIVLUWHUWLUWMUUGUOZXKUUJUWGUSZUWMUWQUUIUSZUTZUXBUXCUWMUUIUSZUTZVAZUXR
      VBZBUUGVCZAUUGVCZNUYBVCZOUYBVCZVBZUUGUWJUTZUUIUWIUTZVBZUYEUWEUYSUGUFUWGUW
      FUVLVKVLUVLVJVLUWEUUDUUHUUNYAXKUWCUSZXLUUEUSZUUSUTZVAZYAXKUWBUSZXLUUEUSZU
      VEUTZUVIUVNVAZVBZBUUGVCAUUGVCZNUWDVCZOUWDVCZVBZUUEUWGUTZUUCUWFUTZVBZUYSUW
      AVUOUMUJUKUWDUWCUWBUUCVRVLUUCVIVLUUCVGVLUVRUWDUTZUUOUWCUTZUVBUWBUTZVAZUVT
      VUNUUDVVBUVSVUMOUVRUWDVUSVUTVVAVMZVVBUVQVULNUVRUWDVVCVVBUVPVUKABUUGUUGVVB
      UVAVUFUVOVUJVVBUUTVUEUUHUUNVVBUUQVUDUUSVVBUUPVUCXLUUEVVBUUOUWCYAXKVUSVUTV
      VAVNVOVPVQVSVVBUVFVUIUVIUVNVVBUVDVUHUVEVVBUVCVUGXLUUEVVBUVBUWBYAXKVUSVUTV
      VAVTVOVPVQWAWBWCWDWDWEWFVURUUDUWLVUNUYRVURUUCUWFUQVUPVUQWHZWGVURVUMUYQOUW
      DUYBVURUUCUWFVRVVDWIZVURVULUYPNUWDUYBVVEVURVUKUYNABUUGUUGVURVUFUYMVUJUXRV
      URUUHUYGUUNUYJVUEUYLVURUUFUWMUUGVURUUEUWGXKXLVUPVUQWJZVOZWGVURUUKUYHUUMUY
      IVURUUEUWGXKUUJVVFVOVURUUFUWMUULUWQUUIVVGVURUUEUWGXKXOVVFVOWKWLVURVUDUXBU
      USUYKVURVUCUXAXLXLUUEUWGVVFVURUWCUWTYAXKVURUUCUWFVIVVDWIVOVURXLWMZWNVURUU
      RUXCUUFUWMUUIVURUUEUWGYAXLVVFVOVVGWKWLWOVURVUIUXKUVIUXNUVNUXQVURVUHUXIUVE
      UXJVURVUGUXHXLXLUUEUWGVVFVURUWBUXGYAXKVURUUCUWFVGVVDWIVOVVHWNVURYAYAUUFUW
      MUUEUWGVVFVURYAWMVVGWNWLVURUVHUXMXLVURUVGUXLXLXLUUEUWGVVFVURUUCUWFVDVVDWI
      VVHWNVQVURUVKUXPUVMVURUVJUXOXLXLUUEUWGVVFVURUUCUWFVFVVDWIVVHWNVQWOWBWCWDW
      DWBWPWQVUBUYRUYDUWLVUBUYPUYAONUYBUYBVUBUYOUXTAUUGUWJUYTVUAWJZVUBUYNUXSBUU
      GUWJVVIVUBUYMUXFUXRVUBUYGUWNUYJUWSUYLUXEVUBUUGUWJUWMVVIWRVUBUYHUWPUYIUWRV
      UBUUJUWOXKUWGVUBUUIUWIXLXOUYTVUAWHZVOWSVUBUUIUWIUWMUWQVVJVOWLVUBUYKUXDUXB
      VUBUUIUWIUXCUWMVVJVOWTWOXAWDWDWCWEWPWQUYFUWLXJUYDUUAUYFUWFHUQUYFUWFLVJVEH
      UVLLVJXHTXBZWGUYFUYCYTOUYBIUYFUYBHVRVEIUYFUWFHVRVVKWIUAXBZUYFUYAYSNUYBIVV
      LUYFUXTYRAUWJKUYFUWJLVRVEKUVLLVRXHPXBZUYFUXSYQBUWJKVVMUYFUXFYGUXRYPUYFUWN
      XNUWSXTUXEYFUYFUWMXMUWJKUYFUWGEXKXLUYFUWGLVKVEEUVLLVKXHRXBZVOZVVMXCUYFUWP
      XQUWRXSUYFXKXKUWOXPUWGEVVNUYFXKWMUYFUWICXLXOUYFUWILVIVECUVLLVIXHQXBZVOWNU
      YFUWMXMUWQXRUWICVVPVVOUYFUWGEXKXOVVNVOWNWLUYFUXBYCUXDYEUYFUXAYBXLXLUWGEVV
      NUYFUWTDYAXKUYFUWTHVIVEDUYFUWFHVIVVKWIUBXBVOUYFXLWMZWNUYFUXCYDUWMXMUWICVV
      PUYFUWGEYAXLVVNVOVVOWNWLWOUYFUXKYKUXNYMUXQYOUYFUXIYIUXJYJUYFUXHYHXLXLUWGE
      VVNUYFUXGFYAXKUYFUXGHVGVEFUYFUWFHVGVVKWIUCXBVOVVQWNUYFYAYAUWMXMUWGEVVNUYF
      YAWMVVOWNWLUYFUXMYLXLUYFUXLGXLXLUWGEVVNUYFUXLHVDVEGUYFUWFHVDVVKWIUDXBVVQW
      NVQUYFUXPYNUVMMUYFUXOJXLXLUWGEVVNUYFUXOHVFVEJUYFUWFHVFVVKWIUEXBVVQWNUYFUV
      MLVFVEMUVLLVFXHSXBWLWOWBWDWDWDWDWBWPABUHUKUFULUMUGNOUJUIXDXEXIXJUUAXFXG
      $.


    $( Lemma for properties of a semimodule.  (Contributed by NM, 8-Dec-2013.)
       (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    slmdlema $p |- ( ( W e. SLMod /\ ( Q e. K /\ R e. K )
          /\ ( X e. V /\ Y e. V ) ) ->
                ( ( ( R .x. Y ) e. V
                 /\ ( R .x. ( Y .+ X ) ) = ( ( R .x. Y ) .+ ( R .x. X ) )
                 /\ ( ( Q .+^ R ) .x. Y ) = ( ( Q .x. Y ) .+ ( R .x. Y ) )
               ) /\ ( ( ( Q .X. R ) .x. Y ) = ( Q .x. ( R .x. Y ) )
                 /\ ( .1. .x. Y ) = Y
                 /\ ( O .x. Y ) = .0. ) ) ) $=
      ( vw vx vr vq cslmd wcel wa co wceq w3a cv wral ccmn isslmd simp3bi oveq1
      csrg oveq1d eqeq12d 3anbi3d 3anbi1d anbi12d 2ralbidv eleq1d oveq12d oveq2
      oveq2d 3anbi123d biidd 3anbi13d rspc2v mpan9 3anbi2d anbi1d eqeq1d 3impia
      id syl5com ) LUJUKZCIUKDIUKULZMKUKNKUKULZDNEUMZKUKZDNMAUMZEUMZWGDMEUMZAUM
      ZUNZCDBUMZNEUMZCNEUMZWGAUMZUNZUOZCDFUMZNEUMZCWGEUMZUNZGNEUMZNUNZJNEUMZOUN
      ZUOZULZWDWEULDUFUPZEUMZKUKZDXJUGUPZAUMZEUMZXKDXMEUMZAUMZUNZWNXJEUMZCXJEUM
      ZXKAUMZUNZUOZWTXJEUMZCXKEUMZUNZGXJEUMZXJUNZJXJEUMZOUNZUOZULZUFKUQUGKUQZWF
      XIWDUHUPZXJEUMZKUKZYNXNEUMZYOYNXMEUMZAUMZUNZUIUPZYNBUMZXJEUMZUUAXJEUMZYOA
      UMZUNZUOZUUAYNFUMZXJEUMZUUAYOEUMZUNZYHYJUOZULZUFKUQUGKUQZUHIUQUIIUQZWEYMW
      DLURUKHVBUKUUOUGUFABEFGHIJKLOUHUIPQRSTUAUBUCUDUEUSUTUUNYMYPYTCYNBUMZXJEUM
      ZXTYOAUMZUNZUOZCYNFUMZXJEUMZCYOEUMZUNZYHYJUOZULZUFKUQUGKUQUIUHCDIIUUACUNZ
      UUMUVFUGUFKKUVGUUGUUTUULUVEUVGUUFUUSYPYTUVGUUCUUQUUEUURUVGUUBUUPXJEUUACYN
      BVAVCUVGUUDXTYOAUUACXJEVAVCVDVEUVGUUKUVDYHYJUVGUUIUVBUUJUVCUVGUUHUVAXJEUU
      ACYNFVAVCUUACYOEVAVDVFVGVHYNDUNZUVFYLUGUFKKUVHUUTYCUVEYKUVHYPXLYTXRUUSYBU
      VHYOXKKYNDXJEVAZVIUVHYQXOYSXQYNDXNEVAUVHYOXKYRXPAUVIYNDXMEVAVJVDUVHUUQXSU
      URYAUVHUUPWNXJEYNDCBVKVCUVHYOXKXTAUVIVLVDVMUVHUVDYFYJYJYHUVHUVBYDUVCYEUVH
      UVAWTXJEYNDCFVKVCUVHYOXKCEUVIVLVDUVHYJVNVOVGVHVPVQYLXIXLDXJMAUMZEUMZXKWKA
      UMZUNZYBUOZYKULUGUFMNKKXMMUNZYCUVNYKUVOXRUVMXLYBUVOXOUVKXQUVLUVOXNUVJDEXM
      MXJAVKVLUVOXPWKXKAXMMDEVKVLVDVRVSXJNUNZUVNWSYKXHUVPXLWHUVMWMYBWRUVPXKWGKX
      JNDEVKZVIUVPUVKWJUVLWLUVPUVJWIDEXJNMAVAVLUVPXKWGWKAUVQVCVDUVPXSWOYAWQXJNW
      NEVKUVPXTWPXKWGAXJNCEVKUVQVJVDVMUVPYFXCYHXEYJXGUVPYDXAYEXBXJNWTEVKUVPXKWG
      CEUVQVLVDUVPYGXDXJNXJNGEVKUVPWBVDUVPYIXFOXJNJEVKVTVMVGVPWCWA $.
  $}

  ${
    $d a f g k p q r s v w x F $.  $d a f g k p q r s v w x K $.
    $d q r w x Q $.  $d r w x R $.  $d a f g k p q r s v w x V $.
    $d a f g q r v w x W $.  $d w x X $.  $d w Y $.
    $d a f g k p q r s t v w x .X. $.  $d a f g k p q r s v w x .+ $.
    $d a f g k p q r s v w x .+^ $.  $d a f g k p q r s v w x .1. $.
    $d a f g k p q r s v w x .x. $.
    $( Left semimodules generalize the notion of left modules.  (Contributed by
       Thierry Arnoux, 1-Apr-2018.) $)
    lmodslmd $p |- ( W e. LMod -> W e. SLMod ) $=
      ( vr vw vx vq wcel cfv cv co cbs cplusg wceq w3a c0g wral r19.21bi simpld
      wa eqid ralrimiva clmod ccmn csca csrg cvsca cmulr cur cslmd lmodcmn cgrp
      crg islmod simp2bi rngsrg syl simp3bi simprd simp-4l lmod0vs syl2anc 3jca
      simpr jca isslmd syl3anbrc ) AUAFZAUBFAUCGZUDFZBHZCHZAUEGZIZAJGZFVIVJDHZA
      KGZIVKIVLVIVNVKIVOILEHZVIVGKGZIVJVKIVPVJVKIVLVOILMZVPVIVGUFGZIVJVKIVPVLVK
      ILZVGUGGZVJVKIVJLZVGNGZVJVKIANGZLZMZRZCVMOZDVMOZBVGJGZOZEWJOAUHFAUIVFVGUK
      FZVHVFAUJFZWLVRVTWBRZRZCVMOZDVMOZBWJOZEWJOZDCVOVQVKVSWAVGWJVMABEVMSZVOSZV
      KSZVGSZWJSZVQSZVSSZWASZULZUMVGUNUOVFWKEWJVFVPWJFZRZWIBWJXJVIWJFZRZWHDVMXL
      VNVMFZRZWGCVMXNVJVMFZRZVRWFXPVRWNXNWOCVMXLWPDVMXJWQBWJVFWREWJVFWMWLWSXHUP
      PPPPZQXPVTWBWEXPVTWBXPVRWNXQUQZQXPVTWBXRUQXPVFXOWEVFXIXKXMXOURXNXOVBVKVGW
      CVMAVJWDWTXCXBWCSZWDSZUSUTVAVCTTTTDCVOVQVKVSWAVGWJWCVMAWDBEWTXAXBXTXCXDXE
      XFXGXSVDVE $.
  $}

  ${
    $d q r w x y z F $.  $d q r w x y z W $.
    $( A semimodule is a commutative monoid.  (Contributed by Thierry Arnoux,
       1-Apr-2018.) $)
    slmdcmn $p |- ( W e. SLMod -> W e. CMnd ) $=
      ( vz vy vx vw cslmd wcel ccmn csca cfv csrg cv co cbs cplusg wceq w3a c0g
      wral eqid cvsca cmulr cur wa isslmd simp1bi ) AFGAHGAIJZKGBLZCLZAUAJZMZAN
      JZGUHUIDLZAOJZMUJMUKUHUMUJMUNMPELZUHUGOJZMUIUJMUOUIUJMUKUNMPQUOUHUGUBJZMU
      IUJMUOUKUJMPUGUCJZUIUJMUIPUGRJZUIUJMARJZPQUDCULSDULSBUGNJZSEVASDCUNUPUJUQ
      URUGVAUSULAUTBEULTUNTUJTUTTUGTVATUPTUQTURTUSTUEUF $.

    $( A semimodule is a monoid.  (Contributed by Thierry Arnoux,
       1-Apr-2018.) $)
    slmdmnd $p |- ( W e. SLMod -> W e. Mnd ) $=
      ( cslmd wcel ccmn cmnd slmdcmn cmnmnd syl ) ABCADCAECAFAGH $.

    slmdsrg.1 $e |- F = ( Scalar ` W ) $.
    $( The scalar component of a semimodule is a semiring.  (Contributed by NM,
       8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    slmdsrg $p |- ( W e. SLMod -> F e. SRing ) $=
      ( vz vy vx vw cslmd wcel ccmn cv cfv co cbs cplusg wceq w3a c0g wral eqid
      csrg cvsca cmulr cur wa isslmd simp2bi ) BHIBJIAUAIDKZEKZBUBLZMZBNLZIUHUI
      FKZBOLZMUJMUKUHUMUJMUNMPGKZUHAOLZMUIUJMUOUIUJMUKUNMPQUOUHAUCLZMUIUJMUOUKU
      JMPAUDLZUIUJMUIPARLZUIUJMBRLZPQUEEULSFULSDANLZSGVASFEUNUPUJUQURAVAUSULBUT
      DGULTUNTUJTUTTCVATUPTUQTURTUSTUFUG $.
  $}

  ${
    slmdbn0.b $e |- B = ( Base ` W ) $.
    $( The base set of a semimodule is nonempty.  (Contributed by Thierry
       Arnoux, 1-Apr-2018.) $)
    slmdbn0 $p |- ( W e. SLMod -> B =/= (/) ) $=
      ( cslmd wcel cmnd c0g cfv c0 wne slmdmnd eqid mndidcl ne0i 3syl ) BDEBFEB
      GHZAEAIJBKABPCPLMAPNO $.
  $}

  ${
    slmdacl.f $e |- F = ( Scalar ` W ) $.
    slmdacl.k $e |- K = ( Base ` F ) $.
    slmdacl.p $e |- .+ = ( +g ` F ) $.
    $( Closure of ring addition for a semimodule.  (Contributed by Thierry
       Arnoux, 1-Apr-2018.) $)
    slmdacl $p |- ( ( W e. SLMod /\ X e. K /\ Y e. K ) -> ( X .+ Y ) e. K ) $=
      ( cslmd wcel cmnd co csrg slmdsrg srgmnd syl mndcl syl3an1 ) DJKZBLKZECKF
      CKEFAMCKTBNKUABDGOBPQCABEFHIRS $.
  $}

  ${
    slmdmcl.f $e |- F = ( Scalar ` W ) $.
    slmdmcl.k $e |- K = ( Base ` F ) $.
    slmdmcl.t $e |- .x. = ( .r ` F ) $.
    $( Closure of ring multiplication for a semimodule.  (Contributed by NM,
       14-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    slmdmcl $p |- ( ( W e. SLMod /\ X e. K /\ Y e. K ) -> ( X .x. Y ) e. K ) $=
      ( cslmd wcel csrg co slmdsrg srgcl syl3an1 ) DJKBLKECKFCKEFAMCKBDGNCBAEFH
      IOP $.
  $}

  ${
    slmdsn0.f $e |- F = ( Scalar ` W ) $.
    slmdsn0.b $e |- B = ( Base ` F ) $.
    $( The set of scalars in a semimodule is nonempty.  (Contributed by Thierry
       Arnoux, 1-Apr-2018.) $)
    slmdsn0 $p |- ( W e. SLMod -> B =/= (/) ) $=
      ( wcel c0g cfv c0 wne csrg cmnd slmdsrg srgmnd eqid mndidcl 3syl ne0i syl
      cslmd ) CTFZBGHZAFZAIJUABKFBLFUCBCDMBNABUBEUBOPQAUBRS $.
  $}

  ${
    slmdvacl.v $e |- V = ( Base ` W ) $.
    slmdvacl.a $e |- .+ = ( +g ` W ) $.
    $( Closure of vector addition for a semiring left module.  (Contributed by
       NM, 8-Dec-2013.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    slmdvacl $p |- ( ( W e. SLMod /\ X e. V /\ Y e. V ) -> ( X .+ Y ) e. V ) $=
      ( cslmd wcel cmnd co slmdmnd mndcl syl3an1 ) CHICJIDBIEBIDEAKBICLBACDEFGM
      N $.

    $( Semiring left module vector sum is associative.  (Contributed by NM,
       10-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    slmdass $p |- ( ( W e. SLMod /\ ( X e. V /\ Y e. V /\ Z e. V ) ) ->
                    ( ( X .+ Y ) .+ Z ) = ( X .+ ( Y .+ Z ) ) ) $=
      ( cslmd wcel cmnd w3a co wceq slmdmnd mndass sylan ) CIJCKJDBJEBJFBJLDEAM
      FAMDEFAMAMNCOBACDEFGHPQ $.
  $}

  ${
    slmdvscl.v $e |- V = ( Base ` W ) $.
    slmdvscl.f $e |- F = ( Scalar ` W ) $.
    slmdvscl.s $e |- .x. = ( .s ` W ) $.
    slmdvscl.k $e |- K = ( Base ` F ) $.
    $( Closure of scalar product for a semiring left module.  ( ~ hvmulcl
       analog.)  (Contributed by NM, 8-Dec-2013.)  (Revised by Mario Carneiro,
       19-Jun-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmdvscl $p |- ( ( W e. SLMod /\ R e. K /\ X e. V ) -> ( R .x. X ) e. V ) $=
      ( wcel wa co pm4.24 w3a cplusg cfv wceq eqid cslmd cmulr cur c0g slmdlema
      biid simpld simp1d syl3anb ) FUALZUJADLZUKUKMZGELZUMUMMZAGBNZELZUJUFUKOUM
      OUJULUNPZUPAGGFQRZNBNUOUOURNZSZAACQRZNGBNUSSZUQUPUTVBPAACUBRZNGBNAUOBNSCU
      CRZGBNGSCUDRZGBNFUDRZSPURVAAABVCVDCDVEEFGGVFHURTJVFTIKVATVCTVDTVETUEUGUHU
      I $.
  $}

  ${
    slmdvsdi.v $e |- V = ( Base ` W ) $.
    slmdvsdi.a $e |- .+ = ( +g ` W ) $.
    slmdvsdi.f $e |- F = ( Scalar ` W ) $.
    slmdvsdi.s $e |- .x. = ( .s ` W ) $.
    slmdvsdi.k $e |- K = ( Base ` F ) $.
    $( Distributive law for scalar product.  ( ~ ax-hvdistr1 analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmdvsdi $p |- ( ( W e. SLMod /\ ( R e. K /\ X e. V /\ Y e. V ) ) ->
                     ( R .x. ( X .+ Y ) ) = ( ( R .x. X ) .+ ( R .x. Y ) ) ) $=
      ( wcel co wceq w3a cfv eqid cslmd wa cplusg cmulr cur c0g slmdlema simpld
      wi simp2d 3expia anabsan2 exp4b com34 3imp2 ) GUAOZBEOZHFOZIFOZBHIAPCPBHC
      PZBICPAPQZUPUQUSURVAUPUQUSURVAUPUQUSURUBZVAUIUPUQUQUBZVBVAUPVCVBRZUTFOZVA
      BBDUCSZPHCPUTUTAPQZVDVEVAVGRBBDUDSZPHCPBUTCPQDUESZHCPHQDUFSZHCPGUFSZQRAVF
      BBCVHVIDEVJFGIHVKJKMVKTLNVFTVHTVITVJTUGUHUJUKULUMUNUO $.
  $}

  ${
    slmdvsdir.v $e |- V = ( Base ` W ) $.
    slmdvsdir.a $e |- .+ = ( +g ` W ) $.
    slmdvsdir.f $e |- F = ( Scalar ` W ) $.
    slmdvsdir.s $e |- .x. = ( .s ` W ) $.
    slmdvsdir.k $e |- K = ( Base ` F ) $.
    slmdvsdir.p $e |- .+^ = ( +g ` F ) $.
    $( Distributive law for scalar product.  ( ~ ax-hvdistr1 analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmdvsdir $p |- ( ( W e. SLMod /\ ( Q e. K /\ R e. K /\ X e. V ) ) ->
                    ( ( Q .+^ R ) .x. X ) = ( ( Q .x. X ) .+ ( R .x. X ) ) ) $=
      ( wcel co wceq cfv cslmd wa w3a cmulr cur c0g eqid slmdlema simpld simp3d
      3expa anabsan2 exp42 3imp2 ) IUAQZCGQZDGQZJHQZCDBRJERCJERDJERZARSZUOUPUQU
      RUTUOUPUQUBZUBURUTUOVAURURUBZUTUOVAVBUCZUSHQZDJJARERUSUSARSZUTVCVDVEUTUCC
      DFUDTZRJERCUSERSFUETZJERJSFUFTZJERIUFTZSUCABCDEVFVGFGVHHIJJVIKLNVIUGMOPVF
      UGVGUGVHUGUHUIUJUKULUMUN $.

  $}


  ${
    slmdvsass.v $e |- V = ( Base ` W ) $.
    slmdvsass.f $e |- F = ( Scalar ` W ) $.
    slmdvsass.s $e |- .x. = ( .s ` W ) $.
    slmdvsass.k $e |- K = ( Base ` F ) $.
    slmdvsass.t $e |- .X. = ( .r ` F ) $.
    $( Associative law for scalar product.  ( ~ ax-hvmulass analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmdvsass $p |- ( ( W e. SLMod /\ ( Q e. K /\ R e. K /\ X e. V ) ) ->
                      ( ( Q .X. R ) .x. X ) = ( Q .x. ( R .x. X ) ) ) $=
      ( wcel co wceq wa cfv eqid cslmd w3a cur c0g cplusg slmdlema simprd 3expa
      simp1d anabsan2 exp42 3imp2 ) HUAOZAFOZBFOZIGOZABDPICPABICPZCPQZUMUNUOUPU
      RUMUNUORZRUPURUMUSUPUPRZURUMUSUTUBZUREUCSZICPIQZEUDSZICPHUDSZQZVAUQGOBIIH
      UESZPCPUQUQVGPQABEUESZPICPAICPUQVGPQUBURVCVFUBVGVHABCDVBEFVDGHIIVEJVGTLVE
      TKMVHTNVBTVDTUFUGUIUHUJUKUL $.
  $}

  ${
    slmd0cl.f $e |- F = ( Scalar ` W ) $.
    slmd0cl.k $e |- K = ( Base ` F ) $.
    slmd0cl.z $e |- .0. = ( 0g ` F ) $.
    $( The ring zero in a semimodule belongs to the ring base set.
       (Contributed by NM, 11-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmd0cl $p |- ( W e. SLMod -> .0. e. K ) $=
      ( cslmd wcel csrg slmdsrg srg0cl syl ) CHIAJIDBIACEKBADFGLM $.
  $}

  ${
    slmd1cl.f $e |- F = ( Scalar ` W ) $.
    slmd1cl.k $e |- K = ( Base ` F ) $.
    slmd1cl.u $e |- .1. = ( 1r ` F ) $.
    $( The ring unit in a semiring left module belongs to the ring base set.
       (Contributed by NM, 11-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmd1cl $p |- ( W e. SLMod -> .1. e. K ) $=
      ( cslmd wcel csrg slmdsrg srgidcl syl ) DHIBJIACIBDEKCBAFGLM $.
  $}

  ${
    slmdvs1.v $e |- V = ( Base ` W ) $.
    slmdvs1.f $e |- F = ( Scalar ` W ) $.
    slmdvs1.s $e |- .x. = ( .s ` W ) $.
    slmdvs1.u $e |- .1. = ( 1r ` F ) $.
    $( Scalar product with ring unit.  ( ~ ax-hvmulid analog.)  (Contributed by
       NM, 10-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised
       by Thierry Arnoux, 1-Apr-2018.) $)
    slmdvs1 $p |- ( ( W e. SLMod /\ X e. V ) -> ( .1. .x. X ) = X ) $=
      ( cslmd wcel wa cfv co wceq eqid w3a c0g cplusg simpl slmd1cl simpr cmulr
      cbs adantr slmdlema simprd simp2d syl122anc ) EKLZFDLZMUKBCUENZLZUNULULBF
      AOZFPZUKULUAUKUNULBCUMEHUMQZJUBUFZURUKULUCZUSUKUNUNMULULMRZBBCUDNZOFAOBUO
      AOPZUPCSNZFAOESNZPZUTUODLBFFETNZOAOUOUOVFOZPBBCTNZOFAOVGPRVBUPVERVFVHBBAV
      ABCUMVCDEFFVDGVFQIVDQHUQVHQVAQJVCQUGUHUIUJ $.
  $}

  ${
    slmd0vcl.v $e |- V = ( Base ` W ) $.
    slmd0vcl.z $e |- .0. = ( 0g ` W ) $.
    $( The zero vector is a vector.  ( ~ ax-hv0cl analog.)  (Contributed by NM,
       10-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    slmd0vcl $p |- ( W e. SLMod -> .0. e. V ) $=
      ( cslmd wcel cmnd slmdmnd mndidcl syl ) BFGBHGCAGBIABCDEJK $.
  $}

  ${
    slmd0vlid.v $e |- V = ( Base ` W ) $.
    slmd0vlid.a $e |- .+ = ( +g ` W ) $.
    slmd0vlid.z $e |- .0. = ( 0g ` W ) $.
    $( Left identity law for the zero vector.  ( ~ hvaddid2 analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmd0vlid $p |- ( ( W e. SLMod /\ X e. V ) -> ( .0. .+ X ) = X ) $=
      ( cslmd wcel cmnd co wceq slmdmnd mndlid sylan ) CIJCKJDBJEDALDMCNBACDEFG
      HOP $.

    $( Right identity law for the zero vector.  ( ~ ax-hvaddid analog.)
       (Contributed by NM, 10-Jan-2014.)  (Revised by Mario Carneiro,
       19-Jun-2014.)  (Revised by Thierry Arnoux, 1-Apr-2018.) $)
    slmd0vrid $p |- ( ( W e. SLMod /\ X e. V ) -> ( X .+ .0. ) = X ) $=
      ( cslmd wcel cmnd co wceq slmdmnd mndrid sylan ) CIJCKJDBJDEALDMCNBACDEFG
      HOP $.
  $}

  ${
    slmd0vs.v $e |- V = ( Base ` W ) $.
    slmd0vs.f $e |- F = ( Scalar ` W ) $.
    slmd0vs.s $e |- .x. = ( .s ` W ) $.
    slmd0vs.o $e |- O = ( 0g ` F ) $.
    slmd0vs.z $e |- .0. = ( 0g ` W ) $.
    $( Zero times a vector is the zero vector.  Equation 1a of [Kreyszig]
       p. 51.  ( ~ ax-hvmul0 analog.)  (Contributed by NM, 12-Jan-2014.)
       (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by Thierry Arnoux,
       1-Apr-2018.) $)
    slmd0vs $p |- ( ( W e. SLMod /\ X e. V ) -> ( O .x. X ) = .0. ) $=
      ( wcel wa cfv co wceq cplusg w3a eqid cslmd cmulr cur simpl slmd0cl simpr
      cbs syl slmdlema syl122anc simprd simp3d ) EUAMZFDMZNZCCBUBOZPFAPCCFAPZAP
      QZBUCOZFAPFQZUQGQZUOUQDMCFFEROZPAPUQUQVBPZQCCBROZPFAPVCQSZURUTVASZUOUMCBU
      GOZMZVHUNUNVEVFNUMUNUDZUOUMVHVIBVGECIVGTZKUEUHZVKUMUNUFZVLVBVDCCAUPUSBVGC
      DEFFGHVBTJLIVJVDTUPTUSTKUIUJUKUL $.
  $}

  ${
    slmdvs0.f $e |- F = ( Scalar ` W ) $.
    slmdvs0.s $e |- .x. = ( .s ` W ) $.
    slmdvs0.k $e |- K = ( Base ` F ) $.
    slmdvs0.z $e |- .0. = ( 0g ` W ) $.
    $( Anything times the zero vector is the zero vector.  Equation 1b of
       [Kreyszig] p. 51.  ( ~ hvmul0 analog.)  (Contributed by NM,
       12-Jan-2014.)  (Revised by Mario Carneiro, 19-Jun-2014.)  (Revised by
       Thierry Arnoux, 1-Apr-2018.) $)
    slmdvs0 $p |- ( ( W e. SLMod /\ X e. K ) -> ( X .x. .0. ) = .0. ) $=
      ( cslmd wcel wa c0g cfv cmulr co wceq eqid adantr csrg srgrz sylan oveq1d
      slmdsrg cbs simpl simpr srg0cl slmd0vcl slmdvsass syl13anc slmd0vs syldan
      syl oveq2d eqtrd 3eqtr3d ) DKLZECLZMZEBNOZBPOZQZFAQZVBFAQZEFAQZFVAVDVBFAU
      SBUALZUTVDVBRBDGUEZCBVCEVBIVCSZVBSZUBUCUDVAVEEVFAQZVGVAUSUTVBCLZFDUFOZLZV
      EVLRUSUTUGUSUTUHVAVHVMUSVHUTVITCBVBIVKUIUOUSVOUTVNDFVNSZJUJTZEVBAVCBCVNDF
      VPGHIVJUKULVAVFFEAUSUTVOVFFRVQABVBVNDFFVPGHVKJUMUNZUPUQVRUR $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Finitely supported group sums - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d k A $.  $d k B $.  $d k D $.  $d k E $.  $d k ph $.  $d k V $.
    $d k W $.
    sumpr.1 $e |- ( k = A -> C = D ) $.
    sumpr.2 $e |- ( k = B -> C = E ) $.
    sumpr.3 $e |- ( ph -> ( D e. CC /\ E e. CC ) ) $.
    sumpr.4 $e |- ( ph -> ( A e. V /\ B e. W ) ) $.
    sumpr.5 $e |- ( ph -> A =/= B ) $.
    $( A sum over a pair is the sum of the elements.  (Contributed by Thierry
       Arnoux, 12-Dec-2016.) $)
    sumpr $p |- ( ph -> sum_ k e. { A , B } C = ( D + E ) ) $=
      ( csu csn caddc wceq wcel cc cpr co wne cin disjsn2 syl cun df-pr a1i cfn
      c0 prfi wral wa wb eleq1d ralprg mpbird r19.21bi fsumsplit simpld syl2anc
      cv sumsn simprd oveq12d eqtrd ) ABCUAZDFOBPZDFOZCPZDFOZQUBEGQUBAVIVKDVHFA
      BCUCVIVKUDUKRNBCUEUFVHVIVKUGRABCUHUIVHUJSABCULUIADTSZFVHAVMFVHUMZETSZGTSZ
      UNZLABHSZCISZUNVNVQUOMVMVOVPFBCHIFVCZBRDETJUPVTCRDGTKUPUQUFURUSUTAVJEVLGQ
      AVRVOVJERAVRVSMVAAVOVPLVADEFBHJVDVBAVSVPVLGRAVRVSMVEAVOVPLVEDGFCIKVDVBVFV
      G $.
  $}

  ${
    $d k B $.  $d k C $.  $d k G $.  $d k M $.  $d k ph $.
    gsumsn2.b $e |- B = ( Base ` G ) $.
    gsumsn2.g $e |- G e. Mnd $.
    gsumsn2.s $e |- ( ( ph /\ k = M ) -> A = C ) $.
    gsumsn2.m $e |- ( ph -> M e. V ) $.
    gsumsn2.c $e |- ( ph -> C e. B ) $.
    $( Group sum of a singleton.  (Contributed by Thierry Arnoux,
       30-Jan-2017.) $)
    gsumsn2 $p |- ( ph -> ( G gsum ( k e. { M } |-> A ) ) = C ) $=
      ( cmpt cgsu co cfv c1 wcel wceq csn chash cmg elsni sylan2 mpteq2dva cmnd
      oveq2d cfn a1i snfi eqid gsumconst syl3anc eqtrd hashsng syl oveq1d mulg1
      cv 3eqtrd ) AFEGUAZBNZOPZVBUBQZDFUCQZPZRDVFPZDAVDFEVBDNZOPZVGAVCVIFOAEVBB
      DEUTZVBSAVKGTBDTVKGUDKUEUFUHAFUGSZVBUISZDCSZVJVGTVLAJUJVMAGUKUJMVBCVFEFDI
      VFULZUMUNUOAVERDVFAGHSVERTLGHUPUQURAVNVHDTMCVFFDIVOUSUQVA $.
  $}

  ${
    $d a b A $.  $d a b B $.  $d a b f m n s t x F $.  $d a b f m n s t x G $.
    $d a b f m n s t x H $.  $d a b f m n s t x ph $.
    gsumpropd2.f $e |- ( ph -> F e. V ) $.
    gsumpropd2.g $e |- ( ph -> G e. W ) $.
    gsumpropd2.h $e |- ( ph -> H e. X ) $.
    gsumpropd2.b $e |- ( ph -> ( Base ` G ) = ( Base ` H ) ) $.
    gsumpropd2.c $e |- ( ( ph /\ ( s e. ( Base ` G ) /\ t e. ( Base ` G ) ) )
                                -> ( s ( +g ` G ) t ) e. ( Base ` G ) ) $.
    gsumpropd2.e $e |- ( ( ph /\ ( s e. ( Base ` G ) /\ t e. ( Base ` G ) ) )
                                -> ( s ( +g ` G ) t ) = ( s ( +g ` H ) t ) ) $.
    gsumpropd2.n $e |- ( ph -> Fun F ) $.
    gsumpropd2.r $e |- ( ph -> ran F C_ ( Base ` G ) ) $.
    ${
      gsumprop2dlem.1 $e |- A = ( `' F " ( _V \ { s e. ( Base ` G ) | A. t e. (
       Base ` G ) ( ( s ( +g ` G ) t ) = t /\ ( t ( +g ` G ) s ) = t ) } ) ) $.
      gsumprop2dlem.2 $e |- B = ( `' F " ( _V \ { s e. ( Base ` H ) | A. t e. (
       Base ` H ) ( ( s ( +g ` H ) t ) = t /\ ( t ( +g ` H ) s ) = t ) } ) ) $.
      $( Lemma for ~ gsumpropd2 (Contributed by Thierry Arnoux,
         28-Jun-2017.) $)
      gsumpropd2lem $p |- ( ph -> ( G gsum F ) = ( H gsum F ) ) $=
        ( vm vn vx vf va vb crn cv cplusg cfv co wceq cbs wral crab wss c0g cdm
        wa cfz wcel cseq cuz wrex wex cio c1 chash wf1o ccom cif cgsu adantr wb
        eqeq1d proplem ancom2s anbi12d anassrs raleqbidva rabeqbidva grpidpropd
        sseq2d eqidd simprl ad2antrr wfun simpr simplrr eleqtrrd fvelrn syl2anc
        sseldd adantlr seqfeq4 eqeq2d pm5.32da rexbidva iotabidv ccnv cdif cima
        exbidv cvv difeq2d imaeq2d 3eqtr4g fveq2d ad3antrrr f1ofun f1odm oveq2d
        ad3antlr eqtrd fvco difpreima syl syl5eq difss syl6eqss dfdm4 syl6sseqr
        dfrn4 eqtri sylan wn c0 wfn 1z seqfn fndm mp2b sylnibr ndmfv bitrd eqid
        eleq2i a1i gsumvalx wf ffvelrnd eqeltrd simpll caovclg eqtr4d pm2.61dan
        f1of cz f1oeq2 f1oeq3 anbi1d ifeq12d ifbieq12d 3eqtr4d ) AEUHZKUIZBUIZF
        UJUKZULZUURUMZUURUUQUUSULZUURUMZUTZBFUNUKZUOZKUVEUPZUQZFURUKZEUSZVAUHVB
        ZUVJUBUIZUCUIZVAULZUMZUDUIZUVMUUSEUVLVCUKZUMZUTZUCUVLVDUKZVEZUBVFZUDVGZ
        VHCVIUKZVAULZCUEUIZVJZUVPUWDUUSEUWFVKZVHVCZUKZUMZUTZUEVFZUDVGZVLZVLUUPU
        UQUURGUJUKZULZUURUMZUURUUQUWPULZUURUMZUTZBGUNUKZUOZKUXBUPZUQZGURUKZUVKU
        VOUVPUVMUWPEUVLVCUKZUMZUTZUCUVTVEZUBVFZUDVGZVHDVIUKZVAULZDUWFVJZUVPUXMU
        WPUWHVHVCZUKZUMZUTZUEVFZUDVGZVLZVLFEVMULGEVMULAUVHUXEUVIUWOUXFUYBAUVGUX
        DUUPAUVFUXCKUVEUXBOAUUQUVEVBZUTUVDUXABUVEUXBAUVEUXBUMUYCOVNAUYCUURUVEVB
        ZUVDUXAVOAUYCUYDUTZUTZUVAUWRUVCUWTUYFUUTUWQUURQVPUYFUVBUWSUURAUYDUYCUVB
        UWSUMAUFUGUVEUVEUUSUWPUURUUQAKBUVEUVEUUSUWPUFUIZUGUIZQVQZVQVRVPVSVTWAWB
        ZWDAKBUVEFGAUVEWEOQWCAUVKUWCUXLUWNUYAAUWBUXKUDAUWAUXJUBAUVSUXIUCUVTAUVM
        UVTVBZUTUVOUVRUXHAUYKUVOUVRUXHVOAUYKUVOUTZUTZUVQUXGUVPUYMKBUUSUWPUVEEUV
        LUVMAUYKUVOWFUYMUUQUVNVBZUTZUUPUVEUUQEUKZAUUPUVEUQZUYLUYNSWGUYOEWHZUUQU
        VJVBUYPUUPVBAUYRUYLUYNRWGUYOUUQUVNUVJUYMUYNWIAUYKUVOUYNWJWKUUQEWLWMWNAU
        YEUUTUVEVBUYLPWOAUYEUUTUWQUMUYLQWOWPWQVTWRWSXDWTAUWMUXTUDAUWLUXSUEAUWLU
        WGUXRUTUXSAUWGUWKUXRAUWGUTZUWJUXQUVPUYSUWJUXMUWIUKZUXQAUWJUYTUMUWGAUWDU
        XMUWIACDVIAEXAZXEUVGXBZXCZVUAXEUXDXBZXCZCDAVUBVUDVUAAUVGUXDXEUYJXFXGTUA
        XHZXIZXIVNUYSUXMVHVDUKZVBZUYTUXQUMZUYSVUIUTZUFUGUUSUWPUVEUWHVHUXMUYSVUI
        WIVUKUYGUXNVBZUTZUUPUVEUYGUWHUKZAUYQUWGVUIVULSXJVUMVUNUYGUWFUKZEUKZUUPV
        UMUWFWHZUYGUWFUSZVBVUNVUPUMUWGVUQAVUIVULUWECUWFXKXNVUMUYGUXNVURVUKVULWI
        ZVUMVURUWEUXNUWGVURUWEUMAVUIVULUWECUWFXLXNAUWEUXNUMZUWGVUIVULAUWDUXMVHV
        AVUGXMZXJZXOWKUYGEUWFXPWMVUMUYRVUOUVJVBVUPUUPVBAUYRUWGVUIVULRXJVUMCUVJV
        UOACUVJUQUWGVUIVULACVUAXEXCZUVJACVVCVUAUVGXCZXBZVVCACVUCVVETAUYRVUCVVEU
        MRXEUVGEXQXRXSVVCVVDXTYAUVJVUAUHVVCEYBVUAYDYEYCXJVUMUWECUYGUWFUWGUWECUW
        FUUAAVUIVULUWECUWFUUHXNVUMUYGUXNUWEVUSVVBWKUUBWNVUOEWLWMUUCWNVUKAUYGUVE
        VBUYHUVEVBUTZUYGUYHUUSULZUVEVBAUWGVUIUUDZAKBUYGUYHUVEUVEUVEUUSPUUEYFVUK
        AVVFVVGUYGUYHUWPULUMVVHUYIYFWPAVUIYGZVUJUWGAVVIUTZUYTYHUXQVVJUXMUWIUSZV
        BZYGUYTYHUMVVJVUIVVLAVVIWIZVVKVUHUXMVHUUIVBZUWIVUHYIVVKVUHUMYJUUSUWHVHY
        KVUHUWIYLYMYRYNUXMUWIYOXRVVJUXMUXPUSZVBZYGUXQYHUMVVJVUIVVPVVMVVOVUHUXMV
        VNUXPVUHYIVVOVUHUMYJUWPUWHVHYKVUHUXPYLYMYRYNUXMUXPYOXRUUFWOUUGXOWQWRAUW
        GUXOUXRAUWGUXNCUWFVJZUXOAVUTUWGVVQVOVVAUWEUXNCUWFUUJXRACDUMVVQUXOVOVUFC
        DUXNUWFUUKXRYPUULYPXDWTUUMUUNAUDBUVJUVEUUSUEUBUCEFUVGICHUVIKUVEYQUVIYQU
        USYQUVGYQCVUCUMATYSMLAUVJWEZYTAUDBUVJUXBUWPUEUBUCEGUXDJDHUXFKUXBYQUXFYQ
        UWPYQUXDYQDVUEUMAUAYSNLVVRYTUUO $.
    $}

    $( A stronger version of ~ gsumpropd , working for magma, where only the
       closure of the addition operation on a common base is required.
       (Contributed by Thierry Arnoux, 28-Jun-2017.) $)
    gsumpropd2 $p |- ( ph -> ( G gsum F ) = ( H gsum F ) ) $=
      ( cfv co wceq ccnv cvv cv cplusg wa cbs wral crab cdif cima gsumpropd2lem
      eqid ) ABCUAZUBIUCZBUCZDUDRZSUOTUOUNUPSUOTUEBDUFRZUGIUQUHUIUJZUMUBUNUOEUD
      RZSUOTUOUNUSSUOTUEBEUFRZUGIUTUHUIUJZCDEFGHIJKLMNOPQURULVAULUK $.
  $}

  ${
    $d k l A $.  $d l B $.  $d l G $.  $d l X $.
    gsumconstf.k $e |- F/_ k X $.
    gsumconstf.b $e |- B = ( Base ` G ) $.
    gsumconstf.m $e |- .x. = ( .g ` G ) $.
    $( Sum of a constant series (Contributed by Thierry Arnoux, 5-Jul-2017.) $)
    gsumconstf $p |- ( ( G e. Mnd /\ A e. Fin /\ X e. B ) ->
      ( G gsum ( k e. A |-> X ) ) = ( ( # ` A ) .x. X ) ) $=
      ( vl cmnd wcel cfn w3a cmpt cgsu co chash cfv nfcv eqidd cbvmpt gsumconst
      weq oveq2i syl5eq ) EKLAMLFBLNEDAFOZPQEJAFOZPQARSFCQUGUHEPDJAFFJFTGDJUDFU
      AUBUEABCJEFHIUCUF $.
  $}

  ${
    $d k B $.  $d k G $.  $d k M $.
    gsumsnf.c $e |- F/_ k C $.
    gsumsnf.b $e |- B = ( Base ` G ) $.
    gsumsnf.s $e |- ( k = M -> A = C ) $.
    $( Group sum of a singleton.  (Contributed by Mario Carneiro,
       19-Dec-2014.)  (Revised by Mario Carneiro, 24-Apr-2016.) $)
    gsumsnf $p |- ( ( G e. Mnd /\ M e. V /\ C e. B ) ->
      ( G gsum ( k e. { M } |-> A ) ) = C ) $=
      ( cmnd wcel w3a csn cmpt cgsu co cfv c1 wceq chash cmg elsni syl mpteq2ia
      cv oveq2i cfn snfi eqid gsumconstf mp3an2 3adant2 syl5eq hashsng 3ad2ant2
      oveq1d mulg1 3ad2ant3 3eqtrd ) EKLZFGLZCBLZMZEDFNZAOZPQZVEUARZCEUBRZQZSCV
      IQZCVDVGEDVECOZPQZVJVFVLEPDVEACDUFZVELVNFTACTVNFUCJUDUEUGVAVCVMVJTZVBVAVE
      UHLVCVOFUIVEBVIDECHIVIUJZUKULUMUNVDVHSCVIVBVAVHSTVCFGUOUPUQVCVAVKCTVBBVIE
      CIVPURUSUT $.
  $}

  ${
    $d k A $.  $d k B $.  $d k G $.  $d k M $.  $d k ph $.
    gsumunsnf.0 $e |- F/_ k Y $.
    gsumunsnf.b $e |- B = ( Base ` G ) $.
    gsumunsnf.p $e |- .+ = ( +g ` G ) $.
    gsumunsnf.g $e |- ( ph -> G e. CMnd ) $.
    gsumunsnf.a $e |- ( ph -> A e. Fin ) $.
    gsumunsnf.f $e |- ( ( ph /\ k e. A ) -> X e. B ) $.
    gsumunsnf.m $e |- ( ph -> M e. V ) $.
    gsumunsnf.d $e |- ( ph -> -. M e. A ) $.
    gsumunsnf.y $e |- ( ph -> Y e. B ) $.
    gsumunsnf.s $e |- ( k = M -> X = Y ) $.
    $( Append an element to a finite group sum.  (Contributed by Mario
       Carneiro, 19-Dec-2014.) $)
    gsumunsnf $p |- ( ph -> ( G gsum ( k e. ( A u. { M } ) |-> X ) ) =
      ( ( G gsum ( k e. A |-> X ) ) .+ Y ) ) $=
      ( csn cun cmpt cgsu co cfn c0g cfv eqid wcel snfi unfi sylancl cv wo elun
      wa wceq elsni syl adantl adantr eqeltrd jaodan sylan2b ccnv cvv cdif cima
      wss cdm cnvimass dmmptss sstri ssfi wn cin disjsn sylibr eqidd gsumsplit2
      c0 cmnd ccmn cmnmnd gsumsnf syl3anc oveq2d eqtrd ) AFEBGUAZUBZIUCZUDUEFEB
      IUCUDUEZFEWJIUCUDUEZDUEWMJDUEAWKCBWJDEFUFIFUGUHZLWOUIMNABUFUJWJUFUJWKUFUJ
      ZOGUKBWJULUMZEUNZWKUJAWRBUJZWRWJUJZUOICUJZWRBWJUPAWSXAWTPAWTUQIJCWTIJURZA
      WTWRGURXBWRGUSTUTVAAJCUJZWTSVBVCVDVEAWPWLVFVGWOUAVHZVIZWKVJXEUFUJWQXEWLVK
      WKWLXDVLEWKIWLWLUIVMVNWKXEVOUMAGBUJVPBWJVQWBURRBGVRVSAWKVTWAAWNJWMDAFWCUJ
      ZGHUJXCWNJURAFWDUJXFNFWEUTQSICJEFGHKLTWFWGWHWI $.
  $}

  ${
    $( TODO can be shortened using ~ gsumunsn $)
    $d a e y .<_ $.  $d a e x y A $.  $d x B $.  $d a e x y F $.
    $d a e x y G $.  $d a e x y M $.  $d a e y ph $.
    gsumle.b $e |- B = ( Base ` M ) $.
    gsumle.l $e |- .<_ = ( le ` M ) $.
    gsumle.m $e |- ( ph -> M e. oMnd ) $.
    gsumle.n $e |- ( ph -> M e. CMnd ) $.
    gsumle.a $e |- ( ph -> A e. Fin ) $.
    gsumle.f $e |- ( ph -> F : A --> B ) $.
    gsumle.g $e |- ( ph -> G : A --> B ) $.
    gsumle.c $e |- ( ph -> F oR .<_ G ) $.
    $( A finite sum in an ordered monoid is monotonic.  This proof would be
       much easier in an ordered group, where an inverse element would be
       available.  (Contributed by Thierry Arnoux, 13-Mar-2018.) $)
    gsumle $p |- ( ph -> ( M gsum F ) .<_ ( M gsum G ) ) $=
      ( cres cgsu co wcel wceq va ve vy vx cfn wbr wss ssid wa cv wi c0 csn cun
      sseq1 anbi2d reseq2 oveq2d breq12d imbi12d comnd ctos omndtos tospos 3syl
      cpo c0g res0 oveq2i eqid gsum0 eqtri cmnd omndmnd mndidcl syl5eqel posref
      cfv syl2anc eqtr4i breq2i sylib adantr wn ssun1 sstr2 ax-mp anim2i imim1i
      simplr simpllr simpr cplusg ad3antrrr wf ad2antrr ssun2 snss mpbir sseldd
      vex a1i ffvelrnd ccmn syl5ss fssres cdif ssfi fisuppfi gsumcl cofr simpll
      cvv syl wfn ffn inidm eqidd ofrval syl3anc ccnv cima cdm cnvimass sseqtri
      dmres inss1 sstri gsumsplit resabs1 oveq12i syl6eq feqresmpt fveq2 gsumsn
      cin cmpt eqtrd ex fnresdm omndadd2d disjsn sylibr cmnmnd 3brtr4d syl21anc
      snex unex a2d syl5 findcard2s imp mpanr2 mpancom 3brtr3d ) AGDBPZQRZGEBPZ
      QRZGDQRGEQRFBUESZAUUQUUSFUFZLUUTABBUGZUVABUHUUTAUVBUIZUVAAUAUJZBUGZUIZGDU
      VDPZQRZGEUVDPZQRZFUFZUKAULBUGZUIZGDULPZQRZGEULPZQRZFUFZUKAUBUJZBUGZUIZGDU
      VSPZQRZGEUVSPZQRZFUFZUKZAUVSUCUJZUMZUNZBUGZUIZGDUWJPZQRZGEUWJPZQRZFUFZUKZ
      UVCUVAUKUAUBUCBUVDULTZUVFUVMUVKUVRUWSUVEUVLAUVDULBUOUPUWSUVHUVOUVJUVQFUWS
      UVGUVNGQUVDULDUQURUWSUVIUVPGQUVDULEUQURUSUTUVDUVSTZUVFUWAUVKUWFUWTUVEUVTA
      UVDUVSBUOUPUWTUVHUWCUVJUWEFUWTUVGUWBGQUVDUVSDUQURUWTUVIUWDGQUVDUVSEUQURUS
      UTUVDUWJTZUVFUWLUVKUWQUXAUVEUWKAUVDUWJBUOUPUXAUVHUWNUVJUWPFUXAUVGUWMGQUVD
      UWJDUQURUXAUVIUWOGQUVDUWJEUQURUSUTUVDBTZUVFUVCUVKUVAUXBUVEUVBAUVDBBUOUPUX
      BUVHUUQUVJUUSFUXBUVGUUPGQUVDBDUQURUXBUVIUURGQUVDBEUQURUSUTAUVRUVLAUVOUVOF
      UFZUVRAGVFSZUVOCSUXCAGVASZGVBSUXDJGVCGVDVEAUVOGVGVRZCUVOGULQRUXFUVNULGQDV
      HZVIGUXFUXFVJZVKVLAUXEGVMSZUXFCSJGVNCGUXFHUXHVOVEVPCGFUVOHIVQVSUVOUVQUVOF
      UVNUVPGQUVNULUVPUXGEVHVTVIWAWBWCUWGUWLUWFUKUVSUESZUWHUVSSWDZUIZUWRUWLUWAU
      WFUWKUVTAUVSUWJUGZUWKUVTUKUVSUWIWEZUVSUWJBWFWGWHWIUXLUWLUWFUWQUXLUWLUWFUW
      QUKUXLUWLUIZUWFUWQUXOUWFUIUWLUXKUWFUWQUXLUWLUWFWJUXJUXKUWLUWFWKUXOUWFWLUW
      LUXKUIZUWFUIZUWCUWHDVRZGWMVRZRZUWEUWHEVRZUXSRZUWNUWPFUXQCUXSFGUYAUWCUXRUW
      EHIUXSVJZAUXEUWKUXKUWFJWNUXPUYACSZUWFUXPBCUWHEABCEWOZUWKUXKNWPZUXPUWJBUWH
      AUWKUXKWJZUWHUWJSZUXPUYHUWIUWJUGZUWIUVSWQZUWHUWJUCXAZWRWSXBWTZXCZWCUXPUWC
      CSUWFUXPUVSCUWBGXMUXFHUXHAGXDSZUWKUXKKWPZUVSXMSUXPUBXAZXBZUXPBCDWOZUVTUVS
      CUWBWOAUYRUWKUXKMWPZUXPUVSUWJBUXNUYGXEZBCUVSDXFVSZUXPUVSCXMUXFUMXGZUWBUXP
      UUTUVTUXJAUUTUWKUXKLWPZUYTBUVSXHVSZVUAXIXJWCUXPUXRCSZUWFUXPBCUWHDUYSUYLXC
      ZWCUXPUWECSUWFUXPUVSCUWDGXMUXFHUXHUYOUYQUXPUYEUVTUVSCUWDWOUYFUYTBCUVSEXFV
      SZUXPUVSCVUBUWDVUDVUGXIXJWCUXPUWFWLUXPUXRUYAFUFZUWFUXPADEFXKUFZUWHBSZVUHA
      UWKUXKXLZUXPAVUIVUKOXNUYLABBUXRUYAFBDEUEUEUWHAUYRDBXOZMBCDXPXNZAUYEEBXOZN
      BCEXPXNZLLBXQAVUJUIZUXRXRVUPUYAXRXSXTWCUXPUYNUWFUYOWCUUAUXPUWNUXTTUWFUXPU
      WNUWCGDUWIPZQRZUXSRZUXTUXPUWNGUWMUVSPZQRZGUWMUWIPZQRZUXSRVUSUXPUWJCUVSUWI
      UXSUWMGXMUXFHUXHUYCUYOUWJXMSUXPUVSUWIUYPUWHUUGUUHXBZUXPUYRUWKUWJCUWMWOUYS
      UYGBCUWJDXFVSUXPUUTUWMYAVUBYBZBUGVVEUESVUCUXPVVEUWJBVVEUWJDYCZYPZUWJVVEUW
      MYCVVGUWMVUBYDDUWJYFYEUWJVVFYGYHUYGXEBVVEXHVSUXPUXKUVSUWIYPULTUWLUXKWLUVS
      UWHUUBUUCZUXPUWJXRZYIVVAUWCVVCVURUXSVUTUWBGQUXMVUTUWBTUXNDUVSUWJYJWGVIVVB
      VUQGQUYIVVBVUQTUYJDUWIUWJYJWGVIYKYLUXPVURUXRUWCUXSUXPVURGUDUWIUDUJZDVRZYQ
      ZQRZUXRUXPVUQVVLGQUXPUDBCUWIDUYSUXPUWIUWJBUYJUYGXEZYMURUXPUXIUWHXMSZVUEVV
      MUXRTUXPUYNUXIUYOGUUDXNZVVOUXPUYKXBZVUFVVKCUXRUDGUWHXMHVVJUWHDYNYOXTYRURY
      RWCUXPUWPUYBTUWFUXPUWPUWEGEUWIPZQRZUXSRZUYBUXPUWPGUWOUVSPZQRZGUWOUWIPZQRZ
      UXSRVVTUXPUWJCUVSUWIUXSUWOGXMUXFHUXHUYCUYOVVDUXPUYEUWKUWJCUWOWOUYFUYGBCUW
      JEXFVSUXPUUTUWOYAVUBYBZBUGVWEUESVUCUXPVWEUWJBVWEUWJEYCZYPZUWJVWEUWOYCVWGU
      WOVUBYDEUWJYFYEUWJVWFYGYHUYGXEBVWEXHVSVVHVVIYIVWBUWEVWDVVSUXSVWAUWDGQUXMV
      WAUWDTUXNEUVSUWJYJWGVIVWCVVRGQUYIVWCVVRTUYJEUWIUWJYJWGVIYKYLUXPVVSUYAUWEU
      XSUXPVVSGUDUWIVVJEVRZYQZQRZUYAUXPVVRVWIGQUXPUDBCUWIEUYFVVNYMURUXPUXIVVOUY
      DVWJUYATVVPVVQUYMVWHCUYAUDGUWHXMHVVJUWHEYNYOXTYRURYRWCUUEUUFYSYSUUIUUJUUK
      UULUUMUUNAUUPDGQAVULUUPDTVUMBDYTXNURAUUREGQAVUNUURETVUOBEYTXNURUUO $.
  $}

  ${
    $d x y A $.  $d x B $.  $d y C $.  $d x y D $.  $d x E $.  $d x y ph $.
    gsummptf1o.x $e |- F/_ x H $.
    gsummptf1o.b $e |- B = ( Base ` G ) $.
    gsummptf1o.z $e |- .0. = ( 0g ` G ) $.
    gsummptf1o.i $e |- ( x = E -> C = H ) $.
    gsummptf1o.g $e |- ( ph -> G e. CMnd ) $.
    gsummptf1o.a $e |- ( ph -> A e. Fin ) $.
    gsummptf1o.d $e |- ( ph -> F C_ B ) $.
    gsummptf1o.f $e |- ( ( ph /\ x e. A ) -> C e. F ) $.
    gsummptf1o.e $e |- ( ( ph /\ y e. D ) -> E e. A ) $.
    gsummptf1o.h $e |- ( ( ph /\ x e. A ) -> E! y e. D x = E ) $.
    $( Re-index a finite group sum using a bijection.  (Contributed by Thierry
       Arnoux, 29-Mar-2018.) $)
    gsummptf1o $p |- ( ph -> ( G gsum ( x e. A |-> C ) )
      = ( G gsum ( y e. D |-> H ) ) ) $=
      ( cmpt cgsu co ccom cfn cv wcel wss adantr sseldd eqid fmptd cvv csn cdif
      wa fisuppfi wral wceq wreu wf1o ralrimiva f1ompt sylanbrc gsumf1o fmptcos
      csb eqidd nfv wnfc a1i adantl csbiedf mpteq2dva eqtrd oveq2d ) AJBDFUCZUD
      UEJVSCGHUCZUFZUDUEJCGKUCZUDUEADEGVSJVTUGLNOQRABDFEVSABUHZDUIZURIEFAIEUJWD
      SUKTULVSUMUNZADEUOLUPUQVSRWEUSAHDUIZCGUTWCHVAZCGVBZBDUTGDVTVCAWFCGUAVDZAW
      HBDUBVDCBGDHVTVTUMVEVFVGAWAWBJUDAWACGBHFVIZUCWBACBGDHFVTVSWIAVTVJAVSVJVHA
      CGWJKACUHGUIURZBHFKDWKBVKBKVLWKMVMUAWGFKVAWKPVNVOVPVQVRVQ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x ph $.
    gsummptun.b $e |- B = ( Base ` W ) $.
    gsummptun.z $e |- .0. = ( 0g ` W ) $.
    gsummptun.p $e |- .+ = ( +g ` W ) $.
    gsummptun.w $e |- ( ph -> W e. CMnd ) $.
    gsummptun.a $e |- ( ph -> ( A u. C ) e. Fin ) $.
    gsummptun.d $e |- ( ph -> ( A i^i C ) = (/) ) $.
    gsummptun.1 $e |- ( ( ph /\ x e. ( A u. C ) ) -> D e. B ) $.
    $( Group sum of a disjoint union, whereas sums are expressed as mappings.
       (Contributed by Thierry Arnoux, 28-Mar-2018.) $)
    gsummptun $p |- ( ph -> ( W gsum ( x e. ( A u. C ) |-> D ) ) =
      ( ( W gsum ( x e. A |-> D ) ) .+ ( W gsum ( x e. C |-> D ) ) ) ) $=
      ( cmpt cgsu co cres cun cfn eqid fmptd cdif fisuppfi eqidd gsumsplit wceq
      cvv csn wss ssun1 resmpt ax-mp oveq2i ssun2 oveq12i syl6eq ) AHBCEUAZFQZR
      SHVACTZRSZHVAETZRSZGSHBCFQZRSZHBEFQZRSZGSAUTDCEGVAHUBIJKLMNABUTFDVAPVAUCU
      DZAUTDUJIUKUEVANVJUFOAUTUGUHVCVGVEVIGVBVFHRCUTULVBVFUICEUMBUTCFUNUOUPVDVH
      HREUTULVDVHUIECUQBUTEFUNUOUPURUS $.
  $}

  ${
    $d p x y A $.  $d p x y B $.  $d p y C $.  $d p x y E $.  $d p x y F $.
    $d p x y ph $.  $d x y .0. $.  $d x y W $.
    gsummpt2co.b $e |- B = ( Base ` W ) $.
    gsummpt2co.z $e |- .0. = ( 0g ` W ) $.
    gsummpt2co.w $e |- ( ph -> W e. CMnd ) $.
    gsummpt2co.a $e |- ( ph -> A e. Fin ) $.
    gsummpt2co.e $e |- ( ph -> E ~<_ om ) $.
    gsummpt2co.1 $e |- ( ( ph /\ x e. A ) -> C e. B ) $.
    gsummpt2co.2 $e |- ( ( ph /\ x e. A ) -> D e. E ) $.
    gsummpt2co.3 $e |- F = ( x e. A |-> D ) $.
    $( Split a finite sum into a sum of a collection of sums over disjoint
       subsets.  (Contributed by Thierry Arnoux, 27-Mar-2018.) $)
    gsummpt2co $p |- ( ph -> ( W gsum ( x e. A |-> C ) ) =
      ( W gsum ( y e. E |-> ( W gsum ( x e. ( `' F " { y } ) |-> C ) ) ) ) ) $=
      ( wcel vp cmpt cgsu co ccnv cv c2nd cfv csb csn cmpt2 nfcsb1v csbeq1a wss
      cima ssid a1i cop wceq wbr wex elcnv vex op2ndd adantr cdm dmmptss breldm
      wa sseldi adantl eqeltrd exlimivv sylbi wfun wreu funmpt2 funcnvcnv ax-mp
      crn dfdm4 dmeqi ralrimiva dmmptg syl syl5eq syl5eqr eleq2d biimpar relcnv
      wral wrel fcnvgreu mpanl1 syl2anc gsummptf1o cxp ciun rnmptss dfcnv2 nfcv
      mpteq1d csbeq1 csbid syl6eq mpt2mptxf oveq2d cvv cdom ctex mptfi syl5eqel
      com cnvfi 3syl imaexg simpll imassrn sseqtr4i sstri elimasn biimpi sylibr
      cfn anasss wn df-br pm2.24d imp gsum2d2 3eqtrd ) AJBDFUBUCUDJUAIUEZBUAUFZ
      UGUHZFUIZUBZUCUDJCBHYLCUFZUJZUOZFUKZUCUDJCHJBYSFUBUCUDUBUCUDABUADEFYLYNEJ
      YOKBYNFULZLMBYNFUMNOEEUNAEUPUQQYMYLTZYNDTZAUUBYMYQBUFZURZUSZUUDYQIUTZVIZB
      VACVAUUCCBYMIVBUUHUUCCBUUHYNUUDDUUFYNUUDUSZUUGYQUUDYMCVCZBVCZVDZVEUUGUUDD
      TZUUFUUGIVFZDUUDBDGISVGZUUDYQIUUKUUJVHVJVKVLVMVNVKAUUMVIZYLUEVOZUUDYLVTZT
      ZUUDYNUSUAYLVPZUUQUUPIVOUUQBDGISVQIVRVSUQAUUSUUMAUURDUUDAUURUUNDIWAZAUUNB
      DGUBZVFZDIUVBSWBAGHTZBDWKZUVCDUSAUVDBDRWCZBDGHWDWEWFWGWHWIYLWLUUQUUSUUTIW
      JYLUUDUAWMWNWOWPAYPYTJUCAYPUACHYRYSWQWRZYOUBYTAUAYLUVGYOAIVTHUNZYLUVGUSAU
      VEUVHUVFBDGHISWSWECHIWTWEXBCBUAHYSYOFCYOXAUUAUUFYOBUUDFUIZFUUFUUIYOUVIUSU
      ULBYNUUDFXCWEBFXDXEXFXEXGAHEYSYLCBJXHXHFKLMNAHXMXIUTHXHTPHXJWEAYSXHTZYQHT
      ZAYLYDTZUVJADYDTZIYDTUVLOUVMIUVBYDSBDGXKXLIXNXOZYLYRYDXPWEVEAUVKUUDYSTZFE
      TZAUVKVIZUVOVIZAUUMUVPAUVKUVOXQUVRYSDUUDYSUUNDYSUURUUNYLYRXRUVAXSUUOXTUVR
      UUEYLTZUVOUVOUVSUVQUVOUVSYLYQUUDUUJUUKYAZYBVKZUVTYCVJQWOYEUVNAUVKUVOVIZYQ
      UUDYLUTZYFZFKUSZAUWBVIZUWDUWEUWFUWCUWEAUVKUVOUWCUVRUVSUWCUWAYQUUDYLYGYCYE
      YHYIYEYJYK $.
  $}

  ${
    $d x A $.  $d x y B $.  $d y C $.  $d x y K $.  $d x ph $.
    gsummptmhm.b $e |- B = ( Base ` G ) $.
    gsummptmhm.z $e |- .0. = ( 0g ` G ) $.
    gsummptmhm.g $e |- ( ph -> G e. CMnd ) $.
    gsummptmhm.h $e |- ( ph -> H e. Mnd ) $.
    gsummptmhm.a $e |- ( ph -> A e. V ) $.
    gsummptmhm.k $e |- ( ph -> K e. ( G MndHom H ) ) $.
    gsummptmhm.c $e |- ( ( ph /\ x e. A ) -> C e. B ) $.
    gsummptmhm.w $e |- ( ph ->
                         ( `' ( x e. A |-> C ) " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Apply a group homomorphism to a group sum expressed with a mapping.
       (Contributed by Thierry Arnoux, 7-Sep-2018.) $)
    gsummptmhm $p |- ( ph -> ( H gsum ( x e. A |-> ( K ` C ) ) )
      = ( K ` ( G gsum ( x e. A |-> C ) ) ) ) $=
      ( vy cgsu cmpt ccom co cfv cv wceq eqid a1i wfn cmhm wcel cbs wf mhmf ffn
      3syl dffn5 sylib fveq2 fmptco oveq2d fmptd gsummhm eqtr3d ) AGHBCEUAZUBZT
      UCGBCEHUDZUAZTUCFVETUCHUDAVFVHGTABSCDESUEZHUDZVGVEHQVEVEUFAVEUGZUHAHDUIZH
      SDVJUAUFAHFGUJUCUKDGULUDZHUMVLPDVMFGHKVMUGUNDVMHUOUPSDHUQURVIEHUSUTVAACDV
      EFGHIJKLMNOPABCEDVEQVKVBRVCVD $.
  $}

  ${
    $d k A $.  $d k x ph $.
    regsumfsum.1 $e |- ( ph -> A e. Fin ) $.
    regsumfsum.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
    $( Relate a group sum on ` ( CCfld |``s RR ) ` to a finite sum on the
       reals.  Cf. ~ gsumfsum (Contributed by Thierry Arnoux, 7-Sep-2018.) $)
    regsumfsum $p |- ( ph -> ( ( CCfld |`s RR ) gsum ( k e. A |-> B ) )
                         = sum_ k e. A B ) $=
      ( vx ccnfld cgsu co cr cc caddc cvv cc0 eqid wcel a1i ax-resscn cv csu wa
      cmpt cress cfn cnfldbas cnfldadd cnfldex wss fmptd 0re wceq simpr addid2d
      addid1d jca gsumress sseldi gsumfsum eqtr3d ) AHDBCUCZIJHKUDJZVAIJBCDUAAG
      BLMKVAHVBNUEOUFUGVBPHNQAUHREKLUIASRADBCKVAFVAPUJOKQAUKRAGTZLQZUBZOVCMJVCU
      LVCOMJVCULVEVCAVDUMZUNVEVCVFUOUPUQABCDEADTBQUBKLCSFURUSUT $.
  $}

  ${
    $d a e k z .x. $.  $d a e k z A $.  $d a e z P $.  $d a e z Q $.
    $d a e k z W $.  $d a e k z ph $.  $d k B $.
    gsumvsca.b $e |- B = ( Base ` W ) $.
    gsumvsca.g $e |- G = ( Scalar ` W ) $.
    gsumvsca.z $e |- .0. = ( 0g ` W ) $.
    gsumvsca.t $e |- .x. = ( .s ` W ) $.
    gsumvsca.p $e |- .+ = ( +g ` W ) $.
    gsumvsca.k $e |- ( ph -> K C_ ( Base ` G ) ) $.
    gsumvsca.a $e |- ( ph -> A e. Fin ) $.
    gsumvsca.w $e |- ( ph -> W e. SLMod ) $.
    ${
      $d k P $.
      gsumvsca1.n $e |- ( ph -> P e. K ) $.
      gsumvsca1.c $e |- ( ( ph /\ k e. A ) -> Q e. B ) $.
      $( Scalar product of a finite group sum for a left module over a semiring
         (Contributed by Thierry Arnoux, 16-Mar-2018.) $)
      gsumvsca1 $p |- ( ph -> ( W gsum ( k e. A |-> ( P .x. Q ) ) ) =
                             ( P .x. ( W gsum ( k e. A |-> Q ) ) ) ) $=
        ( va ve vz cfn wcel co cmpt cgsu wceq wss ssid wa cv wi c0 sseq1 anbi2d
        csn cun mpteq1 oveq2d eqeq12d imbi12d cslmd cbs cfv sseldd eqid slmdvs0
        syl2anc eqcom sylibr mpt0 oveq2i gsum0 eqtri eqeq12i adantr ssun1 sstr2
        wn ax-mp anim2i imim1i csb ad2antrl cvv ccmn slmdcmn syl vex a1i simprr
        simplrl syl5ss sselda fmptd cdif simpll fisuppfi gsumcl wral ssun2 snss
        ralrimiva rspcsbela slmdvsdi nfcsb1v simplr csbeq1a gsumunsnf nfcv nfov
        syl13anc slmdvscl syl3anc simpr oveq1d eqtrd 3eqtr4rd ex a2d findcard2s
        syl5 imp mpanr2 mpancom ) BUFUGZAKHBDFGUHZUIZUJUHZDKHBFUIZUJUHZGUHZUKZS
        YJABBULZYQBUMYJAYRUNZYQAUCUOZBULZUNZKHYTYKUIZUJUHZDKHYTFUIZUJUHZGUHZUKZ
        UPAUQBULZUNZKHUQYKUIZUJUHZDKHUQFUIZUJUHZGUHZUKZUPAUDUOZBULZUNZKHUUQYKUI
        ZUJUHZDKHUUQFUIZUJUHZGUHZUKZUPZAUUQUEUOZUTZVAZBULZUNZKHUVIYKUIZUJUHZDKH
        UVIFUIZUJUHZGUHZUKZUPZYSYQUPUCUDUEBYTUQUKZUUBUUJUUHUUPUVSUUAUUIAYTUQBUR
        USUVSUUDUULUUGUUOUVSUUCUUKKUJHYTUQYKVBVCUVSUUFUUNDGUVSUUEUUMKUJHYTUQFVB
        VCVCVDVEYTUUQUKZUUBUUSUUHUVEUVTUUAUURAYTUUQBURUSUVTUUDUVAUUGUVDUVTUUCUU
        TKUJHYTUUQYKVBVCUVTUUFUVCDGUVTUUEUVBKUJHYTUUQFVBVCVCVDVEYTUVIUKZUUBUVKU
        UHUVQUWAUUAUVJAYTUVIBURUSUWAUUDUVMUUGUVPUWAUUCUVLKUJHYTUVIYKVBVCUWAUUFU
        VODGUWAUUEUVNKUJHYTUVIFVBVCVCVDVEYTBUKZUUBYSUUHYQUWBUUAYRAYTBBURUSUWBUU
        DYMUUGYPUWBUUCYLKUJHYTBYKVBVCUWBUUFYODGUWBUUEYNKUJHYTBFVBVCVCVDVEAUUPUU
        IALDLGUHZUKZUUPAUWCLUKZUWDAKVFUGZDIVGVHZUGZUWETAJUWGDRUAVIZGIUWGKDLNPUW
        GVJZOVKVLLUWCVMVNUULLUUOUWCUULKUQUJUHZLUUKUQKUJHYKVOVPKLOVQZVRUUNLDGUUN
        UWKLUUMUQKUJHFVOVPUWLVRVPVSVNVTUVFUVKUVEUPUUQUFUGZUVGUUQUGWCZUNZUVRUVKU
        USUVEUVJUURAUUQUVIULUVJUURUPUUQUVHWAZUUQUVIBWBWDWEWFUWOUVKUVEUVQUWOUVKU
        VEUVQUPUWOUVKUNZUVEUVQUWQUVEUNZDUVCHUVGFWGZEUHZGUHZUVDDUWSGUHZEUHZUVPUV
        MUWQUXAUXCUKZUVEUWQUWFUWHUVCCUGUWSCUGZUXDAUWFUWOUVJTWHZAUWHUWOUVJUWIWHZ
        UWQUUQCUVBKWILMOUWQUWFKWJUGUXFKWKWLZUUQWIUGUWQUDWMWNUWQHUUQFCUVBUWQHUOZ
        UUQUGZUNZAUXIBUGFCUGZUWOAUVJUXJWPZUWQUUQBUXIUWQUUQUVIBUWPUWOAUVJWOZWQWR
        UBVLZUVBVJWSZUWQUUQCWILUTWTUVBUWMUWNUVKXAZUXPXBXCUWQUVGBUGZUXLHBXDZUXEU
        WQUVHBULUXRUWQUVHUVIBUVHUUQXEUXNWQUVGBUEWMZXFVNAUXSUWOUVJAUXLHBUBXGWHHU
        VGBFCXHVLZEDGIUWGCKUVCUWSMQNPUWJXIXPVTUWQUVPUXAUKUVEUWQUVOUWTDGUWQUUQCE
        HKUVGWIFUWSHUVGFXJZMQUXHUXQUXOUVGWIUGUWQUXTWNZUWMUWNUVKXKZUYAHUVGFXLZXM
        VCVTUWRUVMUVAUXBEUHZUXCUWQUVMUYFUKUVEUWQUUQCEHKUVGWIYKUXBHDUWSGHDXNHGXN
        UYBXOMQUXHUXQUXKUWFUWHUXLYKCUGUXKAUWFUXMTWLUXKAUWHUXMUWIWLUXODGIUWGCKFM
        NPUWJXQXRUYCUYDUWQUWFUWHUXEUXBCUGUXFUXGUYADGIUWGCKUWSMNPUWJXQXRUXIUVGUK
        FUWSDGUYEVCXMVTUWRUVAUVDUXBEUWQUVEXSXTYAYBYCYCYDYFYEYGYHYI $.
    $}

    ${
      $d a e k z G $.  $d k Q $.
      gsumvsca2.n $e |- ( ph -> Q e. B ) $.
      gsumvsca2.c $e |- ( ( ph /\ k e. A ) -> P e. K ) $.
      $( Scalar product of a finite group sum for a left module over a semiring
         (Contributed by Thierry Arnoux, 16-Mar-2018.) $)
      gsumvsca2 $p |- ( ph -> ( W gsum ( k e. A |-> ( P .x. Q ) ) ) =
                             ( ( G gsum ( k e. A |-> P ) ) .x. Q ) ) $=
        ( va ve vz cfn wcel co cmpt cgsu wceq wss ssid wa cv wi c0 sseq1 anbi2d
        csn cun mpteq1 oveq2d oveq1d eqeq12d imbi12d c0g cfv cslmd eqid slmd0vs
        syl2anc eqcom sylibr mpt0 oveq2i gsum0 eqtri oveq1i eqeq12i ssun1 sstr2
        adantr wn ax-mp anim2i imim1i csb cplusg cbs ad2antrl csrg ccmn slmdsrg
        cvv srgcmn 3syl vex a1i simplrl simprr syl5ss sselda sseldd cdif simpll
        fmptd fisuppfi gsumcl wral ssun2 ralrimiva rspcsbela slmdvsdir syl13anc
        snss nfcsb1v simplr csbeq1a gsumunsnf nfcv slmdcmn syl slmdvscl syl3anc
        nfov simpr eqtrd 3eqtr4rd ex a2d syl5 findcard2s imp mpanr2 mpancom ) B
        UFUGZAKHBDFGUHZUIZUJUHZIHBDUIZUJUHZFGUHZUKZSYQABBULZUUDBUMYQAUUEUNZUUDA
        UCUOZBULZUNZKHUUGYRUIZUJUHZIHUUGDUIZUJUHZFGUHZUKZUPAUQBULZUNZKHUQYRUIZU
        JUHZIHUQDUIZUJUHZFGUHZUKZUPAUDUOZBULZUNZKHUVDYRUIZUJUHZIHUVDDUIZUJUHZFG
        UHZUKZUPZAUVDUEUOZUTZVAZBULZUNZKHUVPYRUIZUJUHZIHUVPDUIZUJUHZFGUHZUKZUPZ
        UUFUUDUPUCUDUEBUUGUQUKZUUIUUQUUOUVCUWFUUHUUPAUUGUQBURUSUWFUUKUUSUUNUVBU
        WFUUJUURKUJHUUGUQYRVBVCUWFUUMUVAFGUWFUULUUTIUJHUUGUQDVBVCVDVEVFUUGUVDUK
        ZUUIUVFUUOUVLUWGUUHUVEAUUGUVDBURUSUWGUUKUVHUUNUVKUWGUUJUVGKUJHUUGUVDYRV
        BVCUWGUUMUVJFGUWGUULUVIIUJHUUGUVDDVBVCVDVEVFUUGUVPUKZUUIUVRUUOUWDUWHUUH
        UVQAUUGUVPBURUSUWHUUKUVTUUNUWCUWHUUJUVSKUJHUUGUVPYRVBVCUWHUUMUWBFGUWHUU
        LUWAIUJHUUGUVPDVBVCVDVEVFUUGBUKZUUIUUFUUOUUDUWIUUHUUEAUUGBBURUSUWIUUKYT
        UUNUUCUWIUUJYSKUJHUUGBYRVBVCUWIUUMUUBFGUWIUULUUAIUJHUUGBDVBVCVDVEVFAUVC
        UUPALIVGVHZFGUHZUKZUVCAUWKLUKZUWLAKVIUGZFCUGZUWMTUAGIUWJCKFLMNPUWJVJZOV
        KVLLUWKVMVNUUSLUVBUWKUUSKUQUJUHLUURUQKUJHYRVOVPKLOVQVRUVAUWJFGUVAIUQUJU
        HUWJUUTUQIUJHDVOVPIUWJUWPVQVRVSVTVNWCUVMUVRUVLUPUVDUFUGZUVNUVDUGWDZUNZU
        WEUVRUVFUVLUVQUVEAUVDUVPULUVQUVEUPUVDUVOWAZUVDUVPBWBWEWFWGUWSUVRUVLUWDU
        WSUVRUVLUWDUPUWSUVRUNZUVLUWDUXAUVLUNZUVJHUVNDWHZIWIVHZUHZFGUHZUVKUXCFGU
        HZEUHZUWCUVTUXAUXFUXHUKZUVLUXAUWNUVJIWJVHZUGUXCUXJUGZUWOUXIAUWNUWSUVQTW
        KZUXAUVDUXJUVIIWOUWJUXJVJZUWPUXAUWNIWLUGIWMUGUXLIKNWNIWPWQZUVDWOUGUXAUD
        WRWSUXAHUVDDUXJUVIUXAHUOZUVDUGZUNZAUXOBUGZDUXJUGZUWSAUVQUXPWTZUXAUVDBUX
        OUXAUVDUVPBUWTUWSAUVQXAZXBXCAUXRUNJUXJDAJUXJULUXRRWCUBXDZVLZUVIVJXGZUXA
        UVDUXJWOUWJUTXEUVIUWQUWRUVRXFZUYDXHXIUXAUVNBUGZUXSHBXJZUXKUXAUVOBULUYFU
        XAUVOUVPBUVOUVDXKUYAXBUVNBUEWRZXPVNAUYGUWSUVQAUXSHBUYBXLWKHUVNBDUXJXMVL
        ZAUWOUWSUVQUAWKZEUXDUVJUXCGIUXJCKFMQNPUXMUXDVJZXNXOWCUXAUWCUXFUKUVLUXAU
        WBUXEFGUXAUVDUXJUXDHIUVNWODUXCHUVNDXQZUXMUYKUXNUYEUYCUVNWOUGUXAUYHWSZUW
        QUWRUVRXRZUYIHUVNDXSZXTVDWCUXBUVTUVHUXGEUHZUXHUXAUVTUYPUKUVLUXAUVDCEHKU
        VNWOYRUXGHUXCFGUYLHGYAHFYAYFMQUXAUWNKWMUGUXLKYBYCUYEUXQUWNUXSUWOYRCUGUX
        QAUWNUXTTYCUYCUXQAUWOUXTUAYCDGIUXJCKFMNPUXMYDYEUYMUYNUXAUWNUXKUWOUXGCUG
        UXLUYIUYJUXCGIUXJCKFMNPUXMYDYEUXOUVNUKDUXCFGUYOVDXTWCUXBUVHUVKUXGEUXAUV
        LYGVDYHYIYJYJYKYLYMYNYOYP $.
    $}
  $}

$(
  @{
    gsummptadd.b @e |- B = ( Base ` G ) @.
    gsummptadd.z @e |- .0. = ( 0g ` G ) @.
    gsummptadd.p @e |- .+ = ( +g ` G ) @.
    gsummptadd.g @e |- ( ph -> G e. CMnd ) @.
    gsummptadd.a @e |- ( ph -> A e. Fin ) @.
    gsummptadd.f @e |- ( ( ph /\ x e. A ) -> C e. B ) @.
    gsummptadd.h @e |- ( ( ph /\ x e. A ) -> D e. B ) @.
    @( The sum of two group sums expressed as mappings.  (Contributed by
       Thierry Arnoux, 19-Mar-2018.) @)
    gsummptadd @p |- ( ph -> ( G gsum ( x e. A |-> ( C .+ D ) ) )
      = ( ( G gsum ( x e. A |-> C ) ) .+ ( G gsum ( x e. A |-> D ) ) ) ) @=
      ? @.
  @}

  @{
    gsummptres.b @e |- B = ( Base ` G ) @.
    gsummptres.z @e |- .0. = ( 0g ` G ) @.
    gsummptres.g @e |- ( ph -> G e. CMnd ) @.
    gsummptres.a @e |- ( ph -> A e. Fin ) @.
    gsummptres.f @e |- ( ( ph /\ x e. A ) -> C e. B ) @.
    gsummptres.s @e |- ( ( ph /\ x e. ( A \ D ) ) -> C = .0. ) @.
    @( Extend a finite group sum by padding outside with zeroes.
       (Contributed by Thierry Arnoux, 27-Mar-2018.) @)
    gsummptres @p |- ( ph
      -> ( G gsum ( x e. A |-> C ) ) = ( G gsum ( x e. D |-> C ) ) ) @=
      ? @.
  @}

$)

  ${
    $d r s u v w y z A $.  $d r s u v w y z F $.  $d r s u v w y z ph $.
    $d r s u v w y z G $.  $d r u v w y z S $.
    xrge0tsmsd.g $e |- G = ( RR*s |`s ( 0 [,] +oo ) ) $.
    xrge0tsmsd.a $e |- ( ph -> A e. V ) $.
    xrge0tsmsd.f $e |- ( ph -> F : A --> ( 0 [,] +oo ) ) $.
    xrge0tsmsd.s $e |- ( ph -> S = sup (
      ran ( s e. ( ~P A i^i Fin ) |-> ( G gsum ( F |` s ) ) ) , RR* , < ) ) $.
    $( Any finite or infinite sum in the nonnegative extended reals is uniquely
       convergent to the supremum of all finite sums.  (Contributed by Mario
       Carneiro, 13-Sep-2015.)  (Revised by Thierry Arnoux, 30-Jan-2017.) $)
    xrge0tsmsd $p |- ( ph -> ( G tsums F ) = { S } ) $=
      ( vz co wcel cc0 cxr wbr wa cvv syl vu vy vx vv vr vw ctsu wceq cpnf cicc
      csn cv wss cres cgsu wi cpw cfn cin wral wrex cle cordt cfv crest crn clt
      cmpt csup cxrs ax-mp cmnf cdif cress eqid wne ge0nemnf elxrge0 mp2an ccmn
      wf jca eqeltri a1i elfpw simprbi simplbi fssres fisuppfi gsumcl sseldi c0
      cc reseq2 syl6eq oveq2d elrnmpt1s supxrub sylancl breqtrrd sylanbrc letop
      ctop wb ovex inss1 cioo simplrl simplrr simpr elin syl2anc simprrr adantr
      simprrl sstrd simprlr xrge0gsumle xrltletrd weq w3a mpbir3and sseldd expr
      cr ralrimiva ad3antrrr breqtrd mpbid sylib reximddv syl5ibrcom syl5bi mpd
      eleq2 simprr ad2antrr ad2antrl ctps cha iccssxr xrsbas ressbas2 xrge0subm
      cbs csubmnd difexg simpl eldifsn 3imtr4i ssriv ressabs eqtr4i xrs10 subm0
      c0g xrex xrge0cmn adantl syl2an frn supxrcl eqeltrd 0ss 0fin mpbir2an 0cn
      fmptd res0 gsum0 sseli ctg reex elrestr mp3an12 xrtgioo syl6eleqr tg2 cxp
      elrest wfn ioof ffn ovelrn mp2b syl6ss simp-4l simprll eliooord xrlelttrd
      ssfi simprd elioo1 anassrs simpld supxrlub rgenw cbvmptv rexrnmpt anbi12d
      breq2 imbi1d rexlimdvva rexlimdv cioc eqeltrrd pnfnei simp-5l rexr simprl
      sseq1 pnfge pnfxr elioc1 simplr rexlimddv wo xrnemnf mpjaodan syl5 imbi2d
      rexralbidv imbi12d rexlimdva ralrimiv cts xrstset resstset topnval xrstps
      ltpnf resstps eltsms mpbir2and ctsr letsr ordthaus resthaus haustsms2
      mp1i ) ACEDUGMZNZVUACUKUHAVUBCOUIUJMZNZCUAULZNZLULZUBULZUMZEDVUHUNZUOMZVU
      ENZUPZUBBUQURUSZUTLVUNVAZUPZUAVBVCVDZVUCVEMZUTACPNZOCVBQZVUDACGVUNEDGULZU
      NZUOMZVHZVFZPVGVIZPKAVVEPUMZVVFPNAVUNPVVDWAVVGAGVUNVVCPVVDAVVAVUNNZRZVUCP
      VVCOUIUUAZVVIVVAVUCVVBEUROVUCPUMVUCEUUEVDUHVVJVUCPEVJHUUBUUCVKZVUCVJPVLUK
      ZVMZVNMZUUFVDNOEUUPVDUHVVNVVNVOZUUDVUCEVVNOEVJVUCVNMZVVNVUCVNMZHVVMSNZVUC
      VVMUMVVQVVPUHPSNVVRUUQPVVLSUUGVKUCVUCVVMUCULZPNZOVVSVBQZRZVVTVVSVLVPZRVVS
      VUCNVVSVVMNVWBVVTVWCVVTVWAUUHVVSVQWBVVSVRVVSPVLUUIUUJUUKVVMVUCVJSUULVSUUM
      VVNVVOUUNUUOVKZEVTNZVVIEVVPVTHUURWCZWDVVHVVAURNZAVVHVVABUMZVWGVVABWEZWFUU
      SZABVUCDWAZVWHVVAVUCVVBWAVVHJVVHVWHVWGVWIWGBVUCVVADWHUUTZVVIVVAVUCSOUKVMZ
      VVBVWJVWLWIWJWKVVDVOZUVHVUNPVVDUVATZVVEUVBTUVCZAOVVFCVBAVVGOVVENZOVVFVBQV
      WOWLVUNNZOWMNVWQVWRWLBUMWLURNBUVDUVEWLBWEUVFUVGGVUNVVCOWLVVDWMVWNVVAWLUHZ
      VVCEWLUOMOVWSVVBWLEUOVWSVVBDWLUNWLVVAWLDWNDUVIWOWPEOVWDUVJWOWQVSVVEOWRWSK
      WTZCVRXAAVUPUAVURVUEVURNZVUEUDULZVUCUSZUHZUDVUQVAZAVUPVUQXCNZVUCSNZVXAVXE
      XDXBOUIUJXEZUDVUEVUCVUQXCSUVTVSAVXDVUPUDVUQAVXBVUQNZRZVUPVXDCVXCNZVUIVUKV
      XCNZUPZUBVUNUTZLVUNVAZUPVXKCVXBNZVXJVXOVXCVXBCVXBVUCXFUVKAVXIVXPVXOAVXIVX
      PRZRZCYENZVXOCUIUHZVXRVXSRZVUFVUEVXBYEUSZUMZRZUAXGVFZVAZVXOVYAVYBVYEUVLVD
      ZNCVYBNZVYFVYAVYBVUQYEVEMZVYGVYAVXIVYBVYINZAVXIVXPVXSXHVXFYESNVXIVYJXBUVM
      VXBYEVUQXCSUVNUVOTVYIVYIVOUVPUVQVYAVXPVXSVYHAVXIVXPVXSXIVXRVXSXJCVXBYEXKX
      AUAVYBVYECUVRXLVYAVYDVXOUAVYEVUEVYENZVUEUEULZUFULZXGMZUHZUFPVAUEPVAZVYAVY
      DVXOUPZPPUVSZYEUQZXGWAXGVYRUWAVYKVYPXDUWBVYRVYSXGUWCUEUFPPVUEXGUWDUWEVYAV
      YOVYQUEUFPPVYAVYLPNZVYMPNZRZRVYQVYOCVYNNZVYNVYBUMZRZVXOUPVYAWUBWUEVXOVYAW
      UBWUERZRZVYLEDVUGUNZUOMZVGQZVXNLVUNWUGVUGVUNNZWUJRZRZVXMUBVUNWUMVUHVUNNZV
      UIVXLWUGWULWUNVUIRZVXLWUGWULWUORZRZVUKVXBNZVUKVUCNZVXLWUQVYNVXBVUKWUQVYNV
      YBVXBWUGWUDWUPVYAWUBWUCWUDXMXNVXBYEXFUWFWUQVUKVYNNZVUKPNZVYLVUKVGQZVUKVYM
      VGQZWUQVUCPVUKVVJWUQVUHVUCVUJEUROVVKVWDVWEWUQVWFWDZWUQWUNVUHURNZWUGWULWUN
      VUIXOZWUNVUHBUMZWVEVUHBWEZWFZTZWUQVWKWVGVUHVUCVUJWAZWUQAVWKAVXQVXSWUFWUPU
      WGZJTZWUQWUNWVGWVFWUNWVGWVEWVHWGZTZBVUCVUHDWHZXLZWUQVUHVUCVWMVUJWVJWVQWIW
      JZWKZWUQVYLWUIVUKWUGVYTWUPVYAVYTWUAWUEUWHZXNZWUQVUCPWUIVVJWUQVUGVUCWUHEUR
      OVVKVWDWVDWUQWVEVUIVUGURNZWVJWUGWULWUNVUIXMZVUHVUGUWKZXLZWUQVWKVUGBUMZVUG
      VUCWUHWAZWVMWUQVUGVUHBWWCWVOXPBVUCVUGDWHZXLZWUQVUGVUCVWMWUHWWEWWIWIWJWKWV
      SWUGWUKWUJWUOXQWUQBVUHVUGDEFHWUQABFNZWVLITWVMWVFWWCXRXSWUQVUKCVYMWVSWUQAV
      USWVLVWPTWUGWUAWUPVYAVYTWUAWUEXQXNZWUQVUKVVFCVBWUQVVGVUKVVENZVUKVVFVBQWUQ
      AVVGWVLVWOTWUQWUNVUKSNWWLWVFEVUJUOXEGVUNVVCVUKVUHVVDSVWNGUBXTVVBVUJEUOVVA
      VUHDWNWPWQWSVVEVUKWRXLWUQACVVFUHZWVLKTWTWUGCVYMVGQZWUPWUGVYLCVGQZWWNWUGWU
      CWWOWWNRVYAWUBWUCWUDXOCVYLVYMUWITZUWLXNUWJWUQVYTWUAWUTWVAWVBWVCYAXDWWAWWK
      VYLVYMVUKUWMXLYBYCWVRVUKVXBVUCXKZXAUWNYDYFWUGVYLVYMVGQZUFVVEVAZWUJLVUNVAZ
      WUGVYLVVFVGQZWWSWUGVYLCVVFVGWUGWWOWWNWWPUWOAWWMVXQVXSWUFKYGYHWUGVVGVYTWXA
      WWSXDZAVVGVXQVXSWUFVWOYGWVTUFVVEVYLUWPZXLYIWUISNZLVUNUTWWSWWTXDWXDLVUNEWU
      HUOXEUWQWWRWUJLUFVUNWUIVVDSGLVUNVVCWUIGLXTVVBWUHEUOVVAVUGDWNWPUWRVYMWUIVY
      LVGUXAUWSVKZYJYKYDVYOVYDWUEVXOVYOVUFWUCVYCWUDVUEVYNCYOVUEVYNVYBUXKUWTUXBY
      LUXCYMUXDYNVXRVXTRZVYLUIUXEMZVXBUMZVXOUEYEWXFVXIUIVXBNWXHUEYEVAAVXIVXPVXT
      XHWXFCUIVXBVXRVXTXJAVXIVXPVXTXIUXFUEVXBUXGXLWXFVYLYENZWXHRZRZWUJVXNLVUNWX
      KWULRZVXMUBVUNWXLWUNVUIVXLWXLWUORZWURWUSVXLWXMWXGVXBVUKWXKWXHWULWUOWXFWXI
      WXHYPYQWXMVUKWXGNZWVAWVBVUKUIVBQZWXMVUCPVUKVVJWXMVUHVUCVUJEUROVVKVWDVWEWX
      MVWFWDZWUNWVEWXLVUIWVIYRZWXMVWKWVGWVKWXMAVWKAVXQVXTWXJWULWUOUXHZJTZWUNWVG
      WXLVUIWVNYRZWVPXLZWXMVUHVUCVWMVUJWXQWYAWIWJZWKZWXMVYLWUIVUKWXKVYTWULWUOWX
      IVYTWXFWXHVYLUXIYRZYQZWXMVUCPWUIVVJWXMVUGVUCWUHEUROVVKVWDWXPWXMWVEVUIWWBW
      XQWXLWUNVUIYPZWWDXLZWXMVWKWWFWWGWXSWXMVUGVUHBWYFWXTXPWWHXLZWXMVUGVUCVWMWU
      HWYGWYHWIWJWKWYCWXKWUKWUJWUOXIWXMBVUHVUGDEFHWXMAWWJWXRITWXSWXLWUNVUIUXJWY
      FXRXSWXMWVAWXOWYCVUKUXLTWXMVYTUIPNWXNWVAWVBWXOYAXDWYEUXMVYLUIVUKUXNWSYBYC
      WYBWWQXAYDYFWXKWWSWWTWXKWXAWWSWXKVYLCVVFVGWXKVYLUICVGWXIVYLUIVGQWXFWXHVYL
      UYKYRVXRVXTWXJUXOWTAWWMVXQVXTWXJKYGYHWXKVVGVYTWXBAVVGVXQVXTWXJVWOYGWYDWXC
      XLYIWXEYJYKUXPVXRVUSCVLVPZRZVXSVXTUXQAWYJVXQAVUSWYIVWPAVUSVUTWYIVWPVWTCVQ
      XLWBXNCUXRYJUXSYDUXTVXDVUFVXKVUOVXOVUEVXCCYOVXDVUMVXMLUBVUNVUNVXDVULVXLVU
      IVUEVXCVUKYOUYAUYBUYCYLUYDYMUYEAUBLUABVUCCVUNDEVURFVVKVUCVUQEVVKVXGVUQEUY
      FVDUHVXHVUCVJEVUQSHUYGUYHVKUYIZVUNVOVWEAVWFWDZEYSNAEVVPYSHVJYSNVXGVVPYSNU
      YJVXHVUCVJSUYLVSWCWDZIJUYMUYNABVUCDEVURFCVVKWYLWYMIJWYKAVUQYTNZVXGVURYTNV
      BUYONWYNAUYPVBUYQUYTVXHVUCVUQSUYRWSUYSYN $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x ph $.
    xrge0tsmseq.g $e |- G = ( RR*s |`s ( 0 [,] +oo ) ) $.
    xrge0tsmseq.a $e |- ( ph -> A e. V ) $.
    xrge0tsmseq.f $e |- ( ph -> F : A --> ( 0 [,] +oo ) ) $.
    $( Any limit of a finite or infinite sum in the nonnegative extended reals
       is the union of the sets limits, since this set is a singleton.
       (Contributed by Thierry Arnoux, 23-Jun-2017.) $)
    xrge0tsmsbi $p |- ( ph ->
                           ( C e. ( G tsums F ) <-> C = U. ( G tsums F ) ) ) $=
      ( ctsu co wcel cuni csn wceq c1o cen wbr cc0 cvv cpnf wf xrge0tsms2 sylib
      cicc syl2anc en1b eleq2d wb ovex uniex eleq1 mpbiri elsncg syl ibir elsni
      impbii syl6bbr ) ACEDJKZLCUTMZNZLZCVAOZAUTVBCAUTPQRZUTVBOABFLBSUAUEKDUBVE
      HIBDEFGUCUFUTUGUDUHVDVCVDVCVDCTLZVCVDUIVDVFVATLUTEDJUJUKCVATULUMCVATUNUOU
      PCVAUQURUS $.
    ${
      xrge0tsmseq.h $e |- ( ph -> C e. ( G tsums F ) ) $.
      $( Any limit of a finite or infinite sum in the nonnegative extended
         reals is the union of the sets limits, since this set is a singleton.
         (Contributed by Thierry Arnoux, 24-Mar-2017.) $)
      xrge0tsmseq $p |- ( ph -> C = U. ( G tsums F ) ) $=
        ( ctsu co cuni csn wcel c1o cen wbr wceq syl2anc cc0 cpnf wf xrge0tsms2
        cicc en1eqsn unieqd unisng syl eqtr2d ) AEDKLZMCNZMZCAUKULACUKOZUKPQRZU
        KULSJABFOBUAUBUELDUCUOHIBDEFGUDTCUKUFTUGAUNUMCSJCUKUHUIUJ $.
    $}
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Rings - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)


  ${
    $d x B $.  $d e x R $.  $d e x .1. $.  $d x .0. $.  $d x .x. $.
    $d e x ph $.
    rngurd.b $e |- ( ph -> B = ( Base ` R ) ) $.
    rngurd.p $e |- ( ph -> .x. = ( .r ` R ) ) $.
    rngurd.z $e |- ( ph -> .1. e. B ) $.
    rngurd.i $e |- ( ( ph /\ x e. B ) -> ( .1. .x. x ) = x ) $.
    rngurd.j $e |- ( ( ph /\ x e. B ) -> ( x .x. .1. ) = x ) $.
    $( Deduce the unit of a ring from its properties.  (Contributed by Thierry
       Arnoux, 6-Sep-2016.) $)
    rngurd $p |- ( ph -> .1. = ( 1r ` R ) ) $=
      ( ve wcel co wceq wa wral oveqd eqeq1d anbi12d cur cfv cbs cmulr cio eqid
      cv dfur2 eleqtrd jca ralrimiva adantr raleqbidva mpbid wb wi simpr oveq2d
      weu wal eqeq12d rspcdv mpd adantrr simprr oveq2 id oveq1 rspcv imp simprd
      syl2anc eqtr3d ex eleq2d imbi1d alrimiv eleq1 ralbidv eqeu iota2 mpbi2and
      syl3anc syl5req ) ADUAUBZLUGZDUCUBZMZWFBUGZDUDUBZNZWIOZWIWFWJNZWIOZPZBWGQ
      ZPZLUEZFBWGDWJWELWGUFWJUFWEUFUHAFWGMZFWIWJNZWIOZWIFWJNZWIOZPZBWGQZWRFOZAF
      CWGIGUIZAFWIENZWIOZWIFENZWIOZPZBCQXEAXLBCAWICMZPZXIXKJKUJUKAXLXDBCWGGXNXI
      XAXKXCXNXHWTWIXNEWJFWIAEWJOXMHULZRSXNXJXBWIXNEWJWIFXORSTUMUNZAFCMZWQLUSZW
      SXEPZXFUOIAWSXSWQWFFOZUPZLUTXRXGAWSXEXGXPUJAYALAWFCMZWFWIENZWIOZWIWFENZWI
      OZPZBCQZPZXTUPYAAYIXTAYIPZFWFENZWFFAYBYKWFOZYHAYBPZXIBCQZYLAYNYBAXIBCJUKU
      LYMXIYLBWFCAYBUQYMWIWFOZPZXHYKWIWFYPWIWFFEYMYOUQZURYQVAVBVCVDYJXQYHYKFOZA
      XQYIIULAYBYHVEXQYHPWFFENZFOZYRXQYHYTYRPZYGUUABFCWIFOZYDYTYFYRUUBYCYSWIFWI
      FWFEVFUUBVGZVAUUBYEYKWIFWIFWFEVHUUCVATVIVJVKVLVMVNAYIWQXTAYBWHYHWPACWGWFG
      VOAYGWOBCWGGXNYDWLYFWNXNYCWKWIXNEWJWFWIXORSXNYEWMWIXNEWJWIWFXORSTUMTVPUNV
      QWQXSLFWGXTWHWSWPXEWFFWGVRXTWOXDBWGXTWLXAWNXCXTWKWTWIWFFWIWJVHSXTWMXBWIWF
      FWIWJVFSTVSTZVTWCWQXSLFCUUDWAVLWBWD $.
  $}

  ${
    $d x .1. $.  $d x A $.  $d x B $.  $d x R $.  $d x S $.
    ress1r.s $e |- S = ( R |`s A ) $.
    ress1r.b $e |- B = ( Base ` R ) $.
    ress1r.1 $e |- .1. = ( 1r ` R ) $.
    $( ` 1r ` is unaffected by restriction.  This is a bit more generic than
       ~ subrg1 (Contributed by Thierry Arnoux, 6-Sep-2018.) $)
    ress1r $p |- ( ( R e. Ring /\ .1. e. A /\ A C_ B ) -> .1. = ( 1r ` S ) ) $=
      ( vx crg wcel wss w3a cmulr cfv cbs wceq cvv co syl2anc ressbas2 3ad2ant3
      simp3 fvex eqeltri ssexg sylancl eqid ressmulr syl simp2 cv simpl1 sselda
      wa rnglidm rngridm rngurd ) CJKZEAKZABLZMZIADCNOZEVAUSADPOQUTABDCFGUAUBVB
      ARKZVCDNOQVBVABRKVDUSUTVAUCZBCPORGCPUDUEABRUFUGACDVCRFVCUHZUIUJUSUTVAUKVB
      IULZAKZUOZUSVGBKZEVGVCSVGQUSUTVAVHUMZVBABVGVEUNZBCVCEVGGVFHUPTVIUSVJVGEVC
      SVGQVKVLBCVCEVGGVFHUQTUR $.
  $}

  ${
    dvrdir.b $e |- B = ( Base ` R ) $.
    dvrdir.u $e |- U = ( Unit ` R ) $.
    dvrdir.p $e |- .+ = ( +g ` R ) $.
    dvrdir.t $e |- ./ = ( /r ` R ) $.
    $( Distributive law for the division operation of a ring.  (Contributed by
       Thierry Arnoux, 30-Oct-2017.) $)
    dvrdir $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. B /\ Z e. U ) ) ->
                     ( ( X .+ Y ) ./ Z ) = ( ( X ./ Z ) .+ ( Y ./ Z ) ) ) $=
      ( crg wcel co cfv wceq eqid dvrval syl2anc w3a cinvr simpr1 simpr2 unitss
      wa cmulr simpl simpr3 unitinvcl syldan sseldi rngdir syl13anc cgrp rnggrp
      adantr grpcl syl3anc oveq12d 3eqtr4d ) DMNZFANZGANZHENZUAZUFZFGCOZHDUBPZP
      ZDUGPZOZFVJVKOZGVJVKOZCOZVHHBOZFHBOZGHBOZCOVGVBVCVDVJANVLVOQVBVFUHVBVCVDV
      EUCZVBVCVDVEUDZVGEAVJADEIJUEVBVFVEVJENVBVCVDVEUIZDEVIHJVIRZUJUKULACDVKFGV
      JIKVKRZUMUNVGVHANZVEVPVLQVGDUONZVCVDWDVBWEVFDUPUQVSVTACDFGIKURUSWAABDVKEV
      IVHHIWCJWBLSTVGVQVMVRVNCVGVCVEVQVMQVSWAABDVKEVIFHIWCJWBLSTVGVDVEVRVNQVTWA
      ABDVKEVIGHIWCJWBLSTUTVA $.

    rdivmuldivd.p $e |- .x. = ( .r ` R ) $.
    rdivmuldivd.r $e |- ( ph -> R e. CRing ) $.
    rdivmuldivd.a $e |- ( ph -> X e. B ) $.
    rdivmuldivd.b $e |- ( ph -> Y e. U ) $.
    rdivmuldivd.c $e |- ( ph -> Z e. B ) $.
    rdivmuldivd.d $e |- ( ph -> W e. U ) $.
    $( Multiplication of two ratios.  Theorem I.14 of [Apostol] p. 18.
       (Contributed by Thierry Arnoux, 30-Oct-2017.) $)
    rdivmuldivd $p |- ( ph -> ( ( X ./ Y ) .x. ( Z ./ W ) ) =
                             ( ( X .x. Z ) ./ ( Y .x. W ) ) ) $=
      ( co cinvr cfv wcel wceq wa eqid dvrval oveq1d syl2anc crg crngrng unitss
      ccrg unitinvcl sseldi dvrcl syl3anc rngass syl13anc crngcom oveq2d 3eqtrd
      syl cmgp cress cplusg cgrp unitgrp unitgrpbas invrfval grpinvadd cvv fvex
      cui eqeltri mgpress sylancl fveq2d cmulr ressmulr ax-mp mgpplusg syl6reqr
      oveqd 3eqtr4d rngcl unitmulcl eqtr4d 3eqtr3rd 3eqtr4rd eqtrd ) AIJCUBZKHC
      UBZFUBZIWOJEUCUDZUDZFUBZFUBZIKFUBZJHFUBZCUBZAWPIWRFUBZWOFUBZIWRWOFUBZFUBZ
      WTAIBUEZJGUEZWPXEUFRSXHXIUGWNXDWOFBCEFGWQIJLPMWQUHZOUIUJUKAEULUEZXHWRBUEZ
      WOBUEZXEXGUFAEUOUEZXKQEUMVEZRAGBWRBEGLMUNZAXKXIWRGUEXOSEGWQJMXJUPUKUQZAXK
      KBUEZHGUEZXMXOTUABCEGKHLMOURUSZBEFIWRWOLPUTVAAXFWSIFAXNXLXMXFWSUFQXQXTBEF
      WRWOLPVBUSVCVDAXAXBWQUDZFUBZXAHWQUDZWRFUBZFUBZXCWTAYAYDXAFAJHEVFUDZGVGUBZ
      VHUDZUBZWQUDZYCWRYHUBZYAYDAYGVIUEZXIXSYJYKUFAXKYLXOEGYGMYGUHZVJVESUAGYHYG
      WQJHEGYGMYMVKYHUHEGYGWQMYMXJVLVMUSAXBYIWQAFYHJHAYHEGVGUBZVFUDZVHUDFAYGYOV
      HAXKGVNUEZYGYOUFXOGEVPUDVNMEVPVOVQZGEYNYFULVNYNUHZYFUHVRVSVTYNFYOYOUHYPFY
      NWAUDUFYQGEYNFVNYRPWBWCWDWEZWFVTAFYHYCWRYSWFWGVCAXABUEZXBGUEZXCYBUFAXKXHX
      RYTXORTBEFIKLPWHUSZAXKXIXSUUAXOSUAEFGJHMPWIUSBCEFGWQXAXBLPMXJOUIUKAXAYCFU
      BZWRFUBZIWOFUBZWRFUBZYEWTAUUCUUEWRFAUUCIKYCFUBZFUBZUUEAXKXHXRYCBUEZUUCUUH
      UFXORTAGBYCXPAXKXSYCGUEXOUAEGWQHMXJUPUKUQZBEFIKYCLPUTVAAWOUUGIFAXRXSWOUUG
      UFTUABCEFGWQKHLPMXJOUIUKVCWJUJAXKYTUUIXLUUDYEUFXOUUBUUJXQBEFXAYCWRLPUTVAA
      XKXHXMXLUUFWTUFXORXTXQBEFIWOWRLPUTVAWKWLWM $.
  $}

  ${
    $d y R $.  $d y U $.  $d y X $.
    rnginvval.b $e |- B = ( Base ` R ) $.
    rnginvval.p $e |- .* = ( .r ` R ) $.
    rnginvval.o $e |- .1. = ( 1r ` R ) $.
    rnginvval.n $e |- N = ( invr ` R ) $.
    rnginvval.u $e |- U = ( Unit ` R ) $.
    $( The ring inverse expressed in terms of multiplication.  (Contributed by
       Thierry Arnoux, 23-Oct-2017.) $)
    rnginvval $p |- ( ( R e. Ring /\ X e. U ) ->
                             ( N ` X ) = ( iota_ y e. U ( y .* X ) = .1. ) ) $=
      ( wcel wa cfv co wceq eqid cvv crg cv cmgp c0g crio unitgrpbas cplusg cui
      cress fvex eqeltri mgpplusg ressplusg invrfval grpinvval adantl unitgrpid
      ax-mp adantr eqeq2d riotabidva eqtr4d ) CUANZHDNZOHGPZAUBZHFQZCUCPZDUIQZU
      DPZRZADUEZVGERZADUEZVDVEVLRVCADFVIGHVJCDVIMVISZUFDTNFVIUGPRDCUHPTMCUHUJUK
      DFVHVITVOCFVHVHSJULUMURVJSCDVIGMVOLUNUOUPVCVNVLRVDVCVMVKADVCVFDNZOEVJVGVC
      EVJRVPCDEVIMVOKUQUSUTVAUSVB $.
  $}

  ${
    dvrcan5.b $e |- B = ( Base ` R ) $.
    dvrcan5.o $e |- U = ( Unit ` R ) $.
    dvrcan5.d $e |- ./ = ( /r ` R ) $.
    dvrcan5.t $e |- .x. = ( .r ` R ) $.
    $( Cancellation law for common factor in ratio.  ( ~ divcan5 analog.)
       (Contributed by Thierry Arnoux, 26-Oct-2016.) $)
    dvrcan5 $p |- ( ( R e. Ring /\ ( X e. B /\ Y e. U /\ Z e. U ) ) ->
      ( ( X .x. Z ) ./ ( Y .x. Z ) ) = ( X ./ Y ) ) $=
      ( wcel co cfv wceq sseldi eqid syl2anc cvv crg w3a wa cinvr unitss simpr3
      unitmulcl 3adant3r1 dvrval cmgp cress simpl unitgrp syl simpr2 unitgrpbas
      cgrp cplusg cui fvex eqeltri mgpplusg ressplusg invrfval grpinvadd oveq2d
      syl3anc cur unitrinv oveq1d 3ad2antr3 unitinvcl 3ad2antr2 rngass syl13anc
      ax-mp rnglidm 3eqtr3d 3eqtrd simpr1 dvrass 3eqtr4d ) CUAMZFAMZGEMZHEMZUBZ
      UCZFHGHDNZBNZDNZFGCUDOZOZDNZFHDNWIBNZFGBNZWHWJWMFDWHWJHWIWLOZDNZHHWLOZWMD
      NZDNZWMWHHAMZWIEMZWJWRPWHEAHACEIJUEZWCWDWEWFUFZQZWCWEWFXCWDCDEGHJLUGUHZAB
      CDEWLHWIILJWLRZKUISWHCUJOZEUKNZUQMZWEWFWRXAPWHWCXKWCWGULZCEXJJXJRZUMUNWCW
      DWEWFUOZXEXKWEWFUBWQWTHDEDXJWLGHCEXJJXMUPETMDXJUROPECUSOTJCUSUTVAEDXIXJTX
      MCDXIXIRLVBVCVPCEXJWLJXMXHVDVEVFVGWHHWSDNZWMDNZCVHOZWMDNZXAWMWCWDWFXPXRPW
      EWCWFUCXOXQWMDCDEXQWLHJXHLXQRZVIVJVKWHWCXBWSAMWMAMZXPXAPXLXFWHEAWSXDWCWDW
      FWSEMWECEWLHJXHVLVKQWHEAWMXDWCWDWEWMEMWFCEWLGJXHVLVMQZACDHWSWMILVNVOWHWCX
      TXRWMPXLYAACDXQWMILXSVQSVRVSVFWHWCWDXBXCWOWKPXLWCWDWEWFVTZXFXGABCDEFHWIIJ
      KLWAVOWHWDWEWPWNPYBXNABCDEWLFGILJXHKUISWB $.
  $}

  ${
    $( If ` A ` is a subring of ` R ` , then they have the same
       characteristic.  (Contributed by Thierry Arnoux, 24-Feb-2018.) $)
    subrgchr $p |- ( A e. ( SubRing ` R ) ->
      ( chr ` ( R |`s A ) ) = ( chr ` R ) ) $=
      ( csubrg cfv wcel cress cur cod cchr csubg wceq subrgsubg subrg1cl subgod
      co eqid syl2anc subrg1 fveq2d chrval eqtr2d 3eqtr3g ) ABCDEZBAFOZGDZUDHDZ
      DZBGDZBHDZDZUDIDZBIDZUCUJUHUFDZUGUCABJDEUHAEUJUMKABLABUHUHPZMUHUFBUDUIAUD
      PZUIPZUFPZNQUCUHUEUFABUDUHUOUNRSUAUKUDUEUFUQUEPUKPTULBUHUIUPUNULPTUB $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Ordered rings and fields
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c oRing $.
  $c oField $.

  $( Extend class notation with the class of all ordered rings. $)
  corng $a class oRing $.

  $( Extend class notation with the class of all ordered fields. $)
  cofld $a class oField $.

  ${
    $d a b f l r t v z $.
    $( Define class of all ordered rings.  An ordered ring is a ring with a
       total ordering compatible with its operations.  (Contributed by Thierry
       Arnoux, 23-Mar-2018.) $)
    df-orng $a |- oRing = { r e. ( Ring i^i oGrp ) | [. ( Base ` r ) / v ].
      [. ( 0g ` r ) / z ]. [. ( .r ` r ) / t ]. [. ( le ` r ) / l ].
      A. a e. v A. b e. v ( ( z l a /\ z l b ) -> z l ( a t b ) ) } $.

    $( Define class of all ordered fields.  An ordered field is a field with a
       total ordering compatible with its operations.  (Contributed by Thierry
       Arnoux, 18-Jan-2018.) $)
    df-ofld $a |- oField = ( Field i^i oRing ) $.
  $}

  ${
    $d a b l r t v z B $.  $d a b l r t v z R $.  $d l r t z .0. $.
    $d l r .<_ $.  $d l r t .x. $.
    isorng.0 $e |- B = ( Base ` R ) $.
    isorng.1 $e |- .0. = ( 0g ` R ) $.
    isorng.2 $e |- .x. = ( .r ` R ) $.
    isorng.3 $e |- .<_ = ( le ` R ) $.
    $( An ordered ring is a ring with a total ordering compatible with its
       operations.  (Contributed by Thierry Arnoux, 18-Jan-2018.) $)
    isorng $p |- ( R e. oRing <-> ( R e. Ring /\ R e. oGrp /\
      A. a e. B A. b e. B ( ( .0. .<_ a /\ .0. .<_ b )
        -> .0. .<_ ( a .x. b ) ) ) ) $=
      ( vl vt wcel wbr wa wral cfv wsbc wceq vz vv vr crg cogrp cin cv co corng
      wi w3a elin anbi1i cple cmulr c0g cbs cvv fvex simpr simpl fveq2d syl6eqr
      a1i eqtrd oveqd breq2d imbi2d 2ralbidv sbcbidv sbcied wb fveq2 raleqbi1dv
      adantr raleq breq1d anbi12d imbi12d bitr2d 3bitr3d df-orng elrab2 3bitr4i
      syl breqd df-3an ) BUDUEUFZNZEFUGZDOZEGUGZDOZPZEWJWLCUHZDOZUJZGAQFAQZPBUD
      NZBUENZPZWRPBUINWSWTWRUKWIXAWRBUDUEULUMUAUGZWJLUGZOZXBWLXCOZPZXBWJWLMUGZU
      HZXCOZUJZGUBUGZQZFXKQZLUCUGZUNRZSZMXNUORZSZUAXNUPRZSZUBXNUQRZSZWRUCBWHUIX
      NBTZEWJXCOZEWLXCOZPZEXHXCOZUJZGAQFAQZLXOSZMXQSZYFEWOXCOZUJZGAQFAQZLXOSZYB
      WRYCYJYOMXQURXQURNYCXNUOUSVDYCXGXQTZPZYIYNLXOYQYHYMFGAAYQYGYLYFYQXHWOEXCY
      QXGCWJWLYQXGXQCYCYPUTYQXQBUORCYQXNBUOYCYPVAVBJVCVEVFVGVHVIVJVKYCYBXJGAQZF
      AQZLXOSZMXQSZUAXSSZYKYCXTUUBUBYAURYAURNYCXNUQUSVDYCXKYATZPZXRUUAUAXSUUDXP
      YTMXQUUDXMYSLXOUUDXKATXMYSVLUUDXKYAAYCUUCUTYCYAATUUCYCYABUQRAXNBUQVMHVCVO
      VEXLYRFXKAXJGXKAVPVNWEVJVJVJVKYCUUAYKUAXSURXSURNYCXNUPUSVDYCXBXSTZPZYTYJM
      XQUUFYSYILXOUUFXJYHFGAAUUFXFYFXIYGUUFXDYDXEYEUUFXBEWJXCUUFXBXSEYCUUEUTYCX
      SETUUEYCXSBUPREXNBUPVMIVCVOVEZVQUUFXBEWLXCUUGVQVRUUFXBEXHXCUUGVQVSVIVJVJV
      KVTYCYNWRLXOURXOURNYCXNUNUSVDYCXCXOTZPZYMWQFGAAUUIYFWNYLWPUUIYDWKYEWMUUIX
      CDEWJUUIXCXODYCUUHUTUUIXOBUNRDUUIXNBUNYCUUHVAVBKVCVEZWFUUIXCDEWLUUJWFVRUU
      IXCDEWOUUJWFVSVIVKWAUAUBMUCFGLWBWCWSWTWRWGWD $.
  $}

  ${
    $d a b R $.
    $( An ordered ring is a ring.  (Contributed by Thierry Arnoux,
       23-Mar-2018.) $)
    orngrng $p |- ( R e. oRing -> R e. Ring ) $=
      ( va vb corng wcel crg cogrp c0g cfv cv cple wbr wa cmulr co wi wral eqid
      cbs isorng simp1bi ) ADEAFEAGEAHIZBJZAKIZLUBCJZUDLMUBUCUEANIZOUDLPCASIZQB
      UGQUGAUFUDUBBCUGRUBRUFRUDRTUA $.

    $( An ordered ring is an ordered group.  (Contributed by Thierry Arnoux,
       23-Mar-2018.) $)
    orngogrp $p |- ( R e. oRing -> R e. oGrp ) $=
      ( va vb corng wcel crg cogrp c0g cfv cv cple wbr wa cmulr co wi wral eqid
      cbs isorng simp2bi ) ADEAFEAGEAHIZBJZAKIZLUBCJZUDLMUBUCUEANIZOUDLPCASIZQB
      UGQUGAUFUDUBBCUGRUBRUFRUDRTUA $.
  $}

  $( An ordered field is a field with a total ordering compatible with its
     operations.  (Contributed by Thierry Arnoux, 23-Mar-2018.) $)
  isofld $p |- ( F e. oField <-> ( F e. Field /\ F e. oRing ) ) $=
    ( cfield corng cofld df-ofld elin2 ) ABCDEF $.

  ${
    $d a b B $.  $d a b R $.  $d a b X $.  $d b Y $.  $d a b .0. $.
    $d a b .<_ $.  $d a b .x. $.
    orngmul.0 $e |- B = ( Base ` R ) $.
    orngmul.1 $e |- .<_ = ( le ` R ) $.
    orngmul.2 $e |- .0. = ( 0g ` R ) $.
    orngmul.3 $e |- .x. = ( .r ` R ) $.
    $( In an ordered field, the ordering is compatible with the ring
       multiplication operation.  (Contributed by Thierry Arnoux,
       20-Jan-2018.) $)
    orngmul $p |- ( ( R e. oRing
      /\ ( X e. B /\ .0. .<_ X ) /\ ( Y e. B /\ .0. .<_ Y ) )
      -> .0. .<_ ( X .x. Y ) ) $=
      ( va vb wcel wbr wa co cv wi wral w3a simp2r simp3r jca simp2l simp3l crg
      corng cogrp isorng simp3bi 3ad2ant1 wceq breq2 biidd anbi12d oveq1 breq2d
      imbi12d oveq2 rspc2v imp syl21anc mpd ) BUHNZEANZGEDOZPZFANZGFDOZPZUAZVGV
      JPZGEFCQZDOZVLVGVJVEVFVGVKUBVEVHVIVJUCUDVLVFVIGLRZDOZGMRZDOZPZGVPVRCQZDOZ
      SZMATLATZVMVOSZVEVFVGVKUEVEVHVIVJUFVEVHWDVKVEBUGNBUINWDABCDGLMHJKIUJUKULV
      FVIPWDWEWCWEVGVSPZGEVRCQZDOZSLMEFAAVPEUMZVTWFWBWHWIVQVGVSVSVPEGDUNWIVSUOU
      PWIWAWGGDVPEVRCUQURUSVRFUMZWFVMWHVOWJVGVGVSVJWJVGUOVRFGDUNUPWJWGVNGDVRFEC
      UTURUSVAVBVCVD $.

    $( In an ordered field, all squares are positive.  (Contributed by Thierry
       Arnoux, 20-Jan-2018.) $)
    orngsqr $p |- ( ( R e. oRing /\ X e. B ) -> .0. .<_ ( X .x. X ) ) $=
      ( wcel wa wbr co syl3anc cfv syl eqid wceq wo corng simpll simplr orngmul
      simpr jca wn cminusg cgrp orngrng ad2antrr rnggrp grpinvcl syl2anc cplusg
      crg comnd w3a cogrp orngogrp isogrp simprbi grpidcl 3jca cplt simpl pltle
      wi 3syl con3d imp sylan w3o wor ctos omndtos cid cres wss tosso ibi solin
      simpld syl12anc 3orass sylib orel1 sylc orcom eqcom orbi2i bitri mpbi cpo
      imbi2i wb tospos pleval2 mpbird omndadd grprinv grplid rngm2neg pm2.61dan
      3brtr3d breqtrd ) BUAKZEAKZLZFEDMZFEECNZDMZXIXJLZXGXHXJLZXNXLXGXHXJUBXMXH
      XJXGXHXJUCXIXJUEUFZXOABCDEEFGHIJUDOXIXJUGZLZFEBUHPZPZXSCNZXKDXQXGXSAKZFXS
      DMZLZYCFXTDMXGXHXPUBZXQYAYBXQBUIKZXHYAXQBUPKZYEXGYFXHXPBUJZUKZBULZQZXGXHX
      PUCZABXREGXRRZUMUNZXQEXSBUOPZNZFXSYNNZFXSDXQBUQKZXHFAKZYAUREFDMZYOYPDMXQX
      GYQYDXGBUSKZYQBUTYTYEYQBVAVBQZQXQXHYRYAYKXQYEYRYJABFGIVCZQZYMVDXQYSEFBVEP
      ZMZEFSZTZXQFESZUUETZVHXQUUGVHXQFEUUDMZUGZUUJUUITZUUIXIXGYRXHURZXPUUKXIXGY
      RXHXGXHVFZXIXGYRUUNXGYFYEYRYGYIUUBVIQXGXHUEVDUUMXPUUKUUMUUJXJUAAAUUDBDFEH
      UUDRZVGVJVKVLXQUUJUUHUUEVMZUULXQAUUDVNZYRXHUUPXQXGBVOKZUUQYDXGYQUURUUABVP
      QZUURUUQVQAVRDVSZUURUUQUUTLAUUDBDVOGHUUOVTWAWCVIUUCYKAFEUUDWBWDUUJUUHUUEW
      EWFUUJUUIWGWHUUIUUGXQUUIUUEUUHTUUGUUHUUEWIUUHUUFUUEFEWJWKWLWOWMXQBWNKZXHY
      RYSUUGWPXQXGUURUVAYDUUSBWQVIYKUUCAUUDBDEFGHUUOWROWSAYNDBEFXSGHYNRZWTOXQYE
      XHYOFSYJYKAYNBXREFGUVBIYLXAUNXQYEYAYPXSSYJYMAYNBXSFGUVBIXBUNXEUFZUVCABCDX
      SXSFGHIJUDOXQABCXREEGJYLYHYKYKXCXFXD $.
  $}

  ${
    orngmullt.b $e |- B = ( Base ` R ) $.
    orngmullt.t $e |- .x. = ( .r ` R ) $.
    orngmullt.0 $e |- .0. = ( 0g ` R ) $.
    orngmullt.1 $e |- ( ph -> R e. oRing ) $.
    orngmullt.2 $e |- ( ph -> X e. B ) $.
    orngmullt.3 $e |- ( ph -> Y e. B ) $.
    orngmullt.4 $e |- ( ph -> Z e. B ) $.
    ${
      orngmulle.l $e |- .<_ = ( le ` R ) $.
      orngmulle.5 $e |- ( ph -> X .<_ Y ) $.
      orngmulle.6 $e |- ( ph -> .0. .<_ Z ) $.
      $( In an ordered ring, multiplication with a positive does not change
         comparison.  (Contributed by Thierry Arnoux, 10-Apr-2018.) $)
      ornglmulle $p |- ( ph -> ( Z .x. X ) .<_ ( Z .x. Y ) ) $=
        ( wcel co cplusg cfv csg comnd wbr cogrp corng orngogrp syl cgrp isogrp
        simprbi crg orngrng rnggrp grpidcl rngcl syl3anc eqid grpsubcl grpsubid
        wceq syl2anc ogrpsub syl131anc eqbrtrrd orngmul rngsubdi breqtrd grplid
        syl122anc omndadd grpnpcan 3brtr3d ) AHIFDUAZCUBUCZUAZIGDUAZVPCUDUCZUAZ
        VPVQUAZVPVSEACUETZHBTZWABTZVPBTZHWAEUFVRWBEUFACUGTZWCACUHTZWGMCUIUJZWGC
        UKTZWCCULUMUJAWJWDACUNTZWJAWHWKMCUOUJZCUPUJZBCHJLUQUJAWJVSBTZWFWEWMAWKI
        BTZGBTZWNWLPOBCDIGJKURUSZAWKWOFBTZWFWLPNBCDIFJKURUSZBCVTVSVPJVTUTZVAUSW
        SAHIGFVTUAZDUAZWAEAWHWOHIEUFXABTZHXAEUFHXBEUFMPSAWJWPWRXCWMONBCVTGFJWTV
        AUSAFFVTUAZHXAEAWJWRXDHVCWMNBCVTFHJLWTVBVDAWGWRWPWRFGEUFXDXAEUFWINONRBC
        EVTFGFJQWTVEVFVGBCDEIXAHJQLKVHVLABCDVTIGFJKWTWLPONVIVJBVQECHWAVPJQVQUTZ
        VMVFAWJWFVRVPVCWMWSBVQCVPHJXELVKVDAWJWNWFWBVSVCWMWQWSBVQCVTVSVPJXEWTVNU
        SVO $.

      $( In an ordered ring, multiplication with a positive does not change
         comparison.  (Contributed by Thierry Arnoux, 10-Apr-2018.) $)
      orngrmulle $p |- ( ph -> ( X .x. Z ) .<_ ( Y .x. Z ) ) $=
        ( wcel co cplusg cfv csg comnd wbr cogrp corng orngogrp syl cgrp isogrp
        simprbi crg orngrng rnggrp grpidcl rngcl syl3anc eqid grpsubcl grpsubid
        wceq syl2anc ogrpsub syl131anc orngmul syl122anc breqtrd omndadd grplid
        eqbrtrrd rngsubdir grpnpcan 3brtr3d ) AHFIDUAZCUBUCZUAZGIDUAZVPCUDUCZUA
        ZVPVQUAZVPVSEACUETZHBTZWABTZVPBTZHWAEUFVRWBEUFACUGTZWCACUHTZWGMCUIUJZWG
        CUKTZWCCULUMUJAWJWDACUNTZWJAWHWKMCUOUJZCUPUJZBCHJLUQUJAWJVSBTZWFWEWMAWK
        GBTZIBTZWNWLOPBCDGIJKURUSZAWKFBTZWPWFWLNPBCDFIJKURUSZBCVTVSVPJVTUTZVAUS
        WSAHGFVTUAZIDUAZWAEAWHXABTZHXAEUFWPHIEUFHXBEUFMAWJWOWRXCWMONBCVTGFJWTVA
        USAFFVTUAZHXAEAWJWRXDHVCWMNBCVTFHJLWTVBVDAWGWRWOWRFGEUFXDXAEUFWINONRBCE
        VTFGFJQWTVEVFVLPSBCDEXAIHJQLKVGVHABCDVTGFIJKWTWLONPVMVIBVQECHWAVPJQVQUT
        ZVJVFAWJWFVRVPVCWMWSBVQCVPHJXELVKVDAWJWNWFWBVSVCWMWQWSBVQCVTVSVPJXEWTVN
        USVO $.
    $}

    ${
      orngmullt.l $e |- .< = ( lt ` R ) $.
      orngmullt.d $e |- ( ph -> R e. DivRing ) $.
      orngmullt.5 $e |- ( ph -> X .< Y ) $.
      orngmullt.6 $e |- ( ph -> .0. .< Z ) $.
      $( In an ordered ring, multiplication with a positive does not change
         strict comparison.  (Contributed by Thierry Arnoux, 9-Apr-2018.) $)
      ornglmullt $p |- ( ph -> ( Z .x. X ) .< ( Z .x. Y ) ) $=
        ( co wbr cple cfv wne eqid corng wcel w3a imp syl31anc crg cgrp orngrng
        pltle syl rnggrp grpidcl 3syl ornglmulle wceq wa cinvr simpr oveq2d cur
        cui cdr pltne necomd drngunit biimpar syl12anc unitlinv oveq1d rnginvcl
        syl2anc rngass syl13anc rnglidm 3eqtr3d adantr neneqd pm2.65da wb rngcl
        neneqad syl3anc pltval mpbir2and ) AIFEUAZIGEUAZDUBZWKWLCUCUDZUBZWKWLUE
        ZABCEWNFGHIJKLMNOPWNUFZACUGUHZFBUHZGBUHZFGDUBZFGWNUBZMNOSWRWSWTUIZXAXBU
        GBBDCWNFGWQQUOUJUKAWRHBUHZIBUHZHIDUBZHIWNUBZMACULUHZCUMUHXDAWRXHMCUNUPZ
        CUQBCHJLURUSZPTWRXDXEUIZXFXGUGBBDCWNHIWQQUOUJUKUTAWKWLAWKWLVAZFGVAAXLVB
        ZICVCUDZUDZWKEUAZXOWLEUAZFGXMWKWLXOEAXLVDVEAXPFVAXLAXOIEUAZFEUAZCVFUDZF
        EUAZXPFAXRXTFEAXHICVGUDZUHZXRXTVAXIACVHUHZXEIHUEZYCRPAHIAWRXDXEXFHIUEZM
        XJPTXKXFYFUGBBDCHIQVIUJUKVJYDYCXEYEVBBCYBIHJYBUFZLVKVLVMZCEYBXTXNIYGXNU
        FZKXTUFZVNVQZVOAXHXOBUHZXEWSXSXPVAXIAXHYCYLXIYHBCYBXNIYGYIJVPVQZPNBCEXO
        IFJKVRVSAXHWSYAFVAXINBCEXTFJKYJVTVQWAWBAXQGVAXLAXRGEUAZXTGEUAZXQGAXRXTG
        EYKVOAXHYLXEWTYNXQVAXIYMPOBCEXOIGJKVRVSAXHWTYOGVAXIOBCEXTGJKYJVTVQWAWBW
        AXMFGAFGUEZXLAWRWSWTXAYPMNOSXCXAYPUGBBDCFGQVIUJUKWBWCWDWGAWRWKBUHZWLBUH
        ZWMWOWPVBWEMAXHXEWSYQXIPNBCEIFJKWFWHAXHXEWTYRXIPOBCEIGJKWFWHUGBBDCWNWKW
        LWQQWIWHWJ $.

      $( In an ordered ring, multiplication with a positive does not change
         strict comparison.  (Contributed by Thierry Arnoux, 9-Apr-2018.) $)
      orngrmullt $p |- ( ph -> ( X .x. Z ) .< ( Y .x. Z ) ) $=
        ( co wbr cple cfv wne eqid corng wcel w3a imp syl31anc crg cgrp orngrng
        pltle syl rnggrp grpidcl 3syl orngrmulle wceq cdvr simpr oveq1d cui cdr
        wa pltne necomd drngunit biimpar syl12anc dvrcan3 syl3anc adantr neneqd
        3eqtr3d pm2.65da neneqad wb rngcl pltval mpbir2and ) AFIEUAZGIEUAZDUBZW
        DWECUCUDZUBZWDWEUEZABCEWGFGHIJKLMNOPWGUFZACUGUHZFBUHZGBUHZFGDUBZFGWGUBZ
        MNOSWKWLWMUIZWNWOUGBBDCWGFGWJQUOUJUKAWKHBUHZIBUHZHIDUBZHIWGUBZMACULUHZC
        UMUHWQAWKXAMCUNUPZCUQBCHJLURUSZPTWKWQWRUIZWSWTUGBBDCWGHIWJQUOUJUKUTAWDW
        EAWDWEVAZFGVAAXEVGZWDICVBUDZUAZWEIXGUAZFGXFWDWEIXGAXEVCVDAXHFVAZXEAXAWL
        ICVEUDZUHZXJXBNACVFUHZWRIHUEZXLRPAHIAWKWQWRWSHIUEZMXCPTXDWSXOUGBBDCHIQV
        HUJUKVIXMXLWRXNVGBCXKIHJXKUFZLVJVKVLZBXGCEXKFIJXPXGUFZKVMVNVOAXIGVAZXEA
        XAWMXLXSXBOXQBXGCEXKGIJXPXRKVMVNVOVQXFFGAFGUEZXEAWKWLWMWNXTMNOSWPWNXTUG
        BBDCFGQVHUJUKVOVPVRVSAWKWDBUHZWEBUHZWFWHWIVGVTMAXAWLWRYAXBNPBCEFIJKWAVN
        AXAWMWRYBXBOPBCEGIJKWAVNUGBBDCWGWDWEWJQWBVNWC $.
    $}
  $}

  $( An ordered field is a field.  (Contributed by Thierry Arnoux,
     20-Jan-2018.) $)
  ofldfld $p |- ( F e. oField -> F e. Field ) $=
    ( cofld wcel cfield corng isofld simplbi ) ABCADCAECAFG $.

  $( An ordered field is a totally ordered set.  (Contributed by Thierry
     Arnoux, 20-Jan-2018.) $)
  ofldtos $p |- ( F e. oField -> F e. Toset ) $=
    ( cofld wcel comnd ctos corng cogrp cfield isofld orngogrp cgrp isogrp 3syl
    simprbi omndtos syl ) ABCZADCZAECQAFCZAGCZRQAHCSAINAJTAKCRALNMAOP $.

  ${
    orng0le1.1 $e |- .0. = ( 0g ` F ) $.
    orng0le1.2 $e |- .1. = ( 1r ` F ) $.
    ${
      orng0le1.3 $e |- .<_ = ( le ` F ) $.
      $( In an ordered ring, the ring unit is positive.  (Contributed by
         Thierry Arnoux, 21-Jan-2018.) $)
      orng0le1 $p |- ( F e. oRing -> .0. .<_ .1. ) $=
        ( corng wcel cmulr cfv co cbs wbr crg orngrng eqid rngidcl syl orngsqr
        mpdan wceq rnglidm syl2anc breqtrd ) BHIZDAABJKZLZACUFABMKZIZDUHCNUFBOI
        ZUJBPZUIBAUIQZFRSZUIBUGCADUMGEUGQZTUAUFUKUJUHAUBULUNUIBUGAAUMUOFUCUDUE
        $.
    $}

    ${
      ofld0lt1.3 $e |- .< = ( lt ` F ) $.
      $( In an ordered field, the ring unit is strictly positive.  (Contributed
         by Thierry Arnoux, 21-Jan-2018.) $)
      ofldlt1 $p |- ( F e. oField -> .0. .< .1. ) $=
        ( cofld wcel wbr cple cfv wne corng cfield cvv c0g fvex eqeltri cur syl
        isofld simprbi eqid orng0le1 cdr ofldfld ccrg isfld simplbi 3syl necomd
        drngunz wa wb pltval mp3an23 mpbir2and ) CHIZDBAJZDBCKLZJZDBMZUSCNIZVBU
        SCOIZVDCUBUCBCVADEFVAUDZUEUAUSBDUSVECUFIZBDMCUGVEVGCUHICUIUJCBDEFUMUKUL
        USDPIBPIUTVBVCUNUODCQLPECQRSBCTLPFCTRSHPPACVADBVFGUPUQUR $.
    $}
  $}

  ${
    $d m n F $.  $d n y F $.
    $( The characteristic of an ordered field is zero.  (Contributed by Thierry
       Arnoux, 21-Jan-2018.) $)
    ofldchr $p |- ( F e. oField -> ( chr ` F ) = 0 ) $=
      ( vy wcel cfv cc0 eqid co wceq cn 3syl wa wbr wi c1 breq2d imbi2d syl3anc
      oveq1 syl cvv vn vm cofld cchr cur cod chrval cv cmg c0g crab c0 clt ccnv
      cr csup cif crg cbs cfield cdr ofldfld ccrg isfld simplbi drngrng rngidcl
      odval wn wral cplt wne caddc ofldlt1 breqtrrd cpo w3a ctos ofldtos tospos
      mulg1 ad2antlr cgrp rnggrp grpidcl grpmnd simpll mulgnncl peano2nnd simpr
      cmnd cplusg cogrp simplr isofld simprbi orngogrp ogrpaddlt grplid syl2anc
      3jca corng eqcomd mulgnnp1 ccmn rngcmn cmncom eqtrd 3brtr4d jca plttr imp
      syl21anc ex a2d nnind impcom fvex ovex pltne mp3an23 adantr necomd neneqd
      mpd ralrimiva rabeq0 sylibr iftrue syl5eqr ) AUCCZAUDDZAUEDZAUFDZDZEYLAYM
      YNYNFZYMFZYLFUGYKYOBUHZYMAUIDZGZAUJDZHZBIUKZULHZEUUCUOUMUNUPZUQZEYKAURCZY
      MAUSDZCZYOUUFHYKAUTCZAVACZUUGAVBUUJUUKAVCCAVDVEAVFJZUUHAYMUUHFZYQVGZBYMYS
      AUUCYNUUHUUAUUMYSFZUUAFZYPUUCFVHJYKUUDUUFEHYKUUBVIZBIVJUUDYKUUQBIYKYRICZK
      ZYTUUAUUSUUAYTUUSUUAYTAVKDZLZUUAYTVLZUURYKUVAYKUUAUAUHZYMYSGZUUTLZMYKUUAN
      YMYSGZUUTLZMYKUUAUBUHZYMYSGZUUTLZMYKUUAUVHNVMGZYMYSGZUUTLZMYKUVAMUAUBYRUV
      CNHZUVEUVGYKUVNUVDUVFUUAUUTUVCNYMYSROPUVCUVHHZUVEUVJYKUVOUVDUVIUUAUUTUVCU
      VHYMYSROPUVCUVKHZUVEUVMYKUVPUVDUVLUUAUUTUVCUVKYMYSROPUVCYRHZUVEUVAYKUVQUV
      DYTUUAUUTUVCYRYMYSROPYKUUAYMUVFUUTUUTYMAUUAUUPYQUUTFZVNZYKUUIUVFYMHYKUUGU
      UIUULUUNSZUUHYSAYMUUMUUOWASVOUVHICZYKUVJUVMUWAYKUVJUVMMUWAYKKZUVJUVMUWBUV
      JKZAVPCZUUAUUHCZUVIUUHCZUVLUUHCZVQZUVJUVIUVLUUTLZKZUVMYKUWDUWAUVJYKAVRCUW
      DAVSAVTSWBUWCUWEUWFUWGUWCAWCCZUWEYKUWKUWAUVJYKUUGUWKUULAWDSWBZUUHAUUAUUMU
      UPWESZUWCAWKCZUWAUUIUWFUWCUWKUWNUWLAWFSZUWAYKUVJWGZYKUUIUWAUVJUVTWBZUUHYS
      AUVHYMUUMUUOWHQZUWCUWNUVKICUUIUWGUWOUWCUVHUWPWIUWQUUHYSAUVKYMUUMUUOWHQXAU
      WCUVJUWIUWBUVJWJUWCUUAUVIAWLDZGZYMUVIUWSGZUVIUVLUUTUWCAWMCZUWEUUIUWFVQUUA
      YMUUTLZUWTUXAUUTLUWCYKAXBCZUXBUWAYKUVJWNZYKUUJUXDAWOWPAWQJUWCUWEUUIUWFUWM
      UWQUWRXAUWCYKUXCUXEUVSSUUHUWSUUTAUUAYMUVIUUMUVRUWSFZWRQUWCUWTUVIUWCUWKUWF
      UWTUVIHUWLUWRUUHUWSAUVIUUAUUMUXFUUPWSWTXCUWCUVLUVIYMUWSGZUXAUWCUWAUUIUVLU
      XGHUWPUWQUUHUWSYSAUVHYMUUMUUOUXFXDWTUWCAXECZUWFUUIUXGUXAHUWCYKUUGUXHUXEUU
      LAXFJUWRUWQUUHUWSAUVIYMUUMUXFXGQXHXIXJUWDUWHKUWJUVMUUHUUTAUUAUVIUVLUUMUVR
      XKXLXMXNXNXOXPXQYKUVAUVBMZUURYKUUATCYTTCUXIAUJXRYRYMYSXSUCTTUUTAUUAYTUVRX
      TYAYBYEYCYDYFUUBBIYGYHUUDEUUEYISXHYJ $.
  $}

  ${
    $d a b c x y A $.  $d a b x y R $.
    $( Every subring of an ordered ring is also an ordered ring.  (Contributed
       by Thierry Arnoux, 21-Jan-2018.) $)
    suborng $p |- ( ( R e. oRing /\ ( R |`s A ) e. Ring )
      -> ( R |`s A ) e. oRing ) $=
      ( va vb wcel cress co wa c0g cfv wbr cbs cgrp syl jca c0 wceq eqid adantr
      cvv corng crg cogrp cv cple cmulr wi wral w3a simpr comnd rnggrp orngogrp
      isogrp simprbi rngmnd anim12i submomnd sylibr simp-4l wn reldmress ovprc2
      cmnd wss fveq2d adantl base0 syl6eqr wne cur rngidcl ne0i ad2antlr neneqd
      condan ressbas inss2 syl6eqssr ad3antrrr simpllr sseldd simprl wb orngrng
      cin csubg ressinbas oveq2d eqtrd eqeltrrd 3jca issubg subg0 eqtr4d ressle
      ad2antrr eqidd breq123d mpbird simplr simprr orngmul ressmulr oveqd mpbid
      syl3anc ex anasss ralrimivva isorng ) BUAEZBAFGZUBEZHZXNXMUCEZXMIJZCUDZXM
      UEJZKZXQDUDZXSKZHZXQXRYAXMUFJZGZXSKZUGZDXMLJZUHCYHUHZUIXMUAEXOXNXPYIXLXNU
      JZXOXMMEZXMUKEZHXPXOYKYLXOXNYKYJXMULNZXOBUKEZXMVDEZHYLXLYNXNYOXLBUCEZYNBU
      MYPBMEZYNBUNUONXMUPUQABURNOXMUNUSXOYGCDYHYHXOXRYHEZYAYHEZYGXOYRHZYSHZYCYF
      UUAYCHZBIJZXRYABUFJZGZBUEJZKZYFUUBXLXRBLJZEZUUCXRUUFKZHYAUUHEZUUCYAUUFKZH
      UUGXLXNYRYSYCUTUUBUUIUUJUUBYHUUHXRXOYHUUHVEZYRYSYCXOATEZUUMXOUUNYHPQXOUUN
      VAZHZYHPLJZPUUOYHUUQQXOUUOXMPLBAFVBVCVFVGVHVIUUPYHPXNYHPVJZXLUUOXNXMVKJZY
      HEUURYHXMUUSYHRZUUSRVLYHUUSVMNVNVOVPZUUNYHAUUHWFZUUHAUUHXMTBXMRZUUHRZVQZA
      UUHVRVSNZVTZXOYRYSYCWAWBUUBUUJXTUUAXTYBWCUUAUUJXTWDYCUUAUUCXQXRXRUUFXSXOU
      UCXQQZYRYSXOUUCBYHFGZIJZXQXOYHBWGJEZUUCUVJQXOYQUUMUVIMEZUIUVKXOYQUUMUVLXL
      YQXNXLBUBEYQBWEBULNSUVFXOXMUVIMXOUUNXMUVIQUVAUUNXMBUVBFGUVIAUUHBTUVDWHUUN
      UVBYHBFUVEWIWJNZYMWKWLUUHYHBUVDWMUSYHBUVIUUCUVIRUUCRZWNNXOXMUVIIUVMVFWOWQ
      ZUUAUUNUUFXSQZXOUUNYRYSUVAWQZABUUFTXMUVCUUFRZWPNZUUAXRWRWSSWTOUUBUUKUULUU
      BYHUUHYAUVGYTYSYCXAWBUUBUULYBUUAXTYBXBUUAUULYBWDYCUUAUUCXQYAYAUUFXSUVOUVS
      UUAYAWRWSSWTOUUHBUUDUUFXRYAUUCUVDUVRUVNUUDRZXCXGUUBUUCXQUUEYEUUFXSUUAUVHY
      CUVOSUUAUVPYCUVSSUUBUUDYDXRYAUUBUUNUUDYDQUUAUUNYCUVQSABXMUUDTUVCUVTXDNXEW
      SXFXHXIXJWLYHXMYDXSXQCDUUTXQRYDRXSRXKUS $.
  $}

  $( Every subfield of an ordered field is also an ordered field.  (Contributed
     by Thierry Arnoux, 21-Jan-2018.) $)
  subofld $p |- ( ( F e. oField /\ ( F |`s A ) e. Field )
    -> ( F |`s A ) e. oField ) $=
    ( cofld wcel cress co cfield corng simpr crg isofld simprbi adantr ccrg cdr
    wa isfld crngrng 3syl suborng syl2anc jca sylibr ) BCDZBAEFZGDZPZUFUEHDZPUE
    CDUGUFUHUDUFIZUGBHDZUEJDZUHUDUJUFUDBGDUJBKLMUGUFUENDZUKUIUFUEODULUEQLUERSAB
    TUAUBUEKUC $.

  ${
    $d n x y z B $.  $d n x y z W $.  $d x y z H $.  $d n x y z .< $.
    isarchiofld.b $e |- B = ( Base ` W ) $.
    isarchiofld.h $e |- H = ( ZRHom ` W ) $.
    isarchiofld.l $e |- .< = ( lt ` W ) $.
    $( Axiom of Archimedes : a characterization of the Archimedean property for
       ordered fields.  (Contributed by Thierry Arnoux, 9-Apr-2018.) $)
    isarchiofld $p |- ( W e. oField ->
      ( W e. Archi <-> A. x e. B E. n e. NN x .< ( H ` n ) ) ) $=
      ( wcel cfv wbr co cn wral eqid 3syl wceq syl wa vy vz cofld carchi c0g cv
      cmg wi corng cogrp wb cfield isofld simprbi orngogrp isarchi3 cur orngrng
      wrex crg rngidcl breq2 oveq2 breq2d rexbidv imbi12d ralbidv rspcv ofldlt1
      pm5.5 sylibd cz nnz ccnfld cress zrhmulg syl2an rexbidva sylibrd nfv nfan
      nfra1 cdvr cui ad3antrrr simplrr wne simplrl simpr simplll rnggrp grpidcl
      cgrp pltne syl3anc mpd necomd simplbi ccrg isfld drngunit mpbir2and dvrcl
      cdr breq1 cbvralv sylib ad2antrr imp syl2anc cmulr simp-4l simp-4r simprd
      simpld simpllr simplr mulgcl eqeltrd orngrmullt dvrcan1 mulgass2 syl13anc
      oveq1d rnglidm oveq2d 3brtr3d ex reximdva adantllr expr ralrimi ralrimiva
      3eqtrd impbid bitrd ) FUCJZFUDJZFUEKZUAUFZCLZAUFZDUFZYTFUGKZMZCLZDNUSZUHZ
      ABOZUABOZUUBUUCEKZCLZDNUSZABOZYQFUIJZFUJJYRUUJUKYQFULJZUUOFUMZUNZFUOUAABC
      UUDDFYSGYSPZIUUDPZUPQYQUUJUUNYQUUJUUBUUCFUQKZUUDMZCLZDNUSZABOZUUNYQUUJYSU
      VACLZUVDUHZABOZUVEYQUVABJZUUJUVHUHYQUUOFUTJZUVIUURFURZBFUVAGUVAPZVAZQUUIU
      VHUAUVABYTUVARZUUHUVGABUVNUUAUVFUUGUVDYTUVAYSCVBUVNUUFUVCDNUVNUUEUVBUUBCY
      TUVAUUCUUDVCVDVEVFVGVHSYQUVGUVDABYQUVFUVGUVDUKCUVAFYSUUSUVLIVIUVFUVDVJSVG
      VKYQUUMUVDABYQUULUVCDNYQUUCNJZTUUKUVBUUBCYQUVJUUCVLJZUUKUVBRZUVOYQUUOUVJU
      URUVKSZUUCVMZFUUDUVAEUUCVNVLVOMZUVTPHUUTUVLVPVQZVDVRVGVSYQUUNUUJYQUUNTZUU
      IUABUWBYTBJZTUUHABUWBUWCAYQUUNAYQAVTUUMABWBWAUWCAVTWAUWBUWCUUBBJZUUHUWBUW
      CUWDTZTZUUAUUGUWFUUATZUUBYTFWCKZMZUUKCLZDNUSZUUGUWGUWIBJZUBUFZUUKCLZDNUSZ
      UBBOZUWKUWGUVJUWDYTFWDKZJZUWLYQUVJUUNUWEUUAUVRWEZUWBUWCUWDUUAWFUWGUWRUWCY
      TYSWGZUWBUWCUWDUUAWHZUWGYSYTUWGUUAYSYTWGZUWFUUAWIUWGYQYSBJZUWCUUAUXBUHZYQ
      UUNUWEUUAWJZUWGUVJFWMJZUXCUWSFWKZBFYSGUUSWLZQUXAUCBBCFYSYTIWNZWOWPWQUWGYQ
      FXDJZUWRUWCUWTTUKZUXEYQUUPUXJYQUUPUUOUUQWRUUPUXJFWSJFWTWRSZBFUWQYTYSGUWQP
      ZUUSXAZQXBBUWHFUWQUUBYTGUXMUWHPZXCZWOUWBUWPUWEUUAUWBUUNUWPYQUUNWIUUMUWOAU
      BBUUBUWMRUULUWNDNUUBUWMUUKCXEVEXFXGXHUWLUWPUWKUWOUWKUBUWIBUWMUWIRUWNUWJDN
      UWMUWIUUKCXEVEVHXIXJYQUWEUUAUWKUUGUHUUNYQUWETZUUATZUWJUUFDNUXRUVOTZUWJUUF
      UXSUWJTZUWIYTFXKKZMZUUKYTUYAMZUUBUUECUXTBFCUYAUWIUUKYSYTGUYAPZUUSUXTYQUUO
      YQUWEUUAUVOUWJXLZUURSUXTUVJUWDUWRUWLUXTYQUVJUYEUVRSZUXTUWCUWDYQUWEUUAUVOU
      WJXMZXNZUXTUWRUWCUWTUXTUWCUWDUYGXOZUXTYSYTUXTUUAUXBUXQUUAUVOUWJXPZUXTYQUX
      CUWCUXDUYEUXTUVJUXFUXCUYFUXGUXHQUYIUXIWOWPWQUXTYQUXJUXKUYEUXLUXNQXBZUXPWO
      UXTUUKUVBBUXTYQUVOUVQUYEUXRUVOUWJXQZUWAXJZUXTUXFUVPUVIUVBBJUXTUVJUXFUYFUX
      GSUXTUVOUVPUYLUVSSZUXTUVJUVIUYFUVMSZBUUDFUUCUVAGUUTXRWOXSUYIIUXTYQUXJUYEU
      XLSUXSUWJWIUYJXTUXTUVJUWDUWRUYBUUBRUYFUYHUYKBUWHFUYAUWQUUBYTGUXMUXOUYDYAW
      OUXTUYCUVBYTUYAMZUUCUVAYTUYAMZUUDMZUUEUXTUUKUVBYTUYAUYMYDUXTUVJUVPUVIUWCU
      YPUYRRUYFUYNUYOUYIBFUUDUYAUUCUVAYTGUUTUYDYBYCUXTUYQYTUUCUUDUXTUVJUWCUYQYT
      RUYFUYIBFUYAUVAYTGUYDUVLYEXJYFYNYGYHYIYJWPYHYKYLYMYHYOYP $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Ring homomorphisms - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d c y A $.  $d c y B $.  $d c y F $.  $d c R $.  $d c y S $.  $d c X $.
    $d c .|| $.
    rhmdvdsr.x $e |- X = ( Base ` R ) $.
    rhmdvdsr.m $e |- .|| = ( ||r ` R ) $.
    rhmdvdsr.n $e |- ./ = ( ||r ` S ) $.
    $( A ring homomorphism preserves the divisibility relation.  (Contributed
       by Thierry Arnoux, 22-Oct-2017.) $)
    rhmdvdsr $p |- ( ( ( F e. ( R RingHom S ) /\ A e. X /\ B e. X )
      /\ A .|| B ) -> ( F ` A ) ./ ( F ` B ) ) $=
      ( vy vc co wcel wa cfv wceq wrex syl2anc crh w3a wbr cbs cv simpl1 simpl2
      cmulr eqid rhmf ffvelrnda wral simpll1 simpr adantr rhmmul syl3anc dvdsr2
      ralrimiva biimpac r19.29 fveq2d eqtr3d reximi syl eqeq1d rspcev rexlimivw
      simpl oveq1 dvdsr sylanbrc ) GEFUANOZAHOZBHOZUBZABCUCZPZAGQZFUDQZOZLUEZVS
      FUHQZNZBGQZRZLVTSZVSWEDUCVRVMVNWAVMVNVOVQUFVMVNVOVQUGZVMHVTAGHVTEFGIVTUIZ
      UJZUKTVRMUEZGQZVTOZWLVSWCNZWERZPZMHSZWGVRWMMHULWOMHSZWQVRWMMHVRWKHOZPZVMW
      SWMVMVNVOVQWSUMZVRWSUNZVMHVTWKGWJUKTUSVRWKAEUHQZNZGQZWNRZMHULZXDBRZMHSZWR
      VRXFMHWTVMWSVNXFXAXBVRVNWSWHUOWKAEFXCWCGHIXCUIZWCUIZUPUQUSVRVQVNXIVPVQUNW
      HVNVQXIMHCEXCABIJXJURUTTXGXIPXFXHPZMHSWRXFXHMHVAXLWOMHXLXEWNWEXFXHVIXLXDB
      GXFXHUNVBVCVDVETWMWOMHVATWPWGMHWFWOLWLVTWBWLRWDWNWEWBWLVSWCVJVFVGVHVELVTD
      FWCVSWEWIKXKVKVL $.
  $}

  ${
    $d x y F $.  $d x y R $.  $d x y S $.
    $( A ring homomorphism is also a ring homomorphism for the opposite rings.
       (Contributed by Thierry Arnoux, 27-Oct-2017.) $)
    rhmopp $p |- ( F e. ( R RingHom S )
       -> F e. ( ( oppR ` R ) RingHom ( oppR ` S ) ) ) $=
      ( vx vy wcel coppr cfv cbs cmulr cur eqid crg opprrngb sylib oppr1 eqcomi
      co cv wa crh rhmrcl1 rhmrcl2 rhm1 wceq simpl simprr opprbas simprl rhmmul
      syl6eleqr syl3anc opprmul fveq2i 3eqtr4g cgrp cplusg wral cghm rnggrp syl
      wf rhmf rhmghm ad2antrr simplr simpr ghmlin ralrimiva jca31 oppradd isghm
      jca sylibr isrhm2d ) CABUARFZDEAGHZIHZVQBGHZVQJHZVSJHZVQKHZCVSKHZVRLWBLWC
      LVTLZWALZVPAMFVQMFZABCUBAVQVQLZNOZVPBMFVSMFZABCUCBVSVSLZNOZABWBCWCAKHZWBA
      WLVQWGWLLPQBKHZWCBWMVSWJWMLPQUDVPDSZVRFZESZVRFZTZTZWPWNAJHZRZCHZWPCHZWNCH
      ZBJHZRZWNWPVTRZCHXDXCWARWSVPWPAIHZFZWNXHFZXBXFUEVPWRUFWSWPVRXHVPWOWQUGXHA
      VQWGXHLZUHZUKWSWNVRXHVPWOWQUIXLUKWPWNABWTXECXHXKWTLZXELZUJULXGXACXHAVTWTV
      QWNWPXKXMWGWDUMUNBIHZBWAXEVSXDXCXOLZXNWJWEUMUOVPVQUPFZVSUPFZTXHXOCVBZWNWP
      AUQHZRCHXDXCBUQHZRUEZEXHURZDXHURZTZTCVQVSUSRFVPXQXRYEVPWFXQWHVQUTVAVPWIXR
      WKVSUTVAVPXSYDXHXOABCXKXPVCVPYCDXHVPXJTZYBEXHYFXITCABUSRFZXJXIYBVPYGXJXIA
      BCVDVEVPXJXIVFYFXIVGXTYAABWNCWPXHXKXTLZYALZVHULVIVIVMVJEDXTYAVQVSCXHXOXLX
      OBVSWJXPUHXTAVQWGYHVKYABVSWJYIVKVLVNVO $.
  $}

  ${
    $( Ring homomorphisms preserve unit elements.  (Contributed by Thierry
       Arnoux, 23-Oct-2017.) $)
    elrhmunit $p |- ( ( F e. ( R RingHom S ) /\ A e. ( Unit ` R ) )
      -> ( F ` A ) e. ( Unit ` S ) ) $=
      ( crh co wcel cui cfv wa cur cdsr wbr coppr eqid isunit rhmdvdsr syl31anc
      wb adantr cbs simpl unitss simpr sseldi rhmrcl1 rngidcl 3syl sylib simpld
      crg rhm1 breq2d mpbid rhmopp simprd opprbas sylanbrc ) DBCEFGZABHIZGZJZAD
      IZCKIZCLIZMZVCVDCNIZLIZMZVCCHIZGVBVCBKIZDIZVEMZVFVBUSABUAIZGZVKVNGZAVKBLI
      ZMZVMUSVAUBZVBUTVNAVNBUTVNOZUTOZUCUSVAUDZUEZVBUSBUKGVPVSBCDUFVNBVKVTVKOZU
      GUHZVBVRAVKBNIZLIZMZVBVAVRWHJWBVQBWFUTVKWGAWAWDVQOZWFOZWGOZPUIZUJAVKVQVEB
      CDVNVTWIVEOZQRUSVMVFSVAUSVLVDVCVEBCVKDVDWDVDOZULZUMTUNVBVCVLVHMZVIVBDWFVG
      EFGZVOVPWHWPUSWQVABCDUOTWCWEVBVRWHWLUPAVKWGVHWFVGDVNVNBWFWJVTUQWKVHOZQRUS
      WPVISVAUSVLVDVCVHWOUMTUNVECVGVJVDVHVCVJOWNWMVGOWRPUR $.
  $}

$(
  @{
    rhmdvr.u @e |- U = ( Unit ` R ) @.
    rhmdvr.x @e |- X = ( Base ` R ) @.
    rhmdvr.m @e |- ./ = ( /r ` R ) @.
    rhmdvr.d @e |- .|| = ( ||r ` R ) @.
    rhmdvr.n @e |- D = ( /r ` S ) @.
    @( A ring homomorphism preserves ring division.  (Contributed  by Thierry
       Arnoux, 22-Oct-2017.) @)
    rhmdvr @p |- ( ( F e. ( R RingHom S ) /\ A e. X /\ B .|| A ) ->
      ( F ` ( A ./ B ) ) = ( ( F ` A ) D ( F ` B ) ) ) @=
      ? @.
  @}
$)

  ${
    rhmdvd.u $e |- U = ( Unit ` S ) $.
    rhmdvd.x $e |- X = ( Base ` R ) $.
    rhmdvd.d $e |- ./ = ( /r ` S ) $.
    rhmdvd.m $e |- .x. = ( .r ` R ) $.
    $( A ring homomorphism preserves ratios.  (Contributed by Thierry Arnoux,
       22-Oct-2017.) $)
    rhmdvd $p |- ( ( F e. ( R RingHom S ) /\ ( A e. X /\ B e. X /\ C e. X )
      /\ ( ( F ` B ) e. U /\ ( F ` C ) e. U ) ) -> ( ( F ` A ) ./ ( F ` B ) )
         = ( ( F ` ( A .x. C ) ) ./ ( F ` ( B .x. C ) ) ) ) $=
      ( co wcel w3a cfv wceq eqid crh cmulr simp21 simp23 rhmmul syl3anc simp22
      wa simp1 oveq12d crg cbs rhmrcl2 3ad2ant1 wf rhmf ffvelrnd simp3l dvrcan5
      simp3r syl13anc eqtr2d ) IEFUAOPZAJPZBJPZCJPZQZBIRZHPZCIRZHPZUHZQZACGOIRZ
      BCGOIRZDOAIRZVJFUBRZOZVHVJVQOZDOZVPVHDOZVMVNVRVOVSDVMVCVDVFVNVRSVCVGVLUIZ
      VCVDVEVFVLUCZVCVDVEVFVLUDZACEFGVQIJLNVQTZUEUFVMVCVEVFVOVSSWBVCVDVEVFVLUGW
      DBCEFGVQIJLNWEUEUFUJVMFUKPZVPFULRZPVIVKVTWASVCVGWFVLEFIUMUNVMJWGAIVCVGJWG
      IUOVLJWGEFILWGTZUPUNWCUQVCVGVIVKURVCVGVIVKUTWGDFVQHVPVHVJWHKMWEUSVAVB $.
  $}

  ${
    $d x y A $.  $d y F $.  $d x y R $.  $d y S $.
    $( Ring homomorphisms preserve the inverse of unit elements.  (Contributed
       by Thierry Arnoux, 23-Oct-2017.) $)
    rhmunitinv $p |- ( ( F e. ( R RingHom S ) /\ A e. ( Unit ` R ) )
      -> ( F ` ( ( invr ` R ) ` A ) ) = ( ( invr ` S ) ` ( F ` A ) ) ) $=
      ( co wcel cui cfv cinvr cmulr wceq cur crg eqid unitlinv unitinvcl sseldi
      sylan adantr elrhmunit crh rhmrcl1 fveq2d cbs simpl unitss rhmmul syl3anc
      wa simpr rhm1 3eqtr3d rhmrcl2 syl2anc eqtr4d cmgp cress wb unitgrp syldan
      cgrp syl unitgrpbas cplusg fvex mgpplusg ressplusg ax-mp grprcan syl13anc
      cvv mpbid ) DBCUAEFZABGHZFZUIZABIHZHZDHZADHZCJHZEZVTCIHZHZVTWAEZKZVSWDKZV
      PWBCLHZWEVPVRABJHZEZDHZBLHZDHZWBWHVPWJWLDVMBMFZVOWJWLKBCDUBZBWIVNWLVQAVNN
      ZVQNZWINZWLNZORUCVPVMVRBUDHZFAWTFWKWBKVMVOUEVPVNWTVRWTBVNWTNZWPUFZVMWNVOV
      RVNFZWOBVNVQAWPWQPRZQVPVNWTAXBVMVOUJQVRABCWIWADWTXAWRWANZUGUHVMWMWHKVOBCW
      LDWHWSWHNZUKSULVPCMFZVTCGHZFZWEWHKVMXGVOBCDUMZSZABCDTZCWAXHWHWCVTXHNZWCNZ
      XEXFOUNUOVPCUPHZXHUQEZVAFZVSXHFZWDXHFZXIWFWGURVMXQVOVMXGXQXJCXHXPXMXPNZUS
      VBSVMVOXCXRXDVRBCDTUTVPXGXIXSXKXLCXHWCVTXMXNPUNXLXHWAXPVSWDVTCXHXPXMXTVCX
      HVKFWAXPVDHKCGVEXHWAXOXPVKXTCWAXOXONXEVFVGVHVIVJVL $.
  $}

$(
  @{
    rhmuntghm.1 @e |- G = ( ( mulGrp ` R ) |`s ( Unit ` R ) ) @.
    rhmuntghm.2 @e |- H = ( ( mulGrp ` S ) |`s ( Unit ` S ) ) @.
    @( A ring homomorphism induces a group homomorphism on the group units
       @)
    rhmuntghm @p |- ( F e. ( R RingHom S ) -> ( F |` G ) e. ( G GrpHom H ) ) @=
      ? @.
  @}
$)

  ${
    $d x .0. $.  $d x .1. $.  $d x F $.  $d x R $.  $d x S $.  $d x U $.
    kerunit.1 $e |- U = ( Unit ` R ) $.
    kerunit.2 $e |- .0. = ( 0g ` S ) $.
    kerunit.3 $e |- .1. = ( 1r ` S ) $.
    $( If a unit element lies in the kernel of a ring homomorphism, then
       ` 0 = 1 ` , i.e. the target ring is the zero ring.  (Contributed by
       Thierry Arnoux, 24-Oct-2017.) $)
    kerunit $p |- ( ( F e. ( R RingHom S ) /\
      ( U i^i ( `' F " { .0. } ) ) =/= (/) ) -> .1. = .0. ) $=
      ( vx co wcel wa wceq cfv cmulr crg eqid syldan adantr crh ccnv csn cin c0
      cima wne wrex cinvr cur elin biimpi adantl simpld rhmrcl1 unitlinv fveq2d
      cv sylan cbs simpl rnginvcl syl2anc unitcl syl rhmmul syl3anc simprd rhmf
      wf wfn wb elpreima 3syl simplbda fvex elsnc sylib oveq2d rhmrcl2 ffvelrnd
      ffn rngrz 3eqtrd rhm1 3eqtr3rd reximdva0 id rexlimivw ) EABUAKLZCEUBFUCZU
      FZUDZUEUGMDFNZJWMUHWNWJWNJWMWJJURZWMLZMZWOAUIOZOZWOAPOZKZEOZAUJOZEOZFDWJW
      PWOCLZXBXDNZWQXEWOWLLZWPXEXGMZWJWPXHWOCWLUKULUMZUNZWJAQLZXEXFABEUOZXKXEMX
      AXCEAWTCXCWRWOGWRRZWTRZXCRZUPUQUSSWQXBWSEOZWOEOZBPOZKZXPFXRKZFWQWJWSAUTOZ
      LZWOYALZXBXSNWJWPVAWQXKXEYBWJXKWPXLTXJYAACWRWOGXMYARZVBVCZWQXEYCXJYAACWOY
      DGVDVEWSWOABWTXREYAYDXNXRRZVFVGWQXQFXPXRWQXQWKLZXQFNWJWPXGYGWQXEXGXIVHWJX
      GYCYGWJYABUTOZEVJZEYAVKXGYCYGMVLYAYHABEYDYHRZVIZYAYHEWBYAWOWKEVMVNVOSXQFW
      OEVPVQVRVSWQBQLZXPYHLXTFNWJYLWPABEVTTWQYAYHWSEWJYIWPYKTYEWAYHBXRXPFYJYFHW
      CVCWDWJXDDNWPABXCEDXOIWETWFWGWNWNJWMWNWHWIVE $.
  $}

$(
  @{
    ker2idl.i @e |- I = ( 2Ideal ` R ) @.
    ker2idl.0 @e |- .0. = ( 0g ` S ) @.
    @( The kernel of a ring homomorphism is a two-sided ideal.
       See also ~ keridl . @)
    ker2idl @p |- ( F e. ( R RingHom S ) -> ( `' F " { .0. } ) e. I ) @=
      ? @.
  @}
$)

  ${
    $d x y .0. $.  $d x y A $.  $d x B $.  $d x y F $.  $d x y N $.
    $d x y R $.  $d x y S $.
    kerf1hrm.a $e |- A = ( Base ` R ) $.
    kerf1hrm.b $e |- B = ( Base ` S ) $.
    kerf1hrm.n $e |- N = ( 0g ` R ) $.
    kerf1hrm.0 $e |- .0. = ( 0g ` S ) $.
    $( TODO use ~ ghmf1 to shorten one direction $)
    $( A ring homomorphism ` F ` is injective if and only if its kernel is the
       singleton ` { N } ` .  (Contributed by Thierry Arnoux, 27-Oct-2017.) $)
    kerf1hrm $p |- ( F e. ( R RingHom S ) -> ( F : A -1-1-> B <->
      ( `' F " { .0. } ) = { N } ) ) $=
      ( vx vy co wcel wceq wa cfv wb adantr crh wf1 ccnv csn cima cv simpl f1fn
      wfn adantl elpreima syl biimpa simpld simprd fvex elsnc sylib cghm rhmghm
      ghmid ad2antrr eqeq2d wi wral cgrp rhmrcl1 rnggrp grpidcl 3syl wf simprbi
      crg dff13 r19.21bi fveq2 eqeq2 imbi12d rspcva syl2anc sylbird syl21anc ex
      imp elsn syl6ibr ssrdv wss rhmf ffn mpbir2and snssd eqssd w3a csg simpr2l
      sylibr simpr2r simpr3 eqid ghmeqker simpr1 eleqtrd ovex grpsubeq0 syl3anc
      syl31anc mpbid 3anassrs ralrimivva sylanbrc impbida ) ECDUANOZABEUBZEUCGU
      DZUEZFUDZPZXMXNQZXPXQXSLXPXQXSLUFZXPOZXTFPZXTXQOXSYAYBXSYAQZXSXTAOZXTERZG
      PZYBXSYAUGYCYDYEXOOZXSYAYDYGQZXSEAUIZYAYHSXNYIXMABEUHUJAXTXOEUKULUMZUNYCY
      GYFYCYDYGYJUOYEGXTEUPUQURXSYDQZYFYBYKYFYEFERZPZYBYKYLGYEXMYLGPZXNYDXMECDU
      SNOZYNCDEUTZCDEFGJKVAULZVBVCYKFAOZYEMUFZERZPZXTYSPZVDZMAVEZYMYBVDZYKCVMOZ
      CVFOZYRXMUUFXNYDCDEVGZVBCVHZACFHJVIZVJXSUUDLAXNUUDLAVEZXMXNABEVKZUUKLMABE
      VNZVLUJVOUUCUUEMFAYSFPZUUAYMUUBYBUUNYTYLYEYSFEVPVCYSFXTVQVRVSVTWAWDWBWCLF
      WEWFWGXMXQXPWHXNXMFXPXMFXPOZYRYLXOOZXMUUFUUGYRUUHUUIUUJVJXMYNUUPYQYLGFEUP
      UQWQXMUULYIUUOYRUUPQSABCDEHIWIZABEWJAFXOEUKVJWKWLTWMXMXRQZUULUUKXNXMUULXR
      UUQTUURUUCLMAAUURYDYSAOZQZQUUAUUBXMXRUUTUUAUUBXMXRUUTUUAWNZQZXTYSCWORZNZF
      PZUUBUVBUVDXQOUVEUVBUVDXPXQUVBYOYDUUSUUAUVDXPOZXMYOUVAYPTYDUUSXRUUAXMWPZY
      DUUSXRUUAXMWRZXMXRUUTUUAWSYOYDUUSWNUUAUVFACDXTEXPUVCYSGHKXPWTUVCWTZXAUMXG
      XMXRUUTUUAXBXCUVDFXTYSUVCXDUQURUVBUUGYDUUSUVEUUBSUVBUUFUUGXMUUFUVAUUHTUUI
      ULUVGUVHACUVCXTYSFHJUVIXEXFXHXIWCXJUUMXKXL $.

$(
    @( If ` R ` is a field and ` S ` is a non-zero ring then a ring
       homomorphism between ` R ` and ` S ` is injective. @)
    hrmf1 @p |- ( ( F e. ( R RingHom S ) /\ R e. Field /\ S e. NzRing ) ->
      F : A -1-1-> B ) @=
      ? @.
$)
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    The commutative ring of integers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    zzs.1 $e |- Z = ( CCfld |`s ZZ ) $.
    $( The base of the ring of integers.  (Contributed by Thierry Arnoux,
       31-Oct-2017.) $)
    zzsbase $p |- ZZ = ( Base ` Z ) $=
      ( cz cc wss cbs cfv wceq zsscn ccnfld cnfldbas ressbas2 ax-mp ) CDECAFGHI
      CDAJBKLM $.

    $( The addition operation of the ring of integers.  (Contributed by Thierry
       Arnoux, 8-Nov-2017.) $)
    zzsplusg $p |- + = ( +g ` Z ) $=
      ( cz cvv wcel caddc cplusg cfv wceq zex ccnfld cnfldadd ressplusg ax-mp )
      CDEFAGHIJCFKADBLMN $.

    $d x y $.
    $( The multiplication (group power) opereation of the group of integers.
       (Contributed by Thierry Arnoux, 31-Oct-2017.) $)
    zzsmulg $p |- ( ( A e. ZZ /\ B e. ZZ )
      -> ( A ( .g ` Z ) B ) = ( A x. B ) ) $=
      ( vx vy cz wcel wa ccnfld cmg cfv co cmul csubg wceq c1 cv zcn eqid 1z cc
      zaddcl znegcl cnsubglem subgmulg mp3an1 simpr cnfldmulg syldan eqtr3d
      zcnd ) AGHZBGHZIZABJKLZMZABCKLZMZABNMZGJOLHUMUNUQUSPEFGQERZSVAFRUCVAUDUAU
      EGURUPJCABUPTDURTUFUGUMUNBUBHUQUTPUOBUMUNUHULABUIUJUK $.

    $( The multiplication operation of the ring of integers.  (Contributed by
       Thierry Arnoux, 1-Nov-2017.) $)
    zzsmulr $p |- x. = ( .r ` Z ) $=
      ( cz cvv wcel cmul cmulr cfv wceq zex ccnfld cnfldmul ressmulr ax-mp ) CD
      EFAGHIJCKAFDBLMN $.

    $( The neutral element of the ring of integers.  (Contributed by Thierry
       Arnoux, 1-Nov-2017.) $)
    zzs0 $p |- 0 = ( 0g ` Z ) $=
      ( ccnfld cmnd wcel cc0 cz wss c0g cfv wceq ccrg crg cncrng crngrng rngmnd
      cc mp2b 0z zsscn cnfldbas cnfld0 ress0g mp3an ) CDEZFGEGQHFAIJKCLECMEUENC
      OCPRSTGQCAFBUAUBUCUD $.

    $( The multiplicative neutral element of the ring of integers (Contributed
       by Thierry Arnoux, 1-Nov-2017.) $)
    zzs1 $p |- 1 = ( 1r ` Z ) $=
      ( cz ccnfld csubrg cfv wcel c1 cur wceq zsubrg cnfld1 subrg1 ax-mp ) CDEF
      GHAIFJKCDAHBLMN $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Scalar restriction operation
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c |`v $.

  $( Extend class notation with the scalar restriction operation. $)
  cresv $a class |`v $.

  ${
    $d w x $.
    $( Define an operator to restrict the scalar field component of an extended
       structure.  (Contributed by Thierry Arnoux, 5-Sep-2018.) $)
    df-resv $a |- |`v = ( w e. _V , x e. _V |->
      if ( ( Base ` ( Scalar ` w ) ) C_ x , w , ( w sSet <. ( Scalar ` ndx ) ,
      ( ( Scalar ` w ) |`s x ) >. ) ) ) $.
  $}

  ${
    $d x y $.  $d w A $.  $d w W $.
    $( The scalar restriction is a proper operator, so it can be used with
       ~ ovprc1 .  (Contributed by Thierry Arnoux, 6-Sep-2018.) $)
    reldmresv $p |- Rel dom |`v $=
      ( vy vx cvv cv csca cfv cbs wss cnx cress co cop csts cif cresv reldmmpt2
      df-resv ) ABCCADZEFZGFBDZHRRIEFSTJKLMKNOBAQP $.
  $}

  ${
    $d w x A $.  $d w x B $.  $d w x F $.  $d w x W $.
    resvsca.r $e |- R = ( W |`v A ) $.
    resvsca.f $e |- F = ( Scalar ` W ) $.
    resvsca.b $e |- B = ( Base ` F ) $.
    $( Value of structure restriction.  (Contributed by Thierry Arnoux,
       6-Sep-2018.) $)
    resvval $p |- ( ( W e. X /\ A e. Y ) -> R = if ( B C_ A , W ,
            ( W sSet <. ( Scalar ` ndx ) , ( F |`s A ) >. ) ) ) $=
      ( vw vx wcel co csca cfv cress csts cvv wceq wa wss cnx cop cif elex ovex
      cresv ifcl mpan2 adantr cv cbs simpl fveq2d syl6eqr simpr sseq12d oveq12d
      opeq2d ifbieq12d df-resv ovmpt2ga mpd3an3 syl2an syl5eq ) EFMZAGMZUACEAUH
      NZBAUBZEEUCOPZDAQNZUDZRNZUEZHVGESMZASMZVIVOTZVHEFUFAGUFVPVQVOSMZVRVPVSVQV
      PVNSMVSEVMRUGVJEVNSUIUJUKKLEASSKULZOPZUMPZLULZUBZVTVTVKWAWCQNZUDZRNZUEVOU
      HSVTETZWCATZUAZWDVJVTWGEVNWJWBBWCAWJWBDUMPBWJWADUMWJWAEOPDWJVTEOWHWIUNZUO
      IUPZUOJUPWHWIUQZURWKWJVTEWFVMRWKWJWEVLVKWJWADWCAQWLWMUSUTUSVALKVBVCVDVEVF
      $.

    $( General behavior of trivial restriction.  (Contributed by Thierry
       Arnoux, 6-Sep-2018.) $)
    resvid2 $p |- ( ( B C_ A /\ W e. X /\ A e. Y ) -> R = W ) $=
      ( wss wcel wceq wa cnx csca cfv cress co cop cif resvval iftrue sylan9eqr
      csts 3impb ) BAKZEFLZAGLZCEMUHUINUGCUGEEOPQDARSTUESZUAEABCDEFGHIJUBUGEUJU
      CUDUF $.

    $( Value of nontrivial structure restriction.  (Contributed by Thierry
       Arnoux, 6-Sep-2018.) $)
    resvval2 $p |- ( ( -. B C_ A /\ W e. X /\ A e. Y ) -> R = ( W sSet
        <. ( Scalar ` ndx ) , ( F |`s A ) >. ) ) $=
      ( wss wn wcel cnx csca cfv cress co cop csts wa resvval iffalse sylan9eqr
      wceq cif 3impb ) BAKZLZEFMZAGMZCENOPDAQRSTRZUEUJUKUAUICUHEULUFULABCDEFGHI
      JUBUHEULUCUDUG $.

    $( Base set of a structure restriction.  (Contributed by Thierry Arnoux,
       6-Sep-2018.) $)
    resvsca $p |- ( A e. V -> ( F |`s A ) = ( Scalar ` R ) ) $=
      ( cvv wcel cress co csca cfv wceq w3a fveq2d 3eqtr4a c0 wss wa wi eqeltri
      fvex eqid ressid2 mp3an2 3adant2 resvid2 3expib cnx csts simp2 ovex scaid
      wn cop setsid sylancl resvval2 eqtr4d pm2.61i strfvn ress0 3eqtr4ri fvprc
      0fv 0ex syl5eq oveq1d cresv reldmresv ovprc1 adantr pm2.61ian ) FJKZAEKZD
      ALMZCNOZPZBAUAZVQVRUBWAUCWBVQVRWAWBVQVRQZDFNOZVSVTHWBVRVSDPZVQWBDJKVRWEDW
      DJHFNUEUDABVSDJEVSUFIUGUHUIWCCFNABCDFJEGHIUJRSUKWBUQZVQVRWAWFVQVRQZVSFULN
      OZVSURUMMZNOZVTWGVQVSJKVSWJPWFVQVRUNDALUOJVSNJFUPUSUTWGCWINABCDFJEGHIVARV
      BUKVCVQUQZWAVRWKTALMZTNOZVSVTWHTOTWMWLWHVHTNWHVIUPVDAVEVFWKDTALWKDWDTHFNV
      GVJVKWKCTNWKCFAVLMTGFAVLVMVNVJRSVOVP $.
  $}

  ${
    resvlem.r $e |- R = ( W |`v A ) $.
    resvlem.e $e |- C = ( E ` W ) $.
    resvlem.f $e |- E = Slot N $.
    resvlem.n $e |- N e. NN $.
    resvlem.b $e |- N =/= 5 $.
    $( Other elements of a structure restriction.  (Contributed by Thierry
       Arnoux, 6-Sep-2018.) $)
    resvlem $p |- ( A e. V -> C = ( E ` R ) ) $=
      ( wcel cfv cvv csca w3a fveq2d co c0 wceq cbs wss wa wi resvid2 3expib wn
      eqid cnx cress cop csts resvval2 ndxid c5 ndxarg eqnetri neeqtrri setsnid
      scandx syl6eqr pm2.61i cresv reldmresv ovprc1 syl5eq str0 fvprc pm2.61ian
      eqtr4d adantr syl6reqr ) AFMZCDNZGDNZBGOMZVNVOVPUAZGPNZUBNZAUCZVQVNUDVRUE
      WAVQVNVRWAVQVNQCGDAVTCVSGOFHVSUIZVTUIZUFRUGWAUHZVQVNVRWDVQVNQZVOGUJPNZVSA
      UKSZULUMSZDNVPWECWHDAVTCVSGOFHWBWCUNRWGWFDGDEJKUOUJDNZUPWFWIEUPDEJKUQLURV
      AUSUTVBUGVCVQUHZVRVNWJVOTVPWJVOTDNTWJCTDWJCGAVDSTHGAVDVEVFVGRDEJVHVBGDVIV
      KVLVJIVM $.
  $}

  ${
    resvbas.1 $e |- H = ( G |`v A ) $.
    ${
      resvbas.2 $e |- B = ( Base ` G ) $.
      $( ` Base ` is unaffected by scalar restriction.  (Contributed by Thierry
         Arnoux, 6-Sep-2018.) $)
      resvbas $p |- ( A e. V -> B = ( Base ` H ) ) $=
        ( cbs c1 df-base 1nn c5 1re 1lt5 ltneii resvlem ) ABDHIECFGJKILMNOP $.
    $}

    ${
      resvplusg.2 $e |- .+ = ( +g ` G ) $.
      $( ` +g ` is unaffected by scalar restriction.  (Contributed by Thierry
         Arnoux, 6-Sep-2018.) $)
      resvplusg $p |- ( A e. V -> .+ = ( +g ` H ) ) $=
        ( cplusg c2 df-plusg 2nn c5 2re 2lt5 ltneii resvlem ) ABDHIECFGJKILMNOP
        $.
    $}

    ${
      resvvsca.2 $e |- .x. = ( .s ` G ) $.
      $( ` .s ` is unaffected by scalar restriction.  (Contributed by Thierry
         Arnoux, 6-Sep-2018.) $)
      resvvsca $p |- ( A e. V -> .x. = ( .s ` H ) ) $=
        ( cvsca c6 df-vsca 6nn c5 5re 5lt6 ltneii necomi resvlem ) ABDHIECFGJKL
        ILIMNOPQ $.
    $}

    ${
      resvmulr.2 $e |- .x. = ( .r ` G ) $.
      $( ` .s ` is unaffected by scalar restriction.  (Contributed by Thierry
         Arnoux, 6-Sep-2018.) $)
      resvmulr $p |- ( A e. V -> .x. = ( .r ` H ) ) $=
        ( cmulr c3 df-mulr 3nn c5 3re 3lt5 ltneii resvlem ) ABDHIECFGJKILMNOP
        $.
    $}

    ${
      $d x y A $.  $d x y G $.  $d x y H $.  $d x y V $.
      resv0g.2 $e |- .0. = ( 0g ` G ) $.
      $( ` 0g ` is unaffected by scalar restriction.  (Contributed by Thierry
         Arnoux, 6-Sep-2018.) $)
      resv0g $p |- ( A e. V -> .0. = ( 0g ` H ) ) $=
        ( vx vy wcel c0g cfv cbs wceq eqid a1i resvbas cv wa cplusg grpidpropd
        resvplusg adantr oveqd syl5eq ) ADJZEBKLCKLGUFHIBMLZBCUGUGNUFUGOZPAUGBC
        DFUHQUFHRZUGJIRZUGJSZSBTLZCTLZUIUJUFULUMNUKAULBCDFULOUBUCUDUAUE $.
    $}

    ${
      $d e x A $.  $d e x G $.  $d e x H $.  $d e x V $.
      resv1r.2 $e |- .1. = ( 1r ` G ) $.
      $( ` 1r ` is unaffected by scalar restriction.  (Contributed by Thierry
         Arnoux, 6-Sep-2018.) $)
      resv1r $p |- ( A e. V -> .1. = ( 1r ` H ) ) $=
        ( ve vx wcel cv cbs cfv cmulr co wceq wa wral cio eqid resvbas resvmulr
        cur eleq2d oveqd eqeq1d anbi12d raleqbidv iotabidv dfur2 3eqtr4g ) AEJZ
        HKZCLMZJZUMIKZCNMZOZUPPZUPUMUQOZUPPZQZIUNRZQZHSUMDLMZJZUMUPDNMZOZUPPZUP
        UMVGOZUPPZQZIVERZQZHSBDUCMZULVDVNHULUOVFVCVMULUNVEUMAUNCDEFUNTZUAZUDULV
        BVLIUNVEVQULUSVIVAVKULURVHUPULUQVGUMUPAUQCDEFUQTZUBZUEUFULUTVJUPULUQVGU
        PUMVSUEUFUGUHUGUIIUNCUQBHVPVRGUJIVEDVGVOHVETVGTVOTUJUK $.
    $}

    ${
      $d x y A $.  $d x y G $.  $d x y H $.  $d x y V $.
      $( Scalar restriction preserves commutative monoids.  (Contributed by
         Thierry Arnoux, 6-Sep-2018.) $)
      resvcmn $p |- ( A e. V -> ( G e. CMnd <-> H e. CMnd ) ) $=
        ( vx vy wcel cbs cfv eqidd eqid resvbas cv cplusg wceq resvplusg adantr
        wa oveqd cmnpropd ) ADHZFGBIJZBCUBUCKAUCBCDEUCLMUBFNZUCHGNZUCHSZSBOJZCO
        JZUDUEUBUGUHPUFAUGBCDEUGLQRTUA $.
    $}
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    The commutative ring of gaussian integers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The gaussian integers form a commutative ring.  (Contributed by Thierry
     Arnoux, 18-Mar-2018.) $)
  gzcrng $p |- ( CCfld |`s Z[i] ) e. CRing $=
    ( ccnfld ccrg wcel cgz csubrg cfv cress cncrng gzsubrg eqid subrgcrng mp2an
    co ) ABCDAEFCADGMZBCHIDANNJKL $.


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    The ordered field of reals
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    re.1 $e |- R = ( CCfld |`s RR ) $.
    $( The base of the field of reals.  (Contributed by Thierry Arnoux,
       1-Nov-2017.) $)
    rebase $p |- RR = ( Base ` R ) $=
      ( cr cc wss cbs cfv wceq ax-resscn ccnfld cnfldbas ressbas2 ax-mp ) CDECA
      FGHICDAJBKLM $.

    $d x y $.
    $( The multiplication (group power) operation of the group of reals.
       (Contributed by Thierry Arnoux, 1-Nov-2017.) $)
    remulg $p |- ( ( N e. ZZ /\ A e. RR )
      -> ( N ( .g ` R ) A ) = ( N x. A ) ) $=
      ( vx vy cz wcel cr wa ccnfld cmg cfv co cmul csubg wceq c1 cv eqid mp3an1
      recn readdcl renegcl 1re cnsubglem subgmulg simpr cnfldmulg syldan eqtr3d
      cc recnd ) CGHZAIHZJZCAKLMZNZCABLMZNZCAONZIKPMHUNUOURUTQEFIRESZUBVBFSUCVB
      UDUEUFIUSUQKBCAUQTDUSTUGUAUNUOAULHURVAQUPAUNUOUHUMCAUIUJUK $.

    $( The addition operation of the field of reals.  (Contributed by Thierry
       Arnoux, 21-Jan-2018.) $)
    replusg $p |- + = ( +g ` R ) $=
      ( cr cvv wcel caddc cplusg cfv wceq reex ccnfld cnfldadd ressplusg ax-mp
      ) CDEFAGHIJCFKADBLMN $.

    $( The multiplication operation of the field of reals.  (Contributed by
       Thierry Arnoux, 1-Nov-2017.) $)
    remulr $p |- x. = ( .r ` R ) $=
      ( cr cvv wcel cmul cmulr cfv wceq reex ccnfld cnfldmul ressmulr ax-mp ) C
      DEFAGHIJCKAFDBLMN $.

    $( The neutral element of the field of reals.  (Contributed by Thierry
       Arnoux, 1-Nov-2017.) $)
    re0g $p |- 0 = ( 0g ` R ) $=
      ( ccnfld cmnd wcel cc0 cr wss c0g cfv wceq ccrg crg cncrng crngrng rngmnd
      cc mp2b 0re ax-resscn cnfldbas cnfld0 ress0g mp3an ) CDEZFGEGQHFAIJKCLECM
      EUENCOCPRSTGQCAFBUAUBUCUD $.

    $( The multiplicative neutral element of the field of reals.  (Contributed
       by Thierry Arnoux, 1-Nov-2017.) $)
    re1r $p |- 1 = ( 1r ` R ) $=
      ( cr ccnfld csubrg cfv wcel c1 cur wceq cress co cdr simpli cnfld1 subrg1
      resubdrg ax-mp ) CDEFGZHAIFJSDCKLMGQNCDAHBOPR $.

    $( The ordering relation of the field of reals.  (Contributed by Thierry
       Arnoux, 21-Jan-2018.) $)
    rele2 $p |- <_ = ( le ` R ) $=
      ( cr cvv wcel cle cple cfv wceq reex ccnfld cnfldle ressle ax-mp ) CDEFAG
      HIJCKFDABLMN $.

    $( The ordering relation of the field of reals.  (Contributed by Thierry
       Arnoux, 21-Jan-2018.) $)
    relt $p |- < = ( lt ` R ) $=
      ( clt cle cid cdif cplt cfv dflt2 cvv wcel wceq ccnfld cress ovex eqeltri
      cr co rele2 eqid pltfval ax-mp eqtr4i ) CDEFZAGHZIAJKUEUDLAMQNRJBMQNOPJUE
      ADABSUETUAUBUC $.

    $( The division operation of the field of reals.  (Contributed by Thierry
       Arnoux, 1-Nov-2017.) $)
    redvr $p |- ( ( A e. RR /\ B e. RR /\ B =/= 0 )
      -> ( A ( /r ` R ) B ) = ( A / B ) ) $=
      ( wcel cc0 wne w3a cdiv cdvr cfv ccnfld csubrg cui wceq cdr resubdrg eqid
      cr co cress simpli simp1 wa 3simpc wb simpri eqeltri rebase re0g drngunit
      a1i ax-mp sylibr cnflddiv subrgdv syl3anc eqcomd ) ASEZBSEZBFGZHZABITZABC
      JKZTZVBSLMKEZUSBCNKZEZVCVEOVFVBVFLSUATZPEZQUBULUSUTVAUCVBUTVAUDZVHUSUTVAU
      ECPEVHVKUFCVIPDVFVJQUGUHSCVGBFCDUIVGRZCDUJUKUMUNSILCVGVDABDUOVLVDRUPUQUR
      $.

    $( The real numbers are a totally ordered set.  (Contributed by Thierry
       Arnoux, 21-Jan-2018.) $)
    retos $p |- R e. Toset $=
      ( vx ctos wcel cr clt wor cid cres cle wss ltso wbr idref leid cvv ccnfld
      cv cress mprgbir wa wb co ovex eqeltri rebase rele2 tosso ax-mp mpbir2an
      relt ) ADEZFGHZIFJKLZMUOCSZUPKNCFCFKOUPPUAAQEUMUNUOUBUCARFTUDQBRFTUEUFFGA
      KQABUGABUHABULUIUJUK $.

    $( The real numbers form a field.  (Contributed by Thierry Arnoux,
       1-Nov-2017.) $)
    refld $p |- R e. Field $=
      ( cfield wcel cdr ccrg ccnfld cr cress csubrg cfv resubdrg simpri eqeltri
      co cncrng simpli subrgcrng mp2an isfld mpbir2an ) ACDAEDAFDZAGHIOZEBHGJKD
      ZUCEDZLMNGFDUDUBPUDUELQHGABRSATUA $.

    $d a b c R $.
    $( The real numbers form an ordered field.  (Contributed by Thierry Arnoux,
       21-Jan-2018.) $)
    reofld $p |- R e. oField $=
      ( va vb vc wcel wa cc0 cv cle wbr cmul co wi wral w3a ax-mp caddc mpbir
      cr cofld cfield corng refld crg cogrp cdr ccrg isfld simplbi drngrng mp2b
      cgrp comnd rnggrp cmnd grpmnd retos simpl simpr1 simpr2 leadd1dd 3anassrs
      ctos simpr3 3impa rgen3 3pm3.2i rebase replusg rele2 isomnd pm3.2i isogrp
      ex mulge0 an4s rgen2 re0g remulr isorng isofld ) AUAFAUBFZAUCFZGWCWDABUDZ
      WDAUEFZAUFFZHCIZJKZHDIZJKZGZHWHWJLMJKZNZDTOCTOZPWFWGWOWCAUGFZWFWEWCWPAUHF
      AUIUJAUKULZWGAUMFZAUNFZGWRWSWFWRWQAUOQZWSAUPFZAVDFZWHWJJKZWHEIZRMWJXDRMJK
      ZNZETODTOCTOZPXAXBXGWRXAWTAUQQABURXFCDETTTWHTFZWJTFZXDTFZXFXHXIGZXJGXCXEX
      HXIXJXCXEXHXIXJXCPZGWHWJXDXHXLUSXHXIXJXCUTXHXIXJXCVAXHXIXJXCVEVBVCVOVFVGV
      HTRJACDEABVIZABVJABVKZVLSVMAVNSWNCDTTXKWLWMXHWIXIWKWMWHWJVPVQVOVRVHTALJHC
      DXMABVSABVTXNWASVMAWBS $.
  $}

  $( The nonnegative integers form an ordered monoid.  (Contributed by Thierry
     Arnoux, 23-Mar-2018.) $)
  nn0omnd $p |- ( CCfld |`s NN0 ) e. oMnd $=
    ( ccnfld cr cress co cn0 comnd cvv wcel wss wceq reex nn0ssre ressabs mp2an
    cmnd cofld eqid reofld simprbi ax-mp corng cfield isofld orngogrp cgrp 3syl
    cogrp isogrp csubmnd cfv nn0subm submmnd eqeltri submomnd eqeltrri ) ABCDZE
    CDZAECDZFBGHEBIUQURJKLBEAGMNZUPFHZUQOHUQFHUPPHZUTUPUPQRVAUPUAHZUPUGHZUTVAUP
    UBHVBUPUCSUPUDVCUPUEHUTUPUHSUFTUQUROUSEAUIUJHUROHUKEURAURQULTUMEUPUNNUO $.

  ${
    $d n x $.
    $( The field of the real numbers is Archimedean.  See also ~ arch .
       (Contributed by Thierry Arnoux, 9-Apr-2018.) $)
    rearchi $p |- ( CCfld |`s RR ) e. Archi $=
      ( vx vn ccnfld cr cress co carchi wcel cv czrh cfv clt cn wrex cz wb wceq
      wbr c1 eqid wral arch nnz cmg cmul crg cfield refld isfld simplbi drngrng
      cdr ccrg mp2b re1r zrhmulg 1re remulg mpan2 zcn mulid1d 3eqtrd breq2d syl
      mpan rexbiia sylibr rgen cofld reofld rebase relt isarchiofld ax-mp mpbir
      ) CDEFZGHZAIZBIZVPJKZKZLRZBMNZADUAZWCADVRDHVRVSLRZBMNWCVRBUBWBWEBMVSMHVSO
      HZWBWEPVSUCWFWAVSVRLWFWAVSSVPUDKZFZVSSUEFZVSVPUFHZWFWAWHQVPUGHZVPULHZWJVP
      VPTZUHWKWLVPUMHVPUIUJVPUKUNVPWGSVTVSCOEFZWNTVTTZWGTVPWMUOUPVEWFSDHWHWIQUQ
      SVPVSWMURUSWFVSVSUTVAVBVCVDVFVGVHVPVIHVQWDPVPWMVJADLBVTVPVPWMVKWOVPWMVLVM
      VNVO $.
  $}

  ${
    $d q r w x W $.
    xrge0slmod.1 $e |- G = ( RR*s |`s ( 0 [,] +oo ) ) $.
    xrge0slmod.2 $e |- W = ( G |`v ( 0 [,) +oo ) ) $.
    $( The extended nonnegative real numbers form a semiring left module.  One
       could also have used ` subringAlg ` to get the same structure.
       (Contributed by Thierry Arnoux, 6-Sep-2018.) $)
    xrge0slmod $p |- W e. SLMod $=
      ( wcel ccnfld cc0 cpnf co cress cxmu cxad wceq c1 cvv ax-mp sseldi cr cxr
      cfv vr vw vx vq cslmd ccmn cico csrg cv cicc caddc w3a cmul wral xrge0cmn
      wa cxrs eqeltri wb ovex resvcmn rge0srg icossicc simplr ge0xmulcl syl2anc
      simprr simprl xrge0adddi rge0ssre simpll rexadd oveq1d xrge0adddir eqtr3d
      mpbi syl3anc 3jca rexmul rexrd iccssxr xmulass xmulid2 syl jca ralrimivva
      xmul02 rgen2a xrge0base fveq2i eqtr4i resvbas cplusg xrge0plusg resvplusg
      cbs ax-xrsvsca ressvsca resvvsca c0g xrge00 resv0g cin csca reex ressress
      cvsca mp2an ax-xrssca resssca eqid rebase resvsca incom wss eqtr3i oveq2i
      df-ss 3eqtr3ri ax-resscn sstri cnfldbas ressbas2 cnfldadd ressplusg cmulr
      cc cnfldmul ressmulr crg cur cdr cndrng wbr clt 1re ltpnf 0re pnfxr mp3an
      drngrng cle 0le1 3pm3.2i elico2 cnfld1 ress1r cmnd rngmnd mp2b 0xr lbico1
      mpbir cnfld0 ress0g isslmd mpbir3an ) BUEEBUFEZFGHUGIZJIZUHEUAUIZUBUIZKIZ
      GHUJIZEZUVAUVBUCUIZLIKIUVCUVAUVFKILIMZUDUIZUVAUKIZUVBKIZUVHUVBKIUVCLIZMZU
      LZUVHUVAUMIZUVBKIZUVHUVCKIZMZNUVBKIUVBMZGUVBKIGMZULZUPZUBUVDUNUCUVDUNZUAU
      USUNUDUUSUNAUFEZUURAUQUVDJIZUFCUOURUUSOEZUWCUURUSGHUGUTZUUSABODVAPVPVBUWB
      UDUAUUSUVHUUSEZUVAUUSEZUPZUWAUCUBUVDUVDUWIUVFUVDEZUVBUVDEZUPZUPZUVMUVTUWM
      UVEUVGUVLUWMUVAUVDEZUWKUVEUWMUUSUVDUVAGHVCZUWGUWHUWLVDZQZUWIUWJUWKVGZUVAU
      VBVEVFUWMUWKUWJUWNUVGUWRUWIUWJUWKVHUWQUVBUVFUVAVIVQUWMUVHUVALIZUVBKIZUVJU
      VKUWMUWSUVIUVBKUWMUVHREZUVAREZUWSUVIMUWMUUSRUVHVJUWGUWHUWLVKZQZUWMUUSRUVA
      VJUWPQZUVHUVAVLVFVMUWMUVHUVDEUWNUWKUWTUVKMUWMUUSUVDUVHUWOUXCQUWQUWRUVHUVA
      UVBVNVQVOVRUWMUVQUVRUVSUWMUVHUVAKIZUVBKIZUVOUVPUWMUXFUVNUVBKUWMUXAUXBUXFU
      VNMUXDUXEUVHUVAVSVFVMUWMUVHSEUVASEUVBSEZUXGUVPMUWMUVHUXDVTUWMUVAUXEVTUWMU
      VDSUVBGHWAUWRQZUVHUVAUVBWBVQVOUWMUXHUVRUXIUVBWCWDUWMUXHUVSUXIUVBWGWDVRWEW
      FWHUCUBLUKKUMNUUTUUSGUVDBGUAUDUWEUVDBWPTMUWFUUSUVDABODUVDUWDWPTAWPTWIAUWD
      WPCWJWKWLPUWELBWMTMUWFUUSLABODLUWDWMTAWMTWNAUWDWMCWJWKWOPUWEKBXGTMUWFUUSK
      ABODUVDOEZKAXGTMGHUJUTZUVDKUQAOCWQWRPWSPUWEGBWTTMUWFUUSABOGDGUWDWTTAWTTXA
      AUWDWTCWJWKXBPFRJIZUUSJIZFRUUSXCZJIZBXDTZUUTROEUWEUXMUXOMXEUWFRUUSFOOXFXH
      UWEUXMUXPMUWFUUSRBUXLOADUXJUXLAXDTMUXKUVDUXLUQAOCXIXJPUXLUXLXKXLXMPUXNUUS
      FJUUSRXCZUXNUUSUUSRXNUUSRXOUXQUUSMVJUUSRXRVPXPXQXSUUSYGXOZUUSUUTWPTMUUSRY
      GVJXTYAZUUSYGUUTFUUTXKZYBYCPUWEUKUUTWMTMUWFUUSUKFUUTOUXTYDYEPUWEUMUUTYFTM
      UWFUUSFUUTUMOUXTYHYIPFYJEZNUUSEZUXRNUUTYKTMFYLEZUYAYMFUUAZPUYBNREZGNUUBYN
      ZNHYOYNZULZUYEUYFUYGYPUUCUYEUYGYPNYQPUUDGREZHSEZUYBUYHUSYRYSGHNUUEXHUUMUX
      SUUSYGFUUTNUXTYBUUFUUGYTFUUHEZGUUSEZUXRGUUTWTTMUYCUYAUYKYMUYDFUUIUUJGSEUY
      JGHYOYNZUYLUUKYSUYIUYMYRGYQPGHUULYTUXSUUSYGFUUTGUXTYBUUNUUOYTUUPUUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Regular spaces
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
$(
    regclnei.1 @e |- X = U. J @.
    regclnei.2 @e |- B = ( ( Clsd ` J ) i^i ( ( nei ` J ) ` { A } ) ) @.
    @( For a regular space ` J ` , the set of closed neighborhoods of any point
       ` X ` is a filter base which generates the filter of neighborhoods of
       ` X ` . Condition O_III of [BourbakiTop1] p.  I.56. @)
    regclnei @p |- ( ( J e. Reg /\ A e. X ) ->
      ( B e. ( fBas ` X ) /\ ( X filGen B ) = ( ( nei ` J ) ` { A } ) ) ) @=
      ? @.

    @( Given any point ` A ` and neighborhood ` N ` of ` A ` , there is a
       closed neighborhood ` E ` of ` A `` that is a subset of  ` N ` .
       Same as ~ regsep ??? @)
    regclnei $p |- ( ( J e. Reg /\ A e. X /\ N e. ( ( nei ` J ) ` { A } ) )
      -> E. E e. ( ( Clsd ` J ) i^i ( ( nei ` J ) ` { A } ) ) E C_ N ) @=
      ? @.
$)
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Pseudometrics
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Declare new constant symbols and define their syntactical properties. $)
  $c ~Met $.
  $c pstoMet $.

  $( Extend class notation with the class of metric identifications. $)
  cmetid $a class ~Met $.

  $( Extend class notation with the metric induced by a pseudometric. $)
  cpstm $a class pstoMet $.

  ${
    $d d x y $.
    $( Define the metric identification relation for a pseudometric.
       (Contributed by Thierry Arnoux, 7-Feb-2018.) $)
    df-metid $a |- ~Met = ( d e. U. ran PsMet |-> { <. x , y >. |
      ( ( x e. dom dom d /\ y e. dom dom d ) /\ ( x d y ) = 0 ) } ) $.
  $}

  ${
    $d a b d x y z $.
    $( Define the metric induced by a pseudometric.  (Contributed by Thierry
       Arnoux, 7-Feb-2018.) $)
    df-pstm $a |- pstoMet = ( d e. U. ran PsMet |->
      ( a e. ( dom dom d /. ( ~Met ` d ) ) , b e. ( dom dom d /. ( ~Met ` d ) )
      |-> U. { z | E. x e. a E. y e. b z = ( x d y ) } ) ) $.
  $}

  ${
    $d d w x y z $.  $d d x y D $.  $d d x y X $.
    $( Value of the metric identification relation.  (Contributed by Thierry
       Arnoux, 7-Feb-2018.) $)
    metidval $p |- ( D e. ( PsMet ` X ) -> ( ~Met ` D ) =
      { <. x , y >. | ( ( x e. X /\ y e. X ) /\ ( x D y ) = 0 ) } ) $=
      ( vd vz vw cpsmet cfv wcel cv cdm wa co cc0 wceq copab cvv eleq2d wral wb
      crn cuni cmetid cmpt df-metid simpr dmeqd psmetdmdm adantr eqtr4d anbi12d
      a1i oveqd eqeq1d opabbidv wrex elfvdm fveq2 mpancom wfun cxad cle wbr cxr
      rspcev cxp cmap df-psmet funmpt2 elunirn ax-mp sylibr wss opabssxp elfvex
      crab xpexg syl2anc ssexg sylancr fvmptd ) CDHIZJZECAKZEKZLZLZJZBKZWHJZMZW
      EWJWFNZOPZMZABQZWEDJZWJDJZMZWEWJCNZOPZMZABQZHUBUCZUDRUDEXDWPUEPWDABEUFUMW
      DWFCPZMZWOXBABXFWLWSWNXAXFWIWQWKWRXFWHDWEXFWHCLZLZDXFWGXGXFWFCWDXEUGZUHUH
      WDDXHPXECDUIUJUKZSXFWHDWJXJSULXFWMWTOXFWFCWEWJXIUNUOULUPWDCWEHIZJZAHLZUQZ
      CXDJZDXMJWDXNCDHURXLWDADXMWEDPXKWCCWEDHUSSVFUTHVAXOXNUAARWJWJWFNOPWJFKZWF
      NGKZWJWFNXQXPWFNVBNVCVDGWETFWETMBWETEVEWEWEVGVHNVQHABFGEVIVJACHVKVLVMWDXC
      DDVGZVNXRRJZXCRJXAABDDVOWDDRJZXTXSCDHVPZYADDRRVRVSXCXRRVTWAWB $.

    $( As a relation, the metric identification is a subset of a cross
       product.  (Contributed by Thierry Arnoux, 7-Feb-2018.) $)
    metidss $p |- ( D e. ( PsMet ` X ) -> ( ~Met ` D ) C_ ( X X. X ) ) $=
      ( vx vy cpsmet cfv wcel cmetid cv wa cc0 wceq copab cxp metidval opabssxp
      co syl6eqss ) ABEFGAHFCIZBGDIZBGJSTAQKLZJCDMBBNCDABOUACDBBPR $.
  $}

  ${
    $d a b A $.  $d a b B $.  $d a b D $.  $d a b X $.
    $( ` A ` and ` B ` identify by the metric ` D ` if their distance is zero.
       (Contributed by Thierry Arnoux, 7-Feb-2018.) $)
    metidv $p |- ( ( D e. ( PsMet ` X ) /\ ( A e. X /\ B e. X ) )
      -> ( A ( ~Met ` D ) B <-> ( A D B ) = 0 ) ) $=
      ( va vb cpsmet cfv wcel wa cmetid wbr co cc0 wceq cv copab eleq1 adantl
      wb metidval adantr breqd bi2anan9 oveq12 eqeq1d anbi12d eqid brabga bitrd
      ibar bitr4d ) CDGHIZADIZBDIZJZJZABCKHZLZUPABCMZNOZJZVAUQUSABEPZDIZFPZDIZJ
      ZVCVECMZNOZJZEFQZLZVBUQURVKABUMURVKOUPEFCDUAUBUCUPVLVBTUMVJVBEFABVKDDVCAO
      ZVEBOZJZVGUPVIVAVMVDUNVNVFUOVCADRVEBDRUDVOVHUTNVCAVEBCUEUFUGVKUHUISUJUPVA
      VBTUMUPVAUKSUL $.
  $}

  ${
    $( Basic property of the metric identification relation.  (Contributed by
       Thierry Arnoux, 7-Feb-2018.) $)
    metideq $p |- ( ( D e. ( PsMet ` X ) /\
      ( A ( ~Met ` D ) B /\ E ( ~Met ` D ) F ) ) -> ( A D E ) = ( B D F ) ) $=
      ( wcel wbr wa co wceq cle cxr wss syl syl2anc sseldd psmetsym cxad cc0 wb
      cpsmet cfv cmetid simpl cdm metidss dmss dmxpid syl6sseq wrel xpss syl6ss
      cxp cvv df-rel sylibr simprl releldm syl3anc fovrnda syl12anc eqeltrd crn
      simprr psmetf rnss rnxpid eqeltrrd psmettri2 syl13anc jca metidv syl21anc
      relelrn biimpa eqtr3d oveq1d xaddid2 eqtrd breqtrd oveq2d xaddid1 xrletrd
      3eqtrd 3eqtr4d xrletri3 mpbird ) CFUBUCGZABCUDUCZHZDEWJHZIZIZADCJZBECJZKZ
      WOWPLHZWPWOLHZIZWNWRWSWNWOBDCJZWPWNWODACJZMWNWIAFGZDFGZWOXBKWIWMUEZWNWJUF
      ZFAWNWIXFFNXEWIXFFFUNZUFZFWIWJXGNZXFXHNCFUGZWJXGUHOFUIUJOZWNWJUKZWKAXFGWN
      WIXLXEWIWJUOUOUNZNXLWIWJXGXMXJFFULUMWJUPUQOZWIWKWLURZABWJUSPQZWNXFFDXKWNX
      LWLDXFGXNWIWKWLVEZDEWJUSPQZADCFRUTZWNWIXDXCXBMGZXEXRXPWIDAMFFCCFVFZVAVBZV
      CZWNWIBFGZXDXAMGZXEWNWJVDZFBWNWIYFFNXEWIYFXGVDZFWIXIYFYGNXJWJXGVGOFVHUJOZ
      WNXLWKBYFGXNXOABWJVOPQZXRWIBDMFFCYAVAVBZWNEBCJZWPMWNWIEFGZYDYKWPKXEWNYFFE
      YHWNXLWLEYFGXNXQDEWJVOPQZYIEBCFRUTZWNWIYLYDYKMGZXEYMYIWIEBMFFCYAVAVBZVIZW
      NWOBACJZXASJZXALWNWIYDXCXDWOYSLHXEYIXPXRADBCFVJVKWNYSTXASJZXAWNYRTXASWNAB
      CJZYRTWNWIXCYDUUAYRKXEXPYIABCFRUTWNWIXCYDIZWKUUATKZXEWNXCYDXPYIVLXOWIUUBI
      WKUUCABCFVMVPVNZVQVRWNYEYTXAKYJXAVSOVTWAWNXAYKEDCJZSJZWPLWNWIYLYDXDXAUUFL
      HXEYMYIXRBDECFVJVKWNUUFYKTSJZYKWPWNUUETYKSWNUUEDECJZTWNWIYLXDUUEUUHKXEYMX
      REDCFRUTWNWIXDYLIZWLUUHTKZXEWNXDYLXRYMVLXQWIUUIIWLUUJDECFVMVPVNZVTWBWNYOU
      UGYKKYPYKWCOYNWEWAWDWNWPAECJZWOYQWNWIXCYLUULMGZXEXPYMWIAEMFFCYAVAVBZYCWNW
      PUUAUULSJZUULLWNWIXCYDYLWPUUOLHXEXPYIYMBEACFVJVKWNUUOTUULSJZUULWNUUATUULS
      UUDVRWNUUMUUPUULKUUNUULVSOVTWAWNUULXBUUHSJZWOLWNWIXDXCYLUULUUQLHXEXRXPYMA
      EDCFVJVKWNXBTSJZXBUUQWOWNXTUURXBKYBXBWCOWNUUHTXBSUUKWBXSWFWAWDVLWNWOMGWPM
      GWQWTUAYCYQWOWPWGPWH $.

    $d x y z D $.  $d x y z X $.
    $( The metric identification is an equivalence relation.  (Contributed by
       Thierry Arnoux, 11-Feb-2018.) $)
    metider $p |- ( D e. ( PsMet ` X ) -> ( ~Met ` D ) Er X ) $=
      ( vx wcel cv wbr wa ssbrd imp brxp sylib co cc0 wceq metidv wb cle syldan
      cxad simpld cpsmet cfv cmetid cvv cxp wss wrel metidss xpss syl6ss df-rel
      vy sylibr psmetsym 3expb eqeq1d ancom2s 3bitr4d biimpd impancom mpd simpl
      vz simprr simprl simprd psmettri2 syl13anc eqtr3d oveq12d cxr 0xr xaddid1
      mpbid ax-mp breqtrd psmetge0 syl3anc psmetcl xrletri3 mpan2 syl mpbir2and
      syl6eq syl12anc mpbird psmet0 anabsan2 impbida iserd ) ABUAUBDZCULVCBAUCU
      BZWKWLUDUDUEZUFWLUGWKWLBBUEZWMABUHZBBUIUJWLUKUMWKCEZULEZWLFZGZWPBDZWQBDZG
      ZWQWPWLFZWSWPWQWNFZXBWKWRXDWKWLWNWPWQWOHIWPWQBBJKZWKXBWRXCWKXBGZWRXCXFWPW
      QALZMNZWQWPALZMNZWRXCXFXGXIMWKWTXAXGXINZWPWQABUNUOZUPWPWQABOZWKXAWTXCXJPW
      QWPABOUQURUSUTVAWKWRWQVCEZWLFZGZGZWPXNWLFZWPXNALZMNZXQXTXSMQFZMXSQFZXQXSX
      IWQXNALZSLZMQXQWKXAWTXNBDZXSYDQFWKXPVBZXQXAYEWKXPXOXAYEGZWKWRXOVDZWKXOGWQ
      XNWNFZYGWKXOYIWKWLWNWQXNWOHIWQXNBBJKRZTXQWTXAWKXPWRXBWKWRXOVEZXERZTZXQXAY
      EYJVFZWPXNWQABVGVHXQYDMMSLZMXQXIMYCMSXQXGXIMWKXPXBXKYLXLRXQWRXHYKWKXPXBWR
      XHPYLXMRVNVIXQXOYCMNZYHWKXPYGXOYPPYJWQXNABORVNVJMVKDZYOMNVLMVMVOWDVPXQWKW
      TYEYBYFYMYNWPXNABVQVRXQXSVKDZXTYAYBGPZXQWKWTYEYRYFYMYNWPXNABVSVRYRYQYSVLX
      SMVTWAWBWCXQWKWTYEXRXTPYFYMYNWPXNABOWEWFWKWTWPWPWLFZWKWTGYTWPWPALMNZWPABW
      GWKWTYTUUAPWPWPABOWHWFWKYTGZWTWTUUBWPWPWNFZWTWTGWKYTUUCWKWLWNWPWPWOHIWPWP
      BBJKTWIWJ $.
  $}

  ${
    $d a b c d x y z D $.  $d a b c d x y z X $.  $d a b c d x y z .~ $.
    pstmval.1 $e |- .~ = ( ~Met ` D ) $.
    $( Value of the metric induced by a pseudometric ` D ` .  (Contributed by
       Thierry Arnoux, 7-Feb-2018.) $)
    pstmval $p |- ( D e. ( PsMet ` X ) -> ( pstoMet ` D ) =
      ( a e. ( X /. .~ ) , b e. ( X /. .~ )
      |-> U. { z | E. x e. a E. y e. b z = ( x D y ) } ) ) $=
      ( vd vc cpsmet cfv wcel cv cdm co wceq wrex cvv cmetid cqs cab cuni cmpt2
      crn cpstm cmpt df-pstm wa psmetdmdm adantr dmeq dmeqd adantl eqtr4d qseq1
      a1i syl fveq2 syl6reqr eqtr2d mpt2eq12 syl2anc w3a simp1r eqeq2d 2rexbidv
      qseq2 oveqd abbidv unieqd mpt2eq3dva elfvdm eleq2d rspcev mpancom wfun wb
      eqtrd cc0 cxad cle wbr wral cxr cmap crab df-psmet funmpt2 elunirn sylibr
      cxp ax-mp elfvex qsexg eqid mpt2exg fvmptd ) DFLMZNZJDGHJOZPZPZXBUAMZUBZX
      FCOZAOZBOZXBQZRZBHOZSAGOZSZCUCZUDZUEZGHFEUBZXRXGXHXIDQZRZBXLSAXMSZCUCZUDZ
      UEZLUFUDZUGTUGJYEXQUHRXAABCGHJUIURXAXBDRZUJZXQGHXRXRXPUEZYDYGXFXRRZYIXQYH
      RYGXRXDEUBZXFYGFXDRXRYJRYGFDPZPZXDXAFYLRYFDFUKULYFXDYLRXAYFXCYKXBDUMUNUOU
      PFXDEUQUSYFYJXFRZXAYFEXERYMYFXEDUAMEXBDUAUTIVAEXEXDVIUSUOVBZYNGHXFXFXRXRX
      PVCVDYGGHXRXRXPYCYGXMXRNZXLXRNZVEZXOYBYQXNYACYQXKXTABXMXLYQXJXSXGYQXBDXHX
      IXAYFYOYPVFVJVGVHVKVLVMVTXADXHLMZNZALPZSZDYENZFYTNXAUUADFLVNYSXAAFYTXHFRY
      RWTDXHFLUTVOVPVQLVRUUBUUAVSATXMXMXBQWARXMXLXBQKOZXMXBQUUCXLXBQWBQWCWDKXHW
      EHXHWEUJGXHWEJWFXHXHWMWGQWHLAGHKJWIWJADLWKWNWLXAXRTNZUUDYDTNXAFTNUUDDFLWO
      FETWPUSZUUEGHXRXRYCTTYDYDWQWRVDWS $.

    $d a b e f z .~ $.  $d a b e f x y z A $.  $d a b e f x y z B $.
    $d e f z D $.  $d e f z X $.
    $( Function value of the metric induced by a pseudometric ` D `
       (Contributed by Thierry Arnoux, 11-Feb-2018.) $)
    pstmfval $p |- ( ( D e. ( PsMet ` X ) /\ A e. X /\ B e. X ) ->
      ( [ A ] .~ ( pstoMet ` D ) [ B ] .~ ) = ( A D B ) ) $=
      ( vx vy vz va vb ve wcel co cv wceq wrex cvv wbr wb vf cpsmet cfv w3a cec
      cpstm cqs cab cuni cmpt2 pstmval 3ad2ant1 cmetid eqeltri ecelqsi 3ad2ant2
      oveqd fvex 3ad2ant3 rexeq abbidv unieqd rexbidv eqid ecexg ax-mp ab2rexex
      uniex ovmpt2 syl2anc csn wa simpr3 simpl1 simpr1 cxp wss metidss syl5eqss
      wrel syl6ss df-rel sylibr adantr relelec mpbid breqi sylib simpr2 metideq
      xpss syl12anc eqtr4d adantlr 3anassrs oveq1 eqeq2d cbvrex2v biimpi adantl
      syl oveq2 r19.29_2a cc0 simpl2 psmet0 3syl a1i breqd metidv 3bitrd mpbird
      ex simpl3 simpr rspc2ev syl3anc impbid df-sn syl6eqr unisn syl6eq 3eqtrd
      ovex ) CEUBUCMZAEMZBEMZUDZADUEZBDUEZCUFUCZNYIYJGHEDUGZYLIOZJOZKOZCNZPZKHO
      ZQZJGOZQZIUHZUIZUJZNZYQKYJQZJYIQZIUHZUIZABCNZYHYKUUDYIYJYEYFYKUUDPYGJKICD
      EGHFUKULUQYHYIYLMZYJYLMZUUEUUIPYFYEUUKYGEADDCUMUCZRFCUMURUNZUOUPYGYEUULYF
      EBDUUNUOUSGHYIYJYLYLUUCUUIUUDYSJYIQZIUHZUIYTYIPZUUBUUPUUQUUAUUOIYSJYTYIUT
      VAVBYRYJPZUUPUUHUURUUOUUGIUURYSUUFJYIYQKYRYJUTVCVAVBUUDVDUUHJKIYIYJYPDRMZ
      YIRMUUNARDVEVFUUSYJRMUUNBRDVEVFVGVHVIVJYHUUIUUJVKZUIUUJYHUUHUUTYHUUHYMUUJ
      PZIUHUUTYHUUGUVAIYHUUGUVAYHUUGUVAYHUUGVLZYMLOZUAOZCNZPZUVALUAYIYJUVBUVCYI
      MZUVDYJMZUVFUVAYHUVGUVHUVFUDZUVAUUGYHUVIVLZYMUVEUUJYHUVGUVHUVFVMUVJYEAUVC
      UUMSZBUVDUUMSZUUJUVEPYEYFYGUVIVNUVJAUVCDSZUVKUVJUVGUVMYHUVGUVHUVFVOUVJDVT
      ZUVGUVMTYHUVNUVIYEYFUVNYGYEDRRVPZVQUVNYEDEEVPZUVOYEDUUMUVPFCEVRVSEEWKWADW
      BWCZULWDZUVCADWEXAWFAUVCDUUMFWGWHUVJBUVDDSZUVLUVJUVHUVSYHUVGUVHUVFWIUVJUV
      NUVHUVSTUVRUVDBDWEXAWFBUVDDUUMFWGWHAUVCCBUVDEWJWLWMWNWOUUGUVFUAYJQLYIQZYH
      UUGUVTYQUVFYMUVCYOCNZPJKLUAYIYJYNUVCPYPUWAYMYNUVCYOCWPWQYOUVDPUWAUVEYMYOU
      VDUVCCXBWQWRWSWTXCXMYHUVAUUGYHUVAVLZAYIMZBYJMZUVAUUGUWBUWCAACNXDPZUWBYEYF
      UWEYEYFYGUVAVNZYEYFYGUVAXEZACEXFVJUWBUWCAADSZAAUUMSZUWEUWBYEUVNUWCUWHTUWF
      UVQAADWEXGUWBDUUMAADUUMPUWBFXHZXIUWBYEYFYFUWIUWETUWFUWGUWGAACEXJWLXKXLUWB
      UWDBBCNXDPZUWBYEYGUWKUWFYEYFYGUVAXNZBCEXFVJUWBUWDBBDSZBBUUMSZUWKUWBYEUVNU
      WDUWMTUWFUVQBBDWEXGUWBDUUMBBUWJXIUWBYEYGYGUWNUWKTUWFUWLUWLBBCEXJWLXKXLYHU
      VAXOYQUVAYMAYOCNZPJKABYIYJYNAPYPUWOYMYNAYOCWPWQYOBPUWOUUJYMYOBACXBWQXPXQX
      MXRVAIUUJXSXTVBUUJABCYDYAYBYC $.

    $( The metric induced by a pseudometric is a full-fledged metric on the
       equivalence classes of the metric identification.  (Contributed by
       Thierry Arnoux, 11-Feb-2018.) $)
    pstmxmet $p |- ( D e. ( PsMet ` X ) ->
      ( pstoMet ` D ) e. ( *Met ` ( X /. .~ ) ) ) $=
      ( vx vy vz va vb wcel cxr cv co cc0 wceq wb wral wa cvv r19.29a vc cpsmet
      cfv cpstm cqs cxmt cxp wf cxad cle wbr wfn wrex cuni cmpt2 ab2rexex uniex
      cab vex rgen2w eqid fnmpt2 ax-mp pstmval fneq1d cec simpllr simpr oveq12d
      mpbiri simp-5l simp-4r simplr pstmfval syl3anc eqtrd psmetf eqeltrd elqsi
      fovrnd ad2antll ad2antrr ad2antrl ralrimivva ffnov sylanbrc simpll eqeq1d
      syl cmetid breqi metidv anassrs syl5bb bitr4d wer ereq1 sylibr erth bitrd
      metider adantllr adantlr adantr eqeq12d 3bitr4d simp-6l simp-6r psmettri2
      syl13anc simp-5r syl21anc breq12d adantl6r ad5antlr adantl5r ad4antlr jca
      mpbird adantl4r ad3antlr ralrimiva anasss elfvex qsexg isxmet 3syl ) ACUB
      UCJZAUDUCZCBUEZUFUCJZYJYJUGZKYIUHZELZFLZYIMZNOZYNYOOZPZYPGLZYNYIMZYTYOYIM
      ZUIMZUJUKZGYJQZRZFYJQEYJQZRZYHYMUUGYHYIYLULZYPKJZFYJQEYJQYMYHUUIEFYJYJYTH
      LZILZAMZOIYOUMHYNUMGURZUNZUOZYLULZUUOSJZFYJQEYJQUUQUUREFYJYJUUNHIGYNYOUUM
      EUSFUSUPUQUTEFYJYJUUOUUPSUUPVAVBVCYHYLYIUUPHIGABCEFDVDVEVJYHUUJEFYJYJYHYN
      YJJZYOYJJZRZRZYNUUKBVFZOZUUJHCUVBUUKCJZRZUVDRZYOUULBVFZOZUUJICUVGUULCJZRZ
      UVIRZYPUUMKUVLYPUVCUVHYIMZUUMUVLYNUVCYOUVHYIUVFUVDUVJUVIVGZUVKUVIVHZVIZUV
      LYHUVEUVJUVMUUMOZYHUVAUVEUVDUVJUVIVKZUVBUVEUVDUVJUVIVLZUVGUVJUVIVMZUUKUUL
      ABCDVNZVOVPUVLUUKUULKCCAUVLYHCCUGKAUHUVRACVQWIUVSUVTVTVRUVBUVIICUMZUVEUVD
      UUTUWBYHUUSICYOBVSZWAWBZTUUSUVDHCUMZYHUUTHCYNBVSZWCZTWDEFYJYJKYIWEWFYHUUF
      EFYJYJUVBYSUUEUVBUVDYSHCUVGUVIYSICUVLUVMNOZUVCUVHOZYQYRUVKUWHUWIPZUVIUVFU
      VJUWJUVDYHUVEUVJUWJUVAYHUVERZUVJRZUWHUUKUULBUKZUWIUWLUWHUUMNOZUWMUWLUVMUU
      MNUWLYHUVEUVJUVQYHUVEUVJWGZYHUVEUVJVMZUWKUVJVHUWAVOZWHUWMUUKUULAWJUCZUKZU
      WLUWNUUKUULBUWRDWKYHUVEUVJUWSUWNPUUKUULACWLWMWNWOUWLUUKUULBCUWLCUWRWPZCBW
      PZUWLYHUWTUWOACXAWIBUWROUXAUWTPDCBUWRWQVCWRUWPWSWTXBXCXDUVLYPUVMNUVPWHUVL
      YNUVCYOUVHUVNUVOXEXFUWDTUWGTYHUUSUUTUUEYHUUSRUUTRZUUDGYJUXBYTYJJZRUVDUUDH
      CYHUUSUUTUXCUVEUVDUUDYHUUTRUXCRUVERUVDRUVIUUDICYHUUTUXCUVEUVDUVJUVIUUDYHU
      XCRUVERUVDRUVJRUVIRYTUALZBVFZOZUUDUACYHUXCUVEUVDUVJUVIUXDCJZUXFUUDUWKUVDR
      ZUVJRZUVIRZUXGRZUXFRZUUDUUMUXDUUKAMZUXDUULAMZUIMZUJUKZUXLYHUXGUVEUVJUXPYH
      UVEUVDUVJUVIUXGUXFXGZUXJUXGUXFVMZYHUVEUVDUVJUVIUXGUXFXHZUXHUVJUVIUXGUXFVL
      ZUUKUULUXDACXIXJUXLYPUUMUUCUXOUJUXLYPUVMUUMUXLYNUVCYOUVHYIUWKUVDUVJUVIUXG
      UXFXKZUXIUVIUXGUXFVGZVIUXLYHUVEUVJUVQUXQUXSUXTUWQXLVPUXLUUAUXMUUBUXNUIUXL
      UUAUXEUVCYIMZUXMUXLYTUXEYNUVCYIUXKUXFVHZUYAVIUXLYHUXGUVEUYCUXMOUXQUXRUXSU
      XDUUKABCDVNVOVPUXLUUBUXEUVHYIMZUXNUXLYTUXEYOUVHYIUYDUYBVIUXLYHUXGUVJUYEUX
      NOUXQUXRUXTUXDUULABCDVNVOVPVIXMXSXNUXCUXFUACUMYHUVEUVDUVJUVIUACYTBVSXOTXP
      UUTUWBYHUXCUVEUVDUWCXQTXTUUSUWEYHUUTUXCUWFYATYBYCXRWDXRYHCSJYJSJYKUUHPACU
      BYDCBSYEEFGSYIYJYFYGXS $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Continuity - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    hauseqcn.x $e |- X = U. J $.
    hauseqcn.k $e |- ( ph -> K e. Haus ) $.
    hauseqcn.f $e |- ( ph -> F e. ( J Cn K ) ) $.
    hauseqcn.g $e |- ( ph -> G e. ( J Cn K ) ) $.
    hauseqcn.e $e |- ( ph -> ( F |` A ) = ( G |` A ) ) $.
    hauseqcn.a $e |- ( ph -> A C_ X ) $.
    hauseqcn.c $e |- ( ph -> ( ( cls ` J ) ` A ) = X ) $.
    $( In a Hausdorff topology, two continuous functions which agree on a dense
       set agree everywhere.  (Contributed by Thierry Arnoux, 28-Dec-2017.) $)
    hauseqcn $p |- ( ph -> F = G ) $=
      ( wceq cin wss cfv wcel 3syl cuni cdm ccl ctop ccn co cntop1 dmin wf eqid
      syl cnf fdm ineq12d syl6eq syl5sseq cres wfn wb syl6sseq fnreseql syl3anc
      inidm ffn mpbid ccld hauseqlcld cldcls 3sstr3d syl5eqssr fneqeql2 syl2anc
      clsss mpbird ) ACDOZEUAZCDPUBZQZAVPGVQHABEUCRZRZVQVSRZGVQAEUDSZVQVPQBVQQZ
      VTWAQACEFUEUFZSZWBJCEFUGUKACUBZDUBZPZVQVPCDUHAWHVPVPPVPAWFVPWGVPAWEVPFUAZ
      CUIZWFVPOJCEFVPWIVPUJZWIUJZULZVPWICUMTADWDSZVPWIDUIZWGVPOKDEFVPWIWKWLULZV
      PWIDUMTUNVPVCUOUPACBUQDBUQOZWCLACVPURZDVPURZBVPQWQWCUSAWEWJWRJWMVPWICVDTZ
      AWNWOWSKWPVPWIDVDTZABGVPMHUTVPCDBVAVBVEVQBEVPWKVMVBNAVQEVFRSWAVQOACDEFIJK
      VGVQEVHUKVIVJAWRWSVOVRUSWTXAVPCDVKVLVN $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Topology of the closed unit
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The closed unit is a subset of the set of the complex numbers Useful lemma
     for manipulating probabilities within the closed unit.  (Contributed by
     Thierry Arnoux, 12-Dec-2016.) $)
  unitsscn $p |- ( 0 [,] 1 ) C_ CC $=
    ( cc0 c1 cicc co cr cc unitssre ax-resscn sstri ) ABCDEFGHI $.

  $( The closed unit is a subset of the set of the real numbers Useful lemma
     for manipulating probabilities within the closed unit.  (Contributed by
     Thierry Arnoux, 21-Dec-2016.) $)
  elunitrn $p |- ( A e. ( 0 [,] 1 ) -> A e. RR ) $=
    ( cc0 c1 cicc co wcel cr cle wbr 0re 1re elicc2i simp1bi ) ABCDEFAGFBAHIACH
    IBCAJKLM $.

  $( The closed unit is a subset of the set of the complext numbers Useful
     lemma for manipulating probabilities within the closed unit.  (Contributed
     by Thierry Arnoux, 21-Dec-2016.) $)
  elunitcn $p |- ( A e. ( 0 [,] 1 ) -> A e. CC ) $=
    ( cc0 c1 cicc co wcel elunitrn recnd ) ABCDEFAAGH $.

  $( An element of the closed unit is positive Useful lemma for manipulating
     probabilities within the closed unit.  (Contributed by Thierry Arnoux,
     20-Dec-2016.) $)
  elunitge0 $p |- ( A e. ( 0 [,] 1 ) -> 0 <_ A ) $=
    ( cc0 c1 cicc co wcel cr cle wbr 0re 1re elicc2i simp2bi ) ABCDEFAGFBAHIACH
    IBCAJKLM $.

  $( The closed unit is a subset of the set of the extended non-negative
     reals.  Useful lemma for manipulating probabilities within the closed
     unit.  (Contributed by Thierry Arnoux, 12-Dec-2016.) $)
  unitssxrge0 $p |- ( 0 [,] 1 ) C_ ( 0 [,] +oo ) $=
    ( cc0 cpnf cicc co wcel c1 wss cxr cle wbr 0xr pnfxr pnfge ax-mp lbicc2 1re
    mp3an rexri 0le1 mp2an w3a wb elicc1 mpbir3an iccss2 ) AABCDZEZFUFEZAFCDUFG
    AHEZBHEZABIJZUGKLUIUKKAMNABOQUHFHEZAFIJZFBIJZFPRZSULUNUOFMNUIUJUHULUMUNUAUB
    KLABFUCTUDABAFUET $.

  $( Necessary conditions for a quotient to be in the closed unit.  (somewhat
     too strong, it would be sufficient that A and B are in RR+) (Contributed
     by Thierry Arnoux, 20-Dec-2016.) $)
  unitdivcld $p |- ( ( A e. ( 0 [,] 1 ) /\ B e. ( 0 [,] 1 ) /\ B =/= 0 ) ->
                                   ( A <_ B <-> ( A / B ) e. ( 0 [,] 1 ) ) ) $=
    ( cc0 c1 cicc co w3a cle wbr cr wa elunitrn 3ad2ant1 simp3 adantr elunitge0
    wcel wb 0re 1re wne cdiv 3ad2ant2 redivcld clt ltlen sylancr biimpar 3com23
    3impb mpd3an3 3adant1 divge0 syl22anc a1i ledivmul syl112anc ax-1rid breq2d
    cmul syl bitr2d biimpa 3jca ex syl5ibr impbid elicc2i syl6bbr ) ACDEFZQZBVJ
    QZBCUAZGZABHIZABUBFZJQZCVPHIZVPDHIZGZVPVJQVNVOVTVNVOVTVNVOKVQVRVSVNVQVOVNAB
    VKVLAJQZVMALMZVLVKBJQZVMBLZUCZVKVLVMNUDOVNVRVOVNWACAHIZWCCBUEIZVRWBVKVLWFVM
    APMWEVLVMWGVKVLVMCBHIZWGVLWHVMBPOVLWHVMWGVLWHVMWGVLWGWHVMKZVLCJQWCWGWIRSWDC
    BUFUGUHUJUIUKULZABUMUNOVNVOVSVNVSABDUTFZHIZVOVNWADJQZWCWGVSWLRWBWMVNTUOWEWJ
    ADBUPUQVNWCWLVORWEWCWKBAHBURUSVAVBZVCVDVEVTVOVNVSVQVRVSNWNVFVGCDVPSTVHVI $.

  ${
    $d x y $.
    df-iis $e |- I = ( ( mulGrp ` CCfld ) |`s ( 0 [,] 1 ) ) $.
    $( The closed unit forms a topological monoid.  (Contributed by Thierry
       Arnoux, 25-Mar-2017.) $)
    iistmd $p |- I e. TopMnd $=
      ( vx vy ccnfld cmgp cfv ctmd wcel cc0 c1 cicc co csubmnd cnnrg mp2b cc cv
      cmul wral cnrg ctrg nrgtrg trgtmd wss unitsscn 1elunit iimulcl rgen2a w3a
      eqid cmnd wb crg nrgrng rngmgp cnfldbas mgpbas rngidval cnfldmul mgpplusg
      cnfld1 issubm ax-mp mpbir3an submtmd mp2an ) EFGZHIZJKLMZVHNGIZAHIEUAIZEU
      BIVIOEUCEVHVHUKZUDPVKVJQUEZKVJIZCRZDRZSMVJIZDVJTCVJTZUFUGVRCDVJVPVQUHUIVH
      ULIZVKVNVOVSUJUMVLEUNIVTOEUOEVHVMUPPCDQSVJVHKQEVHVMUQUREKVHVMVBUSESVHVMUT
      VAVCVDVEVJVHABVFVG $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Topology of ` ( RR X. RR ) `
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    unicls.1 $e |- J e. Top $.
    unicls.2 $e |- X = U. J $.
    $( The union of the closed set is the underlying set of the topology.
       (Contributed by Thierry Arnoux, 21-Sep-2017.) $)
    unicls $p |- U. ( Clsd ` J ) = X $=
      ( ccld cfv cuni wss wcel wceq cpw cldss2 sspwuni mpbi ctop topcld unissel
      ax-mp mp2an ) AEFZGZBHZBTIZUABJTBKHUBABDLTBMNAOIUCCABDPRTBQS $.
  $}

  ${
    tpr2tp.0 $e |- J = ( topGen ` ran (,) ) $.
    $( The usual topology on ` ( RR X. RR ) ` is the product topology of the
       usual topology on ` RR ` .  (Contributed by Thierry Arnoux,
       21-Sep-2017.) $)
    tpr2tp $p |- ( J tX J ) e. ( TopOn ` ( RR X. RR ) ) $=
      ( cr ctopon cfv wcel ctx cxp cioo crn ctg retopon eqeltri txtopon mp2an
      co ) ACDEZFZRAAGPCCHDEFAIJKEQBLMZSAACCNO $.

    $( The usual topology on ` ( RR X. RR ) ` is the product topology of the
       usual topology on ` RR ` .  (Contributed by Thierry Arnoux,
       21-Sep-2017.) $)
    tpr2uni $p |- U. ( J tX J ) = ( RR X. RR ) $=
      ( cr cxp ctx co cuni tpr2tp toponunii eqcomi ) CCDZAAEFZGKLABHIJ $.
  $}

  ${
    $d r A $.  $d r B $.
    $( Rewrite the cartesian product of two sets as the intersection of their
       preimage by ` 1st ` and ` 2nd ` , the projections on the first and
       second elements.  (Contributed by Thierry Arnoux, 22-Sep-2017.) $)
    xpinpreima $p |- ( A X. B ) = ( ( `' ( 1st |` ( _V X. _V ) ) " A )
                                i^i ( `' ( 2nd |` ( _V X. _V ) ) " B ) ) $=
      ( vr c1st cfv wcel cvv cxp crab c2nd cin cres ccnv cima wf wceq fncnvima2
      wfn ffn mp2b cv wa inrab f1stres fvres eleq1d rabbiia f2ndres ineq12i xp2
      eqtri 3eqtr4ri ) CUAZDEZAFZCGGHZIZUMJEZBFZCUPIZKUOUSUBCUPIDUPLZMANZJUPLZM
      BNZKABHUOUSCUPUCVBUQVDUTVBUMVAEZAFZCUPIZUQUPGVAOVAUPRVBVGPGGUDUPGVASCUPAV
      AQTVFUOCUPUMUPFZVEUNAUMUPDUEUFUGUKVDUMVCEZBFZCUPIZUTUPGVCOVCUPRVDVKPGGUHU
      PGVCSCUPBVCQTVJUSCUPVHVIURBUMUPJUEUFUGUKUICABUJUL $.

    $d r E $.  $d r F $.
    $( Rewrite the cartesian product of two sets as the intersection of their
       preimage by ` 1st ` and ` 2nd ` , the projections on the first and
       second elements.  (Contributed by Thierry Arnoux, 22-Sep-2017.) $)
    xpinpreima2 $p |- ( ( A C_ E /\ B C_ F )
                -> ( A X. B ) = ( ( `' ( 1st |` ( E X. F ) ) " A )
                              i^i ( `' ( 2nd |` ( E X. F ) ) " B ) ) ) $=
      ( vr wss wa cxp c1st cfv wcel crab c2nd cin cres ccnv cima sseldd syl6eqr
      cvv cv xpss rabss2 mp1i simprl simpll simprrl simplr simprrr jca sylanbrc
      elxp7 rabss3d eqssd xp2 syl6reqr inrab wf wfn wceq f1stres fncnvima2 mp2b
      ffn fvres eleq1d rabbiia eqtri f2ndres ineq12i ) ACFZBDFZGZABHZEUAZIJZAKZ
      ECDHZLZVOMJZBKZEVRLZNZIVROZPAQZMVROZPBQZNVMVNVQWAGZEVRLZWCVMWIWHETTHZLZVN
      VMWIWKVRWJFWIWKFVMCDUBWHEVRWJUCUDVMWHEWJVRVMVOWJKZWHGZGZWLVPCKZVTDKZGVOVR
      KZVMWLWHUEWNWOWPWNACVPVKVLWMUFVMWLVQWAUGRWNBDVTVKVLWMUHVMWLVQWAUIRUJVOCDU
      LUKUMUNEABUOUPVQWAEVRUQSWEVSWGWBWEVOWDJZAKZEVRLZVSVRCWDURWDVRUSWEWTUTCDVA
      VRCWDVDEVRAWDVBVCWSVQEVRWQWRVPAVOVRIVEVFVGVHWGVOWFJZBKZEVRLZWBVRDWFURWFVR
      USWGXCUTCDVIVRDWFVDEVRBWFVBVCXBWAEVRWQXAVTBVOVRMVEVFVGVHVJS $.
  $}

  ${
    $( The complex square of side ` D ` is a subset of the complex circle of
       radius ` D ` .  (Contributed by Thierry Arnoux, 25-Sep-2017.) $)
    sqsscirc1 $p |- ( ( ( ( X e. RR /\ 0 <_ X ) /\ ( Y e. RR /\ 0 <_ Y ) )
      /\ D e. RR+ ) -> ( ( X < ( D / 2 ) /\ Y < ( D / 2 ) ) ->
      ( sqr ` ( ( X ^ 2 ) + ( Y ^ 2 ) ) ) < D ) ) $=
      ( cr wcel cc0 cle wbr wa c2 cdiv co clt csqr cfv a1i cmul 2re c1 c4 caddc
      crp simp-4l resqcld simpllr simpld readdcld sqge0d addge0d resqrcld rpred
      simplr rehalfcld simprl simp-4r rpge0d divge0d lt2sqd mpbid simprr simprd
      cexp 2rp lt2addd sqrltd rpre recnd 2timesd fveq2d rpge0 sqrsqd oveq2d 0re
      2pos ltleii sqrmuld cc 2cn sqrcld rpcn 2ne0 div32d 3eqtr4d eqtr3d 2lt4 wb
      wne 4re 4pos sqrlt mp4an mpbi sqrpclii ltdiv1ii sqrsq mp2an oveq1i fveq2i
      wceq sq2 dividi 3eqtr3i breqtri 1re ltmul1d mpbii mulid2d breqtrd eqbrtrd
      id syl lttrd ex ) BDEZFBGHZIZCDEZFCGHZIZIZAUBEZIZBAJKLZMHZCYCMHZIZBJVBLZC
      JVBLZUALZNOZAMHYBYFIZYJYCJVBLZYLUALZNOZAYKYIYKYGYHYKBXNXOXSYAYFUCZUDZYKCY
      KXQXRXPXSYAYFUEZUFZUDZUGZYKYGYHYPYSYKBYOUHYKCYRUHUIZUJYKYMYKYLYLYKYCYKAYK
      AXTYAYFULZUKZUMZUDZUUEUGZYKYLYLUUEUUEYKYCUUDUHZUUGUIZUJUUCYKYIYMMHYJYNMHY
      KYGYHYLYLYPYSUUEUUEYKYDYGYLMHYBYDYEUNYKBYCYOUUDXNXOXSYAYFUOYKAJUUCJUBEZYK
      VCPYKAUUBUPUQZURUSYKYEYHYLMHYBYDYEUTYKCYCYRUUDYKXQXRYQVAUUJURUSVDYKYIYMYT
      UUAUUFUUHVEUSYKYAYNAMHUUBYAYNJNOZJKLZAQLZAMYAJYLQLZNOZYNUUMYAUUNYMNYAYLYA
      YLYAYCYAAAVFZUMZUDZVGVHVIYAUUKYLNOZQLUUKYCQLUUOUUMYAUUSYCUUKQYAYCUUQYAAJU
      UPUUIYAVCPAVJUQVKVLYAJYLJDEZYARPZFJGHZYAFJVMRVNVOZPZUURYAYCUUQUHVPYAUUKJA
      YAJJVQEYAVRPZVSUVEAVTZJFWGYAWAPWBWCWDYAUUMSAQLZAMYAUULSMHUUMUVGMHUULTNOZJ
      KLZSMUUKUVHMHZUULUVIMHJTMHZUVJWEUUTUVBTDEFTGHUVKUVJWFRUVCWHFTVMWHWIVOJTWJ
      WKWLUUKUVHJJRVNWMTWHWIWMRVNWNWLJJVBLZNOZJKLJJKLUVISUVMJJKUUTUVBUVMJWSRUVC
      JWOWPWQUVMUVHJKUVLTNWTWRWQJVRWAXAXBXCYAUULSAYAUUKYAJUVAUVDUJUMSDEYAXDPYAX
      JXEXFYAAUVFXGXHXIXKXLXM $.
  $}

  ${
    $( The complex square of side ` D ` is a subset of the complex disc of
       radius ` D ` .  (Contributed by Thierry Arnoux, 25-Sep-2017.) $)
    sqsscirc2 $p |- ( ( ( A e. CC /\ B e. CC ) /\ D e. RR+ ) ->
      ( ( ( abs ` ( Re ` ( B - A ) ) ) < ( D / 2 ) /\
          ( abs ` ( Im ` ( B - A ) ) ) < ( D / 2 ) )
                                              -> ( abs ` ( B - A ) ) < D ) ) $=
      ( cc wcel wa co cfv cabs c2 clt wbr cexp caddc csqr cc0 cle recnd abscld
      cr crp cmin cre cim wi simplr simpll subcld recld absge0d jca imcld simpr
      cdiv sqsscirc1 syl21anc absval2d breq1d absresq syl oveq12d fveq2d bitr4d
      wceq sylibrd ) ADEZBDEZFZCUAEZFZBAUBGZUCHZIHZCJUNGZKLVKUDHZIHZVNKLFZVMJMG
      ZVPJMGZNGZOHZCKLZVKIHZCKLZVJVMTEZPVMQLZFVPTEZPVPQLZFVIVQWBUEVJWEWFVJVLVJV
      LVJVKVJBAVFVGVIUFVFVGVIUGUHZUIZRZSVJVLWKUJUKVJWGWHVJVOVJVOVJVKWIULZRZSVJV
      OWMUJUKVHVIUMCVMVPUOUPVJWDVLJMGZVOJMGZNGZOHZCKLWBVJWCWQCKVJVKWIUQURVJWAWQ
      CKVJVTWPOVJVRWNVSWONVJVLTEVRWNVDWJVLUSUTVJVOTEVSWOVDWLVOUSUTVAVBURVCVE $.
  $}

  ${
    $d x y F $.  $d x G $.  $d x y H $.  $d x y X $.  $d x y Y $.
    cnre2csqlem.1 $e |- ( G |` ( RR X. RR ) ) = ( H o. F ) $.
    cnre2csqlem.2 $e |- F Fn ( RR X. RR ) $.
    cnre2csqlem.3 $e |- G Fn _V $.
    cnre2csqlem.4 $e |- ( x e. ( RR X. RR ) -> ( G ` x ) e. RR ) $.
    cnre2csqlem.5 $e |- ( ( x e. ran F /\ y e. ran F )
                          -> ( H ` ( x - y ) ) = ( ( H ` x ) - ( H ` y ) ) ) $.
    $( Lemma for ~ cnre2csqima (Contributed by Thierry Arnoux, 27-Sep-2017.) $)
    cnre2csqlem $p |- ( ( X e. ( RR X. RR ) /\ Y e. ( RR X. RR ) /\ D e. RR+ )
      -> ( Y e. ( `' ( G |` ( RR X. RR ) )
                                " ( ( ( G ` X ) - D ) (,) ( ( G ` X ) + D ) ) )
           -> ( abs ` ( H ` ( ( F ` Y ) - ( F ` X ) ) ) ) < D ) ) $=
      ( cr wcel cfv cmin co clt wceq cxp crp w3a cres ccnv caddc cioo cima cabs
      wbr wa wfn wb cvv wss fnssres mp2an elpreima mp1i simplbda ex simp2 fvres
      ssv syl eleq1d simp1 cv fveq2 vtoclga simp3 rpred resubcld rexrd readdcld
      cxr elioo2 syl2anc biimpa simp2d simp3d jca sylbid absdiflt biimprd 3syld
      wi syl3anc crn fnfvelrn sylancr oveq1 fveq2d oveq1d oveq2 oveq2d vtocl2ga
      eqeq12d ccom fveq1i fvco2 3eqtr3a oveq12d eqtr4d breq1d sylibrd ) GNNUAZO
      ZHXGOZCUBOZUCZHEXGUDZUEGEPZCQRZXMCUFRZUGRZUHOZHEPZXMQRZUIPZCSUJZHDPZGDPZQ
      RZFPZUIPZCSUJXKXQHXLPZXPOZXNXRSUJZXRXOSUJZUKZYAXKXQYHXKXQXIYHXLXGULZXQXIY
      HUKUMXKEUNULXGUNUOYLKXGVDUNXGEUPUQXGHXPXLURUSUTVAXKYHXRXPOZYKXKYGXRXPXKXI
      YGXRTXHXIXJVBZHXGEVCVEZVFXKYMYKXKYMUKZYIYJYPXRNOZYIYJXKYMYQYIYJUCZXKXNVPO
      XOVPOYMYRUMXKXNXKXMCXKXHXMNOZXHXIXJVGZAVHZEPZNOZYSAGXGUUAGTUUBXMNUUAGEVIV
      FLVJVEZXKCXHXIXJVKVLZVMVNXKXOXKXMCUUDUUEVOVNXNXOXRVQVRVSZVTYPYQYIYJUUFWAW
      BVAWCXKYQYSCNOZYKYAWGXKXIYQYNUUCYQAHXGUUAHTUUBXRNUUAHEVIVFLVJVEUUDUUEYQYS
      UUGUCYAYKXRXMCWDWEWHWFXKYFXTCSXKYEXSUIXKYEYBFPZYCFPZQRZXSXKYBDWIZOZYCUUKO
      ZYEUUJTZXKDXGULZXIUULJYNXGHDWJWKXKUUOXHUUMJYTXGGDWJWKUUABVHZQRZFPZUUAFPZU
      UPFPZQRZTYBUUPQRZFPZUUHUUTQRZTUUNABYBYCUUKUUKUUAYBTZUURUVCUVAUVDUVEUUQUVB
      FUUAYBUUPQWLWMUVEUUSUUHUUTQUUAYBFVIWNWRUUPYCTZUVCYEUVDUUJUVFUVBYDFUUPYCYB
      QWOWMUVFUUTUUIUUHQUUPYCFVIWPWRMWQVRXKXRUUHXMUUIQXKYGHFDWSZPZXRUUHHXLUVGIW
      TYOXKUUOXIUVHUUHTJYNXGFDHXAWKXBXKGXLPZGUVGPZXMUUIGXLUVGIWTXKXHUVIXMTYTGXG
      EVCVEXKUUOXHUVJUUITJYTXGFDGXAWKXBXCXDWMXEXF $.
  $}


  ${
    $d x y z $.  $d u z F $.  $d u z X $.  $d u z Y $.
    cnre2csqima.1 $e |- F = ( x e. RR , y e. RR |-> ( x + ( _i x. y ) ) ) $.
    $( Image of a centered square by the canonical bijection from
       ` ( RR X. RR ) ` to ` CC ` .  (Contributed by Thierry Arnoux,
       27-Sep-2017.) $)
    cnre2csqima $p |- ( ( X e. ( RR X. RR ) /\ Y e. ( RR X. RR ) /\ D e. RR+ )
      -> ( Y e. ( ( ( ( 1st ` X ) - D ) (,) ( ( 1st ` X ) + D ) )
               X. ( ( ( 2nd ` X ) - D ) (,) ( ( 2nd ` X ) + D ) ) ) ->
           ( ( abs ` ( Re ` ( ( F ` Y ) - ( F ` X ) ) ) ) < D /\
             ( abs ` ( Im ` ( ( F ` Y ) - ( F ` X ) ) ) ) < D ) ) ) $=
      ( vz c1st cfv co caddc c2nd wcel cr cre cim cc wceq cvv vu cmin cioo cres
      cxp ccnv cima cin crp w3a cabs clt wbr wa wss wb xpinpreima2 eleq2d mp2an
      ioossre elin cv ci cmul ccj cdiv cmpt2 ccom simpl recnd ax-icn a1i mulcld
      c2 simpr addcld reval syl crre eqtr3d mpt2eq3ia wtru adantl cmpt df-re id
      fveq2 oveq12d oveq1d fmpt2co trud df1stres 3eqtr4ri wral wfn rgen2a ax-mp
      fnmpt2 wfo fo1st fofn xp1st crn cab rnmpt2 adantr eqeltrd rexlimivv abssi
      wrex ex eqsstri sseldi resubd cnre2csqlem imval crim df-im oveq1 df2ndres
      fveq2d fo2nd xp2nd imsubd anim12d syl5bi ) FEIJZCUBKZYGCLKZUCKZEMJZCUBKZY
      KCLKZUCKZUEZNZFIOOUEZUDZUFYJUGZMYQUDZUFYNUGZUHZNZEYQNFYQNCUINUJZFDJEDJUBK
      ZPJUKJCULUMZUUEQJUKJCULUMZUNZYJOUOZYNOUOZYPUUCUPYHYIUTYLYMUTUUIUUJUNYOUUB
      FYJYNOOUQURUSUUCFYSNZFUUANZUNUUDUUHFYSUUAVAUUDUUKUUFUULUUGHUACDIPEFABOOAV
      BZVCBVBZVDKZLKZUUPVEJZLKZVNVFKZVGZABOOUUMVGPDVHZYRABOOUUSUUMUUMONZUUNONZU
      NZUUPPJZUUSUUMUVDUUPRNZUVEUUSSUVDUUMUUOUVDUUMUVBUVCVIVJUVDVCUUNVCRNUVDVKV
      LUVDUUNUVBUVCVOVJVMVPZUUPVQVRUUMUUNVSVTWAUVAUUTSWBABHOORUUPHVBZUVHVEJZLKZ
      VNVFKZUUSDPUVDUVFWBUVGWCZDABOOUUPVGSWBGVLZPHRUVKWDSWBHWEVLUVHUUPSZUVJUURV
      NVFUVNUVHUUPUVIUUQLUVNWFUVHUUPVEWGWHWIWJWKABOOWLWMUVFBOWNAOWNDYQWOUVFABOU
      VGWPABOOUUPDRGWRWQZTTIWSITWOWTTTIXAWQUVHOOXBUVHDXCZNZUAVBZUVPNZUNZUVHUVRU
      VTUVPRUVHUVPUVNBOXJAOXJZHXDRABHOOUUPDGXEUWAHRUVNUVHRNZABOOUVDUVNUWBUVDUVN
      UNUVHUUPRUVDUVNVOUVDUVFUVNUVGXFXGXKXHXIXLZUVQUVSVIXMZUVTUVPRUVRUWCUVQUVSV
      OXMZXNXOHUACDMQEFABOOUUPVCVFKZPJZVGZABOOUUNVGQDVHZYTABOOUWGUUNUVDUUPQJZUW
      GUUNUVDUVFUWJUWGSUVGUUPXPVRUUMUUNXQVTWAUWIUWHSWBABHOORUUPUVHVCVFKZPJZUWGD
      QUVLUVMQHRUWLWDSWBHXRVLUVNUWKUWFPUVHUUPVCVFXSYAWJWKABOOXTWMUVOTTMWSMTWOYB
      TTMXAWQUVHOOYCUVTUVHUVRUWDUWEYDXOYEYFYF $.
  $}

  ${
    $d u v x y z $.  $d d m r x A $.  $d d r B $.  $d d m x G $.  $d d x J $.
    $d d x y m r X $.
    tpr2rico.0 $e |- J = ( topGen ` ran (,) ) $.
    tpr2rico.1 $e |- G = ( u e. RR , v e. RR |-> ( u + ( _i x. v ) ) ) $.
    tpr2rico.2 $e |- B = ran ( x e. ran (,) , y e. ran (,) |-> ( x X. y ) ) $.
    $( For any point of an open set of the usual topology on ` ( RR X. RR ) `
       there is an opened square which contains that point and is entirely in
       the open set.  This is square is actually a ball by the ` ( l ^ +oo ) `
       norm ` X ` .  (Contributed by Thierry Arnoux, 21-Sep-2017.) $)
    tpr2rico $p |- ( ( A e. ( J tX J ) /\ X e. A ) ->
      E. r e. B ( X e. r /\ r C_ A ) ) $=
      ( vd co wcel wa crp cr cc vz vm ctx c1st cfv cv cdiv cmin caddc cioo c2nd
      c2 cxp wss wrex wral crn cmpt2 wceq cxr wfn cpw clt df-ioo ixxf mp1i cuni
      wf ffn elssuni ctop retop eqeltri uniretop unieqi eqtr4i txunii syl6sseqr
      ctg ad2antrr simplr sseldd xp1st syl simpr rpred rehalfcld resubcld rexrd
      readdcld fnovrn syl3anc xp2nd eqeq2d eqid vex syl6eleqr ralrimiva cvv wbr
      rphalfcld ltsubrpd ltaddrpd w3a wb elioo1 syl2anc mpbir3and jca cabs cima
      eqidd cmnf cpnf mnfle pnfge mnfxr ioossioo mpanl12 ioomax syl6sseq sselda
      cle pnfxr wi adantr wf1o mp2b a1i syl21anc imp cnxmet ex wfun ax-mp f1odm
      cdm funfvima sylancr r19.29 xpeq1 xpeq2 rspc2ev xpex elrnmpt2 sylibr xpss
      sseldi elxp7 sylanbrc ccnv ccom cbl xpss12 expcom ancld imdistanri simpr1
      cre 3anassrs cnre2csqima ccnfld ctopn chmeo cnrehmeo cnfldtopon toponunii
      cim hmeof1o f1of ffvelrnd ffvelrnda sqsscirc2 rpxrd jctil cnmetdval elbl3
      cxmt eqbrtrd biimpar syldan syld f1ocnv f1ofun f1ocnvfv1 eleq1d biimpd ci
      3syld ssrdv cmul mpt2fun hmeoima cnfldtopn elmopn2 simprbi sseq1d rexbidv
      mpan oveq1 rspcva imass2 f1of1 f1imacnv sseq2d syl5ib reximdv sstr reximi
      wf1 mpd eleq2 sseq1 anbi12d rspcev rexlimivw ) EHHUCOZPZIEPZQZIUDUEZNUFZU
      LUGOZUHOZUYAUYCUIOZUJOZIUKUEZUYCUHOZUYGUYCUIOZUJOZUMZFPZIUYKPZUYKEUNZQZQZ
      NRUOZIJUFZPZUYREUNZQZJFUOZUXTUYLNRUPUYONRUOZUYQUXTUYLNRUXTUYBRPZQZUYKABUJ
      UQZVUFAUFZBUFZUMZURZUQZFVUEUYKVUIUSZBVUFUOAVUFUOZUYKVUKPVUEUYFVUFPZUYJVUF
      PZUYKUYKUSZVUMVUEUJUTUTUMZVAZUYDUTPZUYEUTPZVUNVUQUTVBZUJVHVURVUEABUAVCVCU
      JABUAVDVEVUQVVAUJVIVFZVUEUYDVUEUYAUYCVUEISSUMZPZUYASPVUEEVVCIUXREVVCUNZUX
      SVUDUXREUXQVGVVCEUXQVJHHSSHVUFVSUEZVKKVLVMZVVGSVVFVGHVGVNHVVFKVOVPZVVHVQZ
      VRZVTUXRUXSVUDWAWBZISSWCWDZVUEUYBVUEUYBUXTVUDWEZWFWGZWHWIZVUEUYEVUEUYAUYC
      VVLVVNWJWIZUTUTUYDUYEUJWKWLVUEVURUYHUTPZUYIUTPZVUOVVBVUEUYHVUEUYGUYCVUEVV
      DUYGSPVVKISSWMWDZVVNWHWIZVUEUYIVUEUYGUYCVVSVVNWJWIZUTUTUYHUYIUJWKWLVUEUYK
      XLVULVUPUYKUYFVUHUMZUSABUYFUYJVUFVUFVUGUYFUSVUIVWBUYKVUGUYFVUHUUAWNVUHUYJ
      USVWBUYKUYKVUHUYJUYFUUBWNUUCWLABVUFVUFVUIUYKVUJVUJWOVUGVUHAWPBWPUUDUUEUUF
      MWQWRUXTUYMNRUPUYNNRUOZVUCUXTUYMNRVUEIWSWSUMZPUYAUYFPZUYGUYJPZQUYMVUEVVCV
      WDISSUUGVVKUUHVUEVWEVWFVUEVWEUYAUTPZUYDUYAVCWTZUYAUYEVCWTZVUEUYAVVLWIVUEU
      YAUYCVVLVUEUYBVVMXAZXBVUEUYAUYCVVLVWJXCVUEVUSVUTVWEVWGVWHVWIXDXEVVOVVPUYD
      UYEUYAXFXGXHVUEVWFUYGUTPZUYHUYGVCWTZUYGUYIVCWTZVUEUYGVVSWIVUEUYGUYCVVSVWJ
      XBVUEUYGUYCVVSVWJXCVUEVVQVVRVWFVWKVWLVWMXDXEVVTVWAUYHUYIUYGXFXGXHXIIUYFUY
      JUUIUUJWRUXTUYKGUUKZIGUEZUYBXJUHUULZUUMUEZOZXKZUNZVWSEUNZQZNRUOZVWCUXTVWT
      NRUPVXANRUOZVXCUXTVWTNRVUEAUYKVWSVUEVUGUYKPZVUGVWSPZVUEVXEQVUEVUGVVCPZQZV
      XEQVXFVXEVUEVXHVXEVUEVXGVUEVXEVXGVUEUYKVVCVUGVUEUYFSUNUYJSUNUYKVVCUNVUEUY
      FXMXNUJOZSVUEXMUYDYCWTZUYEXNYCWTZUYFVXIUNZVUEVUSVXJVVOUYDXOWDVUEVUTVXKVVP
      UYEXPWDXMUTPZXNUTPZVXJVXKQVXLXQYDXMXNUYDUYEXRXSXGXTYAVUEUYJVXISVUEXMUYHYC
      WTZUYIXNYCWTZUYJVXIUNZVUEVVQVXOVVTUYHXOWDVUEVVRVXPVWAUYIXPWDVXMVXNVXOVXPQ
      VXQXQYDXMXNUYHUYIXRXSXGXTYAUYFSUYJSUUNXGYBUUOUUPUUQVXHVXEVXFVXHVXEVUGGUEZ
      VWRPZVXRVWNUEZVWSPZVXFVXHVXEVXRVWOUHOZUUSUEXJUEUYCVCWTVYBUVHUEXJUEUYCVCWT
      QZVXSVXHVVDVXGUYCRPVXEVYCYEUXRUXSVUDVXGVVDUXRUXSVUDVXGXDZQEVVCIUXRVVEVYDV
      VJYFUXRUXSVUDVXGUURWBUUTZVUEVXGWEZVXHUYBUXTVUDVXGWAZXADCUYCGIVUGLUVAWLVXH
      VYCVXSVXHVYCVYBXJUEZUYBVCWTZVXSVXHVYCVYIVXHVWOTPZVXRTPZVUDVYCVYIYEVXHVVCT
      IGVVCTGVHZVXHGUXQUVBUVCUEZUVDOPZVVCTGYGZVYLDCGHVYMLKVYMWOZUVEZGUXQVYMVVCT
      VVITVYMVYMVYPUVFUVGUVIZVVCTGUVJYHZYIVYEUVKZVUEVVCTVUGGVYLVUEVYSYIUVLZVYGV
      WOVXRUYBUVMYJYKVXHVYIQZVWPTUVRUEPZUYBUTPZQZVYJVYKQZVXRVWOVWPOZUYBVCWTZVXS
      WUBWUDWUCVXHWUDVYIVXHUYBVYGUVNYFYLUVOWUBVYJVYKVXHVYJVYIVYTYFZVXHVYKVYIWUA
      YFZXIWUBWUGVYHUYBVCWUBVYKVYJWUGVYHUSWUJWUIVXRVWOVWPVWPWOUVPXGVXHVYIWEUVSW
      UEWUFQVXSWUHVXRVWPVWOUYBTUVQUVTYJUWAYMUWBVXHVWNYNZVXRVWNYQZPVXSVYAYETVVCV
      WNYGZWUKVYNVYOWUMVYQVYRVVCTGUWCYHZTVVCVWNUWDYOVXHVXRTWULWUAWUMWULTUSWUNTV
      VCVWNYPYOWQVWRVXRVWNYRYSVXHVYAVXFVXHVXTVUGVWSVXHVYOVXGVXTVUGUSVYNVYOVXHVY
      QVYRVFVYFVVCTVUGGUWEXGUWFUWGUWIYKWDYMUWJWRUXTVWRGEXKZUNZNRUOZVXDUXTVWOWUO
      PZUBUFZUYBVWQOZWUOUNZNRUOZUBWUOUPZWUQUXTGYNZIGYQZPZUXSWURWVDUXTDCSSDUFUWH
      CUFUWKOUIOGLUWLYIUXTIVVCWVEUXREVVCIVVJYBVYNVYOWVEVVCUSVYQVYRVVCTGYPYHWQUX
      RUXSWEWVDWVFQUXSWUREIGYRYKYJUXRWVCUXSUXRWUOVYMPZWVCVYNUXRWVGVYQEGUXQVYMUW
      MUWSWVGWUOTUNZWVCWUCWVGWVHWVCQXEYLUBNWUOVWPVYMTVYMVYPUWNUWOYOUWPWDYFWVBWU
      QUBVWOWUOWUSVWOUSZWVAWUPNRWVIWUTVWRWUOWUSVWOUYBVWQUWTUWQUWRUXAXGUXRWUQVXD
      YEUXSUXRWUPVXANRWUPVWSVWNWUOXKZUNUXRVXAVWRWUOVWNUXBUXRWVJEVWSUXRVVCTGUXJZ
      VVEWVJEUSVYNVYOWVKVYQVYRVVCTGUXCYHVVJVVCTEGUXDYSUXEUXFUXGYFUXKVWTVXANRYTX
      GVXBUYNNRUYKVWSEUXHUXIWDUYMUYNNRYTXGUYLUYONRYTXGUYPVUBNRVUAUYOJUYKFUYRUYK
      USUYSUYMUYTUYNUYRUYKIUXLUYRUYKEUXMUXNUXOUXPWD $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Order topology - misc. additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y z A $.  $d x y B $.
    cnvordtrestixx.1 $e |- A C_ RR* $.
    cnvordtrestixx.2 $e |- ( ( x e. A /\ y e. A ) -> ( x [,] y ) C_ A ) $.
    $( The restriction of the 'greater than' order to an interval gives the
       same topology as the subspace topology.  (Contributed by Thierry Arnoux,
       1-Apr-2017.) $)
    cnvordtrestixx $p |- ( ( ordTop ` <_ ) |`t A ) =
      ( ordTop ` ( `' <_ i^i ( A X. A ) ) ) $=
      ( vz cle cordt cfv crest co wceq wtru cxr wcel ax-mp wss cv wa wbr cnvtsr
      ccnv cxp cin crn cdm lern df-rn eqtri ctsr letsr a1i crab wb brcnvg simpr
      adantlr simplr syl2anc anbi12d ancom syl6bb rabbidva sseldi iccval ancoms
      cicc simpl eqsstr3d eqsstrd adantl ordtrest2 trud cps tsrps oveq1i eqtr2i
      ordtcnv ) GUBZCCUCUDHIZVSHIZCJKZGHIZCJKVTWBLMBAFCVSNNGUEVSUFUGGUHUIVSUJOZ
      MGUJOZWDUKGUAPULCNQMDULBRZCOZARZCOZSZWFFRZVSTZWKWHVSTZSZFNUMZCQMWJWOWHWKG
      TZWKWFGTZSZFNUMZCWJWNWRFNWJWKNOZSZWNWQWPSWRXAWLWQWMWPWGWTWLWQUNWIWFWKCNGU
      OUQXAWTWIWMWPUNWJWTUPWGWIWTURWKWHNCGUOUSUTWQWPVAVBVCWJWSWHWFVGKZCWJWHNOWF
      NOXBWSLWJCNWHDWGWIUPVDWJCNWFDWGWIVHVDFWHWFVEUSWIWGXBCQEVFVIVJVKVLVMWAWCCJ
      GVNOZWAWCLWEXCUKGVOPGVRPVPVQ $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Continuity in topological spaces - misc. additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d a b y .* $.  $d a x y .* $.  $d a b y .+ $.  $d a b C $.  $d a b y F $.
    $d a b J $.  $d a b K $.  $d x y .+ $.  $d x y B $.  $d x y F $.
    mndpluscn.f $e |- F e. ( J Homeo K ) $.
    mndpluscn.p $e |- .+ : ( B X. B ) --> B $.
    mndpluscn.t $e |- .* : ( C X. C ) --> C $.
    mndpluscn.j $e |- J e. ( TopOn ` B ) $.
    mndpluscn.k $e |- K e. ( TopOn ` C ) $.
    mndpluscn.h $e |- ( ( x e. B /\ y e. B ) ->
                           ( F ` ( x .+ y ) ) = ( ( F ` x ) .* ( F ` y ) ) ) $.
    mndpluscn.o $e |- .+ e. ( ( J tX J ) Cn J ) $.
    $( A mapping that is both a homeomorphism and a monoid homomorphism
       preserves the "continuousness" of the operation.  (Contributed by
       Thierry Arnoux, 25-Mar-2017.) $)
    mndpluscn $p   |- .* e. ( ( K tX K ) Cn K ) $=
      ( va vb cfv co cv ccnv cmpt2 ctx ccn cxp wf wfn wceq ffn fnov biimpi mp2b
      wcel wral wf1o chmeo toponunii hmeof1o ax-mp f1ocnvdm mpan anim12i rgen2a
      wa oveq1 fveq2d oveq1d eqeq12d oveq2d rspc2va sylancl f1ocnvfv2 oveqan12d
      fveq2 oveq2 eqtr2d mpt2eq3ia eqtri ctopon a1i cnmpt1st hmeocnvcn cnmpt21f
      wtru mp1i cnmpt2nd cnmpt22f hmeocn trud eqeltri ) GQRDDQUAZFUBZSZRUAZWMSZ
      ETZFSZUCZIIUDTIUETZGQRDDWLWOGTZUCZWSDDUFZDGUGGXCUHZGXBUIZLXCDGUJXDXEQRDDG
      UKULUMQRDDXAWRWLDUNZWODUNZVEZWRWNFSZWPFSZGTZXAXHWNCUNZWPCUNZVEAUAZBUAZETZ
      FSZXNFSZXOFSZGTZUIZBCUOACUOWRXKUIZXFXLXGXMCDFUPZXFXLFHIUQTUNZYCJFHICDCHMU
      RDINURUSUTZCDWLFVAVBYCXGXMYECDWOFVAVBVCYAABCOVDYAYBWNXOETZFSZXIXSGTZUIABW
      NWPCCXNWNUIZXQYGXTYHYIXPYFFXNWNXOEVFVGYIXRXIXSGXNWNFVOVHVIXOWPUIZYGWRYHXK
      YJYFWQFXOWPWNEVPVGYJXSXJXIGXOWPFVOVJVIVKVLXFXGXIWLXJWOGYCXFXIWLUIYECDWLFV
      MVBYCXGXJWOUIYECDWOFVMVBVNVQVRVSWSWTUNWEQRWQFIIHIDDIDVTSUNWENWAZYKWEQRWNW
      PEIIHHHDDYKYKWEQRWLWMIIIHDDYKYKWEQRIIDDYKYKWBYDWMIHUETUNWEJFHIWCWFZWDWEQR
      WOWMIIIHDDYKYKWEQRIIDDYKYKWGYLWDEHHUDTHUETUNWEPWAWHYDFHIUETUNWEJFHIWIWFWD
      WJWK $.
  $}

  ${
    $d x y F $.  $d x y S $.  $d x y T $.
    mhmhmeotmd.m $e |- F e. ( S MndHom T ) $.
    mhmhmeotmd.h $e |- F e. ( ( TopOpen ` S ) Homeo ( TopOpen ` T ) ) $.
    mhmhmeotmd.t $e |- S e. TopMnd $.
    mhmhmeotmd.s $e |- T e. TopSp $.
    $( Deduce a Topological Monoid using mapping that is both a homeomorphism
       and a monoid homomorphism.  (Contributed by Thierry Arnoux,
       21-Jun-2017.) $)
    mhmhmeotmd $p |- T e. TopMnd $=
      ( vx vy ctmd wcel cmnd cplusf cfv ctopn ctx co ax-mp wf eqid ctps mhmrcl2
      ccn cmhm cbs cxp mhmrcl1 mndplusf ctopon tmdtopon istps mpbi cv wa cplusg
      wceq mhmlin mp3an1 plusfval fveq2d mhmf ffvelrni syl2an 3eqtr4d mndpluscn
      tmdcn istmd mpbir3an ) BJKBLKZBUAKZBMNZBONZVLPQVLUCQKCABUDQKZVIDABCUBRZGH
      IAUENZBUENZAMNZCVKAONZVLEALKZVOVOUFVOVQSVMVSDABCUGRVOVQAVOTZVQTZUHRVIVPVP
      UFVPVKSVNVPVKBVPTZVKTZUHRAJKZVRVOUINKFAVRVOVRTZVTUJRVJVLVPUINKGVPVLBWBVLT
      ZUKULHUMZVOKZIUMZVOKZUNZWGWIAUONZQZCNZWGCNZWICNZBUONZQZWGWIVQQZCNWOWPVKQZ
      VMWHWJWNWRUPDVOWLWQABCWGWIVTWLTZWQTZUQURWKWSWMCVOWLVQAWGWIVTXAWAUSUTWHWOV
      PKWPVPKWTWRUPWJVOVPWGCVMVOVPCSDVOVPABCVTWBVARZVBVOVPWICXCVBVPWQVKBWOWPWBX
      BWCUSVCVDWDVQVRVRPQVRUCQKFVQAVRWEWAVFRVEVKBVLWCWFVGVH $.
  $}

  ${
    $d w x C $.  $d w x ph $.  $d x y z C $.
    rmulccn.1 $e |- J = ( topGen ` ran (,) ) $.
    rmulccn.2 $e |- ( ph -> C e. RR ) $.
    $( Multiplication by a real constant is a continuous function (Contributed
       by Thierry Arnoux, 23-May-2017.) $)
    rmulccn $p |- ( ph -> ( x e. RR |-> ( x x. C ) ) e. ( J Cn J ) ) $=
      ( vy vz vw cc cv cmul co cr cfv ccn wcel a1i wceq ax-resscn cmpt cres wss
      ccnfld ctopn crest ctopon eqid cnfldtopon cnmptid recnd cmpt2 ctx cxp wfn
      cnmptc wf ax-mulf ax-mp fnov mpbi mulcn eqeltrri oveq12 cnmpt12 toponunii
      ffn cnrest sylancl crn wb wral wa simpr adantr mulcld ralrimiva fnmpt syl
      fnssres fvres oveq1 fvmpt eqtrd remulcld eqeltrd fnfvrnss syl2anc cnrest2
      recn ovex syl3anc mpbid resmpt cioo tgioo2 eqtri oveq12i eqcomi 3eltr3g
      ctg ) ABJBKZCLMZUAZNUBZUDUEOZNUFMZXGPMZBNXCUAZDDPMZAXEXGXFPMQZXEXHQZAXDXF
      XFPMQNJUCZXKABGHXBCGKZHKZLMZXCXFXFXFXFJJJXFJUGOQZAXFXFUHZUIZRZABXFJXTUJAB
      CXFXFJJXTXTACFUKZUPXTXTGHJJXPULZXFXFUMMXFPMZQALYBYCLJJUNZUOZLYBSYDJLUQYEU
      RYDJLVGUSGHJJLUTVAXFXRVBVCRXNXBXOCLVDVETNXDXFXFJJXFXSVFVHVIAXQXEVJNUCZXMX
      KXLVKXTAXENUOZIKZXEOZNQZINVLYFAXDJUOZXMYGAXCJQZBJVLYKAYLBJAXBJQZVMXBCAYMV
      NACJQYMYAVOVPVQBJXCXDJXDUHZVRVSTJNXDVTVIAYJINAYHNQZVMZYIYHCLMZNYPYOYIYQSA
      YOVNZYOYIYHXDOZYQYHNXDWAYOYHJQYSYQSYHWJBYHXCYQJXDXBYHCLWBYNYHCLWKWCVSWDVS
      YPYHCYRACNQYOFVOWEWFVQINNXEWGWHXMATRNXEXGXFJWIWLWMXMXEXISTBJNXCWNUSXJXHDX
      GDXGPDWOVJXAOXGEXFXRWPWQZYTWRWSWT $.
  $}

  ${
    $d x y $.
    raddcn.1 $e |- J = ( topGen ` ran (,) ) $.
    $( Addition in the real numbers is a continuous function.  (Contributed by
       Thierry Arnoux, 23-May-2017.) $)
    raddcn $p |- ( x e. RR , y e. RR |-> ( x + y ) ) e. ( ( J tX J ) Cn J ) $=
      ( caddc cr cxp ctx co cfv crest ccn wcel wss ax-resscn mp2an ctop cvv crn
      cc cres ccnfld ctopn cv cmpt2 eqid addcn xpss12 cnfldtop toponunii txunii
      cnfldtopon cnrest wceq reex txrest mp4an cioo tgioo2 eqtr2i oveq12i eqtri
      ctg oveq1i eleqtri ctopon wb wfn wf ax-addf ax-mp fnssres fnov mpbi ovres
      mpt2eq3ia rneqi wral readdcl rgen2a rnmpt2ss eqsstri cnrest2 mp3an oveq2i
      ffn 3eltr3i ) EFFGZUAZCCHIZUBUCJZFKIZLIZABFFAUDZBUDZEIZUEZWJCLIWIWJWKLIZM
      ZWIWMMZWIWKWKHIZWHKIZWKLIZWREXAWKLIMWHTTGZNZWIXCMWKWKUFZUGFTNZXGXEOOFTFTU
      HPZWHEXAWKXDWKWKTTWKXFUIZXITWKWKXFULZUJZXKUKUMPXBWJWKLXBWLWLHIZWJWKQMZXMF
      RMZXNXBXLUNXIXIUOUOFFWKWKQQRRUPUQWLCWLCHCURSVCJWLDWKXFUSUTZXOVAVBVDVEWKTV
      FJMWISZFNXGWSWTVGXJXPWQSZFWIWQWIABFFWNWOWIIZUEZWQWIWHVHZWIXSUNEXDVHZXEXTX
      DTEVIYAVJXDTEWFVKXHXDWHEVLPABFFWIVMVNABFFXRWPWNWOFFEVOVPVBZVQWPFMZBFVRAFV
      RXQFNYCABFWNWOVSVTABFFWPFWQWQUFWAVKWBOFWIWJWKTWCWDVNYBWLCWJLXOWEWG $.
  $}

  ${
    $d x y C $.  $d x y F $.  $d x y ph $.
    xrmulc1cn.k $e |- J = ( ordTop ` <_ ) $.
    xrmulc1cn.f $e |- F = ( x e. RR* |-> ( x *e C ) ) $.
    xrmulc1cn.c $e |- ( ph -> C e. RR+ ) $.
    $( The operation multiplying an extended real number by a non-negative
       constant is continuous.  (Contributed by Thierry Arnoux, 5-Jul-2017.) $)
    xrmulc1cn $p |- ( ph -> F e. ( J Cn J ) ) $=
      ( vy cle cfv co wcel cxr wral cxmu wceq wa simpr ralrimiva cordt ccn ctsr
      wiso letsr a1i wf1o cv wbr wb wreu crp adantr rpxrd xmulcld cc0 wne rpred
      rpne0d xreceu syl3anc eqcom adantlr xmulcom eqeq1d syl5bb reubidva mpbird
      cr syl2anc f1ompt sylanbrc simplr ad2antrr xlemul1 cvv ovex sylancl oveq1
      fvmpt2 fvmpt adantl breq12d bitr4d df-isom ordthmeolem oveq12i syl6eleqr
      ledm ) ADJUAKZWJUBLZEEUBLAJUCMZWLNNJJDUDZDWKMWLAUEUFZWNANNDUGZBUHZIUHZJUI
      ZWPDKZWQDKZJUIZUJZINOZBNOWMAWPCPLZNMZBNOWQXDQZBNUKZINOWOAXEBNAWPNMZRZWPCA
      XHSXICACULMZXHHUMUNZUOTAXGINAWQNMZRZXGCWPPLZWQQZBNUKZXMXLCVIMCUPUQXPAXLSX
      MCAXJXLHUMZURXMCXQUSBWQCUTVAXMXFXOBNXFXDWQQXMXHRZXOWQXDVBXRXDXNWQXRXHCNMZ
      XDXNQXMXHSAXHXSXLXKVCWPCVDVJVEVFVGVHTBINNXDDGVKVLAXCBNXIXBINXIXLRZWRXDWQC
      PLZJUIZXAXTXHXLXJWRYBUJAXHXLVMZXIXLSAXJXHXLHVNWPWQCVOVAXTWSXDWTYAJXTXHXDV
      PMWSXDQYCWPCPVQBNXDVPDGVTVRXLWTYAQXIBWQXDYANDWPWQCPVSGWQCPVQWAWBWCWDTTBIN
      NJJDWEVLJJDUCUCNNWIWIWFVAEWJEWJUBFFWGWH $.
  $}

  ${
    $d b e x y B $.  $d b d e x y D $.  $d b d e x y E $.  $d b d e x y F $.
    $d b d e x y J $.  $d b d e x y K $.  $d b d e x y X $.  $d b d e x y Y $.
    fmcncfil.1 $e |- J = ( MetOpen ` D ) $.
    fmcncfil.2 $e |- K = ( MetOpen ` E ) $.
    $( The image of a Cauchy filter by a continuous filter map is a Cauchy
       filter.  (Contributed by Thierry Arnoux, 12-Nov-2017.) $)
    fmcncfil $p |- ( ( ( D e. ( CMet ` X ) /\ E e. ( *Met ` Y )
      /\ F e. ( J Cn K ) ) /\ B e. ( CauFil ` D ) ) ->
      ( ( Y FilMap F ) ` B ) e. ( CauFil ` E ) ) $=
      ( vx vb cfv wcel co wa cv cflim wex wral vy vd cms cxmt ccn w3a ccfil cfm
      ve simpl2 cflf wi wal simpl1 c0 wne cmetcvg n0 sylib sylancom cme cmetmet
      cfil metxmet 3syl cfilfil ctopon mopntopon simpl3 cnflf simplbda syl21anc
      syl wf wceq oveq2 fveq1d eleq2d raleqbidv rspcv sylc df-ral 19.29r pm3.35
      eximi syl2anc clt wbr crp metcn biimpa simpld flfval syl3anc exbidv mpbid
      wrex flimcfil ex exlimdv ) BGUCMNZCHUDMNZDEFUEONZUFZABUGMNZPZXBKQZDMZFAHD
      UHOMZROZNZKSZXICUGMNZXAXBXCXEUJZXFXHDFAUKOZMZNZKSZXLXFXGEAROZNZKSZXTXQULZ
      KUMZXRXDXEXAYAXAXBXCXEUNZXAXEPXSUOUPYABAEGIUQKXSURUSUTXFXQKXSTZYCXFAGVCMZ
      NZXHDFLQZUKOZMZNZKEYHROZTZLYFTZYEXDXEBGUDMNZYGXFXABGVAMNYOYDBGVBBGVDVEZBA
      GVFUTZXFEGVGMNZFHVGMNZXCYNXFYOYRYPBEGIVHVMXFXBYSXNCFHJVHVMZXAXBXCXEVIZYRY
      SPXCGHDVNZYNKLDEFGHVJVKVLYMYELAYFYHAVOZYKXQKYLXSYHAERVPUUCYJXPXHUUCDYIXOY
      HAFUKVPVQVRVSVTWAXQKXSWBUSYAYCPXTYBPZKSXRXTYBKWCUUDXQKXTXQWDWEVMWFXFXQXKK
      XFXPXJXHXFYSYGUUBXPXJVOYTYQXFUUBXGUAQZBOUBQWGWHXHUUEDMCOUIQWGWHULUAGTUBWI
      WQUIWITKGTZXFYOXBXCUUBUUFPZYPXNUUAYOXBPXCUUGKUIUBUABCDEFGHIJWJWKVLWLDFAHG
      WMWNVRWOWPXBXKXMKXBXKXMXHCXIFHJWRWSWTWA $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Topology of the extended non-negative real numbers monoid
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The extended non-negative reals are homeomorphic to the closed unit
     interval.  (Contributed by Thierry Arnoux, 24-Mar-2017.) $)
  xrge0hmph $p |- II ~= ( ( ordTop ` <_ ) |`t ( 0 [,] +oo ) ) $=
    ( vx cc0 c1 cicc co cv wceq cpnf cmin cdiv cif cmpt cii cle cordt cfv crest
    chmeo clt eqid wcel chmph wbr wiso iccpnfhmeo simpri hmphi ax-mp ) ABCDEZAF
    ZCGHUJCUJIEJEKLZMNOPBHDEZQEZREUAZMUMUBUCUIULSSUKUDUNAUKUMUKTUMTUEUFUKMUMUGU
    H $.

  ${
    $d x y $.
    xrge0iifhmeo.1 $e |- F = ( x e. ( 0 [,] 1 ) |->
                                       if ( x = 0 , +oo , -u ( log ` x ) ) ) $.
    $( Define a bijection from ` [ 0 , 1 ] ` to ` [ 0 , +oo ] ` .  (Contributed
       by Thierry Arnoux, 29-Mar-2017.) $)
    xrge0iifcnv $p |- ( F : ( 0 [,] 1 ) -1-1-onto-> ( 0 [,] +oo ) /\ `' F =
      ( y e. ( 0 [,] +oo ) |-> if ( y = +oo , 0 , ( exp ` -u y ) ) ) ) $=
      ( cc0 c1 co cpnf wceq wa wcel cxr cle wbr 0xr pnfxr wn clt cr wb cicc cfv
      wf1o ccnv cv cneg ce cif cmpt wtru clog pnfge ax-mp ubicc2 mp3an a1i cico
      icossicc cioc csn wo wi cun uncom rexri 0le1 snunioc eqtr3i eleq2i bitr3i
      1re elun pm2.53 sylbi elsni syl6 con1d imp cioo 0le0 ltpnf iocssioo mp4an
      crp wss ioorp sseqtri sseli relogcld renegcld rexrd w3a mp2an simp3bi 1rp
      elioc1 logled mpbid log1 syl6breq le0neg1d elico1 syl3anbrc sseldi ifclda
      syl adantl 0elunit iocssicc snunico cmnf mnfxr 0re xrleid icossioo ioomax
      mnflt reefcld efgt0 simp2bi le0neg2d efle sylancl ef0 eqeq2 bibi1d iftrue
      simpr eqeq2d syl5ibrcom wnel ubico df-nel mpbir neleq1 bibi2d cc ifbothda
      syl2an recnd mpbiri syl5ibcom iffalse eqeltrd ad2antrr syl5bi syld impbid
      ex wne ltned adantll neneqd eqeq1 notbid simplr 2falsed relogeftb negcon2
      eqcom 3bitr2d an4s anass1rs f1ocnv2d trud ) EFUAGZEHUAGZCUCCUDBUVGBUEZHIZ
      EUVHUFZUGUBZUHZUIIJUJABUVFUVGAUEZEIZHUVMUKUBZUFZUHZUVLCDUVMUVFKZUVQUVGKUJ
      UVRUVNHUVPUVGHUVGKZUVRUVNJELKZHLKZEHMNZUVSOPUVTUWBOEULUMZEHUNUOUPUVRUVNQZ
      JZEHUQGZUVGUVPEHURUWEUVMEFUSGZKZUVPUWFKZUVRUWDUWHUVRUWHUVNUVRUWHQZUVMEUTZ
      KZUVNUVRUWHUWLVAZUWJUWLVBUVRUVMUWGUWKVCZKUWMUWNUVFUVMUWKUWGVCZUWNUVFUWKUW
      GVDUVTFLKZEFMNUWOUVFIOFVKVEZVFEFVGUOVHVIUVMUWGUWKVLVJUWHUWLVMVNUVMEVOVPVQ
      VRZUWHUVPLKZEUVPMNZUVPHRNZUWIUWHUVPUWHUVOUWHUVMUWGWDUVMUWGEHVSGZWDUVTUWAE
      EMNFHRNZUWGUXBWEOPVTFSKUXCVKFWAUMEHEFWBWCWFWGWHZWIZWJZWKUWHUVOEMNUWTUWHUV
      OFUKUBZEMUWHUVMFMNZUVOUXGMNUWHUVMLKZEUVMRNZUXHUVTUWPUWHUXIUXJUXHWLTOUWQEF
      UVMWPWMWNUWHUVMFUXDFWDKUWHWOUPWQWRWSWTUWHUVOUXEXAWRUWHUVPSKUXAUXFUVPWAXFU
      VTUWAUWIUWSUWTUXAWLTOPEHUVPXBWMXCXFZXDXEXGUVHUVGKZUVLUVFKUJUXLUVIEUVKUVFE
      UVFKUXLUVIJXHUPUXLUVIQZJZUWGUVFUVKEFXIUXNUVHUWFKZUVKUWGKZUXLUXMUXOUXLUXOU
      VIUXLUXOQZUVHHUTZKZUVIUXLUXOUXSVAZUXQUXSVBUXLUVHUWFUXRVCZKUXTUYAUVGUVHUVT
      UWAUWBUYAUVGIOPUWCEHXJUOVIUVHUWFUXRVLVJUXOUXSVMVNUVHHVOVPVQVRZUXOUVKLKZEU
      VKRNZUVKFMNZUXPUXOUVKUXOUVJUXOUVHUWFSUVHUWFXKHVSGZSXKLKUWAXKERNZHHMNZUWFU
      YFWEXLPESKZUYGXMEXQUMUWAUYHPHXNUMXKHEHXOWCXPWGWHZWJZXRWKUXOUVJSKZUYDUYKUV
      JXSXFZUXOUVKEUGUBZFMUXOUVJEMNZUVKUYNMNZUXOEUVHMNZUYOUXOUVHLKZUYQUVHHRNZUV
      TUWAUXOUYRUYQUYSWLTOPEHUVHXBWMXTUXOUVHUYJYAWRUXOUYLUYIUYOUYPTUYKXMUVJEYBY
      CWRYDWTUVTUWPUXPUYCUYDUYEWLTOUWQEFUVKWPWMXCXFXDXEXGUVRUXLJZUVMUVLIZUVHUVQ
      IZTZUJUVIUVNVUBTUVMUVKIZVUBTZVUCUYTEUVKEUVLIUVNVUAVUBEUVLUVMYEYFUVKUVLIVU
      DVUAVUBUVKUVLUVMYEYFUYTUVIJZUVNVUBVUFVUBUVNUVIUYTUVIYHUVNUVQHUVHUVNHUVPYG
      YIYJVUFVUBUVQUWFYKZUVNVUFUVHUWFYKZVUBVUGVUFVUHHUWFYKZVUIHUWFKQZUYIUWAVUJX
      MPEHYLWMHUWFYMYNUVIVUHVUITUYTUVHHUWFYOXGUUAUVHUVQUWFYOUUBVUGUVQUWFKZQVUFU
      VNUVQUWFYMVUFUVNVUKUVRUWDVUKVBUXLUVIUVRUWDVUKUWEUVQUVPUWFUWDUVQUVPIUVRUVN
      HUVPUUCXGUXKUUDUUIUUEVQUUFUUGUUHUVNVUDUVITVUDUVHUVPIZTZVUEUYTUXMJZHUVPHUV
      QIUVIVUBVUDHUVQUVHYEYPUVPUVQIVULVUBVUDUVPUVQUVHYEYPVUNUVNJVUDUVIVUNUVNVUD
      QZVUNVUOUVNEUVKIZQVUNEUVKUXLUXMEUVKUUJUVRUXNEUVKUYIUXNXMUPUXNUXOUYDUYBUYM
      XFUUKUULUUMUVNVUDVUPUVMEUVKUUNUUOYJVRUYTUXMUVNUUPUUQUYTUWDUXMVUMUVRUWDUXL
      UXMVUMUWEUWHUXOVUMUXNUWRUYBUWHUXOJZVUDUVKUVMIZUVOUVJIZVULVUDVURTVUQUVMUVK
      UUTUPUWHUVMWDKUYLVUSVURTUXOUXDUYKUVMUVJUURYSUWHUVOYQKUVHYQKVUSVULTUXOUWHU
      VOUXEYTUXOUVHUYJYTUVOUVHUUSYSUVAYSUVBUVCYRYRXGUVDUVE $.

    $d x X $.
    $( The defined function's value in the real.  (Contributed by Thierry
       Arnoux, 1-Apr-2017.) $)
    xrge0iifcv $p |- ( X e. ( 0 (,] 1 ) -> ( F ` X ) = -u ( log ` X ) ) $=
      ( cc0 c1 cioc co wcel cfv wceq cpnf clog cneg cif cicc cxr syl cr wbr clt
      iocssicc sseli cv eqeq1 fveq2 negeqd ifbieq2d pnfxr elexi negex fvmpt cle
      ifex wn w3a wb 0xr 1re elioc2 mp2an simp2bi gt0ne0d neneqd iffalse eqtrd
      ) CEFGHZIZCBJZCEKZLCMJZNZOZVLVHCEFPHZIVIVMKVGVNCEFUBUCACAUDZEKZLVOMJZNZOV
      MVNBVOCKZVPVJVRVLLVOCEUEVSVQVKVOCMUFUGUHDVJLVLLQUIUJVKUKUNULRVHVJUOVMVLKV
      HCEVHCVHCSIZECUATZCFUMTZEQIFSIVHVTWAWBUPUQURUSEFCUTVAVBVCVDVJLVLVERVF $.

    $d w x y z F $.  $d x X $.
    $( The defined bijection from the closed unit interval and the extended
       non-negative reals is an order isomorphism.  (Contributed by Thierry
       Arnoux, 31-Mar-2017.) $)
    xrge0iifiso $p |- F Isom < , `' < ( ( 0 [,] 1 ) , ( 0 [,] +oo ) ) $=
      ( vw vz cc0 c1 co clt cpnf wbr cfv cxr wceq wcel cle 1re cr wb crp wor cv
      cicc ccnv wpo wfo wral wiso wss iccssxr xrltso soss cnvso mpbi sopo ax-mp
      wi mp2 poss wf1o cneg ce cif cmpt xrge0iifcnv simpli f1ofo csn wo cun 0xr
      cioc rexri 0le1 snunioc mp3an eleq2i elun bitr3i wa elunitrn adantr simpr
      elsn 0re elicc2i simp3bi w3a elioc2 mp2an syl3anbrc clog cioo pnfxr ltpnf
      iocssioo mp4an ioorp sseqtri sseli relogcl renegcld brcnvg sylancr mpbird
      0le0 xrge0iifcv breqtrrd ex breq1 fveq2 0elunit iftrue elexi fvmpt syl6eq
      syl breq1d imbi12d syl5ibr sylbi simpll ad2antlr a1i rpred ad2antrr lttrd
      simp2bi relogcld adantl ltnegd logltb syl2an negex brcnv biimpd breqan12d
      jca 3bitr4d sylibrd sylc exp31 jaoi imp rgen2a soisoi ) FGUCHZIUAZFJUCHZI
      UDZUEZUUGUUIBUFZDUBZEUBZIKZUUMBLZUUNBLZUUJKZUQZEUUGUGDUUGUGUUGUUIIUUJBUHU
      UGMUIMIUAZUUHFGUJUKUUGMIULURUUIMUIMUUJUEZUUKFJUJMUUJUAZUVAUUTUVBUKMIUMUNM
      UUJUOUPUUIMUUJUSURUUGUUIBUTZUULUVCBUDEUUIUUNJNFUUNVAVBLVCVDNAEBCVEVFUUGUU
      IBVGUPUUSDEUUGUUMUUGOZUUNUUGOZUUSUVDUUMFVHZOZUUMFGVLHZOZVIZUVEUUSUQZUVDUU
      MUVFUVHVJZOUVJUVLUUGUUMFMOZGMOFGPKUVLUUGNVKGQVMVNFGVOVPVQUUMUVFUVHVRVSUVG
      UVKUVIUVGUUMFNZUVKDFWDUVEUUSUVNFUUNIKZJUUQUUJKZUQUVEUVOUVPUVEUVOVTZUUNUVH
      OZUVPUVQUUNROZUVOUUNGPKZUVRUVEUVSUVOUUNWAZWBUVEUVOWCUVEUVTUVOUVEUVSFUUNPK
      UVTFGUUNWEQWFWGZWBUVMGROZUVRUVSUVOUVTWHSVKQFGUUNWIWJZWKUVRJUUNWLLZVAZUUQU
      UJUVRUUNTOZJUWFUUJKZUVHTUUNUVHFJWMHZTUVMJMOZFFPKGJIKZUVHUWIUIVKWNXFUWCUWK
      QGWOUPFJFGWPWQWRWSZWTZUWGUWHUWFJIKZUWGUWFROZUWNUWGUWEUUNXAXBZUWFWOXQUWGUW
      JUWOUWHUWNSWNUWPJUWFMRIXCXDXEXQABUUNCXGZXHXQXIUVNUUOUVOUURUVPUUMFUUNIXJUV
      NUUPJUUQUUJUVNUUPFBLZJUUMFBXKFUUGOUWRJNXLAFAUBZFNZJUWSWLLVAZVCJUUGBUWTJUX
      AXMCJMWNXNXOUPXPXRXSXTYAUVIUVEUUOUURUVIUVEVTZUUOVTZUVIUVRVTZUUOUURUXCUVIU
      VRUVIUVEUUOYBUXCUVSUVOUVTUVRUVEUVSUVIUUOUWAYCZUXCFUUMUUNFROUXCWEYDUVIUUMR
      OZUVEUUOUVIUUMUVHTUUMUWLWTZYEYFUXEUVIFUUMIKZUVEUUOUVIUXFUXHUUMGPKZUVMUWCU
      VIUXFUXHUXIWHSVKQFGUUMWIWJYHYFUXBUUOWCZYGUVEUVTUVIUUOUWBYCUWDWKYRUXJUXDUU
      OUUMWLLZVAZUWFUUJKZUURUXDUUOUXMUXDUXKUWEIKZUWFUXLIKZUUOUXMUXDUXKUWEUXDUUM
      UVIUUMTOZUVRUXGWBYIUXDUUNUVRUWGUVIUWMYJYIYKUVIUXPUWGUUOUXNSUVRUXGUWMUUMUU
      NYLYMUXMUXOSUXDUXLUWFIUXKYNUWEYNYOYDYSYPUVIUVRUUPUXLUUQUWFUUJABUUMCXGUWQY
      QYTUUAUUBUUCYAUUDUUEDEUUGUUIIUUJBUUFWQ $.

    $d x u $.
    xrge0iifhmeo.k $e |- J = ( ( ordTop ` <_ ) |`t ( 0 [,] +oo ) ) $.
    $( Expose a homeomorphism from the closed unit interval and the extended
       non-negative reals.  (Contributed by Thierry Arnoux, 1-Apr-2017.) $)
    xrge0iifhmeo $p |- F e. ( II Homeo J ) $=
      ( cle cc0 co cordt cfv cpnf chmeo cvv wcel wiso cps cxr mp2an mpbi cdm vy
      c1 cicc cxp cin ccnv ctsr letsr tsrps ax-mp elexi inex1 cnvps xrge0iifiso
      cii clt wss wb iccssxr gtiso isores1 isores2 wceq ledm psssdm eqcomi lern
      crn df-rn eqtri ordthmeo mp3an dfii5 crest iccss2 cnvordtrestixx eleqtrri
      cv oveq12i ) BFGUBUCHZVTUDZUEZIJZFUFZGKUCHZWEUDZUEZIJZLHZUOCLHWBMNWGMNVTW
      EWBWGBOZBWINFWAFPFUGNFPNZUHFUIUJZUKULWDWFWDPWKWDPNZWLFUMUJZUKULVTWEWBWDBO
      ZWJVTWEFWDBOZWOVTWEUPUPUFBOZWPABDUNVTQUQZWEQUQZWQWPURGUBUSZGKUSZVTWEBUTRS
      VTWEFWDBVASVTWEWBWDBVBSWBWGBMMVTWEWBTZVTWKWRXBVTVCWLWTVTFQVDVERVFWGTZWEWM
      WSXCWEVCWNXAWEWDQQFVHWDTVGFVIVJVERVFVKVLUOWCCWHLVMCFIJWEVNHWHEAUAWEXAGKAV
      RUAVRVOVPVJVSVQ $.


    $d x Y $.
    $( The defined function from the closed unit interval and the extended
       non-negative reals is also a monoid homomorphism.  (Contributed by
       Thierry Arnoux, 5-Apr-2017.) $)
    xrge0iifhom $p |- ( ( X e. ( 0 [,] 1 ) /\ Y e. ( 0 [,] 1 ) ) ->
      ( F ` ( X x. Y ) ) = ( ( F ` X ) +e ( F ` Y ) ) ) $=
      ( cc0 c1 co wcel wceq cfv cxad cxr wbr cpnf cmnf cr sseldi cicc cioc cmul
      wo csn cun cle 0xr 1re rexri 0le1 snunioc mp3an eleq2i elun bitr3i orim1i
      elsni sylbi wa 0elunit cv clog cneg iftrue pnfxr elexi fvmpt ax-mp oveq2i
      cif wne eqeq1 fveq2 negeqd ifbieq2d ifex a1i wn elunitrn adantr elunitge0
      negex simpr neneqad ne0gt0d elrpd relogcld renegcld rexrd ifclda pnfnemnf
      eqeltrd neeq1 renemnfd ifbothda eqnetrd xaddpnf1 syl5eq cc unitsscn simpl
      syl2anc mul01d fveq2d syl6eq eqtr4d oveq2d 3eqtr4rd oveq1i xrge0iifcv crp
      cioo clt wss ltpnf iocssioo mp4an ioorp sseqtri sseli syl xaddpnf2 rpssre
      0le0 sstri ax-resscn mul02d oveq1d caddc rexadd oveqan12d remulcld rpgt0d
      rpred mulgt0d iocssicc iimulcl 0re recnd elicc2i simp3bi w3a elioc2 mp2an
      wb syl3anbrc relogmuld negdid 3eqtrd jaoian sylan jaodan sylan2 ) EHIUAJZ
      KZDUUOKZEHLZEHIUBJZKZUDZDEUCJZBMZDBMZEBMZNJZLZUUPEHUEZKZUUTUDZUVAUUPEUVHU
      USUFZKUVJUVKUUOEHOKZIOKHIUGPUVKUUOLUHIUIUJUKHIULUMZUNEUVHUUSUOUPUVIUURUUT
      EHURUQUSUUQUURUVGUUTUUQUURUTZUVDHBMZNJZDHUCJZBMZUVFUVCUVNUVPQUVRUVNUVPUVD
      QNJZQUVOQUVDNHUUOKUVOQLVAAHAVBZHLZQUVTVCMZVDZVKZQUUOBUWAQUWCVEFQOVFVGZVHV
      IZVJUVNUVDOKZUVDRVLZUVSQLUUQUWGUURUUQUVDDHLZQDVCMZVDZVKZOADUWDUWLUUOBUVTD
      LZUWAUWIUWCUWKQUVTDHVMUWMUWBUWJUVTDVCVNVOVPFUWIQUWKUWEUWJWCVQVHZUUQUWIQUW
      KOQOKZUUQUWIUTZVFVRUUQUWIVSZUTZUWKUWRUWJUWRDUWRDUUQDSKUWQDVTWAZUWRDUWSUUQ
      HDUGPUWQDWBWAUWRDHUUQUWQWDWEWFWGWHWIZWJWKWMWAUUQUWHUURUUQUVDUWLRUWNUWIQRV
      LZUWKRVLUWLRVLUUQQUWKQUWLRWNUWKUWLRWNUXAUWPWLVRUWRUWKUWTWOWPWQWAUVDWRXCWS
      UVNUVRUVOQUVNUVQHBUVNDUVNUUOWTDXAUUQUURXBTXDXEUWFXFXGUVNUVEUVOUVDNUVNEHBU
      UQUURWDZXEXHUVNUVBUVQBUVNEHDUCUXBXHXEXIUUQUWIDUUSKZUDZUUTUVGUUQDUVHKZUXCU
      DZUXDUUQDUVKKUXFUVKUUODUVMUNDUVHUUSUOUPUXEUWIUXCDHURUQUSUWIUUTUVGUXCUWIUU
      TUTZUVOUVENJZHEUCJZBMZUVFUVCUXGUXHQUXJUXGUXHQUVENJZQUVOQUVENUWFXJUXGUVEOK
      ZUVERVLZUXKQLUXGUUTUXLUWIUUTWDZUUTUVEUUTUVEEVCMZVDZSABEFXKZUUTUXOUUTEUUSX
      LEUUSHQXMJZXLUVLUWOHHUGPIQXNPZUUSUXRXOUHVFYEISKZUXSUIIXPVIHQHIXQXRXSXTZYA
      WHWIWMZWJYBUXGUUTUXMUXNUUTUVEUYBWOYBUVEYCXCWSUXGUXJUVOQUXGUXIHBUXGEUXGUUS
      WTEUUSSWTUUSXLSUYAYDYFYGYFUXNTYHXEUWFXFXGUXGUVDUVOUVENUXGDHBUWIUUTXBZXEYI
      UXGUVBUXIBUXGDHEUCUYCYIXEXIUXCUUTUTZUWKUXPNJZUWKUXPYJJZUVFUVCUYDUWKSKUXPS
      KUYEUYFLUYDUWJUYDDUYDUUSXLDUYAUXCUUTXBZTZWHZWIUYDUXOUYDEUYDUUSXLEUYAUXCUU
      TWDZTZWHZWIUWKUXPYKXCUXCUUTUVDUWKUVEUXPNABDFXKUXQYLUYDUVCUVBVCMZVDZUWJUXO
      YJJZVDUYFUYDUVBUUSKZUVCUYNLUYDUVBSKZHUVBXNPZUVBIUGPZUYPUYDDEUYDDUYHYOZUYD
      EUYKYOZYMUYDDEUYTVUAUYDDUYHYNUYDEUYKYNYPUYDUVBUUOKZUYSUYDUUQUUPVUBUYDUUSU
      UODHIYQZUYGTUYDUUSUUOEVUCUYJTDEYRXCVUBUYQHUVBUGPUYSHIUVBYSUIUUAUUBYBUVLUX
      TUYPUYQUYRUYSUUCUUFUHUIHIUVBUUDUUEUUGABUVBFXKYBUYDUYMUYOUYDDEUYHUYKUUHVOU
      YDUWJUXOUYDUWJUYIYTUYDUXOUYLYTUUIUUJXIUUKUULUUMUUN $.

    $( Condition for the defined function, ` -u ( log `` x ) ` to be a monoid
       homomorphism.  (Contributed by Thierry Arnoux, 20-Jun-2017.) $)
    xrge0iif1 $p |- ( F ` 1 ) = 0 $=
      ( c1 cc0 cicc co wcel cfv wceq 1elunit cv cpnf clog cneg cif wn wne neeq1
      ax-1ne0 mpbiri neneqd iffalse syl fveq2 negeqd log1 negeqi neg0 eqtri a1i
      3eqtrd c0ex fvmpt ax-mp ) FGFHIZJFBKGLMAFANZGLZOUSPKZQZRZGURBUSFLZVCVBFPK
      ZQZGVDUTSVCVBLVDUSGVDUSGTFGTUBUSFGUAUCUDUTOVBUEUFVDVAVEUSFPUGUHVFGLVDVFGQ
      GVEGUIUJUKULUMUNDUOUPUQ $.

    $( The defined function from the closed unit interval and the extended
       non-negative reals is a monoid homomorphism.  (Contributed by Thierry
       Arnoux, 21-Jun-2017.) $)
    xrge0iifmhm $p |- F e. ( ( ( mulGrp ` CCfld ) |`s ( 0 [,] 1 ) )
                                         MndHom ( RR*s |`s ( 0 [,] +oo ) ) ) $=
      ( vy vz ccnfld cfv cc0 c1 cicc co cress wcel cmul wceq ax-mp cc cvv wa wf
      cmgp cxrs cpnf cmhm cmnd cv cxad wral ctmd eqid iistmd tmdmnd ccmn cmnmnd
      w3a xrge0cmn pm3.2i wf1o ccnv cneg ce cmpt xrge0iifcnv simpli xrge0iifhom
      cif rgen2a xrge0iif1 3pm3.2i wss cbs unitsscn cnfldbas ressbas2 xrge0base
      f1of mgpbas cnfldex ovex mgpress mp2an cmulr cnfldmul ressmulr xrge0plusg
      mgpplusg crg c0g cnrng 1elunit cnfld1 rngidss mp3an xrge00 ismhm mpbir2an
      ) BHUCIZJKLMZNMZUDJUELMZNMZUFMOXAUGOZXCUGOZUAWTXBBUBZFUHZGUHZPMBIXGBIXHBI
      UIMQZGWTUJFWTUJZKBIJQZUQXDXEXAUKOXDXAXAULZUMXAUNRXCUOOXEURXCUPRUSXFXJXKWT
      XBBUTZXFXMBVAFXBXGUEQJXGVBVCIVHVDQAFBDVEVFWTXBBVRRXIFGWTABCXGXHDEVGVIABCD
      EVJVKFGWTXBPUIXAXCBJKWTSVLZWTXAVMIQVNWTSXAWSXLSHWSWSULZVOVSVPRVQHWTNMZPXA
      HTOWTTOZXAXPUCIQVTJKLWAZWTHXPWSTTXPULZXOWBWCXQPXPWDIQXRWTHXPPTXSWEWFRWHWG
      HWIOXNKWTOKXAWJIQWKVNWLWTSHKXAXLVOWMWNWOWPWQWR $.

    $d x v $.  $d a b .+ $.  $d u v .+ $.  $d u v F $.
    xrge0pluscn.1 $e |- .+ = ( +e |` ( ( 0 [,] +oo ) X. ( 0 [,] +oo ) ) ) $.
    $( The addition operation of the extended non-negative real numbers monoid
       is continuous.  (Contributed by Thierry Arnoux, 24-Mar-2017.) $)
    xrge0pluscn $p   |- .+ e. ( ( J tX J ) Cn J ) $=
      ( vu vv cc0 co cmul cii wf wcel cc cxad cxr cfv ccnfld va vb vy cicc cpnf
      c1 cxp cres xrge0iifhmeo wfn cv wral wss unitsscn xpss12 mp2an wb ax-mulf
      ffn fnssresb mpbir wa ovres iimulcl eqeltrd rgen2a ffnov mpbir2an iccssxr
      mp2b xaddf fneq1i oveqi ge0xaddcl syl5eqel iitopon cle cordt crest ctopon
      letopon resttopon eqeltri wceq wf1o ccnv cneg cif cmpt xrge0iifcnv simpli
      f1of ax-mp ffvelrni syl2an syl5eq xrge0iifhom eqcomd fveq2d 3eqtr2rd cmgp
      ce cress ctmd ctx ccn eqid iistmd cvv cnfldex ovex mgpress mgptopn cplusf
      dfii4 cnfldbas mgpbas cnfldmul mgpplusg ressplusf eqcomi tmdcn mndpluscn
      ) HIJUFUDKZJUEUDKZLYDYDUGZUHZCBMDACDEFUIYFYDYGNYGYFUJZHUKZIUKZYGKZYDOZIYD
      ULHYDULYHYFPPUGZUMZYDPUMZYOYNUNUNYDPYDPUOUPYMPLNZLYMUJZYHYNUQURYMPLUSZYMY
      FLUTVJVAYLHIYDYIYDOZYJYDOZVBZYKYIYJLKZYDYIYJYDYDLVCZYIYJVDVEVFHIYDYDYDYGV
      GVHYEYEUGZYEBNBUUDUJZUAUKZUBUKZBKZYEOZUBYEULUAYEULUUEQUUDUHZUUDUJZUUKUUDR
      RUGZUMZYERUMZUUNUUMJUEVIZUUOYERYERUOUPUULRQNQUULUJUUKUUMUQVKUULRQUSUULUUD
      QUTVJVAUUDBUUJGVLVAUUIUAUBYEUUFYEOUUGYEOVBZUUHUUFUUGUUJKZYEBUUJUUFUUGGVMU
      UPUUQUUFUUGQKYEUUFUUGYEYEQVCUUFUUGVNVEVOVFUAUBYEYEYEBVGVHVPDVQVRSZYEVSKZY
      EVTSZFUURRVTSOUUNUUSUUTOWAUUOYEUURRWBUPWCUUAYICSZYJCSZBKZUVAUVBQKZUUBCSYK
      CSUUAUVCUVAUVBUUJKZUVDBUUJUVAUVBGVMYSUVAYEOUVBYEOUVEUVDWDYTYDYEYICYDYECWE
      ZYDYECNUVFCWFUCYEUCUKZUEWDJUVGWGXBSWHWIWDAUCCEWJWKYDYECWLWMZWNYDYEYJCUVHW
      NUVAUVBYEYEQVCWOWPACDYIYJEFWQUUAUUBYKCUUAYKUUBUUCWRWSWTTXASZYDXCKZXDOYGMM
      XEKMXFKOUVJUVJXGZXHYGUVJMTYDXCKZMUVJTXIOYDXIOUVJUVLXASWDXJJUFUDXKYDTUVLUV
      IXIXIUVLXGZUVIXGZXLUPUVLUVMXOXMUVJXNSYGYDPLUVIUVJPTUVIUVNXPXQUVKTLUVIUVNX
      RXSYPYQURYRWMUNXTYAYBWMYC $.
  $}

  ${
    $d x y C $.
    xrge0mulc1cn.k $e |- J = ( ( ordTop ` <_ ) |`t ( 0 [,] +oo ) ) $.
    xrge0mulc1cn.f $e |- F = ( x e. ( 0 [,] +oo ) |-> ( x *e C ) ) $.
    xrge0mulc1cn.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
    $( The operation multiplying a non-negative real numbers by a non-negative
       constant is continuous.  (Contributed by Thierry Arnoux, 6-Jul-2017.) $)
    xrge0mulc1cn $p |- ( ph -> F e. ( J Cn J ) ) $=
      ( vy cc0 wceq ccn co wcel cpnf cfv cxr a1i cxmu crp cioo ctopon csn cordt
      cicc wf cle crest wss letopon iccssxr resttopon mp2an eqeltri pnfxr pnfge
      wbr 0xr ax-mp lbicc2 mp3an cxp cv wa simpl oveq2d simpr sseldi xmul01 syl
      cmpt eqtrd mpteq2dva fconstmpt 3eqtr4g c0ex fconst2 sylibr cnconst adantl
      syl22anc cres eqid oveq1 cbvmptv xrmulc1cn letopuni cnrest sylancl resmpt
      id eqtr4i eqcomi oveq1i 3eltr3g ioorp ioossicc eqsstr3i ge0xmulcl syl2anc
      crn wb fmptd frn cnrest2 syl3anc mpbid oveq2i syl6eleqr eleq2s cico wo cr
      clt 0re ltpnf elicoelioo sylib mpjaodan ) ACJKZDEELMZNZCJOUAMZNZXTYBAXTEJ
      OUEMZUBPZNZYGJYENZYEJUCZDUFZYBYGXTEUGUDPZYEUHMZYFFYKQUBPNZYEQUIZYLYFNUJJO
      UKZYEYKQULUMUNRZYPYHXTJQNZOQNZJOUGUQZYHURUOYQYSURJUPUSJOUTVARXTDYEYIVBZKY
      JXTBYEBVCZCSMZVKZBYEJVKDYTXTBYEUUBJXTUUAYENZVDZUUBUUAJSMZJUUECJUUASXTUUDV
      EVFUUEUUAQNUUFJKUUEYEQUUAYOXTUUDVGVHUUAVIVJVLVMGBYEJVNVOYEJDVPVQVRJDEEYEY
      EVSWAVTYDYBAYBCTYCCTNZDEYLLMZYAUUGDEYKLMZNZDUUHNZUUGBQUUBVKZYEWBZYLYKLMZD
      UUIUUGUULYKYKLMNYNUUMUUNNUUGICUULYKYKWCBIQUUBIVCZCSMUUAUUOCSWDWEUUGWKWFYO
      YEUULYKYKQWGWHWIUUMUUCDYNUUMUUCKYOBQYEUUBWJUSGWLYLEYKLEYLFWMWNWOUUGYMDXAY
      EUIZYNUUJUUKXBYMUUGUJRUUGYEYEDUFUUPUUGBYEUUBYEDUUGUUDVDZUUDCYENUUBYENUUGU
      UDVGUUQTYECTYCYEWPJOWQWRUUGUUDVEVHUUACWSWTGXCYEYEDXDVJYNUUGYORYEDEYKQXEXF
      XGEYLELFXHXIWPXJVTACJOXKMNZXTYDXLZHYQYRJOXNUQZUURUUSXBURUOJXMNUUTXOJXPUSJ
      OCXQVAXRXS $.
  $}

  $( The extended non-negative real numbers monoid forms a topological space.
     (Contributed by Thierry Arnoux, 19-Jun-2017.) $)
  xrge0tps $p |- ( RR*s |`s ( 0 [,] +oo ) ) e. TopSp $=
    ( cxrs ctps wcel cc0 cpnf cicc co cvv cress xrstps ovex resstps mp2an ) ABC
    DEFGZHCANIGBCJDEFKNAHLM $.

  $( The topology of the extended non-negative real numbers.  (Contributed by
     Thierry Arnoux, 20-Jun-2017.) $)
  xrge0topn $p |- ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) =
                                       ( ( ordTop ` <_ ) |`t ( 0 [,] +oo ) ) $=
    ( cle cordt cfv cc0 cpnf cicc co crest cxrs cress ctopn eqid xrstopn eqcomi
    resstopn ) ABCZDEFGZHGIQJGZKCQRPIRLMON $.

  $( The topology of the extended non-negative real numbers is Hausdorff.
     (Contributed by Thierry Arnoux, 26-Jul-2017.) $)
  xrge0haus $p |- ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) e. Haus $=
    ( cxrs cc0 cpnf cicc cress ctopn cfv cle cordt crest cha xrge0topn wcel cvv
    co xrhaus ovex resthaus mp2an eqeltri ) ABCDOZEOFGHIGZUAJOZKLUBKMUANMUCKMPB
    CDQUAUBNRST $.

  ${
    $d x y $.
    $( The extended non-negative real numbers monoid is a topological monoid.
       (Contributed by Thierry Arnoux, 26-Mar-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    xrge0tmdOLD $p |- ( RR*s |`s ( 0 [,] +oo ) ) e. TopMnd $=
      ( vx vy cxrs cc0 cpnf cicc co wcel cxad cxp cfv ax-mp wceq clog cneg eqid
      cv cif cxr cvv cress ctmd cmnd ctps cres cle cordt crest ctx ccn xrge0cmn
      ccmn cmnmnd xrge0tps cmpt eqeq1 fveq2 negeqd ifbieq2d cbvmptv xrge0pluscn
      c1 cplusf xrsbas xrsadd wf wfn ffn iccssxr ressplusf eqcomi xrge0base cts
      xaddf ovex xrstset resstset topnval istmd mpbir3an ) CDEFGZUAGZUBHWBUCHZW
      BUDHIWAWAJUEZUFUGKZWAUHGZWFUIGWFUJGHWBULHWCUKWBUMLUNAWDBDVBFGZBQZDMZEWHNK
      ZOZRZUOWFBAWGWLAQZDMZEWMNKZOZRWHWMMZWIWNWKWPEWHWMDUPWQWJWOWHWMNUQURUSUTWF
      PWDPVAWDWBWFWBVCKWDWASICWBVDWBPZVESSJZSIVFIWSVGVNWSSIVHLDEVIVJVKWAWEWBVLW
      ATHWEWBVMKMDEFVOWACWBWETWRVPVQLVRVSVT $.
  $}

  ${
    $d x y $.
    $( The extended non-negative real numbers monoid is a topological monoid.
       (Contributed by Thierry Arnoux, 26-Mar-2017.)  (Proof Shortened by
       Thierry Arnoux, 21-Jun-2017.) $)
    xrge0tmd $p |- ( RR*s |`s ( 0 [,] +oo ) ) e. TopMnd $=
      ( vx vy ccnfld cmgp cfv cc0 c1 cicc co cress cpnf cv wceq clog cneg chmeo
      cif cii cvv eqid cxrs cmpt ctopn nfcv eqeq1 fveq2 negeqd cbvmpt xrge0topn
      ifbieq2d xrge0iifmhm xrge0iifhmeo wcel cnfldex ovex mgpress mp2an mgptopn
      dfii4 oveq1i eleqtri iistmd xrge0tps mhmhmeotmd ) CDEZFGHIZJIZUAFKHIJIZAV
      FALZFMZKVINEZOZQZUBZBVNVHUCEZABVFVMBLZFMZKVPNEZOZQZBVMUDAVTUDVIVPMZVJVQVL
      VSKVIVPFUEWAVKVRVIVPNUFUGUJUHZUIUKVNRVOPIVGUCEZVOPIBVNVOWBUIULRWCVOPCVFJI
      ZRVGCSUMVFSUMVGWDDEMUNFGHUOVFCWDVESSWDTZVETUPUQWDWEUSURUTVAVGVGTVBVCVD $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Limits - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    lmlim.j $e |- J e. ( TopOn ` Y ) $.
    lmlim.f $e |- ( ph -> F : NN --> X ) $.
    lmlim.p $e |- ( ph -> P e. X ) $.
    lmlim.t $e |- ( J |`t X ) = ( ( TopOpen ` CCfld ) |`t X ) $.
    lmlim.x $e |- X C_ CC $.
    $( Relate a limit in a given topology to a complex number limit, provided
       that topology agrees with the common topology on ` CC ` on the required
       subset.  (Contributed by Thierry Arnoux, 11-Jul-2017.) $)
    lmlim $p |- ( ph -> ( F ( ~~>t ` J ) P <-> F ~~> P ) ) $=
      ( clm cfv wbr c1 cvv cn cc wcel a1i crest ccnfld ctopn cli eqid nnuz cnex
      co wss ssexd ctop topontopi cz 1z wb fveq2i breqi cnfldtop wf fss sylancl
      lmss lmclimf sylancr bitr3d 3bitrd ) ACBDLMNCBDEUAUHZLMZNZCBUBUCMZEUAUHZL
      MZNZCBUDNZABCDVGOPEQVGUEUFAERPRPSAUGTERUIZAKTUJZDUKSAFDGULTIOUMSZAUNTZHVB
      VIVMUOACBVHVLVGVKLJUPUQTACBVJLMNZVMVNABCVJVKOPEQVKUEUFVPVJUKSAVJVJUEZURTI
      VRHVBAVQQRCUSZVSVNUOUNAQECUSVOWAHKQERCUTVABCVJOQVTUFVCVDVEVF $.
  $}

  ${
    lmlimxrge0.j $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    lmlimxrge0.f $e |- ( ph -> F : NN --> X ) $.
    lmlimxrge0.p $e |- ( ph -> P e. X ) $.
    lmlimxrge0.x $e |- X C_ ( 0 [,) +oo ) $.
    $( Relate a limit in the non-negative extended reals to a complex limit,
       provided the considered function is a real function.  (Contributed by
       Thierry Arnoux, 11-Jul-2017.) $)
    lmlimxrge0 $p |- ( ph -> ( F ( ~~>t ` J ) P <-> F ~~> P ) ) $=
      ( cc0 cpnf co cfv crest cxr wcel wss cvv sstri cr cicc cordt ctopon cress
      cxrs ctopn xrge0topn eqtri letopon iccssxr resttopon mp2an eqeltri ccnfld
      wceq elexi cico icossicc ovex restabs mp3an oveq1i rge0ssre xrrest2 ax-mp
      cle eqid 3eqtr4i cc ax-resscn lmlim ) ABCDEJKUALZDVFUBMZVLNLZVLUCMZDUEVLU
      DLUFMVNFUGUHZVMOUCMZPVLOQVNVOPUIJKUJVLVMOUKULUMGHVNENLZVMENLZDENLUNUFMZEN
      LZVMRPEVLQVLRPVRVSUOVMVQUIUPEJKUQLZVLIJKURSJKUAUSEVLVMRRUTVADVNENVPVBETQW
      AVSUOEWBTIVCSZEVTVMVTVGVMVGVDVEVHETVIWCVJSVK $.
  $}

  ${
    $d j k x z F $.
    $( Implication of convergence for a non-negative series.  This could be
       used to shorten ~ prmreclem6 (Contributed by Thierry Arnoux,
       28-Jul-2017.) $)
    rge0scvg $p |- ( ( F : NN --> ( 0 [,) +oo ) /\ seq 1 ( + , F ) e. dom ~~> )
      -> sup ( ran seq 1 ( + , F ) , RR , < ) e. RR ) $=
      ( vz vx vj vk cn wf c1 cli wcel wa cr c0 cv cle wbr wral nnuz adantr cfv
      cc0 cpnf cico co caddc cseq cdm crn wss wne wrex clt csup cz a1i rge0ssre
      1z fss mpan2 ffvelrnda serfre frn syl 1nn syl5eleqr ne0i dm0rn0 necon3bii
      fdm sylib 3syl climdm biimpi adantl climrecl simpr simplll ffvelrn sseldi
      syl2anc elrege0 simprbi adantlr climserle ralrimiva wceq breq2 ralbidv wb
      rspcev wfn ffn breq1 ralrn rexbidv mpbird suprcl syl3anc ) FUAUBUCUDZAGZU
      EAHUFZIUGJZKZXAUHZLUIZXDMUJZBNZCNZOPZBXDQZCLUKZXDLULUMLJWTXEXBWTFLXAGZXEW
      TDAHFRHUNJZWTUQUOWTFLDNZAWTWSLUIFLAGUPFWSLAURUSUTVAZFLXAVBVCSWTXFXBWTXLHX
      AUGZJZXFXOXLHFXPVDFLXAVIVEXQXPMUJXFXPHVFXPMXDMXAVGVHVJVKSXCXKENZXATZXHOPZ
      EFQZCLUKZXCXAITZLJXSYCOPZEFQZYBXCYCEXAHFRXMXCUQUOXBXAYCIPZWTXBYFXAVLVMVNZ
      XCFLXRXAWTXLXBXOSUTVOXCYDEFXCXRFJZKZYCDAHXRFRXCYHVPXCYFYHYGSYIXNFJZKWTYJX
      NATZLJZWTXBYHYJVQYIYJVPWTYJKZWSLYKUPFWSXNAVRZVSVTXCYJUAYKOPZYHWTYJYOXBYMY
      KWSJZYOYNYPYLYOYKWAWBVCWCWCWDWEYAYECYCLXHYCWFXTYDEFXHYCXSOWGWHWJVTWTXKYBW
      IXBWTXJYACLWTXLXAFWKXJYAWIXOFLXAWLXIXTBEFXAXGXSXHOWMWNVKWOSWPCBXDWQWR $.
  $}

  ${
    $d k F $.  $d k M $.  $d k S $.  $d k ph $.
    fsumcvg4.s $e |- S = ( ZZ>= ` M ) $.
    fsumcvg4.m $e |- ( ph -> M e. ZZ ) $.
    fsumcvg4.c $e |- ( ph -> F : S --> CC ) $.
    fsumcvg4.f $e |- ( ph -> ( `' F " ( CC \ { 0 } ) ) e. Fin ) $.
    $( A serie with finite support is a finite sum, and therefore converges.
       (Contributed by Thierry Arnoux, 6-Sep-2017.) $)
    fsumcvg4 $p |- ( ph -> seq M ( + , F ) e. dom ~~> ) $=
      ( vk cc cc0 cdif cima wceq 3syl syl wcel wa wo eqid ccnv csn cv wfun ffun
      cfv wf difpreima difss syl6eqss fimacnv sseqtrd wn cif exmidd biantru a1i
      wb wne crab cvv ffs2 wfn fnniniseg2 eqtr3d eleq2d rabid syl6bb necon2bbid
      baibd biimprd pm4.71d orbi12d mpbid eqif sylibr sselda ffvelrnda fsumcvg3
      ffn syldan ) ACUAZJKUBZLZMZIUCZCUFZICDBEFHAWEWBJMZBAWEWHWBWCMZLZWHABJCUGZ
      CUDWEWJNGBJCUEJWCCUHOWHWIUIUJAWKWHBNGBJCUKPULZAWFBQZRZWFWEQZWGWGNZRZWOUMZ
      WGKNZRZSZWGWOWGKUNNWNWOWRSXAWNWOUOWNWOWQWRWTWOWQURWNWPWOWGTUPUQWNWRWSWNWS
      WRWNWOWGKAWOWMWGKUSZAWOWFXBIBUTZQWMXBRAWEXCWFAWBVAWCLMZWEXCAWKXDWENGBJWDC
      KWDTVBPAWKCBVCXDXCNGBJCVTIBKCVDOVEVFXBIBVGVHVJVIVKVLVMVNWOWGWGKVOVPAWOWMW
      GJQAWEBWFWLVQABJWFCGVRWAVS $.
  $}

  ${
    $d x y A $.  $d y J $.
    pnfneige0.j $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    $( A neighborhood of ` +oo ` contains an unbounded interval based at a real
       number.  See ~ pnfnei (Contributed by Thierry Arnoux, 31-Jul-2017.) $)
    pnfneige0 $p |- ( ( A e. J /\ +oo e. A ) ->
      E. x e. RR ( x (,] +oo ) C_ A ) $=
      ( vy wcel cpnf wa cioc co cc0 cin wss cr a1i wceq cxr cfv ctop cvv cv clt
      wrex wbr cif 0re wn simpllr ifclda rexr 0xr iocinif syl3anc ovif syl6reqr
      pnfxr ad2antlr cicc iocssicc sslin mp1i simpr ssin biimpri simpld ssinss1
      3syl sstrd eqsstrd oveq1 sseq1d rspcev syl2anc cordt crest ctopon letopon
      iccssxr resttopon mp2an topontopi ovex cress ctopn xrge0topn eqtri eleq2i
      cxrs biimpi elrestr letop restabs mp3an syl6eleq wb iocpnfordt ssid inss2
      restopnb syl23anc mpbird adantr ltpnf ubioc1 elin sylanbrc pnfnei r19.29a
      cle ax-mp ) BCFZGBFZHZEUAZGIJZBKGIJZLZMZAUAZGIJZBMZANUCZENXMXNNFZHZXRHZXN
      KUBUDZKXNUEZNFYGGIJZBMZYBYEYFKXNNKNFZYEYFHUFOXMYCXRYFUGUHUIYEYHXOXPLZBYCY
      HYKPXMXRYCYKYFXPXOUEZYHYCXNQFKQFZGQFZYKYLPXNUJYMYCUKOYNYCUPOXNKGULUMYFKXN
      GIUNUOUQYEYKXOKGURJZLZBXPYOMZYKYPMYEKGUSZXPYOXOUTVAYEXRXOBMZYPBMYDXRVBXRY
      SXOXPMZYSYTHXRXOBXPVCVDVEXOYOBVFVGVHVIYAYIAYGNXSYGPXTYHBXSYGGIVJVKVLVMXMX
      QXIVNRZFZGXQFZXRENUCXKUUBXLXKUUBXQUUAXPVOJZFZXKXQUUAYOVOJZXPVOJZUUDXKUUFS
      FZXPTFZBUUFFZXQUUGFUUHXKYOUUFUUAQVPRFYOQMUUFYOVPRFVQKGVRYOUUAQVSVTWAOUUIX
      KKGIWBOZXKUUJCUUFBCWHYOWCJWDRUUFDWEWFWGWIBXPUUFSTWJUMUUASFZYQYOTFUUGUUDPW
      KYRKGURWBXPYOUUASTWLWMWNXKUULUUIXPUUAFZXPXPMZXQXPMZUUBUUEWOUULXKWKOUUKUUM
      XKKWPOUUNXKXPWQOUUOXKBXPWROXPXPXQUUATWSWTXAXBXMXLGXPFZUUCXKXLVBUUPXMYMYNK
      GUBUDZUUPUKUPYJUUQUFKXCXJKGXDWMOGBXPXEXFEXQXGVMXH $.
  $}

  ${
    $d a j l x A $.  $d a j k l x F $.  $d a k l x J $.  $d a k l x ph $.
    lmxrge0.j $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    lmxrge0.6 $e |- ( ph -> F : NN --> ( 0 [,] +oo ) ) $.
    lmxrge0.7 $e |- ( ( ph /\ k e. NN ) -> ( F ` k ) = A ) $.
    $( Express "sequence ` F ` converges to plus infinity" (i.e. diverges), for
       a sequence of non-negative extended real numbers.  (Contributed by
       Thierry Arnoux, 2-Aug-2017.) $)
    lmxrge0 $p |- ( ph -> ( F ( ~~>t ` J ) +oo <-> A. x e. RR E. j e. NN
      A. k e. ( ZZ>= ` j ) x < A ) ) $=
      ( vl cpnf cfv wbr wcel cn cr cc0 wa cxr va clm cv cuz wral wrex wi clt co
      cicc ctopon cle cordt crest cxrs cress ctopn eqid xrstopn resstopn eqtr4i
      c1 wss letopon iccssxr resttopon mp2an eqeltri a1i nnuz cz 1z lmbrf pnfxr
      0xr pnfge ax-mp ubicc2 mp3an biantrur syl6bbr cioc cin rexr ltpnf syl3anc
      ubioc1 0re jctir elin sylibr ad2antlr ctop letop iocpnfordt inopn elrestr
      ovex wceq inss2 iocssicc sstri sseqin2 mpbi incom eqtr3i 3eltr4i wb eleq2
      cvv adantl biimprd simp-5r rexrd simpr simp-4r eleqtrd simplbi syl elioc1
      w3a mpan2 biimpa simp2d syl2anc ralimdva reximdva raleqdv cbvrexv syl6ibr
      ex fveq2 imim12d rspcimdv imp mpd ralrimdva simpllr simplr sseldd simplll
      pnfneige0 r19.29r simp-4l uznnssnn jca ffvelrnda eqeltrrd sseldi ad2antrr
      biimpar syl13anc adantlr syl21anc syl5bi expimpd rexlimdva syl12anc exp31
      syl5 impbid bitrd ) AFLGUBMNZLUAUCZOZCUVDOZEKUCZUDMZUEZKPUFZUGZUAGUEZBUCZ
      CUHNZEDUCZUDMZUEZDPUFZBQUEZAUVCLRLUJUIZOZUVLSUVLAUACLKEFGVBUVTPGUVTUKMZOA
      GULUMMZUVTUNUIZUWBGUOUVTUPUIZUQMUWDHUVTUWEUWCUOUWEURUSUTVAZUWCTUKMOUVTTVC
      UWDUWBOVDRLVEZUVTUWCTVFVGVHVIVJVBVKOAVLVIIJVMUWAUVLRTOZLTOZRLULNZUWAVOVNU
      WHUWJVORVPVQRLVRVSVTWAAUVLUVSAUVLUVRBQAUVMQOZSZUVLUVRUWLUVLSLUVMLWBUIZRLW
      BUIZWCZOZUVRUWKUWPAUVLUWKLUWMOZLUWNOZSUWPUWKUWQUWRUWKUVMTOZUWIUVMLUHNUWQU
      VMWDUWIUWKVNVIUVMWEUVMLWGWFUWHUWIRLUHNZUWRVOVNRQOUWTWHRWEVQRLWGVSWILUWMUW
      NWJWKWLUWLUVLUWPUVRUGZUWLUVKUXAUAUWOGUWOGOUWLUWOUVTWCZUWDUWOGUWCWMOZUVTXJ
      OUWOUWCOZUXBUWDOWNRLUJWRUXCUWMUWCOUWNUWCOUXDWNUVMWORWOUWMUWNUWCWPVSUWOUVT
      UWCWMXJWQVSUVTUWOWCZUWOUXBUWOUVTVCUXEUWOWSUWOUWNUVTUWMUWNWTRLXAXBUWOUVTXC
      XDUVTUWOXEXFUWFXGVIUWLUVDUWOWSZSZUWPUVEUVJUVRUXGUVEUWPUXFUVEUWPXHUWLUVDUW
      OLXIXKXLUXGUVJUVNEUVHUEZKPUFZUVRUXGUVIUXHKPUXGUVGPOZSZUVFUVNEUVHUXKEUCZUV
      HOZSZUVFUVNUXNUVFSZUWSCUWMOZUVNUXOUVMAUWKUXFUXJUXMUVFXMXNUXOCUWOOZUXPUXOC
      UVDUWOUXNUVFXOUWLUXFUXJUXMUVFXPXQUXQUXPCUWNOCUWMUWNWJXRXSUWSUXPSCTOZUVNCL
      ULNZUWSUXPUXRUVNUXSYAZUWSUWIUXPUXTXHVNUVMLCXTYBZYCYDYEYKYFYGUVQUXHDKPUVOU
      VGWSUVNEUVPUVHUVOUVGUDYLYHYIZYJYMYNYOYPYKYQAUVSUVKUAGAUVDGOZSZUVSUVEUVJUY
      DUVSSZUVESZAUWMUVDVCZBQUFZUVSUVJAUYCUVSUVEUUAUYFUYCUVEUYHAUYCUVSUVEYRUYEU
      VEXOBUVDGHUUBYEUYDUVSUVEYSAUYHUVSSZUVJUYIUYGUVRSZBQUFAUVJUYGUVRBQUUCAUYJU
      VJBQUWLUYGUVRUVJUVRUXIUWLUYGSZUVJUYBUYKUXHUVIKPUYKUXJSZUVNUVFEUVHUYLUXMSZ
      AUXLPOZSZUWKUYGUVNUVFUGUYMAUYNAUWKUYGUXJUXMUUDUYMUVHPUXLUXJUVHPVCUYKUXMUV
      GUUEWLUYLUXMXOYTUUFAUWKUYGUXJUXMXPUWLUYGUXJUXMYRUYOUWKSZUYGSZUVNUVFUYQUVN
      SUWMUVDCUYPUYGUVNYSUYPUVNUXPUYGUYPUVNSZUWSUXRUVNUXSUXPUYRUVMUYOUWKUVNYSXN
      UYOUXRUWKUVNUYOUVTTCUWGUYOUXLFMCUVTJAPUVTUXLFIUUGUUHUUIUUJZUYPUVNXOUYRUXR
      UXSUYSCVPXSUWSUXPUXTUYAUUKUULUUMYTYKUUNYFYGUUOUUPUUQUUTYOUURUUSYQUVAUVB
      $.
  $}

  ${
    $d j k l x F $.  $d j k l x ph $.
    lmdvg.1 $e |- ( ph -> F : NN --> ( 0 [,) +oo ) ) $.
    lmdvg.2 $e |- ( ( ph /\ k e. NN ) -> ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
    lmdvg.3 $e |- ( ph -> -. F e. dom ~~> ) $.
    $( If a monotonic sequence of real numbers diverges, it is unbounded.
       (Contributed by Thierry Arnoux, 4-Aug-2017.) $)
    lmdvg $p |- ( ph
               -> A. x e. RR E. j e. NN A. k e. ( ZZ>= ` j ) x < ( F ` k ) ) $=
      ( vl cfv wbr wral cn cr wcel wa cle c1 co simpr cv clt cuz wn cli cdm crn
      wrex csup nnuz cz 1z a1i wf cc0 cpnf cico wss rge0ssre fss sylancl adantr
      caddc ralrimiva fveq2 oveq1 fveq2d breq12d cbvralv sylib r19.21bi adantlr
      wceq breq1d rexbii climsup cvv nnex fex ltso supex breldmg syl3anc syldan
      mtand ralnex sylibr simplr ffvelrnda ltnled rexbidva rexnal syl6bb mpbird
      ralbidva ad2antrr ad3antrrr uznnssnn ad3antlr sseldd ffvelrnd simp-4l cfz
      simpllr fzssnn cmin simplll syl2anc monoord syl21anc ltletrd reximdva mpd
      ex ) ABUAZDUAZEJZUBKZDCUAZUCJZLZCMUHZBNAXONOZPZXOXSEJZUBKZCMUHZYBAYGBNAYG
      BNLYEXOQKZCMLZUDZBNLZAYIBNUHZUDYKAYLEUEUFOZHAYLEEUGZNUBUIZUEKZYMAYLPZBIER
      MUJRUKOYQULUMAMNEUNZYLAMUOUPUQSZEUNZYSNURYRFUSMYSNEUTVAZVBAIUAZMOZUUBEJZU
      UBRVCSZEJZQKZYLAUUGIMAXQXPRVCSZEJZQKZDMLUUGIMLAUUJDMGVDUUJUUGDIMXPUUBVMZX
      QUUDUUIUUFQXPUUBEVEUUKUUHUUEEXPUUBRVCVFVGVHVIVJVKZVLYQYLUUDXOQKZIMLZBNUHA
      YLTYIUUNBNYHUUMCIMXSUUBVMYEUUDXOQXSUUBEVEVNVIVOVJVPAYPPZEVQOZYOVQOZYPYMAU
      UPYPAYTMVQOUUPFVRMYSVQEVSVAVBUUQUUONYNUBVTWAUMAYPTEYOVQVQUEWBWCWDWEYIBNWF
      WGAYGYJBNYDYGYHUDZCMUHYJYDYFUURCMYDXSMOZPZXOYEAYCUUSWHZYDMNXSEAYRYCUUAVBZ
      WIZWJWKYHCMWLWMWOWNVKYDYFYACMUUTYFYAUUTYFPZXRDXTUVDXPXTOZPZXOYEXQUUTYCYFU
      VEUVAWPUUTYENOYFUVEUVCWPUVFMNXPEYDYRUUSYFUVEUVBWQUVFXTMXPUUSXTMURYDYFUVEX
      SWRWSUVDUVETZWTXAUUTYFUVEWHUVFAUUSUVEYEXQQKAYCUUSYFUVEXBYDUUSYFUVEXDUVGAU
      USPZUVEPZIEXSXPUVHUVETUVIUUBXSXPXCSZOZPZMNUUBEAYRUUSUVEUVKUUAWQUVLUVJMUUB
      UUSUVJMURAUVEUVKXSXPXEWSUVIUVKTWTXAUVIUUBXSXPRXFSZXCSZOZPZAUUCUUGAUUSUVEU
      VOXGUVPUVNMUUBUUSUVNMURAUVEUVOXSUVMXEWSUVIUVOTWTUULXHXIXJXKVDXNXLXMVD $.
  $}

  ${
    $d j k x F $.  $d k x J $.  $d j k x ph $.
    lmdvglim.j $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    lmdvglim.1 $e |- ( ph -> F : NN --> ( 0 [,) +oo ) ) $.
    lmdvglim.2 $e |- ( ( ph /\ k e. NN ) -> ( F ` k ) <_ ( F ` ( k + 1 ) ) ) $.
    lmdvglim.3 $e |- ( ph -> -. F e. dom ~~> ) $.
    $( If a monotonic real number sequence ` F ` diverges, it converges in the
       extended real numbers and its limit is plus infinity.  (Contributed by
       Thierry Arnoux, 3-Aug-2017.) $)
    lmdvglim $p |- ( ph -> F ( ~~>t ` J ) +oo ) $=
      ( vx vj cpnf clm cfv wbr cv wral cn cc0 co wf clt wrex cr lmdvg cico cicc
      cuz wss icossicc fss sylancl wcel wa eqidd lmxrge0 mpbird ) ACKDLMNIOBOZC
      MZUANBJOUGMPJQUBIUCPAIJBCFGHUDAIURJBCDEAQRKUESZCTUSRKUFSZUHQUTCTFRKUIQUSU
      TCUJUKAUQQULUMURUNUOUP $.
  $}
$( End $[ set-mbox-ta-algtop.mm $] $)
$( Begin $[ set-mbox-ta-ucm.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Uniform Stuctures and Spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
              Hausdorff Completion
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c HCmp $. $( The Hausdorff completion relation. $)

  $( Extend class notation with the Hausdorff completion relation. $)
  chcmp $a class HCmp $.

  ${
    $d u w $.
    $( Nota: despite unicity, this definition will not yield a function, since
       only 3 components of the structure are fixed. ( Base o. HCmp ) shall be
       a function, though.  $)
    $( Definition of the Hausdorff completion.  In this definition, a structure
       ` w ` is a Hausdorff completion of a uniform structure ` u ` if ` w ` is
       a complete uniform space, in which ` u ` is dense, and which admits the
       same uniform structure.  Theorem 3 of [BourbakiTop1] p.  II.21. states
       the existence and unicity of such a completion.  (Contributed by Thierry
       Arnoux, 5-Mar-2018.) $)
    df-hcmp $a |- HCmp = { <. u , w >. | ( ( u e. U. ran UnifOn /\ w e. CUnifSp
      ) /\ ( ( UnifSt ` w ) |`t dom U. u ) = u
        /\ ( ( cls ` ( TopOpen ` w ) ) ` dom U. u ) = ( Base ` w ) ) } $.
  $}
$( End $[ set-mbox-ta-ucm.mm $] $)
$( Begin $[ set-mbox-ta-rrhom.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Topology and algebraic structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
             The norm on the ring of the integer numbers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    zzsnm.1 $e |- Z = ( CCfld |`s ZZ ) $.
    $( The norm of the ring of the integers (Contributed by Thierry Arnoux,
       8-Nov-2017.) $)
    zzsnm $p |- ( M e. ZZ -> ( abs ` M ) = ( ( norm ` Z ) ` M ) ) $=
      ( cz wcel cnm cfv cabs cres ccnfld cmnd cc0 cc wss crg cnrng rngmnd ax-mp
      wceq 0z zsscn cnfldbas cnfld0 cnfldnm ressnm mp3an fveq1i fvres syl5reqr
      ) ADEABFGZGAHDIZGAHGAUKUJJKEZLDEDMNUKUJSJOEULPJQRTUADMJBHLCUBUCUDUEUFUGAD
      HUHUI $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
             The complete ordered field of the real numbers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    recms.1 $e |- R = ( CCfld |`s RR ) $.
    $( The real numbers form a complete metric space.  (Contributed by Thierry
       Arnoux, 1-Nov-2017.) $)
    recms $p |- R e. CMetSp $=
      ( ccms wcel cr ccnfld ctopn cfv ccld eqid recld2 cc wss wb cncms cnfldbas
      ax-resscn cmsss mp2an mpbir ) ACDZEFGHZIHDZUBUBJZKFCDELMUAUCNOQEUBAFLBPUD
      RST $.

    $( The Uniform structure of the real numbers.  (Contributed by Thierry
       Arnoux, 14-Feb-2018.) $)
    reust $p |- ( UnifSt ` R )
                  = ( metUnif ` ( ( dist ` R ) |` ( RR X. RR ) ) ) $=
      ( cuss cfv cabs cmetu cr crest co cres ccnfld fveq2i wcel wceq reex ax-mp
      cvv 3eqtri cc cc0 cmin ccom cxp cds cress ressuss eqid cnflduss oveq1i c0
      wne cpsmet wss 0re ne0i cnxmet xmetpsmet ax-resscn restmetu mp3an cnfldds
      cxmt ressds reseq1i ) ACDZEUAUBZFDZGGUCZHIZVFVHJZFDZAUDDZVHJZFDVEKGUEIZCD
      ZKCDZVHHIZVIAVNCBLGQMZVOVQNOGQKUFPVPVGVHHVPVPUGUHUIRGUJUKZVFSULDMZGSUMVIV
      KNTGMVSUNGTUOPVFSVBDMVTUPVFSUQPURGVFSUSUTVJVMFVFVLVHVRVFVLNOGVFKAQBVAVCPV
      DLR $.

    $( The real numbers form a complete uniform space.  (Contributed by Thierry
       Arnoux, 17-Dec-2017.) $)
    recusp $p |- R e. CUnifSp $=
      ( cr c0 wne ccms wcel cuss cfv cds cxp cres cmetu wceq ccusp cc0 0re ne0i
      ax-mp eqid recms reust rebase cmetcusp1 mp3an ) CDEZAFGAHIZAJICCKLZMINAOG
      PCGUFQCPRSABUAABUBUHUGACABUCUHTUGTUDUE $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
             Topological ` ZZ ` -modules
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    zlmlem2.1 $e |- W = ( ZMod ` G ) $.

    ${
      $d x y G $.  $d x y W $.
      zlm0.1 $e |- .0. = ( 0g ` G ) $.
      $( Zero of a ` ZZ ` -module.  (Contributed by Thierry Arnoux,
         8-Nov-2017.) $)
      zlm0 $p |- .0. = ( 0g ` W ) $=
        ( vx vy c0g cfv wceq wtru cbs eqid a1i zlmbas cv wcel cplusg zlmplusg
        wa oveqd grpidpropd trud eqtri ) CAHIZBHIZEUEUFJKFGALIZABUGUGJKUGMZNUGB
        LIJKUGABDUHONKFPZUGQGPZUGQTTZARIZBRIZUIUJULUMJUKULABDULMSNUAUBUCUD $.
    $}

    ${
      $d x y G $.  $d x y W $.
      zlm1.1 $e |- .1. = ( 1r ` G ) $.
      $( Unit of a ` ZZ ` -module (if present).  (Contributed by Thierry
         Arnoux, 8-Nov-2017.) $)
      zlm1 $p |- .1. = ( 1r ` W ) $=
        ( vx vy cur cfv wceq wtru cbs eqid a1i zlmbas cv wcel wa cmulr zlmmulr
        oveqd rngidpropd trud eqtri ) ABHIZCHIZEUEUFJKFGBLIZBCUGUGJKUGMZNUGCLIJ
        KUGBCDUHONKFPZUGQGPZUGQRRZBSIZCSIZUIUJULUMJUKULBCDULMTNUAUBUCUD $.
    $}

    ${
      zlmds.1 $e |- D = ( dist ` G ) $.
      $( Distance in a ` ZZ ` -module (if present).  (Contributed by Thierry
         Arnoux, 8-Nov-2017.) $)
      zlmds $p |- ( G e. V -> D = ( dist ` W ) ) $=
        ( cds cfv cnx co cop csts eqid dsid wne c1 c2 c5 1nn c6 wcel csca cress
        ccnfld cz cvsca cmg zlmval fveq2d cdc 5re 2nn0 5nn0 5lt10 declti gtneii
        dsndx scandx neeq12i mpbir setsnid 6re 6nn0 6lt10 vscandx eqtri syl6eqr
        syl6reqr ) BCUAZDGHZBGHZAVIVJBIUBHZUDUEUCJZKLJZIUFHZBUGHZKLJZGHZVKVIDVQ
        GVPBCDVMEVMMVPMUHUIVKVNGHVRVMVLGBNIGHZVLOPQUJZRORVTUKPQRSULUMUNUOUPVSVT
        VLRUQURUSUTVAVPVOGVNNVSVOOVTTOTVTVBPQTSULVCVDUOUPVSVTVOTUQVEUSUTVAVFVGF
        VH $.
    $}

    ${
      zlmtset.1 $e |- J = ( TopSet ` G ) $.
      $( Topology in a ` ZZ ` -module (if present).  (Contributed by Thierry
         Arnoux, 8-Nov-2017.) $)
      zlmtset $p |- ( G e. V -> J = ( TopSet ` W ) ) $=
        ( cts cfv cnx co cop csts eqid tsetid wne c9 c5 gtneii tsetndx c6 cress
        wcel csca ccnfld cz cvsca cmg zlmval fveq2d 5lt9 scandx neeq12i setsnid
        5re mpbir 6re 6lt9 vscandx 3eqtri syl6reqr ) ACUBZDGHAIUCHZUDUEUAJZKLJZ
        IUFHZAUGHZKLJZGHZBVADVGGVFACDVCEVCMVFMUHUIBAGHVDGHVHFVCVBGANIGHZVBOPQOQ
        PUNUJRVIPVBQSUKULUOUMVFVEGVDNVIVEOPTOTPUPUQRVIPVETSURULUOUMUSUT $.
    $}

    ${
      zlmnm.1 $e |- N = ( norm ` G ) $.
      $( Norm of a ` ZZ ` -module (if present).  (Contributed by Thierry
         Arnoux, 8-Nov-2017.) $)
      zlmnm $p |- ( G e. V -> N = ( norm ` W ) ) $=
        ( wcel cnm cfv cbs wceq zlmbas a1i cplusg zlmplusg zlmds nmpropd syl5eq
        eqid cds ) ACGZBAHIDHIFUAADAJIZDJIKUAUBADEUBSLMANIZDNIKUAUCADEUCSOMATIZ
        ACDEUDSPQR $.
    $}

    ${
      $d x y G $.  $d x y W $.
      $( The ` ZZ ` -module built from a normed ring is also a normed ring.
         (Contributed by Thierry Arnoux, 8-Nov-2017.) $)
      zhmnrg $p |- ( G e. NrmRing -> W e. NrmRing ) $=
        ( vx vy cnrg wcel cngp cnm cfv cabv cgrp cmt csg ccom cds wceq eqid a1i
        wa wss w3a cbs zlmbas cplusg zlmplusg proplem3 grppropd cxp reseq1d cts
        zlmds zlmtset topnpropd mspropd zlmnm grpsubpropd coeq12d sseq12d isngp
        cv 3anbi123d 3bitr4g cmulr zlmmulr abvpropd2 eleq12d anbi12d isnrg ibi
        ) AFGZBFGZVKAHGZAIJZAKJZGZTBHGZBIJZBKJZGZTVKVLVKVMVQVPVTVKALGZAMGZVNANJ
        ZOZAPJZUAZUBBLGZBMGZVRBNJZOZBPJZUAZUBVMVQVKWAWGWBWHWFWLVKDEAUCJZABWMWMQ
        VKWMRZSZWMBUCJQVKWMABCWNUDSZVKDVAWMGEVAWMGTDEAUEJZBUEJZWQWRQVKWQABCWQRU
        FSZUGUHVKWMABWOWPVKWEWKWMWMUIWEAFBCWERZULZUJVKABWPAAUKJZFBCXBRUMUNUOVKW
        DWJWEWKVKVNVRWCWIAVNFBCVNRZUPZVKABWPWSUQURXAUSVBWEAWCVNXCWCRWTUTWKBWIVR
        VRRZWIRWKRUTVCVKVNVRVOVSXDVKABWPWSAVDJZBVDJQVKXFABCXFRVESVFVGVHVOAVNXCV
        ORVIVSBVRXEVSRVIVCVJ $.
    $}
  $}

  ${
    nmmulg.x $e |- B = ( Base ` R ) $.
    nmmulg.n $e |- N = ( norm ` R ) $.
    nmmulg.z $e |- Z = ( ZMod ` R ) $.
    ${
      nmmulg.t $e |- .x. = ( .g ` R ) $.
      $( The norm of a group product, provided the ` ZZ ` -module is normed.
         (Contributed by Thierry Arnoux, 8-Nov-2017.) $)
      nmmulg $p |- ( ( Z e. NrmMod /\ M e. ZZ /\ X e. B ) ->
        ( N ` ( M .x. X ) ) = ( ( abs ` M ) x. ( N ` X ) ) ) $=
        ( wcel cz co cnm cfv cmul cbs wceq eqid cnlm w3a csca cabs simp2 ccnfld
        cress zzsbase cabel clmod nlmlmod zlmlmod sylibr 3ad2ant1 zlmsca fveq2d
        syl5eq eleqtrd zlmbas zlmvsca nmvs syld3an2 zlmnm fveq1d zzsnm 3ad2ant2
        syl eqtrd oveq12d 3eqtr4d ) GUALZDMLZFALZUBZDFCNZGOPZPZDGUCPZOPZPZFVPPZ
        QNZVOEPDUDPZFEPZQNVKDVRRPZLVLVMVQWBSVNDMWEVKVLVMUEVNMUFMUGNZRPWEWFWFTZU
        HVNWFVRRVNBUILZWFVRSVKVLWHVMVKGUJLWHGUKBGJULUMUNZBUIGWFJWGUOVGZUPUQURVS
        CVRWEVPAGDFABGJHUSVPTCBGJKUTVRTWETVSTVAVBVNVOEVPVNWHEVPSWIBEUIGJIVCVGZV
        DVNWCVTWDWAQVNWCDWFOPZPZVTVLVKWCWMSVMDWFWGVEVFVNDWLVSVNWFVROWJUPVDVHVNF
        EVPWKVDVIVJ $.
    $}

    ${
      zrhnm.1 $e |- L = ( ZRHom ` R ) $.
      $( The norm of the image by ` ZRHom ` of an integer in a normed ring.
         (Contributed by Thierry Arnoux, 8-Nov-2017.) $)
      zrhnm $p |- ( ( ( Z e. NrmMod /\ Z e. NrmRing /\ R e. NzRing )
                           /\ M e. ZZ ) -> ( N ` ( L ` M ) ) = ( abs ` M ) ) $=
        ( wcel cnzr cz cfv c1 cmul co wceq syl eqid cnlm cnrg w3a wa cur simpl3
        cmg crg nzrrng simpr ccnfld cress zrhmulg fveq2d syl2anc simpl1 rngidcl
        cabs nmmulg syl3anc cnm zlmnm fveq1d simpl2 c0g nrgrng nzrnz zlm1 isnzr
        wne zlm0 sylanbrc nm1 eqtrd oveq2d 3eqtrd zcnd abscl recnd mulid1 3syl
        cc ) FUAKZFUBKZBLKZUCZDMKZUDZDCNZENZDURNZOPQZWKWHWJDBUENZBUGNZQZENZWKWM
        ENZPQZWLWHBUHKZWGWJWPRWHWEWSWCWDWEWGUFZBUISZWFWGUJZWSWGUDWIWOEBWNWMCDUK
        MULQZXCTJWNTZWMTZUMUNUOWHWCWGWMAKZWPWRRWCWDWEWGUPXBWHWSXFXAABWMGXEUQSAB
        WNDEWMFGHIXDUSUTWHWQOWKPWHWQWMFVANZNZOWHWMEXGWHWEEXGRWTBELFIHVBSVCWHWDF
        LKZXHORWCWDWEWGVDZWHFUHKZWMBVENZVJZXIWHWDXKXJFVFSWHWEXMWTBWMXLXEXLTZVGS
        FWMXLWMBFIXEVHZBFXLIXNVKVIVLFWMXGXGTXOVMUOVNVOVPWHDWBKZWKWBKWLWKRWHDXBV
        QXPWKDVRVSWKVTWAVN $.
    $}
  $}

  ${
    $d a b x $.  $d x y R $.  $d x z R $.
    $( The ` ZZ ` -module of ` CC ` is a normed module.  (Contributed by
       Thierry Arnoux, 25-Feb-2018.) $)
    cnzh $p |- ( ZMod ` CCfld ) e. NrmMod $=
      ( vz vx ccnfld cfv wcel cz co cnrg cv cabs cmul wceq cc wral wa eqid mp2b
      cnnrg cvv ax-mp czlm cnlm cngp clmod cress w3a cmg cres zhmnrg nrgngp crg
      cabel nrgrng rngabl zlmlmod mpbi csubrg zsubrg subrgnrg mp2an zsscn simpl
      3pm3.2i sseldi simpr absmul syl2anc cnfldmulg fveq2d fvres adantr 3eqtr4d
      oveq1d ralrimiva pm3.2i cnfldbas zlmbas cnm cnfldex cnfldnm zlmnm zlmvsca
      rgen csca zlmsca zzsbase cmnd cc0 wss cnrng rngmnd 0z cnfld0 ressnm mp3an
      isnlm mpbir ) CUADZUBEWRUCEZWRUDEZCFUEGZHEZUFZAIZBIZCUGDZGZJDZXDJFUHZDZXE
      JDZKGZLZBMNZAFNZOXCXOWSWTXBCHEZWRHEWSRCWRWRPZUIWRUJQCULEZWTXPCUKEZXRRCUMC
      UNQCWRXQUOUPXPFCUQDEXBRURFCXAXAPZUSUTVCXNAFXDFEZXMBMYAXEMEZOZXDXEKGZJDZXD
      JDZXKKGZXHXLYCXDMEYBYEYGLYCFMXDVAYAYBVBVDYAYBVEXDXEVFVGYCXGYDJXDXEVHVIYCX
      JYFXKKYAXJYFLYBXDFJVJVKVMVLVNWCVOABXIXFXAFJMWRMCWRXQVPVQCSEZJWRVRDLVSCJSW
      RXQVTWATXFCWRXQXFPWBYHXAWRWDDLVSCSWRXAXQXTWETXAXTWFCWGEZWHFEFMWIXIXAVRDLX
      SYIWJCWKTWLVAFMCXAJWHXTVPWMVTWNWOWPWQ $.

    rezh.1 $e |- R = ( CCfld |`s RR ) $.
    $( The ` ZZ ` -module of ` RR ` is a normed module.  (Contributed by
       Thierry Arnoux, 14-Feb-2018.) $)
    rezh $p |- ( ZMod ` R ) e. NrmMod $=
      ( vz vx cfv wcel ccnfld cz co cnrg cabs cr cmul wceq wa eqid cc ax-mp cc0
      fvres czlm cnlm cngp clmod cress cv cvsca cres wral csubrg cnnrg resubdrg
      w3a cdr simpli subrgnrg mp2an zhmnrg nrgngp mp2b cabel crg nrgrng zlmlmod
      rngabl mpbi zsubrg 3pm3.2i zsscn simpl sseldi ax-resscn simpr syl2anc cmg
      absmul csubg subrgsubg eqcomi subgmulg mp3an1 cnfldmulg syldan eqtr3d zre
      zlmvsca fveq2d remulcl syl sylan eqtrd oveqan12d 3eqtr4d ralrimiva pm3.2i
      rgen rebase zlmbas cvv cnm ccusp recusp elexi cmnd wss cnrng 0re cnfldbas
      rngmnd cnfld0 cnfldnm ressnm mp3an zlmnm csca zlmsca zzsbase isnlm mpbir
      0z ) AUAEZUBFYAUCFZYAUDFZGHUEIZJFZUMZCUFZDUFZYAUGEZIZKLUHZEZYGKHUHZEZYHYK
      EZMIZNZDLUIZCHUIZOYFYSYBYCYEAJFZYAJFYBGJFZLGUJEZFZYTUKUUCGLUEIUNFULUOZLGA
      BUPUQZAYAYAPZURYAUSUTAVAFZYCYTAVBFUUGUUEAVCAVEUTAYAUUFVDVFUUAHUUBFYEUKVGH
      GYDYDPZUPUQVHYRCHYGHFZYQDLUUIYHLFZOZYGYHMIZKEZYGKEZYHKEZMIZYLYPUUKYGQFYHQ
      FZUUMUUPNUUKHQYGVIUUIUUJVJVKUUKLQYHVLUUIUUJVMVKZYGYHVPVNUUKYLUULYKEZUUMUU
      KYJUULYKUUKYGYHGVOEZIZYJUULLGVQEFZUUIUUJUVAYJNUUCUVBUUDLGVRRLYIUUTGAYGYHU
      UTPBAVOEZYIUVCAYAUUFUVCPWFVSVTWAUUIUUJUUQUVAUULNUURYGYHWBWCWDWGUUIYGLFZUU
      JUUSUUMNZYGWEUVDUUJOUULLFUVEYGYHWHUULLKTWIWJWKUUIUUJYNUUNYOUUOMYGHKTYHLKT
      WLWMWNWPWOCDYMYIYDHYKLYALAYAUUFABWQWRAWSFZYKYAWTENAXAABXBXCZAYKWSYAUUFGXD
      FZSLFLQXEYKAWTENGVBFUVHXFGXIRZXGVLLQGAKSBXHXJXKXLXMXNRYIPUVFYDYAXOENUVGAW
      SYAYDUUFUUHXPRYDUUHXQUVHSHFHQXEYMYDWTENUVIXTVIHQGYDKSUUHXHXJXKXLXMXRXS $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
  Canonical embedding of the field of the rational numbers into a division ring
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c QQHom $.

  $( Map the rationals into a field. $)
  cqqh $a class QQHom $.

  ${
    $d r x y $.
    $( Define the canonical homomorphism from the rationals into any field.
       (Contributed by Mario Carneiro, 22-Oct-2017.)  (Revised by Thierry
       Arnoux, 23-Oct-2017.) $)
    df-qqh $a |- QQHom = ( r e. _V |-> ran ( x e. ZZ , y e.
      ( `' ( ZRHom ` r ) " ( Unit ` r ) ) |-> <. ( x / y ) ,
      ( ( ( ZRHom ` r ) ` x ) ( /r ` r ) ( ( ZRHom ` r ) ` y ) ) >. ) ) $.
  $}

  ${
    $d f x y R $.  $d f ./ $.  $d f y L $.
    qqhval.1 $e |- ./ = ( /r ` R ) $.
    qqhval.2 $e |- .1. = ( 1r ` R ) $.
    qqhval.3 $e |- L = ( ZRHom ` R ) $.
    $( Value of the canonical homormorphism from the rational number to a
       field.  (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    qqhval $p |- ( R e. _V -> ( QQHom ` R ) =
      ran ( x e. ZZ , y e. ( `' L " ( Unit ` R ) ) |->
        <. ( x / y ) , ( ( L ` x ) ./ ( L ` y ) ) >. ) ) $=
      ( vf cz cv czrh cfv ccnv cui co cdvr cvv fveq2 cima cdiv cmpt2 cqqh eqidd
      cop wceq syl6eqr cnveqd imaeq12d fveq1d oveq123d opeq2d mpt2eq123dv rneqd
      crn df-qqh zex wcel fvex eqeltri cnvex imaexg ax-mp mpt2ex rnex fvmpt ) J
      DABKJLZMNZOZVHPNZUAZALZBLZUBQZVMVINZVNVINZVHRNZQZUFZUCZUPABKFOZDPNZUAZVOV
      MFNZVNFNZCQZUFZUCZUPSUDVHDUGZWAWIWJABKVLVTKWDWHWJKUEWJVJWBVKWCWJVIFWJVIDM
      NZFVHDMTIUHZUIVHDPTUJWJVSWGVOWJVPWEVQWFVRCWJVRDRNCVHDRTGUHWJVMVIFWLUKWJVN
      VIFWLUKULUMUNUOABJUQWIABKWDWHURWBSUSWDSUSFFWKSIDMUTVAVBWBWCSVCVDVEVFVG $.
  $}

  ${
    zrhker.0 $e |- B = ( Base ` R ) $.
    zrhker.1 $e |- L = ( ZRHom ` R ) $.
    zrhker.2 $e |- .0. = ( 0g ` R ) $.
    $( The kernel of the homomorphism from the integers to a ring, if it is
       injective.  (Contributed by Thierry Arnoux, 26-Oct-2017.) $)
    zrhf1ker $p |- ( R e. Ring ->
       ( L : ZZ -1-1-> B <-> ( `' L " { .0. } ) = { 0 } ) ) $=
      ( crg wcel ccnfld cz cress co crh wf1 ccnv csn cima cc0 wceq eqid zzsbase
      wb zrhrhm zzs0 kerf1hrm syl ) BHICJKLMZBNMIKACOCPDQRSQTUCBCUHUHUAZFUDKAUH
      BCSDUHUIUBEUHUIUEGUFUG $.

    $d x B $.  $d x R $.
    $( The kernel of the homomorphism from the integers to a ring is injective
       if and only if the ring has characteristic 0 .  (Contributed by Thierry
       Arnoux, 8-Nov-2017.) $)
    zrhchr $p |- ( R e. Ring -> ( ( chr ` R ) = 0 <-> L : ZZ -1-1-> B ) ) $=
      ( vx crg wcel cz wf1 cv cur cfv co cc0 wceq wb eqid cmg cmpt ccnfld cress
      cod cchr zrhval2 f1eq1 syl cgrp rnggrp rngidcl odf1 syl2anc chrval eqeq1i
      a1i 3bitr2rd ) BIJZKACLZKAHKHMBNOZBUAOZPUBZLZVABUEOZOZQRZBUFOZQRZUSCVCRUT
      VDSBVBVAHCUCKUDPZVJTFVBTZVATZUGKACVCUHUIUSBUJJVAAJVGVDSBUKABVAEVLULHVAVBV
      CBVEAEVETZVKVCTUMUNVGVISUSVFVHQVHBVAVEVMVLVHTUOUPUQUR $.

    $( The kernel of the homomorphism from the integers to a ring with
       characteristic 0.  (Contributed by Thierry Arnoux, 8-Nov-2017.) $)
    zrhker $p |- ( R e. Ring ->
       ( ( chr ` R ) = 0 <-> ( `' L " { .0. } ) = { 0 } ) ) $=
      ( crg wcel cchr cfv cc0 wceq cz wf1 ccnv csn cima zrhchr zrhf1ker bitrd )
      BHIBJKLMNACOCPDQRLQMABCDEFGSABCDEFGTUA $.

    $( The preimage by ` ZRHom ` of the unit of a division ring is
       ` ( ZZ \ { 0 } ) ` .  (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    zrhunitpreima $p |- ( ( R e. DivRing /\ ( chr ` R ) = 0 )
      -> ( `' L " ( Unit ` R ) ) = ( ZZ \ { 0 } ) ) $=
      ( cdr wcel cfv cc0 wceq cima csn cdif cz eqid adantr co 3syl cchr wa ccnv
      cui c0g crg isdrng simprbi imaeq2d wfun drngrng ccnfld crh zrhrhm zzsbase
      cress wf rhmf ffun difpreima fimacnv zrhker biimpa sylan difeq12d 3eqtrd
      4syl ) BHIZBUAJKLZUBZCUCZBUDJZMZVKABUEJZNZOZMZVKAMZVKVOMZOZPKNZOVHVMVQLVI
      VHVLVPVKVHBUFIZVLVPLABVLVNEVLQVNQZUGUHUIRVHVQVTLZVIVHWBCUJZWDBUKZWBCULPUP
      SZBUMSIZPACUQZWEBCWGWGQZFUNZPAWGBCWGWJUOEURZPACUSTAVOCUTTRVJVRPVSWAVHVRPL
      ZVIVHWBWHWIWMWFWKWLPACVAVGRVHWBVIVSWALZWFWBVIWNABCVNEFWCVBVCVDVEVF $.

    $( Condition for the image by ` ZRHom ` to be a unit.  (Contributed by
       Thierry Arnoux, 30-Oct-2017.) $)
    elzrhunit $p |- ( ( ( R e. DivRing /\ ( chr ` R ) = 0 )
      /\ ( M e. ZZ /\ M =/= 0 ) ) -> ( L ` M ) e. ( Unit ` R ) ) $=
      ( cdr wcel cchr cfv cc0 wceq wa cz wne wfn co 3syl cui crg simpll drngrng
      ccnv cima ccnfld cress crh wf eqid zrhrhm zzsbase rhmf ffn cdif simprl wn
      csn elsncg necon3bbid biimpar adantl eldifd zrhunitpreima adantr eleqtrrd
      elpreima simplbda syl2anc ) BIJZBKLMNZOZDPJZDMQZOZOZCPRZDCUEBUALZUFZJZDCL
      VSJZVQVKBUBJZVRVKVLVPUCBUDWCCUGPUHSZBUISJPACUJVRBCWDWDUKZGULPAWDBCWDWEUMF
      UNPACUOTTVQDPMUSZUPZVTVQDPWFVMVNVOUQVPDWFJZURZVMVNWIVOVNWHDMDMPUTVAVBVCVD
      VMVTWGNVPABCEFGHVEVFVGVRWAVNWBPDVSCVHVIVJ $.
  $}

  $( Lemma for ~ qqhval2 (Contributed by Thierry Arnoux, 29-Oct-2017.) $)
  elzdif0 $p |- ( M e. ( ZZ \ { 0 } ) -> ( M e. NN \/ -u M e. NN ) ) $=
    ( cz cc0 csn cdif wcel wceq cneg eldifi eldifn elsncg notbid biimpa syl2anc
    wn cn wo w3o cr sylib wa elz simprd 3orass orel1 sylc ) ABCDZEFZACGZOZUIAPF
    ZAHPFZQZQZUMUHABFZAUGFZOZUJABUGIZABUGJUOUQUJUOUPUIACBKLMNUHUIUKULRZUNUHASFZ
    USUHUOUTUSUAURAUBTUCUIUKULUDTUIUMUEUF $.

  ${
    $d z X $.  $d z Y $.
    qqhval2.0 $e |- B = ( Base ` R ) $.
    qqhval2.1 $e |- ./ = ( /r ` R ) $.
    qqhval2.2 $e |- L = ( ZRHom ` R ) $.
    $( Lemma for ~ qqhval2 (Contributed by Thierry Arnoux, 29-Oct-2017.) $)
    qqhval2lem $p |- ( ( ( R e. DivRing /\ ( chr ` R ) = 0 )
      /\ ( X e. ZZ /\ Y e. ZZ /\ Y =/= 0 ) )
         -> ( ( L ` ( numer ` ( X / Y ) ) ) ./ ( L ` ( denom ` ( X / Y ) ) ) )
         = ( ( L ` X ) ./ ( L ` Y ) ) ) $=
      ( wcel cfv cc0 wceq wa cz co cmul wn fveq2d c1 cdr cchr wne w3a cgcd cdiv
      cnumer cdenom ccnfld cress crh cui crg drngrng eqid syl ad2antrr cdivides
      zrhrhm simpr1 simpr2 gcdcld nn0zd simpr3 gcdeq0 simplbda necon3d syl21anc
      wbr ex imp gcddvds syl2anc simpld dvdsval2 biimpa syl31anc simprd zzsbase
      c0g wf rhmf ffvelrnd wfn ccnv csn cima zcnd divne0d ovex elsnc necon3bbii
      ffn sylibr simplr zrhker neleqtrrd elpreima baibd biimprd con3and fvex wb
      sylib drngunit mpbir2and zzsmulr rhmdvd syl132anc cn cneg divnumden sylan
      eqcomd oveq12d adantr mulm1d neg1cn a1i mulcomd eqtr3d divnumden2 syl3anc
      cc simpr znegcld cabs znegcl ax-mp ax-1cn absnegi eqtri zrngunit mpbir2an
      1z abs1 elrhmunit 3eqtr4rd wo divcan1d simp3 neneqd cr simp2 3orass orel1
      w3o elz sylc adantl mpjaodan 3eqtr3d ) CUAJZCUBKLMZNZEOJZFOJZFLUCZUDZNZEE
      FUEPZUFPZDKZFUVAUFPZDKZBPZUVBUVAQPZDKZUVDUVAQPZDKZBPZEFUFPZUGKZDKZUVLUHKZ
      DKZBPZEDKZFDKZBPUUTDUIOUJPZCUKPJZUVBOJZUVDOJZUVAOJZUVECULKZJZUVADKZUWEJZU
      VFUVKMUUMUWAUUNUUSUUMCUMJZUWACUNZCDUVTUVTUOZIUSUPUQZUUTUWDUVALUCZUUPUVAEU
      RVIZUWBUUTUVAUUTEFUUOUUPUUQUURUTZUUOUUPUUQUURVAZVBVCZUUTUUPUUQUURUWMUWOUW
      PUUOUUPUUQUURVDZUUPUUQNZUURUWMUWSUVALFLUWSUVALMZFLMZUWSUWTELMUXAEFVEVFVJV
      GVKVHZUWOUUTUWNUVAFURVIZUUTUUPUUQUWNUXCNUWOUWPEFVLVMZVNUWDUWMUUPUDUWNUWBU
      VAEVOVPVQZUUTUWDUWMUUQUXCUWCUWQUXBUWPUUTUWNUXCUXDVRUWDUWMUUQUDUXCUWCUVAFV
      OVPVQZUWQUUTUWFUVEAJZUVECVTKZUCZUUTOAUVDDUUTUWAOADWAZUWLOAUVTCDUVTUWKVSZG
      WBUPZUXFWCUUTDOWDZUWCUVDDWEUXHWFZWGZJZRZUXIUUTUXJUXMUXLOADWMUPZUXFUUTUXOL
      WFZUVDUUTUVDLUCUVDUXSJZRUUTFUVAUUTFUWPWHZUUTUVAUWQWHZUWRUXBWIUXTUVDLUVDLF
      UVAUFWJWKWLWNUUTUWIUUNUXOUXSMZUUMUWIUUNUUSUWJUQUUMUUNUUSWOUWIUUNUYCACDUXH
      GIUXHUOZWPVPVMZWQUXMUWCNZUXQNUVEUXNJZRUXIUYFUYGUXPUYFUXPUYGUXMUXPUWCUYGOU
      VDUXNDWRWSWTXAUYGUVEUXHUVEUXHUVDDXBWKWLXDVHUUMUWFUXGUXINXCUUNUUSACUWEUVEU
      XHGUWEUOZUYDXEUQXFZUUTUWHUWGAJZUWGUXHUCZUUTOAUVADUXLUWQWCUUTUXMUWDUVAUXOJ
      ZRZUYKUXRUWQUUTUXOUXSUVAUUTUWMUVAUXSJZRUXBUYNUVALUVALEFUEWJWKWLWNUYEWQUXM
      UWDNZUYMNUWGUXNJZRUYKUYOUYPUYLUYOUYLUYPUXMUYLUWDUYPOUVAUXNDWRWSWTXAUYPUWG
      UXHUWGUXHUVADXBWKWLXDVHUUMUWHUYJUYKNXCUUNUUSACUWEUWGUXHGUYHUYDXEUQXFUVBUV
      DUVABUVTCQUWEDOUYHUXKHUVTUWKXGZXHXIUUTFXJJZUVFUVQMFXKXJJZUUTUYRNZUVCUVNUV
      EUVPBUYTUVBUVMDUYTUVMUVBUYTUVMUVBMZUVOUVDMZUUTUUPUYRVUAVUBNUWOEFXLXMZVNXN
      SUYTUVDUVODUYTUVOUVDUYTVUAVUBVUCVRXNSXOUUTUYSNZUVBXKZDKZUVDXKZDKZBPUVBTXK
      ZQPZDKZUVDVUIQPZDKZBPZUVQUVFVUDVUFVUKVUHVUMBVUDVUEVUJDVUDVUIUVBQPVUEVUJVU
      DUVBVUDUVBUUTUWBUYSUXEXPZWHZXQVUDVUIUVBVUIYDJVUDXRXSZVUPXTYASVUDVUGVULDVU
      DVUIUVDQPVUGVULVUDUVDVUDUVDUUTUWCUYSUXFXPZWHZXQVUDVUIUVDVUQVUSXTYASXOVUDU
      VNVUFUVPVUHBVUDUVMVUEDVUDUVMVUEMZUVOVUGMZVUDUUPUUQUYSVUTVVANUUTUUPUYSUWOX
      PUUTUUQUYSUWPXPUUTUYSYEEFYBYCZVNSVUDUVOVUGDVUDVUTVVAVVBVRSXOVUDUWAUWBUWCV
      UIOJZUWFVUIDKUWEJZUVFVUNMUUTUWAUYSUWLXPZVUOVURVUDTTOJZVUDYOXSYFUUTUWFUYSU
      YIXPVUDUWAVUIUVTULKJZVVDVVEVVGVUDVVGVVCVUIYGKZTMVVFVVCYOTYHYIVVHTYGKTTYJY
      KYPYLVUIUVTUWKYMYNXSVUIUVTCDYQVMUVBUVDVUIBUVTCQUWEDOUYHUXKHUYQXHXIYRUUSUY
      RUYSYSZUUOUUSUXARUXAVVIYSZVVIUUSFLUUPUUQUURUUAUUBUUSUXAUYRUYSUUGZVVJUUSFU
      UCJZVVKUUSUUQVVLVVKNUUPUUQUURUUDFUUHXDVRUXAUYRUYSUUEXDUXAVVIUUFUUIUUJUUKU
      UTUVHUVRUVJUVSBUUTUVGEDUUTEUVAUUTEUWOWHUYBUXBYTSUUTUVIFDUUTFUVAUYAUYBUXBY
      TSXOUUL $.

    $d x y z $.  $d e q s x y ./ $.  $d e q s x y B $.  $d e q s x y L $.
    $d e q s x y R $.
    $( Value of the canonical homormorphism from the rational number when the
       target ring is a division ring.  (Contributed by Thierry Arnoux,
       26-Oct-2017.) $)
    qqhval2 $p |- ( ( R e. DivRing /\ ( chr ` R ) = 0 ) -> ( QQHom ` R ) =
      ( q e. QQ |-> ( ( L ` ( numer ` q ) ) ./ ( L ` ( denom ` q ) ) ) ) ) $=
      ( vx vy ve vs wcel cfv cc0 wceq wa cz co cq cdr cchr cqqh ccnv cui cv cop
      cima cdiv crn csn cdif cnumer cdenom cmpt cvv elex adantr cur eqid qqhval
      cmpt2 syl eqidd c0g zrhunitpreima mpt2eq12 syl2anc rneqd wrex copab nfab1
      cab nfv nfcv wex simpr wne zssq simplrl sseldi simplrr eldifad wn eldifbd
      elsn necon3bbii qdivcl syl3anc simplll simpllr qqhval2lem eqcomd syl23anc
      sylib w3a ovex opeq12 eqeq2d eleq1d fveq2d oveq12d eqeq12d anbi12d spc2ev
      simpl syl12anc ex rexlimdvva imp 19.42vv simprrl qnumcl qdencl nnzd nnne0
      elsni necon3ai 3syl eldifd qeqnumdivden simprrr opeq12d eqtrd oveq1 fveq2
      cn simprl oveq1d oveq2 oveq2d rspc2ev exlimivv sylbir impbida abid elopab
      3bitr4g eqrd rnmpt2 df-mpt 3eqtr4g 3eqtrd ) CUAMZCUBNOPZQZCUCNZIJRDUDCUEN
      UHZIUFZJUFZUISZUUIDNZUUJDNZBSZUGZVBZUJZIJRROUKZULZUUOVBZUJZETEUFZUMNZDNZU
      VBUNNZDNZBSZUOZUUFCUPMZUUGUUQPUUDUVIUUECUAUQURIJBCCUSNZDGUVJUTHVAVCUUFUUP
      UUTUUFRRPUUHUUSPUUPUUTPUUFRVDACDCVENZFHUVKUTVFIJRUUHRUUSUUOVGVHVIUUFKUFZU
      UOPZJUUSVJIRVJZKVMZUVBTMZLUFZUVGPZQZELVKZUVAUVHUUFKUVOUVTUUFKVNUVNKVLKUVT
      VOUUFUVNUVLUVBUVQUGZPZUVSQZLVPEVPZUVLUVOMUVLUVTMUUFUVNUWDUUFUVNUWDUUFUVMU
      WDIJRUUSUUFUUIRMZUUJUUSMZQZQZUVMUWDUWHUVMQZUVMUUKTMZUUNUUKUMNZDNZUUKUNNZD
      NZBSZPZUWDUWHUVMVQUWIUUITMUUJTMUUJOVRZUWJUWIRTUUIVSUUFUWEUWFUVMVTZWAUWIRT
      UUJVSUWIUUJRUURUUFUWEUWFUVMWBZWCZWAUWIUUJUURMZWDUWQUWIUUJRUURUWSWEUXAUUJO
      JOWFWGWOZUUIUUJWHWIUWIUUDUUEUWEUUJRMZUWQUWPUUDUUEUWGUVMWJUUDUUEUWGUVMWKUW
      RUWTUXBUUFUWEUXCUWQWPQUWOUUNABCDUUIUUJFGHWLWMWNUWCUVMUWJUWPQZQELUUKUUNUUI
      UUJUIWQUULUUMBWQUVBUUKPZUVQUUNPZQZUWBUVMUVSUXDUXGUWAUUOUVLUVBUVQUUKUUNWRW
      SUXGUVPUWJUVRUWPUXGUVBUUKTUXEUXFXFZWTUXGUVQUUNUVGUWOUXEUXFVQUXGUVDUWLUVFU
      WNBUXGUVCUWKDUXGUVBUUKUMUXHXAXAUXGUVEUWMDUXGUVBUUKUNUXHXAXAXBXCXDXDXEXGXH
      XIXJUUFUWDQUUFUWCQZLVPEVPUVNUUFUWCELXKUXIUVNELUXIUVCRMZUVEUUSMUVLUVCUVEUI
      SZUVGUGZPZUVNUXIUVPUXJUUFUWBUVPUVRXLZUVBXMVCUXIUVERUURUXIUVEUXIUVPUVEYGMZ
      UXNUVBXNVCZXOUXIUXOUVEOVRUVEUURMZWDUXPUVEXPUXQUVEOUVEOXQXRXSXTUXIUVLUWAUX
      LUUFUWBUVSYHUXIUVBUXKUVQUVGUXIUVPUVBUXKPUXNUVBYAVCUUFUWBUVPUVRYBYCYDUVMUX
      MUVLUVCUUJUISZUVDUUMBSZUGZPIJUVCUVERUUSUUIUVCPZUUOUXTUVLUYAUUKUXRUUNUXSUU
      IUVCUUJUIYEUYAUULUVDUUMBUUIUVCDYFYIYCWSUUJUVEPZUXTUXLUVLUYBUXRUXKUXSUVGUU
      JUVEUVCUIYJUYBUUMUVFUVDBUUJUVEDYFYKYCWSYLWIYMYNYOUVNKYPUVSELUVLYQYRYSIJKR
      UUSUUOUUTUUTUTYTELTUVGUUAUUBUUC $.

    $d q Q $.
    $( Value of the canonical homormorphism from the rational number when the
       target ring is a division ring.  (Contributed by Thierry Arnoux,
       30-Oct-2017.) $)
    qqhvval $p |- ( ( ( R e. DivRing /\ ( chr ` R ) = 0 ) /\ Q e. QQ ) ->
      ( ( QQHom ` R ) ` Q )
          = ( ( L ` ( numer ` Q ) ) ./ ( L ` ( denom ` Q ) ) ) ) $=
      ( vq wcel cfv wceq wa cq cnumer cdenom co cvv simpr fveq2d cchr cqqh cmpt
      cdr cc0 cv qqhval2 adantr oveq12d ovex a1i fvmptd ) DUDJDUAKUELMZCNJZMZIC
      IUFZOKZEKZUPPKZEKZBQZCOKZEKZCPKZEKZBQZNDUBKZRUMVGINVAUCLUNABDEIFGHUGUHUOU
      PCLZMZURVCUTVEBVIUQVBEVIUPCOUOVHSZTTVIUSVDEVIUPCPVJTTUIUMUNSVFRJUOVCVEBUJ
      UKUL $.

    $( The image of ` 0 ` by the ` QQHom ` homomorphism is the ring's zero.
       (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    qqh0 $p |- ( ( R e. DivRing /\ ( chr ` R ) = 0 )
                                     -> ( ( QQHom ` R ) ` 0 ) = ( 0g ` R ) ) $=
      ( wcel cfv cc0 wceq wa co cq cz 0z c1 fveq2i eqid syl cdr cchr cnumer c0g
      cqqh cdenom zssq sselii qqhvval mpan2 cgcd cdiv cabs 1z gcd0id ax-mp abs1
      eqtri 0cn div1i eqcomi pm3.2i cn wb qnumdenbi mp3an simpli simpri oveq12i
      1nn mpbi cur drngrng zrh0 zrh1 oveq12d cgrp drnggrp grpidcl syl2anc eqtrd
      crg dvr1 syl5eq adantr ) CUAHZCUBIJKZLZJCUEIIZJUCIZDIZJUFIZDIZBMZCUDIZWHJ
      NHZWIWNKONJUGPUHZABJCDEFGUIUJWFWNWOKWGWFWNJDIZQDIZBMZWOWKWRWMWSBWJJDWJJKZ
      WLQKZJQUKMZQKZJJQULMZKZLZXAXBLZXDXFXCQUMIZQQOHXCXIKUNQUOUPUQURXEJJUSUTVAV
      BWPJOHQVCHXGXHVDWQPVJJJQVEVFVKZVGRWLQDXAXBXJVHRVIWFWTWOCVLIZBMZWOWFCWBHZW
      TXLKCVMZXMWRWOWSXKBCDWOGWOSZVNCXKDGXKSZVOVPTWFXMWOAHZXLWOKXNWFCVQHXQCVRAC
      WOEXOVSTABCXKWOEFXPWCVTWAWDWEWA $.

    $( The image of ` 1 ` by the ` QQHom ` homomorphism is the ring's unit.
       (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    qqh1 $p |- ( ( R e. DivRing /\ ( chr ` R ) = 0 )
                                     -> ( ( QQHom ` R ) ` 1 ) = ( 1r ` R ) ) $=
      ( cdr wcel cfv wceq wa c1 co cq cz 1z fveq2i syl eqtrd cchr cnumer cdenom
      cc0 cqqh cur zssq sselii qqhvval mpan2 cgcd cdiv gcd1 ax-mp ax-1cn eqcomi
      div1i pm3.2i cn wb 1nn qnumdenbi mp3an mpbi simpli simpri oveq12i drngrng
      crg eqid zrh1 oveq12d rngidcl dvr1 syl2anc syl5eq adantr ) CHIZCUAJUDKZLZ
      MCUEJJZMUBJZDJZMUCJZDJZBNZCUFJZVTMOIZWAWFKPOMUGQUHZABMCDEFGUIUJVRWFWGKVSV
      RWFMDJZWJBNZWGWCWJWEWJBWBMDWBMKZWDMKZMMUKNMKZMMMULNZKZLZWLWMLZWNWPMPIZWNQ
      MUMUNWOMMUOUQUPURWHWSMUSIWQWRUTWIQVAMMMVBVCVDZVERWDMDWLWMWTVFRVGVRWKWGWGB
      NZWGVRCVIIZWKXAKCVHZXBWJWGWJWGBCWGDGWGVJZVKZXEVLSVRXBWGAIZXAWGKXCVRXBXFXC
      ACWGEXDVMSABCWGWGEFXDVNVOTVPVQT $.

    $( TODO simplify this & others using properties of ` ( CClfd |`s ZZ )` $)
    $( ` QQHom ` as a function.  (Contributed by Thierry Arnoux,
       28-Oct-2017.) $)
    qqhf $p |- ( ( R e. DivRing /\ ( chr ` R ) = 0 )
      -> ( QQHom ` R ) : QQ --> B ) $=
      ( vq wcel cfv cc0 wceq wa cq cdenom co adantr cz eqid 3syl cchr cv cnumer
      cdr cqqh qqhval2 crg cui drngrng ccnfld crh wf zrhrhm zzsbase rhmf qnumcl
      adantl ffvelrnd c0g wne simpll cn qdencl nnzd csn ccnv cima nnne0d neneqd
      cress wn fvex elsnc sylnibr zrhker biimpa sylan neleqtrrd wfn wb elpreima
      ffn biimpar expr con3and syl21anc neneqad drngunit syl12anc dvrcl syl3anc
      sylnib fmpt3d ) CUDIZCUAJKLZMZHNHUBZUCJZDJZWQOJZDJZBPZACUEJABCDHEFGUFWPWQ
      NIZMZCUGIZWSAIXACUHJZIZXBAIWPXEXCWNXEWOCUIZQQZXDRAWRDXDXEDUJRVJPZCUKPIZRA
      DULZXICDXJXJSZGUMZRAXJCDXJXMUNEUOZTZXCWRRIWPWQUPUQURXDWNXAAIZXACUSJZUTZXG
      WNWOXCVAZXDRAWTDXPXDWTXCWTVBIWPWQVCUQZVDZURXDXAXRXDXAXRVEZIZXAXRLXDWNWTRI
      ZWTDVFYCVGZIZVKYDVKXTYBXDYFKVEZWTXDWTKLWTYHIXDWTKXDWTYAVHVIWTKWQOVLVMVNWP
      YFYHLZXCWNXEWOYIXHXEWOYIACDXREGXRSZVOVPVQQVRWNYEMYDYGWNYEYDYGWNYGYEYDMZWN
      XEDRVSZYGYKVTXHXEXKXLYLXNXORADWBTRWTYCDWATWCWDWEWFXAXRWTDVLVMWLWGWNXGXQXS
      MACXFXAXREXFSZYJWHWCWIABCXFWSXAEYMFWJWKWM $.

    $( The image of a quotient by the ` QQHom ` homomorphism.  (Contributed by
       Thierry Arnoux, 28-Oct-2017.) $)
    qqhvq $p |- ( ( ( R e. DivRing /\ ( chr ` R ) = 0 )
      /\ ( X e. ZZ /\ Y e. ZZ /\ Y =/= 0 ) )
             -> ( ( QQHom ` R ) ` ( X / Y ) ) = ( ( L ` X ) ./ ( L ` Y ) ) ) $=
      ( cdr wcel cfv cc0 wceq wa cz co cq zssq sseldi cchr wne cdiv cqqh cnumer
      w3a cdenom simpr1 simpr2 simpr3 qdivcl syl3anc qqhvval syldan qqhval2lem
      eqtrd ) CJKCUALMNOZEPKZFPKZFMUBZUFZOZEFUCQZCUDLLZVCUELDLVCUGLDLBQZEDLFDLB
      QUQVAVCRKZVDVENVBERKFRKUTVFVBPRESUQURUSUTUHTVBPRFSUQURUSUTUITUQURUSUTUJEF
      UKULABVCCDGHIUMUNABCDEFGHIUOUP $.

    $d x y Q $.
    qqhrhm.1 $e |- Q = ( CCfld |`s QQ ) $.
    $( The ` QQHom ` homomorphism is a group homomorphism if the target
       structure is a division ring.  (Contributed by Thierry Arnoux,
       9-Nov-2017.) $)
    qqhghm $p |- ( ( R e. DivRing /\ ( chr ` R ) = 0 )
                                       -> ( QQHom ` R ) e. ( Q GrpHom R ) ) $=
      ( wcel cfv cc0 wceq caddc cq eqid cmul co cz ad2antrl vx vy cdr wa cplusg
      cchr cqqh qrngbas cvv qex ccnfld cnfldadd ressplusg ax-mp cgrp qdrng mp1i
      drnggrp adantr qqhf cv cnumer cdenom crg drngrng ad2antrr wf cress zrhrhm
      cui crh zzsbase rhmf 3syl qnumcl cn qdencl ad2antll nnzd zmulcld ffvelrnd
      cmulr syl zzsmulr rhmmul syl3anc wne simpl nnne0d c0g elzrhunit unitmulcl
      syl12anc eqeltrd syl13anc cdiv qeqnumdivden oveq12d zcnd divadddivd eqtrd
      dvrdir fveq2d zaddcld qqhvq cghm rhmghm w3a zzsplusg ghmlin oveq1d 3eqtrd
      mulne0d rhmdvd syl132anc mulcomd oveq2d 3eqtr4d isghmd ) DUCJZDUFKLMZUDZU
      AUBNDUEKZCDDUGKZOACIUHFOUIJNCUEKMUJONUKCUIIULUMUNYCPZCUCJCUOJYBCIUPCURUQX
      TDUOJYADURUSABDEFGHUTYBUAVAZOJZUBVAZOJZUDZUDZYFVBKZYHVCKZQRZEKZYHVBKZYFVC
      KZQRZEKZYCRZYQYMQRZEKZBRZYOUUBBRZYSUUBBRZYCRZYFYHNRZYDKZYFYDKZYHYDKZYCRYK
      DVDJZYOAJYSAJUUBDVJKZJUUCUUFMXTUUKYAYJDVEZVFZYKSAYNEYBSAEVGZYJYBUUKEUKSVH
      RZDVKRJZUUOXTUUKYAUUMUSDEUUPUUPPZHVIZSAUUPDEUUPUURVLZFVMVNUSZYKYLYMYGYLSJ
      ZYBYIYFVOTZYKYMYIYMVPJYBYGYHVQVRZVSZVTZWAYKSAYREUVAYKYPYQYIYPSJZYBYGYHVOV
      RZYKYQYGYQVPJYBYIYFVQTZVSZVTZWAYKUUBYQEKZYMEKZDWBKZRZUULYKUUQYQSJZYMSJZUU
      BUVOMYKUUKUUQUUNUUSWCZUVJUVEYQYMUUPDQUVNESUUTUUPUURWDZUVNPZWEWFYKUUKUVLUU
      LJZUVMUULJZUVOUULJUUNYKYBUVPYQLWGZUWAYBYJWHZUVJYKYQUVIWIZADEYQDWJKZFHUWFP
      ZWKWMZYKYBUVQYMLWGZUWBUWDUVEYKYMUVDWIZADEYMUWFFHUWGWKWMZDUVNUULUVLUVMUULP
      ZUVTWLWFWNABYCDUULYOYSUUBFUWLYEGXBWOYKUUHYNYRNRZUUAWPRZYDKZUWMEKZUUBBRZUU
      CYKUUGUWNYDYKUUGYLYQWPRZYPYMWPRZNRUWNYKYFUWRYHUWSNYGYFUWRMYBYIYFWQZTYIYHU
      WSMYBYGYHWQZVRWRYKYLYQYPYMYKYLUVCWSYKYQUVJWSZYKYPUVHWSYKYMUVEWSZUWEUWJWTX
      AXCYKYBUWMSJUUASJUUALWGUWOUWQMUWDYKYNYRUVFUVKXDYKYQYMUVJUVEVTYKYQYMUXBUXC
      UWEUWJXMABDEUWMUUAFGHXEWOYKEUUPDXFRJZYNSJZYRSJZUWQUUCMYKUUQUXDUVRUUPDEXGW
      CUVFUVKUXDUXEUXFXHUWPYTUUBBNYCUUPDYNEYRSUUTUUPUURXIYEXJXKWFXLYKUUIUUDUUJU
      UEYCYKUUIUWRYDKZYLEKUVLBRZUUDYGUUIUXGMYBYIYGYFUWRYDUWTXCTYKYBUVBUVPUWCUXG
      UXHMUWDUVCUVJUWEABDEYLYQFGHXEWOYKUUQUVBUVPUVQUWAUWBUXHUUDMUVRUVCUVJUVEUWH
      UWKYLYQYMBUUPDQUULESUWLUUTGUVSXNXOXLYKUUJUWSYDKZUUEYIUUJUXIMYBYGYIYHUWSYD
      UXAXCVRYKYPEKUVMBRZYSYMYQQRZEKZBRZUXIUUEYKUUQUVGUVQUVPUWBUWAUXJUXMMUVRUVH
      UVEUVJUWKUWHYPYMYQBUUPDQUULESUWLUUTGUVSXNXOYKYBUVGUVQUWIUXIUXJMUWDUVHUVEU
      WJABDEYPYMFGHXEWOYKUUBUXLYSBYKUUAUXKEYKYQYMUXBUXCXPXCXQXRXAWRXRXS $.

    $( TODO - Shorten using ~ qqhghm ! $)
    $( The ` QQHom ` homomorphism is a ring homomorphism if the target
       structure is a field.  If the target structure is a division ring, it is
       a group homomorphism, but not a ring homomorphism, because it does not
       preserve the ring multiplication operation.  (Contributed by Thierry
       Arnoux, 29-Oct-2017.) $)
    qqhrhm $p |- ( ( R e. Field /\ ( chr ` R ) = 0 )
                                       -> ( QQHom ` R ) e. ( Q RingHom R ) ) $=
      ( wcel cfv wceq cq caddc cmul eqid co cz fveq2d syl13anc vx vy cfield cc0
      cchr wa cplusg cmulr c1 cqqh cur qrngbas cvv qex ccnfld cnfldmul ressmulr
      qrng1 ax-mp cdr crg qdrng drngrng mp1i ccrg isfld simplbi adantr syl qqh1
      sylan cv cnumer cdenom cui simprbi ad2antrr cress crh zrhrhm zzsbase rhmf
      wf 3syl qnumcl ad2antrl ffvelrnd wne simplr jca cn qdencl nnzd nnne0d c0g
      elzrhunit syl12anc rdivmuldivd cdiv qeqnumdivden qqhvq eqtrd oveq12d zcnd
      ad2antll zmulcld mulne0d zzsmulr rhmmul syl3anc 3eqtrd 3eqtr4rd ressplusg
      divmuldivd cnfldadd qqhf unitmulcl eqeltrd dvrdir divadddivd zaddcld cghm
      rhmghm w3a zzsplusg ghmlin oveq1d rhmdvd syl132anc mulcomd oveq2d 3eqtr4d
      isrhmd ) DUCJZDUEKUDLZUFZUAUBMANDUGKZCDODUHKZUIDUJKZDUKKZCIULCIURYTPMUMJZ
      OCUHKLUNMUOCOUMIUPUQUSYRPZCUTJCVAJYPCIVBCVCVDYPDUTJZDVAJZYNUUCYOYNUUCDVEJ
      ZDVFZVGZVHDVCZVIZYNUUCYOUIYSKYTLUUGABDEFGHVJVKYPUAVLZMJZUBVLZMJZUFZUFZUUJ
      VMKZEKZUUJVNKZEKZBQZUULVMKZEKZUULVNKZEKZBQZYRQUUQUVBYRQZUUSUVDYRQZBQZUUJY
      SKZUULYSKZYRQUUJUULOQZYSKZUUOABYQDYRDVOKZUVDUUQUUSUVBFUVMPZYQPZGUUBYNUUEY
      OUUNYNUUCUUEUUFVPVQUUORAUUPEYPRAEWCZUUNYPUUDEUORVRQZDVSQJZUVPUUIDEUVQUVQP
      ZHVTZRAUVQDEUVQUVSWAZFWBWDVHZUUKUUPRJZYPUUMUUJWEWFZWGUUOUUCYOUFZUURRJZUUR
      UDWHZUUSUVMJZUUOUUCYOYNUUCYOUUNUUGVQZYNYOUUNWIWJZUUOUURUUKUURWKJYPUUMUUJW
      LWFZWMZUUOUURUWKWNZADEUURDWOKZFHUWNPZWPWQZUUORAUVAEUWBUUMUVARJZYPUUKUULWE
      XEZWGUUOUWEUVCRJZUVCUDWHZUVDUVMJZUWJUUOUVCUUMUVCWKJYPUUKUULWLXEZWMZUUOUVC
      UXBWNZADEUVCUWNFHUWOWPWQZWRUUOUVIUUTUVJUVEYRUUOUVIUUPUURWSQZYSKZUUTUUKUVI
      UXGLYPUUMUUKUUJUXFYSUUJWTZSWFZUUOUWEUWCUWFUWGUXGUUTLUWJUWDUWLUWMABDEUUPUU
      RFGHXATZXBUUOUVJUVAUVCWSQZYSKZUVEUUMUVJUXLLYPUUKUUMUULUXKYSUULWTZSXEZUUOU
      WEUWQUWSUWTUXLUVELUWJUWRUXCUXDABDEUVAUVCFGHXATZXBXCUUOUVLUUPUVAOQZUURUVCO
      QZWSQZYSKZUXPEKZUXQEKZBQZUVHUUOUVKUXRYSUUOUVKUXFUXKOQUXRUUOUUJUXFUULUXKOU
      UKUUJUXFLYPUUMUXHWFZUUMUULUXKLYPUUKUXMXEZXCUUOUUPUURUVAUVCUUOUUPUWDXDZUUO
      UURUWLXDZUUOUVAUWRXDZUUOUVCUXCXDZUWMUXDXNXBSUUOUWEUXPRJUXQRJZUXQUDWHZUXSU
      YBLUWJUUOUUPUVAUWDUWRXFUUOUURUVCUWLUXCXFZUUOUURUVCUYFUYHUWMUXDXGZABDEUXPU
      XQFGHXATUUOUXTUVFUYAUVGBUUOUVRUWCUWQUXTUVFLUUOUUDUVRUUOUUCUUDUWIUUHVIZUVT
      VIZUWDUWRUUPUVAUVQDOYRERUWAUVQUVSXHZUUBXIXJUUOUVRUWFUWSUYAUVGLUYNUWLUXCUU
      RUVCUVQDOYRERUWAUYOUUBXIXJZXCXKXLFUUANCUGKLUNMNUOCUMIXOXMUSUVOYNUUCYOMAYS
      WCUUGABDEFGHXPVKUUOUUPUVCOQZEKZUVAUUROQZEKZYQQZUYABQZUYRUYABQZUYTUYABQZYQ
      QZUUJUULNQZYSKZUVIUVJYQQUUOUUDUYRAJUYTAJUYAUVMJVUBVUELUYMUUORAUYQEUWBUUOU
      UPUVCUWDUXCXFZWGUUORAUYSEUWBUUOUVAUURUWRUWLXFZWGUUOUYAUVGUVMUYPUUOUUDUWHU
      XAUVGUVMJUYMUWPUXEDYRUVMUUSUVDUVNUUBXQXJXRABYQDUVMUYRUYTUYAFUVNUVOGXSTUUO
      VUGUYQUYSNQZUXQWSQZYSKZVUJEKZUYABQZVUBUUOVUFVUKYSUUOVUFUXFUXKNQVUKUUOUUJU
      XFUULUXKNUYCUYDXCUUOUUPUURUVAUVCUYEUYFUYGUYHUWMUXDXTXBSUUOUWEVUJRJUYIUYJV
      ULVUNLUWJUUOUYQUYSVUHVUIYAUYKUYLABDEVUJUXQFGHXATUUOEUVQDYBQJZUYQRJZUYSRJZ
      VUNVUBLUUOUVRVUOUYNUVQDEYCVIVUHVUIVUOVUPVUQYDVUMVUAUYABNYQUVQDUYQEUYSRUWA
      UVQUVSYEUVOYFYGXJXKUUOUVIVUCUVJVUDYQUUOUVIUXGUUTVUCUXIUXJUUOUVRUWCUWFUWSU
      WHUXAUUTVUCLUYNUWDUWLUXCUWPUXEUUPUURUVCBUVQDOUVMERUVNUWAGUYOYHYIXKUUOUVJU
      XLVUDUXNUUOUVEUYTUVCUUROQZEKZBQZUXLVUDUUOUVRUWQUWSUWFUXAUWHUVEVUTLUYNUWRU
      XCUWLUXEUWPUVAUVCUURBUVQDOUVMERUVNUWAGUYOYHYIUXOUUOUYAVUSUYTBUUOUXQVUREUU
      OUURUVCUYFUYHYJSYKYLXBXCYLYM $.
  $}

  ${
    qqhnm.n $e |- N = ( norm ` R ) $.
    qqhnm.z $e |- Z = ( ZMod ` R ) $.
    $( The norm of the image by ` QQHom ` of a rational number in a topological
       division ring.  (Contributed by Thierry Arnoux, 8-Nov-2017.) $)
    qqhnm $p |- ( ( ( R e. ( NrmRing i^i DivRing ) /\ Z e. NrmMod
      /\ ( chr ` R ) = 0 ) /\ Q e. QQ )
      -> ( N ` ( ( QQHom ` R ) ` Q ) ) = ( abs ` Q ) ) $=
      ( cnrg cdr wcel cfv cc0 wceq wa cabs cdiv co fveq2d syl cz eqid cnlm cchr
      cin w3a cq cnumer cdenom cqqh simpr qeqnumdivden qnumcl zcnd qdencl nncnd
      cn wne nnne0 3syl absdivd czrh cdvr simpl1 sseldi simpl3 qqhvval syl21anc
      inss2 cbs cnzr cui inss1 drngnzr crg ccnfld crh wf drngrng zrhrhm zzsbase
      cress rhmf 4syl ffvelrnd c0g elzrhunit syl22anc nmdvr simpl2 zhmnrg zrhnm
      nnzd syl31anc oveq12d 3eqtrrd ) BGHUCZIZDUAIZBUBJKLZUDZAUEIZMZANJZAUFJZAU
      GJZOPZNJZXCNJZXDNJZOPZABUHJJZCJZXAWTXBXFLWSWTUIZWTAXENAUJQRXAXCXDXAXCXAWT
      XCSIZXLAUKRZULXAXDXAWTXDUOIZXLAUMZRZUNXAWTXOXDKUPZXLXPXDUQURZUSXAXKXCBUTJ
      ZJZXDXTJZBVAJZPZCJZYACJZYBCJZOPZXIXABHIZWRWTXKYELXAWOHBGHVGWPWQWRWTVBZVCZ
      WPWQWRWTVDZXLYIWRMWTMXJYDCBVHJZYCABXTYMTZYCTZXTTZVEQVFXABGIZBVIIZYAYMIYBB
      VJJZIZYEYHLXAWOGBGHVKYJVCZXAYIYRYKBVLRZXASYMXCXTXAYIBVMIXTVNSVTPZBVOPISYM
      XTVPYKBVQBXTUUCUUCTZYPVRSYMUUCBXTUUCUUDVSYNWAWBXNWCXAYIWRXDSIZXRYTYKYLXAX
      DXQWKZXSYMBXTXDBWDJZYNYPUUGTWEWFYAYBYCBYSCYMYNEYSTYOWGWFXAYFXGYGXHOXAWQDG
      IZYRXMYFXGLWPWQWRWTWHZXAYQUUHUUABDFWIRZUUBXNYMBXTXCCDYNEFYPWJWLXAWQUUHYRU
      UEYGXHLUUIUUJUUBUUFYMBXTXDCDYNEFYPWJWLWMWNWN $.
  $}

  ${
    $d d e q J $.  $d d e q R $.  $d e q Z $.
    qqhcn.q $e |- Q = ( CCfld |`s QQ ) $.
    qqhcn.j $e |- J = ( TopOpen ` Q ) $.
    qqhcn.z $e |- Z = ( ZMod ` R ) $.
    qqhcn.k $e |- K = ( TopOpen ` R ) $.
    $( The ` QQHom ` homomorphism is a continuous function.  (Contributed by
       Thierry Arnoux, 9-Nov-2017.) $)
    qqhcn $p |- ( ( R e. ( NrmRing i^i DivRing ) /\ Z e. NrmMod
                       /\ ( chr ` R ) = 0 ) -> ( QQHom ` R ) e. ( J Cn K ) ) $=
      ( vq cnrg cdr wcel cfv cc0 wceq cq co eqid ccnfld vd ve cin cnlm cchr w3a
      cqqh ccn ccnp wa cds cbs cxp cres cmopn wf cv cabs cmin ccom clt wbr wral
      wi crp wrex inss2 sseli 3ad2ant1 simp3 cdvr czrh qqhf syl2anc simpr qsscn
      cnm cc sseldi cneg 0cn cnmetdval mpan df-neg fveq2i a1i absneg 3eqtr2d cz
      syl zssq sselii ovresd qqhnm adantlr 3eqtr4d ad2antrr ffvelrnd cngp inss1
      0z csg nrgngp ngpdsr syl3anc c0g qqh0 oveq2d cgrp ngpgrp grpsubid1 fveq2d
      eqtrd 3eqtrd eqtr4d breq1d biimpd ralrimiva imbi1d ralbidv rspcev cxmt wb
      breq2 cress cvv cnfldxms qex ressxms mp2an eqeltri qrngbas ax-mp xmsxmet2
      cxme mp1i 3syl xmstopn ctmd ctgp cnfldds ressds ngpxms mpbir2and eleqtrrd
      reseq1i metcnp fveq1d cghm csubg cnfldtgp csubrg qsubdrg simpli subrgsubg
      subgtgp tgptmd ctrg nrgtrg trgtmd2 qqhghm ghmcnp mpbid simprd ) BKLUCZMZE
      UDMZBUENOPZUFZOQMZBUGNZCDUHRMZUVIUVKOCDUIRZNZMZUVJUVLUJZUVIUVKOCBUKNZBULN
      ZUVRUMUNZUONZUIRZNZUVNUVIUVKUWBMZQUVRUVKUPZOJUQZURUSUTZQQUMZUNZRZUAUQZVAV
      BZOUVKNZUWEUVKNZUVSRZUBUQZVAVBZVDZJQVCZUAVEVFZUBVEVCZUVIBLMZUVHUWDUVFUVGU
      XAUVHUVELBKLVGVHVIZUVFUVGUVHVJZUVRBVKNZBBVLNZUVRSZUXDSZUXESZVMVNZUVIUWSUB
      VEUVIUWOVEMZUJZUXJUWIUWOVAVBZUWPVDZJQVCZUWSUVIUXJVOUXKUXMJQUXKUWEQMZUJZUX
      LUWPUXPUWIUWNUWOVAUXPUWIUWMBVQNZNZUWNUXPOUWEUWFRZUWEURNZUWIUXRUXPUWEVRMZU
      XSUXTPUXPQVRUWEVPUXKUXOVOZVSUYAUXSOUWEUSRZURNZUWEVTZURNZUXTOVRMUYAUXSUYDP
      WAOUWEUWFUWFSWBWCUYFUYDPUYAUYEUYCURUWEWDWEWFUWEWGWHWJUXPOUWEUWFQUVJUXPWIQ
      OWKXAWLZWFZUYBWMUVIUXOUXRUXTPUXJUWEBUXQEUXQSZHWNWOWPUXPUWNUWLUWMUVQRZUWMU
      WLBXBNZRZUXQNZUXRUXPUWLUWMUVQUVRUXPQUVROUVKUVIUWDUXJUXOUXIWQZUYHWRZUXPQUV
      RUWEUVKUYNUYBWRZWMUXPBWSMZUWLUVRMUWMUVRMZUYJUYMPUXPBKMZUYQUVIUYSUXJUXOUVF
      UVGUYSUVHUVEKBKLWTVHZVIZWQBXCZWJZUYOUYPUWLUWMUVQBUYKUXQUVRUYIUXFUYKSZUVQS
      ZXDXEUXPUYLUWMUXQUXPUYLUWMBXFNZUYKRZUWMUXPUWLVUFUWMUYKUXPUXAUVHUWLVUFPUVI
      UXAUXJUXOUXBWQUVIUVHUXJUXOUXCWQUVRUXDBUXEUXFUXGUXHXGVNXHUXPBXIMZUYRVUGUWM
      PUXPUYQVUHVUCBXJWJUYPUVRBUYKUWMVUFUXFVUFSVUDXKVNXMXLXNXOXPXQXRUWRUXNUAUWO
      VEUWJUWOPZUWQUXMJQVUIUWKUXLUWPUWJUWOUWIVAYDXSXTYAVNXRUVIUWHQYBNMZUVSUVRYB
      NMZUVJUWCUWDUWTUJYCAYOMZVUJUVIATQYERZYOFTYOMQYFMZVUMYOMYGYHQTYFYIYJYKZUWF
      AQAFYLZVUNUWFAUKNZPYHQUWFTAYFFUUAUUBYMZYNYPUVIBYOMZVUKUVFUVGVUSUVHUVFUYSU
      YQVUSUYTVUBBUUCYQVIZUVQBUVRUXFVUEYNWJUVJUVIUYGWFUBUAJUWHUVSOUVKCUVTQUVRVU
      LCUWHUONPVUOUWHCAQGVUPUWFVUQUWGVURUUFYRYMUVTSUUGXEUUDUVIOUVMUWAUVIDUVTCUI
      UVIVUSDUVTPVUTUVSDBUVRIUXFUVSSYRWJXHUUHUUEUVIAYSMZBYSMZUVKABUUIRMZUVOUVPY
      CAYTMZVVAUVITYTMQTUUJNMZVVDUUKQTUULNMZVVEVVFVUMLMUUMUUNQTUUOYMQTAFUUPYJAU
      UQYPUVIUYSBUURMVVBVUABUUSBUUTYQUVIUXAUVHVVCUXBUXCUVRUXDABUXEUXFUXGUXHFUVA
      VNOUVKABCDQVUPGIUVBXEUVCUVD $.
  $}

  ${
    $d d e p q B $.  $d d e p q R $.  $d p V $.  $d d e p q ph $.
    qqhucn.b $e |- B = ( Base ` R ) $.
    qqhucn.q $e |- Q = ( CCfld |`s QQ ) $.
    qqhucn.u $e |- U = ( UnifSt ` Q ) $.
    qqhucn.v $e |- V = ( metUnif ` ( ( dist ` R ) |` ( B X. B ) ) ) $.
    qqhucn.z $e |- Z = ( ZMod ` R ) $.
    qqhucn.1 $e |- ( ph -> R e. NrmRing ) $.
    qqhucn.2 $e |- ( ph -> R e. DivRing ) $.
    qqhucn.3 $e |- ( ph -> Z e. NrmMod ) $.
    qqhucn.4 $e |- ( ph -> ( chr ` R ) = 0 ) $.
    $( The ` QQHom ` homomorphism is uniformly continuous.  (Contributed by
       Thierry Arnoux, 28-Jan-2018.) $)
    qqhucn $p |- ( ph -> ( QQHom ` R ) e. ( U uCn V ) ) $=
      ( cfv cq co wcel vp vq vd ve cqqh cabs cmin ccom cxp cres cmetu wf cv clt
      cucn wbr cds wi wral crp wrex wa cdr cchr cc0 wceq cdvr czrh eqid syl2anc
      qqhf simpr simplr ovresd cc qsscn sseldi cnmetdval eqtrd abssub ffvelrnda
      eqtr4d adantr csg cnm cngp cnrg nrgngp syl ad2antrr ngpdsr syl3anc ccnfld
      csubg csubrg cress qsubdrg simpli subrgsubg ax-mp cnfldsub subgsub mp3an1
      fveq2d cghm simpll qqhghm qrngbas ghmsub eqtr2d cnlm elin sylanbrc qsubcl
      jca cin qqhnm syl31anc 3eqtrd breq1d biimpd ralrimiva imbi1d 2ralbidv wne
      breq2 c0 ne0i a1i 4syl cxmt cpsmet cxme cvv xmsxmet2 xmetpsmet cuss crest
      qex 3eqtri rspcev cz 0z zq crg cur drngrng rngidcl cnfldxms ressxms mp2an
      eqeltri cnfldds ressds ngpxms metucn mpbird fveq2i cnflduss oveq1i cnxmet
      mp1i ressuss wss restmetu mp3an oveq1d eleqtrrd ) ADUEQZUFUGUHZRRUIZUJZUK
      QZFUOSZEFUOSAUVIUVNTRBUVIULZUAUMZUBUMZUVLSZUCUMZUNUPZUVPUVIQZUVQUVIQZDUQQ
      ZBBUIUJZSZUDUMZUNUPZURZUBRUSUARUSZUCUTVAZUDUTUSZVBAUVOUWKADVCTZDVDQVEVFZU
      VONPBDVGQZDDVHQZHUWNVIZUWOVIZVKVJZAUWJUDUTAUWFUTTZVBUWSUVRUWFUNUPZUWGURZU
      BRUSZUARUSZUWJAUWSVLAUXCUWSAUXBUARAUVPRTZVBZUXAUBRUXEUVQRTZVBZUWTUWGUXGUV
      RUWEUWFUNUXGUVRUVQUVPUGSZUFQZUWEUXGUVRUVPUVQUGSUFQZUXIUXGUVRUVPUVQUVJSZUX
      JUXGUVPUVQUVJRAUXDUXFVMZUXEUXFVLZVNUXGUVPVOTZUVQVOTZUXKUXJVFUXGRVOUVPVPUX
      LVQZUXGRVOUVQVPUXMVQZUVPUVQUVJUVJVIVRVJVSUXGUXOUXNUXIUXJVFUXQUXPUVQUVPVTV
      JWBUXGUWEUWAUWBUWCSZUXIUXGUWAUWBUWCBUXEUWABTZUXFARBUVPUVIUWRWAWCZUXERBUVQ
      UVIAUVOUXDUWRWCWAZVNUXGUXRUWBUWADWDQZSZDWEQZQZUXHUVIQZUYDQZUXIUXGDWFTZUXS
      UWBBTUXRUYEVFAUYHUXDUXFADWGTZUYHMDWHZWIWJUXTUYAUWAUWBUWCDUYBUYDBUYDVIZHUY
      BVIZUWCVIZWKWLUXGUYCUYFUYDUXGUYFUVQUVPCWDQZSZUVIQZUYCUXGUXHUYOUVIUXGUXFUX
      DVBZUXHUYOVFZUXGUXFUXDUXMUXLXOZRWMWNQTZUXFUXDUYRRWMWOQTZUYTVUAWMRWPSZVCTW
      QWRRWMWSWTRWMCUGUYNUVQUVPXAIUYNVIZXBXCWIXDUXGUVICDXESTZUXFUXDUYPUYCVFUXGA
      VUDAUXDUXFXFAUWLUWMVUDNPBUWNCDUWOHUWPUWQIXGVJWIUXMUXLRCDUVQUVIUYNUYBUVPCI
      XHZVUCUYLXIWLXJXDUXGDWGVCXPTZGXKTZUWMUXHRTZUYGUXIVFAVUFUXDUXFAUYIUWLVUFMN
      DWGVCXLXMWJAVUGUXDUXFOWJAUWMUXDUXFPWJUXGUYQVUHUYSUVQUVPXNWIUXHDUYDGUYKLXQ
      XRXSVSWBXTYAYBYBWCUWIUXCUCUWFUTUVSUWFVFZUWHUXAUAUBRRVUIUVTUWTUWGUVSUWFUVR
      UNYFYCYDUUAVJYBXOAUAUBUVLUWDUVMUVIFRBUCUDUVMVIKRYGYEZAVERTZVUJVEUUBTVUKUU
      CVEUUDWTRVEYHWTZYIAUWLDUUETDUUFQZBTBYGYENDUUGBDVUMHVUMVIUUHBVUMYHYJAUVLRY
      KQTZUVLRYLQTCYMTVUNACVUBYMIWMYMTRYNTZVUBYMTUUIYSRWMYNUUJUUKUULUVJCRVUEVUO
      UVJCUQQVFYSRUVJWMCYNIUUMUUNWTYOUVBUVLRYPWIAUWDBYKQTZUWDBYLQTAUYIUYHDYMTVU
      PMUYJDUUOUWCDBHUYMYOYJUWDBYPWIUUPUUQAEUVMFUOEUVMVFAEWMYQQZUVKYRSZUVJUKQZU
      VKYRSZUVMECYQQVUBYQQZVURJCVUBYQIUURVUOVVAVURVFYSRYNWMUVCWTYTVUQVUSUVKYRVU
      QVUQVIUUSUUTVUJUVJVOYLQTZRVOUVDVUTUVMVFVULUVJVOYKQTVVBUVAUVJVOYPWTVPRUVJV
      OUVEUVFYTYIUVGUVH $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Canonical embedding of the real numbers into a complete ordered field
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c RRHom $.
  $c RRExt $.

  $( Map the real numbers into a complete field. $)
  crrh $a class RRHom $.

  $( Extend class notation with the class of extension fields of ` RR ` . $)
  crrext $a class RRExt $.

  $( Define the canonical homomorphism from the real numbers to any complete
     field, as the extension by continuity of the canonical homomorphism from
     the rational numbers.  (Contributed by Mario Carneiro, 22-Oct-2017.)
     (Revised by Thierry Arnoux, 23-Oct-2017.) $)
  df-rrh $a |- RRHom = ( r e. _V |->
    ( ( ( topGen ` ran (,) ) CnExt ( TopOpen ` r ) ) ` ( QQHom ` r ) ) ) $.

  ${
    $d r J $.  $d r K $.  $d r R $.
    rrhval.1 $e |- J = ( topGen ` ran (,) ) $.
    rrhval.2 $e |- K = ( TopOpen ` R ) $.
    $( Value of the canonical homormorphism from the real numbers to a complete
       space.  (Contributed by Thierry Arnoux, 2-Nov-2017.) $)
    rrhval $p |- ( R e. V
      -> ( RRHom ` R ) = ( ( J CnExt K ) ` ( QQHom ` R ) ) ) $=
      ( vr wcel cvv crrh cfv cqqh ccnext co wceq elex cv cioo ctopn fveq2 fvmpt
      crn ctg eqcomi a1i syl6eqr oveq12d fveq12d df-rrh fvex syl ) ADHAIHAJKALK
      ZBCMNZKZOADPGAGQZLKZRUBUCKZUOSKZMNZKUNIJUOAOZUPULUSUMUTUQBURCMUQBOUTBUQEU
      DUEUTURASKCUOASTFUFUGUOALTUHGUIULUMUJUAUK $.
  $}

  ${
    rrhf.d $e |- D = ( ( dist ` R ) |` ( B X. B ) ) $.
    rrhf.j $e |- J = ( topGen ` ran (,) ) $.
    rrhf.b $e |- B = ( Base ` R ) $.
    rrhf.k $e |- K = ( TopOpen ` R ) $.
    rrhf.z $e |- Z = ( ZMod ` R ) $.
    rrhf.1 $e |- ( ph -> R e. DivRing ) $.
    rrhf.2 $e |- ( ph -> R e. NrmRing ) $.
    rrhf.3 $e |- ( ph -> Z e. NrmMod ) $.
    rrhf.4 $e |- ( ph -> ( chr ` R ) = 0 ) $.
    rrhf.5 $e |- ( ph -> R e. CUnifSp ) $.
    rrhf.6 $e |- ( ph -> ( UnifSt ` R ) = ( metUnif ` D ) ) $.
    $( If the topology of ` R ` is Hausdorff, and ` R ` is a complete uniform
       space, then the canonical homomorphism from the real numbers to ` R ` is
       continuous.  (Contributed by Thierry Arnoux, 17-Jan-2018.) $)
    rrhcn $p |- ( ph -> ( RRHom ` R ) e. ( J Cn K ) ) $=
      ( cfv wcel crrh cqqh ccnext co ccn ctps wceq cxme cnrg cngp nrgngp ngpxms
      3syl xmstps syl rrhval cq ccnfld cr cress cuss eqid rebase cioo crn ctopn
      ctg tgioo3 3eqtri cvv wss reex qssre ressabs mp2an eqcomi fveq2i cnfldtps
      resstps a1i cusp ccusp recusp cuspusp ax-mp cmopn xmstopn xmsxmet methaus
      cha cxmt eqeltrd cmetu cucn czlm cres cnlm syl5eqelr qqhucn eqcomd oveq2d
      cds cxp eleqtrd ccl fveq1i qdensere eqtri ucnextcn ) ADUASZDUBSZEFUCUDSZE
      FUEUDADUFTZXJXLUGADUHTZXMADUITDUJTXNNDUKDULUMZDUNUOZDEFUFIKUPUOAUQURUSUTU
      DZVASZURUQUTUDZVASZDVASZXKEFXQDUSBXQXQVBZVCJEVDVEVGSZXQVFSZYDIYDYDVBZVHYE
      VIKXRVBXSXQUQUTUDZVAYFXSUSVJTZUQUSVKZYFXSUGVLVMUSUQURVJVNVOVPVQYAVBXQUFTZ
      AURUFTYGYIVRVLUSURVJVSVOVTXQWATZAXQWBTYJXQYBWCXQWDWEVTXPQAFCWFSZWJAXNFYKU
      GXOCFDBKJHWGUOAXNCBWKSTYKWJTXOCDBJHWHCYKBYKVBWIUMWLYHAVMVTAXKXTCWMSZWNUDX
      TYAWNUDABXSDXTYLDWOSZJXSVBXTVBCDXBSBBXCWPWMHVQYMVBNMAYMGWQLOWRPWSAYLYAXTW
      NAYAYLRWTXAXDUQEXESZSZUSUGAYOUQYCXESZSUSUQYNYPEYCXEIVQXFXGXHVTXIWL $.

    $( If the topology of ` R ` is Hausdorff, Cauchy sequences have at most one
       limit, i.e. the canonical homomorphism of ` RR ` into ` R ` is a
       function.  (Contributed by Thierry Arnoux, 2-Nov-2017.) $)
    rrhf $p |- ( ph -> ( RRHom ` R ) : RR --> B ) $=
      ( cr wcel crrh cfv wf cuni cioo crn ctg ccn eqid rrhcn uniretop cnf eqidd
      co syl ctps wceq cxme cnrg cngp nrgngp ngpxms xmstps tpsuni feq23d mpbird
      3syl ) ASBDUAUBZUCSFUDZVHUCZAVHUEUFUGUBZFUHUNTVJABCDVKFGHVKUIJKLMNOPQRUJV
      HVKFSVIUKVIUIULUOASBSVIVHASUMADUPTZBVIUQADURTZVLADUSTDUTTVMNDVADVBVGDVCUO
      BFDJKVDUOVEVF $.
  $}

  $( Define the class of extensions of ` RR ` .  This is a shorthand for
     listing the necessary conditions for a structure to admit a canonical
     embedding of ` RR ` into it.  Interestingly, this is not coming from a
     mathematical reference, but was from the necessary conditions to build the
     embedding at each step ( ` ZZ ` , ` QQ ` and ` RR ` ).  It would be
     interesting see if this is formally treated in the literature.  See
     ~ isrrext for a better readable version.  (Contributed by Thierry Arnoux,
     2-May-2018.) $)
  df-rrext $a |- RRExt = { r e. ( NrmRing i^i DivRing ) |
     ( ( ( ZMod ` r ) e. NrmMod /\ ( chr ` r ) = 0 ) /\ ( r e. CUnifSp
     /\ ( UnifSt ` r ) = ( metUnif ` ( ( dist ` r )
     |` ( ( Base ` r ) X. ( Base ` r ) ) ) ) ) ) } $.

  ${
    $d r D $.  $d r R $.  $d r Z $.
    isrrext.b $e |- B = ( Base ` R ) $.
    isrrext.v $e |- D = ( ( dist ` R ) |` ( B X. B ) ) $.
    isrrext.z $e |- Z = ( ZMod ` R ) $.
    $( Express the property " ` R ` is an extension of ` RR ` ".  (Contributed
       by Thierry Arnoux, 2-May-2018.) $)
    isrrext $p |- ( R e. RRExt <-> ( ( R e. NrmRing /\ R e. DivRing ) /\
      ( Z e. NrmMod /\ ( chr ` R ) = 0 ) /\ ( R e. CUnifSp
      /\ ( UnifSt ` R ) = ( metUnif ` D ) ) ) ) $=
      ( vr cnrg cdr wcel cnlm cchr cfv cc0 wceq wa ccusp cuss fveq2 crrext elin
      cin cmetu w3a anbi1i cv czlm cds cbs eleq1d eleq1i syl6bbr eqeq1d anbi12d
      cres eleq1 syl6eqr xpeq12d reseq12d fveq2d eqeq12d df-rrext elrab2 3anass
      cxp 3bitr4i ) CIJUCZKZDLKZCMNZOPZQZCRKZCSNZBUDNZPZQZQZQCIKCJKQZVSQCUAKVTV
      MVRUEVIVTVSCIJUBUFHUGZUHNZLKZWAMNZOPZQZWARKZWASNZWAUINZWAUJNZWJVFZUPZUDNZ
      PZQZQVSHCVHUAWACPZWFVMWOVRWPWCVJWEVLWPWCCUHNZLKVJWPWBWQLWACUHTUKDWQLGULUM
      WPWDVKOWACMTUNUOWPWGVNWNVQWACRUQWPWHVOWMVPWACSTWPWLBUDWPWLCUINZAAVFZUPBWP
      WIWRWKWSWACUITWPWJAWJAWPWJCUJNAWACUJTEURZWTUSUTFURVAVBUOUOHVCVDVTVMVRVEVG
      $.
  $}

  $( An extension of ` RR ` is a normed ring.  (Contributed by Thierry Arnoux,
     2-May-2018.) $)
  rrextnrg $p |- ( R e. RRExt -> R e. NrmRing ) $=
    ( crrext wcel cnrg cdr wa czlm cfv cnlm cchr cc0 wceq cuss cds cbs cxp cres
    ccusp cmetu eqid isrrext simp1bi simpld ) ABCZADCZAECZUDUEUFFAGHZICAJHKLFAR
    CAMHANHAOHZUHPQZSHLFUHUIAUGUHTUITUGTUAUBUC $.

  $( An extension of ` RR ` is a division ring.  (Contributed by Thierry
     Arnoux, 2-May-2018.) $)
  rrextdrg $p |- ( R e. RRExt -> R e. DivRing ) $=
    ( crrext wcel cnrg cdr wa czlm cfv cnlm cchr cc0 wceq cuss cds cbs cxp cres
    ccusp cmetu eqid isrrext simp1bi simprd ) ABCZADCZAECZUDUEUFFAGHZICAJHKLFAR
    CAMHANHAOHZUHPQZSHLFUHUIAUGUHTUITUGTUAUBUC $.

  ${
    rrextnlm.z $e |- Z = ( ZMod ` R ) $.
    $( The norm of an extension of ` RR ` is absolutely homogeneous.
       (Contributed by Thierry Arnoux, 2-May-2018.) $)
    rrextnlm $p |- ( R e. RRExt -> Z e. NrmMod ) $=
      ( crrext wcel cnlm cchr cfv cc0 wceq cnrg cdr ccusp cuss cds cbs cxp cres
      wa eqid cmetu isrrext simp2bi simpld ) ADEZBFEZAGHIJZUEAKEALESUFUGSAMEANH
      AOHAPHZUHQRZUAHJSUHUIABUHTUITCUBUCUD $.
  $}

  $( The ring characteristic of an extension of ` RR ` is zero.  (Contributed
     by Thierry Arnoux, 2-May-2018.) $)
  rrextchr $p |- ( R e. RRExt -> ( chr ` R ) = 0 ) $=
    ( crrext wcel czlm cfv cnlm cchr cc0 wceq cnrg cdr wa cuss cds cbs cxp cres
    ccusp cmetu eqid isrrext simp2bi simprd ) ABCZADEZFCZAGEHIZUDAJCAKCLUFUGLAR
    CAMEANEAOEZUHPQZSEILUHUIAUEUHTUITUETUAUBUC $.

  $( An extension of ` RR ` is a complete uniform space.  (Contributed by
     Thierry Arnoux, 2-May-2018.) $)
  rrextcusp $p |- ( R e. RRExt -> R e. CUnifSp ) $=
    ( crrext wcel ccusp cuss cfv cds cbs cxp cres cmetu wceq cnrg cdr czlm cnlm
    wa cchr cc0 eqid isrrext simp3bi simpld ) ABCZADCZAEFAGFAHFZUFIJZKFLZUDAMCA
    NCQAOFZPCARFSLQUEUHQUFUGAUIUFTUGTUITUAUBUC $.

  $( An extension of ` RR ` is a topological space.  (Contributed by Thierry
     Arnoux, 7-Sep-2018.) $)
  rrexttps $p |- ( R e. RRExt -> R e. TopSp ) $=
    ( crrext wcel cxme ctps cnrg cngp rrextnrg nrgngp ngpxms 3syl xmstps syl )
    ABCZADCZAECNAFCAGCOAHAIAJKALM $.

  ${
    rrexthaus.1 $e |- K = ( TopOpen ` R ) $.
    $( The topology of an extension of ` RR ` is Hausdorff.  (Contributed by
       Thierry Arnoux, 7-Sep-2018.) $)
    rrexthaus $p |- ( R e. RRExt -> K e. Haus ) $=
      ( crrext wcel cds cfv cbs cxp cres cmopn cha cxme wceq cnrg cngp rrextnrg
      nrgngp 3syl eqid ngpxms xmstopn syl cxmt xmsxmet methaus eqeltrd ) ADEZBA
      FGAHGZUIIJZKGZLUHAMEZBUKNUHAOEAPEULAQARAUASZUJBAUICUITZUJTZUBUCUHULUJUIUD
      GEUKLEUMUJAUIUNUOUEUJUKUIUKTUFSUG $.
  $}

  ${
    rrextust.b $e |- B = ( Base ` R ) $.
    rrextust.d $e |- D = ( ( dist ` R ) |` ( B X. B ) ) $.
    $( The uniformity of an extension of ` RR ` is the uniformity generated by
       its distance.  (Contributed by Thierry Arnoux, 2-May-2018.) $)
    rrextust $p |- ( R e. RRExt -> ( UnifSt ` R ) = ( metUnif ` D ) ) $=
      ( crrext wcel ccusp cuss cfv cmetu wceq cnrg cdr czlm cnlm cchr cc0 eqid
      wa isrrext simp3bi simprd ) CFGZCHGZCIJBKJLZUDCMGCNGTCOJZPGCQJRLTUEUFTABC
      UGDEUGSUAUBUC $.
  $}

  ${
    $( The field of the real numbers is an extension of the real numbers.
       (Contributed by Thierry Arnoux, 2-May-2018.) $)
    rerrext $p |- ( CCfld |`s RR ) e. RRExt $=
      ( ccnfld cr cress co crrext wcel cnrg cdr wa czlm cfv cnlm cchr cc0 ccusp
      wceq cuss resubdrg eqid pm3.2i cds cxp cmetu csubrg cnnrg simpli subrgnrg
      cres mp2an simpri cofld reofld ofldchr ax-mp recusp reust rebase mpbir3an
      rezh isrrext ) ABCDZEFVAGFZVAHFZIVAJKZLFZVAMKNPZIVAOFZVAQKVAUAKBBUBUHZUCK
      PZIVBVCAGFBAUDKFZVBUEVJVCRUFBAVAVASZUGUIVJVCRUJTVEVFVAVKUSVAUKFVFVAVKULVA
      UMUNTVGVIVAVKUOVAVKUPTBVHVAVDVAVKUQVHSVDSUTUR $.
  $}

  ${
    $( The field of the complex numbers is an extension of the real numbers.
       (Contributed by Thierry Arnoux, 2-May-2018.) $)
    cnrrext $p |- CCfld e. RRExt $=
      ( ccnfld crrext wcel cnrg cdr wa czlm cfv cnlm cchr cc0 wceq ccusp pm3.2i
      cr ax-mp eqid eqtr3i cc cres cuss cabs cmin ccom cmetu cnnrg cndrng cress
      cnzh co csubrg resubdrg simpli subrgchr reofld ofldchr cnfldcusp cnflduss
      cofld cnfldbas cxp cds wfn cme wf cnmet metf mp2b fnresdm cnfldds reseq1i
      ffn isrrext mpbir3an ) ABCADCZAECZFAGHZICZAJHZKLZFAMCZAUAHZUBUCUDZUEHLZFV
      OVPUFUGNVRVTUIAOUHUJZJHZVSKOAUKHCZWFVSLWGWEECULUMOAUNPWEUSCWFKLWEWEQUOWEU
      PPRNWAWDUQWBWBQURNSWCAVQUTWCSSVAZTZWCAVBHZWHTWCWHVCZWIWCLWCSVDHCWHOWCVEWK
      VFWCSVGWHOWCVLVHWHWCVIPWCWJWHVJVKRVQQVMVN $.
  $}

$(
  @{
    rrhfvale.b @e |- B = ( Base ` R ) @.
    rrhfvale.h @e |- H = ( RRHom ` R ) @.
    rrhfvale.j @e |- J = ( topGen ` ran (,) ) @.
    rrhfvale.k @e |- K = ( TopOpen ` R ) @.
    @( Value of the canonical embedding of ` RR ` into ` R ` at a given point
       ` A ` .  (Contributed by Thierry Arnoux, 8-Sep-2018.) @)
    rrhfvale @p |- ( ( R e. RRExt /\ A e. RR ) -> ( H ` A ) =
     U. ( ( K fLimf ( ( ( nei ` J ) ` { A } ) |`t QQ ) ) ` ( QQHom ` R ) ) ) @=
      ? @.
  @}
$)

  ${
    rrhfe.b $e |- B = ( Base ` R ) $.
    $( If ` R ` is an extension of ` RR ` , then the canonical homomorphism of
       ` RR ` into ` R ` is a function.  (Contributed by Thierry Arnoux,
       2-May-2018.) $)
    rrhfe $p |- ( R e. RRExt -> ( RRHom ` R ) : RR --> B ) $=
      ( crrext wcel cds cfv cxp cres cioo crn ctopn czlm eqid rrextdrg rrextnrg
      ctg rrextnlm rrextchr rrextcusp rrextust rrhf ) BDEABFGAAHIZBJKQGZBLGZBMG
      ZUCNZUDNCUENUFNZBOBPBUFUHRBSBTAUCBCUGUAUB $.
  $}

  ${
    rrhcne.j $e |- J = ( topGen ` ran (,) ) $.
    rrhcne.k $e |- K = ( TopOpen ` R ) $.
    $( If ` R ` is an extension of ` RR ` , then the canonical homomorphism of
       ` RR ` into ` R ` is continuous.  (Contributed by Thierry Arnoux,
       2-May-2018.) $)
    rrhcne $p |- ( R e. RRExt -> ( RRHom ` R ) e. ( J Cn K ) ) $=
      ( wcel cbs cfv cds cxp cres czlm eqid rrextdrg rrextnrg rrextnlm rrextchr
      crrext rrextcusp rrextust rrhcn ) ARFAGHZAIHUBUBJKZABCALHZUCMZDUBMZEUDMZA
      NAOAUDUGPAQASUBUCAUFUETUA $.
  $}

$(
  @{
    @( The ` RRHom ` homomorphism leaves rational numbers unchanged.
       (Contributed by Thierry Arnoux, 27-Mar-2018.) @)
    rrhqima @p |- ( ( R e. RRExt /\ Q e. QQ ) ->
      ( ( RRHom ` R ) ` Q ) = ( ( QQHom ` R ) ` Q ) ) @=
      ? @.

    @( The canonical homomorphism from the real numbers to any complete
       field is a monoid homomorphism. @)
    rrhmhm @p |- ( R e. RRExt
      -> ( RRHom ` R ) e. ( ( CCfld |`s RR ) MndHom R ) ) @=
      ? @.
  @}
$)

$(
      rrhrhm.3 @e |- ( ph -> R e. CUnifSp ) @.
      rrhrhm.1 @e |- W = ( CCfld |`s RR ) @.
      @( The ` RRHom ` homomorphism is a ring homomorphism if the target
         structure is a complete field.  @)
      rrhrhm @p |- ( ph -> ( RRHom ` R ) e. ( W RingHom R ) ) @=
        ? @.
$)


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Embedding from the extended real numbers into a complete lattice
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)


  $c RR*Hom $.

  $( Map the extended real numbers into a complete lattice. $)
  cxrh $a class RR*Hom $.

  ${
    $d r x $.
    $( Define an embedding from the extended real number into a complete
       lattice.  (Contributed by Thierry Arnoux, 19-Feb-2018.) $)
    df-xrh $a |- RR*Hom = ( r e. _V |->
      ( x e. RR* |-> if ( x e. RR , ( ( RRHom ` r ) ` x ) ,
        if ( x = +oo , ( ( lub ` r ) ` ( ( RRHom ` r ) " RR ) ) ,
                       ( ( glb ` r ) ` ( ( RRHom ` r ) " RR ) ) ) ) ) ) $.
  $}

  ${
    $d r x R $.  $d r B $.  $d r L $.  $d r U $.
    xrhval.b $e |- B = ( ( RRHom ` R ) " RR ) $.
    xrhval.l $e |- L = ( glb ` R ) $.
    xrhval.u $e |- U = ( lub ` R ) $.
    $( The value of the embedding from the extended real numbers into a
       complete lattice.  (Contributed by Thierry Arnoux, 19-Feb-2018.) $)
    xrhval $p |- ( R e. V -> ( RR*Hom ` R ) = ( x e. RR* |->
      if ( x e. RR , ( ( RRHom ` R ) ` x ) ,
         if ( x = +oo , ( U ` B ) , ( L ` B ) ) ) ) ) $=
      ( vr wcel cfv cxr cr crrh wceq cif club cglb fveq2 cxrh cv cpnf cmpt elex
      cvv cima eqidd fveq12d syl6eqr imaeq1d ifeq12d mpteq12dv xrex mptex fvmpt
      df-xrh syl ) CFKCUFKCUALAMAUBZNKZUSCOLZLZUSUCPZBDLZBELZQZQZUDZPCFUEJCAMUT
      USJUBZOLZLZVCVJNUGZVIRLZLZVLVISLZLZQZQZUDVHUFUAVICPZAMVRMVGVSMUHVSUTVKVBV
      QVFVSUSUSVJVAVICOTZVSUSUHUIVSVCVNVDVPVEVSVLBVMDVSVMCRLDVICRTIUJVSVLVANUGB
      VSVJVANVTUKGUJZUIVSVLBVOEVSVOCSLEVICSTHUJWAUIULULUMAJUQAMVGUNUOUPUR $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
             Canonical embeddings into the ordered field of the real numbers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $( The ` ZRHom ` homomorphism for the real number structure is the
       identity.  (Contributed by Thierry Arnoux, 31-Oct-2017.) $)
    zrhre $p |- ( ZRHom ` ( CCfld |`s RR ) ) = ( _I |` ZZ ) $=
      ( vn ccnfld cr cress co czrh cfv cz cv c1 cmg cmpt cid cres cdr wcel wceq
      crg csubrg eqid resubdrg simpri drngrng re1r zrhval2 mp2b cmul 1re remulg
      mpan2 zre ax-1rid syl eqtrd mpteq2ia mptresid 3eqtri ) BCDEZFGZAHAIZJURKG
      ZEZLZAHUTLMHNUROPZURRPUSVCQCBSGPVDUAUBURUCURVAJAUSBHDEZVETUSTVATURURTZUDU
      EUFAHVBUTUTHPZVBUTJUGEZUTVGJCPVBVHQUHJURUTVFUIUJVGUTCPVHUTQUTUKUTULUMUNUO
      AHUPUQ $.
  $}

  ${
    $( The ` QQHom ` homomorphism for the real number structure is the
       identity.  (Contributed by Thierry Arnoux, 31-Oct-2017.) $)
    qqhre $p |- ( QQHom ` ( CCfld |`s RR ) ) = ( _I |` QQ ) $=
      ( vq ccnfld cr co cfv cq cmpt cid cres wceq wcel cc0 cz wf1 ax-mp wb eqid
      zrhre mp2b cdiv cress cqqh cv wtru wf cdr cchr csubrg resubdrg simpri crg
      drngrng czrh wss wf1o f1oi f1of1 zssre f1ss mp2an f1eq1 mpbir rebase re0g
      zrhchr mpbiri cdvr qqhf a1i feqmptd cnumer cdenom qqhvval mpanl12 wne f1f
      trud qnumcl ffvelrnd qdencl nnzd wa anim1i ccnv cima zrhf1ker mpbi eleq2i
      csn wfn fniniseg fvex elsnc 3bitr3ri sylibr nnne0d adantr neneqd pm2.65da
      ffn neneqad redvr syl3anc fveq1i fvresi syl5eq qeqnumdivden eqtr4d 3eqtrd
      syl oveq12d mpteq2ia mptresid 3eqtri ) BCUADZUBEZAFAUCZXPEZGZAFXQGHFIXPXS
      JUDAFCXPFCXPUEZUDXOUFKZXOUGELJZXTCBUHEKYAUIUJZYAXOUKKZYBYCXOULZYDYBMCXOUM
      EZNZYGMCHMIZNZMMYHNZMCUNYIMMYHUOYJMUPMMYHUQOURMMCYHUSUTYFYHJYGYIPRMCYFYHV
      AOVBZCXOYFLXOXOQZVCZYFQZXOYLVDZVEVFSZCXOVGEZXOYFYMYQQZYNVHUTVIVJVQAFXRXQX
      QFKZXRXQVKEZYFEZXQVLEZYFEZYQDZUUAUUCTDZXQYAYBYSXRUUDJYCYPCYQXQXOYFYMYRYNV
      MVNYSUUACKUUCCKUUCLVOUUDUUEJYSMCYTYFMCYFUEZYSYGUUFYKMCYFVPOZVIZXQVRZVSYSM
      CUUBYFUUHYSUUBXQVTZWAZVSYSUUCLYSUUCLJZUUBLJZYSUULWBZUUBMKZUULWBZUUMYSUUOU
      ULUUKWCUUBYFWDLWIZWEZKZUUBUUQKUUPUUMUURUUQUUBYGUURUUQJZYKYAYDYGUUTPYCYECX
      OYFLYMYNYOWFSWGWHUUFYFMWJUUSUUPPUUGMCYFWTMLUUBYFWKSUUBLXQVLWLWMWNWOUUNUUB
      LYSUUBLVOUULYSUUBUUJWPWQWRWSXAUUAUUCXOYLXBXCYSUUEYTUUBTDXQYSUUAYTUUCUUBTY
      SYTMKZUUAYTJUUIUVAUUAYTYHEYTYTYFYHRXDMYTXEXFXJYSUUOUUCUUBJUUKUUOUUCUUBYHE
      UUBUUBYFYHRXDMUUBXEXFXJXKXQXGXHXIXLAFXMXN $.
  $}

  ${
    $d a b x $.  $d x y $.  $d x z $.
    $( The ` RRHom ` homomorphism for the real numbers structure is the
       identity.  (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    rrhre $p |- ( RRHom ` ( CCfld |`s RR ) ) = ( _I |` RR ) $=
      ( va vb cr co cfv cid cres wceq wtru cq uniretop wcel a1i retop ax-mp wss
      eqid qssre mp2an cvv ccnfld cress crrh cioo crn ctg cha rehaus crrext ccn
      vx rerrext ctopn tgioo3 rrhcne mp1i ctopon ctop toptopon mpbi idcn ccnext
      wf wf1o f1oi f1of fss ccl qdensere cv csn cnei crest cflf c0 cima wrex wi
      wne wral wa cin simplr simpr opnneip syl3anc fvex qex elrestr mp3an12 syl
      inss2 resiima inss1 eqsstri imaeq2 sseq1d syl2anc ex ralrimiva ancli cfil
      rspcev wb eleq2i biimpri trnei mpbid mp3an13 mpbird ne0i adantl creg cusp
      isflf ccusp recusp cuspusp uspreg resabs1 cnrest cnextfres trud cqqh ccms
      eqeltrri recms elexi rrhval qqhre fveq2i eqtri reseq1i 3eqtr4i hauseqcn )
      UACUBDZUCEZFCGZHIJYQYRUDUEUFEZYSCKYSUGLZIUHMZYPUILYQYSYSUJDZLIULYPYSYSYSQ
      ZYPUMEZUUDQUNZUOUPYRUUBLZIYSCUQELZUUFYSURLZUUGNYSCKUSUTZYSCVAOZMYQJGZYRJG
      ZHIFJGZYSYSVBDZEZJGZUUMUUKUULUUPUUMHIUKJCCUUMYSYSKKUUHINMUUAJCUUMVCZIJJUU
      MVCZJCPZUUQJJUUMVDUURJVEJJUUMVFORJJCUUMVGSZMUUSIRMZJYSVHEEZCHIVIMZUKVJZCL
      ZUUMYSUVDVKZYSVLEZEZJVMDZVNDEZVOVSZIUVEUVDUVJLZUVKUVEUVLUVEUVDAVJZLZUUMBV
      JZVPZUVMPZBUVIVQZVRZAYSVTZWAZUVEUVTUVEUVSAYSUVEUVMYSLZWAZUVNUVRUWCUVNWAZU
      VMJWBZUVILZUUMUWEVPZUVMPZUVRUWDUVMUVHLZUWFUWDUUHUWBUVNUWIUUHUWDNMUVEUWBUV
      NWCUWCUVNWDUVDYSUVMWEWFUVHTLJTLUWIUWFUVFUVGWGWHUVMJUVHTTWIWJWKUWHUWDUWGUW
      EUVMUWEJPUWGUWEHUVMJWLJUWEWMOUVMJWNWOMUVQUWHBUWEUVIUVOUWEHUVPUWGUVMUVOUWE
      UUMWPWQXCWRWSWTXAUVEUVIJXBELZUVLUWAXDZUVEUVDUVBLZUWJUWLUVEUVBCUVDVIXEXFUU
      GUUSUVEUWLUWJXDUUIRJUVDYSCXGWJXHUUGUWJUUQUWKUUIUUTUVDAUUMYSUVICJBXOXIWKXJ
      UVJUVDXKWKXLYSXMLZIYPXNLZYTUWMYPXPLUWNYPYPQZXQYPXROUHYSYPUUEXSSMUUMYSJVMD
      YSUJDZLIUULUUMUWPUUSUULUUMHRFJCXTOZUUFUUSUULUWPLUUJRJYRYSYSCKYASYFMYBYCYQ
      UUOJYQYPYDEZUUNEZUUOYPTLYQUWSHYPYEYPUWOYGYHYPYSYSTUUCUUEYIOUWRUUMUUNYJYKY
      LYMUWQYNMUVAUVCYOYC $.
  $}
$( End $[ set-mbox-ta-rrhom.mm $] $)
$( Begin $[ set-mbox-ta-logb.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Real and complex functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Integer powers - misc. additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d k A $.  $d k n B $.
    $( A lower bound for an exponentiation.  (Contributed by Thierry Arnoux,
       19-Aug-2017.) $)
    nexple $p |- ( ( A e. NN0 /\ B e. RR /\ 2 <_ B ) -> A <_ ( B ^ A ) ) $=
      ( cn0 wcel cr c2 cle wbr w3a cexp co cc0 wi c1 id oveq2 breq12d a1i letrd
      wceq vk vn cn wa simpr simpl2 simpl3 3jca caddc biidd imbi12d imbi2d 1nn0
      simpl 1re 2re 2nn nnge1 ax-mp expge1d cmul simp1 nnnn0d readdcld 3ad2ant2
      nn0red remulcld reexpcld leadd2dd recnd times2d breqtrrd nn0ge0d lemul2ad
      cv syl simp2r 0nn0 2nn0 nn0ge0 simp3 lemul1ad cc expp1 syl2anc 3expia a2d
      ex nnind 3impib oveq2d exp0d eqtrd 3brtr4d elnn0 biimpi 3ad2ant1 mpjaodan
      0le1 wo ) ACDZBEDZFBGHZIZAUCDZABAJKZGHZALTZXDXEUDZXEXBXCIXGXIXEXBXCXDXEUE
      XAXBXCXEUFXAXBXCXEUGUHXEXBXCXGXBXCUDZUAVOZBXKJKZGHZMXJNBNJKZGHZMXJUBVOZBX
      PJKZGHZMXJXPNUIKZBXSJKZGHZMXJXGMUAUBAXKNTZXJXJXMXOYBXJUJYBXKNXLXNGYBOXKNB
      JPQUKXKXPTZXMXRXJYCXKXPXLXQGYCOXKXPBJPQULXKXSTZXJXJXMYAYDXJUJYDXKXSXLXTGY
      DOXKXSBJPQUKXKATZXJXJXMXGYEXJUJYEXKAXLXFGYEOXKABJPQUKXJBNXBXCUNZNCDXJUMRX
      JNFBNEDZXJUORFEDZXJUPRZYFNFGHZXJFUCDYJUQFURUSRXBXCUEZSUTXPUCDZXJXRYAYLXJX
      RYAMYLXJXRYAYLXJXRIZXSXQBVAKZXTGYMXSXPBVAKZYNYMXPNYMXPYMXPYLXJXRVBZVCZVFZ
      YGYMUORZVDZYMXPBYRXJYLXBXRYFVEZVGZYMXQBYMBXPUUAYQVHZUUAVGYMXSXPFVAKZYOYTY
      MXPFYRYHYMUPRZVGUUBYMXSXPXPUIKUUDGYMNXPXPYSYRYRYMYLNXPGHYPXPURVPVIYMXPYMX
      PYRVJVKVLYMFBXPUUEUUAYRYMXPYQVMYLXBXCXRVQVNSYMXPXQBYRUUCUUAXJYLLBGHXRXJLF
      BXJLLCDXJVRRVFYIYFLFGHZXJFCDUUFVSFVTUSRYKSVEYLXJXRWAWBSYMBWCDXPCDXTYNTYMB
      UUAVJYQBXPWDWEVLWFWHWGWIWJVPXDXHUDZLNAXFGLNGHUUGWSRXDXHUEZUUGXFBLJKNUUGAL
      BJUUHWKUUGBUUGBXAXBXCXHUFVJWLWMWNXAXBXEXHWTZXCXAUUIAWOWPWQWR $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Logarithm laws generalized to an arbitrary base - logb
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-

  Define "log using an arbitrary base" function and then prove some
  of its properties.  This builds on previous work by Stefan O'Rear.
  Note that ` logb ` is generalized to an arbitrary base and arbitrary
  parameter in ` CC ` , but it doesn't accept infinities as arguments,
  unlike ` log ` .

  Metamath doesn't care what letters are used to represent classes.
  Usually classes begin with the letter "A", but here we use "B" and "X"
  to more clearly distinguish between "base" and "other parameter of log".

  There are different ways this could be defined in Metamath.  The
  approach used here is intentionally similar to existing 2-parameter Metamath
  functions.  The way defined here supports two notations,
  ` ( logb `` <. B , X >. ) ` and ` ( B logb X ) `  where ` B ` is the base
  and ` X ` is the other parameter.
  An alternative would be to support the notational form
  ` ( ( logb `` B ) `` X ) ` ;  that looks a little more like traditional
  notation, but is different than other 2-parameter functions.
  It's not obvious to me which is better,
  so here we try out one way as an experiment.  Feedback and help welcome.
$)

  $c logb $. $( Logarithm generalized to an arbitrary base. $)

  $( Extend class notation to include the logarithm generalized to an arbitrary
     base. $)
  clogb $a class logb $.

  ${
    $d n x y z $.
    $( Define the ` logb ` operator.  This is the logarithm generalized to an
       arbitrary base.  It can be used as ` ( logb `` <. B , X >. ) ` for "log
       base B of X".  In the most common traditional notation, base B is a
       subscript of "log".  You could also use ` ( B logb X ) ` , which looks
       like a less-common notation that some use where the base is a preceding
       superscript.  Note:  This definition doesn't prevent bases of 1 or 0;
       proofs may need to forbid them.  (Contributed by David A. Wheeler,
       21-Jan-2017.) $)
    df-logb $a |- logb = ( x e. ( CC \ { 0 , 1 } ) , y e. ( CC \ { 0 } ) |->
                         ( ( log ` y ) / ( log ` x ) ) ) $.
  $}

  ${
    $d x y B $.  $d x y X $.
    $( Define the value of the ` logb ` function, the logarithm generalized to
       an arbitrary base, when used as infix.  Most Metamath statements select
       variables in order of their use, but to make the order clearer we use
       "B" for base and "X" for the other operand here.  Proof is similar to
       ~ modval .  (Contributed by David A. Wheeler, 21-Jan-2017.)  (Revised by
       David A. Wheeler, 16-Jul-2017.) $)
    logbval $p |- ( ( B e. ( CC \ { 0 , 1 } ) /\ X e. ( CC \ { 0 } ) )
           -> ( B logb X ) = ( ( log ` X ) / ( log ` B ) ) )
      $=
      ( vx vy cc cc0 c1 cpr cdif csn cv clog cfv cdiv clogb fveq2 oveq2d oveq1d
      co wceq df-logb ovex ovmpt2 ) CDABEFGHIEFJIDKZLMZCKZLMZNSBLMZALMZNSOUEUIN
      SUFATUGUIUENUFALPQUDBTUEUHUINUDBLPRCDUAUHUINUBUC $.
  $}

  $( Define the value of the ` logb ` function, the logarithm generalized to an
     arbitrary base, when used in the 2-argument form ` logb <. B , X >. `
     (Contributed by David A. Wheeler, 21-Jan-2017.)  (Revised by David A.
     Wheeler, 16-Jul-2017.) $)
  logb2aval $p |- ( ( B e. ( CC \ { 0 , 1 } ) /\ X e. ( CC \ { 0 } ) )
         -> ( logb ` <. B , X >. ) = ( ( log ` X ) / ( log ` B ) ) ) $=
    ( cc cc0 c1 cpr cdif wcel csn wa cop clogb cfv co clog cdiv logbval syl5eqr
    df-ov ) ACDEFGHBCDIGHJABKLMABLNBOMAOMPNABLSABQR $.

  $( General logarithm is a real number, given positive real numbers.  Based on
     ~ reglogcl .  (Contributed by David A. Wheeler, 21-Jan-2017.)
  relogbcl $p |- ( ( B e. RR+ /\ X e. RR+ /\ B =/= 1 ) ->
                   ( B logb X ) e. RR ) $= ? $.
  $)

  $( Membership in a set with two elements removed.  Similar to ~ eldifsn and
     ~ eldiftp .  (Contributed by Mario Carneiro, 18-Jul-2017.) $)
  eldifpr $p |- ( A e. ( B \ { C , D } ) <->
                ( A e. B /\ A =/= C /\ A =/= D ) ) $=
    ( wcel cpr wn wa wne cdif w3a wo elprg notbid neanior syl6bbr pm5.32i eldif
    wceq 3anass 3bitr4i ) ABEZACDFZEZGZHUBACIZADIZHZHABUCJEUBUFUGKUBUEUHUBUEACS
    ADSLZGUHUBUDUIACDBMNACADOPQABUCRUBUFUGTUA $.

  $( Membership in a set with three elements removed.  Similar to ~ eldifsn and
     ~ eldifpr .  (Contributed by David A. Wheeler, 22-Jul-2017.) $)
  eldiftp $p |- ( A e. ( B \ { C , D , E } ) <->
                ( A e. B /\ ( A =/= C /\ A =/= D /\ A =/= E ) ) ) $=
    ( ctp cdif wcel wn wa wne w3a eldif wceq w3o eltpg ne3anior syl6bbr pm5.32i
    notbid bitri ) ABCDEFZGHABHZAUBHZIZJUCACKADKAEKLZJABUBMUCUEUFUCUEACNADNAENO
    ZIUFUCUDUGACDEBPTACADAEQRSUA $.

  $( if ` ( log `` A ) = 0 ` then ` A = 1 ` (Contributed by David A. Wheeler,
     22-Jul-2017.) $)
  logeq0im1 $p |- ( ( A e. CC /\ A =/= 0 /\ ( log ` A ) = 0 ) -> A = 1 ) $=
    ( cc wcel cc0 wne clog cfv wceq w3a ce c1 eflog 3adant3 ef0 syl6eq 3ad2ant3
    fveq2 eqtr3d ) ABCZADEZAFGZDHZIUAJGZAKSTUCAHUBALMUBSUCKHTUBUCDJGKUADJQNOPR
    $.

  $( log isn't 0 if argument isn't 0 or 1.  Unlike ~ logne0 , this handles
     complex numbers.  (Contributed by David A. Wheeler, 17-Jul-2017.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  logccne0OLD $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) ->
                  ( log ` A ) =/= 0 ) $=
    ( cc wcel cc0 wne c1 w3a clog ce wceq wn eflog 3adant3 simp3 eqnetrd neneqd
    cfv fveq2 ef0 syl6eq necon3bi syl ) ABCZADEZAFEZGZAHQZIQZFJZKUGDEUFUHFUFUHA
    FUCUDUHAJUEALMUCUDUENOPUIUGDUGDJUHDIQFUGDIRSTUAUB $.

  $( log isn't 0 if argument isn't 0 or 1.  Unlike ~ logne0 , this handles
     complex numbers.  (Contributed by David A. Wheeler, 17-Jul-2017.) $)
  logccne0 $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) ->
                  ( log ` A ) =/= 0 ) $=
    ( cc wcel cc0 wne c1 w3a clog wceq simp3 neneqd wi logeq0im1 3expia 3adant3
    cfv mtod neneqad ) ABCZADEZAFEZGZAHPZDUBUCDIZAFIZUBAFSTUAJKSTUDUELUASTUDUEA
    MNOQR $.

  $( General logarithm closure.  (Contributed by David A. Wheeler,
     17-Jul-2017.) $)
  logbcl $p |- ( ( B e. ( CC \ { 0 , 1 } ) /\ X e. ( CC \ { 0 } ) )
                 -> ( B logb X ) e. CC ) $=
    ( cc cc0 c1 cpr cdif wcel csn wa clogb co clog cfv cdiv logbval wne eldifsn
    sylbi adantr logcl adantl eldifi eldifpr simp2bi logcld w3a logccne0 divcld
    eqeltrd ) ACDEFZGHZBCDIGHZJZABKLBMNZAMNZOLCABPUNUOUPUMUOCHZULUMBCHBDQJUQBCD
    RBUASUBULUPCHUMULAACUKUCULACHZADQZAEQZACDEUDZUEUFTULUPDQZUMULURUSUTUGVBVAAU
    HSTUIUJ $.

  $( General logarithm when base and arg match (Contributed by David A.
     Wheeler, 22-Jul-2017.) $)
  logbid1 $p |- ( ( A e. CC /\ A =/= 0 /\ A =/= 1 ) -> ( A logb A ) = 1 ) $=
    ( cc wcel cc0 wne w3a clogb clog cfv cdiv cpr cdif csn wceq eldifpr biimpri
    c1 co wa 3adant3 eldifsn logbval syl2anc logcl logccne0 dividd eqtrd ) ABCZ
    ADEZAQEZFZAAGRZAHIZUMJRZQUKABDQKLCZABDMLCZULUNNUOUKABDQOPUHUIUPUJUPUHUISABD
    UAPTAAUBUCUKUMUHUIUMBCUJAUDTAUEUFUG $.

  $( Useful lemma for working with integer logarithm bases (with is a common
     case, e.g. base 2, base 3 or base 10) (Contributed by Thierry Arnoux,
     26-Sep-2017.) $)
  rnlogblem $p |- ( B e. ( ZZ>= ` 2 ) -> ( B e. RR+ /\ B =/= 0 /\ B =/= 1 ) )
    $=
    ( c2 cuz cfv wcel crp cc0 wne c1 cn wss cz cle wbr 2z 1re 2re nelne2 mpan2
    wn 1lt2 ltleii 1z eluz1i mpbir2an uzss ax-mp nnuz sseqtr4i sseli nnrpd 2pos
    clt 0re ltnlei mpbi eluzle mto 1nuz2 3jca ) ABCDZEZAFEAGHZAIHZVBAVAJAVAICDZ
    JBVEEZVAVEKVFBLEIBMNOIBPQUAUBIBUCUDUEIBUFUGUHUIUJUKVBGVAEZTVCVGBGMNZGBUMNVH
    TULGBUNQUOUPBGUQURAGVARSVBIVAETVDUSAIVARSUT $.

  $( Value of the general logarithm with integer base.  (Contributed by Thierry
     Arnoux, 27-Sep-2017.) $)
  rnlogbval $p |- ( ( B e. ( ZZ>= ` 2 ) /\ X e. RR+ )
        -> ( B logb X ) = ( ( log ` X ) / ( log ` B ) ) ) $=
    ( c2 cuz cfv wcel crp wa cc cc0 c1 cpr cdif csn clogb co clog cdiv wceq wne
    rnlogblem adantr simp1d rpcnd simp2d simp3d eldifpr syl3anbrc simpr eldifsn
    w3a rpcnne0d sylibr logbval syl2anc ) ACDEFZBGFZHZAIJKLMFZBIJNMFZABOPBQEAQE
    RPSURAIFAJTZAKTZUSURAURAGFZVAVBUPVCVAVBUKUQAUAUBZUCUDURVCVAVBVDUEURVCVAVBVD
    UFAIJKUGUHURBIFBJTHUTURBUPUQUIULBIJUJUMABUNUO $.

  $( Closure of the general logarithm with integer base on positive reals.  See
     ~ logbcl .  (Contributed by Thierry Arnoux, 27-Sep-2017.) $)
  rnlogbcl $p |- ( ( B e. ( ZZ>= ` 2 ) /\ X e. RR+ ) -> ( B logb X ) e. RR ) $=
    ( c2 cuz cfv wcel crp wa clogb co clog cdiv cr rnlogbval simpr relogcld cc0
    wne c1 w3a rnlogblem adantr simp1d simp3d logne0 syl2anc redivcld eqeltrd )
    ACDEFZBGFZHZABIJBKEZAKEZLJMABNUKULUMUKBUIUJOPUKAUKAGFZAQRZASRZUIUNUOUPTUJAU
    AUBZUCZPUKUNUPUMQRURUKUNUOUPUQUDAUEUFUGUH $.

  $( Closure of the general logarithm with integer base on positive reals.
     (Contributed by Thierry Arnoux, 27-Sep-2017.) $)
  relogbcl $p |- ( ( B e. RR+ /\ X e. RR+ /\ B =/= 1 )
              -> ( B logb X ) e. RR ) $=
    ( crp wcel c1 wne w3a clogb co clog cfv cdiv cr cc cc0 cdif rpcnne0d sylibr
    wa relogcl cpr csn wceq simp1 simp3 df-3an sylanbrc eldifpr eldifsn logbval
    simp2 syl2anc 3ad2ant2 3ad2ant1 logne0 3adant2 redivcld eqeltrd ) ACDZBCDZA
    EFZGZABHIZBJKZAJKZLIZMVBANOEUAPDZBNOUBPDZVCVFUCVBANDZAOFZVAGZVGVBVIVJSVAVKV
    BAUSUTVAUDQUSUTVAUEVIVJVAUFUGANOEUHRVBBNDBOFSVHVBBUSUTVAUKQBNOUIRABUJULVBVD
    VEUTUSVDMDVABTUMUSUTVEMDVAATUNUSVAVEOFUTAUOUPUQUR $.

  $( The natural logarithm of ` 1 ` in base ` B ` .  See ~ log1 (Contributed by
     Thierry Arnoux, 27-Sep-2017.) $)
  logb1 $p |- ( ( B e. CC /\ B =/= 0 /\ B =/= 1 ) -> ( B logb 1 ) = 0 ) $=
    ( cc wcel cc0 wne c1 w3a clogb co clog cfv cdiv cpr cdif eldifpr csn ax-1cn
    wceq ax-1ne0 eldifsn mpbir2an logbval mpan2 sylbir log1 oveq1i simp1 logcld
    simp2 logccne0 div0d syl5eq eqtrd ) ABCZADEZAFEZGZAFHIZFJKZAJKZLIZDUQABDFMN
    CZURVARZABDFOVBFBDPNCZVCVDFBCFDEQSFBDTUAAFUBUCUDUQVADUTLIDUSDUTLUEUFUQUTUQA
    UNUOUPUGUNUOUPUIUHAUJUKULUM $.

  $( Identity law for general logarithm with integer base.  (Contributed by
     Thierry Arnoux, 27-Sep-2017.) $)
  nnlogbexp $p |- ( ( B e. ( ZZ>= ` 2 ) /\ M e. ZZ ) ->
    ( B logb ( B ^ M ) ) = M ) $=
    ( cfv wcel wa cexp co clogb wceq cc0 c1 cc wne adantr oveq2d clog cdiv cdif
    simpr syl2anc c2 cuz cz crp w3a rnlogblem simp1d rpcnd simp2d logb1 syl3anc
    simp3d exp0d eqtrd 3eqtr4d cmul cpr csn eldifpr syl3anbrc rpexpcld rpcnne0d
    eldifsn sylibr logbval ccxp cr logcxpd cxpexpzd fveq2d eqtr3d oveq1d logcld
    zred recnd logne0 divcan4d 3eqtr2d pm2.61dane ) AUAUBCDZBUCDZEZAABFGZHGZBIB
    JWBBJIZEZAKHGZJWDBWFALDZAJMZAKMZWGJIWBWHWEWBAWBAUDDZWIWJVTWKWIWJUEWAAUFNZUG
    ZUHZNZWBWIWEWBWKWIWJWLUIZNWBWJWEWBWKWIWJWLULZNAUJUKWFWCKAHWFWCAJFGKWFBJAFWB
    WESZOWFAWOUMUNOWRUOWBBJMZEZWDWCPCZAPCZQGZBXBUPGZXBQGBWTALJKUQRDZWCLJURRDZWD
    XCIWTWHWIWJXEWBWHWSWNNZWBWIWSWPNZWBWJWSWQNZALJKUSUTWTWCLDWCJMEXFWTWCWTABWBW
    KWSWMNZWBWAWSVTWASZNZVAVBWCLJVCVDAWCVETWTXDXAXBQWTABVFGZPCXDXAWTABXJWBBVGDW
    SWBBXKVNNZVHWTXMWCPWTABXGXHXLVIVJVKVLWTBXBWTBXNVOWTAXGXHVMWTWKWJXBJMXJXIAVP
    TVQVRVS $.

  $( Logarithm of a reciprocal changes sign.  See ~ logrec (Contributed by
     Thierry Arnoux, 27-Sep-2017.) $)
  logbrec $p |- ( ( B e. ( ZZ>= ` 2 ) /\ A e. RR+ ) ->
    ( B logb ( 1 / A ) ) = -u ( B logb A ) ) $=
    ( c2 cfv wcel crp c1 cdiv co clog cneg wceq rnlogbval logcld cc0 wne adantr
    clogb relogcld cpi cuz simpr rpreccld syldan negeqd rpne0d rnlogblem simp1d
    wa rpcnd recnd simp3d logne0 syl2anc divnegd reccld recne0d cc reim0d pipos
    cim 0re gtneii necomd eqnetrd logrec syl3anc eqcomd negcon1ad oveq1d 3eqtrd
    a1i eqtr4d ) BCUADEZAFEZUIZBGAHIZRIZVQJDZBJDZHIZBARIZKZVNVOVQFEVRWALVPAVNVO
    UBZUCBVQMUDVPWCAJDZVTHIZKWEKZVTHIWAVPWBWFBAMUEVPWEVTVPAVPAWDUJZVPAWDUFZNVPV
    TVPBVNBFEZVOVNWJBOPZBGPZBUGZUHQZSUKVPWJWLVTOPWNVNWLVOVNWJWKWLWMULQBUMUNUOVP
    WGVSVTHVPVSWEVPVQVPAWHWIUPVPAWHWIUQNVPWEVSKZVPAUREAOPWEVADZTPWEWOLWHWIVPWPO
    TVPWEVPAWDSUSVPTOTOPVPOTVBUTVCVLVDVEAVFVGVHVIVJVKVM $.

  $( The general logarithm function is monotone.  See ~ logltb (Contributed by
     Thierry Arnoux, 27-Sep-2017.) $)
  logblt $p |- ( ( B e. ( ZZ>= ` 2 ) /\ X e. RR+ /\ Y e. RR+ ) ->
    ( X < Y <-> ( B logb X ) < ( B logb Y ) ) ) $=
    ( c2 cuz cfv wcel crp w3a clog clt cdiv co clogb relogcld cz wceq rnlogbval
    wbr c1 simp2 simp3 simp1 eluzelz syl zred caddc 1z fveq2i syl6eleqr eluzp1l
    sylancr rplogcld ltdiv1d wb logltb 3adant1 3adant3 3adant2 breq12d 3bitr4d
    1p1e2 ) ADEFZGZBHGZCHGZIZBJFZCJFZKSZVHAJFZLMZVIVKLMZKSBCKSZABNMZACNMZKSVGVH
    VIVKVGBVDVEVFUAOVGCVDVEVFUBOVGAVGAVGVDAPGVDVEVFUCZDAUDUEUFVGTPGATTUGMZEFZGT
    AKSUHVGAVCVSVQVRDEVBUIUJTAUKULUMUNVEVFVNVJUOVDBCUPUQVGVOVLVPVMKVDVEVOVLQVFA
    BRURVDVFVPVMQVEACRUSUTVA $.

  $( ` log 2 ` is less than ` 1 ` .  This is just a weaker form of ~ log2ub
     when no tight upper bound is required.  (Contributed by Thierry Arnoux,
     27-Sep-2017.) $)
  log2le1 $p |- ( log ` 2 ) < 1 $=
    ( c2 clog c5 cdc c3 c6 cdiv co clt wbr c1 2nn0 5nn0 3nn0 6nn0 decltc nn0rei
    deccl cc0 wcel cfv log2ub 3lt10 5lt10 2lt3 6nn decnncl 0nn0 declti ltdiv1ii
    10pos recni 0re gtneii dividi breqtri crp cr 2rp relogcl ax-mp redivcli 1re
    mpbi lttri mp2an ) ABUAZACDZEDZEFDZCDZGHZIJVLKIJVGKIJUBVLVKVKGHZKIVIVKIJVLV
    MIJVHVJECACLMRZEFNORZNMUCAECFLNMOUDUEPPVIVKVKVIVHEVNNRQZVKVJCVOMRQZVQVJCSEF
    NUFUGMUHUKUIZUJVDVKVKVQULSVKUMVRUNZUOUPVGVLKAUQTVGURTUSAUTVAVIVKVPVQVSVBVCV
    EVF $.

$( End $[ set-mbox-ta-logb.mm $] $)
$( Begin $[ set-mbox-ta-ind.mm $] $)
$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Indicator Functions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c _Ind $.

  $( Extend class notation with the indicator function generator. $)
  cind $a class _Ind $.

  ${
    $d a o x $.
    $( Define the indicator function generator.  (Contributed by Thierry
       Arnoux, 20-Jan-2017.) $)
    df-ind $a |- _Ind = ( o e. _V |-> ( a e. ~P o |->
                                    ( x e. o |-> if ( x e. a , 1 , 0 ) ) ) ) $.
  $}

  ${
    $d a o x O $.  $d a o V $.
    $( Value of the indicator function generator with domain ` O ` .
       (Contributed by Thierry Arnoux, 23-Aug-2017.) $)
    indv $p |- ( O e. V ->
     ( _Ind ` O ) = ( a e. ~P O |-> ( x e. O |-> if ( x e. a , 1 , 0 ) ) ) ) $=
      ( vo wcel cpw cc0 cif cmpt cvv cind wceq df-ind a1i pweq mpteq1 mpteq12dv
      cv c1 adantl elex pwexg mptexg 3syl fvmptd ) BCFZEBDESZGZAUHASDSFTHIZJZJZ
      DBGZABUJJZJZKLKLEKULJMUGAEDNOUHBMZULUOMUGUPDUIUKUMUNUHBPAUHBUJQRUABCUBZUG
      BKFUMKFUOKFUQBKUCDUMUNKUDUEUF $.

    $d a o x A $.
    $( Value of the indicator function generator for a set ` A ` and a domain
       ` O ` .  (Contributed by Thierry Arnoux, 2-Feb-2017.) $)
    indval $p |- ( ( O e. V /\ A C_ O ) ->
               ( ( _Ind ` O ) ` A ) = ( x e. O |-> if ( x e. A , 1 , 0 ) ) ) $=
      ( va wcel wss wa cv c1 cc0 cif cmpt cpw cind cfv cvv wceq indv adantr syl
      eleq2 ifbid mpteq2dv adantl simpr ssexg ancoms elpwg mpbird mptexg fvmptd
      wb ) CDFZBCGZHZEBACAIZEIZFZJKLZMZACUQBFZJKLZMZCNZCOPZQUNVFEVEVAMRUOACDEST
      URBRZVAVDRUPVGACUTVCVGUSVBJKURBUQUBUCUDUEUPBVEFZUOUNUOUFUPBQFZVHUOUMUOUNV
      IBCDUGUHBCQUIUAUJUNVDQFUOACVCDUKTUL $.
  $}

  ${
    $d x y A $.  $d x O $.
    $( Alternate value of the indicator function generator.  (Contributed by
       Thierry Arnoux, 2-Feb-2017.) $)
    indval2 $p |- ( ( O e. V /\ A C_ O ) -> ( ( _Ind ` O ) ` A ) =
                              ( ( A X. { 1 } ) u. ( ( O \ A ) X. { 0 } ) ) ) $=
      ( vx wcel wss cfv csn c1 cc0 cxp ciun wceq syl6eq sneqd xpeq2d iunxpconst
      cun iuneq2i eqtri wa cind cif cdif cmpt dfmpt3 indval undif biimpi adantl
      cv iuneq1d 3eqtr4a iunxun iftrue wn eldifn iffalse syl uneq12i ) BCEZABFZ
      UAZABUBGGZDADUKZHZVEAEZIJUCZHZKZLZDBAUDZVJLZRZAIHZKZVLJHZKZRVCVDDAVLRZVJL
      ZVNVCDBVHUEDBVJLVDVTDBVHUFDABCUGVCDVSBVJVBVSBMZVAVBWAABUHUIUJULUMDAVLVJUN
      NVKVPVMVRVKDAVFVOKZLVPDAVJWBVGVIVOVFVGVHIVGIJUOOPSDAVOQTVMDVLVFVQKZLVRDVL
      VJWCVEVLEZVIVQVFWDVGUPZVIVQMVEBAUQWEVHJVGIJUROUSPSDVLVQQTUTN $.
  $}

  ${
    $d x A $.  $d x O $.  $d x V $.
    $( An indicator function as a function with domain and codomain.
       (Contributed by Thierry Arnoux, 13-Aug-2017.) $)
    indf $p |- ( ( O e. V /\ A C_ O ) ->
                                    ( ( _Ind ` O ) ` A ) : O --> { 0 , 1 } ) $=
      ( vx wcel wss wa cv c1 cc0 cif cpr cind cfv indval cr 1re 0re ifpr mp2an
      prcom eleqtri a1i fmpt3d ) BCEABFGZDBDHZAEZIJKZJILZABMNNDABCOUHUIEUEUFBEG
      UHIJLZUIIPEJPEUHUJEQRUGIJPPSTIJUAUBUCUD $.

    $d x X $.
    $( Value of the indicator function.  (Contributed by Thierry Arnoux,
       13-Aug-2017.) $)
    indfval $p |- ( ( O e. V /\ A C_ O /\ X e. O ) ->
      ( ( ( _Ind ` O ) ` A ) ` X ) = if ( X e. A , 1 , 0 ) ) $=
      ( vx wcel wss w3a cv c1 cc0 cif cind cfv cr cmpt wceq indval 3adant3 wa
      simpr eleq1d ifbid simp3 1re 0re keepel a1i fvmptd ) BCFZABGZDBFZHZEDEIZA
      FZJKLZDAFZJKLZBABMNNZOUJUKUSEBUPPQULEABCRSUMUNDQZTZUOUQJKVAUNDAUMUTUAUBUC
      UJUKULUDUROFUMUQJKOUEUFUGUHUI $.
  $}

  $( The range of the indicator function is a subset of ` RR ` .  (Contributed
     by Thierry Arnoux, 14-Aug-2017.) $)
  pr01ssre $p |- { 0 , 1 } C_ RR $=
    ( cc0 cr wcel c1 cpr wss 0re 1re prssi mp2an ) ABCDBCADEBFGHADBIJ $.

  $( Value of the indicator function where it is ` 1 ` .  (Contributed by
     Thierry Arnoux, 14-Aug-2017.) $)
  ind1 $p |- ( ( O e. V /\ A C_ O /\ X e. A ) ->
                                          ( ( ( _Ind ` O ) ` A ) ` X ) = 1 ) $=
    ( wcel wss w3a cind cfv c1 cc0 cif wceq simp2 simp3 sseldd indfval syld3an3
    iftrue 3ad2ant3 eqtrd ) BCEZABFZDAEZGZDABHIIIZUDJKLZJUBUCUDDBEUFUGMUEABDUBU
    CUDNUBUCUDOPABCDQRUDUBUGJMUCUDJKSTUA $.

  $( Value of the indicator function where it is ` 0 ` .  (Contributed by
     Thierry Arnoux, 14-Aug-2017.) $)
  ind0 $p |- ( ( O e. V /\ A C_ O /\ X e. ( O \ A ) ) ->
                                          ( ( ( _Ind ` O ) ` A ) ` X ) = 0 ) $=
    ( wcel wss cdif w3a cind cfv c1 cc0 wceq eldifi indfval syl3an3 wn 3ad2ant3
    cif eldifn iffalse syl eqtrd ) BCEZABFZDBAGEZHZDABIJJJZDAEZKLSZLUFUDUEDBEUH
    UJMDBANABCDOPUGUIQZUJLMUFUDUKUEDBATRUIKLUAUBUC $.

  $( Value of the indicator function where it is ` 1 ` .  (Contributed by
     Thierry Arnoux, 22-Aug-2017.) $)
  ind1a $p |- ( ( O e. V /\ A C_ O /\ X e. O ) ->
                           ( ( ( ( _Ind ` O ) ` A ) ` X ) = 1 <-> X e. A ) ) $=
    ( wcel wss w3a cind cfv c1 wceq cc0 cif indfval eqeq1d wa wn eqid biantru
    wo wne ax-1ne0 df-ne mpbi biorfi bianfi orbi2i 3bitri eqcom 3bitr2ri syl6bb
    eqif ) BCEABFDBEGZDABHIIIZJKDAEZJLMZJKZUOUMUNUPJABCDNOUOUOJJKZPZUOQZJLKZPZT
    ZJUPKUQUOUSUSVATVCURUOJRSVAUSJLUAVAQUBJLUCUDZUEVAVBUSVAUTVDUFUGUHUOJJLULJUP
    UIUJUK $.

  ${
    $d x A $.  $d x O $.  $d x V $.
    $( Preimage of the singleton ` { 1 } ` by the indicator function.  See
       ~ i1f1lem .  (Contributed by Thierry Arnoux, 21-Aug-2017.) $)
    indpi1 $p |- ( ( O e. V /\ A C_ O ) ->
                                   ( `' ( ( _Ind ` O ) ` A ) " { 1 } ) = A ) $=
      ( vx wcel wss wa cind cfv ccnv c1 csn cima cv wb ind1a 3expia pm5.32d cc0
      wceq cpr wf wfn indf ffn fniniseg 3syl ssel pm4.71rd adantl 3bitr4d eqrdv
      ) BCEZABFZGZDABHIIZJKLMZAUODNZBEZURUPIKTZGZUSURAEZGZURUQEZVBUOUSUTVBUMUNU
      SUTVBOABCURPQRUOBSKUAZUPUBUPBUCVDVAOABCUDBVEUPUEBKURUPUFUGUNVBVCOUMUNVBUS
      ABURUHUIUJUKUL $.
  $}

  ${
    $d x A $.  $d x O $.  $d x ph $.
    indsum.1 $e |- ( ph -> O e. Fin ) $.
    indsum.2 $e |- ( ph -> A C_ O ) $.
    indsum.3 $e |- ( ( ph /\ x e. O ) -> B e. CC ) $.
    $( TODO: shorten using ~ sumss2 ! $)
    $( Finite sum of a product with the indicator function / cross-product with
       the indicator function.  (Contributed by Thierry Arnoux,
       14-Aug-2017.) $)
    indsum $p |- ( ph -> sum_ x e. O ( ( ( ( _Ind ` O ) ` A ) ` x ) x. B )
                        = sum_ x e. A B ) $=
      ( cfv cmul co csu wcel wa cc0 c1 cfn syldan wceq adantr cv cind cc sselda
      cpr cr pr01ssre wss indf syl2anc ffvelrnda sseldi recnd mulcld cdif simpr
      wf ind0 syl3anc oveq1d difssd mul02d eqtrd fsumss mulid2d sumeq2dv eqtr3d
      ind1 ) ACBUAZCEUBIIZIZDJKZBLEVLBLCDBLACEVLBGAVICMZVIEMZVLUCMACEVIGUDZAVNN
      ZVKDVPVKVPOPUEZUFVKUGAEVQVIVJAEQMZCEUHZEVQVJUQFGCEQUIUJUKULUMHUNRAVIECUOZ
      MZNZVLODJKZOWBVKODJWBVRVSWAVKOSAVRWAFTAVSWAGTAWAUPCEQVIURUSUTAWAVNWCOSAVT
      EVIAECVAUDVPDHVBRVCFVDACVLDBAVMNZVLPDJKZDWDVKPDJWDVRVSVMVKPSAVRVMFTAVSVMG
      TAVMUPCEQVIVHUSUTAVMVNWEDSVOVPDHVERVCVFVG $.
  $}

  ${
    $d a x O $.  $d a V $.
    $( The bijection between a power set and the set of indicator functions.
       (Contributed by Thierry Arnoux, 14-Aug-2017.) $)
    indf1o $p |- ( O e. V ->
                        ( _Ind ` O ) : ~P O -1-1-onto-> ( { 0 , 1 } ^m O ) ) $=
      ( va vx wcel cpw cc0 c1 cpr cmap co cind cfv wf1o wel cif cmpt cr id a1i
      0re 1re wne ax-1ne0 necomi eqid pw2f1o wceq wb indv f1oeq1 syl mpbird ) A
      BEZAFZGHIAJKZALMZNZUOUPCUODADCOHGPQQZNZUNCDAGHUSBRUNSGREUNUATHREUNUBTGHUC
      UNHGUDUETUSUFUGUNUQUSUHURUTUIDABCUJUOUPUQUSUKULUM $.
  $}

  ${
    $d x F $.  $d x O $.  $d x V $.
    $( A function with range ` { 0 , 1 } ` as an indicator of the preimage of
       ` { 1 } ` (Contributed by Thierry Arnoux, 23-Aug-2017.) $)
    indpreima $p |- ( ( O e. V /\ F : O --> { 0 , 1 } ) ->
                                   F = ( ( _Ind ` O ) ` ( `' F " { 1 } ) ) ) $=
      ( vx wcel cc0 c1 cpr wf wa cfv wfn ffn adantl wceq syl ffvelrnda syl6eleq
      simpr wb ccnv csn cima cind wss cdm cnvimass fdm syl5sseq syldan cv prcom
      indf simpll adantr ind1a syl3anc fniniseg baibd bitr2d elpreq eqfnfvd ) B
      CEZBFGHZAIZJZDBAAUAGUBZUCZBUDKKZVEABLZVCBVDAMNZVFBVDVIIZVIBLVCVEVHBUEZVLV
      FAUFZVHBAVGUGVEVNBOVCBVDAUHNUIZVHBCUMUJZBVDVIMPVFDUKZBEZJZGFVQAKZVQVIKZVS
      VTVDGFHZVFBVDVQAVCVESQFGULZRVSWAVDWBVFBVDVQVIVPQWCRVSWAGOZVQVHEZVTGOZVSVC
      VMVRWDWETVCVEVRUNVFVMVRVOUOVFVRSVHBCVQUPUQVFWEVRWFVFVJWEVRWFJTVKBGVQAURPU
      SUTVAVB $.
  $}

  ${
    $d a f g O $.  $d a g V $.
    $( The bijection between finite subsets and the indicator functions with
       finite support.  (Contributed by Thierry Arnoux, 22-Aug-2017.) $)
    indf1ofs $p |- ( O e. V -> ( ( _Ind ` O ) |` Fin ) : ( ~P O i^i Fin )
         -1-1-onto-> { f e. ( { 0 , 1 } ^m O ) | ( `' f " { 1 } ) e. Fin } ) $=
      ( vg va wcel cfn cfv cima cres wf1o cv ccnv c1 wss syl wceq wa syldan wb
      cpw cin cind csn cc0 cpr cmap crab wf1 indf1o f1of1 f1ores sylancl resres
      co inss1 wfn f1ofn fnresdm 3syl reseq1d syl5eqr eqidd simpll simpr sseldi
      wrex wf elpwid indf adantr feq1d mpbid prex elmapg biimpar syl2anc cnveqd
      cvv mpan imaeq1d indpi1 inss2 eqeltrd eqeltrrd jca rexlimdva cdm cnvimass
      biimpa fdm adantrr syl5sseq simprr elfpw sylanbrc indpreima eqcomd eqeq1d
      ex fveq2 rspcev impbid fvelimab cnveq eleq1d elrab a1i 3bitr4d f1oeq123d
      eqrdv ) BCFZBUAZGUBZBUCHZXNIZXOXNJZKZXNALZMZNUDZIZGFZAUENUFZBUGUOZUHZXOGJ
      ZKXLXMYEXOUIZXNXMOZXRXLXMYEXOKZYHBCUJZXMYEXOUKPXMGUPZXMYEXNXOULUMXLXNXNXP
      YFXQYGXLXQXOXMJZGJYGXOXMGUNXLYMXOGXLYJXOXMUQZYMXOQYKXMYEXOURZXMXOUSUTVAVB
      XLXNVCXLDXPYFXLELZXOHZDLZQZEXNVGZYRYEFZYRMZYAIZGFZRZYRXPFZYRYFFZXLYTUUEXL
      YSUUEEXNXLYPXNFZRZYSUUEUUIYSRZUUAUUDUUJXLBYDYRVHZUUAXLUUHYSVDUUJBYDYQVHZU
      UKUUIUULYSXLUUHYPBOZUULUUIYPBUUIXNXMYPYLXLUUHVEZVFVIZYPBCVJSVKUUJBYDYQYRU
      UIYSVEZVLVMXLUUAUUKYDVSFXLUUAUUKTUENVNYDBYRVSCVOVTZVPVQUUJYQMZYAIZUUCGUUJ
      UURUUBYAUUJYQYRUUPVRWAUUIUUSGFYSUUIUUSYPGXLUUHUUMUUSYPQUUOYPBCWBSUUIXNGYP
      XMGWCUUNVFWDVKWEWFWTWGXLUUEYTXLUUERZUUCXNFZUUCXOHZYRQZYTUUTUUCBOUUDUVAUUT
      YRWHZUUCBYRYAWIXLUUAUVDBQZUUDXLUUARUUKUVEXLUUAUUKUUQWJZBYDYRWKPWLWMXLUUAU
      UDWNUUCBWOWPXLUUAUVCUUDXLUUAUUKUVCUVFXLUUKRYRUVBYRBCWQWRSWLYSUVCEUUCXNYPU
      UCQYQUVBYRYPUUCXOXAWSXBVQWTXCXLYNYIUUFYTTXLYJYNYKYOPYLEXMXNYRXOXDUMUUGUUE
      TXLYCUUDAYRYEXSYRQZYBUUCGUVGXTUUBYAXSYRXEWAXFXGXHXIXKXJVM $.
  $}

$( End $[ set-mbox-ta-ind.mm $] $)
$( Begin $[ set-mbox-ta-esum.mm $] $)
$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Extended sum
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c sum* $. $( Summation sign. $)

  $( Extend class notation to include infinite summations. $)
  cesum $a class sum* k e. A B $.

  ${
    $( Define a short-hand for the possibly infinite sum over the extended
       non-negative reals. ` sum* ` is relying on the properties of the
       ` tsums ` , developped by Mario Carneiro.  (Contributed by Thierry
       Arnoux, 21-Sep-2016.) $)
    df-esum $a |- sum* k e. A B =
      U. ( ( RR*s |`s ( 0 [,] +oo ) ) tsums ( k e. A |-> B ) ) $.
  $}

  $( An extended sum is a set by definition.  (Contributed by Thierry Arnoux,
     5-Sep-2017.) $)
  esumex $p |- sum* k e. A B e. _V $=
    ( cesum cxrs cc0 cpnf cicc co cress cmpt ctsu cuni cvv df-esum ovex eqeltri
    uniex ) ABCDEFGHIJIZCABKZLIZMNABCOUASTLPRQ $.

  ${
    $d k V $.
    esumcl.1 $e |- F/_ k A $.
    $( Closure for extended sum in the extended positive reals.  (Contributed
       by Thierry Arnoux, 2-Jan-2017.) $)
    esumcl $p |- ( ( A e. V /\ A. k e. A B e. ( 0 [,] +oo ) ) ->
                        sum* k e. A B e. ( 0 [,] +oo ) ) $=
      ( wcel cc0 cpnf cicc co wral wa cxrs cress cmpt ctsu cesum xrge0base eqid
      a1i ccmn xrge0cmn ctps xrge0tps simpl nfel1 nfra1 nfan nfcv fmptdF tsmscl
      simpr r19.21bi cuni wceq df-esum xrge0tsmsbi mpbiri sseldd ) ADFZBGHIJZFZ
      CAKZLZMVANJZCABOZPJZVAABCQZVDAVAVFVEDRVEUAFVDUBTVEUCFVDUDTUTVCUEZVDCABVAV
      FUTVCCCADEUFVBCAUGUHECVAUIVDVBCAUTVCULUMVFSUJZUKVDVHVGFVHVGUNUOABCUPVDAVH
      VFVEDVESVIVJUQURUS $.
  $}

  ${
    esumeq12dvaf.1 $e |- F/ k ph $.
    esumeq12dvaf.2 $e |- ( ph -> A = B ) $.
    esumeq12dvaf.3 $e |- ( ( ph /\ k e. A ) -> C = D ) $.
    $( Equality deduction for extended sum.  (Contributed by Thierry Arnoux,
       26-Mar-2017.) $)
    esumeq12dvaf $p |- ( ph -> sum* k e. A C = sum* k e. B D ) $=
      ( cxrs cc0 cpnf cicc co cmpt ctsu cuni cesum wceq df-esum wal wral alrimi
      cress cv wcel ex ralrimi mpteq12f syl2anc oveq2d unieqd 3eqtr4g ) AJKLMNU
      DNZFBDOZPNZQUNFCEOZPNZQBDFRCEFRAUPURAUOUQUNPABCSZFUADESZFBUBUOUQSAUSFGHUC
      AUTFBGAFUEBUFUTIUGUHFBDCEUIUJUKULBDFTCEFTUM $.
  $}

  ${
    $d k ph $.
    esumeq12dva.1 $e |- ( ph -> A = B ) $.
    esumeq12dva.2 $e |- ( ( ph /\ k e. A ) -> C = D ) $.
    $( Equality deduction for extended sum.  (Contributed by Thierry Arnoux,
       18-Feb-2017.)  (Revised by Thierry Arnoux, 29-Jun-2017.) $)
    esumeq12dva $p |- ( ph -> sum* k e. A C = sum* k e. B D ) $=
      ( nfv esumeq12dvaf ) ABCDEFAFIGHJ $.
  $}

  ${
    $d k ph $.
    esumeq12d.1 $e |- ( ph -> A = B ) $.
    esumeq12d.2 $e |- ( ph -> C = D ) $.
    $( Equality deduction for extended sum.  (Contributed by Thierry Arnoux,
       18-Feb-2017.) $)
    esumeq12d $p |- ( ph -> sum* k e. A C = sum* k e. B D ) $=
      ( wceq cv wcel adantr esumeq12dva ) ABCDEFGADEIFJBKHLM $.
  $}

  ${
    $d k A $.  $d k B $.
    $( Equality theorem for an extended sum.  (Contributed by Thierry Arnoux,
       18-Feb-2017.) $)
    esumeq1 $p |- ( A = B -> sum* k e. A C = sum* k e. B C ) $=
      ( wceq id eqidd esumeq12d ) ABEZABCCDIFICGH $.
  $}

  ${
    esumeq1d.0 $e |- F/ k ph $.
    esumeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality theorem for an extended sum.  (Contributed by Thierry Arnoux,
       19-Oct-2017.) $)
    esumeq1d $p |- ( ph -> sum* k e. A C = sum* k e. B C ) $=
      ( cv wcel wa eqidd esumeq12dvaf ) ABCDDEFGAEHBIJDKL $.
  $}

  ${
    $d k A $.
    $( Equality theorem for extended sum.  (Contributed by Thierry Arnoux,
       24-Dec-2016.) $)
    esumeq2 $p |- ( A. k e. A B = C -> sum* k e. A B = sum* k e. A C ) $=
      ( wceq wral cxrs cc0 cpnf cicc co cress cmpt ctsu cuni cesum eqid mpteq12
      mpan df-esum oveq2d unieqd 3eqtr4g ) BCEDAFZGHIJKLKZDABMZNKZOUEDACMZNKZOA
      BDPACDPUDUGUIUDUFUHUENAAEUDUFUHEAQDABACRSUAUBABDTACDTUC $.
  $}

  ${
    esumeq2d.0 $e |- F/ k ph $.
    esumeq2d.1 $e |- ( ph -> A. k e. A B = C ) $.
    $( Equality deduction for extended sum.  (Contributed by Thierry Arnoux,
       21-Sep-2016.) $)
    esumeq2d $p |- ( ph -> sum* k e. A B = sum* k e. A C ) $=
      ( eqidd wceq r19.21bi esumeq12dvaf ) ABBCDEFABHACDIEBGJK $.
  $}

  ${
    $d k ph $.
    esumeq2dv.1 $e |- ( ( ph /\ k e. A ) -> B = C ) $.
    $( Equality deduction for extended sum.  (Contributed by Thierry Arnoux,
       2-Jan-2017.) $)
    esumeq2dv $p |- ( ph -> sum* k e. A B = sum* k e. A C ) $=
      ( nfv wceq ralrimiva esumeq2d ) ABCDEAEGACDHEBFIJ $.
  $}

  ${
    $d k ph $.
    esumeq2sdv.1 $e |- ( ph -> B = C ) $.
    $( Equality deduction for extended sum.  (Contributed by Thierry Arnoux,
       25-Dec-2016.) $)
    esumeq2sdv $p |- ( ph -> sum* k e. A B = sum* k e. A C ) $=
      ( wceq cv wcel adantr esumeq2dv ) ABCDEACDGEHBIFJK $.
  $}

  ${
    nfesum1.1 $e |- F/_ k A $.
    $( Bound-variable hypothesis builder for extended sum.  (Contributed by
       Thierry Arnoux, 19-Oct-2017.) $)
    nfesum1 $p |- F/_ k sum* k e. A B $=
      ( cesum cxrs cc0 cpnf cicc cress cmpt ctsu cuni df-esum nfcv nfmpt1 nfuni
      co nfov nfcxfr ) CABCEFGHIRJRZCABKZLRZMABCNCUCCUAUBLCUAOCLOCABPSQT $.
  $}

  ${
    $d j k $.
    cbvesum.1 $e |- ( j = k -> B = C ) $.
    ${
      cbvesum.2 $e |- F/_ k A $.
      cbvesum.3 $e |- F/_ j A $.
      cbvesum.4 $e |- F/_ k B $.
      cbvesum.5 $e |- F/_ j C $.
      $( Change bound variable in an extended sum.  (Contributed by Thierry
         Arnoux, 19-Jun-2017.) $)
      cbvesum $p |- sum* j e. A B = sum* k e. A C $=
        ( cxrs cc0 cpnf cicc co cmpt ctsu cuni cesum df-esum cbvmptf 3eqtr4i
        cress oveq2i unieqi ) KLMNOUCOZDABPZQOZRUFEACPZQOZRABDSACESUHUJUGUIUFQD
        EABCHGIJFUAUDUEABDTACETUB $.
    $}

    $d A j k $.  $d B k $.  $d C j $.
    $( Change bound variable in an extended sum.  (Contributed by Thierry
       Arnoux, 19-Jun-2017.) $)
    cbvesumv $p |- sum* j e. A B = sum* k e. A C $=
      ( nfcv cbvesum ) ABCDEFEAGDAGEBGDCGH $.
  $}

  ${
    esumid.p $e |- F/ k ph $.
    esumid.0 $e |- F/_ k A $.
    esumid.1 $e |- ( ph -> A e. V ) $.
    esumid.2 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumid.3 $e |- ( ph -> C e. ( ( RR*s |`s ( 0 [,] +oo ) )
                                                  tsums ( k e. A |-> B ) ) ) $.
    $( Identify the extended sum as any limit points of the infinite sum.
       (Contributed by Thierry Arnoux, 9-May-2017.) $)
    esumid $p |- ( ph -> sum* k e. A B = C ) $=
      ( cxrs cc0 cpnf cicc co cress cmpt ctsu eqid cuni nfcv fmptdF xrge0tsmseq
      cesum df-esum syl6reqr ) ADLMNOPZQPZEBCRZSPUABCEUEABDUJUIFUITIAEBCUHUJGHE
      UHUBJUJTUCKUDBCEUFUG $.
  $}

  ${
    $d k x $.  $d x A $.  $d x ph $.  $d x B $.
    esumval.p $e |- F/ k ph $.
    esumval.0 $e |- F/_ k A $.
    esumval.1 $e |- ( ph -> A e. V ) $.
    esumval.2 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumval.3 $e |- ( ( ph /\ x e. ( ~P A i^i Fin ) ) ->
                  ( ( RR*s |`s ( 0 [,] +oo ) ) gsum ( k e. x |-> B ) ) = C ) $.
    $( Develop the value of the extended sum.  (Contributed by Thierry Arnoux,
       4-Jan-2017.) $)
    esumval $p |- ( ph -> sum* k e. A B =
                     sup ( ran ( x e. ( ~P A i^i Fin ) |-> C ) , RR* , < ) ) $=
      ( cfn cmpt crn cxr clt cuni co cgsu cesum cpw cin csup csn cxrs cpnf cicc
      cc0 cress ctsu df-esum eqid nfcv fmptdF cv cres wcel wss wceq inss1 sseli
      wa elpwid adantl resmptf oveq2d eqtr2d mpteq2dva rneqd supeq1d xrge0tsmsd
      syl unieqd syl5eq xrltso supex unisn syl6eq ) ACDFUAZBCUBZMUCZENZOZPQUDZU
      EZRZWEAVTUFUIUGUHSZUJSZFCDNZUKSZRWGCDFULAWKWFACWEWJWIGBWIUMJAFCDWHWJHIFWH
      UNKWJUMUOAPWDBWBWIWJBUPZUQZTSZNZOQAWCWOABWBEWNAWLWBURZVCZWNWIFWLDNZTSEWQW
      MWRWITWQWLCUSZWMWRUTWPWSAWPWLCWBWAWLWAMVAVBVDVEFCWLDIFWLUNVFVMVGLVHVIVJVK
      VLVNVOWEPWDQVPVQVRVS $.
  $}

  ${
    $d x k $.  $d x A $.  $d k V $.  $d x ph $.  $d x B $.
    esumel.1 $e |- F/ k ph $.
    esumel.2 $e |- F/_ k A $.
    esumel.3 $e |- ( ph -> A e. V ) $.
    esumel.4 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    $( The extended sum is a limit point of the corresponding infinite group
       sum.  (Contributed by Thierry Arnoux, 24-Mar-2017.) $)
    esumel $p |- ( ph -> sum* k e. A B e.
                     ( ( RR*s |`s ( 0 [,] +oo ) ) tsums ( k e. A |-> B ) ) ) $=
      ( vx cesum co cmpt wcel cv syl eqid nfcv cgsu cfn csn cxrs cc0 cpnf cress
      cicc ctsu wral ex ralrimi esumcl syl2anc snidg fmptdF cres cpw cin wa wss
      wceq inss1 simpr sseldi elpwid resmptf eqcomd esumval xrge0tsmsd eleqtrrd
      oveq2d ) ABCDKZVKUAZUBUCUDUFLZUELZDBCMZUGLAVKVMNZVKVLNABENCVMNZDBUHVPHAVQ
      DBFADOBNVQIUIUJBCDEGUKULVKVMUMPABVKVOVNEJVNQHADBCVMVOFGDVMRIVOQUNAJBCVNVO
      JOZUOZSLDEFGHIAVRBUPZTUQZNZURZDVRCMZVSVNSWCVSWDWCVRBUSVSWDUTWCVRBWCWAVTVR
      VTTVAAWBVBVCVDDBVRCGDVRRVEPVFVJVGVHVI $.
  $}

  ${
    $d x y $.  $d y A $.
    $( Extended sum over the empty set.  (Contributed by Thierry Arnoux,
       19-Feb-2017.) $)
    esumnul $p |- sum* x e. (/) A = 0 $=
      ( vy c0 cfn cin cc0 cmpt cxr clt csup csn wceq wtru cvv wcel 0ex a1i cgsu
      co cesum cpw nftru nfcv cpnf cicc wral ral0 r19.21bi cv cxrs cress ineq1i
      crn pw0 0fin wss snssi df-ss sylib ax-mp eqtri eleq2i elsn biimpi mpteq1d
      bitri mpt0 syl6eq oveq2d xrge00 gsum0 adantl esumval cxp fconstmpt eqcomi
      trud wfn wne 0xr rgenw eqid fnmpt snnz eqnetri fconst5 mp2an mpbi supeq1i
      wb wor xrltso supsn 3eqtri ) DBAUAZCDUBZEFZGHZUNZIJKZGLZIJKZGWPXAMNCDBGAO
      AUCADUDDOPNQRNBGUEUFTZPZADXEADUGNXEAUHRUICUJZWRPZUKXDULTZAXFBHZSTZGMNXGXJ
      XHDSTGXGXIDXHSXGXIADBHDXGAXFDBXGXFDMZXGXFDLZPXKWRXLXFWRXLEFZXLWQXLEUOUMDE
      PZXMXLMZUPXNXLEUQXODEURXLEUSUTVAVBZVCCDVDVGVEVFABVHVIVJXHGVKVLVIVMVNVRIWT
      XBJWSWRXBVOZMZWTXBMZXQWSCWRGVPVQWSWRVSZWRDVTXRXSWKGIPZCWRUGXTYACWRWAWBCWR
      GWSIWSWCWDVAWRXLDXPDQWEWFWRGWSWGWHWIWJIJWLYAXCGMWMWAIGJWNWHWO $.
  $}

  ${
    esum0.k $e |- F/_ k A $.
    $d x y $.  $d x y A $.  $d k x V $.
    $( Extended sum of zero.  (Contributed by Thierry Arnoux, 3-Mar-2017.) $)
    esum0 $p |- ( A e. V -> sum* k e. A 0 = 0 ) $=
      ( vx wcel cc0 cfn cmpt cxr clt csup cpnf co 0xr ax-mp a1i wceq mp2an c0
      cesum cpw cin crn nfel1 id cicc cv cle wbr pnfxr pnfge lbicc2 mp3an cress
      wa cxrs cgsu cmnd cvv ccmn xrge0cmn cmnmnd xrge00 gsumz esumval fconstmpt
      vex csn cxp eqcomi wfn wne wral rgenw eqid fnmpt 0elpw 0fin elin mpbir2an
      wb ne0i fconst5 mpbi supeq1d wor xrltso supsn syl6eq eqtrd ) ACFZAGBUAEAU
      BZHUCZGIZUDZJKLZGWLEAGGBCBACDUEDWLUFGGMUGNZFZWLBUHAFUPGJFZMJFGMUIUJZWSOUK
      WTXAOGULPGMUMUNQUQWRUONZBEUHZGIURNGRZWLXCWNFUPXBUSFZXCUTFXDXBVAFXEVBXBVCP
      EVHXCBXBUTGVDVESQVFWLWQGVIZJKLZGWLJWPXFKWPXFRZWLWOWNXFVJZRZXHXIWOEWNGVGVK
      WOWNVLZWNTVMZXJXHWBWTEWNVNXKWTEWNOVOEWNGWOJWOVPVQPTWNFZXLXMTWMFTHFAVRVSTW
      MHVTWAWNTWCPWNGWOWDSWEQWFJKWGWTXGGRWHOJGKWISWJWK $.
  $}

  ${
    $d k n $.  $d k A $.  $d n B $.  $d k C $.  $d k D $.  $d k G $.
    $d k ph $.
    esumf1o.0 $e |- F/ n ph $.
    esumf1o.a $e |- F/_ n A $.
    esumf1o.c $e |- F/_ n C $.
    esumf1o.f $e |- F/_ n F $.
    esumf1o.1 $e |- ( k = G -> B = D ) $.
    esumf1o.2 $e |- ( ph -> A e. V ) $.
    esumf1o.3 $e |- ( ph -> F : C -1-1-onto-> A ) $.
    esumf1o.4 $e |- ( ( ph /\ n e. C ) -> ( F ` n ) = G ) $.
    esumf1o.5 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    $( Re-index an extended sum using a bijection.  (Contributed by Thierry
       Arnoux, 6-Apr-2017.) $)
    esumf1o $p |- ( ph -> sum* k e. A B = sum* n e. C D ) $=
      ( co cxrs cc0 cpnf cicc cress cmpt ctsu cuni ccom xrge0base ccmn xrge0cmn
      cesum wcel a1i ctps xrge0tps eqid fmptd tsmsf1o cv wa wf1o f1of ffvelrnda
      cfv wf syl eqeltrrd ralrimi feqmptdf mpteq2da eqtrd eqidd fmptcof2 oveq2d
      ex unieqd df-esum 3eqtr4g ) AUAUBUCUDTZUETZFBCUFZUGTZUHWBGDEUFZUGTZUHBCFU
      MDEGUMAWDWFAWDWBWCHUIZUGTWFABWADWCWBHJUJWBUKUNAULUOWBUPUNAUQUOPAFBCWAWCSW
      CURUSQUTAWGWEWBUGAGFDBICEHWCMLKAIBUNZGDKAGVAZDUNZWHAWJVBWIHVFZIBRADBWIHAD
      BHVCDBHVGQDBHVDVHZVEVIVQVJAHGDWKUFGDIUFAGDBHMNWLVKAGDWKIKRVLVMAWCVNOVOVPV
      MVRBCFVSDEGVSVT $.
  $}

  ${
    $d k y z $.  $d y z A $.  $d y B $.  $d k D $.  $d y z C $.  $d y ph $.
    esumc.1 $e |- F/ k ph $.
    esumc.2 $e |- F/_ k A $.
    esumc.3 $e |- ( y = C -> D = B ) $.
    esumc.4 $e |- ( ph -> A e. V ) $.
    esumc.5 $e |- ( ph -> Fun `' ( k e. A |-> C ) ) $.
    esumc.6 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumc.7 $e |- ( ( ph /\ k e. A ) -> C e. W ) $.
    $( Convert from the collection form to the class-variable form of a sum.
       (Contributed by Thierry Arnoux, 10-May-2017.) $)
    esumc $p |- ( ph ->
                       sum* k e. A B = sum* y e. { z | E. k e. A z = C } D ) $=
      ( cv wceq wcel wrex cab cesum cmpt cvv nfre1 nfab nfmpt1 syl abrexexd wfn
      elex ccnv wfun crn wf1o wral ex ralrimi fnmptf rnmpt a1i dff1o2 syl3anbrc
      eqid wa cfv simpr fvmpt2f syl2anc cc0 cpnf cicc co vex eqeq1 rexbidv elab
      reximi sylbi nfv wi eleq1 syl5ibrcom rexlimd imp sylan2 esumf1o eqcomd )
      ACRZFSZHDUAZCUBZGBUCDEHUCAWMGDEBHHDFUDZFUEKWLHCWKHDUFUGLHDFUHMAHCDFLADITD
      UETNDIULUIUJAWNDUKZWNUMUNWNUOWMSZDWMWNUPAFJTZHDUQWOAWQHDKAHRZDTZWQQURUSHD
      FJLUTUIOWPAHCDFWNWNVEVAVBDWMWNVCVDAWSVFZWSWQWRWNVGFSAWSVHQHDFJLVIVJBRZWMT
      ZAGESZHDUAZGVKVLVMVNZTZXBXAFSZHDUAZXDWLXHCXABVOWJXASWKXGHDWJXAFVPVQVRXGXC
      HDMVSVTAXDXFAXCXFHDKXFHWAAWSXCXFWBWTXFXCEXETPGEXEWCWDURWEWFWGWHWI $.
  $}

  ${
    esumsplit.1 $e |- F/ k ph $.
    esumsplit.2 $e |- F/_ k A $.
    esumsplit.3 $e |- F/_ k B $.
    esumsplit.4 $e |- ( ph -> A e. _V ) $.
    esumsplit.5 $e |- ( ph -> B e. _V ) $.
    esumsplit.6 $e |- ( ph -> ( A i^i B ) = (/) ) $.
    esumsplit.7 $e |- ( ( ph /\ k e. A ) -> C e. ( 0 [,] +oo ) ) $.
    esumsplit.8 $e |- ( ( ph /\ k e. B ) -> C e. ( 0 [,] +oo ) ) $.
    $( Split an extended sum into two parts.  (Contributed by Thierry Arnoux,
       9-May-2017.) $)
    esumsplit $p |- ( ph -> sum* k e. ( A u. B ) C =
                                        ( sum* k e. A C +e sum* k e. B C ) ) $=
      ( cesum cxad co cvv wcel cmpt ctsu cun nfun unexg syl2anc cv wo cpnf cicc
      cc0 elun jaodan sylan2b cxrs cress xrge0base xrge0plusg ccmn xrge0cmn a1i
      ctmd xrge0tmd nfcv eqid fmptdF cres esumel wceq ssun1 resmptf mp1i oveq2d
      wss eleqtrrd ssun2 eqidd tsmssplit esumid ) ABCUAZDBDENZCDENZOPEQFEBCGHUB
      ZABQRCQRVRQRIJBCQQUCUDZEUEZVRRAWCBRZWCCRZUFDUIUGUHPZRZWCBCUJAWDWGWELMUKUL
      ZAVRWFBCOEVRDSZUMWFUNPZQVSVTUOUPWJUQRAURUSWJUTRAVAUSWBAEVRDWFWIFWAEWFVBWH
      WIVCVDAVSWJEBDSZTPWJWIBVEZTPABDEQFGILVFAWLWKWJTBVRVLWLWKVGABCVHEVRBDWAGVI
      VJVKVMAVTWJECDSZTPWJWICVEZTPACDEQFHJMVFAWNWMWJTCVRVLWNWMVGACBVNEVRCDWAHVI
      VJVKVMKAVRVOVPVQ $.
  $}

  ${
    $d k x y A $.  $d x y B $.  $d y C $.  $d k V $.  $d k x y ph $.
    esumadd.0 $e |- ( ph -> A e. V ) $.
    esumadd.1 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumadd.2 $e |- ( ( ph /\ k e. A ) -> C e. ( 0 [,] +oo ) ) $.
    $( Addition of infinite sums.  (Contributed by Thierry Arnoux,
       24-Mar-2017.) $)
    esumadd $p |- ( ph -> sum* k e. A ( B +e C ) =
                        ( sum* k e. A B +e sum* k e. A C ) ) $=
      ( cxad co cesum wcel cmpt ctsu a1i eqid fmptd esumel eqidd nfv nfcv cv wa
      cpnf cicc ge0xaddcl syl2anc cxrs cress xrge0base xrge0plusg ccmn xrge0cmn
      cc0 cof ctmd xrge0tmd tsmsadd offval2 oveq2d eleqtrd esumid ) ABCDJKZBCEL
      ZBDELZJKZEFAEUAZEBUBZGAEUCBMUDCUOUEUFKZMDVJMVDVJMHICDUGUHAVGUIVJUJKZEBCNZ
      EBDNZJUPKZOKVKEBVDNZOKABVJJVLVKVMFVEVFUKULVKUMMAUNPVKUQMAURPGAEBCVJVLHVLQ
      RAEBDVJVMIVMQRABCEFVHVIGHSABDEFVHVIGISUSAVNVOVKOAEBCDJVLVMFVJVJGHIAVLTAVM
      TUTVAVBVC $.

    esumle.3 $e |- ( ( ph /\ k e. A ) -> B <_ C ) $.
    $( If all of the terms of an extended sums compare, so do the sums.
       (Contributed by Thierry Arnoux, 8-Jun-2017.) $)
    esumle $p |- ( ph -> sum* k e. A B <_ sum* k e. A C ) $=
      ( cesum cxad co cle cxr wcel cc0 wbr cpnf syl2anc cxne cicc esumcl sseldi
      iccssxr wral ralrimiva nfcv cv wa xnegcld xaddcld wb xsubge0 mpbird pnfge
      syl w3a 0xr pnfxr elicc1 mp2an syl3anbrc a1i elicc4 syl3anc xraddge02 imp
      mpbid simpld syl21anc xaddcom breqtrd esumadd xrge0npcan esumeq2dv eqtr3d
      wceq ) ABCEKZBDCUAZLMZEKZVSLMZBDEKZNAVSVSWBLMZWCNAVSOPZWBOPZQWBNRZVSWENRZ
      AQSUBMZOVSQSUEZABFPZCWJPZEBUFVSWJPGAWMEBHUGBCEFEBUHZUCTUDZAWJOWBWKAWLWAWJ
      PZEBUFWBWJPZGAWPEBAEUIBPUJZWAOPZQWANRZWASNRZWPWRDVTWRWJODWKIUDZWRCWRWJOCW
      KHUDZUKULZWRWTCDNRZJWRDOPCOPWTXEUMXBXCDCUNTUOWRWSXAXDWAUPUQQOPZSOPZWPWSWT
      XAURUMUSUTQSWAVAVBVCZUGBWAEFWNUCTZUDZAWHWBSNRZAWQWHXKUJZXIAXFXGWGWQXLUMXF
      AUSVDXGAUTVDXJQSWBVEVFVIVJWFWGUJWHWIVSWBVGVHVKAWFWGWEWCVRWOXJVSWBVLTVMABW
      ACLMZEKWCWDABWACEFGXHHVNABXMDEWRDWJPWMXEXMDVRIHJDCVOVFVPVQVM $.
  $}

  ${
    $d k A $.  $d k C $.
    esummono.f $e |- F/ k ph $.
    esummono.c $e |- ( ph -> C e. V ) $.
    esummono.b $e |- ( ( ph /\ k e. C ) -> B e. ( 0 [,] +oo ) ) $.
    esummono.a $e |- ( ph -> A C_ C ) $.
    $( Extended sum is monotonic.  (Contributed by Thierry Arnoux,
       19-Oct-2017.) $)
    esummono $p |- ( ph -> sum* k e. A B <_ sum* k e. C B ) $=
      ( cesum co cle cc0 wbr cpnf wcel cvv syl2anc cxr cdif cxad cicc difexg cv
      wral syl simpr eldifad syldan ralrimi nfcv esumcl elxrge0 simprbi iccssxr
      wa ex wi ssexd sselda sseldi xraddge02 mpd cun cin wceq disjdif esumsplit
      c0 a1i wss undif sylib esumeq1d eqtr3d breqtrd ) ABCEKZVRDBUAZCEKZUBLZDCE
      KZMANVTMOZVRWAMOZAVTNPUCLZQZWCAVSRQZCWEQZEVSUFWFADFQWGHDBFUDUGZAWHEVSGAEU
      EZVSQZWHAWKWJDQZWHAWKUQWJDBAWKUHUIIUJZURUKVSCEREVSULZUMSZWFVTTQZWCVTUNUOU
      GAVRTQWPWCWDUSAWETVRNPUPZABRQWHEBUFVRWEQABDFHJUTZAWHEBGAWJBQZWHAWSWLWHABD
      WJJVAIUJZURUKBCEREBULZUMSVBAWETVTWQWOVBVRVTVCSVDABVSVEZCEKWAWBABVSCEGXAWN
      WRWIBVSVFVJVGABDVHVKWTWMVIAXBDCEGABDVLXBDVGJBDVMVNVOVPVQ $.
  $}

  ${
    $d a k x y A $.  $d a x y B $.  $d y X $.  $d a x y ph $.
    gsumesum.0 $e |- F/ k ph $.
    gsumesum.1 $e |- ( ph -> A e. Fin ) $.
    gsumesum.2 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    $( Relate a group sum on ` ( RR*s |``s ( 0 [,] +oo ) ) ` to a finite
       extended sum.  (Contributed by Thierry Arnoux, 19-Oct-2017.) $)
    gsumesum $p |- ( ph -> ( ( RR*s |`s ( 0 [,] +oo ) ) gsum ( k e. A |-> B ) )
      = sum* k e. A B ) $=
      ( vx va cfn cc0 co cgsu cxr wcel wa a1i sseldi wceq syl2anc cesum cpw cin
      vy cxrs cpnf cicc cress cv cmpt crn clt csup eqidd esumval xrltso iccssxr
      nfcv wor xrge0base xrge00 ccmn xrge0cmn eqid fmptdF cvv csn cdif fisuppfi
      gsumcl wrex pwidg elin sylanbrc mpteq1 oveq2d eqeq2d rspcev ovex elrnmpti
      syl sylibr cle wbr wn wral simpr cbvmptv cxad vex nfv nfan wel simpll wss
      sylib inss1 sseli elpwid sseldd inss2 adantr difexg eldifad diffi elxrge0
      ad2antlr simprbi xraddge02 imp syl21anc adantlr adantl cres xrge0plusg wf
      ccnv cima c0 disjdif cun undif biimpi eqcomd gsumsplit resmpt difss ax-mp
      oveq2i oveq12d eqtrd breqtrrd ralrimiva r19.29r biimpar rexlimivw rnmptss
      breq1 wb sselda xrltnle con2bid mpbid supmax eqtr2d ) ABCDUAHBUBZJUCZUEKU
      FUGLZUHLZDHUIZCUJZMLZUJZUKZNULUMUUIDBCUJZMLZAHBCUULDJEDBURZFGAUUJUUGOZPZU
      ULUNUOAUDNUUNUUPULNULUSAUPQAUUHNUUPKUFUQZABUUHUUOUUIJKUTVAUUIVBOZAVCQFADB
      CUUHUUOEUUQDUUHURZGUUOVDVEZABUUHVFKVGVHZUUOFUVCVIZVJRZAUUPUULSZHUUGVKZUUP
      UUNOABUUGOZUUPUUPSZUVHABUUFOZBJOZUVIAUVLUVKFBJVLWAFBUUFJVMVNAUUPUNUVGUVJH
      BUUGUUJBSZUULUUPUUPUVMUUKUUOUUIMDUUJBCVOVPVQVRTHUUGUULUUPUUMUUMVDZUUIUUKM
      VSVTWBAUDUIZUUNOZPZUVOUUPWCWDZUUPUVOULWDZWEZUVQUVOUUIDIUIZCUJZMLZSZIUUGVK
      ZUWCUUPWCWDZIUUGWFZUVRUVQUVPUWEAUVPWGIUUGUWCUVOUUMHIUUGUULUWCUUJUWASUUKUW
      BUUIMDUUJUWACVOVPWHUUIUWBMVSVTWPUVQUWFIUUGUVQUWAUUGOZPZUWCUWCUUIDBUWAVHZC
      UJZMLZWILZUUPWCAUWHUWCUWMWCWDZUVPAUWHPZUWCNOZUWLNOZKUWLWCWDZUWNUWOUUHNUWC
      UUTUWOUWAUUHUWBUUIVFKUTVAUVAUWOVCQZUWAVFOUWOIWJQUWODUWACUUHUWBAUWHDEUWHDW
      KWLZDUWAURUVBUWODIWMZPZADUIZBOZCUUHOZAUWHUXAWNUXBUWABUXCUWHUWABWOZAUXAUWH
      UWABUUGUUFUWAUUFJWQZWRWSZXGUWOUXAWGWTGTUWBVDVEZUWOUWAUUHUVDUWBUWOUUGJUWAU
      UFJXAZAUWHWGRUXIVIVJRUWOUUHNUWLUUTUWOUWJUUHUWKUUIVFKUTVAUWSUWOUVLUWJVFOAU
      VLUWHFXBZBUWAJXCWAUWODUWJCUUHUWKUWTDUWJURUVBUWOUXCUWJOZPZAUXDUXEAUWHUXLWN
      UXMUXCBUWAUWOUXLWGXDGTUWKVDVEZUWOUWJUUHUVDUWKUWOUVLUWJJOUXKBUWAXEWAUXNVIV
      JZRUWOUWLUUHOZUWRUXOUXPUWQUWRUWLXFXHWAUWPUWQPUWRUWNUWCUWLXIXJXKXLUWIAUXFU
      UPUWMSAUVPUWHWNUWHUXFUVQUXHXMAUXFPZUUPUUIUUOUWAXNZMLZUUIUUOUWJXNZMLZWILUW
      MUXQBUUHUWAUWJWIUUOUUIJKUTVAXOUVAUXQVCQAUVLUXFFXBABUUHUUOXPUXFUVCXBAUUOXQ
      UVDXRJOUXFUVEXBUWAUWJUCXSSUXQUWABXTQUXFBUWAUWJYAZSAUXFUYBBUXFUYBBSUWABYBY
      CYDXMYEUXQUXSUWCUYAUWLWIUXFUXSUWCSAUXFUXRUWBUUIMDBUWACYFVPXMUYAUWLSUXQUXT
      UWKUUIMUWJBWOUXTUWKSBUWAYGDBUWJCYFYHYIQYJYKTYLYMUWEUWGPUWDUWFPZIUUGVKUVRU
      WDUWFIUUGYNUYCUVRIUUGUWDUVRUWFUVOUWCUUPWCYRYOYPWATUVQUUPNOZUVONOZUVRUVTYS
      AUYDUVPUVFXBAUUNNUVOAUULNOZHUUGWFUUNNWOAUYFHUUGUUSUUHNUULUUTUUSUUJUUHUUKU
      UIUUGKUTVAUVAUUSVCQAUURWGZUUSDUUJCUUHUUKAUURDEUURDWKWLDUUJURUVBUUSDHWMZPZ
      AUXDUXEAUURUYHWNUYIUUJBUXCUYIUUJBUURUUJUUFOAUYHUUGUUFUUJUXGWRXGWSUUSUYHWG
      WTGTUUKVDVEZUUSUUJUUHUVDUUKUUSUUGJUUJUXJUYGRUYJVIVJRYMHUUGUULNUUMUVNYQWAY
      TUYDUYEPUVSUVRUUPUVOUUAUUBTUUCUUDUUE $.
  $}

  ${
    $d a k x y A $.  $d a x y B $.  $d a y X $.  $d a x y ph $.
    esumlub.f $e |- F/ k ph $.
    esumlub.0 $e |- ( ph -> A e. V ) $.
    esumlub.1 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumlub.2 $e |- ( ph -> X e. RR* ) $.
    esumlub.3 $e |- ( ph -> X < sum* k e. A B ) $.
    $( The extended sum is the lowest upper bound for the partial sums.
       (Contributed by Thierry Arnoux, 19-Oct-2017.) $)
    esumlub $p |- ( ph -> E. a e. ( ~P A i^i Fin ) X < sum* k e. a B ) $=
      ( vx clt wbr cfn cxr wcel wa simpr vy cxrs cc0 cpnf cicc co cress cv cmpt
      cgsu cpw cin wrex cesum crn csup nfcv eqidd esumval breq2d wss wb iccssxr
      wral xrge0base xrge00 ccmn xrge0cmn a1i nfan simpll inss1 ad2antlr elpwid
      nfv sseli sseldd syl2anc eqid fmptdF cvv csn inss2 sseldi fisuppfi gsumcl
      cdif ralrimiva rnmptss syl supxrlub bitrd ovex wceq mpteq1 oveq2d cbvmptv
      mpbid elrnmpti rexxfr2d gsumesum biimpd reximdva mpd ) AFUBUCUDUEUFZUGUFZ
      DGUHZCUIZUJUFZNOZGBUKZPULZUMZFXGCDUNZNOZGXLUMAFUAUHZNOZUAMXLXFDMUHZCUIZUJ
      UFZUIZUOZUMZXMAFBCDUNZNOZYCLAYEFYBQNUPZNOZYCAYDYFFNAMBCXTDEHDBUQIJAXRXLRZ
      SZXTURUSUTAYBQVAZFQRYGYCVBAXTQRZMXLVDYJAYKMXLYIXEQXTUCUDVCYIXRXEXSXFXLUCV
      EVFXFVGRYIVHVIAYHTZYIDXRCXEXSAYHDHYHDVOVJDXRUQDXEUQYIDUHZXRRZSZAYMBRZCXER
      ZAYHYNVKYOXRBYMYOXRBYHXRXKRAYNXLXKXRXKPVLZVPVMVNYIYNTVQJVRXSVSVTZYIXRXEWA
      UCWBWGXSYIXLPXRXKPWCZYLWDYSWEWFWDWHMXLXTQYAYAVSWIWJKUAYBFWKVRWLWRAXQXJUAG
      XIYBXLWAXIWARAXGXLRZSZXFXHUJWMZVIXPYBRXPXIWNZGXLUMVBAGXLXIXPYAMGXLXTXIXRX
      GWNXSXHXFUJDXRXGCWOWPWQUUCWSVIAUUDSXPXIFNAUUDTUTWTWRAXJXOGXLUUBXJXOUUBXIX
      NFNUUBXGCDAUUADHUUADVOVJUUBXLPXGYTAUUATWDUUBYMXGRZSZAYPYQAUUAUUEVKUUFXGBY
      MUUFXGBUUAXGXKRAUUEXLXKXGYRVPVMVNUUBUUETVQJVRXAUTXBXCXD $.
  $}

  ${
    $d k V $.
    esumaddf.0 $e |- F/ k ph $.
    esumaddf.a $e |- F/_ k A $.
    esumaddf.1 $e |- ( ph -> A e. V ) $.
    esumaddf.2 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumaddf.3 $e |- ( ( ph /\ k e. A ) -> C e. ( 0 [,] +oo ) ) $.
    $( Addition of infinite sums.  (Contributed by Thierry Arnoux,
       22-Jun-2017.) $)
    esumaddf $p |- ( ph -> sum* k e. A ( B +e C ) =
                        ( sum* k e. A B +e sum* k e. A C ) ) $=
      ( cxad co cesum wcel cmpt ctsu a1i eqid fmptdF cv cc0 cpnf cicc ge0xaddcl
      wa syl2anc cxrs cof xrge0base xrge0plusg ccmn xrge0cmn ctmd xrge0tmd nfcv
      cress esumel tsmsadd eqidd offval2f oveq2d eleqtrd esumid ) ABCDLMZBCENZB
      DENZLMZEFGHIAEUABOUFCUBUCUDMZODVIOVEVIOJKCDUEUGAVHUHVIUQMZEBCPZEBDPZLUIMZ
      QMVJEBVEPZQMABVILVKVJVLFVFVGUJUKVJULOAUMRVJUNOAUORIAEBCVIVKGHEVIUPZJVKSTA
      EBDVIVLGHVOKVLSTABCEFGHIJURABDEFGHIKURUSAVMVNVJQAEBCDLVKVLFVIVIGHIJKAVKUT
      AVLUTVAVBVCVD $.

    esumlef.3 $e |- ( ( ph /\ k e. A ) -> B <_ C ) $.
    $( If all of the terms of an extended sums compare, so do the sums.
       (Contributed by Thierry Arnoux, 8-Jun-2017.) $)
    esumlef $p |- ( ph -> sum* k e. A B <_ sum* k e. A C ) $=
      ( cesum co cle cxr wcel cc0 wbr cpnf cxne cxad cicc iccssxr cv ex ralrimi
      wral esumcl syl2anc sseldi wa xnegcld xaddcld wb xsubge0 mpbird pnfge syl
      w3a 0xr pnfxr elicc1 mp2an syl3anbrc elicc4 syl3anc mpbid simpld syl21anc
      a1i xraddge02 wceq xaddcom breqtrd esumaddf xrge0npcan esumeq2d eqtr3d
      imp ) ABCEMZBDCUAZUBNZEMZWAUBNZBDEMZOAWAWAWDUBNZWEOAWAPQZWDPQZRWDOSZWAWGO
      SZARTUCNZPWARTUDZABFQZCWLQZEBUHWAWLQIAWOEBGAEUEBQZWOJUFUGBCEFHUIUJUKZAWLP
      WDWMAWNWCWLQZEBUHWDWLQZIAWREBGAWPWRAWPULZWCPQZRWCOSZWCTOSZWRWTDWBWTWLPDWM
      KUKZWTCWTWLPCWMJUKZUMUNZWTXBCDOSZLWTDPQCPQXBXGUOXDXEDCUPUJUQWTXAXCXFWCURU
      SRPQZTPQZWRXAXBXCUTUOVAVBRTWCVCVDVEZUFUGBWCEFHUIUJZUKZAWJWDTOSZAWSWJXMULZ
      XKAXHXIWIWSXNUOXHAVAVKXIAVBVKXLRTWDVFVGVHVIWHWIULWJWKWAWDVLVTVJAWHWIWGWEV
      MWQXLWAWDVNUJVOABWCCUBNZEMWEWFABWCCEFGHIXJJVPABXODEGAXODVMZEBGAWPXPWTDWLQ
      WOXGXPKJLDCVQVGUFUGVRVSVO $.
  $}

  ${
    $d a l n x y z A $.  $d a l n x y z B $.  $d a k l n x y V $.
    esumcst.1 $e |- F/_ k A $.
    esumcst.2 $e |- F/_ k B $.
    $( The extended sum of a constant.  (Contributed by Thierry Arnoux,
       3-Mar-2017.)  (Revised by Thierry Arnoux, 5-Jul-2017.) $)
    esumcst $p |- ( ( A e. V /\ B e. ( 0 [,] +oo ) ) ->
                                        sum* k e. A B = ( ( # ` A ) *e B ) ) $=
      ( vx wcel cc0 cpnf co wa cfn chash cxmu cxr clt wceq syl2anc wbr vy vz vn
      va vl cicc cesum cpw cin cv cfv cmpt crn csup nfel1 nfan simpl cxrs cress
      simplr cgsu cmg cmnd ctmd xrge0tmd tmdmnd ax-mp a1i inss2 simpr xrge0base
      sseldi eqid gsumconstf syl3anc cn0 syl xrge0mulgnn0 eqtrd esumval wss cle
      hashcl wral wrex wi cr csn cun nn0ssre ressxr sstri pnfxr snssi unssi cvv
      wf hashf vex ffvelrn mp2an sselii iccssxr adantr xmulcld hashxrcl elrnmpt
      fmptd frn wb biimpi 0xr iccgelb jca cdom inss1 sseli elpwi 3syl ralrimiva
      ssdomg r19.29r elin sylibr fveq2 oveq1d eqeq2d rspcev ovex adantl simp-4r
      breq2 c0 oveq2d xmul01 elrnmpti simpllr cn ex c1 hashdomi syl2anr eqbrtrd
      sylc xlemul1a syl31anc rexlimivw pwidg ancri mpan2 crp w3o elxrge02 sylib
      wn 0elpw 0fin mpbir2an hash0 eqeltri syl6req ad4antr breqtrd cdiv eqeltrd
      nnnn0 hashclb sylanbrc eqidd simp-8r nnred simp-5r ltdivmul2d mpbid rpred
      cmul rexmul breqtrrd rexlimdva impr rerpdivcld ishashinf ad2antlr r19.29a
      arch wex nfielex snelpwi snfi jctir hashsng 1re syl6eqel syl5breqr eqtr2d
      xmulpnf1 exlimddv adantll ltpnf 3jaodan mpdan pm2.61dan supxr2 syl22anc
      0lt1 ) ADHZBIJUFKZHZLZABCUGGAUHZMUIZGUJZNUKZBOKZULZUMZPQUNZANUKZBOKZUXIGA
      BUXNCDUXFUXHCCADEUOCBUXGFUOUPEUXFUXHUQZUXFUXHCUJAHUTUXIUXLUXKHZLZURUXGUSK
      ZCUXLBULVAKZUXMBUYCVBUKZKZUXNUYBUYCVCHZUXLMHZUXHUYDUYFRUYGUYBUYCVDHUYGVEU
      YCVFVGVHUYBUXKMUXLUXJMVIUXIUYAVJZVLZUXFUXHUYAUTZUXLUXGUYECUYCBFVKUYEVMVNV
      OUYBUXMVPHZUXHUYFUXNRUYBUYHUYLUYJUXLWCVQUYKUXMBVRSVSVTUXIUXPPWAZUXSPHUAUJ
      ZUXSWBTZUAUXPWDUYNUXSQTZUYNUBUJZQTZUBUXPWEZWFZUAWGWDUXQUXSRUXIUXKPUXOWQUY
      MUXIGUXKUXNPUXOUYBUXMBUXMPHZUYBVPJWHZWIZPUXMVPVUBPVPWGPWJWKWLJPHZVUBPWAWM
      JPWNVGWOWPVUCNWQUXLWPHUXMVUCHWRGWSWPVUCUXLNWTXAXBVHZUXIBPHZUYAUXIUXGPBIJX
      CUXFUXHVJVLZXDZXEUXOVMZXHUXKPUXOXIVQUXIUXRBUXFUXRPHZUXHADXFXDZVUGXEUXIUYO
      UAUXPUXIUYNUXPHZLUYNUXNRZUXNUXSWBTZLZGUXKWEZUYOVULVUMGUXKWEZVUNGUXKWDVUPU
      XIVULVUQUYNWPHVULVUQXJUAWSGUXKUXNUYNUXOWPVUIXGVGXKUXIVUNGUXKUYBVUAVUJVUFI
      BWBTZLUXMUXRWBTZVUNVUEUXIVUJUYAVUKXDUYBVUFVURVUHUYBIPHZVUDUXHVURVUTUYBXLV
      HVUDUYBWMVHUYKIJBXMVOXNUYBUXLAXOTZVUSUYBUXFUXLAWAZVVAUXIUXFUYAUXTXDUYBUYA
      UXLUXJHVVBUYIUXKUXJUXLUXJMXPXQUXLAXRXSUXLADYAUUDUXLAUUAVQUXMUXRBUUEUUFXTV
      UMVUNGUXKYBUUBVUOUYOGUXKVUOUYNUXNUXSWBVUMVUNUQVUMVUNVJUUCUUGVQXTUXIUYTUAW
      GUXIUYNWGHZLZUYPUYSVVDUYPLZAMHZUYSVVEVVFLUXSUXPHZUYPUYSVVFVVGVVEVVFAUXKHZ
      VVGVVFAUXJHZVVFLVVHVVFVVIAMUUHUUIAUXJMYCYDVVHUXSUXNRZGUXKWEZVVGVVHUXSUXSR
      ZVVKUXSVMVVJVVLGAUXKUXLARZUXNUXSUXSVVMUXMUXRBOUXLANYEYFYGYHUUJUXSWPHVVGVV
      KXJUXRBOYIGUXKUXNUXSUXOWPVUIXGVGYDVQYJVVDUYPVVFUTUYRUYPUBUXSUXPUYQUXSUYNQ
      YLYHSVVEVVFUUOZLZBIRZBUUKHZBJRZUULZUYSVVOUXHVVSUXFUXHVVCUYPVVNYKBUUMUUNVV
      OVVPUYSVVQVVRVVOVVPLZIUXPHZUYNIQTZUYSVVTIUXNRZGUXKWEZVWAVVTYMUXKHZIYMNUKZ
      BOKZRZVWDVWEVVTVWEYMUXJHYMMHAUUPUUQYMUXJMYCUURVHVVTVWGVWFIOKZIVVTBIVWFOVV
      OVVPVJZYNVWFPHVWIIRVWFIPUUSXLUUTVWFYOVGUVAVWCVWHGYMUXKUXLYMRZUXNVWGIVWKUX
      MVWFBOUXLYMNYEYFYGYHSGUXKUXNIUXOVUIUXMBOYIZYPYDVVTUYNUXSIQVVDUYPVVNVVPYQV
      VTUXSUXRIOKZIVVTBIUXROVWJYNVVTVUJVWMIRUXIVUJVVCUYPVVNVVPVUKUVBUXRYOVQVSUV
      CUYRVWBUBIUXPUYQIUYNQYLYHSVVOVVQLZUYNBUVDKZUCUJZQTZUDUJZNUKZVWPRZUDUXJWEZ
      LZUYSUCYRVWNVWPYRHZLZVWQVXAUYSVXDVWQLZVWTUYSUDUXJVXEVWRUXJHZLZVWTUYSVXGVW
      TLZVWSBOKZUXPHZUYNVXIQTZUYSVXHVXIUXNRZGUXKWEZVXJVXHVWRUXKHZVXIVXIRZVXMVXH
      VXFVWRMHZVXNVXEVXFVWTUTVXHVWSYRHZVXPVXHVWSVWPYRVXGVWTVJZVWNVXCVWQVXFVWTYK
      ZUVEVXQVWSVPHZVXPVWSUVFVWRWPHVXPVXTXJUDWSVWRWPUVGVGYDVQVWRUXJMYCUVHVXHVXI
      UVIVXLVXOGVWRUXKUXLVWRRZUXNVXIVXIVYAUXMVWSBOUXLVWRNYEYFYGYHSGUXKUXNVXIUXO
      VUIVWLYPYDVXHUYNVWPBUVPKZVXIQVXHVWQUYNVYBQTVXDVWQVXFVWTYQVXHUYNVWPBUXIVVC
      UYPVVNVVQVXCVWQVXFVWTUVJVXHVWPVXSUVKZVVOVVQVXCVWQVXFVWTUVLZUVMUVNVXHVXIVW
      PBOKZVYBVXHVWSVWPBOVXRYFVXHVWPWGHBWGHVYEVYBRVYCVXHBVYDUVOVWPBUVQSVSUVRUYR
      VXKUBVXIUXPUYQVXIUYNQYLYHSYSUVSUVTVWNVWQUCYRWEZVXAUCYRWDZVXBUCYRWEVWNVWOW
      GHVYFVWNUYNBUXIVVCUYPVVNVVQYKVVOVVQVJUWAVWOUCUWEVQVVNVYGVVEVVQUDAUCUWBUWC
      VWQVXAUCYRYBSUWDVVOVVRLZJUXPHZUYNJQTZUYSVYHJUXNRZGUXKWEZVYIVVNVVRVYLVVEVV
      NVVRLZUEUJZAHZVYLUEVVNVYOUEUWFVVRUEAUWGXDVYMVYOLZVYNWHZUXKHZJVYQNUKZBOKZR
      ZVYLVYOVYRVYMVYOVYQUXJHZVYQMHZLVYRVYOWUBWUCVYNAUWHVYNUWIUWJVYQUXJMYCYDYJV
      YPVYTVYSJOKZJVYPBJVYSOVVNVVRVYOUTYNVYOWUDJRZVYMVYOVYSPHIVYSQTWUEVYOVYSYTP
      VYNAUWKZWGPYTWKUWLXBUWMVYOIYTVYSQUXEWUFUWNVYSUWPSYJUWOVYKWUAGVYQUXKUXLVYQ
      RZUXNVYTJWUGUXMVYSBOUXLVYQNYEYFYGYHSUWQUWRGUXKUXNJUXOVUIVWLYPYDVYHVVCVYJU
      XIVVCUYPVVNVVRYKUYNUWSVQUYRVYJUBJUXPUYQJUYNQYLYHSUWTUXAUXBYSXTUAUBUXPUXSU
      XCUXDVS $.
  $}

  ${
    $d x A $.  $d k x B $.  $d k x M $.  $d k V $.  $d k x ph $.
    esumsn.1 $e |- ( ( ph /\ k = M ) -> A = B ) $.
    esumsn.2 $e |- ( ph -> M e. V ) $.
    esumsn.3 $e |- ( ph -> B e. ( 0 [,] +oo ) ) $.
    $( The extended sum of a singleton is the term.  (Contributed by Thierry
       Arnoux, 2-Jan-2017.) $)
    esumsn $p   |- ( ph -> sum* k e. { M } A = B ) $=
      ( vx cc0 co wceq a1i cfn wcel syl2anc cxr clt c0 csn cesum cxrs cpnf cicc
      cress cmpt ctsu cuni df-esum eqid snfi wf wss cop sylan2 mpteq2dva fmptsn
      cv elsni eqtr4d wb fsng mpbird fss cpr csup wbr cif cpw cin cres cgsu crn
      snssd wor xrltso 0xr cle wa elxrge0 sylib simpld syl3anc 0fin reseq2 res0
      suppr syl6eq oveq2d xrge00 gsum0 adantl ssid xrge0base ccmn cmnd xrge0cmn
      resmpt ax-mp cmnmnd gsumsn2 sylan9eqr pwsn prssi mp2an eqsstri df-ss mpbi
      fmptpr eqtri mpteq12i syl6eqr rneqd rnpropg eqtr3d supeq1d simprd xrlenlt
      wn mpbid eqidd jca olcd eqif sylibr 3eqtr4rd xrge0tsmsd unieqd unisng syl
      wo 3eqtrd ) AEUAZBDUBZUCKUDUELZUFLZDYNBUGZUHLZUIZCUAZUIZCYOYTMAYNBDUJNAYS
      UUAAYNCYRYQOJYQUKYNOPZAEULZNZAYNUUAYRUMZUUAYPUNYNYPYRUMAUUFYRECUOUAZMZAYR
      DYNCUGZUUGADYNBCDUSZYNPAUUJEMBCMUUJEUTGUPUQAEFPZCYPPZUUGUUIMHIDECFYPURQVA
      AUUKUULUUFUUHVBHIECFYPYRVCQVDACYPIVOYNUUAYPYRVEQAKCVFZRSVGZCKSVHZKCVIZJYN
      VJZOVKZYQYRJUSZVLZVMLZUGZVNZRSVGCARSVPZKRPZCRPZUUNUUPMUVDAVQNUVEAVRNZAUVF
      KCVSVHZAUULUVFUVHVTICWAWBZWCZRKCSWHWDARUVCUUMSATKUOYNCUOVFZVNZUVCUUMAUVKU
      VBAUVKJTYNVFZUVAUGUVBAJTYNKCUVAOORYPTOPZAWENZUUEUVGIUUSTMZUVAKMAUVPUVAYQT
      VMLKUVPUUTTYQVMUVPUUTYRTVLTUUSTYRWFYRWGWIWJYQKWKWLWIWMUUSYNMZAUVAYQYRVMLC
      UVQUUTYRYQVMUVQUUTYRYNVLZYRUUSYNYRWFYNYNUNUVRYRMYNWNDYNYNBWSWTWIWJABYPCDY
      QEFWOYQWPPYQWQPWRYQXAWTGHIXBXCXJJUURUVAUVMUVAUURUUQUVMUUQOUNUURUUQMUUQUVM
      OEXDZUVNUUCUVMOUNWEUUDTYNOXEXFXGUUQOXHXIUVSXKUVAUKXLXMXNAUVNUUCUVLUUMMUVO
      UUETYNKCOOXOQXPXQAUUOCKMVTZUUOXTZCCMZVTZYLCUUPMAUWCUVTAUWAUWBAUVHUWAAUVFU
      VHUVIXRAUVEUVFUVHUWAVBUVGUVJKCXSQYAACYBYCYDUUOCKCYEYFYGYHYIAUULUUBCMICYPY
      JYKYM $.
  $}

  ${
    $d A k x $.  $d B k x $.  $d C x $.  $d k D $.  $d k E $.  $d k ph $.
    $d k V $.  $d k W $.
    esumpr.1 $e |- ( ( ph /\ k = A ) -> C = D ) $.
    esumpr.2 $e |- ( ( ph /\ k = B ) -> C = E ) $.
    esumpr.3 $e |- ( ph -> A e. V ) $.
    esumpr.4 $e |- ( ph -> B e. W ) $.
    esumpr.5 $e |- ( ph -> D e. ( 0 [,] +oo ) ) $.
    esumpr.6 $e |- ( ph -> E e. ( 0 [,] +oo ) ) $.
    ${
      esumpr.7 $e |- ( ph -> A =/= B ) $.
      $( Extended sum over a pair.  (Contributed by Thierry Arnoux,
         2-Jan-2017.) $)
      esumpr $p |- ( ph -> sum* k e. { A , B } C = ( D +e E ) ) $=
        ( cesum cxad wceq wcel cpr csn cun df-pr esumeq1 mp1i nfv nfcv cvv snex
        co a1i wne cin c0 disjsn2 syl cv wa cc0 cpnf cicc sylan2 adantr eqeltrd
        elsni esumsplit esumsn oveq12d 3eqtrd ) ABCUAZDFQZBUBZCUBZUCZDFQZVMDFQZ
        VNDFQZRUKEGRUKVKVOSVLVPSABCUDVKVODFUEUFAVMVNDFAFUGFVMUHFVNUHVMUITABUJUL
        VNUITACUJULABCUMVMVNUNUOSPBCUPUQAFURZVMTZUSDEUTVAVBUKZVTAVSBSDESVSBVFJV
        CAEWATVTNVDVEAVSVNTZUSDGWAWBAVSCSDGSVSCVFKVCAGWATWBOVDVEVGAVQEVRGRADEFB
        HJLNVHADGFCIKMOVHVIVJ $.
    $}

    ${
      esumpr2.1 $e |- ( ph -> ( A = B -> ( D = 0 \/ D = +oo ) ) ) $.
      $( Extended sum over a pair, with a relaxed condition compared to
         ~ esumpr .  (Contributed by Thierry Arnoux, 2-Jan-2017.) $)
      esumpr2 $p |- ( ph -> sum* k e. { A , B } C = ( D +e E ) ) $=
        ( cxad wceq adantr cpnf cpr cesum co wa csn simpr dfsn2 syl5req esumeq1
        preq2 3syl esumsn eqtrd cc0 oveq2 cxr wcel 0xr eleq1 mpbiri xaddid1 syl
        wo cmnf wne pnfxr pnfnemnf neeq1 xaddpnf1 syl2anc 3eqtr4d jaoi syl6 imp
        id cv simpll wi eqeq2 biimprd cicc eqtr3d oveq2d 3eqtr2d adantlr esumpr
        pm2.61dane ) ABCUAZDFUBZEGQUCZRBCABCRZUDZWIEEEQUCZWJWLWIBUEZDFUBZEWLWKW
        HWNRWIWORAWKUFZWKWNBBUAWHBUGBCBUJUHWHWNDFUIUKAWOERWKADEFBHJLNULSUMAWKWM
        ERZAWKEUNRZETRZVCWQPWRWQWSWRWMEUNQUCZEEUNEQUOWREUPUQZWTERWRXAUNUPUQUREU
        NUPUSUTEVAVBUMWSETQUCZTWMEWSXAEVDVEZXBTRWSXATUPUQVFETUPUSUTWSXCTVDVEVGE
        TVDVHUTEVIVJETEQUOWSVOVKVLVMVNWLEGEQWLCUEDFUBZEGWLDEFCIWLFVPZCRZUDAXEBR
        ZDERZAWKXFVQWLXFXGWLWKXFXGVRWPWKXGXFBCXEVSVTVBVNJVJACIUQZWKMSAEUNTWAUCZ
        UQZWKNSULAXDGRWKADGFCIKMOULSWBWCWDABCVEZUDBCDEFGHIAXGXHXLJWEAXFDGRXLKWE
        ABHUQXLLSAXIXLMSAXKXLNSAGXJUQXLOSAXLUFWFWG $.
    $}
  $}


  ${
    $d i k n x $.  $d i n x F $.  $d i k N $.
    esumfzf.1 $e |- F/_ k F $.
    $( Formulating a partial extended sum over integers using the recursive
       sequence builder.  (Contributed by Thierry Arnoux, 18-Oct-2017.) $)
    esumfzf $p |- ( ( F : NN --> ( 0 [,] +oo ) /\ N e. NN )
      -> sum* k e. ( 1 ... N ) ( F ` k ) = ( seq 1 ( +e , F ) ` N ) ) $=
      ( vx cn wcel co c1 cfz cfv cesum cxad wceq wi nfv esumeq1d nfcv wa simpr
      vi vn cc0 cpnf cicc wf cseq caddc oveq2 fveq2 eqeq12d imbi2d nffv cbvesum
      cv csn cz fveq2d 1z a1i 1nn ffvelrn mpan2 esumsn syl5eq fzsn esumeq1 seq1
      ax-mp 3eqtr4g cuz simpl nnuz syl6eleq syl adantr oveq1d cun nfci nff nfan
      seqp1 fzsuc cvv ovex snex cin c0 fzp1disj simplr wss fzssnn ffvelrnd elsn
      sseldi sylib simpll peano2nnd eqeltrd esumsplit oveq2d 3eqtr2rd exp31 a2d
      3eqtrrd nnind impcom ) CFGFUCUDUEHZBUFZICJHZAUOZBKZALZCMBIUGZKZNZXIIUAUOZ
      JHZXLALZXQXNKZNZOXIIIJHZXLALZIXNKZNZOXIIUBUOZJHZXLALZYFXNKZNZOXIIYFIUHHZJ
      HZXLALZYKXNKZNZOXIXPOUAUBCXQINZYAYEXIYPXSYCXTYDYPXRYBXLAYPAPXQIIJUIQXQIXN
      UJUKULXQYFNZYAYJXIYQXSYHXTYIYQXRYGXLAYQAPXQYFIJUIQXQYFXNUJUKULXQYKNZYAYOX
      IYRXSYMXTYNYRXRYLXLAYRAPXQYKIJUIQXQYKXNUJUKULXQCNZYAXPXIYSXSXMXTXOYSXRXJX
      LAYSAPXQCIJUIQXQCXNUJUKULXIIUPZXLALZIBKZYCYDXIUUAYTEUOZBKZELUUBYTXLUUDAEX
      KUUCBUJZEYTRAYTREXLRZAUUCBDAUUCRUMZUNXIUUDUUBEIUQXIUUCINZSUUCIBXIUUHTURIU
      QGZXIUSUTXIIFGZUUBXHGVAFXHIBVBVCVDVEYBYTNZYCUUANUUIUUKUSIVFVIYBYTXLAVGVIU
      UIYDUUBNUSMBIVHVIVJYFFGZXIYJYOUULXIYJYOUULXISZYJSZYNYIYKBKZMHZYHUUOMHZYMU
      UMYNUUPNZYJUUMYFIVKKZGZUURUUMYFFUUSUULXIVLZVMVNZMBIYFWBVOVPUUNYHYIUUOMUUM
      YJTVQUUMUUQYMNYJUUMYMYGYKUPZVRZXLALYHUVCXLALZMHUUQUUMYLUVDXLAUULXIAUULAPZ
      AFXHBDAUBFUVFVSAXHRVTWAZUUMUUTYLUVDNUVBIYFWCVOQUUMYGUVCXLAUVGAYGRAUVCRZYG
      WDGUUMIYFJWEUTUVCWDGUUMYKWFUTYGUVCWGWHNUUMIYFWIUTUUMXKYGGZSZFXHXKBUULXIUV
      IWJUVJYGFXKUUJYGFWKVAIYFWLVIUUMUVITWOWMUUMXKUVCGZSZFXHXKBUULXIUVKWJUVLXKY
      KFUVLUVKXKYKNUUMUVKTAYKWNWPUVLYFUULXIUVKWQWRWSWMWTUUMUVEUUOYHMUUMUVEUVCUU
      DELUUOUVCXLUUDAEUUEEUVCRUVHUUFUUGUNUUMUUDUUOEYKFUUMUUCYKNZSUUCYKBUUMUVMTU
      RUUMYFUVAWRZUUMFXHYKBUULXITUVNWMVDVEXAXEVPXBXCXDXFXG $.
  $}

  ${
    $d a k n x $.  $d a n x F $.  $d k n x y $.  $d y F $.
    esumfsup.1 $e |- F/_ k F $.
    $( Formulating an extended sum over integers using the recursive sequence
       builder.  (Contributed by Thierry Arnoux, 18-Oct-2017.) $)
    esumfsup $p |- ( F : NN --> ( 0 [,] +oo )
      -> sum* k e. NN ( F ` k ) = sup ( ran seq 1 ( +e , F ) , RR* , < ) ) $=
      ( vx vn va cn c1 cxr clt wcel wbr wral wrex wceq wa cvv nfcv nfan simpr
      vy cc0 cpnf cicc co wf cxad cseq crn csup cv cfv cesum wss cle wi wfn cuz
      cr cz 1z seqfn ax-mp nnuz fneq2i mpbir iccssxr cfz esumfzf nff nfv simpll
      ovex 1nn fzssnn sseldd ffvelrnd ex ralrimi esumcl sylancr eqeltrrd sseldi
      mp1i ralrimiva fnfvrnss nnex ffvelrn fvelrnb eqcom eqeq1d rexbidva bitr4d
      wb syl5bbr biimpa a1i adantlr esummono adantr jca r19.29r breq1 rexlimivw
      biimpar 3syl cpw cfn cin nfesum1 simplll sylancom simplr esumlub ssnnssfz
      nfbr rexrd r19.42v simp-4l reximi sylbir sylan2 rexbii sylibr syl2anc vex
      simp-4r nfel1 simp-5l simpllr inss1 sseli elpwi xrltletr syl3anc reximdva
      rexlimdva mpd breq2d rexxfr2d ad2antrr mpbird supxr2 syl22anc eqcomd ) GU
      BUCUDUEZBUFZUGBHUHZUIZIJUJZGAUKZBULZAUMZUUGUUIIUNZUUMIKDUKZUUMUOLZDUUIMUU
      OUUMJLZUUOUAUKZJLZUAUUINZUPZDUSMUUJUUMOUUGUUHGUQZEUKZUUHULZIKZEGMUUNUVBUU
      HHURULZUQZHUTKUVGVAUGBHVBVCGUVFUUHVDVEVFZUUGUVEEGUUGUVCGKZPZUUFIUVDUBUCVG
      ZUVJHUVCVHUEZUULAUMZUVDUUFABUVCCVIZUVJUVLQKZUULUUFKZAUVLMZUVMUUFKZHUVCVHV
      MZUVJUVPAUVLUUGUVIAAGUUFBCAGRZAUUFRVJZUVIAVKZSZUVJUUKUVLKZUVPUVJUWDPZGUUF
      UUKBUUGUVIUWDVLUWEUVLGUUKHGKZUVLGUNZUWEVNHUVCVOZWDUVJUWDTVPVQVRVSUVLUULAQ
      AUVLRVTZWAZWBWCWEEGIUUHWFWAUUGUUFIUUMUVKUUGGQKZUVPAGMUUMUUFKWGUUGUVPAGUWA
      UUGUUKGKZUVPGUUFUUKBWHZVRVSGUULAQUVTVTWAWCUUGUUPDUUIUUGUUOUUIKZPZUUOUVMOZ
      EGNZUVMUUMUOLZEGMZPUWPUWRPZEGNUUPUWOUWQUWSUUGUWNUWQUUGUWNUVDUUOOZEGNZUWQU
      VBUWNUXBWNUUGUVHEGUUOUUHWIWDUUGUWPUXAEGUWPUVMUUOOUVJUXAUVMUUOWJUVJUVMUVDU
      UOUVNWKWOWLWMWPUUGUWSUWNUUGUWREGUVJUVLUULGAQUWCUWKUVJWGWQUUGUWLUVPUVIUWMW
      RUWFUWGUVJVNUWHWDWSWEWTXAUWPUWREGXBUWTUUPEGUWPUUPUWRUUOUVMUUMUOXCXEXDXFWE
      UUGUVADUSUUGUUOUSKZPZUUQUUTUXDUUQPZUUTUUOUVMJLZEGNZUXEUUOFUKZUULAUMZJLZUX
      IUVMUOLZPZEGNZFGXGZXHXIZNZUXGUXEUXJFUXONZUXKEGNZFUXOMZUXPUXEGUULAQUUOFUXD
      UUQAUUGUXCAUWAUXCAVKSAUUOUUMJAUUORAJRGUULAUVTXJXPSZUWKUXEWGWQUXEUWLUUGUVP
      UUGUXCUUQUWLXKUWMXLUXEUUOUUGUXCUUQXMXQUXDUUQTXNUXEUXRFUXOUXHUXOKZUXEUXHUV
      LUNZEGNZUXRUXHEXOUXEUYCPUXEUYBPZEGNUXRUXEUYBEGXRUYDUXKEGUYDUXHUULUVLAQUXE
      UYBAUXTUYBAVKSUVOUYDUVSWQUYDUWDPZGUUFUUKBUUGUXCUUQUYBUWDXSUYEUVLGUUKUWFUW
      GVNUWHVCZUYDUWDTWCVQUXEUYBTWSXTYAYBWEUXQUXSPUXJUXRPZFUXONUXPUXJUXRFUXOXBU
      XMUYGFUXOUXJUXKEGXRYCYDYEUXEUXMUXGFUXOUXEUYAPZUXLUXFEGUYHUVIPZUUOIKUXIIKU
      VMIKUXLUXFUPUYIUUOUUGUXCUUQUYAUVIYGXQUYIUUFIUXIUVKUYIUXHQKUVPAUXHMUXIUUFK
      FYFUYIUVPAUXHUYHUVIAUXEUYAAUXTAUXHUXOAUXHRZYHSUWBSZUYIUUKUXHKZUVPUYIUYLPZ
      GUUFUUKBUUGUXCUUQUYAUVIUYLYIUYMUXHGUUKUYMUYAUXHUXNKUXHGUNUXEUYAUVIUYLYJUX
      OUXNUXHUXNXHYKYLUXHGYMXFUYIUYLTVPVQVRVSUXHUULAQUYJVTWAWCUYIUUFIUVMUVKUYIU
      VOUVQUVRUVSUYIUVPAUVLUYKUYIUWDUVPUYIUWDPZGUUFUUKBUUGUXCUUQUYAUVIUWDYIUYNU
      VLGUUKUYFUYIUWDTWCVQVRVSUWIWAWCUUOUXIUVMYNYOYPYQYRUUGUUTUXGWNUXCUUQUUGUUS
      UXFUAEUVMUUIGUUFUWJUUGUURUUIKZUVDUUROZEGNZUURUVMOZEGNUVBUYOUYQWNUUGUVHEGU
      URUUHWIWDUUGUYRUYPEGUYRUVMUUROUVJUYPUVMUURWJUVJUVMUVDUURUVNWKWOWLWMUUGUYR
      PUURUVMUUOJUUGUYRTYSYTUUAUUBVRWEDUAUUIUUMUUCUUDUUE $.

    $( Formulating an extended sum over integers using the recursive sequence
       builder.  This version is limited to real valued functions.
       (Contributed by Thierry Arnoux, 19-Oct-2017.) $)
    esumfsupre $p |- ( F : NN --> ( 0 [,) +oo )
      -> sum* k e. NN ( F ` k ) = sup ( ran seq 1 ( + , F ) , RR* , < ) ) $=
      ( vx vy cn cc0 cpnf co cv cfv cxad c1 cxr clt caddc wcel wa cr cmnf cesum
      cico wf cseq crn csup cicc wceq wss icossicc fss mpan2 esumfsup syl cz 1z
      a1i cuz elnnuz ffvelrn sylan2br ge0addcl adantl wbr cle mnfxr pnfxr mnflt
      0re ax-mp pnfge icossioo mp4an ioomax sseqtri simprl sseldi simprr rexadd
      cioo eqcomd syl2anc seqfeq3 rneqd supeq1d eqtr4d ) FGHUBIZBUCZFAJBKAUAZLB
      MUDZUEZNOUFZPBMUDZUEZNOUFWHFGHUGIZBUCZWIWLUHWHWGWOUIWPGHUJFWGWOBUKULABCUM
      UNWHNWNWKOWHWMWJWHDEPLWGBMMUOQWHUPUQDJZMURKQWHWQFQWQBKWGQWQUSFWGWQBUTVAWQ
      WGQZEJZWGQZRZWQWSPIZWGQWHWQWSVBVCWHXARZWQSQZWSSQZXBWQWSLIZUHXCWGSWQWGTHVT
      IZSTNQHNQZTGOVDZHHVEVDZWGXGUIVFVGGSQXIVIGVHVJXHXJVGHVKVJTHGHVLVMVNVOZWHWR
      WTVPVQXCWGSWSXKWHWRWTVRVQXDXERXFXBWQWSVSWAWBWCWDWEWF $.
  $}

  ${
    esumss.p $e |- F/ k ph $.
    esumss.a $e |- F/_ k A $.
    esumss.b $e |- F/_ k B $.
    esumss.1 $e |- ( ph -> A C_ B ) $.
    esumss.2 $e |- ( ph -> B e. V ) $.
    esumss.3 $e |- ( ( ph /\ k e. B ) -> C e. ( 0 [,] +oo ) ) $.
    esumss.4 $e |- ( ( ph /\ k e. ( B \ A ) ) -> C = 0 ) $.
    $( Change the index set to a subset by adding zeroes.  (Contributed by
       Thierry Arnoux, 19-Jun-2017.) $)
    esumss $p |- ( ph -> sum* k e. A C = sum* k e. B C ) $=
      ( cc0 co cmpt ctsu cuni cesum wcel cxrs cpnf cicc cress cres wceq resmptf
      wss syl oveq2d xrge0base xrge00 ccmn xrge0cmn a1i ctps xrge0tps nfcv eqid
      fmptdF suppss2f tsmsres eqtr3d unieqd df-esum 3eqtr4g ) AUANUBUCOZUDOZEBD
      PZQOZRVHECDPZQOZRBDESCDESAVJVLAVHVKBUEZQOVJVLAVMVIVHQABCUHVMVIUFJECBDIHUG
      UIUJACVGVKVHFBNUKULVHUMTAUNUOVHUPTAUQUOKAECDVGVKGIEVGURLVKUSUTACDEBNGIHMV
      AVBVCVDBDEVECDEVEVF $.
  $}

  ${
    $d k A $.  $d k V $.
    esumpinfval.0 $e |- F/ k ph $.
    esumpinfval.1 $e |- ( ph -> A e. V ) $.
    esumpinfval.2 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumpinfval.3 $e |- ( ph -> E. k e. A B = +oo ) $.
    $( The value of the extended sum of non-negative terms, with at least one
       infinite term.  (Contributed by Thierry Arnoux, 19-Jun-2017.) $)
    esumpinfval $p |- ( ph -> sum* k e. A B = +oo ) $=
      ( cesum cxr wcel cpnf cle wbr wceq cc0 wa 0xr pnfxr cicc co iccssxr cv ex
      wral ralrimi nfcv esumcl syl2anc sseldi cif nfrab1 wss ssrab2 pnfge ax-mp
      crab a1i ubicc2 mp3an wn lbicc2 ifclda eldif rabid simplbi2 con3and sylbi
      cdif adantl iffalse syl esumss chash cfv cxmu simprbi iftrue esumeq12dvaf
      eqidd cvv ssexd esumcst sylancl clt hashxrcl c0 wrex rabn0 sylibr hashgt0
      xmulpnf1 3eqtrd eqtr3d breq1 breq2 mpbiri adantr iccgelb mp3an12 ifbothda
      wne esumlef eqbrtrrd xgepnf biimpd sylc ) ABCDJZKLZMXINOZXIMPZAQMUAUBZKXI
      QMUCABELCXMLZDBUFXIXMLGAXNDBFADUDZBLZXNHUEUGBCDEDBUHZUIUJUKABCMPZMQULZDJZ
      MXINAXRDBURZXSDJZXTMAYABXSDEFXRDBUMZXQYABUNAXRDBUOUSZGAXPRZXRMQXMMXMLZYEX
      RRQKLZMKLZQMNOZYFSTYGYISQUPUQZQMUTVAZUSQXMLZYEXRVBZRZYGYHYIYLSTYJQMVCVAUS
      VDZAXOBYAVJLZRYMXSQPYPYMAYPXPXOYALZVBRYMXOBYAVEXPXRYQYQXPXRXRDBVFZVGVHVIV
      KXRMQVLVMVNAYBYAMDJZYAVOVPZMVQUBZMAYAYAXSMDFAYAWAYQXSMPZAYQXRUUBYQXPXRYRV
      RXRMQVSVMVKVTAYAWBLZYFYSUUAPAYABEGYDWCZYKYAMDWBYCDMUHWDWEAYTKLZQYTWFOZUUA
      MPAUUCUUEUUDYAWBWGVMAUUCYAWHXCZUUFUUDAXRDBWIUUGIXRDBWJWKYAWBWLUJYTWMUJWNW
      OABXSCDEFXQGYOHXRMCNOZQCNOZXSCNOYEMQMXSCNWPQXSCNWPXRUUHYEXRUUHMMNOZYHUUJT
      MUPUQCMMNWQWRVKYNXNUUIYEXNYMHWSYGYHXNUUISTQMCWTXAVMXBXDXEXJXKXLXIXFXGXH
      $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y V $.
    $( Lemma for ~ esumpfinval (Contributed by Thierry Arnoux, 28-Jun-2017.) $)
    esumpfinvallem $p |- ( ( A e. V /\ F : A --> ( 0 [,) +oo ) ) ->
      ( CCfld gsum F ) = ( ( RR*s |`s ( 0 [,] +oo ) ) gsum F ) ) $=
      ( wcel cc0 cpnf co wa ccnfld cress cxrs cvv ovex a1i wceq cxr ax-mp caddc
      cr cxad vy vx cico cgsu cicc fex ancoms cbs cfv wss cmnf cioo clt wbr cle
      wf cc mnfxr pnfxr 0re mnflt pnfge icossioo mp4an ioomax sseqtri ax-resscn
      sstri eqid cnfldbas ressbas2 xrsbas eqtr3i cplusg simprl syl6eleqr simprr
      icossxr cv ge0addcl cnfldadd ressplusg oveqi 3eltr3g syl2anc simpl sseldi
      simpr rexadd eqcomd xrsadd 3eqtr3g wfun ffun syl crn frn syl6sseq cnfldex
      gsumpropd2 0xr ltpnf lbico1 mp3an addid2d addid1d jca gsumress xrge0plusg
      xrge0base ressress mp2an incom icossicc dfss eqtr4i oveq2i eqtr2i iccssxr
      cin mpbi xaddid2 xaddid1 3eqtr4d ) ACDZAEFUCGZBUPZHZIYFJGZBUDGKYFJGZBUDGI
      BUDGKEFUEGZJGZBUDGYHUABYIYJLLLUBYGYEBLDAYFCBUFUGYILDYHIYFJMNYJLDYHKYFJMNY
      IUHUIZYJUHUIZOYHYFYMYNYFUQUJZYFYMOYFSUQYFUKFULGZSUKPDFPDZUKEUMUNZFFUOUNZY
      FYPUJURUSESDZYRUTEVAQYQYSUSFVBQUKFEFVCVDVEVFZVGVHZYFUQYIIYIVIZVJVKQZYFPUJ
      YFYNOEFVRYFPYJKYJVIZVLVKQVMNYHUBVSZYMDZUAVSZYMDZHHZUUFYFDZUUHYFDZUUFUUHYI
      VNUIZGZYMDUUJUUFYMYFYHUUGUUIVOUUDVPZUUJUUHYMYFYHUUGUUIVQUUDVPZUUKUULHZUUF
      UUHRGZYFUUNYMUUFUUHVTRUUMUUFUUHYFLDZRUUMOEFUCMZYFRIYILUUCWAWBQWCZUUDWDWEU
      UJUUKUULUUNUUFUUHYJVNUIZGZOUUOUUPUUQUURUUFUUHTGZUUNUVCUUQUUFSDZUUHSDZUURU
      VDOUUQYFSUUFUUAUUKUULWFWGUUQYFSUUHUUAUUKUULWHWGUVEUVFHUVDUURUUFUUHWIWJWEU
      VATUVBUUFUUHUUSTUVBOUUTYFTKYJLUUEWKWBQWCWLWEYHYGBWMYEYGWHZAYFBWNWOYHBWPZY
      FYMYHYGUVHYFUJUVGAYFBWQWOUUDWRWTYHUBAUQRYFBIYILCEVJWAUUCILDYHWSNYEYGWFZYO
      YHUUBNUVGEYFDZYHEPDYQEFUMUNZUVJXAUSYTUVKUTEXBQEFXCXDNZYHUUFUQDZHZEUUFRGUU
      FOUUFERGUUFOUVNUUFYHUVMWHZXEUVNUUFUVOXFXGXHYHUBAYKTYFBYLYJLCEXJXIYLYFJGZK
      YKYFXTZJGZYJYKLDUUSUVPUVROEFUEMUUTYKYFKLLXKXLUVQYFKJUVQYFYKXTZYFYKYFXMYFY
      KUJZYFUVSOEFXNZYFYKXOYAXPXQXRYLLDYHKYKJMNUVIUVTYHUWANUVGUVLYHUUFYKDZHZEUU
      FTGUUFOZUUFETGUUFOZUWCUUFPDZUWDUWCYKPUUFEFXSYHUWBWHWGZUUFYBWOUWCUWFUWEUWG
      UUFYCWOXGXHYD $.
  $}

  ${
    $d k A $.  $d k ph $.
    esumpfinval.a $e |- ( ph -> A e. Fin ) $.
    esumpfinval.b $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,) +oo ) ) $.
    $( The value of the extended sum of a finite set of non-negative finite
       terms (Contributed by Thierry Arnoux, 28-Jun-2017.) $)
    esumpfinval $p |- ( ph -> sum* k e. A B = sum_ k e. A B ) $=
      ( cc0 cpnf cicc co cgsu csn cuni cle cfn wcel a1i cvv cr cmnf cesum cress
      cxrs cmpt ccnfld csu ctsu df-esum cordt cfv crest xrge0base ccmn xrge0cmn
      xrge00 ctps xrge0tps cv wa cico icossicc sseldi eqid fmptd fisuppfi ctopn
      cdif xrge0topn eqcomi xrhaus ovex resthaus mp2an haustsmsid unieqd syl5eq
      cha unisn syl6eq wf wceq esumpfinvallem syl2anc cc cioo cxr clt wbr mnfxr
      wss pnfxr mnflt ax-mp pnfge icossioo mp4an ioomax sseqtri ax-resscn sstri
      0re gsumfsum 3eqtr2d ) ABCDUAZUCGHIJZUBJZDBCUDZKJZUEXGKJZBCDUFAXDXHLZMZXH
      AXDXFXGUGJZMXKBCDUHAXLXJABXEXGXFNUIUJZXEUKJZOGULUOXFUMPAUNQXFUPPAUQQEADBC
      XEXGADURBPUSZGHUTJZXECGHVAFVBXGVCZVDZABXERGLVGXGEXRVEXFVFUJXNVHVIXNVQPZAX
      MVQPXERPXSVJGHIVKXEXMRVLVMQVNVOVPXHXFXGKVKVRVSABOPBXPXGVTXIXHWAEADBCXPXGF
      XQVDBXGOWBWCABCDEXOXPWDCXPSWDXPTHWEJZSTWFPHWFPZTGWGWHZHHNWHZXPXTWJWIWKGSP
      YBXAGWLWMYAYCWKHWNWMTHGHWOWPWQWRWSWTFVBXBXC $.
  $}

  ${
    $d k l $.  $d l A $.  $d l B $.  $d l ph $.
    esumpfinvalf.1 $e |- F/_ k A $.
    esumpfinvalf.2 $e |- F/ k ph $.
    esumpfinvalf.a $e |- ( ph -> A e. Fin ) $.
    esumpfinvalf.b $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,) +oo ) ) $.
    $( Same as ~ esumpfinval , minus distinct variable restrictions.
       (Contributed by Thierry Arnoux, 28-Aug-2017.) $)
    esumpfinvalf $p |- ( ph -> sum* k e. A B = sum_ k e. A B ) $=
      ( vl cc0 cpnf co cgsu ccnfld wcel nfcv cvv cc wsb cmnf cxrs cicc cmpt csu
      cesum cress csn cuni ctsu df-esum cle cordt cfv cfn xrge0base xrge00 ccmn
      crest xrge0cmn a1i ctps xrge0tps cv cico icossicc sseldi eqid fmptdF cdif
      fisuppfi ctopn xrge0topn eqcomi cha xrhaus ovex resthaus mp2an haustsmsid
      wa unieqd syl5eq unisn syl6eq wf wceq esumpfinvallem syl2anc csb cioo cxr
      wi cr clt wbr wss mnfxr pnfxr 0re mnflt ax-mp pnfge icossioo mp4an ioomax
      sseqtri ax-resscn sstri sbt sbim sban sbf clelsb3f anbi12i bitri sbsbc wb
      wsbc sbcel1g imbi12i mpbi gsumfsum nfcsb1v csbeq1a cbvmptf oveq2i 3eqtr4g
      vex cbvsum 3eqtr2d ) ABCDUEZUAJKUBLZUFLZDBCUCZMLZNYNMLZBCDUDZAYKYOUGZUHZY
      OAYKYMYNUILZUHYSBCDUJAYTYRABYLYNYMUKULUMZYLURLZUNJUOUPYMUQOAUSUTYMVAOAVBU
      TGADBCYLYNFEDYLPADVCBOZVTZJKVDLZYLCJKVEHVFYNVGZVHZABYLQJUGVIYNGUUGVJYMVKU
      MUUBVLVMUUBVNOZAUUAVNOYLQOUUHVOJKUBVPYLUUAQVQVRUTVSWAWBYOYMYNMVPWCWDABUNO
      BUUEYNWEYPYOWFGADBCUUEYNFEDUUEPHUUFVHBYNUNWGWHANIBDIVCZCWIZUCZMLBUUJIUDYP
      YQABUUJIGUUDCROZWLZDISZAUUIBOZVTZUUJROZWLZUUMDIUUDUUERCUUEWMRUUETKWJLZWMT
      WKOKWKOZTJWNWOZKKUKWOZUUEUUSWPWQWRJWMOUVAWSJWTXAUUTUVBWRKXBXATKJKXCXDXEXF
      XGXHHVFXIUUNUUDDISZUULDISZWLUURUUDUULDIXJUVCUUPUVDUUQUVCADISZUUCDISZVTUUP
      AUUCDIXKUVEAUVFUUOADIFXLIDBEXMXNXOUVDUULDUUIXRZUUQUULDIXPUUIQOUVGUUQXQIYH
      DUUICRQXSXAXOXTXOYAYBYNUUKNMDIBCUUJEIBPZICPZDUUICYCZDUUICYDZYEYFBCUUJDIUV
      KUVHEUVIUVJYIYGYJ $.
  $}

  ${
    $d k V $.  $d k M $.
    esumpinfsum.p $e |- F/ k ph $.
    esumpinfsum.a $e |- F/_ k A $.
    esumpinfsum.1 $e |- ( ph -> A e. V ) $.
    esumpinfsum.2 $e |- ( ph -> -. A e. Fin ) $.
    esumpinfsum.3 $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumpinfsum.4 $e |- ( ( ph /\ k e. A ) -> M <_ B ) $.
    esumpinfsum.5 $e |- ( ph -> M e. RR* ) $.
    esumpinfsum.6 $e |- ( ph -> 0 < M ) $.
    $( The value of the extended sum of infinitely many terms greater than
       one.  (Contributed by Thierry Arnoux, 29-Jun-2017.) $)
    esumpinfsum $p |- ( ph -> sum* k e. A B = +oo ) $=
      ( cxr wcel cpnf cle wbr cc0 cesum wceq cicc co iccssxr wral cv ex ralrimi
      esumcl syl2anc sseldi chash cfv cxmu clt 0xr xrltle sylancr mpd pnfge syl
      wi w3a wb pnfxr elicc1 mp2an syl3anbrc nfcv esumcst cfn wn hashinf oveq1d
      xmulpnf2 3eqtrd adantr esumlef eqbrtrrd xgepnf biimpd sylc ) ABCDUAZOPZQW
      DRSZWDQUBZATQUCUDZOWDTQUEABFPZCWHPZDBUFWDWHPIAWJDBGADUGBPZWJKUHUIBCDFHUJU
      KULABEDUAZQWDRAWLBUMUNZEUOUDZQEUOUDZQAWIEWHPZWLWNUBIAEOPZTERSZEQRSZWPMATE
      UPSZWRNATOPZWQWTWRVCUQMTEURUSUTAWQWSMEVAVBXAQOPWPWQWRWSVDVEUQVFTQEVGVHVIZ
      BEDFHDEVJVKUKAWMQEUOAWIBVLPVMWMQUBIJBFVNUKVOAWQWTWOQUBMNEVPUKVQABECDFGHIA
      WPWKXBVRKLVSVTWEWFWGWDWAWBWC $.
  $}

  ${
    $d k l n s x y z $.  $d b l m n s x y A $.  $d k m n s x y z B $.
    $d b k m n x y ph $.
    esumpcvgval.1 $e |- ( ( ph /\ k e. NN ) -> A e. ( 0 [,) +oo ) ) $.
    esumpcvgval.2 $e |- ( k = l -> A = B ) $.
    esumpcvgval.3 $e |- ( ph ->
                      ( n e. NN |-> sum_ k e. ( 1 ... n ) A ) e. dom ~~> ) $.
    $( The value of the extended sum when the corresponding series sum is
       convergent.  (Contributed by Thierry Arnoux, 31-Jul-2017.) $)
    esumpcvgval $p |- ( ph -> sum* k e. NN A = sum_ k e. NN A ) $=
      ( cn c1 cr wcel wa cc0 cpnf wceq cle wbr syl vb vx vy vs vm vz cpw cfn cv
      cin csu cmpt crn cxr clt csup caddc cseq cesum wor xrltso a1i nnuz cz cfv
      1z co weq eqcom 3imtr3i cbvmptv fmptd ffvelrnda elrege0 simplbi serfre wf
      cico adantr simpr peano2nnd ffvelrnd simprbi addge01d mpbid syl6eleq wral
      cuz wrex syl2anc cmnf wss pnfxr ax-mp sseldi cfz cdm simpll elfznn adantl
      recnd fsumser fzfid adantlr ralrimiva breq2 rspcev wn elrnmpti sylan2 imp
      eqid ex breq1 rexlimdva sylan2b simplr fsumrecl ad2antrr simprr wne mpbir
      c0 wfn eqeq2d simpr1r 3anassrs wb w3a 0xr elin mpbir2an sumeq1 xrlelttric
      mp2an wo mpan mpjaodan cvv cgsu seqp1 breqtrrd cioo mnfxr 0re mnflt pnfge
      fvmpt2 icossioo mp4an ioomax sseqtri feqmptd cc eqcomd mpteq2dva eqeltrrd
      eqtr2d isumrecl sseqtr4i isumless eqbrtrrd ralbidv climsup climrecl rexrd
      cli fzssuz sumex ssnnssfz fsumless reximdv rexbidv syl5ibrcom inss2 inss1
      elpwid sseldd eqeltrd frn 1nn ne0i dm0rn0 eqeq1d syl5bbr necon3bid mpbiri
      fdm seqfn fneq2i dffn5 mpbi r19.29 biimparc rexlimivw reximi fveq2 sylibr
      fvex ad2ant2r suprub syl31anc letrd rexlimddv lenltd pnfnlt notbid mpbird
      ad3antrrr pm2.21dd simplll simpr1l elico1 syl3anbrc simprl suprlub biimpa
      3jca syl21anc wi ssriv ovex elpw fzfi eqtr4d ssrdv ssrexv syldan syl12anc
      3imtr4g simplrl xgepnf orbi1d 0elpw 0fin sum0 eqcomi ad2antrl eqsupd nfcv
      nnex cicc icossicc ccnfld cxrs cress elex esumpfinvallem gsumfsum esumval
      nfv eqtr3d isumclim 3eqtr4d ) AUAJUGZUHUJZUAUIZBDUKZULZUMZUNUOUPUQFJCULZK
      URZUMZLUOUPZJBDUSJBDUKZAUBUCUNVUTVVDUOUNUOUTAVAVBAVVDAVVDEVVBKJVCKVDMZAVF
      VBZAUDEVVBKJVCVVGAUBVVAKJVCVVGAUBUIZJMNVVHVVAVEZOPVRVGZMZVVILMZAJVVJVVHVV
      AADJBVVJVVAGFDJCBDFVHBCQFDVHCBQHDUIZFUIVIBCVIVJVKZVLZVMVVKVVLOVVIRSVVIVNV
      OTVPZAEUIZJMZNZVVQVVBVEZVVTVVQKUQVGZVVAVEZUQVGZVWAVVBVEZRVVSOVWBRSZVVTVWC
      RSVVSVWBVVJMZVWEVVSJVVJVWAVVAAJVVJVVAVQVVRVVOVSVVSVVQAVVRVTZWAWBZVWFVWBLM
      ZVWEVWBVNZWCTVVSVVTVWBAJLVVQVVBVVPVMZVVSVWFVWIVWHVWFVWIVWEVWJVOTWDWEVVSVV
      QKWHVEZMVWDVWCQVVSVVQJVWLVWGVCWFZUQVVAKVVQUUATUUBAVVELMVVTVVERSZEJWGZVVTU
      DUIZRSZEJWGZUDLWIZABDVVAKJVCVVGAVVMJMZNZVWTBVVJMZVVMVVAVEBQZAVWTVTGDJBVVJ
      VVAVVNUUHWJZVXAVVJLBVVJWKPUUCVGZLWKUNMPUNMZWKOUOSZPPRSZVVJVXEWLUUDWMOLMVX
      GUUEOUUFWNVXFVXHWMPUUGWNWKPOPUUIUUJUUKUULZGWOZAEJKVVQWPVGZBDUKZULZVVBUVGW
      QZAVVBEJVVTULZVXMAEJLVVBVVPUUMAEJVVTVXLVVSVXLVVTVVSBDVVAKVVQVVSVVMVXKMZNZ
      AVWTVXCAVVRVXPWRZVXPVWTVVSVVMVVQWSZWTZVXDWJVWMVXQAVWTBUUNMVXRVXTVXABVXJXA
      ZWJXBZUUOUUPUURIUUQZUUSAVWNEJVVSVXLVVTVVERVYBVVSVXKBDVVAKJVCVVFVVSVFVBVVS
      KVVQXCVXKJWLZVVSVXKVWLJKVVQUVHVCUUTVBAVWTVXCVVRVXDXDAVWTBLMZVVRVXJXDVVSVW
      TNVXBOBRSZAVWTVXBVVRGXDVXBVYEVYFBVNZWCZTAVVBVXNMVVRVYCVSUVAUVBXEVWRVWOUDV
      VELVWPVVEQVWQVWNEJVWPVVEVVTRXFUVCXGWJZUVDZVWKUVEZUVFZAVVHVUTMZNZVVHVVDRSZ
      VVDVVHUOSXHVYNVVHKUEUIZWPVGZBDUKZRSZVYOUEJVYMAVVHVURQZUAVUPWIZVYSUEJWIZUA
      VUPVURVVHVUSVUSXLZVUQBDUVIZXIZAWUAWUBAVYTWUBUAVUPAVUQVUPMZNZWUBVYTVURVYRR
      SZUEJWIZWUFAVUQVYQWLZUEJWIZWUIVUQUEUVJAWUKWUIAWUJWUHUEJAWUJWUHAWUJNZVYQBV
      UQDWULKVYPXCAVVMVYQMZVYEWUJAWUMNZVXBVYEWUMAVWTVXBVVMVYPWSZGXJZVXBVYEVYFVY
      GVOZTZXDAWUMVYFWUJWUNVXBVYFWUPVYHTXDAWUJVTUVKXMUVLXKXJVYTVYSWUHUEJVVHVURV
      YRRXNUVMUVNXOXKXPVYNVYPJMZVYSNZNZVVHVYRVVDVYNVVHLMZWUTVYMAWUAWVBWUEAWUAWV
      BAVYTWVBUAVUPWUGVYTWVBWUGVYTNVVHVURLWUGVYTVTWUGVURLMVYTWUGVUQBDWUGVUPUHVU
      QVUOUHUVOAWUFVTWOZWUGVVMVUQMZNZVXBVYEWVEAVWTVXBAWUFWVDWRWVEVUQJVVMWVEVUQJ
      WVEVUPVUOVUQVUOUHUVPAWUFWVDXQWOUVQWUGWVDVTUVRGWJZWUQTZXRVSUVSXMXOXKXPZVSA
      VYRLMVYMWUTAVYQBDAKVYPXCWURXRXSAVVDLMZVYMWUTVYKXSVYNWUSVYSXTWVAVVCLWLZVVC
      YCYAZUFUIZVWPRSZUFVVCWGZUDLWIZVYRVVCMZVYRVVDRSAWVJVYMWUTAJLVVBVQZWVJVVPJL
      VVBUVTTZXSAWVKVYMWUTAWVKJYCYAZKJMWVSUWAJKUWBWNAVVCYCJYCVVCYCQVVBWQZYCQAJY
      CQVVBUWCAWVTJYCAWVQWVTJQVVPJLVVBUWHTUWDUWEUWFUWGZXSAWVOVYMWUTAVWSWVOVYIVW
      RWVNUDLVWRWVMUFVVCWVLVVCMVWRWVLVVTQZEJWIZWVMEJVVTWVLVVBVVBJYDZVVBVXOQWWDV
      VBVWLYDZVVFWWEVFUQVVAKUWIWNJVWLVVBVCUWJYBEJVVBUWKUWLZVVQVVBUWSZXIVWRWWCNV
      WQWWBNZEJWIWVMVWQWWBEJUWMWWHWVMEJWWBWVMVWQWVLVVTVWPRXNUWNUWOTXPXEUWPTZXSA
      WUSWVPVYMVYSAWUSNZVYRVVTQZEJWIZWVPWWJWUSVYRVYPVVBVEZQZWWLAWUSVTZWWJBDVVAK
      VYPWWJWUMNZAVWTVXCAWUSWUMWRZWUMVWTWWJWUOWTZVXDWJWWJVYPJVWLWWOVCWFWWPBWWPV
      XBVYEWWPAVWTVXBWWQWWRGWJWUQTXAXBWWKWWNEVYPJEUEVHVVTWWMVYRVVQVYPVVBUWQYEXG
      WJEJVVTVYRVVBWWFWWGXIUWRUWTUDUFVVCVYRUXAUXBUXCUXDVYNVVHVVDWVHAWVIVYMVYKVS
      UXEWEAVVHUNMZVVHVVDUOSZNZNZOVVHRSZVVHUCUIZUOSZUCVUTWIZVVHOUOSZWXBWXCNZVVH
      PQZWXFVVHPUOSZWXHWXINZWWTWXFAWXAWXCWXIWWTWWSWWTWXCWXIAYFYGWXKWWTXHZPVVDUO
      SZXHZWXKVVDUNMZWXNAWXOWXAWXCWXIVYLUXIVVDUXFTWXIWXLWXNYHWXHWXIWWTWXMVVHPVV
      DUOXNUXGWTUXHUXJWXHWXJNZAVVHVVJMZWWTWXFAWXAWXCWXJUXKWXPWWSWXCWXJWXQAWXAWX
      CWXJWWSWWSWWTWXCWXJAUXLYGWXBWXCWXJXQWXHWXJVTOUNMZVXFWXQWWSWXCWXJYIYHYJWMO
      PVVHUXMYOUXNAWXAWXCWXJWWTWWSWWTWXCWXJAYFYGAWXQWWTNZWXEUCVVCWIZWXFAWXSNZWV
      JWVKWVOYIZWVBWWTWXTWYAWVJWVKWVOAWVJWXSWVRVSAWVKWXSWWAVSAWVOWXSWWIVSUXRWYA
      VVJLVVHVXIAWXQWWTUXOWOAWXQWWTXTWYBWVBNWWTWXTUDUFUCVVCVVHUXPUXQUXSAWXTWXFA
      VVCVUTWLWXTWXFUXTAUCVVCVUTAWXDVVTQZEJWIWXDVURQZUAVUPWIZWXDVVCMWXDVUTMAWYC
      WYEEJVVSWYCWYEVVSWYCNZVXKVUPMZWXDVXLQZWYEWYGWYFWYGVXKVUOMZVXKUHMWYIVYDDVX
      KJVXSUYAVXKJKVVQWPUYBUYCYBKVVQUYDVXKVUOUHYKYLVBWYFWXDVVTVXLVVSWYCVTVVSVXL
      VVTQWYCVYBVSUYEWYDWYHUAVXKVUPVUQVXKQVURVXLWXDVUQVXKBDYMYEXGWJXMXOEJVVTWXD
      VVBWWFWWGXIUAVUPVURWXDVUSWUCWUDXIUYJUYFWXEUCVVCVUTUYGTXKUYHUYIWXHWWSWXIWX
      JYPZAWWSWWTWXCUYKWWSPVVHRSZWXJYPZWYJVXFWWSWYLWMPVVHYNYQWWSWYKWXIWXJVVHUYL
      UYMWETYRWXGWXFWXBOVUTMZWXGWXFWYMOVURQZUAVUPWIZYCVUPMZOYCBDUKZQZWYOWYPYCVU
      OMYCUHMJUYNUYOYCVUOUHYKYLWYQOBDUYPUYQWYNWYRUAYCVUPVUQYCQVURWYQOVUQYCBDYMY
      EXGYOUAVUPVUROVUSWUCWUDXIYBWXEWXGUCOVUTWXDOVVHUOXFXGYQWTWWSWXCWXGYPZAWWTW
      XRWWSWYSYJOVVHYNYQUYRYRUYSAUAJBVURDYSADVUKDJUYTJYSMAVUAVBVXAVVJOPVUBVGZBO
      PVUCGWOWUGVUDDVUQBULZYTVGZVUEWYTVUFVGXUAYTVGZVURWUGVUQYSMZVUQVVJXUAVQXUBX
      UCQWUFXUDAVUQVUPVUGWTWUGDVUQBVVJXUAWVFXUAXLVLVUQXUAYSVUHWJWUGVUQBDWVCWVEB
      WVGXAVUIVULVUJABVVDDVVAKJVCVVGVXDVYAVYJVUMVUN $.
  $}

  ${
    $d k M $.  $d k N $.  $d k ph $.
    esumpmono.1 $e |- ( ph -> M e. NN ) $.
    esumpmono.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    esumpmono.3 $e |- ( ( ph /\ k e. NN ) -> A e. ( 0 [,) +oo ) ) $.
    $( The partial sums in an extended sum form a monotonic sequence.
       (Contributed by Thierry Arnoux, 31-Aug-2017.) $)
    esumpmono $p |- ( ph ->
                        sum* k e. ( 1 ... M ) A <_ sum* k e. ( 1 ... N ) A ) $=
      ( c1 cfz co cesum cc0 cle wbr cxr wcel cpnf cvv cn cxad cicc iccssxr wral
      caddc ovex cv elfznn wa cico icossicc sseldi sylan2 ralrimiva nfcv esumcl
      a1i syl2anc xrleid syl cuz adantr peano2nn nnuz syl6eleq fzss1 3syl simpr
      cfv wss sseldd syldan elxrge0 simprbi wi 0xr xle2add syl22anc mp2and wceq
      xaddid1 eqcomd cun eluzfz fzsplit esumeq1 nfv clt c0 nnre ltp1d esumsplit
      cin fzdisj eqtrd 3brtr4d ) AIDJKZBCLZMUAKZWRDIUEKZEJKZBCLZUAKZWRIEJKZBCLZ
      NAWRWRNOZMXBNOZWSXCNOZAWRPQZXFAMRUBKZPWRMRUCZAWQSQZBXJQZCWQUDWRXJQXLAIDJU
      FUQZAXMCWQCUGZWQQAXOTQZXMXODUHAXPUIMRUJKXJBMRUKHULZUMZUNWQBCSCWQUOZUPURUL
      ZWRUSUTAXBXJQZXGAXASQZXMCXAUDYAYBAWTEJUFUQZAXMCXAAXOXAQZXPXMAYDUIZXOXDQXP
      YEXAXDXOYEDTQZWTIVAVIZQXAXDVJAYFYDFVBYFWTTYGDVCVDVEWTIEVFVGAYDVHVKXOEUHUT
      XQVLZUNXABCSCXAUOZUPURZYAXBPQZXGXBVMVNUTAXIMPQZXIYKXFXGUIXHVOXTYLAVPUQXTA
      XJPXBXKYJULWRMWRXBVQVRVSAWSWRAXIWSWRVTXTWRWAUTWBAXEWQXAWCZBCLZXCADXDQZXDY
      MVTXEYNVTADYGQEDVAVIQYOADTYGFVDVEGDIEWDURDIEWEXDYMBCWFVGAWQXABCACWGXSYIXN
      YCAYFDWTWHOWQXAWMWIVTFYFDDWJWKIDWTEWNVGXRYHWLWOWP $.
  $}

  ${
    $d k A $.  $d x y k C $.  $d k V $.  $d x y k ph $.
    esumcocn.j $e |- J = ( ( ordTop ` <_ ) |`t ( 0 [,] +oo ) ) $.
    esumcocn.a $e |- ( ph -> A e. V ) $.
    esumcocn.b $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumcocn.1 $e |- ( ph -> C e. ( J Cn J ) ) $.
    esumcocn.0 $e |- ( ph -> ( C ` 0 ) = 0 ) $.
    esumcocn.f $e |- ( ( ph /\ x e. ( 0 [,] +oo ) /\ y e. ( 0 [,] +oo ) ) ->
                           ( C ` ( x +e y ) ) = ( ( C ` x ) +e ( C ` y ) ) ) $.
    $( Lemma for ~ esummulc2 and co.  Composing with a continuous function
       preserves extended sums (Contributed by Thierry Arnoux, 29-Jun-2017.) $)
    esumcocn $p |- ( ph -> ( C ` sum* k e. A B ) = sum* k e. A ( C ` B ) ) $=
      ( cfv wcel cc0 co xrge0base cesum nfv nfcv cv wa cpnf cicc ccn cxrs cress
      wf ctps cuni xrge0tps cle cordt crest ctopn xrge0topn eqtr4i tpsuni ax-mp
      wceq cnf adantr ffvelrnd cmpt ccom ctsu ccmn xrge0cmn cmnd cxad wral cmhm
      syl a1i cmnmnd 3expib ralrimivv w3a xrge0plusg xrge00 ismhm biimpri eqidd
      syl23anc fmpt3d esumel tsmsmhm cofmpt oveq2d eleqtrd esumid eqcomd ) ADEF
      PZGUADEGUAZFPZADWPWRGIAGUBZGDUCZKAGUDDQZUERUFUGSZXBEFAXBXBFUKZXAAFHHUHSQX
      CMFHHXBXBUIXBUJSZULQZXBHUMVCUNXBHXDTHUOUPPXBUQSXDURPJUSUTZVAVBZXGVDVPZVEL
      VFAWRXDFGDEVGZVHZVISXDGDWPVGZVISADXBFXIXDXDHHIWQTXFXFXDVJQZAVKVQZXEAUNVQZ
      XMXNAXDVLQZXOXCBUDZCUDZVMSFPXPFPXQFPVMSVCZCXBVNBXBVNZRFPRVCZFXDXDVOSQZXOA
      XLXOVKXDVRVBVQZYBXHAXRBCXBXBAXPXBQXQXBQXROVSVTNYAXOXOUEXCXSXTWAUEBCXBXBVM
      VMXDXDFRRTTWBWBWCWCWDWEWGMKAGDEXBXIAXIWFLWHADEGIWSWTKLWIWJAXJXKXDVIAGDEXB
      XBFXHLWKWLWMWNWO $.
  $}

  ${
    $d k z A $.  $d z B $.  $d k x y z C $.  $d k V $.  $d k x y z ph $.
    esummulc2.a $e |- ( ph -> A e. V ) $.
    esummulc2.b $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esummulc2.c $e |- ( ph -> C e. ( 0 [,) +oo ) ) $.
    $( An extended sum multiplied by a constant.  (Contributed by Thierry
       Arnoux, 6-Jul-2017.) $)
    esummulc1 $p |- ( ph ->
                           ( sum* k e. A B *e C ) = sum* k e. A ( B *e C ) ) $=
      ( vz cc0 cpnf co cxmu cfv wceq wcel a1i fvmptd cvv vx cesum cicc cmpt cle
      vy cv cordt crest eqid xrge0mulc1cn eqidd oveq1 cxr icossxr sseldi xmul02
      cico syl sylan9eqr wbr 0xr pnfxr pnfge ax-mp lbicc2 mp3an w3a simp2 simp3
      cxad icossicc 3ad2ant1 xrge0adddir syl3anc simpr oveq1d ge0xaddcl 3adant1
      wa ovex oveq12d 3eqtr4d esumcocn wral ralrimiva syl2anc esumeq2dv 3eqtr3d
      nfcv esumcl ) ABCEUBZJKLUCMZJUGZDNMZUDZOBCWPOZEUBWLDNMZBCDNMZEUBAUAUFBCWP
      EUEUHOWMUIMZFWTUJZGHAJDWPWTXAWPUJIUKAJKWOKWMWPWMAWPULZWNKPAWOKDNMZKWNKDNU
      MADUNQXCKPAKLURMZUNDKLUOIUPDUQUSUTKWMQZAKUNQZLUNQKLUEVAZXEVBVCXFXGVBKVDVE
      KLVFVGRZXHSAUAUGZWMQZUFUGZWMQZVHZXIXKVKMZDNMZXIDNMZXKDNMZVKMZXNWPOXIWPOZX
      KWPOZVKMXMXJXLDWMQXOXRPAXJXLVIZAXJXLVJZXMXDWMDKLVLAXJDXDQXLIVMUPXIXKDVNVO
      XMJXNWOXOWMWPTXMWPULZXMWNXNPZVTWNXNDNXMYDVPVQXJXLXNWMQAXIXKVRVSXOTQXMXNDN
      WARSXMXSXPXTXQVKXMJXIWOXPWMWPTYCXMWNXIPZVTWNXIDNXMYEVPVQYAXPTQXMXIDNWARSX
      MJXKWOXQWMWPTYCXMWNXKPZVTWNXKDNXMYFVPVQYBXQTQXMXKDNWARSWBWCWDAJWLWOWRWMWP
      TXBAWNWLPZVTWNWLDNAYGVPVQABFQCWMQZEBWEWLWMQGAYHEBHWFBCEFEBWJWKWGWRTQAWLDN
      WARSABWQWSEAEUGBQVTZJCWOWSWMWPTYIWPULYIWNCPZVTWNCDNYIYJVPVQHWSTQYICDNWARS
      WHWI $.

    $( An extended sum multiplied by a constant.  (Contributed by Thierry
       Arnoux, 6-Jul-2017.) $)
    esummulc2 $p |- ( ph ->
                           ( C *e sum* k e. A B ) = sum* k e. A ( C *e B ) ) $=
      ( cesum cxmu co cxr wcel wceq cc0 cpnf sseldi syl2anc xmulcom cico esumcl
      icossxr cicc iccssxr wral ralrimiva nfcv esummulc1 cv wa adantr esumeq2dv
      3eqtrd ) ADBCEJZKLZUODKLZBCDKLZEJBDCKLZEJADMNZUOMNUPUQOAPQUALMDPQUCIRZAPQ
      UDLZMUOPQUEZABFNCVBNZEBUFUOVBNGAVDEBHUGBCEFEBUHUBSRDUOTSABCDEFGHIUIABURUS
      EAEUJBNZUKZCMNUTURUSOVFVBMCVCHRAUTVEVAULCDTSUMUN $.
  $}

  ${
    $d k A $.  $d x y k C $.  $d k V $.  $d x y k ph $.
    esumdivc.a $e |- ( ph -> A e. V ) $.
    esumdivc.b $e |- ( ( ph /\ k e. A ) -> B e. ( 0 [,] +oo ) ) $.
    esumdivc.c $e |- ( ph -> C e. RR+ ) $.
    $( An extended sum divided by a constant.  (Contributed by Thierry Arnoux,
       6-Jul-2017.) $)
    esumdivc $p |- ( ph -> ( sum* k e. A B /e C ) = sum* k e. A ( B /e C ) ) $=
      ( cesum c1 cxdiv co cc0 cpnf wcel wceq syl3anc sseldi cxr cxmu cr wne 1re
      cdiv cico a1i rpred rpne0d rexdiv cioo ioossico eqsstr3i rpreccld eqeltrd
      crp ioorp esummulc1 cicc iccssxr wral ralrimiva esumcl syl2anc xdivrec cv
      nfcv wa adantr esumeq2dv 3eqtr4d ) ABCEJZKDLMZUAMZBCVMUAMZEJVLDLMZBCDLMZE
      JABCVMEFGHAVMKDUEMZNOUFMZAKUBPZDUBPZDNUCZVMVRQVTAUDUGADIUHZADIUIZKDUJRAUP
      VSVRUPNOUKMVSUQNOULUMADIUNSUOURAVLTPWAWBVPVNQANOUSMZTVLNOUTZABFPCWEPZEBVA
      VLWEPGAWGEBHVBBCEFEBVGVCVDSWCWDVLDVERABVQVOEAEVFBPZVHZCTPWAWBVQVOQWIWETCW
      FHSAWAWHWCVIAWBWHWDVICDVERVJVK $.
  $}

  $( Lemma for ~ hasheuni (Contributed by Thierry Arnoux, 19-Nov-2016.) $)
  hashf2 $p |- # : _V --> ( 0 [,] +oo ) $=
    ( vx cvv cn0 cpnf csn cun chash wf cc0 cicc co wss hashf cv cxr cle wbr 0xr
    wcel ax-mp cz nn0z zre rexr 3syl nn0ge0 elxrge0 sylanbrc ssriv pnfxr ubicc2
    cr pnfge mp3an snssi unssi fss mp2an ) BCDEZFZGHUTIDJKZLBVAGHMCUSVAACVAANZC
    SZVBOSZIVBPQVBVASVCVBUASVBULSVDVBUBVBUCVBUDUEVBUFVBUGUHUIDVASZUSVALIOSZDOSI
    DPQZVERUJVFVGRIUMTIDUKUNDVAUOTUPBUTVAGUQUR $.

  ${
    $d x A $.  $d x V $.
    $( The cardinality of a disjoint union, not necessarily finite. cf.
       ~ hashuni .  (Contributed by Thierry Arnoux, 19-Nov-2016.)  (Revised by
       Thierry Arnoux, 2-Jan-2017.)  (Revised by Thierry Arnoux,
       20-Jun-2017.) $)
    hasheuni $p |- ( ( A e. V /\ Disj_ x e. A x )
                                   -> ( # ` U. A ) = sum* x e. A ( # ` x ) ) $=
      ( wcel wa cfn chash cesum wceq wss nfv cc0 cpnf co wral wn cvv a1i c0 c1
      cv wdisj cuni cfv w3a nfdisj1 nf3an simp2 simp3 simp1 hashunif simpl cico
      csu dfss3 cn0 hashcl cr cle nn0re nn0ge0 elrege0 sylanbrc ralimi r19.21bi
      wbr sylbi adantll esumpfinval 3adant1 eqtr4d 3adant1l 3expa uniexg notbii
      syl wrex rexnal bitr4i wi elssuni ssfi expcom rexlimiv hashinf syl2an vex
      con3d mpan reximi nfre1 nfan cicc hashf2 ffvelrn mp2an esumpinfval sylan2
      simpr 3adant2 3adant1r pm2.61dan cpw pwfi pwuni mpan2 con3i crab cxad cun
      wf wtru nftru wo unrab exmid rgenw rabid2 mpbir eqtr4i trud nfrab1 rabexg
      esumeq1d cin rabnc esumsplit syl5eqr adantr cdif csn dfrab3 hasheq0 ax-mp
      cab wb abbii syl2anc wne cxr df-sn ineq2i eqtri snfi inss2 eqeltri difinf
      notrab eleq1i sylnib rabid sylib simprd biimpri necon3bi hashge1 1re 0lt1
      rexri esumpinfsum oveq2d cmnf iccssxr ralrimiva esumcl sseldi xrge0neqmnf
      clt xaddpnf1 3eqtrd adantlr ) BCDZABAUAZUBZEZBFDZBUCZGUDZBUVMGUDZAHZIZUVO
      UVPEBFJZUWAUVOUVPUWBUWAUVNUVPUWBUWAUVLUVNUVPUWBUEZUVRBUVSAUNZUVTUWCABUVNU
      VPUWBAABUVMUFUVPAKUWBAKUGUVNUVPUWBUHUVNUVPUWBUIUVNUVPUWBUJUKUVPUWBUVTUWDI
      UVNUVPUWBEBUVSAUVPUWBULUWBUVMBDZUVSLMUMNDZUVPUWBUWFABUWBUVMFDZABOZUWFABOA
      BFUOZUWGUWFABUWGUVSUPDZUWFUVMUQUWJUVSURDLUVSUSVFUWFUVSUTUVSVAUVSVBVCVPVDV
      GVEVHVIVJVKVLVMUVOUVPUWBPZUWAUVLUVPUWKUWAUVNUVLUWKUWAUVPUVLUWKEUVRMUVTUVL
      UVQQDZUVQFDZPZUVRMIZUWKBCVNZUWKUWGPZABVQZUWNUWKUWHPUWRUWBUWHUWIVOUWGABVRV
      SZUWQUWNABUWEUVMUVQJZUWQUWNVTUVMBWAUWTUWMUWGUWMUWTUWGUVQUVMWBWCWHVPWDVGUV
      QQWEZWFUWKUVLUVSMIZABVQZUVTMIUWKUWRUXCUWSUWQUXBABUVMQDZUWQUXBAWGZUVMQWEWI
      WJVGUVLUXCEZBUVSACUVLUXCAUVLAKZUXBABWKWLUVLUXCULUVSLMWMNZDZUXFUWEEQUXHGXK
      UXDUXIWNUXEQUXHUVMGWOWPZRUVLUXCWSWQWRVKWTXAVMXBUVLUVPPZUWAUVNUVLUXKEZUVRM
      UVTUVLUWLUWNUWOUXKUWPUWMUVPUWMUVQXCZFDZUVPUVQXDUXNBUXMJUVPBXEUXMBWBXFVGXG
      UXAWFUXLUVTUVSLIZABXHZUVSAHZUXOPZABXHZUVSAHZXINZUXQMXINZMUVLUVTUYAIUXKUVL
      UVTUXPUXSXJZUVSAHZUYAUYDUVTIXLUYCBUVSAAXMUYCBIXLUYCUXOUXRXNZABXHZBUXOUXRA
      BXOBUYFIUYEABOUYEABUXOXPXQUYEABXRXSXTRYDYAUVLUXPUXSUVSAUXGUXOABYBZUXRABYB
      ZUXOABCYCZUXRABCYCZUXPUXSYESIUVLUXOABYFRUXIUVLUVMUXPDZEUXJRUXIUVLUVMUXSDZ
      EUXJRYGYHYIUXLUXTMUXQXIUXLUXSUVSATQUXLAKUYHUVLUXSQDUXKUYJYIUXLBUXPYJZFDZU
      XSFDUXLUXKUXPFDZUYNPUVLUXKWSUYOUXLUXPBSYKZYEZFUXPBUXOAYOZYEUYQUXOABYLUYRU
      YPBUYRUVMSIZAYOUYPUXOUYSAUXDUXOUYSYPUXEUVMQYMYNZYQASUUAXTUUBUUCUYPFDUYQUY
      PJUYQFDSUUDBUYPUUEUYPUYQWBWPUUFRBUXPUUGYRUYMUXSFUXOABUUHUUIUUJUXIUXLUYLEZ
      UXJRVUAUXDUVMSYSZTUVSUSVFUXDVUAUXERVUAUXRVUBVUAUWEUXRVUAUYLUWEUXREUXLUYLW
      SUXRABUUKUULUUMUXOUVMSUXOUYSUYTUUNUUOVPUVMQUUPYRTYTDUXLTUUQUUSRLTUVHVFUXL
      UURRUUTUVAUXLUXQYTDUXQUVBYSZUYBMIUXLUXHYTUXQLMUVCUXLUXPQDZUXIAUXPOUXQUXHD
      ZUVLVUDUXKUYIYIUXLUXIAUXPUXIUXLUYKEUXJRUVDUXPUVSAQUYGUVEYRZUVFUXLVUEVUCVU
      FUXQUVGVPUXQUVIYRUVJVKUVKXB $.
  $}

  ${
    $d k l x y z $.  $d l m n x y z A $.  $d k l n x y B $.
    $d k l m n x y F $.  $d k n J $.  $d k l m n x y ph $.
    esumcvg.j $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    esumcvg.f $e |- F = ( n e. NN |-> sum* k e. ( 1 ... n ) A ) $.
    esumcvg.a $e |- ( ( ph /\ k e. NN ) -> A e. ( 0 [,] +oo ) ) $.
    esumcvg.m $e |- ( k = m -> A = B ) $.
    $( The sequence of partial sums of an extended sum converges to the whole
       sum. cf. ~ fsumcvg2 .  (Contributed by Thierry Arnoux, 5-Sep-2017.) $)
    esumcvg $p |- ( ph -> F ( ~~>t ` J ) sum* k e. NN A ) $=
      ( vl cpnf wcel cn wbr wceq wa c1 vx vy vz cc0 cico co wral cesum clm wrex
      cfv cli csu nnuz cz 1z a1i simpr cv cc cmnf cxr clt cle pnfxr ax-mp pnfge
      cr wss wi weq eleq1d adantl imp sseldi adantlr cfz cmpt fzfid esumpfinval
      elfznn sylan2 syl5eq wf fmptd adantr simplll eqidd eqcom sylancom elrege0
      fvmptd sylib caddc wfn cvv ovex simpll syl2anc ralrimiva nfcv sylancr syl
      esumcl mpbir eqtrd wb mpbid breqtrrd nnzd uzid 3syl oveq2 esumeq1 simp-4l
      cuz cfn nfv nnex cgsu simplr eqid breq2d reximdva mp2an rspce cres anbi2d
      cxp eleq1 imbi12d nfan esumpinfval chvarv ex ctopon 0xr mp3an syldan wo
      cdm mnfxr 0re mnflt icossioo mp4an ioomax sseqtri ax-resscn sstri cbvralv
      cioo rsp sylbir mpteq2dva fsumcl fvmpt2d isumclim3 fsumrp0cl eqeltrd cicc
      3imtr3i simpld cseq ffn fneq2i syl6eleq fsumser eqfnfvd eqeltrrd isumrecl
      seqfn simprd isumge0 sylanbrc ssid lmlimxrge0 mpbird esumpcvgval peano2uz
      syl5eqelr wn esumpmono eqtr4d cbvmptv eqtr4i w3a simpr3 peano2nnd 3brtr4d
      3anassrs lmdvglim cpw cin crn csup ccnfld cxrs cress inss1 esumpfinvallem
      elpwid sseldd inss2 gsumfsum eqtr3d esumval lmdvg r19.21bi fveq2d reximia
      nnz rspcdv ad2antrr ffvelrnd ltle esumex sylibd fzssuz sseqtr4i elpw fzfi
      mpd elin mpbir2an sumex sumeq1 elrnmpt1s mpan rexlimivw adantllr fsumrecl
      breq2 rexrd frn supxrunb1 pm2.61dan csn reseq1i wsb anbi12d fveq2 reseq2d
      sbequ12r xpeq1d eqeq12d nfs1v simpllr elnnuz eluzfz sbequ12 mpteq12 sylan
      sylanb uznnssnn fconstmpt 3eqtr4d mpdan cordt crest ctopn xrge0topn eqtri
      resmpt letopon iccssxr eqeltri ubicc2 lmconst syl3anc breq1 biimprd mpan9
      resttopon cpm elfvexd cnex nnsscn elpm2r syl22anc lmres biimpar rexlimdva
      nfre1 eliccelico r19.30 eqeq1d cbvrexv orbi2i sylibr mpjaodan ) ACUDNUEUF
      ZOZEPUGZGPBDUHZHUIUKZQZBNRZDPUJZAVWNSZGULUUAZOZVWQVWTVXBSZGPBDUMZVWOVWPVX
      CGVXDVWPQGVXDULQVXCBFDGTPUNTUOOZVXCUPUQZVWTVXBURZVWTDUSZPOZBUTOZVXBVWTVXI
      SVWLUTBVWLVHUTVWLVANUULUFZVHVAVBONVBOZVAUDVCQZNNVDQZVWLVXKVIUUBVEUDVHOVXM
      UUCUDUUDVFVXLVXNVENVGVFVANUDNUUEUUFUUGUUHZUUIUUJZVWTVXIBVWLOZVWNVXIVXQVJZ
      AVWNVXQDPUGVXRVXQVWMDEPDEVKZBCVWLLVLUUKVXQDPUUMUUNVMVNZVOZVPVWTFUSZPOZVYB
      GUKZTVYBVQUFZBDUMZRVXBVWTFPVYFGUTVWTGFPVYEBDUHZVRZFPVYFVRZJVWTFPVYGVYFVWT
      VYCSZVYEBDVYJTVYBVSZVWTVXHVYEOZVXQVYCVYLVWTVXIVXQVXHVYBWAZVXTWBVPZVTZUUOZ
      WCVYJVYEBDVYKVYJVYLSVWLUTBVXPVYNVOZUUPUUQZVPUURVXCVXDGHVWLIVWTPVWLGWDZVXB
      VWTFPVYGVWLGVYJVYGVYFVWLVYOVYJVYEBDVYKVYNUUSUUTJWEZWFVXCVXDVHOUDVXDVDQVXD
      VWLOVXCBDEPCVRZTPUNVXFVXCVXIAVXHWUAUKBRZAVWNVXBVXIWGAVXISZEVXHCBPWUAUDNUV
      AUFZWUCWUAWHEDVKZCBRZWUCVXSBCRWUEWUFLVXHEUSZWIBCWIUVBVMAVXIURZKWLZWJZVXCV
      XISZBVHOZUDBVDQZWUKVXQWULWUMSVWTVXIVXQVXBVXTVPZBWKWMZUVCZVXCGWNWUATUVDZVX
      AVWTGWUQRVXBVWTFPGWUQAGPWOZVWNAPWUDGWDZWURAFPVYGWUDGAVYCSZVYEWPOZBWUDOZDV
      YEUGVYGWUDOTVYBVQWQZWUTWVBDVYEWUTVYLSAVXIWVBAVYCVYLWRVYLVXIWUTVYMVMKWSWTV
      YEBDWPDVYEXAXDXBJWEZPWUDGUVEXCWFWUQPWOZVWTWVEWUQTXPUKZWOZVXEWVGUPWNWUATUV
      LVFPWVFWUQUNUVFXEUQVYJVYDVYFVYBWUQUKVYRVYJBDWUATVYBVYJVYLAWUBAVWNVYCVYLWG
      VYLAVXIWUBVYMWUIWBWJVYJVYBPWVFVWTVYCURUNUVGVYQUVHXFUVIWFVXGUVJZUVKVXCBDWU
      ATPUNVXFWUJWUPWVHWUKWULWUMWUOUVMUVNVXDWKUVOVWLUVPUVQUVRVXCBCDFEWUNLVXCVYH
      VXAOZVYIVXAOZVXCVYHGVXAJVXGUWAVWTWVIWVJXGVXBVWTVYHVYIVXAVYPVLWFXHUVSXIVWT
      VXBUWBZSZGNVWOVWPWVLFGHIVWTVYSWVKVYTWFZWVLVYCSZVYGTVYBTWNUFZVQUFZBDUHZVYD
      WVOGUKVDWVNBDVYBWVOWVLVYCURZWVNVYBUOOVYBVYBXPUKZOWVOWVSOWVNVYBWVRXJVYBXKV
      YBVYBUVTXLWVNVXIVWTVXQVWTWVKVYCVXIWGVXTWJUWCVWTVYCVYDVYGRWVKVYJVYDVYFVYGV
      YRVYOUWDVPWVNMWVOTMUSZVQUFZBDUHZWVQPGWUDGMPWWBVRZRWVNGVYHWWCJMFPWWBVYGMFV
      KWWAVYERWWBVYGRWVTVYBTVQXMWWAVYEBDXNXCUWEUWFUQVWTWVKVYCWVTWVORZWWBWVQRZVW
      TWVKVYCWWDUWGSWWDWWAWVPRWWEVWTWVKVYCWWDUWHWVTWVOTVQXMWWAWVPBDXNXLUWKWVNVY
      BWVRUWIWVNWVPWPOWVBDWVPUGWVQWUDOTWVOVQWQWVNWVBDWVPWVNVXHWVPOZSAVXIWVBAVWN
      WVKVYCWWFXOWWFVXIWVNVXHWVOWAVMKWSWTWVPBDWPDWVPXAXDXBWLUWJZVWTWVKURZUWLWVL
      VWOUAPUWMZXQUWNZUAUSZBDUMZVRZUWOZVBVCUWPZNVWTVWOWWORWVKVWTUAPBWWLDWPVWTDX
      RDPXAPWPOZVWTXSUQAVXIWVBVWNKVPVWTWWKWWJOZSZUWQDWWKBVRZXTUFZUWRWUDUWSUFZWW
      SXTUFZWWLWWRWWQWWKVWLWWSWDWWTWXBRVWTWWQURZWWRDWWKBVWLWWSWWRVXHWWKOZSZVWTV
      XIVXQVWTWWQWXDWRZWXEWWKPVXHWXEWWKPWXEWWJWWIWWKWWIXQUWTVWTWWQWXDYAVOUXBWWR
      WXDURUXCZVXTWSZWWSYBWEWWKWWSWWJUXAWSWWRWWKBDWWRWWJXQWWKWWIXQUXDZWXCVOWXEV
      WTVXIVXJWXFWXGVYAWSUXEUXFUXGWFWVLUBUSZUCUSZVDQZUCWWNUJZUBVHUGZWWONRZWVLWX
      MUBVHWVLWXJVHOZSZWXJWWABDUMZVDQZMPUJZWXMWXQWXJWVTGUKZVCQZMPUJZWXTWXQWXJVY
      DVCQZFWVTXPUKZUGZMPUJZWYCWVLWYGUBVHWVLUBMFGWVMWWGWWHUXHUXIWYFWYBMPWVTPOZW
      YDWYBFWVTWYEWYHWVTUOOWVTWYEOWVTUXLWVTXKXCWYHFMVKZSZVYDWYAWXJVCWYJVYBWVTGW
      YHWYIURUXJYCUXMUXKXCWXQWYBWXSMPWXQWYHSZWYBWXJWYAVDQZWXSWYKWXPWYAVHOWYBWYL
      VJWVLWXPWYHYAWYKVWLVHWYAVXOWYKPVWLWVTGWVLVYSWXPWYHWVMUXNWXQWYHURZUXOVOWXJ
      WYAUXPWSWYKWYAWXRWXJVDWYKWYAWWBWXRWYKFWVTVYGWWBPGWPGVYHRWYKJUQWYIVYGWWBRZ
      WYKWYIVYEWWARWYNVYBWVTTVQXMVYEWWABDXNXCVMWYMWWBWPOWYKWWABDUXQUQWLWYKWWABD
      WYKTWVTVSWYKVXHWWAOZSVWTVXIVXQVWTWVKWXPWYHWYOXOWYOVXIWYKVXHWVTWAVMVXTWSVT
      XFYCUXRYDUYCWXSWXMMPWXRWWNOZWXSWXMWWAWWJOZWXRWPOWYPWYQWWAWWIOZWWAXQOWYRWW
      APVIWWAWVFPTWVTUXSUNUXTWWAPTWVTVQWQUYAXETWVTUYBWWAWWIXQUYDUYEWWABDUYFUAWW
      JWWLWXRWWAWWMWPWWMYBZWWKWWABDUYGUYHYEWXLWXSUCWXRWWNWXSUCXRWXKWXRWXJVDUYMY
      FUYIUYJXCWTWVLWWJVBWWMWDWWNVBVIWXNWXOXGWVLUAWWJWWLVBWWMWVLWWQSZWWLWYTWWKB
      DWYTWWJXQWWKWXIWVLWWQURVOWYTWXDSVWLVHBVXOVWTWWQWXDVXQWVKWXHUYKVOUYLUYNWYS
      WEWWJVBWWMUYOUBUCWWNUYPXLXHXFXIUYQAVWSSZGNVWOVWPAVWSGVXHXPUKZYGZXUBNUYRZY
      IZRZDPUJZGNVWPQZAVWSXUGAVWRXUFDPWUCVWRXUFWUCVWRSZXUCVYHXUBYGZXUEGVYHXUBJU
      YSAWYHSZVWRDMUYTZSZVYHWYEYGZWYEXUDYIZRZVJXUIXUJXUERZVJMDMDVKZXUMXUIXUPXUQ
      XURXUKWUCXULVWRXURWYHVXIAWVTVXHPYJYHVWRMDVUDVUAXURXUNXUJXUOXUEXURWYEXUBVY
      HWVTVXHXPVUBZVUCXURWYEXUBXUDXUSVUEVUFYKXUMVYGNRZFWYEUGZXUPXUMXUTFWYEXUMVY
      BWYEOZSZVYEBDWPXUMXVBDXUKXULDXUKDXRVWRDMVUGZYLXVBDXRYLWVAXVCWVCUQXVCVYLSA
      VXIWVBAWYHXULXVBVYLXOVYLVXIXVCVYMVMKWSXVCWVTVYEOZXULVWRDVYEUJXUMXVBWYHXVE
      AWYHXULXVBVUHWYHWVTWVFOXVBXVEWVTVUIWVTTVYBVUJVUNWJXUKXULXVBYAVWRXULDWVTVY
      EXVDVWRDMVUKYFWSYMWTXUMXVASZFWYEVYGVRZFWYENVRZXUNXUOXUMWYEWYERXVAXVGXVHRX
      UMWYEWHFWYEVYGWYENVULVUMXUMXUNXVGRZXVAXUMWYHWYEPVIXVIAWYHXULYAWVTVUOFPWYE
      VYGVVDXLWFXUOXVHRXVFFWYENVUPUQVUQVURYNWCYOYDVNAXUGXUHAXUFXUHDPWUCXUFXUHWU
      CXUFXUCNVWPQZXUHWUCXUENVWPQZXUFXVJWUCHWUDYPUKZOZNWUDOZVXHUOOXVKXVMWUCHVDV
      USUKZWUDVUTUFZXVLHWXAVVAUKXVPIVVBVVCXVOVBYPUKOWUDVBVIXVPXVLOVVEUDNVVFWUDX
      VOVBVVNYEVVGUQZXVNWUCUDVBOZVXLUDNVDQZXVNYQVEXVRXVSYQUDVGVFZUDNVVHYRUQWUCV
      XHWUHXJZNHVXHWUDXUBXUBYBVVIVVJXUFXVJXVKXUCXUENVWPVVKVVLVVMWUCXUHXVJWUCNGH
      VXHWUDXVQWUCWUDWPOUTWPOZWUSPUTVIZGWUDUTVVOUFOWUCHYPWUDXVQVVPXWBWUCVVQUQAW
      USVXIWVDWFXWCWUCVVRUQWUDUTPGWPWPVVSVVTXWAVWAVWBYSYOVWCVNYSXUAPBDWPAVWSDAD
      XRVWRDPVWDYLWWPXUAXSUQAVXIWVBVWSKVPAVWSURYMXIAVWNCNRZEPUJZYTZVWNVWSYTAVWM
      XWDYTZEPUGXWFAXWGEPAWUGPOZSZCWUDOZXWGWUCWVBVJXWIXWJVJDEVXSWUCXWIWVBXWJVXS
      VXIXWHAVXHWUGPYJYHVXSBCWUDLVLYKKYNXVRVXLXVSXWJXWGXGYQVEXVTUDNCVWEYRWMWTVW
      MXWDEPVWFXCVWSXWEVWNVWRXWDDEPVXSBCNLVWGVWHVWIVWJVWK $.
  $}

  ${
    $d i k l m n $.  $d i l m n A $.  $d k n B $.  $d k l n C $.  $d k n J $.
    $d k l n ph $.
    esumcvg2.j $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    esumcvg2.a $e |- ( ( ph /\ k e. NN ) -> A e. ( 0 [,] +oo ) ) $.
    esumcvg2.l $e |- ( k = l -> A = B ) $.
    esumcvg2.m $e |- ( k = m -> A = C ) $.
    $( Simpler version of ~ esumcvg .  (Contributed by Thierry Arnoux,
       5-Sep-2017.) $)
    esumcvg2 $p |- ( ph -> ( n e. NN |-> sum* k e. ( 1 ... n ) A )
      ( ~~>t ` J ) sum* k e. NN A ) $=
      ( vi cn c1 cv cfz cesum wceq co cmpt clm cfv cbvesumv esumeq1 syl syl5eqr
      oveq2 cbvmptv esumcvg syl5eqbrr ) AGOPGQZRUAZBESZUBNOPNQZRUAZDFSZUBZOBESH
      UCUDNGOURUOUPUMTZURUQBESZUOUQBDEFMUEUTUQUNTVAUOTUPUMPRUIUQUNBEUFUGUHUJZAB
      CEIGUSHJVBKLUKUL $.
  $}

$( End $[ set-mbox-ta-esum.mm $] $)
$( Begin $[ set-mbox-ta-ofc.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Mixed Function/Constant operation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c oFC $.  $( A small o with F/C subscript $)

  $( Extend class notation to include mapping of an operation to an operation
     for a function and a constant. $)
  cofc $a class oFC R $.

  ${
    $d f c x R $.
    $( Define the function/constant operation map.  The definition is designed
       so that if ` R ` is a binary operation, then ` oFC R ` is the analogous
       operation on functions and constants.  (Contributed by Thierry Arnoux,
       21-Jan-2017.) $)
    df-ofc $a |- oFC R = ( f e. _V , c e. _V |->
      ( x e. dom f |-> ( ( f ` x ) R c ) ) ) $.
  $}

  ${
    $d c f x R $.  $d c f x S $.
    $( Equality theorem for function/constant operation.  (Contributed by
       Thierry Arnoux, 30-Jan-2017.) $)
    ofceq $p |- ( R = S -> oFC R = oFC S ) $=
      ( vf vc vx wceq cvv cv cdm co cmpt cmpt2 cofc wcel oveq mpteq2dv 3ad2ant1
      cfv mpt2eq3dva df-ofc 3eqtr4g ) ABFZCDGGECHZIZEHUCRZDHZAJZKZLCDGGEUDUEUFB
      JZKZLAMBMUBCDGGUHUJUBUCGNUHUJFUFGNUBEUDUGUIUEUFABOPQSEACDTEBCDTUA $.
  $}

  ${
    $d c f x C $.  $d c f x F $.  $d c f x R $.  $d c f x ph $.
    ofcfval.1 $e |- ( ph -> F Fn A ) $.
    ofcfval.2 $e |- ( ph -> A e. V ) $.
    ofcfval.3 $e |- ( ph -> C e. W ) $.
    ${
      ofcfval.6 $e |- ( ( ph /\ x e. A ) -> ( F ` x ) = B ) $.
      $( Value of an operation applied to a function and a constant.
         (Contributed by Thierry Arnoux, 30-Jan-2017.) $)
      ofcfval $p |- ( ph -> ( F oFC R C ) = ( x e. A |-> ( B R C ) ) ) $=
        ( vf vc co cvv wceq wa wcel cofc cdm cv cfv cmpt cmpt2 df-ofc a1i dmeqd
        simprl fveq1d simprr oveq12d mpteq12dv wfn fnex syl2anc elex syl mptexg
        fndm eqeltrd ovmpt2d eleq2d pm5.32i sylbi oveq1d mpteq12dva eqtrd ) AGE
        FUAZPBGUBZBUCZGUDZEFPZUEZBCDEFPZUEANOGEQQBNUCZUBZVLVQUDZOUCZFPZUEZVOVJQ
        VJNOQQWBUFRABFNOUGUHAVQGRZVTERZSSZBVRWAVKVNWEVQGAWCWDUJZUIWEVSVMVTEFWEV
        LVQGWFUKAWCWDULUMUNAGCUOZCHTGQTJKCHGUPUQAEITEQTLEIURUSAVKHTVOQTAVKCHAWG
        VKCRJCGVAUSZKVBBVKVNHUTUSVCABVKVNCVPWHAVLVKTZSZVMDEFWJAVLCTZSVMDRAWIWKA
        VKCVLWHVDVEMVFVGVHVI $.
    $}

    $d x A $.
    ${
      $d x X $.
      ofcval.6 $e |- ( ( ph /\ X e. A ) -> ( F ` X ) = B ) $.
      $( Evaluate a function/constant operation at a point.  (Contributed by
         Thierry Arnoux, 31-Jan-2017.) $)
      ofcval $p |- ( ( ph /\ X e. A ) -> ( ( F oFC R C ) ` X ) = ( B R C ) ) $=
        ( vx wcel wa co cfv cvv wceq cofc cv eqidd ofcfval adantr fveq2d oveq1d
        cmpt simpr ovex a1i fvmptd eqtrd ) AIBOZPZIFDEUAQZRIFRZDEQZCDEQUONINUBZ
        FRZDEQZURBUPSAUPNBVAUHTUNANBUTDEFGHJKLAUSBOPUTUCUDUEUOUSITZPZUTUQDEVCUS
        IFUOVBUIUFUGAUNUIURSOUOUQDEUJUKULUOUQCDEMUGUM $.
    $}

    $( The function operation produces a function.  (Contributed by Thierry
       Arnoux, 31-Jan-2017.) $)
    ofcfn $p |- ( ph -> ( F oFC R C ) Fn A ) $=
      ( vx cofc co wfn cv cfv cmpt ovex eqid fnmpti wcel wa eqidd fneq1d mpbiri
      ofcfval ) AECDLMZBNKBKOZEPZCDMZQZBNKBUJUKUICDRUKSTABUGUKAKBUICDEFGHIJAUHB
      UAUBUIUCUFUDUE $.
  $}

  ${
    $d x y C $.  $d x y F $.  $d x y P $.  $d x y R $.  $d x y ph $.  $d y B $.
    ofcfeqd2.1 $e |- ( ( ph /\ x e. A ) -> ( F ` x ) e. B ) $.
    ofcfeqd2.2 $e |- ( ( ph /\ y e. B ) -> ( y R C ) = ( y P C ) ) $.
    ofcfeqd2.3 $e |- ( ph -> F Fn A ) $.
    ofcfeqd2.4 $e |- ( ph -> A e. V ) $.
    ofcfeqd2.5 $e |- ( ph -> C e. W ) $.
    $( Equality theorem for function/constant operation value.  (Contributed by
       Thierry Arnoux, 31-Jan-2017.) $)
    ofcfeqd2 $p |- ( ph -> ( F oFC R C ) = ( F oFC P C ) ) $=
      ( cv co cmpt wceq cofc wcel wa wral ralrimiva adantr oveq1 eqeq12d rspcva
      cfv syl2anc mpteq2dva eqidd ofcfval 3eqtr4d ) ABDBQZIUJZFHRZSBDUQFGRZSIFH
      UARIFGUARABDURUSAUPDUBZUCZUQEUBCQZFHRZVBFGRZTZCEUDZURUSTZLAVFUTAVECEMUEUF
      VEVGCUQEVBUQTVCURVDUSVBUQFHUGVBUQFGUGUHUIUKULABDUQFHIJKNOPVAUQUMZUNABDUQF
      GIJKNOPVHUNUO $.
  $}

  ${
    $d c f x C $.  $d c f x F $.  $d c f x R $.
    $( General value of ` ( F oFC R C ) ` with no assumptions on functionality
       of ` F ` .  (Contributed by Thierry Arnoux, 31-Jan-2017.) $)
    ofcfval3 $p |- ( ( F e. V /\ C e. W ) -> ( F oFC R C ) =
        ( x e. dom F |-> ( ( F ` x ) R C ) ) ) $=
      ( vf vc wcel wa cvv cdm cv cfv co cmpt cofc wceq elex adantr adantl dmexg
      mptexg simpl dmeqd fveq1d simpr oveq12d mpteq12dv df-ofc ovmpt2ga syl3anc
      syl ) DEIZBFIZJDKIZBKIZADLZAMZDNZBCOZPZKIZDBCQZOVBRUNUPUODESTUOUQUNBFSUAU
      NVCUOUNURKIVCDEUBAURVAKUCUMTGHDBKKAGMZLZUSVENZHMZCOZPVBVDKVEDRZVHBRZJZAVF
      VIURVAVLVEDVJVKUDZUEVLVGUTVHBCVLUSVEDVMUFVJVKUGUHUIACGHUJUKUL $.
  $}

  ${
    $d z A $.  $d y z C $.  $d x y z F $.  $d x y z R $.  $d x y S $.
    $d x y T $.  $d x y z U $.  $d x y z ph $.
    ofcf.1 $e |- ( ( ph /\ ( x e. S /\ y e. T ) ) -> ( x R y ) e. U ) $.
    ofcf.2 $e |- ( ph -> F : A --> S ) $.
    ofcf.4 $e |- ( ph -> A e. V ) $.
    ofcf.5 $e |- ( ph -> C e. T ) $.
    $( The function/constant operation produces a function.  (Contributed by
       Thierry Arnoux, 30-Jan-2017.) $)
    ofcf $p |- ( ph -> ( F oFC R C ) : A --> U ) $=
      ( vz cv co wcel wral cfv wf wfn ffn syl wa eqidd ofcfval ffvelrnda adantr
      cofc ralrimivva proplem2 syl21anc fmpt3d ) APDPQZJUAZEFRZIJEFUKRAPDUQEFJK
      HADGJUBJDUCMDGJUDUENOAUPDSZUFZUQUGUHUTUQGSEHSZBQCQFRISZCHTBGTZURISADGUPJM
      UIAVAUSOUJAVCUSAVBBCGHLULUJBCGHIFUQEUMUNUO $.
  $}

  ${
    $d x A $.  $d x C $.  $d x F $.  $d x R $.  $d x ph $.
    ofcfval2.1 $e |- ( ph -> A e. V ) $.
    ofcfval2.2 $e |- ( ph -> C e. W ) $.
    ofcfval2.3 $e |- ( ( ph /\ x e. A ) -> B e. W ) $.
    ofcfval2.4 $e |- ( ph -> F = ( x e. A |-> B ) ) $.
    $( The function operation expressed as a mapping.  (Contributed by Thierry
       Arnoux, 31-Jan-2017.) $)
    ofcfval2 $p |- ( ph -> ( F oFC R C ) = ( x e. A |-> ( B R C ) ) ) $=
      ( wfn cmpt wcel wral ralrimiva eqid fnmpt fneq1d mpbird fvmpt2d ofcfval
      syl ) ABCDEFGHIAGCNBCDOZCNZADIPZBCQUGAUHBCLRBCDUFIUFSTUEACGUFMUAUBJKABCDG
      IMLUCUD $.
  $}

  ${
    $d y A $.  $d x y B $.  $d x y C $.  $d x y F $.  $d x y R $.  $d y ph $.
    ofcfval4.1 $e |- ( ph -> F : A --> B ) $.
    ofcfval4.2 $e |- ( ph -> A e. V ) $.
    ofcfval4.3 $e |- ( ph -> C e. W ) $.
    $( The function/constant operation expressed as an operation composition.
       (Contributed by Thierry Arnoux, 31-Jan-2017.) $)
    ofcfval4 $p |- ( ph ->
                         ( F oFC R C ) = ( ( x e. B |-> ( x R C ) ) o. F ) ) $=
      ( vy cv co cmpt wceq cvv wcel syl2anc cdm cfv cofc wf fdm syl mpteq1d fex
      ccom ofcfval3 ffvelrnda feqmptd eqidd oveq1 fmptco 3eqtr4d ) AMGUAZMNZGUB
      ZEFOZPZMCUTPGEFUCOZBDBNZEFOZPZGUIAMUQCUTACDGUDZUQCQJCDGUEUFUGAGRSZEISVBVA
      QAVFCHSVGJKCDHGUHTLMEFGRIUJTAMBCDUSVDUTGVEACDURGJUKAMCDGJULAVEUMVCUSEFUNU
      OUP $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x R $.  $d x ph $.
    ofcc.1 $e |- ( ph -> A e. V ) $.
    ofcc.2 $e |- ( ph -> B e. W ) $.
    ofcc.3 $e |- ( ph -> C e. X ) $.
    $( Left operation by a constant on a mixed operation with a constant.
       (Contributed by Thierry Arnoux, 31-Jan-2017.) $)
    ofcc $p |- ( ph -> ( ( A X. { B } ) oFC R C ) = ( A X. { ( B R C ) } ) ) $=
      ( vx csn cxp cofc co cmpt wcel wfn fnconstg syl cv wceq fvconst2g ofcfval
      cfv sylan fconstmpt syl6eqr ) ABCMNZDEOPLBCDEPZQBUKMNALBCDEUJFHACGRZUJBSJ
      BCGTUAIKAULLUBZBRUMUJUFCUCJBCUMGUDUGUELBUKUHUI $.
  $}

$( End $[ set-mbox-ta-ofc.mm $] $)
$( Begin $[ set-mbox-ta-meas.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Abstract measure
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Sigma-Algebra
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c sigAlgebra $.

  $( Extend class notation to include the function giving the sigma-algebras on
     a given base set. $)
  csiga $a class sigAlgebra $.

  ${
    $d o s x $.
    $( Define a sigma-algebra, i.e. a set closed under complement and countable
       union.  Litterature usually uses capital greek sigma and omega letters
       for the algebra set, and the base set respectively.  We are using ` S `
       and ` O ` as a parallel.  (Contributed by Thierry Arnoux,
       3-Sep-2016.) $)
    df-siga $a |- sigAlgebra = ( o e. _V |-> { s | ( s C_ ~P o /\
      ( o e. s /\ A. x e. s ( o \ x ) e. s
      /\ A. x e. ~P s ( x ~<_ om -> U. x e. s ) ) ) } ) $.
  $}

  ${
    $d o s $.
    $( Lemma for ~ issiga and ~ isrnsiga The set of sigma algebra with base set
       ` o ` is a set.  Note: a more generic version with
       ` ( O e. _V -> ... ) ` could be useful for ~ sigaval .  (Contributed by
       Thierry Arnoux, 24-Oct-2016.) $)
    sigaex $p |- { s | ( s C_ ~P o /\ ( o e. s /\ A. x e. s ( o \ x ) e. s
      /\ A. x e. ~P s ( x ~<_ om -> U. x e. s ) ) ) } e. _V $=
      ( cv wcel cdif wral com cdom wbr cuni wi cpw w3a crab cab cvv vex pwexg
      wa wss df-rab elpw anbi1i abbii eqtri mp2b rabex eqeltrri ) BDZCDZEUJADZF
      UKEAUKGULHIJULKUKELAUKMGNZCUJMZMZOZUKUNUAZUMTZCPZQUPUKUOEZUMTZCPUSUMCUOUB
      VAURCUTUQUMUKUNCRUCUDUEUFUMCUOUJQEUNQEUOQEBRUJQSUNQSUGUHUI $.
  $}

  ${
    $d s o x O $.
    $( The set of sigma-algebra with a given base set.  (Contributed by Thierry
       Arnoux, 23-Sep-2016.) $)
    sigaval $p |- ( O e. _V -> ( sigAlgebra ` O ) = { s | ( s C_ ~P O /\
      ( O e. s /\ A. x e. s ( O \ x ) e. s
      /\ A. x e. ~P s ( x ~<_ om -> U. x e. s ) ) ) } ) $=
      ( vo cvv wcel cv cpw wss cdif wral com cdom wbr w3a cab csiga wceq pwexg
      wa cuni cfv crab df-rab vex elpw anbi1i abbii eqtri rabexg 3syl syl5eqelr
      wi pweq sseq2d eleq1 difeq1 eleq1d ralbidv 3anbi12d anbi12d abbidv fvmptg
      df-siga mpdan ) BEFZCGZBHZIZBVGFZBAGZJZVGFZAVGKZVKLMNVKUAVGFUMAVGHKZOZTZC
      PZEFBQUBVRRVFVRVPCVHHZUCZEVTVGVSFZVPTZCPVRVPCVSUDWBVQCWAVIVPVGVHCUEUFUGUH
      UIVFVHEFVSEFVTEFBESVHESVPCVSEUJUKULDBVGDGZHZIZWCVGFZWCVKJZVGFZAVGKZVOOZTZ
      CPVREEQWCBRZWKVQCWLWEVIWJVPWLWDVHVGWCBUNUOWLWFVJWIVNVOWCBVGUPWLWHVMAVGWLW
      GVLVGWCBVKUQURUSUTVAVBADCVDVCVE $.
  $}

  ${
    $d o s x O $.  $d o s x S $.
    $( An alternative definition of the sigma-algebra, for a given base set.
       (Contributed by Thierry Arnoux, 19-Sep-2016.) $)
    issiga $p |- ( S e. _V -> ( S e. ( sigAlgebra ` O ) <->
      ( S C_ ~P O /\ ( O e. S /\ A. x e. S ( O \ x ) e. S
      /\ A. x e. ~P S ( x ~<_ om -> U. x e. S ) ) ) ) ) $=
      ( vs vo cvv wcel wa csiga cpw wss cv cdif wral wi w3a elex a1i wb wceq
      cfv com cdom wbr cuni elfvex jca simpr1 anc2ri df-siga sigaex pweq sseq2d
      syl sseq1 eleq12 simpr difeq1 adantr eleq1d eleq2 adantl raleqbidv imbi2d
      sylan9bb bitrd 3anbi123d anbi12d abfmpel pm5.21ndd ) BFGZCFGZVKHZBCIUAZGZ
      BCJZKZCBGZCALZMZBGZABNZVSUBUCUDZVSUEZBGZOZABJZNZPZHZVOVMOVKVOVLVKBCIUFBVN
      QUGRVKWJVLWJVLOVKWJVRVLVQVRWBWHUHCBQUNRUIVMVOWJSOVKDLZELZJZKZWLWKGZWLVSMZ
      WKGZAWKNZWCWDWKGZOZAWKJZNZPZHWJEDCBIFFAEDUJAEDUKWLCTZWKBTZHZWNVQXCWIXDWNW
      KVPKXEVQXDWMVPWKWLCULUMWKBVPUOVEXFWOVRWRWBXBWHWLCWKBUPXFWQWAAWKBXDXEUQXFW
      QVTWKGZWAXFWPVTWKXDWPVTTXEWLCVSURUSUTXEXGWASXDWKBVTVAVBVFVCXEXBWHSXDXEWTW
      FAXAWGWKBULXEWSWEWCWKBWDVAVDVCVBVGVHVIRVJ $.
  $}

  ${
    $d a o s x S $.
    $( The property of being a sigma algebra on an indefinite base set.
       (Contributed by Thierry Arnoux, 3-Sep-2016.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    isrnsigaOLD $p |- ( S e. U. ran sigAlgebra <-> ( S e. _V /\
      E. o ( S C_ ~P o /\ ( o e. S /\ A. x e. S ( o \ x ) e. S
      /\ A. x e. ~P S ( x ~<_ om -> U. x e. S ) ) ) ) ) $=
      ( vs csiga crn cuni wcel cvv cv cpw wss cdif wral com wi w3a wa cab eleq2
      cdom wbr wrex wex df-siga crab df-rab vex elpwg ax-mp anbi1i abbii eqtr2i
      grothpwex pwex rabex eqeltri wceq sseq1 raleqbi1dv pweq imbi12d raleqbidv
      wb biidd 3anbi123d anbi12d abfmpunirn rexv anbi2i bitri ) BEFGHBIHZBCJZKZ
      LZVMBHZVMAJZMZBHZABNZVQOUAUBZVQGZBHZPZABKZNZQZRZCIUCZRVLWHCUDZRDJZVNLZVMW
      KHZVRWKHZAWKNZWAWBWKHZPZAWKKZNZQZRZWHCDBEIACDUEXADSZWTDVNKZUFZIXDWKXCHZWT
      RZDSXBWTDXCUGXFXADXEWLWTWKIHXEWLVDDUHWKVNIUIUJUKULUMWTDXCVNCUNUOUPUQWKBUR
      ZWLVOWTWGWKBVNUSXGWMVPWOVTWSWFWKBVMTWNVSAWKBWKBVRTUTXGWQWDAWRWEWKBVAXGWAW
      AWPWCXGWAVEWKBWBTVBVCVFVGVHWIWJVLWHCVIVJVK $.

    $( The property of being a sigma algebra on an indefinite base set.
       (Contributed by Thierry Arnoux, 3-Sep-2016.)  (Proof shortened by
       Thierry Arnoux, 23-Oct-2016.) $)
    isrnsiga $p |- ( S e. U. ran sigAlgebra <-> ( S e. _V /\
      E. o ( S C_ ~P o /\ ( o e. S /\ A. x e. S ( o \ x ) e. S
      /\ A. x e. ~P S ( x ~<_ om -> U. x e. S ) ) ) ) ) $=
      ( vs csiga crn cuni wcel cvv cv cpw wss cdif wral com cdom wi w3a eleq2
      wa wbr wrex df-siga sigaex wceq sseq1 raleqbi1dv pweq raleqbidv 3anbi123d
      wex imbi2d anbi12d abfmpunirn rexv anbi2i bitri ) BEFGHBIHZBCJZKZLZUSBHZU
      SAJZMZBHZABNZVCOPUAZVCGZBHZQZABKZNZRZTZCIUBZTURVNCUKZTDJZUTLZUSVQHZVDVQHZ
      AVQNZVGVHVQHZQZAVQKZNZRZTVNCDBEIACDUCACDUDVQBUEZVRVAWFVMVQBUTUFWGVSVBWAVF
      WEVLVQBUSSVTVEAVQBVQBVDSUGWGWCVJAWDVKVQBUHWGWBVIVGVQBVHSULUIUJUMUNVOVPURV
      NCUOUPUQ $.

    $( A sigma-algebra contains the empty set.  (Contributed by Thierry Arnoux,
       4-Sep-2016.) $)
    0elsiga $p |- ( S e. U. ran sigAlgebra -> (/) e. S ) $=
      ( vo vx csiga crn cuni wcel cv cpw wss cdif wral com wbr wi w3a wa wex c0
      cdom cvv isrnsiga simprbi 3simpa adantl eximi difeq2 syl6eq eleq1d rspcva
      weq difid exlimiv 3syl ) ADEFGZABHZIJZUPAGZUPCHZKZAGZCALZUSMTNUSFAGOCAILZ
      PZQZBRZURVBQZBRSAGZUOAUAGVFCABUBUCVEVGBVDVGUQURVBVCUDUEUFVGVHBVAVHCUPACBU
      KZUTSAVIUTUPUPKSUSUPUPUGUPULUHUIUJUMUN $.

    $d x A $.
    $( A sigma-algebra contains its base universe set.  (Contributed by Thierry
       Arnoux, 26-Oct-2016.) $)
    baselsiga $p |- ( S e. ( sigAlgebra ` A ) -> A e. S ) $=
      ( vx cvv wcel csiga cfv elex wa cv cdif wral com cdom wbr cuni wi cpw wss
      w3a issiga simplbda simp1d mpancom ) BDEZBAFGZEZABEZBUFHUEUGIUHACJZKBECBL
      ZUIMNOUIPBEQCBRLZUEUGBARSUHUJUKTCBAUAUBUCUD $.

    $( A sigma-algebra is a set of subset of the base set.  (Contributed by
       Thierry Arnoux, 18-Jan-2017.) $)
    sigasspw $p |- ( S e. ( sigAlgebra ` A ) -> S C_ ~P A ) $=
      ( vx csiga cfv wcel cpw wss cv cdif wral com cdom wbr cuni wi w3a wa elex
      cvv issiga biimpa mpancom simpld ) BADEZFZBAGHZABFACIZJBFCBKUHLMNUHOBFPCB
      GKQZBTFZUFUGUIRZBUESUJUFUKCBAUAUBUCUD $.

    $( A sigma-algebra is closed under countable union.  (Contributed by
       Thierry Arnoux, 26-Dec-2016.) $)
    sigaclcu $p |- ( ( S e. U. ran sigAlgebra /\ A e. ~P S /\ A ~<_ om )
      -> U. A e. S ) $=
      ( vx vo csiga crn cuni wcel cpw com cdom wbr w3a cv wi wral simp2 cdif wa
      wss wex cvv isrnsiga simprbi simpr3 exlimiv syl 3ad2ant1 simp3 wceq breq1
      unieq eleq1d imbi12d rspcv syl3c ) BEFGHZABIZHZAJKLZMUSCNZJKLZVAGZBHZOZCU
      RPZUTAGZBHZUQUSUTQUQUSVFUTUQBDNZITZVIBHZVIVARBHCBPZVFMSZDUAZVFUQBUBHVNCBD
      UCUDVMVFDVJVKVLVFUEUFUGUHUQUSUTUIVEUTVHOCAURVAAUJZVBUTVDVHVAAJKUKVOVCVGBV
      AAULUMUNUOUP $.

    ${
      $d z x A $.  $d z B $.  $d k z S $.
      sigaclcuni.1 $e |- F/_ k A $.
      $( A sigma-algebra is closed under countable union: indexed union version
         (Contributed by Thierry Arnoux, 8-Jun-2017.) $)
      sigaclcuni $p |- ( ( S e. U. ran sigAlgebra /\ A. k e. A B e. S
                                         /\ A ~<_ om ) -> U_ k e. A B e. S ) $=
        ( vz csiga crn cuni wcel wral com cdom wbr wceq 3ad2ant2 wa eqeltrd syl
        wrex w3a ciun cv cab dfiun2g cpw simp1 wss r19.29 simpr simpl rexlimivw
        ex abssdv wb elpw2g mpbird abrexctf 3ad2ant3 sigaclcu syl3anc ) CGHIZJZ
        BCJZDAKZALMNZUAZDABUBZFUCZBOZDATZFUDZIZCVEVCVHVMOVFDFABCUEPVGVCVLCUFJZV
        LLMNZVMCJVCVEVFUGZVGVNVLCUHZVEVCVQVFVEVKFCVEVKVICJZVEVKQVDVJQZDATVRVDVJ
        DAUIVSVRDAVSVIBCVDVJUJVDVJUKRULSUMUNPVGVCVNVQUOVPVLCVBUPSUQVFVCVOVEDFAB
        EURUSVLCUTVAR $.
    $}

    $( A sigma-algebra is closed under finite union.  (Contributed by Thierry
       Arnoux, 28-Dec-2016.) $)
    sigaclfu $p |- ( ( S e. U. ran sigAlgebra /\ A e. ~P S /\ A e. Fin )
      -> U. A e. S ) $=
      ( cfn wcel csiga crn cuni cpw com cdom wbr csdm isfinite sdomdom sigaclcu
      sylbi syl3an3 ) ACDZBEFGDABHDAIJKZAGBDRAILKSAMAINPABOQ $.

    $d k x S $.
    $( A sigma-algebra is closed under countable union - indexing on ` NN `
       (Contributed by Thierry Arnoux, 29-Dec-2016.) $)
    sigaclcu2 $p |- ( ( S e. U. ran sigAlgebra /\ A. k e. NN A e. S )
      -> U_ k e. NN A e. S ) $=
      ( vx csiga crn cuni wcel cn wral wa ciun cv wceq wrex cab com cdom wbr wi
      dfiun2g adantl cpw simpl wss abid eleq1a ralimi r19.23v sylib imp adantll
      sylan2b ralrimiva nfcv dfss3f sylibr wb elpw2g adantr mpbird nnct abrexct
      nfab1 mp1i sigaclcu syl3anc eqeltrd ) BEFGZHZABHZCIJZKZCIALZDMZANZCIOZDPZ
      GZBVLVNVSNVJCDIABUAUBVMVJVRBUCHZVRQRSZVSBHVJVLUDVMVTVRBUEZVMVOBHZDVRJWBVM
      WCDVRVOVRHVMVQWCVQDUFVLVQWCVJVLVQWCVLVPWCTZCIJVQWCTVKWDCIABVOUGUHVPWCCIUI
      UJUKULUMUNDVRBVQDVDDBUOUPUQVJVTWBURVLVRBVIUSUTVAIQRSWAVMVBCDIAVCVEVRBVFVG
      VH $.

    $d k N $.
    $( A sigma-algebra is closed under finite union - indexing on
       ` ( 1 ..^ N ) ` (Contributed by Thierry Arnoux, 28-Dec-2016.) $)
    sigaclfu2 $p |- ( ( S e. U. ran sigAlgebra /\ A. k e. ( 1 ..^ N ) A e. S )
      -> U_ k e. ( 1 ..^ N ) A e. S ) $=
      ( csiga crn cuni wcel c1 cfzo co wral wa ciun cn cun wceq iuneq2i eqtri
      c0 cv cif cdif iunxun wss fzossnn undif mpbi iuneq1 iftrue eldifn iffalse
      ax-mp wn syl iun0 uneq12i 3eqtr3i un0 0elsiga wi simpr simpllr mpd ifclda
      simplll exp31 ralimdv2 imp sylan sigaclcu2 syldan syl5eqelr ) BEFGHZABHZC
      IDJKZLZMCVPANZCOCUAZVPHZATUBZNZBWBVRTPZVRCVPOVPUCZPZWANZCVPWANZCWDWANZPWB
      WCCVPWDWAUDWEOQZWFWBQVPOUEWIDUFVPOUGUHCWEOWAUIUMWGVRWHTCVPWAAVTATUJRWHCWD
      TNTCWDWATVSWDHVTUNZWATQVSOVPUKVTATULUORCWDUPSUQURVRUSSVNVQWABHZCOLZWBBHVN
      TBHZVQWLBUTWMVQWLWMVOWKCVPOWMVTVOVAZVSOHZWKWMWNMWOMZVTATBWPVTMVTVOWPVTVBW
      MWNWOVTVCVDWMWNWOWJVFVEVGVHVIVJWABCVKVLVM $.

    $d k M $.  $d k ph $.  $d x A $.
    sigaclcu3.1 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    sigaclcu3.2 $e |- ( ph -> ( N = NN \/ N = ( 1 ..^ M ) ) ) $.
    sigaclcu3.3 $e |- ( ( ph /\ k e. N ) -> A e. S ) $.
    $( A sigma-algebra is closed under countable or finite union.  (Contributed
       by Thierry Arnoux, 6-Mar-2017.) $)
    sigaclcu3 $p |- ( ph -> U_ k e. N A e. S ) $=
      ( cn wceq ciun wcel wa simpr iuneq1d wral adantr raleqdv mpbid c1 cfzo co
      csiga crn cuni ralrimiva sigaclcu2 syl2anc eqeltrd sigaclfu2 mpjaodan ) A
      FJKZDFBLZCMFUAEUBUCZKZAUMNZUNDJBLZCUQDFJBAUMOZPUQCUDUEUFMZBCMZDJQZURCMAUT
      UMGRUQVADFQZVBAVCUMAVADFIUGZRUQVADFJUSSTBCDUHUIUJAUPNZUNDUOBLZCVEDFUOBAUP
      OZPVEUTVADUOQZVFCMAUTUPGRVEVCVHAVCUPVDRVEVADFUOVGSTBCDEUKUIUJHUL $.
  $}

  ${
    $d o x S $.  $d x O $.
    $( Property of being a sigma-algebra with a given base set, noting that the
       base set of a sigma algebra is actually its union set.  (Contributed by
       Thierry Arnoux, 24-Sep-2016.)  (Revised by Thierry Arnoux,
       23-Oct-2016.) $)
    issgon $p |- ( S e. ( sigAlgebra ` O ) <->
      ( S e. U. ran sigAlgebra /\ O = U. S ) ) $=
      ( vx vo csiga wcel cuni wceq wa elex cpw wss cdif wral w3a elpwuni biimpa
      cv ancom eqcom cfv crn fvssunirn sseli cvv com cdom wbr wi issiga 3imtr4i
      3ad2antr1 syl6bi mpcom jca wex isrnsiga simprbi pweq sseq2d difeq1 eleq1d
      wb eleq1 ralbidv 3anbi12d anbi12d syl ibi exlimiv biimprd pwuni syl5sseqr
      simprd jctild anim2d biimpar syl56 impcom impbii ) ABEUAZFZAEUBGZFZBAGZHZ
      IWBWDWFWAWCAEBUCUDAUEFZWBWFAWAJWGWBABKZLZBAFZBCRZMZAFZCANZWKUFUGUHWKGAFUI
      CAKNZOZIZWFCABUJZWIWNWJWFWOWJWIIWEBHZWIWJIWFWJWIWSABPQWIWJSBWETUKULUMUNUO
      WFWDWBWDWGWEAFZWEWKMZAFZCANZWOOZIWFWGWQIWBWDWGXDAWCJWDAWEKZLZXDWDADRZKZLZ
      XGAFZXGWKMZAFZCANZWOOZIZDUPZXFXDIZWDWGXPCADUQURXOXQDXOXQXOXGWEHZXOXQVCXIX
      MXJXRWOXJXIIWEXGHZXIXJIXRXJXIXSAXGPQXIXJSXGWETUKULXRXIXFXNXDXRXHXEAXGWEUS
      UTXRXJWTXMXCWOXGWEAVDXRXLXBCAXRXKXAAXGWEWKVAVBVEVFVGVHVIVJVHVNUOWFXDWQWGW
      FXDWPWIWFWPXDWFWJWTWNXCWOBWEAVDWFWMXBCAWFWLXAABWEWKVAVBVEVFVKWFXEAWHAVLBW
      EUSVMVOVPWGWBWQWRVQVRVSVT $.
  $}

  ${
    $( A sigma alebra is a sigma on its union set.  (Contributed by Thierry
       Arnoux, 6-Jun-2017.) $)
    sgon $p |- ( S e. U. ran sigAlgebra -> S e. ( sigAlgebra ` U. S ) ) $=
      ( csiga crn cuni wcel wceq cfv eqid wa issgon biimpri mpan2 ) ABCDEZADZNF
      ZANBGEZNHPMOIANJKL $.
  $}

  ${
    $( An element of a sigma-algebra is a subset of the base set.  (Contributed
       by Thierry Arnoux, 6-Jun-2017.) $)
    elsigass $p |- ( ( S e. U. ran sigAlgebra /\ A e. S ) -> A C_ U. S ) $=
      ( csiga crn cuni wcel wa cpw cfv wss sgon sigasspw syl sselda elpwid ) BC
      DEFZABFGABEZPBQHZAPBQCIFBRJBKQBLMNO $.
  $}

  ${
    $( Dropping the base information off a sigma-algebra.  (Contributed by
       Thierry Arnoux, 13-Feb-2017.) $)
    elrnsiga $p |- ( S e. ( sigAlgebra ` O ) -> S e. U. ran sigAlgebra ) $=
      ( csiga cfv crn cuni fvssunirn sseli ) BCDCEFACBGH $.
  $}

  ${
    $d x S $.
    $( The property of being a sigma algebra, universe is the union set.
       (Contributed by Thierry Arnoux, 11-Nov-2016.) $)
    isrnsigau $p |- ( S e. U. ran sigAlgebra -> ( S C_ ~P U. S /\ ( U. S e. S
      /\ A. x e. S ( U. S \ x ) e. S
      /\ A. x e. ~P S ( x ~<_ om -> U. x e. S ) ) ) ) $=
      ( csiga crn cuni wcel cfv cpw wss cv cdif wral com cdom wbr wi w3a wa cvv
      sgon wb elex issiga syl mpbid ) BCDEZFZBBEZCGFZBUHHIUHBFUHAJZKBFABLUJMNOU
      JEBFPABHLQRZBTUGBSFUIUKUABUFUBABUHUCUDUE $.

    $( A sigma-algebra contains its universe set.  (Contributed by Thierry
       Arnoux, 13-Feb-2017.)  (Shortened by Thierry Arnoux, 6-Jun-2017.) $)
    unielsiga $p |- ( S e. U. ran sigAlgebra -> U. S e. S ) $=
      ( csiga crn cuni wcel cfv sgon baselsiga syl ) ABCDEAADZBFEJAEAGJAHI $.
  $}

  ${
    $d o x y $.
    $( Lebesgue-measurable subsets of ` RR ` form a sigma-algebra (Contributed
       by Thierry Arnoux, 10-Sep-2016.)  (Revised by Thierry Arnoux,
       24-Oct-2016.) $)
    dmvlsiga $p |- dom vol e. ( sigAlgebra ` RR ) $=
      ( vx vy cvol cdm cr csiga cfv wcel cpw wss cv cdif wral com cdom wbr cuni
      wi rgen cn w3a pwssb mblss mprgbir rembl cmmbl ciun nnenom ensymi domentr
      cen mpan2 elpwi dfss3 sylib iunmbl2 syl2anr uniiun eleq1i syl6ibr 3pm3.2i
      ex cvv wa wb reex pwex ssexi issiga ax-mp mpbir2an ) CDZEFGHZVLEIZJZEVLHZ
      EAKZLVLHZAVLMZVQNOPZVQQZVLHZRZAVLIZMZUAZVOVQEJAVLAVLEUBVQUCUDZVPVSWEUEVRA
      VLVQUFSWCAWDVQWDHZVTBVQBKZUGZVLHZWBWHVTWKVTVQTOPZWIVLHBVQMZWKWHVTNTUKPWLT
      NUHUIVQNTUJULWHVQVLJWMVQVLUMBVQVLUNUOVQWIBUPUQVBWAWJVLBVQURUSUTSVAVLVCHVM
      VOWFVDVEVLVNEVFVGWGVHAVLEVIVJVK $.
  $}

  ${
    $d x O $.  $d x V $.
    $( Any power set forms a sigma-algebra.  (Contributed by Thierry Arnoux,
       13-Sep-2016.)  (Revised by Thierry Arnoux, 24-Oct-2016.) $)
    pwsiga $p |- ( O e. V -> ~P O e. ( sigAlgebra ` O ) ) $=
      ( vx wcel cpw csiga cfv wss cdif wral com cdom wbr cuni w3a ssid ralrimiv
      cv wi a1d a1i pwidg difss elpw2g mpbiri sspwuni uniex bitr4i biimpi elpwi
      vex elpw imim1i mp1i 3jca cvv wa wb pwexg issiga syl mpbir2and ) ABDZAEZA
      FGDZVDVDHZAVDDZACRZIZVDDZCVDJZVHKLMZVHNZVDDZSZCVDEZJZOZVFVCVDPUAVCVGVKVQA
      BUBVCVJCVDVCVJVHVDDVCVJVIAHAVHUCVIABUDUETQVCVOCVPVHVDHZVOSVHVPDZVOSVCVSVN
      VLVSVNVSVMAHVNVHAUFVMAVHCUKUGULUHUITVTVSVOVHVDUJUMUNQUOVCVDUPDVEVFVRUQURA
      BUSCVDAUTVAVB $.
  $}

  ${
    $d x O $.
    $( The smallest possible sigma-algebra containing ` O ` (Contributed by
       Thierry Arnoux, 13-Sep-2016.) $)
    prsiga $p |- ( O e. V -> { (/) , O } e. ( sigAlgebra ` O ) ) $=
      ( vx wcel c0 cpr cpw cdif wral cuni 0ex cvv wceq eleq1d ralprg cun pm3.2i
      wa wb unieq wss cv com cdom wbr wi w3a csiga cfv 0elpw pwidg prssi prid2g
      sylancr dif0 syl5eqel difid prid1 a1i difeq2 mpan mpbir2and eqeltri unisn
      uni0 snex mp1i mpbiri unisng eqeltrd uniprg uncom eqtri syl6eq prex ralun
      csn un0 syl2anc pwpr raleqi sylibr ax-1 ralimi 3jca issiga ax-mp sylanbrc
      syl ) ABDZEAFZAGZUAZAWKDZACUBZHZWKDZCWKIZWOUCUDUEZWOJZWKDZUFZCWKGZIZUGZWK
      AUHUIDZWJEWLDAWLDWMAUJABUKEAWLULUNWJWNWRXDEABUMZWJWRAEHZWKDZAAHZWKDZWJXHA
      WKAUOXGUPWJXJEWKAUQEWKDWJEAKURZUSUPELDZWJWRXIXKRSKWQXIXKCEALBWOEMZWPXHWKW
      OEAUTNWOAMWPXJWKWOAAUTNOVAVBWJXACXCIZXDWJXACEEVQZFZAVQZWKFZPZIZXOWJXACXQI
      ZXACXSIZYAWJYBEJZWKDZXPJZWKDZRZYEYGYDEWKVEXLVCYFEWKEKVDXLVCQXMXPLDZRYBYHS
      WJXMYIKEVFQXAYEYGCEXPLLXNWTYDWKWOETNWOXPMWTYFWKWOXPTNOVGVHWJYCXRJZWKDZWKJ
      ZWKDZWJYJAWKABVIXGVJWJYLAWKWJYLEAPZAXMWJYLYNMKEALBVKVAYNAEPAEAVLAVRVMVNXG
      VJXRLDZWKLDZRYCYKYMRSWJYOYPAVFEAVOZQXAYKYMCXRWKLLWOXRMWTYJWKWOXRTNWOWKMWT
      YLWKWOWKTNOVGVBXACXQXSVPVSXACXCXTEAVTWAWBXAXBCXCXAWSWCWDWIWEYPXFWMXERSYQC
      WKAWFWGWH $.
  $}

  ${
    $d x y z A $.  $d x y z S $.
    $( A sigma-algebra is closed under countable intersection.  Deduction
       version.  (Contributed by Thierry Arnoux, 19-Sep-2016.) $)
    sigaclci $p |- ( ( ( S e. U. ran sigAlgebra /\ A e. ~P S ) /\
      ( A ~<_ om /\ A =/= (/) ) ) -> |^| A e. S ) $=
      ( vz vx vy cuni wcel wa com cdom wbr cv cdif wral wi wss adantr wceq syl
      wb csiga crn cpw wne cint ciun w3a isrnsigau simprd simp2d wrex cab elpwi
      ssrexv ss2abdv uniiunlem mpbid sylan9ssr cvv abrexexg elpwg adantl mpbird
      c0 simp3d jca abrexdom2jm domtr sylan breq1 eleq1d imbi12d rspcva sylsyld
      ex unieq ssralv sylc dfiun2g eleq1 3syl sylibrd difeq2 rspccv adantrd imp
      simpr pwuni syl6ss iundifdifd adantld syl6 ) BUAUBFGZABUCZGZHZAIJKZAVDUDZ
      HZHAUEZBGZBFZCAXBCLZMZUFZMZBGZWPWSXGWPWQXGWRWPXBDLZMZBGZDBNZWQXEBGZXGWMXK
      WOWMXBBGZXKXHIJKZXHFZBGZOZDWNNZWMBXBUCZPZXMXKXRUGDBUHUIZUJQWPWQELXDRZCAUK
      ZEULZFZBGZXLWPYDWNGZXRHWQYDIJKZYFWPYGXRWPYGYDBPZWOWMYDYBCBUKZEULZBWOYCYJE
      WOABPZYCYJOABUMZYBCABUNSUOWMXDBGZCBNZYKBPZWMXMYOXCIJKXCFBGOCWNNZWMXTXMYOY
      QUGCBUHUIUJZWMYOYOYPTYRCEBXDBBUPSUQURWOYGYITZWMWOYDUSGYSCEAXDWNUTYDBUSVAS
      VBVCWMXRWOWMXMXKXRYAVEQVFWOWQYHOWMWOWQYHWOYDAJKWQYHECAXDWNVGYDAIVHVIVOVBX
      QYHYFODYDWNXHYDRZXNYHXPYFXHYDIJVJYTXOYEBXHYDVPVKVLVMVNWPYNCANZXEYERXLYFTW
      PYLYOUUAWOYLWMYMVBWMYOWOYRQYNCABVQVRCEAXDBVSXEYEBVTWAWBXJXGDXEBXHXERXIXFB
      XHXEXBWCVKWDVNWEWFWPWSXAXGTZWPWSWTXFRZUUBWPWRUUCWQWPWOAXSPWRUUCOWMWOWGWOA
      BXSYMBWHWICAXBWJWAWKWTXFBVTWLWFVC $.
  $}

  ${
    $d x S $.  $d x B $.
    $( A sigma algebra is closed under set difference.  (Contributed by Thierry
       Arnoux, 13-Sep-2016.) $)
    difelsiga $p |- ( ( S e. U. ran sigAlgebra /\ A e. S /\ B e. S ) ->
      ( A \ B ) e. S ) $=
      ( vx csiga crn cuni wcel w3a cdif cpr cint wss wceq wral com cdom wbr cpw
      syl2anc cin simp2 elssuni difin2 cv isrnsigau simprd simp2d difeq2 eleq1d
      3syl wi rspccva sylan 3adant2 intprg eqtr4d c0 wne simp1 prex elpw sylibr
      prssi prct prnzg syl sigaclci syl22anc eqeltrd ) CEFGHZACHZBCHZIZABJZCGZB
      JZAKZLZCVNVOVQAUAZVSVNVLAVPMVOVTNVKVLVMUBZACUCABVPUDUKVNVQCHZVLVSVTNVKVMW
      BVLVKVPDUEZJZCHZDCOZVMWBVKVPCHZWFWCPQRWCGCHULDCSZOZVKCVPSMWGWFWIIDCUFUGUH
      WEWBDBCWCBNWDVQCWCBVPUIUJUMUNUOZWAVQACCUPTUQVNVKVRWHHZVRPQRZVRURUSZVSCHVK
      VLVMUTVNVRCMZWKVNWBVLWNWJWAVQACVDTVRCVQAVAVBVCVNWBVLWLWJWAVQACCVETVNWBWMW
      JVQACVFVGVRCVHVIVJ $.
  $}

  ${
    $d x A $.  $d x B $.  $d x S $.
    $( A sigma algebra is closed under set union.  (Contributed by Thierry
       Arnoux, 13-Dec-2016.) $)
    unelsiga $p |- ( ( S e. U. ran sigAlgebra /\ A e. S /\ B e. S ) ->
      ( A u. B ) e. S ) $=
      ( vx csiga crn cuni wcel w3a cpr cun wceq uniprg 3adant1 com cdom wbr cpw
      wi wral cv cdif isrnsigau simprd simp3d 3ad2ant1 prct prelpwi breq1 unieq
      wss wa eleq1d imbi12d rspcv syl mp2d eqeltrrd ) CEFGHZACHZBCHZIZABJZGZABK
      ZCUTVAVDVELUSABCCMNVBDUAZOPQZVFGZCHZSZDCRZTZVCOPQZVDCHZUSUTVLVAUSCGZCHZVO
      VFUBCHDCTZVLUSCVORUKVPVQVLIDCUCUDUEUFUTVAVMUSABCCUGNUTVAVLVMVNSZSZUSUTVAU
      LVCVKHVSABCUHVJVRDVCVKVFVCLZVGVMVIVNVFVCOPUIVTVHVDCVFVCUJUMUNUOUPNUQUR $.
  $}

  ${
    $( A sigma algebra is closed under set intersection.  (Contributed by
       Thierry Arnoux, 13-Dec-2016.) $)
    inelsiga $p |- ( ( S e. U. ran sigAlgebra /\ A e. S /\ B e. S ) ->
      ( A i^i B ) e. S ) $=
      ( csiga crn cuni wcel w3a cin cdif dfin4 difelsiga syld3an3 syl5eqel ) CD
      EFGZACGZBCGZHABIAABJZJZCABKOPQRCGSCGABCLARCLMN $.
  $}

  ${
    $d x A $.  $d x S $.
    $( Building a sigma algebra from intersections with a given set.
       (Contributed by Thierry Arnoux, 26-Dec-2016.) $)
    sigainb $p |- ( ( S e. U. ran sigAlgebra /\ A e. S ) ->
      ( S i^i ~P A ) e. ( sigAlgebra ` A ) ) $=
      ( vx csiga cuni wcel wa cpw wss wral simpr syl elin sylanbrc simplr elpwg
      syl3anc ralrimiva sstr mpan2 crn cin cvv cdif com cdom wbr w3a cfv inex1g
      cv wi adantr inss2 a1i pwidg simpll inss1 sseldi difelsiga mpbiri simplll
      difss elpwi 3syl biimpar syl2anc sigaclcu sspwuni uniex elpw bitr4i sylib
      vex ex 3jca issiga syl12anc ) BDUAEZFZABFZGZBAHZUBZUCFZWDWCIZAWDFZACUKZUD
      ZWDFZCWDJZWHUEUFUGZWHEZWDFZULZCWDHZJZUHZWDADUIFZVTWEWABWCVSUJUMWFWBBWCUNZ
      UOWBWGWKWQWBWAAWCFZWGVTWAKZWBWAXAXBABUPLABWCMNWBWJCWDWBWHWDFZGZWIBFZWIWCF
      ZWJXDVTWAWHBFXEVTWAXCUQVTWAXCOXDWDBWHBWCURZWBXCKUSAWHBUTQZXDXEXFXHXEXFWIA
      IAWHVCWIABPVALWIBWCMNRWBWOCWPWBWHWPFZGZWLWNXJWLGZWMBFZWMWCFZWNXKVTWHBHFZW
      LXLVTWAXIWLVBXKXIWHBIZXNWBXIWLOZXKXIWHWDIZXOXPWHWDVDZXQWDBIXOXGWHWDBSTVEX
      IXNXOWHBWPPVFVGXJWLKWHBVHQXKWHWCIZXMXKXIXQXSXPXRXQWFXSWTWHWDWCSTVEXSWMAIX
      MWHAVIWMAWHCVNVJVKVLVMWMBWCMNVORVPWEWSWFWRGCWDAVQVFVR $.
  $}

  ${
    $d s x A $.  $d s x O $.
    $( The intersection of a collection of sigma-algebras of same base is a
       sigma-algebra.  (Contributed by Thierry Arnoux, 27-Dec-2016.) $)
    insiga $p |- ( ( A =/= (/) /\ A e. ~P ( sigAlgebra ` O ) )
      -> |^| A e. ( sigAlgebra ` O ) ) $=
      ( vx vs csiga cpw wcel wa cvv wss cv adantr simpr syl wb ralrimiva elintg
      wral mpbird jca c0 wne cfv cint cdif com cdom wbr cuni w3a intex intssuni
      wi biimpi elpwi sigasspw vex elpw sylibr ssriv syl6ss sspwuni sylib sstrd
      simplr elelpwi syl2anc issiga ax-mp simprd simp1d wex n0 ex eximdv elfvex
      mpd exlimiv simpll elinti adantll simp2d r19.21bi difexg simplll sylan9ss
      simpllr intss1 sylancom simp3d sylc uniexg ad2antlr 3jca biimpar syl12anc
      imp ) AUAUBZABEUCZFGZHZAUDZIGZXBBFZJZBXBGZBCKZUEZXBGZCXBRZXGUFUGUHZXGUIZX
      BGZUMZCXBFZRZUJZXBWSGZWRXCWTWRXCAUKUNLXAXBAUIZXDWRXBXSJWTAULLXAAXDFZJZXSX
      DJXAWTYAWRWTMWTAWSXTAWSUODWSXTDKZWSGZYBXDJZYBXTGBYBUPYBXDDUQZURUSUTVANAXD
      VBVCVDXAXFXJXPXAXFBYBGZDARZXAYFDAXAYBAGZHZYFXHYBGZCYBRZXKXLYBGZUMZCYBFZRZ
      YIYDYFYKYOUJZYIYCYDYPHZYIYHWTYCXAYHMWRWTYHVEYBAWSVFVGZYBIGYCYQOYECYBBVHVI
      VCVJZVKPXABIGZXFYGOXAYCDVLZYTXAYHDVLZUUAWRUUBWTWRUUBDAVMUNLXAYHYCDXAYHYCY
      RVNVOVQYCYTDYBBEVPVRNZDBAIQNSXAXICXBXAXGXBGZHZXIYJDARZUUEYJDAUUEYHHZYIXGY
      BGZYJUUGXAYHXAUUDYHVSUUEYHMTUUDYHUUHXAUUDYHUUHXGAYBVTWQWAYIYJCYBYIYFYKYOY
      SWBWCVGPUUEXHIGZXIUUFOXAUUIUUDXAYTUUIUUCBXGIWDNLDXHAIQNSPXAXNCXOXAXGXOGZH
      ZXKXMUUKXKHZXMYLDARZUULYLDAUULYHHZYIXGYNGZHXKYLUUNYIUUOUUNXAYHXAUUJXKYHWE
      UULYHMTUULYHUUJUUOXAUUJXKYHWGUUJYHHXGYBJUUOUUJYHXGXBYBXGXBUOYBAWHWFXGYBCU
      QURUSWITUUKXKYHVEYIYMCYNYIYFYKYOYSWJWCWKPUULXLIGZXMUUMOUUJUUPXAXKXGXOWLWM
      DXLAIQNSVNPWNXCXRXEXQHCXBBVHWOWP $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Generated Sigma-Algebra
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c sigaGen $.
  $( Extend class notation to include the sigma-algebra generator. $)
  csigagen $a class sigaGen $.

  ${
    $d s x $.
    $( Define the sigma algebra generated by a given collection of sets as the
       intersection of all sigma algebra containing that set.  (Contributed by
       Thierry Arnoux, 27-Dec-2016.) $)
    df-sigagen $a |- sigaGen = ( x e. _V |->
      |^| { s e. ( sigAlgebra ` U. x ) | x C_ s } ) $.
  $}

  ${
    $d s x A $.  $d x V $.
    $( Value of the generated sigma-algebra.  (Contributed by Thierry Arnoux,
       27-Dec-2016.) $)
    sigagenval $p |- ( A e. V -> ( sigaGen ` A ) =
      |^| { s e. ( sigAlgebra ` U. A ) | A C_ s } ) $=
      ( vx wcel cv wss cuni cfv crab cint cvv csigagen cmpt wceq df-sigagen a1i
      csiga unieq syl fveq2d sseq1 rabeqbidv inteqd adantl c0 wne cpw wa uniexg
      elex pwsiga pwuni jctir sseq2 elrab sylibr ne0i intex sylib fvmptd ) ABEZ
      DADFZCFZGZCVCHZRIZJZKZAVDGZCAHZRIZJZKZLMLMDLVINOVBDCPQVCAOZVIVNOVBVOVHVMV
      OVEVJCVGVLVOVFVKRVCASUAVCAVDUBUCUDUEABUKVBVMUFUGZVNLEVBVKUHZVMEZVPVBVQVLE
      ZAVQGZUIVRVBVSVTVBVKLEVSABUJVKLULTAUMUNVJVTCVQVLVDVQAUOUPUQVMVQURTVMUSUTV
      A $.
  $}

  ${
    $d s A $.
    $( A generated sigma algebra is a sigma algebra.  (Contributed by Thierry
       Arnoux, 27-Dec-2016.) $)
    sigagensiga $p |- ( A e. V -> ( sigaGen ` A ) e. ( sigAlgebra ` U. A ) ) $=
      ( vs wcel csigagen cfv cv wss cuni csiga crab cint sigagenval wne cpw cvv
      c0 fvex syl6eqelr sylibr intex ssrab2 a1i elpw2 insiga syl2anc eqeltrd )
      ABDZAEFZACGHZCAIZJFZKZLZULABCMZUHUMQNZUMULODZUNULDUHUNPDUPUHUNUIPUOAERSUM
      UATUHUMULHZUQURUHUJCULUBUCUMULUKJRUDTUMUKUEUFUG $.
  $}

  ${
    sgsiga.1 $e |- ( ph -> A e. V ) $.
    $( A generated sigma algebra is a sigma algebra.  (Contributed by Thierry
       Arnoux, 30-Jan-2017.) $)
    sgsiga $p |- ( ph -> ( sigaGen ` A ) e. U. ran sigAlgebra ) $=
      ( wcel csigagen cfv cuni csiga crn sigagensiga elrnsiga 3syl ) ABCEBFGZBH
      ZIGENIJHEDBCKNOLM $.
  $}

  $( The sigma algebra generated by a collection ` A ` is a sigma algebra on
     ` U. A ` .  (Contributed by Thierry Arnoux, 27-Dec-2016.) $)
  unisg $p |- ( A e. V -> U. ( sigaGen ` A ) = U. A ) $=
    ( wcel cuni csigagen cfv csiga crn wceq wa sigagensiga issgon simprd eqcomd
    sylib ) ABCZADZAEFZDZPRGHDCZQSIZPRQGFCTUAJABKRQLOMN $.

  ${
    $d j s $.
    $( A sigma algebra can be generated from any set.  (Contributed by Thierry
       Arnoux, 21-Jan-2017.) $)
    dmsigagen $p |- dom sigaGen = _V $=
      ( vj vs cvv cv wss cuni csiga cfv crab cint csigagen c0 wne wcel wrex cpw
      vex uniex pwsiga ax-mp pwuni sseq2 rspcev mp2an rabn0 mpbir intex dmmpti
      mpbi df-sigagen ) ACADZBDZEZBUKFZGHZIZJZKUPLMZUQCNURUMBUOOZUNPZUONZUKUTEZ
      USUNCNVAUKAQRUNCSTUKUAUMVBBUTUOULUTUKUBUCUDUMBUOUEUFUPUGUIABUJUH $.
  $}

  ${
    $d s A $.
    $( A set is a subset of the sigma algebra it generates.  (Contributed by
       Thierry Arnoux, 24-Jan-2017.) $)
    sssigagen $p |- ( A e. V -> A C_ ( sigaGen ` A ) ) $=
      ( vs wcel cv wss cuni cfv crab cint csigagen ssintub sigagenval syl5sseqr
      csiga ) ABDACEFCAGOHZIJAAKHCAPLABCMN $.
  $}

  $( A subset of the generating set is also a subset of the generated sigma
     algebra.  (Contributed by Thierry Arnoux, 22-Sep-2017.) $)
  sssigagen2 $p |- ( ( A e. V /\ B C_ A ) -> B C_ ( sigaGen ` A ) ) $=
    ( wcel wss wa csigagen cfv simpr sssigagen adantr sstrd ) ACDZBAEZFBAAGHZMN
    IMAOENACJKL $.

  ${
    $d s A $.
    $( Any element of set is also an element of the sigma algebra that set
       generates.  (Contributed by Thierry Arnoux, 27-Mar-2017.) $)
    elsigagen $p |- ( ( A e. V /\ B e. A ) -> B e. ( sigaGen ` A ) ) $=
      ( wcel csigagen cfv sssigagen sselda ) ACDAAEFBACGH $.
  $}

  $( Any countable union of elements of a set is also in the sigma algebra that
     set generates.  (Contributed by Thierry Arnoux, 17-Sep-2017.) $)
  elsigagen2 $p |- ( ( A e. V /\ B C_ A /\ B ~<_ om )
                                      -> U. B e. ( sigaGen ` A ) ) $=
    ( wcel wss com cdom wbr w3a csigagen cfv csiga crn cuni cpw simp1 sssigagen
    sgsiga 3syl cvv sspwb biimpi simp2 simp3 ctex elpwg mpbird sigaclcu syl3anc
    wb sseldd ) ACDZBAEZBFGHZIZAJKZLMNDBUPOZDUNBNUPDUOACULUMUNPZRUOAOZUQBUOULAU
    PEZUSUQEZURACQUTVAAUPUAUBSUOBUSDZUMULUMUNUCUOUNBTDVBUMUJULUMUNUDZBUEBATUFSU
    GUKVCBUPUHUI $.

  ${
    $d s A $.  $d s S $.
    $( The generated sigma-algebra is a subset of all sigma algebra containing
       the generating set, i.e. the generated sigma-algebra is the smallest
       sigma algebra containing the generating set, here ` B ` .  (Contributed
       by Thierry Arnoux, 4-Jun-2017.) $)
    sigagenss $p |- ( ( S e. ( sigAlgebra ` U. A ) /\ A C_ S ) ->
      ( sigaGen ` A ) C_ S ) $=
      ( vs cuni csiga cfv wcel wss wa csigagen cv crab cint cvv wceq sigagenval
      ssexg ancoms syl sseq2 intminss eqsstrd ) BADEFZGZABHZIZAJFZACKZHZCUCLMZB
      UFANGZUGUJOUEUDUKABUCQRANCPSUIUECBUCUHBATUAUB $.
  $}

  ${
    $d s A $.  $d s S $.
    $( Sufficient condition for inclusion of sigma algebra.  This is used to
       prove equality of sigma algebra.  (Contributed by Thierry Arnoux,
       10-Oct-2017.) $)
    sigagenss2 $p |- ( ( U. A = U. B /\ A C_ ( sigaGen ` B ) /\ B e. V ) ->
      ( sigaGen ` A ) C_ ( sigaGen ` B ) ) $=
      ( cuni wceq csigagen cfv wss wcel csiga sigagensiga 3ad2ant3 simp1 fveq2d
      w3a eleqtrrd simp2 sigagenss syl2anc ) ADZBDZEZABFGZHZBCIZOZUCTJGZIUDAFGU
      CHUFUCUAJGZUGUEUBUCUHIUDBCKLUFTUAJUBUDUEMNPUBUDUEQAUCRS $.
  $}

  $( The sigma-algebra generated by a sigma-algebra is itself.  (Contributed by
     Thierry Arnoux, 4-Jun-2017.) $)
  sigagenid $p |- ( S e. U. ran sigAlgebra -> ( sigaGen ` S ) = S ) $=
    ( csiga crn cuni wcel csigagen cfv wss sgon ssid sigagenss sssigagen eqssd
    sylancl ) ABCDZEZAFGZAPAADBGEAAHQAHAIAJAAKNAOLM $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     The Borel algebra on the real numbers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c BrSiga $.
  $( The Borel Algebra on real numbers, usually a gothic B $)
  cbrsiga $a class BrSiga $. $( Extend class notation with the Borel Algebra $)

  $( A Borel Algebra is defined as a sigma algebra generated by a topology.
     'The' Borel sigma algebra here refers to the sigma algebra generated by
     the topology of open intervals on real numbers.  The Borel algebra of a
     given topology ` J ` is the sigma-algebra generated by ` J ` ,
     ` ( sigaGen `` J ) ` , so there is no need to introduce a special constant
     function for Borel sigma Algebra.  (Contributed by Thierry Arnoux,
     27-Dec-2016.) $)
  df-brsiga $a |- BrSiga = ( sigaGen ` ( topGen ` ran (,) ) ) $.

  ${
    $d s x $.
    $( The Borel Algebra on real numbers is a Borel sigma algebra.
       (Contributed by Thierry Arnoux, 27-Dec-2016.) $)
    brsiga $p |- BrSiga e. ( sigaGen " Top ) $=
      ( vx vs cbrsiga cioo crn ctg csigagen ctop cima df-brsiga wcel retop wfun
      cfv cvv cv cuni csiga c0 mp2b cdm wi wss crab cint df-sigagen sigagensiga
      funmpt2 fvex elrnsiga 0elsiga elfvdm funfvima mp2an ax-mp eqeltri ) CDEZF
      NZGNZGHIZJURHKZUSUTKZLGMURGUAKZVAVBUBAOAPZBPUCBVDQRNUDUEGABUFUHUSREQKZSUS
      KVCUROKUSURQZRNKVEUQFUIUROUGUSVFUJTUSUKSURGULTHURGUMUNUOUP $.
  $}

  $( The Borel Algebra is a sigma algebra on the real numbers.  (Contributed by
     Thierry Arnoux, 27-Dec-2016.) $)
  brsigarn $p |- BrSiga e. ( sigAlgebra ` RR ) $=
    ( cioo crn ctg cfv csigagen cuni csiga cbrsiga cr cvv wcel fvex sigagensiga
    ax-mp df-brsiga uniretop fveq2i 3eltr4i ) ABZCDZEDZTFZGDZHIGDTJKUAUCKSCLTJM
    NOIUBGPQR $.

  $( The Borel Algebra is a set of subsets of the real numbers.  (Contributed
     by Thierry Arnoux, 19-Jan-2017.) $)
  brsigasspwrn $p |- BrSiga C_ ~P RR $=
    ( cbrsiga cr csiga cfv wcel cpw wss brsigarn sigasspw ax-mp ) ABCDEABFGHBAI
    J $.

  $( The union of the Borel Algebra is the set of real numbers.  (Contributed
     by Thierry Arnoux, 21-Jan-2017.) $)
  unibrsiga $p |- U. BrSiga = RR $=
    ( cioo crn ctg cfv csigagen cuni cbrsiga cr ctop wcel retop unisg df-brsiga
    wceq ax-mp unieqi uniretop 3eqtr4i ) ABCDZEDZFZSFZGFHSIJUAUBNKSILOGTMPQR $.

  ${
    $d x J $.
    $( A Borel Algebra contains all closed sets of its base topology.
       (Contributed by Thierry Arnoux, 27-Mar-2017.) $)
    cldssbrsiga $p |- ( J e. Top -> ( Clsd ` J ) C_ ( sigaGen ` J ) ) $=
      ( vx ctop wcel ccld cfv csigagen cv cuni cdif wss wceq cldss adantl dfss4
      wa eqid csiga adantr cvv sylib topopn difopn sylan crn sgsiga sigagensiga
      id elex baselsiga 3syl elsigagen difelsiga syl3anc syldan eqeltrrd ssrdv
      ex ) ACDZBAEFZAGFZUSBHZUTDZVBVADUSVCPZAIZVEVBJZJZVBVAVDVBVEKZVGVBLVCVHUSV
      BAVEVEQZMNVBVEOUAUSVCVFADZVGVADZUSVEADVCVJAVEVIUBVEVBAVEVIUCUDUSVJPVARUEI
      DZVEVADZVFVADVKUSVLVJUSACUSUHUFSUSVMVJUSATDVAVERFDVMACUIATUGVEVAUJUKSAVFC
      ULVEVFVAUMUNUOUPURUQ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
              Product Sigma-Algebra
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c sX $.

  $( Extend class notation with the product sigma-algebra operation. $)
  csx $a class sX $. $( Circled times operator $)

  ${
    $d s t x y $.
    $( Define the product sigma-algebra operation, analogue to ~ df-tx .
       (Contributed by Thierry Arnoux, 1-Jun-2017.) $)
    df-sx $a |- sX = ( s e. _V , t e. _V |->
             ( sigaGen ` ran ( x e. s , y e. t |-> ( x X. y ) ) ) ) $.
  $}

  ${
    $d s t x y S $.  $d s t x y T $.
    sxval.1 $e |- A = ran ( x e. S , y e. T |-> ( x X. y ) ) $.
    $( Value of the product sigma-algebra operation.  (Contributed by Thierry
       Arnoux, 1-Jun-2017.) $)
    sxval $p |- ( ( S e. V /\ T e. W ) -> ( S sX T ) = ( sigaGen ` A ) ) $=
      ( vs vt wcel csx cv cmpt2 crn csigagen cfv cvv wceq eqidd cxp mpt2eq123dv
      wa co elex id rneqd fveq2d df-sx fvex ovmpt2 syl2an fveq2i syl6eqr ) DFKZ
      EGKZUCDELUDZABDEAMBMUAZNZOZPQZCPQUODRKERKUQVASUPDFUEEGUEIJDERRABIMZJMZURN
      ZOZPQVALABDVCURNZOZPQVBDSZVEVGPVHVDVFVHABVBVCURDVCURVHUFVHVCTVHURTUBUGUHV
      CESZVGUTPVIVFUSVIABDVCURDEURVIDTVIUFVIURTUBUGUHABJIUIUTPUJUKULCUTPHUMUN
      $.
  $}

  ${
    $d x y S $.  $d x y T $.
    $( A product sigma-algebra is a sigma-algebra (Contributed by Thierry
       Arnoux, 1-Jun-2017.) $)
    sxsiga $p |- ( ( S e. U. ran sigAlgebra /\ T e. U. ran sigAlgebra ) ->
      ( S sX T ) e. U. ran sigAlgebra ) $=
      ( vx vy csiga crn cuni wcel wa csx co cv cxp cmpt2 cfv csigagen sxval cvv
      eqid syl txbasex sigagensiga eqeltrd elrnsiga ) AEFGZHBUEHIZABJKZCDABCLDL
      MNFZGZEOZHUGUEHUFUGUHPOZUJCDUHABUEUEUHSZQUFUHRHUKUJHCDUHABUEUEULUAUHRUBTU
      CUGUIUDT $.

    $( A product sigma-algebra is a sigma-algebra on the product of the bases.
       (Contributed by Thierry Arnoux, 1-Jun-2017.) $)
    sxsigon $p |- ( ( S e. U. ran sigAlgebra /\ T e. U. ran sigAlgebra ) ->
      ( S sX T ) e. ( sigAlgebra ` ( U. S X. U. T ) ) ) $=
      ( vx vy csiga crn cuni wcel wa csx co cxp wceq sxsiga cmpt2 csigagen eqid
      cfv cv cvv sxval unieqd mpt2exga rnexg unisg eqtrd txuni2 syl6reqr issgon
      3syl sylanbrc ) AEFGZHBULHIZABJKZULHAGZBGZLZUNGZMUNUQERHABNUMURCDABCSDSLZ
      OZFZGZUQUMURVAPRZGZVBUMUNVCCDVAABULULVAQZUAUBUMUTTHVATHVDVBMCDABUSULULUCU
      TTUDVATUEUJUFCDVAABUOUPVEUOQUPQUGUHUNUQUIUK $.
  $}

  $( The base set of a product sigma-algebra.  (Contributed by Thierry Arnoux,
     1-Jun-2017.) $)
  sxuni $p |- ( ( S e. U. ran sigAlgebra /\ T e. U. ran sigAlgebra ) ->
    ( U. S X. U. T ) = U. ( S sX T ) ) $=
    ( csiga crn cuni wcel wa csx co cxp cfv wceq sxsigon issgon simprbi syl ) A
    CDEZFBQFGABHIZAEBEJZCKFZSRELZABMTRQFUARSNOP $.

  ${
    $d x y A $.  $d x y B $.  $d x y S $.  $d x y T $.
    $( The cartesian product of two open sets is an element of the product
       sigma algebra.  (Contributed by Thierry Arnoux, 3-Jun-2017.) $)
    elsx $p |- ( ( ( S e. V /\ T e. W ) /\ ( A e. S /\ B e. T ) )
                                               -> ( A X. B ) e. ( S sX T ) ) $=
      ( vx vy wcel wa cxp cv cmpt2 cvv eqid syl adantr wceq wrex eqeq2d crn cfv
      csigagen csx co wss txbasex sssigagen xpeq1 xpeq2 rspc2ev mp3an3 wb xpexg
      elrnmpt2g mpbird adantl sseldd sxval eleqtrrd ) CEIDFIJZACIZBDIZJZJZABKZG
      HCDGLZHLZKZMZUAZUCUBZCDUDUEZVEVKVLVFVAVKVLUFZVDVAVKNIVNGHVKCDEFVKOZUGVKNU
      HPQVDVFVKIZVAVDVPVFVIRZHDSGCSZVBVCVFVFRZVRVFOVQVSVFAVHKZRGHABCDVGARVIVTVF
      VGAVHUITVHBRVTVFVFVHBAUJTUKULVDVFNIVPVRUMABCDUNGHCDVIVFVJNVJOUOPUPUQURVAV
      MVLRVDGHVKCDEFVOUSQUT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Measures
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c measures $. $( The class of the measures on a sigma-algebra $)

  $( Extend class notation to include the class of measures. $)
  cmeas $a class measures $.

  ${
    $d m x y $.  $d m s x S $.  $d s y $.
    $( Define a measure as a non-negative countably additive function over a
       sigma-algebra onto ` ( 0 [,] +oo ) ` (Contributed by Thierry Arnoux,
       10-Sep-2016.) $)
    df-meas $a |- measures = ( s e. U. ran sigAlgebra |->
      { m | ( m : s --> ( 0 [,] +oo ) /\ ( m ` (/) ) = 0
      /\ A. x e. ~P s ( ( x ~<_ om /\ Disj_ y e. x y )
      -> ( m ` U. x ) = sum* y e. x ( m ` y ) ) ) } ) $.

    $( The base set of a measure is a sigma-algebra.  (Contributed by Thierry
       Arnoux, 25-Dec-2016.) $)
    measbase $p |- ( M e. ( measures ` S ) -> S e. U. ran sigAlgebra ) $=
      ( vs vm vx vy cmeas cfv wcel cdm csiga crn cuni cv cc0 cpnf cicc wceq cab
      cvv elfvdm co wf c0 com cdom wbr wdisj wa cesum wi cpw wral w3a vex mapex
      ovex mp2an simp1 ss2abi ssexi df-meas dmmpti syl6eleq ) BAGHIAGJKLMZBAGUA
      CVECNZOPQUBZDNZUCZUDVHHORZENZUEUFUGFVKFNZUHUIVKMVHHVKVLVHHFUJRUKEVFULUMZU
      NZDSZGVOVIDSZVFTIVGTIVPTICUOOPQUQVFVGTTDUPURVNVIDVIVJVMUSUTVAEFDCVBVCVD
      $.

    $( The value of the ` measures ` function applied on a sigma-algebra.
       (Contributed by Thierry Arnoux, 17-Oct-2016.) $)
    measval $p |- ( S e. U. ran sigAlgebra -> ( measures ` S ) =
      { m | ( m : S --> ( 0 [,] +oo ) /\ ( m ` (/) ) = 0
      /\ A. x e. ~P S ( ( x ~<_ om /\ Disj_ y e. x y )
      -> ( m ` U. x ) = sum* y e. x ( m ` y ) ) ) } ) $=
      ( vs cuni wcel cc0 cpnf cicc cv wf cfv wceq cpw wral w3a cab cvv cmeas co
      csiga crn c0 com cdom wbr wdisj wa cesum wi simp1 ss2abi ovex mapex mpan2
      wss ssexg sylancr feq2 pweq raleqdv 3anbi13d abbidv df-meas fvmptg mpdan
      ) CUBUCFZGZCHIJUAZDKZLZUDVKMHNZAKZUEUFUGBVNBKZUHUIVNFVKMVNVOVKMBUJNUKZACO
      ZPZQZDRZSGZCTMVTNVIVTVLDRZUQWBSGZWAVSVLDVLVMVRULUMVIVJSGWCHIJUNCVJVHSDUOU
      PVTWBSURUSECEKZVJVKLZVMVPAWDOZPZQZDRVTVHSTWDCNZWHVSDWIWEVLWGVRVMWDCVJVKUT
      WIVPAWFVQWDCVAVBVCVDABDEVEVFVG $.
  $}

  ${
    $d x y m s M $.  $d x m s S $.
    $( The property of being a measure (Contributed by Thierry Arnoux,
       10-Sep-2016.)  (Revised by Thierry Arnoux, 19-Oct-2016.) $)
    ismeas $p |- ( S e. U. ran sigAlgebra -> ( M e. ( measures ` S ) <-> (
      M : S --> ( 0 [,] +oo ) /\ ( M ` (/) ) = 0
      /\ A. x e. ~P S ( ( x ~<_ om /\ Disj_ y e. x y )
      -> ( M ` U. x ) = sum* y e. x ( M ` y ) ) ) ) ) $=
      ( vs vm cuni wcel cvv cmeas cfv cc0 cpnf c0 wceq cv wa wi wb fveq1 crn co
      csiga cicc com cdom wbr wdisj cesum cpw wral w3a elex a1i simp1 ovex fex2
      wf 3expb expcom mpan2 syl5 df-meas cab vex mapex mp2an ss2abi ssexi simpr
      simpl feq12d eqeq1d adantl esumeq2sdv eqeq12d raleqbidv 3anbi123d abfmpel
      pweqd imbi2d ex pm5.21ndd ) CUCUAGZHZDIHZDCJKZHZCLMUDUBZDURZNDKZLOZAPZUEU
      FUGBWMBPZUHQZWMGZDKZWMWNDKZBUIZOZRZACUJZUKZULZWHWFRWEDWGUMUNXDWJWEWFWJWLX
      CUOWEWIIHZWJWFRLMUDUPZWJWEXEQWFWJWEXEWFCWIDWDIUQUSUTVAVBWEWFWHXDSEPZWIFPZ
      URZNXHKZLOZWOWPXHKZWMWNXHKZBUIZOZRZAXGUJZUKZULZXDEFCDJWDIABFEVCXSFVDXIFVD
      ZXGIHXEXTIHEVEXFXGWIIIFVFVGXSXIFXIXKXRUOVHVIXGCOZXHDOZQZXIWJXKWLXRXCYCXGC
      WIXHDYAYBVJYAYBVKZVLYBXKWLSYAYBXJWKLNXHDTVMVNYCXPXAAXQXBYCXGCYDVTYBXPXASY
      AYBXOWTWOYBXLWQXNWSWPXHDTYBWMXMWRBWNXHDTVOVPWAVNVQVRVSWBWC $.
  $}

  ${
    $d m s x y M $.
    $( The property of being a measure on an undefined base sigma algebra
       (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    isrnmeas $p |- ( M e. U. ran measures
      -> ( dom M e. U. ran sigAlgebra /\ ( M : dom M --> ( 0 [,] +oo )
      /\ ( M ` (/) ) = 0 /\ A. x e. ~P dom M ( ( x ~<_ om /\ Disj_ y e. x y )
      -> ( M ` U. x ) = sum* y e. x ( M ` y ) ) ) ) ) $=
      ( vs vm cmeas crn cuni wcel cv cc0 wf c0 cfv wceq wa wral w3a cvv fveq1
      cpnf cicc co com cdom wbr wdisj cesum cpw csiga wrex cdm df-meas cab ovex
      vex mapex mp2an simp1 ss2abi ssexi feq1 eqeq1d esumeq2sdv eqeq12d ralbidv
      wi imbi2d 3anbi123d abfmpunirn simprbi 3ad2ant1 adantl simpl eqeltrd feq2
      fdm biimpar syl2anc simp2 simp3 pweq raleqdv 3jca jca rexlimiva syl ) CFG
      HIZDJZKUAUBUCZCLZMCNZKOZAJZUDUEUFBWNBJZUGPZWNHZCNZWNWOCNZBUHZOZVGZAWIUIZQ
      ZRZDUJGHZUKZCULZXFIZXHWJCLZWMXBAXHUIZQZRZPZWHCSIXGWIWJEJZLZMXONZKOZWPWQXO
      NZWNWOXONZBUHZOZVGZAXCQZRZXEDECFXFABEDUMYEEUNXPEUNZWISIWJSIYFSIDUPKUAUBUO
      WIWJSSEUQURYEXPEXPXRYDUSUTVAXOCOZXPWKXRWMYDXDWIWJXOCVBYGXQWLKMXOCTVCYGYCX
      BAXCYGYBXAWPYGXSWRYAWTWQXOCTYGWNXTWSBWOXOCTVDVEVHVFVIVJVKXEXNDXFWIXFIZXEP
      ZXIXMYIXHWIXFXEXHWIOZYHWKWMYJXDWIWJCVQVLZVMYHXEVNVOXEXMYHXEXJWMXLXEYJWKXJ
      YKWKWMXDUSYJXJWKXHWIWJCVPVRVSWKWMXDVTXEYJXDXLYKWKWMXDWAYJXLXDYJXBAXKXCXHW
      IWBWCVRVSWDVMWEWFWG $.
  $}

  ${
    $d x y M $.  $d m s x y $.
    $( The domain of a measure is a sigma algebra.  (Contributed by Thierry
       Arnoux, 19-Feb-2018.) $)
    dmmeas $p |- ( M e. U. ran measures -> dom M e. U. ran sigAlgebra ) $=
      ( vx vy cmeas crn cuni wcel cdm csiga cc0 cpnf cicc co wf c0 cfv wceq com
      cv cdom wbr wdisj wa cesum wi cpw wral w3a isrnmeas simpld ) ADEFGAHZIEFG
      UKJKLMANOAPJQBSZRTUACULCSZUBUCULFAPULUMAPCUDQUEBUKUFUGUHBCAUIUJ $.

    $( The base set of a measure is its domain.  (Contributed by Thierry
       Arnoux, 25-Dec-2016.) $)
    measbasedom $p |- ( M e. U. ran measures
                                             <-> M e. ( measures ` dom M ) ) $=
      ( vx vy vs vm cmeas crn cuni wcel cfv cc0 wf c0 wceq cv cesum wi cpw wral
      w3a cdm cpnf cicc co com wbr wdisj wa csiga isrnmeas simprd simpld ismeas
      cdom wb syl mpbird wfun cab df-meas funmpt2 elunirn2 mpan impbii ) AFGHIZ
      AAUAZFJIZVEVGVFKUBUCUDZALMAJKNBOZUEUNUFCVICOZUGUHZVIHZAJVIVJAJCPNQBVFRSTZ
      VEVFUIGHZIZVMBCAUJZUKVEVOVGVMUOVEVOVMVPULBCVFAUMUPUQFURVGVEDVNDOZVHEOZLMV
      RJKNVKVLVRJVIVJVRJCPNQBVQRSTEUSFBCEDUTVAVFAFVBVCVD $.
  $}

  ${
    $d x y M $.  $d y S $.
    $( A measure is a function over its base to the positive extended reals.
       (Contributed by Thierry Arnoux, 26-Dec-2016.) $)
    measfrge0 $p |- ( M e. ( measures ` S ) -> M : S --> ( 0 [,] +oo ) ) $=
      ( vy vx cmeas cfv wcel cc0 cpnf cicc co wf c0 wceq cv com cdom wdisj cuni
      wbr wa cesum wi cpw wral w3a csiga crn wb measbase ismeas syl ibi simp1d
      ) BAEFGZAHIJKBLZMBFHNZCOZPQTDURDOZRUAURSBFURUSBFDUBNUCCAUDUEZUOUPUQUTUFZU
      OAUGUHSGUOVAUIABUJCDABUKULUMUN $.
  $}

  $( A measure is a function on its base sigma algebra.  (Contributed by
     Thierry Arnoux, 13-Feb-2017.) $)
  measfn $p |- ( M e. ( measures ` S ) -> M Fn S ) $=
    ( cmeas cfv wcel cc0 cpnf cicc co wf wfn measfrge0 ffn syl ) BACDEAFGHIZBJB
    AKABLAOBMN $.

  $( The values of a measure are positive extended reals.  (Contributed by
     Thierry Arnoux, 26-Dec-2016.) $)
  measvxrge0 $p |- ( ( M e. ( measures ` S ) /\ A e. S ) ->
    ( M ` A ) e. ( 0 [,] +oo ) ) $=
    ( cmeas cfv wcel cc0 cpnf cicc co measfrge0 ffvelrnda ) CBDEFBGHIJACBCKL $.

  ${
    $d x y M $.  $d y S $.
    $( The measure of the empty set is always zero.  (Contributed by Thierry
       Arnoux, 26-Dec-2016.) $)
    measvnul $p |- ( M e. ( measures ` S ) -> ( M ` (/) ) = 0 ) $=
      ( vy vx cmeas cfv wcel cc0 cpnf cicc co wf c0 wceq cv com cdom wdisj cuni
      wbr wa cesum wi cpw wral w3a csiga crn wb measbase ismeas syl ibi simp2d
      ) BAEFGZAHIJKBLZMBFHNZCOZPQTDURDOZRUAURSBFURUSBFDUBNUCCAUDUEZUOUPUQUTUFZU
      OAUGUHSGUOVAUIABUJCDABUKULUMUN $.
  $}

  $( A measure is non negative.  (Contributed by Thierry Arnoux,
     9-Mar-2018.) $)
  measge0 $p |- ( ( M e. ( measures ` S ) /\ A e. S ) -> 0 <_ ( M ` A ) ) $=
    ( cmeas cfv wcel wa cxr cc0 cle wbr cpnf co measvxrge0 elxrge0 sylib simprd
    cicc ) CBDEFABFGZACEZHFZITJKZSTILRMFUAUBGABCNTOPQ $.

  $( If the measure of a given set is bounded by zero, it is zero.
     (Contributed by Thierry Arnoux, 20-Oct-2017.) $)
  measle0 $p |- ( ( M e. ( measures ` S ) /\ A e. S /\ ( M ` A ) <_ 0 )
    -> ( M ` A ) = 0 ) $=
    ( cmeas cfv wcel cc0 cle wbr w3a wceq simp3 wa cpnf cicc measvxrge0 elxrge0
    cxr co sylib 3adant3 simprd wb simpld 0xr xrletri3 sylancl mpbir2and ) CBDE
    FZABFZACEZGHIZJZUKGKZULGUKHIZUIUJULLUMUKRFZUOUIUJUPUOMZULUIUJMUKGNOSFUQABCP
    UKQTUAZUBUMUPGRFUNULUOMUCUMUPUOURUDUEUKGUFUGUH $.

  ${
    $d x y A $.  $d x y M $.  $d y S $.
    $( The measure of a countable disjoint union is the sum of the measures.
       (Contributed by Thierry Arnoux, 26-Dec-2016.) $)
    measvun $p |- ( ( M e. ( measures ` S ) /\ A e. ~P S /\
      ( A ~<_ om /\ Disj_ x e. A x ) )
      -> ( M ` U. A ) = sum* x e. A ( M ` x ) ) $=
      ( vy cmeas cfv wcel com cdom wbr cv wdisj wa w3a cuni cesum wceq wi cc0
      cpw wral simp2 cpnf cicc co wf c0 csiga crn wb measbase ismeas syl simp3d
      3ad2ant1 simp3 breq1 disjeq1 anbi12d unieq fveq2d esumeq1 eqeq12d imbi12d
      ibi rspcv syl3c ) DCFGHZBCUAZHZBIJKZABALZMZNZOVKELZIJKZAVPVMMZNZVPPZDGZVP
      VMDGZAQZRZSZEVJUBZVOBPZDGZBWBAQZRZVIVKVOUCVIVKWFVOVICTUDUEUFDUGZUHDGTRZWF
      VIWKWLWFOZVICUIUJPHVIWMUKCDULEACDUMUNVFUOUPVIVKVOUQWEVOWJSEBVJVPBRZVSVOWD
      WJWNVQVLVRVNVPBIJURAVPBVMUSUTWNWAWHWCWIWNVTWGDVPBVAVBVPBWBAVCVDVEVGVH $.
  $}

  ${
    $d x y A $.  $d x B $.  $d x y M $.  $d x y S $.
    $( The measure the union of two complementary sets is the sum of their
       measures.  (Contributed by Thierry Arnoux, 10-Mar-2017.) $)
    measxun2 $p |- ( ( M e. ( measures ` S ) /\ ( A e. S /\ B e. S )
      /\ B C_ A ) -> ( M ` A ) = ( ( M ` B ) +e ( M ` ( A \ B ) ) ) ) $=
      ( vx cfv wcel wa wss cpr cuni co wdisj wceq syl3anc syl2anc cin fveq2d c0
      cc0 cmeas w3a cdif cv cesum cxad cpw com cdom simp1 simp2r csiga measbase
      wbr crn simp2l difelsiga prelpwi prct simp3 disjdifprg2 prcom dfss biimpi
      syl incom syl6eq preq2d syl5eqr disjeq1d biimprd mpan9 jca measvun uniprg
      cun undif sylan9eq simpr cpnf cicc measvxrge0 wo eqimss ssdifeq0 measvnul
      sylib sylan9eqr sylan orcd ex esumpr2 3eqtr3d ) DCUAFGZACGZBCGZHZBAIZUBZB
      ABUCZJZKZDFZXAEUDZDFZEUEZADFZBDFZWTDFZUFLWSWNXACUGGZXAUHUIUNZEXAXDMZHXCXF
      NWNWQWRUJZWSWPWTCGZXJWNWOWPWRUKZWSCULUOKGZWOWPXNWSWNXPXMCDUMVEWNWOWPWRUPZ
      XOABCUQOZBWTCURPWSXKXLWSWPXNXKXOXRBWTCCUSPWSWOWRXLXQWNWQWRUTZWOEWTABQZJZX
      DMZWRXLEABCVAWRXLYBWREXAYAXDWRXAWTBJYAWTBVBWRBXTWTWRBBAQZXTWRBYCNBAVCVDBA
      VFVGVHVIVJVKVLPVMEXACDVNOWSWPXNHZWRXCXGNWSWPXNXOXRVMXSYDWRHXBADYDWRXBBWTV
      PZABWTCCVOWRYEANBAVQVDVRRPWSBWTXEXHEXICCWSXDBNZHXDBDWSYFVSRWSXDWTNZHXDWTD
      WSYGVSRXOXRWSWNWPXHTVTWALZGXMXOBCDWBPWSWNXNXIYHGXMXRWTCDWBPWSBWTNZXHTNZXH
      VTNZWCWSYIHYJYKWSWNYIYJXMYIWNXHSDFTYIBSDYIBWTIBSNBWTWDBAWEWGRCDWFWHWIWJWK
      WLWM $.
  $}

  ${
    $d x y A $.  $d x y M $.  $d y S $.
    $( The measure the union of two disjoint sets is the sum of their
       measures.  (Contributed by Thierry Arnoux, 10-Mar-2017.) $)
    measun $p |- ( ( M e. ( measures ` S ) /\ ( A e. S /\ B e. S )
      /\ ( A i^i B ) = (/) )
      -> ( M ` ( A u. B ) ) = ( ( M ` A ) +e ( M ` B ) ) ) $=
      ( cmeas cfv wcel wa c0 wceq cun cdif cxad cxr cc0 cpnf measvxrge0 syl2anc
      co sseldi cin w3a wss simp1 cuni measbase 3ad2ant1 simp2l simp2r unelsiga
      csiga crn syl3anc ssun2 a1i measxun2 syl121anc difun2 inundif uneq1 uncom
      syl6eq syl5reqr syl5eq fveq2d oveq2d 3ad2ant3 cicc iccssxr xaddcom 3eqtrd
      un0 eqtri ) DCEFGZACGZBCGZHZABUAZIJZUBZABKZDFZBDFZWABLZDFZMSZWCADFZMSZWGW
      CMSZVTVNWACGZVPBWAUCZWBWFJVNVQVSUDZVTCUKULUEGZVOVPWJVNVQWMVSCDUFUGVNVOVPV
      SUHZVNVOVPVSUIZABCUJUMWOWKVTBAUNUOWABCDUPUQVSVNWFWHJVQVSWEWGWCMVSWDADVSWD
      ABLZAABURVSAVRWPKZWPABUSVSWQIWPKZWPVRIWPUTWRWPIKWPIWPVAWPVLVMVBVCVDVEVFVG
      VTWCNGZWGNGZWHWIJVTVNVPWSWLWOVNVPHOPVHSZNWCOPVIZBCDQTRVTVNVOWTWLWNVNVOHXA
      NWGXBACDQTRWCWGVJRVK $.
  $}

  ${
    $d y z A $.  $d x y z M $.  $d x y S $.  $d y z B $.  $d z S $.
    measvunilem.1 $e |- F/_ x A $.
    $( Lemma for ~ measvuni (Contributed by Thierry Arnoux, 7-Feb-2017.)
       (Revised by Thierry Arnoux, 19-Feb-2017.)  (Revised by Thierry Arnoux,
       6-Mar-2017.) $)
    measvunilem $p |- ( ( M e. ( measures ` S ) /\
      A. x e. A B e. ( S \ { (/) } ) /\ ( A ~<_ om /\ Disj_ x e. A B ) )
      -> ( M ` U_ x e. A B ) = sum* x e. A ( M ` B ) ) $=
      ( vy vz cfv wcel wral com cdom wbr wdisj cv wceq cvv syl nfcv c0 csn cdif
      cmeas wa w3a wrex cab cuni cesum ciun cpw simp1 wss simp3l abrexctf simp2
      ctex eldifi ralimi abrexss elpwg biimpar syl2anc simp3r measvun syl112anc
      disjabrexf dfiun2g fveq2d nfra1 nfbr nfdisj1 nfan nf3an r19.21bi disjdsct
      nfv fveq2 cc0 cpnf cicc co simpl1 measvxrge0 sylan2 esumc 3eqtr4d ) EDUDI
      JZCDUAUBZUCZJZABKZBLMNZABCOZUEZUFZGPCQABUGGUHZUIZEIZWRHPZEIZHUJZABCUKZEIZ
      BCEIZAUJWQWIWRDULJZWRLMNZHWRXAOZWTXCQWIWMWPUMWQWRRJZWRDUNZXGWQXHXJWQWNXHW
      IWMWNWOUOZAGBCFUPSZWRURSWQWMXKWIWMWPUQZWMCDJZABKXKWLXOABCDWJUSZUTAGBCDADT
      VASSXJXGXKWRDRVBVCVDXMWQWOXIWIWMWNWOVEZAHGBCFVHSHWRDEVFVGWQWMXEWTQXNWMXDW
      SEAGBCWKVIVJSWQHGBXFCXBARWKWIWMWPAWIAVRWLABVKWNWOAABLMFAMTALTVLABCVMVNVOZ
      FXACEVSWQWNBRJXLBURSWQABCDXRFWQWLABXNVPZXQVQWQAPBJZUEWIWLXFVTWAWBWCJZWIWM
      WPXTWDXSWLWIXOYAXPCDEWEWFVDXSWGWH $.
  $}

  ${
    $d y z A $.  $d x y z M $.  $d x y S $.  $d y z B $.
    measvunilem.0.1 $e |- F/_ x A $.
    $( Lemma for ~ measvuni .  (Contributed by Thierry Arnoux, 6-Mar-2017.) $)
    measvunilem0 $p |- ( ( M e. ( measures ` S ) /\
      A. x e. A B e. { (/) } /\ ( A ~<_ om /\ Disj_ x e. A B ) )
      -> ( M ` U_ x e. A B ) = sum* x e. A ( M ` B ) ) $=
      ( cfv wcel c0 com cdom wa cc0 cesum ciun cvv wceq nfcv fveq2d eqtrd cmeas
      csn wral wbr wdisj w3a simp3l ctex esum0 3syl nfv nfra1 nfbr nfdisj1 nfan
      nf3an eqidd cv simp2 r19.21bi elsni measvnul 3ad2ant1 adantr esumeq12dvaf
      syl iuneq12daf iun0 syl6eq 3eqtr4rd ) EDUAGHZCIUBHZABUCZBJKUDZABCUEZLZUFZ
      BMANZMBCEGZANABCOZEGZVQVNBPHVRMQVKVMVNVOUGBUHBAPFUIUJVQBBVSMAVKVMVPAVKAUK
      VLABULVNVOAABJKFAKRAJRUMABCUNUOUPZVQBUQZVQAURBHZLZVSIEGZMWECIEWEVLCIQVQVL
      ABVKVMVPUSUTCIVAVFZSVQWFMQZWDVKVMWHVPDEVBVCZVDTVEVQWAWFMVQVTIEVQVTABIOIVQ
      ABBCIWBFFWCWGVGABVHVISWITVJ $.
  $}

  ${
    $d x y z A $.  $d x y z M $.  $d x y S $.  $d y z B $.
    $( The measure of a countable disjoint union is the sum of the measures.
       This theorem uses a collection rather than a set of subsets of ` S ` .
       (Contributed by Thierry Arnoux, 7-Mar-2017.) $)
    measvuni $p |- ( ( M e. ( measures ` S ) /\ A. x e. A B e. S /\
      ( A ~<_ om /\ Disj_ x e. A B ) ) -> ( M ` U_ x e. A B ) =
      sum* x e. A ( M ` B ) ) $=
      ( cfv wcel wral com wa c0 crab ciun wceq adantl ralrimiva 3ad2ant1 adantr
      cesum cin cmeas cdom wbr wdisj w3a csn cdif co simp1 cv rabid simprbi wss
      cxad ssrab2 ssct mpan 3ad2ant3 simp3r nfrab1 mpsyl measvunilem0 syl112anc
      nfcv disjss1f measvunilem oveq12d cun nfra1 nfdisj1 nfan nf3an nfun simp2
      nfv rabid2 sylibr elun csiga cuni measbase 0elsiga snssi 3syl undif sylib
      wo crn eleq2d syl5bbr rabbidv eqtr4d unrab syl6eqr eqidd iuneq12df fveq2d
      iunxun fveq2i syl6eq wb elsni eleq1d mpbird syl2an sigaclcuni syl3anc syl
      eldifad iuneq2i iun0 eqtri ineq1 incom eqtr3i mp1i measun syl121anc eqtrd
      in0 esumeq1d cvv ctex inrab wn noel disjdif eleq2i mtbir elin mtbi rabeq0
      rgenw mpbir a1i cc0 cpnf cicc sylan syl2anc measvxrge0 esumsplit 3eqtr4d
      ) EDUAFGZCDGZABHZBIUBUCZABCUDZJZUEZACKUFZGZABLZCMZEFZACDUUKUGZGZABLZCMZEF
      ZUNUHZUUMCEFZASZUURUVBASZUNUHZABCMZEFZBUVBASZUUJUUOUVCUUTUVDUNUUJUUDUULAU
      UMHZUUMIUBUCZAUUMCUDZUUOUVCNUUDUUFUUIUIZUUDUUFUVIUUIUUDUULAUUMAUJZUUMGZUU
      LUUDUVNUVMBGZUULUULABUKULZOPQUUIUUDUVJUUFUUGUVJUUHUUMBUMZUUGUVJUULABUOZUU
      MBUPUQRURZUVQUUJUUHUVKUVRUUDUUFUUGUUHUSZAUUMBCUULABUTZABVDZVEVAAUUMCDEUWA
      VBVCUUJUUDUUQAUURHZUURIUBUCZAUURCUDZUUTUVDNUVLUUDUUFUWCUUIUUDUUQAUURUVMUU
      RGZUUQUUDUWFUVOUUQUUQABUKULZOZPQUUIUUDUWDUUFUUGUWDUUHUURBUMZUUGUWDUUQABUO
      ZUURBUPUQRURZUWIUUJUUHUWEUWJUVTAUURBCUUQABUTZUWBVEVAAUURCDEUWLVFVCVGUUJUV
      GUUNUUSVHZEFZUVAUUJUVGAUUMUURVHZCMZEFUWNUUJUVFUWPEUUJABUWOCCUUDUUFUUIAUUD
      AVOUUEABVIUUGUUHAUUGAVOABCVJVKVLZUWBAUUMUURUWAUWLVMUUJBUULUUQWGZABLZUWOUU
      JBUUEABLZUWSUUJUUFBUWTNUUDUUFUUIVNUUEABVPVQUUDUUFUWSUWTNUUIUUDUWRUUEABUWR
      CUUKUUPVHZGUUDUUECUUKUUPVRUUDUXADCUUDUUKDUMZUXADNUUDDVSWHVTGZKDGZUXBDEWAZ
      DWBZKDWCWDUUKDWEWFWIWJWKQWLUULUUQABWMWNZUUJCWOWPWQUWPUWMEAUUMUURCWRWSWTUU
      JUUDUUNDGZUUSDGZUUNUUSTZKNZUWNUVANUVLUUJUXCUUEAUUMHZUVJUXHUUDUUFUXCUUIUXE
      QZUUDUUFUXLUUIUUDUUEAUUMUUDUXCUULUUEUVNUXEUVPUXCUULJUUEUXDUXCUXDUULUXFRUU
      LUUEUXDXAUXCUULCKDCKXBZXCOXDXEZPQUVSUUMCDAUWAXFXGUUJUXCUUEAUURHZUWDUXIUXM
      UUDUUFUXPUUIUUDUUEAUURUUDUWFJCDUUKUWHXIPQUWKUURCDAUWLXFXGUUNKNZUXKUUJUUNA
      UUMKMKAUUMCKUVNUULCKNUVPUXNXHXJAUUMXKXLUXQUXJKUUSTZKUUNKUUSXMUUSKTUXRKUUS
      KXNUUSXTXOWTXPUUNUUSDEXQXRXSUUJUVHUWOUVBASUVEUUJBUWOUVBAUWQUXGYAUUJUUMUUR
      UVBAUWQUWAUWLUUJUVJUUMYBGUVSUUMYCXHUUJUWDUURYBGUWKUURYCXHUUMUURTZKNUUJUXS
      UULUUQJZABLZKUULUUQABYDUYAKNUXTYEZABHUYBABCUUKUUPTZGZUXTUYDCKGCYFUYCKCUUK
      DYGYHYICUUKUUPYJYKYMUXTABYLYNXLYOUUJUVNJUUDUUEUVBYPYQYRUHGZUUJUUDUVNUVLRU
      UJUUDUVNUUEUVLUXOYSCDEUUAZYTUUJUWFJZUUDUUEUYEUUJUUDUWFUVLRUYGCDUUKUWFUUQU
      UJUWGOXIUYFYTUUBXSUUC $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y M $.  $d x y S $.  $d y ph $.
    measssd.1 $e |- ( ph -> M e. ( measures ` S ) ) $.
    measssd.2 $e |- ( ph -> A e. S ) $.
    measssd.3 $e |- ( ph -> B e. S ) $.
    measssd.4 $e |- ( ph -> A C_ B ) $.
    $( A measure is monotone with respect to set inclusion.  (Contributed by
       Thierry Arnoux, 28-Dec-2016.) $)
    measssd $p |- ( ph -> ( M ` A ) <_ ( M ` B ) ) $=
      ( vy cfv cle cc0 wbr wcel syl syl2anc wceq wss adantl cdif cxad cpnf cicc
      co cmeas csiga crn cuni measbase difelsiga syl3anc measvxrge0 cxr elxrge0
      simprbi wi simplbi xraddge02 mpd cpr cesum cpw cdom wdisj prssi prex elpw
      com sylibr prct disjdifprg prcom a1i disjeq1d mpbid measvun syl112anc cun
      cv uniprg undif sylib eqtrd fveq2d fveq2 wo eqimss ssdifeq0 measvnul orcd
      wa c0 adantr ex esumpr2 3eqtr3d breqtrrd ) ABEKZWSCBUAZEKZUBUEZCEKZLAMXAL
      NZWSXBLNZAXAMUCUDUEZOZXDAEDUFKOZWTDOZXGFADUGUHUIOZCDOZBDOZXIAXHXJFDEUJPHG
      CBDUKULZWTDEUMQZXGXAUNOZXDXAUOZUPPAWSUNOZXOXDXEUQAWSXFOZXQAXHXLXRFGBDEUMQ
      ZXRXQMWSLNWSUOURPAXGXOXNXGXOXDXPURPWSXAUSQUTABWTVAZUIZEKZXTJVTZEKZJVBZXCX
      BAXHXTDVCOZXTVIVDNZJXTYCVEZYBYERFAXTDSZYFAXLXIYIGXMBWTDVFQXTDBWTVGVHVJAXL
      XIYGGXMBWTDDVKQAJWTBVAZYCVEZYHAXLXKYKGHJBCDDVLQAJYJXTYCYJXTRAWTBVMVNVOVPJ
      XTDEVQVRAYACEAYABWTVSZCAXLXIYAYLRGXMBWTDDWAQABCSYLCRIBCWBWCWDWEABWTYDWSJX
      ADDYCBRYDWSRAYCBEWFTYCWTRYDXARAYCWTEWFTGXMXSXNABWTRZWSMRZWSUCRZWGAYMWLZYN
      YOYPWSWMEKZMYPBWMEYMBWMRZAYMBWTSYRBWTWHBCWIWCTWEAYQMRZYMAXHYSFDEWJPWNWDWK
      WOWPWQWR $.
  $}

  ${
    measunl.1 $e |- ( ph -> M e. ( measures ` S ) ) $.
    measunl.2 $e |- ( ph -> A e. S ) $.
    measunl.3 $e |- ( ph -> B e. S ) $.
    $( A measure is sub-additive with respect to union.  (Contributed by
       Thierry Arnoux, 20-Oct-2017.) $)
    measunl $p |- ( ph -> ( M ` ( A u. B ) ) <_ ( ( M ` A ) +e ( M ` B ) ) ) $=
      ( cun cfv co cle wcel cin c0 wceq cxr wbr measvxrge0 syl2anc undif1 cmeas
      cdif cxad fveq2i csiga crn cuni measbase difelsiga syl3anc disjdif eqtr3i
      syl a1i measun syl121anc syl5eqr cc0 cpnf cicc iccssxr sseldi wa inelsiga
      incom elxrge0 sylib simprd wi xraddge02 mpd uncom inundif wss inss1 inss2
      sstri ssini sseqtri ss0 ax-mp breqtrrd xleadd1a syl31anc eqbrtrd ) ABCIZE
      JZBCUCZEJZCEJZUDKZBEJZWKUDKZLAWHWICIZEJZWLWOWGEBCUAUEAEDUBJMZWIDMZCDMZWIC
      NZOPZWPWLPFADUFUGUHMZBDMZWSWRAWQXBFDEUIUNZGHBCDUJUKZHXAACWINZWTOCWIVFCBUL
      ZUMUOWICDEUPUQURAWJQMZWMQMWKQMWJWMLRWLWNLRAUSUTVAKZQWJUSUTVBZAWQWRWJXIMFX
      EWIDESTVCZAXIQWMXJAWQXCWMXIMFGBDESTVCAXIQWKXJAWQWSWKXIMFHCDESTVCAWJWJBCNZ
      EJZUDKZWMLAUSXMLRZWJXNLRZAXMQMZXOAXMXIMZXQXOVDAWQXLDMZXRFAXBXCWSXSXDGHBCD
      VEUKZXLDESTZXMVGVHVIAXHXQXOXPVJXKAXIQXMXJYAVCWJXMVKTVLAWMWIXLIZEJZXNYBBEX
      LWIIYBBXLWIVMBCVNUMUEAWQWRXSWIXLNZOPZYCXNPFXEXTYEAXLWINZYDOXLWIVFYFOVOYFO
      PYFXFOYFCWIYFXLCXLWIVPBCVQVRXLWIVQVSXGVTYFWAWBUMUOWIXLDEUPUQURWCWJWMWKWDW
      EWF $.
  $}

  ${
    $d k x y A $.  $d x y B $.  $d k n I $.  $d n y M $.  $d k n x y N $.
    $d k n y S $.  $d k n y ph $.
    measiuns.0 $e |- F/_ n B $.
    measiuns.1 $e |- ( n = k -> A = B ) $.
    measiuns.2 $e |- ( ph -> ( N = NN \/ N = ( 1 ..^ I ) ) ) $.
    measiuns.3 $e |- ( ph -> M e. ( measures ` S ) ) $.
    measiuns.4 $e |- ( ( ph /\ n e. N ) -> A e. S ) $.
    $( The measure of the union of a collection of sets, expressed as the sum
       of a disjoint set.  This is used as a lemma for both ~ measiun and
       ~ meascnbl (Contributed by Thierry Arnoux, 22-Jan-2017.)  (Proof
       shortened by Thierry Arnoux, 7-Feb-2017.) $)
    measiuns $p |- ( ph -> ( M ` U_ n e. N A )
      = sum* n e. N ( M ` ( A \ U_ k e. ( 1 ..^ n ) B ) ) ) $=
      ( cfv c1 wcel wa cn wss ciun cv cfzo co cdif cesum iundisjcnt fveq2d wral
      cmeas com cdom wbr wdisj wceq crn cuni measbase syl adantr simpll fzossnn
      csiga simpr syl5sseqr cuz simplr eleqtrd elfzouz2 fzoss2 3syl sseqtr4d wo
      mpjaodan sselda wsb sbimi sban nfv sbf clelsb3 anbi12i bitri csb wsbc cvv
      sbsbc wb vex sbcel1g ax-mp nfcv cbvcsb csbid eqtri eleq1i 3imtr3i syl2anc
      ralrimiva sigaclfu2 difelsiga syl3anc eqimss sseq1 jaoi nnct ssct sylancl
      mpbiri iundisj2cnt measvuni syl112anc eqtrd ) AFIBUAZHOFIBEPFUBZUCUDZCUAZ
      UEZUAZHOZIXRHOFUFZAXNXSHABCEFGIJKLUGUHAHDUJOQZXRDQZFIUIIUKULUMZFIXRUNXTYA
      UOMAYCFIAXOIQZRZDVCUPUQQZBDQZXQDQZYCAYGYEAYBYGMDHURUSUTZNYFYGCDQZEXPUIYIY
      JYFYKEXPYFEUBZXPQZRAYLIQZYKAYEYMVAYFXPIYLYFISUOZXPITIPGUCUDZUOZYFYORSXPIX
      OVBYFYOVDVEYFYQRZXPYPIYRXOYPQGXOVFOQXPYPTYRXOIYPAYEYQVGYFYQVDZVHXOPGVIXOP
      GVJVKYSVLAYOYQVMZYELUTVNVOYFFEVPZYHFEVPZAYNRZYKYFYHFENVQUUAAFEVPZYEFEVPZR
      UUCAYEFEVRUUDAUUEYNAFEAFVSVTEFIWAWBWCUUBFYLBWDZDQZYKUUBYHFYLWEZUUGYHFEWGY
      LWFQUUHUUGWHEWIFYLBDWFWJWKWCUUFCDUUFEYLCWDCFEYLBCEBWLJKWMECWNWOWPWCWQWRWS
      CDEXOWTWRBXQDXAXBWSAISTZSUKULUMYDAYTUUILYOUUIYQISXCYQUUIYPSTGVBIYPSXDXIXE
      USXFISXGXHABCEFGIJKLXJFIXRDHXKXLXM $.
  $}

  ${
    $d k m n y z $.  $d k n y ph $.  $d n y k S $.  $d k y z B $.  $d n y M $.
    measiun.1 $e |- ( ph -> M e. ( measures ` S ) ) $.
    measiun.2 $e |- ( ph -> A e. S ) $.
    measiun.3 $e |- ( ( ph /\ n e. NN ) -> B e. S ) $.
    measiun.4 $e |- ( ph -> A C_ U_ n e. NN B ) $.
    $( A measure is sub-additive.  (Contributed by Thierry Arnoux,
       30-Dec-2016.)  (Proof shortened by Thierry Arnoux, 7-Feb-2017.) $)
    measiun $p |- ( ph -> ( M ` A ) <_ sum* n e. NN ( M ` B ) ) $=
      ( vk cfv cn co cxr wcel measvxrge0 syl2anc wral wi vm ciun cesum cc0 cpnf
      cicc iccssxr cmeas sseldi csiga crn cuni measbase syl ralrimiva sigaclcu2
      cvv nnex cv wa adantr nfcv esumcl sylancr measssd c1 cfzo csb cle nfcsb1v
      cdif csbeq1a wceq eqidd orcd measiuns a1i nfel1 nfim eleq1 eleq1d imbi12d
      nfv imbi2d ex chvar ralrimiv wss fzossnn ssralv ax-mp sigaclfu2 difelsiga
      sylan2 syl3anc difssd esumle eqbrtrd xrletrd ) ABFLZEMCUBZFLZMCFLZEUCZAUD
      UEUFNZOWTUDUEUGZAFDUHLPZBDPWTXEPGHBDFQRUIAXEOXBXFAXGXADPZXBXEPGADUJUKULPZ
      CDPZEMSXHAXGXIGDFUMUNZAXJEMIUOCDEUPRZXADFQRUIAXEOXDXFAMUQPZXCXEPZEMSXDXEP
      URAXNEMAEUSZMPZUTZXGXJXNAXGXPGVAZICDFQRZUOMXCEUQEMVBVCVDUIABXADFGHXLJVEAX
      BMCKVFXOVGNZEKUSZCVHZUBZVKZFLZEUCXDVIACYBDKEUAUSZFMEYACVJZEYACVLZAMMVMMVF
      YFVGNVMAMVNVOGIVPAMYEXCEUQXMAURVQXQXGYDDPZYEXEPXRXQXIXJYCDPZYIAXIXPXKVAIA
      YJXPAXIYBDPZKMSZYJXKAYKKMAXPXJTZTAYAMPZYKTZTEKAYOEAEWCYNYKEEYAMEYAVBVREYB
      DYGVRVSVSXOYAVMZYMYOAYPXPYNXJYKXOYAMVTYPCYBDYHWAWBWDAXPXJIWEWFWGYLXIYKKXT
      SZYJXTMWHYLYQTXOWIYKKXTMWJWKYBDKXOWLWNRVACYCDWMWOZYDDFQRXSXQYDCDFXRYRIXQC
      YCWPVEWQWRWS $.
  $}

  ${
    $d i k l m n o p x F $.  $d i l n J $.  $d i l m n o p M $.  $d i k n S $.
    $d i k l m n o p ph $.
    meascnbl.0 $e |- J = ( TopOpen ` ( RR*s |`s ( 0 [,] +oo ) ) ) $.
    meascnbl.1 $e |- ( ph -> M e. ( measures ` S ) ) $.
    meascnbl.2 $e |- ( ph -> F : NN --> S ) $.
    meascnbl.3 $e |- ( ( ph /\ n e. NN ) -> ( F ` n ) C_ ( F ` ( n + 1 ) ) ) $.
    $( A measure is continuous from below.  Cf. ~ volsup .  (Contributed by
       Thierry Arnoux, 18-Jan-2017.)  (Revised by Thierry Arnoux,
       11-Jul-2017.) $)
    meascnbl $p   |- ( ph -> ( M o. F ) ( ~~>t ` J ) ( M ` U. ran F ) ) $=
      ( vi vk cn c1 cv co cfv cfzo wcel wceq vo vp vx ciun cdif cesum cmpt ccom
      cfz crn cuni clm cmeas cc0 cpnf cicc adantr csiga measbase ffvelrnda wral
      wa syl simpll fzossnn simpr syl2anc ralrimiva sigaclfu2 difelsiga syl3anc
      sseldi measvxrge0 fveq2 iuneq1d difeq12d fveq2d esumcvg2 measfrge0 fcompt
      oveq2 wf caddc nfcv cz nnzd fzval3 olcd eleq2d biimpa measiuns wfn iuninc
      ffn eqtr3d mpteq2dva eqtr4d wrex dfiun2g fnrnfv unieqd eqidd orcd 3brtr4d
      cab ) AKMNKOZUIPZCOZDQZLNXHRPZLOZDQZUDZUEZFQZCUFZUGZMXOCUFZFDUHZDUJZUKZFQ
      ZEULQAXOUAOZDQZLNYCRPZXLUDZUEZFQUBOZDQZLNYHRPZXLUDZUEZFQCUBKEUAGAXHMSZVBZ
      FBUMQSZXNBSZXOUNUOUPPZSAYOYMHUQYNBURUJUKSZXIBSZXMBSZYPAYRYMAYOYRHBFUSVCUQ
      ZAMBXHDIUTZYNYRXLBSZLXJVAYTUUAYNUUCLXJYNXKXJSZVBZAXKMSUUCAYMUUDVDUUEXJMXK
      XHVEYNUUDVFVLAMBXKDIUTVGVHXLBLXHVIVGXIXMBVJVKXNBFVMVGXHYCTZXNYGFUUFXIYDXM
      YFXHYCDVNUUFLXJYEXLXHYCNRWAVOVPVQXHYHTZXNYLFUUGXIYIXMYKXHYHDVNUUGLXJYJXLX
      HYHNRWAVOVPVQVRAXSKMXFDQZFQZUGZXQABYQFWBZMBDWBZXSUUJTAYOUUKHBFVSVCIKFDMBY
      QVTVGAKMXPUUIAXFMSZVBZCXGXIUDZFQXPUUIUUNXIXLBLCXFNWCPZFXGCXLWDZXHXKDVNZUU
      NXGNUUPRPZTZXGMTUUNXFWESUUTUUNXFAUUMVFWFNXFWGVCZWHAYOUUMHUQUUNXHXGSZVBZAY
      MYSAUUMUVBVDUVCUUSMXHUUPVEUUNUVBXHUUSSUUNXGUUSXHUVAWIWJVLUUBVGWKUUNUUOUUH
      FAKCDAUULDMWLZIMBDWNVCZJWMVQWOWPWQACMXIUDZFQYBXRAUVFYAFAUVFUCOXITCMWRUCXE
      ZUKZYAAYSCMVAUVFUVHTAYSCMUUBVHCUCMXIBWSVCAXTUVGAUVDXTUVGTUVECUCMDWTVCXAWQ
      VQAXIXLBLCUUPFMUUQUURAMMTMUUSTAMXBXCHUUBWKWOXD $.
  $}

  ${
    $d x y z A $.  $d x B $.  $d x y z S $.  $d x y z M $.
    $( Lemma for ~ measinb (Contributed by Thierry Arnoux, 2-Jun-2017.) $)
    measinblem $p |- ( ( ( ( M e. ( measures ` S ) /\ A e. S ) /\ B e. ~P S )
      /\ ( B ~<_ om /\ Disj_ x e. B x ) ) ->
      ( M ` ( U. B i^i A ) ) = sum* x e. B ( M ` ( x i^i A ) ) ) $=
      ( cmeas cfv wcel wa cpw com cdom wbr cv wdisj cuni cin ciun nfv nfan wral
      cesum iunin1 uniiun ineq1i eqtr4i fveq2i wceq simplll nfdisj1 w3a simp1ll
      csiga crn measbase simp1r elelpwi syl2anc simp1lr inelsiga syl3anc 3expia
      syl simp3 ralrimi simprl disjin ad2antll measvuni syl112anc syl5eqr ) EDF
      GHZBDHZIZCDJHZIZCKLMZACANZOZIZIZCPZBQZEGACVRBQZRZEGZCWDEGAUBZWEWCEWEACVRR
      ZBQWCACBVRUCWBWHBACUDUEUFUGWAVLWDDHZACUAVQACWDOZWFWGUHVLVMVOVTUIWAWIACVPV
      TAVPASVQVSAVQASACVRUJTTVPVTVRCHZWIVPVTWKUKZDUMUNPHZVRDHZVMWIWLVLWMVLVMVOV
      TWKULDEUOVCWLWKVOWNVPVTWKVDVNVOVTWKUPVRCDUQURVLVMVOVTWKUSVRBDUTVAVBVEVPVQ
      VSVFVSWJVPVQABCVRVGVHACWDDEVIVJVK $.

    $( Building a measure restricted to the intersection with a given set.
       (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    measinb $p |- ( ( M e. ( measures ` S ) /\ A e. S ) ->
      ( x e. S |-> ( M ` ( x i^i A ) ) ) e. ( measures ` S ) ) $=
      ( vz vy cfv wcel wa cv cin wceq inelsiga syl3anc measvxrge0 syl2anc eqidd
      cc0 c0 syl cmeas cmpt cpnf cicc co com cdom wbr wdisj cuni cesum cpw wral
      wf wi simpll csiga crn measbase ad2antrr simpr simplr eqid fmptd cr ineq1
      incom in0 eqtr3i syl6eq fveq2d adantl eqtrd adantr 0elsiga 0re a1i fvmptd
      measvnul measinblem simplll simprl sigaclcu simpllr elpwi ad2antlr sseldd
      wss esumeq2dv 3eqtr4d ex ralrimiva w3a wb ismeas mpbir3and ) DCUAGZHZBCHZ
      IZACAJZBKZDGZUBZWQHZCRUCUDUEZXDUNZSXDGRLZEJZUFUGUHZFXIFJZUIZIZXIUJZXDGZXI
      XKXDGZFUKZLZUOZECULZUMZWTACXCXFXDWTXACHZIZWRXBCHZXCXFHWRWSYBUPYCCUQURUJHZ
      YBWSYDWRYEWSYBCDUSZUTWTYBVAWRWSYBVBXABCMNXBCDOPXDVCVDWTASXCRCXDVEWTXDQWTX
      ASLZIXCSDGZRYGXCYHLWTYGXBSDYGXBSBKZSXASBVFBSKYISBSVGBVHVIVJVKVLWRYHRLWSYG
      CDVSUTVMWTYESCHWRYEWSYFVNZCVOTRVEHWTVPVQVRWTXSEXTWTXIXTHZIZXMXRYLXMIZXNBK
      ZDGZXIXKBKZDGZFUKZXOXQFBXICDVTYMAXNXCYOCXDXFYMXDQYMXAXNLZIXBYNDYSXBYNLYMX
      AXNBVFVLVKYMYEYKXJXNCHZYMWRYEWRWSYKXMWAZYFTZWTYKXMVBYLXJXLWBXICWCNZYMWRYN
      CHZYOXFHUUAYMYEYTWSUUDUUBUUCWRWSYKXMWDXNBCMNYNCDOPVRYLXQYRLXMYLXIXPYQFYLX
      KXIHZIZAXKXCYQCXDXFUUFXDQUUFXAXKLZIXBYPDUUGXBYPLUUFXAXKBVFVLVKUUFXICXKYKX
      ICWHWTUUEXICWEWFYLUUEVAWGZUUFWRYPCHZYQXFHWRWSYKUUEWAZUUFYEXKCHWSUUIUUFWRY
      EUUJYFTUUHWRWSYKUUEWDXKBCMNYPCDOPVRWIVNWJWKWLWTYEXEXGXHYAWMWNYJEFCXDWOTWP
      $.
  $}

  ${
    $d x y z A $.  $d x y z S $.  $d x y z M $.  $d x y T $.
    $( Building a measure restricted to a smaller sigma algebra.  (Contributed
       by Thierry Arnoux, 25-Dec-2016.) $)
    measres $p |- ( ( M e. ( measures ` S ) /\ T e. U. ran sigAlgebra
        /\ T C_ S ) -> ( M |` T ) e. ( measures ` T ) ) $=
      ( vx vy cmeas cfv wcel cuni wss w3a wf c0 wceq cv wa cesum 3ad2ant1 fvres
      cc0 csiga crn cpnf cicc co cres com cdom wbr wdisj wi cpw simp2 measfrge0
      wral simp3 fssres syl2anc 0elsiga 3syl measvnul eqtrd simp11 simp13 sspwb
      ssel2 sylanb measvun syl3anc simp3l sigaclcu syl sselda adantll esumeq2dv
      elpwi 3adant3 3eqtr4d 3expia ralrimiva 3jca ismeas biimprd sylc ) CAFGHZB
      UAUBIHZBAJZKZWFBTUCUDUEZCBUFZLZMWJGZTNZDOZUGUHUIZEWNEOZUJZPZWNIZWJGZWNWPW
      JGZEQZNZUKZDBULZUOZKZWJBFGHZWEWFWGUMZWHWKWMXFWHAWICLZWGWKWEWFXJWGACUNRWEW
      FWGUPAWIBCUQURWHWLMCGZTWHWFMBHWLXKNXIBUSMBCSUTWEWFXKTNWGACVARVBWHXDDXEWHW
      NXEHZWRXCWHXLWRKZWSCGZWNWPCGZEQZWTXBXMWEWNAULZHZWRXNXPNWEWFWGXLWRVCXMWGXL
      XRWEWFWGXLWRVDWHXLWRUMZWGXEXQJXLXRBAVEXEXQWNVFVGURWHXLWRUPEWNACVHVIXMWSBH
      ZWTXNNXMWFXLWOXTWHXLWFWRXIRXSWHXLWOWQVJWNBVKVIWSBCSVLWHXLXBXPNWRWHXLPZWNX
      AXOEYAWPWNHZPWPBHZXAXONXLYBYCWHXLWNBWPWNBVPVMVNWPBCSVLVOVQVRVSVTWAWFXHXGD
      EBWJWBWCWD $.
  $}

  ${
    $d x y z A $.  $d x y z S $.  $d x y z M $.
    $( Building a measure restricted to the intersection with a given set.
       (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    measinb2 $p |- ( ( M e. ( measures ` S ) /\ A e. S ) ->
      ( x e. ( S i^i ~P A ) |-> ( M ` ( x i^i A ) ) )
      e. ( measures ` ( S i^i ~P A ) ) ) $=
      ( cmeas cfv wcel wa cpw cin cv cmpt cres resmpt3 inin eqid mpteq12i eqtri
      csiga crn wss measinb measbase sigainb elrnsiga syl sylan measres syl3anc
      cuni inss1 a1i syl5eqelr ) DCEFZGZBCGZHZACBIZJZAKBJDFZLZACUTLZUSMZUSEFZVC
      ACUSJZUTLVAACUSUTNAVEUTUSUTCUROUTPQRUQVBUNGUSSTUJZGZUSCUAZVCVDGABCDUBUOCV
      FGZUPVGCDUCVIUPHUSBSFGVGBCUDUSBUEUFUGVHUQCURUKULCUSVBUHUIUM $.
  $}

  ${
    $d x y z A $.  $d x y z M $.  $d x y z S $.
    $( Division of a measure by a positive constant is a measure.  (Contributed
       by Thierry Arnoux, 25-Dec-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    measdivcstOLD $p |- ( ( M e. ( measures ` S ) /\ A e. RR+ )
      -> ( x e. S |-> ( ( M ` x ) /e A ) ) e. ( measures ` S ) ) $=
      ( vy vz cfv wcel wa cc0 co cv cxdiv c0 wceq wi cvv simplr syl oveq1d cpnf
      cmeas crp cicc cmpt wf com cdom wbr wdisj cuni cesum cpw wral w3a wfn crn
      wss wfun cdm funmpt ovex rgenw dmmptg ax-mp mpbir2an a1i wrex wb vex eqid
      df-fn elrnmpt measfrge0 ffvelrn sylan adantlr xrpxdivcld eleq1a rexlimdva
      syl5bi ssrdv sylanbrc csiga measbase 0elsiga adantr jctir fvmptg measvnul
      df-f fveq2 xdiv0rp sylan9eq eqtrd simpll simprl simprr 3jca simplll simpr
      elpwg sylanb syl2anc measvxrge0 esumdivc 3ad2antr1 ad2antrr simpr1 simpr2
      ssel2 sigaclcu syl3anc fvmpt3i jca simpr3 measvun ralrimiva r19.21bi sylc
      3expia esumeq2dv 3eqtr4d ex ismeas biimprd mpd ) DCUBGZHZBUCHZIZCJUAUDKZA
      CALZDGZBMKZUEZUFZNYPGZJOZELZUGUHUIZFYTFLZUJZIZYTUKZYPGZYTUUBYPGZFULZOZPZE
      CUMZUNZUOZYPYHHZYKYQYSUULYKYPCUPZYPUQZYLURYQUUOYKUUOYPUSYPUTCOZACYOVAYOQH
      ZACUNUUQUURACYNBMVBZVCACYOQVDVEYPCVLVFVGYKEUUPYLYTUUPHZYTYOOZACVHZYKYTYLH
      ZYTQHZUUTUVBVIEVJZACYOYTYPQYPVKZVMVEYKUVAUVCACYKYMCHZIZYOYLHUVAUVCPUVHYNB
      YIUVGYNYLHZYJYICYLDUFUVGUVICDVNCYLYMDVOVPVQYIYJUVGRVRYOYLYTVSSVTWAWBCYLYP
      WKWCYKYRNDGZBMKZJYKNCHZUVKQHZIYRUVKOYKUVLUVMYIUVLYJYICWDUQUKHZUVLCDWEZCWF
      SWGUVJBMVBWHANYOUVKCQYPYMNOYNUVJBMYMNDWLTUVFWISYIYJUVKJBMKJYIUVJJBMCDWJTB
      WMWNWOYKUUJEUUKYKYTUUKHZIZUUDUUIUVQUUDIZYKUVPUUAUUCUOZUUIYKUVPUUDWPUVRUVP
      UUAUUCYKUVPUUDRUVQUUAUUCWQUVQUUAUUCWRWSYKUVSIZYTUUBDGZFULZBMKZYTUWABMKZFU
      LZUUFUUHYKUUAUVPUWCUWEOUUCUVQYTUWABFQUVDUVQUVEVGUVQUUBYTHZIZYIUUBCHZUWAYL
      HYIYJUVPUWFWTUWGUVPUWFUWHYKUVPUWFRUVQUWFXAUVPYTCURZUWFUWHUVDUVPUWIVIUVEYT
      CQXBVEYTCUUBXKXCZXDUUBCDXEXDYIYJUVPRXFXGUVTUUFUUEDGZBMKZUWCUVTUUECHZUUFUW
      LOUVTUVNUVPUUAUWMYIUVNYJUVSUVOXHYKUVPUUAUUCXIZYKUVPUUAUUCXJZYTCXLXMAUUEYO
      UWLCYPYMUUEOYNUWKBMYMUUEDWLTUVFUUSXNSUVTUWKUWBBMUVTYIUVPIUUDUWKUWBOZUVTYI
      UVPYIYJUVSWPUWNXOUVTUUAUUCUWOYKUVPUUAUUCXPXOYIUUDUWPPZEUUKYIUWQEUUKYIUVPU
      UDUWPFYTCDXQYAXRXSXTTWOUVTUVPUUHUWEOUWNUVPYTUUGUWDFUVPUWFIUWHUUGUWDOUWJAU
      UBYOUWDCYPYMUUBOYNUWABMYMUUBDWLTUVFUUSXNSYBSYCXDYDXRWSYIUUMUUNPYJYIUUNUUM
      YIUVNUUNUUMVIUVOEFCYPYESYFWGYG $.
  $}

  ${
    $d x y z A $.  $d x y z M $.  $d x y z S $.
    $( Division of a measure by a positive constant is a measure.  (Contributed
       by Thierry Arnoux, 25-Dec-2016.)  (Revised by Thierry Arnoux,
       30-Jan-2017.) $)
    measdivcst $p |- ( ( M e. ( measures ` S ) /\ A e. RR+ )
      -> ( M oFC /e A ) e. ( measures ` S ) ) $=
      ( vx vy vz cfv wcel wa cxdiv co cv wceq cc0 syl adantr eqtrd cvv oveq1d
      c0 crp cofc cmpt cdm ofcfval3 cpnf cicc wf measfrge0 fdm mpteq1d com cdom
      cmeas wbr wdisj cuni cesum wi cpw wral measvxrge0 adantlr xrpxdivcld eqid
      simplr fmptd csiga crn measbase 0elsiga ovex fveq2 fvmptg sylancl xdiv0rp
      measvnul sylan9eq w3a simpll simprl simprr 3jca vex a1i simplll wss ssel2
      sylanb adantll syl2anc esumdivc 3ad2antr1 ad2antrr simpr1 simpr2 sigaclcu
      elpw syl3anc fvmpt3i simpr3 measvun syl112anc esumeq2dv 3eqtr4d ralrimiva
      ex wb ismeas biimprd mp3and eqeltrd ) CBUNGZHZAUAHZIZCAJUBKZDBDLZCGZAJKZU
      CZXMXPXQDCUDZXTUCYADAJCXMUAUEXPDYBBXTXNYBBMZXOXNBNUFUGKZCUHYCBCUIBYDCUJOP
      UKQXPBYDYAUHZTYAGZNMZELZULUMUOZFYHFLZUPZIZYHUQZYAGZYHYJYAGZFURZMZUSZEBUTZ
      VAZYAXMHZXPDBXTYDYAXPXRBHZIXSAXNUUBXSYDHXOXRBCVBVCXNXOUUBVFVDYAVEZVGXPYFT
      CGZAJKZNXPTBHZUUERHYFUUEMXNUUFXOXNBVHVIUQHZUUFBCVJZBVKOPUUDAJVLDTXTUUEBRY
      AXRTMXSUUDAJXRTCVMSUUCVNVOXNXOUUENAJKNXNUUDNAJBCVQSAVPVRQXPYREYSXPYHYSHZI
      ZYLYQUUJYLIZXPUUIYIYKVSZYQXPUUIYLVTUUKUUIYIYKXPUUIYLVFUUJYIYKWAUUJYIYKWBW
      CXPUULIZYHYJCGZFURZAJKZYHUUNAJKZFURZYNYPXPYIUUIUUPUURMYKUUJYHUUNAFRYHRHUU
      JEWDZWEUUJYJYHHZIXNYJBHZUUNYDHXNXOUUIUUTWFUUIUUTUVAXPUUIYHBWGUUTUVAYHBUUS
      WRYHBYJWHWIZWJYJBCVBWKXNXOUUIVFWLWMUUMYNYMCGZAJKZUUPUUMYMBHZYNUVDMUUMUUGU
      UIYIUVEXNUUGXOUULUUHWNXPUUIYIYKWOZXPUUIYIYKWPZYHBWQWSDYMXTUVDBYAXRYMMXSUV
      CAJXRYMCVMSUUCXSAJVLZWTOUUMUVCUUOAJUUMXNUUIYIYKUVCUUOMXNXOUULVTUVFUVGXPUU
      IYIYKXAFYHBCXBXCSQUUMUUIYPUURMUVFUUIYHYOUUQFUUIUUTIUVAYOUUQMUVBDYJXTUUQBY
      AXRYJMXSUUNAJXRYJCVMSUUCUVHWTOXDOXEWKXGXFXNYEYGYTVSZUUAUSXOXNUUAUVIXNUUGU
      UAUVIXHUUHEFBYAXIOXJPXKXL $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
              The counting measure
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y S $.
    $( The Counting measure is a measure on any sigma-algebra.  (Contributed by
       Thierry Arnoux, 25-Dec-2016.) $)
    cntmeas $p |- ( S e. U. ran sigAlgebra
                                         -> ( # |` S ) e. ( measures ` S ) ) $=
      ( vx vy cuni wcel chash cfv cc0 wf c0 wceq cv wa cesum cpw wral cvv fvres
      wi wss csiga crn cres cmeas cpnf cicc co com cdom wbr wdisj hashf2 fssres
      ssv mp2an a1i 0elsiga syl hash0 vex hasheuni mpan ad2antll cdif isrnsigau
      syl6eq w3a simprd simp3d imim2i ralimi r19.21bi imp elpwi sseld esumeq2dv
      adantrr syl6 ad2antlr 3eqtr4d ex ralrimiva ismeas mpbir3and ) AUAUBDEZFAU
      CZAUDGEAHUEUFUGZWFIZJWFGZHKBLZUHUIUJZCWJCLZUKZMZWJDZWFGZWJWLWFGZCNZKZSZBA
      OZPWHWEQWGFIAQTWHULAUNQWGAFUMUOUPWEWIJFGZHWEJAEWIXBKAUQJAFRURUSVFWEWTBXAW
      EWJXAEZMZWNWSXDWNMWOFGZWJWLFGZCNZWPWRWMXEXGKZXDWKWJQEWMXHBUTCWJQVAVBVCXDW
      KWPXEKZWMXDWKXIWEWKXISZBXAWEWKWOAEZSZBXAPZXJBXAPWEADZAEZXNWJVDAEBAPZXMWEA
      XNOTXOXPXMVGBAVEVHVIXLXJBXAXKXIWKWOAFRVJVKURVLVMVQXCWRXGKWEWNXCWJWQXFCXCW
      LWJEZWQXFKZXCXQWLAEXRXCWJAWLWJAVNVOWLAFRVRVMVPVSVTWAWBBCAWFWCWD $.
  $}

  $( The counting measure is a measure on any power set.  (Contributed by
     Thierry Arnoux, 24-Jan-2017.) $)
  pwcntmeas $p |- ( O e. V -> ( # |` ~P O ) e. ( measures ` ~P O ) ) $=
    ( wcel cpw csiga cfv crn cuni chash cres cmeas pwsiga elrnsiga cntmeas 3syl
    ) ABCADZAEFCPEGHCIPJPKFCABLPAMPNO $.

  $( Counting and Lebesgue measures are different.  (Contributed by Thierry
     Arnoux, 27-Jan-2017.) $)
  cntnevol $p |- ( # |` ~P O ) =/= vol $=
    ( c1 wcel chash cpw cvol wne cfv cc0 a1i wceq syl cr 1re syl6eq cdm necon3i
    ax-mp wss wn cres ax-1ne0 snelpwi fvres hashsng covol ovolsn nulmbl syl2anc
    csn snssi mblvol mp2b 3netr4d fveq1 biantrur snex elpw dmhashres eleq2i 1ex
    wa snss 3bitr4i notbii bitr3i nelne1 sylbir necomd dmeq pm2.61i ) BACZDAEZU
    AZFGZVLBUJZVNHZVPFHZGVOVLBIVQVRBIGVLUBJVLVQVPDHZBVLVPVMCZVQVSKBAUCVPVMDUDLB
    MCZVSBKNBMUEROVRIKZVLWAVPFPZCZWBNWAVPMSVPUFHZIKZWDBMUKBUGZVPUHUIZWDVRWEIVPU
    LWAWFNWGROUMJUNVNFVQVRVPVNFUOQLVLTZVNPZWCGVOWIWCWJWIWDVPWJCZTZVBZWCWJGWMWLW
    IWDWLWAWDNWHRUPWKVLVTVPASWKVLVPABUQURWJVMVPVMUSUTBAVAVCVDVEVFVPWCWJVGVHVIVN
    FWJWCVNFVJQLVK $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        The Lebesgue measure - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The Lebesgue measure is monotone with respect to set inclusion.
     (Contributed by Thierry Arnoux, 17-Oct-2017.) $)
  volss $p |- ( ( A e. dom vol /\ B e. dom vol /\ A C_ B )
    -> ( vol ` A ) <_ ( vol ` B ) ) $=
    ( cvol cdm wss w3a covol cfv cle cr wbr simp3 mblss 3ad2ant2 ovolss syl2anc
    wcel wceq mblvol 3ad2ant1 3brtr4d ) ACDZQZBUBQZABEZFZAGHZBGHZACHZBCHZIUFUEB
    JEZUGUHIKUCUDUELUDUCUKUEBMNABOPUCUDUIUGRUEASTUDUCUJUHRUEBSNUA $.

  ${
    $( The union of the Lebesgue measurable sets is ` RR ` .  (Contributed by
       Thierry Arnoux, 30-Jan-2017.) $)
    unidmvol $p |- U. dom vol = RR $=
      ( vx cvol cdm cuni cr wss wcel wceq cv unissb mblss mprgbir rembl unissel
      mp2an ) BCZDZEFZEPGQEHRAIZEFAPAPEJSKLMPENO $.
  $}

$(
  @{
    @d n y F @. @d n y X @. @d n y ph @.
    volmeaslem.1 @e |- ( ph -> X e. ~P dom vol ) @.
    volmeaslem.2 @e |- ( ph -> Disj_ y e. X y ) @.
    volmeaslem.3 @e |- ( ph -> F : NN -1-1-onto-> X ) @.
    volmeaslem.4 @e |- ( ( ph /\ y e. X ) -> ( vol ` y ) e. RR )  @.
    @( Lemma for ~ volmeas .
     (Contributed by Thierry Arnoux, 7-Apr-2017.) @)
    volmeaslem @p |- ( ph -> ( vol ` U. X ) = sum* y e. X ( vol ` y ) ) @=
      ( vn cvol cfv cn wcel cr wa wceq adantr syl2anc a1i nfcv cuni cesum caddc
      cv ciun cmpt c1 cseq crn cxr clt csup cdm wral wdisj cpw wf1o wf f1of syl
      ffvelrnda elelpwi ralrimiva fveq2 eleq1d rspcv sylc simpr disjrdx mpbird
      jca eqid voliun wfo f1ofo iunrdx uniiun syl6reqr fveq2d fvmpt2d cpnf cicc
      cc0 co volf ffvelrnd esumsup 3eqtr4d nfv eqidd esumf1o eqtr4d ) ADUAZJKZL
      IUDZCKZJKZIUBZDBUDZJKZBUBAILWPUEZJKZUCILWQUFZUGUHZUIUJUKULZWNWRAWPJUMZMZW
      QNMZOZILUNILWPUOZXBXEPAXIILAWOLMZOZXGXHXLWPDMZDXFUPZMZXGALDWOCALDCUQZLDCU
      RGLDCUSUTVAZAXOXKEQWPDXFVBRZXLXMWTNMZBDUNZXHXQAXTXKAXSBDHVCQXSXHBWPDWSWPP
      ZWTWQNWSWPJVDZVEVFVGZVKVCAXJBDWSUOFAIBLWPDWSCGAYAVHZVIVJWPXDIXCXDVLZXCVLZ
      VMRAWMXAJAXABDWSUEWMAIBLWPDWSCAXPLDCVNGLDCVOUTYDVPBDVQVRVSAWQIXCXDYEAILWQ
      XCNXCXCPAYFSYCVTXLXFWCWAWBWDZWPJXFYGJURZXLWESXRWFWGWHADWTLWQBICWPXNAIWIID
      TILTICTYBEGXLWPWJAWSDMZOZXFYGWSJYHYJWESYJYIXOWSXFMAYIVHAXOYIEQWSDXFVBRWFW
      KWL @.
      @( [7-Apr-2017] @)
  @}
$)

  ${
    $d k n $.  $d k A $.
    $( The Lebesgue measure function is countably additive.  This formulation
       on the extended reals, allows for ` +oo ` for the measure of any set in
       the sum.  Cf. ~ ovoliun and ~ voliun (Contributed by Thierry Arnoux,
       16-Oct-2017.) $)
    voliune $p |- ( ( A. n e. NN A e. dom vol /\ Disj_ n e. NN A ) ->
      ( vol ` U_ n e. NN A ) = sum* n e. NN ( vol ` A ) ) $=
      ( vk cvol wcel cn wral wa cfv wceq cpnf wrex cxr cc0 syl adantlr nfcv cle
      wbr wb cdm wdisj cr ciun cesum caddc cmpt cseq crn clt csup r19.26 voliun
      c1 eqid sylanbr an32s cv nfra1 nfan cicc co simpr csb nfcsb1v nfv csbeq1a
      weq equcoms eqcomd eleq1d cbvral rspc syl5bir impcom volf ffvelrni fvmpt2
      nfel1 syl2anc ex ralrimi esumeq2d cico wf r19.21bi w3a pnfxr elicc1 mp2an
      0xr simp2bi ltpnf elico2 syl3anbrc fmptdF nfmpt1 esumfsupre eqtr3d eqtr4d
      nffv nfeq1 fveq2d eqeq1d cbvrex sylib iunmbl adantr ssiun2sf adantl volss
      0re wss syl3anc ralrimiva r19.29r breq1 biimpa reximi c0 wne 1nn r19.9rzv
      ne0i mp2b sylibr iccssxr sseldi ad2antrr mpbid cvv nfdisj1 nfre1 nnex a1i
      xgepnf 3ad2antr3 3anassrs wo wn esumpinfval rexnal orbi2i r19.29 xrge0nre
      exmid mpbir sylan orim2d mpi mpjaodan ) ADUAZEZBFGZBFAUBZHZADIZUCEZBFGZBF
      AUDZDIZFUUQBUEZJUUQKJZBFLZUUPUUSHUVAUFBFUUQUGZUNUHZUIMUJUKZUVBUUNUUSUUOUV
      AUVGJZUUNUUSHZUUMUURHBFGUUOUVHUUMUURBFULAUVFBUVEUVFUOUVEUOZUMUPUQUUNUUSUV
      BUVGJUUOUVIFBURZUVEIZBUEZUVBUVGUVIFUVLUUQBUUNUUSBUUMBFUSZUURBFUSUTZUVIUVL
      UUQJZBFUVOUVIUVKFEZUVPUUNUVQUVPUUSUUNUVQHZUVQUUQNKVAVBZEZUVPUUNUVQVCUVRUU
      MUVTUVQUUNUUMUUNBCURZAVDZUULEZCFGUVQUUMUWCUUMCBFBUWBUULBUWAAVEZVSZUUMCVFZ
      CBVHZUWBAUULUWGAUWBAUWBJBCBUWAAVGZVIVJVKZVLUWCUUMCUVKFUWFUWIVMVNVOUULUVSA
      DVPVQZOZBFUUQUVSUVEUVJVRVTPWAWBWCUVIFNKWDVBZUVEWEUVMUVGJUVIBFUUQUWLUVEUVO
      BFQZBUWLQUVIUVQHZUURNUUQRSZUUQKUJSZUUQUWLEZUVIUURBFUUNUUSVCWFZUWNUVTUWOUU
      NUVQUVTUUSUWKPUVTUUQMEZUWOUUQKRSZNMEKMEZUVTUWSUWOUWTWGTWKWHNKUUQWIWJWLOUW
      NUURUWPUWRUUQWMONUCEUXAUWQUURUWOUWPWGTXLWHNKUUQWNWJWOUVJWPBUVEBFUUQWQWROW
      SPWTUUPUVDHZUVAKUVBUXBKUVARSZUVAKJZUXBUXCCFLZUXCUXBUWBDIZKJZUXFUVARSZHZCF
      LZUXEUXBUXGCFLZUXHCFGUXJUXBUVDUXKUUPUVDVCZUVCUXGBCFUVCCVFBUXFKBUWBDBDQUWD
      XAXBBCVHZUUQUXFKUXMAUWBDUWHXCXDXEXFUXBUXHCFUUPUWAFEZUXHUVDUUNUXNUXHUUOUUN
      UXNHUWCUUTUULEZUWBUUTXMZUXHUXNUUNUWCUUMUWCBUWAFUWEUXMAUWBUULUWHVKVMVOUUNU
      XOUXNABXGZXHUXNUXPUUNBFAUWAUWBUWMBUWAQUWDUWHXIXJUWBUUTXKXNPPXOUXGUXHCFXPV
      TUXIUXCCFUXGUXHUXCUXFKUVARXQXRXSOUNFEFXTYAUXCUXETYBFUNYDUXCCFYCYEYFUXBUVA
      MEZUXCUXDTUUNUXRUUOUVDUUNUXOUXRUXQUXOUVSMUVANKYGUULUVSUUTDVPVQYHOYIUVAYPO
      YJUXBFUUQBYKUUPUVDBUUNUUOBUVNBFAYLUTUVCBFYMUTFYKEUXBYNYOUUNUUOUVDUVQUVTUU
      NUUOUVQUVTUVDUWKYQYRUXLUUAWTUUNUUSUVDYSZUUOUUNUUSUURYTZBFLZYSZUXSUYBUUSUU
      SYTZYSUUSUUFUYAUYCUUSUURBFUUBUUCUUGUUNUYAUVDUUSUUNUYAUVDUUNUYAHUUMUXTHZBF
      LUVDUUMUXTBFUUDUYDUVCBFUUMUVTUXTUVCUWJUUQUUEUUHXSOWAUUIUUJXHUUK $.
  $}

  ${
    $d k n A $.  $d k B $.
    $( The Lebesgue measure function is countably additive.  This theorem is to
       ~ volfiniun what ~ voliune is to ~ voliun .  (Contributed by Thierry
       Arnoux, 16-Oct-2017.) $)
    volfiniune $p |- ( ( A e. Fin /\ A. n e. A B e. dom vol /\ Disj_ n e. A B )
      -> ( vol ` U_ n e. A B ) = sum* n e. A ( vol ` B ) ) $=
      ( vk cfn wcel cvol wral w3a cfv wceq cpnf wrex nfcv cc0 cle wbr syl cxr
      wa cdm wdisj cr ciun cesum csu simpl1 simpl2 simpr r19.26 sylanbrc simpl3
      volfiniun syl3anc nfel1 nfra1 nfdisj1 nf3an nfan cv cico co r19.21bi cicc
      clt csb nfcsb1v nfv csbeq1a equcoms eqcomd eleq1d cbvral rspc impcom volf
      syl5bir ffvelrni sylan wb 0xr pnfxr elicc1 mp2an simp2bi ltpnf 0re elico2
      syl3anbrc esumpfinvalf eqtr4d nffv nfeq1 fveq2d eqeq1d cbvrex wss adantll
      sylib finiunmbl adantr ssiun2sf adantl 3adantl3 adantlr ralrimiva r19.29r
      volss syl2anc breq1 biimpa reximi wex rexex iccssxr sseldi 3adant3 xgepnf
      19.9v mpbid nfre1 3ad2antl2 esumpinfval wo wn exmid rexnal mpbir xrge0nre
      orbi2i r19.29 ex orim2d mpi 3ad2ant2 mpjaodan ) AEFZBGUAZFZCAHZCABUBZIZBG
      JZUCFZCAHZCABUDZGJZAUUCCUEZKUUCLKZCAMZUUBUUETZUUGAUUCCUFZUUHUUKYQYSUUDTCA
      HZUUAUUGUULKYQYTUUAUUEUGZUUKYTUUEUUMYQYTUUAUUEUHZUUBUUEUIZYSUUDCAUJUKYQYT
      UUAUUEULABCUMUNUUKAUUCCCANZUUBUUECYQYTUUACCAEUUQUOYSCAUPCABUQURZUUDCAUPUS
      UUNUUKCUTZAFZTZUUDOUUCPQZUUCLVEQZUUCOLVAVBFZUUKUUDCAUUPVCZUVAUUCOLVDVBZFZ
      UVBUUKYTUUTUVGUUOYTUUTTYSUVGUUTYTYSYTCDUTZBVFZYRFZDAHUUTYSUVJYSDCACUVIYRC
      UVHBVGZUOZYSDVHZUVHUUSKZUVIBYRUVNBUVIBUVIKCDCUVHBVIZVJVKVLZVMUVJYSDUUSAUV
      MUVPVNVQVOYRUVFBGVPVRZRZVSUVGUUCSFZUVBUUCLPQZOSFLSFZUVGUVSUVBUVTIVTWAWBOL
      UUCWCWDWERUVAUUDUVCUVEUUCWFROUCFUWAUVDUUDUVBUVCIVTWGWBOLUUCWHWDWIWJWKUUBU
      UJTZUUGLUUHUWBLUUGPQZUUGLKZUWBUWCDAMZUWCUWBUVIGJZLKZUWFUUGPQZTZDAMZUWEUWB
      UWGDAMZUWHDAHUWJUWBUUJUWKUUBUUJUIZUUIUWGCDAUUIDVHCUWFLCUVIGCGNUVKWLWMUUSU
      VHKZUUCUWFLUWMBUVIGUVOWNWOWPWSUWBUWHDAUUBUVHAFZUWHUUJYQYTUWNUWHUUAYQYTTZU
      WNTUVJUUFYRFZUVIUUFWQZUWHYTUWNUVJYQUWNYTUVJYSUVJCUVHAUVLUWMBUVIYRUVOVLVNV
      OWRUWOUWPUWNABCWTZXAUWNUWQUWOCABUVHUVIUUQCUVHNUVKUVOXBXCUVIUUFXHUNXDXEXFU
      WGUWHDAXGXIUWIUWCDAUWGUWHUWCUWFLUUGPXJXKXLRUWEUWCDXMUWCUWCDAXNUWCDXSWSRUW
      BUUGSFZUWCUWDVTUUBUWSUUJYQYTUWSUUAUWOUWPUWSUWRUWPUVFSUUGOLXOYRUVFUUFGVPVR
      XPRXQXAUUGXRRXTUWBAUUCCEUUBUUJCUURUUICAYAUSYQYTUUAUUJUGUUBUUTUVGUUJYTYQUU
      TUVGUUAUVRYBXEUWLYCWKYTYQUUEUUJYDZUUAYTUUEUUDYEZCAMZYDZUWTUXCUUEUUEYEZYDU
      UEYFUXBUXDUUEUUDCAYGYJYHYTUXBUUJUUEYTUXBUUJYTUXBTYSUXATZCAMUUJYSUXACAYKUX
      EUUICAYSUVGUXAUUIUVQUUCYIVSXLRYLYMYNYOYP $.
  $}

  ${
    $d f n x y $.
    $( The Lebesgue measure is a measure.  (Contributed by Thierry Arnoux,
       16-Oct-2017.) $)
    volmeas $p |- vol e. ( measures ` dom vol ) $=
      ( vx vy vf vn cvol cfv wcel cc0 c0 wceq cv com wbr wa wral cen simpr nfan
      cn nfv cdm cmeas cpnf cicc co wf cdom wdisj cuni cesum wi volf covol 0mbl
      cpw mblvol ax-mp ovol0 eqtri cfn nfdisj1 wss elpwi sseldd ralrimi simplrr
      ad3antrrr w3a ciun uniiun fveq2i volfiniune syl5eq syl3anc wf1o bren nfcv
      ex wex fveq2 simpl a1i adantr sselda ffvelrnd esumf1o adantlr f1of adantl
      eqidd ffvelrnda ralrimiva id disjrdx biimpar syl2anc voliune f1ofo iunrdx
      syl6eqr fveq2d 3eqtr2rd exlimdv sylan2b wo brdom2 isfinite2 ensymb nnenom
      imp csdm entr mpan sylbi orim12i ad2antrl mpjaodan csiga crn wb fvssunirn
      rgen cr dmvlsiga sselii ismeas mpbir3an ) EEUAZUBFGZYHHUCUDUEZEUFZIEFZHJZ
      AKZLUGMZBYNBKZUHZNZYNUIZEFZYNYPEFZBUJZJZUKZAYHUOZOZULYLIUMFZHIYHGYLUUGJUN
      IUPUQURUSUUDAUUEYNUUEGZYRUUCUUHYRNZYNUTGZUUCSYNPMZUUIUUJNZUUJYPYHGZBYNOZY
      QUUCUUIUUJQUULUUMBYNUUIUUJBUUHYRBUUHBTYOYQBYOBTBYNYPVARRUUJBTRUULYPYNGZUU
      MUULUUONYNYHYPUUHYNYHVBZYRUUJUUOYNYHVCZVGUULUUOQVDVRVEUUHYOYQUUJVFUUJUUNY
      QVHYTBYNYPVIZEFUUBYSUUREBYNVJZVKYNYPBVLVMVNUUKUUISYNCKZVOZCVSZUUCSYNCVPUU
      IUVBUUCUUIUVAUUCCUUIUVAUUCUUIUVANZUUBSDKZUUTFZEFZDUJZDSUVEVIZEFZYTUUHUVAU
      UBUVGJYRUUHUVANZYNUUASUVFBDUUTUVEUUEUVJDTDYNVQDSVQDUUTVQYPUVEEVTUUHUVAWAU
      UHUVAQUVJUVDSGZNUVEWJUVJUUONZYHYJYPEYKUVLULWBUVJYNYHYPUUHUUPUVAUUQWCWDWEW
      FWGUVCUVEYHGZDSODSUVEUHZUVIUVGJUVCUVMDSUVCUVKNYNYHUVEUUHUUPYRUVAUVKUUQVGU
      VCSYNUVDUUTUVASYNUUTUFUUISYNUUTWHWIWKVDWLUVCUVAYQUVNUUIUVAQUUHYOYQUVAVFUV
      AUVNYQUVADBSUVEYNYPUUTUVAWMUVAYPUVEJQZWNWOWPUVEDWQWPUVAUVIYTJUUIUVAUVHYSE
      UVAUVHUURYSUVADBSUVEYNYPUUTSYNUUTWRUVOWSUUSWTXAWIXBVRXCXJXDYOUUJUUKXEZUUH
      YQYOYNLXKMZYNLPMZXEUVPYNLXFUVQUUJUVRUUKYNXGUVRLYNPMZUUKYNLXHSLPMUVSUUKXIS
      LYNXLXMXNXOXNXPXQVRYBYHXRXSUIZGYIYKYMUUFVHXTYCXRFUVTYHXRYCYAYDYEABYHEYFUQ
      YG $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
              The 'almost everywhere' relation
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c ae $. $( 'almost everywhere', noted &mu;-a.e. for a given measure &mu;. $)
  $c ~ae $. $( 'almost everywhere' builder for functions $)

  $( Extend class notation to include the 'almost everywhere' relation. $)
  cae $a class ae $.

  $( Extend class notation to include the 'almost everywhere' builder. $)
  cfae $a class ~ae $.

  ${
    $d a m $.
    $( Define 'almost everywhere' with regard to a measure ` M ` .  A property
       holds almost everywhere if the measure of the set where it does not hold
       has measure zero.  (Contributed by Thierry Arnoux, 20-Oct-2017.) $)
    df-ae $a |- ae = { <. a , m >. | ( m ` ( U. dom m \ a ) ) = 0 } $.

    $( 'almost everywhere' is a relation.  (Contributed by Thierry Arnoux,
       20-Oct-2017.) $)
    relae $p |- Rel ae $=
      ( vm va cv cdm cuni cdif cfv cc0 wceq cae df-ae relopabi ) ACZDEBCFMGHIBA
      JABKL $.
  $}

  ${
    $d a m A $.  $d a m M $.
    $( 'almost everywhere' relation for a measure and a measurable set ` A ` .
       (Contributed by Thierry Arnoux, 20-Oct-2017.) $)
    brae $p |- ( ( M e. U. ran measures /\ A e. dom M ) ->
      ( A ae M <-> ( M ` ( U. dom M \ A ) ) = 0 ) ) $=
      ( vm va cdm wcel cmeas crn cuni cae wbr cdif cfv cc0 wb cv wa simpr dmeqd
      wceq unieqd simpl difeq12d fveq12d eqeq1d df-ae brabga ancoms ) ABEZFBGHI
      ZFABJKUIIZALZBMZNTZOCPZEZIZDPZLZUOMZNTUNDCABJUIUJURATZUOBTZQZUTUMNVCUSULU
      OBVAVBRZVCUQUKURAVCUPUIVCUOBVDSUAVAVBUBUCUDUECDUFUGUH $.
  $}

  ${
    $d a m x O $.  $d a m M $.  $d a m ph $.
    braew.1 $e |- U. dom M = O $.
    $( 'almost everywhere' relation for a measure ` M ` and a property ` ph `
       (Contributed by Thierry Arnoux, 20-Oct-2017.) $)
    braew $p |- ( M e. U. ran measures -> ( { x e. O | ph } ae M
      <-> ( M ` { x e. O | -. ph } ) = 0 ) ) $=
      ( vm va cmeas cuni wcel crab cae cdm cdif cfv cc0 wceq cvv syl cv crn wbr
      wn wb dmexg uniexg syl5eqelr rabexg wa simpr dmeqd simpl difeq12d fveq12d
      unieqd eqeq1d df-ae brabga mpancom difeq1i notrab fveq2i eqeq1i syl6bb
      eqtri ) CHUAIZJZABDKZCLUBZCMZIZVHNZCOZPQZAUCBDKZCOZPQVHRJZVGVIVNUDVGDRJVQ
      VGDVKREVGVJRJVKRJCVFUEVJRUFSUGABDRUHSFTZMZIZGTZNZVROZPQVNGFVHCLRVFWAVHQZV
      RCQZUIZWCVMPWFWBVLVRCWDWEUJZWFVTVKWAVHWFVSVJWFVRCWGUKUOWDWEULUMUNUPFGUQUR
      USVMVPPVLVOCVLDVHNVOVKDVHEUTABDVAVEVBVCVD $.
  $}

  ${
    $d x O $.  $d x ph $.
    truae.1 $e |- U. dom M = O $.
    truae.2 $e |- ( ph -> M e. U. ran measures ) $.
    truae.3 $e |- ( ph -> ps ) $.
    $( A truth holds almost everywhere.  (Contributed by Thierry Arnoux,
       20-Oct-2017.) $)
    truae $p |- ( ph -> { x e. O | ps } ae M ) $=
      ( crab cae wbr wn cfv cc0 wceq c0 wss wcel syl cmeas cv wi wral ralrimivw
      pm2.24d rabss sylibr ss0 fveq2d crn cuni measbasedom measvnul sylbi eqtrd
      cdm wb braew mpbird ) ABCEIDJKZBLZCEIZDMZNOZAVCPDMZNAVBPDAVBPQZVBPOAVACUA
      PRZUBZCEUCVFAVHCEABVGHUEUDVACEPUFUGVBUHSUIADTUJUKRZVENOZGVIDDUPZTMRVJDULV
      KDUMUNSUOAVIUTVDUQGBCDEFURSUS $.
  $}

  ${
    $d x O $.
    aean.1 $e |- U. dom M = O $.
    $( A conjunction holds almost everywhere if and only if both its terms do.
       (Contributed by Thierry Arnoux, 20-Oct-2017.) $)
    aean $p |- ( ( M e. U. ran measures /\ { x e. O | -. ph } e. dom M
      /\ { x e. O | -. ps } e. dom M ) -> ( { x e. O | ( ph /\ ps ) } ae M
      <-> ( { x e. O | ph } ae M /\ { x e. O | ps } ae M ) ) ) $=
      ( wcel wn crab wa cfv cc0 wceq cae wbr wb a1i cle adantr syl3anc crn cuni
      cmeas cdm w3a cun wo unrab ianor rabbiia eqtr4i fveq2i eqeq1i measbasedom
      biimpi 3ad2ant1 simp2 csiga measbase syl unelsiga syl3an1 wss ssun1 simpr
      cv measssd breqtrd measle0 simp3 ssun2 jca cxad co measunl simprl oveq12d
      simprr cxr 0xr xaddid1 ax-mp syl6eq impbida syl5bbr braew anbi12d 3bitr4d
      ) DUCUAUBGZAHZCEIZDUDZGZBHZCEIZWLGZUEZABJZHZCEIZDKZLMZWKDKZLMZWODKZLMZJZW
      RCEIDNOZACEIDNOZBCEIDNOZJZXBWKWOUFZDKZLMZWQXGXMXALXLWTDXLWJWNUGZCEIWTWJWN
      CEUHWSXOCEWSXOPCVFEGABUIQUJUKULUMWQXNXGWQXNJZXDXFXPDWLUCKGZWMXCLROXDWQXQX
      NWIWMXQWPWIXQDUNUOZUPZSZWQWMXNWIWMWPUQZSXPXCXMLRWQXCXMROXNWQWKXLWLDXSYAWI
      WLURUAUBGZWMWPXLWLGZWIXQYBXRWLDUSZUTWKWOWLVAZVBZWKXLVCWQWKWOVDQVGSWQXNVEZ
      VHWKWLDVITXPXQWPXELROXFXTWQWPXNWIWMWPVJZSXPXEXMLRWQXEXMROXNWQWOXLWLDXSYHY
      FWOXLVCWQWOWKVKQVGSYGVHWOWLDVITVLWQXGJZXQYCXMLROXNWQXQXGXSSZYIYBWMWPYCYIX
      QYBYJYDUTWQWMXGYASZWQWPXGYHSZYETYIXMXCXEVMVNZLRYIWKWOWLDYJYKYLVOYIYMLLVMV
      NZLYIXCLXELVMWQXDXFVPWQXDXFVRVQLVSGYNLMVTLWAWBWCVHXLWLDVITWDWEWIWMXHXBPWP
      WRCDEFWFUPWIWMXKXGPWPWIXIXDXJXFACDEFWFBCDEFWFWGUPWH $.
  $}

  ${
    $d r m f g x $.
    $( Define a builder for an 'almost everywhere' relation between functions,
       from relations between function values.  In this definition, the range
       of ` f ` and ` g ` is enforced in order to ensure the resulting relation
       is a set.  (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    df-fae $a |- ~ae = ( r e. _V , m e. U. ran measures |-> { <. f , g >. |
      ( ( f e. ( dom r ^m U. dom m ) /\ g e. ( dom r ^m U. dom m ) ) /\
        { x e. U. dom m | ( f ` x ) r ( g ` x ) } ae m ) } ) $.
  $}

  ${
    $d f g m r x M $.  $d f g m r x R $.
    $( Value of the 'almost everywhere' relation for a given relation and
       measure.  (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    faeval $p |- ( ( R e. _V /\ M e. U. ran measures ) ->
      ( R ~ae M ) = { <. f , g >. |
        ( ( f e. ( dom R ^m U. dom M ) /\ g e. ( dom R ^m U. dom M ) ) /\
          { x e. U. dom M | ( f ` x ) R ( g ` x ) } ae M ) } ) $=
      ( vr vm cuni cv cdm cmap co wcel wa cfv wbr crab cae copab wceq cvv cmeas
      crn cfae simpl dmeqd simpr unieqd oveq12d anbi12d breqd rabeqbidv breq12d
      eleq2d opabbidv df-fae cxp ovex xpex opabssxp ssexi ovmpt2a ) FGBEUAUBUCH
      CIZFIZJZGIZJZHZKLZMZDIZVIMZNZAIZVCOZVNVKOZVDPZAVHQZVFRPZNZCDSVCBJZEJZHZKL
      ZMZVKWDMZNZVOVPBPZAWCQZERPZNZCDSZUDVDBTZVFETZNZVTWKCDWOVMWGVSWJWOVJWEVLWF
      WOVIWDVCWOVEWAVHWCKWOVDBWMWNUEZUFWOVGWBWOVFEWMWNUGZUFUHZUIZUNWOVIWDVKWSUN
      UJWOVRWIVFERWOVQWHAVHWCWRWOVDBVOVPWPUKULWQUMUJUOACDGFUPWLWDWDUQWDWDWAWCKU
      RZWTUSWJCDWDWDUTVAVB $.
  $}

  ${
    $d f g x M $.  $d f g x R $.
    $( The 'almost everywhere' builder for functions produces relations.
       (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    relfae $p |- ( ( R e. _V /\ M e. U. ran measures ) -> Rel ( R ~ae M ) ) $=
      ( vf vg vx cvv wcel cmeas crn cuni wa cfae co wrel cdm cmap cfv wbr crab
      cv cae copab relopab faeval releqd mpbiri ) AFGBHIJGKZABLMZNCTZAOBOJZPMZG
      DTZUKGKETZUIQUMULQAREUJSBUARKZCDUBZNUNCDUCUGUHUOEACDBUDUEUF $.
  $}

  ${
    $d f g x F $.  $d f g x G $.  $d f g x M $.  $d f g x R $.
    brfae.0 $e |- dom R = D $.
    brfae.1 $e |- ( ph -> R e. _V ) $.
    brfae.2 $e |- ( ph -> M e. U. ran measures ) $.
    brfae.3 $e |- ( ph -> F e. ( D ^m U. dom M ) ) $.
    brfae.4 $e |- ( ph -> G e. ( D ^m U. dom M ) ) $.
    $( 'almost everywhere' relation for two functions ` F ` and ` G ` with
       regard to the measure ` M ` .  (Contributed by Thierry Arnoux,
       22-Oct-2017.) $)
    brfae $p |- ( ph -> ( F ( R ~ae M ) G
      <-> { x e. U. dom M | ( F ` x ) R ( G ` x ) } ae M ) ) $=
      ( vf vg cv cmap wcel wa cfv wbr cdm cuni co crab copab cfae wb wceq simpl
      cae eleq1d simpr anbi12d fveq1d breq12d rabbidv breq1d brabga syl2anc cvv
      eqid cmeas crn faeval breqd oveq1i syl6eleqr jca biantrurd 3bitr4d ) AEFM
      OZDUAZGUAUBZPUCZQZNOZVNQZRZBOZVKSZVSVPSZDTZBVMUDZGUJTZRZMNUEZTZEVNQZFVNQZ
      RZVSESZVSFSZDTZBVMUDZGUJTZRZEFDGUFUCZTWOAECVMPUCZQFWRQWGWPUGKLWEWPMNEFWFW
      RWRVKEUHZVPFUHZRZVRWJWDWOXAVOWHVQWIXAVKEVNWSWTUIZUKXAVPFVNWSWTULZUKUMXAWC
      WNGUJXAWBWMBVMXAVTWKWAWLDXAVSVKEXBUNXAVSVPFXCUNUOUPUQUMWFVAURUSAWQWFEFADU
      TQGVBVCUBQWQWFUHIJBDMNGVDUSVEAWJWOAWHWIAEWRVNKVLCVMPHVFZVGAFWRVNLXDVGVHVI
      VJ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Measurable functions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c MblFnM $. $( Measurable function $)

  $( Extend class notation with the measurable functions builder. $)
  cmbfm $a class MblFnM $.

  ${
    $d f s t x $.
    $( Define the measurable function builder, which generates the set of
       measurable functions from a measurable space to another one.  Here, the
       measurable spaces are given using their sigma algebra ` s ` and ` t ` ,
       and the spaces themselves are recovered by ` U. s ` and ` U. t ` .

       Note the similarities between the definition of measurable functions in
       measure theory, and of continuous functions in topology.

       This is the definition for the generic measure theory.  For the specific
       case of functions from ` RR ` to ` CC ` , see ~ df-mbf (Contributed by
       Thierry Arnoux, 23-Jan-2017.) $)
    df-mbfm $a |- MblFnM = ( s e. U. ran sigAlgebra , t e. U. ran sigAlgebra
      |-> { f e. ( U. t ^m U. s ) | A. x e. t ( `' f " x ) e. s } ) $.
  $}

  ${
    $d f x F $.  $d f s t x S $.  $d f s t x T $.
    ismbfm.1 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    ismbfm.2 $e |- ( ph -> T e. U. ran sigAlgebra ) $.
    $( The predicate " ` F ` is a measurable function from the measurable space
       ` S ` to the measurable space ` T ` ".  Cf. ~ ismbf (Contributed by
       Thierry Arnoux, 23-Jan-2017.) $)
    ismbfm $p |- ( ph -> ( F e. ( S MblFnM T ) <->
            ( F e. ( U. T ^m U. S ) /\ A. x e. T ( `' F " x ) e. S ) ) ) $=
      ( vf vs vt cmbfm co wcel cv ccnv wral cuni cmap crab wceq csiga crn unieq
      cima wa oveq2d eleq2 ralbidv rabeqbidv oveq1d raleq df-mbfm rabex syl2anc
      ovex ovmpt2 eleq2d cnveq imaeq1d eleq1d elrab syl6bb ) AECDKLZMEHNZOZBNZU
      DZCMZBDPZHDQZCQZRLZSZMEVLMEOZVFUDZCMZBDPZUEAVCVMEACUAUBQZMDVRMVCVMTFGIJCD
      VRVRVGINZMZBJNZPZHWAQZVSQZRLZSVMKVHBWAPZHWCVKRLZSVSCTZWBWFHWEWGWHWDVKWCRV
      SCUCUFWHVTVHBWAVSCVGUGUHUIWADTZWFVIHWGVLWIWCVJVKRWADUCUJVHBWADUKUIBJHIULV
      IHVLVJVKRUOUMUPUNUQVIVQHEVLVDETZVHVPBDWJVGVOCWJVEVNVFVDEURUSUTUHVAVB $.
  $}

  ${
    $d x f $.  $d a s t F $.  $d f s t $.  $d s t x F $.
    $( The property of being a measurable function (Contributed by Thierry
       Arnoux, 23-Jan-2017.) $)
    elunirnmbfm $p |- ( F e. U. ran MblFnM <->
        E. s e. U. ran sigAlgebra E. t e. U. ran sigAlgebra
        ( F e. ( U. t ^m U. s ) /\ A. x e. t ( `' F " x ) e. s ) ) $=
      ( va vf cmbfm crn cuni wcel cv co csiga wrex cmap ccnv cima wral wa cfv
      cdm cxp wfun wb crab df-mbfm mpt2fun elunirn ax-mp ovex dmmpt2 rexeqi cop
      rabex fveq2 df-ov syl6eqr eleq2d rexxp 3bitri simpl simpr ismbfm 2rexbiia
      wceq bitri ) CGHIJZCDKZBKZGLZJZBMHIZNDVLNZCVIIZVHIZOLZJCPAKZQVHJAVIRSZBVL
      NDVLNVGCEKZGTZJZEGUAZNZWAEVLVLUBZNVMGUCVGWCUDDBVLVLFKPVQQVHJAVIRZFVPUEZGA
      BFDUFZUGECGUHUIWAEWBWDDBVLVLWFGWGWEFVPVNVOOUJUNUKULWAVKEDBVLVLVSVHVIUMZVE
      ZVTVJCWIVTWHGTVJVSWHGUOVHVIGUPUQURUSUTVKVRDBVLVLVHVLJZVIVLJZSAVHVICWJWKVA
      WJWKVBVCVDVF $.
  $}

  ${
    $d s t x F $.
    mbfmfun.1 $e |- ( ph -> F e. U. ran MblFnM ) $.
    $( A measurable function is a function.  (Contributed by Thierry Arnoux,
       24-Jan-2017.) $)
    mbfmfun $p |- ( ph -> Fun F ) $=
      ( vt vs vx cmbfm cuni wcel cv cmap co ccnv cima wral csiga wrex rexlimivw
      crn wa wfun elunirnmbfm biimpi wf elmapi ffun syl adantr 3syl ) ABGSHIZBD
      JZHZEJZHZKLIZBMFJNUMIFUKOZTZDPSHZQZEURQZBUAZCUJUTFDBEUBUCUSVAEURUQVADURUO
      VAUPUOUNULBUDVABULUNUEUNULBUFUGUHRRUI $.
  $}

  ${
    $d a s t x F $.  $d s t x S $.  $d t x T $.
    mbfmf.1 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    mbfmf.2 $e |- ( ph -> T e. U. ran sigAlgebra ) $.
    mbfmf.3 $e |- ( ph -> F e. ( S MblFnM T ) ) $.
    $( A measurable function as a function with domain and codomain
       (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
    mbfmf $p |- ( ph -> F : U. S --> U. T ) $=
      ( vx cuni cmap co wcel wf ccnv cv cima wral cmbfm wa ismbfm simpld elmapi
      mpbid syl ) ADCIZBIZJKLZUFUEDMAUGDNHOPBLHCQZADBCRKLUGUHSGAHBCDEFTUCUADUEU
      FUBUD $.

    $( The predicate to be a measurable function (Contributed by Thierry
       Arnoux, 30-Jan-2017.) $)
    isanmbfm $p |- ( ph -> F e. U. ran MblFnM ) $=
      ( vt vs vx cv cuni cmap co wcel wral wa crn wrex cmbfm csiga ismbfm mpbid
      ccnv cima wceq unieq oveq2d eleq2d ralbidv anbi12d oveq1d rspc2ev syl3anc
      eleq2 raleq elunirnmbfm sylibr ) ADHKZLZIKZLZMNZOZDUDJKUEZVAOZJUSPZQZHUAR
      LZSIVISZDTRLOABVIOCVIODCLZBLZMNZOZVEBOZJCPZQZVJEFADBCTNOVQGAJBCDEFUBUCVHV
      QDUTVLMNZOZVOJUSPZQIHBCVIVIVABUFZVDVSVGVTWAVCVRDWAVBVLUTMVABUGUHUIWAVFVOJ
      USVABVEUOUJUKUSCUFZVSVNVTVPWBVRVMDWBUTVKVLMUSCUGULUIVOJUSCUPUKUMUNJHDIUQU
      R $.

    $d x A $.
    mbfmcnvima.4 $e |- ( ph -> A e. T ) $.
    $( The preimage by a measurable function is a measurable set.  (Contributed
       by Thierry Arnoux, 23-Jan-2017.) $)
    mbfmcnvima $p |- ( ph -> ( `' F " A ) e. S ) $=
      ( vx wcel ccnv cv cima wral cuni cmap co cmbfm wa ismbfm mpbid wceq rspcv
      simprd imaeq2 eleq1d sylc ) ABDKELZJMZNZCKZJDOZUIBNZCKZIAEDPCPQRKZUMAECDS
      RKUPUMTHAJCDEFGUAUBUEULUOJBDUJBUCUKUNCUJBUIUFUGUDUH $.
  $}

  ${
    mbfmbfm.1 $e |- ( ph -> M e. U. ran measures ) $.
    mbfmbfm.2 $e |- ( ph -> J e. Top ) $.
    mbfmbfm.3 $e |- ( ph -> F e. ( dom M MblFnM ( sigaGen ` J ) ) ) $.
    $( A measurable function to a Borel Set is measurable.  (Contributed by
       Thierry Arnoux, 24-Jan-2017.) $)
    mbfmbfm $p |- ( ph -> F e. U. ran MblFnM ) $=
      ( cdm csigagen cfv cmeas cuni wcel csiga measbasedom biimpi measbase 3syl
      crn ctop sgsiga isanmbfm ) ADHZCIJBADKSLMZDUCKJMZUCNSLMEUDUEDOPUCDQRACTFU
      AGUB $.
  $}

  ${
    $d x A $.  $d y F $.  $d x y S $.  $d x y T $.  $d x y ph $.
    mbfmcst.1 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    mbfmcst.2 $e |- ( ph -> T e. U. ran sigAlgebra ) $.
    mbfmcst.3 $e |- ( ph -> F = ( x e. U. S |-> A ) ) $.
    mbfmcst.4 $e |- ( ph -> A e. U. T ) $.
    $( A constant function is measurable.  Cf. ~ mbfconst (Contributed by
       Thierry Arnoux, 26-Jan-2017.) $)
    mbfmcst $p |- ( ph -> F e. ( S MblFnM T ) ) $=
      ( vy wcel cuni ccnv cima adantr syl c0 cxp cdm cmbfm co cmap cv wf fmpt3d
      wral wb csiga crn unielsiga elmapg syl2anc mpbird cmpt csn wceq fconstmpt
      cin wa cres cnveqi cnvxp eqtr3i imaeq1i df-ima df-rn 3eqtri cvv inxp inv1
      df-res xpeq2i dmeqi xpeq2 xp0 syl6eq dmeqd dm0 adantl 0elsiga eqeltrd wne
      syl5eqel dmxp pm2.61dane ralrimivw cnveqd imaeq1d eleq1d ismbfm mpbir2and
      ralbidv ) AFDEUAUBLFEMZDMZUCUBLZFNZKUDZOZDLZKEUGZAWPWOWNFUEZABWOCWNFIACWN
      LBUDWOLJPUFAWNELZWODLZWPXBUHAEUIUJMZLXCHEUKQADXELZXDGDUKQZWNWOFEDULUMUNAX
      ABWOCUOZNZWROZDLZKEUGAXKKEAXKCUPZWRUSZRAXMRUQZUTZXJWOXMSZTZDXJXLWOSZWRVAZ
      NZTZXMWOSZNZTXQXJXRWROXSUJYAXIXRWRWOXLSZNXIXRYDXHBWOCURVBWOXLVCVDVEXRWRVF
      XSVGVHXTYCXSYBXSXRWRVISUSXMWOVIUSZSYBXRWRVLXLWOWRVIVJYEWOXMWOVKVMVHVBVNYC
      XPXMWOVCVNVHZXOXQRDXNXQRUQAXNXQRTRXNXPRXNXPWORSRXMRWOVOWOVPVQVRVSVQVTARDL
      ZXNAXFYGGDWAQPWBWDAXMRWCZUTZXJXQDYFYIXQWODYHXQWOUQAWOXMWEVTAXDYHXGPWBWDWF
      WGAWTXKKEAWSXJDAWQXIWRAFXHIWHWIWJWMUNAKDEFGHWKWL $.
  $}

  ${
    $d a z S $.  $d a z T $.  $d a z ph $.
    1stmbfm.1 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    1stmbfm.2 $e |- ( ph -> T e. U. ran sigAlgebra ) $.
    $( The first projection map is measurable with regard to the product sigma
       algebra.  (Contributed by Thierry Arnoux, 3-Jun-2017.) $)
    1stmbfm $p |- ( ph -> ( 1st |` ( U. S X. U. T ) )
                                               e. ( ( S sX T ) MblFnM S ) ) $=
      ( va vz c1st cuni co wcel csiga wceq syl2anc wb syl wa wss cfv adantr cxp
      cres csx cmbfm cmap ccnv cv cima wral f1stres sxuni feq2d mpbii unielsiga
      wf crn sxsiga elmapg mpbird cpw sgon sigasspw pwssb biimpi r19.21bi xpss1
      4syl sseld pm4.71rd wfn ffn elpreima mp2b fvres eleq1d c2nd 1st2nd2 xp2nd
      cop elxp6 anass an32 3bitr2i baib pm5.32i bitri syl6rbbr eqrdv simpr eqid
      bitr4d issgon biimpri sylancl baselsiga syl22anc eqeltrd ralrimiva ismbfm
      elsx mpbir2and ) AHBIZCIZUAZUBZBCUCJZBUDJKXEXBXFIZUEJKZXEUFFUGZUHZXFKZFBU
      IAXHXGXBXEUOZAXDXBXEUOZXLXBXCUJZAXDXGXBXEABLUPIZKZCXOKZXDXGMDEBCUKNULUMAX
      BBKZXGXFKZXHXLOAXPXRDBUNPAXFXOKZXSAXPXQXTDEBCUQNZXFUNPXBXGXEBXFURNUSAXKFB
      AXIBKZQZXJXIXCUAZXFYCGXJYDYCGUGZYDKZYEXDKZYFQZYEXJKZYCYFYGYCYDXDYEYCXIXBR
      ZYDXDRAYJFBAXPBXBLSKBXBUTRZYJFBUIZDBVAXBBVBYKYLFBXBVCVDVGVEXIXBXCVFPVHVIY
      IYGYEXESZXIKZQZYHXMXEXDVJYIYOOXNXDXBXEVKXDYEXIXEVLVMYGYNYFYGYNYEHSZXIKZYF
      YGYMYPXIYEXDHVNVOYGYEYPYEVPSZVSMZYRXCKZYFYQOYEXBXCVQYEXBXCVRYFYSYTQZYQYFY
      SYQYTQQYSYQQYTQUUAYQQYEXIXCVTYSYQYTWAYSYQYTWBWCWDNWKWEWFWGWHYCXPXQYBXCCKZ
      YDXFKAXPYBDTAXQYBETAYBWIAUUBYBACXCLSKZUUBAXQXCXCMZUUCEXCWJUUCXQUUDQCXCWLW
      MWNXCCWOPTXIXCBCXOXOWTWPWQWRAFXFBXEYADWSXA $.

    $( The second projection map is measurable with regard to the product sigma
       algebra (Contributed by Thierry Arnoux, 3-Jun-2017.) $)
    2ndmbfm $p |- ( ph -> ( 2nd |` ( U. S X. U. T ) )
                                                e. ( ( S sX T ) MblFnM T ) ) $=
      ( va vz c2nd cuni co wcel csiga wceq syl2anc wb syl wa wss cfv adantr cxp
      cres csx cmbfm cmap ccnv cv cima wral f2ndres sxuni feq2d mpbii unielsiga
      wf crn sxsiga elmapg mpbird cpw sgon sigasspw pwssb biimpi r19.21bi xpss2
      4syl sseld pm4.71rd wfn ffn elpreima mp2b fvres eleq1d c1st 1st2nd2 xp1st
      cop elxp6 anass bitr4i bitr4d pm5.32i bitri syl6rbbr eqrdv issgon biimpri
      baib eqid sylancl baselsiga simpr elsx eqeltrd ralrimiva ismbfm mpbir2and
      syl22anc ) AHBIZCIZUAZUBZBCUCJZCUDJKXDXBXEIZUEJKZXDUFFUGZUHZXEKZFCUIAXGXF
      XBXDUOZAXCXBXDUOZXKXAXBUJZAXCXFXBXDABLUPIZKZCXNKZXCXFMDEBCUKNULUMAXBCKZXF
      XEKZXGXKOAXPXQECUNPAXEXNKZXRAXOXPXSDEBCUQNZXEUNPXBXFXDCXEURNUSAXJFCAXHCKZ
      QZXIXAXHUAZXEYBGXIYCYBGUGZYCKZYDXCKZYEQZYDXIKZYBYEYFYBYCXCYDYBXHXBRZYCXCR
      AYIFCAXPCXBLSKCXBUTRZYIFCUIZECVAXBCVBYJYKFCXBVCVDVGVEXHXBXAVFPVHVIYHYFYDX
      DSZXHKZQZYGXLXDXCVJYHYNOXMXCXBXDVKXCYDXHXDVLVMYFYMYEYFYMYDHSZXHKZYEYFYLYO
      XHYDXCHVNVOYFYDYDVPSZYOVSMZYQXAKZYEYPOYDXAXBVQYDXAXBVRYEYRYSQZYPYEYRYSYPQ
      QYTYPQYDXAXHVTYRYSYPWAWBWJNWCWDWEWFWGYBXOXPXABKZYAYCXEKAXOYADTAXPYAETAUUA
      YAABXALSKZUUAAXOXAXAMZUUBDXAWKUUBXOUUCQBXAWHWIWLXABWMPTAYAWNXAXHBCXNXNWOW
      TWPWQAFXECXDXTEWRWS $.
  $}

  ${
    $d a x y F $.  $d a x y K $.  $d a x y S $.  $d a x y T $.  $d a x y ph $.
    imambfm.1 $e |- ( ph -> K e. _V ) $.
    imambfm.2 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    imambfm.3 $e |- ( ph -> T = ( sigaGen ` K ) ) $.
    $( If the sigma-algebra in the range of a given function is generated by a
       collection of basic sets ` K ` , then to check the measurability of that
       function, we need only consider inverse images of basic sets ` a ` .
       (Contributed by Thierry Arnoux, 4-Jun-2017.) $)
    imambfm $p |- ( ph -> ( F e. ( S MblFnM T )
                <-> ( F : U. S --> U. T /\ A. a e. K ( `' F " a ) e. S ) ) ) $=
      ( vx vy wcel cuni cima wral wa adantr wss syl wceq cmbfm co wf ccnv csiga
      crn csigagen cfv cvv sgsiga eqeltrd simpr mbfmf ad2antrr simplr sssigagen
      cv sseqtr4d sseldd mbfmcnvima ralrimiva jca cmap unielsiga simprl biimpar
      elmapg syl21anc crab cpw cdif com wbr wi w3a simpl ssrab2 pwuni sstri a1i
      cdom fimacnv ad2antrl imaeq2 eleq1d elrab elrabi adantl difelsiga syl3anc
      sylanbrc wfun simplrl ffun difpreima 3syl difeq1d simprbi ad3antrrr sspwb
      mpbi ad2antlr sigaclcu ciun simpllr simpld unipreima elelpwi syl2anc nfcv
      sseli sigaclcuni ex 3jca rabexg issiga syl12anc unieqd unisg eqtrd fveq2d
      eleq2d mpbid simprr ssrab sigagenss eqsstrd eqssd rabid2 ismbfm mpbir2and
      wb sylib impbida ) ADBCUAUBLZBMZCMZDUCZDUDZFUQZNZBLZFEOZPZAYOPZYRUUCUUEBC
      DABUEUFMZLZYOHQACUUFLZYOACEUGUHZUUFIAEUIGUJUKZQAYOULUMUUEUUBFEUUEYTELZPZY
      TBCDAUUGYOUUKHUNAUUHYOUUKUUJUNAYOUUKUOUULECYTAECRZYOUUKAEUUICAEUILZEUUIRG
      EUIUPSIURZUNUUEUUKULUSUTVAVBAUUDPZYODYQYPVCUBLZUUBFCOZUUPYQCLZYPBLZYRUUQA
      UUSUUDAUUHUUSUUJCVDZSQZAUUTUUDAUUGUUTHBVDZSQZAYRUUCVEUUSUUTPUUQYRYQYPDCBV
      GVFVHUUPCUUBFCVIZTUURUUPCUVEUUPCUUIUVEACUUITUUDIQUUPUVEEMZUEUHZLZEUVERZUU
      IUVERUUPUVEYQUEUHZLZUVHUUPAUVEYQVJZRZYQUVELZYQJUQZVKZUVELZJUVEOZUVOVLWAVM
      ZUVOMZUVELZVNZJUVEVJZOZVOZUVKAUUDVPUVMUUPUVECUVLUUBFCVQZCVRVSVTUUPUVNUVRU
      WDUUPUUSYSYQNZBLZUVNUVBUUPUWGYPBYRUWGYPTAUUCYPYQDWBWCZUVDUKUUBUWHFYQCYTYQ
      TUUAUWGBYTYQYSWDWEWFWKUUPUVQJUVEUUPUVOUVELZPZUVPCLZYSUVPNZBLZUVQUWKUUHUUS
      UVOCLZUWLAUUHUUDUWJUUJUNZUWKUUHUUSUWPUVASUWJUWOUUPUUBFUVOCWGWHYQUVOCWIWJU
      WKUWMUWGYSUVONZVKZBUWKYRDWLZUWMUWRTAYRUUCUWJWMYPYQDWNZYQUVODWOWPUWKUWRYPU
      WQVKZBUUPUWRUXATUWJUUPUWGYPUWQUWIWQQUWKUUGUUTUWQBLZUXABLAUUGUUDUWJHUNZUWK
      UUGUUTUXCUVCSUWJUXBUUPUWJUWOUXBUUBUXBFUVOCYTUVOTUUAUWQBYTUVOYSWDWEWFWRWHY
      PUWQBWIWJUKUKUUBUWNFUVPCYTUVPTUUAUWMBYTUVPYSWDWEWFWKVAUUPUWBJUWCUUPUVOUWC
      LZPZUVSUWAUXEUVSPZUVTCLZYSUVTNZBLZUWAUXFUUHUVOCVJZLZUVSUXGAUUHUUDUXDUVSUU
      JWSUXDUXKUUPUVSUWCUXJUVOUVECRZUWCUXJRUWFUVECWTXAXKXBUXEUVSULZUVOCXCWJUXFU
      XHKUVOYSKUQZNZXDZBUXFYRUWSUXHUXPTUXFYRUUCAUUDUXDUVSXEXFUWTKUVODXGWPUXFUUG
      UXOBLZKUVOOUVSUXPBLAUUGUUDUXDUVSHWSUXFUXQKUVOUXFUXNUVOLZPZUXNUVELZUXQUXSU
      XRUXDUXTUXFUXRULUUPUXDUVSUXRXEUXNUVOUVEXHXIUXTUXNCLUXQUUBUXQFUXNCYTUXNTUU
      AUXOBYTUXNYSWDWEWFWRSVAUXMUVOUXOBKKUVOXJXLWJUKUUBUXIFUVTCYTUVTTUUAUXHBYTU
      VTYSWDWEWFWKXMVAXNAUVKUVMUWEPZAUUHUVEUILUVKUYAYLUUJUUBFCUUFXOJUVEYQXPWPVF
      XQAUVKUVHYLUUDAUVJUVGUVEAYQUVFUEAYQUUIMZUVFACUUIIXRAUUNUYBUVFTGEUIXSSXTYA
      YBQYCUUPUUMUUCUVIAUUMUUDUUOQAYRUUCYDUUBFCEYEWKEUVEYFXIYGUXLUUPUWFVTYHUUBF
      CYIYMUUPFBCDAUUGUUDHQAUUHUUDUUJQYJYKYN $.
  $}

  ${
    $d a F $.  $d a K $.  $d a S $.  $d a T $.  $d a ph $.
    cnmbfm.1 $e |- ( ph -> F e. ( J Cn K ) ) $.
    cnmbfm.2 $e |- ( ph -> S = ( sigaGen ` J ) ) $.
    cnmbfm.3 $e |- ( ph -> T = ( sigaGen ` K ) ) $.
    $( A continuous function is measurable with respect to the Borel Algebra of
       its domain and range.  (Contributed by Thierry Arnoux, 3-Jun-2017.) $)
    cnmbfm $p |- ( ph -> F e. ( S MblFnM T ) ) $=
      ( va co wcel cuni wf eqid syl csigagen cfv ctop 3syl cmbfm ccnv cima wral
      ccn cnf unieqd wceq cntop1 unisg eqtrd cntop2 feq23d mpbird wss sssigagen
      cv wa sseqtr4d adantr cnima sylan sseldd ralrimiva elex csiga sigagensiga
      cvv crn eqeltrd elrnsiga imambfm mpbir2and ) ADBCUAKLBMZCMZDNZDUBJUQZUCZB
      LZJFUDAVPEMZFMZDNZADEFUEKLZWBGDEFVTWAVTOWAOUFPAVNVOVTWADAVNEQRZMZVTABWDHU
      GAWCESLZWEVTUHGDEFUIZESUJTUKAVOFQRZMZWAACWHIUGAWCFSLZWIWAUHGDEFULZFSUJTUK
      UMUNAVSJFAVQFLZUREBVRAEBUOWLAEWDBAWCWFEWDUOGWGESUPTHUSUTAWCWLVRELGVQDEFVA
      VBVCVDABCDFJAWCWJFVHLGWKFSVETABVTVFRZLBVFVIMLABWDWMHAWCWFWDWMLGWGESVGTVJB
      VTVKPIVLVM $.
  $}

  ${
    mbfmco.1 $e |- ( ph -> R e. U. ran sigAlgebra ) $.
    mbfmco.2 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    mbfmco.3 $e |- ( ph -> T e. U. ran sigAlgebra ) $.
    ${
      $d a F $.  $d a G $.  $d a R $.  $d a T $.  $d a ph $.
      mbfmco.4 $e |- ( ph -> F e. ( R MblFnM S ) ) $.
      mbfmco.5 $e |- ( ph -> G e. ( S MblFnM T ) ) $.
      $( The composition of two measurable functions is measurable.  ( cf.
         ~ cnmpt11 ) (Contributed by Thierry Arnoux, 4-Jun-2017.) $)
      mbfmco $p |- ( ph -> ( G o. F ) e. ( R MblFnM T ) ) $=
        ( va cmbfm co wcel cuni ccnv cima wf adantr ccom cmap cv wral mbfmf fco
        syl2anc wb csiga crn unielsiga syl elmapg mpbird wa cnvco imaeq1i imaco
        eqtri simpr mbfmcnvima syl5eqel ralrimiva ismbfm mpbir2and ) AFEUAZBDMN
        OVFDPZBPZUBNOZVFQZLUCZRZBOZLDUDAVIVHVGVFSZACPZVGFSVHVOESVNACDFHIKUEABCE
        GHJUEVHVOVGFEUFUGAVGDOZVHBOZVIVNUHADUIUJPZOZVPIDUKULABVROZVQGBUKULVGVHV
        FDBUMUGUNAVMLDAVKDOZUOZVLEQZFQZVKRZRZBVLWCWDUAZVKRWFVJWGVKFEUPUQWCWDVKU
        RUSWBWEBCEAVTWAGTACVROWAHTZAEBCMNOWAJTWBVKCDFWHAVSWAITAFCDMNOWAKTAWAUTV
        AVAVBVCALBDVFGIVDVE $.
    $}

    ${
      $d a b c H $.  $d a b c R $.  $d a b c S $.  $d a b c T $.
      $d a b c ph $.  $d x R $.  $d x S $.  $d x T $.  $d x ph $.  $d x F $.
      $d x G $.  $d x H $.
      mbfmco2.4 $e |- ( ph -> F e. ( R MblFnM S ) ) $.
      mbfmco2.5 $e |- ( ph -> G e. ( R MblFnM T ) ) $.
      mbfmco2.6 $e |- H = ( x e. U. R |-> <. ( F ` x ) , ( G ` x ) >. ) $.
      $( The pair building of two measurable functions is measurable.  ( cf.
         ~ cnmpt1t ).  (Contributed by Thierry Arnoux, 6-Jun-2017.) $)
      mbfmco2 $p |- ( ph -> H e. ( R MblFnM ( S sX T ) ) ) $=
        ( vc va vb wcel cuni 3ad2ant1 csx co cmbfm wf ccnv cv cima cxp crn wral
        cmpt2 cfv cop mbfmf ffvelrnda opelxpi syl2anc wceq csiga adantr eleqtrd
        sxuni fmptd wrex eqid vex xpex elrnmpt2 w3a simp3 imaeq2d simp2l simp2r
        wa simp1 cin xppreima2 simp2 mbfmcnvima inelsiga syl3anc eqeltrd 3expia
        rexlimdvva imp sylan2b ralrimiva cvv txbasex csigagen imambfm mpbir2and
        sxval ) AHCDEUAUBZUCUBRCSZWNSZHUDHUEZOUFZUGZCRZOPQDEPUFZQUFZUHZUKZUIZUJ
        ABWOBUFZFULZXFGULZUMZWPHAXFWORZVNZXIDSZESZUHZWPXKXGXLRXHXMRXIXNRAWOXLXF
        FACDFIJLUNZUOAWOXMXFGACEGIKMUNZUOXGXHXLXMUPUQAXNWPURZXJADUSUISZRZEXRRZX
        QJKDEVBUQUTVANVCAWTOXEWRXERAWRXCURZQEVDPDVDZWTPQDEXCWRXDXDVEXAXBPVFQVFV
        GVHAYBWTAYAWTPQDEAXADRZXBERZVNZYAWTAYEYAVIZWSWQXCUGZCYFWRXCWQAYEYAVJVKY
        FAYCYDYGCRAYEYAVOAYCYDYAVLAYCYDYAVMAYCYDVIZYGFUEXAUGZGUEXBUGZVPZCAYCYGY
        KURYDABWOXLXMFGHXAXBXOXPNVQTYHCXRRZYICRYJCRYKCRAYCYLYDITZYHXACDFYMAYCXS
        YDJTAYCFCDUCUBRYDLTAYCYDVRVSYHXBCEGYMAYCXTYDKTAYCGCEUCUBRYDMTAYCYDVJVSY
        IYJCVTWAWBWAWBWCWDWEWFWGACWNHXEOAXSXTXEWHRJKPQXEDEXRXRXEVEZWIUQIAXSXTWN
        XEWJULURJKPQXEDEXRXRYNWMUQWKWL $.
    $}
  $}

  ${
    $( Measurable functions with respect to the Lebesgue measure are
       real-valued functions on the real numbers.  (Contributed by Thierry
       Arnoux, 27-Mar-2017.) $)
    mbfmvolf $p |- ( F e. ( dom vol MblFnM BrSiga ) -> F : RR --> RR ) $=
      ( cvol cdm cbrsiga cmbfm co wcel cuni wf cr csiga crn wceq wa issgon mpbi
      cfv simpli a1i simpri dmvlsiga brsigarn id mbfmf feq23i sylibr ) ABCZDEFG
      ZUGHZDHZAIJJAIUHUGDAUGKLHZGZUHULJUIMZUGJKQZGULUMNUAUGJOPZRSDUKGZUHUPJUJMZ
      DUNGUPUQNUBDJOPZRSUHUCUDJJUIUJAULUMUOTUPUQURTUEUF $.
  $}

$(
  @{
    @d x F @.
    mbfmvol.1 @e |- S = ( sigaGen ` ( MetOpen ` ( abs o. - ) ) ) @.
    @( Measurable functions with respect to the Lebesgue measure are
       complex-valued functions in ` MblFn ` .
       (Contributed by Thierry Arnoux, 27-Mar-2017.) @)
    mbfmvol @p |- ( MblFnM ` <. dom vol , S >. )
                                                = ( MblFn i^i ( CC ^m RR ) ) @=
      ? @.
      @( [27-Mar-2017] @)
  @}

  @{
    @d x F @.
    @( Measurable functions with respect to the Lebesgue measure are
       real-valued functions in ` MblFn ` .
       (Contributed by Thierry Arnoux, 27-Mar-2017.) @)
    elmbfmvol @p |- ( F e. ( MblFnM ` <. dom vol , BrSiga >. ) <->
                                          ( F e. MblFn /\ F : RR --> RR ) ) @=
      ? @.
      @( [27-Mar-2017] @)
  @}
$)

  ${
    $d x F $.
    $( Measurable functions with respect to the Lebesgue measure.  We only have
       the inclusion, since ` MblFn ` includes complex-valued functions.
       (Contributed by Thierry Arnoux, 26-Jan-2017.) $)
    elmbfmvol2 $p |- ( F e. ( dom vol MblFnM BrSiga ) -> F e. MblFn ) $=
      ( vx cvol cbrsiga co wcel crn wral wss cfv ctb ax-mp ctop cuni cmap wb cr
      csiga elrnsiga mp1i cdm cmbfm cmbf ccnv cima cioo csigagen retopbas bastg
      cv ctg retop sssigagen sstri df-brsiga sseqtr4i wceq wa dmvlsiga brsigarn
      eqid ismbfm simprbi ssralv mpsyl simplbi elmapi unibrsiga unidmvol eleq2s
      wf oveq12i ismbf 3syl mpbird ) ACUAZDUBEFZAUCFZAUDBUJUEVPFZBUFGZHZVTDIVQV
      SBDHZWAVTVTUKJZUGJZDVTWCWDVTKFVTWCIUHVTKUILWCMFWCWDIULWCMUMLUNUOUPVQADNZV
      PNZOEZFZWBCCUQZVQWHWBURPCVAWIBVPDAVPQRJZFVPRGNZFWIUSVPQSTDWJFDWKFWIUTDQST
      VBLZVCVSBVTDVDVEVQWHQQAVKZVRWAPVQWHWBWLVFWMAQQOEWGAQQVGWEQWFQOVHVIVLVJBQA
      VMVNVO $.
  $}

  ${
    $d f x y O $.  $d f V $.
    $( All functions are measurable with respect to the counting measure.
       (Contributed by Thierry Arnoux, 24-Jan-2017.) $)
    mbfmcnt $p |- ( O e. V -> ( ~P O MblFnM BrSiga ) = ( RR ^m O ) ) $=
      ( vf vx vy wcel cbrsiga co cuni cmap cr cv wa csiga elrnsiga wf unibrsiga
      cfv cvv syl6bi cpw ccnv cima wral crn pwsiga syl brsigarn mp1i ismbfm wfn
      cmbfm wb reex eqeltri unipw elex syl5eqel elmapg sylancr feq2i syl6bb ffn
      wss elpreima simpl ssrdv cnvex imaexg ax-mp elpw sylibr ralrimivw pm4.71d
      vex syl6 bitr4d eqrdv oveq12i syl6eq ) ABFZAUAZGULHZGIZWBIZJHZKAJHWACWCWF
      WACLZWCFWGWFFZWGUBZDLZUCZWBFZDGUDZMWHWADWBGWGWAWBANRFWBNUEIZFABUFWBAOUGGK
      NRFGWNFWAUHGKOUIUJWAWHWMWAWHWGAUKZWMWAWHAWDWGPZWOWAWHWEWDWGPZWPWAWDSFWESF
      WHWQUMWDKSQUNUOWAWEASAUPZABUQURWDWEWGSSUSUTWEAWDWGWRVAVBAWDWGVCTWOWLDGWOW
      KAVDWLWOEWKAWOELZWKFWSAFZWSWGRWJFZMWTAWSWJWGVEWTXAVFTVGWKAWISFWKSFWGCVOVH
      WIWJSVIVJVKVLVMVPVNVQVRWDKWEAJQWRVSVT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
              Borel Algebra on ` ( RR X. RR ) `
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y $.
    $( The base set for the generator of the Borel sigma algebra on
       ` ( RR X. RR ) ` is indeed ` ( RR X. RR ) ` .  (Contributed by Thierry
       Arnoux, 22-Sep-2017.) $)
    br2base $p |- U. ran ( x e. BrSiga , y e. BrSiga |-> ( x X. y ) )
       = ( RR X. RR ) $=
      ( cbrsiga cv cxp crn cr cpw cuni wceq wcel wral brsigasspwrn sseli elpwid
      wss vex eqid ax-mp wrex wa xpss12 syl2an xpex elpw sylibr rgen2a rnmpt2ss
      cmpt2 unibrsiga csiga cfv brsigarn elrnsiga unielsiga mp2b eqeltrri xpeq1
      wb eqeq2d xpeq2 rspc2ev mp3an elrnmpt2 mpbir elpwuni mpbi ) ABCCADZBDZEZU
      IZFZGGEZHZPZVLIVMJZVJVNKZBCLACLVOVQABCVHCKZVICKZUAVJVMPZVQVRVHGPVIGPVTVSV
      RVHGCGHZVHMNOVSVIGCWAVIMNOVHGVIGUBUCVJVMVHVIAQBQUDZUEUFUGABCCVJVNVKVKRZUH
      SVMVLKZVOVPUSWDVMVJJZBCTACTZGCKZWGVMVMJZWFCIZGCUJCGUKULKCUKFIKWICKUMCGUNC
      UOUPUQZWJVMRWEWHVMGVIEZJABGGCCVHGJVJWKVMVHGVIURUTVIGJWKVMVMVIGGVAUTVBVCAB
      CCVJVMVKWCWBVDVEVLVMVFSVG $.
  $}

  ${
    $( An upper bound for a dyadic number.  (Contributed by Thierry Arnoux,
       19-Sep-2017.) $)
    dya2ub $p |- ( R e. RR+ ->
      ( 1 / ( 2 ^ ( |_ ` ( 1 - ( 2 logb R ) ) ) ) ) < R ) $=
      ( crp wcel c1 c2 clogb co cmin cfl cfv clt cneg caddc cr cz rnlogbcl wceq
      wbr a1i syl2anc cexp cdiv cuz 2z uzid ax-mp renegcld flltp1 syl 1z fladdz
      mpan sylancl cc recnd ax-1cn negsubdi negsubdi2 eqtr3d fveq2d breqtrd 2rp
      wa wb resubcld flcld rpexpcld rpreccld id logblt syl3anc breq1d ltnegcon1
      1re logbrec 3bitrd nnlogbexp breq2d bitrd mpbird ) ABCZDEDEAFGZHGZIJZUAGZ
      UBGZAKRZWBLZWDKRZWAWHWHIJDMGZWDKWAWHNCZWHWJKRWAWBEEUCJCZWAWBNCZEOCWLUDEUE
      UFZEAPULZUGZWHUHUIWAWHDMGZIJZWJWDWAWKDOCWRWJQWPUJWHDUKUMWAWQWCIWAWBUNCZDU
      NCZWQWCQWAWBWOUOUPWSWTVCWBDHGLWQWCWBDUQWBDURUSUMUTUSVAWAWGWHEWEFGZKRZWIWA
      WGEWFFGZWBKRZXALZWBKRZXBWAWLWFBCWAWGXDVDWLWAWNSZWAWEWAEWDEBCWAVBSWAWCWADW
      BDNCWAVNSWOVEVFZVGZVHWAVIEWFAVJVKWAXCXEWBKWAWLWEBCZXCXEQXGXIWEEVOTVLWAXAN
      CZWMXFXBVDWAWLXJXKXGXIEWEPTWOXAWBVMTVPWAXAWDWHKWAWLWDOCXAWDQXGXHEWDVQTVRV
      SVT $.
  $}

  ${
    $d e f z $.
    $( The closed half-spaces of ` ( RR X. RR ) ` cover ` ( RR X. RR ) ` .
       (Contributed by Thierry Arnoux, 11-Oct-2017.) $)
    sxbrsigalem0 $p |- U. ( ran ( e e. RR |-> ( ( e [,) +oo ) X. RR ) )
      u. ran ( f e. RR |-> ( RR X. ( f [,) +oo ) ) ) ) = ( RR X. RR ) $=
      ( vz cr cv cpnf cico co cxp cmpt cuni wss wcel pnfxr syl ovex reex cfv wa
      xpex crn cun unissb wo elun cpw eqid rnmptss cxr icossre mpan2 xpss1 elpw
      sylibr mprg sseli elpwid xpss2 jaoi mprgbir wfun c1st funmpt cvv c2nd clt
      sylbi wbr rexr a1i ltpnf lbico1 syl3anc anim1i anim2i elxp7 3imtr4i xp1st
      wceq oveq1 xpeq1d fvmpt eleqtrrd elunirn2 sylancr ssriv ssun3 ax-mp uniun
      sseqtr4i eqssi ) ADAEZFGHZDIZJZUAZBDDBEZFGHZIZJZUAZUBZKZDDIZXCXDLCEZXDLZC
      XBCXBXDUCXEXBMXEWPMZXEXAMZUDXFXEWPXAUEXGXFXHXGXEXDWPXDUFZXEWNXIMZWPXILADA
      DWNXIWOWOUGZUHWLDMZWNXDLZXJXLWMDLZXMXLFUIMZXNNWLFUJUKWMDDULOWNXDWMDWLFGPQ
      TUMUNUOUPUQXHXEXDXAXIXEWSXIMZXAXILBDBDWSXIWTWTUGUHWQDMZWSXDLZXPXQWRDLZXRX
      QXOXSNWQFUJUKWRDDUROWSXDDWRQWQFGPTUMUNUOUPUQUSVGUTXDWPKZXAKZUBZXCXDXTLXDY
      BLCXDXTXEXDMZWOVAXEXEVBRZWORZMXEXTMADWNVCYCXEYDFGHZDIZYEXEVDVDIMZYDDMZXEV
      ERDMZSZSYHYDYFMZYJSZSYCXEYGMYKYMYHYIYLYJYIYDUIMXOYDFVFVHYLYDVIXOYINVJYDVK
      YDFVLVMVNVOXEDDVPXEYFDVPVQYCYIYEYGVSXEDDVRAYDWNYGDWOWLYDVSWMYFDWLYDFGVTWA
      XKYFDYDFGPQTWBOWCYDXEWOWDWEWFXDXTYAWGWHWPXAWIWJWK $.
  $}

  ${
    sxbrsiga.0 $e |- J = ( topGen ` ran (,) ) $.

    ${
      $d e f u v $.  $d u v J $.
      $( The sigma-algebra generated by the closed half-spaces of
         ` ( RR X. RR ) ` is a subset of the sigma-algebra generated by the
         closed sets of ` ( RR X. RR ) ` .  (Contributed by Thierry Arnoux,
         11-Oct-2017.) $)
      sxbrsigalem3 $p |-
         ( sigaGen ` ( ran ( e e. RR |-> ( ( e [,) +oo ) X. RR ) )
                    u. ran ( f e. RR |-> ( RR X. ( f [,) +oo ) ) ) ) )
           C_ ( sigaGen ` ( Clsd ` ( J tX J ) ) ) $=
        ( vu vv cr cv cpnf cico co cxp cuni ccld cfv wss wcel ovex reex xpex c0
        cmpt crn cun ctx wceq csigagen cvv sxbrsigalem0 cioo ctop retop eqeltri
        ctg txtopi uniretop unieqi eqtr4i txunii unicls wfn wral eqid weq oveq1
        fnmpti xpeq1d fvmpt icopnfcld fveq2i syl6eleqr cdif dif0 ax-mp eqeltrri
        0opn opncld mp2an txcld sylancl eqeltrd rgen fnfvrnss xpeq2d unssi fvex
        sylancr sssigagen sstri sigagenss2 mp3an ) AGAHZIJKZGLZUBZUCZBGGBHZIJKZ
        LZUBZUCZUDZMZCCUEKZNOZMZUFXBXEUGOZPXEUHQZXBUGOXGPXCGGLZXFABUIXDXICCCUJU
        CUNOZUKDULUMZXKUOCCGGXKXKGXJMCMUPCXJDUQURZXLUSUTURXBXEXGWPXAXEWOGVAEHZW
        OOZXEQZEGVBWPXEPAGWNWOWMGWLIJRSTWOVCZVFXOEGXMGQZXNXMIJKZGLZXEAXMWNXSGWO
        AEVDWMXRGWLXMIJVEVGXPXRGXMIJRSTVHXQXRCNOZQGXTQZXSXEQXQXRXJNOZXTXMVICXJN
        DVJZVKGUAVLZGXTGVMCUKQZUACQZYDXTQXKYEYFXKCVPVNUACGXLVQVRVOZXRGCCVSVTWAW
        BEGXEWOWCVRWTGVAFHZWTOZXEQZFGVBXAXEPBGWSWTGWRSWQIJRTWTVCZVFYJFGYHGQZYIG
        YHIJKZLZXEBYHWSYNGWTBFVDWRYMGWQYHIJVEWDYKGYMSYHIJRTVHYLYAYMXTQYNXEQYGYL
        YMYBXTYHVIYCVKGYMCCVSWGWAWBFGXEWTWCVRWEXHXEXGPXDNWFZXEUHWHVNWIYOXBXEUHW
        JWK $.
    $}

    ${
      $d x n $.
      dya2ioc.1 $e |- I = ( x e. ZZ , n e. ZZ |->
                       ( ( x / ( 2 ^ n ) ) [,) ( ( x + 1 ) / ( 2 ^ n ) ) ) ) $.

      ${
        $d m n u v x $.  $d m u N $.  $d m u X $.
        $( The function ` I ` returns closed below opened above dyadic rational
           intervals covering the the real line.  This is the same construction
           as in ~ dyadmbl .  (Contributed by Thierry Arnoux, 24-Sep-2017.) $)
        dya2iocival $p |- ( ( N e. ZZ /\ X e. ZZ ) -> ( X I N ) =
          ( ( X / ( 2 ^ N ) ) [,) ( ( X + 1 ) / ( 2 ^ N ) ) ) ) $=
          ( vu vm cz co c2 cexp cdiv c1 caddc cico wceq cv oveq1 oveq1d oveq12d
          wcel oveq2 oveq2d cmpt2 cbvmpt2v eqtr4i ovex ovmpt2 ancoms ) FKUDEKUD
          FECLFMENLZOLZFPQLZUMOLZRLZSIJFEKKITZMJTZNLZOLZURPQLZUTOLZRLZUQCFUTOLZ
          UOUTOLZRLURFSZVAVEVCVFRURFUTOUAVGVBUOUTOURFPQUAUBUCUSESZVEUNVFUPRVHUT
          UMFOUSEMNUEZUFVHUTUMUOOVIUFUCCABKKATZMBTZNLZOLZVJPQLZVLOLZRLZUGIJKKVD
          UGHIJABKKVDVPVJUTOLZVNUTOLZRLURVJSZVAVQVCVRRURVJUTOUAVSVBVNUTOURVJPQU
          AUBUCUSVKSZVQVMVRVORVTUTVLVJOUSVKMNUEZUFVTUTVLVNOWAUFUCUHUIUNUPRUJUKU
          L $.
      $}

      $( Dyadic intervals are subsets of ` RR ` .  (Contributed by Thierry
         Arnoux, 18-Sep-2017.) $)
      dya2iocress $p |- ( ( N e. ZZ /\ X e. ZZ ) -> ( X I N ) C_ RR ) $=
        ( cz wcel wa co c2 cexp cdiv c1 caddc cr a1i rerpdivcld dya2iocival cxr
        cico wss simpr zred crp 2rp simpl rpexpcld 1re readdcld icossre syl2anc
        rexrd eqsstrd ) EIJZFIJZKZFECLFMENLZOLZFPQLZUTOLZUCLZRABCDEFGHUAUSVARJV
        CUBJVDRUDUSFUTUSFUQURUEUFZUSMEMUGJUSUHSUQURUIUJZTUSVCUSVBUTUSFPVEPRJUSU
        KSULVFTUOVAVCUMUNUP $.

      $( Dyadic intervals are Borel sets of ` RR ` .  (Contributed by Thierry
         Arnoux, 22-Sep-2017.) $)
      dya2iocbrsiga $p |- ( ( N e. ZZ /\ X e. ZZ ) -> ( X I N ) e. BrSiga ) $=
        ( wcel co c2 c1 cbrsiga cmnf cioo cxr a1i cr cfv ctop cz cexp cdiv cico
        caddc dya2iocival cdif clt wbr wceq mnfxr simpr zred crp simpl rpexpcld
        wa 2rp rerpdivcld rexrd 1re readdcld mnflt syl difioo syl31anc crn cuni
        csiga brsigarn elrnsiga ax-mp ctg csigagen iooretop elsigagen df-brsiga
        retop mp2an eleqtrri difelsiga mp3an syl6eqelr eqeltrd ) EUAIZFUAIZUQZF
        ECJFKEUBJZUCJZFLUEJZWHUCJZUDJZMABCDEFGHUFWGWLNWKOJZNWIOJZUGZMWGNPIZWIPI
        WKPINWIUHUIZWOWLUJWPWGUKQWGWIWGFWHWGFWEWFULUMZWGKEKUNIWGURQWEWFUOUPZUSZ
        UTWGWKWGWJWHWGFLWRLRIWGVAQVBWSUSUTWGWIRIWQWTWIVCVDNWIWKVEVFMVIVGVHIZWMM
        IWNMIWOMIMRVISIXAVJMRVKVLWMOVGVMSZVNSZMXBTIZWMXBIWMXCIVRNWKVOXBWMTVPVSV
        QVTWNXCMXDWNXBIWNXCIVRNWIVOXBWNTVPVSVQVTWMWNMWAWBWCWD $.

      ${
        $d d n x $.  $d d I $.
        $( Dyadic intervals are Borel sets of ` RR ` .  (Contributed by Thierry
           Arnoux, 22-Sep-2017.)  (Revised by Thierry Arnoux, 13-Oct-2017.) $)
        dya2icobrsiga $p |- ran I C_ BrSiga $=
          ( crn cbrsiga cv wcel c2 co c1 cz cmnf cioo cxr a1i cr cfv cexp caddc
          vd cdiv cico wceq wrex ovex elrnmpt2 wa simpr cdif clt wbr mnfxr zred
          simpl crp 2rp rpexpcld rerpdivcld rexrd 1re readdcld mnflt syl difioo
          syl31anc csiga cuni brsigarn elrnsiga ctg csigagen iooretop elsigagen
          ax-mp retop mp2an df-brsiga eleqtrri difelsiga mp3an syl6eqelr adantr
          ctop eqeltrd ex rexlimivv sylbi ssriv ) UCCGZHUCIZWLJWMAIZKBIZUALZUDL
          ZWNMUBLZWPUDLZUELZUFZBNUGANUGWMHJZABNNWTWMCFWQWSUEUHUIXAXBABNNWNNJZWO
          NJZUJZXAXBXEXAUJWMWTHXEXAUKXEWTHJXAXEWTOWSPLZOWQPLZULZHXEOQJZWQQJWSQJ
          OWQUMUNZXHWTUFXIXEUORXEWQXEWNWPXEWNXCXDUQUPZXEKWOKURJXEUSRXCXDUKUTZVA
          ZVBXEWSXEWRWPXEWNMXKMSJXEVCRVDXLVAVBXEWQSJXJXMWQVEVFOWQWSVGVHHVIGVJJZ
          XFHJXGHJXHHJHSVITJXNVKHSVLVQXFPGVMTZVNTZHXOWFJZXFXOJXFXPJVROWSVOXOXFW
          FVPVSVTWAXGXPHXQXGXOJXGXPJVROWQVOXOXGWFVPVSVTWAXFXGHWBWCWDWEWGWHWIWJW
          K $.
      $}

      $d x I $.
      ${
        $d n x $.  $d b D $.  $d b u x G $.  $d b u I $.  $d b u x N $.
        $d b u x X $.
        dya2icoseg.1 $e |- N = ( |_ ` ( 1 - ( 2 logb D ) ) ) $.
        $( For any point and any closed below, opened above interval of ` RR `
           centered on that point, there is a closed below opened above dyadic
           rational interval which contains that point and is included in the
           original interval.  (Contributed by Thierry Arnoux, 19-Sep-2017.) $)
        dya2icoseg $p |- ( ( X e. RR /\ D e. RR+ ) -> E. b e. ran I
          ( X e. b /\ b C_ ( ( X - D ) (,) ( X + D ) ) ) ) $=
          ( wcel c2 co cmin caddc cz cdiv c1 wbr crp cexp cmul cfl cfv crn cioo
          cr wa wss cv wrex cxp wfn cico fnmpt2i a1i simpl 2rp clogb 1re cuz 2z
          ovex uzid ax-mp rnlogbcl mpan resubcld flcld syl5eqel rpexpcl sylancr
          rpred adantl remulcld fnovrn syl3anc cle clt zred fllelt syl lediv1dd
          simpld recnd cc 2cn cc0 2ne0 expne0d divcan4d breqtrd readdcld simprd
          wne ltdiv1dd eqbrtrrd cxr w3a redivcld rexrd elico2 syl2anc mpbir3and
          wb wceq dya2iocival eleqtrrd rereccld oveq2i dya2ub syl5eqbr ltsub2dd
          simpr mulcld ax-1cn divsubdird oveq1d eqtrd ltsub1dd ltletrd leadd1dd
          pncand ltled divdird ltadd2dd lelttrd icossioo syl22anc eqsstrd eleq2
          sseq1 anbi12d rspcev syl12anc ) GUHLZBUALZUIZGMFUBNZUCNZUDUEZFDNZDUFZ
          LZGUUCLZUUCGBONZGBPNZUGNZUJZGHUKZLZUUKUUIUJZUIZHUUDULYSDQQUMUNZUUBQLZ
          FQLZUUEUUOYSACQQAUKZMCUKUBNZRNZUURSPNUUSRNZUONDJUUTUVAUOVDUPUQYSUUAYS
          GYTYQYRURZYRYTUHLZYQYRMUALZUUQUVCUSYRFSMBUTNZONZUDUEZQKYRUVFYRSUVESUH
          LZYRVAUQMMVBUELZYRUVEUHLMQLUVIVCMVEVFMBVGVHVIVJVKZUVDUUQUIYTMFVLZVNVM
          VOZVPZVJZYRUUQYQUVJVOZQQUUBFDVQVRYSGUUBYTRNZUUBSPNZYTRNZUONZUUCYSGUVS
          LZYQUVPGVSTZGUVRVTTZUVBYSUVPUUAYTRNZGVSYSUUBUUAYTYSUUBUVNWAZUVMYSUVDU
          UQYTUALUSUVOUVKVMZYSUUBUUAVSTZUUAUVQVTTZYSUUAUHLUWFUWGUIUVMUUAWBWCZWE
          ZWDYSGYTYSGUVBWFZYSYTUVLWFZYSMFMWGLYSWHUQMWIWPYSWJUQUVOWKZWLZWMYSUWCG
          UVRVTUWMYSUUAUVQYTUVMYSUUBSUWDUVHYSVAUQZWNZUWEYSUWFUWGUWHWOZWQWRYSUVP
          UHLUVRWSLUVTYQUWAUWBWTXFYSUUBYTUWDUVLUWLXAZYSUVRYSUVQYTUWOUVLUWLXAZXB
          UVPUVRGXCXDXEYSUUQUUPUUCUVSXGUVOUVNACDEFUUBIJXHXDZXIYSUUCUVSUUIUWSYSU
          UGWSLUUHWSLUUGUVPVTTUVRUUHVSTUVSUUIUJYSUUGYSGBUVBYSBYQYRXOVNZVIZXBYSU
          UHYSGBUVBUWTWNZXBYSUUGGSYTRNZONZUVPUXAYSGUXCUVBYSYTUVLUWLXJZVIUWQYSUX
          CBGUXEUWTUVBYSUXCSMUVGUBNZRNZBVTYTUXFSRFUVGMUBKXKXKYRUXGBVTTYQBXLVOXM
          ZXNYSUUASONZYTRNZUXDUVPVSYSUXJUWCUXCONUXDYSUUASYTYSGYTUWJUWKXPZSWGLYS
          XQUQZUWKUWLXRYSUWCGUXCOUWMXSXTYSUXIUUBYTYSUUASUVMUWNVIZUWDUWEYSUXIUUB
          UXMUWDYSUXIUVQSONUUBVTYSUUAUVQSUVMUWOUWNUWPYAYSUUBSYSUUBUWDWFUXLYDWMY
          EWDWRYBYSUVRUUHUWRUXBYSUVRGUXCPNZUUHUWRYSGUXCUVBUXEWNUXBYSUVRUUASPNZY
          TRNZUXNVSYSUVQUXOYTUWOYSUUASUVMUWNWNUWEYSUUBUUASUWDUVMUWNUWIYCWDYSUXP
          UWCUXCPNUXNYSUUASYTUXKUXLUWKUWLYFYSUWCGUXCPUWMXSXTWMYSUXCBGUXEUWTUVBU
          XHYGYHYEUUGUUHUVPUVRYIYJYKUUNUUFUUJUIHUUCUUDUUKUUCXGUULUUFUUMUUJUUKUU
          CGYLUUKUUCUUIYMYNYOYP $.
      $}

      ${
        $d a b n x w $.  $d a b d x E $.  $d b d I $.  $d b d x X $.
        $( For any point and any opened interval of ` RR ` containing that
           point, there is a closed below opened above dyadic rational interval
           which contains that point and is included in the original interval.
           (Contributed by Thierry Arnoux, 12-Oct-2017.) $)
        dya2icoseg2 $p |- ( ( X e. RR /\ E e. ran (,) /\ X e. E ) ->
          E. b e. ran I ( X e. b /\ b C_ E ) ) $=
          ( vd cr wcel co wss wa wrex crp cfv eqid cvv cioo crn cmin caddc wral
          w3a cv c1 c2 cfl dya2icoseg ralrimiva 3ad2ant1 cabs ccom cxp cres cbl
          clogb simp3 ctg iooex rnex bastg ax-mp simp2 sseldi syl6eleqr cxmt wb
          rexmet ccnfld cress cxme cmopn wceq cnfldxms reex ressxms mp2an ctopn
          tgioo3 eqtri rebase cds cnfldds reseq1i xmstopn elmopn2 simprbi oveq1
          ressds syl sseq1d rexbidv rspcva syl2anc bl2ioo sylan2 rexbidva mpbid
          rpre r19.29 r19.41v sstr anim2i anassrs reximi sylbir rexlimivw ) FKL
          ZCUAUBZLZFCLZUFZFGUGZLZXPFJUGZUCMFXRUDMUAMZNZOZGDUBZPZXSCNZOZJQPZXQXP
          CNZOZGYBPZXOYCJQUEZYDJQPZYFXKXMYJXNXKYCJQAXRBDEUHUIXRUSMUCMUJRZFGHIYL
          SUKULUMXOFXRUNUCUOZKKUPZUQZURRZMZCNZJQPZYKXOXNAUGZXRYPMZCNZJQPZACUEZY
          SXKXMXNUTXOCELZUUDXOCXLVARZEXOXLUUFCXLTLXLUUFNUAVBVCXLTVDVEXKXMXNVFVG
          HVHUUECKNZUUDYOKVIRLUUEUUGUUDOVJYOYOSZVKAJCYOEKVLKVMMZVNLZEYOVORVPVLV
          NLKTLZUUJVQVRKVLTVSVTYOEUUIKEUUFUUIWARZHUULUULSWBWCUUIUUISZWDYMUUIWER
          ZYNUUKYMUUNVPVRKYMVLUUITUUMWFWLVEWGWHVEWIVEWJWMUUCYSAFCYTFVPZUUBYRJQU
          UOUUAYQCYTFXRYPWKWNWOWPWQXKXMYSYKVJXNXKYRYDJQXRQLXKXRKLZYRYDVJXRXBXKU
          UPOYQXSCFXRYOUUHWRWNWSWTUMXAYCYDJQXCWQYEYIJQYEYAYDOZGYBPYIYAYDGYBXDUU
          QYHGYBXQXTYDYHXTYDOYGXQXPXSCXEXFXGXHXIXJWM $.
      $}

      $d u v I $.
      dya2ioc.2 $e |- R = ( u e. ran I , v e. ran I |-> ( u X. v ) ) $.
      $( The function returning dyadic square covering for a given size has
         domain ` ( ran I X. ran I ) ` .  (Contributed by Thierry Arnoux,
         19-Sep-2017.) $)
      dya2iocrfn $p |- R Fn ( ran I X. ran I ) $=
        ( crn cv cxp vex xpex fnmpt2i ) CBFKZQCLZBLZMDJRSCNBNOP $.

      $( The dyadic rectangle set is countable.  (Contributed by Thierry
         Arnoux, 18-Sep-2017.)  (Revised by Thierry Arnoux, 11-Oct-2017.) $)
      dya2iocct $p |- ran R ~<_ om $=
        ( crn com cdom wbr cz cv co cn mp2an cvv c2 cexp cdiv c1 caddc cico cen
        cmpt2 znnen nnct endomtr wcel ovex rgen2w mpt2cti eqbrtri rnct ax-mp wa
        cxp vex xpex breq1i biimpri 3syl ) FKZLMNZVGDKLMNZFLMNVGFAEOOAPZUAEPUBQ
        ZUCQZVIUDUEQVJUCQZUFQZUHZLMIOLMNZVOVNLMNORUGNRLMNVOUIUJORLUKSZVPAEOOVMT
        VMTULAEOOVKVLUFUMUNUOSUPFUQURZVQVGVGUSCBVFVFCPZBPZUTZUHZLMNZDLMNZVHCBVF
        VFVTTVTTULCBVFVFVRVSCVABVAVBUNUOWCWBDWALMJVCVDDUQVES $.

      $(
        $d m n x y $. $d m I $. $d m x y N $. $d x y V $.
        @( The value of a dyadic square cover of ` ( RR X. RR ) ` .
           (Contributed by Thierry Arnoux, 24-Sep-2017.) @)
        dya2iocrrnval $p |- ( W e. ran R <-> E. x e. ZZ E. y e. ZZ
          E. m e. ZZ E. n e. ZZ W = ( ( x I n ) X. ( y I m ) ) ) $=
          ( vm cz wcel cv co cxp cmpt2 oveq2d nfcv cfv crn wceq wrex mpt2eq3dva
          w3a simp1 xpeq12d rneqd cmpt c2 cexp cdiv c1 cico nfmpt22 nfcxfr nfov
          caddc nfxp nfmpt2 nfrn cbvmpt eqtr4i zex mpt2ex rnex eleq2d eqid ovex
          fvmpt xpex elrnmpt2 syl6bb ) GMNZHGCUAZNHABMMAOZGEPZBOZGEPZQZRZUBZNHW
          AUCBMUDAMUDVOVPWCHLGABMMVQLOZEPZVSWDEPZQZRZUBZWCMCWDGUCZWHWBWJABMMWGW
          AWJVQMNZVSMNZUFZWEVRWFVTWMWDGVQEWJWKWLUGZSWMWDGVSEWNSUHUEUICDMABMMVQD
          OZEPZVSWOEPZQZRZUBZUJLMWIUJKLDMWIWTDWHABDMMWGDMTZXADWEWFDVQWDEDVQTDEA
          DMMVQUKWOULPZUMPVQUNUSPXBUMPUOPZRJADMMXCUPUQZDWDTZURDVSWDEDVSTXDXEURU
          TVAVBLWTTWDWOUCZWHWSXFABMMWGWRXFWKWLUFZWEWPWFWQXGWDWOVQEXFWKWLUGZSXGW
          DWOVSEXHSUHUEUIVCVDWBABMMWAVEVEVFVGVKVHABMMWAHWBWBVIVRVTVQGEVJVSGEVJV
          LVMVN $.
      $)

      $d u v x $.
      ${
        $d n s t x $.  $d b e f s t A $.  $d s t u v x I $.  $d b e f s t R $.
        $d b e f s t x X $.
        dya2iocnrect.1 $e |-
                      B = ran ( e e. ran (,) , f e. ran (,) |-> ( e X. f ) ) $.
        $( For any point of an opened rectangle in ` ( RR X. RR ) ` , there is
           a closed below opened above dyadic rational square which contains
           that point and is included in the rectangle.  (Contributed by
           Thierry Arnoux, 12-Oct-2017.) $)
        dya2iocnrect $p |- ( ( X e. ( RR X. RR ) /\ A e. B /\ X e. A ) ->
          E. b e. ran R ( X e. b /\ b C_ A ) ) $=
          ( wcel wrex wa vs vt cr cxp w3a cv wceq cioo crn wss cmpt2 eleq2i vex
          eqid xpex elrnmpt2 bitri biimpi 3ad2ant2 simp1 simp3 r19.41vv biimpri
          jca32 simprl simpl simprr eleqtrd 3jca c1st c2nd simpr xp1st 3ad2ant1
          cfv adantl simpll 3ad2ant3 dya2icoseg2 syl3anc simplr reeanv sylanbrc
          xp2nd xpeq1 eqeq2d xpeq2 rspc2ev mp3an3 sylibr ad2antrl simpl1 sseldi
          cvv xpss simprrl simpld simprrr syl12anc simprd xpss12 syl2anc simpl2
          elxp7 sseqtr4d eleq2 sseq1 anbi12d rspcev exp32 rexlimdvv sylc sylan2
          ex rexlimivv 3syl ) LUCUCUDZRZDERZLDRZUEZDGUFZHUFZUDZUGZHUHUIZSGYFSZX
          RXTTZTZYEYHTZHYFSGYFSZLMUFZRZYLDUJZTZMFUIZSZYAYGXRXTXSXRYGXTXSYGXSDGH
          YFYFYDUKZUIZRYGEYSDQULGHYFYFYDDYRYRUNYBYCGUMHUMUOUPUQURUSXRXSXTUTXRXS
          XTVAVDYKYIYEYHGHYFYFVBVCYJYQGHYFYFYBYFRZYCYFRZTZYJYQYJUUBXRYELYDRZUEZ
          YQYJXRYEUUCYEXRXTVEYEYHVFZYJLDYDYEXRXTVGUUEVHVIUUBUUDTZUUDLVJVOZUAUFZ
          RZUUHYBUJZTZLVKVOZUBUFZRZUUMYCUJZTZTZUBJUIZSUAUURSZYQUUBUUDVLUUFUUKUA
          UURSZUUPUBUURSZUUSUUFUUGUCRZYTUUGYBRZUUTUUDUVBUUBXRYEUVBUUCLUCUCVMVNV
          PYTUUAUUDVQUUDUVCUUBUUCXRUVCYELYBYCVMVRVPAIYBJKUUGUANOVSVTUUFUULUCRZU
          UAUULYCRZUVAUUDUVDUUBXRYEUVDUUCLUCUCWDVNVPYTUUAUUDWAUUDUVEUUBUUCXRUVE
          YELYBYCWDVRVPAIYCJKUULUBNOVSVTUUKUUPUAUBUURUURWBWCUUDUUQYQUAUBUURUURU
          UDUUHUURRZUUMUURRZTZUUQYQUUDUVHUUQTZTZUUHUUMUDZYPRZLUVKRZUVKDUJZYQUVH
          UVLUUDUUQUVHUVKCUFZBUFZUDZUGZBUURSCUURSZUVLUVFUVGUVKUVKUGZUVSUVKUNUVR
          UVTUVKUUHUVPUDZUGCBUUHUUMUURUURUVOUUHUGUVQUWAUVKUVOUUHUVPWEWFUVPUUMUG
          UWAUVKUVKUVPUUMUUHWGWFWHWICBUURUURUVQUVKFPUVOUVPCUMBUMUOUPWJWKUVJLWNW
          NUDZRZUUIUUNUVMUVJXQUWBLUCUCWOXRYEUUCUVIWLWMUVJUUIUUJUUDUVHUUKUUPWPZW
          QUVJUUNUUOUUDUVHUUKUUPWRZWQUVMUWCUUIUUNTTLUUHUUMXDVCWSUVJUVKYDDUVJUUJ
          UUOUVKYDUJUVJUUIUUJUWDWTUVJUUNUUOUWEWTUUHYBUUMYCXAXBXRYEUUCUVIXCXEYOU
          VMUVNTMUVKYPYLUVKUGYMUVMYNUVNYLUVKLXFYLUVKDXGXHXIWSXJXKXLXMXNXOXP $.
      $}

      ${
        $d b e f m u v x $.  $d b e r A $.  $d x I $.  $d e J $.
        $d b e f r R $.  $d b e f r x X $.
        $( For any point of an open set of the usual topology on
           ` ( RR X. RR ) ` there is a closed below opened above dyadic
           rational square which contains that point and is entirely in the
           open set.  (Contributed by Thierry Arnoux, 21-Sep-2017.) $)
        dya2iocnei $p |- ( ( A e. ( J tX J ) /\ X e. A ) ->
          E. b e. ran R ( X e. b /\ b C_ A ) ) $=
          ( vr ve vf wcel wa cr cv ctx co cxp wss cioo cmpt2 wrex elunii ancoms
          crn cuni tpr2uni syl6eleq cmul caddc eqid tpr2rico anass dya2iocnrect
          ci 3expb anim1i anasss sylan2br r19.41v simpll simplr simpr sstrd jca
          reximi sylbir syl rexlimdvaa sylc ) DHHUAUBZQZIDQZRZISSUCZQZINTZQZWBD
          UDZRZNOPUEUJZWFOTPTUCUFUJZUGIJTZQZWHDUDZRZJEUJZUGZVSIVPUKZVTVRVQIWNQI
          DVPUHUIHKULUMOPBCDWGCBSSCTUTBTUNUBUOUBUFZHINKWOUPWGUPZUQWAWEWMNWGWAWB
          WGQZWERZRWIWHWBUDZRZJWLUGZWDRZWMWRWAWQWCRZWDRXBWQWCWDURWAXCWDXBWAXCRX
          AWDWAWQWCXAABCWBWGEOPFGHIJKLMWPUSVAVBVCVDXBWTWDRZJWLUGWMWTWDJWLVEXDWK
          JWLXDWIWJWIWSWDVFXDWHWBDWIWSWDVGWTWDVHVIVJVKVLVMVNVO $.
      $}

      ${
        $d m p x $.  $d b c m p u v z A $.  $d m J $.  $d b c m p R $.
        $d b m z $.
        $( Every open set of ` ( RR X. RR ) ` is a union of closed below opened
           above dyadic rational rectangular subsets of ` ( RR X. RR ) ` .
           This union must be a countable union by ~ dya2iocct .  (Contributed
           by Thierry Arnoux, 18-Sep-2017.) $)
        dya2iocuni $p |- ( A e. ( J tX J ) -> E. c e. ~P ran R U. c = A ) $=
          ( vz vb vp wcel cv wrex wceq c0 vm ctx co wel wss crn crab cpw ssrab2
          wa cuni cxp wfn dya2iocrfn cz c2 cexp cdiv c1 caddc cico cmpt2 mpt2ex
          cvv zex eqeltri rnex xpex fnex mp2an elpw2 mpbir a1i wral rex0 mtbiri
          wn ralrimivw rabeq0 sylibr unieqd uni0 syl6eq 0ss syl6eqss wne elequ2
          rexeq sseq1 anbi12d rexbidv elrab simpr reximi syl5ibr adantld syl5bi
          r19.9rzv unissb pm2.61ine dya2iocnei simpl ssel2 ancoms adantl elequ1
          ralrimiv anbi1d rspcev syl2anc jca simprl reximi2 syl eluni2 ex ssrdv
          eqssd unieq eqeq1d ) DHHUBUCPZMNUDZNQZDUEZUJZMDRZNEUFZUGZYGUHZPZYHUKZ
          DSZIQZUKZDSZIYIRYJYAYJYHYGUEYFNYGUIYHYGEEGUFZYPULZUMYQVDPEVDPABCEFGHJ
          KLUNYPYPGGAFUOUOAQZUPFQUQUCZURUCYRUSUTUCYSURUCVAUCZVBVDKAFUOUOYTVEVEV
          CVFVGZUUAVHYQVDEVIVJVGVKVLVMYAYKDYKDUEZYAUUBDTDTSZYKTDUUCYKTUKTUUCYHT
          UUCYFVQZNYGVNYHTSUUCUUDNYGUUCYFYEMTRYEMVOYEMDTWHVPVRYFNYGVSVTWAWBWCDW
          DWEDTWFZOQZDUEZOYHVNUUBUUEUUGOYHUUFYHPZUUFYGPZMOUDZUUGUJZMDRZUJZUUEUU
          GYFUULNUUFYGYCUUFSZYEUUKMDUUNYBUUJYDUUGNOMWGYCUUFDWIWJWKWLZUUEUULUUGU
          UIUULUUGUUEUUGMDRUUKUUGMDUUJUUGWMWNUUGMDWRWOWPWQXGOYHDWSVTWTVMYAUADYK
          YAUAQZDPZUUPYKPZYAUUQUJZUAOUDZOYHRZUURUUSUUTUUGUJZOYGRUVAABCDEFGHUUPO
          JKLXAUVBUUTOYGYHUUIUVBUJZUUHUUTUVCUUMUUHUVCUUIUULUUIUVBXBUVCUUQUVBUUL
          UVBUUQUUIUUGUUTUUQUUFDUUPXCXDXEUUIUVBWMUUKUVBMUUPDMQUUPSUUJUUTUUGMUAO
          XFXHXIXJXKUUOVTUUIUUTUUGXLXKXMXNOUUPYHXOVTXPXQXRYOYLIYHYIYMYHSYNYKDYM
          YHXSXTXIXJ $.
      $}

      ${
        $d c d n u v x y $.  $d d u v I $.  $d c d R $.
        $( The dyadic rectangular set collection covers ` ( RR X. RR ) ` .
           (Contributed by Thierry Arnoux, 18-Sep-2017.) $)
        dya2iocucvr $p |- U. ran R = ( RR X. RR ) $=
          ( vd cr wss cv wcel wrex wa c2 co cz vc crn cuni cxp unissb wceq xpex
          vex elrnmpt2 simpr cpw pwssb cexp cdiv c1 caddc cico ovex simpll zred
          cxr 2re a1i cc0 wne 2ne0 simplr reexpclzd cc 2cn expne0d redivcld 1re
          readdcld rexrd icossre syl2anc eqsstrd rexlimivv sylbi mprgbir elpwid
          sseli xpss12 syl2an adantr ctx ctop cioo ctg cfv retop eqeltri txtopi
          uniretop unieqi eqtr4i txunii topopn dya2iocuni elpwi unissd eqsstr3d
          ex mp2b rexlimiva ax-mp eqssi ) DUBZUCZLLUDZXJXKMKNZXKMZKXIKXIXKUEXLX
          IOXLCNZBNZUDZUFZBFUBZPCXRPXMCBXRXRXPXLDJXNXOCUHBUHUGUIXQXMCBXRXRXNXRO
          ZXOXROZQZXQXMYAXQQXLXPXKYAXQUJYAXPXKMZXQXSXNLMXOLMYBXTXSXNLXRLUKZXNXR
          YCMXLLMZKXRKXRLULXLXROXLANZRENZUMSZUNSZYEUOUPSZYGUNSZUQSZUFZETPATPYDA
          ETTYKXLFIYHYJUQURUIYLYDAETTYETOZYFTOZQZYLYDYOYLQZXLYKLYOYLUJYPYHLOYJV
          AOYKLMYPYEYGYPYEYMYNYLUSUTZYPRYFRLOYPVBVCRVDVEYPVFVCZYMYNYLVGZVHZYPRY
          FRVIOYPVJVCYRYSVKZVLYPYJYPYIYGYPYEUOYQUOLOYPVMVCVNYTUUAVLVOYHYJVPVQVR
          XDVSVTWAZWCWBXTXOLXRYCXOUUBWCWBXNLXOLWDWEWFVRXDVSVTWAUANZUCZXKUFZUAXI
          UKZPZXKXJMZGGWGSZWHOXKUUIOUUGGGGWIUBWJWKZWHHWLWMZUUKWNUUIXKGGLLUUKUUK
          LUUJUCGUCWOGUUJHWPWQZUULWRWSABCXKDEFGUAHIJWTXEUUEUUHUAUUFUUCUUFOZUUEQ
          ZXKUUDXJUUMUUEUJUUNUUCXIUUMUUCXIMUUEUUCXIXAWFXBXCXFXGXH $.
      $}

      $d n u v y $.  $d n x y R $.  $d x J $.
      $( The Borel algebra on ` ( RR X. RR ) ` is a subset of the sigma algebra
         generated by the dyadic closed below, opened above rectangular subsets
         of ` ( RR X. RR ) ` .  This is a step of the proof of Proposition
         1.1.5 of [Cohn] p. 4 (Contributed by Thierry Arnoux, 17-Sep-2017.) $)
      sxbrsigalem1 $p |- ( sigaGen ` ( J tX J ) ) C_ ( sigaGen ` ran R ) $=
        ( vy cuni crn wceq csigagen cfv wss cvv wcel cr ctx co dya2iocucvr cioo
        cxp ctg ctop retop eqeltri uniretop unieqi eqtr4i txunii eqtr2i cv wrex
        cpw dya2iocuni wa simpr com cdom dya2iocct ctex mp1i elpwi ssct sylancl
        wbr elsigagen2 syl3anc adantr eqeltrrd rexlimiva ssriv ax-mp sigagenss2
        syl mp3an ) GGUAUBZLZDMZLZNVTWBOPZQWBRSZVTOPWDQWCTTUEWAABCDEFGHIJUCGGTT
        GUDMUFPZUGHUHUIZWGTWFLGLUJGWFHUKULZWHUMUNAVTWDAUOZVTSKUOZLZWINZKWBUQZUP
        WIWDSZABCWIDEFGKHIJURWLWNKWMWJWMSZWLUSWKWIWDWOWLUTWOWKWDSZWLWOWEWJWBQZW
        JVAVBVIZWPWBVAVBVIZWEWOABCDEFGHIJVCZWBVDZVEWJWBVFZWOWQWSWRXBWTWJWBVGVHW
        BWJRVJVKVLVMVNVRVOWSWEWTXAVPVTWBRVQVS $.

      ${
        $d d e f n u v x y $.  $d u v x I $.  $d x J $.  $d d R $.
        $( The sigma-algebra generated by the dyadic closed below, opened above
           rectangular subsets of ` ( RR X. RR ) ` is a subset of the sigma
           algebra generated by the closed half-spaces of ` ( RR X. RR ) ` .
           The proof goes by noting the fact that the dyadic rectangles are
           intersections of a 'vertical band' and an 'horizontal band', which
           themselves are differences of closed half-spaces.  (Contributed by
           Thierry Arnoux, 17-Sep-2017.) $)
        sxbrsigalem2 $p |- ( sigaGen ` ran R ) C_ ( sigaGen `
           ( ran ( e e. RR |-> ( ( e [,) +oo ) X. RR ) )
          u. ran ( f e. RR |-> ( RR X. ( f [,) +oo ) ) ) ) ) $=
          ( cr cpnf cico cxp wceq wcel wrex cz vd crn cuni cv cmpt cun csigagen
          co cfv wss cvv dya2iocucvr sxbrsigalem0 eqtr4i xpex elrnmpt2 wa simpr
          vex c1st cres ccnv cima c2nd cin cpw dya2icobrsiga brsigasspwrn sstri
          cbrsiga sseli elpwid xpinpreima2 syl2an csiga wtru reex rnex unex a1i
          mptex sgsiga trud 1stpreima syl c2 cexp cdiv caddc ovex xpeq1d difxp1
          c1 cdif cxr cle wbr simpl zred crp rpexpcld rerpdivcld rexrd readdcld
          2rp 1re pnfxr lep1d lediv1dd pnfge syl32anc syl5reqr ssun1 eqid oveq1
          difico eqeq2d rspcev sylancl elrnmpti sylibr sseldi elsigagen sylancr
          difelsiga syl3anc eqeltrd adantr ex rexlimivv 2ndpreima xpeq2d difxp2
          sylbi ssun2 adantl inelsiga ssriv sigagenss2 mp3an ) DUBZUCZEMEUDZNOU
          HZMPZUEZUBZFMMFUDZNOUHZPZUEZUBZUFZUCZQUUAUUMUGUIZUJUUMUKRZUUAUGUIUUOU
          JUUBMMPZUUNABCDGHIJKLULEFUMUNUAUUAUUOUAUDZUUARUURCUDZBUDZPZQZBHUBZSCU
          VCSUURUUORZCBUVCUVCUVAUURDLUUSUUTCUSBUSUOUPUVBUVDCBUVCUVCUUSUVCRZUUTU
          VCRZUQZUVBUVDUVGUVBUQUURUVAUUOUVGUVBURUVGUVAUUORUVBUVGUVAUTUUQVAVBUUS
          VCZVDUUQVAVBUUTVCZVEZUUOUVEUUSMUJZUUTMUJZUVAUVJQUVFUVEUUSMUVCMVFZUUSU
          VCVJUVMAGHIJKVGVHVIZVKVLZUVFUUTMUVCUVMUUTUVNVKVLZUUSUUTMMVMVNUVGUUOVO
          UBUCRZUVHUUORZUVIUUORZUVJUUORUVQUVGUVQVPUUMUKUUPVPUUGUULUUFEMUUEVQWAV
          RUUKFMUUJVQWAVRVSZVTWBWCZVTUVEUVRUVFUVEUVHUUSMPZUUOUVEUVKUVHUWBQUVOUU
          SMMWDWEUVEUUSAUDZWFGUDZWGUHZWHUHZUWCWMWIUHZUWEWHUHZOUHZQZGTSATSUWBUUO
          RZAGTTUWIUUSHKUWFUWHOWJZUPUWJUWKAGTTUWCTRZUWDTRZUQZUWJUWKUWOUWJUQZUWB
          UWIMPZUUOUWPUUSUWIMUWOUWJURWKUWOUWQUUORUWJUWOUWQUWFNOUHZMPZUWHNOUHZMP
          ZWNZUUOUWOUXBUWRUWTWNZMPUWQUWRUWTMWLUWOUXCUWIMUWOUWFWORUWHWORZNWORZUW
          FUWHWPWQUWHNWPWQZUXCUWIQUWOUWFUWOUWCUWEUWOUWCUWMUWNWRWSZUWOWFUWDWFWTR
          UWOXEVTUWMUWNURXAZXBZXCUWOUWHUWOUWGUWEUWOUWCWMUXGWMMRUWOXFVTXDZUXHXBZ
          XCZUXEUWOXGVTUWOUWCUWGUWEUXGUXJUXHUWOUWCUXGXHXIUWOUXDUXFUXLUWHXJWEUWF
          UWHNXPXKZWKXLUWOUVQUWSUUORZUXAUUORZUXBUUORUVQUWOUWAVTZUWOUUPUWSUUMRUX
          NUVTUWOUUGUUMUWSUUGUULXMZUWOUWSUUEQZEMSZUWSUUGRUWOUWFMRZUWSUWSQZUXSUX
          IUWSXNUXRUYAEUWFMUUCUWFQZUUEUWSUWSUYBUUDUWRMUUCUWFNOXOWKXQXRXSEMUUEUW
          SUUFUUFXNZUUDMUUCNOWJVQUOZXTYAYBUUMUWSUKYCYDUWOUUPUXAUUMRUXOUVTUWOUUG
          UUMUXAUXQUWOUXAUUEQZEMSZUXAUUGRUWOUWHMRZUXAUXAQZUYFUXKUXAXNUYEUYHEUWH
          MUUCUWHQZUUEUXAUXAUYIUUDUWTMUUCUWHNOXOWKXQXRXSEMUUEUXAUUFUYCUYDXTYAYB
          UUMUXAUKYCYDUWSUXAUUOYEYFYGYHYGYIYJYNYGYHUVFUVSUVEUVFUVIMUUTPZUUOUVFU
          VLUVIUYJQUVPUUTMMYKWEUVFUUTUWIQZGTSATSUYJUUORZAGTTUWIUUTHKUWLUPUYKUYL
          AGTTUWOUYKUYLUWOUYKUQZUYJMUWIPZUUOUYMUUTUWIMUWOUYKURYLUWOUYNUUORUYKUW
          OUYNMUWRPZMUWTPZWNZUUOUWOUYQMUXCPUYNMUWRUWTYMUWOUXCUWIMUXMYLXLUWOUVQU
          YOUUORZUYPUUORZUYQUUORUXPUWOUUPUYOUUMRUYRUVTUWOUULUUMUYOUULUUGYOZUWOU
          YOUUJQZFMSZUYOUULRUWOUXTUYOUYOQZVUBUXIUYOXNVUAVUCFUWFMUUHUWFQZUUJUYOU
          YOVUDUUIUWRMUUHUWFNOXOYLXQXRXSFMUUJUYOUUKUUKXNZMUUIVQUUHNOWJUOZXTYAYB
          UUMUYOUKYCYDUWOUUPUYPUUMRUYSUVTUWOUULUUMUYPUYTUWOUYPUUJQZFMSZUYPUULRU
          WOUYGUYPUYPQZVUHUXKUYPXNVUGVUIFUWHMUUHUWHQZUUJUYPUYPVUJUUIUWTMUUHUWHN
          OXOYLXQXRXSFMUUJUYPUUKVUEVUFXTYAYBUUMUYPUKYCYDUYOUYPUUOYEYFYGYHYGYIYJ
          YNYGYPUVHUVIUUOYQYFYGYHYGYIYJYNYRUVTUUAUUMUKYSYT $.
      $}

      ${
        $d e f n u v x $.
        $( The Borel algebra on ` ( RR X. RR ) ` is generated by the dyadic
           closed below, opened above rectangular subsets of
           ` ( RR X. RR ) ` .  Proposition 1.1.5 of [Cohn] p. 4 .  Note that
           the interval used in this formalization are closed below, opened
           above instead of opened below, closed above in the proof as they are
           ultimately generated by the floor function.  (Contributed by Thierry
           Arnoux, 21-Sep-2017.) $)
        sxbrsigalem4 $p |- ( sigaGen ` ( J tX J ) ) = ( sigaGen ` ran R ) $=
          ( ve vf co csigagen cfv crn cr cv cpnf cxp ctx sxbrsigalem1 ccld cico
          cmpt cun sxbrsigalem2 sxbrsigalem3 sstri cuni wceq wss ctop topontopi
          wcel tpr2tp eqid unicls cldssbrsiga ax-mp sigagenss2 mp3an eqssi ) GG
          UAMZNOZDPNOZABCDEFGHIJUBVFVDUCOZNOZVEVFKQKRSUDMQTUEPLQQLRSUDMTUEPUFNO
          VHABCDKLEFGHIJUGKLGHUHUIVGUJVDUJZUKVGVEULZVDUMUOZVHVEULVDVIQQTVDGHUPU
          NZVIUQURVKVJVLVDUSUTVLVGVDUMVAVBUIVC $.
      $}

      ${
        $d e f g n u v x $.  $d e f g u v I $.  $d n x R $.  $d u x J $.
        $d v J $.
        $( First direction for ~ sxbrsiga .  (Contributed by Thierry Arnoux,
           22-Sep-2017.)  (Revised by Thierry Arnoux, 11-Oct-2017.) $)
        sxbrsigalem5 $p |- ( sigaGen ` ( J tX J ) ) C_ ( BrSiga sX BrSiga ) $=
          ( ve vf vg cfv cbrsiga cv cxp wss wcel wa crn csigagen cmpt2 ctx cuni
          co csx wceq cr dya2iocucvr br2base eqtr4i csiga brsigarn elexi mpt2ex
          cvv coprab dya2icobrsiga sseli anim12i anim1i ssoprab2i df-mpt2 eqtri
          rnex xpeq1 xpeq2 3sstr4i rnss ax-mp sssigagen2 mp2an sigagenss2 mp3an
          cbvmpt2v sxbrsigalem4 eqid sxval ) DUAZUBNZKLOOKPZLPZQZUCZUAZUBNZGGUD
          UFUBNOOUGUFZVTUEZWFUEZUHVTWGRZWFUQSZWAWGRWIUIUIQWJABCDEFGHIJUJKLUKULW
          LVTWFRZWKWEKLOOWDOUIUMNZUNUOZWOUPVFZDWERWMCPZFUAZSZBPZWRSZTZMPWQWTQZU
          HZTZCBMURZWQOSZWTOSZTZXDTZCBMURZDWEXEXJCBMXBXIXDWSXGXAXHWROWQAEFGHIUS
          ZUTWROWTXLUTVAVBVCDCBWRWRXCUCXFJCBMWRWRXCVDVEWECBOOXCUCXKKLCBOOWDXCWQ
          WCQWBWQWCVGWCWTWQVHVPCBMOOXCVDVEVIDWEVJVKWFVTUQVLVMWPVTWFUQVNVOABCDEF
          GHIJVQOWNSZXMWHWGUHUNUNKLWFOOWNWNWFVRVSVMVI $.
      $}
    $}

    ${
      $d a m n u v x $.  $d u v x J $.
      $( First direction for ~ sxbrsiga , same as sxbrsigalem6, dealing with
         the antecedents.  (Contributed by Thierry Arnoux, 10-Oct-2017.) $)
      sxbrsigalem6 $p |- ( sigaGen ` ( J tX J ) ) C_ ( BrSiga sX BrSiga ) $=
        ( vx vv vu va vm vn cz cv c2 cexp co cdiv c1 caddc cico cmpt2 weq oveq1
        crn cxp oveq1d oveq12d oveq2 oveq2d cbvmpt2v eqid sxbrsigalem5 ) CDEEDF
        GIIFJZKGJZLMZNMZUJOPMZULNMZQMZRZUAZUREJDJUBRZHUQABFGCHIIUPCJZKHJZLMZNMZ
        UTOPMZVBNMZQMUTULNMZVDULNMZQMFCSZUMVFUOVGQUJUTULNTVHUNVDULNUJUTOPTUCUDG
        HSZVFVCVGVEQVIULVBUTNUKVAKLUEZUFVIULVBVDNVJUFUDUGUSUHUI $.
    $}

    ${
      $d x y n $.  $d e f J $.
      $( The product sigma-algebra ` ( BrSiga sX BrSiga ) ` is the Borel
         algebra on ` ( RR X. RR ) ` See example 5.1.1 of [Cohn] p. 143 .
         (Contributed by Thierry Arnoux, 10-Oct-2017.) $)
      sxbrsiga $p |- ( BrSiga sX BrSiga ) = ( sigaGen ` ( J tX J ) ) $=
        ( ve vf cbrsiga co csigagen cfv cv crn cr csiga wcel wceq brsigarn cuni
        mp2an wss mp1i a1i csx ctx cxp cmpt2 eqid ctopon br2base tpr2uni eqtr4i
        sxval wral wa c1st cres ccnv cima c2nd cin cpw brsigasspwrn xpinpreima2
        sseli elpwid syl2an tpr2tp sigagensiga elrnsiga sgsiga ccn cioo retopon
        ax-mp ctg eqeltri tx1cn eqidd df-brsiga fveq2i cnmbfm mbfmcnvima adantr
        tx2cn adantl inelsiga syl3anc eqeltrd rnmpt2ss sigagenss2 mp3an eqsstri
        id rgen2a sxbrsigalem6 eqssi ) EEUAFZAAUBFZGHZWOCDEECIZDIZUCZUDZJZGHZWQ
        EKLHZMZXEWOXCNOOCDXBEEXDXDXBUEUJQXBPZWPPZNXBWQRZWPKKUCZUFHZMZXCWQRXFXIX
        GCDUGABUHUIWTWQMZDEUKCEUKXHXLCDEWREMZWSEMZULZWTUMXIUNZUOWRUPZUQXIUNZUOW
        SUPZURZWQXMWRKRWSKRWTXTNXNXMWRKEKUSZWRUTVBVCXNWSKEYAWSUTVBVCWRWSKKVAVDX
        OWQLJPZMZXQWQMZXSWQMZXTWQMWQXGLHMZYCXOXKYFABVEZWPXJVFVLWQXGVGSXMYDXNXMW
        RWQEXPXMWPXJXKXMYGTVHXEEYBMZXMOEKVGZSXMWQEXPWPAXPWPAVIFZMZXMAKUFHZMZYMY
        KAVJJVMHZYLBVKVNZYOAAKKVOQTXMWQVPEAGHZNZXMEYNGHYPVQAYNGBVRUIZTVSXMWKVTW
        AXNYEXMXNWSWQEXRXNWPXJXKXNYGTVHXEYHXNOYISXNWQEXRWPAXRYJMZXNYMYMYSYOYOAA
        KKWBQTXNWQVPYQXNYRTVSXNWKVTWCXQXSWQWDWEWFWLCDEEWTWQXAXAUEWGVLYGXBWPXJWH
        WIWJABWMWN $.
    $}
  $}

$( End $[ set-mbox-ta-meas.mm $] $)
$( Begin $[ set-mbox-ta-itgm.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Integration
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Lebesgue integral - misc additions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d k x ph $.  $d k A $.  $d k B $.  $d k C $.  $d k D $.
    itgeq12dv.2 $e |- ( ph -> A = B ) $.
    itgeq12dv.1 $e |- ( ( ph /\ x e. A ) -> C = D ) $.
    $( Equality theorem for an integral.  (Contributed by Thierry Arnoux,
       14-Feb-2017.) $)
    itgeq12dv $p |- ( ph -> S. A C _d x = S. B D _d x ) $=
      ( vk cc0 co cv cr cdiv cre cfv cle wa citg2 cmul c3 cfz cexp wcel wbr cif
      ci cmpt csu citg oveq1d fveq2d breq2d pm5.32da eleq2d anbi1d wceq adantrr
      bitrd wn eqidd ifbieq12d2 mpteq2dv oveq2d sumeq2sdv eqid dfitg 3eqtr4g )
      AJUAUBKZUGILUCKZBMBLZCUDZJEVJNKZOPZQUEZRZVNJUFZUHZSPZTKZIUIVIVJBMVKDUDZJF
      VJNKZOPZQUEZRZWCJUFZUHZSPZTKZIUIBCEUJBDFUJAVIVTWIIAVSWHVJTAVRWGSABMVQWFAV
      PWEVNJWCJAVPVLWDRWEAVLVOWDAVLRZVNWCJQWJVMWBOWJEFVJNHUKULZUMUNAVLWAWDACDVK
      GUOUPUSAVLVNWCUQVOWKURAVPUTRJVAVBVCULVDVEBCEVNIVNVFVGBDFWCIWCVFVGVH $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Bochner integral
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c sitg $. $( Measure integral on simple functions $)
  $c sitm $. $( Integral metric $)
  $c itgm $. $( Measure integral $)

  $( Extend class notation with the (measure) Bochner integral. $)
  citgm $a class itgm $.

  $( Extend class notation with the integral metric for simple functions. $)
  csitm $a class sitm $.

  $( Extend class notation with the integral of simple functions. $)
  csitg $a class sitg $.

  ${
    $d f g m w x $.
    $( Define the integral of simple functions from a measurable space
       ` dom m ` to a generic space ` w ` equipped with the right scalar
       product. ` w ` will later be required to be a Banach space.

       These simple functions are required to take finitely many different
       values: this is expressed by ` ran g e. Fin ` in the definition.

       Moreover, for each ` x ` , the pre-image ` ( ``' g " { x } ) ` is
       requested to be measurable, of finite measure.

       In this definition, ` ( sigaGen `` ( TopOpen `` w ) ) ` is the Borel
       sigma-algebra on ` w ` , and the functions ` g ` range over the
       measurable functions over that Borel algebra.

       Definition 2.4.1 of [Bogachev] p. 118.  (Contributed by Thierry Arnoux,
       21-Oct-2017.) $)
    df-sitg $a |- sitg = ( w e. _V , m e. U. ran measures |-> ( f e.
      { g e. ( dom m MblFnM ( sigaGen ` ( TopOpen ` w ) ) ) | ( ran g e. Fin /\
          A. x e. ( ran g \ { ( 0g ` w ) } ) ( m ` ( `' g " { x } ) )
      e. ( 0 [,) +oo ) ) } |-> ( w gsum ( x e. ( ran f \ { ( 0g ` w ) } ) |-> (
          ( ( RRHom ` ( Scalar ` w ) ) ` ( m ` ( `' f " { x } ) ) )
      ( .s ` w ) x ) ) ) ) ) $.
  $}

  ${
    $d f g m w x $.
    $( Define the integral metric for simple functions, as the integral of the
       distances between the function values.  Since distances take
       non-negative values in ` RR* ` , the range structure for this integral
       is ` ( RR*s |``s ( 0 [,] +oo ) ) ` .  See definition 2.3.1 of [Bogachev]
       p. 116.  (Contributed by Thierry Arnoux, 22-Oct-2017.) $)
    df-sitm $a |- sitm = ( w e. _V , m e. U. ran measures |->
        ( f e. dom ( w sitg m ) , g e. dom ( w sitg m ) |->
     ( ( ( RR*s |`s ( 0 [,] +oo ) ) sitg m ) ` ( f oF ( dist ` w ) g ) ) ) ) $.
  $}

  ${
    $d f m w B $.  $d f g x F $.  $d f m w H $.  $d f g m w x M $.
    $d f g m w S $.  $d f g m w x W $.  $d f g m w x .0. $.  $d f m w .x. $.
    sitgval.b $e |- B = ( Base ` W ) $.
    sitgval.j $e |- J = ( TopOpen ` W ) $.
    sitgval.s $e |- S = ( sigaGen ` J ) $.
    sitgval.0 $e |- .0. = ( 0g ` W ) $.
    sitgval.x $e |- .x. = ( .s ` W ) $.
    sitgval.h $e |- H = ( RRHom ` ( Scalar ` W ) ) $.
    sitgval.1 $e |- ( ph -> W e. V ) $.
    sitgval.2 $e |- ( ph -> M e. U. ran measures ) $.
    $( Value of the simple function integral builder for a given space ` W `
       and measure ` M ` .  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    sitgval $p |- ( ph -> ( W sitg M ) = ( f e. { g e. ( dom M MblFnM S ) |
     ( ran g e. Fin /\ A. x e. ( ran g \ { .0. } ) ( M ` ( `' g " { x } ) )
        e. ( 0 [,) +oo ) ) } |-> ( W gsum ( x e. ( ran f \ { .0. } ) |-> (
        ( H ` ( M ` ( `' f " { x } ) ) ) .x. x ) ) ) ) ) $=
      ( vw vm cvv wcel cmeas crn cuni csitg cfn ccnv csn cima cfv cc0 cpnf cico
      co cv cdif wral cdm cmbfm crab cmpt cgsu wceq elex syl c0g ctopn csigagen
      wa csca crrh cvsca fveq2 fveq2d fveq2i eqtri syl6eqr oveq2d sneqd difeq2d
      raleqdv anbi2d rabeqbidv id fveq1d oveq123d mpteq12dv oveq12d dmeq oveq1d
      eqidd fveq1 eleq1d ralbidv simpl df-sitg ovex rabex mptex ovmpt2 syl2anc
      mpteq2dva ) ALUDUEZJUFUGUHZUELJUIURFGUSZUGZUJUEZXIUKBUSZULZUMZJUNZUOUPUQU
      RZUEZBXJMULZUTZVAZVMZGJVBZDVCURZVDZLBFUSZUGZXRUTZYEUKXMUMZJUNZHUNZXLEURZV
      EZVFURZVEZVGALKUEXGTLKVHVIUAUBUCLJUDXHFXKXNUCUSZUNZXPUEZBXJUBUSZVJUNZULZU
      TZVAZVMZGYOVBZYRVKUNZVLUNZVCURZVDZYRBYFYTUTZYHYOUNZYRVNUNZVOUNZUNZXLYRVPU
      NZURZVEZVFURZVEYNUIFXKYQBXSVAZVMZGUUDDVCURZVDZLBYGUUJHUNZXLEURZVEZVFURZVE
      YRLVGZFUUHUUQUVAUVEUVFUUCUUSGUUGUUTUVFUUFDUUDVCUVFUUFLVKUNZVLUNZDUVFUUEUV
      GVLYRLVKVQVRDIVLUNUVHPIUVGVLOVSVTWAWBUVFUUBUURXKUVFYQBUUAXSUVFYTXRXJUVFYS
      MUVFYSLVJUNMYRLVJVQQWAWCZWDWEWFWGUVFYRLUUPUVDVFUVFWHUVFBUUIUUOYGUVCUVFYTX
      RYFUVIWDUVFUUMUVBXLXLUUNEUVFUUNLVPUNEYRLVPVQRWAUVFUUJUULHUVFUULLVNUNZVOUN
      HUVFUUKUVJVOYRLVNVQVRSWAWIUVFXLWOWJWKWLWKYOJVGZFUVAUVEYDYMUVKUUSYAGUUTYCU
      VKUUDYBDVCYOJWMWNUVKUURXTXKUVKYQXQBXSUVKYPXOXPXNYOJWPWQWRWFWGUVKUVDYLLVFU
      VKBYGUVCYKUVKXLYGUEZVMZUVBYJXLEUVMUUJYIHUVMYHYOJUVKUVLWSWIVRWNXFWBWKBUBFG
      UCWTFYDYMYAGYCYBDVCXAXBXCXDXE $.

    $( The predicate " ` F ` is a simple function" relative to the Bochner
       integral.  (Contributed by Thierry Arnoux, 19-Feb-2018.) $)
    issibf $p |- ( ph -> ( F e. dom ( W sitg M ) <-> ( F e. ( dom M MblFnM S )
        /\ ran F e. Fin /\ A. x e. ( ran F \ { .0. } ) ( M ` ( `' F " { x } ) )
        e. ( 0 [,) +oo ) ) ) ) $=
      ( vg vf csitg cdm wcel cmbfm crn cfn ccnv csn cima cfv cc0 cpnf cico cdif
      co cv wral wa w3a crab cmpt cgsu cvv sitgval dmeqd eqid dmmpt syl6eq wceq
      eleq2d difeq1d cnveq imaeq1d fveq2d oveq1d mpteq12dv oveq2d eleq1d syl6bb
      rneq elrab ovex biantru syl6bbr raleqbidv anbi12d 3anass ) AFKIUCUQZUDZUE
      ZFIUDDUFUQZUEZFUGZUHUEZFUIZBURZUJZUKZIULZUMUNUOUQZUEZBWOLUJZUPZUSZUTZUTZW
      NWPXFVAAWLFUAURZUGZUHUEZXIUIZWSUKZIULZXBUEZBXJXDUPZUSZUTZUAWMVBZUEZXHAWLX
      TKBXEXAGULZWREUQZVCZVDUQZVEUEZUTZXTAWLFKBUBURZUGZXDUPZYGUIZWSUKZIULZGULZW
      REUQZVCZVDUQZVEUEZUBXSVBZUEYFAWKYRFAWKUBXSYPVCZUDYRAWJYSABCDEUBUAGHIJKLMN
      OPQRSTVFVGUBXSYPYSYSVHVIVJVLYQYEUBFXSYGFVKZYPYDVEYTYOYCKVDYTBYIYNXEYBYTYH
      WOXDYGFWBVMYTYMYAWREYTYLXAGYTYKWTIYTYJWQWSYGFVNVOVPVPVQVRVSVTWCWAYEXTKYCV
      DWDWEWFXRXGUAFWMXIFVKZXKWPXQXFUUAXJWOUHXIFWBZVTUUAXOXCBXPXEUUAXJWOXDUUBVM
      UUAXNXAXBUUAXMWTIUUAXLWQWSXIFVNVOVPVTWGWHWCWAWNWPXFWIWF $.

    ${
      $d x S $.  $d x ph $.
      sibf0.1 $e |- ( ph -> W e. TopSp ) $.
      sibf0.2 $e |- ( ph -> W e. Mnd ) $.
      $( The constant zero function is a simple function.  (Contributed by
         Thierry Arnoux, 4-Mar-2018.) $)
      sibf0 $p |- ( ph -> ( U. dom M X. { .0. } ) e. dom ( W sitg M ) ) $=
        ( vx cdm cuni csn cxp csitg co wcel cmbfm crn cfn ccnv cv cima cfv cpnf
        cc0 cico cdif wral w3a cmeas csiga dmmeas syl csigagen cvv fvex eqeltri
        a1i sgsiga syl5eqel cmpt wceq fconstmpt cmnd mndidcl ctps tpsuni unieqi
        ctopn unisg syl5eq eqtr4d eleqtrd mbfmcst c0 xpeq1 0xp syl6eq rneqd rn0
        mp1i 0fin syl6eqel wne rnxp snfi pm2.61ine noel 0dif difid eleq2i mtbir
        difeq1d pm2.21i adantl ralrimiva 3jca issibf mpbird ) AGUBZUCZJUDZUEZIG
        UFUGUBUHXOXLCUIUGUHZXOUJZUKUHZXOULUAUMZUDUNGUOUQUPURUGUHZUAXQXNUSZUTZVA
        AXPXRYBAUAJXLCXOAGVBUJUCUHXLVCUJUCZUHRGVDVEACFVFUOZYCMAFVGFVGUHZAFIWAUO
        VGLIWAVHVIZVJVKVLXOUAXMJVMVNAUAXMJVOVJAJBCUCZAIVPUHJBUHTBIJKNVQVEABFUCZ
        YGAIVRUHBYHVNSBFIKLVSVEAYGYDUCZYHCYDMVTYEYIYHVNAYFFVGWBWMWCWDWEWFXRAXRX
        MWGXMWGVNZXQWGUKYJXQWGUJWGYJXOWGYJXOWGXNUEWGXMWGXNWHXNWIWJWKWLWJZWNWOXM
        WGWPZXQXNUKXMXNWQZJWRWOWSVJAXTUAYAXSYAUHZXTAYNXTYNXSWGUHXSWTYAWGXSYAWGV
        NXMWGYJYAWGXNUSWGYJXQWGXNYKXEXNXAWJYLYAXNXNUSWGYLXQXNXNYMXEXNXBWJWSXCXD
        XFXGXHXIAUABCDXOEFGHIJKLMNOPQRXJXK $.
    $}

    ${
      $d x A $.  $d f g B $.  $d f g x F $.  $d f H $.  $d f g M $.
      $d f g S $.  $d f W $.  $d f .x. $.  $d f g .0. $.  $d f x ph $.
      sibfmbl.1 $e |- ( ph -> F e. dom ( W sitg M ) ) $.
      $( A simple function is measurable.  (Contributed by Thierry Arnoux,
         19-Feb-2018.) $)
      sibfmbl $p |- ( ph -> F e. ( dom M MblFnM S ) ) $=
        ( vx cdm cmbfm co wcel crn cfn ccnv cv csn cima cfv cpnf cico cdif wral
        cc0 csitg w3a issibf mpbid simp1d ) AEHUBCUCUDUEZEUFZUGUEZEUHUAUIUJUKHU
        LUQUMUNUDUEUAVDKUJUOUPZAEJHURUDUBUEVCVEVFUSTAUABCDEFGHIJKLMNOPQRSUTVAVB
        $.

      $( A simple function is a function.  (Contributed by Thierry Arnoux,
         19-Feb-2018.) $)
      sibff $p |- ( ph -> F : U. dom M --> U. J ) $=
        ( cdm cuni wf cmeas crn wcel csiga dmmeas syl csigagen cfv cvv fvex a1i
        ctopn syl5eqel sgsiga sibfmbl mbfmf wceq unieqi unisg syl5eq feq3 mpbid
        wb ) AHUAZUBZCUBZEUCZVHGUBZEUCZAVGCEAHUDUEUBUFVGUGUEUBZUFSHUHUIACGUJUKZ
        VMNAGULAGJUOUKZULMVOULUFAJUOUMUNUPZUQUPABCDEFGHIJKLMNOPQRSTURUSAVIVKUTV
        JVLVFAVIVNUBZVKCVNNVAAGULUFVQVKUTVPGULVBUIVCVIVKVHEVDUIVE $.

      $( A simple function has finite range.  (Contributed by Thierry Arnoux,
         19-Feb-2018.) $)
      sibfrn $p |- ( ph -> ran F e. Fin ) $=
        ( vx cdm cmbfm co wcel crn cfn ccnv cv csn cima cfv cpnf cico cdif wral
        cc0 csitg w3a issibf mpbid simp2d ) AEHUBCUCUDUEZEUFZUGUEZEUHUAUIUJUKHU
        LUQUMUNUDUEUAVDKUJUOUPZAEJHURUDUBUEVCVEVFUSTAUABCDEFGHIJKLMNOPQRSUTVAVB
        $.

      $( Any preimage of a singleton by a simple function is measurable.
         (Contributed by Thierry Arnoux, 19-Feb-2018.) $)
      sibfima $p |- ( ( ph /\ A e. ( ran F \ { .0. } ) )
                          -> ( M ` ( `' F " { A } ) ) e. ( 0 [,) +oo ) ) $=
        ( vx ccnv cv csn cima cfv cc0 cpnf cico co wcel crn cdif wral cdm cmbfm
        cfn csitg w3a issibf mpbid simp3d wceq sneq imaeq2d fveq2d eleq1d rspcv
        mpan9 ) AFUCZUBUDZUEZUFZIUGZUHUIUJUKZULZUBFUMZLUEUNZUOZBVSULVKBUEZUFZIU
        GZVPULZAFIUPDUQUKULZVRURULZVTAFKIUSUKUPULWEWFVTUTUAAUBCDEFGHIJKLMNOPQRS
        TVAVBVCVQWDUBBVSVLBVDZVOWCVPWGVNWBIWGVMWAVKVLBVEVFVGVHVIVJ $.

      ${
        sibfinima.g $e |- ( ph -> G e. dom ( W sitg M ) ) $.
        sibfinima.w $e |- ( ph -> W e. TopSp ) $.
        sibfinima.j $e |- ( ph -> J e. Fre ) $.
        $( The measure of the intersection of any two preimages by simple
           functions is a real number.  (Contributed by Thierry Arnoux,
           21-Mar-2018.) $)
        sibfinima $p |- ( ( ( ph /\ X e. ran F /\ Y e. ran G )
          /\ ( X =/= .0. \/ Y =/= .0. ) ) ->
        ( M ` ( ( `' F " { X } ) i^i ( `' G " { Y } ) ) ) e. ( 0 [,) +oo ) ) $=
          ( crn wcel w3a wne wo ccnv csn cima cin cfv cc0 cle wbr cpnf clt cico
          wa cr cxr cicc cdm cmeas cuni measbasedom sylib 3ad2ant1 csiga dmmeas
          co syl csigagen ct1 sgsiga syl5eqel sibfmbl ccld wss ctps ctop tpstop
          cmbfm cldssbrsiga syl6sseqr wf sibff frn simp2 sseldd t1sncld syl2anc
          3syl eqid mbfmcnvima simp3 inelsiga syl3anc measvxrge0 elxrge0 adantr
          simplbi 0re a1i simprbi pnfxr inss1 measssd cdif simpl1 anim1i sylibr
          eldifsn sibfima wb elico2 mp2an xrlelttrd inss2 jaodan xrre3 syl22anc
          simp3bi syl3anbrc ) ALEUGZUHZMFUGZUHZUIZLNUJZMNUJZUKZVCZEULLUMZUNZFUL
          MUMZUNZUOZIUPZVDUHZUQUUCURUSZUUCUTVAUSZUUCUQUTVBVOZUHZYQUUCVEUHZUQVDU
          HZUUEUUFUUDYMUUIYPYMUUCUQUTVFVOZUHZUUIYMIIVGZVHUPUHZUUBUUMUHZUULAYJUU
          NYLAIVHUGVIUHZUUNUBIVJVKVLZYMUUMVMUGVIZUHZYSUUMUHZUUAUUMUHZUUOAYJUUSY
          LAUUPUUSUBIVNVPVLZYMYRUUMCEUVBAYJCUURUHYLACHVQUPZUURQAHVRUFVSVTVLZAYJ
          EUUMCWGVOZUHYLABCDEGHIJKNOPQRSTUAUBUCWAVLYMHWBUPZCYRAYJUVFCWCYLAUVFUV
          CCAKWDUHHWEUHUVFUVCWCUEHKPWFHWHWQQWIVLZYMHVRUHZLHVIZUHYRUVFUHAYJUVHYL
          UFVLZYMYIUVILAYJYIUVIWCZYLAUUMVIZUVIEWJUVKABCDEGHIJKNOPQRSTUAUBUCWKUV
          LUVIEWLVPVLAYJYLWMZWNLHUVIUVIWRZWOWPWNWSZYMYTUUMCFUVBUVDAYJFUVEUHYLAB
          CDFGHIJKNOPQRSTUAUBUDWAVLYMUVFCYTUVGYMUVHMUVIUHYTUVFUHUVJYMYKUVIMAYJY
          KUVIWCZYLAUVLUVIFWJUVPABCDFGHIJKNOPQRSTUAUBUDWKUVLUVIFWLVPVLAYJYLWTZW
          NMHUVIUVNWOWPWNWSZYSUUAUUMXAXBZUUBUUMIXCWPZUULUUIUUEUUCXDZXFVPZXEUUJY
          QXGXHYMUUEYPYMUULUUEUVTUULUUIUUEUWAXIVPXEZYMYNUUFYOYMYNVCZUUCYSIUPZUT
          YMUUIYNUWBXEUWDUWEUUKUHZUWEVEUHZUWDUUNUUTUWFYMUUNYNUUQXEZYMUUTYNUVOXE
          ZYSUUMIXCWPUWFUWGUQUWEURUSZUWEXDXFVPUTVEUHZUWDXJXHUWDUUBYSUUMIUWHYMUU
          OYNUVSXEUWIUUBYSWCUWDYSUUAXKXHXLUWDUWEUUGUHZUWEUTVAUSZUWDALYINUMZXMUH
          ZUWLAYJYLYNXNUWDYJYNVCUWOYMYJYNUVMXOLYINXQXPALBCDEGHIJKNOPQRSTUAUBUCX
          RWPUWLUWEVDUHZUWJUWMUUJUWKUWLUWPUWJUWMUIXSXGXJUQUTUWEXTYAYGVPYBYMYOVC
          ZUUCUUAIUPZUTYMUUIYOUWBXEUWQUWRUUKUHZUWRVEUHZUWQUUNUVAUWSYMUUNYOUUQXE
          ZYMUVAYOUVRXEZUUAUUMIXCWPUWSUWTUQUWRURUSZUWRXDXFVPUWKUWQXJXHUWQUUBUUA
          UUMIUXAYMUUOYOUVSXEUXBUUBUUAWCUWQYSUUAYCXHXLUWQUWRUUGUHZUWRUTVAUSZUWQ
          AMYKUWNXMUHZUXDAYJYLYOXNUWQYLYOVCUXFYMYLYOUVQXOMYKNXQXPAMBCDFGHIJKNOP
          QRSTUAUBUDXRWPUXDUWRVDUHZUXCUXEUUJUWKUXDUXGUXCUXEUIXSXGXJUQUTUWRXTYAY
          GVPYBYDZUUCUQYEYFUWCUXHUUJUWKUUHUUDUUEUUFUIXSXGXJUQUTUUCXTYAYH $.
      $}

      ${
        $d f g m w x y B $.  $d x z C $.  $d b f g p x z F $.
        $d b p x y z G $.  $d f m w H $.  $d x z J $.  $d b p x y z K $.
        $d b f g m p w x z M $.  $d f g m w S $.  $d f g m w x W $.
        $d f g m w x y .0. $.  $d b p x y z .+ $.  $d f m w .x. $.
        $d f p x y ph $.  $d b z ph $.
        sibfof.c $e |- C = ( Base ` K ) $.
        sibfof.0 $e |- ( ph -> W e. TopSp ) $.
        sibfof.1 $e |- ( ph -> .+ : ( B X. B ) --> C ) $.
        sibfof.2 $e |- ( ph -> G e. dom ( W sitg M ) ) $.
        sibfof.3 $e |- ( ph -> K e. TopSp ) $.
        sibfof.4 $e |- ( ph -> J e. Fre ) $.
        sibfof.5 $e |- ( ph -> ( .0. .+ .0. ) = ( 0g ` K ) ) $.
        $( Applying function operations on simple functions results in simple
           functions with regard to the the destination space, provided the
           operation fulfills a simple condition.  (Contributed by Thierry
           Arnoux, 12-Mar-2018.) $)
        sibfof $p |- ( ph -> ( F oF .+ G ) e. dom ( K sitg M ) ) $=
          ( vz vb vx vp vy co cdm wcel ctopn cfv csigagen cmbfm crn cfn ccnv cv
          csn cima cc0 cdif wral cuni wa wf cvv cxp ctps tpsuni syl mpbid sibff
          wceq cmeas uniexg 3syl wb eqid fvex eqtri syl6eqr a1i sgsiga syl5eqel
          feq3 syl2anc mpbird cin cun imaeq2i wfun ffun adantr ciun com wbr wss
          inss2 cnvimass sselda sibfmbl adantl eleqtrd t1sncld sseldd syl6eleqr
          cdom xp1st mbfmcnvima syl3anc ralrimiva wi sibfrn ssdomg mpi isfinite
          xp2nd csdm eqeltrd sylib c0 cr cle wdisj sylancl simpr wne wo sylanl2
          wn cof csitg cpnf cico c0g w3a cmap xpeq12d feq2d fovrnda dmexg inidm
          unieqi unisg ax-mp csiga elmapg inundif unpreima syl5eqr dmmeas iunid
          off imaiun eqtr3i c1st c2nd wfn ffn ofpreima2 ad2antrr inss1 syl5sseq
          simpll fdm syl5ss eqeltri ccld tpstop cldssbrsiga ct1 inelsiga biimpi
          ctop xpfi sdomdom domtr nfcv sigaclcuni ssralv mpsyl imafi ofrn2 ssfi
          syl5eqelr difpreima cnvimarndm difeq2i ssdif0 syl6eq 0elsiga unelsiga
          jca ismbfm csu cesum fveq2d measbasedom difss sseli sylan2 disjpreima
          sndisj imaeq2d simpl disjxpin disjss1 measvuni rge0ssre sseldi oveq12
          mpbi sneq eqtrd ex necon3ad oran nne anbi12i bitri syl6ibr ralrimivva
          notbii fniniseg cop 1st2nd2 df-ov eqtr3d simplr eldifbd elsn eqnetrrd
          necon3bbii oveq1 neeq1d neeq1 orbi1d imbi12d oveq2 orbi2d rspc2v mp2d
          syl31anc measge0 elrege0 sylanbrc esumpfinval 3eqtrd fsumrecl fsumge0
          sibfinima breqtrrd 3jca cvsca csca crrh issibf ) AGHDUUAUQZKLUUBUQURU
          SVVHLURZKUTVAZVBVAZVCUQUSZVVHVDZVEUSZVVHVFZULVGZVHZVIZLVAZVJUUCUUDUQZ
          USZULVVMKUUEVAZVHZVKZVLZUUFAVVLVVNVWEAVVLVVHVVKVMZVVIVMZUUGUQUSZVVOUM
          VGZVIZVVIUSZUMVVKVLZVNAVWHVWLAVWHVWGVWFVVHVOZAVWGCVVHVOZVWMAULUNVWGVW
          GVWGDJVMZVWOCGHVPVPAVVPUNVGZCVWOVWODABBVQZCDVOZVWOVWOVQZCDVOUGAVWQVWS
          CDABVWOBVWOANVRUSZBVWOWCZUFBJNPQVSVTZVXBUUHUUIWAZUUJABEFGIJLMNOPQRSTU
          AUBUCUDWBZABEFHIJLMNOPQRSTUAUBUCUHWBZALWDVDVMZUSZVVIVPUSVWGVPUSZUCLVX
          FUUKVVIVPWEWFZVXIVWGUULUVCZACVWFWCVWNVWMWGACVVJVMZVWFAKVRUSCVXKWCUICV
          VJKUEVVJWHZVSVTVWFVWFVXKVVKVVKVVKWHZUUMVVJVPUSZVWFVXKWCKUTWIZVVJVPUUN
          UUOWJWKCVWFVWGVVHWOVTWAAVWFVPUSZVXHVWHVWMWGAVVKUUPVDVMZUSVXPAVVKVVKVX
          QVXMAVVJVPVXNAVXOWLWMWNZVVKVXQWEVTVXIVWFVWGVVHVPVPUUQWPWQAVWKUMVVKAVW
          IVVKUSZVNZVWJVVOVWIVVMWRZVIZVVOVWIVVMVKZVIZWSZVVIVXTVWJVVOVYAVYCWSZVI
          ZVYEVYFVWIVVOVWIVVMUURWTAVYGVYEWCZVXSAVWNVVHXAZVYHVXJVWGCVVHXBZVYAVYC
          VVHUUSWFXCUUTVXTVVIVXQUSZVYBVVIUSVYDVVIUSZVYEVVIUSAVYKVXSAVXGVYKUCLUV
          AVTZXCZVXTVYBULVYAVVRXDZVVIVVOULVYAVVQXDZVIVYOVYBULVVOVYAVVQUVDVYPVYA
          VVOULVYAUVBWTUVEVXTVYKVVRVVIUSZULVYAVLZVYAXEXQXFZVYOVVIUSVYNAVYRVXSVY
          AVVMXGZAVYQULVVMVLVYRVWIVVMXHZAVYQULVVMAVVPVVMUSZVNZVVRUODVFVVQVIZGVD
          ZHVDZVQZWRZGVFZUOVGZUVFVAZVHZVIZHVFZWUJUVGVAZVHZVIZWRZXDZVVIAVVRWUSWC
          ZWUBAVWGBBVVQDGHVPUOAVWGBGVOZVWGVWOGVOZVXDAVXAWVAWVBWGVXBBVWOVWGGWOVT
          WQAVWGBHVOZVWGVWOHVOZVXEAVXAWVCWVDWGVXBBVWOVWGHWOVTWQVXIAVWRDVWQUVHZU
          GVWQCDUVIVTZUVJZXCWUCVYKWURVVIUSZUOWUHVLZWUHXEXQXFZWUSVVIUSAVYKWUBVYM
          XCWUCWVHUOWUHWUCWUJWUHUSZVNZVYKWUMVVIUSZWUQVVIUSZWVHAVYKWUBWVKVYMUVKW
          VLAWUJVWQUSZWVMAWUBWVKUVNZWUCWUHVWQWUJWUCWUHWUDVWQWUDWUGUVLZAWUDVWQXG
          WUBADURZWUDVWQDVVQXIAVWRWVRVWQWCUGVWQCDUVOVTUVMXCUVPXJZAWVOVNZWULVVIE
          GAVYKWVOVYMXCZAEVXQUSWVOAEJVBVAZVXQRAJVPJVPUSAJNUTVAVPQNUTWIUVQWLWMWN
          XCZAGVVIEVCUQZUSWVOABEFGIJLMNOPQRSTUAUBUCUDXKXCWVTWULWWBEWVTJUVRVAZWW
          BWULAWWEWWBXGZWVOAVWTJUWDUSWWFUFJNQUVSJUVTWFXCZWVTJUWAUSZWUKVWOUSWULW
          WEUSAWWHWVOUJXCZWVTWUKBVWOWVOWUKBUSZAWUJBBXRZXLAVXAWVOVXBXCZXMWUKJVWO
          VWOWHZXNWPXORXPXSWPWVLAWVOWVNWVPWVSWVTWUPVVIEHWWAWWCAHWWDUSWVOABEFHIJ
          LMNOPQRSTUAUBUCUHXKXCWVTWUPWWBEWVTWWEWWBWUPWWGWVTWWHWUOVWOUSWUPWWEUSW
          WIWVTWUOBVWOWVOWUOBUSZAWUJBBYGZXLWWLXMWUOJVWOWWMXNWPXORXPXSWPWUMWUQVV
          IUWBXTZYAZAWVJWUBAWUHWUGXQXFZWUGXEXQXFZWVJAWUHWUGXGZWWRWUDWUGXHZAWUGV
          EUSZWWTWWRYBAWUEVEUSWUFVEUSWXBABEFGIJLMNOPQRSTUAUBUCUDYCABEFHIJLMNOPQ
          RSTUAUBUCUHYCWUEWUFUWEWPZWUHWUGVEYDVTYEAWXBWUGXEYHXFZWWSWXCWXBWXDWUGY
          FUWCWUGXEUWFWFWUHWUGXEUWGWPZXCWUHWURVVIUOUOWUHUWHUWIXTYIYAVYQULVYAVVM
          UWJUWKXCAVYSVXSAVYAVVMXQXFZVVMXEXQXFZVYSAVYTWXFWUAAVVNVYTWXFYBADWUGVI
          ZVEUSZVVMWXHXGVVNADXAZWXBWXIAVWRWXJUGVWQCDXBVTWXCDWUGUWLWPAVWGVWOCDGH
          VPVXDVXEVXCVXIUWMWXHVVMUWNWPZVYAVVMVEYDVTYEAVVMXEYHXFZWXGAVVNWXLWXKVV
          MYFYJVVMXEUWFVTVYAVVMXEUWGWPXCVYAVVRVVIULULVYAUWHUWIXTUWOAVYLVXSAVYDY
          KVVIAVYDVWJVVOVVMVIZVKZYKAVWNVYIVYDWXNWCVXJVYJVWIVVMVVHUWPWFWXNVWJVVH
          URZVKZYKWXMWXOVWJVVHUWQUWRVWJWXOXGWXPYKWCVVHVWIXIVWJWXOUWSUYBWJUWTAVY
          KYKVVIUSVYMVVIUXAVTYIXCVYBVYDVVIUXBXTYIYAUXCAUMVVIVVKVVHVYMVXRUXDWQWX
          KAVWAULVWDAVVPVWDUSZVNZVVSYLUSVJVVSYMXFVWAWXRVVSWUHWURLVAZUOUXEZYLWXR
          VVSWUSLVAZWUHWXSUOUXFZWXTWXRVVRWUSLAWUTWXQWVGXCUXGWXRLVVIWDVAUSZWVIWV
          JUOWUHWURYNZVNWYAWYBWCAWYCWXQAVXGWYCUCLUXHYJXCZWXQAWUBWVIVWDVVMVVPVVM
          VWCUXIUXJZWWQUXKWXRWVJWYDAWVJWXQWXEXCAWYDWXQWWTAUOWUGWURYNZWYDWXAAUNW
          UEWUIVWPVHZVIZYNZUPWUFWUNUPVGZVHZVIZYNZWYGAGXAZUNWUEWYHYNWYJAWVBWYOVX
          DVWGVWOGXBVTUNWUEUXMUNWUEWYHGUXLYOAHXAZUPWUFWYLYNWYNAWVDWYPVXEVWGVWOH
          XBVTUPWUFUXMUPWUFWYLHUXLYOWYJWYNVNUNUPWUEWUFWYIWYMWUMWUQUOVWPWUKWCZWY
          HWULWUIVWPWUKUYCUXNWYKWUOWCZWYLWUPWUNWYKWUOUYCUXNWYJWYNUXOWYJWYNYPUXP
          WPUOWUHWUGWURUXQUWKXCUXCUOWUHWURVVILUXRXTWXRWUHWXSUOAWUHVEUSZWXQAWXBW
          WTWYSWXCWXAWUGWUHUWNYOXCZWXRWVKVNZWXSYLUSVJWXSYMXFZWXSVVTUSZXUAVVTYLW
          XSUXSXUAAWUKWUEUSZWUOWUFUSZWUKOYQZWUOOYQZYRZXUCWXQAWUBWVKAWYFWVPYSZXU
          AWUJWUGUSZXUDXUAWUHWUGWUJWXAWXRWVKYPUXTZWUJWUEWUFXRVTXUAXUJXUEXUKWUJW
          UEWUFYGVTXUAVWPWYKDUQZVWBYQZVWPOYQZWYKOYQZYRZYBZUPBVLUNBVLZWUKWUODUQZ
          VWBYQZXUHXUAAXURXUIAXUQUNUPBBAXUQVWPBUSWYKBUSVNAXUMVWPOWCZWYKOWCZVNZY
          TZXUPAXVCXULVWBAXVCXULVWBWCAXVCVNXULOODUQZVWBXVCXULXVEWCAVWPOWYKODUYA
          XLAXVEVWBWCXVCUKXCUYDUYEUYFXUPXUNYTZXUOYTZVNZYTXVDXUNXUOUYGXVHXVCXVFX
          VAXVGXVBVWPOUYHWYKOUYHUYIUYMUYJUYKXCUYLVTXUAVVPXUSVWBXUAWVOWUJDVAZVVP
          WCZVNZVVPXUSWCXUAWUJWUDUSZXVKWXRWUHWUDWUJWUHWUDXGWXRWVQWLXJXUAWVEXVLX
          VKWGXUAAWVEXUIWVFVTVWQVVPWUJDUYNVTWAXVKXVIVVPXUSWVOXVJYPWVOXVIXUSWCXV
          JWVOXVIWUKWUOUYOZDVAXUSWVOWUJXVMDWUJBBUYPUXGWUKWUODUYQWKXCUYRVTXUAVVP
          VWCUSZYTVVPVWBYQXUAVVPVVMVWCAWXQWVKUYSUYTXVNVVPVWBULVWBVUAVUCYJVUBXUA
          WWJWWNXURXUTXUHYBZYBXUAWVOWWJWXQAWUBWVKWVOWYFWVSYSZWWKVTXUAWVOWWNXVPW
          WOVTXUQXVOWUKWYKDUQZVWBYQZXUFXUOYRZYBUNUPWUKWUOBBWYQXUMXVRXUPXVSWYQXU
          LXVQVWBVWPWUKWYKDVUDVUEWYQXUNXUFXUOVWPWUKOVUFVUGVUHWYRXVRXUTXVSXUHWYR
          XVQXUSVWBWYKWUOWUKDVUIVUEWYRXUOXUGXUFWYKWUOOVUFVUJVUHVUKWPVULABEFGHIJ
          LMNWUKWUOOPQRSTUAUBUCUDUHUFUJVVAVUMUXTZXUAWYCWVHXUBWXRWYCWVKWYEXCWXQA
          WUBWVKWVHWYFWWPYSWURVVILVUNWPZWXSVUOVUPVUQVURZWXRWUHWXSUOWYTXVTVUSYIW
          XRVJWXTVVSYMWXRWUHWXSUOWYTXVTXWAVUTXWBVVBVVSVUOVUPYAVVCAULCVVKKVVDVAZ
          VVHKVVEVAVVFVAZVVJLVRKVWBUEVXLVXMVWBWHXWCWHXWDWHUIUCVVGWQ $.
      $}

      $( Value of the Bochner integral for a simple function ` F ` .
         (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
      sitgfval $p |- ( ph -> ( ( W sitg M ) ` F ) = ( W gsum ( x e. ( ran F \
        { .0. } ) |-> ( ( H ` ( M ` ( `' F " { x } ) ) ) .x. x ) ) ) ) $=
        ( vf vg cv crn csn cdif ccnv cima cfv cmpt cgsu cfn wcel cpnf cico wral
        co cc0 cdm cmbfm crab csitg cvv sitgval wceq simpr rneqd difeq1d cnveqd
        imaeq1d fveq2d oveq1d mpteq12dv oveq2d sibfmbl sibfrn sibfima ralrimiva
        jca32 rneq eleq1d cnveq raleqbidv anbi12d elrab sylibr ovex a1i fvmptd
        wa ) AUBFKBUBUDZUEZLUFZUGZWLUHZBUDZUFZUIZIUJZGUJZWQEURZUKZULURKBFUEZWNU
        GZFUHZWRUIZIUJZGUJZWQEURZUKZULURZUCUDZUEZUMUNZXMUHZWRUIZIUJZUSUOUPURZUN
        ZBXNWNUGZUQZWKZUCIUTDVAURZVBZKIVCURVDABCDEUBUCGHIJKLMNOPQRSTVEAWLFVFZWK
        ZXCXKKULYGBWOXBXEXJYGWMXDWNYGWLFAYFVGZVHVIYGXAXIWQEYGWTXHGYGWSXGIYGWPXF
        WRYGWLFYHVJVKVLVLVMVNVOAFYDUNZXDUMUNZXHXSUNZBXEUQZWKZWKFYEUNAYIYJYLACDE
        FGHIJKLMNOPQRSTUAVPACDEFGHIJKLMNOPQRSTUAVQAYKBXEAWQCDEFGHIJKLMNOPQRSTUA
        VRVSVTYCYMUCFYDXMFVFZXOYJYBYLYNXNXDUMXMFWAZWBYNXTYKBYAXEYNXNXDWNYOVIYNX
        RXHXSYNXQXGIYNXPXFWRXMFWCVKVLWBWDWEWFWGXLVDUNAKXKULWHWIWJ $.

      ${
        $d f g m w x .0. $.  $d f m w .x. $.  $d f g m w x B $.
        $d f g m x F $.  $d m G $.  $d f m w H $.  $d f g m w x y z M $.
        $d f g m w S $.  $d f g m w x W $.  $d f m x ph $.
        sitgclg.g $e |- G = ( Scalar ` W ) $.
        sitgclg.d $e |- D = ( ( dist ` G )
                                |` ( ( Base ` G ) X. ( Base ` G ) ) ) $.
        sitgclg.1 $e |- ( ph -> W e. TopSp ) $.
        sitgclg.2 $e |- ( ph -> W e. CMnd ) $.
        sitgclg.3 $e |- ( ph -> ( Scalar ` W ) e. RRExt ) $.
        sitgclg.4 $e |- ( ( ph /\ m e. ( H " ( 0 [,) +oo ) ) /\ x e. B )
                            -> ( m .x. x ) e. B ) $.
        $( TODO : eliminate G and D $)
        $( Closure of the Bochner integral on simple functions, generic
           version.  See ~ sitgclbn for the version for Banach spaces.
           (Contributed by Thierry Arnoux, 24-Feb-2018.) $)
        sitgclg $p |- ( ph -> ( ( W sitg M ) ` F ) e. B ) $=
          ( vy vz csitg co cfv crn csn cdif ccnv cv cima cmpt cgsu sitgfval cvv
          cdm wcel rnexg difexg 3syl wa cc0 cpnf cico simpl sibfima wfun wss wi
          cr csca cbs wf crrh cioo ctg ctopn czlm cds cxp cres xpeq12i reseq12i
          fveq2i eqtri eqid cdr crrext syl5eqel rrextdrg syl syl5eqelr rrextnrg
          cnrg cnlm rrextnlm cchr wceq rrextchr syl5eqr rrextcusp cuss rrextust
          ccusp cmetu rrhf feq1i sylibr ffun cxr 0re pnfxr icossre a1i sseqtr4d
          mp2an fdm funfvima2 syl2anc imp cuni cmeas csiga cicc c0 com cdom w3a
          cfn sstri wbr wdisj cesum cpw isrnmeas simpld csigagen eqeltri sgsiga
          wral fvex sibfmbl mbfmf frn unieqi unisg syl5eq tpsuni eqtr4d sseqtrd
          ssdifd sselda eldifad simp2 eleq1 3anbi2d oveq1 eleq1d imbi12d vtoclg
          mp1i mpcom syl3anc fmptd sibfrn cnvimass dmmptss difss gsumcl eqeltrd
          ctps ssfi ) AHNLUMUNZUONBHUPZOUQZURZHUSBUTZUQVALUOZJUOZUWGFUNZVBZVCUN
          CABCEFHJKLMNOPQRSTUAUBUCUDVDAUWFCUWKNVEOPSUHAHUWCVFZVGUWDVEVGUWFVEVGU
          DHUWLVHUWDUWEVEVIVJABUWFUWJCUWKAUWGUWFVGZVKZAUWIJVLVMVNUNZVAZVGZUWGCV
          GZUWJCVGZAUWMVOZUWNAUWHUWOVGZUWQUWTAUWGCEFHJKLMNOPQRSTUAUBUCUDVPAUXAU
          WQAJVQZUWOJVFZVRUXAUWQVSAVTNWAUOZWBUOZJWCZUXBAVTUXEUXDWDUOZWCUXFAUXED
          UXDWEUPWFUOZIWGUOIWHUOZDIWIUOZIWBUOZUXKWJZWKUXDWIUOZUXEUXEWJZWKUFUXJU
          XMUXLUXNIUXDWIUEWNUXKUXEUXKUXEIUXDWBUEWNZUXOWLWMWOUXHWPUXEWPIUXDWGUEW
          NIUXDWHUEWNAUXDIWQUEAIWRVGZIWQVGAIUXDWRUEUIWSZIWTXAXBAUXDIXDUEAUXPIXD
          VGUXQIXCXAXBAUXPUXIXEVGUXQIUXIUXIWPXFXAAUXDXGUOIXGUOZVLIUXDXGUEWNAUXP
          UXRVLXHUXQIXIXAXJAUXDIXNUEAUXPIXNVGUXQIXKXAXBAUXDXLUOIXLUOZDXOUOZIUXD
          XLUEWNAUXPUXSUXTXHUXQUXKDIUXKWPUFXMXAXJXPVTUXEJUXGUAXQXRZVTUXEJXSXAAU
          WOVTUXCUWOVTVRZAVLVTVGVMXTVGUYBYAYBVLVMYCYFYDAUXFUXCVTXHUYAVTUXEJYGXA
          YEUWOUWHJYHYIYJYIUWNUWGCUWEAUWFCUWEURUWGAUWDCUWEAUWDEYKZCALVFZYKZUYCH
          WCUWDUYCVRAUYDEHALYLUPYKVGZUYDYMUPYKZVGZUCUYFUYHUYDVLVMYNUNLWCYOLUOVL
          XHUKUTZYPYQUUAULUYIULUTZUUBVKUYIYKLUOUYIUYJLUOULUUCXHVSUKUYDUUDUUJYRU
          KULLUUEUUFXAAEKUUGUOZUYGRAKVEKVEVGZAKNWGUOVEQNWGUUKUUHZYDUUIWSACEFHJK
          LMNOPQRSTUAUBUCUDUULUUMUYEUYCHUUNXAAUYCKYKZCAUYCUYKYKZUYNEUYKRUUOUYLU
          YOUYNXHAUYMKVEUUPUVKUUQANUWAVGCUYNXHUGCKNPQUURXAUUSUUTUVAUVBUVCUWQAUW
          QUWRYRZUWSAUWQUWRUVDAGUTZUWPVGZUWRYRZUYQUWGFUNZCVGZVSUYPUWSVSGUWIUWPU
          YQUWIXHZUYSUYPVUAUWSVUBUYRUWQAUWRUYQUWIUWPUVEUVFVUBUYTUWJCUYQUWIUWGFU
          VGUVHUVIUJUVJUVLUVMUWKWPZUVNAUWDYSVGUWKUSVEUWEURZVAZUWDVRZVUEYSVGACEF
          HJKLMNOPQRSTUAUBUCUDUVOVUFAVUEUWFUWDVUEUWKVFUWFUWKVUDUVPBUWFUWJUWKVUC
          UVQYTUWDUWEUVRYTYDUWDVUEUWBYIUVSUVT $.
      $}

      ${
        $d m x B $.  $d m x W $.  $d m F $.  $d m G $.  $d m x ph $.
        $d m .x. $.
        sitgclbn.1 $e |- ( ph -> W e. Ban ) $.
        sitgclbn.2 $e |- ( ph -> ( Scalar ` W ) e. RRExt ) $.
        $( Closure of the Bochner integral on a simple function.  This version
           is specific to Banach spaces, with additional conditions on its
           scalar field.  (Contributed by Thierry Arnoux, 24-Feb-2018.) $)
        sitgclbn $p |- ( ph -> ( ( W sitg M ) ` F ) e. B ) $=
          ( vx vm csca cfv cds cbs cxp cres eqid ccms wcel cmt ctps bncms cmsms
          cbn syl mstps 3syl clmod ccmn bnlmod lmodcmn cv cc0 cpnf cico co cima
          w3a 3ad2ant1 crn imassrn crrh crrext cr wf wss rrhfe frn fveq2i rneqi
          eqtr4i 3sstr4g syl5ss sseld 3adant3 simp3 lmodvscl syl3anc sitgclg
          imp ) AUCBJUEUFZUGUFWOUHUFZWPUIUJZCDUDEWOFGHIJKLMNOPQRSTWOUKZWQUKAJUL
          UMZJUNUMJUOUMAJURUMZWSUAJUPUSJUQJUTVAAWTJVBUMZJVCUMUAJVDZJVEVAUBAUDVF
          ZFVGVHVIVJZVKZUMZUCVFZBUMZVLXAXCWPUMZXHXCXGDVJBUMAXFXAXHAWTXAUAXBUSVM
          AXFXIXHAXFXIAXEWPXCAXEFVNZWPFXDVOAWOVPUFZVNZWPXJWPAWOVQUMVRWPXKVSXLWP
          VTUBWPWOWPUKZWAVRWPXKWBVAFXKFXKXKQWOWOVPWRWCWEWDXMWFWGWHWNWIAXFXHWJXC
          DWOWPBJXGLWRPXMWKWLWM $.
      $}

      ${
        sitgclcn.1 $e |- ( ph -> W e. Ban ) $.
        sitgclcn.2 $e |- ( ph -> ( Scalar ` W ) = CCfld ) $.
        $( Closure of the Bochner integral on a simple function.  This version
           is specific to Banach spaces on the complex numbers.  (Contributed
           by Thierry Arnoux, 24-Feb-2018.) $)
        sitgclcn $p |- ( ph -> ( ( W sitg M ) ` F ) e. B ) $=
          ( csca cfv ccnfld crrext cnrrext syl6eqel sitgclbn ) ABCDEFGHIJKLMNOP
          QRSTUAAJUCUDUEUFUBUGUHUI $.
      $}

      ${
        sitgclre.1 $e |- ( ph -> W e. Ban ) $.
        sitgclre.3 $e |- ( ph -> ( Scalar ` W ) = ( CCfld |`s RR ) ) $.
        $( Closure of the Bochner integral on a simple function.  This version
           is specific to Banach spaces on the real numbers.  (Contributed by
           Thierry Arnoux, 24-Feb-2018.) $)
        sitgclre $p |- ( ph -> ( ( W sitg M ) ` F ) e. B ) $=
          ( csca cfv ccnfld cr cress co crrext rerrext syl6eqel sitgclbn ) ABCD
          EFGHIJKLMNOPQRSTUAAJUCUDUEUFUGUHUIUBUJUKUL $.
      $}
    $}

    ${
      $d x ph $.
      sitg0.1 $e |- ( ph -> W e. TopSp ) $.
      sitg0.2 $e |- ( ph -> W e. Mnd ) $.
      $( The integral of the constant zero function is zero.  (Contributed by
         Thierry Arnoux, 13-Mar-2018.) $)
      sitg0 $p |- ( ph -> ( ( W sitg M ) ` ( U. dom M X. { .0. } ) ) = .0. ) $=
        ( vx cdm cuni csn cxp csitg co cfv cdif ccnv cv cima cmpt cgsu sitgfval
        crn sibf0 c0 wceq wss rnxpss ssdif0 mpbi mpteq1 ax-mp mpt0 eqtri oveq2i
        gsum0 syl6eq ) AGUBUCZJUDZUEZIGUFUGUHIUAVMUPZVLUIZVMUJUAUKZUDULGUHEUHVP
        DUGZUMZUNUGZJAUABCDVMEFGHIJKLMNOPQRABCDEFGHIJKLMNOPQRSTUQUOVSIURUNUGJVR
        URIUNVRUAURVQUMZURVOURUSZVRVTUSVNVLUTWAVKVLVAVNVLVBVCUAVOURVQVDVEUAVQVF
        VGVHIJNVIVGVJ $.
    $}

    ${
      $d f ph $.
      sitgf.1 $e |- ( ( ph /\ f e. dom ( W sitg M ) )
                    -> ( ( W sitg M ) ` f ) e. B ) $.
      $( The integral for simple functions is itself a function.  (Contributed
         by Thierry Arnoux, 13-Feb-2018.) $)
      sitgf $p |- ( ph -> ( W sitg M ) : dom ( W sitg M ) --> B ) $=
        ( vg vx csitg co cdm wfn crn wss wa wfun cfn wcel ccnv csn cima cfv cc0
        wf cpnf cico cdif wral cmbfm crab cmpt cgsu funmpt sitgval funeqd funfn
        cv mpbiri sylib ralrimiva r19.21bi fnfvrnss syl2anc jca df-f sylibr ) A
        JHUCUDZWAUEZUFZWAUGBUHZUIWBBWAURAWCWDAWAUJZWCAWEEUAVKZUGZUKULWFUMUBVKZU
        NZUOHUPUQUSUTUDULUBWGKUNZVAVBUIUAHUECVCUDVDZJUBEVKZUGWJVAWLUMWIUOHUPFUP
        WHDUDVEVFUDZVEZUJEWKWMVGAWAWNAUBBCDEUAFGHIJKLMNOPQRSVHVIVLWAVJVMZAWCWLW
        AUPBULZEWBVBWDWOAWPEWBAWPEWBAWPEWBTVNVOVNEWBBWAVPVQVRWBBWAVSVT $.
    $}

$(
    @{
      sitgadd.1 @e |- ( ph -> W e. TopSp ) @.
      sitgadd.2 @e |- ( ph -> ( W |`v ( H " ( 0 [,) +oo ) ) ) e. SLMod ) @.
      sitgadd.3 @e |- ( ph -> J e. Fre ) @.
      sitgadd.4 @e |- ( ph -> F e. dom ( W sitg M ) ) @.
      sitgadd.5 @e |- ( ph -> G e. dom ( W sitg M ) ) @.
      @{
        sitgadd.6 @e |- ( ph -> ( Scalar ` W ) e. RRExt ) @.
        sitgadd.7 @e |- .+ = ( +g ` W ) @.
        @( Lemma for ~ sitgadd . @)
        sitgaddlem @p |- ( ph -> ( ( W  sitg M ) ` F )
           = ( W gsum ( p e. ( ( ran F X. ran G ) \ { <. .0. , .0. >. } )
           |-> ( ( H ` ( M ` ( ( `' F " { ( 1st ` p ) } )
           i^i ( `' G " { ( 2nd ` p ) } ) ) ) ) .x. ( 1st ` p ) ) ) ) ) @=
          ? @.

        @( For simple functions, the integral of a sum is the sum of the
           integral. @)
        sitgadd @p |- ( ph -> ( ( W  sitg M ) ` ( F oF .+ G ) )
           = ( ( ( W  sitg M ) ` F ) .+ ( ( W  sitg M ) ` G ) ) ) @=
          ? @.
      @}

      sitgle.1 @e |- .<_ = ( le ` W ) @.
      sitgle.2 @e |- ( ph -> W e. oMnd ) @.
      sitgle.4 @e |- ( ph -> F oR .<_ G ) @.
      @( The simple function integral is monotonic.
         @)
      sitgle @p |- ( ph -> ( ( W sitg M ) ` F ) .<_ ( ( W sitg M ) ` G ) ) @=
        ? @.
    @}
$)
  $}

  ${
    $d m w D $.  $d f g m w M $.  $d f g m w W $.
    sitmval.d $e |- D = ( dist ` W ) $.
    sitmval.1 $e |- ( ph -> W e. V ) $.
    sitmval.2 $e |- ( ph -> M e. U. ran measures ) $.
    $( Value of the simple function integral metric for a given space ` W ` and
       measure ` M ` .  (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    sitmval $p |- ( ph -> ( W sitm M ) =
      ( f e. dom ( W sitg M ) , g e. dom ( W sitg M ) |->
        ( ( ( RR*s |`s ( 0 [,] +oo ) ) sitg M ) ` ( f oF D g ) ) ) ) $=
      ( vw vm wcel co csitg cdm cv cof cfv wceq cmeas cuni csitm cxrs cpnf cicc
      cvv crn cc0 cress cmpt2 elex syl oveq1 dmeqd fveq2 ofeq oveqd mpt2eq123dv
      cds fveq2d oveq2 eqcomi ax-mp a1i fveq12d df-sitm ovex dmex mpt2ex ovmpt2
      syl2anc ) AGUGMZEUAUHUBZMGEUCNCDGEONZPZVPCQZDQZBRZNZUDUIUEUFNUJNZEONZSZUK
      ZTAGFMVMIGFULUMJKLGEUGVNCDKQZLQZONZPZWHVQVRWEUTSZRZNZWAWFONZSZUKWDUCCDGWF
      ONZPZWOVQVRGUTSZRZNZWLSZUKWEGTZCDWHWHWMWOWOWSWTWGWNWEGWFOUNUOZXAWTWKWRWLW
      TWJWQVQVRWTWIWPTWJWQTWEGUTUPWIWPUQUMURVAUSWFETZCDWOWOWSVPVPWCXBWNVOWFEGOV
      BUOZXCXBWRVTWLWBWFEWAOVBXBWQVSVQVRWQVSTZXBWPBTXDBWPHVCWPBUQVDVEURVFUSKCDL
      VGCDVPVPWCVOGEOVHVIZXEVJVKVL $.

    $d f g m w D $.  $d f g F $.  $d f g G $.  $d f g m w M $.  $d f g m w W $.
    $d f g ph $.
    sitmfval.1 $e |- ( ph -> F e. dom ( W sitg M ) ) $.
    sitmfval.2 $e |- ( ph -> G e. dom ( W sitg M ) ) $.
    $( Value of the integral distance between two simple functions.
       (Contributed by Thierry Arnoux, 30-Jan-2018.) $)
    sitmfval $p |- ( ph -> ( F ( W sitm M ) G ) =
      ( ( ( RR*s |`s ( 0 [,] +oo ) ) sitg M ) ` ( F oF D G ) ) ) $=
      ( vf vg csitg co cv cfv cvv wceq cdm cof cxrs cc0 cpnf cicc cress sitmval
      csitm wa simprl simprr oveq12d fveq2d wcel fvex a1i ovmpt2d ) AMNCDGEOPUA
      ZUSMQZNQZBUBZPZUCUDUEUFPUGPEOPZRCDVBPZVDRZGEUIPSABMNEFGHIJUHAUTCTZVADTZUJ
      UJZVCVEVDVIUTCVADVBAVGVHUKAVGVHULUMUNKLVFSUOAVEVDUPUQUR $.
  $}

$(
  @{
    @d m x F @.  @d m x G @.  @d m x M @.  @d m x W @.  @d m x ph @.
    sitmcl.0 @e |- ( ph -> W e. Mnd ) @.
    sitmcl.1 @e |- ( ph -> W e. *MetSp ) @.
    sitmcl.2 @e |- ( ph -> M e. U. ran measures ) @.
    sitmcl.3 @e |- ( ph -> F e. dom ( W sitg M ) ) @.
    sitmcl.4 @e |- ( ph -> G e. dom ( W sitg M ) ) @.
    @( Closure of the integral distance between two simple functions, for an
       extended metric space.  (Contributed by Thierry Arnoux, 13-Feb-2018.) @)
    sitmcl @p |- ( ph -> ( F ( W sitm M ) G ) e. ( 0 [,] +oo ) ) @=
      ( co cfv cc0 eqid cr cvv wcel wceq a1i syl vx vm csitm cds cxrs cpnf cicc
      cof cress csitg cxme sitmfval cxp cres cle cordt crest csigagen cxmu crrh
      ccnfld xrge0base ctopn eqcomi xrge00 cvsca ovex ax-xrsvsca ressvsca ax-mp
      xrge0topn csca ax-xrssca resssca fveq2i cbs cdm cuni wf c0g sibff wb ctps
      xmstps tpsuni 3syl feq3 mpbird cmeas crn dmexg uniexg ofresid cpsmet cxmt
      xmsxmet xmetpsmet psmetxrge0 cha ct1 cmopn xmstopn methaus eqeltrd haust1
      xrge0tps cmnd mndidcl xmet0 syl2anc syl6eq sibfof rebase xpeq12i xrge0cmn
      reseq2i ccmn cdr ccrg cfield wa refld isfld mpbi simpli cnrg csubrg cnnrg
      resubdrg subrgnrg mp2an cchr cofld reofld ofldchr ccusp recusp cuss cima
      cv cmetu reust cico w3a cid rrhre imaeq1i wss cxr 0re pnfxr icossre eqtri
      resiima icossicc eqsstri sseli 3ad2ant2 simp3 ge0xmulcl sitgclg ) ABCEDUC
      KKBCEUDLZUHKZUEMUFUGKZUIKZDUJKZLUVDAUVBBCDUKEUVBNGHIJULAUAUVDVAOUIKZUDLZO
      OUMZUNZUOUPLUVDUQKZURLZUSUBUVCUVGUVGUTLZUVKDPUVEMVBUVEVCLUVKVKVDUVLNVEUVD
      PQZUSUVEVFLRMUFUGVGZUVDUSUEUVEPUVENZVHVIVJUVGUVEVLLZUTUVNUVGUVQRUVOUVDUVG
      UEUVEPUVPVMVNVJZVOUVEPQAUEUVDUIVGSHAUVCBCUVBEVPLZUVSUMZUNZUHKUVFVQADVQZVR
      ZUVSUVBBCPAUWCUVSBVSZUWCEVCLZVRZBVSZAUVSUWEURLZEVFLZBEVLLUTLZUWEDUKEEVTLZ
      UVSNZUWENZUWHNZUWKNZUWINZUWJNZGHIWAAUVSUWFRZUWDUWGWBAEUKQZEWCQZUWRGEWDZUV
      SUWEEUWLUWMWEWFZUVSUWFUWCBWGTWHAUWCUVSCVSZUWCUWFCVSZAUVSUWHUWICUWJUWEDUKE
      UWKUWLUWMUWNUWOUWPUWQGHJWAAUWRUXCUXDWBUXBUVSUWFUWCCWGTWHADWIWJVRZQUWBPQUW
      CPQHDUXEWKUWBPWLWFWMAUVSUVDUWAUWHUWIBCUWJUWEUVEDUKEUWKUWLUWMUWNUWOUWPUWQG
      HIVBAUWSUWTGUXATAUWAUVSWNLQZUVTUVDUWAVSAUWSUWAUVSWOLQZUXFGUWAEUVSUWLUWANZ
      WPZUWAUVSWQWFUWAUVSWRTJUVEWCQAXFSZAUWEWSQUWEWTQAUWEUWAXALZWSAUWSUWEUXKRGU
      WAUWEEUVSUWMUWLUXHXBTAUWSUXGUXKWSQGUXIUWAUXKUVSUXKNXCWFXDUWEXETAUWKUWKUWA
      KZMUVEVTLAUXGUWKUVSQZUXLMRAUWSUXGGUXITAEXGQUXMFUVSEUWKUWLUWOXHTUWKUWAUVSX
      IXJVEXKXLXDUVRUVIUVGVPLZUXNUMUVHOUXNOUXNUVGUVGNZXMZUXPXNXPUXJUVEXQQAXOSUV
      GXRQZAUXQUVGXSQZUVGXTQUXQUXRYAUVGUXOYBUVGYCYDYESUVGYFQZAVAYFQOVAYGLQZUXSY
      HUXTUXQYIYEOVAUVGUXOYJYKSUVGYLLMRZAUVGYMQUYAUVGUXOYNUVGYOVJSUVGYPQAUVGUXO
      YQSUVGYRLUVJUUALRAUVGUXOUUBSAUBYTZUVMMUFUUCKZYSZQZUAYTZUVDQZUUDUYBUVDQZUY
      GUYBUYFUSKUVDQUYEAUYHUYGUYDUVDUYBUYDUYCUVDUYDUUEOUNZUYCYSZUYCUVMUYIUYCUUF
      UUGUYCOUUHZUYJUYCRMOQUFUUIQUYKUUJUUKMUFUULYKOUYCUUNVJUUMMUFUUOUUPUUQUURAU
      YEUYGUUSUYBUYFUUTXJUVAXD @.
  @}

  @{
    @d f g M @.  @d f g W @.  @d f g ph @.
    sitmf.0 @e |- ( ph -> W e. Mnd ) @.
    sitmf.1 @e |- ( ph -> W e. *MetSp ) @.
    sitmf.2 @e |- ( ph -> M e. U. ran measures ) @.
    @( The integral metric as a function.  (Contributed by Thierry Arnoux,
       13-Mar-2018.) @)
    sitmf @p |- ( ph -> ( W sitm M ) :
      ( dom ( W sitg M ) X. dom ( W sitg M ) ) --> ( 0 [,] +oo ) ) @=
      ( vf vg csitg co cdm wf cv cfv wcel wral wa cxme eqid adantr cxp cc0 cpnf
      cicc csitm cds cof cxrs cress cmpt2 cmeas crn cuni simprl simprr sitmfval
      cmnd sitmcl eqeltrrd ralrimivva fmpt2 sylib sitmval feq1d mpbird ) ACBIJK
      ZVFUAZUBUCUDJZCBUEJZLVGVHGHVFVFGMZHMZCUFNZUGJUHVHUIJBIJNZUJZLZAVMVHOZHVFP
      GVFPVOAVPGHVFVFAVJVFOZVKVFOZQZQZVJVKVIJVMVHVTVLVJVKBRCVLSZACROVSETZABUKUL
      UMOVSFTZAVQVRUNZAVQVRUOZUPVTVJVKBCACUQOVSDTWBWCWDWEURUSUTGHVFVFVMVHVNVNSV
      AVBAVGVHVIVNAVLGHBRCWAEFVCVDVE @.

    @d f g h x y M @.  @d f g h x y W @.  @d f g h x y ph @.
    @( The integral metric is a pseudo metric on the simple functions.
       (Contributed by Thierry Arnoux, 14-Mar-2018.) @)
    sitmpsmet @p |- ( ph -> ( W sitm M ) e. ( PsMet ` dom ( W sitg M ) ) ) @=
      ( vx vy co cxr wf cc0 wceq cxad wa cfv wcel eqid cvv syl vf vg vh cdm cxp
      csitg csitm cv cle wbr wral cpsmet cpnf wss sitmf iccssxr fss sylancl cds
      cicc cof cxrs cress cxme cmeas crn cuni simpr sitmfval csn cmpt ctopn wfn
      adantr cbs csigagen cvsca csca crrh c0g sibff ffn dmexg uniexg 3syl inidm
      eqidd offval cres ffvelrnda xmstps tpsuni ad2antrr eleqtrrd ovres syl2anc
      ctps cxmt xmsxmet xmet0 eqtrd xrge0base xrge00 xrge0tps a1i cmnd xrge0cmn
      ccmn ax-mp cslmd ct1 cha haust1 mp1i biimpar simprl ofresid cmpt2 fovrnda
      feq3 fnov simprr sylibr ralrimivva rnmpt2ss df-f eqeltrd sibfof cxmu ovex
      jca off mp2an eqtri 0xr wb adantlr ralrimiva offn ofval mpteq2dva syl6eqr
      eqtr3d fconstmpt fveq2d cordt crest xrge0topn eqcomi xrge0slmod xrge0haus
      cmnmnd sitg0 syl5eqel xmetf sylib xmetge0 syl3anc elxrge0 eqsstrd xmstopn
      rneq methaus mndidcl syl6eq adantl eqeltrrd ax-xrsvsca ressvsca ge0xaddcl
      cmopn rgen2a xaddf mpbi reseq1i resmpt2 fnmpt2 0le0 pnfge elicc1 mpbir3an
      w3a pnfxr xaddid1 xrge0le comnd xrge0omnd xmstri2 syl13anc ofrfval mpbird
      cofr sitgle xrge0plusg sitgadd breqtrd oveq12d 3brtr4d ispsmet mp2b ) ACB
      UFIZUDZUXBUEZJCBUGIZKZUAUHZUXFUXDIZLMZUXFUBUHZUXDIZUCUHZUXFUXDIZUXKUXIUXD
      IZNIZUIUJZUCUXBUKUBUXBUKZOZUAUXBUKZOZUXDUXBULPQZAUXEUXRAUXCLUMUTIZUXDKUYA
      JUNZUXEABCDEFUOLUMUPZUXCUYAJUXDUQURAUXQUAUXBAUXFUXBQZOZUXHUXPUYEUXGUXFUXF
      CUSPZVAZIZVBUYAVCIZBUFIZPZLUYEUYFUXFUXFBVDCUYFRZACVDQZUYDEVNZABVEVFVGZQZU
      YDFVNZAUYDVHZUYRVIUYEUYKBUDZVGZLVJUEZUYJPZLUYEUYHVUAUYJUYEUYHGUYTGUHZUXFP
      ZVUDUYFIZVKZVUAUYEGUYTUYTVUDVUDUYFUYTUXFUXFSSUYEUYTCVLPZVGZUXFKZUXFUYTVMZ
      UYECVOPZVUGVPPZCVQPZUXFCVRPVSPZVUGBVDCCVTPZVUKRZVUGRZVULRZVUORZVUMRZVUNRZ
      UYNUYQUYRWAZUYTVUHUXFWBTZVVCUYEUYPUYSSQZUYTSQZUYQBUYOWCZUYSSWDZWEZVVHUYTW
      FZUYEVUCUYTQZOZVUDWGZVVLWHUYEVUFGUYTLVKVUAUYEGUYTVUELVVKVUDVUDUYFVUKVUKUE
      ZWIZIZVUELVVKVUDVUKQZVVPVVOVUEMVVKVUDVUHVUKUYEUYTVUHVUCUXFVVBWJAVUKVUHMZU
      YDVVJAUYMCWQQZVVQECWKZVUKVUGCVUPVUQWLZWEWMWNZVWAVUDVUDVUKVUKUYFWOWPVVKVVN
      VUKWRPQZVVPVVOLMAVWBUYDVVJAUYMVWBEVVNCVUKVUPVVNRZWSZTZWMVWAVUDVVNVUKWTWPU
      UCUUAGUYTLUUDUUBXAUUEAVUBLMUYDAUYAUIUUFPUYAUUGIZVPPZUYIVQPZUYIVRPVSPZVWFB
      WQUYILXBUYIVLPZVWFUUHUUIZVWGRZXCVWHRZVWIRZUYIWQQZAXDXEZFVWPUYIXFQZAUYIXHQ
      ZVWQXGUYIUULXIXEUUMVNXAXAUYEUXOUBUCUXBUXBUYEUXIUXBQZUXKUXBQZOZOZUXFUXIUYG
      IZUYJPZUXKUXFUYGIZUYJPZUXKUXIUYGIZUYJPZNIZUXJUXNUIVXBVXDVXEVXGNVAIZUYJPVX
      IUIVXBUYAVWGVWHVXCVXJVWIVWFUIBXJUYILXBVWKVWLXCVWMVWNUYIXJQVXBUUJXEZUYEUYP
      VXAUYQVNZVWOVXBXDXEZVXKVXBVWFVWJXKVWKVWJXLQVWJXKQVXBUUKVWJXMXNZUUNVXBVXCU
      XFUXIVVNVAZIUYJUDZVXBUYTVUKUYFUXFUXISVXBVVQVUIUYTVUKUXFKZVXBVVRVVQVXBUYMV
      VRUYEUYMVXAUYNVNZVVSTZVVTTZVXBVUKVULVUMUXFVUNVUGBVDCVUOVUPVUQVURVUSVUTVVA
      VXRVXLUYEUYDVXAUYRVNZWAVVQVXQVUIVUKVUHUYTUXFXTXOWPZVXBVVQUYTVUHUXIKZUYTVU
      KUXIKZVXTVXBVUKVULVUMUXIVUNVUGBVDCVUOVUPVUQVURVUSVUTVVAVXRVXLUYEVWSVWTXPZ
      WAZVVQVYDVYCVUKVUHUYTUXIXTXOWPZVXBUYPVVDVVEVXLVVFVVGWEZXQVXBVUKUYAVVNVULV
      UMUXFUXIVUNVUGUYIBVDCVUOVUPVUQVURVUSVUTVVAVXRVXLVYAXBVXSAVVMUYAVVNKZUYDVX
      AAVVNVVMVMZVVNVFZUYAUNZOVYIAVYJVYLAVVMJVVNKZVYJAVWBVYMVWEVVNVUKUUOTZVVMJV
      VNWBTZAVYKGHVUKVUKVUCHUHZVVNIZXRZVFZUYAAVVNVYRMZVYKVYSMAVYJVYTVYOGHVUKVUK
      VVNYAUUPVVNVYRUVBTAVYQUYAQZHVUKUKGVUKUKVYSUYAUNAWUAGHVUKVUKAVUCVUKQZVYPVU
      KQZOZOZVYQJQZLVYQUIUJZOWUAWUEWUFWUGAVUCVYPJVUKVUKVVNVYNXSWUEVWBWUBWUCWUGA
      VWBWUDVWEVNAWUBWUCXPAWUBWUCYBVUCVYPVVNVUKUUQUURYKVYQUUSYCYDGHVUKVUKVYQUYA
      VYRVYRRYETUUTYKVVMUYAVVNYFYCWMZVYEVXMVXBVUGXLQZVUGXKQAWUIUYDVXAAVUGVVNUVK
      PZXLAUYMVUGWUJMEVVNVUGCVUKVUQVUPVWCUVATAVWBWUJXLQVWEVVNWUJVUKWUJRUVCTYGWM
      VUGXMTZVXBVUOVUOVVNIZLUYIVTPZVXBVWBVUOVUKQZWULLMVXBUYMVWBVXRVWDTVXBCXFQZW
      UNAWUOUYDVXADWMVUKCVUOVUPVUSUVDTVUOVVNVUKWTWPXCUVEZYHYGVXBVXJVXEVXGNUYAUY
      AUEZWIZVAIVXPVXBUYTUYANVXEVXGSVXBGHUYTUYTUYTUYFVUKVUKUYAUXKUXFSSVXBWUDOVY
      QVUCVYPUYFIZUYAWUDVYQWUSMVXBVUCVYPVUKVUKUYFWOUVFVXBVUCVYPUYAVUKVUKVVNWUHX
      SUVGZVXBVVQUYTVUHUXKKZUYTVUKUXKKZVXTVXBVUKVULVUMUXKVUNVUGBVDCVUOVUPVUQVUR
      VUSVUTVVAVXRVXLUYEVWSVWTYBZWAZVVQWVBWVAVUKVUHUYTUXKXTXOWPZVYBVYHVYHVVIYLV
      XBGHUYTUYTUYTUYFVUKVUKUYAUXKUXISSWUTWVEVYGVYHVYHVVIYLVYHXQVXBUYAUYAWURVWJ
      VPPZYIVXEVXGVWIVWJUYIBXHUYILXBVWJRZWVFRZXCUYASQYIVWHMLUMUTYJUYAYIVBUYISUY
      IRUVHUVIXIZVWNVWRVXBXGXEVXLVXBVXEUXKUXFVXOIVXPVXBUYTVUKUYFUXKUXFSWVEVYBVY
      HXQVXBVUKUYAVVNVULVUMUXKUXFVUNVUGUYIBVDCVUOVUPVUQVURVUSVUTVVAVXRVXLWVCXBV
      XSWUHVYAVXMWUKWUPYHYGZXBVXMVXBWURWUQVMZWURVFUYAUNZOWUQUYAWURKVXBWVKWVLVUC
      VYPNIZUYAQZHUYAUKGUYAUKZWVKVXBWVNGHUYAVUCVYPUVJUVLZGHUYAUYAWVMWURUYAWURGH
      JJWVMXRZWUQWIZGHUYAUYAWVMXRZNWVQWUQNJJUEZVMZNWVQMWVTJNKWWAUVMWVTJNWBXIGHJ
      JNYAUVNUVOUYBUYBWVRWVSMUYCUYCGHJJUYAUYAWVMUVPYMYNZUVQXNWVOWVLVXBWVPGHUYAU
      YAWVMUYAWURWWBYEXNYKWUQUYAWURYFYCVXBVXGUXKUXIVXOIVXPVXBUYTVUKUYFUXKUXISWV
      EVYGVYHXQVXBVUKUYAVVNVULVUMUXKUXIVUNVUGUYIBVDCVUOVUPVUQVURVUSVUTVVAVXRVXL
      WVCXBVXSWUHVYEVXMWUKWUPYHYGZVXMVXNLLWURIZWUMMVXBWWDLWUMWWDLLNIZLLUYAQZWWF
      WWDWWEMWWFLJQZLLUIUJZLUMUIUJZYOUVRWWGWWIYOLUVSXIWWGUMJQWWFWWGWWHWWIUWBYPY
      OUWCLUMLUVTYMUWAZWWJLLUYAUYANWOYMWWGWWELMYOLUWDXIYNXCYNXEYHYGUWEUYIUWFQVX
      BUWGXEVXBVXCVXJUIUWLUJVUDVUCUXIPZUYFIZVUCUXKPZVUDUYFIZWWMWWKUYFIZNIZUIUJZ
      GUYTUKVXBWWQGUYTVXBVVJOZUYMWWMVUKQVVPWWKVUKQWWQVXBUYMVVJVXRVNVXBUYTVUKVUC
      UXKWVEWJUYEVVJVVPVXAVWAYQVXBUYTVUKVUCUXIVYGWJVUDWWKWWMUYFCVUKVUPUYLUWHUWI
      YRVXBGUYTUYTWWLWWPUIUYTVXCVXJSSVXBUYTUYTUYFUYTUXFUXISSUYEVUJVXAVVCVNZVXBV
      YCUXIUYTVMVYFUYTVUHUXIWBTZVYHVYHVVIYSVXBUYTUYTNUYTVXEVXGSSVXBUYTUYTUYFUYT
      UXKUXFSSVXBWVAUXKUYTVMWVDUYTVUHUXKWBTZWWSVYHVYHVVIYSZVXBUYTUYTUYFUYTUXKUX
      ISSWXAWWTVYHVYHVVIYSZVYHVYHVVIYSVYHVYHVVIVXBUYTUYTVUDWWKUYFUYTUXFUXISSVUC
      WWSWWTVYHVYHVVIUYEVVJVUDVUDMVXAVVLYQZWWRWWKWGZYTVXBUYTUYTWWNWWONUYTVXEVXG
      SSVUCWXBWXCVYHVYHVVIVXBUYTUYTWWMVUDUYFUYTUXKUXFSSVUCWXAWWSVYHVYHVVIWWRWWM
      WGZWXDYTVXBUYTUYTWWMWWKUYFUYTUXKUXISSVUCWXAWWTVYHVYHVVIWXFWXEYTYTUWJUWKUW
      MVXBUYANWVFYIVXEVXGVWIVWJBXJUYILXBWVGWVHXCWVIVWNVXKVXLVXMVXKVXNWVJWWCUWNU
      WOUWPVXBUYFUXFUXIBVDCUYLVXRVXLVYAVYEVIVXBUXLVXFUXMVXHNVXBUYFUXKUXFBVDCUYL
      VXRVXLWVCVYAVIVXBUYFUXKUXIBVDCUYLVXRVXLWVCVYEVIUWQUWRYDYKYRYKUXASQUXBSQUX
      TUXSYPCBUFYJUXASWCUAUBUCUXDSUXBUWSUWTYC @.
  @}
$)

$(
  @{
    @( The metric identification for simple functions. @)
    sitmmetid @p |- ( ( W e. V /\ M e. U. ran measures ) ->
      ( ~Met ` ( W sitm M ) ) = ( ( _I |` B ) ~ae M ) ) @=
      ? @.
  @}

  @{
    sitmmet.1 @e |- B = ( Base ` W ) @.
    @( The integral metric is a metric for the equivalence classes of simple
       functions equal almost everywhere. @)
    sitmmet @p |- ( ( W e. V /\ M e. U. ran measures ) -> ( W sitm M ) e.
     ( *Met ` ( dom ( W sitg M ) /. ( ( _I |` B ) ~ae M ) ) ) ) @=
      ? @.
  @}
$)

  ${
    $d w m $.
    $( Define the Bochner integral as the extension by continuity of the
       Bochnel integral for simple functions.

       Bogachev first defines 'fundamental in the mean' sequences, in
       definition 2.3.1 of [Bogachev] p. 116, and notes that those are actually
       Cauchy sequences for the pseudometric ` ( w sitm m ) ` .

       He then defines the Bochner integral in chapter 2.4.4 in [Bogachev]
       p. 118.  The definition of the Lebesgue integral, ~ df-itg .

       (Contributed by Thierry Arnoux, 13-Feb-2018.) $)
    df-itgm $a |- itgm = ( w e. _V , m e. U. ran measures |->
      ( ( ( metUnif ` ( w sitm m ) ) CnExt ( UnifSt ` w ) ) ` ( w sitg m ) ) )
      $.
  $}

$(
  @{
    @d w m f e n i @.
    @( TODO with the previous definiton, fundamental sequences shall be the
       Cauchy sequences for ` ( W sitm M ) ` : ` U. ( Cau `` ( W sitm M ) ) `

       Define the 'fundamental in the mean' sequences, in the sense of the
       definition 2.3.1 of [Bogachev] p. 116.  (Contributed by Thierry Arnoux,
       21-Oct-2017.) @)
    df-fndm @a |- Fundm = ( w e. _V , m e. U. ran measures |-> { f e. ( dom (
      w sitg m ) ^m NN ) | A. e e. RR+ E. n e. ZZ A. i e. ( ZZ>= ` n )
      ( ( RR*s sitg m ) ` ( ( f ` n ) ( dist ` w ) ( f ` i ) ) ) <_ e } ) @.
  @}

  @{
    @d f g h m n w x @.
    @( Old definition @)
    @( Define the Bochner integral, following definition 2.4.4 in [Bogachev]
       p. 118.  The definition of the Lebesgue integral, ~ df-itg .
       (Contributed by Thierry Arnoux, 21-Oct-2017.) @)
    df-itgm @a |- itgm = ( w e. _V , m e. U. ran measures |-> ( f e. ( ( Base `
      w ) ^m U. dom m ) |-> U. ran ( g e. { h e. ( w Fundm m ) | A. x e. U. dom
      m ( n e. NN |-> ( ( h ` n ) ` x ) ) ( ~~>t ` ( TopSet ` w ) ) ( f ` x ) }
      |-> ( ( ~~>t ` ( TopSet ` w ) ) ` ( ( w sitg m ) ` ( g ` n ) ) ) ) ) ) @.
  @}
$)

$( End $[ set-mbox-ta-itgm.mm $] $)
$( Begin $[ set-mbox-ta-eulerpart.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Euler's partition theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a k l m n o x y z $.  $d a F $.  $d a x y J $.
    oddpwdc.j $e |- J = { z e. NN | -. 2 || z } $.
    oddpwdc.f $e |- F = ( x e. J , y e. NN0 |-> ( ( 2 ^ y ) x. x ) ) $.
    $( Lemma for ~ eulerpart .  The function ` F ` that decomposes a number
       into its "odd" and "even" parts, which is to say the largest power of
       two and largest odd divisor of a number, is a bijection from pairs of a
       natural number and an odd number to natural numbers.  (Contributed by
       Thierry Arnoux, 15-Aug-2017.) $)
    oddpwdc $p |- F : ( J X. NN0 ) -1-1-onto-> NN $=
      ( cn0 cn c2 cexp co cdivides wbr clt wcel wa a1i cc0 wceq va vk vm vn cxp
      vo vl wf1o wtru cv cmul crab csup cdiv 2nn simpl nnexpcld wn ssrab2 simpr
      eqsstri sseldi nnmulcld ancoms adantl id wor cr wss nn0ssre ltso soss mp2
      cz cle wral wrex wi nnz oveq2 breq1d elrab simprl nn0red nnred 2re nexple
      0z leidi mp3an23 ad2antrl nnzd simprr dvdsle imp syl21anc letrd ralrimiva
      sylan2b breq2 ralbidv syl2anc syl3anc supcl cfn wne adantr ex sylancr syl
      nn0zd c1 cc sylibr jca biimpa caddc supub eleq2i sylnib mpd eqcomd breq2d
      mtbid nncnd wb notbid eqeltrd nn0cnd oveq2d oveq1d 3eqtr3d expcld expne0d
      bitri eqtrd divcan3d mulcomd eqtr4d mpbird rspcev uzsupss c0 fzfi nn0ge0d
      nn0uz cfz elfz2 biimpri syl32anc ssrdv ssfi 0nn0 1dvds recni ax-mp breq1i
      w3a exp0 ne0i fisupcl syl13anc cbvrabv syl6eleq sylib nndivdvds nn0addcld
      simprd 1nn0 ltp1 mt2d imnan expp1 nncn divcan2d dvdscmulr syl112anc bitrd
      nnne0d simplr sseli ad2antrr simplll simprbi cmin znnsub iddvdsexp nnnn0d
      2z zexpcl dvdsmultr2 pncan3d expaddd eqtr3d nnne0i divcld mulcld pm2.65da
      mulassd nsyl3 dvds0lem syl31anc sylanbrc nnexpcl mpan nnne0 ad3antlr jcai
      lttri3 divmul2 ancomd oveq12d jca31 impbii f1od2 trud ) EHUEIDUHUIABUAEHJ
      BUJZKLZAUJZUKLZIDUAUJZJJUBUJZKLZUYAMNZUBHULZHOUMZKLZUNLZUYFIEHGUXSEPZUXQH
      PZQZUXTIPZUIUYJUYIUYLUYJUYIQZUXRUXSUYMJUXQJIPZUYMUORUYJUYIUPUQUYMEIUXSEJC
      UJZMNZURZCIULZIFUYQCIUSVAZUYJUYIUTVBVCVDVEUYAIPZUYHEPZUYFHPZQUIUYTVUAVUBU
      YTUYHIPZJUYHMNZURZQZVUAUYTVUCVUEUYTUYTUYGIPZUYGUYAMNZVUCUYTVFUYTJUYFUYNUY
      TUORZUYTUCUDUFHUYEOHOVGZUYTHVHVIVHOVGVUJVJVKHVHOVLVMZRZUYTSVNPZUYEHVIZUDU
      JZUCUJZVONZUDUYEVPZUCVNVQZVUPVUOONURUDUYEVPVUOVUPONVUOUFUJONUFUYEVQVRUDHV
      PQUCHVQZVUMUYTWHRVUNUYTUYDUBHUSRZUYTUYAVNPZVUOUYAVONZUDUYEVPZVUSUYAVSZUYT
      VVCUDUYEVUOUYEPZUYTVUOHPZJVUOKLZUYAMNZQZVVCUYDVVIUBVUOHUYBVUOTUYCVVHUYAMU
      YBVUOJKVTWAWBZUYTVVJQZVUOVVHUYAVVLVUOUYTVVGVVIWCZWDVVLVVHVVLJVUOUYNVVLUOR
      VVMUQZWEVVLUYAUYTVVJUPZWEVVGVUOVVHVONZUYTVVIVVGJVHPJJVONVVPWFJWFWIVUOJWGW
      JWKVVLVVHVNPZUYTVVIVVHUYAVONZVVLVVHVVNWLVVOUYTVVGVVIWMVVQUYTQVVIVVRVVHUYA
      WNWOWPWQWSZWRVURVVDUCUYAVNVUPUYATVUQVVCUDUYEVUPUYAVUOVOWTXAUUAXBUCUDUFUYE
      SHUUFUUBXCZXDZUQZUYTVUBVUHUYTUYFJUGUJZKLZUYAMNZUGHULZPVUBVUHQUYTUYFUYEVWF
      UYTVUJUYEXEPZUYEUUCXFZVUNUYFUYEPVULUYTSUYAUUGLZXEPUYEVWIVIVWGSUYAUUDUYTUD
      UYEVWIUYTVVFVUOVWIPZUYTVVFQZVUMVVBVUOVNPZSVUOVONZVVCVWJVUMVWKWHRUYTVVBVVF
      VVEXGVWKVUOVVFUYTVVJVVGVVKVVMWSZXKVWKVUOVWNUUEVVSVWJVUMVVBVWLUURVWMVVCQQV
      UOSUYAUUHUUIUUJXHUUKVWIUYEUULXIUYTSUYEPZVWHUYTSHPZJSKLZUYAMNZQVWOUYTVWPVW
      RVWPUYTUUMRUYTXLUYAMNZVWRUYTVVBVWSVVEUYAUUNXJVWQXLUYAMJXMPZVWQXLTJWFUUOZJ
      UUSUUPUUQXNXOUYDVWRUBSHUYBSTUYCVWQUYAMUYBSJKVTWAWBXNUYESUUTXJVVAHUYEOUVAU
      VBUYDVWEUBUGHUYBVWCTUYCVWDUYAMUYBVWCJKVTWAUVCZUVDVWEVUHUGUYFHVWCUYFTVWDUY
      GUYAMVWCUYFJKVTWAWBUVEUVHUYTVUGQVUHVUCUYAUYGUVFXPWPZUYTUYGJUKLZUYAMNZVUDU
      YTJUYFXLXQLZKLZUYAMNZVXEUYTVXFHPZVXHURZUYTUYFXLVWAXLHPUYTUVIRUVGUYTVXIVXH
      QZURVXIVXJVRUYTVXFVWFPZVXKUYTVXFUYEPZVXLUYTVXMUYFVXFONZUYTUYFVHPZVXNUYTHV
      HUYFVJVWAVBZUYFUVJXJUYTUCUDUFHUYEVXFOVULVVTXRUVKUYEVWFVXFVXBXSXTVWEVXHUGV
      XFHVWCVXFTVWDVXGUYAMVWCVXFJKVTWAWBXTVXIVXHUVLXNYAUYTVXGVXDUYAMUYTVWTVUBVX
      GVXDTVXAVWAJUYFUVMXIWAYDUYTVXEVXDUYGUYHUKLZMNZVUDUYTUYAVXQVXDMUYTVXQUYAUY
      TUYAUYGUYAUVNZUYTUYGVWBYEZUYTUYGVWBUVSZUVOYBZYCUYTJVNPZUYHVNPZUYGVNPUYGSX
      FVXRVUDYFUYTJVUIWLUYTUYHVXCWLZUYTUYGVWBWLVYAUYGJUYHUVPUVQUVRYDXOVUAUYHUYR
      PVUFEUYRUYHFXSUYQVUECUYHIUYOUYHTUYPVUDUYOUYHJMWTYGWBYOXNZVWAXOVEUYKUYAUXT
      TZQZUYTUXSUYHTZUXQUYFTZQZQZYFUIVYHVYLVYHUYTVYKVYHUYAUXTIUYKVYGUTZVYHUXRUX
      SVYHJUXQUYNVYHUORUYIUYJVYGUVTZUQZUYIUXSIPZUYJVYGEIUXSUYSUWAUWBZVCYHZVYHVY
      JVYIVYHVYJVYIVYHVYJUXQUYFONZURZUYFUXQONURZQZVYHVYTWUAVYHVYSUYIUYIUYJVYGVY
      SUWCUYIJUXSMNZVYHVYSQZUYIVYPWUCURZUYIUXSUYRPVYPWUEQEUYRUXSFXSUYQWUECUXSIU
      YOUXSTUYPWUCUYOUXSJMWTYGWBYOUWDWUDWUCJUYHJUYFUXQUWELZKLZUKLZMNZWUDJWUGMNZ
      WUIWUDVYCWUFIPZWUJVYCWUDUWIRZWUDUXQVNPZUYFVNPZVYSWUKWUDUXQVYHUYJVYSVYNXGZ
      XKZWUDUYFWUDUCUDUFHUYEOVUJWUDVUKRVYHVUTVYSVYHUYTVUTVYRVVTXJZXGXDZXKZVYHVY
      SUTWUMWUNQVYSWUKUXQUYFUWFXPWPZJWUFUWGXBWUDVYCVYDWUGVNPZWUJWUIVRWULVYHVYDV
      YSVYHUYTVYDVYRVYEXJXGWUDVYCWUFHPWVAWULWUDWUFWUTUWHZJWUFUWJXBJUYHWUGUWKXCY
      AWUDUXSWUHJMWUDUXSWUGUYHUKLZWUHWUDUXTUXRUNLUXRWVCUKLZUXRUNLUXSWVCWUDUXTWV
      DUXRUNWUDUXTUXRWUGUKLZUYHUKLZWVDWUDUYAVXQUXTWVFWUDUYTUYAVXQTZVYHUYTVYSVYR
      XGZVYBXJVYHVYGVYSVYMXGWUDUYGWVEUYHUKWUDJUXQWUFXQLZKLUYGWVEWUDWVIUYFJKWUDU
      XQUYFWUDUXQWUOYIWUDUYFWURYIUWLYJWUDJUXQWUFVWTWUDVXARZWVBWUOUWMUWNYKYLWUDU
      XRWUGUYHWUDJUXQWVJWUOYMZWUDJWUFWVJWVBYMZWUDUYAUYGWUDUYTUYAXMPZWVHVXSXJWUD
      UYTUYGXMPWVHVXTXJWUDJUYFWVJJSXFWUDJUOUWORZWUSYNUWPZUWSYPYKWUDUXSUXRWUDUXS
      VYHVYPVYSVYQXGYEWVKWUDJUXQWVJWVNWUPYNZYQWUDWVCUXRWUDWUGUYHWVLWVOUWQWVKWVP
      YQYLWUDUYHWUGWVOWVLYRYSYCYTUWTUWRVYHUXQUYEPZWUAVYHUYJUXRUYAMNZWVQVYNVYHUX
      SVNPUXRVNPVVBUXSUXRUKLZUYATWVRVYHUXSVYQWLVYHUXRVYOWLVYHUYTVVBVYRVVEXJVYHU
      YAWVSVYHUYAUXTWVSVYMVYHUXRUXSVYHUXRVYOYEVYHUXSVYQYEYRYPYBUXSUXRUYAUXAUXBU
      YDWVRUBUXQHUYBUXQTUYCUXRUYAMUYBUXQJKVTWAWBUXCVYHUCUDUFHUYEUXQOVUJVYHVUKRW
      UQXRYAXOVYHUXQVHPVXOVYJWUBYFVYHHVHUXQVJVYNVBVYHUYTVXOVYRVXPXJUXQUYFUXIXBY
      TVYHVYJVYIVYHVYJQZUXSUYAUXRUNLZUYHWVTWWAUXSWVTWWAUXSTZVYGVYHVYGVYJVYMXGWV
      TWVMUXSXMPUXRXMPZUXRSXFZQZWWBVYGYFWVTUYAVYHUYTVYJVYRXGYEWVTUXSVYHVYPVYJVY
      QXGYEUYJWWEUYIVYGVYJUYJWWCWWDUYJUXRUYNUYJUXRIPZUOJUXQUXDUXEZYEUYJWWFWWDWW
      GUXRUXFXJXOUXGUYAUXSUXRUXJXCYTYBWVTUXRUYGUYAUNWVTVYJUXRUYGTVYHVYJUTUXQUYF
      JKVTXJYJYPXHUXHUXKXOVYLUYIUYJVYGVYLUXSUYHEUYTVYIVYJWCZUYTVUAVYKVYFXGYHVYL
      UXQUYFHUYTVYIVYJWMZUYTVUBVYKVWAXGYHVYLUYAVXQUXTUYTWVGVYKVYBXGVYLUXRUYGUXS
      UYHUKVYLUXQUYFJKWWIYJWWHUXLYSUXMUXNRUXOUXP $.

    $d x y W $.
    $( Lemma for ~ eulerpart : value of the ` F ` function.  (Contributed by
       Thierry Arnoux, 9-Sep-2017.) $)
    oddpwdcv $p |- ( W e. ( J X. NN0 ) ->
        ( F ` W ) = ( ( 2 ^ ( 2nd ` W ) ) x. ( 1st ` W ) ) ) $=
      ( cn0 cxp wcel cfv c1st co c2 cexp cmul wceq cv oveq2 c2nd cop wa simplbi
      elxp6 fveq2d df-ov a1i simprbi oveq1d ovex ovmpt2 syl 3eqtr2d ) FEIJKZFDL
      FMLZFUALZUBZDLZUPUQDNZOUQPNZUPQNZUOFURDUOFURRZUPEKUQIKUCZFEIUEZUDUFUTUSRU
      OUPUQDUGUHUOVDUTVBRUOVCVDVEUIABUPUQEIOBSZPNZASZQNVBDVGUPQNVHUPVGQTVFUQRVG
      VAUPQVFUQOPTUJHVAUPQUKULUMUN $.
  $}

  ${
    $( Define the set of finitely supported functions into nonnegative natural
       numbers. We'll first prove some of their properties.  $)
    eulerpartlems.r $e |- R = { f | ( `' f " NN ) e. Fin } $.

    $( ` S ` recovers the sum of a partition. $)
    eulerpartlems.s $e |- S = ( f e. ( ( NN0 ^m NN ) i^i R )
      |-> sum_ k e. NN ( ( f ` k ) x. k ) ) $.

    $d f k A $.  $d f k R $.
    $( Lemma for ~ eulerpart .  Value of the sum of a partition ` A ` .
       (Contributed by Thierry Arnoux, 26-Aug-2018.) $)
    eulerpartlemsv1 $p |- ( A e. ( ( NN0 ^m NN ) i^i R )
      -> ( S ` A ) = sum_ k e. NN ( ( A ` k ) x. k ) ) $=
      ( cn0 cn cmap co wcel cv cfv cmul csu cvv wceq a1i wa cin simplr sumeq2dv
      cmpt fveq1d oveq1d id sumex fvmptd ) AHIJKBUAZLZDAIEMZDMZNZULOKZEPZIULANZ
      ULOKZEPZUJCQCDUJUPUDRUKGSUKUMARZTZIUOUREVAULILZTZUNUQULOVCULUMAUKUTVBUBUE
      UFUCUKUGUSQLUKIUREUHSUI $.

    $( Lemma for ~ eulerpart .  (Contributed by Thierry Arnoux, 8-Aug-2018.) $)
    eulerpartlemelr $p |- ( A e. ( ( NN0 ^m NN ) i^i R )
      -> ( A : NN --> NN0 /\ ( `' A " NN ) e. Fin ) ) $=
      ( cn0 cn cmap co cin wcel wf ccnv cima cfn inss1 sseli elmapi syl cv wceq
      inss2 cnveq imaeq1d eleq1d elab2g mpbid jca ) AHIJKZBLZMZIHANZAOZIPZQMZUM
      AUKMUNULUKAUKBRSAHITUAUMABMUQULBAUKBUDSDUBZOZIPZQMUQDABULURAUCZUTUPQVAUSU
      OIURAUEUFUGFUHUIUJ $.

    $( Lemma for ~ eulerpart .  Value of the sum of a finite partition ` A `
       (Contributed by Thierry Arnoux, 19-Aug-2018.) $)
    eulerpartlemsv2 $p |- ( A e. ( ( NN0 ^m NN ) i^i R )
      -> ( S ` A ) = sum_ k e. ( `' A " NN ) ( ( A ` k ) x. k ) ) $=
      ( cn0 cn co wcel cfv cmul csu c1 wceq wa adantr cc0 wn cmap cin ccnv cima
      cv eulerpartlemsv1 cdm cnvimass cfn eulerpartlemelr simpld fdm syl sselda
      wf syl5sseq ffvelrnd nnnn0d nn0mulcld nn0cnd cdif wo simpr eldifad wi wfn
      eldifbd ffn elpreima 3syl notbid mpbid imnan sylibr mpd elnn0 sylib orel1
      wb imp syl2anc oveq1d nncnd mul02d eqtrd cuz wss eqimssi a1i sumss eqtr4d
      nnuz ) AHIUAJBUBKZACLIEUEZALZWNMJZENAUCIUDZWPENABCDEFGUFWMWQIWPEOWMAUGZWQ
      IAIUHWMIHAUOZWRIPWMWSWQUIKABCDEFGUJUKZIHAULUMUPZWMWNWQKZQZWPXCWOWNXCIHWNA
      WMWSXBWTRWMWQIWNXAUNZUQXCWNXDURUSUTWMWNIWQVAKZQZWPSWNMJSXFWOSWNMXFWOIKZTZ
      XGWOSPZVBZXIXFWNIKZXHXFWNIWQWMXEVCZVDZXFXKXGQZTZXKXHVEXFXBTXOXFWNIWQXLVGX
      FXBXNXFWSAIVFXBXNVSWMWSXEWTRZIHAVHIWNIAVIVJVKVLXKXGVMVNVOXFWOHKXJXFIHWNAX
      PXMUQWOVPVQXHXJXIXGXIVRVTWAWBXFWNXFWNXMWCWDWEIOWFLZWGWMIXQWLWHWIWJWK $.

    $d f g k R $.
    $( Lemma for ~ eulerpart .  (Contributed by Thierry Arnoux, 8-Aug-2018.) $)
    eulerpartlemsf $p |- S : ( ( NN0 ^m NN ) i^i R ) --> NN0 $=
      ( vg cn cv cfv cmul co csu cn0 wcel cmap wf wi wceq wa cin wral vex eleq1
      simpl fveq1d oveq1d sumeq2dv imbi12d ccnv eulerpartlemsv2 eulerpartlemsv1
      eleq1d cima eqtr3d cfn eulerpartlemelr simprd simpld cdm cnvimass fdm syl
      adantr syl5sseq sselda ffvelrnd nnnn0d nn0mulcld fsumnn0cl eqeltrrd vtocl
      rgen fmpt mpbi ) HDIZCIZJZVPKLZDMZNOZCNHPLAUAZUBWBNBQWACWBGIZWBOZHVPWCJZV
      PKLZDMZNOZRVQWBOZWARGVQCUCWCVQSZWDWIWHWAWCVQWBUDWJWGVTNWJHWFVSDWJVPHOZTZW
      EVRVPKWLVPWCVQWJWKUEUFUGUHUMUIWDWCUJHUNZWFDMZWGNWDWCBJWNWGWCABCDEFUKWCABC
      DEFULUOWDWMWFDWDHNWCQZWMUPOZWCABCDEFUQZURWDVPWMOZTZWEVPWSHNVPWCWDWOWRWDWO
      WPWQUSZVDWDWMHVPWDWCUTZWMHWCHVAWDWOXAHSWTHNWCVBVCVEVFZVGWSVPXBVHVIVJVKVLV
      MCWBNVTBFVNVO $.

    $( This proof could be shortened, at least by using finite sum theorems $)
    $d k l m t A $.  $d l t R $.  $d l t S $.
    $( Lemma for ~ eulerpart .  (Contributed by Thierry Arnoux, 6-Aug-2018.) $)
    eulerpartlems $p |- ( ( A e. ( ( NN0 ^m NN ) i^i R )
      /\ t e. ( ZZ>= ` ( ( S ` A ) + 1 ) ) ) -> ( A ` t ) = 0 ) $=
      ( cn0 cn co wcel cfv c1 wa cc0 wceq clt wbr cmul vl vm cmap cin caddc cuz
      cv cfz wb eulerpartlemsf ffvelrni nndiffz1 eleq2d syl pm5.32i simpr eldif
      cdif wn sylib simpld ccnv cima cfn eulerpartlemelr ffvelrnda syldan simpl
      wf adantr simprd cz nnuz syl6eleq nn0zd elfz5 syl2anc notbid nn0red nnred
      cle ltnled bitr4d biimpa syl21anc wral wrex fveq2 oveq12d eulerpartlemsv1
      wi csu id cbvsumv eqcomd syl5eqr breq2 breq2d anbi12d cbvrexv cr ad2antrr
      wne cmpt 1z a1i eqidd fveq2d ffvelrn nnnn0d nn0mulcld fvmptd cc wss fmptd
      cbvmptv nn0sscn fss sylancl cvv csn eqid ffs2 dfn2 eqeltrd ffn w3a oveq1d
      simp3 simp2 nncnd mul02d eqtrd suppss3 ssfi eqeltrrd sylbir ex imp sylibr
      fsumcvg4 isumrecl simprl remulcld nn0ge0 simprr elnnnn0b nnge1 lemulge12d
      nn0cnd sumsn snfi snssd nn0ge0d isumless eqbrtrrd letrd ltletrd rexlimdva
      mulcld syl6breq ltne neeq1i syl5bi necon2bd mpd ralnex imnan ralbii nn0re
      r19.21bi 0re lenltd nn0le0eq0 bitr3d ) BIJUCKCUDZLZAUGZBDMZNUEKUFMZLZOUVQ
      UVRJNUVSUHKZURZLZOZUVRBMZPQZUVQUWDUWAUVQUVSILZUWDUWAUIUVPIBDCDEFGHUJUKZUW
      HUWCUVTUVRUVSULUMUNUOUWEUWFILZPUWFRSZUSZUWGUVQUWDUVRJLZUWJUWEUWMUVRUWBLZU
      SZUWEUWDUWMUWOOUVQUWDUPUVRJUWBUQUTZVAZUVQJIUVRBUVQJIBVIZBVBZJVCZVDLZBCDEF
      GHVEZVAZVFVGUWEUVQUWMUVSUVRRSZUWLUVQUWDVHUWQUWEUWMUWHUWOUXDUWQUVQUWHUWDUW
      IVJUWEUWMUWOUWPVKUWMUWHOZUWOUXDUXEUWOUVRUVSWASZUSUXDUXEUWNUXFUXEUVRNUFMZL
      UVSVLLUWNUXFUIUXEUVRJUXGUWMUWHVHZVMVNUXEUVSUWMUWHUPZVOUVRNUVSVPVQVRUXEUVS
      UVRUXEUVSUXIVSUXEUVRUXHVTWBWCWDWEUVQUWMOUXDUWLUVQUXDUWLWKZAJUVQUXDUWKOZUS
      ZAJWFZUXJAJWFUVQUXKAJWGZUSZUXMUVQJUWFUVRTKZAWLZUVSQUXOUVQUXQJFUGZBMZUXRTK
      ZFWLZUVSJUXTUXPFAUXRUVRQZUXSUWFUXRUVRTUXRUVRBWHUYBWMWIWNUVQUVSUYABCDEFGHW
      JWOWPUVQUXNUXQUVSUXNUVSUAUGZRSZPUYCBMZRSZOZUAJWGZUVQUXQUVSXCZUXKUYGAUAJUV
      RUYCQZUXDUYDUWKUYFUVRUYCUVSRWQUYJUWFUYEPRUVRUYCBWHZWRWSWTUVQUYHUYIUVQUYHO
      ZUVSXALZUVSJUYEUYCTKZUAWLZRSZUYIUYLUVSUVQUWHUYHUWIVJVSUYLUVSUXQUYORUVQUYH
      UVSUXQRSZUVQUYGUYQUAJUVQUYCJLZOZUYGUYQUYSUYGOZUVSUYCUXQUYTUVSUVQUWHUYRUYG
      UWIXBVSUYTUYCUYSUYRUYGUVQUYRUPZVJZVTZUYSUXQXALUYGUYSUXPAUBJUBUGZBMZVUDTKZ
      XDZNJVMNVLLUYSXEXFZUYSUWMOZUWRUWMUVRVUGMUXPQUVQUWRUYRUWMUXCXBUYSUWMUPZUWR
      UWMOZUBUVRVUFUXPJVUGIVUKVUGXGVUKVUDUVRQZOZVUEUWFVUDUVRTVUMVUDUVRBVUKVULUP
      ZXHVUNWIUWRUWMUPZVUKUWFUVRJIUVRBXIVUKUVRVUOXJXKXLVQZVUIUXPVUIUWFUVRUYSJIU
      VRBUVQUWRUYRUXCVJZVFVUIUVRVUJXJXKZVSZUYSJVUGNVMVUHUYSJIVUGVIIXMXNJXMVUGVI
      ZUYSAJUXPIVUGVURUBAJVUFUXPVULVUEUWFVUDUVRTVUDUVRBWHVULWMWIXPZXOXQJIXMVUGX
      RXSZUYSVUGVBZXTPYAZURZVCZVVCXMVVDURZVCZVDUYSVUTVVFVVHQVVBJXMVVGVUGPVVGYBY
      CUNUYSUWSVVEVCZVDLVVFVVIXNZVVFVDLUYSVVIUWTVDUYSUWRVVIUWTQVUQJIJBPYDYCUNUV
      QUXAUYRUVQUWRUXAUXBVKVJYEUYSUWRVVJVUQUWRAJUXPBVUGPVVAJIBYFUWRUWMUWGYGZUXP
      PUVRTKPVVKUWFPUVRTUWRUWMUWGYIYHVVKUVRVVKUVRUWRUWMUWGYJYKYLYMYNUNVVIVVFYOV
      QYPUUAZUUBVJZUYSUYDUYFUUCUYTUYCUYNUXQVUCUYTUYEUYCUYTUYEUYSUYEILZUYGUVQJIU
      YCBUXCVFZVJZVSZVUCUUDVVMUYTUYCUYEVUCVVQUYTUYCILPUYCWASUYTUYCVUBXJUYCUUEUN
      UYTVVNUYFNUYEWASZVVPUYSUYDUYFUUFVVNUYFOUYEJLVVRUYEUUGUYEUUHYQVQUUIUYSUYNU
      XQWASUYGUYSUYCYAZUXPAWLZUYNUXQWAUYSUYRUYNXMLVVTUYNQVUAUYSUYEUYCUYSUYEVVOU
      UJUYSUYCVUAYKUUTUXPUYNAUYCJUYJUWFUYEUVRUYCTUYKUYJWMWIZUUKVQUYSVVSUXPAVUGN
      JVMVUHVVSVDLUYSUYCUULXFUYSUYCJVUAUUMVUPVUSVUIUXPVURUUNVVLUUOUUPVJUUQUURYR
      UUSYSJUXPUYNAUAVWAWNZUVAUYMUYPOUYOUVSXCUYIUVSUYOUVBUXQUYOUVSVWBUVCYTVQYRU
      VDUVEUVFUXKAJUVGYTUXJUXLAJUXDUWKUVHUVIYTUVKYSWEUWJUWLUWGUWJUWFPWASUWLUWGU
      WJUWFPUWFUVJPXALUWJUVLXFUVMUWFUVNUVOWDVQYQ $.

    $d k t S $.
    $( Lemma for ~ eulerpart .  Value of the sum of a finite partition ` A `
       (Contributed by Thierry Arnoux, 19-Aug-2018.) $)
    eulerpartlemsv3 $p |- ( A e. ( ( NN0 ^m NN ) i^i R )
      -> ( S ` A ) = sum_ k e. ( 1 ... ( S ` A ) ) ( ( A ` k ) x. k ) ) $=
      ( vt cn0 cn co wcel cfv cv cmul csu c1 cc0 wceq wral cmap eulerpartlemsv1
      cin cfz wss cuz fzssuz nnuz sseqtr4i a1i wa ccnv cima cfn eulerpartlemelr
      wf simpld adantr sselda ffvelrn syl2anc nn0cnd nncnd mulcld eulerpartlems
      cdif caddc ralrimiva fveq2 eqeq1d sylibr eulerpartlemsf ffvelrni nndiffz1
      cbvralv syl raleq mpbird r19.21bi oveq1d simpr eldifad mul02d eqtrd sumss
      wb eqimssi eqtr4d ) AIJUAKBUCZLZACMZJENZAMZWLOKZEPQWKUDKZWNEPABCDEFGUBWJW
      OJWNEQWOJUEWJWOQUFMZJQWKUGUHUIUJZWJWLWOLZUKZWMWLWSWMWSJIAUPZWLJLWMILWJWTW
      RWJWTAULJUMUNLABCDEFGUOUQURWJWOJWLWQUSZJIWLAUTVAVBWSWLXAVCVDWJWLJWOVFZLZU
      KZWNRWLOKRXDWMRWLOWJWMRSZEXBWJXEEXBTZXEEWKQVGKUFMZTZWJHNZAMZRSZHXGTXHWJXK
      HXGHABCDEFGVEVHXEXKEHXGWLXISWMXJRWLXIAVIVJVOVKWJXBXGSZXFXHWFWJWKILXLWIIAC
      BCDEFGVLVMWKVNVPXEEXBXGVQVPVRVSVTXDWLXDWLXDWLJWOWJXCWAWBVCWCWDJWPUEWJJWPU
      HWGUJWEWH $.

    $d i n $.  $d i t A $.  $d i t R $.
    $( Lemma for ~ eulerpart .  (Contributed by Thierry Arnoux, 9-Aug-2018.) $)
    eulerpartlemgc $p |- ( ( A e. ( ( NN0 ^m NN ) i^i R ) /\ ( t e. NN
      /\ n e. ( bits ` ( A ` t ) ) ) ) -> ( ( 2 ^ n ) x. t ) <_ ( S ` A ) ) $=
      ( vi cn0 cn co wcel wa c2 cmul cc0 cle wbr cmap cin cv cfv cbits cexp 2re
      a1i wss bitsss simprr sseldd reexpcld simprl nnred remulcld ccnv cima cfn
      cr wf eulerpartlemelr simpld simpr ffvelrn syl2anc adantrr eulerpartlemsf
      adantr nn0red ffvelrni w3a nnrpd rprege0d 3jca csn csu bitsfi sselda 2pos
      syl clt 0re ltlei ax-mp expge0d snssd fsumless recnd oveq2 sumsn bitsinv1
      cc wceq 3brtr3d lemul1a c1 cfz wn fzfid simpl elfznn syl2an adantlr nngt0
      nn0ge0d ltled mulge0d fveq2 oveq12d fsumge1 cdif eldif caddc cuz nndiffz1
      id wb eleq2d pm5.32i eulerpartlems sylbi oveq1d nncnd syldan mul02d eqtrd
      eldifad fsumge0 eqbrtrd sylan2br wo exmid mpjaodan eulerpartlemsv3 eqcomd
      anassrs breqtrd letrd ) BKLUAMCUBZNZAUCZLNZGUCZUUBBUDZUEUDZNZOZOZPUUDUFMZ
      UUBQMZUUEUUBQMZBDUDZUUIUUJUUBUUIPUUDPUTNZUUIUGUHUUIUUFKUUDUUFKUIUUIUUEUJU
      HZUUAUUCUUGUKZULUMZUUIUUBUUAUUCUUGUNZUOZUPUUIUUEUUBUUIUUEUUAUUCUUEKNZUUGU
      UAUUCOZLKBVAZUUCUUTUUAUVBUUCUUAUVBBUQLURUSNBCDEFHIVBVCZVIUUAUUCVDZLKUUBBV
      EVFZVGZVJUUSUPUUIUUMUUAUUMKNZUUHYTKBDCDEFHIVHVKZVIVJUUIUUJUTNZUUEUTNZUUBU
      TNRUUBSTOZVLUUJUUESTUUKUULSTUUIUVIUVJUVKUUQUUAUUCUVJUUGUVAUUEUVEVJVGUUIUU
      BUUIUUBUURVMVNVOUUIUUDVPZPJUCZUFMZJVQZUUFUVNJVQZUUJUUESUUIUUFUVNUVLJUUIUU
      TUUFUSNUVFUUEVRWAUUIUVMUUFNOZPUVMUUNUVQUGUHZUUIUUFKUVMUUOVSZUMUVQPUVMUVRU
      VSRPSTZUVQRPWBTUVTVTRPWCUGWDWEUHWFUUIUUDUUFUUPWGWHUUIUUGUUJWMNUVOUUJWNUUP
      UUIUUJUUQWIUVNUUJJUUDUUFUVMUUDPUFWJWKVFUUIUUTUVPUUEWNUVFJUUEWLWAWOUUJUUEU
      UBWPVFUUAUUHUUCUULUUMSTUURUVAUULWQUUMWRMZFUCZBUDZUWBQMZFVQZUUMSUVAUUBUWAN
      ZUULUWESTZUWFWSZUUAUWFUWGUUCUUAUWFOZUWAUWDUULFUUBUWIWQUUMWTUUAUWBUWANZUWD
      UTNUWFUUAUWJOZUWCUWBUWKUWCUWKUUAUWJUWCKNZUUAUWJXAUUAUWJVDZUUAUVBUWBLNZUWL
      UWJUVCUWBUUMXBZLKUWBBVEXCVFZVJZUWKUWBUWKUWJUWNUWMUWOWAZUOZUPZXDUUAUWJRUWD
      STUWFUWKUWCUWBUWQUWSUWKUWCUWPXFUWKRUWBRUTNUWKWCUHUWSUWKUWNRUWBWBTUWRUWBXE
      WAXGXHZXDUWBUUBWNZUWCUUEUWBUUBQUWBUUBBXIUXBXQXJUUAUWFVDXKXDUUAUUCUWHUWGUU
      CUWHOUUAUUBLUWAXLZNZUWGUUBLUWAXMUUAUXDOZUULRUWESUXEUULRUUBQMRUXEUUERUUBQU
      XEUUAUUBUUMWQXNMXOUDZNZOUUERWNUUAUXDUXGUUAUVGUXDUXGXRUVHUVGUXCUXFUUBUUMXP
      XSWAXTABCDEFHIYAYBYCUXEUUBUUAUXDUUCUUBWMNUXEUUBLUWAUUAUXDVDYHUVAUUBUVDYDY
      EYFYGUUARUWESTUXDUUAUWAUWDFUUAWQUUMWTUWTUXAYIVIYJYKYQUWFUWHYLUVAUWFYMUHYN
      UVAUUMUWEUUAUUMUWEWNUUCBCDEFHIYOVIYPYRYEYS $.
  $}

  ${
    $( Given a natural number ` N ` , consider ` P ` , the set of partitions
       of ` N ` , whereas partitions are represented as functions ` f `
       associating a finite set of natural numbers ` k ` with the number of
       times ` k ` appears in the partition. $)
    eulerpart.p $e |- P = { f e. ( NN0 ^m NN ) | ( ( `' f " NN ) e. Fin /\
      sum_ k e. NN ( ( f ` k ) x. k ) = N ) } $.

    ${
      $d f k A $.  $d f N $.
      $( Lemma for ~ eulerpart .  (Contributed by Mario Carneiro,
         26-Jan-2015.) $)
      eulerpartleme $p |- ( A e. P <-> ( A : NN --> NN0 /\ ( `' A " NN ) e. Fin
        /\ sum_ k e. NN ( ( A ` k ) x. k ) = N ) ) $=
        ( cn0 cn cmap co wcel ccnv cima cfn cv cfv cmul csu wceq wa wf w3a nnex
        nn0ex elmap anbi1i cnveq imaeq1d eleq1d oveq1d sumeq2sdv eqeq1d anbi12d
        fveq1 elrab2 3anass 3bitr4i ) AGHIJZKZALZHMZNKZHDOZAPZVCQJZDRZESZTZTHGA
        UAZVHTABKVIVBVGUBUSVIVHGHAUDUCUEUFCOZLZHMZNKZHVCVJPZVCQJZDRZESZTVHCAURB
        VJASZVMVBVQVGVRVLVANVRVKUTHVJAUGUHUIVRVPVFEVRHVOVEDVRVNVDVCQVCVJAUNUJUK
        ULUMFUOVIVBVGUPUQ $.
    $}

    ${
      $d f k A $.  $d f k N $.  $d k P $.
      $( Lemma for ~ eulerpart (Contributed by Thierry Arnoux, 19-Aug-2018.) $)
      eulerpartlemv $p |- ( A e. P <-> ( A : NN --> NN0 /\ ( `' A " NN ) e. Fin
        /\ sum_ k e. ( `' A " NN ) ( ( A ` k ) x. k ) = N ) ) $=
        ( wcel cn cn0 cfv cmul co csu wceq w3a wa c1 simpl cc0 wn ccnv cima cfn
        wf cv eulerpartleme cdm cnvimass fdm syl5sseq sselda ffvelrnd nn0mulcld
        nnnn0d nn0cnd cdif wo simpr eldifad wi eldifbd wfn wb ffn elpreima 3syl
        notbid mpbid imnan sylibr mpd elnn0 sylib orel1 imp oveq1d nncnd mul02d
        syl2anc eqtrd cuz wss eqimssi sumss eqcomd adantr eqeq1d pm5.32i df-3an
        nnuz a1i 3bitr4i bitri ) ABGHIAUDZAUAHUBZUCGZHDUEZAJZWQKLZDMZENZOZWNWPW
        OWSDMZENZOZABCDEFUFWNWPPZXAPXFXDPXBXEXFXAXDXFWTXCEWNWTXCNWPWNXCWTWNWOHW
        SDQWNAUGWOHAHUHHIAUIUJZWNWQWOGZPZWSXIWRWQXIHIWQAWNXHRWNWOHWQXGUKZULXIWQ
        XJUNUMUOWNWQHWOUPGZPZWSSWQKLSXLWRSWQKXLWRHGZTZXMWRSNZUQZXOXLWQHGZXNXLWQ
        HWOWNXKURZUSZXLXQXMPZTZXQXNUTXLXHTYAXLWQHWOXRVAXLXHXTXLWNAHVBXHXTVCWNXK
        RZHIAVDHWQHAVEVFVGVHXQXMVIVJVKXLWRIGXPXLHIWQAYBXSULWRVLVMXNXPXOXMXOVNVO
        VSVPXLWQXLWQXSVQVRVTHQWAJZWBWNHYCWJWCWKWDWEWFWGWHWNWPXAWIWNWPXDWIWLWM
        $.
    $}

    $( Define odd partitions ` O ` , in which only odd numbers appear, and
       distinct partitions ` D ` , in which numbers appear at most once. $)
    eulerpart.o $e |- O = { g e. P | A. n e. ( `' g " NN ) -. 2 || n } $.
    eulerpart.d $e |- D = { g e. P | A. n e. NN ( g ` n ) <_ 1 } $.

    ${
      $d g n A $.  $d g P $.
      $( Lemma for ~ eulerpart : ` O ` is the set of odd partitions of ` N ` .
         (Contributed by Thierry Arnoux, 10-Aug-2017.) $)
      eulerpartlemo $p |- ( A e. O <->
        ( A e. P /\ A. n e. ( `' A " NN ) -. 2 || n ) ) $=
        ( c2 cv cdivides wbr ccnv cn cima wral wn cnveq imaeq1d raleqdv elrab2
        wceq ) MGNOPUAZGENZQZRSZTUGGAQZRSZTEACIUHAUFZUGGUJULUMUIUKRUHAUBUCUDKUE
        $.
    $}

    ${
      $d f g k n A $.  $d f N $.  $d g n P $.
      $( Lemma for ~ eulerpart : ` D ` is the set of distinct part. of ` N ` .
         (Contributed by Thierry Arnoux, 11-Aug-2017.) $)
      eulerpartlemd $p |- ( A e. D <-> ( A e. P /\ ( A " NN ) C_ { 0 , 1 } ) )
        $=
        ( wcel c1 cn wa cc0 wceq co cn0 cv cfv cle wbr wral cima cpr wss breq1d
        fveq1 ralbidv elrab2 wb c2 cfzo cmin cz 2z fzoval ax-mp fzo0to2pr 2m1e1
        cfz oveq2i 3eqtr3i eleq2i a1i ccnv cfn cmul csu eulerpartleme ffvelrnda
        wf simp1bi 1nn0 jctr w3a elfz2nn0 df-3an bitri baib syl bitr2d ralbidva
        wfun cdm ffun fdm eqimss2 3syl funimass4 syl2anc bitr4d pm5.32i ) ABMAC
        MZGUAZAUBZNUCUDZGOUEZPWPAOUFQNUGZUHZPWQEUAZUBZNUCUDZGOUEWTEACBXCARZXEWS
        GOXFXDWRNUCWQXCAUJUIUKLULWPWTXBWPWTWRXAMZGOUEZXBWPWSXGGOWPWQOMPZXGWRQNV
        CSZMZWSXGXKUMXIXAXJWRQUNUOSZQUNNUPSZVCSZXAXJUNUQMXLXNRURQUNUSUTVAXMNQVC
        VBVDVEVFVGXIWRTMZXKWSUMZWPOTWQAWPOTAVNZAVHOUFVIMOFUAZAUBXRVJSFVKHRACDFH
        JVLVOZVMXOXONTMZPZXPXOXTVPVQXKYAWSXKXOXTWSVRYAWSPWRNVSXOXTWSVTWAWBWCWCW
        DWEWPAWFZOAWGZUHZXBXHUMWPXQYBXSOTAWHWCWPXQYCORYDXSOTAWIOYCWJWKGOXAAWLWM
        WNWOWA $.
    $}

    ${
      $( $d a k l m n o x y z $. $d a F $. $d a x y J $. $)
      $( We will use the set of odd natural numbers ` J ` . $)
      eulerpart.j $e |- J = { z e. NN | -. 2 || z } $.
      eulerpart.f $e |- F = ( x e. J , y e. NN0 |-> ( ( 2 ^ y ) x. x ) ) $.
      eulerpart.h $e |- H = { r e. ( ( ~P NN0 i^i Fin ) ^m J ) |
        ( `' r " ( _V \ { (/) } ) ) e. Fin } $.

      $( ` ( bits o. ( A |`` J ) ) ` results in a function from ` J ` , the odd
         natural numbers, to the subset of ` NN0 ` . Applying ` M ` helps to
         convert this back to a relation. $)
      eulerpart.m $e |- M = ( r e. H |->
        { <. x , y >. | ( x e. J /\ y e. ( r ` x ) ) } ) $.

      ${
        $d r x y J $.  $d r H $.
        $( Lemma for ~ eulerpart (Contributed by Thierry Arnoux,
           27-Aug-2017.) $)
        eulerpartlem1 $p |- M : H -1-1-onto-> ( ~P ( J X. NN0 ) i^i Fin ) $=
          ( cn0 cxp cpw cfn cin wf1o cmap co cv wcel cfv wa copab cmpt cres wss
          cn cvv c2 cdivides wbr crab ssrab2 eqsstri nnex ssex ax-mp nn0ex eqid
          wn fpwrelmapffs wceq wb ccnv c0 csn cdif cima inss1 mapss mp2an sstri
          pwex resmpt eqtr4i f1oeq1 mpbir ) KLUDUEUFUGUHZMUIZKWKPUDUFZLUJUKZAUL
          ZLUMBULWOPULZUNUMUOABUPZUQZKURZUIZABLUDKPWRLUTUSLVAUMLVBCULVCVDVMZCUT
          VEUTTXACUTVFVGLUTVHVIVJVKWRVLUBVNMWSVOWLWTVPMPKWQUQZWSUCKWNUSWSXBVOKW
          PVQVAVRVSVTWAUGUMZPWMUGUHZLUJUKZVEZWNUBXFXEWNXCPXEVFWMVAUMXDWMUSXEWNU
          SUDVKWFWMUGWBXDWMLVAWCWDWEVGPWNKWQWGVJWHKWKMWSWIVJWJ $.
      $}

      ${
        $d f g k x y $.  $d f k A $.  $d f g x N $.  $d g P $.
        $( Lemma for ~ eulerpart .  The set of all partitions of ` N ` is
           finite.  (Contributed by Mario Carneiro, 26-Jan-2015.) $)
        eulerpartlemb $p |- P e. Fin $=
          ( cn cv c1 cfz co wcel cc0 csn cif cixp cfn wtru fzfid wa fzfi keepel
          wss snfi a1i cdif wn wceq eldifn adantl iffalse eqimss 3syl ixpfi2 wf
          trud cn0 ccnv cima cfv csu w3a eulerpartleme wfn ffn 3ad2ant1 cle wbr
          cmul wral cr simp1 ffvelrn sylan nn0re syl wi idi remulcl syl2anc cdm
          nnre cnvimass adantr syl5sseq cc sselda adantlr syldan nnnn0 nn0mulcl
          fdm nn0cn simpl cvv nn0supp suppssr oveq1d eldifi nncn mul02 cuz nnuz
          eqtrd eqimssi sumss nn0sscn caddc nn0addcl simpr 0nn0 eqeltrrd nn0ge0
          fsumcllem nnge1 expr ralrimiva breqtrd syl6eleq elfz5 eleqtrrd syld
          wb eleq1 syl5ibcom 3impia lemulge11 syl22anc fveq2 id oveq12d fsumge1
          simprr eldif eqeq1d rspccva sylan2br fsumge0 adantrr eqbrtrd 3adantl3
          pm2.61d simpl3 letrd nn0uz nn0z mpbird iftrue lemulge12 syl21anc letr
          cz syl3anc mpan2d syl5 sylibrd con3d elnn0 sylib ord imp elsnc sylibr
          wo fvex pm2.61dan vex elixp sylanbrc sylbi ssriv ssfi mp2an ) AUDAUEZ
          UFNUGUHZUIZUJNUGUHZUJUKZULZUMZUNUIZEUWQUTEUNUIUWRUOAUDUWPUWLUJUOUFNUP
          UWPUNUIUOUWKUDUIZUQUWMUWNUWOUNUJNURUJVAUSVBUOUWKUDUWLVCUIZUQUWMVDZUWP
          UWOVEZUWPUWOUTUWTUXAUOUWKUDUWLVFVGUWMUWNUWOVHZUWPUWOVIVJVKVMGEUWQGUEZ
          EUIUDVNUXDVLZUXDVOZUDVPZUNUIZUDHUEZUXDVQZUXIWFUHZHVRZNVEZVSZUXDUWQUIZ
          UXDEFHNQVTUXNUXDUDWAZUWKUXDVQZUWPUIZAUDWGUXOUXEUXHUXPUXMUDVNUXDWBWCUX
          NUXRAUDUXNUWSUQZUWMUXRUXSUWMUQUXQUWNUWPUXSUXQUWNUIZUWMUXSUXTUXQNWDWEZ
          UXSUXQUXQUWKWFUHZNUXSUXQVNUIZUXQWHUIZUXNUXEUWSUYCUXEUXHUXMWIUDVNUWKUX
          DWJWKZUXQWLWMZUXSUYDUWKWHUIZUYBWHUIZUXSUYDWNUYFWOUXSUYGWNUWSUYGUXNUWK
          WSVGZWOZUXQUWKWPWQZUXSNVNUIZNWHUIZUXNUYLUWSUXEUXHUXMUYLUXEUXHUQZUXLVN
          UIUXMUYLUYNUXGUXKHVRZUXLVNUYNUXGUDUXKHUFUYNUXDWRZUXGUDUXDUDWTUXEUYPUD
          VEUXHUDVNUXDXIXAXBZUYNUXIUXGUIZUQZUXKVNUIZUXKXCUIUYSUXJVNUIZUXIVNUIZU
          YTUYNUYRUXIUDUIZVUAUYNUXGUDUXIUYQXDZUXEVUCVUAUXHUDVNUXIUXDWJXEXFUYSVU
          CVUBVUDUXIXGWMUXJUXIXHWQZUXKXJWMUYNUXIUDUXGVCZUIZUQZUXKUJUXIWFUHZUJVU
          HUXJUJUXIWFUYNUDVNUXDUXGUXIUJUXEUXHXKUYNUXFXLUWOVCVPZUXGVEZVUJUXGUTUX
          EVUKUXHUXDUDXMXAVUJUXGVIWMXNXOVUHVUCUXIXCUIVUIUJVEVUGVUCUYNUXIUDUXGXP
          VGUXIXQUXIXRVJYAZUDUFXSVQZUTUYNUDVUMXTYBVBYCZUYNABUXGUXKVNHVNXCUTUYNY
          DVBUWKVNUIZBUEZVNUIUQUWKVUPYEUHVNUIUYNUWKVUPYFVGUXEUXHYGZVUEUJVNUIUYN
          YHVBYKYIUXLNVNUUAUUBUUCXAZNWLWMZUXSUYDUYGUJUXQWDWEZUFUWKWDWEZUXQUYBWD
          WEUYFUYIUXSUYCVUTUXSUYCWNUYEWOUXQYJWMUWSVVAUXNUWKYLVGUXQUWKUUDUUEUXSU
          YBUXLNWDUXEUXHUWSUYBUXLWDWEUXMUYNUWSUQZUYBUYOUXLWDVVBUWKUXGUIZUYBUYOW
          DWEZUYNUWSVVCVVDUYNUWSVVCUQZUQUXGUXKUYBHUWKUYNUXHVVEVUQXAUYNUYRUXKWHU
          IZVVEUYSUYTVVFVUEUXKWLZWMXEUYNUYRUJUXKWDWEZVVEUYSUYTVVHVUEUXKYJZWMXEU
          XIUWKVEZUXJUXQUXIUWKWFUXIUWKUXDUUFVVJUUGUUHZUYNUWSVVCUUJUUIYMUYNUWSVV
          CVDZVVDUYNUWSVVLUQZUQUYBUJUYOWDVVMUYNUWKVUFUIZUYBUJVEZUWKUDUXGUUKUYNU
          XKUJVEZHVUFWGVVNVVOUYNVVPHVUFVULYNVVPVVOHUWKVUFVVJUXKUYBUJVVKUULUUMWK
          UUNUYNUWSUJUYOWDWEVVLVVBUXGUXKHUYNUXHUWSVUQXAVVBUYRUQZUYTVVFUYNUYRUYT
          UWSVUEXEZVVGWMVVQUYTVVHVVRVVIWMUUOUUPUUQYMUUSUYNUYOUXLVEUWSVUNXAYOUUR
          UXEUXHUXMUWSUUTYOZUVAUXSUXQUJXSVQZUINUVIUIZUXTUYAYTUXSUXQVNVVTUYEUVBY
          PUXSUYLVWAVURNUVCWMZUXQUJNYQWQUVDXAUWMUWPUWNVEUXSUWMUWNUWOUVEVGYRUXSU
          XAUQZUXQUWOUWPVWCUXQUJVEZUXQUWOUIUXSUXAVWDUXSUXAUXQUDUIZVDVWDUXSVWEUW
          MUXSVWEUWKNWDWEZUWMVWEUFUXQWDWEZUXSVWFUXQYLUXSVWGUWKUYBWDWEZVWFUXSUYG
          UYDUJUWKWDWEZVWGVWHWNUYIUYFUXSVUOVWIUWSVUOUXNUWKXGVGUWKYJWMUYGUYDUQVW
          IVWGVWHUWKUXQUVFYMUVGUXSVWHUYBNWDWEZVWFVVSUXSUYGUYHUYMVWHVWJUQVWFWNUY
          JUXSUYHWNUYKWOUXSUYMWNVUSWOUWKUYBNUVHUVJUVKYSUVLUXSUWKVUMUIVWAUWMVWFY
          TUXSUWKUDVUMUXNUWSYGXTYPVWBUWKUFNYQWQUVMUVNUXSVWEVWDUXSUYCVWEVWDUWAUY
          EUXQUVOUVPUVQYSUVRUXQUJUWKUXDUWBUVSUVTUXAUXBUXSUXCVGYRUWCYNAUDUWPUXDG
          UWDUWEUWFUWGUWHUWQEUWIUWJ $.
      $}

      $( Define the set of finitely supported functions.  $)
      eulerpart.r $e |- R = { f | ( `' f " NN ) e. Fin } $.

      $( Define the set of functions into ` NN0 ` with odd-valued support. $)
      eulerpart.t $e |- T = { f e. ( NN0 ^m NN ) | ( `' f " NN ) C_ J } $.

      ${
        $d f A $.  $d f J $.
        $( Lemma for ~ eulerpart (Contributed by Thierry Arnoux,
           19-Sep-2017.) $)
        eulerpartlemt0 $p |- ( A e. ( T i^i R ) <-> ( A e. ( NN0 ^m NN ) /\
          ( `' A " NN ) e. Fin /\ ( `' A " NN ) C_ J ) ) $=
          ( wcel wa cn0 cn cmap co ccnv cima wss cvv cfn cin wceq cnveq imaeq1d
          w3a cv sseq1d elrab2 eleq1d elab4g anbi12i elin pm4.71i anbi1i 3anass
          elex an42 3bitr4i ) DHUIZDGUIZUJDUKULUMUNZUIZDUOZULUPZOUQZUJZDURUIZWC
          USUIZUJZUJZDHGUTUIWAWGWDVDZVRWEVSWHIVEZUOZULUPZOUQWDIDVTHWKDVAZWMWCOW
          NWLWBULWKDVBVCZVFUHVGWMUSUIWGIDGWNWMWCUSWOVHUGVIVJDHGVKWAWGWDUJZUJWAW
          FUJZWPUJWJWIWAWQWPWAWFDVTVOVLVMWAWGWDVNWAWDWFWGVPVQVQ $.
      $}

      ${
        $d t z $.  $d f g k n t A $.  $d f J $.  $d f N $.  $d g P $.
        $( Lemma for ~ eulerpart :  Odd partitions are zero for even numbers.
           (Contributed by Thierry Arnoux, 9-Sep-2017.) $)
        eulerpartlemf $p |- ( ( A e. ( T i^i R ) /\ t e. ( NN \ J ) )
          -> ( A ` t ) = 0 )
          $=
          ( cin wcel cv cn cdif wa cfv wn cc0 wceq wo cdivides wbr eldif notbid
          c2 breq2 elrab2 simplbi2 con1d imp sylbi adantl adantr ccnv simpll wb
          cima id simplbi cn0 wf wfn cmap cfn wss eulerpartlemt0 simp1bi elmapi
          co syl ffn elpreima 3syl baibd syl2an biimpar simp3bi simprbi syl2anc
          sselda pm2.65da simpl ffvelrnd elnn0 sylib orel1 sylc ) EIHUJUKZDULZU
          MPUNUKZUOZXIEUPZUMUKZUQXMXLURUSZUTZXNXKXMVEXIVAVBZXKXPXMXJXPXHXJXIUMU
          KZXIPUKZUQZUOXPXIUMPVCZXQXSXPXQXPXRXRXQXPUQZVECULZVAVBZUQYACXIUMPYBXI
          USYCXPYBXIVEVAVFVDUDVGZVHVIVJVKVLVMXKXMUOXHXIEVNUMVQZUKZYAXHXJXMVOXKY
          FXMXHXHXQYFXMVPXJXHVRXJXQXSXTVSZXHYFXQXMXHUMVTEWAZEUMWBYFXQXMUOVPXHEV
          TUMWCWIUKZYHXHYIYEWDUKZYEPWEZABCEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIWFZ
          WGEVTUMWHWJZUMVTEWKUMXIUMEWLWMWNWOWPXHYFUOXRYAXHYEPXIXHYIYJYKYLWQWTXR
          XQYAYDWRWJWSXAXKXLVTUKXOXKUMVTXIEXKXHYHXHXJXBYMWJXJXQXHYGVLXCXLXDXEXM
          XNXFXG $.
      $}

      ${
        $d f m o J $.  $d m o R $.  $d m o T $.
        $( Lemma for ~ eulerpart (Contributed by Thierry Arnoux,
           19-Sep-2017.) $)
        eulerpartlemt $p |- ( ( NN0 ^m J ) i^i R ) =
          ran ( m e. ( T i^i R ) |-> ( m |` J ) ) $=
          ( vo cv cn0 cmap co wcel cab cres wceq cin wrex cmpt crn cdif cc0 csn
          wa cn cxp cun ccnv cima cfn wss wf c0 elmapi adantr 0nn0 elexi fconst
          w3a a1i disjdif fun syl21anc c2 cdivides wn crab ssrab2 eqsstri undif
          wbr mpbi snssi ax-mp ssequn2 feq23i sylib cvv nn0ex nnex elmapg mp2an
          wb sylibr cnvun imaeq1i imaundir eqtri vex cnveq imaeq1d eleq1d elab2
          biimpi adantl cdm cnvxp dmeqi wne 2nn nnzi iddvds breq2 notbid elrab2
          cz simprbi mt2 eldif mpbir2an mp2b mpbir incom eqeltri eulerpartlemt0
          syl2anc syl wfn eqeltrd ne0i dmxp ineq1i 0nnn disjsn eqeq1i 0fin unfi
          imadisj syl5eqel cnvimass fdm syl5sseq 0ss syl5eqss 3jca resundir ffn
          unssd fnresdm fnconstg fnresdisj uneq12d syl6eq syl5req reseq1 eqeq2d
          un0 rspcev simpr simpl simp1d fssres rabex wfun ffun respreima simp2d
          3syl infi resex jca rexlimiva impbii abbii df-in eqid rnmpt 3eqtr4i )
          UIUJZUKOULUMZUNZUWJFUNZVEZUIUOUWJKUJZOUPZUQZKGFURZUSZUIUOUWKFURKUWRUW
          PUTZVAUWNUWSUIUWNUWSUWNUWJVFOVBZVCVDZVGZVHZUWRUNZUWJUXDOUPZUQZUWSUWNU
          XDUKVFULUMZUNZUXDVIZVFVJZVKUNZUXKOVLZVTUXEUWNUXIUXLUXMUWNVFUKUXDVMZUX
          IUWNOUXAVHZUKUXBVHZUXDVMZUXNUWNOUKUWJVMZUXAUXBUXCVMZOUXAURZVNUQZUXQUW
          LUXRUWMUWJUKOVOVPZUXSUWNUXAVCVCUKVQVRVSWAUYAUWNOVFWBZWAOUXAUKUXBUWJUX
          CWCWDUXOUXPVFUKUXDOVFVLZUXOVFUQOWECUJZWFWLZWGZCVFWHZVFUCUYGCVFWIWJZOV
          FWKWMUXBUKVLZUXPUKUQVCUKUNZUYJVQVCUKWNWOUXBUKWPWMWQWRUKWSUNZVFWSUNZUX
          IUXNXDWTXAUKVFUXDWSWSXBXCXEUWNUXKUWJVIZVFVJZUXCVIZVFVJZVHZVKUXKUYNUYP
          VHZVFVJUYRUXJUYSVFUWJUXCXFXGUYNUYPVFXHXIZUWNUYOVKUNZUYQVKUNZUYRVKUNUW
          MVUAUWLUWMVUAHUJZVIZVFVJZVKUNZVUAHUWJFUIXJVUCUWJUQZVUEUYOVKVUGVUDUYNV
          FVUCUWJXKXLXMUGXNXOXPVUBUWNUYQVNVKUYQVNUQUYPXQZVFURZVNUQVUIUXBVFURZVN
          VUHUXBVFVUHUXBUXAVGZXQZUXBUYPVUKUXAUXBXRXSWEUXAUNZUXAVNXTVULUXBUQVUMW
          EVFUNZWEOUNZWGYAVUOWEWEWFWLZWEYGUNVUPWEYAYBWEYCWOVUOVUNVUPWGZUYGVUQCW
          EVFOUYEWEUQUYFVUPUYEWEWEWFYDYEUCYFYHYIWEVFOYJYKUXAWEUUAUXBUXAUUBYLXIU
          UCVFUXBURZVNUQZVUJVNUQVUSVCVFUNWGUUDVFVCUUEYMVURVUJVNVFUXBYNUUFWMXIUY
          PVFUUIYMZUUGYOWAUYOUYQUUHYQUUJUWNUXKUYROUYTUWNUYOUYQOUWNUWJXQZUYOOUWJ
          VFUUKUWNUXRVVAOUQUYBOUKUWJUULYRUUMUYQOVLUWNUYQVNOVUTOUUNWJWAUUSUUOUUP
          ABCUXDDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHYPXEUWNUXFUWJOUPZUXCOUPZVHZUWJU
          WJUXCOUUQUWNVVDUWJVNVHZUWJUWNUWJOYSZVVDVVEUQUWNUXRVVFUYBOUKUWJUURYRVV
          FVVBUWJVVCVNOUWJUUTVVCVNUQZVVFUXAOURZVNUQZVVGVVHUXTVNUXAOYNUYCXIUYKUX
          CUXAYSVVIVVGXDVQUXAVCUKUVAUXAOUXCUVBYLWMWAUVCYRUWJUVHUVDUVEUWQUXGKUXD
          UWRUWOUXDUQUWPUXFUWJUWOUXDOUVFUVGUVIYQUWQUWNKUWRUWOUWRUNZUWQVEZUWLUWM
          VVKUWJUWPUWKVVJUWQUVJZVVKOUKUWPVMZUWPUWKUNZVVKVFUKUWOVMZUYDVVMVVKUWOU
          XHUNZVVOVVKVVPUWOVIVFVJZVKUNZVVQOVLZVVKVVJVVPVVRVVSVTVVJUWQUVKABCUWOD
          EFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHYPWRZUVLUYLUYMVVPVVOXDWTXAUKVFUWOWSWSX
          BXCWRZUYDVVKUYIWAVFUKOUWOUVMYQUYLOWSUNVVNVVMXDWTOUYHWSUCUYGCVFXAUVNYO
          UKOUWPWSWSXBXCXEYTVVKUWJUWPFVVLVVKUWPVIZVFVJZVKUNZUWPFUNVVKVWCVVQOURZ
          VKVVKVVOUWOUVOVWCVWEUQVWAVFUKUWOUVPVFOUWOUVQUVSVVKVVRVWEVKUNVVKVVPVVR
          VVSVVTUVRVVQOUVTYRYTVUFVWDHUWPFUWOOKXJUWAVUCUWPUQZVUEVWCVKVWFVUDVWBVF
          VUCUWPXKXLXMUGXNXEYTUWBUWCUWDUWEUIUWKFUWFKUIUWRUWPUWTUWTUWGUWHUWI $.
      $}

      $( Define the function ` G ` which we will prove to be a bijection
         between ` O ` and ` D ` . $)
      eulerpart.g $e |- G = ( o e. ( T i^i R ) |->
                ( ( _Ind ` NN ) ` ( F " ( M ` ( bits o. ( o |` J ) ) ) ) ) ) $.

      ${
        $d a f g k l m n o x y z $.  $d f k A $.  $d a b o F $.
        $d a b f m o r x y J $.  $d a b o r M $.  $d f g x N $.  $d g P $.
        $d f m o R $.  $d o r H $.  $d f m o T $.
        $( Lemma for ~ eulerpart :  The ` G ` function is a bijection.
           (Contributed by Thierry Arnoux, 27-Aug-2017.) $)
        eulerpartgbij $p |-
                   G : ( T i^i R ) -1-1-onto-> ( ( { 0 , 1 } ^m NN ) i^i R ) $=
          ( va vm vb cin cc0 c1 cpr cn cmap co wf1o cind cfv cres cbits cv ccom
          cfn cima cmpt cpw ccnv csn wcel crab cvv nnex indf1ofs ax-mp wceq cab
          wb incom ineq2i dfrab2 3eqtr4i crn wss wf elmapi syl frn wa c0 cun wn
          wfun mpbir mpbi eqcom 3eqtri syl2anc eleq1d rabbiia eqtr2i f1oeq3 cn0
          bitri wtru cdif a1i c2 nn0ex 0nn0 dfn2 eqtr4i eqid inss1 sseli f1oeq1
          mp1i trud eqtri mp2an wrex wfn vex resex f1oco f1of mp2b eqidd fmptco
          cz ffvelrnda eqeltrrd f1ofn dffn5 fveq2 fvmpt2 ffun fimacnvinrn2 indi
          df-pr 0nnn disjsn 1nn 1ex snss dfss eqeq1i uneq12i un0 imaeq2i syl6eq
          uncom cxp oddpwdc f1opwfi eulerpartlem1 bitsf1o cdivides eqeltri pwex
          wbr rabex inex1 fvres 0bits 3eqtr4ri ffs2 fcobijfs 3syl eqcomi mpbird
          cores mpteq2ia wf1 w3a ssrab2 eqsstri 3pm3.2i imaeq12d sseq1d cbvrabv
          cnveq resf1o f1of1 f1ores fnmpti fvelimab eulerpartlemt eleq2i reseq1
          elrnmpti fvmpt eqeq1d bitrd rexbiia 3bitr4ri resmpt wral fmpt biimpri
          eqriv r19.21bi coeq2 eqcomd f1oeq123d mpbiri bitsf zex fex coex simpr
          fvmpt2d fvex imaeq2 cexp cmul mpt2exg imaexg indf1o reseq1i resmpt3 )
          GFUNZUOUPUQZURUSUTZFUNZNVAZUYFUYIURVBVCZVHVDZLUYFMVELVFZPVDZVGZQVCZVI
          ZVJZVGZVAZURVKZVHUNZUYIUYLVAZUYFVUBUYRVAZUYTVUBHVFZVLZUPVMZVIZVHVNZHU
          YHVOZUYLVAZVUCURVPVNZVUKVQHURVPVRVSVUJUYIVTVUKVUCWBUYIVUFURVIZVHVNZHU
          YHVOZVUJUYHVUNHWAZUNVUPUYHUNUYIVUOUYHVUPWCFVUPUYHUHWDVUNHUYHWEWFVUNVU
          IHUYHVUEUYHVNZVUMVUHVHVUQVUEWQZVUEWGZUYGWHZVUMVUHVTVUQURUYGVUEWIZVURV
          UEUYGURWJZURUYGVUEUUAWKVUQVVAVUTVVBURUYGVUEWLWKVURVUTWMVUMVUFURUYGUNZ
          VIVUHURUYGVUEUUBVVCVUGVUFVVCWNVUGWOZVUGWNWOVUGVVCURUOVMZVUGWOZUNURVVE
          UNZURVUGUNZWOVVDUYGVVFURUOUPUUDWDURVVEVUGUUCVVGWNVVHVUGVVGWNVTUOURVNW
          PUUEURUOUUFWRVUGVUGURUNZVTZVVHVUGVTZVUGURWHZVVJUPURVNVVLUUGUPURUUHUUI
          WSVUGURUUJWSVVJVVIVUGVTVVKVUGVVIWTVVIVVHVUGVUGURWCUUKXHWSUULXAWNVUGUU
          PVUGUUMXAUUNUUOXBXCXDXEVUJUYIVUBUYLXFVSWSUYFVUBUKPXGUUQZVKVHUNZMUKVFZ
          VIZVJZLUYFUYPVJZVGZVAZVUDVVNVUBVVQVAZUYFVVNVVRVAZVVTVVMURMVAVWAABCMPU
          DUEUURVVMURMUKUUSVSUYFVVNQLUYFUYOVJZVGZVAZVWBOVVNQVAZUYFOVWCVAZVWEABC
          DEHIJKMOPQRSTUAUBUCUDUEUFUGUUTZVWGXIVWGUYFTVFZVLVPWNVMXJVIVHVNTXGVKZV
          HUNZPUSUTVOZHXGPUSUTZFUNZVEVUEVGZVJZLUYFUYNVJZVGZVAZVWNVWLVWPVAZUYFVW
          NVWQVAZVWSVWTXIVWTVWNVWLHVWNVEXGVDZVUEVGZVJZVAZXIWNPXGVWKVPHHTVXBUOVP
          VPVWNVWLXGVWKVXBVAXIUVAXKPVPVNZXIPXLCVFUVBUVEWPZCURVOZVPUDVXGCURVQUVF
          UVCZXKXGVPVNZXIXMXKVWKVPVNXIVWJVHXGXMUVDUVGXKUOXGVNZXIXNXKUOVXBVCZUOV
          EVCZWNVXKVXLVXMVTXNUOXGVEUVHVSUVIXEVWNVUNHVWMVOZVUFVPVVEXJVIZVHVNZHVW
          MVOVUPVWMUNVWMVUPUNVXNVWNVUPVWMWCVUNHVWMWEFVUPVWMUHWDUVJVXPVUNHVWMVUE
          VWMVNZVXOVUMVHVXQPXGVUEWIZVXOVUMVTVUEXGPWJZPXGURVUEUOXOUVKWKXCXDXPVWL
          XQUVLVWPVXDVTVWTVXEWBXIVXDVWPHVWNVXCVWOVUEVWNVNZVXQVXCVWOVTZVWNVWMVUE
          VWMFXRXSVXQVXRVUSXGWHVYAVXSPXGVUEWLVEVUEXGUVPUVMWKUVQUVNVWNVWLVWPVXDX
          TYAUVOYBUYFLGUYNVJZUYFVIZVYBUYFVDZVAZVXAGVWMVYBUVRZUYFGWHZVYEGVWMVYBV
          AZVYFVULVXJPURWHZUVSVXKVYHVULVXJVYIVQXMPVXHURUDVXGCURUVTUWAUWBXNURXGP
          LVYBVPVPGUOGVUMPWHZHXGURUSUTZVOUYMVLZXGVVEXJZVIZPWHZLVYKVOUIVYJVYOHLV
          YKVUEUYMVTZVUMVYNPVYPVUFVYLURVYMVUEUYMUWFURVYMVTVYPXOXKUWCUWDUWEYCVYB
          XQZUWGYDGVWMVYBUWHVSGFXRZGVWMUYFVYBUWIYDVYEUYFVWNVYDVAZVXAVYCVWNVTVYE
          VYSWBHVYCVWNVUEVYCVNZULVFZVYBVCZVUEVTZULUYFYEZVXTVYBGYFVYGVYTWUDWBLGU
          YNVYBUYMPLYGYHZVYQUWJVYRULGUYFVUEVYBUWKYDVUEULUYFWUAPVDZVJZWGZVNVUEWU
          FVTZULUYFYEVXTWUDULUYFWUFVUEWUGWUGXQWUAPULYGYHZUWOVWNWUHVUEABCDEFGHIJ
          ULKMOPQRSTUAUBUCUDUEUFUGUHUIUWLUWMWUCWUIULUYFWUAUYFVNZWUCWUFVUEVTZWUI
          WUKWUAGVNZWUCWULWBUYFGWUAVYRXSWUMWUBWUFVUELWUAUYNWUFGVYBUYMWUAPUWNVYQ
          WUJUWPUWQWKWULWUIWBWUKWUFVUEWTXKUWRUWSUWTXHUXEVYCVWNUYFVYDXFVSVYDVWQV
          TZVYSVXAWBVYGWUNVYRLGUYFUYNUXAVSUYFVWNVYDVWQXTVSXHWSZUYFVWNVWLVWPVWQY
          IYDXIUYFUYFOVWLVWCVWRXIVWRVWCXILHUYFVWNUYNVWOUYOVWQVWPXIUYNVWNVNZLUYF
          WUPLUYFUXBZXIVXAUYFVWNVWQWIZWUQWUOUYFVWNVWQYJWUQWURLUYFVWNUYNVWQVWQXQ
          UXCUXDYKXKUXFXIVWQYLXIVWPYLVUEUYNVEUXGYMUXHXIUYFYLOVWLVTXIUFXKUXIUXJY
          BZUYFOVVNQVWCYIYDVWDVVRVTZVWEVWBWBWUTXILTUYFOUYOVWIQVCZUYPVWCQXIUYMUY
          FVNZWMZUYMVWCVCUYOOXILUYFUYOVWCVPXIVWCYLZUYOVPVNWVCVEUYNYNVWJVEWIYNVP
          VNVEVPVNUXKUXLYNVWJVPVEUXMYDWUEUXNXKUXPXIUYFOUYMVWCVWGUYFOVWCWIXIWUSU
          YFOVWCYJYAYOYPWVDQTOWVAVJVTZXIQOYFZWVEVWFWVFVWHOVVNQYQVSTOQYRWSXKVWIU
          YOQYSYMYBUYFVVNVWDVVRXTVSWSZUYFVVNVUBVVQVVRYIYDVVSUYRVTZVVTVUDWBWVHXI
          LUKUYFVVNUYPVVPUYQVVRVVQWVCUYMVVRVCZUYPVVNWVCWVBUYPVPVNZWVIUYPVTXIWVB
          UXOZWVJWVCUYOQUXQXKLUYFUYPVPVVRVVRXQYTXBXIUYFVVNUYMVVRVWBUYFVVNVVRWIX
          IWVGUYFVVNVVRYJYAYOYPXIVVRYLXIVVQYLVVOUYPMUXRYMYBUYFVUBVVSUYRXTVSWSZU
          YFVUBUYIUYLUYRYIYDNUYSVTUYJUYTWBNLUYFUYQUYKVCZVJZUYSUJUYSWVNVTXILUMUY
          FVUBUYQUMVFZUYKVCZWVMUYRUYLWVCUYMUYRVCZUYQVUBWVCWVBUYQVPVNZWVQUYQVTWV
          KWVRWVCMVPVNZWVRVXFVXJWVSVXIXMABPXGXLBVFUXSUTAVFUXTUTVPVPMUEUYAYDMUYP
          VPUYBVSXKLUYFUYQVPUYRUYRXQYTXBXIUYFVUBUYMUYRVUDUYFVUBUYRWIXIWVLUYFVUB
          UYRYJYAYOYPXIUYRYLUYLUMVUBWVPVJZVTXIUYLUMVUAWVPVJZVHVDWVTUYKWWAVHUYKV
          UAYFZUYKWWAVTVULVUAUYHUYKVAWWBVQURVPUYCVUAUYHUYKYQYKUMVUAUYKYRWSUYDUM
          VUAVHWVPUYEYCXKWVOUYQUYKYSYMYBXPUYFUYINUYSXTVSWR $.
      $}

      ${
        $d o A $.  $d o F $.  $d o J $.  $d o M $.  $d o R $.  $d o T $.
        $( Lemma for ~ eulerpart : value of the function ` G ` .  (Contributed
           by Thierry Arnoux, 13-Nov-2017.) $)
        eulerpartlemgv $p |- ( A e. ( T i^i R ) -> ( G ` A ) =
          ( ( _Ind ` NN ) ` ( F " ( M ` ( bits o. ( A |` J ) ) ) ) ) ) $=
          ( cbits cres ccom cfv cima cind cin wceq reseq1 coeq2d fveq2d imaeq2d
          cv cn fvex fvmpt ) MDNULMVDZQUMZUNZRUOZUPZVEUQUOZUONULDQUMZUNZRUOZUPZ
          VMUOHGUROVHDUSZVLVQVMVRVKVPNVRVJVORVRVIVNULVHDQUTVAVBVCVBUKVQVMVFVG
          $.
      $}

      ${
        $d f h k n z $.  $d f n J $.  $d f N $.  $d g h n P $.  $d h O $.
        $d h R $.  $d h T $.
        $( Lemma for ~ eulerpart (Contributed by Thierry Arnoux,
           13-Nov-2017.) $)
        eulerpartlemr $p |- O = ( ( T i^i R ) i^i P ) $=
          ( vh cin cv wcel wa elin anbi1i c2 cdivides wn ccnv cn cima wral wceq
          wbr cnveq imaeq1d raleqdv elrab2 cn0 cmap wss cfn cfv cmul csu eleq1d
          co fveq1 oveq1d ralrimivw sumeq2d eqeq1d anbi12d simplbi cdm cnvimass
          wf nn0ex nnex elmap fdm sylbi syl5sseq syl sselda ralrimiva biantrurd
          simpld biantrud 3bitrd dfss3 breq2 notbid ralbii r19.26 3bitri anbi2i
          simprbi syl6bbr sseq1d vex elab2 anbi12i pm5.32i ancom 3bitr4ri eqriv
          ) UKSGFULZEULZUKUMZXTUNZYBEUNZUOYBGUNZYBFUNZUOZYDUOZYBYAUNYBSUNZYCYGY
          DYBGFUPUQYBXTEUPYIYDURKUMZUSVFZUTZKYBVAZVBVCZVDZUOYDYGUOYHYLKIUMZVAZV
          BVCZVDYOIYBESYPYBVEZYLKYRYNYSYQYMVBYPYBVGVHVIUBVJYDYOYGYDYOYBVKVBVLVS
          ZUNZYNPVMZUOZYNVNUNZUOZYGYDYOUUAYJVBUNZKYNVDZYOUOZUOZUUDUOZUUEYDYOUUH
          UUIUUJYDUUGYOYDUUFKYNYDYNVBYJYDUUAYNVBVMYDUUAUUDVBJUMZYBVOZUUKVPVSZJV
          QZRVEZUOZHUMZVAZVBVCZVNUNZVBUUKUUQVOZUUKVPVSZJVQZRVEZUOUUPHYBYTEUUQYB
          VEZUUTUUDUVDUUOUVEUUSYNVNUVEUURYMVBUUQYBVGVHZVRZUVEUVCUUNRUVEVBUVBUUM
          JUVEUVBUUMVEJVBUVEUVAUULUUKVPUUKUUQYBVTWAWBWCWDWEUAVJZWFZUUAYBWGZYNVB
          YBVBWHUUAVBVKYBWIUVJVBVEVKVBYBWJWKWLVBVKYBWMWNWOWPWQWRWSYDUUAUUHUVIWS
          YDUUDUUIYDUUDUUOYDUUAUUPUVHXJWTXAXBUUCUUIUUDUUBUUHUUAUUBYJPUNZKYNVDUU
          FYLUOZKYNVDUUHKYNPXCUVKUVLKYNURCUMZUSVFZUTYLCYJVBPUVMYJVEUVNYKUVMYJUR
          USXDXEUDVJXFUUFYLKYNXGXHXIUQXKYEUUCYFUUDUUSPVMUUBHYBYTGUVEUUSYNPUVFXL
          UIVJUUTUUDHYBFUKXMUVGUHXNXOXKXPYDYGXQXHXRXS $.
      $}

      ${
        $d f k n t x y z $.  $d f o r w A $.  $d w B $.  $d o w F $.  $d r H $.
        $d f n o r w x y J $.  $d o w M $.  $d f N $.  $d g n P $.  $d o R $.
        $d o T $.
        $( Lemma for ~ eulerpart (Contributed by Thierry Arnoux,
           30-Aug-2018.) $)
        eulerpartlemmf $p |- ( A e. ( T i^i R ) -> ( bits o. ( A |` J ) ) e. H
          ) $=
          ( cin wcel cbits cres ccom cn0 cpw cfn cmap co ccnv cvv csn cdif cima
          c0 wa wf wf1o bitsf1o f1of ax-mp wss w3a eulerpartlemt0 biimpi simp1d
          cn nn0ex nnex elmap sylib c2 cv cdivides wbr wn ssrab2 eqsstri fssres
          crab sylancl fco2 sylancr pwex inex1 ssexi sylibr simp2d wceq wb dfn2
          cc0 ffs2 eleq1 3syl mpbird resss cnvss imass1 mp2b ssfi mpan2 imaeq1i
          syl cnvco imaco eqtri wfun funres ssv ssdif cz bitsf difpreima bitsf1
          ffun wf1 snssi f1imacnv mp2an cfv wfn ffn fnsnfv 0bits sneqi eqtr3i
          0z imaeq2i difeq2i 3sstr4i sspreima syl5eqss syl2anc jca cnveq eleq1d
          imaeq1d elrab2 ) DHGULUMZUNDQUOZUPZUQURZUSULZQUTVAZUMZUUNVBZVCVGVDZVE
          ZVFZUSUMZVHUUNPUMUULUURUVCUULQUUPUUNVIZUURUULUQUUPUNUQUOZVIZQUQUUMVIZ
          UVDUQUUPUVEVJUVFVKUQUUPUVEVLVMUULVSUQDVIZQVSVNUVGUULDUQVSUTVAUMZUVHUU
          LUVIDVBZVSVFZUSUMZUVKQVNZUULUVIUVLUVMVOABCDEFGHIJKLNPQRSTUAUBUCUDUEUF
          UGUHUIUJVPVQZVRUQVSDVTWAWBWCZQWDCWEWFWGWHZCVSWLVSUEUVPCVSWIWJZVSUQQDW
          KWMQUQUUPUNUUMWNWOUUPQUUNUUOUSUQVTWPWQQVSWAUVQWRWBWSUULUUMVBZVCXDVDZV
          EZVFZUSUMZUVBUWAVNUVCUULUVJUVTVFZUSUMZUWBUULUWDUVLUULUVIUVLUVMUVNWTUU
          LUVHUWCUVKXAUWDUVLXBUVOVSUQVSDXDXCXEUWCUVKUSXFXGXHUWDUWAUWCVNZUWBUUMD
          VNUVRUVJVNUWEDQXIUUMDXJUVRUVJUVTXKXLUWCUWAXMXNXPUULUVBUVRUNVBZUVAVFZV
          FZUWAUVBUVRUWFUPZUVAVFUWHUUSUWIUVAUNUUMXQXOUVRUWFUVAXRXSUULUUMXTZUWGU
          VTVNUWHUWAVNUULUVHDXTUWJUVOVSUQDYHQDYAXGUWFVCVFZUWFUUTVFZVEZVCUWLVEZU
          WGUVTUWKVCVNUWMUWNVNUWKYBUWKVCUWLYCVMUNXTZUWGUWMXAYDUUOUNVIZUWOYEYDUU
          OUNYHVMVCUUTUNYFVMUVSUWLVCUWFUNUVSVFZVFZUVSUWLYDUUOUNYIUVSYDVNZUWRUVS
          XAYGXDYDUMZUWSYTXDYDYJVMYDUUOUVSUNYKYLUWQUUTUWFXDUNYMZVDZUWQUUTUNYDYN
          ZUWTUXBUWQXAUWPUXCYEYDUUOUNYOVMYTYDXDUNYPYLUXAVGYQYRYSUUAYSUUBUUCUWGU
          VTUUMUUDWMUUEUWAUVBXMUUFUUGUAWEZVBZUVAVFZUSUMUVCUAUUNUUQPUXDUUNXAZUXF
          UVBUSUXGUXEUUSUVAUXDUUNUUHUUJUUIUGUUKWS $.

        $d t n w x y A $.  $d n t x y B $.  $d n t x y F $.  $d t w x y J $.
        $d r H $.  $d n t x y M $.  $d n r t w x y R $.  $d n r t w x y T $.
        $( Lemma for ~ eulerpart : value of the function ` G ` evaluated
           (Contributed by Thierry Arnoux, 10-Aug-2018.) $)
        eulerpartlemgvv $p |- ( ( A e. ( T i^i R ) /\ B e. NN )
          -> ( ( G ` A ) ` B ) = if ( E. t e. NN E. n e. ( bits ` ( A ` t ) )
          ( ( 2 ^ n ) x. t ) = B , 1 , 0 ) ) $=
          ( vw cin wcel cn wa cfv cbits cima c1 cc0 cif c2 cv cexp co cmul wceq
          wrex adantr cvv wss nnex a1i cn0 wf1o wf f1of mp2b simpr wfn wb ax-mp
          ffn cfn syl nfv nfre1 nfan cop eleq2d opabbidv adantl cdivides wbr wn
          copab simpl eleq1d fveq2d syl6eq wfun sylib 3syl biimpar fvco syl2anc
          wex fvres eqtrd syl6bb df-rex exbii bitrd biimpa adantlr wi fveq2 imp
          ex reximdva eqeq2 rexbidv mpbid r19.29af simplr oveq2 eqeq12d imbi12d
          vex oveq1d chvar eqeq1d c0 wral breq2 notbid elrab2 cres ccom imassrn
          eulerpartlemgv fveq1d crn cxp oddpwdc frn sstri indfval syl3anc inss1
          cind cpw eulerpartlemmf eulerpartlem1 ffvelrni sseldi elpwid fvelimab
          sylancr cmpt fveq1 anbi2d crab ssrab2 eqsstri ssexi cab abid2 eqeltri
          fvex opabex3 fvmptd eleq12d anbi12d cbvopabv cmap ccnv eulerpartlemt0
          cdm w3a biimpi simp1d nn0ex elmap ffun funres fssres sylancl pm5.32da
          fdm elopab ancom anass bitri 2exbii anbi2i 19.42v bitr4i bitsss sseli
          3bitr4i anim2i ad2antlr opelxp c2nd c1st oddpwdcv op2nd op1st oveq12i
          oveq2i sylbir eqtr2d anassrs ssrexv adantllr simp-5l simpllr eleqtrrd
          mpd opabid syl12anc ad4antr sseldd opeq1 opeq2 sylan2 rspcev sylan9bb
          cbvrexdva2 cbvrexv n0i 0bits con3i ffvelrn sylan elnn0 orcomd orcanai
          mpdan simp3bi sselda simprbi ralrimiva elpreima imbi1d impexp cbvralv
          ralbidv2 sylibr r19.21bi syldan sylanbrc adantlrr simprr jca reximdv2
          wo r19.29_2a impbida ifbid 3eqtrd ) EJIUOUPZFUQUPZURZFEQUSZUSZFPUTESU
          UAZUUBZTUSZVAZUQUUNUSUSZUSZFVVNUPZVBVCVDZVENVFZVGVHZDVFZVIVHZFVJZNVWA
          EUSZUTUSZVKZDUQVKZVBVCVDVVFVVJVVPVJVVGVVFFVVIVVOABCEGHIJKLMNOPQRSTUAU
          BUCUDUEUFUGUHUIUJUKULUMUUDUUEVLVVHUQVMUPZVVNUQVNZVVGVVPVVRVJVWHVVHVOV
          PVWIVVHVVNPUUFZUQPVVMUUCSVQUUGZUQPVRZVWKUQPVSZVWJUQVNABCPSUGUHUUHZVWK
          UQPVTZVWKUQPUUIWAUUJVPVVFVVGWBVVNUQVMFUUKUULVVHVVQVWGVBVCVVHVVQUNVFZP
          USZFVJZUNVVMVKZVWGVVHPVWKWCZVVMVWKVNZVVQVWSWDVWLVWMVWTVWNVWOVWKUQPWFW
          AVVHVVMVWKVVFVVMVWKUUOZUPVVGVVFVXBWGUOZVXBVVMVXBWGUUMVVFVVLRUPVVMVXCU
          PABCEGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUUPZRVXCVVLTRVXCTVRRVXCT
          VSABCGHKLMNPRSTUAUBUCUDUEUFUGUHUIUJUUQRVXCTVTWEUURWHUUSVLUUTZUNVWKVVM
          FPUVAUVBVVHVWSVWGVVHVWSURVWRVWGUNVVMVVHVWSUNVVHUNWIVWRUNVVMWJWKVVHVWP
          VVMUPZVWRVWGVWSVVHVXFURZVWRURZVWBVWQVJZNVWEVKZDUQVKZVWGVXGVXKVWRVXGVX
          JDSVKZVXKVXGVWPVWAVVSWLZVJZNVWEVKZDSVKZVXLVVFVXFVXPVVGVVFVXFVXPVVFVXF
          VWPVWASUPZVVSVWAVVLUSZUPZURZDNWSZUPZVXPVVFVVMVYAVWPVVFVVMAVFZSUPZBVFZ
          VYCVVLUSZUPZURZABWSZVYAVVFUCVVLVYDVYEVYCUCVFZUSZUPZURZABWSZVYIRTVMTUC
          RVYNUVCVJVVFUJVPVYJVVLVJZVYNVYIVJVVFVYOVYMVYHABVYOVYLVYGVYDVYOVYKVYFV
          YEVYCVYJVVLUVDWMUVEWNWOVXDVYIVMUPVVFVYGABSSUQVOSVECVFZWPWQZWRZCUQUVFU
          QUGVYRCUQUVGUVHZUVIVYGBUVJZVMUPVYDVYTVYFVMBVYFUVKVYCVVLUVMUVLVPUVNVPU
          VOZVYHVXTABDNVYCVWAVJZVYEVVSVJZURZVYDVXQVYGVXSWUDVYCVWASWUBWUCWTZXAWU
          DVYEVVSVYFVXRWUBWUCWBWUDVYCVWAVVLWUEXBUVPUVQUVRXCWMVVFVYBVXNVXQVVSVWE
          UPZURZURZNXJDXJZVXPVVFVYBVWPWUGDNWSZUPWUIVVFVYAWUJVWPVVFVXTWUGDNVVFVX
          QVXSWUFVVFVXQURZVXRVWEVVSWUKVXRVWAVVKUSZUTUSZVWEWUKVVKXDZVWAVVKUWBZUP
          ZVXRWUMVJVVFWUNVXQVVFUQVQEVSZEXDWUNVVFEVQUQUVSVHUPZWUQVVFWUREUVTUQVAZ
          WGUPZWUSSVNZVVFWURWUTWVAUWCABCEGHIJKLMNPRSTUAUBUCUDUEUFUGUHUIUJUKULUW
          AZUWDUWEVQUQEUWFVOUWGXEZUQVQEUWHSEUWIXFZVLVVFWUPVXQVVFSVQVVKVSZWUPVXQ
          WDVVFWUQSUQVNZWVEWVCVYSUQVQSEUWJUWKZWVEWUOSVWASVQVVKUWMZWMWHXGVWAUTVV
          KXHXIVXQWUMVWEVJVVFVXQWULVWDUTVWASEXKXBWOXLWMUWLWNWMWUGDNVWPUWNXMWUIV
          XQWUFVXNURZURZNXJZDXJZVXPWUHWVJDNWUHWUGVXNURWVJVXNWUGUWOVXQWUFVXNUWPU
          WQUWRVXQVXOURZDXJVXQWVINXJZURZDXJVXPWVLWVMWVODVXOWVNVXQVXNNVWEXNUWSXO
          VXODSXNWVKWVODVXQWVINUWTXOUXDUXAXMXPXQXRVXGVXOVXJDSVXGVXQURVXNVXINVWE
          VXGVXQWUFVXNVXIXSVXGWUGURZVXNVXIWVPVXNURZVWQVXMPUSZVWBWVPVXNVWQWVRVJZ
          VXNWVSXSWVPVWPVXMPXTVPYAWVQVXQVVSVQUPZURZWVRVWBVJZWUGWWAVXGVXNWUFWVTV
          XQVWEVQVVSVWDUXBUXCUXEUXFWWAVXMVWKUPZWWBVWAVVSSVQUXGWWCWVRVEVXMUXHUSZ
          VGVHZVXMUXIUSZVIVHVWBABCPSVXMUGUHUXJWWEVVTWWFVWAVIWWDVVSVEVGVWAVVSDYL
          ZNYLZUXKUXNVWAVVSWWGWWHUXLUXMXCZUXOWHUXPYBUXQYCYCUYCWVFVXLVXKXSVYSVXJ
          DSUQUXRWEWHVLVXHVXJVWFDUQVWRVXJVWFWDVXGVWRVXIVWCNVWEVWQFVWBYDYEWOYEYF
          UXSVVHVWSWBYGVVHVWGURZVEVYEVGVHZVYCVIVHZFVJZVWSABSVYCEUSZUTUSZWWJVYDU
          RZVYEWWOUPZURZWWMURZVYCVYEWLZVVMUPZWWTPUSZFVJZVWSWWSVVFVYDVYGWXAVVFVV
          GVWGVYDWWQWWMUXTZWWJVYDWWQWWMUYAZWWSVYEWWOVYFWWPWWQWWMYHWWSVVFVYDVYFW
          WOVJWXDWXEVVFVYDURZVYFVYCVVKUSZUTUSZWWOWXFWUNVYCWUOUPZVYFWXHVJVVFWUNV
          YDWVDVLVVFWXIVYDVVFWVEWXIVYDWDWVGWVEWUOSVYCWVHWMWHXGVYCUTVVKXHXIVYDWX
          HWWOVJVVFVYDWXGWWNUTVYCSEXKXBWOXLXIUYBVVFWXAVYHVVFWXAWWTVYIUPVYHVVFVV
          MVYIWWTWUAWMVYHABUYDXMXGUYEZWWSWWMWWTVWKUPZWXCWWRWWMWBWWSVVMVWKWWTVVH
          VXAVWGVYDWWQWWMVXEUYFWXJUYGWXKWWMWXBWWLVJZWXCVWAVYEWLZVWKUPZWXMPUSZWW
          KVWAVIVHZVJZXSZWXKWXLXSZDAWXSDWIVWAVYCVJZWXNWXKWXQWXLWXTWXMWWTVWKVWAV
          YCVYEUYHZXAWXTWXOWXBWXPWWLWXTWXMWWTPWYAXBVWAVYCWWKVIYIYJYKWWCWWBXSWXR
          NBWXRNWIVVSVYEVJZWWCWXNWWBWXQWYBVXMWXMVWKVVSVYEVWAUYIZXAWYBWVRWXOVWBW
          XPWYBVXMWXMPWYCXBWYBVVTWWKVWAVIVVSVYEVEVGYIZYMYJYKWWIYNYNWWMWXLWXCWWL
          FWXBYDXQUYJXIVWRWXCUNWWTVVMVWPWWTVJVWQWXBFVWPWWTPXTYOUYKXIVVHVWGWWMBW
          WOVKZAUQVKZWYEASVKZWWJVWGWYFVVHVWGWBVWFWYEDAUQWXTVWCWWMNBVWEWWOWXTVWC
          VVTVYCVIVHZFVJWYBWWMWXTVWBWYHFVWAVYCVVTVIYIYOWYBWYHWWLFWYBVVTWWKVYCVI
          WYDYMYOUYLWXTWYBURZVWDWWNUTWYIVWAVYCEWXTWYBWTXBXBUYMUYNXEVVFWYFWYGVVG
          VVFWYFWYGVVFWYEWYEAUQSVVFVYCUQUPZWYEURZVYDWYEURVVFWYKURZVYDWYEWYLWWMV
          YDBWWOVVFWYKBVVFBWIWYJWYEBWYJBWIWWMBWWOWJWKWKWYLWWQURVYDWWMVVFWYJWWQV
          YDWYEVVFWYJURZWWQURZWYJVEVYCWPWQZWRZVYDVVFWYJWWQYHWYMWWQWWNUQUPZWYPWY
          NWWNVCVJZWRZWYQWYNWWOYPVJZWRZWYSWWQXUAWYMWWOVYEUYOWOWYRWYTWYRWWOVCUTU
          SYPWWNVCUTXTUYPXCUYQWHWYNWYRWYQWYNWYQWYRWYNWWNVQUPZWYQWYRVVAWYMXUBWWQ
          VVFWUQWYJXUBWVCUQVQVYCEUYRUYSVLWWNUYTXEVUAVUBVUCWYMWYQWYPVVFWYQWYPXSZ
          AUQVVFVVSEUSZUQUPZVEVVSWPWQZWRZXSZNUQYQZXUCAUQYQVVFXUGNWUSYQXUIVVFXUG
          NWUSVVFVVSWUSUPZURVVSSUPZXUGVVFWUSSVVSVVFWURWUTWVAWVBVUDVUEXUKVVSUQUP
          ZXUGVYRXUGCVVSUQSVYPVVSVJVYQXUFVYPVVSVEWPYRYSUGYTVUFWHVUGVVFXUGXUHNWU
          SUQVVFXUJXUGXSXULXUEURZXUGXSXULXUHXSVVFXUJXUMXUGVVFWUQEUQWCXUJXUMWDWV
          CUQVQEWFUQVVSUQEVUHXFVUIXULXUEXUGVUJXMVULYFXUCXUHANUQVYCVVSVJZWYQXUEW
          YPXUGXUNWWNXUDUQVYCVVSEXTXAXUNWYOXUFVYCVVSVEWPYRYSYKVUKVUMVUNYAVUOVYR
          WYPCVYCUQSVYPVYCVJVYQWYOVYPVYCVEWPYRYSUGYTVUPVUQVLVVFWYJWYEVURZYGXUOV
          USYBVUTYAXRVUOVVBVVCXPVVDVVE $.
      $}

      ${
        $d t z $.  $d f g k n t w A $.  $d f n t w J $.  $d f k n t w N $.
        $d n t w O $.  $d g k P $.  $d f k n t w R $.  $d n t w T $.
        eulerpartlemgh.1 $e |- U = U_ t e. ( ( `' A " NN ) i^i J )
                                     ( { t } X. ( bits ` ( A ` t ) ) ) $.
        $( Lemma for ~ eulerpart :  Rewriting the ` U ` set for an odd
           partition Note that interestingly, this proof reuses
           ~ marypha2lem2 .  (Contributed by Thierry Arnoux, 10-Aug-2018.) $)
        eulerpartlemgu $p |- ( A e. ( T i^i R ) -> U = { <. t , n >. |
          ( t e. ( ( `' A " NN ) i^i J ) /\ n e. ( ( bits o. A ) ` t ) ) } ) $=
          ( cin wcel ccnv cn cima cv csn cfv cbits cxp ciun ccom copab wfun cdm
          wa wceq cn0 wf cmap co cfn wss eulerpartlemt0 simp1bi elmapi syl ffun
          adantr inss1 cnvimass syl5sseq syl5ss sselda wb eleq2d mpbird syl2anc
          fdm fvco xpeq2d iuneq2dv eqid marypha2lem2 a1i eqtr3d syl5eq ) EIHUOU
          PZJDEUQURUSZSUOZDUTZVAZXEEVBVCVBZVDZVEZXEXDUPZNUTXEVCEVFZVBZUPVJDNVGZ
          UNXBDXDXFXLVDZVEZXIXMXBDXDXNXHXBXJVJZXLXGXFXPEVHZXEEVIZUPZXLXGVKXPURV
          LEVMZXQXBXTXJXBEVLURVNVOUPZXTXBYAXCVPUPXCSVQABCEFGHIKLMNPRSTUAUBUCUDU
          EUFUGUHUIUJUKULVRVSEVLURVTWAZWCURVLEWBWAXPXSXEURUPZXBXDURXEXBXDXCURXC
          SWDXBXRXCUREURWEXBXTXRURVKYBURVLEWMWAZWFWGWHXBXSYCWIXJXBXRURXEYDWJWCW
          KXEVCEWNWLWOWPXOXMVKXBDNXDXOXKXOWQWRWSWTXA $.

        $d t x y z $.  $d f g k m n p t x A $.  $d n p t x F $.
        $d f n t x y w J $.  $d f k n t w N $.  $d n p t w O $.  $d g k t P $.
        $d n p t R $.  $d n p t N $.  $d p U $.  $d p T $.
        $( Lemma for ~ eulerpart :  The ` F ` function is a bijection on the
           ` U ` subsets.  (Contributed by Thierry Arnoux, 15-Aug-2018.) $)
        eulerpartlemgh $p |- ( A e. ( T i^i R ) ->
          ( F |` U ) : U -1-1-onto-> { m e. NN |
          E. t e. NN E. n e. ( bits ` ( A ` t ) ) ( ( 2 ^ n ) x. t ) = m } ) $=
          ( vp cin wcel cima cres wf1o c2 cv cexp cmul wceq cfv cbits wrex crab
          co cn0 cxp wf1 wss oddpwdc f1of1 ax-mp ccnv csn ciun wral inss2 sseli
          cn vex snss sylib bitsss xpss12 sylancl rgen iunss mpbir f1ores mp2an
          eqsstri wb wa 2nn adantl nnexpcld simplr nnmulcld adantr simpr eleq1d
          a1i mpbid exp31 rexlimdv rexlimdva pm4.71rd wn c0 rex0 cc0 wo wi cmap
          wf wfn cfn eulerpartlemt0 simp1bi elmapi ad2antrr notbid fveq2d 0bits
          syl ffn imp syl6eq rexeqdv mpbiri ex con4d anasss rexbidv 3syl sylibr
          elpreima imnan mpd ffvelrnd elnn0 syl2anc cdif eulerpartlemf sylan2br
          orel1 eldif anassrs elin sylanbrc simprr jca reximdv2 cdivides ssrab2
          wbr sstri ssrexv impbid bitr3d eqeq2 elrab imaeq2i imaiun eqtri eliun
          eleq2i f1ofn biimpi ovelimab sylancr oveq1 eqeq2d rexsn syl6bb eqeq1i
          cop df-ov eqcom bitr3i opelxpi c2nd c1st oddpwdcv op2nd op1st oveq12i
          oveq2i eqeq1d syl5bbr sylan2 rexbidva bitrd 3bitri eqrdv f1oeq3 mpbii
          rexbiia 3bitr4rd ) EIHUQURZJQJUSZQJUTZVAZJVBOVCZVDVKZDVCZVEVKZNVCZVFZ
          OUXLEVGZVHVGZVIZDWEVIZNWEVJZUXHVAZTVLVMZWEQVNZJUYBVOUXIUYBWEQVAZUYCAB
          CQTUHUIVPZUYBWEQVQVRJDEVSWEUSZTUQZUXLVTZUXQVMZWAZUYBUOUYJUYBVOUYIUYBV
          OZDUYGWBUYKDUYGUXLUYGURZUYHTVOZUXQVLVOZUYKUYLUXLTURZUYMUYGTUXLUYFTWCZ
          WDZUXLTDWFZWGZWHUXPWIZUYHTUXQVLWJZWKWLDUYGUYIUYBWMWNWQUYBWEJQWOWPUXFU
          XGUXTVFUXIUYAWRUXFUPUXGUXTUXFUPVCZWEURZUXMVUBVFZOUXQVIZDWEVIZWSZVUEDU
          YGVIZVUBUXTURZVUBUXGURZUXFVUFVUGVUHUXFVUFVUCUXFVUEVUCDWEUXFUXLWEURZWS
          ZVUDVUCOUXQVULUXJUXQURZVUDVUCVULVUMWSZVUDWSZUXMWEURZVUCVUNVUPVUDVUNUX
          KUXLVUNVBUXJVBWEURVUNWTXHVUMUXJVLURZVULUXQVLUXJUYTWDZXAXBUXFVUKVUMXCX
          DXEVUOUXMVUBWEVUNVUDXFXGXIXJXKXLXMUXFVUFVUHUXFVUEVUEDWEUYGUXFVUKVUEWS
          ZUYLVUEWSUXFVUSWSZUYLVUEVUTUXLUYFURZUYOUYLUXFVUKVUEVVAVULVUEVVAVULVVA
          VUEVULVVAXNZVUEXNZVULVVBWSZVVCVUDOXOVIZXNZVUDOXPZVVDVUEVVEVVDVUDOUXQX
          OVVDUXQXQVHVGZXOVVDUXPXQVHVVDUXPWEURZXNZVVIUXPXQVFZXRZVVKVVDVUKVVJUXF
          VUKVVBXCZVVDVUKVVIWSZXNZVUKVVJXSVVDVVBVVOVULVVBXFVVDVVAVVNVVDWEVLEYAZ
          EWEYBVVAVVNWRUXFVVPVUKVVBUXFEVLWEXTVKURZVVPUXFVVQUYFYCURUYFTVOABCEFGH
          IKLMOQSTUAUBUCUDUEUFUGUHUIUJUKULUMYDYEEVLWEYFYKYGZWEVLEYLWEUXLWEEUUCU
          UAYHXIVUKVVIUUDUUBUUEVVDUXPVLURVVLVVDWEVLUXLEVVRVVMUUFUXPUUGWHVVJVVLV
          VKVVIVVKUULYMUUHYIYJYNYOYHYPYQYRYMYSUXFVUKVUEUYOVULVUEUYOVULUYOVUEVUL
          UYOXNZVVCVULVVSWSZVVCVVFVVGVVTVUEVVEVVTVUDOUXQXOVVTUXQVVHXOVVTUXPXQVH
          UXFVUKVVSVVKVUKVVSWSUXFUXLWETUUIURVVKUXLWETUUMABCDEFGHIKLMOQSTUAUBUCU
          DUEUFUGUHUIUJUKULUMUUJUUKUUNYIYJYNYOYHYPYQYRYMYSUXLUYFTUUOUUPUXFVUKVU
          EUUQUURYQUUSVUHVUFXSZUXFUYGWEVOVWAUYGTWEUYPTVBCVCUUTUVBXNZCWEVJWEUHVW
          BCWEUVAWQUVCVUEDUYGWEUVDVRXHUVEUVFVUIVUGWRUXFUXSVUFNVUBWEUXNVUBVFZUXR
          VUEDWEVWCUXOVUDOUXQUXNVUBUXMUVGYTYTUVHXHVUJVUHWRUXFVUJVUBDUYGQUYIUSZW
          AZURVUBVWDURZDUYGVIVUHUXGVWEVUBUXGQUYJUSVWEJUYJQUOUVIDQUYGUYIUVJUVKUV
          MDVUBUYGVWDUVLVWFVUEDUYGUYLUYOVWFVUEWRUYQUYOVWFVUBUXLUXJQVKZVFZOUXQVI
          ZVUEUYOVWFVUBAVCZUXJQVKZVFZOUXQVIZAUYHVIZVWIUYOQUYBYBZUYKVWFVWNWRUYDV
          WOUYEUYBWEQUVNVRUYOUYMUYNUYKUYOUYMUYSUVOUYTVUAWKAOUYBUYHUXQVUBQUVPUVQ
          VWMVWIAUXLUYRVWJUXLVFZVWLVWHOUXQVWPVWKVWGVUBVWJUXLUXJQUVRUVSYTUVTUWAU
          YOVWHVUDOUXQVUMUYOVUQVWHVUDWRVURVWHUXLUXJUWCZQVGZVUBVFZUYOVUQWSZVUDVW
          SVWGVUBVFVWHVWGVWRVUBUXLUXJQUWDUWBVWGVUBUWEUWFVWTVWRUXMVUBVWTVWQUYBUR
          ZVWRUXMVFUXLUXJTVLUWGVXAVWRVBVWQUWHVGZVDVKZVWQUWIVGZVEVKUXMABCQTVWQUH
          UIUWJVXCUXKVXDUXLVEVXBUXJVBVDUXLUXJUYROWFZUWKUWNUXLUXJUYRVXEUWLUWMYNY
          KUWOUWPUWQUWRUWSYKUXDUWTXHUXEUXAUXGUXTJUXHUXBYKUXC $.
      $}

      ${
        $d f g k n o x y z $.  $d f o r A $.  $d o F $.  $d o r H $.
        $d f n o r x y J $.  $d o r M $.  $d f g x N $.  $d g n P $.
        $d f o R $.  $d f o T $.
        $( Lemma for ~ eulerpart :  Images under ` G ` have finite support.
           (Contributed by Thierry Arnoux, 29-Aug-2018.) $)
        eulerpartlemgf $p |- ( A e. ( T i^i R ) ->
          ( `' ( G ` A ) " NN ) e. Fin ) $=
          ( cin wcel cfv ccnv c1 csn cima cfn cn cbits cres ccom eulerpartlemgv
          wss cind cnveqd imaeq1d cvv wceq nnex crn imassrn cn0 wf1o wf oddpwdc
          cxp f1of frn mp2b sstri indpi1 mp2an cpw eulerpartlemmf eulerpartlem1
          syl6eq inss2 ax-mp ffvelrni syl wfun ffun imafi mpan eqeltrd cc0 cdif
          sseldi cpr cmap eulerpartgbij elin simplbi elmapi 3syl ssv dfn2 ssdif
          co syl5eqss sspreima sylancl wne ax-1ne0 necomi difprsn1 ffs2 sseqtrd
          eqcomi ssfi syl2anc ) DHGULZUMZDOUNZUOZUPUQZURZUSUMYGUTURZYIVEYJUSUMY
          EYINVADQVBVCZRUNZURZUSYEYIYMUTVFUNUNZUOZYHURZYMYEYGYOYHYEYFYNABCDEFGH
          IJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVDVGVHUTVIUMYMUTVEYPYMVJVKYMNVLZUTN
          YLVMQVNVRZUTNVOZYRUTNVPZYQUTVEABCNQUEUFVQZYRUTNVSZYRUTNVTWAWBYMUTVIWC
          WDWHYEYLUSUMZYMUSUMZYEYRWEZUSULZUSYLUUEUSWIYEYKPUMYLUUFUMABCDEFGHIJKL
          MNOPQRSTUAUBUCUDUEUFUGUHUIUJUKWFPUUFYKRPUUFRVOPUUFRVPABCEFIJKLNPQRSTU
          AUBUCUDUEUFUGUHWGPUUFRVSWJWKWLWTNWMZUUCUUDYSYTUUGUUAUUBYRUTNWNWANYLWO
          WPWLWQYEYJYGVIWRUQZWSZURZYIYEYFWMZUTUUIVEZYJUUJVEYEUTWRUPXAZYFVPZUUKY
          EYFUUMUTXBXKZGULZUMZYFUUOUMZUUNYDUUPDOYDUUPOVOYDUUPOVPABCEFGHIJKLMNOP
          QRSTUAUBUCUDUEUFUGUHUIUJUKXCYDUUPOVSWJWKUUQUURYFGUMYFUUOGXDXEYFUUMUTX
          FXGZUTUUMYFWNWLVNVIVEZUULVNXHUUTUTVNUUHWSUUIXIVNVIUUHXJXLWJUTUUIYFXMX
          NYEUUNUUJYIVJUUSUTUUMYHYFWRUUMUUHWSZYHWRUPXOUVAYHVJUPWRXPXQWRUPXRWJYA
          XSWLXTYIYJYBYC $.
      $}

      $( ` S ` recovers the sum of a partition. $)
      eulerpart.s $e |- S = ( f e. ( ( NN0 ^m NN ) i^i R )
        |-> sum_ k e. NN ( ( f ` k ) x. k ) ) $.

      ${
        $d f g k n o t x y z $.  $d f g k m n o r t w x y A $.  $d f k G $.
        $d n o t w x y F $.  $d o r H $.  $d f n o r t w x y J $.
        $d n o r t x y M $.  $d f g k n t x N $.  $d n r t x y O $.
        $d g k n t P $.  $d f k n o r t x y R $.  $d w x y R $.
        $d f k n o r t w x y T $.
        $( Lemma for ~ eulerpart :  The ` G ` function also preserves partition
           sums.  (Contributed by Thierry Arnoux, 10-Sep-2017.) $)
        eulerpartlemgs2 $p |- ( A e. ( T i^i R )
          -> ( S ` ( G ` A ) ) = ( S ` A ) ) $=
          ( vt vw vm cin wcel cfv ccnv cn cima cv cmul co csu c2 cexp wceq wrex
          cbits c1 cc0 cif csn cxp ciun c2nd c1st cdm cnvimass cpr cmap wf wf1o
          wa eulerpartgbij f1of ax-mp ffvelrni sylib simpld elmapi fdm syl5sseq
          elin 3syl sselda eulerpartlemgvv oveq1d syldan sumeq2dv eqeq2 rexbidv
          crab elrab simprbi iftrue syl cc nnsscn simplbi sseldi mulid2 sumeq2i
          eqtrd id cfn wss adantl jca ssfi syl2anc cvv wral cn0 inss2 simpr a1i
          sylibr mp2an mulcld eqtr3d adantr inss1 oveq12d sseli eulerpartlemsv2
          wn vex cres cen wbr eulerpartlemgf 1nn syl6eqel wb simpl wfn elpreima
          ffn mpbird ex eqid eulerpartlemgh cnvexg imaexg inex1g snex fvex xpex
          ssrdv rgenw iunexg f1oeng sylan mpdan enfii fvres snssd bitsss xpss12
          sylancl ralrimiva oddpwdcv fsumf1o syl5eq ax-1cn 0cn ifcl ssrab2 cdif
          iunss eldifbd ssdifssd notbii bitr4i biimpi imp iffalse syl6ss mul02d
          imnan fsumss eulerpartlemt0 simp1bi sseldd ffvelrnd bitsfi 2cn simprr
          wi expcl anassrs fsummulc1 bitsinv1 op2ndd oveq2d op1std cnveq eleq1d
          cop imaeq1d elab2g mpbid adantrr fsum2d 3eqtr3d sseq1d elrab2 sumeq1d
          df-ss 3eqtr2d fveq2 cbvsumv syl6eqr 0nn0 1nn0 prssi mpan2 nn0ex elmap
          fss nnex biimpri anim1i 3imtr4i 3eqtr4d ) DIGUQZURZDPUSZUTVAVBZLVCZVU
          AUSZVUCVDVEZLVFZDUTZVAVBZVUCDUSZVUCVDVEZLVFZVUAHUSZDHUSZUYTVUFVUHUNVC
          ZDUSZVUNVDVEZUNVFZVUKUYTVUFVUBVGMVCZVHVEZVUNVDVEZVUCVIZMVUOVKUSZVJZUN
          VAVJZVLVMVNZVUCVDVEZLVFZUNVUHRUQZVUNVOZVVBVPZVQZVGUOVCZVRUSZVHVEZVVLV
          SUSZVDVEZUOVFZVUQUYTVUBVUEVVFLUYTVUCVUBURZVUCVAURZVUEVVFVIUYTVUBVAVUC
          UYTVUAVTZVUBVAVUAVAWAUYTVUAVMVLWBZVAWCVEZURZVAVWAVUAWDZVVTVAVIUYTVWCV
          UAGURZUYTVUAVWBGUQZURZVWCVWEWFZUYSVWFDPUYSVWFPWEUYSVWFPWDABCEFGIJKLMN
          OPQRSTUAUBUCUDUEUFUGUHUIUJUKULWGUYSVWFPWHWIWJZVUAVWBGWPZWKWLZVUAVWAVA
          WMZVAVWAVUAWNWQWOZWRUYTVVSWFVUDVVEVUCVDABCUNDVUCEFGIJKLMNOPQRSTUAUBUC
          UDUEUFUGUHUIUJUKULWSZWTXAXBUYTVUTUPVCZVIZMVVBVJZUNVAVJZUPVAXEZVVFLVFZ
          VVQVVGUYTVWTVWSVUCLVFVVQVWSVVFVUCLVUCVWSURZVVFVLVUCVDVEZVUCVXAVVEVLVU
          CVDVXAVVDVVEVLVIZVXAVVSVVDVWRVVDUPVUCVAVWOVUCVIZVWQVVCUNVAVXDVWPVVAMV
          VBVWOVUCVUTXCXDXDXFZXGZVVDVLVMXHZXIWTVXAVUCXJURVXBVUCVIVXAVAXJVUCXKVX
          AVVSVVDVXEXLZXMVUCXNXIXPXOUYTVWSVUCVVKVVPLUOOVVKUUAZVVPVUCVVPVIXQUYTV
          WSXRURZVVKVWSUUBUUCZVVKXRURUYTVUBXRURVWSVUBXSVXJABCDEFGIJKLMNOPQRSTUA
          UBUCUDUEUFUGUHUIUJUKULUUDZUYTLVWSVUBUYTVXAVVRUYTVXAWFZVVRVVSVUDVAURZW
          FZVXMVVSVXNVXAVVSUYTVXHXTZVXMVUDVLVAVXMVUDVVEVLUYTVXAVVSVUDVVEVIVXPVW
          NXAVXMVVDVXCVXAVVDUYTVXFXTVXGXIXPUUEUUFYAVXMUYTVVRVXOUUGZUYTVXAUUHUYT
          VWDVUAVAUUIVXQUYTVWCVWDVWKVWLXIVAVWAVUAUUKVAVUCVAVUAUUJWQXIUULUUMUVBZ
          VUBVWSYBYCUYTVVKVWSVXIWEZVXKABCUNDEFGIVVKJKLUPMNOPQRSTUAUBUCUDUEUFUGU
          HUIUJUKULVVKUUNUUOZUYTVVKYDURZVXSVXKUYTVVHYDURZVVJYDURZUNVVHYEVYAUYTV
          UGYDURVUHYDURVYBDUYSUUPVUGVAYDUUQVUHRYDUURWQVYCUNVVHVVIVVBVUNUUSVUOVK
          UUTUVAUVCUNVVHVVJYDYDUVDUVMVVKVWSYDVXIUVEUVFUVGVVKVWSUVHYCVXTUYTVVLVV
          KURZWFZVVLVXIUSZVVLOUSZVVPVYDVYFVYGVIUYTVVLVVKOUVIXTVYEVVLRYFVPZURVYG
          VVPVIUYTVVKVYHVVLUYTVVJVYHXSZUNVVHYEVVKVYHXSUYTVYIUNVVHUYTVUNVVHURZWF
          ZVVIRXSVVBYFXSZVYIVYKVUNRVYKVVHRVUNVUHRYGUYTVYJYHZXMUVJVYLVYKVUOUVKZY
          IVVIRVVBYFUVLYCUVNUNVVHVVJVYHUWCYJWRABCORVVLUFUGUVOXIXPVXMVAXJVUCXKVX
          PXMUVPUVQUYTVWSVUBVVFLVXRVXMVVEVUCVVEXJURZVXMVLXJURVMXJURVYOUVRUVSVVD
          VLVMXJUVTYKYIVXMVAXJVUCXKVXMVWSVAVUCVWRUPVAUWAUYTVXAYHXMXMYLUYTVUCVUB
          VWSUWBZURZWFZVVFVMVUCVDVEVMVYRVVEVMVUCVDVYRVVDYSZVVEVMVIVYRVXAYSZVVSV
          YSVYRVUCVUBVWSUYTVYQYHUWDUYTVYPVAVUCUYTVUBVAVWSVWMUWEZWRVYTVVSVYSVYTV
          VSVYSUXBZVYTVVSVVDWFZYSWUBVXAWUCVXEUWFVVSVVDUWMUWGUWHUWIYCVVDVLVMUWJX
          IWTVYRVUCUYTVYPXJVUCUYTVYPVAXJWUAXKUWKWRUWLXPVXLUWNYMUYTVVHVUPUNVFZVV
          QVUQUYTVVHVVBVUSMVFZVUNVDVEZUNVFVVHVVBVUTMVFZUNVFWUDVVQUYTVVHWUFWUGUN
          VYKVVBVUSVUNMVYKVUOYFURZVVBXRURVYKVAYFVUNDUYTVAYFDWDZVYJUYTDYFVAWCVEZ
          URZWUIUYTWUKVUHXRURZVUHRXSZABCDEFGIJKLMOQRSTUAUBUCUDUEUFUGUHUIUJUKUWO
          UWPZDYFVAWMXIZYNVYKVUHVAVUNUYTVUHVAXSVYJUYTDVTZVUHVADVAWAUYTWUIWUPVAV
          IWUOVAYFDWNXIWOYNVYKVVHVUHVUNVUHRYOZVYMXMUWQZUWRZVUOUWSXIZVYKVAXJVUNX
          KWURXMZUYTVYJVURVVBURZVUSXJURZUYTVYJWVBWFWFZVGXJURZVURYFURWVCWVEWVDUW
          TYIWVDVVBYFVURVYNUYTVYJWVBUXAXMVGVURUXCYCZUXDUXEXBUYTVVHWUFVUPUNVYKWU
          HWUFVUPVIWUSWUHWUEVUOVUNVDMVUOUXFWTXIXBUYTUOVVHVVBVUTVVPUNMVVLVUNVURU
          XLVIZVVNVUSVVOVUNVDWVGVVMVURVGVHVUNVURVVLUNYTZMYTZUXGUXHVUNVURVVLWVHW
          VIUXIYPUYTWULVVHVUHXSZVVHXRURUYTDGURZWULUYSGDIGYGYQZJVCZUTZVAVBZXRURW
          ULJDGUYSWVMDVIZWVOVUHXRWVPWVNVUGVAWVMDUXJUXMZUXKUJUXNUXOWVJUYTWUQYIVU
          HVVHYBYCWUTWVDVUSVUNWVFUYTVYJVUNXJURWVBWVAUXPYLUXQUXRUYTVVHVUHVUPUNUY
          TWUMVVHVUHVIUYTDIURZWUMUYSIDIGYOYQWVRWUKWUMWVORXSWUMJDWUJIWVPWVOVUHRW
          VQUXSUKUXTXGXIVUHRUYBWKUYAYMUYCVUHVUJVUPLUNVUCVUNVIZVUIVUOVUCVUNVDVUC
          VUNDUYDWVSXQYPUYEUYFUYTVWGVUAWUJGUQZURZVULVUFVIVWIVWHVUAWUJURZVWEWFVW
          GWWAVWCWWBVWEVWCVWDVAYFVUAWDZWWBVWLVWDVWAYFXSZWWCVMYFURVLYFURWWDUYGUY
          HVMVLYFUYIYKVAVWAYFVUAUYMUYJWWBWWCYFVAVUAUYKUYNUYLUYOWQUYPVWJVUAWUJGW
          PUYQVUAGHJLUJUMYRWQUYTDWVTURZVUMVUKVIUYTWUKWVKWFWWEUYTWUKWVKWUNWVLYAD
          WUJGWPYJDGHJLUJUMYRXIUYR $.
      $}


      $d d f g k n o q r x y z $.  $d d D $.  $d d k n o q x y F $.
      $d f k o q G $.  $d o q r H $.  $d d f k n o q r x y J $.
      $d d k n o q r x y M $.  $d d f g k n o q x N $.  $d n r x y O $.
      $d g k n q P $.  $d d f k n o q r x y R $.  $d q S $.
      $d d f k n o q r x y T $.
      $( Lemma for ~ eulerpart .  (Contributed by Thierry Arnoux,
         30-Aug-2018.) $)
      eulerpartlemn $p |- ( G |` O ) : O -1-1-onto-> D $=
        ( vq vd cres wf1o wtru cn cv cfv cmul co csu wceq cin crab cc0 cpr cmap
        c1 wi vex wcel wa simpl fveq1d oveq1d sumeq2dv eqeq1d cbvrabv a1i eqidd
        reseq2d f1oeq123d imbi2d cbits ccom cima cind eulerpartgbij simp2 eleq1
        fveq2 reseq1 coeq2d fveq2d imaeq2d eqeq12d imbi12d eulerpartlemgv vtocl
        w3a syl cn0 wss cvv nn0ex mp2an ax-mp wf eulerpartlemsv1 eulerpartlemt0
        ccnv cfn elin c2 cdivides wbr wral nfcv nfv cnveq imaeq1d nfrab1 df-3an
        wn anbi1i eulerpartleme an32 3bitr4i wb nnex dfss3 3bitri pm5.32i rabid
        bitr4i eqri df-f 3bitr4ri simp3 eqtr4d eulerpartlemgs2 0nn0 prssi mapss
        sumeq2sdv 1nn0 ssrin f1of ffvelrni simp1bi inss2 sseli sylanbrc 3eqtr3d
        sseldi 3ad2ant2 eqtr3d frabbijd raleqdv cbvrabcsf elmapg bitri cnvimass
        3anbi1i cdm fdm sseq2d mpbii sylib biantrurd breq2 notbid elrab2 ralbii
        r19.26 syl6rbbr adantr 3eqtri reseq2i wfn crn fnima sseq1d anbi2d mpan2
        sstr pm4.71ri bicomi syl6bb anass prex elmap eleq1d elab2 eulerpartlemd
        anbi12i mpbird trud ) TDOTUOZUPZUQUXBURKUSZUMUSZUTZUXCVAVBZKVCZSVDZUMHF
        VEZVFZURUXCUNUSZUTZUXCVAVBZKVCZSVDZUNVGVJVHZURVIVBZFVEZVFZOUXJUOZUPZUQU
        RUXCMUSZUTZUXCVAVBZKVCZSVDZMUXIVFZUXSOUYGUOZUPZVKUQUYAVKMUXDUMVLUYBUXDV
        DZUYIUYAUQUYJUYGUXJUXSUXSUYHUXTUYJUYGUXJOUYGUXJVDUYJUYFUXHMUMUXIUYJUYEU
        XGSUYJURUYDUXFKUYJUXCURVMZVNZUYCUXEUXCVAUYLUXCUYBUXDUYJUYKVOVPVQVRVSVTW
        AZWCUYMUYJUXSWBWDWEUQUYFUXOMUNUXIUXRNWFUYBQUOZWGZRUTZWHZURWIUTZUTZOUKUX
        IUXROUPZUQABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKWJZWAUQUYBUXIVMZUXKU
        YSVDZXBZUXNUYESVUDURUXCUYBOUTZUTZUXCVAVBZKVCZUXNUYEVUDURVUGUXMKVUDVUFUX
        LUXCVAVUDUXCVUEUXKVUDVUEUYSUXKVUDVUBVUEUYSVDZUQVUBVUCWKUXDUXIVMZUXDOUTZ
        NWFUXDQUOZWGZRUTZWHZUYRUTZVDZVKVUBVUIVKUMUYBMVLZUXDUYBVDZVUJVUBVUQVUIUX
        DUYBUXIWLZVUSVUKVUEVUPUYSUXDUYBOWMZVUSVUOUYQUYRVUSVUNUYPNVUSVUMUYORVUSV
        ULUYNWFUXDUYBQWNWOWPWQWPWRWSABCUXDDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
        KWTXAXCUQVUBVUCUUAUUBVPVQUUGVUBUQVUHUYEVDVUCVUBVUEGUTZUYBGUTZVUHUYEVUJV
        UKGUTZUXDGUTZVDZVKVUBVVBVVCVDZVKUMUYBVURVUSVUJVUBVVFVVGVUTVUSVVDVVBVVEV
        VCVUSVUKVUEGVVAWPUXDUYBGWMWRWSABCUXDDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
        UJUKULUUCXAVUBVUEXDURVIVBZFVEZVMVVBVUHVDVUBUXRVVIVUEUXQVVHXEZUXRVVIXEXD
        XFVMZUXPXDXEZVVJXGVGXDVMVJXDVMVVLUUDUUHVGVJXDUUEXHZUXPXDURXFUUFXHUXQVVH
        FUUIXIUXIUXRUYBOUYTUXIUXROXJVUAUXIUXROUUJXIUUKUUQVUEFGIKUIULXKXCVUBUYBV
        VIVMZVVCUYEVDVUBUYBVVHVMZUYBFVMVVNVUBVVOUYBXMURWHZXNVMVVPQXEABCUYBDEFHI
        JKLNPQRSTUAUBUCUDUEUFUGUHUIUJXLUULUXIFUYBHFUUMUUNUYBVVHFXOUUOUYBFGIKUIU
        LXKXCUUPUURUUSVSUUTXAUQTUXJDUXSUXAUXTUXAUXTVDUQTUXJOTXPLUSZXQXRZYFZLJUS
        ZXMZURWHZXSZJEVFVVSLUXDXMZURWHZXSZUMEVFZUXJUCVWCVWFJUMEEUMEXTJEXTVWCUMY
        AVWFJYAVVTUXDVDZEWBVWHVVSLVWBVWEVWHVWAVWDURVVTUXDYBYCUVAUVBUMVWGUXJVWFU
        MEYDUXHUMUXIYDUXDEVMZVWFVNZVUJUXHVNZUXDVWGVMUXDUXJVMVWJURXDUXDXJZVWEXNV
        MZVNZVWFVNZUXHVNZVWKVWLVWMUXHXBZVWFVNVWNUXHVNZVWFVNVWJVWPVWQVWRVWFVWLVW
        MUXHYEYGVWIVWQVWFUXDEIKSUBYHYGVWNVWFUXHYIYJVUJVWOUXHVUJVWLVWMVWEQXEZXBZ
        VWNVWSVNVWOVUJUXDVVHVMZVWMVWSXBVWTABCUXDDEFHIJKLNPQRSTUAUBUCUDUEUFUGUHU
        IUJXLVXAVWLVWMVWSVVKURXFVMVXAVWLYKXGYLXDURUXDXFXFUVCXHUVFUVDVWLVWMVWSYE
        VWNVWSVWFVWLVWSVWFYKVWMVWLVWFVVQURVMZLVWEXSZVWFVNZVWSVWLVXCVWFVWLVWEURX
        EZVXCVWLVWEUXDUVGZXEVXEUXDURUVEVWLVXFURVWEURXDUXDUVHUVIUVJLVWEURYMUVKUV
        LVWSVVQQVMZLVWEXSVXBVVSVNZLVWEXSVXDLVWEQYMVXGVXHLVWEXPCUSZXQXRZYFVVSCVV
        QURQVXIVVQVDVXJVVRVXIVVQXPXQUVMUVNUEUVOUVPVXBVVSLVWEUVQYNUVRUVSYOYNYGYQ
        VWFUMEYPUXHUMUXIYPYJYRUVTZUWAWATUXJVDUQVXKWADUXSVDUQUNDUXSUNDXTUXOUNUXR
        YDUXKUXRVMZUXOVNZUXKEVMZUXKURWHZUXPXEZVNZUXKUXSVMUXKDVMVXMURXDUXKXJZUXK
        XMZURWHZXNVMZVNZVXPVNZUXOVNZVXQVXLVYCUXOUXKUXQVMZUXKFVMZVNVXRVXPVNZVYAV
        NVXLVYCVYEVYGVYFVYAURUXPUXKXJZUXKURUWBZUXKUWCZXDXEZVNZVXPVNZVYEVYGVYIVY
        KVXPVNZVNVYIVYJUXPXEZVNVYMVYHVYIVYNVYOVYIVYNVYKVYOVNZVYOVYIVXPVYOVYKVYI
        VXOVYJUXPURUXKUWDUWEUWFVYOVYPVYOVYKVYOVVLVYKVVMVYJUXPXDUWHUWGUWIUWJUWKY
        OVYIVYKVXPUWLURUXPUXKYSYTUXPURUXKVGVJUWMYLUWNVXRVYLVXPURXDUXKYSYGYJIUSZ
        XMZURWHZXNVMVYAIUXKFUNVLVYQUXKVDZVYSVXTXNVYTVYRVXSURVYQUXKYBYCUWOUIUWPU
        WRUXKUXQFXOVXRVYAVXPYIYJYGVXQVXRVYAUXOXBZVXPVNVYBUXOVNZVXPVNVYDVXNWUAVX
        PUXKEIKSUBYHYGWUAWUBVXPVXRVYAUXOYEYGVYBUXOVXPYIYNYQUXOUNUXRYPUXKDEIJKLS
        TUBUCUDUWQYTYRWAWDUWSUWT $.
    $}

    $d a b f g h k n m o q r s t x y z $.  $d g D $.  $d f g k n q x N $.
    $d g n r x y O $.  $d g k n P $.
    $( Euler's theorem on partitions, also known as a special case of
       Glaisher's theorem.  Let ` P ` be the set of all partitions of ` N ` ,
       represented as multisets of natural numbers, which is to say functions
       from ` NN ` to ` NN0 ` where the value of the function represents the
       number of repetitions of an individual element, and the sum of all the
       elements with repetition equals ` N ` .  Then the set ` O ` of all
       partitions that only consist of odd numbers and the set ` D ` of all
       partitions which have no repeated elements have the same cardinality.
       (Contributed by Thierry Arnoux, 14-Aug-2018.) $)
    eulerpart $p |- ( # ` O ) = ( # ` D ) $=
      ( vr va vb cv cfv wceq cima cfn wcel vo vh vz vx vy vq vm vt vs wex chash
      wf1o ccnv cn c2 cdivides wbr wn crab wss cn0 cmap cab cin cexp cmul cmpt2
      co cbits cres ccom cvv c0 csn cdif cpw wa copab cmpt cind csu eqid oveq1d
      oveq2 cbvmpt2v nfcv nfv eqidd cnveq imaeq1d eleq1d cbvrabcsf eqcomi fveq1
      eleq2d anbi2d opabbidv cbvmptv simpl simpr eleq12d anbi12d cbvopabv eqtri
      fveq2d mpteq12i cbvabv sseq1d cbvrabv reseq1 coeq2d imaeq2d eqtr4i fveq1i
      imaeq1i imaeq2i fveq2i mpteq2i eulerpartlemn ovex rabex inex1 mptex resex
      f1oeq1 spcev ax-mp cen bren hasheni sylbir ) HADOZULZDUJZHUKPAUKPQZHAUAUB
      OZUMZUNRZUOUCOUPUQURUCUNUSZUTZUBVAUNVBVHZUSZYRSTZUBVCZVDZUDUEYSVAUOUEOZVE
      VHZUDOZVFVHZVGZVIUAOZYSVJZVKZLLOZUMZVLVMVNVOZRZSTZLVAVPSVDYSVBVHZUSZUUHYS
      TZUUFUUHUUNPZTZVQZUDUEVRZVSZPZRZUNVTPZPZVSZHVJZULZYNUDUEUCABUUDCUUAUUDVDU
      NEOZCOZPUVNVFVHEWAVSZUUBCDEFUFMNYSVAUONOZVEVHZMOZVFVHZVGZUVKUGOZUMZUUPRZS
      TZUGUUSUSZYSUHUIOZUMZUUPRZSTZUIUUSUSZUVSYSTZUVQUVSUHOZPZTZVQZMNVRZVSZGHLI
      JKYSWBMNUDUEYSVAUVTUUIUVRUUHVFVHUVSUUHUVRVFWDUVQUUFQZUVRUUGUUHVFUVQUUFUOV
      EWDWCWEZUUTUWFUURUWELUGUUSUUSUGUUSWFZLUUSWFUURUGWGUWELWGUUNUWBQZUUSWHUXBU
      UQUWDSUXBUUOUWCUUPUUNUWBWIWJWKWLZWMUWRLUWKUWLUVQUVSUUNPZTZVQZMNVRZVSZLUWF
      UVEVSZUHLUWKUWQUXGUWMUUNQZUWPUXFMNUXJUWOUXEUWLUXJUWNUXDUVQUVSUWMUUNWNWOWP
      WQWRLUWKUXGUWFUVEUWFUWKUWEUWJUGUIUUSUUSUIUUSWFUXAUWEUIWGUWJUGWGUWBUWGQZUU
      SWHUXKUWDUWISUXKUWCUWHUUPUWBUWGWIWJWKWLWMUXFUVDMNUDUEUVSUUHQZUWSVQZUWLUVA
      UXEUVCUXMUVSUUHYSUXLUWSWSZWKUXMUVQUUFUXDUVBUXLUWSWTUXMUVSUUHUUNUXNXEXAXBX
      CXFZXDUUCUVOUMZUNRZSTUBCYPUVOQZYRUXQSUXRYQUXPUNYPUVOWIWJZWKXGYTUXQYSUTUBC
      UUAUXRYRUXQYSUXSXHXIUVKUFUUEUUJVIUFOZYSVJZVKZUVFPZRZUVIPZVSUFUUEUWAUYBUWR
      PZRZUVIPZVSUAUFUUEUVJUYEUUKUXTQZUVHUYDUVIUYIUVGUYCUUJUYIUUMUYBUVFUYIUULUY
      AVIUUKUXTYSXJXKXEXLXEWRUFUUEUYEUYHUYDUYGUVIUYDUWAUYCRUYGUUJUWAUYCUWAUUJUW
      TWMXOUYCUYFUWAUYBUVFUWRUVFUXHUWRUVFUXIUXHLUUTUVEUWFUVEUXCUVEWBXFUXOXMLUHU
      WKUXGUWQUUNUWMQZUXFUWPMNUYJUXEUWOUWLUYJUXDUWNUVQUVSUUNUWMWNWOWPWQWRXDXNXP
      XDXQXRXDUVPWBXSYMUVMDUVLUVKHUAUUEUVJUUBUUDYTUBUUAVAUNVBXTYAYBYCYDHAYLUVLY
      EYFYGYNHAYHUQYOHADYIHAYJYKYG $.
  $}
$( End $[ set-mbox-ta-eulerpart.mm $] $)
$( Begin $[ set-mbox-ta-proba.mm $] $)
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Probability
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Probability Theory
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)
  $c Prob $. $( The class of probability measures $)

  $( Extend class notation to include the class of probability measures. $)
  cprb $a class Prob $.

  $( Define the class of probability measures as the set of measures with total
     measure 1.  (Contributed by Thierry Arnoux, 14-Sep-2016.) $)
  df-prob $a |- Prob = { p e. U. ran measures | ( p ` U. dom p ) = 1 } $.

  ${
    $d p P $.
    $( The property of being a probability measure (Contributed by Thierry
       Arnoux, 8-Dec-2016.) $)
    elprob $p |- ( P e. Prob <->
      ( P e. U. ran measures /\ ( P ` U. dom P ) = 1 ) ) $=
      ( vp cv cdm cuni cfv c1 wceq cmeas crn cprb id dmeq unieqd fveq12d eqeq1d
      df-prob elrab2 ) BCZDZEZSFZGHADZEZAFZGHBAIJEKSAHZUBUEGUFUAUDSAUFLUFTUCSAM
      NOPBQR $.
  $}

  $( A probability measure is a measure on its domain.  (Contributed by Thierry
     Arnoux, 23-Dec-2016.) $)
  domprobmeas $p |- ( P e. Prob -> P e. ( measures ` dom P ) ) $=
    ( cprb wcel cmeas crn cuni cdm cfv c1 wceq elprob simplbi measbasedom sylib
    ) ABCZADEFCZAAGZDHCOPQFAHIJAKLAMN $.

  $( The domain of a probability measure is a sigma-algebra.  (Contributed by
     Thierry Arnoux, 23-Dec-2016.) $)
  domprobsiga $p |- ( P e. Prob -> dom P e. U. ran sigAlgebra ) $=
    ( cprb wcel cdm cmeas cfv csiga crn cuni domprobmeas measbase syl ) ABCAADZ
    EFCMGHICAJMAKL $.

  $( The probability of the universe set is 1 (Second axiom of Kolmogorov)
     (Contributed by Thierry Arnoux, 8-Dec-2016.) $)
  probtot $p |- ( P e. Prob -> ( P ` U. dom P ) = 1 ) $=
    ( cprb wcel cmeas crn cuni cdm cfv c1 wceq elprob simprbi ) ABCADEFCAGFAHIJ
    AKL $.

  ${
    $d x y P $.
    $( A probability is bounded in [ 0 , 1 ] (First axiom of Kolmogorov)
       (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    prob01 $p |- ( ( P e. Prob /\ A e. dom P ) -> ( P ` A ) e. ( 0 [,] 1 ) ) $=
      ( cprb wcel cdm wa cfv cxr cc0 cle wbr c1 w3a cicc cpnf cmeas cuni adantr
      co wb domprobmeas measvxrge0 sylan elxrge0 sylib simpr csiga crn measbase
      unielsiga wss elssuni adantl measssd probtot breq2d mpbid df-3an sylanbrc
      3syl 0xr 1re rexri elicc1 mp2an sylibr ) BCDZABEZDZFZABGZHDZIVKJKZVKLJKZM
      ZVKILNSDZVJVLVMFZVNVOVJVKIONSDZVQVGBVHPGDZVIVRBUAZAVHBUBUCVKUDUEVJVKVHQZB
      GZJKZVNVJAWAVHBVGVSVIVTRZVGVIUFVJVSVHUGUHQDWAVHDWDVHBUIVHUJUTVIAWAUKVGAVH
      ULUMUNVGWCVNTVIVGWBLVKJBUOUPRUQVLVMVNURUSIHDLHDVPVOTVALVBVCILVKVDVEVF $.
  $}

  $( The probability of the empty event set is 0.  (Contributed by Thierry
     Arnoux, 25-Dec-2016.) $)
  probnul $p |- ( P e. Prob -> ( P ` (/) ) = 0 ) $=
    ( cprb wcel cdm cmeas cfv c0 cc0 wceq domprobmeas measvnul syl ) ABCAADZEFC
    GAFHIAJMAKL $.

  ${
    $d x P $.
    unveldomd.1 $e |- ( ph -> P e. Prob ) $.
    $( The universe is an element of the domain of the probability, the
       universe (entire probability space) being ` U. dom P ` in our
       construction.  (Contributed by Thierry Arnoux, 22-Jan-2017.) $)
    unveldomd $p |- ( ph -> U. dom P e. dom P ) $=
      ( cprb wcel cdm csiga crn cuni cfv domprobsiga sgon baselsiga 4syl ) ABDE
      BFZGHIEOOIZGJEPOECBKOLPOMN $.
  $}

  ${
    $d x P $.
    $( The universe is an element of the domain of the probability, the
       universe (entire probability space) being ` U. dom P ` in our
       construction.  (Contributed by Thierry Arnoux, 22-Jan-2017.) $)
    unveldom $p |- ( P e. Prob -> U. dom P e. dom P ) $=
      ( cprb wcel id unveldomd ) ABCZAFDE $.
  $}

  ${
    $d x P $.
    $( The empty set is an element of the domain of the probability.
       (Contributed by Thierry Arnoux, 22-Jan-2017.) $)
    nuleldmp $p |- ( P e. Prob -> (/) e. dom P ) $=
      ( cprb wcel cdm csiga crn cuni c0 domprobsiga 0elsiga syl ) ABCADZEFGCHLC
      AILJK $.
  $}

  ${
    $d x z A $.  $d x z P $.
    $( The probability of the union of a countable disjoint set of events is
       the sum of their probabilities.  (Third axiom of Kolmogorov) Here, the
       ` sum_ ` construct cannot be used as it can handle infinite indexing set
       only if they are subsets of ` ZZ ` , which is not the case here.
       (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    probcun $p |- ( ( P e. Prob /\ A e. ~P dom P /\ ( A ~<_ om
      /\ Disj_ x e. A x ) ) -> ( P ` U. A ) = sum* x e. A ( P ` x ) ) $=
      ( cprb wcel cdm cmeas cfv cpw com cdom cv wdisj wa cuni cesum domprobmeas
      wbr wceq measvun syl3an1 ) CDECCFZGHEBUBIEBJKRABALZMNBOCHBUCCHAPSCQABUBCT
      UA $.
  $}

  ${
    $d x A $.  $d x B $.  $d x P $.
    $( The probability of the union two incompatible events is the sum of their
       probabilities.  (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    probun $p |- ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) ->
      ( ( A i^i B ) = (/) ->
                          ( P ` ( A u. B ) ) = ( ( P ` A ) + ( P ` B ) ) ) ) $=
      ( vx wcel c0 wceq cfv caddc co wa syl6eq sylan9eqr fveq2d 3ad2ant2 adantr
      cc0 syl2anc sseldi cr cprb cdm w3a cin wi simpll1 simplr simpr cdif disj3
      cun biimpi difeq1 difid eqtr2 syldan uneq12d unidm probnul oveq12d eqtr4d
      00id syl12anc ex wne cxad 3anass anbi1i df-3an bitr4i cpr cuni cv cpw com
      cesum cdom wbr wdisj simpl1 wss prssi prex elpw sylibr prct simp2l simp2r
      wb simp3 id disjprg syl3anc biimpar probcun syl112anc uniprg fveq2 adantl
      c1 cicc cpnf unitssxrge0 simp1 prob01 esumpr eqeq12d mpbid sylanb simpll2
      unitssre simpll3 rexadd eqtrd pm2.61dane ) CUAEZACUBZEZBXQEZUCZABUDFGZABU
      KZCHZACHZBCHZIJZGZUEABXTABGZKZYAYGYIYAKXPYHYAYGXPXRXSYHYAUFXTYHYAUGYIYAUH
      XPYHYAKZKZYCQYFYJXPYCFCHZQYJYBFCYJYBFFUKFYJAFBFYAYHAABUIZFYAAYMGABUJULYHY
      MBBUIFABBUMBUNLMZYHYAAFGBFGYNABFUOUPZUQFURLNCUSZMYKYFQQIJQYKYDQYEQIYJXPYD
      YLQYJAFCYNNYPMYJXPYEYLQYJBFCYONYPMUTVBLVAVCVDXTABVEZKZYAYGYRYAKZYCYDYEVFJ
      ZYFYRXPXRXSKZYQUCZYAYCYTGZYRXPUUAKZYQKUUBXTUUDYQXPXRXSVGVHXPUUAYQVIVJUUBY
      AKZABVKZVLZCHZUUFDVMZCHZDVPZGZUUCUUEXPUUFXQVNEZUUFVOVQVRZDUUFUUIVSZUULXPU
      UAYQYAVTUUEUUFXQWAZUUMUUBUUPYAUUAXPUUPYQABXQWBOPUUFXQABWCWDWEUUBUUNYAUUAX
      PUUNYQABXQXQWFOPUUBUUOYAUUBXRXSYQUUOYAWIXPXRXSYQWGZXPXRXSYQWHZXPUUAYQWJZD
      ABUUIABXQUUIAGZWKUUIBGZWKWLWMWNDUUFCWOWPUUBUULUUCWIYAUUBUUHYCUUKYTUUAXPUU
      HYCGYQUUAUUGYBCABXQXQWQNOUUBABUUJYDDYEXQXQUUTUUJYDGUUBUUIACWRWSUVAUUJYEGU
      UBUUIBCWRWSUUQUURUUBQWTXAJZQXBXAJZYDXCUUBXPXRYDUVBEZXPUUAYQXDZUUQACXEZRSU
      UBUVBUVCYEXCUUBXPXSYEUVBEZUVEUURBCXEZRSUUSXFXGPXHXIYSYDTEYETEYTYFGYSUVBTY
      DXKYSXPXRUVDXPXRXSYQYAUFZXPXRXSYQYAXJUVFRSYSUVBTYEXKYSXPXSUVGUVIXPXRXSYQY
      AXLUVHRSYDYEXMRXNVDXO $.
  $}

  $( The probability of the difference of two event sets (Contributed by
     Thierry Arnoux, 12-Dec-2016.) $)
  probdif $p |- ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) ->
    ( P ` ( A \ B ) ) = ( ( P ` A ) - ( P ` ( A i^i B ) ) ) ) $=
    ( cprb wcel w3a cfv cin cmin co cdif wceq syl3an1 c0 wss cc unitsscn prob01
    syl2anc sseldi cdm caddc cun inundif fveq2i simp1 cuni domprobsiga inelsiga
    csiga crn difelsiga indif2 inss2 ssinss1 ax-mp ssdif0 mpbi eqtri probun mpi
    syl3anc syl5eqr oveq1d cc0 c1 cicc pncan2d eqtr2d ) CDEZACUAZEZBVKEZFZACGZA
    BHZCGZIJVQABKZCGZUBJZVQIJVSVNVOVTVQIVNVOVPVRUCZCGZVTWAACABUDUEVNVJVPVKEZVRV
    KEZWBVTLZVJVLVMUFZVJVKUJUKUGEZVLVMWCCUHZABVKUIMZVJWGVLVMWDWHABVKULMZVJWCWDF
    VPVRHZNLWEWKVPAHZBKZNVPABUMWLBOZWMNLVPBOWNABUNVPABUOUPWLBUQURUSVPVRCUTVAVBV
    CVDVNVQVSVNVEVFVGJZPVQQVNVJWCVQWOEWFWIVPCRSTVNWOPVSQVNVJWDVSWOEWFWJVRCRSTVH
    VI $.

  $( A probability law is increasing with regard to event set inclusion.
     (Contributed by Thierry Arnoux, 10-Feb-2017.) $)
  probinc $p |- ( ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) /\ A C_ B ) ->
    ( P ` A ) <_ ( P ` B ) ) $=
    ( cprb wcel cdm w3a wss wa cmeas cfv simpl1 domprobmeas simpl2 simpl3 simpr
    syl measssd ) CDEZACFZEZBTEZGZABHZIZABTCUESCTJKESUAUBUDLCMQSUAUBUDNSUAUBUDO
    UCUDPR $.

  $( The probability of the complement of a set.  That is, the probability that
     the event ` A ` does not occur.  (Contributed by Thierry Arnoux,
     15-Dec-2016.) $)
  probdsb $p |- ( ( P e. Prob /\ A e. dom P ) ->
    ( P ` ( U. dom P \ A ) ) = ( 1 - ( P ` A ) ) ) $=
    ( cprb wcel cdm wa cuni cdif cfv cmin co wceq simpl unveldomd simpr probdif
    cin c1 syl3anc probtot wss elssuni dfss1 sylib fveq2d oveqan12d eqtrd ) BCD
    ZABEZDZFZUIGZAHBIZULBIZULAQZBIZJKZRABIZJKUKUHULUIDUJUMUQLUHUJMZUKBUSNUHUJOU
    LABPSUHUJUNRUPURJBTUJUOABUJAULUAUOALAUIUBAULUCUDUEUFUG $.

  ${
    probmeasd.1 $e |- ( ph -> P e. Prob ) $.
    $( A probability measure is a measure.  (Contributed by Thierry Arnoux,
       2-Feb-2017.) $)
    probmeasd $p |- ( ph -> P e. U. ran measures ) $=
      ( cdm cmeas cfv wcel crn cuni cprb domprobmeas syl measbasedom sylibr ) A
      BBDEFGZBEHIGABJGOCBKLBMN $.

    ${
      probvalrnd.1 $e |- ( ph -> A e. dom P ) $.
      $( The value of a probability is a real number.  (Contributed by Thierry
         Arnoux, 2-Feb-2017.) $)
      probvalrnd $p |- ( ph -> ( P ` A ) e. RR ) $=
        ( cc0 c1 cicc co cr cfv unitssre cprb wcel cdm prob01 syl2anc sseldi )
        AFGHIZJBCKZLACMNBCONTSNDEBCPQR $.
    $}

    $( The probability of the universe set is finite.  (Contributed by Thierry
       Arnoux, 2-Feb-2017.) $)
    probtotrnd $p |- ( ph -> ( P ` U. dom P ) e. RR ) $=
      ( cdm cuni unveldomd probvalrnd ) ABDEBCABCFG $.
  $}

  ${
    $d b c A $.  $d b c B $.  $d b c P $.  $d c b ph $.
    totprobd.1 $e |- ( ph -> P e. Prob ) $.
    totprobd.2 $e |- ( ph -> A e. dom P ) $.
    totprobd.3 $e |- ( ph -> B e. ~P dom P ) $.
    totprobd.4 $e |- ( ph -> U. B = U. dom P ) $.
    totprobd.5 $e |- ( ph -> B ~<_ om ) $.
    totprobd.6 $e |- ( ph -> Disj_ b e. B b ) $.
    $( Law of total probability, deduction form.  (Contributed by Thierry
       Arnoux, 25-Dec-2016.) $)
    totprobd $p |- ( ph -> ( P ` A ) = sum* b e. B ( P ` ( b i^i A ) ) ) $=
      ( vc cuni cin cfv wceq wcel syl syl2anc adantr cesum wss elssuni sseqtr4d
      cdm dfss1 sylib fveq2d cmpt cmeas cpw com cdom wbr wdisj cprb domprobmeas
      cv measinb measvun syl112anc c1 cicc co eqidd wa simpr ineq1d domprobsiga
      cc0 crn sigaclcu syl3anc inelsiga prob01 fvmptd elelpwi esumeq2dv 3eqtr3d
      csiga eqtr3d ) ACMZBNZDOZBDOCEURZBNZDOZEUAZAWCBDABWBUBWCBPABDUEZMZWBABWIQ
      ZBWJUBGBWIUCRIUDBWBUFUGUHAWBLWILURZBNZDOZUIZOZCWEWOOZEUAZWDWHAWOWIUJOZQZC
      WIUKQZCULUMUNZECWEUOWPWRPADWSQZWKWTADUPQZXCFDUQRGLBWIDUSSHJKECWIWOUTVAALW
      BWNWDWIWOVJVBVCVDZAWOVEAWLWBPZVFZWMWCDXGWLWBBAXFVGVHUHAWIVTVKMQZXAXBWBWIQ
      ZAXDXHFDVIRZHJCWIVLVMZAXDWCWIQZWDXEQFAXHXIWKXLXJXKGWBBWIVNVMWCDVOSVPACWQW
      GEAWECQZVFZLWEWNWGWIWOXEXNWOVEXNWLWEPZVFZWMWFDXPWLWEBXNXOVGVHUHXNXMXAWEWI
      QZAXMVGAXAXMHTWECWIVQSZXNXDWFWIQZWGXEQAXDXMFTXNXHXQWKXSAXHXMXJTXRAWKXMGTW
      EBWIVNVMWFDVOSVPVRVSWA $.
  $}

  ${
    $d b c A $.  $d b c B $.  $d b c P $.
    $( Law of total probability (Contributed by Thierry Arnoux,
       25-Dec-2016.) $)
    totprob $p |- ( ( P e. Prob /\ A e. dom P /\
      ( U. B = U. dom P /\ B e. ~P dom P /\ ( B ~<_ om /\ Disj_ b e. B b ) ) )
      -> ( P ` A ) = sum* b e. B ( P ` ( b i^i A ) ) ) $=
      ( vc cprb wcel cdm cuni wceq cpw com cdom wbr cv wdisj w3a cfv cin cesum
      wa simp1 simp2 simp32 simp31 simp33l cbvdisjv sylib totprobd ineq1 fveq2d
      simp33r id cbvesumv syl6eqr ) CFGZACHZGZBIUQIJZBUQKGZBLMNZDBDOZPZUAZQZQZA
      CRBEOZASZCRZETBVBASZCRZDTVFABCEUPURVEUBUPURVEUCUPURUSUTVDUDUPURUSUTVDUEVA
      VCUSUTUPURUFVFVCEBVGPVAVCUSUTUPURULDEBVBVGVBVGJZUMUGUHUIBVKVIDEVLVJVHCVBV
      GAUJUKUNUO $.
  $}

  ${
    $d x M $.  $d x y S $.
    $( Build a probability measure from a finite measure (Contributed by
       Thierry Arnoux, 17-Dec-2016.)  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    probfinmeasbOLD $p |- ( ( M e. ( measures ` S ) /\ ( M ` U. S ) e. RR+ )
                   -> ( x e. S |-> ( ( M ` x ) /e ( M ` U. S ) ) ) e. Prob ) $=
      ( vy cmeas cfv wcel cuni crp wa cv cxdiv co crn wceq cvv wral fveq2i cpw
      c1 cmpt cdm cprb measdivcstOLD ovex rgenw dmmptg ax-mp measbasedom sylibr
      syl6eleqr unieqi csiga measbase cdif com cdom wbr wi wss isrnsigau simprd
      w3a simp1d syl id rpxdivcld anim12i fveq2 oveq1d eqid fvmptg cc0 wne rpre
      cr rpne0 xdivid syl2anc adantl eqtrd syl5eq elprob sylanbrc ) CBEFZGZBHZC
      FZIGZJZABAKZCFZWHLMZUAZENHGZWNUBZHZWNFZTOWNUCGWJWNWPEFZGWOWJWNWEWSAWHBCUD
      WPBEWMPGZABQWPBOWTABWLWHLUEUFABWMPUGUHZRUKWNUIUJWJWRWGWNFZTWQWGWNWPBXAULR
      WJXBWHWHLMZTWJWGBGZXCIGZJXBXCOWFXDWIXEWFBUMNHGZXDBCUNXFXDWGDKZUOBGDBQZXGU
      PUQURXGHBGUSDBSQZXFBWGSUTXDXHXIVCDBVAVBVDVEWIWHWHWIVFZXJVGVHAWGWMXCBIWNWK
      WGOWLWHWHLWKWGCVIVJWNVKVLVEWIXCTOZWFWIWHVPGWHVMVNXKWHVOWHVQWHVRVSVTWAWBWN
      WCWD $.
  $}

  ${
    $( Build a probability measure from a finite measure (Contributed by
       Thierry Arnoux, 31-Jan-2017.) $)
    probfinmeasb $p |- ( ( M e. ( measures ` S ) /\ ( M ` U. S ) e. RR+ ) ->
      ( M oFC /e ( M ` U. S ) ) e. Prob ) $=
      ( cmeas cfv wcel cuni crp wa cxdiv cofc co crn cdm c1 wceq wfn adantr syl
      cprb fveq2d measdivcst csiga measfn measbase simpr ofcfn fndm measbasedom
      eleqtrrd sylibr unieqd unielsiga eqidd ofcval mpdan cr cc0 wne rpre rpne0
      xdivid syl2anc adantl 3eqtrd elprob sylanbrc ) BACDZEZAFZBDZGEZHZBVJIJKZC
      LFEZVMMZFZVMDZNOVMSEVLVMVOCDZEVNVLVMVGVRVJABUAVLVOACVLVMAPVOAOVLAVJIBUBLF
      ZGVHBAPVKABUCQZVHAVSEZVKABUDQZVHVKUEZUFAVMUGRZTUIVMUHUJVLVQVIVMDZVJVJIKZN
      VLVPVIVMVLVOAWDUKTVLVIAEZWEWFOVLWAWGWBAULRVLAVJVJIBVSGVIVTWBWCVLWGHVJUMUN
      UOVKWFNOZVHVKVJUPEVJUQURWHVJUSVJUTVJVAVBVCVDVMVEVF $.
  $}

  ${
    $d x y A $.  $d x y M $.  $d x y S $.
    $( Build a probability from a measure and a set with finite measure
       (Contributed by Thierry Arnoux, 25-Dec-2016.) $)
    probmeasb $p |- ( ( M e. ( measures ` S ) /\ A e. S /\ ( M ` A ) e. RR+ )
      -> ( x e. S |-> ( ( M ` ( x i^i A ) ) / ( M ` A ) ) ) e. Prob ) $=
      ( vy cmeas cfv wcel cin co cuni c1 wceq cc0 cpnf fveq2d adantr syl cr cxr
      crp w3a cv cdiv cmpt crn cdm cprb cxdiv simp1 simp2 measinb syl2anc simp3
      measdivcstOLD cicc eqidd simpr csiga measbase inelsiga syl3anc measvxrge0
      ineq1d fvmptd oveq1d wne cle wbr iccssxr sseldi rpred 0xr iccgelb mp3an12
      wa pnfxr wss inss2 measssd xrrege0 syl22anc rpne0d rexdiv eqtrd mpteq2dva
      wral rerpdivcld ralrimiva dmmptg eqcomd 3eltr3d measbasedom sylibr unieqd
      a1i rpcnd incom elssuni df-ss sylib syl5eq diveq1bd sgon baselsiga elprob
      4syl 1re sylanbrc ) DCFGZHZBCHZBDGZUAHZUBZACAUCZBIZDGZXMUDJZUEZFUFKHZXTUG
      ZKZXTGZLMXTUHHXOXTYBFGZHYAXOACXPECEUCZBIZDGZUEZGZXMUIJZUEZXJXTYEXOYIXJHZX
      NYLXJHXOXKXLYMXKXLXNUJZXKXLXNUKZEBCDULUMXKXLXNUNZAXMCYIUOUMXOACYKXSXOXPCH
      ZVPZYKXRXMUIJZXSYRYJXRXMUIYREXPYHXRCYINOUPJZYRYIUQYRYFXPMZVPZYGXQDUUBYFXP
      BYRUUAURVDPXOYQURZYRXKXQCHZXRYTHZXOXKYQYNQZYRCUSUFKHZYQXLUUDYRXKUUGUUFCDU
      TZRUUCXOXLYQYOQZXPBCVAVBZXQCDVCUMZVEVFYRXRSHZXMSHZXMNVGZYSXSMYRXRTHUUMNXR
      VHVIZXRXMVHVIUULYRYTTXRNOVJUUKVKYRXMXOXNYQYPQZVLZYRUUEUUOUUKNTHOTHUUEUUOV
      MVQNOXRVNVORYRXQBCDUUFUUJUUIXQBVRYRXPBVSWPVTXRXMWAWBZUUQYRXMUUPWCXRXMWDVB
      WEWFXOYEXJXOYBCFXOXSSHZACWGYBCMXOUUSACYRXRXMUURUUPWHWIACXSSWJRZPWKWLXTWMW
      NXOYDCKZXTGLXOYCUVAXTXOYBCUUTWOPXOAUVAXSLCXTSXOXTUQXOXPUVAMZVPZXRXMUVCXMX
      OXNUVBYPQWQXOUUNUVBXOXMYPWCQUVCXQBDUVCXQUVABIZBUVCXPUVABXOUVBURVDXOUVDBMZ
      UVBXOXLUVEYOXLUVDBUVAIZBUVABWRXLBUVAVRUVFBMBCWSBUVAWTXAXBRQWEPXCXOXKUUGCU
      VAUSGHUVACHYNUUHCXDUVACXEXGLSHXOXHWPVEWEXTXFXI $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Conditional Probabilities
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Conditional Probabililty builder $)
  $c cprob $.

  $( Extends class notation with the conditional probability builder. $)
  ccprob $a class cprob $.

  ${
    $d a b p $.
    $( Define the conditional probability.  (Contributed by Thierry Arnoux,
       14-Sep-2016.)  (Revised by Thierry Arnoux, 21-Jan-2017.) $)
    df-cndprob $a |- cprob = ( p e. Prob |->
      ( a e. dom p , b e. dom p |-> ( ( p ` ( a i^i b ) ) / ( p ` b ) ) ) ) $.
  $}

  ${
    $d a b p P $.  $d a b A $.  $d a b B $.
    $( The value of the conditional probability , i.e. the probability for the
       event ` A ` , given ` B ` , under the probability law ` P ` .
       (Contributed by Thierry Arnoux, 21-Jan-2017.) $)
    cndprobval $p |- ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) ->
    ( ( cprob ` P ) ` <. A , B >. ) = ( ( P ` ( A i^i B ) ) / ( P ` B ) ) ) $=
      ( va vb vp cprb wcel cdm ccprob cfv co cin cdiv cvv cmpt2 wceq a1i fveq1
      cv w3a cop df-ov cmpt df-cndprob dmeq oveq12d mpt2eq123dv adantl id dmexg
      mpt2exga syl2anc fvmptd 3ad2ant1 simprl simprr ineq12d fveq2d simp2 simp3
      wa ovex ovmpt2d syl5eqr ) CGHZACIZHZBVGHZUAZABUBCJKZKABVKLABMZCKZBCKZNLZA
      BVKUCVJDEABVGVGDTZETZMZCKZVQCKZNLZVOVKOVFVHVKDEVGVGWAPZQVIVFFCDEFTZIZWDVR
      WCKZVQWCKZNLZPZWBGJOJFGWHUDQVFFDEUERWCCQZWHWBQVFWIDEWDWDWGVGVGWAWCCUFZWJW
      IWEVSWFVTNVRWCCSVQWCCSUGUHUIVFUJVFVGOHZWKWBOHCGUKZWLDEVGVGWAOOULUMUNUOVJV
      PAQZVQBQZVBVBZVSVMVTVNNWOVRVLCWOVPAVQBVJWMWNUPVJWMWNUQZURUSWOVQBCWPUSUGVF
      VHVIUTVFVHVIVAVOOHVJVMVNNVCRVDVE $.
  $}

  $( An identity linking conditional probability and intersection.
     (Contributed by Thierry Arnoux, 13-Dec-2016.)  (Revised by Thierry Arnoux,
     21-Jan-2017.) $)
  cndprobin $p |- ( ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) /\
    ( P ` B ) =/= 0 ) ->
    ( ( ( cprob ` P ) ` <. A , B >. ) x. ( P ` B ) ) = ( P ` ( A i^i B ) ) ) $=
    ( cprb wcel cdm w3a cfv cc0 wne wa ccprob cmul co adantr cc unitsscn prob01
    cop sseldi cin cdiv wceq cndprobval oveq1d cicc simp1 csiga crn domprobsiga
    c1 cuni inelsiga syl3an1 syl2anc 3adant2 simpr divcan1d eqtrd ) CDEZACFZEZB
    VAEZGZBCHZIJZKZABSCLHHZVEMNZABUAZCHZVEUBNZVEMNZVKVDVIVMUCVFVDVHVLVEMABCUDUE
    OVGVKVEVDVKPEVFVDIUKUFNZPVKQVDUTVJVAEZVKVNEUTVBVCUGUTVAUHUIULEVBVCVOCUJABVA
    UMUNVJCRUOTOVDVEPEVFVDVNPVEQUTVCVEVNEVBBCRUPTOVDVFUQURUS $.

  $( The conditional probability has values in ` [ 0 , 1 ] ` .  (Contributed by
     Thierry Arnoux, 13-Dec-2016.)  (Revised by Thierry Arnoux,
     21-Jan-2017.) $)
  cndprob01 $p |- ( ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) /\
    ( P ` B ) =/= 0 ) -> ( ( cprob ` P ) ` <. A , B >. ) e. ( 0 [,] 1 ) ) $=
    ( cprb wcel cdm w3a cfv cc0 wne wa cop ccprob cin co syl3anc prob01 syl2anc
    cdiv syl cicc wceq cndprobval adantr cle wbr cmeas simpl1 domprobmeas csiga
    c1 crn cuni domprobsiga simpl2 simpl3 inelsiga wss inss2 measssd unitdivcld
    a1i wb simpr mpbid eqeltrd ) CDEZACFZEZBVHEZGZBCHZIJZKZABLCMHHZABNZCHZVLSOZ
    IUKUAOZVKVOVRUBVMABCUCUDVNVQVLUEUFZVRVSEZVNVPBVHCVNVGCVHUGHEVGVIVJVMUHZCUIT
    VNVHUJULUMEZVIVJVPVHEZVNVGWCWBCUNTVGVIVJVMUOVGVIVJVMUPZABVHUQPZWEVPBURVNABU
    SVBUTVNVQVSEZVLVSEZVMVTWAVCVNVGWDWGWBWFVPCQRVNVGVJWHWBWEBCQRVKVMVDVQVLVAPVE
    VF $.

  $( The conditional probability given a certain event is one.  (Contributed by
     Thierry Arnoux, 20-Dec-2016.)  (Revised by Thierry Arnoux,
     21-Jan-2017.) $)
  cndprobtot $p |- ( ( P e. Prob /\ A e. dom P /\ ( P ` A ) =/= 0 ) ->
    ( ( cprob ` P ) ` <. U. dom P , A >. ) = 1 ) $=
    ( cprb wcel cdm cfv cc0 wne w3a cuni cop ccprob cin cdiv co c1 wceq 3adant3
    wa simpl unveldomd simpr cndprobval syl3anc wss 3ad2ant2 dfss1 sylib fveq2d
    elssuni oveq1d cicc cc prob01 elunitcn syl simp3 dividd 3eqtrd ) BCDZABEZDZ
    ABFZGHZIZVAJZAKBLFFZVFAMZBFZVCNOZVCVCNOPUTVBVGVJQZVDUTVBSZUTVFVADVBVKUTVBTZ
    VLBVMUAUTVBUBVFABUCUDRVEVIVCVCNVEVHABVEAVFUEZVHAQVBUTVNVDAVAUJUFAVFUGUHUIUK
    VEVCVEVCGPULODZVCUMDUTVBVOVDABUNRVCUOUPUTVBVDUQURUS $.

  $( The conditional probability given empty event is zero.  (Contributed by
     Thierry Arnoux, 20-Dec-2016.)  (Revised by Thierry Arnoux,
     21-Jan-2017.) $)
  cndprobnul $p |- ( ( P e. Prob /\ A e. dom P /\ ( P ` A ) =/= 0 ) ->
    ( ( cprob ` P ) ` <. (/) , A >. ) = 0 ) $=
    ( cprb wcel cdm cfv cc0 wne w3a c0 cop ccprob cin cdiv co wceq nuleldmp syl
    simp1 simp2 cndprobval syl3anc incom in0 eqtri fveq2i oveq1i probnul oveq1d
    a1i c1 cicc cc prob01 3adant3 elunitcn simp3 div0d 3eqtrd eqtrd ) BCDZABEZD
    ZABFZGHZIZJAKBLFFZJAMZBFZVDNOZGVFVAJVBDZVCVGVJPVAVCVESZVFVAVKVLBQRVAVCVETJA
    BUAUBVFVJJBFZVDNOZGVDNOGVJVNPVFVIVMVDNVHJBVHAJMJJAUCAUDUEUFUGUJVFVMGVDNVFVA
    VMGPVLBUHRUIVFVDVFVDGUKULODZVDUMDVAVCVOVEABUNUOVDUPRVAVCVEUQURUSUT $.

  ${
    $d a B $.  $d a P $.
    $( The conditional probability defines a probability law.  (Contributed by
       Thierry Arnoux, 23-Dec-2016.)  (Revised by Thierry Arnoux,
       21-Jan-2017.) $)
    cndprobprob $p |- ( ( P e. Prob /\ B e. dom P /\ ( P ` B ) =/= 0 ) ->
      ( a e. dom P |-> ( ( cprob ` P ) ` <. a , B >. ) ) e. Prob ) $=
      ( cprb wcel cdm cfv cc0 wne w3a cv cop ccprob cmpt cin cdiv co 3adant3 wa
      syl cmeas domprobmeas 3ad2ant1 simp2 c1 cicc cr prob01 elunitrn elunitge0
      crp cle wbr simp3 ne0gt0d elrpd probmeasb syl3anc wceq 3anan32 cndprobval
      wb sylbir mpteq2dva eleq1d mpbird ) BDEZABFZEZABGZHIZJZCVHCKZALBMGGZNZDEZ
      CVHVMAOBGVJPQZNZDEZVLBVHUAGEZVIVJUKEVSVGVIVTVKBUBUCVGVIVKUDVLVJVLVJHUEUFQ
      EZVJUGEVGVIWAVKABUHRZVJUITZVLVJWCVLWAHVJULUMWBVJUJTVGVIVKUNUOUPCAVHBUQURV
      GVIVPVSVBVKVGVISZVOVRDWDCVHVNVQWDVMVHEZSVGWEVIJVNVQUSVGWEVIUTVMABVAVCVDVE
      RVF $.
  $}

  $( Bayes Theorem (Contributed by Thierry Arnoux, 20-Dec-2016.)  (Revised by
     Thierry Arnoux, 21-Jan-2017.) $)
  bayesth $p |- ( ( ( P e. Prob /\ A e. dom P /\ B e. dom P ) /\
    ( P ` A ) =/= 0 /\ ( P ` B ) =/= 0 ) -> ( ( cprob ` P ) ` <. A , B >. ) =
    ( ( ( ( cprob ` P ) ` <. B , A >. ) x. ( P ` A ) ) / ( P ` B ) ) ) $=
    ( cprb wcel w3a cfv cc0 wne cop cmul co cdiv cc unitsscn 3adant2 sseldi cin
    wceq cndprobin cdm ccprob cicc cndprob01 simp11 simp13 prob01 syl2anc simp3
    c1 divcan4d incom fveq2i simp12 simp2 syl31anc 3eqtr4a oveq1d eqtr3d ) CDEZ
    ACUAZEZBVAEZFZACGZHIZBCGZHIZFZABJCUBGZGZVGKLZVGMLVKBAJVJGVEKLZVGMLVIVKVGVIH
    UJUCLZNVKOVDVHVKVNEVFABCUDPQVIVNNVGOVIUTVCVGVNEUTVBVCVFVHUEZUTVBVCVFVHUFZBC
    UGUHQVDVFVHUIUKVIVLVMVGMVIABRZCGZBARZCGZVLVMVQVSCABULUMVDVHVLVRSVFABCTPVIUT
    VCVBVFVMVTSVOVPUTVBVCVFVHUNVDVFVHUOBACTUPUQURUS $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Real Valued Random Variables
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c rRndVar $. $( The class of real-valued random variables $)

  $( Extend class notation with the class of real valued random variables. $)
  crrv $a class rRndVar $.

  $( In its generic definition, a random variable is a measurable function from
     a probability space to a Borel set.  Here, we specifically target
     real-valued random variables, i.e. measurable function from a probability
     space to the Borel sigma algebra on the set of real numbers.  (Contributed
     by Thierry Arnoux, 20-Sep-2016.)  (Revised by Thierry Arnoux,
     25-Jan-2017.) $)
  df-rrv $a |- rRndVar = ( p e. Prob |-> ( dom p MblFnM BrSiga ) ) $.

  ${
    $d p y P $.  $d y X $.
    isrrvv.1 $e |- ( ph -> P e. Prob ) $.
    $( A real-valued random variable is a measurable function from its sample
       space to the Borel Sigma Algebra.  (Contributed by Thierry Arnoux,
       25-Jan-2017.) $)
    rrvmbfm $p |- ( ph -> ( X e. ( rRndVar ` P ) <->
                                            X e. ( dom P MblFnM BrSiga ) ) ) $=
      ( vp crrv cfv cdm cbrsiga cmbfm co cprb wcel wceq dmeq oveq1d df-rrv ovex
      cv fvmpt syl eleq2d ) ABFGZBHZIJKZCABLMUCUENDEBESZHZIJKUELFUFBNUGUDIJUFBO
      PEQUDIJRTUAUB $.

    $( Elementhood to the set of real-valued random variables with respect to
       the probability ` P ` .  (Contributed by Thierry Arnoux,
       25-Jan-2017.) $)
    isrrvv $p |- ( ph -> ( X e. ( rRndVar ` P ) <-> ( X : U. dom P --> RR /\
      A. y e. BrSiga ( `' X " y ) e. dom P ) ) ) $=
      ( crrv cfv wcel cdm cbrsiga cmbfm co cuni cmap ccnv wa cr csiga syl cvv
      cv cima wral wf rrvmbfm cprb domprobsiga brsigarn elrnsiga mp1i unibrsiga
      crn ismbfm oveq1i eleq2i reex uniexg elmapg sylancr syl5bb anbi1d 3bitrd
      wb ) ADCFGHDCIZJKLHDJMZVDMZNLZHZDOBUAUBVDHBJUCZPVFQDUDZVIPACDEUEABVDJDACU
      FHVDRULMZHZECUGSZJQRGHJVKHAUHJQUIUJUMAVHVJVIVHDQVFNLZHZAVJVGVNDVEQVFNUKUN
      UOAQTHVFTHZVOVJVCUPAVLVPVMVDVKUQSQVFDTTURUSUTVAVB $.

    rrvvf.1 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.
    $( A real-valued random variable is a function.  (Contributed by Thierry
       Arnoux, 25-Jan-2017.) $)
    rrvvf $p |- ( ph -> X : U. dom P --> RR ) $=
      ( vy cdm cuni cr wf ccnv cv cima wcel cbrsiga wral crrv cfv wa isrrvv
      mpbid simpld ) ABGZHICJZCKFLMUCNFOPZACBQRNUDUESEAFBCDTUAUB $.

    $( A real-valued random variable is a function over the universe.
       (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
    rrvfn $p |- ( ph -> X Fn U. dom P ) $=
      ( cdm cuni cr wf wfn rrvvf ffn syl ) ABFGZHCICNJABCDEKNHCLM $.

    $( The domain of a random variable is the universe.  (Contributed by
       Thierry Arnoux, 25-Jan-2017.) $)
    rrvdm $p |- ( ph -> dom X = U. dom P ) $=
      ( cdm cuni cr wf wceq rrvvf fdm syl ) ABFGZHCICFNJABCDEKNHCLM $.

    $( The range of a random variable as a subset of ` RR ` .  (Contributed by
       Thierry Arnoux, 6-Feb-2017.) $)
    rrvrnss $p |- ( ph -> ran X C_ RR ) $=
      ( cdm cuni cr wf crn wss rrvvf frn syl ) ABFGZHCICJHKABCDELOHCMN $.

    $( A real-valued random variable is a function.  (Contributed by Thierry
       Arnoux, 25-Jan-2017.) $)
    rrvf2 $p |- ( ph -> X : dom X --> RR ) $=
      ( cdm cr wf cuni rrvvf rrvdm feq2d mpbird ) ACFZGCHBFIZGCHABCDEJANOGCABCD
      EKLM $.

    $( The domain of a random variable.  This is useful to shorten proofs.
       (Contributed by Thierry Arnoux, 25-Jan-2017.) $)
    rrvdmss $p |- ( ph -> U. dom P C_ dom X ) $=
      ( cdm cuni wceq wss rrvdm eqimss2 syl ) ACFZBFGZHNMIABCDEJNMKL $.

    $( For a real-value random variable ` X ` , any open interval in ` RR ` is
       the image of a measurable set.  (Contributed by Thierry Arnoux,
       25-Jan-2017.) $)
    rrvfinvima $p |- ( ph -> A. y e. BrSiga ( `' X " y ) e. dom P ) $=
      ( cdm cuni cr wf ccnv cv cima wcel cbrsiga wral crrv cfv wa isrrvv simprd
      mpbid ) ACGZHIDJZDKBLMUCNBOPZADCQRNUDUESFABCDETUBUA $.
  $}

  ${
    $d x y P $.  $d y ph $.  $d y P $.
    0rrv.1 $e |- ( ph -> P e. Prob ) $.
    $( The constant function equal to zero is a random variable.  (Contributed
       by Thierry Arnoux, 16-Jan-2017.)  (Revised by Thierry Arnoux,
       30-Jan-2017.) $)
    0rrv $p |- ( ph -> ( x e. U. dom P |-> 0 ) e. ( rRndVar ` P ) ) $=
      ( vy cdm cuni cc0 wcel cr ccnv cima cbrsiga wral cin wceq cxp 3eqtri cvv
      c0 cmpt crrv cfv wf cv 0re rgenw eqid fmpt mpbi a1i csn wa cres fconstmpt
      crn cnveqi cnvxp eqtr3i imaeq1i df-ima df-rn df-res inxp inv1 dmeqi xpeq2
      xpeq2i xp0 syl6eq dmeqd adantl cprb csiga domprobsiga 0elsiga 3syl adantr
      dm0 eqeltrd syl5eqel dmxp unveldomd pm2.61dane ralrimivw isrrvv mpbir2and
      wne ) ABCFZGZHUAZCUBUCIWJJWKUDZWKKZEUEZLZWIIZEMNWLAHJIZBWJNWLWQBWJUFUGBWJ
      JHWKWKUHUIUJUKAWPEMAWPHULZWNOZTAWSTPZUMZWOWJWSQZFZWIWOWRWJQZWNUNZKZFZWSWJ
      QZKZFXCWOXDWNLXEUPXGWMXDWNWJWRQZKWMXDXJWKBWJHUOUQWJWRURUSUTXDWNVAXEVBRXFX
      IXEXHXEXDWNSQOWSWJSOZQXHXDWNVCWRWJWNSVDXKWJWSWJVEVHRUQVFXIXBWSWJURVFRZXAX
      CTWIWTXCTPAWTXCTFTWTXBTWTXBWJTQTWSTWJVGWJVIVJVKVSVJVLATWIIZWTACVMIWIVNUPG
      IXMDCVOWIVPVQVRVTWAAWSTWHZUMZWOXCWIXLXOXCWJWIXNXCWJPAWJWSWBVLAWJWIIXNACDW
      CVRVTWAWDWEAECWKDWFWG $.
  $}

  ${
    $d a b x y P $.  $d a b x y X $.  $d a b x y Y $.  $d a b x y ph $.
    rrvadd.1 $e |- ( ph -> P e. Prob ) $.
    rrvadd.2 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.
    rrvadd.3 $e |- ( ph -> Y e. ( rRndVar ` P ) ) $.
    $( The sum of two random variables is a random variable (Contributed by
       Thierry Arnoux, 4-Jun-2017.) $)
    rrvadd $p |- ( ph -> ( X oF + Y ) e. ( rRndVar ` P ) ) $=
      ( vx vy va vb caddc co cfv wcel cbrsiga cr cv rrvmbfm wceq cof crrv cmbfm
      cdm cmpt2 cuni cop cmpt ccom nfmpt1 rrvvf unveldomd eqidd ofoprabco csiga
      csx cprb crn domprobsiga syl brsigarn elrnsiga sxsiga syl2anc mpbid fveq2
      mp1i opeq12d cbvmptv mbfmco2 cioo ctg ctx ccn eqid a1i csigagen df-brsiga
      raddcn sxbrsiga cnmbfm mbfmco eqeltrd mpbird ) ACDLUAMZBUBNZOWEBUDZPUCMZO
      AWEHIQQHRIRLMUEZJWGUFZJRZCNZWKDNZUGZUHZUIWHAHIWJQQLCDWOWIWGJJWJWNUJABCEFU
      KABDEGUKABEULAWOUMAWIUMUNAWGPPUPMZPWOWIABUQOWGUOURUFZOEBUSUTZAPWQOZWSWPWQ
      OPQUONOWSAVAPQVBVGZWTPPVCVDWTAKWGPPCDWOWRWTWTACWFOCWHOFABCESVEADWFODWHOGA
      BDESVEJKWJWNKRZCNZXADNZUGWKXATWLXBWMXCWKXACVFWKXADVFVHVIVJAWPPWIVKURVLNZX
      DVMMZXDWIXEXDVNMOAHIXDXDVOZVSVPWPXEVQNTAXDXFVTVPPXDVQNTAVRVPWAWBWCABWEESW
      D $.
  $}

  ${
    $d v x y z C $.  $d x y z P $.  $d x y z X $.  $d v x y z ph $.
    rrvmulc.1 $e |- ( ph -> P e. Prob ) $.
    rrvmulc.2 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.
    rrvmulc.3 $e |- ( ph -> C e. RR ) $.
    $( A random variable multiplied by a constant is a random variable.
       (Contributed by Thierry Arnoux, 17-Jan-2017.)  (Revised by Thierry
       Arnoux, 22-May-2017.) $)
    rrvmulc $p |- ( ph -> ( X oFC x. C ) e. ( rRndVar ` P ) ) $=
      ( vx cmul co cfv wcel cbrsiga cr cuni cvv csiga crn syl rrvmbfm cofc crrv
      cdm cmbfm cv cmpt ccom cprb domprobsiga uniexg ofcfval4 brsigarn elrnsiga
      rrvvf mp1i mpbid cioo ctg eqid rmulccn csigagen wceq df-brsiga a1i cnmbfm
      mbfmco eqeltrd mpbird ) ADBIUAJZCUBKZLVICUCZMUDJZLAVIHNHUEBIJUFZDUGVLAHVK
      OZNBIDPNACDEFUNAVKQROZLZVNPLACUHLVPECUISZVKVOUJSGUKAVKMMDVMVQMNQKLMVOLAUL
      MNUMUOZVRADVJLDVLLFACDETUPAMMVMUQRURKZVSAHBVSVSUSGUTMVSVAKVBAVCVDZVTVEVFV
      GACVIETVH $.
  $}

  ${
    $d k n P $.  $d k N $.  $d k n X $.  $d k n ph $.
    rrvsum.1 $e |- ( ph -> P e. Prob ) $.
    rrvsum.2 $e |- ( ph -> X : NN --> ( rRndVar ` P ) ) $.
    rrvsum.3 $e |- ( ( ph /\ N e. NN ) -> S = ( seq 1 ( oF + , X ) ` N ) ) $.
    $( An indexed sum of random variables is a random variable.  (Contributed
       by Thierry Arnoux, 22-May-2017.) $)
    rrvsum $p |- ( ( ph /\ N e. NN ) -> S e. ( rRndVar ` P ) ) $=
      ( vk vn cn wcel wa c1 cfv wi wceq fveq2 eleq1d imbi2d caddc cof cseq crrv
      cv co cz 1z seq1 ax-mp 1nn ffvelrnda mpan2 syl5eqel cuz seqp1 nnuz eleq2s
      ad2antlr cprb ad2antrr simpr peano2nn sylan2 adantr rrvadd eqeltrd expcom
      ex a2d nnind impcom ) ADKLZMCDUAUBZENUCZOZBUDOZHVMAVPVQLZAIUEZVOOZVQLZPAN
      VOOZVQLZPAJUEZVOOZVQLZPAWDNUAUFZVOOZVQLZPAVRPIJDVSNQZWAWCAWJVTWBVQVSNVORS
      TVSWDQZWAWFAWKVTWEVQVSWDVORSTVSWGQZWAWIAWLVTWHVQVSWGVORSTVSDQZWAVRAWMVTVP
      VQVSDVORSTAWBNEOZVQNUGLWBWNQUHVNENUIUJANKLWNVQLUKAKVQNEGULUMUNWDKLZAWFWIA
      WOWFWIPAWOMZWFWIWPWFMZWHWEWGEOZVNUFZVQWOWHWSQZAWFWTWDNUOOKVNENWDUPUQURUSW
      QBWEWRABUTLWOWFFVAWPWFVBWPWRVQLZWFWOAWGKLXAWDVCAKVQWGEGULVDVEVFVGVIVHVJVK
      VLVG $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Preimage set mapping operator
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c oRVC $. $( A small o with RV/C subscript $)

  $( Extend class notation to include the preimage set mapping operator. $)
  corvc $a class oRVC R $.

  ${
    $d a x y R $.
    $( Define the preimage set mapping operator.  In probability theory, the
       notation ` P ( X = A ) ` denotes the probability that a random variable
       ` X ` takes the value ` A ` .  We introduce here an operator which
       enables to write this in Metamath as ` ( P `` ( X oRVC _I A ) ) ` , and
       keep a similar notation.  Because with this notation ` ( X oRVC _I A ) `
       is a set, we can also apply it to conditional probabilities, like in
       ` ( P `` ( X oRVC _I A ) | ( Y oRVC _I B ) ) ) ` .

       The oRVC operator transforms a relation ` R ` into an operation taking a
       random variable ` X ` and a constant ` C ` , and returning the preimage
       through ` X ` of the equivalence class of ` C ` .

       The most commonly used relations are: - equality: ` { X = A } ` as
       ` ( X oRVC _I A ) ` cf. ~ ideq - elementhood: ` { X e. A } ` as
       ` ( X oRVC _E A ) ` cf. ~ epel - less-than: ` { X <_ A } ` as
       ` ( X oRVC <_ A ) `

       Even though it is primarily designed to be used within probability
       theory and with random variables, this operator is defined on generic
       functions, and could be used in other fields, e.g. for continuous
       functions.  (Contributed by Thierry Arnoux, 15-Jan-2017.) $)
    df-orvc $a |- oRVC R =
             ( x e. { x | Fun x } , a e. _V |-> ( `' x " { y | y R a } ) ) $.
  $}

  ${
    $d a x y A $.  $d a x y R $.  $d a x y X $.  $d a x ph $.
    orvcval.1 $e |- ( ph -> Fun X ) $.
    orvcval.2 $e |- ( ph -> X e. V ) $.
    orvcval.3 $e |- ( ph -> A e. W ) $.
    $( Value of the preimage mapping operator applied on a given random
       variable and constant (Contributed by Thierry Arnoux, 19-Jan-2017.) $)
    orvcval $p |- ( ph -> ( X oRVC R A ) = ( `' X " { y | y R A } ) ) $=
      ( vx va cv wfun cab cvv ccnv wbr wceq wcel cima corvc cmpt2 df-orvc simpl
      a1i wa cnveqd simpr breq2d abbidv imaeq12d adantl wb funeq elabg syl elex
      mpbird cnvexg imaexg 3syl ovmpt2d ) AKLGCKMZNZKOZPVDQZBMZLMZDRZBOZUAZGQZV
      HCDRZBOZUAZDUBZPVQKLVFPVLUCSAKBDLUDUFVDGSZVICSZUGZVLVPSAVTVGVMVKVOVTVDGVR
      VSUEUHVTVJVNBVTVICVHDVRVSUIUJUKULUMAGVFTZGNZHAGETZWAWBUNIVEWBKGEVDGUOUPUQ
      USACFTCPTJCFURUQAWCVMPTVPPTIGEUTVMVOPVAVBVC $.

    $d y z A $.  $d y z R $.  $d z X $.
    $( Another way to express the value of the preimage mapping operator
       (Contributed by Thierry Arnoux, 19-Jan-2017.) $)
    orvcval2 $p |- ( ph -> ( X oRVC R A ) = { z e. dom X | ( X ` z ) R A } ) $=
      ( vy corvc co ccnv cv wbr wcel crab wceq a1i cab cima cfv cdm orvcval wfn
      wfun funfn sylib fncnvima2 syl wb fvex breq1 elab rabbiia 3eqtrd ) AGCDLM
      GNKOZCDPZKUAZUBZBOZGUCZUTQZBGUDZRZVCCDPZBVERZAKCDEFGHIJUEAGVEUFZVAVFSAGUG
      VIHGUHUIBVEUTGUJUKVFVHSAVDVGBVEVDVGULVBVEQUSVGKVCVBGUMURVCCDUNUOTUPTUQ $.

    $( Elementhood of a preimage (Contributed by Thierry Arnoux,
       21-Jan-2017.) $)
    elorvc $p |- ( ( ph /\ z e. dom X ) ->
                              ( z e. ( X oRVC R A ) <-> ( X ` z ) R A ) ) $=
      ( cv corvc co wcel cdm cfv wbr crab wa orvcval2 eleq2d rabid syl6bb baibd
      ) ABKZGCDLMZNZUEGOZNZUEGPCDQZAUGUEUJBUHRZNUIUJSAUFUKUEABCDEFGHIJTUAUJBUHU
      BUCUD $.
  $}


  ${
    orvccel.1 $e |- ( ph -> S e. U. ran sigAlgebra ) $.
    orvccel.2 $e |- ( ph -> J e. Top ) $.
    orvccel.3 $e |- ( ph -> X e. ( S MblFnM ( sigaGen ` J ) ) ) $.
    orvccel.4 $e |- ( ph -> A e. V ) $.
    $d y A $.  $d y R $.  $d y X $.  $d y J $.
    $( The value of the preimage mapping operator can be restricted to
       preimages in the base set of the topology.  Cf. ~ orvcval (Contributed
       by Thierry Arnoux, 21-Jan-2017.) $)
    orvcval4 $p |- ( ph ->
                        ( X oRVC R A ) = ( `' X " { y e. U. J | y R A } ) ) $=
      ( cima cuni co wceq ctop wf wcel cvv ccnv wbr cab cin corvc crab wfun crn
      cv wss csigagen cfv sgsiga isanmbfm mbfmfun mbfmf eqidd elex unisg feq23d
      3syl mpbid frn syl fimacnvinrn2 syl2anc cmbfm orvcval a1i imaeq2d 3eqtr4d
      dfrab2 ) AHUAZBUICDUBZBUCZMZVMVOFNZUDZMZHCDUEOVMVNBVQUFZMAHUGHUHVQUJZVPVS
      PAHAEFUKULZHIAFQJUMZKUNUOZAENZVQHRZWAAWEWBNZHRWFAEWBHIWCKUPAWEWGWEVQHAWEU
      QAFQSFTSWGVQPJFQURFTUSVAUTVBWEVQHVCVDVOVQHVEVFABCDEWBVGOGHWDKLVHAVTVRVMVT
      VRPAVNBVQVLVIVJVK $.

    ${
      orvcoel.5 $e |- ( ph -> { y e. U. J | y R A } e. J ) $.
      $( If the relation produces open sets, preimage maps by a measurable
         function are measurable sets.  (Contributed by Thierry Arnoux,
         21-Jan-2017.) $)
      orvcoel $p |- ( ph -> ( X oRVC R A ) e. S ) $=
        ( corvc co ccnv cv wbr cuni ctop crab cima orvcval4 csigagen cfv sgsiga
        wcel wss sssigagen syl sseldd mbfmcnvima eqeltrd ) AHCDNOHPBQCDRBFSUAZU
        BEABCDEFGHIJKLUCAUNEFUDUEZHIAFTJUFKAFUOUNAFTUGFUOUHJFTUIUJMUKULUM $.
    $}

    ${
      orvccel.5 $e |- ( ph -> { y e. U. J | y R A } e. ( Clsd ` J ) ) $.
      $( If the relation produces closed sets, preimage maps by a measurable
         function are measurable sets.  (Contributed by Thierry Arnoux,
         21-Jan-2017.) $)
      orvccel $p |- ( ph -> ( X oRVC R A ) e. S ) $=
        ( corvc co ccnv cv wbr cfv ctop cuni crab cima orvcval4 csigagen sgsiga
        ccld wcel wss cldssbrsiga syl sseldd mbfmcnvima eqeltrd ) AHCDNOHPBQCDR
        BFUAUBZUCEABCDEFGHIJKLUDAUOEFUESZHIAFTJUFKAFUGSZUPUOAFTUHUQUPUIJFUJUKMU
        LUMUN $.
    $}
  $}

  ${
    orrvccel.1 $e |- ( ph -> P e. Prob ) $.
    orrvccel.2 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.

    $d z A $.  $d z R $.  $d z X $.
    orrvccel.4 $e |- ( ph -> A e. V ) $.
    $( Elementhood of a preimage for a real-valued random variable.
       (Contributed by Thierry Arnoux, 21-Jan-2017.) $)
    elorrvc $p |- ( ( ph /\ z e. U. dom P ) ->
                                 ( z e. ( X oRVC R A ) <-> ( X ` z ) R A ) ) $=
      ( cv cdm cuni wcel wa corvc co cfv wbr syl rrvdm eleq2d biimprd imdistani
      wb crrv wfn wfun rrvfn fnfun elorvc ) ABKZDLMZNZOAULGLZNZOULGCEPQNULGRCES
      UEAUNUPAUPUNAUOUMULADGHIUAUBUCUDABCEDUFRFGAGUMUGGUHADGHIUIUMGUJTIJUKT $.

    $d y A $.  $d y R $.  $d y X $.
    $( The value of the preimage mapping operator can be restricted to
       preimages of subsets of RR. (Contributed by Thierry Arnoux,
       21-Jan-2017.) $)
    orrvcval4 $p |- ( ph ->
                          ( X oRVC R A ) = ( `' X " { y e. RR | y R A } ) ) $=
      ( co crn cfv cuni crab cima cr wcel cbrsiga cmbfm corvc ccnv wbr cioo ctg
      cdm cprb csiga domprobsiga syl ctop retop a1i csigagen crrv rrvmbfm mpbid
      cv df-brsiga oveq2i syl6eleq orvcval4 wceq uniretop rabeq imaeq2i syl6eqr
      ax-mp ) AGCEUAKGUBZBURCEUCZBUDLUEMZNZOZPVIVJBQOZPABCEDUFZVKFGADUGRVOUHLNR
      HDUIUJVKUKRAULUMAGVOSTKZVOVKUNMZTKAGDUOMRGVPRIADGHUPUQSVQVOTUSUTVAJVBVNVM
      VIQVLVCVNVMVCVDVJBQVLVEVHVFVG $.

    ${
      orrvcoel.5 $e |- ( ph ->
                              { y e. RR | y R A } e. ( topGen ` ran (,) ) ) $.
      $( If the relation produces open sets, preimage maps of a random variable
         are measurable sets.  (Contributed by Thierry Arnoux, 21-Jan-2017.) $)
      orrvcoel $p |- ( ph -> ( X oRVC R A ) e. dom P ) $=
        ( crn cfv wcel cuni cbrsiga cmbfm co crab cr cdm cioo csiga domprobsiga
        ctg cprb syl ctop retop a1i csigagen crrv rrvmbfm mpbid oveq2i syl6eleq
        df-brsiga cv wbr wceq uniretop rabeq ax-mp syl5eqelr orvcoel ) ABCEDUAZ
        UBLUEMZFGADUFNVFUCLONHDUDUGVGUHNAUIUJAGVFPQRZVFVGUKMZQRAGDULMNGVHNIADGH
        UMUNPVIVFQUQUOUPJABURCEUSZBVGOZSZVJBTSZVGTVKUTVMVLUTVAVJBTVKVBVCKVDVE
        $.
    $}

    ${
      orrvccel.5 $e |- ( ph ->
                   { y e. RR | y R A } e. ( Clsd ` ( topGen ` ran (,) ) ) ) $.
      $( If the relation produces closed sets, preimage maps are measurable
         sets.  (Contributed by Thierry Arnoux, 21-Jan-2017.) $)
      orrvccel $p |- ( ph -> ( X oRVC R A ) e. dom P ) $=
        ( crn cfv wcel cuni cbrsiga cmbfm co crab cr cdm cioo csiga domprobsiga
        ctg cprb syl ctop retop a1i csigagen crrv rrvmbfm mpbid oveq2i syl6eleq
        df-brsiga cv wbr ccld wceq uniretop rabeq ax-mp syl5eqelr orvccel ) ABC
        EDUAZUBLUEMZFGADUFNVGUCLONHDUDUGVHUHNAUIUJAGVGPQRZVGVHUKMZQRAGDULMNGVIN
        IADGHUMUNPVJVGQUQUOUPJABURCEUSZBVHOZSZVKBTSZVHUTMTVLVAVNVMVAVBVKBTVLVCV
        DKVEVF $.
    $}
  $}

  ${
    $d x A $.  $d x X $.  $d x ph $.
    orvcgteel.1 $e |- ( ph -> P e. Prob ) $.
    orvcgteel.2 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.
    orvcgteel.3 $e |- ( ph -> A e. RR ) $.
    $( Preimage maps produced by the "greater than or equal" relation are
       measurable sets.  (Contributed by Thierry Arnoux, 5-Feb-2017.) $)
    orvcgteel $p |- ( ph -> ( X oRVC `' <_ A ) e. dom P ) $=
      ( vx cle cr wbr crab cpnf cfv wa cxr wcel adantr ad2antrl jca ccnv cv crn
      cico co cioo ctg ccld clt simpr brcnvg syl2anc pm5.32da rexr simprr ltpnf
      simprl simprrl simprrr xrre3 syl22anc impbida bitrd rabbidva2 rexrd pnfxr
      wb wceq icoval sylancl eqtr4d icopnfcld syl eqeltrd orrvccel ) AHBCIUAZJD
      EFGAHUBZBVPKZHJLZBMUDUEZUFUCUGNUHNZAVSBVQIKZVQMUIKZOZHPLZVTAVRWDHJPAVQJQZ
      VROWFWBOZVQPQZWDOZAWFVRWBAWFOWFBJQZVRWBVGAWFUJAWJWFGRVQBJJIUKULUMAWGWIAWG
      OZWHWDWFWHAWBVQUNSWKWBWCAWFWBUOWFWCAWBVQUPSTTAWIOZWFWBWLWHWJWBWCWFAWHWDUQ
      AWJWIGRAWHWBWCURZAWHWBWCUSVQBUTVAWMTVBVCVDABPQMPQVTWEVHABGVEVFHBMVIVJVKAW
      JVTWAQGBVLVMVNVO $.
  $}


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Distribution Functions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    dstrvprob.1 $e |- ( ph -> P e. Prob ) $.
    dstrvprob.2 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.

    ${
      $d a x A $.  $d a P $.  $d a x X $.  $d a x ph $.
      orvcelel.1 $e |- ( ph -> A e. BrSiga ) $.
      $( Preimage maps produced by the "elementhood" relation (Contributed by
         Thierry Arnoux, 6-Feb-2017.) $)
      orvcelval $p |- ( ph -> ( X oRVC _E A ) = ( `' X " A ) ) $=
        ( vx cep corvc co ccnv cv cr crab cima cbrsiga wcel syl wceq wbr cin wb
        orrvcval4 epelg rabbidv a1i wss cuni elssuni unibrsiga syl6sseq sseqin2
        dfin5 sylib 3eqtr2d imaeq2d eqtrd ) ADBIJKDLZHMZBIUAZHNOZPUSBPAHBCIQDEF
        GUDAVBBUSAVBUTBRZHNOZNBUBZBAVAVCHNABQRZVAVCUCGUTBQUESUFVEVDTAHNBUNUGABN
        UHZVEBTAVFVGGVFBQUINBQUJUKULSBNUMUOUPUQUR $.

      $( Preimage maps produced by the "elementhood" relation are measurable
         sets.  (Contributed by Thierry Arnoux, 5-Feb-2017.) $)
      orvcelel $p |- ( ph -> ( X oRVC _E A ) e. dom P ) $=
        ( va cep corvc co ccnv cima cdm orvcelval wcel cbrsiga wral rrvfinvima
        cv wceq wa simpr imaeq2d eleq1d rspcdv mpd eqeltrd ) ADBIJKDLZBMZCNZABC
        DEFGOAUIHTZMZUKPZHQRUJUKPZAHCDEFSAUNUOHBQGAULBUAZUBZUMUJUKUQULBUIAUPUCU
        DUEUFUGUH $.
    $}

    ${
      $d a P $.  $d a X $.
      dstrvprob.3 $e |- ( ph ->
                           D = ( a e. BrSiga |-> ( P ` ( X oRVC _E a ) ) ) ) $.
      ${
        $d a A $.
        dstrvval.1 $e |- ( ph -> A e. BrSiga ) $.
        $( The value of the distribution of a random variable.  (Contributed by
           Thierry Arnoux, 9-Feb-2017.) $)
        dstrvval $p |- ( ph -> ( D ` A ) = ( P ` ( `' X " A ) ) ) $=
          ( cfv cbrsiga cv cep corvc co cmpt ccnv wceq fveq2d cima fveq1d oveq2
          wcel eqid fvex fvmpt syl orvcelval 3eqtrd ) ABCKBFLEFMZNOZPZDKZQZKZEB
          ULPZDKZERBUAZDKABCUOIUBABLUDUPURSJFBUNURLUOUKBSUMUQDUKBEULUCTUOUEUQDU
          FUGUHAUQUSDABDEGHJUITUJ $.
      $}

      $d a x D $.  $d a x ph $.
      $( The distribution of a random variable is a probability law (TODO:
         could be shortened using ~ dstrvval ) (Contributed by Thierry Arnoux,
         10-Feb-2017.) $)
      dstrvprob $p |- ( ph -> D e. Prob ) $=
        ( wcel cfv c1 wceq cbrsiga cc0 c0 wa syl cr fveq2d eqtrd cmeas crn cuni
        vx cdm cprb cpnf cicc co wf cv com cdom wbr wdisj cesum wi cpw wral cep
        corvc adantr crrv simpr orvcelel prob01 syl2anc cxr cle rexrd elunitge0
        elunitrn elxrge0 sylanbrc fmpt3d oveq2d csiga brsigarn elrnsiga 0elsiga
        ccnv cima mp2b probvalrnd fvmptd orvcelval fveq2i probnul syl5eq 3eqtrd
        a1i ima0 ciun wfun ad2antrr ffun unipreima domprobmeas nfv nfdisj1 nfan
        rrvvf simplll simpllr elelpwi rrvfinvima r19.21bi ralrimi simprl simprr
        disjpreima measvuni syl112anc cmpt mp1i simplr sigaclcu syl3anc fvmpt2d
        ex dstrvval esumeq2d 3eqtr4d ralrimiva wb ismeas syl3anbrc dmeqd dmmptg
        w3a eleqtrrd measbasedom sylibr unieqd unibrsiga syl6eq fimacnv probtot
        baselsiga 1re elprob ) ABUAUBUCIZBUEZUCZBJZKLBUFIABUUCUAJZIUUBABMUAJZUU
        FAMNUGUHUIZBUJZOBJZNLZUDUKZULUMUNZEUULEUKZUOZPZUULUCZBJZUULUUNBJZEUPZLZ
        UQZUDMURZUSZBUUGIZAEMDUUNUTVAZUIZCJZUUHBHAUUNMIZPZUVHNKUHUIZIZUVHUUHIZU
        VJCUFIZUVGCUEZIUVLAUVNUVIFVBZUVJUUNCDUVPADCVCJIZUVIGVBAUVIVDVEUVGCVFVGZ
        UVLUVHVHINUVHVIUNUVMUVLUVHUVHVLVJUVHVKUVHVMVNQZVOAUUJDOUVFUIZCJZDWAZOWB
        ZCJZNAEOUVHUWAMBRHAUUNOLZPZUVGUVTCUWFUUNODUVFAUWEVDVPSOMIZAMRVQJIZMVQUB
        UCIZUWGVRMRVSZMVTWCWKZAUVTCFAOCDFGUWKVEWDWEAUVTUWCCAOCDFGUWKWFSAUWDOCJZ
        NUWCOCUWBWLWGAUVNUWLNLFCWHQWIWJAUVBUDUVCAUULUVCIZPZUUPUVAUWNUUPPZUWBUUQ
        WBZCJZUULUWBUUNWBZCJZEUPZUURUUTUWOUWQEUULUWRWMZCJZUWTUWODWNZUWQUXBLUWOU
        VOUCZRDUJZUXCAUXEUWMUUPACDFGXBZWOUXDRDWPQZUXCUWPUXACEUULDWQSQUWOCUVOUAJ
        IZUWRUVOIZEUULUSUUMEUULUWRUOZUXBUWTLUWOUVNUXHAUVNUWMUUPFWOZCWRQUWOUXIEU
        ULUWNUUPEUWNEWSUUMUUOEUUMEWSEUULUUNWTXAXAZUWOUUNUULIZUXIUWOUXMPZAUVIUXI
        AUWMUUPUXMXCZUXNUXMUWMUVIUWOUXMVDAUWMUUPUXMXDUUNUULMXEVGZAUXIEMAECDFGXF
        XGVGXTXHUWNUUMUUOXIZUWOUXCUUOUXJUXGUWNUUMUUOXJEUULUUNDXKVGEUULUWRUVOCXL
        XMTUWOUUQBCDEUXKAUVQUWMUUPGWOZABEMUVHXNZLUWMUUPHWOUWOUWIUWMUUMUUQMIUWHU
        WIUWOVRUWJXOAUWMUUPXPUXQUULMXQXRYAUWOUULUUSUWSEUXLUWOUUSUWSLZEUULUXLUWO
        UXMUXTUXNUUSUVHUWSUXNAUVIUUSUVHLUXOUXPAEMUVHBUVKHUVRXSVGUXNUVGUWRCUXNUU
        NCDUWOUVNUXMUXKVBUWOUVQUXMUXRVBUXPWFSTXTXHYBYCXTYDUWHUWIUVEUUIUUKUVDYJY
        EVRUWJUDEMBYFWCYGAUUCMUAAUUCUXSUEZMABUXSHYHAUVMEMUSUYAMLAUVMEMUVSYDEMUV
        HUUHYIQTZSYKBYLYMAUUERBJKAUUDRBAUUDMUCRAUUCMUYBYNYOYPSAERUVHKMBRHAUUNRL
        ZPZUVHUWBRWBZCJZKUYDUVGUYECUYDUVGDRUVFUIZUYEUYDUUNRDUVFAUYCVDVPAUYGUYEL
        UYCARCDFGUWHRMIAVRRMYSXOZWFVBTSAUYFKLUYCAUYFUXDCJZKAUYEUXDCAUXEUYEUXDLU
        XFUXDRDYQQSAUVNUYIKLFCYRQTVBTUYHKRIAYTWKWETBUUAVN $.
    $}
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Cumulative Distribution Functions
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    dstfrv.1 $e |- ( ph -> P e. Prob ) $.
    dstfrv.2 $e |- ( ph -> X e. ( rRndVar ` P ) ) $.

    ${
      $d x A $.  $d x X $.  $d x ph $.
      orvclteel.1 $e |- ( ph -> A e. RR ) $.
      $( Preimage maps produced by the "lower than or equal" relation are
         measurable sets.  (Contributed by Thierry Arnoux, 4-Feb-2017.) $)
      orvclteel $p |- ( ph -> ( X oRVC <_ A ) e. dom P ) $=
        ( vx cle cr cv wbr crab cmnf cfv wa cxr wcel ad2antrl jca cioc cioo crn
        co ctg ccld clt rexr simprr simprl adantr simprrl simprrr xrre syl22anc
        mnflt impbida rabbidva2 mnfxr rexrd iocval sylancr eqtr4d iocmnfcld syl
        wceq eqeltrd orrvccel ) AHBCIJDEFGAHKZBILZHJMZNBUAUDZUBUCUEOUFOZAVKNVIU
        GLZVJPZHQMZVLAVJVOHJQAVIJRZVJPZVIQRZVOPZAVRPZVSVOVQVSAVJVIUHSWAVNVJVQVN
        AVJVIUPSAVQVJUITTAVTPZVQVJWBVSBJRZVNVJVQAVSVOUJAWCVTGUKAVSVNVJULAVSVNVJ
        UMZVIBUNUOWDTUQURANQRBQRVLVPVFUSABGUTHNBVAVBVCAWCVLVMRGBVDVEVGVH $.

      $d x B $.
      dstfrvel.1 $e |- ( ph -> B e. U. dom P ) $.
      dstfrvel.2 $e |- ( ph -> ( X ` B ) <_ A ) $.
      $( Elementhood of preimage maps produced by the "lower than or equal"
         relation.  (Contributed by Thierry Arnoux, 13-Feb-2017.) $)
      dstfrvel $p |- ( ph -> B e. ( X oRVC <_ A ) ) $=
        ( vx ccnv cv cle wbr cr crab wcel cdm eleqtrrd cima corvc co cuni rrvvf
        cfv ffvelrnd breq1 elrab sylanbrc wfun wb wf syl rrvdm fvimacnv syl2anc
        ffun mpbid orrvcval4 ) ACELKMZBNOZKPQZUAZEBNUBUCACEUFZVCRZCVDRZAVEPRVEB
        NOZVFADSUDZPCEADEFGUEZIUGJVBVHKVEPVAVEBNUHUIUJAEUKZCESZRVFVGULAVIPEUMVK
        VJVIPEURUNACVIVLIADEFGUOTCVCEUPUQUSAKBDNPEFGHUTT $.
    $}

    ${
      $d n x P $.  $d n x X $.  $d n x ph $.
      $( The limit of all preimage maps by the "lower than or equal" relation
         is the universe.  (Contributed by Thierry Arnoux, 12-Feb-2017.) $)
      dstfrvunirn $p |- ( ph ->
                         U. ran ( n e. NN |-> ( X oRVC <_ n ) ) = U. dom P ) $=
        ( cn cle co wcel wa cfv c1 wbr cr a1i syl2anc breq2 adantr simpr vx cdm
        cuni cv corvc ciun cmpt crn wrex clt cif cfl caddc rrvvf ffvelrnda ifcl
        1le1 wn lenltd biimpar ifbothda flge1nn peano2nnd cprb crrv nnred ltled
        1re leidd fllep1 syl letrd dstfrvel oveq2 eleq2d rspcev ex wi orvclteel
        wceq elunii expcom rexlimdva impbid eliun syl6bbr eqrdv dfiun3 syl6req
        ovex ) ABUBZUCZCGDCUDZHUEZIZUFZCGWOUGUHUCAUAWLWPAUAUDZWLJZWQWOJZCGUIZWQ
        WPJAWRWTAWRWTAWRKZWQDLZMUJNZMXBUKZULLZMUMIZGJWQDXFWNIZJZWTXAXEXAXDOJZMX
        DHNZXEGJXAMOJZXBOJZXIXKXAVHPZAWLOWQDABDEFUNUOZXCMXBOUPQZXCMMHNZMXBHNZXJ
        XAMXBMXDMHRXBXDMHRXPXAXCKZUQPXAXQXCURZXAMXBXMXNUSUTVAXDVBQVCZXAXFWQBDAB
        VDJZWRESADBVELJZWRFSXAXFXTVFZAWRTXAXBXDXFXNXOYCXCXBMHNXBXBHNZXBXDHNXAMX
        BMXDXBHRXBXDXBHRXRXBMXAXLXCXNSXKXRVHPXAXCTVGXAYDXSXAXBXNVISVAXAXIXDXFHN
        XOXDVJVKVLVMWSXHCXFGWMXFVTWOXGWQWMXFDWNVNVOVPQVQAWSWRCGAWMGJZKZWOWKJZWS
        WRVRYFWMBDAYAYEESAYBYEFSYFWMAYETVFVSWSYGWRWQWOWKWAWBVKWCWDCWQGWOWEWFWGC
        GWODWMWNWJWHWI $.
    $}

    ${
      $d x A $.  $d x B $.  $d x X $.  $d x ph $.
      orvclteinc.1 $e |- ( ph -> A e. RR ) $.
      orvclteinc.2 $e |- ( ph -> B e. RR ) $.
      orvclteinc.3 $e |- ( ph -> A <_ B ) $.
      $( Preimage maps produced by the "lower than or equal" relation are
         increasing.  (Contributed by Thierry Arnoux, 11-Feb-2017.) $)
      orvclteinc $p |- ( ph -> ( X oRVC <_ A ) C_ ( X oRVC <_ B ) ) $=
        ( vx cle wbr cr crab cima co wss wcel 3ad2ant1 ccnv cv corvc wfun rrvf2
        cdm wf ffun syl w3a simp2 simp3 letrd 3expia ss2rabdv syl2anc orrvcval4
        sspreima 3sstr4d ) AEUAZKUBZBLMZKNOZPZUTVACLMZKNOZPZEBLUCZQECVHQAEUDZVC
        VFRVDVGRAEUFZNEUGVIADEFGUEVJNEUHUIAVBVEKNAVANSZVBVEAVKVBUJVABCAVKVBUKAV
        KBNSVBHTAVKCNSVBITAVKVBULAVKBCLMVBJTUMUNUOVCVFEURUPAKBDLNEFGHUQAKCDLNEF
        GIUQUS $.
    $}

    dstfrv.3 $e |- ( ph -> F = ( x e. RR |-> ( P ` ( X oRVC <_ x ) ) ) ) $.
    ${
      $d x A $.  $d x B $.  $d x P $.  $d x X $.  $d x ph $.
      dstfrvinc.1 $e |- ( ph -> A e. RR ) $.
      dstfrvinc.2 $e |- ( ph -> B e. RR ) $.
      dstfrvinc.3 $e |- ( ph -> A <_ B ) $.
      $( A cumulative distribution function is non-decreasing.  (Contributed by
         Thierry Arnoux, 11-Feb-2017.) $)
      dstfrvinc $p |- ( ph -> ( F ` A ) <_ ( F ` B ) ) $=
        ( cle co cfv wcel orvclteel cr wceq corvc cdm cprb cmeas syl orvclteinc
        domprobmeas measssd cv wa simpr oveq2d fveq2d probvalrnd fvmptd 3brtr4d
        ) AGCNUAZOZEPZGDUQOZEPZCFPDFPNAURUTEUBZEAEUCQEVBUDPQHEUGUEACEGHIKRZADEG
        HILRZACDEGHIKLMUFUHABCGBUIZUQOZEPZUSSFSJAVECTZUJZVFUREVIVECGUQAVHUKULUM
        KAUREHVCUNUOABDVGVASFSJAVEDTZUJZVFUTEVKVEDGUQAVJUKULUMLAUTEHVDUNUOUP $.
    $}

    $d a i n x P $.  $d a i n x X $.  $d i F $.  $d a i n x ph $.
    $( The limit of the cumulative distribution function is one.  (Contributed
       by Thierry Arnoux, 12-Feb-2017.)  (Revised by Thierry Arnoux,
       11-Jul-2017.) $)
    dstfrvclim1 $p |- ( ph -> F ~~> 1 ) $=
      ( vi va c1 wbr cn cfv cmpt co cc0 cpnf wcel wceq vn cli cv cle corvc ccom
      crn cuni cxrs cicc cress ctopn clm cdm eqid cprb cmeas domprobmeas syl wa
      adantr simpr nnred orvclteel fmptd caddc peano2nnd lep1d orvclteinc eqidd
      crrv oveq2d fvmptd 3sstr4d meascnbl wf wfn measfn dffn5 biimpi 3syl sylan
      prob01 fmpt3d fco syl2anc dstfrvunirn unveldomd eqeltrd cxr clt wss pnfxr
      cico 0xr 0le0 cr ltpnf ax-mp iccssico mp4an lmlimxrge0 mpbid fveq2 fmptco
      1re fveq2d probvalrnd mpteq2dva eqtr4d probtot eqtrd 3brtr3d cz cvv wb 1z
      reex mptex syl6eqel nnuz climmpt sylancr mpbird ) ADKUBLZIMIUCZDNZOZKUBLZ
      ACIMEYFUDUEZPZOZUFZYLUGUHZCNZYHKUBAYMYOUIQRUJPUKPULNZUMNLYMYOUBLACUNZUAYL
      YPCYPUOZACUPSZCYQUQNSZFCURUSZAIMYKYQYLAYFMSZUTZYFCEAYSUUBFVAZAECVKNSZUUBG
      VAUUCYFAUUBVBVCZVDZYLUOVEZAUAUCZMSZUTZEUUIYJPZEUUIKVFPZYJPZUUIYLNUUMYLNUU
      KUUIUUMCEAYSUUJFVAZAUUEUUJGVAZUUKUUIAUUJVBZVCZUUKUUMUUKUUIUUQVGZVCZUUKUUI
      UURVHVIUUKIUUIYKUULMYLYQUUKYLVJZUUKYFUUITZUTYFUUIEYJUUKUVBVBVLUUQUUKUUICE
      UUOUUPUURVDVMUUKIUUMYKUUNMYLYQUVAUUKYFUUMTZUTYFUUMEYJUUKUVCVBVLUUSUUKUUMC
      EUUOUUPUUTVDVMVNVOAYOYMYPQKUJPZYRAYQUVDCVPMYQYLVPMUVDYMVPAJYQJUCZCNZUVDCA
      YTCYQVQZCJYQUVFOTZUUAYQCVRUVGUVHJYQCVSVTWAZAYSUVEYQSUVFUVDSFUVECWCWBWDUUH
      MYQUVDCYLWEWFAYSYNYQSYOUVDSFAYNYQUHZYQACIEFGWGZACFWHWIYNCWCWFQWJSRWJSQQUD
      LKRWKLZUVDQRWNPWLWOWMWPKWQSUVLXFKWRWSQRQKWTXAXBXCAYMIMYKCNZOYHAIJMYQYKUVF
      UVMYLCUUGAYLVJUVIUVEYKCXDXEAIMYGUVMUUCBYFEBUCZYJPZCNZUVMWQDWQADBWQUVPOZTU
      UBHVAUUCUVNYFTZUTZUVOYKCUVSUVNYFEYJUUCUVRVBVLXGUUFUUCYKCUUDUUGXHVMXIXJAYO
      UVJCNZKAYNUVJCUVKXGAYSUVTKTFCXKUSXLXMAKXNSDXOSYEYIXPXQADUVQXOHBWQUVPXRXSX
      TKIDYHKXOMYAYHUOYBYCYD $.

    $( The limit at minus infinity of the cumulative distribution function is
       zero. $)
    $( dstfrvclim0 #p |- ( ph -> ( x e. RR |-> ( F ` -u x ) ) ~~> 0 ) $=
      $. $)
  $}

$(

@(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Expected Value
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
@)

  @c Exp @. @( Symbol for the expected value, 'exp' @)

  cexpt @a class Exp @.

  @( Define the expected value of a random variable as the integral of the
     variable, over the entire probability space. An expected value is defined
     with respect to a given probability measure ` p ` .
     (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
  df-expt @a |- Exp = ( p e. Prob |->
    ( x e. ( rRndVar ` p ) |-> S.m U. dom p x _d p ) ) @.

  @{
    @d p x P @. @d p x ph @. @d x X @.
    exptval.1 @e |- ( ph -> P e. Prob ) @.
    exptval.2 @e |- ( ph -> E = ( Exp ` P ) ) @.
    @{
      exptval.3 @e |- ( ph -> X e. ( rRndVar ` P ) ) @.
      @( Expected value with respect to probability measure ` P ` .
         (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
      exptval   @p |- ( ph -> ( E ` X ) =  S.m U. dom P X _d P ) @=
        ( vx vp cdm cuni cv citgm crrv cfv cexpt cmpt cvv wceq eqidd cr df-expt
        cprb a1i wa simpr fveq2d dmeqd unieqd itgmeq123dTMP mpteq12dv wcel fvex
        mptexg mp1i fvmptd eqtrd probmeasd rrvf2 rrvdmss probtotrnd itgmclrdTMP
        unveldomd ) AHDBJZKZHLZBMZVEDBMBNOZCUAACBPOHVHVGQZFAIBHILZNOZVJJZKZVFVJ
        MZQZVIUCPRPIUCVOQSAHIUBUDAVJBSZUEZHVKVNVHVGVQVJBNAVPUFZUGVQVMVEBVFVFVJV
        QVLVDVQVJBVRUHUIVQVFTVRUJUKEVHRULVIRULABNUMHVHVGRUNUOUPUQAVFDSZUEZVEVEB
        VFDBVTVETAVSUFVTBTUJGAVEDBABEURABDEGUSABDEGUTABEVCABEVAVBUP @.

      @( Expected values are real numbers.
         (Contributed by Thierry Arnoux, 20-Jan-2017.) @)
      exptvrn   @p |- ( ph -> ( E ` X ) e. RR ) @=
        ( cfv cdm citgm cr exptval probmeasd rrvf2 rrvdmss unveldomd probvalrnd
        cuni itgmclrdTMP eqeltrd ) ADCHBIRZDBJKABCDEFGLAUADBABEMABDEGNABDEGOABE
        PZAUABEUBQST @.
    @}

    @{
      exptind.1 @e |- ( ph -> A e. dom P ) @.
      @( The expected value of the indicator function of the set ` A `
         is the probability of ` A ` .
         (Contributed by Thierry Arnoux, 20-Jan-2017.) @)
      exptind   @p |- ( ph -> ( E ` ( U. dom P _Ind A ) ) = ( P ` A ) ) @=
        ( cfv citgm cun wcel wceq syl co cc0 c0 a1i cres cuni cdif crrv syl2anc
        cdm cind cprb indrrv fveq1d eleq1d mpbird exptval wss undif itgmeq1dTMP
        elssuni sylib cxad cin disjdif itgmunTMP c1 csn cxp itgmresTMP unveldom
        cmul indval2 eqtrd reseq1d resundir ssid xpssres ax-mp eqeq1i xpdisjres
        incom mpbi uneq12i un0 3eqtri syl6eq itgmeq2dTMP 3eqtr3rd cr probvalrnd
        inidm 1re itgmcst recnd mulid2 3eqtrd uncom eqtri csiga crn domprobsiga
        cc difelsiga syl3anc 0re mul02 oveq12d cxr rexrd xaddid1 3eqtr2d ) ABEJ
        ZDJCUEZUAZXHCKBXJBUBZLZXHCKZBCJZACDXHFGAXHCUCJZMBXJUFJZJZXOMZACUGMZBXIM
        ZXRFHBCUHUDAXHXQXOABEXPIUIZUJUKULAXLXJXHCABXJUMZXLXJNAXTYBHBXIUPOZBXJUN
        UQUOAXMBXHCKZXKXHCKZURPXNQURPZXNABXKXHCBXKUSZRNZABXJUTZSVAAYDXNYEQURAYD
        BBVBVCZVDZCKZVBXNVGPZXNABXHBTZCKZBBUSZXHCKZYLYDYOYQNABBXHCVESABYNYKCAYN
        YKXKQVCZVDZLZBTZYKAXHYTBAXHXQYTYAAXJXIMZYBXQYTNAXSUUBFCVFOZYCBXJXIVHUDV
        IZVJUUAYKBTZYSBTZLYKRLYKYKYSBVKUUEYKUUFRBBUMZUUEYKNBVLZBYJBVMVNXKBUSZRN
        ZUUFRNYHUUJYIYGUUIRBXKVQVOVRXKYRBVPVNVSYKVTWAWBWCAYPBXHCYPBNABWGSUOWDAB
        BVBCHUUGAUUHSVBWEMAWHSABCFHWFZWIAXNWRMYMXNNAXNUUKWJXNWKOWLAYEXKYSCKZQXK
        CJZVGPZQAXKXHXKTZCKZXKXKUSZXHCKZUULYEUUPUURNAXKXKXHCVESAXKUUOYSCAUUOYTX
        KTZYSAXHYTXKUUDVJUUSYKXKTZYSXKTZLRYSLZYSYKYSXKVKUUTRUVAYSYHUUTRNYIBYJXK
        VPVNXKXKUMZUVAYSNXKVLZXKYRXKVMVNVSUVBYSRLYSRYSWMYSVTWNWAWBWCAUUQXKXHCUU
        QXKNAXKWGSUOWDAXKXKQCAXIWOWPUAMZUUBXTXKXIMAXSUVEFCWQOUUCHXJBXIWSWTZUVCA
        UVDSQWEMAXASAXKCFUVFWFZWIAUUMWRMUUNQNAUUMUVGWJUUMXBOWLXCAXNXDMYFXNNAXNU
        UKXEXNXFOWLXG @.
    @}

    expt.3 @e |- ( ph -> X e. ( rRndVar ` P ) ) @.
    @{
      exptmulc.1 @e |- ( ph -> C e. RR ) @.
      @( The expected value of a random variable multiplied by a constant.
         (Contributed by Thierry Arnoux, 16-Jan-2017.) @)
      exptmulc   @p |- ( ph -> ( E ` ( X oFC x. C ) ) = ( ( E ` X ) x. C ) ) @=
        ( cdm cuni cmul cofc co citgm cfv probmeasd rrvf2 rrvdmss exptval
        unveldomd probtotrnd itgmmulc2TMP rrvmulc oveq1d 3eqtr4d ) ACJKZEBLMNZC
        OUGECOZBLNUHDPEDPZBLNAUGBECACFQACEFHRACEFHSACFUAACFUBIUCACDUHFGABCEFHIU
        DTAUJUIBLACDEFGHTUEUF @.
    @}

    @{
      exptadd.1 @e |- ( ph -> Y e. ( rRndVar ` P ) ) @.
      @( The sum of expected values is the expected value of the sum.
         (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
      exptadd   @p |- ( ph ->
                          ( E ` ( X oF + Y ) ) = ( ( E ` X ) + ( E ` Y ) ) ) @=
        ( cdm cuni caddc cof co citgm cfv probmeasd rrvf2 rrvdmss exptval
        unveldomd probtotrnd itgmaddTMP rrvadd oveq12d 3eqtr4d ) ABJKZDELMNZBOU
        GDBOZUGEBOZLNUHCPDCPZECPZLNAUGDEBABFQABDFHRABEFIRABDFHSABEFISABFUAABFUB
        UCABCUHFGABDEFHIUDTAUKUIULUJLABCDFGHTABCEFGITUEUF @.

      exptle.1 @e |- ( ph -> X oR <_ Y ) @.
      @( If two random variables compare, so do their expected values.
         (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
      exptle   @p |- ( ph -> ( E ` X ) <_ ( E ` Y ) ) @=
        ( cdm cuni citgm cfv cle cofr wbr itgmleTMP syl exptval 3brtr4d ) ABKLZ
        DBMZUBEBMZDCNECNOADEOPQUCUDOQJUBDEBRSABCDFGHTABCEFGITUA @.
    @}

    @{
      @d b x A @. @d b I @. @d b p x P @. @d b x X @. @d b p x ph @.
      markovneq.1 @e |- ( ph -> A e. RR+ ) @.
      markovneq.2 @e |- ( ( ph /\ b e. U. dom P ) -> 0 <_ ( X ` b ) ) @.
      markovneq.3 @e |- ( ph -> ( E ` X ) e. RR ) @.
      @{
        @( Lemma for Markov's Inequality
           (Contributed by Thierry Arnoux, 21-Jan-2017.)
           (Revised by Thierry Arnoux, 4-Feb-2017.) @)
        markovneqlem   @p |- ( ph ->
                 ( ( U. dom P _Ind ( X oRVC `' <_ A ) ) oFC x. A ) oR <_ X ) @=
          ( cle cmul wcel cc0 cvv cr ccnv corvc co cfv cofc cofr wbr cv cif cdm
          cuni wral wa crp elorrvc ifbid wn wo exmid a1i pm4.24 wb rpred brcnvg
          fvex sylancr adantr anbi2d syl5bb biantrud orbi12d mpbid breq1 elimif
          sylibr ralrimiva crrv cind cprb orvcgteel indrrv fveq1d eleq1d mpbird
          eqbrtrd syl2anc rrvfn csiga domprobsiga elex uniexb sylib ofcfn inidm
          crn 3syl c1 cmpt wss wceq elssuni syl indval eqtrd 1re ifclda fvmpt2d
          0re ofcval ovif rpcnd mulid2d mul02d ifeq12d syl5eq eqidd ofrfval ) A
          FBOUAZUBUCZEUDZBPUEUCZFOUFUGGUHZXSQZBRUIZYBFUDZOUGZGCUJZUKZULAYFGYHAY
          BYHQZUMZYDYEBXRUGZBRUIZYEOYJYCYKBRAGBCXRUNFHJKUOUPYJYKBYEOUGZUMZYKUQZ
          RYEOUGZUMZURZYLYEOUGZYJYKYOURZYRYTYJYKUSUTYJYKYNYOYQYKYKYKUMYJYNYKVAY
          JYKYMYKAYKYMVBZYIAYESQBTQUUAYBFVEABKVCZYEBSTOVDVFVGVHVIYJYPYOLVJVKVLY
          KYSYMYPBRYLBYEOVMYLRYEOVMVNVOWEVPAGYHYHYDYEOYHYAFSSAYHBPXTSTACXTHAXTC
          VQUDZQXSYHVRUDZUDZUUCQZACVSQZXSYGQZUUFHABCFHJUUBVTZXSCWAWFAXTUUEUUCAX
          SEUUDNWBZWCWDWGZAYGSQZYHSQZAUUGYGWHWOUKZQUULHCWIYGUUNWJWPYGWKWLZUUBWM
          ACFHJWGUUOUUOYHWNYJYBYAUDYCWQRUIZBPUCZYDAYHUUPBPXTSTYBUUKUUOUUBAGYHUU
          PXTTAXTUUEGYHUUPWRZUUJAUUMXSYHWSZUUEUURWTUUOAUUHUUSUUIXSYGXAXBGXSYHSX
          CWFXDAUUPTQYIAYCWQRTWQTQAYCUMXEUTRTQAYCUQUMXHUTXFVGXGXIAUUQYDWTYIAUUQ
          YCWQBPUCZRBPUCZUIYDYCWQRBPXJAYCUUTBUVARABABKXKZXLABUVBXMXNXOVGXDYJYEX
          PXQWD @.
      @}

      @( Markov's Inequality
         (Contributed by Thierry Arnoux, 21-Jan-2017.)
         (Revised by Thierry Arnoux, 4-Feb-2017.) @)
      markovneq   @p |- ( ph ->
                         ( P ` ( X oRVC `' <_ A ) ) <_ ( ( E `  X ) / A ) ) @=
        ( vx cle co cfv cmul wbr cr wcel ccnv corvc cdiv cpnf cico cv crab cioo
        rpred crn ctg ccld wb wal wceq wa elicopnf brcnvg expcom pm5.32d bitr4d
        syl rabid syl6bbr alrimiv nfcv nfrab1 cleqf icopnfcld eqeltrrd orrvccel
        sylibr probvalrnd remulcld cuni cind cofc cprb orvcgteel indrrv syl2anc
        crrv exptmulc eqidd exptind oveq1d rrvmulc markovneqlem exptle eqbrtrrd
        cdm eqtrd lediv1dd recnd rpne0d divcan4d breq1d mpbid ) AEBNUAZUBOZCPZB
        QOZBUCOZEDPZBUCOZNRXAXENRAXBXDBAXABAWTCGAMBCWSSEGIABJUIZABUDUEOZMUFZBWS
        RZMSUGZUHUJUKPULPZAXHXGTZXHXJTZUMZMUNXGXJUOAXNMAXLXHSTZXIUPZXMAXLXOBXHN
        RZUPZXPABSTZXLXRUMXFBXHUQVBAXSXPXRUMXFXSXOXIXQXOXSXIXQUMXHBSSNURUSUTVBV
        AXIMSVCVDVEMXGXJMXGVFXIMSVGVHVLAXSXGXKTXFBVIVBVJVKZVMZXFVNLJAWTCWKZVOVP
        PZPZBQVQOZDPZXBXDNAYFYDDPZBQOXBABCDYDGHACVRTWTYBTYDCWBPTGABCEGIXFVSWTCV
        TWAZXFWCAYGXABQAWTCDYCGHXTAYCWDZWEWFWLACDYEEGHABCYDGYHXFWGIABCDYCEFGHIJ
        KLYIWHWIWJWMAXCXAXENAXABAXAYAWNABXFWNABJWOWPWQWR @.
    @}

  @}

  @{
    exptsum.1 @e |- ( ph -> P e. Prob ) @.
    exptsum.2 @e |- ( ph -> E = ( Exp ` P ) ) @.
    exptsum.3 @e |- ( ph -> X : NN --> ( rRndVar ` P ) ) @.
    exptsum.4 @e |- ( ( ph /\ N e. NN ) -> S = ( seq 1 ( oF + , X ) ` N ) ) @.
    @( The expected value of an indexed sum of random variables is the sum
       of the expected values. (Contributed by Thierry Arnoux, XX-May-2017.) @)
    exptsum @p |- ( ( ph /\ N e. NN ) ->
                       ( E ` S ) = sum_ i e. ( 1 ... N ) ( E ` ( X ` i ) ) ) @=
      ? @.
  @}

@(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Variance and Covariance
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
@)

  @c Var @. @( Symbol for the variance, 'var' @)
  @c Cov @. @( Symbol for the covariance, 'cov' @)

  cvar @a class Var @.
  ccov @a class Cov @.

  @( Define the variance of a random variable.
     (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
  df-var @a |- Var = ( p e. Prob |-> ( x e. ( rRndVar ` p ) |-> ( ( Exp ` p ) `
  ( ( x oFC - ( ( Exp ` p ) ` x ) ) oFC ^ 2 ) ) ) ) @.

  @( Define the covariance of two random variables.
     (Contributed by Thierry Arnoux, 18-May-2017.) @)
  df-cov @a |- Cov = ( p e. Prob |->
    ( x e. ( rRndVar ` p ) , y e. ( rRndVar ` p ) |-> ( ( Exp ` p ) `
    ( ( x oFC - ( ( Exp ` p ) ` x ) ) oFC x. ( y oFC - ( ( Exp ` p ) ` y ) ) )
    ) ) ) @.

  @{
    @d p x E @. @d p x P @. @d p x ph @. @d x X @.
    varval.1 @e |- ( ph -> P e. Prob ) @.
    varval.2 @e |- ( ph -> E = ( Exp ` P ) ) @.
    varval.3 @e |- ( ph -> V = ( Var ` P ) ) @.
    varval.4 @e |- ( ph -> X e. ( rRndVar ` P ) ) @.
    @( Value of the variance of the random variable ` X ` .
       (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
    varval   @p |- ( ph -> ( V ` X ) =
      ( E ` ( ( X oFC - ( E ` X ) ) oFC ^ 2 ) ) ) @=
      ( vx vp cfv co c2 crrv cvv cvar cmpt wceq fveq2d cmin cofc cexp
      cv cexpt cprb df-var a1i wa adantr eqtr4d fveq1d oveq2d oveq1d
      simpr fveq12d mpteq12dv wcel fvex mptexg fvmptd eqtrd oveq12d
      syl ) AJEJUDZVECLZUAUBZMZNUCUBZMZCLZEECLZVGMZNVIMZCLZBOLZDPADBQ
      LJVPVKRZHAKBJKUDZOLZVEVEVRUELZLZVGMZNVIMZVTLZRZVQUFQPQKUFWERSAJ
      KUGUHAVRBSZUIZJVSWDVPVKWGVRBOAWFUOZTWGWCVJVTCWGVTBUELZCWGVRBUEW
      HTACWISWFGUJUKZWGWBVHNVIWGWAVFVEVGWGVEVTCWJULUMUNUPUQFAVPPURZVQ
      PURWKABOUSUHJVPVKPUTVDVAVBAVEESZUIZVJVNCWMVHVMNVIWMVEEVFVLVGAWL
      UOZWMVEECWNTVCUNTIVOPURAVNCUSUHVA @.

    @( Variances are real numbers.
       (Contributed by Thierry Arnoux, 18-May-2017.) @)
    varvrn   @p |- ( ph -> ( V ` X ) e. RR ) @=
      ? @.

    @( Variances are non-negative.
       (Contributed by Thierry Arnoux, 18-May-2017.) @)
    varge0   @p |- ( ph -> 0 <_ ( V ` X ) ) @=
      ? @.

    @{
      @d b x A @. @d b I @. @d b p x P @. @d b x X @. @d b p x ph @.
      chebneq.1 @e |- ( ph -> A e. RR+ ) @.
      chebneq.2 @e |- ( ( ph /\ b e. U. dom P ) -> 0 <_ ( X ` b ) ) @.
      chebneq.3 @e |- ( ph -> ( E ` X ) e. RR ) @.
      @( Chebyshev's Inequality @)
      chebneq   @p |- ( ph ->
        ( P ` ( ( abs ` ( X oFC - ( E ` X ) ) ) oRVC `' <_ A ) )
                                              <_ ( ( V ` X ) / ( A ^ 2 ) ) ) @=
        ? @.
     @}
  @}

  @{
    @d p x E @. @d p x P @. @d p x ph @. @d x X @.
    covval.1 @e |- ( ph -> P e. Prob ) @.
    covval.2 @e |- ( ph -> E = ( Exp ` P ) ) @.
    covval.3 @e |- ( ph -> C = ( Cov ` P ) ) @.
    @{
      covval.4 @e |- ( ph -> X e. ( rRndVar ` P ) ) @.
      covval.5 @e |- ( ph -> Y e. ( rRndVar ` P ) ) @.
      @( Value of the variance of the random variable ` X ` .
         (Contributed by Thierry Arnoux, 15-Jan-2017.) @)
      covval   @p |- ( ph -> ( X C Y ) =
        ( E ` ( ( X oFC - ( E ` X ) ) oFC x. ( Y oFC - ( E ` Y ) ) ) ) ) @=
        ? @.

      @( Covariance is symmetric. @)
      covsym @p |- ( ph -> ( X C Y ) = ( Y C X ) ) @=
        ? @.
    @}

    @{
      covid.4 @e |- ( ph -> V = ( Var ` P ) ) @.
      covid.5 @e |- ( ph -> X e. ( rRndVar ` P ) ) @.
      @( The covariance of a random variable with itself is its variance. @)
      covid @p |- ( ph -> ( X C X ) = ( V ` X ) ) @=
        ? @.

    @}

    @{
      varsum.3 @e |- ( ph -> V = ( Var ` P ) ) @.
      varsum.5 @e |- ( ph -> X : NN --> ( rRndVar ` P ) ) @.
      varsum.6 @e |- ( ( ph /\ N e NN ) -> S = ( seq 1 ( oF + , X ) ` N ) ) @.
      @( Sum of the variance of a sequence of random variables ` X ` .
         (Contributed by Thierry Arnoux, XX-May-2017.) @)
      varsum @p |- ( ( ph /\ N e. NN ) -> ( V ` S ) =  sum_ i e. ( 1 ... N )
        sum_ j e. ( 1 ... N ) ( ( X ` i ) C ( X ` j ) ) ) @=
        ? @.

      @( Sum of the variance of a sequence of random variables ` X ` ,
         expressed using the sum of the variances.
         (Contributed by Thierry Arnoux, XX-May-2017.) @)
      varsum2 @p |- ( ( ph /\ N e. NN ) -> ( V ` S ) = (
        sum_ i e. ( 1 ... N ) ( V ` ( X ` i ) ) + ( 2 x. sum_ i e. ( 1 ... N )
        sum_ j e. ( 1 ..^ i ) ( ( X ` i ) C ( X ` j ) ) ) ) ) @=
        ? @.
    @}
  @}

$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Probabilities - example
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y H $.  $d x y T $.  $d y P $.  $d y X $.  $d x y ph $.
    $( Coin-flip is a usual example in the probability theory.
       Here we use two sets ` H ` for heads, and ` T ` for tails.
       We assume a uniform probability for heads and tails.
       A random variable ` X ` is defined, yielding to a result of 1 for heads
       and 0 for tails. $)

    coinflip.h $e |- H e. _V $.
    coinflip.t $e |- T e. _V $.
    coinflip.th $e |- H =/= T $.
    coinflip.2 $e |- P = ( ( # |` ~P { H , T } ) oFC / 2 ) $.
    coinflip.3 $e |- X = { <. H , 1 >. , <. T , 0 >. } $.
    $( Division in the extended real numbers can be used for the coin-flip
       example.  (Contributed by Thierry Arnoux, 15-Jan-2017.) $)
    coinfliplem $p |- P = ( ( # |` ~P { H , T } ) oFC /e 2 ) $=
      ( vx chash c2 cdiv co cxdiv wcel wceq cr cfn a1i vy cpr cpw cres cofc cvv
      cv wa cfv simpr fvres syl cn0 wss prfi elpwid ssfi sylancr hashcl eqeltrd
      nn0red cc0 wne 2re 2ne0 rexdiv syl3anc hashresfn pwfi mpbi ofcfeqd2 ax-mp
      wfn eqtr4i ) AKCBUBZUCZUDZLMUENZVQLOUENZHCUFPZVSVRQEVTJUAVPRLMOVQSRVTJUGZ
      VPPZUHZWAVQUIZWAKUIZRWCWBWDWEQVTWBUJZWAVPKUKULWCWEWCWASPZWEUMPWCVOSPZWAVO
      UNWGCBUOZWCWAVOWFUPVOWAUQURWAUSULVAUTVTUAUGZRPZUHZWKLRPZLVBVCZWJLONWJLMNQ
      VTWKUJWMWLVDTWNWLVETWJLVFVGVQVPVMVTVPVHTVPSPZVTWHWOWIVOVIVJTWMVTVDTVKVLVN
      $.

    $( The ` P ` we defined for coin-flip is a probability law.  (Contributed
       by Thierry Arnoux, 15-Jan-2017.) $)
    coinflipprob $p |- P e. Prob $=
      ( chash cfv co cprb c2 wcel wceq eqeltri ax-mp cvv mp2an cres coinfliplem
      cpr cpw cuni cxdiv cofc unipw prex pwid fveq2i wne wb hashprg mpbi 3eqtri
      fvres oveq2i eqtr4i cmeas crp pwcntmeas 2rp probfinmeasb ) AJCBUCZUDZUAZV
      FUEZVGKZUFUGZLZMAVGNVJLVKABCDEFGHIUBVINVGVJVIVHJKZVEJKZNVHVFOVIVLPVHVEVFV
      EUHZVECBUIZUJQVHVFJUQRVHVEJVNUKCBULZVMNPZGCSOBSOVPVQUMEFCBSUNTUOUPZURUSVG
      VFUTKOZVIVAOVKMOVESOVSVOVESVBRVINVAVRVCQVFVGVDTQ $.

    $( The space of our coin-flip probability (Contributed by Thierry Arnoux,
       15-Jan-2017.) $)
    coinflipspace $p |- dom P = ~P { H , T } $=
      ( cdm chash cpr cpw c2 cdiv cvv wcel wfn cr a1i cres cofc dmeqi hashresfn
      co wceq prex pwexg mp1i 2re ofcfn fndm mp2b eqtri ) AJKCBLZMZUAZNOUBUEZJZ
      UPAURHUCCPQZURUPRUSUPUFEUTUPNOUQPSUQUPRUTUPUDTUOPQUPPQUTCBUGUOPUHUINSQUTU
      JTUKUPURULUMUN $.

    $( The universe of our coin-flip probability is ` { H , T } ` .
       (Contributed by Thierry Arnoux, 15-Jan-2017.) $)
    coinflipuniv $p |- U. dom P = { H , T } $=
      ( cdm cuni cpr cpw coinflipspace unieqi unipw eqtri ) AJZKCBLZMZKSRTABCDE
      FGHINOSPQ $.

    $( The ` X ` we defined for coin-flip is a random variable.  (Contributed
       by Thierry Arnoux, 12-Jan-2017.) $)
    coinfliprv $p |- X e. ( rRndVar ` P ) $=
      ( vy wcel cdm cr wf cbrsiga c1 cc0 cpr wss cvv crrv cfv cuni ccnv cv cima
      wral cop wne 1ex c0ex fpr ax-mp feq1i mpbir coinflipuniv feq2i wa 1re 0re
      pm3.2i prss mpbi fss mp2an crn imassrn dfdm4 eqtr3i sseqtri coinflipspace
      fdmi cpw eleq2i prex cnvexg imaexg mp2b elpw bitr2i biimpi mp1i rgen cprb
      eqeltri wb coinflipprob a1i isrrvv mpbir2an ) DAUAUBKZALZUCZMDNZDUDZJUEZU
      FZWLKZJOUGZWMPQRZDNZWTMSZWNXACBRZWTDNZXDXCWTCPUHZBQUHZRZNZCBUIXHGCBPQEFUJ
      UKULUMXCWTDXGIUNUOZWMXCWTDABCDEFGHIUPUQUOPMKZQMKZURXBXJXKUSUTVAPQMUJUKVBV
      CWMWTMDVDVEWRJOWQXCSZWRWPOKWQWOVFZXCWOWPVGDLXMXCDVHXCWTDXIVLVIVJXLWRWRWQX
      CVMZKXLWLXNWQABCDEFGHIVKVNWQXCDTKWOTKWQTKDXGTIXEXFVOWEDTVPWOWPTVQVRVSVTWA
      WBWCCTKZWKWNWSURWFEXOJADAWDKXOABCDEFGHIWGWHWIUMWJ $.

    $( The probability of heads is one-half.  (Contributed by Thierry Arnoux,
       15-Jan-2017.) $)
    coinflippv $p |- ( P ` { H } ) = ( 1 / 2 ) $=
      ( vx cfv chash c2 cdiv c1 wcel wceq cvv cn0 a1i csn cpr cpw cres cofc wss
      co fveq1i snsspr1 prex elpw2 biimpri cv fveq2 hashsng ax-mp syl6eq oveq1d
      cmpt pwex 2nn0 wa cfn prfi elpwi ssfi sylancr adantl hashcl syl cun hashf
      cpnf wf ssv feqresmpt ofcfval2 ovex fvmpt mp2b eqtri ) CUAZAKWBLCBUBZUCZU
      DZMNUEUGZKZOMNUGZWBAWFHUHWBWCUFZWBWDPZWGWHQCBUIWJWIWBWCCBUJZUKULJWBJUMZLK
      ZMNUGZWHWDWFWLWBQZWMOMNWOWMWBLKZOWLWBLUNCRPZWPOQECRUOUPUQURWQWFJWDWNUSQEW
      QJWDWMMNWERSWDRPWQWCWKUTTMSPWQVATWQWLWDPZVBWLVCPZWMSPWRWSWQWRWCVCPWLWCUFW
      SCBVDWLWCVEWCWLVFVGVHWLVIVJWQJRSVMUAVKZWDLRWTLVNWQVLTWDRUFWQWDVOTVPVQUPOM
      NVRVSVTWA $.

    $( The probability of tails is one-half.  (Contributed by Thierry Arnoux,
       5-Feb-2017.) $)
    coinflippvt $p |- ( P ` { T } ) = ( 1 / 2 ) $=
      ( csn cfv c1 c2 co cmin cdif wcel wceq ax-mp eqtri cdiv cuni coinflipprob
      cdm cprb cpr cpw prid1 snelpwi coinflipspace probdsb coinflipuniv difeq1i
      eleqtrri mp2an wne difprsn1 fveq2i coinflippv oveq2i 3eqtr3i 1mhlfehlf )
      BJZAKZLLMUANZONZVEAUDZUBZCJZPZAKZLVIAKZONZVDVFAUEQVIVGQVKVMRABCDEFGHIUCVI
      CBUFZUGZVGCVNQVIVOQCBEUHCVNUISABCDEFGHIUJUNVIAUKUOVJVCAVJVNVIPZVCVHVNVIAB
      CDEFGHIULUMCBUPVPVCRGCBUQSTURVLVELOABCDEFGHIUSUTVAVBT $.

$(
    @( The expectation of our gain is one-half.
       (Contributed by Thierry Arnoux, 12-Jan-2017.) @)
    coinflipexp @p |- ( ( Exp ` P ) ` X ) = ( 1 / 2 ) @=
      ( cfv c2 cxdiv co c1 cvv wcel wceq a1i ax-mp cc0 cexpt cpr chash cpw cres
      cofc citgm cdiv cuni cprb coinflipprob eqidd crrv coinfliprv coinflipuniv
      vy exptval coinfliplem itgmeq123dTMP eqtri itgmdiv3TMP cv prex itgmcntTMP
      cdm cesum oveq1i cxad fveq2 adantl cpnf cicc cop fveq1i wne 1ex fvpr1 cxr
      cle wbr cr ressxr 1re sselii 0le1 elxrge0 mpbir2an eqeltri c0ex fvpr2 0xr
      0le0 esumpr oveq12i xaddid1 3eqtri 2re 2ne0 rexdiv mp3an ) DAUAJZJZCBUBZD
      UCXCUDUEZKLUFMZUGZXCDXDUGZKLMZNKUHMZXBAVEUIZDAUGZXFCOPZXBXKQEXLAXADAUJPXL
      ABCDEFGHIUKRXLXAULDAUMJPXLABCDEFGHIUNRUQSXLXKXFQEXLXJXCXEDDAXJXCQXLABCDEF
      GHIUORXLDULAXEQXLABCDEFGHIURRUSSUTXCKDXDVAXHXCUPVBZDJZUPVFZKLMNKLMZXIXGXO
      KLXCOPXGXOQCBVCUPXCDXCOVDSVGXONKLXOCDJZBDJZVHMZNTVHMZNXLXOXSQEXLCBXNXQUPX
      ROOXMCQXNXQQXLXMCDVIVJXMBQXNXRQXLXMBDVIVJXLXLERBOPXLFRXQTVKVLMZPXLXQNYAXQ
      CCNVMBTVMUBZJZNCDYBIVNCBVOZYCNQGCBNTEVPVQSUTZNYAPNVRPZTNVSVTWAVRNWBWCWDZW
      ENWFWGWHRXRYAPXLXRTYAXRBYBJZTBDYBIVNYDYHTQGCBNTFWIWJSUTZTYAPTVRPTTVSVTWKW
      LTWFWGWHRYDXLGRWMSXQNXRTVHYEYIWNYFXTNQYGNWOSWPVGNWAPKWAPKTVOXPXIQWCWQWRNK
      WSWTWPWP @.
$)
  $}

$(
@(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                      Uncorrelated random sequences
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
@)

  @c UnCorr @. @( Symbol for uncorrelated random samples @)
  cuncor @a class UnCorr @.

  @( Define a random sample as an indexed set of ` n ` random variables of
     the same probability measure ` p ` , which are not correlated when taken
     pairwise. @)
  df-uncor @a |- UnCorr = ( p e. Prob |-> { x e. ( ( rRndVar ` p ) ^m NN ) |
    A. i e. NN A. j e. NN  ( ( Exp ` p ) ` ( ( x ` i ) oF * ( x ` j ) ) ) =
    ( ( ( Exp ` p ) ` ( x ` i ) ) * ( ( Exp ` p ) ` ( x ` j ) ) ) } ) @.

  @{
    uncorval.1 @e |- ( ph -> P e. Prob ) @.
    uncorval.2 @e |- ( ph -> E = ( Exp ` P ) ) @.
    uncorval.3 @e |- ( ph -> X e. ( UnCorr ` P ) ) @.

    @( Elements of a sequence of random variables are random variables. @)
    uncorrnd @p |- ( ph -> X : NN --> ( rRndVar ` P ) ) @=
      ? @.

    @( Property of a sequence of pairwise uncorrelated random variables. @)
    uncorval @p |- ( ( ph /\ i e. NN /\ j e. NN ) ->
      ( E ` ( ( X ` i ) oF * ( X ` j ) ) ) =
      ( ( E ` ( X ` i ) ) * ( E ` ( X ` j ) ) ) ) @=
      ? @.

  @}
@(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                               Convergence
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
@)

  @c ~ms~> @. @( Symbol for convergence in mean square @)
  @c ~p~> @. @( Symbol for convergence in probability @)
  cmsli @a class ~ms~> @.
  cprl @a class ~p~> @.

  @( Define convergence in probability @)
  df-prl @a |- ~p~> = ( p e. Prob |-> { <. x , y >. | A. e e. RR+ ( n e. NN |->
    ( p ` ( ( abs o. ( ( x ` n ) oFC - y ) ) oRVC `' <_ e  ) ) ) ~~> 0 } ) @.

  @( Define convergence in mean square @)
  df-msli @a |- ~ms~> = ( p e. Prob |-> { <. x , y >. | ( n e. NN |->
    ( ( Exp ` p ) ` ( ( ( x ` n ) oFC - y ) oFC ^ 2 ) ) ) ~~> 0 } ) @.

  @{
    plival.1 @e |- ( ph -> P e. Prob ) @.
    @( Convergence in mean square is a relation. @)
    plirel @p |- ( ph -> Rel ( ~p~> ` P ) ) @=
      ? @.
    @( Convergence in mean square is a relation. @)
    mslirel @p |- ( ph -> Rel ( ~ms~> ` P ) ) @=
      ? @.

    plival.2 @e |- ( ph -> X : NN --> ( rRndVar ` P ) ) @.
    plival.3 @e |- ( ph -> Y e. RR ) @.
    @( Express the predicate: ` X ` converges in probability to ` Y ` . @)
    plival @p |- ( ph -> ( X ( ~ms~> ` P ) Y <-> A. e e. RR+ ( n e. NN |->
      ( P ` ( ( abs o. ( ( X ` n ) oFC - Y ) ) oRVC `' <_ e  ) ) ) ~~> 0 ) ) @=
      ? @.

    mslival.1 @e |- ( ph -> E = ( Exp ` P ) ) @.
    @( Express the predicate: ` X ` converges in mean square to ` Y ` . @)
    mslival @p |- ( ph -> ( X ( ~ms~> ` P ) Y <-> ( n e. NN |->
      ( E ` ( ( ( X ` n ) oFC - Y ) oFC ^ 2 ) ) ) ~~> 0 ) ) @=
      ? @.
  @}

@(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                         Weak Law of Large Numbers
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
@)
  @{
    @( Hypothesis for the Weak Law of Large Numbers. ` X ` is a random sample.
       ~ wllnms.5 expresses the fact that the random variables ` X ` are
       uncorrelated. ~ wllnms.9 defines ` S ` as the partial sum of ` X ` over
       ` ( 1 ... n ) ` . @)
    wllnms.1 @e |- ( ph -> P e. Prob ) @.
    wllnms.2 @e |- ( ph -> E = ( Exp ` P ) ) @.
    wllnms.3 @e |- ( ph -> V = ( Var ` P ) ) @.
    wllnms.4 @e |- ( ph -> X e. ( UnCorr ` P ) ) @.
    wllnms.5 @e |- ( ph -> C e. RR+ ) @.
    wllnms.6 @e |- ( ( ph /\ N e. NN ) -> M = ( E ` ( X ` N ) ) ) @.
    wllnms.7 @e |- ( ( ph /\ N e. NN ) -> ( V ` ( X ` N ) ) <_ C ) @.
    wllnms.8 @e |- ( ( ph /\ n e NN ) -> S = ( seq 1 ( oF + , X ) ` n ) ) @.

    @( Weak Law of Large Numbers - convergence in mean square @)
    wllnms @p |- ( ph -> ( n e. NN |-> ( S oFC / n ) ) ( ~ms~> ` P ) M ) @=
      ? @.

    @( Weak Law of Large Numbers - convergence in probability @)
    wllnp @p |- ( ph -> ( n e. NN |-> ( S oFC / n ) ) ( ~p~> ` P ) M ) @=
      ? @.
  @}
$)


$( End $[ set-mbox-ta-proba.mm $] $)
$( Begin $[ set-mbox-ta-ballot.mm $] $)
$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
     Bertrand's Ballot Problem
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $(
    $d c k i $.
    $d c i M $.
    $d c i N $.
    $d b c i x O $.
    $d i j k C $.
    $d c i j k F $.
    $d b c x E $.
    $d i j k J $.
    $d b c i x O $.
    $d b R $.
    $d k ph $.
  $)

  ${
    $d c M $.  $d c N $.  $d c O $.  $d i M $.  $d i N $.  $d i O $.  $d j M $.
    $d j N $.  $d j O $.  $d k M $.  $d k N $.  $d k O $.

    $( Two candidates A and B participate to an election,
      where A receives ` M ` votes and B receives ` N ` votes.
      Ballots are counted by picking ballot papers one by one,
      and we're evaluating the probability that A is ahead throughout the count

      We number the ballots picked using integers in ` ( 1 ... ( M + N ) ) ` .
      We then characterise a counting ` c ` as the set of indices in the
      counting sequence where A was picked.
      Thus, for a counting ` c C_ ( 1 ... ( M + N ) ) ` :
        "The ith ballot paper picked is for A" is expressed as ` i e. c `
        "The ith ballot paper picked is for B" is expressed as ` -. i e. c `
        "The number of ballot papers for A" is expressed as ` ( # ` c ) `
    $)

    ballotth.m $e |- M e. NN $.
    ballotth.n $e |- N e. NN $.

    $( ` O ` is the universe, all countings where A receives ` M ` votes
       out of ` M + N ` $)
    ballotth.o $e |- O = { c e. ~P ( 1 ... ( M + N ) ) | ( # ` c ) = M } $.
    $( ` O ` is a set.  (Contributed by Thierry Arnoux, 7-Dec-2016.) $)
    ballotlemoex $p |- O e. _V $=
      ( c1 caddc co cfz cpw ovex pwex cv chash cfv wceq crab ssrab2 eqsstri
      ssexi ) CHABIJZKJZLZUDHUCKMNCDOPQARZDUESUEGUFDUETUAUB $.

    $( The size of the universe is a binomial coefficient.  (Contributed by
       Thierry Arnoux, 23-Nov-2016.) $)
    ballotlem1 $p |- ( # ` O ) = ( ( M + N ) _C M ) $=
      ( chash cfv cv wceq c1 caddc co cfz cpw crab cbc wcel cn fveq2i fzfi nnzi
      cfn cz hashbc mp2an cn0 wa pm3.2i nnaddcl nnnn0 mp2b hashfz1 ax-mp oveq1i
      3eqtr2i ) CHIDJHIAKDLABMNZONZPQZHIZUSHIZARNZURARNCUTHGUAUSUDSAUESVCVAKLUR
      UBAEUCDUSAUFUGVBURARURUHSZVBURKATSZBTSZUIURTSVDVEVFEFUJABUKURULUMURUNUOUP
      UQ $.

    ${
      $d c d $.  $d d C $.  $d d M $.  $d d N $.
      $( Elementhood in ` O ` .  (Contributed by Thierry Arnoux,
         17-Apr-2017.) $)
      ballotlemelo $p |- ( C e. O <->
                             ( C C_ ( 1 ... ( M + N ) ) /\ ( # ` C ) = M ) ) $=
        ( vd wcel c1 co cfz chash cfv wceq wa cv fveq2 eqeq1d caddc cpw cbvrabv
        wss crab eqtri elrab2 ovex elpw2 anbi1i bitri ) ADJAKBCUALZMLZUBZJZANOZ
        BPZQAUMUDZUQQIRZNOZBPZUQIAUNDUSAPUTUPBUSANSTDERZNOZBPZEUNUEVAIUNUEHVDVA
        EIUNVBUSPVCUTBVBUSNSTUCUFUGUOURUQAUMKULMUHUIUJUK $.
    $}

    $( Let ` P ` be the uniform discrete probability measure over ` O ` . $)
    ballotth.p $e |- P = ( x e. ~P O |-> ( ( # ` x ) / ( # ` O ) ) ) $.

    ${
      $d c i M $.  $d c i N $.  $d c i x O $.

      $( The probability that the first vote picked in a count is a B
         (Contributed by Thierry Arnoux, 23-Nov-2016.) $)
      ballotlem2 $p |- ( P ` { c e. O | -. 1 e. c } ) = ( N / ( M + N ) ) $=
        ( vi c1 wcel cfv co c2 wa cle wbr mp2an cv wn crab caddc cmin cbc chash
        cdiv wceq ssrab2 ballotlemoex elpw2 mpbir fveq2 oveq1d ovex fvmpt ax-mp
        cpw wss cfz cab cuz cn 2nn nnge1 cz wb 1z 2z eluz fzss1 sspwb sseli clt
        mpbi 1lt2 1re 2re ltnlei elfzle1 mto elelpwi ancom mtbi imnani jca ssin
        cin wo 1p1e2 nnrei le2addi eqbrtrri readdcli letri nnaddcl nnzi elfzp12
        biimpi orcanai oveq1i syl6eleq ss2abi abid2 ineq1i eqtr3i 3sstr3i mpan2
        inab sstr sylbi vex elpw wi wal wex df-ex bicomi con1bii df-clel notbii
        ssab imnan bitr4i 3bitr4ri bitr2i anbi12i 3imtr4i anbi1i df-rab cneg cc
        albii nncni 2cn ax-1cn 3eqtri eqtri cc0 impbii rabeq2i an32 3eqtr4i cfn
        abbii fveq2i fzfi hashbc eluz1i mpbir2an hashfz addcli mp3an negsubdi2i
        subadd23 2m1e1 negeqi oveq2i negsubi ballotlem1 oveq12i w3a 0le1 0re cr
        crp nngt0i elrpii ltaddrp 3pm3.2i 0z elfzm11 bcm1n pncan2 ) LFUAZMZUBZF
        EUCZBNZCDUDOZLUEOZCUFOZUWACUFOZUHOZUWACUEOZUWAUHOZDUWAUHOUVTUVSUGNZEUGN
        ZUHOZUWEUVSEUSZMZUVTUWJUIUWLUVSEUTUVRFEUJUVSECDEFGHIUKULUMAUVSAUAZUGNZU
        WIUHOUWJUWKBUWMUVSUIUWNUWHUWIUHUWMUVSUGUNUOJUWHUWIUHUPUQURUWHUWCUWIUWDU
        HUVPUGNCUIZFPUWAVAOZUSZUCZUGNZUWHUWCUWRUVSUGUVPUWQMZUWOQZFVBUVPEMZUVRQZ
        FVBUWRUVSUXAUXCFUXAUVPLUWAVAOZUSZMZUVRQZUWOQZUXCUWTUXGUWOUWTUXGUWTUXFUV
        RUWQUXEUVPUWPUXDUTZUWQUXEUTPLVCNZMZUXIUXKLPRSZPVDMUXLVEPVFURZLVGMZPVGMU
        XKUXLVHVIVJLPVKTUMPLUWAVLURUWPUXDVMVPVNUWTUVQUVQUWTQZUWTUVQQUXOLUWPMZUX
        PPLRSZLPVOSUXQUBVQLPVRVSVTVPLPUWAWAWBLUVPUWPWCWBUVQUWTWDWEWFWGUVPUXDUTZ
        UVPKUAZLUIZUBZKVBZUTZQZUVPUWPUTZUXGUWTUYDUVPUXDUYBWIZUTZUYEUVPUXDUYBWHU
        YGUYFUWPUTUYEUXSUXDMZUYAQZKVBZUXSUWPMZKVBUYFUWPUYIUYKKUYIUXSLLUDOZUWAVA
        OZUWPUYHUXTUXSUYMMZUYHUXTUYNWJZUWAUXJMZUYHUYOVHUYPLUWARSZUXLPUWARSZUYQU
        XMUYLPUWARWKLCRSZLDRSZUYLUWARSCVDMZUYSGCVFURZDVDMZUYTHDVFURLLCDVRVRCGWL
        ZDHWLZWMTWNZLPUWAVRVSCDVUDVUEWOWPTUXNUWAVGMZUYPUYQVHVIUWAVUAVUCUWAVDMZG
        HCDWQTZWRZLUWAVKTUMUXSLUWAWSURWTXAUYLPUWAVAWKXBXCXDUYHKVBZUYBWIUYJUYFUY
        HUYAKXJVUKUXDUYBKUXDXEXFXGKUWPXEXHUVPUYFUWPXKXIXLUXFUXRUVRUYCUVPUXDFXMZ
        XNUYCUXSUVPMZUYAXOZKXPZUVRUYAKUVPYCUXTVUMQZKXQZUBVUPUBZKXPZUVRVUOVUSVUQ
        VUQVUSUBVUPKXRXSXTUVQVUQKLUVPYAYBVUOVUMUXTQZUBZKXPVUSVUNVVAKVUMUXTYDYNV
        URVVAKVUPVUTUXTVUMWDYBYNYEYFYGYHUVPUWPVULXNYIUUAYJUXCUXFUWOQZUVRQUXHUXB
        VVBUVRUWOFEUXEIUUBYJUXFUVRUWOUUCYEYEUUFUWOFUWQYKUVRFEYKUUDUUGUWPUGNZCUF
        OZUWSUWCUWPUUEMCVGMZVVDUWSUIPUWAUUHCGWRZFUWPCUUITVVCUWBCUFVVCUWALYLZUDO
        ZUWBVVCUWAPUEOLUDOZUWALPUEOZUDOZVVHUWAPVCNMZVVCVVIUIVVLVUGUYRVUJVUFPUWA
        VJUUJUUKPUWAUULURUWAYMMPYMMLYMMVVIVVKUICDCGYOZDHYOZUUMZYPYQUWAPLUUPUUNV
        VJVVGUWAUDPLUEOZYLVVJVVGPLYPYQUUOVVPLUUQUURXGUUSYRUWALVVOYQUUTYSXBXGXGC
        DEFGHIUVAUVBYSCYTUWBVAOMZVUHUWEUWGUIVVQVVEYTCRSZCUWAVOSZUVCZVVEVVRVVSVV
        FYTLRSUYSVVRUVDVUBYTLCUVEVRVUDWPTCUVFMDUVGMVVSVUDDVUEDHUVHUVICDUVJTUVKY
        TVGMVUGVVQVVTVHUVLVUJCYTUWAUVMTUMVUICUWAUVNTUWFDUWAUHCYMMDYMMUWFDUIVVMV
        VNCDUVOTXBYR $.
    $}

    $d c i F $.  $d j F $.  $d k F $.
    $( F is the difference between ballots for A and B
      among the i first ballots picked in a given count ` c ` .
      Those ballots for A are in ` c `, i.e. in ` ( ( 1 ... i ) i^i c ) `
      Those ballots for B are out of ` c `, i.e. in ` ( ( 1 ... i ) \ c ) ` $)
    ballotth.f $e |- F = ( c e. O |-> ( i e. ZZ |->
      ( ( # ` ( ( 1 ... i ) i^i c ) ) - ( # ` ( ( 1 ... i ) \ c ) ) ) ) ) $.

    $d i c $.  $d i C $.
    ${
      $d b O $.  $d b C $.  $d b c $.  $d b i $.  $d i J $.
      ballotlemfval.c $e |- ( ph -> C e. O ) $.
      ballotlemfval.j $e |- ( ph -> J e. ZZ ) $.

      $d i ph $.
      $( The value of F. (Contributed by Thierry Arnoux, 23-Nov-2016.) $)
      ballotlemfval $p |- ( ph -> ( ( F ` C ) ` J ) =
        ( ( # ` ( ( 1 ... J ) i^i C ) ) - ( # ` ( ( 1 ... J ) \ C ) ) ) ) $=
        ( chash cfv vb c1 cv cfz co cin cdif cmin cz cvv wcel cmpt simpl ineq2d
        wceq wa fveq2d difeq2d oveq12d mpteq2dva difeq2 mpteq2dv cbvmptv eqtr4i
        ineq2 zex mptex fvmpt syl oveq2 ineq1d difeq1d adantl ovex a1i fvmptd )
        AEGUBEUCZUDUEZCUFZSTZVRCUGZSTZUHUEZUBGUDUEZCUFZSTZWDCUGZSTZUHUEZUICFTZU
        JACJUKWJEUIWCULZUOQUACEUIVRUAUCZUFZSTZVRWLUGZSTZUHUEZULZWKJFWLCUOZEUIWQ
        WCWSVQUIUKZUPZWNVTWPWBUHXAWMVSSXAWLCVRWSWTUMZUNUQXAWOWASXAWLCVRXBURUQUS
        UTFKJEUIVRKUCZUFZSTZVRXCUGZSTZUHUEZULZULUAJWRULPUAKJWRXIWLXCUOZEUIWQXHX
        JWNXEWPXGUHXJWMXDSWLXCVRVEUQXJWOXFSWLXCVRVAUQUSVBVCVDEUIWCVFVGVHVIVQGUO
        ZWCWIUOAXKVTWFWBWHUHXKVSWESXKVRWDCVQGUBUDVJZVKUQXKWAWGSXKVRWDCXLVLUQUSV
        MRWIUJUKAWFWHUHVNVOVP $.

      $( ` ( F `` C ) ` has values in ` ZZ ` .  (Contributed by Thierry Arnoux,
         23-Nov-2016.) $)
      ballotlemfelz $p |- ( ph -> ( ( F ` C ) ` J ) e. ZZ ) $=
        ( cfv wcel c1 cfz co cin chash cdif cmin ballotlemfval cfn cn0 wss fzfi
        cz inss1 ssfi mp2an hashcl ax-mp nn0zi difss zsubcl syl6eqel ) AGCFSSUA
        GUBUCZCUDZUESZVCCUFZUESZUGUCZUMABCDEFGHIJKLMNOPQRUHVEUMTVGUMTVHUMTVEVDU
        ITZVEUJTVCUITZVDVCUKVIUAGULZVCCUNVCVDUOUPVDUQURUSVGVFUITZVGUJTVJVFVCUKV
        LVKVCCUTVCVFUOUPVFUQURUSVEVGVAUPVB $.
    $}

    ${
      $d i J $.  $d i ph $.
      ballotlemfp1.c $e |- ( ph -> C e. O ) $.
      ballotlemfp1.j $e |- ( ph -> J e. NN ) $.
      $( If the ` J ` th ballot is for A, ` ( F `` C ) ` goes up 1.  If the
         ` J ` th ballot is for B, ` ( F `` C ) ` goes down 1.  (Contributed by
         Thierry Arnoux, 24-Nov-2016.) $)
      ballotlemfp1 $p |- ( ph -> (
         ( -. J e. C -> ( ( F ` C ) ` J ) = ( ( ( F ` C ) ` ( J - 1 ) ) - 1 ) )
      /\ ( J e. C -> ( ( F ` C ) ` J ) = ( ( ( F ` C ) ` ( J - 1 ) ) + 1 ) )
        ) ) $=
        ( c1 wceq wcel wn cfv cmin co wi caddc cfz cin chash cdif ballotlemfval
        wa nnzd adantr csn cun c0 cuz cn elnnuz sylib fzspl ineq1d indir syl6eq
        syl disjsn eqeq1i bitr3i biimpi adantl uneq2d un0 3eqtrd fveq2d difeq1d
        incom a1i difundir disj3 eqcomd sylan9eq cz uzid uznfz 3syl difss sseli
        cfn nsyl wss fzfi ssfi mp2an jctil hashunsng sylc eqtrd oveq12d zsubcld
        1z oveq1d cc cn0 inss1 hashcl ax-mp nn0cni diffi ax-1cn subsub4d eqtr2d
        ex snssi df-ss simpr difin2 difid ineq1i in0 3eqtri addsubd eqtr4d jca
        ) AGCUAZUBZGCFUCZUCZGSUDUEZYHUCZSUDUEZTZUFYFYIYKSUGUEZTZUFAYGYMAYGUMZYI
        SGUHUEZCUIZUJUCZYQCUKZUJUCZUDUEZSYJUHUEZCUIZUJUCZUUCCUKZUJUCZSUGUEZUDUE
        ZYLAYIUUBTZYGABCDEFGHIJKLMNOPQAGRUNZULZUOYPYSUUEUUAUUHUDYPYRUUDUJYPYRUU
        DGUPZCUIZUQZUUDURUQZUUDAYRUUOTZYGAGSUSUCUAZUUQAGUTUAUURRGVAVBZUURYRUUCU
        UMUQZCUIUUOUURYQUUTCSGVCZVDUUCUUMCVEVFVGZUOYPUUNURUUDYGUUNURTZAYGUVCYGC
        UUMUIZURTUVCCGVHUVDUUNURCUUMVRVIVJVKZVLVMUUPUUDTYPUUDVNVSVOVPYPUUAUUFUU
        MUQZUJUCZUUHYPYTUVFUJAYGYTUUFUUMCUKZUQZUVFAUURYTUVITUUSUURYTUUTCUKUVIUU
        RYQUUTCUVAVQUUCUUMCVTVFVGZYGUVHUUMUUFYGUUMUVHYGUVCUUMUVHTUVEUUMCWAVBWBV
        MWCVPYPGWDUAZUUFWJUAZGUUFUAZUBZUMUVGUUHTAUVKYGUUKUOYPUVNUVLYPGUUCUAZUVM
        AUVOUBZYGAUVKGGUSUCUAZUVPUUKGWEZGSGWFZWGUOUUFUUCGUUCCWHZWIWKUUCWJUAZUUF
        UUCWLUVLSYJWMZUVTUUCUUFWNWOWPUUFGWDWQWRWSWTYPYLUUEUUGUDUEZSUDUEUUIYPYKU
        WCSUDAYKUWCTZYGABCDEFYJHIJKLMNOPQAGSUUKSWDUAAXBVSXAULZUOXCYPUUEUUGSUUEX
        DUAZYPUUEUUDWJUAZUUEXEUAUWAUUDUUCWLUWGUWBUUCCXFZUUCUUDWNWOZUUDXGXHXIZVS
        UUGXDUAZYPUUGUVLUUGXEUAUWAUVLUWBUUCCXJXHUUFXGXHXIZVSSXDUAZYPXKVSXLXMVOX
        NAYFYOAYFUMZYIUUBUUESUGUEZUUGUDUEZYNAUUJYFUULUOUWNYSUWOUUAUUGUDUWNYSUUO
        UJUCZUUDUUMUQZUJUCZUWOAYSUWQTYFAYRUUOUJUVBVPUOYFUWQUWSTAYFUUOUWRUJYFUUN
        UUMUUDYFUUMCWLZUUNUUMTGCXOZUUMCXPVBVMVPVLUWNYFUWGGUUDUAZUBZUMUWSUWOTAYF
        XQUWNUXCUWGUWNUVOUXBUWNUVKUVQUVPAUVKYFUUKUOUVRUVSWGUUDUUCGUWHWIWKUWIWPU
        UDGCWQWRVOUWNUUAUVIUJUCZUUFURUQZUJUCZUUGAUUAUXDTYFAYTUVIUJUVJVPUOYFUXDU
        XFTAYFUVIUXEUJYFUVHURUUFYFUWTUVHURTUXAUWTUVHCCUKZUUMUIZURUUMCCXRUXHURUU
        MUIUUMURUIURUXGURUUMCXSXTURUUMVRUUMYAYBVFVGVMVPVLUWNUXEUUFUJUXEUUFTUWNU
        UFVNVSVPVOWTUWNUWPUWCSUGUEYNUWNUUESUUGUWFUWNUWJVSUWMUWNXKVSUWKUWNUWLVSY
        CUWNYKUWCSUGAUWDYFUWEUOXCYDVOXNYE $.

      $d k i j $.  $d j k J $.  $d j k C $.  $d ph k $.
      ballotlemfc0.3 $e |- ( ph ->
                                E. i e. ( 1 ... J ) ( ( F ` C ) ` i ) <_ 0 ) $.
      ballotlemfc0.4 $e |- ( ph -> 0 < ( ( F ` C ) ` J ) ) $.
      $( ` F ` takes value 0 between negative and positive values.
         (Contributed by Thierry Arnoux, 24-Nov-2016.) $)
      ballotlemfc0 $p |- ( ph -> E. k e. ( 1 ... J ) ( ( F ` C ) ` k ) = 0 ) $=
        ( vj cv cfv cc0 wceq cle wbr c1 cfz co crab wrex wral wcel fveq2 breq1d
        wa elrab anbi1i simprlr caddc wn simprl adantrr clt cr cuz fzssuz uzssz
        sstri zssre sseli ltp1d 1re a1i readdcld ltnled mpbid syl simprr adantr
        cz wi simpr fveq2d breq2d wb cn elnnuz sylib eleq1 syl5ibrcom anc2li 1z
        eluzfz2 0le1 0z eluz1i mpbir2an fzss1 sseld ax-mp elfzelz ballotlemfelz
        0re adantl zred sylan2 syl6 imp bitr3d ex con2d cmin nn1m1nn oveq1 nnzd
        wo csn fzsn eqtr3d rexeqdv mpbird ax-1cn eleq2d eqeq2d sylibr 1p1e2 wss
        c2 mp2an mpd breq1 syl2anc simplrr sylan oveq1d adantlrr cfn syl6bbr cc
        rexsng pm2.65da biortn notnot orbi1i elfzp1 nncnd npcand oveq2d 3bitr3d
        orbi2d orcom syl6bb biimpd pm5.6 jctil fzaddel biimp3a 3anidm23 oveq12d
        jctir syl2an 1nn0 nn0addge1i breqtri 2z eluz mpbir syld sylan2d rspccva
        syl6bi sylan2br con3d simpll mpsyl imdistani elfznn ballotlemfp1 simpld
        expr zcnd pncand zlem1lt sylancl bitr4d syl21anc syl12anc condan simprd
        ltled mpdan notbid syldan zleltp1 mpan zre letri3d mpbir2and sylan2b c0
        bitrd wne ssrab2 fzfi ssfi rabn0 fimaxre syl3anc reximddv elrabi anim1i
        reximi2 ) AFUCZCGUDZUDZUEUFZFEUCZUXQUDZUEUGUHZEUIHUJUKZULZUMUXSFUYCUMAU
        BUCZUXPUGUHZUBUYDUNZUXSFUYDUXPUYDUOZUYGURAUXPUYCUOZUXRUEUGUHZURZUYGURZU
        XSUYHUYKUYGUYBUYJEUXPUYCUXTUXPUFUYAUXRUEUGUXTUXPUXQUPUQUSUTAUYLURZUXSUY
        JUEUXRUGUHZAUYIUYJUYGVAUYMUYNUXRUIVBUKZUEUGUHZVCZUYMUXPUIVBUKZUXQUDZUEU
        GUHZVCZUYQUYMUYRUXPUGUHZVCZVUAUYMUYIVUCAUYKUYIUYGAUYIUYJVDZVEUYIUXPUYRV
        FUHVUCUYIUXPUYCVGUXPUYCWCVGUYCUIVHUDZWCUIHVIUIVJVKVLVKZVMZVNUYIUXPUYRVU
        GUYIUXPUIVUGUIVGUOZUYIVOVPVQVRVSVTZUYMUYGUYRUYCUOZVUCVUAWDAUYKUYGWAAUYK
        VUJUYGAUYKVUJAUYJUXPHUFZVCZUYIVUJAVUKUYJAVUKUYJVCZAVUKURZUEHUXQUDZVFUHZ
        VUMAVUPVUKUAWBVUNUEUXRVFUHZVUPVUMVUNUXRVUOUEVFVUNUXPHUXQAVUKWEWFWGAVUKV
        UQVUMWHZAVUKAUYIURVURAVUKUYIAUYIVUKHUYCUOZAHVUEUOZVUSAHWIUOZVUTSHWJWKUI
        HWPVTUXPHUYCWLWMWNUYIAUXPUEHUJUKZUOZVURUIUEVHUDUOZUYIVVCWDVVDUIWCUOZUEU
        IUGUHWOWQUEUIWRWSWTZVVDUYCVVBUXPUIUEHXAZXBXCZAVVCURZUEUXRUEVGUOZVVIXFVP
        VVIUXRVVIBCDEGUXPIJKLMNOPQACKUOZVVCRWBVVCUXPWCUOZAUXPUEHXDXGXEZXHVRXIXJ
        XKXLVSXMXNAUYIVULURZUXPUIHUIXOUKZUJUKUOZVUJAUYIVUKVVPXSZWDVVNVVPWDAUYIV
        VQAUYIVVPVUKXSZVVQAUXPUIVVOUIVBUKZUJUKZUOZVVPUXPVVSUFZXSZUYIVVRAVVOVUEU
        OZVWAVWCWHAVVOWIUOZVWDAVWEHUIUFZVWEXSZAVVAVWGSHXPVTAVWEVWFVCZVCZVWEXSZV
        WGAVWHVWEVWJWHAVWFVUOUEUGUHZAVWFURZUYBEHXTZUMZVWKVWLUYBEUYCUMZVWNAVWOVW
        FTWBVWLUYBEUYCVWMVWLHHUJUKZUYCVWMVWFVWPUYCUFAHUIHUJXQXGAVWPVWMUFZVWFAHW
        CUOVWQAHSXRZHYAVTWBYBYCVSAVWNVWKWHZVWFAVVAVWSSUYBVWKEHWIUXTHUFUYAVUOUEU
        GUXTHUXQUPUQUUCVTWBVSVWLVUPVWKVCZAVUPVWFUAWBAVUPVWTWHVWFAUEVUOVVJAXFVPA
        VUOABCDEGHIJKLMNOPQRVWRXEXHVRWBVSUUDVWHVWEUUEVTVWFVWIVWEVWFUUFUUGUUAYDZ
        VVOWJWKUXPUIVVOUUHVTAVVTUYCUXPAVVSHUIUJAHUIAHSUUIUIUUBUOZAYEVPUUJZUUKYF
        AVWBVUKVVPAVVSHUXPVXCYGUUMUULVVPVUKUUNUUOUUPUYIVUKVVPUUQYHAVVPVUJAVVPUR
        UYRUIUIVBUKZVVSUJUKZUOZVUJAVVPVXFAVVPVVPVXFAVVEVVOWCUOZURVVLVVEURVVPVXF
        WHVVPAVXGVVEAVVOVXAXRWOUURVVPVVLVVEUXPUIVVOXDWOUVCUXPUIUIVVOUUSUVDUUTUV
        AAVXFVUJWDVVPAVXFUYRYKHUJUKZUOVUJAVXEVXHUYRAVXDYKVVSHUJVXDYKUFAYIVPVXCU
        VBYFVXHUYCUYRYKVUEUOZVXHUYCYJVXIUIYKUGUHZUIVXDYKUGUIUIVOUVEUVFYIUVGVVEY
        KWCUOVXIVXJWHWOUVHUIYKUVIYLUVJYKUIHXAXCVMUVNWBYMXMUVKUVLZXKZVEZUYGVUJUR
        UYTVUBUYGVUJUYTVUBVUJUYTURUYGUYRUYDUOVUBUYBUYTEUYRUYCUXTUYRUFUYAUYSUEUG
        UXTUYRUXQUPUQUSUYFVUBUBUYRUYDUYEUYRUXPUGYNUVMUVOZUWCUVPYOYMUYMUYSUYOUFZ
        VUAUYQWHUYMUYRCUOZVXOUYMVXPVUBUYMVXPVCZURUYGVUJUYTVUBAUYKUYGVXQYPUYMVUJ
        VXQVXMWBAUYKVXQUYTUYGAUYKURZVXQURZUYSUEVXSAUYRVVBUOZUYSVGUOAUYKVXQUVQZV
        VDVXSVUJVXTVVFVXRVUJVXQVXLWBVVDUYCVVBUYRVVGXBUVRAVXTURZUYSVYBBCDEGUYRIJ
        KLMNOPQAVVKVXTRWBVXTUYRWCUOAUYRUEHXDXGXEXHYOVVJVXSXFVPVXSUYJUYSUEVFUHZA
        UYIUYJVXQYPVXSAVVCUYSUXRUIXOUKZUFZUYJVYCWHVYAVXSUYIVVCVXRUYIVXQVUDWBZVV
        HVTVXSUYSUYRUIXOUKZUXQUDZUIXOUKZUFZVYEVXRAVUJURZVXQVYJAUYKVUJVXKUVSZVYK
        VXQVYJVYKVXQVYJWDZVXPUYSVYHUIVBUKZUFZWDZVYKBCDEGUYRIJKLMNOPQAVVKVUJRWBV
        UJUYRWIUOAUYRHUVTXGUWAZUWBXKYQVXSUYIVYJVYEWHVYFUYIVYIVYDUYSUYIVYHUXRUIX
        OUYIVYGUXPUXQUYIUXPUIUYIUXPUXPUIHXDUWDVXBUYIYEVPUWEWFZYRYGVTVSVVIVYEURU
        YJVYDUEVFUHZVYCVVIUYJVYSWHZVYEVVIUXRWCUOZUEWCUOZVYTVVMWRUXRUEUWFUWGWBVY
        EVYCVYSWHVVIUYSVYDUEVFYNXGUWHUWIVSUWMYSVXNUWJUYMVUCVXQVUIWBUWKAUYKVXPVX
        OUYGVXRVXPURZVYOVXOVXRVYKVXPVYOVYLVYKVXPVYOVYKVYMVYPVYQUWLXKYQWUCUYIVYO
        VXOWHVXRUYIVXPVUDWBUYIVYNUYOUYSUYIVYHUXRUIVBVYRYRYGVTVSYSUWNVXOUYTUYPUY
        SUYOUEUGYNUWOVTVSUYMWUAUYNUYQWHAUYKWUAUYGAUYKVVCWUAVXRUYIVVCVUDVVHVTVVM
        UWPVEZWUAUYNUEUYOVFUHZUYQWUBWUAUYNWUEWHWRUEUXRUWQUWRWUAUEUYOVVJWUAXFVPW
        UAUXRUIUXRUWSVUHWUAVOVPVQVRUXDVTYDUYMUXRUEUYMUXRWUDXHVVJUYMXFVPUWTUXAUX
        BAUYDVGYJZUYDYTUOZUYDUXCUXEZUYGFUYDUMWUFAUYDUYCVGUYBEUYCUXFZVUFVKVPWUGA
        UYCYTUOUYDUYCYJWUGUIHUXGWUIUYCUYDUXHYLVPAVWOWUHTUYBEUYCUXIYHFUBUYDUXJUX
        KUXLUXSUXSFUYDUYCUYHUYIUXSUYBEUXPUYCUXMUXNUXOVT $.
    $}

    ${
      $d i J $.  $d i ph $.  $d k i j $.  $d j k J $.  $d j k C $.  $d ph k $.
      ballotlemfcc.c $e |- ( ph -> C e. O ) $.
      ballotlemfcc.j $e |- ( ph -> J e. NN ) $.
      ballotlemfcc.3 $e |- ( ph ->
                                E. i e. ( 1 ... J ) 0 <_ ( ( F ` C ) ` i ) ) $.
      ballotlemfcc.4 $e |- ( ph -> ( ( F ` C ) ` J ) < 0 ) $.
      $( ` F ` takes value 0 between positive and negative values.
         (Contributed by Thierry Arnoux, 2-Apr-2017.) $)
      ballotlemfcc $p |- ( ph -> E. k e. ( 1 ... J ) ( ( F ` C ) ` k ) = 0 ) $=
        ( vj cv cfv cc0 wceq cle wbr c1 cfz co crab wrex wral wcel fveq2 breq2d
        wa elrab anbi1i cmin wn caddc simprl adantrr clt cr cz cuz fzssuz uzssz
        sstri zssre sseli ltp1d 1re a1i readdcld ltnled mpbid syl simprr adantr
        wi simpr fveq2d breq1d wb cn elnnuz sylib eluzfz2 eleq1 syl5ibrcom 0le1
        anc2li 1z eluz1i mpbir2an fzss1 sseld elfzelz adantl ballotlemfelz zred
        0z ax-mp 0re sylan2 syl6 imp bitr3d ex con2d wo nn1m1nn oveq1 nnzd fzsn
        eqtr3d rexeqdv rexsng mpbird ax-1cn eleq2d eqeq2d sylibr c2 1p1e2 mp2an
        csn wss mpd syl2anc simplrr sylan oveq1d breq2 adantlrr cfn pm2.65da cc
        biortn notnot orbi1i syl6bbr elfzp1 npcand oveq2d orbi2d 3bitr3d syl6bb
        nncnd orcom biimpd pm5.6 jctil jctir fzaddel syl2an 3anidm23 nn0addge1i
        biimp3a oveq12d 1nn0 breqtri 2z eluz mpbir syl6bi sylan2d breq1 rspccva
        syld sylan2br expr con3d simpll mpsyl elfznn ballotlemfp1 simprd pncand
        imdistani zcnd zleltp1 sylancr bitr4d syl21anc ltled mtand simpld mpdan
        syl12anc notbid syldan zlem1lt mpan2 zre resubcld bitrd simprlr letri3d
        mpbir2and sylan2b c0 wne ssrab2 fzfi ssfi rabn0 fimaxre reximddv elrabi
        syl3anc anim1i reximi2 ) AFUCZCGUDZUDZUEUFZFUEEUCZUXSUDZUGUHZEUIHUJUKZU
        LZUMUYAFUYEUMAUBUCZUXRUGUHZUBUYFUNZUYAFUYFUXRUYFUOZUYIURAUXRUYEUOZUEUXT
        UGUHZURZUYIURZUYAUYJUYMUYIUYDUYLEUXRUYEUYBUXRUFUYCUXTUEUGUYBUXRUXSUPUQU
        SUTAUYNURZUYAUXTUEUGUHZUYLUYOUYPUEUXTUIVAUKZUGUHZVBZUYOUEUXRUIVCUKZUXSU
        DZUGUHZVBZUYSUYOUYTUXRUGUHZVBZVUCUYOUYKVUEAUYMUYKUYIAUYKUYLVDZVEUYKUXRU
        YTVFUHVUEUYKUXRUYEVGUXRUYEVHVGUYEUIVIUDZVHUIHVJUIVKVLVMVLZVNZVOUYKUXRUY
        TVUIUYKUXRUIVUIUIVGUOZUYKVPVQVRVSVTWAZUYOUYIUYTUYEUOZVUEVUCWDAUYMUYIWBA
        UYMVULUYIAUYMVULAUYLUXRHUFZVBZUYKVULAVUMUYLAVUMUYLVBZAVUMURZHUXSUDZUEVF
        UHZVUOAVURVUMUAWCVUPUXTUEVFUHZVURVUOVUPUXTVUQUEVFVUPUXRHUXSAVUMWEWFWGAV
        UMVUSVUOWHZAVUMAUYKURVUTAVUMUYKAUYKVUMHUYEUOZAHVUGUOZVVAAHWIUOZVVBSHWJW
        KUIHWLWAUXRHUYEWMWNWPUYKAUXRUEHUJUKZUOZVUTUIUEVIUDUOZUYKVVEWDVVFUIVHUOZ
        UEUIUGUHWQWOUEUIXFWRWSZVVFUYEVVDUXRUIUEHWTZXAXGZAVVEURZUXTUEVVKUXTVVKBC
        DEGUXRIJKLMNOPQACKUOZVVERWCVVEUXRVHUOZAUXRUEHXBXCXDZXEUEVGUOZVVKXHVQVSX
        IXJXKXLVTXMXNAUYKVUNURZUXRUIHUIVAUKZUJUKUOZVULAUYKVUMVVRXOZWDVVPVVRWDAU
        YKVVSAUYKVVRVUMXOZVVSAUXRUIVVQUIVCUKZUJUKZUOZVVRUXRVWAUFZXOZUYKVVTAVVQV
        UGUOZVWCVWEWHAVVQWIUOZVWFAVWGHUIUFZVWGXOZAVVCVWISHXPWAAVWGVWHVBZVBZVWGX
        OZVWIAVWJVWGVWLWHAVWHUEVUQUGUHZAVWHURZUYDEHYKZUMZVWMVWNUYDEUYEUMZVWPAVW
        QVWHTWCVWNUYDEUYEVWOVWNHHUJUKZUYEVWOVWHVWRUYEUFAHUIHUJXQXCAVWRVWOUFZVWH
        AHVHUOVWSAHSXRZHXSWAWCXTYAVTAVWPVWMWHZVWHAVVCVXASUYDVWMEHWIUYBHUFUYCVUQ
        UEUGUYBHUXSUPUQYBWAWCVTVWNVURVWMVBZAVURVWHUAWCAVURVXBWHVWHAVUQUEAVUQABC
        DEGHIJKLMNOPQRVWTXDXEVVOAXHVQVSWCVTUUAVWJVWGUUCWAVWHVWKVWGVWHUUDUUEUUFY
        CZVVQWJWKUXRUIVVQUUGWAAVWBUYEUXRAVWAHUIUJAHUIAHSUUMUIUUBUOZAYDVQUUHZUUI
        YEAVWDVUMVVRAVWAHUXRVXEYFUUJUUKVVRVUMUUNUULUUOUYKVUMVVRUUPYGAVVRVULAVVR
        URUYTUIUIVCUKZVWAUJUKZUOZVULAVVRVXHAVVRVVRVXHAVVGVVQVHUOZURVVMVVGURVVRV
        XHWHVVRAVXIVVGAVVQVXCXRWQUUQVVRVVMVVGUXRUIVVQXBWQUURUXRUIUIVVQUUSUUTUVC
        UVAAVXHVULWDVVRAVXHUYTYHHUJUKZUOVULAVXGVXJUYTAVXFYHVWAHUJVXFYHUFAYIVQVX
        EUVDYEVXJUYEUYTYHVUGUOZVXJUYEYLVXKUIYHUGUHZUIVXFYHUGUIUIVPUVEUVBYIUVFVV
        GYHVHUOVXKVXLWHWQUVGUIYHUVHYJUVIYHUIHWTXGVNUVJWCYMXMUVNUVKZXKZVEZUYIVUL
        URVUBVUDUYIVULVUBVUDVULVUBURUYIUYTUYFUOVUDUYDVUBEUYTUYEUYBUYTUFUYCVUAUE
        UGUYBUYTUXSUPUQUSUYHVUDUBUYTUYFUYGUYTUXRUGUVLUVMUVOZUVPUVQYNYMUYOVUAUYQ
        UFZVUCUYSWHUYOUYTCUOZVBZVXQUYOVXRVUDVUKUYOVXRURUYIVULVUBVUDAUYMUYIVXRYO
        UYOVULVXRVXOWCAUYMVXRVUBUYIAUYMURZVXRURZUEVUAVVOVYAXHVQVYAAUYTVVDUOZVUA
        VGUOAUYMVXRUVRZVVFVYAVULVYBVVHVXTVULVXRVXNWCVVFUYEVVDUYTVVIXAUVSAVYBURZ
        VUAVYDBCDEGUYTIJKLMNOPQAVVLVYBRWCVYBUYTVHUOAUYTUEHXBXCXDXEYNVYAUYLUEVUA
        VFUHZAUYKUYLVXRYOVYAAVVEVUAUXTUIVCUKZUFZUYLVYEWHVYCVYAUYKVVEVXTUYKVXRVU
        FWCZVVJWAVYAVUAUYTUIVAUKZUXSUDZUIVCUKZUFZVYGVXTAVULURZVXRVYLAUYMVULVXMU
        WDZVYMVXRVYLVYMVXSVUAVYJUIVAUKZUFZWDZVXRVYLWDZVYMBCDEGUYTIJKLMNOPQAVVLV
        ULRWCVULUYTWIUOAUYTHUVTXCUWAZUWBXKYPVYAUYKVYLVYGWHVYHUYKVYKVYFVUAUYKVYJ
        UXTUIVCUYKVYIUXRUXSUYKUXRUIUYKUXRUXRUIHXBUWEVXDUYKYDVQUWCWFZYQYFWAVTVVK
        VYGURUYLUEVYFVFUHZVYEVVKUYLWUAWHZVYGVVKUEVHUOZUXTVHUOZWUBXFVVNUEUXTUWFU
        WGWCVYGVYEWUAWHVVKVUAVYFUEVFYRXCUWHUWIVTUWJYSVXPUWNUWKAUYMVXSVXQUYIVXTV
        XSURZVYPVXQVXTVYMVXSVYPVYNVYMVXSVYPVYMVYQVYRVYSUWLXKYPWUEUYKVYPVXQWHVXT
        UYKVXSVUFWCUYKVYOUYQVUAUYKVYJUXTUIVAVYTYQYFWAVTYSUWMVXQVUBUYRVUAUYQUEUG
        YRUWOWAVTUYOWUDUYPUYSWHAUYMWUDUYIAUYMVVEWUDVXTUYKVVEVUFVVJWAVVNUWPVEZWU
        DUYPUYQUEVFUHZUYSWUDWUCUYPWUGWHXFUXTUEUWQUWRWUDUYQUEWUDUXTUIUXTUWSVUJWU
        DVPVQUWTVVOWUDXHVQVSUXAWAYCAUYKUYLUYIUXBUYOUXTUEUYOUXTWUFXEVVOUYOXHVQUX
        CUXDUXEAUYFVGYLZUYFYTUOZUYFUXFUXGZUYIFUYFUMWUHAUYFUYEVGUYDEUYEUXHZVUHVL
        VQWUIAUYEYTUOUYFUYEYLWUIUIHUXIWUKUYEUYFUXJYJVQAVWQWUJTUYDEUYEUXKYGFUBUY
        FUXLUXOUXMUYAUYAFUYFUYEUYJUYKUYAUYDEUXRUYEUXNUXPUXQWA $.
    $}

    ${
      $d b c M $.  $d b C $.
      $( ` ( F `` C ) ` finishes counting at ` ( M - N ) ` .  (Contributed by
         Thierry Arnoux, 25-Nov-2016.) $)
      ballotlemfmpn $p |- ( C e. O ->
                                     ( ( F ` C ) ` ( M + N ) ) = ( M - N ) ) $=
        ( wcel co cfv chash cmin wceq vb caddc c1 cfz cin cdif id cz cn nnaddcl
        mp2an nnzi a1i ballotlemfval wss cpw cv crab ssrab2 eqsstri sseli dfss1
        elpwid sylib fveq2d cab rabssab eleq2s fveq2 eqeq1d cbvabv elab2g mpbid
        eqtrd cfn fzfi hashssdif sylancr cn0 nnnn0i hashfz1 mp1i oveq12d pncan2
        cc nncni 3eqtrd ) BHOZFGUBPZBEQQUCWIUDPZBUEZRQZWJBUFRQZSPFGSPWHABCDEWIF
        GHIJKLMNWHUGWIUHOWHWIFUIOGUIOWIUIOJKFGUJUKZULUMUNWHWLFWMGSWHWLBRQZFWHWK
        BRWHBWJUOZWKBTWHBWJHWJUPZBHIUQZRQZFTZIWQURZWQLWTIWQUSUTVAVCZBWJVBVDVEWH
        BWTIVFZOZWOFTZXDBXAHXAXCBWTIWQVGVALVHUAUQZRQZFTZXEUABXCHXFBTXGWOFXFBRVI
        VJWTXHIUAWRXFTWSXGFWRXFRVIVJVKVLVMZVNWHWMWJRQZWOSPZWIFSPZGWHWJVOOWPWMXK
        TUCWIVPXBWJBVQVRWHXJWIWOFSWIVSOXJWITWHWIWNVTWIWAWBXIWCXLGTZWHFWEOGWEOXM
        FJWFGKWFFGWDUKUMWGWCVN $.
    $}

    $( ` ( F `` C ) ` always starts counting at 0 .  (Contributed by Thierry
       Arnoux, 25-Nov-2016.) $)
    ballotlemfval0 $p |- ( C e. O -> ( ( F ` C ) ` 0 ) = 0 ) $=
      ( cc0 cfv co chash c0 eqtri wcel c1 cfz cin cdif cmin id cz ballotlemfval
      0z a1i fz10 ineq1i incom 3eqtr2i fveq2i hash0 difeq1i 0dif oveq12i subidi
      in0 0cn syl6eq ) BHUAZOBEPPUBOUCQZBUDZRPZVFBUEZRPZUFQZOVEABCDEOFGHIJKLMNV
      EUGOUHUAVEUJUKUIVKOOUFQOVHOVJOUFVHSRPZOVGSRVGSBUDBSUDSVFSBULUMBSUNBVBUOUP
      UQTVJVLOVISRVISBUESVFSBULURBUSTUPUQTUTOVCVATVD $.

    $( E is the event where A is strictly ahead throughout the count. $)
    ballotth.e $e |- E = { c e. O | A. i e. ( 1 ... ( M + N ) )
      0 < ( ( F ` c ) ` i ) } $.

    ${
      $d c d $.  $d d i $.  $d d C $.  $d d F $.  $d d M $.  $d d N $.
      $d d O $.
      $( Elements of ` E ` .  (Contributed by Thierry Arnoux, 14-Dec-2016.) $)
      ballotleme $p |- ( C e. E <->
        ( C e. O /\ A. i e. ( 1 ... ( M + N ) ) 0 < ( ( F ` C ) ` i ) ) ) $=
        ( vd cc0 cfv clt cv wbr c1 caddc co cfz wral wceq fveq1d breq2d ralbidv
        fveq2 crab cbvrabv eqtri elrab2 ) RDUAZQUAZFSZSZTUBZDUCGHUDUEUFUEZUGZRU
        QBFSZSZTUBZDVBUGQBIEURBUHZVAVFDVBVGUTVERTVGUQUSVDURBFULUIUJUKERUQJUAZFS
        ZSZTUBZDVBUGZJIUMVCQIUMPVLVCJQIVHURUHZVKVADVBVMVJUTRTVMUQVIUSVHURFULUIU
        JUKUNUOUP $.
    $}

    ${
      $d i j C $.  $d c i F $.  $d j F $.  $d j M $.  $d j N $.  $d j O $.
      $( Elements of ` ( O \ E ) ` .  (Contributed by Thierry Arnoux,
         7-Dec-2016.) $)
      ballotlemodife $p |- ( C e. ( O \ E ) <->
        ( C e. O /\ E. i e. ( 1 ... ( M + N ) ) ( ( F ` C ) ` i ) <_ 0 ) ) $=
        ( vj wcel wa cc0 cdif wn cv cfv cle wbr c1 caddc co cfz wrex eldif wral
        clt wo wi df-or pm3.24 a1bi bitr4i ballotleme notbii anbi2i andi 3bitri
        ianor cr wss 0p1e1 oveq1i cz 0z fzp1ss ax-mp eqsstr3i a1i imdistani wsb
        sseld simpl elfzelz adantl ballotlemfelz zred sbimi nfv clelsb3 anbi12i
        sban sbf bitri weq fveq2 eleq1d sbie 3imtr3i syl lenltd rexbidva rexnal
        0re syl6bb pm5.32i 3bitr4i ) BIEUARBIRZBERZUBZSZXEDUCZBFUDZUDZTUEUFZDUG
        GHUHUIZUJUIZUKZSZBIEULXEXEUBZSZXETXKUNUFZDXNUMZUBZSZUOZYBXHXPYCXRUBZYBU
        PYBXRYBUQYDYBXEURUSUTXHXEXEXTSZUBZSXEXQYAUOZSYCXGYFXEXFYEABCDEFGHIJKLMN
        OPVAVBVCYFYGXEXEXTVFVCXEXQYAVDVEXEXOYAXEXOXSUBZDXNUKYAXEXLYHDXNXEXIXNRZ
        SZXKTYJXEXITXMUJUIZRZSZXKVGRZXEYIYLXEXNYKXIXNYKVHXEXNTUGUHUIZXMUJUIZYKY
        OUGXMUJVIVJTVKRYPYKVHVLTXMVMVNVOVPVSVQXEQUCZYKRZSZQDVRZYQXJUDZVGRZQDVRY
        MYNYSUUBQDYSUUAYSABCDFYQGHIJKLMNOXEYRVTYRYQVKRXEYQTXMWAWBWCWDWEYTXEQDVR
        ZYRQDVRZSYMXEYRQDWIUUCXEUUDYLXEQDXEQWFWJDQYKWGWHWKUUBYNQDYNQWFQDWLUUAXK
        VGYQXIXJWMWNWOWPWQTVGRYJXAVPWRWSXSDXNWTXBXCXDWK $.
    $}

    $( If the first pick is a vote for B, A is not ahead throughout the count
       (Contributed by Thierry Arnoux, 25-Nov-2016.) $)
    ballotlem4 $p |- ( C e. O -> ( -. 1 e. C -> -. C e. E ) ) $=
      ( wcel c1 cc0 clt wn wa cv cfv wbr caddc co cfz wral cuz cn nnaddcl mp2an
      wrex elnnuz mpbi eluzfz1 ax-mp cmin cle 0le1 0re 1re lenlti cr wb ltsub13
      mp3an subidi breq2i bitri mtbir 1m1e0 fveq2i ballotlemfval0 syl5eq oveq1d
      0cn breq2d mtbiri adantr wceq simpl 1nn a1i ballotlemfp1 simpld mpan2 imp
      wi mtbird fveq2 notbid rspcev sylancr rexnal sylib ballotleme simprbi ex
      nsyl ) BIQZRBQZUAZBEQZUAXBXDUBZSDUCZBFUDZUDZTUEZDRGHUFUGZUHUGZUIZXEXFXJUA
      ZDXLUNZXMUAXFRXLQZSRXHUDZTUEZUAZXOXKRUJUDQZXPXKUKQZXTGUKQHUKQYAKLGHULUMXK
      UOUPRXKUQURZXFXRSRRUSUGZXHUDZRUSUGZTUEZXBYFUAXDXBYFSSRUSUGZTUEZYHRSTUEZSR
      UTUEYIUAVASRVBVCVDUPYHRSSUSUGZTUEZYISVEQZYLRVEQYHYKVFVBVBVCSSRVGVHYJSRTSV
      RVIVJVKVLXBYEYGSTXBYDSRUSXBYDSXHUDSYCSXHVMVNABCDFGHIJKLMNOVOVPVQVSVTWAXFX
      QYESTXBXDXQYEWBZXBXPXDYMWJZYBXBXPUBZYNXCXQYDRUFUGWBWJYOABCDFRGHIJKLMNOXBX
      PWCRUKQYOWDWEWFWGWHWIVSWKXNXSDRXLXGRWBZXJXRYPXIXQSTXGRXHWLVSWMWNWOXJDXLWP
      WQXEXBXMABCDEFGHIJKLMNOPWRWSXAWT $.

    $( From now on, we assume that A wins the poll $)
    ballotth.mgtn $e |- N < M $.

    $d i k E $.  $d k C $.
    $( If A is not ahead throughout, there is a ` k ` where votes are tied.
       (Contributed by Thierry Arnoux, 1-Dec-2016.) $)
    ballotlem5 $p |- ( C e. ( O \ E ) ->
      E. k e. ( 1 ... ( M + N ) ) ( ( F ` C ) ` k ) = 0 ) $=
      ( wcel co cdif caddc eldifi cn a1i nnaddcld cv cfv cc0 cle ballotlemodife
      wbr cfz wrex simprbi cmin nnrei posdifi mpbi wceq ballotlemfmpn syl5breqr
      c1 clt syl ballotlemfc0 ) BJFUASZABCDEGHIUBTZHIJKLMNOPBJFUCZVGHIHUDSVGLUE
      IUDSVGMUEUFVGBJSZDUGBGUHZUHUIUJULDVCVHUMTUNABCDFGHIJKLMNOPQUKUOVGUIHIUPTZ
      VHVKUHZVDIHVDULUIVLVDULRIHIMUQHLUQURUSVGVJVMVLUTVIABCDGHIJKLMNOPVAVEVBVF
      $.

    $( Let I be the first time a tie is reached in a given count. $)
    ballotth.i $e |- I = ( c e. ( O \ E ) |-> sup ( { k e. ( 1 ... ( M + N ) )
      | ( ( F ` c ) ` k ) = 0 } , RR , `' < ) ) $.

    $d I k $.  $d c d k $.  $d c i k E $.
    ${
      $d d C $.  $d d E $.  $d d F $.  $d d M $.  $d d N $.  $d d O $.
      $( Value of ` I ` for a given counting ` C ` .  (Contributed by Thierry
         Arnoux, 1-Dec-2016.) $)
      ballotlemi $p |- ( C e. ( O \ E ) -> ( I ` C ) = sup (
       { k e. ( 1 ... ( M + N ) ) | ( ( F ` C ) ` k ) = 0 } , RR , `' < ) ) $=
        ( vd cv cfv cc0 wceq c1 caddc co cfz crab cr clt ccnv csup fveq2 fveq1d
        cdif rabbidv supeq1d cmpt cbvmptv eqtri wor ltso cnvso mpbi supex fvmpt
        eqeq1d ) UABEUBZUAUBZGUCZUCZUDUEZEUFIJUGUHUIUHZUJZUKULUMZUNZVJBGUCZUCZU
        DUEZEVOUJZUKVQUNKFUQZHVKBUEZUKVPWBVQWDVNWAEVOWDVMVTUDWDVJVLVSVKBGUOUPVI
        URUSHLWCVJLUBZGUCZUCZUDUEZEVOUJZUKVQUNZUTUAWCVRUTTLUAWCWJVRWEVKUEZUKWIV
        PVQWKWHVNEVOWKWGVMUDWKVJWFVLWEVKGUOUPVIURUSVAVBUKWBVQUKULVCUKVQVCVDUKUL
        VEVFVGVH $.
    $}

    $( Properties of ` ( I `` C ) ` .  (Contributed by Thierry Arnoux,
       12-Dec-2016.) $)
    ballotlemiex $p |- ( C e. ( O \ E ) -> ( ( I ` C ) e. ( 1 ... ( M + N ) )
      /\ ( ( F ` C ) ` ( I ` C ) ) = 0 ) ) $=
      ( cdif wcel cfv cv cc0 wceq c1 caddc co cfz crab clt ccnv csup ballotlemi
      wa cr wor cfn c0 wne wss ltso cnvso mpbi a1i fzfi ssrab2 mp2an ballotlem5
      ssfi wrex rabn0 sylibr cz cuz fzssuz uzssz sstri fisupcl syl13anc eqeltrd
      zssre fveq2 eqeq1d elrab sylib ) BKFUAUBZBHUCZEUDZBGUCZUCZUEUFZEUGIJUHUIZ
      UJUIZUKZUBWIWOUBWIWKUCZUEUFZUPWHWIWPUQULUMZUNZWPABCDEFGHIJKLMNOPQRSTUOWHU
      QWSURZWPUSUBZWPUTVAZWPUQVBZWTWPUBXAWHUQULURXAVCUQULVDVEVFXBWHWOUSUBWPWOVB
      XBUGWNVGWMEWOVHZWOWPVKVIVFWHWMEWOVLXCABCDEFGIJKLMNOPQRSVJWMEWOVMVNXDWHWPW
      OUQXEWOVOUQWOUGVPUCVOUGWNVQUGVRVSWCVSVSVFUQWPWSVTWAWBWMWREWIWOWJWIUFWLWQU
      EWJWIWKWDWEWFWG $.

    $d c E $.  $d i I $.
    ${
      $d c k y z $.  $d y z C $.  $d y z F $.  $d y z M $.  $d y z N $.
      $( The first tie cannot be reached at the first pick.  (Contributed by
         Thierry Arnoux, 12-Mar-2017.) $)
      ballotlemi1 $p |- ( ( C e. ( O \ E ) /\ -. 1 e. C ) ->
                                                           ( I ` C ) =/= 1 ) $=
        ( cdif wcel c1 wn wa cfv wceq cc0 cmin co wne 0re 1re resubcli clt 0lt1
        wbr cr wb ltsub23 mp3an 0cn subidi breq1i bitr2i mpbi gtneii necon3abii
        eqcom wi caddc eldifi cn 1nn a1i ballotlemfp1 simpld imp ballotlemfval0
        1m1e0 fveq2i oveq1i syl adantr oveq1d 3eqtrrd eqeq1d mtbii ballotlemiex
        cfz simprd ad2antrr fveq2 adantl mpbid mtand neneqad ) BKFUAUBZUCBUBZUD
        ZUEZBHUFZUCXAXBUCUGZUCBGUFZUFZUHUGZXAUHUCUIUJZUHUGZXFUHXGUKXHUDXGUHUHUC
        ULUMUNUHUCUOUQZXGUHUOUQZUPXJUHUHUIUJZUCUOUQZXIUHURUBZUCURUBXMXJXLUSULUM
        ULUHUCUHUTVAXKUHUCUOUHVBVCVDVEVFVGXHUHXGUHXGVIVHVFXAXGXEUHXAXEUCUCUIUJZ
        XDUFZUCUIUJZUHXDUFZUCUIUJZXGWRWTXEXPUGZWRWTXSVJWSXEXOUCVKUJUGVJWRABCDGU
        CIJKLMNOPQBKFVLZUCVMUBWRVNVOVPVQVRXPXRUGXAXOXQUCUIXNUHXDVTWAWBVOXAXQUHU
        CUIWRXQUHUGZWTWRBKUBYAXTABCDGIJKLMNOPQVSWCWDWEWFWGWHXAXCUEXBXDUFZUHUGZX
        FWRYCWTXCWRXBUCIJVKUJWJUJUBYCABCDEFGHIJKLMNOPQRSTWIWKWLXCYCXFUSXAXCYBXE
        UHXBUCXDWMWGWNWOWPWQ $.

      $( The first tie cannot be reached at the first pick.  (Contributed by
         Thierry Arnoux, 4-Apr-2017.) $)
      ballotlemii $p |- ( ( C e. ( O \ E ) /\ 1 e. C ) -> ( I ` C ) =/= 1 ) $=
        ( cdif wcel c1 wa cfv wceq cc0 caddc co wn 1e0p1 ax-1ne0 eqnetrri df-ne
        wne mpbi cmin wi eldifi cn 1nn a1i ballotlemfp1 simprd imp 1m1e0 fveq2i
        oveq1i ballotlemfval0 syl adantr oveq1d 3eqtrrd eqeq1d cfz ballotlemiex
        mtbii ad2antrr wb fveq2 adantl mpbid mtand neneqad ) BKFUAUBZUCBUBZUDZB
        HUEZUCWGWHUCUFZUCBGUEZUEZUGUFZWGUGUCUHUIZUGUFZWLWMUGUOWNUJUCWMUGUKULUMW
        MUGUNUPWGWMWKUGWGWKUCUCUQUIZWJUEZUCUHUIZUGWJUEZUCUHUIZWMWEWFWKWQUFZWEWF
        UJWKWPUCUQUIUFURWFWTURWEABCDGUCIJKLMNOPQBKFUSZUCUTUBWEVAVBVCVDVEWQWSUFW
        GWPWRUCUHWOUGWJVFVGVHVBWGWRUGUCUHWEWRUGUFZWFWEBKUBXBXAABCDGIJKLMNOPQVIV
        JVKVLVMVNVQWGWIUDWHWJUEZUGUFZWLWEXDWFWIWEWHUCIJUHUIVOUIUBXDABCDEFGHIJKL
        MNOPQRSTVPVDVRWIXDWLVSWGWIXCWKUGWHUCWJVTVNWAWBWCWD $.

      $d k w y z $.  $d w C $.  $d w F $.  $d w M $.  $d w N $.
      $( The set of zeroes of ` F ` satisfies the conditions to have a supremum
         (Contributed by Thierry Arnoux, 1-Dec-2016.) $)
      ballotlemsup $p |- ( C e. ( O \ E ) -> E. z e. RR ( A. w e.
        { k e. ( 1 ... ( M + N ) ) | ( ( F ` C ) ` k ) = 0 } -. z `' < w
        /\ A. w e. RR ( w `' < z -> E. y e.
        { k e. ( 1 ... ( M + N ) ) | ( ( F ` C ) ` k ) = 0 } w `' < y )
        ) ) $=
        ( cdif wcel cr clt ccnv wor cv cfv cc0 wceq c1 caddc co cfz crab cfn c0
        wne wss w3a wa wbr wn wral wrex fzfi ssrab2 ssfi mp2an ballotlem5 rabn0
        wi a1i sylibr cn fzssuz nnuz sseqtr4i nnssre sstri 3jca ltso cnvso mpbi
        cuz jctil fisup2g sseli anim1i reximi2 3syl ) ENIUDUEZUFUGUHZUIZHUJEJUK
        UKULUMZHUNLMUOUPZUQUPZURZUSUEZXAUTVAZXAUFVBZVCZVDCUJZDUJZWPVEVFDXAVGXGX
        FWPVEXGBUJWPVEBXAVHVODUFVGVDZCXAVHXHCUFVHWOXEWQWOXBXCXDXBWOWTUSUEXAWTVB
        XBUNWSVIWRHWTVJZWTXAVKVLVPWOWRHWTVHXCAEFGHIJLMNOPQRSTUAUBVMWRHWTVNVQXDW
        OXAWTUFXIWTVRUFWTUNWHUKVRUNWSVSVTWAWBWCWCZVPWDUFUGUIWQWEUFUGWFWGWICDBUF
        XAWPWJXHXHCXAUFXFXAUEXFUFUEXHXAUFXFXJWKWLWMWN $.

      $( ` ( I `` C ) ` is the first tie.  (Contributed by Thierry Arnoux,
         1-Dec-2016.) $)
      ballotlemimin $p |- ( C e. ( O \ E ) ->
        -. E. k e. ( 1 ... ( ( I ` C ) - 1 ) ) ( ( F ` C ) ` k ) = 0 ) $=
        ( vz vw vy cdif wcel cv cfv cc0 wceq c1 cmin co cfz clt wbr cle elfzle2
        wa adantl cz wb elfzelz caddc cn ballotlemiex simpld elfznn syl zltlem1
        nnzd syl2anr mpbird adantr wn ccnv cuz wss 1z a1i zsubcld nnaddcl mp2an
        zred nnred zlem1lt syl2anc mpbid ltled eluz fzss2 sseld crab rabid csup
        cr wral wrex wi ballotlemsup ltso cnvso mpbi id supub ballotlemi breq1d
        wor notbid sylibrd syl5bir syland ltrel relbrcnv sylnib pm2.65da nrexdv
        imp anassrs ) BKFUDUEZEUFZBGUGZUGUHUIZEUJBHUGZUJUKULZUMULZXSXTYEUEZURZY
        BXTYCUNUOZYGYHYBYGYHXTYDUPUOZYFYIXSXTUJYDUQUSYFXTUTUEYCUTUEZYHYIVAXSXTU
        JYDVBXSYCXSYCUJIJVCULZUMULZUEZYCVDUEXSYMYCYAUGUHUIABCDEFGHIJKLMNOPQRSTV
        EVFZYCYKVGVHVJZXTYCVIVKVLVMXSYFYBYHVNXSYFYBURZURYCXTUNVOZUOZYHXSYPYRVNZ
        XSYFXTYLUEZYBYSXSYEYLXTXSYKYDVPUGUEZYEYLVQXSUUAYDYKUPUOZXSYDYKXSYDXSYCU
        JYOUJUTUEXSVRVSVTZWCXSYKYKVDUEZXSIVDUEJVDUEUUDMNIJWAWBVSZWDXSYCYKUPUOZY
        DYKUNUOZXSYMUUFYNYCUJYKUQVHXSYJYKUTUEZUUFUUGVAYOXSYKUUEVJZYCYKWEWFWGWHX
        SYDUTUEUUHUUAUUBVAUUCUUIYDYKWIWFVLYDUJYKWJVHWKYTYBURXTYBEYLWLZUEZXSYSYB
        EYLWMXSUUKUUJWOYQWNZXTYQUOZVNZYSXSUAUFZUBUFZYQUOVNUBUUJWPUUPUUOYQUOUUPU
        CUFYQUOUCUUJWQWRUBWOWPURUAWOWQZUUKUUNWRAUCUAUBBCDEFGHIJKLMNOPQRSTWSUUQU
        AUBUCWOUUJXTYQWOYQXGZUUQWOUNXGUURWTWOUNXAXBVSUUQXCXDVHXSYRUUMXSYCUULXTY
        QABCDEFGHIJKLMNOPQRSTXEXFXHXIXJXKXQYCXTUNXLXMXNXRXOXP $.

      $( If the first vote is for B, the vote on the first tie is for A.
         (Contributed by Thierry Arnoux, 1-Dec-2016.) $)
      ballotlemic $p |- ( ( C e. ( O \ E ) /\ -. 1 e. C ) ->
                                                            ( I ` C ) e. C ) $=
        ( cdif wcel c1 wn wa cfv cv cc0 wceq cmin co wrex eldifi ad2antrr cn c2
        cfz cuz wne caddc ballotlemiex simpld elfznn adantr ballotlemi1 eluz2b3
        syl sylanbrc uz2m1nn cle wbr elnnuz biimpi eluzfz1 3syl wi ballotlemfp1
        1nn a1i imp 1m1e0 fveq2i oveq1i ballotlemfval0 oveq1d 3eqtrrd cr wb 0re
        1re suble0 mp2an mpbir syl6eqbrr fveq2 breq1d rspcev syl2anc clt ax-1cn
        0le1 0lt1 addid1i simprd eqtr3d cz nnzd 1z zsubcld ballotlemfelz cc 0cn
        zcnd subaddd syl5eqr syl5breq adantlr ballotlemfc0 ballotlemimin condan
        mpbid ) BKFUAUBZUCBUBZUDZUEZBHUFZBUBZEUGBGUFZUFUHUIEUCYFUCUJUKZUQUKZULZ
        YEYGUDZUEZABCDEGYIIJKLMNOPQYBBKUBZYDYLBKFUMZUNYEYIUOUBZYLYEYFUPURUFUBZY
        PYEYFUOUBZYFUCUSYQYBYRYDYBYFUCIJUTUKZUQUKUBZYRYBYTYFYHUFZUHUIZABCDEFGHI
        JKLMNOPQRSTVAZVBYFYSVCVGZVDABCDEFGHIJKLMNOPQRSTVEYFVFVHYFVIVGZVDYMUCYJU
        BZUCYHUFZUHVJVKZDUGZYHUFZUHVJVKZDYJULYEUUFYLYEYPYIUCURUFUBZUUFUUEYPUULY
        IVLVMUCYIVNVOVDYEUUHYLYEUUGUHUCUJUKZUHVJYEUUGUCUCUJUKZYHUFZUCUJUKZUHYHU
        FZUCUJUKZUUMYBYDUUGUUPUIZYBYDUUSVPYCUUGUUOUCUTUKUIVPYBABCDGUCIJKLMNOPQY
        OUCUOUBYBVRVSVQVBVTUUPUURUIYEUUOUUQUCUJUUNUHYHWAWBWCVSYEUUQUHUCUJYBUUQU
        HUIZYDYBYNUUTYOABCDGIJKLMNOPQWDVGVDWEWFUUMUHVJVKZUHUCVJVKZXAUHWGUBUCWGU
        BUVAUVBWHWIWJUHUCWKWLWMWNVDUUKUUHDUCYJUUIUCUIUUJUUGUHVJUUIUCYHWOWPWQWRY
        BYLUHYIYHUFZWSVKYDYBYLUEZUHUCUVCWSXBUVDUCUCUHUTUKZUVCUCWTXCUVDUVCUCUJUK
        ZUHUIUVEUVCUIUVDUUAUVFUHYBYLUUAUVFUIZYBYLUVGVPYGUUAUVCUCUTUKUIVPYBABCDG
        YFIJKLMNOPQYOUUDVQVBVTYBUUBYLYBYTUUBUUCXDVDXEUVDUVCUCUHUVDUVCUVDABCDGYI
        IJKLMNOPQYBYNYLYOVDUVDYFUCYBYFXFUBYLYBYFUUDXGVDUCXFUBUVDXHVSXIXJXMUCXKU
        BUVDWTVSUHXKUBUVDXLVSXNYAXOXPXQXRYBYKUDYDYLABCDEFGHIJKLMNOPQRSTXSUNXT
        $.

      $( If the first vote is for A, the vote on the first tie is for B.
         (Contributed by Thierry Arnoux, 4-Apr-2017.) $)
      ballotlem1c $p |- ( ( C e. ( O \ E ) /\ 1 e. C ) ->
                                                         -. ( I ` C ) e. C ) $=
        ( cdif wcel c1 wa cfv cv cc0 wceq cmin co cfz eldifi ad2antrr cn c2 cuz
        wrex wne ballotlemiex simpld elfznn adantr ballotlemii eluz2b3 sylanbrc
        caddc syl uz2m1nn cle wbr elnnuz biimpi eluzfz1 3syl 0le1 1e0p1 breqtri
        wn wi 1nn ballotlemfp1 simprd 1m1e0 fveq2i oveq1i ballotlemfval0 oveq1d
        a1i imp 3eqtrrd syl5breq fveq2 breq2d rspcev syl2anc cneg df-neg eqtr3d
        clt cc 0cn ax-1cn cz nnzd 1z zsubcld ballotlemfelz zcnd subadd2d mpbird
        syl5eq 0lt1 cr wb 1re lt0neg2 ax-mp mpbi syl6eqbrr adantlr ballotlemfcc
        ballotlemimin pm2.65da ) BKFUAUBZUCBUBZUDZBHUEZBUBZEUFBGUEZUEUGUHEUCYGU
        CUIUJZUKUJZUQZYFYHUDZABCDEGYJIJKLMNOPQYDBKUBZYEYHBKFULZUMYFYJUNUBZYHYFY
        GUOUPUEUBZYPYFYGUNUBZYGUCURYQYDYRYEYDYGUCIJVFUJZUKUJUBZYRYDYTYGYIUEZUGU
        HZABCDEFGHIJKLMNOPQRSTUSZUTYGYSVAVGZVBABCDEFGHIJKLMNOPQRSTVCYGVDVEYGVHV
        GZVBYMUCYKUBZUGUCYIUEZVIVJZUGDUFZYIUEZVIVJZDYKUQYFUUFYHYFYPYJUCUPUEUBZU
        UFUUEYPUULYJVKVLUCYJVMVNVBYFUUHYHYFUGUGUCVFUJZUUGVIUGUCUUMVIVOVPVQYFUUG
        UCUCUIUJZYIUEZUCVFUJZUGYIUEZUCVFUJZUUMYDYEUUGUUPUHZYDYEVRUUGUUOUCUIUJUH
        VSYEUUSVSYDABCDGUCIJKLMNOPQYOUCUNUBYDVTWHWAWBWIUUPUURUHYFUUOUUQUCVFUUNU
        GYIWCWDWEWHYFUUQUGUCVFYDUUQUGUHZYEYDYNUUTYOABCDGIJKLMNOPQWFVGVBWGWJWKVB
        UUKUUHDUCYKUUIUCUHUUJUUGUGVIUUIUCYIWLWMWNWOYDYHYJYIUEZUGWSVJYEYDYHUDZUV
        AUCWPZUGWSUVBUVCUGUCUIUJZUVAUCWQUVBUVDUVAUHUVAUCVFUJZUGUHUVBUUAUVEUGYDY
        HUUAUVEUHZYDYHVRUUAUVAUCUIUJUHVSYHUVFVSYDABCDGYGIJKLMNOPQYOUUDWAWBWIYDU
        UBYHYDYTUUBUUCWBVBWRUVBUGUCUVAUGWTUBUVBXAWHUCWTUBUVBXBWHUVBUVAUVBABCDGY
        JIJKLMNOPQYDYNYHYOVBUVBYGUCYDYGXCUBYHYDYGUUDXDVBUCXCUBUVBXEWHXFXGXHXIXJ
        XKUGUCWSVJZUVCUGWSVJZXLUCXMUBUVGUVHXNXOUCXPXQXRXSXTYAYDYLVRYEYHABCDEFGH
        IJKLMNOPQRSTYBUMYC $.
    $}

    $( For a given count ` c ` , ` S ` is the operation reflecting the index
       in a count, before a tie is reached. $)
    ballotth.s $e |- S = ( c e. ( O \ E ) |-> ( i e. ( 1 ... ( M + N ) ) |->
                   if ( i <_ ( I ` c ) , ( ( ( I ` c ) + 1 ) - i ) , i ) ) ) $.

    $d c I $.
    ${
      $d c d i k M $.  $d c d i k N $.  $d d E $.  $d d C $.  $d d I $.
      $d d O $.
      $( Value of ` S ` (Contributed by Thierry Arnoux, 12-Apr-2017.) $)
      ballotlemsval $p |- ( C e. ( O \ E ) ->
        ( S ` C ) = ( i e. ( 1 ... ( M + N ) ) |->
                   if ( i <_ ( I ` C ) , ( ( ( I ` C ) + 1 ) - i ) , i ) ) ) $=
        ( vd c1 caddc co cfz cv cfv cle wbr cmin cif cmpt cdif wceq wcel fveq2d
        simpl breq2d oveq1d eqidd ifbieq12d mpteq2dva cbvmptv eqtri mptex fvmpt
        wa ovex ) UCBEUDJKUEUFZUGUFZEUHZUCUHZIUIZUJUKZVOUDUEUFZVMULUFZVMUMZUNZE
        VLVMBIUIZUJUKZWAUDUEUFZVMULUFZVMUMZUNLGUOZDVNBUPZEVLVSWEWGVMVLUQZVIZVPW
        BVRVMWDVMWIVOWAVMUJWIVNBIWGWHUSURZUTWIVQWCVMULWIVOWAUDUEWJVAVAWIVMVBVCV
        DDMWFEVLVMMUHZIUIZUJUKZWLUDUEUFZVMULUFZVMUMZUNZUNUCWFVTUNUBMUCWFWQVTWKV
        NUPZEVLWPVSWRWHVIZWMVPWOVMVRVMWSWLVOVMUJWSWKVNIWRWHUSURZUTWSWNVQVMULWSW
        LVOUDUEWTVAVAWSVMVBVCVDVEVFEVLWEUDVKUGVJVGVH $.

      $d i j $.  $d j I $.  $d j C $.  $d j E $.  $d j F $.  $d j J $.
      $d j F $.  $d j M $.  $d j N $.  $d j O $.
      $( Value of ` S ` evaluated at ` J ` for a given counting ` C ` .
         (Contributed by Thierry Arnoux, 12-Apr-2017.) $)
      ballotlemsv $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) ) ) ->
        ( ( S ` C ) ` J ) =
                     if ( J <_ ( I ` C ) , ( ( ( I ` C ) + 1 ) - J ) , J ) ) $=
        ( vj cdif wcel c1 caddc co cfz wa cv cfv cle wbr cmin cif cvv cmpt wceq
        ballotlemsval breq1 oveq2 ifbieq12d cbvmptv syl6eq adantr breq1d oveq2d
        id simpr adantlr ovex a1i wn elex ad2antlr ifclda fvmptd ) BMGUEUFZJUGK
        LUHUIUJUIZUFZUKZUDJUDULZBIUMZUNUOZWEUGUHUIZWDUPUIZWDUQZJWEUNUOZWGJUPUIZ
        JUQZWABDUMZURVTWMUDWAWIUSZUTWBVTWMEWAEULZWEUNUOZWGWOUPUIZWOUQZUSWNABCDE
        FGHIKLMNOPQRSTUAUBUCVAEUDWAWRWIWOWDUTZWPWFWQWOWHWDWOWDWEUNVBWOWDWGUPVCW
        SVJVDVEVFVGVTWDJUTZWIWLUTWBVTWTUKZWFWJWHWDWKJXAWDJWEUNVTWTVKZVHXAWDJWGU
        PXBVIXBVDVLVTWBVKWCWJWKJURWKURUFWCWJUKWGJUPVMVNWBJURUFVTWJVOJWAVPVQVRVS
        $.
    $}

    $( ` S ` maps values less than ` ( I `` C ) ` to values greater than 1.
       (Contributed by Thierry Arnoux, 28-Apr-2017.) $)
    ballotlemsgt1 $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) )
      /\ J < ( I ` C ) ) -> 1 < ( ( S ` C ) ` J ) ) $=
      ( cdif wcel c1 caddc co cfz cfv clt wbr w3a cmin cz elfzelz 3ad2ant2 zred
      cc0 wceq ballotlemiex simpld syl 3ad2ant1 cr 1re a1i readdcld zcnd ax-1cn
      simp3 cc pncand breqtrrd ltsub13d cle cif ballotlemsv 3adant3 ltled eqtrd
      iftrue ) BMGUDUEZJUFKLUGUHZUIUHZUEZJBIUJZUKULZUMZUFWGUFUGUHZJUNUHZJBDUJUJ
      ZUKWIJWJUFWIJWFWCJUOUEWHJUFWDUPUQURZWIWGUFWIWGWCWFWGUOUEZWHWCWGWEUEZWNWCW
      OWGBHUJUJUSUTABCEFGHIKLMNOPQRSTUAUBVAVBWGUFWDUPVCVDZURZUFVEUEWIVFVGZVHWRW
      IJWGWJUFUNUHUKWCWFWHVKZWIWGUFWIWGWPVIUFVLUEWIVJVGVMVNVOWIWLJWGVPULZWKJVQZ
      WKWCWFWLXAUTWHABCDEFGHIJKLMNOPQRSTUAUBUCVRVSWIWTXAWKUTWIJWGWMWQWSVTWTWKJW
      BVCWAVN $.

    $( Domain of ` S ` for a given counting ` C ` .  (Contributed by Thierry
       Arnoux, 12-Apr-2017.) $)
    ballotlemsdom $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) ) ) ->
      ( ( S ` C ) ` J ) e. ( 1 ... ( M + N ) ) ) $=
      ( cdif wcel c1 caddc co cfz wa cfv cle wbr cmin cif ballotlemsv cz fzssuz
      wss cuz uzssz sstri cc0 wceq ballotlemiex simpld sseldi ad2antrr cn mp2an
      nnaddcl nnzi a1i elfzle2 syl eluz2 fzss2 sylbir syl3anc 1z simplr elfzle1
      w3a simpr elfz4 syl32anc fzrev3i wb cc ax-1cn addcomd oveq1d eleq1d mpbid
      zcnd sseldd wn ifclda eqeltrd ) BMGUDUEZJUFKLUGUHZUIUHZUEZUJZJBDUKUKJBIUK
      ZULUMZXEUFUGUHZJUNUHZJUOXBABCDEFGHIJKLMNOPQRSTUAUBUCUPXDXFXHJXBXDXFUJZUFX
      EUIUHZXBXHXIXEUQUEZXAUQUEZXEXAULUMZXJXBUSZWTXKXCXFWTXBUQXEXBUFUTUKUQUFXAU
      RUFVAVBZWTXEXBUEZXEBHUKUKVCVDABCEFGHIKLMNOPQRSTUAUBVEVFZVGZVHZXLXIXAKVIUE
      LVIUEXAVIUEOPKLVKVJVLVMXIXPXMWTXPXCXFXQVHXEUFXAVNVOXKXLXMWCXAXEUTUKUEXNXE
      XAVPXEUFXAVQVRVSXIUFXEUGUHZJUNUHZXJUEZXHXJUEZXIJXJUEZYBXIUFUQUEZXKJUQUEUF
      JULUMZXFYDYEXIVTVMXSXIXBUQJXOWTXCXFWAZVGXIXCYFYGJUFXAWBVOXDXFWDJUFXEWEWFJ
      UFXEWGVOWTYBYCWHXCXFWTYAXHXJWTXTXGJUNWTUFXEUFWIUEWTWJVMWTXEXRWOWKWLWMVHWN
      WPWTXCXFWQWAWRWS $.

    $( The range ` ( 1 ... ( I `` C ) ) ` is invariant under ` ( S `` C ) ` .
       (Contributed by Thierry Arnoux, 28-Apr-2017.) $)
    ballotlemsel1i $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( I ` C ) ) ) ->
      ( ( S ` C ) ` J ) e. ( 1 ... ( I ` C ) ) ) $=
      ( cdif wcel c1 cfv cfz co wa cz cle wbr a1i caddc cc0 ballotlemiex simpld
      1z wceq elfzelz syl adantr cuz nnaddcl mp2an nnzi elfzle2 eluz2 syl3anbrc
      wss cn fzss2 sselda ballotlemsdom syldan cmin adantl zred cr 1re readdcld
      zcnd cc ax-1cn pncand breqtrrd lesubd cif ballotlemsv iftrue eqtrd elfznn
      ltesubnnd eqbrtrd elfz4 syl32anc ) BMGUDUEZJUFBIUGZUHUIZUEZUJZUFUKUEZWSUK
      UEZJBDUGUGZUKUEZUFXEULUMXEWSULUMXEWTUEXCXBUSUNWRXDXAWRWSUFKLUOUIZUHUIZUEZ
      XDWRXIWSBHUGUGUPUTABCEFGHIKLMNOPQRSTUAUBUQURZWSUFXGVAVBZVCZXBXEXHUEZXFWRX
      AJXHUEZXMWRWTXHJWRXGWSVDUGUEZWTXHVKWRXDXGUKUEZWSXGULUMZXOXKXPWRXGKVLUELVL
      UEXGVLUEOPKLVEVFVGUNWRXIXQXJWSUFXGVHVBWSXGVIVJWSUFXGVMVBVNZABCDEFGHIJKLMN
      OPQRSTUAUBUCVOVPXEUFXGVAVBXBUFWSUFUOUIZJVQUIZXEULXBJXSUFXBJXAJUKUEWRJUFWS
      VAVRVSXBWSUFXBWSXLVSUFVTUEXBWAUNZWBYAXBJWSXSUFVQUIULXAJWSULUMZWRJUFWSVHVR
      ZXBWSUFXBWSXLWCUFWDUEXBWEUNWFWGWHXBXEYBXTJWIZXTWRXAXNXEYDUTXRABCDEFGHIJKL
      MNOPQRSTUAUBUCWJVPXBYBYDXTUTYCYBXTJWKVBWLZWGXBXEXTWSULYEWRXAXNXTWSULUMXRW
      RXNUJWSJWRXDXNXKVCXNJVLUEWRJXGWMVRWNVPWOXEUFWSWPWQ $.

    $d i j $.  $d j I $.  $d j C $.  $d j E $.  $d j F $.  $d j J $.  $d j F $.
    $d j M $.  $d j N $.  $d j O $.
    $( The defined ` S ` is a bijection, and an involution.  (Contributed by
       Thierry Arnoux, 14-Apr-2017.) $)
    ballotlemsf1o $p |- ( C e. ( O \ E ) ->
           ( ( S ` C ) : ( 1 ... ( M + N ) ) -1-1-onto-> ( 1 ... ( M + N ) ) /\
          `' ( S ` C ) = ( S ` C ) ) ) $=
      ( vj cdif wcel c1 caddc cfz cfv wf1o ccnv wceq cle wbr cmin ballotlemsval
      co cv cif cmpt wa ballotlemsv ballotlemsdom eqeltrrd oveq2 id breq1 cc cz
      cvv cc0 ballotlemiex simpld elfzelz peano2zd zcnd adantr nncand eqcomd cn
      syl ad2antll elfznn ltesubnnd vex a1i ovex ifeqeqx ad2antrl simplrl f1o3d
      impbida ifbieq12d cbvmptv simprd 3eqtr4rd jca ) BLGUDUEZUFJKUGUQZUHUQZWTB
      DUIZUJZXAUKZXAULWRXBXCUCWTUCURZBIUIZUMUNZXEUFUGUQZXDUOUQZXDUSZUTZULZWREUC
      WTWTEURZXEUMUNZXGXLUOUQZXLUSZXIXAABCDEFGHIJKLMNOPQRSTUAUBUPZWRXLWTUEZVAXL
      XAUIXOWTABCDEFGHIXLJKLMNOPQRSTUAUBVBABCDEFGHIXLJKLMNOPQRSTUAUBVCVDWRXDWTU
      EZVAXDXAUIXIWTABCDEFGHIXDJKLMNOPQRSTUAUBVBABCDEFGHIXDJKLMNOPQRSTUAUBVCVDW
      RXQXRVAZVAZXLXIULXDXOULXTXFXMXHXEUMUNZEXNXLXGXHUOUQZVJVJXHXDUCXLXHXGUOVEX
      LXDULZVFZXLXHXEUMVGXLXDXEUMVGZXTYBXDXTXGXDWRXGVHUEXSWRXGWRXEWTUEZXGVIUEWR
      YFXEBHUIUIVKULABCEFGHIJKLMNOPQRSTUAVLVMZYFXEXEUFWSVNZVOWAVPVQZXRXDVHUEWRX
      QXRXDXDUFWSVNVPWBVRVSXTYAXFXTXEXDWRXEVIUEZXSWRYFYJYGYHWAVQZXRXDVTUEWRXQXD
      WSWCWBWDVQXDVJUEXTUCWEWFXHVJUEXTXGXDUOWGWFWHXTXMXFXNXEUMUNUCXHXDXGXNUOUQZ
      VJVJXNXLEXDXNXGUOVEXDXLULVFXDXNXEUMVGXDXLXEUMVGXTYLXLXTXGXLYIXQXLVHUEWRXR
      XQXLXLUFWSVNVPWIVRVSXTXMVAZXEXLXTYJXMYKVQYMXQXLVTUEWRXQXRXMWJXLWSWCWAWDXL
      VJUEXTEWEWFXNVJUEXTXGXLUOWGWFWHWLWKZVMWREWTXOUTZXJXAXCYOXJULWREUCWTXOXIYC
      XMXFXNXLXHXDYEXLXDXGUOVEYDWMWNWFXPWRXBXKYNWOWPWQ $.

    $( The image by ` S ` of the first tie pick is the first pick.
       (Contributed by Thierry Arnoux, 14-Apr-2017.) $)
    ballotlemsi $p |- ( C e. ( O \ E ) -> ( ( S ` C ) ` ( I ` C ) ) = 1 ) $=
      ( cdif wcel cfv cle wbr c1 caddc co cmin cif cfz wceq ballotlemiex simpld
      cc0 ballotlemsv mpdan cr elfzelz syl leidd iftrue recnd cc ax-1cn pncan2d
      zred a1i 3eqtrd ) BLGUCUDZBIUEZBDUEUEZVMVMUFUGZVMUHUIUJVMUKUJZVMULZVPUHVL
      VMUHJKUIUJZUMUJUDZVNVQUNVLVSVMBHUEUEUQUNABCEFGHIJKLMNOPQRSTUAUOUPZABCDEFG
      HIVMJKLMNOPQRSTUAUBURUSVLVOVQVPUNVLVMVLVSVMUTUDVTVSVMVMUHVRVAVIVBZVCVOVPV
      MVDVBVLVMUHVLVMWAVEUHVFUDVLVGVJVHVK $.

    $d j k $.  $d j S $.  $d k J $.  $d k S $.
    $( The image by ` S ` of an interval before the first pick.  (Contributed
       by Thierry Arnoux, 5-May-2017.) $)
    ballotlemsima $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( I ` C ) ) ) ->
         ( ( S ` C ) " ( 1 ... J ) ) = ( ( ( S ` C ) ` J ) ... ( I ` C ) ) ) $=
      ( vj cdif wcel c1 cfv cfz co wa cima cz cv wss caddc imassrn wf1o wf ccnv
      crn wceq ballotlemsf1o simpld f1of frn 3syl syl5ss cuz fzssuz uzssz sstri
      syl6ss adantr sselda elfzelz adantl wb wfn f1ofn syl ballotlemiex elfzuz3
      wrex cc0 uztrn syl2anc fzss2 fvelimab cmin cle wbr cif 1z a1i nnzi zaddcl
      mp2an elfzle1 zred elfzle2 letrd elfz4 syl32anc ballotlemsv syldan iftrue
      simpr eqtrd oveq1d eleq2d ad2antrr ax-1cn pncand oveq2d ad2antlr peano2zd
      zcnd cc fzrev syl22anc 3bitr2d risset eqcom adantlr addcld simplr syl3anc
      subsub23 syl5bbr simpll eqeq1d bitr4d rexbidva 3bitrd eqrdav ) BMGUEUFZJU
      GBIUHZUIUJUFZUKZFBDUHZUGJUIUJZULZJUUAUHZYRUIUJZUMYTUUCUMFUNZYQUUCUMUOYSYQ
      UUCUGKLUPUJZUIUJZUMYQUUCUUAVAZUUHUUAUUBUQYQUUHUUHUUAURZUUHUUHUUAUSUUIUUHU
      OYQUUJUUAUTUUAVBABCDEFGHIKLMNOPQRSTUAUBUCVCVDZUUHUUHUUAVEUUHUUHUUAVFVGVHU
      UHUGVIUHUMUGUUGVJUGVKVLVMVNVOUUFUUEUFZUUFUMUFZYTUUFUUDYRVPVQYTUUMUKZUUFUU
      CUFZUDUNZUUAUHZUUFVBZUDUUBWDZUULYTUUOUUSVRZUUMYTUUAUUHVSZUUBUUHUOZUUTYQUV
      AYSYQUUJUVAUUKUUHUUHUUAVTWAVNYTUUGJVIUHZUFZUVBYTUUGYRVIUHUFZYRUVCUFZUVDYT
      YRUUHUFZUVEYQUVGYSYQUVGYRBHUHUHWEVBABCEFGHIKLMNOPQRSTUAUBWBVDZVNYRUGUUGWC
      WAYSUVFYQJUGYRWCVQYRUUGJWFWGJUGUUGWHWAZUDUUHUUBUUFUUAWIWGVNUUNUULYRUGUPUJ
      ZUUFWJUJZUUBUFZUUPUVKVBZUDUUBWDZUUSUUNUULUUFUVJJWJUJZYRUIUJZUFZUUFUVOUVJU
      GWJUJZUIUJZUFZUVLYTUULUVQVRUUMYTUUEUVPUUFYTUUDUVOYRUIYTUUDJYRWKWLZUVOJWMZ
      UVOYQYSJUUHUFZUUDUWBVBYTUGUMUFZUUGUMUFZJUMUFZUGJWKWLZJUUGWKWLUWCUWDYTWNWO
      UWEYTKUMUFLUMUFUWEKOWPLPWPKLWQWRWOZYSUWFYQJUGYRVPZVQZYSUWGYQJUGYRWSVQYTJY
      RUUGYTJUWJWTYTYRYQYRUMUFZYSYQUVGUWKUVHYRUGUUGVPWAZVNWTYTUUGUWHWTYSUWAYQJU
      GYRXAZVQYQYRUUGWKWLZYSYQUVGUWNUVHYRUGUUGXAWAVNXBJUGUUGXCXDABCDEFGHIJKLMNO
      PQRSTUAUBUCXEXFYTYSUWAUWBUVOVBYQYSXHUWMUWAUVOJXGVGXIXJXKVNUUNUVSUVPUUFUUN
      UVRYRUVOUIUUNYRUGUUNYRYQUWKYSUUMUWLXLZXRUGXSUFZUUNXMWOXNXOXKUUNUWDUWFUVJU
      MUFUUMUVTUVLVRUWDUUNWNWOYSUWFYQUUMUWIXPUUNYRUWOXQYTUUMXHUVJUUFUGJXTYAYBUV
      LUVNVRUUNUDUVKUUBYCWOUUNUVMUURUDUUBUUNUUPUUBUFZUKZUVMUVJUUPWJUJZUUFVBZUUR
      UVMUVKUUPVBZUWRUWTUVKUUPYDUWRUVJXSUFUUFXSUFUUPXSUFUXAUWTVRUWRYRUGUWRYRYTU
      WQUWKUUMYQUWKYSUWQUWLXLZYEXRUWPUWRXMWOYFUWRUUFYTUUMUWQYGXRUWRUUPUWQUUPUMU
      FZUUNUUPUGJVPZVQXRUVJUUFUUPYIYHYJYTUWQUURUWTVRUUMYTUWQUKZUUQUWSUUFUXEUUQU
      UPYRWKWLZUWSUUPWMZUWSUXEYQUUPUUHUFUUQUXGVBYQYSUWQYKYTUUBUUHUUPUVIVOABCDEF
      GHIUUPKLMNOPQRSTUAUBUCXEWGUXEUXFUXGUWSVBUXEUUPJYRUXEUUPUWQUXCYTUXDVQWTUXE
      JYSUWFYQUWQUWIXPWTUXEYRUXBWTUWQUUPJWKWLYTUUPUGJXAVQYSUWAYQUWQUWMXPXBUXFUW
      SUUPXGWAXIYLYEYMYNYOYMYP $.

    $d i k D $.
    $( If two countings share the same first tie, they also have the same swap
       function.  (Contributed by Thierry Arnoux, 18-Apr-2017.) $)
    ballotlemieq $p |- ( ( C e. ( O \ E ) /\ D e. ( O \ E ) /\
      ( I ` C ) = ( I ` D ) ) -> ( S ` C ) = ( S ` D ) ) $=
      ( cdif wcel cfv wceq w3a c1 caddc co cfz cv cle wbr cmin cif simpl breq2d
      oveq1d eqidd ifbieq12d mpteq2dva 3ad2ant3 ballotlemsval 3ad2ant1 3ad2ant2
      cmpt wa 3eqtr4d ) BMHUDZUEZCVKUEZBJUFZCJUFZUGZUHFUIKLUJUKULUKZFUMZVNUNUOZ
      VNUIUJUKZVRUPUKZVRUQZVHZFVQVRVOUNUOZVOUIUJUKZVRUPUKZVRUQZVHZBEUFZCEUFZVPV
      LWCWHUGVMVPFVQWBWGVPVRVQUEZVIZVSWDWAVRWFVRWLVNVOVRUNVPWKURZUSWLVTWEVRUPWL
      VNVOUIUJWMUTUTWLVRVAVBVCVDVLVMWIWCUGVPABDEFGHIJKLMNOPQRSTUAUBUCVEVFVMVLWJ
      WHUGVPACDEFGHIJKLMNOPQRSTUAUBUCVEVGVJ $.

    $( R is the operation reflecting the picks in a count,
       before a tie is reached. $)
    ballotth.r $e |- R = ( c e. ( O \ E ) |-> ( ( S ` c ) " c ) ) $.

    $d i S $.  $d c S $.
    ${
      $d c d i $.  $d d E $.  $d d I $.  $d d O $.  $d d C $.  $d d S $.
      $d c I $.  $d i J $.  $d i I $.
      $( Value of ` R ` .  (Contributed by Thierry Arnoux, 14-Apr-2017.) $)
      ballotlemrval $p |- ( C e. ( O \ E )
            -> ( R ` C ) = ( ( S ` C ) " C ) ) $=
        ( vd cv cfv cima cdif wceq fveq2 id imaeq12d cmpt cbvmptv cvv wcel fvex
        eqtri imaexg ax-mp fvmpt ) UEBUEUFZEUGZVCUHZBEUGZBUHZMHUIZDVCBUJZVDVFVC
        BVCBEUKVIULUMDNVHNUFZEUGZVJUHZUNUEVHVEUNUDNUEVHVLVEVJVCUJZVKVDVJVCVJVCE
        UKVMULUMUOUSVFUPUQVGUPUQBEURVFBUPUTVAVB $.
    $}

    $( The image of ` ( R `` C ) ` by ` ( S `` C ) ` (Contributed by Thierry
       Arnoux, 21-Apr-2017.) $)
    ballotlemscr $p |- ( C e. ( O \ E ) -> ( ( S ` C ) " ( R ` C ) ) = C ) $=
      ( cdif wcel cfv cima ccnv ballotlemrval imaeq2d c1 caddc co cfz wf1o wceq
      ballotlemsf1o simprd imaeq1d wf1 wss simpld f1of1 syl eldifi ballotlemelo
      chash simplbi f1imacnv syl2anc 3eqtr2d ) BMHUEUFZBEUGZBDUGZUHVNVNBUHZUHVN
      UIZVPUHZBVMVOVPVNABCDEFGHIJKLMNOPQRSTUAUBUCUDUJUKVMVQVNVPVMULKLUMUNUOUNZV
      SVNUPZVQVNUQZABCEFGHIJKLMNOPQRSTUAUBUCURZUSUTVMVSVSVNVAZBVSVBZVRBUQVMVTWC
      VMVTWAWBVCVSVSVNVDVEVMBMUFZWDBMHVFWEWDBVHUGKUQBKLMNOPQVGVIVEVSVSBVNVJVKVL
      $.

    ${
      $( Value of ` R ` evaluated at ` J ` .  (Contributed by Thierry Arnoux,
         17-Apr-2017.) $)
      ballotlemrv $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) ) ) ->
        ( J e. ( R ` C ) <->
              if ( J <_ ( I ` C ) , ( ( ( I ` C ) + 1 ) - J ) , J ) e. C ) ) $=
        ( cdif wcel c1 caddc co cfz wa cfv ccnv cima cle wbr cmin cif wfun wf1o
        cdm wb simpl wceq ballotlemsf1o simpld f1ofun 3syl simpr f1odm eleqtrrd
        fvimacnv syl2anc ballotlemsv eleq1d simprd imaeq1d ballotlemrval eqtr4d
        eleq2d syl 3bitr3rd ) BNHUFUGZKUHLMUIUJUKUJZUGZULZKBEUMZUMZBUGZKWHUNZBU
        OZUGZKBJUMZUPUQWNUHUIUJKURUJKUSZBUGKBDUMZUGZWGWHUTZKWHVBZUGWJWMVCWGWDWE
        WEWHVAZWRWDWFVDZWDWTWKWHVEZABCEFGHIJLMNOPQRSTUAUBUCUDVFZVGZWEWEWHVHVIWG
        KWEWSWDWFVJWGWDWTWSWEVEXAXDWEWEWHVKVIVLKBWHVMVNWGWIWOBABCEFGHIJKLMNOPQR
        STUAUBUCUDVOVPWGWDWMWQVCXAWDWLWPKWDWLWHBUOWPWDWKWHBWDWTXBXCVQVRABCDEFGH
        IJLMNOPQRSTUAUBUCUDUEVSVTWAWBWC $.

      $( Value of ` R ` before the tie.  (Contributed by Thierry Arnoux,
         11-Apr-2017.) $)
      ballotlemrv1 $p
       |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) ) /\ J <_ ( I ` C ) ) ->
                     ( J e. ( R ` C ) <-> ( ( ( I ` C ) + 1 ) - J ) e. C ) ) $=
  ( cdif wcel c1 caddc co cfz cfv cle wbr w3a cif wb ballotlemrv 3adant3 iftrue
  cmin eleq1d 3ad2ant3 bitrd ) BNHUFUGZKUHLMUIUJUKUJUGZKBJULZUMUNZUOKBDULUGZVHV
  GUHUIUJKVAUJZKUPZBUGZVJBUGZVEVFVIVLUQVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEURUSVHVE
  VLVMUQVFVHVKVJBVHVJKUTVBVCVD $.

      $( Value of ` R ` after the tie.  (Contributed by Thierry Arnoux,
         11-Apr-2017.) $)
      ballotlemrv2 $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) ) /\
        ( I ` C ) < J ) -> ( J e. ( R ` C ) <-> J e. C ) ) $=
        ( cdif wcel c1 caddc co cfz cfv clt wbr w3a cle cmin cif wb ballotlemrv
        3adant3 wn wceq wa cz cuz fzssuz uzssz sstri ballotlemiex simpld sseldi
        cc0 adantr zred simpr ltnled biimp3a iffalse syl eleq1d bitrd ) BNHUFUG
        ZKUHLMUIUJZUKUJZUGZBJULZKUMUNZUOZKBDULUGZKWGUPUNZWGUHUIUJKUQUJZKURZBUGZ
        KBUGWCWFWJWNUSWHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUTVAWIWMKBWIWKVBZWMKVCWCW
        FWHWOWCWFVDZWGKWPWGWCWGVEUGWFWCWEVEWGWEUHVFULVEUHWDVGUHVHVIZWCWGWEUGWGB
        IULULVMVCABCFGHIJLMNOPQRSTUAUBUCVJVKVLVNVOWPKWPWEVEKWQWCWFVPVLVOVQVRWKW
        LKVSVTWAWB $.

      $( Range of ` R ` is included in ` O ` .  (Contributed by Thierry Arnoux,
         17-Apr-2017.) $)
      ballotlemro $p |- ( C e. ( O \ E ) -> ( R ` C ) e. O ) $=
        ( cdif wcel cfv c1 caddc co cfz wss wceq cima ballotlemrval crn imassrn
        chash wf1o wfo ccnv ballotlemsf1o simpld forn 3syl syl5sseq eqsstrd cen
        f1ofo wbr wf1 f1of1 syl wa eldifi ballotlemelo sylib id syl3anc eqbrtrd
        f1imaeng hasheni simprd eqtrd sylanbrc ) BMHUEZUFZBDUGZUHKLUIUJUKUJZULW
        HURUGZKUMWHMUFWGWHBEUGZBUNZWIABCDEFGHIJKLMNOPQRSTUAUBUCUDUOZWGWKUPZWLWI
        WKBUQWGWIWIWKUSZWIWIWKUTWNWIUMWGWOWKVAWKUMABCEFGHIJKLMNOPQRSTUAUBUCVBVC
        ZWIWIWKVIWIWIWKVDVEVFVGWGWJBURUGZKWGWHBVHVJWJWQUMWGWHWLBVHWMWGWIWIWKVKZ
        BWIULZWGWLBVHVJWGWOWRWPWIWIWKVLVMWGWSWQKUMZWGBMUFWSWTVNBMHVOBKLMNOPQVPV
        QZVCWGVRWIWIBWKWFWAVSVTWHBWBVMWGWSWTXAWCWDWHKLMNOPQVPWE $.
    $}

    $d i R $.
    ${
      $d u v C $.  $d u v I $.  $d u v J $.  $d u v R $.  $d u v S $.
      $d u v U $.  $d u v V $.
      $( ` .^ ` is the difference of counts of elements of ` U ` in / out of
         set ` V ` . $)
      ballotlemg $e |- .^ = ( u e. Fin , v e. Fin |->
                               ( ( # ` ( v i^i u ) ) - ( # ` ( v \ u ) ) ) ) $.
      $( Expand the value of ` .^ ` .  (Contributed by Thierry Arnoux,
         21-Apr-2017.) $)
      ballotlemgval $p |- ( ( U e. Fin /\ V e. Fin ) ->
                  ( U .^ V ) = ( ( # ` ( V i^i U ) ) - ( # ` ( V \ U ) ) ) ) $=
        ( cfn cv cin chash cfv cdif cmin wceq ineq2 fveq2d difeq2 oveq12d ineq1
        co difeq1 ovex ovmpt2 ) CBGQUJUJBUKZCUKZULZUMUNZVGVHUOZUMUNZUPVCQGULZUM
        UNZQGUOZUMUNZUPVCKVGGULZUMUNZVGGUOZUMUNZUPVCVHGUQZVJVRVLVTUPWAVIVQUMVHG
        VGURUSWAVKVSUMVHGVGUTUSVAVGQUQZVRVNVTVPUPWBVQVMUMVGQGVBUSWBVSVOUMVGQGVD
        USVAUIVNVPUPVEVF $.

      ${
        $d u v U $.  $d u v V $.  $d u v W $.
        ballotlemgun.1 $e |- ( ph -> U e. Fin ) $.
        ballotlemgun.2 $e |- ( ph -> V e. Fin ) $.
        ballotlemgun.3 $e |- ( ph -> W e. Fin ) $.
        ballotlemgun.4 $e |- ( ph -> ( V i^i W ) = (/) ) $.
        $( A property of the defined ` .^ ` operator (Contributed by Thierry
           Arnoux, 26-Apr-2017.) $)
        ballotlemgun $p |- ( ph ->
                         ( U .^ ( V u. W ) ) = ( ( U .^ V ) + ( U .^ W ) ) ) $=
          ( cun cin chash cfv cdif cmin co caddc indir fveq2i wcel c0 wceq infi
          cfn syl ineq1d inindir incom in0 eqtr3i 3eqtr3g hashun syl3anc syl5eq
          difundir diffi difeq1d difindir 0dif oveq12d cn0 hashcl 3syl addsub4d
          nn0cnd eqtrd unfi syl2anc ballotlemgval 3eqtr4d ) ARSUPZHUQZURUSZWQHU
          TZURUSZVAVBZRHUQZURUSZRHUTZURUSZVAVBZSHUQZURUSZSHUTZURUSZVAVBZVCVBZHW
          QLVBZHRLVBZHSLVBZVCVBAXBXDXIVCVBZXFXKVCVBZVAVBXMAWSXQXAXRVAAWSXCXHUPZ
          URUSZXQWRXSURRSHVDVEAXCVJVFZXHVJVFZXCXHUQZVGVHXTXQVHARVJVFZYAUMRHVIZV
          KASVJVFZYBUNSHVIZVKARSUQZHUQVGHUQZYCVGAYHVGHUOVLRSHVMHVGUQYIVGHVGVNHV
          OVPVQXCXHVRVSVTAXAXEXJUPZURUSZXRWTYJURRSHWAVEAXEVJVFZXJVJVFZXEXJUQZVG
          VHYKXRVHAYDYLUMRHWBZVKAYFYMUNSHWBZVKAYHHUTVGHUTYNVGAYHVGHUOWCRSHWDHWE
          VQXEXJVRVSVTWFAXDXIXFXKAXDAYDYAXDWGVFUMYEXCWHWIWKAXIAYFYBXIWGVFUNYGXH
          WHWIWKAXFAYDYLXFWGVFUMYOXEWHWIWKAXKAYFYMXKWGVFUNYPXJWHWIWKWJWLAHVJVFZ
          WQVJVFZXNXBVHULAYDYFYRUMUNRSWMWNBCDEFGHIJKLMNOPQWQTUAUBUCUDUEUFUGUHUI
          UJUKWOWNAXOXGXPXLVCAYQYDXOXGVHULUMBCDEFGHIJKLMNOPQRTUAUBUCUDUEUFUGUHU
          IUJUKWOWNAYQYFXPXLVHULUNBCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGUHUIUJUKWOWNW
          FWP $.
      $}

      $d i J $.
      $( Express the value of ` ( F `` C ) ` in terms of ` .^ ` .  (Contributed
         by Thierry Arnoux, 21-Apr-2017.) $)
      ballotlemfg $p |- ( ( C e. ( O \ E ) /\ J e. ( 0 ... ( M + N ) ) ) ->
                                  ( ( F ` C ) ` J ) = ( C .^ ( 1 ... J ) ) ) $=
        ( cdif wcel cc0 caddc co cfz wa cfv c1 chash cmin eldifi adantr elfzelz
        cin cz adantl ballotlemfval cfn wceq wss fzfi ballotlemelo simplbi ssfi
        sylancr syl fzfid ballotlemgval syl2anc eqtr4d ) DQJUJUKZNULOPUMUNZUOUN
        UKZUPZNDLUQUQURNUOUNZDVDUSUQWEDUJUSUQUTUNZDWEKUNZWDADEHLNOPQRSTUAUBUCWA
        DQUKZWCDQJVAVBZWCNVEUKWANULWBVCVFVGWDDVHUKZWEVHUKWGWFVIWDWHWJWIWHURWBUO
        UNZVHUKDWKVJZWJURWBVKWHWLDUSUQOVIDOPQRSTUAVLVMWKDVNVOVPWDURNVQABCEFGDHI
        JKLMOPQWERSTUAUBUCUDUEUFUGUHUIVRVSVT $.

      $( Express the value of ` ( F `` ( R `` C ) ) ` in terms of the newly
         defined ` .^ ` .  (Contributed by Thierry Arnoux, 21-Apr-2017.) $)
      ballotlemfrc $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( I ` C ) ) ) ->
        ( ( F ` ( R ` C ) ) ` J ) =
                              ( C .^ ( ( ( S ` C ) ` J ) ... ( I ` C ) ) ) ) $=
        ( cdif wcel c1 cfv cfz co wa cin chash cmin cima cres wf1o cen wbr wceq
        caddc wf1 wss ccnv ballotlemsf1o simpld syl adantr cuz cc0 ballotlemiex
        f1of1 elfzuz3 adantl uztrn syl2anc fzss2 ssinss1 f1ores ovex inex1 3syl
        f1oen hasheni ssdifssd difexg oveq12d ballotlemro elfzelz ballotlemfval
        cvv ax-mp cz cfn fzfi eldifi ballotlemelo simplbi sylancr ballotlemgval
        ssfi fzfid wfun dff1o3 simprbi imain ballotlemsima ballotlemscr ineq12d
        wfo eqtrd fveq2d imadif difeq12d eqtr4d 3eqtr4d ) DQJUJUKZNULDMUMZUNUOU
        KZUPZULNUNUOZDFUMZUQZURUMZYFYGUJZURUMZUSUODGUMZYHUTZURUMZYLYJUTZURUMZUS
        UOZNYGLUMUMDNYLUMZYCUNUOZKUOZYEYIYNYKYPUSYEYHYMYLYHVAZVBZYHYMVCVDYIYNVE
        YEULOPVFUOZUNUOZUUDYLVGZYHUUDVHZUUBYBUUEYDYBUUDUUDYLVBZUUEYBUUGYLVIZYLV
        EADEGHIJLMOPQRSTUAUBUCUDUEUFUGVJVKZUUDUUDYLVQVLVMZYEYFUUDVHZUUFYEUUCNVN
        UMZUKZUUKYEUUCYCVNUMUKZYCUULUKZUUMYEYCUUDUKZUUNYBUUPYDYBUUPYCDLUMUMVOVE
        ADEHIJLMOPQRSTUAUBUCUDUEUFVPVKVMYCULUUCVRVLYDUUOYBNULYCVRVSYCUUCNVTWANU
        LUUCWBVLZYFYGUUDWCVLUUDUUDYHYLWDWAYHYMUUAYFYGULNUNWEZWFWHYHYMWIWGYEYJYO
        YLYJVAZVBZYJYOVCVDYKYPVEYEUUEYJUUDVHUUTUUJYEYFUUDYGUUQWJUUDUUDYJYLWDWAY
        JYOUUSYFWPUKYJWPUKUURYFYGWPWKWQWHYJYOWIWGWLYEAYGEHLNOPQRSTUAUBUCYBYGQUK
        YDADEFGHIJLMOPQRSTUAUBUCUDUEUFUGUHWMVMYDNWRUKYBNULYCWNVSWOYEYTYSDUQZURU
        MZYSDUJZURUMZUSUOZYQYEDWSUKZYSWSUKYTUVEVEYEUUDWSUKDUUDVHZUVFULUUCWTYBUV
        GYDYBDQUKZUVGDQJXAUVHUVGDURUMOVEDOPQRSTUAXBXCVLVMUUDDXFXDYEYRYCXGABCEFG
        DHIJKLMOPQYSRSTUAUBUCUDUEUFUGUHUIXEWAYEYNUVBYPUVDUSYEYMUVAURYEYMYLYFUTZ
        YLYGUTZUQZUVAYBYMUVKVEZYDYBUUGUUHXHZUVLUUIUUGUUDUUDYLXOUVMUUDUUDYLXIXJZ
        YFYGYLXKWGVMYEUVIYSUVJDADEGHIJLMNOPQRSTUAUBUCUDUEUFUGXLZYBUVJDVEYDADEFG
        HIJLMOPQRSTUAUBUCUDUEUFUGUHXMVMZXNXPXQYEYOUVCURYEYOUVIUVJUJZUVCYBYOUVQV
        EZYDYBUUGUVMUVRUUIUVNYFYGYLXRWGVMYEUVIYSUVJDUVOUVPXSXPXQWLXTYA $.

      $( Reverse counting preserves a tie at the first tie.  (Contributed by
         Thierry Arnoux, 21-Apr-2017.) $)
      ballotlemfrci $p |- ( C e. ( O \ E ) ->
                                     ( ( F ` ( R ` C ) ) ` ( I ` C ) ) = 0 ) $=
        ( cdif wcel cfv c1 cfz co cc0 wceq caddc cuz ballotlemiex simpld elfzuz
        eluzfz2 3syl ballotlemfrc mpdan ballotlemsi oveq1d oveq2d eqtrd wss cn0
        1nn0 nn0uz eleqtri fzss1 ax-mp sseldi ballotlemfg simprd 3eqtr2d ) DPJU
        IUJZDMUKZDFUKLUKUKZDULWBUMUNZKUNZWBDLUKUKZUOWAWCDWBDGUKUKZWBUMUNZKUNZWE
        WAWBWDUJZWCWIUPWAWBULNOUQUNZUMUNZUJZWBULURUKUJWJWAWMWFUOUPZADEHIJLMNOPQ
        RSTUAUBUCUDUEUSZUTZWBULWKVAULWBVBVCABCDEFGHIJKLMWBNOPQRSTUAUBUCUDUEUFUG
        UHVDVEWAWHWDDKWAWGULWBUMADEGHIJLMNOPQRSTUAUBUCUDUEUFVFVGVHVIWAWBUOWKUMU
        NZUJWFWEUPWAWLWQWBULUOURUKZUJWLWQVJULVKWRVLVMVNULUOWKVOVPWPVQABCDEFGHIJ
        KLMWBNOPQRSTUAUBUCUDUEUFUGUHVRVEWAWMWNWOVSVT $.

      $( Value of ` F ` for a reverse counting ` ( R `` C ) ` .  (Contributed
         by Thierry Arnoux, 27-Apr-2017.) $)
      ballotlemfrceq $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( I ` C ) ) )
        -> ( ( F ` C ) ` ( ( ( S ` C ) ` J ) - 1 ) )
                                            = -u ( ( F ` ( R ` C ) ) ` J ) ) $=
        ( cdif wcel c1 cfv cfz co wa cmin caddc cc0 wceq cneg ballotlemsel1i cz
        wb 1z a1i ballotlemiex adantr simpld elfzelz syl cuz elfzuz3 fzss2 3syl
        simpr sseldd ballotlemsdom syldan fzsubel syl22anc mpbid 1m1e0 syl6eleq
        wss oveq1i cle wbr zsubcld cn nnaddcl mp2an elfzle2 clt zlem1lt syl2anc
        nnzi cr zred sylbid mpd eluz2 syl3anbrc sselda ballotlemfg ballotlemfrc
        wi ltle oveq12d cun fzsplit3 oveq2d cn0 nn0uz eleqtri fzss1 ax-mp sseli
        1nn0 sylan2 simprd eqtr3d cfn eldifi chash ballotlemelo simplbi sylancr
        fzfi ssfi fzfid c0 ltm1 fzdisj ballotlemgun 3eqtr3rd ballotlemfelz zcnd
        cin cc eqtrd ballotlemro addeq0 ) DQJUJUKZNULDMUMZUNUOZUKZUPZNDGUMUMZUL
        UQUOZDLUMZUMZNDFUMZLUMUMZURUOZUSUTZUULUUNVAUTZUUHUUODULUUJUNUOZKUOZDUUI
        UUEUNUOZKUOZURUOZUSUUHUULUUSUUNUVAURUUDUUGUUJUSOPURUOZUNUOZUKZUULUUSUTU
        UDUUGUUJUSUUEULUQUOZUNUOZUKUVEUUHUUJULULUQUOZUVFUNUOZUVGUUHUUIUUFUKZUUJ
        UVIUKZADEGHIJLMNOPQRSTUAUBUCUDUEUFUGVBZUUHULVCUKZUUEVCUKZUUIVCUKZUVMUVJ
        UVKVDUVMUUHVEVFZUUHUUEULUVCUNUOZUKZUVNUUHUVRUUEUUKUMZUSUTZUUDUVRUVTUPUU
        GADEHIJLMOPQRSTUAUBUCUDUEUFVGZVHZVIZUUEULUVCVJZVKUUHUUIUVQUKZUVOUUDUUGN
        UVQUKUWEUUHUUFUVQNUUHUVRUVCUUEVLUMUKUUFUVQWEUWCUUEULUVCVMUUEULUVCVNVOUU
        DUUGVPZVQADEGHIJLMNOPQRSTUAUBUCUDUEUFUGVRVSUUIULUVCVJVKZUVPUUIULULUUEVT
        WAWBUVHUSUVFUNWCWFWDUUDUVGUVDUUJUUDUVCUVFVLUMUKZUVGUVDWEUUDUVFVCUKUVCVC
        UKZUVFUVCWGWHZUWHUUDUUEULUUDUVRUVNUUDUVRUVTUWAVIZUWDVKZUVMUUDVEVFWIZUWI
        UUDUVCOWJUKPWJUKUVCWJUKSTOPWKWLWQVFZUUDUUEUVCWGWHZUWJUUDUVRUWOUWKUUEULU
        VCWMVKUUDUWOUVFUVCWNWHZUWJUUDUVNUWIUWOUWPVDUWLUWNUUEUVCWOWPUUDUVFWRUKUV
        CWRUKUWPUWJXGUUDUVFUWMWSUUDUVCUWNWSUVFUVCXHWPWTXAUVFUVCXBXCUVFUSUVCVNVK
        XDVSABCDEFGHIJKLMUUJOPQRSTUAUBUCUDUEUFUGUHUIXEVSABCDEFGHIJKLMNOPQRSTUAU
        BUCUDUEUFUGUHUIXFXIUUHDUUFKUOZDUURUUTXJZKUOUSUVBUUHUUFUWRDKUUHUVJUUFUWR
        UTUVLUUIULUUEXKVKXLUUHUVSUWQUSUUDUUGUVRUVSUWQUTZUWCUVRUUDUUEUVDUKUWSUVQ
        UVDUUEULUSVLUMZUKUVQUVDWEULXMUWTXSXNXOULUSUVCXPXQXRABCDEFGHIJKLMUUEOPQR
        STUAUBUCUDUEUFUGUHUIXEXTVSUUHUVRUVTUWBYAYBUUHABCEFGDHIJKLMOPQUURUUTRSTU
        AUBUCUDUEUFUGUHUIUUDDYCUKZUUGUUDUVQYCUKDUVQWEZUXAULUVCYIUUDDQUKZUXBDQJY
        DZUXCUXBDYEUMOUTDOPQRSTUAYFYGVKUVQDYJYHVHUUHULUUJYKUUHUUIUUEYKUUHUUIWRU
        KUUJUUIWNWHUURUUTYSYLUTUUHUUIUWGWSUUIYMULUUJUUIUUEYNVOYOYPUUAUUHUULYTUK
        UUNYTUKUUPUUQVDUUHUULUUHADEHLUUJOPQRSTUAUBUCUUDUXCUUGUXDVHUUHUUIULUWGUV
        PWIYQYRUUHUUNUUHAUUMEHLNOPQRSTUAUBUCUUDUUMQUKUUGADEFGHIJLMOPQRSTUAUBUCU
        DUEUFUGUHUUBVHUUHUUGNVCUKUWFNULUUEVJVKYQYRUULUUNUUCWPWB $.
    $}

    $d k S $.  $d k J $.
    ${
      $d u v C $.  $d u v I $.  $d u v J $.  $d u v R $.  $d u v S $.
      $d w y z $.  $d c k y z $.  $d y z C $.  $d y z F $.  $d y z M $.
      $d y z N $.  $d k w y z $.  $d w C $.  $d w F $.  $d w M $.  $d w N $.
      $d i J $.
      $( Value of ` F ` for a reversed counting ` ( R `` C ) ` , before the
         first tie, cannot be zero .  (Contributed by Thierry Arnoux,
         25-Apr-2017.) $)
      ballotlemfrcn0 $p |- ( ( C e. ( O \ E ) /\ J e. ( 1 ... ( M + N ) ) /\
        J < ( I ` C ) ) -> ( ( F ` ( R ` C ) ) ` J ) =/= 0 ) $=
        ( vz vw vy vv vu cdif wcel c1 caddc co cfz cfv clt wbr w3a cc0 wne cmin
        wceq wn cz cle 1z a1i cn nnaddcl mp2an wa ballotlemsdom elfzelz 3adant3
        nnzi syl zsubcld ballotlemsgt1 zltlem1 biimpa syl21anc zred cr resubcld
        1re simp1 ballotlemiex 3syl 3ad2ant2 elfzle1 simp3 ltled elfz4 syl32anc
        simpld ballotlemsel1i syl2anc elfzle2 wb zlem1lt mpbid letrd wi cv crab
        ccnv csup fvex brcnv sylibr ballotlemi breq1d 3ad2ant1 wor ballotlemsup
        ovex ltso cnvso mpbi supub con2d sylc fveq2 eqeq1d elrab sylnib neneqad
        imnan mpd cneg ballotlemro adantr adantl ballotlemfelz zcnd negeq0d cfn
        chash cin cmpt2 eqid ballotlemfrceq bitr4d necon3bid mpbird ) BNHUKULZK
        UMLMUNUOZUPUOZULZKBJUQZURUSZUTZKBDUQZIUQUQZVAVBZKBEUQUQZUMVCUOZBIUQZUQZ
        VAVBZUUNUVAVAUUNUUSUUJULZUVAVAVDZVEZUUNUMVFULZUUIVFULZUUSVFULUMUUSVGUSZ
        UUSUUIVGUSUVCUVFUUNVHVIZUVGUUNUUILVJULMVJULUUIVJULPQLMVKVLVQVIZUUNUURUM
        UUHUUKUURVFULZUUMUUHUUKVMUURUUJULUVKABCEFGHIJKLMNOPQRSTUAUBUCUDVNUURUMU
        UIVOVRVPZUVIVSUUNUVFUVKUMUURURUSZUVHUVIUVLABCEFGHIJKLMNOPQRSTUAUBUCUDVT
        UVFUVKVMUVMUVHUMUURWAWBWCUUNUUSUULUUIUUNUURUMUUNUURUVLWDUMWEULUUNWGVIWF
        ZUUNUULUUNUUHUULUUJULZUULVFULZUUHUUKUUMWHZUUHUVOUULUUTUQVAVDABCFGHIJLMN
        OPQRSTUAUBUCWIWQZUULUMUUIVOWJZWDZUUNUUIUVJWDUUNUUSUULUVNUVTUUNUURUULVGU
        SZUUSUULURUSZUUNUURUMUULUPUOZULZUWAUUNUUHKUWCULZUWDUVQUUNUVFUVPKVFULZUM
        KVGUSZKUULVGUSUWEUVIUVSUUKUUHUWFUUMKUMUUIVOWKZUUKUUHUWGUUMKUMUUIWLWKUUN
        KUULUUNKUWHWDUVTUUHUUKUUMWMWNKUMUULWOWPZABCEFGHIJKLMNOPQRSTUAUBUCUDWRWS
        UURUMUULWTVRUUNUVKUVPUWAUWBXAUVLUVSUURUULXBWSXCZWNUUNUUHUVOUULUUIVGUSUV
        QUVRUULUMUUIWTWJXDUUSUMUUIWOWPUUNUVCUVDVMZVEUVCUVEXEUUNUUSGXFZUUTUQZVAV
        DZGUUJXGZULZUWKUUNUUHUWOWEURXHZXIZUUSUWQUSZUWPVEUVQUUNUULUUSUWQUSZUWSUU
        NUWBUWTUWJUULUUSURBJXJUURUMVCXRXKXLUUHUUKUWTUWSXAUUMUUHUULUWRUUSUWQABCF
        GHIJLMNOPQRSTUAUBUCXMXNXOXCUUHUWPUWSUUHUFUGUHWEUWOUUSUWQWEUWQXPZUUHWEUR
        XPUXAXSWEURXTYAVIAUHUFUGBCFGHIJLMNOPQRSTUAUBUCXQYBYCYDUWNUVDGUUSUUJUWLU
        USVDUWMUVAVAUWLUUSUUTYEYFYGYHUVCUVDYJXLYKYIUUNUUHUWEUUQUVBXAUVQUWIUUHUW
        EVMZUUPVAUVAVAUXBUUPVAVDUUPYLZVAVDUVDUXBUUPUXBUUPUXBAUUOCFIKLMNOPQRSTUU
        HUUONULUWEABCDEFGHIJLMNOPQRSTUAUBUCUDUEYMYNUWEUWFUUHKUMUULVOYOYPYQYRUXB
        UVAUXCVAAUIUJBCDEFGHUJUIYSYSUIXFZUJXFZUUAYTUQUXDUXEUKYTUQVCUOUUBZIJKLMN
        OPQRSTUAUBUCUDUEUXFUUCUUDYFUUEUUFWSUUG $.

      $( Range of ` R ` .  (Contributed by Thierry Arnoux, 19-Apr-2017.) $)
      ballotlemrc $p |- ( C e. ( O \ E ) -> ( R ` C ) e. ( O \ E ) ) $=
        ( vv vu cdif wcel cfv cv cc0 cle wbr c1 caddc cfz wrex ballotlemro wceq
        co ballotlemiex simpld cfn cin chash cmin cmpt2 eqid ballotlemfrci 0le0
        syl6eqbr fveq2 breq1d rspcev syl2anc ballotlemodife sylanbrc ) BMHUGZUH
        ZBDUIZMUHFUJZVTIUIZUIZUKULUMZFUNKLUOUTUPUTZUQZVTVRUHABCDEFGHIJKLMNOPQRS
        TUAUBUCUDURVSBJUIZWEUHZWGWBUIZUKULUMZWFVSWHWGBIUIUIUKUSABCFGHIJKLMNOPQR
        STUAUBVAVBVSWIUKUKULAUEUFBCDEFGHUFUEVCVCUEUJZUFUJZVDVEUIWKWLUGVEUIVFUTV
        GZIJKLMNOPQRSTUAUBUCUDWMVHVIVJVKWDWJFWGWEWAWGUSWCWIUKULWAWGWBVLVMVNVOAV
        TCFHIKLMNOPQRSTVPVQ $.
    $}

    $d k i R $.
    ${
      $d k x y z $.  $d x y z C $.  $d y E $.  $d x y z F $.  $d y I $.
      $d x y z M $.  $d x y z N $.  $d y O $.  $d y R $.  $d u v C $.
      $d u v I $.  $d u v J $.  $d u v R $.  $d u v S $.  $d u v y U $.
      $d u v y V $.  $d i y $.
      $( Applying ` R ` does not change first ties.  (Contributed by Thierry
         Arnoux, 19-Apr-2017.) $)
      ballotlemirc $p |- ( C e. ( O \ E ) -> ( I ` ( R ` C ) ) = ( I ` C ) ) $=
        ( vy vv vu cdif wcel cfv cv cc0 wceq c1 caddc co cfz crab clt ccnv csup
        cr ballotlemrc ballotlemi syl wor ltso cnvso a1i cz ballotlemiex simpld
        mpbi elfzelz zred cfn chash cmin cmpt2 ballotlemfrci fveq2 eqeq1d elrab
        cin eqid sylanbrc wa wbr wn elrabi anim2i cvv adantr vex brcnvg sylancl
        wb biimpa w3a ballotlemfrcn0 neneqd simprbi nsyl 3expa syldan con2d imp
        ex sylancom supmax eqtrd ) BMHUHZUIZBDUJZJUJZGUKZXNIUJZUJZULUMZGUNKLUOU
        PZUQUPZURZVBUSUTZVAZBJUJZXMXNXLUIXOYDUMABCDEFGHIJKLMNOPQRSTUAUBUCUDVCAX
        NCFGHIJKLMNOPQRSTUAUBVDVEXMUEVBYBYEYCVBYCVFZXMVBUSVFYFVGVBUSVHVMVIXMYEX
        MYEYAUIZYEVJUIXMYGYEBIUJUJULUMABCFGHIJKLMNOPQRSTUAUBVKVLZYEUNXTVNVEVOXM
        YGYEXQUJZULUMZYEYBUIYHAUFUGBCDEFGHUGUFVPVPUFUKZUGUKZWDVQUJYKYLUHVQUJVRU
        PVSZIJKLMNOPQRSTUAUBUCUDYMWEVTXSYJGYEYAXPYEUMXRYIULXPYEXQWAWBWCWFXMUEUK
        ZYBUIZXMYNYAUIZWGZYEYNYCWHZWIZYOYPXMXSGYNYAWJWKYQYOYSYQYRYOYQYRYOWIZYQY
        RYNYEUSWHZYTYQYRUUAYQYGYNWLUIYRUUAWQXMYGYPYHWMUEWNYEYNYAWLUSWOWPWRXMYPU
        UAYTXMYPUUAWSZYNXQUJZULUMZYOUUBUUCULABCDEFGHIJYNKLMNOPQRSTUAUBUCUDWTXAY
        OYPUUDXSUUDGYNYAXPYNUMXRUUCULXPYNXQWAWBWCXBXCXDXEXHXFXGXIXJXK $.
    $}

    $( due to x used in ballotlemirc $)
    $d x c $.  $d x C $.  $d x F $.  $d x M $.  $d x N $.  $d c I $.
    $d d e S $.
    ${
      $d d e i x k $.  $d d e E $.  $d d e I $.  $d d e O $.
      $( Lemma for ~ ballotlemrinv .  (Contributed by Thierry Arnoux,
         18-Apr-2017.) $)
      ballotlemrinv0 $p |- ( ( C e. ( O \ E ) /\ D = ( ( S ` C ) " C ) ) ->
                             ( D e. ( O \ E ) /\ C = ( ( S ` D ) " D ) ) ) $=
        ( cdif wcel cfv cima wceq ballotlemrval adantr simpr eqtr4d ballotlemrc
        wa eqeltrrd ccnv c1 caddc cfz wf1o ballotlemsf1o simprd eqcomd imaeq12d
        co simpl ballotlemirc fveq2d eqtr3d ballotlemieq syl3anc imaeq1d simpld
        wf1 wss f1of1 3syl chash ballotlemelo simplbi f1imacnv syl2anc 3eqtr3rd
        eldifi jca ) BNIUFZUGZCBFUHZBUIZUJZUPZCWHUGZBCFUHZCUIZUJWMBEUHZCWHWMWQW
        KCWIWQWKUJWLABDEFGHIJKLMNOPQRSTUAUBUCUDUEUKULWIWLUMZUNZWIWQWHUGWLABDEFG
        HIJKLMNOPQRSTUAUBUCUDUEUOULUQZWMWJCUIWJURZWKUIZWPBWMWJXACWKWMXAWJWIXAWJ
        UJZWLWIUSLMUTVGVAVGZXDWJVBZXCABDFGHIJKLMNOPQRSTUAUBUCUDVCZVDULVEWRVFWMW
        JWOCWMWIWNBKUHZCKUHZUJWJWOUJWIWLVHZWTWMWQKUHZXGXHWIXJXGUJWLABDEFGHIJKLM
        NOPQRSTUAUBUCUDUEVIULWMWQCKWSVJVKABCDFGHIJKLMNOPQRSTUAUBUCUDVLVMVNWMXDX
        DWJVPZBXDVQZXBBUJWMWIXEXKXIWIXEXCXFVOXDXDWJVRVSWMWIBNUGZXLXIBNIWFXMXLBV
        TUHLUJBLMNOPQRWAWBVSXDXDBWJWCWDWEWG $.

      $( ` R ` is its own inverse : it is an involution.  (Contributed by
         Thierry Arnoux, 10-Apr-2017.) $)
      ballotlemrinv $p |- `' R = R $=
        ( vd cdif cv cfv cima cmpt ccnv wceq wtru wcel wa ballotlemrinv0 impbii
        wb a1i mptcnv trud fveq2 id imaeq12d cbvmptv eqtri cnveqi 3eqtr4i ) MLG
        UEZMUFZDUGZVIUHZUIZUJZVLCUJCVMUDVHUDUFZDUGZVNUHZUIZVLVMVQUKULMUDVHVKVHV
        PVIVHUMVNVKUKUNZVNVHUMVIVPUKUNZUQULVRVSAVIVNBCDEFGHIJKLMNOPQRSTUAUBUCUO
        AVNVIBCDEFGHIJKLMNOPQRSTUAUBUCUOUPURUSUTUDMVHVPVKVNVIUKZVOVJVNVIVNVIDVA
        VTVBVCVDVECVLUCVFUCVG $.
    $}

    ${
      $( When the vote on the first tie is for A, the first vote is also for A
         on the reverse counting.  (Contributed by Thierry Arnoux,
         18-Apr-2017.) $)
      ballotlem1ri $p |- ( C e. ( O \ E ) ->
                                     ( 1 e. ( R ` C ) <-> ( I ` C ) e. C ) ) $=
        ( cdif wcel c1 cfv caddc co cfz cle wbr wb cuz cn nnaddcl mp2an eleqtri
        cmin nnuz eluzfz1 mp1i cc0 ballotlemiex simpld elfzle1 syl ballotlemrv1
        wceq mpd3an23 cz elfzelz zcnd cc ax-1cn a1i pncand eleq1d bitrd ) BMHUE
        UFZUGBDUHUFZBJUHZUGUIUJUGUTUJZBUFZWCBUFWAUGUGKLUIUJZUKUJZUFZUGWCULUMZWB
        WEUNWFUGUOUHZUFWHWAWFUPWJKUPUFLUPUFWFUPUFOPKLUQURVAUSUGWFVBVCWAWCWGUFZW
        IWAWKWCBIUHUHVDVJABCFGHIJKLMNOPQRSTUAUBVEVFZWCUGWFVGVHABCDEFGHIJUGKLMNO
        PQRSTUAUBUCUDVIVKWAWDWCBWAWCUGWAWCWAWKWCVLUFWLWCUGWFVMVHVNUGVOUFWAVPVQV
        RVSVT $.
    $}

    $d x k i $.  $d c k $.
    ${
      $d b E $.  $d b c O $.  $d b R $.

      $( ` R ` is a bijection between two subsets of ` ( O \ E ) ` : one where
         a vote for A is picked first, and one where a vote for B is picked
         first (Contributed by Thierry Arnoux, 12-Dec-2016.) $)
      ballotlem7 $p |- ( R |` { c e. ( O \ E ) | 1 e. c } ) :
      { c e. ( O \ E ) | 1 e. c } -1-1-onto-> { c e. ( O \ E ) | -. 1 e. c } $=
        ( vb c1 cv wcel cdif crab wn cfv cima funmpt2 ballotlemrinv wss wral wa
        rabid ballotlemrc adantr ballotlem1c ex ballotlem1ri notbid sylibrd imp
        jca sylbi rgen wceq eleq2 cbvrabv eleq2i bitr3i ralbii mpbi wfun cdm wb
        elrab ssrab2 cvv fvex imaexg ax-mp dmmpti sseqtr4i nfrab1 nfmpt1 nfcxfr
        cmpt funimass4f mp2an mpbir ballotlemic rinvf1o ) UEMUFZUGZMLGUHZUIZWRU
        JZMWSUIZCMWSWQDUKZWQULZCUCUMZABCDEFGHIJKLMNOPQRSTUAUBUCUNCWTULXBUOZWQCU
        KZXBUGZMWTUPZXGWSUGZUEXGUGZUJZUQZMWTUPXIXMMWTWQWTUGWQWSUGZWRUQZXMWRMWSU
        RXOXJXLXNXJWRAWQBCDEFGHIJKLMNOPQRSTUAUBUCUSZUTXNWRXLXNWRWQIUKWQUGZUJZXL
        XNWRXRAWQBEFGHIJKLMNOPQRSTUAVAVBXNXKXQAWQBCDEFGHIJKLMNOPQRSTUAUBUCVCZVD
        VEVFVGVHVIXMXHMWTXMXGUEUDUFZUGZUJZUDWSUIZUGXHYBXLUDXGWSXTXGVJYAXKXTXGUE
        VKZVDVTYCXBXGYBXAUDMWSXTWQVJYAWRXTWQUEVKZVDVLVMVNVOVPCVQZWTCVRZUOXFXIVS
        XEWTWSYGWRMWSWAMWSXDCXCWBUGXDWBUGWQDWCXCWQWBWDWEUCWFZWGZMWTXBCWRMWSWHZX
        AMWSWHZMCMWSXDWKUCMWSXDWIWJZWLWMWNCXBULWTUOZXGWTUGZMXBUPZXJXKUQZMXBUPYO
        YPMXBWQXBUGXNXAUQZYPXAMWSURYQXJXKXNXJXAXPUTXNXAXKXNXAXQXKXNXAXQAWQBEFGH
        IJKLMNOPQRSTUAWOVBXSVEVFVGVHVIYPYNMXBYPXGYAUDWSUIZUGYNYAXKUDXGWSYDVTYRW
        TXGYAWRUDMWSYEVLVMVNVOVPYFXBYGUOYMYOVSXEXBWSYGXAMWSWAYHWGZMXBWTCYKYJYLW
        LWMWNYIYSWP $.
    $}

    ${
      $( There are as many countings with ties starting with a ballot for A as
         there are starting with a ballot for B. (Contributed by Thierry
         Arnoux, 7-Dec-2016.) $)
      ballotlem8 $p |- ( # ` { c e. ( O \ E ) | 1 e. c } )
                     = ( # ` { c e. ( O \ E ) | -. 1 e. c } ) $=
        ( c1 cv wcel cdif crab wn cres wf1o cen wbr chash cfv wceq ballotlemoex
        ballotlem7 cvv difexg ax-mp rabex f1oen hasheni mp2b ) UDMUEUFZMLGUGZUH
        ZVFUIMVGUHZCVHUJZUKVHVIULUMVHUNUOVIUNUOUPABCDEFGHIJKLMNOPQRSTUAUBUCURVH
        VIVJVFMVGLUSUFVGUSUFJKLMNOPUQLGUSUTVAVBVCVHVIVDVE $.
    $}

    $d x c $.  $d x C $.  $d x E $.  $d x O $.
    $( Bertrand's ballot problem : the probability that A is ahead throughout
       the counting.  (Contributed by Thierry Arnoux, 7-Dec-2016.) $)
    ballotth $p |- ( P ` E ) = ( ( M - N ) / ( M + N ) ) $=
      ( cfv c1 cdif chash cdiv co cmin caddc cmul wss wceq cc0 clt wbr cfz wral
      c2 crab ssrab2 eqsstri cpw wcel cfn fzfi pwfi mpbi ssfi mp2an elexi fveq2
      cv elpw oveq1d ovex fvmpt sylbir ax-mp hashssdif eqcomi cn0 hashcl nn0cni
      difss subsub23i oveq1i eqtr4i cc wne wa cbc ballotlem1 cle nnnn0i nnaddcl
      cn nnrei nn0addge1i elfz2nn0 mpbir3an bccl2 nnne0i pm3.2i divsubdir mp3an
      eqnetri dividi 3eqtri wn ballotlem8 cun rabxm fveq2i c0 sstri rabnc eqtri
      hashun elpw2 mpbir ballotlem2 wi nfrab1 dfss2f ballotlem4 imdistani rabid
      cin eldif 3imtr4i simprbi sylanbrc oveq2i divassi 2timesi 3eqtr2i nncni
      2cn mpgbir rabss2 3eqtr3i 3eqtr4ri mulcli addsub4i subidi addid1i oveq12i
      eqssi subcli 3eqtr3ri ) GBUDZUELGUFZUGUDZLUGUDZUHUIZUJUIZUEUTKJKUKUIZUHUI
      ZULUIZUJUIZJKUJUIZUUSUHUIZUUMUUPUUOUJUIZUUPUHUIZUUPUUPUHUIZUUQUJUIZUURUUM
      GUGUDZUUPUHUIZUVFGLUMZUUMUVJUNZGUOEVNMVNZHUDUDUPUQEUEUUSURUIZUSZMLVALSUVO
      MLVBVCZUVKGLVDZVEUVLGLGVFLVFVEZUVKGVFVEZUVNVDZVFVEZLUVTUMUVRUVNVFVEUWAUEU
      USVGUVNVHVIZLUVMUGUDJUNZMUVTVAUVTPUWCMUVTVBVCZUVTLVJVKZUVPLGVJVKZVLVOAGAV
      NZUGUDZUUPUHUIZUVJUVQBUWGGUNUWHUVIUUPUHUWGGUGVMVPQUVIUUPUHVQVRVSVTUVEUVIU
      UPUHUUPUVIUJUIZUUOUNUVEUVIUNUUOUWJUVRUVKUUOUWJUNUWEUVPLGWAVKWBUUPUVIUUOUU
      PUVRUUPWCVEUWELWDVTWEZUVIUVSUVIWCVEUWFGWDVTWEUUOUUNVFVEZUUOWCVEUVRUUNLUMZ
      UWLUWELGWFZLUUNVJVKUUNWDVTWEZWGVIWHWIUUPWJVEZUUOWJVEUWPUUPUOWKZWLUVFUVHUN
      UWKUWOUWPUWQUWKUUPUUSJWMUIZUOJKLMNOPWNUWRJUOUUSURUIVEZUWRWRVEUWSJWCVEUUSW
      CVEJUUSWOUQJNWPUUSJWRVEKWRVEUUSWRVENOJKWQVKZWPJKJNWSKOWPWTJUUSXAXBJUUSXCV
      TXDXHZXEUUPUUOUUPXFXGUVGUEUUQUJUUPUWKUXAXIWHXJUVAUUQUEUJUEUVMVEZMUUNVAZUG
      UDZUXBXKZMUUNVAZUGUDZUKUIZUUPUHUIUXGUXGUKUIZUUPUHUIZUUQUVAUXHUXIUUPUHUXDU
      XGUXGUKABCDEFGHIJKLMNOPQRSTUAUBUCXLWHWHUUOUXHUUPUHUUOUXCUXFXMZUGUDZUXHUUN
      UXKUGUXBMUUNXNXOUXCVFVEZUXFVFVEZUXCUXFYJXPUNUXLUXHUNUWAUXCUVTUMUXMUWBUXCL
      UVTUXCUUNLUXBMUUNVBUWNXQUWDXQUVTUXCVJVKUWAUXFUVTUMUXNUWBUXFLUVTUXFUUNLUXE
      MUUNVBUWNXQUWDXQUVTUXFVJVKZUXBMUUNXRUXCUXFXTXGXSWHUVAUTUXGUUPUHUIZULUIUTU
      XGULUIZUUPUHUIUXJUUTUXPUTULUXEMLVAZBUDZUXRUGUDZUUPUHUIZUUTUXPUXRUVQVEZUXS
      UYAUNUYBUXRLUMUXEMLVBUXRLLVFUWEVLYAYBAUXRUWIUYAUVQBUWGUXRUNUWHUXTUUPUHUWG
      UXRUGVMVPQUXTUUPUHVQVRVTABJKLMNOPQYCUXTUXGUUPUHUXRUXFUGUXRUXFUXRUXFUMUVMU
      XRVEZUVMUXFVEZYDMMUXRUXFUXEMLYEUXEMUUNYEYFUYCUVMUUNVEZUXEUYDUVMLVEZUXEWLU
      YFUVMGVEXKZWLUYCUYEUYFUXEUYGAUVMBEGHJKLMNOPQRSYGYHUXEMLYIZUVMLGYKYLUYCUYF
      UXEUYHYMUXEMUUNYIYNUUAUWMUXFUXRUMUWNUXEMUUNLUUBVTUUJXOWHUUCYOUTUXGUUPYTUX
      GUXNUXGWCVEUXOUXFWDVTWEZUWKUXAYPUXQUXIUUPUHUXGUYIYQWHYRUUDYOUUSUTKULUIZUJ
      UIZUUSUHUIZUUSUUSUHUIZUYJUUSUHUIZUJUIZUVDUVBUUSWJVEZUYJWJVEUYPUUSUOWKZWLU
      YLUYOUNUUSUWTYSZUTKYTKOYSZUUEUYPUYQUYRUUSUWTXDZXEUUSUYJUUSXFXGUYKUVCUUSUH
      UYKUUSKKUKUIZUJUIZUVCUYJVUAUUSUJKUYSYQYOVUBUVCKKUJUIZUKUIUVCUOUKUIUVCJKKK
      JNYSZUYSUYSUYSUUFVUCUOUVCUKKUYSUUGYOUVCJKVUDUYSUUKUUHXJXSWHUYMUEUYNUVAUJU
      USUYRUYTXIUTKUUSYTUYSUYRUYTYPUUIUULYR $.
  $}

$( End $[ set-mbox-ta-ballot.mm $] $)

$( (End of Thierry Arnoux's mathbox.) $)
$( End $[ set-mbox-ta.mm $] $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Mario Carneiro
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Miscellaneous stuff
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    quartfull.a $e |- ( ph -> A e. CC ) $.
    quartfull.b $e |- ( ph -> B e. CC ) $.
    quartfull.c $e |- ( ph -> C e. CC ) $.
    quartfull.d $e |- ( ph -> D e. CC ) $.
    quartfull.x $e |- ( ph -> X e. CC ) $.
    quartfull.t0 $e |- ( ph -> ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^
      2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 )
      / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. (
      ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ;
      ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) /
      2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x.
      ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( (
      ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x.
      A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. (
      A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) =/= 0 ) $.
    quartfull.m0 $e |- ( ph -> -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) )
      ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) -
      ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) )
      + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A )
      / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^
      4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^
      2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 )
      / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. (
      ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ;
      ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( (
      ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^
      3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 )
      ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x.
      B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u
      ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C
      - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B
      - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( (
      A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) +
      ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) -
      ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) )
      + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A )
      / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^
      4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^
      2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 )
      ^c ( 1 / 3 ) ) ) ) / 3 ) =/= 0 ) $.
    $( The quartic equation, written out in full.  This actually makes a fairly
       good Metamath stress test.  Note that the length of this formula could
       be shortened significantly if the intermediate expressions were expanded
       and simplified, but it's not like this theorem will be used anyway.
       (Contributed by Mario Carneiro, 6-May-2015.) $)
    quartfull $p |- ( ph -> ( ( ( ( X ^ 4 ) + ( A x. ( X ^ 3 ) ) ) + ( ( B x. (
      X ^ 2 ) ) + ( ( C x. X ) + D ) ) ) = 0 <-> ( ( X = ( ( -u ( A / 4 ) - ( (
      sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u
      ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C
      - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B
      - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( (
      A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) +
      ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) -
      ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) )
      + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A )
      / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^
      4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^
      2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 )
      ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1
      2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - (
      ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) /
      2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x.
      ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( (
      -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( (
      C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( (
      B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( (
      ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) )
      ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2
      x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( (
      3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) )
      ) ) / 3 ) ) / 2 ) ) + ( sqr ` ( ( -u ( ( ( sqr ` -u ( ( ( ( 2 x. ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x.
      ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A
      ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) )
      x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( (
      3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( (
      B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x.
      B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 /
      8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x.
      B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4
      x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - (
      ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6
      ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B
      - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) /
      4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4
      ) ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^
      3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^
      2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( (
      C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 )
      x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + (
      ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 )
      ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) -
      ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 )
      ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) )
      ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ^ 2 ) - ( (
      B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) / 2 ) ) + ( ( ( ( C - ( ( A x. B ) / 2 )
      ) + ( ( A ^ 3 ) / 8 ) ) / 4 ) / ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8
      ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2
      ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) /
      8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( (
      D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ;
      2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( (
      3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2
      ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. (
      A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ;
      1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( (
      ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A
      ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A
      ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3
      / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) +
      ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) )
      ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) -
      ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) )
      + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A )
      / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^
      4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^
      2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 )
      / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. (
      ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ;
      ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( (
      ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^
      3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ) ) ) ) \/ X = ( ( -u
      ( A / 4 ) - ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) )
      ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - (
      ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) +
      ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) /
      4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4
      ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2
      ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) /
      8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( (
      D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ;
      2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( (
      ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^
      3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 )
      ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x.
      B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u
      ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C
      - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B
      - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( (
      A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) +
      ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) -
      ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) )
      + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A )
      / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^
      4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^
      2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 )
      ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ) - ( sqr ` ( ( -u ( ( ( sqr ` -u ( ( (
      ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B -
      ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B )
      / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B )
      / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( (
      ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( (
      ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. (
      ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( (
      ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) )
      ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2
      x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( (
      3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) )
      ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - (
      ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6
      ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A
      ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3
      ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x.
      ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 /
      ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B -
      ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B )
      / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B )
      / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. (
      ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C
      x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 )
      x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2
      ) ^ 2 ) - ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) / 2 ) ) + ( ( ( ( C - ( (
      A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) / 4 ) / ( ( sqr ` -u ( ( ( ( 2 x.
      ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3
      / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 )
      ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A
      ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1
      6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u (
      2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C -
      ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B -
      ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A
      ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2
      ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. (
      ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ;
      ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + (
      ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C
      x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 )
      x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^
      2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 )
      / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. (
      ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ;
      ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) /
      2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x.
      ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( (
      ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x.
      A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. (
      A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) )
      ) ) ) ) \/ ( X = ( ( -u ( A / 4 ) + ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3
      / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A
      ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3
      ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x.
      ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 /
      ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B -
      ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B )
      / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B )
      / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. (
      ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C
      x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 )
      x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B -
      ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4
      ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 )
      ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3
      ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2
      ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C
      x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 )
      x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + (
      ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 )
      ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) -
      ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 )
      ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) )
      ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ) + ( sqr `
      ( ( -u ( ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) +
      ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2
      7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ;
      7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 )
      ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) )
      ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) )
      ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 )
      ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D -
      ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5
      6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. (
      A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^
      2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) )
      ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^
      2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) /
      ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u ( 2
      x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - (
      ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - (
      ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^
      2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + (
      sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - (
      ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) +
      ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) /
      4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4
      ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2
      ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ;
      1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c
      ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ^ 2 ) - ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) )
      ) / 2 ) ) - ( ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) / 4 )
      / ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( (
      ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. (
      ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x.
      ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + (
      ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) )
      ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3
      ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2
      ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C
      x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 )
      x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^
      2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 )
      x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) )
      ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 )
      + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1
      6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. (
      ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A
      x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3
      / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 )
      x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr `
      ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7
      x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7
      2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) )
      + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) )
      ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + (
      ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 )
      - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 /
      3 ) ) ) ) / 3 ) ) / 2 ) ) ) ) ) \/ X = ( ( -u ( A / 4 ) + ( ( sqr ` -u (
      ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( (
      B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x.
      B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 /
      8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x.
      B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` (
      ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x.
      ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2
      x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) +
      ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) )
      ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ;
      1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) -
      ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3
      ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D
      - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2
      5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x.
      ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A
      ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) )
      x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( (
      3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( (
      B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x.
      B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 /
      8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x.
      B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4
      x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - (
      ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6
      ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) /
      2 ) ) - ( sqr ` ( ( -u ( ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. (
      A ^ 2 ) ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) )
      ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) )
      ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - (
      ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6
      ) x. ( A ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8
      ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) +
      ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2
      ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 )
      - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B -
      ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4
      ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 )
      ) ) ) ) ) ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( (
      ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) /
      ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2
      7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ;
      7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 )
      ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) )
      ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) )
      ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 )
      ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D -
      ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5
      6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. (
      A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^
      2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) )
      ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ^ 2 ) - ( ( B - ( ( 3 / 8 )
      x. ( A ^ 2 ) ) ) / 2 ) ) - ( ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 )
      / 8 ) ) / 4 ) / ( ( sqr ` -u ( ( ( ( 2 x. ( B - ( ( 3 / 8 ) x. ( A ^ 2 )
      ) ) ) + ( ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) )
      - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) )
      ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A
      ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A
      ^ 4 ) ) ) ) ) ) ) + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A
      ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3
      ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x.
      ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 /
      ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8
      ) x. ( A ^ 2 ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( (
      ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) )
      ^ 3 ) ) ) ) ) / 2 ) ^c ( 1 / 3 ) ) ) + ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2
      ) ) ) ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 )
      x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) / ( ( ( ( (
      -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) ) - ( ; 2 7 x. ( ( (
      C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) ) ) + ( ; 7 2 x. ( (
      B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( (
      ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) )
      + ( sqr ` ( ( ( ( -u ( 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) ^ 3 ) )
      - ( ; 2 7 x. ( ( ( C - ( ( A x. B ) / 2 ) ) + ( ( A ^ 3 ) / 8 ) ) ^ 2 ) )
      ) + ( ; 7 2 x. ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) ) x. ( ( D - ( ( C x. A
      ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B ) / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A
      ^ 4 ) ) ) ) ) ) ) ^ 2 ) - ( 4 x. ( ( ( ( B - ( ( 3 / 8 ) x. ( A ^ 2 ) ) )
      ^ 2 ) + ( ; 1 2 x. ( ( D - ( ( C x. A ) / 4 ) ) + ( ( ( ( A ^ 2 ) x. B )
      / ; 1 6 ) - ( ( 3 / ; ; 2 5 6 ) x. ( A ^ 4 ) ) ) ) ) ) ^ 3 ) ) ) ) ) / 2
      ) ^c ( 1 / 3 ) ) ) ) / 3 ) ) / 2 ) ) ) ) ) ) ) ) ) $=
      ( cdiv co c2 cexp cmul cmin eqidd c3 c8 caddc c4 c1 c6 cdc c5 cneg c7 cfv
      csqr ccxp quart ) ABCDECUAUBNOBPQOZROSOZDBCROPNOSOBUAQOUBNOUCOZEDBROUDNOS
      OUOCROUEUFUGNOUAPUHUGUFUGNOBUDQOROSOUCOZPUPROPUPUAQOROUIPUJUGUQPQOROSOUJP
      UGUPURROROUCOZUSPQOUDUPPQOUEPUGURROUCOZUAQOROSOULUKZUCOPNOUEUANOUMOZUCOUT
      VBNOUCOUANOUIZULUKPNOZVBUTBUDNOUIZVDPQOUIUPPNOSOZUQUDNOVDNOZUCOULUKZVFVGS
      OULUKZVCUSVAFGHIJKAVETAUPTAUQTAURTAUTTAUSTAVATAVDTAVCTAVBTLMAVHTAVITUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             Zeta function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c zeta $. $( Riemann zeta function $)

  $( The Riemann zeta function. $)
  czeta $a class zeta $.

  ${
    $d f k n s $.
    $( Define the Riemann zeta function.  This definition uses a series
       expansion of the alternating zeta function ~~? zetaalt that is
       convergent everywhere except ` 1 ` , but going from the alternating zeta
       function to the regular zeta function requires dividing by
       ` 1 - 2 ^ ( 1 - s ) ` , which has zeroes other than ` 1 ` .  To extract
       the correct value of the zeta function at these points, we extend the
       divided alternating zeta function by continuity.  (Contributed by Mario
       Carneiro, 18-Jul-2014.) $)
    df-zeta $a |- zeta = ( iota_ f e. ( ( CC \ { 1 } ) -cn-> CC )
      A. s e. ( CC \ { 1 } ) ( ( 1 - ( 2 ^c ( 1 - s ) ) ) x. ( f ` s ) ) =
      sum_ n e. NN0 ( sum_ k e. ( 0 ... n ) ( ( ( -u 1 ^ k ) x. ( n _C k ) ) x.
        ( ( k + 1 ) ^c s ) ) / ( 2 ^ ( n + 1 ) ) ) ) $.
  $}

  ${
    $d k m n S $.  $d k F $.  $d k m ph $.
    zetacvg.1 $e |- ( ph -> S e. CC ) $.
    zetacvg.2 $e |- ( ph -> 1 < ( Re ` S ) ) $.
    zetacvg.3 $e |- ( ( ph /\ k e. NN ) -> ( F ` k ) = ( k ^c -u S ) ) $.
    $( The zeta series is convergent.  (Contributed by Mario Carneiro,
       18-Jul-2014.) $)
    zetacvg $p |- ( ph -> seq 1 ( + , F ) e. dom ~~> ) $=
      ( cfv ccxp co c1 wcel wceq cmul cc cc0 c2 wbr cr cle vn vm cn cv cre cneg
      cmpt nnuz cz 1z a1i wa cabs oveq1 eqid ovex fvmpt adantl clog ce nncn wne
      nnne0 negcld adantr cxpefd eqtrd fveq2d relogcld recnd mulcl syl2an absef
      nnrp syl cmin remul renegd rered oveqan12d reim0d oveq2d mul01d sylan9eqr
      cim imcl oveq12d recld renegcld subid1d 3eqtrd eqtr4d cxpcld eqeltrd cseq
      caddc cli cdm cn0 cexp cdiv crp 2rp 1re resubcl sylancr rpcxpcl rpcnd clt
      recl addid2d breqtrrd wb 0re ltsubadd mp3an13 mpbird 1lt2 mpanl12 sylancl
      2re cxplt mpbid rprege0d absid 2cn 3brtr4d reeflogd nnrpd syl2anc remulcl
      efle mulneg1 nncnd nnne0d cxpmuld cxpexp ax-1cn 2nn 3eqtr3d eqcomi geolim
      cxp0 ax-mp oveq2 seqex breldm rpred rpge0d nnre lep1d peano2nn 0lt1 lttrd
      syl2anr lemul2 syl112anc lenegd nn0re mulcomd simpr negsub eqcomd nnexpcl
      mpan cxpaddd sylan cxp1d oveq1d 3eqtr4d climcnds abscvgcvg ) ACUAUCUAUDZB
      UEHZUFZIJZUGZDKUCUHKUILAUJUKACUDZUCLZULZUVRUVQHZUVRUVOIJZUVRDHZUMHZUVSUWA
      UWBMAUAUVRUVPUWBUCUVQUVMUVRUVOIUNUVQUOZUVRUVOIUPUQURZUVTUWDBUFZUVRUSHZNJZ
      UTHZUMHZUWIUEHZUTHZUWBUVTUWCUWJUMUVTUWCUVRUWGIJZUWJGUVTUVRUWGUVSUVROLAUVR
      VAURZUVSUVRPVBAUVRVCURZAUWGOLZUVSABEVDZVEZVFVGVHUVTUWIOLZUWKUWMMAUWQUWHOL
      ZUWTUVSUWRUVSUWHUVSUVRUVRVNZVIZVJZUWGUWHVKVLUWIVMVOUVTUWMUVOUWHNJZUTHZUWB
      UVTUWLUXEUTUVTUWLUWGUEHZUWHUEHZNJZUWGWEHZUWHWEHZNJZVPJZUXEPVPJUXEAUWQUXAU
      WLUXMMUVSUWRUXDUWGUWHVQVLUVTUXIUXEUXLPVPAUVSUXGUVOUXHUWHNABEVRUVSUWHUXCVS
      VTUVSAUXLUXJPNJPUVSUXKPUXJNUVSUWHUXCWAWBAUXJAUWQUXJOLUWRUWQUXJUWGWFVJVOWC
      WDWGUVTUXEAUVOOLZUXAUXEOLUVSAUVOAUVNABEWHZWIZVJZUXDUVOUWHVKVLWJWKVHUVTUVR
      UVOUWOUWPAUXNUVSUXQVEZVFZWLWKWLUVTUWCUWNOGUVTUVRUWGUWOUWSWMWNAWPUVQKWOWQW
      RZLWPUAWSQKUVNVPJZIJZUVMWTJZUGZPWOZUXTLZAUYEKKUYBVPJZXAJZWQRUYFAUYBUBUYDA
      UYBAQXBLZUYASLZUYBXBLXCAKSLZUVNSLZUYJXDUXOKUVNXEXFZQUYAXGXFZXHZAUYBQPIJZU
      YBUMHZKXIAUYAPXIRZUYBUYPXIRZAUYRKPUVNWPJZXIRZAKUVNUYTXIFAUVNABOLZUVNOLZEV
      UBUVNBXJVJVOZXKXLAUYLUYRVUAXMZUXOUYKUYLPSLZVUEXDXNKUVNPXOXPVOXQAUYJVUFUYR
      UYSXMZUYMXNQSLKQXIRUYJVUFULVUGYAXRQUYAPYBXSXTYCAUYBSLPUYBTRULUYQUYBMAUYBU
      YNYDUYBYEVOKUYPMAUYPKQOLZUYPKMYFQUUCUUDUUAUKYGUBUDZWSLZVUIUYDHZUYBVUIWTJZ
      MAUAVUIUYCVULWSUYDUVMVUIUYBWTUUEUYDUOUYBVUIWTUPUQURZUUBUYEUYHWQWPUYDPUUFK
      UYGXAUPUUGVOACUBUVQUYDUVTUWAUWBSUWFUVTUWBUVSUVRXBLUVOSLZUWBXBLAUXBUXPUVRU
      VOXGUUOZUUHWNUVTPUWBUWATUVTUWBVUOUUIUWFXLUVTUVOUVRKWPJZUSHZNJZUTHZUXFVUPU
      VQHZUWATUVTVURUXETRZVUSUXFTRZUVTUVNVUQNJZUFZUVNUWHNJZUFZVURUXETUVTVVEVVCT
      RZVVDVVFTRUVTUWHVUQTRZVVGUVSVVHAUVSVVHUWHUTHZVUQUTHZTRZUVSUVRVUPVVIVVJTUV
      SUVRUVRUUJUUKUVSUVRUXBYHUVSVUPUVSVUPUVRUULZYIZYHYGUVSUWHSLZVUQSLZVVHVVKXM
      UXCUVSVUPVVMVIZUWHVUQYLYJXQURUVTVVNVVOUYLPUVNXIRZVVHVVGXMUVSVVNAUXCURUVTV
      UPUVTVUPUVSVUPUCLZAVVLURZYIVIAUYLUVSUXOVEAVVQUVSAPKUVNVUFAXNUKUYKAXDUKUXO
      PKXIRAUUMUKFUUNVEUWHVUQUVNUUPUUQYCUVTVVEVVCAUYLVVNVVESLUVSUXOUXCUVNUWHYKV
      LAUYLVVOVVCSLUVSUXOVVPUVNVUQYKVLUURYCAVUCVUQOLVURVVDMUVSVUDUVSVUQVVPVJUVN
      VUQYMVLAVUCUXAUXEVVFMUVSVUDUXDUVNUWHYMVLYGUVTVURSLZUXESLZVVAVVBXMAVUNVVOV
      VTUVSUXPVVPUVOVUQYKVLAVUNVVNVWAUVSUXPUXCUVOUWHYKVLVURUXEYLYJYCUVTVUTVUPUV
      OIJZVUSUVTVVRVUTVWBMVVSUAVUPUVPVWBUCUVQUVMVUPUVOIUNUWEVUPUVOIUPUQVOUVTVUP
      UVOUVTVUPVVSYNUVTVUPVVSYOUXRVFVGUVTUWAUWBUXFUWFUXSVGYGAVUJULZVULQVUIWTJZV
      WDUVOIJZNJZVUKVWDVWDUVQHZNJVWCUYBVUIIJZVWDKIJZVWENJZVULVWFVWCQUYAVUINJZIJ
      ZVWDKUVOWPJZIJZVWHVWJVWCVWLQVUIUYANJZIJQVUIIJZUYAIJVWNVWCVWKVWOQIVWCUYAVU
      IAUYAOLVUJAUYAUYMVJVEZVWCVUIVUJVUISLAVUIUUSURZVJZUUTWBVWCQVUIUYAUYIVWCXCU
      KZVWRVWQYPVWCVWPVWDUYAVWMIVWCVUHVUJVWPVWDMYFAVUJUVAZQVUIYQXFVWCVWMUYAVWCK
      OLZVUCVWMUYAMYRAVUCVUJVUDVEKUVNUVBXFUVCWGWKVWCQUYAVUIVWTAUYJVUJUYMVEVWSYP
      VWCVWDKUVOVWCVWDVUJVWDUCLZAQUCLZVUJVXCYSQVUIUVDZUVEURZYNZVWCVWDVXFYOVXBVW
      CYRUKAUXNVUJUXQVEUVFYTAUYBOLVUJVWHVULMUYOUYBVUIYQUVGVWCVWIVWDVWENVWCVWDVX
      GUVHUVIYTVUMVWCVWGVWEVWDNVWCVXCVWGVWEMVWCVXDVUJVXCYSVXAVXEXFUAVWDUVPVWEUC
      UVQUVMVWDUVOIUNUWEVWDUVOIUPUQVOWBUVJUVKXQUVL $.
  $}

  $(
  @{
    @d k m n S @.  @d k F @.  @d k m ph @.
    cxpfdcvg.1 @e |- F = ( k e. NN0 |-> ( n e. NN0 |-> sum_ m e. ( 0 ... k )
      ( ( ( -u 1 ^ m ) x. ( k _C m ) ) x. ( ( n + m ) ^c S ) ) ) @.
    @( FIX COMMENT @)
    cxpfdfval @p |- ( K e. NN0 -> ( F ` K ) = ( n e. NN0 |-> sum_ m e.
    ( 0 ... K ) ( ( ( -u 1 ^ m ) x. ( K _C m ) ) x. ( ( n + m ) ^c S ) ) ) ) @=
      ? @.
      @( [18-Jul-2014] @)

    @( FIX COMMENT @)
    cxpfdval @p |- ( ( K e. NN0 /\ N e. NN0 ) -> ( ( F ` K ) ` N ) = sum_ m e.
      ( 0 ... K ) ( ( ( -u 1 ^ m ) x. ( K _C m ) ) x. ( ( N + m ) ^c S ) ) ) @=
      ? @.
      @( [18-Jul-2014] @)

    @( FIX COMMENT @)
    cxpfd0 @p |- ( N e. NN0 -> ( ( F ` 0 ) ` N ) = ( N ^c S ) ) @=
      ? @.
      @( [18-Jul-2014] @)

    cxpfdcvg.2 @e |- ( ph -> K e. NN0 ) @.
    cxpfdcvg.3 @e |- ( ph -> S e. RR ) @.
    @( FIX COMMENT @)
    cxpfddif @p |- ( ph -> ( ( F ` ( K + 1 ) ) ` N ) =
      ( ( ( F ` K ) ` N ) - ( ( F ` K ) ` ( N + 1 ) ) ) ) @=
      ? @.
      @( [18-Jul-2014] @)

    @( FIX COMMENT @)
    cxpfditg @p |- ( ph -> ( ( F ` K ) ` N ) = sum_ m e. ( 0 ... N )
      ( ( ( -u 1 ^ m ) x. ( K _C m ) ) x. ( ( N + m ) ^c S ) ) ) @=
      ? @.
      @( [18-Jul-2014] @)

    cxpfdcvg.4 @e |- ( ph -> S < N ) @.
    @{
      cxpfdle.5 @e |- ( ph -> K e. NN0 ) @.
      cxpfdle.6 @e |- ( ph -> M e. ( ZZ>= ` K ) ) @.
      @( FIX COMMENT @)
      cxpfdle @p |- ( ph -> ( F ` M ) <_ ( F ` K ) ) @=
        ? @.
        @( [18-Jul-2014] @)
    @}

    @( FIX COMMENT @)
    cxpfdcvg @p |- ( ph -> F ~~> 0 ) @=
      ? @.
      @( [18-Jul-2014] @)
  @}
  $)

  $(
  @{
    @d k n s S @.
    @( The value of the zeta function. @)
    zetacl @p |- ( ( S e. CC /\ S =/= 1 ) -> ( zeta ` S ) e. CC ) @=
      ? @.
  @}

  @( Give an alternating sequence related to the zeta function. @)
  zetaalt @p |- ( ( S e. CC /\ 0 < ( Re ` S ) ) ->
    ( ( 1 - ( exp ` ( ( 1 - S ) x. ( log ` 2 ) ) ) ) x. ( zeta ` S ) ) =
    sum_ n e. NN ( ( -u 1 ^ n ) x. ( n ^c -u S ) ) ) @=
    ? @.

  @( Derive the standard expression for the zeta function. (This is usually
     quoted as the definition of the zeta function, but it is not convergent
     everywhere, unlike our definition.) @)
  zetaval2 @p |- ( ( S e. CC /\ 1 < ( Re ` S ) ) ->
    ( zeta ` S ) = sum_ n e. NN ( n ^c -u S ) ) @=
    ? @.

  @{
    @( The laurent expansion of the zeta function about the pole at ` s = 1 ` .
       The function ` J ( n ) ` is commonly known as the ` n ` -th Stieltjes
       constant. @)
    zetaval3.1 @e |- J = ( ~~> ` ( m e. NN |->
          ( sum_ k e. ( 1 ... m ) ( ( ( log ` k ) ^ n ) / k ) -
            ( ( ( log ` m ) ^ ( n + 1 ) ) / ( n + 1 ) ) ) ) ) @.
    zetaval3 @p |- ( ( S e. CC /\ S =/= 1 ) -> ( zeta ` S ) =
      ( ( 1 / ( S - 1 ) ) + sum_ n e. NN0
        ( ( ( ( 1 - S ) ^ n ) / ( ! ` n ) ) x. J ) ) ) @=
      ? @.
  @}

  @( The value of the zeta function on the natural numbers. @)
  zetann @p |- ( S e. ( ZZ>= ` 2 ) ->
    ( zeta ` S ) = sum_ n e. NN ( n ^ -u S ) ) @=
    ? @.

  @( The value of ` zeta ( 0 ) ` . @)
  zeta0 @p |- ( zeta ` 0 ) = -u ( 1 / 2 ) @=
    ? @.

  @( The value of ` zeta ( 2 ) ` , whose derivation (with an imprecise proof)
     is attributed to Euler. @)
  zeta2 @p |- ( zeta ` 2 ) = ( ( pi ^ 2 ) / 6 ) @=
    ? @.

  @( Apery's constant, ` zeta ( 3 ) ` , is irrational. @)
  zeta3irr @p |- ( zeta ` 3 ) e/ QQ @=
    ? @.

  @( The trivial zeroes of the zeta function. @)
  zetatrivz @p |- ( N e. NN -> ( zeta ` ( -u 2 x. N ) ) = 0 ) @=
    ? @.

  @( The nontrivial zeroes of the zeta function are in the critical strip.
     The Riemann Hypothesis would replace this conclusion with
     ` ( Re `` S ) = ( 1 / 2 ) ` . @)
  zetazcs @p |- ( ( S e. ( CC \ ZZ ) /\ ( zeta ` S ) = 0 ) ->
      ( Re ` S ) e. ( 0 (,) 1 ) ) @=
    ? @.
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             Gamma function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c _G $. $( Gamma function (capital letter Gamma) $)
  $c log_G $. $( logarithm of the Gamma function $)
  $c 1/_G $. $( inverse of the Gamma function $)

  $( Logarithm of the Gamma function. $)
  clgam $a class log_G $.

  $( The Gamma function. $)
  cgam $a class _G $.

  $( The inverse Gamma function. $)
  cigam $a class 1/_G $.

  ${
    $d z n m $.
    $( Define the log-Gamma function.  We can work with this form of the gamma
       function a bit easier than the equivalent expression for the gamma
       function itself, and moreover this function is not actually equal to
       ` log ( _G ( x ) ) ` because the branch cuts are placed differently (we
       do have ` exp ( log_G ( x ) ) = _G ( x ) ` , though).  This definition
       is attributed to Euler, and unlike the usual integral definition is
       defined on the entire complex plane except the nonpositive integers
       ` ZZ \ NN ` , where the function has simple poles.  (Contributed by
       Mario Carneiro, 12-Jul-2014.) $)
    df-lgam $a |- log_G = ( z e. ( CC \ ( ZZ \ NN ) ) |-> ( sum_ m e. NN
    ( ( z x. ( log ` ( ( m + 1 ) / m ) ) ) - ( log ` ( ( z / m ) + 1 ) ) )
      - ( log ` z ) ) ) $.

    $( Define the Gamma function.  See ~ df-lgam for more information about the
       reason for this definition in terms of the log-gamma function.
       (Contributed by Mario Carneiro, 12-Jul-2014.) $)
    df-gam $a |- _G = ( exp o. log_G ) $.

    $( Define the inverse Gamma function, which is defined everywhere, unlike
       the Gamma function itself.  (Contributed by Mario Carneiro,
       16-Jul-2017.) $)
    df-igam $a |- 1/_G = ( x e. CC |->
      if ( x e. ( ZZ \ NN ) , 0 , ( 1 / ( _G ` x ) ) ) ) $.
  $}

  $( Elementhood in the set of non-nonpositive integers.  (Contributed by Mario
     Carneiro, 12-Jul-2014.) $)
  eldmgm $p |- ( A e. ( CC \ ( ZZ \ NN ) ) <->
                ( A e. CC /\ -. -u A e. NN0 ) ) $=
    ( cc cz cn cdif wcel wn wa cneg cn0 eldif cr wo simprbi orcanai cc0 wbr clt
    elznn mpbid wceq negneg adantr nn0negz adantl eqeltrrd ex wi cle nngt0 nnre
    lt0neg2d wb renegcld 0re ltnle sylancl nn0ge0 nsyl3 a1i jcad impbid2 syl5bb
    notbid pm5.32i bitri ) ABCDEZEFABFZAVGFZGZHVHAIZJFZGZHABVGKVHVJVMVHVIVLVIAC
    FZADFZGZHZVHVLACDKVHVQVLVNVOVLVNALFVOVLMASNOVHVLVNVPVHVLVNVHVLHVKIZACVHVRAU
    AVLAUBUCVLVRCFVHVKUDUEUFUGVLVPUHVHVOPVKUIQZVLVOVKPRQZVSGZVOPARQVTAUJVOAAUKZ
    ULTVOVKLFPLFVTWAUMVOAWBUNUOVKPUPUQTVKURUSUTVAVBVCVDVEVF $.

  $( If ` A ` is not a nonpositive integer, then ` A + N ` is nonzero for any
     nonnegative integer ` N ` .  (Contributed by Mario Carneiro,
     12-Jul-2014.) $)
  dmgmaddn0 $p |- ( ( A e. ( CC \ ( ZZ \ NN ) ) /\ N e. NN0 ) ->
                    ( A + N ) =/= 0 ) $=
    ( cc cz cn cdif wcel cn0 wa cneg wn caddc co cc0 eldmgm simprbi adantr wceq
    wne cmin df-neg eqeq1i 0cn a1i eldifi nn0cn adantl subaddd simpr syl5ibrcom
    syl5bb eleq1 sylbird necon3bd mpd ) ACDEFZFGZBHGZIZAJZHGZKZABLMZNSUQVBURUQA
    CGZVBAOPQUSVAVCNUSVCNRZUTBRZVAVFNATMZBRUSVEUTVGBAUAUBUSNABNCGUSUCUDUQVDURAC
    UPUEQURBCGUQBUFUGUHUKUSVAVFURUQURUIUTBHULUJUMUNUO $.

  $( If ` A ` is in the continuous domain of the logarithm, then it is in the
     domain of the Gamma function.  (Contributed by Mario Carneiro,
     8-Jul-2017.) $)
  dmlogdmgm $p |- ( A e. ( CC \ ( -oo (,] 0 ) ) ->
    A e. ( CC \ ( ZZ \ NN ) ) ) $=
    ( cc cmnf cc0 cioc co cdif wcel cn0 wn cz cn eldifi cle wbr wa clt cr mpbid
    cneg simpr nn0ge0d crp adantr nn0red negrebd wi eqid ellogdm simprbi syldan
    imp rpgt0d lt0neg2d 0re a1i ltnled pm2.65da eldmgm sylanbrc ) ABCDEFZGZHZAB
    HZATZIHZJABKLGGHABVAMZVCVFDVENOZVCVFPZVEVCVFUAZUBVIVEDQOZVHJVIDAQOVKVIAVCVF
    ARHZAUCHZVIAVCVDVFVGUDVIVEVJUEZUFZVCVLVMVCVDVLVMUGAVBVBUHUIUJULUKUMVIAVOUNS
    VIVEDVNDRHVIUOUPUQSURAUSUT $.

  $( A positive real number is in the domain of the Gamma function.
     (Contributed by Mario Carneiro, 9-Jul-2017.) $)
  rpdmgm $p |- ( A e. RR+ -> A e. ( CC \ ( ZZ \ NN ) ) ) $=
    ( crp wcel cc cmnf cioc co cdif cz cn cr wi rpcn ax-1 eqid ellogdm sylanbrc
    cc0 dmlogdmgm syl ) ABCZADERFGHZCZADIJHHCUAADCAKCZUALUCAMUAUDNAUBUBOPQAST
    $.

  ${
    $d m x y A $.  $d x y N $.
    dmgmn0.a $e |- ( ph -> A e. ( CC \ ( ZZ \ NN ) ) ) $.
    $( If ` A ` is not a nonpositive integer, then ` A ` is nonzero.
       (Contributed by Mario Carneiro, 3-Jul-2017.) $)
    dmgmn0 $p |- ( ph -> A =/= 0 ) $=
      ( cc0 caddc co cc cz cdif eldifad addid1d wcel cn0 0nn0 dmgmaddn0 sylancl
      cn wne eqnetrrd ) ABDEFZBDABABGHQIZCJKABGUAILDMLTDRCNBDOPS $.

    ${
      dmgmaddnn0.n $e |- ( ph -> N e. NN0 ) $.
      $( If ` A ` is not a nonpositive integer and ` N ` is a nonnegative
         integer, then ` A + N ` is also not a nonpositive integer.
         (Contributed by Mario Carneiro, 6-Jul-2017.) $)
      dmgmaddnn0 $p |- ( ph -> ( A + N ) e. ( CC \ ( ZZ \ NN ) ) ) $=
        ( caddc co cc wcel cneg cn0 wn cz cn cdif eldifad nn0cnd eldmgm adantr
        wa addcld sylib simprd wceq cmin negdi2d oveq1d negcld npcand nn0addcld
        eqtrd simpr eqeltrrd mtand sylanbrc ) ABCFGZHIUPJZKIZLUPHMNOZOZIABCABHU
        SDPZACEQZUAAURBJZKIZABHIZVDLZABUTIVEVFTDBRUBUCAURTZUQCFGZVCKAVHVCUDURAV
        HVCCUEGZCFGVCAUQVICFABCVAVBUFUGAVCCABVAUHVBUIUKSVGUQCAURULACKIURESUJUMU
        NUPRUO $.
    $}

    dmgmdivn0.a $e |- ( ph -> M e. NN ) $.
    $( Lemma for ~ lgamf .  (Contributed by Mario Carneiro, 3-Jul-2017.) $)
    dmgmdivn0 $p |- ( ph -> ( ( A / M ) + 1 ) =/= 0 ) $=
      ( caddc co cdiv c1 cc cz cn cdif eldifad nncnd nnne0d divdird dividd wcel
      cc0 oveq2d eqtrd addcld cn0 wne nnnn0d dmgmaddn0 syl2anc divne0d eqnetrrd
      ) ABCFGZCHGZBCHGZIFGZTAULUMCCHGZFGUNABCCABJKLMZDNZACEOZURACEPZQAUOIUMFACU
      RUSRUAUBAUKCABCUQURUCURABJUPMSCUDSUKTUEDACEUFBCUGUHUSUIUJ $.
  $}

  ${
    $d n r y G $.  $d t x y N $.  $d k m n r t x y z R $.  $d m n r t y z U $.
    $d k m t x y A $.  $d n r y O $.  $d m n r t x y z ph $.  $d n r y T $.
    lgamgulm.r $e |- ( ph -> R e. NN ) $.
    lgamgulm.u $e |- U = { x e. CC | ( ( abs ` x ) <_ R /\
      A. k e. NN0 ( 1 / R ) <_ ( abs ` ( x + k ) ) ) } $.
    $( Lemma for ~ lgamgulm .  (Contributed by Mario Carneiro, 3-Jul-2017.) $)
    lgamgulmlem1 $p |- ( ph -> U C_ ( CC \ ( ZZ \ NN ) ) ) $=
      ( cv cabs cfv cle wbr co caddc cn0 cc cn cdif wcel cc0 c1 cdiv wral wa cz
      crab w3a cneg wn simp2 clt 3ad2ant1 nnred nngt0d recgt0d 0re a1i nnrecred
      cr ltnled mpbid wi wceq oveq2 fveq2d breq2d rspccv adantl 3ad2ant3 negidd
      abs0 syl6eq sylibd mtod eldmgm sylanbrc rabssdv syl5eqss ) ADBHZIJCKLZUAC
      UBMZVSEHZNMZIJZKLZEOUCZUDZBPUFPUEQRRZGAWGBPWHAVSPSZWGUGZWIVSUHZOSZUIVSWHS
      AWIWGUJZWJWLWATKLZWJTWAUKLWNUIWJCWJCAWICQSWGFULZUMWJCWOUNUOWJTWATUSSWJUPU
      QWJCWOURUTVAWJWLWAVSWKNMZIJZKLZWNWGAWLWRVBZWIWFWSVTWEWREWKOWBWKVCZWDWQWAK
      WTWCWPIWBWKVSNVDVEVFVGVHVIWJWQTWAKWJWQTIJTWJWPTIWJVSWMVJVEVKVLVFVMVNVSVOV
      PVQVR $.

    ${
      lgamgulm.n $e |- ( ph -> N e. NN ) $.
      lgamgulm.a $e |- ( ph -> A e. U ) $.
      lgamgulm.l $e |- ( ph -> ( 2 x. R ) <_ N ) $.
      $( Lemma for ~ lgamgulm .  (Contributed by Mario Carneiro,
         3-Jul-2017.) $)
      lgamgulmlem2 $p |- ( ph ->
        ( abs ` ( ( A / N ) - ( log ` ( ( A / N ) + 1 ) ) ) ) <_
          ( R x. ( ( 1 / ( N - R ) ) - ( 1 / N ) ) ) ) $=
        ( vt c1 cc0 co cfv wcel cr cc vy cdiv cv cmul caddc clog cmin cmpt cabs
        cle wbr 1elunit 0elunit 0re a1i 1re eqid wss ccncf cn cdif nnred divcld
        recnd unitssre ax-resscn cncfmptc syl3anc sylancr cncfmpt2f wa wi simpr
        crp adantr mulcld ax-1cn addcld cre wceq adantl recld clt abscld syl c2
        cneg rehalfcld absge0d nnrpd absidd oveq2d eqtr2d cn0 wral fveq2 breq1d
        absdivd fveq2d eqbrtrrd lemul12ad absmuld mulid1d mpbid divrecd breqtrd
        simpld wne ledivmuld mpbird letrd oveq2i syl6eq breqtrrd eqeltrrd eqidd
        lelttrd wf fvres eqtrd wb cdv cioo logcld subcld sylan2 reccld remulcld
        cdm oveq2 resubcld cvv oveq12d oveq1d dividd divsubdird recdivd eqbrtrd
        nfcv abs1 cicc ccnfld ctopn ctx ccn subcn mulcn cz lgamgulmlem1 eldifad
        sseldd nnne0d sstri ssid cncfmptid cmnf cioc cres ccom absrele nndivred
        sseldi rere elicc2i simp2bi rpge0d oveq1 breq2d ralbidv anbi12d simprbi
        elrab2 lediv1dd simp3bi 3brtr3d 2rp lemuldiv2d 2re 2ne0 absltd renegcld
        halflt1 posdifd subnegd readdd re1 elrpd ellogdm sylanbrc logcn feqmptd
        ex cncff fmptco mpteq2dva fmptd difss addcn cncffvrn cncfco crn logdmn0
        ctg tgioo2 cnt iccntr dvmptntr reex prid1 ioossicc sseli sselda dvmptid
        cpr dvmptcmul mpteq2dv ctop retop iooretop isopn3i mp2an dvmptres2 cnex
        syl5ss prid2 eldifi 0cn dvmptadd addid1d mpteq2ia syl6req dvlog dvmptco
        dvmptc dvmptsub dmeqd dmmpti ltaddrpd 2timesd ltletrd rprecred nnrecred
        ovex difrp syl2anc fveq1d nffvmpt1 nffv nfbr nfim anbi2d imbi12d fvmpt2
        nfv eleq1 sylancl subdid mulcomd div23d 3eqtr4d 3eqtrd rpdivcld divne0d
        dmgmn0 eliooord gt0ne0d mulne0d divdird eqnetrrd absrpcld negcld rpne0d
        0le1 rpred rerpdivcld lerecd absnegd oveq1i lesub1dd abs2difd syl5eqbrr
        addcomd negeqd negdi2d eqtr3d gtned subne0d nncand pncand eqcomd recidd
        lediv2ad 3eqtr3rd 3eqtr2d 3brtr4d mul12d chvar mpanr12 sylan9eqr fvmptd
        dvlip mul01d 0p1e1 log1 subid1i dmgmdivn0 subid1d fveq2i eqtri syl5req
        ) ANMONUUAPZCGUBPZMUCZUDPZVXNNUEPZUFQZUGPZUHZQZOVXRQZUGPZUIQZDNGDUGPZUB
        PZNGUBPZUGPZUDPZNOUGPZUIQZUDPZVXLVXLNUEPZUFQZUGPZUIQVYGUJANVXKRZOVXKRZV
        YBVYJUJUKULUMAUAONVXRVYGNOOSRZAUNUONSRZAUPUOZAMVXNVXPUGUUBUUCQZVXKVYSUQ
        ZUGVYSVYSUUDPVYSUUEPZRAVYSVYTUUFUOAMVXLVXMUDVYSVXKVYTUDWUARAVYSVYTUUGUO
        AVXLTRZVXKTURZTTURZMVXKVXLUHVXKTUSPZRACGACTUUHUTVAZAETWUFVACABDEFHIUUIK
        UUKZUUJZAGAGJVBZVDZAGJUULZVCZWUCAVXKSTVEVFUUMZUOZWUDATUUNUOZMVXLVXKTVGV
        HAWUCWUDMVXKVXMUHWUERWUMWUOMVXKTUUOVIVJZAUFTUUPOUUQPZVAZUURZMVXKVXOUHZU
        USZMVXKVXPUHZWUEAWVAMVXKVXOWUSQZUHWVBAMUAVXKWURVXOUAUCZWUSQZWVCWUTWUSAV
        XMVXKRZVKZVXOTRVXOSRZVXOVNRZVLVXOWURRZWVGVXNNWVGVXLVXMAWUBWVFWULVOZWVGV
        XMWVGVXKSVXMVEAWVFVMUVBZVDZVPZNTRZWVGVQUOZVRZWVGWVHWVIWVGWVHVKVXOVSQZVX
        OVNWVHWVRVXOVTWVGVXOUVCWAWVGWVRVNRWVHWVGWVRWVGVXOWVQWBWVGOVXNVSQZNUEPZW
        VRWCWVGOWVSNWGZUGPZWVTWCWVGWWAWVSWCUKZOWWBWCUKWVGWWCWVSNWCUKZWVGWVSUIQZ
        NWCUKWWCWWDVKWVGWWEVXNUIQZNWVGWVSWVGWVSWVGVXNWVNWBZVDZWDWVGVXNWVNWDZVYQ
        WVGUPUOZWVGVXNTRWWEWWFUJUKWVNVXNUUTWEWVGWWFNWFUBPZNWWIWVGNWWJWHZWWJWVGW
        WFDGUBPZWWKWWIWVGDGADSRZWVFADHVBZVOAGUTRWVFJVOUVAZWWLWVGVXLUIQZVXMUDPZW
        WMNUDPWWFWWMUJWVGWWQWWMVXMNAWWQSRWVFAVXLWULWDVOWWPWVLWWJWVGVXLWVKWIWVFO
        VXMUJUKZAWVFVXMSRZWWSVXMNUJUKZONVXMUNUPUVDZUVEWAZAWWQWWMUJUKWVFACUIQZGU
        BPZWWQWWMUJAWWQWXDGUIQZUBPZWXEACGWUHWUJWUKWRAWXFGWXDUBAGWUIAGAGJWJZUVFZ
        WKWLWMAWXDDGACWUHWDZWWOWXHAWXDDUJUKZNDUBPZCFUCZUEPZUIQZUJUKZFWNWOZACERZ
        WXKWXQVKZKWXRCTRZWXSBUCZUIQZDUJUKZWXLWYAWXMUEPZUIQZUJUKZFWNWOZVKWXSBCTE
        WYACVTZWYCWXKWYGWXQWYHWYBWXDDUJWYACUIWPWQWYHWYFWXPFWNWYHWYEWXOWXLUJWYHW
        YDWXNUIWYACWXMUEUVGWSUVHUVIUVJIUVLUVKWEXGZUVMWTVOWVFWXAAWVFWWTWWSWXAWXB
        UVNWAXAWVGWWFWWQVXMUIQZUDPWWRWVGVXLVXMWVKWVMXBWVGWYJVXMWWQUDWVGVXMWVLWX
        CWKWLWMWVGWWMWVGWWMWWPVDXCUVOZAWWMWWKUJUKZWVFAWYLDGWWKUDPZUJUKADGWFUBPZ
        WYMUJAWFDUDPZGUJUKDWYNUJUKLADGWFWWOWUIWFVNRAUVPUOUVQXDAGWFWUJAWFWFSRAUV
        RUOZVDWFOXHAUVSUOXEXFADWWKGWWOANVYRWHWXHXIXJVOXKWWKNWCUKWVGUWBUOXQXQWVG
        WVSNWWGWWJUVTXDXGWVGWWAWVSWVGNWWJUWAWWGUWCXDWVGWVSNWWHWVPUWDXFWVGWVRWVS
        NVSQZUEPWVTWVGVXNNWVNWVPUWEWYQNWVSUEUWFXLXMXNUWGVOXOUWLVXOWURWURUQZUWHU
        WIZAWUTXPAUAWURTWUSAWUSWURTUSPRZWURTWUSXRWYTAWURWYRUWJUOZWURTWUSUWMWEUW
        KZWVDVXOWUSWPUWNAMVXKWVCVXPWVGWVJWVCVXPVTWYSVXOWURUFXSWEUWOXTAVXKWURTWU
        TWUSAWUTVXKWURUSPRZVXKWURWUTXRZAMVXKVXOWURWUTWYSWUTUQUWPAWURTURWUTWUERX
        UCXUDYATWUQUWQAMVXNNUEVYSVXKVYTUEWUARAVYSVYTUWRUOWUPAWVOWUCWUDMVXKNUHWU
        ERWVOAVQUOZWUNWUOMNVXKTVGVHVJVXKTWURWUTUWSVIXJXUAUWTXOVJASVXRYBPZYIMONY
        CPZVXLNVXOUBPZVXLUDPZUGPZUHZYIXUGAXUFXUKAXUFSMXUGVXQUHYBPXUKAMVXQSYCUXA
        UXCQZVYSVXKXUGSTURAVFUOZVXKSURAVEUOZWVGVXNVXPWVNWVGVXOWVQWVGWVJVXOOXHZW
        YSVXOWURWYRUXBWEZYDZYEVYSVYTUXDZVYTAVYPVYQVXKXULUXEQZQXUGVTUNVYRONUXFVI
        UXGAMVXNVXLVXPXUISTTXUGSSTUXNZRASTUXHUXIUOZAVXMXUGRZVKZVXLVXMXVCCGAWXTX
        VBWUHVOZAGTRZXVBWUJVOZAGOXHZXVBWUKVOZVCZXVBAWVFVXMTRXUGVXKVXMONUXJZUXKZ
        WVMYFZVPZXVIAMVXNVXLSXULVYSTSXUGXUGXVAAWWTVKZVXLVXMXVNCGAWXTWWTWUHVOAXV
        EWWTWUJVOAXVGWWTWUKVOVCZASTVXMXUMUXLZVPZXVOASMSVXNUHYBPMSVXLNUDPZUHMSVX
        LUHZAMVXMNVXLSTSXVAXVPWVOXVNVQUOZAMSXVAUXMWULUXOAMSXVRVXLAVXLWULXCZUXPX
        TZAXUGVXKSXVJXUNUYDZXURVYTXUGXUSQXUGVTZAXULUXQRXUGXULRXWDUXRONUXSXUGXUL
        UXTUYAUOZUYBXVBAWVFVXPTRXVKXUQYFXVCXUHVXLXVCVXOXVCVXNNXVMWVOXVCVQUOZVRZ
        XVBAWVFXUOXVKXUPYFZYGZXVIVPAMUAVXOVXLWVDUFQZNWVDUBPZSTVXPXUHTTXUGWURXVA
        TXUTRASTUYCUYEUOXVBAWVFWVJXVKWYSYFXVIAWVDWURRZVKZWVDXWLWVDTRAWVDTWUQUYF
        WAZXWLWVDOXHAWVDWURWYRUXBWAZYDXWMWVDXWNXWOYGAMVXOVXLSXULVYSTSXUGXUGXVAX
        VNVXNNXVQXVTVRXVOASMSVXOUHYBPMSVXLOUEPZUHXVSAMVXNVXLNOSTTSXVAXVQXVOXWBX
        VTOTRXVNUYGUOAMNSXVAXUEUYNUYHAMSXWPVXLAVXLWULUYIUXPXTXWCXURVYTXWEUYBATU
        AWURXWJUHZYBPTWUSYBPUAWURXWKUHAXWQWUSTYBAWUSUAWURWVEUHXWQXUBUAWURWVEXWJ
        WVDWURUFXSUYJUYKWLUAWURWYRUYLXMWVDVXOUFWPWVDVXONUBYJUYMUYOXTZUYPMXUGXUJ
        XUKVXLXUIUGVUCZXUKUQZUYQXMADVYFWWOAVYDVYEAVYCADGWCUKZVYCVNRZADWYOGWWOAW
        FDWYPWWOYHWUIADDDUEPWYOWCADDWWOADHWJZUYRADADWWOVDZUYSXNLUYTZAWWNGSRZXXA
        XXBYAWWOWUIDGVUDVUEXDZVUAZAGJVUBZYKZYHZAWVDXUGRZVKZWVDXUFQZUIQZWVDXUKQZ
        UIQZVYGUJAXXOXXQVTXXLAXXNXXPUIAWVDXUFXUKXWRVUFWSVOXVCVXMXUKQZUIQZVYGUJU
        KZVLXXMXXQVYGUJUKZVLMUAXXMXYAMXXMMVUNMXXQVYGUJMXXPUIMUIYSMXUGXUJWVDVUGV
        UHMUJYSMVYGYSVUIVUJVXMWVDVTZXVCXXMXXTXYAXYBXVBXXLAVXMWVDXUGVUOVUKXYBXXS
        XXQVYGUJXYBXXRXXPUIVXMWVDXUKWPWSWQVULXVCXXSWXDNXUHUGPZUIQZUDPZGUBPZVYGU
        JXVCXXSXUJUIQVXLXYCUDPZUIQZXYFXVCXXRXUJUIXVCXVBXUJYLRXXRXUJVTAXVBVMXWSM
        XUGXUJYLXUKXWTVUMVUPWSXVCXUJXYGUIXVCXYGXVRVXLXUHUDPZUGPXUJXVCVXLNXUHXVI
        XWFXWIVUQXVCXVRVXLXYIXUIUGXVCVXLXVIXCXVCVXLXUHXVIXWIVURYMWMWSXVCWWQXYDU
        DPWXEXYDUDPXYHXYFXVCWWQWXEXYDUDXVCWWQWXGWXEXVCCGXVDXVFXVHWRXVCWXFGWXDUB
        XVCGAXXFXVBWUIVOZAOGUJUKXVBWXIVOWKWLXTYNXVCVXLXYCXVIXVCNXUHXWFXWIYEZXBX
        VCWXDXYDGXVCWXDAWXDSRXVBWXJVOZVDXVCXYDXVCXYCXYKWDZVDXVFXVHVUSVUTVVAXVCX
        YFVYGUJUKXYEGVYGUDPZUJUKXVCXYEDGVYFUDPZUDPXYNUJXVCWXDDXYDXYOXYLAWWNXVBW
        WOVOXYMXVCGVYFXYJXVCVYDVYEAVYDSRXVBXXHVOAVYESRXVBXXIVOYKYHAOWXDUJUKXVBA
        CWUHWIVOXVCXYCXYKWIAWXKXVBWYIVOXVCNNNVXNUBPZUEPZUIQZUBPZGVYCUBPZNUGPZXY
        DXYOUJXVCXYSNVYCDUBPZUBPZYUAUJXVCYUBXYRNXVCVYCDAXXBXVBXXGVOADVNRXVBXXCV
        OZVVBZXVCXYQXVCNXYPXWFXVCVXNXVMXVCVXLVXMXVIXVLXVCCGXVDXVFACOXHXVBACWUGV
        VDVOXVHVVCXVCVXMXVCOVXMWCUKZVXMNWCUKZXVBYUFYUGVKAVXMONVVEWAXGVVFVVGZYGZ
        VRZXVCVXOVXNUBPZXYQOXVCYUKVXNVXNUBPZXYPUEPXYQXVCVXNNVXNXVMXWFXVMYUHVVHX
        VCYULNXYPUEXVCVXNXVMYUHYOYNXTZXVCVXOVXNXWGXVMXWHYUHVVCVVIZVVJVYQXVCUPUO
        ZONUJUKXVCVVMUOXVCYUBXYPWGZUIQZNUGPZXYRXVCYUBYUEVVNXVCYUQNXVCYUPXVCXYPY
        UIVVKZWDZYUOYKXVCXYQYUJWDXVCYUBGDUBPZNUGPZYURUJXVCYUBYVADDUBPZUGPYVBXVC
        GDDXVFADTRXVBXXDVOZYVDXVCDYUDVVLZYPXVCYVCNYVAUGXVCDYVDYVEYOWLXTXVCYVAYU
        QNXVCGDXYJYUDVVOYUTYUOXVCYVANWWFUBPZYUQUJXVCNWWMUBPZYVAYVFUJXVCDGYVDXVF
        YVEXVHYQXVCWWFWWMUJUKZYVGYVFUJUKXVBAWVFYVHXVKWYKYFXVCWWFWWMXVCVXNXVMYUH
        VVJXVCDGYUDAGVNRXVBWXHVOZVVBVVPXDWTXVCYUQXYPUIQZYVFXVCXYPYUIVVQXVCYVJNU
        IQZWWFUBPYVFXVCNVXNXWFXVMYUHWRYVKNWWFUBYTVVRXMXTXNVVSYRXVCYURYUPNUGPZUI
        QZXYRUJXVCYURYUQYVKUGPYVMUJYVKNYUQUGYTXLXVCYUPNYUSXWFVVTVWAXVCXYQWGZUIQ
        YVMXYRXVCYVNYVLUIXVCYVNXYPNUEPZWGYVLXVCXYQYVOXVCNXYPXWFYUIVWBVWCXVCXYPN
        YUIXWFVWDXTWSXVCXYQYUJVVQVWEXFXKVWLXVCYUCDVYCUBPZXYTVYCVYCUBPZUGPZYUAXV
        CVYCDAVYCTRXVBAGDWUJXXDYEZVOZYVDAVYCOXHXVBAGDWUJXXDADGWWOXXEVWFVWGZVOZY
        VEYQXVCGVYCUGPZVYCUBPYVPYVRXVCYWCDVYCUBXVCGDXVFYVDVWHYNXVCGVYCVYCXVFYVT
        YVTYWBYPVWEXVCYVQNXYTUGXVCVYCYVTYWBYOWLVVAXFXVCXYDNXYQUBPZUIQZXYSXVCXYC
        YWDUIXVCXYCVXNVXOUBPZNYUKUBPYWDXVCVXONUGPZVXOUBPVXOVXOUBPZXUHUGPYWFXYCX
        VCVXONVXOXWGXWFXWGXWHYPXVCYWGVXNVXOUBXVCVXNNXVMXWFVWIYNXVCYWHNXUHUGXVCV
        XOXWGXWHYOYNVWMXVCVXOVXNXWGXVMXWHYUHYQXVCYUKXYQNUBYUMWLVWNWSXVCYWEYVKXY
        RUBPXYSXVCNXYQXWFYUJYUNWRYVKNXYRUBYTVVRXMXTXVCXYOGVYDUDPZGVYEUDPZUGPYUA
        XVCGVYDVYEXVFAVYDTRXVBAVYCYVSYWAYGVOAVYETRXVBAVYEXXIVDVOVUQXVCYWIXYTYWJ
        NUGXVCXYTYWIXVCGVYCXVFYVTYWBXEVWJXVCGXVFXVHVWKYMXTVWOXAXVCDGVYFYVDXVFAV
        YFTRXVBAVYFXXJVDZVOVWPXFXVCXYEVYGGXVCWXDXYDXYLXYMYHAVYGSRXVBXXKVOYVIXIX
        JYRVWQYRVXAVWRAVYMVYAUIAVYAVYMOUGPVYMAVXSVYMVXTOUGAMNVXQVYMVXKVXRYLAVXR
        XPZAVXMNVTZVKZVXNVXLVXPVYLUGYWMAVXNXVRVXLVXMNVXLUDYJXWAVWSZYWNVXOVYKUFY
        WNVXNVXLNUEYWOYNWSYMVYNAULUOVYMYLRAVXLVYLUGVUCUOVWTAMOVXQOVXKVXRVXKYWLA
        VXMOVTZVKZVXQOOUGPOYWQVXNOVXPOUGYWPAVXNVXLOUDPOVXMOVXLUDYJAVXLWULVXBVWS
        ZYWQVXPNUFQOYWQVXONUFYWQVXOONUEPNYWQVXNONUEYWRYNVXCXMWSVXDXMYMOUYGVXEXM
        VYOAUMUOZYWSVWTYMAVYMAVXLVYLWULAVYKAVXLNWULXUEVRACGWUGJVXFYDYEVXGWMWSAV
        YJVYGNUDPVYGVYINVYGUDVYIYVKNVYHNUINVQVXEVXHYTVXIXLAVYGADVYFXXDYWKVPXCVX
        JVWO $.

      $( Lemma for ~ lgamgulm .  (Contributed by Mario Carneiro,
         3-Jul-2017.) $)
      lgamgulmlem3 $p |- ( ph ->
        ( abs ` ( ( A x. ( log ` ( ( N + 1 ) / N ) ) ) -
                  ( log ` ( ( A / N ) + 1 ) ) ) ) <_
        ( R x. ( ( 2 x. ( R + 1 ) ) / ( N ^ 2 ) ) ) ) $=
        ( c1 co cdiv cfv cmul cmin c2 cle caddc clog cabs cc cz cn lgamgulmlem1
        cexp cdif sseldd eldifad peano2nnd nnrpd rpdivcld relogcld recnd mulcld
        nncnd nnne0d divcld wcel ax-1cn addcld dmgmdivn0 logcld subcld readdcld
        a1i abscld nnred cr 2re 1re remulcld nnsqcld nndivred abs3difd nnrecred
        resubcld clt wbr crp ltaddrpd 2timesd breqtrrd ltletrd wb difrp syl2anc
        mpbid rprecred divrecd oveq2d subdid eqtr4d fveq2d absmuld eqtrd cv cn0
        absge0d wral wa wceq fveq2 breq1d breq2d ralbidv anbi12d elrab2 simprbi
        oveq1 simpld relogdivd logdifbnd eqbrtrd abssuble0d logdiflbnd lesub2dd
        syl lemul12ad lgamgulmlem2 le2addd gtned subne0d subrecd pnncand oveq1d
        addcomd eqtr2d reccld npncan3d eqcomd adddid 3eqtrd rpmulcld rerpdivcld
        rpge0d cc0 letrd rpexpcld rphalfcld 0le1 addge0d sqvald wne 2ne0 div23d
        2z rehalfcld divge0d lemuldiv2d 2halvesd subaddd mpbird lesubd lediv2ad
        2rp lep1d divdiv2d mulcomd lemul2ad eqbrtrrd ) ACGMUANZGONZUBPZQNZCGONZ
        MUANZUBPZRNZUCPUVGUVHRNZUCPZUVHUVJRNZUCPZUANZDSDMUANZQNZGSUHNZONZQNZAUV
        KAUVGUVJACUVFACUDUEUFUIZAEUDUWBUICABDEFHIUGKUJZUKZAUVFAUVEAUVDGAUVDAGJU
        LZUMZAGJUMZUNUOZUPZUQZAUVIAUVHMACGUWDAGJURZAGJUSZUTZMUDVAAVBVHZVCACGUWC
        JVDVEZVFVIAUVMUVOAUVLAUVGUVHUWJUWMVFVIZAUVNAUVHUVJUWMUWOVFVIZVGZADUVTAD
        HVJZAUVRUVSASUVQSVKVAAVLVHZADMUWSMVKVAAVMVHZVGZVNAGJVOZVPZVNZAUVGUVJUVH
        UWJUWOUWMVQAUVPDMGONZMUVDONZRNZQNZDMGDRNZONZUXFRNZQNZUANZUWAUWRAUXIUXMA
        DUXHUWSAUXFUXGAGJVRZAUVDUWEVRZVSZVNZADUXLUWSAUXKUXFAUXJADGVTWAZUXJWBVAZ
        ADSDQNZGUWSASDUWTUWSVNAGJVJZADDDUANUYAVTADDUWSADHUMZWCADADHURZWDWELWFZA
        DVKVAGVKVAUXSUXTWGUWSUYBDGWHWIWJZWKUXOVSZVNZVGUXEAUVMUVOUXIUXMUWPUWQUXR
        UYHAUVMCUCPZUVFUXFRNZUCPZQNZUXITAUVMCUYJQNZUCPUYLAUVLUYMUCAUVLUVGCUXFQN
        ZRNUYMAUVHUYNUVGRACGUWDUWKUWLWLWMACUVFUXFUWDUWIAUXFUXOUPZWNWOWPACUYJUWD
        AUVFUXFUWIUYOVFZWQWRAUYIDUYKUXHACUWDVIUWSAUYJUYPVIUXQACUWDXAAUYJUYPXAAU
        YIDTWAZMDONZCFWSZUANZUCPZTWAZFWTXBZACEVAZUYQVUCXCZKVUDCUDVAVUEBWSZUCPZD
        TWAZUYRVUFUYSUANZUCPZTWAZFWTXBZXCVUEBCUDEVUFCXDZVUHUYQVULVUCVUMVUGUYIDT
        VUFCUCXEXFVUMVUKVUBFWTVUMVUJVUAUYRTVUMVUIUYTUCVUFCUYSUAXLWPXGXHXIIXJXKX
        TXMAUYKUXFUVFRNUXHTAUVFUXFUWHUXOAUVFUVDUBPGUBPRNZUXFTAUVDGUWFUWGXNZAGWB
        VAZVUNUXFTWAUWGGXOXTXPXQAUXGUVFUXFUXPUWHUXOAUXGVUNUVFTAVUPUXGVUNTWAUWGG
        XRXTVUOWEXSXPYAXPABCDEFGHIJKLYBYCADUVQUXJUVDQNZONZQNZUXNUWATAVUSDUXKUXG
        RNZQNDUXHUXLUANZQNUXNAVURVUTDQAVUTUVDUXJRNZVUQONVURAUXJUVDAGDUWKUYDVFZA
        GMUWKUWNVCZAGDUWKUYDADGUWSUYEYDYEZAUVDUWEUSZYFAVVBUVQVUQOAVVBMDUANUVQAG
        MDUWKUWNUYDYGAMDUWNUYDYIWRYHYJWMAVUTVVADQAVVAVUTAUXFUXGUXKUYOAUVDVVDVVF
        YKAUXJVVCVVEYKYLYMWMADUXHUXLUYDAUXHUXQUPAUXLUYGUPYNYOAVURUVTDAUVQVUQUXB
        AUXJUVDUYFUWFYPZYQUXDUWSADUYCYRZAVURUVQUVSSONZONZUVTTAVVIVUQUVQAUVSAGSU
        WGSUEVAAUUIVHUUAUUBVVGUXBADMUWSUXAVVHYSMTWAAUUCVHUUDAVVIGSONZGQNZVUQTAV
        VIGGQNZSONVVLAUVSVVMSOAGUWKUUEYHAGGSUWKUWKASUWTUPZSYSUUFAUUGVHZUUHWRAVV
        KUXJGUVDAGUYBUUJZAGDUYBUWSVSUYBAGMUYBUXAVGAGSUYBSWBVAAUURVHZAGUWGYRZUUK
        VVRADGVVKUWSUYBVVPADVVKGVVKRNZTAUYAGTWADVVKTWALADGSUWSUYBVVQUULWJAVVSVV
        KXDVVKVVKUANGXDAGUWKUUMAGVVKVVKUWKAVVKVVPUPZVVTUUNUUOWEUUPAGUYBUUSYAXPU
        UQAVVJUVQSQNZUVSONUVTAUVQUVSSAUVQADHULURZAUVSUXCURVVNAUVSUXCUSVVOUUTAVW
        AUVRUVSOAUVQSVWBVVNUVAYHYJWEUVBUVCYTYT $.
    $}

    lgamgulm.g $e |- G = ( m e. NN |-> ( z e. U |->
  ( ( z x. ( log ` ( ( m + 1 ) / m ) ) ) - ( log ` ( ( z / m ) + 1 ) ) ) ) ) $.
    ${
      lgamgulm.t $e |- T = ( m e. NN |-> if ( ( 2 x. R ) <_ m ,
        ( R x. ( ( 2 x. ( R + 1 ) ) / ( m ^ 2 ) ) ) ,
        ( ( R x. ( log ` ( ( m + 1 ) / m ) ) ) +
          ( ( log ` ( ( R + 1 ) x. m ) ) + pi ) ) ) ) $.
      $( Lemma for ~ lgamgulm .  (Contributed by Mario Carneiro,
         3-Jul-2017.) $)
      lgamgulmlem4 $p |- ( ph -> seq 1 ( + , T ) e. dom ~~> ) $=
        ( caddc c1 wcel c2 cmul co cn vn cseq cli cdm cv cexp cdiv cmpt 2nn a1i
        nnmulcld nnzd cuz cfv wa cle wbr clog cpi cif wceq eluzle adantl iftrue
        syl nnuz uztrn2 sylan breq2 oveq1 oveq2d id oveq12d fveq2d oveq2 oveq1d
        ifbieq12d ovex ifex fvmpt eqid 3eqtr4d seqfeq cneg ccxp cz 1z nncnd 2cn
        cc ax-1cn addcld mulcld cre clt 1lt2 cr 2re rere ax-mp breqtrri zetacvg
        climdm sylib simpr negcld cxpcld eqeltrd adantr sqcld nnne0d 2z expne0d
        divrecd divassd cxpnegd cxpexpzd eqtr2d 3eqtr3d climrel releldmi divcld
        isermulc2 iserex mpbid 1re readdcld remulcld nnsqcld nndivred peano2nnd
        nnred nnrpd rpdivcld relogcld rpmulcld pire ifcl syl2anc recnd mpbird )
        ANEOUBUCUDZPNEQDRSZUBZUUBPAUUDNHTDQDONSZRSZHUEZQUFSZUGSZRSZUHZUUCUBZUUB
        ANUAEUUKUUCAUUCAQDQTPAUIUJJUKZULAUAUEZUUCUMUNPZUOZUUCUUNUPUQZDUUFUUNQUF
        SZUGSZRSZDUUNONSZUUNUGSZURUNZRSZUUEUUNRSZURUNZUSNSZNSZUTZUUTUUNEUNZUUNU
        UKUNZUUPUUQUVIUUTVAUUOUUQAUUCUUNVBVCUUQUUTUVHVDVEUUPUUNTPZUVJUVIVAZAUUC
        TPUUOUVLUUMOUUNUUCTVFVGVHZHUUNUUCUUGUPUQZUUJDUUGONSZUUGUGSZURUNZRSZUUEU
        UGRSZURUNZUSNSZNSZUTUVITEUUGUUNVAZUVOUUQUUJUWCUUTUVHUUGUUNUUCUPVIUWDUUI
        UUSDRUWDUUHUURUUFUGUUGUUNQUFVJVKVKZUWDUVSUVDUWBUVGNUWDUVRUVCDRUWDUVQUVB
        URUWDUVPUVAUUGUUNUGUUGUUNONVJUWDVLVMVNVKUWDUWAUVFUSNUWDUVTUVEURUUGUUNUU
        ERVOVNVPVMVQMUUQUUTUVHDUUSRVRZUVDUVGNVRVSVTZVEUUPUVLUVKUUTVAZUVNHUUNUUJ
        UUTTUUKUWEUUKWAUWFVTZVEWBWCANUUKOUBZUUBPZUULUUBPAUWJDUUFRSZNHTUUGQWDZWE
        SZUHZOUBZUCUNZRSZUCUQUWKAUWQUWLUAUWOUUKOTVFOWFPAWGUJADUUFADJWHZAQUUEQWJ
        PZAWIUJZADOUWSOWJPZAWKUJWLWMWMAUWPUUBPUWPUWQUCUQAQUAUWOUXAOQWNUNZWOUQAO
        QUXCWOWPQWQPZUXCQVAWRQWSWTXAUJUVLUUNUWOUNZUUNUWMWESZVAAHUUNUWNUXFTUWOUU
        GUUNUWMWEVJUWOWAUUNUWMWEVRVTVCZXBUWPXCXDAUVLUOZUXEUXFWJUXGUXHUUNUWMUXHU
        UNAUVLXEZWHZUXHQUWTUXHWIUJZXFXGXHUXHUUTUWLUXFRSZUVKUWLUXERSUXHUWLUURUGS
        UWLOUURUGSZRSUUTUXLUXHUWLUURUXHDUUFADWJPUVLUWSXIZUXHQUUEUXKUXHDOUXNUXBU
        XHWKUJWLWMZWMUXHUUNUXJXJZUXHUUNQUXJUXHUUNUXIXKZQWFPUXHXLUJZXMZXNUXHDUUF
        UURUXNUXOUXPUXSXOUXHUXMUXFUWLRUXHUXFOUUNQWESZUGSUXMUXHUUNQUXJUXQUXKXPUX
        HUXTUUROUGUXHUUNQUXJUXQUXRXQVKXRVKXSUVLUWHAUWIVCZUXHUXEUXFUWLRUXGVKWBYC
        UWJUWRUCXTYAVEAUAUUKOUUCTVFUUMUXHUVKUUTWJUYAUXHDUUSUXNUXHUUFUURUXOUXPUX
        SYBWMXHYDYEXHAUAEOUUCTVFUUMUXHUVJUXHUVJUVIWQUVLUVMAUWGVCUXHUUTWQPUVHWQP
        UVIWQPUXHDUUSUXHDADTPUVLJXIZYLZUXHUUFUURUXHQUUEUXDUXHWRUJUXHDOUYCOWQPUX
        HYFUJYGYHUXHUUNUXIYIYJYHUXHUVDUVGUXHDUVCUYCUXHUVBUXHUVAUUNUXHUVAUXHUUNU
        XIYKYMUXHUUNUXIYMZYNYOYHUXHUVFUSUXHUVEUXHUUEUUNUXHUUEUXHDUYBYKYMUYDYPYO
        USWQPUXHYQUJYGYGUUQUUTUVHWQYRYSXHYTYDUUA $.

      $( Lemma for ~ lgamgulm .  (Contributed by Mario Carneiro,
         3-Jul-2017.) $)
      lgamgulmlem5 $p |- ( ( ph /\ ( n e. NN /\ y e. U ) ) ->
        ( abs ` ( ( G ` n ) ` y ) ) <_ ( T ` n ) ) $=
        ( c1 caddc co cfv cle vt cv cn wcel wa cdiv clog cmul cmin cabs c2 cexp
        wbr cpi cif breq2 adantr cn0 wral cc crab weq fveq2 breq1d oveq1 fveq2d
        breq2d ralbidv anbi12d cbvrabv eqtri simplrl simpr lgamgulmlem3 wn cdif
        simprr cz lgamgulmlem1 sseldd eldifad peano2nnd nnrpd rpdivcld relogcld
        wss simprl recnd mulcld nncnd nnne0d divcld ax-1cn a1i addcld dmgmdivn0
        logcld subcld abscld readdcld nnred remulcld rpmulcld cr pire abs2dif2d
        absmuld rpred mulid2d lep1d eqbrtrd 1re lemuldivd logge0d absidd oveq2d
        mpbid eqtrd elrab2 simprbi ad2antll cc0 crp wceq 1rp oveq2 letrd eqtr2d
        nnrecred absdivd rpge0d 3brtr3d logled leadd1dd oveq12d oveq1d ad2antrl
        cmpt fvmpt ovex simpld lemul1ad absrpcld abslogle syl2anc cneg relogdiv
        wne sylancr log1 oveq1i df-neg eqtr4i 0le1 lediv2ad nnnn0d simprd rspcv
        syl6req sylc lediv1dd recdiv2d divdird dividd 3eqtrrd rpreccld syl6breq
        abstrid abs1 oveq2i absge0d nnge1d lediv12ad div1d lemulge11d mpbir2and
        absled le2addd ifbothda id mpteq2dv cvv cnex rabex eqeltri mptex fveq1d
        eqid ifbieq12d ifex 3brtr4d ) AJUBZUCUDZCUBZGUDZUEZUEZUWNUWLPQRZUWLUFRZ
        UGSZUHRZUWNUWLUFRZPQRZUGSZUIRZUJSZUKEUHRZUWLTUMZEUKEPQRZUHRZUWLUKULRZUF
        RZUHRZEUWTUHRZUXIUWLUHRZUGSZUNQRZQRZUOZUWNUWLKSZSZUJSUWLFSZTUXHUXFUXMTU
        MUXFUXRTUMZUXFUXSTUMUWQUXMUXRUXMUXSUXFTUPUXRUXSUXFTUPUWQUXHUEUAUWNEGHUW
        LUWQEUCUDZUXHAUYDUWPLUQZUQGBUBZUJSZETUMZPEUFRZUYFHUBZQRZUJSZTUMZHURUSZU
        EZBUTVAZUAUBZUJSZETUMZUYIUYQUYJQRZUJSZTUMZHURUSZUEZUAUTVAMUYOVUDBUAUTBU
        AVBZUYHUYSUYNVUCVUEUYGUYRETUYFUYQUJVCVDVUEUYMVUBHURVUEUYLVUAUYITVUEUYKU
        YTUJUYFUYQUYJQVEVFVGVHVIVJVKAUWMUWOUXHVLUWQUWOUXHAUWMUWOVQZUQUWQUXHVMVN
        UWQUYCUXHVOUWQUXFUXAUJSZUXDUJSZQRUXRUWQUXEUWQUXAUXDUWQUWNUWTUWQUWNUTVRU
        CVPZUWQGUTVUIVPZUWNAGVUJWFUWPABEGHLMVSUQVUFVTZWAZUWQUWTUWQUWSUWQUWRUWLU
        WQUWRUWQUWLAUWMUWOWGZWBWCUWQUWLVUMWCZWDZWEZWHZWIZUWQUXCUWQUXBPUWQUWNUWL
        VULUWQUWLVUMWJZUWQUWLVUMWKZWLZPUTUDUWQWMWNZWOZUWQUWNUWLVUKVUMWPZWQZWRWS
        UWQVUGVUHUWQUXAVURWSZUWQUXDVVEWSZWTUWQUXNUXQUWQEUWTUWQEUYEXAZVUPXBZUWQU
        XPUNUWQUXOUWQUXIUWLUWQUXIUWQEUYEWBZWCZVUNXCZWEZUNXDUDUWQXEWNZWTZWTUWQUX
        AUXDVURVVEXFUWQVUGVUHUXNUXQVVFVVGVVIVVOUWQVUGUWNUJSZUWTUHRZUXNTUWQVUGVV
        PUWTUJSZUHRVVQUWQUWNUWTVULVUQXGUWQVVRUWTVVPUHUWQUWTVUPUWQUWSUWQUWSVUOXH
        UWQPUWLUHRZUWRTUMPUWSTUMUWQVVSUWLUWRTUWQUWLVUSXIUWQUWLUWQUWLVUMXAZXJXKU
        WQPUWRUWLPXDUDUWQXLWNZUWQUWLPVVTVWAWTVUNXMXQXNZXOXPXRUWQVVPEUWTUWQUWNVU
        LWSZVVHVUPVWBUWQVVPETUMZUYIUWNUYJQRZUJSZTUMZHURUSZUWOVWDVWHUEZAUWMUWOUW
        NUTUDVWIUYOVWIBUWNUTGBCVBZUYHVWDUYNVWHVWJUYGVVPETUYFUWNUJVCVDVWJUYMVWGH
        URVWJUYLVWFUYITVWJUYKVWEUJUYFUWNUYJQVEVFVGVHVIMXSXTYAZUUAZUUBXKUWQVUHUX
        CUJSZUGSZUJSZUNQRZUXQVVGUWQVWOUNUWQVWNUWQVWNUWQVWMUWQUXCVVCVVDUUCZWEZWH
        WSZVVNWTVVOUWQUXCUTUDUXCYBUUHVUHVWPTUMVVCVVDUXCUUDUUEUWQVWOUXPUNVWSVVMV
        VNUWQVWOUXPTUMUXPUUFZVWNTUMVWNUXPTUMZUWQVWTPUXOUFRZUGSZVWNTUWQVXCPUGSZU
        XPUIRZVWTUWQPYCUDZUXOYCUDVXCVXEYDYEVVLPUXOUUGUUIVXEYBUXPUIRVWTVXDYBUXPU
        IUUJUUKUXPUULUUMUUSUWQVXBVWMTUMVXCVWNTUMUWQPUXIUFRZUWLUFRUWNUWLQRZUJSZU
        WLUFRZVXBVWMTUWQVXGVXIUWLUWQUXIVVJYIZUWQVXHUWQUWNUWLVULVUSWOZWSZVUNUWQV
        XGUYIVXIVXKUWQEUYEYIVXMUWQEUXIPUWQEUYEWCVVKVWAYBPTUMUWQUUNWNUWQEVVHXJUU
        OUWQUWLURUDVWHUYIVXITUMZUWQUWLVUMUUPUWQVWDVWHVWKUUQVWGVXNHUWLURHJVBZVWF
        VXIUYITVXOVWEVXHUJUYJUWLUWNQYFVFVGUURUUTYGUVAUWQUXIUWLUWQUXIVVJWJVUSUWQ
        UXIVVJWKVUTUVBUWQVWMVXHUWLUFRZUJSVXIUWLUJSZUFRVXJUWQUXCVXPUJUWQVXPUXBUW
        LUWLUFRZQRUXCUWQUWNUWLUWLVULVUSVUSVUTUVCUWQVXRPUXBQUWQUWLVUSVUTUVDXPYHV
        FUWQVXHUWLVXLVUSVUTYJUWQVXQUWLVXIUFUWQUWLVVTUWQUWLVUNYKXOZXPUVEYLUWQVXB
        VWMUWQUXOVVLUVFVWQYMXQXKUWQVWMUXOTUMVXAUWQVWMUXIUXOUWQUXCVVCWSZUWQEPVVH
        VWAWTZUWQUXOVVLXHUWQVWMUXBUJSZPQRZUXIVXTUWQVYBPUWQUXBVVAWSZVWAWTVYAUWQV
        WMVYBPUJSZQRVYCTUWQUXBPVVAVVBUVHVYEPVYBQUVIUVJUVGUWQVYBEPVYDVVHVWAUWQVV
        PUWLUFRZEPUFRVYBETUWQVVPEPUWLVWCVVHVXFUWQYEWNVVTUWQUWNVULUVKVWLUWQUWLVU
        MUVLZUVMUWQVYBVVPVXQUFRVYFUWQUWNUWLVULVUSVUTYJUWQVXQUWLVVPUFVXSXPYHUWQE
        UWQEUYEWJUVNYLYNYGUWQUXIUWLVYAVVTUWQUXIVVKYKVYGUVOYGUWQVWMUXOVWQVVLYMXQ
        UWQVWNUXPVWRVVMUVQUVPYNYGUVRYGUQUVSUWQUYAUXEUJUWQUYAUWNDGDUBZUWTUHRZVYH
        UWLUFRZPQRZUGSZUIRZYRZSZUXEUWQUWNUXTVYNUWMUXTVYNYDAUWOIUWLDGVYHIUBZPQRZ
        VYPUFRZUGSZUHRZVYHVYPUFRZPQRZUGSZUIRZYRVYNUCKIJVBZDGWUDVYMWUEVYTVYIWUCV
        YLUIWUEVYSUWTVYHUHWUEVYRUWSUGWUEVYQUWRVYPUWLUFVYPUWLPQVEWUEUVTYOVFZXPWU
        EWUBVYKUGWUEWUAVYJPQVYPUWLVYHUFYFYPVFYOUWANDGVYMGUYPUWBMUYOBUTUWCUWDUWE
        UWFYSYQUWGUWOVYOUXEYDAUWMDUWNVYMUXEGVYNDCVBZVYIUXAVYLUXDUIVYHUWNUWTUHVE
        WUGVYKUXCUGWUGVYJUXBPQVYHUWNUWLUFVEYPVFYOVYNUWHUXAUXDUIYTYSYAXRVFUWMUYB
        UXSYDAUWOIUWLUXGVYPTUMZEUXJVYPUKULRZUFRZUHRZEVYSUHRZUXIVYPUHRZUGSZUNQRZ
        QRZUOUXSUCFWUEWUHUXHWUKWUPUXMUXRVYPUWLUXGTUPWUEWUJUXLEUHWUEWUIUXKUXJUFV
        YPUWLUKULVEXPXPWUEWULUXNWUOUXQQWUEVYSUWTEUHWUFXPWUEWUNUXPUNQWUEWUMUXOUG
        VYPUWLUXIUHYFVFYPYOUWIOUXHUXMUXREUXLUHYTUXNUXQQYTUWJYSYQUWK $.

      $d m ph $.
      $( The series ` G ` is uniformly convergent on the compact region ` U ` ,
         which describes a circle of radius ` R ` with holes of size ` 1 / R `
         around the poles of the gamma function.  (Contributed by Mario
         Carneiro, 9-Jul-2017.) $)
      lgamgulmlem6 $p |- ( ph -> ( seq 1 ( oF + , G ) e. dom ( ~~>u ` U ) /\
        ( seq 1 ( oF + , G ) ( ~~>u ` U ) ( z e. U |-> O ) ->
          E. r e. RR A. z e. U ( abs ` O ) <_ r ) ) ) $=
        ( c1 cfv wcel cr co vy vn caddc cof cseq culm cdm cmpt wbr cabs cv wral
        cle wrex wi cvv cn nnuz cz 1z a1i cdiv cn0 wa cc crab cnex eqeltri clog
        rabex cmul cmin cmap wf cdif lgamgulmlem1 ad2antrr simpr sseldd eldifad
        wss simplr peano2nnd nnrpd rpdivcld relogcld recnd mulcld nnne0d divcld
        nncnd ax-1cn addcld dmgmdivn0 logcld subcld eqid fmptd elmap sylibr cpi
        cexp cif nnex mptex adantr nnred 2re readdcld remulcld nnsqcld nndivred
        c2 rpmulcld pire ifcl syl2anc ffvelrnda lgamgulmlem5 lgamgulmlem4 mtest
        1re adantlr cli mtestbdd nfcv nffvmpt1 nffv nfv weq fveq2 fveq2d breq1d
        nfbr cbvral wb ulmcl adantl fmpt fvmpt2 ralbi 3syl syl5bb rexbidv mpbid
        ralimiaa ex jca ) AUCUDIPUEZFUFQZUGRUUICFJUHZUUJUIZJUJQZKUKZUMUIZCFULZK
        SUNZUOAUAFUBIEPUPUPUQURPUSRZAUTVAFUPRZAFBUKZUJQDUMUIPDVBTUUTGUKUCTUJQUM
        UIGVCULVDZBVEVFUPMUVABVEVGVJVHZVAAHUQCFCUKZHUKZPUCTZUVDVBTZVIQZVKTZUVCU
        VDVBTZPUCTZVIQZVLTZUHZVEFVMTZIAUVDUQRZVDZFVEUVMVNUVMUVNRUVPCFUVLVEUVMUV
        PUVCFRZVDZUVHUVKUVRUVCUVGUVRUVCVEUSUQVOZUVRFVEUVSVOZUVCAFUVTWAUVOUVQABD
        FGLMVPVQUVPUVQVRVSZVTZUVRUVGUVRUVFUVRUVEUVDUVRUVEUVRUVDAUVOUVQWBZWCWDUV
        RUVDUWCWDWEWFWGWHUVRUVJUVRUVIPUVRUVCUVDUWBUVRUVDUWCWKUVRUVDUWCWIWJPVERU
        VRWLVAWMUVRUVCUVDUWAUWCWNWOWPUVMWQWRVEFUVMVGUVBWSWTNWRZEUPRZAEHUQXMDVKT
        UVDUMUIZDXMDPUCTZVKTZUVDXMXBTZVBTZVKTZDUVGVKTZUWGUVDVKTZVIQZXAUCTZUCTZX
        CZUHUPOHUQUWQXDXEVHZVAAUQSUBUKZEAHUQUWQSEUVPUWKSRUWPSRUWQSRUVPDUWJUVPDA
        DUQRUVOLXFZXGZUVPUWHUWIUVPXMUWGXMSRUVPXHVAUVPDPUXAPSRUVPYBVAXIXJUVPUVDA
        UVOVRZXKXLXJUVPUWLUWOUVPDUVGUXAUVPUVFUVPUVEUVDUVPUVEUVPUVDUXBWCWDUVPUVD
        UXBWDZWEWFXJUVPUWNXAUVPUWMUVPUWGUVDUVPUWGUVPDUWTWCWDUXCXNWFXASRUVPXOVAX
        IXIUWFUWKUWPSXPXQOWRXRZABUACDEFGHUBILMNOXSZABCDEFGHILMNOXTZYAAUULUUQAUU
        LVDZUAUKZUUKQZUJQZUUNUMUIZUAFULZKSUNUUQUXGKUAFUUKUBIEPUPUPUQURUURUXGUTV
        AUUSUXGUVBVAAUQUVNIVNUULUWDXFUWEUXGUWRVAAUWSUQRZUWSEQZSRUULUXDYCAUXMUXH
        FRVDUXHUWSIQQUJQUXNUMUIUULUXEYCAUCEPUEYDUGRUULUXFXFAUULVRYEUXGUXLUUPKSU
        XLUVCUUKQZUJQZUUNUMUIZCFULZUXGUUPUXKUXQUACFCUXJUUNUMCUXIUJCUJYFCFJUXHYG
        YHCUMYFCUUNYFYNUXQUAYIUACYJZUXJUXPUUNUMUXSUXIUXOUJUXHUVCUUKYKYLYMYOUXGJ
        VERZCFULZUXQUUOYPZCFULUXRUUPYPUXGFVEUUKVNZUYAUULUYCAFUUIUUKYQYRCFVEJUUK
        UUKWQZYSWTUXTUYBCFUVQUXTVDZUXPUUMUUNUMUYEUXOJUJCFJVEUUKUYDYTYLYMUUFUXQU
        UOCFUUAUUBUUCUUDUUEUUGUUH $.
    $}

    $( The series ` G ` is uniformly convergent on the compact region ` U ` ,
       which describes a circle of radius ` R ` with holes of size ` 1 / R `
       around the poles of the gamma function.  (Contributed by Mario Carneiro,
       3-Jul-2017.) $)
    lgamgulm $p |- ( ph -> seq 1 ( oF + , G ) e. dom ( ~~>u ` U ) ) $=
      ( vr caddc c1 cfv cmpt wbr c2 cmul co cof cseq culm cdm wcel cabs cv wral
      cle cr wrex wi cn cexp cdiv clog cpi cif eqid lgamgulmlem6 simpld ) AMUAH
      NUBZEUCOZUDUEVBCENPVCQNUFOLUGUIQCEUHLUJUKULABCDGUMRDSTGUGZUIQDRDNMTZSTVDR
      UNTUOTSTDVDNMTVDUOTUPOSTVEVDSTUPOUQMTMTURPZEFGHNLIJKVFUSUTVA $.

    $( Rewrite the limit of the sequence ` G ` in terms of the log-Gamma
       function.  (Contributed by Mario Carneiro, 6-Jul-2017.) $)
    lgamgulm2 $p |- ( ph -> ( A. z e. U ( log_G ` z ) e. CC /\
      seq 1 ( oF + , G ) ( ~~>u ` U )
        ( z e. U |-> ( ( log_G ` z ) + ( log ` z ) ) ) ) ) $=
      ( cfv cc wcel caddc c1 clog co cn cvv vn cv clgam wral cof cseq cmpt culm
      wbr wa cdiv cmul cmin csu cz cdif wceq lgamgulmlem1 sselda df-lgam fvmpt2
      ovex sylancl nnuz 1z a1i oveq1 id oveq12d fveq2d oveq2d oveq2 oveq1d eqid
      fvmpt adantl eldifad adantr simpr peano2nnd nnrpd rpdivcld relogcld recnd
      mulcld nncnd nnne0d divcld ax-1cn addcld dmgmdivn0 logcld subcld cmap wfn
      cuz seqfn ax-mp fneq2i mpbir cdm lgamgulm ulmdm sylib ulmf2 sylancr seqex
      wf seqeq3d fveq1d cabs cle cn0 crab rabex eqeltri syl6eleq cfz wss elfznn
      cnex ssriv seqof2 adantlr eqtrd fvex isumclim ulmcl syl ffvelrnda eqeltrd
      ulmclm dmgmn0 ralrimiva ffn 3syl nfcv nfmpt1 nfmpt nfcxfr nfseq mpteq2dva
      nffv dffn5f npcand 3eqtrrd breqtrd jca ) ACUBZUCLZMNZCEUDOUEZHPUFZCEUUJUU
      IQLZORZUGZEUHLZUIAUUKCEAUUIENZUJZUUJSUUIUAUBZPORZUUTUKRZQLZULRZUUIUUTUKRZ
      PORZQLZUMRZUAUNZUUNUMRZMUUSUUIMUOSUPZUPZNZUVJTNUUJUVJUQAEUVLUUIABDEFIJURU
      SZUVIUUNUMVBCUVLUVJTUCCUAUTVAVCZUUSUVIUUNUUSUVIUUIUUMUUQLZLZMUUSUVHUVQUAG
      SUUIGUBZPORZUVRUKRZQLZULRZUUIUVRUKRZPORZQLZUMRZUGZPSVDPUONZUUSVEVFZUUTSNZ
      UUTUWGLUVHUQUUSGUUTUWFUVHSUWGUVRUUTUQZUWBUVDUWEUVGUMUWKUWAUVCUUIULUWKUVTU
      VBQUWKUVSUVAUVRUUTUKUVRUUTPOVGUWKVHVIVJVKUWKUWDUVFQUWKUWCUVEPOUVRUUTUUIUK
      VLVMVJVIUWGVNUVDUVGUMVBVOVPUUSUWJUJZUVDUVGUWLUUIUVCUUSUUIMNUWJUUSUUIMUVKU
      VNVQZVRZUWLUVCUWLUVBUWLUVAUUTUWLUVAUWLUUTUUSUWJVSZVTWAUWLUUTUWOWAWBWCWDWE
      UWLUVFUWLUVEPUWLUUIUUTUWNUWLUUTUWOWFUWLUUTUWOWGWHPMNUWLWIVFWJUWLUUIUUTUUS
      UVMUWJUVNVRUWOWKWLWMUUSUUIEUAUUMUVPOUWGPUFZPTSVDUWIASMEWNRUUMXHZUURAUUMSW
      OZUUMUVPUUQUIZUWQUWRUUMPWPLZWOZUWHUXAVEUULHPWQWRSUWTUUMVDWSWTAUUMUUQXANUW
      SABCDEFGHIJKXBEUUMXCXDZEUUMUVPSXEXFVRAUURVSZUWPTNUUSOUWGPXGVFUWLUUIUUTUUM
      LZLUUICEUUTUWPLZUGZLZUXEUWLUUIUXDUXFUWLUXDUUTUULGSCEUWFUGZUGZPUFZLZUXFUWL
      UUTUUMUXJUWLHUXIUULPHUXIUQUWLKVFXIXJAUWJUXKUXFUQUURAUWJUJZGCESOPUUTTTUWFE
      TNUXLEBUBZXKLDXLUIPDUKRUXMFUBORXKLXLUIFXMUDUJZBMXNTJUXNBMYAXOXPVFUXLUUTSU
      WTAUWJVSVDXQPUUTXRRZSXSUXLGUXOSUVRUUTXTYBVFUWFTNUXLUVRSNUURUJUJUWBUWEUMVB
      VFYCYDYEXJUWLUURUXETNUXGUXEUQUUSUURUWJUXCVRUUTUWPYFCEUXETUXFUXFVNVAVCYEAU
      WSUURUXBVRYLYGZAEMUUIUVPAUWSEMUVPXHZUXBEUUMUVPYHZYIYJYKZUUSUUIUWMUUSUUIUV
      NYMWLZWMYKYNAUUMUVPUUPUUQUXBAUVPCEUVQUGZUUPAUVPEWOZUVPUYAUQAUWSUXQUYBUXBU
      XREMUVPYOYPCEUVPCUUMUUQCUUQYQCUULHPCPYQCUULYQCHUXIKCGSUXHCSYQCEUWFYRYSYTU
      UAUUCUUDXDACEUVQUUOUUSUUOUVJUUNORUVIUVQUUSUUJUVJUUNOUVOVMUUSUVIUUNUXSUXTU
      UEUXPUUFUUBYEUUGUUH $.

    $( The log-Gamma function is bounded on the region ` U ` .  (Contributed by
       Mario Carneiro, 9-Jul-2017.) $)
    lgambdd $p |- ( ph ->
      E. r e. RR A. z e. U ( abs ` ( log_G ` z ) ) <_ r ) $=
      ( cfv caddc co cabs cle wbr cr wcel vy clgam clog wral wrex cof cseq cmpt
      cv c1 culm cc lgamgulm2 simprd cdm wi cmul cexp cdiv cpi cif lgamgulmlem6
      cn c2 eqid mpd crp nnrpd adantr relogcld pire a1i readdcld adantrr simpld
      wa simpr r19.21bi abscld cz wss lgamgulmlem1 sselda eldifad dmgmn0 logcld
      cdif addcld ad2antrr cmin cneg negcld abs2difd absnegd subnegd lesubadd2d
      oveq2d fveq2d 3brtr3d mpbid absrpcld recnd cc0 wne abslogle wceq relogdiv
      syl2anc 1rp sylancr df-neg log1 oveq1i eqtr4i syl6reqr fveq2 breq1d oveq1
      cn0 0nn0 breq2d ralbidv anbi12d elrab2 simprbi adantl oveq2 rspcv addid1d
      mpsyl breqtrd rpreccld logled eqbrtrd mpbir2and leadd1dd simpllr leadd2dd
      absled letrd ex ralimdva impr breq2 rspcev rexlimddv ) ACUIZUBMZUUGUCMZNO
      ZPMZUAUIZQRZCEUDZUUHPMZIUIZQRZCEUDZISUEZUASANUFHUJUGZCEUUJUHEUKMZRZUUNUAS
      UEZAUUHULTZCEUDZUVBABCDEFGHJKLUMZUNAUUTUVAUOTUVBUVCUPABCDGVCVDDUQOGUIZQRD
      VDDUJNOZUQOUVGVDUROUSOUQODUVGUJNOUVGUSOUCMUQOUVHUVGUQOUCMUTNONOVAUHZEFGHU
      UJUAJKLUVIVEVBUNVFAUULSTZUUNVPVPDUCMZUTNOZUULNOZSTZUUOUVMQRZCEUDZUUSAUVJU
      VNUUNAUVJVPZUVLUULUVQUVKUTUVQDADVGTZUVJADJVHVIZVJUTSTZUVQVKVLVMAUVJVQVMZV
      NAUVJUUNUVPUVQUUMUVOCEUVQUUGETZVPZUUMUVOUWCUUMVPZUUOUVLUUKNOZUVMUWCUUOSTU
      UMUWCUUHUVQUVDCEAUVEUVJAUVEUVBUVFVOVIVRZVSZVIUWCUWESTUUMUWCUVLUUKUWCUVKUT
      UWCDUVQUVRUWBUVSVIZVJZUVTUWCVKVLZVMZUWCUUJUWCUUHUUIUWFUWCUUGUWCUUGULVTVCW
      GZUVQEULUWLWGZUUGAEUWMWAUVJABDEFJKWBVIWCZWDZUWCUUGUWNWEZWFZWHVSZVMZVIUVQU
      VNUWBUUMUWAWIUWCUUOUWEQRUUMUWCUUOUUIPMZUUKNOZUWEUWGUWCUWTUUKUWCUUIUWQVSZU
      WRVMUWSUWCUUOUWTWJOZUUKQRUUOUXAQRUWCUUOUUIWKZPMZWJOUUHUXDWJOZPMUXCUUKQUWC
      UUHUXDUWFUWCUUIUWQWLWMUWCUXEUWTUUOWJUWCUUIUWQWNWQUWCUXFUUJPUWCUUHUUIUWFUW
      QWOWRWSUWCUUOUWTUUKUWGUXBUWRWPWTUWCUWTUVLUUKUXBUWKUWRUWCUWTUUGPMZUCMZPMZU
      TNOZUVLUXBUWCUXIUTUWCUXHUWCUXHUWCUXGUWCUUGUWOUWPXAZVJZXBVSZUWJVMUWKUWCUUG
      ULTZUUGXCXDUWTUXJQRUWOUWPUUGXEXHUWCUXIUVKUTUXMUWIUWJUWCUXIUVKQRUVKWKZUXHQ
      RUXHUVKQRZUWCUXOUJDUSOZUCMZUXHQUWCUXRUJUCMZUVKWJOZUXOUWCUJVGTUVRUXRUXTXFX
      IUWHUJDXGXJUXOXCUVKWJOUXTUVKXKUXSXCUVKWJXLXMXNXOUWCUXQUXGQRUXRUXHQRUWCUXQ
      UUGXCNOZPMZUXGQXCXSTUWCUXQUUGFUIZNOZPMZQRZFXSUDZUXQUYBQRZXTUWCUXGDQRZUYGU
      WBUYIUYGVPZUVQUWBUXNUYJBUIZPMZDQRZUXQUYKUYCNOZPMZQRZFXSUDZVPUYJBUUGULEUYK
      UUGXFZUYMUYIUYQUYGUYRUYLUXGDQUYKUUGPXPXQUYRUYPUYFFXSUYRUYOUYEUXQQUYRUYNUY
      DPUYKUUGUYCNXRWRYAYBYCKYDYEYFZUNUYFUYHFXCXSUYCXCXFZUYEUYBUXQQUYTUYDUYAPUY
      CXCUUGNYGWRYAYHYJUWCUYAUUGPUWCUUGUWOYIWRYKUWCUXQUXGUWCDUWHYLUXKYMWTYNUWCU
      YIUXPUWCUYIUYGUYSVOUWCUXGDUXKUWHYMWTUWCUXHUVKUXLUWIYSYOYPYTYPYTVIUWDUUKUU
      LUVLUWCUUKSTUUMUWRVIAUVJUWBUUMYQUWCUVLSTUUMUWKVIUWCUUMVQYRYTUUAUUBUUCUURU
      VPIUVMSUUPUVMXFUUQUVOCEUUPUVMUUOQUUDYBUUEXHUUF $.
  $}

  ${
    $d a k m n r t x z A $.  $d n r z G $.  $d a J $.  $d a k m n r t x z ph $.
    $d a m n t z U $.
    lgamucov.u $e |- U = { x e. CC | ( ( abs ` x ) <_ r /\
      A. k e. NN0 ( 1 / r ) <_ ( abs ` ( x + k ) ) ) } $.
    lgamucov.a $e |- ( ph -> A e. ( CC \ ( ZZ \ NN ) ) ) $.
    ${
      lgamucov.j $e |- J = ( TopOpen ` CCfld ) $.
      $( The ` U ` regions used in the proof of ~ lgamgulm have interiors which
         cover the entire domain of the Gamma function.  (Contributed by Mario
         Carneiro, 6-Jul-2017.) $)
      lgamucov $p |- ( ph -> E. r e. NN A e. ( ( int ` J ) ` U ) ) $=
        ( cabs cfv co cc wcel a1i c2 clt wbr adantr va cv cmin ccom cbl cz cdif
        cn wss cnt wrex crp cxmt cnxmet ccld sszcld cnfldtopon toponunii cldopn
        difss mp2b cnfldtopn mopni2 syl3anc wa caddc cdiv eldifad abscld simprl
        cr rpred readdcld 2re rerpdivcld arch syl ctop cnfldtop cle c1 cn0 wral
        crab ssrab2 eqsstri ad2antrr rphalfcld rpxrd blopn simplr simp-4r nnred
        ad4antr resubcld rehalfcld abs2difd wceq eqid cnmetdval syl2anc abssubd
        cxr subcld eqtrd simpr eqbrtrrd lelttrd rphalflt lttrd ltsubadd2d mpbid
        rpdivcld ltaddrpd simpllr nnrecred nn0cnd addcld ad5antr ad6antr dmgmn0
        2rp ltled absrpcld rpaddcld ltaddrp2d nnrpd ltrecd 2cn rpcnd cc0 rpne0d
        wne 2ne0 recdivd cneg wn wb syl22anc ex breqtrd simprbi negnegd eqeltrd
        eldmgm nsyl3 ad3antrrr negcld elbl2 subnegd fveq2d breq1d ltnled 3bitrd
        elbl3 mpbird blhalf sstrd sseld sylbird mt3d ltletrd ralrimiva ss2rabdv
        simprr jca blval 3sstr4d ssntr blcntr sseldd reximdva mpd rexlimddv ) A
        CUAUBZKUCUDZUELZMZNUFUHUGZUGZUIZCDFUJLLZOZGUHUKZUAULAUVPNUMLOZUVTFOZCUV
        TOZUWAUAULUKUWEAUNPUWFAUVSUFUIUVSFUOLOUWFUFUHUTUVSFJUPUVSFNNFFJUQURZUSV
        APIUAUVTUVPCFNFJVBZVCVDAUVOULOZUWAVEZVEZCKLZUVOVFMZQUVOVGMZVFMZGUBZRSZG
        UHUKZUWDUWLUWPVKOZUWSUWLUWNUWOUWLUWMUVOUWLCACNOZUWKACNUVSIVHTZVIZUWLUVO
        AUWJUWAVJZVLZVMZUWLQUVOQVKOUWLVNPUXDVOZVMZUWPGVPVQUWLUWRUWCGUHUWLUWQUHO
        ZVEZUWRUWCUXJUWRVEZCUVOQVGMZUVQMZUWBCUXKFVROZDNUIZUXMFOZUXMDUIUXMUWBUIU
        XNUXKFJVSPUXOUXKDBUBZKLZUWQVTSZWAUWQVGMZUXQEUBZVFMZKLZVTSZEWBWCZVEZBNWD
        ZNHUYFBNWEWFPUXKUWEUXAUXLXCOZUXPUWEUXKUNPZUWLUXAUXIUWRUXBWGZUXKUXLUXKUV
        OUWLUWJUXIUWRUXDWGZWHZWIZUVPCUXLFNUWIWJVDUXKCUXQUVPMZUXLRSZBNWDZUYGUXMD
        UXKUYOUYFBNUXKUXQNOZVEZUYOUYFUYRUYOVEZUXSUYEUYSUXRUWQUYSUXQUXKUYQUYOWKZ
        VIZUYSUWQUWLUXIUWRUYQUYOWLZWMZUYSUXRUWPUWQVUAUWLUWTUXIUWRUYQUYOUXHWNZVU
        CUYSUXRUWNUWPVUAUWLUWNVKOUXIUWRUYQUYOUXFWNZVUDUYSUXRUWMUCMZUVORSUXRUWNR
        SUYSVUFUXLUVOUYSUXRUWMVUAUWLUWMVKOUXIUWRUYQUYOUXCWNZWOZUYSUVOUWLUVOVKOZ
        UXIUWRUYQUYOUXEWNZWPZVUJUYSVUFUXQCUCMZKLZUXLVUHUYSVULUYSUXQCUYTUXKUXAUY
        QUYOUYJWGZXDVIVUKUYSUXQCUYTVUNWQUYSUYNVUMUXLRUYSUYNCUXQUCMKLZVUMUYSUXAU
        YQUYNVUOWRVUNUYTCUXQUVPUVPWSZWTXAUYSCUXQVUNUYTXBXEUYRUYOXFXGXHUYSUWJUXL
        UVORSUXKUWJUYQUYOUYKWGZUVOXIVQXJUYSUXRUWMUVOVUAVUGVUJXKXLUYSUWNUWOVUEUY
        SQUVOQULOUYSYBPVUQXMZXNXJUXJUWRUYQUYOXOXJYCUYSUYDEWBUYSUYAWBOZVEZUXTUYC
        VUTUWQUYSUXIVUSVUBTZXPZVUTUYBVUTUXQUYAUXKUYQUYOVUSXOZVUTUYAUYSVUSXFZXQZ
        XRVIZVUTUXTUXLUYCVVBUYSUXLVKOVUSVUKTZVVFVUTUXTWAUWOVGMZUXLRVUTUWOUWQRSU
        XTVVHRSVUTUWOUWPUWQUWLUWOVKOUXIUWRUYQUYOVUSUXGXSZUYSUWTVUSVUDTUYSUWQVKO
        VUSVUCTVUTUWOUWNVVIVUTUWMUVOVUTCUYSUXAVUSVUNTZVUTCAUWGUWKUXIUWRUYQUYOVU
        SIXTYAYDUYSUWJVUSVUQTZYEYFUXJUWRUYQUYOVUSWLXJVUTUWOUWQUYSUWOULOVUSVURTV
        UTUWQVVAYGYHXLVUTQUVOQNOVUTYIPVUTUVOVVKYJQYKYMVUTYNPVUTUVOVVKYLYOUUAVUT
        UXLUYCVTSZUYAYPZUVTOZVVNVVMYPZWBOZVUTVVNVVMNOZVVPYQVVMUUEUUBVUTVVOUYAWB
        VUTUYAVVEUUCVVDUUDUUFVUTVVLYQZVVMUXQUXLUVQMZOZVVNVUTVVTUXQVVMUVPMZUXLRS
        ZUYCUXLRSVVRVUTUWEUYHUYQVVQVVTVWBYRUWEVUTUNPZUXKUYHUYQUYOVUSUYMUUGZVVCV
        UTUYAVVEUUHZVVMUVPUXQUXLNUUIYSVUTVWAUYCUXLRVUTVWAUXQVVMUCMZKLZUYCVUTUYQ
        VVQVWAVWGWRVVCVWEUXQVVMUVPVUPWTXAVUTVWFUYBKVUTUXQUYAVVCVVEUUJUUKXEUULVU
        TUYCUXLVVFVVGUUMUUNVUTVVSUVTVVMVUTVVSUVRUVTVUTUWEUYQVUICVVSOZVVSUVRUIVW
        CVVCUYSVUIVUSVUJTVUTVWHUYOUYRUYOVUSWKVUTUWEUYHUYQUXAVWHUYOYRVWCVWDVVCVV
        JCUVPUXQUXLNUUOYSUUPUVOUVPNUXQCUUQYSUWLUWAUXIUWRUYQUYOVUSAUWJUWAUVEXSUU
        RUUSUUTUVAUVBYCUVCUVFYTUVDUXKUWEUXAUYHUXMUYPWRUYIUYJUYMBUVPCUXLNUVGVDDU
        YGWRUXKHPUVHDFUXMNUWHUVIYSUXKUWEUXAUXLULOCUXMOUYIUYJUYLUVPCUXLNUVJVDUVK
        YTUVLUVMUVN $.
    $}

    $( The ` U ` regions used in the proof of ~ lgamgulm have interiors which
       cover the entire domain of the Gamma function.  (Contributed by Mario
       Carneiro, 8-Jul-2017.) $)
    lgamucov2 $p |- ( ph -> E. r e. NN A e. U ) $=
      ( ccnfld cfv wcel cn wrex cc wss cv cabs cle wbr co cnt lgamucov cnfldtop
      ctopn eqid ctop c1 cdiv caddc wral wa ssrab2 eqsstri cnfldtopon toponunii
      cn0 crab ntrss2 mp2an sseli reximi syl ) ACDIUDJZUAJJZKZFLMCDKZFLMABCDEVC
      FGHVCUEZUBVEVFFLVDDCVCUFKDNOVDDOVCVGUCDBPZQJFPZRSUGVIUHTVHEPUITQJRSEUPUJU
      KZBNUQNGVJBNULUMDVCNNVCVCVGUNUOURUSUTVAVB $.

    lgamcvglem.g $e |- G = ( m e. NN |->
    ( ( A x. ( log ` ( ( m + 1 ) / m ) ) ) - ( log ` ( ( A / m ) + 1 ) ) ) ) $.
    $( Lemma for ~ lgamf and ~ lgamcvg .  (Contributed by Mario Carneiro,
       8-Jul-2017.) $)
    lgamcvglem $p |- ( ph -> ( ( log_G ` A ) e. CC /\
      seq 1 ( + , G ) ~~> ( ( log_G ` A ) + ( log ` A ) ) ) ) $=
      ( vz wcel cfv caddc c1 co wa cn cvv vt vn clgam cc cseq cli wbr lgamucov2
      clog cv wral simprr cof cdiv cmul cmin cmpt culm simprl cabs cle cn0 crab
      wceq fveq2 breq1d oveq1 fveq2d breq2d ralbidv anbi12d cbvrabv eqid simpld
      eqtri lgamgulm2 eleq1d rspcv sylc nnuz cz 1z a1i wfn cmap cuz seqfn ax-mp
      fneq2i mpbir simprd ulmf2 sylancr seqex cnex rabex eqeltri simpr syl6eleq
      wf cfz wss elfznn ssriv ovex seqof2 simplr oveq1d oveq12d syl6eqr seqeq3d
      mpteq2dva fveq1d simplrr fvex fvmptd ulmclm fvmpt syl breqtrd rexlimddv
      jca ) ACDMZCUCNZUDMZOGPUEZYDCUINZOQZUFUGZRHSABCDEHIJUHAHUJZSMZYCRRZYEYIYL
      YCLUJZUCNZUDMZLDUKZYEAYKYCULZYLYPOUMZFSLDYMFUJZPOQYSUNQUINZUOQZYMYSUNQZPO
      QZUINZUPQZUQUQZPUEZLDYNYMUINZOQZUQZDURNUGZYLUALYJDEFUUFAYKYCUSDBUJZUTNZYJ
      VAUGZPYJUNQZUULEUJZOQZUTNZVAUGZEVBUKZRZBUDVCZUAUJZUTNZYJVAUGZUUOUVCUUPOQZ
      UTNZVAUGZEVBUKZRZUAUDVCIUVAUVJBUAUDUULUVCVDZUUNUVEUUTUVIUVKUUMUVDYJVAUULU
      VCUTVEVFUVKUUSUVHEVBUVKUURUVGUUOVAUVKUUQUVFUTUULUVCUUPOVGVHVIVJVKVLVOUUFV
      MVPZVNYOYELCDYMCVDZYNYDUDYMCUCVEZVQVRVSYLYFCUUJNZYHUFYLCDUBUUGUUJYFPTSVTP
      WAMZYLWBWCYLUUGSWDZUUKSUDDWEQUUGWTUVQUUGPWFNZWDZUVPUVSWBYRUUFPWGWHSUVRUUG
      VTWIWJYLYPUUKUVLWKZDUUGUUJSWLWMYQYFTMYLOGPWNWCYLUBUJZSMZRZLCUWAOFSUUEUQZP
      UEZNUWAYFNZDUWAUUGNTUWCFLDSOPUWATTUUEDTMUWCDUVBTIUVABUDWOWPWQWCUWCUWASUVR
      YLUWBWRVTWSPUWAXAQZSXBUWCFUWGSYSUWAXCXDWCUUETMUWCYSSMZYMDMRRUUAUUDUPXEWCX
      FUWCUVMRZUWAUWEYFUWIUWDGOPUWIUWDFSCYTUOQZCYSUNQZPOQZUINZUPQZUQGUWIFSUUEUW
      NUWIUWHRZUUAUWJUUDUWMUPUWOYMCYTUOUWCUVMUWHXGZXHUWOUUCUWLUIUWOUUBUWKPOUWOY
      MCYSUNUWPXHXHVHXIXLKXJXKXMAYKYCUWBXNUWFTMUWCUWAYFXOWCXPUVTXQYLYCUVOYHVDYQ
      LCUUIYHDUUJUVMYNYDUUHYGOUVNYMCUIVEXIUUJVMYDYGOXEXRXSXTYBYA $.
  $}

  ${
    $d k n r x A $.
    $( The log-Gamma function is a complex function defined on the whole
       complex plane except for the negative integers.  (Contributed by Mario
       Carneiro, 8-Jul-2017.) $)
    lgamcl $p |- ( A e. ( CC \ ( ZZ \ NN ) ) -> ( log_G ` A ) e. CC ) $=
      ( vn vx vr vk cc cn cdif wcel cfv caddc cv c1 cdiv clog wbr cabs cle eqid
      co cz clgam cmul cmin cmpt cseq cli cn0 wral wa crab id lgamcvglem simpld
      ) AFUAGHHIZAUBJZFIKBGABLZMKTUQNTOJUCTAUQNTMKTOJUDTUEZMUFUPAOJKTUGPUOCACLZ
      QJDLZRPMUTNTUSELKTQJRPEUHUIUJCFUKZEBURDVASUOULURSUMUN $.

    $( The log-Gamma function is a complex function defined on the whole
       complex plane except for the negative integers.  (Contributed by Mario
       Carneiro, 6-Jul-2017.) $)
    lgamf $p |- log_G : ( CC \ ( ZZ \ NN ) ) --> CC $=
      ( vx vn cc cz cn cdif clgam wf wtru cv c1 caddc co cdiv clog cfv cmin cvv
      wcel a1i cmul csu wa ovex cmpt wceq df-lgam lgamcl adantl fmpt2d trud ) C
      DEFFZCGHIAAULEAJZBJZKLMUNNMOPUAMUMUNNMKLMOPQMBUBZUMOPZQMZCGRUQRSIUMULSZUC
      UOUPQUDTGAULUQUEUFIABUGTURUMGPCSIUMUHUIUJUK $.

    $( The Gamma function is a complex function defined on the whole complex
       plane except for the negative integers.  (Contributed by Mario Carneiro,
       6-Jul-2017.) $)
    gamf $p |- _G : ( CC \ ( ZZ \ NN ) ) --> CC $=
      ( cc cz cn cdif cgam wf clgam ccom eff lgamf fco mp2an df-gam feq1i mpbir
      ce ) ABCDDZAEFQAPGHZFZAAPFQAGFSIJQAAPGKLQAERMNO $.

    $( The exponential of the log-Gamma function is the Gamma function (by
       definition).  (Contributed by Mario Carneiro, 8-Jul-2017.) $)
    gamcl $p |- ( A e. ( CC \ ( ZZ \ NN ) ) -> ( _G ` A ) e. CC ) $=
      ( cc cz cn cdif cgam gamf ffvelrni ) BCDEEBAFGH $.

    $( The exponential of the log-Gamma function is the Gamma function (by
       definition).  (Contributed by Mario Carneiro, 8-Jul-2017.) $)
    eflgam $p |- ( A e. ( CC \ ( ZZ \ NN ) ) ->
      ( exp ` ( log_G ` A ) ) = ( _G ` A ) ) $=
      ( cc cz cn cdif wcel cgam ce clgam ccom df-gam fveq1i wf wceq lgamf fvco3
      cfv mpan syl5req ) ABCDEEZFZAGQAHIJZQZAIQHQZAGUBKLTBIMUAUCUDNOTBAHIPRS $.

    $( The Gamma function is never zero.  (Contributed by Mario Carneiro,
       9-Jul-2017.) $)
    gamne0 $p |- ( A e. ( CC \ ( ZZ \ NN ) ) -> ( _G ` A ) =/= 0 ) $=
      ( cc cz cn cdif wcel clgam cfv ce cgam cc0 eflgam wne lgamcl syl eqnetrrd
      efne0 ) ABCDEEFZAGHZIHZAJHKALRSBFTKMANSQOP $.

    $( Value of the inverse Gamma function.  (Contributed by Mario Carneiro,
       16-Jul-2017.) $)
    igamval $p |- ( A e. CC ->
      ( 1/_G ` A ) = if ( A e. ( ZZ \ NN ) , 0 , ( 1 / ( _G ` A ) ) ) ) $=
      ( vx cv cz cn cdif wcel cc0 c1 cgam cfv cdiv co cc cigam wceq eleq1 fveq2
      cif oveq2d ifbieq2d df-igam c0ex ovex ifex fvmpt ) BABCZDEFZGZHIUGJKZLMZS
      AUHGZHIAJKZLMZSNOUGAPZUIULUKUNHUGAUHQUOUJUMILUGAJRTUABUBULHUNUCIUMLUDUEUF
      $.

    $( Value of the inverse Gamma function on nonpositive integers.
       (Contributed by Mario Carneiro, 16-Jul-2017.) $)
    igamz $p |- ( A e. ( ZZ \ NN ) -> ( 1/_G ` A ) = 0 ) $=
      ( cz cn cdif wcel cigam cfv cc0 c1 cgam cdiv cif wceq eldifi zcnd igamval
      co cc syl iftrue eqtrd ) ABCDEZAFGZUBHIAJGKQZLZHUBAREUCUEMUBAABCNOAPSUBHU
      DTUA $.

    $( Value of the inverse Gamma function in terms of the Gamma function.
       (Contributed by Mario Carneiro, 16-Jul-2017.) $)
    igamgam $p |- ( A e. ( CC \ ( ZZ \ NN ) ) ->
      ( 1/_G ` A ) = ( 1 / ( _G ` A ) ) ) $=
      ( cc cz cn cdif wcel wn wa cigam cfv c1 cgam cdiv co wceq cc0 cif igamval
      eldif iffalse sylan9eq sylbi ) ABCDEZEFABFZAUCFZGZHAIJZKALJMNZOABUCSUDUFU
      GUEPUHQUHARUEPUHTUAUB $.

    $( Value of the inverse Gamma function in terms of the log-Gamma function.
       (Contributed by Mario Carneiro, 16-Jul-2017.) $)
    igamlgam $p |- ( A e. ( CC \ ( ZZ \ NN ) ) ->
      ( 1/_G ` A ) = ( exp ` -u ( log_G ` A ) ) ) $=
      ( cc cz cn cdif wcel c1 clgam cfv ce cdiv co cgam cneg eflgam oveq2d wceq
      cigam lgamcl efneg syl igamgam 3eqtr4rd ) ABCDEEFZGAHIZJIZKLZGAMIZKLUENJI
      ZARIUDUFUHGKAOPUDUEBFUIUGQASUETUAAUBUC $.

    $( Closure of the inverse Gamma function.  (Contributed by Mario Carneiro,
       16-Jul-2017.) $)
    igamf $p |- 1/_G : CC --> CC $=
      ( vx cc cv cz cn cdif wcel cc0 c1 cgam cfv cdiv cif cigam df-igam 0cn a1i
      co wa wn eldif gamcl gamne0 reccld sylbir ifclda fmpti ) ABBACZDEFZGZHIUH
      JKZLRZMNAOUHBGZUJHULBHBGUMUJSPQUMUJTSUHBUIFGZULBGUHBUIUAUNUKUHUBUHUCUDUEU
      FUG $.

    $( Closure of the inverse Gamma function.  (Contributed by Mario Carneiro,
       16-Jul-2017.) $)
    igamcl $p |- ( A e. CC -> ( 1/_G ` A ) e. CC ) $=
      ( cc wcel cigam cfv cz cn cdif cc0 c1 cgam cdiv co cif igamval wa 0cn a1i
      wn eldif gamcl gamne0 reccld sylbir ifclda eqeltrd ) ABCZADEAFGHZCZIJAKEZ
      LMZNBAOUGUIIUKBIBCUGUIPQRUGUISPABUHHCZUKBCABUHTULUJAUAAUBUCUDUEUF $.

    $( The Gamma function is the inverse of the inverse Gamma function.
       (Contributed by Mario Carneiro, 16-Jul-2017.) $)
    gamigam $p |- ( A e. ( CC \ ( ZZ \ NN ) ) ->
      ( _G ` A ) = ( 1 / ( 1/_G ` A ) ) ) $=
      ( cc cz cn cdif wcel c1 cigam cfv cdiv cgam igamgam oveq2d gamne0 recrecd
      co gamcl eqtr2d ) ABCDEEFZGAHIZJPGGAKIZJPZJPUASTUBGJALMSUAAQANOR $.
  $}

  ${
    $d k m n r x y A $.  $d k n y G $.  $d k m n r x y ph $.
    lgamcvg.g $e |- G = ( m e. NN |->
    ( ( A x. ( log ` ( ( m + 1 ) / m ) ) ) - ( log ` ( ( A / m ) + 1 ) ) ) ) $.
    lgamcvg.a $e |- ( ph -> A e. ( CC \ ( ZZ \ NN ) ) ) $.
    $( The series ` G ` converges to ` log_G ( A ) + log ( A ) ` .
       (Contributed by Mario Carneiro, 6-Jul-2017.) $)
    lgamcvg $p |- ( ph ->
      seq 1 ( + , G ) ~~> ( ( log_G ` A ) + ( log ` A ) ) ) $=
      ( vx vy vk clgam cfv cc wcel caddc c1 co wbr cv cabs cle cseq clog cli wa
      cdiv cn0 wral crab eqid lgamcvglem simprd ) ABJKZLMNDOUAULBUBKNPUCQAGBGRZ
      SKHRZTQOUNUEPUMIRNPSKTQIUFUGUDGLUHZICDHUOUIFEUJUK $.

    $( The series ` G ` converges to ` log_G ( A + 1 ) ` .  (Contributed by
       Mario Carneiro, 9-Jul-2017.) $)
    lgamcvg2 $p |- ( ph -> seq 1 ( + , G ) ~~> ( log_G ` ( A + 1 ) ) ) $=
      ( vk caddc c1 co cfv clog cmin cn cdiv wcel a1i cc0 cc wceq vn vr vx cseq
      clgam cli cv cmul cmpt cvv nnuz eqid cn0 1nn0 dmgmaddnn0 lgamcvg cabs clt
      cz 1z wbr cr cdif abscld syl wa cuz cres ccom nnzd ad2antrr ax-1cn addcld
      wi nncnd peano2nnd nnne0d divcld sylancl pncand fveq2d nnred nnrpd rpge0d
      absdivd absidd oveq2d eqtrd 3eqtrd adantr cle adantl syl2anc mpbid mpbird
      wb breqtrrd eqbrtrd crp 1rp mp1i sseldi wss resmpt recnd nnex mptex oveq2
      ovex fvmpt eqeltrd weq oveq1 absge0d eqtr4d oveq1d climres crn wf 3eqtr4d
      fvex logcld dmgmdivn0 breqtrd cfz elfznn oveq12d syl6eleq relogcld mulcld
      csu subcld fsumser fsumcl 3eqtr3d divdird eqtr3d dividd logdiv2 syl3anc
      seqex wrex eldifad arch cmnf cioc simprl ccncf logcn cbl dvlog2lem uztrn2
      ex ad2antrl imp cnmetdval simplrr eluzle nnleltp1 lttrd mulid1d ltdivmuld
      1re cxmt cxr cnxmet rpxr elbl3 syl22anc fmptd ssrdv divcnv simpr nndivred
      lep1d lediv2ad 3brtr4d climsqz2 climabs0 climaddc1 0p1e1 syl6breq ellogdm
      eqbrtrrd mpbir2an climcncf logdmss eqidd wf1o logf1o feqmptd fveq2 fmptco
      csn f1of cores 3syl fvres log1 syl6eq 3brtr3d rexlimddv climsubc2 subid1d
      frn dmgmn0 rpdivcld fzfid eqeltrrd nncand pncan2d subdird mulid2d subsubd
      id addcomd subsub2d wne nnnn0d dmgmaddn0 nnncan2d add32d addassd 3eqtr3rd
      sub4d relogdivd eqtr2d sumeq2dv fsumsub fsumtscop eqcomd climsub lgamcl
      div1d ) AHDIUDZBIHJZUEKZUYPLKZHJZUYRMJUYQUFAUYSUYRUAHCNUYPCUGZIHJZUYTOJZL
      KZUHJZUYPUYTOJZIHJZLKZMJZUIZIUDZCNUYRBVUAOJZIHJZLKZMJZUIZUYOIUJNUKIUSPAUT
      QZAUYPCVUIVUIULZABIFIUMPAUNQUOZUPUYOUJPAHDIUUAQAVUOUYRRMJUYRUFARUYRUACNVU
      MUIZVUOIUJNUKVUPABUQKZUBUGZURVAZVUSRUFVAZUBNAVUTVBPZVVBUBNUUBABABSUSNVCZF
      UUCZVDZVUTUBUUDVEAVVANPZVVBVFZVFZVUSVVAVGKZVHZRUFVAZVVCVVJLSUUERUUFJVCZVH
      ZCVVKVULUIZVIZIVVOKZVVLRUFVVJVVNSIVVOVVPVVAVVKVVKULVVJVVAAVVHVVBUUGZVJZVV
      OVVNSUUHJPVVJVVNVVNULZUUIQVVJCVVKVULVVNVVPVVJUYTVVKPZVFZIIUQMVIZUUJKJZVVN
      VULVWEVWEULUUKVWCVULVWEPZVULIVWDJZIURVAZVWCVWGVUTVUAOJZIURVWCVWGVULIMJZUQ
      KZVUKUQKZVWIVWCVULSPZISPZVWGVWKTVWCVUKIVWCBVUAABSPZVVIVWBVVFVKZVWCUYTIVWC
      UYTVVJVWBUYTNPZVVHVWBVWQVNAVVBVVHVWBVWQIUYTVVANUKUULUUMUUNZUUOZVOVWNVWCVL
      QZVMZVWCVUAVWCUYTVWSVPZVQZVRZVWTVMZVLVULIVWDVWDULUUPVSVWCVWJVUKUQVWCVUKIV
      XDVWTVTWAVWCVWLVUTVUAUQKZOJVWIVWCBVUAVWPVXAVXCWEVWCVXFVUAVUTOVWCVUAVWCVUA
      VXBWBZVWCVUAVWCVUAVXBWCZWDWFWGWHWIVWCVWIIURVAVUTVUAIUHJZURVAVWCVUTVUAVXIU
      RVWCVUTVVAVUAAVVDVVIVWBVVGVKZVWCVVAVVJVVHVWBVVSWJZWBVXGAVVHVVBVWBUUQVWCVV
      AUYTWKVAZVVAVUAURVAZVWBVXLVVJVVAUYTUURWLVWCVVHVWQVXLVXMWPVXKVWSVVAUYTUUSW
      MWNUUTVWCVUAVXAUVAWQVWCVUTIVUAVXJIVBPZVWCUVCQVXHUVBWOWRVWCVWDSUVDKPZIUVEP
      ZVWNVWMVWFVWHWPVXOVWCUVFQIWSPZVXPVWCWTIUVGXAVWTVXEVULVWDIISUVHUVIWOXBZVVP
      ULUVJZVVJCNVULUIZVVKVHZVVPIUFVVJVVKNXCZVYAVVPTVVJCVVKNVWRUVKZCNVVKVULXDVE
      VVJVYAIUFVAZVXTIUFVAZAVYEVVIAVXTRIHJIUFARIUACNVUKUIZVXTIUJNUKVUPAVYFRUFVA
      CNVWLUIZRUFVAARUACNVUTUYTOJZUIZVYGIUJNUKVUPAVUTSPVYIRUFVAAVUTVVGXEVUTCUVL
      VEVYGUJPACNVWLXFXGQZAUAUGZNPZVFZVYKVYIKZVUTVYKOJZVBVYLVYNVYOTACVYKVYHVYON
      VYIUYTVYKVUTOXHVYIULVUTVYKOXIXJWLZVYMVUTVYKVYMBAVWOVYLVVFWJZVDZAVYLUVMZUV
      NXKVYMVYKVYGKZBVYKIHJZOJZUQKZVBVYLVYTWUCTACVYKVWLWUCNVYGCUAXLZVUKWUBUQWUD
      VUAWUABOUYTVYKIHXMWGZWAVYGULWUBUQYAXJWLZVYMWUBVYMBWUAVYQVYMVYKIVYMVYKVYSV
      OVWNVYMVLQZVMZVYMWUAVYMVYKVYSVPZVQZVRZVDXKVYMWUCVYOVYTVYNWKVYMWUCVUTWUAOJ
      ZVYOWKVYMWUCVUTWUAUQKZOJWULVYMBWUAVYQWUHWUJWEVYMWUMWUAVUTOVYMWUAVYMWUAWUI
      WBVYMWUAVYMWUAWUIWCZWDWFWGWHVYMVYKWUAVUTVYMVYKVYSWCWUNVYRVYMBVYQXNVYMVYKV
      YMVYKVYSWBUVOUVPWRWUFVYPUVQVYMRWUCVYTWKVYMWUBWUKXNWUFWQUVRAUAVYFVYGIUJUJN
      UKVUPVYFUJPACNVUKXFXGQVYJVYMVYKVYFKZWUBSVYLWUOWUBTACVYKVUKWUBNVYFWUEVYFUL
      BWUAOXIXJWLZWUKXKZVYMVYTWUCWUOUQKWUFVYMWUOWUBUQWUPWAXOUVSWOVWNAVLQZVXTUJP
      ZACNVULXFXGZQWUQVYMVYKVXTKZWUBIHJZWUOIHJVYLWVAWVBTACVYKVULWVBNVXTWUDVUKWU
      BIHWUEXPZVXTULWUBIHXIXJWLVYMWUOWUBIHWUPXPXOUVTUWAUWBWJVVJVVAUSPZWUSVYDVYE
      WPVVTWUTIVXTVVAUJXQVSWOUWDIVVNPZVVJWVEVWNVXNVXQVNVLVXQVXNWTQIVVNVWAUWCUWE
      ZQUWFVVJLVVPVIZCVVKVUMUIZVVQVVLVVJCUCVVKSRUWNVCZVULUCUGZLKVUMVVPLVWCVVNWV
      IVULVVNVWAUWGVXRXBVVJVVPUWHVVJUCWVILXRZLWVIWVKLUWIWVIWVKLXSVVJUWJWVIWVKLU
      WOXAUWKWVJVULLUWLUWMVVJVVKVVNVVPXSVVPXRVVNXCVVQWVGTVXSVVKVVNVVPUXELVVPVVN
      UWPUWQVVJVYBVVLWVHTVYCCNVVKVUMXDVEXTVVJVVRILKZRWVEVVRWVLTVVJWVFIVVNLUWRXA
      UWSUWTUXAVVJWVDVUSUJPVVMVVCWPVVTCNVUMXFXGRVUSVVAUJXQVSWNUXBAUYPABIVVFWURV
      MAUYPVURUXFYBZVUOUJPACNVUNXFXGQVYMVYKVUSKZWVBLKZSVYLWVNWVOTACVYKVUMWVONVU
      SWUDVULWVBLWVCWAZVUSULWVBLYAXJWLZVYMWVBVYMWUBIWUKWUGVMVYMBWUAABSVVEVCZPZV
      YLFWJWUIYCYBZXKVYMVYKVUOKZUYRWVOMJZUYRWVNMJVYLWWAWWBTACVYKVUNWWBNVUOWUDVU
      MWVOUYRMWVPWGVUOULUYRWVOMXIXJWLZVYMWVNWVOUYRMWVQWGXOUXCAUYRWVMUXDYDVYMIVY
      KYEJZUYPGUGZIHJZWWEOJZLKZUHJZUYPWWEOJZIHJZLKZMJZGYKZVYKVUJKZSVYMWWMGVUIIV
      YKVYMWWEWWDPZVFZWWENPZWWEVUIKWWMTWWPWWRVYMWWEVYKYFWLZCWWEVUHWWMNVUICGXLZV
      UDWWIVUGWWLMWWTVUCWWHUYPUHWWTVUBWWGLWWTVUAWWFUYTWWEOUYTWWEIHXMWWTUXOYGWAZ
      WGWWTVUFWWKLWWTVUEWWJIHUYTWWEUYPOXHXPWAYGVUQWWIWWLMXIXJVEVYMVYKNIVGKZVYSU
      KYHZWWQWWIWWLWWQUYPWWHWWQBIAVWOVYLWWPVVFVKZVWNWWQVLQZVMZWWQWWHWWQWWGWWQWW
      FWWEWWQWWFWWQWWEWWSVPZWCZWWQWWEWWSWCZUXGYIXEZYJZWWQWWKWWQWWJIWWQUYPWWEWXF
      WWQWWEWWSVOZWWQWWEWWSVQZVRWXEVMWWQUYPWWEAUYPWVRPZVYLWWPVURVKWWSYCYBZYLZYM
      ZVYMWWDWWMGVYMIVYKUXHZWXPYNZUXIVYMWWAWWBSWWCVYMUYRWVOAUYRSPVYLWVMWJWVTYLX
      KVYMWWDBWWHUHJZBWWEOJZIHJZLKZMJZGYKZWWNWWBMJZVYKUYOKWWOWWAMJVYMWWNWWNWYEM
      JZMJWYEWYFVYMWWNWYEWXSVYMWWDWYDGWXRWWQWXTWYCWWQBWWHWXDWXJYJZWWQWYBWWQWYAI
      WWQBWWEWXDWXLWXMVRWXEVMWWQBWWEAWVSVYLWWPFVKZWWSYCYBZYLZYNUXJVYMWYGWWBWWNM
      VYMWWDWWMWYDMJZGYKWWDWYCBWWFOJZIHJZLKZMJZGYKZWYGWWBVYMWWDWYLWYPGWWQWYLWWI
      WXTMJZWWLWYCMJZMJWWHWYSMJZWYPWWQWWIWWLWXTWYCWXKWXOWYHWYJUYEWWQWYRWWHWYSMW
      WQUYPBMJZWWHUHJIWWHUHJWYRWWHWWQXUAIWWHUHWWQBIWXDWXEUXKXPWWQUYPBWWHWXFWXDW
      XJUXLWWQWWHWXJUXMYOXPWWQWYTWWHWWLMJZWYCHJWYCXUBHJZWYPWWQWWHWWLWYCWXJWXOWY
      JUXNWWQXUBWYCWWQWWHWWLWXJWXOYLWYJUXPWWQWYCWWLWWHMJZMJXUCWYPWWQWYCWWLWWHWY
      JWXOWXJUXQWWQXUDWYOWYCMWWQBWWFHJZLKZWWELKZMJZWWFLKZXUGMJZMJXUFXUIMJZXUDWY
      OWWQXUFXUIXUGWWQXUEWWQBWWFWXDWWQWWFWXGVOZVMZWWQWVSWWFUMPXUERUXRZWYIWWQWWF
      WXGUXSBWWFUXTWMZYBWWQXUIWWQWWFWXHYIXEWWQXUGWWQWWEWXIYIXEUYAWWQWWLXUHWWHXU
      JMWWQWWLXUEWWEOJZLKZXUHWWQWWKXUPLWWQUYPWWEHJZWWEOJWWJWWEWWEOJZHJXUPWWKWWQ
      UYPWWEWWEWXFWXLWXLWXMYPWWQXURXUEWWEOWWQBWWEHJIHJXURXUEWWQBWWEIWXDWXLWXEUY
      BWWQBWWEIWXDWXLWXEUYCYQXPWWQXUSIWWJHWWQWWEWXLWXMYRWGUYDWAWWQXUESPZXUNWWEW
      SPXUQXUHTXUMXUOWXIXUEWWEYSYTWHWWQWWFWWEWXHWXIUYFYGWWQWYOXUEWWFOJZLKZXUKWW
      QWYNXVALWWQXVAWYMWWFWWFOJZHJWYNWWQBWWFWWFWXDXULXULWWQWWFWXGVQZYPWWQXVCIWY
      MHWWQWWFXULXVDYRWGUYGWAWWQXUTXUNWWFWSPXVBXUKTXUMXUOWXHXUEWWFYSYTWHXTWGYQW
      IWIUYHVYMWWDWWMWYDGWXRWXPWYKUYIVYMWYQBIOJZIHJZLKZWVOMJWWBVYMBWVJOJZIHJZLK
      WYCWYOXVGGUCWVOIVYKUCGXLZXVIWYBLXVJXVHWYAIHWVJWWEBOXHXPWAWVJWWFTZXVIWYNLX
      VKXVHWYMIHWVJWWFBOXHXPWAWVJITZXVIXVFLXVLXVHXVEIHWVJIBOXHXPWAWVJWUATZXVIWV
      BLXVMXVHWUBIHWVJWUABOXHXPWAVYMVYKVYSVJVYMWUANWXBWUIUKYHVYMWVJIWUAYEJPZVFZ
      XVIXVOXVHIXVOBWVJAVWOVYLXVNVVFVKXVOWVJXVNWVJNPVYMWVJWUAYFWLZVOXVOWVJXVPVQ
      VRVWNXVOVLQVMXVOBWVJAWVSVYLXVNFVKXVPYCYBUYJVYMXVGUYRWVOMVYMXVFUYPLVYMXVEB
      IHVYMBVYQUYNXPWAXPWHYOWGYQVYMWYDGDIVYKWWQWWRWWEDKWYDTWWSCWWEBVUCUHJZBUYTO
      JZIHJZLKZMJWYDNDWWTXVQWXTXVTWYCMWWTVUCWWHBUHWXAWGWWTXVSWYBLWWTXVRWYAIHUYT
      WWEBOXHXPWAYGEWXTWYCMXIXJVEWXCWYKYMVYMWWNWWOWWBWWAMWXQVYMWWAWWBWWCUYKYGYO
      UYLAUYQUYRAWXNUYQSPVURUYPUYMVEWVMVTYD $.

    $( The pointwise exponential of the series ` G ` converges to
       ` _G ( A ) x. A ` .  (Contributed by Mario Carneiro, 6-Jul-2017.) $)
    gamcvg $p |- ( ph ->
      ( exp o. seq 1 ( + , G ) ) ~~> ( ( _G ` A ) x. A ) ) $=
      ( vn ce caddc c1 cfv clog co cmul cc cn nnuz wcel a1i wceq cseq ccom cgam
      clgam cli cz 1z ccncf efcn cv cdiv cmin wa eldifad adantr simpr peano2nnd
      nnrpd rpdivcld relogcld recnd mulcld nncnd nnne0d divcld ax-1cn dmgmdivn0
      cdif addcld logcld subcld fmptd ffvelrnda serf lgamcl syl dmgmn0 climcncf
      lgamcvg efadd syl2anc eflgam cc0 wne eflog oveq12d eqtrd breqtrd ) AHIDJU
      AZUBBUDKZBLKZIMZHKZBUCKZBNMZUEAOOWLHWIJPQJUFRAUGSZHOOUHMRAUISAGDJPQWPAPOG
      UJDACPBCUJZJIMZWQUKMZLKZNMZBWQUKMZJIMZLKZULMODAWQPRZUMZXAXDXFBWTABORZXEAB
      OUFPVHZFUNZUOZXFWTXFWSXFWRWQXFWRXFWQAXEUPZUQURXFWQXKURUSUTVAVBXFXCXFXBJXF
      BWQXJXFWQXKVCXFWQXKVDVEJORXFVFSVIXFBWQABOXHVHRZXEFUOXKVGVJVKEVLVMVNABCDEF
      VSAWJWKAXLWJORZFBVOVPZABXIABFVQZVJZVIVRAWMWJHKZWKHKZNMZWOAXMWKORWMXSTXNXP
      WJWKVTWAAXQWNXRBNAXLXQWNTFBWBVPAXGBWCWDXRBTXIXOBWEWAWFWGWH $.
  $}

  ${
    $d m A $.
    $( The functional equation of the (log) Gamma function.  (Contributed by
       Mario Carneiro, 9-Jul-2017.) $)
    lgamp1 $p |- ( A e. ( CC \ ( ZZ \ NN ) ) ->
      ( log_G ` ( A + 1 ) ) = ( ( log_G ` A ) + ( log ` A ) ) ) $=
      ( vm cc cz cn cdif wcel caddc cv c1 co cdiv clog cfv cmul cmin cmpt clgam
      cli wbr cseq wceq eqid id lgamcvg2 lgamcvg climuni syl2anc ) ACDEFFGZHBEA
      BIZJHKUJLKMNOKAUJLKJHKMNPKQZJUAZAJHKRNZSTULARNAMNHKZSTUMUNUBUIABUKUKUCZUI
      UDZUEUIABUKUOUPUFUMUNULUGUH $.

    $( The functional equation of the Gamma function.  (Contributed by Mario
       Carneiro, 9-Jul-2017.) $)
    gamp1 $p |- ( A e. ( CC \ ( ZZ \ NN ) ) ->
      ( _G ` ( A + 1 ) ) = ( ( _G ` A ) x. A ) ) $=
      ( cc cz cn cdif wcel c1 caddc clgam cfv cmul cgam clog lgamp1 fveq2d wceq
      co ce syl2anc eflgam lgamcl eldifi id dmgmn0 logcld cc0 wne oveq2d 3eqtrd
      efadd eflog cn0 1nn0 a1i dmgmaddnn0 syl oveq1d 3eqtr3d ) ABCDEZEZFZAGHQZI
      JZRJZAIJZRJZAKQZVBLJZALJZAKQVAVDVEAMJZHQZRJZVFVJRJZKQZVGVAVCVKRANOVAVEBFV
      JBFVLVNPAUAVAAABUSUBZVAAVAUCZUDZUEVEVJUJSVAVMAVFKVAABFAUFUGVMAPVOVQAUKSUH
      UIVAVBUTFVDVHPVAAGVPGULFVAUMUNUOVBTUPVAVFVIAKATUQUR $.
  $}

  ${
    $d m A $.  $d k n F $.  $d k n x G $.  $d k m n x ph $.
    gamcvg2.f $e |- F = ( m e. NN |->
      ( ( ( ( m + 1 ) / m ) ^c A ) / ( ( A / m ) + 1 ) ) ) $.
    gamcvg2.a $e |- ( ph -> A e. ( CC \ ( ZZ \ NN ) ) ) $.
    ${
      gamcvg2.g $e |- G = ( m e. NN |->
    ( ( A x. ( log ` ( ( m + 1 ) / m ) ) ) - ( log ` ( ( A / m ) + 1 ) ) ) ) $.
      $( Lemma for ~ gamcvg2 .  (Contributed by Mario Carneiro,
         10-Jul-2017.) $)
      gamcvg2lem $p |- ( ph ->
        ( exp o. seq 1 ( + , G ) ) = seq 1 ( x. , F ) ) $=
        ( vk cn caddc c1 cfv ce cmul wcel cc co cdiv wceq vn vx cv cseq cmpt wa
        ccom addcl adantl cfz simpll elfznn clog oveq1 id oveq12d fveq2d oveq2d
        cmin oveq2 oveq1d ovex fvmpt cz adantr eldifad simpr peano2nnd rpdivcld
        nnrpd relogcld recnd mulcld nncnd nnne0d divcld ax-1cn addcld dmgmdivn0
        cdif a1i logcld subcld eqeltrd syl2anc nnuz syl6eleq efadd ccxp divne0d
        cuz efsub cxpefd eqcomd cc0 eflog eqtrd 3eqtr4d seqhomo mpteq2dva wf 1z
        wne eff serf fcompt wfn seqfn mp1i fneq2i sylibr dffn5 sylib ) AIJIUCZK
        ELUDZMNMZUEZIJXNODLUDZMZUEZNXOUGZXRAIJXPXSAXNJPZUFZUAUBKOQEDNLXNUAUCZQP
        UBUCZQPUFZYDYEKRZQPYCYDYEUHUIYCYDLXNUJRPZUFZAYDJPZYDEMZQPAYBYHUKZYHYJYC
        YDXNULUIZAYJUFZYKBYDLKRZYDSRZUMMZORZBYDSRZLKRZUMMZUSRZQYJYKUUBTACYDBCUC
        ZLKRZUUCSRZUMMZORZBUUCSRZLKRZUMMZUSRUUBJEUUCYDTZUUGYRUUJUUAUSUUKUUFYQBO
        UUKUUEYPUMUUKUUDYOUUCYDSUUCYDLKUNUUKUOUPZUQURUUKUUIYTUMUUKUUHYSLKUUCYDB
        SUTVAZUQUPHYRUUAUSVBVCUIZYNYRUUAYNBYQYNBQVDJVTZABQUUOVTPYJGVEZVFZYNYQYN
        YPYNYOYDYNYOYNYDAYJVGZVHZVJYNYDUURVJVIVKVLVMZYNYTYNYSLYNBYDUUQYNYDUURVN
        ZYNYDUURVOZVPLQPYNVQWAZVRZYNBYDUUPUURVSZWBZWCWDZWEYCXNJLWKMZAYBVGWFWGYF
        YGNMYDNMYENMORTYCYDYEWHUIYIAYJYKNMZYDDMZTYLYMYNUUBNMZYPBWIRZYTSRZUVIUVJ
        YNUVKYRNMZUUANMZSRZUVMYNYRQPUUAQPUVKUVPTUUTUVFYRUUAWLWEYNUVNUVLUVOYTSYN
        UVLUVNYNYPBYNYOYDYNYDLUVAUVCVRZUVAUVBVPYNYOYDUVQUVAYNYOUUSVOUVBWJUUQWMW
        NYNYTQPYTWOXCUVOYTTUVDUVEYTWPWEUPWQYNYKUUBNUUNUQYJUVJUVMTACYDUUEBWIRZUU
        ISRUVMJDUUKUVRUVLUUIYTSUUKUUEYPBWIUULVAUUMUPFUVLYTSVBVCUIWRWEWSWTAQQNXA
        ZJQXOXAYAXQTUVSAXDWAAUAELJWFLVDPZAXBWAUVGXEINXOJQQXFWEAXRJXGZXRXTTAXRUV
        HXGZUWAUVTUWBAXBODLXHXIJUVHXRWFXJXKIJXRXLXMWR $.
    $}

    $( An infinite product expression for the gamma function.  (Contributed by
       Mario Carneiro, 9-Jul-2017.) $)
    gamcvg2 $p |- ( ph -> seq 1 ( x. , F ) ~~> ( ( _G ` A ) x. A ) ) $=
      ( ce caddc cn cv c1 co cdiv clog cfv cmul cmin cmpt cseq ccom cgam gamcvg
      cli eqid gamcvg2lem eqbrtrrd ) AGHCIBCJZKHLUGMLNOPLBUGMLKHLNOQLRZKSTPDKSB
      UAOBPLUCABCDUHEFUHUDZUEABCUHUIFUBUF $.
  $}

$(
  @{
    gamcnlem.r @e |- ( ph -> R e. NN ) @.
    gamcnlem.u @e |- U = { x e. CC | ( ( abs ` x ) <_ R /\
      A. m e. NN0 ( 1 / R ) <_ ( abs ` ( x + m ) ) ) } @.
    gamcnlem.f @e |- F = ( m e. NN |->
      ( ( ( ( m + 1 ) / m ) ^c z ) / ( ( z / m ) + 1 ) ) ) @.
    gamcnlem.g @e |- G = ( m e. NN |->
    ( ( z x. ( log ` ( ( m + 1 ) / m ) ) ) - ( log ` ( ( z / m ) + 1 ) ) ) ) @.
    @( The log-Gamma function is bounded on the region ` U `.
       (Contributed by Mario Carneiro, 9-Jul-2017.) @)
    gamcnlem @p |- ( ph -> ( _G |` U ) e. ( U -cn-> CC ) ) @=
      ? @.
  @}
$)

  ${
    $d m n x A $.
    $( The Gamma function is real for real input.  (Contributed by Mario
       Carneiro, 9-Jul-2017.) $)
    regamcl $p |- ( A e. ( RR \ ( ZZ \ NN ) ) -> ( _G ` A ) e. RR ) $=
      ( vn vm vx cr cz cn cdif wcel cmul co cdiv cc cv c1 caddc nnuz a1i nnrpd
      wa cgam cfv eldifi recnd eldifn eldifd syl dmgmn0 divcan4d ccxp cmpt cseq
      gamcl 1z gamcvg2 simpr peano2nnd rpdivcld rpge0d adantr recxpcld nndivred
      eqid rpred 1re readdcld dmgmdivn0 redivcld fmptd ffvelrnda remulcl adantl
      seqf climrecl eqeltrrd ) AEFGHZHIZAUAUBZAJKZALKVREVQVRAVQAMVPHIZVRMIVQAMV
      PVQAAEVPUCZUDZAEVPUEUFZAUMUGWBVQAWCUHZUIVQVSAVQVSBJCGCNZOPKZWELKZAUJKZAWE
      LKZOPKZLKZUKZOULZOGQOFIVQUNRZVQACWLWLVCZWCUOVQGEBNZWMVQBDJEWLOGQWNVQGEWPW
      LVQCGWKEWLVQWEGIZTZWHWJWRWGAWRWGWRWFWEWRWFWRWEVQWQUPZUQSWRWEWSSURZVDWRWGW
      TUSVQAEIWQWAUTZVAWRWIOWRAWEXAWSVBOEIWRVERVFWRAWEVQVTWQWCUTWSVGVHWOVIVJWPE
      IDNZEITWPXBJKEIVQWPXBVKVLVMVJVNWAWDVHVO $.

    $( The log-Gamma function is real for positive real input.  (Contributed by
       Mario Carneiro, 9-Jul-2017.) $)
    relgamcl $p |- ( A e. RR+ -> ( log_G ` A ) e. RR ) $=
      ( vn vm crp wcel cfv clog caddc co cmin cr cc cz cn cdif cv cdiv nnuz a1i
      c1 clgam rpdmgm lgamcl syl relogcl recnd pncand cmul cmpt cseq 1z lgamcvg
      simpl rpred simpr peano2nnd nnrpd rpdivcld relogcld remulcld 1rp rpaddcld
      eqid wa resubcld fmptd ffvelrnda serfre climrecl eqeltrrd ) ADEZAUAFZAGFZ
      HIZVMJIVLKVKVLVMVKALMNOOEVLLEAUBZAUCUDVKVMAUEZUFUGVKVNVMVKVNBHCNACPZTHIZV
      QQIZGFZUHIZAVQQIZTHIZGFZJIZUIZTUJZTNRTMEVKUKSZVKACWFWFVCZVOULVKNKBPZWGVKB
      WFTNRWHVKNKWJWFVKCNWEKWFVKVQNEZVDZWAWDWLAVTWLAVKWKUMZUNWLVSWLVRVQWLVRWLVQ
      VKWKUOZUPUQWLVQWNUQZURUSUTWLWCWLWBTWLAVQWMWOURTDEWLVASVBUSVEWIVFVGVHVGVIV
      PVEVJ $.

    $( The log-Gamma function is positive real for positive real input.
       (Contributed by Mario Carneiro, 9-Jul-2017.) $)
    rpgamcl $p |- ( A e. RR+ -> ( _G ` A ) e. RR+ ) $=
      ( crp wcel clgam cfv ce cgam cc cz cn cdif wceq rpdmgm eflgam syl rpefcld
      relgamcl eqeltrrd ) ABCZADEZFEZAGEZBSAHIJKKCUAUBLAMANOSTAQPR $.
  $}

  ${
    $( The log-Gamma function at one.  (Contributed by Mario Carneiro,
       9-Jul-2017.) $)
    lgam1 $p |- ( log_G ` 1 ) = 0 $=
      ( vm caddc c1 cfv cc0 cxp cli wbr clog co wtru cdiv cmin cmpt wcel ax-1cn
      cn cc a1i cz cuz csn cseq clgam wceq cv cmul peano2nn nnrpd nnrp rpdivcld
      relogcld recnd mulid2d nncn dividd oveq1d divdird reccld addcomd 3eqtr4rd
      nnne0 fveq2d oveq12d subidd eqtrd mpteq2ia fconstmpt nnuz xpeq1i 3eqtr2ri
      cdif wn 1nn eldifn eldif mpbir2an lgamcvg trud log1 oveq2i lgamcl addid1i
      mt2 ax-mp eqtri breqtri 1z serclim0 climuni mp2an ) BCUADZEUBZFZCUCZCUDDZ
      GHWOEGHZWPEUEWOWPCIDZBJZWPGWOWSGHKCAWNAQCAUFZCBJZWTLJZIDZUGJZCWTLJZCBJZID
      ZMJZNAQENQWMFWNAQXHEWTQOZXHXCXCMJEXIXDXCXGXCMXIXCXIXCXIXBXIXAWTXIXAWTUHUI
      WTUJUKULUMZUNXIXFXBIXIWTWTLJZXEBJCXEBJXBXFXIXKCXEBXIWTWTUOZWTVBZUPUQXIWTC
      WTXLCROZXIPSZXLXMURXIXECXIWTXLXMUSXOUTVAVCVDXIXCXJVEVFVGAQEVHQWLWMVIVJVKC
      RTQVLZVLOZKXQXNCXPOZVMPXRCQOVNCTQVOWDCRXPVPVQZSVRVSWSWPEBJWPWREWPBVTWAWPX
      QWPROXSCWBWEWCWFWGCTOWQWHCWIWEWPEWOWJWK $.

    $( The log-Gamma function at one.  (Contributed by Mario Carneiro,
       9-Jul-2017.) $)
    gam1 $p |- ( _G ` 1 ) = 1 $=
      ( c1 clgam cfv ce cc0 cgam lgam1 fveq2i cc cz cn cdif wcel wceq wn ax-1cn
      1nn eldifn mt2 eldif mpbir2an eflgam ax-mp ef0 3eqtr3i ) ABCZDCZEDCAFCZAU
      FEDGHAIJKLZLMZUGUHNUJAIMAUIMZOPUKAKMQAJKRSAIUITUAAUBUCUDUE $.
  $}

  ${
    $d n x $.  $d x N $.
    $( The Gamma function generalizes the factorial.  (Contributed by Mario
       Carneiro, 9-Jul-2017.) $)
    facgam $p |- ( N e. NN0 -> ( ! ` N ) = ( _G ` ( N + 1 ) ) ) $=
      ( vx vn cv cfa cfv c1 caddc co cgam cc0 fveq2 oveq1 syl6eq fveq2d eqeq12d
      wceq wcel cmul cn 0p1e1 gam1 fac0 cn0 facp1 cc cz cdif nncnd eldifn nsyl3
      nn0p1nn eldifd gamp1 syl syl5ibr nn0ind ) BDZEFZURGHIZJFZQKEFZGQCDZEFZVCG
      HIZJFZQZVEEFZVEGHIZJFZQZAEFZAGHIZJFZQBCAURKQZUSVBVAGURKELVOVAGJFGVOUTGJVO
      UTKGHIGURKGHMUANOUBNPURVCQZUSVDVAVFURVCELVPUTVEJURVCGHMOPURVEQZUSVHVAVJUR
      VEELVQUTVIJURVEGHMOPURAQZUSVLVAVNURAELVRUTVMJURAGHMOPUCVGVKVCUDRZVDVESIZV
      FVESIZQVDVFVESMVSVHVTVJWAVCUEVSVEUFUGTUHZUHRVJWAQVSVEUFWBVSVEVCULZUIVEWBR
      VETRVSVEUGTUJWCUKUMVEUNUOPUPUQ $.

    $( The Gamma function generalizes the factorial.  (Contributed by Mario
       Carneiro, 9-Jul-2017.) $)
    gamfac $p |- ( N e. NN -> ( _G ` N ) = ( ! ` ( N - 1 ) ) ) $=
      ( cn wcel c1 cmin co cfa cfv cgam cn0 wceq nnm1nn0 facgam syl nncn ax-1cn
      caddc cc a1i npcand fveq2d eqtr2d ) ABCZADEFZGHZUDDQFZIHZAIHUCUDJCUEUGKAL
      UDMNUCUFAIUCADAODRCUCPSTUAUB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Derangements and the Subfactorial
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g h m n s x y z A $.  $d b c f g x y F $.  $d c f g h k m n x y z N $.
    $d b k m n $.  $d b c f g h s x y z B $.  $d b c x y C $.  $d b c x y ph $.
    $d n D $.  $d c f n x y K $.  $d b f g x y M $.  $d m n x y S $.  $d f V $.
    $( Lemma for derangements.  (Contributed by Mario Carneiro,
       19-Jan-2015.) $)
    deranglem $p |- ( A e. Fin ->
      { f | ( f : A -1-1-onto-> A /\ ph ) } e. Fin ) $=
      ( cfn wcel cv wf1o wa cab cmap co wss mapfi wf f1of adantr elmapg syl5ibr
      abssdv ssfi syl2anc anidms ) BDEZBBCFZGZAHZCIZDEZUCUCHZBBJKZDEUGUJLUHBBMU
      IUFCUJUFUDUJEUIBBUDNZUEUKABBUDOPBBUDDDQRSUJUGTUAUB $.

    derang.d $e |- D = ( x e. Fin |-> ( # ` { f | ( f : x -1-1-onto-> x /\
      A. y e. x ( f ` y ) =/= y ) } ) ) $.
    $( Define the derangement function, which counts the number of bijections
       from a set to itself such that no element is mapped to itself.
       (Contributed by Mario Carneiro, 19-Jan-2015.) $)
    derangval $p |- ( A e. Fin -> ( D ` A ) =
      ( # ` { f | ( f : A -1-1-onto-> A /\ A. y e. A ( f ` y ) =/= y ) } ) ) $=
      ( cv wf1o cfv wne wral wa cab chash cfn wceq f1oeq2 f1oeq3 bitrd raleq
      anbi12d abbidv fveq2d fvex fvmpt ) ACAGZUFEGZHZBGZUGIUIJZBUFKZLZEMZNICCUG
      HZUJBCKZLZEMZNIODUFCPZUMUQNURULUPEURUHUNUKUOURUHCUFUGHUNUFCUFUGQUFCCUGRSU
      JBUFCTUAUBUCFUQNUDUE $.

    $( The derangement number is a function from finite sets to nonnegative
       integers.  (Contributed by Mario Carneiro, 19-Jan-2015.) $)
    derangf $p |- D : Fin --> NN0 $=
      ( cfn cn0 cv wf1o cfv wne wral cab chash wcel deranglem hashcl syl fmpti
      wa ) AFGAHZUADHZIBHZUBJUCKBUALZTDMZNJZCEUAFOUEFOUFGOUDUADPUEQRS $.

    $( The derangement number of the empty set.  (Contributed by Mario
       Carneiro, 19-Jan-2015.) $)
    derang0 $p |- ( D ` (/) ) = 1 $=
      ( c0 cfv cv wf1o wne wral wa cab chash csn c1 wcel wceq ax-mp cvv biantru
      cfn 0fin derangval ral0 eqid f1o00 mpbiran2 bitr3i abbii df-sn eqtr4i 0ex
      fveq2i hashsng 3eqtri ) FCGZFFDHZIZBHZURGUTJZBFKZLZDMZNGZFOZNGZPFUBQUQVER
      UCABFCDEUDSVDVFNVDURFRZDMVFVCVHDVCUSVHVBUSVABUEUAUSVHFFRFUFFURUGUHUIUJDFU
      KULUNFTQVGPRUMFTUOSUP $.

    $( The derangement number of a singleton.  (Contributed by Mario Carneiro,
       19-Jan-2015.) $)
    derangsn $p |- ( A e. V -> ( D ` { A } ) = 0 ) $=
      ( wcel csn cfv c0 chash cc0 cv wf1o wne wral wa wceq syl cab cfn snfi wss
      derangval ax-mp wf adantr snidg ffvelrn syl2anr wn simpr fveq2 id neeq12d
      f1of rspcva syl2an elsni necon3ai pm2.21dd abssdv ss0 fveq2d syl5eq hash0
      ex syl6eq ) CFHZCIZDJZKLJZMVJVLVKVKENZOZBNZVNJZVPPZBVKQZRZEUAZLJZVMVKUBHV
      LWBSCUCABVKDEGUEUFVJWAKLVJWAKUDWAKSVJVTEKVJVTVNKHZVJVTRZCVNJZVKHZWCVTVKVK
      VNUGZCVKHZWFVJVOWGVSVKVKVNUQUHCFUIZVKVKCVNUJUKWDWECPZWFULVJWHVSWJVTWIVOVS
      UMVRWJBCVKVPCSZVQWEVPCVPCVNUNWKUOUPURUSWFWECWECUTVATVBVHVCWAVDTVEVFVGVI
      $.

    $( One half of ~ derangen .  (Contributed by Mario Carneiro,
       22-Jan-2015.) $)
    derangenlem $p |- ( ( A ~~ B /\ B e. Fin ) -> ( D ` A ) <_ ( D ` B ) ) $=
      ( vs cfn wcel wa cv wf1o cfv wne wral ccom syl2anc wceq syl vg vh cen wbr
      vz cab chash cle cdom wex simpl bren sylib deranglem adantl wi ccnv f1oco
      ad2ant2lr f1ocnv ad2antlr coass fveq1i simprl f1of fvco3 syl5eq ffvelrnda
      wf sylan simplrr fveq2 neeq12d rspcv sylc eqnetrd necomd simpllr f1ocnvfv
      id necon3d mpd ralrimiva cbvralv jca ex vex f1oeq1 neeq1d ralbidv anbi12d
      fveq1 elab coex cnvex 3imtr4g anbi12i wfo wfn f1ofo adantrr f1ofn simprrl
      simplr cocan2 syl3anc wf1 f1of1 simprll cocan1 bitrd syl5bi dom2d exlimdv
      wb mp2d enfii ancoms hashdom mpbird derangval 3brtr4d ) CDUCUDZDIJZKZCCFL
      ZMZBLZYFNZYHOZBCPZKZFUFZUGNZDDYFMZYJBDPZKZFUFZUGNZCENZDENZUHYEYNYSUHUDZYM
      YRUIUDZYECDHLZMZHUJZYRIJZUUCYEYCUUFYCYDUKCDHULUMYDUUGYCYPDFUNUOZYEUUEUUGU
      UCUPZHYEUUEUUIYEUUEKZUAUBYMYRUUDUALZQZUUDUQZQZUUDUBLZQZUUMQZIUUJCCUUKMZYH
      UUKNZYHOZBCPZKZDDUUNMZYHUUNNZYHOZBDPZKZUUKYMJZUUNYRJUUJUVBUVGUUJUVBKZUVCU
      VFUVICDUULMZDCUUMMZUVCUUEUURUVJYEUVACCDUUDUUKURUSZUUEUVKYEUVBCDUUDUTZVAZD
      CDUULUUMURRUVIUELZUUNNZUVOOZUEDPUVFUVIUVQUEDUVIUVODJZKZUVPUVOUUKUUMQZNZUU
      DNZUVOUVSUVPUVOUUDUVTQZNZUWBUVOUUNUWCUUDUUKUUMVBVCUVIDCUVTVIZUVRUWDUWBSUV
      IDCUVTMZUWEUVIUURUVKUWFUUJUURUVAVDUVNDCCUUKUUMURRDCUVTVETZDCUVOUUDUVTVFVJ
      VGUVSUVOUUMNZUWAOUWBUVOOUVSUWAUWHUVSUWAUWHUUKNZUWHUVIDCUUMVIZUVRUWAUWISUV
      IUVKUWJUVNDCUUMVETZDCUVOUUKUUMVFVJUVSUWHCJUVAUWIUWHOZUVIDCUVOUUMUWKVHUUJU
      URUVAUVRVKUUTUWLBUWHCYHUWHSZUUSUWIYHUWHYHUWHUUKVLUWMVTVMVNVOVPVQUVSUWBUVO
      UWHUWAUVSUUEUWACJUWBUVOSUWHUWASUPYEUUEUVBUVRVRUVIDCUVOUVTUWGVHCDUWAUVOUUD
      VSRWAWBVPWCUVQUVEUEBDUVOYHSZUVPUVDUVOYHUVOYHUUNVLUWNVTVMWDUMWEWFYLUVBFUUK
      UAWGZYFUUKSZYGUURYKUVACCYFUUKWHUWPYJUUTBCUWPYIUUSYHYHYFUUKWLWIWJWKWMZYQUV
      GFUUNUULUUMUUDUUKHWGZUWOWNUUDUWRWOWNYFUUNSZYOUVCYPUVFDDYFUUNWHUWSYJUVEBDU
      WSYIUVDYHYHYFUUNWLWIWJWKWMWPUVHUUOYMJZKUVBCCUUOMZYHUUONZYHOZBCPZKZKZUUJUU
      NUUQSZUUKUUOSZXOZUVHUVBUWTUXEUWQYLUXEFUUOUBWGYFUUOSZYGUXAYKUXDCCYFUUOWHUX
      JYJUXCBCUXJYIUXBYHYHYFUUOWLWIWJWKWMWQUUJUXFUXIUUJUXFKZUXGUULUUPSZUXHUXKDC
      UUMWRZUULCWSZUUPCWSZUXGUXLXOUXKUVKUXMUUEUVKYEUXFUVMVADCUUMWTTUXKUVJUXNUUJ
      UVBUVJUXEUVLXACDUULXBTUXKCDUUPMZUXOUXKUUEUXAUXPYEUUEUXFXDUUJUVBUXAUXDXCZC
      CDUUDUUOURRCDUUPXBTDCUUMUULUUPXEXFUXKCDUUDXGZCCUUKVIZCCUUOVIZUXLUXHXOUUEU
      XRYEUXFCDUUDXHVAUXKUURUXSUUJUURUVAUXEXICCUUKVETUXKUXAUXTUXQCCUUOVETCCDUUD
      UUKUUOXJXFXKWFXLXMWFXNXPYEYMIJZUUGUUBUUCXOYECIJZUYAYDYCUYBCDXQXRZYKCFUNTU
      UHYMYRIXSRXTYEUYBYTYNSUYCABCEFGYATYDUUAYSSYCABDEFGYAUOYB $.

    $( The derangement number is a cardinal invariant, i.e. it only depends on
       the size of a set and not on its contents.  (Contributed by Mario
       Carneiro, 22-Jan-2015.) $)
    derangen $p |- ( ( A ~~ B /\ B e. Fin ) -> ( D ` A ) = ( D ` B ) ) $=
      ( cen wbr cfn wcel wa cfv cle derangenlem syl2anc cn0 ffvelrni cr nn0re
      wceq ensym adantr enfi biimpar derangf syl adantl letri3 syl2an mpbir2and
      wb ) CDHIZDJKZLZCEMZDEMZUAZUPUQNIZUQUPNIZABCDEFGOUODCHIZCJKZUTUMVAUNCDUBU
      CUMVBUNCDUDUEZABDCEFGOPUOUPQKZUQQKZURUSUTLULZUOVBVDVCJQCEABEFGUFZRUGUNVEU
      MJQDEVGRUHVDUPSKUQSKVFVEUPTUQTUPUQUIUJPUK $.

    subfac.n $e |- S = ( n e. NN0 |-> ( D ` ( 1 ... n ) ) ) $.
    $( The subfactorial is defined as the number of derangements (see
       ~ derangval ) of the set ` ( 1 ... N ) ` .  (Contributed by Mario
       Carneiro, 21-Jan-2015.) $)
    subfacval $p |- ( N e. NN0 -> ( S ` N ) = ( D ` ( 1 ... N ) ) ) $=
      ( c1 cv cfz co cfv cn0 wceq oveq2 fveq2d fvex fvmpt ) FGJFKZLMZCNJGLMZCNO
      DUAGPUBUCCUAGJLQRIUCCST $.

    $( Write the derangement number in terms of the subfactorial.  (Contributed
       by Mario Carneiro, 22-Jan-2015.) $)
    derangen2 $p |- ( A e. Fin -> ( D ` A ) = ( S ` ( # ` A ) ) ) $=
      ( cfn wcel chash cfv c1 cfz co cn0 wceq syl mpancom subfacval cen hashfz1
      hashcl wbr wb fzfid hashen mpbid derangen eqtr2d ) CJKZCLMZEMZNUMOPZDMZCD
      MZULUMQKZUNUPRCUDZABDEFGUMHIUASUOCUBUEZULUPUQRULUOLMUMRZUTULURVAUSUMUCSUO
      JKULVAUTUFULNUMUGUOCUHTUIABUOCDFHUJTUK $.

    $( The subfactorial is a function from nonnegative integers to nonnegative
       integers.  (Contributed by Mario Carneiro, 19-Jan-2015.) $)
    subfacf $p |- S : NN0 --> NN0 $=
      ( c1 cv cfz co cfv cn0 wcel wral wf cfn fzfi derangf ffvelrni ax-mp rgenw
      fmpt mpbi ) IFJZKLZCMZNOZFNPNNDQUIFNUGROUIIUFSRNUGCABCEGTUAUBUCFNNUHDHUDU
      E $.

    $( The subfactorial is less than the factorial.  (Contributed by Mario
       Carneiro, 19-Jan-2015.) $)
    subfaclefac $p |- ( N e. NN0 -> ( S ` N ) <_ ( ! ` N ) ) $=
      ( wcel c1 cv cfv wa cab chash cfa cle cfn syl cn0 cfz co wf1o wne wbr wss
      wral cdom anidm abbii fzfid deranglem syl5eqelr simpl ss2abi ee10 hashdom
      ssdomg wb syl2anc mpbird subfacval derangval eqtrd hashfac hashfz1 fveq2d
      wceq eqtr2d 3brtr4d ) GUAJZKGUBUCZVMELZUDZBLZVNMVPUEBVMUHZNZEOZPMZVOEOZPM
      ZGDMZGQMZRVLVTWBRUFZVSWAUIUFZVLWASJZVSWAUGWFVLWAVOVONZEOZSWHVOEVOUJUKVLVM
      SJZWISJVLKGULZVOVMEUMTUNZVRVOEVOVQUOUPVSWASUSUQVLVSSJZWGWEWFUTVLWJWMWKVQV
      MEUMTWLVSWASURVAVBVLWCVMCMZVTABCDEFGHIVCVLWJWNVTVIWKABVMCEHVDTVEVLWBVMPMZ
      QMZWDVLWJWBWPVIWKVMEVFTVLWOGQGVGVHVJVK $.

    $( The subfactorial at zero.  (Contributed by Mario Carneiro,
       19-Jan-2015.) $)
    subfac0 $p |- ( S ` 0 ) = 1 $=
      ( cc0 cfv c1 cfz co c0 cn0 wcel wceq 0nn0 subfacval ax-mp fveq2i derang0
      fz10 3eqtri ) IDJZKILMZCJZNCJKIOPUEUGQRABCDEFIGHSTUFNCUCUAABCEGUBUD $.

    $( The subfactorial at one.  (Contributed by Mario Carneiro,
       19-Jan-2015.) $)
    subfac1 $p |- ( S ` 1 ) = 0 $=
      ( c1 cfv cfz co csn cc0 cn0 wcel wceq 1nn0 subfacval ax-mp cz fzsn fveq2i
      1z derangsn 3eqtri ) IDJZIIKLZCJZIMZCJZNIOPZUGUIQRABCDEFIGHSTUHUJCIUAPUHU
      JQUDIUBTUCULUKNQRABICEOGUETUF $.

    ${
      subfacp1lem.a $e |- A = { f |
        ( f : ( 1 ... ( N + 1 ) ) -1-1-onto-> ( 1 ... ( N + 1 ) ) /\
          A. y e. ( 1 ... ( N + 1 ) ) ( f ` y ) =/= y ) } $.
      ${
        subfacp1lem1.n $e |- ( ph -> N e. NN ) $.
        subfacp1lem1.m $e |- ( ph -> M e. ( 2 ... ( N + 1 ) ) ) $.
        subfacp1lem1.x $e |- M e. _V $.
        subfacp1lem1.k $e |- K = ( ( 2 ... ( N + 1 ) ) \ { M } ) $.
        $( Lemma for ~ subfacp1 .  The set ` K ` together with ` { 1 , M } `
           partitions the set ` 1 ... ( N + 1 ) ` .  (Contributed by Mario
           Carneiro, 23-Jan-2015.) $)
        subfacp1lem1 $p |- ( ph ->
          ( ( K i^i { 1 , M } ) = (/) /\
            ( K u. { 1 , M } ) = ( 1 ... ( N + 1 ) ) /\
            ( # ` K ) = ( N - 1 ) ) ) $=
          ( c1 wcel cpr cin c0 wceq cun caddc co cfz chash cfv cmin cv disj wne
          wn wo wa csn cdif cle wbr eldifi elfzle1 clt 1lt2 1re 2re ltnlei mpbi
          breq2 mtbiri necon2ai 3syl eldifsni jca eleq2s neanior sylib vex elpr
          c2 sylnibr mprgbir a1i uncom cz 1z ax-mp uneq1i undif1 eqtr2i uneq12i
          fzsn df-pr equncomi uneq2i unass eqtr4i 3eqtr4i wss snssd df-2 oveq1i
          ssequn2 syl6eq uneq2d peano2nnd nnuz syl6eleq eluzfz1 fzsplit syl5eqr
          cuz cn eqtr4d oveq2i cfn fzfi diffi eqeltri hashun mp3an fveq2d neeq1
          syl vtoclga necomd cvv wb 1ex hashprg mp2an oveq2d 3eqtr3a cn0 nnnn0d
          prfi hashfz1 nncnd cc eqtr3d 2cn hashcl nn0cni subadd2d mpbird ax-1cn
          pnpcan2d 3jca ) AISJUAZUBUCUDZIUUJUEZSKSUFUGZUHUGZUDIUIUJZKSUKUGZUDUU
          KAUUKBULZUUJTZUOBIBIUUJUMUUQITZUUQSUDZUUQJUDUPZUURUUSUUQSUNZUUQJUNZUQ
          ZUVAUOUVDUUQWAUUMUHUGZJURZUSZIUUQUVGTZUVBUVCUVHUUQUVETZWAUUQUTVAZUVBU
          UQUVEUVFVBUUQWAUUMVCZUVJUUQSUUTUVJWASUTVAZSWAVDVAUVLUOVESWAVFVGVHVIUU
          QSWAUTVJVKVLZVMUUQUVEJVNVORVPUUQSUUQJVQVRUUQSJBVSVTWBWCZWDAUULSSUHUGZ
          UVEUVFUEZUEZUUNSURZIUVFUEZUEUVSUVRUEZUVQUULUVRUVSWEUVOUVRUVPUVSSWFTUV
          OUVRUDWGSWMWHUVSUVGUVFUEUVPIUVGUVFRWIUVEUVFWJWKWLUULIUVFUVRUEZUEUVTUU
          JUWAIUUJUVRUVFSJWNWOWPIUVFUVRWQWRWSAUVQUVOSSUFUGZUUMUHUGZUEZUUNAUVPUW
          CUVOAUVPUVEUWCAUVFUVEWTUVPUVEUDAJUVEPXAUVFUVEXDVRWAUWBUUMUHXBXCXEXFAU
          UMSXMUJZTSUUNTUUNUWDUDAUUMXNUWEAKOXGZXHXISUUMXJSSUUMXKVMXOXLZAUUMWAUK
          UGZUUMUWBUKUGUUOUUPWAUWBUUMUKXBXPAUWHUUOUDUUOWAUFUGZUUMUDAUUNUIUJZUWI
          UUMAUULUIUJZUUOUUJUIUJZUFUGZUWJUWIIXQTZUUJXQTUUKUWKUWMUDIUVGXQRUVEXQT
          UVGXQTWAUUMXRUVEUVFXSWHXTZSJYQUVNIUUJYAYBAUULUUNUIUWGYCAUWLWAUUOUFASJ
          UNZUWLWAUDZAJSAJUVETJSUNZPUVBUWRBJUVEUUQJSYDUVIUVJUVBUVKUVMYEYFYEYGSY
          HTJYHTUWPUWQYIYJQSJYHYKYLVRYMYNAUUMYOTUWJUUMUDAUUMUWFYPUUMYRYEUUAAUUM
          WAUUOAUUMUWFYSWAYTTAUUBWDUUOYTTAUUOUWNUUOYOTUWOIUUCWHUUDWDUUEUUFAKSSA
          KOYSSYTTAUUGWDZUWSUUHYNUUI $.

        ${
          subfacp1lem2.5 $e |- F =
            ( G u. { <. 1 , M >. , <. M , 1 >. } ) $.
          subfacp1lem2.6 $e |- ( ph -> G : K -1-1-onto-> K ) $.
          $( Lemma for ~ subfacp1 .  Properties of a bijection on ` K `
             augmented with the two-element flip to get a bijection on
             ` K u. { 1 , M } ` .  (Contributed by Mario Carneiro,
             23-Jan-2015.) $)
          subfacp1lem2a $p |- ( ph ->
            ( F : ( 1 ... ( N + 1 ) ) -1-1-onto-> ( 1 ... ( N + 1 ) ) /\
              ( F ` 1 ) = M /\ ( F ` M ) = 1 ) ) $=
            ( c1 caddc co cfz wf1o cfv wceq cpr cun cop cin c0 cz cvv f1oprswap
            wcel mp2an a1i chash cmin subfacp1lem1 simp1d f1oun syl22anc simp2d
            1z wb f1oeq1 ax-mp f1oeq2 syl5bbr f1oeq3 bitrd syl mpbid csn f1ofun
            wfun wss cdm snsspr1 ssun2 sseqtr4i sstri 1ex snid eleqtrri funssfv
            dmsnop mp3an23 fvsn syl6eq snsspr2 3jca ) AUCMUCUDUEUFUEZWQIUGZUCIU
            HZLUILIUHZUCUIAKUCLUJZUKZXBJUCLULZLUCULZUJZUKZUGZWRAKKJUGXAXAXEUGZK
            XAUMUNUIZXIXGUBXHAUCUOURLUPURXHVHSUCLUOUPUQUSUTAXIXBWQUIZKVAUHMUCVB
            UEUIZABCDEFGHKLMNOPQRSTVCZVDZXMKKXAXAJXEVEVFAXJXGWRVIAXIXJXKXLVGXJX
            GWQXBIUGZWRXGXBXBIUGZXJXNIXFUIXOXGVIUAXBXBIXFVJVKXBWQXBIVLVMXBWQWQI
            VNVOVPVQZAWSUCXCVRZUHZLAIVTZWSXRUIZAWRXSXPWQWQIVSVPZXSXQIWAUCXQWBZU
            RXTXQXEIXCXDWCXEXFIXEJWDUAWEZWFUCUCVRYBUCWGWHUCLSWKWIUCIXQWJWLVPUCL
            WGSWMWNAWTLXDVRZUHZUCAXSWTYEUIZYAXSYDIWALYDWBZURYFYDXEIXCXDWOYCWFLL
            VRYGLSWHLUCWGWKWILIYDWJWLVPLUCSWGWMWNWP $.

          $( Lemma for ~ subfacp1 .  Properties of a bijection on ` K `
             augmented with the two-element flip to get a bijection on
             ` K u. { 1 , M } ` .  (Contributed by Mario Carneiro,
             23-Jan-2015.) $)
          subfacp1lem2b $p |- ( ( ph /\ X e. K ) -> ( F ` X ) = ( G ` X ) ) $=
            ( wcel wa wfun wss cdm cfv wceq caddc cfz wf1o subfacp1lem2a simp1d
            c1 co f1ofun syl adantr cop cpr cun ssun1 sseqtr4i a1i f1odm eleq2d
            biimpar funssfv syl3anc ) ANKUDZUEZIUFZJIUGZNJUHZUDZNIUINJUIUJAVNVL
            AUPMUPUKUQULUQZVRIUMZVNAVSUPIUILUJLIUIUPUJABCDEFGHIJKLMOPQRSTUAUBUC
            UNUOVRVRIURUSUTVOVMJJUPLVALUPVAVBZVCIJVTVDUBVEVFAVQVLAVPKNAKKJUMVPK
            UJUCKKJVGUSVHVINIJVJVK $.
        $}

        ${
          subfacp1lem3.b $e |- B = { g e. A |
            ( ( g ` 1 ) = M /\ ( g ` M ) = 1 ) } $.
          subfacp1lem3.c $e |- C = { f | ( f : K -1-1-onto-> K /\
            A. y e. K ( f ` y ) =/= y ) } $.
          $( Lemma for ~ subfacp1 .  In ~ subfacp1lem6 we cut up the set of all
             derangements on ` 1 ... ( N + 1 ) ` first according to the value
             at ` 1 ` , and then by whether or not
             ` ( f `` ( f `` 1 ) ) = 1 ` .  In this lemma, we show that the
             subset of all ` N + 1 ` derangements that satisfy this for fixed
             ` M = ( f `` 1 ) ` is in bijection with ` N - 1 ` derangements, by
             simply dropping the ` x = 1 ` and ` x = M ` points from the
             function to get a derangement on
             ` K = ( 1 ... ( N - 1 ) ) \ { 1 , M } ` .  (Contributed by Mario
             Carneiro, 23-Jan-2015.) $)
          subfacp1lem3 $p |- ( ph -> ( # ` B ) = ( S ` ( N - 1 ) ) ) $=
            ( vb vc chash cfv c1 cmin co cen wbr wceq cres cop cpr cun cvv wcel
            cv cfn wss cfz wf1o wne wral cab fzfi deranglem ax-mp eqeltri mp2an
            wa elexi a1i c2 cdif wfo simpr weq fveq1 eqeq1d elrab2 sylib simpld
            anbi12d vex f1oeq1 neeq1d ralbidv elab2 wf simprbi wfn wb f1ofn syl
            3syl wrex c0 simp2d syl5sseq adantr fnssres syl2anc simprd syl6eqel
            cin fveq2 eleq1d ralpr sylanbrc fvres ralbiia sylibr rspcev sylancr
            1ex eqeq2 rexbidv eqcom syl5eq simp1d mpbid ralbidva eqnetrd simp3d
            ex cn neeq12d ralunb raleqdv adantrr adantrl eqtr4d eqeq12d syl6bbr
            id eqeq2d eqfnfv caddc crab ssrab2 eqsstri ssfi csn diffi ccnv wfun
            wf1 f1of1 df-f1 fnresdm mpbird f1ofo ssun2 subfacp1lem1 prid2 prid1
            ffnfv syl5bb rexbiia ralbii dffo3 resdif syl3anc uncom incom reseq2
            f1oeq2 f1oeq3 3bitrd ssun1 ssralv sylc resex sylan9eq subfacp1lem2a
            uneqdifeq eqid subfacp1lem2b r19.21bi ralrimiva elfzuz eluz2b3 prex
            cuz necomd unex biantrud 3bitr3rd syl6bb 3bitr4d en3d hashen fveq2i
            jca derangval derangen2 3eqtr2ri fveq2d syl5eqr eqtrd ) AEUFUGZFUFU
            GZNUHUIUJZHUGZAEFUKULZUXDUXEUMZAUDUEEFUDUTZLUNZUEUTZUHMUOZMUHUOZUPZ
            UQZEURUSAEVADVAUSEDVBEVAUSZDUHNUHUUAUJZVCUJZUXSIUTZVDZCUTZUXTUGZUYB
            VEZCUXSVFZVMZIVGZVAQUXSVAUSUYGVAUSUHUXRVHUYEUXSIVIVJVKEUHJUTZUGZMUM
            ZMUYHUGZUHUMZVMZJDUUBDUBUYMJDUUCUUDDEUUEVLZVNVOFURUSAFVAFLLUXTVDZUY
            DCLVFZVMZIVGZVAUCLVAUSZUYRVAUSLVPUXRVCUJZMUUFZVQZVAUAUYTVAUSVUBVAUS
            VPUXRVHUYTVUAUUGVJVKZUYPLIVIVJVKZVNVOAUXJEUSZUXKFUSZAVUEVMZLLUXKVDZ
            UYBUXJUGZUYBVEZCLVFZVUFVUGUXSUHMUPZVQZVUMUXJVUMUNZVDZVUHVUGUXJUUHUU
            IZUXSUXSUXJUXSUNZVRZVULVULUXJVULUNZVRZVUOVUGUXSUXSUXJVDZUXSUXSUXJUU
            JZVUPVUGVVAVUJCUXSVFZVUGUXJDUSZVVAVVCVMZVUGVVDUHUXJUGZMUMZMUXJUGZUH
            UMZVMZVUGVUEVVDVVJVMAVUEVSUYMVVJJUXJDEJUDVTZUYJVVGUYLVVIVVKUYIVVFMU
            HUYHUXJWAWBVVKUYKVVHUHMUYHUXJWAWBWFUBWCWDZWEUYFVVEIUXJDUDWGZIUDVTZU
            YAVVAUYEVVCUXSUXSUXTUXJWHVVNUYDVUJCUXSVVNUYCVUIUYBUYBUXTUXJWAWIWJWF
            QWKWDZWEZUXSUXSUXJUUKVVBUXSUXSUXJWLVUPUXSUXSUXJUULWMWRVUGUXSUXSVUQV
            DZVURVUGVVQVVAVVPVUGUXJUXSWNZVUQUXJUMVVQVVAWOVUGVVAVVRVVPUXSUXSUXJW
            PWQZUXSUXJUUMUXSUXSVUQUXJWHWRUUNUXSUXSVUQUUOWQVUGVULVULVUSWLZBUTZUY
            BVUSUGZUMZCVULWSZBVULVFZVUTVUGVUSVULWNZVWAVUSUGZVULUSZBVULVFZVVTVUG
            VVRVULUXSVBZVWFVVSAVWJVUEALVULUQZVULUXSVULLUUPALVULXHZWTUMZVWKUXSUM
            ZLUFUGZUXFUMZABCDGHIKLMNOPQRSTUAUUQZXAZXBZXCUXSVULUXJXDXEVUGVWAUXJU
            GZVULUSZBVULVFZVWIVUGVVFVULUSZVVHVULUSZVXBVUGVVFMVULVUGVVGVVIVUGVVD
            VVJVVLXFZWEZUHMTUURZXGVUGVVHUHVULVUGVVGVVIVXEXFZUHMXRUUSZXGVXAVXCVX
            DBUHMXRTVWAUHUMZVWTVVFVULVWAUHUXJXIXJVWAMUMZVWTVVHVULVWAMUXJXIXJXKX
            LVWHVXABVULVWAVULUSVWGVWTVULVWAVULUXJXMXJXNXOBVULVULVUSUUTXLVUGVUIV
            WAUMZCVULWSZBVULVFZVWEVUGVUIUHUMZCVULWSZVUIMUMZCVULWSZVXNVUGMVULUSV
            VIVXPVXGVXHVXOVVICMVULUYBMUMZVUIVVHUHUYBMUXJXIZWBXPXQVUGUHVULUSVVGV
            XRVXIVXFVXQVVGCUHVULUYBUHUMZVUIVVFMUYBUHUXJXIZWBXPXQVXMVXPVXRBUHMXR
            TVXJVXLVXOCVULVWAUHVUIXSXTVXKVXLVXQCVULVWAMVUIXSXTXKXLVWDVXMBVULVWC
            VXLCVULVWCVWBVWAUMUYBVULUSZVXLVWAVWBYAVYCVWBVUIVWAUYBVULUXJXMWBUVAU
            VBUVCXOCBVULVULVUSUVDXLUXSVULUXSVULUXJUVEUVFVUGVUMLUMZVUOVUHWOAVYDV
            UEAVULLUQZUXSUMZVYDAVYEVWKUXSVULLUVGVWRYBAVWJVULLXHZWTUMVYFVYDWOVWS
            AVYGVWLWTVULLUVHAVWMVWNVWPVWQYCYBVULLUXSUVSXEYDXCVYDVUOVUMVUMUXKVDZ
            LVUMUXKVDVUHVYDVUNUXKUMVUOVYHWOVUMLUXJUVIVUMVUMVUNUXKWHWQVUMLVUMUXK
            UVJVUMLLUXKUVKUVLWQYDVUGLUXSVBZVVCVUKAVYIVUEAVWKLUXSLVULUVMVWRXBZXC
            VUGVVAVVCVVOXFVUJCLUXSUVNUVOUYQVUHVUKVMIUXKFUXJLVVMUVPUXTUXKUMZUYOV
            UHUYPVUKLLUXTUXKWHVYKUYDVUJCLVYKUYBLUSZVMUYCVUIUYBVYKVYLUYCUYBUXKUG
            ZVUIUYBUXTUXKWAUYBLUXJXMZUVQWIYEWFUCWKXLYHAUXLFUSZUXPEUSZAVYOVMZUXP
            DUSZUHUXPUGZMUMZMUXPUGZUHUMZVMZVYPVYQUXSUXSUXPVDZUYBUXPUGZUYBVEZCUX
            SVFZVYRVYQWUDVYTWUBVYQBCDGHIKUXPUXLLMNOPQANYIUSVYORXCZAMUYTUSZVYOSX
            CZTUAUXPUVTZVYQLLUXLVDZUYBUXLUGZUYBVEZCLVFZVYQVYOWULWUOVMZAVYOVSUYQ
            WUPIUXLFUEWGZIUEVTZUYOWULUYPWUOLLUXTUXLWHWURUYDWUNCLWURUYCWUMUYBUYB
            UXTUXLWAWIWJWFUCWKWDZWEZUVRZYCZVYQWUFCVWKVFZWUGVYQWUFCLVFWUFCVULVFZ
            WVCVYQWUFCLVYQVYLVMZWUEWUMUYBVYQBCDGHIKUXPUXLLMNUYBOPQWUHWUJTUAWUKW
            UTUWAZVYQWUNCLVYQWULWUOWUSXFUWBYFUWCVYQVYSUHVEZWUAMVEZWVDVYQVYSMUHV
            YQWUDVYTWUBWVAXAZAMUHVEZVYOAWUIMVPUWGUGUSZWVJSMVPUXRUWDWVKMYIUSWVJM
            UWEWMWRXCZYFVYQWUAUHMVYQWUDVYTWUBWVAYGZVYQMUHWVLUWHYFWUFWVGWVHCUHMX
            RTVYAWUEVYSUYBUHUYBUHUXPXIZVYAYRYJVXSWUEWUAUYBMUYBMUXPXIZVXSYRYJXKX
            LWUFCLVULYKXLVYQWUFCVWKUXSAVWNVYOVWRXCYLYDUYFWUDWUGVMIUXPDUXLUXOWUQ
            UXMUXNUWFUWIUXTUXPUMZUYAWUDUYEWUGUXSUXSUXTUXPWHWVPUYDWUFCUXSWVPUYCW
            UEUYBUYBUXTUXPWAWIWJWFQWKXLVYQVYTWUBWVIWVMUWQUYMWUCJUXPDEUYHUXPUMZU
            YJVYTUYLWUBWVQUYIVYSMUHUYHUXPWAWBWVQUYKWUAUHMUYHUXPWAWBWFUBWCXLYHAV
            UEVYOVMZUXJUXPUMZUXLUXKUMZWOAWVRVMZVUIWUEUMZCUXSVFZWUMVYMUMZCLVFZWV
            SWVTWWAWWCVUIWUMUMZCLVFZWWEWWAWWBCLVFZWWBCVWKVFZWWGWWCWWAWWHWWHWWBC
            VULVFZVMWWIWWAWWJWWHWWAVVFVYSUMZVVHWUAUMZWWJWWAVVFMVYSAVUEVVGVYOVXF
            YMAVYOVYTVUEWVIYNYOWWAVVHUHWUAAVUEVVIVYOVXHYMAVYOWUBVUEWVMYNYOWWBWW
            KWWLCUHMXRTVYAVUIVVFWUEVYSVYBWVNYPVXSVUIVVHWUEWUAVXTWVOYPXKXLUWJWWB
            CLVULYKYQAVYOWWHWWGWOVUEVYQWWBWWFCLWVEWUEWUMVUIWVFYSYEYNWWAWWBCVWKU
            XSAVWNWVRVWRXCYLUWKWWDWWFCLVYLWWDWUMVUIUMWWFVYLVYMVUIWUMVYNYSWUMVUI
            YAUWLXNYQWWAVVRUXPUXSWNZWVSWWCWOAVUEVVRVYOVVSYMZWWAWUDWWMAVYOWUDVUE
            WVBYNUXSUXSUXPWPWQCUXSUXJUXPYTXEWWAUXLLWNZUXKLWNZWVTWWEWOWWAWULWWOA
            VYOWULVUEWUTYNLLUXLWPWQWWAVVRVYIWWPWWNAVYIWVRVYJXCUXSLUXJXDXECLUXLU
            XKYTXEUWMYHUWNUXQFVAUSUXIUXHWOUYNVUDEFUWOVLXOAUXEVWOHUGZUXGUXEUYRUF
            UGZLGUGZWWQFUYRUFUCUWPUYSWWSWWRUMVUCBCLGIOUWRVJUYSWWSWWQUMVUCBCLGHI
            KOPUWSVJUWTAVWOUXFHAVWMVWNVWPVWQYGUXAUXBUXC $.
        $}

        ${
          subfacp1lem5.b $e |- B = { g e. A |
            ( ( g ` 1 ) = M /\ ( g ` M ) =/= 1 ) } $.
          subfacp1lem5.f $e |- F =
            ( ( _I |` K ) u. { <. 1 , M >. , <. M , 1 >. } ) $.
          $( Lemma for ~ subfacp1 .  The function ` F ` , which swaps ` 1 `
             with ` M ` and leaves all other elements alone, is a bijection of
             order ` 2 ` , i.e. it is its own inverse.  (Contributed by Mario
             Carneiro, 19-Jan-2015.) $)
          subfacp1lem4 $p |- ( ph -> `' F = F ) $=
            ( c1 caddc co cfz ccnv wf1o wfn cfv wceq cid cres a1i subfacp1lem2a
            f1oi simp1d f1ocnv f1ofn 3syl syl cv wcel wa cpr wo cun cin c0 cmin
            chash subfacp1lem1 simp2d eleq2d biimpar sylib subfacp1lem2b fvresi
            elun adantl eqtrd fveq2d vex elpr simp3d id eqeq12d syl5ibrcom jaod
            fveq2 imp sylan2b jaodan syldan wi adantr wf f1of ffvelrnda syl2anc
            f1ocnvfv mpd eqfnfvd ) ABUDNUDUEUFUGUFZKUHZKAXEXEKUIZXEXEXFUIXFXEUJ
            AXGUDKUKZMULZMKUKZUDULZABCDFGHJKUMLUNZLMNOPQRSTUAUCLLXLUIALUQUOZUPZ
            URZXEXEKUSXEXEXFUTVAAXGKXEUJXOXEXEKUTVBABVCZXEVDZVEZXPKUKZKUKZXPULZ
            XPXFUKXSULZAXQXPLVDZXPUDMVFZVDZVGZYAXRXPLYDVHZVDZYFAYHXQAYGXEXPALYD
            VIVJULYGXEULLVLUKNUDVKUFULABCDFGHJLMNOPQRSTUAVMVNVOVPXPLYDVTVQAYCYA
            YEAYCVEZXTXSXPYIXSXPKYIXSXPXLUKZXPABCDFGHJKXLLMNXPOPQRSTUAUCXMVRYCY
            JXPULALXPVSWAWBZWCYKWBYEAXPUDULZXPMULZVGZYAXPUDMBWDWEAYNYAAYLYAYMAY
            AYLXHKUKZUDULAYOXJUDAXHMKAXGXIXKXNVNZWCAXGXIXKXNWFZWBYLXTYOXPUDYLXS
            XHKXPUDKWKWCYLWGWHWIAYAYMXJKUKZMULAYRXHMAXJUDKYQWCYPWBYMXTYRXPMYMXS
            XJKXPMKWKWCYMWGWHWIWJWLWMWNWOXRXGXSXEVDYAYBWPAXGXQXOWQAXEXEXPKAXGXE
            XEKWRXOXEXEKWSVBWTXEXEXSXPKXBXAXCXD $.

          subfacp1lem5.c $e |- C = { f | ( f : ( 2 ... ( N + 1 ) ) -1-1-onto->
      ( 2 ... ( N + 1 ) ) /\ A. y e. ( 2 ... ( N + 1 ) ) ( f ` y ) =/= y ) } $.
          $( Lemma for ~ subfacp1 .  In ~ subfacp1lem6 we cut up the set of all
             derangements on ` 1 ... ( N + 1 ) ` first according to the value
             at ` 1 ` , and then by whether or not
             ` ( f `` ( f `` 1 ) ) = 1 ` .  In this lemma, we show that the
             subset of all ` N + 1 ` derangements with
             ` ( f `` ( f `` 1 ) ) =/= 1 ` for fixed ` M = ( f `` 1 ) ` is in
             bijection with derangements of ` 2 ... ( N + 1 ) ` , because
             pre-composing with the function ` F ` swaps ` 1 ` and ` M ` and
             turns the function into a bijection with ` ( f `` 1 ) = 1 ` and
             ` ( f `` x ) =/= x ` for all other ` x ` , so dropping the point
             at ` 1 ` yields a derangement on the ` N ` remaining points.
             (Contributed by Mario Carneiro, 23-Jan-2015.) $)
          subfacp1lem5 $p |- ( ph -> ( # ` B ) = ( S ` N ) ) $=
            ( vb vc chash cfv wbr wceq cv ccom c2 c1 caddc cfz cres cop csn cun
            co cvv wcel cfn wss wf1o wne wral wa cab fzfi deranglem ax-mp mp2an
            eqeltri elexi a1i cdif ccnv wfun wfo wf1 cid adantr simpr weq fveq1
            eqeq1d neeq1d anbi12d elrab2 sylib simpld vex ralbidv elab2 syl2anc
            f1oeq1 f1oco f1of1 wf wfn wb f1ofn f1ofo syl 1ex nnuz syl6eleq f1of
            cuz cn fvco3 simprd fveq2d 3eqtrd eqtrd syl3anc c0 sylancl ad2antrr
            sseldi neeqtrrd fveq2 neeq12d syl5ibrcom adantrr necomd wi f1ocnvfv
            eqnetrd necon3d mpd sylanbrc ex funssfv adantrl cmin cc crab ssrab2
            cen eqsstri ssfi f1oi subfacp1lem2a df-f1 simprbi 3syl fnresdm 4syl
            simp1d mpbird peano2nnd eluzfz1 fnressn simp3d opeq2d mpbiri resdif
            f1osn sneqd fzsplit cz 1z fzsn 1p1e2 oveq1i uneq12i cin snssd incom
            syl6req wn cle clt 1lt2 1re 2re ltnlei mpbi elfzle1 mto mpbir eqtri
            disjsn uneqdifeq reseq2 f1oeq2 f1oeq3 3bitrd fzp1ss eqsstr3i fveq1d
            mpbid subfacp1lem4 sseli r19.21bi sylan2 eleq2i bitri subfacp1lem2b
            eldifsn fvresi adantl sylan2br adantlr pm2.61dne ffvelrn syl2an cpr
            expr ralrimiva difexg fex prex unex coex resex fvres sylan9eq f1oun
            ralbidva mpanr12 sylancr bitrd biimpa syldan sylan wo eleqtrrd elun
            nelne2 simp2d f1ofun ssun1 snid dmsnop eleqtrri mp3an23 fvsn syl6eq
            cdm 3netr4d elsni imp ssun2 f1odm eleq2d biimpar ffvelrnd ffvelrnda
            jaodan snex rspcv sylc jca fco cocan1 coass coeq1d f1ococnv1 eqtr3d
            fcoi2 syl5eqr eqtr4d eqeq12d sylibr biantrurd ralunb syl6bbr eqcomd
            ralsn adantlrl raleqdv 3bitr3rd eqfnfv fnssres 3bitr4d eqcom syl6bb
            id 3bitr3d en3d hashen derangen2 derangval fveq2i syl6eqr syl6eleqr
            eluzp1p1 df-2 hashfz nncnd ax-1cn subsubd 2m1e1 oveq2i pncan syl5eq
            2cn 3eqtr2d ) AEUHUIZFUHUIZOHUIZAEFUUCUJZVXDVXEUKZAUFUGEFLUFULZUMZU
            NOUOUPVBZUQVBZURZLUOUOUSZUTZUGULZVAZUMZEVCVDAEVEDVEVDEDVFEVEVDZDUOV
            XKUQVBZVXTIULZVGZCULZVYAUIZVYCVHZCVXTVIZVJZIVKZVERVXTVEVDVYHVEVDUOV
            XKVLVYFVXTIVMVNVPEUOJULZUIZNUKZNVYIUIZUOVHZVJZJDUUADUCVYNJDUUBUUDDE
            UUEVOZVQVRFVCVDAFVEFVXLVXLVYAVGZVYECVXLVIZVJZIVKZVEUEVXLVEVDZVYSVEV
            DUNVXKVLZVYQVXLIVMVNVPZVQVRAVXIEVDZVXMFVDZAWUCVJZVXLVXLVXMVGZVYCVXJ
            UIZVYCVHZCVXLVIZWUDWUEVXTUOUTZVSZWUKVXJWUKURZVGZWUFWUEVXJVTWAZVXTVX
            TVXJVXTURZWBZWUJWUJVXJWUJURZWBZWUMWUEVXTVXTVXJVGZVXTVXTVXJWCZWUNWUE
            VXTVXTLVGZVXTVXTVXIVGZWUSAWVAWUCAWVAUOLUIZNUKZNLUIZUOUKZABCDGHIKLWD
            MURZMNOPQRSTUAUBUDMMWVGVGZAMUUFZVRZUUGZUUMZWEZWUEWVBVYCVXIUIZVYCVHZ
            CVXTVIZWUEVXIDVDZWVBWVPVJZWUEWVQUOVXIUIZNUKZNVXIUIZUOVHZVJZWUEWUCWV
            QWWCVJAWUCWFVYNWWCJVXIDEJUFWGZVYKWVTVYMWWBWWDVYJWVSNUOVYIVXIWHWIWWD
            VYLWWAUONVYIVXIWHWJWKUCWLWMZWNVYGWVRIVXIDUFWOZIUFWGZVYBWVBVYFWVPVXT
            VXTVYAVXIWSWWGVYEWVOCVXTWWGVYDWVNVYCVYCVYAVXIWHWJWPWKRWQWMZWNZVXTVX
            TVXTLVXIWTWRZVXTVXTVXJXAWUTVXTVXTVXJXBZWUNVXTVXTVXJUUHUUIUUJWUEVXTV
            XTWUOVGZWUPWUEWWLWUSWWJWUEWUSVXJVXTXCZWUOVXJUKWWLWUSXDWWJVXTVXTVXJX
            EZVXTVXJUUKVXTVXTWUOVXJWSUULUUNVXTVXTWUOXFXGWUEWUJWUJWUQVGZWURWUEWW
            OWUJWUJVXOVGZUOUOXHXHUVBZWUEWUQVXOUKWWOWWPXDWUEWUQUOUOVXJUIZUSZUTZV
            XOWUEWWMUOVXTVDZWUQWWTUKWUEWUSWWMWWJWWNXGZAWXAWUCAVXKUOXLUIZVDWXAAV
            XKXMWXCAOSUUOZXIXJUOVXKUUPXGZWEZVXTUOVXJUUQWRWUEWWSVXNWUEWWRUOUOWUE
            WWRWVSLUIZWVEUOWUEVXTVXTVXIXBZWXAWWRWXGUKWUEWVBWXHWWIVXTVXTVXIXKXGZ
            WXFVXTVXTUOLVXIXNWRWUEWVSNLWUEWVTWWBWUEWVQWWCWWEXOZWNXPAWVFWUCAWVAW
            VDWVFWVKUURZWEZXQZUUSUVCXRWUJWUJWUQVXOWSXGUUTWUJWUJWUQXFXGVXTWUJVXT
            WUJVXJUVAXSWUEWUKVXLUKZWUMWUFXDAWXNWUCAWUJVXLVAZVXTUKZWXNAVXTUOUOUQ
            VBZUOUOUPVBZVXKUQVBZVAZWXOAWXAVXTWXTUKWXEUOUOVXKUVDXGWXQWUJWXSVXLUO
            UVEVDZWXQWUJUKUVFUOUVGVNWXRUNVXKUQUVHUVIZUVJUVNZAWUJVXTVFWUJVXLUVKZ
            XTUKZWXPWXNXDAUOVXTWXEUVLWYDVXLWUJUVKZXTWUJVXLUVMWYFXTUKUOVXLVDZUVO
            ZWYGUNUOUVPUJZUOUNUVQUJWYIUVOUVRUOUNUVSUVTUWAUWBUOUNVXKUWCUWDZVXLUO
            UWGUWEUWFZWUJVXLVXTUWHYAUWPWEWXNWUMWUKWUKVXMVGZVXLWUKVXMVGWUFWXNWUL
            VXMUKWUMWYLXDWUKVXLVXJUWIWUKWUKWULVXMWSXGWUKVXLWUKVXMUWJWUKVXLVXLVX
            MUWKUWLXGUWPWUEWUHCVXLWUEVYCVXLVDZVJZWUGWVNLUIZVYCWYNWXHVYCVXTVDZWU
            GWYOUKWUEWXHWYMWXIWEWYNVXLVXTVYCVXLWXSVXTWYBWYAWXSVXTVFUVFUOVXKUWMV
            NUWNZWUEWYMWFYCVXTVXTVYCLVXIXNWRWYNVYCLVTZUIZWVNVHWYOVYCVHWYNWYSVYC
            LUIZWVNAWYSWYTUKZWUCWYMAVYCWYRLABCDEGHIJKLMNOPQRSTUAUBUCUDUWQZUWOZY
            BWYNWVNWYTWYNWVNWYTVHZVYCNWYNXUDVYCNUKZWWAWVEVHZWUEXUFWYMWUEWWAUOWV
            EWUEWVTWWBWXJXOWXLYDWEXUEWVNWWAWYTWVEVYCNVXIYEVYCNLYEZYFYGWUEWYMVYC
            NVHZXUDWUEWYMXUHVJZVJWVNVYCWYTWUEWYMWVOXUHWYMWUEWYPWVOVXLVXTVYCWYQU
            WRZWUEWVOCVXTWUEWVBWVPWWHXOUWSUWTYHAXUIWYTVYCUKZWUCXUIAVYCMVDZXUKXU
            LVYCVXLNUTZVSZVDXUIMXUNVYCUBUXAVYCVXLNUXDUXBAXULVJWYTVYCWVGUIZVYCAB
            CDGHIKLWVGMNOVYCPQRSTUAUBUDWVJUXCXULXUOVYCUKAMVYCUXEUXFXRUXGZUXHYDU
            XMUXIYIYLWYNWYOVYCWYSWVNWYNWVAWVNVXTVDZWYOVYCUKWYSWVNUKYJWUEWVAWYMW
            VMWEWUEWXHWYPXUQWYMWXIXUJVXTVXTVYCVXIUXJUXKVXTVXTWVNVYCLYKWRYMYNYLU
            XNVYRWUFWUIVJIVXMFVXJVXLLVXILWVGUONUSZNUOUSZUXLZVAVCUDWVGXUTMMWVGXB
            ZMVCVDWVGVCVDWVHXVAWVIMMWVGXKVNMXUNVCUBVYTXUNVCVDWUAVXLXUMVEUXOVNVP
            MMVCWVGUXPVOXURXUSUXQUXRVPZWWFUXSUXTVYAVXMUKZVYPWUFVYQWUIVXLVXLVYAV
            XMWSXVCVYEWUHCVXLXVCWYMVJVYDWUGVYCXVCWYMVYDVYCVXMUIZWUGVYCVYAVXMWHV
            YCVXLVXJUYAZUYBWJUYDWKUEWQYOYPAVXPFVDZVXREVDZAXVFVJZVXRDVDZUOVXRUIZ
            NUKZNVXRUIZUOVHZVJZXVGXVHVXTVXTVXRVGZVYCVXRUIZVYCVHZCVXTVIZXVIXVHWV
            AVXTVXTVXQVGZXVOAWVAXVFWVLWEZAXVFWXOWXOVXQVGZXVSXVHWWPVXLVXLVXPVGZX
            WAWWQXVHXWBVYCVXPUIZVYCVHZCVXLVIZXVHXVFXWBXWEVJZAXVFWFVYRXWFIVXPFUG
            WOZIUGWGZVYPXWBVYQXWEVXLVXLVYAVXPWSXWHVYEXWDCVXLXWHVYDXWCVYCVYCVYAV
            XPWHWJWPWKUEWQWMZWNZWWPXWBVJWYEWYEXWAWYKWYKWUJWUJVXLVXLVXOVXPUYCUYE
            UYFZAXWAXVSAWXPXWAXVSXDWYCWXPXWAVXTWXOVXQVGXVSWXOVXTWXOVXQUWJWXOVXT
            VXTVXQUWKUYGXGUYHUYIZVXTVXTVXTLVXQWTWRXVHXVQCVXTXVHWYPVJZXVPVYCVXQU
            IZLUIZVYCXVHVXTVXTVXQXBZWYPXVPXWOUKXVHXVSXWPXWLVXTVXTVXQXKXGZVXTVXT
            VYCLVXQXNUYJXWMWYSXWNVHXWOVYCVHXWMWYSWYTXWNAXUAXVFWYPXUCYBXVHWYPVYC
            WUJVDZWYMUYKZWYTXWNVHZXWMVYCWXOVDXWSXWMVYCVXTWXOXVHWYPWFAWXPXVFWYPW
            YCYBUYLVYCWUJVXLUYMWMXVHXWRXWTWYMXVHXWRXWTXVHXWTXWRWVCUOVXQUIZVHXVH
            NUOWVCXXAANUOVHZXVFANVXLVDZWYHXXBTWYJNUOVXLUYNYAWEAWVDXVFAWVAWVDWVF
            WVKUYOZWEZXVHXXAUOVXOUIZUOXVHVXQWAZXXAXXFUKZXVHXWAXXGXWKWXOWXOVXQUY
            PXGZXXGVXOVXQVFUOVXOVUDZVDXXHVXOVXPUYQUOWUJXXJUOXHUYRUOUOXHUYSUYTUO
            VXQVXOYQVUAXGUOUOXHXHVUBVUCZVUEXWRWYTWVCXWNXXAXWRVYCUOLVYCUOVUFZXPX
            WRVYCUOVXQXXLXPYFYGVUGXVHWYMVJZXWNWYTXXMXWNXWCWYTXXMXXGVXPVXQVFZVYC
            VXPVUDZVDZXWNXWCUKZXVHXXGWYMXXIWEXXNXXMVXPVXOVUHZVRXVHXXPWYMXVHXXOV
            XLVYCXVHXWBXXOVXLUKXWJVXLVXLVXPVUIXGZVUJVUKVYCVXQVXPYQXSZXXMXWCWYTV
            HZVYCNXXMXYAXUENVXPUIZWVEVHXXMXYBUOWVEXVHXYBUOVHZWYMXVHXYBVXLVDWYHX
            YCXVHVXLVXLNVXPXVHXWBVXLVXLVXPXBXWJVXLVXLVXPXKXGAXXCXVFTWEZVULZWYJX
            YBUOVXLUYNYAWEAWVFXVFWYMWXKYBYDXUEXWCXYBWYTWVEVYCNVXPYEZXUGYFYGXVHW
            YMXUHXYAXVHXUIVJXWCVYCWYTXVHWYMXWDXUHXVHXWDCVXLXVHXWBXWEXWIXOZUWSYH
            AXUIXUKXVFXUPUXHYDUXMUXIYLYIVUNUYIYLXWMXWOVYCWYSXWNXWMWVAXWNVXTVDXW
            OVYCUKWYSXWNUKYJXVHWVAWYPXVTWEXVHVXTVXTVYCVXQXWQVUMVXTVXTXWNVYCLYKW
            RYMYNYLUXNVYGXVOXVRVJIVXRDLVXQXVBVXOVXPVXNVUOXWGUXRUXSVYAVXRUKZVYBX
            VOVYFXVRVXTVXTVYAVXRWSXYHVYEXVQCVXTXYHVYDXVPVYCVYCVYAVXRWHWJWPWKRWQ
            YOXVHXVKXVMXVHXVJXXALUIZWVCNXVHXWPWXAXVJXYIUKXWQAWXAXVFWXEWEVXTVXTU
            OLVXQXNWRXVHXXAUOLXXKXPXXEXQXVHXVLXYBLUIZUOXVHXVLNVXQUIZLUIZXYJXVHX
            WPNVXTVDZXVLXYLUKXWQAXYMXVFAVXLVXTNWYQTYCWEVXTVXTNLVXQXNWRXVHXYKXYB
            LXVHXXGXXNNXXOVDXYKXYBUKXXIXXNXVHXXRVRXVHNVXLXXOXYDXXSUYLNVXQVXPYQX
            SXPXRXVHUOWYRUIZXYBVHXYJUOVHXVHXYNNXYBAXYNNUKXVFAXYNWVCNAUOWYRLXUBU
            WOXXDXRWEXVHXYBNXVHXXCXWEXYBNVHZXYDXYGXWDXYOCNVXLXUEXWCXYBVYCNXYFXU
            EVWCYFVUPVUQYIYLXVHXYJUOXYNXYBXVHWVAXYBVXTVDXYJUOUKXYNXYBUKYJXVTXVH
            VXLVXTXYBWYQXYEYCVXTVXTXYBUOLYKWRYMYNYLVURVYNXVNJVXRDEVYIVXRUKZVYKX
            VKVYMXVMXYPVYJXVJNUOVYIVXRWHWIXYPVYLXVLUONVYIVXRWHWJWKUCWLYOYPAWUCX
            VFVJZVXIVXRUKZVXPVXMUKZXDAXYQVJZLVXJUMZVXRUKZVXJVXQUKZXYRXYSXYTVXTV
            XTLWCZWWKXWPYUBYUCXDXYTWVAYUDAWVAXYQWVLWEZVXTVXTLXAXGXYTVXTVXTLXBZW
            XHWWKXYTWVAYUFYUEVXTVXTLXKXGAWUCWXHXVFWXIYHZVXTVXTVXTLVXIVUSWRAXVFX
            WPWUCXWQYRVXTVXTVXTLVXJVXQVUTXSXYTYUAVXIVXRXYTYUALLUMZVXIUMZVXILLVX
            IVVAXYTYUIWDVXTURZVXIUMZVXIXYTYUHYUJVXIAYUHYUJUKXYQAWYRLUMZYUHYUJAW
            YRLLXUBVVBAWVAYULYUJUKWVLVXTVXTLVVCXGVVDWEVVBXYTWXHYUKVXIUKYUGVXTVX
            TVXIVVEXGXRVVFWIXYTYUCVXMVXPUKZXYSXYTWUGXWNUKZCVXTVIZXVDXWCUKZCVXLV
            IZYUCYUMXYTYUNCVXLVIZYUNCWXOVIZYUQYUOXYTYURYUNCWUJVIZYURVJYUSXYTYUT
            YURXYTWWRXXAUKZYUTXYTWWRUOXXAAWUCWWRUOUKXVFWXMYHAXVFXXAUOUKWUCXXKYR
            VVGYUNYVACUOXHVYCUOUKWUGWWRXWNXXAVYCUOVXJYEVYCUOVXQYEVVHVVNVVIVVJYU
            NCWUJVXLVVKVVLXYTYUNYUPCVXLXYTWYMVJZWUGXVDXWNXWCYVBXVDWUGWYMXVDWUGU
            KXYTXVEUXFVVMAXVFWYMXXQWUCXXTVVOVVHUYDXYTYUNCWXOVXTAWXPXYQWYCWEVVPV
            VQXYTWWMVXQVXTXCZYUCYUOXDAWUCWWMXVFWXBYHZXYTXVSYVCAXVFXVSWUCXWLYRVX
            TVXTVXQXEXGCVXTVXJVXQVVRWRXYTVXMVXLXCZVXPVXLXCZYUMYUQXDXYTWWMVXLVXT
            VFYVEYVDWYQVXTVXLVXJVVSYAXYTXWBYVFAXVFXWBWUCXWJYRVXLVXLVXPXEXGCVXLV
            XMVXPVVRWRVVTVXMVXPVWAVWBVWDYPVWEVXSFVEVDVXHVXGXDVYOWUBEFVWFVOVVIAV
            XEVXLUHUIZHUIZVXFVYTYVHVXEUKWUAVYTVXLGUIZYVHVXEBCVXLGHIKPQVWGVYTYVI
            VYSUHUIVXEBCVXLGIPVWHFVYSUHUEVWIVWJVVDVNAYVGOHAYVGVXKUNYSVBUOUPVBZV
            XKUNUOYSVBZYSVBZOAVXKUNXLUIZVDYVGYVJUKAVXKWXRXLUIZYVMAOWXCVDVXKYVNV
            DAOXMWXCSXIXJUOOVWLXGUNWXRXLVWMVWIVWKUNVXKVWNXGAVXKUNUOAVXKWXDVWOUN
            YTVDAVXBVRUOYTVDZAVWPVRVWQAYVLVXKUOYSVBZOYVKUOVXKYSVWRVWSAOYTVDYVOY
            VPOUKAOSVWOVWPOUOVWTYAVXAVXCXPVVFXR $.
        $}
      $}

      $( Lemma for ~ subfacp1 .  By induction, we cut up the set of all
         derangements on ` N + 1 ` according to the ` N ` possible values of
         ` ( f `` 1 ) ` (since ` ( f `` 1 ) =/= 1 ` ), and for each set for
         fixed ` M = ( f `` 1 ) ` , the subset of derangements with
         ` ( f `` M ) = 1 ` has size ` S ( N - 1 ) ` (by ~ subfacp1lem3 ),
         while the subset with ` ( f `` M ) =/= 1 ` has size ` S ( N ) ` (by
         ~ subfacp1lem5 ).  Adding it all up yields the desired equation
         ` N ( S ( N ) + S ( N - 1 ) ) ` for the number of derangements on
         ` N + 1 ` .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      subfacp1lem6 $p |- ( N e. NN ->
        ( S ` ( N + 1 ) ) = ( N x. ( ( S ` N ) + ( S ` ( N - 1 ) ) ) ) ) $=
        ( vg wcel c1 caddc co cfv chash wceq wi vm vz vh cfz crab cmin cmul cn0
        cn cv peano2nn nnnn0d subfacval syl wf1o wne wa cab cfn fzfid derangval
        wral fveq2i syl6eqr wss cuz nnuz syl6eleq eluzfz1 adantr expcom ss2abdv
        weq fveq1 cbvabv 3sstr4g ssabral sylib sylibr fveq2d 3eqtrd eleq1 oveq2
        cc0 csn ax-mp syl6eq eleq2d elsnc rabbidv oveq1d eqeq12d imbi12d imbi2d
        wf oveq1 c0 wn fveq2 id neeq12d neeq1d rabeq0 ffvelrni nn0cnd ex cun wo
        syl5bbr wb unrab ssrab2 ssfi mp2an inrab rgenw mpbir eqtri hashun mp3an
        cin cc nncn ad2antlr ax-1cn a1i sylancl mpbi c2 cop eqid eqeq1d anbi12d
        mpd cbvrabv f1oeq1 cbvralv ralbidv syl5bb a2d f1of syl2im eleq1d rabid2
        ffvelrn elfz1end cz 1z fzsn fvex syl6bb 1m1e0 hash0 rspcv adantld df-ne
        nnnn0 subfacf nnm1nn0 nn0addcld mul02d simplr peano2fzr sylancom imim1d
        3eqtr4a elfzp1 fzfi deranglem eqeltri fzp1disj inelcm sylan2br necon2bi
        addsubd subcl ad2antrr adddird mulid2d exmidne orcom biantru andi bitri
        a1d rabbiia eqtr4i simpr necon3ai adantl imnan cid cdif cres cpr simpll
        nnne0 0p1e1 eqeq2i 0cn addcan2 mp3an23 necon3bbid mpbird elfzp12 biimpa
        ord df-2 oveq1i syl6eleqr ovex subfacp1lem5 subfacp1lem3 oveq12d syl5eq
        eqtr4d oveq2d syl5ibr syld nnind mpcom pncan ) HUIMZHNOPZEQZNLUJZQZNUYD
        UDPZMZLCUEZRQZUYDNUFPZHEQZHNUFPZEQZOPZUGPZHUYPUGPUYCUYEUYHDQZCRQZUYKUYC
        UYDUHMUYEUYRSUYCUYDHUKZULABDEFGUYDIJUMUNUYCUYRUYHUYHFUJZUOZBUJZVUAQZVUC
        UPZBUYHVBZUQZFURZRQZUYSUYCUYHUSMZUYRVUISUYCNUYDUTABUYHDFIVAUNCVUHRKVCVD
        UYCCUYJRUYCUYILCVBZCUYJSUYCCUYILURZVEVUKUYCVUHNVUAQZUYHMZFURCVULUYCVUGV
        UNFUYCNUYHMZVUGUYHUYHVUAWOZVUNUYCUYDNVFQZMZVUOUYCUYDUIVUQUYTVGVHZNUYDVI
        UNZVUBVUPVUFUYHUYHVUAUUAVJVUPVUOVUNUYHUYHNVUAUUEVKUUBVLKUYIVUNLFLFVMZUY
        GVUMUYHNUYFVUAVNZUUCVOVPUYILCVQVRUYILCUUDVSVTWAUYCUYDUYHMZUYKUYQSZUYCUY
        DUIMZVVCUYTUYDUUFVRVVEUYCVVCVVDTZUYTUYCAUJZUYHMZUYGNVVGUDPZMZLCUEZRQZVV
        GNUFPZUYPUGPZSZTZTUYCVUOUYGNSZLCUEZRQZWDUYPUGPZSZTZTUYCUAUJZUYHMZUYGNVW
        CUDPZMZLCUEZRQZVWCNUFPZUYPUGPZSZTZTUYCVWCNOPZUYHMZUYGNVWMUDPZMZLCUEZRQZ
        VWMNUFPZUYPUGPZSZTZTUYCVVFTAUAUYDVVGNSZVVPVWBUYCVXCVVHVUOVVOVWAVVGNUYHW
        BVXCVVLVVSVVNVVTVXCVVKVVRRVXCVVJVVQLCVXCVVJUYGNWEZMVVQVXCVVIVXDUYGVXCVV
        INNUDPZVXDVVGNNUDWCNUUGMVXEVXDSUUHNUUIWFWGWHUYGNNUYFUUJZWIUUKWJVTVXCVVM
        WDUYPUGVXCVVMNNUFPWDVVGNNUFWPUULWGWKWLWMWNAUAVMZVVPVWLUYCVXGVVHVWDVVOVW
        KVVGVWCUYHWBVXGVVLVWHVVNVWJVXGVVKVWGRVXGVVJVWFLCVXGVVIVWEUYGVVGVWCNUDWC
        WHWJVTVXGVVMVWIUYPUGVVGVWCNUFWPWKWLWMWNVVGVWMSZVVPVXBUYCVXHVVHVWNVVOVXA
        VVGVWMUYHWBVXHVVLVWRVVNVWTVXHVVKVWQRVXHVVJVWPLCVXHVVIVWOUYGVVGVWMNUDWCW
        HWJVTVXHVVMVWSUYPUGVVGVWMNUFWPWKWLWMWNVVGUYDSZVVPVVFUYCVXIVVHVVCVVOVVDV
        VGUYDUYHWBVXIVVLUYKVVNUYQVXIVVKUYJRVXIVVJUYILCVXIVVIUYHUYGVVGUYDNUDWCWH
        WJVTVXIVVMUYLUYPUGVVGUYDNUFWPWKWLWMWNUYCVWAVUOUYCWQRQWDVVSVVTUUMUYCVVRW
        QRUYCVVQWRZLCVBZVVRWQSUYCCVXJLURZVEVXKUYCVUHVUMNUPZFURCVXLUYCVUGVXMFUYC
        VUFVXMVUBUYCVUOVUFVXMTVUTVUEVXMBNUYHVUCNSZVUDVUMVUCNVUCNVUAWSVXNWTXAUUN
        UNUUOVLKVXJVXMLFVXJUYGNUPVVAVXMUYGNUUPVVAUYGVUMNVVBXBXIVOVPVXJLCVQVRVVQ
        LCXCVSVTUYCUYPUYCUYPUYCUYMUYOUYCHUHMUYMUHMHUUQUHUHHEABDEFGIJUURZXDUNUYC
        UYNUHMUYOUHMHUUSUHUHUYNEVXOXDUNUUTZXEUVAUVFUWEVWCUIMZUYCVWLVXBUYCVXQVWL
        VXBTUYCVXQUQZVWLVWNVWKTVXBVXRVWNVWDVWKVXRVWNVWDVXRVWNVWCVUQMZVWDVXRVWNU
        QZVWCUIVUQUYCVXQVWNUVBVGVHZVWCNUYDUVCUVDXFUVEVXRVWNVWKVXAVXRVWNVWKVXATV
        WKVXAVXTVWHUYGVWMSZLCUEZRQZOPZVWJVYDOPZSVWHVWJVYDOWPVXTVWRVYEVWTVYFVXTV
        WRVWGVYCXGZRQZVYEVXTVWQVYGRVXTVWQVWFVYBXHZLCUEVYGVXTVWPVYILCVXTVXSVWPVY
        IXJVYAUYGNVWCUVGUNWJVWFVYBLCXKVDVTVWGUSMZVYCUSMZVWGVYCYAZWQSVYHVYESCUSM
        ZVWGCVEVYJCVUHUSKVUJVUHUSMNUYDUVHVUFUYHFUVIWFUVJZVWFLCXLCVWGXMXNVYMVYCC
        VEVYKVYNVYBLCXLCVYCXMXNVYLVWFVYBUQZLCUEZWQVWFVYBLCXOVYPWQSVYOWRZLCVBVYQ
        LCVWEVWMWEZYAZWQSVYQNVWCUVKVYOVYSWQVYBVWFUYGVYRMVYSWQUPUYGVWMVXFWIUYGVW
        EVYRUVLUVMUVNWFXPVYOLCXCXQXRVWGVYCXSXTWGVXTVWTVWINOPZUYPUGPVWJNUYPUGPZO
        PVYFVXTVWSVYTUYPUGVXTVWCNNVXQVWCYBMZUYCVWNVWCYCZYDZNYBMZVXTYEYFZWUFUVOW
        KVXTVWINUYPVXTWUBWUEVWIYBMWUDYEVWCNUVPYGWUFVXTUYPUYCUYPUHMVXQVWNVXPUVQX
        EZUVRVXTWUAVYDVWJOVXTWUAUYPVYDVXTUYPWUGUVSVXTVYDVYBVWMUYFQZNUPZUQZLCUEZ
        RQZVYBWUHNSZUQZLCUEZRQZOPZUYPVYDWUKWUOXGZRQZWUQVYCWURRVYCWUJWUNXHZLCUEW
        URVYBWUTLCVYBWUTXJUYFCMVYBVYBWUIWUMXHZUQWUTWVAVYBWUMWUIXHWVAWUHNUVTWUMW
        UIUWAYHUWBVYBWUIWUMUWCUWDYFUWFWUJWUNLCXKUWGVCWUKUSMZWUOUSMZWUKWUOYAZWQS
        WUSWUQSVYMWUKCVEWVBVYNWUJLCXLCWUKXMXNVYMWUOCVEWVCVYNWUNLCXLCWUOXMXNWVDW
        UJWUNUQZLCUEZWQWUJWUNLCXOWVFWQSWVEWRZLCVBWVGLCWUJWUNWRZTWVGWUIWVHVYBWUN
        WUHNVYBWUMUWHUWIUWJWUJWUNUWKYHXPWVELCXCXQXRWUKWUOXSXTXRVXTWULUYMWUPUYOO
        VXTABCWUKYIUYDUDPZWVIUYFUOZUBUJZUYFQZWVKUPZUBWVIVBZUQZLURDEFUCGUWLWVIVY
        RUWMZUWNNVWMYJVWMNYJUWOXGZWVPVWMHIJKUYCVXQVWNUWPZVXTVWMNNOPZUYDUDPZWVIV
        XTVWMNSZWRZVWMWVTMZVXQWWBUYCVWNVXQWWBVWCWDUPVWCUWQVXQWWAVWCWDWWAVWMWDNO
        PZSZVXQVWCWDSZWWDNVWMUWRUWSVXQWUBWWEWWFXJZWUCWUBWDYBMWUEWWGUWTYEVWCWDNU
        XAUXBUNXIUXCUXDYDVXTWWAWWCVXRVWNWWAWWCXHZVXRVURVWNWWHXJUYCVURVXQVUSVJVW
        MNUYDUXEUNUXFUXGYNYIWVSUYDUDUXHUXIUXJZVWCNOUXKZWVPYKZWUJNUCUJZQZVWMSZVW
        MWWLQZNUPZUQLUCCLUCVMZVYBWWNWUIWWPWWQUYGWWMVWMNUYFWWLVNYLZWWQWUHWWONVWM
        UYFWWLVNZXBYMYOWVQYKWVOWVIWVIVUAUOZVUEBWVIVBZUQLFVVAWVJWWTWVNWXAWVIWVIU
        YFVUAYPWVNVUCUYFQZVUCUPZBWVIVBVVAWXAWVMWXCUBBWVIUBBVMZWVLWXBWVKVUCWVKVU
        CUYFWSWXDWTXAZYQVVAWXCVUEBWVIVVAWXBVUDVUCVUCUYFVUAVNXBZYRYSYMVOUXLVXTAB
        CWUOWVPWVPUYFUOZWVMUBWVPVBZUQZLURDEFUCGWVPVWMHIJKWVRWWIWWJWWKWUNWWNWWON
        SZUQLUCCWWQVYBWWNWUMWXJWWRWWQWUHWWONWWSYLYMYOWXIWVPWVPVUAUOZVUEBWVPVBZU
        QLFVVAWXGWXKWXHWXLWVPWVPUYFVUAYPWXHWXCBWVPVBVVAWXLWVMWXCUBBWVPWXEYQVVAW
        XCVUEBWVPWXFYRYSYMVOUXMUXNUXOUXPUXQWAWLUXRXFYTUXSVKYTUXTUYAYNUYCUYLHUYP
        UGUYCHYBMWUEUYLHSHYCYEHNUYBYGWKWA $.
    $}

    $( A two-term recurrence for the subfactorial.  This theorem allows us to
       forget the combinatorial definition of the derangement number in favor
       of the recursive definition provided by this theorem and ~ subfac0 ,
       ~ subfac1 .  (Contributed by Mario Carneiro, 23-Jan-2015.) $)
    subfacp1 $p |- ( N e. NN ->
      ( S ` ( N + 1 ) ) = ( N x. ( ( S ` N ) + ( S ` ( N - 1 ) ) ) ) ) $=
      ( vg vz c1 co cv wf1o cfv wne wral wa weq caddc cfz cab f1oeq1 id neeq12d
      fveq2 cbvralv fveq1 neeq1d ralbidv syl5bb anbi12d cbvabv subfacp1lem6 ) A
      BLGLUAMUBMZUPJNZOZKNZUQPZUSQZKUPRZSZJUCCDEFGHIVCUPUPENZOZBNZVDPZVFQZBUPRZ
      SJEJETZURVEVBVIUPUPUQVDUDVBVFUQPZVFQZBUPRVJVIVAVLKBUPKBTZUTVKUSVFUSVFUQUG
      VMUEUFUHVJVLVHBUPVJVKVGVFVFUQVDUIUJUKULUMUNUO $.

    $( A closed-form expression for the subfactorial.  (Contributed by Mario
       Carneiro, 23-Jan-2015.) $)
    subfacval2 $p |- ( N e. NN0 -> ( S ` N ) =
      ( ( ! ` N ) x. sum_ k e. ( 0 ... N ) ( ( -u 1 ^ k ) / ( ! ` k ) ) ) ) $=
      ( wcel cfv cfa cc0 cfz co c1 cmul wceq caddc vm cn0 cneg cv cexp cdiv csu
      wa fveq2 subfac0 syl6eq oveq2 sumeq1d oveq12d eqeq12d oveq1 0p1e1 subfac1
      fac0 fveq2d oveq2d anbi12d cz cc 0z ax-1cn neg1cn ax-mp div1i fsum1 mp2an
      fac1 exp0 oveq2i 1t1e1 eqtr2i wtru nn0uz 1e0p1 exp1 renegcli reexpcl mpan
      cr 1re faccl nndivred recnd adantl 0nn0 pm3.2i negidi fsump1i trud simpri
      a1i mul01i wi simpr oveq12 ancoms cmin nn0p1nn subfacp1 syl nn0cn sylancl
      cn pncan eqtrd peano2nn0 nncnd fzfid elfznn0 fsumcl sylancr nnne0d divcld
      expcl adddid id syl6eleq fsump1 facp1 mulcomd oveq1d nn0cnd 3eqtrd div12d
      cuz mulassd divcan3d divcan2d mulcld negsub eqtr3d 3eqtr4d addassd add32d
      expp1 eqcomd mulid1d adddird syl5ibr jcad nn0ind simpld ) HUBKHDLZHMLZNHO
      PZQUCZFUDZUEPZUULMLZUFPZFUGZRPZSZHQTPZDLZUUSMLZNUUSOPZUUOFUGZRPZSZAUDZDLZ
      UVFMLZNUVFOPZUUOFUGZRPZSZUVFQTPZDLZUVMMLZNUVMOPZUUOFUGZRPZSZUHQQNNOPZUUOF
      UGZRPZSZNQNQOPZUUOFUGZRPZSZUHUAUDZDLZUWHMLZNUWHOPZUUOFUGZRPZSZUWHQTPZDLZU
      WOMLZNUWOOPZUUOFUGZRPZSZUHZUXAUWOQTPZDLZUXCMLZNUXCOPZUUOFUGZRPZSZUHUURUVE
      UHAUAHUVFNSZUVLUWCUVSUWGUXJUVGQUVKUWBUXJUVGNDLQUVFNDUIABCDEGIJUJUKUXJUVHQ
      UVJUWARUXJUVHNMLZQUVFNMUIUSUKUXJUVIUVTUUOFUVFNNOULUMUNUOUXJUVNNUVRUWFUXJU
      VNQDLNUXJUVMQDUXJUVMNQTPQUVFNQTUPUQUKZUTABCDEGIJURUKUXJUVOQUVQUWERUXJUVOQ
      MLZQUXJUVMQMUXLUTVLUKUXJUVPUWDUUOFUXJUVMQNOUXLVAUMUNUOVBUVFUWHSZUVLUWNUVS
      UXAUXNUVGUWIUVKUWMUVFUWHDUIUXNUVHUWJUVJUWLRUVFUWHMUIUXNUVIUWKUUOFUVFUWHNO
      ULUMUNUOUXNUVNUWPUVRUWTUXNUVMUWODUVFUWHQTUPZUTUXNUVOUWQUVQUWSRUXNUVMUWOMU
      XOUTUXNUVPUWRUUOFUXNUVMUWONOUXOVAUMUNUOVBUVFUWOSZUVLUXAUVSUXIUXPUVGUWPUVK
      UWTUVFUWODUIUXPUVHUWQUVJUWSRUVFUWOMUIUXPUVIUWRUUOFUVFUWONOULUMUNUOUXPUVNU
      XDUVRUXHUXPUVMUXCDUVFUWOQTUPZUTUXPUVOUXEUVQUXGRUXPUVMUXCMUXQUTUXPUVPUXFUU
      OFUXPUVMUXCNOUXQVAUMUNUOVBUVFHSZUVLUURUVSUVEUXRUVGUUHUVKUUQUVFHDUIUXRUVHU
      UIUVJUUPRUVFHMUIUXRUVIUUJUUOFUVFHNOULUMUNUOUXRUVNUUTUVRUVDUXRUVMUUSDUVFHQ
      TUPZUTUXRUVOUVAUVQUVCRUXRUVMUUSMUXSUTUXRUVPUVBUUOFUXRUVMUUSNOUXSVAUMUNUOV
      BUWCUWGUWBQQRPQUWAQQRNVCKQVDKZUWAQSZVEVFUUOQFNUULNSZUUOQQUFPQUYBUUMQUUNQU
      FUYBUUMUUKNUEPZQUULNUUKUEULUUKVDKZUYCQSVGUUKVMVHUKUYBUUNUXKQUULNMUIUSUKUN
      QVFVIUKVJVKZVNVOVPUWFQNRPNUWENQRQUBKZUWENSZUYFUYGUHVQUUOUUKQNFNNQUBVRVSUU
      LQSZUUOUUKQUFPUUKUYHUUMUUKUUNQUFUYHUUMUUKQUEPZUUKUULQUUKUEULUYDUYIUUKSVGU
      UKVTVHUKUYHUUNUXMQUULQMUIVLUKUNUUKVGVIUKUULUBKZUUOVDKZVQUYJUUOUYJUUMUUNUU
      KWDKUYJUUMWDKQWEWAUUKUULWBWCUULWFWGWHZWINUBKZUYAUHVQUYMUYAWJUYEWKWPQUUKTP
      NSVQQVFWLWPWMWNWOVNQVFWQVPWKUWHUBKZUXBUXAUXIUXBUXAWRUYNUWNUXAWSWPUXBUXIUY
      NUWOUWPUWITPZRPZUWOUWTUWMTPZRPZSUXBUYOUYQUWORUXAUWNUYOUYQSUWPUWTUWIUWMTWT
      XAVAUYNUXDUYPUXHUYRUYNUXDUWOUWPUWOQXBPZDLZTPZRPZUYPUYNUWOXHKUXDVUBSUWHXCZ
      ABCDEGUWOIJXDXEUYNVUAUYOUWORUYNUYTUWIUWPTUYNUYSUWHDUYNUWHVDKUXTUYSUWHSUWH
      XFVFUWHQXIXGUTVAVAXJUYNUXEUWSUUKUXCUEPZUXEUFPZTPZRPZUWOUWJUXCRPZUWLRPZUUK
      UWOUEPZTPZRPZUXHUYRUYNVUGUXEUWSRPZUXEVUERPZTPUWOVUHRPZUWLRPZVUJUXCRPZTPZV
      UDTPZVULUYNUXEUWSVUEUYNUXEUYNUXCUBKZUXEXHKUYNUWOUBKZVUTUWHXKZUWOXKXEZUXCW
      FXEZXLZUYNUWRUUOFUYNNUWOXMUYNUULUWRKZUHUYJUYKVVFUYJUYNUULUWOXNWIUYLXEZXOU
      YNVUDUXEUYNUYDVUTVUDVDKVGVVCUUKUXCXSXPZVVEUYNUXEVVDXQZXRXTUYNVUMVURVUNVUD
      TUYNVUMUXEUWLVUJUWQUFPZTPZRPUXEUWLRPZUXEVVJRPZTPVURUYNUWSVVKUXERUYNUUOVVJ
      FNUWHUYNUWHUBNYJLZUYNYAVRYBVVGUULUWOSUUMVUJUUNUWQUFUULUWOUUKUEULUULUWOMUI
      UNYCZVAUYNUXEUWLVVJVVEUYNUWKUUOFUYNNUWHXMUYNUULUWKKZUHUYJUYKVVPUYJUYNUULU
      WHXNWIUYLXEXOZUYNVUJUWQUYNUYDVVAVUJVDKVGVVBUUKUWOXSXPZUYNUWQUYNVVAUWQXHKV
      VBUWOWFXEZXLZUYNUWQVVSXQZXRZXTUYNVVLVUPVVMVUQTUYNUXEVUOUWLRUYNUXEUWQUXCRP
      ZUWOUWJRPZUXCRPVUOUYNVVAUXEVWCSVVBUWOYDXEZUYNUWQVWDUXCRUYNUWQUWJUWORPZVWD
      UWHYDZUYNUWJUWOUYNUWJUWHWFXLZUYNUWOVUCXLZYEXJYFUYNUWOUWJUXCVWIVWHUYNUXCVV
      CYGZYKYHYFUYNVVMVUJUXEUWQUFPZRPVUQUYNUXEVUJUWQVVEVVRVVTVWAYIUYNVWKUXCVUJR
      UYNVWKVWCUWQUFPUXCUYNUXEVWCUWQUFVWEYFUYNUXCUWQVWJVVTVWAYLXJVAXJUNYHUYNVUD
      UXEVVHVVEVVIYMUNUYNVUPVUQVUDTPZTPUWOVUIRPZUWOVUJRPZTPVUSVULUYNVUPVWMVWLVW
      NTUYNUWOVUHUWLVWIUYNUWJUXCVWHVWJYNZVVQYKUYNVUQVUJUUKRPZTPZVUJUWORPZVWLVWN
      UYNVUJUXCUUKTPZRPVWQVWRUYNVUJUXCUUKVVRVWJUYDUYNVGWPXTUYNVWSUWOVUJRUYNVWSU
      XCQXBPZUWOUYNUXCVDKUXTVWSVWTSVWJVFUXCQYOXGUYNUWOVDKUXTVWTUWOSVWIVFUWOQXIX
      GXJVAYPUYNVUDVWPVUQTUYNUYDVVAVUDVWPSVGVVBUUKUWOYTXPVAUYNUWOVUJVWIVVRYEYQU
      NUYNVUPVUQVUDUYNVUOUWLUYNUWOVUHVWIVWOYNVVQYNUYNVUJUXCVVRVWJYNVVHYRUYNUWOV
      UIVUJVWIUYNVUHUWLVWOVVQYNVVRXTYQYHUYNUXGVUFUXERUYNUUOVUEFNUWOUYNUWOUBVVNV
      VBVRYBUYNUULUXFKZUHUYJUYKVXAUYJUYNUULUXCXNWIUYLXEUULUXCSUUMVUDUUNUXEUFUUL
      UXCUUKUEULUULUXCMUIUNYCVAUYNUYQVUKUWORUYNUWQUWLRPZVUJTPZUWMTPVXBUWMTPZVUJ
      TPUYQVUKUYNVXBVUJUWMUYNUWQUWLVVTVVQYNVVRUYNUWJUWLVWHVVQYNYSUYNUWTVXCUWMTU
      YNUWTUWQVVKRPVXBUWQVVJRPZTPVXCUYNUWSVVKUWQRVVOVAUYNUWQUWLVVJVVTVVQVWBXTUY
      NVXEVUJVXBTUYNVUJUWQVVRVVTVWAYMVAYHYFUYNVUIVXDVUJTUYNVUIUWQUWJTPZUWLRPVXD
      UYNVUHVXFUWLRUYNVUHVWFUWJQRPZTPVXFUYNUWJUWOQVWHVWIUXTUYNVFWPXTUYNVWFUWQVX
      GUWJTUYNUWQVWFVWGUUAUYNUWJVWHUUBUNXJYFUYNUWQUWJUWLVVTVWHVVQUUCXJYFYQVAYQU
      OUUDUUEUUFUUG $.

    $( The subfactorial converges rapidly to ` N ! / _e ` .  (Contributed by
       Mario Carneiro, 23-Jan-2015.) $)
    subfaclim $p |- ( N e. NN ->
      ( abs ` ( ( ( ! ` N ) / _e ) - ( S ` N ) ) ) < ( 1 / N ) ) $=
      ( vk wcel cfv cdiv co c1 caddc cmul cn0 syl cc0 cn cfa cmin cabs cc nnnn0
      ceu faccl nncnd wne ere recni epos gt0ne0ii divcl mp3an23 ffvelrni nn0cnd
      subfacf subcld abscld peano2nn peano2nnd nnred nnmulcld nndivred cuz cneg
      nnrecre cv cexp csu cle wbr cmpt eqid neg1cn a1i ax-1cn absnegi abs1 1le1
      eqtri eqbrtri eftlub wa wceq nnnn0d eluznn0 eftval sumeq2dv fveq2d oveq1i
      sylan cz nnzd 1exp syl5eq oveq1d recnd mulid2d eqtrd 3brtr3d cr clt eftcl
      wb mpan cseq cli cdm eftlcvg sylancr isumcl nngt0d lemul2 syl112anc mpbid
      subfacval2 nncn pncan sylancl oveq2d sumeq1d eqtr4d divrec ce df-e oveq2i
      cfz efneg ax-mp adantl 3eqtrd mulcld nnne0d adddird nnre nngt0 jca fsumcl
      efval 3eqtr2i nn0uz mp2an isumsplit elfznn0 adddid subaddd mpbird absmuld
      0nn0 fzfid nn0ge0d absidd mulassd eqtr2d divcan5d divassd 3eqtr3d 3brtr4d
      facp1 nnmulcl mpancom ltp1d mulcomd oveq12d addassd breqtrrd 1re syl22anc
      lt2mul2div lelttrd ) GUAKZGUBLZUGMNZGDLZUCNZUDLZGOPNZOPNZUVTUVTQNZMNZOGMN
      ZUVNUVRUVNUVPUVQUVNUVOUEKZUVPUEKZUVNUVOUVNGRKZUVOUAKGUFZGUHSZUIZUWEUGUEKZ
      UGTUJZUWFUGUKULZUGUKUMUNZUVOUGUOUPSZUVNUVQUVNUWGUVQRKUWHRRGDABCDEFHIUSUQS
      URZUTVAUVNUWAUWBUVNUWAUVNUVTGVBZVCZVDZUVNUVTUVTUWQUWQVEZVFGVIUVNUVOUVTVGL
      ZOVHZJVJZVKNUXCUBLMNZJVLZUDLZQNZUVOUWAUVTUBLZUVTQNZMNZQNZUVSUWCVMUVNUXFUX
      JVMVNZUXGUXKVMVNZUVNUXAUXCFRUXBFVJZVKNUXNUBLZMNVOZLZJVLZUDLUXBUDLZUVTVKNZ
      UXJQNZUXFUXJVMUVNUXBJFUXPFRUXSUXNVKNUXOMNVOZFRUXTUXHMNOUWAMNUXNVKNQNVOZUV
      TUXPVPZUYBVPUYCVPUWQUXBUEKZUVNVQVRUXSOVMVNUVNUXSOOVMUXSOUDLOOVSVTWAWCZWBW
      DVRWEUVNUXRUXEUDUVNUXAUXQUXDJUVNUXCUXAKZWFZUXCRKZUXQUXDWGZUVNUVTRKZUYGUYI
      UVNUVTUWQWHZUXCUVTWIWNZUXBFUXPUXCUYDWJZSZWKWLUVNUYAOUXJQNUXJUVNUXTOUXJQUV
      NUXTOUVTVKNZOUXSOUVTVKUYFWMUVNUVTWOKUYPOWGUVNUVTUWQWPZUVTWQSWRWSUVNUXJUVN
      UXJUVNUWAUXIUWSUVNUXHUVTUVNUYKUXHUAKUYLUVTUHSUWQVEZVFZWTXAXBXCUVNUXFXDKUX
      JXDKUVOXDKTUVOXEVNUXLUXMXGUVNUXEUVNUXDJUXPUVTUXAUXAVPZUYQUYOUYHUYIUXDUEKZ
      UYMUYEUYIVUAVQUXBUXCXFZXHZSUVNUYEUYKPUXPUVTXIXJXKZKVQUYLUXBFUXPUVTUYDXLXM
      XNZVAUYSUVNUVOUWIVDZUVNUVOUWIXOUXFUXJUVOXPXQXRUVNUVSUVOUXEQNZUDLUVOUDLZUX
      FQNUXGUVNUVRVUGUDUVNUVRVUGWGUVQVUGPNZUVPWGUVNVUIUVOTUVTOUCNZYJNZUXDJVLZQN
      ZVUGPNZUVPUVNUVQVUMVUGPUVNUVQUVOTGYJNZUXDJVLZQNZVUMUVNUWGUVQVUQWGUWHABCDE
      JFGHIXSSUVNVULVUPUVOQUVNVUKVUOUXDJUVNVUJGTYJUVNGUEKOUEKZVUJGWGGXTZVSGOYAY
      BYCYDYCYEWSUVNUVPUVOOUGMNZQNZUVOVULUXEPNZQNVUNUVNUWEUVPVVAWGZUWJUWEUWKUWL
      VVCUWMUWNUVOUGYFUPSUVNVUTVVBUVOQUVNVUTRUXDJVLZVVBVUTOOYGLZMNZUXBYGLZVVDUG
      VVEOMYHYIVURVVGVVFWGVSOYKYLUYEVVGVVDWGVQUXBJUUBYLUUCUVNUXDJUXPTUVTUXARUUD
      UYTUYLUYIUYJUVNUYNYMUYIVUAUVNVUCYMPUXPTXIVUDKZUVNUYETRKVVHVQUULUXBFUXPTUY
      DXLUUEVRUUFWRYCUVNUVOVULUXEUWJUVNVUKUXDJUVNTVUJUUMUVNUXCVUKKZWFUYEUYIVUAV
      QVVIUYIUVNUXCVUJUUGYMVUBXMUUAVUEUUHYNYEUVNUVPUVQVUGUWOUWPUVNUVOUXEUWJVUEY
      OUUIUUJWLUVNUVOUXEUWJVUEUUKUVNVUHUVOUXFQUVNUVOVUFUVNUVOUVNUVOUWIWHUUNUUOW
      SYNUVNUVOUWAQNZUVOUWBQNZMNVVJUXIMNUWCUXKUVNVVKUXIVVJMUVNUXIUVOUVTQNZUVTQN
      VVKUVNUXHVVLUVTQUVNUWGUXHVVLWGUWHGUVBSWSUVNUVOUVTUVTUWJUVNUVTUWQUIZVVMUUP
      UUQYCUVNUWAUWBUVOUVNUWAUWRUIZUVNUWBUWTUIZUWJUVNUWBUWTYPUVNUVOUWIYPUURUVNU
      VOUWAUXIUWJVVNUVNUXIUYRUIUVNUXIUYRYPUUSUUTUVAUVNUWAGQNZOUWBQNZXEVNZUWCUWD
      XEVNZUVNVVPVVPOPNZVVQXEUVNVVPUVNVVPUWAUAKUVNVVPUAKUWRUWAGUVCUVDVDUVEUVNVV
      QUWBGUVTQNZOUVTQNZPNZVVTUVNUWBVVOXAUVNGOUVTVUSVURUVNVSVRZVVMYQUVNVWCUVTGQ
      NZUVTPNZVVTUVNVWAVWEVWBUVTPUVNGUVTVUSVVMUVFUVNUVTVVMXAUVGUVNVVTVWEOGQNZPN
      ZOPNVWEGPNZOPNVWFUVNVVPVWHOPUVNUVTOGVVMVWDVUSYQWSUVNVWHVWIOPUVNVWGGVWEPUV
      NGVUSXAYCWSUVNVWEGOUVNUVTGVVMVUSYOVUSVWDUVHYNYEYNUVIUVNUWAXDKGXDKZTGXEVNZ
      WFOXDKZUWBXDKZTUWBXEVNZWFZVVRVVSXGUWSUVNVWJVWKGYRGYSYTVWLUVNUVJVRUVNUWBUA
      KZVWOUWTVWPVWMVWNUWBYRUWBYSYTSUWAGOUWBUVLUVKXRUVM $.

    $( Another closed form expression for the subfactorial.  The expression
       ` |_ `` ( x + 1 / 2 ) ` is a way of saying "rounded to the nearest
       integer".  (Contributed by Mario Carneiro, 23-Jan-2015.) $)
    subfacval3 $p |- ( N e. NN -> ( S ` N ) =
      ( |_ ` ( ( ( ! ` N ) / _e ) + ( 1 / 2 ) ) ) ) $=
      ( wcel cfv ceu co c1 c2 caddc wbr clt cr cc0 cn cfa cdiv cfl wceq cle cn0
      nnnn0 subfacf ffvelrni syl nn0zd zred crp faccl epr rerpdivcl sylancl 1re
      nnred rehalfcli readdcl cmin cabs wa wo elnn1uz2 fveq2 fac1 syl6eq oveq1d
      subfac1 oveq12d rpreccl ax-mp rpre recni subid1i fveq2d rpge0 absid mp2an
      cuz c3 egt2lt3 simpli 2re 2pos epos ltrecii mpbi syl6eqbr eluz2b2 simplbi
      ere cc resubcld recnd abscld nnrecred a1i subfaclim eluzle wb nngt0 lerec
      nnre mpanl12 syl2anc mpbid ltletrd sylbi absdifltd simpld ltsubaddd ltled
      jaoi simprd ltadd1dd addassd ax-1cn 2halves oveq2i breqtrd flbi mpbir2and
      cz eqcomd ) GUAJZGUBKZLUCMZNOUCMZPMZUDKZGDKZYIYNYOUEZYOYMUFQZYMYONPMZRQZY
      IYOYMYIYOYIYOYIGUGJZYOUGJGUHZUGUGGDABCDEFHIUIUJUKULZUMZYIYKSJZYLSJZYMSJZY
      IYJSJLUNJZUUDYIYJYIYTYJUAJUUAGUOUKUTUPYJLUQURZNUSVAZYKYLVBURZYIYOYLVCMYKR
      QZYOYMRQYIUUKYKYOYLPMZRQZYIYKYOVCMZVDKZYLRQZUUKUUMVEYIGNUEZGOWCKJZVFUUPGV
      GUUQUUPUURUUQUUONLUCMZYLRUUQUUOUUSVDKZUUSUUQUUNUUSVDUUQUUNUUSTVCMUUSUUQYK
      UUSYOTVCUUQYJNLUCUUQYJNUBKNGNUBVHVIVJVKUUQYONDKTGNDVHABCDEFHIVLVJVMUUSUUS
      UUSUNJZUUSSJZUUGUVAUPLVNVOZUUSVPVOZVQVRVJVSUVBTUUSUFQZUUTUUSUEUVDUVAUVEUV
      CUUSVTVOUUSWAWBVJOLRQZUUSYLRQUVFLWDRQWEWFOLWGWOWHWIWJWKWLUURUUONGUCMZYLUU
      RUUNUURYIUUNWPJUURYINGRQGWMWNZYIUUNYIYKYOUUHUUCWQWRUKWSUURGUVHWTUUEUURUUI
      XAUURYIUUOUVGRQUVHABCDEFGHIXBUKUUROGUFQZUVGYLUFQZOGXCUURYIUVIUVJXDZUVHYIG
      SJZTGRQZUVKGXGGXEOSJTORQUVLUVMVEUVKWGWHOGXFXHXIUKXJXKXQXLYIYKYOYLUUHUUCUU
      EYIUUIXAZXMXJZXNYIYOYLYKUUCUVNUUHXOXJXPYIYMUULYLPMZYRRYIYKUULYLUUHYIYOSJU
      UEUULSJUUCUUIYOYLVBURUVNYIUUKUUMUVOXRXSYIUVPYOYLYLPMZPMYRYIYOYLYLYIYOUUCW
      RYIYLUVNWRZUVRXTUVQNYOPNWPJUVQNUEYANYBVOYCVJYDYIUUFYOYGJYPYQYSVEXDUUJUUBY
      MYOYEXIYFYH $.
  $}

  ${
    $d f m x y A $.  $d m n x y D $.
    derangfmla.d $e |- D = ( x e. Fin |-> ( # ` { f | ( f : x -1-1-onto-> x /\
      A. y e. x ( f ` y ) =/= y ) } ) ) $.
    $( The derangements formula, which expresses the number of derangements of
       a finite nonempty set in terms of the factorial.  The expression
       ` |_ `` ( x + 1 / 2 ) ` is a way of saying "rounded to the nearest
       integer".  (Contributed by Mario Carneiro, 23-Jan-2015.) $)
    derangfmla $p |- ( ( A e. Fin /\ A =/= (/) ) ->
      ( D ` A ) = ( |_ ` ( ( ( ! ` ( # ` A ) ) / _e ) + ( 1 / 2 ) ) ) ) $=
      ( vn vm cfn wcel c0 wne cfv cn0 c1 cv cfz co cdiv wceq chash cmpt cfa ceu
      wa c2 caddc cfl oveq2 fveq2d cbvmptv derangen2 adantr cn hashnncl biimpar
      subfacval3 syl eqtrd ) CIJZCKLZUEZCDMZCUAMZGNOGPZQRZDMZUBZMZVDUCMUDSROUFS
      RUGRUHMZUTVCVITVAABCDVHEHFGHNVGOHPZQRZDMVEVKTVFVLDVEVKOQUIUJUKZULUMVBVDUN
      JZVIVJTUTVNVACUOUPABDVHEHVDFVMUQURUS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      The Erd&#337;s-Szekeres theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d y F $.  $d y O $.  $d x S $.  $d y X $.
    erdszelem1.1 $e |- S = { y e. ~P ( 1 ... A ) | ( ( F |` y )
        Isom < , O ( y , ( F " y ) ) /\ A e. y ) } $.
    $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
    erdszelem1 $p |- ( X e. S <-> ( X C_ ( 1 ... A )
        /\ ( F |` X ) Isom < , O ( X , ( F " X ) ) /\ A e. X ) ) $=
      ( c1 cfz co cpw wcel cima clt cres wiso wa wceq wb syl wss w3a ovex elpw2
      anbi1i cv reseq2 isoeq1 isoeq4 imaeq2 isoeq5 3bitrd anbi12d elrab2 3anass
      eleq2 3bitr4i ) FHBIJZKZLZFDFMZNEDFOZPZBFLZQZQFURUAZVEQFCLVFVCVDUBUTVFVEF
      URHBIUCUDUEAUFZDVGMZNEDVGOZPZBVGLZQVEAFUSCVGFRZVJVCVKVDVLVJVGVHNEVBPZFVHN
      EVBPZVCVLVIVBRVJVMSVGFDUGVGVHNEVBVIUHTVGVHFNEVBUIVLVHVARVNVCSVGFDUJFVHVAN
      EVBUKTULVGFBUPUMGUNVFVCVDUOUQ $.

    $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
    erdszelem2 $p |- ( ( # " S ) e. Fin /\ ( # " S ) C_ NN ) $=
      ( vx chash cima cfn wcel cn wss cres c1 cv clt wiso mp2an cvv wfo cfz cpw
      co fzfi pwfi mpbi wa crab ssrab2 eqsstri ssfi wfun cdm cn0 cpnf csn hashf
      cun ffun ax-mp ssv fdmi sseqtr4i fores fofi cfv wral funimass4 erdszelem1
      wf wb w3a c0 wne 3ad2ant3 simp1 sylancr hashnncl syl mpbird sylbi mprgbir
      ne0i pm3.2i ) HCIZJKZWFLMZCJKZCWFHCNZUAZWGOBUBUDZUCZJKZCWMMWIWLJKZWNOBUEZ
      WLUFUGCAPZDWQIQEDWQNRBWQKUHZAWMUIWMFWRAWMUJUKWMCULSHUMZCHUNZMZWKTUOUPUQUS
      ZHVKWSURTXBHUTVAZCTWTCVBTXBHURVCVDZCHVESCWFWJVFSWHGPZHVGLKZGCWSXAWHXFGCVH
      VLXCXDGCLHVISXECKXEWLMZXEDXEIQEDXENRZBXEKZVMZXFABCDEXEFVJXJXFXEVNVOZXIXGX
      KXHXEBWDVPXJXEJKZXFXKVLXJWOXGXLWPXGXHXIVQWLXEULVRXEVSVTWAWBWCWE $.
  $}

  ${
    $d f w x y z B $.  $d f m n s w x y z F $.  $d n s x y I $.  $d f s z K $.
    $d f s w x y z A $.  $d n s x y J $.  $d f s w x y z O $.  $d m s x y R $.
    $d a b m n s w x y z N $.  $d a b f m n s w x y z ph $.  $d m s x y S $.
    $d a b m s w z T $.
    erdsze.n $e |- ( ph -> N e. NN ) $.
    erdsze.f $e |- ( ph -> F : ( 1 ... N ) -1-1-> RR ) $.
    ${
      erdszelem.k $e |- K = ( x e. ( 1 ... N ) |->
        sup ( ( # " { y e. ~P ( 1 ... x ) | ( ( F |` y )
          Isom < , O ( y , ( F " y ) ) /\ x e. y ) } ) , RR , < ) ) $.
      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem3 $p |- ( A e. ( 1 ... N ) -> ( K ` A ) =
        sup ( ( # " { y e. ~P ( 1 ... A ) | ( ( F |` y )
          Isom < , O ( y , ( F " y ) ) /\ A e. y ) } ) , RR , < ) ) $=
        ( chash cv cima clt wcel c1 cfz co cr cres wiso wa crab csup wceq oveq2
        cpw pweqd eleq1 anbi2d rabeqbidv imaeq2d supeq1d ltso supex fvmpt ) BDL
        CMZEURNOHEURUAUBZBMZURPZUCZCQUTRSZUHZUDZNZTOUELUSDURPZUCZCQDRSZUHZUDZNZ
        TOUEQGRSFUTDUFZTVFVLOVMVEVKLVMVBVHCVDVJVMVCVIUTDQRUGUIVMVAVGUSUTDURUJUK
        ULUMUNKTVLOUOUPUQ $.

      erdszelem.o $e |- O Or RR $.
      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem4 $p |- ( ( ph /\ A e. ( 1 ... N ) ) -> { A } e.
        { y e. ~P ( 1 ... A ) | ( ( F |` y )
          Isom < , O ( y , ( F " y ) ) /\ A e. y ) } ) $=
        ( c1 wcel wa wss clt adantl wbr cr cfz co csn cima cres wiso cv crab cn
        cpw elfznn elfz1end sylib snssd cfv wi wb elsni breqan12d cuz fzssuz cz
        wral uzssz zssre sstri simpr adantr sseldi pm2.21d sylbid ralrimivva wf
        ltnrd wf1 f1f syl wor ltso soss mp2 soisores mpanl12 syl2anc snidg eqid
        mpbird erdszelem1 syl3anbrc ) ADMGUAUBZNZOZDUCZMDUAUBZPWMEWMUDQHEWMUEUF
        ZDWMNZWMCUGZEWQUDQHEWQUEUFDWQNOCWNUJUHZNWLDWNWLDUINZDWNNWKWSADGUKRDULUM
        UNWLWOBUGZWQQSZWTEUOWQEUOHSZUPZCWMVCBWMVCZWLXCBCWMWMWLWTWMNZWQWMNZOZOZX
        ADDQSZXBXGXAXIUQWLXEXFWTDWQDQWTDURWQDURUSRXHXIXBXHDXHWJTDWJMUTUOZTMGVAX
        JVBTMVDVEVFVFZWLWKXGAWKVGZVHVIVNVJVKVLWLWJTEVMZWMWJPZWOXDUQZAXMWKAWJTEV
        OXMJWJTEVPVQVHWLDWJXLUNWJQVRZTHVRXMXNOXOWJTPTQVRXPXKVSWJTQVTWALBCWMWJTQ
        HEWBWCWDWGWKWPADWJWERCDWREHWMWRWFWHWI $.

      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem5 $p |- ( ( ph /\ A e. ( 1 ... N ) ) -> ( K ` A ) e. ( # "
        { y e. ~P ( 1 ... A ) | ( ( F |` y )
          Isom < , O ( y , ( F " y ) ) /\ A e. y ) } ) ) $=
        ( c1 cfz co wcel chash clt cr c0 wa cfv cv cima cres wiso cpw crab csup
        wceq erdszelem3 adantl wne cdm cin csn cvv snex cn0 cpnf cun hashf fdmi
        eleqtrri erdszelem4 inelcm sylancr imadisj necon3bii sylibr cfn cn eqid
        wss erdszelem2 simpli simpri nnssre sstri wor ltso fisupcl mpan mp3an13
        w3a syl eqeltrd ) ADMGNOPZUAZDFUBZQCUCZEWKUDRHEWKUEUFDWKPUACMDNOUGUHZUD
        ZSRUIZWMWHWJWNUJAABCDEFGHIJKUKULWIWMTUMZWNWMPZWIQUNZWLUOZTUMZWOWIDUPZWQ
        PWTWLPWSWTUQWQDURUQUSUTUPVAQVBVCVDABCDEFGHIJKLVEWTWQWLVFVGWMTWRTQWLVHVI
        VJWMVKPZWOWMSVNZWPXAWMVLVNZCDWLEHWLVMVOZVPWMVLSXAXCXDVQVRVSSRVTXAWOXBWE
        WPWASWMRWBWCWDWFWG $.

      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem6 $p |- ( ph -> K : ( 1 ... N ) --> NN ) $=
        ( c1 cfz co cv cima clt wcel wa cn vz chash cres wiso cpw crab csup cvv
        cr ltso supex a1i cmpt wceq cfv cfn erdszelem2 simpri erdszelem5 sseldi
        wss eqid fmpt2d ) ABUALFMNZUBCOZDVEPQGDVEUCUDZBOZVERSCLVGMNUEUFPZUIQUGZ
        TEUHVIUHRAVGVDRSUIVHQUJUKULEBVDVIUMUNAJULAUAOZVDRSUBVFVJVERSCLVJMNUEUFZ
        PZTVJEUOVLUPRVLTVACVJVKDGVKVBUQURABCVJDEFGHIJKUSUTVC $.

      erdszelem.a $e |- ( ph -> A e. ( 1 ... N ) ) $.
      ${
        erdszelem7.r $e |- ( ph -> R e. NN ) $.
        erdszelem7.m $e |- ( ph -> -. ( K ` A ) e. ( 1 ... ( R - 1 ) ) ) $.
        $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro,
           22-Jan-2015.) $)
        erdszelem7 $p |- ( ph -> E. s e. ~P ( 1 ... N )
          ( R <_ ( # ` s ) /\ ( F |` s ) Isom < , O ( s , ( F " s ) ) ) ) $=
          ( chash wcel c1 cv cfv wceq cima clt cres wiso wa cfz co cpw crab cle
          wrex wbr wfun cvv cn0 cpnf csn wf hashf ffun ax-mp erdszelem5 fvelima
          cun mpdan sylancr wss w3a wi eqid erdszelem1 simprl1 cuz elfzuz3 3syl
          fzss2 adantr sstrd elpw sylibr wn cmin cz wb erdszelem6 ffvelrnd nnuz
          vex cn syl6eleq peano2zm elfz5 syl2anc nnltlem1 bitr4d mtbid nnred cr
          nnz cfn erdszelem2 simpri nnssre sseldi lenltd mpbird simprr breqtrrd
          sstri simprl2 jca32 expr sylan2b expimpd reximdv2 mpd ) AJUAZRUBZDGUB
          ZUCZJCUAZFYDUDUEIFYDUFUGDYDSUHCTDUIUJZUKULZUNZEYAUMUOZXTFXTUDUEIFXTUF
          UGZUHZJTHUIUJZUKZUNARUPZYBRYFUDZSZYGUQURUSUTVGZRVAYMVBUQYPRVCVDADYKSZ
          YOOABCDFGHIKLMNVEVHZJYBYFRVFVIAYCYJJYFYLAXTYFSZYCXTYLSZYJUHZYSAXTYEVJ
          ZYIDXTSZVKZYCUUAVLCDYFFIXTYFVMZVNAUUDYCUUAAUUDYCUHZUHZYTYHYIUUGXTYKVJ
          YTUUGXTYEYKUUBYIUUCYCAVOAYEYKVJZUUFAYQHDVPUBSUUHODTHVQDTHVSVRVTWAXTYK
          JWKWBWCUUGEYBYAUMAEYBUMUOZUUFAUUIYBEUEUOZWDAYBTETWEUJZUIUJSZUUJQAUULY
          BUUKUMUOZUUJAYBTVPUBZSUUKWFSZUULUUMWGAYBWLUUNAYKWLDGABCFGHIKLMNWHOWIZ
          WJWMAEWLSZEWFSUUOPEXBEWNVRYBTUUKWOWPAYBWLSUUQUUJUUMWGUUPPYBEWQWPWRWSA
          EYBAEPWTAYNXAYBYNWLXAYNXCSYNWLVJCDYFFIUUEXDXEXFXLYRXGXHXIVTAUUDYCXJXK
          UUBYIUUCYCAXMXNXOXPXQXRXS $.
      $}

      erdszelem.b $e |- ( ph -> B e. ( 1 ... N ) ) $.
      erdszelem.l $e |- ( ph -> A < B ) $.
      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem8 $p |- ( ph ->
        ( ( K ` A ) = ( K ` B ) -> -. ( F ` A ) O ( F ` B ) ) ) $=
        ( wbr wcel c1 cr vf vw vz cfv cv chash wceq cima clt cres wa cfz co cpw
        wiso crab wrex wne wi wfun cvv cn0 cpnf csn hashf ffun ax-mp erdszelem5
        cun wf mpdan fvelima sylancr wss w3a eqid erdszelem1 fzfid simplr1 ssfi
        cfn syl2anc hashcl syl nn0red cle csup c0 wral erdszelem2 simpri nnssre
        caddc cn sstri a1i wn elfznn nnred ltnled elfzle2 nsyl ad2antrr ssneldd
        mpbid hashunsng mp2and cuz cz elfzelz ltled eluz2 syl3anbrc fzss2 sstrd
        elfz1end sylib snssd unssd simplr2 wb wf1 wor soisores sselda ad3antrrr
        mpanl12 lenltd adantr adantl ffvelrnd imbi2d syl5ibrcom ralrimiv ralunb
        fvres elsni sylanbrc ralrimiva mpbird f1f elfzuz3 3syl uzssz zssre ltso
        fzssuz soss mp2 r19.21bi sseldi simplr3 simpr isorel breqan12d syl12anc
        bitrd mtbid simplr sotr2 mpan syl3anc fveq2d breq2d zred syldan pm2.21d
        a1d breq1d imbi1d ralbidv ssun2 snssg mpbiri cdm vex snex unex eleqtrri
        fdmi funfvima eqeltrrd ne0i simpli fimaxre2 sylancl syl31anc erdszelem3
        mp2an suprub breqtrrd erdszelem6 nnnn0d nn0ltp1le ltned neeq1 syl5ibcom
        ex sylan2b rexlimdva mpd necon2bd ) ADFUDZEFUDZIQZDGUDZEGUDZAUAUEZUFUDZ
        UXFUGZUACUEZFUXKUHUIIFUXKUJUOZDUXKRUKCSDULUMZUNUPZUQZUXEUXFUXGURZUSZAUF
        UTZUXFUFUXNUHRZUXOVAVBVCVDVIZUFVJUXRVEVAUXTUFVFVGZADSHULUMZRZUXSNABCDFG
        HIJKLMVHVKUAUXFUXNUFVLVMAUXJUXQUAUXNUXHUXNRAUXHUXMVNZUXHFUXHUHZUIIFUXHU
        JZUOZDUXHRZVOZUXJUXQUSCDUXNFIUXHUXNVPVQAUYIUKZUXEUXIUXGURZUSUXJUXQUYJUX
        EUYKUYJUXEUKZUXIUXGUYLUXIUYLUXHWARZUXIVBRZUYLUXMWARUYDUYMUYLSDVRUYDUYGU
        YHAUXEVSZUXMUXHVTWBZUXHWCWDZWEUYLUXIUXGUIQZUXISWMUMZUXGWFQZUYLUYSUFUXLE
        UXKRUKCSEULUMZUNUPZUHZTUIWGZUXGWFUYLVUCTVNZVUCWHURZUBUEZUCUEZWFQUBVUCWI
        UCTUQZUYSVUCRZUYSVUDWFQVUEUYLVUCWNTVUCWARZVUCWNVNZCEVUBFIVUBVPZWJZWKWLW
        OWPZUYLVUJVUFUYLUXHEVDZVIZUFUDZUYSVUCUYLUYMEUXHRWQZVURUYSUGZUYPUYLUXHUX
        MEUYOAEUXMRZWQUYIUXEAEDWFQZVVAADEUIQVVBWQPADEADAUYCDWNRZNDHWRZWDWSZAEAE
        UYBRZEWNRZOEHWRWDZWSZWTXEESDXAXBXCXDUYLVVFUYMVUSUKVUTUSAVVFUYIUXEOXCZUX
        HEUYBXFWDXGUYLVUQVUBRZVURVUCRZUYLVUQVUAVNVUQFVUQUHUIIFVUQUJUOZEVUQRZVVK
        UYLUXHVUPVUAUYLUXHUXMVUAUYOAUXMVUAVNZUYIUXEAEDXHUDZRZVVOADXIRZEXIRZDEWF
        QVVQAUYCVVRNDSHXJWDAVVFVVSOESHXJWDADEVVEVVIPXKDEXLXMDSEXNWDXCXOUYLEVUAA
        EVUARZUYIUXEAVVGVVTVVHEXPXQXCZXRXSZUYLVVMVUHVUGUIQZVUHFUDZVUGFUDZIQZUSZ
        UBVUQWIZUCVUQWIZUYLVWHUCUXHWIVWHUCVUPWIVWIUYLVWHUCUXHUYLVUHUXHRZUKZVWGU
        BUXHWIZVWGUBVUPWIVWHUYLVWLUCUXHUYLUYGVWLUCUXHWIZUYDUYGUYHAUXEXTZUYLUYBT
        FVJZUXHUYBVNZUYGVWMYAZAVWOUYIUXEAUYBTFYBVWOKUYBTFUUAWDXCZUYLUXHUXMUYBUY
        OAUXMUYBVNZUYIUXEAUYCHVVPRVWSNDSHUUBDSHXNUUCXCXOZUYBUIYCZTIYCZVWOVWPUKV
        WQUYBTVNTUIYCVXAUYBSXHUDZTSHUUGVXCXITSUUDUUEWOWOZUUFUYBTUIUUHUUIZMUCUBU
        XHUYBTUIIFYDYGWBXEUUJVWKVWGUBVUPVWKVWGVUGVUPRZVWCVWDUXDIQZUSVWKVXGVWCVW
        KUXCVWDIQZWQZUXEVXGVWKDVUHUIQZVXHVWKVUHDWFQZVXJWQVWKVUHUXMRVXKUYLUXHUXM
        VUHUYOYEVUHSDXAWDVWKVUHDVWKUYBTVUHVXDUYLUXHUYBVUHVWTYEZUUKVWKDVWKUYCVVC
        AUYCUYIUXEVWJNYFZVVDWDWSYHXEVWKUYGUYHVWJVXJVXHYAUYLUYGVWJVWNYIUYLUYHVWJ
        UYDUYGUYHAUXEUULYIUYLVWJUUMUYGUYHVWJUKZUKVXJDUYFUDZVUHUYFUDZIQZVXHUXHUY
        EDVUHUIIUYFUUNVXNVXQVXHYAUYGUYHVWJVXOUXCVXPVWDIDUXHFYPVUHUXHFYPUUOYJUUQ
        UUPUURUYJUXEVWJUUSVWKVWDTRZUXCTRZUXDTRZVXIUXEUKVXGUSZVWKUYBTVUHFUYLVWOV
        WJVWRYIZVXLYKVWKUYBTDFVYBVXMYKVWKUYBTEFVYBUYLVVFVWJVVJYIYKVXBVXRVXSVXTV
        OVYAMTVWDUXCUXDIUUTUVAUVBXGUVHVXFVWFVXGVWCVXFVWEUXDVWDIVXFVUGEFVUGEYQUV
        CUVDYLYMYNVWGUBUXHVUPYOYRYSUYLVWHUCVUPUYLVWHVUHVUPRZEVUGUIQZVWFUSZUBVUQ
        WIUYLVYEUBVUQUYLVUGVUQRZUKVYDVWFUYLVYFVUGVUARZVYDWQZUYLVUQVUAVUGVWBYEUY
        LVYGUKZVUGEWFQZVYHVYGVYJUYLVUGSEXAYJVYIVUGEVYGVUGTRUYLVYGVUGVUGSEXJUVEY
        JAETRUYIUXEVYGVVIYFYHXEUVFUVGYSVYCVWGVYEUBVUQVYCVWCVYDVWFVYCVUHEVUGUIVU
        HEYQUVIUVJUVKYMYNVWHUCUXHVUPYOYRUYLVWOVUQUYBVNZVVMVWIYAZVWRUYLUXHVUPUYB
        VWTUYLEUYBVVJXRXSVXAVXBVWOVYKUKVYLVXEMUCUBVUQUYBTUIIFYDYGWBYTUYLVVNVUPV
        UQVNZVUPUXHUVLUYLVVTVVNVYMYAVWAEVUQVUAUVMWDUVNCEVUBFIVUQVUMVQXMUXRVUQUF
        UVOZRVVKVVLUSUYAVUQVAVYNUXHVUPUAUVPEUVQUVRVAUXTUFVEUVTUVSVUBVUQUFUWAUWI
        WDUWBZVUCUYSUWCWDUYLVUEVUKVUIVUOVUKVULVUNUWDUCUBVUCUWEUWFVYOUCUBVUCUYSU
        WJUWGAUXGVUDUGZUYIUXEAVVFVYPOABCEFGHIJKLUWHWDXCUWKUYLUYNUXGVBRUYRUYTYAU
        YQUYLUXGAUXGWNRUYIUXEAUYBWNEGABCFGHIJKLMUWLOYKXCUWMUXIUXGUWNWBYTUWOUWRU
        XJUYKUXPUXEUXIUXFUXGUWPYLUWQUWSUWTUXAUXB $.
    $}

    ${
      erdszelem.i $e |- I = ( x e. ( 1 ... N ) |->
        sup ( ( # " { y e. ~P ( 1 ... x ) | ( ( F |` y )
          Isom < , < ( y , ( F " y ) ) /\ x e. y ) } ) , RR , < ) ) $.
      erdszelem.j $e |- J = ( x e. ( 1 ... N ) |->
        sup ( ( # " { y e. ~P ( 1 ... x ) | ( ( F |` y )
          Isom < , `' < ( y , ( F " y ) ) /\ x e. y ) } ) , RR , < ) ) $.
      erdszelem.t $e |- T = ( n e. ( 1 ... N ) |->
        <. ( I ` n ) , ( J ` n ) >. ) $.
      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem9 $p |- ( ph -> T : ( 1 ... N ) -1-1-> ( NN X. NN ) ) $=
        ( cn cfv wceq wa clt cr vz vw va vb c1 cfz co cxp wf cv wi wral wf1 cop
        wcel ltso erdszelem6 ffvelrnda ccnv wor cnvso opelxpi syl2anc eqeqan12d
        mpbi fmptd fveq2 eqeq12 imbi12d eqcom syl6bb wss elfzelz zred ssriv a1i
        biidd cle wbr w3a simpr1 opeq12d opex fvmpt syl simpr2 eqeq12d fvex wne
        wn sseldi simpr3 leltned wo wb adantr f1fveq syl12anc syl6bbr necon3bid
        opth bitr4d biimpa f1f ad2antrr ffvelrnd lttri2d mpbid simpr erdszelem8
        anim12d ioran brcnv notbii anbi2i bitr4i syl6ibr mt2d ex sylbird syl5bi
        necon4ad sylbid syl6ib wlogle ralrimivva dff13 sylanbrc ) AUEIUFUGZOOUH
        ZDUIUAUJZDPZUBUJZDPZQZYKYMQZUKZUBYIULUAYIULYIYJDUMAEYIEUJZGPZYRHPZUNZYJ
        DAYRYIUORYSOUOYTOUOUUAYJUOAYIOYRGABCFGISJKLUPUQURAYIOYRHABCFHISUSZJKMTS
        UTTUUBUTUPTSVAVEZUQURYSYTOOVBVCNVFAYQUAUBYIYIAUCUJZDPZUDUJZDPZQZUUDUUFQ
        ZUKYQYQUAUBUCUDYIUUDYKQZUUFYMQZRUUHYOUUIYPUUJUUKUUEYLUUGYNUUDYKDVGUUFYM
        DVGVDUUDYKUUFYMVHVIUUDYMQZUUFYKQZRZUUHYOUUIYPUUNUUHYNYLQYOUULUUMUUEYNUU
        GYLUUDYMDVGUUFYKDVGVDYNYLVJVKUUNUUIYMYKQZYPUUDYMUUFYKVHYMYKVJZVKVIYITVL
        AUAYITYKYIUOZYKYKUEIVMVNZVOZVPAUUQYMYIUOZRRYQVQAUUQUUTYKYMVRVSZVTZRZYOU
        UOYPUVCYOYKGPZYKHPZUNZYMGPZYMHPZUNZQZUUOUVCYLUVFYNUVIUVCUUQYLUVFQAUUQUU
        TUVAWAZEYKUUAUVFYIDYRYKQYSUVDYTUVEYRYKGVGYRYKHVGWBNUVDUVEWCWDWEUVCUUTYN
        UVIQAUUQUUTUVAWFZEYMUUAUVIYIDYRYMQYSUVGYTUVHYRYMGVGYRYMHVGWBNUVGUVHWCWD
        WEWGUVJUVDUVGQZUVEUVHQZRZUVCUUOUVDUVEUVGUVHYKGWHYKHWHXAUVCUVOYMYKUVCYMY
        KWIZYKYMSVSZUVOWJZUVCYKYMUVCUUQYKTUOUVKUURWEUVCYITYMUUSUVLWKAUUQUUTUVAW
        LWMZUVCUVQUVRUVCUVQRZUVOYKFPZYMFPZSVSZUWBUWASVSZWNZUVTUWAUWBWIZUWEUVCUV
        QUWFUVCUVQUVPUWFUVSUVCUWAUWBYMYKUVCUWAUWBQZYPUUOUVCYITFUMZUUQUUTUWGYPWO
        AUWHUVBKWPUVKUVLYITYKYMFWQWRUUPWSWTXBXCUVTUWAUWBUVTYITYKFAYITFUIZUVBUVQ
        AUWHUWIKYITFXDWEXEZUVCUUQUVQUVKWPZXFUVTYITYMFUWJUVCUUTUVQUVLWPZXFXGXHUV
        TUVOUWCWJZUWAUWBUUBVSZWJZRZUWEWJZUVTUVMUWMUVNUWOUVTBCYKYMFGISAIOUOUVBUV
        QJXEZAUWHUVBUVQKXEZLUPUWKUWLUVCUVQXIZXJUVTBCYKYMFHIUUBUWRUWSMUUCUWKUWLU
        WTXJXKUWQUWMUWDWJZRUWPUWCUWDXLUWOUXAUWMUWNUWDUWAUWBSYKFWHYMFWHXMXNXOXPX
        QXRXSXTYBYAYCUUPYDYEYFUAUBYIYJDYGYH $.

      erdszelem.r $e |- ( ph -> R e. NN ) $.
      erdszelem.s $e |- ( ph -> S e. NN ) $.
      erdszelem.m $e |- ( ph -> ( ( R - 1 ) x. ( S - 1 ) ) < N ) $.
      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem10 $p |- ( ph -> E. m e. ( 1 ... N )
        ( -. ( I ` m ) e. ( 1 ... ( R - 1 ) ) \/
          -. ( J ` m ) e. ( 1 ... ( S - 1 ) ) ) ) $=
        ( vs cv cfv c1 cmin co cfz cxp wcel wn wrex wo crn wss csdm wbr cdom wi
        cfn fzfi xpfi mp2an ssdomg ax-mp domnsym syl cen chash cmul wceq hashxp
        clt cn cn0 nnm1nn0 hashfz1 oveq12d syl5eq nnnn0d 3brtr4d fzfid hashsdom
        3syl wb sylancr mpbid wf1 wf1o erdszelem9 f1f1orn ovex sdomentr syl2anc
        f1oen nsyl3 wex nss df-rex bitr4i sylib wfn f1fn eleq1 notbid rexrn cop
        wa fveq2 opeq12d opex fvmpt adantl eleq1d opelxp syl6bb ianor rexbidva
        ) AGUBZFUCZUDDUDUEUFZUGUFZUDEUDUEUFZUGUFZUHZUIZUJZGUDLUGUFZUKZXRJUCZYAU
        IZUJXRKUCZYCUIZUJULZGYGUKAUAUBZYDUIZUJZUAFUMZUKZYHAYQYDUNZUJZYRYSYDYQUO
        UPZAYSYQYDUQUPZUUAUJYDUSUIZYSUUBURYAUSUIZYCUSUIZUUCUDXTUTZUDYBUTZYAYCVA
        VBZYQYDUSVCVDYQYDVEVFAYDYGUOUPZYGYQVGUPZUUAAYDVHUCZYGVHUCZVLUPZUUIAXTYB
        VIUFZLUUKUULVLTAUUKYAVHUCZYCVHUCZVIUFZUUNUUDUUEUUKUUQVJUUFUUGYAYCVKVBAU
        UOXTUUPYBVIADVMUIXTVNUIUUOXTVJRDVOXTVPWCAEVMUIYBVNUIUUPYBVJSEVOYBVPWCVQ
        VRALVNUIUULLVJALMVSLVPVFVTAUUCYGUSUIUUMUUIWDUUHAUDLWAYDYGWBWEWFAYGVMVMU
        HZFWGZYGYQFWHUUJABCFHIJKLMNOPQWIZYGUURFWJYGYQFUDLUGWKWNWCYDYGYQWLWMWOYT
        YNYQUIYPXGUAWPYRUAYQYDWQYPUAYQWRWSWTAUUSFYGXAYRYHWDUUTYGUURFXBYPYFUAGYG
        FYNXSVJYOYEYNXSYDXCXDXEWCWFAYFYMGYGAXRYGUIZXGZYFYJYLXGZUJYMUVBYEUVCUVBY
        EYIYKXFZYDUIUVCUVBXSUVDYDUVAXSUVDVJAHXRHUBZJUCZUVEKUCZXFUVDYGFUVEXRVJUV
        FYIUVGYKUVEXRJXHUVEXRKXHXIQYIYKXJXKXLXMYIYKYAYCXNXOXDYJYLXPXOXQWF $.

      $( Lemma for ~ erdsze .  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
      erdszelem11 $p |- ( ph -> E. s e. ~P ( 1 ... N )
      ( ( R <_ ( # ` s ) /\ ( F |` s ) Isom < , < ( s , ( F " s ) ) ) \/
        ( S <_ ( # ` s ) /\ ( F |` s ) Isom < , `' < ( s , ( F " s ) ) ) ) ) $=
        ( vm cv chash cfv cle wbr cima clt cres wiso wa c1 cfz co cpw wrex ccnv
        wo cmin wcel wn erdszelem10 cn adantr wf1 ltso simprl simprr erdszelem7
        cr expr wor cnvso mpbi orim12d rexlimdva mpd r19.43 sylibr ) ADLUBZUCUD
        ZUEUFVTHVTUGZUHUHHVTUIZUJUKZLULKUMUNZUOZUPZEWAUEUFVTWBUHUHUQZWCUJUKZLWF
        UPZURZWDWIURLWFUPAUAUBZIUDULDULUSUNUMUNUTVAZWLJUDULEULUSUNUMUNUTVAZURZU
        AWEUPWKABCDEFUAGHIJKMNOPQRSTVBAWOWKUAWEAWLWEUTZUKWMWGWNWJAWPWMWGAWPWMUK
        ZUKBCWLDHIKUHLAKVCUTZWQMVDAWEVJHVEZWQNVDOVFAWPWMVGADVCUTWQRVDAWPWMVHVIV
        KAWPWNWJAWPWNUKZUKBCWLEHJKWHLAWRWTMVDAWSWTNVDPVJUHVLVJWHVLVFVJUHVMVNAWP
        WNVGAEVCUTWTSVDAWPWNVHVIVKVOVPVQWDWILWFVRVS $.
    $}

    erdsze.r $e |- ( ph -> R e. NN ) $.
    erdsze.s $e |- ( ph -> S e. NN ) $.
    erdsze.l $e |- ( ph -> ( ( R - 1 ) x. ( S - 1 ) ) < N ) $.
    $( The Erd&#337;s-Szekeres theorem.  For any injective sequence ` F ` on
       the reals of length at least ` ( R - 1 ) x. ( S - 1 ) + 1 ` , there is
       either a subsequence of length at least ` R ` on which ` F ` is
       increasing (i.e. a ` < , < ` order isomorphism) or a subsequence of
       length at least ` S ` on which ` F ` is decreasing (i.e. a ` < , ``' < `
       order isomorphism, recalling that ` ``' < ` is the greater-than
       relation).  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
    erdsze $p |- ( ph -> E. s e. ~P ( 1 ... N )
    ( ( R <_ ( # ` s ) /\ ( F |` s ) Isom < , < ( s , ( F " s ) ) ) \/
      ( S <_ ( # ` s ) /\ ( F |` s ) Isom < , `' < ( s , ( F " s ) ) ) ) ) $=
      ( vx vy vz vw chash cima clt wiso wa vn c1 cfz co cv cres wel cpw crab cr
      csup cmpt cfv ccnv cop weq wceq wb reseq2 isoeq1 syl isoeq4 imaeq2 isoeq5
      3bitrd elequ2 anbi12d cbvrabv oveq2 pweqd elequ1 anbi2d rabeqbidv imaeq2d
      syl5eq supeq1d cbvmptv eqid erdszelem11 ) ALMBCUAUBEUCUDZUAUEZNVTPOUEZDWB
      QZRRDWBUFZSZNOUGZTZOUBNUEZUCUDZUHZUIZQZUJRUKZULZUMWANVTPWBWCRRUNZWDSZWFTZ
      OWJUIZQZUJRUKZULZUMUOULZUADWNXAEFGHNLVTWMPMUEZDXCQZRRDXCUFZSZLMUGZTZMUBLU
      EZUCUDZUHZUIZQZUJRUKNLUPZUJWLXMRXNWKXLPXNWKXFNMUGZTZMWJUIXLWGXPOMWJOMUPZW
      EXFWFXOXQWEWBWCRRXESZXCWCRRXESZXFXQWDXEUQZWEXRURWBXCDUSZWBWCRRXEWDUTVAWBW
      CXCRRXEVBXQWCXDUQZXSXFURWBXCDVCZXCWCXDRRXEVDVAVEOMNVFZVGVHXNXPXHMWJXKXNWI
      XJWHXIUBUCVIVJZXNXOXGXFNLMVKZVLVMVOVNVPVQNLVTWTPXCXDRWOXESZXGTZMXKUIZQZUJ
      RUKXNUJWSYJRXNWRYIPXNWRYGXOTZMWJUIYIWQYKOMWJXQWPYGWFXOXQWPWBWCRWOXESZXCWC
      RWOXESZYGXQXTWPYLURYAWBWCRWOXEWDUTVAWBWCXCRWOXEVBXQYBYMYGURYCXCWCXDRWOXEV
      DVAVEYDVGVHXNYKYHMWJXKYEXNXOXGYGYFVLVMVOVNVPVQXBVRIJKVS $.
  $}

  ${
    $d f s t A $.  $d f s t F $.  $d s t x y G $.  $d f s t R $.  $d f s t S $.
    $d f s t x y N $.  $d f s t x y ph $.
    erdsze2.r $e |- ( ph -> R e. NN ) $.
    erdsze2.s $e |- ( ph -> S e. NN ) $.
    erdsze2.f $e |- ( ph -> F : A -1-1-> RR ) $.
    erdsze2.a $e |- ( ph -> A C_ RR ) $.
    ${
      erdsze2lem.n $e |- N = ( ( R - 1 ) x. ( S - 1 ) ) $.
      erdsze2lem.l $e |- ( ph -> N < ( # ` A ) ) $.
      $( Lemma for ~ erdsze2 .  (Contributed by Mario Carneiro,
         22-Jan-2015.) $)
      erdsze2lem1 $p |- ( ph -> E. f ( f : ( 1 ... ( N + 1 ) ) -1-1-> A /\
        f Isom < , < ( ( 1 ... ( N + 1 ) ) , ran f ) ) ) $=
        ( c1 co clt wcel syl wb cr vs caddc cfz cv cen wbr wss wf1 crn wiso wex
        wa cdom cfn chash cfv cle wceq cn0 cmin cmul nnm1nn0 nn0mulcld syl5eqel
        cn peano2nn0 hashfz1 adantr hashcl nn0ltp1le syl2an mpbid eqbrtrd fzfid
        3syl simpr hashdom syl2anc isinffi cvv reex ssexg sylancl brdomg mpbird
        wn pm2.61dan domeng simprr sstrd ltso soss ee10 simprl enfi fz1iso wf1o
        isof1o adantl hashen eqtr3d oveq2d f1oeq2 f1of1 simplrr f1ss f1ofo forn
        wor wfo isoeq5 4syl isoeq4 jca ex eximdv mpd exlimddv ) ANGNUBOZUCOZUAU
        DZUEUFZYABUGZULZXTBEUDZUHZXTYEUIZPPYEUJZULZEUKZUAAXTBUMUFZYDUAUKZABUNQZ
        YKAYMULZXTUOUPZBUOUPZUQUFZYKYNYOXSYPUQAYOXSURZYMAGUSQZXSUSQYRAGCNUTOZDN
        UTOZVAOUSLAYTUUAACVEQYTUSQHCVBRADVEQUUAUSQIDVBRVCVDZGVFXSVGVOZVHYNGYPPU
        FZXSYPUQUFZAUUDYMMVHAYSYPUSQUUDUUESYMUUBBVIGYPVJVKVLVMYNXTUNQZYMYQYKSYN
        NXSVNAYMVPXTBUNVQVRVLAYMWFZULZYKYFEUKZUUHUUGUUFUUIAUUGVPUUHNXSVNBXTEVSV
        RUUHBVTQZYKUUISAUUJUUGABTUGZTVTQUUJKWABTVTWBWCZVHXTBVTEWDRWEWGAUUJYKYLS
        UULUAXTBVTWHRVLAYDULZNYAUOUPZUCOZYAPPYEUJZEUKZYJUUMYAPXIZYAUNQZUUQUUMYA
        TUGTPXIUURUUMYABTAYBYCWIAUUKYDKVHWJWKYATPWLWMUUMUUFUUSUUMNXSVNZUUMYBUUF
        UUSSAYBYCWNZXTYAWORVLZYAPEWPVRUUMUUPYIEUUMUUPYIUUMUUPULZYFYHUVCXTYAYEUH
        ZYCYFUVCXTYAYEWQZUVDUVCUUOYAYEWQZUVEUUPUVFUUMUUOYAPPYEWRWSZUVCUUOXTURZU
        VFUVESUVCUUNXSNUCUUMUUNXSURUUPUUMYOUUNXSUUMYOUUNURZYBUVAUUMUUFUUSUVIYBS
        UUTUVBXTYAWTVRWEAYRYDUUCVHXAVHXBZUUOXTYAYEXCRVLXTYAYEXDRAYBYCUUPXEXTYAB
        YEXFVRUVCUUOYGPPYEUJZYHUVCUVKUUPUUMUUPVPUVCUVFUUOYAYEXJYGYAURUVKUUPSUVG
        UUOYAYEXGUUOYAYEXHUUOYGYAPPYEXKXLWEUVCUVHUVKYHSUVJUUOYGXTPPYEXMRVLXNXOX
        PXQXR $.

      erdsze2lem.g $e |- ( ph -> G : ( 1 ... ( N + 1 ) ) -1-1-> A ) $.
      erdsze2lem.i $e |- ( ph ->
        G Isom < , < ( ( 1 ... ( N + 1 ) ) , ran G ) ) $.
      $( Lemma for ~ erdsze2 .  (Contributed by Mario Carneiro,
         22-Jan-2015.) $)
      erdsze2lem2 $p |- ( ph -> E. s e. ~P A
      ( ( R <_ ( # ` s ) /\ ( F |` s ) Isom < , < ( s , ( F " s ) ) ) \/
        ( S <_ ( # ` s ) /\ ( F |` s ) Isom < , `' < ( s , ( F " s ) ) ) ) ) $=
        ( clt wiso wcel syl vt vx vy cv chash cfv cle ccom cima cres wa ccnv wo
        wbr c1 caddc co cfz cpw wrex cn0 cn cmin cmul nnm1nn0 nn0mulcld nn0p1nn
        syl5eqel cr wf1 f1co syl2anc nn0red ltp1d syl5eqbrr erdsze wss vex elpw
        wi crn imassrn wf f1f frn syl5ss cvv wb reex ssexg elpw2g mpbird adantr
        sylancl wceq cen f1imaen sylan cfn fzfid simpr ssfi enfii hashen breq2d
        biimprd ad2antrr simprl sseldd simprr isorel syl12anc biimpd ralrimivva
        wral wor elfznn nnred ssriv a1i ltso soss ee10 soisores syl22anc isocnv
        isotr ex resco coeq1i isoeq1 isoeq5 syl6bb sylibd anim12d isoeq4 3bitrd
        coass ax-mp anbi12d eqtri f1ores f1ococnv2 coeq2d coires1 syl6eq syl5eq
        wf1o imaco orim12d fveq2 reseq2 imaeq2 orbi12d rspcev sylan2b rexlimdva
        cid ee12an mpd ) ACUAUDZUEUFZUGUNZUVAEFUHZUVAUIZQQUVDUVAUJZRZUKZDUVBUGU
        NZUVAUVEQQULZUVFRZUKZUMZUAUOGUOUPUQZURUQZUSZUTCHUDZUEUFZUGUNZUVQEUVQUIZ
        QQEUVQUJZRZUKZDUVRUGUNZUVQUVTQUVJUWARZUKZUMZHBUSZUTZACDUVDUVNUAAGVASUVN
        VBSAGCUOVCUQZDUOVCUQZVDUQZVAMAUWJUWKACVBSUWJVASICVETADVBSUWKVASJDVETVFV
        HZGVGTABVIEVJUVOBFVJZUVOVIUVDVJKOUVOBVIEFVKVLIJAUWLGUVNQMAGAGUWMVMVNVOV
        PAUVMUWIUAUVPUVAUVPSAUVAUVOVQZUVMUWIVTUVAUVOUAVRZVSAUWOUKZFUVAUIZUWHSZU
        VMCUWRUEUFZUGUNZUWREUWRUIZQQEUWRUJZRZUKZDUWTUGUNZUWRUXBQUVJUXCRZUKZUMZU
        WIAUWSUWOAUWSUWRBVQZAUWRFWAZBFUVAWBAUVOBFWCZUXKBVQAUWNUXLOUVOBFWDTZUVOB
        FWETWFABWGSZUWSUXJWHABVIVQZVIWGSUXNLWIBVIWGWJWNUWRBWGWKTWLWMUWQUVHUXEUV
        LUXHUWQUVCUXAUVGUXDUWQUXAUVCUWQUWTUVBCUGUWQUWTUVBWOZUWRUVAWPUNZAUWNUWOU
        XQOUVOBUVAFUWPWQWRZUWQUWRWSSZUVAWSSZUXPUXQWHUWQUXTUXQUXSUWQUVOWSSUWOUXT
        UWQUOUVNWTAUWOXAZUVOUVAXBVLZUXRUWRUVAXCVLUYBUWRUVAXDVLWLZXEXFUWQUVGUWRU
        VEQQUVFFUVAUJZULZUHZRZUXDUWQUWRUVAQQUYERZUVGUYGVTUWQUVAUWRQQUYDRZUYHUWQ
        UYIUBUDZUCUDZQUNZUYJFUFUYKFUFQUNZVTZUCUVAXOUBUVAXOZUWQUYNUBUCUVAUVAUWQU
        YJUVASZUYKUVASZUKZUKZUYLUYMUYSUVOUXKQQFRZUYJUVOSUYKUVOSUYLUYMWHAUYTUWOU
        YRPXGUYSUVAUVOUYJUWQUWOUYRUYAWMZUWQUYPUYQXHXIUYSUVAUVOUYKVUAUWQUYPUYQXJ
        XIUVOUXKUYJUYKQQFXKXLXMXNUWQUVOQXPZBQXPZUXLUWOUYIUYOWHUWQUVOVIVQZVIQXPZ
        VUBVUDUWQUAUVOVIUVAUVOSUVAUVAUVNXQXRXSXTYAUVOVIQYBYCUWQUXOVUEVUCAUXOUWO
        LWMYABVIQYBYCAUXLUWOUXMWMUYAUBUCUVAUVOBQQFYDYEWLUVAUWRQQUYDYFTZUYHUVGUY
        GUWRUVAUVEQQQUVFUYEYGYHTUWQUYGUWRUVEQQUXCRZUXDUWQUYFUXCWOZUYGVUGWHUWQUY
        FEUYDUYEUHZUHZUXCUYFEUYDUHZUYEUHVUJUVFVUKUYEEFUVAYIYJEUYDUYEYRUUAUWQVUJ
        EUURUWRUJZUHUXCUWQVUIVULEUWQUVAUWRUYDUUHZVUIVULWOAUWNUWOVUMOUVOBUVAFUUB
        WRUVAUWRUYDUUCTUUDEUWRUUEUUFUUGZUWRUVEQQUXCUYFYKTUVEUXBWOZVUGUXDWHEFUVA
        UUIZUWRUVEUXBQQUXCYLYSYMYNYOUWQUVIUXFUVKUXGUWQUXFUVIUWQUWTUVBDUGUYCXEXF
        UWQUVKUWRUVEQUVJUYFRZUXGUWQUYHUVKVUQVTVUFUYHUVKVUQUWRUVAUVEQQUVJUVFUYEY
        GYHTUWQVUQUWRUVEQUVJUXCRZUXGUWQVUHVUQVURWHVUNUWRUVEQUVJUXCUYFYKTVUOVURU
        XGWHVUPUWRUVEUXBQUVJUXCYLYSYMYNYOUUJUWGUXIHUWRUWHUVQUWRWOZUWCUXEUWFUXHV
        USUVSUXAUWBUXDVUSUVRUWTCUGUVQUWRUEUUKZXEVUSUWBUVQUVTQQUXCRZUWRUVTQQUXCR
        ZUXDVUSUWAUXCWOZUWBVVAWHUVQUWREUULZUVQUVTQQUXCUWAYKTUVQUVTUWRQQUXCYPVUS
        UVTUXBWOZVVBUXDWHUVQUWREUUMZUWRUVTUXBQQUXCYLTYQYTVUSUWDUXFUWEUXGVUSUVRU
        WTDUGVUTXEVUSUWEUVQUVTQUVJUXCRZUWRUVTQUVJUXCRZUXGVUSVVCUWEVVGWHVVDUVQUV
        TQUVJUXCUWAYKTUVQUVTUWRQUVJUXCYPVUSVVEVVHUXGWHVVFUWRUVTUXBQUVJUXCYLTYQY
        TUUNUUOUUSUUPUUQUUT $.
    $}

    erdsze2.l $e |- ( ph -> ( ( R - 1 ) x. ( S - 1 ) ) < ( # ` A ) ) $.
    $( Generalize the statement of the Erd&#337;s-Szekeres theorem ~ erdsze to
       "sequences" indexed by an arbitrary subset of ` RR ` , which can be
       infinite.  (Contributed by Mario Carneiro, 22-Jan-2015.) $)
    erdsze2 $p |- ( ph -> E. s e. ~P A
      ( ( R <_ ( # ` s ) /\ ( F |` s ) Isom < , < ( s , ( F " s ) ) ) \/
        ( S <_ ( # ` s ) /\ ( F |` s ) Isom < , `' < ( s , ( F " s ) ) ) ) ) $=
      ( vf c1 cmin co clt wiso wa wbr adantr caddc cfz cv wf1 crn chash cfv cle
      cmul cima cres ccnv wo cpw wrex eqid erdsze2lem1 cn wcel cr simprl simprr
      wss erdsze2lem2 exlimddv ) AMCMNODMNOUIOZMUAOUBOZBLUCZUDZVGVHUEPPVHQZRZCF
      UCZUFUGZUHSVLEVLUJZPPEVLUKZQRDVMUHSVLVNPPULVOQRUMFBUNUOLABCDLEVFGHIJVFUPZ
      KUQAVKRBCDEVHVFFACURUSVKGTADURUSVKHTABUTEUDVKITABUTVCVKJTVPAVFBUFUGPSVKKT
      AVIVJVAAVIVJVBVDVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Euler's partition theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $(
  @{
    eulerpartlemm.f @e |- F = ( x e. NN0 , y e. { z e. NN | -. 2 || z } |->
      ( ( 2 ^ x ) x. y ) ) @.
    @( Lemma for ~ eulerpart .  The function ` F ` that decomposes a number
       into its "odd" and "even" parts, which is to say the largest power of
       two and largest odd divisor of a number, is a bijection from
       pairs of a natural number and an odd number to natural numbers. @)
    eulerpartlemm @p |- F : ( NN0 X. { z e. NN | -. 2 || z } ) -1-1-onto->
      NN ) @=
      ( cn0 cn cmap co wcel ccnv cima cfn cv cfv cmul csu wceq wa wf nn0ex nnex
      w3a elmap anbi1i cnveq eleq1d fveq1 oveq1d sumeq2sdv eqeq1d elrab2 3anass
      imaeq1d anbi12d 3bitr4i ) AGHIJZKZALZHMZNKZHDOZAPZVCQJZDRZESZTZTHGAUAZVHT
      ABKVIVBVGUDUSVIVHGHAUBUCUEUFCOZLZHMZNKZHVCVJPZVCQJZDRZESZTVHCAURBVJASZVMV
      BVQVGVRVLVANVRVKUTHVJAUGUOUHVRVPVFEVRHVOVEDVRVNVDVCQVCVJAUIUJUKULUPFUMVIV
      BVGUNUQ @.
      @( [26-Jan-2015] @)
  @}

  @{
    eulerpart.p @e |- P = { f e. ( NN0 ^m NN ) | ( ( `' f " NN ) e. Fin /\
      sum_ k e. NN ( ( f ` k ) x. k ) = N ) } @.
    @( Lemma for ~ eulerpart . @)
    eulerpartleme @p |- ( A e. P <-> ( A : NN --> NN0 /\ ( `' A " NN ) e. Fin
      /\ sum_ k e. NN ( ( A ` k ) x. k ) = N ) ) @=
      ( cn0 cn cmap co wcel ccnv cima cfn cv cfv cmul csu wceq wa wf nn0ex nnex
      w3a elmap anbi1i cnveq eleq1d fveq1 oveq1d sumeq2sdv eqeq1d elrab2 3anass
      imaeq1d anbi12d 3bitr4i ) AGHIJZKZALZHMZNKZHDOZAPZVCQJZDRZESZTZTHGAUAZVHT
      ABKVIVBVGUDUSVIVHGHAUBUCUEUFCOZLZHMZNKZHVCVJPZVCQJZDRZESZTVHCAURBVJASZVMV
      BVQVGVRVLVANVRVKUTHVJAUGUOUHVRVPVFEVRHVOVEDVRVNVDVCQVCVJAUIUJUKULUPFUMVIV
      BVGUNUQ @.
      @( [26-Jan-2015] @)

    @( Lemma for ~ eulerpart .  The set of all partitions of ` N ` is
       finite. @)
    eulerpartlemb @p |- P e. Fin @=
      ( vx cn c1 co wcel cc0 wa wceq adantl cn0 cle wbr syl wi adantr vg vy cfz
      cv csn cif cixp cfn wss wtru fzfid fzfi snfi keepel a1i wn eldifn iffalse
      cdif eqimss 3syl ixpfi2 trud ccnv cima cfv cmul csu w3a eulerpartleme wfn
      wf wral ffn 3ad2ant1 cr simp1 ffvelrn sylan nn0re idi remulcl syl2anc cdm
      cnvimass fdm syl5sseq cc sselda adantlr syldan nnnn0 nn0mulcl nn0cn simpl
      nnre cvv nn0supp suppssr oveq1d eldifi nncn mul02 eqtrd cuz eqimssi sumss
      nnuz nn0sscn caddc nn0addcl simpr 0nn0 fsumcllem eqeltrrd eleq1 syl5ibcom
      3impia nn0ge0 nnge1 lemulge11 syl22anc fveq2 oveq12d simprr fsumge1 eldif
      id expr ralrimiva eqeq1d rspccva sylan2br fsumge0 breqtrd syl6eleq elfz5
      wb eleqtrrd syld adantrr eqbrtrd pm2.61d 3adantl3 simpl3 letrd nn0uz nn0z
      cz mpbird iftrue lemulge12 syl21anc letr syl3anc syl5 sylibrd con3d elnn0
      mpan2d sylib ord imp fvex elsnc sylibr pm2.61dan vex elixp sylanbrc sylbi
      wo ssriv ssfi mp2an ) FGFUDZHDUCIZJZKDUCIZKUEZUFZUGZUHJZAUWBUIAUHJUWCUJFG
      UWAUVQKUJHDUKUWAUHJUJUVPGJZLUVRUVSUVTUHKDULKUMUNUOUJUVPGUVQUSJZLUVRUPZUWA
      UVTMZUWAUVTUIUWEUWFUJUVPGUVQUQNUVRUVSUVTURZUWAUVTUTVAVBVCUAAUWBUAUDZAJGOU
      WIVLZUWIVDZGVEZUHJZGCUDZUWIVFZUWNVGIZCVHZDMZVIZUWIUWBJZUWIABCDEVJUWSUWIGV
      KZUVPUWIVFZUWAJZFGVMUWTUWJUWMUXAUWRGOUWIVNVOUWSUXCFGUWSUWDLZUVRUXCUXDUVRL
      UXBUVSUWAUXDUXBUVSJZUVRUXDUXEUXBDPQZUXDUXBUXBUVPVGIZDUXDUXBOJZUXBVPJZUWSU
      WJUWDUXHUWJUWMUWRVQGOUVPUWIVRVSZUXBVTRZUXDUXIUVPVPJZUXGVPJZUXDUXISUXKWAUX
      DUXLSUWDUXLUWSUVPWPNZWAZUXBUVPWBWCZUXDDOJZDVPJZUWSUXQUWDUWJUWMUWRUXQUWJUW
      MLZUWQOJUWRUXQUXSUWLUWPCVHZUWQOUXSUWLGUWPCHUXSUWIWDZUWLGUWIGWEUWJUYAGMUWM
      GOUWIWFTWGZUXSUWNUWLJZLZUWPOJZUWPWHJUYDUWOOJZUWNOJZUYEUXSUYCUWNGJZUYFUXSU
      WLGUWNUYBWIZUWJUYHUYFUWMGOUWNUWIVRWJWKUYDUYHUYGUYIUWNWLRUWOUWNWMWCZUWPWNR
      UXSUWNGUWLUSZJZLZUWPKUWNVGIZKUYMUWOKUWNVGUXSGOUWIUWLUWNKUWJUWMWOUXSUWKWQU
      VTUSVEZUWLMZUYOUWLUIUWJUYPUWMUWIGWRTUYOUWLUTRWSWTUYMUYHUWNWHJUYNKMUYLUYHU
      XSUWNGUWLXANUWNXBUWNXCVAXDZGHXEVFZUIUXSGUYRXHXFUOXGZUXSFUBUWLUWPOCOWHUIUX
      SXIUOUVPOJZUBUDZOJLUVPVUAXJIOJUXSUVPVUAXKNUWJUWMXLZUYJKOJUXSXMUOXNXOUWQDO
      XPXQXRTZDVTRZUXDUXIUXLKUXBPQZHUVPPQZUXBUXGPQUXKUXNUXDUXHVUEUXDUXHSUXJWAUX
      BXSRUWDVUFUWSUVPXTNUXBUVPYAYBUXDUXGUWQDPUWJUWMUWDUXGUWQPQUWRUXSUWDLZUXGUX
      TUWQPVUGUVPUWLJZUXGUXTPQZUXSUWDVUHVUIUXSUWDVUHLZLUWLUWPUXGCUVPUXSUWMVUJVU
      BTUXSUYCUWPVPJZVUJUYDUYEVUKUYJUWPVTZRWJUXSUYCKUWPPQZVUJUYDUYEVUMUYJUWPXSZ
      RWJUWNUVPMZUWOUXBUWNUVPVGUWNUVPUWIYCVUOYHYDZUXSUWDVUHYEYFYIUXSUWDVUHUPZVU
      IUXSUWDVUQLZLUXGKUXTPVURUXSUVPUYKJZUXGKMZUVPGUWLYGUXSUWPKMZCUYKVMVUSVUTUX
      SVVACUYKUYQYJVVAVUTCUVPUYKVUOUWPUXGKVUPYKYLVSYMUXSUWDKUXTPQVUQVUGUWLUWPCU
      XSUWMUWDVUBTVUGUYCLZUYEVUKUXSUYCUYEUWDUYJWJZVULRVVBUYEVUMVVCVUNRYNUUAUUBY
      IUUCUXSUXTUWQMUWDUYSTYOUUDUWJUWMUWRUWDUUEYOZUUFUXDUXBKXEVFZJDUUIJZUXEUXFY
      RUXDUXBOVVEUXJUUGYPUXDUXQVVFVUCDUUHRZUXBKDYQWCUUJTUVRUWAUVSMUXDUVRUVSUVTU
      UKNYSUXDUWFLZUXBUVTUWAVVHUXBKMZUXBUVTJUXDUWFVVIUXDUWFUXBGJZUPVVIUXDVVJUVR
      UXDVVJUVPDPQZUVRVVJHUXBPQZUXDVVKUXBXTUXDVVLUVPUXGPQZVVKUXDUXLUXIKUVPPQZVV
      LVVMSUXNUXKUXDUYTVVNUWDUYTUWSUVPWLNUVPXSRUXLUXILVVNVVLVVMUVPUXBUULYIUUMUX
      DVVMUXGDPQZVVKVVDUXDUXLUXMUXRVVMVVOLVVKSUXOUXDUXMSUXPWAUXDUXRSVUDWAUVPUXG
      DUUNUUOUUTYTUUPUXDUVPUYRJVVFUVRVVKYRUXDUVPGUYRUWSUWDXLXHYPVVGUVPHDYQWCUUQ
      UURUXDVVJVVIUXDUXHVVJVVIUVLUXJUXBUUSUVAUVBYTUVCUXBKUVPUWIUVDUVEUVFUWFUWGU
      XDUWHNYSUVGYJFGUWAUWIUAUVHUVIUVJUVKUVMUWBAUVNUVO @.
      @( [26-Jan-2015] @)

    eulerpart.o @e |- O = { g e. P | A. n e. ( `' g " NN ) -. 2 || n } @.
    eulerpart.d @e |- D = { g e. P | A. n e. NN ( g ` n ) <_ 1 } @.
    @{
      eulerpart.f @e |- F = ( x e. ( ~P NN0 i^i Fin ) |->
        sum_ y e. x ( 2 ^ y ) ) @.
      @( Lemma for ~ eulerpart . @)
      eulerpartlemi @p |- ( A e. P -> { t e. NN |
      E. n e. ( `' F ` ( A ` t ) ) ( ( 2 ^ n ) x. t ) = M } C_ ( 1 ... M ) ) @=
        ( wcel cn0 c2 cv cexp co cmul wceq cfv ccnv wrex c1 cfz wi cn wral crab
        wss wa cle wbr cr cc0 nnre ad2antlr 2nn cpw cfn cin inss1 eulerpartleme
        wf cima csu simp1bi ffvelrn wf1o ackbijnn f1ocnv f1of mp2b ffvelrni syl
        sylan sseldi elpwi sselda nnexpcl sylancr simplr nnnn0 nn0ge0 lemulge12
        3syl nnge1 syl22anc cuz cz wb syl6eleq nnmulcl syl2anc nnz elfz5 mpbird
        nnuz oveq2 eleq2d syl5ibcom rexlimdva ralrimiva rabss sylibr ) DFSZUAJU
        BZUCUDZCUBZUEUDZLUFZJXODUGZKUHZUGZUIZXOUJLUKUDZSZULZCUMUNYACUMUOYBUPXLY
        DCUMXLXOUMSZUQZXQYCJXTYFXMXTSZUQZXOUJXPUKUDZSZXQYCYHYJXOXPURUSZYHXOUTSZ
        XNUTSZVAXOURUSZUJXNURUSZYKYEYLXLYGXOVBVCYHXNUMSZYMYHUAUMSXMTSYPVDYFXTTX
        MYFXTTVEZSXTTUPYFYQVFVGZYQXTYQVFVHYFXRTSZXTYRSXLUMTDVJZYEYSXLYTDUHUMVKV
        FSUMIUBZDUGUUAUEUDIVLMUFDFGIMOVIVMUMTXODVNWBTYRXRXSYRTKVOTYRXSVOTYRXSVJ
        ABKRVPYRTKVQTYRXSVRVSVTWAWCXTTWDWAWEUAXMWFWGZXNVBWAYHYEXOTSYNXLYEYGWHZX
        OWIXOWJWLYHYPYOUUBXNWMWAXOXNWKWNYHXOUJWOUGZSXPWPSZYJYKWQYHXOUMUUDUUCXDW
        RYHXPUMSZUUEYHYPYEUUFUUBUUCXNXOWSWTXPXAWAXOUJXPXBWTXCXQYIYBXOXPLUJUKXEX
        FXGXHXIYACUMYBXJXK @.
        @( [26-Jan-2015] @)

      eulerpart.g @e |- G = ( o e. P |-> ( m e. NN |-> ( # `
     { t e. NN | E. n e. ( `' F ` ( o ` t ) ) ( ( 2 ^ n ) x. t ) = m } ) ) ) @.
      @( Lemma for ~ eulerpart . @)
      eulerpartlemf @p |- ( A e. P -> ( G ` A ) = ( m e. NN |-> ( # `
     { t e. NN | E. n e. ( `' F ` ( A ` t ) ) ( ( 2 ^ n ) x. t ) = m } ) ) ) @=
        ( cn c2 cv cexp co cmul wceq cfv ccnv wrex crab chash cmpt fveq1 fveq2d
        rexeqdv rabbidv mpteq2dv nnex mptex fvmpt ) LDJUBUCKUDUEUFCUDZUGUFJUDUH
        ZKVCLUDZUIZMUJZUIZUKZCUBULZUMUIZUNJUBVDKVCDUIZVGUIZUKZCUBULZUMUIZUNFNVE
        DUHZJUBVKVPVQVJVOUMVQVIVNCUBVQVDKVHVMVQVFVLVGVCVEDUOUPUQURUPUSUAJUBVPUT
        VAVB @.
        @( [26-Jan-2015] @)

      @( Lemma for ~ eulerpart . @)
      eulerpartlema @p |- G : P --> P @=
        ? @.

      @( Lemma for ~ eulerpart . @)
      eulerpartlemh @p |- ( G |` O ) : O --> D @=
        ? @.

      @( Lemma for ~ eulerpart . @)
      eulerpartlemc @p |- ( G |` O ) : O -1-1-> D @=
        ? @.

      @( Lemma for ~ eulerpart . @)
      eulerpartlemg @p |- ( G |` O ) : O -1-1-onto-> D @=
        ? @.

      eulerpart.h @e |- H = ( d e. P |-> ( m e. NN |-> if ( 2 || m , 0 ,
    sum_ n e. NN0 ( ( d ` ( ( 2 ^ n ) x. m ) ) x. ( ( 2 ^ n ) x. m ) ) ) ) ) @.
      @( Lemma for ~ eulerpart . @)
      eulerpartlemj @p |- H : P --> O @=
        ? @.

      @( Lemma for ~ eulerpart . @)
      eulerpartlemk @p |- ( H |` D ) : D -1-1-> O @=
        ? @.

      @( Lemma for ~ eulerpart . @)
      eulerpartleml @p |- ( H |` D ) : D -1-1-onto-> O @=
        ? @.

    @}

    @( Euler's theorem on partitions, also known as a special case of
       Glaisher's theorem. Let ` P ` be the set of all partitions of ` N ` ,
       represented as multisets of natural numbers, which is to say functions
       from ` NN ` to ` NN0 ` where the value of the function represents the
       number of repetitions of an individual element, and the sum of all the
       elements with repetition equals ` N ` . Then the set ` O ` of all
       partitions that only consist of odd numbers and the set ` D ` of all
       partitions which have no repeated elements have the same cardinality. @)
    eulerpart @p |- ( N e. NN0 -> ( # ` O ) = ( # ` D ) ) @=
      ? @.
  @}
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                The Kuratowski closure-complement theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    kur14lem1.a $e |- A C_ X $.
    kur14lem1.c $e |- ( X \ A ) e. T $.
    kur14lem1.k $e |- ( K ` A ) e. T $.
    $( Lemma for ~ kur14 .  (Contributed by Mario Carneiro, 17-Feb-2015.) $)
    kur14lem1 $p |- ( N = A ->
      ( N C_ X /\ { ( X \ N ) , ( K ` N ) } C_ T ) ) $=
      ( wceq wss cdif cfv cpr sseq1 mpbiri difeq2 fveq2 preq12d wcel prssi jca
      mp2an syl6eqss ) DAIZDEJZEDKZDCLZMZBJUDUEAEJFDAENOUDUHEAKZACLZMZBUDUFUIUG
      UJDAEPDACQRUIBSUJBSUKBJGHUIUJBTUBUCUA $.
  $}

  ${
    $d s x A $.  $d s x K $.  $d s x y T $.  $d s x y X $.
    kur14lem.j $e |- J e. Top $.
    kur14lem.x $e |- X = U. J $.
    kur14lem.k $e |- K = ( cls ` J ) $.
    kur14lem.i $e |- I = ( int ` J ) $.
    kur14lem.a $e |- A C_ X $.
    $( Lemma for ~ kur14 .  Write interior in terms of closure and complement:
       ` i A = c k c A ` where ` c ` is complement and ` k ` is closure.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    kur14lem2 $p |- ( I ` A ) = ( X \ ( K ` ( X \ A ) ) ) $=
      ( cnt cfv cdif ccl ctop wcel wss wceq ntrval2 fveq1i difeq2i 3eqtr4i
      mp2an ) ACKLZLZEEAMZCNLZLZMZABLEUFDLZMCOPAEQUEUIRFJACEGSUCABUDITUJUHEUFDU
      GHTUAUB $.

    $( Lemma for ~ kur14 .  A closure is a subset of the base set.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    kur14lem3 $p |- ( K ` A ) C_ X $=
      ( cfv ccl fveq1i ctop wcel wss clsss3 mp2an eqsstri ) ADKACLKZKZEADTHMCNO
      AEPUAEPFJACEGQRS $.

    $( Lemma for ~ kur14 .  Complementation is an involution on the set of
       subsets of a topology.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    kur14lem4 $p |- ( X \ ( X \ A ) ) = A $=
      ( wss cdif wceq dfss4 mpbi ) AEKEEALLAMJAENO $.

    $( Lemma for ~ kur14 .  Closure is an idempotent operation in the set of
       subsets of a topology.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    kur14lem5 $p |- ( K ` ( K ` A ) ) = ( K ` A ) $=
      ( ccl cfv ctop wcel wss wceq clsidm mp2an fveq1i fveq12i 3eqtr4i ) ACKLZL
      ZUBLZUCADLZDLUECMNAEOUDUCPFJACEGQRUEUCDUBHADUBHSZTUFUA $.

    kur14lem.b $e |- B = ( X \ ( K ` A ) ) $.
    $( Lemma for ~ kur14 .  If ` k ` is the complementation operator and ` k `
       is the closure operator, this expresses the identity
       ` k c k A = k c k c k c k A ` for any subset ` A ` of the topological
       space.  This is the key result that lets us cut down long enough
       sequences of ` c k c k ... ` that arise when applying closure and
       complement repeatedly to ` A ` , and explains why we end up with a
       number as large as ` 1 4 ` , yet no larger.  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    kur14lem6 $p |- ( K ` ( I ` ( K ` B ) ) ) = ( K ` B ) $=
      ( cfv wss cdif eqsstri fveq1i clsss mp3an 3sstr4i ccl ctop wcel kur14lem3
      difss cnt ntrss2 mp2an kur14lem5 sseqtri kur14lem2 fveq2i difeq2i 3eqtr2i
      eqtr3i sscon ax-mp eqssi ) BEMZCMZEMZUSVAUSEMZUSUTDUAMZMZUSVCMZVAVBDUBUCZ
      USFNZUTUSNVDVENGBCDEFGHIJBFAEMZOZFLFVHUEPZUDZUTUSDUFMZMZUSUSCVLJQVFVGVMUS
      NGVKUSDFHUGUHPUSUTDFHRSUTEVCIQZUSEVCIQTBCDEFGHIJVJUIUJBVCMZVDUSVAVFUTFNBU
      TNVOVDNGUTFFUSOZEMZOZFUSCDEFGHIJVKUKZFVQUEPVIVRBUTVQVHNVIVRNVPVCMZVHVCMZV
      QVHVFVHFNZVPVHNVTWANGACDEFGHIJKUDZVPVHVLMZVHVPFVIEMZOVHCMWDUSWEFBVIELULUM
      VHCDEFGHIJWCUKVHCVLJQUNVFWBWDVHNGWCVHDFHUGUHPVHVPDFHRSVPEVCIQVHEMVHWAACDE
      FGHIJKUIVHEVCIQUOTVQVHFUPUQLVSTUTBDFHRSBEVCIQVNTUR $.

    kur14lem.c $e |- C = ( K ` ( X \ A ) ) $.
    kur14lem.d $e |- D = ( I ` ( K ` A ) ) $.
    kur14lem.t $e |- T = ( ( ( { A , ( X \ A ) , ( K ` A ) } u.
      { B , C , ( I ` A ) } ) u. { ( K ` B ) , D , ( K ` ( I ` A ) ) } ) u.
      ( { ( I ` C ) , ( K ` D ) , ( I ` ( K ` B ) ) } u.
      { ( K ` ( I ` C ) ) , ( I ` ( K ` ( I ` A ) ) ) } ) ) $.
    $( Lemma for ~ kur14 : main proof.  The set ` T ` here contains all the
       distinct combinations of ` k ` and ` c ` that can arise, and we prove
       here that applying ` k ` or ` c ` to any element of ` T ` yields another
       elemnt of ` T ` .  In operator shorthand, we have
       ` T = { A , c A , k A `
       ` , c k A , k c A , c k c A , k c k A , c k c k A , k c k c A , `
       ` c k c k c A , k c k c k A , c k c k c k A , k c k c k c A , `
       ` c k c k c k c A } ` .  From the identities ` c c A = A ` and
       ` k k A = k A ` , we can reduce any operator combination containing two
       adjacent identical operators, which is why the list only contains
       alternating sequences.  The reason the sequences don't keep going after
       a certain point is due to the identity ` k c k A = k c k c k c k A ` ,
       proved in ~ kur14lem6 .  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    kur14lem7 $p |- ( N e. T ->
      ( N C_ X /\ { ( X \ N ) , ( K ` N ) } C_ T ) ) $=
      ( cdif wss cfv cpr wa ctp cun wcel wo elun w3o eltpi ssun1 sseqtr4i sstri
      wceq ctop topopn ax-mp elexi difss ssexi tpid2 sselii kur14lem1 kur14lem4
      fvex tpid3 tpid1 eqeltri ssun2 kur14lem3 eqsstri eqeltrri kur14lem5 3jaoi
      syl difeq2i eqtri kur14lem2 eqtr4i fveq2i 3eqtr4i eqtr3i jaoi sylbi prid1
      kur14lem6 elpri prid2 eleq2s ) IJUAJITIHUBUCEUAUDZIAJATZAHUBZUEZBCAFUBZUE
      ZUFZBHUBZDWOHUBZUEZUFZCFUBZDHUBZWRFUBZUEZXBHUBZWSFUBZUCZUFZUFZEIXJUGIXAUG
      ZIXIUGZUHWKIXAXIUIXKWKXLXKIWQUGZIWTUGZUHWKIWQWTUIXMWKXNXMIWNUGZIWPUGZUHWK
      IWNWPUIXOWKXPXOIAUOZIWLUOZIWMUOZUJWKIAWLWMUKXQWKXRXSAEHIJOWNEWLWNWQEWNWPU
      LWQXAEWQWTULXAXJEXAXIULSUMZUNZUNZAWLWMWLJJGGUPUGJGUGKGJLUQURUSZJAUTZVAVBV
      CWNEWMYBAWLWMAHVFVGVCZVDWLEHIJYDJWLTAEAFGHJKLMNOVEWNEAYBAWLWMAJYCOVAVHVCV
      ICWLHUBZEQWPECWPWQEWPWNVJYAUNZBCWOCJYCCYFJQWLFGHJKLMNYDVKVLZVAVBVCZVMVDWM
      EHIJAFGHJKLMNOVKZBJWMTZEPWPEBYGBCWOBJYCBYKJPJWMUTVLZVAVHVCVMWMHUBWMEAFGHJ
      KLMNOVNYEVIVDVOVPXPIBUOZICUOZIWOUOZUJWKIBCWOUKYMWKYNYOBEHIJYLJBTZWMEYPJYK
      TWMBYKJPVQWMFGHJKLMNYJVEVRYEVIWTEWRWTXAEWTWQVJXTUNZWRDWSBHVFVHVCZVDCEHIJY
      HJCTZWOEYSJYFTZWOCYFJQVQAFGHJKLMNOVSZVTZWPEWOYGBCWOAFVFVGVCVICHUBZCEYFHUB
      YFUUCCWLFGHJKLMNYDVNCYFHQWAQWBYIVIVDWOEHIJWOYTJUUAJYFUTVLZJWOTZCEJYSTUUEC
      YSWOJUUBVQCFGHJKLMNYHVEWCYIVIWTEWSYQWRDWSWOHVFVGVCZVDVOVPWDWEXNIWRUOZIDUO
      ZIWSUOZUJWKIWRDWSUKUUGWKUUHUUIWREHIJBFGHJKLMNYLVKZDJWRTZEWMFUBZJYKHUBZTZD
      UUKWMFGHJKLMNYJVSZRWRUUMJBYKHPWAVQWBZWTEDYQWRDWSDJYCDUUNJDUULUUNRUUOVRJUU
      MUTVLZVAVBVCVMWRHUBWREBFGHJKLMNYLVNYRVIVDDEHIJUUQJDTZWREUURJUUKTWRDUUKJUU
      PVQWRFGHJKLMNUUJVEVRYRVIXEEXCXEXIEXEXHULXIXJEXIXAVJSUMZUNZXBXCXDDHVFVBVCZ
      VDWSEHIJWOFGHJKLMNUUDVKZXBJWSTZEXBJYSHUBZTZUVCCFGHJKLMNYHVSZUVDWSJYSWOHUU
      BWAVQVRZXEEXBUUTXBXCXDCFVFVHVCVMWSHUBWSEWOFGHJKLMNUUDVNUUFVIVDVOVPWDWEXLI
      XEUGZIXHUGZUHWKIXEXHUIUVHWKUVIUVHIXBUOZIXCUOZIXDUOZUJWKIXBXCXDUKUVJWKUVKU
      VLXBEHIJXBUVEJUVFJUVDUTVLZJXBTZWSEUVNJUVCTWSXBUVCJUVGVQWSFGHJKLMNUVBVEVRU
      UFVIXHEXFXHXIEXHXEVJUUSUNZXFXGXBHVFWFVCZVDXCEHIJDFGHJKLMNUUQVKZJXCTZXDEUV
      RJUUKHUBZTZXDXCUVSJDUUKHUUPWAVQWRFGHJKLMNUUJVSZVTZXEEXDUUTXBXCXDWRFVFVGVC
      VIXCHUBXCEDFGHJKLMNUUQVNUVAVIVDXDEHIJXDUVTJUWAJUVSUTVLJXDTZXCEJUVRTUWCXCU
      VRXDJUWBVQXCFGHJKLMNUVQVEWCUVAVIXDHUBWREABFGHJKLMNOPWGYRVIVDVOVPUVIIXFUOZ
      IXGUOZUHWKIXFXGWHUWDWKUWEXFEHIJXBFGHJKLMNUVMVKZJXFTZXGEUWGJUVCHUBZTZXGXFU
      WHJXBUVCHUVGWAVQWSFGHJKLMNUVBVSZVTZXHEXGUVOXFXGWSFVFWIVCVIXFHUBXFEXBFGHJK
      LMNUVMVNUVPVIVDXGEHIJXGUWIJUWJJUWHUTVLJXGTZXFEJUWGTUWLXFUWGXGJUWKVQXFFGHJ
      KLMNUWFVEWCUVPVIXGHUBWSEWLWOFGHJKLMNYDUUAWGUUFVIVDWDVPWDWEWDWESWJ $.

    $( Lemma for ~ kur14 .  Show that the set ` T ` contains at most ` 1 4 `
       elements.  (It could be less if some of the operators take the same
       value for a given set, but Kuratowski showed that this upper bound of
       ` 1 4 ` is tight in the sense that there exist topological spaces and
       subsets of these spaces for which all ` 1 4 ` generated sets are
       distinct, and indeed the real numbers form such a topological space.)
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    kur14lem8 $p |- ( T e. Fin /\ ( # ` T ) <_ ; 1 4 ) $=
      ( cfv ctp cdif cun cpr c9 c5 c1 c4 c6 eqid hashtplei 3nn0 3p3e6 hashunlei
      cdc c3 6nn0 6p3e9 c2 hashprlei 2nn0 3p2e5 9nn0 5nn0 9p5e14 ) AIAUAZAHSZTZ
      BCAFSZTZUBZBHSZDVHHSZTZUBZCFSZDHSZVKFSZTZVOHSZVLFSZUCZUBZEUDUEUFUGUNRVJVM
      VNUHUOUDVNUIVGVIVJUOUOUHVJUIAVEVFUJBCVHUJUKUKULUMVKDVLUJUPUKUQUMVRWAWBUOU
      RUEWBUIVOVPVQUJVSVTUSUKUTVAUMVBVCVDUM $.

    kur14lem.s $e |- S = |^| { x e. ~P ~P X |
      ( A e. x /\ A. y e. x { ( X \ y ) , ( K ` y ) } C_ x ) } $.
    $( Lemma for ~ kur14 .  Since the set ` T ` is closed under closure and
       complement, it contains the minimal set ` S ` as a subset, so ` S ` also
       has at most ` 1 4 ` elements.  (Indeed ` S = T ` , and it's not hard to
       prove this, but we don't need it for this proof.)  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    kur14lem9 $p |- ( S e. Fin /\ ( # ` S ) <_ ; 1 4 ) $=
      ( vs c1 c4 cdc cv wcel cdif cfv cpr wss wral wa cpw crab cint wi elintrab
      vex ctp cun ssun1 sseqtr4i sstri topopn ax-mp elexi ssexi tpid1 kur14lem7
      ctop sselii simprd simpld elpw2 sylibr ssriv mpbir eleq2 sseq2 raleqbi1dv
      rgen pwex wceq anbi12d imbi12d rspccv mp2ani sylbi eqsstri kur14lem8 1nn0
      mpi 4nn0 deccl hashsslei ) HGUDUEUFGCAUGZUHZLBUGZUIWTKUJUKZWRULZBWRUMZUNZ
      ALUOZUOZUPUQZHUBUCXGHUCUGZXGUHXDXHWRUHZURZAXFUMZXHHUHZXDAXHXFUCUTUSXKCHUH
      ZXAHULZBHUMZXLCLCUIZCKUJZVAZHCXRXRDECIUJZVAZVBZHXRXTVCYAYADKUJZFXSKUJZVAZ
      VBZHYAYDVCYEYEEIUJZFKUJYBIUJVAYFKUJYCIUJUKVBZVBHYEYGVCUAVDVEVECXPXQCLLJJV
      LUHLJUHMJLNVFVGVHZQVIVJVMXNBHWTHUHZWTLULZXNCDEFHIJKWTLMNOPQRSTUAVKZVNWCXK
      HXFUHZXMXOUNZXLURZYLHXEULBHXEYIYJWTXEUHYIYJXNYKVOWTLYHVPVQVRHXELYHWDVPVSX
      JYNAHXFWRHWEZXDYMXIXLYOWSXMXCXOWRHCVTXBXNBWRHWRHXAWAWBWFWRHXHVTWGWHWNWIWJ
      VRWKCDEFHIJKLMNOPQRSTUAWLUDUEWMWOWPWQ $.
  $}

  ${
    $d x y A $.  $d x y J $.  $d x y K $.  $d x y X $.
    kur14lem10.j $e |- J e. Top $.
    kur14lem10.x $e |- X = U. J $.
    kur14lem10.k $e |- K = ( cls ` J ) $.
    kur14lem10.s $e |- S = |^| { x e. ~P ~P X |
      ( A e. x /\ A. y e. x { ( X \ y ) , ( K ` y ) } C_ x ) } $.
    kur14lem10.a $e |- A C_ X $.
    $( Lemma for ~ kur14 .  Discharge the set ` T ` .  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    kur14lem10 $p |- ( S e. Fin /\ ( # ` S ) <_ ; 1 4 ) $=
      ( cfv cdif cnt ctp cun cpr eqid kur14lem9 ) ABCGCFMZNZGCNZFMZUAEOMZMZDCUC
      UAPUBUDCUEMZPQUBFMZUFUGFMZPQUDUEMZUFFMUHUEMPUJFMUIUEMRQQZUEEFGHIJUESLUBSU
      DSUFSUKSKT $.
  $}

  ${
    $d x y A $.  $d x y J $.  $d x X $.
    kur14.x $e |- X = U. J $.
    kur14.k $e |- K = ( cls ` J ) $.
    kur14.s $e |- S = |^| { x e. ~P ~P X |
      ( A e. x /\ A. y e. x { ( X \ y ) , ( K ` y ) } C_ x ) } $.
    $( Kuratowski's closure-complement theorem.  There are at most 14 sets
       which can be obtained by the application of the closure and complement
       operations to a set in a topological space.  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    kur14 $p |- ( ( J e. Top /\ A C_ X ) ->
      ( S e. Fin /\ ( # ` S ) <_ ; 1 4 ) ) $=
      ( wss ctop wcel cfn chash cfv cle wa c0 cpw c1 c4 cdc wbr cif cv cdif cpr
      wral crab cint csn cuni ccl wceq eleq1 anbi1d inteqd syl5eq eleq1d fveq2d
      rabbidv breq1d anbi12d unieq pweqd sseq2d cvv sn0top elimel ax-mp syl6bbr
      uniexg elpw2 ifbid difeq1d fveq2 fveq1d preq12d sseq1d ralbidv eqid 0elpw
      rabeqbidv elpwi kur14lem10 dedth2h ancoms ) CGKZELMZDNMZDOPZUAUBUCZQUDZRZ
      WIWJWOWICSUEZAUFZMZGBUFZUGZWSFPZUHZWQKZBWQUIZRZAGTZTZUJZUKZNMZXIOPZWMQUDZ
      RCWJESULZUEZUMZTZMZCSUEZWQMZXOWSUGZWSXNUNPZPZUHZWQKZBWQUIZRZAXPTZUJZUKZNM
      ZYIOPZWMQUDZRCESXMCWPUOZWKXJWNXLYMDXINYMDCWQMZXDRZAXGUJZUKXIJYMYPXHYMYOXE
      AXGYMYNWRXDCWPWQUPUQVBURUSZUTYMWLXKWMQYMDXIOYQVAVCVDEXNUOZXJYJXLYLYRXIYIN
      YRXHYHYRXEYFAXGYGYRXFXPYRGXOYRGEUMXOHEXNVEUSZVFVFYRWRXSXDYEYRWPXRWQYRWIXQ
      CSYRWICXOKXQYRGXOCYSVGCXOXNLMXOVHMEXMLVIVJZXNLVMVKVNVLVOUTYRXCYDBWQYRXBYC
      WQYRWTXTXAYBYRGXOWSYSVPYRWSFYAYRFEUNPYAIEXNUNVQUSVRVSVTWAVDWDURZUTYRXKYKW
      MQYRXIYIOUUAVAVCVDABXRYIXNYAXOYTXOWBYAWBYIWBXRXPMXRXOKCSXPXOWCVJXRXOWEVKW
      FWGWH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Retracts and sections
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Retr $.

  $( Extend class notation with the retract relation. $)
  cretr $a class Retr $.

  ${
    $d j k r s $.
    $( Define the set of retractions on two topological spaces.  We say that
       ` R ` is a retraction from ` J ` to ` K ` . or ` R e. ( J Retr K ) ` iff
       there is an ` S ` such that ` R : J --> K , S : K --> J ` are continuous
       functions called the retraction and section respectively, and their
       composite ` R o. S ` is homotopic to the identity map.  If a retraction
       exists, we say ` J ` is a retract of ` K ` .  (This terminology is
       borrowed from HoTT and appears to be nonstandard, although it has
       similaries to the concept of retract in the category of topological
       spaces and to a deformation retract in general topology.)  Two
       topological spaces that are retracts of each other are called homotopy
       equivalent.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    df-retr $a |- Retr = ( j e. Top , k e. Top |-> { r e. ( j Cn k ) |
   E. s e. ( k Cn j ) ( ( r o. s ) ( j Htpy j ) ( _I |` U. j ) ) =/= (/) } ) $.
  $}

  ${
    $( Exponentiation of negative one to an even power.  (Contributed by Scott
       Fenton, 17-Jan-2018.) $)
    m1expevenALT $p |- ( N e. ZZ -> ( -u 1 ^ ( 2 x. N ) ) = 1 ) $=
      ( cz wcel c1 cneg c2 cmul co cexp caddc zcn 2timesd oveq2d wceq cc neg1cn
      ax-1cn anidms oveq12 syl6eq cc0 wne wa ax-1ne0 negne0i expaddz mpanl12 wo
      cpr m1expcl2 ovex elpr mulm1i negnegi eqtri 1t1e1 jaoi sylbi syl 3eqtrd )
      ABCZDEZFAGHZIHVBAAJHZIHZVBAIHZVFGHZDVAVCVDVBIVAAAKLMVAVEVGNZVBOCVBUAUBVAV
      AUCVHPDQUDUEVBAAUFUGRVAVFVBDUICZVGDNZAUJVIVFVBNZVFDNZUHVJVFVBDVBAIUKULVKV
      JVLVKVGVBVBGHZDVKVGVMNVFVBVFVBGSRVMVBEDVBPUMDQUNUOTVLVGDDGHZDVLVGVNNVFDVF
      DGSRUPTUQURUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Path-connected and simply connected spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c PCon $.
  $c SCon $.

  $( Extend class notation with the class of path-connected topologies. $)
  cpcon $a class PCon $.

  $( Extend class notation with the class of simply connected topologies. $)
  cscon $a class SCon $.

  ${
    $d f j x y $.
    $( Define the class of path-connected topologies.  A topology is
       path-connected if there is a path (a continuous function from the unit
       interval) that goes from ` x ` to ` y ` for any points ` x , y ` in the
       space.  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    df-pcon $a |- PCon = { j e. Top | A. x e. U. j A. y e. U. j
      E. f e. ( II Cn j ) ( ( f ` 0 ) = x /\ ( f ` 1 ) = y ) } $.

    $( Define the class of simply connected topologies.  A topology is simply
       connected if it is path-connected and every loop (continuous path with
       identical start and endpoint) is contractible to a point (path-homotopic
       to a constant function).  (Contributed by Mario Carneiro, 11-Feb-2015.)
       (New usage is discouraged.) $)
    df-scon $a |- SCon = { j e. PCon | A. f e. ( II Cn j ) ( ( f ` 0 ) =
      ( f ` 1 ) -> f ( ~=ph ` j ) ( ( 0 [,] 1 ) X. { ( f ` 0 ) } ) ) } $.
  $}

  ${
    $d f x y A $.  $d f y B $.  $d f j x y J $.  $d j x y X $.
    ispcon.1 $e |- X = U. J $.
    $( The property of being a path-connected topological space.  (Contributed
       by Mario Carneiro, 11-Feb-2015.) $)
    ispcon $p |- ( J e. PCon <-> ( J e. Top /\ A. x e. X A. y e. X
      E. f e. ( II Cn J ) ( ( f ` 0 ) = x /\ ( f ` 1 ) = y ) ) ) $=
      ( vj cc0 cv cfv wceq c1 wa cii ccn co wrex cuni wral raleqbidv ctop cpcon
      unieq syl6eqr oveq2 rexeqdv df-pcon elrab2 ) HCIZJAIKLUIJBIKMZCNGIZOPZQZB
      UKRZSZAUNSUJCNDOPZQZBESZAESGDUAUBUKDKZUOURAUNEUSUNDREUKDUCFUDZUSUMUQBUNEU
      TUSUJCULUPUKDNOUEUFTTABCGUGUH $.

    $( The property of being a path-connected topological space.  (Contributed
       by Mario Carneiro, 11-Feb-2015.) $)
    pconcn $p |- ( ( J e. PCon /\ A e. X /\ B e. X ) ->
      E. f e. ( II Cn J ) ( ( f ` 0 ) = A /\ ( f ` 1 ) = B ) ) $=
      ( vx vy cpcon wcel cc0 cv cfv wceq c1 wa wrex wral eqeq2 rexbidv cii ctop
      ccn co ispcon simprbi anbi1d anbi2d rspc2v syl5com 3impib ) DIJZAEJZBEJZK
      CLZMZANZOUOMZBNZPZCUADUCUDZQZULUPGLZNZURHLZNZPZCVAQZHERGERZUMUNPVBULDUBJV
      IGHCDEFUEUFVHVBUQVFPZCVAQGHABEEVCANZVGVJCVAVKVDUQVFVCAUPSUGTVEBNZVJUTCVAV
      LVFUSUQVEBURSUHTUIUJUK $.
  $}

  ${
    $d f F $.  $d f j x y J $.
    $( A simply connected space is a topology.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    pcontop $p |- ( J e. PCon -> J e. Top ) $=
      ( vf vx vy cpcon wcel ctop cc0 cv cfv wceq c1 cii ccn wrex cuni wral eqid
      wa co ispcon simplbi ) AEFAGFHBIZJCIKLUCJDIKSBMANTODAPZQCUDQCDBAUDUDRUAUB
      $.

    $( The property of being a simply connected topological space.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    isscon $p |- ( J e. SCon <-> ( J e. PCon /\ A. f e. ( II Cn J )
     ( ( f ` 0 ) = ( f ` 1 ) ->
       f ( ~=ph ` J ) ( ( 0 [,] 1 ) X. { ( f ` 0 ) } ) ) ) ) $=
      ( vj cc0 cv cfv c1 wceq cicc co csn cxp cphtpc wbr wi cii ccn cpcon cscon
      wral oveq2 fveq2 breqd imbi2d raleqbidv df-scon elrab2 ) DAEZFZGUHFHZUHDG
      IJUIKLZCEZMFZNZOZAPULQJZTUJUHUKBMFZNZOZAPBQJZTCBRSULBHZUOUSAUPUTULBPQUAVA
      UNURUJVAUMUQUHUKULBMUBUCUDUEACUFUG $.

    $( A simply connected space is path-connected.  (Contributed by Mario
       Carneiro, 11-Feb-2015.) $)
    sconpcon $p |- ( J e. SCon -> J e. PCon ) $=
      ( vf cscon wcel cpcon cc0 cv cfv c1 wceq co csn cxp cphtpc wbr wi cii ccn
      cicc wral isscon simplbi ) ACDAEDFBGZHZIUCHJUCFISKUDLMANHOPBQARKTBAUAUB
      $.

    $( A simply connected space is a topology.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    scontop $p |- ( J e. SCon -> J e. Top ) $=
      ( cscon wcel cpcon ctop sconpcon pcontop syl ) ABCADCAECAFAGH $.

    $( A closed path in a simply connected space is contractible to a point.
       (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    sconpht $p |- ( ( J e. SCon /\ F e. ( II Cn J ) /\ ( F ` 0 ) = ( F ` 1 ) )
      -> F ( ~=ph ` J ) ( ( 0 [,] 1 ) X. { ( F ` 0 ) } ) ) $=
      ( vf cscon wcel cii ccn co cc0 cfv c1 wceq csn cxp cphtpc wbr cv wi fveq1
      cicc wral cpcon isscon simprbi eqeq12d id sneqd xpeq2d breq12d rspccv syl
      imbi12d 3imp ) BDEZAFBGHZEZIAJZKAJZLZAIKTHZUQMZNZBOJZPZUNICQZJZKVEJZLZVEU
      TVFMZNZVCPZRZCUOUAZUPUSVDRZRUNBUBEVMCBUCUDVLVNCAUOVEALZVHUSVKVDVOVFUQVGUR
      IVEASZKVEASUEVOVEAVJVBVCVOUFVOVIVAUTVOVFUQVPUGUHUIULUJUKUM $.
  $}

  ${
    $d f g u v x y F $.  $d g u v x y J $.  $d f g u v x y K $.  $d g u v X $.
    $d g u v x y Y $.
    cnpcon.2 $e |- Y = U. K $.
    $( An image of a path-connected space is path-connected.  (Contributed by
       Mario Carneiro, 24-Mar-2015.) $)
    cnpcon $p |- ( ( J e. PCon /\ F : X -onto-> Y /\ F e. ( J Cn K ) ) ->
      K e. PCon ) $=
      ( vf vx vy vu vv vg wcel cc0 cv cfv wceq c1 wa wral cpcon wfo ccn co ctop
      w3a cii wrex cntop2 3ad2ant3 cuni eqid pconcn 3expb 3ad2antl1 ccom simprl
      simpll3 cnco syl2anc cicc wf iiuni cnf syl 0elunit sylancl simprrl fveq2d
      fvco3 1elunit simprrr eqeq1d anbi12d rspcev syl12anc rexlimddv ralrimivva
      eqtrd fveq1 crn forn 3ad2ant2 dffo2 sylanbrc eqeq2 anbi2d rexbidv ralbidv
      wb cbvfo mpbid anbi1d ispcon ) BUAMZDEAUBZABCUCUDMZUFZCUEMZNGOZPZHOZQZRWT
      PZIOZQZSZGUGCUCUDZUHZIETZHETZCUAMWQWOWSWPABCUIUJWRXAJOZAPZQZXFSZGXHUHZIET
      ZJBUKZTZXKWRXNXDKOZAPZQZSZGXHUHZKXRTZJXRTXSWRYDJKXRXRWRXLXRMZXTXRMZSZSZNL
      OZPZXLQZRYJPZXTQZSZYDLUGBUCUDZWOWPYHYOLYPUHZWQWOYFYGYQXLXTLBXRXRULZUMUNUO
      YIYJYPMZYOSZSZAYJUPZXHMZNUUBPZXMQZRUUBPZYAQZYDUUAYSWQUUCYIYSYOUQZWOWPWQYH
      YTURYJAUGBCUSUTUUAUUDYKAPZXMUUANRVAUDZXRYJVBZNUUJMUUDUUIQUUAYSUUKUUHYJUGB
      UUJXRVCYRVDVEZVFUUJXRNAYJVJVGUUAYKXLAYIYSYLYNVHVIVSUUAUUFYMAPZYAUUAUUKRUU
      JMUUFUUMQUULVKUUJXRRAYJVJVGUUAYMXTAYIYSYLYNVLVIVSYCUUEUUGSGUUBXHWTUUBQZXN
      UUEYBUUGUUNXAUUDXMNWTUUBVTVMUUNXDUUFYARWTUUBVTVMVNVOVPVQVRWRYEXQJXRWRXREA
      UBZYEXQWJWRXREAVBZAWAEQZUUOWQWOUUPWPABCXREYRFVDUJWPWOUUQWQDEAWBWCXREAWDWE
      ZYDXPKIXREAYAXEQZYCXOGXHUUSYBXFXNYAXEXDWFWGWHWKVEWIWLWRUUOXSXKWJUURXQXJJH
      XREAXMXBQZXPXIIEUUTXOXGGXHUUTXNXCXFXMXBXAWFWMWHWIWKVEWLHIGCEFWNWE $.
  $}

  ${
    $d a b f x y J $.  $d f g h t u v w x y z R $.  $d f g h t u v w x y z S $.
    $d f g i t x y z A $.  $d f g i t x y z F $.  $d g i t x y z V $.
    $( A path-connected space is connected.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    pconcon $p |- ( J e. PCon -> J e. Con ) $=
      ( vx vy va vb vf wcel cv c0 wne wceq wa wex cc0 cfv c1 cii syl2anc adantr
      simplrr cpcon ccon cin w3a cun cuni wi df-3an n0 anbi12i eeanv bitr4i ccn
      wral co wrex simpll simprll simplrl elunii simprlr eqid pconcn syl3anc wn
      adantl cicc iiuni iicon a1i cdif ccld uncom simprr syl5eq wss elssuni syl
      wf wb incom uneqdifeq mpbid ctop pcontop ad3antrrr opncld 0elunit eqeltrd
      eqeltrrd 1elunit ffvelrn sylancl inelcm pm2.21ddne expr pm2.01d rexlimddv
      concn exp32 exlimdvv syl5bi imp3a ralrimivva ctopon toptopon sylib dfcon2
      neneqad mpbird ) AUAGZAUBGZBHZIJZCHZIJZXMXOUCZIKZUDZXMXOUEZAUFZJZUGZCAUNB
      AUNZXKYCBCAAXSXNXPLZXRLXKXMAGZXOAGZLZLZYBXNXPXRUHYIYEXRYBYEDHZXMGZEHZXOGZ
      LZEMDMZYIXRYBUGZYEYKDMZYMEMZLYOXNYQXPYRDXMUIEXOUIUJYKYMDEUKULYIYNYPDEYIYN
      XRYBYIYNXRLZLZNFHZOZYJKZPUUAOZYLKZLZYBFQAUMUOZYTXKYJYAGZYLYAGZUUFFUUGUPXK
      YHYSUQYTYKYFUUHYIYKYMXRURZXKYFYGYSUSZYJXMAUTRYTYMYGUUIYIYKYMXRVAZXKYFYGYS
      TZYLXOAUTRYJYLFAYAYAVBZVCVDYTUUAUUGGZUUFLZLZXTYAUUQXTYAKZYTUUPUURUURVEZYT
      UUPUURLZLZUUSXQIYIYNXRUUTTZUVAYLXMGYMXQIJUVAUUDYLXMUUTUUEYTUUOUUCUUEUURTV
      FUVANPVGUOZXMUUAVSPUVCGUUDXMGUVANXMUUAQAUVCVHQUBGUVAVIVJYTUUOUUFUURURYTYF
      UUTUUKSUVAYAXOVKZXMAVLOZUVAXOXMUEZYAKZUVDXMKZUVAUVFXTYAXOXMVMYTUUPUURVNVO
      UVAXOYAVPZXOXMUCZIKUVGUVHVTUVAYGUVIYTYGUUTUUMSZXOAVQVRUVAUVJXQIXOXMWAUVBV
      OXOXMYAWBRWCUVAAWDGZYGUVDUVEGXKUVLYHYSUUTAWEZWFUVKXOAYAUUNWGRWJNUVCGUVAWH
      VJUVAUUBYJXMUUTUUCYTUUOUUCUUEUURUSVFYTYKUUTUUJSWIWSWKUVCXMPUUAWLWMWJYTYMU
      UTUULSYLXMXOWNRWOWPWQXIWRWTXAXBXCXBXDXKAYAXEOGZXLYDVTXKUVLUVNUVMAYAUUNXFX
      GBCAYAXHVRXJ $.

    $( The topological product of two path-connected spaces is path-connected.
       (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    txpcon $p |- ( ( R e. PCon /\ S e. PCon ) -> ( R tX S ) e. PCon ) $=
      ( vf vu vv vz vw vg vh vt wcel wa co cc0 cv cfv wceq c1 wrex wral vx ctop
      vy cpcon ctx cii ccn cuni pcontop txtop syl2an cxp cop w3a pconcn anim12i
      an6 eqid sylbir reeanv sylibr cicc iiuni txcnmpt ad2antrl 0elunit opeq12d
      cmpt fveq2 fvmpt ax-mp simprrl simpld simprrr syl5eq 1elunit simprd fveq1
      opex eqeq1d anbi12d rspcev syl12anc rexlimdvva mpd 3expa ralrimivva eqeq2
      anbi2d rexbidv ralxp anbi1d 2ralbidv syl5bb txuni raleqdv raleqbidv mpbid
      expr ispcon sylanbrc ) AUDKZBUDKZLZABUEMZUBKZNCOZPZDOZQZRXGPZEOZQZLZCUFXE
      UGMZSZEXEUHZTZDXQTZXEUDKXBAUBKZBUBKZXFXCAUIZBUIZABUJUKXDXPEAUHZBUHZULZTZD
      YFTZXSXDXHUAOZUCOZUMZQZXKFOZGOZUMZQZLZCXOSZGYETFYDTZUCYETUAYDTYHXDYSUAUCY
      DYEXDYIYDKZYJYEKZLZLYRFGYDYEXDUUBYMYDKZYNYEKZLZYRXDUUBUUEUNZNHOZPZYIQZRUU
      GPZYMQZLZNIOZPZYJQZRUUMPZYNQZLZLZIUFBUGMZSHUFAUGMZSZYRUUFUULHUVASZUURIUUT
      SZLZUVBUUFXBYTUUCUNZXCUUAUUDUNZLUVEXBYTUUCXCUUAUUDUQUVFUVCUVGUVDYIYMHAYDY
      DURZUOYJYNIBYEYEURZUOUPUSUULUURHIUVAUUTUTVAUUFUUSYRHIUVAUUTUUFUUGUVAKUUMU
      UTKLZUUSYRUUFUVJUUSLLZJNRVBMZJOZUUGPZUVMUUMPZUMZVHZXOKZNUVQPZYKQZRUVQPZYO
      QZYRUVJUVRUUFUUSJABUFUUGUUMUVQUVLVCUVQURZVDVEUVKUVSUUHUUNUMZYKNUVLKUVSUWD
      QVFJNUVPUWDUVLUVQUVMNQUVNUUHUVOUUNUVMNUUGVIUVMNUUMVIVGUWCUUHUUNVSVJVKUVKU
      UHYIUUNYJUVKUUIUUKUUFUVJUULUURVLZVMUVKUUOUUQUUFUVJUULUURVNZVMVGVOUVKUWAUU
      JUUPUMZYORUVLKUWAUWGQVPJRUVPUWGUVLUVQUVMRQUVNUUJUVOUUPUVMRUUGVIUVMRUUMVIV
      GUWCUUJUUPVSVJVKUVKUUJYMUUPYNUVKUUIUUKUWEVQUVKUUOUUQUWFVQVGVOYQUVTUWBLCUV
      QXOXGUVQQZYLUVTYPUWBUWHXHUVSYKNXGUVQVRVTUWHXKUWAYORXGUVQVRVTWAWBWCWSWDWEW
      FWGWGYGYSDUAUCYDYEYGXJYPLZCXOSZGYETFYDTXIYKQZYSXPUWJEFGYDYEXLYOQZXNUWICXO
      UWLXMYPXJXLYOXKWHWIWJWKUWKUWJYRFGYDYEUWKUWIYQCXOUWKXJYLYPXIYKXHWHWLWJWMWN
      WKVAXDYGXRDYFXQXBXTYAYFXQQXCYBYCABYDYEUVHUVIWOUKZXDXPEYFXQUWMWPWQWRDECXEX
      QXQURWTXA $.

    $( The topological product of a collection of path-connected spaces is
       path-connected.  The proof uses the axiom of choice.  (Contributed by
       Mario Carneiro, 17-Feb-2015.) $)
    ptpcon $p |- ( ( A e. V /\ F : A --> PCon ) -> ( Xt_ ` F ) e. PCon ) $=
      ( vf vx vt vz vi wcel cpcon wa cfv cc0 cv wceq c1 cii wral cmpt fveq2 cpt
      vy vg wf ctop ccn co wrex cuni wss pcontop ssriv fss mpan2 sylan2 cid wfn
      pttop wex ad2antrr eleq2d biimpa simplr ffvelrnda cixp simprl eqid adantr
      fvi ptuni eleqtrrd vex elixp simprd r19.21bi simprr pconcn syl3anc df-rex
      sylib syldan ralrimiva fvex eleq1 fveq1 eqeq1d anbi12d ac6s2 cicc iitopon
      syl ctopon a1i simplll biimpar oveq2d eleq12d fveq1d eqeq12d sylan simpld
      rspccva iiuni cnf feqmptd eqeltrrd ptcn mpteq2dva 0elunit mptexg mpteq2dv
      fvmptg sylancr 3eqtr4d 1elunit rspcev syl12anc exlimddv ralrimivva ispcon
      cvv dffn5 sylanbrc ) ACIZAJBUDZKZBUALZUEIZMDNZLZENZOZPYILZUBNZOZKZDQYGUFU
      GZUHZUBYGUIZREYSRYGJIYEYDAUEBUDZYHYEJUEUJYTEJUEYKUKULAJUEBUMUNZABCURUOYFY
      REUBYSYSYFYKYSIZYNYSIZKZKZUCNZAUPLZUQZFNZUUFLZQUUIBLZUFUGZIZMUUJLZUUIYKLZ
      OZPUUJLZUUIYNLZOZKZKZFUUGRZKZYRUCUUEYIUULIZYJUUOOZYMUUROZKZKZDUSZFUUGRUVC
      UCUSUUEUVIFUUGUUEUUIUUGIZUUIAIZUVIUUEUVJUVKUUEUUGAUUIYDUUGAOZYEUUDACVIUTZ
      VAVBUUEUVKKZUVGDUULUHZUVIUVNUUKJIUUOUUKUIZIZUURUVPIZUVOUUEAJUUIBYDYEUUDVC
      ZVDUUEUVQFAUUEYKAUQZUVQFARZUUEYKFAUVPVEZIUVTUWAKUUEYKYSUWBYFUUBUUCVFYFUWB
      YSOZUUDYEYDYTUWCUUAFABYGCYGVGZVJUOVHZVKFAUVPYKEVLVMVTZVNVOUUEUVRFAUUEYNAU
      QZUVRFARZUUEYNUWBIUWGUWHKUUEYNYSUWBYFUUBUUCVPUWEVKFAUVPYNUBVLVMVTZVNVOUUO
      UURDUUKUVPUVPVGVQVRUVGDUULVSVTWAWBUVHUVAFDUUGUCAUPWCYIUUJOZUVDUUMUVGUUTYI
      UUJUULWDUWJUVEUUPUVFUUSUWJYJUUNUUOMYIUUJWEWFUWJYMUUQUURPYIUUJWEWFWGWGWHWK
      UUEUVCKZGMPWIUGZHAGNZHNZUUFLZLZSZSZYQIMUWRLZYKOZPUWRLZYNOZYRUWKGUWPHBAQYG
      CUWLUWDQUWLWLLIUWKWJWMYDYEUUDUVCWNZUWKYEYTUUEYEUVCUVSVHUUAWKUWKUWNAIZKZUW
      OGUWLUWPSQUWNBLZUFUGZUXEGUWLUXFUIZUWOUXEUWOUXGIZUWLUXHUWOUDUXEUXIMUWOLZUW
      NYKLZOZPUWOLZUWNYNLZOZKZUWKUXDUWNUUGIZUXIUXPKZUWKUXQUXDUWKUUGAUWNUUEUVLUV
      CUVMVHVAWOUWKUVBUXQUXRUUEUUHUVBVPUVAUXRFUWNUUGUUIUWNOZUUMUXIUUTUXPUXSUUJU
      WOUULUXGUUIUWNUUFTZUXSUUKUXFQUFUUIUWNBTWPWQUXSUUPUXLUUSUXOUXSUUNUXJUUOUXK
      UXSMUUJUWOUXTWRUUIUWNYKTWSUXSUUQUXMUURUXNUXSPUUJUWOUXTWRUUIUWNYNTWSWGWGXB
      WTWAZXAZUWOQUXFUWLUXHXCUXHVGXDWKXEUYBXFXGUWKHAUXJSZHAUXKSZUWSYKUWKHAUXJUX
      KUXEUXLUXOUXEUXIUXPUYAVNZXAXHUWKMUWLIUYCYAIZUWSUYCOXIUWKYDUYFUXCHAUXJCXJW
      KGMUWQUYCUWLYAUWRUWMMOHAUWPUXJUWMMUWOTXKUWRVGZXLXMUWKUVTYKUYDOUUEUVTUVCUU
      EUVTUWAUWFXAVHHAYKYBVTXNUWKHAUXMSZHAUXNSZUXAYNUWKHAUXMUXNUXEUXLUXOUYEVNXH
      UWKPUWLIUYHYAIZUXAUYHOXOUWKYDUYJUXCHAUXMCXJWKGPUWQUYHUWLYAUWRUWMPOHAUWPUX
      MUWMPUWOTXKUYGXLXMUWKUWGYNUYIOUUEUWGUVCUUEUWGUWHUWIXAVHHAYNYBVTXNYPUWTUXB
      KDUWRYQYIUWROZYLUWTYOUXBUYKYJUWSYKMYIUWRWEWFUYKYMUXAYNPYIUWRWEWFWGXPXQXRX
      SEUBDYGYSYSVGXTYC $.
  $}

  ${
    $d f x y z A $.  $d f g h s u w x y z J $.
    $( The indiscrete topology (or trivial topology) on any set is
       path-connected.  (Contributed by Mario Carneiro, 7-Jul-2015.)  (Revised
       by Mario Carneiro, 14-Aug-2015.) $)
    indispcon $p |- { (/) , A } e. PCon $=
      ( vf vx vy vz c0 wcel cc0 cv cfv wceq c1 wa cii co cuni wral cicc cun cvv
      cpr cpcon ctop ccn wrex indistop cif cmpt cmap wf simpl 0ex n0i wn prprc2
      csn unieqd unisn syl6eq nsyl2 adantr uniprg sylancr uncom un0 eqtri simpr
      eleqtrd ifcl syl2anc eqid fmptd ovex elmapg sylancl mpbird ctopon iitopon
      cnindis eleqtrrd 0elunit iftrue vex fvmpt mp1i 1elunit wne ax-1ne0 mpbiri
      wb neeq1 ifnefalse syl fveq1 eqeq1d anbi12d rspcev syl12anc rgen2a ispcon
      mpbir2an ) FAUAZUBGXBUCGHBIZJZCIZKZLXCJZDIZKZMZBNXBUDOZUEZDXBPZQCXMQAUFXL
      CDXMXEXMGZXHXMGZMZEHLROZEIZHKZXEXHUGZUHZXKGHYAJZXEKZLYAJZXHKZXLXPYAAXQUIO
      ZXKXPYAYFGZXQAYAUJZXPEXQXTAYAXPXTAGZXRXQGXPXEAGXHAGYIXPXEXMAXNXOUKXPXMFAS
      ZAXPFTGATGZXMYJKULXNYKXOXNXMFKYKXMXEUMYKUNZXMFUPZPFYLXBYMFAUOUQFULURUSUTV
      AZFATTVBVCYJAFSAFAVDAVEVFUSZVHXPXHXMAXNXOVGYOVHXSXEXHAVIVJVAYAVKZVLXPYKXQ
      TGYGYHWJYNHLRVMAXQYATTVNVOVPXPNXQVQJGYKXKYFKVRYNANTXQVSVCVTHXQGYCXPWAEHXT
      XEXQYAXSXEXHWBYPCWCWDWELXQGYEXPWFELXTXHXQYAXRLKZXRHWGZXTXHKYQYRLHWGWHXRLH
      WKWIXRHXEXHWLWMYPDWCWDWEXJYCYEMBYAXKXCYAKZXFYCXIYEYSXDYBXEHXCYAWNWOYSXGYD
      XHLXCYAWNWOWPWQWRWSCDBXBXMXMVKWTXA $.

    $( A connected and locally path-connected space is path-connected.
       (Contributed by Mario Carneiro, 7-Jul-2015.) $)
    conpcon $p |- ( ( J e. Con /\ J e. N-Locally PCon ) -> J e. PCon ) $=
      ( vf vx vy vz vu vw vg wcel wa cc0 cv cfv wceq c1 adantr wss fveq1 eqeq1d
      wrex vs vh ccon cpcon cnlly ctop cii co cuni wral contop crab eqid simpll
      ccn ccld cin inss1 wel wi crest w3a cpw simplr ad2antrr topopn syl simprr
      nlly2i syl3anc simprr1 eqeq2 anbi2d rexbidv elrab simprbi simprr3 simprr2
      simprll sseldd elpwi ad2antrl restuni syl2anc eleqtrd pconcn cpco simplrl
      ad2antlr cnrest2r simprl simplrr simprd simprrl eqtr4d pcocn simpld eqtrd
      weq pco0 pco1 simprrr anbi12d rspcev syl12anc rexlimddv anassrs ralrimiva
      rexlimdvaa sstrd jctild cbvrexv ssrab 3imtr4g syl5 expr reximdv rexlimdva
      jca mpd wb ssrab2 isclo2 sylancl mpbird sseldi c0 wne cicc csn cxp ctopon
      simpr iitopon a1i toptopon sylib cnconst2 fvconst2 mp1i 0elunit syl112anc
      1elunit rspc2ev rabn0 sylibr inss2 conclo eqcomd rabid2 ispcon sylanbrc
      vex ) AUCIZAUDUEIZJZAUFIZKBLZMZCLZNZOUURMZDLZNZJZBUGAUOUHZTZDAUIZUJZCUVHU
      JAUDIUUNUUQUUOAUKZPUUPUVICUVHUUPUUTUVHIZJZUVHUVGDUVHULZNUVIUVLUVMUVHUVLUV
      MAUVHUVHUMZUUNUUOUVKUNUVLAAUPMZUQZAUVMAUVOURUVLUVMUVPIZEFUSZGLZUVMIZFLZUV
      MQZUTZGUWAUJZJZFATZEUVHUJZUVLUWFEUVHUUPUVKELZUVHIZUWFUUPUVKUWIJZJZUVRUWAU
      ALZQZAUWLVAUHZUDIZVBZFATZUAUVHVCZTZUWFUWKUUOUVHAIZUWIUWSUUNUUOUWJVDUWKUUQ
      UWTUUNUUQUUOUWJUVJVEZAUVHUVNVFVGUUPUVKUWIVHFUDUWHUVHAUAVIVJUWKUWQUWFUAUWR
      UWKUWLUWRIZJUWPUWEFAUWKUXBUWPUWEUWKUXBUWPJZJZUVRUWDUVRUWMUWOUXBUWKVKUXDUW
      CGUWAUVTUVAUVBUVSNZJZBUVFTZUXDGFUSZJZUWBUVTUVSUVHIUXGUVGUXGDUVSUVHDGWSZUV
      EUXFBUVFUXJUVDUXEUVAUVCUVSUVBVLVMVNVOVPUXIKHLZMZUUTNZOUXKMZUVSNZJZHUVFTZU
      WAUVHQZUVGDUWAUJZJUXGUWBUXIUXQUXSUXRUXIUXPUXSHUVFUXDUXHUXKUVFIZUXPJZUXSUX
      DUXHUYAJZJUVGDUWAUXDUYBDFUSZUVGUXDUYBUYCJZJZKUBLZMZUVSNZOUYFMZUVCNZJZUVGU
      BUGUWNUOUHZUYEUWOUVSUWNUIZIUVCUYMIUYKUBUYLTUXDUWOUYDUVRUWMUWOUXBUWKVQPUYE
      UVSUWLUYMUYEUWAUWLUVSUXDUWMUYDUVRUWMUWOUXBUWKVRZPZUXDUXHUYAUYCVSVTUYEUUQU
      WLUVHQZUWLUYMNUWKUUQUXCUYDUXAVEZUXDUYPUYDUXBUYPUWKUWPUWLUVHWAZWBPUWLAUVHU
      VNWCWDZWEUYEUVCUWLUYMUYEUWAUWLUVCUYOUXDUYBUYCVHVTUYSWEUVSUVCUBUWNUYMUYMUM
      WFVJUYEUYFUYLIZUYKJZJZUXKUYFAWGMUHZUVFIKVUCMZUUTNZOVUCMZUVCNZUVGVUBUXKUYF
      AUYDUXTUXDVUAUXHUXTUXPUYCWHWIZVUBUYLUVFUYFVUBUUQUYLUVFQUYEUUQVUAUYQPUWLUG
      AWJVGUYEUYTUYKWKVTZVUBUXNUVSUYGVUBUXMUXOUYDUXPUXDVUAUXHUXTUXPUYCWLWIZWMUY
      EUYTUYHUYJWNWOWPVUBVUDUXLUUTVUBUXKUYFAVUHVUIWTVUBUXMUXOVUJWQWRVUBVUFUYIUV
      CVUBUXKUYFAVUHVUIXAUYEUYTUYHUYJXBWRUVEVUEVUGJBVUCUVFUURVUCNZUVAVUEUVDVUGV
      UKUUSVUDUUTKUURVUCRSVUKUVBVUFUVCOUURVUCRSXCXDXEXFXGXHXGXIUXIUWAUWLUVHUXDU
      WMUXHUYNPUXIUXBUYPUWKUXBUWPUXHWHUYRVGXJXKUXFUXPBHUVFBHWSZUVAUXMUXEUXOVULU
      USUXLUUTKUURUXKRSVULUVBUXNUVSOUURUXKRSXCXLUVGDUVHUWAXMXNXOXHXSXPXQXRXTXGX
      HUVLUUQUVMUVHQUVQUWGYAUUNUUQUUOUVKUVJVEZUVGDUVHYBEFGUVMAUVHUVNYCYDYEZYFUV
      LUVGDUVHTZUVMYGYHUVLUVKKOYIUHZUUTYJYKZUVFIZKVUQMZUUTNZOVUQMZUUTNZVUOUUPUV
      KYMZUVLUGVUPYLMIZAUVHYLMIZUVKVURVVDUVLYNYOUVLUUQVVEVUMAUVHUVNYPYQVVCUUTUG
      AVUPUVHYRVJKVUPIVUTUVLUUAVUPUUTKCUUMZYSYTOVUPIVVBUVLUUCVUPUUTOVVFYSYTUVEV
      UTVVBJUVAUVBUUTNZJDBUUTVUQUVHUVFDCWSUVDVVGUVAUVCUUTUVBVLVMUURVUQNZUVAVUTV
      VGVVBVVHUUSVUSUUTKUURVUQRSVVHUVBVVAUUTOUURVUQRSXCUUDUUBUVGDUVHUUEUUFUVLUV
      PUVOUVMAUVOUUGVUNYFUUHUUIUVGDUVHUUJYQXHCDBAUVHUVNUUKUUL $.
  $}

  ${
    $d f g h s t x y $.  $d f h s y A $.  $d f g P $.  $d f g Q $.  $d f g S $.
    $d f h s y B $.  $d f g h s t y J $.  $d f g T $.  $d f h s t y X $.
    pconpi1.x $e |- X = U. J $.
    $( A quotient of a path-connected space is path-connected.  (Contributed by
       Mario Carneiro, 24-Mar-2015.) $)
    qtoppcon $p |- ( ( J e. PCon /\ F Fn X ) -> ( J qTop F ) e. PCon ) $=
      ( cpcon pcontop cqtop co cuni eqid cnpcon qtopcmplem ) EABCDBFABBAGHZCMIZ
      NJKL $.

    pconpi1.p $e |- P = ( J pi1 A ) $.
    pconpi1.q $e |- Q = ( J pi1 B ) $.
    pconpi1.s $e |- S = ( Base ` P ) $.
    pconpi1.t $e |- T = ( Base ` Q ) $.
    $( All fundamental groups in a path-connected space are isomorphic.
       (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    pconpi1 $p |- ( ( J e. PCon /\ A e. X /\ B e. X ) -> P ~=g Q ) $=
      ( wcel cv cfv c1 co cpi1 eqid vf vh vx vy cpcon w3a cc0 wceq cgic wbr cii
      wa ccn pconcn cbs cuni cphtpc cec cicc cmin cmpt cpco cop crn cgim ctopon
      ctop simpl1 pcontop toptopon sylib simprl oveq2 cbvmptv pi1xfrgim simprrl
      syl fveq2d oveq2d syl6eqr simprrr oveq12d eleqtrd brgici rexlimddv ) GUEN
      ZAHNZBHNZUFZUGUAOZPZAUHZQWJPZBUHZULZCDUIUJZUAUKGUMRZABUAGHIUNWIWJWQNZWOUL
      ZULZUBGWKSRZUOPZUPUBOZGUQPZURUCUGQUSRZQUCOZUTRZWJPZVAZXCWJGVBPZRXJRXDURVC
      VAVDZCDVERZNWPWTXKXAGWMSRZVERXLWTUDXBXAXMUBWJXKXIGHXATXMTXBTXKTWTGVGNZGHV
      FPNWTWFXNWFWGWHWSVHGVIVQGHIVJVKWIWRWOVLUCUDXEXHQUDOZUTRZWJPXFXOUHXGXPWJXF
      XOQUTVMVRVNVOWTXACXMDVEWTXAGASRCWTWKAGSWIWRWLWNVPVSJVTWTXMGBSRDWTWMBGSWIW
      RWLWNWAVSKVTWBWCCDXKWDVQWE $.
  $}

  ${
    $d x G $.  $d x J $.
    sconpht2.1 $e |- ( ph -> J e. SCon ) $.
    sconpht2.2 $e |- ( ph -> F e. ( II Cn J ) ) $.
    sconpht2.3 $e |- ( ph -> G e. ( II Cn J ) ) $.
    sconpht2.4 $e |- ( ph -> ( F ` 0 ) = ( G ` 0 ) ) $.
    sconpht2.5 $e |- ( ph -> ( F ` 1 ) = ( G ` 1 ) ) $.
    $( Any two paths in a simply connected space with the same start and end
       point are path-homotopic.  (Contributed by Mario Carneiro,
       12-Feb-2015.) $)
    sconpht2 $p |- ( ph -> F ( ~=ph ` J ) G ) $=
      ( vx cc0 c1 co cfv csn cxp wbr wcel wceq eqtr4d cicc cmin cmpt cpco cscon
      cphtpc cii ccn w3a eqid pcorevcl syl simp1d simp2d pcocn pco0 pco1 simp3d
      cv sconpht syl3anc sneqd xpeq2d breqtrd pcophtb mpbid ) ABJKLUAMZLJUSUBMC
      NUCZDUDNMZVGKBNZOZPZDUFNZQBCVMQAVIVGKVINZOZPZVLVMADUERVIUGDUHMZRVNLVINZSV
      IVPVMQEABVHDFAVHVQRZKVHNZLCNZSZLVHNZKCNZSZACVQRVSWBWEUIGJCVHDVHUJZUKULZUM
      ZALBNWAVTIAVSWBWEWGUNTUOAVNVJVRABVHDFWHUPZAVRWCVJABVHDFWHUQAVJWDWCHAVSWBW
      EWGURTTTVIDUTVAAVOVKVGAVNVJWIVBVCVDAJVLBCVHDWFVLUJFGHIVEVF $.
  $}

  ${
    $d f g x J $.  $d f x X $.  $d f g x Y $.
    sconpi1.1 $e |- X = U. J $.
    $( A path-connected topological space is simply connected iff its
       fundamental group is trivial.  (Contributed by Mario Carneiro,
       12-Feb-2015.) $)
    sconpi1 $p |- ( ( J e. PCon /\ Y e. X ) ->
      ( J e. SCon <-> ( Base ` ( J pi1 Y ) ) ~~ 1o ) ) $=
      ( vx vf wcel wa co cfv c1o cen wbr csn cc0 wceq c1 eqid syl2anc syl cpcon
      cscon cpi1 cbs c0g cv cphtpc cec cii ccn wrex ctop wb adantl simpl ctopon
      scontop toptopon sylib simpr elpi1 cicc cxp wer phtpcer a1i simplr simprl
      simpllr simprr eqtr4d sconpht syl3anc sneqd xpeq2d breqtrd erthi ad2antrr
      pi1id eqtrd eqeq1 syl5bb syl5ibrcom expimpd rexlimdva sylbid ssrdv pi1grp
      elsn cgrp grpidcl snssd eqssd fvex ensn1 syl6eqbr adantll wi wral simplll
      simpll pcontop wf iiuni cnf 0elunit ffvelrn sylancl eqcomd elpi1i pcoptcl
      eqidd w3a simp1d simp2d simp3d cgic pconpi1 gicen entr en1eqsn elsni erth
      eleqtrd mpbird expr ralrimiva isscon sylanbrc impbida ) AUAGZCBGZHZAUBGZA
      CUCIZUDJZKLMZYLYNYQYKYLYNHZYPYOUEJZNZKLYRYPYTYREYPYTYREUFZYPGZOFUFZJZCPZQ
      UUCJZCPZHZUUAUUCAUGJZUHZPZHZFUIAUJIZUKZUUAYTGZYRAULGZYLUUBUUNUMYNUUPYLAUQ
      UNZYLYNUOZUUPYLHZYPFUUAYOABCYORZYPRZUUSUUPABUPJGZUUPYLUOABDURZUSUUPYLUTVA
      SYRUULUUOFUUMYRUUCUUMGZHZUUHUUKUUOUVEUUHHZUUOUUKUUJYSPZUVFUUJOQVBIZCNZVCZ
      UUIUHZYSUVFUUCUVJUUIUUMUUMUUIVDZUVFAVEZVFUVFUUCUVHUUDNZVCZUVJUUIUVFYNUVDU
      UDUUFPZUUCUVOUUIMZYLYNUVDUUHVIYRUVDUUHVGUVFUUDCUUFUVEUUEUUGVHZUVEUUEUUGVJ
      VKUUCAVLVMUVFUVNUVIUVHUVFUUDCUVRVNVOVPVQYRUVKYSPZUVDUUHYRUVBYLUVSYRUUPUVB
      UUQUVCUSZUURYOABCUVJUUTUVJRVSSVRVTUUOUUAYSPUUKUVGEYSWIUUAUUJYSWAWBWCWDWEW
      FWGYRYSYPYRYOWJGZYSYPGYRUVBYLUWAUVTUURYOABCUUTWHSYPYOYSUVAYSRWKTWLWMYSYOU
      EWNWOWPWQYMYQHZYKUVPUVQWRZFUUMWSYNYKYLYQXAUWBUWCFUUMUWBUVDUVPUVQUWBUVDUVP
      HZHZUVQUUJUVOUUIUHZPZUWEUUJUWFNZGUWGUWEUUJAUUDUCIZUDJZUWHUWEUWJUUCUWIABUU
      DUWIRZUWJRZUWEUUPUVBUWEYKUUPYKYLYQUWDWTZAXBTUVCUSZUWEUVHBUUCXCZOUVHGUUDBG
      ZUWEUVDUWOUWBUVDUVPVHZUUCUIAUVHBXDDXETXFUVHBOUUCXGXHZUWQUWEUUDXLUWEUUDUUF
      UWBUVDUVPVJXIXJUWEUWFUWJGUWJKLMZUWJUWHPUWEUWJUVOUWIABUUDUWKUWLUWNUWRUWEUV
      OUUMGZOUVOJUUDPZQUVOJUUDPZUWEUVBUWPUWTUXAUXBXMUWNUWRUVOABUUDUVORXKSZXNUWE
      UWTUXAUXBUXCXOUWEUWTUXAUXBUXCXPXJUWEUWJYPLMZYQUWSUWEUWIYOXQMZUXDUWEYKUWPY
      LUXEUWMUWRYKYLYQUWDVIUUDCUWIYOUWJYPABDUWKUUTUWLUVAXRVMUWJYPUWIYOUWLUVAXST
      YMYQUWDVGUWJYPKXTSUWFUWJYASYDUUJUWFYBTUWEUUCUVOUUIUUMUVLUWEUVMVFUWQYCYEYF
      YGFAYHYIYJ $.
  $}

  ${
    $d s x y G $.  $d s x y H $.  $d s x y ph $.  $d s x y R $.  $d s x y S $.
    $d x A $.  $d x B $.  $d s x F $.
    txscon.1 $e |- ( ph -> R e. Top ) $.
    txscon.2 $e |- ( ph -> S e. Top ) $.
    txscon.3 $e |- ( ph -> F e. ( II Cn ( R tX S ) ) ) $.
    txscon.5 $e |- A = ( ( 1st |` ( U. R X. U. S ) ) o. F ) $.
    txscon.6 $e |- B = ( ( 2nd |` ( U. R X. U. S ) ) o. F ) $.
    txscon.7 $e |- ( ph ->
      G e. ( A ( PHtpy ` R ) ( ( 0 [,] 1 ) X. { ( A ` 0 ) } ) ) ) $.
    txscon.8 $e |- ( ph ->
      H e. ( B ( PHtpy ` S ) ( ( 0 [,] 1 ) X. { ( B ` 0 ) } ) ) ) $.
    $( Lemma for ~ txscon .  (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    txsconlem $p |- ( ph ->
      F ( ~=ph ` ( R tX S ) ) ( ( 0 [,] 1 ) X. { ( F ` 0 ) } ) ) $=
      ( co cc0 c1 cfv wceq vx vy vs cii ctx ccn wcel cicc csn cxp cphtpy c0 wne
      cphtpc wbr cmpt fconstmpt cuni ctopon iitopon a1i ctop eqid sylib txtopon
      toptopon syl2anc cnf2 syl3anc 0elunit ffvelrn sylancl cnmptc syl5eqel cop
      wf cmpt2 wfn c1st cres ccom tx1cn cnco iiuni cnf syl phtpycn sseldd iitop
      cv txunii ffn 3syl fnov eqeltrrd c2nd tx2cn cnmpt2t chtpy phtpyhtpy htpyi
      simpld fveq1i fvco3 sylan syl5eq fvres 3eqtrd opeq12d oveq12 opex ovmpt2a
      wa simpr 1st2nd2 3eqtr4d simprd fvex fvconst2 adantl eqtrd adantr 1elunit
      phtpyi sylancr isphtpy2d ne0i isphtpc syl3anbrc ) AFUDDEUEPZUFPZUGZQRUHPZ
      QFSZUIUJZYKUGFYOYJUKSPZULUMZFYOYJUNSUOKAYOUAYMYNUPYKUAYMYNUQAUAYNUDYJYMDU
      RZEURZUJZUDYMUSSUGZAUTVAZADYRUSSUGZEYSUSSUGZYJYTUSSUGZADVBUGUUCIDYRYRVCZV
      FVDZAEVBUGUUDJEYSYSVCZVFVDZDEYRYSVEVGZAYMYTFVPZQYMUGZYNYTUGZAUUAUUEYLUUKU
      UBUUJKFUDYJYMYTVHVIZVJYMYTQFVKVLZVMVNZAUAUBYMYMUAWJZUBWJZGPZUUQUURHPZVOZV
      QZYPUGYQAFYOUVBYJUCKUUPAUAUBUUSUUTUDUDDEYMYMUUBUUBAGUAUBYMYMUUSVQZUDUDUEP
      ZDUFPZAGYMYMUJZVRZGUVCTAGUVEUGUVFYRGVPUVGABYMQBSZUIUJZDUKSPZUVEGABUVIDABV
      SYTVTZFWAZUDDUFPZLAYLUVKYJDUFPUGZUVLUVMUGKAUUCUUDUVNUUGUUIDEYRYSWBVGFUVKU
      DYJDWCVGVNZAUVIUAYMUVHUPUVMUAYMUVHUQAUAUVHUDDYMYRUUBUUGAYMYRBVPZUULUVHYRU
      GABUVMUGUVPUVOBUDDYMYRWDUUFWEWFVJYMYRQBVKVLVMVNZWGNWHZGUVDDUVFYRUDUDYMYMW
      IWIWDWDWKZUUFWEUVFYRGWLWMUAUBYMYMGWNVDUVRWOAHUAUBYMYMUUTVQZUVDEUFPZAHUVFV
      RZHUVTTAHUWAUGUVFYSHVPUWBACYMQCSZUIUJZEUKSPZUWAHACUWDEACWPYTVTZFWAZUDEUFP
      ZMAYLUWFYJEUFPUGZUWGUWHUGKAUUCUUDUWIUUGUUIDEYRYSWQVGFUWFUDYJEWCVGVNZAUWDU
      AYMUWCUPUWHUAYMUWCUQAUAUWCUDEYMYSUUBUUIAYMYSCVPZUULUWCYSUGACUWHUGUWKUWJCU
      DEYMYSWDUUHWEWFVJYMYSQCVKVLVMVNZWGOWHZHUVDEUVFYSUVSUUHWEUVFYSHWLWMUAUBYMY
      MHWNVDUWMWOWRAUCWJZYMUGZXMZUWNQGPZUWNQHPZVOZUWNFSZVSSZUWTWPSZVOZUWNQUVBPZ
      UWTUWPUWQUXAUWRUXBUWPUWQUWNBSZUWTUVKSZUXAUWPUWQUXETZUWNRGPZUWNUVISZTZAUWN
      BUVIGUDDYMUUBUVOUVQAUVJBUVIUDDWSPPGABUVIDUVOUVQWTNWHXAZXBUWPUXEUWNUVLSZUX
      FUWNBUVLLXCAUUKUWOUXLUXFTUUNYMYTUWNUVKFXDXEXFUWPUWTYTUGZUXFUXATAUUKUWOUXM
      UUNYMYTUWNFVKXEZUWTYTVSXGWFXHUWPUWRUWNCSZUWTUWFSZUXBUWPUWRUXOTZUWNRHPZUWN
      UWDSZTZAUWNCUWDHUDEYMUUBUWJUWLAUWECUWDUDEWSPPHACUWDEUWJUWLWTOWHXAZXBUWPUX
      OUWNUWGSZUXPUWNCUWGMXCAUUKUWOUYBUXPTUUNYMYTUWNUWFFXDXEXFUWPUXMUXPUXBTUXNU
      WTYTWPXGWFXHXIUWPUWOUULUXDUWSTAUWOXNZVJUAUBUWNQYMYMUVAUWSUVBUUQUWNTZUURQT
      XMUUSUWQUUTUWRUUQUWNUURQGXJUUQUWNUURQHXJXIUVBVCZUWQUWRXKXLVLUWPUXMUWTUXCT
      UXNUWTYRYSXOWFXPUWPUXHUXRVOZYNVSSZYNWPSZVOZUWNRUVBPZUWNYOSZUWPUXHUYGUXRUY
      HUWPUXHUXIUVHUYGUWPUXGUXJUXKXQUWOUXIUVHTAYMUVHUWNQBXRXSXTAUVHUYGTUWOAUVHQ
      UVLSZUYGQBUVLLXCAUYLYNUVKSZUYGAUUKUULUYLUYMTUUNVJYMYTQUVKFXDVLAUUMUYMUYGT
      UUOYNYTVSXGWFYAXFYBZXHUWPUXRUXSUWCUYHUWPUXQUXTUYAXQUWOUXSUWCTAYMUWCUWNQCX
      RXSXTAUWCUYHTUWOAUWCQUWGSZUYHQCUWGMXCAUYOYNUWFSZUYHAUUKUULUYOUYPTUUNVJYMY
      TQUWFFXDVLAUUMUYPUYHTUUOYNYTWPXGWFYAXFYBZXHXIUWPUWORYMUGZUYJUYFTUYCYCUAUB
      UWNRYMYMUVAUYFUVBUYDUURRTXMUUSUXHUUTUXRUUQUWNUURRGXJUUQUWNUURRHXJXIUYEUXH
      UXRXKXLVLUWPUYKYNUYIUWOUYKYNTAYMYNUWNQFXRXSXTUWPUUMYNUYITAUUMUWOUUOYBYNYR
      YSXOWFZYAXPUWPQUWNGPZQUWNHPZVOZUYIQUWNUVBPZYNUWPUYTUYGVUAUYHUWPUYTUVHUYGU
      WPUYTUVHTZRUWNGPZRBSZTZAUWNBUVIGDUVOUVQNYDZXBUYNYAUWPVUAUWCUYHUWPVUAUWCTZ
      RUWNHPZRCSZTZAUWNCUWDHEUWJUWLOYDZXBUYQYAXIUWPUULUWOVUCVUBTVJUYCUAUBQUWNYM
      YMUVAVUBUVBUUQQTUURUWNTZXMUUSUYTUUTVUAUUQQUURUWNGXJUUQQUURUWNHXJXIUYEUYTV
      UAXKXLYEUYSXPUWPVUEVUJVOZRFSZVSSZVUPWPSZVOZRUWNUVBPZVUPUWPVUEVUQVUJVURUWP
      VUEVUFVUQUWPVUDVUGVUHXQAVUFVUQTUWOAVUFVUPUVKSZVUQAVUFRUVLSZVVARBUVLLXCAUU
      KUYRVVBVVATUUNYCYMYTRUVKFXDVLXFAVUPYTUGZVVAVUQTAUUKUYRVVCUUNYCYMYTRFVKVLZ
      VUPYTVSXGWFYAYBYAUWPVUJVUKVURUWPVUIVULVUMXQAVUKVURTUWOAVUKVUPUWFSZVURAVUK
      RUWGSZVVERCUWGMXCAUUKUYRVVFVVETUUNYCYMYTRUWFFXDVLXFAVVCVVEVURTVVDVUPYTWPX
      GWFYAYBYAXIUWPUYRUWOVUTVUOTYCUYCUAUBRUWNYMYMUVAVUOUVBUUQRTVUNXMUUSVUEUUTV
      UJUUQRUURUWNGXJUUQRUURUWNHXJXIUYEVUEVUJXKXLYEUWPVVCVUPVUSTAVVCUWOVVDYBVUP
      YRYSXOWFXPYFYPUVBYGWFFYOYJYHYI $.
  $}

  ${
    $d f g h R $.  $d f g h S $.
    $( The topological product of two simply connected spaces is simply
       connected.  (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    txscon $p |- ( ( R e. SCon /\ S e. SCon ) -> ( R tX S ) e. SCon ) $=
      ( vf vg vh wcel wa co cc0 cfv c1 wceq cxp cii ccn wex ctopon eqid syl2anc
      sylib cscon ctx cpcon cv cicc csn cphtpc wbr wi wral sconpcon txpcon c1st
      syl2an cuni cres ccom cphtpy c2nd c0 wne w3a simpll ctop scontop ad2antrr
      simprl toptopon ad2antlr tx1cn cnco simprr fveq2d wf iitopon txtopon cnf2
      a1i syl3anc 0elunit sylancl 1elunit 3eqtr4d sconpht isphtpc simp3d simplr
      fvco3 tx2cn eeanv adantr txsconlem exlimdvv syl5bir mp2and expr ralrimiva
      n0 ex isscon sylanbrc ) AUAFZBUAFZGZABUBHZUCFZICUDZJZKXGJZLZXGIKUEHZXHUFM
      XEUGJUHZUIZCNXEOHZUJXEUAFXBAUCFBUCFXFXCAUKBUKABULUNXDXMCXNXDXGXNFZXJXLXDX
      OXJGZGZDUDZUMAUOZBUOZMZUPZXGUQZXKIYCJZUFMZAURJHZFZDPZEUDZUSYAUPZXGUQZXKIY
      KJZUFMZBURJHZFZEPZXLXQYFUTVAZYHXQYCNAOHZFZYEYRFZYQXQYCYEAUGJUHZYSYTYQVBXQ
      XBYSYDKYCJZLUUAXBXCXPVCXQXOYBXEAOHFZYSXDXOXJVGZXQAXSQJFZBXTQJFZUUCXQAVDFZ
      UUEXBUUGXCXPAVEVFZAXSXSRVHTZXQBVDFZUUFXCUUJXBXPBVEVIZBXTXTRVHTZABXSXTVJSX
      GYBNXEAVKSXQXHYBJZXIYBJZYDUUBXQXHXIYBXDXOXJVLZVMXQXKYAXGVNZIXKFZYDUUMLXQN
      XKQJFZXEYAQJFZXOUUPUURXQVOVRXQUUEUUFUUSUUIUULABXSXTVPSUUDXGNXEXKYAVQVSZVT
      XKYAIYBXGWHWAXQUUPKXKFZUUBUUNLUUTWBXKYAKYBXGWHWAWCYCAWDVSYCYEAWETWFDYFWRT
      XQYNUTVAZYPXQYKNBOHZFZYMUVCFZUVBXQYKYMBUGJUHZUVDUVEUVBVBXQXCUVDYLKYKJZLUV
      FXBXCXPWGXQXOYJXEBOHFZUVDUUDXQUUEUUFUVHUUIUULABXSXTWISXGYJNXEBVKSXQXHYJJZ
      XIYJJZYLUVGXQXHXIYJUUOVMXQUUPUUQYLUVILUUTVTXKYAIYJXGWHWAXQUUPUVAUVGUVJLUU
      TWBXKYAKYJXGWHWAWCYKBWDVSYKYMBWETWFEYNWRTYHYPGYGYOGZEPDPXQXLYGYODEWJXQUVK
      XLDEXQUVKXLXQUVKGYCYKABXGXRYIXQUUGUVKUUHWKXQUUJUVKUUKWKXQXOUVKUUDWKYCRYKR
      XQYGYOVGXQYGYOVLWLWSWMWNWOWPWQCXEWTXA $.
  $}

  ${
    $d t z J $.  $d f s t x y z K $.  $d f s t x y z ph $.  $d t x y z S $.
    cvxpcon.1 $e |- ( ph -> S C_ CC ) $.
    cvxpcon.2 $e |- ( ( ph /\ ( x e. S /\ y e. S /\ t e. ( 0 [,] 1 ) ) ) ->
      ( ( t x. x ) + ( ( 1 - t ) x. y ) ) e. S ) $.
    cvxpcon.3 $e |- J = ( TopOpen ` CCfld ) $.
    cvxpcon.4 $e |- K = ( J |`t S ) $.
    $( A convex subset of the complex numbers is path-connected.  (Contributed
       by Mario Carneiro, 12-Feb-2015.) $)
    cvxpcon $p |- ( ph -> K e. PCon ) $=
      ( wcel cc0 wceq c1 co cc cmul cmin caddc vf ctop cv cfv cii ccn wrex cuni
      wral cpcon crest cvv cnfldtop cnex ssexg sylancl resttop sylancr syl5eqel
      wa wss cicc cmpt dfii3 ctopon cnfldtopon unitssre ax-resscn sstri cnmptid
      a1i cr adantr simprr sseldd cnmptc ctx mulcn cnmpt12f ax-1cn subcn simprl
      addcn cnmpt1res crn wb wf wi 3exp2 com23 imp42 eqid fmptd frn syl cnrest2
      syl3anc mpbid oveq2i syl6eleqr 0elunit oveq1 oveq2 subid1i syl6eq oveq12d
      oveq1d ovex fvmpt ax-mp mul02d mulid2d addid2d eqtrd syl5eq 1elunit 1m1e0
      addid1d fveq1 eqeq1d anbi12d rspcev syl12anc ralrimivva resttopon raleqdv
      toponuni raleqbidv ispcon sylanbrc ) AGUBLMUAUCZUDZCUCZNZOYKUDZBUCZNZUTZU
      AUEGUFPZUGZBGUHZUIZCUUAUIZGUJLAGFEUKPZUBKAFUBLEULLZUUDUBLFJUMAEQVAZQULLUU
      EHUNEQULUOUPEFULUQURUSAYTBEUIZCEUIUUCAYTCBEEAYMELZYPELZUTZUTZDMOVBPZDUCZY
      PRPZOUUMSPZYMRPZTPZVCZYSLMUURUDZYMNZOUURUDZYPNZYTUUKUURUEUUDUFPZYSUUKUURU
      EFUFPLZUURUVCLZUUKDUUQFUEFQUULFJVDFQVEUDLZUUKFJVFZVKZUULQVAUUKUULVLQVGVHV
      IVKUUKDUUNUUPTFFFFQUVHUUKDUUMYPRFFFFQUVHUUKDFQUVHVJZUUKDYPFFQQUVHUVHUUKEQ
      YPAUUFUUJHVMZAUUHUUIVNVOZVPRFFVQPFUFPZLUUKFJVRVKZVSUUKDUUOYMRFFFFQUVHUUKD
      OUUMSFFFFQUVHUUKDOFFQQUVHUVHOQLUUKVTVKVPUVISUVLLUUKFJWAVKVSUUKDYMFFQQUVHU
      VHUUKEQYMUVJAUUHUUIWBVOZVPUVMVSTUVLLUUKFJWCVKVSWDUUKUVFUURWEEVAZUUFUVDUVE
      WFUVHUUKUULEUURWGUVOUUKDUULUUQEUURAUUHUUIUUMUULLZUUQELZAUUIUUHUVPUVQWHAUU
      IUUHUVPUVQIWIWJWKUURWLZWMUULEUURWNWOUVJEUURUEFQWPWQWRGUUDUEUFKWSWTUUKUUSM
      YPRPZOYMRPZTPZYMMUULLUUSUWANXADMUUQUWAUULUURUUMMNZUUNUVSUUPUVTTUUMMYPRXBU
      WBUUOOYMRUWBUUOOMSPOUUMMOSXCOVTXDXEXGXFUVRUVSUVTTXHXIXJUUKUWAMYMTPYMUUKUV
      SMUVTYMTUUKYPUVKXKUUKYMUVNXLXFUUKYMUVNXMXNXOUUKUVAOYPRPZMYMRPZTPZYPOUULLU
      VAUWENXPDOUUQUWEUULUURUUMONZUUNUWCUUPUWDTUUMOYPRXBUWFUUOMYMRUWFUUOOOSPMUU
      MOOSXCXQXEXGXFUVRUWCUWDTXHXIXJUUKUWEYPMTPYPUUKUWCYPUWDMTUUKYPUVKXLUUKYMUV
      NXKXFUUKYPUVKXRXNXOYRUUTUVBUTUAUURYSYKUURNZYNUUTYQUVBUWGYLUUSYMMYKUURXSXT
      UWGYOUVAYPOYKUURXSXTYAYBYCYDAUUGUUBCEUUAAGEVEUDZLEUUANAGUUDUWHKAUVFUUFUUD
      UWHLUVGHEFQYEURUSEGYGWOZAYTBEUUAUWIYFYHWRCBUAGUUAUUAWLYIYJ $.

    $( A convex subset of the complex numbers is simply connected.
       (Contributed by Mario Carneiro, 12-Feb-2015.) $)
    cvxscon $p |- ( ph -> K e. SCon ) $=
      ( vz wcel cc0 c1 co cii cmul caddc cc vf vs cpcon cv cfv wceq cicc cphtpc
      csn cxp wbr wi ccn wral cscon cvxpcon wa cphtpy c0 wne simprl cuni ctopon
      w3a ctop pcontop syl adantr eqid toptopon sylib iiuni cnf 0elunit ffvelrn
      wf sylancl pcoptcl syl2anc simp1d cmin cmpt2 ctx crest iitopon cnfldtopon
      a1i dfii3 wss cr unitssre ax-resscn cnmpt2nd cnmpt2res resttopon syl5eqel
      sstri sylancr toponuni eleqtrrd sseldd cnmpt2c cnmpt22f cnmpt1st cnfldtop
      mulcn ax-1cn subcn cnrest2r ax-mp oveq2i syl6eleq cnmpt21f addcn ffvelrnd
      sseldi crn wb 3exp2 imp42 an32s ralrimivva oveq2 oveq1d eleq1d oveq2d weq
      simpr syl6eq fveq2d oveq12d ovmpt2a mul02d mulid2d 3eqtrd 1elunit 3eqtr3d
      simpl ovex eqtrd ad2ant2rl rspc2va syl21anc frn cnrest2 syl3anc syl6eleqr
      fmpt2 mpbid subid1i toponunii ffvelrnda addid2d 1m1e0 addid1d fvex adantl
      eqtr4d pncan3 subcl adddird simplrr isphtpy2d ne0i isphtpc syl3anbrc expr
      fvconst2 ralrimiva isscon sylanbrc ) AGUCMZNUAUDZUEZOUVMUEZUFZUVMNOUGPZUV
      NUIUJZGUHUEUKZULZUAQGUMPZUNGUOMABCDEFGHIJKUPZAUVTUAUWAAUVMUWAMZUVPUVSAUWC
      UVPUQZUQZUWCUVRUWAMZUVMUVRGURUEPZUSUTZUVSAUWCUVPVAZUWEUWFNUVRUEUVNUFZOUVR
      UEUVNUFZUWEGGVBZVCUEMZUVNUWLMZUWFUWJUWKVDUWEGVEMZUWMAUWOUWDAUVLUWOUWBGVFV
      GVHGUWLUWLVIZVJVKUWEUVQUWLUVMVPZNUVQMZUWNUWEUWCUWQUWIUVMQGUVQUWLVLUWPVMVG
      ZVNUVQUWLNUVMVOVQZUVRGUWLUVNUVRVIVRVSVTZUWELDUVQUVQDUDZUVNRPZOUXBWAPZLUDZ
      UVMUEZRPZSPZWBZUWGMUWHUWEUVMUVRUXIGUBUWIUXAUWEUXIQQWCPZFEWDPZUMPZUXJGUMPU
      WEUXIUXJFUMPMZUXIUXLMZUWELDUXCUXGSQQFFFUVQUVQQUVQVCUEMUWEWEWGZUXOUWELDUXB
      UVNRQQFFFUVQUVQUXOUXOUWELDUXBFQFFQUVQTUVQTFJWHZFTVCUEMZUWEFJWFZWGZUVQTWIU
      WEUVQWJTWKWLWQZWGZUXPUXSUYAUWELDFFTTUXSUXSWMZWNUWELDUVNQQFUVQUVQTUXOUXOUX
      SUWEETUVNAETWIZUWDHVHZUWEUVNUWLEUWTAEUWLUFZUWDAGEVCUEZMUYEAGUXKUYFKAUXQUY
      CUXKUYFMUXRHEFTWOWRWPEGWSVGVHZWTZXAZXBRFFWCPFUMPZMUWEFJXFWGZXCUWELDUXDUXF
      RQQFFFUVQUVQUXOUXOUWELDUXDFQFFQUVQTUVQTUXPUXSUYAUXPUXSUYAUWELDOUXBWAFFFFF
      TTUXSUXSUWELDOFFFTTTUXSUXSUXSOTMZUWEXGWGXBUYBWAUYJMUWEFJXHWGXCWNUWELDUXEU
      VMQQQFUVQUVQUXOUXOUWELDQQUVQUVQUXOUXOXDUWEQUXKUMPZQFUMPZUVMFVEMUYMUYNWIFJ
      XEEQFXIXJUWEUVMUWAUYMUWIGUXKQUMKXKXLXPZXMUYKXCSUYJMUWEFJXNWGXCUWEUXQUXIXQ
      EWIZUYCUXMUXNXRUXSUWEUVQUVQUJZEUXIVPZUYPUWEUXHEMZDUVQUNLUVQUNUYRUWEUYSLDU
      VQUVQUWEUXEUVQMZUXBUVQMZUQZUQZUVNEMZUXFEMUXBBUDZRPZUXDCUDZRPZSPZEMZCEUNBE
      UNZUYSUWEVUDVUBUYHVHVUCUXFUWLEVUCUVQUWLUXEUVMUWEUWQVUBUWSVHUWEUYTVUAVAXOU
      WEUYEVUBUYGVHWTAVUAVUKUWDUYTAVUAUQVUJBCEEAVUEEMZVUGEMZUQVUAVUJAVULVUMVUAV
      UJAVULVUMVUAVUJIXSXTYAYBUUAVUJUYSUXCVUHSPZEMBCUVNUXFEEVUEUVNUFZVUIVUNEVUO
      VUFUXCVUHSVUEUVNUXBRYCYDYEVUGUXFUFZVUNUXHEVUPVUHUXGUXCSVUGUXFUXDRYCYFYEUU
      BUUCYBLDUVQUVQUXHEUXIUXIVIZUUHVKUYQEUXIUUDVGUYDEUXIUXJFTUUEUUFUUIGUXKUXJU
      MKXKUUGUWEUBUDZUVQMZUQZVURNUXIPZNUVNRPZOVURUVMUEZRPZSPZNVVCSPVVCVUTVUSUWR
      VVAVVEUFUWEVUSYHZVNLDVURNUVQUVQUXHVVEUXILUBYGZUXBNUFZUQZUXCVVBUXGVVDSVVIU
      XBNUVNRVVGVVHYHZYDVVIUXDOUXFVVCRVVIUXDONWAPOVVIUXBNOWAVVJYFOXGUUJYIVVIUXE
      VURUVMVVGVVHYRYJYKYKVUQVVBVVDSYSYLVQVUTVVBNVVDVVCSVUTUVNUWEUVNTMVUSUYIVHZ
      YMVUTVVCUWEUVQTVURUVMUWEUVMUYNMUVQTUVMVPUYOUVMQFUVQTVLTFUXRUUKVMVGUULZYNY
      KVUTVVCVVLUUMYOVUTVUROUXIPZOUVNRPZNVVCRPZSPZUVNNSPZVURUVRUEZVUTVUSOUVQMZV
      VMVVPUFVVFYPLDVUROUVQUVQUXHVVPUXIVVGUXBOUFZUQZUXCVVNUXGVVOSVWAUXBOUVNRVVG
      VVTYHZYDVWAUXDNUXFVVCRVWAUXDOOWAPNVWAUXBOOWAVWBYFUUNYIVWAUXEVURUVMVVGVVTY
      RYJYKYKVUQVVNVVOSYSYLVQVUTVVNUVNVVONSVUTUVNVVKYNZVUTVVCVVLYMYKVUTVVQUVNVV
      RVUTUVNVVKUUOVUSVVRUVNUFUWEUVQUVNVURNUVMUUPUVHUUQUURYOVUTNVURUXIPZVURUVNR
      PZOVURWAPZUVNRPZSPZUVNVUTUWRVUSVWDVWHUFVNVVFLDNVURUVQUVQUXHVWHUXIUXENUFZD
      UBYGZUQZUXCVWEUXGVWGSVWKUXBVURUVNRVWIVWJYHZYDVWKUXDVWFUXFUVNRVWKUXBVUROWA
      VWLYFVWKUXENUVMVWIVWJYRYJYKYKVUQVWEVWGSYSYLWRVUTVURVWFSPZUVNRPVVNVWHUVNVU
      TVWMOUVNRVUTVURTMZUYLVWMOUFVUTUVQTVURUXTVVFXPZXGVUROUUSVQYDVUTVURVWFUVNVW
      OVUTUYLVWNVWFTMXGVWOOVURUUTWRVVKUVAVWCYQZYTVUTOVURUXIPZVWEVWFUVORPZSPZUVO
      VUTVVSVUSVWQVWSUFYPVVFLDOVURUVQUVQUXHVWSUXIUXEOUFZVWJUQZUXCVWEUXGVWRSVXAU
      XBVURUVNRVWTVWJYHZYDVXAUXDVWFUXFUVORVXAUXBVUROWAVXBYFVXAUXEOUVMVWTVWJYRYJ
      YKYKVUQVWEVWRSYSYLWRVUTVWHUVNVWSUVOVWPVUTVWGVWRVWESVUTUVNUVOVWFRAUWCUVPVU
      SUVBZYFYFVXCYQYTUVCUWGUXIUVDVGUVMUVRGUVEUVFUVGUVIUAGUVJUVK $.
  $}

  ${
    $d t J $.  $d t x y K $.  $d t x y P $.  $d t x y R $.  $d t x y S $.
    blscon.j $e |- J = ( TopOpen ` CCfld ) $.
    blscon.s $e |- S = ( P ( ball ` ( abs o. - ) ) R ) $.
    blscon.k $e |- K = ( J |`t S ) $.
    $( An open ball in the complex numbers is simply connected.  (Contributed
       by Mario Carneiro, 12-Feb-2015.) $)
    blscon $p |- ( ( P e. CC /\ R e. RR* ) -> K e. SCon ) $=
      ( vx vy vt cc wcel cxr wa cabs cmin ccom cfv cv cbl cxmt wss cnxmet blssm
      co mp3an1 syl5eqss blcvx cvxscon ) ALMZBNMZOZIJKCDEUMCABPQRZUASUFZLGUNLUB
      SMUKULUOLUCUDUNABLUEUGUHITJTABCKTGUIFHUJ $.
  $}

  ${
    $d r u x y J $.
    cnllyscon.j $e |- J = ( TopOpen ` CCfld ) $.
    $( The topology of the complex numbers is locally simply connected.
       (Contributed by Mario Carneiro, 2-Mar-2015.) $)
    cnllyscon $p |- J e. Locally SCon $=
      ( vy vu vx vr cscon wcel cv crest co wrex wral cfv wss crp cnxmet syl3anc
      wa cc clly ctop cpw cin cnfldtop cabs cmin ccom cbl cxmt cnfldtopn mopni2
      mp3an1 cxr a1i ctopon cnfldtopon simpll toponss sylancr simplr rpxr blopn
      sseldd ad2antrl simprr vex sylibr elin sylanbrc simprl blcntr eqid blscon
      elpw2 syl2anc wceq eleq2 oveq2 eleq1d anbi12d rspcev syl12anc rgen2 islly
      rexlimddv mpbir2an ) AGUAHAUBHCIZDIZHZAWIJKZGHZSZDAEIZUCZUDZLZCWNMEAMABUE
      WQECAWNWNAHZWHWNHZSZWHFIZUFUGUHZUINKZWNOZWQFPXBTUJNHZWRWSXDFPLQFWNXBWHATA
      BUKZULUMWTXAPHZXDSZSZXCWPHZWHXCHZAXCJKZGHZWQXIXCAHZXCWOHZXJXIXEWHTHZXAUNH
      ZXNXEXIQUOZXIWNTWHXIATUPNHWRWNTOABUQWRWSXHURWNATUSUTWRWSXHVAVDZXGXQWTXDXA
      VBVEZXBWHXAATXFVCRXIXDXOWTXGXDVFXCWNEVGVOVHXCAWOVIVJXIXEXPXGXKXRXSWTXGXDV
      KXBWHXATVLRXIXPXQXMXSXTWHXAXCAXLBXCVMXLVMVNVPWMXKXMSDXCWPWIXCVQZWJXKWLXMW
      IXCWHVRYAWKXLGWIXCAJVSVTWAWBWCWFWDECDGAWEWG $.
  $}

  ${
    $d s t w x y z A $.  $d s t w x y z J $.
    rescon.1 $e |- J = ( ( topGen ` ran (,) ) |`t A ) $.
    $( A subset of ` RR ` is simply connected iff it is connected.
       (Contributed by Mario Carneiro, 9-Mar-2015.) $)
    rescon $p |- ( A C_ RR -> ( J e. SCon <-> J e. Con ) ) $=
      ( vx vy vt cr wcel wa co adantr cc cv c1 cmul caddc wral oveq2 cle wbr vz
      vw wss cscon ccon cpcon sconpcon pconcon syl ccnfld ctopn crest wceq cioo
      vs cfv crn ctg eqid rerest syl6eqr simpl ax-resscn syl6ss cc0 cicc df-3an
      w3a cmin weq oveqan12d eleq1d ralbidv unitssre sstri sseldi simpr2 sseldd
      simpr mulcld ax-1cn subcl sylancr simpr1 nncan oveq1d oveq2d eqtr4d iirev
      addcomd adantl eleq1i reconn syl5bb biimpa r19.21bi 3adantr3 remulcld 1re
      anasss simplll resubcl readdcld recnd sylancl adddird mulid2d 3eqtr3d 0re
      pncan3 elicc2i simp3d wb subge0 mpbird simplr3 lemul2ad leadd2dd eqbrtrrd
      sylib simp2d leadd1dd breqtrd elicc2 syl2anc mpbir3and oveq1 oveq12d sylc
      ralrimiva rspcv eqeltrd cbvralv wloglei sylan2b cvxscon eqeltrrd impbid2
      ex ) AGUCZBUDHZBUEHZUUABUFHUUBBUGBUHUIYTUUBUUAYTUUBIZUJUKUPZAULJZBUDYTUUE
      BUMUUBYTUUEUNUQURUPZAULJZBAUUFUUDUUDUSZUUFUSUTCVAKUUCDEFAUUDUUEUUCAGLYTUU
      BVBZVCVDZDMZAHZEMZAHZFMZVENVFJZHZVHUUCUULUUNIZUUQIUUOUUKOJZNUUOVIJZUUMOJZ
      PJZAHZUULUUNUUQVGUUCUURUUQUVCUUCUURIUVCFUUPUUCUUOUAMZOJZUUTUBMZOJZPJZAHZF
      UUPQUVCFUUPQZUUOUUMOJZUUTUUKOJZPJZAHZFUUPQZDEUAUBAUADVJZUBEVJZIZUVIUVCFUU
      PUVRUVHUVBAUVPUVQUVEUUSUVGUVAPUVDUUKUUOORUVFUUMUUTORVKVLVMUAEVJZUBDVJZIZU
      VIUVNFUUPUWAUVHUVMAUVSUVTUVEUVKUVGUVLPUVDUUMUUOORUVFUUKUUTORVKVLVMUUIUUCU
      ULUUNUUKUUMSTZVHZIZUOMZUUMOJZNUWEVIJZUUKOJZPJZAHZUOUUPQUVOUWDUWJUOUUPUWDU
      WEUUPHZIZUWIUWHNUWGVIJZUUMOJZPJZAUWLUWIUWHUWFPJUWOUWLUWFUWHUWLUWEUUMUWLUU
      PLUWEUUPGLVNVCVOUWDUWKVSVPZUWDUUMLHZUWKUWDALUUMUUCALUCUWCUUJKZUUCUULUUNUW
      BVQZVRZKVTUWLUWGUUKUWLNLHZUWELHZUWGLHWAUWPNUWEWBWCUWDUUKLHZUWKUWDALUUKUWR
      UUCUULUUNUWBWDZVRZKVTWJUWLUWNUWFUWHPUWLUWMUWEUUMOUWLUXAUXBUWMUWEUMWAUWPNU
      WEWEWCWFWGWHUWLUWGUUPHZUVJUWOAHZUWKUXFUWDUWEWIWKUWDUVJUWKUWDUVCFUUPUWDUUQ
      IZUUKUUMVFJZAUVBUWDUXIAUCZUUQUUCUULUUNUXJUWBUUCUULUUNUXJUUCUULIUXJEAUUCUX
      JEAQZDAYTUUBUXKDAQZUUBUUGUEHYTUXLBUUGUECWLDEAWMWNWOWPWPWTWQKUXHUVBUXIHZUV
      BGHZUUKUVBSTZUVBUUMSTZUXHUUSUVAUXHUUOUUKUXHUUPGUUOVNUWDUUQVSZVPZUXHAGUUKY
      TUUBUWCUUQXAZUWDUULUUQUXDKVRZWRZUXHUUTUUMUXHNGHZUUOGHZUUTGHWSUXRNUUOXBWCZ
      UXHAGUUMUXSUWDUUNUUQUWSKVRZWRZXCUXHUUSUVLPJZUUKUVBSUXHUUOUUTPJZUUKOJNUUKO
      JUYGUUKUXHUYHNUUKOUXHUUOLHUXAUYHNUMUXHUUOUXRXDZWAUUONXJXEZWFUXHUUOUUTUUKU
      YIUXHUUTUYDXDZUWDUXCUUQUXEKZXFUXHUUKUYLXGXHUXHUVLUVAUUSUXHUUTUUKUYDUXTWRU
      YFUYAUXHUUKUUMUUTUXTUYEUYDUXHVEUUTSTZUUONSTZUXHUYCVEUUOSTZUYNUXHUUQUYCUYO
      UYNVHUXQVENUUOXIWSXKXTZXLUXHUYBUYCUYMUYNXMWSUXRNUUOXNWCXOUULUUNUWBUUCUUQX
      PZXQXRXSUXHUVBUVKUVAPJZUUMSUXHUUSUVKUVAUYAUXHUUOUUMUXRUYEWRUYFUXHUUKUUMUU
      OUXTUYEUXRUXHUYCUYOUYNUYPYAUYQXQYBUXHUYHUUMOJNUUMOJUYRUUMUXHUYHNUUMOUYJWF
      UXHUUOUUTUUMUYIUYKUWDUWQUUQUWTKZXFUXHUUMUYSXGXHYCUXHUUKGHUUMGHUXMUXNUXOUX
      PVHXMUXTUYEUUKUUMUVBYDYEYFVRYJZKUVCUXGFUWGUUPUUOUWGUMZUVBUWOAVUAUUSUWHUVA
      UWNPUUOUWGUUKOYGVUAUUTUWMUUMOUUOUWGNVIRWFYHVLYKYIYLYJUWJUVNUOFUUPUOFVJZUW
      IUVMAVUBUWFUVKUWHUVLPUWEUUOUUMOYGVUBUWGUUTUUKOUWEUUONVIRWFYHVLYMXTUYTYNWP
      WTYOUUHUUEUSYPYQYSYR $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( An open interval is simply connected.  (Contributed by Mario Carneiro,
       9-Mar-2015.) $)
    iooscon $p |- ( ( topGen ` ran (,) ) |`t ( A (,) B ) ) e. SCon $=
      ( vx vy cv cicc co cioo wss wral crn ctg cfv crest cscon iccssioo2 rgen2a
      wcel cr wb ioossre ccon eqid rescon reconn bitr2d ax-mp mpbi ) CEZDEZFGAB
      HGZIZDUKJCUKJZHKLMUKNGZORZULCDUKABUIUJPQUKSIZUMUOTABUAUPUOUNUBRUMUKUNUNUC
      UDCDUKUEUFUGUH $.
  $}

  $( A closed interval is simply connected.  (Contributed by Mario Carneiro,
     9-Mar-2015.) $)
  iccscon $p |- ( ( A e. RR /\ B e. RR ) ->
    ( ( topGen ` ran (,) ) |`t ( A [,] B ) ) e. SCon ) $=
    ( cr wcel wa cioo crn ctg cfv cicc co crest cscon ccon iccconn iccssre eqid
    wss wb rescon syl mpbird ) ACDBCDEZFGHIABJKZLKZMDZUENDZABOUCUDCRUFUGSABPUDU
    EUEQTUAUB $.

  $( The real numbers are simply connected.  (Contributed by Mario Carneiro,
     9-Mar-2015.) $)
  retopscon $p |- ( topGen ` ran (,) ) e. SCon $=
    ( cioo crn ctg cmnf cpnf co crest cscon ctop wcel wceq retop cr cuni ioomax
    cfv uniretop eqtri restid ax-mp iooscon eqeltrri ) ABCPZDEAFZGFZUCHUCIJUEUC
    KLUCIUDUDMUCNOQRSTDEUAUB $.

  ${
    $d a b u v x y z A $.  $d a b u v x y z B $.
    $( A closed interval is locally simply connected.  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    iccllyscon $p |- ( ( A e. RR /\ B e. RR ) ->
      ( ( topGen ` ran (,) ) |`t ( A [,] B ) ) e. Locally SCon ) $=
      ( vz vx vy vu vv cr wcel wa cv co wss cioo crest cscon wrex wral cxr wb
      va vb cicc cin crn ctg cfv w3a clly simprl simprr sseldi tg2 syl2anc wceq
      inss1 wi cxp cpw wf wfn ioof ffn ovelrn mp2b simprrr syl5ss ineq1d oveq2d
      simprrl iooscon ioossre ccon eqid rescon reconn bitrd mpbi ssralv ralimdv
      ax-mp syld mp1i inss2 iccconn iccssre syl mpbid ad2antrr 2ralbii r19.26-2
      mpsyl ssin bitr3i sylanbrc sstri sylibr eqeltrd exp32 rexlimdvw reximdvai
      3jca syl5bi ctb retopbas bastg ssrexv syl6 mpd ralrimivva ctop retop ovex
      cvv subislly mp2an ) AHIBHIJZCKZABUCLZUDZDKZMZEKZXRIZNUEZUFUGZXTOLZPIZUHZ
      CYFQZEYAXSUDZRDYFRZYFXSOLZPUIIZXQYJDEYFYKXQYAYFIZYCYKIZJZJZYDXRYAMZJZCYEQ
      ZYJYRYOYCYAIUUAXQYOYPUJYRYKYAYCYAXSUPXQYOYPUKULCYAYEYCUMUNYRUUAYICYEQZYJY
      RYTYICYEXRYEIZXRUAKZUBKZNLZUOZUBSQZUASQZYRYTYIUQZSSURZHUSZNUTNUUKVAUUCUUI
      TVBUUKUULNVCUAUBSSXRNVDVEYRUUHUUJUASYRUUGUUJUBSYRUUGYTYIYRUUGYTJZJZYBYDYH
      UUNXTXRYAXRXSUPYRUUGYDYSVFVGYRUUGYDYSVJUUNYGYFUUFXSUDZOLZPUUNXTUUOYFOUUNX
      RUUFXSYRUUGYTUJVHVIUUNFKGKUCLZUUOMZGUUORFUUORZUUPPIZUUNUUQUUFMZGUUORZFUUO
      RZUUQXSMZGUUORZFUUORZUUSUVAGUUFRZFUUFRZUVCUUNYFUUFOLZPIZUVHUUDUUEVKUUFHMZ
      UVJUVHTUUDUUEVLZUVKUVJUVIVMIUVHUUFUVIUVIVNVOFGUUFVPVQWAVRUUOUUFMZUVHUVCUQ
      UUFXSUPZUVMUVHUVBFUUFRUVCUVMUVGUVBFUUFUVAGUUOUUFVSVTUVBFUUOUUFVSWBWAWCUUO
      XSMZUUNUVDGXSRZFXSRZUVFUUFXSWDXQUVQYQUUMXQYMVMIZUVQABWEXQXSHMUVRUVQTABWFF
      GXSVPWGWHWIUVOUVQUVEFXSRUVFUVOUVPUVEFXSUVDGUUOXSVSVTUVEFUUOXSVSWBWLUUSUVA
      UVDJZGUUORFUUORUVCUVFJUVSUURFGUUOUUOUUQUUFXSWMWJUVAUVDFGUUOUUOWKWNWOUUOHM
      ZUUTUUSTUUOUUFHUVNUVLWPUVTUUTUUPVMIUUSUUOUUPUUPVNVOFGUUOVPVQWAWQWRXBWSWTW
      TXCXAYEXDIYEYFMUUBYJUQXEYEXDXFYICYEYFXGVEXHXIXJYFXKIXSXNIYNYLTXLABUCXMDEC
      PXSYFXNXOXPWQ $.

    $( The real numbers are locally simply connected.  (Contributed by Mario
       Carneiro, 10-Mar-2015.) $)
    rellyscon $p |- ( topGen ` ran (,) ) e. Locally SCon $=
      ( vy vz vx va vb cioo cscon wcel wel cv crest co wa cpw wrex wral wss ctb
      cxr rexlimivw crn ctg cfv clly ctop cin retop retopbas bastg ax-mp simprl
      tg2 sseldi simprrr vex elpw sylibr elin sylanbrc simprrl cxp cr wf wfn wb
      wceq ioof ffn ovelrn oveq2 iooscon syl6eqel sylbi ad2antrl jca32 reximdv2
      mp2b ex mpd rgen2 islly mpbir2an ) FUAZUBUCZGUDHWDUEHABIZWDBJZKLZGHZMZBWD
      CJZNZUFZOZAWJPCWDPUGWMCAWDWJWJWDHACIMZWEWFWJQZMZBWCOWMBWJWCAJULWNWPWIBWCW
      LWNWFWCHZWPMZWFWLHZWIMWNWRMZWSWEWHWTWFWDHWFWKHZWSWTWCWDWFWCRHWCWDQUHWCRUI
      UJWNWQWPUKUMWTWOXAWNWQWEWOUNWFWJBUOUPUQWFWDWKURUSWNWQWEWOUTWQWHWNWPWQWFDJ
      ZEJZFLZVFZESOZDSOZWHSSVAZVBNZFVCFXHVDWQXGVEVGXHXIFVHDESSWFFVIVQXFWHDSXEWH
      ESXEWGWDXDKLGWFXDWDKVJXBXCVKVLTTVMVNVOVRVPVSVTCABGWDWAWB $.
  $}

  $( The unit interval is simply connected.  (Contributed by Mario Carneiro,
     9-Mar-2015.) $)
  iiscon $p |- II e. SCon $=
    ( cii cioo crn ctg cfv cc0 c1 cicc co crest cscon dfii2 cr wcel 0re iccscon
    1re mp2an eqeltri ) ABCDEFGHIJIZKLFMNGMNTKNOQFGPRS $.

  $( The unit interval is locally simply connected.  (Contributed by Mario
     Carneiro, 10-Mar-2015.) $)
  iillyscon $p |- II e. Locally SCon $=
    ( cii cioo crn ctg cfv c1 cicc co crest cscon clly dfii2 cr wcel iccllyscon
    cc0 0re 1re mp2an eqeltri ) ABCDEPFGHIHZJKZLPMNFMNUAUBNQRPFOST $.

  $( The unit interval is locally connected.  (Contributed by Mario Carneiro,
     6-Jul-2015.) $)
  iinllycon $p |- II e. N-Locally Con $=
    ( vx cscon cnlly ccon cii cv wcel cpcon sconpcon pconcon ssriv nllyss ax-mp
    wss syl clly llyssnlly iillyscon sselii ) BCZDCZEBDNTUANABDAFZBGUBHGUBDGUBI
    UBJOKBDLMBPTEBQRSS $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                Covering maps
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CovMap $.

  $( Extend class notation with the class of covering maps. $)
  ccvm $a class CovMap $.

  ${
    $d c j f x k s u v $.
    $( Define the class of covering maps on two topological spaces.  A function
       ` f : c --> j ` is a covering map if it is continuous and for every
       point ` x ` in the target space there is a neighborhood ` k ` of ` x `
       and a decomposition ` s ` of the preimage of ` k ` as a disjoint union
       such that ` f ` is a homeomorphism of each set ` u e. s ` onto ` k ` .
       (Contributed by Mario Carneiro, 13-Feb-2015.) $)
    df-cvm $a |- CovMap = ( c e. Top , j e. Top |-> { f e. ( c Cn j ) |
      A. x e. U. j E. k e. j ( x e. k /\ E. s e. ( ~P c \ { (/) } )
       ( U. s = ( `' f " k ) /\ A. u e. s
         ( A. v e. ( s \ { u } ) ( u i^i v ) = (/) /\
           ( f |` u ) e. ( ( c |`t u ) Homeo ( j |`t k ) ) ) ) ) } ) $.

    $( Lemma for covering maps.  (Contributed by Mario Carneiro,
       13-Feb-2015.) $)
    fncvm $p |- CovMap Fn ( Top X. Top ) $=
      ( vc vj vx vk vs vf vu vv ctop cv wcel cuni wceq c0 cdif wral crest co wa
      csn ccnv cima cin cres chmeo cpw wrex crab ccvm df-cvm ovex rabex fnmpt2i
      ccn ) ABIICJDJZKEJZLFJZUAUOUBMGJZHJUCNMHUPURTOPUQURUDAJZURQRBJZUOQRUERKSG
      UPPSEUSUFNTOUGSDUTUGCUTLPZFUSUTUNRZUHUICHGFBDEAUJVAFVBUSUTUNUKULUM $.
  $}

  ${
    $d a b c d f j k s u v x $.  $d a b c f j k s u x C $.  $d c f j x X $.
    $d a b c f k s u x F $.  $d a b c f j k s u x J $.
    iscvm.1 $e |- S = ( k e. J |->
      { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
        A. u e. s ( A. v e. ( s \ { u } ) ( u i^i v ) = (/) /\
           ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t k ) ) ) ) } ) $.
    $( Change bound variables in the set of even coverings.  (Contributed by
       Mario Carneiro, 17-Feb-2015.) $)
    cvmscbv $p |- S = ( a e. J |->
      { b e. ( ~P C \ { (/) } ) | ( U. b = ( `' F " a ) /\
        A. c e. b ( A. d e. ( b \ { c } ) ( c i^i d ) = (/) /\
           ( F |` c ) e. ( ( C |`t c ) Homeo ( J |`t a ) ) ) ) } ) $=
      ( cv wceq c0 wral crest co wa cuni ccnv cima cin csn cdif cres chmeo wcel
      cpw crab cmpt weq unieq eqeq1d ineq2 cbvralv sneq difeq2d ineq1 raleqbidv
      syl5bb reseq2 oveq1d eleq12d anbi12d difeq1 raleqdv anbi1d cbvrabv imaeq2
      oveq2 raleqbi1dv eqeq2d oveq2d eleq2d anbi2d ralbidv rabbidv syl5eq eqtri
      cbvmptv ) DEGHNZUAZFUBZENZUCZOZBNZANZUDZPOZAWCWIUEZUFZQZFWIUGZCWIRSZGWFRS
      ZUHSZUIZTZBWCQZTZHCUJPUEUFZUKZULIGJNZUAZWEINZUCZOZKNZLNZUDZPOZLXFXKUEZUFZ
      QZFXKUGZCXKRSZGXHRSZUHSZUIZTZKXFQZTZJXDUKZULMEIGXEYFEIUMZXEXGWGOZXQXRXSWR
      UHSZUIZTZKXFQZTZJXDUKYFXCYMHJXDHJUMZWHYHXBYLYNWDXGWGWCXFUNUOXBXNLWCXOUFZQ
      ZYJTZKWCQYNYLXAYQBKWCBKUMZWOYPWTYJWOWIXLUDZPOZLWNQYRYPWLYTALWNALUMWKYSPWJ
      XLWIUPUOUQYRYTXNLWNYOYRWMXOWCWIXKURUSYRYSXMPWIXKXLUTUOVAVBYRWPXRWSYIWIXKF
      VCYRWQXSWRUHWIXKCRVLVDVEVFUQYQYKKWCXFYNYPXQYJYNXNLYOXPWCXFXOVGVHVIVMVBVFV
      JYGYMYEJXDYGYHXJYLYDYGWGXIXGWFXHWEVKVNYGYKYCKXFYGYJYBXQYGYIYAXRYGWRXTXSUH
      WFXHGRVLVOVPVQVRVFVSVTWBWA $.

    iscvm.2 $e |- X = U. J $.
    $( The property of being a covering map.  (Contributed by Mario Carneiro,
       13-Feb-2015.) $)
    iscvm $p |- ( F e. ( C CovMap J ) <->
      ( ( C e. Top /\ J e. Top /\ F e. ( C Cn J ) ) /\ A. x e. X E. k e. J
        ( x e. k /\ ( S ` k ) =/= (/) ) ) ) $=
      ( vf ctop wcel wa co cv wrex wral vc vj ccn cfv wne w3a ccvm anass df-3an
      c0 anbi1i cuni ccnv cima wceq cin csn cdif cres crest chmeo crab elmpt2cl
      cpw df-cvm oveq12 simpr unieqd syl6eqr simpl pweqd oveq1 oveqan12d eleq2d
      difeq1d anbi2d ralbidv rexeqbidv raleqbidv rabeqbidv rabex ovmpt2a cvv id
      ovex pwexg adantr difexg rabexg 3syl fvmpt2 syl2anr neeq1d rabn0 rexbidva
      syl6bb cnveq imaeq1d eqeq2d reseq1 eleq1d anbi12d rexbidv syl6bbr biadan2
      elrab bitr4d 3bitr4ri ) DNOZHNOZPZGDHUCQZOZPZARFRZOZXOEUDZUJUEZPZFHSZAITZ
      PXKXMYAPZPXIXJXMUFZYAPGDHUGQZOZXKXMYAUHYCXNYAXIXJXMUIUKYEXKYBUAUBNNXPJRZU
      LZMRZUMZXOUNZUOZCRZBRUPUJUOBYFYLUQURTZYHYLUSZUARZYLUTQZUBRZXOUTQZVAQZOZPZ
      CYFTZPZJYOVDZUJUQZURZSZPZFYQSZAYQULZTZMYOYQUCQZVBZDHUGGABCMUBFJUAVEZVCXKY
      EGXPYKYMYNDYLUTQZHXOUTQZVAQZOZPZCYFTZPZJDVDZUUEURZSZPZFHSZAITZMXLVBZOZYBX
      KYDUVHGUAUBDHNNUUMUVHUGYODUOZYQHUOZPZUUKUVGMUULXLYODYQHUCVFUVLUUIUVFAUUJI
      UVLUUJHULIUVLYQHUVJUVKVGZVHLVIUVLUUHUVEFYQHUVMUVLUUGUVDXPUVLUUCUVAJUUFUVC
      UVLUUDUVBUUEUVLYODUVJUVKVJVKVOUVLUUBUUTYKUVLUUAUUSCYFUVLYTUURYMUVLYSUUQYN
      UVJUVKYPUUOYRUUPVAYODYLUTVLYQHXOUTVLVMVNVPVQVPVRVPVRVSVTUUNUVGMXLDHUCWEWA
      WBVNXKYBXMXPYGGUMZXOUNZUOZYMGYLUSZUUQOZPZCYFTZPZJUVCSZPZFHSZAITZPUVIXKYAU
      WEXMXKXTUWDAIXKXSUWCFHXKXOHOZPZXRUWBXPUWGXRUWAJUVCVBZUJUEUWBUWGXQUWHUJUWF
      UWFUWHWCOZXQUWHUOXKUWFWDXKUVBWCOZUVCWCOUWIXIUWJXJDNWFWGUVBUUEWCWHUWAJUVCW
      CWIWJFHUWHWCEKWKWLWMUWAJUVCWNWPVPWOVQVPUVGUWEMGXLYHGUOZUVFUWDAIUWKUVEUWCF
      HUWKUVDUWBXPUWKUVAUWAJUVCUWKYKUVPUUTUVTUWKYJUVOYGUWKYIUVNXOYHGWQWRWSUWKUU
      SUVSCYFUWKUURUVRYMUWKYNUVQUUQYHGYLWTXAVPVQXBXCVPXCVQXFXDXGXEXH $.
  $}

  ${
    $d k s u v x C $.  $d k s u x F $.  $d k s u x J $.
    $( Reverse closure for a covering map.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    cvmtop1 $p |- ( F e. ( C CovMap J ) -> C e. Top ) $=
      ( ccvm co wcel ctop c0 wceq n0i cxp wfn cdm fncvm fndm ax-mp ndmov simpld
      wa nsyl2 ) BACDEZFZAGFZCGFZUBUAHIUCUDSUABJACGDDGGKZLDMUEINUEDOPQTR $.

    $( Reverse closure for a covering map.  (Contributed by Mario Carneiro,
       13-Feb-2015.) $)
    cvmtop2 $p |- ( F e. ( C CovMap J ) -> J e. Top ) $=
      ( ccvm co wcel ctop c0 wceq n0i cxp wfn cdm fncvm fndm ax-mp ndmov simprd
      wa nsyl2 ) BACDEZFZAGFZCGFZUBUAHIUCUDSUABJACGDDGGKZLDMUEINUEDOPQTR $.

    $( A covering map is a continuous function.  (Contributed by Mario
       Carneiro, 13-Feb-2015.) $)
    cvmcn $p |- ( F e. ( C CovMap J ) -> F e. ( C Cn J ) ) $=
      ( vx vk vs vu vv co wcel ctop cv cuni wceq c0 csn cdif wral crest wa ccvm
      ccn w3a ccnv cima cin cres chmeo cpw crab cmpt cfv wne wrex iscvm simplbi
      eqid simp3d ) BACUAIJZAKJZCKJZBACUBIJZUSUTVAVBUCDLELZJVCECFLZMBUDVCUENGLZ
      HLUFONHVDVEPQRBVEUGAVESICVCSIUHIJTGVDRTFAUIOPQUJUKZULOUMTECUNDCMZRDHGAVFE
      BCVGFVFUQVGUQUOUPUR $.
  $}

  ${
    $d a b k s t u v w x y z C $.  $d a b k s t u v w x y z F $.  $d k x y P $.
    $d a b k s t u v w x y z J $.  $d t w x y z S $.  $d k s t u v w x y z U $.
    $d s u v x z T $.  $d a b k s t u v w x y z V $.  $d v W $.  $d x y z X $.
    $d t u v w x y z A $.  $d t v w x y z B $.
    cvmcov.1 $e |- S = ( k e. J |->
      { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
        A. u e. s ( A. v e. ( s \ { u } ) ( u i^i v ) = (/) /\
           ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t k ) ) ) ) } ) $.
    ${
      cvmcov.2 $e |- X = U. J $.
      $( Property of a covering map.  In order to make the covering property
         more manageable, we define here the set ` S ( k ) ` of all even
         coverings of an open set ` k ` in the range.  Then the covering
         property states that every point has a neighborhood which has an even
         covering.  (Contributed by Mario Carneiro, 13-Feb-2015.) $)
      cvmcov $p |- ( ( F e. ( C CovMap J ) /\ P e. X ) ->
        E. x e. J ( P e. x /\ ( S ` x ) =/= (/) ) ) $=
        ( co wcel wa cv c0 wrex wceq ccvm cfv wne wral ctop ccn w3a iscvm eleq1
        simprbi anbi1d rexbidv rspcv mpan9 nfv cuni ccnv cima cin csn cdif cres
        crest chmeo cpw crab cmpt nfmpt1 nfcxfr nfcv nffv nfne nfan eleq2 fveq2
        neeq1d anbi12d cbvrex sylibr ) HDIUANOZEJOZPEGQZOZWBFUBZRUCZPZGISZEAQZO
        ZWHFUBZRUCZPZAISVTWHWBOZWEPZGISZAJUDZWAWGVTDUEOIUEOHDIUFNOUGWPABCDFGHIJ
        KLMUHUJWOWGAEJWHETZWNWFGIWQWMWCWEWHEWBUIUKULUMUNWLWFAGIWIWKGWIGUOGWJRGW
        HFGFGIKQZUPHUQWBURTCQZBQUSRTBWRWSUTVAUDHWSVBDWSVCNIWBVCNVDNOPCWRUDPKDVE
        RUTVAVFZVGLGIWTVHVIGWHVJVKGRVJVLVMWFAUOWHWBTZWIWCWKWEWHWBEVNXAWJWDRWHWB
        FVOVPVQVRVS $.
    $}

    $( Reverse closure for an even covering.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    cvmsrcl $p |- ( T e. ( S ` U ) -> U e. J ) $=
      ( wcel cv wceq c0 csn cdif wral crest co cfv cdm cuni ccnv cima cin chmeo
      cres wa cpw crab dmmptss elfvdm sseldi ) EFDUALDUBIFGIJMZUCHUDGMZUENBMZAM
      UFONAUOUQPQRHUQUHCUQSTIUPSTUGTLUIBUORUIJCUJOPQUKDKULEFDUMUN $.

    $( One direction of ~ cvmsval .  (Contributed by Mario Carneiro,
       13-Feb-2015.) $)
    cvmsi $p |- ( T e. ( S ` U ) ->
      ( U e. J /\ ( T C_ C /\ T =/= (/) ) /\ ( U. T = ( `' F " U ) /\
        A. u e. T ( A. v e. ( T \ { u } ) ( u i^i v ) = (/) /\
           ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t U ) ) ) ) ) ) $=
      ( wcel c0 wa wceq cv cdif wral crest co cfv wss cuni ccnv cima cres chmeo
      wne cin csn cvmsrcl crab imaeq2 eqeq2d oveq2 oveq2d eleq2d anbi2d ralbidv
      cpw anbi12d rabbidv fvmptss2 sseli unieq eqeq1d difeq1 raleqdv raleqbi1dv
      anbi1d elrab sylib simpld eldifsn elpwi anim1i syl simprd 3jca ) EFDUAZLZ
      FILECUBZEMUHZNZEUCZHUDZFUEZOZBPZAPUIMOZAEWIUJZQZRZHWIUFZCWISTZIFSTZUGTZLZ
      NZBERZNZABCDEFGHIJKUKWAECUTZLZWCNZWDWAEXBMUJQZLZXDWAXFXAWAEJPZUCZWGOZWJAX
      GWKQZRZWRNZBXGRZNZJXEULZLXFXANVTXOEGIXHWFGPZUEZOZXKWNWOIXPSTZUGTZLZNZBXGR
      ZNZJXEULXOFDXPFOZYDXNJXEYEXRXIYCXMYEXQWGXHXPFWFUMUNYEYBXLBXGYEYAWRXKYEXTW
      QWNYEXSWPWOUGXPFISUOUPUQURUSVAVBKVCVDXNXAJEXEXGEOZXIWHXMWTYFXHWEWGXGEVEVF
      XLWSBXGEYFXKWMWRYFWJAXJWLXGEWKVGVHVJVIVAVKVLZVMEXBMVNVLXCWBWCECVOVPVQWAXF
      XAYGVRVS $.

    $( Elementhood in the set ` S ` of all even coverings of an open set in
       ` J ` . ` S ` is an even covering of ` U ` if it is a nonempty
       collection of disjoint open sets in ` C ` whose union is the preimage of
       ` U ` , such that each set ` u e. S ` is homeomorphic under ` F ` to
       ` U ` .  (Contributed by Mario Carneiro, 13-Feb-2015.) $)
    cvmsval $p |- ( C e. V -> ( T e. ( S ` U ) <->
      ( U e. J /\ ( T C_ C /\ T =/= (/) ) /\ ( U. T = ( `' F " U ) /\
        A. u e. T ( A. v e. ( T \ { u } ) ( u i^i v ) = (/) /\
           ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t U ) ) ) ) ) ) ) $=
      ( wcel c0 wa wceq cv wral co cvv cfv wss wne cuni ccnv cima cin cdif cres
      csn crest chmeo w3a cvmsi 3anass cpw crab pwexg difexg rabexg 3syl imaeq2
      id eqeq2d oveq2 oveq2d eleq2d anbi2d ralbidv anbi12d rabbidv fvmptg unieq
      syl2anr eqeq1d difeq1 raleqdv anbi1d raleqbi1dv elrab elpw2g adantr bitrd
      eldifsn wb syl5bb biimprd expimpd syl5bi impbid2 ) CJMZEFDUAZMZFIMZECUBZE
      NUCZOZEUDZHUEZFUFZPZBQZAQUGNPZAEXBUJZUHZRZHXBUIZCXBUKSZIFUKSZULSZMZOZBERZ
      OZUMZABCDEFGHIKLUNXOWNWQXNOZOWKWMWNWQXNUOWKWNXPWMWKWNOZWMXPXQWMEKQZUDZWTP
      ZXCAXRXDUHZRZXKOZBXRRZOZKCUPZNUJZUHZUQZMZXPXQWLYIEWNWNYITMZWLYIPWKWNVCWKY
      FTMYHTMYKCJURYFYGTUSYEKYHTUTVAGFXSWSGQZUFZPZYBXGXHIYLUKSZULSZMZOZBXRRZOZK
      YHUQYIITDYLFPZYTYEKYHUUAYNXTYSYDUUAYMWTXSYLFWSVBVDUUAYRYCBXRUUAYQXKYBUUAY
      PXJXGUUAYOXIXHULYLFIUKVEVFVGVHVIVJVKLVLVNVGYJEYHMZXNOXQXPYEXNKEYHXREPZXTX
      AYDXMUUCXSWRWTXREVMVOYCXLBXREUUCYBXFXKUUCXCAYAXEXREXDVPVQVRVSVJVTXQUUBWQX
      NUUBEYFMZWPOXQWQEYFNWDXQUUDWOWPWKUUDWOWEWNECJWAWBVRWFVRWFWCWGWHWIWJ $.

    $( An even covering is a subset of the topology of the domain (i.e. a
       collection of open sets).  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    cvmsss $p |- ( T e. ( S ` U ) -> T C_ C ) $=
      ( cfv wcel c0 wa wceq cv wral crest co wss cuni ccnv cima cdif cres chmeo
      wne cin csn cvmsi simp2d simpld ) EFDLMZECUAZENUHZUNFIMUOUPOEUBHUCFUDPBQZ
      AQUINPAEUQUJUERHUQUFCUQSTIFSTUGTMOBEROABCDEFGHIJKUKULUM $.

    $( An even covering is nonempty.  (Contributed by Mario Carneiro,
       11-Feb-2015.) $)
    cvmsn0 $p |- ( T e. ( S ` U ) -> T =/= (/) ) $=
      ( cfv wcel c0 wa wceq cv wral crest co wss cuni ccnv cima cdif cres chmeo
      wne cin csn cvmsi simp2d simprd ) EFDLMZECUAZENUHZUNFIMUOUPOEUBHUCFUDPBQZ
      AQUINPAEUQUJUERHUQUFCUQSTIFSTUGTMOBEROABCDEFGHIJKUKULUM $.

    $( An even covering of ` U ` has union equal to the preimage of ` U ` by
       ` F ` .  (Contributed by Mario Carneiro, 11-Feb-2015.) $)
    cvmsuni $p |- ( T e. ( S ` U ) -> U. T = ( `' F " U ) ) $=
      ( cfv wcel wceq cv c0 wral crest co wa cuni ccnv cima cin cdif cres chmeo
      csn wss wne cvmsi simp3d simpld ) EFDLMZEUAHUBFUCNZBOZAOUDPNAEUPUHUEQHUPU
      FCUPRSIFRSUGSMTBEQZUNFIMECUIEPUJTUOUQTABCDEFGHIJKUKULUM $.

    $( An even covering of ` U ` is a disjoint union.  (Contributed by Mario
       Carneiro, 13-Feb-2015.) $)
    cvmsdisj $p |- ( ( T e. ( S ` U ) /\ A e. T /\ B e. T ) ->
      ( A = B \/ ( A i^i B ) = (/) ) ) $=
      ( wcel wceq cin c0 wne wa wral cfv w3a wn df-ne wi cv csn cdif cres crest
      co chmeo cuni ccnv cima wss cvmsi simp3d simprd simpl ralimi sneq difeq2d
      ineq1 eqeq1d raleqbidv rspccva sylan necom eldifsn biimpri sylan2b rspccv
      syl ineq2 syl2im exp3a 3impia syl5bir orrd ) GHFUANZCGNZDGNZUBZCDOZCDPZQO
      ZWEUCCDRZWDWGCDUDWAWBWCWHWGUEWAWBSZWCWHWGWICAUFZPZQOZAGCUGZUHZTZWCWHSDWNN
      ZWGWABUFZWJPZQOZAGWQUGZUHZTZBGTZWBWOWAXBJWQUIEWQUJUKKHUJUKULUKNZSZBGTZXCW
      AGUMJUNHUOOZXFWAHKNGEUPGQRSXGXFSABEFGHIJKLMUQURUSXEXBBGXBXDUTVAVNXBWOBCGW
      QCOZWSWLAXAWNXHWTWMGWQCVBVCXHWRWKQWQCWJVDVEVFVGVHWHWCDCRZWPCDVIWPWCXISDGC
      VJVKVLWLWGADWNWJDOWKWFQWJDCVOVEVMVPVQVRVSVT $.

    $( Every element of an even covering of ` U ` is homeomorphic to ` U ` via
       ` F ` .  (Contributed by Mario Carneiro, 13-Feb-2015.) $)
    cvmshmeo $p |- ( ( T e. ( S ` U ) /\ A e. T ) ->
      ( F |` A ) e. ( ( C |`t A ) Homeo ( J |`t U ) ) ) $=
      ( wcel cv crest co chmeo wral wceq wa cfv cres cin c0 cdif cuni ccnv cima
      csn wss wne cvmsi simp3d simprd simpr ralimi reseq2 oveq2 eleq12d rspccva
      syl oveq1d sylan ) FGEUAMZIBNZUBZDVEOPZJGOPZQPZMZBFRZCFMICUBZDCOPZVHQPZMZ
      VDVEANUCUDSAFVEUIUERZVJTZBFRZVKVDFUFIUGGUHSZVRVDGJMFDUJFUDUKTVSVRTABDEFGH
      IJKLULUMUNVQVJBFVPVJUOUPVAVJVOBCFVECSZVFVLVIVNVECIUQVTVGVMVHQVECDOURVBUSU
      TVC $.

    $( ` F ` , localized to an element of an even covering of ` U ` , is a
       bijection.  (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    cvmsf1o $p |- ( ( F e. ( C CovMap J ) /\ T e. ( S ` U ) /\ A e. T ) ->
      ( F |` A ) : A -1-1-onto-> U ) $=
      ( co wcel cfv crest ctopon cuni wss ctop ccvm w3a cres chmeo wf1o cvmtop1
      3ad2ant1 eqid toptopon sylib cvmsss 3ad2ant2 sseldd elssuni syl resttopon
      simp3 syl2anc cvmtop2 cvmsrcl cvmshmeo 3adant1 hmeof1o2 syl3anc ) IDJUAMN
      ZFGEONZCFNZUBZDCPMZCQONZJGPMZGQONZICUCZVIVKUDMNZCGVMUEVHDDRZQONZCVOSZVJVH
      DTNZVPVEVFVRVGDIJUFUGDVOVOUHUIUJVHCDNVQVHFDCVFVEFDSVGABDEFGHIJKLUKULVEVFV
      GUQUMCDUNUOCDVOUPURVHJJRZQONZGVSSZVLVHJTNZVTVEVFWBVGDIJUSUGJVSVSUHUIUJVHG
      JNZWAVFVEWCVGABDEFGHIJKLUTULGJUNUOGJVSUPURVFVGVNVEABCDEFGHIJKLVAVBVMVIVKC
      GVCVD $.

    $( The sets of an even covering are clopen in the subspace topology on
       ` T ` .  (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    cvmscld $p |- ( ( F e. ( C CovMap J ) /\ T e. ( S ` U ) /\ A e. T ) ->
      A e. ( Clsd ` ( C |`t ( `' F " U ) ) ) ) $=
      ( vx wcel cuni wss wceq syl2anc cin c0 ccvm co cfv w3a ccnv cima csn cdif
      crest ccld ctop cvmtop1 3ad2ant1 cvmsuni 3ad2ant2 cvmsss eqsstr3d restuni
      unissd eqid difeq1d cun unisng 3ad2ant3 uneq2d uniun undif1 simp3 ssequn2
      snssd sylib syl5eq unieqd eqtrd syl5eqr eqtr3d difss unissi syl5sseq ciun
      wb cv uniiun ineq2i incom iunin2 3eqtr4i wa wne eldifsn necom df-ne bitri
      wn wo cvmsdisj 3expa ord syl5bi impr sylan2b iuneq2dv 3adant1 iun0 syl6eq
      uneqdifeq mpbid cvv uniexg eqeltrrd resttop elssuni adantl adantr sseqtrd
      df-ss sselda elrestr syl3anc ex ssrdv ssdifssd uniopn opncld ) IDJUAUBNZF
      GEUCZNZCFNZUDZDIUEGUFZUIUBZOZFCUGZUHZOZUHZCYKUJUCZYIYJYOUHZYPCYIYJYLYOYID
      UKNZYJDOZPYJYLQYEYGYSYHDIJULUMZYIYJFOZYTYGYEUUBYJQZYHABDEFGHIJKLUNUOZYIFD
      YGYEFDPYHABDEFGHIJKLUPUOZUSUQYJDYTYTUTURRVAYIYOCVBZYJQZYRCQZYIYOYMOZVBZUU
      FYJYIUUICYOYHYEUUICQYGCFVCVDVEYIUUJYNYMVBZOZYJYNYMVFYIUULUUBYJYIUUKFYIUUK
      FYMVBZFFYMVGYIYMFPUUMFQYICFYEYGYHVHVJYMFVIVKVLVMUUDVNVOVPYIYOYJPYOCSZTQUU
      GUUHWAYIUUBYOYJYNFFYMVQVRUUDVSYIUUNMYNCMWBZSZVTZTCYOSCMYNUUOVTZSUUNUUQYOU
      URCMYNWCWDYOCWEMYNCUUOWFWGYIUUQMYNTVTZTYGYHUUQUUSQYEYGYHWHZMYNUUPTUUOYNNU
      UTUUOFNZUUOCWIZWHUUPTQZUUOFCWJUUTUVAUVBUVCUVBCUUOQZWNZUUTUVAWHZUVCUVBCUUO
      WIUVEUUOCWKCUUOWLWMUVFUVDUVCYGYHUVAUVDUVCWOABCUUODEFGHIJKLWPWQWRWSWTXAXBX
      CMYNXDXEVLYOCYJXFRXGVPYIYKUKNZYOYKNZYPYQNYIYSYJXHNZUVGUUAYIUUBYJXHUUDYGYE
      UUBXHNYHFYFXIUOXJZYJDXHXKRZYIUVGYNYKPUVHUVKYIFYKYMYIMFYKYIUVAUUOYKNYIUVAW
      HZUUOYJSZUUOYKUVLUUOYJPUVMUUOQUVLUUOUUBYJUVAUUOUUBPYIUUOFXLXMYIUUCUVAUUDX
      NXOUUOYJXPVKUVLYSUVIUUODNUVMYKNYIYSUVAUUAXNYIUVIUVAUVJXNYIFDUUOUUEXQUUOYJ
      DUKXHXRXSXJXTYAYBYNYKYCRYOYKYLYLUTYDRXJ $.

    $( An open subset of an evenly covered set is evenly covered.  (Contributed
       by Mario Carneiro, 7-Jul-2015.) $)
    cvmsss2 $p |- ( ( F e. ( C CovMap J ) /\ V e. J /\ V C_ U ) ->
      ( ( S ` U ) =/= (/) -> ( S ` V ) =/= (/) ) ) $=
      ( vy vz vt c0 wcel co wss wa wceq vx vw va vb cfv wne cv wex ccvm n0 ccnv
      w3a cima cin cmpt crn cuni csn cdif wral cres crest chmeo simpl2 wel ctop
      wf simpl1 cvmtop1 syl adantr cvmsss adantl sselda ccn cvmcn cnima syl2anc
      inopn syl3anc fmptd frn cvmsn0 cdm cvv dmmptg inex1g eqeq1i dm0rn0 bitr3i
      eqid necon3bii sylib jca cpw inss2 wb elpw2g mpbiri sspwuni simpl3 imass2
      mprg cvmsuni sseqtr4d wrex weq ineq1 eqeq2d rspcev mpan2 ad2antrl elrnmpt
      vex inex1 ax-mp sylibr simprr simplr elin eleq2 rexlimdvaa eluni2 3imtr4g
      sylanbrc mpd ex ssrdv eqssd eldifsn wi wn equcoms necon3ai wo simpr inss1
      eqeq1d syl5bi restabs simpllr cvmsdisj ord sseq0 mpan syl56 neeq1 inindir
      ineq2 syl6eqr imbi12d syl5ibrcom rexlimdva imp3a ralrimiv resabs1 adantll
      cvmshmeo elssuni restuni syl5sseq hmeores syl5eqelr a1i cnvresima imaeq2i
      incom eqtr4i wfo wf1o cvmsf1o f1ofo foimacnv syl5eq cvmtop2 cvmsrcl eqtrd
      oveq2d oveq12d eleqtrd ralrimiva rgenw cbvmptv sneq difeq2d reseq2 oveq1d
      raleqbidv eleq12d anbi12d ralrnmpt cvmscbv cvmsval mpbir3and ne0i exlimdv
      oveq2 ) EDUEZOUFUAUGZUWRPZUAUHGCHUIQPZIHPZIERZULZIDUEZOUFZUAUWRUJUXDUWTUX
      FUAUXDUWTUXFUXDUWTSZLUWSLUGZGUKZIUMZUNZUOZUPZUXEPZUXFUXGUXNUXBUXMCRZUXMOU
      FZSZUXMUQZUXJTZUBUGZMUGZUNZOTZMUXMUXTURZUSZUTZGUXTVAZCUXTVBQZHIVBQZVCQZPZ
      SZUBUXMUTZSZUXAUXBUXCUWTVDZUXGUXOUXPUXGUWSCUXLVGUXOUXGLUWSUXKCUXLUXGLUAVE
      ZSZCVFPZUXHCPUXJCPZUXKCPUXGUYRUYPUXGUXAUYRUXAUXBUXCUWTVHZCGHVIVJZVKUXGUWS
      CUXHUWTUWSCRUXDABCDUWSEFGHJKVLVMZVNUXGUYSUYPUXGGCHVOQPZUXBUYSUXGUXAVUCUYT
      CGHVPVJUYOIGCHVQVRVKZUXHUXJCVSVTUXLWKZWAUWSCUXLWBVJUXGUWSOUFZUXPUWTVUFUXD
      ABCDUWSEFGHJKWCVMUWSOUXMOUWSOTUXLWDZOTUXMOTVUGUWSOUXKWEPVUGUWSTLUWSLUWSUX
      KWEWFUXHUXJUWSWGXCWHUXLWIWJWLWMWNUXGUXSUYMUXGUXRUXJUXGUXMUXJWOZRZUXRUXJRU
      XGUWSVUHUXLVGVUIUXGLUWSUXKVUHUXLUYQUXKVUHPZUXKUXJRZUXHUXJWPUYQUYSVUJVUKWQ
      VUDUXKUXJCWRVJWSVUEWAUWSVUHUXLWBVJUXMUXJWTWMUXGMUXJUXRUXGUYAUXJPZUYAUXRPZ
      UXGVULSZUYAUWSUQZPZVUMUXGUXJVUOUYAUXGUXJUXIEUMZVUOUXGUXCUXJVUQRUXAUXBUXCU
      WTXAZIEUXIXBVJUWTVUOVUQTUXDABCDUWSEFGHJKXDVMXEVNVUNMNVEZNUWSXFMUBVEZUBUXM
      XFZVUPVUMVUNVUSVVANUWSVUNNUAVEZVUSSZSZNUGZUXJUNZUXMPZUYAVVFPZVVAVVDVVFUXK
      TZLUWSXFZVVGVVBVVJVUNVUSVVBVVFVVFTZVVJVVFWKVVIVVKLVVEUWSLNXGUXKVVFVVFUXHV
      VEUXJXHZXIXJXKXLVVFWEPZVVGVVJWQVVEUXJNXNXOZLUWSUXKVVFUXLWEVUEXMXPXQVVDVUS
      VULVVHVUNVVBVUSXRUXGVULVVCXSUYAVVEUXJXTYEVUTVVHUBVVFUXMUXTVVFUYAYAXJVRYBN
      UYAUWSYCUBUYAUXMYCYDYFYGYHYIUXGVVFUYAUNZOTZMUXMVVFURZUSZUTZGVVFVAZCVVFVBQ
      ZUYIVCQZPZSZNUWSUTZUYMUXGVWDNUWSUXGVVBSZVVSVWCVWFVVPMVVRUYAVVRPUYAUXMPZUY
      AVVFUFZSVWFVVPUYAUXMVVFYJVWFVWGVWHVVPVWGUYAUXKTZLUWSXFZVWFVWHVVPYKZUYAWEP
      VWGVWJWQMXNLUWSUXKUYAUXLWEVUEXMXPVWFVWIVWKLUWSVWFUYPSZVWKVWIUXKVVFUFZVVEU
      XHUNZUXJUNZOTZYKVWMNLXGZYLVWLVWNOTZVWPVWQUXKVVFUXKVVFTLNVVLYMYNVWLVWQVWRV
      WLUWTVVBUYPVWQVWRYOUXDUWTVVBUYPUUAUXGVVBUYPXSVWFUYPYPABVVEUXHCDUWSEFGHJKU
      UBVTUUCVWOVWNRVWRVWPVWNUXJYQVWOVWNUUDUUEUUFVWIVWHVWMVVPVWPUYAUXKVVFUUGVWI
      VVOVWOOVWIVVOVVFUXKUNVWOUYAUXKVVFUUIVVEUXHUXJUUHUUJYRUUKUULUUMYSUUNYSUUOV
      WFVVTCVVEVBQZVVFVBQZHEVBQZGVVEVAZVVFUMZVBQZVCQZVWBVWFVVTVXBVVFVAZVXEVVFVV
      ERZVXFVVTTVVEUXJYQZGVVFVVEUUPXPVWFVXBVWSVXAVCQPZVVFVWSUQZRVXFVXEPUWTVVBVX
      IUXDABVVECDUWSEFGHJKUURUUQVWFVVEVVFVXJVXHVWFUYRVVECUQZRZVVEVXJTUXGUYRVVBV
      UAVKZVWFVVECPVXLUXGUWSCVVEVUBVNVVECUUSVJVVECVXKVXKWKUUTVRUVAVXBVWSVXAVXJV
      VFVXJWKUVBVRUVCVWFVWTVWAVXDUYIVCVWFUYRVXGVVBVWTVWATVXMVXGVWFVXHUVDUXGVVBY
      PZVVFVVECVFUWSYTVTVWFVXDVXAIVBQZUYIVWFVXCIVXAVBVWFVXCVXBVXBUKIUMZUMZIVVFV
      XPVXBVVFUXJVVEUNVXPVVEUXJUVGVVEIGUVEUVHUVFVWFVVEEVXBUVIZUXCVXQITVWFVVEEVX
      BUVJZVXRVWFUXAUWTVVBVXSUXGUXAVVBUYTVKUXDUWTVVBXSVXNABVVECDUWSEFGHJKUVKVTV
      VEEVXBUVLVJUXGUXCVVBVURVKVVEEIVXBUVMVRUVNUVRUXGVXOUYITZVVBUXGHVFPZUXCEHPZ
      VXTUXGUXAVYAUYTCGHUVOVJVURUWTVYBUXDABCDUWSEFGHJKUVPVMIEHVFHYTVTVKUVQUVSUV
      TWNUWAVVMNUWSUTUYMVWEWQVVMNUWSVVNUWBUYLVWDNUBUWSVVFUXLWELNUWSUXKVVFVVLUWC
      UXTVVFTZUYFVVSUYKVWCVYCUYCVVPMUYEVVRVYCUYDVVQUXMUXTVVFUWDUWEVYCUYBVVOOUXT
      VVFUYAXHYRUWHVYCUYGVVTUYJVWBUXTVVFGUWFVYCUYHVWAUYIVCUXTVVFCVBUWQUWGUWIUWJ
      UWKXPXQWNUXGUYRUXNUXBUXQUYNULWQVUAMUBCDUXMIUCGHVFUDABCDFGHJUCUDUBMKUWLUWM
      VJUWNUXEUXMUWOVJYGUWPYS $.

    $( The covering map property can be restricted to an open subset.
       (Contributed by Mario Carneiro, 7-Jul-2015.) $)
    cvmcov2 $p |- ( ( F e. ( C CovMap J ) /\ U e. J /\ P e. U ) ->
      E. x e. ~P U ( P e. x /\ ( S ` x ) =/= (/) ) ) $=
      ( vy wcel cv cfv c0 wne wa adantr ccvm co w3a wrex cuni simp1 simp3 simp2
      cpw elunii syl2anc eqid cvmcov cin wss inss2 vex inex1 elpw mpbir simprrl
      a1i elin sylanbrc simprrr wi ctop cvmtop2 syl inopn syl3anc inss1 cvmsss2
      simprl mpd wceq eleq2 fveq2 neeq1d anbi12d rspcev syl12anc rexlimddv ) ID
      JUAUBNZGJNZEGNZUCZEMOZNZWHFPQRZSZEAOZNZWLFPZQRZSZAGUIZUDZMJWGWDEJUEZNZWKM
      JUDWDWEWFUFZWGWFWEWTWDWEWFUGZWDWEWFUHZEGJUJUKMBCDEFHIJWSKLWSULUMUKWGWHJNZ
      WKSZSZWHGUNZWQNZEXGNZXGFPZQRZWRXHXFXHXGGUOWHGUPXGGWHGMUQURUSUTVBXFWIWFXIW
      GXDWIWJVAWGWFXEXBTEWHGVCVDXFWJXKWGXDWIWJVEXFWDXGJNZXGWHUOZWJXKVFWGWDXEXAT
      ZXFJVGNZXDWEXLXFWDXOXNDIJVHVIWGXDWKVNWGWEXEXCTWHGJVJVKXMXFWHGVLVBBCDFWHHI
      JXGKLVMVKVOWPXIXKSAXGWQWLXGVPZWMXIWOXKWLXGEVQXPWNXJQWLXGFVRVSVTWAWBWC $.

    cvmseu.1 $e |- B = U. C $.
    $( Every element in ` U. T ` is a member of a unique element of ` T ` .
       (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    cvmseu $p |- ( ( F e. ( C CovMap J ) /\
      ( T e. ( S ` U ) /\ A e. B /\ ( F ` A ) e. U ) ) -> E! x e. T A e. x ) $=
      ( vz wcel wa wceq c0 ccvm co cfv w3a wrex wral wreu cuni ccnv cima simpr2
      cv wi simpr3 ccn wf wfn cvmcn adantr eqid cnf ffn elpreima 4syl mpbir2and
      wb simpr1 cvmsuni syl eleqtrrd eluni2 sylib cin wne inelcm cvmsdisj 3expb
      wo sylan ord necon1ad syl5 ralrimivva eleq2 reu4 sylanbrc ) KFLUAUBQZHIGU
      CQZDEQZDKUCIQZUDZRZDAULZQZAHUEZWNDPULZQZRZWMWPSZUMZPHUFAHUFWNAHUGWLDHUHZQ
      WOWLDKUIIUJZXAWLDXBQZWIWJWGWHWIWJUKWGWHWIWJUNWLKFLUOUBQZELUHZKUPKEUQXCWIW
      JRVFWGXDWKFKLURUSKFLEXEOXEUTVAEXEKVBEDIKVCVDVEWLWHXAXBSWGWHWIWJVGZBCFGHIJ
      KLMNVHVIVJADHVKVLWLWTAPHHWRWMWPVMZTVNWLWMHQZWPHQZRZRZWSDWMWPVOXKWSXGTXKWS
      XGTSZWLWHXJWSXLVRZXFWHXHXIXMBCWMWPFGHIJKLMNVPVQVSVTWAWBWCWNWQAPHWMWPDWDWE
      WF $.

    ${
      cvmsiota.2 $e |- W = ( iota_ x e. T A e. x ) $.
      $( Identify the unique element of ` T ` containing ` A ` .  (Contributed
         by Mario Carneiro, 14-Feb-2015.) $)
      cvmsiota $p |- ( ( F e. ( C CovMap J ) /\
        ( T e. ( S ` U ) /\ A e. B /\ ( F ` A ) e. U ) ) ->
          ( W e. T /\ A e. W ) ) $=
        ( wcel cfv wa ccvm co w3a crab crio wreu cvmseu riotacl2 syl5eqel eleq2
        cv syl cbvrabv elrab2 sylib ) KFLUAUBRHIGSRDERDKSIRUCTZMDAUKZRZAHUDZRMH
        RDMRZTUPMURAHUEZUSQUPURAHUFVAUSRABCDEFGHIJKLNOPUGURAHUHULUIDBUKZRZUTBMH
        USVBMDUJURVCABHUQVBDUJUMUNUO $.
    $}

    $( Lemma for ~ cvmopn .  (Contributed by Mario Carneiro, 7-May-2015.) $)
    cvmopnlem $p |- ( ( F e. ( C CovMap J ) /\ A e. C ) -> ( F " A ) e. J ) $=
      ( vx vy co wcel wa cv wss adantr vz vt vw ccvm cima wrex wral cfv c0 cuni
      wne simpll wf ccn cvmcn eqid cnf elssuni syl6sseqr adantl sselda ffvelrnd
      syl cvmcov syl2anc wex crio cin crest cres wceq inss2 resima2 ax-mp chmeo
      n0 simprr simprl cvmsiota syl13anc simpld cvmtop1 simpllr elrestr syl3anc
      cvmshmeo ctop hmeoima wb cvmtop2 ad2antrr cvmsrcl ad2antll restopn2 mpbid
      syl5eqelr wfn ffn inss1 syl5ss simplr simprd elin sylanbrc fnfvima imass2
      mp1i eleq2 sseq1 anbi12d rspcev syl12anc exlimdv syl5bi expimpd rexlimdvw
      expr mpd ralrimiva eleq1 anbi1d rexbidv ralima mpbird eltop2 ) HEIUDOPZCE
      PZQZHCUEZIPZMRZNRZPZYLYISZQZNIUFZMYIUGZYHYQUARZHUHZYLPZYNQZNIUFZUACUGZYHU
      UBUACYHYRCPZQZYSUBRZPZUUFFUHZUIUKZQZUBIUFZUUBUUEYFYSIUJZPUUKYFYGUUDULZUUE
      DUULYRHYHDUULHUMZUUDYHHEIUNOPZUUNYFUUOYGEHIUOTHEIDUULLUULUPZUQVCZTYHCDYRY
      GCDSZYFYGCEUJDCEURLUSZUTZVAZVBUBABEYSFGHIUULJKUUPVDVEUUEUUJUUBUBIUUEUUGUU
      IUUBUUIUCRZUUHPZUCVFUUEUUGQZUUBUCUUHVPUVDUVCUUBUCUUEUUGUVCUUBUUEUUGUVCQZQ
      ZHCYRYKPMUVBVGZVHZUEZIPZYSUVIPZUVIYISZUUBUVFUVJUVIUUFSZUVFUVIIUUFVIOZPZUV
      JUVMQZUVFUVIHUVGVJZUVHUEZUVNUVHUVGSUVRUVIVKCUVGVLHUVHUVGVMVNUVFUVQEUVGVIO
      ZUVNVOOPZUVHUVSPZUVRUVNPUVFUVCUVGUVBPZUVTUUEUUGUVCVQZUVFUWBYRUVGPZUVFYFUV
      CYRDPZUUGUWBUWDQUUEYFUVEUUMTZUWCUUEUWEUVEUVATUUEUUGUVCVRMABYRDEFUVBUUFGHI
      UVGJKLUVGUPVSVTZWAZABUVGEFUVBUUFGHIJKWFVEUVFEWGPZUWBYGUWAUVFYFUWIUWFEHIWB
      VCUWHYFYGUUDUVEWCZCUVGEWGUVBWDWEUVHUVQUVSUVNWHVEWPUVFIWGPZUUFIPZUVOUVPWIY
      HUWKUUDUVEYFUWKYGEHIWJTZWKUVCUWLUUEUUGABEFUVBUUFGHIJKWLWMUUFUVIIWNVEWOWAU
      VFHDWQZUVHDSYRUVHPZUVKYHUWNUUDUVEYHUUNUWNUUQDUULHWRVCZWKUVFUVHCDCUVGWSZUV
      FYGUURUWJUUSVCWTUVFUUDUWDUWOYHUUDUVEXAUVFUWBUWDUWGXBYRCUVGXCXDDUVHHYRXEWE
      UVHCSUVLUVFUWQUVHCHXFXGUUAUVKUVLQNUVIIYLUVIVKYTUVKYNUVLYLUVIYSXHYLUVIYIXI
      XJXKXLXQXMXNXOXPXRXSYHUWNUURYQUUCWIUWPUUTYPUUBMUADCHYKYSVKZYOUUANIUWRYMYT
      YNYKYSYLXTYAYBYCVEYDYHUWKYJYQWIUWMMNYIIYEVCYD $.

    cvmfolem.2 $e |- X = U. J $.
    $( Lemma for ~ cvmfo .  (Contributed by Mario Carneiro, 13-Feb-2015.) $)
    cvmfolem $p |- ( F e. ( C CovMap J ) -> F : B -onto-> X ) $=
      ( vx vy wcel cv cfv wceq wa vz vw vt ccvm co wf wrex wral wfo ccn cnf syl
      cvmcn c0 wne cvmcov ex wex n0 cvmsn0 ad2antll sylib cres ccnv wss simprlr
      cuni cvmsss simprr sseldd elssuni syl6sseqr simpll cvmsf1o syl3anc f1ocnv
      wf1o f1of 3syl simprll f1ocnvfv2 syl2anc fvres eqtr3d fveq2 eqeq2d rspcev
      ffvelrnd expr exlimdv mpd syl5bi expimpd rexlimdva syld ralrimiv sylanbrc
      dffo3 ) GDHUDUEPZCIGUFZNQZOQZGRZSZOCUGZNIUHCIGUIWSGDHUJUEPWTDGHUMGDHCILMU
      KULWSXENIWSXAIPZXAUAQZPZXGERZUNUOZTZUAHUGZXEWSXFXLUAABDXAEFGHIJKMUPUQWSXK
      XEUAHWSXGHPZTZXHXJXEXJUBQZXIPZUBURXNXHTZXEUBXIUSXQXPXEUBXNXHXPXEXNXHXPTZT
      ZUCQZXOPZUCURZXEXSXOUNUOZYBXPYCXNXHABDEXOXGFGHJKUTVAUCXOUSVBXSYAXEUCXNXRY
      AXEXNXRYATZTZXAGXTVCZVDZRZCPXAYHGRZSZXEYEXTCYHYEXTDVGZCYEXTDPXTYKVEYEXODX
      TYEXPXODVEXNXHXPYAVFZABDEXOXGFGHJKVHULXNXRYAVIZVJXTDVKULLVLYEXGXTXAYGYEXT
      XGYFVQZXGXTYGVQXGXTYGUFYEWSXPYAYNWSXMYDVMYLYMABXTDEXOXGFGHJKVNVOZXTXGYFVP
      XGXTYGVRVSXNXHXPYAVTZWHZVJYEYHYFRZXAYIYEYNXHYRXASYOYPXTXGXAYFWAWBYEYHXTPY
      RYISYQYHXTGWCULWDXDYJOYHCXBYHSXCYIXAXBYHGWEWFWGWBWIWJWKWIWJWLWMWNWOWPONCI
      GWRWQ $.
  $}

  ${
    $d u v A $.  $d k s u v C $.  $d k s u v F $.  $d k s u v J $.
    $( A covering map is an open map.  (Contributed by Mario Carneiro,
       7-May-2015.) $)
    cvmopn $p |- ( ( F e. ( C CovMap J ) /\ A e. C ) -> ( F " A ) e. J ) $=
      ( vv vu vk vs cuni cv ccnv wceq c0 csn cdif wral crest co wa eqid cin cpw
      cima cres chmeo wcel crab cmpt cvmopnlem ) EFABIZBGDHJZICKGJZUCLFJZEJUAML
      EUKUMNOPCUMUDBUMQRDULQRUERUFSFUKPSHBUBMNOUGUHZGCDHUNTUJTUI $.
  $}

  ${
    $d a b f g k m r s u v w C $.  $d f g G $.  $d a b k m r s t u v w y z J $.
    $d b v w B $.  $d a f g m s t x y z K $.  $d a b k m r s t u v w x y z M $.
    $d a m s t x y z N $.  $d f g x O $.  $d a f g m s t x y z ph $.  $d x Q $.
    $d a b f g k m r s t u v w y z F $.  $d a b m s t y z S $.  $d k s u v U $.
    $d f g P $.  $d x R $.  $d s u v T $.  $d u v W $.  $d a m s t x y z Y $.
    cvmliftmo.b $e |- B = U. C $.
    cvmliftmo.y $e |- Y = U. K $.
    cvmliftmo.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmliftmo.k $e |- ( ph -> K e. Con ) $.
    cvmliftmo.l $e |- ( ph -> K e. N-Locally Con ) $.
    cvmliftmo.o $e |- ( ph -> O e. Y ) $.
    ${
      cvmliftmoi.m $e |- ( ph -> M e. ( K Cn C ) ) $.
      cvmliftmoi.n $e |- ( ph -> N e. ( K Cn C ) ) $.
      cvmliftmoi.g $e |- ( ph -> ( F o. M ) = ( F o. N ) ) $.
      cvmliftmoi.p $e |- ( ph -> ( M ` O ) = ( N ` O ) ) $.
      ${
        cvmliftmolem.1 $e |- S = ( k e. J |->
          { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
            A. u e. s ( A. v e. ( s \ { u } ) ( u i^i v ) = (/) /\
               ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t k ) ) ) ) } ) $.
        ${
          cvmliftmolem.2 $e |- ( ( ph /\ ps ) -> T e. ( S ` U ) ) $.
          cvmliftmolem.3 $e |- ( ( ph /\ ps ) -> W e. T ) $.
          cvmliftmolem.4 $e |- ( ( ph /\ ps ) -> I C_ ( `' M " W ) ) $.
          cvmliftmolem.5 $e |- ( ( ph /\ ps ) -> ( K |`t I ) e. Con ) $.
          cvmliftmolem.6 $e |- ( ( ph /\ ps ) -> X e. I ) $.
          cvmliftmolem.7 $e |- ( ( ph /\ ps ) -> Q e. I ) $.
          cvmliftmolem.8 $e |- ( ( ph /\ ps ) -> R e. I ) $.
          cvmliftmolem.9 $e |- ( ( ph /\ ps ) -> ( F ` ( M ` X ) ) e. U ) $.
          $( Lemma for ~ cvmliftmo .  (Contributed by Mario Carneiro,
             10-Mar-2015.) $)
          cvmliftmolem1 $p |- ( ( ph /\ ps ) ->
            ( Q e. dom ( M i^i N ) -> R e. dom ( M i^i N ) ) ) $=
            ( vx wa cv cfv wceq crab wcel cin cres ccom adantr fveq1d ccnv cima
            cdm sseldd wfn wb wf ccn cnf syl ffn elpreima simprbda syldan fvco3
            sylan 3eqtr3d simplbda fvres crest cuni eqid ccon cnvimass syl5sseq
            co wss fdm sstrd cnrest syl2anc ctopon crn ctop ccvm toptopon sylib
            cvmtop1 df-ima elssuni cvmsuni sseqtrd imass2 cnvco 3eqtr3g imaeq1d
            cnveqd imaco wfun sseqtr4d funimass3 mpbird syl5eqssr cvmcn cnrest2
            ffun syl3anc mpbid df-ss cvv eqeltrrd eqeq12d elrab3 3imtr4d eleq2d
            fveq2 topopn ssexd cvmsss elrestr ccld cvmscld contop restuni simpr
            eleqtrd eqeltrd concn feq2d ffvelrnd 3eqtr4d wf1 wf1o cvmsf1o f1of1
            f1fveq syl12anc ex fndmin ) ABVDZGVCVEZQVFZUVERVFZVGZVCUBVHZVIZHUVI
            VIZGQRVJVQZVIHUVLVIUVDGQVFZGRVFZVGZHQVFZHRVFZVGZUVJUVKUVDUVOUVRUVDU
            VOVDZUVPMTVKZVFZUVQUVTVFZVGZUVRUVSUVPMVFZUVQMVFZUWAUWBUVDUWDUWEVGUV
            OUVDHMQVLZVFZHMRVLZVFZUWDUWEUVDHUWFUWHAUWFUWHVGBULVMZVNABHUBVIZUWGU
            WDVGZABHQVOZTVPZVIZUWKUVDNUWNHUQVAVRZAUWOUWKUVPTVIZAQUBVSZUWOUWKUWQ
            VDVTAUBEQWAZUWRAQPFWBWTZVIUWSUJQPFUBEUEUDWCWDZUBEQWEWDZUBHTQWFWDZWG
            WHZAUWSUWKUWLUXAUBEHMQWIWJWHABUWKUWIUWEVGZUXDAUBERWAZUWKUXEARUWTVIZ
            UXFUKRPFUBEUEUDWCWDZUBEHMRWIWJWHWKVMUVSUWQUWAUWDVGUVDUWQUVOABUWOUWQ
            UWPAUWOUWKUWQUXCWLWHVMZUVPTMWMWDUVSUVQTVIZUWBUWEVGUVSHRNVKZVFZUVQTU
            VSHNVIZUXLUVQVGUVDUXMUVOVAVMZHNRWMWDUVSNTHUXKUVSNTUXKWAPNWNWTZWOZTU
            XKWAUVSGTUXKUXOFMVOZKVPZWNWTZUXPUXPWPUVDUXOWQVIUVOURVMUVDUXKUXOUXSW
            BWTVIZUVOUVDUXKUXOFWBWTVIZUXTUVDUXGNUBXAZUYAAUXGBUKVMUVDNUWNUBUQAUW
            NUBXABAQVQZUWNUBQTWRAUWSUYCUBVGUXAUBEQXBWDWSVMXCZNRPFUBUEXDXEUVDFEX
            FVFVIZUXKXGZUXRXAUXREXAUYAUXTVTUVDFXHVIZUYEUVDMFOXIWTVIZUYGAUYHBUFV
            MZFMOXLWDZFEUDXJXKUVDUYFRNVPZUXRRNXMUVDUYKUXRXAZNRVOZUXRVPZXAZUVDNU
            WMUXRVPZUYNUVDNUWNUYPUQUVDTUXRXAZUWNUYPXAUVDTJWOZUXRUVDTJVIZTUYRXAU
            PTJXNWDUVDJKIVFVIZUYRUXRVGUOCDFIJKLMOUCUNXOWDXPZTUXRUWMXQWDXCUVDUWM
            UXQVLZKVPUYMUXQVLZKVPUYPUYNUVDVUBVUCKUVDUWFVOUWHVOVUBVUCUVDUWFUWHUW
            JYAMQXRMRXRXSXTUWMUXQKYBUYMUXQKYBXSXPUVDRYCZNRVQZXAUYLUYOVTUVDUXFVU
            DAUXFBUXHVMZUBERYJWDUVDNUBVUEUYDUVDUXFVUEUBVGVUFUBERXBWDYDNUXRRYEXE
            YFYGUVDMVQZUXREMKWRAVUGEVGZBAEOWOZMWAZVUHAMFOWBWTVIZVUJAUYHVUKUFFMO
            YHWDMFOEVUIUDVUIWPWCWDEVUIMXBWDVMWSZUXRUXKUXOFEYIYKYLVMUVDTUXSVIUVO
            UVDTUXRVJZTUXSUVDUYQVUMTVGVUATUXRYMXKUVDUYGUXRYNVITFVIVUMUXSVIUYJUV
            DUXREFUVDUYGEFVIUYJFEUDUUAWDVULUUBUVDJFTUVDUYTJFXAUOCDFIJKLMOUCUNUU
            CWDUPVRTUXRFXHYNUUDYKYOVMUVDTUXSUUEVFVIZUVOUVDUYHUYTUYSVUNUYIUOUPCD
            TFIJKLMOUCUNUUFYKVMUVDGUXPVIUVOUVDGNUXPUTUVDPXHVIZUYBNUXPVGZAVUOBAP
            WQVIVUOUGPUUGWDVMUYDNPUBUEUUHXEZUUJVMUVSGUXKVFZUVNTUVSGNVIZVURUVNVG
            UVDVUSUVOUTVMGNRWMWDUVSUVMUVNTUVDUVOUUIUVDUVMTVIZUVOABGUWNVIZVUTUVD
            NUWNGUQUTVRZAVVAGUBVIZVUTAUWRVVAVVCVUTVDVTUXBUBGTQWFWDZWLWHVMYOUUKU
            ULUVSNUXPTUXKUVDVUPUVOVUQVMUUMYFUXNUUNYOZUVQTMWMWDUUOUVSTKUVTUUPZUW
            QUXJUWCUVRVTUVDVVFUVOUVDTKUVTUUQZVVFUVDUYHUYTUYSVVGUYIUOUPCDTFIJKLM
            OUCUNUURYKTKUVTUUSWDVMUXIVVETKUVPUVQUVTUUTUVAYLUVBUVDVVCUVJUVOVTABV
            VAVVCVVBAVVAVVCVUTVVDWGWHUVHUVOVCGUBUVEGVGUVFUVMUVGUVNUVEGQYTUVEGRY
            TYPYQWDUVDUWKUVKUVRVTUXDUVHUVRVCHUBUVEHVGUVFUVPUVGUVQUVEHQYTUVEHRYT
            YPYQWDYRUVDUVLUVIGAUVLUVIVGZBAUWRRUBVSZVVHUXBAUXFVVIUXHUBERWEWDVCUB
            QRUVCXEVMZYSUVDUVLUVIHVVJYSYR $.
        $}

        $( Lemma for ~ cvmliftmo .  (Contributed by Mario Carneiro,
           10-Mar-2015.) $)
        cvmliftmolem2 $p |- ( ph -> M = N ) $=
          ( vx vy vz va vt vb ccn co wcel wf wfn cnf ffn 3syl cv wceq crab wral
          cfv cin cdm ccld inss1 wb wa wrex c0 ccvm cuni adantr ffvelrnda cvmcn
          wne syl eqid syldan cvmcov syl2anc wi wex n0 wss crest ccon ccnv crio
          w3a cima cpw cnlly simprrr simprll ffvelrnd simprrl cvmsiota syl13anc
          cvmsss simpld sseldd simprd elpreima mpbir2and nlly2i syl3anc simprr1
          cnima simplrr adantl adantrr simplll ad2antll elpwid simplr3 adantrrr
          simplr2 cvmliftmolem1 impbid anassrs ralrimiva jca reximdva rexlimdva
          expr exlimdv syl5bi expimpd ctop contop fndmin ssrab2 syl6eqss sseldi
          mpd fveq2 isclo mpbird eqeq12d sylanbrc eleqtrrd conclo eqtr3d rabid2
          elrab ne0i inss2 sylib r19.21bi eqfnfvd ) AUGNKLAKJEUMUNZUOZNDKUPZKNU
          QZUBKJENDQPURZNDKUSZUTZALUUOUONDLUPLNUQZUCLJENDQPURNDLUSUTZAUGVAZKVEZ
          UVDLVEZVBZUGNANUVGUGNVCZVBUVGUGNVDAKLVFVGZNUVHAUVIJNQSAJJVHVEZVFZJUVI
          JUVJVIAUVIUVKUOZUVDUHVAZUOZUVDUVIUOZUIVAZUVIUOZVJZUIUVMVDZVKZUHJVLZUG
          NVDZAUWAUGNAUVDNUOZVKZUVEHVEZUJVAZUOZUWFFVEZVMVSZVKZUJIVLZUWAUWDHEIVN
          UNUOZUWEIVOZUOZUWKAUWLUWCRVPAUWCUVEDUOZUWNANDUVDKAUUPUUQUBUUSVTZVQADU
          WMUVEHAUWLHEIUMUNUODUWMHUPREHIVRHEIDUWMPUWMWAZURUTVQWBUJBCEUWEFGHIUWM
          OUFUWQWCWDUWDUWJUWAUJIAUWCUWFIUOZUWJUWAWEAUWCUWRVKZVKZUWGUWIUWAUWIUKV
          AZUWHUOZUKWFUWTUWGVKZUWAUKUWHWGUXCUXBUWAUKUWTUWGUXBUWAAUWSUWGUXBVKZUW
          AAUWSUXDVKZVKZUVNUVMOVAZWHZJUXGWIUNWJUOZWMZUHJVLZOKWKUVEULVAUOULUXAWL
          ZWNZWOZVLZUWAUXFJWJWPUOZUXMJUOZUVDUXMUOZUXOAUXPUXETVPUXFUUPUXLEUOUXQA
          UUPUXEUBVPUXFUXAEUXLUXFUXBUXAEWHAUWSUWGUXBWQZBCEFUXAUWFGHIOUFXCVTUXFU
          XLUXAUOZUVEUXLUOZUXFUWLUXBUWOUWGUXTUYAVKAUWLUXERVPUXSUXFNDUVDKAUUQUXE
          UWPVPZAUWCUWRUXDWRZWSAUWSUWGUXBWTZULBCUVEDEFUXAUWFGHIUXLOUFPUXLWAXAXB
          ZXDZXEUXLKJEXLWDUXFUXRUWCUYAUYCUXFUXTUYAUYEXFUXFUUQUURUXRUWCUYAVKVJUY
          BUUTNUVDUXLKXGUTXHUHWJUVDUXMJOXIXJUXFUXKUWAOUXNUXFUXGUXNUOZVKUXJUVTUH
          JUXFUYGUVMJUOZUXJUVTWEUXFUYGUYHVKZUXJUVTUXFUYIUXJVKZVKZUVNUVSUVNUXHUX
          IUYIUXFXKUYKUVRUIUVMUXFUYJUVPUVMUOZUVRAUXEUYJUYLVKZUVRAUXEUYMVKZVKZUV
          OUVQAUYNBCDEUVDUVPFUXAUWFGHUXGIJKLMUXLUVDNOPQRSTUAUBUCUDUEUFUYNUXBAUW
          SUWGUXBUYMXMXNZAUXEUXTUYMUYFXOZUYOUXGUXMUYMUYGAUXEUYGUYHUXJUYLXPXQXRZ
          UYMUXIAUXEUVNUXHUXIUYIUYLXSXQZUYOUVMUXGUVDUYMUXHAUXEUVNUXHUXIUYIUYLYA
          XQZAUXEUYJUVNUYLUXEUYJVKUVNAUVNUXHUXIUYIUXEXKXNXTXEZVUAUYOUVMUXGUVPUY
          TAUXEUYJUYLWQXEZAUXEUWGUYMUYDXOZYBAUYNBCDEUVPUVDFUXAUWFGHUXGIJKLMUXLU
          VDNOPQRSTUAUBUCUDUEUFUYPUYQUYRUYSVUAVUBVUAVUCYBYCYDYDYEYFYIYDYGYHYSYD
          YIYJYKYLYDYHYSYEAJYMUOZUVINWHUVLUWBVJAJWJUOVUDSJYNVTAUVIUVHNAUURUVBUV
          IUVHVBUVAUVCUGNKLYOWDZUVGUGNYPYQUGUHUIUVIJNQUUAWDUUBZYRAMUVIUOUVIVMVS
          AMUVHUVIAMNUOMKVEZMLVEZVBZMUVHUOUAUEUVGVUIUGMNUVDMVBUVEVUGUVFVUHUVDMK
          YTUVDMLYTUUCUUIUUDVUEUUEUVIMUUJVTAUVKUVJUVIJUVJUUKVUFYRUUFVUEUUGUVGUG
          NUUHUULUUMUUN $.
      $}

      $( A lift of a continuous function from a connected and locally connected
         space over a covering map is unique when it exists.  (Contributed by
         Mario Carneiro, 10-Mar-2015.) $)
      cvmliftmoi $p |- ( ph -> M = N ) $=
        ( vw vr vk vs vu vv vb vm cv cuni ccnv cima wceq cin csn cdif wral cres
        c0 crest co chmeo wcel wa cpw crab cmpt eqid cvmscbv cvmliftmolem2 ) AU
        AUBBCUCEUDUIZUJDUKUCUIZULUMUEUIZUFUIUNUSUMUFVKVMUOUPUQDVMURCVMUTVAEVLUT
        VAVBVAVCVDUEVKUQVDUDCVEUSUOUPVFVGZUGDEFGHIJUHKLMNOPQRSTUFUECVNUCDEUDUGU
        HUBUAVNVHVIVJ $.
    $}

    cvmliftmo.g $e |- ( ph -> G e. ( K Cn J ) ) $.
    cvmliftmo.p $e |- ( ph -> P e. B ) $.
    cvmliftmo.e $e |- ( ph -> ( F ` P ) = ( G ` O ) ) $.
    $( A lift of a continuous function from a connected and locally connected
       space over a covering map is unique when it exists.  (Contributed by
       Mario Carneiro, 10-Mar-2015.)  (Revised by NM, 17-Jun-2017.) $)
    cvmliftmo $p |- ( ph ->
        E* f e. ( K Cn C ) ( ( F o. f ) = G /\ ( f ` O ) = P ) ) $=
      ( vg cv ccom wceq cfv wa weq wi ccn co wral wrmo wcel ccvm ad2antrr cnlly
      ccon simplrl simplrr simprll simprrl eqtr4d simprlr simprrr cvmliftmoi ex
      ralrimivva coeq2 eqeq1d fveq1 anbi12d rmo4 sylibr ) AFEUBZUCZGUDZJVNUEZDU
      DZUFZFUAUBZUCZGUDZJVTUEZDUDZUFZUFZEUAUGZUHZUAICUIUJZUKEWIUKVSEWIULAWHEUAW
      IWIAVNWIUMZVTWIUMZUFZUFZWFWGWMWFUFZBCFHIVNVTJKLMAFCHUNUJUMWLWFNUOAIUQUMWL
      WFOUOAIUQUPUMWLWFPUOAJKUMWLWFQUOAWJWKWFURAWJWKWFUSWNVOGWAWMVPVRWEUTWMVSWB
      WDVAVBWNVQDWCWMVPVRWEVCWMVSWBWDVDVBVEVFVGVSWEEUAWIWGVPWBVRWDWGVOWAGVNVTFV
      HVIWGVQWCDJVNVTVJVIVKVLVM $.
  $}

  ${
    $d b v y z B $.  $d a b c d f g j k m n s t u v w x y z F $.  $d n y z L $.
    $d f y K $.  $d a b c d j k m s u v x y z M $.  $d b f g k m n u v x z P $.
    $d a b c d f g j k n s u v y z C $.  $d a f g j n s x y z ph $.  $d z ps $.
    $d b c d k m n u v x y z N $.  $d a b f g j k n s u v x z S $.  $d a j X $.
    $d a b f g j k m n s t u v w x y z G $.  $d a b c d j k m s u v x y z T $.
    $d a b c d f g j k n s u v x z J $.  $d b c d k m n u v x y z Q $.
    $d k m x z W $.
    cvmliftlem.1 $e |- S = ( k e. J |->
      { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
        A. u e. s ( A. v e. ( s \ { u } ) ( u i^i v ) = (/) /\
           ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t k ) ) ) ) } ) $.
    cvmliftlem.b $e |- B = U. C $.
    cvmliftlem.x $e |- X = U. J $.
    cvmliftlem.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmliftlem.g $e |- ( ph -> G e. ( II Cn J ) ) $.
    cvmliftlem.p $e |- ( ph -> P e. B ) $.
    cvmliftlem.e $e |- ( ph -> ( F ` P ) = ( G ` 0 ) ) $.
    ${
      cvmliftlem.n $e |- ( ph -> N e. NN ) $.
      cvmliftlem.t $e |- ( ph ->
        T : ( 1 ... N ) --> U_ j e. J ( { j } X. ( S ` j ) ) ) $.
      cvmliftlem.a $e |- ( ph -> A. k e. ( 1 ... N )
        ( G " ( ( ( k - 1 ) / N ) [,] ( k / N ) ) ) C_ ( 1st ` ( T ` k ) ) ) $.
      cvmliftlem.l $e |- L = ( topGen ` ran (,) ) $.
      ${
        cvmliftlem1.m $e |- ( ( ph /\ ps ) -> M e. ( 1 ... N ) ) $.
        $( Lemma for ~ cvmlift .  In ~ cvmliftlem15 , we picked an ` N ` large
           enough so that the sections ` ( G " [ ( k - 1 ) / N , k / N ] ) `
           are all contained in an even covering, and the function ` T `
           enumerates these even coverings.  So ` 1st `` ( T `` M ) ` is a
           neighborhood of ` ( G " [ ( M - 1 ) / N , M / N ] ) ` , and
           ` 2nd `` ( T `` M ) ` is an even covering of ` 1st `` ( T `` M ) ` ,
           which is to say a disjoint union of open sets in ` C ` whose image
           is ` 1st `` ( T `` M ) ` .  (Contributed by Mario Carneiro,
           14-Feb-2015.) $)
        cvmliftlem1 $p |- ( ( ph /\ ps ) ->
          ( 2nd ` ( T ` M ) ) e. ( S ` ( 1st ` ( T ` M ) ) ) ) $=
          ( wa cfv c1st c2nd cop csn cxp ciun wcel wrel wceq relxp rgenw reliun
          cv wral mpbir c1 cfz co adantr ffvelrnd 1st2nd sylancr eqeltrrd fveq2
          wf opeliunxp2 simprbi syl ) ABULZPIUMZUNUMZWCUOUMZUPZJNJVFZUQZWGHUMZU
          RZUSZUTZWEWDHUMZUTZWBWCWFWKWBWKVAZWCWKUTWCWFVBWOWJVAZJNVGWPJNWHWIVCVD
          JNWJVEVHWBVIQVJVKZWKPIAWQWKIVRBUHVLUKVMZWCWKVNVOWRVPWLWDNUTWNJNWIWDWE
          WMWGWDHVQVSVTWA $.

        cvmliftlem3.3 $e |- W = ( ( ( M - 1 ) / N ) [,] ( M / N ) ) $.
        $( Lemma for ~ cvmlift . ` W = [ ( k - 1 ) / N , k / N ] ` is a subset
           of ` [ 0 , 1 ] ` for each ` M e. ( 1 ... N ) ` .  (Contributed by
           Mario Carneiro, 16-Feb-2015.) $)
        cvmliftlem2 $p |- ( ( ph /\ ps ) -> W C_ ( 0 [,] 1 ) ) $=
          ( wa c1 cmin co cdiv cicc cc0 cr wcel cle wbr wss 0re a1i 1re clt cfz
          elfznn syl nnred peano2rem cn0 nnm1nn0 nn0ge0d adantr nngt0d syl22anc
          cn divge0 elfzle2 nncnd mulid1d breqtrrd wb ledivmul syl112anc mpbird
          cmul iccss syl5eqss ) ABUNZRPUOUPUQZQURUQZPQURUQZUSUQZUTUOUSUQZUMWNUT
          VAVBZUOVAVBZUTWPVCVDZWQUOVCVDZWRWSVEWTWNVFVGXAWNVHVGZWNWOVAVBZUTWOVCV
          DQVAVBZUTQVIVDZXBWNPVAVBZXEWNPWNPUOQVJUQVBZPWAVBZULPQVKVLZVMZPVNVLWNW
          OWNXJWOVOVBXKPVPVLVQWNQAQWAVBBUHVRZVMZWNQXMVSZWOQWBVTWNXCPQUOWKUQZVCV
          DZWNPQXPVCWNXIPQVCVDULPUOQWCVLWNQWNQXMWDWEWFWNXHXAXFXGXCXQWGXLXDXNXOP
          UOQWHWIWJUTUOWPWQWLVTWM $.

        cvmliftlem3.m $e |- ( ( ph /\ ps ) -> A e. W ) $.
        $( Lemma for ~ cvmlift .  Since ` 1st `` ( T `` M ) ` is a neighborhood
           of ` ( G " W ) ` , every element ` A e. W ` satisfies
           ` ( G `` A ) e. ( 1st `` ( T `` M ) ) ` .  (Contributed by Mario
           Carneiro, 16-Feb-2015.) $)
        cvmliftlem3 $p |- ( ( ph /\ ps ) ->
          ( G ` A ) e. ( 1st ` ( T ` M ) ) ) $=
          ( wa cima cfv c1st c1 cfz co wcel cmin cdiv cicc wss wral adantr wceq
          cv oveq1 oveq1d oveq12d syl6eqr imaeq2d fveq2 sseq12d rspcv sylc wfun
          fveq2d cdm wi cc0 cii ccn iiuni cnf syl ffun cvmliftlem2 fdm sseqtr4d
          wf funfvima2 syl2anc mpd sseldd ) ABUPZNSUQZQJURZUSURZENURZWTQUTRVAVB
          ZVCNLVKZUTVDVBZRVEVBZXFRVEVBZVFVBZUQZXFJURZUSURZVGZLXEVHZXAXCVGZUMAXO
          BUKVIXNXPLQXEXFQVJZXKXAXMXCXQXJSNXQXJQUTVDVBZRVEVBZQRVEVBZVFVBSXQXHXS
          XIXTVFXQXGXRRVEXFQUTVDVLVMXFQRVEVLVNUNVOVPXQXLXBUSXFQJVQWBVRVSVTWTESV
          CZXDXAVCZUOWTNWAZSNWCZVGYAYBWDWTWEUTVFVBZTNWOZYCAYFBANWFOWGVBVCYFUFNW
          FOYETWHUDWIWJVIZYETNWKWJWTSYEYDABCDFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
          JUKULUMUNWLWTYFYDYEVJYGYETNWMWJWNSENWPWQWRWS $.
      $}

      cvmliftlem.q $e |- Q = seq 0 ( ( x e. _V , m e. NN |->
        ( z e. ( ( ( m - 1 ) / N ) [,] ( m / N ) ) |->
          ( `' ( F |` ( iota_ b e. ( 2nd ` ( T ` m ) )
            ( x ` ( ( m - 1 ) / N ) ) e. b ) ) ` ( G ` z ) ) ) ) ,
          ( ( _I |` NN ) u. { <. 0 , { <. 0 , P >. } >. } ) ) $.
      $( Lemma for ~ cvmlift .  The function ` Q ` will be our lifted path,
         defined piecewise on each section ` [ ( M - 1 ) / N , M / N ] ` for
         ` M e. ( 1 ... N ) ` .  For ` M = 0 ` , it is a "seed" value which
         makes the rest of the recursion work, a singleton function mapping
         ` 0 ` to ` P ` .  (Contributed by Mario Carneiro, 15-Feb-2015.) $)
      cvmliftlem4 $p |- ( Q ` 0 ) = { <. 0 , P >. } $=
        ( cc0 cfv cop csn cid cn cres cun cvv cv c1 cmin co cdiv cicc wcel c2nd
        crio ccnv cmpt cmpt2 cseq fveq1i cz wceq 0z seq1 ax-mp eqtri wfn cin c0
        wa fnresi c0ex snex fnsn 0nnn disjsn mpbir snid pm3.2i fvun2 mp3an fvsn
        wn ) UOIUPZUOUOUOHUQZURZUQURZUPZXCXAUOUSUTVAZXDVBZUPZXEXAUOBNVCUTCNVDZV
        EVFVGSVHVGZXISVHVGVIVGCVDPUPOXJBVDUPUBVDVJUBXIKUPVKUPVLVAVMUPVNVOZXGUOV
        PZUPZXHUOIXLUNVQUOVRVJXMXHVSVTXKXGUOWAWBWCXFUTWDXDUOURZWDUTXNWEWFVSZUOX
        NVJZWGXHXEVSUTWHUOXCWIXBWJZWKXOXPXOUOUTVJWTWLUTUOWMWNUOWIWOWPUTXNXFXDUO
        WQWRWCUOXCWIXQWSWC $.

      ${
        cvmliftlem5.3 $e |- W = ( ( ( M - 1 ) / N ) [,] ( M / N ) ) $.
        $( Lemma for ~ cvmlift .  Definition of ` Q ` at a successor.  This is
           a function defined on ` W ` as ` ``' ( T |`` I ) o. G ` where ` I `
           is the unique covering set of ` 2nd `` ( T `` M ) ` that contains
           ` Q ( M - 1 ) ` evaluated at the last defined point, namely
           ` ( M - 1 ) / N ` (note that for ` M = 1 ` this is using the seed
           value ` Q ( 0 ) ( 0 ) = P ` ).  (Contributed by Mario Carneiro,
           15-Feb-2015.) $)
        cvmliftlem5 $p |- ( ( ph /\ M e. NN ) -> ( Q ` M ) = ( z e. W |->
            ( `' ( F |` ( iota_ b e. ( 2nd ` ( T ` M ) )
        ( ( Q ` ( M - 1 ) ) ` ( ( M - 1 ) / N ) ) e. b ) ) ` ( G ` z ) ) ) ) $=
          ( cn wcel wa cfv c1 cmin co cid cres cc0 cop csn cun cvv cv cdiv cicc
          c2nd crio ccnv cmpt cmpt2 cseq cz caddc cuz wceq 0z simpr nnuz fveq2i
          1e0p1 eqtri syl6eleq seqm1 sylancr fveq1i oveq1i 3eqtr4g c0 wn disjsn
          cin 0nnn mpbir wfn fnresi c0ex snex fvun1 mp3an12 fvresi adantl eqtrd
          fnsn oveq2d fvex a1i oveq1d oveq12d syl6eqr simpl fveq12d riotaeqbidv
          fveq2d eleq1d reseq2d cnveqd fveq1d mpteq12dv eqid ovex eqeltri mptex
          ovmpt2a sylan 3eqtrd ) ASURUSZUTZSIVAZSVBVCVDZIVAZSVEURVFZVGVGHVHZVIZ
          VHVIZVJZVAZBNVKURCNVLZVBVCVDZTVMVDZUUFTVMVDZVNVDZCVLPVAZOUUHBVLZVAZUD
          VLZUSZUDUUFKVAZVOVAZVPZVFZVQZVAZVRZVSZVDZYSSUVCVDZCUAUUKOYRTVMVDZYSVA
          ZUUNUSZUDSKVAZVOVAZVPZVFZVQZVAZVRZYPSUVCUUDVGVTZVAZYRUVPVAZUUEUVCVDZY
          QUVDYPVGWAUSSVGVBWBVDZWCVAZUSUVQUVSWDWEYPSURUWAAYOWFZURVBWCVAUWAWGVBU
          VTWCWIWHWJWKUVCUUDVGSWLWMSIUVPUPWNYSUVRUUEUVCYRIUVPUPWNWOWPYPUUESYSUV
          CYPUUESYTVAZSYPURVGVIZWTWQWDZYOUUEUWCWDZUWEVGURUSWRXAURVGWSXBUWBYTURX
          CUUCUWDXCUWEYOUTUWFURXDVGUUBXEUUAXFXLURUWDYTUUCSXGXHWMYOUWCSWDAURSXIX
          JXKXMAYSVKUSZYOUVEUVOWDUWGAYRIXNXOBNYSSVKURUVBUVOUVCUULYSWDZUUFSWDZUT
          ZCUUJUVAUAUVNUWJUUJUVFSTVMVDZVNVDZUAUWJUUHUVFUUIUWKVNUWJUUGYRTVMUWJUU
          FSVBVCUWHUWIWFZXPXPZUWJUUFSTVMUWMXPXQUQXRUWJUUKUUTUVMUWJUUSUVLUWJUURU
          VKOUWJUUOUVHUDUUQUVJUWJUUPUVIVOUWJUUFSKUWMYBYBUWJUUMUVGUUNUWJUUHUVFUU
          LYSUWHUWIXSUWNXTYCYAYDYEYFYGUVCYHCUAUVNUAUWLVKUQUVFUWKVNYIYJYKYLYMYN
          $.

        ${
          cvmliftlem6.1 $e |- ( ( ph /\ ps ) -> M e. ( 1 ... N ) ) $.
          cvmliftlem6.2 $e |- ( ( ph /\ ps ) ->
            ( ( Q ` ( M - 1 ) ) ` ( ( M - 1 ) / N ) ) e.
              ( `' F " { ( G ` ( ( M - 1 ) / N ) ) } ) ) $.
          $( Lemma for ~ cvmlift .  Induction step for ~ cvmliftlem7 .
             Assuming that ` Q ( M - 1 ) ` is defined at ` ( M - 1 ) / N ` and
             is a preimage of ` G ( ( M - 1 ) / N ) ` , the next segment
             ` Q ( M ) ` is also defined and is a function on ` W ` which is a
             lift ` G ` for this segment.  This follows explicitly from the
             definition ` Q ( M ) = ``' ( F |`` I ) o. G ` since ` G ` is in
             ` 1st `` ( F `` M ) ` for the entire interval so that
             ` ``' ( F |`` I ) ` maps this into ` I ` and ` F o. Q ` maps back
             to ` G ` .  (Contributed by Mario Carneiro, 16-Feb-2015.) $)
          cvmliftlem6 $p |- ( ( ph /\ ps ) ->
            ( ( Q ` M ) : W --> B /\ ( F o. ( Q ` M ) ) = ( G |` W ) ) ) $=
            ( vy wa cfv wf ccom cres wceq cv cmin cdiv wcel c2nd crio ccnv cmpt
            c1 cuni wss c1st cfz adantrr cvmliftlem1 cvmsss syl ccvm adantr csn
            co cima wfn wb ccn cvmcn cnf 3syl fniniseg mpbid simpld simprd cicc
            ffn cxr cle wbr cr cn elfznn nnred peano2rem nndivred rexrd clt cc0
            ltm1d nngt0d ltdiv1 syl112anc syl3anc syl6eleqr cvmliftlem3 eqeltrd
            lbicc2 eqid cvmsiota syl13anc sseldd elssuni syl6sseqr wf1o cvmsf1o
            ltled f1ocnv f1of simprr ffvelrnd anassrs fvres syl2anc feqmptd cii
            fmptd cvmliftlem5 syldan mpbird f1ocnvfv2 3eqtr2rd mpteq2dva fmptco
            feq1d fveq2 iiuni cvmliftlem2 fssres 3eqtr4d jca ) ABVBZUBGTJVCZVDZ
            PUUQVEZQUBVFZVGUUPUURUBGDUBDVHZQVCZPTVPVIWHZUAVJWHZUVCJVCVCZUEVHVKU
            ETLVCZVLVCZVMZVFZVNZVCZVOZVDUUPDUBUVKGUVLABUVAUBVKZUVKGVKABUVMVBZVB
            ZUVHGUVKUVOUVHHVQZGUVOUVHHVKUVHUVPVRUVOUVGHUVHUVOUVGUVFVSVCZKVCVKZU
            VGHVRAUVNEFGHIKLMNPQRSTUAUCUDUFUGUHUIUJUKULUMUNUOUPABTVPUAVTWHVKZUV
            MUSWAZWBZEFHKUVGUVQNPRUDUFWCWDUVOUVHUVGVKZUVEUVHVKZUVOPHRWEWHVKZUVR
            UVEGVKZUVEPVCZUVQVKUWBUWCVBAUWDUVNUIWFZUWAUVOUWEUWFUVDQVCZVGZUVOUVE
            PVNUWHWGWIVKZUWEUWIVBZABUWJUVMUTWAUVOGUCPVDZPGWJUWJUWKWKUVOUWDPHRWL
            WHVKZUWLUWGHPRWMZPHRGUCUGUHWNZWOGUCPXAGUWHUVEPWPWOWQZWRUVOUWFUWHUVQ
            UVOUWEUWIUWPWSAUVNEFUVDGHIKLMNPQRSTUAUBUCUDUFUGUHUIUJUKULUMUNUOUPUV
            TURUVOUVDUVDTUAVJWHZWTWHZUBUVOUVDXBVKUWQXBVKUVDUWQXCXDUVDUWRVKUVOUV
            DUVOUVCUAUVOTXEVKZUVCXEVKZUVOTUVOUVSTXFVKZUVTTUAXGZWDXHZTXIWDZAUAXF
            VKUVNUMWFZXJZXKUVOUWQUVOTUAUXCUXEXJZXKUVOUVDUWQUXFUXGUVOUVCTXLXDZUV
            DUWQXLXDZUVOTUXCXNUVOUWTUWSUAXEVKXMUAXLXDUXHUXIWKUXDUXCUVOUAUXEXHUV
            OUAUXEXOUVCTUAXPXQWQYKUVDUWQYBXRURXSXTYAUEEFUVEGHKUVGUVQNPRUVHUDUFU
            GUVHYCYDYEWRZYFUVHHYGWDUGYHUVOUVQUVHUVBUVJUVOUVHUVQUVIYIZUVQUVHUVJY
            IUVQUVHUVJVDUVOUWDUVRUWBUXKUWGUWAUXJEFUVHHKUVGUVQNPRUDUFYJXRZUVHUVQ
            UVIYLUVQUVHUVJYMWOAUVNEFUVAGHIKLMNPQRSTUAUBUCUDUFUGUHUIUJUKULUMUNUO
            UPUVTURABUVMYNZXTZYOZYFYPZUVLYCUUAUUPUBGUUQUVLABUXAUUQUVLVGUUPUVSUX
            AUSUXBWDACDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUUBU
            UCZUUIUUDUUPDUBUVKPVCZVODUBUVAUUTVCZVOUUSUUTUUPDUBUXRUXSABUVMUXRUXS
            VGUVOUXSUVBUVKUVIVCZUXRUVOUVMUXSUVBVGUXMUVAUBQYQWDUVOUXKUVBUVQVKUXT
            UVBVGUXLUXNUVHUVQUVBUVIUUEYRUVOUVKUVHVKUXTUXRVGUXOUVKUVHPYQWDUUFYPU
            UGUUPDVAUBGUVKVAVHZPVCUXRUUQPUXPUXQUUPVAGUCPAUWLBAUWDUWMUWLUIUWNUWO
            WOWFYSUYAUVKPUUJUUHUUPDUBUCUUTUUPXMVPWTWHZUCQVDZUBUYBVRUBUCUUTVDAUY
            CBAQYTRWLWHVKUYCUJQYTRUYBUCUUKUHWNWDWFABEFGHIKLMNPQRSTUAUBUCUDUFUGU
            HUIUJUKULUMUNUOUPUSURUULUYBUCUBQUUMYRYSUUNUUO $.
        $}

        $( Lemma for ~ cvmlift .  Prove by induction that every ` Q ` function
           is well-defined (we can immediately follow this theorem with
           ~ cvmliftlem6 to show functionality and lifting of ` Q ` ).
           (Contributed by Mario Carneiro, 14-Feb-2015.) $)
        cvmliftlem7 $p |- ( ( ph /\ M e. ( 1 ... N ) ) ->
          ( ( Q ` ( M - 1 ) ) ` ( ( M - 1 ) / N ) ) e.
            ( `' F " { ( G ` ( ( M - 1 ) / N ) ) } ) ) $=
          ( vy vn c1 cfz co wcel cmin cc0 cdiv cfv ccnv cima wa caddc fzssp1 cc
          csn wceq nncnd adantr ax-1cn npcan sylancl oveq2d syl5sseq cz elfzelz
          simpr wb nnzd elfzm1b syl2anr mpbid sseldd elfznn0 adantl cv wi eleq1
          fveq2 oveq1 fveq12d fveq2d imaeq2d eleq12d imbi12d imbi2d cvmliftlem4
          cn0 sneqd cop a1i nnne0d div0d 0nn0 fvsng sylancr eqtrd eqtr4d wfn wf
          ccn ccvm syl fniniseg mpbir2and cuz syl6eleq cicc cres cle cn syl2anc
          cvmcn wbr oveq1d cxr nndivred rexrd cr clt expr a2d cnf eqeltrd nn0uz
          ffn 3syl a1d id peano2fzr ex imim1d ccom eqid simprlr elfzle2 simprll
          nn0p1nn elfz5 mpbird simprr nn0cnd pncan 3eltr4d cvmliftlem6 peano2re
          nnuz simpld nn0red ltp1d nnred nngt0d ltdiv1 syl112anc ubicc2 syl3anc
          ltled eleqtrrd ffvelrnd simprd reseq2d feq2d fvco3 fvres 3eqtr3d syld
          fveq1d expcom nn0ind imp3a mpcom syldan ) ASUTTVAVBZVCZSUTVDVBZVETVAV
          BZVCZUWMTVFVBZUWMIVGZVGZOVHZUWPPVGZVNZVIZVCZAUWLVJZVETUTVDVBZVAVBZUWN
          UWMUXDVEUXEUTVKVBZVAVBUXFUWNVEUXEVLUXDUXGTVEVAUXDTVMVCZUTVMVCZUXGTVOA
          UXHUWLATULVPZVQVRTUTVSVTWAWBUXDUWLUWMUXFVCZAUWLWEUWLSWCVCTWCVCZUWLUXK
          WFASUTTWDATULWGZSTWHWIWJWKUWMXFVCZAUWOVJUXCUWOUXNAUWMTWLWMUXNAUWOUXCA
          URWNZUWNVCZUXOTVFVBZUXOIVGZVGZUWSUXQPVGZVNZVIZVCZWOZWOAVEUWNVCZVETVFV
          BZVEIVGZVGZUWSUYFPVGZVNZVIZVCZWOZWOAUSWNZUWNVCZUYNTVFVBZUYNIVGZVGZUWS
          UYPPVGZVNZVIZVCZWOZWOAUYNUTVKVBZUWNVCZVUDTVFVBZVUDIVGZVGZUWSVUFPVGZVN
          ZVIZVCZWOZWOAUWOUXCWOZWOURUSUWMUXOVEVOZUYDUYMAVUOUXPUYEUYCUYLUXOVEUWN
          WPVUOUXSUYHUYBUYKVUOUXQUYFUXRUYGUXOVEIWQUXOVETVFWRZWSVUOUYAUYJUWSVUOU
          XTUYIVUOUXQUYFPVUPWTXGXAXBXCXDUXOUYNVOZUYDVUCAVUQUXPUYOUYCVUBUXOUYNUW
          NWPVUQUXSUYRUYBVUAVUQUXQUYPUXRUYQUXOUYNIWQUXOUYNTVFWRZWSVUQUYAUYTUWSV
          UQUXTUYSVUQUXQUYPPVURWTXGXAXBXCXDUXOVUDVOZUYDVUMAVUSUXPVUEUYCVULUXOVU
          DUWNWPVUSUXSVUHUYBVUKVUSUXQVUFUXRVUGUXOVUDIWQUXOVUDTVFWRZWSVUSUYAVUJU
          WSVUSUXTVUIVUSUXQVUFPVUTWTXGXAXBXCXDUXOUWMVOZUYDVUNAVVAUXPUWOUYCUXCUX
          OUWMUWNWPVVAUXSUWRUYBUXBVVAUXQUWPUXRUWQUXOUWMIWQUXOUWMTVFWRZWSVVAUYAU
          XAUWSVVAUXTUWTVVAUXQUWPPVVBWTXGXAXBXCXDAUYLUYEAUYHHUYKAUYHVEVEHXHVNZV
          GZHAUYFVEUYGVVCUYGVVCVOAABCDEFGHIJKLMNOPQRTUBUCUDUEUFUGUHUIUJUKULUMUN
          UOUPXEXIATUXJATULXJXKZWSAVEXFVCHFVCZVVDHVOXLUJVEHXFFXMXNXOAHUYKVCZVVF
          HOVGZUYIVOZUJAVVHVEPVGUYIUKAUYFVEPVVEWTXPAOFXQZVVGVVFVVIVJWFAOGQXSVBV
          CZFUBOXRVVJAOGQXTVBVCVVKUHGOQYKYAOGQFUBUFUGUUAFUBOUUDUUEZFUYIHOYBYAYC
          UUBUUFUYNXFVCZAVUCVUMAVVMVUCVUMWOAVVMVJZVUCVUEVUBWOVUMVVNVUEUYOVUBVVN
          UYNVEYDVGZVCZVUEUYOWOVVMVVPAVVMUYNXFVVOVVMUUGUUCYEWMVVPVUEUYOUYNVETUU
          HUUIYAUUJVVNVUEVUBVULAVVMVUEVUBVULWOAVVMVUEVJZVUBVULAVVQVUBVJZVJZVULV
          UHFVCZVUHOVGZVUIVOZVVSVUDUTVDVBZTVFVBZVUFYFVBZFVUFVUGVVSVWEFVUGXRZOVU
          GUUKZPVWEYGZVOZAVVRBCDEFGHIJKLMNOPQRVUDTVWEUBUCUDUEUFUGUHUIUJUKULUMUN
          UOUPVWEUULVVSVUDUWKVCZVUDTYHYLZVVSVUEVWKAVVMVUEVUBUUMVUDVETUUNYAVVSVU
          DUTYDVGZVCUXLVWJVWKWFVVSVUDYIVWLVVSVVMVUDYIVCAVVMVUEVUBUUOZUYNUUPYAUV
          EYEAUXLVVRUXMVQVUDUTTUUQYJUURVVSUYRVUAVWDVWCIVGZVGUWSVWDPVGZVNZVIAVVQ
          VUBUUSVVSVWDUYPVWNUYQVVSVWCUYNIVVSUYNVMVCUXIVWCUYNVOVVSUYNVWMUUTVRUYN
          UTUVAVTZWTVVSVWCUYNTVFVWQYMZWSVVSVWPUYTUWSVVSVWOUYSVVSVWDUYPPVWRWTXGX
          AUVBUVCZUVFZVVSVUFUYPVUFYFVBZVWEVVSUYPYNVCVUFYNVCUYPVUFYHYLVUFVXAVCZV
          VSUYPVVSUYNTVVSUYNVWMUVGZATYIVCVVRULVQZYOZYPVVSVUFVVSVUDTVVSUYNYQVCZV
          UDYQVCZVXCUYNUVDYAZVXDYOZYPVVSUYPVUFVXEVXIVVSUYNVUDYRYLZUYPVUFYRYLZVV
          SUYNVXCUVHVVSVXFVXGTYQVCVETYRYLVXJVXKWFVXCVXHVVSTVXDUVIVVSTVXDUVJUYNV
          UDTUVKUVLWJUVOUYPVUFUVMUVNZVVSVWDUYPVUFYFVWRYMZUVPUVQVVSVUFVWGVGZVUFP
          VXAYGZVGZVWAVUIVVSVUFVWGVXOVVSVWGVWHVXOVVSVWFVWIVWSUVRVVSVWEVXAPVXMUV
          SXOUWEVVSVXAFVUGXRZVXBVXNVWAVOVVSVWFVXQVWTVVSVWEVXAFVUGVXMUVTWJVXLVXA
          FVUFOVUGUWAYJVVSVXBVXPVUIVOVXLVUFVXAPUWBYAUWCVVSVVJVULVVTVWBVJWFAVVJV
          VRVVLVQFVUIVUHOYBYAYCYSYSYTUWDUWFYTUWGUWHUWIUWJ $.

        $( Lemma for ~ cvmlift .  The functions ` Q ` are continuous functions
           because they are defined as ` ``' ( F |`` I ) o. G ` where ` G ` is
           continuous and ` ( F |`` I ) ` is a homeomorphism.  (Contributed by
           Mario Carneiro, 16-Feb-2015.) $)
        cvmliftlem8 $p |- ( ( ph /\ M e. ( 1 ... N ) ) ->
          ( Q ` M ) e. ( ( L |`t W ) Cn C ) ) $=
          ( c1 cfz co wcel wa cfv cv cmin cdiv c2nd crio cres ccnv crest ccn cn
          cmpt wceq elfznn cvmliftlem5 sylan2 ccvm ctop adantr cvmtop1 cnrest2r
          wss 3syl c1st cr ctopon cioo crn ctg retopon eqeltri cicc cvmliftlem2
          cc0 simpr unitssre syl6ss resttopon sylancr cii eqid iitopon wf iiuni
          a1i cnf syl feqmptd eqeltrrd cnmpt1res dfii2 oveq1i eqtr4i retop ovex
          cvv restabs syl3anc syl5eq oveq1d eleqtrd cvmtop2 sylib simprl simprr
          wb toptopon cvmliftlem3 anassrs mpbid simpld cxr nnred nndivred rexrd
          wbr clt eqeltrd fmptd frn cvmliftlem1 cvmsrcl elssuni syl6sseqr chmeo
          cuni cnrest2 csn cvmliftlem7 wfn cvmcn ffn fniniseg simprd cle adantl
          cima peano2rem ltm1d nngt0d ltdiv1 syl112anc ltled syl6eleqr cvmsiota
          lbicc2 syl13anc cvmshmeo syl2anc hmeocnvcn cnmpt11f sseldd ) ASURTUSU
          TVAZVBZSIVCZCUACVDZPVCZOSURVEUTZTVFUTZUVTIVCVCZUDVDVAUDSKVCZVGVCZVHZV
          IZVJZVCVNZRUAVKUTZGVLUTZUVOASVMVAZUVQUWHVOSTVPZABCDEFGHIJKLMNOPQRSTUA
          UBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQVQVRUVPUWIGUWEVKUTZVLUTZUWJUWHUVPOGQV
          SUTVAZGVTVAUWNUWJWDAUWOUVOUHWAZGOQWBUWEUWIGWCWEUVPCUVSUWGUWIQUWCWFVCZ
          VKUTZUWMUAUVPRWGWHVCZVAUAWGWDUWIUAWHVCVARWIWJWKVCZUWSUOWLWMUVPUAWPURW
          NUTZWGAUVODEFGHJKLMOPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOAUVOWQZUQWOZWRWS
          UARWGWTXAUVPCUAUVSVNZUWIQVLUTZVAZUXDUWIUWRVLUTVAZUVPUXDXBUAVKUTZQVLUT
          UXEUVPCUVSXBUXHQUXAUAUXHXCXBUXAWHVCVAUVPXDXGUXCUVPPCUXAUVSVNXBQVLUTZU
          VPCUXAUBPUVPPUXIVAZUXAUBPXEAUXJUVOUIWAZPXBQUXAUBXFUGXHXIXJUXKXKXLUVPU
          XHUWIQVLUVPUXHRUXAVKUTZUAVKUTZUWIXBUXLUAVKXBUWTUXAVKUTUXLXMRUWTUXAVKU
          OXNXOXNUVPRVTVAZUAUXAWDUXAXRVAZUXMUWIVOUXNUVPRUWTVTUOXPWMXGUXCUXOUVPW
          PURWNXQXGUAUXARVTXRXSXTYAYBYCUVPQUBWHVCVAZUXDWJUWQWDZUWQUBWDUXFUXGYHU
          VPQVTVAZUXPUVPUWOUXRUWPGOQYDXIQUBUGYIYEUVPUAUWQUXDXEUXQUVPCUAUVSUWQUX
          DAUVOUVRUAVAZUVSUWQVAAUVOUXSVBDEUVRFGHJKLMOPQRSTUAUBUCUEUFUGUHUIUJUKU
          LUMUNUOAUVOUXSYFUQAUVOUXSYGYJYKUXDXCUUAUAUWQUXDUUBXIUVPUWQQUUHZUBUVPU
          WDUWQJVCVAZUWQQVAUWQUXTWDAUVODEFGHJKLMOPQRSTUBUCUEUFUGUHUIUJUKULUMUNU
          OUXBUUCZDEGJUWDUWQMOQUCUEUUDUWQQUUEWEUGUUFUWQUXDUWIQUBUUIXTYLUVPUWFUW
          MUWRUUGUTVAZUWGUWRUWMVLUTVAUVPUYAUWEUWDVAZUYCUYBUVPUYDUWBUWEVAZUVPUWO
          UYAUWBFVAZUWBOVCZUWQVAUYDUYEVBUWPUYBUVPUYFUYGUWAPVCZVOZUVPUWBOVJUYHUU
          JUUSVAZUYFUYIVBZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPU
          QUUKUVPFUBOXEZOFUULUYJUYKYHUVPUWOOGQVLUTVAUYLUWPGOQUUMOGQFUBUFUGXHWEF
          UBOUUNFUYHUWBOUUOWEYLZYMUVPUYGUYHUWQUVPUYFUYIUYMUUPAUVODEUWAFGHJKLMOP
          QRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUXBUQUVPUWAUWASTVFUTZWNUTZUAUVPUWAYNV
          AUYNYNVAUWAUYNUUQYRUWAUYOVAUVPUWAUVPUVTTUVPSWGVAZUVTWGVAZUVPSUVOUWKAU
          WLUURYOZSUUTXIZATVMVAUVOULWAZYPZYQUVPUYNUVPSTUYRUYTYPZYQUVPUWAUYNVUAV
          UBUVPUVTSYSYRZUWAUYNYSYRZUVPSUYRUVAUVPUYQUYPTWGVAWPTYSYRVUCVUDYHUYSUY
          RUVPTUYTYOUVPTUYTUVBUVTSTUVCUVDYLUVEUWAUYNUVHXTUQUVFYJYTUDDEUWBFGJUWD
          UWQMOQUWEUCUEUFUWEXCUVGUVIYMDEUWEGJUWDUWQMOQUCUEUVJUVKUWFUWMUWRUVLXIU
          VMUVNYT $.
      $}

      $( Lemma for ~ cvmlift .  The ` Q ( M ) ` functions are defined on almost
         disjoint intervals, but they overlap at the edges.  Here we show that
         at these points the ` Q ` functions agree on their common domain.
         (Contributed by Mario Carneiro, 14-Feb-2015.) $)
      cvmliftlem9 $p |- ( ( ph /\ M e. ( 1 ... N ) ) ->
          ( ( Q ` M ) ` ( ( M - 1 ) / N ) ) =
          ( ( Q ` ( M - 1 ) ) ` ( ( M - 1 ) / N ) ) ) $=
        ( c1 cfz co wcel wa cmin cdiv cfv cv c2nd crio cres ccnv cicc cmpt wceq
        cvv cn elfznn eqid cvmliftlem5 sylan2 simpr fveq2d cxr cle wbr cr nnred
        adantl peano2rem syl adantr rexrd clt ltm1d cc0 nngt0d ltdiv1 syl112anc
        nndivred wb mpbid ltled lbicc2 syl3anc fvex a1i fvmptd ccvm cvmliftlem1
        c1st csn cima cvmliftlem7 wf wfn ccn cvmcn cnf 3syl ffn fniniseg simpld
        cvmliftlem3 eqeltrd cvmsiota syl13anc fvres eqtrd wf1o cvmsf1o f1ocnvfv
        simprd wi syl2anc mpd ) ASUPTUQURUSZUTZSUPVAURZTVBURZSIVCZVCYPPVCZOYPYO
        IVCVCZUCVDUSUCSKVCZVEVCZVFZVGZVHZVCZYSYNCYPCVDZPVCZUUDVCZUUEYPSTVBURZVI
        URZYQVLYMASVMUSZYQCUUJUUHVJVKSTVNZABCDEFGHIJKLMNOPQRSTUUJUAUBUCUDUEUFUG
        UHUIUJUKULUMUNUOUUJVOZVPVQYNUUFYPVKZUTZUUGYRUUDUUOUUFYPPYNUUNVRVSVSYNYP
        VTUSUUIVTUSYPUUIWAWBYPUUJUSYNYPYNYOTYNSWCUSZYOWCUSZYNSYMUUKAUULWEWDZSWF
        WGZATVMUSYMUKWHZWPZWIYNUUIYNSTUURUUTWPZWIYNYPUUIUVAUVBYNYOSWJWBZYPUUIWJ
        WBZYNSUURWKYNUUQUUPTWCUSWLTWJWBUVCUVDWQUUSUURYNTUUTWDYNTUUTWMYOSTWNWOWR
        WSYPUUIWTXAZUUEVLUSYNYRUUDXBXCXDYNYSUUCVCZYRVKZUUEYSVKZYNUVFYSOVCZYRYNY
        SUUBUSZUVFUVIVKYNUUBUUAUSZUVJYNOGQXEURUSZUUAYTXGVCZJVCUSZYSFUSZUVIUVMUS
        UVKUVJUTAUVLYMUGWHZAYMDEFGHJKLMOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNAYMVRZXF
        ZYNUVOUVIYRVKZYNYSOVHYRXHXIUSZUVOUVSUTZABCDEFGHIJKLMNOPQRSTUUJUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUUMXJYNFUAOXKZOFXLUVTUWAWQYNUVLOGQXMURUSUWBUVPGOQX
        NOGQFUAUEUFXOXPFUAOXQFYRYSOXRXPWRZXSYNUVIYRUVMYNUVOUVSUWCYIZAYMDEYPFGHJ
        KLMOPQRSTUUJUAUBUDUEUFUGUHUIUJUKULUMUNUVQUUMUVEXTYAUCDEYSFGJUUAUVMMOQUU
        BUBUDUEUUBVOYBYCZYIZYSUUBOYDWGUWDYEYNUUBUVMUUCYFZUVJUVGUVHYJYNUVLUVNUVK
        UWGUVPUVRYNUVKUVJUWEXSDEUUBGJUUAUVMMOQUBUDYGXAUWFUUBUVMYSYRUUCYHYKYLYE
        $.

      cvmliftlem.k $e |- K = U_ k e. ( 1 ... N ) ( Q ` k ) $.
      ${
        cvmliftlem10.1 $e |- ( ch <-> ( ( n e. NN /\ ( n + 1 ) e. ( 1 ... N ) )
          /\ ( U_ k e. ( 1 ... n ) ( Q ` k ) e.
            ( ( L |`t ( 0 [,] ( n / N ) ) ) Cn C ) /\ ( F o.
        U_ k e. ( 1 ... n ) ( Q ` k ) ) = ( G |` ( 0 [,] ( n / N ) ) ) ) ) ) $.
        $( Lemma for ~ cvmlift .  The function ` K ` is going to be our
           complete lifted path, formed by unioning together all the ` Q `
           functions (each of which is defined on one segment
           ` [ ( M - 1 ) / N , M / N ] ` of the interval).  Here we prove by
           induction that ` K ` is a continuous function and a lift of ` G ` by
           applying ~ cvmliftlem6 , ~ cvmliftlem7 (to show it is a function and
           a lift), ~ cvmliftlem8 (to show it is continuous), and ~ cvmliftlem9
           (to show that different ` Q ` functions agree on the intersection of
           their domains, so that the pasting lemma ~ paste gives that ` K ` is
           well-defined and continuous).  (Contributed by Mario Carneiro,
           14-Feb-2015.) $)
        cvmliftlem10 $p |- ( ph ->
          ( K e. ( ( L |`t ( 0 [,] ( N / N ) ) ) Cn C ) /\
            ( F o. K ) = ( G |` ( 0 [,] ( N / N ) ) ) ) ) $=
          ( vy c1 cfz co wcel cc0 cdiv cicc crest ccn ccom cres wceq wa eluzfz2
          cfv cn syl wi cv ciun caddc eleq1 csn oveq2 syl6eq fveq2 iunxsn oveq1
          iuneq1d oveq2d oveq1d eleq12d coeq2d reseq2d eqeq12d imbi2d cmin eqid
          anbi12d imbi12d cvmliftlem8 mpdan nncnd simpr cvmliftlem7 cvmliftlem6
          eleqtrd wf simprd eqtrd jca adantl cuni cr wss ccld 0re nnred iccssre
          nndivred sylancr simpld icccld syl6eleqr cun a1i cle wbr clt wb mpbid
          syl3anc syl2anc ctop eqtr3d feq2d syldan cxr rexrd cvv cuz nnuz cz 1z
          syl6eleq fzsn ax-mp 1ex syl6eqr eluzfz1 1m1e0 oveq1i nnne0d div0d a1d
          syl5eq elnnuz biimpi peano2fzr ex imim1d simplbi elfznn adantr fveq2i
          cioo crn ctg ssun1 nnnn0d nn0ge0d nngt0d divge0 syl22anc ltp1d ltdiv1
          syl112anc ltled w3a elicc2 mpbir3and iccsplit syl5sseqr unieqi eqtr4i
          uniretop restcldi ssun2 eqeltri restuni cin simprbi cnf mpbird ax-1cn
          retop cc pncan sylancl cop wfun cdm ffun ssiun2s peano2rem ubicc2 fdm
          ltm1d funssfv fveq2d fveq12d cvmliftlem9 3eqtr2d opeq2d sneqd wfn ffn
          eleqtrrd 0xr fnressn lbicc2 3eqtr4d cif df-icc xrmaxle xrlemin iftrue
          ixxin oveq12d iccid 3eqtrd fresaun iunxun ovex uneq2i syl6req reseq1d
          fzsuc eqtri feq1d fresaunres1 restabs 3eltr4d uneq12d resundi 3eqtr4g
          fresaunres2 paste coundi 3eqtr2rd sylan2br expr a2d syld expcom nnind
          mpcom mpd ) AUBVAUBVBVCZVDZTUAVEUBUBVFVCZVGVCZVHVCZHVIVCZVDZQTVJZRVVB
          VKZVLZVMZAUBVAUUAVOZVDZVUTAUBVPVVJUMUUBUUEZVAUBVNVQUBVPVDZAVUTVVIVRZU
          MAUTVSZVUSVDZNVAVVOVBVCZNVSZJVOZVTZUAVEVVOUBVFVCZVGVCZVHVCZHVIVCZVDZQ
          VVTVJZRVWBVKZVLZVMZVRZVRAVAVUSVDZVAJVOZUAVEVAUBVFVCZVGVCZVHVCZHVIVCZV
          DZQVWLVJZRVWNVKZVLZVMZVRZVRAPVSZVUSVDZNVAVXCVBVCZVVSVTZUAVEVXCUBVFVCZ
          VGVCZVHVCZHVIVCZVDZQVXFVJZRVXHVKZVLZVMZVRZVRAVXCVAWAVCZVUSVDZNVAVXQVB
          VCZVVSVTZUAVEVXQUBVFVCZVGVCZVHVCZHVIVCZVDZQVXTVJZRVYBVKZVLZVMZVRZVRAV
          VNVRUTPUBVVOVAVLZVWJVXBAVYKVVPVWKVWIVXAVVOVAVUSWBVYKVWEVWQVWHVWTVYKVV
          TVWLVWDVWPVYKVVTNVAWCZVVSVTVWLVYKNVVQVYLVVSVYKVVQVAVAVBVCZVYLVVOVAVAV
          BWDVAUUCVDVYMVYLVLUUDVAUUFUUGWEWINVAVVSVWLUUHVVRVAJWFWGWEZVYKVWCVWOHV
          IVYKVWBVWNUAVHVYKVWAVWMVEVGVVOVAUBVFWHWJZWJWKWLVYKVWFVWRVWGVWSVYKVVTV
          WLQVYNWMVYKVWBVWNRVYOWNWOWSWTWPVVOVXCVLZVWJVXPAVYPVVPVXDVWIVXOVVOVXCV
          USWBVYPVWEVXKVWHVXNVYPVVTVXFVWDVXJVYPNVVQVXEVVSVVOVXCVAVBWDWIZVYPVWCV
          XIHVIVYPVWBVXHUAVHVYPVWAVXGVEVGVVOVXCUBVFWHWJZWJWKWLVYPVWFVXLVWGVXMVY
          PVVTVXFQVYQWMVYPVWBVXHRVYRWNWOWSWTWPVVOVXQVLZVWJVYJAVYSVVPVXRVWIVYIVV
          OVXQVUSWBVYSVWEVYEVWHVYHVYSVVTVXTVWDVYDVYSNVVQVXSVVSVVOVXQVAVBWDWIZVY
          SVWCVYCHVIVYSVWBVYBUAVHVYSVWAVYAVEVGVVOVXQUBVFWHWJZWJWKWLVYSVWFVYFVWG
          VYGVYSVVTVXTQVYTWMVYSVWBVYBRWUAWNWOWSWTWPVVOUBVLZVWJVVNAWUBVVPVUTVWIV
          VIVVOUBVUSWBWUBVWEVVEVWHVVHWUBVVTTVWDVVDWUBVVTNVUSVVSVTTWUBNVVQVUSVVS
          VVOUBVAVBWDWIURUUIZWUBVWCVVCHVIWUBVWBVVBUAVHWUBVWAVVAVEVGVVOUBUBVFWHW
          JZWJWKWLWUBVWFVVFVWGVVGWUBVVTTQWUCWMWUBVWBVVBRWUDWNWOWSWTWPAVXAVWKAVW
          QVWTAVWLUAVAVAWQVCZUBVFVCZVWMVGVCZVHVCZHVIVCZVWPAVWKVWLWUIVDAVVKVWKVV
          LVAUBUUJVQZACDEFGHIJKLMNOQRSUAVAUBWUGUCUDUEUFUGUHUIUJUKULUMUNUOUPUQWU
          GWRZXAXBAWUHVWOHVIAWUGVWNUAVHAWUFVEVWMVGAWUFVEUBVFVCVEWUEVEUBVFUUKUUL
          AUBAUBUMXCAUBUMUUMUUNUUPWKZWJWKXGAVWRRWUGVKZVWSAWUGGVWLXHZVWRWUMVLZAV
          WKWUNWUOVMWUJAVWKCDEFGHIJKLMNOQRSUAVAUBWUGUCUDUEUFUGUHUIUJUKULUMUNUOU
          PUQWUKAVWKXDACDEFGHIJKLMNOQRSUAVAUBWUGUCUDUEUFUGUHUIUJUKULUMUNUOUPUQW
          UKXEXFXBXIAWUGVWNRWULWNXJXKUUOVXCVPVDZAVXPVYJAWUPVXPVYJVRAWUPVMZVXPVX
          RVXOVRVYJWUQVXRVXDVXOWUQVXCVVJVDZVXRVXDVRWUPWURAWUPWURVXCUUQUURZXLWUR
          VXRVXDVXCVAUBUUSZUUTVQUVAWUQVXRVXOVYIAWUPVXRVXOVYIVRAWUPVXRVMZVXOVYIW
          VAVXOVMABVYIUSABVMZVYEVYHWVBVXHVXGVYAVGVCZVXTVYCHVYCXMZGWVDWRUGWVBVYB
          XNXOZVXHUAXPVOZVDVXHVYBXOZVXHVYCXPVOZVDWVBVEXNVDZVYAXNVDZWVEXQWVBVXQU
          BWVBVXQWVBVXRVXQVPVDWVBWUPVXRBWVAABWVAVXOUSUVBZXLXIZVXQUBUVCVQXRZAVVM
          BUMUVDZXTZVEVYAXSYAZWVBVXHUVFUVGUVHVOZXPVOZWVFWVBWVIVXGXNVDZVXHWVRVDX
          QWVBVXCUBWVBVXCBWUPABWUPVXRWVKYBXLZXRZWVNXTZVEVXGYCYAUAWVQXPUPUVEZYDW
          VBVXHWVCYEZVXHVYBVXHWVCUVIWVBWVIWVJVXGVYBVDZVYBWWDVLWVIWVBXQYFWVOWVBW
          WEWVSVEVXGYGYHZVXGVYAYGYHZWWBWVBVXCXNVDZVEVXCYGYHUBXNVDZVEUBYIYHZWWFW
          WAWVBVXCWVBVXCWVTUVJUVKWVBUBWVNXRZWVBUBWVNUVLZVXCUBUVMUVNZWVBVXGVYAWW
          BWVOWVBVXCVXQYIYHZVXGVYAYIYHZWVBVXCWWAUVOWVBWWHVXQXNVDWWIWWJWWNWWOYJW
          WAWVMWWKWWLVXCVXQUBUVPUVQYKUVRZWVBWVIWVJWWEWVSWWFWWGUVSYJXQWVOVEVYAVX
          GUVTYAUWAVEVYAVXGUWBYLZUWCZVYBVXHUAXNXNWVQXMUAXMUWFUAWVQUPUWDUWEZUWGY
          LWVBWVEWVCWVFVDWVCVYBXOZWVCWVHVDWVPWVBWVCWVRWVFWVBWVSWVJWVCWVRVDWWBWV
          OVXGVYAYCYMWWCYDWVBWWDWVCVYBWVCVXHUWHWWQUWCZVYBWVCUAXNWWSUWGYLWVBVYBW
          WDWVDWWQWVBUAYNVDZWVEVYBWVDVLUAWVQYNUPUWPUWIZWVPVYBUAXNWWSUWJYAYOZWVB
          WWDGVXTXHZWVDGVXTXHWVBWWDGVXFVXQJVOZYEZXHZWXEWVBVXHGVXFXHZWVCGWXFXHZV
          XFVXHWVCUWKZVKZWXFWXKVKZVLZWXHWVBWXIVXIXMZGVXFXHZWVBVXKWXPWVBVXKVXNBV
          XOABWVAVXOUSUWLXLZYBZVXFVXIHWXOGWXOWRUGUWMVQWVBVXHWXOGVXFWVBWXBVXHXNX
          OZVXHWXOVLWXCWVBWVIWVSWXSXQWWBVEVXGXSYAVXHUAXNWWSUWJYAYPUWNZWVBVXQVAW
          QVCZUBVFVCZVYAVGVCZGWXFXHZWXJWVBWYDQWXFVJZRWYCVKZVLZABVXRWYDWYGVMWVLA
          VXRCDEFGHIJKLMNOQRSUAVXQUBWYCUCUDUEUFUGUHUIUJUKULUMUNUOUPUQWYCWRZAVXR
          XDACDEFGHIJKLMNOQRSUAVXQUBWYCUCUDUEUFUGUHUIUJUKULUMUNUOUPUQWYHXEXFYQZ
          YBWVBWYCWVCGWXFWVBWYBVXGVYAVGWVBWYAVXCUBVFWVBVXCUWQVDVAUWQVDWYAVXCVLW
          VBVXCWVTXCUWOVXCVAUWRUWSZWKZWKZYPYKZWVBVXFVXGWCZVKZWXFWYNVKZWXLWXMWVB
          VXGVXGVXFVOZUWTZWCZVXGVXGWXFVOZUWTZWCZWYOWYPWVBWYRXUAWVBWYQWYTVXGWVBW
          YQVXGVXCJVOZVOZWYBWYAJVOZVOZWYTWVBVXFUXAZXUCVXFXOZVXGXUCUXBZVDWYQXUDV
          LWVBWXIXUGWXTVXHGVXFUXCVQWVBVXCVXEVDZXUHWVBWURXUJWVBWUPWURWVTWUSVQZVA
          VXCVNVQNVXEVVSVXCXUCVVRVXCJWFUXDVQWVBVXGVXCVAWQVCZUBVFVCZVXGVGVCZXUIW
          VBXUMYRVDVXGYRVDZXUMVXGYGYHVXGXUNVDWVBXUMWVBXULUBWVBWWHXULXNVDZWWAVXC
          UXEVQZWVNXTZYSWVBVXGWWBYSZWVBXUMVXGXURWWBWVBXULVXCYIYHZXUMVXGYIYHZWVB
          VXCWWAUXHWVBXUPWWHWWIWWJXUTXVAYJXUQWWAWWKWWLXULVXCUBUVPUVQYKUVRXUMVXG
          UXFYLWVBXUNGXUCXHZXUIXUNVLWVBXVBQXUCVJRXUNVKVLZABVXDXVBXVCVMWVBWURVXR
          VXDXUKWVLWUTYMAVXDCDEFGHIJKLMNOQRSUAVXCUBXUNUCUDUEUFUGUHUIUJUKULUMUNU
          OUPUQXUNWRZAVXDXDACDEFGHIJKLMNOQRSUAVXCUBXUNUCUDUEUFUGUHUIUJUKULUMUNU
          OUPUQXVDXEXFYQYBXUNGXUCUXGVQUXRVXGVXFXUCUXIYLWVBWYBVXGXUEXUCWVBWYAVXC
          JWYJUXJWYKUXKWVBWYBWXFVOZXUFWYTABVXRXVEXUFVLWVLACDEFGHIJKLMNOQRSUAVXQ
          UBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQUXLYQWVBWYBVXGWXFWYKUXJYOUXMUXNUXOWVB
          VXFVXHUXPZVXGVXHVDZWYOWYSVLWVBWXIXVFWXTVXHGVXFUXQVQWVBVEYRVDZXUOWWFXV
          GXVHWVBUXSYFZXUSWWMVEVXGUXFYLVXHVXGVXFUXTYMWVBWXFWVCUXPZVXGWVCVDZWYPX
          UBVLWVBWXJXVJWYMWVCGWXFUXQVQWVBXUOVYAYRVDZWWGXVKXUSWVBVYAWVOYSZWWPVXG
          VYAUYAYLWVCVXGWXFUXTYMUYBWVBWXKWYNVXFWVBWXKWWFVXGVEUYCZWWGVXGVYAUYCZV
          GVCZVXGVXGVGVCZWYNWVBXVHXUOXUOXVLWXKXVPVLXVIXUSXUSXVMCUTDVEVXGVXGVYAY
          GYGVGCUTDUYDVEVXGDVSZUYEXVRVXGVYAUYFUYHUVNWVBXVNVXGXVOVXGVGWVBWWFXVNV
          XGVLWWMWWFVXGVEUYGVQWVBWWGXVOVXGVLWWPWWGVXGVYAUYGVQUYIWVBXUOXVQWYNVLX
          USVXGUYJVQUYKZWNWVBWXKWYNWXFXVSWNUYBZVXHWVCGVXFWXFUYLYLWVBWWDGWXGVXTW
          VBVXTNVXEVXQWCZYEZVVSVTZWXGWVBNVXSXWBVVSWVBWURVXSXWBVLXUKVAVXCUYRVQWI
          XWCVXFNXWAVVSVTZYEWXGNVXEXWAVVSUYMXWDWXFVXFNVXQVVSWXFVXCVAWAUYNVVRVXQ
          JWFWGUYOUYSUYPZUYTYKWVBWWDWVDGVXTWXDYPYKWVBVXFVXJVXTVXHVKZVYCVXHVHVCZ
          HVIVCWXRWVBWXGVXHVKZXWFVXFWVBWXGVXTVXHXWEUYQWVBWXIWXJWXNXWHVXFVLWXTWY
          MXVTVXHWVCGVXFWXFVUAYLYOWVBXWGVXIHVIWVBWXBWVGVYBYTVDZXWGVXIVLWXBWVBWX
          CYFZWWRXWIWVBVEVYAVGUYNYFZVXHVYBUAYNYTVUBYLWKVUCWVBWXFUAWVCVHVCZHVIVC
          ZVXTWVCVKZVYCWVCVHVCZHVIVCWVBWXFUAWYCVHVCZHVIVCZXWMABVXRWXFXWQVDWVLAC
          DEFGHIJKLMNOQRSUAVXQUBWYCUCUDUEUFUGUHUIUJUKULUMUNUOUPUQWYHXAYQWVBXWPX
          WLHVIWVBWYCWVCUAVHWYLWJWKXGWVBWXGWVCVKZXWNWXFWVBWXGVXTWVCXWEUYQWVBWXI
          WXJWXNXWRWXFVLWXTWYMXVTVXHWVCGVXFWXFVUGYLYOWVBXWOXWLHVIWVBWXBWWTXWIXW
          OXWLVLXWJWXAXWKWVCVYBUAYNYTVUBYLWKVUCVUHWVBVYGRWWDVKZQWXGVJZVYFWVBVYB
          WWDRWWQWNWVBVXLWYEYEVXMRWVCVKZYEXWTXWSWVBVXLVXMWYEXXAWVBVXKVXNWXQXIWV
          BWYEWYFXXAWVBWYDWYGWYIXIWVBWYCWVCRWYLWNXJVUDQVXFWXFVUIRVXHWVCVUEVUFWV
          BWXGVXTQXWEWMVUJXKVUKVULVULVUMVUNVUOVUMVUPVUQVUR $.
      $}

      $( Lemma for ~ cvmlift .  (Contributed by Mario Carneiro,
         14-Feb-2015.) $)
      cvmliftlem11 $p |- ( ph -> ( K e. ( II Cn C ) /\ ( F o. K ) = G ) ) $=
        ( vn cii ccn co wcel ccom wceq cc0 cdiv cicc crest cres cv cn caddc cfz
        c1 wa cfv ciun biid cvmliftlem10 simpld crn ctg a1i nncnd nnne0d dividd
        oveq2d oveq12d dfii2 syl6eqr oveq1d eleqtrd simprd reseq2d wf wfn iiuni
        cioo cnf ffn fnresdm 4syl 3eqtrd jca ) ARURGUSUTZVAORVBZPVCARSVDTTVEUTZ
        VFUTZVGUTZGUSUTZXDARXIVAZXEPXGVHZVCZAUQVIZVJVAXMVMVKUTVMTVLUTVAVNMVMXMV
        LUTMVIIVOVPZSVDXMTVEUTVFUTZVGUTGUSUTVAOXNVBPXOVHVCVNVNZBCDEFGHIJKLMNUQO
        PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPXPVQVRZVSAXHURGUSAXHWQVTWAVOZVDVMV
        FUTZVGUTURASXRXGXSVGSXRVCAUNWBAXFVMVDVFATATUKWCATUKWDWEWFZWGWHWIWJWKAXE
        XKPXSVHZPAXJXLXQWLAXGXSPXTWMAPURQUSUTVAXSUAPWNPXSWOYAPVCUHPURQXSUAWPUFW
        RXSUAPWSXSPWTXAXBXC $.

      $( Lemma for ~ cvmlift .  The initial value of ` K ` is ` P ` because
         ` Q ( 1 ) ` is a subset of ` K ` which takes value ` P ` at ` 0 ` .
         (Contributed by Mario Carneiro, 16-Feb-2015.) $)
      cvmliftlem13 $p |- ( ph -> ( K ` 0 ) = P ) $=
        ( cc0 cfv c1 cop csn wfun wss cdm wcel wceq cicc co wf cii cvmliftlem11
        ccn ccom simpld iiuni cnf syl ffun cfz cv ciun cn nnuz syl6eleq eluzfz1
        cuz fveq2 ssiun2s syl6sseqr cmin cdiv cxr cle wbr 0xr nnrecred rexrd cr
        a1i clt 1re 0le1 nnred nngt0d divge0 syl22anc lbicc2 1m1e0 oveq1i nncnd
        syl3anc nnne0d div0d syl5eq oveq1d eleqtrrd cres eqid simpr cvmliftlem7
        wa cvmliftlem6 mpdan fdm funssfv cvmliftlem9 fveq2d cvmliftlem4 fveq12d
        fveq2i eqtri 3eqtr3d cn0 0nn0 fvsng sylancr 3eqtrd ) AUQRURZUQUSIURZURZ
        UQUQHUTVAZURZHARVBZYSRVCUQYSVDZVEYRYTVFAUQUSVGVHZFRVIZUUCARVJGVLVHVEZUU
        FAUUGORVMPVFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVKVNRVJ
        GUUEFVOUEVPVQUUEFRVRVQAYSMUSTVSVHZMVTZIURZWAZRAUSUUHVEZYSUUKVCATUSWFURZ
        VEUULATWBUUMUKWCWDUSTWEVQZMUUHUUJUSYSUUIUSIWGWHVQUPWIAUQUSUSWJVHZTWKVHZ
        USTWKVHZVGVHZUUDAUQUQUUQVGVHZUURAUQWLVEZUUQWLVEUQUUQWMWNZUQUUSVEUUTAWOW
        SAUUQATUKWPWQAUSWRVEZUQUSWMWNZTWRVEUQTWTWNUVAUVBAXAWSUVCAXBWSATUKXCATUK
        XDUSTXEXFUQUUQXGXKAUUPUQUUQVGAUUPUQTWKVHUQUUOUQTWKXHXIATATUKXJATUKXLXMX
        NZXOXPAUURFYSVIZUUDUURVFAUVEOYSVMPUURXQVFZAUULUVEUVFYAUUNAUULBCDEFGHIJK
        LMNOPQSUSTUURUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUURXRZAUULXSABCDEFGHIJKLMNOP
        QSUSTUURUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUVGXTYBYCVNUURFYSYDVQXPUQRYSYEXKA
        UUPYSURZUUPUUOIURZURZYTUUBAUULUVHUVJVFUUNABCDEFGHIJKLMNOPQSUSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOYFYCAUUPUQYSUVDYGAUUPUQUVIUUAUVIUUAVFAUVIUQIURUUAU
        UOUQIXHYJABCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOYHYKWSUVDYIYL
        AUQYMVEHFVEUUBHVFYNUIUQHYMFYOYPYQ $.

      $( Lemma for ~ cvmlift .  Putting the results of ~ cvmliftlem11 ,
         ~ cvmliftlem13 and ~ cvmliftmo together, we have that ` K ` is a
         continuous function, satisfies ` F o. K = G ` and ` K ( 0 ) = P ` ,
         and is equal to any other function which also has these properties, so
         it follows that ` K ` is the unique lift of ` G ` .  (Contributed by
         Mario Carneiro, 16-Feb-2015.) $)
      cvmliftlem14 $p |- ( ph ->
          E! f e. ( II Cn C ) ( ( F o. f ) = G /\ ( f ` 0 ) = P ) ) $=
        ( cv ccom wceq cc0 cfv wa cii ccn co wrex wrmo wreu cvmliftlem11 simpld
        simprd cvmliftlem13 coeq2 eqeq1d fveq1 anbi12d rspcev syl12anc c1 iiuni
        wcel cicc ccon iicon cnlly iinllycon 0elunit cvmliftmo reu5 sylanbrc
        a1i ) APLURZUSZQUTZVAWMVBZHUTZVCZLVDGVEVFZVGZWRLWSVHWRLWSVIASWSWBZPSUSZ
        QUTZVASVBZHUTZWTAXAXCABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOU
        PUQVJZVKAXAXCXFVLABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQV
        MWRXCXEVCLSWSWMSUTZWOXCWQXEXGWNXBQWMSPVNVOXGWPXDHVAWMSVPVOVQVRVSAFGHLPQ
        RVDVAVAVTWCVFZUFWAUHVDWDWBAWEWLVDWDWFWBAWGWLVAXHWBAWHWLUIUJUKWIWRLWSWJW
        K $.
    $}

    $( Lemma for ~ cvmlift .  Discharge the assumptions of ~ cvmliftlem14 .
       The set of all open subsets ` u ` of the unit interval such that
       ` G " u ` is contained in an even covering of some open set in ` J ` is
       a cover of ` II ` by the definition of a covering map, so by the
       Lebesgue number lemma ~ lebnumii , there is a subdivision of the unit
       interval into ` N ` equal parts such that each part is entirely
       contained within one such open set of ` J ` .  Then using finite choice
       ~ ac6sfi to uniformly select one such subset and one even covering of
       each subset, we are ready to finish the proof with ~ cvmliftlem14 .
       (Contributed by Mario Carneiro, 14-Feb-2015.) $)
    cvmliftlem15 $p |- ( ph ->
        E! f e. ( II Cn C ) ( ( F o. f ) = G /\ ( f ` 0 ) = P ) ) $=
      ( vn vj vx vg vz vy vw vt vc va vm vb cv cmin cdiv cicc wss cima cfv wrex
      c1 co cii crab cfz wral cn ccom wceq cc0 wa ccn wreu cuni ssrab2 wcel wne
      c0 ccvm adantr wf iiuni cnf ffvelrnda cvmcov syl2anc ccnv ad2antrr simprl
      syl cnima simplr simprrl wfn ffn elpreima 3syl mpbir2and simprrr crn wfun
      wb cin ffun funimacnv inss1 syl6eqss eleq2 imaeq2 sseq1d sylib ex sylancr
      mpd csn cxp ciun c1st weq cop sseq2d fveq2 c2nd crio cres cmpt cmpt2 cseq
      vex cvv ax-mp eqid fveq2d eleq1d syl5eq reseq2d cnveqd fveq1d oveq1 ssrdv
      ralrimivw r19.2z rexbidv anbi12d rspcev syl12anc reximdva rexbii elunirab
      expr r19.42v 3bitr4i uniss mp1i syl6sseqr eqssd lebnumii wex cfn 2rexbidv
      rexcom fzfi rexrab op1std rexiunxp wi imass2 sstr2 reximdv syl5bir impcom
      rexlimivw ralimi ac6sfi cid cun cioo ctg sneq xpeq12d cbviunv feq3 simprr
      sylbi cbvmptv cbvriotav fveq1 riotabidv mpteq2dv oveq1d oveq12d mpteq12dv
      riotaeqbidv cbvmpt2v seqeq2 cvmliftlem14 exlimdv syl5 rexlimdva ) AIUNZVB
      UOVCUBUNZUPVCUXAUXBUPVCUQVCZBUNZURZBKCUNZUSZUCUNZURZNUXHGUTZVAZUCLVAZCVDV
      EZVAZIVBUXBVFVCZVGZUBVHVAZJHUNZVIKVJVKUXRUTFVJVLHVDEVMVCVNZAUXMVDURZVKVBU
      QVCZUXMVOZVJUXQUXLCVDVPZAUYAUYBAUDUYAUYBAUDUNZUYAVQZUYDUYBVQZAUYEVLZUYDUX
      FVQZUXKVLZCVDVAZUCLVAZUYFUYGUYDKUTZUXHVQZUXJVSVRZVLZUCLVAZUYKUYGJELVTVCVQ
      ZUYLMVQUYPAUYQUYERWAAUYAMUYDKAKVDLVMVCVQZUYAMKWBZSKVDLUYAMWCQWDWKZWEUCBCE
      UYLGIJLMNOQWFWGUYGUYOUYJUCLUYGUXHLVQZUYOUYJUYGVUAUYOVLZVLZKWHUXHUSZVDVQZU
      YDVUDVQZKVUDUSZUXHURZNUXJVAZUYJVUCUYRVUAVUEAUYRUYEVUBSWIUYGVUAUYOWJUXHKVD
      LWLWGVUCVUFUYEUYMAUYEVUBWMUYGVUAUYMUYNWNVUCUYSKUYAWOVUFUYEUYMVLXCAUYSUYEV
      UBUYTWIZUYAMKWPUYAUYDUXHKWQWRWSVUCUYNVUHNUXJVGVUIUYGVUAUYMUYNWTVUCVUHNUXJ
      VUCVUGUXHKXAZXDZUXHVUCUYSKXBVUGVULVJVUJUYAMKXEUXHKXFWRUXHVUKXGXHUUBVUHNUX
      JUUCWGUYIVUFVUIVLCVUDVDUXFVUDVJZUYHVUFUXKVUIUXFVUDUYDXIVUMUXIVUHNUXJVUMUX
      GVUGUXHUXFVUDKXJXKUUDUUEUUFUUGUUKUUHXOUYIUCLVAZCVDVAUYHUXLVLZCVDVAUYKUYFV
      UNVUOCVDUYHUXKUCLUULUUIUYIUCCLVDUVBUXLCUYDVDUUJUUMXLXMUUAAUYBVDVOZUYAUXTU
      YBVUPURAUYCUXMVDUUNUUOWCUUPUUQBUXMIUBUURXNAUXPUXSUBVHUXPUXOUCLUXHXPZUXJXQ
      ZXRZUEUNZWBZKUXCUSZUXAVUTUTZXSUTZURZIUXOVGZVLZUEUUSZAUXBVHVQZVLZUXSUXPUXO
      UUTVQVVBUXFXSUTZURZCVUSVAZIUXOVGVVHVBUXBUVCUXNVVMIUXOUXNKUXDUSZUXHURZNUXJ
      VAUCLVAZUXEVLZBVDVAVVMUXLVVPUXEBCVDCBXTZUXIVVOUCNLUXJVVRUXGVVNUXHUXFUXDKX
      JXKUVAUVDVVQVVMBVDUXEVVPVVMVVPVVNVVKURZCVUSVAUXEVVMVVSVVOCUCNLUXJUXFUXHNU
      NZYAVJVVKUXHVVNUXHVVTUXFUCYJNYJUVEYBUVFUXEVVSVVLCVUSUXEVVBVVNURVVSVVLUVGU
      XCUXDKUVHVVBVVNVVKUVIWKUVJUVKUVLUVMUWEUVNVVLVVEICUXOVUSUEUXFVVCVJVVKVVDVV
      BUXFVVCXSYCYBUVOXNVVJVVGUXSUEVVJVVGUXSVVJVVGVLZUDUFBCDEFUGUHYKVHUIUHUNZVB
      UOVCZUXBUPVCZVWBUXBUPVCZUQVCZUIUNZKUTZJVWDUGUNZUTZUJUNZVQZUJVWBVUTUTZYDUT
      ZYEZYFZWHZUTZYGZYHZUVPVHYFVKVKFYAXPYAXPUVQZVKYIZGVUTHUKIULJKLIUXOUXAVXBUT
      XRZUVRXAUVSUTZUXBMNUMOPQAUYQVVIVVGRWIAUYRVVIVVGSWIAFDVQVVIVVGTWIAFJUTVKKU
      TVJVVIVVGUAWIAVVIVVGWMVWAVVAUXOUKLUKUNZXPZVXEGUTZXQZXRZVUTWBZVVJVVAVVFWJV
      USVXIVJVVAVXJXCUCUKLVURVXHUCUKXTVUQVXFUXJVXGUXHVXEUVTUXHVXEGYCUWAUWBVUSVX
      IUXOVUTUWCYLXLVVJVVAVVFUWDVXDYMVWTUDULYKVHUFULUNZVBUOVCZUXBUPVCZVXKUXBUPV
      CZUQVCZUFUNZKUTZJVXMUYDUTZUMUNZVQZUMVXKVUTUTZYDUTZYEZYFZWHZUTZYGZYHZVJVXB
      VYHVXAVKYIVJUGUHUDULYKVHVWSVYGUFVWFVXQJVWDUYDUTZVXSVQZUMVWNYEZYFZWHZUTZYG
      ZUGUDXTZVWSUFVWFVXQVWQUTZYGVYOUIUFVWFVWRVYQUIUFXTVWHVXQVWQVWGVXPKYCYNUWFV
      YPUFVWFVYQVYNVYPVXQVWQVYMVYPVWPVYLVYPVWOVYKJVYPVWOVWJVXSVQZUMVWNYEVYKVWLV
      YRUJUMVWNVWKVXSVWJXIUWGVYPVYRVYJUMVWNVYPVWJVYIVXSVWDVWIUYDUWHYOUWIYPYQYRY
      SUWJYPUHULXTZUFVWFVYNVXOVYFVYSVWDVXMVWEVXNUQVYSVWCVXLUXBUPVWBVXKVBUOYTUWK
      ZVWBVXKUXBUPYTUWLVYSVXQVYMVYEVYSVYLVYDVYSVYKVYCJVYSVYJVXTUMVWNVYBVYSVWMVY
      AYDVWBVXKVUTYCYNVYSVYIVXRVXSVYSVWDVXMUYDVYTYNYOUWNYQYRYSUWMUWOVWTVYHVXAVK
      UWPYLVXCYMUWQXMUWRUWSUWTXO $.
  $}

  $(
  @{
    iscvm2.1 @e |- X = U. J @.
    iscvm2.2 @e |- A = { j e. Top | E. y
      E. g e. ( ( j tX ~P y ) Homeo ( C |`t ( `' F " U. j ) ) )
       ( g o. ( F |` ( `' F " U. j ) ) ) = ( 1st |` ( U. j X. y ) ) } @.
    @{
      iscvm2.s @e |- S = ( k e. J |->
        { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
          A. u e. s ( A. v e. ( s \ { u } ) ( u i^i v ) = (/) /\
             ( F |` u ) e. ( ( C |`t u ) Homeo ( J |`t k ) ) ) ) } ) @.
      @( An alternative characterisation of covering maps using the
         ` Locally A `
         predicate. A continuous function ` F ` is a covering map iff ` J ` is
         locally evenly covered, where " ` x ` is evenly covered" means that
         ` ``' F " x ` is homeomorphic to the product of ` x ` with a discrete
         space, and such that ` F ` looks like the first projection function
         under this homeomorphism. @)
      iscvm2lem @p |- ( ( C e. Top /\ J e. Top /\ F e. ( C Cn J ) ) ->
        ( F e. ( C CovMap J ) <-> J e. Locally A ) ) @=
        ? @.
        @( [13-Feb-2015] @)
    @}

    @( An alternative characterisation of covering maps using the ` Locally A `
       predicate. A continuous function ` F ` is a covering map iff ` J ` is
       locally evenly covered, where " ` x ` is evenly covered" means that
       ` ``' F " x ` is homeomorphic to the product of ` x ` with a discrete
       space, and such that ` F ` looks like the first projection function
       under this homeomorphism. @)
    iscvm2 @p |- ( ( C e. Top /\ J e. Top /\ F e. ( C Cn J ) ) ->
      ( F e. ( C CovMap J ) <-> J e. Locally A ) ) @=
      ? @.
      @( [13-Feb-2015] @)
  @}
  $)

  ${
    $d a b c d f k s u v C $.  $d a b c d f G $.  $d a b c d f P $.  $d a X $.
    $d a b c d f k s u v F $.  $d a b c d f k s u v J $.  $d a b c d f V $.
    $d b c d f B $.
    cvmlift.1 $e |- B = U. C $.
    $( One of the important properties of covering maps is that any path ` G `
       in the base space "lifts" to a path ` f ` in the covering space such
       that ` F o. f = G ` , and given a starting point ` P ` in the covering
       space this lift is unique.  The proof is contained in ~ cvmliftlem1 thru
       ~ cvmliftlem15 .  (Contributed by Mario Carneiro, 16-Feb-2015.) $)
    cvmlift $p |- ( ( ( F e. ( C CovMap J ) /\ G e. ( II Cn J ) ) /\
      ( P e. B /\ ( F ` P ) = ( G ` 0 ) ) ) ->
        E! f e. ( II Cn C ) ( ( F o. f ) = G /\ ( f ` 0 ) = P ) ) $=
      ( vd vc vk vs vu vv va co wcel wa wceq cv ccvm cii ccn cfv cuni ccnv cima
      vb cc0 cin c0 csn cdif wral cres crest chmeo cpw crab cmpt cvmscbv simpll
      eqid simplr simprl simprr cvmliftlem15 ) EBGUAPQZFUBGUCPQZRZCAQZCEUDUIFUD
      SZRZRIJABCKGLTZUEEUFKTZUGSMTZNTUJUKSNVNVPULUMUNEVPUOBVPUPPGVOUPPUQPQRMVNU
      NRLBURUKULUMUSUTZDOEFGGUEZUHNMBVQKEGLOUHJIVQVCVAHVRVCVHVIVMVBVHVIVMVDVJVK
      VLVEVJVKVLVFVG $.

    cvmfo.2 $e |- X = U. J $.
    $( A covering map is an onto function.  (Contributed by Mario Carneiro,
       13-Feb-2015.) $)
    cvmfo $p |- ( F e. ( C CovMap J ) -> F : B -onto-> X ) $=
      ( vd vc vk vs vu vv va vb cv wceq c0 csn co cuni ccnv cima cdif wral cres
      cin crest chmeo wcel wa cpw crab cmpt eqid cvmscbv cvmfolem ) HIABJDKPZUA
      CUBJPZUCQLPZMPUGRQMURUTSUDUECUTUFBUTUHTDUSUHTUITUJUKLURUEUKKBULRSUDUMUNZN
      CDEOMLBVAJCDKNOIHVAUOUPFGUQ $.
  $}

  ${
    $d g B $.  $d f g C $.  $d f g F $.  $d f g G $.  $d g H $.  $d f g P $.
    $d g J $.
    cvmliftiota.b $e |- B = U. C $.
    cvmliftiota.h $e |- H =
      ( iota_ f e. ( II Cn C ) ( ( F o. f ) = G /\ ( f ` 0 ) = P ) ) $.
    cvmliftiota.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmliftiota.g $e |- ( ph -> G e. ( II Cn J ) ) $.
    cvmliftiota.p $e |- ( ph -> P e. B ) $.
    cvmliftiota.e $e |- ( ph -> ( F ` P ) = ( G ` 0 ) ) $.
    $( Write out a function ` H ` that is the unique lift of ` F ` .
       (Contributed by Mario Carneiro, 16-Feb-2015.) $)
    cvmliftiota $p |- ( ph ->
        ( H e. ( II Cn C ) /\ ( F o. H ) = G /\ ( H ` 0 ) = P ) ) $=
      ( vg wceq cc0 cfv wcel cv ccom wa cii ccn co crab crio coeq2 eqeq1d fveq1
      w3a anbi12d cbvriotav eqtri wreu ccvm cvmlift syl22anc riotacl2 syl elrab
      syl5eqel 3anass bitr4i sylib ) AHFPUAZUBZGQZRVGSZDQZUCZPUDCUEUFZUGZTZHVMT
      ZFHUBZGQZRHSZDQZULZAHVLPVMUHZVNHFEUAZUBZGQZRWCSZDQZUCZEVMUHWBKWHVLEPVMWCV
      GQZWEVIWGVKWIWDVHGWCVGFUIUJWIWFVJDRWCVGUKUJUMUNUOAVLPVMUPZWBVNTAFCIUQUFTG
      UDIUEUFTDBTDFSRGSQWJLMNOBCDPFGIJURUSVLPVMUTVAVCVOVPVRVTUCZUCWAVLWKPHVMVGH
      QZVIVRVKVTWLVHVQGVGHFUIUJWLVJVSDRVGHUKUJUMVBVPVRVTVDVEVF $.
  $}

  ${
    $d t u x y z $.  $d u y z M $.
    $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro, 1-Jun-2015.) $)
    cvmlift2lem1 $p |- ( A. y e. ( 0 [,] 1 ) E. u e. ( ( nei ` II ) ` { y } )
        ( ( u X. { x } ) C_ M <-> ( u X. { t } ) C_ M ) ->
      ( ( ( 0 [,] 1 ) X. { x } ) C_ M ->
        ( ( 0 [,] 1 ) X. { t } ) C_ M ) ) $=
      ( vz cv csn cxp wss wb cii cfv wral cop wcel iitop mpan adantl vex cc0 c1
      cnei wrex cicc co wi wa bi1 ctop iiuni neii1 xpss1 simpl sstrd ssnei snss
      syl sylibr snid opelxpi sylancl ssel syl5com embantd syl5 rexlimdva com12
      ralimdv dfss3 eleq1 ralxp weq opeq2 eleq1d ralsn ralbii 3bitri syl6ibr )
      CGZAGHZIZEJZVTDGZHZIZEJZKZCBGZHZLUCMMZUDZBUAUBUEUFZNZWMWAIZEJZWIWDOZEPZBW
      MNZWMWEIZEJZWPWNWSWPWLWRBWMWPWHWRCWKWHWCWGUGWPVTWKPZUHZWRWCWGUIXCWCWGWRXC
      WBWOEXCVTWMJZWBWOJXBXDWPLUJPZXBXDQWJLVTWMUKULRSVTWMWAUMURWPXBUNUOXCWQWFPZ
      WGWRXCWIVTPZWDWEPXFXCWJVTJZXGXBXHWPXEXBXHQWJLVTUPRSWIVTBTUQUSWDDTZUTWIWDV
      TWEVAVBWFEWQVCVDVEVFVGVIVHXAFGZEPZFWTNWIVTOZEPZCWENZBWMNWSFWTEVJXKXMFBCWM
      WEXJXLEVKVLXNWRBWMXMWRCWDXICDVMXLWQEVTWDWIVNVOVPVQVRVS $.
  $}

  ${
    $d c d k s A $.  $d c d k s F $.  $d x H $.  $d c d k s J $.  $d c d s T $.
    $d c d k s x C $.  $d x K $.  $d x M $.  $d x ph $.  $d c d x W $.
    cvmlift2lem9a.b $e |- B = U. C $.
    cvmlift2lem9a.y $e |- Y = U. K $.
    cvmlift2lem9a.s $e |- S = ( k e. J |->
      { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
        A. c e. s ( A. d e. ( s \ { c } ) ( c i^i d ) = (/) /\
           ( F |` c ) e. ( ( C |`t c ) Homeo ( J |`t k ) ) ) ) } ) $.
    cvmlift2lem9a.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmlift2lem9a.h $e |- ( ph -> H : Y --> B ) $.
    cvmlift2lem9a.g $e |- ( ph -> ( F o. H ) e. ( K Cn J ) ) $.
    cvmlift2lem9a.k $e |- ( ph -> K e. Top ) $.
    cvmlift2lem9a.1 $e |- ( ph -> X e. Y ) $.
    cvmlift2lem9a.2 $e |- ( ph -> T e. ( S ` A ) ) $.
    cvmlift2lem9a.3 $e |- ( ph -> ( W e. T /\ ( H ` X ) e. W ) ) $.
    cvmlift2lem9a.4 $e |- ( ph -> M C_ Y ) $.
    cvmlift2lem9a.6 $e |- ( ph -> ( H " M ) C_ W ) $.
    $( Lemma for ~ cvmlift2 and ~ cvmlift3 .  (Contributed by Mario Carneiro,
       9-Jul-2015.) $)
    cvmlift2lem9a $p |- ( ph -> ( H |` M ) e. ( ( K |`t M ) Cn C ) ) $=
      ( vx crest co ccn cres ctop wcel wss ccvm cvmtop1 syl cnrest2r wf ccnv cv
      cima wral wfn crn ffn fnssres syl2anc df-ima syl5eqssr df-f sylanbrc ccom
      wa wf1 wceq cfv simpld cvmsf1o syl3anc adantr f1of1 ctopon toptopon sylib
      wf1o cvmsss sseldd toponss sylan f1imacnv imaeq2d imaco cnvco cores resco
      resttopon syl6eqr cnveqd syl5eqr imaeq1d eqtr3d resima2 restopn2 simprbda
      cnrest wb cvmopn eqeltrd cnima ralrimiva iscn mpbir2and ) AKLULUMZDMULUMZ
      UNUMZXRDUNUMZILUOZADUPUQZXTYAURAHDJUSUMUQZYCUBDHJUTVAZMXRDVBVAAYBXTUQZLMY
      BVCZYBVDZUKVEZVFZXRUQZUKXSVGZAYBLVHZYBVIZMURZYGAIOVHZLOURZYMAOCIVCYPUCOCI
      VJVAUIOLIVKVLAYNILVFMILVMUJVNZLMYBVOVPAYKUKXSAYIXSUQZVRZYJHIVQZLUOZVDZHMU
      OZYIVFZVFZXRYTYHUUDVDZUUEVFZVFZYJUUFYTUUHYIYHYTMBUUDVSZYIMURZUUHYIVTYTMBU
      UDWJZUUJAUULYSAYDFBEWAUQZMFUQZUULUBUGAUUNNIWAMUQUHWBZRQMDEFBGHJPUAWCWDWEM
      BUUDWFVAAXSMWGWAUQZYSUUKADCWGWAUQZMCURZUUPAYCUUQYEDCSWHWIZAUUQMDUQZUURUUS
      AFDMAUUMFDURUGRQDEFBGHJPUAWKVAUUOWLZMDCWMVLMDCXAVLZYIXSMWMWNZMBYIUUDWOVLW
      PYTUUIYHUUGVQZUUEVFUUFYHUUGUUEWQYTUVDUUCUUEYTUVDUUDYBVQZVDUUCUUDYBWRYTUVE
      UUBAUVEUUBVTYSAUVEHYBVQZUUBAYOUVEUVFVTYRHYBMWSVAHILWTXBWEXCXDXEXDXFYTUUBX
      RJUNUMUQZUUEJUQUUFXRUQAUVGYSAUUAKJUNUMUQYQUVGUDUILUUAKJOTXJVLWEYTUUEHYIVF
      ZJYTUUKUUEUVHVTUVCHYIMXGVAYTYDYIDUQZUVHJUQAYDYSUBWEAYSUVIUUKAYCUUTYSUVIUU
      KVRXKYEUVAMYIDXHVLXIYIDHJXLVLXMUUEUUBXRJXNVLXMXOAXRLWGWAUQZUUPYFYGYLVRXKA
      KOWGWAUQZYQUVJAKUPUQUVKUEKOTWHWIUILKOXAVLUVBUKYBXRXSLMXPVLXQWL $.
  $}

  ${
    $d b c d f g h k m s u v w x y z F $.  $d a b f g m n r t u v w x y z ph $.
    $d a t v x A $.  $d a b c d k r s u x y z M $.  $d b f m t u v w x y z S $.
    $d b c d f g k m s u v w x y z J $.  $d b c d s u v T $.  $d m n u w z U $.
    $d a b c f g h k m t u v w x y z G $.  $d m n u w V $.  $d c d m n u v W $.
    $d b c f u v w x y z H $.  $d a b c d f k m t u v w x y z X $.  $d z Z $.
    $d a b c d f g h k m r s t u v w x y z C $.  $d f g h k u v x y z P $.
    $d b c d v w x y z B $.  $d a b c d f k m t u v w x y z Y $.
    cvmlift2.b $e |- B = U. C $.
    cvmlift2.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmlift2.g $e |- ( ph -> G e. ( ( II tX II ) Cn J ) ) $.
    cvmlift2.p $e |- ( ph -> P e. B ) $.
    cvmlift2.i $e |- ( ph -> ( F ` P ) = ( 0 G 0 ) ) $.
    ${
      cvmlift2.h $e |- H = ( iota_ f e. ( II Cn C )
      ( ( F o. f ) = ( z e. ( 0 [,] 1 ) |-> ( z G 0 ) ) /\ ( f ` 0 ) = P ) ) $.
      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      cvmlift2lem2 $p |- ( ph -> ( H e. ( II Cn C ) /\
        ( F o. H ) = ( z e. ( 0 [,] 1 ) |-> ( z G 0 ) ) /\ ( H ` 0 ) = P ) ) $=
        ( cc0 co cii cfv c1 cicc cv cmpt ctopon wcel iitopon a1i cnmptid cnmptc
        0elunit cnmpt12f wceq oveq1 eqid ovex fvmpt ax-mp syl6eqr cvmliftiota )
        ACDEFGBQUAUBRZBUCZQHRZUDZIJKPLABVBQHSSSJVASVAUETUFAUGUHZABSVAVEUIABQSSV
        AVAVEVEQVAUFZAUKUHUJMULNAEGTQQHRZQVDTZOVFVHVGUMUKBQVCVGVAVDVBQQHUNVDUOQ
        QHUPUQURUSUT $.

      ${
        cvmlift2lem3.1 $e |- K = ( iota_ f e. ( II Cn C ) ( ( F o. f ) =
     ( z e. ( 0 [,] 1 ) |-> ( X G z ) ) /\ ( f ` 0 ) = ( H ` X ) ) ) $.
        $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
           7-May-2015.) $)
        cvmlift2lem3 $p |- ( ( ph /\ X e. ( 0 [,] 1 ) ) ->
      ( K e. ( II Cn C ) /\ ( F o. K ) = ( z e. ( 0 [,] 1 ) |-> ( X G z ) ) /\
        ( K ` 0 ) = ( H ` X ) ) ) $=
          ( cii cc0 c1 cicc co wcel wa cv cmpt ccvm adantr ctopon iitopon simpr
          cfv a1i cnmptc cnmptid ctx ccn cnmpt12f ccom wceq cvmlift2lem2 simp1d
          wf iiuni cnf syl ffvelrnda 0elunit oveq2 eqid ovex mp1i simp2d fveq1d
          fvmpt oveq1 sylan9eq fvco3 sylan 3eqtr2rd cvmliftiota ) ALUAUBUCUDZUE
          ZUFZCDLIUNZFGBWDLBUGZHUDZUHZKJMSAGDJUIUDUEWENUJWFBLWHHTTTJWDTWDUKUNUE
          WFULUOZWFBLTTWDWDWKWKAWEUMUPWFBTWDWKUQAHTTURUDJUSUDUEWEOUJUTAWDCLIAIT
          DUSUDUEZWDCIVEZAWLGIVAZBWDWHUAHUDZUHZVBZUAIUNEVBZABCDEFGHIJMNOPQRVCZV
          DITDWDCVFMVGVHZVIWFUAWJUNZLUAHUDZLWNUNZWGGUNZUAWDUEXAXBVBWFVJBUAWIXBW
          DWJWHUALHVKWJVLLUAHVMZVQVNAWEXCLWPUNXBALWNWPAWLWQWRWSVOVPBLWOXBWDWPWH
          LUAHVRWPVLXEVQVSAWMWEXCXDVBWTWDCLGIVTWAWBWC $.
      $}

      $d a b c d f g m n r t u v w x y z K $.
      cvmlift2.k $e |- K = ( x e. ( 0 [,] 1 ) , y e. ( 0 [,] 1 ) |->
          ( ( iota_ f e. ( II Cn C ) ( ( F o. f ) =
     ( z e. ( 0 [,] 1 ) |-> ( x G z ) ) /\ ( f ` 0 ) = ( H ` x ) ) ) ` y ) ) $.
      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         1-Jun-2015.) $)
      cvmlift2lem4 $p |- ( ( X e. ( 0 [,] 1 ) /\ Y e. ( 0 [,] 1 ) ) ->
      ( X K Y ) = ( ( iota_ f e. ( II Cn C ) ( ( F o. f ) =
     ( z e. ( 0 [,] 1 ) |-> ( X G z ) ) /\ ( f ` 0 ) = ( H ` X ) ) ) ` Y ) ) $=
        ( cc0 c1 cicc co cv ccom cmpt wceq cfv wa cii ccn oveq1 mpteq2dv eqeq2d
        crio fveq2 anbi12d riotabidv fveq1d fvex ovmpt2 ) BCNOUCUDUEUFZVECUGZIH
        UGZUHZDVEBUGZDUGZJUFZUIZUJZUCVGUKZVIKUKZUJZULZHUMFUNUFZURZUKOVHDVENVJJU
        FZUIZUJZVNNKUKZUJZULZHVRURZUKMVFWFUKVINUJZVFVSWFWGVQWEHVRWGVMWBVPWDWGVL
        WAVHWGDVEVKVTVINVJJUOUPUQWGVOWCVNVINKUSUQUTVAVBVFOWFUSUBOWFVCVD $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      cvmlift2lem5 $p |- ( ph -> K : ( ( 0 [,] 1 ) X. ( 0 [,] 1 ) ) --> B ) $=
        ( cv ccom cc0 c1 cicc co cmpt wceq cfv wa cii ccn crio wcel wral cxp wf
        w3a eqid cvmlift2lem3 adantrr simp1d cnf syl simprr ffvelrnd ralrimivva
        iiuni fmpt2 sylib ) ACUAZIHUAZUBDUCUDUEUFZBUAZDUAJUFUGZUHUCVLUIVNKUIZUH
        UJHUKFULUFZUMZUIZEUNZCVMUOBVMUOVMVMUPEMUQAVTBCVMVMAVNVMUNZVKVMUNZUJUJZV
        MEVKVRWCVRVQUNZVMEVRUQWCWDIVRUBVOUHZUCVRUIVPUHZAWAWDWEWFURWBADEFGHIJKLV
        RVNNOPQRSVRUSUTVAVBVRUKFVMEVHNVCVDAWAWBVEVFVGBCVMVMVSEMTVIVJ $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      cvmlift2lem6 $p |- ( ( ph /\ X e. ( 0 [,] 1 ) ) ->
        ( K |` ( { X } X. ( 0 [,] 1 ) ) ) e.
          ( ( ( II tX II ) |`t ( { X } X. ( 0 [,] 1 ) ) ) Cn C ) ) $=
        ( vu vv cc0 c1 cicc co wcel wa csn cxp cres ccom cmpt wceq cfv cii crio
        cv ccn cmpt2 ctx crest wfn wf cvmlift2lem5 adantr ffn syl sylib reseq1d
        fnov wss simpr snssd ssid resmpt2 sylancl w3a elsni oveq1d simp1r simp3
        3ad2ant2 cvmlift2lem4 syl2anc eqtrd mpt2eq3dva eqid ctopon a1i cnmpt2nd
        iitopon cvmlift2lem3 simp1d cnmpt21f cnmpt2res ctop cvv iitop snex ovex
        txrest mp4an oveq1i syl6eleqr eqeltrd ) ANUDUEUFUGZUHZUIZMNUJZXHUKZULZU
        BUCXKXHUCUSZIHUSZUMDXHNDUSJUGUNZUOUDXOUPNKUPZUOUIHUQFUTUGZURZUPZVAZUQUQ
        VBUGXLVCUGZFUTUGZXJXMUBUCXHXHUBUSZXNMUGZVAZXLULZYAXJMYFXLXJMXHXHUKZVDZM
        YFUOXJYHEMVEZYIAYJXIABCDEFGHIJKLMOPQRSTUAVFVGYHEMVHVIUBUCXHXHMVLVJVKXJY
        GUBUCXKXHYEVAZYAXJXKXHVMXHXHVMZYGYKUOXJNXHAXIVNVOZXHVPZUBUCXHXHXKXHYEVQ
        VRXJUBUCXKXHYEXTXJYDXKUHZXNXHUHZVSZYENXNMUGZXTYQYDNXNMYOXJYDNUOYPYDNVTW
        DWAYQXIYPYRXTUOAXIYOYPWBXJYOYPWCABCDEFGHIJKLMNXNOPQRSTUAWEWFWGWHWGWGXJY
        AUQXKVCUGZUQXHVCUGZVBUGZFUTUGYCXJUBUCXTUQYSFUQYTXHXHXKXHYSWIUQXHWJUPUHX
        JWMWKZYMYTWIUUBYLXJYNWKXJUBUCXNXSUQUQUQFXHXHUUBUUBXJUBUCUQUQXHXHUUBUUBW
        LXJXSXRUHIXSUMXPUOUDXSUPXQUOADEFGHIJKLXSNOPQRSTXSWIWNWOWPWQYBUUAFUTUQWR
        UHZUUCXKWSUHXHWSUHYBUUAUOWTWTNXAUDUEUFXBXKXHUQUQWRWRWSWSXCXDXEXFXG $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      cvmlift2lem7 $p |- ( ph -> ( F o. K ) = G ) $=
        ( vw cc0 c1 cicc co cv ccom cmpt wceq cfv wa cii ccn crio wcel w3a eqid
        cmpt2 cvmlift2lem3 adantrr simp2d fveq1d wf simp1d iiuni cnf syl simprr
        fvco3 syl2anc oveq2 ovex fvmpt 3impb mpt2eq3dva ffvelrnd a1i cuni cvmcn
        3eqtr3d ccvm 3syl feqmptd fveq2 fmpt2co cxp wfn iitop txunii fnov sylib
        ctx ffn 3eqtr4d ) ABCUBUCUDUEZWOCUFZIHUFZUGDWOBUFZDUFZJUEZUHZUIUBWQUJWR
        KUJZUIUKHULFUMUEZUNZUJZIUJZURBCWOWOWRWPJUEZURZIMUGJABCWOWOXFXGAWRWOUOZW
        PWOUOZXFXGUIAXIXJUKUKZWPIXDUGZUJZWPXAUJZXFXGXKWPXLXAXKXDXCUOZXLXAUIZUBX
        DUJXBUIZAXIXOXPXQUPXJADEFGHIJKLXDWRNOPQRSXDUQUSUTZVAVBXKWOEXDVCZXJXMXFU
        IXKXOXSXKXOXPXQXRVDXDULFWOEVENVFVGZAXIXJVHZWOEWPIXDVIVJXKXJXNXGUIYADWPW
        TXGWOXAWSWPWRJVKXAUQWRWPJVLVMVGVTVNVOABCUAWOWOEXEUAUFZIUJXFMIXKWOEWPXDX
        TYAVPMBCWOWOXEURUIATVQAUAELVRZIAIFLWAUEUOIFLUMUEUOEYCIVCOFILVSIFLEYCNYC
        UQZVFWBWCYBXEIWDWEAJWOWOWFZWGZJXHUIAJULULWLUEZLUMUEUOYEYCJVCYFPJYGLYEYC
        ULULWOWOWHWHVEVEWIYDVFYEYCJWMWBBCWOWOJWJWKWN $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         9-Mar-2015.) $)
      cvmlift2lem8 $p |- ( ( ph /\ X e. ( 0 [,] 1 ) ) ->
          ( X K 0 ) = ( H ` X ) ) $=
        ( cc0 c1 cicc co wcel wa ccom cmpt wceq cfv cii crio simpr cvmlift2lem4
        cv ccn 0elunit sylancl eqid cvmlift2lem3 simp3d eqtrd ) ANUBUCUDUEZUFZU
        GZNUBMUEZUBIHUPZUHDVDNDUPJUEUIZUJUBVHUKNKUKZUJUGHULFUQUEZUMZUKZVJVFVEUB
        VDUFVGVMUJAVEUNURABCDEFGHIJKLMNUBOPQRSTUAUOUSVFVLVKUFIVLUHVIUJVMVJUJADE
        FGHIJKLVLNOPQRSTVLUTVAVBVC $.

      ${
        $d a S $.
        cvmlift2lem10.s $e |- S = ( k e. J |->
          { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
            A. c e. s ( A. d e. ( s \ { c } ) ( c i^i d ) = (/) /\
               ( F |` c ) e. ( ( C |`t c ) Homeo ( J |`t k ) ) ) ) } ) $.
        ${
          cvmlift2lem9.1 $e |- ( ph -> ( X G Y ) e. M ) $.
          cvmlift2lem9.2 $e |- ( ph -> T e. ( S ` M ) ) $.
          cvmlift2lem9.3 $e |- ( ph -> U e. II ) $.
          cvmlift2lem9.4 $e |- ( ph -> V e. II ) $.
          cvmlift2lem9.5 $e |- ( ph -> ( II |`t U ) e. Con ) $.
          cvmlift2lem9.6 $e |- ( ph -> ( II |`t V ) e. Con ) $.
          cvmlift2lem9.7 $e |- ( ph -> X e. U ) $.
          cvmlift2lem9.8 $e |- ( ph -> Y e. V ) $.
          cvmlift2lem9.9 $e |- ( ph -> ( U X. V ) C_ ( `' G " M ) ) $.
          cvmlift2lem9.10 $e |- ( ph -> Z e. V ) $.
          cvmlift2lem9.11 $e |- ( ph -> ( K |` ( U X. { Z } ) ) e.
            ( ( ( II tX II ) |`t ( U X. { Z } ) ) Cn C ) ) $.
          cvmlift2lem9.w $e |- W = ( iota_ b e. T ( X K Y ) e. b ) $.
          $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
             1-Jun-2015.) $)
          cvmlift2lem9 $p |- ( ph ->
           ( K |` ( U X. V ) ) e. ( ( ( II tX II ) |`t ( U X. V ) ) Cn C ) ) $=
            ( vm vn cii ctx co cxp cop cc0 iitop iiuni ccn eqeltrd ctop a1i wss
            wcel cuni elssuni syl sseldd opelxpi syl2anc wa cfv fovrnd wf df-ov
            wceq sylib cima csn cres snidg ovres ccnv eqid ccon cvv snex adantr
            crest txrest syl22anc cpw iitopon restsn2 sylancr cpr pwsn indiscon
            c0 eqeltri syl6eqel txcon xpss2 snssd xpss1 restuni sseqtrd syl3anc
            crn wb df-ima imass2 syl5eqr mpbird sstrd syl5eqssr cnrest2 eleqtrd
            mpbid concn feq2d cicc txunii cvmlift2lem5 ccom cvmlift2lem7 txtopi
            syl6sseqr ccvm fvco3 fveq1d eqtr3d fveq2i 3eqtr4g cvmsiota syl13anc
            c1 eleq1i anbi2i xpss12 cv wral ad2antrl simprr ctopon cvmlift2lem6
            sselda adantrr syldan cnrest resabs1 restabs oveq1d 3eltr3d cvmtop1
            ovex xpex toptopon simprl imaco cnvco cnveqd sseqtr4d wfun cdm ffun
            imaeq1d fdm funimass3 cnvimass cvmcn syl5sseq cvmsss simpld cvmsuni
            cvmsrcl cnima restopn2 mpbir2and ccld cvmscld eqtr4d mpdan eqeltrrd
            cnf simprd ralrimivva funimassov cvmlift2lem9a ) AREFHILMQPVJVJVKVL
            ZJSVMZTUAUBVNZVOUUPUUAVLZUXLVMZUDUFUGUHVJVJUXLUXLVPVPVQVQUUBZUOUIAB
            CDEFGKMNOPQUHUIUJUKULUMUNUUCZAMQUUDZNUXIPVRVLABCDEFGKMNOPQUHUIUJUKU
            LUMUNUUEZUJVSUXIVTWCZAVJVJVPVPUUFZWAZAUAUXLWCZUBUXLWCUXKUXMWCZAJUXL
            UAAJVJWCZJUXLWBZURUYCJVJWDZUXLJVJWEVQUUGWFZVBWGZASUXLUBASVJWCZSUXLW
            BZUSUYHSUYEUXLSVJWEVQUUGWFZVCWGZUAUBUXLUXLWHWIZUQATIWCZUAUBQVLZTWCZ
            WJZUYMUXKQWKZTWCZWJAMFPUUHVLWCZIRHWKWCZUYNEWCUYNMWKZRWCUYPUIUQAUAUB
            EUXLUXLQUXOUYGUYKWLAVUAUAUBNVLZRAUYQMWKZUXKNWKZVUAVUBAUXKUXPWKZVUCV
            UDAUXMEQWMZUYBVUEVUCWOUXOUYLUXMEUXKMQUUIWIAUXKUXPNUXQUUJUUKUYNUYQMU
            AUBQWNZUULUAUBNWNUUMUPVSUEUGUFUYNEFHIRLMPTUDUOUHVGUUNUUOZUYOUYRUYMU
            YNUYQTVUGUUQUURWPAUYDUYIUXJUXMWBUYFUYJJUXLSUXLUUSWIZAQUXJWQZTWBZVHU
            UTZVIUUTZQVLZTWCZVISUVAVHJUVAZAVUOVHVIJSAVULJWCZVUMSWCZWJZWJZVULVUM
            QVULWRZSVMZWSZVLZVUNTVUTVULVVAWCZVURVVDVUNWOVUQVVEAVURVULJWTUVBZAVU
            QVURUVCZVULVUMVVASQXAWIVUTVULVUMTVVASVVCVUTVVBTVVCWMUXIVVBXHVLZWDZT
            VVCWMVUTVULUCVNZTVVCVVHFMXBZRWQZXHVLZVVIVVIXCVUTVVHVJVVAXHVLZVJSXHV
            LZVKVLZXDVUTVJVTWCZVVQVVAXEWCZUYHVVHVVPWOVVQVUTVPWAZVVSVVRVUTVULXFZ
            WAAUYHVUSUSXGVVASVJVJVTVTXEVJXIXJVUTVVNXDWCVVOXDWCZVVPXDWCVUTVVNVVA
            XKZXDVUTVJUXLUVDWKWCZVULUXLWCZVVNVWBWOXLAVUQVWDVURAJUXLVULUYFUVFUVG
            ZVULVJUXLXMXNVWBXRVVAXOXDVULXPVVAXQXSXTAVWAVUSVAXGVVNVVOYAWIVSVUTVV
            CVVHFVRVLZWCZVVCVVHVVMVRVLWCZVUTQVVAUXLVMZWSZVVBWSZUXIVWIXHVLZVVBXH
            VLZFVRVLZVVCVWFVUTVWJVWLFVRVLWCZVVBVWLWDZWBVWKVWNWCAVUSVWDVWOVWEABC
            DEFGKMNOPQVULUHUIUJUKULUMUNUVEUVHVUTVVBVWIVWPVUTUYIVVBVWIWBZAUYIVUS
            UYJXGSUXLVVAYBWFZVUTUXRVWIUXMWBZVWIVWPWOUXSVUTVVAUXLWBVWSVUTVULUXLV
            WEYCVVAUXLUXLYDWFZVWIUXIUXMUXNYEXNYFVVBVWJVWLFVWPVWPXCUVIWIVUTVWQVW
            KVVCWOVWRQVVBVWIUVJWFVUTVWMVVHFVRVUTUXRVWQVWIXEWCZVWMVVHWOUXRVUTUXS
            WAVWRVXAVUTVVAUXLVVTVOUUPUUAUVOZUVPWAVVBVWIUXIVTXEUVKYGUVLUVMVUTFEU
            VDWKWCZVVCYHZVVLWBVVLEWBZVWGVWHYIVUTFVTWCZVXCAVXFVUSAUYSVXFUIFMPUVN
            WFZXGFEUHUVQZWPVUTVXDQVVBWQZVVLQVVBYJVUTVXIVUJVVLVUTVVBUXJWBZVXIVUJ
            WBVUTVVAJWBVXJVUTVULJAVUQVURUVRZYCVVAJSYDWFVVBUXJQYKWFAVUJVVLWBZVUS
            AVXLUXJQXBZVVLWQZWBZAUXJNXBZRWQZVXNVDAVXNVXMVVKUUDZRWQVXQVXMVVKRUVS
            AVXRVXPRAVXRUXPXBVXPMQUVTAUXPNUXQUWAYLUWFYLUWBAQUWCZUXJQUWDZWBZVXLV
            XOYIAVUFVXSUXOUXMEQUWEWFZAUXJUXMVXTVUIAVUFVXTUXMWOUXOUXMEQUWGWFUWBZ
            UXJVVLQUWHWIYMZXGYNYOAVXEVUSAMUWDZVVLEMRUWIAEPWDZMWMZVYEEWOAMFPVRVL
            WCZVYGAUYSVYHUIFMPUWJWFZMFPEVYFUHVYFXCUXDWFEVYFMUWGWFUWKZXGVVLVVCVV
            HFEYPYGYRATVVMWCZVUSAVYKTFWCZTVVLWBZAIFTAUYTIFWBUQUGUFFHIRLMPUDUOUW
            LWFAUYMUYOVUHUWMZWGATIWDZVVLAUYMTVYOWBVYNTIWEWFAUYTVYOVVLWOUQUGUFFH
            IRLMPUDUOUWNWFYFAVXFVVLFWCZVYKVYLVYMWJYIVXGAVYHRPWCZVYPVYIAUYTVYQUQ
            UGUFFHIRLMPUDUOUWOWFRMFPUWPWIVVLTFUWQWIUWRZXGATVVMUWSWKWCZVUSAUYSUY
            TUYMVYSUIUQVYNUGUFTFHIRLMPUDUOUWTYGZXGVUTVVJVVBVVIVUTVVEUCSWCZVVJVV
            BWCVVFAWUAVUSVEXGZVULUCVVASWHWIVUTUXRVVBUXMWBVVBVVIWOUXSVUTVVBVWIUX
            MVWRVWTYNVVBUXIUXMUXNYEXNZYQVUTVVJVVCWKZVULUCQJUCWRZVMZWSZVLZTVUTWU
            DVULUCVVCVLZWUHVULUCVVCWNVUTWUIVULUCQVLZWUHVUTVVEWUAWUIWUJWOVVFWUBV
            ULUCVVASQXAWIVUTVUQUCWUEWCZWUHWUJWOVXKAWUKVUSAWUAWUKVEUCSWTWFZXGZVU
            LUCJWUEQXAWIUXAYLVUTVULUCTJWUEWUGAWUFTWUGWMZVUSAWUNUXIWUFXHVLZWDZTW
            UGWMAUAUCVNZTWUGWUOVVMWUPWUPXCAWUOVJJXHVLZVJWUEXHVLZVKVLZXDAVVQVVQU
            YCWUEXEWCZWUOWUTWOVVQAVPWAZWVBURWVAAUCXFWAJWUEVJVJVTVTVJXEXIXJAWURX
            DWCWUSXDWCWUTXDWCUTAWUSWUEXKZXDAVWCUCUXLWCWUSWVCWOXLASUXLUCUYJVEWGZ
            UCVJUXLXMXNWVCXRWUEXOXDUCXPWUEXQXSXTWURWUSYAWIVSAWUGWUOFVRVLWCZWUGW
            UOVVMVRVLWCZVFAVXCWUGYHZVVLWBVXEWVEWVFYIAVXFVXCVXGVXHWPZAWVGQWUFWQZ
            VVLQWUFYJAWVIVUJVVLAWUFUXJWBZWVIVUJWBAWUESWBWVJAUCSVEYCWUESJYBWFWUF
            UXJQYKWFVYDYNYOVYJVVLWUGWUOFEYPYGYRVYRVYTAWUQWUFWUPAUAJWCZWUKWUQWUF
            WCVBWULUAUCJWUEWHWIAUXRWUFUXMWBZWUFWUPWOUXSAUYDWUEUXLWBWVLUYFAUCUXL
            WVDYCJUXLWUEUXLUUSWIWUFUXIUXMUXNYEXNZYQAWUQWUGWKZUAUCQUAWRZSVMZWSZV
            LZTAWVNUAUCWUGVLZWVRUAUCWUGWNAWVSUAUCQVLZWVRAWVKWUKWVSWVTWOVBWULUAU
            CJWUEQXAWIAUAWVOWCZWUAWVRWVTWOAWVKWWAVBUAJWTWFZVEUAUCWVOSQXAWIUXAYL
            AUAUCTWVOSWVQAWVPTWVQWMUXIWVPXHVLZWDZTWVQWMAUXKTWVQWWCVVMWWDWWDXCAW
            WCVJWVOXHVLZVVOVKVLZXDAVVQVVQWVOXEWCZUYHWWCWWFWOWVBWVBWWGAUAXFZWAUS
            WVOSVJVJVTVTXEVJXIXJAWWEXDWCVWAWWFXDWCAWWEWVOXKZXDAVWCUYAWWEWWIWOXL
            UYGUAVJUXLXMXNWWIXRWVOXOXDUAXPWVOXQXSXTVAWWEVVOYAWIVSAWVQWWCFVRVLZW
            CZWVQWWCVVMVRVLWCZAQWVOUXLVMZWSZWVPWSZUXIWWMXHVLZWVPXHVLZFVRVLZWVQW
            WJAWWNWWPFVRVLWCZWVPWWPWDZWBWWOWWRWCAUYAWWSUYGABCDEFGKMNOPQUAUHUIUJ
            UKULUMUNUVEUXBAWVPWWMWWTAUYIWVPWWMWBZUYJSUXLWVOYBWFZAUXRWWMUXMWBZWW
            MWWTWOUXSAWVOUXLWBWXCAUAUXLUYGYCWVOUXLUXLYDWFWWMUXIUXMUXNYEXNYFWVPW
            WNWWPFWWTWWTXCUVIWIAWXAWWOWVQWOWXBQWVPWWMUVJWFAWWQWWCFVRAUXRWXAWWMX
            EWCZWWQWWCWOUXTWXBWXDAWVOUXLWWHVXBUVPWAWVPWWMUXIVTXEUVKYGUVLUVMAVXC
            WVQYHZVVLWBVXEWWKWWLYIWVHAWXEQWVPWQZVVLQWVPYJAWXFVUJVVLAWVPUXJWBZWX
            FVUJWBAWVOJWBWXGAUAJVBYCWVOJSYDWFZWVPUXJQYKWFVYDYNYOVYJVVLWVQWWCFEY
            PYGYRVYRVYTAUXKWVPWWDAWWAUBSWCZUXKWVPWCWWBVCUAUBWVOSWHWIAUXRWVPUXMW
            BWVPWWDWOUXSAWVPUXJUXMWXHVUIYNWVPUXIUXMUXNYEXNZYQAUXKWVQWKZUYNTAWXK
            UAUBWVQVLZUYNUAUBWVQWNAWWAWXIWXLUYNWOWWBVCUAUBWVOSQXAWIYLAUYMUYOVUH
            UXEVSYSAWVPWWDTWVQWXJYTYMWWBVEWLVSYSAWUFWUPTWUGWVMYTYMXGVXKWUMWLVSY
            SVUTVVBVVITVVCWUCYTYMVVFVVGWLUXCUXFAVXSVYAVUKVUPYIVYBVYCVHVIJSTQUXG
            WIYMUXH $.
        $}

        cvmlift2lem10.1 $e |- ( ph -> X e. ( 0 [,] 1 ) ) $.
        cvmlift2lem10.2 $e |- ( ph -> Y e. ( 0 [,] 1 ) ) $.
        $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
           1-Jun-2015.) $)
        cvmlift2lem10 $p |- ( ph -> E. u e. II E. v e. II ( X e. u /\ Y e. v /\
            ( E. w e. v ( K |` ( u X. { w } ) ) e.
              ( ( ( II tX II ) |`t ( u X. { w } ) ) Cn C ) ->
       ( K |` ( u X. v ) ) e. ( ( ( II tX II ) |`t ( u X. v ) ) Cn C ) ) ) ) $=
          ( vm vt va vb cop cfv cv wcel c0 wne wa wrex csn cxp cii ctx co crest
          cres ccn wi w3a ccvm cuni cc0 c1 cicc iitop iiuni txunii eqid cnf syl
          wf opelxpi syl2anc ffvelrnd cvmcov wex n0 ccnv cima cscon wral adantr
          wss simprl wfn wb elpreima 3syl mpbir2and cvmsrcl ad2antll cnima ctop
          ffn eltx mp2an sylib wceq eleq1 opelxp syl6bb 2rexbidv sylc iillyscon
          anbi1d rspcv clly simplrl simprll llyi syl3anc simplrr simprlr reeanv
          a1i ex simp3 reximdv mpd cpcon ccon sconpcon pconcon reximdva simprl1
          simpl2 simpr2 simprr1 xpss12 sstrd 3jcad anim12i jcad syl5bir simp3l1
          mp2and rexlimdvva simp3l2 crio simpl1l simpl1r simpld syl5eqel simprd
          df-ov simpl2l simpl2r simp3rl simp3rr simp3l3 cvmlift2lem9 rexlimdvaa
          simprr 3jca 3expia anassrs expr exlimdv syl5bi expimpd rexlimdvw ) AS
          TURZOUSZUNUTZVAZUVTKUSZVBVCZVDZUNQVEZSGUTZVAZTFUTZVAZRUWFEUTZVFVGZVLV
          HVHVIVJZUWKVKVJIVMVJVAZEUWHVERUWFUWHVGZVLUWLUWNVKVJIVMVJVAZVNZVOZFVHV
          EZGVHVEZANIQVPVJVAZUVSQVQZVAUWEUEAVRVSVTVJZUXBVGZUXAUVROAOUWLQVMVJVAZ
          UXCUXAOWGZUFOUWLQUXCUXAVHVHUXBUXBWAWAWBWBWCUXAWDZWEWFZASUXBVATUXBVAUV
          RUXCVAZULUMSTUXBUXBWHWIZWJUNUCUBIUVSKMNQUXAUAUKUXFWKWIAUWDUWSUNQAUWAU
          WCUWSUWCUOUTZUWBVAZUOWLAUWAVDZUWSUOUWBWMUXLUXKUWSUOAUWAUXKUWSAUWAUXKV
          DZVDZUWGUWIUWNOWNUVTWOZWSZVOZVHUWFVKVJZWPVAZVHUWHVKVJZWPVAZVDZVDZFVHV
          EZGVHVEZUWSUXNSUPUTZVAZTUQUTZVAZVDZUYFUYHVGZUXOWSZVDZUQVHVEUPVHVEZUYE
          UXNUVRUXOVAZDUTZUYKVAZUYLVDZUQVHVEUPVHVEZDUXOWQZUYNUXNUYOUXHUWAAUXHUX
          MUXIWRAUWAUXKWTUXNUXEOUXCXAUYOUXHUWAVDXBAUXEUXMUXGWRUXCUXAOXJUXCUVRUV
          TOXCXDXEUXNUXOUWLVAZUYTUXNUXDUVTQVAZVUAAUXDUXMUFWRUXKVUBAUWAUCUBIKUXJ
          UVTMNQUAUKXFXGUVTOUWLQXHWIVHXIVAZVUCVUAUYTXBWAWAUPUQUXOVHVHXIXIDXKXLX
          MUYSUYNDUVRUXOUYPUVRXNZUYRUYMUPUQVHVHVUDUYQUYJUYLVUDUYQUVRUYKVAUYJUYP
          UVRUYKXOSTUYFUYHXPXQYAXRYBXSUXNUYMUYEUPUQVHVHUXNUYFVHVAZUYHVHVAZVDVDZ
          UYMUYEVUGUYMVDZUWFUYFWSZUWGUXSVOZGVHVEZUWHUYHWSZUWIUYAVOZFVHVEZUYEVUH
          VHWPYCVAZVUEUYGVUKVUOVUHXTYKZUXNVUEVUFUYMYDVUGUYGUYIUYLYEGWPSUYFVHYFY
          GVUHVUOVUFUYIVUNVUPUXNVUEVUFUYMYHVUGUYGUYIUYLYIFWPTUYHVHYFYGVUKVUNVDV
          UJVUMVDZFVHVEZGVHVEVUHUYEVUJVUMGFVHVHYJVUHVURUYDGVHVUHVUQUYCFVHVUHVUQ
          UXQUYBVUHVUQUWGUWIUXPVUQUWGVNVUHVUIUWGUXSVUMUUBYKVUQUWIVNVUHVUJVULUWI
          UYAUUCYKVUHVUQUXPVUHVUQVDZUWNUYKUXOVUSVUIVULUWNUYKWSVUIUWGUXSVUMVUHUU
          AVULUWIUYAVUJVUHUUDUWFUYFUWHUYHUUEWIVUGUYJUYLVUQYHUUFYLUUGVUQUYBVNVUH
          VUJUXSVUMUYAVUIUWGUXSYMVULUWIUYAYMUUHYKUUIYNYNUUJUULYLUUMYOUXNUYDUWRG
          VHUXNUWFVHVAZVDUYCUWQFVHUXNVUTUWHVHVAZUYCUWQVNUXNVUTVVAVDZUYCUWQUXNVV
          BUYCVOZUWGUWIUWPUWGUWIUXPUYBUXNVVBUUKZUWGUWIUXPUYBUXNVVBUUNZVVCUWMUWO
          EUWHVVCUWJUWHVAZUWMVDZVDZBCDHIJKUXJUWFLMNOPQRUVTUWHSTRVJUYHVAUQUXJUUO
          ZSTUWJUAUQUBUCUDVVHAUWTAUXMVVBUYCVVGUUPZUEWFVVHAUXDVVJUFWFVVHAJHVAVVJ
          UGWFVVHAJNUSVRVROVJXNVVJUHWFUIUJUKVVHSTOVJUVSUVTSTOUVAVVHUWAUXKAUXMVV
          BUYCVVGUUQZUURUUSVVHUWAUXKVVKUUTVUTVVAUXNUYCVVGUVBVUTVVAUXNUYCVVGUVCV
          VHUXSUXRYPVAUXRYQVAVVCUXSVVGUXSUYAUXQUXNVVBUVDWRUXRYRUXRYSXDVVHUYAUXT
          YPVAUXTYQVAVVCUYAVVGUXSUYAUXQUXNVVBUVEWRUXTYRUXTYSXDVVCUWGVVGVVDWRVVC
          UWIVVGVVEWRVVCUXPVVGUWGUWIUXPUYBUXNVVBUVFWRVVCVVFUWMWTVVCVVFUWMUVIVVI
          WDUVGUVHUVJUVKUVLYTYTYOUVMUVNUVOUVPUVQYO $.
      $}

      ${
        cvmlift2.m $e |- M = { z e. ( ( 0 [,] 1 ) X. ( 0 [,] 1 ) ) |
          K e. ( ( ( II tX II ) CnP C ) ` z ) } $.
        ${
          cvmlift2lem11.1 $e |- ( ph -> U e. II ) $.
          cvmlift2lem11.2 $e |- ( ph -> V e. II ) $.
          cvmlift2lem11.3 $e |- ( ph -> Y e. V ) $.
          cvmlift2lem11.4 $e |- ( ph -> Z e. V ) $.
          cvmlift2lem11.5 $e |- ( ph -> ( E. w e. V
     ( K |` ( U X. { w } ) ) e. ( ( ( II tX II ) |`t ( U X. { w } ) ) Cn C ) ->
       ( K |` ( U X. V ) ) e. ( ( ( II tX II ) |`t ( U X. V ) ) Cn C ) ) ) $.
          $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
             1-Jun-2015.) $)
          cvmlift2lem11 $p |- ( ph ->
              ( ( U X. { Y } ) C_ M -> ( U X. { Z } ) C_ M ) ) $=
            ( csn cxp wss wa cv cii ctx ccnp cfv wcel cc0 cicc crab adantr cuni
            co c1 elssuni iiuni syl6sseqr elunii syl6eleqr syl2anc snssd xpss12
            syl cres crest ccn wrex wf wral cvmlift2lem5 sseldd fssres syl6sseq
            simpr ssrab simprbi r19.21bi ctopon iitopon txtopon mp2an toponunii
            cnpresti syl3anc ralrimiva wb resttopon sylancr ctop toptopon sylib
            ccvm cvmtop1 cncnp mpbir2and wceq sneq xpeq2d reseq2d oveq2d oveq1d
            eleq12d rspcev imp syldan xpss2 iitop txtopi restuni sseqtrd sselda
            eqid cncnpi cnt a1i txopn syl22anc isopn3i sseqtr4d ad2antrr mpbird
            cnprest ssrabdv ex ) AIRUMZUNZPUOZISUMZUNZPUOAUUBUPZUUDODUQZURURUSV
            HZGUTVHVAVBZDVCVIVDVHZUUIUNZVEZPUUEUUHDUUJUUDUUEIUUIUOZUUCUUIUOUUDU
            UJUOUUEIURVBZUULAUUMUUBUHVFZUUMIURVGZUUIIURVJVKVLVRZUUESUUIASUUIVBZ
            UUBASQVBZQURVBZUUQUKUIUURUUSUPSUUOUUISQURVMVKVNVOVFVPIUUIUUCUUIVQVO
            UUEUUFUUDVBZUPZUUHOIQUNZVSZUUFUUGUVBVTVHZGUTVHVAVBZUVAUVCUVDGWAVHVB
            ZUUFUVDVGZVBUVEUUEUVFUUTAUUBOIEUQZUMZUNZVSZUUGUVJVTVHZGWAVHZVBZEQWB
            ZUVFUUERQVBZOUUAVSZUUGUUAVTVHZGWAVHZVBZUVOAUVPUUBUJVFZUUEUVTUUAFUVQ
            WCZUVQUUFUVRGUTVHVAVBZDUUAWDZUUEUUJFOWCZUUAUUJUOZUWBAUWEUUBABCDFGHJ
            KLMNOTUAUBUCUDUEUFWEZVFUUEUULYTUUIUOUWFUUPUUERUUIUUEQUUIRUUEUUSQUUI
            UOZAUUSUUBUIVFZUUSQUUOUUIQURVJVKVLVRZUWAWFVPIUUIYTUUIVQVOZUUJFUUAOW
            GVOUUEUWCDUUAUUEUUFUUAVBZUPUWFUWLUUHUWCUUEUWFUWLUWKVFUUEUWLWIUUEUUH
            DUUAUUEUUAUUKUOZUUHDUUAWDZUUEUUAPUUKAUUBWIUGWHUWMUWFUWNUUHDUUJUUAWJ
            WKVRWLUUAUUFOUUGGUUJUUJUUGURUUIWMVAVBZUWOUUGUUJWMVAVBZWNWNURURUUIUU
            IWOWPZWQZWRWSWTUUEUVRUUAWMVAVBZGFWMVAVBZUVTUWBUWDUPXAUUEUWPUWFUWSUW
            QUWKUUAUUGUUJXBXCUUEGXDVBZUWTAUXAUUBAKGNXGVHVBUXAUAGKNXHVRVFGFTXEXF
            DUVQUVRGUUAFXIVOXJUVNUVTERQUVHRXKZUVKUVQUVMUVSUXBUVJUUAOUXBUVIYTIUV
            HRXLXMZXNUXBUVLUVRGWAUXBUVJUUAUUGVTUXCXOXPXQXRVOAUVOUVFULXSXTVFUUEU
            UDUVGUUFUUEUUDUVBUVGUUEUUCQUOUUDUVBUOUUESQAUURUUBUKVFVPUUCQIYAVRZUU
            EUUGXDVBZUVBUUJUOZUVBUVGXKURURYBYBYCZUUEUULUWHUXFUUPUWJIUUIQUUIVQVO
            ZUVBUUGUUJUWRYDXCYEYFUUFUVCUVDGUVGUVGYGYHVOUVAUXEUXFUUFUVBUUGYIVAVA
            ZVBUWEUUHUVEXAUXEUVAUXGYJUUEUXFUUTUXHVFUUEUUDUXIUUFUUEUUDUVBUXIUXDU
            UEUXEUVBUUGVBZUXIUVBXKUXGUUEURXDVBZUXKUUMUUSUXJUXKUUEYBYJZUXLUUNUWI
            IQURURXDXDYKYLUVBUUGYMXCYNYFAUWEUUBUUTUWGYOUVBUUFOUUGGUUJFUWRTYQYLY
            PYRUGVLYS $.
        $}

        $d c ph $.
        cvmlift2.a $e |- A =
          { a e. ( 0 [,] 1 ) | ( ( 0 [,] 1 ) X. { a } ) C_ M } $.
        cvmlift2.s $e |- S = { <. r , t >. |
          ( t e. ( 0 [,] 1 ) /\ E. u e. ( ( nei ` II ) ` { r } )
            ( ( u X. { a } ) C_ M <-> ( u X. { t } ) C_ M ) ) } $.
        $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
           1-Jun-2015.) $)
        cvmlift2lem12 $p |- ( ph -> K e. ( ( II tX II ) Cn C ) ) $=
          ( vv vb vw vk vs vc vd cii ctx co ccn wcel cc0 cxp ccnp cfv wral crab
          cv wss csn ciun wceq iiuni a1i cin wb wa wrex ctop iitop copab sylibr
          wel vex adantl jca df-xp mp2an cop cres crest wi w3a cuni cdif adantr
          c0 cmpt eqid simprr simprl cvmlift2lem10 simplrl simplrr syl22anc wal
          syl6eleqr syl2anr ad3antrrr sneq xpeq2d reseq2d oveq2d oveq1d eleq12d
          simpr syl5bi cvmlift2lem11 impbid syl2anc ex sseq12i ssopab2b opelxpi
          weq bitri rexlimdvva eleq1d ralrimiva sylib cvmlift2lem1 elrab2 cmpt2
          mpd syl ctopon iitopon cvv sylancr c1 cicc cvmlift2lem5 iunid xpiundi
          xpeq2i eqtr3i ccon iicon ccld inss1 cnt ccmp iicmp txtopi cnei neiss2
          mpan snss a1d rexlimiv simpl ssopab2i 3sstr4i txunii ntropn ccnv cima
          wf chmeo cpw ccvm elunii opnneip syl3anc simplr2 cbvrexv simplr3 rspe
          txopn ssntr simpr1 simpr2 sseldd opeq2 ralsn dfss3 eleq1 ralxp txtube
          alrimivv anassrs ntrss2 sstr mpan2 ralcom 3bitr2i ralimi bicom rexbii
          r2al ralbii sylbi rabeq2i baib ad3antlr elssuni sselda sseq1d bibi12d
          syl6sseqr syl5ibr ralimdva syl5 anim2d reximdva ssrab2 eqsstri sseldi
          isclo wne 0elunit wrel relxp opelxp df-3an wfn ffn fnov reseq1d snssd
          id resmpt2 simplll cvmlift2lem8 sylan syldan eqeq1d syl5ibrcom 3impia
          elsni mpt2eq3dva 3eqtrd cnmpt1st ccom cvmlift2lem2 cnmpt21f cnmpt2res
          simp1d snex txrest mp4an oveq1i eqeltrd rspcev xpss12 restuni eleqtrd
          cncnpi expcom isopn3i eleqtrrd cnprest sylibrd embantd expimpd eleq2d
          fveq2 sylanbrc opeq2d relssdv ne0i inss2 conclo syl5reqr rabid2 iunss
          syl5eqss syl6sseq ssrab simprbi txtopon cvmtop1 toptopon mpbir2and
          cncnp ) AQURURUSUTZIVAUTVBZVCUUAUUBUTZVWIVDZHQUVIZQDVIZVWGIVEUTZVFZVB
          ZDVWJVGZABCDHIJLMNOPQUAUBUCUDUEUFUGUUCZAVWJVWODVWJVHZVJZVWPAVWJRVWRAV
          WJTVWIVWITVIZVKZVDZVLZRVWITVWIVXAVLZVDVWJVXCVXDVWIVWITVWIUUDUUFTVWIVX
          AVWIUUEUUGAVXBRVJZTVWIVGZVXCRVJAVWIVXETVWIVHZVMVXFAVXGGVWIUIAGURVWIVN
          URUUHVBAUUIVOAURURUUJVFZVPZURGURVXHUUKATUKWDZVWTGVBZFVIZGVBZVQZFUKVIZ
          VGZVRZUKURVSZTVWIVGZGVXIVBZAVXRTVWIAVWTVWIVBZVRZVXJVWIVXOVDZKVWGUULVF
          ZVFZVJZVRZUKURVSVXRVYBUKVWTURURVYEVWIVWIVNVNURUUMVBVYBUUNVOURVTVBZVYB
          WAVOVYEVWGVBZVYBVWGVTVBZKVWJVJZVYIURURWAWAUUOZVXLVWIVBZEVIZVXAVDRVJZV
          YNVXLVKZVDRVJZVQZESVIZVKZURUUPVFVFZVSZVRZSFWBZVYSVWIVBZVYMVRZSFWBKVWJ
          WUCWUFSFWUCWUEVYMWUBWUEVYMVYRWUEEWUAVYNWUAVBZWUEVYRWUGVYTVWIVJZWUEVYH
          WUGWUHWAVYTURVYNVWIVNUUQUURVYSVWISWEUUSWCUUTUVAWFVYMWUBUVBWGUVCUJSFVW
          IVWIWHUVDZKVWGVWJURURVWIVWIWAWAVNVNUVEZUVFWIVOVYBULVIZUMVIZWJZVYEVBZU
          MVXAVGZULVWIVGZVXBVYEVJZVYBWUOULVWIAVYAWUKVWIVBZWUOAVYAWURVRZVRZWUKVW
          TWJZVYEVBZWUOWUTULEWDZVXJQVYNWULVKZVDZWKZVWGWVEWLUTZIVAUTZVBZUMVXOVSZ
          QVYNVXOVDZWKZVWGWVKWLUTZIVAUTVBZWMZWNZUKURVSEURVSWVBWUTBCDUMUKEHIJUNP
          UOVIZWOMUVGUNVIZUVHVMUPVIZUQVIVPWRVMUQWVQWVSVKZWPVGMWVSWKIWVSWLUTPWVR
          WLUTUVJUTVBVRUPWVQVGVRUOIUVKWRVKWPVHWSZLUNMNOPQWUKVWTUOUPUQUAAMIPUVLU
          TVBZWUSUBWQZANVWGPVAUTVBZWUSUCWQZAJHVBZWUSUDWQZAJMVFVCVCNUTVMZWUSUEWQ
          ZUFUGWWAWTZAVYAWURXAAVYAWURXBXCWUTWVPWVBEUKURURWUTVYNURVBZVXOURVBZVRZ
          VRZWVPWVBWWNWVPVRZWVKVYEWVAWWOVYJVYKWVKVWGVBZWVKKVJZWVKVYEVJVYJWWOVYL
          VOVYKWWOWUIVOWWOVYHVYHWWKWWLWWPVYHWWOWAVOZWWRWUTWWKWWLWVPXDZWUTWWKWWL
          WVPXEZVYNVXOURURVTVTUVTZXFWWOSEWDZFUKWDZVRZWUCWMZFXGSXGZWWQWWOWXESFWW
          OWXDWUCWWOWXDVRZVYMWUBWXDWXCWWLVYMWWOWXBWXCXQWWTWXCWWLVRVXLURWOZVWIVX
          LVXOURUVMVNXHXIWXGWUGVYRWUBWXGVYHWWKWXBWUGVYHWXGWAVOWWOWWKWXDWWSWQZWW
          OWXBWXCXBVYSURVYNUVNUVOWXGVYOVYQWXGBCDUPHIJVYNLMNOPQRVXOVWTVXLUAWUTWW
          BWWMWVPWXDWWCXJZWUTWWDWWMWVPWXDWWEXJZWUTWWFWWMWVPWXDWWGXJZWUTWWHWWMWV
          PWXDWWIXJZUFUGUHWXIWWOWWLWXDWWTWQZWVCVXJWVOWWNWXDUVPZWWOWXBWXCXAZQVYN
          WVTVDZWKZVWGWXQWLUTZIVAUTZVBZUPVXOVSWVJWXGWVNWYAWVIUPUMVXOUPUMYFZWXRW
          VFWXTWVHWYBWXQWVEQWYBWVTWVDVYNWVSWULXKXLZXMWYBWXSWVGIVAWYBWXQWVEVWGWL
          WYCXNXOXPUVQWVCVXJWVOWWNWXDUVRXRZXSWXGBCDUPHIJVYNLMNOPQRVXOVXLVWTUAWX
          JWXKWXLWXMUFUGUHWXIWXNWXPWXOWYDXSXTVYREWUAUVSYAWGYBUWKWWQWXDSFWBZWUDV
          JWXFWVKWYEKWUDSFVYNVXOWHUJYCWXDWUCSFYDYGWCKVWGWVKVWJWUJUWAXFWWOWVCVXJ
          WVAWVKVBWWNWVCVXJWVOUWBWWNWVCVXJWVOUWCWUKVWTVYNVXOYEYAUWDYBYHYOWUNWVB
          UMVWTTWEUMTYFWUMWVAVYEWULVWTWUKUWEYIUWFWCUWLYJWUQVYNVYEVBZEVXBVGWUPEV
          XBVYEUWGWYFWUNEULUMVWIVXAVYNWUMVYEUWHUWIYGWCAVYAXQUWJVYBVYGVXQUKURVYB
          WWLVRZVYFVXPVXJVYFWUCSVWIVGZFVXOVGZWYGVXPVYFVYCKVJZWYIVYFVYEKVJZWYJVY
          JVYKWYKVYLWUIKVWGVWJWUJUWMWIVYCVYEKUWNUWOWYJWUEWXCVRZSFWBZWUDVJZWYIVY
          CWYMKWUDSFVWIVXOWHUJYCWYNWYLWUCWMFXGSXGWUCFVXOVGSVWIVGWYIWYLWUCSFYDWU
          CSFVWIVXOUXAWUCSFVWIVXOUWPUWQYGYKWYGWYHVXNFVXOWYHVXNWYGWXCVRZVXEVWIVY
          PVDZRVJZVQZWYHWUBSVWIVGZWYRWUCWUBSVWIVYMWUBXQUWRWYSVXEWYQTSEFRYLWYSVY
          QVYOVQZEWUAVSZSVWIVGWYQVXEWMWUBXUASVWIVYRWYTEWUAVYOVYQUWSUWTUXBFSETRY
          LUXCXTYPWYOVXKVXEVXMWYQVYAVXKVXEVQAWWLWXCVXKVYAVXEVXETGVWIUIUXDUXEUXF
          WYOVYMVXMWYQVQWYGVXOVWIVXLWWLVXOVWIVJZVYBWWLVXOWXHVWIVXOURUXGVNUXKZWF
          UXHVXMVYMWYQVXEWYQTVXLVWIGTFYFZVXBWYPRXUDVXAVYPVWIVWTVXLXKXLUXIUIYMUX
          EYPUXJUXLUXMUXNUXOUXPYOYJVYHGVWIVJVXTVXSVQWAGVXGVWIUIVXETVWIUXQUXRTUK
          FGURVWIVNUXTWIWCZUXSAVCGVBZGWRUYAAVCVWIVBZVWIVCVKZVDZRVJZXUFXUGAUYBVO
          ZASTXUIRXUIUYCAVWIXUHUYDVOVYSVWTWJZXUIVBWUEVWTXUHVBZVRAXULRVBZVYSVWTV
          WIXUHUYEAWUEXUMXUNAWUEVRZXUNXUMVYSVCWJZRVBZXUOXUPVWJVBZQXUPVWMVFZVBZX
          UQWUEWUEXUGXURAWUEUYLXUKVYSVCVWIVWIYEXIXUOWXBVCVXOVBZWVOWNZUKURVSEURV
          SXUTXUOBCDUMUKEHIJWWALUNMNOPQVYSVCUOUPUQUAAWWBWUEUBWQAWWDWUEUCWQAWWFW
          UEUDWQAWWHWUEUEWQUFUGWWJAWUEXQXUGXUOUYBVOXCXUOXVBXUTEUKURURXVBWXBXVAV
          RZWVOVRXUOWWMVRZXUTWXBXVAWVOUYFXVDXVCWVOXUTXVDXVCVRZWVJWVNXUTXVEXVAQV
          YNXUHVDZWKZVWGXVFWLUTZIVAUTZVBZWVJXVDWXBXVAXAXVEXVGULUMVYNXUHWUKOVFZY
          NZXVIXVEXVGULUMVWIVWIWUKWULQUTZYNZXVFWKZULUMVYNXUHXVMYNZXVLXVEQXVNXVF
          XVEQVWJUYGZQXVNVMXVEVWKXVQAVWKWUEWWMXVCVWQXJZVWJHQUYHYPULUMVWIVWIQUYI
          YKUYJXVEVYNVWIVJZXUHVWIVJZXVOXVPVMXVEWWKXVSXUOWWKWWLXVCXDZWWKVYNWXHVW
          IVYNURUXGVNUXKYPZAXVTWUEWWMXVCAVCVWIXUKUYKXJZULUMVWIVWIVYNXUHXVMUYMYA
          XVEULUMVYNXUHXVMXVKXVEWVCWULXUHVBZXVMXVKVMZXVEWVCVRXWEXWDWUKVCQUTZXVK
          VMZXVEWVCWURXWGXVEVYNVWIWUKXWBUXHXVEAWURXWGAWUEWWMXVCUYNZABCDHIJLMNOP
          QWUKUAUBUCUDUEUFUGUYOUYPUYQXWDXVMXWFXVKXWDWULVCWUKQWULVCVUAXNUYRUYSUY
          TVUBVUCXVEXVLURVYNWLUTZURXUHWLUTZUSUTZIVAUTXVIXVEULUMXVKURXWIIURXWJXU
          HVWIVYNVWIXWIWTURVWIYQVFVBZXVEYRVOZXWBXWJWTXWMXWCXVEULUMWUKOURURURIVW
          IVWIXWMXWMXVEULUMURURVWIVWIXWMXWMVUDXVEAOURIVAUTVBZXWHAXWNMOVUEDVWIVW
          LVCNUTWSVMVCOVFJVMADHIJLMNOPUAUBUCUDUEUFVUFVUIYPVUGVUHXVHXWKIVAVYHVYH
          VYNYSVBXUHYSVBXVHXWKVMWAWAEWEVCVUJVYNXUHURURVTVTYSYSVUKVULVUMXHVUNWVI
          XVJUMVCVXOWULVCVMZWVFXVGWVHXVIXWOWVEXVFQXWOWVDXUHVYNWULVCXKXLZXMXWOWV
          GXVHIVAXWOWVEXVFVWGWLXWPXNXOXPVUOYAXVEWVNWVLXUPWVMIVEUTVFVBZXUTXVEXUP
          WVMWOZVBZWVNXWQWMXVEXUPWVKXWRXVCXUPWVKVBXVDVYSVCVYNVXOYEWFZXVEVYJWVKV
          WJVJZWVKXWRVMVYLXVEXVSXUBXXAXWBXVEWWLXUBXUOWWKWWLXVCXEZXUCYPVYNVWIVXO
          VWIVUPYAZWVKVWGVWJWUJVUQYTVURWVNXWSXWQXUPWVLWVMIXWRXWRWTVUSVUTYPXVEVY
          JXXAXUPWVKVYDVFZVBVWKXUTXWQVQVYJXVEVYLVOXXCXVEXUPWVKXXDXWTXVEVYJWWPXX
          DWVKVMVYLXVEVYHVYHWWKWWLWWPVYHXVEWAVOZXXEXWAXXBWXAXFWVKVWGVVAYTVVBXVR
          WVKXUPQVWGIVWJHWUJUAVVCXFVVDVVEVVFXRYHYOVWOXUTDXUPVWJRVWLXUPVMVWNXUSQ
          VWLXUPVWMVVHVVGUHYMVVIXUMXULXUPRXUMVWTVCVYSVWTVCVUAVVJYIUYSVVFXRVVKVX
          EXUJTVCVWIGVWTVCVMZVXBXUIRXXFVXAXUHVWIVWTVCXKXLUXIUIYMVVIGVCVVLYPAVXI
          VXHGURVXHVVMXUEUXSVVNVVOVXETVWIVVPYKTVWIVXBRVVQWCVVRUHVVSVWSVWJVWJVJV
          WPVWODVWJVWJVVTVWAYPAVWGVWJYQVFVBZIHYQVFVBZVWHVWKVWPVRVQXWLXWLXXGYRYR
          URURVWIVWIVWBWIAIVTVBZXXHAWWBXXIUBIMPVWCYPIHUAVWDYKDQVWGIVWJHVWFYTVWE
          $.
      $}

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      cvmlift2lem13 $p |- ( ph -> E! g e. ( ( II tX II ) Cn C )
        ( ( F o. g ) = G /\ ( 0 g 0 ) = P ) ) $=
        ( vu vt va vd vv vb vc vr cv ccom wceq cc0 co wa cii ctx wrex wrmo wreu
        ccn wcel c1 cicc csn cxp ccnp cfv crab wss cnei copab weq fveq2 cbvrabv
        wb eleq2d xpeq2d sseq1d simpr eleq1d xpeq1 bibi12d cbvrexv simpl fveq2d
        sneq sneqd bibi2d rexeqbidv anbi12d cbvopabv cvmlift2lem12 cvmlift2lem7
        syl5bb 0elunit cvmlift2lem8 mpan2 cmpt cvmlift2lem2 simp3d eqtrd eqeq1d
        coeq2 oveq rspcev syl12anc cop iitop iiuni txunii iicon txcon mp2an a1i
        ccon cnlly iinllycon txnlly df-ov syl6eq cvmliftmo eqeq1i anbi2i rmobii
        opelxpi sylibr reu5 sylanbrc ) AJIUJZUKZKULZUMUMYJUNZGULZUOZIUPUPUQUNZF
        VAUNZURZYOIYQUSZYOIYQUTANYQVBJNUKZKULZUMUMNUNZGULZYRABCDUBUCUMVCVDUNZDU
        JZVEZVFZNUDUJZYPFVGUNZVHZVBZUDUUDUUDVFZVIZVJZDUUDVIEFGUEUJZUUDVBZUFUJZU
        GUJZVEZVFZUUMVJZUUQUUOVEZVFZUUMVJZVPZUFUHUJZVEZUPVKVHZVHZURZUOZUHUEVLHJ
        KLMNUUMUIUGOPQRSTUAUUKNUUEUUIVHZVBUDDUULUDDVMUUJUVLNUUHUUEUUIVNVQVOUUNU
        UDUUSVFZUUMVJDUGUUDDUGVMZUUGUVMUUMUVNUUFUUSUUDUUEUURWGVRVSVOUVKUCUJZUUD
        VBZUBUJZUUSVFZUUMVJZUVQUVOVEZVFZUUMVJZVPZUBUIUJZVEZUVHVHZURZUOUHUEUIUCU
        HUIVMZUEUCVMZUOZUUPUVPUVJUWGUWJUUOUVOUUDUWHUWIVTZWAUVJUVSUVQUVBVFZUUMVJ
        ZVPZUBUVIURUWJUWGUVEUWNUFUBUVIUFUBVMZUVAUVSUVDUWMUWOUUTUVRUUMUUQUVQUUSW
        BVSUWOUVCUWLUUMUUQUVQUVBWBVSWCWDUWJUWNUWCUBUVIUWFUWJUVGUWEUVHUWJUVFUWDU
        WHUWIWEWHWFUWJUWMUWBUVSUWJUWLUWAUUMUWJUVBUVTUVQUWJUUOUVOUWKWHVRVSWIWJWO
        WKWLWMABCDEFGHJKLMNOPQRSTUAWNAUUBUMLVHZGAUMUUDVBZUUBUWPULWPABCDEFGHJKLM
        NUMOPQRSTUAWQWRALUPFVAUNVBJLUKDUUDUUEUMKUNWSULUWPGULADEFGHJKLMOPQRSTWTX
        AXBYOUUAUUCUOINYQYJNULZYLUUAYNUUCUWRYKYTKYJNJXDXCUWRYMUUBGUMUMYJNXEXCWK
        XFXGAYLUMUMXHZYJVHZGULZUOZIYQUSYSAEFGIJKMYPUWSUULOUPUPUUDUUDXIXIXJXJXKP
        YPXPVBZAUPXPVBZUXDUXCXLXLUPUPXMXNXOYPXPXQZVBZAUPUXEVBZUXGUXFXRXRXPUPUPB
        CBUJCUJXMXSXNXOUWSUULVBZAUWQUWQUXHWPWPUMUMUUDUUDYFXNXOQRAGJVHUMUMKUNUWS
        KVHSUMUMKXTYAYBYOUXBIYQYNUXAYLYMUWTGUMUMYJXTYCYDYEYGYOIYQYHYI $.
    $}

    $( A two-dimensional version of ~ cvmlift .  There is a unique lift of
       functions on the unit square ` II tX II ` which commutes with the
       covering map.  (Contributed by Mario Carneiro, 1-Jun-2015.) $)
    cvmlift2 $p |- ( ph -> E! f e. ( ( II tX II ) Cn C )
      ( ( F o. f ) = G /\ ( 0 f 0 ) = P ) ) $=
      ( vz vg cv cc0 co wceq cfv vx vy vh vw vu vv vk ccom c1 cicc cmpt cii ccn
      crio cmpt2 coeq2 oveq1 cbvmptv a1i eqeq12d fveq1 eqeq1d anbi12d cbvriotav
      wa oveq2 mpteq2dv eqeq2d riotabidv syl5eq fveq1d cbvmpt2v cvmlift2lem13
      fveq2 ) AUAUBNBCDOEFGFUCPZUHZUDQUIUJRZUDPZQGRZUKZSZQVOTZDSZVEZUCULCUMRZUN
      ZHUEUFVQVQUFPZFUGPZUHZUDVQUEPZVRGRZUKZSZQWHTZWJWFTZSZVEZUGWEUNZTZUOIJKLMW
      DFOPZUHZNVQNPZQGRZUKZSZQWTTZDSZVEUCOWEVOWTSZWAXEWCXGXHVPXAVTXDVOWTFUPVTXD
      SXHUDNVQVSXCVRXBQGUQURUSUTXHWBXFDQVOWTVAVBVCVDUEUFUAUBVQVQWSUBPZXANVQUAPZ
      XBGRZUKZSZXFXJWFTZSZVEZOWEUNZTWGXQTWJXJSZWGWRXQXRWRXANVQWJXBGRZUKZSZXFWOS
      ZVEZOWEUNXQWQYCUGOWEWHWTSZWMYAWPYBYDWIXAWLXTWHWTFUPWLXTSYDUDNVQWKXSVRXBWJ
      GVFURUSUTYDWNXFWOQWHWTVAVBVCVDXRYCXPOWEXRYAXMYBXOXRXTXLXAXRNVQXSXKWJXJXBG
      UQVGVHXRWOXNXFWJXJWFVNVHVCVIVJVKWGXIXQVNVLVM $.
  $}

  ${
    $d f s x A $.  $d f s x B $.  $d f h s x F $.  $d f g h J $.  $d g h s M $.
    $d f g h s x C $.  $d f g h s x G $.  $d f g h s x H $.  $d g h s ph $.
    $d g h s N $.  $d f h x P $.
    cvmliftpht.b $e |- B = U. C $.
    cvmliftpht.m $e |- M =
      ( iota_ f e. ( II Cn C ) ( ( F o. f ) = G /\ ( f ` 0 ) = P ) ) $.
    cvmliftpht.n $e |- N =
      ( iota_ f e. ( II Cn C ) ( ( F o. f ) = H /\ ( f ` 0 ) = P ) ) $.
    cvmliftpht.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmliftpht.p $e |- ( ph -> P e. B ) $.
    cvmliftpht.e $e |- ( ph -> ( F ` P ) = ( G ` 0 ) ) $.
    ${
      cvmliftphtlem.g $e |- ( ph -> G e. ( II Cn J ) ) $.
      cvmliftphtlem.h $e |- ( ph -> H e. ( II Cn J ) ) $.
      cvmliftphtlem.k $e |- ( ph -> K e. ( G ( PHtpy ` J ) H ) ) $.
      cvmliftphtlem.a $e |- ( ph -> A e. ( ( II tX II ) Cn C ) ) $.
      cvmliftphtlem.c $e |- ( ph -> ( F o. A ) = K ) $.
      cvmliftphtlem.0 $e |- ( ph -> ( 0 A 0 ) = P ) $.
      $( Lemma for ~ cvmliftpht .  (Contributed by Mario Carneiro,
         6-Jul-2015.) $)
      cvmliftphtlem $p |- ( ph -> A e. ( M ( PHtpy ` C ) N ) ) $=
        ( vs vx cii ccn co wcel ccom wceq cc0 cfv cvmliftiota simp1d c1 phtpy01
        simpld eqtrd cv cicc cmpt wral wa crio cop cxp wf iitop cnf syl 0elunit
        iiuni opelxpi mpan2 fvco3 syl2an adantr fveq1d eqtr3d df-ov 3eqtr4g a1i
        fveq2i ctopon mpteq2dva fovrn mp3an3 sylan eqidd feqmptd fmptco 3eqtr4d
        eqid fveq2 wb cnmptc cnmpt12f cvmlift syl22anc coeq2 eqeq1d fveq1 oveq1
        wreu ovex fvmpt ax-mp syl6eq anbi12d riota2 syl2anc mpbi2and syl5eq cvv
        mpteqb mprg sylib r19.21bi 1elunit simprd ccon ffvelrn sylancl cnconst2
        csn syl3anc fconstmpt syl6eqr mp3an2 fcoconst oveq2 fvconst2 cvmliftmoi
        mpan fvex rspcv mpsyl txunii iitopon cphtpy chtpy phtpyhtpy sseldd cuni
        ctx htpyi ccvm cvmcn cnmptid iicon cnlly iinllycon ctop toptopon phtpyi
        cvmtop1 simp3d fveq2d wfn ffn eqtr4d simp2d 3eqtrd eqeq12d isphtpy2d )
        ALMBDUFALUHDUIUJZUKZGLULZHUMZUNLUOZEUMZACDEFGHLJNOQTRSUPZUQZAMUVIUKZGMU
        LIUMUNMUOEUMACDEFGIMJNPQUARAEGUOZUNHUOZUNIUOZSAUVSUVTUMURHUOZURIUOUMAHI
        KJTUAUBUSUTVAZUPUQZUCAUFVBZUNBUJZUWDLUOZUMZUFUNURVCUJZAUFUWHUWEVDZUFUWH
        UWFVDZUMZUWGUFUWHVEZALUWIUWJALGFVBZULZHUMZUNUWMUOZEUMZVFZFUVIVGZUWIOAGU
        WIULZHUMZUNUNBUJZEUMZUWSUWIUMZAUFUWHUWEGUOZVDUFUWHUWDHUOZVDUWTHAUFUWHUX
        EUXFAUWDUWHUKZVFZUXEUWDUNKUJZUXFUXHUWDUNVHZBUOZGUOZUXJKUOZUXEUXIUXHUXJG
        BULZUOZUXLUXMAUWHUWHVIZCBVJZUXJUXPUKZUXOUXLUMUXGABUHUHUUHUJZDUIUJUKUXQU
        CBUXSDUXPCUHUHUWHUWHVKVKVOVOUUANVLVMZUXGUNUWHUKZUXRVNUWDUNUWHUWHVPVQUXP
        CUXJGBVRVSUXHUXJUXNKAUXNKUMUXGUDVTZWAWBUWEUXKGUWDUNBWCWFUWDUNKWCWDUXHUX
        IUXFUMZUWDURKUJZUWDIUOZUMZAUWDHIKUHJUWHUHUWHWGUOUKZAUUBWEZTUAAHIJUUCUOU
        JHIUHJUUDUJUJKAHIJTUAUUEUBUUFUUIZUTVAWHAUFUGUWHCUWEUGVBZGUOZUXEUWIGAUXQ
        UXGUWECUKZUXTUXQUXGUYAUYLVNUWDUNCUWHUWHBWIWJWKAUWIWLAUGCJUUGZGAGDJUIUJU
        KZCUYMGVJZAGDJUUJUJUKZUYNQDGJUUKVMGDJCUYMNUYMWPZVLVMZWMZUYJUWEGWQWNAUFU
        WHUYMHAHUHJUIUJZUKZUWHUYMHVJTHUHJUWHUYMVOUYQVLVMWMWOUEAUWIUVIUKUWRFUVIX
        GZUXAUXCVFZUXDWRAUFUWDUNBUHUHUHDUWHUYHAUFUHUWHUYHUULZAUFUNUHUHUWHUWHUYH
        UYHUYAAVNWEZWSZUCWTAUYPVUAECUKZUVRUVSUMZVUBQTRSCDEFGHJNXAXBUWRVUCFUVIUW
        IUWMUWIUMZUWOUXAUWQUXCVUIUWNUWTHUWMUWIGXCXDVUIUWPUXBEVUIUWPUNUWIUOZUXBU
        NUWMUWIXEUYAVUJUXBUMVNUFUNUWEUXBUWHUWIUWDUNUNBXFUWIWPUNUNBXHZXIXJXKXDXL
        XMXNXOXPAUFUWHCLAUVJUWHCLVJZUVPLUHDUWHCVONVLVMZWMWBUWEXQUKZUWKUWLWRUFUW
        HUFUWHUWEUWFXQXRVUNUXGUWDUNBXHWEXSXTZYAAUWDURBUJZUWDMUOZUMZUFUWHAUFUWHV
        UPVDZUFUWHVUQVDZUMZVURUFUWHVEZAMVUSVUTAMUWNIUMZUWQVFZFUVIVGZVUSPAGVUSUL
        ZIUMZUNURBUJZEUMZVVEVUSUMZAUFUWHVUPGUOZVDUFUWHUYEVDVVFIAUFUWHVVKUYEUXHV
        VKUYDUYEUXHUWDURVHZBUOZGUOZVVLKUOZVVKUYDUXHVVLUXNUOZVVNVVOAUXQVVLUXPUKZ
        VVPVVNUMUXGUXTUXGURUWHUKZVVQYBUWDURUWHUWHVPVQUXPCVVLGBVRVSUXHVVLUXNKUYB
        WAWBVUPVVMGUWDURBWCWFUWDURKWCWDUXHUYCUYFUYIYCVAWHAUFUGUWHCVUPUYKVVKVUSG
        AUXQUXGVUPCUKZUXTUXQUXGVVRVVSYBUWDURCUWHUWHBWIWJWKAVUSWLUYSUYJVUPGWQWNA
        UFUWHUYMIAIUYTUKZUWHUYMIVJUAIUHJUWHUYMVOUYQVLVMWMWOAVVHUVMEVVRAUNUWDBUJ
        ZUVMUMZUFUWHVEZVVHUVMUMZYBAUFUWHVWAVDZUFUWHUVMVDZUMZVWCAVWEUWHUVMYHVIZV
        WFACDGJUHVWEVWHUNUWHNVOQUHYDUKAUUMWEZUHYDUUNUKAUUOWEZVUEAUFUNUWDBUHUHUH
        DUWHUYHVUFVUDUCWTAUYGDCWGUOUKZUVMCUKZVWHUVIUKUYHADUUPUKZVWKAUYPVWMQDGJU
        USVMDCNUUQXTZAVULUYAVWLVUMVNUWHCUNLYEYFZUVMUHDUWHCYGYIAUFUWHVWAGUOZVDZU
        WHUVMGUOZYHVIZGVWEULGVWHULZAVWQUFUWHVWRVDVWSAUFUWHVWPVWRUXHUNUWDKUJZUVS
        VWPVWRUXHVXAUVSUMZURUWDKUJZUWAUMZAUWDHIKJTUAUBUURZUTUXHUNUWDVHZBUOZGUOZ
        VXFKUOZVWPVXAUXHVXFUXNUOZVXHVXIAUXQVXFUXPUKZVXJVXHUMUXGUXTUYAUXGVXKVNUN
        UWDUWHUWHVPYQUXPCVXFGBVRVSUXHVXFUXNKUYBWAWBVWAVXGGUNUWDBWCWFUNUWDKWCWDU
        XHVWRUVRUVSUXHUVMEGAUVNUXGAUVJUVLUVNUVOUUTZVTUVAAVUHUXGSVTVAWOWHUFUWHVW
        RYJYKAUFUGUWHCVWAUYKVWPVWEGAUXQUXGVWACUKZUXTUXQUYAUXGVXMVNUNUWDCUWHUWHB
        WIYLWKAVWEWLUYSUYJVWAGWQWNAGCUVBZVWLVWTVWSUMAUYOVXNUYRCUYMGUVCVMZVWOGUW
        HCUVMYMXNWOAUXBUVMUNVWEUOZUNVWHUOZAUXBEUVMUEVXLUVDUYAVXPUXBUMVNUFUNVWAU
        XBUWHVWEUWDUNUNBYNVWEWPVUKXIXJUYAVXQUVMUMVNUWHUVMUNUNLYRYOXJWDYPUFUWHUV
        MYJXKVWAXQUKZVWGVWCWRUFUWHUFUWHVWAUVMXQXRVXRUXGUNUWDBXHWEXSXTZVWBVWDUFU
        RUWHUWDURUMZVWAVVHUVMUWDURUNBYNXDYSYTVXLVAAVUSUVIUKVVDFUVIXGZVVGVVIVFZV
        VJWRAUFUWDURBUHUHUHDUWHUYHVUDAUFURUHUHUWHUWHUYHUYHVVRAYBWEWSZUCWTAUYPVV
        TVUGUVRUVTUMVYAQUARUWBCDEFGIJNXAXBVVDVYBFUVIVUSUWMVUSUMZVVCVVGUWQVVIVYD
        UWNVVFIUWMVUSGXCXDVYDUWPVVHEVYDUWPUNVUSUOZVVHUNUWMVUSXEUYAVYEVVHUMVNUFU
        NVUPVVHUWHVUSUWDUNURBXFVUSWPUNURBXHXIXJXKXDXLXMXNXOXPAUFUWHCMAUVQUWHCMV
        JUWCMUHDUWHCVONVLVMWMWBVUPXQUKZVVAVVBWRUFUWHUFUWHVUPVUQXQXRVYFUXGUWDURB
        XHWEXSXTYAAVWBUFUWHVXSYAAURUWDBUJZURLUOZUMZUFUWHAUFUWHVYGVDZUFUWHVYHVDZ
        UMZVYIUFUWHVEZAVYJUWHVYHYHVIZVYKACDGJUHVYJVYNUNUWHNVOQVWIVWJVUEAUFURUWD
        BUHUHUHDUWHUYHVYCVUDUCWTAUYGVWKVYHCUKZVYNUVIUKUYHVWNAVULVVRVYOVUMYBUWHC
        URLYEYFZVYHUHDUWHCYGYIAUFUWHVYGGUOZVDZUWHVYHGUOZYHVIZGVYJULGVYNULZAVYRU
        FUWHVYSVDVYTAUFUWHVYQVYSUXHVYQVXCUWAVYSUXHURUWDVHZBUOZGUOZWUBKUOZVYQVXC
        UXHWUBUXNUOZWUDWUEAUXQWUBUXPUKZWUFWUDUMUXGUXTVVRUXGWUGYBURUWDUWHUWHVPYQ
        UXPCWUBGBVRVSUXHWUBUXNKUYBWAWBVYGWUCGURUWDBWCWFURUWDKWCWDUXHVXBVXDVXEYC
        UXHURUVKUOZUWAVYSUXHURUVKHAUVLUXGAUVJUVLUVNUVOUVEVTWAUXHVULVVRWUHVYSUMA
        VULUXGVUMVTYBUWHCURGLVRYFWBUVFWHUFUWHVYSYJYKAUFUGUWHCVYGUYKVYQVYJGAUXQU
        XGVYGCUKZUXTUXQVVRUXGWUIYBURUWDCUWHUWHBWIYLWKAVYJWLUYSUYJVYGGWQWNAVXNVY
        OWUAVYTUMVXOVYPGUWHCVYHYMXNWOAURUNBUJZVYHUNVYJUOZUNVYNUOZVVRAUWLWUJVYHU
        MZYBVUOUWGWUMUFURUWHVXTUWEWUJUWFVYHUWDURUNBXFUWDURLWQUVGYSYTUYAWUKWUJUM
        VNUFUNVYGWUJUWHVYJUWDUNURBYNVYJWPURUNBXHXIXJUYAWULVYHUMVNUWHVYHUNURLYRY
        OXJWDYPUFUWHVYHYJXKVYGXQUKZVYLVYMWRUFUWHUFUWHVYGVYHXQXRWUNUXGURUWDBXHWE
        XSXTYAUVH $.
    $}

    cvmliftpht.g $e |- ( ph -> G ( ~=ph ` J ) H ) $.
    $( If ` G ` and ` H ` are path-homotopic, then their lifts ` M ` and ` N `
       are also path-homotopic.  (Contributed by Mario Carneiro,
       6-Jul-2015.) $)
    cvmliftpht $p |- ( ph -> M ( ~=ph ` C ) N ) $=
      ( co cc0 vg vh cii ccn wcel cphtpy cfv c0 wne cphtpc wbr ccom w3a isphtpc
      wceq sylib simp1d cvmliftiota simp2d c1 wa phtpc01 simpld eqtrd cv simp3d
      syl wex n0 wreu wrex ccvm adantr phtpycn sselda cicc 0elunit simpr phtpyi
      mpan2 eqtr4d cvmlift2 reurex ad2antrr simplr simprl simprrl cvmliftphtlem
      ctx simprrr ne0i rexlimddv exlimddv syl3anbrc ) AJUCCUDSZUEZKWOUEZJKCUFUG
      SZUHUIZJKCUJUGUKAWPFJULGUOTJUGDUOABCDEFGJILMOAGUCIUDSZUEZHWTUEZGHIUFUGSZU
      HUIZAGHIUJUGUKZXAXBXDUMRGHIUNUPZUQZPQURUQAWQFKULHUOTKUGDUOABCDEFHKILNOAXA
      XBXDXFUSZPADFUGZTGUGZTHUGZQAXJXKUOZUTGUGZUTHUGUOZAXEXLXNVARGHIVBVGVCVDURU
      QAUAVEZXCUEZWSUAAXDXPUAVHAXAXBXDXFVFUAXCVIUPAXPVAZFUBVEZULXOUOZTTXRSDUOZV
      AZWSUBUCUCWISZCUDSZXQYAUBYCVJYAUBYCVKXQBCDUBFXOILAFCIVLSUEZXPOVMAXCYBIUDS
      XOAGHIXGXHVNVOADBUEZXPPVMXQXIXJTTXOSZAXIXJUOZXPQVMXQYFXJUOZUTTXOSXMUOZXQT
      TUTVPSUEYHYIVAVQXQTGHXOIAXAXPXGVMAXBXPXHVMAXPVRVSVTVCWAWBYAUBYCWCVGXQXRYC
      UEZYAVAZVAZXRWRUEWSYLXRBCDEFGHIXOJKLMNAYDXPYKOWDAYEXPYKPWDAYGXPYKQWDAXAXP
      YKXGWDAXBXPYKXHWDAXPYKWEXQYJYAWFXQYJXSXTWGXQYJXSXTWJWHWRXRWKVGWLWMJKCUNWN
      $.
  $}

  ${
    $d b c d f k s w z A $.  $d f g w z I $.  $d a b c d f g k s u v w x y J $.
    $d a b c d f g h k n s u v w x y z F $.  $d f g h n x y M $.  $d f g w N $.
    $d a b c d f g h m n t v w x y z H $.  $d f g w Q $.  $d a b f m t v x S $.
    $d a b d f g h u v w x y z B $.  $d g w R $.  $d a b c d f g h n w x z X $.
    $d a b c d f g h k m n t u v w x y z G $.  $d b c d s T $.  $d f g x z Z $.
    $d a b c d f g h k m n s t u v w x y z C $.  $d a f h m n t v w x y ph $.
    $d a b c f g h m n t u v w x y z K $.  $d a b c d f g h n u v w x z P $.
    $d a b c f g h n u v w x z O $.  $d a f g h m t u v w x y z Y $.
    $d c d f h n x y W $.
    cvmlift3.b $e |- B = U. C $.
    cvmlift3.y $e |- Y = U. K $.
    cvmlift3.f $e |- ( ph -> F e. ( C CovMap J ) ) $.
    cvmlift3.k $e |- ( ph -> K e. SCon ) $.
    cvmlift3.l $e |- ( ph -> K e. N-Locally PCon ) $.
    cvmlift3.o $e |- ( ph -> O e. Y ) $.
    cvmlift3.g $e |- ( ph -> G e. ( K Cn J ) ) $.
    cvmlift3.p $e |- ( ph -> P e. B ) $.
    cvmlift3.e $e |- ( ph -> ( F ` P ) = ( G ` O ) ) $.
    ${
      cvmlift3lem1.1 $e |- ( ph -> M e. ( II Cn K ) ) $.
      cvmlift3lem1.2 $e |- ( ph -> ( M ` 0 ) = O ) $.
      cvmlift3lem1.3 $e |- ( ph -> N e. ( II Cn K ) ) $.
      cvmlift3lem1.4 $e |- ( ph -> ( N ` 0 ) = O ) $.
      cvmlift3lem1.5 $e |- ( ph -> ( M ` 1 ) = ( N ` 1 ) ) $.
      $( Lemma for ~ cvmlift3 .  (Contributed by Mario Carneiro,
         6-Jul-2015.) $)
      cvmlift3lem1 $p |- ( ph ->
        ( ( iota_ g e. ( II Cn C )
          ( ( F o. g ) = ( G o. M ) /\ ( g ` 0 ) = P ) ) ` 1 ) =
        ( ( iota_ g e. ( II Cn C )
          ( ( F o. g ) = ( G o. N ) /\ ( g ` 0 ) = P ) ) ` 1 ) ) $=
        ( cc0 cv ccom wceq cfv wa cii ccn co crio cphtpc wbr eqid fveq2d eqtr4d
        c1 cicc wf wcel iiuni cnf syl 0elunit fvco3 sylancl sconpht2 cvmliftpht
        phtpcco2 phtpc01 simprd ) AUHFEUIZUJZGJUJZUKUHVRULDUKZUMEUNCUOUPZUQZULU
        HVSGKUJZUKWAUMEWBUQZULUKZVCWCULVCWEULUKZAWCWECURULUSWFWGUMABCDEFVTWDHWC
        WENWCUTWEUTPUAADFULZUHJULZGULZUHVTULZAWHLGULWJUBAWILGUDVAVBAUHVCVDUPZMJ
        VEZUHWLVFWKWJUKAJUNIUOUPVFWMUCJUNIWLMVGOVHVIVJWLMUHGJVKVLVBAGJKIHAJKIQU
        CUEAWILUHKULUDUFVBUGVMTVOVNWCWECVPVIVQ $.
    $}

    $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro, 6-Jul-2015.) $)
    cvmlift3lem2 $p |- ( ( ph /\ X e. Y ) -> E! z e. B E. f e. ( II Cn K )
      ( ( f ` 0 ) = O /\ ( f ` 1 ) = X /\ ( ( iota_ g e. ( II Cn C )
        ( ( F o. g ) = ( G o. f ) /\ ( g ` 0 ) = P ) ) ` 1 ) = z ) ) $=
      ( va vh vw wcel wa cc0 cv cfv wceq c1 cii ccn co wrex ccom crio w3a cpcon
      wreu cscon adantr sconpcon simpr pconcn syl3anc wi wral cicc wf eqid ccvm
      syl ad2antrr simprl cnco syl2anc simprrl fveq2d iiuni cnf 0elunit sylancl
      fvco3 cvmliftiota simp1d 1elunit ffvelrn simprrr eqidd fveq1 eqeq1d coeq2
      3eqtr4rd eqeq2d anbi1d riotabidv fveq1d 3anbi123d rspcev syl13anc ad4antr
      cnlly simprr1 simprr2 eqtr4d cvmlift3lem1 simprr3 eqtrd ralrimiva 3anbi3d
      rexlimdvaa eqeq2 rexbidv eqeq1 imbi2d ralbidv anbi12d cbvrexv syl5bb reu8
      syl12anc sylibr mpd ) AMNUGZUHZUIUDUJZUKZLULZUMYIUKZMULZUHZUDUNKUOUPZUQZU
      IFUJZUKZLULZUMYQUKZMULZUMHGUJZURZIYQURZULZUIUUBUKEULZUHZGUNDUOUPZUSZUKZBU
      JZULZUTZFYOUQZBCVBZYHKVAUGZLNUGZYGYPYHKVCUGZUUPAUURYGRVDKVEVOAUUQYGTVDAYG
      VFLMUDKNPVGVHYHYNUUOUDYOYHYIYOUGZYNUHZUHZUUNUIUEUJZUKZLULZUMUVBUKZMULZUMU
      UCIUVBURZULZUUFUHZGUUHUSZUKZUFUJZULZUTZUEYOUQZUUKUVLULZVIZUFCVJZUHZBCUQZU
      UOUVAUMUUCIYIURZULZUUFUHZGUUHUSZUKZCUGZYSUUAUUJUWEULZUTZFYOUQZUVOUWEUVLUL
      ZVIZUFCVJZUVTUVAUIUMVKUPZCUWDVLZUMUWMUGUWFUVAUWDUUHUGZUWNUVAUWOHUWDURUWAU
      LUIUWDUKEULUVACDEGHUWAUWDJOUWDVMAHDJVNUPUGZYGUUTQVPUVAUUSIKJUOUPUGZUWAUNJ
      UOUPUGYHUUSYNVQZAUWQYGUUTUAVPYIIUNKJVRVSAECUGZYGUUTUBVPUVAYJIUKZLIUKZUIUW
      AUKZEHUKZUVAYJLIYHUUSYKYMVTZWAUVAUWMNYIVLZUIUWMUGUXBUWTULUVAUUSUXEUWRYIUN
      KUWMNWBPWCVOWDUWMNUIIYIWFWEAUXCUXAULZYGUUTUCVPWPWGWHUWDUNDUWMCWBOWCVOWIUW
      MCUMUWDWJWEUVAUUSYKYMUWEUWEULZUWIUWRUXDYHUUSYKYMWKZUVAUWEWLUWHYKYMUXGUTFY
      IYOYQYIULZYSYKUUAYMUWGUXGUXIYRYJLUIYQYIWMWNUXIYTYLMUMYQYIWMWNUXIUUJUWEUWE
      UXIUMUUIUWDUXIUUGUWCGUUHUXIUUEUWBUUFUXIUUDUWAUUCYQYIIWOWQWRWSWTWNXAXBXCUV
      AUWKUFCUVAUVLCUGZUHZUVNUWJUEYOUXKUVBYOUGZUVNUHZUHZUWEUVKUVLUXNCDEGHIJKYIU
      VBLNOPAUWPYGUUTUXJUXMQXDAUURYGUUTUXJUXMRXDAKVAXEUGYGUUTUXJUXMSXDAUUQYGUUT
      UXJUXMTXDAUWQYGUUTUXJUXMUAXDAUWSYGUUTUXJUXMUBXDAUXFYGUUTUXJUXMUCXDUVAUUSU
      XJUXMUWRVPUVAYKUXJUXMUXDVPUXKUXLUVNVQUVDUVFUVMUXLUXKXFUXNYLMUVEUVAYMUXJUX
      MUXHVPUVDUVFUVMUXLUXKXGXHXIUVDUVFUVMUXLUXKXJXKXNXLUVSUWIUWLUHBUWECUUKUWEU
      LZUUNUWIUVRUWLUXOUUMUWHFYOUXOUULUWGYSUUAUUKUWEUUJXOXMXPUXOUVQUWKUFCUXOUVP
      UWJUVOUUKUWEUVLXQXRXSXTXBYDUUNUVOBUFCUUNUVDUVFUVKUUKULZUTZUEYOUQUVPUVOUUM
      UXQFUEYOYQUVBULZYSUVDUUAUVFUULUXPUXRYRUVCLUIYQUVBWMWNUXRYTUVEMUMYQUVBWMWN
      UXRUUJUVKUUKUXRUMUUIUVJUXRUUGUVIGUUHUXRUUEUVHUUFUXRUUDUVGUUCYQUVBIWOWQWRW
      SWTWNXAYAUVPUXQUVNUEYOUVPUXPUVMUVDUVFUUKUVLUVKXOXMXPYBYCYEXNYF $.

    ${
      cvmlift3.h $e |- H = ( x e. Y |-> ( iota_ z e. B E. f e. ( II Cn K )
        ( ( f ` 0 ) = O /\ ( f ` 1 ) = x /\ ( ( iota_ g e. ( II Cn C )
          ( ( F o. g ) = ( G o. f ) /\ ( g ` 0 ) = P ) ) ` 1 ) = z ) ) ) $.
      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         6-Jul-2015.) $)
      cvmlift3lem3 $p |- ( ph -> H : Y --> B ) $=
        ( cc0 cv cfv wceq c1 ccom wa cii ccn co crio w3a wrex wcel cvmlift3lem2
        wreu riotacl syl fmptd ) ABOUFGUGZUHNUIUJVEUHBUGZUIUJIHUGZUKJVEUKUIUFVG
        UHFUIULHUMEUNUOUPUHCUGUIUQGUMMUNUOURZCDUPZDKAVFOUSULVHCDVAVIDUSACDEFGHI
        JLMNVFOPQRSTUAUBUCUDUTVHCDVBVCUEVD $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         6-Jul-2015.) $)
      cvmlift3lem4 $p |- ( ( ph /\ X e. Y ) -> ( ( H ` X ) = A <-> E. f e.
    ( II Cn K ) ( ( f ` 0 ) = O /\ ( f ` 1 ) = X /\ ( ( iota_ g e. ( II Cn C )
      ( ( F o. g ) = ( G o. f ) /\ ( g ` 0 ) = P ) ) ` 1 ) = A ) ) ) $=
        ( wcel wa cfv wceq cc0 cv c1 ccom cii ccn co crio w3a wrex cvmlift3lem3
        ffvelrnda eleq1 syl5ibcom wi cicc eqid ccvm ad2antrr simprl cnco simprr
        syl2anc fveq2d iiuni cnf syl 0elunit fvco3 sylancl 3eqtr4rd cvmliftiota
        wf simp1d 1elunit ffvelrn expr 3impd rexlimdva wb eqeq2 3anbi2d rexbidv
        a1dd riotabidv riotaex adantl eqeq1d cvmlift3lem2 3anbi3d riota2 sylan2
        fvmpt wreu bitr4d expcom pm5.21ndd ) APQUHZUIZDEUHZPLUJZDUKZULHUMZUJZOU
        KZUNXNUJZPUKZUNJIUMZUOKXNUOZUKULXSUJGUKUIIUPFUQURZUSZUJZDUKZUTZHUPNUQUR
        ZVAZXJXLEUHXMXKAQEPLABCEFGHIJKLMNOQRSTUAUBUCUDUEUFUGVBVCXLDEVDVEXJYEXKH
        YFXJXNYFUHZUIZXPXRYDXKYIXPYDXKVFZXRXJYHXPYJXJYHXPUIZUIZYCEUHZYDXKYLULUN
        VGURZEYBWDZUNYNUHYMYLYBYAUHZYOYLYPJYBUOXTUKULYBUJGUKYLEFGIJXTYBMRYBVHAJ
        FMVIURUHXIYKTVJYLYHKNMUQURUHZXTUPMUQURUHXJYHXPVKZAYQXIYKUDVJXNKUPNMVLVN
        AGEUHXIYKUEVJYLXOKUJZOKUJZULXTUJZGJUJZYLXOOKXJYHXPVMVOYLYNQXNWDZULYNUHU
        UAYSUKYLYHUUCYRXNUPNYNQVPSVQVRVSYNQULKXNVTWAAUUBYTUKXIYKUFVJWBWCWEYBUPF
        YNEVPRVQVRWFYNEUNYBWGWAYCDEVDVEWHWOWIWJXKXJXMYGWKXKXJUIXMXPXRYCCUMZUKZU
        TZHYFVAZCEUSZDUKZYGXJXMUUIWKXKXJXLUUHDXIXLUUHUKABPXPXQBUMZUKZUUEUTZHYFV
        AZCEUSUUHQLUUJPUKZUUMUUGCEUUNUULUUFHYFUUNUUKXRXPUUEUUJPXQWLWMWNWPUGUUGC
        EWQXDWRWSWRXJXKUUGCEXEYGUUIWKACEFGHIJKMNOPQRSTUAUBUCUDUEUFWTUUGYGCEDUUD
        DUKZUUFYEHYFUUOUUEYDXPXRUUDDYCWLXAWNXBXCXFXGXH $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         6-Jul-2015.) $)
      cvmlift3lem5 $p |- ( ph -> ( F o. H ) = G ) $=
        ( vy vw cv cfv cmpt ccom wcel wa cc0 wceq c1 cii ccn crio w3a wrex eqid
        co cvmlift3lem4 df-3an ccvm ad3antrrr simplr cnco syl2anc simprl fveq2d
        mpbii cicc wf iiuni cnf syl 0elunit sylancl 3eqtr4rd cvmliftiota simp2d
        fvco3 fveq1d simp1d 1elunit simprr eqtrd 3eqtr3d fveq2 eqeq1d syl5ibcom
        expimpd syl5bi rexlimdva mpteq2dva cvmlift3lem3 ffvelrnda feqmptd cvmcn
        mpd cuni 3syl fmptco 3eqtr4d ) AUFOUFUHZKUIZIUIZUJUFOXGJUIZUJIKUKJAUFOX
        IXJAXGOULZUMZUNGUHZUIZNUOZUPXMUIZXGUOZUPIHUHZUKJXMUKZUOUNXRUIFUOUMHUQEU
        RVCZUSZUIZXHUOZUTZGUQMURVCZVAZXIXJUOZXLXHXHUOYFXHVBABCXHDEFGHIJKLMNXGOP
        QRSTUAUBUCUDUEVDVMXLYDYGGYEYDXOXQUMZYCUMXLXMYEULZUMZYGXOXQYCVEYJYHYCYGY
        JYHUMZYBIUIZXJUOYCYGYKUPIYAUKZUIZUPXSUIZYLXJYKUPYMXSYKYAXTULZYMXSUOZUNY
        AUIFUOZYKDEFHIXSYALPYAVBAIELVFVCULZXKYIYHRVGYKYIJMLURVCULZXSUQLURVCULXL
        YIYHVHZAYTXKYIYHUBVGXMJUQMLVIVJAFDULXKYIYHUCVGYKXNJUIZNJUIZUNXSUIZFIUIZ
        YKXNNJYJXOXQVKVLYKUNUPVNVCZOXMVOZUNUUFULUUDUUBUOYKYIUUGUUAXMUQMUUFOVPQV
        QVRZVSUUFOUNJXMWDVTAUUEUUCUOXKYIYHUDVGWAWBZWCWEYKUUFDYAVOZUPUUFULZYNYLU
        OYKYPUUJYKYPYQYRUUIWFYAUQEUUFDVPPVQVRWGUUFDUPIYAWDVTYKYOXPJUIZXJYKUUGUU
        KYOUULUOUUHWGUUFOUPJXMWDVTYKXPXGJYJXOXQWHVLWIWJYCYLXIXJYBXHIWKWLWMWNWOW
        PXBWQAUFUGODXHUGUHZIUIXIKIAODXGKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEWRZWSAUFO
        DKUUNWTAUGDLXCZIAYSIELURVCULDUUOIVOREILXAIELDUUOPUUOVBZVQXDWTUUMXHIWKXE
        AUFOUUOJAYTOUUOJVOUBJMLOUUOQUUPVQVRWTXF $.

      cvmlift3lem7.s $e |- S = ( k e. J |->
        { s e. ( ~P C \ { (/) } ) | ( U. s = ( `' F " k ) /\
          A. c e. s ( A. d e. ( s \ { c } ) ( c i^i d ) = (/) /\
             ( F |` c ) e. ( ( C |`t c ) Homeo ( J |`t k ) ) ) ) } ) $.
      ${
        cvmlift3lem7.1 $e |- ( ph -> ( G ` X ) e. A ) $.
        cvmlift3lem7.2 $e |- ( ph -> T e. ( S ` A ) ) $.
        cvmlift3lem7.3 $e |- ( ph -> M C_ ( `' G " A ) ) $.
        cvmlift3lem7.w $e |- W = ( iota_ b e. T ( H ` X ) e. b ) $.
        ${
          cvmlift3lem6.x $e |- ( ph -> X e. M ) $.
          cvmlift3lem6.z $e |- ( ph -> Z e. M ) $.
          cvmlift3lem6.q $e |- ( ph -> Q e. ( II Cn K ) ) $.
          cvmlift3lem6.r $e |- R = ( iota_ g e. ( II Cn C )
            ( ( F o. g ) = ( G o. Q ) /\ ( g ` 0 ) = P ) ) $.
          cvmlift3lem6.1 $e |- ( ph ->
            ( ( Q ` 0 ) = O /\ ( Q ` 1 ) = X /\ ( R ` 1 ) = ( H ` X ) ) ) $.
          cvmlift3lem6.n $e |- ( ph -> N e. ( II Cn ( K |`t M ) ) ) $.
          cvmlift3lem6.2 $e |- ( ph ->
            ( ( N ` 0 ) = X /\ ( N ` 1 ) = Z ) ) $.
          cvmlift3lem6.i $e |- I = ( iota_ g e. ( II Cn C )
            ( ( F o. g ) = ( G o. N ) /\ ( g ` 0 ) = ( H ` X ) ) ) $.
          $( Lemma for ~ cvmlift3 .  (Contributed by Mario Carneiro,
             9-Jul-2015.) $)
          cvmlift3lem6 $p |- ( ph -> ( H ` Z ) e. W ) $=
            ( cfv c1 wceq cc0 cv ccom wa cii ccn co crio w3a cpco wcel ctop wss
            crest syl sseldd simp2d simpld eqtr4d pcocn pco0 simp1d pco1 simprd
            eqtrd syl2anc fveq2d wf iiuni cnf 0elunit fvco3 sylancl cvmliftiota
            cnco 3eqtr4rd ccnv cima cdm cnvimass cuni fdm syl5sseq sstrd fveq1d
            simp3d copco coeq2 eqeq1d fveq1 syl13anc mpbird a1i ctopon toptopon
            wb crn sylib rnco2 syl3anc frn wfun eqeltrd wrex cscon scontop cicc
            cnrest2r cvmlift3lem3 eqid ffvelrnd cvmlift3lem5 oveq12d ccvm cvmcn
            eqtr3d 3eqtr4d wreu cvmlift syl22anc anbi12d riota2 mpbi2and eqeq2d
            anbi1d riotabidv rspcev cvmlift3lem4 mpdan ccon iicon cvmtop1 rneqd
            3anbi123d 3eqtr3g iitopon resttopon cnf2 funimass3 eqsstrd sseqtr4d
            ffun syl6ss cnrest2 cvmsss cvmsiota elssuni cvmsuni sseqtrd cvmsrcl
            mpbid cnima restopn2 mpbir2and ccld cvmscld concn 1elunit ffvelrn )
            AUGQVOZVPRVOZUDAUWQUWRVQZVRLVSZVOZUCVQZVPUWTVOZUGVQZVPOMVSZVTZPUWTV
            TZVQZVRUXEVOZGVQZWAZMWBFWCWDZWEZVOZUWRVQZWFZLWBTWCWDZUUAZAHUBTWGVOW
            DZUXQWHZVRUXSVOZUCVQZVPUXSVOZUGVQZVPUXFPUXSVTZVQZUXJWAZMUXLWEZVOZUW
            RVQZUXRAHUBTVIAWBTUAWKWDZWCWDZUXQUBATWIWHZUYLUXQWJATUUBWHUYMUOTUUCW
            LZUAWBTUUEWLVLWMZAVPHVOZUEVRUBVOZAVRHVOZUCVQZUYPUEVQZVPIVOZUEQVOZVQ
            ZVKWNAUYQUEVQZVPUBVOZUGVQZVMWOZWPZWQZAUYAUYRUCAHUBTVIUYOWRAUYSUYTVU
            CVKWSZXBZAUYCVUEUGAHUBTVIUYOWTAVUDVUFVMXAXBAUYIVPIRFWGVOWDZVOUWRAVP
            UYHVULAOVULVTZUYEVQZVRVULVOZGVQZUYHVULVQZAOIVTZORVTZSWGVOZWDPHVTZPU
            BVTZVUTWDVUMUYEAVURVVAVUSVVBVUTAIUXLWHZVURVVAVQZVRIVOZGVQZAEFGMOVVA
            ISULVJUNAHUXQWHZPTSWCWDWHZVVAWBSWCWDZWHVIURHPWBTSXLXCUSAUYRPVOZUCPV
            OZVRVVAVOZGOVOZAUYRUCPVUJXDAVRVPUUDWDZUFHXEZVRVVNWHZVVLVVJVQAVVGVVO
            VIHWBTVVNUFXFUMXGWLXHVVNUFVRPHXIXJUTXMXKZWNARUXLWHZVUSVVBVQZVRRVOZV
            UBVQZAEFVUBMOVVBRSULVNUNAUBUXQWHZVVHVVBVVIWHUYOURUBPWBTSXLXCAUFEUEQ
            ABCEFGLMOPQSTUCUFULUMUNUOUPUQURUSUTVAUUFZAUAUFUEAUAPXNDXOZUFVEAPXPZ
            VWDUFPDXQZAUFSXRZPXEZVWEUFVQAVVHVWHURPTSUFVWGUMVWGUUGZXGWLZUFVWGPXS
            WLXTYAZVGWMZUUHZAUYQPVOZUEPVOZVRVVBVOZVUBOVOZAUYQUEPVUGXDAVVNUFUBXE
            ZVVPVWPVWNVQAVWBVWRUYOUBWBTVVNUFXFUMXGWLXHVVNUFVRPUBXIXJAUEOQVTZVOZ
            VWQVWOAUFEQXEUEUFWHVWTVWQVQVWCVWLUFEUEOQXIXCAUEVWSPABCEFGLMOPQSTUCU
            FULUMUNUOUPUQURUSUTVAUUIYBUUMZXMXKZWNZUUJAIROFSAVVCVVDVVFVVQWSZAVVR
            VVSVWAVXBWSZAVUAVUBVVTAUYSUYTVUCVKYCAVVRVVSVWAVXBYCZWPZAOFSUUKWDWHZ
            OFSWCWDWHZUNFOSUULWLZYDAHUBPTSVIUYOVUHURYDUUNAVUOVVEGAIRFVXDVXEWRAV
            VCVVDVVFVVQYCXBAVULUXLWHUYGMUXLUUOZVUNVUPWAZVUQYMAIRFVXDVXEVXGWQAVX
            HUYEVVIWHZGEWHVVMVRUYEVOZVQVXKUNAUXTVVHVXMVUIURUXSPWBTSXLXCUSAUYAPV
            OZVVKVXNVVMAUYAUCPVUKXDAVVNUFUXSXEZVVPVXNVXOVQAUXTVXPVUIUXSWBTVVNUF
            XFUMXGWLXHVVNUFVRPUXSXIXJUTXMEFGMOUYESULUUPUUQUYGVXLMUXLVULUXEVULVQ
            ZUYFVUNUXJVUPVXQUXFVUMUYEUXEVULOYEYFVXQUXIVUOGVRUXEVULYGYFUURUUSXCU
            UTYBAIRFVXDVXEWTXBUXPUYBUYDUYJWFLUXSUXQUWTUXSVQZUXBUYBUXDUYDUXOUYJV
            XRUXAUYAUCVRUWTUXSYGYFVXRUXCUYCUGVPUWTUXSYGYFVXRUXNUYIUWRVXRVPUXMUY
            HVXRUXKUYGMUXLVXRUXHUYFUXJVXRUXGUYEUXFUWTUXSPYEUVAUVBUVCYBYFUVKUVDY
            HAUGUFWHUWSUXRYMAUAUFUGVWKVHWMABCUWREFGLMOPQSTUCUGUFULUMUNUOUPUQURU
            SUTVAUVEUVFYIAVVNUDRXEVPVVNWHUWRUDWHAVRUDRWBFOXNDXOZWKWDZVVNXFWBUVG
            WHAUVHYJAVVRRWBVXTWCWDWHZVXEAFEYKVOWHZRYNZVXSWJZVXSEWJVVRVYAYMAFWIW
            HZVYBAVXHVYEUNFOSUVIWLZFEULYLYOAOVYCXOZDWJZVYDAVYGPUBYNZXOZDAVUSYNV
            VBYNVYGVYJAVUSVVBVXCUVJORYPPUBYPUVLAVYJDWJZVYIVWDWJZAVYIUAVWDAVVNUA
            UBXEZVYIUAWJAWBVVNYKVOWHZUYKUAYKVOWHZUBUYLWHVYMVYNAUVMYJATUFYKVOWHZ
            UAUFWJVYOAUYMVYPUYNTUFUMYLYOVWKUATUFUVNXCVLUBWBUYKVVNUAUVOYQVVNUAUB
            YRWLVEYAZAPYSZVYIVWEWJVYKVYLYMAVWHVYRVWJUFVWGPUVSWLAVYIVWDVWEVYQVWF
            UVTVYIDPUVPXCYIUVQAOYSZVYCOXPZWJVYHVYDYMAEVWGOXEZVYSAVXIWUAVXJOFSEV
            WGULVWIXGWLZEVWGOUVSWLAVYCEVYTAVVNERXEZVYCEWJAVVRWUCVXERWBFVVNEXFUL
            XGWLVVNERYRWLAWUAVYTEVQWUBEVWGOXSWLZUVRVYCDOUVPXCUWHAVYTVXSEODXQWUD
            XTVXSRWBFEUWAYQUWHAUDVXTWHZUDFWHZUDVXSWJZAKFUDAKDJVOWHZKFWJVDUKUJFJ
            KDNOSUHVBUWBWLAUDKWHZVUBUDWHZAVXHWUHVUBEWHVWQDWHWUIWUJWAUNVDVWMAVWQ
            VWODVXAVCYTUIUKUJVUBEFJKDNOSUDUHVBULVFUWCYHZWOZWMAUDKXRZVXSAWUIUDWU
            MWJWULUDKUWDWLAWUHWUMVXSVQVDUKUJFJKDNOSUHVBUWEWLUWFAVYEVXSFWHZWUEWU
            FWUGWAYMVYFAVXIDSWHZWUNVXJAWUHWUOVDUKUJFJKDNOSUHVBUWGWLDOFSUWIXCVXS
            UDFUWJXCUWKAVXHWUHWUIUDVXTUWLVOWHUNVDWULUKUJUDFJKDNOSUHVBUWMYQVVPAX
            HYJAVVTVUBUDVXFAWUIWUJWUKXAYTUWNUWOVVNUDVPRUWPXJYT $.
        $}

        cvmlift3lem7.7 $e |- ( ph -> ( K |`t M ) e. PCon ) $.
        cvmlift3lem7.4 $e |- ( ph -> V e. K ) $.
        cvmlift3lem7.5 $e |- ( ph -> V C_ M ) $.
        cvmlift3lem7.6 $e |- ( ph -> X e. V ) $.
        $( Lemma for ~ cvmlift3 .  (Contributed by Mario Carneiro,
           9-Jul-2015.) $)
        cvmlift3lem7 $p |- ( ph -> H e. ( ( K CnP C ) ` X ) ) $=
          ( vy vh va vn ccnp cfv wcel cres crest cuni cvmlift3lem3 cvmlift3lem5
          co ccn ccom eqeltrd cscon ctop scontop syl ccnv cima cnvimass wf wceq
          cdm eqid cnf fdm 3syl syl5sseq sstrd sseldd wa ffvelrnd fvco3 syl2anc
          ccvm fveq1d eqtr3d cvmsiota syl13anc wss cv wral cc0 c1 cii crio wrex
          w3a cvmlift3lem4 mpbii mpdan adantr weq fveq1 eqeq1d eqeq2d riotabidv
          coeq2 anbi12d cbvriotav syl6eqr 3anbi123d cbvrexv sylib cpcon restuni
          anbi1d ad3antrrr wb mpbird syl22anc eleq2d biimpa pconcn reeanv cnlly
          eleqtrd syl3anc simpllr simplrl simprl simplrr simprr cvmlift3lem6 ex
          rexlimdvva syl5bir mp2and ralrimiva wfun ffun funimass4 cvmlift2lem9a
          sseqtr4d cncnpi cnt ssntr cnprest ) AOUBQFVKVSVLVMZORVNZUBQRVOVSZFVKV
          SVLVMZAUVIUVJFVTVSVMUBUVJVPZVMZUVKADEFHILMOPQRUAUBUCUDUFUGUHUIURUJABC
          EFGJKMNOPQSUCUHUIUJUKULUMUNUOUPUQVQZAMOWAZNQPVTVSZABCEFGJKMNOPQSUCUHU
          IUJUKULUMUNUOUPUQVRZUNWBAQWCVMZQWDVMZUKQWEWFZARUCUBARNWGDWHZUCVAANWLZ
          UWAUCNDWIANUVPVMZUCPVPZNWJUWBUCWKUNNQPUCUWDUIUWDWMWNUCUWDNWOWPWQWRZAT
          RUBVEVFWSZWSZUTAMFPXDVSVMZIDHVLVMZUBOVLZEVMUWJMVLZDVMUAIVMUWJUAVMWTUJ
          UTAUCEUBOUVNUWGXAAUWKUBNVLZDAUBUVOVLZUWKUWLAUCEOWJZUBUCVMZUWMUWKWKUVN
          UWGUCEUBMOXBXCAUBUVONUVQXEXFUSWBUEUGUFUWJEFHIDLMPUAUDURUHVBXGXHUWEAOR
          WHUAXIZVGXJZOVLUAVMZVGRXKZAUWRVGRAUWQRVMZWTZXLVHXJZVLZSWKZXMUXBVLZUBW
          KZXMMVIXJZWAZNUXBWAZWKZXLUXGVLZGWKZWTZVIXNFVTVSZXOZVLZUWJWKZXQZVHXNQV
          TVSZXPZXLVJXJZVLUBWKXMUYAVLUWQWKWTZVJXNUVJVTVSZXPZUWRUXAXLJXJZVLZSWKZ
          XMUYEVLZUBWKZXMMKXJZWAZNUYEWAZWKZXLUYJVLZGWKZWTZKUXNXOZVLZUWJWKZXQZJU
          XSXPZUXTAVUAUWTAUWOVUAUWGAUWOWTUWJUWJWKVUAUWJWMABCUWJEFGJKMNOPQSUBUCU
          HUIUJUKULUMUNUOUPUQXRXSXTYAUYTUXRJVHUXSJVHYBZUYGUXDUYIUXFUYSUXQVUBUYF
          UXCSXLUYEUXBYCYDVUBUYHUXEUBXMUYEUXBYCYDVUBUYRUXPUWJVUBXMUYQUXOVUBUYQU
          YKUXIWKZUYOWTZKUXNXOUXOVUBUYPVUDKUXNVUBUYMVUCUYOVUBUYLUXIUYKUYEUXBNYG
          YEYPYFUXMVUDVIKUXNVIKYBZUXJVUCUXLUYOVUEUXHUYKUXIUXGUYJMYGZYDVUEUXKUYN
          GXLUXGUYJYCZYDYHYIZYJXEYDYKYLYMUXAUVJYNVMZUVMUWQUVLVMZUYDAVUIUWTVCYAA
          UVMUWTAUBRUVLUWFAUVSRUCXIZRUVLWKUVTUWERQUCUIYOXCZUUFZYAAUWTVUJARUVLUW
          QVULUUAUUBUBUWQVJUVJUVLUVLWMZUUCUUGUXTUYDWTUXRUYBWTZVJUYCXPVHUXSXPUXA
          UWRUXRUYBVHVJUXSUYCUUDUXAVUOUWRVHVJUXSUYCUXAUXBUXSVMZUYAUYCVMZWTZWTZV
          UOUWRVUSVUOWTBCDEFGUXBUXOHIJKLMNOUXHNUYAWAZWKZUXKUWJWKZWTZVIUXNXOPQRU
          YASUAUBUCUWQUDUEUFUGUHUIAUWHUWTVURVUOUJYQAUVRUWTVURVUOUKYQAQYNUUEVMUW
          TVURVUOULYQASUCVMUWTVURVUOUMYQAUWCUWTVURVUOUNYQAGEVMUWTVURVUOUOYQAGMV
          LSNVLWKUWTVURVUOUPYQUQURAUWLDVMUWTVURVUOUSYQAUWIUWTVURVUOUTYQARUWAXIU
          WTVURVUOVAYQVBAUBRVMUWTVURVUOUWFYQAUWTVURVUOUUHUXAVUPVUQVUOUUIVUHVUSU
          XRUYBUUJUXAVUPVUQVUOUUKVUSUXRUYBUULVVCUYKVUTWKZUYNUWJWKZWTVIKUXNVUEVV
          AVVDVVBVVEVUEUXHUYKVUTVUFYDVUEUXKUYNUWJVUGYDYHYIUUMUUNUUOUUPUUQUURAOU
          USZROWLZXIUWPUWSYRAUWNVVFUVNUCEOUUTWFARUCVVGUWEAUWNVVGUCWKUVNUCEOWOWF
          UVCVGRUAOUVAXCYSUVBVUMUBUVIUVJFUVLVUNUVDXCAUVSVUKUBRQUVEVLVLZVMUWNUVH
          UVKYRUVTUWEATVVHUBAUVSVUKTQVMTRXITVVHXIUVTUWEVDVERQTUCUIUVFYTVFWSUVNR
          UBOQFUCEUIUHUVGYTYS $.
      $}

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         6-Jul-2015.) $)
      cvmlift3lem8 $p |- ( ph -> H e. ( K Cn C ) ) $=
        ( vy va vt vv vm vb ccn co wcel wf cv ccnp cfv wral cvmlift3lem3 wa wne
        c0 wrex ccvm cuni adantr eqid cnf syl ffvelrnda cvmcov syl2anc n0 crest
        wex wss cpcon w3a ccnv cima cnlly ad2antrr simprr cvmsrcl simplr simprl
        cpw cnima wfn ffn elpreima 4syl mpbir2and nlly2i syl3anc crio ad3antrrr
        wb cscon wceq simprll simprr3 simprlr simprr2 simprr1 cvmlift3lem7 expr
        elpwid rexlimdvva mpd exlimdv syl5bi expimpd rexlimdvw ralrimiva ctopon
        ctop scontop toptopon sylib cvmtop1 cncnp ) AMOEURUSUTZQDMVAZMULVBZOEVC
        USVDUTZULQVEZABCDEFHIKLMNOPQUAUBUCUDUEUFUGUHUIUJVFAYMULQAYLQUTZVGZYLLVD
        ZUMVBZUTZYRGVDZVIVHZVGZUMNVJZYMYPKENVKUSUTZYQNVLZUTUUCAUUDYOUCVMAQUUEYL
        LALONURUSUTZQUUELVAZUGLONQUUEUBUUEVNZVOZVPVQUMTSEYQGJKNUUERUKUUHVRVSYPU
        UBYMUMNYPYSUUAYMUUAUNVBZYTUTZUNWBYPYSVGZYMUNYTVTUULUUKYMUNYPYSUUKYMYPYS
        UUKVGZVGZYLUOVBZUTZUUOUPVBZWCZOUUQWAUSWDUTZWEZUOOVJUPLWFYRWGZWNZVJZYMUU
        NOWDWHUTZUVAOUTZYLUVAUTZUVCAUVDYOUUMUEWIUUNUUFYRNUTZUVEAUUFYOUUMUGWIZUU
        NUUKUVGYPYSUUKWJZTSEGUUJYRJKNRUKWKVPYRLONWOVSUUNUVFYOYSAYOUUMWLYPYSUUKW
        MZUUNUUFUUGLQWPUVFYOYSVGXEUVHUUIQUUELWQQYLYRLWRWSWTUOWDYLUVAOUPXAXBUUNU
        UTYMUPUOUVBOUUNUUQUVBUTZUUOOUTZVGZUUTYMUUNUVMUUTVGZVGZBCYRDEFGUUJHIJKLM
        NOUUQPUUOYLMVDUQVBUTUQUUJXCZYLQRUQSTUAUBAUUDYOUUMUVNUCXDAOXFUTZYOUUMUVN
        UDXDAUVDYOUUMUVNUEXDAPQUTYOUUMUVNUFXDAUUFYOUUMUVNUGXDAFDUTYOUUMUVNUHXDA
        FKVDPLVDXGYOUUMUVNUIXDUJUKUUNYSUVNUVJVMUUNUUKUVNUVIVMUVOUUQUVAUUNUVKUVL
        UUTXHXOUVPVNUUPUURUUSUVMUUNXIUUNUVKUVLUUTXJUUPUURUUSUVMUUNXKUUPUURUUSUV
        MUUNXLXMXNXPXQXNXRXSXTYAXQYBAOQYCVDUTZEDYCVDUTZYJYKYNVGXEAOYDUTZUVRAUVQ
        UVTUDOYEVPOQUBYFYGAEYDUTZUVSAUUDUWAUCEKNYHVPEDUAYFYGULMOEQDYIVSWT $.

      $( Lemma for ~ cvmlift2 .  (Contributed by Mario Carneiro,
         7-May-2015.) $)
      cvmlift3lem9 $p |- ( ph ->
          E. f e. ( K Cn C ) ( ( F o. f ) = G /\ ( f ` O ) = P ) ) $=
        ( ccn co wcel ccom wceq cfv cv wa wrex cvmlift3lem8 cvmlift3lem5 cc0 c1
        cii crio w3a cicc csn cxp ctopon iitopon a1i cscon scontop syl toptopon
        ctop sylib cnconst2 syl3anc 0elunit fvconst2g sylancl 1elunit sneqd wfn
        xpeq2d ccvm cuni wf cvmcn eqid cnf ffn 4syl fcoconst syl2anc 3eqtr4d wb
        cvmtop1 cvmtop2 ffvelrnd eqeltrd fveq1d 3eqtr4rd cvmlift syl22anc coeq2
        wreu eqeq1d fveq1 anbi12d riota2 mpbi2and eqtrd eqeq2d anbi1d riotabidv
        3anbi123d rspcev syl13anc cvmlift3lem4 mpdan mpbird syl12anc ) AMOEULUM
        ZUNKMUOZLUPZPMUQZFUPZKHURZUOZLUPZPYLUQZFUPZUSZHYGUTABCDEFGHIJKLMNOPQRST
        UAUBUCUDUEUFUGUHUIUJUKVAABCDEFHIKLMNOPQUAUBUCUDUEUFUGUHUIUJVBAYKVCYLUQZ
        PUPZVDYLUQZPUPZVDKIURZUOZLYLUOZUPZVCUUBUQZFUPZUSZIVEEULUMZVFZUQZFUPZVGZ
        HVEOULUMZUTZAVCVDVHUMZPVIVJZUUNUNZVCUUQUQZPUPZVDUUQUQZPUPZVDUUCLUUQUOZU
        PZUUGUSZIUUIVFZUQZFUPZUUOAVEUUPVKUQUNZOQVKUQUNZPQUNZUURUVIAVLVMZAOVRUNZ
        UVJAOVNUNUVMUDOVOVPOQUBVQVSUFPVEOUUPQVTWAAUVKVCUUPUNZUUTUFWBUUPPVCQWCWD
        AUVKVDUUPUNZUVBUFWEUUPPVDQWCWDAUVGVDUUPFVIVJZUQZFAVDUVFUVPAKUVPUOZUVCUP
        ZVCUVPUQZFUPZUVFUVPUPZAUUPFKUQZVIZVJZUUPPLUQZVIZVJZUVRUVCAUWDUWGUUPAUWC
        UWFUIWFWHAKDWGZFDUNZUVRUWEUPAKENWIUMUNZKENULUMUNDNWJZKWKUWIUCEKNWLKENDU
        WLUAUWLWMZWNDUWLKWOWPUHKUUPDFWQWRALQWGZUVKUVCUWHUPAQUWLLWKZUWNALONULUMU
        NUWOUGLONQUWLUBUWMWNVPZQUWLLWOVPUFLUUPQPWQWRZWSAUWJUVNUWAUHWBUUPFVCDWCW
        DAUVPUUIUNZUVEIUUIXJZUVSUWAUSZUWBWTAUVIEDVKUQUNZUWJUWRUVLAEVRUNZUXAAUWK
        UXBUCEKNXAVPEDUAVQVSUHFVEEUUPDVTWAAUWKUVCVENULUMZUNUWJUWCVCUVCUQZUPUWSU
        CAUVCUWHUXCUWQAUVINUWLVKUQUNZUWFUWLUNZUWHUXCUNUVLANVRUNZUXEAUWKUXGUCEKN
        XBVPNUWLUWMVQVSAQUWLPLUWPUFXCZUWFVENUUPUWLVTWAXDUHAVCUWHUQZUWFUXDUWCAUX
        FUVNUXIUWFUPUXHWBUUPUWFVCUWLWCWDAVCUVCUWHUWQXEUIXFDEFIKUVCNUAXGXHUVEUWT
        IUUIUVPUUBUVPUPZUVDUVSUUGUWAUXJUUCUVRUVCUUBUVPKXIXKUXJUUFUVTFVCUUBUVPXL
        XKXMXNWRXOXEAUWJUVOUVQFUPUHWEUUPFVDDWCWDXPUUMUUTUVBUVHVGHUUQUUNYLUUQUPZ
        YSUUTUUAUVBUULUVHUXKYRUUSPVCYLUUQXLXKUXKYTUVAPVDYLUUQXLXKUXKUUKUVGFUXKV
        DUUJUVFUXKUUHUVEIUUIUXKUUEUVDUUGUXKUUDUVCUUCYLUUQLXIXQXRXSXEXKXTYAYBAUV
        KYKUUOWTUFABCFDEFHIKLMNOPPQUAUBUCUDUEUFUGUHUIUJYCYDYEYQYIYKUSHMYGYLMUPZ
        YNYIYPYKUXLYMYHLYLMKXIXKUXLYOYJFPYLMXLXKXMYAYF $.
    $}

    $( A general version of ~ cvmlift .  If ` K ` is simply connected and
       weakly locally path-connected, then there is a unique lift of functions
       on ` K ` which commutes with the covering map.  (Contributed by Mario
       Carneiro, 9-Jul-2015.) $)
    cvmlift3 $p |- ( ph ->
        E! f e. ( K Cn C ) ( ( F o. f ) = G /\ ( f ` O ) = P ) ) $=
      ( vx vz vk vs vc vd vg va vb vv vu cv ccom wceq cfv wa ccn wrex wrmo wreu
      co cuni ccnv cima cin c0 csn cdif wral cres crest chmeo wcel cpw crab cc0
      cmpt c1 cii crio w3a eqeq2 3anbi3d rexbidv cbvriotav fveq1 eqeq1d anbi12d
      weq coeq2 eqeq2d anbi1d riotabidv syl5eq fveq1d 3anbi123d cbvrexv 3anbi2d
      syl5bb cbvmptv eqid cvmscbv cvmlift3lem9 cscon ccon sconpcon pconcon 3syl
      cpcon cnlly wss ssriv nllyss ax-mp sseldi cvmliftmo reu5 sylanbrc ) AFEUL
      ZUMGUNJXSUODUNUPZEICUQVAZURXTEYAUSXTEYAUTAUAUBBCDUCHUDULZVBFVCUCULZVDUNUE
      ULZUFULZVEVFUNUFYBYDVGVHVIFYDVJCYDVKVAHYCVKVAVLVAVMUPUEYBVIUPUDCVNVFVGVHV
      OVQZEUGUHFGUHKVPYDUOZJUNZVRYDUOZUHULZUNZVRFYEUMZGYDUMZUNZVPYEUOZDUNZUPZUF
      VSCUQVAZVTZUOZUIULZUNZWAZUEVSIUQVAZURZUIBVTZVQHIJKUIUJUKLMNOPQRSTUHUAKUUF
      VPXSUOZJUNZVRXSUOZUAULZUNZVRFUGULZUMZGXSUMZUNZVPUULUOZDUNZUPZUGYRVTZUOZUB
      ULZUNZWAZEUUDURZUBBVTZUHUAWIZUUFYHYKYTUVAUNZWAZUEUUDURZUBBVTUVEUUEUVIUIUB
      BUIUBWIZUUCUVHUEUUDUVJUUBUVGYHYKUUAUVAYTWBWCWDWEUVFUVIUVDUBBUVIUUHUUIYJUN
      ZUVBWAZEUUDURUVFUVDUVHUVLUEEUUDUEEWIZYHUUHYKUVKUVGUVBUVMYGUUGJVPYDXSWFWGU
      VMYIUUIYJVRYDXSWFWGUVMYTUUTUVAUVMVRYSUUSUVMYSUUMYMUNZUUQUPZUGYRVTUUSYQUVO
      UFUGYRUFUGWIZYNUVNYPUUQUVPYLUUMYMYEUULFWJWGUVPYOUUPDVPYEUULWFWGWHWEUVMUVO
      UURUGYRUVMUVNUUOUUQUVMYMUUNUUMYDXSGWJWKWLWMWNWOWGWPWQUVFUVLUVCEUUDUVFUVKU
      UKUUHUVBYJUUJUUIWBWRWDWSWMWNWTUFUECYFUCFHUDUHUIUJUKYFXAXBXCABCDEFGHIJKLMN
      AIXDVMIXIVMIXEVMOIXFIXGXHAXIXJZXEXJZIXIXEXKUVQUVRXKUAXIXEUUJXGXLXIXEXMXNP
      XOQRSTXPXTEYAXQXR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Normal numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d n A $.  $d n B $.  $d k n N $.  $d n R $.
    snmlff.f $e |- F = ( n e. NN |-> ( ( # ` { k e. ( 1 ... n ) |
      ( |_ ` ( ( A x. ( R ^ k ) ) mod R ) ) = B } ) / n ) ) $.
    $( The function ` F ` from ~ snmlval is a mapping from positive integers to
       real numbers in the range ` [ 0 , 1 ] ` .  (Contributed by Mario
       Carneiro, 6-Apr-2015.) $)
    snmlff $p |- F : NN --> ( 0 [,] 1 ) $=
      ( cn cc0 c1 co cv cmul cfv wceq wcel cr cle wbr cfn cicc cexp cmo cfl cfz
      crab chash cdiv cn0 wss ssrab2 ssfi sylancl hashcl nn0red nndivre mpancom
      fzfid syl clt nn0ge0d nnre nngt0 divge0 syl22anc cdom ssdomg ee10 hashdom
      wb syl2anc mpbird nnnn0 hashfz1 breqtrd mulid1d breqtrrd 1re a1i ledivmul
      nncn syl112anc 0re elicc2i syl3anbrc fmpti ) EHIJUAKZACDLUBKMKCUCKUDNBOZD
      JELZUEKZUFZUGNZWIUHKZFGWIHPZWMQPZIWMRSZWMJRSZWMWGPWLQPZWNWOWNWLWNWKTPZWLU
      IPWNWJTPZWKWJUJZWSWNJWIURZWHDWJUKZWJWKULUMZWKUNUSZUOZWLWIUPUQWNWRIWLRSWIQ
      PZIWIUTSZWPXFWNWLXEVAWIVBZWIVCZWLWIVDVEWNWQWLWIJMKZRSZWNWLWIXKRWNWLWJUGNZ
      WIRWNWLXMRSZWKWJVFSZWNWTXAXOXBXCWKWJTVGVHWNWSWTXNXOVJXDXBWKWJTVIVKVLWNWIU
      IPXMWIOWIVMWIVNUSVOWNWIWIWAVPVQWNWRJQPZXGXHWQXLVJXFXPWNVRVSXIXJWLJWIVTWBV
      LIJWMWCVRWDWEWF $.

    $( The function ` F ` from ~ snmlval maps ` N ` to the relative density of
       ` B ` in the first ` N ` digits of the digit string of ` A ` in base
       ` R ` .  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    snmlfval $p |- ( N e. NN -> ( F ` N ) = ( ( # ` { k e. ( 1 ... N ) |
      ( |_ ` ( ( A x. ( R ^ k ) ) mod R ) ) = B } ) / N ) ) $=
      ( cv cexp co cmul cmo cfv wceq c1 cfz crab chash cdiv cfl oveq2 rabeq syl
      cn fveq2d id oveq12d ovex fvmpt ) EGACDIJKLKCMKUANBOZDPEIZQKZRZSNZULTKUKD
      PGQKZRZSNZGTKUEFULGOZUOURULGTUSUNUQSUSUMUPOUNUQOULGPQUBUKDUMUPUCUDUFUSUGU
      HHURGTUIUJ $.
  $}

  ${
    $d b k n x A $.  $d b k n B $.  $d b F $.  $d b k n r x R $.
    snml.s $e |- S = ( r e. ( ZZ>= ` 2 ) |->
      { x e. RR | A. b e. ( 0 ... ( r - 1 ) ) ( n e. NN |-> ( ( # `
      { k e. ( 1 ... n ) | ( |_ ` ( ( x x. ( r ^ k ) ) mod r ) ) = b } )
        / n ) ) ~~> ( 1 / r ) } ) $.
    $( The property " ` A ` is simply normal in base ` R ` ".  A number is
       simply normal if each digit ` 0 <_ b < R ` occurs in the base- ` R `
       digit string of ` A ` with frequency ` 1 / R ` (which is consistent with
       the expectation in an infinite random string of numbers selected from
       ` 0 ... R - 1 ` ).  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
    snmlval $p |- ( A e. ( S ` R ) <-> ( R e. ( ZZ>= ` 2 ) /\ A e. RR /\
      A. b e. ( 0 ... ( R - 1 ) ) ( n e. NN |-> ( ( # `
      { k e. ( 1 ... n ) | ( |_ ` ( ( A x. ( R ^ k ) ) mod R ) ) = b } )
        / n ) ) ~~> ( 1 / R ) ) ) $=
      ( cfv cr cn cv co cmul cmo cfl wceq c1 cdiv c2 cuz wcel wa cexp cfz chash
      crab cmpt cli wbr cc0 cmin wral w3a oveq1 oveq2d id oveq12d fveq2d eqeq1d
      rabbidv oveq1d mpteq2dv oveq2 breq12d raleqbidv rabex fvmpt eleq2d breq1d
      reex ralbidv syl6bb pm5.32i dmmptss elfvdm sseldi pm4.71ri 3anass 3bitr4i
      elrab cdm ) CUAUBJZUCZBCDJZUCZUDWEBKUCZFLBCEMZUENZONZCPNZQJZHMZRZESFMZUFN
      ZUHZUGJZWPTNZUIZSCTNZUJUKZHULCSUMNZUFNZUNZUDZUDWGWEWHXFUOWEWGXGWEWGBFLAMZ
      WJONZCPNZQJZWNRZEWQUHZUGJZWPTNZUIZXBUJUKZHXEUNZAKUHZUCXGWEWFXSBGCFLXHGMZW
      IUENZONZXTPNZQJZWNRZEWQUHZUGJZWPTNZUIZSXTTNZUJUKZHULXTSUMNZUFNZUNZAKUHZXS
      WDDXTCRZYNXRAKYPYKXQHYMXEYPYLXDULUFXTCSUMUPUQYPYIXPYJXBUJYPFLYHXOYPYGXNWP
      TYPYFXMUGYPYEXLEWQYPYDXKWNYPYCXJQYPYBXIXTCPYPYAWJXHOXTCWIUEUPUQYPURUSUTVA
      VBUTVCVDXTCSTVEVFVGVBIXRAKVLVHVIVJXRXFABKXHBRZXQXCHXEYQXPXAXBUJYQFLXOWTYQ
      XNWSWPTYQXMWRUGYQXLWOEWQYQXKWMWNYQXJWLQYQXIWKCPXHBWJOUPVCUTVAVBUTVCVDVKVM
      WBVNVOWGWEWGDWCWDCGWDYODIVPBCDVQVRVSWEWHXFVTWA $.

    ${
      snml.f $e |- F = ( n e. NN |-> ( ( # `
        { k e. ( 1 ... n ) | ( |_ ` ( ( A x. ( R ^ k ) ) mod R ) ) = B } )
          / n ) ) $.
      $( If ` A ` is simply normal, then the function ` F ` of relative density
         of ` B ` in the digit string converges to ` 1 / R ` , i.e. the set of
         occurences of ` B ` in the digit string has natural density
         ` 1 / R ` .  (Contributed by Mario Carneiro, 6-Apr-2015.) $)
      snmlflim $p |- ( ( A e. ( S ` R ) /\ B e. ( 0 ... ( R - 1 ) ) ) ->
        F ~~> ( 1 / R ) ) $=
        ( cfv wcel cn cv co wceq c1 cdiv cexp cmul cmo cfl cfz crab cli wbr cc0
        chash cmpt cmin wral c2 cuz snmlval simp3bi eqeq2 rabbidv fveq2d oveq1d
        cr mpteq2dv syl6eqr breq1d rspccva sylan ) BDEMNZGOBDFPUAQUBQDUCQUDMZJP
        ZRZFSGPZUEQZUFZUJMZVLTQZUKZSDTQZUGUHZJUIDSULQUEQZUMZCVTNHVRUGUHZVHDUNUO
        MNBVBNWAABDEFGIJKUPUQVSWBJCVTVJCRZVQHVRUGWCVQGOVICRZFVMUFZUJMZVLTQZUKHW
        CGOVPWGWCVOWFVLTWCVNWEUJWCVKWDFVMVJCVIURUSUTVAVCLVDVEVFVG $.
    $}

  $(
    @( Almost all numbers (in the sense of Lebesgue measure) are simply normal
       in base ` R ` . @)
    snmlnul @p |- ( R e. ( ZZ>= ` 2 ) -> ( vol* ` ( RR \ ( S ` R ) ) ) = 0 ) @=
      ? @.

    @( Almost all numbers (in the sense of Lebesgue measure) are normal
       in every base. @)
    nmlnul @p |- ( vol* ` ( RR \ { x e. RR | A. r e. ( ZZ>= ` 2 ) A. n e. NN0
      A. k e. NN ( x x. ( r ^ n ) ) e. ( S ` ( r ^ k ) ) } ) ) = 0 @=
      ( cfv cn0 cn co wcel cr crab covol wral cc0 wceq wbr syl c2 cuz cexp cmul
      cv wn ciun cdif wrex wa iunrab a1i iuneq2dv syl6eq iuneq2i wtru wb rexnal
      rexbii bitri tru biantrur 3bitri rabbiia difrab rgenw rabid2 mpbir eqcomi
      difeq1i 3eqtr2i 3eqtri fveq2i cdom wss cvv fvex clt eluz2b2 simplbi ssriv
      c1 ssdomg mp2 ssrab2 iunss cen nn0ennn endom ax-mp nnex domrefg difss crp
      cdiv ad2antrr simplr nnexpcl syl2anc nnrp simpr adantr nnre remulcl eldif
      baibr cc recnd mulcom eleq1d bitrd rabbidva nnnn0 adantl exp0 nnz simprbi
      cz 0z nngt0 ltexp2a syl32anc eqbrtrrd sylanbrc snmlnul 0re ovolsca oveq1d
      syl6eqel wne nncn nnne0 div0 3eqtrd jca ralrimiva ovoliunnul sylancr rgen
      mp2an eqtr3i ) EUAUBHZDICJAUEZEUEZDUEZUCKZUDKZUUDCUEZUCKZBHZLZUFZAMNZUGZU
      GZUGZOHZMUUKCJPZDIPZEUUBPZAMNZUHZOHQUUPUVBOUUPEUUBUULCJUIZDIUIZAMNZUGUVDE
      UUBUIZAMNZUVBEUUBUUOUVEUUDUUBLZUUODIUVCAMNZUGUVEUVHDIUUNUVIUUNUVIRUVHUUEI
      LZUJZUULCAJMUKULUMUVCDAIMUKUNUOUVDEAUUBMUKUVGUPUUTUFZUJZAMNUPAMNZUVAUHUVB
      UVFUVMAMUVFUVMUQUUCMLZUVFUUSUFZEUUBUIUVLUVMUVDUVPEUUBUVDUURUFZDIUIUVPUVCU
      VQDIUUKCJURUSUURDIURUTUSUUSEUUBURUPUVLVAVBVCULVDUPUUTAMVEUVNMUVAMUVNMUVNR
      UPAMPUPAMVAVFUPAMVGVHVIVJVKVLVMUUBJVNSZUUOMVOZUUOOHQRZUJZEUUBPUUQQRUUBVPL
      UUBJVOUVRUAUBVQEUUBJUVHUUDJLZWBUUDVRSZUUDVSZVTZWAUUBJVPWCWDUWAEUUBUVHUVSU
      VTUVSUVHUVSUUNMVOZDIPUWFDIUWFUUMMVOZCJPUWGCJUULAMWEZVFCJUUMMWFVHZVFDIUUNM
      WFVHULUVHIJVNSZUWFUUNOHQRZUJZDIPUVTIJWGSUWJWHIJWIWJUVHUWLDIUVKUWFUWKUWFUV
      KUWIULUVKJJVNSZUWGUUMOHZQRZUJZCJPUWKJVPLUWMWKJVPWLWJUVKUWPCJUVKUUHJLZUJZU
      WGUWOUWGUWRUWHULUWRUWNMUUJUHZOHZUUFWOKQUUFWOKZQUWRAUWSUUMUUFUWSMVOUWRMUUJ
      WMULUWRUUFJLZUUFWNLUWRUWBUVJUXBUVHUWBUVJUWQUWEWPZUVHUVJUWQWQUUDUUEWRWSZUU
      FWTTUWRUULUUFUUCUDKZUWSLZAMUWRUVOUJZUULUUGUWSLZUXFUXGUUGMLZUULUXHUQUXGUVO
      UUFMLZUXIUWRUVOXAZUXGUXBUXJUWRUXBUVOUXDXBUUFXCTZUUCUUFXDWSUXHUXIUULUUGMUU
      JXEXFTUXGUUGUXEUWSUXGUUCXGLUUFXGLZUUGUXERUXGUUCUXKXHUXGUUFUXLXHUUCUUFXIWS
      XJXKXLUWRUWTQMUWRUUIUUBLZUWTQRUWRUUIJLZWBUUIVRSUXNUWRUWBUUHILZUXOUXCUWQUX
      PUVKUUHXMXNUUDUUHWRWSUWRUUDQUCKZWBUUIVRUWRUUDXGLUXQWBRUWRUUDUWRUWBUUDMLZU
      XCUUDXCTZXHUUDXOTUWRUXRQXRLZUUHXRLZUWCQUUHVRSZUXQUUIVRSUXSUXTUWRXSULUWQUY
      AUVKUUHXPXNUVHUWCUVJUWQUVHUWBUWCUWDXQWPUWQUYBUVKUUHXTXNUUDQUUHYAYBYCUUIVS
      YDAUUIBCDEFGYETZYFYIYGUWRUWTQUUFWOUYCYHUWRUXMUUFQYJZUXAQRUWRUXBUXMUXDUUFY
      KTUWRUXBUYDUXDUUFYLTUUFYMWSYNYOYPJUUMCYQYRYOYPIUUNDYQYRYOYSUUBUUOEYQYTUUA
      @.
      @( [8-Apr-2015] @)

    @( Since almost all numbers are normal in every base, there must exist a
       normal number. @)
    nmlex @p |- E. x e. RR A. r e. ( ZZ>= ` 2 ) A. n e. NN0
      A. k e. NN ( x x. ( r ^ n ) ) e. ( S ` ( r ^ k ) ) @=
      ( cv cexp co cfv wcel wral cr c0 cdif covol cpnf mpbi syl6eq cmul cn0 cuz
      cn c2 crab wne wrex cc0 nmlnul 0re eqeltri wceq wnel pnfnre df-nel difeq2
      wn dif0 fveq2d ovolre eleq1d mtbiri necon2ai ax-mp rabn0 ) AHEHZDHIJUAJVG
      CHIJBKLCUDMDUBMEUEUCKMZANUFZOUGZVHANUHNVIPZQKZNLZVJVLUINABCDEFGUJUKULVMVI
      OVIOUMZVMRNLZRNUNVOURUORNUPSVNVLRNVNVLNQKRVNVKNQVNVKNOPNVIONUQNUSTUTVATVB
      VCVDVEVHANVFS @.
      @( [6-Apr-2015] @)
  $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                Compactification
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $(
  @{
    @d k n s S @.
    alextop.1 @e |- X = U. J @.
    alextop.2 @e |- O = ~P U. X @.
    alextop.3 @e |- K = ( J u. { x | E. y e. J ( x = ( y u. { O } ) /\
                        ( J |`t ( X \ y ) ) e. Comp ) } ) @.
    @( The domain of the Alexandroff extension. @)
    alexuni @p |- ( J e. Top -> ( X u. { O } ) = U. K ) @=
      ? @.

    @( The Alexandroff extension is a compactification of the original
       topology. @)
    alextop @p |- ( J e. Top -> K e. Comp ) @=
      ? @.
  @}
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                             Godel-sets of formulas
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c e.g $. $( Godel-set of membership $)
  $c |g $. $( Godel-set for Sheffer stroke $)
  $c A.g $. $( Godel-set of universal quantification $)
  $c =g $. $( Godel-set of equality $)
  $c /\g $. $( Godel-set of conjunction $)
  $c -.g $. $( Godel-set of negation $)
  $c ->g $. $( Godel-set of implication $)
  $c <->g $. $( Godel-set of equivalence $)
  $c \/g $. $( Godel-set of disjunction $)
  $c E.g $. $( Godel-set of existential quantification $)
  $c Fmla $. $( Formula predicate $)
  $c Sat $. $( Satisfaction predicate $)
  $c SatE $. $( Satisfaction predicate $)
  $c |= $. $( Proves relation $)

  $( The Godel-set of membership. $)
  cgoe $a class e.g $.

  $( The Godel-set for the Sheffer stroke. $)
  cgna $a class |g $.

  $( The Godel-set of universal quantification.  (Note that this is not a
     wff.) $)
  cgol $a class A.g N U $.

  $( The satisfaction function. $)
  csat $a class Sat $.

  $( The formula set predicate. $)
  cfmla $a class Fmla $.

  $( The ` e. ` -satisfaction function. $)
  csate $a class SatE $.

  $( The "proves" relation. $)
  cprv $a class |= $.

  $( Define the Godel-set of membership.  Here the arguments
     ` x = <. N , P >. ` correspond to v_N and v_P , so ` ( (/) e.g 1o ) `
     actually means v_0 ` e. ` v_1 , not ` 0 e. 1 ` .  (Contributed by Mario
     Carneiro, 14-Jul-2013.) $)
  df-goel $a |- e.g = ( x e. ( om X. om ) |-> <. (/) , x >. ) $.

  $( Define the Godel-set for the Sheffer stroke NAND. Here the arguments
     ` x = <. U , V >. ` are also Godel-sets corresponding to smaller
     formulae.  (Contributed by Mario Carneiro, 14-Jul-2013.) $)
  df-gona $a |- |g = ( x e. ( _V X. _V ) |-> <. 1o , x >. ) $.

  $( Define the Godel-set of universal quantification.  Here ` N e. om `
     corresponds to v_N , and ` U ` represents another formula, and this
     expression is ` [ A. x ph ] = A.g N U ` where ` x ` is the ` N ` -th
     variable, ` U = [ ph ] ` is the code for ` ph ` .  Note that this is a
     _class_ expression, not a wff.  (Contributed by Mario Carneiro,
     14-Jul-2013.) $)
  df-goal $a |- A.g N U = <. 2o , <. N , U >. >. $.

  ${
    $d a e f i j m u v x y z $.
    $( Define the satisfaction predicate. This recursive construction builds up
       a function over wff codes and simultaneously defines the set of
       assignments to all variables from ` M ` that makes the coded wff true in
       the model ` M ` , where ` e. ` is interpreted as the binary relation ` E
       ` on ` M ` .

       The interpretation of the statement ` S e. ( ( ( M Sat E ) `` n ) `` U )
       ` is that for the model ` <. M , E >. ` , ` S : om --> M ` is a
       valuation of the variables (v_0 ` = ( S `` (/) ) ` , v_1 ` = ( S `` 1o
       ) ` , etc.) and ` U ` is a code for a wff using ` = , e. , \/ , -. , A.
       ` that is true under the assignment ` S ` . The function is defined by
       finite recursion; ` ( ( M Sat E ) `` n ) ` only operates on wffs of
       depth at most ` n e. om ` , and ` ( ( M Sat E ) `` om ) = U_ n e. om ( (
       M Sat E ) `` n ) ` operates on all wffs.

       The coding scheme for the wffs is defined so that <HTML><ul>
       <li>v<sub>i</sub> ` e. ` v<sub>j</sub> is coded as
       ` <. (/) , <. i , j >. >. ` ,</li>
       <li> ` ( ph -/\ ps ) ` is coded as ` <. 1o , <. ph , ps >. >. ` ,
       and</li>
       <li> ` A. ` v<sub>i</sub> ` ph ` is coded as
       ` <. 2o , <. i , ph >. >. ` .</li></ul></HTML>

       (Contributed by Mario Carneiro, 14-Jul-2013.)  $)
    df-sat $a |- Sat = ( m e. _V , e e. _V |->
       ( rec ( ( f e. _V |-> ( f u.
           { <. x , y >. | E. u e. f ( E. v e. f
      ( x = ( ( 1st ` u ) |g ( 1st ` v ) ) /\
        y = ( ( m ^m om ) \ ( ( 2nd ` u ) i^i ( 2nd ` v ) ) ) ) \/ E. i e. om
      ( x = A.g i ( 1st ` u ) /\
        y = { a e. ( m ^m om ) | A. z e. m ( { <. i , z >. } u.
          ( a |` ( om \ { i } ) ) ) e. ( 2nd ` u ) } ) ) } ) ) ,
           { <. x , y >. | E. i e. om E. j e. om
      ( x = ( i e.g j ) /\
        y = { a e. ( m ^m om ) | ( a ` i ) e ( a ` j ) } ) } )
         |` suc om ) ) $.
  $}

  ${
    $d m u $.
    $( A simplified version of the satisfaction predicate, using the standard
       membership relation and eliminating the extra variable ` n ` .
       (Contributed by Mario Carneiro, 14-Jul-2013.) $)
    df-sate $a |- SatE = ( m e. _V , u e. _V |->
       ( ( ( m Sat ( _E i^i ( m X. m ) ) ) ` om ) ` u ) ) $.
  $}

  $( Define the predicate which defines the set of valid Godel formulas.  The
     parameter ` n ` defines the maximum height of the formulas: the set
     ` ( Fmla `` (/) ) ` is all formulas of the form ` x = y ` or ` x e. y `
     (which in our coding scheme is the set
     ` ( { (/) , 1o } X. ( om X. om ) ) ` ; see ~ df-sat for the full coding
     scheme), and each extra level adds to the complexity of the formulas in
     ` ( Fmla `` n ) ` . ` ( Fmla `` om ) = U_ n e. om ( Fmla `` n ) ` is the
     set of all valid formulas.  (Contributed by Mario Carneiro,
     14-Jul-2013.) $)
  df-fmla $a |- Fmla = ( n e. suc om |-> dom ( ( (/) Sat (/) ) ` n ) ) $.

  $( The Godel-set of negation.  (Note that this is not a wff.) $)
  cgon $a class -.g U $.

  $( The Godel-set of conjunction. $)
  cgoa $a class /\g $.

  $( The Godel-set of implication. $)
  cgoi $a class ->g $.

  $( The Godel-set of disjunction. $)
  cgoo $a class \/g $.

  $( The Godel-set of equivalence. $)
  cgob $a class <->g $.

  $( The Godel-set of equality. $)
  cgoq $a class =g $.

  $( The Godel-set of existential quantification.  (Note that this is not a
     wff.) $)
  cgox $a class E.g N U $.

  $( Define the Godel-set of negation.  Here the argument ` U ` is also a
     Godel-set corresponding to smaller formulae.  Note that this is a _class_
     expression, not a wff.  (Contributed by Mario Carneiro, 14-Jul-2013.) $)
  df-gonot $a |- -.g U = ( U |g U ) $.

  ${
    $d u v w $.
    $( Define the Godel-set of conjunction.  Here the arguments ` U ` and ` V `
       are also Godel-sets corresponding to smaller formulae.  (Contributed by
       Mario Carneiro, 14-Jul-2013.) $)
    df-goan $a |- /\g = ( u e. _V , v e. _V |-> -.g ( u |g v ) ) $.

    $( Define the Godel-set of implication.  Here the arguments ` U ` and ` V `
       are also Godel-sets corresponding to smaller formulae.  Note that this
       is a _class_ expression, not a wff.  (Contributed by Mario Carneiro,
       14-Jul-2013.) $)
    df-goim $a |- ->g = ( u e. _V , v e. _V |-> ( u |g -.g v ) ) $.

    $( Define the Godel-set of disjunction.  Here the arguments ` U ` and ` V `
       are also Godel-sets corresponding to smaller formulae.  Note that this
       is a _class_ expression, not a wff.  (Contributed by Mario Carneiro,
       14-Jul-2013.) $)
    df-goor $a |- \/g = ( u e. _V , v e. _V |-> ( -.g u ->g v ) ) $.

    $( Define the Godel-set of equivalence.  Here the arguments ` U ` and ` V `
       are also Godel-sets corresponding to smaller formulae.  Note that this
       is a _class_ expression, not a wff.  (Contributed by Mario Carneiro,
       14-Jul-2013.) $)
    df-gobi $a |- <->g = ( u e. _V , v e. _V |->
                           ( ( u ->g v ) /\g ( v ->g u ) ) ) $.

    $( Define the Godel-set of equality.  Here the arguments
       ` x = <. N , P >. ` correspond to v_N and v_P , so ` ( (/) =g 1o ) `
       actually means v_0 ` = ` v_1 , not ` 0 = 1 ` .  Here we use the trick
       mentioned in ~ ax-ext to introduce equality as a defined notion in terms
       of ` e.g ` .  The expression ` suc ( u u. v ) = ` max ` ( u , v ) + 1 `
       here is a convenient way of getting a dummy variable distinct from ` u `
       and ` v ` .  (Contributed by Mario Carneiro, 14-Jul-2013.) $)
    df-goeq $a |- =g = ( u e. om , v e. om |-> [_ suc ( u u. v ) / w ]_
                         A.g w ( ( w e.g u ) <->g ( w e.g v ) ) ) $.
  $}

  $( Define the Godel-set of existential quantification.  Here ` N e. om `
     corresponds to v_N , and ` U ` represents another formula, and this
     expression is ` [ E. x ph ] = E.g N U ` where ` x ` is the ` N ` -th
     variable, ` U = [ ph ] ` is the code for ` ph ` .  Note that this is a
     _class_ expression, not a wff.  (Contributed by Mario Carneiro,
     14-Jul-2013.) $)
  df-goex $a |- E.g N U = -.g A.g N -.g U $.

  ${
    $d m u $.
    $( Define the "proves" relation on a set.  A wff is true in a model ` M `
       if for every valuation ` s e. ( M ^m om ) ` , the interpretation of the
       wff using the membership relation on ` M ` is true.  (Contributed by
       Mario Carneiro, 14-Jul-2013.) $)
    df-prv $a |- |= = { <. m , u >. | ( m SatE u ) = ( m ^m om ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                  Models of ZF
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c AxExt $. $( The Axiom of Extensionality $)
  $c AxRep $. $( The Axiom Scheme of Replacement $)
  $c AxPow $. $( The Axiom of Power Sets $)
  $c AxUn $. $( The Axiom of Unions $)
  $c AxReg $. $( The Axiom of Regularity $)
  $c AxInf $. $( The Axiom of Infinity $)
  $c ZF $. $( The set of models of ZF $)

  $( The Axiom of Extensionality. $)
  cgze $a class AxExt $.

  $( The Axiom Scheme of Replacement. $)
  cgzr $a class AxRep $.

  $( The Axiom of Power Sets. $)
  cgzp $a class AxPow $.

  $( The Axiom of Unions. $)
  cgzu $a class AxUn $.

  $( The Axiom of Regularity. $)
  cgzg $a class AxReg $.

  $( The Axiom of Infinity. $)
  cgzi $a class AxInf $.

  $( The set of models of ZF. $)
  cgzf $a class ZF $.

  $( The Godel-set version of the Axiom of Extensionality.  (Contributed by
     Mario Carneiro, 14-Jul-2013.) $)
  df-gzext $a |- AxExt =
    ( A.g 2o ( ( 2o e.g (/) ) <->g ( 2o e.g 1o ) ) ->g ( (/) =g 1o ) ) $.

  $( The Godel-set version of the Axiom Scheme of Replacement.  Since this is a
     scheme and not a single axiom, it manifests as a function on wffs, each
     giving rise to a different axiom.  (Contributed by Mario Carneiro,
     14-Jul-2013.) $)
  df-gzrep $a |- AxRep = ( u e. ( Fmla ` om ) |->
    ( A.g 3o E.g 1o A.g 2o ( A.g 1o u ->g ( 2o =g 1o ) ) ->g A.g 1o A.g 2o
      ( ( 2o e.g 1o ) <->g E.g 3o ( ( 3o e.g (/) ) /\g A.g 1o u ) ) ) ) $.

  $( The Godel-set version of the Axiom of Power Sets.  (Contributed by Mario
     Carneiro, 14-Jul-2013.) $)
  df-gzpow $a |- AxPow =
    E.g 1o A.g 2o ( A.g 1o ( ( 1o e.g 2o ) <->g ( 1o e.g (/) ) ) ->g
                    ( 2o e.g 1o ) ) $.

  $( The Godel-set version of the Axiom of Unions.  (Contributed by Mario
     Carneiro, 14-Jul-2013.) $)
  df-gzun $a |- AxUn =
    E.g 1o A.g 2o ( E.g 1o ( ( 2o e.g 1o ) /\g ( 1o e.g (/) ) ) ->g
                    ( 2o e.g 1o ) ) $.

  $( The Godel-set version of the Axiom of Regularity.  (Contributed by Mario
     Carneiro, 14-Jul-2013.) $)
  df-gzreg $a |- AxReg = ( E.g 1o ( 1o e.g (/) ) ->g
      E.g 1o ( ( 1o e.g (/) ) /\g
               A.g 2o ( ( 2o e.g 1o ) ->g -.g ( 2o e.g (/) ) ) ) ) $.

  $( The Godel-set version of the Axiom of Infinity.  (Contributed by Mario
     Carneiro, 14-Jul-2013.) $)
  df-gzinf $a |- AxInf = E.g 1o ( ( (/) e.g 1o ) /\g A.g 2o ( ( 2o e.g 1o ) ->g
      E.g (/) ( ( 2o e.g (/) ) /\g ( (/) e.g 1o ) ) ) ) $.

  ${
    $d m u $.
    $( Define the class of all (transitive) models of ZF. (Contributed by Mario
       Carneiro, 14-Jul-2013.) $)
    df-gzf $a |- ZF = { m | ( ( Tr m /\ m |= AxExt /\ m |= AxPow ) /\
                              ( m |= AxUn /\ m |= AxReg /\ m |= AxInf ) /\
                              A. u e. ( Fmla ` om ) m |= ( AxRep ` u ) ) } $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Splitting fields
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c IntgRing $. $( Integral subring of a ring $)
  $c cplMetSp $. $( Completion of a metric space $)
  $c HomLimB $. $( Direct limit auxiliaries $)
  $c HomLim $. $( Direct limit structure $)
  $c polyFld $. $( Polynomial extension field $)
  $c splitFld1 $. $( Splitting field for a polynomial auxiliary $)
  $c splitFld $. $( Splitting field for a polynomial $)
  $c polySplitLim $. $( Splitting field for a sequence of polynomials $)

  $( Integral subring of a ring. $)
  citr $a class IntgRing $.

  $( Completion of a metric space. $)
  ccpms $a class cplMetSp $.

  $( Embeddings for a direct limit. $)
  chlb $a class HomLimB $.

  $( Direct limit structure. $)
  chlim $a class HomLim $.

  $( Polynomial extension field. $)
  cpfl $a class polyFld $.

  $( Splitting field for a single polynomial (auxiliary). $)
  csf1 $a class splitFld1 $.

  $( Splitting field for a finite set of polynomials. $)
  csf $a class splitFld $.

  $( Splitting field for a sequence of polynomials. $)
  cpsl $a class polySplitLim $.

  ${
    $d b d e f g h i j m n o p q r s t v w x y z $.
    $( Define the subring of elements of ` r ` integral over ` s ` in a ring.
       (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-irng $a |- IntgRing = ( r e. _V , s e. _V |->
      U_ f e. ( Monic1p ` ( r |`s s ) ) ( `' f " { ( 0g ` r ) } ) ) $.

    $( A function which completes the given metric space.  (Contributed by
       Mario Carneiro, 2-Dec-2014.) $)
    df-cplmet $a |- cplMetSp = ( w e. _V |->
      [_ ( ( w ^s NN ) |`s ( Cau ` ( dist ` w ) ) ) / r ]_
      [_ ( Base ` r ) / v ]_ [_ { <. f , g >. | ( { f , g } C_ v /\
        A. x e. RR+ E. j e. ZZ ( f |` ( ZZ>= ` j ) ) :
          ( ZZ>= ` j ) --> ( ( g ` j ) ( ball ` ( dist ` w ) ) x ) ) } / e ]_
      ( ( r /s e ) sSet { <. ( dist ` ndx ) , { <. <. x , y >. , z >. |
        E. p e. v E. q e. v ( ( x = [ p ] e /\ y = [ q ] e ) /\
          ( p oF ( dist ` r ) q ) ~~> z ) } >. } ) ) $.

    $( The input to this function is a sequence (on ` NN ` ) of homomorphisms
       ` F ( n ) : R ( n ) --> R ( n + 1 ) ` .  The resulting structure is the
       direct limit of the direct system so defined.  This function returns the
       pair ` <. S , G >. ` where ` S ` is the terminal object and ` G ` is a
       sequence of functions such that ` G ( n ) : R ( n ) --> S ` and
       ` G ( n ) = F ( n ) o. G ( n + 1 ) ` .  (Contributed by Mario Carneiro,
       2-Dec-2014.) $)
    df-homlimb $a |- HomLimB = ( f e. _V |->
     [_ U_ n e. NN ( { n } X. dom ( f ` n ) ) / v ]_
     [_ |^| { s | ( s Er v /\ ( x e. v |-> <. ( ( 1st ` x ) + 1 ) ,
          ( ( f ` ( 1st ` x ) ) ` ( 2nd ` x ) ) >. ) C_ s ) } / e ]_
    <. ( v /. e ) , ( n e. NN |->
       ( x e. dom ( f ` n ) |-> [ <. n , x >. ] e ) ) >. ) $.

    $( The input to this function is a sequence (on ` NN ` ) of structures
       ` R ( n ) ` and homomorphisms ` F ( n ) : R ( n ) --> R ( n + 1 ) ` .
       The resulting structure is the direct limit of the direct system so
       defined, and maintains any structures that were present in the original
       objects.  TODO: generalize to directed sets?  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    df-homlim $a |- HomLim = ( r e. _V , f e. _V |->
     [_ ( HomLimB ` f ) / e ]_ [_ ( 1st ` e ) / v ]_ [_ ( 2nd ` e ) / g ]_
    ( { <. ( Base ` ndx ) , v >. ,
        <. ( +g ` ndx ) , U_ n e. NN ran ( x e. dom ( g ` n ) ,
        y e. dom ( g ` n ) |-> <. <. ( ( g ` n ) ` x ) , ( ( g ` n ) ` y ) >. ,
          ( ( g ` n ) ` ( x ( +g ` ( r ` n ) ) y ) ) >. ) >. ,
        <. ( .r ` ndx ) , U_ n e. NN ran ( x e. dom ( g ` n ) ,
        y e. dom ( g ` n ) |-> <. <. ( ( g ` n ) ` x ) , ( ( g ` n ) ` y ) >. ,
          ( ( g ` n ) ` ( x ( .r ` ( r ` n ) ) y ) ) >. ) >. } u.
      { <. ( TopOpen ` ndx ) , { s e. ~P v |
           A. n e. NN ( `' ( g ` n ) " s ) e. ( TopOpen ` ( r ` n ) ) } >. ,
        <. ( dist ` ndx ) , U_ n e. NN ran ( x e. dom ( ( g ` n ) ` n ) ,
        y e. dom ( ( g ` n ) ` n ) |-> <. <. ( ( g ` n ) ` x ) ,
             ( ( g ` n ) ` y ) >. , ( x ( dist ` ( r ` n ) ) y ) >. ) >. ,
        <. ( le ` ndx ) , U_ n e. NN ( `' ( g ` n ) o.
           ( ( le ` ( r ` n ) ) o. ( g ` n ) ) ) >. } ) ) $.

    $( Define the field extension that augments a field with the root of the
       given irreducible polynomial, and extends the norm if one exists and the
       extension is unique.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-plfl $a |- polyFld = ( r e. _V , p e. _V |-> [_ ( Poly1 ` r ) / s ]_
      [_ ( ( RSpan ` s ) ` { p } ) / i ]_
      [_ ( z e. ( Base ` r ) |->
           [ ( z ( .s ` s ) ( 1r ` s ) ) ] ( s ~QG i ) ) / f ]_
      <. [_ ( s /s ( s ~QG i ) ) / t ]_ ( ( t toNrmGrp ( iota_ n e.
        ( AbsVal ` t ) ( n o. f ) = ( norm ` r ) ) ) sSet <. ( le ` ndx ) ,
          [_ ( z e. ( Base ` t ) |->
            ( iota_ q e. z ( r deg1 q ) < ( r deg1 p ) ) ) / g ]_
          ( `' g o. ( ( le ` s ) o. g ) ) >. ) , f >. ) $.

    $( Temporary construction for the splitting field of a polynomial.  The
       inputs are a field ` r ` and a polynomial ` p ` that we want to split,
       along with a tuple ` j ` in the same format as the output.  The output
       is a tuple ` <. S , F >. ` where ` S ` is the splitting field and ` F `
       is an injective homomorphism from the original field ` r ` .

       The function works by repeatedly finding the smallest monic irreducible
       factor, and extending the field by that factor using the ` polyFld `
       construction.  We keep track of a total order in each of the splitting
       fields so that we can pick an element definably without needing global
       choice.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-sfl1 $a |- splitFld1 = ( r e. _V , j e. _V |-> ( p e. ( Poly1 ` r ) |->
        ( rec ( ( s e. _V , f e. _V |-> [_ ( mPoly ` s ) / m ]_
        [_ { g e. ( ( Monic1p ` s ) i^i ( Irred ` m ) ) |
             ( g ( ||r ` m ) ( p o. f ) /\ 1 < ( s deg1 g ) ) } / b ]_
        if ( ( ( p o. f ) = ( 0g ` m ) \/ b = (/) ) , <. s , f >. ,
          [_ ( glb ` b ) / h ]_ [_ ( s polyFld h ) / t ]_
          <. ( 1st ` t ) , ( f o. ( 2nd ` t ) ) >. ) ) , j ) `
        ( card ` ( 1 ... ( r deg1 p ) ) ) ) ) ) $.

    $( Define the splitting field of a finite collection of polynomials, given
       a total ordered base field.  The output is a tuple ` <. S , F >. ` where
       ` S ` is the totally ordered splitting field and ` F ` is an injective
       homomorphism from the original field ` r ` .  (Contributed by Mario
       Carneiro, 2-Dec-2014.) $)
    df-sfl $a |- splitFld = ( r e. _V , p e. _V |->
        ( iota x E. f ( f Isom < , ( lt ` r ) ( ( 1 ... ( # ` p ) ) , p ) /\
          x = ( seq 0 ( ( e e. _V , g e. _V |->
            ( ( r splitFld1 e ) ` g ) ) , ( f u.
        { <. 0 , <. r , ( _I |` ( Base ` r ) ) >. >. } ) ) `
          ( # ` p ) ) ) ) ) $.

    $( Define the direct limit of an increasing sequence of fields produced by
       pasting together the splitting fields for each sequence of polynomials.
       That is, given a ring ` r ` , a strict order on ` r ` , and a sequence
       ` p : NN --> ( ~P r i^i Fin ) ` of finite sets of polynomials to split,
       we construct the direct limit system of field extensions by splitting
       one set at a time and passing the resulting construction to
       ` HomLim ` .  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-psl $a |- polySplitLim = ( r e. _V ,
      p e. ( ( ~P ( Base ` r ) i^i Fin ) ^m NN ) |->
    [_ ( 1st o. seq 0 ( ( g e. _V , q e. _V |->
      [_ ( 1st ` g ) / e ]_ [_ ( 1st ` e ) / s ]_
      [_ ( s splitFld ran ( x e. q |-> ( x o. ( 2nd ` g ) ) ) ) / f ]_
        <. f , ( ( 2nd ` g ) o. ( 2nd ` f ) ) >. ) ,
        ( p u. { <. 0 , <. <. r , (/) >. ,
          ( _I |` ( Base ` r ) ) >. >. } ) ) ) / f ]_
      ( ( 1st o. ( f shift 1 ) ) HomLim ( 2nd o. f ) ) ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         <i>p</i>-adic number fields
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Introduce new constant symbols. $)
  $c ZRing $. $( Integral elements of a ring $)
  $c GF $. $( Galois finite field $)
  $c GF_oo $. $( Galois limit field $)
  $c ~Qp $. $( Equivalence relation for Qp $)
  $c /Qp $. $( Representative of equivalence relation $)
  $c Qp $. $( p-adic rational numbers $)
  $c Zp $. $( p-adic integers $)
  $c _Qp $. $( Algebraic completion of Qp $)
  $c Cp $. $( Metric completion of _Qp $)

  $( Integral elements of a ring. $)
  czr $a class ZRing $.

  $( Galois finite field. $)
  cgf $a class GF $.

  $( Galois limit field. $)
  cgfo $a class GF_oo $.

  $( Equivalence relation for ~ df-qp . $)
  ceqp $a class ~Qp $.

  $( Equivalence relation representatives for ~ df-qp . $)
  crqp $a class /Qp $.

  $( The set of ` p ` -adic rational numbers. $)
  cqp $a class Qp $.

  $( The set of ` p ` -adic integers.  (Not to be confused with ~ czn .) $)
  czp $a class Zp $.

  $( Algebraic completion of the ` p ` -adic rational numbers. $)
  cqpa $a class _Qp $.

  $( Metric completion of ` _Qp ` . $)
  ccp $a class Cp $.

  ${
    $d b d f g h i k n p r s x y z $.
    $( Define the subring of integral elements in a ring.  (Contributed by
       Mario Carneiro, 2-Dec-2014.) $)
    df-zrng $a |- ZRing = ( r e. _V |->
      ( r IntgRing ran ( ZRHom ` r ) ) ) $.

    $( Define the Galois finite field of order ` p ^ n ` .  (Contributed by
       Mario Carneiro, 2-Dec-2014.) $)
    df-gf $a |- GF = ( p e. Prime , n e. NN |-> [_ ( Z/nZ ` p ) / r ]_
    ( 1st ` ( r splitFld { [_ ( Poly1 ` r ) / s ]_ [_ ( var1 ` r ) / x ]_
        ( ( ( p ^ n ) ( .g ` ( mulGrp ` s ) ) x ) ( -g ` s ) x ) } ) ) ) $.

    $( Define the Galois field of order ` p ^ +oo ` , as a direct limit of the
       Galois finite fields.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-gfoo $a |- GF_oo = ( p e. Prime |-> [_ ( Z/nZ ` p ) / r ]_
      ( r polySplitLim ( n e. NN |->
      { [_ ( Poly1 ` r ) / s ]_ [_ ( var1 ` r ) / x ]_
        ( ( ( p ^ n ) ( .g ` ( mulGrp ` s ) ) x ) ( -g ` s ) x ) } ) ) ) $.

    $( Define an equivalence relation on ` ZZ ` -indexed sequences of integers
       such that two sequences are equivalent iff the difference is equivalent
       to zero, and a sequence is equivalent to zero iff the sum
       ` sum_ k <_ n f ( k ) ( p ^ k ) ` is a multiple of ` p ^ ( n + 1 ) ` for
       every ` n ` .  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-eqp $a |- ~Qp = ( p e. Prime |->
      { <. f , g >. | ( { f , g } C_ ( ZZ ^m ZZ ) /\
       A. n e. ZZ sum_ k e. ( ZZ>= ` -u n ) ( ( ( f ` -u k ) - ( g ` -u k ) ) /
        ( p ^ ( k + ( n + 1 ) ) ) ) e. ZZ ) } ) $.

    $( There is a unique element of ` ( ZZ ^m ( 0 ... ( p - 1 ) ) ) ` ` ~Qp `
       -equivalent to any element of ` ( ZZ ^m ZZ ) ` , if the sequences are
       zero for sufficiently large negative values; this function selects that
       element.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-rqp $a |- /Qp = ( p e. Prime |-> ( ~Qp i^i [_ { f e. ( ZZ ^m ZZ ) |
      E. x e. ran ZZ>= ( `' f " ( ZZ \ { 0 } ) ) C_ x } / y ]_
        ( y X. ( y i^i ( ZZ ^m ( 0 ... ( p - 1 ) ) ) ) ) ) ) $.

    $( Define the ` p ` -adic completion of the rational numbers, as a normed
       field structure with a total order (that is not compatible with the
       operations).  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-qp $a |- Qp = ( p e. Prime |->
        [_ { h e. ( ZZ ^m ( 0 ... ( p - 1 ) ) ) |
          E. x e. ran ZZ>= ( `' h " ( ZZ \ { 0 } ) ) C_ x } / b ]_
  ( ( { <. ( Base ` ndx ) , b >. ,
        <. ( +g ` ndx ) ,
          ( f e. b , g e. b |-> ( ( /Qp ` p ) ` ( f oF + g ) ) ) >. ,
        <. ( .r ` ndx ) ,
          ( f e. b , g e. b |-> ( ( /Qp ` p ) ` ( n e. ZZ |->
           sum_ k e. ZZ ( ( f ` k ) x. ( g ` ( n - k ) ) ) ) ) ) >. } u.
      { <. ( le ` ndx ) , { <. f , g >. | ( { f , g } C_ b /\
        sum_ k e. ZZ ( ( f ` -u k ) x. ( ( p + 1 ) ^ -u k ) ) <
        sum_ k e. ZZ ( ( g ` -u k ) x. ( ( p + 1 ) ^ -u k ) ) ) } >. } )
        toNrmGrp ( f e. b |-> if ( f = ( ZZ X. { 0 } ) , 0 ,
        ( p ^ -u sup ( ( `' f " ( ZZ \ { 0 } ) ) , RR , `' < ) ) ) ) ) ) $.

    $( Define the ` p ` -adic integers, as a subset of the ` p ` -adic
       rationals.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-zp $a |- Zp = ( ZRing o. Qp ) $.

    $( Define the completion of the ` p ` -adic rationals.  Here we simply
       define it as the splitting field of a dense sequence of polynomials
       (using as the ` n ` -th set the collection of polynomials with degree
       less than ` n ` and with coefficients ` < ( p ^ n ) ` ).  Krasner's
       lemma will then show that all monic polynomials have splitting fields
       isomorphic to a sufficiently close Eisenstein polynomial from the list,
       and unramified extensions are generated by the polynomial
       ` x ^ ( p ^ n ) - x ` , which is in the list.  Thus, every finite
       extension of ` Qp ` is a subfield of this field extension, so it is
       algebraically closed.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-qpa $a |- _Qp = ( p e. Prime |-> [_ ( Qp ` p ) / r ]_
      ( r polySplitLim ( n e. NN |-> { f e. ( Poly1 ` r ) |
        ( ( r deg1 f ) <_ n /\ A. d e. ran ( coe1 ` f )
          ( `' d " ( ZZ \ { 0 } ) ) C_ ( 0 ... n ) ) } ) ) ) $.

    $( Define the metric completion of the algebraic completion of the ` p `
       -adic rationals.  (Contributed by Mario Carneiro, 2-Dec-2014.) $)
    df-cp $a |- Cp = ( cplMetSp o. _Qp ) $.
  $}

  $( TODO list $)

  $( change *mpt2* -> *mpo* $)
  $( use more symbol variables like .+ $)
  $( Uniform spaces $)
  $( Characterization of perfectly normal spaces $)
  $( Hausdorff quotient $)
  $( Make SymGrp a subgroup of EndoMnd (the TopMnd of functions X --> X) $)
  $( add mpt2mptf, fmpt2i $)

$( (End of Mario Carneiro's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Paul Chapman
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Propositional calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                               Prime numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Finite set induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      The ` # ` (finite set size) function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Group homomorphism and isomorphism
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.  $d B y $.  $d F w x y z $.  $d G x y $.  $d H w x y z $.
    $d M y z $.  $d S x y $.  $d T x y $.  $d X w x y z $.  $d Z w x y z $.
    ghomgrpilem1.1 $e |- G e. GrpOp $.
    ghomgrpilem1.2 $e |- H e. GrpOp $.
    ghomgrpilem1.3 $e |- F e. ( G GrpOpHom H ) $.
    ghomgrpilem1.4 $e |- X = ran G $.
    ghomgrpilem1.5 $e |- U = ( GId ` G ) $.
    ghomgrpilem1.6 $e |- N = ( inv ` G ) $.
    ghomgrpilem1.7 $e |- W = ran H $.
    ghomgrpilem1.8 $e |- T = ( GId ` H ) $.
    ghomgrpilem1.9 $e |- M = ( inv ` H ) $.
    ghomgrpilem1.10 $e |- Z = ran F $.
    ghomgrpilem1.11 $e |- S = ( H |` ( Z X. Z ) ) $.
    $( Lemma for ~ ghomgrpi .  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    ghomgrpilem1 $p |- ( ( A e. X /\ B e. X ) ->
                         ( ( F ` A ) H ( F ` B ) ) = ( F ` ( A G B ) ) ) $=
      ( vy vx wcel cv co wceq wral fveq2 oveq1d oveq1 fveq2d eqeq12d ralbidv wf
      cfv cghom wa wb elghom mp2an mpbi simpri vtoclri oveq2d oveq2 rspcv mpan9
      cgr ) ALUGAFUSZUEUHZFUSZHUIZAVNGUIZFUSZUJZUELUKZBLUGVMBFUSZHUIZABGUIZFUSZ
      UJZUFUHZFUSZVOHUIZWFVNGUIZFUSZUJZUELUKZVTUFALWFAUJZWKVSUELWMWHVPWJVRWMWGV
      MVOHWFAFULUMWMWIVQFWFAVNGUNUOUPUQLKFURZWLUFLUKZFGHUTUIUGZWNWOVAZPGVLUGHVL
      UGWPWQVBNOUFUEFGHKLQTVCVDVEVFVGVSWEUEBLVNBUJZVPWBVRWDWRVOWAVMHVNBFULVHWRV
      QWCFVNBAGVIUOUPVJVK $.

    $( Lemma for ~ ghomgrpi .  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    ghomgrpilem2 $p |- S e. ( SubGrpOp ` H ) $=
      ( vx vy vz vw crn wf wss cv cfv co wceq wral cghom wa cgr wb elghom mp2an
      wcel mpbi simpli frn ax-mp eqsstri wrex eleq2i wfn fvelrnb biimpi anim12i
      ffn bitri reeanv sylibr ghomgrpilem1 grpocl dffn3 feq3 mpbir ffvelrni syl
      mp3an1 eqeltrd oveq12 eleq1d syl5ibcom rexlimivv cgi grpolid fveq2i eqtri
      grpoidcl ffvelrn eqid grpoid eqtr4i eqeltri grpoinvcl mpan mpdan grporinv
      fveq2d eqtrd syl6eqr grpoinvid1 syl2anc mpbird fveq2 rexlimiv issubgoi
      sylbi ) UCUDBFAGIKMRSTKDUGZIUAJIDUHZXNIUIXOUCUJZDUKUDUJZDUKFULXPXQEULDUKU
      MUDJUNUCJUNZDEFUOULVAZXOXRUPZNEUQVAZFUQVAZXSXTURLMUCUDDEFIJORUSUTVBVCZJID
      VDVEVFUBXPKVAZXQKVAZUPZUEUJZDUKZXPUMZUFUJZDUKZXQUMZUPZUFJVGUEJVGZXPXQFULZ
      KVAZYFYIUEJVGZYLUFJVGZUPYNYDYQYEYRYDYQYDXPXNVAZYQKXNXPUAVHDJVIZYSYQURXOYT
      YCJIDVMVEZUEJXPDVJVEVNZVKYEYRYEXQXNVAZYRKXNXQUAVHYTUUCYRURUUAUFJXQDVJVEVN
      VKVLYIYLUEUFJJVOVPYMYPUEUFJJYGJVAZYJJVAZUPZYHYKFULZKVAYMYPUUFUUGYGYJEULZD
      UKZKYGYJABCDEFGHIJKLMNOPQRSTUAUBVQUUFUUHJVAZUUIKVAYAUUDUUEUUJLYGYJEJOVRWD
      JKUUHDJKDUHZJXNDUHZYTUULUUAJDVSVBKXNUMUUKUULURUAKXNJDVTVEWAZWBWCWEYMUUGYO
      KYHXPYKXQFWFWGWHWIWCBCDUKZKBFWJUKZUUNSUUNUUOUMZUUNUUNFULZUUNUMZUUQCCEULZD
      UKZUUNCJVAZUVAUUQUUTUMYAUVALCEJOPWNVEZUVBCCABCDEFGHIJKLMNOPQRSTUAUBVQUTUU
      SCDYAUVAUUSCUMLUVBCCEJOPWKUTWLWMYBUUNIVAZUUPUURURMXOUVAUVCYCUVBJICDWOUTUU
      NUUOFIRUUOWPWQUTWAWRZUUKUVAUUNKVAUUMUVBJKCDWOUTWSYDYQXPGUKZKVAZUUBYIUVFUE
      JUUDYHGUKZKVAYIUVFUUDUVGYGHUKZDUKZKUUDUVGUVIUMZYHUVIFULZBUMZUUDUVKUUNBUUD
      UVKYGUVHEULZDUKZUUNUUDUVHJVAZUVKUVNUMYAUUDUVOLYGEHJOQWTXAZYGUVHABCDEFGHIJ
      KLMNOPQRSTUAUBVQXBUUDUVMCDYAUUDUVMCUMLYGCEHJOPQXCXAXDXEUVDXFUUDYHIVAZUVII
      VAZUVJUVLURZJIYGDYCWBUUDUVOUVRUVPJIUVHDYCWBWCYBUVQUVRUVSMYHUVIBFGIRSTXGWD
      XHXIUUDUVOUVIKVAUVPJKUVHDUUMWBWCWEYIUVGUVEKYHXPGXJWGWHXKXMXL $.
  $}

  ${
    ghomgrpi.1 $e |- G e. GrpOp $.
    ghomgrpi.2 $e |- H e. GrpOp $.
    ghomgrpi.3 $e |- F e. ( G GrpOpHom H ) $.
    ghomgrpi.4 $e |- Y = ran F $.
    ghomgrpi.5 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( The image of a group homomorphism from ` G ` to ` H ` is a subgroup of
       ` H ` (inference version).  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    ghomgrpi $p |- S e. ( SubGrpOp ` H ) $=
      ( cgi cfv cgn crn eqid ghomgrpilem2 ) ADKLZCKLZBCDDMLZCMLZDNZCNZEFGHUBORO
      TOUAOQOSOIJP $.
  $}

  ${
    $d A x y $.  $d G x y $.
    ghomsn.1 $e |- A e. _V $.
    ghomsn.2 $e |- G = { <. <. A , A >. , A >. } $.
    $( The endomorphism of the trivial group.  (Contributed by Paul Chapman,
       25-Feb-2008.) $)
    ghomsn $p |- ( _I |` { A } ) e. ( G GrpOpHom G ) $=
      ( vx vy csn co wcel cv wceq wral ax-mp wa elsn fveq2 fvresi syl6eq eqtr4d
      cfv cid cres cghom wf wf1o f1oi f1of snid oveqan12d oveq12 syl2anb grposn
      cgr cop eqeltri crn opex rnsnop eqtr2i grpocl mp3an1 syl rgen2a wb elghom
      rneqi mp2an mpbir2an ) UAAGZUBZBBUCHIZVIVIVJUDZEJZVJTZFJZVJTZBHZVMVOBHZVJ
      TZKZFVILEVILZVIVIVJUEVLVIUFVIVIVJUGMVTEFVIVMVIIZVOVIIZNZVQVRVSWBVMAKZVOAK
      ZVQVRKWCEAOFAOWEWFNVQAABHVRWEWFVNAVPABWEVNAVJTZAVMAVJPAVIIWGAKACUHVIAQMZR
      WFVPWGAVOAVJPWHRUIVMAVOABUJSUKWDVRVIIZVSVRKBUMIZWBWCWIBAAUNZAUNGZUMDACULU
      OZVMVOBVIBUPWLUPVIBWLDVFWKAAAUQURUSZUTVAVIVRQVBSVCWJWJVKVLWANVDWMWMEFVJBB
      VIVIWNWNVEVGVH $.
  $}

  ${
    ghomgrplem.1 $e |- ( ph ->
                      ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) )
        $.
    ghomgrplem.2 $e |- S = { <. <. z , z >. , z >. } $.
    ghomgrplem.3 $e |- J = ( _I |` { z } ) $.
    $( Lemma for ~ ghomgrp .  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    ghomgrplem $p |- ( ph
            -> ( H |` ( ran F X. ran F ) ) e. ( SubGrpOp ` H ) ) $=
      ( crn cxp cres csubgo wcel cif wceq cgr cghom eleq1 cfv reseq1 fveq2 rneq
      eleq12d xpeq1 xpeq2 eqtrd reseq2d syl eleq1d co simp1d cop csn vex grposn
      eqeltri elimdhyp simp2d simp3d cid ghomsn elimdelov eqid ghomgrpi dedth2v
      cv ) AFDKZVILZMZFNUAZOAFCPZVJMZVMNUAZOVMADGPZKZVQLZMZVOOFDCGFVMQVKVNVLVOF
      VMVJUBFVMNUCUEDVPQZVNVSVOVTVIVQQZVNVSQDVPUDWAVJVRVMWAVJVQVILVRVIVQVIUFVIV
      QVQUGUHUIUJUKVSVPAECPZVMVQAEROZWBROCROZECAWCFROZDEFSULOZHUMEWBRTCWBRTCBVH
      ZWGUNWGUNUORIWGBUPZUQURZUSAWEVMROWDFCAWCWEWFHUTFVMRTCVMRTWIUSAEFDSCCGAWCW
      EWFHVAGVBWGUOMCCSULJWGCWHIVCURVDVQVEVSVEVFVG $.
  $}

  ${
    ghomgrp.1 $e |- Y = ran F $.
    ghomgrp.2 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( The image of a group homomorphism from ` G ` to ` H ` is a subgroup of
       ` H ` .  (Contributed by Paul Chapman, 25-Feb-2008.) $)
    ghomgrp $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
                     S e. ( SubGrpOp ` H ) ) $=
      ( vx cgr wcel cghom co w3a crn cxp cres wceq cop csn eqid cfv ax-mp eqtri
      csubgo xpid11 reseq2 sylbir cv cid id ghomgrplem syl5eqel ) CIJDIJBCDKLJM
      ZADBNZUNOZPZDUDUAADEEOZPZUPGEUNQZURUPQZFUSUQUOQUTEUNUEUQUODUFUGUBUCUMHHUH
      ZVARVARSZBCDUIVASPZUMUJVBTVCTUKUL $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.  $d X x y $.
    ghomfo.1 $e |- X = ran G $.
    ghomfo.2 $e |- Y = ran F $.
    ghomfo.3 $e |- S = ( H |` ( Y X. Y ) ) $.
    ghomfo.4 $e |- Z = ran S $.
    $( A group homomorphism maps onto its image.  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomfo $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
                   F : X -onto-> Z ) $=
      ( vx vy cgr wcel co wceq wfo cfv wss cghom w3a wfn crn wf cv wral wa eqid
      elghom biimp3a simpld ffn syl cxp cres dmeqi csubgo ghomgrp issubgo sylib
      cdm simp2d grpofo fof fdm 4syl frn syl5eqss xpss12 syl2anc ssdmres sseq2d
      wb 3syl syl5rbbr 3ad2ant2 mpbid 3eqtr3a xpid11 syl6req df-fo sylanbrc ) C
      NOZDNOZBCDUAPOZUBZBEUCZBUDZGQEGBRWGEDUDZBUEZWHWGWKLUFZBSMUFZBSDPWLWMCPBSQ
      MEUGLEUGZWDWEWFWKWNUHLMBCDWJEHWJUIZUJUKULZEWJBUMUNWGGFWIWGGGUOZFFUOZQGFQW
      GAVBZDWRUPZVBZWQWRAWTJUQWGANOZWQGARWQGAUEWSWQQWGWEXBADTZWGADURSOWEXBXCUBA
      BCDFIJUSDAUTVAVCAGKVDWQGAVEWQGAVFVGWGWRWJWJUOZTZXAWRQZWGFWJTZXGXEWGFWIWJI
      WGWKWIWJTWPEWJBVHUNVIZXHFWJFWJVJVKWEWDXEXFVNWFXFWRDVBZTWEXEWRDVLWEXIXDWRW
      EXDWJDRXDWJDUEXIXDQDWJWOVDXDWJDVEXDWJDVFVOVMVPVQVRVSGFVTVAIWAEGBWBWC $.

    $( Closure of a group homomorphism.  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomcl $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
                   ( A e. X -> ( F ` A ) e. Z ) ) $=
      ( cgr wcel cghom co w3a wfo wf cfv wi ghomfo fof ffvelrn ex 3syl ) DMNEMN
      CDEOPNQFHCRFHCSZAFNZACTHNZUABCDEFGHIJKLUBFHCUCUGUHUIFHACUDUEUF $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.  $d S x y $.
    ghomgsg.1 $e |- Y = ran F $.
    ghomgsg.2 $e |- S = ( H |` ( Y X. Y ) ) $.
    $( A group homomorphism from ` G ` to ` H ` is also a group homomorphism
       from ` G ` to its image in ` H ` .  (Contributed by Paul Chapman,
       3-Mar-2008.) $)
    ghomgsg $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
                    F e. ( G GrpOpHom S ) ) $=
      ( vx vy cgr wcel cghom co w3a crn cfv wceq wral eqid wa wf wfo ghomfo fof
      syl elghom biimp3a simprd ffvelrn anim12dan csubgo ghomgrp subgoov syldan
      cv sylan eqeq1d 2ralbidva mpbird wss issubgo sylib simp2d biimprd 3adant3
      wi syld3an2 mp2and ) CJKZDJKZBCDLMKZNZCOZAOZBUAZHUOZBPZIUOZBPZAMZVPVRCMBP
      ZQZIVMRHVMRZBCALMKZVLVMVNBUBVOABCDVMEVNVMSZFGVNSZUCVMVNBUDUEZVLWCVQVSDMZW
      AQZIVMRHVMRZVLVMDOZBUAZWJVIVJVKWLWJTHIBCDWKVMWEWKSUFUGUHVLWBWIHIVMVMVLVPV
      MKZVRVMKZTZTVTWHWAVLWOVQVNKZVSVNKZTZVTWHQZVLVOWOWRWGVOWMWPWNWQVMVNVPBUIVM
      VNVRBUIUJUPVLADUKPKZWRWSABCDEFGULZVQVSDAVNWFUMUPUNUQURUSVIAJKZVJVKVOWCTZW
      DVFZVLVJXBADUTZVLWTVJXBXENXADAVAVBVCVIXBXDVKVIXBTWDXCHIBCAVNVMWEWFUFVDVEV
      GVH $.
  $}

  ${
    $d F x $.  $d G x $.  $d H x $.  $d T x $.  $d U x $.  $d X x $.  $d Z x $.
    ghomf1olem.1 $e |- X = ran G $.
    ghomf1olem.2 $e |- Y = ran F $.
    ghomf1olem.3 $e |- S = ( H |` ( Y X. Y ) ) $.
    ghomf1olem.4 $e |- Z = ran S $.
    ghomf1olem.5 $e |- U = ( GId ` G ) $.
    ghomf1olem.6 $e |- T = ( GId ` H ) $.

    ${
      $d F x y z $.  $d G y z $.  $d H y z $.  $d N x $.  $d T y z $.
      $d U y z $.  $d X y z $.
      ghomf1olem.7 $e |- N = ( inv ` G ) $.
      $( Lemma for ~ ghomf1o .  (Contributed by Paul Chapman, 3-Mar-2008.) $)
      ghomf1olem $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) )
          ->
          ( F : X -1-1-onto-> Z <-> A. x e. X ( ( F ` x ) = T -> x = U ) ) ) $=
        ( wceq wi vy vz cgr wcel cghom co w3a wf1o cv cfv wf wf1 wa f1of1 dff13
        sylib simprd grpoidcl fveq2 eqeq1d equequ1 imbi12d eqeq2d rspc2v expcom
        wral eqeq2 syl com23 3ad2ant1 syl5 ghomid imbi1d imbi2d sylibd ralrimdv
        wfo ghomfo adantr fof grpoinvcl grpocl syld3an3 3expib eqeq1 rspcv syl6
        3adant2 imp oveq1 3ad2ant3 simprl 3ad2antl1 adantrl jca ghomlin 3adant3
        syldan simprr grporinv fveq2d 3eqtrd 3eqtr3d 3expia grpo2inv grpoinvid2
        wb equcom 3com23 bitr3d syl5bbr biimprd imim12d syld impancom ralrimivv
        3expb sylanbrc df-f1o ex impbid ) FUCUDZGUCUDZEFGUEUFUDZUGZIKEUHZAUIZEU
        JZCSZYGDSZTZAIVFZYEYFYKAIYEYFYGIUDZYHDEUJZSZYJTZTZYMYKTYFUAUIZEUJZUBUIZ
        EUJZSZYRYTSZTZUBIVFUAIVFZYEYQYFIKEUKZUUEYFIKEULZUUFUUEUMIKEUNUAUBIKEUOZ
        UPUQYBYCUUEYQTYDYBYMUUEYPYBDIUDZYMUUEYPTZTDFILPURYMUUIUUJUUDYPYHUUASZYG
        YTSZTUAUBYGDIIYRYGSZUUBUUKUUCUULUUMYSYHUUAYRYGEUSUTUAAUBVAVBYTDSZUUKYOU
        ULYJUUNUUAYNYHYTDEUSVCYTDYGVGVBVDVEVHVIVJVKYEYPYKYMYEYOYIYJYEYNCYHCDEFG
        PQVLZVCVMVNVOVPYEYLYFYEYLUMZUUGIKEVQZYFUUPUUFUUEUUGUUPUUQUUFYEUUQYLBEFG
        IJKLMNOVRVSZIKEVTVHUUPUUDUAUBIIYEYRIUDZYTIUDZUMZYLUUDYEUVAUMZYLYRYTHUJZ
        FUFZEUJZCSZUVDDSZTZUUDYEUVAYLUVHTZYEUVAUVDIUDZUVIYBYCUVAUVJTYDYBUUSUUTU
        VJYBUUSUUTUVCIUDZUVJYBUUTUVKUUSYTFHILRWAZWHZYRUVCFILWBWCWDVJYKUVHAUVDIY
        GUVDSZYIUVFYJUVGUVNYHUVECYGUVDEUSUTYGUVDDWEVBWFWGWIUVBUUBUVFUVGUUCYEUVA
        UUBUVFYEUVAUUBUGYSUVCEUJZGUFZUUAUVOGUFZUVECUUBYEUVPUVQSUVAYSUUAUVOGWJWK
        YEUVAUVPUVESZUUBYEUVAUUSUVKUMUVRUVBUUSUVKYEUUSUUTWLYEUUTUVKUUSYBYCUUTUV
        KYDUVLWMWNZWOYRUVCEFGILWPWRWQYEUVAUVQCSUUBUVBUVQYTUVCFUFZEUJZYNCYEUVAUU
        TUVKUMUVQUWASUVBUUTUVKYEUUSUUTWSUVSWOYTUVCEFGILWPWRUVBUVTDEYEUUTUVTDSZU
        USYBYCUUTUWBYDYTDFHILPRWTWMWNXAYEYNCSUVAUUOVSXBWQXCXDUVBUUCUVGYBYCUVAUU
        CUVGXGZYDYBUUSUUTUWCUUCYTYRSZYBUUSUUTUGZUVGUBUAXHUWEUVCHUJZYRSZUWDUVGUW
        EUWFYTYRYBUUTUWFYTSUUSYTFHILRXEWHUTYBUUSUUTUVKUWGUVGXGZUVMYBUVKUUSUWHUV
        CYRDFHILPRXFXIWCXJXKXQWMXLXMXNXOXPUUHXRUURIKEXSXRXTYA $.
    $}

    $( Two ways of saying a group homomorphism is 1-1-onto its image.
       (Contributed by Paul Chapman, 3-Mar-2008.) $)
    ghomf1o $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
        ( F : X -1-1-onto-> Z <-> A. x e. X ( ( F ` x ) = T -> x = U ) ) ) $=
      ( cgn cfv eqid ghomf1olem ) ABCDEFGFQRZHIJKLMNOPUAST $.
  $}

  ${
    $d F f $.  $d G f g h s $.  $d H f g h s $.
    $( Membership in the set of group isomorphisms from ` G ` to ` H ` .
       (Contributed by Paul Chapman, 25-Feb-2008.) $)
    elgiso $p |- ( ( G e. GrpOp /\ H e. GrpOp ) -> ( F e. ( G GrpOpIso H ) <->
        ( F e. ( G GrpOpHom H ) /\ F : ran G -1-1-onto-> ran H ) ) ) $=
      ( vf vg vh cgr wcel wa cgiso co crn cv wf1o cghom crab wceq wb rneq syl
      oveq1 f1oeq2 rabeqbidv oveq2 f1oeq3 ovex rabex ovmpt2 eleq2d f1oeq1 elrab
      df-giso syl6bb ) BGHCGHIZABCJKZHABLZCLZDMZNZDBCOKZPZHAUTHUPUQANZIUNUOVAAE
      FBCGGEMZLZFMZLZURNZDVCVEOKZPVAJUPVFURNZDBVEOKZPVCBQZVGVIDVHVJVCBVEOUAVKVD
      UPQVGVIRVCBSVDUPVFURUBTUCVECQZVIUSDVJUTVECBOUDVLVFUQQVIUSRVECSVFUQUPURUET
      UCDEFULUSDUTBCOUFUGUHUIUSVBDAUTUPUQURAUJUKUM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Real and complex numbers (cont.)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k m $.
    $( Utility lemma to convert between ` m <_ k ` and ` k e. ( ZZ>= `` m ) `
       in limit theorems.  (Contributed by Paul Chapman, 10-Nov-2012.) $)
    climuzcnv $p |- ( m e. NN -> ( ( k e. ( ZZ>= ` m ) -> ph ) <->
                                   ( k e. NN -> ( m <_ k -> ph ) ) ) ) $=
      ( cv cn wcel cuz cfv wi cle wbr wa elnnuz uztrn sylan2b sylibr expcom nnz
      c1 cz eluzle a1i jcad biimpri syl3an1 syl3an2 3expib impbid imbi1d impexp
      w3a eluz2 syl6bb ) CDZEFZBDZUNGHFZAIUPEFZUNUPJKZLZAIURUSAIIUOUQUTAUOUQUTU
      OUQURUSUQUOURUQUOLUPSGHZFZURUOUQUNVAFVBUNMUNUPSNOUPMPQUQUSIUOUNUPUAUBUCUO
      URUSUQURUOUPTFZUSUQUPRUOUNTFZVCUSUQUNRUQVDVCUSUKUNUPULUDUEUFUGUHUIURUSAUJ
      UM $.
  $}

  ${
    $d k w x y z F $.  $d k w y z H $.  $d k z M $.  $d k w y z ph $.
    $d k G $.
    sinccvg.1 $e |- ( ph -> F : NN --> ( RR \ { 0 } ) ) $.
    sinccvg.2 $e |- ( ph -> F ~~> 0 ) $.
    sinccvg.3 $e |- G = ( x e. ( RR \ { 0 } ) |-> ( ( sin ` x ) / x ) ) $.
    sinccvg.4 $e |- H = ( x e. CC |-> ( 1 - ( ( x ^ 2 ) / 3 ) ) ) $.
    sinccvg.5 $e |- ( ph -> M e. NN ) $.
    sinccvg.6 $e |- ( ( ph /\ k e. ( ZZ>= ` M ) ) ->
                      ( abs ` ( F ` k ) ) < 1 ) $.
    $( ` ( ( sin `` x ) / x ) ~~> 1 ` as (real) ` x ~~> 0 ` .  (Contributed by
       Paul Chapman, 10-Nov-2012.)  (Revised by Mario Carneiro,
       21-May-2014.) $)
    sinccvglem $p |- ( ph -> ( G o. F ) ~~> 1 ) $=
      ( c1 cc0 wcel cc co c3 cdiv vy vz vw ccom cvv cuz cfv eqid nnzd cli cv c2
      wfun cexp cmin funmpt2 cn cr csn cdif wf nnex sylancl cofunexg sylancr wa
      fex wne adantr nnuz uztrn2 sylan ffvelrnd eldifsn sylib simpld recnd sqcl
      ax-1cn 3cn 3ne0 divcl mp3an23 syl subcl fmpti ccncf crp cabs clt wbr wral
      wrex cmpt ccnfld ctopn ccn wtru ctopon cnfldtopon a1i cnmptc divccn mp2an
      wi sqcn oveq1 cnmpt11 ctx subcn cnmpt12f trud cncfcn1 3eltr4i mp3an1 wceq
      cncfi fvco3 syldan climcn1lem 0cn oveq1d syl6eq fvmpt csin ovex eqtrd 1re
      oveq2d eqeltrd fveq2 oveq12d resincld simprd cle cmul eqbrtrd cneg ltled
      id sq0i div0i subid1i 1ex ax-mp syl6breq resqcld nndivre resubcl redivcld
      3nn abscld subdird mulid2d caddc df-3 oveq2i cn0 2nn0 expp1 syl5eq div23d
      absresq eqtr2d cioc absrpcld rpgt0d ltle mpd cxr w3a 0xr elioc2 syl3anbrc
      sin01bnd ltmuldivd mpbid sinneg div2negd eqeq1d syl5ibrcom absord breqtrd
      wb mpjaod 3brtr4d mulid1d breqtrrd ltdivmuld mpbird eqbrtrrd climsqz ) AN
      CFDUDZEDUDZGUEGUFUGZUWOUHZAGLUIZAUWMOFUGZNUJAUAUBUCOCDUWMFGUEUWOUWPIAFUMD
      UEPZUWMUEPBQNBUKZULUNRZSTRZUORZFKUPAUQUROUSUTZDVAZUQUEPUWSHVBUQUXDUEDVGVC
      ZFDUEVDVEUWQACUKZUWOPZVFZUXGDUGZUXIUXJURPZUXJOVHZUXIUXJUXDPZUXKUXLVFUXIUQ
      UXDUXGDAUXEUXHHVIAGUQPUXHUXGUQPZLNUXGGUQVJVKVLZVMZUXJUROVNVOZVPZVQZBQQUXC
      FKUWTQPZNQPZUXBQPZUXCQPVSUXTUXAQPZUYBUWTVRUYCSQPZSOVHZUYBVTWAUXASWBWCWDNU
      XBWEVEWFFQQWGRZPOQPZUAUKZWHPUCUKZOUORWIUGUBUKWJWKUYIFUGUWRUORWIUGUYHWJWKX
      EUCQWLUBWHWMBQUXCWNZWOWPUGZUYKWQRZFUYFUYJUYLPWRBNUXBUOUYKUYKUYKUYKQUYKQWS
      UGPWRUYKUYKUHZWTXAZWRBNUYKUYKQQUYNUYNUYAWRVSXAXBWRBUAUXAUYHSTRZUXBUYKUYKU
      YKQQUYNBQUXAWNUYLPWRBUYKUYMXFXAUYNUAQUYOWNUYLPZWRUYDUYEUYPVTWAUASUYKUYMXC
      XDXAUYHUXASTXGXHUOUYKUYKXIRUYKWQRPWRUYKUYMXJXAXKXLKUYKUYMXMXNUBUCQQOUYHFX
      QXOAUXHUXNUXGUWMUGZUXJFUGZXPZUXOAUXEUXNUYSHUQUXDUXGFDXRVLXSZXTUYGUWRNXPYA
      BOUXCNQFUWTOXPZUXCNOUORNVUAUXBONUOVUAUXBOSTROVUAUXAOSTUWTUUAYBSVTWAUUBYCY
      INVSUUCYCKUUDYDUUEUUFAEUMUWSUWNUEPBUXDUWTYEUGZUWTTRZEJUPUXFEDUEVDVEUXIUYQ
      NUXJULUNRZSTRZUORZURUXIUYQUYRVUFUYTUXIUXJQPZUYRVUFXPUXSBUXJUXCVUFQFUWTUXJ
      XPZUXBVUENUOVUHUXAVUDSTUWTUXJULUNXGYBYIKNVUEUOYFYDWDYGZUXINURPZVUEURPZVUF
      URPYHUXIVUDURPSUQPVUKUXIUXJUXRUUGZUUKVUDSUUHVCZNVUEUUIVEZYJUXIUXGUWNUGZUX
      JYEUGZUXJTRZURUXIVUOUXJEUGZVUQAUXHUXNVUOVURXPZUXOAUXEUXNVUSHUQUXDUXGEDXRV
      LXSUXIUXMVURVUQXPUXPBUXJVUCVUQUXDEVUHVUBVUPUWTUXJTUWTUXJYEYKVUHYTYLJVUPUX
      JTYFYDWDYGZUXIVUPUXJUXIUXJUXRYMZUXRUXIUXKUXLUXQYNZUUJZYJUXIVUFVUQUYQVUOYO
      UXIVUFVUQVUNVVCUXIVUFUXJWIUGZYEUGZVVDTRZVUQWJUXIVUFVVDYPRZVVEWJWKVUFVVFWJ
      WKUXIVVGVVDVVDSUNRZSTRZUORZVVEWJUXIVVGNVVDYPRZVUEVVDYPRZUORVVJUXINVUEVVDU
      YAUXIVSXAUXIVUEVUMVQUXIVVDUXIUXJUXSUULZVQZUUMUXIVVKVVDVVLVVIUOUXIVVDVVNUU
      NUXIVVIVUDVVDYPRZSTRVVLUXIVVHVVOSTUXIVVHVVDULNUUORZUNRZVVOSVVPVVDUNUUPUUQ
      UXIVVQVVDULUNRZVVDYPRZVVOUXIVVDQPULUURPVVQVVSXPVVNUUSVVDULUUTVCUXIVVRVUDV
      VDYPUXIUXKVVRVUDXPUXRUXJUVCWDYBYGUVAYBUXIVUDVVDSUXIVUDVULVQVVNUYDUXIVTXAU
      YEUXIWAXAUVBUVDYLYGUXIVVJVVEWJWKZVVEVVDWJWKZUXIVVDONUVERPZVVTVWAVFUXIVVDU
      RPZOVVDWJWKZVVDNYOWKZVWBVVMUXIVVDUXIUXJUXSVVBUVFZUVGUXIVVDNWJWKZVWEMUXIVW
      CVUJVWGVWEXEVVMYHVVDNUVHVCUVIOUVJPVUJVWBVWCVWDVWEUVKUWDUVLYHONVVDUVMXDUVN
      VVDUVOWDZVPYQUXIVUFVVEVVDVUNUXIVVDVVMYMZVWFUVPUVQUXIVVDUXJXPZVVFVUQXPZVVD
      UXJYRZXPZVWJVWKXEUXIVWJVVEVUPVVDUXJTVVDUXJYEYKVWJYTYLXAUXIVWKVWMVWLYEUGZV
      WLTRZVUQXPUXIVWOVUPYRZVWLTRVUQUXIVWNVWPVWLTUXIVUGVWNVWPXPUXSUXJUVRWDYBUXI
      VUPUXJUXIVUPVVAVQUXSVVBUVSYGVWMVVFVWOVUQVWMVVEVWNVVDVWLTVVDVWLYEYKVWMYTYL
      UVTUWAUXIUXJUXRUWBUWEZUWCYSVUIVUTUWFUXIVUOVUQNYOVUTUXIVUQNVVCVUJUXIYHXAZU
      XIVVFVUQNWJVWQUXIVVFNWJWKVVEVVDNYPRZWJWKUXIVVEVVDVWSWJUXIVVTVWAVWHYNUXIVV
      DVVNUWGUWHUXIVVENVVDVWIVWRVWFUWIUWJUWKYSYQUWL $.
  $}

  ${
    $d j k n x F $.
    $( ` ( ( sin `` x ) / x ) ~~> 1 ` as (real) ` x ~~> 0 ` .  (Contributed by
       Paul Chapman, 10-Nov-2012.)  (Proof shortened by Mario Carneiro,
       21-May-2014.) $)
    sinccvg $p |- ( ( F : NN --> ( RR \ { 0 } ) /\ F ~~> 0 ) ->
      ( ( x e. ( RR \ { 0 } ) |-> ( ( sin ` x ) / x ) ) o. F ) ~~> 1 ) $=
      ( vk vj vn cn cc0 cli wbr wa cv cfv cabs c1 clt cdiv co cmpt wcel a1i csn
      cr cdif wf cuz wral csin ccom nnuz cz 1z crp 1rp eqidd simpr climi0 cc c2
      cexp c3 cmin simpll simplr eqid simprl simprr fveq2 fveq2d breq1d rspccva
      weq sylan sinccvglem rexlimddv ) FUBGUAUCZBUDZBGHIZJZCKZBLZMLZNOIZCDKZUEL
      ZUFZAVOAKZUGLWFPQRZBUHNHIDFVRVTNDCBNFUINUJSVRUKTNULSVRUMTVRVSFSJVTUNVPVQU
      OUPVRWCFSZWEJZJZAEBWGAUQNWFURUSQUTPQVAQRZWCVPVQWIVBVPVQWIVCWGVDWKVDVRWHWE
      VEWJWEEKZWDSWLBLZMLZNOIZVRWHWEVFWBWOCWLWDCEVKZWAWNNOWPVTWMMVSWLBVGVHVIVJV
      LVMVN $.
  $}

  ${
    $d n y $.  $d k P $.  $d k n R $.
    circum.1 $e |- A = ( ( 2 x. pi ) / n ) $.
    circum.2 $e |-
      P = ( n e. NN |-> ( ( 2 x. n ) x. ( R x. ( sin ` ( A / 2 ) ) ) ) ) $.
    circum.3 $e |- R e. RR $.
    $( The circumference of a circle of radius ` R ` , defined as the limit as
       ` n ~~> +oo ` of the perimeter of an inscribed n-sided isogons, is
       ` ( ( 2 x. pi ) x. R ) ` .  (Contributed by Paul Chapman, 10-Nov-2012.)
       (Proof shortened by Mario Carneiro, 21-May-2014.) $)
    circum $p |- P ~~> ( ( 2 x. pi ) x. R ) $=
      ( c2 cpi cmul co wtru cn cdiv csin cfv wcel a1i cr cc vk vy c1 cli wbr cv
      cmpt cvv nnuz cz 1z cc0 csn cdif ccom wne wa crp pire elrpii nnrp rpdivcl
      pipos sylancr rprene0d eldifsn sylibr adantl eqidd wceq id oveq12d fmptco
      fveq2 wf eqid fmpti recni divcnv mp1i sinccvg eqbrtrrd 2re remulcli mptex
      nnex eldifi resincld eldifsni redivcld fco mp2an trud feq1i mpbi ffvelrni
      eqeltri recnd nncn nnne0 divassd oveq1d simpr nndivre 2ne0 divcan3d eqtrd
      fveq2d rpne0d divcan2d eqtr4d oveq2d oveq2 ovex fvmpt mulassd mulcl mul4d
      eqeltrrd mul32d syl5eq 3eqtr4d climmulc2 mulid1i breqtri ) BHIJKZCJKZUCJK
      ZYGUDBYHUDUELUCYGUADMIDUFZNKZOPZYJNKZUGZBUCUHMUIUCUJQLUKRLUBSULUMZUNZUBUF
      ZOPZYPNKZUGZDMYJUGZUOZYMUCUDLDUBMYOYJYRYLYTYSYIMQZYJYOQZLUUBYJSQYJULUPUQU
      UCUUBYJUUBIURQZYIURQYJURQIUSVCUTZYIVAIYIVBVDVEYJSULVFVGZVHLYTVILYSVIYPYJV
      JZYQYKYPYJNYPYJOVNUUGVKVLVMZLMYOYTVOZYTULUDUEZUUAUCUDUEDMYOYJYTYTVPUUFVQZ
      ITQZUUJLIUSVRZIDVSVTUBYTWAVDWBYGTQLYGYFCHIWCUSWDGWDVRZRBUHQLBDMHYIJKZCAHN
      KZOPZJKZJKZUGUHFDMUUSWFWEWQRLUAUFZMQZUQZUUTYMPZUVAUVCSQLMSUUTYMMSUUAVOZMS
      YMVOYOSYSVOUUIUVDUBYOSYRYSYSVPYPYOQZYQYPUVEYPYPSYNWGZWHUVFYPSULWIWJVQUUKM
      YOSYSYTWKWLMSUUAYMUUAYMVJUUHWMWNWOWPVHWRZUVBHUUTJKZCYFUUTNKZHNKZOPZJKZJKZ
      YGIUUTNKZOPZUVNNKZJKZUUTBPZYGUVCJKUVBUVMUVHCUVNJKZJKZUVPJKZUVQUVBUVMUVHUV
      SUVPJKZJKUWAUVBUVLUWBUVHJUVBUVLCUVNUVPJKZJKUWBUVBUVKUWCCJUVBUVKUVOUWCUVBU
      VJUVNOUVBUVJHUVNJKZHNKUVNUVBUVIUWDHNUVBHIUUTHTQZUVBHWCVRZRZUULUVBUUMRZUVA
      UUTTQZLUUTWSVHZUVAUUTULUPLUUTWTVHZXAXBUVBUVNHUVBUVNUVBISQUVAUVNSQUSLUVAXC
      IUUTXDVDZWRZUWGHULUPUVBXERXFXGXHUVBUVOUVNUVBUVOUVBUVNUWLWHWRUWMUVBUVNUVBU
      UDUUTURQZUVNURQUUEUVAUWNLUUTVAVHIUUTVBVDXIXJXKXLUVBCUVNUVPCTQZUVBCGVRZRZU
      WMUVBUVCUVPTUVAUVCUVPVJLDUUTYLUVPMYMYIUUTVJZYKUVOYJUVNNUWRYJUVNOYIUUTINXM
      ZXHUWSVLYMVPUVOUVNNXNXOVHZUVGXSZXPXKXLUVBUVHUVSUVPUVBUWEUWIUVHTQUWFUWJHUU
      TXQVDUVBUWOUVNTQUVSTQUWPUWMCUVNXQVDUXAXPXKUVBUVTYGUVPJUVBUVTHCJKZUUTUVNJK
      ZJKZYGUVBHUUTCUVNUWGUWJUWQUWMXRUVBUXDUXBIJKYGUVBUXCIUXBJUVBIUUTUWHUWJUWKX
      JXLUVBHCIUWGUWQUWHXTXGXGXBXGUVAUVRUVMVJLDUUTUUSUVMMBUWRUUOUVHUURUVLJYIUUT
      HJXMUWRUUQUVKCJUWRUUPUVJOUWRAUVIHNUWRAYFYINKUVIEYIUUTYFNXMYAXBXHXLVLFUVHU
      VLJXNXOVHUVBUVCUVPYGJUWTXLYBYCWMYGUUNYDYE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Miscellaneous theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Membership in a curtailed finite sequence of integers.  (Contributed by
     Paul Chapman, 17-Nov-2012.) $)
  elfzm12 $p |- ( N e. NN ->
                  ( M e. ( 1 ... ( N - 1 ) ) -> M e. ( 1 ... N ) ) ) $=
    ( cn wcel c1 cmin co cfz cz cuz cfv wss nnz cle wbr zre lem1d peano2zm eluz
    wb mpancom mpbird fzss2 3syl sseld ) BCDZEBEFGZHGZEBHGZAUFBIDZBUGJKDZUHUILB
    MUJUKUGBNOZUJBBPQUGIDUJUKULTBRUGBSUAUBUGEBUCUDUE $.

  ${
    $d F k $.  $d N k $.
    nn0seqcvg.1 $e |- F : NN0 --> NN0 $.
    nn0seqcvg.2 $e |- N = ( F ` 0 ) $.
    nn0seqcvg.3 $e |- ( k e. NN0 -> ( ( F ` ( k + 1 ) ) =/= 0 ->
                                      ( F ` ( k + 1 ) ) < ( F ` k ) ) ) $.
    $( A strictly-decreasing nonnegative integer sequence with initial term
       ` N ` reaches zero by the ` N ` th term.  Inference version.
       (Contributed by Paul Chapman, 31-Mar-2011.) $)
    nn0seqcvg $p |- ( F ` N ) = 0 $=
      ( c1 wceq cfv cc0 eqid cn0 wf a1i cv wcel caddc co wne clt wbr nn0seqcvgd
      wi adantl ax-mp ) GGHZCBIJHGKUFABCLLBMUFDNCJBIHUFENAOZLPUGGQRBIZJSUHUGBIT
      UAUCUFFUDUBUE $.
  $}

  $( Identity law for modulo restricted to integers.  (Contributed by Paul
     Chapman, 22-Jun-2011.) $)
  zmodid2 $p |- ( ( M e. ZZ /\ N e. NN ) -> ( ( M mod N ) = M <->
                                              M e. ( 0 ... ( N - 1 ) ) ) ) $=
    ( cz wcel cn wa cmo co wceq cc0 cle wbr clt c1 cmin cfz cr crp wb zre nnrp
    modid2 syl2an nnz w3a 0z elfzm11 mpan 3anass syl6bb bicomd sylan9bbr bitr4d
    syl ibar ) ACDZBEDZFABGHAIZJAKLZABMLZFZAJBNOHPHDZUPAQDBRDURVASUQATBUAABUBUC
    UQVBUPVAFZUPVAUQBCDZVBVCSBUDVDVBUPUSUTUEZVCJCDVDVBVESUFAJBUGUHUPUSUTUIUJUNU
    PVAVCUPVAUOUKULUM $.

  $( Absorbtion law for modulo.  (Contributed by Paul Chapman, 22-Jun-2011.) $)
  modaddabs $p |- ( ( A e. RR /\ B e. RR /\ C e. RR+ ) ->
            ( ( ( A mod C ) + ( B mod C ) ) mod C ) = ( ( A + B ) mod C ) ) $=
    ( cr wcel cmo co caddc cc wa modcl recnd 3adant2 3adant1 addcomd wceq simpl
    oveq1d jca modabs2 crp w3a simpr modadd1 recn 3ad2ant2 eqtr4d 3simpc 3eqtrd
    syl3anc ) ADEZBDEZCUAEZUBZACFGZBCFGZHGZCFGUPUOHGZCFGZUOBHGZCFGZABHGCFGZUNUQ
    URCFUNUOUPUKUMUOIEULUKUMJZUOACKZLMZULUMUPIEUKULUMJZUPBCKZLNORUNUSBUOHGZCFGZ
    VAUNUPDEZULJZUODEZUMJZUPCFGUPPZUSVIPULUMVKUKVFVJULVGULUMQSNUKUMVMULVCVLUMVD
    UKUMUCSMULUMVNUKBCTNUPBUOCUDUJUNUTVHCFUNUOBVEULUKBIEUMBUEUFORUGUNVLUKJZVFUO
    CFGUOPZVAVBPUKUMVOULVCVLUKVDUKUMQSMUKULUMUHUKUMVPULACTMUOABCUDUJUI $.

  $( An integer is a member of a 0-based finite set of sequential integers iff
     its successor is a member of the corresponding 1-based set.  (Contributed
     by Paul Chapman, 22-Jun-2011.) $)
  elfzp1b $p |- ( ( K e. ZZ /\ N e. ZZ ) ->
                ( K e. ( 0 ... ( N - 1 ) ) <-> ( K + 1 ) e. ( 1 ... N ) ) ) $=
    ( cz wcel wa c1 caddc co cfz cc0 wb peano2z 1z fzsubel mpanl1 mpanr2 sylan2
    cmin cc wceq ancoms zcn ax-1cn pncan sylancl 1m1e0 oveq1i a1i adantr bitr2d
    eleq12d ) ACDZBCDZEAFGHZFBIHDZUNFRHZFFRHZBFRHZIHZDZAJURIHZDZUMULUOUTKZULUMU
    NCDZVCALUMVDFCDZVCMVEUMVDVEEVCMUNFFBNOPQUAULUTVBKUMULUPAUSVAULASDFSDUPATAUB
    UCAFUDUEUSVATULUQJURIUFUGUHUKUIUJ $.

  ${
    $( Division of both sides of 'less than or equal to' by a nonnegative
       number.  (Contributed by Paul Chapman, 7-Sep-2007.) $)
    lediv2aALT $p |- ( ( ( A e. RR /\ 0 < A ) /\ ( B e. RR /\ 0 < B ) /\
                       ( C e. RR /\ 0 <_ C ) ) ->
                     ( A <_ B -> ( C / B ) <_ ( C / A ) ) ) $=
      ( cr wcel cc0 clt wbr wa cle w3a c1 cdiv co anim12i ancoms cc recn adantr
      syl wi wne gt0ne0 rereccl syldan 3adant3 simp3 df-3an sylanbrc lemul2a ex
      cmul lerec wceq jca 3anass sylibr divrec 3adant1 3adant2 breq12d 3imtr4d
      wb ) ADEZFAGHZIZBDEZFBGHZIZCDEZFCJHZIZKZLBMNZLAMNZJHZCVNULNZCVOULNZJHZABJ
      HZCBMNZCAMNZJHVMVNDEZVODEZVLKZVPVSUAVMWCWDIZVLWEVFVIWFVLVIVFWFVIWCVFWDVGV
      HBFUBZWCBUCZBUDUEVDVEAFUBZWDAUCZAUDUEOPUFVFVIVLUGWCWDVLUHUIWEVPVSVNVOCUJU
      KTVFVIVTVPVCVLABUMUFVMWAVQWBVRJVIVLWAVQUNZVFVLVIWKVLVIIZCQEZBQEZWGKZWKWLW
      MWNWGIZIWOVLWMVIWPVJWMVKCRSZVIWNWGVGWNVHBRSWHUOOWMWNWGUPUQCBURTPUSVFVLWBV
      RUNZVIVLVFWRVLVFIZWMAQEZWIKZWRWSWMWTWIIZIXAVLWMVFXBWQVFWTWIVDWTVEARSWJUOO
      WMWTWIUPUQCAURTPUTVAVB $.
  $}

  ${
    abs2sqlei.1 $e |- A e. CC $.
    abs2sqlei.2 $e |- B e. CC $.
    $( The absolute values of two numbers compare as their squares.
       (Contributed by Paul Chapman, 7-Sep-2007.) $)
    abs2sqlei $p |- ( ( abs ` A ) <_ ( abs ` B ) <->
                     ( ( abs ` A ) ^ 2 ) <_ ( ( abs ` B ) ^ 2 ) ) $=
      ( cc0 cabs cfv cle wbr c2 cexp co wb absge0i abscli le2sqi mp2an ) EAFGZH
      IEBFGZHIRSHIRJKLSJKLHIMACNBDNRSACOBDOPQ $.
  $}

  ${
    abs2sqlti.1 $e |- A e. CC $.
    abs2sqlti.2 $e |- B e. CC $.
    $( The absolute values of two numbers compare as their squares.
       (Contributed by Paul Chapman, 7-Sep-2007.) $)
    abs2sqlti $p |- ( ( abs ` A ) < ( abs ` B ) <->
                     ( ( abs ` A ) ^ 2 ) < ( ( abs ` B ) ^ 2 ) ) $=
      ( cc0 cabs cfv cle wbr clt c2 cexp co wb absge0i abscli lt2sqi mp2an ) EA
      FGZHIEBFGZHISTJISKLMTKLMJINACOBDOSTACPBDPQR $.
  $}

  ${
    $( The absolute values of two numbers compare as their squares.
       (Contributed by Paul Chapman, 7-Sep-2007.) $)
    abs2sqle $p |- ( ( A e. CC /\ B e. CC ) ->
                      ( ( abs ` A ) <_ ( abs ` B ) <->
                        ( ( abs ` A ) ^ 2 ) <_ ( ( abs ` B ) ^ 2 ) ) ) $=
      ( cc wcel cabs cfv cle wbr c2 cexp co wb cc0 cif wceq fveq2 breq1d breq2d
      bibi12d 0cn oveq1d oveq1 syl elimel abs2sqlei dedth2h ) ACDZBCDZAEFZBEFZG
      HZUIIJKZUJIJKZGHZLUGAMNZEFZUJGHZUPIJKZUMGHZLUPUHBMNZEFZGHZURVAIJKZGHZLABM
      MAUOOZUKUQUNUSVEUIUPUJGAUOEPZQVEULURUMGVEUIUPIJVFUAQSBUTOZUQVBUSVDVGUJVAU
      PGBUTEPZRVGUJVAOZUSVDLVHVIUMVCURGUJVAIJUBRUCSUOUTAMCTUDBMCTUDUEUF $.
  $}

  ${
    $( The absolute values of two numbers compare as their squares.
       (Contributed by Paul Chapman, 7-Sep-2007.) $)
    abs2sqlt $p |- ( ( A e. CC /\ B e. CC ) ->
                      ( ( abs ` A ) < ( abs ` B ) <->
                        ( ( abs ` A ) ^ 2 ) < ( ( abs ` B ) ^ 2 ) ) ) $=
      ( cc wcel cabs cfv clt wbr c2 cexp co wb cc0 cif wceq fveq2 breq1d breq2d
      bibi12d 0cn oveq1d oveq1 syl elimel abs2sqlti dedth2h ) ACDZBCDZAEFZBEFZG
      HZUIIJKZUJIJKZGHZLUGAMNZEFZUJGHZUPIJKZUMGHZLUPUHBMNZEFZGHZURVAIJKZGHZLABM
      MAUOOZUKUQUNUSVEUIUPUJGAUOEPZQVEULURUMGVEUIUPIJVFUAQSBUTOZUQVBUSVDVGUJVAU
      PGBUTEPZRVGUJVAOZUSVDLVHVIUMVCURGUJVAIJUBRUCSUOUTAMCTUDBMCTUDUEUF $.
  $}

  ${
    abs2difi.1 $e |- A e. CC $.
    abs2difi.2 $e |- B e. CC $.
    $( Difference of absolute values.  (Contributed by Paul Chapman,
       7-Sep-2007.) $)
    abs2difi $p |- ( ( abs ` A ) - ( abs ` B ) ) <_ ( abs ` ( A - B ) ) $=
      ( cc wcel cabs cfv cmin co cle wbr abs2dif mp2an ) AEFBEFAGHBGHIJABIJGHKL
      CDABMN $.
  $}

  ${
    abs2difabsi.1 $e |- A e. CC $.
    abs2difabsi.2 $e |- B e. CC $.
    $( Absolute value of difference of absolute values.  (Contributed by Paul
       Chapman, 7-Sep-2007.) $)
    abs2difabsi $p |- ( abs ` ( ( abs ` A ) - ( abs ` B ) ) ) <_
                     ( abs ` ( A - B ) ) $=
      ( cc wcel cabs cfv cmin co cle wbr abs2difabs mp2an ) AEFBEFAGHBGHIJGHABI
      JGHKLCDABMN $.
  $}

$( (End of Paul Chapman's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Drahflow
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  This is the mathbox of Jens-Wolfhard Schicke-Uffmann, reachable at
  drahflow@gmx.de / drahflow.name

$)

  $c ^r $. $( Exponentiation of a relation. $)

  $( Extend class notation to include relation exponentiation. $)
  crelexp $a class ^r $.

  ${
    $d n r x y z $.
    $( Definition of repeated composition of a relation with itself, aka
       relation exponentiation.  (Contributed by Drahflow, 12-Nov-2015.) $)
    df-relexp $a |- ^r = ( r e. _V , n e. NN0 |->
                       ( seq 0 ( ( x e. _V , y e. _V |-> ( x o. r ) ) ,
                                 ( z e. _V |-> ( _I |` U. U. r ) ) ) ` n ) ) $.
  $}

  ${
    $d R r n a $.  $d R r x a $.  $d R r y a $.  $d R r z a $.  $d ph r n $.
    $d ph r z $.  $d n x y z $.
    relexp0.1 $e |- ( ph -> Rel R ) $.
    relexp0.2 $e |- ( ph -> R e. _V ) $.
    $( A relation composed zero times is the (restricted) identity.
       (Contributed by Drahflow, 12-Nov-2015.) $)
    relexp0 $p |- ( ph -> ( R ^r 0 ) = ( _I |` U. U. R ) ) $=
      ( vr vn vx vy vz cvv wcel cc0 crelexp cuni wceq wa wi cv eqidd a1i co cid
      cres uniexg resiexg cn0 ccom cmpt2 cmpt cseq cfv simpl adantl simprr c0ex
      0z simpll fvmptd seq1i eqeq1 anbi2d fveq2 eqeq1d mpcom anbi1d mpt2eq123dv
      3imtr4d coeq2 unieq unieqd reseq2d mpteq2dv seqeq123d fveq1d 0nn0 ovmpt2d
      wb df-relexp oveq imbi2d ax-mp mpbir sylan mpancom ) BJKZABLMUAZUBBNZNZUC
      ZOZDWEWGJKZAWJBJUDWKWHJKZAWJWGJUDWLWIJKZAWJWHJUEWMAPZWJQZWNBLEFJUFFRZGHJJ
      GRZERZUGZUHZIJUBWRNZNZUCZUIZLUJZUKZUHZUAZWIOZQZWNEFBLJUFXFWIXGJWNXGSWRBOZ
      WNXKWPLOZPZPZXFWIOZXMXKWNXKXLULUMXKWNBBOZXLPZPZWPGHJJWQBUGZUHZIJWIUIZLUJZ
      UKZWIOZXNXOXRYDQXKXLXRYDWNXPXLUNXLWNXPLLOZPZPZLYBUKZWIOZXRYDYGYIQXLYGWIXT
      YALUPYGILWIWIJYAJYGYASYGIRLOPWISLJKYGUOTWMAYFUQURUSTXLXQYFWNXLXLYEXPWPLLU
      TVAVAXLYCYHWIWPLYBVBVCVGVDTXKXMXQWNXKXKXPXLWRBBUTVEVAXKXFYCWIXKWPXEYBXKWT
      XTXDYALLXKLSXKGHJJWSJJXSXKJSZYJWRBWQVHVFXKIJXCWIXKXBWHUBXKXAWGWRBVIVJVKVL
      VMVNVCVGVDAWEWMDUMLUFKWNVOTWMAULVPMXGOZWOXJVQGHIFEVRYKWJXIWNYKWFXHWIBLMXG
      VSVCVTWAWBWCWCWCWD $.
  $}

  ${
    $d R r n a x y $.  $d R r n a z $.  $d R r n b x y $.  $d R r n b z $.
    $d R s a x y t $.  $d R s a z t $.  $d N r n a $.  $d N r n b $.
    $d N s a t $.  $d ph r n b $.  $d ph s t $.  $d x y z $.
    relexpsucr.1 $e |- ( ph -> Rel R ) $.
    relexpsucr.2 $e |- ( ph -> R e. _V ) $.
    $( A reduction for relation exponentiation to the right.  (Contributed by
       Drahflow, 12-Nov-2015.) $)
    relexpsucr $p |- ( ph -> ( N e. NN0 -> ( R ^r ( N + 1 ) ) =
                                           ( ( R ^r N ) o. R ) ) ) $=
      ( vr vx vy vz cvv wcel cn0 co ccom wceq wi wa cv cc0 cfv vn vb vs vt cuni
      cid cres c1 caddc crelexp uniexg resiexg 4syl cmpt2 cmpt cseq eqidd coeq2
      simprr mpt2eq123dv unieq unieqd reseq2d mpteq2dv seqeq123d ad2antrl eqeq1
      fveq1d anbi2d fveq2 eqeq1d imbi12d mpcom ad2antll simpl 1nn0 a1i nn0addcl
      mpbiri syl2anc ovmpt2d simprl anbi1d cuz nn0uz syl6eleq seqp1 syl cbvmptv
      fvex jctir elex 3syl fvmptd coeq1 adantr cbvmpt2 coexg eqeq2d syl5ibr imp
      nfcv oveq2 eqtrd mpancom df-relexp oveq coeq1d eqeq12d imbi2d ax-mp mpbir
      wb expcom ) UFBUEZUEZUGZJKZACLKZBCUHUIMZUJMZBCUJMZBNZOZPABJKZXOJKXPJKXREB
      JUKXOJUKXPJULUMXSXRAQZYDXSYFQZYDPZYGBXTFUAJLUARZGHJJGRZFRZNZUNZIJUFYKUEZU
      EZUGZUOZSUPZTZUNZMZBCYTMZBNZOZPZYGUUAXTGHJJYJBNZUNZIJXQUOZSUPZTZUUCYGFUAB
      XTJLYSUUJYTJYGYTUQZYIXTOZYGYKBOZUULQZQZYSUUJOZYGUUMUULUSUULUUOUUPPYGUUMXT
      XTOZQZQZXTYRTZUUJOZPUUMUVAYGUUQUUMXTYRUUIUUMYMUUGYQUUHSSUUMSUQUUMGHJJYLJJ
      UUFUUMJUQZUVBYKBYJURUTUUMIJYPXQUUMYOXPUFUUMYNXOYKBVAVBVCVDVEZVHVFUULUUOUU
      SUUPUVAUULUUNUURYGUULUULUUQUUMYIXTXTVGVIVIUULYSUUTUUJYIXTYRVJVKVLVSVMAYEX
      SXREVNZYGXSUHLKZXTLKZXSYFVOZUVEYGVPVQCUHVRZVTUUJJKYGXTUUIWJVQWAUUBCUUITZO
      ZYGUUJUUCOYGFUABCJLYSUVIYTJUUKUUMYGUUMYICOZQZQZYSUVIOZYGUUMUVKWBUUMUVMUVN
      PYGBBOZUVKQZQZYIUUITZUVIOZPUVKUVSYGUVOYICUUIVJVNUUMUVMUVQUVNUVSUUMUVLUVPY
      GUUMUUMUVOUVKYKBBVGWCVIUUMYSUVRUVIUUMYIYRUUIUVCVHVKVLVSVMUVDUVGUVIJKZYGCU
      UIWJVQZWAUVJYGQZUUJUVIXTUUHTZUUGMZUUCUWBCSWDTZKUUJUWDOUWBCLUWEUVJXSYFWBZW
      EWFUUGUUHSCWGWHUWCXQOZUWBUWDUUCOZUWBUBXTXQXQJUUHJUUHUBJXQUOOUWBIUBJXQXQIR
      UBRZOXQUQWIVQUWBUWIXTOQXQUQUWBXSUVEQUVFXTJKUWBXSUVEUWFVPWKUVHXTLWLWMYFXRU
      VJXSXRAVOVNWNUWBUWHUWGUVIXQUUGMZUUCOZUVJYGUWKYGUWKUVJUWJUVIBNZOYGUCUDUVIX
      QJJUCRZBNZUWLUUGJUUGUCUDJJUWNUNOYGGHUCUDJJUUFUWNUCUUFXBUDUUFXBGUWNXBHUWNX
      BYJUWMOUUFUWNOHRUDRZOYJUWMBWOWPWQVQUWMUVIOUWNUWLOYGUWOXQOUWMUVIBWOVFUWAXS
      XRAWBYGUVTYEUWLJKUWAUVDUVIBJJWRVTWAUVJUUCUWLUWJUUBUVIBWOWSWTXAUWGUWDUWJUU
      CUWCXQUVIUUGXCVKWTVMXDXEXDUJYTOZYHUUEXMGHIUAFXFUWPYDUUDYGUWPYAUUAYCUUCBXT
      UJYTXGUWPYBUUBBBCUJYTXGXHXIXJXKXLXNXE $.
  $}

  ${
    $d a r s x y t R $.  $d n r R $.  $d r x y $.  $d r s t z R $.
    relexp1.1 $e |- ( ph -> Rel R ) $.
    relexp1.2 $e |- ( ph -> R e. _V ) $.
    $( A relation composed once is itself.  (Contributed by Drahflow,
       12-Nov-2015.) $)
    relexp1 $p |- ( ph -> ( R ^r 1 ) = R ) $=
      ( c1 cc0 caddc wceq crelexp 1e0p1 oveq2 ccom cn0 wcel 0nn0 relexpsucr mpi
      co cuni sylan9eq cid cres relexp0 coeq1 wrel relcoi2 mpancom eqtrd mpan
      syl ) EFEGRZHZABEIRZBHJULAUMBUKIRZBEUKBIKAUNBFIRZBLZBAFMNUNUPHOABFCDPQUOU
      ABSSUBZHZAUPBHABCDUCURAUPUQBLZBUOUQBUDABUEUSBHCBUFUJTUGUHTUI $.
  $}

  ${
    $d N i $.  $d ph i n $.  $d n i R $.
    relexpsucl.1 $e |- ( ph -> Rel R ) $.
    relexpsucl.2 $e |- ( ph -> R e. _V ) $.
    $( A reduction for relation exponentiation to the left.  (Contributed by
       Drahflow, 12-Nov-2015.) $)
    relexpsucl $p |- ( ph -> ( N e. NN0 -> ( R ^r ( N + 1 ) ) =
                                           ( R o. ( R ^r N ) ) ) ) $=
      ( cn0 wcel c1 caddc co crelexp ccom wceq wa wi eleq1 anbi1d oveq2 eqeq12d
      cc0 vi vn cv oveq1 oveq2d coeq2d imbi12d cuni cres relexp0 adantl relexp1
      cid wrel relcoi1 eqtr4d coeq2 eqeq2d syl5ibr mpcom wb 0p1e1 eqeq1d imbi2d
      syl ax-mp mpbir simpl simprl cvv relexpsucr simprrr anbi2d simprrl mp2and
      mpd eqeq1 coeq1d coass syl6eq coeq1 sylbid anassrs expcom nn0ind anabsi5
      eqtrd ) CFGZABCHIJZKJZBBCKJZLZMZWHAWMUAUCZFGZANZBWNHIJZKJZBBWNKJZLZMZOTFG
      ZANZBTHIJZKJZBBTKJZLZMZOZUBUCZFGZANZBXJHIJZKJZBBXJKJZLZMZOZXMFGZANZBXMHIJ
      ZKJZBXNLZMZOZWHANZWMOUAUBCWNTMZWPXCXAXHYGWOXBAWNTFPQYGWRXEWTXGYGWQXDBKWNT
      HIUDUEYGWSXFBWNTBKRUFSUGWNXJMZWPXLXAXQYHWOXKAWNXJFPQYHWRXNWTXPYHWQXMBKWNX
      JHIUDUEYHWSXOBWNXJBKRUFSUGWNXMMZWPXTXAYDYIWOXSAWNXMFPQYIWRYBWTYCYIWQYABKW
      NXMHIUDUEYIWSXNBWNXMBKRUFSUGWNCMZWPYFXAWMYJWOWHAWNCFPQYJWRWJWTWLYJWQWIBKW
      NCHIUDUEYJWSWKBWNCBKRUFSUGXIXCBHKJZXGMZOZXFUMBUHUHUIZMZXCYLAYOXBABDEUJUKX
      CYLYOYKBYNLZMXCYKBYPAYKBMXBABDEULUKXCBUNZYPBMAYQXBDUKBUOVEUPYOXGYPYKXFYNB
      UQURUSUTXDHMZXIYMVAVBYRXHYLXCYRXEYKXGXDHBKRVCVDVFVGXRXKYEXTXRXKNZYDXSAYSY
      DXSAYSNZNZYBXNBLZYCUUAXSYBUUBMXSYTVHUUABXMUUAAYQXSAYSVIZDVEZUUAABVJGUUCEV
      EZVKVPXNXOBLZMZUUAUUBYCMZUUAXKUUGXSAXRXKVLUUABXJUUDUUEVKVPUUGUUAXSAXLUUFX
      PMZOZXKNZNZNZUUHUUGYTUULXSUUGYSUUKAUUGXRUUJXKUUGXQUUIXLXNUUFXPVQVDQVMVMUU
      MUUHUUGUUFBLZBUUFLZMUUMUUNXPBLUUOUUMUUFXPBUUMXKAUUIXSAUUJXKVLXSAUUKVIXSAU
      UJXKVNVOVRBXOBVSVTUUGUUBUUNYCUUOXNUUFBWAXNUUFBUQSUSWBUTWGWCWDWDWEWFWD $.
  $}

  ${
    $d N i $.  $d ph i n $.  $d n i R $.
    relexpcnv.1 $e |- ( ph -> Rel R ) $.
    relexpcnv.2 $e |- ( ph -> R e. _V ) $.
    $( Distributivity of converse and relation exponentiation.  (Contributed by
       Drahflow, 12-Nov-2015.) $)
    relexpcnv $p |- ( ph -> ( N e. NN0 -> `' ( R ^r N ) = ( `' R ^r N ) ) ) $=
      ( cn0 wcel crelexp co ccnv wceq wa cc0 eleq1 anbi1d oveq2 eqeq12d imbi12d
      wi cnveqd vi vn cv c1 caddc cid cuni cres relexp0 adantl id cnvresid wrel
      relcnvfld syl reseq2 simpr relcnv cvv cnvexg 3syl sylancl eqcomd sylan9eq
      simpl mpancom syl5eq ccom simprrr relexpsucl mpd cnvco simprrl mp2and a1i
      coeq1d relexpsucr eqtr4d anassrs expcom nn0ind anabsi5 ) CFGZABCHIZJZBJZC
      HIZKZWCAWHUAUCZFGZALZBWIHIZJZWFWIHIZKZSMFGZALZBMHIZJZWFMHIZKZSUBUCZFGZALZ
      BXBHIZJZWFXBHIZKZSZXBUDUEIZFGZALZBXJHIZJZWFXJHIZKZSZWCALZWHSUAUBCWIMKZWKW
      QWOXAXSWJWPAWIMFNOXSWMWSWNWTXSWLWRWIMBHPTWIMWFHPQRWIXBKZWKXDWOXHXTWJXCAWI
      XBFNOXTWMXFWNXGXTWLXEWIXBBHPTWIXBWFHPQRWIXJKZWKXLWOXPYAWJXKAWIXJFNOYAWMXN
      WNXOYAWLXMWIXJBHPTWIXJWFHPQRWICKZWKXRWOWHYBWJWCAWICFNOYBWMWEWNWGYBWLWDWIC
      BHPTWICWFHPQRWRUFBUGUGZUHZKZWQXAAYEWPABDEUIUJYEWQWSYDJZWTYEWRYDYEUKTWQYFY
      DWTYCULYCWFUGUGZKZWQYDWTKWQBUMZYHAYIWPDUJBUNUOYHWQYDUFYGUHZWTYCYGUFUPWQWT
      YJWQAWFUMZWTYJKWPAUQBURZAYKLZWFAYKUQYMABUSGZWFUSGZAYKVEEBUSUTZVAUIVBVCVDV
      FVGVDVFXIXCXQXLXIXCLZXPXKAYQXPXNBXEVHZJZKZXKAYQLZLZXPUUBXMYRUUBXCXMYRKXKA
      XIXCVIZUUBBXBUUBAYIUUAAXKAYQVEUJZDUOUUBAYNUUDEUOVJVKTYTUUBLZXNXGWFVHZXOYT
      UUBXNYSUUFYTUKUUBYSXFWFVHUUFBXEVLUUBXFXGWFUUBXCAXHUUCUUDXKAXIXCVMVNVPVGVD
      UUEXCXOUUFKUUBXCYTUUCUJUUEWFXBYKUUEYLVOUUEAYNYOYTXKAYQVMEYPVAVQVKVRVFVSVT
      VTWAWBVT $.
  $}

  ${
    relexprel.1 $e |- ( ph -> Rel R ) $.
    relexprel.2 $e |- ( ph -> R e. _V ) $.
    $( The exponentiation of a relation is a relation.  (Contributed by
       Drahflow, 12-Nov-2015.) $)
    relexprel $p |- ( ph -> ( N e. NN0 -> Rel ( R ^r N ) ) ) $=
      ( cn0 wcel crelexp co wrel ccnv wa relexpcnv impcom cnveqd relcnv a1i cvv
      wceq cnvexg adantl dfrel2 sylib oveq1d 3eqtrrd releq syl5ibr mpcom expcom
      syl ) CFGZABCHIZJZULULKZKZSZUKALZUMUQUOBKZCHIZKZURKZCHIZULUQUNUSAUKUNUSSA
      BCDEMNOAUKUTVBSAURCURJABPQABRGURRGEBRTUJMNUQVABCHUQBJZVABSAVCUKDUABUBUCUD
      UEUQUMUPUOJZVDUQUNPQULUOUFUGUHUI $.
  $}

  ${
    $d N i $.  $d ph i n $.  $d n i R $.
    relexpdm.1 $e |- ( ph -> Rel R ) $.
    relexpdm.2 $e |- ( ph -> R e. _V ) $.
    $( The domain of an exponentiation of a relation a subset of the relation's
       field.  (Contributed by Drahflow, 12-Nov-2015.) $)
    relexpdm $p |- ( ph -> ( N e. NN0 -> dom ( R ^r N ) C_ U. U. R ) ) $=
      ( cn0 wcel crelexp co cdm wss wa cc0 wceq eleq1 anbi1d oveq2 dmeqd sseq1d
      wi vi vn cuni cv c1 caddc imbi12d cid cres relexp0 adantl dmresi ssid a1i
      syl5eqss dmeq syl5ibr mpcom ccom simprrr simprl syl cvv relexpsucl dmcoss
      wrel mpd simprrl mp2and syl5ss anassrs expcom nn0ind anabsi5 ) CFGZABCHIZ
      JZBUCUCZKZVOAVSUAUDZFGZALZBVTHIZJZVRKZTMFGZALZBMHIZJZVRKZTUBUDZFGZALZBWKH
      IZJZVRKZTZWKUEUFIZFGZALZBWRHIZJZVRKZTZVOALZVSTUAUBCVTMNZWBWGWEWJXFWAWFAVT
      MFOPXFWDWIVRXFWCWHVTMBHQRSUGVTWKNZWBWMWEWPXGWAWLAVTWKFOPXGWDWOVRXGWCWNVTW
      KBHQRSUGVTWRNZWBWTWEXCXHWAWSAVTWRFOPXHWDXBVRXHWCXAVTWRBHQRSUGVTCNZWBXEWEV
      SXIWAVOAVTCFOPXIWDVQVRXIWCVPVTCBHQRSUGWHUHVRUIZNZWGWJAXKWFABDEUJUKWGWJXKX
      JJZVRKWGXLVRVRVRULVRVRKWGVRUMUNUOXKWIXLVRWHXJUPSUQURWQWLXDWTWQWLLZXCWSAXM
      XCXABWNUSZNZWSAXMLLZXCXPWLXOWSAWQWLUTZXPBWKXPABVFWSAXMVAZDVBXPABVCGXREVBV
      DVGXPXCXOXNJZVRKXPXSWOVRBWNVEXPWLAWPXQXRWSAWQWLVHVIVJXOXBXSVRXAXNUPSUQURV
      KVLVLVMVNVL $.
  $}

  ${
    $d N i $.  $d ph i n $.  $d n i R $.
    relexprn.1 $e |- ( ph -> Rel R ) $.
    relexprn.2 $e |- ( ph -> R e. _V ) $.
    $( The range of an exponentiation of a relation a subset of the relation's
       field.  (Contributed by Drahflow, 12-Nov-2015.) $)
    relexprn $p |- ( ph -> ( N e. NN0 -> ran ( R ^r N ) C_ U. U. R ) ) $=
      ( cn0 wcel crelexp co crn wss wa cc0 wceq eleq1 anbi1d oveq2 rneqd sseq1d
      wi vi vn cuni cv c1 caddc imbi12d cid cres relexp0 adantl rnresi ssid a1i
      syl5eqss rneq syl5ibr mpcom ccom simprrr simprl syl cvv relexpsucr rncoss
      wrel mpd simprrl mp2and syl5ss anassrs expcom nn0ind anabsi5 ) CFGZABCHIZ
      JZBUCUCZKZVOAVSUAUDZFGZALZBVTHIZJZVRKZTMFGZALZBMHIZJZVRKZTUBUDZFGZALZBWKH
      IZJZVRKZTZWKUEUFIZFGZALZBWRHIZJZVRKZTZVOALZVSTUAUBCVTMNZWBWGWEWJXFWAWFAVT
      MFOPXFWDWIVRXFWCWHVTMBHQRSUGVTWKNZWBWMWEWPXGWAWLAVTWKFOPXGWDWOVRXGWCWNVTW
      KBHQRSUGVTWRNZWBWTWEXCXHWAWSAVTWRFOPXHWDXBVRXHWCXAVTWRBHQRSUGVTCNZWBXEWEV
      SXIWAVOAVTCFOPXIWDVQVRXIWCVPVTCBHQRSUGWHUHVRUIZNZWGWJAXKWFABDEUJUKWGWJXKX
      JJZVRKWGXLVRVRVRULVRVRKWGVRUMUNUOXKWIXLVRWHXJUPSUQURWQWLXDWTWQWLLZXCWSAXM
      XCXAWNBUSZNZWSAXMLLZXCXPWLXOWSAWQWLUTZXPBWKXPABVFWSAXMVAZDVBXPABVCGXREVBV
      DVGXPXCXOXNJZVRKXPXSWOVRWNBVEXPWLAWPXQXRWSAWQWLVHVIVJXOXBXSVRXAXNUPSUQURV
      KVLVLVMVNVL $.
  $}

  ${
    relexpfld.1 $e |- ( ph -> Rel R ) $.
    relexpfld.2 $e |- ( ph -> R e. _V ) $.
    $( The field of an exponentiation of a relation a subset of the relation's
       field.  (Contributed by Drahflow, 12-Nov-2015.) $)
    relexpfld $p |- ( ph -> ( N e. NN0 -> U. U. ( R ^r N ) C_ U. U. R ) ) $=
      ( cn0 wcel crelexp cuni wss cdm crn cun wrel wceq relexprel impcom relfld
      co wa syl relexpdm relexprn unssd eqsstrd expcom ) CFGZABCHSZIIZBIIZJUGAT
      ZUIUHKZUHLZMZUJUKUHNZUIUNOAUGUOABCDEPQUHRUAUKULUMUJAUGULUJJABCDEUBQAUGUMU
      JJABCDEUCQUDUEUF $.
  $}

  ${
    $d M i $.  $d N i m $.  $d m i ph $.  $d m i R $.
    relexpadd.1 $e |- ( ph -> Rel R ) $.
    relexpadd.2 $e |- ( ph -> R e. _V ) $.
    $( Relation composition becomes addition under exponentiation.
       (Contributed by Drahflow, 12-Nov-2015.) $)
    relexpadd $p |- ( ph -> ( ( N e. NN0 /\ M e. NN0 ) ->
                      ( ( R ^r N ) o. ( R ^r M ) ) = ( R ^r ( N + M ) ) ) ) $=
      ( cn0 wcel wa crelexp co ccom caddc wceq wi cc0 c1 oveq2 adantl mpancom
      vi vm simprl cv eleq1 anbi1d anbi2d coeq2d oveq2d eqeq12d cc nn0cn adantr
      imbi12d addid1 cid cuni cres simprrr relexp0 syl coires1 cdm wss relexpdm
      coeq2 sylc wrel simprrl relexprel relssres adantrr syl5eq sylan9eq eqeq2d
      syl5ibr mpcom relexpsucr nn0cnd ax-1cn a1i addassd eqcomd nn0addcl sylan2
      coass jca32 mpd coeq1d syl5eqr simpl eqtr4d expcom anassrs impcom nn0ind
      ) DGHZCGHZIABDJKZBCJKZLZBDCMKZJKZNZWQWRAXDWRWQWRAIZIZXDWQWRAUCWQUAUDZGHZA
      IZIZWSBXGJKZLZBDXGMKZJKZNZOWQPGHZAIZIZWSBPJKZLZBDPMKZJKZNZOWQUBUDZGHZAIZI
      ZWSBYDJKZLZBDYDMKZJKZNZOZWQYDQMKZGHZAIZIZWSBYNJKZLZBDYNMKZJKZNZOZXFXDOUAU
      BCXGPNZXJXRXOYCUUDXIXQWQUUDXHXPAXGPGUEUFUGUUDXLXTXNYBUUDXKXSWSXGPBJRUHUUD
      XMYABJXGPDMRUIUJUNXGYDNZXJYGXOYLUUEXIYFWQUUEXHYEAXGYDGUEUFUGUUEXLYIXNYKUU
      EXKYHWSXGYDBJRUHUUEXMYJBJXGYDDMRUIUJUNXGYNNZXJYQXOUUBUUFXIYPWQUUFXHYOAXGY
      NGUEUFUGUUFXLYSXNUUAUUFXKYRWSXGYNBJRUHUUFXMYTBJXGYNDMRUIUJUNXGCNZXJXFXOXD
      UUGXIXEWQUUGXHWRAXGCGUEUFUGUUGXLXAXNXCUUGXKWTWSXGCBJRUHUUGXMXBBJXGCDMRUIU
      JUNDUKHZXRYCWQUUHXQDULZUMYADNZUUHXRIZYCUUHUUJXRDUOUMUUKYCUUJXTWSNZXSUPBUQ
      UQZURZNZUUKUULUUKAUUOUUHWQXPAUSZABEFUTVAUUOUUKXTWSUUNLZWSXSUUNWSVFUUKUUQW
      SUUMURZWSWSUUMVBWSVCUUMVDZUUKUURWSNZUUKAWQUUSUUPUUHWQXQUCABDEFVEVGWSVHZUU
      SUUKIZUUTUVBAWQUVAUUKAUUSUUPSUUSUUHWQXQVIABDEFVJVGUVAUUSUUTUUKWSUUMVKVLTT
      VMVNTUUJYBWSXTYADBJRVOVPVQTYMYEUUCYQYMYEIZUUBWQYPUVCUUBYPUVCIWQUUBYOAUVCW
      QUUBOWQYOAUVCIIZUUBYRYHBLZNZWQUVDIZUUBUVGAYEUVFWQYOAUVCVIZUVDYEWQYOAYMYEU
      SZSZABYDEFVRVGUVFUVGYSWSUVELZUUAYRUVEWSVFYTYJQMKZNZUVGUVKUUANZUVGUVLYTUVG
      DYDQWQUUHUVDUUIUMUVGYDUVJVSQUKHUVGVTWAWBWCUVGUVNUVMUVKBUVLJKZNZYJGHZUVGUV
      PUVDWQYEUVQUVIDYDWDWEUVQUVGIZUVKYKBLZUVOUVRUVKYIBLUVSWSYHBWFUVRYIYKBUVRYG
      YLUVRWQYEAUVQWQUVDUCUVGYEUVQUVJSUVGAUVQUVHSZWGUVGYMUVQUVDYMWQYOAYMYEVISSW
      HWIWJUVRAUVQUVOUVSNUVTUVQUVGWKABYJEFVRVGWLTUVMUUAUVOUVKYTUVLBJRVOVPVQVNTW
      MWNWOWNWMWMWPVQWNWM $.
  $}

  ${
    $d k n x $.  $d k ps l $.  $d k l x et $.  $d k l x S $.  $d k l x R $.
    $d i x l et j $.  $d i x l S j $.  $d i x l R j $.  $d i ps l j $.
    $d i m S $.  $d i ch $.  $d i th $.  $d j x ph $.
    relexpindlem.1 $e |- ( et -> Rel R ) $.
    relexpindlem.2 $e |- ( et -> R e. _V ) $.
    relexpindlem.3 $e |- ( et -> S e. _V ) $.
    relexpindlem.4 $e |- ( i = S -> ( ph <-> ch ) ) $.
    relexpindlem.5 $e |- ( i = x -> ( ph <-> ps ) ) $.
    relexpindlem.6 $e |- ( i = j -> ( ph <-> th ) ) $.
    relexpindlem.7 $e |- ( et -> ch ) $.
    relexpindlem.8 $e |- ( et -> ( j R x -> ( th -> ps ) ) ) $.
    $( Principle of transitive induction, finite and non-class version.  The
       first three hypotheses give various existences, the next three give
       necessary substitutions and the last two are the basis and the induction
       hypothesis.  (Contributed by Drahflow, 12-Nov-2015.) $)
    relexpindlem $p |- ( et -> ( n e. NN0 -> ( S ( R ^r n ) x -> ps ) ) ) $=
      ( wa vk vl cv cn0 wcel crelexp co wbr wi wal simpr cc0 caddc eleq1 anbi2d
      c1 wceq oveq2 breqd imbi1d albidv imbi12d weq cid cuni relexp0 adantr w3a
      cres wex simpl cvv adantl ad2antrl simprl expcom 3imp1 wb ad2antll bicomd
      jca anbi1 syl6bi mpcom 3jca anassrs impbid spcegv syl2anc cop df-br sylib
      vex opelres simpll sylibr ideq mpancom breq1 eqeq2 3anbi1d exbidv anbi12d
      anbi1d mpbid 3imp exlimiv breq syl5ibr alrimiv breq2 cbvalv imbi2 simprrr
      bicomi ccom relexpsucl brcog sylancl simprrl mpd id sp ax-mp syl3c impcom
      sylc exlimddv nn0ind 19.21bi ex ) EKUCZUDUEZHFUCZGYLUFUGZUHZBUIZEYMTZYQFY
      MYRYQFUJZEYMUKEUAUCZUDUEZTZHYNGYTUFUGZUHZBUIZFUJZUIEULUDUEZTZHYNGULUFUGZU
      HZBUIZFUJZUIEUBUCZUDUEZTZHYNGUUMUFUGZUHZBUIZFUJZUIZEUUMUPUMUGZUDUEZTZHYNG
      UVAUFUGZUHZBUIZFUJZUIZYRYSUIUAUBYLYTULUQZUUBUUHUUFUULUVIUUAUUGEYTULUDUNUO
      UVIUUEUUKFUVIUUDUUJBUVIUUCUUIHYNYTULGUFURUSUTVAVBUAUBVCZUUBUUOUUFUUSUVJUU
      AUUNEYTUUMUDUNUOUVJUUEUURFUVJUUDUUQBUVJUUCUUPHYNYTUUMGUFURUSUTVAVBYTUVAUQ
      ZUUBUVCUUFUVGUVKUUAUVBEYTUVAUDUNUOUVKUUEUVFFUVKUUDUVEBUVKUUCUVDHYNYTUVAGU
      FURUSUTVAVBUAKVCZUUBYRUUFYSUVLUUAYMEYTYLUDUNUOUVLUUEYQFUVLUUDYPBUVLUUCYOH
      YNYTYLGUFURUSUTVAVBUUHUUKFUUIVDGVEVEZVIZUQZUUHUUKEUVOUUGEGLMVFVGUUHUUKUVO
      HYNUVNUHZBUIZIUCZHUQZAEVHZIVJZUUHUVQUUHCEUWAECUUGRVGEUUGVKHVLUEZCETZUWAEU
      WBCNVMUVTUWCIHVLUVSUVTUWCUVTUVSUWCUVSAEUVSUWCAUVSEUVSUWCUIZUIEAUVSTZUWDUV
      SEUWETZUWCUVSUWFTCEECUVSUWERVNUVSEUWEVOWAVPVPVPVQVPUWCUVSUVTCEUVSUVTCEUVS
      TZTZUVSAEUWGUVSCEUVSUKVMCAVRZUWHAUWHACUVSACVRCEOVSVTUWIUWHAUWGTACAUWGWBAU
      WGVKWCWDCEUVSVOWEWFVPWGWHWDWIUVPUWAUUHTZBHYNUQZUVPUWJTZBHYNWJZVDUEZHUVMUE
      ZTZUWLUWKUWLUWMUVNUEZUWPUWLUVPUWQUVPUWJVKHYNUVNWKWLHYNVDUVMFWMZWNWLUWPUWL
      TZHYNVDUHZUWKUWSUWNUWTUWNUWOUWLWOHYNVDWKWPHYNUWRWQWLWRUWKUWLYNYNUVNUHZIFV
      CZAEVHZIVJZUUHTZTBUWKUVPUXAUWJUXEHYNYNUVNWSUWKUWAUXDUUHUWKUVTUXCIUWKUVSUX
      BAEHYNUVRWTXAXBXDXCUXDBUXAUUHUXCBIUXBAEBAUXBEBUIEAUXBTZBEUXFTABEAUXBVOUXB
      ABVREAPVSXEVPVPXFXGVNWCWDVPWRUVOUUJUVPBHYNUUIUVNXHUTXIWDXJUUTUUNUVHUVCUUT
      UUNTZUVGEUVBUXGUVGUUSHUVRUUPUHZAUIZIUJZVRZEUVBUXGTZTZUVGUIUXJUUSUXIUURIFU
      XBUXHUUQABUVRYNHUUPXKPVBXLXOUXKUXMEUVBUUOUXJUIZUUNTZTZTZUVGUXKUXLUXPEUXKU
      XGUXOUVBUXKUUTUXNUUNUUSUXJUUOXMXDUOUOUXQUVFFUVDGUUPXPZUQZUXQUVFUXQEUUNUXS
      EUXPVKEUVBUXNUUNXNEGUUMLMXQYGUXQUVFUXSHYNUXRUHZBUIZUXTUXQBUXTUXQTZHJUCZUU
      PUHZUYCYNGUHZTZBJUYBUXTUYFJVJZUXTUXQVKUYBUWBYNVLUEUXTUYGVREUWBUXTUXPNVNUW
      RJHYNGUUPVLVLXRXSXEUXTUXQUYFBUXQUYFTUXTBEUXPUYFUYAUXPUYFTEUYAUVBUXOUYFEUY
      AUIZUXOUYFTUVBUYHUXNUUNUYFUVBUYHUIUVBUXNUUNUYFTZTZUYHEUVBUYJTZUYAUXTEUYKT
      ZBUXJUXTUYLTZBUYMUUOUXJUYMEUUNUXTEUYKVOUYKUUNUXTEUVBUXNUUNUYFXTVSWAUYKUXN
      UXTEUVBUXNUYIVOVSYAUXJUYMTZEUYEDBUXJUXTEUYKXTUYLUYEUXJUXTUYJUYEEUVBUXNUUN
      UYDUYEXNVSVSUXJUYDDUIZJUJZVRZUYNDUIUXIUYOIJIJVCUXHUYDADUVRUYCHUUPXKQVBXLU
      YQUYNUYPUXTEUVBUUOUYPUIZUYITZTZTZTZTZDUYQUXJUYPUYMVUBUYQYBUYQUYLVUAUXTUYQ
      UYKUYTEUYQUYJUYSUVBUYQUXNUYRUYIUXJUYPUUOXMXDUOUOUOXCVUCUYDDVUAUYDUYPUXTUY
      SUYDEUVBUYRUUNUYDUYEXTVSVSUYPUYOVUBUYOJYCVGYAWCYDSYEWRVPVPVPWFYFWFYFWFYFW
      FYHVPUXSUVEUXTBHYNUVDUXRXHUTXIWDXJWCYDWFVPVPYIWDYJYK $.
  $}

  ${
    $d n x $.  $d et x i j $.  $d i x j S $.  $d i x j R $.  $d i ps j $.
    $d i th $.  $d i ch $.  $d j x ph $.  $d X x $.  $d ta x $.
    relexpind.1 $e |- ( et -> Rel R ) $.
    relexpind.2 $e |- ( et -> R e. _V ) $.
    relexpind.3 $e |- ( et -> S e. _V ) $.
    relexpind.4 $e |- ( et -> X e. _V ) $.
    relexpind.5 $e |- ( i = S -> ( ph <-> ch ) ) $.
    relexpind.6 $e |- ( i = x -> ( ph <-> ps ) ) $.
    relexpind.7 $e |- ( i = j -> ( ph <-> th ) ) $.
    relexpind.8 $e |- ( x = X -> ( ps <-> ta ) ) $.
    relexpind.9 $e |- ( et -> ch ) $.
    relexpind.10 $e |- ( et -> ( j R x -> ( th -> ps ) ) ) $.
    $( Principle of transitive induction, finite version.  The first three
       hypotheses give various existences, the next three give necessary
       substitutions and the last two are the basis and the induction
       hypothesis.  (Contributed by Drahflow, 12-Nov-2015.) $)
    relexpind $p |- ( et -> ( n e. NN0 -> ( S ( R ^r n ) X -> ta ) ) ) $=
      ( cvv wcel cv cn0 crelexp co wbr wi wal relexpindlem ax-gen id wceq breq2
      a1i wb imbi1d imbi2d imbi2 bibi1d syl5ibr mpcom spcgv syl3c ) FMUDUEFLUFZ
      UGUEZIGUFZHVHUHUIZUJZBUKZUKZUKZGULZFVIIMVKUJZEUKZUKZQVPFVOGABCDFGHIJKLNOP
      RSTUBUCUMUNURFUOVOFVSUKZGMUDBEUSZVJMUPZVOVTUSZUAWBWCWAFVIVLEUKZUKZUKZVTUS
      WBWEVSFWBWDVRVIWBVLVQEVJMIVKUQUTVAVAWAVOWFVTWAVNWEFWAVMWDVIBEVLVBVAVAVCVD
      VEVFVG $.
  $}

  $c t*rec $.
  $( Extend class notation with recursively defined reflexive, transitive
     closure. $)
  crtrcl $a class t*rec $.

  ${
    $d n r $.
    $( The reflexive, transitive closure of a relation constructed as the union
       of all finite exponentiations.  (Contributed by Drahflow,
       12-Nov-2015.) $)
    df-rtrclrec $a |- t*rec = ( r e. _V |-> U_ n e. NN0 ( r ^r n ) ) $.
  $}

  ${
    rtrclreclem.1 $e |- ( ph -> Rel R ) $.
    rtrclreclem.2 $e |- ( ph -> R e. _V ) $.

    ${
      $d R r n $.  $d A n $.  $d B n $.
      $( If two elements are connected by a reflexive, transitive closure, then
         they are connected via ` n ` instances the relation, for some ` n ` .
         (Contributed by Drahflow, 12-Nov-2015.) $)
      dfrtrclrec2 $p |- ( ph -> ( A ( t*rec ` R ) B <->
                                  E. n e. NN0 A ( R ^r n ) B ) ) $=
        ( vr crtrcl cfv wbr cv crelexp co cn0 wrex wb cvv wceq wcel nn0ex iunex
        wi ciun cmpt ovex oveq1 iuneq2d eqid fvmptg sylancl cop eliun a1i df-br
        breq rexbii 3bitr4g mpancom df-rtrclrec fveq1 breqd bibi1d imbi2d ax-mp
        sylan9bb mpbir ) ABCDIJZKZBCDELZMNZKZEOPZQZUCZABCDHREOHLZVJMNZUDZUEZJZK
        ZVMQZUCZVTEOVKUDZSZAWBADRTWDRTWEGEOVKUADVJMUFUBHDVRWDRRVSVPDSEOVQVKVPDV
        JMUGUHVSUIUJUKWEWABCWDKZAVMBCVTWDUPABCULZWDTZWGVKTZEOPZWFVMWHWJQAEWGOVK
        UMUNBCWDUOVLWIEOBCVKUOUQURVFUSIVSSZVOWCQEHUTWKVNWBAWKVIWAVMWKVHVTBCDIVS
        VAVBVCVDVEVG $.
    $}

    ${
      $d R r n $.
      $( The reflexive, transitive closure is indeed reflexive.  (Contributed
         by Drahflow, 12-Nov-2015.) $)
      rtrclreclem.refl $p |- ( ph -> ( _I |` U. U. R ) C_ ( t*rec ` R ) ) $=
        ( vr vn cuni crtrcl cfv wss wi cvv cn0 cv crelexp co ciun cc0 wcel wceq
        cres cmpt wrex 0nn0 relexp0 syl5sseqr oveq2 sseq2d rspcev sylancr ssiun
        cid ssid nn0ex ovex iunex oveq1 iuneq2d eqid fvmptg sylancl sseqtr4d wb
        syl df-rtrclrec fveq1 imbi2d ax-mp mpbir ) AULBGGUAZBHIZJZKZAVJBELFMENZ
        FNZOPZQZUBZIZJZKZAVJFMBVOOPZQZVSAVJWBJZFMUCZVJWCJARMSVJBROPZJZWEUDAVJVJ
        WFVJUMABCDUEUFWDWGFRMVORTWBWFVJVORBOUGUHUIUJFMWBVJUKVDABLSWCLSVSWCTDFMW
        BUNBVOOUOUPEBVQWCLLVRVNBTFMVPWBVNBVOOUQURVRUSUTVAVBHVRTZVMWAVCFEVEWHVLV
        TAWHVKVSVJBHVRVFUHVGVHVI $.
    $}

    ${
      $d R r n $.  $d ph r $.
      $( The reflexive, transitive closure is indeed a closure.  (Contributed
         by Drahflow, 12-Nov-2015.) $)
      rtrclreclem.subset $p |- ( ph -> R C_ ( t*rec ` R ) ) $=
        ( vr vn crtrcl cfv wss wi cvv cn0 cv crelexp co ciun c1 wcel a1i wceq
        cmpt wrex 1nn0 relexp1 sseqtr4d oveq2 sseq2d rspcev sylancr ssiun eqidd
        ssid syl oveq1 iuneq2d adantl nn0ex ovex iunex fvmptd df-rtrclrec fveq1
        wb imbi2d ax-mp mpbir ) ABBGHZIZJZABBEKFLEMZFMZNOZPZUAZHZIZJZABFLBVKNOZ
        PZVOABVRIZFLUBZBVSIAQLRBBQNOZIZWAUCABBWBBBIABULSABCDUDUEVTWCFQLVKQTVRWB
        BVKQBNUFUGUHUIFLVRBUJUMAEBVMVSKVNKAVNUKVJBTZVMVSTAWDFLVLVRVJBVKNUNUOUPD
        VSKRAFLVRUQBVKNURUSSUTUEGVNTZVIVQVCFEVAWEVHVPAWEVGVOBBGVNVBUGVDVEVF $.
    $}

    ${
      $d R d e g $.  $d R f e g n m h $.  $d R n e g m i $.  $d ph d e g $.
      $d ph f e g n m $.
      $( The reflexive, transitive closure is indeed transitive.  (Contributed
         by Drahflow, 12-Nov-2015.) $)
      rtrclreclem.trans $p |- ( ph -> ( ( t*rec ` R ) o. ( t*rec ` R ) ) C_
                                      ( t*rec ` R ) ) $=
        ( ve vf vg cv wbr wa wceq wcel wi crelexp cn0 syl adantl expcom anassrs
        co vd vn vm vi crtrcl cfv ccom wex copab df-co cop elopab anbi1d simprr
        vh eqeq1 simprl wrex simpl wb dfrtrclrec2 mpbid simprrl caddc nn0addcld
        nn0cnd addcomd eleq1 relexpadd mp2and oveq2 eqeq2d syl5ibr sylbid mpcom
        wrel cvv eqcomd vex breq2 breq1 anbi12d spcev syl2anc brco sylibr breqd
        breq rspcev syldan mpancom df-br syl5bbr mpbird impcom rexlimiv exlimdv
        sylc anabsi5 exlimdvv syl5bi eleq2 imbi1d ax-mp ssrdv ) AUABUEUFZXFUGZX
        FXGEHZFHZXFIZXIGHZXFIZJZFUHZEGUIZKZAUAHZXGLZXQXFLZMZMEGFXFXFUJAXTXPXQXO
        LZXSMYAXQXHXKUKZKZXNJZGUHEUHAXSXNEGXQULAYDXSEGYDAXSYCXNAXSYCXNAJZXSYCYC
        YEJYBYBKZYEJZXSYCYCYFYEXQYBYBUPUMYGXSYCYBXFLZYGAXNYHYFXNAUNYFXNAUQAXMYH
        FXMAYHXJXLAYHXHXIBUBHZNTZIZUBOURZXJXLAJZJZYHYNXJYLXJYMUSYNAXJYLUTXJXLAU
        NAXHXIBUBCDVAPVBYKYNYHMZUBOYKYIOLZYOYNYKYPJZYHXJYMYQYHYMYQJXJYHXLAYQXJY
        HMZXJXLAYQJZJZYHXIXKBUCHZNTZIZUCOURZXJYTJZYHUUEXLUUDXJXLYSUQUUEAXLUUDUT
        XJXLAYQVCAXIXKBUCCDVAPVBUUCUUEYHMZUCOUUCUUAOLZUUFUUEUUCUUGJZYHXJYTUUHYH
        YTUUHJXJYHXLYSUUHYRYSUUHJXLYRAYQUUHXLYRMZYQUUHJAUUIYKYPUUHAUUIMAYKYPUUH
        JZJZUUIXLAUUKJZYRXJXLUULJZYHXJUUMJZYHXHXKBUDHZNTZIZUDOURZYIUUAVDTZOLZUU
        NUURUUNYIUUAUUMYPXJUULYPXLAYKYPUUHVCQQZUUMUUGXJUULUUGXLUUKUUGAUUJUUGYKY
        PUUCUUGUNQQQQZVEUUTUUNXHXKBUUSNTZIZUURUVCUUBYJUGZKZUUTUUNJZUVDUVGUVEUVC
        UUSUUAYIVDTZKZUVGUVEUVCKZUVGYIUUAUVGYIUUNYPUUTUVAQVFUVGUUAUUNUUGUUTUVBQ
        VFVGUVIUVGUVHOLZUUNJZUVJUVIUUTUVKUUNUUSUVHOVHUMUVLUVJUVIUVEBUVHNTZKZUVL
        UUGYPUVNUUNUUGUVKUVBQUUNYPUVKUVAQUVLBYIUUAUVLABVPZUUNAUVKXJXLAUUKVCZQZC
        PUVLABVQLZUVQDPVIVJUVIUVCUVMUVEUUSUVHBNVKVLVMVNVOVRUVGUVDUVFXHXKUVEIZUV
        GXHUOHZYJIZUVTXKUUBIZJZUOUHZUVSUVGYKUUCUWDUUNYKUUTUUMYKXJXLAYKUUJVCQQUU
        NUUCUUTUUMUUCXJUULUUCXLUUKUUCAYKYPUUCUUGVCQQQQUWCYKUUCJUOXIFVSUVTXIKUWA
        YKUWBUUCUVTXIXHYJVTUVTXIXKUUBWAWBWCWDUOXHXKUUBYJEVSGVSWEWFXHXKUVCUVEWHV
        MVOUUQUVDUDUUSOUUOUUSKUUPUVCXHXKUUOUUSBNVKWGWIWJWKYHXHXKXFIUUNUURXHXKXF
        WLUUNXHXKBUDUUNAUVOUVPCPUUNAUVRUVPDPVAWMWNRRRSWOSWOSWOSRRWPVORSWOSRRWPV
        OSRWQWRXQYBXFVHVMVNWSSRWTXAXPXRYAXSXGXOXQXBXCVMXDXE $.
    $}

    ${
      $d ph s n i $.  $d ph s m i $.  $d ph r n $.  $d R r n $.  $d R i n $.
      $d R i m $.
      $( The reflexive, transitive closure of ` R ` is the smallest reflexive,
         transitive relation which contains ` R ` and the identity.
         (Contributed by Drahflow, 12-Nov-2015.) $)
      rtrclreclem.min $p |- ( ph -> A. s ( ( ( _I |` ( dom R u. ran R ) ) C_ s
          /\ R C_ s /\ ( s o. s ) C_ s ) -> ( t*rec ` R ) C_ s ) ) $=
        ( vn cv wss wi cvv cn0 crelexp co wceq adantl wcel wa cc0 sseq1d expcom
        vr vi vm cid cdm crn cun cres ccom w3a crtrcl cfv ciun cmpt eqidd oveq1
        iuneq2d nn0ex ovex iunex a1i fvmptd c1 caddc eleq1 anbi1d oveq2 imbi12d
        wral cuni simprl relexp0 syl wrel relfld simprrr reseq2 syl5ibr eqsstrd
        mpcom simprrl jca32 mpd relexpsucr coss2 coss1 sylan9ss mpancom anassrs
        sstrd impcom nn0ind anabsi5 ralrimiv iunss sylibr 3imp1 sseq1 imbi2d wb
        3syl df-rtrclrec fveq1 ax-mp mpbir alrimiv ) AUDBUEBUFUGZUHZCGZHZBXIHZX
        IXIUIZXIHZUJZBUKULZXIHZIZCAXQIZAXNBUAJFKUAGZFGZLMZUMZUNZULZXIHZIZIZYDFK
        BXTLMZUMZNZAYFAUABYBYIJYCJAYCUOXSBNZYBYINAYKFKYAYHXSBXTLUPUQOEYIJPAFKYH
        URBXTLUSUTVAVBAYFYJXNYIXIHZIXNAYLXJXKXMAYLXKXJXMAYLIZIXMXKXJQZYMAXMYNQZ
        YLAYOQZYHXIHZFKVIYLYPYQFKXTKPZYPYQYRYPYQUBGZKPZYPQZBYSLMZXIHZIRKPZYPQZB
        RLMZXIHZIUCGZKPZYPQZBUUHLMZXIHZIZUUHVCVDMZKPZYPQZBUUNLMZXIHZIZYRYPQZYQI
        UBUCXTYSRNZUUAUUEUUCUUGUVAYTUUDYPYSRKVEVFUVAUUBUUFXIYSRBLVGSVHYSUUHNZUU
        AUUJUUCUULUVBYTUUIYPYSUUHKVEVFUVBUUBUUKXIYSUUHBLVGSVHYSUUNNZUUAUUPUUCUU
        RUVCYTUUOYPYSUUNKVEVFUVCUUBUUQXIYSUUNBLVGSVHYSXTNZUUAUUTUUCYQUVDYTYRYPY
        SXTKVEVFUVDUUBYHXIYSXTBLVGSVHUUEUUFUDBVJVJZUHZXIUUEAUUFUVFNUUDAYOVKZABD
        EVLVMUVEXGNZUUEUVFXIHZUUEABVNZUVHUVGDBVOXAUUEUVIUVHXJYPXJUUDAXMXKXJVPOU
        VHUVFXHXIUVEXGUDVQSVRVTVSUUMUUIUUSUUPUUMUUIQZUURUUOYPUVKUURYPUVKQUUOUUR
        AYOUVKUUOUURIZYOUVKQAUVLXMYNUVKAUVLIZYNUVKQXMUVMXKXJUVKXMUVMIXMXKXJUVKQ
        ZQZUVMAXMUVOQZUVLUUOAUVPQZUURUULUUOUVQQZUURUVRUUJUULUVRUUIAYOUVQUUIUUOU
        VPUUIAUVOUUIXMXKXJUUMUUIVPOOOZUUOAUVPVKUVRXMXKXJUUOAXMUVOWAZUVQXKUUOAXM
        XKUVNWAOZUVQXJUUOUVPXJAXMXKXJUVKWAOOWBWBUVQUUMUUOUVPUUMAUVOUUMXMXKXJUUM
        UUIWAOOOWCUULUVRQZUUQUUKBUIZXIUWBUUIUUQUWCNUVRUUIUULUVSOUWBBUUHUWBAUVJU
        ULUUOAUVPWAZDVMUWBABJPUWDEVMWDWCUWBUWCUUKXIUIZXIUWBXKUWCUWEHUVRXKUULUWA
        OBXIUUKWEVMUULUVRUWEXLXIUUKXIXIWFUVTWGWJVSWHTTTWIWKWIWKWIWKWITTWLWMTWNF
        KYHXIWOWPTTTWQTYJYEYLXNYDYIXIWRWSVRVTUKYCNZXRYGWTFUAXBUWFXQYFAUWFXPYEXN
        UWFXOYDXIBUKYCXCSWSWSXDXEXF $.
    $}
  $}

  ${
    $d x z R $.  $d x z ph $.  $d s z R $.  $d s z ph $.
    drrtrcl2.1 $e |- ( ph -> Rel R ) $.
    drrtrcl2.2 $e |- ( ph -> R e. _V ) $.
    $( The two definitions ` t* ` and ` t*rec ` of the reflexive, transitive
       closure coincide if ` R ` is indeed a relation.  (Contributed by
       Drahflow, 12-Nov-2015.) $)
    dfrtrcl2 $p |- ( ph -> ( t* ` R ) = ( t*rec ` R ) ) $=
      ( vx vz vs crtcl cfv wceq wi cvv cid cv cres wss w3a id wcel sseq2 crtrcl
      cdm crn cun ccom cab cint cmpt eqidd dmeq uneq12d reseq2d sseq1d 3anbi12d
      rneq abbidv inteqd adantl c0 wne cuni wrel relfld eqcomd rtrclreclem.refl
      syl syl5ibr mpcom rtrclreclem.subset rtrclreclem.trans wb coeq12d sseq12d
      wal fvex 3anbi123d a1i alrimiv elabgt sylancr mpbir3and ne0i intex fvmptd
      sylib intss1 wral vex elab rtrclreclem.min 19.21bi syl5bi ralrimiv sylibr
      ssint eqssd eqtrd df-rtrcl fveq1 eqeq1d imbi2d ax-mp mpbir ) ABHIZBUAIZJZ
      KZABELMENZUBZXHUCZUDZOZFNZPZXHXMPZXMXMUEZXMPZQZFUFZUGZUHZIZXEJZKZAYBMBUBZ
      BUCZUDZOZXMPZBXMPZXQQZFUFZUGZXEAEBXTYMLYALAYAUIXHBJZXTYMJAYNXSYLYNXRYKFYN
      XNYIXOYJXQYNXLYHXMYNXKYGMYNXIYEXJYFXHBUJXHBUOUKULUMYNXHBXMYNRUMUNUPUQURDA
      YLUSUTZYMLSAXEYLSZYOAYPYHXEPZBXEPZXEXEUEZXEPZYGBVAVAZJZAYQAUUAYGABVBUUAYG
      JCBVCVFVDAYQUUBMUUAOZXEPABCDVEUUBYHUUCXEUUBYGUUAMUUBRULUMVGVHABCDVIABCDVJ
      AXELSXMXEJZYKYQYRYTQZVKKZFVNYPUUEVKBUAVOAUUFFUUFAUUDYIYQYJYRXQYTXMXEYHTXM
      XEBTUUDXPYSXMXEUUDXMXEXMXEUUDRZUUGVLUUGVMVPVQVRYKUUEFXELVSVTWAZYLXEWBVFYL
      WCWEWDAYMXEAYPYMXEPUUHXEYLWFVFAXEGNZPZGYLWGXEYMPAUUJGYLUUIYLSYHUUIPZBUUIP
      ZUUIUUIUEZUUIPZQZAUUJYKUUOFUUIGWHXMUUIJZYIUUKYJUULXQUUNXMUUIYHTXMUUIBTUUP
      XPUUMXMUUIUUPXMUUIXMUUIUUPRZUUQVLUUQVMVPWIAUUOUUJKGABGCDWJWKWLWMGXEYLWOWN
      WPWQHYAJZXGYDVKEFWRUURXFYCAUURXDYBXEBHYAWSWTXAXBXC $.
  $}

  ${
    $d R n x $.  $d R i j x $.  $d S n x $.  $d S i j x $.  $d X n x $.
    $d et n x $.  $d et i j x $.  $d ta n x $.  $d ps i j $.  $d th i $.
    $d ph j x $.  $d ch i $.
    rtrclind.1 $e |- ( et -> Rel R ) $.
    rtrclind.2 $e |- ( et -> R e. _V ) $.
    rtrclind.3 $e |- ( et -> S e. _V ) $.
    rtrclind.4 $e |- ( et -> X e. _V ) $.
    rtrclind.5 $e |- ( i = S -> ( ph <-> ch ) ) $.
    rtrclind.6 $e |- ( i = x -> ( ph <-> ps ) ) $.
    rtrclind.7 $e |- ( i = j -> ( ph <-> th ) ) $.
    rtrclind.8 $e |- ( x = X -> ( ps <-> ta ) ) $.
    rtrclind.9 $e |- ( et -> ch ) $.
    rtrclind.10 $e |- ( et -> ( j R x -> ( th -> ps ) ) ) $.
    $( Principle of transitive induction.  The first four hypotheses give
       various existences, the next four give necessary substitutions and the
       last two are the basis and the induction hypothesis.  (Contributed by
       Drahflow, 12-Nov-2015.) $)
    rtrclind $p |- ( et -> ( S ( t* ` R ) X -> ta ) ) $=
      ( vn crtcl cfv crtrcl wceq wbr wi dfrtrcl2 cv crelexp co wrex dfrtrclrec2
      cn0 wa biimpac wcel simprl simprrr simprrl relexpind syl3c anassrs expcom
      rexlimiv mpcom breq imbi1d syl5ibr ) HUDUEZHUFUEZUGZFILVLUHZEUIZFHMNUJFVP
      VNILVMUHZEUIVQFEILHUCUKZULUMUHZUCUPUNZVQFUQZEFVQVTFILHUCMNUOURVSWAEUIZUCU
      PVSVRUPUSZWBWAVSWCUQZEVQFWDEVQFWDUQUQFWCVSEVQFWDUTVQFVSWCVAVQFVSWCVBABCDE
      FGHIJKUCLMNOPQRSTUAUBVCVDVEVFVFVGVHVFVNVOVQEILVLVMVIVJVKVH $.
  $}

$( (End of Drahflow's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Scott Fenton
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              ZFC Axioms in primitive form
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( ~ ax-ext without distinct variable conditions or defined symbols.
     (Contributed by Scott Fenton, 13-Oct-2010.) $)
  axextprim $p |- -. A. x -. ( ( x e. y -> x e. z ) ->
               ( ( x e. z -> x e. y ) -> y = z ) ) $=
    ( wel wb weq wi wex wn wal axextnd wa dfbi2 imbi1i impexp bitri exbii df-ex
    mpbi ) ABDZACDZEZBCFZGZAHZTUAGZUATGZUCGGZIAJIZABCKUEUHAHUIUDUHAUDUFUGLZUCGU
    HUBUJUCTUAMNUFUGUCOPQUHARPS $.

  $( ~ ax-rep without distinct variable conditions or defined symbols.
     (Contributed by Scott Fenton, 13-Oct-2010.) $)
  axrepprim $p |- -. A. x -. ( -. A. y -. A. z ( ph -> z = y ) ->
               A. z -. ( ( A. y z e. x -> -. A. x ( A. z x e. y ->
               -. A. y ph ) ) -> -. ( -. A. x ( A. z x e. y -> -. A. y ph )
               -> A. y z e. x ) ) ) $=
    ( weq wi wal wex wel wa wb wn axrepnd df-ex df-an exbii exnal bitri bibi2i
    dfbi1 albii imbi12i mpbi ) ADCEFDGZCHZDBICGZBCIDGZACGZJZBHZKZDGZFZBHZUDLCGL
    ZUFUGUHLFZBGLZFUQUFFLFLZDGZFZLBGLZABCDMUNUTBHVAUMUTBUEUOULUSUDCNUKURDUKUFUQ
    KURUJUQUFUJUPLZBHUQUIVBBUGUHOPUPBQRSUFUQTRUAUBPUTBNRUC $.

  $( ~ ax-un without distinct variable conditions or defined symbols.
     (Contributed by Scott Fenton, 13-Oct-2010.) $)
  axunprim $p |- -. A. x -. A. y ( -. A. x ( y e. x -> -. x e. z )
               -> y e. x ) $=
    ( wel wa wex wi wal axunnd df-an exbii exnal bitri imbi1i albii df-ex mpbi
    wn ) BADZACDZEZAFZSGZBHZAFZSTRGZAHRZSGZBHZRAHRZABCIUEUIAFUJUDUIAUCUHBUBUGSU
    BUFRZAFUGUAUKASTJKUFALMNOKUIAPMQ $.

  $( ~ ax-pow without distinct variable conditions or defined symbols.
     (Contributed by Scott Fenton, 13-Oct-2010.) $)
  axpowprim $p |- ( A. x -. A. y ( A. x ( -. A. z -. x e. y -> A. y x e. z )
               -> y e. x ) -> x = y ) $=
    ( weq wel wn wal wi wex axpownd df-ex imbi1i albii exbii bitri sylib con4i
    ) ABDZABEZFCGFZACEBGZHZAGZBAEZHZBGZFAGZRFSCIZUAHZAGZUDHZBGZAIZUGFZABCJUMUFA
    IUNULUFAUKUEBUJUCUDUIUBAUHTUASCKLMLMNUFAKOPQ $.

  $( ~ ax-reg without distinct variable conditions or defined symbols.
     (Contributed by Scott Fenton, 13-Oct-2010.) $)
  axregprim $p |- ( x e. y ->
               -. A. x ( x e. y -> -. A. z ( z e. x -> -. z e. y ) ) ) $=
    ( wel wn wi wal wa wex axregnd df-an exbii exnal bitri sylib ) ABDZPCADCBDE
    FCGZHZAIZPQEFZAGEZABCJSTEZAIUARUBAPQKLTAMNO $.

  $( ~ ax-inf without distinct variable conditions or defined symbols.
     (New usage is discouraged.)  (Contributed by Scott Fenton,
     13-Oct-2010.) $)
  axinfprim $p |- -. A. x -. ( y e. z -> -. ( y e. x ->
               -. A. y ( y e. x -> -. A. z ( y e. z -> -. z e. x ) ) ) ) $=
    ( wel wa wex wi wn axinfnd df-an exbii exnal bitri imbi2i albii anbi2i mpbi
    wal df-ex ) BCDZBADZUATCADZEZCFZGZBRZEZGZAFZTUAUATUBHGZCRHZGZBRZHGHZGZHARHZ
    ABCIUIUOAFUPUHUOAUGUNTUGUAUMEUNUFUMUAUEULBUDUKUAUDUJHZCFUKUCUQCTUBJKUJCLMNO
    PUAUMJMNKUOASMQ $.

  $( ~ ax-ac without distinct variable conditions or defined symbols.
     (New usage is discouraged.)  (Contributed by Scott Fenton,
     26-Oct-2010.) $)
  axacprim $p |- -. A. x -. A. y A. z ( A. x -. ( y e. z -> -. z e. w ) ->
                  -. A. w -. A. y -. ( ( -. A. w ( y e. z -> ( z e. w ->
                  ( y e. w -> -. w e. x ) ) ) -> y = w ) -> -. ( y = w ->
                  -. A. w ( y e. z -> ( z e. w -> ( y e. w -> -. w e. x )
                  ) ) ) ) ) $=
    ( wel wa wal wex wb wi wn axacnd df-an albii annim anbi2i exbii bitri df-ex
    weq anass pm4.63 bitr3i 3bitr2i exnal bibi1i dfbi1 imbi12i 2albii mpbi ) BC
    EZCDEZFZAGZUMBDEZDAEZFZFZDHZBDTZIZBGZDHZJZCGBGZAHZUKULKJKZAGZUKULUOUPKJZJZJ
    ZDGKZUTJUTVLJKJKZBGZKDGKZJZCGBGZKAGKZABCDLVFVQAHVRVEVQAVDVPBCUNVHVCVOUMVGAU
    KULMNVCVNDHVOVBVNDVAVMBVAVLUTIVMUSVLUTUSVKKZDHVLURVSDURUKULUQFZFUKVJKZFVSUK
    ULUQUAWAVTUKWAULVIKZFVTULVIOWBUQULUOUPUBPUCPUKVJOUDQVKDUERUFVLUTUGRNQVNDSRU
    HUIQVQASRUJ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Untangled classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( We call a class "untanged" if all its members are not members of
       themselves.  The term originates from Isbell (see citation in
       ~ dfon2 ).  Using this concept, we can avoid a lot of the uses of the
       Axiom of Regularity.  Here, we prove a series of properties of untanged
       classes.  First, we prove that an untangled class is not a member of
       itself.  (Contributed by Scott Fenton, 28-Feb-2011.) $)
    untelirr $p |- ( A. x e. A -. x e. x -> -. A e. A ) $=
      ( wel wn wral wcel cv wceq eleq1 eleq2 bitrd notbid rspccv pm2.01d ) AACZ
      DZABEBBFZPQDABBAGZBHZOQSOBRFQRBRIRBBJKLMN $.
  $}

  ${
    $d x y A $.
    $( The union of a class is untangled iff all its members are untangled.
       (Contributed by Scott Fenton, 28-Feb-2011.) $)
    untuni $p |- ( A. x e. U. A -. x e. x
        <-> A. y e. A A. x e. y -. x e. x ) $=
      ( cv cuni wcel wel wn wal wral wrex r19.23v albii ralcom4 eluni2 3bitr4ri
      wi imbi1i df-ral ralbii 3bitr4i ) ADZCEZFZAAGHZQZAIZABGZUEQZAIZBCJZUEAUCJ
      UEABDZJZBCJUIBCJZAIUHBCKZUEQZAIUKUGUNUPAUHUEBCLMUIBACNUFUPAUDUOUEBUBCORMP
      UEAUCSUMUJBCUEAULSTUA $.
  $}

  ${
    $d x A $.  $d x y $.
    untsucf.1 $e |- F/_ y A $.
    $( If a class is untangled, then so is its successor.  (Contributed by
       Scott Fenton, 28-Feb-2011.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    untsucf $p |- ( A. x e. A -. x e. x -> A. y e. suc A -. y e. y ) $=
      ( wel wn wral csuc nfral cv wcel wceq wo elsuc elequ1 elequ2 bitrd notbid
      nfv vex rspccv untelirr eleq1 eleq2 syl5ibrcom jaod syl5bi ralrimi ) AAEZ
      FZACGZBBEZFZBCHZUJBACDUJBSIBJZUNKUOCKZUOCLZMUKUMUOCBTNUKUPUMUQUJUMAUOCAJU
      OLZUIULURUIBAEULABAOABBPQRUAUKUMUQCCKZFACUBUQULUSUQULCUOKUSUOCUOUCUOCCUDQ
      RUEUFUGUH $.
  $}

  $( The null set is untangled.  (Contributed by Scott Fenton, 10-Mar-2011.)
     (Proof shortened by Andrew Salmon, 27-Aug-2011.) $)
  unt0 $p |- A. x e. (/) -. x e. x $=
    ( wel wn ral0 ) AABCAD $.

  ${
    $d x y A $.
    $( If there is an untangled element of a class, then the intersection of
       the class is untangled.  (Contributed by Scott Fenton, 1-Mar-2011.) $)
    untint $p |- ( E. x e. A A. y e. x -. y e. y ->
                    A. y e. |^| A -. y e. y ) $=
      ( wel wn cv wral cint wcel wss wi intss1 ssralv syl rexlimiv ) BBDEZBAFZG
      ZPBCHZGZACQCISQJRTKQCLPBSQMNO $.
  $}

  ${
    $d x A $.
    $( If ` A ` is well-founded by ` _E ` , then it is untangled.  (Contributed
       by Scott Fenton, 1-Mar-2011.) $)
    efrunt $p |- ( _E Fr A -> A. x e. A -. x e. x ) $=
      ( cep wfr cv wcel wn wa wbr frirr epel sylnib ralrimiva ) BCDZAEZOFZGABNO
      BFHOOCIPBOCJAAKLM $.
  $}

  ${
    $d x y A $.
    $( A transitive class is untangled iff its elements are.  (Contributed by
       Scott Fenton, 7-Mar-2011.) $)
    untangtr $p |- ( Tr A ->
                   ( A. x e. A -. x e. x <->
                     A. x e. A A. y e. x -. y e. y ) ) $=
      ( wtr wel wn wral cv cuni wss df-tr ssralv sylbi weq elequ1 elequ2 notbid
      wi bitrd cbvralv untuni bitri syl6ib untelirr ralimi impbid1 ) CDZAAEZFZA
      CGZBBEZFZBAHZGZACGZUGUJUIACIZGZUOUGUPCJUJUQRCKUIAUPCLMUQULBUPGUOUIULABUPA
      BNZUHUKURUHBAEUKABAOABBPSQTBACUAUBUCUNUIACBUMUDUEUF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Extra propositional calculus theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Partial elimination of a triple disjunction by denial of a disjunct.
     (Contributed by Scott Fenton, 26-Mar-2011.) $)
  3orel1 $p |- ( -. ph -> ( ( ph \/ ps \/ ch ) -> ( ps \/ ch ) ) ) $=
    ( w3o wo wn 3orass orel1 syl5bi ) ABCDABCEZEAFJABCGAJHI $.

  $( Partial elimination of a triple disjunction by denial of a disjunct.
     (Contributed by Scott Fenton, 26-Mar-2011.)  (Proof shortened by Andrew
     Salmon, 25-May-2011.) $)
  3orel2 $p |- ( -. ps -> ( ( ph \/ ps \/ ch ) -> ( ph \/ ch ) ) ) $=
    ( w3o wn wo 3orrot 3orel1 orcom syl6ib syl5bi ) ABCDBCADZBEZACFZABCGMLCAFNB
    CAHCAIJK $.

  $( Partial elimination of a triple disjunction by denial of a disjunct.
     (Contributed by Scott Fenton, 26-Mar-2011.) $)
  3orel3 $p |- ( -. ch -> ( ( ph \/ ps \/ ch ) -> ( ph \/ ps ) ) ) $=
    ( w3o wo wn df-3or orel2 syl5bi ) ABCDABEZCECFJABCGCJHI $.

  ${
    3pm3.2ni.1 $e |- -. ph $.
    3pm3.2ni.2 $e |- -. ps $.
    3pm3.2ni.3 $e |- -. ch $.
    $( Triple negated disjuntion introduction.  (Contributed by Scott Fenton,
       20-Apr-2011.) $)
    3pm3.2ni $p |- -. ( ph \/ ps \/ ch ) $=
      ( w3o wo pm3.2ni df-3or mtbir ) ABCGABHZCHLCABDEIFIABCJK $.
  $}

  ${
    3jaodd.1 $e |- ( ph -> ( ps -> ( ch -> et ) ) ) $.
    3jaodd.2 $e |- ( ph -> ( ps -> ( th -> et ) ) ) $.
    3jaodd.3 $e |- ( ph -> ( ps -> ( ta -> et ) ) ) $.
    $( Double deduction form of ~ 3jaoi .  (Contributed by Scott Fenton,
       20-Apr-2011.) $)
    3jaodd $p |- ( ph -> ( ps -> ( ( ch \/ th \/ ta ) -> et ) ) ) $=
      ( w3o wi com3r 3jaoi com3l ) CDEJABFCABFKKDEABCFGLABDFHLABEFILMN $.
  $}

  $( Closed form of ~ 3ori , (Contributed by Scott Fenton, 20-Apr-2011.) $)
  3orit $p |- ( ( ph \/ ps \/ ch ) <-> ( ( -. ph /\ -. ps ) -> ch ) ) $=
    ( w3o wo wn wi wa df-3or df-or ioran imbi1i 3bitri ) ABCDABEZCENFZCGAFBFHZC
    GABCINCJOPCABKLM $.

  ${
    3mixd.1 $e |- ( ph -> ps ) $.
    $( Deduction introducing triple disjunction.  (Contributed by Scott Fenton,
       8-Jun-2011.) $)
    3mix1d $p |- ( ph -> ( ps \/ ch \/ th ) ) $=
      ( w3o 3mix1 syl ) ABBCDFEBCDGH $.

    $( Deduction introducing triple disjunction.  (Contributed by Scott Fenton,
       8-Jun-2011.) $)
    3mix2d $p |- ( ph -> ( ch \/ ps \/ th ) ) $=
      ( w3o 3mix2 syl ) ABCBDFEBCDGH $.

    $( Deduction introducing triple disjunction.  (Contributed by Scott Fenton,
       8-Jun-2011.) $)
    3mix3d $p |- ( ph -> ( ch \/ th \/ ps ) ) $=
      ( w3o 3mix3 syl ) ABCDBFEBCDGH $.
  $}

  $( A biconditional in the antecedent is the same as two implications.
     (Contributed by Scott Fenton, 12-Dec-2010.) $)
  biimpexp $p |- ( ( ( ph <-> ps ) -> ch )
                   <-> ( ( ph -> ps ) -> ( ( ps -> ph ) -> ch ) ) ) $=
    ( wb wi wa dfbi2 imbi1i impexp bitri ) ABDZCEABEZBAEZFZCELMCEEKNCABGHLMCIJ
    $.

  $( Elimination of two disjuncts in a triple disjunction.  (Contributed by
     Scott Fenton, 9-Jun-2011.) $)
  3orel13 $p |- ( ( -. ph /\ -. ch ) -> ( ( ph \/ ps \/ ch ) -> ps ) ) $=
    ( wn w3o wo 3orel3 orel1 sylan9r ) CDABCEABFADBABCGABHI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Misc. Useful Theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Two classes are inequal iff their intersection is a proper subset of one
     of them.  (Contributed by Scott Fenton, 23-Feb-2011.) $)
  nepss $p |- ( A =/= B <-> ( ( A i^i B ) C. A \/ ( A i^i B ) C. B ) ) $=
    ( wne cin wss wa wo wpss wn wceq nne neeq1 biimprcd orrd jctl inidm necon3i
    syl5bi adantl df-pss inss1 inss2 orim12i ineq2 syl5reqr ineq1 syl6eq impbii
    syl jaoi orbi12i bitr4i ) ABCZABDZAEZUNACZFZUNBEZUNBCZFZGZUNAHZUNBHZGUMVAUM
    UPUSGVAUMUPUSUPIUNAJZUMUSUNAKVDUSUMUNABLMRNUPUQUSUTUPUOABUAOUSURABUBOUCUIUQ
    UMUTUPUMUOABUNAABJZAAADUNAPABAUDUEQSUSUMURABUNBVEUNBBDBABBUFBPUGQSUJUHVBUQV
    CUTUNATUNBTUKUL $.


  ${
    3ccased.1 $e |- ( ph -> ( ( ch /\ et ) -> ps ) ) $.
    3ccased.2 $e |- ( ph -> ( ( ch /\ ze ) -> ps ) ) $.
    3ccased.3 $e |- ( ph -> ( ( ch /\ si ) -> ps ) ) $.
    3ccased.4 $e |- ( ph -> ( ( th /\ et ) -> ps ) ) $.
    3ccased.5 $e |- ( ph -> ( ( th /\ ze ) -> ps ) ) $.
    3ccased.6 $e |- ( ph -> ( ( th /\ si ) -> ps ) ) $.
    3ccased.7 $e |- ( ph -> ( ( ta /\ et ) -> ps ) ) $.
    3ccased.8 $e |- ( ph -> ( ( ta /\ ze ) -> ps ) ) $.
    3ccased.9 $e |- ( ph -> ( ( ta /\ si ) -> ps ) ) $.
    $( Triple disjunction form of ~ ccased .  (Contributed by Scott Fenton,
       27-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    3ccased $p |- ( ph -> ( ( ( ch \/ th \/ ta ) /\ ( et \/ ze \/ si ) ) ->
                     ps ) ) $=
      ( wa com12 3jaodan w3o wi 3jaoian ) CDEUAFGHUAZRABCUDABUBZDECFUEGHACFRBIS
      ACGRBJSACHRBKSTDFUEGHADFRBLSADGRBMSADHRBNSTEFUEGHAEFRBOSAEGRBPSAEHRBQSTUC
      S $.
  $}

  ${
    $d R x y z $.  $d A x y z $.
    $( Expansion of the definition of a strict order.  (Contributed by Scott
       Fenton, 6-Jun-2016.) $)
    dfso3 $p |- ( R Or A <->
       A. x e. A A. y e. A A. z e. A
       ( -. x R x /\
         ( ( x R y /\ y R z ) -> x R z ) /\
         ( x R y \/ x = y \/ y R x ) ) ) $=
      ( cv wbr wn wa wi weq w3o wral w3a wor wcel c0 wne wb ralbii r19.27zv syl
      ne0i ralbiia df-3an 2ralbii df-po anbi1i df-so r19.26-2 3bitr4i 3bitr4ri
      wpo ) AFZUNEGHZUNBFZEGZUPCFZEGIUNUREGJZIZUQABKUPUNEGLZIZCDMZBDMZADMUTCDMZ
      VAIZBDMZADMZUOUSVANZCDMZBDMADMDEOZVDVGADVCVFBDUPDPDQRVCVFSDUPUCUTVACDUAUB
      UDTVJVCABDDVIVBCDUOUSVAUETUFDEUMZVABDMADMZIVEBDMADMZVMIVKVHVLVNVMABCDEUGU
      HABDEUIVEVAABDDUJUKUL $.
  $}

  $( A binary relationship involving unordered triplets.  (Contributed by Scott
     Fenton, 7-Jun-2016.) $)
  brtpid1 $p |- A { <. A , B >. , C , D } B $=
    ( cop ctp wbr wcel opex tpid1 df-br mpbir ) ABABEZCDFZGMNHMCDABIJABNKL $.

  $( A binary relationship involving unordered triplets.  (Contributed by Scott
     Fenton, 7-Jun-2016.) $)
  brtpid2 $p |- A { C , <. A , B >. , D } B $=
    ( cop ctp wbr wcel opex tpid2 df-br mpbir ) ABCABEZDFZGMNHCMDABIJABNKL $.

  $( A binary relationship involving unordered triplets.  (Contributed by Scott
     Fenton, 7-Jun-2016.) $)
  brtpid3 $p |- A { C , D , <. A , B >. } B $=
    ( cop ctp wbr wcel opex tpid3 df-br mpbir ) ABCDABEZFZGMNHCDMABIJABNKL $.

  ${
    $d A x $.  $d B x $.  $d ps x $.
    ceqsrexv2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Alternate elimitation of a restricted existential quantifier, using
       implicit substitution.  (Contributed by Scott Fenton, 5-Sep-2017.) $)
    ceqsrexv2 $p |- ( E. x e. B ( x = A /\ ph ) <-> ( A e. B /\ ps ) ) $=
      ( ceqsrexbv ) ABCDEFG $.
  $}

  ${
    $d x V $.  $d A y $.  $d ps y $.  $d x y $.
    iota5f.1 $e |- F/ x ph $.
    iota5f.2 $e |- F/_ x A $.
    iota5f.3 $e |- ( ( ph /\ A e. V ) -> ( ps <-> x = A ) ) $.
    $( A method for computing iota.  (Contributed by Scott Fenton,
       13-Dec-2017.) $)
    iota5f $p |- ( ( ph /\ A e. V ) -> ( iota x ps ) = A ) $=
      ( vy wcel wa cv wceq wb wal cio nfel1 nfan wi eqeq2 alrimi bibi2d imbi12d
      weq nfeq2 albid iotaval vtoclg adantl mpd ) ADEJZKZBCLZDMZNZCOZBCPZDMZULU
      OCAUKCFCDEGQRHUAUKUPURSZABCIUDZNZCOZUQILZMZSUSIDEVCDMZVBUPVDURVEVAUOCCVCD
      GUEVEUTUNBVCDUMTUBUFVCDUQTUCBCIUGUHUIUJ $.
  $}

  ${
    $d x y $.
    $( The identity function using maps-to notation.  (Contributed by Scott
       Fenton, 15-Dec-2017.) $)
    dfid4 $p |- _I = ( x e. _V |-> x ) $=
      ( vy weq copab cv cvv wcel wa cid equcom vex biantrur bitri opabbii df-id
      cmpt df-mpt 3eqtr4i ) ABCZABDAEZFGZBACZHZABDIAFTPSUCABSUBUCABJUAUBAKLMNAB
      OABFTQR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Properties of reals and complexes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    sqdivzi.1 $e |- A e. CC $.
    sqdivzi.2 $e |- B e. CC $.
    $( Distribution of square over division.  (Contributed by Scott Fenton,
       7-Jun-2013.) $)
    sqdivzi $p |- ( B =/= 0 ->
            ( ( A / B ) ^ 2 ) = ( ( A ^ 2 ) / ( B ^ 2 ) ) ) $=
      ( cc0 wne cdiv co c2 cexp c1 cif oveq2 oveq1d oveq1 oveq2d eqeq12d ax-1cn
      wceq cc keepel elimne0 sqdivi dedth ) BEFZABGHZIJHZAIJHZBIJHZGHZSAUEBKLZG
      HZIJHZUHUKIJHZGHZSBKBUKSZUGUMUJUOUPUFULIJBUKAGMNUPUIUNUHGBUKIJOPQAUKCUEBK
      TDRUABUBUCUD $.
  $}

  $( A condition for a ratio to be a member of the closed unit.  (Contributed
     by Scott Fenton, 11-Jun-2013.) $)
  divelunit $p |- ( ( ( A e. RR /\ 0 <_ A ) /\ ( B e. RR /\ 0 < B ) ) ->
      ( ( A / B ) e. ( 0 [,] 1 ) <-> A <_ B ) ) $=
    ( cdiv co cc0 c1 cicc wcel cr cle wbr wa clt w3a 0re 1re elicc2i bitri cmul
    df-3an ledivmul mp3an2 adantlr simpll simprl wne gt0ne0 adantl redivcld jca
    wb divge0 biantrurd cc recn ad2antrl mulid1d breq2d 3bitr3d syl5bb ) ABCDZE
    FGDHZVAIHZEVAJKZLZVAFJKZLZAIHZEAJKZLZBIHZEBMKZLZLZABJKZVBVCVDVFNVGEFVAOPQVC
    VDVFTRVNVFABFSDZJKZVGVOVHVMVFVQUKZVIVHFIHVMVRPAFBUAUBUCVNVEVFVNVCVDVNABVHVI
    VMUDVJVKVLUEVMBEUFVJBUGUHUIABULUJUMVNVPBAJVNBVKBUNHVJVLBUOUPUQURUSUT $.

  ${
    pm2.61iine.1 $e |- ( ( A =/= C /\ B =/= D ) -> ph ) $.
    pm2.61iine.2 $e |- ( A = C -> ph ) $.
    pm2.61iine.3 $e |- ( B = D -> ph ) $.
    $( Equality version of ~ pm2.61ii .  (Contributed by Scott Fenton,
       13-Jun-2013.) $)
    pm2.61iine $p |- ph $=
      ( wceq wn wne df-ne syl2anbr ex pm2.61ii ) BDIZCEIZAPJZQJZARBDKCEKASBDLCE
      LFMNGHO $.
  $}

  ${
    $d A x y z w $.  $d B x y z w $.
    $( The Dedekind cut theorem.  This theorem, which may be used to replace
       ~ ax-pre-sup with appropriate adjustments, states that, if ` A `
       completely preceeds ` B ` , then there is some number separating the two
       of them.  (Contributed by Scott Fenton, 13-Jun-2013.) $)
    dedekind $p |- ( ( A C_ RR /\ B C_ RR /\ A. x e. A A. y e. B x < y ) ->
       E. z e. RR A. x e. A A. y e. B ( x <_ z /\ z <_ y ) ) $=
      ( vw cr clt wbr wral cle wa wrex wi c0 wn wcel wceq nfv c1 wss cv wne w3a
      simp2l simp1l wex simp1r n0 sylib simp2r sseld ralcom breq2 ralbidv sylbi
      rspccv 3ad2ant3 jcad eximdv df-rex sylibr axsup syl3anc nfra1 nf3an nfra2
      mpd simprrl r19.21bi simpl2l sselda simplrl lenltd mpbird ex simpl3 simp2
      nfan simpr rsp com12 adantl ssel2 adantlr adantr simplr ltnsym syld an32s
      syl2anc ralimdva syl2an notbid cbvralv ralnex simplrr breq1 rexbidv rspcv
      imbi12d sylc mtod simprll expr anim12d exp3a ralrimd ralrimi reximdva 1re
      3expib rzal anbi12d 2ralbidv rspcev sylancr ralrimivw pm2.61iine 3impa
      a1d ) DGUAZEGUAZAUBZBUBZHIZBEJZADJZYDCUBZKIZYIYEKIZLZBEJZADJZCGMZYBYCLZYH
      LZYONDEOODOUCZEOUCZLZYPYHYOYTYPYHUDZYIYDHIPZADJZYDYIHIZYDFUBZHIZFDMZNZAGJ
      ZLZCGMZYOUUAYBYRUUDADJZCGMZUUKYTYBYCYHUEYRYSYPYHUFUUAYIGQZUULLZCUGZUUMUUA
      YIEQZCUGZUUPUUAYSUURYRYSYPYHUHCEUIUJUUAUUQUUOCUUAUUQUUNUULUUAEGYIYTYBYCYH
      UKZULYHYTUUQUULNZYPYHYFADJZBEJUUTYFABDEUMUVAUULBYIEYEYIRYFUUDADYEYIYDHUNU
      OUQUPURUSUTVHUULCGVAVBCAFDVCVDUUAUUJYNCGUUAUUNUUJYNUUAUUNUUJLZLZYMADUUAUV
      BAYTYPYHAYTASYPASYGADVEVFUUNUUJAUUNASUUCUUIAUUBADVEUUHAGVEVSVSVSUVCYDDQZY
      LBEUUAUVBBYTYPYHBYTBSYPBSYFABDEVGVFUVBBSVSUVDBSUVCUVDYEEQZYLUVCUVDYJUVEYK
      UVCUVDYJUVCUVDLZYJUUBUVCUUBADUUAUUNUUCUUIVIVJUVFYDYIUVCDGYDYBYCYTYHUVBVKV
      LUUAUUNUUJUVDVMVNVOVPUUAUVBUVEYKUUAUVBUVELZLZYKYEYIHIZPUVHUVIYEUUEHIZFDMZ
      UVHUVJPZFDJZUVKPUVHYEYDHIZPZADJZUVMUVHYHUVPYTYPYHUVGVQUUAYPUVEYHUVPNUVGYT
      YPYHVRUVBUVEVTZYPUVELYGUVOADYPUVDUVEYGUVONYPUVDLZUVELZYGYFUVOUVEYGYFNUVRY
      GUVEYFYFBEWAWBWCUVSYDGQZYEGQZYFUVONUVRUVTUVEYBUVDUVTYCDGYDWDWEWFUVREGYEYB
      YCUVDWGVLYDYEWHWKWIWJWLWMVHUVOUVLAFDYDUUERUVNUVJYDUUEYEHUNWNWOUJUVJFDWPUJ
      UVHUWAUUIUVIUVKNZUUAYCUVEUWAUVGUUSUVQEGYEWDWMZUVGUUIUUAUUNUUCUUIUVEWQWCUU
      HUWBAYEGYDYERZUUDUVIUUGUVKYDYEYIHWRUWDUUFUVJFDYDYEUUEHWRWSXAWTXBXCUVHYIYE
      UUAUUNUUJUVEXDUWCVNVOXEXFXGXHXIXEXJVHXLDORZYOYQUWETGQZYDTKIZTYEKIZLZBEJZA
      DJZYOXKUWJADXMYNUWKCTGYITRZYLUWIABDEUWLYJUWGYKUWHYITYDKUNYITYEKWRXNXOXPZX
      QYAEORZYOYQUWNUWFUWKYOXKUWNUWJADUWIBEXMXRUWMXQYAXSXT $.

    $( The Dedekind cut theorem, with the hypothesis weakened to only require
       non-strict less than.  (Contributed by Scott Fenton, 2-Jul-2013.) $)
    dedekindle $p |- ( ( A C_ RR /\ B C_ RR /\ A. x e. A A. y e. B x <_ y ) ->
       E. z e. RR A. x e. A A. y e. B ( x <_ z /\ z <_ y ) ) $=
      ( vw cr wss cv cle wbr wral wa wi c0 wcel syl2an weq ssel2 nfv w3a simpr1
      wrex cin wceq clt simpr2 wne wn simp1 simpl disjel eleq1 biimpcd necon3bd
      ad2antll mpd simp2 simp3 simpr ltlend biimprd anassrs ralimdva 3exp 3imp2
      mpan2d dedekind syl3anc ex wex n0 inss1 sseli nfra1 nf3an nfra2 rsp inss2
      nfan breq2 rspccv syl5 com23 imp32 3ad2antl3 adantr breq1 ralbidv rspccva
      syl6 r19.21bi ralrimi expr anbi12d 2ralbidv rspcev syl2anc expcom exlimiv
      jca sylbi pm2.61ine ) DGHZEGHZAIZBIZJKZBELZADLZUAZXFCIZJKZXLXGJKZMZBELADL
      ZCGUCZNZDEUDZOXSOUEZXKXQXTXKMXDXEXFXGUFKZBELZADLZXQXTXDXEXJUBXTXDXEXJUGXT
      XDXEXJYCXTXDXEXJYCNXTXDXEUAZXIYBADYDXFDPZMXHYABEYDYEXGEPZXHYANYDYEYFMZMZX
      HXGXFUHZYAYHXFEPZUIZYIYDXTYEYKYGXTXDXEUJYEYFUKZDEXFULQYFYKYINYDYEYFYJXGXF
      BARYFYJXGXFEUMUNUOUPUQYHYAXHYIMYHXFXGYDXDYEXFGPYGXTXDXEURYLDGXFSQYDXEYFXG
      GPYGXTXDXEUSYEYFUTEGXGSQVAVBVGVCVDVDVEVFABCDEVHVIVJXSOUHFIZXSPZFVKXRFXSVL
      YNXRFXKYNXQXKYNMZYMGPZXFYMJKZYMXGJKZMZBELZADLZXQXKXDYMDPZYPYNXDXEXJUJXSDY
      MDEVMVNZDGYMSQYOYTADXKYNAXDXEXJAXDATXEATXIADVOVPYNATVTXKYNYEYTXKYNYEMZMZY
      SBEXKUUDBXDXEXJBXDBTXEBTXHABDEVQVPUUDBTVTUUEYFYSUUEYFMYQYRUUEYQYFXJXDUUDY
      QXEXJYNYEYQXJYEYNYQXJYEXIYNYQNXIADVRYNYMEPXIYQXSEYMDEVSVNXHYQBYMEXGYMXFJW
      AWBWCWKWDWEWFWGUUEYRBEXKXJUUBYRBELZUUDXDXEXJUSYNUUBYEUUCWGXIUUFAYMDAFRXHY
      RBEXFYMXGJWHWIWJQWLXAVJWMWNWMXPUUACYMGCFRZXOYSABDEUUGXMYQXNYRXLYMXFJWAXLY
      MXGJWHWOWPWQWRWSWTXBXC $.
  $}

  $( A generalized form of the cancellation law for multiplication.
     (Contributed by Scott Fenton, 17-Jun-2013.) $)
  mulcan1g $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
    ( ( A x. B ) = ( A x. C ) <-> ( A = 0 \/ B = C ) ) ) $=
    ( cc wcel w3a cmul co cmin cc0 wceq wo mulcl 3adant3 3adant2 subeq0ad simp1
    subcl 3adant1 mul0ord subdi eqeq1d wb subeq0 orbi2d 3bitr3d bitr3d ) ADEZBD
    EZCDEZFZABGHZACGHZIHZJKZULUMKAJKZBCKZLZUKULUMUHUIULDEUJABMNUHUJUMDEUIACMOPU
    KABCIHZGHZJKUPUSJKZLUOURUKAUSUHUIUJQUIUJUSDEUHBCRSTUKUTUNJABCUAUBUKVAUQUPUI
    UJVAUQUCUHBCUDSUEUFUG $.

  $( A generalized form of the cancellation law for multiplication.
     (Contributed by Scott Fenton, 17-Jun-2013.) $)
  mulcan2g $p |- ( ( A e. CC /\ B e. CC /\ C e. CC ) ->
    ( ( A x. C ) = ( B x. C ) <-> ( A = B \/ C = 0 ) ) ) $=
    ( cc wcel w3a cmul co wceq wo mulcom 3adant2 3adant1 eqeq12d mulcan1g 3coml
    cc0 wb orcom syl6bb bitrd ) ADEZBDEZCDEZFZACGHZBCGHZICAGHZCBGHZIZABIZCQIZJZ
    UEUFUHUGUIUBUDUFUHIUCACKLUCUDUGUIIUBBCKMNUEUJULUKJZUMUDUBUCUJUNRCABOPULUKST
    UA $.

  $( A condition for multiplication to be non-negative.  (Contributed by Scott
     Fenton, 25-Jun-2013.) $)
  mulge0b $p |- ( ( A e. RR /\ B e. RR ) ->
    ( 0 <_ ( A x. B ) <->
      ( ( A <_ 0 /\ B <_ 0 ) \/ ( 0 <_ A /\ 0 <_ B ) ) ) ) $=
    ( cr wcel wa cc0 cmul co cle wbr wo wn clt wb 0re ltnle mpan adantr wi ex
    ianor adantl orbi12d ltle imp ad2ant2rl remulcl simprl simpll simprr divge0
    cdiv syl22anc recn ad2antlr ad2antrr wne gt0ne0 divcan3d breqtrd jca simplr
    cc expr ad2ant2l divcan4d jaod sylbird syl5bi orrd le0neg1 bi2anan9 renegcl
    cneg mulge0 an4s syl2an wceq mul2neg breq2d sylibd sylbid impbid ) ACDZBCDZ
    EZFABGHZIJZAFIJZBFIJZEZFAIJZFBIJZEZKZWFWHWOWFWHEZWKWNWKLWILZWJLZKZWPWNWIWJU
    AWPWSFAMJZFBMJZKZWNWFXBWSNWHWFWTWQXAWRWDWTWQNZWEFCDZWDXCOFAPQRWEXAWRNZWDXDW
    EXEOFBPQUBUCRWPWTWNXAWFWHWTWNWFWHWTEZEZWLWMWDWTWLWEWHWDWTWLXDWDWTWLSOFAUDQU
    EUFXGFWGAULHZBIXGWGCDZWHWDWTFXHIJWFXIXFABUGZRWFWHWTUHWDWEXFUIWFWHWTUJWGAUKU
    MXGBAWEBVCDZWDXFBUNZUOWDAVCDZWEXFAUNZUPWDWTAFUQWEWHAURUFUSUTVAVDWFWHXAWNWFW
    HXAEZEZWLWMXPFWGBULHZAIXPXIWHWEXAFXQIJWFXIXOXJRWFWHXAUHWDWEXOVBWFWHXAUJWGBU
    KUMXPABWDXMWEXOXNUPWEXKWDXOXLUOWEXABFUQWDWHBURVEVFUTWEXAWMWDWHWEXAWMXDWEXAW
    MSOFBUDQUEVEVAVDVGVHVIVJTWFWKWHWNWFWKFAVNZIJZFBVNZIJZEZWHWDWIXSWEWJYAAVKBVK
    VLWFYBFXRXTGHZIJZWHWDXRCDZXTCDZYBYDSWEAVMBVMYEYFEYBYDYEXSYFYAYDXRXTVOVPTVQW
    FYCWGFIWDXMXKYCWGVRWEXNXLABVSVQVTWAWBWFWNWHWDWLWEWMWHABVOVPTVGWC $.

  $( A condition for multiplication to be non-positive.  (Contributed by Scott
     Fenton, 25-Jun-2013.) $)
  mulle0b $p |- ( ( A e. RR /\ B e. RR ) ->
    ( ( A x. B ) <_ 0 <->
      ( ( A <_ 0 /\ 0 <_ B ) \/ ( 0 <_ A /\ B <_ 0 ) ) ) ) $=
    ( cr wcel wa cmul co cc0 cle wbr cneg wo remulcl le0neg1d wb le0neg2 anbi2d
    le0neg1 cc recn orbi12d adantl renegcl mulge0b sylan2 mulneg2 breq2d syl2an
    3bitr2rd bitrd ) ACDZBCDZEZABFGZHIJHUNKZIJZAHIJZHBIJZEZHAIJZBHIJZEZLZUMUNAB
    MNUMVCUQBKZHIJZEZUTHVDIJZEZLZHAVDFGZIJZUPULVCVIOUKULUSVFVBVHULURVEUQBPQULVA
    VGUTBRQUAUBULUKVDCDVKVIOBUCAVDUDUEUKASDZBSDZVKUPOULATBTVLVMEVJUOHIABUFUGUHU
    IUJ $.

  $( A condition for multiplication of subtraction to be non-positive.
     (Contributed by Scott Fenton, 25-Jun-2013.) $)
  mulsuble0b $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
    ( ( ( A - B ) x. ( C - B ) ) <_ 0 <->
      ( ( A <_ B /\ B <_ C ) \/ ( C <_ B /\ B <_ A ) ) ) ) $=
    ( cr wcel cmin co cc0 cle wbr wa wo wb resubcl 3adant3 ancoms suble0 subge0
    3adant1 anbi12d w3a cmul mulle0b syl2anc ancom syl6bb orbi12d bitrd ) ADEZB
    DEZCDEZUAZABFGZCBFGZUBGHIJZUMHIJZHUNIJZKZHUMIJZUNHIJZKZLZABIJZBCIJZKZCBIJZB
    AIJZKZLULUMDEZUNDEZUOVBMUIUJVIUKABNOUJUKVJUIUKUJVJCBNPSUMUNUCUDULURVEVAVHUL
    UPVCUQVDUIUJUPVCMUKABQOUJUKUQVDMZUIUKUJVKCBRPSTULVAVGVFKVHULUSVGUTVFUIUJUSV
    GMUKABROUJUKUTVFMZUIUKUJVLCBQPSTVGVFUEUFUGUH $.

  $( An interval law for less than or equal.  (Contributed by Scott Fenton,
     27-Jun-2013.) $)
  relin01 $p |- ( A e. RR ->
    ( A <_ 0 \/ ( 0 <_ A /\ A <_ 1 ) \/ 1 <_ A ) ) $=
    ( cr cc0 cle wbr c1 wa wo w3o 1re letric mpan2 pm3.21 orim2d syl5com orim1d
    wcel 0re mpd df-3or sylibr ) ABQZACDEZCADEZAFDEZGZHZFADEZHZUCUFUHIUBUEUHHZU
    IUBFBQUJJAFKLUBUEUGUHUBUCUDHZUEUGUBCBQUKRACKLUEUDUFUCUEUDMNOPSUCUFUHTUA $.

  $( Bring a term in a subtraction into the numerator.  (Contributed by Scott
     Fenton, 3-Jul-2013.) $)
  subdivcomb1 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
     ( ( ( C x. A ) - B ) / C ) = ( A - ( B / C ) ) ) $=
    ( cc wcel cc0 wne wa cmul co cmin cdiv wceq simp3l simp1 divsubdir syld3an1
    w3a mulcld divcan3 3expb 3adant2 oveq1d eqtrd ) ADEZBDEZCDEZCFGZHZRZCAIJZBK
    JCLJZUKCLJZBCLJZKJZAUNKJUKDEUFUEUIULUOMUJCAUEUFUGUHNUEUFUIOSUKBCPQUJUMAUNKU
    EUIUMAMZUFUEUGUHUPACTUAUBUCUD $.

  $( Bring a term in a subtraction into the numerator.  (Contributed by Scott
     Fenton, 3-Jul-2013.) $)
  subdivcomb2 $p |- ( ( A e. CC /\ B e. CC /\ ( C e. CC /\ C =/= 0 ) ) ->
     ( ( A - ( C x. B ) ) / C ) = ( ( A / C ) - B ) ) $=
    ( cc wcel cc0 wne wa w3a cmul co cmin cdiv simp3l simp2 mulcld divsubdir c1
    wceq eqtrd syld3an2 simprl simpl simpr div23 syl3anc divid oveq1d sylan9eqr
    mulid2 3adant1 oveq2d ) ADEZBDEZCDEZCFGZHZIZACBJKZLKCMKZACMKZUSCMKZLKZVABLK
    UMUSDEUNUQUTVCSURCBUMUNUOUPNUMUNUQOPAUSCQUAURVBBVALUNUQVBBSUMUNUQHZVBCCMKZB
    JKZBVDUOUNUQVBVFSUNUOUPUBUNUQUCUNUQUDCBCUEUFUQUNVFRBJKBUQVERBJCUGUHBUJUITUK
    ULT $.

  $( Reverse the order of subtraction in an equality.  (Contributed by Scott
     Fenton, 8-Jul-2013.) $)
  subeqrev $p |- ( ( ( A e. CC /\ B e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
    ( ( A - B ) = ( C - D ) <-> ( B - A ) = ( D - C ) ) ) $=
    ( cc wcel wa cmin co cneg wb subcl neg11 syl2an negsubdi2 eqeqan12d bitr3d
    wceq ) AEFBEFGZCEFDEFGZGABHIZJZCDHIZJZRZUAUCRZBAHIZDCHIZRSUAEFUCEFUEUFKTABL
    CDLUAUCMNSTUBUGUDUHABOCDOPQ $.

  $( Shift membership in a finite sequence of naturals.  (Contributed by Scott
     Fenton, 17-Jul-2013.) $)
  fznatpl1 $p |- ( ( N e. NN /\ I e. ( 1 ... ( N - 1 ) ) ) ->
           ( I + 1 ) e. ( 1 ... N ) ) $=
    ( wcel c1 co cfz wa caddc cle wbr cr 1re zred adantl peano2re syl wb mp3an2
    cz syl2anc cn cmin elfzelz ltp1d elfzle1 leadd1 mp3an13 mpbid ltletrd ltled
    a1i elfzle2 nnz adantr leaddsub mpbird peano2zd 1z elfz mpbir2and ) BUACZAD
    BDUBEZFECZGZADHEZDBFECZDVEIJZVEBIJZVDDVEDKCZVDLUKZVDAKCZVEKCVCVKVAVCAADVBUC
    ZMNZAOPZVDDDDHEZVEVJVDVIVOKCVJDOPVNVDDVJUDVDDAIJZVOVEIJZVCVPVAADVBUENVDVKVP
    VQQZVMVIVKVIVRLLDADUFUGPUHUIUJVDVHAVBIJZVCVSVAADVBULNVDVKBKCZVHVSQZVMVDBVAB
    SCZVCBUMUNZMVKVIVTWALADBUORTUPVDVESCZWBVFVGVHGQZVCWDVAVCAVLUQNWCWDDSCWBWEUR
    VEDBUSRTUT $.

  ${
    $d N x $.  $d M x $.
    $( The supremum of a finite sequence of integers.  (Contributed by Scott
       Fenton, 8-Aug-2013.) $)
    supfz $p |- ( N e. ( ZZ>= ` M ) -> sup ( ( M ... N ) , ZZ , < ) = N ) $=
      ( vx cuz cfv wcel cz cfz co clt wor cr wss zssre ltso mp2 a1i eluzelz wbr
      soss eluzfz2 cv wa cle wn elfzle2 adantl wb elfzelz zred eluzelre syl2anr
      lenlt mpbid supmax ) BADEFZCGABHIZBJGJKZUPGLMLJKURNOGLJTPQABRABUAUPCUBZUQ
      FZUCUSBUDSZBUSJSUEZUTVAUPUSABUFUGUTUSLFBLFVAVBUHUPUTUSUSABUIUJABUKUSBUMUL
      UNUO $.

    $( The infimum of a finite sequence of integers.  (Contributed by Scott
       Fenton, 8-Aug-2013.) $)
    inffz $p |- ( N e. ( ZZ>= ` M ) -> sup ( ( M ... N ) , ZZ , `' < ) = M ) $=
      ( vx cuz cfv wcel cz cfz co clt ccnv wor cr wss zssre wa wbr wn wb zred
      ltso soss mp2 cnvso mpbi a1i eluzel2 eluzfz1 cv cle elfzle1 elfzelz lenlt
      adantl syl2an mpbid brcnvg notbid sylan mpbird supmax ) BADEFZCGABHIZAJKZ
      GVDLZVBGJLZVEGMNMJLVFOUAGMJUBUCGJUDUEUFABUGZABUHVBCUIZVCFZPZAVHVDQZRZVHAJ
      QZRZVJAVHUJQZVNVIVOVBVHABUKUNVBAMFVHMFVOVNSVIVBAVGTVIVHVHABULTAVHUMUOUPVB
      AGFZVIVLVNSVGVPVIPVKVMAVHGVCJUQURUSUTVA $.

  $}

  $( The binomial coefficent of ` ( N - 1 ) ` is ` N ` .  (Contributed by Scott
     Fenton, 16-May-2014.) $)
  bcnm1 $p |- ( N e. NN0 -> ( N _C ( N - 1 ) ) = N ) $=
    ( cn0 wcel c1 cbc co cmin cz wceq 1z bccmpl mpan2 bcn1 eqtr3d ) ABCZADEFZAA
    DGFEFZAODHCPQIJDAKLAMN $.

  $( The sequence ` ( 0 ... ( N - 1 ) ) ` is empty iff ` N ` is zero.
     (Contributed by Scott Fenton, 16-May-2014.) $)
  fz0n $p |- ( N e. NN0 -> ( ( 0 ... ( N - 1 ) ) = (/) <-> N = 0 ) ) $=
    ( cn0 wcel c1 cmin co cc0 clt wbr cfz c0 cz wb 0z sylancr cle cr 1re bitr3d
    wceq nn0z peano2zm syl fzn cn wo elnn0 wn nnge1 wa subge0 0re resubcl lenlt
    nnre sylancl mpbid nnne0 neneqd 2falsed cneg oveq1 df-neg syl6eqr 0lt1 mpbi
    lt0neg2 ax-mp syl6eqbr id 2thd jaoi sylbi ) ABCZADEFZGHIZGVOJFKTZAGTZVNGLCV
    OLCZVPVQMNVNALCVSAUAAUBUCGVOUDOVNAUECZVRUFVPVRMZAUGVTWAVRVTVPVRVTDAPIZVPUHZ
    AUIVTAQCZDQCZWBWCMAUORWDWEUJZGVOPIZWBWCADUKWFGQCVOQCWGWCMULADUMGVOUNOSUPUQV
    TAGAURUSUTVRVPVRVRVODVAZGHVRVOGDEFWHAGDEVBDVCVDGDHIZWHGHIZVEWEWIWJMRDVGVHVF
    VIVRVJVKVLVMS $.

  $( The value of four choose three.  (Contributed by Scott Fenton,
     11-Jun-2016.) $)
  4bc3eq4 $p |- ( 4 _C 3 ) = 4 $=
    ( c4 c1 cmin co cbc 4cn ax-1cn 3cn 3p1e4 addcomli subaddrii oveq2i cn0 wcel
    c3 wceq 4nn0 bcnm1 ax-mp eqtr3i ) AABCDZEDZAOEDAUAOAEABOFGHOBAHGIJKLAMNUBAP
    QARST $.


  $( The value of four choose two.  (Contributed by Scott Fenton,
     9-Jan-2017.) $)
  4bc2eq6 $p |- ( 4 _C 2 ) = 6 $=
    ( c4 c2 co cfa cfv cmul cdiv c6 cc0 wcel cz cle wbr 2re ltleii 4re ax-mp c3
    wceq eqtri cbc cmin cfz w3a wa 0z 4nn nnzi 2z 3pm3.2i 0re 2pos pm3.2i elfz4
    2lt4 mp2an bcval2 caddc cn0 3nn0 facp1 df-4 fveq2i oveq2i 3eqtr4i 4cn 2p2e4
    c1 2cn subaddrii fac2 oveq12i 2t2e4 faccl nncni 4pos gt0ne0ii divcan4i fac3
    cn ) ABUACZADEZABUBCZDEZBDEZFCZGCZHBIAUCCJZWAWGSIKJZAKJZBKJZUDIBLMZBALMZUEW
    HWIWJWKUFAUGUHUIUJWLWMIBUKNULOBANPUOOUMBIAUNUPBAUQQWGRDEZAFCZAGCZHWBWOWFAGR
    VHURCZDEZWNWQFCZWBWORUSJZWRWSSUTRVAQAWQDVBVCAWQWNFVBVDVEWFBBFCAWDBWEBFWDWEB
    WCBDABBVFVIVIVGVJVCVKTVKVLVMTVLWPWNHWNAWNWTWNVTJUTRVNQVOVFAPVPVQVRVSTTT $.

  $( Half minus a third.  (Contributed by Scott Fenton, 8-Jul-2015.) $)
  halfthird $p |- ( ( 1 / 2 ) - ( 1 / 3 ) ) = ( 1 / 6 ) $=
    ( c1 c2 cdiv co c3 cmin cmul c6 2cn 3cn 2ne0 subreci ax-1cn 2p1e3 subaddrii
    3ne0 3t2e6 mulcomli oveq12i eqtri ) ABCDAECDFDEBFDZBEGDZCDAHCDBEIJKPLUAAUBH
    CEBAJIMNOEBHJIQRST $.

  $( One fifth minus one sixth.  (Contributed by Scott Fenton, 9-Jan-2017.) $)
  5recm6rec $p |- ( ( 1 / 5 ) - ( 1 / 6 ) ) = ( 1 / ; 3 0 ) $=
    ( c1 c5 cdiv co c6 cmin cmul c3 cc0 cdc 5nn nncni 6nn 5re 5pos gt0ne0ii 6re
    6pos subreci ax-1cn 5p1e6 subaddrii 6t5e30 mulcomli oveq12i eqtri ) ABCDAEC
    DFDEBFDZBEGDZCDAHIJZCDBEBKLZEMLZBNOPEQRPSUGAUHUICEBAUKUJTUAUBEBUIUKUJUCUDUE
    UF $.

  ${
    pnpncand.1 $e |- ( ph -> A e. CC ) $.
    pnpncand.2 $e |- ( ph -> B e. CC ) $.
    pnpncand.3 $e |- ( ph -> C e. CC ) $.
    $( Addition/subtraction cancellation law.  (Contributed by Scott Fenton,
       14-Dec-2017.) $)
    pnpncand $p |- ( ph -> ( ( A + ( B - C ) ) + ( C - B ) ) = A ) $=
      ( cmin co caddc subcld addcld subsub2d pncand eqtr3d ) ABCDHIZJIZPHIQDCHI
      JIBAQCDABPEACDFGKZLFGMABPERNO $.
  $}

  ${
    $d F f $.  $d A f $.  $d B f $.
    $( Value of a sequence shifted by ` A ` .  (Contributed by Scott Fenton,
       16-Dec-2017.) $)
    shftvalg $p |- ( ( F e. V /\ A e. CC /\ B e. CC ) ->
      ( ( F shift A ) ` B ) = ( F ` ( B - A ) ) ) $=
      ( vf wcel cc cshi co cmin wceq wa cv wi oveq1 fveq1d fveq1 eqeq12d imbi2d
      cfv vex shftval vtoclg 3impib ) CDFAGFZBGFZBCAHIZTZBAJIZCTZKZUEUFLZBEMZAH
      IZTZUIUMTZKZNULUKNECDUMCKZUQUKULURUOUHUPUJURBUNUGUMCAHOPUIUMCQRSABUMEUAUB
      UCUD $.
  $}

  ${
    possumd.1 $e |- ( ph -> A e. RR ) $.
    possumd.2 $e |- ( ph -> B e. RR ) $.
    $( Condition for a positive sum.  (Contributed by Scott Fenton,
       16-Dec-2017.) $)
    possumd $p |- ( ph -> ( 0 < ( A + B ) <-> -u B < A ) ) $=
      ( cneg clt wbr cmin co caddc renegcld posdifd recnd subnegd breq2d bitr2d
      cc0 ) ACFZBGHRBSIJZGHRBCKJZGHASBACELDMATUARGABCABDNACENOPQ $.
  $}

  $( One plus the upper bound of a finite set of integers is not a member of
     that set.  (Contributed by Scott Fenton, 16-Dec-2017.) $)
  fzp1nel $p |- -. ( N + 1 ) e. ( M ... N ) $=
    ( c1 caddc co cfz wcel wn cz w3a cle wbr wa wi cr zre clt ltp1 id peano2re
    ltnled mpbid syl intnand 3ad2ant2 elfz2 notbii imnan bitr4i mpbir ) BCDEZAB
    FEGZHZAIGZBIGZUKIGZJZAUKKLZUKBKLZMZHZNZUOUNVAUPUOUSURUOBOGZUSHZBPVCBUKQLVDB
    RVCBUKVCSBTUAUBUCUDUEUMUQUTMZHVBULVEUKABUFUGUQUTUHUIUJ $.

  ${
    $d A k $.  $d A m $.  $d B k $.  $d B m $.  $d F k $.  $d k m $.
    $d k ph $.  $d M k $.  $d Z k $.
    divcnvshft.1 $e |- Z = ( ZZ>= ` M ) $.
    divcnvshft.2 $e |- ( ph -> M e. ZZ ) $.
    divcnvshft.3 $e |- ( ph -> A e. CC ) $.
    divcnvshft.4 $e |- ( ph -> B e. ZZ ) $.
    divcnvshft.5 $e |- ( ph -> F e. V ) $.
    divcnvshft.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = ( A / ( k + B ) ) ) $.
    $( Limit of a ratio function.  (Contributed by Scott Fenton,
       16-Dec-2017.) $)
    divcnvshft $p |- ( ph -> F ~~> 0 ) $=
      ( vm cc0 cli cz cn wcel wbr cv cdiv co cmpt cc divcnv syl c1 cuz cfv cres
      wss wceq nnssz resmpt ax-mp nnuz reseq2i eqtr3i breq1i cvv wb zex climres
      1z mptex mp2an bitri sylib a1i wa caddc uzssz eqsstri sseli adantl adantr
      zaddcld oveq2 eqid ovex fvmpt eqtr4d climshft2 mpbird ) AEPQUAORBOUBZUCUD
      ZUEZPQUAZAOSWHUEZPQUAZWJABUFTWLKBOUGUHWLWIUIUJUKZULZPQUAZWJWKWNPQWISULZWK
      WNSRUMWPWKUNUOORSWHUPUQSWMWIURUSUTVAUIRTWIVBTZWOWJVCVFORWHVDVGZPWIUIVBVEV
      HVIVJAPDEWICFGVBHIJLMWQAWRVKADUBZHTZVLZWSCVMUDZWIUKZBXBUCUDZWSEUKXAXBRTXC
      XDUNXAWSCWTWSRTAHRWSHFUJUKRIFVNVOVPVQACRTWTLVRVSOXBWHXDRWIWGXBBUCVTWIWABX
      BUCWBWCUHNWDWEWF $.
  $}

  ${
    $d A k $.  $d A m $.  $d B k $.  $d B m $.  $d F k $.  $d k m $.
    $d k ph $.  $d M k $.  $d m ph $.  $d Z k $.
    divcnvlin.1 $e |- Z = ( ZZ>= ` M ) $.
    divcnvlin.2 $e |- ( ph -> M e. ZZ ) $.
    divcnvlin.3 $e |- ( ph -> A e. CC ) $.
    divcnvlin.4 $e |- ( ph -> B e. ZZ ) $.
    divcnvlin.5 $e |- ( ph -> F e. V ) $.
    divcnvlin.6 $e |- ( ( ph /\ k e. Z ) ->
        ( F ` k ) = ( ( k + A ) / ( k + B ) ) ) $.
    $( Limit of the ratio of two linear functions.  (Contributed by Scott
       Fenton, 17-Dec-2017.) $)
    divcnvlin $p |- ( ph -> F ~~> 1 ) $=
      ( vm c1 co caddc cn wcel cli wbr cz cv cmin cdiv cmpt cc0 wa cc nncn zcnd
      adantl subcld adantr wne nnne0 divdird dividd oveq1d eqtrd mpteq2dva nnuz
      cvv a1i divcnv syl ax-1cn nnex mptex divcld eqid fmptd ffvelrnda cfv wceq
      1z weq oveq2 oveq2d ovex fvmpt eqtr4d climaddc2 eqbrtrd cres nnssz resmpt
      cuz wss ax-mp reseq2i eqtr3i addid1i breq12i wb climres mp2an bitri sylib
      zex eluzelz eleq2s ppncand zaddcld oveq1 oveq12d 3eqtr4d climshft2 mpbird
      id ) AEPUAUBOUCOUDZBCUEQZRQZXLUFQZUGZPUAUBZAOSXOUGZPUHRQZUAUBZXQAXROSPXMX
      LUFQZRQZUGZXSUAAOSXOYBAXLSTZUIZXOXLXLUFQZYARQYBYEXLXMXLYDXLUJTAXLUKUMZAXM
      UJTZYDABCKACLULUNZUOZYGYDXLUHUPAXLUQUMZURYEYFPYARYEXLYGYKUSUTVAVBAUHPDOSY
      AUGZYCPVDSVCPUCTZAVQVEAYHYLUHUAUBYIXMOVFVGPUJTAVHVEYCVDTAOSYBVIVJVEASUJDU
      DZYLAOSYAUJYLYEXMXLYJYGYKVKYLVLZVMVNYNSTZYNYCVOZPYNYLVOZRQZVPAYPYQPXMYNUF
      QZRQZYSOYNYBUUASYCODVRYAYTPRXLYNXMUFVSZVTYCVLPYTRWAWBYPYRYTPROYNYAYTSYLUU
      BYOXMYNUFWAWBVTWCUMWDWEXTXPPWIVOZWFZPUAUBZXQXRUUDXSPUAXPSWFZXRUUDSUCWJUUF
      XRVPWGOUCSXOWHWKSUUCXPVCWLWMPVHWNWOYMXPVDTZUUEXQWPVQOUCXOXAVJZPXPPVDWQWRW
      SWTAPDEXPCFGVDHIJLMUUGAUUHVEAYNHTZUIZYNCRQZXMRQZUUKUFQZYNBRQZUUKUFQUUKXPV
      OZYNEVOUUJUULUUNUUKUFUUJYNCBUUIYNUJTAUUIYNYNUCTZYNFWIVOHFYNXBIXCZULUMUUJC
      ACUCTUUILUOZULABUJTUUIKUOXDUTUUJUUKUCTUUOUUMVPUUJYNCUUIUUPAUUQUMUURXEOUUK
      XOUUMUCXPXLUUKVPZXNUULXLUUKUFXLUUKXMRXFUUSXKXGXPVLUULUUKUFWAWBVGNXHXIXJ
      $.
  $}

  ${
    muls1d.1 $e |- ( ph -> A e. CC ) $.
    muls1d.2 $e |- ( ph -> B e. CC ) $.
    $( Multiplication by one minus a number.  (Contributed by Scott Fenton,
       23-Dec-2017.) $)
    muls1d $p |- ( ph -> ( A x. ( B - 1 ) ) = ( ( A x. B ) - A ) ) $=
      ( c1 cmin co cmul cc wcel ax-1cn a1i subdid mulid1d oveq2d eqtrd ) ABCFGH
      IHBCIHZBFIHZGHRBGHABCFDEFJKALMNASBRGABDOPQ $.
  $}

  ${
    $d A k $.  $d B k $.  $d F k $.  $d F m $.  $d k m $.  $d k ph $.
    $d M k $.  $d Z k $.  $d Z m $.
    climlec3.1 $e |- Z = ( ZZ>= ` M ) $.
    climlec3.2 $e |- ( ph -> M e. ZZ ) $.
    climlec3.3 $e |- ( ph -> B e. RR ) $.
    climlec3.4 $e |- ( ph -> F ~~> A ) $.
    climlec3.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. RR ) $.
    climlec3.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) <_ B ) $.
    $( Comparison of a constant to the limit of a sequence.  (Contributed by
       Scott Fenton, 5-Jan-2018.) $)
    climlec3 $p |- ( ph -> A <_ B ) $=
      ( vm cle wbr cneg cfv cc0 wcel cv cmpt renegcld co cli cvv cc 0cn a1i cuz
      cmin fvex eqeltri mptex wa recnd wceq simpr weq fveq2 negeqd eqid syl2anc
      cr fvmptg df-neg syl6eq climsubc2 syl6breqr eqeltrd adantr mpbid breqtrrd
      lenegd climlec2 climrecl mpbird ) ABCOPCQZBQZOPAVRVSDNGNUAZERZQZUBZFGHIAC
      JUCAWCSBUKUDVSUEABSDEWCFUFGHIKSUGTAUHUIWCUFTANGWBGFUJRUFHFUJULUMUNUIADUAZ
      GTZUOZWDERZLUPWFWDWCRZWGQZSWGUKUDWFWEWIVDTWHWIUQAWEURWFWGLUCZNWDWBWIGVDWC
      NDUSWAWGVTWDEUTVAWCVBVEVCZWGVFVGVHBVFVIWFWHWIVDWKWJVJWFVRWIWHOWFWGCOPVRWI
      OPMWFWGCLACVDTWEJVKVNVLWKVMVOABCABDEFGHIKLVPJVNVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Product sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d F k x $.  $d ph k x $.  $d M k x $.  $d Z k $.
    prodf.1 $e |- Z = ( ZZ>= ` M ) $.
    prodf.2 $e |- ( ph -> M e. ZZ ) $.
    prodf.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( An infinite product of complex terms is a function from an upper set of
       integers to ` CC ` .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
    prodf $p |- ( ph -> seq M ( x. , F ) : Z --> CC ) $=
      ( vx cmul cc cv wcel wa co mulcl adantl seqf ) ABIJKCDEFGHBLZKMILZKMNSTJO
      KMASTPQR $.
  $}

  ${
    $d A k $.  $d F k $.  $d F n $.  $d F x $.  $d k n $.  $d k ph $.
    $d k x $.  $d M k $.  $d M n $.  $d M x $.  $d N k $.  $d N n $.
    $d n ph $.  $d n x $.  $d N x $.  $d ph x $.  $d Z k $.
    clim2prod.1 $e |- Z = ( ZZ>= ` M ) $.
    clim2prod.2 $e |- ( ph -> N e. Z ) $.
    clim2prod.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    clim2prod.4 $e |- ( ph -> seq ( N + 1 ) ( x. , F ) ~~> A ) $.
    $( The limit of an infinite product with an initial segment added.
       (Contributed by Scott Fenton, 18-Dec-2017.) $)
    clim2prod $p |- ( ph -> seq M ( x. , F ) ~~>
        ( ( seq M ( x. , F ) ` N ) x. A ) ) $=
      ( cmul cfv co cc wcel syl wceq wi fveq2 vx vn cseq c1 caddc cvv cuz uzssz
      eqid cz eqsstri sseldi peano2zd syl6eleq eluzel2 prodf ffvelrnd seqex a1i
      wss peano2uz uzss syl6sseqr sselda syldan ffvelrnda oveq2d eqeq12d imbi2d
      cv weq wa adantr seqp1 seq1 adantl eqtr4d expcom syl6eleqr wral ralrimiva
      oveq1 eleq1d rspcv mpan9 mulassd 3eqtrd exp31 a2d uzind4 impcom climmulc2
      com12 ) ABFLDEUCZMZCLDFUDUENZUCZWNWPUFWPUGMZWRUIZAFAGUJFGEUGMZUJHEUHUKIUL
      UMZKAGOFWNACDEGHAFWTPZEUJPAFGWTIHUNZEFUOQJUPIUQZWNUFPALDEURUSAWROCVJZWQAC
      DWPWRWSXAAXEWRPZXEGPXEDMZOPZAWRGXEAWRWTGAWPWTPZWRWTUTAXBXIXCEFVAQEWPVBQZH
      VCVDJVEUPZVFXFAXEWNMZWOXEWQMZLNZRZAUAVJZWNMZWOXPWQMZLNZRZSAWPWNMZWOWPWQMZ
      LNZRZSAUBVJZWNMZWOYEWQMZLNZRZSAYEUDUENZWNMZWOYJWQMZLNZRZSAXOSUAUBWPXEXPWP
      RZXTYDAYOXQYAXSYCXPWPWNTYOXRYBWOLXPWPWQTVGVHVIUAUBVKZXTYIAYPXQYFXSYHXPYEW
      NTYPXRYGWOLXPYEWQTVGVHVIXPYJRZXTYNAYQXQYKXSYMXPYJWNTYQXRYLWOLXPYJWQTVGVHV
      IUACVKZXTXOAYRXQXLXSXNXPXEWNTYRXRXMWOLXPXEWQTVGVHVIAWPUJPZYDAYSVLZYAWOWPD
      MZLNZYCYTXBYAUUBRAXBYSXCVMLDEFVNQYTYBUUAWOLYSYBUUARALDWPVOVPVGVQVRYEWRPZA
      YIYNAUUCYIYNSAUUCYIYNAUUCVLZYIVLZYKYFYJDMZLNZYHUUFLNZYMUUDYKUUGRZYIUUDYEW
      TPZUUIAWRWTYEXJVDZLDEYEVNQVMYIUUGUUHRUUDYFYHUUFLWBVPUUEUUHWOYGUUFLNZLNZYM
      UUDUUHUUMRYIUUDWOYGUUFAWOOPUUCXDVMAWROYEWQXKVFAUUCYJGPZUUFOPZUUDUUJUUNUUK
      UUJYJWTGEYEVAHVSQAXHCGVTUUNUUOAXHCGJWAXHUUOCYJGXEYJRXGUUFOXEYJDTWCWDWEVEW
      FVMUUDYMUUMRYIUUDYLUULWOLUUCYLUULRALDWPYEVNVPVGVMVQWGWHWMWIWJWKWL $.
  $}

  ${
    $d A j $.  $d F j $.  $d F k $.  $d F x $.  $d F y $.  $d j k $.
    $d j ph $.  $d j x $.  $d j y $.  $d k ph $.  $d k x $.  $d k y $.
    $d M j $.  $d M k $.  $d M x $.  $d M y $.  $d N j $.  $d N k $.  $d N x $.
    $d N y $.  $d ph x $.  $d ph y $.  $d x y $.  $d Z k $.
    clim2div.1 $e |- Z = ( ZZ>= ` M ) $.
    clim2div.2 $e |- ( ph -> N e. Z ) $.
    clim2div.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    clim2div.4 $e |- ( ph -> seq M ( x. , F ) ~~> A ) $.
    clim2div.5 $e |- ( ph -> ( seq M ( x. , F ) ` N ) =/= 0 ) $.
    $( The limit of an infinite product with an initial segment removed.
       (Contributed by Scott Fenton, 20-Dec-2017.) $)
    clim2div $p |- ( ph ->
      seq ( N + 1 ) ( x. , F ) ~~> ( A / ( seq M ( x. , F ) ` N ) ) ) $=
      ( cmul co cfv cdiv wcel syl cc cv vj vx vy c1 caddc cseq cli cvv cuz eqid
      cz eluzelz eleq2s peano2zd eluzel2 prodf ffvelrnd seqex syl6eleq peano2uz
      reccld a1i syl6eleqr uztrn2 sylan ffvelrnda syldan wa mulcl adantl mulass
      wceq w3a adantr cfz elfzuz sylan2 adantlr seqsplit eqcomd cc0 wne divmuld
      simpr mpbird divrec2d eqtr3d climmulc2 wbr climcl breqtrrd ) AMDFUDUENZUF
      ZUDFMDEUFZOZPNZBMNBWOPNUGABWPUAWNWMWLUHWLUIOZWQUJZAFAFGQZFUKQZIWTFEUIOZGE
      FULHUMRUNZKAWOAGSFWNACDEGHAWSEUKQZIXCFXAGEFUOHUMRJUPZIUQZLVAWMUHQAMDWLURV
      BAUATZWQQZXFGQZXFWNOZSQAWLGQZXGXHAWLXAGAFXAQZWLXAQAFGXAIHUSZEFUTRHVCZEXFW
      LGHVDVEAGSXFWNXDVFVGZAXGVHZXIWOPNZXFWMOZWPXIMNXOXPXQVLWOXQMNZXIVLXOXIXRXO
      CUBUCMSDEFXFCTZSQZUBTZSQZVHXSYAMNZSQXOXSYAVIVJXTYBUCTZSQVMYCYDMNXSYAYDMNM
      NVLXOXSYAYDVKVJAXGWDAXKXGXLVNAXSEXFVONQZXSDOSQZXGYEAXSGQZYFYEXSXAGXSEXFVP
      HVCJVQVRVSVTXOXIWOXQXNAWOSQXGXEVNZAWQSXFWMACDWLWQWRXBAXSWQQZYGYFAXJYIYGXM
      EXSWLGHVDVEJVGUPVFAWOWAWBXGLVNZWCWEXOXIWOXNYHYJWFWGWHABWOAWNBUGWIBSQKBWNW
      JRXELWFWK $.
  $}

  ${
    $d F k $.  $d G k $.  $d H k $.  $d k ph $.  $d k x $.  $d k y $.
    $d k z $.  $d M k $.  $d N k $.  $d ph x $.  $d ph y $.  $d ph z $.
    $d x y $.  $d x z $.  $d y z $.
    prodfmul.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    prodfmul.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. CC ) $.
    prodfmul.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. CC ) $.
    prodfmul.4 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
       ( H ` k ) = ( ( F ` k ) x. ( G ` k ) ) ) $.
    $( The product of two infinite products.  (Contributed by Scott Fenton,
       18-Dec-2017.) $)
    prodfmul $p |- ( ph -> ( seq M ( x. , H ) ` N ) =
       ( ( seq M ( x. , F ) ` N ) x. ( seq M ( x. , G ) ` N ) ) ) $=
      ( vx vy vz cmul cc cv wcel co adantl wa mulcl wceq mulcom mulass seqcaopr
      w3a ) ALMNOPBCDEFGLQZPRZMQZPRZUAZUHUJOSZPRAUHUJUBTULUMUJUHOSUCAUHUJUDTUIU
      KNQZPRUGUMUNOSUHUJUNOSOSUCAUHUJUNUETHIJKUF $.
  $}

  ${
    $d Z k $.  $d M k $.  $d N k $.
    prodf1.1 $e |- Z = ( ZZ>= ` M ) $.
    $( The value of the partial products in a one-valued infinite product.
       (Contributed by Scott Fenton, 5-Dec-2017.) $)
    prodf1 $p |- ( N e. Z -> ( seq M ( x. , ( Z X. { 1 } ) ) ` N ) = 1 ) $=
      ( vk wcel cmul c1 csn cxp co wceq 1t1e1 a1i cuz cfv eleq2i biimpi cv cc
      cfz wa ax-1cn elfzuz syl6eleqr adantl fvconst2g sylancr seqid3 ) BCFZEGCH
      IJZABHHHGKHLUJMNUJBAOPZFCULBDQRUJESZABUAKFZUBHTFUMCFZUMUKPHLUCUNUOUJUNUMU
      LCUMABUDDUEUFCHUMTUGUHUI $.

    $( A one-valued infinite product is equal to the constant one function.
       (Contributed by Scott Fenton, 5-Dec-2017.) $)
    prodf1f $p |- ( M e. ZZ ->
      seq M ( x. , ( Z X. { 1 } ) ) = ( Z X. { 1 } ) ) $=
      ( vk cz wcel cmul c1 csn cxp cseq wceq cv cfv wral prodf1 fvconst2 eqtr4d
      1ex wfn rgen wb cuz seqfn fneq2i sylibr wf fconst ffn ax-mp eqfnfv mpbiri
      sylancl ) AEFZGBHIZJZAKZUPLZDMZUQNZUSUPNZLZDBOZVBDBUSBFUTHVAAUSBCPBHUSSQR
      UAUNUQBTZUPBTZURVCUBUNUQAUCNZTVDGUPAUDBVFUQCUEUFBUOUPUGVEBHSUHBUOUPUIUJDB
      UQUPUKUMUL $.

    $( The constant one product converges to one.  (Contributed by Scott
       Fenton, 5-Dec-2017.) $)
    prodfclim1 $p |- ( M e. ZZ -> seq M ( x. , ( Z X. { 1 } ) ) ~~> 1 ) $=
      ( cz wcel cmul c1 csn cxp cseq cli prodf1f cc wbr ax-1cn cuz cfv eqimss2i
      cvv fvex eqeltri climconst2 mpan eqbrtrd ) ADEZFBGHIZAJUFGKABCLGMEUEUFGKN
      OGABBAPQZCRBUGSCAPTUAUBUCUD $.
  $}

  ${
    $d F k $.  $d F m $.  $d F n $.  $d F x $.  $d k n $.  $d k ph $.
    $d k x $.  $d M k $.  $d M m $.  $d m n $.  $d M n $.  $d m ph $.
    $d M x $.  $d N k $.  $d N m $.  $d N n $.  $d n ph $.  $d n x $.
    $d N x $.  $d ph x $.
    prodfn0.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    prodfn0.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. CC ) $.
    prodfn0.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) =/= 0 ) $.
    $( No term of a non-zero infinite product is zero.  (Contributed by Scott
       Fenton, 14-Jan-2018.) $)
    prodfn0 $p |- ( ph -> ( seq M ( x. , F ) ` N ) =/= 0 ) $=
      ( co wcel cmul cfv cc0 wne syl wi wceq fveq2 imbi2d cc vm vn cfz cseq cuz
      vx eluzfz2 cv c1 caddc neeq1d eluzfz1 wa cz elfzelz adantl expcom vtoclga
      weq seq1 impcom eqnetrd w3a elfzouz 3ad2ant2 seqp1 elfzofz elfzuz elfzuz3
      cfzo fzss2 sselda sylan2 anassrs mulcl seqcl 3adant3 fzofzp1 eleq1d simp3
      wss mulne0d 3exp com12 a2d fzind2 mpcom ) EDEUCIZJZAEKCDUDZLZMNZAEDUELZJZ
      WIFDEUGOAUAUHZWJLZMNZPADWJLZMNZPZAUBUHZWJLZMNZPAXAUIUJIZWJLZMNZPAWLPUAUBE
      DEWODQZWQWSAXGWPWRMWODWJRUKSUAUBUSZWQXCAXHWPXBMWOXAWJRUKSWOXDQZWQXFAXIWPX
      EMWOXDWJRUKSWOEQZWQWLAXJWPWKMWOEWJRUKSWNDWHJZWTDEULAXKWSAXKUMZWRDCLZMXLDU
      NJZWRXMQXKXNADDEUOUPKCDUTOXKAXMMNZABUHZCLZMNZPZAXOPBDWHXPDQZXRXOAXTXQXMMX
      PDCRUKSAXPWHJZXRHUQZURVAVBUQOXADEVJIJZAXCXFAYCXCXFPAYCXCXFAYCXCVCZXEXBXDC
      LZKIZMYDXAWMJZXEYFQYCAYGXCXADEVDVEKCDXAVFOYDXBYEAYCXBTJZXCYCAXAWHJZYHXADE
      VGAYIUMZBUFKTCDXAYIYGAXADEVHUPAYIXPDXAUCIZJZXQTJZYIYLUMAYAYMYIYKWHXPYIEXA
      UELJYKWHWAXADEVIXADEVKOVLGVMVNXPTJUFUHZTJUMXPYNKITJYJXPYNVOUPVPVMVQAYCYET
      JZXCYCAYOYCXDWHJZAYOPZDEXAVRZAYMPYQBXDWHXPXDQZYMYOAYSXQYETXPXDCRZVSSAYAYM
      GUQUROVAVQAYCXCVTAYCYEMNZXCYCAYPUUAYRYPAUUAXSAUUAPBXDWHYSXRUUAAYSXQYEMYTU
      KSYBURVAVMVQWBVBWCWDWEWFWG $.

    $d G k $.  $d G m $.  $d G n $.
    prodfrec.4 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
       ( G ` k ) = ( 1 / ( F ` k ) ) ) $.
    $( The reciprocal of an infinite product.  (Contributed by Scott Fenton,
       15-Jan-2018.) $)
    prodfrec $p |- ( ph -> ( seq M ( x. , G ) ` N ) =
      ( 1 / ( seq M ( x. , F ) ` N ) ) ) $=
      ( co wcel cmul cfv c1 cdiv wceq syl wi fveq2 vm vn vx cfz cseq eluzfz2 cv
      cuz caddc oveq2d eqeq12d imbi2d eluzfz1 expcom vtoclga mpcom eluzel2 seq1
      weq cz 3eqtr4d a1i w3a oveq1 3ad2ant3 wa fzofzp1 impcom cc ax-1cn elfzouz
      cfzo adantl wss elfzouz2 fzss2 sselda sylan2 anassrs mulcl eleq1d cc0 wne
      seqcl prodfn0 neeq1d divmuldivd 1t1e1 oveq1i eqtrd 3adant3 seqp1 3ad2ant2
      syl6eq 3exp com12 a2d fzind2 ) FEFUDKZLZAFMDEUEZNZOFMCEUEZNZPKZQZAFEUHNZL
      ZWTGEFUFRAUAUGZXANZOXIXCNZPKZQZSAEXANZOEXCNZPKZQZSZAUBUGZXANZOXSXCNZPKZQZ
      SAXSOUIKZXANZOYDXCNZPKZQZSAXFSUAUBFEFXIEQZXMXQAYIXJXNXLXPXIEXATYIXKXOOPXI
      EXCTUJUKULUAUBUSZXMYCAYJXJXTXLYBXIXSXATYJXKYAOPXIXSXCTUJUKULXIYDQZXMYHAYK
      XJYEXLYGXIYDXATYKXKYFOPXIYDXCTUJUKULXIFQZXMXFAYLXJXBXLXEXIFXATYLXKXDOPXIF
      XCTUJUKULXRXHAEDNZOECNZPKZXNXPEWSLZAYMYOQZAXHYPGEFUMRABUGZDNZOYRCNZPKZQZS
      ZAYQSBEWSYREQZUUBYQAUUDYSYMUUAYOYREDTUUDYTYNOPYRECTUJUKULAYRWSLZUUBJUNZUO
      UPAEUTLZXNYMQAXHUUGGEFUQRZMDEURRAXOYNOPAUUGXOYNQUUHMCEURRUJVAVBXSEFVLKLZA
      YCYHAUUIYCYHSAUUIYCYHAUUIYCVCZXTYDDNZMKZOYAYDCNZMKZPKZYEYGUUJUULYBUUKMKZU
      UOYCAUULUUPQUUIXTYBUUKMVDVEAUUIUUPUUOQYCAUUIVFZUUPYBOUUMPKZMKZUUOUUQUUKUU
      RYBMUUIAUUKUURQZUUIYDWSLZAUUTSZEFXSVGZUUCUVBBYDWSYRYDQZUUBUUTAUVDYSUUKUUA
      UURYRYDDTUVDYTUUMOPYRYDCTZUJUKULUUFUORVHUJUUQUUSOOMKZUUNPKUUOUUQOYAOUUMOV
      ILUUQVJVBZUUQBUCMVICEXSUUIXSXGLZAXSEFVKZVMZAUUIYREXSUDKZLZYTVILZUUIUVLVFZ
      AUUEUVMUUIUVKWSYRUUIFXSUHNLUVKWSVNXSEFVOXSEFVPRVQZHVRVSZYRVILUCUGZVILVFYR
      UVQMKVILUUQYRUVQVTVMWDUVGUUIAUUMVILZUUIUVAAUVRSZUVCAUVMSUVSBYDWSUVDUVMUVR
      AUVDYTUUMVIUVEWAULAUUEUVMHUNUORVHUUQBCEXSUVJUVPAUUIUVLYTWBWCZUVNAUUEUVTUV
      OIVRVSWEUUIAUUMWBWCZUUIUVAAUWASZUVCAUVTSUWBBYDWSUVDUVTUWAAUVDYTUUMWBUVEWF
      ULAUUEUVTIUNUORVHWGUVFOUUNPWHWIWNWJWKWJUUIAYEUULQZYCUUIUVHUWCUVIMDEXSWLRW
      MUUIAYGUUOQYCUUIYFUUNOPUUIUVHYFUUNQUVIMCEXSWLRUJWMVAWOWPWQWRUP $.
  $}

  ${
    $d F k $.  $d F x $.  $d G k $.  $d G n $.  $d G x $.  $d H k $.  $d k n $.
    $d k ph $.  $d k x $.  $d M k $.  $d M n $.  $d M x $.  $d N k $.
    $d N n $.  $d n ph $.  $d ph x $.
    prodfdiv.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    prodfdiv.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. CC ) $.
    prodfdiv.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) e. CC ) $.
    prodfdiv.4 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( G ` k ) =/= 0 ) $.
    prodfdiv.5 $e |- ( ( ph /\ k e. ( M ... N ) ) ->
       ( H ` k ) = ( ( F ` k ) / ( G ` k ) ) ) $.
    $( The quotient of two infinite products.  (Contributed by Scott Fenton,
       15-Jan-2018.) $)
    prodfdiv $p |- ( ph -> ( seq M ( x. , H ) ` N ) =
       ( ( seq M ( x. , F ) ` N ) / ( seq M ( x. , G ) ` N ) ) ) $=
      ( vn cmul cfv co c1 cdiv wcel cc vx cseq cfz cv cmpt wceq weq oveq2d eqid
      fveq2 ovex fvmpt adantl prodfrec wa wi eleq1 anbi2d eleq1d imbi12d chvarv
      cc0 wne neeq1d reccld fmptd ffvelrnda divrecd 3eqtr4d mulcl seqcl prodfn0
      prodfmul ) AGNCFUBOZGNMFGUCPZQMUDZDOZRPZUEZFUBOZNPVNQGNDFUBOZRPZNPGNEFUBO
      VNWARPAVTWBVNNABDVSFGHJKBUDZVOSZWCVSOZQWCDOZRPZUFAMWCVRWGVOVSMBUGVQWFQRVP
      WCDUJUHVSUIZQWFRUKULUMZUNUHABCVSEFGHIAVOTWCVSAMVOVRTVSAVPVOSZUOZVQAWDUOZW
      FTSZUPWKVQTSZUPBMBMUGZWLWKWMWNWOWDWJAWCVPVOUQURZWOWFVQTWCVPDUJZUSUTJVAWLW
      FVBVCZUPWKVQVBVCZUPBMWOWLWKWRWSWPWOWFVQVBWQVDUTKVAVEWHVFVGWLWCCOZWFRPWTWG
      NPWCEOWTWENPWLWTWFIJKVHLWLWEWGWTNWIUHVIVMAVNWAABUANTCFGHIWCTSUAUDZTSUOWCX
      ANPTSAWCXAVJUMZVKABUANTDFGHJXBVKABDFGHJKVLVHVI $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Non-trivial convergence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F k $.  $d F n $.  $d F y $.  $d k n $.  $d k ph $.  $d k y $.
    $d M k $.  $d M n $.  $d M y $.  $d n ph $.  $d n y $.  $d ph y $.
    $d Z k $.  $d Z y $.
    ntrivcvg.1 $e |- Z = ( ZZ>= ` M ) $.
    ntrivcvg.2 $e |- ( ph -> E. n e. Z E. y ( y =/= 0 /\
       seq n ( x. , F ) ~~> y ) ) $.
    ntrivcvg.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( A non-trivially converging infinite product converges.  (Contributed by
       Scott Fenton, 18-Dec-2017.) $)
    ntrivcvg $p |- ( ph -> seq M ( x. , F ) e. dom ~~> ) $=
      ( cv cmul cseq cli wbr wa wcel c1 co cfv cc0 wne wex wrex cdm wceq cuz wo
      cmin uzm1 eleq2s ad2antlr wi seqeq1 breq1d seqex vex breldm syl6bi simplr
      adantld cc adantlr caddc cz eqsstri sseldi zcnd ax-1cn a1i npcand seqeq1d
      uzssz biimpar clim2prod ovex syl an32s expcom eqcomi jaoi mpcom rexlimdva
      ex exlimdv mpd ) ABKZUAUBZLEDKZMZWGNOZPZBUCZDGUDLEFMZNUEQZIAWMWODGAWIGQZP
      ZWLWOBWQWKWOWHWQWKWOWIFUFZWIRUISZFUGTZQZUHZWQWKPZWOWPXBAWKXBWIWTGFWIUJHUK
      ULWRXCWOUMZXAWRWKWOWQWRWKWNWGNOWOWRWJWNWGNLEWIFUNUOWNWGNLEFUPZBUQURUSVAXD
      WSGWTXCWSGQZWOWQXFWKWOWQXFPZWKPZWNWSWNTZWGLSZNOWOXHWGCEFWSGHWQXFWKUTXGCKZ
      GQZXKETVBQZWKWQXLXMXFAXLXMWPJVCVCVCXGLEWSRVDSZMZWGNOWKXGXOWJWGNXGXNWILEXG
      WIRXGWIXGGVEWIGWTVEHFVMVFAWPXFUTVGVHRVBQXGVIVJVKVLUOVNVOWNXJNXEXIWGLVPURV
      QVRVSGWTHVTUKWAWBWDVAWEWCWF $.
  $}

  ${
    $d F n $.  $d F y $.  $d M n $.  $d M y $.  $d n y $.  $d X y $.  $d Z n $.
    ntrivcvgn0.1 $e |- Z = ( ZZ>= ` M ) $.
    ntrivcvgn0.2 $e |- ( ph -> M e. ZZ ) $.
    ntrivcvgn0.3 $e |- ( ph -> seq M ( x. , F ) ~~> X ) $.
    ntrivcvgn0.4 $e |- ( ph -> X =/= 0 ) $.
    $( A product that converges to a non-zero value converges non-trivially.
       (Contributed by Scott Fenton, 18-Dec-2017.) $)
    ntrivcvgn0 $p |- ( ph -> E. n e. Z E. y ( y =/= 0 /\
       seq n ( x. , F ) ~~> y ) ) $=
      ( wcel cv cc0 wne cmul cseq cli wbr wa wex wrex cuz cfv cz uzid syl6eleqr
      syl cvv climrel brrelex2i jca wceq neeq1 breq2 anbi12d spcegv sylc seqeq1
      breq1d anbi2d exbidv rspcev syl2anc ) AEGLBMZNOZPDEQZVERSZTZBUAZVFPDCMZQZ
      VERSZTZBUAZCGUBAEEUCUDZGAEUELEVPLIEUFUHHUGAFUILZFNOZVGFRSZTZVJAVSVQJVGFRU
      JUKUHAVRVSKJULVIVTBFUIVEFUMVFVRVHVSVEFNUNVEFVGRUOUPUQURVOVJCEGVKEUMZVNVIB
      WAVMVHVFWAVLVGVERPDVKEUSUTVAVBVCVD $.
  $}

  ${
    $d F k $.  $d F m $.  $d F n $.  $d k m $.  $d k n $.  $d k ph $.
    $d M k $.  $d M m $.  $d m n $.  $d M n $.  $d m ph $.  $d N k $.
    $d N m $.  $d N n $.  $d n ph $.  $d Z k $.
    ntrivcvgfvn0.1 $e |- Z = ( ZZ>= ` M ) $.
    ntrivcvgfvn0.2 $e |- ( ph -> N e. Z ) $.
    ntrivcvgfvn0.3 $e |- ( ph -> seq M ( x. , F ) ~~> X ) $.
    ntrivcvgfvn0.4 $e |- ( ph -> X =/= 0 ) $.
    ntrivcvgfvn0.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( Any value of a product sequence that converges to a non-zero value is
       itself non-zero.  (Contributed by Scott Fenton, 20-Dec-2017.) $)
    ntrivcvgfvn0 $p |- ( ph -> ( seq M ( x. , F ) ` N ) =/= 0 ) $=
      ( cc0 cmul cfv wceq cli cc wcel wi vm vn wne cseq wa wfun wbr cdm wf ffun
      fclim ax-mp funbrfv mpsyl adantr cvv cuz eqid cz uzssz eqsstri sseldi a1i
      seqex 0cn cv c1 caddc co fveq2 eqeq1d imbi2d weq simpr w3a syl6eleq uztrn
      sylan2 3adant3 seqp1 oveq1 3ad2ant3 peano2uz uztrn2 syl2an wral ralrimiva
      eleq1d rspcv mpan9 syldan ancoms mul02d 3eqtrd 3exp adantrd uzind4 impcom
      syl a2d climconst eqtr3d ex necon3d mpd ) AFMUCENCDUDZOZMUCKAXGMFMAXGMPZF
      MPAXHUEZXFQOZFMAXJFPZXHQUFZAXFFQUGXKQUHZRQUIXLUKXMRQUJULZJXFFQUMUNUOXLXIX
      FMQUGXJMPXNXIMBXFEUPEUQOZXOURAEUSSZXHAGUSEGDUQOZUSHDUTVAIVBUOXFUPSXINCDVD
      VCMRSXIVEVCBVFZXOSXIXRXFOZMPZXIUAVFZXFOZMPZTXIXHTZXIUBVFZXFOZMPZTXIYEVGVH
      VIZXFOZMPZTXIXTTUAUBEXRYAEPZYCXHXIYKYBXGMYAEXFVJVKVLUAUBVMZYCYGXIYLYBYFMY
      AYEXFVJVKVLYAYHPZYCYJXIYMYBYIMYAYHXFVJVKVLUABVMZYCXTXIYNYBXSMYAXRXFVJVKVL
      YDXPAXHVNVCYEXOSZXIYGYJYOAYGYJTXHYOAYGYJYOAYGVOZYIYFYHCOZNVIZMYQNVIZMYPYE
      XQSZYIYRPYOAYTYGAYOEXQSYTAEGXQIHVPEYEDVQVRVSNCDYEVTWSYGYOYRYSPAYFMYQNWAWB
      YOAYSMPYGYOAUEYQAYOYQRSZAYOYHGSZUUAAEGSYHXOSUUBYOIEYEWCDYHEGHWDWEAXRCOZRS
      ZBGWFUUBUUAAUUDBGLWGUUDUUABYHGXRYHPUUCYQRXRYHCVJWHWIWJWKWLWMVSWNWOWPWTWQW
      RXAXFMQUMUNXBXCXDXE $.
  $}

  ${
    $d F k $.  $d k ph $.  $d M k $.  $d N k $.  $d Z k $.
    ntrivcvgtail.1 $e |- Z = ( ZZ>= ` M ) $.
    ntrivcvgtail.2 $e |- ( ph -> N e. Z ) $.
    ntrivcvgtail.3 $e |- ( ph -> seq M ( x. , F ) ~~> X ) $.
    ntrivcvgtail.4 $e |- ( ph -> X =/= 0 ) $.
    ntrivcvgtail.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( A tail of a non-trivially convergent sequence converges non-trivially.
       (Contributed by Scott Fenton, 20-Dec-2017.) $)
    ntrivcvgtail $p |- ( ph -> ( ( ~~> ` seq N ( x. , F ) ) =/= 0 /\
     seq N ( x. , F ) ~~> ( ~~> ` seq N ( x. , F ) ) ) ) $=
      ( cmul cli cfv cc0 wbr wcel cc adantr wceq cseq wne wa c1 cmin co cuz cdm
      wfun wf fclim ffun ax-mp funbrfv mpsyl eqnetrd breqtrrd jca seqeq1 fveq2d
      wb neeq1d breq12d anbi12d adantl mpbird caddc cdiv syl6eleqr ntrivcvgfvn0
      simpr cv adantlr clim2div climcl syl eluzel2 eleq2s prodf feq2i ffvelrnda
      cz sylib divne0d uzssz eqsstri sseldi zcnd ax-1cn npcand seqeq1d mpbi2and
      a1i wo syl6eleq uzm1 mpjaodan ) AEDUAZMCEUBZNOZPUCZWTXANQZUDZEUEUFUGZDUHO
      ZRZAWSUDXDMCDUBZNOZPUCZXHXINQZUDZAXLWSAXJXKAXIFPNUJZAXHFNQZXIFUANUIZSNUKX
      MULXOSNUMUNZJXHFNUOUPZKUQAXHFXINJXQURUSTWSXDXLVBAWSXBXJXCXKWSXAXIPWSWTXHN
      MCEDUTZVAZVCWSWTXHXAXINXRXSVDVEVFVGAXGUDZMCXEUEVHUGZUBZNOZPUCZYBYCNQZXDXT
      YCFXEXHOZVIUGZPXMXTYBYGNQYCYGUAXPXTFBCDXEGHXTXEXFGAXGVLHVJZABVMZGRYICOSRX
      GLVNZAXNXGJTZXTBCDXEFGHYHYKAFPUCXGKTZYJVKZVOZYBYGNUOUPZXTFYFAFSRZXGAXNYPJ
      FXHVPVQTAXFSXEXHAGSXHUKXFSXHUKABCDGHAEGRDWCRZIYQEXFGDEVRHVSVQLVTGXFSXHHWA
      WDWBYLYMWEUQXTYBYGYCNYNYOURXTYDXBYEXCXTYCXAPXTYBWTNXTYAEMCXTEUEAESRXGAEAG
      WCEGXFWCHDWFWGIWHWITUESRXTWJWNWKWLZVAZVCXTYBWTYCXANYRYSVDVEWMAEXFRWSXGWOA
      EGXFIHWPDEWQVQWR $.
  $}

  ${
    $d F w $.  $d H q $.  $d H w $.  $d P q $.  $d P w $.  $d q w $.  $d Y w $.
    $d Z q $.  $d F j $.  $d F k $.  $d G j $.  $d G k $.  $d H j $.  $d H k $.
    $d j k $.  $d j ph $.  $d k ph $.  $d P j $.  $d P k $.  $d Y j $.
    $d F k $.  $d G k $.  $d H k $.  $d k m $.  $d k n $.  $d k ph $.
    $d k y $.  $d k z $.  $d Z k $.  $d N k $.
    ntrivcvgmullem.1 $e |- Z = ( ZZ>= ` M ) $.
    ntrivcvgmullem.2 $e |- ( ph -> N e. Z ) $.
    ntrivcvgmullem.3 $e |- ( ph -> P e. Z ) $.
    ntrivcvgmullem.4 $e |- ( ph -> X =/= 0 ) $.
    ntrivcvgmullem.5 $e |- ( ph -> Y =/= 0 ) $.
    ntrivcvgmullem.6 $e |- ( ph -> seq N ( x. , F ) ~~> X ) $.
    ntrivcvgmullem.7 $e |- ( ph -> seq P ( x. , G ) ~~> Y ) $.
    ntrivcvgmullem.8 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    ntrivcvgmullem.9 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
    ntrivcvgmullem.a $e |- ( ph -> N <_ P ) $.
    ntrivcvgmullem.b $e |- ( ( ph /\ k e. Z ) ->
       ( H ` k ) = ( ( F ` k ) x. ( G ` k ) ) ) $.
    $( Lemma for ~ ntrivcvgmul .  (Contributed by Scott Fenton,
       19-Dec-2017.) $)
    ntrivcvgmullem $p |- ( ph -> E. q e. Z E. w ( w =/= 0 /\
       seq q ( x. , H ) ~~> w ) ) $=
      ( vj wcel cv cc0 wne cmul cseq cli wbr wa wex wrex cfv co cc cuz eqid cle
      cz wb uzssz eqsstri sseldi eluz syl2anc mpbird uztrn2 syldan ntrivcvgtail
      sylan simprd climcl syl simpld mulne0d seqex prodf ffvelrnda simpr simpll
      cvv a1i cfz adantr elfzuz syl2an wceq prodfmul climmul ovex neeq1 anbi12d
      breq2 spcev seqeq1 breq1d anbi2d exbidv rspcev ) ACLUFZBUGZUHUIZUJGCUKZXE
      ULUMZUNZBUOZXFUJGMUGZUKZXEULUMZUNZBUOZMLUPPAUJECUKZULUQZKUJURZUHUIZXGXRUL
      UMZXJAXQKAXPXQULUMZXQUSUFAXQUHUIZYAADEICJIUTUQZYCVAACYCUFZICVBUMZUCAIVCUF
      CVCUFYDYEVDALVCILHUTUQVCNHVEVFZOVGALVCCYFPVGZICVHVIVJSQADUGZYCUFZYHLUFZYH
      EUQZUSUFZAILUFYIYJOHYHILNVKVNUAVLVMZVOZXQXPVPVQAUJFCUKZKULUMKUSUFTKYOVPVQ
      AYBYAYMVRRVSAXQKUEXPYOXGCWECUTUQZYPVAZYGYNXGWEUFAUJGCVTWFTAYPUSUEUGZXPADE
      CYPYQYGAYHYPUFZYJYLAXDYSYJPHYHCLNVKZVNZUAVLWAWBAYPUSYRYOADFCYPYQYGAYSYJYH
      FUQZUSUFZUUAUBVLWAWBAYRYPUFZUNZDEFGCYRAUUDWCUUEYHCYRWGURUFZUNZAYJYLAUUDUU
      FWDZUUEXDYSYJUUFAXDUUDPWHYHCYRWIYTWJZUAVIUUGAYJUUCUUHUUIUBVIUUGAYJYHGUQYK
      UUBUJURWKUUHUUIUDVIWLWMXIXSXTUNBXRXQKUJWNXEXRWKXFXSXHXTXEXRUHWOXEXRXGULWQ
      WPWRVIXOXJMCLXKCWKZXNXIBUUJXMXHXFUUJXLXGXEULUJGXKCWSWTXAXBXCVI $.
  $}


  ${
    $d F m $.  $d F z $.  $d G n $.  $d G y $.  $d H m $.  $d H n $.  $d H y $.
    $d H z $.  $d m n $.  $d m p $.  $d m ph $.  $d m w $.  $d m y $.
    $d m z $.  $d n p $.  $d n ph $.  $d n w $.  $d n y $.  $d n z $.
    $d p y $.  $d p z $.  $d ph y $.  $d ph z $.  $d w y $.  $d w z $.
    $d y z $.  $d Z m $.  $d Z n $.  $d Z y $.  $d Z z $.  $d F w $.  $d G w $.
    $d H p $.  $d H w $.  $d p w $.  $d Z p $.  $d F k $.  $d G k $.  $d H k $.
    $d k m $.  $d k n $.  $d k ph $.  $d k y $.  $d k z $.  $d Z k $.
    ntrivcvgmul.1 $e |- Z = ( ZZ>= ` M ) $.
    ntrivcvgmul.3 $e |- ( ph ->
       E. n e. Z E. y ( y =/= 0 /\ seq n ( x. , F ) ~~> y ) ) $.
    ntrivcvgmul.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    ntrivcvgmul.5 $e |- ( ph ->
       E. m e. Z E. z ( z =/= 0 /\ seq m ( x. , G ) ~~> z ) ) $.
    ntrivcvgmul.6 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
    ntrivcvgmul.7 $e |- ( ( ph /\ k e. Z ) ->
       ( H ` k ) = ( ( F ` k ) x. ( G ` k ) ) ) $.
    $( The product of two non-trivially converging products converges
       non-trivially.  (Contributed by Scott Fenton, 18-Dec-2017.) $)
    ntrivcvgmul $p |- ( ph -> E. p e. Z E. w ( w =/= 0 /\
       seq p ( x. , H ) ~~> w ) ) $=
      ( wa cv cc0 wne cmul cseq cli wbr wex eeanv 2rexbii reeanv bitri sylanbrc
      wrex wcel w3a cuz cfv uzssz eqsstri simp2l sseldi zred simp2r cle simpl2l
      cz simpl2r simp3ll adantr simp3rl simp3lr simp3rr simpl1 sylan simpr wceq
      cc co ntrivcvgmullem mulcomd eqtrd lecasei 3expia exlimdvv rexlimdvva mpd
      ) ABUAZUBUCZUDHGUAZUEWHUFUGZTZCUAZUBUCZUDIFUAZUEWMUFUGZTZTZCUHBUHZFLUNGLU
      NZDUAZUBUCUDJMUAUEXAUFUGTDUHMLUNZAWLBUHZGLUNZWQCUHZFLUNZWTOQWTXCXETZFLUNG
      LUNXDXFTWSXGGFLLWLWQBCUIUJXCXEGFLLUKULUMAWSXBGFLLAWJLUOZWOLUOZTZTWRXBBCAX
      JWRXBAXJWRUPZXBWJWOXKWJXKLVGWJLKUQURVGNKUSUTZAXHXIWRVAVBVCXKWOXKLVGWOXLAX
      HXIWRVDVBVCXKWJWOVEUGZTZDWOEHIJKWJWHWMLMNXHXIAWRXMVFXHXIAWRXMVHXKWIXMWIWK
      WQAXJVIZVJXKWNXMWNWPWLAXJVKZVJXKWKXMWIWKWQAXJVLZVJXKWPXMWNWPWLAXJVMZVJXNA
      EUAZLUOZXSHURZVRUOZAXJWRXMVNZPVOXNAXTXSIURZVRUOZYCRVOXKXMVPXNAXTXSJURZYAY
      DUDVSZVQYCSVOVTXKWOWJVEUGZTZDWJEIHJKWOWMWHLMNXHXIAWRYHVHXHXIAWRYHVFXKWNYH
      XPVJXKWIYHXOVJXKWPYHXRVJXKWKYHXQVJYIAXTYEAXJWRYHVNZRVOYIAXTYBYJPVOXKYHVPY
      IAXTYFYDYAUDVSZVQYJAXTTZYFYGYKSYLYAYDPRWAWBVOVTWCWDWEWFWG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Complex products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the constant symbol for complex products. $)
  $c prod_ $.

  $( Extend class notation to include complex products. $)
  cprod $a class prod_ k e. A B $.

  ${
    $d k f m n x y $.  $d A f m n x y $.  $d B f m n x y $.
    $( Define the product of a series with an index set of integers ` A ` .
       This definition takes most of the aspects of ~ df-sum and adapts them
       for multiplication instead of addition.  However, we insist that in the
       infinite case, there is a non-zero tail of the sequence.  This ensures
       that the convergence criteria match those of infinite sums.
       (Contributed by Scott Fenton, 4-Dec-2017.) $)
    df-prod $a |- prod_ k e. A B =
    ( iota x ( E. m e. ZZ ( A C_ ( ZZ>= ` m ) /\
      E. n e. ( ZZ>= ` m )
         E. y ( y =/= 0 /\
               seq n ( x. , ( k e. ZZ |-> if ( k e. A , B , 1 ) ) ) ~~> y ) /\
      seq m ( x. , ( k e. ZZ |-> if ( k e. A , B , 1 ) ) ) ~~> x ) \/
      E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> A /\
       x =
       ( seq 1 ( x. , ( n e. NN |-> [_ ( f ` n ) / k ]_ B ) ) ` m ) ) ) ) $.

  $}

  ${
    $d k f m n x y $.  $d A f m n x y $.  $d B f m n x y $.
    $( A product is a set.  (Contributed by Scott Fenton, 4-Dec-2017.) $)
    prodex $p |- prod_ k e. A B e. _V $=
      ( vm vy vn vx vf cv cfv cmul cz c1 cmpt cseq cli wbr wa wex wrex cuz wcel
      cprod wss cc0 wne cif w3a cfz co wf1o cn csb wceq cio cvv df-prod eqeltri
      wo iotaex ) ABCUCADIZUAJZUDEIZUEUFKCLCIAUBBMUGNZFIZOVCPQRESFVBTKVDVAOGIZP
      QUHDLTMVAUIUJAHIZUKVFVAKFULCVEVGJBUMNMOJUNRHSDULTUSZGUOUPGEABHCDFUQVHGUTU
      R $.

    $d C f m n x y $.
    ${
      prodeq1f.1 $e |- F/_ k A $.
      prodeq1f.2 $e |- F/_ k B $.
      $( Equality theorem for a product.  (Contributed by Scott Fenton,
         1-Dec-2017.) $)
      prodeq1f $p |- ( A = B -> prod_ k e. A C = prod_ k e. B C ) $=
        ( vm vy vn vx vf cv cmul cz c1 cseq cli wbr wa wrex cuz cfv wss cc0 wne
        wceq wcel cif cmpt wex w3a cfz co wf1o cn csb wo cprod sseq1 nfeq eleq2
        cio ifbid adantr mpteq2da seqeq3d breq1d anbi2d exbidv 3anbi123d f1oeq3
        rexbidv anbi1d orbi12d iotabidv df-prod 3eqtr4g ) ABUFZAGLZUAUBZUCZHLZU
        DUEZMDNDLZAUGZCOUHZUIZILZPZWBQRZSZHUJZIVTTZMWGVSPZJLZQRZUKZGNTZOVSULUMZ
        AKLZUNZWOVSMIUODWHWTUBCUPUIOPUBUFZSZKUJZGUOTZUQZJVBBVTUCZWCMDNWDBUGZCOU
        HZUIZWHPZWBQRZSZHUJZIVTTZMXJVSPZWOQRZUKZGNTZWSBWTUNZXBSZKUJZGUOTZUQZJVB
        ACDURBCDURVRXFYDJVRWRXSXEYCVRWQXRGNVRWAXGWMXOWPXQABVTUSVRWLXNIVTVRWKXMH
        VRWJXLWCVRWIXKWBQVRWGXJMWHVRDNWFXIDABEFUTVRWFXIUFWDNUGVRWEXHCOABWDVAVCV
        DVEZVFVGVHVIVLVRWNXPWOQVRWGXJMVSYEVFVGVJVLVRXDYBGUOVRXCYAKVRXAXTXBABWSW
        TVKVMVIVLVNVOJHACKDGIVPJHBCKDGIVPVQ $.
    $}
  $}

  ${
    $d A k x $.  $d B k x $.  $d C x $.
    $( Equality theorem for a product.  (Contributed by Scott Fenton,
       1-Dec-2017.) $)
    prodeq1 $p |- ( A = B -> prod_ k e. A C = prod_ k e. B C ) $=
      ( nfcv prodeq1f ) ABCDDAEDBEF $.
  $}

  ${
    $d f k m n x y A $.  $d f m n x y B $.
    nfcprod1.1 $e |- F/_ k A $.
    $( Bound-variable hypothesis builder for product.  (Contributed by Scott
       Fenton, 4-Dec-2017.) $)
    nfcprod1 $p |- F/_ k prod_ k e. A B $=
      ( vm vy vn vx vf cv cfv cmul cz c1 cseq cli wrex cn nfcv nfseq cprod wcel
      cuz wss cc0 wne cif cmpt wbr wa wex w3a cfz co wf1o csb wceq df-prod nfss
      wo cio nfv nfbr nfan nfex nfrex nf3an nff1o nfcsb1v nfmpt nffv nfeq2 nfor
      nfmpt1 nfiota nfcxfr ) CABCUAAEJZUCKZUDZFJZUEUFZLCMCJAUBBNUGZUHZGJZOZVTPU
      IZUJZFUKZGVRQZLWCVQOZHJZPUIZULZEMQZNVQUMUNZAIJZUOZWKVQLGRCWDWPKZBUPZUHZNO
      ZKZUQZUJZIUKZERQZUTZHVAHFABICEGURXGCHWNXFCWMCEMCMSVSWIWLCCAVRDCVRSZUSWHCG
      VRXHWGCFWAWFCWACVBCWEVTPCLWCWDCWDSCLSZCMWBVNZTCPSZCVTSVCVDVEVFCWJWKPCLWCV
      QCVQSZXIXJTXKCWKSVCVGVFXECERCRSZXDCIWQXCCCWOAWPCWPSCWOSDVHCWKXBCVQXACLWTN
      CNSXICGRWSXMCWRBVIVJTXLVKVLVDVEVFVMVOVP $.
  $}

  ${
    $d f k m n x y z $.  $d f m n y z A $.  $d f m n y z B $.
    nfcprod.1 $e |- F/_ x A $.
    nfcprod.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for product: if ` x ` is (effectively)
       not free in ` A ` and ` B ` , it is not free in ` prod_ k e. A B ` .
       (Contributed by Scott Fenton, 1-Dec-2017.) $)
    nfcprod $p |- F/_ x prod_ k e. A B $=
      ( vm vz vn vy vf cv cfv cmul cz c1 cseq cli cn nfcv cprod cuz wss cc0 wne
      wcel cif cmpt wbr wa wex wrex w3a cfz co wf1o csb wceq wo cio df-prod nfv
      nfss nfcri nfif nfmpt nfseq nfbr nfan nfex nfrex nf3an nff1o nfcsb nfiota
      nffv nfeq2 nfor nfcxfr ) ABCDUABGLZUBMZUCZHLZUDUEZNDODLBUFZCPUGZUHZILZQZW
      CRUIZUJZHUKZIWAULZNWGVTQZJLZRUIZUMZGOULZPVTUNUOZBKLZUPZWOVTNISDWHWTMZCUQZ
      UHZPQZMZURZUJZKUKZGSULZUSZJUTJHBCKDGIVAXKAJWRXJAWQAGOAOTZWBWMWPAABWAEAWAT
      ZVCWLAIWAXMWKAHWDWJAWDAVBAWIWCRANWGWHAWHTANTZADOWFXLWEACPADBEVDFAPTZVEVFZ
      VGARTZAWCTVHVIVJVKAWNWORANWGVTAVTTZXNXPVGXQAWOTVHVLVKXIAGSASTZXHAKXAXGAAW
      SBWTAWTTAWSTEVMAWOXFAVTXEANXDPXOXNAISXCXSADXBCAXBTFVNVFVGXRVPVQVIVJVKVRVO
      VS $.
  $}

  ${
    $d f k m n x y A $.  $d f m n x y B $.  $d f m n x y C $.
    $( Equality theorem for product, when the class expressions ` B ` and ` C `
       are equal everywhere.  Proved using only Extensionality.  (Contributed
       by Scott Fenton, 4-Dec-2017.) $)
    prodeq2w $p |- ( A. k B = C -> prod_ k e. A B = prod_ k e. A C ) $=
      ( vm vy vn vx vf wceq cv cfv cmul cz c1 cmpt cseq cli wrex cn wal cuz wss
      cc0 wne wcel cif wbr wa wex w3a cfz co wf1o csb cio cprod wral eqid ifeq1
      wo alimi alral syl mpteq12 sylancr seqeq3d breq1d anbi2d rexbidv 3anbi23d
      exbidv cvv wi fvex nfcv nfcsb1v nfeq csbeq1a eqeq12d spcgf ax-mp mpteq2dv
      fveq1d eqeq2d orbi12d iotabidv df-prod 3eqtr4g ) BCJZDUAZAEKZUBLZUCZFKZUD
      UEZMDNDKZAUFZBOUGZPZGKZQZWORUHZUIZFUJZGWMSZMWTWLQZHKZRUHZUKZENSZOWLULUMAI
      KZUNZXHWLMGTDXAXLLZBUOZPZOQZLZJZUIZIUJZETSZVAZHUPWNWPMDNWRCOUGZPZXAQZWORU
      HZUIZFUJZGWMSZMYEWLQZXHRUHZUKZENSZXMXHWLMGTDXNCUOZPZOQZLZJZUIZIUJZETSZVAZ
      HUPABDUQACDUQWKYCUUCHWKXKYNYBUUBWKXJYMENWKXFYJXIYLWNWKXEYIGWMWKXDYHFWKXCY
      GWPWKXBYFWORWKWTYEMXAWKNNJWSYDJZDNURZWTYEJNUSWKUUDDUAUUEWJUUDDWRBCOUTVBUU
      DDNVCVDDNWSNYDVEVFZVGVHVIVLVJWKXGYKXHRWKWTYEMWLUUFVGVHVKVJWKYAUUAETWKXTYT
      IWKXSYSXMWKXRYRXHWKWLXQYQWKXPYPMOWKGTXOYOXNVMUFWKXOYOJZVNXAXLVOWJUUGDXNVM
      DXNVPDXOYODXNBVQDXNCVQVRWQXNJBXOCYODXNBVSDXNCVSVTWAWBWCVGWDWEVIVLVJWFWGHF
      ABIDEGWHHFACIDEGWHWI $.
  $}

  ${
    $d f k m n x y A $.  $d f m n x y B $.  $d f m n x y C $.
    $( Equality theorem for product, with the class expressions ` B ` and ` C `
       guarded by ` _I ` to be always sets.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq2ii $p |- ( A. k e. A ( _I ` B ) = ( _I ` C ) ->
                   prod_ k e. A B = prod_ k e. A C ) $=
      ( vm vy vn vx vf cid cfv wceq cv cmul cz wcel c1 cmpt wa cn wral cuz cseq
      wss cc0 wne cif cli wbr wex wrex w3a cfz co wf1o csb wo cio cprod eluzelz
      wb adantl nfra1 wi rsp adantr ifeq1 syl6 wn iffalse pm2.61d1 fvif 3eqtr4g
      eqtr4d mpteq2da fveq1d adantlr eqid fvmptex seqfeq breq1d anbi2d rexbidva
      exbidv simpr 3anbi23d simplr nnuz syl6eleq f1of ad2antlr ffvelrn sylancom
      simplll nfcsb1v nfeq csbeq1a eqeq12d rspc sylc fvex csbfv2g ax-mp 3eqtr3g
      wf cvv elfznn weq fveq2 csbeq1d fvmpti syl 3eqtr4d seqfveq eqeq2d orbi12d
      pm5.32da iotabidv df-prod ) BJKZCJKZLZDAUAZAEMZUBKZUDZFMZUEUFZNDODMZAPZBQ
      UGZRZGMZUCZYGUHUIZSZFUJZGYEUKZNYLYDUCZHMZUHUIZULZEOUKZQYDUMUNZAIMZUOZYTYD
      NGTDYMUUEKZBUPZRZQUCKZLZSZIUJZETUKZUQZHURYFYHNDOYJCQUGZRZYMUCZYGUHUIZSZFU
      JZGYEUKZNUUQYDUCZYTUHUIZULZEOUKZUUFYTYDNGTDUUGCUPZRZQUCKZLZSZIUJZETUKZUQZ
      HURABDUSACDUSYCUUOUVNHYCUUCUVFUUNUVMYCUUBUVEEOYCYDOPZSZYRUVBUUAUVDYFYCYRU
      VBVAUVOYCYQUVAGYEYCYMYEPZSZYPUUTFUVRYOUUSYHUVRYNUURYGUHUVRNHYLUUQYMUVQYMO
      PYCYDYMUTVBUVRYTYMUBKPZSYTDOYKJKZRZKZYTDOUUPJKZRZKZYTYLKZYTUUQKZYCUVSUWBU
      WELUVQYCUVSSYTUWAUWDYCUWAUWDLZUVSYCDOUVTUWCYBDAVCYCYIOPZSZYJXTQJKZUGZYJYA
      UWKUGZUVTUWCUWJYJUWLUWMLZUWJYJYBUWNYCYJYBVDUWIYBDAVEVFYJXTYAUWKVGVHYJVIUW
      LUWKUWMYJXTUWKVJYJYAUWKVJVNVKYJBQJVLYJCQJVLVMVOZVFVPVQDOYKYTYLUWAYLVRUWAV
      RVSZDOUUPYTUUQUWDUUQVRUWDVRVSZVMVTWAWBWDWCVFUVPYSUVCYTUHUVPNHYLUUQYDYCUVO
      WEYCYTYEPZUWFUWGLUVOYCUWRSZUWBUWEUWFUWGUWSYTUWAUWDYCUWHUWRUWOVFVPUWPUWQVM
      VQVTWAWFWCYCUUMUVLETYCYDTPZSZUULUVKIUXAUUFUUKUVJUXAUUFSZUUJUVIYTUXBNHUUIU
      VHQYDUXBYDTQUBKYCUWTUUFWGWHWIUXBYTUUDPZSZDYTUUEKZBUPZJKZDUXECUPZJKZYTUUIK
      ZYTUVHKZUXDDUXEXTUPZDUXEYAUPZUXGUXIUXDUXEAPZYCUXLUXMLZUXBUXCUUDAUUEXEZUXN
      UUFUXPUXAUXCUUDAUUEWJWKUUDAYTUUEWLWMYCUWTUUFUXCWNYBUXODUXEADUXLUXMDUXEXTW
      ODUXEYAWOWPYIUXELXTUXLYAUXMDUXEXTWQDUXEYAWQWRWSWTUXEXFPZUXLUXGLYTUUEXAZDU
      XEBXFJXBXCUXQUXMUXILUXRDUXECXFJXBXCXDUXDYTTPZUXJUXGLUXCUXSUXBYTYDXGVBZGYT
      UUHUXFTUUIGHXHZDUUGUXEBYMYTUUEXIZXJUUIVRXKXLUXDUXSUXKUXILUXTGYTUVGUXHTUVH
      UYADUUGUXECUYBXJUVHVRXKXLXMXNXOXQWDWCXPXRHFABIDEGXSHFACIDEGXSVM $.

  $}

  ${
    $d f k m n x A $.  $d f m n x B $.  $d f m n x C $.
    $( Equality theorem for product.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq2 $p |- ( A. k e. A B = C -> prod_ k e. A B = prod_ k e. A C ) $=
      ( wceq wral cid cfv cprod fveq2 ralimi prodeq2ii syl ) BCEZDAFBGHCGHEZDAF
      ABDIACDIENODABCGJKABCDLM $.
  $}

  ${
    $d f j k m n x y $.  $d f m n x y A $.  $d f m n x y B $.
    $d f m n x y C $.
    cbvprod.1 $e |- ( j = k -> B = C ) $.
    ${
      cbvprod.2 $e |- F/_ k A $.
      cbvprod.3 $e |- F/_ j A $.
      cbvprod.4 $e |- F/_ k B $.
      cbvprod.5 $e |- F/_ j C $.
      $( Change bound variable in a product.  (Contributed by Scott Fenton,
         4-Dec-2017.) $)
      cbvprod $p |- prod_ j e. A B = prod_ k e. A C $=
        ( vm vy vn vx vf cv cmul cz c1 wceq cuz cfv wss cc0 wne wcel cif cli wa
        cmpt cseq wbr wex wrex w3a cfz co wf1o cn csb cio cprod biid nfcri nfcv
        nfif weq eleq1 eqidd ifbieq12d cbvmpt seqeq3 ax-mp breq1i anbi2i rexbii
        wo exbii 3anbi123i cbvcsb mpteq2i fveq1i eqeq2i orbi12i iotabii df-prod
        3eqtr4i ) AKPZUAUBZUCZLPZUDUEZQDRDPZAUFZBSUGZUJZMPZUKZWKUHULZUIZLUMZMWI
        UNZQWPWHUKZNPZUHULZUOZKRUNZSWHUPUQAOPZURZXDWHQMUSDWQXHUBZBUTZUJZSUKZUBZ
        TZUIZOUMZKUSUNZVQZNVAWJWLQEREPZAUFZCSUGZUJZWQUKZWKUHULZUIZLUMZMWIUNZQYC
        WHUKZXDUHULZUOZKRUNZXIXDWHQMUSEXJCUTZUJZSUKZUBZTZUIZOUMZKUSUNZVQZNVAABD
        VBACEVBXSUUANXGYLXRYTXFYKKRWJWJXBYHXEYJWJVCXAYGMWIWTYFLWSYEWLWRYDWKUHWP
        YCTZWRYDTDERWOYBWNEBSEDAGVDIESVEVFYADCSDEAHVDJDSVEVFDEVGZWNYABSCSWMXTAV
        HFUUCSVIVJVKZQWPYCWQVLVMVNVOVRVPXCYIXDUHUUBXCYITUUDQWPYCWHVLVMVNVSVPXQY
        SKUSXPYROXOYQXIXNYPXDWHXMYOXLYNTXMYOTMUSXKYMDEXJBCIJFVTWAQXLYNSVLVMWBWC
        VOVRVPWDWENLABODKMWFNLACOEKMWFWG $.
    $}

    $d A j k $.  $d B k $.  $d C j $.
    $( Change bound variable in a product.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    cbvprodv $p |- prod_ j e. A B = prod_ k e. A C $=
      ( nfcv cbvprod ) ABCDEFEAGDAGEBGDCGH $.
  $}

  ${
    $d j k x A $.  $d x B $.  $d x C $.
    cbvprodi.1 $e |- F/_ k B $.
    cbvprodi.2 $e |- F/_ j C $.
    cbvprodi.3 $e |- ( j = k -> B = C ) $.
    $( Change bound variable in a product.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    cbvprodi $p |- prod_ j e. A B = prod_ k e. A C $=
      ( nfcv cbvprod ) ABCDEHEAIDAIFGJ $.
  $}

  ${
    $d k A $.  $d k B $.
    prodeq1i.1 $e |- A = B $.
    $( Equality inference for product.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq1i $p |- prod_ k e. A C = prod_ k e. B C $=
      ( wceq cprod prodeq1 ax-mp ) ABFACDGBCDGFEABCDHI $.
  $}

  ${
    $d k A $.
    prodeq2i.1 $e |- ( k e. A -> B = C ) $.
    $( Equality inference for product.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq2i $p |- prod_ k e. A B = prod_ k e. A C $=
      ( wceq cprod prodeq2 mprg ) BCFABDGACDGFDAABCDHEI $.
  $}

  ${
    $d k A $.  $d k B $.
    prodeq12i.1 $e |- A = B $.
    prodeq12i.2 $e |- ( k e. A -> C = D ) $.
    $( Equality inference for product.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq12i $p |- prod_ k e. A C = prod_ k e. B D $=
      ( cprod prodeq2i prodeq1i eqtri ) ACEHADEHBDEHACDEGIABDEFJK $.
  $}

  ${
    $d k A $.  $d k B $.
    prodeq1d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for sum.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq1d $p |- ( ph -> prod_ k e. A C = prod_ k e. B C ) $=
      ( wceq cprod prodeq1 syl ) ABCGBDEHCDEHGFBCDEIJ $.
  $}

  ${
    $d k A $.
    prodeq2d.1 $e |- ( ph -> A. k e. A B = C ) $.
    $( Equality deduction for sum.  Note that unlike ~ prodeq2dv , ` k ` may
       occur in ` ph ` .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
    prodeq2d $p |- ( ph -> prod_ k e. A B = prod_ k e. A C ) $=
      ( wceq wral cprod prodeq2 syl ) ACDGEBHBCEIBDEIGFBCDEJK $.
  $}

  ${
    $d k A $.  $d k ph $.
    prodeq2dv.1 $e |- ( ( ph /\ k e. A ) -> B = C ) $.
    $( Equality deduction for sum.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq2dv $p |- ( ph -> prod_ k e. A B = prod_ k e. A C ) $=
      ( wceq ralrimiva prodeq2d ) ABCDEACDGEBFHI $.
  $}

  ${
    $d k A $.  $d k ph $.
    prodeq2sdv.1 $e |- ( ph -> B = C ) $.
    $( Equality deduction for sum.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq2sdv $p |- ( ph -> prod_ k e. A B = prod_ k e. A C ) $=
      ( wceq cv wcel adantr prodeq2dv ) ABCDEACDGEHBIFJK $.
  $}

  ${
    $d j k A $.  $d k B $.  $d j k ph $.
    2cprodeq2dv.1 $e |- ( ( ph /\ j e. A /\ k e. B ) -> C = D ) $.
    $( Equality deduction for double sum.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    2cprodeq2dv $p |- ( ph ->
           prod_ j e. A prod_ k e. B C = prod_ j e. A prod_ k e. B D ) $=
      ( cprod cv wcel wa wceq 3expa prodeq2dv ) ABCDGICEGIFAFJBKZLCDEGAPGJCKDEM
      HNOO $.
  $}

  ${
    $d k A $.  $d k B $.  $d k ph $.
    prodeq12dv.1 $e |- ( ph -> A = B ) $.
    prodeq12dv.2 $e |- ( ( ph /\ k e. A ) -> C = D ) $.
    $( Equality deduction for sum.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq12dv $p |- ( ph -> prod_ k e. A C = prod_ k e. B D ) $=
      ( cprod prodeq2dv prodeq1d eqtrd ) ABDFIBEFICEFIABDEFHJABCEFGKL $.
  $}

  ${
    $d k A $.  $d k B $.  $d k ph $.
    prodeq12rdv.1 $e |- ( ph -> A = B ) $.
    prodeq12rdv.2 $e |- ( ( ph /\ k e. B ) -> C = D ) $.
    $( Equality deduction for sum.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodeq12rdv $p |- ( ph -> prod_ k e. A C = prod_ k e. B D ) $=
      ( cprod prodeq1d prodeq2dv eqtrd ) ABDFICDFICEFIABCDFGJACDEFHKL $.
  $}

  ${
    $d k A $.
    $( The second class argument to a sum can be chosen so that it is always a
       set.  (Contributed by Scott Fenton, 4-Dec-2017.) $)
    prod2id $p |- prod_ k e. A B = prod_ k e. A ( _I ` B ) $=
      ( cid cfv wceq cprod prodeq2ii cv wcel cvv fvex fvi ax-mp eqcomi a1i mprg
      ) BDEZRDEZFZABCGARCGFCAABRCHTCIAJSRRKJSRFBDLRKMNOPQ $.
  $}

  ${
    $d A k n $.  $d F k n $.  $d ph k n $.  $d M n $.  $d N n $.
    prodmo.1 $e |- F = ( k e. ZZ |-> if ( k e. A , B , 1 ) ) $.
    prodmo.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.

    ${
      prodrb.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
      $( Lemma for ~ prodrb .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
      prodrblem $p |- ( ( ph /\ A C_ ( ZZ>= ` N ) ) ->
      ( seq M ( x. , F ) |` ( ZZ>= ` N ) ) = seq N ( x. , F ) ) $=
        ( cuz cfv wa cc c1 wcel co wceq adantl cz vn wss cmul mulid2 ax-1cn a1i
        cv adantr cif iftrue adantlr eqeltrd ex iffalse syl6eqel pm2.61d1 fmptd
        wn uzssz sseldi ffvelrnd cmin cfz cdif elfzelz caddc simplr zcnd npcand
        fveq2d sseqtr4d fznuz ssneldd eldifd weq fveq2 eqeq1d eldifi eldifn syl
        fvmpt2 syl2anc eqtrd vtoclga seqid ) ABGKLZUBZMZUAUCNEFGOUAUGZNPOWIUCQW
        IRWHWIUDSONPZWHUEUFAGFKLZPWGJUHAGELNPWGATNGEADTDUGZBPZCOUIZNEAWLTPZMZWM
        WNNPZWPWMWQWPWMMWNCNWMWNCRWPWMCOUJSAWMCNPWOIUKULUMWMURZWNONWMCOUNZUEUOU
        PHUQAWKTGFUSJUTZVAUHWHWIFGOVBQZVCQPZMZWITBVDZPWIELZORZXCWITBXBWITPWHWIF
        XAVESXCBXAOVFQZKLZWIXCBWFXHAWGXBVGXCXGGKXCGOWHGNPZXBAXIWGAGWTVHUHUHWJXC
        UEUFVIVJVKXBWIXHPURWHWIFXAVLSVMVNWLELZORXFDWIXDDUAVOXJXEOWLWIEVPVQWLXDP
        ZXJWNOXKWOWQXJWNRWLTBVRXKWNONXKWRWNORWLTBVSWSVTZUEUODTWNNEHWAWBXLWCWDVT
        WE $.

      ${
        $d F m $.  $d M k m $.  $d m ph $.  $d N k m $.  $d m n $.
        fprodcvg.4 $e |- ( ph -> A C_ ( M ... N ) ) $.
        $( The sequence of partial products of a finite product converges to
           the whole product.  (Contributed by Scott Fenton, 4-Dec-2017.) $)
        fprodcvg $p |- ( ph ->
        seq M ( x. , F ) ~~> ( seq M ( x. , F ) ` N ) ) $=
          ( cmul cfv wcel cz syl cc wa c1 wceq vn vm cseq cvv cuz eluzelz seqex
          a1i eluzel2 cv cif adantl iftrue adantlr eqeltrd ex wn iffalse ax-1cn
          eqid syl6eqel pm2.61d1 fvmpt2 syl2anc prodf ffvelrnd co mulid1 adantr
          simpr caddc cfz elfzuz cdif sseld fznuz con2d imp eldifd fveq2 eqeq1d
          syl6 weq eldifi eldifn eqtrd vtoclga sylan2 seqid2 eqcomd climconst )
          AGLEFUCZMZUAWLGUDGUEMZWNUTAGFUEMZNZGONJFGUFPWLUDNALEFUGUHAWOQGWLADEFW
          OWOUTZAWPFONZJFGUIPZADUJZWONZRZWTEMZWTBNZCSUKZQXBWTONZXEQNZXCXETZXAXF
          AFWTUFULXBXDXGXBXDXGXBXDRXECQXDXECTXBXDCSUMULAXDCQNXAIUNUOUPXDUQZXESQ
          XDCSURZUSVAVBZDOXEQEHVCZVDXKUOZVEJVFAUAUJZWNNZRZWMXNWLMXPUBLQEGFXNSUB
          UJZQNXQSLVGXQTXPXQVHULAWPXOJVIZAXOVJXPWOQGWLXPDEFWOWQAWRXOWSVIAXAXCQN
          XOXMUNVEXRVFAXQGSVKVGZXNVLVGNZXQEMZSTZXOXTAXQXSUEMNZYBXQXSXNVMAYCRZXQ
          OBVNZNYBYDXQOBYCXQONAXSXQUFULAYCXQBNZUQAYFYCAYFXQFGVLVGZNYCUQABYGXQKV
          OXQFGVPWBVQVRVSXCSTYBDXQYEDUBWCXCYASWTXQEVTWAWTYENZXCXESYHXFXGXHWTOBW
          DYHXESQYHXIXESTWTOBWEXJPZUSVAXLVDYIWFWGPWHUNWIWJWK $.
      $}
    $}

    ${
      $d N k $.  $d M k $.
      prodrb.4 $e |- ( ph -> M e. ZZ ) $.
      prodrb.5 $e |- ( ph -> N e. ZZ ) $.
      prodrb.6 $e |- ( ph -> A C_ ( ZZ>= ` M ) ) $.
      prodrb.7 $e |- ( ph -> A C_ ( ZZ>= ` N ) ) $.
      $( Lemma for ~ prodrb .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
      prodrblem2 $p |- ( ( ph /\ N e. ( ZZ>= ` M ) ) ->
       ( seq M ( x. , F ) ~~> C <-> seq N ( x. , F ) ~~> C ) ) $=
        ( cuz cfv wcel cmul cli wbr wa cseq cres cz cvv wb adantr seqex climres
        sylancl wss wceq cv cc adantlr simpr prodrblem mpdan breq1d bitr3d ) AH
        GOPQZUAZRFGUBZHOPZUCZDSTZVCDSTZRFHUBZDSTVBHUDQZVCUEQVFVGUFAVIVALUGRFGUH
        DVCHUEUIUJVBVEVHDSVBBVDUKZVEVHULAVJVANUGVBBCEFGHIAEUMBQCUNQVAJUOAVAUPUQ
        URUSUT $.


      $( Rebase the starting point of a product.  (Contributed by Scott Fenton,
         4-Dec-2017.) $)
      prodrb $p |- ( ph ->
       ( seq M ( x. , F ) ~~> C <-> seq N ( x. , F ) ~~> C ) ) $=
        ( cuz cfv wcel cmul cseq cli wbr wb prodrblem2 wa bicomd uztric syl2anc
        cz wo mpjaodan ) AHGOPQZRFGSDTUAZRFHSDTUAZUBGHOPQZABCDEFGHIJKLMNUCAUNUD
        UMULABCDEFHGIJLKNMUCUEAGUHQHUHQUKUNUIKLGHUFUGUJ $.
    $}

    prodmo.3 $e |- G = ( j e. NN |-> [_ ( f ` j ) / k ]_ B ) $.

    ${
      $d B j $.  $d f i $.  $d f j $.  $d f k $.  $d f m $.  $d f z $.
      $d G i $.  $d G j $.  $d G m $.  $d G z $.  $d H i $.  $d i j $.
      $d i m $.  $d i ph $.  $d i z $.  $d j k $.  $d j m $.  $d j ph $.
      $d j z $.  $d K i $.  $d K j $.  $d k m $.  $d K m $.  $d K z $.
      $d M i $.  $d M j $.  $d M m $.  $d m ph $.  $d m z $.  $d M z $.
      $d ph z $.
      prodmolem3.4 $e |- H = ( j e. NN |-> [_ ( K ` j ) / k ]_ B ) $.
      prodmolem3.5 $e |- ( ph -> ( M e. NN /\ N e. NN ) ) $.
      prodmolem3.6 $e |- ( ph -> f : ( 1 ... M ) -1-1-onto-> A ) $.
      prodmolem3.7 $e |- ( ph -> K : ( 1 ... N ) -1-1-onto-> A ) $.
      $( Lemma for ~ prodmo .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
      prodmolem3 $p |- ( ph ->
         ( seq 1 ( x. , G ) ` M ) = ( seq 1 ( x. , H ) ` N ) ) $=
        ( wcel vm vz vi cmul c1 cseq cfv cc cv ccnv ccom wa mulcl adantl mulcom
        co wceq w3a mulass cn cuz simpld nnuz syl6eleq wss ssid a1i wf1o f1ocnv
        cfz syl f1oco syl2anc wb chash cen wbr ovex f1oen cfn fzfi hashen mp2an
        sylibr cn0 simprd nnnn0d hashfz1 3eqtr3rd oveq2d f1oeq2 mpbird csb wral
        elfznn f1of ffvelrnda ralrimiva adantr nfcsb1v csbeq1a eleq1d rspc sylc
        nfel1 weq fveq2 csbeq1d fvmptg eqeltrd cid fvco3 sylan fveq2d f1ocnvfv2
        wf eqtrd fvmpti 3syl 3eqtr4rd seqf1o eqtr3d ) AKUDIUEUFZUGKUDHUEUFUGLYC
        UGAUAEUBUHUDUHUCDUIZUJZJUKZHIUEKUAUIZUHTZEUIZUHTZULZYGYIUDUPZUHTAYGYIUM
        UNYKYLYIYGUDUPUQAYGYIUOUNYHYJUBUIZUHTURYLYMUDUPYGYIYMUDUPUDUPUQAYGYIYMU
        SUNAKUTUEVAUGAKUTTZLUTTZQVBZVCVDUHUHVEAUHVFVGAUEKVJUPZYQYFVHZUELVJUPZYQ
        YFVHZABYQYEVHZYSBJVHZYTAYQBYDVHZUUARYQBYDVIVKSYSBYQYEJVLVMZAYQYSUQZYRYT
        VNAKLUEVJAYSVOUGZYQVOUGZLKAYSYQVPVQZUUFUUGUQZAYTUUHUUDYSYQYFUELVJVRVSVK
        YSVTTYQVTTUUIUUHVNUELWAUEKWAYSYQWBWCWDALWETUUFLUQALAYNYOQWFWGLWHVKAKWET
        UUGKUQAKYPWGKWHVKWIZWJZYQYSYQYFWKVKWLZAYGYQTZULZYGHUGZFYGYDUGZCWMZUHUUN
        YGUTTZUUQUHTZUUOUUQUQUUMUURAYGKWOUNUUNUUPBTCUHTZFBWNZUUSAYQBYGYDAUUCYQB
        YDXPRYQBYDWPVKWQAUVAUUMAUUTFBNWRWSUUTUUSFUUPBFUUQUHFUUPCWTXEFUIUUPUQCUU
        QUHFUUPCXAXBXCXDZEYGFYIYDUGZCWMZUUQUTUHHEUAXFFUVCUUPCYIYGYDXGXHOXIVMUVB
        XJAUCUIZYQTZULZFUVEYFUGZYDUGZCWMZXKUGZFUVEJUGZCWMZXKUGZUVHHUGZUVEIUGZUV
        GUVJUVMXKUVGFUVIUVLCUVGUVIUVLYEUGZYDUGZUVLUVGUVHUVQYDAYQBJXPZUVFUVHUVQU
        QAYQBJVHZUVSAUVTUUBSAUUEUVTUUBVNUUKYQYSBJWKVKWLYQBJWPVKZYQBUVEYEJXLXMXN
        UVGUUCUVLBTUVRUVLUQAUUCUVFRWSAYQBUVEJUWAWQYQBUVLYDXOVMXQXHXNUVGUVHYQTUV
        HUTTUVOUVKUQAYQYQUVEYFAYRYQYQYFXPUULYQYQYFWPVKWQUVHKWOEUVHUVDUVJUTHYIUV
        HUQFUVCUVICYIUVHYDXGXHOXRXSUVGUVEUTTZUVPUVNUQUVFUWBAUVEKWOUNEUVEFYIJUGZ
        CWMUVMUTIEUCXFFUWCUVLCYIUVEJXGXHPXRVKXTYAAKLYCUUJXNYB $.
    $}

    ${
      $d A j $.  $d A m $.  $d A x $.  $d B j $.  $d B n $.  $d f j $.
      $d f k $.  $d F m $.  $d F x $.  $d G j $.  $d H x $.  $d j k $.
      $d j ph $.  $d j x $.  $d K j $.  $d K k $.  $d k m $.  $d K m $.
      $d K n $.  $d k x $.  $d K x $.  $d M j $.  $d M k $.  $d M m $.
      $d m ph $.  $d m x $.  $d M x $.  $d N j $.  $d N k $.  $d n x $.
      $d ph x $.
      prodmolem2.4 $e |- H = ( j e. NN |-> [_ ( K ` j ) / k ]_ B ) $.
      prodmolem2.5 $e |- ( ph -> N e. NN ) $.
      prodmolem2.6 $e |- ( ph -> M e. ZZ ) $.
      prodmolem2.7 $e |- ( ph -> A C_ ( ZZ>= ` M ) ) $.
      prodmolem2.8 $e |- ( ph -> f : ( 1 ... N ) -1-1-onto-> A ) $.
      prodmolem2.9 $e |- ( ph -> K Isom < , < ( ( 1 ... ( # ` A ) ) , A ) ) $.
      $( Lemma for ~ prodmo .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
      prodmolem2a $p |- ( ph ->
         seq M ( x. , F ) ~~> ( seq 1 ( x. , G ) ` N ) ) $=
        ( vm vx vn cmul cseq cfv c1 cli cuz cfz co clt wiso wf1o chash wceq cen
        wf wb wbr cv ovex f1oen syl cfn wcel fzfid ensymd syl2anc hashen mpbird
        enfii cn0 nnnn0d hashfz1 eqtr3d oveq2d isoeq4 mpbid isof1o f1of 3syl cn
        nnuz syl6eleq eluzfz2 ffvelrnd sseldd sselda cle f1ocnvfv2 sylan f1ocnv
        wa ccnv ffvelrnda elfzle2 cxr wss adantr cr fzssuz cz uzssz zssre sstri
        ressxr syl6ss leisorel syl122anc eqbrtrrd eluzelz eluz elfzuzb sylanbrc
        a1i ex ssrdv fprodcvg cc adantl ax-1cn cif iftrue syl6eqel weq fveq2 wi
        csb nfv nfcsb1v nfcv nfif eleq1 csbeq1a eqidd ifbieq12d cmpt fvmptg jca
        mulid2 mulcl eleqtrrd eqeltrd wn iffalse pm2.61d1 fmptd elfzelz ffvelrn
        mulid1 syl2an cdif eqeq1d eldifi sseldi eldifn eqtrd vtoclga nfel1 nfim
        fvmpt2 eleq1d imbi2d vtoclf csbeq1 cbvmpt eqtri elfznn eqeltrrd csbeq1d
        fvex 3eqtr4rd seqcoll prodmolem3 eqtr4d breqtrd ) AUEGKUFZLJUGZUVSUGZLU
        EHUHUFUGZUIABCFGKUVTMNABKUJUGZUVTSAUHLUKULZBLJAUWDBUMUMJUNZUWDBJUOZUWDB
        JUSAUHBUPUGZUKULZBUMUMJUNZUWEUAAUWHUWDUQUWIUWEUTAUWGLUHUKAUWDUPUGZUWGLA
        UWJUWGUQZUWDBURVAZAUWDBDVBZUOUWLTUWDBUWMUHLUKVCVDVEZAUWDVFVGZBVFVGZUWKU
        WLUTAUHLVHZAUWOBUWDURVAUWPUWQAUWDBUWNVIBUWDVMVJUWDBVKVJVLALVNVGUWJLUQAL
        QVOLVPVEVQVRZUWHBUWDUMUMJVSVEVTZUWDBUMUMJWAZUWDBJWBWCALUHUJUGZVGLUWDVGZ
        ALWDUXAQWEWFUHLWGVEZWHWIZAEBKUVTUKULZAEVBZBVGZUXFUXEVGZAUXGWOZUXFUWCVGU
        VTUXFUJUGVGZUXHABUWCUXFSWJUXIUXJUXFUVTWKVAZUXIUXFJWPZUGZJUGZUXFUVTWKAUW
        FUXGUXNUXFUQAUWEUWFUWSUWTVEZUWDBUXFJWLWMUXIUXMLWKVAZUXNUVTWKVAZUXIUXMUW
        DVGZUXPABUWDUXFUXLAUWFBUWDUXLUOBUWDUXLUSUXOUWDBJWNBUWDUXLWBWCWQZUXMUHLW
        RVEUXIUWEUWDWSWTZBWSWTZUXRUXBUXPUXQUTAUWEUXGUWSXAUXTUXIUWDXBWSUWDUXAXBU
        HLXCUXAXDXBUHXEXFXGXGXHXGXQAUYAUXGABUWCWSSUWCXBWSUWCXDXBKXEZXFXGXHXGXIX
        AUXSAUXBUXGUXCXAUWDBUXMLJXJXKVTXLUXIUXFXDVGUVTXDVGZUXJUXKUTABXDUXFABUWC
        XDSUYBXIZWJAUYCUXGAUVTUWCVGUYCUXDKUVTXMVEXAUXFUVTXNVJVLUXFKUVTXOXPXRXSX
        TAUWALUEIUHUFUGUWBABUEYAUBUCGJIKLUHUBVBZYAVGZUHUYEUEULUYEUQAUYEUUBYBUYF
        UYEUHUEULUYEUQAUYEUULYBUYFUCVBZYAVGWOUYEUYGUEULYAVGAUYEUYGUUCYBUHYAVGAY
        CXQUAALUWDUWHUXCUWRUUDSAXDYAGUSUYEXDVGUYEGUGZYAVGUYEKUWGJUGZUKULZVGAFXD
        FVBZBVGZCUHYDZYAGAUYMYAVGZUYKXDVGZAUYLUYNAUYLUYNAUYLWOUYMCYAUYLUYMCUQAU
        YLCUHYEYBNUUEXRUYLUUFZUYMUHYAUYLCUHUUGZYCYFUUHZXAMUUIUYEKUYIUUJXDYAUYEG
        UUKUUMUYEUYJBUUNZVGUYHUHUQZAUYKGUGZUHUQUYTFUYEUYSFUBYGVUAUYHUHUYKUYEGYH
        UUOUYKUYSVGZVUAUYMUHVUBUYOUYNVUAUYMUQVUBUYJXDUYKUYJUWCXDKUYIXCUYBXGUYKU
        YJBUUPUUQVUBUYMUHYAVUBUYPUYMUHUQUYKUYJBUURUYQVEZYCYFFXDUYMYAGMUVCVJVUCU
        USUUTYBAUYGUWHVGZWOZUYGJUGZBVGZFVUFCYJZUHYDZVUHVUFGUGZUYGIUGZVUEVUGVUIV
        UHUQAUWHBUYGJAUWIUWHBJUOUWHBJUSUAUWHBUMUMJWAUWHBJWBWCWQZVUGVUHUHYEVEZVU
        EVUFXDVGVUIYAVGZVUJVUIUQVUEBXDVUFABXDWTVUDUYDXAVULWIAVUNVUDAUYNYIAVUNYI
        FVUFAVUNFAFYKFVUIYAVUGFVUHUHVUGFYKFVUFCYLFUHYMZYNUVAUVBUYGJUVMUYKVUFUQZ
        UYNVUNAVUPUYMVUIYAVUPUYLVUGCUHVUHUHUYKVUFBYOFVUFCYPVUPUHYQYRUVDUVEUYRUV
        FXAZUDVUFUDVBZBVGZFVURCYJZUHYDZVUIXDYAGVURVUFUQZVUSVUGVUTUHVUHUHVURVUFB
        YOFVURVUFCUVGVVBUHYQYRGFXDUYMYSUDXDVVAYSMFUDXDUYMVVAUDUYMYMVUSFVUTUHVUS
        FYKFVURCYLVUOYNFUDYGZUYLVUSCUHVUTUHUYKVURBYOFVURCYPVVCUHYQYRUVHUVIYTVJV
        UEUYGWDVGZVUHYAVGVUKVUHUQVUDVVDAUYGUWGUVJYBVUEVUIVUHYAVUMVUQUVKEUYGFUXF
        JUGZCYJVUHWDYAIEUCYGFVVEVUFCUXFUYGJYHUVLPYTVJUVNUVOABCDEFGHIJLLMNOPALWD
        VGZVVFQQUUATUXOUVPUVQUVR $.
    $}

    ${
      $d A f $.  $d A g $.  $d A j $.  $d A m $.  $d A w $.  $d B j $.
      $d F f $.  $d f g $.  $d F g $.  $d f j $.  $d F j $.  $d f k $.
      $d f m $.  $d F m $.  $d f ph $.  $d f w $.  $d F w $.  $d f x $.
      $d f z $.  $d G g $.  $d g j $.  $d G j $.  $d g k $.  $d g m $.
      $d g ph $.  $d g w $.  $d G w $.  $d g x $.  $d j k $.  $d j m $.
      $d j ph $.  $d j w $.  $d j x $.  $d k m $.  $d k w $.  $d k x $.
      $d m ph $.  $d m w $.  $d m x $.  $d m z $.  $d ph w $.  $d w x $.
      $d w z $.

      $( Lemma for ~ prodmo .  (Contributed by Scott Fenton, 4-Dec-2017.) $)
      prodmolem2 $p |- ( ( ph /\
        E. m e. ZZ ( A C_ ( ZZ>= ` m ) /\
                          E. n e. ( ZZ>= ` m ) E. y ( y =/= 0 /\
                       seq n ( x. , F ) ~~> y ) /\
                     seq m ( x. , F ) ~~> x ) ) ->
        ( E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> A /\
                            z = ( seq 1 ( x. , G ) ` m ) ) -> x = z ) ) $=
        ( vw cv wa cz vg cuz cfv wss cc0 wne cmul cseq cli wbr wex wrex w3a cfz
        c1 co wf1o wceq cn weq 3simpb reximi fveq2 sseq2d seqeq1 breq1d anbi12d
        wi cbvrexv reeanv wcel simprlr chash clt wor cfn cr simprll uzssz zssre
        wiso sstri syl6ss ltso soss ee10 cen fzfi f1oen ad2antll ensymd sylancr
        ovex enfii fz1iso syl2anc csb cmpt cc simpll sylan eqid simplrr simplrl
        simplll adantl simprr prodmolem2a expr exlimdv climuni eqeq2 syl5ibrcom
        mpd imp3a expimpd rexlimdvva syl5bir expdimp sylan2b sylan2 ) EJRZUBUCZ
        UDZCRZUEUFUGLKRUHYEUIUJSCUKKYCULZUGLYBUHZBRZUIUJZUMZJTULAYDYISZJTULZUOY
        BUNUPZEGRZUQZDRZYBUGMUOUHUCZURZSZGUKZJUSULZBDUTZVHZYJYKJTYDYFYIVAVBYLAE
        QRZUBUCZUDZUGLUUDUHZYHUIUJZSZQTULZUUCYKUUIJQTJQUTZYDUUFYIUUHUUKYCUUEEYB
        UUDUBVCVDUUKYGUUGYHUIUGLYBUUDVEVFVGVIAUUJUUAUUBUUJUUASUUIYTSZJUSULQTULA
        UUBUUIYTQJTUSVJAUULUUBQJTUSAUUDTVKZYBUSVKZSZSZUUIYTUUBUUPUUISZYSUUBGUUQ
        YOYRUUBUUPUUIYOYRUUBVHUUPUUIYOSZSZUUBYRYHYQURZUUSUUHUUGYQUIUJZUUTUUPUUF
        UUHYOVLUUSUOEVMUCUNUPEVNVNUARZWAZUAUKZUVAUUSEVNVOZEVPVKZUVDUUSEVQUDVQVN
        VOUVEUUSEUUEVQUUPUUFUUHYOVRUUETVQUUDVSVTWBWCWDEVQVNWEWFUUSYMVPVKEYMWGUJ
        UVFUOYBWHUUSYMEYOYMEWGUJUUPUUIYMEYNUOYBUNWMWIWJWKEYMWNWLEVNUAWOWPUUSUVC
        UVAUAUUPUURUVCUVAUUPUURUVCSZSZEFGHILMHUSIHRUVBUCFWQWRZUVBUUDYBNUVHAIREV
        KFWSVKAUUOUVGWTOXAPUVIXBAUUMUUNUVGXCAUUMUUNUVGXDUVGUUFUUPUUFUUHYOUVCXEX
        FUUPUUIYOUVCVLUUPUURUVCXGXHXIXJXNYHYQUUGXKWPYPYQYHXLXMXIXOXJXPXQXRXSXTY
        A $.
    $}

    $d A a $.  $d a f $.  $d A f $.  $d a g $.  $d A g $.  $d a j $.  $d A j $.
    $d a k $.  $d a m $.  $d A m $.  $d a ph $.  $d a w $.  $d A w $.
    $d A x $.  $d A z $.  $d B a $.  $d B f $.  $d B j $.  $d B m $.  $d F f $.
    $d f g $.  $d f j $.  $d F j $.  $d f k $.  $d f m $.  $d F m $.
    $d f ph $.  $d f w $.  $d F w $.  $d f x $.  $d F x $.  $d f z $.
    $d F z $.  $d G a $.  $d G g $.  $d g j $.  $d G j $.  $d g k $.  $d g m $.
    $d g ph $.  $d g w $.  $d G w $.  $d g x $.  $d G x $.  $d g z $.
    $d G z $.  $d j k $.  $d j m $.  $d j ph $.  $d j x $.  $d j z $.
    $d k m $.  $d k w $.  $d k x $.  $d k z $.  $d m ph $.  $d m w $.
    $d m x $.  $d m z $.  $d n x $.  $d n z $.  $d ph w $.  $d ph x $.
    $d ph z $.  $d w x $.  $d w z $.  $d x y $.  $d x z $.  $d y z $.

    $( A product has at most one limit.  (Contributed by Scott Fenton,
       4-Dec-2017.) $)
    prodmo $p |- ( ph -> E* x ( E. m e. ZZ ( A C_ ( ZZ>= ` m ) /\
      E. n e. ( ZZ>= ` m )
         E. y ( y =/= 0 /\ seq n ( x. , F ) ~~> y ) /\
         seq m ( x. , F ) ~~> x ) \/
      E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> A /\
       x = ( seq 1 ( x. , G ) ` m ) ) ) ) $=
      ( vw wa wrex cz cn vz vg va cuz cfv wss cc0 wne cmul cseq cli wbr wex w3a
      cv c1 cfz co wf1o wceq wo weq wi 3simpb reximi fveq2 sseq2d seqeq1 breq1d
      wal wmo anbi12d cbvrexv anbi2i reeanv bitr4i wcel simprlr adantlr simprll
      adantl cc simprrl prodrb mpbid simprrr climuni syl2anc ex rexlimivv sylbi
      expcom syl2an prodmolem2 equcomi syl6 expimpd com12 ancoms csb cmpt eeanv
      2rexbii wb oveq2 f1oeq2 syl eqeq2d exbidv f1oeq1 csbeq1d mpteq2dv seqeq3d
      fveq1 syl5eq fveq1d cbvexv syl6bb 3bitr4i an4 simpll sylan cbvmptv simplr
      eqtri simprl simprr prodmolem3 eqeq12 syl5ibrcom rexlimdvva syl5bir ccase
      syl5bi exlimdvv alrimivv breq2 3anbi3d rexbidv eqeq1 anbi2d orbi12d mo4
      sylibr ) ADIUOZUDUEZUFZCUOZUGUHUIKJUOUJUUHUKULQCUMJUUFRZUIKUUEUJZBUOZUKUL
      ZUNZISRZUPUUEUQURZDFUOZUSZUUKUUEUILUPUJZUEZUTZQZFUMZITRZVAZUUGUUIUUJUAUOZ
      UKULZUNZISRZUUQUVEUUSUTZQZFUMZITRZVAZQZBUAVBZVCZUAVJBVJUVDBVKAUVPBUAUVNAU
      VOUUNUVHUVCUVLAUVOVCZUUNUUGUULQZISRZUUGUVFQZISRZUVQUVHUUMUVRISUUGUUIUULVD
      VEUVGUVTISUUGUUIUVFVDVEUVSUWAQZUVRDPUOZUDUEZUFZUIKUWCUJZUVEUKULZQZQZPSRIS
      RZUVQUWBUVSUWHPSRZQUWJUWAUWKUVSUVTUWHIPSIPVBZUUGUWEUVFUWGUWLUUFUWDDUUEUWC
      UDVFVGUWLUUJUWFUVEUKUIKUUEUWCVHVIVLVMVNUVRUWHIPSSVOVPUWIUVQIPSSUUESVQZUWC
      SVQZQZUWIUVQAUWOUWIQZUVOAUWPQZUWFUUKUKULZUWGUVOUWQUULUWRUWPUULAUWOUUGUULU
      WHVRWAUWQDEUUKHKUUEUWCMAHUODVQZEWBVQZUWPNVSAUWMUWNUWIVTAUWMUWNUWIVRUWPUUG
      AUWOUUGUULUWHVTWAUWPUWEAUWOUVRUWEUWGWCWAWDWEUWPUWGAUWOUVRUWEUWGWFWAUUKUVE
      UWFWGWHWLWIWJWKWMUVHUVCUVQAUVHUVCQUVOAUVHUVCUVOAUVHQUVCUABVBUVOAUACBDEFGH
      IJKLMNOWNUABWOWPWQWRWSAUUNUVLQUVOAUUNUVLUVOABCUADEFGHIJKLMNOWNWQWRAUVCUVL
      QZUVOUXAUVAUPUWCUQURZDUBUOZUSZUVEUWCUIGTHGUOZUXCUEZEWTZXAZUPUJZUEZUTZQZQZ
      UBUMFUMZPTRITRZAUVOUVBUXLUBUMZQZPTRITRUVCUXPPTRZQUXOUXAUVBUXPIPTTVOUXNUXQ
      IPTTUVAUXLFUBXBXCUVLUXRUVCUVKUXPIPTUWLUVKUXBDUUPUSZUVEUWCUURUEZUTZQZFUMUX
      PUWLUVJUYBFUWLUUQUXSUVIUYAUWLUUOUXBUTUUQUXSXDUUEUWCUPUQXEUUOUXBDUUPXFXGUW
      LUUSUXTUVEUUEUWCUURVFXHVLXIUYBUXLFUBFUBVBZUXSUXDUYAUXKUXBDUUPUXCXJUYCUXTU
      XJUVEUYCUWCUURUXIUYCLUXHUIUPUYCLGTHUXEUUPUEZEWTZXAZUXHOUYCGTUYEUXGUYCHUYD
      UXFEUXEUUPUXCXNXKXLXOXMXPXHVLXQXRVMVNXSAUXNUVOIPTTAUUETVQUWCTVQQZQZUXMUVO
      FUBUXMUUQUXDQZUUTUXKQZQUYHUVOUUQUUTUXDUXKXTUYHUYIUYJUVOUYHUYIQZUVOUYJUUSU
      XJUTUYKDEFUCHKLUXHUXCUUEUWCMUYKAUWSUWTAUYGUYIYANYBLUYFUCTHUCUOZUUPUEZEWTZ
      XAOGUCTUYEUYNGUCVBZHUYDUYMEUXEUYLUUPVFXKYCYEGUCTUXGHUYLUXCUEZEWTUYOHUXFUY
      PEUXEUYLUXCVFXKYCAUYGUYIYDUYHUUQUXDYFUYHUUQUXDYGYHUUKUUSUVEUXJYIYJWQYNYOY
      KYLWRYMWRYPUVDUVMBUAUVOUUNUVHUVCUVLUVOUUMUVGISUVOUULUVFUUGUUIUUKUVEUUJUKY
      QYRYSUVOUVBUVKITUVOUVAUVJFUVOUUTUVIUUQUUKUVEUUSYTUUAXIYSUUBUUCUUD $.
  $}

  ${

    zprod.1 $e |- Z = ( ZZ>= ` M ) $.
    zprod.2 $e |- ( ph -> M e. ZZ ) $.
    zprod.3 $e |- ( ph ->
       E. n e. Z E. y ( y =/= 0 /\ seq n ( x. , F ) ~~> y ) ) $.

    ${
      $d A f $.  $d A g $.  $d A i $.  $d A j $.  $d A k $.  $d A m $.
      $d A n $.  $d A x $.  $d A y $.  $d A z $.  $d B f $.  $d B g $.
      $d B i $.  $d B j $.  $d B m $.  $d B n $.  $d B x $.  $d B y $.
      $d B z $.  $d f g $.  $d f i $.  $d f j $.  $d f k $.  $d F k $.
      $d f m $.  $d f n $.  $d f ph $.  $d f x $.  $d F x $.  $d f y $.
      $d F z $.  $d g i $.  $d g j $.  $d g k $.  $d g m $.  $d g n $.
      $d g ph $.  $d i j $.  $d i k $.  $d i m $.  $d i n $.  $d i ph $.
      $d j k $.  $d j m $.  $d j n $.  $d j ph $.  $d k m $.  $d k n $.
      $d k ph $.  $d k x $.  $d k y $.  $d k z $.  $d M f $.  $d M g $.
      $d M i $.  $d M j $.  $d M k $.  $d M m $.  $d m n $.  $d m ph $.
      $d m x $.  $d M x $.  $d m y $.  $d M y $.  $d M z $.  $d n ph $.
      $d n x $.  $d n y $.  $d n z $.  $d ph x $.  $d ph y $.  $d ph z $.
      $d x y $.  $d Z m $.  $d Z n $.
      zprod.4 $e |- ( ph -> A C_ Z ) $.
      zprod.5 $e |- ( ( ph /\ k e. Z ) ->
         ( F ` k ) = if ( k e. A , B , 1 ) ) $.
      zprod.6 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
      $( Series product with index set a subset of the upper integers.
         (Contributed by Scott Fenton, 5-Dec-2017.) $)
      zprod $p |- ( ph -> prod_ k e. A B = ( ~~> ` seq M ( x. , F ) ) ) $=
        ( cfv cz wcel c1 wa vm vx vf vi vg vj vz cuz wss cc0 wne cmul cmpt cseq
        cv cif cli wbr wex wrex w3a cfz co wf1o cn csb wceq wo cio cprod 3simpb
        nfcv nfv nfcsb1v nfif weq eleq1 csbeq1a ifbieq12d cbvmpt cc simpll wral
        eqidd ralrimiva nfel1 eleq1d rspc mpan9 simplr ad2antrr syl6sseq prodrb
        syl5 simpr biimpd expimpd rexlimdva chash clt wor cfn uzssz zssre sstri
        wiso cr eqsstri syl6ss ltso soss ee10 cen fzfi ovex f1oen adantl ensymd
        enfii sylancr fz1iso syl2anc fveq2 csbeq1d csbco syl6eqr cbvmptv simprl
        eqid simprr prodmolem2a exlimdv adantr eleq2i ex eqtr4d sylan2br seqfeq
        eqeq12d breq1d expr breq2 syl5ibrcom jaod wb eluzelz uztrn ancoms sseli
        mpd iftrue eqeltrd wn iffalse ax-1cn syl6eqel pm2.61d1 syl2anr nffvmpt1
        fvmpt2 nfeq2 sylan2 anassrs anbi2d exbidv sylan2b rexbidva mpbid sseq2d
        rexeqdv seqeq1 rspcev syl13anc orcd impbid nfeq1 bitrd iotabidv df-prod
        3anbi123d df-fv 3eqtr4g ) ACUAUOZUHPZUIZBUOZUJUKZULEQEUOZCRZDSUPZUMZFUO
        ZUNZUWFUQURZTZBUSZFUWDUTZULUWKUWCUNZUBUOZUQURZVAZUAQUTZSUWCVBVCZCUCUOZV
        DZUWSUWCULFVEEUWLUXDPZDVFZUMZSUNPZVGZTZUCUSZUAVEUTZVHZUBVIULGHUNZUWSUQU
        RZUBVICDEVJUXOUQPAUXNUXPUBAUXNULUWKHUNZUWSUQURZUXPAUXNUXRAUXBUXRUXMAUXA
        UXRUAQUXAUWEUWTTAUWCQRZTZUXRUWEUWQUWTVKUXTUWEUWTUXRUXTUWETZUWTUXRUYACEU
        DUOZDVFZUWSUDUWKUWCHEUDQUWJUYBCRZUYCSUPUDUWJVLUYDEUYCSUYDEVMEUYBDVNZESV
        LVOEUDVPZUWIUYDDSUYCSUWHUYBCVQEUYBDVRZUYFSWDVSVTZUYAAUYDUYCWARZAUXSUWEW
        BADWARZECWCUYDUYIAUYJECOWEUYJUYIEUYBCEUYCWAUYEWFUYFDUYCWAUYGWGWHWNZWIAU
        XSUWEWJAHQRZUXSUWEKWKUXTUWEWOACHUHPZUIZUXSUWEACIUYMMJWLZWKWMWPWQWNWRAUX
        LUXRUAVEAUWCVERZTZUXKUXRUCUYQUXEUXJUXRUYQUXETZUXRUXJUXQUXIUQURZUYRSCWSP
        VBVCCWTWTUEUOZXFZUEUSZUYSUYRCWTXAZCXBRZVUBUYRCXGUIZXGWTXAVUCAVUEUYPUXEA
        CIXGMIUYMXGJUYMQXGHXCZXDXEXHXIWKXJCXGWTXKXLUYRUXCXBRCUXCXMURVUDSUWCXNUY
        RUXCCUXEUXCCXMURUYQUXCCUXDSUWCVBXOXPXQXRCUXCXSXTCWTUEYAYBUYRVUAUYSUEUYQ
        UXEVUAUYSUYQUXEVUATZTZCUYCUCUFUDUWKUXHUFVEUDUFUOZUYTPUYCVFUMZUYTHUWCUYH
        VUHAUYDUYIAUYPVUGWBUYKWIFUFVEUXGUDVUIUXDPZUYCVFZFUFVPZUXGEVUKDVFVULVUME
        UXFVUKDUWLVUIUXDYCYDEUDVUKDYEYFYGVUJYIAUYPVUGWJAUYLUYPVUGKWKAUYNUYPVUGU
        YOWKUYQUXEVUAYHUYQUXEVUAYJYKUUAYLUUJUWSUXIUXQUQUUBUUCWQYLWRUUDAUXRUXNAU
        XRTZUXBUXMVUNUYLCIUIZUWPFIUTZUXRUXBAUYLUXRKYMAVUOUXRMYMAVUPUXRAUWGULGUW
        LUNZUWFUQURZTZBUSZFIUTVUPLAVUTUWPFIUWLIRAUWLUYMRZVUTUWPUUEIUYMUWLJYNAVV
        ATZVUSUWOBVVBVURUWNUWGVVBVUQUWMUWFUQVVBULUGGUWKUWLVVAUWLQRAHUWLUUFXQAVV
        AUGUOZUWLUHPRZVVCGPZVVCUWKPZVGZVVAVVDTAVVCUYMRZVVGVVDVVAVVHUWLVVCHUUGUU
        HAUWHGPZUWHUWKPZVGZEUYMWCVVHVVGAVVKEUYMUWHUYMRZAUWHIRZVVKIUYMUWHJYNZAVV
        MTZVVIUWJVVJNVVMUWHQRUWJWARZVVJUWJVGAIQUWHIUYMQJVUFXHUUIAUWIVVPAUWIVVPA
        UWITUWJDWAUWIUWJDVGAUWIDSUUKXQOUULYOUWIUUMUWJSWAUWIDSUUNUUOUUPUUQEQUWJW
        AUWKUWKYIUUTUURZYPYQWEVVKVVGEVVCUYMEVVEVVFEQUWJVVCUUSZUVAEUGVPZVVIVVEVV
        JVVFUWHVVCGYCZUWHVVCUWKYCZYSWHWIUVBUVCYRYTUVDUVEUVFUVGUVHYMAUXRWOUXAVUO
        VUPUXRVAUAHQUWCHVGZUWEVUOUWQVUPUWTUXRVWBUWDICVWBUWDUYMIUWCHUHYCJYFZUVIV
        WBUWPFUWDIVWCUVJVWBUWRUXQUWSUQULUWKUWCHUVKYTUVTUVLUVMUVNYOUVOAUXQUXOUWS
        UQAULUGUWKGHKAVVJVVIVGZEUYMWCVVHVVFVVEVGZAVWDEUYMVVLAVVMVWDVVNVVOVVJUWJ
        VVIVVQNYPYQWEVWDVWEEVVCUYMEVVFVVEVVRUVPVVSVVJVVFVVIVVEVWAVVTYSWHWIYRYTU
        VQUVRUBBCDUCEUAFUVSUBUXOUQUWAUWB $.
    $}

    ${
      $d B n $.  $d B y $.  $d F k $.  $d k n $.  $d k ph $.  $d k y $.
      $d M k $.  $d M y $.  $d n ph $.  $d n y $.  $d ph y $.  $d Z k $.
      $d Z n $.  $d Z y $.
      iprod.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
      iprod.5 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
      $( Series product with an upper integer index set (i.e. an infinite
         product.)  (Contributed by Scott Fenton, 5-Dec-2017.) $)
      iprod $p |- ( ph -> prod_ k e. Z B = ( ~~> ` seq M ( x. , F ) ) ) $=
        ( wss ssid a1i cv wcel wa c1 cfv cif wceq iftrue adantl eqtr4d zprod )
        ABHCDEFGHIJKHHNAHOPADQZHRZSUHFUACUICTUBZLUIUJCUCAUICTUDUEUFMUG $.
    $}

  $}


  ${

    zprodn0.1 $e |- Z = ( ZZ>= ` M ) $.
    zprodn0.2 $e |- ( ph -> M e. ZZ ) $.
    zprodn0.3 $e |- ( ph -> X =/= 0 ) $.
    zprodn0.4 $e |- ( ph -> seq M ( x. , F ) ~~> X ) $.

    ${
      $d A k $.  $d A m $.  $d A x $.  $d B m $.  $d B x $.  $d F k $.
      $d F m $.  $d F x $.  $d k m $.  $d k ph $.  $d k x $.  $d M k $.
      $d M m $.  $d m ph $.  $d m x $.  $d M x $.  $d ph x $.  $d X x $.
      $d Z m $.  $d Z x $.
      zprodn0.5 $e |- ( ph -> A C_ Z ) $.
      zprodn0.6 $e |- ( ( ph /\ k e. Z ) ->
         ( F ` k ) = if ( k e. A , B , 1 ) ) $.
      zprodn0.7 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
      $( Non-zero series product with index set a subset of the upper
         integers.  (Contributed by Scott Fenton, 6-Dec-2017.) $)
      zprodn0 $p |- ( ph -> prod_ k e. A B = X ) $=
        ( vx vm cprod cli cc cmul cseq cfv ntrivcvgn0 zprod wfun wbr wceq fclim
        cdm wf ffun ax-mp funbrfv mpsyl eqtrd ) ABCDRUAEFUBZSUCZGAPBCDQEFHIJAPQ
        EFGHIJLKUDMNOUESUFZAUQGSUGURGUHSUJZTSUKUSUIUTTSULUMLUQGSUNUOUP $.
    $}

    ${
      $d F k $.  $d k ph $.  $d M k $.  $d Z k $.
      iprodn0.5 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
      iprodn0.6 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
      $( Non-zero series product with an upper integer index set (i.e. an
         infinite product.)  (Contributed by Scott Fenton, 6-Dec-2017.) $)
      iprodn0 $p |- ( ph -> prod_ k e. Z B = X ) $=
        ( wss ssid a1i cv wcel wa c1 cfv cif wceq iftrue adantl eqtr4d zprodn0
        ) AGBCDEFGHIJKGGNAGOPACQZGRZSUHDUABUIBTUBZLUIUJBUCAUIBTUDUEUFMUG $.
    $}

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A f $.  $d A i $.  $d A j $.  $d A k $.  $d A m $.  $d A n $.  $d A x $.
    $d A y $.  $d B f $.  $d B i $.  $d B j $.  $d B m $.  $d B n $.  $d B x $.
    $d B y $.  $d C f $.  $d C k $.  $d F f $.  $d f i $.  $d f j $.  $d f k $.
    $d F k $.  $d f m $.  $d f n $.  $d F n $.  $d f ph $.  $d f x $.
    $d f y $.  $d G f $.  $d G k $.  $d G m $.  $d G n $.  $d G x $.  $d i j $.
    $d i k $.  $d i m $.  $d i n $.  $d i ph $.  $d i x $.  $d j k $.
    $d j m $.  $d j n $.  $d j ph $.  $d j x $.  $d k m $.  $d k n $.
    $d k ph $.  $d k x $.  $d k y $.  $d M f $.  $d M k $.  $d M m $.
    $d m n $.  $d M n $.  $d m ph $.  $d m x $.  $d M x $.  $d m y $.
    $d n ph $.  $d n x $.  $d n y $.  $d ph x $.  $d x y $.
    fprod.1 $e |- ( k = ( F ` n ) -> B = C ) $.
    fprod.2 $e |- ( ph -> M e. NN ) $.
    fprod.3 $e |- ( ph -> F : ( 1 ... M ) -1-1-onto-> A ) $.
    fprod.4 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    fprod.5 $e |- ( ( ph /\ n e. ( 1 ... M ) ) -> ( G ` n ) = C ) $.
    $( The value of a product over a nonempty finite set.  (Contributed by
       Scott Fenton, 6-Dec-2017.) $)
    fprod $p |- ( ph -> prod_ k e. A B = ( seq 1 ( x. , G ) ` M ) ) $=
      ( vm cfv wcel c1 cn wceq vy vx vf vj vi cprod cv cuz wss cc0 wne cmul cif
      cz cmpt cseq cli wbr wa wex wrex w3a cfz co wf1o csb cio df-prod cvv fvex
      wo wb wmo wi nfcv nfv nfcsb1v weq eleq1 csbeq1a eqidd ifbieq12d cbvmpt cc
      nfif wral ralrimiva nfel1 eleq1d rspc mpan9 fveq2 csbeq1d syl6eqr cbvmptv
      prodmo wf f1of syl ovex fex sylancl nnuz syl6eleq elfznn adantl syl6eqelr
      csbco eqid fvmpt2 syl2anc eqtr4d nffvmpt1 nfeq2 eqeq12d seqfveq jca fveq1
      f1oeq1 csbief syl6eq mpteq2dv seqeq3d fveq1d eqeq2d anbi12d spcegv f1oeq2
      sylc oveq2 exbidv rspcev olcd breq2 3anbi3d rexbidv eqeq1 anbi2d orbi12d
      moi2 mpanl1 ancom2s expr syl5ibrcom impbid adantr iota5 mpan2 syl5eq ) AB
      CEUFBOUGZUHPZUIZUAUGZUJUKULEUNEUGZBQZCRUMZUOZFUGZUPUUMUQURUSUAUTFUUKVAZUL
      UUQUUJUPZUBUGZUQURZVBZOUNVAZRUUJVCVDZBUCUGZVEZUVAUUJULFSEUURUVFPZCVFZUOZR
      UPZPZTZUSZUCUTZOSVAZVKZUBVGZIULHRUPZPZUBUABCUCEOFVHAUVTVIQZUVRUVTTIUVSVJZ
      AUVQUBUVTVIAUVQUVAUVTTZVLUWAAUVQUWCAUVQUBVMZUULUUSUUTUVTUQURZVBZOUNVAZUVG
      UVTUVLTZUSZUCUTZOSVAZVKZUVQUWCVNAUBUABEUDUGZCVFZUCUEUDOFUUQUVJEUDUNUUPUWM
      BQZUWNRUMUDUUPVOUWOEUWNRUWOEVPEUWMCVQZERVOWEEUDVRZUUOUWOCRUWNRUUNUWMBVSEU
      WMCVTZUWQRWAWBWCACWDQZEBWFUWOUWNWDQZAUWSEBMWGUWSUWTEUWMBEUWNWDUWPWHUWQCUW
      NWDUWRWIWJWKFUESUVIUDUEUGZUVFPZUWNVFZFUEVRZUVIEUXBCVFUXCUXDEUVHUXBCUURUXA
      UVFWLWMEUDUXBCXHWNWOWPAUWKUWGAISQRIVCVDZBUVFVEZUVTIUVKPZTZUSZUCUTZUWKKAGV
      IQZUXEBGVEZUVTIULFSDUOZRUPZPZTZUSZUXJAUXEBGWQZUXEVIQUXKAUXLUXRLUXEBGWRWSR
      IVCWTUXEBVIGXAXBAUXLUXPLAULEHUXMRIAISRUHPKXCXDAUURHPZUURUXMPZTZFUXEWFUUNU
      XEQUUNHPZUUNUXMPZTZAUYAFUXEAUURUXEQZUSZUXSDUXTNUYFUURSQZDVIQUXTDTUYEUYGAU
      URIXEXFUYFDUXSVINUURHVJXGFSDVIUXMUXMXIXJXKXLWGUYAUYDFUUNUXEFUYBUYCFSDUUNX
      MXNFEVRUXSUYBUXTUYCUURUUNHWLUURUUNUXMWLXOWJWKXPXQUXIUXQUCGVIUVFGTZUXFUXLU
      XHUXPUXEBUVFGXSUYHUXGUXOUVTUYHIUVKUXNUYHUVJUXMULRUYHFSUVIDUYHUVIEUURGPZCV
      FDUYHEUVHUYICUURUVFGXRWMEUYICDUURGVJEDVOJXTYAYBYCYDYEYFYGYIUWJUXJOISUUJIT
      ZUWIUXIUCUYJUVGUXFUWHUXHUYJUVEUXETUVGUXFVLUUJIRVCYJUVEUXEBUVFYHWSUYJUVLUX
      GUVTUUJIUVKWLYEYFYKYLXKYMZUWDUWLUVQUWCUWDUVQUWLUWCUWAUWDUVQUWLUSUWCUWBUVQ
      UWLUBUVTVIUWCUVDUWGUVPUWKUWCUVCUWFOUNUWCUVBUWEUULUUSUVAUVTUUTUQYNYOYPUWCU
      VOUWJOSUWCUVNUWIUCUWCUVMUWHUVGUVAUVTUVLYQYRYKYPYSZYTUUAUUBUUCXKAUVQUWCUWL
      UYKUYLUUDUUEUUFUUGUUHUUI $.
  $}


  ${
    $d A k $.  $d A m $.  $d A n $.  $d A y $.  $d B m $.  $d B n $.  $d B y $.
    $d k m $.  $d k n $.  $d k y $.  $d m n $.  $d m ph $.  $d N m $.
    $d N n $.  $d n ph $.  $d n y $.  $d N y $.  $d Z k $.  $d Z m $.
    $d Z n $.  $d Z y $.
    fprodntriv.1 $e |- Z = ( ZZ>= ` M ) $.
    fprodntriv.2 $e |- ( ph -> N e. Z ) $.
    fprodntriv.3 $e |- ( ph -> A C_ ( M ... N ) ) $.
    $( A non-triviality lemma for finite sequences.  (Contributed by Scott
       Fenton, 16-Dec-2017.) $)
    fprodntriv $p |- ( ph -> E. n e. Z E. y ( y =/= 0 /\ seq n ( x.
      , ( k e. Z |-> if ( k e. A , B , 1 ) ) ) ~~> y ) ) $=
      ( c1 wcel cmul cli wbr wa cfv wceq vm caddc co cc0 wne cif cmpt cseq wrex
      cv wex cuz syl6eleq peano2uz syl syl6eleqr ax-1ne0 eqid cz eluzelz eleq2s
      cvv peano2zd seqex a1i cc ax-1cn csn cxp simpr cfz csb wn wss w3a cle clt
      ad2antrr zred elfzelz adantl ltp1d elfzle1 ltletrd ltnled intnand sylnibr
      mpbid ssneldd iffalse fzssuz adantr uzss syl6sseqr syl5ss sselda syl6eqel
      elfz2 nfcv nfv nfcsb1v nfif weq eleq1 csbeq1a eqidd fvmptf syl2anc elfzuz
      ifbieq12d 1ex fvconst2 3eqtr4d seqfveq prodf1 eqtrd climconst neeq1 breq2
      anbi12d spcev sylancr seqeq1 breq1d anbi2d exbidv rspcev ) AHMUBUCZINBUJZ
      UDUEZOEIEUJZCNZDMUFZUGZYHUHZYIPQZRZBUKZYJOYNFUJZUHZYIPQZRZBUKZFIUIAYHGULS
      ZIAHUUDNYHUUDNZAHIUUDKJUMGHUNUOZJUPAMUDUEZYOMPQZYRUQAMFYOYHVBYHULSZUUIURZ
      AHAHINHUSNZKUUKHUUDIGHUTJVAUOZVCYOVBNAOYNYHVDVEMVFNAVGVEAYSUUINZRZYSYOSYS
      OUUIMVHVIZYHUHSZMUUNOUAYNUUOYHYSAUUMVJUUNUAUJZYHYSVKUCZNZRZUUQCNZEUUQDVLZ
      MUFZMUUQYNSZUUQUUOSZUUTUVAVMUVCMTUUTCGHVKUCZUUQACUVFVNUUMUUSLVRUUTGUSNUUK
      UUQUSNZVOZGUUQVPQZUUQHVPQZRZRUUQUVFNUUTUVKUVHUUTUVJUVIUUTHUUQVQQUVJVMUUTH
      YHUUQUUTHAUUKUUMUUSUULVRZVSZUUTYHUUTHUVLVCVSUUTUUQUUSUVGUUNUUQYHYSVTWAVSZ
      UUTHUVMWBUUSYHUUQVPQUUNUUQYHYSWCWAWDUUTHUUQUVMUVNWEWHWFWFUUQGHWRWGWIUVAUV
      BMWJUOZUUTUUQINUVCVFNUVDUVCTUUNUURIUUQUUNUURUUIIYHYSWKUUNUUIUUDIUUNUUEUUI
      UUDVNAUUEUUMUUFWLGYHWMUOJWNWOWPUUTUVCMVFUVOVGWQEUUQYMUVCIYNVFEUUQWSUVAEUV
      BMUVAEWTEUUQDXAEMWSXBEUAXCZYLUVADMUVBMYKUUQCXDEUUQDXEUVPMXFXJYNURXGXHUUTU
      UQUUINZUVEMTUUSUVQUUNUUQYHYSXIWAUUIMUUQXKXLUOXMXNUUMUUPMTAYHYSUUIUUJXOWAX
      PXQYQUUGUUHRBMXKYIMTYJUUGYPUUHYIMUDXRYIMYOPXSXTYAYBUUCYRFYHIYSYHTZUUBYQBU
      VRUUAYPYJUVRYTYOYIPOYNYSYHYCYDYEYFYGXH $.
  $}

  ${
    $d A n x $.  $d k n x $.
    $( A product over the empty set is one.  (Contributed by Scott Fenton,
       5-Dec-2017.) $)
    prod0 $p |- prod_ k e. (/) A = 1 $=
      ( c1 cz wcel c0 cprod wceq 1z csn cxp nnuz cc0 wne ax-1ne0 a1i prodfclim1
      cn id ax-mp wss 0ss cv wa cfv cif fvconst2g wn iffalse syl6eqr cc pm2.21i
      noel adantl zprodn0 ) CDEZFABGCHIUPFABRCJKZCCRLUPSCMNUPOPCRLQFRUAUPRUBPUP
      BUCZREUDURUQUECURFEZACUFZRCURDUGUSUHUTCHURUMZUSACUITUJUSAUKEZUPUSVBVAULUN
      UOT $.
  $}

  ${
    $d A f j k $.  $d M k $.
    $( Any product of one over a valid set is one.  (Contributed by Scott
       Fenton, 7-Dec-2017.) $)
    prod1 $p |- ( ( A C_ ( ZZ>= ` M ) \/ A e. Fin ) ->
        prod_ k e. A 1 = 1 ) $=
      ( vf vj cuz cfv wss c1 cprod wceq wcel cz wa cxp a1i adantl cv c0 cn eqid
      cfn csn simpr cc0 wne ax-1ne0 cmul cseq cli wbr prodfclim1 simpl fvconst2
      cif 1ex ifid syl6eqr cc ax-1cn zprodn0 wn cdm cpw uzf fdmi eleq2i sylnbir
      ndmfv sseq2d biimpac ss0 prodeq1 prod0 syl6eq 3syl pm2.61dan chash cfz co
      wf1o wex wo fz1f1o eqidd elfznn fprod nnuz prodf1 adantr eqtrd ex exlimdv
      syl imp jaoi ) ACFGZHZAIBJZIKZAUBLZWRCMLZWTWRXBNZAIBWQIUCZOZCIWQWQUAZWRXB
      UDIUEUFXCUGPXBUHXECUIIUJUKWRCWQXFULQWRXBUMBRZWQLZXGXEGZXGALZIIUOZKXCXHXII
      XKWQIXGUPUNXJIUQURQIUSLZXCXJNUTPVAWRXBVBZNASHZASKZWTXMWRXNXMWQSAXBCFVCZLW
      QSKXPMCMMVDFVEVFVGCFVIVHVJVKAVLXOWSSIBJIASIBVMIBVNVOZVPVQXAXOAVRGZTLZIXRV
      SVTZADRZWAZDWBZNZWCWTADWDXOWTYDXQXSYCWTXSYBWTDXSYBWTXSYBNZWSXRUHTXDOZIUIG
      ZIYEAIIBEYAYFXRXGERZYAGKIWEXSYBUMXSYBUDXLYEXJNUTPYHXTLZYHYFGIKZYEYIYHTLYJ
      YHXRWFTIYHUPUNWNQWGXSYGIKYBIXRTWHWIWJWKWLWMWOWPWNWP $.
  $}

  ${
    $d A j k $.  $d B j $.
    $( A lemma to facilitate conversions from the function form to the
       class-variable form of a product.  (Contributed by Scott Fenton,
       7-Dec-2017.) $)
    prodfc $p |- prod_ j e. A ( ( k e. A |-> B ) ` j ) = prod_ k e. A B $=
      ( cv cmpt cfv cprod cid eqid fvmpt2i prodeq2i nffvmpt1 nfcv fveq2 prod2id
      cbvprodi 3eqtr4i ) ADEZDABFZGZDHABIGZDHACEZTGZCHABDHAUAUBDDABTTJKLAUDUACD
      DABUCMCUANUCSTOQABDPR $.
  $}

  ${
    $d A f $.  $d A k $.  $d A m $.  $d A n $.  $d B f $.  $d B m $.  $d B n $.
    $d C f $.  $d C m $.  $d C n $.  $d D f $.  $d D k $.  $d D m $.  $d f k $.
    $d f m $.  $d F m $.  $d f n $.  $d F n $.  $d f ph $.  $d G k $.
    $d k m $.  $d k n $.  $d k ph $.  $d m n $.  $d m ph $.  $d n ph $.
    fprodf1o.1 $e |- ( k = G -> B = D ) $.
    fprodf1o.2 $e |- ( ph -> C e. Fin ) $.
    fprodf1o.3 $e |- ( ph -> F : C -1-1-onto-> A ) $.
    fprodf1o.4 $e |- ( ( ph /\ n e. C ) -> ( F ` n ) = G ) $.
    fprodf1o.5 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    $( Re-index a finite product using a bijection.  (Contributed by Scott
       Fenton, 7-Dec-2017.) $)
    fprodf1o $p |- ( ph -> prod_ k e. A B = prod_ n e. C D ) $=
      ( vm c0 wceq cprod cfv wcel vf chash cn c1 cfz co cv wf1o wa prod0 adantr
      wex wfo wb f1oeq2 adantl mpbid f1ofo fo00 simprbi prodeq1d prodeq1 syl6eq
      3eqtr4a ex cmpt cmul ccom cseq fveq2 fveq2d simprl simprr cc wf ffvelrnda
      f1of eqid fmptd syldan adantlr simpr f1oco syl2an fvco3 sylan eqtrd fprod
      syl cid eqeltrrd fvmpti fvmpt2i 3eqtr4rd ralrimiva nffvmpt1 nfeq1 eqeq12d
      wral weq rspc prodeq2dv prodfc 3eqtr3g expr exlimdv expimpd cfn wo fz1f1o
      mpan9 mpjaod ) ADPQZBCFRZDEGRZQZDUBSZUCTZUDXQUEUFZDUAUGZUHZUAULZUIZAXMXPA
      XMUIZPCFRUDXNXOCFUJYDBPCFYDPBHUMZBPQZYDPBHUHZYEYDDBHUHZYGAYHXMLUKXMYHYGUN
      ADPBHUOUPUQPBHURWIYEHPQYFBHUSUTWIVAXMXOUDQAXMXOPEGRUDDPEGVBEGUJVCUPVDVEAX
      RYBXPAXRUIYAXPUAAXRYAXPAXRYAUIZUIZBOUGZFBCVFZSZORZDYKGDEVFZSZORZXNXOYJDYK
      HSZYLSZORXQVGYLHXTVHZVHZUDVISYQYNYJDYSGUGZXTSZHSZYLSZOGXTUUAXQYKUUCQYRUUD
      YLYKUUCHVJVKAXRYAVLZAXRYAVMAYKDTZYSVNTZYIAUUGYRBTUUHADBYKHAYHDBHVOLDBHVQW
      IZVPABVNYRYLAFBCVNYLNYLVRZVSZVPVTWAYJUUBXSTZUIZUUBUUASZUUBYTSZYLSZUUEYJXS
      BYTVOZUULUUNUUPQYJXSBYTUHZUUQAYHYAUURYILXRYAWBXSDBHXTWCWDZXSBYTVQWIXSBUUB
      YLYTWEWFZUUMUUOUUDYLYJXSDXTVOZUULUUOUUDQYIUVAAYAUVAXRXSDXTVQUPUPXSDUUBHXT
      WEWFVKWGWHYJDYPYSOAUUGYPYSQZYIAUUBYOSZUUBHSZYLSZQZGDWSUUGUVBAUVFGDAUUBDTZ
      UIZIYLSZEWJSZUVEUVCUVHIBTUVIUVJQUVHUVDIBMADBUUBHUUIVPWKFICEBYLJUUJWLWIUVH
      UVDIYLMVKUVGUVCUVJQAGDEYOYOVRWMUPWNWOUVFUVBGYKDGYPYSGDEYKWPWQGOWTZUVCYPUV
      EYSUUBYKYOVJUVKUVDYRYLUUBYKHVJVKWRXAXKWAXBYJBYMUUPOGYTUUAXQYKUUOYLVJUUFUU
      SYJBVNYKYLABVNYLVOYIUUKUKVPUUTWHWNBCOFXCDEOGXCXDXEXFXGADXHTXMYCXIKDUAXJWI
      XL $.
  $}

  ${
    $d A k $.  $d A m $.  $d A n $.  $d A y $.  $d B k $.  $d B m $.  $d B n $.
    $d B y $.  $d C m $.  $d C n $.  $d C y $.  $d k m $.  $d k n $.
    $d k ph $.  $d k y $.  $d M m $.  $d m n $.  $d M n $.  $d m ph $.
    $d m y $.  $d M y $.  $d n ph $.  $d n y $.  $d ph y $.  $d M k $.
    prodss.1 $e |- ( ph -> A C_ B ) $.
    prodss.2 $e |- ( ( ph /\ k e. A ) -> C e. CC ) $.
    prodss.3 $e |- ( ph -> E. n e. ( ZZ>= ` M ) E. y ( y =/= 0 /\
       seq n ( x. ,
           ( k e. ( ZZ>= ` M ) |-> if ( k e. B , C , 1 ) ) ) ~~> y ) ) $.
    prodss.4 $e |- ( ( ph /\ k e. ( B \ A ) ) -> C = 1 ) $.
    prodss.5 $e |- ( ph -> B C_ ( ZZ>= ` M ) ) $.
    $( Change the index set to a subset in an upper integer product.
       (Contributed by Scott Fenton, 11-Dec-2017.) $)
    prodss $p |- ( ph -> prod_ k e. A C = prod_ k e. B C ) $=
      ( wcel wceq wa c1 adantr cc adantl vm cz cprod cmpt cfv cmul cuz cif cseq
      cv cli eqid simpr cc0 wne wbr wex wrex wss sstrd csb iftrue wral wi ex wn
      cdif eldif syl6eqel sylan2br expr pm2.61d ralrimiva nfcsb1v nfel1 csbeq1a
      ax-1cn weq rspc mpan9 eqeltrd iffalse pm2.61dan nfcv nfv nfif eleq1 eqidd
      eleq1d ifbieq12d fvmptf syl2anc sselda adantlr syldan fvmpts eqtrd eqeq1d
      nfeq1 eqtr4d ssneld imp syl wf fmptd ffvelrnda zprod ancoms ifeq1d prodfc
      sylan 3eqtr3g cdm cpw uzf fdmi eleq2i ndmfv sylnbir sseqtrd ss0 prodeq1d
      c0 ) AHUBNZCEFUCZDEFUCZOAYDPZCUAUJZFCEUDZUEZUAUCZDYHFDEUDZUEZUAUCZYEYFYGY
      KUFFHUGUEZFUJZDNZEQUHZUDZHUIUKUEYNYGBCYJUAGYSHYOYOULZAYDUMZABUJZUNUOUFYSG
      UJUIUUBUKUPPBUQGYOURYDKRZACYOUSYDACDYOIMUTRYGYHYONZPZYHYSUEZYHDNZFYHEVAZQ
      UHZYHCNZYJQUHZUUEUUDUUISNZUUFUUIOZYGUUDUMYGUULUUDAUULYDAUUGUULAUUGPUUIUUH
      SUUGUUIUUHOZAUUGUUHQVBZTAESNZFDVCUUGUUHSNZAUUPFDAYQPYPCNZUUPAUURUUPVDYQAU
      URUUPJVERAYQUURVFZUUPYQUUSPAYPDCVGZNZUUPYPDCVHAUVAPEQSLVQVIVJVKVLZVMUUPUU
      QFYHDFUUHSFYHEVNZVOFUAVRZEUUHSFYHEVPZWIVSVTZWAUUGVFZUULAUVGUUIQSUUGUUHQWB
      ZVQVITWCRZRFYHYRUUIYOYSSFYHWDUUGFUUHQUUGFWEUVCFQWDWFUVDYQUUGEQUUHQYPYHDWG
      UVEUVDQWHWJYSULWKZWLYGUUKUUIOZUUDYGUUGUVKYGUUGPZUUKUUHUUIUVLUUJUUKUUHOZYG
      UUJUVMVDUUGYGUUJUVMYGUUJPZUUKYJUUHUUJUUKYJOYGUUJYJQVBTUVNUUJUUQYJUUHOYGUU
      JUMYGUUJUUGUUQYGCDYHACDUSZYDIRZWMAUUGUUQYDUVFWNZWOFYHECYISYIULZWPWLWQVERY
      GUUGUUJVFZUVMYGUUGUVSPZPUUKQUUHUVTUUKQOZYGUVSUWAUUGUUJYJQWBZTTUVTYGYHUUTN
      ZUUHQOZYHDCVHYGEQOZFUUTVCZUWCUWDAUWFYDAUWEFUUTLVMRUWEUWDFYHUUTFUUHQUVCWSU
      VDEUUHQUVEWRVSVTVJWTVKVLUUGUUNYGUUOTWTYGUVGPZUUKQUUIUWGUVSUWAYGUVGUVSYGCD
      YHUVPXAXBUWBXCUVGUUIQOYGUVHTWTWCRWTYGCSYHYIACSYIXDYDAFCESYIJUVRXERXFXGYGB
      DYMUAGYSHYOYTUUAUUCADYOUSZYDMRUUEUUFUUIUUGYMQUHZYGUULUUDUUMUVIUUDUULUUMUV
      JXHXKUUEUUGUWIUUIOZYGUUGUWJUUDUVLUUGYMUUHQUVLUUGUUQYMUUHOYGUUGUMUVQFYHEDY
      LSYLULZWPWLXIWNUVGUWJUUEUVGUWIQUUIUUGYMQWBUVHWTTWCWTYGDSYHYLADSYLXDYDAFDE
      SYLUVBUWKXERXFXGWTCEUAFXJDEUAFXJXLAYDVFZPZCDEFUWMCYCDUWMCYCUSCYCOUWMCDYCA
      UVOUWLIRUWMDYOYCAUWHUWLMRUWLYOYCOZAYDHUGXMZNUWNUWOUBHUBUBXNUGXOXPXQHUGXRX
      STXTZUTCYAXCUWMDYCUSDYCOUWPDYAXCWTYBWC $.
  $}

  ${
    $d A f $.  $d A k $.  $d A m $.  $d A n $.  $d B f $.  $d B k $.  $d B m $.
    $d B n $.  $d C f $.  $d C m $.  $d C n $.  $d f k $.  $d f m $.  $d f n $.
    $d f ph $.  $d k m $.  $d k n $.  $d k ph $.  $d m n $.  $d m ph $.
    $d n ph $.  $d A y $.  $d B y $.  $d C y $.  $d f y $.  $d k y $.
    $d m y $.  $d n y $.  $d ph y $.
    fprodss.1 $e |- ( ph -> A C_ B ) $.
    fprodss.2 $e |- ( ( ph /\ k e. A ) -> C e. CC ) $.
    fprodss.3 $e |- ( ( ph /\ k e. ( B \ A ) ) -> C = 1 ) $.
    fprodss.4 $e |- ( ph -> B e. Fin ) $.
    $( Change the index set to a subset in a finite sum.  (Contributed by Scott
       Fenton, 16-Dec-2017.) $)
    fprodss $p |- ( ph -> prod_ k e. A C = prod_ k e. B C ) $=
      ( vm vn c0 wceq cprod cfv wcel c1 wa syl cc vf vy chash cn cfz co cv wf1o
      wex wss sseq2 ss0 syl6bi prodeq1 eqcomd sylan9eq expcom syld syl5com cmpt
      ccnv cima cdm cnvimass wf simprr f1of fdm syl5sseq wfn wb f1ofn ffvelrnda
      elpreima ex adantrd sylbid imp wi adantr wn cdif ax-1cn syl6eqel sylan2br
      eldif expr pm2.61d adantlr eqid fmptd syldan cuz simprl nnuz syl6eleq a1i
      ssid fprodntriv eldifi sylan2 eldifn adantl biantrurd bitr4d mtbid eldifd
      cres difss resmpt ax-mp fveq1i fvres syl5eqr csn elsnc2 ad2antrr ffvelrnd
      1ex sylibr elsni eqtr3d fzssuz prodss fveq1d sylan9req prodeq2dv fisuppfi
      fveq2 fzfid wf1 f1of1 f1ores syl2anc wfo foimacnv f1oeq3 fprodf1o prodfc
      f1ofo mpbid sselda eqtrd eqidd 3eqtr4d 3eqtr3g exlimdv expimpd cfn fz1f1o
      wo mpjaod ) ACLMZBDENZCDENZMZCUCOZUDPZQUUQUEUFZCUAUGZUHZUAUIZRZABCUJZUUMU
      UPFUUMUVDBLMZUUPUUMUVDBLUJUVECLBUKBULUMUVEUUMUUPUVEUUMUUNLDENZUUOBLDEUNUU
      MUUOUVFCLDEUNUOUPUQURUSAUURUVBUUPAUURRUVAUUPUAAUURUVAUUPAUURUVARZRZBJUGZE
      BDUTZOZJNZCUVIECDUTZOZJNZUUNUUOUVHUUTVABVBZKUGZUUTOZUVMOZKNZUUSUVSKNUVLUV
      OUVHUBUVPUUSUVSKJQUVHUUTVCZUVPUUSUUTBVDUVHUUSCUUTVEZUWAUUSMUVHUVAUWBAUURU
      VAVFZUUSCUUTVGSZUUSCUUTVHSVIZUVHUVQUVPPZUVRCPZUVSTPUVHUWFUWGUVHUWFUVQUUSP
      ZUVRBPZRZUWGUVHUUTUUSVJZUWFUWJVKZUVHUVAUWKUWCUUSCUUTVLSUUSUVQBUUTVNSZUVHU
      WHUWGUWIUVHUWHUWGUVHUUSCUVQUUTUWDVMZVOVPVQVRUVHCTUVRUVMUVHECDTUVMAEUGZCPZ
      DTPZUVGAUWPRUWOBPZUWQAUWRUWQVSUWPAUWRUWQGVOVTAUWPUWRWAZUWQUWPUWSRAUWOCBWB
      ZPZUWQUWOCBWFAUXARZDQTHWCWDWEWGWHWIUVMWJWKZVMWLUVHUBUUSUVSKJQUUQQWMOZUXDW
      JUVHUUQUDUXDAUURUVAWNWOWPUUSUUSUJUVHUUSWRWQWSUVHUVQUUSUVPWBPZRZUVREUWTDUT
      ZOZUVSQUXFUVRUWTPZUXHUVSMUXFUVRCBUXEUVHUWHUWGUVQUUSUVPWTZUWNXAUXFUWFUWIUX
      EUWFWAUVHUVQUUSUVPXBXCUXFUWFUWJUWIUVHUWLUXEUWMVTUXFUWHUWIUXEUWHUVHUXJXCXD
      XEXFXGZUXIUXHUVRUVMUWTXHZOUVSUVRUXLUXGUWTCUJUXLUXGMCBXIECUWTDXJXKXLUVRUWT
      UVMXMXNSUXFUXHQXOZPUXHQMUXFUWTUXMUVRUXGAUWTUXMUXGVEUVGUXEAEUWTDUXMUXGUXBD
      QMDUXMPHDQXSXPXTUXGWJWKXQUXKXRUXHQYASYBUUSUXDUJUVHQUUQYCWQYDUVHUVLBUVNJNU
      VTUVHBUVKUVNJUVHUVIBPZUVKUVIUVMBXHZOUVNUVHUVIUXOUVJUVHUVDUXOUVJMAUVDUVGFV
      TZECBDXJSYEUVIBUVMXMYFYGUVHBUVNUVPUVSJKUUTUVPXHZUVRUVIUVRUVMYIZUVHUUSCBUU
      TUVHQUUQYJZUWDYHUVHUVPUUTUVPVBZUXQUHZUVPBUXQUHZUVHUUSCUUTYKZUVPUUSUJUYAUV
      HUVAUYCUWCUUSCUUTYLSUWEUUSCUVPUUTYMYNUVHUXTBMZUYAUYBVKUVHUUSCUUTYOZUVDUYD
      UVHUVAUYEUWCUUSCUUTYTSUXPUUSCBUUTYPYNUXTBUVPUXQYQSUUAUWFUVQUXQOUVRMUVHUVQ
      UVPUUTXMXCUVHUXNUVICPUVNTPUVHBCUVIUXPUUBUVHCTUVIUVMUXCVMZWLYRUUCUVHCUVNUU
      SUVSJKUUTUVRUXRUXSUWCUVHUWHRUVRUUDUYFYRUUEBDJEYSCDJEYSUUFWGUUGUUHACUUIPUU
      MUVCUUKICUAUUJSUUL $.
  $}


  ${
    $d A j $.  $d A m $.  $d F j $.  $d F k $.  $d F m $.  $d j k $.  $d j m $.
    $d j n $.  $d j ph $.  $d k m $.  $d k ph $.  $d M j $.  $d M k $.
    $d M m $.  $d m n $.  $d M n $.  $d m p $.  $d M p $.  $d m ph $.
    $d N j $.  $d N k $.  $d N m $.  $d N n $.  $d n p $.  $d N p $.
    $d n ph $.  $d p ph $.
    fprodser.1 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) = A ) $.
    fprodser.2 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fprodser.3 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    $( A finite product expressed in terms of a partial product of an infinite
       sequence.  The recursive definition of a finite product follows from
       here.  (Contributed by Scott Fenton, 14-Dec-2017.) $)
    fprodser $p |- ( ph -> prod_ k e. ( M ... N ) A =
          ( seq M ( x. , F ) ` N ) ) $=
      ( vn vm vp co cfv c1 caddc wcel cc wceq adantr vj cprod cv cmpt cmul cseq
      cfz prodfc cmin ccom fveq2 cn cuz cz eluzelz syl eluzel2 ax-1cn subadd23d
      zcnd a1i eqcomd cn0 uznn0sub nn0p1nn eqeltrd wral wreu wf1o wsbc pnpncand
      pncan3d oveq12d eleq2d biimpa wa elfzelz adantl peano2zm simpr ovex oveq1
      npcand eleq1d sbcie sylibr syldan ralrimiva nnzd fzshftral syl3anc mpbird
      wb 1z weq wi fzsubel syl22anc mpbid nncand subsub2d eleqtrd eqeq2d rspcev
      wrex syl2anc anim12i simprl simprr addcan2d syl5ib sylan2 ralrimivva reu4
      eqtr2 sylanbrc f1ompt fmptd ffvelrnda csb fzaddel nfcsb1v csbeq1a eqeq12d
      eqid nfeq2 rspc mpan9 wf f1of fvco3 sylan fvmpt fveq2d eqtrd nfel1 fvmpts
      3eqtr4d fprod nnuz syl6eleq seqshft2 seqeq1d fveq12d 3eqtrd syl5eqr ) AEF
      UGMZBCUBUUGUAUCZCUUGBUDZNZUAUBZFUEDEUFZNZUUGBUACUHAUUKFOEUIMPMZUEDJOUUNUG
      MZJUCZEOUIMZPMZUDZUJZOUFNUUNUUQPMZUEDOUUQPMZUFZNUUMAUUGUUJKUCZUUSNZUUINZU
      AKUUSUUTUUNUUHUVEUUIUKAUUNFEUIMZOPMZULAUVHUUNAFEOAFAFEUMNQZFUNQZHEFUOUPZU
      TZAEAUVIEUNQZHEFUQUPZUTZORQAURVAZUSVBAUVGVCQZUVHULQAUVIUVQHEFVDUPUVGVEUPV
      FZAUURUUGQZJUUOVGZLUCZUURSZJUUOVHZLUUGVGUUOUUGUUSVIZAUVTUVSJUWAUUQUIMZVJZ
      LUVBUVAUGMZVGZAUWFLUWGAUWAUWGQZUWAUUGQZUWFAUWIUWJAUWGUUGUWAAUVBEUVAFUGAOE
      UVPUVOVLZAFOEUVLUVPUVOVKZVMZVNVOAUWJVPZUWEUUQPMZUUGQZUWFUWNUWOUWAUUGUWNUW
      AUUQUWJUWARQAUWJUWAUWAEFVQZUTVRAUUQRQZUWJAUUQAUVMUUQUNQZUVNEVSUPZUTZTWCZA
      UWJVTZVFUVSUWPJUWEUWAUUQUIWAUUPUWESZUURUWOUUGUUPUWEUUQPWBZWDWEWFWGWHAOUNQ
      ZUUNUNQZUWSUVTUWHWMUXFAWNVAAUUNUVRWIZUWTUVSJLUUQOUUNWJWKWLAUWCLUUGUWNUWBJ
      UUOXEZUWBUWAUVDUUQPMZSZVPZJKWOZWPZKUUOVGJUUOVGZUWCUWNUWEUUOQUWAUWOSZUXIUW
      NUWEEUUQUIMZFUUQUIMZUGMZUUOUWNUWJUWEUXSQZUXCUWNUVMUVJUWAUNQZUWSUWJUXTWMAU
      VMUWJUVNTAUVJUWJUVKTUWJUYAAUWQVRAUWSUWJUWTTUWAUUQEFWQWRWSAUXSUUOSUWJAUXQO
      UXRUUNUGAEOUVOUVPWTAFEOUVLUVOUVPXAVMTXBUWNUWOUWAUXBVBUWBUXPJUWEUUOUXDUURU
      WOUWAUXEXCXDXFAUXOUWJAUXNJKUUOUUOUUPUUOQZUVDUUOQZVPAUUPRQZUVDRQZVPZUXNUYB
      UYDUYCUYEUYBUUPUUPOUUNVQUTUYCUVDUVDOUUNVQZUTXGUXLUURUXJSAUYFVPZUXMUWAUURU
      XJXOUYHUUPUVDUUQAUYDUYEXHAUYDUYEXIAUWRUYFUXATXJXKXLXMTUWBUXKJKUUOUXMUURUX
      JUWAUUPUVDUUQPWBZXCXNXPWHJLUUOUUGUURUUSUUSYEZXQXPZAUUGRUUHUUIACUUGBRUUIIU
      UIYEZXRXSAUYCVPZUXJDNZCUXJBXTZUVDUUTNZUVFAUYCUXJUUGQZUYNUYOSZUYMUXJUWGUUG
      UYMUYCUXJUWGQZAUYCVTUYMUXFUXGUVDUNQZUWSUYCUYSWMUXFUYMWNVAAUXGUYCUXHTUYCUY
      TAUYGVRAUWSUYCUWTTUVDUUQOUUNYAWRWSAUWGUUGSUYCUWMTXBZACUCZDNZBSZCUUGVGUYQU
      YRAVUDCUUGGWHVUDUYRCUXJUUGCUYNUYOCUXJBYBZYFVUBUXJSZVUCUYNBUYOVUBUXJDUKCUX
      JBYCZYDYGYHWGUYMUYPUVEDNZUYNAUUOUUGUUSYIZUYCUYPVUHSAUWDVUIUYKUUOUUGUUSYJU
      PUUOUUGUVDDUUSYKYLUYMUVEUXJDUYCUVEUXJSAJUVDUURUXJUUOUUSUYIUYJUVDUUQPWAYMV
      RZYNYOZUYMUVFUXJUUINZUYOUYMUVEUXJUUIVUJYNUYMUYQUYORQZVULUYOSVUAAUYCUYQVUM
      VUAABRQZCUUGVGUYQVUMAVUNCUUGIWHVUNVUMCUXJUUGCUYORVUEYPVUFBUYORVUGWDYGYHWG
      CUXJBUUGUUIRUYLYQXFYOYRYSAUEKUUTDUUQOUUNAUUNULOUMNUVRYTUUAUWTVUKUUBAUVAFU
      VCUULAUVBEUEDUWKUUCUWLUUDUUEUUF $.
  $}

  ${
    fprodcllem.1 $e |- ( ph -> S C_ CC ) $.
    fprodcllem.2 $e |- ( ( ph /\ ( x e. S /\ y e. S ) ) ->
      ( x x. y ) e. S ) $.
    fprodcllem.3 $e |- ( ph -> A e. Fin ) $.
    fprodcllem.4 $e |- ( ( ph /\ k e. A ) -> B e. S ) $.

    ${
      $d A f $.  $d A k $.  $d A m $.  $d A x $.  $d A y $.  $d B f $.
      $d B m $.  $d B x $.  $d B y $.  $d f k $.  $d f m $.  $d f ph $.
      $d f x $.  $d f y $.  $d k m $.  $d k ph $.  $d k x $.  $d k y $.
      $d m ph $.  $d m x $.  $d ph x $.  $d ph y $.  $d S f $.  $d S k $.
      $d S x $.  $d S y $.  $d x y $.
      fprodcl2lem.5 $e |- ( ph -> A =/= (/) ) $.
      $( Finite product closure lemma.  (Contributed by Scott Fenton,
         14-Dec-2017.) $)
      fprodcl2lem $p |- ( ph -> prod_ k e. A B e. S ) $=
        ( vf vm wcel cfv c1 cv wa cc c0 wceq cprod chash cn cfz co wf1o wex wne
        wn a1d necon4bd cmul cmpt ccom prodfc fveq2 simprl simprr adantr sseldd
        cseq wss eqid fmptd ffvelrnda adantlr f1of ad2antll fvco3 sylan syl5eqr
        wf fprod cuz nnuz syl6eleq fco syl2anc eqeltrd expr exlimdv expimpd cfn
        seqcl wo fz1f1o syl mpjaod ) ADUAUBZDEGUCZFOZDUDPZUEOZQWNUFUGZDMRZUHZMU
        IZSZAWMDUAADUAUJWMUKLULUMAWOWSWMAWOSWRWMMAWOWRWMAWOWRSZSZWLWNUNGDEUOZWQ
        UPZQVCPZFXBWLDNRZXCPZNUCXEDENGUQXBDXGBRZWQPZXCPZNBWQXDWNXFXIXCURAWOWRUS
        ZAWOWRUTAXFDOXGTOXAADTXFXCAGDETXCAGRDOZSFTEAFTVDXLHVAKVBXCVEZVFVGVHXBWP
        DWQVNZXHWPOXHXDPXJUBWRXNAWOWPDWQVIVJZWPDXHXCWQVKVLVOVMXBBCUNFXDQWNXBWNU
        EQVPPXKVQVRXBWPFXHXDXBDFXCVNZXNWPFXDVNAXPXAAGDEFXCKXMVFVAXOWPDFXCWQVSVT
        VGAXHFOCRZFOSXHXQUNUGFOXAIVHWFWAWBWCWDADWEOWKWTWGJDMWHWIWJ $.
    $}

    $d A k $.  $d A x $.  $d A y $.  $d B x $.  $d B y $.  $d k ph $.
    $d k x $.  $d k y $.  $d ph x $.  $d ph y $.  $d S k $.  $d S x $.
    $d S y $.  $d x y $.
    fprodcllem.5 $e |- ( ph -> 1 e. S ) $.
    $( Finite product closure lemma.  (Contributed by Scott Fenton,
       14-Dec-2017.) $)
    fprodcllem $p |- ( ph -> prod_ k e. A B e. S ) $=
      ( cprod wcel c0 wceq wa c1 adantr cv prodeq1 syl6eq adantl eqeltrd wne cc
      prod0 wss cmul co adantlr cfn simpr fprodcl2lem pm2.61dane ) ADEGMZFNDOAD
      OPZQUPRFUQUPRPAUQUPOEGMRDOEGUAEGUGUBUCARFNUQLSUDADOUEZQBCDEFGAFUFUHURHSAB
      TZFNCTZFNQUSUTUIUJFNURIUKADULNURJSAGTDNEFNURKUKAURUMUNUO $.
  $}

  ${
    $d A k x y $.  $d B x y $.  $d ph k x y $.
    fprodcl.1 $e |- ( ph -> A e. Fin ) $.

    ${
      fprodcl.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
      $( Closure of a finite product of complex numbers.  (Contributed by Scott
         Fenton, 14-Dec-2017.) $)
      fprodcl $p |- ( ph -> prod_ k e. A B e. CC ) $=
        ( vx vy cc wss ssid a1i cv wcel wa cmul co mulcl adantl c1 fprodcllem
        ax-1cn ) AGHBCIDIIJAIKLGMZINHMZINOUCUDPQINAUCUDRSEFTINAUBLUA $.
    $}

    ${
      fprodrecl.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
      $( Closure of a finite product of real numbers.  (Contributed by Scott
         Fenton, 14-Dec-2017.) $)
      fprodrecl $p |- ( ph -> prod_ k e. A B e. RR ) $=
        ( vx vy cr cc wss ax-resscn a1i cv wcel wa cmul co remulcl adantl 1re
        c1 fprodcllem ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUBIOAUAMUC $.
    $}

    ${
      fprodzcl.2 $e |- ( ( ph /\ k e. A ) -> B e. ZZ ) $.
      $( Closure of a finite product of integers.  (Contributed by Scott
         Fenton, 14-Dec-2017.) $)
      fprodzcl $p |- ( ph -> prod_ k e. A B e. ZZ ) $=
        ( vx vy cz cc wss zsscn a1i cv wcel wa cmul co zmulcl adantl fprodcllem
        c1 1z ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUBIOAUCMUA $.
    $}

    ${
      fprodnncl.2 $e |- ( ( ph /\ k e. A ) -> B e. NN ) $.
      $( Closure of a finite product of natural numbers.  (Contributed by Scott
         Fenton, 14-Dec-2017.) $)
      fprodnncl $p |- ( ph -> prod_ k e. A B e. NN ) $=
        ( vx vy cn cc wss nnsscn a1i cv wcel wa cmul co nnmulcl adantl c1 1nn
        fprodcllem ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUAIOAUBMUC $.
    $}

    ${
      fprodrpcl.2 $e |- ( ( ph /\ k e. A ) -> B e. RR+ ) $.
      $( Closure of a finite product of positive reals.  (Contributed by Scott
         Fenton, 14-Dec-2017.) $)
      fprodrpcl $p |- ( ph -> prod_ k e. A B e. RR+ ) $=
        ( vx vy crp cc wss cr rpssre ax-resscn sstri a1i cv wcel wa cmul adantl
        co rpmulcl c1 1rp fprodcllem ) AGHBCIDIJKAILJMNOPGQZIRHQZIRSUGUHTUBIRAU
        GUHUCUAEFUDIRAUEPUF $.
    $}

    ${
      fprodnn0cl.2 $e |- ( ( ph /\ k e. A ) -> B e. NN0 ) $.
      $( Closure of a finite product of non-negative integers.  (Contributed by
         Scott Fenton, 14-Dec-2017.) $)
      fprodnn0cl $p |- ( ph -> prod_ k e. A B e. NN0 ) $=
        ( vx vy cn0 cc wss nn0sscn a1i cv wcel wa cmul co nn0mulcl adantl 1nn0
        c1 fprodcllem ) AGHBCIDIJKALMGNZIOHNZIOPUDUEQRIOAUDUESTEFUBIOAUAMUC $.
    $}
  $}

  ${
    $d A f $.  $d A k $.  $d A m $.  $d B f $.  $d B m $.  $d C f $.  $d C m $.
    $d f k $.  $d f ph $.  $d k m $.  $d k ph $.  $d A n $.  $d B n $.
    $d C n $.  $d f m $.  $d f n $.  $d k n $.  $d m n $.  $d m ph $.
    $d n ph $.
    fprodmul.1 $e |- ( ph -> A e. Fin ) $.
    fprodmul.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    fprodmul.3 $e |- ( ( ph /\ k e. A ) -> C e. CC ) $.
    $( The product of two finite products.  (Contributed by Scott Fenton,
       14-Dec-2017.) $)
    fprodmul $p |- ( ph -> prod_ k e. A ( B x. C ) =
      ( prod_ k e. A B x. prod_ k e. A C ) ) $=
      ( vm c0 wceq cmul co cprod cfv wcel c1 wa cc wf vf vn chash cn cfz cv wex
      wf1o wi 1t1e1 oveq12i 3eqtr4ri prodeq1 oveq12d 3eqtr4a a1i cmpt ccom cseq
      prod0 cuz simprl nnuz syl6eleq eqid fmptd f1of ad2antll syl2anc ffvelrnda
      adantr fco wral simpr mulcld fvmpt2 ralrimiva ad2antrr nffvmpt1 nfcv nfov
      eqtr4d nfeq fveq2 eqeq12d rspc fvco3 sylan 3eqtr4d prodfmul simprr prodfc
      sylc fprod 3eqtr3g expr exlimdv expimpd cfn wo fz1f1o syl mpjaod ) ABJKZB
      CDLMZENZBCENZBDENZLMZKZBUCOZUDPZQXKUEMZBUAUFZUHZUAUGZRZXDXJUIAXDJXEENZJCE
      NZJDENZLMZXFXIQQLMQYAXRUJXSQXTQLCEUTDEUTUKXEEUTULBJXEEUMXDXGXSXHXTLBJCEUM
      BJDEUMUNUOUPAXLXPXJAXLRXOXJUAAXLXOXJAXLXORZRZBIUFZEBXEUQZOZINZBYDEBCUQZOZ
      INZBYDEBDUQZOZINZLMZXFXIYCXKLYEXNURZQUSOXKLYHXNURZQUSOZXKLYKXNURZQUSOZLMY
      GYNYCUBYPYRYOQXKYCXKUDQVAOAXLXOVBZVCVDYCXMSUBUFZYPYCBSYHTZXMBXNTZXMSYPTAU
      UBYBAEBCSYHGYHVEZVFVKZXOUUCAXLXMBXNVGVHZXMBSYHXNVLVIVJYCXMSUUAYRYCBSYKTZU
      UCXMSYRTAUUGYBAEBDSYKHYKVEZVFVKZUUFXMBSYKXNVLVIVJYCUUAXMPZRZUUAXNOZYEOZUU
      LYHOZUULYKOZLMZUUAYOOZUUAYPOZUUAYROZLMUUKUULBPEUFZYEOZUUTYHOZUUTYKOZLMZKZ
      EBVMZUUMUUPKZYCXMBUUAXNUUFVJAUVFYBUUJAUVEEBAUUTBPZRZUVAXEUVDUVIUVHXESPUVA
      XEKAUVHVNZUVICDGHVOZEBXESYEYEVEZVPVIUVIUVBCUVCDLUVIUVHCSPUVBCKUVJGEBCSYHU
      UDVPVIUVIUVHDSPUVCDKUVJHEBDSYKUUHVPVIUNWBVQVRUVEUVGEUULBEUUMUUPEBXEUULVSE
      UUNUUOLEBCUULVSELVTEBDUULVSWAWCUUTUULKZUVAUUMUVDUUPUUTUULYEWDUVMUVBUUNUVC
      UUOLUUTUULYHWDUUTUULYKWDUNWEWFWMYCUUCUUJUUQUUMKUUFXMBUUAYEXNWGWHZUUKUURUU
      NUUSUUOLYCUUCUUJUURUUNKUUFXMBUUAYHXNWGWHZYCUUCUUJUUSUUOKUUFXMBUUAYKXNWGWH
      ZUNWIWJYCBYFUUMIUBXNYOXKYDUULYEWDYTAXLXOWKZYCBSYDYEABSYETYBAEBXESYEUVKUVL
      VFVKVJUVNWNYCYJYQYMYSLYCBYIUUNIUBXNYPXKYDUULYHWDYTUVQYCBSYDYHUUEVJUVOWNYC
      BYLUUOIUBXNYRXKYDUULYKWDYTUVQYCBSYDYKUUIVJUVPWNUNWIBXEIEWLYJXGYMXHLBCIEWL
      BDIEWLUKWOWPWQWRABWSPXDXQWTFBUAXAXBXC $.

    fproddiv.4 $e |- ( ( ph /\ k e. A ) -> C =/= 0 ) $.
    $( The quotient of two finite products.  (Contributed by Scott Fenton,
       15-Jan-2018.) $)
    fproddiv $p |- ( ph -> prod_ k e. A ( B / C ) =
       ( prod_ k e. A B / prod_ k e. A C ) ) $=
      ( vm c0 wceq cdiv co cprod cfv wcel c1 cc cc0 vf vn chash cn cfz wf1o wex
      cv wa wi ax-1cn div1i eqcomi prodeq1 syl6eq oveq12d 3eqtr4a a1i cmpt cmul
      prod0 ccom cseq cuz simprl nnuz syl6eleq wf eqid fmptd f1of adantl syl2an
      fco ffvelrnda simprr syl fvco3 sylan wral simpr syl2anc eqnetrd ralrimiva
      wne fvmpt2 ad2antrr nffvmpt1 nfcv nfne fveq2 neeq1d rspc sylc divcld nfov
      eqtr4d nfeq eqeq12d 3eqtr4d prodfdiv adantr fprod oveq12i 3eqtr3g exlimdv
      prodfc expr expimpd cfn wo fz1f1o mpjaod ) ABKLZBCDMNZEOZBCEOZBDEOZMNZLZB
      UCPZUDQZRYAUENZBUAUHZUFZUAUGZUIZXNXTUJAXNRRRMNZXPXSYHRRUKULUMXNXPKXOEORBK
      XOEUNXOEVAUOXNXQRXRRMXNXQKCEORBKCEUNCEVAUOXNXRKDEORBKDEUNDEVAUOUPUQURAYBY
      FXTAYBUIYEXTUAAYBYEXTAYBYEUIZUIZBJUHZEBXOUSZPZJOZBYKEBCUSZPZJOZBYKEBDUSZP
      ZJOZMNZXPXSYJYAUTYLYDVBZRVCPYAUTYOYDVBZRVCPZYAUTYRYDVBZRVCPZMNYNUUAYJUBUU
      CUUEUUBRYAYJYAUDRVDPAYBYEVEZVFVGYJYCSUBUHZUUCABSYOVHZYCBYDVHZYCSUUCVHYIAE
      BCSYOGYOVIZVJZYEUUJYBYCBYDVKZVLZYCBSYOYDVNVMVOYJYCSUUHUUEABSYRVHZUUJYCSUU
      EVHYIAEBDSYRHYRVIZVJZUUNYCBSYRYDVNVMVOYJUUHYCQZUIZUUHUUEPZUUHYDPZYRPZTYJU
      UJUURUUTUVBLYJYEUUJAYBYEVPZUUMVQZYCBUUHYRYDVRVSZUUSUVABQZEUHZYRPZTWEZEBVT
      ZUVBTWEZYJYCBUUHYDUVDVOZAUVJYIUURAUVIEBAUVGBQZUIZUVHDTUVNUVMDSQUVHDLAUVMW
      AZHEBDSYRUUPWFWBZIWCWDWGUVIUVKEUVABEUVBTEBDUVAWHZETWIWJUVGUVALZUVHUVBTUVG
      UVAYRWKZWLWMWNWCUUSUVAYLPZUVAYOPZUVBMNZUUHUUBPZUUHUUCPZUUTMNUUSUVFUVGYLPZ
      UVGYOPZUVHMNZLZEBVTZUVTUWBLZUVLAUWIYIUURAUWHEBUVNUWEXOUWGUVNUVMXOSQUWEXOL
      UVOUVNCDGHIWOZEBXOSYLYLVIZWFWBUVNUWFCUVHDMUVNUVMCSQUWFCLUVOGEBCSYOUUKWFWB
      UVPUPWQWDWGUWHUWJEUVABEUVTUWBEBXOUVAWHEUWAUVBMEBCUVAWHEMWIUVQWPWRUVRUWEUV
      TUWGUWBUVGUVAYLWKUVRUWFUWAUVHUVBMUVGUVAYOWKUVSUPWSWMWNYJUUJUURUWCUVTLUVDY
      CBUUHYLYDVRVSZUUSUWDUWAUUTUVBMYJUUJUURUWDUWALUVDYCBUUHYOYDVRVSZUVEUPWTXAY
      JBYMUVTJUBYDUUBYAYKUVAYLWKUUGUVCYJBSYKYLABSYLVHYIAEBXOSYLUWKUWLVJXBVOUWMX
      CYJYQUUDYTUUFMYJBYPUWAJUBYDUUCYAYKUVAYOWKUUGUVCYJBSYKYOAUUIYIUULXBVOUWNXC
      YJBYSUVBJUBYDUUEYAYKUVAYRWKUUGUVCYJBSYKYRAUUOYIUUQXBVOUVEXCUPWTBXOJEXGYQX
      QYTXRMBCJEXGBDJEXGXDXEXHXFXIABXJQXNYGXKFBUAXLVQXM $.
  $}

  ${
    $d A m n $.  $d B k m n $.  $d M k m n $.  $d V k m n $.
    prodsn.1 $e |- ( k = M -> A = B ) $.
    $( A product of a singleton is the term.  (Contributed by Scott Fenton,
       14-Dec-2017.) $)
    prodsn $p |- ( ( M e. V /\ B e. CC ) -> prod_ k e. { M } A = B ) $=
      ( vm vn wcel cc wa csn cprod c1 cfv csb cz 1z wceq adantr cmul cv nfcsb1v
      cop cseq nfcv csbeq1a cbvprodi csbeq1 cn 1nn a1i cfz co wf1o f1osng ax-mp
      wb fzsn f1oeq2 sylibr mpan nfcvd csbiegf sylan9eqr sylan2b simplr eqeltrd
      elsn eleq2i bitri fvsng csbeq1d simpr sylancr 3eqtr4rd eqeq12d syl5ibrcom
      fveq2 imp fprod syl5eq seq1i eqtrd ) DEIZBJIZKZDLZACMZNUANBUDLZNUEOZBWGWI
      WHCGUBZAPZGMWKWHAWMCGGAUFCWLAUCCWLAUGUHWGWHWMCHUBZNDUDLZOZAPZGHWOWJNCWLWP
      AUINUJIWGUKULWENNUMUNZWHWOUOZWFNQIZWEWSRWTWEKNLZWHWOUOZWSNDQEUPWRXASZWSXB
      URWTXCRNUSUQZWRXAWHWOUTUQVAVBTWGWLWHIZKWMBJXEWGWLDSZWMBSGDVIXFWGWMCDAPZBC
      WLDAUIWEXGBSWFCDABEWECBVCFVDTZVEVFWEWFXEVGVHWNWRIZWGWNNSZWNWJOZWQSZXIWNXA
      IXJWRXAWNXDVJHNVIVKWGXJXLWGXLXJNWJOZCNWOOZAPZSWGXGBXOXMXHWGCXNDAWEXNDSZWF
      WTWEXPRNDQEVLVBTVMWGWTWFXMBSRWEWFVNNBQJVLVOZVPXJXKXMWQXOWNNWJVSXJCWPXNAWN
      NWOVSVMVQVRVTVFWAWBWGBUAWJNRXQWCWD $.

    $( A finite product of only one term is the term itself.  (Contributed by
       Scott Fenton, 14-Dec-2017.) $)
    fprod1 $p |- ( ( M e. ZZ /\ B e. CC ) -> prod_ k e. ( M ... M ) A = B ) $=
      ( cz wcel cc wa cfz co cprod csn wceq fzsn prodeq1d adantr prodsn eqtrd )
      DFGZBHGZIDDJKZACLZDMZACLZBTUCUENUATUBUDACDOPQABCDFERS $.
  $}

  ${
    climprod1.1 $e |- Z = ( ZZ>= ` M ) $.
    climprod1.2 $e |- ( ph -> M e. ZZ ) $.
    $( The limit of a product over one.  (Contributed by Scott Fenton,
       15-Dec-2017.) $)
    climprod1 $p |- ( ph -> seq M ( x. , ( Z X. { 1 } ) ) ~~> 1 ) $=
      ( cz wcel cmul c1 csn cxp cseq cli wbr prodfclim1 syl ) ABFGHCIJKBLIMNEBC
      DOP $.
  $}

  ${
    $d A k $.  $d B k $.  $d k ph $.  $d U k $.
    fprodsplit.1 $e |- ( ph -> ( A i^i B ) = (/) ) $.
    fprodsplit.2 $e |- ( ph -> U = ( A u. B ) ) $.
    fprodsplit.3 $e |- ( ph -> U e. Fin ) $.
    fprodsplit.4 $e |- ( ( ph /\ k e. U ) -> C e. CC ) $.
    $( Split a finite product into two parts.  (Contributed by Scott Fenton,
       16-Dec-2017.) $)
    fprodsplit $p |- ( ph -> prod_ k e. U C =
      ( prod_ k e. A C x. prod_ k e. B C ) ) $=
      ( cprod cmul co wcel c1 wa cc wceq adantl syl cv cif iftrue cun syl5sseqr
      prodeq2i ssun1 sselda syldan eqeltrd cdif wn eldifn iffalse fprodss ssun2
      syl5eqr oveq12d ax-1cn ifcl sylancl fprodmul wo eleq2d elun syl6bb biimpa
      cin c0 disjel sylan mulid1d eqtrd ex con2d imp mulid2d prodeq2dv 3eqtr2rd
      jaodan ) ABDFKZCDFKZLMEFUAZBNZDOUBZFKZEWCCNZDOUBZFKZLMEWEWHLMZFKEDFKAWAWF
      WBWILAWABWEFKWFBWEDFWDDOUCZUFABEWEFABCUDZBEBCUGHUEZAWDPZWEDQWDWEDRAWKSZAW
      DWCENZDQNZABEWCWMUHJUIZUJWCEBUKNZWEORZAWSWDULZWTWCEBUMWDDOUNZTSIUOUQAWBCW
      HFKWICWHDFWGDOUCZUFACEWHFAWLCECBUPHUEZAWGPZWHDQWGWHDRAXCSZAWGWPWQACEWCXDU
      HJUIZUJWCECUKNZWHORZAXHWGULZXIWCECUMWGDOUNZTSIUOUQURAEWEWHFIAWPPZWQOQNZWE
      QNJUSWDDOQUTVAXLWQXMWHQNJUSWGDOQUTVAVBAEWJDFAWPWDWGVCZWJDRZAWPXNAWPWCWLNX
      NAEWLWCHVDWCBCVEVFVGAWDXOWGWNWJDOLMDWNWEDWHOLWOWNXJXIABCVHVIRWDXJGBCWCVJV
      KZXKTURWNDWRVLVMXEWJODLMDXEWEOWHDLXEXAWTAWGXAAWDWGAWDXJXPVNVOVPXBTXFURXED
      XGVQVMVTUIVRVS $.
  $}

  ${
    $d B k $.  $d k ph $.  $d M k $.  $d N k $.
    fprodm1.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fprodm1.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    fprodm1.3 $e |- ( k = N -> A = B ) $.
    $( Separate out the last term in a finite product.  (Contributed by Scott
       Fenton, 16-Dec-2017.) $)
    fprodm1 $p |- ( ph -> prod_ k e. ( M ... N ) A =
       ( prod_ k e. ( M ... ( N - 1 ) ) A x. B ) ) $=
      ( cfz co cprod c1 cmul wcel wceq cuz cfv syl cc cmin csn wn caddc fzp1nel
      cin c0 cz eluzelz zcnd ax-1cn a1i npcand eleq1d disjsn sylibr cun eluzel2
      mtbii peano2zm fveq2d eleqtrrd syl2anc fzsuc2 oveq2d sneqd uneq2d 3eqtr3d
      eluzp1m1 fzfid fprodsplit wral eluzfz2 ralrimiva rspcv sylc prodsn eqtrd
      cv ) AEFJKZBDLEFMUAKZJKZBDLZFUBZBDLZNKWCCNKAWBWDBVTDAFWBOZUCWBWDUFUGPAWAM
      UDKZWBOWFEWAUEAWGFWBAFMAFAFEQRZOZFUHOGEFUISUJMTOAUKULZUMZUNUSWBFUOUPAEWGJ
      KZWBWGUBZUQZVTWBWDUQAEUHOZWAEMUAKZQROZWLWNPAWIWOGEFURSZAWPUHOZFWPMUDKZQRZ
      OWQAWOWSWREUTSAFWHXAGAWTEQAEMAEWRUJWJUMVAVBWPFVIVCEWAVDVCAWGFEJWKVEAWMWDW
      BAWGFWKVFVGVHAEFVJHVKAWECWCNAWICTOZWECPGAFVTOZBTOZDVTVLXBAWIXCGEFVMSAXDDV
      THVNXDXBDFVTDVSFPBCTIUNVOVPBCDFWHIVQVCVEVR $.
  $}

  ${
    $d B k $.  $d k ph $.  $d M k $.  $d N k $.
    fprod1p.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fprod1p.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    fprod1p.3 $e |- ( k = M -> A = B ) $.
    $( Separate out the first term in a finite product.  (Contributed by Scott
       Fenton, 24-Dec-2017.) $)
    fprod1p $p |- ( ph -> prod_ k e. ( M ... N ) A =
      ( B x. prod_ k e. ( ( M + 1 ) ... N ) A ) ) $=
      ( cfz co cprod cmul cin c0 wcel wceq syl cun cc csn caddc cuz cfv eluzfz1
      c1 cz elfzelz fzsn ineq1d clt wbr zred ltp1d fzdisj eqtr3d fzsplit uneq1d
      eqtrd fzfid fprodsplit wral ralrimiva cv eleq1d rspcv sylc prodsn syl2anc
      oveq1d ) AEFJKZBDLEUAZBDLZEUFUBKZFJKZBDLZMKCVPMKAVLVOBVKDAEEJKZVONZVLVONO
      AVQVLVOAEUGPZVQVLQAEVKPZVSAFEUCUDPVTGEFUERZEEFUHRZEUIRZUJAEVNUKULVROQAEAE
      WBUMUNEEVNFUORUPAVKVQVOSZVLVOSAVTVKWDQWAEEFUQRAVQVLVOWCURUSAEFUTHVAAVMCVP
      MAVTCTPZVMCQWAAVTBTPZDVKVBWEWAAWFDVKHVCWFWEDEVKDVDEQBCTIVEVFVGBCDEVKIVHVI
      VJUS $.
  $}


  ${
    $d B k $.  $d k ph $.  $d M k $.  $d N k $.
    fprodp1.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fprodp1.2 $e |- ( ( ph /\ k e. ( M ... ( N + 1 ) ) ) -> A e. CC ) $.
    fprodp1.3 $e |- ( k = ( N + 1 ) -> A = B ) $.
    $( Multiply in the last term in a finite product.  (Contributed by Scott
       Fenton, 24-Dec-2017.) $)
    fprodp1 $p |- ( ph -> prod_ k e. ( M ... ( N + 1 ) ) A =
     ( prod_ k e. ( M ... N ) A x. B ) ) $=
      ( c1 caddc co cfz cprod cmin cmul cuz cfv wcel syl peano2uz fprodm1 cz cc
      eluzelz zcnd ax-1cn a1i pncand oveq2d prodeq1d oveq1d eqtrd ) AEFJKLZMLBD
      NEUNJOLZMLZBDNZCPLEFMLZBDNZCPLABCDEUNAFEQRZSZUNUTSGEFUATHIUBAUQUSCPAUPURB
      DAUOFEMAFJAFAVAFUCSGEFUETUFJUDSAUGUHUIUJUKULUM $.
  $}

  ${
    $d A m $.  $d k m ph $.  $d M k m $.  $d N k m $.
    fprodm1s.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fprodm1s.2 $e |- ( ( ph /\ k e. ( M ... N ) ) -> A e. CC ) $.
    $( Separate out the last term in a finite product.  (Contributed by Scott
       Fenton, 27-Dec-2017.) $)
    fprodm1s $p |- ( ph -> prod_ k e. ( M ... N ) A =
      ( prod_ k e. ( M ... ( N - 1 ) ) A x. [_ N / k ]_ A ) ) $=
      ( vm cfz co cv csb cprod c1 cmin cmul cc wcel wral cbvprodi nfcsb1v nfel1
      ralrimiva csbeq1a eleq1d rspc mpan9 csbeq1 fprodm1 nfcv oveq1i 3eqtr4g
      weq ) ADEIJZCHKZBLZHMDENOJIJZUPHMZCEBLZPJUNBCMUQBCMZUSPJAUPUSHDEFABQRZCUN
      SUOUNRUPQRZAVACUNGUCVAVBCUOUNCUPQCUOBUAZUBCHUMBUPQCUOBUDZUEUFUGCUOEBUHUIU
      NBUPCHHBUJZVCVDTUTURUSPUQBUPCHVEVCVDTUKUL $.
  $}


  ${
    $d A m $.  $d k m ph $.  $d M k m $.  $d N k m $.
    fprodp1s.1 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    fprodp1s.2 $e |- ( ( ph /\ k e. ( M ... ( N + 1 ) ) ) -> A e. CC ) $.
    $( Multiply in the last term in a finite product.  (Contributed by Scott
       Fenton, 27-Dec-2017.) $)
    fprodp1s $p |- ( ph -> prod_ k e. ( M ... ( N + 1 ) ) A =
       ( prod_ k e. ( M ... N ) A x. [_ ( N + 1 ) / k ]_ A ) ) $=
      ( vm c1 caddc co cfz cv csb cprod cmul cc wcel wral cbvprodi nfel1 eleq1d
      ralrimiva nfcsb1v csbeq1a rspc mpan9 csbeq1 fprodp1 nfcv oveq1i 3eqtr4g
      weq ) ADEIJKZLKZCHMZBNZHODELKZUQHOZCUNBNZPKUOBCOURBCOZUTPKAUQUTHDEFABQRZC
      UOSUPUORUQQRZAVBCUOGUCVBVCCUPUOCUQQCUPBUDZUACHUMBUQQCUPBUEZUBUFUGCUPUNBUH
      UIUOBUQCHHBUJZVDVETVAUSUTPURBUQCHVFVDVETUKUL $.
  $}

  ${
    $d A n $.  $d k n $.  $d M k $.  $d M n $.  $d V n $.
    $( A product of the singleton is the term.  (Contributed by Scott Fenton,
       25-Dec-2017.) $)
    prodsns $p |- ( ( M e. V /\ [_ M / k ]_ A e. CC ) ->
       prod_ k e. { M } A = [_ M / k ]_ A ) $=
      ( vn wcel csb cc wa csn cprod nfcv nfcsb1v csbeq1a cbvprodi csbeq1 prodsn
      cv syl5eq ) CDFBCAGZHFICJZABKUABERZAGZEKTUAAUCBEEALBUBAMBUBANOUCTECDBUBCA
      PQS $.
  $}

  ${
    $d A k $.
    $( Factorial using product notation.  (Contributed by Scott Fenton,
       15-Dec-2017.) $)
    fprodfac $p |- ( A e. NN0 -> ( ! ` A ) = prod_ k e. ( 1 ... A ) k ) $=
      ( cn0 wcel cn cc0 wceq wo cfa cfv c1 cfz co cv cprod elnn0 cid cvv syl6eq
      c0 cmul cseq facnn wa vex fvi mp1i elnnuz biimpi cc elfznn nncnd fprodser
      cuz adantl eqtr4d prod0 fveq2 fac0 oveq2 fz10 prodeq1d 3eqtr4a jaoi sylbi
      eqcomi ) ACDAEDZAFGZHAIJZKALMZBNZBOZGZAPVGVMVHVGVIAUAQKUBJVLAUCVGVKBQKAVK
      RDVKQJVKGVGVKVJDZUDBUEVKRUFUGVGAKUNJDAUHUIVNVKUJDVGVNVKVKAUKULUOUMUPVHKTV
      KBOZVIVLVOKVKBUQVFVHVIFIJKAFIURUSSVHVJTVKBVHVJKFLMTAFKLUTVASVBVCVDVE $.
  $}

  ${
    $d A a $.  $d a k $.  $d a m $.  $d A m $.  $d a n $.  $d A n $.
    $d a ph $.  $d k m $.  $d k n $.  $d k ph $.  $d M a $.  $d M k $.
    $d M m $.  $d m n $.  $d M n $.  $d m ph $.  $d N a $.  $d N k $.
    $d N m $.  $d n ph $.  $d Z a $.  $d Z k $.  $d Z m $.  $d Z n $.
    fprodabs.1 $e |- Z = ( ZZ>= ` M ) $.
    fprodabs.2 $e |- ( ph -> N e. Z ) $.
    fprodabs.3 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    $( The absolute value of a finite product.  (Contributed by Scott Fenton,
       25-Dec-2017.) $)
    fprodabs $p |- ( ph -> ( abs ` prod_ k e. ( M ... N ) A ) =
      prod_ k e. ( M ... N ) ( abs ` A ) ) $=
      ( cfv wcel cfz co cprod cabs wceq wi prodeq1d fveq2d cc va vn syl6eleq cv
      cuz c1 caddc oveq2 eqeq12d imbi2d weq cz wa csb csbfv2g adantl fzsn simpr
      csn uzid syl6eleqr wral ralrimiva nfcsb1v nfel1 csbeq1a eleq1d rspc mpan9
      sylan2 abscld recnd eqeltrd prodsns syl2anc eqtrd 3eqtr4rd w3a cmul simp3
      expcom cvv ax-mp eqcomi a1i oveq12d elfzuz adantlr fprodp1s fzfid fprodcl
      ovex peano2uz absmuld 3adant3 3eqtr4d 3exp com12 a2d uzind4 mpcom ) EDUEJ
      ZKADELMZBCNZOJZXCBOJZCNZPZAEFXBHGUCADUAUDZLMZBCNZOJZXJXFCNZPZQADDLMZBCNZO
      JZXOXFCNZPZQADUBUDZLMZBCNZOJZYAXFCNZPZQADXTUFUGMZLMZBCNZOJZYGXFCNZPZQAXHQ
      UAUBDEXIDPZXNXSAYLXLXQXMXRYLXKXPOYLXJXOBCXIDDLUHZRSYLXJXOXFCYMRUIUJUAUBUK
      ZXNYEAYNXLYCXMYDYNXKYBOYNXJYABCXIXTDLUHZRSYNXJYAXFCYORUIUJXIYFPZXNYKAYPXL
      YIXMYJYPXKYHOYPXJYGBCXIYFDLUHZRSYPXJYGXFCYQRUIUJXIEPZXNXHAYRXLXEXMXGYRXKX
      DOYRXJXCBCXIEDLUHZRSYRXJXCXFCYSRUIUJADULKZXSAYTUMZCDXFUNZCDBUNZOJZXRXQYTU
      UBUUDPACDBULOUOUPZUUAXRDUSZXFCNZUUBUUAXOUUFXFCYTXOUUFPADUQZUPRUUAYTUUBTKU
      UGUUBPAYTURZUUAUUBUUDTUUEUUAUUDUUAUUCYTADFKZUUCTKZYTDXBFDUTGVAABTKZCFVBZU
      UJUUKAUULCFIVCZUULUUKCDFCUUCTCDBVDVECUDZDPBUUCTCDBVFVGVHVIVJZVKVLVMXFCDUL
      VNVOVPUUAXPUUCOUUAXPUUFBCNZUUCYTXPUUQPAYTXOUUFBCUUHRUPUUAYTUUKUUQUUCPUUIU
      UPBCDULVNVOVPSVQWAXTXBKZAYEYKAUURYEYKQAUURYEYKAUURYEVRZYCCYFBUNZOJZVSMZYD
      CYFXFUNZVSMZYIYJUUSYCYDUVAUVCVSAUURYEVTUVAUVCPUUSUVCUVAYFWBKUVCUVAPXTUFUG
      WLCYFBWBOUOWCWDWEWFAUURYIUVBPYEAUURUMZYIYBUUTVSMZOJUVBUVEYHUVFOUVEBCDXTAU
      URURZAUUOYGKZUULUURUVHAUUOFKZUULUVHUUOXBFUUODYFWGGVAIVJWHZWISUVEYBUUTUVEY
      ABCUVEDXTWJAUUOYAKZUULUURUVKAUVIUULUVKUUOXBFUUODXTWGGVAIVJWHWKUURAYFFKZUU
      TTKZUURYFXBFDXTWMGVAAUUMUVLUVMUUNUULUVMCYFFCUUTTCYFBVDVEUUOYFPBUUTTCYFBVF
      VGVHVIVJWNVPWOAUURYJUVDPYEUVEXFCDXTUVGUVEUVHUMZXFUVNBUVJVKVLWIWOWPWQWRWSW
      TXA $.

    $( Move the exponential function from inside a finite product to outside a
       finite sum.  (Contributed by Scott Fenton, 26-Dec-2017.) $)
    fprodefsum $p |- ( ph -> prod_ k e. ( M ... N ) ( exp ` A ) =
      ( exp ` sum_ k e. ( M ... N ) A ) ) $=
      ( vm cfz co ce cfv cprod csu wcel wceq fveq2d cc va vn cv cuz syl6eleq wi
      cmpt c1 caddc oveq2 prodeq1d sumeq1d eqeq12d imbi2d weq cz csb csn adantl
      wa fzsn simpr uzid syl6eleqr efcl syl fmptd ffvelrnda sylan2 fveq2 prodsn
      eqid syl2anc cvv fvex nfcv nfcsb1v nffv csbeq1a fvmptf sylancl sumsn wral
      3eqtrd ralrimiva nfel1 eleq1d rspc impcom syl2an fvmpts eqtr4d expcom w3a
      simp3 peano2uzs mpan9 3adant3 oveq12d elfzuz adantlr fprodp1 fsump1 fzfid
      cmul fsumcl efadd eqtrd 3eqtr4d 3exp com12 a2d eqcomi eleq2s uzind4 mpcom
      cres fzssuz sseqtr4i resmpt ax-mp fveq1i syl5reqr prodeq2i prodfc sumeq2i
      wss fvres eqtri sumfc fveq2i 3eqtr3g ) ADEKLZJUCZCFBMNZUGZNZJOZYMYNCFBUGZ
      NZJPZMNZYMYOCOZYMBCPZMNEDUDNZQAYRUUBRZAEFUUEHGUEADUAUCZKLZYQJOZUUHYTJPZMN
      ZRZUFADDKLZYQJOZUUMYTJPZMNZRZUFADUBUCZKLZYQJOZUUSYTJPZMNZRZUFZADUURUHUILZ
      KLZYQJOZUVFYTJPZMNZRZUFZAUUFUFUAUBDEUUGDRZUULUUQAUVLUUIUUNUUKUUPUVLUUHUUM
      YQJUUGDDKUJZUKUVLUUJUUOMUVLUUHUUMYTJUVMULSUMUNUAUBUOZUULUVCAUVNUUIUUTUUKU
      VBUVNUUHUUSYQJUUGUURDKUJZUKUVNUUJUVAMUVNUUHUUSYTJUVOULSUMUNUUGUVERZUULUVJ
      AUVPUUIUVGUUKUVIUVPUUHUVFYQJUUGUVEDKUJZUKUVPUUJUVHMUVPUUHUVFYTJUVQULSUMUN
      UUGERZUULUUFAUVRUUIYRUUKUUBUVRUUHYMYQJUUGEDKUJZUKUVRUUJUUAMUVRUUHYMYTJUVS
      ULSUMUNADUPQZUUQAUVTUTZUUNCDBUQZMNZUUPUWAUUNDURZYQJOZDYPNZUWCUWAUUMUWDYQJ
      UVTUUMUWDRADVAUSZUKUWAUVTUWFTQZUWEUWFRAUVTVBZUVTADFQZUWHUVTDUUEFDVCGVDZAF
      TDYPACFYOTYPACUCZFQUTBTQZYOTQIBVEVFYPVLZVGZVHVIYQUWFJDUPYNDYPVJVKVMUWAUWJ
      UWCVNQUWFUWCRUVTUWJAUWKUSZUWBMVOCDYOUWCFYPVNCDVPCUWBMCMVPZCDBVQZVRUWLDRZB
      UWBMCDBVSZSUWNVTWAWDUWAUUOUWBMUWAUUOUWDYTJPZDYSNZUWBUWAUUMUWDYTJUWGULUWAU
      VTUXBTQZUXAUXBRUWIUVTAUWJUXCUWKAFTDYSACFBTYSIYSVLZVGZVHVIYTUXBJDUPYNDYSVJ
      WBVMUWAUWJUWBTQZUXBUWBRUWPAUWMCFWCZUWJUXFUVTAUWMCFIWEZUWKUWJUXGUXFUWMUXFC
      DFCUWBTUWRWFUWSBUWBTUWTWGWHWIWJCDBFYSTUXDWKVMWDSWLWMUVDUVKUFUURFUUEUURFQZ
      AUVCUVJAUXIUVCUVJUFAUXIUVCUVJAUXIUVCWNZUUTUVEYPNZXELZUVBUVEYSNZMNZXELZUVG
      UVIUXJUUTUVBUXKUXNXEAUXIUVCWOAUXIUXKUXNRZUVCUXIAUVEFQZUXPDUURFGWPZAUXQUTZ
      UXKCUVEBUQZMNZUXNUXSUXQUYATQZUXKUYARAUXQVBZUXSUXTTQZUYBAUXGUXQUYDUXHUWMUY
      DCUVEFCUXTTCUVEBVQZWFUWLUVERZBUXTTCUVEBVSZWGWHWQZUXTVEVFCUVEYOUYAFYPTCUVE
      VPCUXTMUWQUYEVRUYFBUXTMUYGSUWNVTVMUXSUXMUXTMUXSUXQUYDUXMUXTRUYCUYHCUVEBFY
      STUXDWKVMSWLVIWRWSAUXIUVGUXLRUVCAUXIUTZYQUXKJDUURUYIUURFUUEAUXIVBGUEZAYNU
      VFQZYQTQZUXIUYKAYNFQZUYLUYKYNUUEFYNDUVEWTGVDZAFTYNYPUWOVHVIXAYNUVEYPVJXBW
      RAUXIUVIUXORUVCUYIUVIUVAUXMUILZMNZUXOUYIUVHUYOMUYIYTUXMJDUURUYJAUYKYTTQZU
      XIUYKAUYMUYQUYNAFTYNYSUXEVHZVIXAYNUVEYSVJXCSUYIUVATQUXMTQZUYPUXORUYIUUSYT
      JUYIDUURXDAYNUUSQZUYQUXIUYTAUYMUYQUYTYNUUEFYNDUURWTGVDUYRVIXAXFUXIAUXQUYS
      UXRAFTUVEYSUXEVHVIUVAUXMXGVMXHWRXIXJXKXLFUUEGXMXNXOXPYRYMYNCYMYOUGZNZJOUU
      CYMYQVUBJYNYMQZVUBYNYPYMXQZNYQYNVUDVUAYMFYGZVUDVUARYMUUEFDEXRGXSZCFYMYOXT
      YAYBYNYMYPYHYCYDYMYOJCYEYIUUAUUDMUUAYMYNCYMBUGZNZJPUUDYMYTVUHJVUCVUHYNYSY
      MXQZNYTYNVUIVUGVUEVUIVUGRVUFCFYMBXTYAYBYNYMYSYHYCYFYMBJCYJYIYKYL $.
  $}

  ${
    $d A a $.  $d a k $.  $d a m $.  $d A m $.  $d a ph $.  $d K a $.
    $d K k $.  $d k m $.  $d k ph $.  $d M a $.  $d M k $.  $d M m $.
    $d m ph $.  $d N a $.  $d N k $.  $d N m $.  $d Z k $.
    fprodeq0.1 $e |- Z = ( ZZ>= ` M ) $.
    fprodeq0.2 $e |- ( ph -> N e. Z ) $.
    fprodeq0.3 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    fprodeq0.4 $e |- ( ( ph /\ k = N ) -> A = 0 ) $.
    $( Anything finite product containing a zero term is itself zero.
       (Contributed by Scott Fenton, 27-Dec-2017.) $)
    fprodeq0 $p |- ( ( ph /\ K e. ( ZZ>= ` N ) ) ->
       prod_ k e. ( M ... K ) A = 0 ) $=
      ( cuz wcel cfz co cprod cmul cc0 syl elfzuz cfv wa caddc clt wbr cin wceq
      c1 c0 cz eluzel2 adantl zred ltp1d fzdisj cun w3a cle eleq2s eluzelz 3jca
      adantr eluzle anim12i elfz2 sylanbrc fzsplit fzfid cv cc syl6eleqr sylan2
      adantlr fprodsplit cmin csb syl6eleq fprodm1s csbied oveq2d mul01d 3eqtrd
      fprodcl oveq1d peano2uzs uztrn2 syl2an adantrl syldan anassrs mul02d ) AD
      FLUAMZUBZEDNOZBCPEFNOZBCPZFUHUCOZDNOZBCPZQORWSQORWMWOWRBWNCWMFWQUDUEWOWRU
      FUIUGWMFWMFWLFUJMZAFDUKULZUMUNEFWQDUOSWMFWNMZWNWOWRUPUGWMEUJMZDUJMZWTUQEF
      URUEZFDURUEZUBXBWMXCXDWTAXCWLAFGMZXCIXCFELUAZGEFUKHUSSVBWLXDAFDUTULXAVAAX
      EWLXFAXGXEIXEFXHGEFVCHUSSFDVCVDFEDVEVFFEDVGSWMEDVHACVIZWNMZBVJMZWLXJAXIGM
      ZXKXJXIXHGXIEDTHVKJVLVMVNWMWPRWSQAWPRUGWLAWPEFUHVOOZNOZBCPZCFBVPZQOXORQOR
      ABCEFAFGXHIHVQXIWOMZAXLXKXQXIXHGXIEFTHVKJVLVRAXPRXOQACFBRGIKVSVTAXOAXNBCA
      EXMVHXIXNMZAXLXKXRXIXHGXIEXMTHVKJVLWCWAWBVBWDWMWSWMWRBCWMWQDVHAWLXIWRMZXK
      AWLXSUBXLXKAXSXLWLAWQGMZXIWQLUAMXLXSAXGXTIEFGHWESXIWQDTEXIWQGHWFWGWHJWIWJ
      WCWKWB $.
  $}


  ${
    $d A k $.  $d B j $.  $d j k $.  $d j ph $.  $d K j $.  $d K k $.
    $d k ph $.  $d M j $.  $d M k $.  $d N j $.  $d N k $.
    fprodshft.1 $e |- ( ph -> K e. ZZ ) $.
    fprodshft.2 $e |- ( ph -> M e. ZZ ) $.
    fprodshft.3 $e |- ( ph -> N e. ZZ ) $.
    fprodshft.4 $e |- ( ( ph /\ j e. ( M ... N ) ) -> A e. CC ) $.
    ${
      fprodshft.5 $e |- ( j = ( k - K ) -> A = B ) $.
      $( Shift the index of a finite product.  (Contributed by Scott Fenton,
         5-Jan-2018.) $)
      fprodshft $p |- ( ph ->
      prod_ j e. ( M ... N ) A = prod_ k e. ( ( M + K ) ... ( N + K ) ) B ) $=
        ( co caddc cmin wcel wceq adantr cz cfz cv cmpt wfn ccnv wf1o ovex eqid
        fzfid fnmpti a1i wa copab oveq1 ad2antll elfzelz ad2antrl npcand eqtr2d
        zcnd simprl eqeltrrd simprr zsubcld eqeltrd fzaddel syl22anc mpbird jca
        cc wb mpbid pncand impbida opabbidv df-mpt cnveqi cnvopab eqtri 3eqtr4g
        fneq1d mpbiri dff1o4 sylanbrc cfv fvmpt adantl fprodf1o ) AGHUANZBGFONZ
        HFONZUANZCDEDWLDUBZFPNZUCZEUBZFPNZMAWJWKUIAWOWLUDZWOUEZWIUDZWLWIWOUFWRA
        DWLWNWOWMFPUGWOUHZUJUKAWTEWIWPFONZUCZWIUDEWIXBXCWPFOUGXCUHUJAWIWSXCAWMW
        LQZWPWNRZULZEDUMZWPWIQZWMXBRZULZEDUMWSXCAXFXJEDAXFXJAXFULZXHXIXKXHXBWLQ
        ZXKWMXBWLXKXBWNFONZWMXEXBXMRAXDWPWNFOUNUOXKWMFXDWMVJQAXEXDWMWMWJWKUPZUT
        UQAFVJQZXFAFIUTZSURUSZAXDXEVAVBXKGTQZHTQZWPTQZFTQZXHXLVKZAXRXFJSAXSXFKS
        XKWPWNTAXDXEVCXKWMFXDWMTQAXEXNUQAYAXFISZVDVEYCWPFGHVFZVGVHXQVIAXJULZXDX
        EYEWMXBWLAXHXIVCYEXHXLAXHXIVAYEXRXSXTYAYBAXRXJJSAXSXJKSXHXTAXIWPGHUPZUQ
        AYAXJISYDVGVLVEYEWNXBFPNZWPXIWNYGRAXHWMXBFPUNUOYEWPFXHWPVJQAXIXHWPYFUTU
        QAXOXJXPSVMUSVIVNVOWSXFDEUMZUEXGWOYHDEWLWNVPVQXFDEVRVSEDWIXBVPVTWAWBWLW
        IWOWCWDWPWLQWPWOWEWQRADWPWNWQWLWOWMWPFPUNXAWPFPUGWFWGLWH $.
    $}

    fprodrev.5 $e |- ( j = ( K - k ) -> A = B ) $.
    $( Reversal of a finite product.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    fprodrev $p |- ( ph -> prod_ j e. ( M ... N ) A =
      prod_ k e. ( ( K - N ) ... ( K - M ) ) B ) $=
      ( co cmin wcel wceq wa cz adantr cfz cmpt fzfid wfn ccnv wf1o ovex fnmpti
      cv eqid copab simprr simprl elfzelz ad2antrl fzrev syl22anc mpbid eqeltrd
      a1i wb oveq2 ad2antll cc nncand eqtr2d jca fzrev2 impbida opabbidv df-mpt
      zcnd cnveqi cnvopab eqtri 3eqtr4g fneq1d mpbiri dff1o4 sylanbrc cfv fvmpt
      adantl fprodf1o ) AGHUANZBFHONZFGONZUANZCDEDWHFDUIZONZUBZFEUIZONZMAWFWGUC
      AWKWHUDZWKUEZWEUDZWHWEWKUFWNADWHWJWKFWIOUGWKUJZUHUTAWPEWEWMUBZWEUDEWEWMWR
      FWLOUGZWRUJUHAWEWOWRAWIWHPZWLWJQZRZEDUKZWLWEPZWIWMQZRZEDUKWOWRAXBXFEDAXBX
      FAXBRZXDXEXGWLWJWEAWTXAULXGWTWJWEPZAWTXAUMXGGSPZHSPZFSPZWISPZWTXHVAAXIXBJ
      TAXJXBKTAXKXBITWTXLAXAWIWFWGUNZUOFWIGHUPUQURUSXGWMFWJONZWIXAWMXNQAWTWLWJF
      OVBVCXGFWIAFVDPZXBAFIVLZTWTWIVDPAXAWTWIXMVLUOVEVFVGAXFRZWTXAXQWIWMWHAXDXE
      ULXQXDWMWHPZAXDXEUMXQXIXJXKWLSPZXDXRVAAXIXFJTAXJXFKTAXKXFITXDXSAXEWLGHUNZ
      UOFWLGHVHUQURUSXQWJFWMONZWLXEWJYAQAXDWIWMFOVBVCXQFWLAXOXFXPTXDWLVDPAXEXDW
      LXTVLUOVEVFVGVIVJWOXBDEUKZUEXCWKYBDEWHWJVKVMXBDEVNVOEDWEWMVKVPVQVRWHWEWKV
      SVTWLWHPWLWKWAWMQADWLWJWMWHWKWIWLFOVBWQWSWBWCLWD $.
  $}

  ${
    $d A f k n $.  $d B f k n $.
    $( The product of constant terms ( ` k ` is not free in ` B ` .)
       (Contributed by Scott Fenton, 12-Jan-2018.) $)
    fprodconst $p |- ( ( A e. Fin /\ B e. CC ) ->
       prod_ k e. A B = ( B ^ ( # ` A ) ) ) $=
      ( vf vn wcel cc wa c0 wceq cprod chash cfv cexp co cn c1 cv cc0 syl6eq wi
      cfn cfz wf1o wex exp0 eqcomd prodeq1 prod0 fveq2 hash0 eqeq12d syl5ibrcom
      oveq2d adantl cmul csn cseq eqidd simprl simprr simpllr fvconst2g syl2anc
      cxp elfznn fprod expnnval ad2ant2lr eqtr4d expr exlimdv expimpd wo fz1f1o
      adantr mpjaod ) AUBFZBGFZHZAIJZABCKZBALMZNOZJZWCPFZQWCUCOZADRZUDZDUEZHZVS
      WAWEUAVRVSWEWAQBSNOZJVSWLQBUFUGWAWBQWDWLWAWBIBCKQAIBCUHBCUITWAWCSBNWAWCIL
      MSAILUJUKTUNULUMUOVTWFWJWEVTWFHWIWEDVTWFWIWEVTWFWIHZHZWBWCUPPBUQVEZQURMZW
      DWNABBCEWHWOWCCRZERZWHMJBUSVTWFWIUTVTWFWIVAVRVSWMWQAFVBWNWRWGFZHVSWRPFZWR
      WOMBJVRVSWMWSVBWSWTWNWRWCVFUOPBWRGVCVDVGVSWFWDWPJVRWIBWCVHVIVJVKVLVMVRWAW
      KVNVSADVOVPVQ $.
  $}

  ${
    $d A f $.  $d A k $.  $d A m $.  $d A n $.  $d B f $.  $d B m $.  $d B n $.
    $d f k $.  $d f m $.  $d f n $.  $d f ph $.  $d k m $.  $d k n $.
    $d k ph $.  $d m n $.  $d m ph $.  $d n ph $.
    fprodn0.1 $e |- ( ph -> A e. Fin ) $.
    fprodn0.2 $e |- ( ( ph /\ k e. A ) -> B e. CC ) $.
    fprodn0.3 $e |- ( ( ph /\ k e. A ) -> B =/= 0 ) $.
    $( A finite product of non-zero terms is non-zero.  (Contributed by Scott
       Fenton, 15-Jan-2018.) $)
    fprodn0 $p |- ( ph -> prod_ k e. A B =/= 0 ) $=
      ( vf vm wceq cc0 wne cfv wcel c1 cv wa wi eqnetrd cc vn c0 cprod chash cn
      cfz wf1o wex prodeq1 prod0 syl6eq ax-1ne0 a1i cmul cmpt ccom prodfc fveq2
      co cseq simprl simprr wf eqid fmptd adantr ffvelrnda f1of syl fvco3 sylan
      fprod syl5eqr cuz nnuz syl6eleq fco syl2anc adantll csb simpr nfv nfcsb1v
      nfcv nfim csbeq1a eleq1d imbi2d expcom vtoclgaf impcom fvmpts nfne neeq1d
      nfel1 sylan2 anassrs prodfn0 expr exlimdv expimpd cfn wo fz1f1o mpjaod )
      ABUBJZBCDUCZKLZBUDMZUENZOXIUFUSZBHPZUGZHUHZQZXFXHRAXFXGOKXFXGUBCDUCOBUBCD
      UICDUJUKOKLXFULUMSUMAXJXNXHAXJQXMXHHAXJXMXHAXJXMQZQZXGXIUNDBCUOZXLUPZOUTM
      ZKXQXGBIPZXRMZIUCXTBCIDUQXQBYBUAPZXLMZXRMZIUAXLXSXIYAYDXRURAXJXMVAZAXJXMV
      BZXQBTYAXRABTXRVCZXPADBCTXRFXRVDZVEVFZVGXQXKBXLVCZYCXKNYCXSMYEJXQXMYKYGXK
      BXLVHZVIZXKBYCXRXLVJVKVLVMXQIXSOXIXQXIUEOVNMYFVOVPXQXKTYAXSXQYHYKXKTXSVCY
      JYMXKBTXRXLVQVRVGXQYAXKNZQYAXSMZYAXLMZXRMZKXQYKYNYOYQJYMXKBYAXRXLVJVKAXPY
      NYQKLZXPYNQAYPBNZYRXMYNYSXJXMXKBYAXLYLVGVSAYSQZYQDYPCVTZKYTYSUUATNZYQUUAJ
      AYSWAYSAUUBACTNZRAUUBRDYPBDYPWDZAUUBDADWBZDUUATDYPCWCZWOWEDPZYPJZUUCUUBAU
      UHCUUATDYPCWFZWGWHAUUGBNZUUCFWIWJWKDYPCBXRTYIWLVRYSAUUAKLZACKLZRAUUKRDYPB
      UUDAUUKDUUEDUUAKUUFDKWDWMWEUUHUULUUKAUUHCUUAKUUIWNWHAUUJUULGWIWJWKSWPWQSW
      RSWSWTXAABXBNXFXOXCEBHXDVIXE $.
  $}

  ${
    fprod2d.1 $e |- ( z = <. j , k >. -> D = C ) $.
    fprod2d.2 $e |- ( ph -> A e. Fin ) $.
    fprod2d.3 $e |- ( ( ph /\ j e. A ) -> B e. Fin ) $.
    fprod2d.4 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> C e. CC ) $.

    ${
      $d A j $.  $d A k $.  $d A m $.  $d B k $.  $d B m $.  $d B z $.
      $d C m $.  $d C z $.  $d D j $.  $d D k $.  $d D m $.  $d j k $.
      $d j m $.  $d j ph $.  $d j x $.  $d j y $.  $d j z $.  $d k m $.
      $d k ph $.  $d k x $.  $d k y $.  $d k z $.  $d m ph $.  $d m x $.
      $d m y $.  $d m z $.  $d ph z $.  $d x z $.  $d y z $.
      fprod2d.5 $e |- ( ph -> -. y e. x ) $.
      fprod2d.6 $e |- ( ph -> ( x u. { y } ) C_ A ) $.
      fprod2d.7 $e |- ( ps <-> prod_ j e. x prod_ k e. B C =
                             prod_ z e. U_ j e. x ( { j } X. B ) D ) $.
      $( Lemma for ~ fprod2d - induction step.  (Contributed by Scott Fenton,
         30-Jan-2018.) $)
      fprod2dlem $p |- ( ( ph /\ ps ) ->
                        prod_ j e. ( x u. { y } ) prod_ k e. B C =
                        prod_ z e. U_ j e. ( x u. { y } ) ( { j } X. B ) D ) $=
        ( vm wcel wa cv cprod csn cmul co cxp ciun csb wceq simpr sylib nfcsb1v
        cun nfcv nfcprod weq csbeq1a adantr prodeq12dv cbvprodi wss unssbd snss
        cc vex sylibr cfn wral ralrimiva nfel1 eleq1d rspc ralrimivva raleqbidv
        sylc nfral r19.21bi fprodcl csbeq1 prodsn syl2anc c2nd cfv cres sylancr
        snfi xpfi wf1o 2ndconst syl fvres mpan9 fprodf1o cop wex elxp nfv nfcri
        adantl nfan nfex opeq1 eqeq2d eleq1 syl6bb anbi1d eleq2d pm5.32i bicomi
        elsn anbi12d exbidv cbvex bitri nfcsb nfeq2 ad2antlr fveq2 op2nd exlimd
        ad2antrl syl6req syl5bi imp syl5eq eqtrd wel cin syldan fprodsplit wrex
        c0 eliun xp1st elsni elin sneq xpeq12d eqtri 3eqtrd expl eqtr4d oveq12d
        prodeq2dv wn disjsn eqidd ssfi sselda anassrs c1st biimprd impcom sylbi
        rexlimiva anim12i 3imtr4i noel syl6bi syl5 ssrdv ss0 iunxun nfxp cbviun
        pm2.21i iunxsn uneq2i a1i simprl simprrl opeq1d simpll simprrr syl12anc
        iunfi eqeltrd ex exlimdvv rexlimdva 3eqtr4d ) ABUAZCUBZGHKUCZJUCZDUBZUD
        ZUWEJUCZUEUFZJUWDJUBZUDZGUGZUHZIEUCZUWHJUWGGUIZUGZIEUCZUEUFZUWDUWHUNZUW
        EJUCZJUWTUWMUHZIEUCZUWCUWFUWOUWIUWRUEUWCBUWFUWOUJABUKRULAUWIUWRUJBAUWIU
        WHJSUBZGUIZJUXDHUIZKUCZSUCZUWRUWHUWEUXGJSSUWEUOJUXEUXFKJUXDGUMZJUXDHUMU
        PJSUQZGUXEHUXFKJUXDGURZUXJHUXFUJKUBZGTZJUXDHURUSUTVAAUXHUWPJUWGHUIZKUCZ
        UWRAUWGFTZUXOVETUXHUXOUJAUWHFVBUXPAUWDUWHFQVCUWGFDVFZVDVGZAUWPUXNKAUXPG
        VHTZJFVIUWPVHTZUXRAUXSJFNVJUXSUXTJUWGFJUWPVHJUWGGUMZVKJDUQZGUWPVHJUWGGU
        RZVLVMVPZAUXNVETZKUWPAUXPHVETZKGVIZJFVIUYEKUWPVIZUXRAUYFJKFGOVNUYGUYHJU
        WGFUYEJKUWPUYAJUXNVEJUWGHUMZVKVQUYBUYFUYEKGUWPUYCUYBHUXNVEJUWGHURZVLVOV
        MVPZVRVSUXGUXOSUWGFSDUQZUXEUWPUXFUXNKJUXDUWGGVTZUYLUXFUXNUJUXLUXETJUXDU
        WGHVTUSUTWAWBAUXOUWPKUXDUXNUIZSUCZUWRUWPUXNUYNKSSUXNUOKUXDUXNUMZKUXDUXN
        URZVAAUYOUWQKEUBZWCWDZUXNUIZEUCUWRAUWPUYNUWQUYTSEWCUWQWEZUYSKUXDUYSUXNV
        TAUWHVHTUXTUWQVHTUWGWGUYDUWHUWPWHWFAUXPUWQUWPVUAWIUXRUWGUWPFWJWKUYRUWQT
        ZUYRVUAWDUYSUJAUYRUWQWCWLWTAUYHUXDUWPTUYNVETZUYKUYEVUCKUXDUWPKUYNVEUYPV
        KKSUQUXNUYNVEUYQVLVMWMWNAUWQIUYTEAVUBIUYTUJZVUBUYRUWKUXLWOZUJZUYBUXMUAZ
        UAZKWPZJWPZAVUDVUBUYRUXDUXLWOZUJZUXDUWHTZUXLUWPTZUAZUAZKWPZSWPVUJSKUYRU
        WHUWPWQVUQVUISJVUPJKVULVUOJVULJWRVUMVUNJVUMJWRJKUWPUYAWSXAXAXBVUISWRSJU
        QZVUPVUHKVURVULVUFVUOVUGVURVUKVUEUYRUXDUWKUXLXCXDVURVUOUYBVUNUAZVUGVURV
        UMUYBVUNVURVUMUWKUWHTUYBUXDUWKUWHXEJUWGXKXFXGVUGVUSUYBUXMVUNUYBGUWPUXLU
        YCXHXIXJXFXLXMXNXOAVUIVUDJAJWRJIUYTJKUYSUXNJUYSUOUYIXPXQAVUHVUDKAKWRKIU
        YTKUYSUXNUMXQAVUFVUGVUDAVUFUAZVUGUAZIHUXNUYTVUFIHUJZAVUGLXRUYBHUXNUJVUT
        UXMUYJYBVVAUXLUYSUJZUXNUYTUJVUFVVCAVUGVUFUYSVUEWCWDUXLUYRVUEWCXSUWKUXLJ
        VFKVFXTYCXRKUYSUXNURWKUUAUUBYAYAYDYEUUEUUCYFYGYFUSUUDAUXAUWJUJBAUWDUWHU
        WEUWTJADCYHUUFUWDUWHYIZYMUJPUWDUWGUUGVGZAUWTUUHAFVHTUWTFVBUWTVHTZMQFUWT
        UUIWBZAUWKUWTTZUWKFTZUWEVETAUWTFUWKQUUJZAVVIUAGHKNAVVIUXMUYFOUUKVSYJYKU
        SAUXCUWSUJBAUWNUWQIUXBEAUWNUWQYIZYMVBVVKYMUJAEVVKYMUYRVVKTZUYRUULWDZVVD
        TZAUYRYMTZUYRUWNTZVUBUAVVMUWDTZVVMUWHTZUAVVLVVNVVPVVQVUBVVRVVPUYRUWMTZJ
        UWDYLVVQJUYRUWDUWMYNVVSVVQJUWDVVSJCYHZVVQVVSVVQVVTVVSVVMUWKUWDVVSVVMUWL
        TVVMUWKUJUYRUWLGYOVVMUWKYPWKVLUUMUUNUUPUUOUYRUWHUWPYOUUQUYRUWNUWQYQVVMU
        WDUWHYQUURAVVNVVMYMTZVVOAVVDYMVVMVVEXHVWAVVOVVMUUSUVGUUTUVAUVBVVKUVCWKU
        XBUWNUWQUNZUJAUXBUWNJUWHUWMUHZUNVWBJUWDUWHUWMUVDVWCUWQUWNVWCSUWHUXDUDZU
        XEUGZUHUWQJSUWHUWMVWESUWMUOJVWDUXEJVWDUOUXIUVEUXJUWLVWDGUXEUWKUXDYRUXKY
        SUVFSUWGVWEUWQUXQUYLVWDUWHUXEUWPUXDUWGYRUYMYSUVHYTUVIYTUVJAVVFUWMVHTZJU
        WTVIUXBVHTVVGAVWFJUWTAVVHUAZUWLVHTUXSVWFUWKWGAVVHVVIUXSVVJNYJUWLGWHWFVJ
        JUWTUWMUVQWBAUYRUXBTZIVETZVWHVVSJUWTYLAVWIJUYRUWTUWMYNAVVSVWIJUWTVVSVUL
        UXDUWLTZUXMUAZUAZKWPSWPVWGVWISKUYRUWLGWQVWGVWLVWISKVWGVWLVWIVWGVWLUAZIH
        VEVWMVUFVVBVWMUYRVUKVUEVWGVULVWKUVKVWMUXDUWKUXLVWMVWJVURVWGVULVWJUXMUVL
        UXDUWKYPWKUVMYGLWKVWMAVVIUXMUYFAVVHVWLUVNVWGVVIVWLVVJUSVWGVULVWJUXMUVOO
        UVPUVRUVSUVTYDUWAYDYEYKUSUWB $.
    $}

    $d A j $.  $d A k $.  $d A w $.  $d A x $.  $d A y $.  $d A z $.  $d B k $.
    $d B w $.  $d B x $.  $d B y $.  $d B z $.  $d C w $.  $d C x $.  $d C y $.
    $d C z $.  $d D j $.  $d D k $.  $d D w $.  $d D x $.  $d D y $.  $d j k $.
    $d j ph $.  $d j w $.  $d j x $.  $d j y $.  $d j z $.  $d k ph $.
    $d k w $.  $d k x $.  $d k y $.  $d k z $.  $d ph w $.  $d ph x $.
    $d ph y $.  $d ph z $.  $d w x $.  $d w y $.  $d w z $.  $d x y $.
    $d x z $.  $d y z $.
    $( Write a double product as a product over a two dimensional region.
       Compare ~ fsum2d .  (Contributed by Scott Fenton, 30-Jan-2018.) $)
    fprod2d $p |- ( ph -> prod_ j e. A prod_ k e. B C =
                           prod_ z e. U_ j e. A ( { j } X. B ) D ) $=
      ( vx wss cprod cv wceq wcel wi c0 vw vy csn cxp ciun ssid cfn cun prodeq1
      sseq1 iuneq1 0iun syl6eq prodeq1d eqeq12d imbi12d imbi2d weq prod0 eqtr4i
      c1 a1i wel wn wa ssun1 sstr imim1i adantr adantlr simplr simpr fprod2dlem
      mpan cc biid exp31 a2d syl5 expcom adantl findcard2s mpcom mpi ) ACCNZCDE
      HOZGOZGCGPZUCDUDZUEZFBOZQZCUFCUGRZAWEWLSZJAUAPZCNZWOWFGOZGWOWIUEZFBOZQZSZ
      SATCNZTWFGOZTFBOZQZSZSAMPZCNZXGWFGOZGXGWIUEZFBOZQZSZSZAXGUBPUCZUHZCNZXPWF
      GOZGXPWIUEZFBOZQZSZSZAWNSUAMUBCWOTQZXAXFAYDWPXBWTXEWOTCUJYDWQXCWSXDWOTWFG
      UIYDWRTFBYDWRGTWIUETGWOTWIUKGWIULUMUNUOUPUQUAMURZXAXMAYEWPXHWTXLWOXGCUJYE
      WQXIWSXKWOXGWFGUIYEWRXJFBGWOXGWIUKUNUOUPUQWOXPQZXAYBAYFWPXQWTYAWOXPCUJYFW
      QXRWSXTWOXPWFGUIYFWRXSFBGWOXPWIUKUNUOUPUQWOCQZXAWNAYGWPWEWTWLWOCCUJYGWQWG
      WSWKWOCWFGUIYGWRWJFBGWOCWIUKUNUOUPUQXFAXEXBXCVAXDWFGUSFBUSUTVBVBUBMVCVDZX
      NYCSXGUGRYHAXMYBAYHXMYBSXMXQXLSAYHVEZYBXQXHXLXGXPNXQXHXGXOVFXGXPCVGVNVHYI
      XQXLYAYIXQXLYAYIXQVEXLMUBBCDEFGHIYIWMXQAWMYHJVIVIYIWHCRZDUGRZXQAYJYKYHKVJ
      VJYIYJHPDRVEZEVORZXQAYLYMYHLVJVJAYHXQVKYIXQVLXLVPVMVQVRVSVTVRWAWBWCWD $.
  $}

  ${
    $d A j $.  $d A k $.  $d A z $.  $d B j $.  $d B k $.  $d B z $.  $d C z $.
    $d D j $.  $d D k $.  $d j k $.  $d j ph $.  $d j z $.  $d k ph $.
    $d k z $.  $d ph z $.
    fprodxp.1 $e |- ( z = <. j , k >. -> D = C ) $.
    fprodxp.2 $e |- ( ph -> A e. Fin ) $.
    fprodxp.3 $e |- ( ph -> B e. Fin ) $.
    fprodxp.4 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> C e. CC ) $.
    $( Combine two products into a single product over the cartesian product.
       (Contributed by Scott Fenton, 1-Feb-2018.) $)
    fprodxp $p |- ( ph ->
    prod_ j e. A prod_ k e. B C = prod_ z e. ( A X. B ) D ) $=
      ( cprod cv csn cxp ciun cfn wcel adantr fprod2d iunxpconst prodeq1i
      syl6eq ) ACDEHMGMGCGNZODPQZFBMCDPZFBMABCDEFGHIJADRSUECSKTLUAUFUGFBGCDUBUC
      UD $.
  $}

  ${
    $d A x $.  $d A y $.  $d A z $.  $d B j $.  $d B k $.  $d B y $.  $d C j $.
    $d C k $.  $d D x $.  $d D y $.  $d j k $.  $d j x $.  $d j y $.  $d k x $.
    $d k y $.  $d ph x $.  $d ph y $.  $d x y $.  $d y z $.
    fprodcnv.1 $e |- ( x = <. j , k >. -> B = D ) $.
    fprodcnv.2 $e |- ( y = <. k , j >. -> C = D ) $.
    fprodcnv.3 $e |- ( ph -> A e. Fin ) $.
    fprodcnv.4 $e |- ( ph -> Rel A ) $.
    fprodcnv.5 $e |- ( ( ph /\ x e. A ) -> B e. CC ) $.
    $( Transform a product region using the converse operation.  (Contributed
       by Scott Fenton, 1-Feb-2018.) $)
    fprodcnv $p |- ( ph -> prod_ x e. A B = prod_ y e. `' A C ) $=
      ( vz ccnv cv cfv csb wceq cprod c2nd c1st csn cuni cmpt csbeq1a fvex opex
      cop nfcv csbief opeq12 csbeq1d syl5eqr csbie2 syl6eqr cfn wcel cnvfi wf1o
      wa syl wrel relcnv cnvf1o ax-mp wb dfrel2 sylib f1oeq3 1st2nd mpan fveq2d
      mpbii eleq1d ibi sneq cnveqd unieqd opswap syl6eq eqid fvmpt eqtrd adantl
      fprodf1o ancoms prodeq2i ) ADEBUADPZHCQZUBRZIWKUCRZGSSZCUAWJFCUAADEWJWNBC
      OWJOQZUDZPZUEZUFZWLWMUJZBQWTTEBWTESZWNBWTEUGHIWLWMGXAWKUBUHZWKUCUHZHQZWLT
      ZIQZWMTZVBZGBXDXFUJZESXABXIEGXDXFUIBGUKJULXHBXIWTEXDXFWLWMUMUNUOUPUQADURU
      SWJURUSLDUTVCAWJWJPZWSVAZWJDWSVAZWJVDZXKDVEZOWJVFVGAXJDTZXKXLVHADVDXOMDVI
      VJXJDWJWSVKVCVOWKWJUSZWKWSRZWTTAXPXQWMWLUJZWSRZWTXPWKXRWSXMXPWKXRTZXNWKWJ
      VLVMZVNXPXRWJUSZXSWTTXPYBXPWKXRWJYAVPVQOXRWRWTWJWSWOXRTZWRXRUDZPZUEWTYCWQ
      YEYCWPYDWOXRVRVSVTWMWLWAWBWSWCWLWMUIWDVCWEWFNWGWJFWNCXPFCXRFSZWNXPXTFYFTY
      ACXRFUGVCHIWLWMGYFXBXCXHGCXFXDUJZFSYFCYGFGXFXDUICGUKKULXHCYGXRFXGXEYGXRTX
      FXDWMWLUMWHUNUOUPUQWIUQ $.
  $}

  ${
    $d A j $.  $d A k $.  $d A m $.  $d A x $.  $d A y $.  $d A z $.  $d B k $.
    $d B m $.  $d B x $.  $d B y $.  $d B z $.  $d C j $.  $d C k $.  $d C m $.
    $d C n $.  $d C w $.  $d C x $.  $d C y $.  $d C z $.  $d D j $.  $d D m $.
    $d D n $.  $d D w $.  $d D x $.  $d D y $.  $d D z $.  $d E m $.  $d E n $.
    $d E w $.  $d E z $.  $d j k $.  $d j m $.  $d j n $.  $d j ph $.
    $d j w $.  $d j x $.  $d j y $.  $d j z $.  $d k m $.  $d k n $.
    $d k ph $.  $d k w $.  $d k x $.  $d k y $.  $d k z $.  $d m n $.
    $d m ph $.  $d m w $.  $d m z $.  $d n ph $.  $d n w $.  $d n z $.
    $d ph w $.  $d ph x $.  $d ph y $.  $d ph z $.  $d w z $.  $d x y $.
    $d A n $.  $d B n $.
    fprodcom2.1 $e |- ( ph -> A e. Fin ) $.
    fprodcom2.2 $e |- ( ph -> C e. Fin ) $.
    fprodcom2.3 $e |- ( ( ph /\ j e. A ) -> B e. Fin ) $.
    fprodcom2.4 $e |- ( ph ->
    ( ( j e. A /\ k e. B ) <-> ( k e. C /\ j e. D ) ) ) $.
    fprodcom2.5 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> E e. CC ) $.
    $( Interchange order of multiplication.  Note that ` B ( j ) ` and
       ` D ( k ) ` are not necessarily constant expressions.  (Contributed by
       Scott Fenton, 1-Feb-2018.) $)
    fprodcom2 $p |- ( ph -> prod_ j e. A prod_ k e. B E =
      prod_ k e. C prod_ j e. D E ) $=
      ( vm vn csb cprod wceq wcel wa vz vw vx vy cv csn cxp ciun c2nd c1st ccnv
      cfv wrel relxp rgenw reliun mpbir relcnv cop wex wb weq ancom vex 3bitr4i
      wral opth a1i anbi12d 2exbidv eliunxp opelcnv excom 3bitr4g eqrelrdv nfcv
      3bitri nfcsb1v nfxp csbeq1a xpeq12d cbviun cnveqi 3eqtr3g prodeq1d op1std
      sneq csbeq1d op2ndd csbeq2dv eqtrd cfn snfi wss adantr wrex nfcri id snid
      syl6eqelr opelxp syl6rbbr eleq2d bitrd rspce eliun sylibr adantl eleqtrrd
      biantrurd sylib simpr simpld elsni syl simpl eqeltrd rexlimiva expr ssrdv
      ssfi syl2anc sylancr ralrimiva cc ralrimivva nfel1 eleq1d raleqbidv mpan9
      xpfi rspc csbeq1 rspcv sylc fprod2d nfcprod cbvprodi prodeq12dv syl5eq wi
      iunfi mprgbir xp2nd xp1st eqcomd biimpa sylbi rexlimi nfral impr syl12anc
      syl5com fprodcnv eqtr4d 3eqtr4d nfcsb 3eqtr4g ) ABFNUEZCPZGOUEZFUUSHPZPZO
      QZNQZDGUVAEPZUVCNQZOQZBCHGQZFQDEHFQZGQANBUUSUFZUUTUGZUHZGUAUEZUIULZFUVNUJ
      ULZHPZPZUAQZODUVAUFZUVFUGZUHZGUBUEZUJULZFUWCUIULZHPZPZUBQZUVEUVHAUVSUWBUK
      ZUVRUAQUWHAUVMUWIUVRUAAFBFUEZUFZCUGZUHZGDGUEZUFZEUGZUHZUKZUVMUWIAUCUDUWMU
      WRUWMUMUWLUMZFBVFUWSFBUWKCUNUOFBUWLUPUQUWQURAUCUEZUDUEZUSZUWJUWNUSRZUWJBS
      ZUWNCSTZTZGUTFUTUXAUWTUSZUWNUWJUSRZUWNDSUWJESTZTZGUTFUTZUXBUWMSUXBUWRSZAU
      XFUXJFGAUXCUXHUXEUXIUXCUXHVAAUCFVBZUDGVBZTUXNUXMTUXCUXHUXMUXNVCUWTUXAUWJU
      WNUCVDZUDVDZVGUXAUWTUWNUWJUXPUXOVGVEVHLVIVJFGBCUXBVKUXLUXGUWQSUXJFUTGUTUX
      KUWTUXAUWQUXOUXPVLGFDEUXGVKUXJGFVMVQVNVOZFNBUWLUVLNUWLVPFUVKUUTFUVKVPFUUS
      CVRZVSFNVBZUWKUVKCUUTUWJUUSWGFUUSCVTZWAWBUWQUWBGODUWPUWAOUWPVPGUVTUVFGUVT
      VPGUVAEVRZVSGOVBZUWOUVTEUVFUWNUVAWGGUVAEVTZWAWBWCWDWEAUBUAUWBUWGUVRUVCONU
      WCUVAUUSUSZRZUWGGUVAUWFPUVCUYEGUWDUVAUWFUVAUUSUWCOVDZNVDZWFWHUYEGUVAUWFUV
      BUYEFUWEUUSHUVAUUSUWCUYFUYGWIWHWJWKZUVNUUSUVAUSZRZUVRGUVAUVQPUVCUYJGUVOUV
      AUVQUUSUVAUVNUYGUYFWIWHUYJGUVAUVQUVBUYJFUVPUUSHUUSUVAUVNUYGUYFWFWHWJWKZAD
      WLSUWAWLSZODVFUWBWLSJAUYLODAUVADSZTZUVTWLSUVFWLSZUYLUVAWMUYNBWLSZUVFBWNUY
      OAUYPUYMIWOUYNNUVFBAUYMUUSUVFSZUUSBSZAUYMUYQTZTZUYIUWLSZFBWPZUYRUYTUYIUWM
      SVUBUYTUYIUWRUWMUYSUYIUWRSZAUYSUYDUWQSZVUCUYSUYDUWPSZGDWPVUDVUEUYQGUVADGN
      UVFUYAWQUYBVUEUUSESZUYQUYBVUFUVAUWOSZVUFTVUEUYBVUGVUFUYBUVAUWNUWOUYBWRUWN
      GVDWSWTXJUVAUUSUWOEXAXBUYBEUVFUUSUYCXCXDXEGUYDDUWPXFXGUUSUVAUWQUYGUYFVLXG
      XHAUWMUWRRUYSUXQWOXIFUYIBUWLXFXKZVUAUYRFBUXDVUATZUUSUWJBVUIUUSUWKSZNFVBVU
      IVUJUVACSZVUIVUAVUJVUKTZUXDVUAXLUUSUVAUWKCXAZXKXMUUSUWJXNZXOUXDVUAXPXQXRX
      OZXSXTBUVFYAYBZUVTUVFYKYCYDODUWAUUBYBUWBUMZAVUQUWAUMZODODUWAUPVURUYMUVTUV
      FUNVHUUCVHAUWCUWBSZTZUWEGUWDEPZSZGUWDUVBPZYESZNVVAVFZUWGYESZVUTUWCUWASZOD
      WPZVVBVUTVUSVVHAVUSXLOUWCDUWAXFXKZVVGVVBODUYMVVGTZUWEUVFVVAVVGUWEUVFSUYMU
      WCUVTUVFUUDXHVVJGUWDUVAEVVJUWDUVTSZUWDUVARVVGVVKUYMUWCUVTUVFUUEXHUWDUVAXN
      XOZWHXIXRXOVUTUWDDSZUVCYESZNUVFVFZODVFZVVEVUTVVHVVMVVIVVGVVMODVVJUWDUVADV
      VLUYMVVGXPXQXRXOAVVPVUSAVVNONDUVFUYTAUYRUVAUUTSZVVNAUYSXPVUOUYTVUBVVQVUHV
      UAVVQFBFOUUTUXRWQVUAVVQUUAUXDVUAVULVVQVUMVUJVUKVVQVUJCUUTUVAVUJUXSCUUTRVU
      JUUSUWJVUNUUFUXTXOXCUUGUUHVHUUIXOAUYRVVQVVNAUYRTUVBYESZGUUTVFZVVQVVNAHYES
      ZGCVFZFBVFUYRVVSAVVTFGBCMYFVWAVVSFUUSBVVRFGUUTUXRFUVBYEFUUSHVRZYGUUJUXSVV
      TVVRGCUUTUXTUXSHUVBYEFUUSHVTZYHYIYLYJVVRVVNGUVAUUTGUVCYEGUVAUVBVRZYGUYBUV
      BUVCYEGUVAUVBVTZYHYLUUMUUKZUULZYFWOVVOVVEOUWDDUVAUWDRZVVNVVDNUVFVVAGUVAUW
      DEYMVWHUVCVVCYEGUVAUWDUVBYMYHYIYNYOVVDVVFNUWEVVAUUSUWERZVVCUWGYEVWIGUWDUV
      BUWFFUUSUWEHYMWJYHYNYOUUNUUOAUABUUTUVCUVRNOUYKIACWLSZFBVFUYRUUTWLSZAVWJFB
      KYDVWJVWKFUUSBFUUTWLUXRYGUXSCUUTWLUXTYHYLYJVWFYPAUBDUVFUVCUWGONUYHJVUPVWG
      YPUUPBUVIUVDFNNUVIVPFUUTUVCOUXRFGUVAUVBFUVAVPVWBUUQYQUXSUVICGUVAHPZOQUVDC
      HVWLGOOHVPGUVAHVRGUVAHVTYRUXSCUUTVWLUVCOUXTUXSVWLUVCRVUKUXSGUVAHUVBVWCWJW
      OYSYTYRDUVJUVGGOOUVJVPGUVFUVCNUYAVWDYQUYBUVJEUVBNQUVGEHUVBFNNHVPVWBVWCYRU
      YBEUVFUVBUVCNUYCUYBUVBUVCRVUFVWEWOYSYTYRUUR $.
  $}

  ${
    $d A j $.  $d A k $.  $d B j $.  $d B k $.  $d j k $.  $d j ph $.
    $d k ph $.
    fprodcom.1 $e |- ( ph -> A e. Fin ) $.
    fprodcom.2 $e |- ( ph -> B e. Fin ) $.
    fprodcom.3 $e |- ( ( ph /\ ( j e. A /\ k e. B ) ) -> C e. CC ) $.
    $( Interchange product order.  (Contributed by Scott Fenton,
       2-Feb-2018.) $)
    fprodcom $p |- ( ph -> prod_ j e. A prod_ k e. B C =
       prod_ k e. B prod_ j e. A C ) $=
      ( cfn wcel cv adantr wa wb ancom a1i fprodcom2 ) ABCCBEFDGHACJKELBKZHMSFL
      CKZNTSNOASTPQIR $.
  $}

  ${
    $d j k $.  $d j ph $.  $d k ph $.  $d N j $.  $d N k $.
    fprod0diag.1 $e |-
      ( ( ph /\ ( j e. ( 0 ... N ) /\ k e. ( 0 ... ( N - j ) ) ) ) ->
      A e. CC ) $.
    $( Two ways to express "the product of ` A ( j , k ) ` over the the
       triangular region ` M <_ j ` , ` M <_ k ` , ` j + k <_ N ` .  Compare
       ~ fsum0diag .  (Contributed by Scott Fenton, 2-Feb-2018.) $)
    fprod0diag $p |- ( ph ->
      prod_ j e. ( 0 ... N ) prod_ k e. ( 0 ... ( N - j ) ) A =
      prod_ k e. ( 0 ... N ) prod_ j e. ( 0 ... ( N - k ) ) A ) $=
      ( cc0 cfz co cv cmin fzfid wcel wa wb fsum0diaglem impbii a1i fprodcom2 )
      AGEHIZGECJZKIZHIZTGEDJZKIHIZCDBAGELZUFAUATMZNGUBLUGUDUCMNZUDTMUAUEMNZOAUH
      UICDEPDCEPQRFS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Infinite products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    iprodclim.1 $e |- Z = ( ZZ>= ` M ) $.
    iprodclim.2 $e |- ( ph -> M e. ZZ ) $.
    iprodclim.3 $e |- ( ph -> E. n e. Z E. y ( y =/= 0 /\
      seq n ( x. , F ) ~~> y ) ) $.
    iprodclim.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    iprodclim.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    ${
      $d A n $.  $d A y $.  $d F k $.  $d k n $.  $d k ph $.  $d k y $.
      $d M k $.  $d M y $.  $d n ph $.  $d n y $.  $d ph y $.  $d Z k $.
      $d Z n $.  $d Z y $.
      iprodclim.6 $e |- ( ph -> seq M ( x. , F ) ~~> B ) $.
      $( An infinite product equals the value its sequence converges to.
         (Contributed by Scott Fenton, 18-Dec-2017.) $)
      iprodclim $p |- ( ph -> prod_ k e. Z A = B ) $=
        ( cprod cmul cseq cli cc cfv iprod wfun wbr wceq cdm fclim ffun funbrfv
        wf ax-mp mpsyl eqtrd ) AICEPQGHRZSUAZDABCEFGHIJKLMNUBSUCZAUNDSUDUODUESU
        FZTSUJUPUGUQTSUHUKOUNDSUIULUM $.
    $}

    $d A n $.  $d A y $.  $d F k $.  $d k n $.  $d k ph $.  $d k y $.
    $d M k $.  $d M y $.  $d n ph $.  $d n y $.  $d ph y $.  $d Z k $.
    $d Z n $.  $d Z y $.  $d F n $.  $d F y $.  $d M n $.
    $( A converging product converges to its infinite product.  (Contributed by
       Scott Fenton, 18-Dec-2017.) $)
    iprodclim2 $p |- ( ph -> seq M ( x. , F ) ~~> prod_ k e. Z A ) $=
      ( cmul cseq cli cfv cprod cdm wcel cv wa cc eqeltrd ntrivcvg climdm sylib
      wbr iprod breqtrrd ) ANFGOZUKPQZHCDRPAUKPSTUKULPUHABDEFGHIKADUAZHTUBUMFQC
      UCLMUDUEUKUFUGABCDEFGHIJKLMUIUJ $.
  $}

  ${
    $d A j $.  $d A m $.  $d A n $.  $d A x $.  $d A y $.  $d F j $.  $d F x $.
    $d j k $.  $d j ph $.  $d j x $.  $d k m $.  $d k n $.  $d k ph $.
    $d k x $.  $d k y $.  $d M j $.  $d M m $.  $d m n $.  $d m ph $.
    $d M x $.  $d m y $.  $d M y $.  $d n ph $.  $d n y $.  $d ph x $.
    $d ph y $.  $d Z j $.  $d Z k $.  $d Z m $.  $d Z n $.  $d Z x $.
    $d Z y $.  $d j m $.  $d M k $.
    iprodclim3.1 $e |- Z = ( ZZ>= ` M ) $.
    iprodclim3.2 $e |- ( ph -> M e. ZZ ) $.
    iprodclim3.3 $e |- ( ph -> E. n e. Z E. y ( y =/= 0 /\
      seq n ( x. , ( k e. Z |-> A ) ) ~~> y ) ) $.
    iprodclim3.4 $e |- ( ph -> F e. dom ~~> ) $.
    iprodclim3.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    iprodclim3.6 $e |- ( ( ph /\ j e. Z ) ->
                        ( F ` j ) = prod_ k e. ( M ... j ) A ) $.
    $( The sequence of partial finite product of a converging infinite product
       converge to the infinite product of the series.  Note that ` j ` must
       not occur in ` A ` .  (Contributed by Scott Fenton, 18-Dec-2017.) $)
    iprodclim3 $p |- ( ph -> F ~~> prod_ k e. Z A ) $=
      ( vm vx cli cfv wcel cprod cdm wbr climdm sylib cmul cmpt cv prodfc eqidd
      cseq wa eqid fmptd ffvelrnda iprod syl5eqr cio cvv seqex a1i cfz cres wss
      cc co wceq cuz fzssuz sseqtr4i resmpt ax-mp fvres syl5reqr prodeq2i eqtri
      fveq1i simpr syl6eleq elfzuz syl6eleqr sylan2 adantlr eqtr2d climeq df-fv
      fprodser iotabidv 3eqtr4g eqtrd breqtrrd ) AGGRSZICEUAZRAGRUBZTGWLRUCMGUD
      UEAWMUFEICUGZHUKZRSZWLAWMIPUHZWOSZPUAWQICPEUIABWSPFWOHIJKLAWRITZULWSUJAIV
      EWRWOAEICVEWONWOUMUNUOZUPUQAWPQUHZRUCZQURGXBRUCZQURWQWLAXCXDQAXBDWPGHUSWN
      IJWPUSTAUFWOHUTVAMKADUHZITZULZXEGSHXEVBVFZCEUAZXEWPSZOXGXIXHWSPUAZXJXKXHW
      REXHCUGZSZPUAXIXHWSXMPWRXHTZXMWRWOXHVCZSWSWRXOXLXHIVDXOXLVGXHHVHSZIHXEVIJ
      VJEIXHCVKVLVQWRXHWOVMVNVOXHCPEUIVPXGWSPWOHXEXGXNULWSUJXGXEIXPAXFVRJVSAXNW
      SVETZXFXNAWTXQXNWRXPIWRHXEVTJWAXAWBWCWGUQWDWEWHQWPRWFQGRWFWIWJWK $.
  $}

  ${
    iprodcl.1 $e |- Z = ( ZZ>= ` M ) $.
    iprodcl.2 $e |- ( ph -> M e. ZZ ) $.
    iprodcl.3 $e |- ( ph -> E. n e. Z E. y ( y =/= 0 /\
      seq n ( x. , F ) ~~> y ) ) $.
    iprodcl.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.

    ${
      $d A n $.  $d A y $.  $d F k $.  $d F n $.  $d F y $.  $d k n $.
      $d k ph $.  $d k y $.  $d M k $.  $d M n $.  $d M y $.  $d n ph $.
      $d n y $.  $d ph y $.  $d Z k $.  $d Z n $.  $d Z y $.
      iprodcl.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
      $( The product of a non-trivially converging infinite sequence is a
         complex number.  (Contributed by Scott Fenton, 18-Dec-2017.) $)
      iprodcl $p |- ( ph -> prod_ k e. Z A e. CC ) $=
        ( cprod cmul cli cfv cc wcel eqeltrd cseq iprod wf fclim cv wa ntrivcvg
        cdm ffvelrn sylancr ) AHCDNOFGUAZPQZRABCDEFGHIJKLMUBAPUHZRPUCUKUMSULRSU
        DABDEFGHIKADUEZHSUFUNFQCRLMTUGUMRUKPUIUJT $.
    $}

    ${
      $d A j $.  $d A n $.  $d A y $.  $d F j $.  $d F k $.  $d F x $.
      $d j k $.  $d j ph $.  $d k n $.  $d k ph $.  $d k x $.  $d k y $.
      $d M j $.  $d M k $.  $d M x $.  $d M y $.  $d n ph $.  $d n y $.
      $d ph x $.  $d ph y $.  $d Z j $.  $d Z k $.  $d Z n $.  $d Z y $.
      $d F n $.  $d F y $.  $d M n $.
      iprodrecl.5 $e |- ( ( ph /\ k e. Z ) -> A e. RR ) $.
      $( The product of a non-trivially converging infinite real sequence is a
         real number.  (Contributed by Scott Fenton, 18-Dec-2017.) $)
      iprodrecl $p |- ( ph -> prod_ k e. Z A e. RR ) $=
        ( vj vx cmul cv wcel wa cr cprod cseq iprodclim2 cfv eqeltrd co remulcl
        recnd adantl seqf ffvelrnda climrecl ) AHCDUANPFGUBZGHIJABCDEFGHIJKLADQ
        ZHRSZCMUHUCAHTNQUMADOPTFGHIJUOUNFUDCTLMUEUNTROQZTRSUNUPPUFTRAUNUPUGUIUJ
        UKUL $.
    $}
  $}

  ${
    $d A j $.  $d a k $.  $d a m $.  $d a n $.  $d A n $.  $d A p $.  $d A w $.
    $d a y $.  $d A y $.  $d a z $.  $d B j $.  $d B m $.  $d B p $.  $d B w $.
    $d B z $.  $d F a $.  $d F j $.  $d F k $.  $d F m $.  $d F n $.  $d F x $.
    $d F y $.  $d F z $.  $d G a $.  $d G j $.  $d G k $.  $d G m $.  $d G n $.
    $d G x $.  $d G y $.  $d G z $.  $d j k $.  $d j m $.  $d j ph $.
    $d k m $.  $d k n $.  $d k p $.  $d k ph $.  $d k w $.  $d k x $.
    $d k y $.  $d k z $.  $d M j $.  $d M k $.  $d M m $.  $d m n $.  $d M n $.
    $d m p $.  $d m ph $.  $d m w $.  $d M w $.  $d M x $.  $d m y $.
    $d M y $.  $d m z $.  $d M z $.  $d n p $.  $d n ph $.  $d n w $.
    $d n y $.  $d n z $.  $d p ph $.  $d p w $.  $d p y $.  $d p z $.
    $d ph w $.  $d ph x $.  $d ph y $.  $d ph z $.  $d w y $.  $d w z $.
    $d y z $.  $d Z a $.  $d Z j $.  $d Z k $.  $d Z m $.  $d Z n $.  $d Z p $.
    $d Z w $.  $d Z y $.  $d Z z $.  $d a p $.  $d a w $.  $d F p $.  $d F w $.
    $d G p $.  $d G w $.
    iprodmul.1 $e |- Z = ( ZZ>= ` M ) $.
    iprodmul.2 $e |- ( ph -> M e. ZZ ) $.
    iprodmul.3 $e |- ( ph -> E. n e. Z E. y ( y =/= 0 /\
      seq n ( x. , F ) ~~> y ) ) $.
    iprodmul.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    iprodmul.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    iprodmul.6 $e |- ( ph -> E. m e. Z E. z ( z =/= 0 /\
      seq m ( x. , G ) ~~> z ) ) $.
    iprodmul.7 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = B ) $.
    iprodmul.8 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
    $( Multiplication of infinite sums.  (Contributed by Scott Fenton,
       18-Dec-2017.) $)
    iprodmul $p |- ( ph -> prod_ k e. Z ( A x. B ) =
     ( prod_ k e. Z A x. prod_ k e. Z B ) ) $=
      ( vw vp va vj cmul co cprod cv cfv cmpt cc0 wne cseq cli wbr wa wrex wcel
      wex cc eqeltrd wceq weq fveq2 oveq12d eqid ovex fvmpt ntrivcvgmul cbvmptv
      adantl seqeq3 ax-mp breq1i anbi2i exbii rexbii sylibr simpr mulcld fvmptg
      syl2anc eqtrd cvv iprodclim2 seqex a1i prodf ffvelrnda syl6eleq syl6eleqr
      cuz cfz elfzuz sylan2 adantlr prodfmul climmul iprodclim ) AUADEUEUFZLDFU
      GZLEFUGZUEUFFUBGLGUHZIUIZXCJUIZUEUFZUJZKLMNAUAUHZUKULZUEUCLUCUHZIUIZXJJUI
      ZUEUFZUJZUBUHZUMZXHUNUOZUPZUAUSZUBLUQXIUEXGXOUMZXHUNUOZUPZUAUSZUBLUQABCUA
      FGHIJXNKLUBMOAFUHZLURZUPZYDIUIZDUTPQVAZRYFYDJUIZEUTSTVAZYEYDXNUIYGYIUEUFZ
      VBAUCYDXMYKLXNUCFVCXKYGXLYIUEXJYDIVDXJYDJVDVEXNVFYGYIUEVGVHVKVIYCXSUBLYBX
      RUAYAXQXIXTXPXHUNXGXNVBXTXPVBGUCLXFXMGUCVCXDXKXEXLUEXCXJIVDXCXJJVDVEVJUEX
      GXNXOVLVMVNVOVPVQVRYFYDXGUIZYKWTYFYEYKUTURYLYKVBZAYEVSYFYGYIYHYJVTGYDXFYK
      LUTXGGFVCXDYGXEYIUEXCYDIVDXCYDJVDVEXGVFWAWBZYFYGDYIEUEPSVEWCYFDEQTVTAXAXB
      UDUEIKUMZUEJKUMZUEXGKUMZKWDLMNABDFHIKLMNOPQWEYQWDURAUEXGKWFWGACEFGJKLMNRS
      TWEALUTUDUHZYOAFIKLMNYHWHWIALUTYRYPAFJKLMNYJWHWIAYRLURZUPZFIJXGKYRYTYRLKW
      LUIZAYSVSMWJAYDKYRWMUFURZYGUTURZYSUUBAYEUUCUUBYDUUALYDKYRWNMWKZYHWOWPAUUB
      YIUTURZYSUUBAYEUUEUUDYJWOWPUUBYTYEYMUUDAYEYMYSYNWPWOWQWRWS $.
  $}

  $(
  @{
    @d A w x @. @d B w x @. @d C w x @. @d ph x @. @d R w x @.
    @d w z @. @d X w y @. @d x y @. @d x z @. @d X z @. @d Y w x @.
    ntrivcvgvaulem1.1 @e |- ( ( ph /\ x e. A ) ->
      E. y e. B A. z e. C Y R x ) @.
    @( Lemma for ~ ntrivcvgcau .  Specialization of a particular form
       while avoiding a distinctness requirement between ` x ` and ` X ` .
       (Contributed by Scott Fenton, 30-Dec-2017.) @)
    ntrivcvgcaulem1 @p |- ( ( ph /\ X e. A ) ->
      E. y e. B A. z e. C Y R X ) @=
      ( vw cv wbr wral wrex wcel breq2 ralbidv rexbidv ralrimiva weq sylib wceq
      cbvralv rspcv mpan9 ) AJLMZHNZDGOZCFPZLEOZIEQJIHNZDGOZCFPZAJBMZHNZDGOZCFP
      ZBEOULAUSBEKUAUSUKBLEBLUBZURUJCFUTUQUIDGUPUHJHRSTUEUCUKUOLIEUHIUDZUJUNCFV
      AUIUMDGUHIJHRSTUFUG @.
  @}

  @{
    ntrivcvgcaulem2.1 @e |- Z = ( ZZ>= `  M ) @.
    ntrivcvgcaulem2.2 @e |- ( ph -> K e. Z ) @.
    ntrivcvgcaulem2.3 @e |- ( ( ph /\ k e. Z ) -> A e. CC ) @.
    ntrivcvgcaulem2.4 @e |- ( ( ph /\ m e. ( ZZ>= ` K ) ) ->
       ( abs ` ( prod_ k e. ( K ... m ) A - 1 ) ) < ( 1 / 2 ) ) @.

    @{
      @d K k @. @d k m @. @d k ph @.
    @( Lemma for ~ ntrivcvgcau .  A product whose absolute difference
       from one is less than one half has an absolute value less than two.
       (Contributed by Scott Fenton, 30-Dec-2017.) @)
    ntrivcvgcaulem2 @p |- ( ( ph /\ m e. ( ZZ>= ` K ) ) ->
     ( abs ` prod_ k e. ( K ... m ) A ) < 2 ) @=
      ( cfv wcel co c1 caddc cabs c2 a1i cr cv cuz wa cfz cprod cmin clt elfzuz
      fzfid cc uztrn2 syl2an syldan adantlr fprodcl ax-1cn npcand fveq2d abscld
      eqeltrd subcld abs1 1re eqeltri readdcld 2re abstrid rereccli wbr halflt1
      cdiv 2ne0 lttrd ltadd1dd oveq2i df-2 3brtr4g lelttrd eqbrtrrd ) ADUAZEUBL
      ZMZUCZEVTUDNZBCUEZOUFNZOPNZQLZWEQLRUGWCWGWEQWCWEOWCWDBCWCEVTUIACUAZWDMZBU
      JMZWBAWJWIGMZWKAEGMWIWAMWLWJIWIEVTUHFWIEGHUKULJUMUNUOZOUJMWCUPSZUQZURWCWH
      WFQLZOQLZPNZRWCWGWCWGWEUJWOWMUTUSWCWPWQWCWFWCWEOWMWNVAZUSZWQTMWCWQOTVBVCV
      DSVERTMWCVFSWCWFOWSWNVGWCWPOPNOOPNWRRUGWCWPOOWTOTMWCVCSZXAWCWPORVKNZOWTXB
      TMWCRVFVLVHSXAKXBOUGVIWCVJSVMVNWQOWPPVBVOVPVQVRVS @.
    @}


    @{
      @d A m @. @d K k @. @d k m @. @d K m @. @d k ph @. @d m ph @.
    @( Lemma for ~ ntrivcvgcau .  A product whose absolute difference from
       one is less than one half has no zero values.  (Contributed
       by Scott Fenton, 30-Dec-2017.) @)
    ntrivcvgcaulem3 @p |- ( ( ph /\ k e. ( ZZ>= ` K ) ) -> A =/= 0 ) @=
      ( cfv wcel cc0 wceq co c1 cmin cabs clt cv cuz wne csb wi wa cfz cprod c2
      wral cdiv wbr fzfid elfzuz uztrn2 syl2an syldan fprodcl adantr ax-1cn a1i
      cc subcld abscld cr 2re 2ne0 rereccli ltnsymd halflt1 cneg absnegi df-neg
      fveq2i abs1 3eqtr3i breqtrri oveq1 fveq2d syl5breqr nsyl adantlr fprodm1s
      cmul simpr oveq2 sylan9eqr eqtrd mtand neneqad ralrimiva nfv nfcsb1v nfcv
      mul01d nfne weq csbeq1a neeq1d cbvral rsp sylbir syl imp ) ACUAZEUBLZMZBN
      UCZACDUAZBUDZNUCZDXFUJZXGXHUEZAXKDXFAXIXFMZUFZXJNXOXJNOZEXIUGPZBCUHZNOZXO
      QUIUKPZXRQRPZSLZTULXSXOYBXTXOYAXOXRQAXRVBMXNAXQBCAEXIUMAXEXQMZXEGMZBVBMZA
      EGMZXGYDYCIXEEXIUNFXEEGHUOZUPJUQZURUSQVBMXOUTVAVCVDXTVEMXOUIVFVGVHVAKVIXS
      XTNQRPZSLZYBTXTQYJTVJQVKZSLQSLYJQQUTVLYKYISQVMVNVOVPVQXSYAYISXRNQRVRVSVTW
      AXOXPUFXREXIQRPZUGPZBCUHZXJWDPZNXOXRYOOXPXOBCEXIAXNWEAYCYEXNYHWBWCUSXPXOY
      OYNNWDPNXJNYNWDWFXOYNXOYMBCXOEYLUMAXEYMMZYEXNAYPYDYEAYFXGYDYPIXEEYLUNYGUP
      JUQWBURWOWGWHWIWJWKXLXHCXFUJXMXHXKCDXFXHDWLCXJNCXIBWMCNWNWPCDWQBXJNCXIBWR
      WSWTXHCXFXAXBXCXD @.
    @}

    ntrivcvgcaulem4.5 @e |- ( ( ph /\ x e. RR+ ) ->
      E. n e. Z A. q e. ( ZZ>= ` n )
       ( abs ` ( prod_ k e. ( n ... q ) A - 1 ) ) < x ) @.

    ntrivcvgcaulem4 @p |- ( ( ph /\ x e. RR+ ) -> E.
      j e. ( ZZ>= ` K ) A. p e. ( ZZ>= ` j )
      ( abs ` ( prod_ k e. ( ( j + 1 ) ... p ) A - 1 ) ) < ( x / 2 ) ) @= ? @.


    @{
    @d j p @. @d j ph @. @d j x @. @d K p @. @d p ph @. @d p x @. @d A m @.
    @d j k @. @d j m @. @d K k @. @d k m @. @d K m @. @d k p @. @d k ph @.
    @d k x @. @d m ph @.

    @( Lemma for ~ ntrivcvgcau .  Translate final hypothesis into
       a Cauchy-like criterion.  (Contributed by Scott Fenton, 30-Dec-2017.) @)
    ntrivcvgcaulem5 @p |- ( ( ph /\ x e. RR+ ) ->
     E. j e. Z A. p e. ( ZZ>= ` j )
       ( abs ` ( prod_ k e. ( K ... p ) A - prod_ k e. ( K ... j ) A ) )
                 < x ) @=
      ( wcel wa co cv crp c1 caddc cfz cprod cmin cabs cfv c2 cdiv clt wbr wral
      cuz wrex ntrivcvgcaulem4 wss syl6eleq uzss syl6sseqr adantr sseld adantrd
      syl wi w3a cmul fzfid simplll simpll elfzuz uztrn2 syl2an syl2anc fprodcl
      cr cc abscld 3adant3 simpl peano2uzs ax-1cn subcld simplr rphalfcld rpred
      2re a1i cc0 cle absge0d simprl eleq1 anbi2d prodeq1d oveq1d fveq2d breq1d
      weq oveq2 imbi12d chvarv ntrivcvgcaulem2 simp3 ltmul12ad wceq c0 eluzelre
      cin ad2antrl fzdisj cun simprr elfzuzb sylanbrc fzsplit fprodsplit muls1d
      ltp1d eqtr4d absmuld eqtr2d simp1r rpcn 2cn 2ne0 divcan2d 3brtr3d anassrs
      wne 3expia ralimdva expimpd jcad reximdv2 mpd ) ABUAZUBRZSZDUAZUCUDTZLUAZ
      UETZCEUFZUCUGTZUHUIZYRUJUKTZULUMZLUUAUOUIZUNZDHUOUIZUPHUUCUETZCEUFZHUUAUE
      TZCEUFZUGTZUHUIZYRULUMZLUUJUNZDJUPABCDEFGHIJKLMNOPQUQYTUUKUUTDUULJYTUUAUU
      LRZUUKSUUAJRZUUTYTUVAUVBUUKYTUULJUUAAUULJURYSAUULIUOUIZJAHUVCRUULUVCURAHJ
      UVCNMUSIHUTVEMVAVBVCVDYTUVAUUKUUTYTUVASUUIUUSLUUJYTUVAUUCUUJRZUUIUUSVFYTU
      VAUVDSZUUIUUSYTUVEUUIVGZUUPUHUIZUUGVHTZUJUUHVHTZUURYRULUVFUVGUJUUGUUHYTUV
      EUVGVQRUUIYTUVESZUUPUVJUUOCEUVJHUUAVIUVJEUAZUUORZSAUVKJRZCVRRZAYSUVEUVLVJ
      UVJHJRZUVKUULRZUVMUVLUVJAUVOAYSUVEVKZNVEZUVKHUUAVLIUVKHJMVMZVNOVOVPZVSVTU
      JVQRUVFWHWIYTUVEUUGVQRUUIUVJUUFUVJUUEUCUVJUUDCEUVJUUBUUCVIUVJUVKUUDRZSAUV
      MUVNAYSUVEUWAVJUVJUUBJRZUVKUUBUOUIRUVMUWAUVJUVBUWBYTUVOUVAUVBUVEAUVOYSNVB
      UVAUVDWAIUUAHJMVMVNIUUAJMWBVEUVKUUBUUCVLIUVKUUBJMVMVNOVOVPZUCVRRUVJWCWIWD
      ZVSVTYTUVEUUHVQRUUIUVJUUHUVJYRAYSUVEWEWFWGVTYTUVEWJUVGWKUMUUIUVJUUPUVTWLV
      TYTUVEUVGUJULUMZUUIUVJAUVAUWEUVQYTUVAUVDWMZACEDHIJMNOAFUAZUULRZSZHUWGUETZ
      CEUFZUCUGTZUHUIZUCUJUKTZULUMZVFAUVASZUUPUCUGTZUHUIZUWNULUMZVFFDFDWTZUWIUW
      PUWOUWSUWTUWHUVAAUWGUUAUULWNWOUWTUWMUWRUWNULUWTUWLUWQUHUWTUWKUUPUCUGUWTUW
      JUUOCEUWGUUAHUEXAWPWQWRWSXBPXCXDVOVTYTUVEWJUUGWKUMUUIUVJUUFUWDWLVTYTUVEUU
      IXEXFYTUVEUVHUURXGUUIUVJUURUUPUUFVHTZUHUIUVHUVJUUQUXAUHUVJUUQUUPUUEVHTZUU
      PUGTUXAUVJUUNUXBUUPUGUVJUUOUUDCUUMEUVJUUAUUBULUMUUOUUDXJXHXGUVJUUAUVAUUAV
      QRYTUVDHUUAXIXKXTHUUAUUBUUCXLVEUVJUUAUUMRZUUMUUOUUDXMXGUVJUVAUVDUXCUWFYTU
      VAUVDXNUUAHUUCXOXPUUAHUUCXQVEUVJHUUCVIUVJUVKUUMRZSAUVMUVNAYSUVEUXDVJUVJUV
      OUVPUVMUXDUVRUVKHUUCVLUVSVNOVOXRWQUVJUUPUUEUVTUWCXSYAWRUVJUUPUUFUVTUWDYBY
      CVTUVFYSUVIYRXGAYSUVEUUIYDYSYRUJYRYEUJVRRYSYFWIUJWJYKYSYGWIYHVEYIYLYJYMYN
      YOYPYQ @.
    @}
  @}
  $)

  ${
    $d F j $.  $d F k $.  $d F n $.  $d j k $.  $d j n $.  $d j ph $.
    $d k ph $.  $d M j $.  $d M k $.  $d M n $.  $d n ph $.  $d Z k $.
    iprodefisumlem.1 $e |- Z = ( ZZ>= ` M ) $.
    iprodefisumlem.2 $e |- ( ph -> M e. ZZ ) $.
    iprodefisumlem.3 $e |- ( ph -> F : Z --> CC ) $.
    $( Lemma for ~ iprodefisum .  (Contributed by Scott Fenton,
       11-Feb-2018.) $)
    iprodefisumlem $p |- ( ph -> seq M ( x. , ( exp o. F ) ) =
       ( exp o. seq M ( + , F ) ) ) $=
      ( vk cmul ce caddc cc wcel cfv wceq syl wi co fveq2 fveq2d vj vn ccom wfn
      cseq wf cv wa fvco3 sylan ffvelrnda efcl eqeltrd prodf ffn eff ax-mp serf
      fnfco sylancr cuz c1 eqeq12d imbi2d weq cz uzid syl6eleqr syl2anc 3eqtr4d
      a1i w3a oveq1 3ad2ant3 adantl peano2uz adantr oveq2d expcom eqcomi eleq2s
      seq1 imp ffvelrnd efadd eqtr4d 3adant3 eqtrd seqp1 3exp a2d uzind4 impcom
      eqfnfvd ) AHDIJBUCZCUEZJKBCUEZUCZADLWPUFWPDUDAHWOCDEFAHUGZDMZUHZWSWONZWSB
      NZJNZLADLBUFZWTXBXDOGDLWSJBUIUJXAXCLMXDLMADLWSBGUKZXCULPUMUNDLWPUOPAJLUDZ
      DLWQUFZWRDUDLLJUFXGUPLLJUOUQAHBCDEFXFURZLDJWQUSUTXAWSWPNZWSWQNZJNZWSWRNZW
      TAXJXLOZAXNQZWSCVANZDAUAUGZWPNZXQWQNZJNZOZQACWPNZCWQNZJNZOZQZAUBUGZWPNZYG
      WQNZJNZOZQAYGVBKRZWPNZYLWQNZJNZOZQXOUAUBCWSXQCOZYAYEAYQXRYBXTYDXQCWPSYQXS
      YCJXQCWQSTVCVDUAUBVEZYAYKAYRXRYHXTYJXQYGWPSYRXSYIJXQYGWQSTVCVDXQYLOZYAYPA
      YSXRYMXTYOXQYLWPSYSXSYNJXQYLWQSTVCVDUAHVEZYAXNAYTXRXJXTXLXQWSWPSYTXSXKJXQ
      WSWQSTVCVDYFCVFMZACWONZCBNZJNZYBYDAXECDMUUBUUDOGACXPDAUUACXPMFCVGPEVHDLCJ
      BUIVIAUUAYBUUBOFIWOCWBPAYCUUCJAUUAYCUUCOFKBCWBPTVJVKYGXPMZAYKYPUUEAYKYPUU
      EAYKVLZYHYLWONZIRZYIYLBNZKRZJNZYMYOUUFUUHYJUUGIRZUUKYKUUEUUHUULOAYHYJUUGI
      VMVNUUEAUULUUKOYKUUEAUHZUULYJUUIJNZIRZUUKUUMUUGUUNYJIUUMXEYLDMZUUGUUNOAXE
      UUEGVOZUUEUUPAUUEYLXPDCYGVPEVHVQZDLYLJBUIVIVRUUMYILMZUUILMUUKUUOOUUEAUUSA
      UUSQYGDXPAYGDMUUSADLYGWQXIUKVSDXPEVTWAWCUUMDLYLBUUQUURWDYIUUIWEVIWFWGWHUU
      EAYMUUHOZYKUUEUUTAIWOCYGWIVQWGUUEAYOUUKOYKUUMYNUUJJUUEYNUUJOAKBCYGWIVQTWG
      VJWJWKWLEWAWMAXHWTXMXLOXIDLWSJWQUIUJWFWN $.
  $}

  ${
    $d F k $.  $d k ph $.  $d M k $.  $d Z k $.  $d F j $.  $d j k $.
    $d Z j $.  $d j ph $.  $d M j $.  $d F x $.  $d j x $.  $d k x $.
    $d M x $.  $d ph x $.  $d Z x $.
    iprodefisum.1 $e |- Z = ( ZZ>= ` M ) $.
    iprodefisum.2 $e |- ( ph -> M e. ZZ ) $.
    iprodefisum.3 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = B ) $.
    iprodefisum.4 $e |- ( ( ph /\ k e. Z ) -> B e. CC ) $.
    iprodefisum.5 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( Applying the exponential function to an infinite sum yields an infinite
       product.  (Contributed by Scott Fenton, 11-Feb-2018.) $)
    iprodefisum $p |- ( ph -> prod_ k e. Z ( exp ` B ) =
       ( exp ` sum_ k e. Z B ) ) $=
      ( vj ce cfv cc wcel syl caddc cseq cli cmpt ccom csu cc0 wne isumcl efne0
      cv cmul ccncf co efcn a1i wa wceq fveq2 eqid fvex adantl eqeltrd serf cuz
      fvmpt eqcomi eleq2s seqfeq cdm wbr climdm eqbrtrd climcl climcncf cbvmptv
      sylib fmptd iprodefisumlem isum fveq2d 3brtr4d wf fvco3 sylan 3eqtrd efcl
      iprodn0 ) ABMNZCMLFLUHZDNZUAZUBZEFBCUCZMNZFGHAWKOPWLUDUEABCDEFGHIJKUFWKUG
      QAMRWIESZUBRDESZTNZMNUIWJESWLTAOOWOMWMEFGHMOOUJUKPAULUMACWIEFGHACUHZFPZUN
      ZWPWINZWPDNZOWQWSWTUOZALWPWHWTFWIWGWPDUPZWIUQWPDURVCZUSZWRWTBOIJUTZUTVAAW
      MWNWOTARCWIDEHWPEVBNZPXAAXAWPFXFXCFXFGVDVEUSVFAWNTVGPWNWOTVHZKWNVIVNZVJAX
      GWOOPXHWOWNVKQVLAWIEFGHACFWTOWIXELCFWHWTXBVMVOZVPAWKWOMABCDEFGHIJVQVRVSWR
      WPWJNZWSMNZWTMNWFAFOWIVTWQXJXKUOXIFOWPMWIWAWBWRWSWTMXDVRWRWTBMIVRWCWRBOPW
      FOPJBWDQWE $.
  $}

  ${
    $d A j $.  $d A k $.  $d A z $.  $d j k $.  $d j ph $.  $d k ph $.
    $d k z $.
    iprodgam.1 $e |- ( ph -> A e. ( CC \ ( ZZ \ NN ) ) ) $.
    $( An infinite product version of Euler's gamma function.  (Contributed by
       Scott Fenton, 12-Feb-2018.) $)
    iprodgam $p |- ( ph -> ( _G ` A ) =
    ( prod_ k e. NN ( ( ( 1 + ( 1 / k ) ) ^c A ) / ( 1 + ( A / k ) ) ) /
      A ) ) $=
      ( vj cfv ce cn c1 cdiv co caddc wcel wceq clog cmul cmin fveq2d oveq12d
      cc vz clgam cgam cv ccxp cprod cdif eflgam syl csu oveq1 oveq1d sumeq2sdv
      cz fveq2 df-lgam ovex fvmpt cmpt nnuz 1z a1i weq oveq2d oveq2 eqid adantl
      id eldifad adantr peano2nn nncnd nncn cc0 wne nnne0 divcld nnne0d divne0d
      wa logcld mulcld ax-1cn addcld simpr dmgmdivn0 subcld cli wbr cdm lgamcvg
      seqex breldm isumcl dmgmn0 efsub syl2anc iprodefisum divdird dividd eqtrd
      cseq crp nnrpd rpreccld rpaddcld rpcnd rpne0d cxpefd eqtr4d eflog addcomd
      1rp prodeq2dv eqtr3d ) ABUBFZGFZBUCFZHIICUDZJKZLKZBUEKZIBXSJKZLKZJKZCUFZB
      JKZABTUNHUGZUGZMZXQXRNDBUHUIAXQHBXSILKZXSJKZOFZPKZYCILKZOFZQKZCUJZBOFZQKZ
      GFZYGAXPYTGAYJXPYTNDUABHUAUDZYMPKZUUBXSJKZILKZOFZQKZCUJZUUBOFZQKYTYIUBUUB
      BNZUUHYRUUIYSQUUJHUUGYQCUUJUUCYNUUFYPQUUBBYMPUKUUJUUEYOOUUJUUDYCILUUBBXSJ
      UKULRSUMUUBBOUOSUACUPYRYSQUQURUIRAUUAYRGFZYSGFZJKZYGAYRTMYSTMUUAUUMNAYQCE
      HBEUDZILKZUUNJKZOFZPKZBUUNJKZILKZOFZQKZUSZIHUTIUNMAVAVBZXSHMZXSUVCFYQNAEX
      SUVBYQHUVCECVCZUURYNUVAYPQUVFUUQYMBPUVFUUPYLOUVFUUOYKUUNXSJUUNXSILUKUVFVH
      SRVDUVFUUTYOOUVFUUSYCILUUNXSBJVEULRSUVCVFZYNYPQUQURVGZAUVEVTZYNYPUVIBYMAB
      TMZUVEABTYHDVIZVJZUVIYLUVIYKXSUVIYKUVEYKHMAXSVKVGZVLZUVEXSTMAXSVMVGZUVEXS
      VNVOAXSVPVGZVQUVIYKXSUVNUVOUVIYKUVMVRUVPVSWAWBZUVIYOUVIYCIUVIBXSUVLUVOUVP
      VQZITMUVIWCVBZWDZUVIBXSAYJUVEDVJAUVEWEZWFZWAZWGZALUVCIXBZXPYSLKZWHWIUWEWH
      WJMABEUVCUVGDWKUWEUWFWHLUVCIWLXPYSLUQWMUIZWNABUVKABDWOZWAYRYSWPWQAUUKYFUU
      LBJAHYQGFZCUFUUKYFAYQCUVCIHUTUVDUVHUWDUWGWRAHUWIYECUVIUWIYNGFZYPGFZJKZYEU
      VIYNTMYPTMUWIUWLNUVQUWCYNYPWPWQUVIUWJYBUWKYDJUVIUWJBYAOFZPKZGFYBUVIYNUWNG
      UVIYMUWMBPUVIYLYAOUVIYLXSXSJKZXTLKYAUVIXSIXSUVOUVSUVOUVPWSUVIUWOIXTLUVIXS
      UVOUVPWTULXARVDRUVIYABUVIYAUVIIXTIXCMUVIXMVBUVIXSUVIXSUWAXDXEXFZXGUVIYAUW
      PXHUVLXIXJUVIUWKYOYDUVIYOTMYOVNVOUWKYONUVTUWBYOXKWQUVIYCIUVRUVSXLXASXAXNX
      OAUVJBVNVOUULBNUVKUWHBXKWQSXAXAXO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Falling and Rising Factorial
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the constant for falling factorial. $)
  $c FallFac $.

  $( Declare the constant for rising factorial. $)
  $c RiseFac $.

  $( Declare the syntax for the falling factorial. $)
  cfallfac $a class FallFac $.

  $( Declare the syntax for the rising factorial. $)
  crisefac $a class RiseFac $.

  ${
    $d x n k $.
    $( Define the rising factorial function.  This is the function
       ` ( A x. ( A + 1 ) x. ... ( A + N ) ) ` for complex ` A ` and
       non-negative integers ` N ` .  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    df-risefac $a |- RiseFac = ( x e. CC , n e. NN0 |->
       prod_ k e. ( 0 ... ( n - 1 ) ) ( x + k ) ) $.

    $( Define the falling factorial function.  This is the function
       ` ( A x. ( A - 1 ) x. ... ( A - N ) ) ` for complex ` A ` and
       non-negative integers ` N ` .  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    df-fallfac $a |- FallFac = ( x e. CC , n e. NN0 |->
       prod_ k e. ( 0 ... ( n - 1 ) ) ( x - k ) ) $.
  $}

  ${
    $d A k $.  $d A n $.  $d A x $.  $d k n $.  $d k x $.  $d N k $.  $d N n $.
    $d n x $.  $d N x $.
    $( The value of the rising factorial function.  (Contributed by Scott
       Fenton, 5-Jan-2018.) $)
    risefacval $p |- ( ( A e. CC /\ N e. NN0 ) ->
      ( A RiseFac N ) = prod_ k e. ( 0 ... ( N - 1 ) ) ( A + k ) ) $=
      ( vx vn cc cn0 cc0 cv c1 cmin co cfz caddc cprod crisefac wceq prodeq2sdv
      oveq1 oveq2d prodeq1d df-risefac prodex ovmpt2 ) DEACFGHEIZJKLZMLZDIZBIZN
      LZBOHCJKLZMLZAUINLZBOPUGUMBOUHAQUGUJUMBUHAUINSRUECQZUGULUMBUNUFUKHMUECJKS
      TUADBEUBULUMBUCUD $.

    $( The value of the falling factorial function.  (Contributed by Scott
       Fenton, 5-Jan-2018.) $)
    fallfacval $p |- ( ( A e. CC /\ N e. NN0 ) ->
      ( A FallFac N ) = prod_ k e. ( 0 ... ( N - 1 ) ) ( A - k ) ) $=
      ( vx vn cc cn0 cc0 cv c1 cmin co cfz cprod cfallfac wceq oveq1 prodeq2sdv
      oveq2d prodeq1d df-fallfac prodex ovmpt2 ) DEACFGHEIZJKLZMLZDIZBIZKLZBNHC
      JKLZMLZAUHKLZBNOUFULBNUGAPUFUIULBUGAUHKQRUDCPZUFUKULBUMUEUJHMUDCJKQSTDBEU
      AUKULBUBUC $.
  $}

  ${
    $d A k $.  $d A n $.  $d k n $.  $d N k $.  $d N n $.
    $( One-based value of rising factorial.  (Contributed by Scott Fenton,
       15-Jan-2018.) $)
    risefacval2 $p |- ( ( A e. CC /\ N e. NN0 ) ->
        ( A RiseFac N ) = prod_ k e. ( 1 ... N ) ( A + ( k - 1 ) ) ) $=
      ( vn cc wcel cn0 wa co cc0 c1 cmin cfz cv caddc cprod cz a1i adantl wceq
      crisefac risefacval 1z 0z nn0z peano2zm simpl elfznn0 nn0cnd addcl syl2an
      syl oveq2 fprodshft 0p1e1 nn0cn ax-1cn npcand oveq12d prodeq1d 3eqtrd ) A
      EFZCGFZHZACUAIJCKLIZMIZADNZOIZDPJKOIZVEKOIZMIZABNKLIZOIZBPKCMIZVMBPADCUBV
      DVHVMDBKJVEKQFVDUCRJQFVDUDRVCVEQFZVBVCCQFVOCUECUFULSVDVBVGEFVHEFVGVFFZVBV
      CUGVPVGVGVEUHUIAVGUJUKVGVLAOUMUNVDVKVNVMBVDVIKVJCMVIKTVDUORVCVJCTVBVCCKCU
      PKEFVCUQRURSUSUTVA $.

    $( One-based value of falling factorial.  (Contributed by Scott Fenton,
       15-Jan-2018.) $)
    fallfacval2 $p |- ( ( A e. CC /\ N e. NN0 ) ->
        ( A FallFac N ) = prod_ k e. ( 1 ... N ) ( A - ( k - 1 ) ) ) $=
      ( vn cc wcel cn0 wa co cc0 c1 cmin cfz cv cprod caddc cz a1i adantl wceq
      cfallfac fallfacval 1z 0z nn0z peano2zm simpl elfznn0 nn0cnd subcl syl2an
      syl oveq2 fprodshft 0p1e1 nn0cn ax-1cn npcand oveq12d prodeq1d 3eqtrd ) A
      EFZCGFZHZACUAIJCKLIZMIZADNZLIZDOJKPIZVEKPIZMIZABNKLIZLIZBOKCMIZVMBOADCUBV
      DVHVMDBKJVEKQFVDUCRJQFVDUDRVCVEQFZVBVCCQFVOCUECUFULSVDVBVGEFVHEFVGVFFZVBV
      CUGVPVGVGVEUHUIAVGUJUKVGVLALUMUNVDVKVNVMBVDVIKVJCMVIKTVDUORVCVJCTVBVCCKCU
      PKEFVCUQRURSUSUTVA $.
  $}

  ${
    $d A k j $.  $d N k j $.
    $( A product representation of falling factorial when ` A ` is a
       non-negative integer.  (Contributed by Scott Fenton, 20-Mar-2018.) $)
    fallfacval3 $p |- ( N e. ( 0 ... A ) -> ( A FallFac N ) =
       prod_ k e. ( ( A - ( N - 1 ) ) ... A ) k ) $=
      ( vj cc0 cfz co wcel cfallfac c1 cmin cv cprod cc cn0 elfz3nn0 cz elfzelz
      wceq zcnd nn0cnd elfznn0 fallfacval syl2anc elfzel2 peano2zm subcl syl2an
      elfzel1 syl oveq2 fprodrev subid1d oveq2d adantr adantl nncand prodeq12dv
      wa 3eqtrd ) CEAFGHZACIGZECJKGZFGZADLZKGZDMZAVCKGZAEKGZFGZAABLZKGZKGZBMVHA
      FGZVKBMVAANHZCOHVBVGSVAACAPUAZCAUBADCUCUDVAVFVMDBAEVCCEAUECEAUIVACQHVCQHC
      EARCUFUJVAVOVENHVFNHVEVDHZVPVQVEVEEVCRTAVEUGUHVEVLAKUKULVAVJVNVMVKBVAVIAV
      HFVAAVPUMUNVAVKVJHZUSAVKVAVOVRVPUOVRVKNHVAVRVKVKVHVIRTUPUQURUT $.
  $}

  ${
    $d A k $.  $d A x $.  $d A y $.  $d k x $.  $d k y $.  $d N k $.  $d N x $.
    $d N y $.  $d S k $.  $d S x $.  $d S y $.  $d x y $.
    risefallfaccllem.1 $e |- S C_ CC $.
    risefallfaccllem.2 $e |- 1 e. S $.
    risefallfaccllem.3 $e |- ( ( x e. S /\ y e. S ) -> ( x x. y ) e. S ) $.

    ${
      risefaccllem.4 $e |- ( ( A e. S /\ k e. NN0 ) -> ( A + k ) e. S ) $.
      $( Lemma for rising factorial closure laws.  (Contributed by Scott
         Fenton, 5-Jan-2018.) $)
      risefaccllem $p |- ( ( A e. S /\ N e. NN0 ) -> ( A RiseFac N ) e. S ) $=
        ( wcel cn0 wa crisefac co cc0 c1 cv cc a1i caddc cprod sseli risefacval
        cmin cfz wceq sylan cmul adantl fzfid elfznn0 sylan2 fprodcllem eqeltrd
        wss adantr ) CDKZFLKZMCFNOZPFQUEOZUFOZCERZUAOZEUBZDURCSKUSUTVEUGDSCGUCC
        EFUDUHURVEDKUSURABVBVDDEDSUPURGTARZDKBRZDKMVFVGUIODKURIUJURPVAUKVCVBKUR
        VCLKVDDKVCVAULJUMQDKURHTUNUQUO $.
    $}


    ${
      fallfaccllem.4 $e |- ( ( A e. S /\ k e. NN0 ) -> ( A - k ) e. S ) $.
      $( Lemma for falling factorial closure laws.  (Contributed by Scott
         Fenton, 5-Jan-2018.) $)
      fallfaccllem $p |- ( ( A e. S /\ N e. NN0 ) -> ( A FallFac N ) e. S ) $=
        ( wcel cn0 wa co cc0 c1 cmin cv cc a1i cfz cprod sseli fallfacval sylan
        cfallfac wceq wss adantl fzfid elfznn0 sylan2 fprodcllem adantr eqeltrd
        cmul ) CDKZFLKZMCFUFNZOFPQNZUANZCERZQNZEUBZDUQCSKURUSVDUGDSCGUCCEFUDUEU
        QVDDKURUQABVAVCDEDSUHUQGTARZDKBRZDKMVEVFUPNDKUQIUIUQOUTUJVBVAKUQVBLKVCD
        KVBUTUKJULPDKUQHTUMUNUO $.
    $}
  $}

  ${
    $d A k $.  $d N k $.  $d A x $.  $d A y $.  $d k x $.  $d k y $.  $d N x $.
    $d N y $.  $d x y $.
    $( Closure law for rising factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    risefaccl $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A RiseFac N ) e. CC ) $=
      ( vx vy vk cc ssid ax-1cn cv mulcl wcel caddc co nn0cn addcl risefaccllem
      cn0 sylan2 ) CDAFEBFGHCIDIJEIZQKAFKSFKASLMFKSNASORP $.

    $( Closure law for falling factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    fallfaccl $p |- ( ( A e. CC /\ N e. NN0 ) -> ( A FallFac N ) e. CC ) $=
      ( vx vy vk cc ssid ax-1cn cv mulcl cn0 wcel cmin nn0cn subcl fallfaccllem
      co sylan2 ) CDAFEBFGHCIDIJEIZKLAFLSFLASMQFLSNASORP $.

    $( Closure law for rising factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    rerisefaccl $p |- ( ( A e. RR /\ N e. NN0 ) -> ( A RiseFac N ) e. RR ) $=
      ( vx vy vk cr ax-resscn 1re cv remulcl wcel caddc co nn0re readdcl sylan2
      cn0 risefaccllem ) CDAFEBGHCIDIJEIZQKAFKSFKASLMFKSNASOPR $.

    $( Closure law for falling factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    refallfaccl $p |- ( ( A e. RR /\ N e. NN0 ) -> ( A FallFac N ) e. RR ) $=
      ( vx vy vk cr ax-resscn 1re cv remulcl cn0 wcel cmin nn0re resubcl sylan2
      co fallfaccllem ) CDAFEBGHCIDIJEIZKLAFLSFLASMQFLSNASOPR $.

    $( Closure law for rising factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    nnrisefaccl $p |- ( ( A e. NN /\ N e. NN0 ) -> ( A RiseFac N ) e. NN ) $=
      ( vx vy vk cn nnsscn 1nn cv nnmulcl nnnn0addcl risefaccllem ) CDAFEBGHCID
      IJAEIKL $.

    $( Closure law for rising factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    zrisefaccl $p |- ( ( A e. ZZ /\ N e. NN0 ) -> ( A RiseFac N ) e. ZZ ) $=
      ( vx vy vk cz zsscn 1z cv zmulcl wcel caddc co zaddcl sylan2 risefaccllem
      cn0 nn0z ) CDAFEBGHCIDIJEIZQKAFKSFKASLMFKSRASNOP $.

    $( Closure law for falling factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    zfallfaccl $p |- ( ( A e. ZZ /\ N e. NN0 ) -> ( A FallFac N ) e. ZZ ) $=
      ( vx vy vk cz zsscn 1z cv zmulcl cn0 wcel cmin zsubcl sylan2 fallfaccllem
      co nn0z ) CDAFEBGHCIDIJEIZKLAFLSFLASMQFLSRASNOP $.

    $( Closure law for rising factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    nn0risefaccl $p |- ( ( A e. NN0 /\ N e. NN0 ) ->
      ( A RiseFac N ) e. NN0 ) $=
      ( vx vy vk cn0 nn0sscn 1nn0 cv nn0mulcl nn0addcl risefaccllem ) CDAFEBGHC
      IDIJAEIKL $.

    $( Closure law for rising factorial.  (Contributed by Scott Fenton,
       9-Jan-2018.) $)
    rprisefaccl $p |- ( ( A e. RR+ /\ N e. NN0 ) -> ( A RiseFac N ) e. RR+ ) $=
      ( vx vy vk crp cr cc rpssre ax-resscn sstri 1rp cv rpmulcl cc0 clt adantr
      wcel wbr adantl cn0 wa caddc rpre nn0re readdcl syl2an cle rpgt0 addgtge0
      co nn0ge0 syl22anc elrpd risefaccllem ) CDAFEBFGHIJKLCMDMNAFRZEMZUARZUBZA
      UQUCUKZUPAGRZUQGRZUTGRURAUDZUQUEZAUQUFUGUSVAVBOAPSZOUQUHSZOUTPSUPVAURVCQU
      RVBUPVDTUPVEURAUIQURVFUPUQULTAUQUJUMUNUO $.

  $}

  ${
    $d N k $.  $d X k $.
    $( A relationship between rising and falling factorials.  (Contributed by
       Scott Fenton, 15-Jan-2018.) $)
    risefallfac $p |- ( ( X e. CC /\ N e. NN0 ) ->
        ( X RiseFac N ) = ( ( -u 1 ^ N ) x. ( -u X FallFac N ) ) ) $=
      ( vk cc wcel cn0 wa c1 co cv cmin cprod cneg cmul cexp syl2an adantl wceq
      cfz neg1cn caddc crisefac cfallfac negcl adantr elfznn nnm1nn0 syl nn0cnd
      subcl mulm1d simpll negdi2d negeqd simpl addcl negnegd 3eqtr2rd prodeq2dv
      cn risefacval2 chash cfv cfn fzfi fprodconst mp2an hashfz1 oveq2d syl5req
      fallfacval2 sylan oveq12d fzfid a1i fprodmul eqtr4d 3eqtr4d ) BDEZAFEZGZH
      ASIZBCJZHKIZUAIZCLWBHMZBMZWDKIZNIZCLZBAUBIWFAOIZWGAUCIZNIZWAWBWEWICWAWCWB
      EZGZWIWHMWEMZMWEWOWHWAWGDEZWDDEZWHDEWNVSWQVTBUDZUEWNWDWNWCUTEWDFEWCAUFWCU
      GUHUIZWGWDUJPZUKWOWPWHWOBWDVSVTWNULWNWRWAWTQUMUNWOWEWAVSWRWEDEWNVSVTUOWTB
      WDUPPUQURUSBCAVAWAWMWBWFCLZWBWHCLZNIWJWAWKXBWLXCNVTWKXBRVSVTXBWFWBVBVCZOI
      ZWKWBVDEWFDEZXBXERHAVETWBWFCVFVGVTXDAWFOAVHVIVJQVSWQVTWLXCRWSWGCAVKVLVMWA
      WBWFWHCWAHAVNXFWOTVOXAVPVQVR $.
  $}

  $( A relationship between falling and rising factorials.  (Contributed by
     Scott Fenton, 17-Jan-2018.) $)
  fallrisefac $p |- ( ( X e. CC /\ N e. NN0 ) ->
    ( X FallFac N ) = ( ( -u 1 ^ N ) x. ( -u X RiseFac N ) ) ) $=
    ( cc wcel cn0 wa cfallfac co cneg cexp cmul crisefac oveq2d neg1cn 3eqtr3rd
    c1 wceq adantl fallfaccl sylan c2 caddc nn0cn 2timesd nn0z m1expevenALT syl
    expadd mp3an1 anidms negneg adantr oveq1d oveq12d expcl mpan negcld mulassd
    cz negcl mulid2d risefallfac eqtr4d ) BCDZAEDZFZBAGHZPIZAJHZVIBIZIZAGHZKHZK
    HZVIVJALHZKHVFVIVIKHZVLKHPVGKHVNVGVFVPPVLVGKVEVPPQVDVEVHUAAKHZJHZVHAAUBHZJH
    ZPVPVEVQVSVHJVEAAUCUDMVEAUSDVRPQAUEAUFUGVEVTVPQZVHCDZVEVEWANVHAAUHUIUJORVFV
    KBAGVDVKBQVEBUKULUMUNVFVIVIVLVEVICDZVDWBVEWCNVHAUOUPRZWDVDVKCDVEVLCDVDVJBUT
    ZUQVKASTURVFVGBASVAOVFVOVMVIKVDVJCDVEVOVMQWEAVJVBTMVC $.


  $( Lemma for ~ risefac0 and ~ fallfac0 .  Show a particular set of finite
     integers is empty.  (Contributed by Scott Fenton, 5-Jan-2018.) $)
  risefall0lem $p |- ( 0 ... ( 0 - 1 ) ) = (/) $=
    ( cc0 c1 cneg cfz co cmin c0 df-neg oveq2i clt wbr wceq 0lt1 cr wcel wb 1re
    ax-mp mpbi cz lt0neg2 0z 1z znegcl fzn mp2an eqtr3i ) ABCZDEZAABFEZDEGUHUJA
    DBHIUHAJKZUIGLZABJKZUKMBNOUMUKPQBUARSATOUHTOZUKULPUBBTOUNUCBUDRAUHUEUFSUG
    $.

  ${
    $d A k $.
    $( The value of the rising factorial when ` N = 0 ` .  (Contributed by
       Scott Fenton, 5-Jan-2018.) $)
    risefac0 $p |- ( A e. CC -> ( A RiseFac 0 ) = 1 ) $=
      ( vk cc wcel cc0 crisefac co c1 cmin cfz caddc cprod wceq 0nn0 risefacval
      cv cn0 mpan2 c0 risefall0lem prodeq1i prod0 eqtri syl6eq ) ACDZAEFGZEEHIG
      JGZABPKGZBLZHUEEQDUFUIMNABEORUISUHBLHUGSUHBTUAUHBUBUCUD $.
  $}


  $( The value of the falling factorial when ` N = 0 ` .  (Contributed by Scott
     Fenton, 5-Jan-2018.) $)
  fallfac0 $p |- ( A e. CC -> ( A FallFac 0 ) = 1 ) $=
    ( cc wcel cc0 cfallfac co cneg cexp crisefac cmul cn0 wceq 0nn0 fallrisefac
    c1 mpan2 neg1cn exp0 mp1i negcl risefac0 syl oveq12d 1t1e1 syl6eq eqtrd ) A
    BCZADEFZOGZDHFZAGZDIFZJFZOUGDKCUHUMLMDANPUGUMOOJFOUGUJOULOJUIBCUJOLUGQUIRSU
    GUKBCULOLATUKUAUBUCUDUEUF $.

  ${
    $d A k $.  $d N k $.
    $( The value of the rising factorial at a successor.  (Contributed by Scott
       Fenton, 5-Jan-2018.) $)
    risefacp1 $p |- ( ( A e. CC /\ N e. NN0 ) ->
       ( A RiseFac ( N + 1 ) ) = ( ( A RiseFac N ) x. ( A + N ) ) ) $=
      ( vk cc wcel cn0 wa cc0 c1 caddc co cmin cfz cprod crisefac adantl sylan2
      cv cmul risefacval nn0cn ax-1cn a1i pncand oveq2d prodeq1d cuz cfv biimpi
      elnn0uz elfznn0 nn0cnd addcl adantlr oveq2 fprodm1 eqtrd peano2nn0 oveq1d
      wceq 3eqtr4d ) ADEZBFEZGZHBIJKZILKZMKZACRZJKZCNZHBILKMKVICNZABJKZSKZAVEOK
      ZABOKZVLSKVDVJHBMKZVICNVMVDVGVPVICVDVFBHMVDBIVCBDEVBBUAPIDEVDUBUCUDUEUFVD
      VIVLCHBVCBHUGUHEZVBVCVQBUJUIPVBVHVPEZVIDEZVCVRVBVHDEVSVRVHVHBUKULAVHUMQUN
      VHBAJUOUPUQVCVBVEFEVNVJUTBURACVETQVDVOVKVLSACBTUSVA $.

    $( The value of the falling factorial at a successor.  (Contributed by
       Scott Fenton, 5-Jan-2018.) $)
    fallfacp1 $p |- ( ( A e. CC /\ N e. NN0 ) ->
       ( A FallFac ( N + 1 ) ) = ( ( A FallFac N ) x. ( A - N ) ) ) $=
      ( vk cc wcel cn0 wa cc0 c1 caddc co cmin cfz cprod cfallfac adantl sylan2
      cv cmul fallfacval nn0cn ax-1cn a1i pncand oveq2d prodeq1d cuz cfv biimpi
      elnn0uz elfznn0 nn0cnd subcl adantlr oveq2 fprodm1 eqtrd peano2nn0 oveq1d
      wceq 3eqtr4d ) ADEZBFEZGZHBIJKZILKZMKZACRZLKZCNZHBILKMKVICNZABLKZSKZAVEOK
      ZABOKZVLSKVDVJHBMKZVICNVMVDVGVPVICVDVFBHMVDBIVCBDEVBBUAPIDEVDUBUCUDUEUFVD
      VIVLCHBVCBHUGUHEZVBVCVQBUJUIPVBVHVPEZVIDEZVCVRVBVHDEVSVRVHVHBUKULAVHUMQUN
      VHBALUOUPUQVCVBVEFEVNVJUTBURACVETQVDVOVKVLSACBTUSVA $.
  $}

  ${
    rffacp1d.1 $e |- ( ph -> A e. CC ) $.
    rffacp1d.2 $e |- ( ph -> N e. NN0 ) $.
    $( The value of the rising factorial at a successor.  (Contributed by Scott
       Fenton, 19-Mar-2018.) $)
    risefacp1d $p |- ( ph ->
     ( A RiseFac ( N + 1 ) ) = ( ( A RiseFac N ) x. ( A + N ) ) ) $=
      ( cc wcel cn0 c1 caddc co crisefac cmul wceq risefacp1 syl2anc ) ABFGCHGB
      CIJKLKBCLKBCJKMKNDEBCOP $.

    $( The value of the falling factorial at a successor.  (Contributed by
       Scott Fenton, 19-Mar-2018.) $)
    fallfacp1d $p |- ( ph ->
     ( A FallFac ( N + 1 ) ) = ( ( A FallFac N ) x. ( A - N ) ) ) $=
      ( cc wcel cn0 c1 caddc co cfallfac cmin cmul wceq fallfacp1 syl2anc ) ABF
      GCHGBCIJKLKBCLKBCMKNKODEBCPQ $.
  $}

  $( The value of rising factorial at one.  (Contributed by Scott Fenton,
     5-Jan-2018.) $)
  risefac1 $p |- ( A e. CC -> ( A RiseFac 1 ) = A ) $=
    ( cc wcel c1 crisefac cc0 caddc 0p1e1 oveq2i cmul wceq 0nn0 risefacp1 mpan2
    co cn0 risefac0 addid1 oveq12d mulid2 3eqtrd syl5eqr ) ABCZADEOAFDGOZEOZAUD
    DAEHIUCUEAFEOZAFGOZJOZDAJOAUCFPCUEUHKLAFMNUCUFDUGAJAQARSATUAUB $.

  $( The value of falling factorial at one.  (Contributed by Scott Fenton,
     5-Jan-2018.) $)
  fallfac1 $p |- ( A e. CC -> ( A FallFac 1 ) = A ) $=
    ( cc wcel c1 cfallfac co cc0 caddc oveq2i cmin cmul cn0 wceq 0nn0 fallfacp1
    0p1e1 mpan2 fallfac0 subid1 oveq12d mulid2 3eqtrd syl5eqr ) ABCZADEFAGDHFZE
    FZAUEDAEPIUDUFAGEFZAGJFZKFZDAKFAUDGLCUFUIMNAGOQUDUGDUHAKARASTAUAUBUC $.
  ${
    $d N k m $.
    $( Relate rising factorial to factorial.  (Contributed by Scott Fenton,
       5-Jan-2018.) $)
    risefacfac $p |- ( N e. NN0 -> ( 1 RiseFac N ) = ( ! ` N ) ) $=
      ( vk cn0 wcel c1 cfz co cv cmin caddc cprod crisefac cfa cfv wa cc ax-1cn
      a1i elfznn nncnd pncan3d prodeq2dv wceq risefacval2 mpan fprodfac 3eqtr4d
      adantl ) ACDZEAFGZEBHZEIGJGZBKZUJUKBKEALGZAMNUIUJULUKBUIUKUJDZOZEUKEPDZUP
      QRUOUKPDUIUOUKUKASTUHUAUBUQUIUNUMUCQEBAUDUEABUFUG $.
  $}

  ${
    $d A k $.  $d N k $.
    $( The forward difference of a falling factorial.  (Contributed by Scott
       Fenton, 21-Jan-2018.) $)
    fallfacfwd $p |- ( ( A e. CC /\ N e. NN ) ->
      ( ( ( A + 1 ) FallFac N ) - ( A FallFac N ) ) =
      ( N x. ( A FallFac ( N - 1 ) ) ) ) $=
      ( vk cc wcel c1 caddc co cfallfac cmin cmul cc0 cfz cprod cn0 wceq adantl
      oveq2d sylan2 eqtrd cn wa cv peano2cn nnnn0 fallfacval syl2an cneg oveq1i
      0p1e1 prodeq1i oveq2i cuz cfv nnm1nn0 syl6eleq simpll cz elfzelz peano2zm
      nn0uz syl subcld oveq1 df-neg syl6eqr fprod1p fallfacval2 3eqtr4a elfznn0
      zcnd nn0cnd ax-1cn a1i prodeq2dv simpl subnegd oveq1d 3eqtr3d simpr nncnd
      subsub3d npcand fallfacp1 eqtr3d oveq12d fallfaccl mulcomd adantr subdird
      pnncand pncan3d 3eqtr2d ) ADEZBUAEZUBZAFGHZBIHZABIHZJHWQABFJHZIHZKHZXAAWT
      JHZKHZJHZBXAKHZWPWRXBWSXDJWPWRLWTMHZWQCUCZJHZCNZXBWNWQDEZBOEWRXJPWOAUDZBU
      EWQCBUFUGWPXGAXHFJHZJHZCNZAFUHZJHZXAKHZXJXBWPXQLFGHZWTMHZXNCNZKHXQFWTMHZX
      NCNZKHXOXRYAYCXQKXTYBXNCXSFWTMUJUIUKULWPXNXQCLWTWPWTOLUMUNWOWTOEZWNBUOZQZ
      VAUPWPXHXGEZUBZAXMWNWOYGUQZYHXMYHXHUREZXMUREYGYJWPXHLWTUSQXHUTVBVKVCXHLPZ
      XMXPAJYKXMLFJHXPXHLFJVDFVEVFRVGWPXAYCXQKWOWNYDXAYCPYEACWTVHSRVIWPXGXNXICY
      HAXHFYIYHXHYGXHOEWPXHWTVJQVLFDEZYHVMVNWBVOWPXQWQXAKWPAFWNWOVPZYLWPVMVNZVQ
      VRVSTWPAWTFGHZIHZWSXDWPYOBAIWPBFWPBWNWOVTWAZYNWCRWOWNYDYPXDPYEAWTWDSWEWFW
      PXEXBXCXAKHZJHWQXCJHZXAKHXFWPXDYRXBJWPXAXCWOWNYDXADEYEAWTWGSZWPAWTYMWPWTY
      FVLZVCZWHRWPWQXCXAWNXKWOXLWIUUBYTWJWPYSBXAKWPYSFWTGHBWPAFWTYMYNUUAWKWPFBY
      NYQWLTVRWMT $.
  $}

  ${
    $d N k $.
    $( The value of the zero falling factorial at natural ` N ` .  (Contributed
       by Scott Fenton, 17-Feb-2018.) $)
    0fallfac $p |- ( N e. NN -> ( 0 FallFac N ) = 0 ) $=
      ( vk cn wcel cc0 cfallfac co c1 cmin cfz cv cprod cc cn0 wceq 0cn sylancr
      elfzelz zcnd adantl caddc nnnn0 fallfacval cuz cfv nnm1nn0 nn0uz syl6eleq
      cmul subcl oveq2 subidi syl6eq fprod1p fzfid fprodcl mul02d 3eqtrd ) ACDZ
      EAFGZEAHIGZJGZEBKZIGZBLZEEHUAGZVAJGZVDBLZUIGEUSEMDZANDUTVEOPAUBEBAUCQUSVD
      EBEVAUSVANEUDUEAUFUGUHVCVBDZVDMDZUSVJVIVCMDZVKPVJVCVCEVARSEVCUJZQTVCEOVDE
      EIGEVCEEIUKEPULUMUNUSVHUSVGVDBUSVFVAUOVCVGDZVKUSVNVIVLVKPVNVCVCVFVARSVMQT
      UPUQUR $.
  $}

  $( The value of the zero rising factorial at natural ` N ` .  (Contributed by
     Scott Fenton, 17-Feb-2018.) $)
  0risefac $p |- ( N e. NN -> ( 0 RiseFac N ) = 0 ) $=
    ( cn wcel cc0 crisefac co c1 cneg cexp cfallfac cmul cc cn0 0cn risefallfac
    wceq nnnn0 sylancr neg0 oveq1i 0fallfac syl5eq oveq2d neg1cn mul01d 3eqtrd
    expcl ) ABCZDAEFZGHZAIFZDHZAJFZKFZUKDKFDUHDLCAMCZUIUNPNAQZADORUHUMDUKKUHUMD
    AJFDULDAJSTAUAUBUCUHUKUHUJLCUOUKLCUDUPUJAUGRUEUF $.

  ${
    $d k ph $.  $d N k $.  $d A j $.  $d A k $.  $d B j $.  $d B k $.
    $d j k $.  $d j ph $.  $d N j $.
    binomfallfaclem.1 $e |- ( ph -> A e. CC ) $.
    binomfallfaclem.2 $e |- ( ph -> B e. CC ) $.
    binomfallfaclem.3 $e |- ( ph -> N e. NN0 ) $.
    $( Lemma for ~ binomfallfac .  Closure law.  (Contributed by Scott Fenton,
       13-Mar-2018.) $)
    binomfallfaclem1 $p |- ( ( ph /\
      K e. ( 0 ... N ) ) -> ( ( N _C K ) x. ( ( A FallFac ( N - K ) ) x.
      ( B FallFac ( K + 1 ) ) ) ) e. CC ) $=
      ( cc0 cfz co wcel wa cbc cfallfac cn0 syl2an cc fallfaccl mulcld c1 caddc
      cmin cmul cz elfzelz bccl nn0cnd fznn0sub elfznn0 peano2nn0 syl ) ADIEJKL
      ZMZEDNKZBEDUCKZOKZCDUAUBKZOKZUDKUNUOAEPLDUELUOPLUMHDIEUFDEUGQUHUNUQUSABRL
      UPPLUQRLUMFDIEUIBUPSQACRLURPLZUSRLUMGUMDPLUTDEUJDUKULCURSQTT $.

    binomfallfaclem.4 $e |- ( ps -> ( ( A + B ) FallFac N ) =
      sum_ k e. ( 0 ... N ) ( ( N _C k ) x.
      ( ( A FallFac ( N - k ) ) x. ( B FallFac k ) ) ) ) $.
    $( Lemma for ~ binomfallfac .  Inductive step.  (Contributed by Scott
       Fenton, 13-Mar-2018.) $)
    binomfallfaclem2 $p |- ( ( ph /\ ps ) ->
    ( ( A + B ) FallFac ( N + 1 ) ) =
      sum_ k e. ( 0 ... ( N + 1 ) ) ( ( ( N + 1 ) _C k ) x.
      ( ( A FallFac ( ( N + 1 ) - k ) ) x. ( B FallFac k ) ) ) ) $=
      ( cc0 co cmin cfallfac cmul caddc c1 wcel cc oveq2d vj wa cfz cv cbc wceq
      csu cn0 cz elfzelz syl2an nn0cnd fznn0sub fallfaccl elfznn0 mulcld addcld
      subcld adantr mulassd subcl adddid adantl ppncand subsubd addsubd 3eqtr4d
      bccl oveq1d mul32d ax-1cn a1i fallfacp1 eqtrd oveq12d 3eqtr3d cuz cfv wss
      eqtr4d nn0zd uzid peano2uz 4syl sselda syldan peano2nn0 3eqtrd fallfacp1d
      fzss2 syl sumeq2dv sylan9eq fzfid fsummulc1 bcpasc peano2zm adddird nn0uz
      eqtr3d syl6eleq oveq2 fsump1 clt wbr wo nn0red olcd bcval4 syl3anc subidd
      ltp1d 0nn0 sylancl eqeltrd syl2anc mul02d fsumcl cneg oveq1 df-neg fsum1p
      addid1d syl6eqr 1z znegcl ax-mp 0lt1 cr lt0neg2 mpbi orci mp3an23 subid1d
      wb 1re 0z binomfallfaclem1 fsumshft fsumadd zcnd subsub3d cbvsumv addid2d
      npcand eqtr2d weq ) ABUBZKFUCLZFEUDZUELZCFUUJMLZNLZDUUJNLZOLZOLZCDPLZFMLZ
      OLZEUGZUUIUUKCFQPLZUUJMLZNLZUUNOLZOLZUUKUUMDUUJQPLZNLZOLZOLZPLZEUGZUUQUVA
      NLZKUVAUCLZUVAUUJUELZUVDOLZEUGZAUUTUVKUFBAUUIUUSUVJEAUUJUUIRZUBZUUSUUKUUO
      UUROLZOLUUKUVDUVHPLZOLUVJUVRUUKUUOUURUVRUUKAFUHRZUUJUIRZUUKUHRZUVQIUUJKFU
      JUUJFVHZUKULZUVRUUMUUNACSRZUULUHRZUUMSRUVQGUUJKFUMZCUULUNUKZADSRZUUJUHRZU
      UNSRZUVQHUUJFUOZDUUJUNZUKZUPZAUURSRUVQAUUQFACDGHUQZAFIULZURZUSUTUVRUVSUVT
      UUKOUVRUUOCUULMLZDUUJMLZPLZOLUUOUWTOLZUUOUXAOLZPLUVSUVTUVRUUOUWTUXAUWPAUW
      FUULSRUWTSRUVQGUVQUULUWHULCUULVAUKZAUWJUUJSRZUXASRUVQHUVQUUJUWMULZDUUJVAU
      KZVBUVRUXBUURUUOOUVRCFMLZUUJPLZUXAPLUXIDPLUXBUURUVRUXIUUJDUVRCFAUWFUVQGUS
      ZAFSRZUVQUWRUSZURUVQUXFAUXGVCZAUWJUVQHUSZVDUVRUWTUXJUXAPUVRCFUUJUXKUXMUXN
      VEVIUVRCDFUXKUXOUXMVFVGTUVRUXCUVDUXDUVHPUVRUXCUUMUWTOLZUUNOLUVDUVRUUMUUNU
      WTUWIUWOUXEVJUVRUVCUXPUUNOUVRUVCCUULQPLZNLZUXPUVRUVBUXQCNUVRFQUUJUXMQSRZU
      VRVKVLUXNVFTAUWFUWGUXRUXPUFUVQGUWHCUULVMUKVNVIVTUVRUXDUUMUUNUXAOLZOLUVHUV
      RUUMUUNUXAUWIUWOUXHUTUVRUVGUXTUUMOAUWJUWKUVGUXTUFUVQHUWMDUUJVMUKTVTVOVPTU
      VRUUKUVDUVHUWEUVRUVCUUNAUVQUUJUVMRZUVCSRZAUUIUVMUUJAFUIRFFVQVRZRUVAUYCRUU
      IUVMVSAFIWAZFWBFFWCFKUVAWJWDWEZAUWFUVBUHRUYBUYAGUUJKUVAUMCUVBUNUKZWFUWOUP
      UVRUUMUVGUWIAUWJUVFUHRZUVGSRUVQHUVQUWKUYGUWMUUJWGWKDUVFUNUKUPVBWHWLUSUUHU
      VLUUIUUPEUGZUUROLZUUTABUVLUUQFNLZUUROLUYIAUUQFUWQIWIBUYJUYHUUROJVIWMAUYIU
      UTUFBAUUIUUPUUREAKFWNZUWSUVRUUKUUOUWEUWPUPWOUSVNAUVPUVKUFBAUVPUVMUVEFUUJQ
      MLZUELZUVDOLZPLZEUGZUVKAUVMUVOUYOEAUYAUBZUUKUYMPLZUVDOLUVOUYOUYQUYRUVNUVD
      OAUWAUWBUYRUVNUFUYAIUUJKUVAUJZUUJFWPUKVIUYQUUKUYMUVDUYQUUKAUWAUWBUWCUYAIU
      YSUWDUKULZUYQUYMAUWAUYLUIRZUYMUHRUYAIUYAUWBVUAUYSUUJWQWKUYLFVHUKULZUYQUVC
      UUNUYFAUWJUWKUWLUYAHUUJUVAUOUWNUKUPZWRWTWLAUVMUVEEUGZUVMUYNEUGZPLUUIUVEEU
      GZUUIUVIEUGZPLUYPUVKAVUDVUFVUEVUGPAVUDVUFFUVAUELZCUVAUVAMLZNLZDUVANLZOLZO
      LZPLVUFKPLVUFAUVEVUMEKFAFUHKVQVRZIWSXAUYQUUKUVDUYTVUCUPZUUJUVAUFZUUKVUHUV
      DVULOUUJUVAFUEXBVUPUVCVUJUUNVUKOVUPUVBVUICNUUJUVAUVAMXBTUUJUVADNXBVOVOXCA
      VUMKVUFPAVUMKVULOLKAVUHKVULOAUWAUVAUIRUVAKXDXEZFUVAXDXEZXFVUHKUFIAUVAAUWA
      UVAUHRZIFWGWKZWAAVURVUQAFAFIXGXLXHUVAFXIXJVIAVULAVUJVUKAVUJCKNLZSAVUIKCNA
      UVAAUVAVUTULZXKTAUWFKUHRZVVASRGXMCKUNXNXOAUWJVUSVUKSRHVUTDUVAUNXPUPXQVNTA
      VUFAUUIUVEEUYKAUVQUYAUVESRUYEVUOWFZXRYCWHAVUEFQXSZUELZCUVAKMLZNLZDKNLZOLZ
      OLZKQPLZUVAUCLZUYNEUGZPLKVUGPLVUGAUYNVVKEKUVAAUVAUHVUNVUTWSXAUYQUYMUVDVUB
      VUCUPZUUJKUFZUYMVVFUVDVVJOVVPUYLVVEFUEVVPUYLKQMLVVEUUJKQMXTQYAYDTVVPUVCVV
      HUUNVVIOVVPUVBVVGCNUUJKUVAMXBTUUJKDNXBVOVOYBAVVKKVVNVUGPAVVKKVVJOLKAVVFKV
      VJOAUWAVVFKUFZIUWAVVEUIRZVVEKXDXEZFVVEXDXEZXFVVQQUIRZVVRYEQYFYGVVSVVTKQXD
      XEZVVSYHQYIRVWBVVSYOYPQYJYGYKYLVVEFXIYMWKVIAVVJAVVHVVIAVVHCUVANLZSAVVGUVA
      CNAUVAVVBYNTAUWFVUSVWCSRGVUTCUVAUNXPXOAUWJVVCVVISRHXMDKUNXNUPXQVNAVVNUUIF
      UAUDZUELZCFVWDMLZNLZDVWDQPLZNLZOLZOLZUAUGZVUGAVWLVVMUYMCFUYLMLZNLZDUYLQPL
      ZNLZOLZOLZEUGVVNAVWKVWRUAEQKFVWAAYEVLKUIRAYQVLUYDACDVWDFGHIYRVWDUYLUFZVWE
      UYMVWJVWQOVWDUYLFUEXBVWSVWGVWNVWIVWPOVWSVWFVWMCNVWDUYLFMXBTVWSVWHVWODNVWD
      UYLQPXTTVOVOYSAVVMVWRUYNEAUUJVVMRZUBZVWQUVDUYMOVXAVWNUVCVWPUUNOVXAVWMUVBC
      NVXAFUUJQAUXLVWTUWRUSVXAUUJVWTUWBAUUJVVLUVAUJVCUUAZUXSVXAVKVLZUUBTVXAVWOU
      UJDNVXAUUJQVXBVXCUUETVOTWLUUFUUIUVIVWKEUAEUAUUGZUUKVWEUVHVWJOUUJVWDFUEXBV
      XDUUMVWGUVGVWIOVXDUULVWFCNUUJVWDFMXBTVXDUVFVWHDNUUJVWDQPXTTVOVOUUCYDVOAVU
      GAUUIUVIEUYKACDUUJFGHIYRZXRUUDWHVOAUVMUVEUYNEAKUVAWNVUOVVOYTAUUIUVEUVIEUY
      KVVDVXEYTVGVNUSVG $.
  $}

  ${
    $d A k $.  $d A m $.  $d A n $.  $d B k $.  $d B m $.  $d B n $.  $d k m $.
    $d k n $.  $d m n $.  $d N k $.  $d N m $.
    $( A version of the binomial theorem using falling factorials instead of
       exponentials.  (Contributed by Scott Fenton, 13-Mar-2018.) $)
    binomfallfac $p |- ( ( A e. CC /\ B e. CC /\ N e. NN0 ) ->
     ( ( A + B ) FallFac N ) =
      sum_ k e. ( 0 ... N ) ( ( N _C k ) x.
      ( ( A FallFac ( N - k ) ) x. ( B FallFac k ) ) ) ) $=
      ( cc wcel co cfallfac cc0 cfz cbc cmin cmul csu wceq oveq2 oveq2d oveq12d
      c1 oveq1 vm vn cn0 caddc cv wa wi csn cz 0z ax-mp syl6eq oveq1d sumeq12dv
      fzsn adantr eqeq12d imbi2d weq fallfac0 oveqan12d 1t1e1 0cn syl6eqel 0nn0
      ax-1cn bcnn subidi sumsn sylancr addcl syl simprl simprr binomfallfaclem2
      3eqtr4rd simpl id exp31 a2d nn0ind com12 3impia ) AEFZBEFZDUCFZABUDGZDHGZ
      IDJGZDCUEZKGZADWJLGZHGZBWJHGZMGZMGZCNZOZWFWDWEUFZWRWSWGUAUEZHGZIWTJGZWTWJ
      KGZAWTWJLGZHGZWNMGZMGZCNZOZUGWSWGIHGZIUHZIWJKGZAIWJLGZHGZWNMGZMGZCNZOZUGW
      SWGUBUEZHGZIXSJGZXSWJKGZAXSWJLGZHGZWNMGZMGZCNZOZUGWSWGXSSUDGZHGZIYIJGZYIW
      JKGZAYIWJLGZHGZWNMGZMGZCNZOZUGWSWRUGUAUBDWTIOZXIXRWSYSXAXJXHXQWTIWGHPYSXB
      XKXGXPCYSXBIIJGZXKWTIIJPIUIFYTXKOUJIUOUKULYSXGXPOWJXBFZYSXCXLXFXOMWTIWJKT
      YSXEXNWNMYSXDXMAHWTIWJLTQUMRUPUNUQURUAUBUSZXIYHWSUUBXAXTXHYGWTXSWGHPUUBXB
      YAXGYFCWTXSIJPUUBXGYFOUUAUUBXCYBXFYEMWTXSWJKTUUBXEYDWNMUUBXDYCAHWTXSWJLTQ
      UMRUPUNUQURWTYIOZXIYRWSUUCXAYJXHYQWTYIWGHPUUCXBYKXGYPCWTYIIJPUUCXGYPOUUAU
      UCXCYLXFYOMWTYIWJKTUUCXEYNWNMUUCXDYMAHWTYIWJLTQUMRUPUNUQURWTDOZXIWRWSUUDX
      AWHXHWQWTDWGHPUUDXBWIXGWPCWTDIJPUUDXGWPOUUAUUDXCWKXFWOMWTDWJKTUUDXEWMWNMU
      UDXDWLAHWTDWJLTQUMRUPUNUQURWSSAIHGZBIHGZMGZMGZSXQXJWSUUHSSMGZSWSUUGSSMWSU
      UGUUISWDWEUUESUUFSMAUTBUTVAVBULQVBULZWSIEFUUHEFXQUUHOVCWSUUHSEUUJVFVDXPUU
      HCIEWJIOZXLSXOUUGMUUKXLIIKGZSWJIIKPIUCFUULSOVEIVGUKULUUKXNUUEWNUUFMUUKXMI
      AHUUKXMIILGIWJIILPIVCVHULQWJIBHPRRVIVJWSWGEFXJSOABVKWGUTVLVPXSUCFZWSYHYRU
      UMWSYHYRUUMWSUFYHABCXSUUMWDWEVMUUMWDWEVNUUMWSVQYHVRVOVSVTWAWBWC $.
  $}

  ${
    $d A k $.  $d B k $.  $d N k $.
    $( A version of the binomial theorem using rising factorials instead of
       exponentials.  (Contributed by Scott Fenton, 16-Mar-2018.) $)
    binomrisefac $p |- ( ( A e. CC /\ B e. CC /\ N e. NN0 ) ->
     ( ( A + B ) RiseFac N ) =
      sum_ k e. ( 0 ... N ) ( ( N _C k ) x.
      ( ( A RiseFac ( N - k ) ) x. ( B RiseFac k ) ) ) ) $=
      ( cc wcel cn0 cneg cexp co caddc cfallfac cmul cc0 csu wceq neg1cn syl2an
      eqtrd syl2anc w3a c1 cfz cv cbc cmin crisefac 3adant3 oveq1d binomfallfac
      negdi negcl id syl3an oveq2d fzfid expcl mpan 3ad2ant3 wa cz elfzelz bccl
      simp3 nn0cnd simpl1 negcld cle nn0zd zsubcl elfzle2 adantl simpl3 elfznn0
      wbr nn0red subge0d mpbird elnn0z sylanbrc fallfaccl simp2 fsummulc2 addcl
      mulcld risefallfac simpl2 oveq12d sylancr mul4d a1i expaddd eqtr3d adantr
      npcan mul12d sumeq2dv 3eqtr4d ) AEFZBEFZDGFZUAZUBHZDIJZABKJZHZDLJZMJZNDUC
      JZXDDCUDZUEJZAHZDXJUFJZLJZBHZXJLJZMJZMJZMJZCOZXEDUGJZXIXKAXMUGJZBXJUGJZMJ
      ZMJZCOXBXHXDXIXRCOZMJXTXBXGYFXDMXBXGXLXOKJZDLJZYFXBXFYGDLWSWTXFYGPXAABUKU
      HUIWSXLEFZWTXOEFZXAXAYHYFPAULBULXAUMXLXOCDUJUNSUOXBXIXRXDCXBNDUPXAWSXDEFZ
      WTXCEFZXAYKQXCDUQURUSZXBXJXIFZUTZXKXQYOXKXBXAXJVAFZXKGFYNWSWTXAVDZXJNDVBZ
      XJDVCRVEZYOXNXPYOYIXMGFZXNEFYOAWSWTXAYNVFZVGYOXMVAFZNXMVHVOZYTXBDVAFYPUUB
      YNXBDYQVIYRDXJVJRYOUUCXJDVHVOZYNUUDXBXJNDVKVLYODXJYODWSWTXAYNVMVPYOXJYNXJ
      GFZXBXJDVNZVLZVPVQVRXMVSVTZXLXMWATZXBYJUUEXPEFYNXBBWSWTXAWBVGUUFXOXJWARZW
      EZWEWCSXBXEEFZXAYAXHPWSWTUULXAABWDUHYQDXEWFTXBXIYEXSCYOYEXKXDXQMJZMJXSYOY
      DUUMXKMYOYDXCXMIJZXNMJZXCXJIJZXPMJZMJZUUMYOYBUUOYCUUQMYOWSYTYBUUOPUUAUUHX
      MAWFTYOWTUUEYCUUQPWSWTXAYNWGUUGXJBWFTWHYOUURUUNUUPMJZXQMJUUMYOUUNXNUUPXPY
      OYLYTUUNEFQUUHXCXMUQWIUUIYNUUPEFZXBYNYLUUEUUTQUUFXCXJUQWIVLUUJWJYOUUSXDXQ
      MYOXCXMXJKJZIJUUSXDYOXCXMXJYLYOQWKUUGUUHWLYOUVADXCIXBDEFXJEFUVADPYNXBDYQV
      EYNXJUUFVEDXJWORUOWMUISSUOYOXKXDXQYSXBYKYNYMWNUUKWPSWQWR $.
  $}


  ${
    $d A k $.  $d N k $.
    $( Represent the falling factorial via factorials when the first argument
       is a natural.  (Contributed by Scott Fenton, 20-Mar-2018.) $)
    fallfacval4 $p |- ( N e. ( 0 ... A ) ->
      ( A FallFac N ) = ( ( ! ` A ) / ( ! ` ( A - N ) ) ) ) $=
      ( vk cc0 cfz co wcel c1 cmin cprod cdiv cfa cfv fzfid zcnd adantl cn wceq
      wbr syl cv cfallfac caddc cmul cc elfzelz fprodcl wa elfznn nncnd fprodn0
      nnne0d divcan3d clt cin fznn0sub nn0red ltp1d fzdisj cuz cun nn0p1nn nnuz
      c0 cn0 syl6eleq nn0zd elfzel2 elfzle1 zred subge02d mpbid eluz2 syl3anbrc
      cz cle fzsplit2 syl2anc fprodsplit oveq1d ax-1cn a1i prodeq1d fallfacval3
      subsubd 3eqtr4rd elfz3nn0 fprodfac oveq12d 3eqtr4d ) BDAEFGZABHIFIFZAEFZC
      UAZCJZHAEFZWNCJZHABIFZEFZWNCJZKFZABUBFALMZWRLMZKFWKWTWRHUCFZAEFZWNCJZUDFZ
      WTKFXFXAWOWKXFWTWKXEWNCWKXDANWNXEGZWNUEGZWKXHWNWNXDAUFOPUGWKWSWNCWKHWRNZW
      KWNWSGZUHZWNXKWNQGWKWNWRUIPZUJZUGWKWSWNCXJXNXLWNXMULUKUMWKWQXGWTKWKWSXEWN
      WPCWKWRXDUNSWSXEUOVDRWKWRWKWRBDAUPZUQURHWRXDAUSTWKXDHUTMZGAWRUTMGZWPWSXEV
      ARWKXDQXPWKWRVEGZXDQGXOWRVBTVCVFWKWRVOGAVOGWRAVPSZXQWKWRXOVGBDAVHZWKDBVPS
      XSBDAVIWKABWKAXTVJWKBBDAUFZVJVKVLWRAVMVNWRHAVQVRWKHANWNWPGZXIWKYBWNWNAUIU
      JPVSVTWKWMXEWNCWKWLXDAEWKABHWKAXTOWKBYAOHUEGWKWAWBWEVTWCWFACBWDWKXBWQXCWT
      KWKAVEGXBWQRBAWGACWHTWKXRXCWTRXOWRCWHTWIWJ $.
  $}

  $( Binomial coefficient in terms of falling factorials.  (Contributed by
     Scott Fenton, 20-Mar-2018.) $)
  bcfallfac $p |- ( K e. ( 0 ... N ) ->
    ( N _C K ) = ( ( N FallFac K ) / ( ! ` K ) ) ) $=
    ( cc0 cfz co wcel cfa cfv cmin cdiv cmul cfallfac cbc cn0 cn elfz3nn0 faccl
    syl nncnd nnne0d fznn0sub elfznn0 divdiv1d fallfacval4 oveq1d 3eqtr4rd
    bcval2 ) ACBDEFZBGHZBAIEZGHZJEZAGHZJEUIUKUMKEJEBALEZUMJEBAMEUHUIUKUMUHUIUHB
    NFUIOFABPBQRSUHUKUHUJNFUKOFACBUAUJQRZSUHUMUHANFUMOFABUBAQRZSUHUKUOTUHUMUPTU
    CUHUNULUMJBAUDUEABUGUF $.

  $( Relate falling factorial to factorial.  (Contributed by Scott Fenton,
     5-Jan-2018.) $)
  fallfacfac $p |- ( N e. NN0 -> ( N FallFac N ) = ( ! ` N ) ) $=
    ( cn0 wcel cfallfac co cfa cfv cmin cdiv c1 cc0 cfz wceq nn0fz0 fallfacval4
    sylbi nn0cn subidd fveq2d fac0 syl6eq oveq2d faccl nncnd div1d 3eqtrd ) ABC
    ZAADEZAFGZAAHEZFGZIEZUIJIEUIUGAKALECUHULMANAAOPUGUKJUIIUGUKKFGJUGUJKFUGAAQR
    STUAUBUGUIUGUIAUCUDUEUF $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Factorial limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d a b $.  $d a k $.  $d a n $.  $d b n $.  $d b x $.  $d k n $.  $d M a $.
    $d M b $.  $d M k $.  $d M n $.  $d M x $.
    $( Lemma for ~ faclim .  Closed form for a particular sequence.
       (Contributed by Scott Fenton, 15-Dec-2017.) $)
    faclimlem1 $p |- ( M e. NN0 ->
     seq 1 ( x. , ( n e. NN |-> ( ( ( 1 + ( M / n ) ) x. ( 1 + ( 1 / n ) ) ) /
     ( 1 + ( ( M + 1 ) / n ) ) ) ) ) =
     ( x e. NN |-> ( ( M + 1 ) x. ( ( x + 1 ) / ( x + ( M + 1 ) ) ) ) ) ) $=
      ( vb wcel cmul cn c1 cdiv co caddc wceq oveq1 oveq12d oveq2d oveq2 3eqtrd
      cfv a1i rpcnd va vk cv cmpt cseq wral wa wi fveq2 cz 1z seq1 ax-mp syl6eq
      cn0 eqeq12d imbi2d weq eqid fvmpt nn0cn div1d ax-1cn div1i oveq2i nn0p1nn
      1nn ovex nncnd addcomd oveq1d addcli nnaddcld nnne0d divassd syl5eq seqp1
      cc cuz nnuz eleq2s adantr adantl peano2nn syl nnrpd rpaddcld rpdivcld crp
      simpl cr nn0re nndivred recnd cc0 cle wbr nn0ge0 divge0d ge0p1rpd eqeltrd
      1rp rpreccld rpmulcld mulassd rpne0d divcan5d mul12d adddid mulid1d simpr
      nn0cnd divcan2d addassd eqtrd eqtr3d divcan1d 3eqtr3rd exp31 nnind impcom
      a2d eqtr4d ralrimiva wfn wb seqfn fneq2i mpbir fnmpti eqfnfv mp2an sylibr
      ) CUOEZDUCZFBGHCBUCZIJZKJZHHYPIJZKJZFJZHCHKJZYPIJZKJZIJZUDZHUEZRZYOAGUUBA
      UCZHKJZUUIUUBKJZIJZFJZUDZRZLZDGUFZUUGUUNLZYNUUPDGYNYOGEZUGUUHUUBYOHKJZYOU
      UBKJZIJZFJZUUOUUSYNUUHUVCLZYNUAUCZUUGRZUUBUVEHKJZUVEUUBKJZIJZFJZLZUHYNHUU
      FRZUUBHHKJZHUUBKJZIJZFJZLZUHYNUBUCZUUGRZUUBUVRHKJZUVRUUBKJZIJZFJZLZUHYNUV
      TUUGRZUUBUVTHKJZUVTUUBKJZIJZFJZLZUHYNUVDUHUAUBYOUVEHLZUVKUVQYNUWKUVFUVLUV
      JUVPUWKUVFHUUGRZUVLUVEHUUGUIHUJEZUWLUVLLUKFUUFHULUMUNUWKUVIUVOUUBFUWKUVGU
      VMUVHUVNIUVEHHKMUVEHUUBKMNOUPUQUAUBURZUVKUWDYNUWNUVFUVSUVJUWCUVEUVRUUGUIU
      WNUVIUWBUUBFUWNUVGUVTUVHUWAIUVEUVRHKMUVEUVRUUBKMNOUPUQUVEUVTLZUVKUWJYNUWO
      UVFUWEUVJUWIUVEUVTUUGUIUWOUVIUWHUUBFUWOUVGUWFUVHUWGIUVEUVTHKMUVEUVTUUBKMN
      OUPUQUADURZUVKUVDYNUWPUVFUUHUVJUVCUVEYOUUGUIUWPUVIUVBUUBFUWPUVGUUTUVHUVAI
      UVEYOHKMUVEYOUUBKMNOUPUQYNUVLHCHIJZKJZHHHIJZKJZFJZHUUBHIJZKJZIJZUVPHGEZUV
      LUXDLVGBHUUEUXDGUUFYPHLZUUAUXAUUDUXCIUXFYRUWRYTUWTFUXFYQUWQHKYPHCIPOUXFYS
      UWSHKYPHHIPONUXFUUCUXBHKYPHUUBIPONUUFUSZUXAUXCIVHUTUMYNUXDHCKJZUVMFJZUVNI
      JUUBUVMFJZUVNIJUVPYNUXAUXIUXCUVNIYNUWRUXHUWTUVMFYNUWQCHKYNCCVAZVBOUWTUVML
      YNUWSHHKHVCVDVESNYNUXBUUBHKYNUUBYNUUBCVFZVIZVBONYNUXIUXJUVNIYNUXHUUBUVMFY
      NHCHVREZYNVCSUXKVJVKVKYNUUBUVMUVNUXMUVMVREYNHHVCVCVLSYNUVNYNHUUBUXEYNVGSU
      XLVMZVIYNUVNUXOVNVOQVPUVRGEZYNUWDUWJUXPYNUWDUWJUXPYNUGZUWDUGUWEUVSUVTUUFR
      ZFJZUWCUXRFJZUWIUXQUWEUXSLZUWDUXPUYAYNUYAUVRHVSRZGFUUFHUVRVQVTWAWBWBUWDUX
      SUXTLUXQUVSUWCUXRFMWCUXQUXTUWILUWDUXQUXTUWCHCUVTIJZKJZHHUVTIJZKJZFJZHUUBU
      VTIJZKJZIJZFJZUUBUWBUYJFJZFJUWIUXPUXTUYKLYNUXPUXRUYJUWCFUXPUVTGEZUXRUYJLU
      VRWDZBUVTUUEUYJGUUFYPUVTLZUUAUYGUUDUYIIUYOYRUYDYTUYFFUYOYQUYCHKYPUVTCIPOU
      YOYSUYEHKYPUVTHIPONUYOUUCUYHHKYPUVTUUBIPONUXGUYGUYIIVHUTWEOWBUXQUUBUWBUYJ
      UXQUUBYNUUBGEUXPUXLWCZVIZUXQUWBUXQUVTUWAUXQUVTUXPUYMYNUYNWBZWFZUXQUVRUUBU
      XQUVRUXPYNWJZWFUXQUUBUYPWFZWGZWHZTZUXQUYJUXQUYGUYIUXQUYDUYFUXQUYDUYCHKJWI
      UXQHUYCUXNUXQVCSZUXQUYCUXQCUVTYNCWKEUXPCWLWCZUYRWMZWNZVJUXQUYCVUGUXQCUVTV
      UFUYSYNWOCWPWQUXPCWRWCWSWTXAZUXQHUYEHWIEUXQXBSZUXQUVTUYSXCZWGZXDZUXQHUYHV
      UJUXQUUBUVTVUAUYSWHZWGZWHTXEUXQUYLUWHUUBFUXQUVTUWBUYGFJZFJZUVTUYIFJZIJVUP
      UYIIJUWHUYLUXQVUPUYIUVTUXQVUPUXQUWBUYGVUCVUMXDTUXQUYIVUOTZUXQUVTUYRVIZUXQ
      UYIVUOXFZUXQUVTUYRVNZXGUXQVUQUWFVURUWGIUXQVUQUWBUVTUYGFJZFJUWBUWAUYFFJZFJ
      ZUWFUXQUVTUWBUYGVUTVUDUXQUYGVUMTZXHUXQVVCVVDUWBFUXQUVTUYDFJZUYFFJVVCVVDUX
      QUVTUYDUYFVUTUXQUYDVUITUXQUYFVULTZXEUXQVVGUWAUYFFUXQVVGUVTHFJZUVTUYCFJZKJ
      UVTCKJZUWAUXQUVTHUYCVUTVUEVUHXIUXQVVIUVTVVJCKUXQUVTVUTXJZUXQCUVTUXQCUXPYN
      XKXLZVUTVVBXMNUXQVVKUVRUXHKJUWAUXQUVRHCUXQUVRUYTVIVUEVVMXNUXQUXHUUBUVRKUX
      QHCVUEVVMVJOXOQVKXPOUXQUWBUWAFJZUYFFJZVVEUWFUXQUWBUWAUYFVUDUXQUWAVUBTZVVH
      XEUXQVVOUVTUYFFJVVIUVTUYEFJZKJUWFUXQVVNUVTUYFFUXQUVTUWAVUTVVPUXQUWAVUBXFX
      QVKUXQUVTHUYEVUTVUEUXQUYEVUKTXIUXQVVIUVTVVQHKVVLUXQHUVTVUEVUTVVBXMNQXPQUX
      QVURVVIUVTUYHFJZKJUWGUXQUVTHUYHVUTVUEUXQUYHVUNTXIUXQVVIUVTVVRUUBKVVLUXQUU
      BUVTUYQVUTVVBXMNXONUXQUWBUYGUYIVUDVVFVUSVVAVOXROQWBQXSYBXTYAUUSUUOUVCLYNA
      YOUUMUVCGUUNADURZUULUVBUUBFVVSUUJUUTUUKUVAIUUIYOHKMUUIYOUUBKMNOUUNUSZUUBU
      VBFVHUTWCYCYDUUGGYEZUUNGYEUURUUQYFVWAUUGUYBYEZUWMVWBUKFUUFHYGUMGUYBUUGVTY
      HYIAGUUMUUNUUBUULFVHVVTYJDGUUGUUNYKYLYM $.
  $}

  ${
    $d k m $.  $d M k $.  $d M m $.  $d M n $.
    $( Lemma for ~ faclim .  Show a limit for the inductive step.  (Contributed
       by Scott Fenton, 15-Dec-2017.) $)
    faclimlem2 $p |- ( M e. NN0 ->
     seq 1 ( x. ,
     ( n e. NN |-> ( ( ( 1 + ( M / n ) ) x. ( 1 + ( 1 / n ) ) ) /
     ( 1 + ( ( M + 1 ) / n ) ) ) ) ) ~~> ( M + 1 ) ) $=
      ( vm vk wcel cmul cn c1 cv cdiv co caddc cmpt cli cvv nnuz cc nnex adantl
      a1i cn0 cseq faclimlem1 cz ax-1cn nn0p1nn nnzd mptex cfv wceq weq oveq12d
      1z oveq1 eqid ovex fvmpt divcnvlin nncnd wa peano2nn nnred simpr nnaddcld
      adantr nndivred ffvelrnda oveq2d eqtr4d climmulc2 mulid1d breqtrd eqbrtrd
      recnd fmptd ) BUAEZFAGHBAIZJKLKHHVQJKLKFKHBHLKZVQJKLKJKMHUBCGVRCIZHLKZVSV
      RLKZJKZFKZMZVRNCABUCVPWDVRHFKVRNVPHVRDCGWBMZWDHOGPHUDEVPUMTZVPHVRDWEHOGPW
      FHQEVPUETVPVRBUFZUGWEOEVPCGWBRUHTDIZGEZWHWEUIZWHHLKZWHVRLKZJKZUJVPCWHWBWM
      GWECDUKZVTWKWAWLJVSWHHLUNVSWHVRLUNULZWEUOZWKWLJUPUQZSURVPVRWGUSZWDOEVPCGW
      CRUHTVPGQWHWEVPCGWBQWEVPVSGEZUTZWBWTVTWAWTVTWSVTGEVPVSVASVBWTVSVRVPWSVCVP
      VRGEWSWGVEVDVFVNWPVOVGWIWHWDUIZVRWJFKZUJVPWIXAVRWMFKZXBCWHWCXCGWDWNWBWMVR
      FWOVHWDUOVRWMFUPUQWIWJWMVRFWQVHVISVJVPVRWRVKVLVM $.
  $}

  $( Lemma for ~ faclim .  Algebraic manipulation for the final induction.
     (Contributed by Scott Fenton, 15-Dec-2017.) $)
  faclimlem3 $p |- ( ( M e. NN0 /\ B e. NN ) ->
  ( ( ( 1 + ( 1 / B ) ) ^ ( M + 1 ) ) / ( 1 + ( ( M + 1 ) / B ) ) ) =
  ( ( ( ( 1 + ( 1 / B ) ) ^ M ) / ( 1 + ( M / B ) ) ) x.
    ( ( ( 1 + ( M / B ) ) x. ( 1 + ( 1 / B ) ) ) / ( 1 + ( ( M + 1 ) / B ) ) )
    ) ) $=
    ( cn0 wcel c1 cdiv caddc cexp cmul crp 1rp a1i adantl rpaddcld rpcnd adantr
    co rpne0d oveq1d rpdivcld cn wa nnrp rpreccld simpl cz nn0z rpexpcl syl2anr
    expp1d cc ax-1cn cr nn0re simpr nndivred addcomd cc0 cle wbr nn0ge0 divge0d
    recnd ge0p1rpd eqeltrd divcan1d mulassd 3eqtr2d nn0p1nn nnrpd divassd eqtrd
    rpmulcld ) BCDZAUADZUBZEEAFQZGQZBEGQZHQZEVSAFQZGQZFQVRBHQZEBAFQZGQZFQZWEVRI
    QZIQZWBFQWFWGWBFQIQVPVTWHWBFVPVTWCVRIQWFWEIQZVRIQWHVPVRBVPVRVPEVQEJDZVPKLZV
    OVQJDVNVOAAUCZUDZMNZOZVNVOUEUJVPWIWCVRIVPWCWEVPWCVOVRJDBUFDWCJDVNVOEVQWJVOK
    LWMNBUGVRBUHUIZOVPWEVPWEWDEGQJVPEWDEUKDVPULLVPWDVPBAVNBUMDVOBUNPZVNVOUOUPZV
    CUQVPWDWRVPBAWQVOAJDVNWLMZVNURBUSUTVOBVAPVBVDVEZOZVPWEWTRVFSVPWFWEVRVPWFVPW
    CWEWPWTTOZXAWOVGVHSVPWFWGWBXBVPWGVPWEVRWTWNVMOVPWBVPEWAWKVPVSAVNVSJDVOVNVSB
    VIVJPWSTNZOVPWBXCRVKVL $.

  ${
    $d A a b m n x $.
    faclim.1 $e |- F =
         ( n e. NN |-> ( ( ( 1 + ( 1 / n ) ) ^ A ) / ( 1 + ( A / n ) ) ) ) $.
    $( An infinite product expression relating to factorials.  Originally due
       to Euler.  (Contributed by Scott Fenton, 22-Nov-2017.) $)
    faclim $p |- ( A e. NN0 -> seq 1 ( x. , F ) ~~> ( ! ` A ) ) $=
      ( wcel cmul c1 cseq cn cdiv co caddc cexp cfa cfv cli wceq cc0 oveq12d cc
      va vm vb vx cn0 cmpt seqeq3 ax-mp wbr oveq2 oveq1 oveq2d mpteq2dv seqeq3d
      cv fveq2 fac0 syl6eq breq12d weq csn cxp 1re nnrecre readdcld recnd exp0d
      cr a1i nncn nnne0 div0d ax-1cn addid1i div1i mpteq2ia fconstmpt wtru nnuz
      eqtr4i cz 1z climprod1 trud eqbrtri cvv simpr seqex faclimlem2 adantr cuz
      wa elnnuz biimpi adantl cfz crp 1rp nnrp rpreccld rpaddcld rpexpcld simpl
      nn0z nn0red nndivred addcomd cle nn0ge0 divge0d ge0p1rpd eqeltrd rpdivcld
      wf rpcnd fmptd elfznn ffvelrn syl2an adantlr mulcl seqcl rpmulcld nn0p1nn
      eqid nnrpd rpdivcl faclimlem3 oveq1d ovex 3eqtr4d sylan2 prodfmul climmul
      fvmpt facp1 breqtrrd ex nn0ind syl5eqbr ) AUEEFCGHZFBIGGBUOZJKZLKZAMKZGAU
      UBJKZLKZJKZUFZGHZANOZPCUUIQUUAUUJQDFCUUIGUGUHFBIUUDUAUOZMKZGUULUUBJKZLKZJ
      KZUFZGHZUULNOZPUIFBIUUDRMKZGRUUBJKZLKZJKZUFZGHZGPUIFBIUUDUBUOZMKZGUVFUUBJ
      KZLKZJKZUFZGHZUVFNOZPUIZFBIUUDUVFGLKZMKZGUVOUUBJKZLKZJKZUFZGHZUVONOZPUIZU
      UJUUKPUIUAUBAUULRQZUURUVEUUSGPUWDUUQUVDFGUWDBIUUPUVCUWDUUMUUTUUOUVBJUULRU
      UDMUJUWDUUNUVAGLUULRUUBJUKULSUMUNUWDUUSRNOGUULRNUPUQURUSUAUBUTZUURUVLUUSU
      VMPUWEUUQUVKFGUWEBIUUPUVJUWEUUMUVGUUOUVIJUULUVFUUDMUJUWEUUNUVHGLUULUVFUUB
      JUKULSUMUNUULUVFNUPUSUULUVOQZUURUWAUUSUWBPUWFUUQUVTFGUWFBIUUPUVSUWFUUMUVP
      UUOUVRJUULUVOUUDMUJUWFUUNUVQGLUULUVOUUBJUKULSUMUNUULUVONUPUSUULAQZUURUUJU
      USUUKPUWGUUQUUIFGUWGBIUUPUUHUWGUUMUUEUUOUUGJUULAUUDMUJUWGUUNUUFGLUULAUUBJ
      UKULSUMUNUULANUPUSUVEFIGVAVBZGHZGPUVDUWHQUVEUWIQUVDBIGUFUWHBIUVCGUUBIEZUV
      CGGJKGUWJUUTGUVBGJUWJUUDUWJUUDUWJGUUCGVHEUWJVCVIUUBVDVEVFVGUWJUVBGRLKGUWJ
      UVARGLUWJUUBUUBVJUUBVKVLULGVMVNURSGVMVOURVPBIGVQVTFUVDUWHGUGUHUWIGPUIVRGI
      VSGWAEZVRWBVIWCWDWEUVFUEEZUVNUWCUWLUVNWLZUWAUVMUVOFKZUWBPUWMUVMUVOUAUVLFB
      IUVIUUDFKZUVRJKZUFZGHZUWAGWFIVSUWKUWMWBVIUWLUVNWGUWAWFEUWMFUVTGWHVIUWLUWR
      UVOPUIUVNBUVFWIWJUWLUULIEZUULUVLOZTEUVNUWLUWSWLZUCUDFTUVKGUULUWSUULGWKOEZ
      UWLUWSUXBUULWMWNWOZUWLUCUOZGUULWPKEZUXDUVKOZTEZUWSUWLITUVKXNUXDIEZUXGUXEU
      WLBIUVJTUVKUWLUWJWLZUVJUXIUVGUVIUXIUUDUVFUXIGUUCGWQEUXIWRVIZUWJUUCWQEUWLU
      WJUUBUUBWSZWTWOXAZUWLUVFWAEUWJUVFXDWJXBUXIUVIUVHGLKWQUXIGUVHGTEUXIVMVIUXI
      UVHUXIUVFUUBUXIUVFUWLUWJXCXEZUWLUWJWGXFZVFXGUXIUVHUXNUXIUVFUUBUXMUWJUUBWQ
      EZUWLUXKWOUWLRUVFXHUIUWJUVFXIWJXJXKXLZXMXOUVKYEZXPUXDUULXQZITUXDUVKXRXSXT
      ZUXDTEUDUOZTEWLUXDUXTFKTEUXAUXDUXTYAWOZYBXTUWLUWSUULUWROZTEUVNUXAUCUDFTUW
      QGUULUXCUWLUXEUXDUWQOZTEZUWSUWLITUWQXNUXHUYDUXEUWLBIUWPTUWQUXIUWPUXIUWOUV
      RUXIUVIUUDUXPUXLYCUXIGUVQUXJUWLUVOWQEUXOUVQWQEUWJUWLUVOUVFYDYFUXKUVOUUBYG
      XSXAXMXOUWQYEZXPUXRITUXDUWQXRXSXTZUYAYBXTUWLUWSUULUWAOUWTUYBFKQUVNUXAUCUV
      KUWQUVTGUULUXCUXSUYFUWLUXEUXDUVTOZUXFUYCFKZQZUWSUXEUWLUXHUYIUXRUWLUXHWLGG
      UXDJKZLKZUVOMKZGUVOUXDJKZLKZJKZUYKUVFMKZGUVFUXDJKZLKZJKZUYRUYKFKZUYNJKZFK
      ZUYGUYHUXDUVFYHUXHUYGUYOQUWLBUXDUVSUYOIUVTBUCUTZUVPUYLUVRUYNJVUCUUDUYKUVO
      MVUCUUCUYJGLUUBUXDGJUJULZYIVUCUVQUYMGLUUBUXDUVOJUJULZSUVTYEUYLUYNJYJYOWOU
      XHUYHVUBQUWLUXHUXFUYSUYCVUAFBUXDUVJUYSIUVKVUCUVGUYPUVIUYRJVUCUUDUYKUVFMVU
      DYIVUCUVHUYQGLUUBUXDUVFJUJULZSUXQUYPUYRJYJYOBUXDUWPVUAIUWQVUCUWOUYTUVRUYN
      JVUCUVIUYRUUDUYKFVUFVUDSVUESUYEUYTUYNJYJYOSWOYKYLXTYMXTYNUWLUWBUWNQUVNUVF
      YPWJYQYRYSYT $.
  $}

  ${
    $d A k x $.
    $( An infinite product expression for factorial.  (Contributed by Scott
       Fenton, 15-Dec-2017.) $)
    iprodfac $p |- ( A e. NN0 -> ( ! ` A ) =
      prod_ k e. NN ( ( ( 1 + ( 1 / k ) ) ^ A ) / ( 1 + ( A / k ) ) ) ) $=
      ( vx cn0 wcel cn c1 cv cdiv co caddc cprod cfv cz a1i oveq2 oveq2d adantr
      cexp crp cfa cmpt nnuz 1z facne0 eqid faclim wceq weq oveq1d oveq12d ovex
      fvmpt adantl wa 1rp simpr nnrpd rpreccld rpaddcld nn0z rpexpcld cc ax-1cn
      nn0re nndivred recnd addcomd cc0 cle wbr nn0ge0 divge0d ge0p1rpd rpdivcld
      cr eqeltrd rpcnd iprodn0 eqcomd ) ADEZFGGBHZIJZKJZASJZGAWBIJZKJZIJZBLAUAM
      ZWAWHBCFGGCHZIJZKJZASJZGAWJIJZKJZIJZUBZGWIFUCGNEWAUDOAUEACWQWQUFZUGWBFEZW
      BWQMWHUHWACWBWPWHFWQCBUIZWMWEWOWGIWTWLWDASWTWKWCGKWJWBGIPQUJWTWNWFGKWJWBA
      IPQUKWRWEWGIULUMUNWAWSUOZWHXAWEWGXAWDAXAGWCGTEXAUPOXAWBXAWBWAWSUQZURZUSUT
      WAANEWSAVARVBXAWGWFGKJTXAGWFGVCEXAVDOXAWFXAAWBWAAVPEWSAVERZXBVFZVGVHXAWFX
      EXAAWBXDXCWAVIAVJVKWSAVLRVMVNVQVOVRVSVT $.
  $}

  ${
    $d a m $.  $d a n $.  $d k m $.  $d k n $.  $d M a $.  $d m n $.  $d M n $.
    faclim2.1 $e |- F =
     ( n e. NN |->
     ( ( ( ! ` n ) x. ( ( n + 1 ) ^ M ) ) / ( ! ` ( n + M ) ) ) ) $.
    $( Another factorial limit due to Euler.  (Contributed by Scott Fenton,
       17-Dec-2017.) $)
    faclim2 $p |- ( M e. NN0 -> F ~~> 1 ) $=
      ( wcel cn cfa cfv c1 caddc cexp cmul cdiv cli cc0 wceq fveq2d oveq12d a1i
      co va vm vk cn0 cv cmpt wbr oveq2 oveq2d mpteq2dv breq1d weq wtru nnuz cz
      1z nnex mptex cc ax-1cn fveq2 oveq1 oveq1d eqid ovex fvmpt peano2nn nncnd
      cvv exp0d nnnn0 faccl syl mulid1d eqtrd nncn addid1d nnne0d dividd adantl
      climconst trud wa simpr nn0p1nn nnzd divcnvlin adantr nnnn0d sylan ancoms
      nnexpcl nnmulcld nnred nnnn0addcl nndivred recnd fmptd ffvelrnda nnaddcld
      adantlr expp1d mulassd eqtr4d nn0addcld nn0cnd addassd 3eqtr3d divmuldivd
      simpl facp1 3eqtr4d climmul 1t1e1 syl6breq ex nn0ind syl5eqbr ) CUDEBAFAU
      EZGHZXSIJTZCKTZLTZXSCJTZGHZMTZUFZINDAFXTYAUAUEZKTZLTZXSYHJTZGHZMTZUFZINUG
      AFXTYAOKTZLTZXSOJTZGHZMTZUFZINUGZAFXTYAUBUEZKTZLTZXSUUBJTZGHZMTZUFZINUGZA
      FXTYAUUBIJTZKTZLTZXSUUJJTZGHZMTZUFZINUGZYGINUGUAUBCYHOPZYNYTINUURAFYMYSUU
      RYJYPYLYRMUURYIYOXTLYHOYAKUHUIUURYKYQGYHOXSJUHQRUJUKUAUBULZYNUUHINUUSAFYM
      UUGUUSYJUUDYLUUFMUUSYIUUCXTLYHUUBYAKUHUIUUSYKUUEGYHUUBXSJUHQRUJUKYHUUJPZY
      NUUPINUUTAFYMUUOUUTYJUULYLUUNMUUTYIUUKXTLYHUUJYAKUHUIUUTYKUUMGYHUUJXSJUHQ
      RUJUKYHCPZYNYGINUVAAFYMYFUVAYJYCYLYEMUVAYIYBXTLYHCYAKUHUIUVAYKYDGYHCXSJUH
      QRUJUKUUAUMIUBYTIVIFUNIUOEZUMUPSYTVIEUMAFYSUQURSIUSEZUMUTSUUBFEZUUBYTHZIP
      UMUVDUVEUUBGHZUUJOKTZLTZUUBOJTZGHZMTZIAUUBYSUVKFYTAUBULZYPUVHYRUVJMUVLXTU
      VFYOUVGLXSUUBGVAUVLYAUUJOKXSUUBIJVBVCRUVLYQUVIGXSUUBOJVBQRYTVDUVHUVJMVEVF
      UVDUVKUVFUVFMTIUVDUVHUVFUVJUVFMUVDUVHUVFILTUVFUVDUVGIUVFLUVDUUJUVDUUJUUBV
      GVHVJUIUVDUVFUVDUVFUVDUUBUDEZUVFFEUUBVKUUBVLVMZVHZVNVOUVDUVIUUBGUVDUUBUUB
      VPVQQRUVDUVFUVOUVDUVFUVNVRVSVOVOVTWAWBUVMUUIUUQUVMUUIWCZUUPIILTINUVPIIUCU
      UHAFYAUUMMTZUFZUUPIVIFUNUVBUVPUPSUVMUUIWDUUPVIEUVPAFUUOUQURSUVMUVRINUGUUI
      UVMIUUJUCUVRIVIFUNUVBUVMUPSUVCUVMUTSUVMUUJUUBWEZWFUVRVIEUVMAFUVQUQURSUCUE
      ZFEZUVTUVRHZUVTIJTZUVTUUJJTZMTZPUVMAUVTUVQUWEFUVRAUCULZYAUWCUUMUWDMXSUVTI
      JVBZXSUVTUUJJVBZRUVRVDZUWCUWDMVEVFZVTWGWHUVMUWAUVTUUHHZUSEUUIUVMFUSUVTUUH
      UVMAFUUGUSUUHUVMXSFEZWCZUUGUWMUUDUUFUWMUUDUWMXTUUCUWMXSUDEXTFEUWMXSUVMUWL
      WDZWIXSVLVMUWLUVMUUCFEZUWLYAFEZUVMUWOXSVGZYAUUBWLWJWKWMWNUWMUUEUDEUUFFEUW
      MUUEUWLUVMUUEFEXSUUBWOWKWIUUEVLVMWPWQUUHVDZWRWSXAUVMUWAUWBUSEUUIUVMFUSUVT
      UVRUVMAFUVQUSUVRUWMUVQUWMYAUUMUWMYAUWLUWPUVMUWQVTWNUWMXSUUJUWNUVMUUJFEZUW
      LUVSWHWTWPWQUWIWRWSXAUVMUWAUVTUUPHZUWKUWBLTZPUUIUVMUWAWCZUVTGHZUWCUUJKTZL
      TZUWDGHZMTZUXCUWCUUBKTZLTZUVTUUBJTZGHZMTZUWELTZUWTUXAUXBUXGUXIUWCLTZUXKUW
      DLTZMTUXMUXBUXEUXNUXFUXOMUXBUXEUXCUXHUWCLTZLTUXNUXBUXDUXPUXCLUXBUWCUUBUXB
      UWCUWAUWCFEZUVMUVTVGZVTVHZUVMUWAXJZXBUIUXBUXCUXHUWCUXBUXCUXBUVTUDEUXCFEUX
      BUVTUVMUWAWDZWIZUVTVLVMZVHUXBUXHUWAUVMUXHFEZUWAUXQUVMUYDUXRUWCUUBWLWJWKZV
      HUXSXCXDUXBUXJIJTZGHZUXKUYFLTZUXFUXOUXBUXJUDEZUYGUYHPUXBUVTUUBUYBUXTXEZUX
      JXKVMUXBUYFUWDGUXBUVTUUBIUXBUVTUYAVHUXBUUBUXTXFUVCUXBUTSXGZQUXBUYFUWDUXKL
      UYKUIXHRUXBUXIUXKUWCUWDUXBUXIUXBUXCUXHUYCUYEWMVHUXBUXKUXBUYIUXKFEUYJUXJVL
      VMZVHUXSUXBUWDUXBUVTUUJUYAUVMUWSUWAUVSWHWTZVHUXBUXKUYLVRUXBUWDUYMVRXIXDUW
      AUWTUXGPUVMAUVTUUOUXGFUUPUWFUULUXEUUNUXFMUWFXTUXCUUKUXDLXSUVTGVAZUWFYAUWC
      UUJKUWGVCRUWFUUMUWDGUWHQRUUPVDUXEUXFMVEVFVTUWAUXAUXMPUVMUWAUWKUXLUWBUWELA
      UVTUUGUXLFUUHUWFUUDUXIUUFUXKMUWFXTUXCUUCUXHLUYNUWFYAUWCUUBKUWGVCRUWFUUEUX
      JGXSUVTUUBJVBQRUWRUXIUXKMVEVFUWJRVTXLXAXMXNXOXPXQXR $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Greatest common divisor and divisibility
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Condition for a prime dividing a square.  (Contributed by Scott Fenton,
     8-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  pdivsq $p |- ( ( P e. Prime /\ M e. ZZ )
      -> ( P || M <-> P || ( M ^ 2 ) ) ) $=
    ( cprime wcel cz wa c2 cexp co cdivides wbr cmul wb sqvald breq2d adantl wo
    zcn euclemma 3anidm23 oridm syl6bb bitr2d ) ACDZBEDZFZABGHIZJKZABBLIZJKZABJ
    KZUEUHUJMUDUEUGUIAJUEBBRNOPUFUJUKUKQZUKUDUEUJULMABBSTUKUAUBUC $.

  ${
    $d K m n $.  $d M m n $.  $d N m n $.
    $( Exponentiation law for divisibility.  (Contributed by Scott Fenton,
       7-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    dvdspw $p |- ( ( K e. ZZ /\ M e. ZZ /\ N e. NN )
        -> ( K || M -> K || ( M ^ N ) ) ) $=
      ( vm cz wcel cn w3a cdivides wbr cv cmul co cexp wa syl2anc adantr zexpcl
      cc zcn wceq wb divides 3adant3 simpl1 simpl3 iddvdsexp cn0 simpr 3ad2ant3
      wrex nnnn0 dvdsmul2 zmulcld dvdstr syl3anc mp2and adantl 3ad2ant1 mulexpd
      wi breqtrrd oveq1 breq2d syl5ibcom rexlimdva sylbid ) AEFZBEFZCGFZHZABIJZ
      DKZALMZBUAZDEUKZABCNMZIJZVHVIVLVPUBVJDABUCUDVKVOVRDEVKVMEFZOZAVNCNMZIJVOV
      RVTAVMCNMZACNMZLMZWAIVTAWCIJZWCWDIJZAWDIJZVTVHVJWEVHVIVJVSUEZVHVIVJVSUFAC
      UGPVTWBEFZWCEFZWFVTVSCUHFZWIVKVSUIVKWKVSVJVHWKVICULUJQZVMCRPZVTVHWKWJWHWL
      ACRPZWBWCUMPVTVHWJWDEFWEWFOWGVAWHWNVTWBWCWMWNUNAWCWDUOUPUQVTVMACVSVMSFVKV
      MTURVKASFZVSVHVIWOVJATUSQWLUTVBVOWAVQAIVNBCNVCVDVEVFVG $.
  $}

  $( Swap the second and third arguments of a gcd.  (Contributed by Scott
     Fenton, 8-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  gcd32 $p |- ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) ->
    ( ( A gcd B ) gcd C ) = ( ( A gcd C ) gcd B ) ) $=
    ( cz wcel w3a cgcd co wceq wa gcdcom oveq2d 3adant1 gcdass 3com23 3eqtr4d )
    ADEZBDEZCDEZFABCGHZGHZACBGHZGHZABGHCGHACGHBGHZRSUAUCIQRSJTUBAGBCKLMCBANQSRU
    DUCIBCANOP $.

  $( Absorption law for gcd.  (Contributed by Scott Fenton, 8-Apr-2014.)
     (Revised by Mario Carneiro, 19-Apr-2014.) $)
  gcdabsorb $p |- ( ( A e. ZZ /\ B e. ZZ ) -> ( ( A gcd B ) gcd B ) = ( A gcd B
      ) ) $=
    ( cz wcel wa cgcd cabs cfv wceq gcdass 3anidm23 gcdid oveq2d adantl gcdabs2
    co 3eqtrd ) ACDZBCDZEABFPZBFPZABBFPZFPZABGHZFPZTRSUAUCIBBAJKSUCUEIRSUBUDAFB
    LMNBAOQ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Properties of relationships
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    brtp.1 $e |- X e. _V $.
    brtp.2 $e |- Y e. _V $.
    $( A condition for a binary relation over an unordered triple.
       (Contributed by Scott Fenton, 8-Jun-2011.) $)
    brtp $p |- ( X { <. A , B >. , <. C , D >. , <. E , F >. } Y <->
                 ( ( X = A /\ Y = B ) \/
                   ( X = C /\ Y = D ) \/
                   ( X = E /\ Y = F ) ) ) $=
      ( cop ctp wbr wcel wceq w3o wa df-br opex opth eltp 3orbi123i 3bitri ) GH
      ABKZCDKZEFKZLZMGHKZUGNUHUDOZUHUEOZUHUFOZPGAOHBOQZGCOHDOQZGEOHFOQZPGHUGRUH
      UDUEUFGHSUAUIULUJUMUKUNGHABIJTGHCDIJTGHEFIJTUBUC $.
  $}

  ${
    $d A x y $.
    dftr6.1 $e |- A e. _V $.
    $( A potential definition of transitivity for sets.  (Contributed by Scott
       Fenton, 18-Mar-2012.) $)
    dftr6 $p |- ( Tr A <-> A e. ( _V \ ran ( ( _E o. _E ) \ _E ) ) ) $=
      ( vx vy wel cv wcel wa wi wal cep cdif wn cvv wbr wex epelc anbi12i exbii
      3bitri ccom crn wtr elrn brdif vex brco epel notbii 19.41v exanali bitr3i
      bitri exnal con2bii dftr2 eldif mpbiran 3bitr4i ) CDEZDFZAGZHZCFZAGZIDJZC
      JZAKKUAZKLZUBZGZMZAUCANVJLGZVKVGVKVDAVIOZCPVFMZCPVGMCAVIBUDVNVOCVNVDAVHOZ
      VDAKOZMZHVCDPZVEMZHZVOVDAVHKUEVPVSVRVTVPVDVAKOZVAAKOZHZDPVSDVDAKKCUFBUGWD
      VCDWBUTWCVBCDUHVAABQRSUMVQVEVDABQUIRWAVCVTHDPVOVCVTDUJVCVEDUKULTSVFCUNTUO
      CDAUPVMANGVLBANVJUQURUS $.
  $}

  ${
    $d A x $.  $d B x $.  $d R x $.
    coep.1 $e |- A e. _V $.
    coep.2 $e |- B e. _V $.
    $( Composition with epsilon.  (Contributed by Scott Fenton,
       18-Feb-2013.) $)
    coep $p |- ( A ( _E o. R ) B <-> E. x e. B A R x ) $=
      ( cv wbr cep wa wex wcel ccom wrex epelc anbi2i ancom bitri exbii brco
      df-rex 3bitr4i ) BAGZDHZUCCIHZJZAKUCCLZUDJZAKBCIDMHUDACNUFUHAUFUDUGJUHUEU
      GUDUCCFOPUDUGQRSABCIDEFTUDACUAUB $.

    $( Composition with the converse of epsilon.  (Contributed by Scott Fenton,
       18-Feb-2013.) $)
    coepr $p |- ( A ( R o. `' _E ) B <-> E. x e. A x R B ) $=
      ( cv cep ccnv wbr wa wex wcel ccom wrex vex brcnv epelc bitri anbi1i brco
      exbii df-rex 3bitr4i ) BAGZHIZJZUECDJZKZALUEBMZUHKZALBCDUFNJUHABOUIUKAUGU
      JUHUGUEBHJUJBUEHEAPQUEBERSTUBABCDUFEFUAUHABUCUD $.
  $}

  ${
    $d R x y z $.  $d A x y z $.
    $( A quantifier free definition of a well-founded relationship.
       (Contributed by Scott Fenton, 11-Apr-2011.) $)
    dffr5 $p |- ( R Fr A <->
                  ( ~P A \ { (/) } ) C_ ran ( _E \ ( _E o. `' R ) ) ) $=
      ( vx vz vy cv c0 cdif wcel cep wi wal wss wa wbr wrex vex anbi12i bitri
      wn cpw csn ccnv ccom crn wne wral wfr eldif elpw necon3bbii wex wel brdif
      elsn epel coep brcnv rexbii dfrex2 3bitrri con1bii df-rex 3bitr4i imbi12i
      exbii elrn albii dfss2 df-fr 3bitr4ri ) CFZAUAZGUBZHZIZVLJJBUCZUDZHZUEZIZ
      KZCLVLAMZVLGUFZNZDFZEFZBOZTDVLUGZEVLPZKZCLVOVTMABUHWBWKCVPWEWAWJVPVLVMIZV
      LVNIZTZNWEVLVMVNUIWLWCWNWDVLACQZUJWMVLGCGUOUKRSWGVLVSOZEULECUMZWINZEULWAW
      JWPWREWPWGVLJOZWGVLVROZTZNWRWGVLJVRUNWSWQXAWIECUPWIWTWTWGWFVQOZDVLPWHDVLP
      WITDWGVLVQEQZWOUQXBWHDVLWGWFBXCDQURUSWHDVLUTVAVBRSVFEVLVSWOVGWIEVLVCVDVEV
      HCVOVTVICEDABVJVK $.
  $}

  ${
    $d A x y $.  $d R x y $.
    $( Quantifier free definition of a strict order.  (Contributed by Scott
       Fenton, 22-Feb-2013.) $)
    dfso2 $p |- ( R Or A <->
              ( R Po A /\ ( A X. A ) C_ ( R u. ( _I u. `' R ) ) ) ) $=
      ( vx vy wor wpo cv wbr wral wa cid cun wcel wi wal wo brun bitr2i 3bitr4i
      vex weq w3o cxp ccnv wss df-so cop opelxp ideq brcnv orbi12i orbi2i df-br
      3orass imbi12i 2albii wrel wb relxp ssrel ax-mp r2al anbi2i bitr4i ) ABEA
      BFZCGZDGZBHZCDUAZVGVFBHZUBZDAICAIZJVEAAUCZBKBUDZLZLZUEZJCDABUFVQVLVEVFVGU
      GZVMMZVRVPMZNZDOCOZVFAMVGAMJZVKNZDOCOVQVLWAWDCDVSWCVTVKVFVGAAUHVKVFVGVPHZ
      VTVHVIVJPZPVHVFVGVOHZPVKWEWFWGVHWGVFVGKHZVFVGVNHZPWFVFVGKVNQWHVIWIVJVFVGD
      TZUIVFVGBCTWJUJUKRULVHVIVJUNVFVGBVOQSVFVGVPUMRUOUPVMUQVQWBURAAUSCDVMVPUTV
      AVKCDAAVBSVCVD $.
  $}

  ${
    $d R x y z w $.  $d A x y z w $.
    $( Quantifier free definition of a partial ordering.  (Contributed by Scott
       Fenton, 22-Feb-2013.) $)
    dfpo2 $p |- ( R Po A <-> ( ( R i^i ( _I |` A ) ) = (/) /\
           ( ( R i^i ( A X. A ) ) o. ( R i^i ( A X. A ) ) ) C_ R ) ) $=
      ( vx vy vz vw cid cin c0 wceq wa wb wbr wn wi wral wcel wal eleq1 df-br
      wpo cres cxp ccom wss po0 res0 ineq2i in0 eqtri xp0 coeq2i eqsstri pm3.2i
      0ss poeq2 reseq2 ineq2d eqeq1d xpeq2 coeq2d sseq1d anbi12d bibi12d mpbiri
      co02 2th wne cv r19.28zv ralbidv bitrd r19.26 syl6bb disj df-ral cop opex
      df-po syl6bbr cvv vex ididg ax-mp brres mpbiran bitr3i imbi12d spcv con2d
      notbid alrimiv wex wrel relres elrel ancri weq breq12 anidms breq2 imbi2d
      mpan spv biimpcd syl ideq anbi1i 3bitr3ri syl5ibrcom exlimdvv syl5 impbii
      imp3a bitr4i 3bitri wrex ralcom r19.23v bitri brin anbi12i an4 ancom brxp
      ralbii anandi 3bitr4i anass exbii brco df-rex r19.42v imbi12i 2albii r2al
      impexp relco ssrel bitr2i 3bitr4g pm2.61ine ) ABUAZBGAUBZHZIJZBAAUCZHZUUH
      UDZBUEZKZLZAIAIJZUULIBUAZBGIUBZHZIJZUUHBAIUCZHZUDZBUEZKZLUUNUVBBUFUUQUVAU
      UPBIHZIUUOIBGUGUHBUIZUJUUTIBUUTUUHIUDIUUSIUUHUUSUVCIUURIBAUKUHUVDUJULUUHV
      FUJBUOUMUNVGUUMUUCUUNUUKUVBAIBUPUUMUUFUUQUUJUVAUUMUUEUUPIUUMUUDUUOBAIGUQU
      RUSUUMUUIUUTBUUMUUHUUSUUHUUMUUGUURBAIAUTURVAVBVCVDVEAIVHZCVIZUVFBMZNZUVFD
      VIZBMZUVIEVIZBMZKZUVFUVKBMZOZKEAPZDAPZCAPZUVHCAPZUVOEAPZDAPZCAPZKZUUCUUKU
      VEUVRUVHUWAKZCAPUWCUVEUVQUWDCAUVEUVQUVHUVTKZDAPUWDUVEUVPUWEDAUVHUVOEAVJVK
      UVHUVTDAVJVLVKUVHUWACAVMVNCDEABVSUUFUVSUUJUWBUUFFVIZUUDQZNZFBPUWFBQZUWHOZ
      FRZUVSFBUUDVOUWHFBVPUWKUVFAQZUVHOZCRZUVSUWKUWNUWKUWMCUWKUVGUWLUWJUVGUWLNZ
      OFUVFUVFVQZUVFUVFVRUWFUWPJZUWIUVGUWHUWOUWQUWIUWPBQUVGUWFUWPBSUVFUVFBTVTUW
      QUWGUWLUWQUWGUWPUUDQZUWLUWFUWPUUDSUWLUVFUVFUUDMZUWRUWSUVFUVFGMZUWLUVFWAQU
      WTCWBZUVFWAWCWDUVFUVFGAUXAWEWFUVFUVFUUDTWGVTWKWHWIWJWLUWNUWJFUWNUWGUWIUWG
      UWFUVIUVKVQZJZEWMDWMZUWGKUWNUWINZUWGUXDUUDWNUWGUXDGAWODEUWFUUDWPXCWQUWNUX
      DUWGUXEUWNUXCUWGUXEOZDEUWNUXFUXCDEWRZUVIAQZKZUVLNZOZUWNUXHUVIUVIBMZNZOZUX
      KUWMUXNCDCDWRZUWLUXHUVHUXMUVFUVIASUXOUVGUXLUXOUVGUXLLUVFUVIUVFUVIBWSWTWKW
      HXDUXNUXGUXHUXJUXGUXNUXHUXJOUXGUXMUXJUXHUXGUXLUVLUVIUVKUVIBXAWKXBXEXNXFUX
      CUWGUXIUXEUXJUXCUWGUXBUUDQZUXIUWFUXBUUDSUVIUVKUUDMUVIUVKGMZUXHKUXPUXIUVIU
      VKGAEWBZWEUVIUVKUUDTUXQUXGUXHUVIUVKUXRXGXHXIVTUXCUWIUVLUXCUWIUXBBQUVLUWFU
      XBBSUVIUVKBTVTWKWHXJXKXNXLWJWLXMUVHCAVPXOXPUWBUVMDAXQZUVNOZEAPZCAPZUUJUWA
      UYACAUWAUVODAPZEAPUYAUVODEAAXRUYCUXTEAUVMUVNDAXSYFXTYFUWLUVKAQZKZUXSKZUVN
      OZERCRZUVFUVKVQZUUIQZUYIBQZOZERCRZUYBUUJUYGUYLCEUYFUYJUVNUYKUVFUVIUUHMZUV
      IUVKUUHMZKZDWMZUXHUYEUVMKZKZDWMZUYJUYFUYPUYSDUYPUVJUVFUVIUUGMZKZUVLUVIUVK
      UUGMZKZKZUXHUYEKZUVMKZUYSUYNVUBUYOVUDUVFUVIBUUGYAUVIUVKBUUGYAYBVUEUVMVUAV
      UCKZKVUHUVMKVUGUVJVUAUVLVUCYCUVMVUHYDVUHVUFUVMUWLUXHKZUXHUYDKZKUXHUWLKZVU
      JKVUHVUFVUIVUKVUJUWLUXHYDXHVUAVUIVUCVUJUVFUVIAAYEUVIUVKAAYEYBUXHUWLUYDYGY
      HXHXPUXHUYEUVMYIXPYJUYQUVFUVKUUIMUYJDUVFUVKUUHUUHUXAUXRYKUVFUVKUUITWGUYTU
      YRDAXQUYFUYRDAYLUYEUVMDAYMWGXIUVFUVKBTYNYOUYBUYEUXTOZERCRUYHUXTCEAAYPUYGV
      ULCEUYEUXSUVNYQYOXOUUIWNUUJUYMLUUHUUHYRCEUUIBYSWDYHYTYBUUAUUB $.
  $}

  ${
    $d b ch $.  $d e et $.  $d a b c d e f g h p q P $.  $d a ps $.  $d g si $.
    $d a b c d e f g h p q x A $.  $d p q x ph $.  $d a b c d e f g h x rh $.
    $d a b c d e f g h p q x B $.  $d a b c d e f g h p q x C $.  $d d ta $.
    $d a b c d e f g h p q x D $.  $d a b c d e f g h p q x E $.  $d c th $.
    $d a b c d e f g h p q x F $.  $d a b c d e f g h p q x G $.  $d f ze $.
    $d a b c d e f g h p q x H $.  $d a b c d e f g h p q x S $.
    $d a b c d e f g h x Q $.  $d a b c d e f g h x X $.
    br8.1 $e |- ( a = A -> ( ph <-> ps ) ) $.
    br8.2 $e |- ( b = B -> ( ps <-> ch ) ) $.
    br8.3 $e |- ( c = C -> ( ch <-> th ) ) $.
    br8.4 $e |- ( d = D -> ( th <-> ta ) ) $.
    br8.5 $e |- ( e = E -> ( ta <-> et ) ) $.
    br8.6 $e |- ( f = F -> ( et <-> ze ) ) $.
    br8.7 $e |- ( g = G -> ( ze <-> si ) ) $.
    br8.8 $e |- ( h = H -> ( si <-> rh ) ) $.
    br8.9 $e |- ( x = X -> P = Q ) $.
    br8.10 $e |- R = { <. p , q >. |
       E. x e. S E. a e. P E. b e. P E. c e. P E. d e. P E. e e. P
       E. f e. P E. g e. P E. h e. P ( p = <. <. a , b >. , <. c , d >. >. /\
       q = <. <. e , f >. , <. g , h >. >. /\ ph ) } $.
    $( Substitution for an eight-place predicate.  (Contributed by Scott
       Fenton, 26-Sep-2013.)  (Revised by Mario Carneiro, 3-May-2015.) $)
    br8 $p |- ( ( ( X e. S /\ A e. Q /\ B e. Q ) /\
                   ( C e. Q /\ D e. Q /\ E e. Q ) /\
                   ( F e. Q /\ G e. Q /\ H e. Q ) ) ->
      ( <. <. A , B >. , <. C , D >. >. R <. <. E , F >. , <. G , H >. >. <->
        rh ) ) $=
      ( cop wbr wceq wrex wcel opex eqeq1 3anbi1d rexbidv 2rexbidv 3anbi2d brab
      cv w3a wa wi wb opth vex sylan9bb eqcoms biimp3a a1i rexlimdva rexlimdvva
      sylbi simpl11 simpl12 simpl13 simpl21 simpl22 simpl23 simpl31 eqidd simpr
      simpl32 simpl33 opeq2d eqeq2d 3anbi23d rspc2ev syl113anc 3anbi13d rspc3ev
      opeq1 opeq1d syl31anc rexeqdv rexeqbidv rspcev syl2anc ex impbid syl5bb
      opeq2 ) KLVDZMNVDZVDZUCUDVDZUEUFVDZVDZQVEYAUJVPZUKVPZVDZULVPZUMVPZVDZVDZV
      FZYDSVPZTVPZVDZUAVPZUBVPZVDZVDZVFZAVQZUBOVGZUAOVGZTOVGZSOVGZUMOVGZULOVGZU
      KOVGZUJOVGZJRVGZUGRVHZKPVHZLPVHZVQZMPVHZNPVHZUCPVHZVQZUDPVHZUEPVHZUFPVHZV
      QZVQZIUIVPZYKVFZUHVPZYSVFZAVQZUBOVGZUAOVGTOVGZSOVGUMOVGZULOVGUKOVGZUJOVGJ
      RVGYLUVGAVQZUBOVGZUAOVGTOVGZSOVGUMOVGZULOVGUKOVGZUJOVGJRVGUUJUIUHYAYDQXSX
      TVIYBYCVIUVDYAVFZUVLUVQJUJROUVRUVKUVPUKULOOUVRUVJUVOUMSOOUVRUVIUVNTUAOOUV
      RUVHUVMUBOUVRUVEYLUVGAUVDYAYKVJVKVLVMVMVMVMUVFYDVFZUVQUUHJUJROUVSUVPUUFUK
      ULOOUVSUVOUUDUMSOOUVSUVNUUBTUAOOUVSUVMUUAUBOUVSUVGYTYLAUVFYDYSVJVNVLVMVMV
      MVMVCVOUVCUUJIUVCUUHIJUJROUVCJVPZRVHYEOVHVRVRZUUFIUKULOOUWAYFOVHYHOVHVRVR
      ZUUDIUMSOOUWBYIOVHYMOVHVRVRZUUBITUAOOUWCYNOVHYPOVHVRVRZUUAIUBOUUAIVSUWDYQ
      OVHVRYLYTAIYLAEYTIAEVTZYKYAYKYAVFYGXSVFZYJXTVFZVRUWEYGYJXSXTYEYFVIYHYIVIW
      AUWFACUWGEUWFYEKVFZYFLVFZVRACVTYEYFKLUJWBUKWBWAUWHABUWICUNUOWCWIUWGYHMVFZ
      YINVFZVRCEVTYHYIMNULWBUMWBWAUWJCDUWKEUPUQWCWIWCWIWDEIVTZYSYDYSYDVFYOYBVFZ
      YRYCVFZVRUWLYOYRYBYCYMYNVIYPYQVIWAUWMEGUWNIUWMYMUCVFZYNUDVFZVREGVTYMYNUCU
      DSWBTWBWAUWOEFUWPGURUSWCWIUWNYPUEVFZYQUFVFZVRGIVTYPYQUEUFUAWBUBWBWAUWQGHU
      WRIUTVAWCWIWCWIWDWCWEWFWGWHWHWHWHUVCIUUJUVCIVRZUUKUUAUBPVGZUAPVGZTPVGZSPV
      GZUMPVGZULPVGZUKPVGZUJPVGZUUJUUKUULUUMUURUVBIWJUWSUULUUMUUOYAXSMYIVDZVDZV
      FZYTDVQZUBPVGZUAPVGZTPVGZSPVGUMPVGZUXGUUKUULUUMUURUVBIWKUUKUULUUMUURUVBIW
      LUUOUUPUUQUUNUVBIWMUWSUUPUUQUUSYAYAVFZYDYBYRVDZVFZGVQZUBPVGUAPVGZUXOUUOUU
      PUUQUUNUVBIWNUUOUUPUUQUUNUVBIWOUUSUUTUVAUUNUURIWPUWSUUTUVAUXPYDYDVFZIUXTU
      USUUTUVAUUNUURIWSUUSUUTUVAUUNUURIWTUWSYAWQUWSYDWQUVCIWRUXSUXPUYAIVQUXPYDY
      BUEYQVDZVDZVFZHVQUAUBUEUFPPUWQUXRUYDGHUXPUWQUXQUYCYDUWQYRUYBYBYPUEYQXHXAX
      BUTXCUWRUYDUYAHIUXPUWRUYCYDYDUWRUYBYCYBYQUFUEXRXAXBVAXCXDXEUXMUXTUXPYTEVQ
      ZUBPVGUAPVGUXPYDUCYNVDZYRVDZVFZFVQZUBPVGUAPVGUMSTNUCUDPPPUWKUXKUYEUAUBPPU
      WKUXJUXPDEYTUWKUXIYAYAUWKUXHXTXSYINMXRXAXBUQXFVMUWOUYEUYIUAUBPPUWOYTUYHEF
      UXPUWOYSUYGYDUWOYOUYFYRYMUCYNXHXIXBURXCVMUWPUYIUXSUAUBPPUWPUYHUXRFGUXPUWP
      UYGUXQYDUWPUYFYBYRYNUDUCXRXIXBUSXCVMXGXJUXDUXOYAKYFVDZYJVDZVFZYTBVQZUBPVG
      ZUAPVGTPVGZSPVGUMPVGYAXSYJVDZVFZYTCVQZUBPVGZUAPVGTPVGZSPVGUMPVGUJUKULKLMP
      PPUWHUXBUYOUMSPPUWHUWTUYNTUAPPUWHUUAUYMUBPUWHYLUYLABYTUWHYKUYKYAUWHYGUYJY
      JYEKYFXHXIXBUNXFVLVMVMUWIUYOUYTUMSPPUWIUYNUYSTUAPPUWIUYMUYRUBPUWIUYLUYQBC
      YTUWIUYKUYPYAUWIUYJXSYJYFLKXRXIXBUOXFVLVMVMUWJUYTUXNUMSPPUWJUYSUXLTUAPPUW
      JUYRUXKUBPUWJUYQUXJCDYTUWJUYPUXIYAUWJYJUXHXSYHMYIXHXAXBUPXFVLVMVMXGXJUUIU
      XGJUGRUVTUGVFZUUHUXFUJOPVBVUAUUGUXEUKOPVBVUAUUFUXDULOPVBVUAUUEUXCUMOPVBVU
      AUUDUXBSOPVBVUAUUCUXATOPVBVUAUUBUWTUAOPVBVUAUUAUBOPVBXKXLXLXLXLXLXLXLXMXN
      XOXPXQ $.
  $}

  ${
    $d b ch $.  $d e et $.  $d a b c d e f p q P $.  $d p q x ph $.  $d a ps $.
    $d a b c d e f p q x A $.  $d a b c d e f p q x B $.  $d a b c d e f x Q $.
    $d a b c d e f p q x C $.  $d a b c d e f p q x D $.  $d a b c d e f x X $.
    $d a b c d e f p q x E $.  $d d ta $.  $d c th $.  $d a b c d e f x ze $.
    $d a b c d e f p q x F $.  $d a b c d e f p q x S $.
    br6.1 $e |- ( a = A -> ( ph <-> ps ) ) $.
    br6.2 $e |- ( b = B -> ( ps <-> ch ) ) $.
    br6.3 $e |- ( c = C -> ( ch <-> th ) ) $.
    br6.4 $e |- ( d = D -> ( th <-> ta ) ) $.
    br6.5 $e |- ( e = E -> ( ta <-> et ) ) $.
    br6.6 $e |- ( f = F -> ( et <-> ze ) ) $.
    br6.7 $e |- ( x = X -> P = Q ) $.
    br6.8 $e |- R = { <. p , q >. |
       E. x e. S E. a e. P E. b e. P E. c e. P E. d e. P E. e e. P
       E. f e. P ( p = <. a , <. b , c >. >. /\
       q = <. d , <. e , f >. >. /\ ph ) } $.
    $( Substitution for a six-place predicate.  (Contributed by Scott Fenton,
       4-Oct-2013.)  (Revised by Mario Carneiro, 3-May-2015.) $)
    br6 $p |- ( ( X e. S /\
                   ( A e. Q /\ B e. Q /\ C e. Q ) /\
                   ( D e. Q /\ E e. Q /\ F e. Q ) ) ->
      ( <. A , <. B , C >. >. R <. D , <. E , F >. >. <-> ze ) ) $=
      ( cop wbr cv wceq w3a wrex wcel opex eqeq1 eqcom 3anbi1d rexbidv 2rexbidv
      syl6bb 3anbi2d brab wa wi wb vex opth sylan9bb sylbi rexlimdva rexlimdvva
      biimp3a a1i simpl1 simpl2 opeq1 eqeq1d 3anbi23d opeq2d eqid pm3.2i df-3an
      opeq2 mpbiran rspc3ev 3ad2antl3 3anbi13d syl2anc rexeqdv rexeqbidv rspcev
      ex impbid syl5bb ) IJKUPZUPZLSTUPZUPZOUQUDURZUEURZUFURZUPZUPZXEUSZUGURZQU
      RZRURZUPZUPZXGUSZAUTZRMVAZQMVAZUGMVAZUFMVAZUEMVAZUDMVAZHPVAZUAPVBZINVBJNV
      BKNVBUTZLNVBSNVBTNVBUTZUTZGUCURZXLUSZUBURZXRUSZAUTZRMVAZQMVAUGMVAZUFMVAUE
      MVAZUDMVAHPVAXMYOAUTZRMVAZQMVAUGMVAZUFMVAUEMVAZUDMVAHPVAYGUCUBXEXGOIXDVCL
      XFVCYLXEUSZYSUUCHUDPMUUDYRUUBUEUFMMUUDYQUUAUGQMMUUDYPYTRMUUDYMXMYOAUUDYMX
      EXLUSXMYLXEXLVDXEXLVEVIVFVGVHVHVHYNXGUSZUUCYEHUDPMUUEUUBYCUEUFMMUUEUUAYAU
      GQMMUUEYTXTRMUUEYOXSXMAUUEYOXGXRUSXSYNXGXRVDXGXRVEVIVJVGVHVHVHUOVKYKYGGYK
      YEGHUDPMYKHURZPVBXHMVBVLVLZYCGUEUFMMUUGXIMVBXJMVBVLVLZYAGUGQMMUUHXNMVBXOM
      VBVLVLZXTGRMXTGVMUUIXPMVBVLXMXSAGXMADXSGXMXHIUSZXKXDUSZVLADVNXHXKIXDUDVOX
      IXJVCVPUUJABUUKDUHUUKXIJUSZXJKUSZVLBDVNXIXJJKUEVOUFVOVPUULBCUUMDUIUJVQVRV
      QVRXSXNLUSZXQXFUSZVLDGVNXNXQLXFUGVOXOXPVCVPUUNDEUUOGUKUUOXOSUSZXPTUSZVLEG
      VNXOXPSTQVORVOVPUUPEFUUQGULUMVQVRVQVRVQWAWBVSVTVTVTYKGYGYKGVLZYHXTRNVAZQN
      VAZUGNVAZUFNVAZUENVAZUDNVAZYGYHYIYJGWCUURYIXEXEUSZXSDUTZRNVAZQNVAUGNVAZUV
      DYHYIYJGWDYJYHGUVHYIUVFGUVELXQUPZXGUSZEUTUVELSXPUPZUPZXGUSZFUTZUGQRLSTNNN
      UUNXSUVJDEUVEUUNXRUVIXGXNLXQWEWFUKWGUUPUVJUVMEFUVEUUPUVIUVLXGUUPXQUVKLXOS
      XPWEWHWFULWGUUQUVNUVEXGXGUSZGUTZGUUQUVMUVOFGUVEUUQUVLXGXGUUQUVKXFLXPTSWLW
      HWFUMWGUVPUVEUVOVLGUVEUVOXEWIXGWIWJUVEUVOGWKWMVIWNWOUVAUVHIXKUPZXEUSZXSBU
      TZRNVAZQNVAUGNVAIJXJUPZUPZXEUSZXSCUTZRNVAZQNVAUGNVAUDUEUFIJKNNNUUJUUSUVTU
      GQNNUUJXTUVSRNUUJXMUVRABXSUUJXLUVQXEXHIXKWEWFUHWPVGVHUULUVTUWEUGQNNUULUVS
      UWDRNUULUVRUWCBCXSUULUVQUWBXEUULXKUWAIXIJXJWEWHWFUIWPVGVHUUMUWEUVGUGQNNUU
      MUWDUVFRNUUMUWCUVECDXSUUMUWBXEXEUUMUWAXDIXJKJWLWHWFUJWPVGVHWNWQYFUVDHUAPU
      UFUAUSZYEUVCUDMNUNUWFYDUVBUEMNUNUWFYCUVAUFMNUNUWFYBUUTUGMNUNUWFYAUUSQMNUN
      UWFXTRMNUNWRWSWSWSWSWSWTWQXAXBXC $.
  $}

  ${
    $d a b c d p q x A $.  $d a b c d p q x B $.  $d b ch $.  $d a b c d x Q $.
    $d a b c d p q x C $.  $d a b c d p q x D $.  $d a ps $.  $d a b c d x X $.
    $d a b c d p q P $.  $d a b c d p q x S $.  $d a b c d x ta $.  $d c th $.
    $d p q x ph $.
    br4.1 $e |- ( a = A -> ( ph <-> ps ) ) $.
    br4.2 $e |- ( b = B -> ( ps <-> ch ) ) $.
    br4.3 $e |- ( c = C -> ( ch <-> th ) ) $.
    br4.4 $e |- ( d = D -> ( th <-> ta ) ) $.
    br4.5 $e |- ( x = X -> P = Q ) $.
    br4.6 $e |- R = { <. p , q >. |
       E. x e. S E. a e. P E. b e. P E. c e. P E. d e. P
       ( p = <. a , b >. /\ q = <. c , d >. /\ ph ) } $.
    $( Substitution for a four-place predicate.  (Contributed by Scott Fenton,
       9-Oct-2013.)  (Revised by Mario Carneiro, 14-Oct-2013.) $)
    br4 $p |- ( ( X e. S /\
                   ( A e. Q /\ B e. Q ) /\
                   ( C e. Q /\ D e. Q ) ) ->
      ( <. A , B >. R <. C , D >. <-> ta ) ) $=
      ( cop wbr cv wceq w3a wrex wcel wa eqeq1 3anbi1d rexbidv 2rexbidv 3anbi2d
      opex brab wi wb vex opth sylan9bb eqcoms biimp3a a1i rexlimdva rexlimdvva
      sylbi simpl1 simpl2l simpl2r simpl3l simpl3r eqidd simpr 3anbi23d rspc2ev
      opeq1 eqeq2d opeq2 syl113anc 3anbi13d syl3anc rexeqdv rexeqbidv rspcev ex
      syl2anc impbid syl5bb ) GHUHZIJUHZMUIWPRUJZSUJZUHZUKZWQTUJZUAUJZUHZUKZAUL
      ZUAKUMZTKUMZSKUMZRKUMZFNUMZONUNZGLUNZHLUNZUOZILUNZJLUNZUOZULZEQUJZWTUKZPU
      JZXDUKZAULZUAKUMZTKUMSKUMZRKUMFNUMXAYCAULZUAKUMZTKUMSKUMZRKUMFNUMXKQPWPWQ
      MGHVAIJVAXTWPUKZYFYIFRNKYJYEYHSTKKYJYDYGUAKYJYAXAYCAXTWPWTUPUQURUSUSYBWQU
      KZYIXIFRNKYKYHXGSTKKYKYGXFUAKYKYCXEXAAYBWQXDUPUTURUSUSUGVBXSXKEXSXIEFRNKX
      SFUJZNUNWRKUNUOUOZXGESTKKYMWSKUNXBKUNUOUOZXFEUAKXFEVCYNXCKUNUOXAXEAEXAACX
      EEACVDZWTWPWTWPUKWRGUKZWSHUKZUOYOWRWSGHRVESVEVFYPABYQCUBUCVGVMVHCEVDZXDWQ
      XDWQUKXBIUKZXCJUKZUOYRXBXCIJTVEUAVEVFYSCDYTEUDUEVGVMVHVGVIVJVKVLVLXSEXKXS
      EUOZXLXFUALUMZTLUMZSLUMZRLUMZXKXLXOXREVNUUAXMXNWPWPUKZXECULZUALUMTLUMZUUE
      XMXNXLXREVOXMXNXLXREVPUUAXPXQUUFWQWQUKZEUUHXPXQXLXOEVQXPXQXLXOEVRUUAWPVSU
      UAWQVSXSEVTUUGUUFUUIEULUUFWQIXCUHZUKZDULTUAIJLLYSXEUUKCDUUFYSXDUUJWQXBIXC
      WCWDUDWAYTUUKUUIDEUUFYTUUJWQWQXCJIWEWDUEWAWBWFUUCUUHWPGWSUHZUKZXEBULZUALU
      MTLUMRSGHLLYPXFUUNTUALLYPXAUUMABXEYPWTUULWPWRGWSWCWDUBWGUSYQUUNUUGTUALLYQ
      UUMUUFBCXEYQUULWPWPWSHGWEWDUCWGUSWBWHXJUUEFONYLOUKZXIUUDRKLUFUUOXHUUCSKLU
      FUUOXGUUBTKLUFUUOXFUAKLUFWIWJWJWJWKWMWLWNWO $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( Alternate definition of restriction.  (Contributed by Scott Fenton,
       17-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    dfres3 $p |- ( A |` B ) = ( A i^i ( B X. ran A ) ) $=
      ( vx vy vz cres cvv cxp cin crn df-res cv wcel wa cop wceq wex vex elxp
      wb biantru opelrn biantrud syl5bbr syl6bi pm5.32d 2exbidv 3bitr4g pm5.32i
      eleq1 com12 elin bitr4i ineqri eqtri ) ABFABGHZIABAJZHZIZABKCAUPUSCLZAMZU
      TUPMZNVAUTURMZNUTUSMVAVBVCVAUTDLZELZOZPZVDBMZVEGMZNZNZEQDQVGVHVEUQMZNZNZE
      QDQVBVCVAVKVNDEVAVGVJVMVGVAVJVMTZVGVAVFAMZVOUTVFAUJVJVHVPVMVIVHERZUAVPVLV
      HVDVEADRVQUBUCUDUEUKUFUGDEUTBGSDEUTBUQSUHUIUTAURULUMUNUO $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( Another distributive law of converse over class composition.
       (Contributed by Scott Fenton, 3-May-2014.) $)
    cnvco1 $p |- `' ( `' A o. B ) = ( `' B o. A ) $=
      ( vx vy vz ccnv ccom relcnv relco cv wbr wa wex cop wcel vex brcnv bicomi
      anbi12ci opelco exbii opelcnv bitri 3bitr4i eqrelriiv ) CDAFZBGZFZBFZAGZU
      GHUIAIDJZEJZBKZULCJZUFKZLZEMZUNULAKZULUKUIKZLZEMUNUKNZUHOZVAUJOUPUTEUMUSU
      OURUSUMULUKBEPZDPZQRULUNAVCCPZQSUAVBUKUNNUGOUQUNUKUGVEVDUBEUKUNUFBVDVETUC
      EUNUKUIAVEVDTUDUE $.

    $( Another distributive law of converse over class composition.
       (Contributed by Scott Fenton, 3-May-2014.) $)
    cnvco2 $p |- `' ( A o. `' B ) = ( B o. `' A ) $=
      ( vx vy vz ccnv ccom relcnv relco cv wbr wa wex cop wcel vex brcnv bicomi
      anbi12ci opelco exbii opelcnv bitri 3bitr4i eqrelriiv ) CDABFZGZFZBAFZGZU
      GHBUIIDJZEJZUFKZULCJZAKZLZEMZUNULUIKZULUKBKZLZEMUNUKNZUHOZVAUJOUPUTEUMUSU
      OURUKULBDPZEPZQURUOUNULACPZVDQRSUAVBUKUNNUGOUQUNUKUGVEVCUBEUKUNAUFVCVETUC
      EUNUKBUIVEVCTUDUE $.
  $}

  ${
    $d A x y z p $.  $d B x y z p $.
    $( Quantifier-free definition of membership in a domain.  (Contributed by
       Scott Fenton, 21-Jan-2017.) $)
    eldm3 $p |- ( A e. dom B <-> ( B |` { A } ) =/= (/) ) $=
      ( vx vy vp vz cdm wcel cvv csn cres c0 wne wceq cv eleq1 cop wex wa exbii
      elex wn snprc reseq2 res0 syl6eq necon1ai sneq reseq2d neeq1d df-clel vex
      sylbi eldm2 n0 elres weq pm5.32i opeq1 eqeq2d anbi1d syl5bbr exbidv rexsn
      wrex bitri excom 3bitri 3bitr4i vtoclbg pm5.21nii ) ABGZHZAIHZBAJZKZLMZAV
      LUAVNVPLVNUBVOLNZVPLNAUCVRVPBLKLVOLBUDBUEUFUMUGCOZVLHZBVSJZKZLMZVMVQCAIVS
      AVLPVSANZWBVPLWDWAVOBVSAUHUIUJVSDOZQZBHZDREOZWFNZWHBHZSZERZDRZVTWCWGWLDEW
      FBUKTDVSBCULZUNWCWHWBHZERWKDRZERWMEWBUOWOWPEWOWHFOZWEQZNZWRBHZSZDRZFWAVEW
      PFDWHBWAUPXBWPFVSWNFCUQZXAWKDXAWSWJSXCWKWSWJWTWHWRBPURXCWSWIWJXCWRWFWHWQV
      SWEUSUTVAVBVCVDVFTWKEDVGVHVIVJVK $.
  $}

  $( Quantifier-free definition of membership in a range.  (Contributed by
     Scott Fenton, 21-Jan-2017.) $)
  elrn3 $p |- ( A e. ran B <-> ( B i^i ( _V X. { A } ) ) =/= (/) ) $=
    ( crn wcel ccnv cdm csn cres wne cvv cxp cin df-rn eleq2i eldm3 wceq ineq2i
    c0 cnvxp wrel cnvin df-res 3eqtr4ri eqeq1i wss inss2 relxp relss mp2 cnveq0
    wb ax-mp bitr4i necon3bii 3bitri ) ABCZDABEZFZDUQAGZHZRIBJUSKZLZRIUPURABMNA
    UQOUTRVBRUTRPVBEZRPZVBRPZUTVCRUQVAEZLUQUSJKZLVCUTVFVGUQJUSSQBVAUAUQUSUBUCUD
    VBTZVEVDUKVBVAUEVATVHBVAUFJUSUGVBVAUHUIVBUJULUMUNUO $.

  ${
    $d R x y z $.  $d A x y z $.

    $( The converse of a partial ordering is still a partial ordering.
       (Contributed by Scott Fenton, 13-Jun-2018.) $)
    pocnv $p |- ( R Po A -> `' R Po A ) $=
      ( vx vy vz wpo ccnv cv wa wbr wn poirr vex brcnv notbii sylibr w3a 3anrev
      wcel wi potr sylan2b ancom anbi12i bitri 3imtr4g ispod ) ABFZCDEABGZUHCHZ
      ASZIUJUJBJZKUJUJUIJZKAUJBLUMULUJUJBCMZUNNOPUHUKDHZASZEHZASZQZIUQUOBJZUOUJ
      BJZIZUQUJBJZUJUOUIJZUOUQUIJZIZUJUQUIJUSUHURUPUKQVBVCTUKUPURRAUQUOUJBUAUBV
      FVEVDIVBVDVEUCVEUTVDVAUOUQBDMZEMZNUJUOBUNVGNUDUEUJUQBUNVHNUFUG $.

    $( The converse of a strict ordering is still a strict ordering.
       (Contributed by Scott Fenton, 13-Jun-2018.) $)
    socnv $p |- ( R Or A -> `' R Or A ) $=
      ( vx vy wor ccnv wpo sopo pocnv cv wcel wa wbr w3o vex brcnv 3orass bitri
      wo or12 syl weq solin biid 3orbi123i orcom orbi2i 3bitr4i sylibr issod )
      ABEZCDABFZUKABGAULGABHABIUAUKCJZAKDJZAKLLUMUNBMZCDUBZUNUMBMZNZUMUNULMZUPU
      NUMULMZNZAUMUNBUCVAUQUPUONZURUSUQUPUPUTUOUMUNBCOZDOZPUPUDUNUMBVDVCPUEUPUQ
      UOSZSZUPUOUQSZSZVBURVEVGUPUQUOUFUGVBUQUPUOSSVFUQUPUOQUQUPUOTRURUOUPUQSSVH
      UOUPUQQUOUPUQTRUHRUIUJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Properties of functions and mappings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A condition for subset trichotomy for functions.  (Contributed by Scott
     Fenton, 19-Apr-2011.) $)
  funpsstri $p |- ( ( Fun H /\ ( F C_ H /\ G C_ H ) /\
                      ( dom F C_ dom G \/ dom G C_ dom F ) ) ->
                    ( F C. G \/ F = G \/ G C. F ) ) $=
    ( wfun wss wa cdm wo w3a wpss wceq w3o cres funssres anim12d ssres2 orim12i
    wi ex sseq12 wb ancoms orbi12d syl5ib syl6 3imp sspsstri sylib ) CDZACEZBCE
    ZFZAGZBGZEZUNUMEZHZIABEZBAEZHZABJABKBAJLUIULUQUTUIULCUMMZAKZCUNMZBKZFZUQUTR
    UIUJVBUKVDUIUJVBCANSUIUKVDCBNSOUQVAVCEZVCVAEZHVEUTUOVFUPVGUMUNCPUNUMCPQVEVF
    URVGUSVAAVCBTVDVBVGUSUAVCBVAATUBUCUDUEUFABUGUH $.

  ${
    $d F p x y z $.  $d G p x y z $.
    $( If a class ` F ` is a proper subset of a function ` G ` , then
       ` dom F C. dom G ` .  (Contributed by Scott Fenton, 20-Apr-2011.) $)
    fundmpss $p |- ( Fun G -> ( F C. G -> dom F C. dom G ) ) $=
      ( vx vy vz vp wpss wss wn wa wi syl cv wbr wex wcel adantl ex wal exlimdv
      wfun cdm pssss dmss a1i cdif c0 wne pssdif n0 wrel funrel reldif cop wceq
      sylib elrel eleq1 df-br syl6bbr biimpcd 2eximdv difss ssbri eximi simprbi
      mpd adantr brdif ssbrd ad2antlr simplbi weq dffun2 sps breq2 biimprd syl6
      sp exp3a syl5 imp adantlr com23 mpdd mtod jcad eximdv syld nss vex notbii
      eldm anbi12i exbii bitri sylibr dfpss3 syl6ibr ) BUAZABGZAUBZBUBZHZXCXBHI
      ZJXBXCGWTXAXDXEXAXDKWTXAABHXDABUCZABUDLUEWTXAXEWTXAJZCMZDMZBNZDOZXHEMZANZ
      EOZIZJZCOZXEXGFMZBAUFZPZFOZXQXAYAWTXAXSUGUHYAABUIFXSUJUPQXGXTXQFXGXTXHXIX
      SNZDOZCOZXQWTXTYDKZXAWTXSUKZYEWTBUKZYFBULBAUMLYFXTYDYFXTJZXRXHXIUNZUOZDOC
      OYDCDXRXSUQYHYJYBCDXTYJYBKYFYJXTYBYJXTYIXSPYBXRYIXSURXHXIXSUSUTVAQVBVGRLV
      HXGYCXPCXGYCXKXOYCXKKXGYBXJDXSBXHXIBAVCVDVEUEXGYBXODXGYBXOXGYBJZXNXHXIANZ
      YBYLIZXGYBXJYMXHXIBAVIZVFQYKXMYLEYKXMXHXLBNZYLXAXMYOKWTYBXAABXHXLXFVJVKYK
      YOXMYLWTYBYOXMYLKZKZXAWTYBYQYBXJWTYQYBXJYMYNVLWTXJYOYPWTXJYOJZDEVMZYPWTYR
      YSKZESZDSZCSZYTWTYGUUCCDEBVNVFUUBYTCUUAYTDYTEVSVOVOLYSYLXMXIXLXHAVPVQVRVT
      WAWBWCWDWETWFRTWGWHWITVGXEXHXCPZXHXBPZIZJZCOXQCXCXBWJUUGXPCUUDXKUUFXODXHB
      CWKZWMUUEXNEXHAUUHWMWLWNWOWPWQRWGXBXCWRWS $.
  $}

  $( The value of a function at a restriction is either null or the same as the
     function itself.  (Contributed by Scott Fenton, 4-Sep-2011.) $)
  fvresval $p |- ( ( ( F |` B ) ` A ) = ( F ` A ) \/
                   ( ( F |` B ) ` A ) = (/) ) $=
    ( wcel wn wo cres cfv wceq c0 exmid fvres nfvres orim12i ax-mp ) ABDZPEZFAC
    BGHZACHIZRJIZFPKPSQTABCLABCMNO $.

  ${
    $d A y $.  $d B y $.  $d x y $.
    $( The maps-to notation always describes a relationship.  (Contributed by
       Scott Fenton, 16-Apr-2012.) $)
    mptrel $p |- Rel ( x e. A |-> B ) $=
      ( vy cv wcel wceq wa cmpt df-mpt relopabi ) AEBFDECGHADABCIADBCJK $.
  $}

  ${
    $d F x y z $.  $d G x y z $.
    $( Given two functions with equal domains, equality only requires one
       direction of the subset relationship.  (Contributed by Scott Fenton,
       24-Apr-2012.)  (Proof shortened by Mario Carneiro, 3-May-2015.) $)
    funsseq $p |- ( ( Fun F /\ Fun G /\ dom F = dom G ) ->
                     ( F = G <-> F C_ G ) ) $=
      ( wfun cdm wceq w3a eqimss wa cres simpl3 reseq2d funssres 3ad2antl2 wrel
      wss simpl2 funrel resdm 3syl 3eqtr3d ex impbid2 ) ACZBCZADZBDZEZFZABEZABO
      ZABGUHUJUIUHUJHZBUEIZBUFIZABUKUEUFBUCUDUGUJJKUDUCUJULAEUGBALMUKUDBNUMBEUC
      UDUGUJPBQBRSTUAUB $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d F x y z $.
    fununiq.1 $e |- A e. _V $.
    fununiq.2 $e |- B e. _V $.
    fununiq.3 $e |- C e. _V $.
    $( The uniqueness condition of functions.  (Contributed by Scott Fenton,
       18-Feb-2013.) $)
    fununiq $p |- ( Fun F -> ( ( A F B /\ A F C ) -> B = C ) ) $=
      ( vx vy vz cv wbr wa wi wal wceq cvv wcel wb breq12 wfun wrel weq 3adant3
      dffun2 3adant2 anbi12d eqeq12 3adant1 imbi12d spc3gv mp3an adantl sylbi
      w3a ) DUADUBZHKZIKZDLZUQJKZDLZMZIJUCZNZJOIOHOZMABDLZACDLZMZBCPZNZHIJDUEVE
      VJUPAQRBQRCQRVEVJNEFGVDVJHIJABCQQQUQAPZURBPZUTCPZUOZVBVHVCVIVNUSVFVAVGVKV
      LUSVFSVMUQAURBDTUDVKVMVAVGSVLUQAUTCDTUFUGVLVMVCVISVKURBUTCUHUIUJUKULUMUN
      $.
  $}

  ${
    funbreq.1 $e |- A e. _V $.
    funbreq.2 $e |- B e. _V $.
    funbreq.3 $e |- C e. _V $.
    $( An equality condition for functions.  (Contributed by Scott Fenton,
       18-Feb-2013.) $)
    funbreq $p |- ( ( Fun F /\ A F B ) -> ( A F C <-> B = C ) ) $=
      ( wfun wbr wa wceq fununiq expdimp wi breq2 biimpcd adantl impbid ) DHZAB
      DIZJACDIZBCKZSTUAUBABCDEFGLMTUBUANSUBTUABCADOPQR $.
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d D y $.  $d ph y $.  $d x y $.
    mpteq12d.1 $e |- F/ x ph $.
    mpteq12d.3 $e |- ( ph -> A = C ) $.
    mpteq12d.4 $e |- ( ph -> B = D ) $.
    $( An equality inference for the maps to notation.  Compare ~ mpteq12dv .
       (Contributed by Scott Fenton, 8-Aug-2013.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    mpteq12d $p |- ( ph -> ( x e. A |-> B ) = ( x e. C |-> D ) ) $=
      ( vy cv wcel wceq wa copab cmpt nfv eleq2d eqeq2d df-mpt anbi12d opabbid
      3eqtr4g ) ABKZCLZJKZDMZNZBJOUDELZUFFMZNZBJOBCDPBEFPAUHUKBJGAJQAUEUIUGUJAC
      EUDHRADFUFISUAUBBJCDTBJEFTUC $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.  $d R x y $.
    fprb.1 $e |- A e. _V $.
    fprb.2 $e |- B e. _V $.
    $( A condition for functionhood over a pair.  (Contributed by Scott Fenton,
       16-Sep-2013.) $)
    fprb $p |- ( A =/= B -> ( F : { A , B } --> R <->
       E. x e. R E. y e. R F = { <. A , x >. , <. B , y >. } ) ) $=
      ( cpr wf cv cop wceq wrex wa cfv wcel ffvelrn mpan2 fveq2 wne prid1 prid2
      adantr wral fvpr1 fvpr2 eqeq12d eqcom syl6bb ralpr sylanbrc adantl wfn wb
      fvex ffn fpr syl eqfnfv syl2an mpbird opeq2 preq1d eqeq2d rspc2ev syl3anc
      preq2d expcom wi wss vex prssi fss ex feq1 biimprcd syl6 rexlimdvv impbid
      ) CDUAZCDIZEFJZFCAKZLZDBKZLZIZMZBENAENZWCWAWJWCWAOZCFPZEQZDFPZEQZFCWLLZDW
      NLZIZMZWJWCWMWAWCCWBQWMCDGUBWBECFRSUDWCWOWAWCDWBQWOCDHUCWBEDFRSUDWKWSWDFP
      ZWDWRPZMZAWBUEZWAXCWCWACWRPZWLMZDWRPZWNMZXCCDWLWNGCFUPZUFCDWLWNHDFUPZUGXB
      XEXGACDGHWDCMZXBWLXDMXEXJWTWLXAXDWDCFTWDCWRTUHWLXDUIUJWDDMZXBWNXFMXGXKWTW
      NXAXFWDDFTWDDWRTUHWNXFUIUJUKULUMWCFWBUNWRWBUNZWSXCUOWAWBEFUQWAWBWLWNIZWRJ
      XLCDWLWNGHXHXIURWBXMWRUQUSAWBFWRUTVAVBWIWSFWPWGIZMABWLWNEEWDWLMZWHXNFXOWE
      WPWGWDWLCVCVDVEWFWNMZXNWRFXPWGWQWPWFWNDVCVHVEVFVGVIWAWIWCABEEWAWDEQWFEQOZ
      WBEWHJZWIWCVJWAXQXRWAWBWDWFIZWHJXSEVKXRXQCDWDWFGHAVLBVLURWDWFEVMWBXSEWHVN
      VAVOWIWCXRWBEFWHVPVQVRVSVT $.
  $}

  ${
    br1steq.1 $e |- A e. _V $.
    br1steq.2 $e |- B e. _V $.
    br1steq.3 $e |- C e. _V $.
    $( Uniqueness condition for binary relationship over the ` 1st `
       relationship.  (Contributed by Scott Fenton, 11-Apr-2014.)  (Proof
       shortened by Mario Carneiro, 3-May-2015.) $)
    br1steq $p |- ( <. A , B >. 1st C <-> C = A ) $=
      ( cop c1st cfv wceq wbr op1st eqeq1i cvv wfn wcel wb wfo fo1st fofn ax-mp
      opex fnbrfvb mp2an eqcom 3bitr3i ) ABGZHIZCJZACJUGCHKZCAJUHACABDELMHNOZUG
      NPUIUJQNNHRUKSNNHTUAABUBNUGCHUCUDACUEUF $.
  $}

  ${
    br2ndeq.1 $e |- A e. _V $.
    br2ndeq.2 $e |- B e. _V $.
    br2ndeq.3 $e |- C e. _V $.
    $( Uniqueness condition for binary relationship over the ` 2nd `
       relationship.  (Contributed by Scott Fenton, 11-Apr-2014.)  (Proof
       shortened by Mario Carneiro, 3-May-2015.) $)
    br2ndeq $p |- ( <. A , B >. 2nd C <-> C = B ) $=
      ( cop c2nd cfv wceq wbr op2nd eqeq1i cvv wfn wcel wb wfo fo2nd fofn ax-mp
      opex fnbrfvb mp2an eqcom 3bitr3i ) ABGZHIZCJZBCJUGCHKZCBJUHBCABDELMHNOZUG
      NPUIUJQNNHRUKSNNHTUAABUBNUGCHUCUDBCUEUF $.
  $}

  ${
    $d A p x y z $.
    $( Definition of domain in terms of ` 1st ` and image.  (Contributed by
       Scott Fenton, 11-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    dfdm5 $p |- dom A = ( ( 1st |` ( _V X. _V ) ) " A ) $=
      ( vx vy vp vz c1st cvv cv cop wex wbr wa excom weq vex bitri anbi1i exbii
      wcel 3bitr4i cdm cres cima wceq breq1 eleq1 anbi12d br1steq equcom syl6bb
      opex ceqsexv opeq1 eleq1d 3bitr3ri ancom anass brres 19.41vv eldm2 elima2
      cxp elvv eqriv ) BAUAZFGGVBZUBZAUCZBHZCHZIZASZCJZDHZASZVNVIVGKZLZDJZVIVES
      VIVHSVNEHZVJIZUDZVNVIFKZVOLZLZEJZDJZCJWECJZDJVMVRWECDMVLWFCWDDJZEJEBNZVTA
      SZLZEJWFVLWHWKEWCWKDVTVSVJUKWAWCVTVIFKZWJLWKWAWBWLVOWJVNVTVIFUEVNVTAUFUGW
      LWIWJWLBENWIVSVJVIEOCOBOZUHBEUIPQUJULRWDEDMWJVLEVIWMWIVTVKAVSVIVJUMUNULUO
      RVQWGDVQVPVOLZWGVOVPUPWAEJCJZWBLZVOLWOWCLWNWGWOWBVOUQVPWPVOVPWBVNVFSZLZWP
      VNVIFVFWMURWRWQWBLWPWBWQUPWQWOWBWQWACJEJWOECVNVCWAECMPQPPQWAWCCEUSTPRTCVI
      AWMUTDVIVGAWMVATVD $.

    $( Definition of range in terms of ` 2nd ` and image.  (Contributed by
       Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    dfrn5 $p |- ran A = ( ( 2nd |` ( _V X. _V ) ) " A ) $=
      ( vx vy vp vz c2nd cvv cv cop wex wbr wa excom weq vex bitri anbi1i exbii
      wcel 3bitr4i crn cres cima wceq breq1 eleq1 anbi12d br2ndeq equcom syl6bb
      opex ceqsexv opeq2 eleq1d 3bitr3ri ancom anass brres 19.41vv elrn2 elima2
      cxp elvv eqriv ) BAUAZFGGVBZUBZAUCZCHZBHZIZASZCJZDHZASZVNVJVGKZLZDJZVJVES
      VJVHSVNVIEHZIZUDZVNVJFKZVOLZLZEJZDJZCJWECJZDJVMVRWECDMVLWFCWDDJZEJEBNZVTA
      SZLZEJWFVLWHWKEWCWKDVTVIVSUKWAWCVTVJFKZWJLWKWAWBWLVOWJVNVTVJFUEVNVTAUFUGW
      LWIWJWLBENWIVIVSVJCOEOBOZUHBEUIPQUJULRWDEDMWJVLEVJWMWIVTVKAVSVJVIUMUNULUO
      RVQWGDVQVPVOLZWGVOVPUPWAEJCJZWBLZVOLWOWCLWNWGWOWBVOUQVPWPVOVPWBVNVFSZLZWP
      VNVJFVFWMURWRWQWBLWPWBWQUPWQWOWBCEVNVCQPPQWAWCCEUSTPRTCVJAWMUTDVJVGAWMVAT
      VD $.
  $}


  ${
    $( A singleton is non-empty iff its argument is a set.  (Contributed by
       Scott Fenton, 8-May-2018.) $)
    snnzb $p |- ( A e. _V <-> { A } =/= (/) ) $=
      ( cvv wcel csn c0 wne wn wceq snprc df-ne con2bii bitri con4bii ) ABCZADZ
      EFZNGOEHZPGAIPQOEJKLM $.
  $}

  ${
    $d A z $.  $d B z $.  $d C z $.  $d D z $.
    $( Alternate way of saying that an ordered pair is in a composition.
       (Contributed by Scott Fenton, 6-May-2018.) $)
    opelco3 $p |- ( <. A , B >. e. ( C o. D ) <->
       B e. ( C " ( D " { A } ) ) ) $=
      ( vz cop ccom wcel wbr csn cima df-br cvv wa wrel wn c0 ima0 wex wb relco
      brrelex12 mpan wceq snprc noel imaeq2 imaeq2d imaeq2i eqtri syl6eq eleq2d
      mtbiri sylbi con4i elex jca wrex df-rex vex elimasng mpan2 syl6bbr adantr
      cv anbi1d exbidv syl5rbb brcog elimag adantl 3bitr4d pm5.21nii bitr3i ) A
      BFCDGZHABVOIZBCDAJZKZKZHZABVOLVPAMHZBMHZNZVTVOOVPWCCDUAABVOUBUCVTWAWBWAVT
      WAPVQQUDZVTPAUEWDVTBQHBUFWDVSQBWDVSCDQKZKZQWDVRWECVQQDUGUHWFCQKQWEQCDRUIC
      RUJUKULUMUNUOBVSUPUQWCAEVEZDIZWGBCIZNZESZWIEVRURZVPVTWLWGVRHZWINZESWCWKWI
      EVRUSWCWNWJEWCWMWHWIWAWMWHTWBWAWMAWGFDHZWHWAWGMHWMWOTEUTDAWGMMVAVBAWGDLVC
      VDVFVGVHEABCDMMVIWBVTWLTWAEBCVRMVJVKVLVMVN $.
  $}

  ${
    $d A x $.  $d B p x y z $.  $d R p x y z $.
    $( Quantifier-free expression saying that a class is a member of an image.
       (Contributed by Scott Fenton, 8-May-2018.) $)
    elima4 $p |- ( A e. ( R " B ) <-> ( R i^i ( B X. { A } ) ) =/= (/) ) $=
      ( vx vy vp vz wcel cvv csn cxp cin c0 wne wceq cv wa wex 3bitri exbii xp0
      cima elex xpeq2 syl6eq ineq2d in0 necon3i snnzb sylibr sneq xpeq2d neeq1d
      eleq1 cop vex elima3 n0 elin ancom elxp anbi1i exrot3 anass 2exbii bitr3i
      19.41vv opex anbi2d ceqsexv an12 elsn opeq2 eleq1d 3bitr3i bitr4i vtoclbg
      weq pm5.21nii ) ACBUBZHZAIHZCBAJZKZLZMNZAVTUCWFWCMNWBWCMWEMWCMOZWECMLMWGW
      DMCWGWDBMKMWCMBUDBUAUEUFCUGUEUHAUIUJDPZVTHZCBWHJZKZLZMNZWAWFDAIWHAVTUNWHA
      OZWLWEMWNWKWDCWNWJWCBWHAUKULUFUMWIEPZBHZWOWHUOZCHZQZERZWMEWHCBDUPZUQWMFPZ
      WLHZFRXBWOGPZUOZOZWPXDWJHZQZQZGRERZXBCHZQZFRZWTFWLURXCXLFXCXKXBWKHZQXNXKQ
      XLXBCWKUSXKXNUTXNXJXKEGXBBWJVAVBSTXFXHXKQZQZGRERZFRXPFRZGRZERXMWTXPFEGVCX
      QXLFXQXIXKQZGRERXLXTXPEGXFXHXKVDVEXIXKEGVGVFTXSWSEXSXHXECHZQZGRGDVRZWPYAQ
      ZQZGRWSXRYBGXOYBFXEWOXDVHXFXKYAXHXBXECUNVIVJTYBYEGYBWPXGYAQQXGYDQYEWPXGYA
      VDWPXGYAVKXGYCYDGWHVLVBSTYDWSGWHXAYCYAWRWPYCXEWQCXDWHWOVMVNVIVJSTVOSVPVQV
      S $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Epsilon induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d ph y z w $.  $d x y z w $.
    setinds.1 $e |- ( A. y e. x [. y / x ]. ph -> ph ) $.
    $( Principle of ` _E ` induction (set induction).  If a property passes
       from all elements of ` x ` to ` x ` itself, then it holds for all
       ` x ` .  (Contributed by Scott Fenton, 10-Mar-2011.) $)
    setinds $p |- ph $=
      ( vz cv cvv wcel vex cab wss wi wceq setind wsbc wral dfss3 df-sbc ralbii
      nfsbc1v nfcv nfral nfim raleq sbceq1a chvar sylbir sylbi sylib mpg eqcomi
      imbi12d abeq2i mpbi ) BFZGHABIABGABJZGEFZUPKZUQUPHZLUPGMEEUPNURABUQOZUSUR
      CFZUPHZCUQPZUTCUQUPQVCABVAOZCUQPZUTVDVBCUQABVARSVDCUOPZALVEUTLBEVEUTBVDBC
      UQBUQUAABVATUBABUQTUCUOUQMVFVEAUTVDCUOUQUDABUQUEULDUFUGUHABUQRUIUJUKUMUN
      $.
  $}

  ${
    $d x y $.  $d ph y $.
    setinds2f.1 $e |- F/ x ps $.
    setinds2f.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    setinds2f.3 $e |- ( A. y e. x ps -> ph ) $.
    $( ` _E ` induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 10-Mar-2011.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    setinds2f $p |- ph $=
      ( cv wsbc wral wsb sbsbc sbie bitr3i ralbii sylbi setinds ) ACDACDHIZDCHZ
      JBDSJARBDSRACDKBACDLABCDEFMNOGPQ $.
  $}

  ${
    $d x y $.  $d ph y $.  $d ps x $.
    setinds2.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    setinds2.2 $e |- ( A. y e. x ps -> ph ) $.
    $( ` _E ` induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 10-Mar-2011.) $)
    setinds2 $p |- ph $=
      ( nfv setinds2f ) ABCDBCGEFH $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Ordinal numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.
    $( A class of transitive sets is partially ordered by ` _E ` .
       (Contributed by Scott Fenton, 15-Oct-2010.) $)
    elpotr $p |- ( A. z e. A Tr z -> _E Po A ) $=
      ( vx vy wel wa wi wal wral wtr cep wpo alral alimi syl ralcom ralbii epel
      cv wbr ralimi bitri sylib dftr2 df-po anbi12i imbi12i elirrv mtbir bitr3i
      wn biantrur 2ralbii bitr4i 3imtr4i ) CDEZDAEZFZCAEZGZDHZCHZABIZUTABIZDBIZ
      CBIZASZJZABIBKLZVCUTDBIZCBIZABIZVFVBVKABVBVJCHVKVAVJCUTDBMNVJCBMOUAVLVJAB
      IZCBIVFVJACBBPVMVECBUTADBBPQUBUCVHVBABCDVGUDQVICSZVNKTZUKZVNDSZKTZVQVGKTZ
      FZVNVGKTZGZFZABIZDBICBIVFCDABKUEVDWDCDBBUTWCABUTWBWCVTURWAUSVRUPVSUQCDRDA
      RUFCARUGVPWBVOCCECUHCCRUIULUJQUMUNUO $.
  $}

  ${
    $( Given ~ ax-reg , an ordinal is a transitive class totally ordered by
       epsilon.  (Contributed by Scott Fenton, 28-Jan-2011.) $)
    dford5reg $p |- ( Ord A <-> ( Tr A /\ _E Or A ) ) $=
      ( word wtr cep wwe wa wor df-ord wfr zfregfr df-we mpbiran anbi2i bitri )
      ABACZADEZFOADGZFAHPQOPADIQAJADKLMN $.
  $}

  ${
    $d x y $.  $d y ph $.  $d y ps $.
    $( Lemma for ~ dfon2 .  (Contributed by Scott Fenton, 28-Feb-2011.) $)
    dfon2lem1 $p |- Tr U. { x | ( ph /\ Tr x /\ ps ) } $=
      ( vy cv wtr w3a cab cuni truni wcel wsbc nfsbc1v nfv vex weq sbceq1a treq
      nf3an 3anbi123d elabf simp2bi mprg ) DEZFZACEZFZBGZCHZIFDUIDUIJUDUIKACUDL
      ZUEBCUDLZUHUJUEUKGCUDUJUEUKCACUDMUECNBCUDMSDOCDPAUJUGUEBUKACUDQUFUDRBCUDQ
      TUAUBUC $.
  $}

  ${
    $d x y A $.  $d y ph $.  $d y ps $.
    $( Lemma for ~ dfon2 (Contributed by Scott Fenton, 28-Feb-2011.) $)
    dfon2lem2 $p |- U. { x | ( x C_ A /\ ph /\ ps ) } C_ A $=
      ( cv wss w3a cab cpw cuni simp1 ss2abi df-pw sseqtr4i sspwuni mpbi ) CEDF
      ZABGZCHZDIZFSJDFSQCHTRQCQABKLCDMNSDOP $.
  $}

  ${
    $d A x y z w t $.

    $( Lemma for ~ dfon2 .  All sets satisfying the new definition are
       transitive and untangled.  (Contributed by Scott Fenton,
       25-Feb-2011.) $)
    dfon2lem3 $p |- ( A e. V -> ( A. x ( ( x C. A /\ Tr x ) -> x e. A ) ->
                                        ( Tr A /\ A. z e. A -. z e. z ) ) ) $=
      ( vw vt wcel cv wtr wa wi wel wn wral wss w3a wceq sseq1 treq cvv wal cab
      wpss cuni untelirr wrex eluni2 raleq 3anbi123d elequ1 elequ2 bitrd notbid
      vex elab cbvralv biimpi 3ad2ant3 sylbi rsp rexlimiv mprg dfon2lem2 dfpss2
      syl dfon2lem1 ssexg mpan psseq1 anbi12d eleq1 imbi12d spcgv imp sylan csn
      csuc snssi df-suc sseq1i unss bitr4i biimpri sylancr suctr untuni mprgbir
      cun ax-mp nfra1 nf3an nfab nfuni untsucf sucexg nfcv raleqf cbvabv elab2g
      nfv nfsuc biimprd com12 mp3an23 elssuni sucssel syl5 syld mpd syl6 mpan2i
      syl5bir mpani mt3i pm3.2i mpbii ex ) CDGZAHZCUCZXSIZJZXSCGZKZAUAZCIZBBLZM
      ZBCNZJZXRYEJZEHZCOZYLIZFFLZMZFYLNZPZEUBZUDZCQZYJYKUUAYTYTGZYHUUBMBYTBYTUE
      BHZYTGBALZAYSUFYHAUUCYSUGUUDYHAYSXSYSGZYHBXSNZUUDYHKUUEXSCOZYAYPFXSNZPZUU
      FYRUUIEXSAUNYLXSQYMUUGYNYAYQUUHYLXSCRYLXSSYPFYLXSUHUIUOUUHUUGUUFYAUUHUUFY
      PYHFBXSFHUUCQZYOYGUUJYOBFLYGFBFUJFBBUKULUMUPUQURUSZYHBXSUTVEVAUSVBYKYTCOZ
      UUAMZUUBYNYQECVCZUULUUMJYTCUCZYKUUBYTCVDYKUUOYTIZUUBYMYQEVFZYKUUOUUPJZYTC
      GZUUBXRYTTGZYEUURUUSKZUULXRUUTUUNYTCDVGVHUUTYEUVAYDUVAAYTTXSYTQZYBUURYCUU
      SUVBXTUUOYAUUPXSYTCVIXSYTSVJXSYTCVKVLVMVNVOUUSYTVQZCOZUUBUUSUULYTVPZCOZUV
      DUUNYTCVRUVDUULUVFJZUVDYTUVEWHZCOUVGUVCUVHCYTVSVTYTUVECWAWBWCWDUUSUVDUVCY
      SGZUUBUVDUUSUVIUVDUVCIZYPFUVCNZUUSUVIKUUPUVJUUQYTWEWIYHBYTNZUVKUVLUUFAYSB
      AYSWFUUKWGZBFYTFYSYRFEYMYNYQFYMFWTYNFWTYPFYLWJWKWLWMZWNWIUUSUVDUVJUVKPZUV
      IUUSUVCTGZUVOUVIKYTCWOUVPUVIUVOUUCCOZUUCIZYPFUUCNZPZUVOBUVCYSTUUCUVCQUVQU
      VDUVRUVJUVSUVKUUCUVCCRUUCUVCSYPFUUCUVCFUUCWPFYTUVNXAWQUIYRUVTEBYLUUCQYMUV
      QYNUVRYQUVSYLUUCCRYLUUCSYPFYLUUCUHUIWRWSXBVEXCXDXCUVIUVCYTOUUSUUBUVCYSXEY
      TYTCXFXGXHXIXJXKXLXMXNUUAUUPUVLJYJUUPUVLUUQUVMXOUUAUUPYFUVLYIYTCSYHBYTCUH
      VJXPVEXQ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    dfon2lem4.1 $e |- A e. _V $.
    dfon2lem4.2 $e |- B e. _V $.
    $( Lemma for ~ dfon2 .  If two sets satisfy the new definition, then one is
       a subset of the other.  (Contributed by Scott Fenton, 25-Feb-2011.) $)
    dfon2lem4 $p |- ( ( A. x ( ( x C. A /\ Tr x ) -> x e. A ) /\
                         A. y ( ( y C. B /\ Tr y ) -> y e. B ) ) ->
                         ( A C_ B \/ B C_ A ) ) $=
      ( vz cv wpss wtr wa wcel wi wal wceq wo wss wn cvv eleq1 inss1 sseli wral
      cin wel dfon2lem3 ax-mp simprd eleq2 bitrd notbid rspccv syl syl5 pm2.01d
      adantr elin sylnib simpld trin syl2an inex1 psseq1 anbi12d imbi12d mpan2d
      treq spcv adantl anim12d mtod ianor sylib sspss mpbi inss2 orel1 orc syl6
      olc jaoa mp2ani df-ss sseqin2 orbi12i sylibr ) AHZCIZWGJZKZWGCLZMZANZBHZD
      IZWNJZKZWNDLZMZBNZKZCDUDZCOZXBDOZPZCDQZDCQZPXAXBCIZRZXBDIZRZPZXEXAXHXJKZR
      XLXAXMXBCLZXBDLZKZXAXBXBLZXPXAXQXQXNXAXQRZXBCXBCDUAZUBWMXNXRMZWTWMGGUEZRZ
      GCUCZXTWMCJZYCCSLWMYDYCKMEAGCSUFUGZUHYBXRGXBCGHZXBOZYAXQYGYAXBYFLXQYFXBYF
      TYFXBXBUIUJUKULUMUPUNUOXBCDUQURXAXHXNXJXOXAXHXBJZXNWMYDDJZYHWTWMYDYCYEUSW
      TYIYBGDUCZDSLWTYIYJKMFBGDSUFUGUSCDUTVAZWMXHYHKZXNMZWTWLYMAXBCDEVBZWGXBOZW
      JYLWKXNYOWHXHWIYHWGXBCVCWGXBVGVDWGXBCTVEVHUPVFXAXJYHXOYKWTXJYHKZXOMZWMWSY
      QBXBYNWNXBOZWQYPWRXOYRWOXJWPYHWNXBDVCWNXBVGVDWNXBDTVEVHVIVFVJVKXHXJVLVMXL
      XHXCPZXJXDPZXEXBCQYSXSXBCVNVOXBDQYTCDVPXBDVNVOXIYSXEXKYTXIYSXCXEXHXCVQXCX
      DVRVSXKYTXDXEXJXDVQXDXCVTVSWAWBUMXFXCXGXDCDWCDCWDWEWF $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    dfon2lem5.1 $e |- A e. _V $.
    dfon2lem5.2 $e |- B e. _V $.
    $( Lemma for ~ dfon2 .  Two sets satisfying the new definition also satisfy
       trichotomy with respect to ` e. ` (Contributed by Scott Fenton,
       25-Feb-2011.) $)
    dfon2lem5 $p |- ( ( A. x ( ( x C. A /\ Tr x ) -> x e. A ) /\
                         A. y ( ( y C. B /\ Tr y ) -> y e. B ) ) ->
                       ( A e. B \/ A = B \/ B e. A ) ) $=
      ( vz cv wpss wtr wa wcel wi wal wceq wn wo w3o bitri cvv dfon2lem4 dfpss2
      wss eqcom notbii anbi2i orbi12i andir bitr4i orcom dfon2lem3 ax-mp simpld
      wel wral psseq1 treq anbi12d eleq1 imbi12d spcv exp3acom23 sylan2 orim12d
      imp mpan9 syl5bi syl5bir mpand 3orrot 3orass df-or sylibr ) AHZCIZVNJZKZV
      NCLZMZANZBHZDIZWAJZKZWADLZMZBNZKZCDOZPZDCLZCDLZQZMZWLWIWKRZWHCDUCZDCUCZQZ
      WJWMABCDEFUAWRWJKZCDIZDCIZQZWHWMXBWPWJKZWQWJKZQWSWTXCXAXDCDUBXAWQDCOZPZKX
      DDCUBXFWJWQXEWIDCUDUEUFSUGWPWQWJUHUIXBXAWTQWHWMWTXAUJWHXAWKWTWLWGVTDJZXAW
      KMZWGXGGGUNPZGDUOZDTLWGXGXJKMFBGDTUKULUMVTXGXHVTXAXGWKVSXAXGKZWKMADFVNDOZ
      VQXKVRWKXLVOXAVPXGVNDCUPVNDUQURVNDCUSUTVAVBVEVCVTCJZWGWTWLMVTXMXIGCUOZCTL
      VTXMXNKMEAGCTUKULUMWGWTXMWLWFWTXMKZWLMBCEWACOZWDXOWEWLXPWBWTWCXMWACDUPWAC
      UQURWACDUSUTVAVBVFVDVGVHVIWOWIWKWLRZWNWLWIWKVJXQWIWMQWNWIWKWLVKWIWMVLSSVM
      $.
  $}

  ${
    $d S x y z w s t $.
    $( Lemma for ~ dfon2 .  A transitive class of sets satisfying the new
       definition satisfies the new definition.  (Contributed by Scott Fenton,
       25-Feb-2011.) $)
    dfon2lem6 $p |- ( ( Tr S /\
                         A. x e. S A. z ( ( z C. x /\ Tr z ) -> z e. x ) ) ->
                       A. y ( ( y C. S /\ Tr y ) -> y e. S ) ) $=
      ( vs vw vt wtr cv wpss wa wel wi wal wral wcel weq wn syl imbi12d wo cdif
      wss pssss ssralv impcom adantrr ad2ant2lr psseq2 anbi1d elequ2 albidv imp
      rspccv eldifi rspcv psseq1 treq anbi12d elequ1 cbvalv syl6ib ad2ant2l w3o
      adantr vex dfon2lem5 3orrot 3orass bitri eleq1a elndif nsyli adantll trss
      orel1 eldifn ssel con3d syl5com syl9 adantl imp31 syl9r mpd syl5bi mp2and
      syl5 ssrdv dfpss2 exp3a com23 syl6 com3l adantld imp32 syl5bir mpand orrd
      ex spv anassrs ralrimiva wrex c0 wne pssdif r19.2z ad2antrl eleq1 syl5ibr
      a1i trel syl7 ad2antrr jaod rexlimdv syld alrimiv ) DHZCIZAIZJZYAHZKZCALZ
      MZCNZADOZKZBIZDJZYKHZKZYKDPZMBYJYNYOYJYNKZBEQZBELZUAZEDYKUBZOZYOYPYSEYTYJ
      YNEIZYTPZYSYJYNUUCKZKZYQYRUUEYKUUBUCZYQRZYRUUEFYKUUBUUEFBLZFELZUUEUUHKZYA
      FIZJZYDKZCFLZMZCNZGIZUUBJZUUQHZKZGELZMZGNZUUIUUEUUHUUPUUEYHAYKOZUUHUUPMYI
      YNUVDXTUUCYIYLUVDYMYLYIUVDYLYKDUCYIUVDMYKDUDYHAYKDUESUFUGUHYHUUPAUUKYKAFQ
      ZYGUUOCUVEYEUUMYFUUNUVEYCUULYDYBUUKYAUIUJAFCUKTULUNSUMUUEUVCUUHYIUUCUVCXT
      YNUUCYIUVCUUCYIYAUUBJZYDKZCELZMZCNZUVCUUCUUBDPZYIUVJMUUBDYKUOZYHUVJAUUBDA
      EQZYGUVICUVMYEUVGYFUVHUVMYCUVFYDYBUUBYAUIUJAECUKTULUPSZUVIUVBCGCGQZUVGUUT
      UVHUVAUVOUVFUURYDUUSYAUUQUUBUQYAUUQURUSCGEUTTVAVBUFVCVEUUPUVCKUUIFEQZEFLZ
      VDZUUJUUICGUUKUUBFVFEVFVGUVRUVPUVQUUIUAZUAZUUJUUIUVRUVPUVQUUIVDUVTUUIUVPU
      VQVHUVPUVQUUIVIVJUUJUVPRZUVTUUIMUUDUUHUWAYJUUCUUHUWAYNUUCUUHUWAUUCUVPUUKY
      TPUUHUUBYTUUKVKUUKYKDVLVMUMVNVNUWAUVTUVSUUJUUIUVPUVSVPUUJUVQRZUVSUUIMUUDU
      UHUWBYJYNUUCUUHUWBYMUUCUUHUWBMMYLYMUUHUUKYKUCZUUCUWBYKUUKVOUUCEBLZRUWCUWB
      UUBDYKVQUWCUVQUWDUUKYKUUBVRVSVTWAWBWCVNUVQUUIVPSWDWEWFWHWGWTWIUUFUUGKYKUU
      BJZUUEYRYKUUBWJYJYNUUCUWEYRMZYIYNUUCUWFMZMXTYIYMUWGYLUUCYIYMUWFUUCYIUVJYM
      UWFMUVNUVJUWEYMYRUVJUWEYMYRUVIUWEYMKZYRMCBCBQZUVGUWHUVHYRUWIUVFUWEYDYMYAY
      KUUBUQYAYKURUSCBEUTTXAWKWLWMWNWOWBWPWQWRWSXBXCYPUUAYSEYTXDZYOYLUUAUWJMZYJ
      YMYLYTXEXFZUWKYKDXGUWLUUAUWJYSEYTXHWTSXIYPYSYOEYTYPYSUUCYOYPYQUUCYOMZYRYQ
      UWMMYPUUCYOYQUVKUVLYKUUBDXJXKXLXTYRUWMMYIYNUUCUVKXTYRYOUVLXTYRUVKYODYKUUB
      XMWKXNXOXPWLXQXRWEWTXS $.
  $}

  ${
    $d A x y z w s t u $.  $d B x y z w t $.
    dfon2lem7.1 $e |- A e. _V $.
    $( Lemma for ~ dfon2 .  All elements of a new ordinal are new ordinals.
       (Contributed by Scott Fenton, 25-Feb-2011.) $)
    dfon2lem7 $p |- ( A. x ( ( x C. A /\ Tr x ) -> x e. A ) ->
                       ( B e. A -> A. y ( ( y C. B /\ Tr y ) -> y e. B ) ) ) $=
      ( vw vt vz vu wpss wtr wa wcel wi wal wss wel wral sylbi imbi12d w3a cuni
      vs cv cab wceq csuc csn wn weq elequ1 elequ2 notbid cbvralv biimpi ralimi
      bitrd untuni sylibr vex sseq1 treq raleq 3anbi123d dfon2lem3 ax-mp simprd
      elab cvv untelirr 3ad2ant3 mprg psseq2 anbi1d albidv 3anbi3i abbii unieqi
      syl eleq2i sylnib dfon2lem2 ssexi snss mtbi intnan cun df-suc sseq1i unss
      bitr4i mtbir dfon2lem1 suctr elsuc wrex eluni2 nfa1 rspccv psseq1 anbi12d
      wo cbvalv syl6ib rexlimi rexlimiv rgen dfon2lem6 mp2an eleq2 mpbiri sucex
      elssuni sylbir mp3an23 ralbii syl6bb cbvabv syl6sseq syl5bir mpani syl5bi
      jaoi a1i mtoi eleq1 spcv mpan2i mtod dfpss2 biimpri mpan nsyl2 mpbii 3syl
      rsp ) AUDZCJZYQKZLZYQCMZNZAOZFUDZCPZUUDKZBUDZGUDZJZUUGKZLZBGQZNZBOZGUUDRZ
      UAZFUEZUBZCUFZUUGHUDZJZUUJLZBHQZNZBOZHCRZDCMUUGDJZUUJLZUUGDMZNZBOZNUUCUUR
      CJZUUSUUCUVLUURCMZUUCUVMUURUGZUUEUUFUUGIUDZJZUUJLZBIQZNZBOZIUUDRZUAZFUEZU
      BZPZUWEUURUWDPZUURUHZUWDPZLZUWHUWFUURUWDMZUWHHHQZUIZHUURRZUWJUIGGQZUIZGYQ
      RZUWMAUUQUWPAUUQRUWLHYQRZAUUQRUWMUWPUWQAUUQUWPUWQUWOUWLGHYQGHUJZUWNUWKUWR
      UWNHGQUWKGHGUKGHHULUQUMUNUOUPHAUUQURUSYQUUQMZYQCPZYSUUNGYQRZUAZUWPUUPUXBF
      YQAUTZFAUJZUUEUWTUUFYSUUOUXAUUDYQCVAZUUDYQVBZUUNGUUDYQVCZVDVHZUXAUWTUWPYS
      UUNUWOGYQUUNIIQUIIUUHRZUWOUUNUUHKZUXIUUHVIMUUNUXJUXILNGUTBIUUHVIVEVFVGIUU
      HVJVSUPVKSVLUWMUURUURMUWJHUURVJUURUWDUURUUQUWCUUPUWBFUUOUWAUUEUUFUUNUVTGI
      UUDGIUJZUUMUVSBUXKUUKUVQUULUVRUXKUUIUVPUUJUUHUVOUUGVMVNGIBULTVOZUNVPVQVRV
      TWAVFUURUWDUURCEUUFUUOFCWBZWCZWDWEWFUWEUURUWGWGZUWDPUWIUVNUXOUWDUURWHZWIU
      URUWGUWDWJWKWLUVMUWGCPZUUCUWEUURCUXNWDUUCUURCPZUXQUWEUXMUXRUXQLZUVNCPZUUC
      UWEUXTUXOCPUXSUVNUXOCUXPWIUURUWGCWJWKUXTUWENUUCUXTUVNUCUDZCPZUYAKZYQUVOJZ
      YSLZAIQZNZAOZIUYARZUAZUCUEZUBZUWDUXTUVNKZUYHIUVNRZUVNUYLPZUURKZUYMUUEUUOF
      WMZUURWNVFUYHIUVNUVOUVNMUVOUURMZUVOUURUFZXBUYHUVOUURIUTWOUYRUYHUYSUYRIAQZ
      AUUQWPZUYHAUVOUUQWQZUYTUYHAUUQUYGAWRUWSUXBUYTUYHNZUXHUXAUWTVUCYSUXAUYTUVT
      UYHUUNUVTGUVOYQUXLWSZUVSUYGBABAUJZUVQUYEUVRUYFVUEUVPUYDUUJYSUUGYQUVOWTUUG
      YQVBXABAIUKTXCXDVKSXESUYSUYHYQUURJZYSLZYQUURMZNZAOZUYPUUTUVOJZUUTKZLZHIQZ
      NZHOZIUURRVUJUYQVUPIUURUYRVUAVUPVUBUYTVUPAUUQUWSUXBUYTVUPNZUXHUXAUWTVUQYS
      UXAUYTUVTVUPVUDUVSVUOBHBHUJZUVQVUMUVRVUNVURUVPVUKUUJVULUUGUUTUVOWTUUGUUTV
      BXABHIUKTXCXDVKSXFSXGIAHUURXHXIUYSUYGVUIAUYSUYEVUGUYFVUHUYSUYDVUFYSUVOUUR
      YQVMVNUVOUURYQXJTVOXKYCSXGUXTUYMUYNUAZUVNUYKMUYOUYJVUSUCUVNUURUXNXLUYAUVN
      UFUYBUXTUYCUYMUYIUYNUYAUVNCVAUYAUVNVBUYHIUYAUVNVCVDVHUVNUYKXMXNXOUYKUWCUY
      JUWBUCFUCFUJZUYBUUEUYCUUFUYIUWAUYAUUDCVAUYAUUDVBVUTUYIUYHIUUDRUWAUYHIUYAU
      UDVCUYHUVTIUUDUYGUVSABABUJZUYEUVQUYFUVRVVAUYDUVPYSUUJYQUUGUVOWTYQUUGVBXAA
      BIUKTXCXPXQVDXRVRXSYDXTYAYBYEUUCUVLUYPUVMUYQUUBUVLUYPLZUVMNAUURUXNYQUURUF
      ZYTVVBUUAUVMVVCYRUVLYSUYPYQUURCWTYQUURVBXAYQUURCYFTYGYHYIUXRUUSUIZUVLUXMU
      VLUXRVVDLUURCYJYKYLYMUUSUVEHUURRUVFUVEHUURUUTUURMHAQZAUUQWPUVEAUUTUUQWQVV
      EUVEAUUQUWSUWTYSUVEHYQRZUAZVVEUVENZUUPVVGFYQUXCUXDUUEUWTUUFYSUUOVVFUXEUXF
      UXDUUOUXAVVFUXGUUNUVEGHYQUWRUUMUVDBUWRUUKUVBUULUVCUWRUUIUVAUUJUUHUUTUUGVM
      VNGHBULTVOUNXQVDVHVVFUWTVVHYSUVEHYQYPVKSXFSXGUVEHUURCVCYNUVEUVKHDCUUTDUFZ
      UVDUVJBVVIUVBUVHUVCUVIVVIUVAUVGUUJUUTDUUGVMVNUUTDUUGXJTVOWSYO $.
  $}

  ${
    $d A x y z w s t $.
    $( Lemma for ~ dfon2 .  The intersection of a non-empty class ` A ` of new
       ordinals is itself a new ordinal and is contained within ` A `
       (Contributed by Scott Fenton, 26-Feb-2011.) $)
    dfon2lem8 $p |- ( ( A =/= (/) /\
                         A. x e. A A. y ( ( y C. x /\ Tr y ) -> y e. x ) ) ->
                       ( A. z ( ( z C. |^| A /\ Tr z ) -> z e. |^| A ) /\
                         |^| A e. A ) ) $=
      ( vt vw cv wpss wtr wa wel wi wal wral wcel wn cvv syl sylbi wceq c0 cint
      wne vex dfon2lem3 ax-mp simpld ralimi trint adantl cuni dfon2lem7 alrimiv
      df-ral 19.21v albii bitr4i impexp 2albii eluni2 biimpi imim1i alimi alcom
      wrex wex 19.23v df-rex imbi1i bitri 3imtr4i sylbir intssuni ssralv adantr
      wss mpd dfon2lem6 imp simprd untelirr adantlr risset notbii ralnex psseq2
      intex eqcom anbi1d elequ2 imbi12d albidv rspccv intss1 dfpss2 psseq1 treq
      anbi12d eleq1 spcgv exp3a syl5bir exp4b com45 com23 syl5 mpdd mpid syl7bi
      ralrimiv ralim syl5bi wb elintg ad2antrr sylibrd mt3d ex ancld mp2and ) D
      UAUCZBGZAGZHZYBIZJZBAKZLZBMZADNZJZDUBZIZEGZFGZHYNIJEFKLEMZFYLNZCGZYLHYRIJ
      YRYLOLCMZYLDOZJZYJYMYAYJYCIZADNYMYIUUBADYIUUBCCKPCYCNZYCQOYIUUBUUCJLAUDZB
      CYCQUEUFUGUHADUIRUJYKYPFDUKZNZYQYJUUFYAYJFAKZYPLZFMZADNZUUFYIUUIADYIUUHFB
      EYCYOUUDULUMUHUUJYCDOZUUHLZFMZAMZUUFUUJUUKUUILZAMUUNUUIADUNUUMUUOAUUKUUHF
      UOUPUQUUNUUKUUGJZYPLZFMAMZUUFUUQUULAFUUKUUGYPURUSUUGADVEZYPLZFMZYOUUEOZYP
      LZFMUURUUFUUTUVCFUVBUUSYPUVBUUSAYODUTVAVBVCUURUUQAMZFMUVAUUQAFVDUVDUUTFUV
      DUUPAVFZYPLUUTUUPYPAVGUUSUVEYPUUGADVHVIUQUPVJYPFUUEUNVKVLSRUJYAUUFYQLZYJY
      AYLUUEVPUVFDVMYPFYLUUEVNRVOVQYMYQJYSYKUUAFCEYLVRYKYSYTYKYSYTYKYSJZYTYLYLO
      ZYAYSUVHPZYJYAYSJZEEKPEYLNZUVIUVJYMUVKYAYSYMUVKJZYAYLQOZYSUVLLDWGZCEYLQUE
      SVSZVTEYLWARWBUVGYTPZYLYNOZEDNZUVHUVPYNYLTZPZEDNZUVGUVRUVPUVSEDVEZPUWAYTU
      WBEYLDWCWDUVSEDWEUQUVGUVTUVQLZEDNUWAUVRLUVGUWCEDUVTYLYNTZPZUVGYNDOZUVQUVS
      UWDYNYLWHWDUVGUWFYMUWEUVQLZYAYSYMYJUVJYMUVKUVOUGWBYKUWFYMUWGLZLYSYKUWFYBY
      NHZYEJZBEKZLZBMZUWHYJUWFUWMLYAYIUWMAYNDYCYNTZYHUWLBUWNYFUWJYGUWKUWNYDUWIY
      EYCYNYBWFWIAEBWJWKWLWMUJYAUWFUWMUWHLZLYJUWFYLYNVPZYAUWOYNDWNYAUWMUWPUWHYA
      UWMUWPUWEYMUVQYAUWMUWPUWEYMUVQLZUWPUWEJYLYNHZYAUWMJZUWQYLYNWOUWSUWRYMUVQY
      AUWMUWRYMJZUVQLZYAUVMUWMUXALUVNUWLUXABYLQYBYLTZUWJUWTUWKUVQUXBUWIUWRYEYMY
      BYLYNWPYBYLWQWRYBYLYNWSWKWTSVSXAXBXCXDXEXFVOXGVOXHXIXJUVTUVQEDXKRXLYAUVHU
      VRXMZYJYSYAUVMUXCUVNEYLDQXNSXOXPXQXRXSXFXT $.
  $}

  ${
    $d A x y z w s t u v $.
    $( Lemma for ~ dfon2 .  A class of new ordinals is well-founded by
       ` _E ` .  (Contributed by Scott Fenton, 3-Mar-2011.) $)
    dfon2lem9 $p |- ( A. x e. A A. y ( ( y C. x /\ Tr y ) -> y e. x )
                         -> _E Fr A ) $=
      ( vz vt vw vu cv wpss wtr wa wel wi wal wral wss wn wrex cep wcel wne wfr
      c0 ssralv cint dfon2lem8 simprd intss1 simpld cvv wceq dfon2lem3 untelirr
      intex imp syl eleq1 notbid syl5ibcom a1dd trss eqss simplbi2com syl6 con3
      com23 pm2.61d sylanb syldan ralrimiv eleq2 ralbidv rspcev syl2anc syl6com
      syl5 expcom imp3a alrimiv wbr df-fr epel notbii ralbii rexbii albii bitri
      imbi2i sylibr ) BHZAHIWJJKBALMBNZACOZDHZCPZWMUCUAZKZEFLZQZEWMOZFWMRZMZDNZ
      CSUBZWLXADWLWNWOWTWNWLWKAWMOZWOWTMWKAWMCUDWOXDWTWOXDKZWMUEZWMTZEHZXFTZQZE
      WMOZWTXEGHZXFIXLJKXLXFTMGNZXGABGWMUFZUGXEXJEWMEDLXFXHPZXEXJXHWMUHWOXDXMXO
      XJMZXEXMXGXNUIWOXFUJTZXMXPWMUNXQXMKZXFXHUKZXPXRXSXJXOXRXFXFTZQZXSXJXRAALQ
      AXFOZYAXRXFJZYBXQXMYCYBKGAXFUJULUOZUGAXFUMUPXSXTXIXFXHXFUQURUSUTXRXOXSQZX
      JXRXOXIXSMYEXJMXRXIXOXSXRXIXHXFPZXOXSMXRYCXIYFMXRYCYBYDUIXFXHVAUPXSXOYFXF
      XHVBVCVDVFXIXSVEVDVFVGVHVIVPVJWSXKFXFWMFHZXFUKZWRXJEWMYHWQXIYGXFXHVKURVLV
      MVNVQVOVRVSXCWPXHYGSVTZQZEWMOZFWMRZMZDNXBDFECSWAYMXADYLWTWPYKWSFWMYJWREWM
      YIWQEFWBWCWDWEWHWFWGWI $.
  $}

  ${
    $d x y z w t u v $.
    $( ` On ` consists of all sets that contain all its transitive proper
       subsets.  This definition comes from J. R. Isbell, "A Definition of
       Ordinal Numbers," American Mathematical Monthly, vol 67 (1960), pp.
       51-52.  (Contributed by Scott Fenton, 20-Feb-2011.) $)
    dfon2 $p |- On = { x | A. y ( ( y C. x /\ Tr y ) -> y e. x ) } $=
      ( vz vw vu vt vv cv cab wpss wtr wa wel wi wal cep wral vex weq imbi12d
      con0 df-on wss wne tz7.7 df-pss syl6bbr exbiri com23 imp3a alrimiv wwe wn
      word cvv wcel dfon2lem3 ax-mp simpld wfr w3o dfon2lem7 ralrimiv dfon2lem9
      psseq2 anbi1d elequ2 albidv psseq1 anbi12d elequ1 cbvalv syl6bb dfon2lem5
      treq anim12d syl6 ralrimivv jca syl wbr dfwe2 epel biid 3orbi123i 2ralbii
      rspccv anbi2i bitri sylibr df-ord sylanbrc impbii abbii eqtri ) UAAHZUNZA
      IBHZWPJZWRKZLBAMZNZBOZAIAUBWQXCAWQXCWQXBBWQWSWTXAWQWTWSXAWQWTXAWSWQWTLXAW
      RWPUCWRWPUDLWSWPWRUEWRWPUFUGUHUIUJUKXCWPKZWPPULZWQXCXDCCMUMCWPQZWPUOUPXCX
      DXFLNARZBCWPUOUQURUSXCWPPUTZCDMZCDSZDCMZVAZDWPQCWPQZLZXEXCEHZFHZJZXOKZLZE
      FMZNZEOZFWPQZXNXCYBFWPBEWPXPXGVBVCYCXHXMFEWPVDYCXLCDWPWPYCCAMZDAMZLGHZCHZ
      JZYFKZLZGCMZNZGOZWRDHZJZWTLZBDMZNZBOZLXLYCYDYMYEYSYBYMFYGWPFCSZYBXOYGJZXR
      LZECMZNZEOYMYTYAUUDEYTXSUUBXTUUCYTXQUUAXRXPYGXOVEVFFCEVGTVHUUDYLEGEGSZUUB
      YJUUCYKUUEUUAYHXRYIXOYFYGVIXOYFVOVJEGCVKTVLVMWGYBYSFYNWPFDSZYBXOYNJZXRLZE
      DMZNZEOYSUUFYAUUJEUUFXSUUHXTUUIUUFXQUUGXRXPYNXOVEVFFDEVGTVHUUJYREBEBSZUUH
      YPUUIYQUUKUUGYOXRWTXOWRYNVIXOWRVOVJEBDVKTVLVMWGVPGBYGYNCRDRVNVQVRVSVTXEXH
      YGYNPWAZXJYNYGPWAZVAZDWPQCWPQZLXNCDWPPWBUUOXMXHUUNXLCDWPWPUULXIXJXJUUMXKC
      DWCXJWDDCWCWEWFWHWIWJWPWKWLWMWNWO $.
  $}

  ${
    $d x y $.
    $( The domain of the epsilon relation is the universe.  (Contributed by
       Scott Fenton, 27-Oct-2010.) $)
    domep $p |- dom _E = _V $=
      ( vx vy weq cab cv cep wbr wex cvv cdm equid wel el exbii mpbir 2th abbii
      epel df-v df-dm 3eqtr4ri ) AACZADAEBEFGZBHZADIFJUBUDAUBUDAKUDABLZBHABMUCU
      EBABRNOPQASABFTUA $.
  $}

  ${
    $d F g $.  $d I g $.
    $( The value of the recursive definition generator at ` (/) ` when the base
       value is a proper class.  (Contributed by Scott Fenton, 26-Mar-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    rdgprc0 $p |- ( -. I e. _V -> ( rec ( F , I ) ` (/) ) = (/) ) $=
      ( vg cvv wcel wn c0 crdg cfv cv wceq cdm wlim crn cuni cif ax-mp syl eqid
      unieqd cmpt cres con0 0elon rdgval res0 eqtri wa eqeq1 wb dmeq limeq rneq
      fveq2i fveq2d ifbieq12d ifbieq2d eleq1d dmmpt elrab2 iftrue eleq1i biimpi
      id fveq12d adantl sylbi con3i ndmfv syl5eq ) BDEZFZGABHZIZGCDCJZGKZBVOLZM
      ZVONZOZVQOZVOIZAIZPZPZUAZIZGVNVMGUBZWFIZWGGUCEVNWIKUDBGCAUEQWHGWFVMUFUNUG
      VLGWFLZEZFWGGKWKVKWKGDEZGGKZBGLZMZGNZOZWNOZGIZAIZPZPZDEZUHVKWEDEXCCGDWJVP
      WEXBDVPVPWMWDXABVOGGUIVPVRWOVTWCWQWTVPVQWNKVRWOUJVOGUKZVQWNULRVPVSWPVOGUM
      TVPWBWSAVPWAWRVOGVPVDVPVQWNXDTVEUOUPUQURCDWEWFWFSUSUTXCVKWLXCVKXBBDWMXBBK
      GSWMBXAVAQVBVCVFVGVHGWFVIRVJ $.
  $}

  ${
    $d F x y z $.  $d I x y z $.
    $( The value of the recursive definition generator when ` I ` is a proper
       class.  (Contributed by Scott Fenton, 26-Mar-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    rdgprc $p |- ( -. I e. _V -> rec ( F , I ) = rec ( F , (/) ) ) $=
      ( vx vz vy cvv wcel cv crdg cfv c0 wceq con0 wral wi fveq2 eqeq12d imbi2d
      weq wb csuc rdgprc0 0ex rdg0 syl6eqr rdgsuc syl5ibr imim2d wlim cres word
      r19.21v wss limord ordsson wfn rdgfnon fvreseq mpanl12 3syl cima cuni crn
      wn rneq df-ima 3eqtr4g unieqd vex rdglim mpan sylbird syl5bi tfinds com12
      wa ralrimiv eqfnfv mp2an sylibr ) BFGVDZCHZABIZJZWBAKIZJZLZCMNZWCWELZWAWG
      CMWBMGWAWGWADHZWCJZWJWEJZLZOZWAKWCJZKWEJZLZOWAEHZWCJZWRWEJZLZOZWAWRUAZWCJ
      ZXCWEJZLZOWAWGODEWBWJKLZWMWQWAXGWKWOWLWPWJKWCPWJKWEPQRDESZWMXAWAXHWKWSWLW
      TWJWRWCPWJWRWEPQRWJXCLZWMXFWAXIWKXDWLXEWJXCWCPWJXCWEPQRDCSZWMWGWAXJWKWDWL
      WFWJWBWCPWJWBWEPQRWAWOKWPABUBKAUCUDUEWRMGZXAXFWAXAXFXKWSAJZWTAJZLWSWTAPXK
      XDXLXEXMBWRAUFKWRAUFQUGUHXBEWJNWAXAEWJNZOWJUIZWNWAXAEWJULXOXNWMWAXOXNWCWJ
      UJZWEWJUJZLZWMXOWJUKWJMUMZXRXNTZWJUNWJUOWCMUPZWEMUPZXSXTBAUQZKAUQZEMWJWCW
      EURUSUTXRWMXOWCWJVAZVBZWEWJVAZVBZLZXRYEYGXRXPVCXQVCYEYGXPXQVEWCWJVFWEWJVF
      VGVHWJFGZXOWMYITDVIYJXOVPWKYFWLYHBWJFAVJKWJFAVJQVKUGVLUHVMVNVOVQYAYBWIWHT
      YCYDCMWCWEVRVSVT $.
  $}

  ${
    $d F f $.  $d f g $.  $d F g $.  $d f i $.  $d F i $.  $d f x $.  $d F x $.
    $d f y $.  $d F y $.  $d g i $.  $d g x $.  $d g y $.  $d I f $.  $d I i $.
    $d i x $.  $d I x $.  $d i y $.  $d I y $.  $d x y $.  $d f z $.  $d F z $.
    $d i z $.  $d y z $.
    $( Alternate definition of the recursive function generator when ` I ` is a
       set.  (Contributed by Scott Fenton, 26-Mar-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    dfrdg2 $p |- ( I e. V -> rec ( F , I ) =
       U. { f | E. x e. On ( f Fn x /\
            A. y e. x ( f ` y ) =
              if ( y = (/) , I ,
                   if ( Lim y , U. ( f " y ) ,
                        ( F ` ( f ` U. y ) ) ) ) ) } ) $=
      ( cv cfv c0 wceq cuni cif con0 cvv wcel ax-mp syl fveq2d ifbieq2d iffalse
      vi vg vz crdg wfn wlim cima wral wa wrex cab rdgeq2 eqeq2d ralbidv anbi2d
      ifeq1 rexbidv abbidv unieqd eqeq12d cdm cmpt crecs cres df-rdg df-recs wb
      crn w3a vex resex eqeq1 wrel relres reldm0 syl6bb dmeq limeq rneq syl6eqr
      df-ima id fveq12d ifbieq12d eqid imaexg uniex fvex fvmpt cin dmres onelss
      ifex wss imp 3adant2 fndm 3ad2ant2 sseqtr4d df-ss sylib syl5eq unieq word
      onelon eloni csuc w3o ordzsl iftrue eqtr4d sucid ordunisuc 3eqtr4a wn wne
      fvres nsuceq0 df-ne mpbi nlimsucg mp2b 3eqtr4g reseq2 syl5ibrcom rexlimiv
      eqtri df-lim simp2bi neneqd 3jaoi sylbi sylan9eqr mpdan ralbidva pm5.32da
      3eqtr4d 3expa rexbiia abbii unieqi 3eqtri vtoclg ) DUAGZUDZCGZAGZUEZBGZUU
      FHZUUIIJZUUDUUIUFZUUFUUIUGZKZUUIKZUUFHZDHZLZLZJZBUUGUHZUIZAMUJZCUKZKZJDEU
      DZUUHUUJUUKEUURLZJZBUUGUHZUIZAMUJZCUKZKZJUAEFUUDEJZUUEUVFUVEUVMUUDEDULUVN
      UVDUVLUVNUVCUVKCUVNUVBUVJAMUVNUVAUVIUUHUVNUUTUVHBUUGUVNUUSUVGUUJUUKUUDEUU
      RUPUMUNUOUQURUSUTUUEUBNUBGZIJZUUDUVOVAZUFZUVOVHZKZUVQKZUVOHZDHZLZLZVBZVCU
      UHUUJUUFUUIVDZUWFHZJZBUUGUHZUIZAMUJZCUKZKUVEUBDUUDVEABCUWFVFUWMUVDUWLUVCC
      UWKUVBAMUUGMOZUUHUWJUVAUWNUUHUIUWIUUTBUUGUWNUUHUUIUUGOZUWIUUTVGUWNUUHUWOV
      IZUWHUUSUUJUWPUWHUWGVAZIJZUUDUWQUFZUUNUWQKZUWGHZDHZLZLZUUSUWGNOUWHUXDJUUF
      UUICVJZVKUBUWGUWEUXDNUWFUVOUWGJZUVPUWRUWDUXCUUDUXFUVPUWGIJZUWRUVOUWGIVLUW
      GVMUXGUWRVGUUFUUIVNUWGVOPVPUXFUVRUWSUVTUWCUUNUXBUXFUVQUWQJUVRUWSVGUVOUWGV
      QZUVQUWQVRQUXFUVSUUMUXFUVSUWGVHUUMUVOUWGVSUUFUUIWAVTUSUXFUWBUXADUXFUWAUWT
      UVOUWGUXFWBUXFUVQUWQUXHUSWCRWDSUWFWEUWRUUDUXCUAVJUWSUUNUXBUUMUUFNOUUMNOUX
      EUUFUUINWFPWGUXADWHWMWMWIPUWPUWQUUIJZUXDUUSJUWPUWQUUIUUFVAZWJZUUIUUFUUIWK
      UWPUUIUXJWNUXKUUIJUWPUUIUUGUXJUWNUWOUUIUUGWNZUUHUWNUWOUXLUUGUUIWLWOWPUUHU
      WNUXJUUGJUWOUUGUUFWQWRWSUUIUXJWTXAXBUXIUWPUXDUUKUUDUULUUNUUOUWGHZDHZLZLZU
      USUXIUWRUUKUXCUXOUUDUWQUUIIVLUXIUWSUULUXBUXNUUNUWQUUIVRUXIUXAUXMDUXIUWTUU
      OUWGUWQUUIXCRRSSUWPUUIXDZUXPUUSJZUWNUWOUXQUUHUWNUWOUIUUIMOUXQUUGUUIXEUUIX
      FQWPUXQUUKUUIUCGZXGZJZUCMUJZUULXHUXRUCUUIXIUUKUXRUYBUULUUKUXPUUDUUSUUKUUD
      UXOXJUUKUUDUURXJXKUYAUXRUCMUXSMOZUXRUYAUXTIJZUUDUXTUFZUUNUXTKZUUFUXTVDZHZ
      DHZLZLZUYDUUDUYEUUNUYFUUFHZDHZLZLZJUYCUYIUYMUYKUYOUYCUYHUYLDUYCUXSUYGHZUX
      SUUFHZUYHUYLUXSUXTOUYPUYQJUXSUCVJZXLUXSUXTUUFXQPUYCUYFUXSUYGUYCUXSXDUYFUX
      SJUXSXFUXSXMQZRUYCUYFUXSUUFUYSRXNRUYKUYJUYIUYDXOZUYKUYJJUXTIXPUYTUXSXRUXT
      IXSXTZUYDUUDUYJTPUXSNOZUYEXOZUYJUYIJUYRUXSNYAZUYEUUNUYITYBYGUYOUYNUYMUYTU
      YOUYNJVUAUYDUUDUYNTPVUBVUCUYNUYMJUYRVUDUYEUUNUYMTYBYGYCUYAUXPUYKUUSUYOUYA
      UUKUYDUXOUYJUUDUUIUXTIVLZUYAUULUYEUXNUYIUUNUUIUXTVRZUYAUXMUYHDUYAUUOUYFUW
      GUYGUUIUXTUUFYDUUIUXTXCZWCRSSUYAUUKUYDUURUYNUUDVUEUYAUULUYEUUQUYMUUNVUFUY
      AUUPUYLDUYAUUOUYFUUFVUGRRSSUTYEYFUULUXPUURUUSUULUXOUUNUXPUURUULUUNUXNXJUU
      LUUKXOZUXPUXOJUULUUIIUULUXQUUIIXPUUIUUOJUUIYHYIYJZUUKUUDUXOTQUULUUNUUQXJY
      QUULVUHUUSUURJVUIUUKUUDUURTQXKYKYLQYMYNXBUMYRYOYPYSYTUUAUUBUUC $.
  $}

  ${
    $d F f $.  $d f x $.  $d F x $.  $d f y $.  $d F y $.  $d I f $.  $d I x $.
    $d I y $.  $d x y $.
    $( Generalization of ~ dfrdg2 to remove sethood requirement.  (Contributed
       by Scott Fenton, 27-Mar-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    dfrdg3 $p |- rec ( F , I ) =
       U. { f | E. x e. On ( f Fn x /\
            A. y e. x ( f ` y ) =
              if ( y = (/) , if ( I e. _V , I , (/) ) ,
                   if ( Lim y , U. ( f " y ) ,
                        ( F ` ( f ` U. y ) ) ) ) ) } $=
      ( cvv wcel crdg cv cfv c0 wceq cif cuni wral wa con0 wrex cab dfrdg2 wlim
      wfn cima iftrue ifeq1d eqeq2d ralbidv anbi2d rexbidv abbidv unieqd eqtr4d
      wn 0ex ax-mp rdgprc iffalse 3eqtr4a pm2.61i ) EFGZDEHZCIZAIZUBZBIZVBJZVEK
      LZUTEKMZVEUAVBVEUCNVENVBJDJMZMZLZBVCOZPZAQRZCSZNZLUTVAVDVFVGEVIMZLZBVCOZP
      ZAQRZCSZNVPABCDEFTUTVOWBUTVNWACUTVMVTAQUTVLVSVDUTVKVRBVCUTVJVQVFUTVGVHEVI
      UTEKUDUEUFUGUHUIUJUKULUTUMZDKHZVDVFVGKVIMZLZBVCOZPZAQRZCSZNZVAVPKFGWDWKLU
      NABCDKFTUODEUPWCVOWJWCVNWICWCVMWHAQWCVLWGVDWCVKWFBVCWCVJWEVFWCVGVHKVIUTEK
      UQUEUFUGUHUIUJUKURUS $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Defined equality axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A version of ~ ax-ext for use with defined equality.  (Contributed by
     Scott Fenton, 12-Dec-2010.) $)
  axextdfeq $p |- E. z ( ( z e. x -> z e. y )
                    -> ( ( z e. y -> z e. x ) -> ( x e. w -> y e. w ) ) ) $=
    ( wel wb wi wex weq axextnd ax-13 imim2i eximii biimpexp exbii mpbi ) CAEZC
    BEZFZADEBDEGZGZCHQRGRQGTGGZCHSABIZGUACCABJUCTSABDKLMUAUBCQRTNOP $.

  $( A version of ~ ax-13 for use with defined equality.  (Contributed by Scott
     Fenton, 12-Dec-2010.) $)
  ax13dfeq $p |- E. z ( ( z e. x -> z e. y ) -> ( w e. x -> w e. y ) ) $=
    ( weq wel wi a9e ax-13 equcoms imim12d eximii ) CDEZCAFZCBFZGDAFZDBFZGGCCDH
    MPNOQPNGDCDCAIJCDBIKL $.

  ${
    $d w x $.  $d w y $.  $d z w $.
    $( ~ ax-ext with distinctors instead of distinct variable restrictions.
       (Contributed by Scott Fenton, 13-Dec-2010.) $)
    axextdist $p |- ( ( -. A. z z = x /\ -. A. z z = y )
                      -> ( A. z ( z e. x <-> z e. y ) -> x = y ) ) $=
      ( vw weq wal wn wa wel wb nfnae nfan wnfc nfcvf adantr nfcrd adantl nfbid
      cv elequ1 wi bibi12d a1i cbvald axext3 syl6bir ) CAECFGZCBECFGZHZCAIZCBIZ
      JZCFDAIZDBIZJZDFABEUIUOULDCUGUHCCACKCBCKLUIUMUNCUICDASZUGCUPMUHCANOPUICDB
      SZUHCUQMUGCBNQPRDCEZUOULJUAUIURUMUJUNUKDCATDCBTUBUCUDABDUEUF $.

    $( ~ axext4 with distinctors instead of distinct variable restrictions.
       (Contributed by Scott Fenton, 13-Dec-2010.) $)
    axext4dist $p |- ( ( -. A. z z = x /\ -. A. z z = y )
                      -> ( x = y <-> A. z ( z e. x <-> z e. y ) ) ) $=
      ( weq wal wn wa wel wb wi ax12o imp nfnae nfan elequ2 a1i alimd axextdist
      syld impbid ) CADCEFZCBDCEFZGZABDZCAHCBHIZCEZUCUDUDCEZUFUAUBUDUGJABCKLUCU
      DUECUAUBCCACMCBCMNUDUEJUCABCOPQSABCRT $.
  $}

  ${
    $d x y $.
    19.12b.1 $e |- F/ y ph $.
    19.12b.2 $e |- F/ x ps $.
    $( ~ 19.12vv with not-free hypotheses, instead of distinct variable
       conditions.  (Contributed by Scott Fenton, 13-Dec-2010.)  (Revised by
       Mario Carneiro, 11-Dec-2016.) $)
    19.12b $p |- ( E. x A. y ( ph -> ps ) <-> A. y E. x ( ph -> ps ) ) $=
      ( wi wal wex 19.21 exbii nfal 19.36 albii bitr2i 3bitri ) ABGZDHZCIABDHZG
      ZCIACHZSGZQCIZDHZRTCABDEJKASCBCDFLMUDUABGZDHUBUCUEDABCFMNUABDADCELJOP $.
  $}

  $( There is always a set not in ` y ` .  (Contributed by Scott Fenton,
     13-Dec-2010.) $)
  exnel $p |- E. x -. x e. y $=
    ( wel wn wex elirrv nfth weq ax-13 con3d spime ax-mp ) BBCZDZABCZDZAEBFZNPA
    BNAQGABHOMABBIJKL $.

  ${
    $d x z $.  $d y z $.
    $( Distinctors in terms of membership.  (NOTE: this only works with
       relations where we can prove ~ el and ~ elirrv .)  (Contributed by Scott
       Fenton, 15-Dec-2010.) $)
    distel $p |- ( -. A. y y = x <-> -. A. y -. x e. y ) $=
      ( vz weq wal wn wel wex el df-ex nfnae dveel1 nfd wb wi elequ2 notbid a1i
      nfnd cbvald syl5bb mpbii elirrv elequ1 mtbii alimi con3i impbii ) BADZBEZ
      FZABGZFZBEZFZUKACGZCHZUOACIUQUPFZCEZFUKUOUPCJUKUSUNUKURUMCBBABKZUKUPBUKUP
      BUTBACLMSCBDZURUMNOUKVAUPULCBAPQRTQUAUBUJUNUIUMBUIBBGULBUCBABUDUEUFUGUH
      $.
  $}

  $( ~ axextnd as a biconditional.  (Contributed by Scott Fenton,
     14-Dec-2010.) $)
  axextndbi $p |- E. z ( x = y <-> ( z e. x <-> z e. y ) ) $=
    ( weq wel wb wex wi wa axextnd elequ2 jctl eximii dfbi2 exbii mpbir ) ABDZC
    AECBEFZFZCGQRHZRQHZIZCGUAUBCCABJUATABCKLMSUBCQRNOP $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Hypothesis builders
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A more general form of ~ hbnt .  (Contributed by Scott Fenton,
     13-Dec-2010.) $)
  hbntg $p |- ( A. x ( ph -> A. x ps ) -> ( -. ps -> A. x -. ph ) ) $=
    ( wn wal wi ax6o con1i con3 al2imi syl5 ) BDBCEZDZCEZALFZCEADZCENBBCGHOMPCA
    LIJK $.

  $( A more general and closed form of ~ hbim .  (Contributed by Scott Fenton,
     13-Dec-2010.) $)
  hbimtg $p |- ( ( A. x ( ph -> A. x ch ) /\ ( ps -> A. x th ) ) ->
                ( ( ch -> ps ) -> A. x ( ph -> th ) ) ) $=
    ( wal wi wa wn hbntg pm2.21 alimi syl6 adantr ax-1 imim2i adantl jad ) ACEF
    GEFZBDEFZGZHCBADGZEFZSCIZUCGUASUDAIZEFUCACEJUEUBEADKLMNUABUCGSTUCBDUBEDAOLP
    QR $.

  $( A more general and closed form of ~ hbal .  (Contributed by Scott Fenton,
     13-Dec-2010.) $)
  hbaltg $p |- ( A. x ( ph -> A. y ps ) -> ( A. x ph -> A. y A. x ps ) ) $=
    ( wal wi alim ax-7 syl6 ) ABDEZFCEACEJCEBCEDEAJCGBCDHI $.

  ${
    hbg.1 $e |- ( ph -> A. x ps ) $.
    $( A more general form of ~ hbn .  (Contributed by Scott Fenton,
       13-Dec-2010.) $)
    hbng $p |- ( -. ps -> A. x -. ph ) $=
      ( wal wi wn hbntg mpg ) ABCEFBGAGCEFCABCHDI $.

    ${
      hbg.2 $e |- ( ch -> A. x th ) $.
      $( A more general form of ~ hbim .  (Contributed by Scott Fenton,
         13-Dec-2010.) $)
      hbimg $p |- ( ( ps -> ch ) -> A. x ( ph -> th ) ) $=
        ( wal wi ax-gen hbimtg mp2an ) ABEHIZEHCDEHIBCIADIEHIMEFJGACBDEKL $.
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The Predecessor Class
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Pred $.
  $( The predecessors symbol. $)
  cpred $a class Pred ( R , A , X ) $.

  $( Define the predecessor class of a relationship.  This is the class of all
     elements ` y ` of ` A ` such that ` y R X ` (see ~ elpred ) .
     (Contributed by Scott Fenton, 29-Jan-2011.) $)
  df-pred $a |- Pred ( R , A , X ) = ( A i^i ( `' R " { X } ) ) $.

  $( Equality theorem for the predecessor class.  (Contributed by Scott Fenton,
     13-Jun-2018.) $)
  predeq123 $p |- ( ( R = S /\ A = B /\ X = Y ) ->
                    Pred ( R , A , X ) = Pred ( S , B , Y ) ) $=
    ( wceq w3a ccnv csn cima cin cpred simp2 3ad2ant1 3ad2ant3 imaeq12d df-pred
    cnveq sneq ineq12d 3eqtr4g ) CDGZABGZEFGZHZACIZEJZKZLBDIZFJZKZLACEMBDFMUFAB
    UIULUCUDUENUFUGUJUHUKUCUDUGUJGUECDSOUEUCUHUKGUDEFTPQUAACERBDFRUB $.


  $( Equality theorem for the predecessor class.  (Contributed by Scott Fenton,
     2-Feb-2011.) $)
  predeq1 $p |- ( R = S -> Pred ( R , A , X ) = Pred ( S , A , X ) ) $=
    ( wceq cpred eqid predeq123 mp3an23 ) BCEAAEDDEABDFACDFEAGDGAABCDDHI $.

  $( Equality theorem for the predecessor class.  (Contributed by Scott Fenton,
     2-Feb-2011.) $)
  predeq2 $p |- ( A = B -> Pred ( R , A , X ) = Pred ( R , B , X ) ) $=
    ( wceq cpred eqid predeq123 mp3an13 ) CCEABEDDEACDFBCDFECGDGABCCDDHI $.

  $( Equality theorem for the predecessor class.  (Contributed by Scott Fenton,
     2-Feb-2011.) $)
  predeq3 $p |- ( X = Y -> Pred ( R , A , X ) = Pred ( R , A , Y ) ) $=
    ( wceq cpred eqid predeq123 mp3an12 ) BBEAAECDEABCFABDFEBGAGAABBCDHI $.


  ${
    nfpred.1 $e |- F/_ x R $.
    nfpred.2 $e |- F/_ x A $.
    nfpred.3 $e |- F/_ x X $.
    $( Bound-variable hypothesis builder for the predecessor class.
       (Contributed by Scott Fenton, 9-Jun-2018.) $)
    nfpred $p |- F/_ x Pred ( R , A , X ) $=
      ( cpred ccnv csn cima cin df-pred nfcnv nfsn nfima nfin nfcxfr ) ABCDHBCI
      ZDJZKZLBCDMABUAFASTACENADGOPQR $.
  $}

  $( If ` A ` is a subset of ` B ` , then their predecessor classes are also
     subsets.  (Contributed by Scott Fenton, 2-Feb-2011.) $)
  predpredss $p |- ( A C_ B -> Pred ( R , A , X ) C_ Pred ( R , B , X ) ) $=
    ( wss ccnv csn cima cin cpred ssrin df-pred 3sstr4g ) ABEACFDGHZIBNIACDJBCD
    JABNKACDLBCDLM $.

  $( The predecessor class of ` A ` is a subset of ` A ` (Contributed by Scott
     Fenton, 2-Feb-2011.) $)
  predss $p |- Pred ( R , A , X ) C_ A $=
    ( cpred ccnv csn cima cin df-pred inss1 eqsstri ) ABCDABECFGZHAABCIALJK $.

  $( Another subset/predecessor class relationship.  (Contributed by Scott
     Fenton, 6-Feb-2011.) $)
  sspred $p |- ( ( B C_ A /\ Pred ( R , A , X ) C_ B ) ->
                 Pred ( R , A , X ) = Pred ( R , B , X ) ) $=
    ( wss cin wceq ccnv csn cima cpred sseqin2 df-pred sseq1i df-ss in32 eqeq1i
    3bitri wa ineq1 eqeq1d biimpa eqeq12i biimpri eqcoms syl syl2anb ) BAEABFZB
    GZUHCHDIJZFZAUJFZGZACDKZBCDKZGZUNBEZBALUQULBEULBFZULGUMUNULBACDMZNULBOURUKU
    LAUJBPQRUIUMSBUJFZULGZUPUIUMVAUIUKUTULUHBUJTUAUBUPULUTUPULUTGUNULUOUTUSBCDM
    UCUDUEUFUG $.

  ${
    $d R y $.  $d X y $.
    dfpred2.1 $e |- X e. _V $.
    $( An alternate definition of predecessor class when ` X ` is a set.
       (Contributed by Scott Fenton, 8-Feb-2011.) $)
    dfpred2 $p |- Pred ( R , A , X ) = ( A i^i { y | y R X } ) $=
      ( cpred ccnv csn cima cin cv wbr cab df-pred cvv wcel iniseg ax-mp ineq2i
      wceq eqtri ) BCDFBCGDHIZJBAKDCLAMZJBCDNUBUCBDOPUBUCTEACDOQRSUA $.

    $d A y $.
    $( An alternate definition of predecessor class when ` X ` is a set.
       (Contributed by Scott Fenton, 13-Jun-2018.) $)
    dfpred3 $p |- Pred ( R , A , X ) = { y e. A | y R X } $=
      ( cpred cv wbr cab cin crab dfpred2 incom eqtri dfrab2 eqtr4i ) BCDFZAGDC
      HZAIZBJZRABKQBSJTABCDELBSMNRABOP $.

  $}

  ${
    $d R x y $.  $d A x y $.  $d X x y $.
    $( An alternate definition of predecessor class when ` X ` is a set.
       (Contributed by Scott Fenton, 13-Jun-2018.) $)
    dfpred3g $p |- ( X e. V -> Pred ( R , A , X ) = { y e. A | y R X } ) $=
      ( vx cpred wbr crab wceq predeq3 breq2 rabbidv eqeq12d vex dfpred3 vtoclg
      cv ) BCFRZGZARZSCHZABIZJBCEGZUAECHZABIZJFEDSEJZTUDUCUFBCSEKUGUBUEABSEUACL
      MNABCSFOPQ $.
  $}

  ${
    elpredim.1 $e |- X e. _V $.
    $( Membership in a predecessor class - implicative version.  (Contributed
       by Scott Fenton, 9-May-2012.) $)
    elpredim $p |- ( Y e. Pred ( R , A , X ) -> Y R X ) $=
      ( cpred wcel ccnv csn cima wa wbr df-pred elin2 cop cvv elimasng opelcnvg
      wb bitrd mpan ibi df-br sylibr adantl sylbi ) DABCFZGDAGZDBHZCIJZGZKDCBLZ
      DAUJUGABCMNUKULUHUKDCOBGZULUKUMCPGZUKUKUMSEUNUKKUKCDOUIGUMUICDPUJQCDPUJBR
      TUAUBDCBUCUDUEUF $.
  $}

  ${
    elpred.1 $e |- Y e. _V $.
    $( Membership in a predecessor class.  (Contributed by Scott Fenton,
       4-Feb-2011.) $)
    elpred $p |- ( X e. D -> ( Y e. Pred ( R , A , X ) <->
                                ( Y e. A /\ Y R X ) ) ) $=
      ( cpred wcel ccnv csn cima wa wbr df-pred elin2 eliniseg anbi2d syl5bb )
      EACDGZHEAHZECIDJKZHZLDBHZTEDCMZLEAUASACDNOUCUBUDTCDEBFPQR $.
  $}

  $( Membership in a predecessor class.  (Contributed by Scott Fenton,
     17-Apr-2011.) $)
  elpredg $p |- ( ( X e. B /\ Y e. A ) ->
                  ( Y e. Pred ( R , A , X ) <-> Y R X ) ) $=
    ( wcel wa cpred ccnv csn cima wbr wb df-pred elin2 baib adantl cop elimasng
    df-br syl6bbr brcnvg 3bitrd ) DBFZEAFZGZEACDHZFZECIZDJKZFZDEUILZEDCLUEUHUKM
    UDUHUEUKEAUJUGACDNOPQUFUKDERUIFULUIDEBASDEUITUADEBACUBUC $.

  ${
    $d A y $.  $d F y $.  $d G y $.  $d X y $.  $d R y $.
    predreseq.1 $e |- X e. _V $.
    $( Equality of restriction to predecessor classes.  (Contributed by Scott
       Fenton, 8-Feb-2011.) $)
    predreseq $p |- ( ( F Fn A /\ G Fn A ) ->
                       ( ( F |` Pred ( R , A , X ) ) =
                         ( G |` Pred ( R , A , X ) ) <->
                         A. y e. A ( y R X -> ( F ` y ) = ( G ` y ) ) ) ) $=
      ( wfn wa cres wceq cfv wral wi wb wcel wal df-ral cvv albii cpred wbr wss
      predss fvreseq mpan2 vex elpred ax-mp imbi1i impexp 3bitri bitr4i syl6bb
      cv ) DBHEBHIZDBCFUAZJEUQJKZAUOZDLUSELKZAUQMZUSFCUBZUTNZABMZUPUQBUCURVAOBC
      FUDABUQDEUEUFVAUSBPZVCNZAQZVDVAUSUQPZUTNZAQVEVBIZUTNZAQVGUTAUQRVIVKAVHVJU
      TFSPVHVJOGBSCFUSAUGUHUIUJTVKVFAVEVBUTUKTULVCABRUMUN $.
  $}

  ${
    predasetex.1 $e |- A e. _V $.
    $( The predecessor class exists when ` A ` does.  (Contributed by Scott
       Fenton, 8-Feb-2011.) $)
    predasetex $p |- Pred ( R , A , X ) e. _V $=
      ( cpred ccnv csn cima cin cvv df-pred inex1 eqeltri ) ABCEABFCGHZIJABCKAN
      DLM $.
  $}

  ${
    $d R x z $.  $d R y z $.  $d A x z $.  $d A y z $.
    $( Change the bound variable in the statement stating that ` R ` is
       set-like.  (Contributed by Scott Fenton, 2-Feb-2011.) $)
    cbvsetlike $p |- ( A. x e. A Pred ( R , A , x ) e. _V <->
                        A. y e. A Pred ( R , A , y ) e. _V ) $=
      ( vz cv cpred cvv wcel wral weq predeq3 eleq1d cbvralv bitr4i ) CDAFZGZHI
      ZACJCDEFZGZHIZECJCDBFZGZHIZBCJRUAAECAEKQTHCDPSLMNUDUABECBEKUCTHCDUBSLMNO
      $.
  $}

  ${
    $d x y A $.  $d x y R $.
    $( Alternate definition of well-founded relation.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    dffr4 $p |- ( R Fr A <->
                   A. x ( ( x C_ A /\ x =/= (/) )
                          -> E. y e. x Pred ( R , x , y ) = (/) ) ) $=
      ( wfr cv wss c0 wne wa ccnv csn cima cin wceq wrex wi wal cpred dffr3
      df-pred eqeq1i rexbii imbi2i albii bitr4i ) CDEAFZCGUGHIJZUGDKBFZLMNZHOZB
      UGPZQZARUHUGDUISZHOZBUGPZQZARABCDTUQUMAUPULUHUOUKBUGUNUJHUGDUIUAUBUCUDUEU
      F $.
  $}

  ${
    $( Membership in the predecessor class implies membership in the base
       class.  (Contributed by Scott Fenton, 11-Feb-2011.) $)
    predel $p |- ( Y e. Pred ( R , A , X ) -> Y e. A ) $=
      ( wcel ccnv csn cima cin cpred elin simplbi df-pred eleq2s ) DAEZDABFCGHZ
      IZABCJDQEODPEDAPKLABCMN $.
  $}

  ${
    $d R z $.  $d A z $.  $d X z $.  $d Y z $.
    $( Property of the precessor class for partial orderings.  (Contributed by
       Scott Fenton, 28-Apr-2012.) $)
    predpo $p |- ( ( R Po A /\ X e. A ) ->
                   ( Y e. Pred ( R , A , X ) ->
                     Pred ( R , A , Y ) C_ Pred ( R , A , X ) ) ) $=
      ( vz wpo wcel wa cpred wss predel w3a cv wbr wi wb elpredg adantll elpred
      ex potr 3exp2 com24 imp31 com13 com14 sylbid com23 imdistand vex 3ad2ant3
      3imp adantl 3ad2ant1 3imtr4d ssrdv 3exp mpdi ) ABFZCAGZHZDABCIZGZDAGZABDI
      ZVBJZABCDKVAVCVDVFVAVCVDLZEVEVBVGEMZAGZVHDBNZHZVIVHCBNZHZVHVEGZVHVBGZVGVI
      VJVLVAVCVDVIVJVLOOZVAVDVCVPVAVDVCVPOVAVDHZVCDCBNZVPUTVDVCVRPUSAABCDQRVJVR
      VIVQVLVJVRVIVQVLOOVQVIVJVRHZVLUSUTVDVIVSVLOZOUSVIVDUTVTUSVIVDUTVTAVHDCBUA
      UBUCUDUETUFUGTUHULUIVDVAVNVKPVCAABDVHEUJZSUKVAVCVOVMPZVDUTWBUSAABCVHWASUM
      UNUOUPUQUR $.
  $}

  $( Property of the predecessor class for strict orderings.  (Contributed by
     Scott Fenton, 11-Feb-2011.) $)
  predso $p |- ( ( R Or A /\ X e. A ) ->
                  ( Y e. Pred ( R , A , X ) ->
                    Pred ( R , A , Y ) C_ Pred ( R , A , X ) ) ) $=
    ( wor wpo wcel cpred wss wi sopo predpo sylan ) ABEABFCAGDABCHZGABDHNIJABKA
    BCDLM $.

  ${
    $d x A $.  $d x R $.  $d x X $.  $d x Y $.
    $( Closed form of ~ elpredim .  (Contributed by Scott Fenton,
       13-Apr-2011.)  (Revised by NM, 5-Apr-2016.) $)
    predbrg $p |- ( ( X e. V /\ Y e. Pred ( R , A , X ) ) -> Y R X ) $=
      ( vx wcel cpred wbr cv wi wceq predeq3 eleq2d imbi12d vex elpredim vtoclg
      breq2 imp ) DCGEABDHZGZEDBIZEABFJZHZGZEUDBIZKUBUCKFDCUDDLZUFUBUGUCUHUEUAE
      ABUDDMNUDDEBSOABUDEFPQRT $.
  $}

  ${
    $d R x $.  $d A x $.  $d X x $.
    $( If ` R ` is set-like in ` A ` , then all predecessors classes of
       elements of ` A ` exist.  (Contributed by Scott Fenton, 20-Feb-2011.)
       (Revised by Mario Carneiro, 26-Jun-2015.) $)
    setlikespec $p |- ( ( X e. A /\ R Se A ) -> Pred ( R , A , X ) e. _V ) $=
      ( vx wcel wse wa cv wbr cpred cvv cab wb vex elpred adantr abbi2dv df-rab
      crab syl6reqr seex ancoms eqeltrrd ) CAEZABFZGZDHZCBIZDASZABCJZKUFUJUGAEU
      HGZDLUIUFUKDUJUDUGUJEUKMUEAABCUGDNOPQUHDARTUEUDUIKEDACBUAUBUC $.
  $}

  $( Idempotent law for the predecessor class.  (Contributed by Scott Fenton,
     29-Mar-2011.) $)
  predidm $p |- Pred ( R , Pred ( R , A , X ) , X ) = Pred ( R , A , X ) $=
    ( cpred ccnv csn cima cin df-pred inidm ineq2i eqtr4i inass ineq1i ) ABCDZB
    CDOBECFGZHZOOBCIOAPHZPHZQOAPPHZHZSORUAABCIZTPAPJKLAPPMLORPUBNLL $.

  $( Intersection law for predecessor classes.  (Contributed by Scott Fenton,
     29-Mar-2011.) $)
  predin $p |- Pred ( R , ( A i^i B ) , X ) =
               ( Pred ( R , A , X ) i^i Pred ( R , B , X ) ) $=
    ( cin ccnv csn cima cpred inindir df-pred ineq12i 3eqtr4i ) ABEZCFDGHZEAOEZ
    BOEZENCDIACDIZBCDIZEABOJNCDKRPSQACDKBCDKLM $.

  $( Union law for predecessor classes.  (Contributed by Scott Fenton,
     29-Mar-2011.) $)
  predun $p |- Pred ( R , ( A u. B ) , X ) =
               ( Pred ( R , A , X ) u. Pred ( R , B , X ) ) $=
    ( cun ccnv csn cima cin cpred indir df-pred uneq12i 3eqtr4i ) ABEZCFDGHZIAP
    IZBPIZEOCDJACDJZBCDJZEABPKOCDLSQTRACDLBCDLMN $.

  $( Difference law for predecessor classes.  (Contributed by Scott Fenton,
     14-Apr-2011.) $)
  preddif $p |- Pred ( R , ( A \ B ) , X ) =
                  ( Pred ( R , A , X ) \ Pred ( R , B , X ) ) $=
    ( cdif ccnv csn cima cin cpred indifdir df-pred difeq12i 3eqtr4i ) ABEZCFDG
    HZIAPIZBPIZEOCDJACDJZBCDJZEABPKOCDLSQTRACDLBCDLMN $.

  ${
    $d X y $.  $d B y $.
    $( The predecessor under the epsilon relationship is equivalent to an
       intersection.  (Contributed by Scott Fenton, 27-Mar-2011.)  (Proof
       shortened by Andrew Salmon, 27-Aug-2011.) $)
    predep $p |- ( X e. B -> Pred ( _E , A , X ) = ( A i^i X ) ) $=
      ( vy wcel cep cpred ccnv csn cima cin df-pred cv wbr cab wrel wceq relcnv
      cvv syl5eq relimasn ax-mp wb vex brcnvg mpan2 epelg bitrd abbi1dv ineq2d
      ) CBEZAFCGAFHZCIJZKACKAFCLUKUMCAUKUMCDMZULNZDOZCULPUMUPQFRDCULUAUBUKUODCU
      KUOUNCFNZUNCEUKUNSEUOUQUCDUDCUNBSFUEUFUNCBUGUHUITUJT $.
  $}

  $( For an ordinal, the predecessor under ` _E ` and ` On ` is an identity
     relationship.  (Contributed by Scott Fenton, 27-Mar-2011.) $)
  predon $p |- ( A e. On -> Pred ( _E , On , A ) = A ) $=
    ( con0 wcel cep cpred cin predep wss wceq onss sseqin2 sylib eqtrd ) ABCZBD
    AEBAFZABBAGNABHOAIAJABKLM $.

  $( The epsilon relationship is set-like.  (Contributed by Scott Fenton,
     27-Mar-2011.) $)
  epsetlike $p |- A. x e. A Pred ( _E , A , x ) e. _V $=
    ( cep cv cpred cvv wcel cin predep incom syl6eq inex1g eqeltrd rgen ) BCADZ
    EZFGABOBGZPOBHZFQPBOHRBBOIBOJKOBBLMN $.

  ${
    $d A x $.  $d B x $.
    $( If ` R ` is set-like over ` A ` , then it is set-like over any subclass
       of ` A ` .  (Contributed by Scott Fenton, 28-Mar-2011.) $)
    setlikess $p |- ( ( A C_ B /\ A. x e. B Pred ( R , B , x ) e. _V ) ->
                       A. x e. A Pred ( R , A , x ) e. _V ) $=
      ( wss cv cpred cvv wcel wral ssralv predpredss ssexg syl ralimdv syld imp
      wi ex ) BCEZCDAFZGZHIZACJZBDUAGZHIZABJZTUDUCABJUGUCABCKTUCUFABTUEUBEZUCUF
      RBCDUALUHUCUFUEUBHMSNOPQ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d R x y z $.  $d X y $.
    $( A property of classes that are downward closed under predecessor.
       (Contributed by Scott Fenton, 13-Apr-2011.) $)
    preddowncl $p |- ( ( B C_ A /\ A. x e. B Pred ( R , A , x ) C_ B ) ->
                        ( X e. B ->
                          Pred ( R , B , X ) = Pred ( R , A , X ) ) ) $=
      ( vy vz wss cv cpred wral wa wcel wceq eleq1 predeq3 eqeq12d imbi2d vex
      wi imbi12d predpredss ad2antrr wbr weq sseq1d rspccva sseld elpredim jcad
      a1i wb elpred adantl mpbird ssrdv adantll eqssd ex vtoclg pm2.43b ) CBHZB
      DAIZJZCHZACKZLZECMZCDEJZBDEJZNZVGFIZCMZCDVLJZBDVLJZNZTZTVGVHVKTZTFECVLENZ
      VQVRVGVSVMVHVPVKVLECOVSVNVIVOVJCDVLEPBDVLEPQUARVGVMVPVGVMLVNVOVBVNVOHVFVM
      CBDVLUBUCVFVMVOVNHVBVFVMLZGVOVNVTGIZVOMZWAVNMZTZWBWACMZWAVLDUDZLZTZVTWBWE
      WFVTVOCWAVEVOCHAVLCAFUEVDVOCBDVCVLPUFUGUHWBWFTVTBDVLWAFSUIUKUJVMWDWHULVFV
      MWCWGWBCCDVLWAGSUMRUNUOUPUQURUSUTVA $.
  $}

  $( Given a partial ordering, ` X ` is not a member of its predecessor class.
     (Contributed by Scott Fenton, 17-Apr-2011.) $)
  predpoirr $p |- ( R Po A -> -. X e. Pred ( R , A , X ) ) $=
    ( wpo wcel cpred wn wa poirr wb elpredg anidms notbid syl5ibr exp3a pm2.43b
    wbr predel con3i pm2.61d1 ) ABDZCAEZCABCFEZGZUAUBUDUBUAUBUDUAUBHUDUBCCBQZGA
    CBIUBUCUEUBUCUEJAABCCKLMNOPUCUBABCCRST $.

  $( Given a well-founded relationship, ` X ` is not a member of its
     predecessor class.  (Contributed by Scott Fenton, 22-Apr-2011.) $)
  predfrirr $p |- ( R Fr A -> -. X e. Pred ( R , A , X ) ) $=
    ( wfr wcel cpred wn wa frirr wb elpredg anidms notbid syl5ibr exp3a pm2.43b
    wbr predel con3i pm2.61d1 ) ABDZCAEZCABCFEZGZUAUBUDUBUAUBUDUAUBHUDUBCCBQZGA
    CBIUBUCUEUBUCUEJAABCCKLMNOPUCUBABCCRST $.

  $( The predecessor class over ` (/) ` is always ` (/) ` (Contributed by Scott
     Fenton, 16-Apr-2011.) $)
  pred0 $p |- Pred ( R , (/) , X ) = (/) $=
    ( c0 cpred ccnv csn cima cin df-pred incom in0 3eqtri ) CABDCAEBFGZHMCHCCAB
    ICMJMKL $.

  ${
    $d N x $.  $d M x $.
    $( The value of the predecessor class over an upper integer set.
       (Contributed by Scott Fenton, 16-May-2014.) $)
    preduz $p |- ( N e. ( ZZ>= ` M ) -> Pred ( < , ( ZZ>= ` M ) , N ) = ( M ...
        ( N - 1 ) ) ) $=
      ( vx cuz cfv wcel clt cpred c1 cmin co cz wa cle wbr wb eluzelz syl bitrd
      anass cfz cv vex elpred zltlem1 syl2anr pm5.32da eluzel2 eluz1 anbi1d jca
      peano2zm biantrurd elfz2 df-3an anbi1i anbi2i bitr4i 3bitri syl6bbr eqrdv
      w3a ) BADEZFZCVCGBHZABIJKZUAKZVDCUBZVEFZALFZVFLFZMZVHLFZAVHNOZMZVHVFNOZMZ
      MZVHVGFZVDVIVQVRVDVIVHVCFZVHBGOZMZVQVCVCGBVHCUCUDVDWBVTVPMVQVDVTWAVPVTVMB
      LFZWAVPPVDAVHQABQZVHBUEUFUGVDVTVOVPVDVJVTVOPABUHZAVHUIRUJSSVDVLVQVDVJVKWE
      VDWCVKWDBULRUKUMSVSVJVKVMVBZVNVPMZMVLVMMZWGMZVRVHAVFUNWFWHWGVJVKVMUOUPWIV
      LVMWGMZMVRVLVMWGTVQWJVLVMVNVPTUQURUSUTVA $.
  $}

  $( The value of the predecessor class over the naturals.  (Contributed by
     Scott Fenton, 6-Aug-2013.) $)
  prednn $p |- ( N e. NN -> Pred ( < , NN , N ) = ( 1 ... ( N - 1 ) ) ) $=
    ( cn wcel clt cpred c1 cuz cfv cmin co cfz wceq predeq2 ax-mp elnnuz preduz
    nnuz sylbi syl5eq ) ABCZBDAEZFGHZDAEZFAFIJKJZBUBLUAUCLQBUBDAMNTAUBCUCUDLAOF
    APRS $.

  $( The value of the predecessor class over ` NN0 ` .  (Contributed by Scott
     Fenton, 9-May-2014.) $)
  prednn0 $p |- ( N e. NN0 -> Pred ( < , NN0 , N ) = ( 0 ... ( N - 1 ) ) ) $=
    ( cn0 clt cpred cc0 c1 cmin co cfz wceq cuz wcel nn0uz predeq2 ax-mp preduz
    cfv syl5eq eleq2s ) BCADZEAFGHIHZJAEKQZBAUBLTUBCADZUABUBJTUCJMBUBCANOEAPRMS
    $.

  ${
    $d K x $.  $d M x $.  $d N x $.  $d V x $.
    $( Calculate the predecessor of an integer under a finite set of integers.
       (Contributed by Scott Fenton, 8-Aug-2013.)  (Proof shortened by Mario
       Carneiro, 3-May-2015.) $)
    predfz $p |- ( K e. ( M ... N ) ->
       Pred ( < , ( M ... N ) , K ) = ( M ... ( K - 1 ) ) ) $=
      ( vx cfz co wcel clt cpred c1 wbr wa cz wb elfzelz syl2anr cuz cfv syl cc
      cv cle zltlem1 elfzuz peano2zm elfz5 bitr4d pm5.32da vex elpred wss caddc
      cmin elfzuz3 wceq zcnd ax-1cn npcan sylancl fveq2d eleqtrrd syl2anc fzss2
      peano2uzr sseld pm4.71rd 3bitr4d eqrdv ) ABCEFZGZDVIHAIZBAJUMFZEFZVJDUAZV
      IGZVNAHKZLVOVNVMGZLVNVKGVQVJVOVPVQVJVOLVPVNVLUBKZVQVOVNMGAMGZVPVRNVJVNBCO
      ABCOZVNAUCPVOVNBQRGVLMGZVQVRNVJVNBCUDVJVSWAVTAUESZVNBVLUFPUGUHVIVIHAVNDUI
      UJVJVQVOVJVMVIVNVJCVLQRGZVMVIUKVJWACVLJULFZQRZGWCWBVJCAQRWEABCUNVJWDAQVJA
      TGJTGWDAUOVJAVTUPUQAJURUSUTVAVLCVDVBVLBCVCSVEVFVGVH $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              (Trans)finite Recursion Theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d ph y z $.  $d x y z $.
    $( A closed form of ~ tfis .  (Contributed by Scott Fenton, 8-Jun-2011.) $)
    tfisg $p |- ( A. x e. On ( A. y e. x [. y / x ]. ph -> ph ) ->
                 A. x e. On ph ) $=
      ( vz cv wsbc wral wi con0 crab wceq wss wcel ssrab2 wa dfss3 nfcv elrabsf
      simprbi nfsbc1v ralimi sylbi nfral nfim raleq sbceq1a imbi12d rspc impcom
      syl5 simpr jctild syl6ibr ralrimiva tfi sylancr eqcomd rabid2 sylib ) ABC
      EZFZCBEZGZAHZBIGZIABIJZKABIGVEVFIVEVFILDEZVFLZVGVFMZHZDIGVFIKABINVEVJDIVE
      VGIMZOZVHVKABVGFZOVIVLVHVMVKVHVACVGGZVLVMVHUTVFMZCVGGVNCVGVFPVOVACVGVOUTI
      MVAABUTIBIQZRSUAUBVKVEVNVMHZVDVQBVGIVNVMBVABCVGBVGQABUTTUCABVGTUDVBVGKVCV
      NAVMVACVBVGUEABVGUFUGUHUIUJVEVKUKULABVGIVPRUMUNDVFUOUPUQABIURUS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y B $.  $d x y R $.
    $( All nonempty (possibly proper) subclasses of ` A ` , which has a
       well-founded relation ` R ` , have ` R `-minimal elements.  Proposition
       6.26 of [TakeutiZaring] p. 31.  (Contributed by Scott Fenton,
       29-Jan-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    tz6.26 $p |- ( ( ( R We A /\ R Se A ) /\ ( B C_ A /\ B =/= (/) ) ) ->
                    E. y e. B Pred ( R , B , y ) = (/) ) $=
      ( vx wwe wse wa wss c0 wne cv wbr wn wral wrex cpred wceq wreu wereu2 syl
      reurex crab rabeq0 cab cin dfrab3 vex dfpred2 eqtr4i eqeq1i bitr3i rexbii
      sylib ) BDFBDGHCBICJKHHZELALZDMZNECOZACPZCDUPQZJRZACPUOURACSUSAEBCDTURACU
      BUAURVAACURUQECUCZJRVAUQECUDVBUTJVBCUQEUEUFUTUQECUGECDUPAUHUIUJUKULUMUN
      $.
  $}

  ${
    $d A x $.  $d A y $.  $d B x $.  $d B y $.  $d R x $.  $d R y $.
    tz6.26i.1 $e |- R We A $.
    tz6.26i.2 $e |- R Se A $.
    $( All nonempty (possibly proper) subclasses of ` A ` , which has a
       well-founded relation ` R ` , have ` R `-minimal elements.  Proposition
       6.26 of [TakeutiZaring] p. 31.  (Contributed by Scott Fenton,
       14-Apr-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    tz6.26i $p |- ( ( B C_ A /\ B =/= (/) ) ->
                    E. y e. B Pred ( R , B , y ) = (/) ) $=
      ( wwe wse wss c0 wne wa cv cpred wceq wrex tz6.26 mpanl12 ) BDGBDHCBICJKL
      CDAMNJOACPEFABCDQR $.
  $}

  ${
    $d A x $.  $d A y $.  $d B x $.  $d B y $.  $d R x $.  $d R y $.
    $( The Principle of Well-Founded Induction.  Theorem 6.27 of
       [TakeutiZaring] p. 32.  This principle states that if ` B ` is a
       subclass of a well-ordered class ` A ` with the property that every
       element of ` B ` whose inital segment is included in ` A ` is itself
       equal to ` A ` .  (Contributed by Scott Fenton, 29-Jan-2011.)  (Revised
       by Mario Carneiro, 26-Jun-2015.) $)
    wfi $p |- ( ( ( R We A /\ R Se A ) /\
                    ( B C_ A /\
                      A. y e. A ( Pred ( R , A , y ) C_ B -> y e. B ) ) )
                  -> A = B ) $=
      ( wa wss cpred wcel wn cdif c0 ssdif0 wceq anbi1i cin df-pred incom eqtri
      wrex bitri wwe wse cv wi wral wne necon3bbii difss eldif anass ancom ccnv
      tz6.26 csn cima indif2 difeq1i 3eqtr4i eqeq1i bitr4i anbi2i rexbii2 sylib
      3bitri rexanali ex mpani syl5bi con4d imp adantrl simprl eqssd ) BDUABDUB
      EZCBFZBDAUCZGZCFZVPCHZUDABUEZEEBCVNVTBCFZVOVNVTWAVNWAVTWAIBCJZKUFZVNVTIZW
      AWBKBCLUGVNWBBFZWCWDBCUHVNWEWCEZWDVNWFEWBDVPGZKMZAWBSZWDABWBDUMWIVRVSIZEZ
      ABSWDWHWKAWBBVPWBHZWHEVPBHZWJEZWHEWMWJWHEZEWMWKEWLWNWHVPBCUINWMWJWHUJWOWK
      WMWOWHWJEWKWJWHUKWHVRWJWHVQCJZKMVRWGWPKDULVPUNUOZWBOZWQBOZCJWGWPWQBCUPWGW
      BWQOWRWBDVPPWBWQQRVQWSCVQBWQOWSBDVPPBWQQRUQURUSVQCLUTNTVAVDVBVRVSABVETVCV
      FVGVHVIVJVKVNVOVTVLVM $.
  $}

  ${
    $d A x $.  $d A y $.  $d B x $.  $d B y $.  $d R x $.  $d R y $.
    wfi.1 $e |- R We A $.
    wfi.2 $e |- R Se A $.
    $( The Principle of Well-Founded Induction.  Theorem 6.27 of
       [TakeutiZaring] p. 32.  This principle states that if ` B ` is a
       subclass of a well-ordered class ` A ` with the property that every
       element of ` B ` whose inital segment is included in ` A ` is itself
       equal to ` A ` .  (Contributed by Scott Fenton, 29-Jan-2011.)  (Revised
       by Mario Carneiro, 26-Jun-2015.) $)
    wfii $p |- ( ( B C_ A /\
                    A. y e. A ( Pred ( R , A , y ) C_ B -> y e. B ) )
                  -> A = B ) $=
      ( wwe wse wss cv cpred wcel wi wral wa wceq wfi mpanl12 ) BDGBDHCBIBDAJZK
      CISCLMABNOBCPEFABCDQR $.
  $}

  ${
    $d A w x y $.  $d A z $.  $d ph w x $.  $d ph z $.  $d R w x y $.
    $d R z $.  $d w y z $.
    wfisg.1 $e |- ( y e. A ->
                       ( A. z e. Pred ( R , A , y ) [. z / y ]. ph -> ph ) ) $.
    $( Well-Founded Induction Schema.  If a property passes from all elements
       less than ` y ` of a well-founded class ` A ` to ` y ` itself (induction
       hypothesis), then the property holds for all elements of ` A ` .
       (Contributed by Scott Fenton, 11-Feb-2011.) $)
    wfisg $p |- ( ( R We A /\ R Se A ) -> A. y e. A ph ) $=
      ( vw wa wceq wral wss cv cpred wcel wi wsbc nfcv elrabsf nfsbc1v nfim wwe
      wse ssrab2 dfss3 simprbi ralimi sylbi nfral eleq1 predeq3 raleqdv sbceq1a
      crab nfv imbi12d chvar syl5 anc2li syl6ibr rgen wfi mpanr12 rabid2 sylib
      ) DEUADEUBHZDABDUMZIZABDJVEVFDKDEGLZMZVFKZVHVFNZOZGDJVGABDUCVLGDVHDNZVJVM
      ABVHPZHVKVMVJVNVJABCLZPZCVIJZVMVNVJVOVFNZCVIJVQCVIVFUDVRVPCVIVRVODNVPABVO
      DBDQZRUEUFUGBLZDNZVPCDEVTMZJZAOZOVMVQVNOZOBGVMWEBVMBUNVQVNBVPBCVIBVIQABVO
      SUHABVHSTTVTVHIZWAVMWDWEVTVHDUIWFWCVQAVNWFVPCWBVIDEVTVHUJUKABVHULUOUOFUPU
      QURABVHDVSRUSUTGDVFEVAVBABDVCVD $.
  $}

  ${
    $d A w y z $.  $d A x $.  $d ph w z $.  $d ph x $.  $d R w y z $.
    $d R x $.  $d x y $.
    wfis.1 $e |- R We A $.
    wfis.2 $e |- R Se A $.
    wfis.3 $e |- ( y e. A ->
                    ( A. z e. Pred ( R , A , y ) [. z / y ]. ph -> ph ) ) $.
    $( Well-Founded Induction Schema.  If all elements less than a given set
       ` x ` of the well-founded class ` A ` have a property (induction
       hypothesis), then all elements of ` A ` have that property.
       (Contributed by Scott Fenton, 29-Jan-2011.) $)
    wfis $p |- ( y e. A -> ph ) $=
      ( wwe wse wral wfisg mp2an rspec ) ABDDEIDEJABDKFGABCDEHLMN $.
  $}

  ${
    $d A x y $.  $d A z $.  $d ph x $.  $d ph z $.  $d R x y $.  $d R z $.
    $d y z $.
    wfis2fg.1 $e |- F/ y ps $.
    wfis2fg.2 $e |- ( y = z -> ( ph <-> ps ) ) $.
    wfis2fg.3 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Well-Founded Induction Schema, using implicit substitution.
       (Contributed by Scott Fenton, 11-Feb-2011.) $)
    wfis2fg $p |- ( ( R We A /\ R Se A ) -> A. y e. A ph ) $=
      ( cv wsbc cpred wral wcel wsb sbsbc sbie bitr3i ralbii syl5bi wfisg ) ACD
      EFACDJKZDEFCJZLZMBDUDMUCENAUBBDUDUBACDOBACDPABCDGHQRSITUA $.
  $}

  ${
    $d A x y $.  $d A z $.  $d ph x $.  $d ph z $.  $d R x y $.  $d R z $.
    $d y z $.
    wfis2f.1 $e |- R We A $.
    wfis2f.2 $e |- R Se A $.
    wfis2f.3 $e |- F/ y ps $.
    wfis2f.4 $e |- ( y = z -> ( ph <-> ps ) ) $.
    wfis2f.5 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Well Founded Induction schema, using implicit substitution.
       (Contributed by Scott Fenton, 29-Jan-2011.) $)
    wfis2f $p |- ( y e. A -> ph ) $=
      ( wwe wse wral wfis2fg mp2an rspec ) ACEEFLEFMACENGHABCDEFIJKOPQ $.
  $}

  ${
    $d A x y $.  $d A z $.  $d ph x $.  $d ph z $.  $d ps y $.  $d R x y $.
    $d R z $.  $d y z $.
    wfis2g.1 $e |- ( y = z -> ( ph <-> ps ) ) $.
    wfis2g.2 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Well-Founded Induction Schema, using implicit substitution.
       (Contributed by Scott Fenton, 11-Feb-2011.) $)
    wfis2g $p |- ( ( R We A /\ R Se A ) -> A. y e. A ph ) $=
      ( nfv wfis2fg ) ABCDEFBCIGHJ $.
  $}

  ${
    $d A x y $.  $d A z $.  $d ph x $.  $d ph z $.  $d ps y $.  $d R x y $.
    $d R z $.  $d y z $.
    wfis2.1 $e |- R We A $.
    wfis2.2 $e |- R Se A $.
    wfis2.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    wfis2.4 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Well Founded Induction schema, using implicit substitution.
       (Contributed by Scott Fenton, 29-Jan-2011.) $)
    wfis2 $p |- ( y e. A -> ph ) $=
      ( wwe wse wral wfis2g mp2an rspec ) ACEEFKEFLACEMGHABCDEFIJNOP $.
  $}

  ${
    $d A x y $.  $d A z $.  $d B y $.  $d ch y $.  $d ph x $.  $d ph z $.
    $d ps y $.  $d R x y $.  $d R z $.  $d y z $.
    wfis3.1 $e |- R We A $.
    wfis3.2 $e |- R Se A $.
    wfis3.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    wfis3.4 $e |- ( y = B -> ( ph <-> ch ) ) $.
    wfis3.5 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Well Founded Induction schema, using implicit substitution.
       (Contributed by Scott Fenton, 29-Jan-2011.) $)
    wfis3 $p |- ( B e. A -> ch ) $=
      ( wfis2 vtoclga ) ACDGFLABDEFHIJKMNO $.
  $}

  ${
    $d ch x $.  $d M x $.  $d M y $.  $d M z $.  $d N x $.  $d ph y $.
    $d ph z $.  $d ps x $.  $d x y $.  $d x z $.
    uzsinds.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    uzsinds.2 $e |- ( x = N -> ( ph <-> ch ) ) $.
    uzsinds.3 $e |- ( x e. ( ZZ>= ` M ) ->
      ( A. y e. ( M ... ( x - 1 ) ) ps -> ph ) ) $.
    $( Strong (or "total") induction principle over a set of upper integers.
       (Contributed by Scott Fenton, 16-May-2014.) $)
    uzsinds $p |- ( N e. ( ZZ>= ` M ) -> ch ) $=
      ( cuz cfv clt ltweuz cvv wcel wse fvex wral co exse ax-mp cv cpred c1 cfz
      cmin preduz raleqdv sylbid wfis3 ) ABCDEFKLZGMFNULOPULMQFKRULMOUAUBHIDUCZ
      ULPZBEULMUMUDZSBEFUMUEUGTUFTZSAUNBEUOUPFUMUHUIJUJUK $.
  $}

  ${
    $d ch x $.  $d N x $.  $d ph y $.  $d ph z $.  $d ps x $.  $d x y $.
    $d x z $.
    nnsinds.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    nnsinds.2 $e |- ( x = N -> ( ph <-> ch ) ) $.
    nnsinds.3 $e |- ( x e. NN ->
      ( A. y e. ( 1 ... ( x - 1 ) ) ps -> ph ) ) $.
    $( Strong (or "total") induction principle over the naturals.  (Contributed
       by Scott Fenton, 16-May-2014.) $)
    nnsinds $p |- ( N e. NN -> ch ) $=
      ( cn wcel c1 cuz cfv elnnuz cv cmin co cfz wral wi sylbir uzsinds sylbi )
      FJKFLMNZKCFOABCDELFGHDPZUEKUFJKBELUFLQRSRTAUAUFOIUBUCUD $.
  $}

  ${
    $d ch x $.  $d N x $.  $d ph y $.  $d ph z $.  $d ps x $.  $d x y $.
    $d x z $.
    nn0sinds.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    nn0sinds.2 $e |- ( x = N -> ( ph <-> ch ) ) $.
    nn0sinds.3 $e |- ( x e. NN0 ->
      ( A. y e. ( 0 ... ( x - 1 ) ) ps -> ph ) ) $.
    $( Strong (or "total") induction principle over the non-negative integers.
       (Contributed by Scott Fenton, 16-May-2014.) $)
    nn0sinds $p |- ( N e. NN0 -> ch ) $=
      ( cn0 wcel cc0 cuz cfv elnn0uz cv c1 cmin co cfz wi sylbir uzsinds sylbi
      wral ) FJKFLMNZKCFOABCDELFGHDPZUFKUGJKBELUGQRSTSUEAUAUGOIUBUCUD $.
  $}

  ${
    $d A x $.  $d ch x $.  $d ph y $.  $d ps x $.  $d x y $.
    omsinds.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    omsinds.2 $e |- ( x = A -> ( ph <-> ch ) ) $.
    omsinds.3 $e |- ( x e. om -> ( A. y e. x ps -> ph ) ) $.
    $( Strong (or "total") induction principle over the finite ordinals.
       (Contributed by Scott Fenton, 17-Jul-2015.) $)
    omsinds $p |- ( A e. om -> ch ) $=
      ( com cep con0 wss wwe omsson epweon wess mp2 epse wral cv wcel cpred cin
      predep wceq word wtr wi ordom ordtr trss dfss1 sylib eqtrd raleqdv sylbid
      mp2b wfis3 ) ABCDEJFKJLMLKNJKNOPJLKQRJSGHDUAZJUBZBEJKUTUCZTBEUTTAVABEVBUT
      VAVBJUTUDZUTJJUTUEVAUTJMZVCUTUFJUGJUHVAVDUIUJJUKJUTULURUTJUMUNUOUPIUQUS
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Transitive closure under a relationship
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c TrPred $.
  $( Define the transitive predecessor class as a class. $)
  ctrpred $a class TrPred ( R , A , X ) $.

  ${
    $d R a y $.  $d A a y $.  $d X a y $.
    $( Define the transitive predecessors of a class ` X ` under a relationship
       ` R ` and a class ` A ` .  This class can be thought of as the
       "smallest" class containing all elements of ` A ` that are linked to
       ` X ` by a chain of ` R ` relationships (see ~ trpredtr and
       ~ trpredmintr ).  Definition based off of Lemma 4.2 of Don Monk's notes
       for Advanced Set Theory, which can be found at
       ~ http://euclid.colorado.edu/~~monkd/settheory (check The Internet
       Archive for it now as Prof.  Monk appears to have rewritten his
       website).  (Contributed by Scott Fenton, 2-Feb-2011.) $)
    df-trpred $a |- TrPred ( R , A , X ) =
                        U. ran ( rec ( ( a e. _V |->
                                         U_ y e. a Pred ( R , A , y ) ) ,
                                       Pred ( R , A , X ) ) |` om ) $.
  $}

  ${
    $d R a i y $.  $d A a i y $.  $d X a i y $.
    $( A definition of the transitive predecessors of a class in terms of
       indexed union.  (Contributed by Scott Fenton, 28-Apr-2012.) $)
    dftrpred2 $p |- TrPred ( R , A , X ) =
        U_ i e. om ( ( rec ( ( a e. _V |-> U_ y e. a Pred ( R , A , y ) ) ,
                             Pred ( R , A , X ) ) |` om ) ` i ) $=
      ( ctrpred cvv cv cpred ciun cmpt crdg com cres crn cuni cfv df-trpred wfn
      wceq frfnom fniunfv ax-mp eqtr4i ) BCEGFHAFIBCAIJKLZBCEJZMNOZPQZDNDIUHRKZ
      ABCEFSUHNTUJUIUAUGUFUBDNUHUCUDUE $.
  $}

  ${
    $d R a y $.  $d S a y $.  $d A a y $.  $d B a y $.  $d X a y $.
    $d Y a y $.

    $( Equality theorem for transitive predecessors.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    trpredeq1 $p |- ( R = S -> TrPred ( R , A , X ) = TrPred ( S , A , X ) ) $=
      ( va vy wceq cvv cpred ciun cmpt crdg com cres crn cuni ctrpred df-trpred
      cv predeq1 iuneq2d mpteq2dv rdgeq12 syl2anc reseq1d rneqd unieqd 3eqtr4g
      ) BCGZEHFESZABFSZIZJZKZABDIZLZMNZOZPEHFUJACUKIZJZKZACDIZLZMNZOZPABDQACDQU
      IURVEUIUQVDUIUPVCMUIUNVAGUOVBGUPVCGUIEHUMUTUIFUJULUSABCUKTUAUBABCDTUOVBUN
      VAUCUDUEUFUGFABDERFACDERUH $.

    $( Equality theorem for transitive predecessors.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    trpredeq2 $p |- ( A = B -> TrPred ( R , A , X ) = TrPred ( R , B , X ) ) $=
      ( va vy wceq cvv cpred ciun cmpt crdg com cres crn cuni ctrpred df-trpred
      cv predeq2 iuneq2d mpteq2dv rdgeq12 reseq1d syl2anc rneqd unieqd 3eqtr4g
      wa ) ABGZEHFESZACFSZIZJZKZACDIZLZMNZOZPEHFUKBCULIZJZKZBCDIZLZMNZOZPACDQBC
      DQUJUSVFUJURVEUJUOVBGZUPVCGZURVEGUJEHUNVAUJFUKUMUTABCULTUAUBABCDTVGVHUIUQ
      VDMUPVCUOVBUCUDUEUFUGFACDERFBCDERUH $.

    $( Equality theorem for transitive predecessors.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    trpredeq3 $p |- ( X = Y -> TrPred ( R , A , X ) = TrPred ( R , A , Y ) ) $=
      ( va vy wceq cvv cpred ciun cmpt crdg com cres crn cuni ctrpred df-trpred
      cv predeq3 rdgeq2 syl reseq1d rneqd unieqd 3eqtr4g ) CDGZEHFESABFSIJKZABC
      IZLZMNZOZPUHABDIZLZMNZOZPABCQABDQUGULUPUGUKUOUGUJUNMUGUIUMGUJUNGABCDTUIUM
      UHUAUBUCUDUEFABCERFABDERUF $.
  $}

  ${
    trpredeq1d.1 $e |- ( ph -> R = S ) $.
    $( Equality deduction for transitive predecessors.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    trpredeq1d $p |- ( ph -> TrPred ( R , A , X ) = TrPred ( S , A , X ) ) $=
      ( wceq ctrpred trpredeq1 syl ) ACDGBCEHBDEHGFBCDEIJ $.
  $}

  ${
    trpredeq2d.1 $e |- ( ph -> A = B ) $.
    $( Equality deduction for transitive predecessors.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    trpredeq2d $p |- ( ph -> TrPred ( R , A , X ) = TrPred ( R , B , X ) ) $=
      ( wceq ctrpred trpredeq2 syl ) ABCGBDEHCDEHGFBCDEIJ $.
  $}

  ${
    trpredeq3d.1 $e |- ( ph -> X = Y ) $.
    $( Equality deduction for transitive predecessors.  (Contributed by Scott
       Fenton, 2-Feb-2011.) $)
    trpredeq3d $p |- ( ph -> TrPred ( R , A , X ) = TrPred ( R , A , Y ) ) $=
      ( wceq ctrpred trpredeq3 syl ) ADEGBCDHBCEHGFBCDEIJ $.
  $}

  ${
    $d R a y i $.  $d A a y i $.  $d X a y i $.  $d Y a y i $.
    $( A class is a transitive predecessor iff it is in some value of the
       underlying function.  This theorem is not really meant to be used
       directly: instead refer to ~ trpredpred and ~ trpredmintr .
       (Contributed by Scott Fenton, 28-Apr-2012.) $)
    eltrpred $p |- ( Y e. TrPred ( R , A , X ) <->
                    E. i e. om Y e. ( ( rec ( ( a e. _V |->
                                              U_ y e. a Pred ( R , A , y ) ) ,
                                        Pred ( R , A , X ) ) |` om ) ` i ) ) $=
      ( ctrpred wcel com cv cvv cpred ciun cmpt crdg cres cfv wrex dftrpred2
      eleq2i eliun bitri ) FBCEHZIFDJDKGLAGKBCAKMNOBCEMPJQRZNZIFUEIDJSUDUFFABCD
      EGTUADFJUEUBUC $.
  $}

  ${
    $d A a b d e j $.  $d A a d e y $.  $d B j $.  $d i j $.  $d j y $.
    $d R a b d e j $.  $d R y $.  $d X a d e j $.
    $( Technical lemma for transitive predecessors properties.  All values of
       the transitive predecessors' underlying function are subsets of the base
       set.  (Contributed by Scott Fenton, 28-Apr-2012.) $)
    trpredlem1 $p |- ( Pred ( R , A , X ) e. B ->
                      ( ( rec ( ( a e. _V |-> U_ y e. a Pred ( R , A , y ) ) ,
                                Pred ( R , A , X ) ) |` om ) ` i )
                       C_ A ) $=
      ( vj ve cv com wcel cpred cvv cfv wss c0 wceq syl6eqss nfcv nn0suc predss
      ciun cmpt crdg cres wi csuc wrex wo fr0g fveq2 sseq1d syl5ibr nfrdg nfres
      wa nfmpt1 nffv predeq3 cbviunv mpteq2i rdgeq1 reseq1 mp2b iuneq1 frsucmpt
      nfiun iunss a1i mprgbir wn frsucmptn adantl pm2.61dan adantr wb rexlimiva
      0ss mpbird a1d jaoi syl nfvres pm2.61i ) EJZKLZBDFMZCLZWFGNAGJZBDAJZMZUCZ
      UDZWHUEZKUFZOZBPZUGZWGWFQRZWFHJZUHZRZHKUIZUJWSHWFUAWTWSXDWIWRWTQWPOZBPWIX
      EWHBWHCWNUKBDFUBSWTWQXEBWFQWPULUMUNXDWRWIXCWRHKXAKLZXCUQWRXBWPOZBPZXFXHXC
      XFIXAWPOZBDIJZMZUCZNLZXHXFXMUQXGXLBGWHXAIWJXKUCZXLWPNGWHTZGXATZIGXIXKGXAW
      PGWOKGWHWNGNWMURXOUOGKTUPXPUSGXKTVHZWNGNXNUDZRWOXRWHUEZRWPXSKUFRGNWMXNAIW
      JWLXKBDWKXJUTVAVBWHWNXRVCWOXSKVDVEZIWJXIXKVFZVGXLBPXKBPZIXIIXIXKBVIYBXJXI
      LBDXJUBVJVKSXFXMVLZUQXGQBYCXGQRXFGWHXAXNXLWPXOXPXQXTYAVMVNBVSZSVOVPXCWRXH
      VQXFXCWQXGBWFXBWPULUMVNVTVRWAWBWCWGVLZWRWIYEWQQBWFKWOWDYDSWAWE $.

  $}

  ${
    $d R a y z $.  $d A a y z $.  $d X a y z $.
    $( Assuming it exists, the predecessor class is a subset of the transitive
       predecessors.  (Contributed by Scott Fenton, 18-Feb-2011.) $)
    trpredpred $p |- ( Pred ( R , A , X ) e. B ->
                      Pred ( R , A , X ) C_ TrPred ( R , A , X ) ) $=
      ( va vy vz cpred wcel cvv cv ciun cmpt crdg com cres crn wbr c0 syl mp2an
      cuni ctrpred wss wex cfv wceq fr0g wfn wb frfnom peano1 fnbrfvb sylib 0ex
      breq1 spcev elrng mpbird elssuni df-trpred syl6sseqr ) ACDHZBIZVCEJFEKACF
      KHLMZVCNOPZQZUBZACDUCVDVCVGIZVCVHUDVDVIGKZVCVFRZGUEZVDSVCVFRZVLVDSVFUFVCU
      GZVMVCBVEUHVFOUISOIVNVMUJVCVEUKULOSVCVFUMUAUNVKVMGSUOVJSVCVFUPUQTGVCVFBUR
      USVCVGUTTFACDEVAVB $.
  $}

  ${
    $d R a b i y z $.  $d A a b i y z $.  $d B i z $.  $d X a b i y z $.
    $( The transitive predecessors form a subset of the base class.
       (Contributed by Scott Fenton, 20-Feb-2011.) $)
    trpredss $p |- ( Pred ( R , A , X ) e. B ->
                    TrPred ( R , A , X ) C_ A ) $=
      ( vi va vy cpred wcel ctrpred com cv cvv ciun cmpt crdg cfv dftrpred2 wss
      cres wral trpredlem1 ralrimivw iunss sylibr syl5eqss ) ACDHZBIZACDJEKELFM
      GFLACGLHNOUGPKTQZNZAGACEDFRUHUIASZEKUAUJASUHUKEKGABCEDFUBUCEKUIAUDUEUF $.
  $}

  ${
    $d A a b f i j t x y $.  $d R a b f i j t x y $.  $d X a b f i j t x y $.
    $d Y a b f i j t y $.
    $( The transitive predecessors are transitive in ` R ` and ` A `
       (Contributed by Scott Fenton, 20-Feb-2011.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    trpredtr $p |- ( ( X e. A /\ R Se A ) ->
                    ( Y e. TrPred ( R , A , X ) ->
                      Pred ( R , A , Y ) C_ TrPred ( R , A , X ) ) ) $=
      ( vi va vy vt vf vj wcel cv cvv cpred ciun com wa wss syl wceq cfv simplr
      ctrpred cmpt crdg cres wrex wse eltrpred csuc peano2 simpr predeq3 sseq2d
      ssid rspcev ssiun sylancl wral setlikespec trpredlem1 sseld expcom adantl
      fvex wi syld ralrimiv ad2antrr iunexg sylancr nfcv cbviunv iuneq1 cbvmptv
      syl5eq rdgeq1 mp2b frsucmpt syl2anc sseqtr4d fveq2 dftrpred2 syl6sseqr ex
      reseq1 rexlimdva syl5bi ) DABCUCZKDELZFMGFLZABGLZNZOZUDZABCNZUEZPUFZUAZKZ
      EPUGCAKZABUHZQZABDNZWIRZGABECDFUIXCWTXEEPXCWJPKZQZWTXEXGWTQZWJUJZPKZXDXIW
      RUAZRZXEXHXFXJXCXFWTUBZWJUKSXHXDHWSABHLZNZOZXKXHWTXDXDRZXDXPRZXGWTULXDUOW
      TXQQXDXORZHWSUGXRXSXQHDWSXNDTXOXDXDABXNDUMUNUPHWSXOXDUQSURXHXFXPMKZXKXPTX
      MXHWSMKXOMKZHWSUSZXTWJWRVEXCYBXFWTXCYAHWSXCXNWSKXNAKZYAXCWSAXNXCWPMKWSARA
      BCUTGAMBECFVASVBXBYCYAVFXAYCXBYAABXNUTVCVDVGVHVIHWSXOMMVJVKIWPWJHILZXOOZX
      PWRMIWPVLIWJVLIXPVLWOIMYEUDZTWQYFWPUEZTWRYGPUFTFIMWNYEWKYDTWNHWKXOOYEGHWK
      WMXOABWLXNUMVMHWKYDXOVNVPVOWPWOYFVQWQYGPWFVRHYDWSXOVNVSVTWAXJXLQZXDJPJLZW
      RUAZOZWIYHXDYJRZJPUGXDYKRYLXLJXIPYIXITYJXKXDYIXIWRWBUNUPJPYJXDUQSGABJCFWC
      WDVTWEWGWH $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d X x y $.  $d B y $.  $d A x y a b c d i j k $.
    $d B i j k $.  $d R a b c d i j k $.  $d X a b c i j k $.
    $( The transitive predecessors form the smallest class transitive in ` R `
       and ` A ` .  That is, if ` B ` is another ` R ` , ` A ` transitive class
       containing ` Pred ( R , A , X ) ` , then ` TrPred ( R , A , X ) C_ B `
       (Contributed by Scott Fenton, 25-Apr-2012.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    trpredmintr $p |- ( ( ( X e. A /\ R Se A ) /\
                         ( A. y e. B Pred ( R , A , y ) C_ B /\
                           Pred ( R , A , X ) C_ B ) ) ->
                       TrPred ( R , A , X ) C_ B ) $=
      ( vi va vc vd wcel wa cv wss wral com cvv ciun cfv wi wceq vj wse ctrpred
      vk cpred cmpt crdg cres dftrpred2 c0 csuc fveq2 sseq1d imbi2d setlikespec
      fr0g syl adantr simprr eqsstrd fvex trpredlem1 sseld expcom syld ralrimiv
      adantl ad2antrr iunexg sylancr nfcv predeq3 cbviunv iuneq1 syl5eq cbvmptv
      eqid rdgeq1 reseq1 mp2b fveq1i eqeq2i sylbi frsucmpt sylan2 sseq1i anbi2i
      nfv nfra1 nfan ssel rsp ad2antrl sylan9r ralrimi sylan2b iunss sylibr a2d
      exp32 finds com12 syl5eqss ) EBJZBDUBZKZBDALZUEZCMZACNZBDEUEZCMZKZKZBDEUC
      FOFLZGPAGLZXHQZUFZXKUGZOUHZRZQZCABDFEGUIXNYACMZFONYBCMXNYCFOXOOJXNYCXNUAL
      ZXTRZCMZSXNUJXTRZCMZSXNUDLZXTRZCMZSXNYIUKZXTRZCMZSXNYCSUAUDXOYDUJTZYFYHXN
      YOYEYGCYDUJXTULUMUNYDYITZYFYKXNYPYEYJCYDYIXTULUMUNYDYLTZYFYNXNYQYEYMCYDYL
      XTULUMUNYDXOTZYFYCXNYRYEYACYDXOXTULUMUNXNYGXKCXFYGXKTZXMXFXKPJZYSBDEUOZXK
      PXRUPUQURXFXJXLUSUTYIOJZXNYKYNUUBXNYKYNUUBXNYKKZKZYMAYIHPIHLZBDILZUEZQZUF
      ZXKUGZOUHZRZXHQZCUUCUUBUUMPJZYMUUMTUUCUULPJXHPJZAUULNZUUNYIUUKVAXFUUPXMYK
      XFUUOAUULXFXGUULJZXGBJZUUOXFUULBXGXFYTUULBMUUAIBPDUDEHVBUQVCXEUURUUOSXDUU
      RXEUUOBDXGUOVDVGVEVFVHAUULXHPPVIVJGXKYIXQUUMXTPGXKVKGYIVKGUUMVKXTVQXPYJTX
      PUULTXQUUMTYJUULXPYIXTUUKXRUUITXSUUJTXTUUKTGHPXQUUHXPUUETXQIXPUUGQUUHAIXP
      XHUUGBDXGUUFVLVMIXPUUEUUGVNVOVPXKXRUUIVRXSUUJOVSVTWAZWBAXPUULXHVNWCWDWEUU
      DXIAUULNZUUMCMUUCUUBXNUULCMZKZUUTYKUVAXNYJUULCUUSWFWGUVBUUTUUBUVBXIAUULXN
      UVAAXFXMAXFAWHXJXLAXIACWIXLAWHWJWJUVAAWHWJUVAUUQXGCJZXNXIUULCXGWKXJUVCXIS
      XFXLXIACWLWMWNWOVGWPAUULXHCWQWRUTWTWSXAXBVFFOYACWQWRXC $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d X x y $.  $d Y x y $.
    $( Given a transitive predecessor ` Y ` of ` X ` , the transitive
       predecessors of ` Y ` are a subset of the transitive predecessors of
       ` X ` .  (Contributed by Scott Fenton, 25-Apr-2012.)  (Revised by Mario
       Carneiro, 26-Jun-2015.) $)
    trpredelss $p |- ( ( X e. A /\ R Se A ) ->
                      ( Y e. TrPred ( R , A , X ) ->
                        TrPred ( R , A , Y ) C_ TrPred ( R , A , X ) ) ) $=
      ( vy wcel wse wa ctrpred wss cv cpred cvv setlikespec trpredss syl sselda
      wral simplr trpredtr ralrimiv adantr imp trpredmintr syl22anc ex ) CAFZAB
      GZHZDABCIZFZABDIUJJZUIUKHDAFUHABEKZLUJJZEUJRZABDLUJJZULUIUJADUIABCLMFUJAJ
      ABCNAMBCOPQUGUHUKSUIUOUKUIUNEUJABCUMTUAUBUIUKUPABCDTUCEAUJBDUDUEUF $.
  $}

  ${
    $d A x y z $.  $d R x y z $.  $d X x y z $.
    $( The transitive predecessors of ` X ` are equal to the predecessors of
       ` X ` together with their transitive predecessors.  (Contributed by
       Scott Fenton, 26-Apr-2012.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    dftrpred3g $p |- ( ( X e. A /\ R Se A ) ->
                    TrPred ( R , A , X ) =
                    ( Pred ( R , A , X ) u.
                      U_ y e. Pred ( R , A , X ) TrPred ( R , A , y ) ) ) $=
      ( vz wcel wa ctrpred cpred wss wral predel cvv setlikespec trpredpred syl
      cv wi expcom syl6 wse ciun cun wo elun adantl syl5 ancld trpredeq3 sseq2d
      wrex rspcev ssiun eliun ancoms adantll trpredss sseld ad2antlr syld simpr
      weq imp simplr trpredelss syl2anc sstrd exp31 reximdvai syl5bi jaod ssun4
      ralrimiv ssun1 jctir trpredmintr mpdan iunss sylibr unssd eqssd ) DBFZBCU
      AZGZBCDHZBCDIZAWFBCAQZHZUBZUCZWDBCEQZIZWJJZEWJKZWFWJJZGWEWJJWDWNWOWDWMEWJ
      WKWJFWKWFFZWKWIFZUDZWDWMWKWFWIUEWDWRWLWIJZWMWDWPWSWQWDWPWPWLBCWKHZJZGZWSW
      DWPXAWPWKBFZWDXABCDWKLWCXCXARWBXCWCXAXCWCGWLMFZXABCWKNZBMCWKOZPSUFUGUHXBW
      LWHJZAWFUKZWSXGXAAWKWFAEVBWHWTWLBCWGWKUIUJULAWFWHWLUMZPTWQWKWHFZAWFUKZWDW
      SAWKWFWHUNWDXKXHWSWDXJXGAWFWGWFFZWGBFZWDXJXGRBCDWGLWDXMXJXGWDXMGZXJGZWLWT
      WHXOXDXAXNXJXDXNXJXCXDXNWHBWKXNBCWGIMFZWHBJWCXMXPWBXMWCXPBCWGNUOUPBMCWGUQ
      PURWCXCXDRWBXMXCWCXDXESUSUTVCXFPXNXJWTWHJZXNXMWCXJXQRWDXMVAWBWCXMVDBCWGWK
      VEVFVCVGVHUGVIXITVJVKWLWIWFVLTVJVMWFWIVNVOEBWJCDVPVQWDWFWIWEWDWFMFWFWEJBC
      DNBMCDOPZWDWHWEJZAWFKWIWEJWDXSAWFWDXLWGWEFXSWDWFWEWGXRURBCDWGVEUTVMAWFWHW
      EVRVSVTWA $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d X x y $.
    $( Another recursive expression for the transitive predecessors.
       (Contributed by Scott Fenton, 27-Apr-2012.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    dftrpred4g $p |- ( ( X e. A /\ R Se A ) ->
        TrPred ( R , A , X ) =
        U_ y e. Pred ( R , A , X ) ( { y } u. TrPred ( R , A , y ) ) ) $=
      ( wcel wse wa ctrpred cpred cv ciun cun csn dftrpred3g iunun iunid uneq1i
      eqtri syl6eqr ) DBEBCFGBCDHBCDIZATBCAJZHZKZLZATUAMZUBLKZABCDNUFATUEKZUCLU
      DATUEUBOUGTUCATPQRS $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d X x y $.
    $( If ` R ` partially orders ` A ` , then the transitive predecessors are
       the same as the immediate predecessors .  (Contributed by Scott Fenton,
       28-Apr-2012.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    trpredpo $p |- ( ( R Po A /\ X e. A /\ R Se A ) ->
                      TrPred ( R , A , X ) = Pred ( R , A , X ) ) $=
      ( vy wpo wcel wse w3a ctrpred cpred cv wss simp2 simp3 wa predpo ralrimiv
      wral 3adant3 cvv ssid a1i trpredmintr syl22anc setlikespec trpredpred syl
      3adant1 eqssd ) ABEZCAFZABGZHZABCIZABCJZUMUKULABDKZJUOLZDUORZUOUOLZUNUOLU
      JUKULMUJUKULNUJUKURULUJUKOUQDUOABCUPPQSUSUMUOUAUBDAUOBCUCUDUKULUOUNLZUJUK
      ULOUOTFUTABCUEATBCUFUGUHUI $.
  $}

  ${
    $d R a i j k y z $.  $d X a i j k y z $.
    $( The class of transitive predecessors is empty when ` A ` is empty.
       (Contributed by Scott Fenton, 30-Apr-2012.) $)
    trpred0 $p |- TrPred ( R , (/) , X ) = (/) $=
      ( vi va vy vj c0 com cv cvv cpred ciun cmpt crdg cres cfv wcel wceq pred0
      iuneq2i ctrpred dftrpred2 iun0 eqtri mpteq2i rdgeq12 mp2an reseq1i fveq1i
      a1i csuc wrex nn0suc fveq2 0ex fr0g ax-mp syl6eq nfcv eqid eqidd frsucmpt
      wo mpan2 eqeq1d syl5ibrcom rexlimiv jaoi syl syl5eq 3eqtri ) GABUACHCIZDJ
      EDIZGAEIZKZLZMZGABKZNZHOZPZLCHGLGEGACBDUBCHWAGVLHQZWAVLDJGMZGNZHOZPZGVLVT
      WEVSWDHVQWCRVRGRVSWDRDJVPGVPEVMGLGEVMVOGVOGRVNVMQAVNSUJTEVMUCUDUEABSVRGVQ
      WCUFUGUHUIWBVLGRZVLFIZUKZRZFHULZVCWFGRZFVLUMWGWLWKWGWFGWEPZGVLGWEUNGJQZWM
      GRUOGJWCUPUQURWJWLFHWHHQZWLWJWIWEPZGRZWOWNWQUODGWHGGWEJDGUSZDWHUSWRWEUTVM
      WHWEPRGVAVBVDWJWFWPGVLWIWEUNVEVFVGVHVIVJTCHUCVK $.
  $}

  ${
    $d R a y $.  $d A a y $.  $d X a y $.
    $( The transitive predecessors of a relation form a set (NOTE: this is the
       first theorem in the transitive predecessor series that requires
       infinity).  (Contributed by Scott Fenton, 18-Feb-2011.) $)
    trpredex $p |- TrPred ( R , A , X ) e. _V $=
      ( va vy ctrpred cvv cpred ciun cmpt crdg com cres crn cuni df-trpred wcel
      cv wfn frfnom omex fnex mp2an rnex uniex eqeltri ) ABCFDGEDRABERHIJZABCHZ
      KLMZNZOGEABCDPUJUIUILSLGQUIGQUHUGTUALGUIUBUCUDUEUF $.
  $}

  ${
    $d A x z $.  $d R x z $.  $d X x z $.  $d Y z $.  $d A a i j y x z $.
    $d R a i j y $.  $d X a i j y $.  $d Y a i j y $.
    $( If ` Y ` is an ` R ` , ` A ` transitive predecessor, then it is either
       an immediate predecessor or there is a transitive predecessor between
       ` Y ` and ` X ` (Contributed by Scott Fenton, 9-May-2012.)  (Revised by
       Mario Carneiro, 26-Jun-2015.) $)
    trpredrec $p |- ( ( X e. A /\ R Se A ) ->
       ( Y e. TrPred ( R , A , X ) -> ( Y e. Pred ( R , A , X ) \/
         E. z e. TrPred ( R , A , X ) Y R z ) ) ) $=
      ( vi va vy vj wcel cv cvv ciun com cfv wrex wa wceq wi eleq2d ctrpred wse
      cpred cmpt crdg cres wbr wo eltrpred csuc nn0suc fveq2 anbi2d setlikespec
      c0 biimpd fr0g syl biimpa syl6com wral wss trpredlem1 sseld expcom adantl
      fvex syld ralrimiv iunexg sylancr nfcv nfmpt1 nfrdg nfres nffv nfiun eqid
      predeq3 cbviunv iuneq1 syl5eq frsucmpt sylan2 expimpd dftrpred2 syl6sseqr
      eliun ssiun2 vex elpredim a1i anim12d reximdv2 com12 sylbi com23 rexlimdv
      pm2.43d orim12d ex syl5 syl5bi ) EBCDUAZJEFKZGLHGKZBCHKZUCZMZUDZBCDUCZUEZ
      NUFZOZJZFNPDBJZBCUBZQZEXKJZEAKZCUGZAXDPZUHZHBCFDEGUIXRXOYCFNXENJXEUORZXEI
      KZUJZRZINPZUHZXRXOYCSIXEUKXRXOYIYCXRXOYIYCSXRXOQZYDXSYHYBYDYJXREUOXMOZJZQ
      ZXSYDYJYMYDXOYLXRYDXNYKEXEUOXMULTUMUPXRYLXSXRYKXKEXRXKLJZYKXKRBCDUNZXKLXJ
      UQURTUSUTYJYGYBINYJYGYENJZYBYGYJXREYFXMOZJZQZYPYBSZYGYJYSYGXOYRXRYGXNYQEX
      EYFXMULTUMUPYSYPYBYPYSEAYEXMOZBCXTUCZMZJZYTYPXRYRUUDYPXRQZYRUUDUUEYQUUCEX
      RYPUUCLJZYQUUCRXRUUALJUUBLJZAUUAVAUUFYEXMVGXRUUGAUUAXRXTUUAJZXTBJZUUGXRUU
      ABXTXRYNUUABVBYOHBLCIDGVCURVDXQUUIUUGSXPUUIXQUUGBCXTUNVEVFVHVIAUUAUUBLLVJ
      VKGXKYEXIUUCXMLGXKVLZGYEVLZAGUUAUUBGYEXMGXLNGXKXJGLXIVMUUJVNGNVLVOUUKVPGU
      UBVLVQXMVRXFUUARXIAXFUUBMUUCHAXFXHUUBBCXGXTVSVTAXFUUAUUBWAWBWCWDTUPWEUUDE
      UUBJZAUUAPZYTAEUUAUUBWHYPUUMYBYPUULYAAUUAXDYPUUHXTXDJUULYAYPUUAXDXTYPUUAI
      NUUAMXDINUUAWIHBCIDGWFWGVDUULYASYPBCXTEAWJWKWLWMWNWOWPUTWSUTWQWRWTXAWQXBW
      RXC $.
  $}

  $(
  @{ @d R x z @. @d A x z @. @d X x z @.
     trpredfrirr.1 @e |- R Fr A @.
     trpredfrirr.2 @e |- A. x e. A Pred ( R , A , x ) e. _V @.

     @( If ` R ` is founded and set-like over ` A ` , then the transitive
        predecessor set is irreflexive @)
     trpredfrirr @p |- ( X e. A -> -. X e. TrPred ( R , A , X ) ) @=
       ( vz wcel ctrpred cpred cv wbr wrex wo wn wa nrexdv wfr predfrirr ax-mp
       jctil ioran sylibr cvv wral wi trpredrec mpan2 mtod ) DBHZDBCDIZHZDBCDJH
       ZDGKCLZGUKMZNZUJUMOZUOOZPUPOUJURUQUJUNGUK?QBCRUQEBCDSTUAUMUOUBUCUJBCAKJU
       DHABUEULUPUFFAGBCDDUGUHUI @.
       @( [12-May-2012] @) @( [10-May-2012] @)
  @}
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Founded Induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a b x $.  $d B a b c y $.  $d R a b c x $.  $d R y $.
    $( Every (possibly proper) subclass of a class ` A ` with a founded,
       set-like relation ` R ` has a minimal element.  Lemma 4.3 of Don Monk's
       notes for Advanced Set Theory, which can be found at
       ~ http://euclid.colorado.edu/~~monkd/settheory .  This is a very strong
       generalization of ~ tz6.26 and ~ tz7.5 .  (Contributed by Scott Fenton,
       4-Feb-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    frmin $p |- ( ( ( R Fr A /\ R Se A ) /\ ( B C_ A /\ B =/= (/) ) ) ->
                   E. y e. B Pred ( R , B , y ) = (/) ) $=
      ( vb vc wa wss c0 wne cv cpred wceq wrex wi wcel eqeq1d ex cvv syl wfr n0
      wse frss anim12d wex predeq3 rspcev adantl ctrpred setlikespec trpredpred
      sess2 ssn0 trpredss jctild adantr trpredex sseq1 neeq1 anbi12d rexeqbi1dv
      predeq2 imbi12d imbi2d wal dffr4 sylbi vtocl trpredtr imp syl2anc biimprd
      sp sspred reximdva ssrexv sylsyld sylan9r an31s pm2.61dne exlimdv syl6com
      syld syl5bi imp32 ) BDUAZBDUCZGZCBHZCIJZCDAKZLZIMZACNZWJWICDUAZCDUCZGZWKW
      OOWJWGWPWHWQCBDUDCBDUMUEWKEKZCPZEUFWRWOECUBWRWTWOEWRWTWOWRWTGWOCDWSLZIWTX
      AIMZWOOWRWTXBWOWNXBAWSCWLWSMWMXAICDWLWSUGQUHRUIWTWQWPXAIJZWOOWTWQGZWPGXCC
      DWSUJZCHZXEIJZGZWOXDXCXHOZWPXDXASPZXICDWSUKZXJXCXGXFXJXAXEHZXCXGOCSDWSULX
      LXCXGXAXEUNRTCSDWSUOZUPTUQWPXHXEDWLLZIMZAXENZXDWOWPFKZCHZXQIJZGZXQDWLLZIM
      ZAXQNZOZOWPXHXPOZOFXECDWSURXQXEMZYDYEWPYFXTXHYCXPYFXRXFXSXGXQXECUSXQXEIUT
      VAYBXOAXQXEYFYAXNIXQXEDWLVCQVBVDVEWPYDFVFYDFACDVGYDFVNVHVIXDXFXPWNAXENWOX
      DXJXFXKXMTZXDXOWNAXEXDWLXEPZGZWNXOYIWMXNIYIXFWMXEHZWMXNMXDXFYHYGUQXDYHYJC
      DWSWLVJVKCXEDWLVOVLQVMVPWNAXECVQVRVSWDVTWARWBWEWCWF $.
  $}

  ${
    $d A x $.  $d A y $.  $d B y $.  $d R x $.  $d R y $.
    $( The principle of founded induction.  Theorem 4.4 of Don Monk's notes
       (see ~ frmin ).  This principle states that if ` B ` is a subclass of a
       founded class ` A ` with the property that every element of ` B ` whose
       initial segment is included in ` A ` is itself equal to ` A ` .  Compare
       ~ wfi and ~ tfi , which are special cases of this theorem that do not
       require the axiom of infinity to prove.  (Contributed by Scott Fenton,
       6-Feb-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    frind $p |- ( ( ( R Fr A /\ R Se A ) /\ ( B C_ A /\
                       A. y e. A ( Pred ( R , A , y ) C_ B -> y e. B ) ) ) ->
                   A = B ) $=
      ( wa wss cpred wcel wn cdif c0 ssdif0 wceq anbi1i cin df-pred incom eqtri
      wrex bitri wfr wse cv wi wral wne necon3bbii difss frmin eldif anass ccnv
      ancom csn cima indif2 difeq1i 3eqtr4i eqeq1i bitr4i anbi2i 3bitri rexbii2
      rexanali sylib ex mpani syl5bi con4d imp adantrl simprl eqssd ) BDUABDUBE
      ZCBFZBDAUCZGZCFZVPCHZUDABUEZEEBCVNVTBCFZVOVNVTWAVNWAVTWAIBCJZKUFZVNVTIZWA
      WBKBCLUGVNWBBFZWCWDBCUHVNWEWCEZWDVNWFEWBDVPGZKMZAWBSZWDABWBDUIWIVRVSIZEZA
      BSWDWHWKAWBBVPWBHZWHEVPBHZWJEZWHEWMWJWHEZEWMWKEWLWNWHVPBCUJNWMWJWHUKWOWKW
      MWOWHWJEWKWJWHUMWHVRWJWHVQCJZKMVRWGWPKDULVPUNUOZWBOZWQBOZCJWGWPWQBCUPWGWB
      WQOWRWBDVPPWBWQQRVQWSCVQBWQOWSBDVPPBWQQRUQURUSVQCLUTNTVAVBVCVRVSABVDTVEVF
      VGVHVIVJVKVNVOVTVLVM $.

    ${
      frind.1 $e |- R Fr A $.
      frind.2 $e |- R Se A $.
      $( The principle of founded induction.  Theorem 4.4 of Don Monk's notes
         (see ~ frmin ).  This principle states that if ` B ` is a subclass of
         a founded class ` A ` with the property that every element of ` B `
         whose initial segment is included in ` A ` is itself equal to ` A ` .
         (Contributed by Scott Fenton, 6-Feb-2011.)  (Revised by Mario
         Carneiro, 26-Jun-2015.) $)
      frindi $p |- ( ( B C_ A /\
                         A. y e. A ( Pred ( R , A , y ) C_ B -> y e. B ) ) ->
                        A = B ) $=
        ( wfr wse wss cv cpred wcel wi wral wa wceq frind mpanl12 ) BDGBDHCBIBD
        AJZKCISCLMABNOBCPEFABCDQR $.
    $}

  $}

  ${
    $d A w y z $.  $d A x $.  $d ph w z $.  $d R w y z $.  $d R x $.
    frinsg.1 $e |- ( y e. A ->
                       ( A. z e. Pred ( R , A , y ) [. z / y ]. ph -> ph ) ) $.
    $( Founded Induction Schema.  If a property passes from all elements less
       than ` y ` of a founded class ` A ` to ` y ` itself (induction
       hypothesis), then the property holds for all elements of ` A ` .
       (Contributed by Scott Fenton, 7-Feb-2011.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    frinsg $p |- ( ( R Fr A /\ R Se A ) -> A. y e. A ph ) $=
      ( vw wa wceq wral wss cv cpred wcel wi wsbc nfcv elrabsf nfsbc1v nfim wfr
      wse ssrab2 dfss3 simprbi ralimi sylbi nfral eleq1 predeq3 raleqdv sbceq1a
      crab imbi12d chvar syl5 anc2li syl6ibr rgen frind mpanr12 rabid2 sylib
      nfv ) DEUADEUBHZDABDUMZIZABDJVEVFDKDEGLZMZVFKZVHVFNZOZGDJVGABDUCVLGDVHDNZ
      VJVMABVHPZHVKVMVJVNVJABCLZPZCVIJZVMVNVJVOVFNZCVIJVQCVIVFUDVRVPCVIVRVODNVP
      ABVODBDQZRUEUFUGBLZDNZVPCDEVTMZJZAOZOVMVQVNOZOBGVMWEBVMBVDVQVNBVPBCVIBVIQ
      ABVOSUHABVHSTTVTVHIZWAVMWDWEVTVHDUIWFWCVQAVNWFVPCWBVIDEVTVHUJUKABVHULUNUN
      FUOUPUQABVHDVSRURUSGDVFEUTVAABDVBVC $.
  $}

  ${
    $d A x $.  $d A w y z $.  $d ph w z $.  $d R x $.  $d R w y z $.
    frins.1 $e |- R Fr A $.
    frins.2 $e |- R Se A $.
    frins.3 $e |- ( y e. A ->
                      ( A. z e. Pred ( R , A , y ) [. z / y ]. ph -> ph ) ) $.
    $( Founded Induction Schema.  If a property passes from all elements less
       than ` y ` of a founded class ` A ` to ` y ` itself (induction
       hypothesis), then the property holds for all elements of ` A ` .
       (Contributed by Scott Fenton, 6-Feb-2011.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    frins $p |- ( y e. A -> ph ) $=
      ( wfr wse wral frinsg mp2an rspec ) ABDDEIDEJABDKFGABCDEHLMN $.
  $}

  ${
    $d A w y z $.  $d A x $.  $d ph w z $.  $d R w y z $.  $d R x $.
    frins2fg.1 $e |- ( y e. A ->
                         ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    frins2fg.2 $e |- F/ y ps $.
    frins2fg.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Founded Induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 7-Feb-2011.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
    frins2fg $p |- ( ( R Fr A /\ R Se A ) -> A. y e. A ph ) $=
      ( cv wsbc cpred wral wcel wsb sbsbc sbie bitr3i ralbii syl5bi frinsg ) AC
      DEFACDJKZDEFCJZLZMBDUDMUCENAUBBDUDUBACDOBACDPABCDHIQRSGTUA $.
  $}

  ${
    $d A x $.  $d A y z $.  $d ph z $.  $d R x $.  $d R y z $.
    frins2f.1 $e |- R Fr A $.
    frins2f.2 $e |- R Se A $.
    frins2f.3 $e |- F/ y ps $.
    frins2f.4 $e |- ( y = z -> ( ph <-> ps ) ) $.
    frins2f.5 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Founded Induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 6-Feb-2011.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
    frins2f $p |- ( y e. A -> ph ) $=
      ( wfr wse wral frins2fg mp2an rspec ) ACEEFLEFMACENGHABCDEFKIJOPQ $.
  $}

  ${
    $d A w y z $.  $d A x $.  $d ph w z $.  $d R w y z $.  $d R x $.
    $d ps y $.
    frins2g.1 $e |- ( y e. A ->
                         ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    frins2g.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    $( Founded Induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 8-Feb-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    frins2g $p |- ( ( R Fr A /\ R Se A ) -> A. y e. A ph ) $=
      ( nfv frins2fg ) ABCDEFGBCIHJ $.
  $}

  ${
    $d A x $.  $d A y z $.  $d ph z $.  $d ps y $.  $d R x $.  $d R y z $.
    frins2.1 $e |- R Fr A $.
    frins2.2 $e |- R Se A $.
    frins2.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    frins2.4 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Founded Induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 6-Feb-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    frins2 $p |- ( y e. A -> ph ) $=
      ( nfv frins2f ) ABCDEFGHBCKIJL $.
  $}

  ${
    $d A x $.  $d A y z $.  $d B y $.  $d ph z $.  $d ps y $.  $d ch y $.
    $d R x $.  $d R y z $.
    frins3.1 $e |- R Fr A $.
    frins3.2 $e |- R Se A $.
    frins3.3 $e |- ( y = z -> ( ph <-> ps ) ) $.
    frins3.4 $e |- ( y = B -> ( ph <-> ch ) ) $.
    frins3.5 $e |- ( y e. A -> ( A. z e. Pred ( R , A , y ) ps -> ph ) ) $.
    $( Founded Induction schema, using implicit substitution.  (Contributed by
       Scott Fenton, 6-Feb-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    frins3 $p |- ( B e. A -> ch ) $=
      ( frins2 vtoclga ) ACDGFLABDEFHIJKMNO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Ordering Ordinal Sequences
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A f x $.  $d G f x $.  $d X x $.
    orderseqlem.1 $e |- F = { f | E. x e. On f : x --> A } $.
    $( Lemma for ~ poseq and ~ soseq .  The function value of a sequene is
       either in ` A ` or null.  (Contributed by Scott Fenton, 8-Jun-2011.) $)
    orderseqlem $p |- ( G e. F -> ( G ` X ) e. ( A u. { (/) } ) ) $=
      ( wcel cv wf con0 wrex cfv c0 csn cun wceq feq1 wss syl rexbidv ibi unss1
      elab2g crn frn fvrn0 ssel ee10 rexlimivw ) EDHZAIZBEJZAKLZFEMZBNOZPZHZUKU
      NULBCIZJZAKLUNCEDDUSEQUTUMAKULBUSERUAGUDUBUMURAKUMEUEZUPPZUQSZUOVBHURUMVA
      BSVCULBEUFVABUPUCTEFUGVBUQUOUHUIUJT $.
  $}

  ${
    $d A b f x $.  $d a b c f g t w x y z $.  $d F a b c f g t w x z $.
    $d R f g t w x z $.  $d S a b c $.
    poseq.1 $e |- R Po ( A u. { (/) } ) $.
    poseq.2 $e |- F = { f | E. x e. On f : x --> A } $.
    poseq.3 $e |- S = { <. f , g >. | ( ( f e. F /\ g e. F ) /\
                        E. x e. On ( A. y e. x ( f ` y ) = ( g ` y ) /\
                           ( f ` x ) R ( g ` x ) ) ) } $.
    $( A partial ordering of sequences of ordinals.  (Contributed by Scott
       Fenton, 8-Jun-2011.) $)
    poseq $p |- S Po F $=
      ( vz vw wbr wa wral cfv con0 wrex anbi12d va vb vc vt wpo cv wn wcel wceq
      wi w3a c0 csn cun wf feq2 cbvrexv abbii eqtri orderseqlem sylancr intnand
      cab poirr adantr nrexdv imnan mpbi vex eleq1 anbi1d eqeq1d ralbidv breq1d
      fveq1 rexbidv anbi2d eqeq2d breq2d brab mtbir raleq fveq2 breq12d simplll
      weq syl5bb simplrr an4 2rexbii reeanv bitri wel w3o word ordtri3or syl2an
      eloni simp1l wss onelss imp adantll ssralv anim2d r19.26 eqtr ralimi syl6
      syl6ibr adantrd 3impia eqeq12d rspcv breq2 biimpd com3l ad2ant2lr 3adant1
      syl impcom syl12anc a1d 3exp ad2antrr ad2antlr ad2antll 3jca potr anim12i
      rspcev anassrs sylan2 exp32 imbi1d syl5ibcom simp1r adantlr anim1d sylbir
      breq1 biimprd ad2ant2rl 3jaod mpd rexlimivv jca31 an4s syl2anb sylibr a1i
      pm3.2i rgen3 df-po mpbir ) HEUEUAUFZUUPENZUGZUUPUBUFZENZUUSUCUFZENZOZUUPU
      VAENZUJZOZUCHPUBHPUAHPUVFUAUBUCHHHUVFUUPHUHZUUSHUHZUVAHUHZUKUURUVEUUQUVGU
      VGOZBUFZUUPQZUVLUIZBAUFZPZUVNUUPQZUVPDNZOZARSZOZUVJUVSUGZUJUVTUGUVGUWAUVG
      UVGUVRARUVGUVRUGUVNRUHUVGUVQUVOUVGCULUMUNZDUEZUVPUWBUHUVQUGIUBCFHUUPUVNHU
      VNCFUFZUOZARSZFVCUUSCUWDUOZUBRSZFVCJUWFUWHFUWEUWGAUBRUVNUUSCUWDUPUQURUSUT
      UWBUVPDVDVAVBVEVFVEUVJUVSVGVHUWDHUHZGUFZHUHZOZUVKUWDQZUVKUWJQZUIZBUVNPZUV
      NUWDQZUVNUWJQZDNZOZARSZOZUVGUWKOZUVLUWNUIZBUVNPZUVPUWRDNZOZARSZOUVTFGUUPU
      UPEUAVIZUXIFUAWFZUWLUXCUXAUXHUXJUWIUVGUWKUWDUUPHVJVKZUXJUWTUXGARUXJUWPUXE
      UWSUXFUXJUWOUXDBUVNUXJUWMUVLUWNUVKUWDUUPVOVLZVMUXJUWQUVPUWRDUVNUWDUUPVOVN
      TVPTGUAWFZUXCUVJUXHUVSUXMUWKUVGUVGUWJUUPHVJVQUXMUXGUVRARUXMUXEUVOUXFUVQUX
      MUXDUVMBUVNUXMUWNUVLUVLUVKUWJUUPVOVRVMUXMUWRUVPUVPDUVNUWJUUPVOVSTVPTKVTWA
      UVCUVGUVIOZUVLUVKUVAQZUIZBUDUFZPZUXQUUPQZUXQUVAQZDNZOZUDRSZOZUVDUUTUVGUVH
      OZUVLUVKUUSQZUIZBLUFZPZUYHUUPQZUYHUUSQZDNZOZLRSZOZUVHUVIOZUYFUXOUIZBMUFZP
      ZUYRUUSQZUYRUVAQZDNZOZMRSZOZUYDUVBUXBUXCUXDBUYHPZUYJUYHUWJQZDNZOZLRSZOUYO
      FGUUPUUSEUXIUBVIZUXJUWLUXCUXAVUJUXKUXAUWOBUYHPZUYHUWDQZVUGDNZOZLRSUXJVUJU
      WTVUOALRALWFZUWPVULUWSVUNUWOBUVNUYHWBVUPUWQVUMUWRVUGDUVNUYHUWDWCUVNUYHUWJ
      WCWDTUQUXJVUOVUILRUXJVULVUFVUNVUHUXJUWOUXDBUYHUXLVMUXJVUMUYJVUGDUYHUWDUUP
      VOVNTVPWGTGUBWFZUXCUYEVUJUYNVUQUWKUVHUVGUWJUUSHVJVQVUQVUIUYMLRVUQVUFUYIVU
      HUYLVUQUXDUYGBUYHVUQUWNUYFUVLUVKUWJUUSVOVRVMVUQVUGUYKUYJDUYHUWJUUSVOVSTVP
      TKVTUXBUVHUWKOZUYFUWNUIZBUYRPZUYTUYRUWJQZDNZOZMRSZOVUEFGUUSUVAEVUKUCVIZFU
      BWFZUWLVURUXAVVDVVFUWIUVHUWKUWDUUSHVJVKUXAUWOBUYRPZUYRUWDQZVVADNZOZMRSVVF
      VVDUWTVVJAMRAMWFZUWPVVGUWSVVIUWOBUVNUYRWBVVKUWQVVHUWRVVADUVNUYRUWDWCUVNUY
      RUWJWCWDTUQVVFVVJVVCMRVVFVVGVUTVVIVVBVVFUWOVUSBUYRVVFUWMUYFUWNUVKUWDUUSVO
      VLVMVVFVVHUYTVVADUYRUWDUUSVOVNTVPWGTGUCWFZVURUYPVVDVUDVVLUWKUVIUVHUWJUVAH
      VJZVQVVLVVCVUCMRVVLVUTUYSVVBVUBVVLVUSUYQBUYRVVLUWNUXOUYFUVKUWJUVAVOZVRVMV
      VLVVAVUAUYTDUYRUWJUVAVOVSTVPTKVTUYEUYPUYNVUDUYDUYEUYPOZUYNVUDOZOUVGUVIUYC
      UVGUVHUYPVVPWEUYEUVHUVIVVPWHVVPVVOUYCVVPUYIUYSOZUYLVUBOZOZMRSLRSZVVOUYCUJ
      ZVVTUYMVUCOZMRSLRSVVPVVSVWBLMRRUYIUYSUYLVUBWIWJUYMVUCLMRRWKWLVVSVWALMRRUY
      HRUHZUYRRUHZOZLMWMZLMWFZMLWMZWNZVVSVWAUJZVWCUYHWOUYRWOVWIVWDUYHWRUYRWRUYH
      UYRWPWQVWEVWFVWJVWGVWHVWEVWFVVSVWAVWEVWFVVSUKZUYCVVOVWKVWCUXPBUYHPZUYJUYH
      UVAQZDNZUYCVWCVWDVWFVVSWSVWEVWFVVSVWLVWEVWFOZVVQVWLVVRVWOUYHUYRWTZVVQVWLU
      JVWDVWFVWPVWCVWDVWFVWPUYRUYHXAXBXCVWPVVQUYGUYQOZBUYHPZVWLVWPVVQUYIUYQBUYH
      PZOZVWRVWPUYSVWSUYIUYQBUYHUYRXDXEUYGUYQBUYHXFZXJVWQUXPBUYHUVLUYFUXOXGZXHZ
      XIXTXKXLVWFVVSVWNVWEVVSVWFVWNUYSUYLVWFVWNUJZUYIVUBUYSUYLVXDVWFUYSUYLVWNVW
      FUYSUYKVWMUIZUYLVWNUJUYQVXEBUYHUYRBLWFUYFUYKUXOVWMUVKUYHUUSWCUVKUYHUVAWCX
      MXNVXEUYLVWNUYKVWMUYJDXOXPXIXQXBXRYAXSUYBVWLVWNOZUDUYHRUDLWFZUXRVWLUYAVWN
      UXPBUXQUYHWBVXGUXSUYJUXTVWMDUXQUYHUUPWCUXQUYHUVAWCWDTYKZYBYCYDVWCVWGVWJUJ
      VWDVWCVWRUYLUYKVWMDNZOZOZVWAUJVWGVWJVWCVXKVVOUYCVXKVVOOVWCVXFUYCVWRVXJVVO
      VXFVWRVWLVXJVVOOVWNVXCVVOVXJVWNVVOUWCUYJUWBUHZUYKUWBUHZVWMUWBUHZUKVXJVWNU
      JIVVOVXLVXMVXNUVGVXLUVHUYPACFHUUPUYHJUTYEUVHVXMUVGUYPACFHUUSUYHJUTYFUVIVX
      NUYEUVHACFHUVAUYHJUTYGYHUWBUYJUYKVWMDYIVAYAYJYLVXHYMYNVWGVXKVVSVWAVWGVWRV
      VQVXJVVRVWRVWTVWGVVQVXAVWGVWSUYSUYIUYQBUYHUYRWBVQWGVWGVXIVUBUYLVWGUYKUYTV
      WMVUADUYHUYRUUSWCUYHUYRUVAWCWDVQTYOYPVEVWEVWHVVSVWAVWEVWHVVSUKZUYCVVOVXOV
      WDUXPBUYRPZUYRUUPQZVUADNZUYCVWCVWDVWHVVSYQVWEVWHVVSVXPVWEVWHOUYRUYHWTZVVS
      VXPUJVWCVWHVXSVWDVWCVWHVXSUYHUYRXAXBYRVXSVVQVXPVVRVXSVVQUYGBUYRPZUYSOZVXP
      VXSUYIVXTUYSUYGBUYRUYHXDYSVYAVWQBUYRPVXPUYGUYQBUYRXFVWQUXPBUYRVXBXHYTXIXK
      XTXLVWHVVSVXRVWEVVSVWHVXRUYIVUBVWHVXRUJZUYSUYLUYIVUBVYBVWHUYIVUBVXRVWHUYI
      VXQUYTUIZVUBVXRUJUYGVYCBUYRUYHBMWFUVLVXQUYFUYTUVKUYRUUPWCUVKUYRUUSWCXMXNV
      YCVXRVUBVXQUYTVUADUUAUUBXIXQXBUUCYAXSUYBVXPVXROUDUYRRUDMWFZUXRVXPUYAVXRUX
      PBUXQUYRWBVYDUXSVXQUXTVUADUXQUYRUUPWCUXQUYRUVAWCWDTYKYBYCYDUUDUUEUUFYTYAU
      UGUUHUUIUXBUXCUXDBUXQPZUXSUXQUWJQZDNZOZUDRSZOUYDFGUUPUVAEUXIVVEUXJUWLUXCU
      XAVYIUXKUXAUWOBUXQPZUXQUWDQZVYFDNZOZUDRSUXJVYIUWTVYMAUDRAUDWFZUWPVYJUWSVY
      LUWOBUVNUXQWBVYNUWQVYKUWRVYFDUVNUXQUWDWCUVNUXQUWJWCWDTUQUXJVYMVYHUDRUXJVY
      JVYEVYLVYGUXJUWOUXDBUXQUXLVMUXJVYKUXSVYFDUXQUWDUUPVOVNTVPWGTVVLUXCUXNVYIU
      YCVVLUWKUVIUVGVVMVQVVLVYHUYBUDRVVLVYEUXRVYGUYAVVLUXDUXPBUXQVVLUWNUXOUVLVV
      NVRVMVVLVYFUXTUXSDUXQUWJUVAVOVSTVPTKVTUUJUULUUKUUMUAUBUCHEUUNUUO $.
  $}

  ${
    $d a b p q y $.  $d A f p q x $.  $d A y $.  $d F a b f g x $.
    $d f g x y $.  $d R f g x $.  $d S a b $.
    soseq.1 $e |- R Or ( A u. { (/) } ) $.
    soseq.2 $e |- F = { f | E. x e. On f : x --> A } $.
    soseq.3 $e |- S = { <. f , g >. | ( ( f e. F /\ g e. F ) /\
                        E. x e. On ( A. y e. x ( f ` y ) = ( g ` y ) /\
                           ( f ` x ) R ( g ` x ) ) ) } $.
    soseq.4 $e |- -. (/) e. A $.
    $( A linear ordering of sequences of ordinals.  (Contributed by Scott
       Fenton, 8-Jun-2011.) $)
    soseq $p |- S Or F $=
      ( wral wcel wa cfv wceq con0 wrex wi va vb vp wor wpo wbr weq w3o csn cun
      vq cv c0 sopo ax-mp poseq wo wn eleq1 anbi1d fveq1 eqeq1d ralbidv anbi12d
      breq1d rexbidv anbi2d eqeq2d breq2d brabg bianabs ancoms orbi12d ralinexa
      wb notbid andi eqcom ralbii anbi1i orbi2i bitri rexbii r19.43 xchbinx cab
      feq2 cbvrexv abbii eqtri orderseqlem sotrieq mpan syl2an imbi2d vex fveq2
      wf wsbc eqeq12d sbcie imbi1i tfisg sylbir elab2 anbi12i reeanv bitr4i wss
      feq1 onss ssralv syl ad2antlr rspcv a1i ffvelrn cdm fdm word eloni ordirr
      eleq2 biimparc sylan ndmfv eqtr2 com23 sylan2 syl5 exp4b imp32 syldd mtoi
      ex imp syld jcad wfn ffn biimprd 3syl adantlr ad2antrr eqtr biimpd expcom
      adantll ordtri3or adantr jctird 3orel13 syl6 eqfnfv2 adantl sylibrd sylbi
      rexlimivv sylbird syl5bir sylbid 3orcomb df-3or bitr2i sylib rgen2a df-so
      orrd mpbir2an ) HEUDHEUEUAULZUBULZEUFZUAUBUGZUVKUVJEUFZUHZUBHMUAHMABCDEFG
      HCUMUIUJZDUDZUVPDUEIUVPDUNUOJKUPUVOUAUBHUVJHNZUVKHNZOZUVLUVNUQZUVMUQZUVOU
      VTUWAUVMUVTUWAURBULZUVJPZUWCUVKPZQZBAULZMZUWGUVJPZUWGUVKPZDUFZOZARSZUWEUW
      DQZBUWGMZUWJUWIDUFZOZARSZUQZURZUVMUVTUWAUWSUVTUVLUWMUVNUWRUVTUVLUWMFULZHN
      ZGULZHNZOZUWCUXAPZUWCUXCPZQZBUWGMZUWGUXAPZUWGUXCPZDUFZOZARSZOZUVRUXDOZUWD
      UXGQZBUWGMZUWIUXKDUFZOZARSZOUVTUWMOFGUVJUVKHHEFUAUGZUXEUXPUXNUYAUYBUXBUVR
      UXDUXAUVJHUSUTUYBUXMUXTARUYBUXIUXRUXLUXSUYBUXHUXQBUWGUYBUXFUWDUXGUWCUXAUV
      JVAVBVCUYBUXJUWIUXKDUWGUXAUVJVAVEVDVFVDGUBUGZUXPUVTUYAUWMUYCUXDUVSUVRUXCU
      VKHUSVGUYCUXTUWLARUYCUXRUWHUXSUWKUYCUXQUWFBUWGUYCUXGUWEUWDUWCUXCUVKVAVHVC
      UYCUXKUWJUWIDUWGUXCUVKVAVIVDVFVDKVJVKUVSUVRUVNUWRVOUVSUVROZUVNUWRUXOUVSUX
      DOZUWEUXGQZBUWGMZUWJUXKDUFZOZARSZOUYDUWROFGUVKUVJHHEFUBUGZUXEUYEUXNUYJUYK
      UXBUVSUXDUXAUVKHUSUTUYKUXMUYIARUYKUXIUYGUXLUYHUYKUXHUYFBUWGUYKUXFUWEUXGUW
      CUXAUVKVAVBVCUYKUXJUWJUXKDUWGUXAUVKVAVEVDVFVDGUAUGZUYEUYDUYJUWRUYLUXDUVRU
      VSUXCUVJHUSVGUYLUYIUWQARUYLUYGUWOUYHUWPUYLUYFUWNBUWGUYLUXGUWDUWEUWCUXCUVJ
      VAVHVCUYLUXKUWIUWJDUWGUXCUVJVAVIVDVFVDKVJVKVLVMVPUWTUWHUWKUWPUQZURZTZARMZ
      UVTUVMUYPUWHUYMOZARSZUWSUWHUYMARVNUYRUWLUWQUQZARSUWSUYQUYSARUYQUWLUWHUWPO
      ZUQUYSUWHUWKUWPVQUYTUWQUWLUWHUWOUWPUWFUWNBUWGUWDUWEVRVSVTWAWBWCUWLUWQARWD
      WBWEUVTUYPUWHUWIUWJQZTZARMZUVMUVTVUBUYOARUVTVUAUYNUWHUVRUWIUVPNZUWJUVPNZV
      UAUYNVOZUVSBCFHUVJUWGHUWGCUXAWRZARSZFWFUWCCUXAWRZBRSZFWFJVUHVUJFVUGVUIABR
      UWGUWCCUXAWGWHWIWJZWKBCFHUVKUWGVUKWKUVQVUDVUEOVUFIUVPUWIUWJDWLWMWNWOVCVUC
      VUAARMZUVTUVMVUCVUAAUWCWSZBUWGMZVUATZARMVULVUOVUBARVUNUWHVUAVUMUWFBUWGVUA
      UWFAUWCBWPABUGUWIUWDUWJUWEUWGUWCUVJWQUWGUWCUVKWQWTXAVSXBVSVUAABXCXDUVTUCU
      LZCUVJWRZUKULZCUVKWRZOZUKRSUCRSZVULUVMTZUVTVUQUCRSZVUSUKRSZOVVAUVRVVCUVSV
      VDUVRUWGCUVJWRZARSZVVCVUHVVFFUVJHUAWPUYBVUGVVEARUWGCUXAUVJXJVFJXEVVEVUQAU
      CRUWGVUPCUVJWGWHWBUVSUWGCUVKWRZARSZVVDVUHVVHFUVKHUBWPUYKVUGVVGARUWGCUXAUV
      KXJVFJXEVVGVUSAUKRUWGVURCUVKWGWHWBXFVUQVUSUCUKRRXGXHVUTVVBUCUKRRVUPRNZVUR
      RNZOZVUTVVBVVKVUTOZVULUCUKUGZVUAAVUPMZOZUVMVVLVULVVMVVNVVLVULVUPVURNZURZV
      URVUPNZURZOZVVPVVMVVRUHZOVVMVVLVULVVTVWAVVLVULVVQVVSVVLVULVUAAVURMZVVQVVJ
      VULVWBTZVVIVUTVVJVURRXIVWCVURXKVUAAVURRXLXMXNVVLVWBVVQVVLVWBOVVPUMCNZLVVL
      VWBVVPVWDTVVLVVPVWBVWDVVLVVPVWBVUPUVJPZVUPUVKPZQZVWDVVPVWBVWGTTVVLVUAVWGA
      VUPVURAUCUGUWIVWEUWJVWFUWGVUPUVJWQUWGVUPUVKWQWTXOXPVVKVUQVUSVVPVWGVWDTZTV
      VKVUQVUSVVPVWHVUSVVPOVWFCNZVVKVUQOVWHVURCVUPUVKXQVVIVUQVWIVWHTZVVJVUQVVIU
      VJXRZVUPQZVWJVUPCUVJXSVVIVWLOZVWGVWIVWDVWMVUPVWKNZURZVWEUMQZVWGVWIVWDTZTV
      VIVUPVUPNZURZVWLVWOVVIVUPXTZVWSVUPYAZVUPYBXMVWLVWOVWSVWLVWNVWRVWKVUPVUPYC
      VPYDYEVUPUVJYFVWPVWGVWQVWPVWGOUMVWFQZVWQVWEUMVWFYGVXBVWDVWIUMVWFCUSUUAXMY
      OUUBYHYIUUCYJYKYLYMYHYPYNYOYQVVLVULVVNVVSVVIVULVVNTZVVJVUTVVIVUPRXIVXCVUP
      XKVUAAVUPRXLXMUUDZVVLVVNVVSVVLVVNOVVRVWDLVVLVVNVVRVWDTVVLVVRVVNVWDVVLVVRV
      VNVURUVJPZVURUVKPZQZVWDVVRVVNVXGTTVVLVUAVXGAVURVUPAUKUGUWIVXEUWJVXFUWGVUR
      UVJWQUWGVURUVKWQWTXOXPVVKVUQVUSVVRVXGVWDTZTZVVKVUSVUQVXIVVKVUSVUQVVRVXHVU
      QVVROVXECNZVVKVUSOVXHVUPCVURUVJXQVUSVVKUVKXRZVURQZVXJVXHTZVURCUVKXSVVJVXL
      VXMVVIVVJVXLOVXFUMQZVXMVVJVURVURNZURZVXLVXNVVJVURXTZVXPVURYAZVURYBXMVXPVX
      LOVURVXKNZURZVXNVXLVXTVXPVXLVXSVXOVXKVURVURYCVPYDVURUVKYFXMYEVXNVXGVXJVWD
      VXGVXNVXJVWDTZVXGVXNOVXEUMQZVYAVXEVXFUMUUEVYBVXJVWDVXEUMCUSUUFXMUUGYHXMUU
      HYIYJYKYHYLYMYHYPYNYOYQYRVVKVWAVUTVVIVWTVXQVWAVVJVXAVXRVUPVURUUIWNUUJUUKV
      VTVWAVVMVVPVVMVVRUULYPUUMVXDYRVUTUVMVVOVOZVVKVUQUVJVUPYSUVKVURYSVYCVUSVUP
      CUVJYTVURCUVKYTAVUPVURUVJUVKUUNWNUUOUUPYOUURUUQYJUUSUUTUVAUVHUVOUVLUVNUVM
      UHUWBUVLUVMUVNUVBUVLUVNUVMUVCUVDUVEUVFUAUBHEUVGUVI $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c wrecs $.

  $( Declare syntax for the well-founded recusive function generator. $)
  cwrecs $a class wrecs ( R , A , F ) $.

  ${
    $d R f x y $.  $d A f x y $.  $d F f x y $.
    $( Here we define the well-founded recusive function generator.  This is
       similar to ` recs ` , but works with arbitrary well-founded
       relationships.  (Contributed by Scott Fenton, 7-Jun-2018.)
       (New usage is discouraged.) $)
    df-wrecs $a |- wrecs ( R , A , F ) = U. { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x ) /\
                                  A. y e. x ( f ` y ) =
                                            ( F ` ( f |` Pred ( R , A , y ) ) )
                                ) } $.
  $}

  ${
    $d R f x y $.  $d S f x y $.  $d A f x y $.  $d B f x y $.  $d F f x y $.
    $d G f x y $.

    $( General equality theorem for the well-founded recursive function
       generator.  (Contributed by Scott Fenton, 7-Jun-2018.) $)
    wrecseq123 $p |- ( ( R = S /\ A = B /\ F = G ) ->
       wrecs ( R , A , F ) = wrecs ( S , B , G ) ) $=
      ( vf vx vy wceq w3a cv wss cpred wral wa cfv cres wex cab wfn cuni cwrecs
      wb sseq2 3ad2ant2 predeq1 predeq2 sylan9eq 3adant3 sseq1d ralbidv anbi12d
      reseq2d fveq12d eqeq2d 3anbi23d exbidv abbidv unieqd df-wrecs 3eqtr4g
      simp3 ) CDJZABJZEFJZKZGLZHLZUAZVIAMZACILZNZVIMZIVIOZPZVLVHQZVHVMRZEQZJZIV
      IOZKZHSZGTZUBVJVIBMZBDVLNZVIMZIVIOZPZVQVHWFRZFQZJZIVIOZKZHSZGTZUBACEUCBDF
      UCVGWDWPVGWCWOGVGWBWNHVGVPWIWAWMVJVGVKWEVOWHVEVDVKWEUDVFABVIUEUFVGVNWGIVI
      VGVMWFVIVDVEVMWFJVFVDVEVMADVLNWFACDVLUGABDVLUHUIZUJUKULUMVGVTWLIVIVGVSWKV
      QVGVRWJEFVDVEVFVCVDVEVRWJJVFVDVEPVMWFVHWQUNUJUOUPULUQURUSUTHIACGEVAHIBDGF
      VAVB $.
  $}

  ${
    $d R f y z $.  $d A f y z $.  $d F f y z $.  $d x f y z $.
    nfwrecs.1 $e |- F/_ x R $.
    nfwrecs.2 $e |- F/_ x A $.
    nfwrecs.3 $e |- F/_ x F $.
    $( Bound-variable hypothesis builder for the well-founded recursive
       function generator.  (Contributed by Scott Fenton, 9-Jun-2018.) $)
    nfwrecs $p |- F/_ x wrecs ( R , A , F ) $=
      ( vf vy vz cwrecs cv wfn wss cpred wral cfv nfcv nfss nfral cres wceq w3a
      wa wex cab cuni df-wrecs nfv nfpred nfan nfres nffv nfeq2 nf3an nfex nfab
      nfuni nfcxfr ) ABCDKHLZILZMZVABNZBCJLZOZVANZJVAPZUDZVDUTQZUTVEUAZDQZUBZJV
      APZUCZIUEZHUFZUGIJBCHDUHAVPVOAHVNAIVBVHVMAVBAUIVCVGAAVABAVARZFSVFAJVAVQAV
      EVAABCVDEFAVDRUJZVQSTUKVLAJVAVQAVIVKAVJDGAUTVEAUTRVRULUMUNTUOUPUQURUS $.
  $}

  $( Equality theorem for the well-founded recusive function generator.
     (Contributed by Scott Fenton, 7-Jun-2018.) $)
  wrecseq1 $p |- ( R = S -> wrecs ( R , A , F ) = wrecs ( S , A , F ) ) $=
    ( wceq cwrecs eqid wrecseq123 mp3an23 ) BCEAAEDDEABDFACDFEAGDGAABCDDHI $.

  $( Equality theorem for the well-founded recusive function generator.
     (Contributed by Scott Fenton, 7-Jun-2018.) $)
  wrecseq2 $p |- ( A = B -> wrecs ( R , A , F ) = wrecs ( R , B , F ) ) $=
    ( wceq cwrecs eqid wrecseq123 mp3an13 ) CCEABEDDEACDFBCDFECGDGABCCDDHI $.

  $( Equality theorem for the well-founded recusive function generator.
     (Contributed by Scott Fenton, 7-Jun-2018.) $)
  wrecseq3 $p |- ( F = G -> wrecs ( R , A , F ) = wrecs ( R , A , G ) ) $=
    ( wceq cwrecs eqid wrecseq123 mp3an12 ) BBEAAECDEABCFABDFEBGAGAABBCDHI $.

  ${
    $d A w x y z $.  $d F w x y z $.  $d G w x y z $.  $d H w x y z $.
    $d R w x y z $.
    $( Functions defined by well-founded recursion are identical up to
       relation, domain, and characteristic function.  (Contributed by Scott
       Fenton, 11-Feb-2011.) $)
    wfr3g $p |- ( ( ( R We A /\ R Se A ) /\
                        ( F Fn A /\
                          A. y e. A ( F ` y ) =
                                    ( H ` ( F |` Pred ( R , A , y ) ) ) ) /\
                     ( G Fn A /\
                       A. y e. A ( G ` y ) =
                                 ( H ` ( G |` Pred ( R , A , y ) ) ) ) )
                   -> F = G ) $=
      ( vz vw wa cv cfv cres wceq wral wi fveq2 eqeq12d fveq2d syl com12 r19.26
      wwe wse wfn w3a imbi2d wcel nfv ra5 predeq3 reseq2d anbi12d rspcva wss wb
      cpred predss fvreseq mpan2 biimpar eqcomd eqtr3 expimpd exp3a com23 imp3a
      ancoms ex a2d syl5 wfis2g r19.21v sylib sylan2br an4s 3impib eqid eqfnfv2
      jctil ad2ant2r 3adant1 mpbird ) BCUBBCUCIZDBUDZAJZDKZDBCWEUPZLZFKZMZABNZI
      ZEBUDZWEEKZEWGLZFKZMZABNZIZUEZDEMZBBMZGJZDKZXCEKZMZGBNZIZWTXGXBWCWLWSXGWL
      WSIWCXGWDWMWKWRWCXGOZWKWRIWDWMIZWJWQIZABNZXIWJWQABUAWCXJXLIZXGWCXMXFOZGBN
      XMXGOXNXMHJZDKZXOEKZMZOZGHBCXCXOMZXFXRXMXTXDXPXEXQXCXODPXCXOEPQUFXSHBCXCU
      PZNXMXRHYANZOXCBUGZXNXMXRHYAXMHUHUIYCXMYBXFYCXJXLYBXFOZYCXLXJYDYCXLXJYDOZ
      YCXLIXDDYALZFKZMZXEEYALZFKZMZIZYEXKYLAXCBWEXCMZWJYHWQYKYMWFXDWIYGWEXCDPYM
      WHYFFYMWGYADBCWEXCUJZUKRQYMWNXEWPYJWEXCEPYMWOYIFYMWGYAEYNUKRQULUMYLXJYBXF
      XJYBIZYLXFYOYJYGMZYLXFOYOYIYFFYOYFYIXJYFYIMZYBXJYABUNYQYBUOBCXCUQHBYADEUR
      USUTVARYPYHYKXFYPYHIXDYJMZYKXFOYHYPYRXDYJYGVBVGYRYKXFXDXEYJVBVHSVCSTVDSVH
      VEVFVIVJVKXMXFGBVLVMTVNVOTVPBVQVSWLWSXAXHUOZWCWDWMYSWKWRGBBDEVRVTWAWB $.
  $}

  ${
    $d A f g w x y z $.  $d F f g w x y z $.  $d R f g w x y z $.
    wfrlem1.1 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x ) /\
                                  A. y e. x ( f ` y ) =
                                            ( F ` ( f |` Pred ( R , A , y ) ) )
                                ) } $.
    $( Lemma for well-founded recursion.  The final item we are interested in
       is the union of acceptable functions ` B ` .  This lemma just changes
       bound variables for later use.  (Contributed by Scott Fenton,
       21-Apr-2011.) $)
    wfrlem1 $p |- B = { g |
                         E. z ( g Fn z /\
                                  ( z C_ A /\
                                    A. w e. z Pred ( R , A , w ) C_ z ) /\
                                  A. w e. z ( g ` w ) =
                                            ( F ` ( g |` Pred ( R , A , w ) ) )
                                ) } $=
      ( cv wfn wss wral cfv cres wceq w3a wex cpred cab weq fneq1 reseq1 fveq2d
      fveq1 eqeq12d ralbidv 3anbi13d exbidv fneq2 sseq1 sseq2 raleqbi1dv sseq1d
      predeq3 cbvralv syl6bb anbi12d raleq fveq2 reseq2d 3anbi123d cbvexv eqtri
      wa cbvabv ) FHLZALZMZVJENZEGBLZUAZVJNZBVJOZVGZVMVIPZVIVNQZJPZRZBVJOZSZATZ
      HUBILZCLZMZWFENZEGDLZUAZWFNZDWFOZVGZWIWEPZWEWJQZJPZRZDWFOZSZCTZIUBKWDWTHI
      HIUCZWDWEVJMZVQVMWEPZWEVNQZJPZRZBVJOZSZATWTXAWCXHAXAVKXBWBXGVQVJVIWEUDXAW
      AXFBVJXAVRXCVTXEVMVIWEUGXAVSXDJVIWEVNUEUFUHUIUJUKXHWSACACUCZXBWGVQWMXGWRV
      JWFWEULXIVLWHVPWLVJWFEUMXIVPVNWFNZBWFOWLVOXJBVJWFVJWFVNUNUOXJWKBDWFBDUCZV
      NWJWFEGVMWIUQZUPURUSUTXIXGXFBWFOWRXFBVJWFVAXFWQBDWFXKXCWNXEWPVMWIWEVBXKXD
      WOJXKVNWJWEXLVCUFUHURUSVDVEUSVHVF $.

    $( Lemma for well-founded recursion.  An acceptable function is a
       function.  (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem2 $p |- ( g e. B -> Fun g ) $=
      ( vz vw cv wcel wfn wss cpred wral wa cfv cres wceq w3a wex wfrlem1 fnfun
      wfun abeq2i 3ad2ant1 exlimiv sylbi ) GLZDMUKJLZNZULCOCEKLZPZULOKULQRZUNUK
      SUKUOTHSUAKULQZUBZJUCZUKUFZUSGDABJKCDEFGHIUDUGURUTJUMUPUTUQULUKUEUHUIUJ
      $.

    $( Lemma for well-founded recursion.  An acceptable function's domain is a
       subset of ` A ` .  (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem3 $p |- ( g e. B -> dom g C_ A ) $=
      ( vz vw cv wcel wfn wss cpred wral wa cfv cres w3a wex cdm wfrlem1 abeq2i
      wceq fndm sseq1d biimpar adantrr 3adant3 exlimiv sylbi ) GLZDMUNJLZNZUOCO
      ZCEKLZPZUOOKUOQZRZURUNSUNUSTHSUFKUOQZUAZJUBZUNUCZCOZVDGDABJKCDEFGHIUDUEVC
      VFJUPVAVFVBUPUQVFUTUPVFUQUPVEUOCUOUNUGUHUIUJUKULUM $.

  $}

  ${
    $d A a b c f g h x y $.  $d B a $.  $d F a b c f g h x y $.
    $d R a b c f g h x y $.
    wfrlem4.1 $e |- R We A $.
    wfrlem4.2 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x ) /\
                                  A. y e. x ( f ` y ) =
                                            ( F ` ( f |` Pred ( R , A , y ) ) )
                                ) } $.
    $( Lemma for well-founded recursion.  Properties of the restriction of an
       acceptable function to the domain of another one.  (Contributed by Scott
       Fenton, 21-Apr-2011.) $)
    wfrlem4 $p |- ( ( g e. B /\ h e. B ) ->
                     ( ( g |` ( dom g i^i dom h ) ) Fn ( dom g i^i dom h ) /\
                       A. a e. ( dom g i^i dom h )
                        ( ( g |` ( dom g i^i dom h ) ) ` a ) =
                        ( F `
                          ( ( g |` ( dom g i^i dom h ) ) |`
                              Pred ( R , ( dom g i^i dom h ) , a ) ) ) ) ) $=
      ( vb vc wcel wa cfv wceq wral wss cv cdm cin cres wfn cpred wfrlem2 funfn
      wfun sylib fnresin1 syl adantr inss1 sseli w3a wex wi wfrlem1 abeq2i fndm
      raleqdv biimpar rsp 3adant2 exlimiv sylbi imp adantlr fvres adantl resres
      syl5 predss sseqin2 mpbi 3an6 2exbii eeanv bitri ssinss1 ad2antrr syl5com
      nfra1 nfan inss2 anim12d biimpi syl6com ralrimi ad2ant2l jca wb ineqan12d
      ssin sseq1 sseq2 raleqbi1dv anbi12d imbi2d mpbiri 3adant3 exlimivv sylbir
      syl2anb simpr preddowncl sylc syl5eq reseq2d fveq2d 3eqtr4d ralrimiva ) G
      UAZDOZHUAZDOZPZXNXNUBZXPUBZUCZUDZYAUEZJUAZYBQZYBYAEYDUFZUDZIQZRZJYASXOYCX
      QXOXNXSUEZYCXOXNUIYJABCDEFGILUGXNUHUJXSXTXNUKULUMXRYIJYAXRYDYAOZPZYDXNQZX
      NCEYDUFZUDZIQZYEYHXOYKYMYPRZXQXOYKYQYKYDXSOZXOYQYAXSYDXSXTUNUOXOXNMUAZUEZ
      YSCTZYNYSTZJYSSZPZYQJYSSZUPZMUQZYRYQURZUUGGDABMJCDEFGILUSUTZUUFUUHMYTUUEU
      UHUUDYTUUEPYQJXSSZUUHYTUUJUUEYTYQJXSYSYSXNVAZVBVCYQJXSVDULVEVFVGVMVHVIYKY
      EYMRXRYDYAXNVJVKYLYGYOIYLYGXNYAYFUCZUDYOXNYAYFVLYLUULYNXNYLUULYFYNYFYATUU
      LYFRYAEYDVNYFYAVOVPYLYACTZYNYATZJYASZPZYKYFYNRXRUUPYKXOUUGXPNUAZUEZUUQCTZ
      YNUUQTZJUUQSZPZYDXPQXPYNUDIQRJUUQSZUPZNUQZUUPXQUUIUVEHDABNJCDEFHILUSUTUUG
      UVEPZYTUURPZUUDUVBPZUUEUVCPZUPZNUQMUQZUUPUVKUUFUVDPZNUQMUQUVFUVJUVLMNYTUU
      RUUDUVBUUEUVCVQVRUUFUVDMNVSVTUVJUUPMNUVGUVHUUPUVIUVGUVHUUPUVGUVHUUPURZUVH
      YSUUQUCZCTZYNUVNTZJUVNSZPZURZUVHUVOUVQUUAUVOUUCUVBYSUUQCWAWBUUCUVAUVQUUAU
      USUUCUVAPZUVPJUVNUUCUVAJUUBJYSWDUUTJUUQWDWEYDUVNOZUVTUUBUUTPZUVPUWAUUCUUB
      UVAUUTUWAYDYSOUUCUUBUVNYSYDYSUUQUNUOUUBJYSVDWCUWAYDUUQOUVAUUTUVNUUQYDYSUU
      QWFUOUUTJUUQVDWCWGUWBUVPYNYSUUQWOWHWIWJWKWLUVGYAUVNRZUVMUVSWMYTUURXSYSXTU
      UQUUKUUQXPVAWNUWCUUPUVRUVHUWCUUMUVOUUOUVQYAUVNCWPUUNUVPJYAUVNYAUVNYNWQWRW
      SWTULXAVHXBXCXDXEUMXRYKXFJCYAEYDXGXHXIXJXIXKXLXMWL $.
  $}

  ${
    $d A a f g h x y $.  $d B a $.  $d F a f g h x y $.  $d R a f g h x y $.
    $d g h u v x $.
    wfrlem5.1 $e |- R We A $.
    wfrlem5.2 $e |- R Se A $.
    wfrlem5.3 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x ) /\
                                  A. y e. x ( f ` y ) =
                                            ( F ` ( f |` Pred ( R , A , y ) ) )
                                ) } $.
    $( Lemma for well-founded recursion.  The values of two acceptable
       functions agree within their domains.  (Contributed by Scott Fenton,
       21-Apr-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    wfrlem5 $p |- ( ( g e. B /\ h e. B ) ->
                     ( ( x g u /\ x h v ) -> u = v ) ) $=
      ( va cv wa cres wceq cfv wbr cdm cin wcel vex breldm anim12i elin anandir
      sylibr brres anbi12i bitr4i biimpi mpdan wwe wse wfn wral wfrlem3 ssinss1
      cpred wss wess mpi sess2 3syl adantr wfrlem4 ancoms reseq2i fneq1i fneq2i
      incom bitri fveq1i predeq2 ax-mp reseq12i fveq2i eqeq12i raleqbii syl3anc
      jca wfr3g breqd biimprd wi wfun wal wfrlem2 funres wrel dffun2 simprbi sp
      sps 4syl sylan2d syl5 ) APZDPZIPZUAZXACPZJPZUAZQZXAXBXCXCUBZXFUBZUCZRZUAZ
      XAXEXFXKRZUAZQZXCFUDZXFFUDZQZXBXESZXHXAXKUDZXPXHXAXIUDZXAXJUDZQYAXDYBXGYC
      XAXBXCAUEZDUEZUFXAXEXFYDCUEZUFUGXAXIXJUHUJXHYAQZXPYGXDYAQZXGYAQZQXPXDXGYA
      UIXMYHXOYIXAXBXCXKYEUKXAXEXFXKYFUKULUMUNUOXSXOXAXEXLUAZXMXTXSYJXOXSXLXNXA
      XEXSXKGUPZXKGUQZQZXLXKUROPZXLTXLXKGYNVBZRKTSOXKUSQXNXKURZYNXNTZXNYORZKTZS
      ZOXKUSZQZXLXNSXQYMXRXQXIEVCXKEVCZYMABEFGHIKNUTXIXJEVAUUCYKYLUUCEGUPYKLXKE
      GVDVEUUCEGUQYLMXKEGVFVEWDVGVHABEFGHIJKOLNVIXSXFXJXIUCZRZUUDURZYNUUETZUUEU
      UDGYNVBZRZKTZSZOUUDUSZQZUUBXRXQUUMABEFGHJIKOLNVIVJYPUUFUUAUULYPUUEXKURUUF
      XKXNUUEXKUUDXFXIXJVNZVKZVLXKUUDUUEUUNVMVOYTUUKOXKUUDUUNYQUUGYSUUJYNXNUUEU
      UOVPYRUUIKXNUUEYOUUHUUOXKUUDSYOUUHSUUNXKUUDGYNVQVRVSVTWAWBULUJOXKGXLXNKWE
      WCWFWGXQXMYJQXTWHZXRXQXCWIXLWIZUUPCWJZDWJZAWJZUUPABEFGHIKNWKXKXCWLUUQXLWM
      UUTADCXLWNWOUUSUUPAUURUUPDUUPCWPWQWQWRVHWSWT $.
  $}

  ${
    $d A f g w x y z $.  $d R f g w x y z $.  $d G f g w x y z $.
    $d X f g w x y z $.
    wfrlem6.1 $e |- F = wrecs ( R , A , G ) $.
    $( Lemma for well-founded recursion.  The definition generates a
       relationship.  (Contributed by Scott Fenton, 8-Jun-2018.) $)
    wfrlem6 $p |- Rel F $=
      ( vf vx vy vg wrel cv wfn wss cpred wral wa cfv cres wceq w3a cuni reluni
      wex cab wcel wfun wfrlem2 funrel syl mprgbir cwrecs df-wrecs eqtri releqi
      eqid mpbir ) CJFKZGKZLURAMABHKZNZURMHUROPUSUQQUQUTRDQSHUROTGUCFUDZUAZJZVC
      IKZJZIVAIVAUBVDVAUEVDUFVEGHAVABFIDVAUOUGVDUHUIUJCVBCABDUKVBEGHABFDULUMUNU
      P $.

    $( Lemma for well-founded recursion.  The domain of ` F ` is a subclass of
       ` A ` .  (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem7 $p |- dom F C_ A $=
      ( vg vf vx vy cdm cv wfn wss cpred wral wa cfv cres wceq eqtri w3a cwrecs
      wex cab ciun cuni df-wrecs dmeqi dmuni iunss eqid wfrlem3 mprgbir eqsstri
      ) CJZFGKZHKZLUQAMABIKZNZUQMIUQOPURUPQUPUSRDQSIUQOUAHUCGUDZFKJZUEZAUOUTUFZ
      JVBCVCCABDUBVCEHIABGDUGTUHFUTUITVBAMVAAMFUTFUTVAAUJHIAUTBGFDUTUKULUMUN $.

    $( Lemma for well-founded recursion.  Compute the prececessor class for an
       ` R ` minimal element of ` ( A \ dom F ) ` .  (Contributed by Scott
       Fenton, 21-Apr-2011.) $)
    wfrlem8 $p |- ( Pred ( R , ( A \ dom F ) , X ) = (/) <->
                   Pred ( R , A , X ) = Pred ( R , dom F , X ) ) $=
      ( cpred cdm wss wa cdif c0 wceq wfrlem7 predpredss biantru preddif eqeq1i
      ax-mp ssdif0 bitr4i eqss 3bitr4i ) ABEGZCHZBEGZIZUGUFUDIZJAUEKBEGZLMZUDUF
      MUHUGUEAIUHABCDFNUEABEOSPUJUDUFKZLMUGUIUKLAUEBEQRUDUFTUAUDUFUBUC $.

    $( Lemma for well-founded recursion.  If ` X e. dom F ` , then its
       predecessor class is a subset of ` dom F ` .  (Contributed by Scott
       Fenton, 21-Apr-2011.) $)
    wfrlem9 $p |- ( X e. dom F -> Pred ( R , A , X ) C_ dom F ) $=
      ( vg vf vx vy vz vw cdm wcel cpred cv wss wral wa cfv cres wceq ciun wrex
      wfn w3a wex cab cuni cwrecs df-wrecs eqtri dmeqi dmuni eleq2i eliun bitri
      wi eqid wfrlem1 abeq2i predeq3 sseq1d rspccv adantl wb fndm eleq2d sseq2d
      imbi12d adantr mpbird adantrl 3adant3 exlimiv sylbi reximia syl syl6sseqr
      ssiun ) ECMZNZABEOZGHPZIPZUEWEAQABJPZOZWEQJWERSWFWDTWDWGUADTUBJWERUFIUGHU
      HZGPZMZUCZWAWBEWJNZGWHUDZWCWKQZWBEWKNWMWAWKEWAWHUIZMWKCWOCABDUJWOFIJABHDU
      KULUMGWHUNULZUOGEWHWJUPUQWMWCWJQZGWHUDWNWLWQGWHWIWHNWIKPZUEZWRAQZABLPZOZW
      RQZLWRRZSZXAWITWIXBUADTUBLWRRZUFZKUGZWLWQURZXHGWHIJKLAWHBHGDWHUSUTVAXGXIK
      WSXEXIXFWSXDXIWTWSXDSXIEWRNZWCWRQZURZXDXLWSXCXKLEWRXAEUBXBWCWRABXAEVBVCVD
      VEWSXIXLVFXDWSWLXJWQXKWSWJWREWRWIVGZVHWSWJWRWCXMVIVJVKVLVMVNVOVPVQGWHWJWC
      VTVRVPWPVS $.


  $}

  ${
    $d A f w x y z $.  $d F w $.  $d G f x y $.  $d R f w x y $.
    wfrlem10.1 $e |- R We A $.
    wfrlem10.2 $e |- F = wrecs ( R , A , G ) $.
    $( Lemma for well-founded recursion.  When ` z ` is an ` R ` minimal
       element of ` ( A \ dom F ) ` , then its predecessor class is equal to
       ` dom F ` .  (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem10 $p |- ( ( z e. ( A \ dom F ) /\
                     Pred ( R , ( A \ dom F ) , z ) = (/) ) ->
                   Pred ( R , A , z ) = dom F ) $=
      ( vw cv cpred wceq wcel wss wa wbr wn wb ax-mp cvv vex cdm cdif c0 biimpi
      wfrlem8 predss a1i simpr weq eldifn eleq1 notbid syl5ibrcom con2d wfrlem9
      imp adantl wi ssel con3d syl5com adantr eldifi elpredg ancoms sylan mtbid
      mpd w3o wfrlem7 sseli wor wwe weso solin syl2anr ecase23d elpred sylanbrc
      mpan ex ssrdv eqssd sylan9eqr ) BDUAZUBZCAIZJUCKZWGWFLZBCWGJZWECWGJZWEWHW
      JWKKBCDEWGGUEUDWIWKWEWKWEMWIWECWGUFUGWIHWEWKWIHIZWELZWLWKLZWIWMNZWMWLWGCO
      ZWNWIWMUHWOWPHAUIZWGWLCOZWIWMWQPWIWQWMWIWMPWQWGWELZPZWGBWEUJZWQWMWSWLWGWE
      UKULUMUNUPWOWGBCWLJZLZWRWOXBWEMZXCPZWMXDWIBCDEWLGUOUQWIXDXEURWMWIWTXDXEXA
      XDXCWSXBWEWGUSUTVAVBVHWIWGBLZWMXCWRQZWGBWEVCZWMXFXGBWECWLWGVDVEVFVGWMWLBL
      ZXFWPWQWRVIZWIWEBWLBCDEGVJVKXHBCVLZXIXFNXJBCVMXKFBCVNRBWLWGCVOVTVPVQWGSLW
      NWMWPNQATWESCWGWLHTVRRVSWAWBWCWD $.
  $}


  ${
    $d A f g h u v x y z $.  $d B g h $.  $d F u v x z $.  $d G f g h x y z $.
    $d R f g h x y z $.
    wfrlem11.1 $e |- R We A $.
    wfrlem11.2 $e |- R Se A $.
    wfrlem11.3 $e |- F = wrecs ( R , A , G ) $.
    $( Lemma for well-founded recursion.  The union of all acceptable functions
       is a function.  (Contributed by Scott Fenton, 21-Apr-2011.)  (Revised by
       Mario Carneiro, 26-Jun-2015.) $)
    wfrlem11 $p |- Fun F $=
      ( vx vu vv vg vf vy vh cv wbr wa wex wcel df-br wfun wrel weq wal wfrlem6
      wfn wss cpred wral cfv cres wceq w3a cab cop cwrecs df-wrecs eqtri eleq2i
      wi cuni eluni bitri anbi1i exbii 3bitr4i anbi12i eeanv bitr4i eqid impcom
      wfrlem5 an4s exlimivv sylbi ax-gen gen2 dffun2 mpbir2an ) CUACUBHOZIOZCPZ
      VTJOZCPZQZIJUCZUTZJUDZIUDHUDABCDGUEWHHIWGJWEVTWAKOZPZWILOZVTUFVTAUGABMOZU
      HZVTUGMVTUIQWLWKUJWKWMUKDUJULMVTUIUMHRLUNZSZQZVTWCNOZPZWQWNSZQZQZNRKRZWFW
      EWPKRZWTNRZQXBWBXCWDXDVTWAUOZCSZXEWISZWOQZKRZWBXCXFXEWNVAZSXICXJXECABDUPX
      JGHMABLDUQURZUSKXEWNVBVCVTWACTWPXHKWJXGWOVTWAWITVDVEVFVTWCUOZCSZXLWQSZWSQ
      ZNRZWDXDXMXLXJSXPCXJXLXKUSNXLWNVBVCVTWCCTWTXONWRXNWSVTWCWQTVDVEVFVGWPWTKN
      VHVIXAWFKNWJWRWOWSWFWOWSQWJWRQWFHMJIAWNBLKNDEFWNVJVLVKVMVNVOVPVQHIJCVRVS
      $.

    ${
      $d F f $.
      $( Lemma for well-founded recursion.  Here, we compute the value of the
         recursive definition generator.  (Contributed by Scott Fenton,
         21-Apr-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
      wfrlem12 $p |- ( y e. dom F ->
                    ( F ` y ) = ( G ` ( F |` Pred ( R , A , y ) ) ) ) $=
        ( vz vf vx cv cdm wcel wex cfv wceq wss wa wi cop cpred cres eldm2 wral
        vex wfn w3a cab cuni cwrecs df-wrecs eqtri eleq2i eluniab bitri elssuni
        abid syl6sseqr sylbir wel fnop ex rsp impcom fndm sseq2d eleq2d anbi12d
        biimprd exp3a wfun wfrlem11 funssfv 3adant3l fun2ssres 3adant3r eqeq12d
        fveq2d mp3an1 expcom com23 syl6com com34 sylcom adantl com14 syl7 exp4a
        pm2.43d syld com12 3impd exlimdv mpdi imp exlimiv sylbi ) ALZDMNWSILZUA
        ZDNZIOWSDPZDBCWSUBZUCZEPZQZIWSDAUFUDXBXGIXBXAJLZNZXHKLZUGZXJBRZXDXJRZAX
        JUEZSZWSXHPZXHXDUCZEPZQZAXJUEZUHZKOZSZJOZXGXBXAYBJUIZUJZNYDDYFXADBCEUKY
        FHKABCJEULUMZUNYBJXAUOUPYCXGJXIYBXGXIYBXHDRZXGYBXHYENZYHYBJURYIXHYFDXHY
        EUQYGUSUTXIYAYHXGTZKXIXKXOXTYJXKXIXOXTYJTTZXKXIAKVAZYKXKXIYLXJWSWTXHVBV
        CXKYLXTXOYJXKYLXTXOYJTZTXKYLYLXTYMYLXTSXSXKYLYMXTYLXSXSAXJVDVEXOYLXSXKY
        JXNYLXSXKYJTTZTXLXNYLXMYNXMAXJVDYLXMXKXSYJYLXMXKXSYJTZXMXKSYLXDXHMZRZWS
        YPNZSZYOXKXMYLYSTXKXMYLYSXKYSXMYLSXKYQXMYRYLXKYPXJXDXJXHVFZVGXKYPXJWSYT
        VHVIVJVKVEYSYHXSXGYHYSXSXGTZDVLZYHYSUUABCDEFGHVMUUBYHYSUHZXGXSUUCXCXPXF
        XRUUBYHYRXCXPQYQWSDXHVNVOUUCXEXQEUUBYHYQXEXQQYRXDDXHVPVQVSVRVJVTWAWBWCV
        KWDWEWFWGWHWIWJWDWKWLWMWNWOWPWQWRWQWR $.
    $}
  $}

  ${
    $d A f x y z $.  $d F f x y z $.  $d G f x y $.  $d R f x y z $.
    $d C f x y $.
    wfrlem13.1 $e |- R We A $.
    wfrlem13.2 $e |- R Se A $.
    wfrlem13.3 $e |- F = wrecs ( R , A , G ) $.
    wfrlem13.4 $e |- C = ( F u.
                      { <. z , ( G ` ( F |` Pred ( R , A , z ) ) ) >. } ) $.
    $( Lemma for well-founded recursion.  From here through ~ wfrlem16 , we aim
       to prove that ` dom F = A ` .  We do this by supposing that there is an
       element ` z ` of ` A ` that is not in ` dom F ` .  We then define ` C `
       by extending ` dom F ` with the appropriate value at ` z ` .  We then
       show that ` z ` cannot be an ` R ` minimal element of
       ` ( A \ dom F ) ` , meaning that ` ( A \ dom F ) ` must be empty, so
       ` dom F = A ` .  Here, we show that ` C ` is a function extending the
       domain of ` F ` by one.  (Contributed by Scott Fenton, 21-Apr-2011.)
       (Revised by Mario Carneiro, 26-Jun-2015.) $)
    wfrlem13 $p |- ( z e. ( A \ dom F ) -> C Fn ( dom F u. { z } ) ) $=
      ( cdm wcel csn cun wfun wceq wa wfn cin c0 cv cdif cpred cfv cop wfrlem11
      cres fvex funsn pm3.2i dmsnop ineq2i wn eldifn disjsn sylibr syl5eq funun
      vex sylancr dmun uneq2i eqtri jctir fneq1i df-fn bitri ) AUAZBEKZUBLZEVHE
      BDVHUCUGZFUDZUEMZNZOZVNKZVIVHMZNZPZQZCVRRZVJVOVSVJEOZVMOZQVIVMKZSZTPVOWBW
      CBDEFGHIUFVHVLAUSVKFUHZUIUJVJWEVIVQSZTWDVQVIVHVLWFUKZULVJVHVILUMWGTPVHBVI
      UNVIVHUOUPUQEVMURUTVPVIWDNVREVMVAWDVQVIWHVBVCVDWAVNVRRVTVRCVNJVEVNVRVFVGU
      P $.

    $( Lemma for well-founded recursion.  Compute the value of ` C ` .
       (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem14 $p |- ( z e. ( A \ dom F ) ->
                     ( y e. ( dom F u. { z } ) ->
                       ( C ` y ) = ( G ` ( C |` Pred ( R , A , y ) ) ) ) ) $=
      ( cv wcel csn cun cfv cres wceq ax-mp c0 cdm wfn cpred wi wfrlem13 weq wo
      cdif elun elsn orbi2i bitri wa wfrlem12 wfun fnfun wss cop ssun1 sseqtr4i
      w3a funssfv wfrlem9 fun2ssres syl3an3 fveq2d eqeq12d mp3an2 sylan syl5ibr
      wb ex pm2.43d vex snid elun2 reseq1i resundir wfr wefr predfrirr ressnop0
      wn wwe mp2b uneq2i eqtri 3eqtri fveq2i opeq2i opex elsnc eleqtrri fnopfvb
      un0 mpbir mpbiri mpan2 fveq2 predeq3 reseq2d syl5ibrcom jaod syl5bi syl )
      BLZCFUAZUHMDXGXFNZOZUBZALZXIMZXKDPZDCEXKUCZQZGPZRZUDBCDEFGHIJKUEXLXKXGMZA
      BUFZUGZXJXQXLXRXKXHMZUGXTXKXGXHUIYAXSXRAXFUJUKULXJXRXQXSXJXRXQXJXRXRXQUDX
      RXQXJXRUMXKFPZFXNQZGPZRZACEFGHIJUNXJDUOZXRXQYEVKZXIDUPYFFDUQZXRYGFFXFFCEX
      FUCZQZGPZURZNZOZDFYMUSKUTYFYHXRVAZXMYBXPYDXKDFVBYOXOYCGXRYFYHXNXGUQXOYCRC
      EFGXKJVCXNDFVDVEVFVGVHVIVJVLVMXJXQXSXFDPZDYIQZGPZRZXJXFXIMZYSXFXHMYTXFBVN
      VOXFXHXGVPSXJYTUMYSXFYRURZDMUUAYNDUUAYMMZUUAYNMUUBUUAYLRYRYKXFYQYJGYQYNYI
      QYJYMYIQZOZYJDYNYIKVQFYMYIVRUUDYJTOYJUUCTYJCEVSZXFYIMWCUUCTRCEWDUUEHCEVTS
      CEXFWAXFYKYIWBWEWFYJWOWGWHWIWJUUAYLXFYRWKWLWPUUAYMFVPSKWMXIXFYRDWNWQWRXSX
      MYPXPYRXKXFDWSXSXOYQGXSXNYIDCEXKXFWTXAVFVGXBXCXDXE $.

    $( Lemma for well-founded recursion.  When ` z ` is ` R ` minimal, ` C ` is
       an acceptable function.  (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem15 $p |- ( ( z e. ( A \ dom F ) /\
                       Pred ( R , ( A \ dom F ) , z ) = (/) ) ->
                     C e. { f | E. x ( f Fn x /\
                     ( x C_ A /\ A. y e. x Pred ( R , A , y ) C_ x ) /\
                     A. y e. x ( f ` y ) =
                     ( G ` ( f |` Pred ( R , A , y ) ) ) ) } ) $=
      ( cv wcel wceq wa wss wral cvv cdm cdif cpred c0 wfn cfv cres w3a wex cab
      csn cun wfrlem10 eldifi setlikespec sylancl adantr eqeltrrd snex wfrlem13
      wse unexg wfrlem7 snssd unss biimpi sylancr weq wo elun elsn orbi2i bitri
      wi wfrlem9 ssun3 syl ssun1 syl6eqss predeq3 sseq1d syl5ibrcom jaod syl5bi
      a1i ralrimiv jca wfrlem14 3jca fneq2 sseq1 sseq2 raleqbi1dv anbi12d raleq
      3anbi123d spcegv sylc mpan2 fnex sylan2 syl2anc fneq1 fveq1 reseq1 fveq2d
      wb eqeq12d ralbidv 3anbi13d exbidv elabg mpbird ) CNZDHUAZUBZOZXPFXNUCUDP
      ZQZEGNZANZUEZYADRZDFBNZUCZYARZBYASZQZYDXTUFZXTYEUGZIUFZPZBYASZUHZAUIZGUJO
      ZEYAUEZYHYDEUFZEYEUGZIUFZPZBYASZUHZAUIZXSXOXNUKZULZTOZEUUFUEZUUFDRZYEUUFR
      ZBUUFSZQZUUABUUFSZUHZUUDXSXOTOZUUETOZUUGXSDFXNUCZXOTCDFHIJLUMZXQUUQTOZXRX
      QXNDODFVAUUSXNDXOUNZKDFXNUOUPUQURZXNUSZXOUUETTVBZUPXSUUHUULUUMXQUUHXRCDEF
      HIJKLMUTUQZXSUUIUUKXQUUIXRXQXODRZUUEDRZUUIDFHILVCXQXNDUUTVDUVEUVFQUUIXOUU
      EDVEVFVGUQXSUUJBUUFYDUUFOZYDXOOZBCVHZVIZXSUUJUVGUVHYDUUEOZVIUVJYDXOUUEVJU
      VKUVIUVHBXNVKVLVMXSUVHUUJUVIUVHUUJVNXSUVHYEXORUUJDFHIYDLVOYEXOUUEVPVQWEXS
      UUJUVIUUQUUFRXSUUQXOUUFUURXOUUEVRVSUVIYEUUQUUFDFYDXNVTWAWBWCWDWFWGXQUUMXR
      XQUUABUUFBCDEFHIJKLMWHWFUQWIUUCUUNAUUFTYAUUFPZYQUUHYHUULUUBUUMYAUUFEWJUVL
      YCUUIYGUUKYAUUFDWKYFUUJBYAUUFYAUUFYEWLWMWNUUABYAUUFWOWPWQWRXSETOZYPUUDXGX
      SUUHUUOUVMUVDUVAUUOUUHUUGUVMUUOUUPUUGUVBUVCWSUUFTEWTXAXBYOUUDGETXTEPZYNUU
      CAUVNYBYQYMUUBYHYAXTEXCUVNYLUUABYAUVNYIYRYKYTYDXTEXDUVNYJYSIXTEYEXEXFXHXI
      XJXKXLVQXM $.

    $( Lemma for well-founded recursion.  If ` z ` is ` R ` minimal in
       ` ( A \ dom F ) ` , then ` C ` is acceptable and thus a subset of
       ` F ` , but ` dom C ` is bigger than ` dom F ` .  Thus, ` z ` cannot be
       minimal, so ` ( A \ dom F ) ` must be empty, and (due to ~ wfrlem7 ),
       ` dom F = A ` .  (Contributed by Scott Fenton, 21-Apr-2011.) $)
    wfrlem16 $p |- dom F = A $=
      ( vf vx vy cdm wss c0 wceq cv cpred wcel wfrlem7 cdif wrex eldifn csn cun
      ssun2 vex snid sselii cres cfv cop dmeqi dmun fvex dmsnop uneq2i eleqtrri
      wa 3eqtri wfn wral w3a wex cab wfrlem15 elssuni syl cwrecs df-wrecs eqtri
      cuni syl6sseqr dmss sseld mpi mtand nrex wn wne df-ne tz6.26i mpan sylbir
      difss mt3 ssdif0 mpbir eqssi ) ENZBBDEFIUABWKOBWKUBZPQZWMWLDARZSPQZAWLUCZ
      WOAWLWNWLTZWOWNWKTZWNBWKUDWQWOUTZWNCNZTWRWNWKWNUEZUFZWTXAXBWNXAWKUGWNAUHU
      IUJWTEWNEBDWNSUKZFULZUMUEZUFZNWKXENZUFXBCXFJUNEXEUOXGXAWKWNXDXCFUPUQURVAU
      SWSWTWKWNWSCEOWTWKOWSCKRZLRZVBXIBOBDMRZSZXIOMXIVCUTXJXHULXHXKUKFULQMXIVCV
      DLVEKVFZVMZEWSCXLTCXMOLMABCDKEFGHIJVGCXLVHVIEBDFVJXMILMBDKFVKVLVNCEVOVIVP
      VQVRVSWMVTWLPWAZWPWLPWBWLBOXNWPBWKWFABWLDGHWCWDWEWGBWKWHWIWJ $.

  $}

  ${
    $d A f x y z $.  $d F f x y z $.  $d G f x y $.  $d R f x y z $.
    wfr1.1 $e |- R We A $.
    wfr1.2 $e |- R Se A $.
    wfr1.3 $e |- F = wrecs ( R , A , G ) $.
    $( The Principle of Well-Founded Recursion, part 1 of 3.  We start with an
       arbitrary function ` G ` and a class of "acceptable" functions ` B ` .
       Then, using a base class ` A ` and a well-ordering ` R ` of ` A ` , we
       define a function ` F ` .  This function is said to be defined by
       "well-founded recursion."  The purpose of these three theorems is to
       demonstrate the properties of ` F ` .  We begin by showing that ` F ` is
       a function over ` A ` .  (Contributed by Scott Fenton, 22-Apr-2011.)
       (Revised by Mario Carneiro, 26-Jun-2015.) $)
    wfr1 $p |- F Fn A $=
      ( vz wfn wfun cdm wceq wfrlem11 cv cpred cres cfv cop csn cun eqid df-fn
      wfrlem16 mpbir2an ) CAICJCKALABCDEFGMHACHNZCABUEOPDQRSTZBCDEFGUFUAUCCAUBU
      D $.
  $}

  ${
    $d A f w x y $.  $d F f w x y $.  $d G f x y $.  $d R f w x y $.  $d X y $.
    wfr2.1 $e |- R We A $.
    wfr2.2 $e |- R Se A $.
    wfr2.3 $e |- F = wrecs ( R , A , G ) $.
    $( The Principle of Well-Founded Recursion, part 2 of 3.  Next, we show
       that the value of ` F ` at any ` z e. A ` is ` G ` recursively applied
       to all "previous" values of ` F ` .  (Contributed by Scott Fenton,
       18-Apr-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    wfr2 $p |- ( X e. A ->
                  ( F ` X ) = ( G ` ( F |` Pred ( R , A , X ) ) ) ) $=
      ( vy vw cv cfv cpred cres wceq fveq2 predeq3 reseq2d fveq2d wcel cdm eqid
      eqeq12d cop csn cun wfrlem16 eleq2i wfrlem12 sylbir vtoclga ) IKZCLZCABUL
      MZNZDLZOZECLZCABEMZNZDLZOIEAULEOZUMURUPVAULECPVBUOUTDVBUNUSCABULEQRSUCULA
      TULCUAZTUQVCAULJACJKZCABVDMNDLUDUEUFZBCDFGHVEUBUGUHIABCDFGHUIUJUK $.

  $}

  ${
    $d A f x y z $.  $d F f x y z $.  $d G f x y z $.  $d H x z $.
    $d R f x y z $.
    wfr3.1 $e |- R We A $.
    wfr3.2 $e |- R Se A $.
    wfr3.3 $e |- F = wrecs ( R , A , G ) $.
    $( The principle of Well-Founded Recursion, part 3 of 3.  Finally, we show
       that ` F ` is unique.  We do this by showing that any function ` H `
       with the same properties we proved of ` F ` in ~ wfr1 and ~ wfr2 is
       identical to ` F ` .  (Contributed by Scott Fenton, 18-Apr-2011.)
       (Revised by Mario Carneiro, 26-Jun-2015.) $)
    wfr3 $p |- ( ( H Fn A /\
                    A. z e. A ( H ` z ) =
                            ( G ` ( H |` Pred ( R , A , z ) ) ) ) ->
                  F = H ) $=
      ( wwe wse wa wfn cv cfv cpred cres wceq wral pm3.2i wfr1 wfr2 rgen wfr3g
      mp3an12 ) BCJZBCKZLDBMZANZDODBCUIPZQEORZABSZLFBMUIFOFUJQEORABSLDFRUFUGGHT
      UHULBCDEGHIUAUKABBCDEUIGHIUBUCTABCDFEUDUE $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Transfinite recursion via Well-founded recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d G f x y $.
    $( Lemma for deriving transfinite recursion from well-founded recursion.
       (Contributed by Scott Fenton, 22-Apr-2011.) $)
    tfrALTlem $p |- recs ( G ) = wrecs ( _E , On , G ) $=
      ( con0 cep cwrecs crecs wfn cfv cres wceq wral epweon epse eqid wfr1 wcel
      vy cv cpred wfr2 predon reseq2d fveq2d eqtrd rgen tfr3 mp2an eqcomi ) BCA
      DZAEZUHBFPQZUHGZUHUJHZAGZIZPBJUHUIIBCUHAKBLZUHMZNUNPBUJBOZUKUHBCUJRZHZAGU
      MBCUHAUJKUOUPSUQUSULAUQURUJUHUJTUAUBUCUDPUHUIAUIMUEUFUG $.
  $}

  ${
    $d B w $.  $d F f w x y $.  $d G f w x y $.  $d y z $.
    $( Let ` F ` be the union of all acceptable functions. $)
    tfrALT.1 $e |- F = recs ( G ) $.
    $( ~ tfr1 via well-founded recursion.  (Contributed by Scott Fenton,
       17-Aug-1994.)  (Revised by Mario Carneiro, 26-Jun-2015.)
       (Proof modification is discouraged.) $)
    tfr1ALT $p |- F Fn On $=
      ( con0 cep epweon epse crecs cwrecs tfrALTlem eqtri wfr1 ) DEABFDGABHDEBI
      CBJKL $.

    $( ~ tfr2 via well-founded recursion.  (Contributed by Scott Fenton,
       22-Apr-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.)
       (Proof modification is discouraged.) $)
    tfr2ALT $p |- ( z e. On -> ( F ` z ) = ( G ` ( F |` z ) ) ) $=
      ( cv con0 wcel cfv cep cpred cres epweon epse crecs cwrecs tfrALTlem wfr2
      eqtri predon reseq2d fveq2d eqtrd ) AEZFGZUCBHBFIUCJZKZCHBUCKZCHFIBCUCLFM
      BCNFICODCPRQUDUFUGCUDUEUCBUCSTUAUB $.

    ${
      $d B x $.
      $( ~ tfr3 via well-founded recursion.  (Contributed by Scott Fenton,
         22-Apr-2011.)  (Revised by Mario Carneiro, 26-Jun-2015.)
         (Proof modification is discouraged.) $)
      tfr3ALT $p |- ( ( B Fn On /\
               A. x e. On ( B ` x ) = ( G ` ( B |` x ) ) ) -> B = F ) $=
        ( cv cfv cres wceq con0 wral wfn cep cpred predon reseq2d fveq2d eqeq2d
        wcel ralbiia wa epweon epse crecs cwrecs tfrALTlem wfr3 eqcomd sylan2br
        eqtri ) AFZBGZBUKHZDGZIZAJKBJLZULBJMUKNZHZDGZIZAJKZBCIUTUOAJUKJSZUSUNUL
        VBURUMDVBUQUKBUKOPQRTUPVAUACBAJMCDBUBJUCCDUDJMDUEEDUFUJUGUHUI $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded zero, successor, and limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c wsuc WLim $.

  $( Declare the syntax for well-founded successor. $)
  cwsuc $a class wsuc ( R , A , X ) $.

  $( Declare the syntax for well-founded limit class. $)
  cwlim $a class WLim ( R , A ) $.

  ${
    $( Define the concept of a successor in a well-founded set.  (Contributed
       by Scott Fenton, 13-Jun-2018.) $)
    df-wsuc $a |- wsuc ( R , A , X ) =
             sup ( Pred ( `' R , A , X ) , A , `' R ) $.
  $}

  ${
    $d R x $.  $d A x $.
    $( Define the class of limit points of a well-founded set.  (Contributed by
       Scott Fenton, 15-Jun-2018.) $)
    df-wlim $a |- WLim ( R , A ) =
       { x e. A | ( x =/= sup ( A , A , `' R ) /\
           x = sup ( Pred ( R , A , x ) , A , R ) ) } $.
  $}


  $( Equality theorem for well-founded successor.  (Contributed by Scott
     Fenton, 13-Jun-2018.) $)
  wsuceq123 $p |- ( ( R = S /\ A = B /\ X = Y ) ->
     wsuc ( R , A , X ) = wsuc ( S , B , Y ) ) $=
    ( wceq w3a ccnv cpred csup cwsuc simp1 cnveqd simp2 simp3 predeq123 syl3anc
    supeq123d df-wsuc 3eqtr4g ) CDGZABGZEFGZHZACIZEJZAUFKBDIZFJZBUHKACELBDFLUEU
    GAUFUIBUHUEUFUHGUCUDUGUIGUECDUBUCUDMNZUBUCUDOZUBUCUDPABUFUHEFQRUKUJSACETBDF
    TUA $.

  $( Equality theorem for well-founded successor.  (Contributed by Scott
     Fenton, 13-Jun-2018.) $)
  wsuceq1 $p |- ( R = S -> wsuc ( R , A , X ) = wsuc ( S , A , X ) ) $=
    ( wceq cwsuc eqid wsuceq123 mp3an23 ) BCEAAEDDEABDFACDFEAGDGAABCDDHI $.

  $( Equality theorem for well-founded successor.  (Contributed by Scott
     Fenton, 13-Jun-2018.) $)
  wsuceq2 $p |- ( A = B -> wsuc ( R , A , X ) = wsuc ( R , B , X ) ) $=
    ( wceq cwsuc eqid wsuceq123 mp3an13 ) CCEABEDDEACDFBCDFECGDGABCCDDHI $.

  $( Equality theorem for well-founded successor.  (Contributed by Scott
     Fenton, 13-Jun-2018.) $)
  wsuceq3 $p |- ( X = Y -> wsuc ( R , A , X ) = wsuc ( R , A , Y ) ) $=
    ( wceq cwsuc eqid wsuceq123 mp3an12 ) BBEAAECDEABCFABDFEBGAGAABBCDHI $.

  ${
    nfwsuc.1 $e |- F/_ x R $.
    nfwsuc.2 $e |- F/_ x A $.
    nfwsuc.3 $e |- F/_ x X $.
    $( Bound-variable hypothesis builder for well-founded successor.
       (Contributed by Scott Fenton, 13-Jun-2018.) $)
    nfwsuc $p |- F/_ x wsuc ( R , A , X ) $=
      ( cwsuc ccnv cpred csup df-wsuc nfcnv nfpred nfsup nfcxfr ) ABCDHBCIZDJZB
      QKBCDLARBQABQDACEMZFGNFSOP $.
  $}

  ${
    $d R x $.  $d S x $.  $d A x $.  $d B x $.
    $( Equality theorem for the limit class.  (Contributed by Scott Fenton,
       15-Jun-2018.) $)
    wlimeq12 $p |- ( ( R = S /\ A = B ) ->
        WLim ( R , A ) = WLim ( S , B ) ) $=
      ( vx wceq wa ccnv csup wne cpred crab cwlim axia2 adantr supeq123d neeq2d
      cv cnveq df-wlim weq eqid predeq123 mp3an3 axia1 eqeq2d anbi12d rabeqbidv
      3eqtr4g ) CDFZABFZGZERZAACHZIZJZUMACUMKZACIZFZGZEALUMBBDHZIZJZUMBDUMKZBDI
      ZFZGZEBLACMBDMULUTVGEABUJUKNZULUPVCUSVFULUOVBUMULAAUNBBVAVHVHUJUNVAFUKCDS
      OPQULURVEUMULUQACVDBDUJUKEEUAUQVDFUMUBABCDUMUMUCUDVHUJUKUEPUFUGUHEACTEBDT
      UI $.
  $}

  $( Equality theorem for the limit class.  (Contributed by Scott Fenton,
     15-Jun-2018.) $)
  wlimeq1 $p |- ( R = S -> WLim ( R , A ) = WLim ( S , A ) ) $=
    ( wceq cwlim eqid wlimeq12 mpan2 ) BCDAADABEACEDAFAABCGH $.

  $( Equality theorem for the limit class.  (Contributed by Scott Fenton,
     15-Jun-2018.) $)
  wlimeq2 $p |- ( A = B -> WLim ( R , A ) = WLim ( R , B ) ) $=
    ( wceq cwlim eqid wlimeq12 mpan ) CCDABDACEBCEDCFABCCGH $.

  ${
    $d R y $.  $d A y $.  $d x y $.
    nfwlim.1 $e |- F/_ x R $.
    nfwlim.2 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for the limit class.  (Contributed by
       Scott Fenton, 15-Jun-2018.) $)
    nfwlim $p |- F/_ x WLim ( R , A ) $=
      ( vy cwlim cv ccnv csup wne cpred wceq crab df-wlim nfcv nfcnv nfsup nfne
      wa nfpred nfeq2 nfan nfrab nfcxfr ) ABCGFHZBBCIZJZKZUFBCUFLZBCJZMZTZFBNFB
      COUMAFBUIULAAUFUHAUFPZABBUGEEACDQRSAUFUKAUJBCABCUFDEUNUAEDRUBUCEUDUE $.
  $}

  ${
    $d R x $.  $d A x $.  $d X x $.
    $( Membership in the limit class.  (Contributed by Scott Fenton,
       15-Jun-2018.) $)
    elwlim $p |- ( X e. WLim ( R , A ) <-> ( X e. A /\
        X =/= sup ( A , A , `' R ) /\
        X = sup ( Pred ( R , A , X ) , A , R ) ) ) $=
      ( vx cwlim wcel ccnv csup wne cpred wceq wa neeq1 predeq3 supeq1d eqeq12d
      w3a cv id anbi12d df-wlim elrab2 3anass bitr4i ) CABEZFCAFZCAABGHZIZCABCJ
      ZABHZKZLZLUFUHUKQDRZUGIZUMABUMJZABHZKZLULDCAUEUMCKZUNUHUQUKUMCUGMURUMCUPU
      JURSURAUOUIBABUMCNOPTDABUAUBUFUHUKUCUD $.
  $}

  ${
    $d R x y z $.  $d A x y z $.
    $( The zero of a well-founded set is a member of that set.  (Contributed by
       Scott Fenton, 13-Jun-2018.) $)
    wzel $p |- ( ( R We A /\ R Se A /\ A =/= (/) ) ->
       sup ( A , A , `' R ) e. A ) $=
      ( vx vy vz c0 wor cv wrex wbr wn wral wi wcel wal cvv vex notbii 3imtr4g
      wa wwe wse wne w3a ccnv weso socnv syl 3ad2ant1 cpred wceq wss simp1 ssid
      simp2 a1i simp3 tz6.26 syl22anc pm2.27 ad2antll rspcev ex ad2antrl jctird
      breq2 elpred ax-mp imnan bitr4i brcnv anbi1i expr com23 alimdv eq0 r19.26
      wb df-ral bitr3i reximdva mpd supcl ) ABUAZABUBZAFUCZUDZCDEAABUEZWDWEAWHG
      ZWFWDABGWIABUFABUGUHUIWGABCHZUJZFUKZCAIZWJDHZWHJZKZDALWNWJWHJZWNEHZWHJZEA
      IZMZDALTZCAIWGWDWEAAULZWFWMWDWEWFUMWDWEWFUOXCWGAUNUPWDWEWFUQCAABURUSWGWLX
      BCAWGWJANZTZWNWKNZKZDOWNANZWPXATZMZDOZWLXBXEXGXJDXEXHXGXIWGXDXHXGXIMWGXDX
      HTTZXHWNWJBJZKZMZXNXATXGXIXLXOXNXAXHXOXNMWGXDXHXNUTVAXDXAWGXHXDWQWTWSWQEW
      JAWRWJWNWHVFVBVCVDVEXGXHXMTZKXOXFXPWJPNXFXPVRCQZAPBWJWNDQZVGVHRXHXMVIVJWP
      XNXAWOXMWJWNBXQXRVKRVLSVMVNVODWKVPXBXIDALXKWPXADAVQXIDAVSVTSWAWBWC $.
  $}

  ${
    $d A x y z w $.  $d ph x y $.  $d R x y z w $.  $d X x y z w $.
    wsuclem.1 $e |- ( ph -> R We A ) $.
    wsuclem.2 $e |- ( ph -> R Se A ) $.
    wsuclem.3 $e |- ( ph -> X e. V ) $.
    wsuclem.4 $e |- ( ph -> E. w e. A X R w ) $.
    $( Lemma for the supremum properties of well-founded successor.
       (Contributed by Scott Fenton, 15-Jun-2018.) $)
    wsuclem $p |- ( ph -> E. x e. A
         ( A. y e. Pred ( `' R , A , X ) -. x `' R y /\
           A. y e. A ( y `' R x ->
              E. z e. Pred ( `' R , A , X ) y `' R z ) ) ) $=
      ( cv c0 wrex wbr wa wcel syl ccnv cpred wceq wn wi wwe wse wss wne predss
      wral a1i crab dfpred3g cvv rabn0 wb brcnvg ancoms rexbidva syl5bb biimpar
      elex syl2anc eqnetrd tz6.26 syl22anc rexeqdv breq1 rexrab w3a noel simp2r
      eleq2d vex simp3 elpredg mtbid brcnv sylnibr 3expa ralrimiva expr simp1rl
      mtbiri simp1rr simp1l elpred breq2 rspcev 3expia anim12d ancomsd reximdva
      mpbir2and syl5bi sylbid mpd ) AFGUAZIUBZGBNZUBZOUCZBWTPZXACNZWSQZUDZCWTUK
      ZXEXAWSQZXEDNZWSQZDWTPZUEZCFUKZRZBFPZAFGUFFGUGWTFUHZWTOUIXDJKXQAFWSIUJULA
      WTENZIWSQZEFUMZOAIHSZWTXTUCLEFWSHIUNTAIUOSZIXRGQZEFPZXTOUIZAYAYBLIHVCTMYB
      YEYDYEXSEFPYBYDXSEFUPYBXSYCEFXRFSYBXSYCUQXRIFUOGURUSUTVAVBVDVEBFWTGVFVGAX
      DXCBXEIWSQZCFUMZPZXPAXCBWTYGAYAWTYGUCLCFWSHIUNTVHYHXAIWSQZXCRZBFPAXPYFYIX
      CBCFXEXAIWSVIVJAYJXOBFAXAFSZRZXCYIXOYLXCXHYIXNAYKXCXHAYKXCRZRXGCWTAYMXEWT
      SZXGAYMYNVKZXEXAGQZXFYOXEXBSZYPYOYQXEOSXEVLYOXBOXEAYKXCYNVMVNWEYOXAUOSZYN
      YQYPUQYRYOBVOZULAYMYNVPWTUOGXAXEVQVDVRXAXEGYSCVOVSVTWAWBWCAYKYIXNAYKYIRZR
      ZXMCFUUAXEFSZXIXLUUAUUBXIVKZXAWTSZXIXLUUCUUDYKYIYKYIAUUBXIWDYKYIAUUBXIWFU
      UCYAUUDYTUQUUCAYAAYTUUBXIWGLTFHWSIXAYSWHTWOUUAUUBXIVPXKXIDXAWTXJXAXEWSWIW
      JVDWKWBWCWLWMWNWPWQWR $.
  $}

  ${
    wsucex.1 $e |- ( ph -> R Or A ) $.
    $( Existence theorem for well-founded successor.  (Contributed by Scott
       Fenton, 16-Jun-2018.) $)
    wsucex $p |- ( ph -> wsuc ( R , A , X ) e. _V ) $=
      ( cwsuc ccnv cpred csup cvv df-wsuc wor socnv syl supexd syl5eqel ) ABCDF
      BCGZDHZBQIJBCDKABRQABCLBQLEBCMNOP $.
  $}

  ${
    $d R a b c y $.  $d A a b c y $.  $d X a b c y $.  $d ph a b $.
    wsuccl.1 $e |- ( ph -> R We A ) $.
    wsuccl.2 $e |- ( ph -> R Se A ) $.
    wsuccl.3 $e |- ( ph -> X e. V ) $.
    wsuccl.4 $e |- ( ph -> E. y e. A X R y ) $.
    $( If ` X ` is a set with an ` R ` successor in ` A ` , then its
       well-founded successor is a member of ` A ` .  (Contributed by Scott
       Fenton, 15-Jun-2018.) $)
    wsuccl $p |- ( ph -> wsuc ( R , A , X ) e. A ) $=
      ( va vb vc cwsuc ccnv cpred csup df-wsuc wwe wor weso socnv wsuclem supcl
      3syl syl5eqel ) ACDFNCDOZFPZCUGQCCDFRAKLMCUHUGACDSCDTCUGTGCDUACDUBUEAKLMB
      CDEFGHIJUCUDUF $.
  $}


  ${
    $d R a b c y $.  $d A a b c y $.  $d X a b c y $.  $d ph a b c $.
    $d Y y $.
    wsuclb.1 $e |- ( ph -> R We A ) $.
    wsuclb.2 $e |- ( ph -> R Se A ) $.
    wsuclb.3 $e |- ( ph -> X e. V ) $.
    wsuclb.4 $e |- ( ph -> Y e. A ) $.
    wsuclb.5 $e |- ( ph -> X R Y ) $.
    $( A well-founded successor is a lower bound on points after ` X ` .
       (Contributed by Scott Fenton, 16-Jun-2018.) $)
    wsuclb $p |- ( ph -> -. Y R wsuc ( R , A , X ) ) $=
      ( va vb vc vy wbr wcel wb brcnvg syl2anc cwsuc ccnv cpred csup wn elpredg
      mpbird wor wwe weso syl socnv wrex breq2 rspcev wsuclem supub mpd df-wsuc
      cv breq1i sylnibr cvv wsucex mtbid ) ABCEUAZFCUBZPZFVFCPZABVGEUCZBVGUDZFV
      GPZVHAFVJQZVLUEAVMFEVGPZAVNEFCPZKAFBQZEDQZVNVORJIFEBDCSTUGAVQVPVMVNRIJBDV
      GEFUFTUGALMNBVJFVGABCUHZBVGUHABCUIVRGBCUJUKZBCULUKALMNOBCDEGHIAVPVOEOUTZC
      PZOBUMJKWAVOOFBVTFECUNUOTUPUQURVFVKFVGBCEUSVAVBAVFVCQVPVHVIRABCEVSVDJVFFV
      CBCSTVE $.
  $}

  ${
    $d R x $.  $d A x $.
    $( The class of limit points is a subclass of the base class.  (Contributed
       by Scott Fenton, 16-Jun-2018.) $)
    wlimss $p |- WLim ( R , A ) C_ A $=
      ( vx cwlim cv ccnv csup wne cpred wceq wa crab df-wlim ssrab2 eqsstri ) A
      BDCEZAABFGHPABPIABGJKZCALACABMQCANO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Founded Recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A w y z $.  $d A x $.  $d F w y z $.  $d G w y z $.  $d H w y z $.
    $d R w y z $.  $d R x $.  $d x z $.
    $( Functions defined by founded recursion are identical up to relation,
       domain, and characteristic function.  General version of frr3
       (Contributed by Scott Fenton, 10-Feb-2011.)  (Revised by Mario Carneiro,
       26-Jun-2015.) $)
    frr3g $p |- ( ( ( R Fr A /\ R Se A ) /\
                     ( F Fn A /\
                       A. y e. A ( F ` y ) =
                                 ( y H ( F |` Pred ( R , A , y ) ) ) ) /\
                     ( G Fn A /\
                       A. y e. A ( G ` y ) =
                                 ( y H ( G |` Pred ( R , A , y ) ) ) ) )
                   -> F = G ) $=
      ( vz vw wa wfn cv cfv cres co wceq wral wi fveq2 eqeq12d syl wfr wse wcel
      cpred w3a nfv ra5 r19.26 anbi2i id predeq3 reseq2d oveq12d anbi12d rspcva
      wss wb predss fvreseq mpan2 biimpar oveq2d eqcomd eqtr3 com12 exp3a com23
      ex expimpd imp3a syl5bir a2d syl5 imbi2d frins2g rsp an4s 3impib ralrimiv
      com3r eqid jctil eqfnfv2 ad2ant2r 3adant1 mpbird ) BCUABCUBIZDBJZAKZDLZWI
      DBCWIUDZMZFNZOZABPZIZEBJZWIELZWIEWKMZFNZOZABPZIZUEZDEOZBBOZGKZDLZXGELZOZG
      BPZIZXDXKXFXDXJGBWGWPXCXGBUCZXJQZWPXCIWGXNWHWQWOXBWGXNQWGXMWHWQIZWOXBIZIZ
      XJWGXQXJQZGBPXMXRQXRXQHKZDLZXSELZOZQZGHBCYCHBCXGUDZPXQYBHYDPZQXMXRXQYBHYD
      XQHUFUGXMXQYEXJXQXOWNXAIZABPZIXMYEXJQZYGXPXOWNXAABUHUIXMXOYGYHXMYGXOYHXMY
      GXOYHQZXMYGIXHXGDYDMZFNZOZXIXGEYDMZFNZOZIZYIYFYPAXGBWIXGOZWNYLXAYOYQWJXHW
      MYKWIXGDRYQWIXGWLYJFYQUJZYQWKYDDBCWIXGUKZULUMSYQWRXIWTYNWIXGERYQWIXGWSYMF
      YRYQWKYDEYSULUMSUNUOYPXOYEXJXOYEIZYPXJYTYNYKOZYPXJQYTYKYNYTYJYMXGFXOYJYMO
      ZYEXOYDBUPUUBYEUQBCXGURHBYDDEUSUTVAVBVCUUAYLYOXJUUAYLIZXHYNOZYOXJQUUCYNXH
      YNXHYKVDVCUUDYOXJXHXIYNVDVHTVITVEVFTVHVGVJVKVLVMXGXSOZXJYBXQUUEXHXTXIYAXG
      XSDRXGXSERSVNVOXRGBVPTVTVQVEVRVSBWAWBWPXCXEXLUQZWGWHWQUUFWOXBGBBDEWCWDWEW
      F $.
  $}

  ${
    $d A f g w x y z $.  $d f G g w x y z $.  $d R f g w x y z $.
    frrlem1.1 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x /\
                                  A. y e. x ( f ` y ) =
                                            ( y G ( f |` Pred ( R , A , y ) ) )
                                 ) ) } $.
    $( Lemma for founded recursion.  The final item we are interested in is the
       union of acceptable functions ` B ` .  This lemma just changes bound
       variables for later use.  (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem1 $p |- B = { g |
                         E. z ( g Fn z /\
                                ( z C_ A /\
                                  A. w e. z Pred ( R , A , w ) C_ z /\
                                  A. w e. z ( g ` w ) =
                                            ( w G ( g |` Pred ( R , A , w ) ) )
                        ) ) } $=
      ( cv wfn wss wral cfv cres co wceq w3a cpred wa wex cab weq reseq1 oveq2d
      fneq1 fveq1 eqeq12d ralbidv 3anbi3d anbi12d exbidv fneq2 sseq1 raleqbi1dv
      sseq2 predeq3 sseq1d cbvralv syl6bb raleq fveq2 reseq2d oveq12d 3anbi123d
      id cbvexv cbvabv eqtri ) FHLZALZMZVMENZEGBLZUAZVMNZBVMOZVPVLPZVPVLVQQZJRZ
      SZBVMOZTZUBZAUCZHUDILZCLZMZWIENZEGDLZUAZWINZDWIOZWLWHPZWLWHWMQZJRZSZDWIOZ
      TZUBZCUCZIUDKWGXCHIHIUEZWGWHVMMZVOVSVPWHPZVPWHVQQZJRZSZBVMOZTZUBZAUCXCXDW
      FXLAXDVNXEWEXKVMVLWHUHXDWDXJVOVSXDWCXIBVMXDVTXFWBXHVPVLWHUIXDWAXGVPJVLWHV
      QUFUGUJUKULUMUNXLXBACACUEZXEWJXKXAVMWIWHUOXMVOWKVSWOXJWTVMWIEUPXMVSVQWINZ
      BWIOWOVRXNBVMWIVMWIVQURUQXNWNBDWIBDUEZVQWMWIEGVPWLUSZUTVAVBXMXJXIBWIOWTXI
      BVMWIVCXIWSBDWIXOXFWPXHWRVPWLWHVDXOVPWLXGWQJXOVHXOVQWMWHXPVEVFUJVAVBVGUMV
      IVBVJVK $.

    $( Lemma for founded recursion.  An acceptable function is a function.
       (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem2 $p |- ( g e. B -> Fun g ) $=
      ( vz vw cv wcel wfn wss cpred wral cfv cres co wceq w3a wa frrlem1 abeq2i
      wex wfun fnfun adantr exlimiv sylbi ) GLZDMULJLZNZUMCOCEKLZPZUMOKUMQUOULR
      UOULUPSHTUAKUMQUBZUCZJUFZULUGZUSGDABJKCDEFGHIUDUEURUTJUNUTUQUMULUHUIUJUK
      $.

    $( Lemma for founded recursion.  An acceptable function's domain is a
       subset of ` A ` .  (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem3 $p |- ( g e. B -> dom g C_ A ) $=
      ( vz vw cv wcel wfn wss cpred wral cfv cres wceq co w3a wa wex cdm abeq2i
      frrlem1 fndm simp1 sseq1 biimpar syl2an exlimiv sylbi ) GLZDMUOJLZNZUPCOZ
      CEKLZPZUPOKUPQZUSUORUSUOUTSHUATKUPQZUBZUCZJUDZUOUEZCOZVEGDABJKCDEFGHIUGUF
      VDVGJUQVFUPTZURVGVCUPUOUHURVAVBUIVHVGURVFUPCUJUKULUMUN $.
  $}

  ${
    $d A a f g $.  $d A a h x y $.  $d B a $.  $d f h x y $.  $d G a f g $.
    $d G h $.  $d G g x y $.  $d R a f g $.  $d R h x y $.  $d A a f g b c $.
    $d h x y b c $.  $d G b c $.  $d R b c $.
    frrlem4.1 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x /\
                                  A. y e. x ( f ` y ) =
                                            ( y G ( f |` Pred ( R , A , y ) ) )
                                 ) ) } $.
    $( Lemma for founded recursion.  Properties of the restriction of an
       acceptable function to the domain of another acceptable function.
       (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem4 $p |- ( ( g e. B /\ h e. B ) ->
       ( ( g |` ( dom g i^i dom h ) ) Fn ( dom g i^i dom h ) /\
         A. a e. ( dom g i^i dom h ) ( ( g |` ( dom g i^i dom h ) ) ` a ) =
            ( a G ( ( g |` ( dom g i^i dom h ) ) |`
                    Pred ( R , ( dom g i^i dom h ) , a ) ) ) ) ) $=
      ( vb vc cv wcel wa cres wceq wral wss cdm cin wfn cfv cpred co wfun funfn
      frrlem2 sylib fnresin1 syl adantr inss1 sseli w3a wex frrlem1 abeq2i fndm
      rsp 3ad2ant3 eleq2 imbi1d syl5ibrcom mpan9 exlimiv sylbi syl5 imp adantlr
      fvres adantl resres predss sseqin2 mpbi eeanv simpl1 ssinss1 simpl2 nfra1
      wi simpr2 nfan syl5com anim12d ssin biimpi syl6com ralrimi syl2anc ineq12
      inss2 wb sseq1d raleqbi1dv anbi12d syl2an biimprcd impcom exlimivv sylbir
      sseq2 an4s syl2anb simpr preddowncl sylc syl5eq reseq2d 3eqtr4d ralrimiva
      oveq2d jca ) GNZDOZHNZDOZPZXPXPUAZXRUAZUBZQZYCUCZJNZYDUDZYFYDYCEYFUEZQZIU
      FZRZJYCSXQYEXSXQXPYAUCZYEXQXPUGYLABCDEFGIKUIXPUHUJYAYBXPUKULUMXTYKJYCXTYF
      YCOZPZYFXPUDZYFXPCEYFUEZQZIUFZYGYJXQYMYOYRRZXSXQYMYSYMYFYAOZXQYSYCYAYFYAY
      BUNUOXQXPLNZUCZUUACTZYPUUATZJUUASZYSJUUASZUPZPZLUQZYTYSWCZUUIGDABLJCDEFGI
      KURUSZUUHUUJLUUBYAUUARZUUGUUJUUAXPUTZUUGUUJUULYFUUAOZYSWCZUUFUUCUUOUUEYSJ
      UUAVAVBUULYTUUNYSYAUUAYFVCVDVEVFVGVHVIVJVKYMYGYORXTYFYCXPVLVMYNYIYQYFIYNY
      IXPYCYHUBZQYQXPYCYHVNYNUUPYPXPYNUUPYHYPYHYCTUUPYHRYCEYFVOYHYCVPVQYNYCCTZY
      PYCTZJYCSZPZYMYHYPRXTUUTYMXQUUIXRMNZUCZUVACTZYPUVATZJUVASZYFXRUDYFXRYPQIU
      FRJUVASZUPZPZMUQZUUTXSUUKUVIHDABMJCDEFHIKURUSUUIUVIPUUHUVHPZMUQLUQUUTUUHU
      VHLMVRUVJUUTLMUUBUVBUUGUVGUUTUUGUVGPZUUBUVBPZUUTUVKUUAUVAUBZCTZYPUVMTZJUV
      MSZUVLUUTWCUVKUUCUVNUUCUUEUUFUVGVSUUAUVACVTULUVKUUEUVEUVPUUCUUEUUFUVGWAUU
      GUVCUVEUVFWDUUEUVEPZUVOJUVMUUEUVEJUUDJUUAWBUVDJUVAWBWEYFUVMOZUVQUUDUVDPZU
      VOUVRUUEUUDUVEUVDUVRUUNUUEUUDUVMUUAYFUUAUVAUNUOUUDJUUAVAWFUVRYFUVAOUVEUVD
      UVMUVAYFUUAUVAWNUOUVDJUVAVAWFWGUVSUVOYPUUAUVAWHWIWJWKWLUVLUUTUVNUVPPZUUBU
      ULYBUVARZUUTUVTWOUVBUUMUVAXRUTUULUWAPZUUQUVNUUSUVPUWBYCUVMCYAUUAYBUVAWMZW
      PUWBYCUVMRUUSUVPWOUWCUURUVOJYCUVMYCUVMYPXDWQULWRWSWTWLXAXEXBXCXFUMXTYMXGJ
      CYCEYFXHXIXJXKXJXNXLXMXO $.
  $}

  ${
    $d A f g $.  $d A h x y $.  $d f g $.  $d f h x y G $.  $d g G $.
    $d h G $.  $d u g v x $.  $d x G $.  $d y g G $.  $d u h v x $.  $d y h $.
    $d R f g $.  $d R h x y $.  $d v u x $.  $d A z $.  $d B z $.  $d C z $.
    $d f z $.  $d G z $.  $d R z $.  $d x z $.  $d y z $.  $d C g $.
    $d B g h u v $.  $d B x $.  $d A a $.  $d f h x y a $.  $d g a $.
    $d B a $.  $d G a $.  $d R a $.
    frrlem5.1 $e |- R Fr A $.
    frrlem5.2 $e |- R Se A $.
    frrlem5.3 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x /\
                                  A. y e. x ( f ` y ) =
                                            ( y G ( f |` Pred ( R , A , y ) ) )
                                 ) ) } $.
    $( Lemma for founded recursion.  The values of two acceptable functions
       agree within their domains.  (Contributed by Paul Chapman,
       21-Apr-2012.)  (Revised by Mario Carneiro, 26-Jun-2015.) $)
    frrlem5 $p |- ( ( g e. B /\ h e. B ) -> ( ( x g u /\ x h v )
             -> u = v ) ) $=
      ( va cv wbr wa cres wceq cdm cin wcel breldm anim12i sylibr anandir brres
      vex elin anbi12i bitr4i biimpi mpdan wfr wse wfn cfv cpred co wss frrlem3
      wral ssinss1 frss mpi sess2 jca 3syl adantr frrlem4 ancoms reseq2i fneq1i
      incom fneq2i bitri fveq1i predeq2 ax-mp reseq12i eqeq12i raleqbii syl3anc
      oveq2i frr3g breqd biimprd wi wfun wal frrlem2 funres wrel dffun2 simprbi
      sp sps 4syl sylan2d syl5 ) APZDPZIPZQZXBCPZJPZQZRZXBXCXDXDUAZXGUAZUBZSZQZ
      XBXFXGXLSZQZRZXDFUCZXGFUCZRZXCXFTZXIXBXLUCZXQXIXBXJUCZXBXKUCZRYBXEYCXHYDX
      BXCXDAUIZDUIZUDXBXFXGYECUIZUDUEXBXJXKUJUFXIYBRZXQYHXEYBRZXHYBRZRXQXEXHYBU
      GXNYIXPYJXBXCXDXLYFUHXBXFXGXLYGUHUKULUMUNXTXPXBXFXMQZXNYAXTYKXPXTXMXOXBXF
      XTXLGUOZXLGUPZRZXMXLUQOPZXMURYOXMXLGYOUSZSKUTTOXLVCRXOXLUQZYOXOURZYOXOYPS
      ZKUTZTZOXLVCZRZXMXOTXRYNXSXRXJEVAXLEVAZYNABEFGHIKNVBXJXKEVDUUDYLYMUUDEGUO
      YLLXLEGVEVFUUDEGUPYMMXLEGVGVFVHVIVJABEFGHIJKONVKXTXGXKXJUBZSZUUEUQZYOUUFU
      RZYOUUFUUEGYOUSZSZKUTZTZOUUEVCZRZUUCXSXRUUNABEFGHJIKONVKVLYQUUGUUBUUMYQUU
      FXLUQUUGXLXOUUFXLUUEXGXJXKVOZVMZVNXLUUEUUFUUOVPVQUUAUULOXLUUEUUOYRUUHYTUU
      KYOXOUUFUUPVRYSUUJYOKXOUUFYPUUIUUPXLUUETYPUUITUUOXLUUEGYOVSVTWAWEWBWCUKUF
      OXLGXMXOKWFWDWGWHXRXNYKRYAWIZXSXRXDWJXMWJZUUQCWKZDWKZAWKZUUQABEFGHIKNWLXL
      XDWMUURXMWNUVAADCXMWOWPUUTUUQAUUSUUQDUUQCWQWRWRWSVJWTXA $.

    $( Lemma for founded recursion.  The union of a subclass of ` B ` is a
       relationship.  (Contributed by Paul Chapman, 29-Apr-2012.) $)
    frrlem5b $p |- ( C C_ B -> Rel U. C ) $=
      ( vz wss cv wrel wral cuni wcel ssel wfun funrel syl syl6 ralrimiv reluni
      frrlem2 sylibr ) EDMZLNZOZLEPEQOUHUJLEUHUIERUIDRZUJEDUISUKUITUJABCDFGLHKU
      FUIUAUBUCUDLEUEUG $.

    $( Lemma for founded recursion.  The union of a subclass of ` B ` is a
       function.  (Contributed by Paul Chapman, 29-Apr-2012.) $)
    frrlem5c $p |- ( C C_ B -> Fun U. C ) $=
      ( vu vv vg vh cv wbr wa wcel wex wss cuni wfun uniss wrel weq wi wal ssid
      frrlem5b ax-mp cop eluni df-br anbi1i exbii 3bitr4i anbi12i eeanv frrlem5
      bitr4i impcom an4s exlimivv sylbi ax-gen gen2 dffun2 mpbir2an funss ee10
      ) EDUAEUBZDUBZUAVMUCZVLUCEDUDVNVMUEZAPZLPZVMQZVPMPZVMQZRZLMUFZUGZMUHZLUHA
      UHDDUAVODUIABCDDFGHIJKUJUKWDALWCMWAVPVQNPZQZWEDSZRZVPVSOPZQZWIDSZRZRZOTNT
      ZWBWAWHNTZWLOTZRWNVRWOVTWPVPVQULZVMSWQWESZWGRZNTVRWONWQDUMVPVQVMUNWHWSNWF
      WRWGVPVQWEUNUOUPUQVPVSULZVMSWTWISZWKRZOTVTWPOWTDUMVPVSVMUNWLXBOWJXAWKVPVS
      WIUNUOUPUQURWHWLNOUSVAWMWBNOWFWJWGWKWBWGWKRWFWJRWBABMLCDFGNOHIJKUTVBVCVDV
      EVFVGALMVMVHVIVLVMVJVK $.

    $( Lemma for founded recursion.  The domain of the union of a subset of
       ` B ` is a subset of ` A ` .  (Contributed by Paul Chapman,
       29-Apr-2012.) $)
    frrlem5d $p |- ( C C_ B -> dom U. C C_ A ) $=
      ( vg wss cuni cdm cv ciun dmuni wral wcel ssel syl6 ralrimiv iunss sylibr
      frrlem3 syl5eqss ) EDMZENOLELPZOZQZCLERUHUJCMZLESUKCMUHULLEUHUIETUIDTULED
      UIUAABCDFGLHKUFUBUCLEUJCUDUEUG $.

    ${
      $d A t w z $.  $d f t w z $.  $d G t w z $.  $d R t w z $.
      $d x y t w z $.  $d X t w z $.  $d C w $.
      $( Lemma for founded recursion.  The domain of the union of a subset of
         ` B ` is closed under predecessors.  (Contributed by Paul Chapman,
         1-May-2012.) $)
      frrlem5e $p |- ( C C_ B -> ( X e. dom U. C ->
                    Pred ( R , A , X ) C_ dom U. C ) ) $=
        ( vz vw vt cdm wcel wss wi wceq cuni wrex cpred ciun dmuni eleq2i eliun
        cv bitri wa ssel2 wfn wral cfv cres w3a wex frrlem1 abeq2i fndm predeq3
        co sseq1d rspccv 3ad2ant2 eleq2 sseq2 imbi12d syl5ibr syl exlimiv sylbi
        imp dmeq sseq2d rspcev ssiun syl6sseqr ex adantl syld rexlimdva syl5bi
        ) IEUAPZQZIMUHZPZQZMEUBZEDRZCFIUCZWDRZWEIMEWGUDZQWIWDWMIMEUEUFMIEWGUGUI
        WJWHWLMEWJWFEQZUJZWHWKWGRZWLWOWFDQZWHWPSZEDWFUKWQWFNUHZULZWSCRZCFOUHZUC
        ZWSRZOWSUMZXBWFUNXBWFXCUOHVBTOWSUMZUPZUJZNUQZWRXIMDABNOCDFGMHLURUSXHWRN
        WTXGWRWTWGWSTZXGWRSWSWFUTXGWRXJIWSQZWKWSRZSZXEXAXMXFXDXLOIWSXBITXCWKWSC
        FXBIVAVCVDVEXJWHXKWPXLWGWSIVFWGWSWKVGVHVIVJVMVKVLVJWNWPWLSWJWNWPWLWNWPU
        JZWKNEWSPZUDZWDXNWKXORZNEUBWKXPRXQWPNWFEWSWFTXOWGWKWSWFVNVOVPNEXOWKVQVJ
        NEUEVRVSVTWAWBWC $.
    $}

    $(
    @{ @d B f @. @d C f @. @d C x @.
    @( Lemma for founded recursion. Calculate the value of the union
       of a subset of ` B ` within its domain. @)
    frrlem5f @p |- ( C C_ B -> ( y e. dom U. C ->
       ( U. C ` y ) = ( y G ( U. C |` Pred ( R , A , y ) ) ) ) ) @=
      ( vz wss cv cop cuni wcel wex cfv cpred cres co wceq cdm wrex wi ssel
      wfn wral w3a wa imp3a exlimdv abeq2i syl5ibOLD syld rexlimdv eluni2
      vex eldm2 ) EDMZBNZLNOZEPZQZLRVBVDSVBVDCFVBTZUAHUBUCZVBVDUDQVAVEVGLVAV
      CGNZQZGEUEVGVEVAVIVGGEVAVHEQVHDQZVIVGUFZEDVHUGVAVHANZUHZVLCMVFVLMBVLUIVBV
      HSVBVHVFUAHUBUCBVLUIUJZUKZARZVKVJVAVOVKAVAVMVNVK?ULUMVPGDKUNUOUPUQGVCEURU
      OUMLVBVDBUSUTUO @.
      @( [12-May-2012] @) @( [2-May-2012] @)
    @}

    @{ @d A w @. @d f w @. @d g w @. @d G w @. @d g z @. @d H g @. @d H h @.
       @d H w @. @d H z @. @d R w @. @d w x @. @d w y @. @d w z @. @d X g @.
       @d X h @. @d X w @. @d X x @. @d X z @.
    @( Lemma for founded recursion. Extend the domain of a particular
       acceptable function by one. @)
    frrlem5g @p |- ( ( X e. A /\ H e. B /\ H Fn TrPred ( R , A , X ) ) ->
                     E. h e. B h Fn ( { X } u. TrPred ( R , A , X ) ) ) @=
      ( vz vw vg wcel ctrpred wfn w3a cres co cop csn cun cv wrex wss cpred
      wral cfv wceq wa wex wfun cdm cin c0 cvv ovex funsngOLD mpan2 3ad2ant1
      frrlem2 3ad2ant2 jca fndm ineq2d 3ad2ant3 wn wal wi eleq1 notbid
      trpredfrirr syl5cbirOLD elsn syl5ibOLD elin notbii pm4.63 con1bii bitri
      sylibr
      alrimiv eq0 eqtrd dmsnop ineq1i syl5eqOLD funun syl uneq2d dmun uneq1i
      eqtri df-fn snssi setlikespec trpredss unss sylib wo predeq3 sseq1d
      trpredpred trpredtr jaod imp elun orbi1i sylan2bOLD ssun4 ralrimiva 3jca
      snex trpredex unex fneq2 sseq1 sseq2 raleqbi1dv raleq 3anbi123d anbi12d
      spcev wb unexg mpan fneq1 fveq1 reseq1 oveq2d eqeq12d ralbidv 3anbi3d
      exbidv frrlem1 elab2g mpbird jctir simp3 fnun syl21anc rspcev syl2anc
      ) JCQZIDQZICEJRZSZTZJJIUUIUAZHUBZUCZUDZIUEZDQZUUPJUDZUUIUEZSZGUFZUUSSZGDU
      GUUKUUQUUPNUFZSZUVCCUHZCEOUFZUIZUVCUHZOUVCUJZUVFUUPUKZUVFUUPUVGUAZHUBZULZ
      OUVCUJZTZUMZNUNZUUKUUTUUSCUHZUVGUUSUHZOUUSUJZUVMOUUSUJZTZUMZUVQUUKUUTUWBU
      UKUUPUOZUUPUPZUUSULZUMUUTUUKUWDUWFUUKUUOUOZIUOZUMZUUOUPZIUPZUQZURULZUMUWD
      UUKUWIUWMUUKUWGUWHUUGUUHUWGUUJUUGUUMUSQUWGJUULHUTJUUMCUSVAVBVCZUUHUUGUWHU
      UJABCDEF?HMVDVEVFUUKUURUWKUQZURUWLUUKUWOUURUUIUQZURUUJUUGUWOUWPULUUHUUJUW
      KUUIUURUUIIVGZVHVIUUKUVCUWPQZVJZNVKZUWPURULZUUKUWSNUUKUVCUURQZUVCUUIQZVJZ
      VLZUWSUUKUVCJULZUXDUXBUXFUXDJUUIQZVJZUUKUXFUXCUXGUVCJUUIVMVNZUUGUUHUXHUUJ
      ACEJKLVOZVCVPNJVQZVRUWSUXBUXCUMZVJUXEUWRUXLUVCUURUUIVSVTUXEUXLUXBUXCWAWBW
      CZWDWENUWPWFZWDWGUWJUURUWKJUUMWHZWIWJVFUUOIWKWLUUJUUGUWFUUHUUJUURUWKUEZUU
      SUWEUUJUWKUUIUURUWQWMUWEUWJUWKUEUXPUUOIWNUWJUURUWKUXOWOWPWJVIVFUUPUUSWQWD
      UUKUVRUVTUWAUUGUUHUVRUUJUUGUURCUHZUUICUHZUMUVRUUGUXQUXRJCWRUUGCEJUIZUSQZU
      XRUUGCEAUFUIUSQACUJZUXTLACEJWSZVBCUSEJWTWLVFUURUUICXAXBVCUUGUUHUVTUUJUUGU
      VSOUUSUUGUVFUUSQZUMUVGUUIUHZUVSUUGUVFJULZUVFUUIQZXCZUYDUYCUUGUYGUYDUUGUYA
      UYGUYDVLLUUGUYAUMZUYEUYDUYFUYEUYDUXSUUIUHZUYHUYEUVGUXSUUICEUVFJXDXEUYHUXT
      UYIUYBCUSEJXFWLVPACEJUVFXGXHVBXIUYCUVFUURQZUYFXCUYGUVFUURUUIXJUYJUYEUYFOJ
      VQXKWCXLUVGUUIUURXMWLXNVC?XOVFUVPUWCNUUSUURUUIJXPCEJXQXRUVCUUSULZUVDUUTUV
      OUWBUVCUUSUUPXSUYKUVEUVRUVIUVTUVNUWAUVCUUSCXTUVHUVSOUVCUUSUVCUUSUVGYAYBUV
      MOUVCUUSYCYDYEYFWLUUKUUPUSQZUUQUVQYGUUHUUGUYLUUJUUOUSQUUHUYLUUNXPUUOIUSDY
      HYIVEPUFZUVCSZUVEUVIUVFUYMUKZUVFUYMUVGUAZHUBZULZOUVCUJZTZUMZNUNUVQPUUPDUS
      UYMUUPULZVUAUVPNVUBUYNUVDUYTUVOUVCUYMUUPYJVUBUYSUVNUVEUVIVUBUYRUVMOUVCVUB
      UYOUVJUYQUVLUVFUYMUUPYKVUBUYPUVKUVFHUYMUUPUVGYLYMYNYOYPYEYQABNOCDEFPHMYRY
      SWLYTUUKUUOUURSZUUJUXAUUTUUKUWGUWJUURULZUMVUCUUKUWGVUDUWNUXOUUAUUOUURWQWD
      UUGUUHUUJUUBUUGUUHUXAUUJUUGUWTUXAUUGUWSNUUGUXEUWSUUGUXFUXDUXBUXFUXDUXHUUG
      UXIUXJVPUXKVRUXMWDWEUXNWDVCUURUUIUUOIUUCUUDUVBUUTGUUPDUUSUVAUUPYJUUEUUF
      @.
      @( [12-May-2012] @) @( [5-May-2012] @)
    @}
    $)
  $}

  ${
    $d A f g x y $.  $d G f g x y $.  $d R f g x y $.  $d B g $.  $d A w z $.
    $d f w z $.  $d g w z $.  $d G w z $.  $d R w z $.  $d x w z $.
    $d y w z $.  $d R w z $.  $d X g $.  $d X w z $.
    frrlem6.1 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x /\
                                  A. y e. x ( f ` y ) =
                                            ( y G ( f |` Pred ( R , A , y ) ) )
                                 ) ) } $.
    frrlem6.2 $e |- F = U. B $.
    $( Lemma for founded recursion.  The union of all acceptable functions is a
       relationship.  (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem6 $p |- Rel F $=
      ( vg cuni wceq wrel cv reluni wcel wfun frrlem2 funrel syl mprgbir mpbiri
      releq ax-mp ) GDLZMZGNZJUGUHUFNZUIKOZNZKDKDPUJDQUJRUKABCDEFKHISUJTUAUBGUF
      UDUCUE $.

    $( Lemma for founded recursion.  The domain of ` F ` is a subclass of
       ` A ` .  (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem7 $p |- dom F C_ A $=
      ( vg cdm cv ciun cuni dmeqi dmuni eqtri wss iunss frrlem3 mprgbir eqsstri
      ) GLZKDKMLZNZCUDDOZLUFGUGJPKDQRUFCSUECSKDKDUECTABCDEFKHIUAUBUC $.
  $}

  ${
    $d A f x y $.  $d F x $.  $d G f x y $.  $d R f x y $.  $d B x $.
    $d A f x y g h u v $.  $d B g h $.  $d F u v $.  $d G g h $.  $d R g h $.
    frrlem10.1 $e |- R Fr A $.
    frrlem10.2 $e |- R Se A $.
    frrlem10.3 $e |- B = { f |
                           E. x ( f Fn x /\
                                  ( x C_ A /\
                                    A. y e. x Pred ( R , A , y ) C_ x /\
                                  A. y e. x ( f ` y ) =
                                            ( y G ( f |` Pred ( R , A , y ) ) )
                                 ) ) } $.
    frrlem10.4 $e |- F = U. B $.
    $( Lemma for founded recursion.  The union of all acceptable functions is a
       function.  (Contributed by Paul Chapman, 21-Apr-2012.) $)
    frrlem10 $p |- Fun F $=
      ( wfun cuni wss ssid frrlem5c ax-mp funeqi mpbir ) GMDNZMZDDOUBDPABCDDEFH
      IJKQRGUALST $.

    ${
      $d A z $.  $d F f $.  $d F z $.  $d G z $.  $d R z $.  $d x y z $.
      $d f z $.
      $( Lemma for founded recursion.  Here, we calculate the value of ` F `
         (the union of all acceptable functions).  (Contributed by Paul
         Chapman, 21-Apr-2012.) $)
      frrlem11 $p |- ( y e. dom F ->
              ( F ` y ) = ( y G ( F |` Pred ( R , A , y ) ) ) ) $=
        ( vz cv wcel wex wceq wss wa wi cdm cop cfv cpred cres co vex eldm2 wfn
        wral w3a cab unieqi eqtri eleq2i eluniab bitri abeq2i elssuni syl6sseqr
        cuni sylbir wel fnop ex rsp impcom fndm sseq2 eleq2 anbi12d syl biimprd
        wb exp3a wfun frrlem10 funssfv 3adant3l fun2ssres oveq2d eqeq12d mp3an1
        3adant3r expcom com23 syl6com com34 sylcom com14 syl7 exp4a pm2.43d imp
        adantl 3impd syld com12 imp3a exlimdv mpdi exlimiv sylbi ) BNZGUAOXDMNZ
        UBZGOZMPXDGUCZXDGCEXDUDZUEZHUFZQZMXDGBUGUHXGXLMXGXFFNZOZXMANZUIZXOCRZXI
        XORZBXOUJZXDXMUCZXDXMXIUEZHUFZQZBXOUJZUKZSZAPZSZFPZXLXGXFYGFULZVAZOYIGY
        KXFGDVAZYKLDYJKUMUNUOYGFXFUPUQYHXLFXNYGXLXNYGXMGRZXLYGXMDOZYMYGFDKURYNX
        MYLGXMDUSLUTVBXNYFYMXLTZAXNXPYEYOXPXNYEYOTZXPXNBAVCZYPXPXNYQXOXDXEXMVDV
        EXPYQYPXPYQSZXQXSYDYOYRXQXSYDYOTZXPYQXQXSSZYSTXPYQYDYTYOXPYQYDYTYOTZTXP
        YQYQYDUUAYQYDSYCXPYQUUAYDYQYCYCBXOVFVGYTYQYCXPYOXSYQYCXPYOTTZTXQXSYQXRU
        UBXRBXOVFYQXRXPYCYOYQXRXPYCYOTZXRXPSYQXIXMUAZRZXDUUDOZSZUUCXPXRYQUUGTXP
        XRYQUUGXPUUGXRYQSZXPUUDXOQZUUGUUHVNXOXMVHUUIUUEXRUUFYQUUDXOXIVIUUDXOXDV
        JVKVLVMVOVGUUGYMYCXLYMUUGYCXLTZGVPZYMUUGUUJABCDEFGHIJKLVQUUKYMUUGUKZXLY
        CUULXHXTXKYBUUKYMUUFXHXTQUUEXDGXMVRVSUULXJYAXDHUUKYMUUEXJYAQUUFXIGXMVTW
        DWAWBVMWCWEWFWGVOWHWIWOWJWKWLWMWHWNVOWPVEWQWRWSWTXAWNXBXCXBXC $.
    $}

    $(
    @{ @d A s t w z @. @d B s t w z @. @d R s t w z @. @d F z @.
       @d g w @. @d g z @. @d h w @. @d h z @.
    @( Calculate the domain of ` F ` . @)
    frrlem12 @p |- dom F = A @=
      ( vz vg vh vw cdm frrlem7 cv wcel ciun wrex csn ctrpred cun wfn wceq
      sneq trpredeq3 uneq12d fneq2d rexbidv fneq1
      cbvrexv syl5bbOLD frins2 vex
      snid elun1 ax-mp fndm eleq2d mpbiri reximi syl eliun sylibr cuni dmeqi
      dmuni eqtri eqcomi syl6eleq ssriv eqssi ) GQZCABCDEFGHKLRMCVPMSZCTZVQNDNS
      ZQZUAZVPVRVQVTTZNDUBZVQWATVRVSVQUCZCEVQUDZUEZUFZNDUBZWCWHOSZPSZUCZCEWJUDZ
      UEZUFZODUBZAMPCEIJVQWJUGZWIWFUFZODUBWOWHWPWQWNODWPWFWMWIWPWDWKWEWLVQWJUHC
      EVQWJUIUJUKULWGWQNODWFVSWIUMUNUO?UPWGWBNDWGWBVQWFTZVQWDTWRVQMUQURVQWDWEUS
      UTWGVTWFVQWFVSVAVBVCVDVENVQDVTVFVGVPWAVPDVHZQWAGWSLVINDVJVKVLVMVNVO @.
      @( [12-May-2012] @) @( [28-Apr-2012] @)
   @}
   $)
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Set up the new syntax for surreal numbers $)
  $c No <s bday $.
  $( Declare the class of all surreal numbers (see ~ df-no ). $)
  csur $a class No $.
  $( Declare the less than relationship over surreal numbers (see
     ~ df-slt ). $)
  cslt $a class <s $.
  $( Declare the birthday function for surreal numbers (see ~ df-bday ). $)
  cbday $a class bday $.

  ${
    $d f a $.
    $( Define the class of surreal numbers.  The surreal numbers are a proper
       class of numbers developed by John H. Conway and introduced by Donald
       Knuth in 1975.  They form a proper class into which all ordered fields
       can be embedded.  The approach we take to defining them was first
       introduced by Hary Goshnor, and is based on the conception of a "sign
       expansion" of a surreal number.  We define the surreals as
       ordinal-indexed sequences of ` 1o ` and ` 2o ` , analagous to Goshnor's
       ` ( - ) ` and ` ( + ) ` .

       After introducing this definition, we will abstract away from it using
       axioms that Norman Alling developed in "Foundations of Analysis over
       Surreal Number Fields."  This is done in an effort to be agnostic
       towards the exact implementation of surreals.  (Contributed by Scott
       Fenton, 9-Jun-2011.) $)
    df-no $a |- No = { f | E. a e. On f : a --> { 1o , 2o } } $.
  $}

  ${
    $d f g x y $.
    $( Next, we introduce surreal less-than, a comparison relationship over the
       surreals by lexicographically ordering them.  (Contributed by Scott
       Fenton, 9-Jun-2011.) $)
    df-slt $a |- <s = { <. f , g >. | ( ( f e. No /\ g e. No ) /\
                         E. x e. On (
                            A. y e. x ( f ` y ) = ( g ` y ) /\
                              ( f ` x ) { <. 1o , (/) >. ,
                                          <. 1o , 2o >. ,
                                          <. (/) , 2o >. } ( g ` x ) ) ) } $.
  $}

  $( Finally, we introduce the birthday function.  This function maps each
     surreal to an ordinal.  In our implementation, this is the domain of the
     sign function.  The important properties of this function are established
     later.  (Contributed by Scott Fenton, 11-Jun-2011.) $)
  df-bday $a |- bday = ( x e. No |-> dom x ) $.

  ${
    $d A f x $.
    $( Membership in the surreals.  (Shortened proof on 2012-Apr-14, SF).
       (Contributed by Scott Fenton, 11-Jun-2011.) $)
    elno $p |- ( A e. No <-> E. x e. On A : x --> { 1o , 2o } ) $=
      ( vf csur wcel cvv cv c1o c2o cpr wf con0 wrex elex ancoms rexlimiva wceq
      fex feq1 rexbidv df-no elab2g pm5.21nii ) BDEBFEZAGZHIJZBKZALMZBDNUGUDALU
      GUELEUDUEUFLBROPUEUFCGZKZALMUHCBDFUIBQUJUGALUEUFUIBSTCAUAUBUC $.
  $}

  ${
    $d A f g x y $.  $d B f g x y $.
    $( The value of the surreal less than relationship.  (Contributed by Scott
       Fenton, 14-Jun-2011.) $)
    sltval $p |- ( ( A e. No /\ B e. No ) ->
            ( A <s B <-> E. x e. On ( A. y e. x ( A ` y ) = ( B ` y ) /\
                         ( A ` x ) { <. 1o , (/) >. , <. 1o , 2o >. ,
                                     <. (/) , 2o >. } ( B ` x ) ) ) ) $=
      ( vf vg csur wcel wa cslt wbr cfv wceq wral cop con0 wrex fveq1 anbi12d
      cv c1o c0 c2o ctp eleq1 anbi1d eqeq1d ralbidv breq1d anbi2d eqeq2d breq2d
      rexbidv df-slt brabg bianabs ) CGHZDGHZIZCDJKBTZCLZUTDLZMZBATZNZVDCLZVDDL
      ZUAUBOUAUCOUBUCOUDZKZIZAPQZETZGHZFTZGHZIZUTVLLZUTVNLZMZBVDNZVDVLLZVDVNLZV
      HKZIZAPQZIUQVOIZVAVRMZBVDNZVFWBVHKZIZAPQZIUSVKIEFCDGGJVLCMZVPWFWEWKWLVMUQ
      VOVLCGUEUFWLWDWJAPWLVTWHWCWIWLVSWGBVDWLVQVAVRUTVLCRUGUHWLWAVFWBVHVDVLCRUI
      SUMSVNDMZWFUSWKVKWMVOURUQVNDGUEUJWMWJVJAPWMWHVEWIVIWMWGVCBVDWMVRVBVAUTVND
      RUKUHWMWBVGVFVHVDVNDRULSUMSABEFUNUOUP $.
  $}

  ${
    $d A x $.
    $( The value of the birthday function within the surreals.  (Contributed by
       Scott Fenton, 14-Jun-2011.) $)
    bdayval $p |- ( A e. No -> ( bday ` A ) = dom A ) $=
      ( vx csur wcel cdm cvv cbday cfv wceq dmexg cv dmeq df-bday fvmptg mpdan
      ) ACDAEZFDAGHPIACJBABKZEPCFGQALBMNO $.
  $}

  ${
    $d A x $.
    $( A surreal is a function.  (Contributed by Scott Fenton, 16-Jun-2011.) $)
    nofun $p |- ( A e. No -> Fun A ) $=
      ( vx csur wcel cv c1o c2o cpr wf con0 wrex wfun elno ffun rexlimivw sylbi
      ) ACDBEZFGHZAIZBJKALZBAMSTBJQRANOP $.

    $( The domain of a surreal is an ordinal.  (Contributed by Scott Fenton,
       16-Jun-2011.) $)
    nodmon $p |- ( A e. No -> dom A e. On ) $=
      ( vx csur wcel cv c1o c2o cpr wf con0 wrex cdm elno fdm biimprcd rexlimiv
      eleq1d sylbi ) ACDBEZFGHZAIZBJKALZJDZBAMUAUCBJUAUCSJDUAUBSJSTANQOPR $.

    $( The range of a surreal is a subset of the surreal signs.  (Contributed
       by Scott Fenton, 16-Jun-2011.) $)
    norn $p |- ( A e. No -> ran A C_ { 1o , 2o } ) $=
      ( vx csur wcel cv c1o c2o cpr con0 wrex crn wss elno frn rexlimivw sylbi
      wf ) ACDBEZFGHZAQZBIJAKSLZBAMTUABIRSANOP $.
  $}


  $( A surreal is a function over its birthday.  (Contributed by Scott Fenton,
     16-Jun-2011.) $)
  nofnbday $p |- ( A e. No -> A Fn ( bday ` A ) ) $=
    ( csur wcel wfun cdm cbday cfv wceq wfn nofun bdayval eqcomd df-fn sylanbrc
    ) ABCZADAEZAFGZHAQIAJOQPAKLAQMN $.

  $( The domain of a surreal has the ordinal property.  (Contributed by Scott
     Fenton, 16-Jun-2011.) $)
  nodmord $p |- ( A e. No -> Ord dom A ) $=
    ( csur wcel cdm con0 word nodmon eloni syl ) ABCADZECJFAGJHI $.

  ${
    $d x A $.
    $( An alternative condition for membership in ` No ` .  (Contributed by
       Scott Fenton, 21-Mar-2012.) $)
    elno2 $p |- ( A e. No <->
              ( Fun A /\ dom A e. On /\ ran A C_ { 1o , 2o } ) ) $=
      ( vx csur wcel wfun cdm con0 crn c1o c2o cpr wss w3a nofun nodmon norn wf
      3jca wa sylibr cv wrex simp2 wceq simpl eqidd df-fn sylanbrc anim1i 3impa
      wfn df-f feq2 rspcev syl2anc elno impbii ) ACDZAEZAFZGDZAHIJKZLZMZURUSVAV
      CANAOAPRVDBUAZVBAQZBGUBZURVDVAUTVBAQZVGUSVAVCUCVDAUTUKZVCSZVHUSVAVCVJUSVA
      SZVIVCVKUSUTUTUDVIUSVAUEVKUTUFAUTUGUHUIUJUTVBAULTVFVHBUTGVEUTVBAUMUNUOBAU
      PTUQ $.
  $}

  $( Another condition for membership in ` No ` .  (Contributed by Scott
     Fenton, 14-Apr-2012.) $)
  elno3 $p |- ( A e. No <-> ( A : dom A --> { 1o , 2o } /\ dom A e. On ) ) $=
    ( wfun cdm con0 wcel crn c1o c2o cpr wss w3a wa csur 3anan32 elno2 wfn df-f
    wf funfn anbi1i bitr4i 3bitr4i ) ABZACZDEZAFGHIZJZKUCUGLZUELAMEUDUFARZUELUC
    UEUGNAOUIUHUEUIAUDPZUGLUHUDUFAQUCUJUGASTUATUB $.

  ${
    $d A a x y $.  $d B a x y $.
    $( Alternate expression for surreal less than.  Two surreals obey surreal
       less than iff they obey the sign ordering at the first place they
       differ.  (Contributed by Scott Fenton, 17-Jun-2011.) $)
    sltval2 $p |- ( ( A e. No /\ B e. No ) ->
                     ( A <s B <->
                       ( A ` |^| { a e. On | ( A ` a ) =/= ( B ` a ) } )
                       { <. 1o , (/) >. , <. 1o , 2o >. , <. (/) , 2o >. }
                       ( B ` |^| { a e. On | ( A ` a ) =/= ( B ` a ) } )
                     ) ) $=
      ( vy vx wcel wa cfv wceq c1o c0 c2o con0 wne wn df-ne mtbiri adantl fveq2
      fvex csur cslt wbr cv wral cop ctp wrex crab cint sltval cvv w3o brtp 1n0
      mpbi eqeq1 fvprc nsyl2 adantr 2on0 3jaoi sylbi onintrab sylib onelon syl5
      expcom neeq12d onnminsb com12 con2bii syl6ibr ralrimiv jca ex impac anass
      syld raleq breq12d anbi12d rspcev wi eqeq12 csuc wb 0elon suc11 necon3bid
      syl 1on mp2an mpbir df-2o df-1o eqeq12i nemtbir eqcom syl6bb mtbi 3imtr4i
      elrab biimpri adantlr wss ssrab2 ne0i onint sylancr nfrab1 nfcv nffv nfne
      elrabf simprbi eqeq12d rspccv ad2antlr mtod simpll oninton ontri1 syl2anc
      nfint mpbird intss1 syldan sylan2 fveq2d pm2.43d expimpd rexlimiv impbid1
      eqssd biimpd bitr4d ) AUAFBUAFGZABUBUCDUDZAHZYSBHZIZDEUDZUEZUUCAHZUUCBHZJ
      KUFJLUFKLUFUGZUCZGZEMUHZCUDZAHZUUKBHZNZCMUIZUJZAHZUUPBHZUUGUCZEDABUKYRUUS
      UUJYRUUSUUJYRUUSGZUUPMFZUUBDUUPUEZUUSGZGZUUJUUTUVAUVBGZUUSGUVDYRUUSUVEYRU
      USUVEUUTUVAUVBUUSUVAYRUUSUUPULFZUVAUUSUUQJIZUURKIZGZUVGUURLIZGZUUQKIZUVJG
      ZUMUVFJKJLKLUUQUURUUPATUUPBTUNUVIUVFUVKUVMUVGUVFUVHUVGUVLUVFUVGUVLJKIZJKN
      ZUVNOUOJKPUPZUUQJKUQQUUPAURUSZUTUVGUVFUVJUVQUTUVJUVFUVLUVJUVHUVFUVJUVHLKI
      ZLKNUVROVALKPUPZUURLKUQQUUPBURUSRVBVCUUNCVDVERZUUTUUBDUUPUUTYSUUPFZYTUUAN
      ZOZUUBUWAUUTUWCUWAUUTYSMFZUWCUUTUVAUWAUWDUVTUVAUWAUWDUUPYSVFVHVGUWDUWAUWC
      UUNUWBCYSUUKYSIUULYTUUMUUAUUKYSASUUKYSBSVIVJVKVSVKUWBUUBYTUUAPVLVMVNVOVPV
      QUVAUVBUUSVRVEUUIUVCEUUPMUUCUUPIZUUDUVBUUHUUSUUBDUUCUUPVTUWEUUEUUQUUFUURU
      UGUUCUUPASUUCUUPBSWAWBWCWKVPUUIUUSEMUUCMFZUUDUUHUUSUWFUUDGZUUHUUSUWGUUHUU
      HUUSWDUWGUUHGZUUHUUSUWHUUEUUQUUFUURUUGUWHUUCUUPAUUHUWGUUEUUFNZUWEUUEJIZUU
      FKIGZUWJUUFLIZGZUUEKIUWLGZUMUUEUUFIZOZUUHUWIUWKUWPUWMUWNUWKUWOUVNUVPUUEJU
      UFKWEQUWMUWOLJIZUWQJWFZKWFZUWRUWSNZUVOUOJMFZKMFZUWTUVOWGWLWHUXAUXBGUWRUWS
      JKJKWIWJWMWNLUWRJUWSWOWPWQWRUWMUWOJLIUWQUUEJUUFLWEJLWSWTQUWNUWOKLIZUVRUXC
      UVSLKWSXAUUEKUUFLWEQVBJKJLKLUUEUUFUUCATUUCBTUNUUEUUFPXBUWGUWIUUCUUOFZUWEU
      WFUWIUXDUUDUXDUWFUWIGUUNUWICUUCMUUKUUCIUULUUEUUMUUFUUKUUCASUUKUUCBSVIXCXD
      XEUWGUXDGZUUCUUPUXEUUCUUPXFZUUPUUCFZOZUXEUXGUUQUURIZUXEUUQUURNZUXIOUXEUUP
      UUOFZUXJUXEUUOMXFZUUOKNZUXKUUNCMXGZUXDUXMUWGUUOUUCXHZRUUOXIXJUXKUVAUXJUUN
      UXJCUUPMCUUOUUNCMXKYEZCMXLCUUQUURCUUPACAXLUXPXMCUUPBCBXLUXPXMXNUUKUUPIUUL
      UUQUUMUURUUKUUPASUUKUUPBSVIXOXPWKUUQUURPVEUUDUXGUXIWDUWFUXDUUBUXIDUUPUUCY
      SUUPIYTUUQUUAUURYSUUPASYSUUPBSXQXRXSXTUXEUWFUVAUXFUXHWGUWFUUDUXDYAUXDUVAU
      WGUXDUXLUXMUVAUXNUXOUUOYBXJRUUCUUPYCYDYFUXDUUPUUCXFUWGUUCUUOYGRYOYHYIZYJU
      WHUUCUUPBUXQYJWAYPVPYKYLYMYNYQ $.
  $}

  ${
    $( The function value of a surreal is either a sign or the empty set.
       (Contributed by Scott Fenton, 22-Jun-2011.) $)
    nofv $p |- ( A e. No -> ( ( A ` X ) = (/) \/ ( A ` X ) = 1o \/
                               ( A ` X ) = 2o ) ) $=
      ( csur wcel cfv c0 wceq c1o c2o wo w3o cdm wn pm2.1 wi ndmfv a1i wa elexi
      con0 wfun crn cpr wss nofun norn fvelrn syl5com impancom 1on elpr2 syl6ib
      ssel 2on syl2anc orim12d mpi 3orass sylibr ) ACDZBAEZFGZVAHGZVAIGZJZJZVBV
      CVDKUTBALDZMZVGJVFVGNUTVHVBVGVEVHVBOUTBAPQUTAUAZAUBZHIUCZUDZVGVEOAUEAUFVI
      VLRVGVAVKDZVEVIVGVLVMVIVGRVAVJDVLVMBAUGVJVKVAUMUHUIVAHIHTUJSITUNSUKULUOUP
      UQVBVCVDURUS $.
  $}

  ${
    $( ` (/) ` is not a surreal sign.  (Contributed by Scott Fenton,
       16-Jun-2011.) $)
    nosgnn0 $p |- -. (/) e. { 1o , 2o } $=
      ( c0 c1o c2o cpr wcel wceq wo wne 1n0 necom df-ne bitri mpbi csuc nsuceq0
      wn df-2o neeq2i bitr4i pm3.2ni 0ex elpr mtbir ) ABCDEABFZACFZGUDUEBAHZUDP
      ZIUFABHUGBAJABKLMACHZUEPBNZAHZUHBOUJAUIHUHUIAJCUIAQRSMACKMTABCUAUBUC $.
  $}

  ${
    nosgnn0i.1 $e |- X e. { 1o , 2o } $.
    $( If ` X ` is a surreal sign, then it is not null.  (Contributed by Scott
       Fenton, 3-Aug-2011.) $)
    nosgnn0i $p |- (/) =/= X $=
      ( c0 wne wceq wn c1o c2o cpr wcel nosgnn0 eleq1 mpbiri mto df-ne mpbir )
      CADCAEZFQCGHIZJZKQSARJBCARLMNCAOP $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( The restriction of a surreal to an ordinal is still a surreal.
       (Contributed by Scott Fenton, 4-Sep-2011.) $)
    noreson $p |- ( ( A e. No /\ B e. On ) -> ( A |` B ) e. No ) $=
      ( vy vx csur wcel con0 wa cv c1o c2o cpr cres wf wrex elno wi onin fresin
      cin feq2 rspcev syl2an an32s ex rexlimiva imp sylanb sylibr ) AEFZBGFZHCI
      ZJKLZABMZNZCGOZUNEFUJDIZUMANZDGOZUKUPDAPUSUKUPURUKUPQDGUQGFZURHUKUPUTUKUR
      UPUTUKHUQBTZGFVAUMUNNZUPURUQBRUQUMABSUOVBCVAGULVAUMUNUAUBUCUDUEUFUGUHCUNP
      UI $.
  $}

  ${
    $d A k $.  $d B k $.

    $( If ` A <s B ` , then the sign of ` A ` at the first place they differ is
       either undefined or ` 1o ` (Contributed by Scott Fenton, 4-Sep-2011.) $)
    sltsgn1 $p |- ( ( A e. No /\ B e. No ) ->
                     ( A <s B ->
                  ( ( A ` |^| { k e. On | ( A ` k ) =/= ( B ` k ) } ) = (/) \/
                    ( A ` |^| { k e. On | ( A ` k ) =/= ( B ` k ) } ) = 1o )
                    ) ) $=
      ( csur wcel wa cslt wbr cv cfv wne con0 crab c1o cop c2o wceq fvex adantr
      c0 cint ctp wo sltval2 w3o brtp olc orc 3jaoi sylbi syl6bi ) ADEBDEFABGHC
      IZAJULBJKCLMUAZAJZUMBJZNTONPOTPOUBHZUNTQZUNNQZUCZABCUDUPURUOTQZFZURUOPQZF
      ZUQVBFZUEUSNTNPTPUNUOUMARUMBRUFVAUSVCVDURUSUTURUQUGZSURUSVBVESUQUSVBUQURU
      HSUIUJUK $.

    $( If ` A <s B ` , then the sign of ` B ` at the first place they differ is
       either undefined or ` 2o ` (Contributed by Scott Fenton, 4-Sep-2011.) $)
    sltsgn2 $p |- ( ( A e. No /\ B e. No ) ->
                     ( A <s B ->
                  ( ( B ` |^| { k e. On | ( A ` k ) =/= ( B ` k ) } ) = (/) \/
                    ( B ` |^| { k e. On | ( A ` k ) =/= ( B ` k ) } ) = 2o )
                    ) ) $=
      ( csur wcel wa cslt wbr cv cfv wne con0 crab c1o cop c2o wceq fvex adantl
      c0 cint ctp wo sltval2 w3o brtp orc olc 3jaoi sylbi syl6bi ) ADEBDEFABGHC
      IZAJULBJKCLMUAZAJZUMBJZNTONPOTPOUBHZUOTQZUOPQZUCZABCUDUPUNNQZUQFZUTURFZUN
      TQZURFZUEUSNTNPTPUNUOUMARUMBRUFVAUSVBVDUQUSUTUQURUGSURUSUTURUQUHZSURUSVCV
      ESUIUJUK $.
  $}

  ${
    $d A a $.  $d B a $.
    $( If ` A <s B ` , then the intersection of all the ordinals that have
       differing signs in ` A ` and ` B ` exists.  (Contributed by Scott
       Fenton, 22-Feb-2012.) $)
    sltintdifex $p |- ( ( A e. No /\ B e. No ) ->
       ( A <s B -> |^| { a e. On | ( A ` a ) =/= ( B ` a ) } e. _V ) ) $=
      ( csur wcel wa wbr cfv wne c1o c0 cop wceq fvex wn fvprc df-ne mpbi eqeq1
      c2o cslt cv con0 crab cint ctp cvv sltval2 w3o brtp 1n0 syl6bb mtbiri syl
      eqcom con4i adantr 2on0 adantl 3jaoi sylbi syl6bi ) ADEBDEFABUAGCUBZAHVCB
      HICUCUDUEZAHZVDBHZJKLJTLKTLUFGZVDUGEZABCUHVGVEJMZVFKMZFZVIVFTMZFZVEKMZVLF
      ZUIVHJKJTKTVEVFVDANVDBNUJVKVHVMVOVIVHVJVHVIVHOZVNVIOVDAPVNVIJKMZJKIVQOUKJ
      KQRVNVIKJMVQVEKJSKJUOULUMUNUPZUQVIVHVLVRUQVLVHVNVHVLVPVJVLOVDBPVJVLTKMZTK
      IVSOURTKQRVJVLKTMVSVFKTSKTUOULUMUNUPUSUTVAVB $.
  $}

  ${
    $d A a x y $.  $d B a x y $.  $d X a x y $.
    $( If the restrictions of two surreals to a given ordinal obey surreal less
       than, then so do the two surreals themselves.  (Contributed by Scott
       Fenton, 4-Sep-2011.) $)
    sltres $p |- ( ( A e. No /\ B e. No /\ X e. On ) ->
                      ( ( A |` X ) <s ( B |` X ) -> A <s B ) ) $=
      ( vy va wcel con0 wbr wa cfv wceq c1o c0 c2o wi imp wn syl sylc ex vx w3a
      csur cres cslt cv wral cop ctp wrex wne crab cint noreson 3adant2 3adant1
      cvv sltintdifex onintrab syl6ib syl2anc wss simpl3 cdm wo wb sltval2 fvex
      w3o brtp 1n0 df-ne mpbi eqeq1 mtbiri ndmfv nsyl2 adantr orcd 2on nosgnn0i
      elexi prid2 eqcom syl6bb adantl olcd 3jaoi sylbi dmres elin2 simplbi jaoi
      syl6bi onelss sselda onelon sylan intss1 ontri1 syl5ib con2d impancom mpd
      fveq2 neeq12d elrab simplbi2 con3d con2bii sylibr fvres eqeq12d ralrimiva
      biimpd fvresval ori eqcomd eqeq2 mpbid a1i ad2antrl cpr wfun nofun fvelrn
      norn sseld syld nosgnn0 eleq1 nsyli adantrl jcad anim12i ad2antll adantrr
      crn syl6 3orim123d 3imtr4g sylbid breq12d anbi12d rspcev syl12anc 3adant3
      raleq sltval mpbird ) AUCFZBUCFZCGFZUBZACUDZBCUDZUEHZABUEHZUUNUUQIZUURDUF
      ZAJZUUTBJZKZDUAUFZUGZUVDAJZUVDBJZLMUHLNUHMNUHUIZHZIZUAGUJZUUSEUFZUUOJZUVL
      UUPJZUKZEGULZUMZGFZUVCDUVQUGZUVQAJZUVQBJZUVHHZUVKUUNUUQUVRUUNUUOUCFZUUPUC
      FZUUQUVROUUKUUMUWCUULACUNUOZUULUUMUWDUUKBCUNUPZUWCUWDIUUQUVQUQFUVRUUOUUPE
      URUVOEUSUTVAPZUUSUVCDUVQUUSUUTUVQFZIZUUTCFZUUTUUOJZUUTUUPJZKZUVCUUSUVQCUU
      TUUSUUMUVQCFZUVQCVBUUKUULUUMUUQVCUUSUVQUUOVDZFZUVQUUPVDZFZVEZUWNUUNUUQUWS
      UUNUUQUVQUUOJZUVQUUPJZUVHHZUWSUUNUWCUWDUUQUXBVFUWEUWFUUOUUPEVGVAZUXBUWTLK
      ZUXAMKZIZUXDUXANKZIZUWTMKZUXGIZVIZUWSLMLNMNUWTUXAUVQUUOVHUVQUUPVHVJZUXFUW
      SUXHUXJUXFUWPUWRUXDUWPUXEUXDUXIUWPUXDUXILMKZLMUKUXMQVKLMVLVMUWTLMVNVOZUVQ
      UUOVPVQZVRVSUXHUWPUWRUXDUWPUXGUXOVRVSUXJUWRUWPUXGUWRUXIUXGUXEUWRUXGUXEMNK
      ZMNUKUXPQNLNNGVTWBWCWAMNVLVMUXGUXENMKUXPUXANMVNNMWDWEVOZUVQUUPVPVQZWFWGWH
      WIWNPUWPUWNUWRUWPUWNUVQAVDZFZUVQCUXSUWOACWJWKZWLZUWRUWNUVQBVDZFZUVQCUYCUW
      QBCWJWKZWLZWMRCUVQWOSWPUWIUWKUWLUKZQZUWMUWIUUTGFZUUTUVPFZQZUYHUUSUVRUWHUY
      IUWGUVQUUTWQWRZUWIUYIUYKUYLUUSUYIUWHUYKUUSUVRUYIUWHUYKOUWGUVRUYIIZUYJUWHU
      YJUVQUUTVBUYMUWHQUUTUVPWSUVQUUTWTXAXBWRXCXDUYIUYGUYJUYJUYIUYGUVOUYGEUUTGU
      VLUUTKUVMUWKUVNUWLUVLUUTUUOXEUVLUUTUUPXEXFXGXHXISUYGUWMUWKUWLVLXJXKUWJUWM
      UVCUWJUWKUVAUWLUVBUUTCAXLUUTCBXLXMXOSXNUUNUUQUWBUUNUUQUXBUWBUXCUUNUXKUVTL
      KZUWAMKZIZUYNUWANKZIZUVTMKZUYQIZVIUXBUWBUUNUXFUYPUXHUYRUXJUYTUUNUXFUYNUYO
      UXFUYNOUUNUXDUYNUXEUXDUVTUWTKUYNUXDUWTUVTUXDUXIUWTUVTKZUXNVUAUXIUVQCAXPXQ
      VQXRUWTLUVTXSXTZVRYAUUNUXFUYOUUNUXFIZUYDQZUYOVUCUWNUWRQZVUDVUCUWPUWNUXDUW
      PUUNUXEUXOYBUYBRUUNUXEVUEUXDUUNUXEVUEUUNUWDUXEVUEOUWFUWDUWRUXALNYCZFZUXEU
      WDUWRUXAUUPYRZFZVUGUWDUUPYDZUWRVUIOUUPYEVUJUWRVUIUVQUUPYFTRUWDVUHVUFUXAUU
      PYGYHYIUXEVUGMVUFFZYJUXAMVUFYKVOYLRPYMUWNUYDUWRUWRUWNUYDUYEXHXISUVQBVPRTY
      NUXHUYROUUNUXDUYNUXGUYQVUBUXGUWAUXAKUYQUXGUXAUWAUXGUXEUXAUWAKZUXQVULUXEUV
      QCBXPXQVQXRUXANUWAXSXTZYOYAUUNUXJUYSUYQUUNUXJUXTQZUYSUUNUXJVUNUUNUXJIZUWN
      UWPQZVUNVUOUWRUWNUXGUWRUUNUXIUXRYPUYFRUUNUXIVUPUXGUUNUXIVUPUUNUWCUXIVUPOU
      WEUWCUWPUWTVUFFZUXIUWCUWPUWTUUOYRZFZVUQUWCUUOYDZUWPVUSOUUOYEVUTUWPVUSUVQU
      UOYFTRUWCVURVUFUWTUUOYGYHYIUXIVUQVUKYJUWTMVUFYKVOYLRPYQUWNUXTUWPUWPUWNUXT
      UYAXHXISTUVQAVPYSUXJUYQOUUNUXGUYQUXIVUMWFYAYNYTUXLLMLNMNUVTUWAUVQAVHUVQBV
      HVJUUAUUBPUVJUVSUWBIUAUVQGUVDUVQKZUVEUVSUVIUWBUVCDUVDUVQUUHVVAUVFUVTUVGUW
      AUVHUVDUVQAXEUVDUVQBXEUUCUUDUUEUUFUUNUURUVKVFZUUQUUKUULVVBUUMUADABUUIUUGV
      RUUJT $.
  $}

  ${
    $d A x $.  $d X x $.
    noxpsgn.1 $e |- X e. { 1o , 2o } $.
    $( The cross product of an ordinal and the singleton of a sign is a
       surreal.  (Contributed by Scott Fenton, 21-Jun-2011.) $)
    noxpsgn $p |- ( A e. On -> ( A X. { X } ) e. No ) $=
      ( vx con0 wcel cv c1o c2o cpr csn cxp wrex csur fconst6 feq2 rspcev mpan2
      wf elno sylibr ) AEFZDGZHIJZABKLZSZDEMZUENFUBAUDUESZUGABUDCOUFUHDAEUCAUDU
      EPQRDUETUA $.
  $}

  $( The cross product of an ordinal and ` { 1o } ` is a surreal.  (Contributed
     by Scott Fenton, 12-Jun-2011.) $)
  noxp1o $p |- ( A e. On -> ( A X. { 1o } ) e. No ) $=
    ( c1o c2o con0 1on elexi prid1 noxpsgn ) ABBCBDEFGH $.

  $( The cross product of an ordinal and ` { 2o } ` is a surreal.  (Contributed
     by Scott Fenton, 12-Jun-2011.) $)
  noxp2o $p |- ( A e. On -> ( A X. { 2o } ) e. No ) $=
    ( c2o c1o con0 2on elexi prid2 noxpsgn ) ABCBBDEFGH $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers: Ordering
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z $.
    $( Lemma for ~ sltso .  The sign expansion relationship totally orders the
       surreal signs.  (Contributed by Scott Fenton, 8-Jun-2011.) $)
    sltsolem1 $p |- { <. 1o , (/) >. , <. 1o , 2o >. , <. (/) , 2o >. }
                      Or ( { 1o , 2o } u. { (/) } ) $=
      ( vx vy vz c1o c2o c0 cop cv wbr wcel wceq wa w3o eqtr2 brtp expcom 3jaod
      mto ex ad2ant2lr ctp wor cpr csn cun wn wne 1n0 df-ne mpbi con0 1on 0elon
      csuc df-2o df-1o eqeq12i suc11 syl5bb mp2an nemtbir ancoms nsuceq0 eqeq1i
      wb 3pm3.2ni vex mtbir a1i wi w3a pm2.21i ad2ant2rl 3mix2 3jaoi imp sylibr
      syl2anb eltp eqtr3 3mix2d 3mix1d 3mix1 3mix3d 3mix3 3orbi123i issoi df-tp
      biid soeq2 ax-mp ) DEFUAZDFGDEGFEGUAZUBZDEUCFUDUEZWMUBZABCWLWMAHZWQWMIZUF
      WQWLJZWRWQDKZWQFKZLZWTWQEKZLZXAXCLZMXBXDXEXBDFKZDFUGXFUFUHDFUIUJZWQDFNRXD
      EDKZXHDFUHDUKJZFUKJZXHXFVEULUMXHDUNZFUNZKXIXJLXFEXKDXLUOUPUQDFURUSUTVAZXC
      WTXHWQEDNVBRXEEFKZXNXKFDVCEXKFUOVDVAZXCXAXNWQEFNVBRVFDFDEFEWQWQAVGZXPOVHV
      IWQBHZWMIZXQCHZWMIZLZWQXSWMIZVJWSXQWLJZXSWLJVKYAWTXSFKZLZWTXSEKZLZXAYFLZM
      ZYBXRWTXQFKZLZWTXQEKZLZXAYLLZMZXQDKZYDLZYPYFLZYJYFLZMZYIXTDFDEFEWQXQXPBVG
      ZOZDFDEFEXQXSUUACVGZOYOYTYIYKYTYIVJYMYNYKYQYIYRYSYQYKYIYPYJYIYDWTYPYJLZYI
      UUDXFXGXQDFNRVLZVMPYRYKYIYPYJYIYFWTUUEVMPYKYSYIWTYFYIYJYJYGYEYHVNVMSQYMYQ
      YIYRYSYMYQYIYLYPYIWTYDYLYPLZYIUUFXHXMXQEDNRVLZTSYMYRYIYLYPYIWTYFUUGTSYMYS
      YIYLYJYIWTYFYLYJLZYIUUHXNXOXQEFNRVLZTSQYNYQYIYRYSYNYQYIYLYPYIXAYDUUGTSYNY
      RYIYLYPYIXAYFUUGTSYNYSYIYLYJYIXAYFUUITSQVOVPVRDFDEFEWQXSXPUUCOVQVIWSYCLYO
      WQXQKZYPXALZYPXCLZYJXCLZMZMZXRUUJXQWQWMIZMWSWTXCXAMZYPYLYJMZUUOYCWQDEFXPV
      SXQDEFUUAVSUUQUURUUOWTUURUUOVJXCXAWTYPUUOYLYJWTYPUUOWTYPLUUJYOUUNWQXQDVTW
      ASWTYLUUOYMYOUUJUUNYMYKYNVNWBSWTYJUUOYKYOUUJUUNYKYMYNWCWBSQXCYPUUOYLYJYPX
      CUUOUULUUNYOUUJUULUUKUUMVNWDPXCYLUUOXCYLLUUJYOUUNWQXQEVTWASYJXCUUOUUMUUNY
      OUUJUUMUUKUULWEWDPQXAYPUUOYLYJYPXAUUOUUKUUNYOUUJUUKUULUUMWCWDPXAYLUUOYNYO
      UUJUUNYNYKYMWEWBSXAYJUUOXAYJLUUJYOUUNWQXQFVTWASQVOVPVRXRYOUUJUUJUUPUUNUUB
      UUJWIDFDEFEXQWQUUAXPOWFVQWGWLWOKWNWPVEDEFWHWLWOWMWJWKUJ $.
  $}

  ${
    $d f g x y $.
    $( Surreal less than totally orders the surreals.  Alling's axiom (O).
       (Contributed by Scott Fenton, 9-Jun-2011.) $)
    sltso $p |- <s Or No $=
      ( vx vy vf vg c1o c2o cpr c0 cop cslt csur sltsolem1 df-no df-slt nosgnn0
      ctp soseq ) ABEFGEHIEFIHFIPJCDKLCAMABCDNOQ $.
  $}

  $( Surreal less than is irreflexive.  (Contributed by Scott Fenton,
     16-Jun-2011.) $)
  sltirr $p |- ( A e. No -> -. A <s A ) $=
    ( csur cslt wor wcel wbr wn sltso sonr mpan ) BCDABEAACFGHBACIJ $.

  $( Surreal less than is transitive.  (Contributed by Scott Fenton,
     16-Jun-2011.) $)
  slttr $p |- ( ( A e. No /\ B e. No /\ C e. No ) ->
                ( ( A <s B /\ B <s C ) -> A <s C ) ) $=
    ( csur cslt wor wcel w3a wbr wa wi sltso sotr mpan ) DEFADGBDGCDGHABEIBCEIJ
    ACEIKLDABCEMN $.

  $( Surreal less than is asymmetric.  (Contributed by Scott Fenton,
     16-Jun-2011.) $)
  sltasym $p |- ( ( A e. No /\ B e. No ) -> ( A <s B -> -. B <s A ) ) $=
    ( csur wcel wa cslt wbr wn sltirr ad2antrr wi slttr 3anidm13 expdimp mtod
    ex ) ACDZBCDZEZABFGZBAFGZHSTEUAAAFGZQUBHRTAIJSTUAUBQRTUAEUBKABALMNOP $.

  $( Surreal less than obeys trichotomy.  (Contributed by Scott Fenton,
     16-Jun-2011.) $)
  slttri $p |- ( ( A e. No /\ B e. No ) -> ( A <s B \/ A = B \/ B <s A ) ) $=
    ( csur cslt wor wcel wa wbr wceq w3o sltso solin mpan ) CDEACFBCFGABDHABIBA
    DHJKCABDLM $.

  $( Trichotomy law for surreal less than.  (Contributed by Scott Fenton,
     22-Apr-2012.) $)
  slttrieq2 $p |- ( ( A e. No /\ B e. No ) ->
                    ( A = B <-> ( -. A <s B /\ -. B <s A ) ) ) $=
    ( csur cslt wor wcel wa wceq wbr wn wb sltso sotrieq2 mpan ) CDEACFBCFGABHA
    BDIJBADIJGKLCABDMN $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers: Birthday Function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f x y $.
    $( The birthday function maps the surreals onto the ordinals.  Alling's
       axiom (B).  (Shortened proof on 2012-Apr-14, SF).  (Contributed by Scott
       Fenton, 11-Jun-2011.) $)
    bdayfo $p |- bday : No -onto-> On $=
      ( vx vy csur con0 cbday wfo wfn crn wceq cdm wcel wral dmexg rgen df-bday
      cv cvv mptfng mpbi c1o wrex cab rnmpt csn cxp noxp1o c0 wne 1on snnz dmxp
      elexi ax-mp eqcomi dmeq eqeq2d rspcev sylancl wi nodmon eleq1a syl impbii
      rexlimiv abbi2i eqtr4i df-fo mpbir2an ) CDEFECGZEHZDIAPZJZQKZACLVIVMACVKC
      MNACVLEAOZRSVJBPZVLIZACUAZBUBDABCVLEVNUCVQBDVODKZVQVRVOTUDZUEZCKVOVTJZIZV
      QVOUFWAVOVSUGUHWAVOITTDUIULUJVOVSUKUMUNVPWBAVTCVKVTIVLWAVOVKVTUOUPUQURVPV
      RACVKCKVLDKVPVRUSVKUTVLDVOVAVBVDVCVEVFCDEVGVH $.

  $}

  $( The birthday function is a function.  (Contributed by Scott Fenton,
     14-Jun-2011.) $)
  bdayfun $p |- Fun bday $=
    ( csur con0 cbday wfo wfun bdayfo fofun ax-mp ) ABCDCEFABCGH $.

  $( The birthday function's range is ` On ` (Contributed by Scott Fenton,
     14-Jun-2011.) $)
  bdayrn $p |- ran bday = On $=
    ( csur con0 cbday wfo crn wceq bdayfo forn ax-mp ) ABCDCEBFGABCHI $.

  $( The birthday function's domain is ` No ` (Contributed by Scott Fenton,
     14-Jun-2011.) $)
  bdaydm $p |- dom bday = No $=
    ( csur con0 cbday wfo wf bdayfo fof ax-mp fdmi ) ABCABCDABCEFABCGHI $.

  $( The birthday function is a function over ` No ` (Contributed by Scott
     Fenton, 30-Jun-2011.) $)
  bdayfn $p |- bday Fn No $=
    ( cbday csur wfn wfun cdm wceq bdayfun bdaydm df-fn mpbir2an ) ABCADAEBFGHA
    BIJ $.

  $( The value of the birthday function is always an ordinal.  (Contributed by
     Scott Fenton, 14-Jun-2011.) $)
  bdayelon $p |- ( bday ` A ) e. On $=
    ( cbday cdm wcel cfv con0 wfun bdayfun wa fvelrn bdayrn syl6eleq mpan wn c0
    crn ndmfv 0elon syl6eqel pm2.61i ) ABCDZABEZFDZBGZUAUCHUDUAIUBBPFABJKLMUANU
    BOFABQRST $.

  $( The surreal numbers are a proper class.  (Contributed by Scott Fenton,
     16-Jun-2011.) $)
  noprc $p |- -. No e. _V $=
    ( csur cvv wcel con0 onprc cbday wfo bdayfo fornex mpi mto ) ABCZDBCZELADFG
    MHADBFIJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers: Density
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.
    $( The value of a surreal at its birthday is ` (/) ` .  (Shortened proof on
       2012-Apr-14, SF) (Contributed by Scott Fenton, 14-Jun-2011.) $)
    fvnobday $p |- ( A e. No -> ( A ` ( bday ` A ) ) = (/) ) $=
      ( csur wcel cbday cfv cdm wn c0 wceq bdayelon onirri bdayval eleq2d mtbii
      ndmfv syl ) ABCZADEZAFZCZGRAEHIQRRCTRAJKQRSRALMNRAOP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers: Density
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a $.  $d B a $.
    $( Lemma for ~ nodense .  If one surreal is older than another, then there
       is an ordinal at which they are not equal.  (Contributed by Scott
       Fenton, 16-Jun-2011.) $)
    nodenselem3 $p |- ( ( A e. No /\ B e. No ) ->
                           ( ( bday ` A ) e. ( bday ` B ) ->
                             E. a e. On ( A ` a ) =/= ( B ` a ) ) ) $=
      ( csur wcel wa cbday cfv cdm cv wne con0 wrex wceq adantl eleq2d bdayelon
      bdayval c0 fveq2 c1o c2o cpr nosgnn0 crn wss norn adantr wfun nofun sylan
      fvelrn sseldd syl5ibcom neneqad adantll fvnobday ad2antrr neeqtrrd necomd
      eleq1 mtoi neeq12d rspcev sylancr ex sylbid ) ADEZBDEZFZAGHZBGHZEVKBIZEZC
      JZAHZVOBHZKZCLMZVJVLVMVKVIVLVMNVHBROPVJVNVSVJVNFZVKLEVKAHZVKBHZKZVSAQVTWB
      WAVTWBSWAVIVNWBSKVHVIVNFZWBSWDWBSNZSUAUBUCZEZUDWDWBWFEWEWGWDBUEZWFWBVIWHW
      FUFVNBUGUHVIBUIVNWBWHEBUJVKBULUKUMWBSWFVAUNVBUOUPVHWASNVIVNAUQURUSUTVRWCC
      VKLVOVKNVPWAVQWBVOVKATVOVKBTVCVDVEVFVG $.
  $}

  ${
    $d A a x $.  $d B a x $.
    $( Lemma for ~ nodense .  Show that a particular abstraction is an
       ordinal.  (Contributed by Scott Fenton, 16-Jun-2011.) $)
    nodenselem4 $p |- ( ( ( A e. No /\ B e. No ) /\ A <s B ) ->
                        |^| { a e. On | ( A ` a ) =/= ( B ` a ) } e. On ) $=
      ( csur wcel wa cslt wbr cfv wne con0 wss wrex wn wi cbday wfn wb nofnbday
      wceq cv crab c0 ssrab2 sltirr breq2 biimprcd con3d syl5com adantr eqfnfv2
      cint wral syl2an notbid wo ianor word bdayelon onordi ordtri3 nodenselem3
      mp2an con2bii necom rexbii syl6ib ancoms jaod syl5bir rexnal onssi ssrexv
      ax-mp df-ne sylibr sylbir a1i syl5bi sylbid syld rabn0 oninton sylancr
      imp ) ADEZBDEZFZABGHZFZCUAZAIZWKBIZJZCKUBZKLWOUCJZWOULKEWNCKUDWJWNCKMZWPW
      HWIWQWHWIABTZNZWQWFWIWSOWGWFAAGHZNWIWSAUEWIWRWTWRWTWIABAGUFUGUHUIUJWHWSAP
      IZBPIZTZWLWMTZCXAUMZFZNZWQWHWRXFWFAXAQBXBQWRXFRWGASBSCXAXBABUKUNUOXGXCNZX
      ENZUPWHWQXCXEUQWHXHWQXIXHXAXBEZXBXAEZUPZWHWQXCXLXAURXBURXCXLNRXAAUSZUTXBB
      USUTXAXBVAVCVDWHXJWQXKABCVBWGWFXKWQOWGWFFXKWMWLJZCKMWQBACVBXNWNCKWMWLVEVF
      VGVHVIVJXIWQOWHXIXDNZCXAMZWQXDCXAVKXPXOCKMZWQXAKLXPXQOXAXMVLXOCXAKVMVNWNX
      OCKWLWMVOVFVPVQVRVIVSVTWAWEWNCKWBVPWOWCWD $.
  $}

  ${
    $d A a x $.  $d B a x $.
    $( Lemma for ~ nodense .  If the birthdays of two distinct surreals are
       equal, then the ordinal from ~ nodenselem4 is an element of that
       birthday.  (Contributed by Scott Fenton, 16-Jun-2011.) $)
    nodenselem5 $p |- ( ( ( A e. No /\ B e. No ) /\
                            ( ( bday ` A ) = ( bday ` B ) /\ A <s B ) ) ->
                          |^| { a e. On | (
                                     A ` a ) =/= ( B ` a ) } e.
                          ( bday ` A ) ) $=
      ( vx csur wcel wa cbday cfv wceq cslt wbr cv wne con0 wn imp wb adantr wi
      crab cint sltirr breq2 notbid syl5ibcom con2d ad2ant2rl wral wfun eqfunfv
      cdm nofun syl2an imnan biimpri impcom wrex df-ne rexbii rexnal bitri word
      wss nodenselem4 eloni syl nodmord ad3antrrr nodmon onelon sylan ex anim1d
      ad2antrr fveq2 neeq12d intminss simprl ordtr2 syl22anc rexlimdvaa syl5bir
      weq syl5 exp4b com23 imp32 sylbid bdayval eqeqan12d anbi1d eleq2d 3imtr4d
      mpd ) AEFZBEFZGZAHIZBHIZJZABKLZGZCMZAIZXDBIZNZCOUAUBZWSFZWRAULZBULZJZXBGZ
      XHXJFZXCXIWRXMXNWRXMGZABJZPZXNWPXBXQWQXLWPXBXQWPXPXBWPAAKLZPXPXBPAUCXPXRX
      BABAKUDUEUFUGQUHXOXQXLDMZAIZXSBIZJZDXJUIZGZPZXNWRXQYERXMWRXPYDWPAUJBUJXPY
      DRWQAUMBUMDABUKUNUESWRXLXBYEXNTZWRXBXLYFWRXBXLYEXNXLYEGYCPZWRXBGZXNYEXLYG
      XLYGTYEXLYCUOUPUQYGXTYANZDXJURZYHXNYJYBPZDXJURYGYIYKDXJXTYAUSUTYBDXJVAVBY
      HYIXNDXJYHXSXJFZYIGZGZXHVCZXJVCZXHXSVDZYLXNYHYOYMYHXHOFYOABCVEXHVFVGSWPYP
      WQXBYMAVHVIYNXSOFZYIGZYQYHYMYSYHYLYRYIWPYLYRTWQXBWPYLYRWPXJOFYLYRAVJXJXSV
      KVLVMVOVNQXGYICXSOCDWDXEXTXFYAXDXSAVPXDXSBVPVQVRVGYHYLYIVSYOYPGYQYLGXNXHX
      SXJVTQWAWBWCWEWFWGWHWIWOVMWRXAXLXBWPWQWSXJWTXKAWJZBWJWKWLWPXIXNRWQWPWSXJX
      HYTWMSWNQ $.
  $}

  ${
    $d A a x $.  $d B a x $.
    $( The restriction of a surreal to the abstraction from ~ nodenselem4 is
       still a surreal.  (Contributed by Scott Fenton, 16-Jun-2011.) $)
    nodenselem6 $p |- ( ( ( A e. No /\ B e. No ) /\
                        ( ( bday ` A ) = ( bday ` B ) /\ A <s B ) ) ->
                        ( A |` |^| { a e. On | (
                                     A ` a ) =/= ( B ` a ) } ) e. No ) $=
      ( vx csur wcel wa cbday cfv wceq cslt wbr cv con0 wf wfn crn wss ad2antrr
      syl2anc c1o c2o cpr wne crab cint cres wrex nodenselem4 nofnbday bdayelon
      adantrl nodenselem5 onelssi syl fnssres resss rnss ax-mp norn syl5ss df-f
      sylanbrc feq2 rspcev elno sylibr ) AEFZBEFZGZAHIZBHIJZABKLZGZGZDMZUAUBUCZ
      ACMZAIVRBIUDCNUEUFZUGZOZDNUHZVTEFVOVSNFZVSVQVTOZWBVJVMWCVLABCUIULVOVTVSPZ
      VTQZVQRWDVOAVKPZVSVKRZWEVHWGVIVNAUJSVOVSVKFWHABCUMVKVSAUKUNUOVKVSAUPTVOWF
      AQZVQVTARWFWIRAVSUQVTAURUSVHWIVQRVIVNAUTSVAVSVQVTVBVCWAWDDVSNVPVSVQVTVDVE
      TDVTVFVG $.
  $}

  ${
    $d A a $.  $d B a $.  $d C a $.
    $( Lemma for ~ nodense . ` A ` and ` B ` are equal at all elements of the
       abstraction.  (Contributed by Scott Fenton, 17-Jun-2011.) $)
    nodenselem7 $p |- ( ( ( A e. No /\ B e. No ) /\
                        ( ( bday ` A ) = ( bday ` B ) /\ A <s B ) ) ->
                        ( C e. |^| { a e. On | ( A ` a ) =/= ( B ` a ) }
                          -> ( A ` C ) = ( B ` C ) ) ) $=
      ( csur wcel wa cbday cfv wceq cslt wbr wne con0 wn wi syl fveq2 syl6ibr
      ex cv crab cint nodenselem4 adantrl onelon wss sylan ontri1 con2bid com23
      biimpd imp mpd intss1 nsyl neeq12d elrab notbii syl6ib imnan mpdd con2bii
      df-ne ) AEFBEFGZAHIBHIJZABKLZGGZCDUAZAIZVIBIZMZDNUBZUCZFZCAIZCBIZMZOZVPVQ
      JZVHVOCNFZVSVHVNNFZVOWAPVEVGWBVFABDUDUEZWBVOWAVNCUFZTQVHVOWAVRGZOZWAVSPVH
      VOCVMFZOZWFVHVOWHVHVOGZVNCUGZWGWIWAWJOZVHWBVOWAWCWDUHVHVOWAWKPZVHWBVOWLPW
      CWBWAVOWKWBWAVOWKPWBWAGZVOWKWMWJVOVNCUIUJULTUKQUMUNCVMUOUPTWGWEVLVRDCNVIC
      JVJVPVKVQVICARVICBRUQURUSUTWAVRVASVBVRVTVPVQVDVCS $.
  $}

  ${
    $d A a $.  $d B a $.
    $( Lemma for ~ nodense .  Give a condition for surreal less than when two
       surreals have the same birthday.  (Contributed by Scott Fenton,
       19-Jun-2011.) $)
    nodenselem8 $p |- ( ( A e. No /\ B e. No /\
                            ( bday ` A ) = ( bday ` B ) ) ->
                          ( A <s B <->
                            ( ( A `
                                |^| { a e. On | ( A ` a ) =/= ( B ` a ) } ) =
                              1o /\
                              ( B `
                                |^| { a e. On | ( A ` a ) =/= ( B ` a ) } ) =
                              2o ) ) ) $=
      ( csur wcel cbday cfv wceq wbr c1o c2o wa wi 3impia c0 cop wn nosgnn0 crn
      fvex w3a cslt cv wne con0 crab cint nodenselem5 exp32 ctp sltval2 3adant3
      wb w3o brtp eleq2 biimpd cpr nofnbday fnfvelrn eleq1 syl5ibcom sylan norn
      wfn sseld adantr syld mtoi ex adantl syl9r imp intnand 3ad2antl1 intnanrd
      3orel13 syl2anc com23 syl5bi sylbid mpdd 3mix2 sylibr syl5ibr impbid ) AD
      EZBDEZAFGZBFGZHZUAZABUBIZCUCZAGWNBGUDCUEUFUGZAGZJHZWOBGZKHZLZWLWMWOWIEZWT
      WGWHWKWMXAMWGWHLZWKWMXAABCUHUINWLWMWPWRJOPJKPOKPUJIZXAWTMZWGWHWMXCUMWKABC
      UKULZXCWQWROHZLZWTWPOHZWSLZUNZWLXDJOJKOKWPWRWOATWOBTUOZWLXAXJWTWLXAXJWTMZ
      WLXALZXGQXIQXLXMXFWQWLXAXFQZWGWHWKXAXNMWKXAWOWJEZXBXNWKXAXOWIWJWOUPUQWHXO
      XNMWGWHXOXNWHXOLZXFOJKURZEZRXPXFOBSZEZXRWHBWJVEZXOXFXTMBUSYAXOLWRXSEXFXTW
      JWOBUTWROXSVAVBVCWHXTXRMXOWHXSXQOBVDVFVGVHVIVJVKVLNVMVNXMXHWSWGWHXAXHQWKW
      GXALZXHXRRYBXHOASZEZXRWGAWIVEZXAXHYDMAUSYEXALWPYCEXHYDWIWOAUTWPOYCVAVBVCW
      GYDXRMXAWGYCXQOAVDVFVGVHVIVOVPXGWTXIVQVRVJVSVTWAWBWTWMWLXCWTXJXCWTXGXIWCX
      KWDXEWEWF $.
  $}

  ${
    $d A a x y $.  $d B a x y $.
    $( Given two distinct surreals with the same birthday, there is an older
       surreal lying between the two of them.  Alling's axiom (SD) (Contributed
       by Scott Fenton, 16-Jun-2011.) $)
    nodense $p |- ( ( ( A e. No /\ B e. No ) /\
                      ( ( bday ` A ) = ( bday ` B ) /\ A <s B ) ) ->
                    E. x e. No ( ( bday ` x ) e. ( bday ` A ) /\
                                 A <s x /\ x <s B ) ) $=
      ( va vy csur wcel wa cbday cfv wceq cslt wbr cv con0 wral c1o c2o fveq2
      c0 wne crab cint cres w3a nodenselem6 cdm bdayval syl cin wss nodenselem5
      wrex dmres bdayelon onelssi ad2antrr sseqtrd df-ss sylib syl5eq eqtrd cop
      eqeltrd ctp nodenselem4 adantrl wi nodenselem8 biimpd 3expia imp32 simpld
      w3o eqid jctir 3mix1d fvex 0ex brtp sylibr fveq2d fvnobday breqtrrd fvres
      eqtr3d eqcomd jctil raleq breq12d anbi12d rspcev syl2anc wb simpll sltval
      rgen mpbird adantl nodenselem7 imp ralrimiva simprd 3mix3d eqbrtrd simplr
      syl12anc eleq1d breq2 breq1 3anbi123d syl13anc ) BFGZCFGZHZBIJZCIJKZBCLMZ
      HZHZBDNZBJYACJUADOUBUCZUDZFGZYCIJZXPGZBYCLMZYCCLMZANZIJZXPGZBYILMZYICLMZU
      EZAFUMBCDUFZXTYEYBXPXTYEYCUGZYBXTYDYEYPKYOYCUHUIXTYPYBBUGZUJZYBBYBUNXTYBY
      QUKYRYBKXTYBXPYQXTYBXPGYBXPUKBCDULZXPYBBUOUPUIXMXPYQKXNXSBUHUQURYBYQUSUTV
      AVBZYSVDXTYGENZBJZUUAYCJZKZEYIPZYIBJZYIYCJZQTVCQRVCTRVCVEZMZHZAOUMZXTYBOG
      ZUUDEYBPZYBBJZYBYCJZUUHMZHZUUKXOXRUULXQBCDVFVGZXTUUPUUMXTUUNTUUOUUHXTUUNQ
      KZTTKZHZUUSTRKZHZUUNTKUVBHZVNUUNTUUHMXTUVAUVCUVDXTUUSUUTXTUUSYBCJZRKZXOXQ
      XRUUSUVFHZXMXNXQXRUVGVHXMXNXQUEXRUVGBCDVIVJVKVLZVMTVOZVPVQQTQRTRUUNTYBBVR
      VSVTWAXTYEYCJZUUOTXTYEYBYCYTWBXTYDUVJTKYOYCWCUIWFZWDUUDEYBUUAYBGZUUCUUBUU
      AYBBWEWGZWQWHUUJUUQAYBOYIYBKZUUEUUMUUIUUPUUDEYIYBWIUVNUUFUUNUUGUUOUUHYIYB
      BSYIYBYCSZWJWKWLWMXTXMYDYGUUKWNXMXNXSWOYOAEBYCWPWMWRXTYHUUCUUACJZKZEYIPZU
      UGYICJZUUHMZHZAOUMZXTUULUVQEYBPZUUOUVEUUHMZUWBUURXTUVQEYBXTUVLHUUBUUCUVPU
      VLUUDXTUVMWSXTUVLUUBUVPKBCUUADWTXAWFXBXTUUOTUVEUUHUVKXTTQKZUVETKHZUWEUVFH
      ZUUTUVFHZVNTUVEUUHMXTUWHUWFUWGXTUVFUUTXTUUSUVFUVHXCUVIWHXDQTQRTRTUVEVSYBC
      VRVTWAXEUWAUWCUWDHAYBOUVNUVRUWCUVTUWDUVQEYIYBWIUVNUUGUUOUVSUVEUUHUVOYIYBC
      SWJWKWLXGXTYDXNYHUWBWNYOXMXNXSXFAEYCCWPWMWRYNYFYGYHUEAYCFYIYCKZYKYFYLYGYM
      YHUWIYJYEXPYIYCISXHYIYCBLXIYIYCCLXJXKWLXL $.
  $}

  ${
    $d A w x y z $.  $d X w x y z $.  $d Y w y z $.
    $( Lemma for ~ nocvxmin .  Given two birthday-minimal elements of a convex
       class of surreals, they are not comparable.  (Contributed by Scott
       Fenton, 30-Jun-2011.) $)
    nocvxminlem $p |- ( ( A C_ No /\ A. x e. A A. y e. A
                           A. z e. No ( ( x <s z /\ z <s y ) -> z e. A ) ) ->
                         ( ( ( X e. A /\ Y e. A ) /\
                             ( ( bday ` X ) = |^| ( bday " A ) /\
                               ( bday ` Y ) = |^| ( bday " A ) ) ) ->
                           -. X <s Y ) ) $=
      ( vw csur wss cv cslt wbr wa wcel wi wral cbday wceq wn con0 cfv cima w3a
      cint wrex breq1 anbi1d imbi1d ralbidv breq2 anbi2d rspc2v anbi12d imbi12d
      weq eleq1 cdm bdaydm sseq2i wfun bdayfun funfvima2 mpan sylbir imp intss1
      rspcv syl wb wne crn imassrn bdayrn sseqtri ne0i oninton sylancr bdayelon
      c0 ontri1 sylancl mpbid ex eleq2 notbid biimprcd syl6 com3l adantrd com35
      com4l impcom imp42 con2d 3anass notbii imnan bitr4i sylibr nrexdv anim12d
      syl8 ssel eqtr3 anim12i anasss adantlr nodense anassrs sylan mtand ) DHIZ
      AJZCJZKLZXNBJZKLZMZXNDNZOZCHPZBDPADPZMZEDNZFDNZMZEQUAZQDUBZUDZRZFQUAZYIRZ
      MZMZEFKLZSYCYNMZYOGJZQUAZYGNZEYQKLZYQFKLZUCZGHUEZYPUUBGHYPYQHNZMZYSYTUUAM
      ZSOZUUBSZUUEUUFYSYCYFYMUUDUUFYSSZOZYBXLYFYMUUDUUJOOZOYFYBXLUUKYFYBEXNKLZX
      NFKLZMZXSOZCHPZXLUUKOYAUUPUULXQMZXSOZCHPABEFDDXMERZXTUURCHUUSXRUUQXSUUSXO
      UULXQXMEXNKUFUGUHUIXPFRZUURUUOCHUUTUUQUUNXSUUTXQUUMUULXPFXNKUJUKUHUIULUUD
      UUPXLYMUUJUUDUUPUUFYMXLUUIUUDUUPUUFYQDNZYMXLUUIOZOUUOUUFUVAOCYQHCGUOZUUNU
      UFXSUVAUVCUULYTUUMUUAXNYQEKUJXNYQFKUFUMXNYQDUPUNVGUVAYJUVBYLXLUVAYJUUIXLU
      VAYRYINZSZYJUUIOXLUVAUVEXLUVAMZYIYRIZUVEUVFYRYHNZUVGXLUVAUVHXLDQUQZIZUVAU
      VHOZUVIHDURUSQUTUVJUVKVADYQQVBVCVDVEZYRYHVFVHUVFYITNZYRTNUVGUVEVIUVFYHTIY
      HVSVJZUVMYHQVKTQDVLVMVNUVFUVHUVNUVLYHYRVOVHYHVPVQYQVRYIYRVTWAWBWCYJUUIUVE
      YJYSUVDYGYIYRWDWEWFWGWHWIXBWJWKWGWHWLWMWNUUHYSUUFMZSUUGUUBUVOYSYTUUAWOWPY
      SUUFWQWRWSWTYPEHNZFHNZMZYGYKRZMZYOUUCXLYNUVTYBXLYFYMUVTXLYFMUVRYMUVSXLYFU
      VRXLYDUVPYEUVQDHEXCDHFXCXAVEYGYKYIXDXEXFXGUVRUVSYOUUCGEFXHXIXJXKWC $.
  $}

  ${
    $d A t w x y z $.
    $( Given a non-empty convex class of surreals, there is a unique
       birthday-minimal element of that class.  (Contributed by Scott Fenton,
       30-Jun-2011.) $)
    nocvxmin $p |- ( ( A =/= (/) /\ A C_ No /\
                        A. x e. A A. y e. A
                           A. z e. No ( ( x <s z /\ z <s y ) -> z e. A ) ) ->
                      E! w e. A ( bday ` w ) = |^| ( bday " A ) ) $=
      ( vt c0 wne csur wss cv cslt wbr wa wcel wi wral cbday cfv imp w3a bdayrn
      cima cint wceq wrex weq wreu con0 crn imassrn sseqtri wex cdm bdaydm wfun
      sseq2i bdayfun funfvima2 mpan sylbir elex2 syl6 exlimdv n0 3imtr4g impcom
      onint sylancr wb wfn bdayfn fvelimab adantl mpbid 3adant3 wn ssel anim12d
      ad2ant2r nocvxminlem ancom anbi12i syl5bi slttrieq2 biimpar exp32 3adant1
      syl12anc ralrimivv fveq2 eqeq1d reu4 sylanbrc ) EGHZEIJZAKZCKZLMWRBKLMNWR
      EOPCIQBEQAEQZUADKZRSZREUCZUDZUEZDEUFZXDFKZRSZXCUEZNZDFUGZPZFEQDEQZXDDEUHW
      OWPXEWSWOWPNZXCXBOZXEXMXBUIJXBGHZXNXBRUJUIREUKUBULWPWOXOWPWQEOZAUMWTXBODU
      MZWOXOWPXPXQAWPXPWQRSZXBOZXQWPERUNZJZXPXSPZXTIEUOUQRUPYAYBUREWQRUSUTVADXR
      XBVBVCVDAEVEDXBVEVFVGXBVHVIWPXNXEVJZWORIVKWPYCVLDIEXCRVMUTVNVOVPWPWSXLWOW
      PWSNZXKDFEEYDWTEOZXFEOZNZXIXJYDYGXINZNWTIOZXFIOZNZWTXFLMVQZXFWTLMVQZXJWPY
      GYKWSXIWPYGYKWPYEYIYFYJEIWTVREIXFVRVSTVTYDYHYLABCEWTXFWATYDYHYMYHYFYENZXH
      XDNZNYDYMYGYNXIYOYEYFWBXDXHWBWCABCEXFWTWAWDTYKXJYLYMNWTXFWEWFWIWGWJWHXDXH
      DFEXJXAXGXCWTXFRWKWLWMWN $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers: Upper and Lower Bounds
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for ~ nobndup and ~ nobnddown .  The successor of the union of the
     image of the birthday function under a set is an ordinal.  (Contributed by
     Scott Fenton, 20-Aug-2011.) $)
  nobndlem1 $p |- ( A e. V -> suc U. ( bday " A ) e. On ) $=
    ( wcel cbday cima cuni word wa csuc con0 wfun bdayfun funimaexg mpan uniexg
    cvv syl wss crn imassrn bdayrn sseqtri ssorduni ax-mp jctil sucelon bitr3i
    elon2 sylib ) ABCZDAEZFZGZULPCZHZULIJCZUJUNUMUJUKPCZUNDKUJUQLDABMNUKPOQUKJR
    UMUKDSJDATUAUBUKUCUDUEUOULJCUPULUHULUFUGUI $.

  ${
    $d F a b n $.  $d X a b $.
    nobndlem2.1 $e |- X e. { 1o , 2o } $.
    nobndlem2.2 $e |- C = |^| { a e. On |
                                A. n e. F E. b e. a ( n ` b ) =/= X } $.
    $( Lemma for ~ nobndup and ~ nobnddown .  Show a particular abstraction is
       an ordinal.  (Contributed by Scott Fenton, 17-Aug-2011.) $)
    nobndlem2 $p |- ( ( F C_ No /\ F e. A ) -> C e. On ) $=
      ( csur wss wcel cv cfv wne wrex con0 cbday c0 wceq wa wral crab cint cima
      cuni csuc nobndlem1 ssel2 bdaydm syl6eleqr simpr wfun wi bdayfun funfvima
      cdm mpan sylc elssuni syl wb bdayelon crn imassrn bdayrn sseqtri ssorduni
      ax-mp ordsssuc mp2an sylib nosgnn0i fvnobday neeq1d mpbiri rspcev syl2anc
      word fveq2 ralrimiva rexeq ralbidv syl2anr onintrab2 syl5eqel ) DJKZDALZU
      AZBGMZCMZNZEOZGFMZPZCDUBZFQUCUDZQIWIWPFQPZWQQLWHRDUEZUFZUGZQLWMGXAPZCDUBZ
      WRWGDAUHWGXBCDWGWKDLZUAZWKRNZXALZXFWKNZEOZXBXEXFWTKZXGXEXFWSLZXJXEWKRUQZL
      ZXDXKXEWKJXLDJWKUIZUJUKWGXDULRUMXMXDXKUNUODWKRUPURUSXFWSUTVAXFQLWTVSZXJXG
      VBWKVCWSQKXOWSRVDQRDVEVFVGWSVHVIXFWTVJVKVLXEXISEOEHVMXEXHSEXEWKJLXHSTXNWK
      VNVAVOVPWMXIGXFXAWJXFTWLXHEWJXFWKVTVOVQVRWAWPXCFXAQWNXATWOXBCDWMGWNXAWBWC
      VQWDWPFWEVLWF $.

    $( Lemma for ~ nobndup and ~ nobnddown .  Calculate the birthday of
       ` ( C X. { X } ) ` .  (Contributed by Scott Fenton, 17-Aug-2011.) $)
    nobndlem3 $p |- ( ( F C_ No /\ F e. A ) ->
                       ( bday ` ( C X. { X } ) ) = C ) $=
      ( csur wss wcel wa csn cxp cbday cfv cdm con0 wceq nobndlem2 noxpsgn 3syl
      bdayval c0 wne c1o c2o cpr elexi snnz dmxp ax-mp syl6eq ) DJKDALMZBENZOZP
      QZUQRZBUOBSLUQJLURUSTABCDEFGHIUABEHUBUQUDUCUPUEUFUSBTEEUGUHUIHUJUKBUPULUM
      UN $.

  $}

  ${
    $d A x y $.  $d X x y $.
    nobndlem4.1 $e |- X e. { 1o , 2o } $.
    $( Lemma for ~ nobndup and ~ nobnddown .  The infimum of the class of all
       ordinals such that ` A ` is not ` X ` is an ordinal.  (Contributed by
       Scott Fenton, 17-Aug-2011.) $)
    nobndlem4 $p |- ( A e. No ->
                        |^| { x e. On | ( A ` x ) =/= X } e. On ) $=
      ( csur wcel cv cfv wne con0 wrex crab cbday bdayelon c0 nosgnn0i fvnobday
      cint neeq1d mpbiri wceq fveq2 rspcev sylancr onintrab2 sylib ) BEFZAGZBHZ
      CIZAJKZUJAJLRJFUGBMHZJFULBHZCIZUKBNUGUNOCICDPUGUMOCBQSTUJUNAULJUHULUAUIUM
      CUHULBUBSUCUDUJAUEUF $.

    $( Lemma for ~ nobndup and ~ nobnddown .  There is always a minimal value
       of a surreal that is not a given sign.  (Contributed by Scott Fenton,
       3-Aug-2011.) $)
    nobndlem5 $p |- ( A e. No ->
                      ( A ` |^| { x e. On | ( A ` x ) =/= X } ) =/= X ) $=
      ( csur wcel cv cfv wne con0 crab cint wa c0 ssrab2 neeq1d wceq fveq2 nfcv
      wss cbday nosgnn0i fvnobday mpbiri bdayelon elrab3 ax-mp sylibr syl onint
      wb ne0i sylancr nfrab1 nfint nffv nfne elrabf sylib simprd ) BEFZAGZBHZCI
      ZAJKZLZJFZVFBHZCIZVAVFVEFZVGVIMVAVEJTVENIZVJVDAJOVABUAHZVEFZVKVAVLBHZCIZV
      MVAVONCICDUBVAVNNCBUCPUDVLJFVMVOUKBUEVDVOAVLJVBVLQVCVNCVBVLBRPUFUGUHVEVLU
      LUIVEUJUMVDVIAVFJAVEVDAJUNUOZAJSAVHCAVFBABSVPUPACSUQVBVFQVCVHCVBVFBRPURUS
      UT $.
  $}

  ${
    $d A a b x $.  $d F a b $.  $d X a b x $.  $d X n $.  $d a b n $.
    $d A n $.  $d F n $.
    nobndlem6.1 $e |- X e. { 1o , 2o } $.
    nobndlem6.2 $e |- C = |^| { a e. On |
                                A. n e. F E. b e. a ( n ` b ) =/= X } $.
    $( Lemma for ~ nobndup and ~ nobnddown .  Given an element ` A ` of ` F ` ,
       then the first position where it differs from ` X ` is strictly less
       than ` C ` (Contributed by Scott Fenton, 3-Aug-2011.) $)
    nobndlem6 $p |- ( ( F C_ No /\ A e. F ) ->
                     |^| { x e. On | ( A ` x ) =/= X } e. C ) $=
      ( csur wss wcel wa cv cfv wne con0 wrex neeq1d crab cint wral wi bdayelon
      cbday ssel2 c0 nosgnn0i fvnobday mpbiri syl wceq rspcev sylancr onintrab2
      fveq2 sylib fveq1 rspcv ad2antlr wel ad2antrr simplr onelon anim1i anasss
      rexbidv weq intminss adantll ontr2 imp syl22anc rexlimdvaa syld ralrimiva
      simprl elintrabg biimpar syl2anc syl6eleqr ) EKLZBEMZNZAOZBPZFQZARUAUBZHO
      ZDOZPZFQZHGOZSZDEUCZGRUAUBZCWEWIRMZWPWIWNMZUDZGRUCZWIWQMZWEWHARSZWRWEBUFP
      ZRMXDBPZFQZXCBUEWEBKMZXFEKBUGXGXFUHFQFIUIXGXEUHFBUJTUKULWHXFAXDRWFXDUMWGX
      EFWFXDBUQTUNUOWHAUPURZWEWTGRWEWNRMZNZWPWJBPZFQZHWNSZWSWDWPXMUDWCXIWOXMDBE
      WKBUMZWMXLHWNXNWLXKFWJWKBUSTVHUTVAXJXLWSHWNXJHGVBZXLNZNWRXIWIWJLZXOWSWEWR
      XIXPXHVCWEXIXPVDXIXPXQWEXIXPNWJRMZXLNZXQXIXOXLXSXIXONXRXLWNWJVEVFVGWHXLAW
      JRAHVIWGXKFWFWJBUQTVJULVKXJXOXLVRWRXINXQXONWSWIWJWNVLVMVNVOVPVQWRXBXAWPGW
      IRRVSVTWAJWB $.
  $}

  ${
    $d A a b x $.  $d F a b $.  $d X a b x $.  $d a b n $.  $d A n $.
    $d F n $.  $d X n $.
    nobndlem7.1 $e |- X e. { 1o , 2o } $.
    nobndlem7.2 $e |- C = |^| { a e. On |
                                A. n e. F E. b e. a ( n ` b ) =/= X } $.
    $( Lemma for ~ nobndup and ~ nobnddown .  Calculate the value of
       ` ( C X. { X } ) ` at the minimal ordinal whose value is different from
       ` X ` .  (Contributed by Scott Fenton, 3-Aug-2011.) $)
    nobndlem7 $p |- ( ( F C_ No /\ A e. F ) ->
                      ( ( C X. { X } ) ` |^| { x e. On | ( A ` x ) =/= X } ) =
                      X ) $=
      ( csur wss wcel wa cv cfv wne con0 crab cint csn cxp wceq nobndlem6 elexi
      c1o c2o cpr fvconst2 syl ) EKLBEMNAOBPFQARSTZCMUKCFUAUBPFUCABCDEFGHIJUDCF
      UKFUFUGUHIUEUIUJ $.
  $}

  ${
    $d F a b n $.  $d S a b $.  $d X a b n $.
    nobndlem8.1 $e |- S e. { 1o , 2o } $.
    nobndlem8.2 $e |- C = |^| { a e. On |
                                A. n e. F E. b e. a ( n ` b ) =/= S } $.
    $( Lemma for ~ nobndup and ~ nobnddown .  Bound the birthday of
       ` ( C X. { S } ) ` above.  (Contributed by Scott Fenton,
       10-Apr-2017.) $)
    nobndlem8 $p |- ( ( F C_ No /\ F e. A ) ->
    ( bday ` ( C X. { S } ) ) C_ suc U. ( bday " F ) ) $=
      ( wcel csur wss cvv cbday cfv wa cv wne wrex con0 csn cima cuni csuc elex
      cxp wral crab nobndlem3 syl6eq nobndlem1 adantl w3a bdayfn fnfvima mp3an1
      cint wfn 3adant2 elssuni syl wb bdayelon sucelon 3ad2ant2 onsssuc sylancr
      sylibr mpbid ssel2 fvnobday nosgnn0i a1i eqnetrd wceq fveq2 neeq1d rspcev
      c0 syl2anc 3expa ralrimiva rexeq ralbidv intminss eqsstrd sylan2 ) EAJEKL
      ZEMJZBCUAUFNOZNEUBZUCZUDZLEAUEWHWIPZWJGQZDQZOZCRZGFQZSZDEUGZFTUHUQZWMWNWJ
      BXBMBDECFGHIUIIUJWNWMTJZWRGWMSZDEUGZXBWMLWIXCWHEMUKZULWNXDDEWHWIWPEJZXDWH
      WIXGUMZWPNOZWMJZXIWPOZCRZXDXHXIWLLZXJXHXIWKJZXMWHXGXNWINKURWHXGXNUNKENWPU
      OUPUSXIWKUTVAXHXITJWLTJZXMXJVBWPVCWIWHXOXGWIXCXOXFWLVDVHVEXIWLVFVGVIWHXGX
      LWIWHXGPWPKJZXLEKWPVJXPXKVSCWPVKVSCRXPCHVLVMVNVAUSWRXLGXIWMWOXIVOWQXKCWOX
      IWPVPVQVRVTWAWBXAXEFWMTWSWMVOWTXDDEWRGWSWMWCWDWEVTWFWG $.
  $}

  ${
    $d A x y a b c d k n $.
    $( Any set of surreals is bounded above by a surreal with a birthday no
       greater than the successor of their maximum birthday.  (Contributed by
       Scott Fenton, 10-Apr-2017.) $)
    nobndup $p |- ( ( A C_ No /\ A e. V ) ->
        E. x e. No ( A. y e. A y <s x /\ ( bday ` x ) C_
        suc U. ( bday " A ) ) ) $=
      ( vb vn va vd vk csur wcel wa cv cfv c2o con0 c1o syl wceq c0 vc wss wrex
      wne wral crab cint csn cxp cslt wbr cbday cima cuni csuc elexi prid2 eqid
      2on nobndlem2 noxp2o cvv elex cop ssel2 adantlr adantr nobndlem4 wn wi wb
      ctp onelon sylan ontri1 syl2anc biimpd con2d ex pm2.43d intss1 nsyl df-ne
      imp fveq2 neeq1d elrab3 biimprd syl5bir mt3d nobndlem6 onelss sylc sselda
      weq fvconst2 eqtr4d ralrimiva w3o wo nobndlem5 neneqd 3orel3 orcomd jctir
      nofv andir sylib olcd 3orass sylibr fvex nobndlem7 breqtrrd raleq breq12d
      brtp anbi12d rspcev syl12anc sltval biimpar syl21anc sylan2 breq2 ralbidv
      nobndlem8 sseq1d ) CJUBZCDKZLZEMFMNOUDEGMUCFCUEGPUFUGZOUHUIZJKZBMZYMUJUKZ
      BCUEZYMULNZULCUMUNUOZUBZYOAMZUJUKZBCUEZUUAULNZYSUBZLZAJUCYKYLPKZYNDYLFCOG
      EQOOPUSUPZUQZYLURZUTYLVAZRYJYICVBKZYQCDVCYIUULLZYPBCUUMYOCKZLZYOJKZYNHMZY
      ONZUUQYMNZSZHUAMZUEZUVAYONZUVAYMNZQTVDQOVDTOVDVLZUKZLZUAPUCZYPYIUUNUUPUUL
      CJYOVEVFZUUMYNUUNUUMUUGYNVBYLFCOGEUUIUUJUTZUUKRVGUUOIMZYONZOUDZIPUFZUGZPK
      ZUUTHUVOUEZUVOYONZUVOYMNZUVEUKZUVHUUOUUPUVPUVIIYOOUUIVHRZUUOUUTHUVOUUOUUQ
      UVOKZLZUUROUUSUWCUUROSZUUQUVNKZUWCUVOUUQUBZUWEUUOUWBUWFVIZUUOUWBUWGUUOUWB
      UWBUWGVJUWCUWFUWBUWCUWFUWBVIZUWCUVPUUQPKZUWFUWHVKUUOUVPUWBUWAVGUUOUVPUWBU
      WIUWAUVOUUQVMVNZUVOUUQVOVPVQVRVSVTWDUUQUVNWAWBUWDVIUUROUDZUWCUWEUUROWCUWC
      UWIUWKUWEVJUWJUWIUWEUWKUVMUWKIUUQPIHWOUVLUUROUVKUUQYOWEWFWGWHRWIWJUWCUUQY
      LKUUSOSUUOUVOYLUUQUUOUUGUVOYLKZUVOYLUBUUMUUGUUNUVJVGYIUUNUWLUULIYOYLFCOGE
      UUIUUJWKVFYLUVOWLWMWNYLOUUQUUHWPRWQWRUUOUVROUVSUVEUUOUVRQSZOTSLZUWMOOSZLZ
      UVRTSZUWOLZWSZUVROUVEUKUUOUWNUWPUWRWTZWTUWSUUOUWTUWNUUOUWMUWQWTZUWOLUWTUU
      OUXAUWOUUOUWQUWMUUOUVROSZVIUWQUWMUXBWSZUWQUWMWTUUOUVROUUOUUPUVROUDUVIIYOO
      UUIXARXBUUOUUPUXCUVIYOUVOXFRUWQUWMUXBXCWMXDOURXEUWMUWQUWOXGXHXIUWNUWPUWRX
      JXKQTQOTOUVROUVOYOXLUUHXQXKYIUUNUVSOSUULIYOYLFCOGEUUIUUJXMVFXNUVGUVQUVTLU
      AUVOPUVAUVOSZUVBUVQUVFUVTUUTHUVAUVOXOUXDUVCUVRUVDUVSUVEUVAUVOYOWEUVAUVOYM
      WEXPXRXSXTUUPYNLYPUVHUAHYOYMYAYBYCWRYDDYLOFCGEUUIUUJYGUUFYQYTLAYMJUUAYMSZ
      UUCYQUUEYTUXEUUBYPBCUUAYMYOUJYEYFUXEUUDYRYSUUAYMULWEYHXRXSXT $.

    $( Any set of surreals is bounded below by a surreal with a birthday no
       greater than the successor of their maximum birthday.  (Contributed by
       Scott Fenton, 10-Apr-2017.) $)
    nobnddown $p |- ( ( A C_ No /\ A e. V ) ->
        E. x e. No ( A. y e. A x <s y /\ ( bday ` x ) C_
        suc U. ( bday " A ) ) ) $=
      ( vb vn vd vk wcel csur wss cv cfv wa c1o con0 c2o syl wceq c0 va vc cslt
      cvv wbr wral cbday cima cuni csuc wrex elex wne crab cint csn elexi prid1
      cxp 1on nobndlem2 noxp1o cop ctp adantr ssel2 adantlr nobndlem4 nobndlem6
      eqid onelss sylc sselda fvconst2 wn wi onss ontri1 syl2anc biimpd pm2.43d
      wb con2d ex imp intss1 nsyl df-ne weq fveq2 neeq1d elrab3 biimprd syl5bir
      mt3d eqtr4d ralrimiva wo nobndlem5 neneqd nofv 3orel2 jctil ex-natded9.20
      orcd fvex brtp df-3or bitri sylibr eqbrtrd raleq breq12d anbi12d syl12anc
      w3o rspcev sltval biimpar syl21anc nobndlem8 breq1 ralbidv sseq1d sylan2
      ) CDICJKZCUDIZALZBLZUCUEZBCUFZYHUGMZUGCUHUIUJZKZNZAJUKZCDULYFYGNZELFLMOUM
      EUALUKFCUFUAPUNUOZOUPUSZJIZYSYIUCUEZBCUFZYSUGMZYMKZYPYQYRPIZYTUDYRFCOUAEO
      QOPUTUQZURZYRVJZVAZYRVBRZYQUUABCYQYICIZNZYTYIJIZGLZYSMZUUNYIMZSZGUBLZUFZU
      URYSMZUURYIMZOTVCOQVCTQVCVDZUEZNZUBPUKZUUAYQYTUUKUUJVEYFUUKUUMYGCJYIVFZVG
      ZUULHLZYIMZOUMZHPUNZUOZPIZUUQGUVLUFZUVLYSMZUVLYIMZUVBUEZUVEYFUUKUVMYGYFUU
      KNUUMUVMUVFHYIOUUGVHRVGZUULUUQGUVLUULUUNUVLIZNZUUOOUUPUVTUUNYRIUUOOSUULUV
      LYRUUNUULUUEUVLYRIZUVLYRKYQUUEUUKUUIVEYFUUKUWAYGHYIYRFCOUAEUUGUUHVIVGZYRU
      VLVKVLVMYROUUNUUFVNRUVTUUPOSZUUNUVKIZUVTUVLUUNKZUWDUULUVSUWEVOZUULUVSUWFU
      ULUVSUVSUWFVPUVTUWEUVSUVTUWEUVSVOZUVTUVMUUNPIZUWEUWGWBUULUVMUVSUVRVEUULUV
      LPUUNUULUVMUVLPKUVRUVLVQRVMZUVLUUNVRVSVTWCWDWAWEUUNUVKWFWGUWCVOUUPOUMZUVT
      UWDUUPOWHUVTUWHUWJUWDVPUWIUWHUWDUWJUVJUWJHUUNPHGWIUVIUUPOUVHUUNYIWJWKWLWM
      RWNWOWPWQUULUVOOUVPUVBUULUWAUVOOSUWBYROUVLUUFVNRUULOOSZUVPTSZNZUWKUVPQSZN
      ZWRZOTSUWNNZWRZOUVPUVBUEZUULUWPUWQUULUWKUWLUWNUULUWLUWNWRZUWKUULUVPOSZVOU
      WLUXAUWNXPZUWTUULUVPOUULUUMUVPOUMUVGHYIOUUGWSRWTUULUUMUXBUVGYIUVLXARUWLUX
      AUWNXBVLOVJXCXDXEUWSUWMUWOUWQXPUWROTOQTQOUVPUUFUVLYIXFXGUWMUWOUWQXHXIXJXK
      UVDUVNUVQNUBUVLPUURUVLSZUUSUVNUVCUVQUUQGUURUVLXLUXCUUTUVOUVAUVPUVBUURUVLY
      SWJUURUVLYIWJXMXNXQXOYTUUMNUUAUVEUBGYSYIXRXSXTWQUDYROFCUAEUUGUUHYAYOUUBUU
      DNAYSJYHYSSZYKUUBYNUUDUXDYJUUABCYHYSYIUCYBYCUXDYLUUCYMYHYSUGWJYDXNXQXOYE
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Surreal Numbers: Full-Eta Property
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Statement of full theorem:
     |- ( ( ( A C_ No /\ A e. V ) /\ ( B C_ No /\ B e. W ) /\
            A. x e. A A. y e. B x <s y ) ->
          E. z e. No ( A. x e. A x <s z /\ A. y e. B z <s y /\
                       ( bday ` z ) C_ suc U. ( bday " ( A u. B ) ) ) )
  $)

  ${
    $d L a b c d k n $.  $d A d x $.  $d a n x z $.  $d b x $.  $d b z $.
    $d c x $.  $d k x $.  $d L x $.  $d L z $.  $d R n $.  $d R y $.  $d R z $.
    $d X a $.  $d X b $.  $d X n $.  $d X z $.

    $( Lemma for nofull (future) .  The full statement of the axiom when ` R `
       is empty.  (Contributed by Scott Fenton, 3-Aug-2011.) $)
    nofulllem1 $p |- ( R = (/) ->
                      ( ( ( L C_ No /\ L e. V ) /\ ( R C_ No /\ R e. W ) /\
                          A. x e. L A. y e. R x <s y ) ->
                        E. z e. No ( A. x e. L x <s z /\
                                     A. y e. R z <s y /\
                 ( bday ` z ) C_ suc U. ( bday " ( L u. R ) ) ) ) ) $=
      ( csur wss wcel wa cv cslt wbr wral w3a cbday cima c0 wceq cuni csuc wrex
      cfv cun nobndup 3ad2ant1 raleq uneq2 un0 syl6eq imaeq2d unieqd syl sseq2d
      suceq anbi12d ral0 biantrur syl6rbbr anbi2d 3anass syl6bbr rexbidv syl5ib
      ) EHIEFJKZDHIDGJKZALZBLZMNBDOAEOZPVHCLZMNAEOZVKQUDZQERZUAZUBZIZKZCHUCZDST
      ZVLVKVIMNZBDOZVMQEDUEZRZUAZUBZIZPZCHUCVFVGVSVJCAEFUFUGVTVRWHCHVTVRVLWBWGK
      ZKWHVTVQWIVLVTWIWABSOZVQKVQVTWBWJWGVQWABDSUHVTWFVPVMVTWEVOTWFVPTVTWDVNVTW
      CEQVTWCESUEEDSEUIEUJUKULUMWEVOUPUNUOUQWJVQWABURUSUTVAVLWBWGVBVCVDVE $.
  $}

  ${
    $d a b c d k n y z $.  $d B d y $.  $d L n z $.  $d L x $.
    $d R a b c d n y z $.  $d X a b n z $.
    $( Lemma for nofull (future) .  The full statement of the axiom when ` L `
       is empty.  (Contributed by Scott Fenton, 3-Aug-2011.) $)
    nofulllem2 $p |- ( L = (/) ->
                      ( ( ( L C_ No /\ L e. V ) /\ ( R C_ No /\ R e. W ) /\
                          A. x e. L A. y e. R x <s y ) ->
                        E. z e. No ( A. x e. L x <s z /\
                                     A. y e. R z <s y /\
                 ( bday ` z ) C_ suc U. ( bday " ( L u. R ) ) ) ) ) $=
      ( csur wss wcel wa cv cslt wbr wral w3a cbday c0 wceq cun cima cuni uneq1
      cfv csuc wrex nobnddown 3ad2ant2 biantrurd uncom un0 eqtri syl6eq imaeq2d
      rzal unieqd suceq syl sseq2d bicomd anbi12d df-3an syl6bbr rexbidv syl5ib
      ) EHIEFJKZDHIDGJKZALZBLZMNBDOAEOZPCLZVIMNBDOZVKQUDZQDUAZUBZUEZIZKZCHUFZER
      SZVHVKMNZAEOZVLVMQEDTZUAZUBZUEZIZPZCHUFVGVFVSVJCBDGUGUHVTVRWHCHVTVRWBVLKZ
      WGKWHVTVLWIVQWGVTWBVLWAAEUOUIVTWGVQVTWFVPVMVTWEVOSWFVPSVTWDVNVTWCDQVTWCRD
      TZDERDUCWJDRTDRDUJDUKULUMUNUPWEVOUQURUSUTVAWBVLWGVBVCVDVE $.
  $}

  ${
    $( Lemma for nofull (future) .  Restriction of surreal number to a superset
       of its birthday does not change anything.  (Contributed by Scott Fenton,
       25-Apr-2017.) $)
    nofulllem3 $p |- ( ( A C_ No /\ X e. A /\ A C_ S ) ->
        ( X |` U. ( bday " S ) ) = X ) $=
      ( csur wss wcel w3a wrel cdm cbday cima cuni cres wceq wa ssel2 nofun syl
      wfun 3adant3 funrel bdayval bdaydm syl6eleqr bdayfun jctil simpr funfvima
      cfv sylc elssuni eqsstr3d imass2 unissd 3ad2ant3 sstrd relssres syl2anc )
      ADEZCAFZABEZGZCHZCIZJBKZLZECVFMCNUSUTVCVAUSUTOZCDFZVCADCPZVHCSVCCQCUARRTV
      BVDJAKZLZVFUSUTVDVKEVAVGVDCJUIZVKVGVHVLVDNVICUBRVGVLVJFZVLVKEVGJSZCJIZFZO
      UTVMVGVPVNVGCDVOVIUCUDUEUFUSUTUGACJUHUJVLVJUKRULTVAUSVKVFEUTVAVJVEABJUMUN
      UOUPCVFUQUR $.
  $}

  ${
    $d L x y a $.  $d R x y a $.  $d W x y $.  $d V x y $.
    nofulllem4.1 $e |- M =
      |^| { a e. On | A. x e. L A. y e. R ( x |` a ) =/= ( y |` a ) } $.
    $( Lemma for nofull (future) .  Show a particular abstraction is an
       ordinal.  (Contributed by Scott Fenton, 25-Apr-2017.) $)
    nofulllem4 $p |- ( ( ( L C_ No /\ L e. V ) /\ ( R C_ No /\ R e. W ) /\
                          A. x e. L A. y e. R x <s y ) -> M e. On ) $=
      ( csur wss wcel wa cv cslt wral cres wne con0 syl2an crab cint wrex cbday
      wbr w3a cun cima cuni cvv unexg csuc nobndlem1 sucelon sylibr syl 3adant3
      ad2ant2l wi wn simprl simpr ssel2 sltirr weq breq1 biimprcd necon2ad 3syl
      notbid impr wceq simpll ssun1 nofulllem3 mp3an3 simplr ssun2 3netr4d expr
      anassrs ralimdva 3impia reseq2 neeq12d 2ralbidv rspcev onintrab2 syl5eqel
      syl2anc sylib ) DJKZDFLZMZCJKZCGLZMZANZBNZOUEZBCPZADPZUFZEWRHNZQZWSXDQZRZ
      BCPADPZHSUAUBZSIXCXHHSUCZXISLXCUDDCUGZUHUIZSLZWRXLQZWSXLQZRZBCPZADPZXJWNW
      QXMXBWMWPXMWLWOWMWPMXKUJLZXMDCFGUKXSXLULSLXMXKUJUMXLUNUOUPURUQWNWQXBXRWNW
      QMZXAXQADXTWRDLZMWTXPBCXTYAWSCLZWTXPUSXTYAYBMZWTXPXTYCWTMZMWRWSXNXOXTYCWT
      WRWSRZXTYCMWSJLZWSWSOUEZUTZWTYEUSXTWOYBYFYCWNWOWPVAZYAYBVBCJWSVCTWSVDYHWT
      WRWSABVEZWTUTYHYJWTYGWRWSWSOVFVJVGVHVIVKXTWLYAXNWRVLZYDWLWMWQVMYAYBWTVMWL
      YADXKKYKDCVNDXKWRVOVPTXTWOYBXOWSVLZYDYIYAYBWTVQWOYBCXKKYLCDVRCXKWSVOVPTVS
      VTWAWBWBWCXHXRHXLSXDXLVLZXGXPABDCYMXEXNXFXOXDXLWRWDXDXLWSWDWEWFWGWJXHHWHW
      KWI $.
  $}

  ${
    $d L x y f g h a b j $.  $d R x y h f g a b j $.  $d R x y h f g a b j $.
    $d W x y f g h a b j $.  $d V x y f g h a b j $.  $d M a b f g h j $.
    $d S b j $.
    nofulllem5.1 $e |- M =
      |^| { a e. On | A. x e. L A. y e. R ( x |` a ) =/= ( y |` a ) } $.
    nofulllem5.2 $e |- S = { f | E. g e. L E. h e. R E. a e. M
         ( ( g |` a ) = f /\ ( h |` a ) = f ) } $.
    nofulllem5.3 $e |- X = U. S $.
    $( Lemma for nofull (future) .  Here, we introduce a new surreal number
       ` X ` .  Eventually, we will show that either ` X ` or a related surreal
       number has the required properties for the final theorem.  We begin by
       calculating the domain of ` X ` .  (Contributed by Scott Fenton,
       1-May-2017.) $)
    nofulllem5 $p |- ( ( ( L C_ No /\ L e. V ) /\ ( R C_ No /\ R e. W ) /\
                         A. x e. L A. y e. R x <s y ) -> dom X = U. M ) $=
      ( vb wcel wa wrex vj csur wss cslt wbr wral w3a cdm ciun cuni dmeqi dmuni
      cv eqtri iunss cres wceq vex weq eqeq2 anbi12d rexbidv 2rexbidv elab2 cin
      inss1 elssuni syl5ss dmres dmeq syl5eqr sseq1d syl5ibcom adantrd rexlimiv
      wi a1i rexlimivv sylbi mprgbir wo wel csuc word con0 nofulllem4 eloni syl
      wb ordsucuniel simpr wn onss sselda crab cint ssrab2 onnmin adantl eleq2i
      wne mpan ex imp reseq2 reseq1 syl6bb sylibr mpd rexbii rexnal bitri breq2
      simprl ssel2 syl2an adantr wrel wfun nofun 3syl syl2anc nodmord ordtri2or
      funrel orcanai syl6ss relssres anassrs reximdva wex r19.41v rexcom eleq2d
      exbii incom elin2 bitr4i rexcom4 3bitri sylnibr neeq12d 2ralbidv cbvral2v
      con2d neeq1d neeq2d elrab sylnib imnan df-ne con2bii simp3 rspc2v adantrl
      breq1 mpan9 simp1l sltirr biimprcd con3d sylc ioran simp2l simprr ordelon
      sucelon sssucid anim12d eqeq12 biimpd ancoms syl6 com23 syl5bi mt3d ancld
      ancomsd eqeq12d eleq2 3anbi13d sucid df-3an mpbiran2 rspcev sylbid rexeqi
      cab eliun resex ceqsexv eqcom anbi1i anass 3bitr4i orbi1d syl6rbb orbi12i
      an12 oridm andir pm5.32i 3anass 3bitr3ri rexab syl6ibr ssrdv eqssd syl5eq
      3bitr4ri ) HUBUCZHJRZSZCUBUCZCKRZSZAUMZBUMZUDUEZBCUFAHUFZUGZLUHZQDQUMZUHZ
      UIZIUJZUYBDUJZUHUYELUYGPUKQDULUNUYAUYEUYFUYEUYFUCZUYAUYHUYDUYFUCZQDQDUYDU
      YFUOUYCDRFUMZMUMZUPZUYCUQZGUMZUYKUPZUYCUQZSZMITZGCTZFHTZUYIUYLEUMZUQZUYOV
      UAUQZSZMITZGCTFHTZUYTEUYCDQUREQUSZVUEUYRFGHCVUGVUDUYQMIVUGVUBUYMVUCUYPVUA
      UYCUYLUTVUAUYCUYOUTVAVBVCZOVDUYRUYIFGHCUYRUYIVPUYJHRZUYNCRZSZUYQUYIMIUYKI
      RZUYMUYIUYPVULUYKUYJUHZVEZUYFUCUYMUYIVULVUNUYKUYFUYKVUMVFUYKIVGVHUYMVUNUY
      DUYFUYMVUNUYLUHZUYDUYJUYKVIZUYLUYCVJVKVLVMVNVOVQVRVSVTVQUYAUAUYFUYEUYAUAU
      MZUYFRZUYLUYOUQZVUQVUMRZVUQUYNUHZRZWAZUAMWBZUGZGCTZFHTZMITZVUQUYERZUYAVUR
      VUQWCZIRZVVHUYAIWDZVURVVKWIUYAIWERZVVLABCHIJKMNWFZIWGWHZVUQIWJWHUYAVVKVVH
      UYAVVKSZVVKUYJVVJUPZUYNVVJUPZUQZVVCSZGCTZFHTZVVHUYAVVKWKVVPVVSGCTZFHTZVWB
      VVPVVQVVRXAZGCUFZFHUFZWLZVWDVVPVVJWERZVWHUYAIWEVVJUYAVVMIWEUCVVNIWMWHWNVV
      PVWIVWGSZWLVWIVWHVPVVPVVJUXQUYKUPZUXRUYKUPZXAZBCUFAHUFZMWEWOZRZVWJUYAVVKV
      WPWLUYAVWPVVKUYAVWPVVKWLUYAVWPSVVJVWOWPZRZVVKVWPVWRWLZUYAVWOWEUCVWPVWSVWN
      MWEWQVWOVVJWRXBWSIVWQVVJNWTUUAXCUUEXDVWNVWGMVVJWEUYKVVJUQZVWNUXQVVJUPZUXR
      VVJUPZXAZBCUFAHUFVWGVWTVWMVXCABHCVWTVWKVXAVWLVXBUYKVVJUXQXEUYKVVJUXRXEUUB
      UUCVXCVWEVVQVXBXAABFGHCAFUSVXAVVQVXBUXQUYJVVJXFUUFBGUSVXBVVRVVQUXRUYNVVJX
      FUUGUUDXGUUHUUIVWIVWGUUJXHXIVWDVWFWLZFHTVWHVWCVXDFHVWCVWEWLZGCTVXDVVSVXEG
      CVWEVVSVVQVVRUUKUULXJVWEGCXKXLXJVWFFHXKXLXHVVPVWCVWAFHVVPVUISZVVSVVTGCVXF
      VUJSVVSVVCVVPVUIVUJVVSVVCVPZUYAVVKVUKVXGUYAVVKVUKSZSZVVSVVCVXIVVSSZVVCFGU
      SZVXIVXKWLZVVSVXIUYJUYNUDUEZUYJUYJUDUEZWLZVXLUYAVUKVXMVVKUYAUXTVUKVXMUXMU
      XPUXTUUMUXSVXMUYJUXRUDUEABUYJUYNHCUXQUYJUXRUDUUPUXRUYNUYJUDXMUUNUUQUUOVXI
      UYJUBRZVXOUYAUXKVUIVXPVXHUXKUXLUXPUXTUURVVKVUIVUJXNHUBUYJXOXPZUYJUUSWHVXM
      VXKVXNVXKVXNVXMUYJUYNUYJUDXMUUTUVAUVBXQVVCWLVUTWLZVVBWLZSZVXJVXKVUTVVBUVC
      VXIVVSVXTVXKVPVXIVXTVVSVXKVXIVXTVVRUYNUQZVVQUYJUQZSZVVSVXKVPZVXIVXSVXRVYC
      VXIVXSVYAVXRVYBVXIVXSVYAVXIVXSSZUYNXRZVVAVVJUCVYAVYEUYNUBRZUYNXSVYFVXIVYG
      VXSUYAUXNVUJVYGVXHUXMUXNUXOUXTUVDVVKVUIVUJUVECUBUYNXOXPZXQUYNXTUYNYEYAVYE
      VVAVUQVVJVXIVVBVVAVUQUCZVXIVUQWDZVVAWDZVVBVYIWAVXIVUQWERZVYJVXIVWIVYLVXIV
      VLVVKVWIUYAVVLVXHVVOXQUYAVVKVUKXNIVVJUVFYBVUQUVGXHVUQWGWHZVXIVYGVYKVYHUYN
      YCWHVUQVVAYDYBYFVUQUVHZYGUYNVVJYHYBXCVXIVXRVYBVXIVXRSZUYJXRZVUMVVJUCVYBVY
      OVXPUYJXSVYPVXIVXPVXRVXQXQUYJXTUYJYEYAVYOVUMVUQVVJVXIVUTVUMVUQUCZVXIVYJVU
      MWDZVUTVYQWAVYMVXIVXPVYRVXQUYJYCWHVUQVUMYDYBYFVYNYGUYJVVJYHYBXCUVIUVRVYBV
      YAVYDVYBVYASVVSVXKVVQUYJVVRUYNUVJUVKUVLUVMUVNXDUVOUVPXCYIYIUVQYJYJXIVVGVW
      BMVVJIVWTVVEVVTFGHCVWTVVEVVSVVCVUQVVJRZUGZVVTVWTVUSVVSVVDVYSVVCVWTUYLVVQU
      YOVVRUYKVVJUYJXEUYKVVJUYNXEUVSUYKVVJVUQUVTUWAVYTVVTVYSVUQUAURUWBVVSVVCVYS
      UWCUWDXGVCUWEYBXCUWFVVIVUQUYDRZQDTWUAQVUFEUWHZTZVVHQVUQDUYDUWIWUAQDWUBOUW
      GUYQWUASZMITZGCTZFHTZQYKZUYTWUASZQYKVVHWUCWUGWUIQWUGUYSWUASZFHTWUIWUFWUJF
      HWUFUYRWUASZGCTWUJWUEWUKGCUYQWUAMIYLXJUYRWUAGCYLXLXJUYSWUAFHYLXLYOVVHVVEM
      ITZGCTZFHTZWUFQYKZFHTWUHVVHVVFMITZFHTWUNVVFMFIHYMWUPWUMFHVVEMGICYMXJXLWUM
      WUOFHWUMWUEQYKZGCTWUOWULWUQGCWULWUDQYKZMITWUQVVEWURMIUYCUYOUQZUYMWUASZSZQ
      YKVUSVUQUYOUHZRZSZWURVVEWUTWVDQUYOUYNUYKGURUWJWUSUYMVUSWUAWVCUYCUYOUYLUTW
      USUYDWVBVUQUYCUYOVJYNVAUWKWVAWUDQUYPWUTSUYMUYPWUASSWVAWUDUYPUYMWUAUWSWUSU
      YPWUTUYCUYOUWLUWMUYMUYPWUAUWNUWOYOWVDVUSVVCVVDSZSVVEVUSWVCWVEVUSWVCVUQVUO
      RZWVCWAZWVEVUSWVGWVCWVCWAWVCVUSWVFWVCWVCVUSVUOWVBVUQUYLUYOVJYNUWPWVCUWTUW
      QWVGVUTVVDSZVVBVVDSZWAWVEWVFWVHWVCWVIVUQVUMUYKVUOVUOVUNVUMUYKVEVUPUYKVUMY
      PUNYQVUQVVAUYKWVBWVBUYKVVAVEVVAUYKVEUYNUYKVIUYKVVAYPUNYQUWRVUTVVBVVDUXAYR
      XGUXBVUSVVCVVDUXCYRUXDXJWUDMQIYSXLXJWUEGQCYSXLXJWUFFQHYSYTVUFUYTWUAQEVUHU
      XEUXJYTUXFUXGUXHUXI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Symmetric difference
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c (++) $.

  $( Declare the syntax for symmetric difference. $)
  csymdif $a class ( A (++) B ) $.

  $( Define the symmetric difference of two classes.  (Contributed by Scott
     Fenton, 31-Mar-2012.) $)
  df-symdif $a |- ( A (++) B ) = ( ( A \ B ) u. ( B \ A ) ) $.

  $( Symmetric difference commutes.  (Contributed by Scott Fenton,
     24-Apr-2012.) $)
  symdifcom $p |- ( A (++) B ) = ( B (++) A ) $=
    ( cdif cun csymdif uncom df-symdif 3eqtr4i ) ABCZBACZDJIDABEBAEIJFABGBAGH
    $.

  $( Equality theorem for symmetric difference.  (Contributed by Scott Fenton,
     24-Apr-2012.) $)
  symdifeq1 $p |- ( A = B -> ( A (++) C ) = ( B (++) C ) ) $=
    ( wceq cdif cun csymdif difeq1 difeq2 uneq12d df-symdif 3eqtr4g ) ABDZACEZC
    AEZFBCEZCBEZFACGBCGMNPOQABCHABCIJACKBCKL $.

  $( Equality theorem for symmetric difference.  (Contributed by Scott Fenton,
     24-Apr-2012.) $)
  symdifeq2 $p |- ( A = B -> ( C (++) A ) = ( C (++) B ) ) $=
    ( wceq csymdif symdifeq1 symdifcom 3eqtr4g ) ABDACEBCECAECBEABCFCAGCBGH $.

  ${
    nfsymdif.1 $e |- F/_ x A $.
    nfsymdif.2 $e |- F/_ x B $.
    $( Hypothesis builder for symmetric difference.  (Contributed by Scott
       Fenton, 19-Feb-2013.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
    nfsymdif $p |- F/_ x ( A (++) B ) $=
      ( csymdif cdif cun df-symdif nfdif nfun nfcxfr ) ABCFBCGZCBGZHBCIAMNABCDE
      JACBEDJKL $.
  $}

  $( Membership in a symmetric difference.  (Contributed by Scott Fenton,
     31-Mar-2012.) $)
  elsymdif $p |- ( A e. ( B (++) C ) <-> -. ( A e. B <-> A e. C ) ) $=
    ( cdif cun wcel wn wa wo csymdif wb elun eldif orbi12i df-symdif eleq2i xor
    bitri 3bitr4i ) ABCDZCBDZEZFZABFZACFZGHZUEUDGHZIZABCJZFUDUEKGUCATFZAUAFZIUH
    ATUALUJUFUKUGABCMACBMNRUIUBABCOPUDUEQS $.

  $( Symmetric difference with the empty class.  (Contributed by Scott Fenton,
     24-Apr-2012.) $)
  symdif0 $p |- ( A (++) (/) ) = A $=
    ( c0 csymdif cdif cun df-symdif dif0 0dif uneq12i un0 3eqtri ) ABCABDZBADZE
    ABEAABFLAMBAGAHIAJK $.

  $( Symmetric difference with the universal class.  (Contributed by Scott
     Fenton, 24-Apr-2012.) $)
  symdifV $p |- ( A (++) _V ) = ( _V \ A ) $=
    ( cvv csymdif cdif cun df-symdif c0 wss wceq ssdif0 mpbi uneq1i uncom eqtri
    ssv un0 ) ABCABDZBADZEZRABFSGREZRQGRABHQGIAOABJKLTRGERGRMRPNNN $.

  $( Symmetric difference yields the empty class with the same argument twice.
     (Contributed by Scott Fenton, 25-Apr-2012.) $)
  symdifid $p |- ( A (++) A ) = (/) $=
    ( csymdif cdif cun c0 df-symdif difid uneq12i un0 3eqtri ) AABAACZKDEEDEAAF
    KEKEAGZLHEIJ $.

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( Symmetric difference associates.  (Contributed by Scott Fenton,
       24-Apr-2012.) $)
    symdifass $p |- ( A (++) ( B (++) C ) ) = ( ( A (++) B ) (++) C ) $=
      ( vx csymdif cv wcel wb biass notbii xor3 notbi con1bii 3bitr3ri elsymdif
      wn bitr4i bibi2i bibi1i 3bitr4i eqriv ) DABCEZEZABEZCEZDFZAGZUFUBGZHZPUFU
      DGZUFCGZHZPUFUCGUFUEGUIULUGUFBGZUKHZPZHZUGUMHZPZUKHZUIULUQUKHZPUGUNHZPUSU
      PUTVAUGUMUKIJUSUTUSPURUKPHUTURUKKUQUKLQMUGUNKNUHUOUGUFBCORUJURUKUFABOSTJU
      FAUBOUFUDCOTUA $.
  $}

  $( The binary relationship of a symmetric difference.  (Contributed by Scott
     Fenton, 11-Apr-2012.) $)
  brsymdif $p |- ( A ( R (++) S ) B <-> -. ( A R B <-> A S B ) ) $=
    ( csymdif wbr cop wcel wb wn df-br elsymdif bibi12i xchbinxr bitri ) ABCDEZ
    FABGZPHZABCFZABDFZIZJABPKRQCHZQDHZIUAQCDLSUBTUCABCKABDKMNO $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Quantifier-free definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c (x) Bigcup SSet Trans Limits Fix Funs Singleton Singletons Image Cart $.
  $c Img Domain Range pprod Apply Cup Cap Succ Funpart FullFun Restrict $.
  $c UB LB $.
  $( Declare the syntax for tail cross product. $)
  ctxp $a class ( A (x) B ) $.
  $( Declare the syntax for the parallel product. $)
  cpprod $a class pprod ( R , S ) $.
  $( Declare the subset relationship class. $)
  csset $a class SSet $.
  $( Declare the transitive set class. $)
  ctrans $a class Trans $.
  $( Declare the set union relationship. $)
  cbigcup $a class Bigcup $.
  $( Declare the syntax for the fixpoints of a class. $)
  cfix $a class Fix A $.
  $( Declare the class of limit ordinals. $)
  climits $a class Limits $.
  $( Declare the syntax for the class of all function. $)
  cfuns $a class Funs $.
  $( Declare the syntax for the singleton function. $)
  csingle $a class Singleton $.
  $( Declare the syntax for the class of all singletons. $)
  csingles $a class Singletons $.
  $( Declare the syntax for the image functor. $)
  cimage $a class Image A $.
  $( Declare the syntax for the cartesian function. $)
  ccart $a class Cart $.
  $( Declare the syntax for the image function. $)
  cimg $a class Img $.
  $( Declare the syntax for the domain function. $)
  cdomain $a class Domain $.
  $( Declare the syntax for the range function. $)
  crange $a class Range $.
  $( Declare the syntax for the application function. $)
  capply $a class Apply $.
  $( Declare the syntax for the cup function. $)
  ccup $a class Cup $.
  $( Declare the syntax for the cap function. $)
  ccap $a class Cap $.
  $( Declare the syntax for the successor function. $)
  csuccf $a class Succ $.
  $( Declare the syntax for the functional part functor. $)
  cfunpart $a class Funpart F $.
  $( Declare the syntax for the full function functor. $)
  cfullfn $a class FullFun F $.
  $( Declare the syntax for the restriction function. $)
  crestrict $a class Restrict $.
  $( Declare the syntax for the upper bound relationship functor. $)
  cub $a class UB R $.
  $( Declare the syntax for the lower bound relationship functor. $)
  clb $a class LB R $.

  $( Define the tail cross of two classes.  Membership in this class is defined
     by ~ txpss3v and ~ brtxp .  (Contributed by Scott Fenton, 31-Mar-2012.) $)
  df-txp $a |- ( A (x) B ) = ( ( `' ( 1st |` ( _V X. _V ) ) o. A ) i^i
                               ( `' ( 2nd |` ( _V X. _V ) ) o. B ) ) $.

  $( Define the parallel product of two classes.  Membership in this class is
     defined by ~ pprodss4v and ~ brpprod .  (Contributed by Scott Fenton,
     11-Apr-2014.) $)
  df-pprod $a |- pprod ( A , B ) =
     ( ( A o. ( 1st |` ( _V X. _V ) ) ) (x)
       ( B o. ( 2nd |` ( _V X. _V ) ) ) ) $.

  $( Define the subset class.  For the value, see ~ brsset .  (Contributed by
     Scott Fenton, 31-Mar-2012.) $)
  df-sset $a |- SSet = ( ( _V X. _V ) \ ran ( _E (x) ( _V \ _E ) ) ) $.

  $( Define the class of all transitive sets.  (Contributed by Scott Fenton,
     31-Mar-2012.) $)
  df-trans $a |- Trans = ( _V \ ran ( ( _E o. _E ) \ _E ) ) $.

  $( Define the Bigcup function, which, per ~ fvbigcup , carries a set to its
     union.  (Contributed by Scott Fenton, 11-Apr-2012.) $)
  df-bigcup $a |- Bigcup = ( ( _V X. _V ) \
     ran ( ( _V (x) _E ) (++) ( ( _E o. _E ) (x) _V ) ) ) $.

  $( Define the class of all fixpoints of a relationship.  (Contributed by
     Scott Fenton, 11-Apr-2012.) $)
  df-fix $a |- Fix A = dom ( A i^i _I ) $.

  $( Define the class of all limit ordinals.  (Contributed by Scott Fenton,
     11-Apr-2012.) $)
  df-limits $a |- Limits = ( ( On i^i Fix Bigcup ) \ { (/) } ) $.

  $( Define the class of all functions.  See ~ elfuns for membership.
     (Contributed by Scott Fenton, 18-Feb-2013.) $)
  df-funs $a |- Funs =
    ( ~P ( _V X. _V ) \
      Fix ( _E o. ( ( 1st (x) ( ( _V \ _I ) o. 2nd ) ) o. `' _E ) ) ) $.

  $( Define the singleton function.  See ~ brsingle for its value.
     (Contributed by Scott Fenton, 4-Apr-2014.) $)
  df-singleton $a |- Singleton =
     ( ( _V X. _V ) \ ran ( ( _V (x) _E ) (++) ( _I (x) _V ) ) ) $.

  $( Define the class of all singletons.  See ~ elsingles for membership.
     (Contributed by Scott Fenton, 19-Feb-2013.) $)
  df-singles $a |- Singletons = ran Singleton $.

  $( Define the image functor.  This function takes a set ` A ` to a function
     ` x |-> ( A " x ) ` , providing that the latter exists.  See ~ imageval
     for the derivation.  (Contributed by Scott Fenton, 27-Mar-2014.) $)
  df-image $a |- Image A = ( ( _V X. _V ) \
           ran ( ( _V (x) _E ) (++) ( ( _E o. `' A ) (x) _V ) ) ) $.

  $( Define the cartesian product function.  See ~ brcart for its value.
     (Contributed by Scott Fenton, 11-Apr-2014.) $)
  df-cart $a |- Cart = ( ( ( _V X. _V ) X. _V ) \
    ran ( ( _V (x) _E ) (++) ( pprod ( _E , _E ) (x) _V ) ) ) $.

  $( Define the image function.  See ~ brimg for its value.  (Contributed by
     Scott Fenton, 12-Apr-2014.) $)
  df-img $a |- Img = ( Image ( ( 2nd o. 1st ) |` ( 1st |` ( _V X. _V ) ) )
                       o. Cart ) $.

  $( Define the domain function.  See ~ brdomain for its value.  (Contributed
     by Scott Fenton, 11-Apr-2014.) $)
  df-domain $a |- Domain = Image ( 1st |` ( _V X. _V ) ) $.

  $( Define the range function.  See ~ brrange for its value.  (Contributed by
     Scott Fenton, 11-Apr-2014.) $)
  df-range $a |- Range = Image ( 2nd |` ( _V X. _V ) ) $.

  $( Define the little cup function.  See ~ brcup for its value.  (Contributed
     by Scott Fenton, 14-Apr-2014.) $)
  df-cup $a |- Cup = ( ( ( _V X. _V ) X. _V ) \
  ran ( ( _V (x) _E ) (++)
        ( ( ( `' 1st o. _E ) u. ( `' 2nd o. _E ) ) (x) _V ) ) ) $.

  $( Define the little cap function.  See ~ brcap for its value.  (Contributed
     by Scott Fenton, 17-Apr-2014.) $)
  df-cap $a |- Cap = ( ( ( _V X. _V ) X. _V ) \
  ran ( ( _V (x) _E ) (++)
        ( ( ( `' 1st o. _E ) i^i ( `' 2nd o. _E ) ) (x) _V ) ) ) $.

  $( Define the restriction function.  See ~ brrestrict for its value.
     (Contributed by Scott Fenton, 17-Apr-2014.) $)
  df-restrict $a |- Restrict = ( Cap o.
    ( 1st (x) ( Cart o. ( 2nd (x) ( Range o. 1st ) ) ) ) ) $.

  $( Define the successor function.  See ~ brsuccf for its value.  (Contributed
     by Scott Fenton, 14-Apr-2014.) $)
  df-succf $a |- Succ = ( Cup o. ( _I (x) Singleton ) ) $.

  $( Define the application function.  See ~ brapply for its value.
     (Contributed by Scott Fenton, 12-Apr-2014.) $)
  df-apply $a |- Apply = ( ( Bigcup o. Bigcup ) o.
  ( ( ( _V X. _V ) \
      ran ( ( _V (x) _E ) (++) ( ( _E |` Singletons ) (x) _V ) ) ) o.
  ( ( Singleton o. Img ) o. pprod ( _I , Singleton ) ) ) ) $.


  $( Define the functional part of a class ` F ` .  This is the maximal part of
     ` F ` that is a function.  See ~ funpartfun and ~ funpartfv for the
     meaning of this statement.  (Contributed by Scott Fenton, 16-Apr-2014.) $)
  df-funpart $a |- Funpart F =
             ( F |` dom ( ( Image F o. Singleton ) i^i ( _V X. Singletons ) ) )
      $.

  $( Define the full function over ` F ` .  This is a function with domain
     ` _V ` that always agrees with ` F ` for its value.  (Contributed by Scott
     Fenton, 17-Apr-2014.) $)
  df-fullfun $a |- FullFun F = ( Funpart F u. ( ( _V \ dom Funpart F ) X. { (/)
      } ) ) $.

  $( Define the upper bound relationship functor.  See ~ brub for value.
     (Contributed by Scott Fenton, 3-May-2018.) $)
  df-ub $a |- UB R = ( ( _V X. _V ) \ ( ( _V \ R ) o. `' _E ) ) $.

  $( Define the lower bound relationship functor.  See ~ brlb for value.
     (Contributed by Scott Fenton, 3-May-2018.) $)
  df-lb $a |- LB R = UB `' R $.

  $( The binary relationship over ` _V ` always holds.  (Contributed by Scott
     Fenton, 11-Apr-2012.) $)
  brv $p |- A _V B $=
    ( cvv wbr cop wcel opex df-br mpbir ) ABCDABECFABGABCHI $.

  ${
    $d A x y z $.  $d B x y z $.
    $( A tail cross product is a subset of the class of ordered triples.
       (Contributed by Scott Fenton, 31-Mar-2012.) $)
    txpss3v $p |- ( A (x) B ) C_ ( _V X. ( _V X. _V ) ) $=
      ( vx vy vz ctxp c1st cvv cxp cres ccnv ccom c2nd cin df-txp inss1 cv wcel
      wbr vex relco wa wex cop brcnv brres simprbi adantl exlimiv opelco opelxp
      sylbi mpbiran 3imtr4i relssi sstri eqsstri ) ABFGHHIZJZKZALZMURJKBLZNZHUR
      IZABOVCVAVDVAVBPCDVAVDUTAUACQZEQZASZVFDQZUTSZUBZEUCVHURRZVEVHUDZVARVLVDRZ
      VJVKEVIVKVGVIVHVFUSSZVKVFVHUSETZDTZUEVNVHVFGSVKVHVFGURVOUFUGULUHUIEVEVHUT
      ACTZVPUJVMVEHRVKVQVEVHHURUKUMUNUOUPUQ $.
  $}

  $( A tail cross product is a relationship.  (Contributed by Scott Fenton,
     31-Mar-2012.) $)
  txprel $p |- Rel ( A (x) B ) $=
    ( ctxp wrel cvv cxp wss txpss3v xpss sstri df-rel mpbir ) ABCZDMEEFZGMENFNA
    BHENIJMKL $.

  ${
    $d A a x y z $.  $d B a x y z $.  $d X a x y z $.  $d Y a x y z $.
    $d Z a x y z $.
    brtxp.1 $e |- X e. _V $.
    brtxp.2 $e |- Y e. _V $.
    brtxp.3 $e |- Z e. _V $.
    $( Characterize a trinary relationship over a tail cross product.  Together
       with ~ txpss3v , this completely defines membership in a tail cross.
       (Contributed by Scott Fenton, 31-Mar-2012.) $)
    brtxp $p |- ( X ( A (x) B ) <. Y , Z >. <-> ( X A Y /\ X B Z ) ) $=
      ( vy vz wbr c1st cvv cres ccnv ccom c2nd wa wex 3bitri cop cxp cin df-txp
      ctxp breqi brin wceq opex brco ancom vex brcnv wcel opelvv brres mpbiran2
      cv br1steq anbi1i bitri exbii breq2 ceqsexv br2ndeq anbi12i ) CDEUAZABUEZ
      KCVGLMMUBZNZOZAPZQVINZOZBPZUCZKCVGVLKZCVGVOKZRCDAKZCEBKZRCVGVHVPABUDUFCVG
      VLVOUGVQVSVRVTVQCIURZAKZWAVGVKKZRZISWADUHZWBRZISVSICVGVKAFDEUIZUJWDWFIWDW
      CWBRWFWBWCUKWCWEWBWCVGWAVJKZVGWALKZWEWAVGVJIULZWGUMWHWIVGVIUNZDEGHUOZVGWA
      LVIWJUPUQDEWAGHWJUSTUTVAVBWBVSIDGWADCAVCVDTVRCJURZBKZWMVGVNKZRZJSWMEUHZWN
      RZJSVTJCVGVNBFWGUJWPWRJWPWOWNRWRWNWOUKWOWQWNWOVGWMVMKZVGWMQKZWQWMVGVMJULZ
      WGUMWSWTWKWLVGWMQVIXAUPUQDEWMGHXAVETUTVAVBWNVTJEHWMECBVCVDTVFT $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d R x y $.  $d S x y $.
    brtxp2.1 $e |- A e. _V $.
    $( The binary relationship over a tail cross when the second argument is
       not an ordered pair.  (Contributed by Scott Fenton, 14-Apr-2014.)
       (Revised by Mario Carneiro, 3-May-2015.) $)
    brtxp2 $p |- ( A ( R (x) S ) B <->
            E. x E. y ( B = <. x , y >. /\ A R x /\ A S y ) ) $=
      ( ctxp wbr cv cop wceq wa wex w3a cvv wcel bitr4i 2exbii vex txpss3v brel
      cxp simprd elvv sylib pm4.71ri 19.41vv breq2 pm5.32i anbi2i 3anass 3bitri
      brtxp ) CDEFHZIZDAJZBJZKZLZUPMZBNANZUTCUSUOIZMZBNANUTCUQEIZCURFIZOZBNANUP
      UTBNANZUPMVBUPVHUPDPPUCZQZVHUPCPQVJCDPVIUOEFUAUBUDABDUEUFUGUTUPABUHRVAVDA
      BUTUPVCDUSCUOUIUJSVDVGABVDUTVEVFMZMVGVCVKUTEFCUQURGATBTUNUKUTVEVFULRSUM
      $.
  $}

  $( Expanded definition of parallel product.  (Contributed by Scott Fenton,
     3-May-2014.) $)
  dfpprod2 $p |- pprod ( A , B ) =
     ( ( `' ( 1st |` ( _V X. _V ) ) o. ( A o. ( 1st |` ( _V X. _V ) ) ) ) i^i
       ( `' ( 2nd |` ( _V X. _V ) ) o. ( B o. ( 2nd |` ( _V X. _V ) ) ) ) ) $=
    ( cpprod c1st cvv cxp cres ccom c2nd ctxp ccnv cin df-pprod df-txp eqtri )
    ABCADEEFZGZHZBIPGZHZJQKRHSKTHLABMRTNO $.

  $( A converse law for parallel product.  (Contributed by Scott Fenton,
     3-May-2014.) $)
  pprodcnveq $p |- pprod ( R , S ) = `' pprod ( `' R , `' S ) $=
    ( cpprod c1st cvv cxp cres ccnv ccom c2nd cin dfpprod2 cnveqi cnvco1 coeq1i
    cnvin coass 3eqtri ineq12i eqtr4i ) ABCDEEFZGZHZAUBIIZJUAGZHZBUEIIZKZAHZBHZ
    CZHZABLULUCUIUBIZIZUFUJUEIZIZKZHUNHZUPHZKUHUKUQUIUJLMUNUPPURUDUSUGURUMHZUBI
    UCAIZUBIUDUBUMNUTVAUBAUBNOUCAUBQRUSUOHZUEIUFBIZUEIUGUEUONVBVCUEBUENOUFBUEQR
    SRT $.

  ${
    $d A x y z w $.  $d B x y z w $.
    $( The parallel product is a subclass of
       ` ( ( _V X. _V ) X. ( _V X. _V ) ) ` .  (Contributed by Scott Fenton,
       11-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    pprodss4v $p |- pprod ( A , B ) C_ ( ( _V X. _V ) X. ( _V X. _V ) ) $=
      ( vx vy vz vw c1st cvv cxp cres ccom cv cop wcel wex wbr vex adantr sylbi
      wa cpprod c2nd ctxp df-pprod txprel txpss3v sseli opelxp2 wceq elvv opeq2
      syl wi eleq1d df-br brtxp brco brres simprbi sylbir syl6bi exlimivv mpcom
      exlimiv opelxp sylanbrc relssi eqsstri ) ABUAAGHHIZJZKZBUBVIJKZUCZVIVIIZA
      BUDCDVMVNVKVLUECLZDLZMZVMNZVOVINZVPVINZVQVNNVTVRVSVRVQHVIIZNVTVMWAVQVKVLU
      FUGVOVPHVIUHULZVTVPELZFLZMZUIZFOEOVRVSUMZEFVPUJWFWGEFWFVRVOWEMZVMNZVSWFVQ
      WHVMVPWEVOUKUNWIVOWEVMPZVSVOWEVMUOWJVOWCVKPZVOWDVLPZTVSVKVLVOWCWDCQZEQZFQ
      UPWKVSWLWKVOVPVJPZVPWCAPZTZDOVSDVOWCAVJWMWNUQWQVSDWOVSWPWOVOVPGPVSVOVPGVI
      DQURUSRVDSRSUTVAVBSVCWBVOVPVIVIVEVFVGVH $.
  $}

  ${
    $d A x $.  $d B y $.  $d W y $.  $d X x $.  $d X y $.  $d Y x $.  $d Y y $.
    $d Z x $.
    brpprod.1 $e |- X e. _V $.
    brpprod.2 $e |- Y e. _V $.
    brpprod.3 $e |- Z e. _V $.
    brpprod.4 $e |- W e. _V $.
    $( Characterize a quatary relationship over a tail cross product.  Together
       with ~ pprodss4v , this completely defines membership in a parallel
       product.  (Contributed by Scott Fenton, 11-Apr-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    brpprod $p |- ( <. X , Y >. pprod ( A , B ) <. Z , W >. <->
            ( X A Z /\ Y B W ) ) $=
      ( vx vy cop wbr c1st cvv c2nd wa wex 3bitri cpprod cxp cres ccom df-pprod
      ctxp breqi opex brtxp cv wceq brco wcel opelvv vex brres mpbiran2 br1steq
      bitri anbi1i exbii breq1 ceqsexv br2ndeq anbi12i ) DEMZFCMZABUAZNVFVGAOPP
      UBZUCZUDZBQVIUCZUDZUFZNVFFVKNZVFCVMNZRDFANZECBNZRVFVGVHVNABUEUGVKVMVFFCDE
      UHZIJUIVOVQVPVRVOVFKUJZVJNZVTFANZRZKSVTDUKZWBRZKSVQKVFFAVJVSIULWCWEKWAWDW
      BWAVFVTONZWDWAWFVFVIUMZDEGHUNZVFVTOVIKUOZUPUQDEVTGHWIURUSUTVAWBVQKDGVTDFA
      VBVCTVPVFLUJZVLNZWJCBNZRZLSWJEUKZWLRZLSVRLVFCBVLVSJULWMWOLWKWNWLWKVFWJQNZ
      WNWKWPWGWHVFWJQVILUOZUPUQDEWJGHWQVDUSUTVAWLVRLEHWJECBVBVCTVET $.
  $}

  ${
    $d a b $.  $d a w $.  $d a z $.  $d b w $.  $d b z $.  $d R a $.  $d R b $.
    $d R w $.  $d R z $.  $d S a $.  $d S b $.  $d S w $.  $d S z $.  $d w z $.
    $d X a $.  $d X b $.  $d X w $.  $d X z $.  $d Y a $.  $d Y b $.  $d Y w $.
    $d Y z $.  $d Z a $.  $d Z b $.  $d Z w $.  $d Z z $.
    brpprod3.1 $e |- X e. _V $.
    brpprod3.2 $e |- Y e. _V $.
    brpprod3.3 $e |- Z e. _V $.
    $( Condition for parallel product when the last argument is not an ordered
       pair.  (Contributed by Scott Fenton, 11-Apr-2014.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    brpprod3a $p |- ( <. X , Y >. pprod ( R , S ) Z <->
       E. z E. w ( Z = <. z , w >. /\ X R z /\ Y S w ) ) $=
      ( cop wbr cv wa wex cvv wcel bitr4i 2exbii vex cpprod wceq pprodss4v brel
      w3a cxp simprd sylib pm4.71ri 19.41vv breq2 pm5.32i brpprod anbi2i 3anass
      elvv 3bitri ) EFKZGCDUAZLZGAMZBMZKZUBZUTNZBOAOZVDURVCUSLZNZBOAOVDEVACLZFV
      BDLZUEZBOAOUTVDBOAOZUTNVFUTVLUTGPPUFZQZVLUTURVMQVNURGVMVMUSCDUCUDUGABGUPU
      HUIVDUTABUJRVEVHABVDUTVGGVCURUSUKULSVHVKABVHVDVIVJNZNVKVGVOVDCDVBEFVAHIAT
      BTUMUNVDVIVJUORSUQ $.

    $( Condition for parallel product when the first argument is not an ordered
       pair.  (Contributed by Scott Fenton, 3-May-2014.) $)
    brpprod3b $p |- ( X pprod ( R , S ) <. Y , Z >. <->
       E. z E. w ( X = <. z , w >. /\ z R Y /\ w S Z ) ) $=
      ( cop cpprod wbr ccnv cv w3a wex brcnv bitri vex wceq opex brpprod3a biid
      pprodcnveq breqi 3anbi123i 2exbii ) EFGKZCDLZMEUICNZDNZLZNZMZEAOZBOZKUAZU
      PFCMZUQGDMZPZBQAQZEUIUJUNCDUEUFUOURFUPUKMZGUQULMZPZBQAQZVBUOUIEUMMVFEUIUM
      HFGUBRABUKULFGEIJHUCSVEVAABURURVCUSVDUTURUDFUPCIATRGUQDJBTRUGUHSS $.

  $}

  $( The subset class is a relationship.  (Contributed by Scott Fenton,
     31-Mar-2012.) $)
  relsset $p |- Rel SSet $=
    ( csset wrel cvv cxp wss cep cdif ctxp df-sset difss eqsstri df-rel mpbir
    crn ) ABACCDZEAOFCFGHNZGOIOPJKALM $.

  ${
    $d A x y $.  $d B x y $.
    brsset.1 $e |- B e. _V $.
    $( For sets, the ` SSet ` binary relationship is equivalent to the subset
       relationship.  (Contributed by Scott Fenton, 31-Mar-2012.) $)
    brsset $p |- ( A SSet B <-> A C_ B ) $=
      ( vx vy csset wbr cvv wcel wss relsset cv cep wn wex wa vex mpbiran bitri
      cdif brrelexi ssex breq1 sseq1 cop ctxp crn wi opex elrn brtxp epel brdif
      wal brv epelc xchbinx anbi12i exbii exanali 3bitrri con1bii df-br df-sset
      cxp eleq2i opelvv eldif dfss2 3bitr4i vtoclbg pm5.21nii ) ABFGZAHIABJZABF
      KUAABCUBDLZBFGZVOBJZVMVNDAHVOABFUCVOABUDVOBUEZMHMTZUFZUGZIZNZELZVOIZWDBIZ
      UHEUNZVPVQWGWBWBWDVRVTGZEOWEWFNZPZEOWGNEVRVTVOBUIUJWHWJEWHWDVOMGZWDBVSGZP
      WJMVSWDVOBEQDQZCUKWKWEWLWIEDULWLWDBMGZWFWLWDBHGWNNWDBUOWDBHMUMRWDBCUPUQUR
      SUSWEWFEUTVAVBVPVRFIZWCVOBFVCWOVRHHVEZWATZIZWCFWQVRVDVFWRVRWPIWCVOBWMCVGV
      RWPWAVHRSSEVOBVIVJVKVL $.
  $}

  ${
    $d x y z $.
    $( ` _I ` is equal to ` SSet ` and its converse.  (Contributed by Scott
       Fenton, 31-Mar-2012.) $)
    idsset $p |- _I = ( SSet i^i `' SSet ) $=
      ( vy vz cid csset ccnv cin reli wrel relsset relin1 ax-mp weq cv wss eqss
      wa wbr vex brsset bitri ideq brin brcnv anbi12i 3bitr4i eqbrriv ) ABCDDEZ
      FZGDHUHHIDUGJKABLAMZBMZNZUJUINZPZUIUJCQUIUJUHQZUIUJOUIUJBRZUAUNUIUJDQZUIU
      JUGQZPUMUIUJDUGUBUPUKUQULUIUJUOSUQUJUIDQULUIUJDARZUOUCUJUIURSTUDTUEUF $.
  $}

  ${
    eltrans.1 $e |- A e. _V $.
    $( Membership in the class of all transitive sets.  (Contributed by Scott
       Fenton, 31-Mar-2012.) $)
    eltrans $p |- ( A e. Trans <-> Tr A ) $=
      ( ctrans wcel cvv cep ccom cdif crn wtr df-trans eleq2i dftr6 bitr4i ) AC
      DAEFFGFHIHZDAJCOAKLABMN $.
  $}

  ${
    $d x y $.

    $( A quantifier-free definition of ` On ` .  (Contributed by Scott Fenton,
       5-Apr-2012.) $)
    dfon3 $p |- On =
     ( _V \ ran ( ( SSet i^i ( Trans X. _V ) ) \ ( _I u. _E ) ) ) $=
      ( vy vx cv wa wcel cvv csset ctrans cid cep cdif wceq wbr wex vex anbi12i
      wn bitri wo anbi1i con0 wpss wtr wi wal cab cxp cin cun crn dfon2 wb elrn
      abeq1 wss brin brsset brxp mpbiran2 eltrans ioran brun ideq epel xchnxbir
      orbi12i brdif dfpss2 an32 anass 3bitr4i exbii exanali eldif bitr4i mpgbir
      con2bii mpbiran eqtri ) UAACZBCZUBZVTUCZDZVTWAEZUDAUEZBUFZFGHFUGZUHZIJUIZ
      KZUJZKZBAUKWGWMLWFWAWMEZULBWFBWMUNWFWAWLEZQZWNWOWFWOVTWAWKMZANZWFQZAWAWKB
      OZUMWRWDWEQZDZANWSWQXBAVTWAWIMZVTWAWJMZQZDVTWAUOZWCDZVTWALZQZXADZDZWQXBXC
      XGXEXJXCVTWAGMZVTWAWHMZDXGVTWAGWHUPXLXFXMWCVTWAWTUQXMVTHEZWCXMXNWAFEZWTVT
      WAHFURUSVTAOUTRPRXHWESZXJXDXHWEVAXDVTWAIMZVTWAJMZSXPVTWAIJVBXQXHXRWEVTWAW
      TVCABVDVFRVEPVTWAWIWJVGXBXGXIDZXADXKWDXSXAWDXFXIDZWCDXSWBXTWCVTWAVHTXFXIW
      CVIRTXGXIXAVJRVKVLWDWEAVMRRVQWNXOWPWTWAFWLVNVRVOVPVS $.
  $}

  $( Another quantifier-free definition of ` On ` .  (Contributed by Scott
     Fenton, 4-May-2014.) $)
  dfon4 $p |- On = ( _V \ ( ( SSet \ ( _I u. _E ) ) " Trans ) ) $=
    ( con0 cvv csset ctrans cxp cin cid cep cun cdif crn cima dfon3 cres df-ima
    df-res indif1 eqtri rneqi difeq2i eqtr4i ) ABCDBEZFGHIZJZKZJBCUCJZDLZJMUGUE
    BUGUFDNZKUEUFDOUHUDUHUFUBFUDUFDPCUBUCQRSRTUA $.

  ${
    $d A x $.  $d B x $.  $d R x $.
    brtxpsd.1 $e |- A e. _V $.
    brtxpsd.2 $e |- B e. _V $.
    $( Expansion of a common form used in quantifier-free definitions.
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brtxpsd $p |- ( -. A ran ( ( _V (x) _E ) (++) ( R (x) _V ) ) B <->
       A. x ( x e. B <-> x R A ) ) $=
      ( cv wcel wbr wb wal cvv cep ctxp csymdif wn wex brv brtxp bitri crn opex
      cop df-br brsymdif vex mpbiran epelc mpbiran2 bibi12i xchbinx exbii exnal
      elrn 3bitrri con1bii ) AGZCHZUQBDIZJZAKZBCLMNZDLNZOZUAZIZVFBCUCZVEHZUTPZA
      QZVAPBCVEUDVHUQVGVDIZAQVJAVGVDBCUBUNVKVIAVKUQVGVBIZUQVGVCIZJUTUQVGVBVCUEV
      LURVMUSVLUQCMIZURVLUQBLIVNUQBRLMUQBCAUFZEFSUGUQCFUHTVMUSUQCLIUQCRDLUQBCVO
      EFSUIUJUKULTUTAUMUOUP $.
  $}

  ${
    $d A x $.  $d B x $.  $d S x $.
    brtxpsd2.1 $e |- A e. _V $.
    brtxpsd2.2 $e |- B e. _V $.
    brtxpsd2.3 $e |- R = ( C \ ran ( ( _V (x) _E ) (++) ( S (x) _V ) ) ) $.
    brtxpsd2.4 $e |- A C B $.
    $( Another common abbreviation for quantifier-free definitions.
       (Contributed by Scott Fenton, 21-Apr-2014.) $)
    brtxpsd2 $p |- ( A R B <-> A. x ( x e. B <-> x S A ) ) $=
      ( wbr cvv cep ctxp csymdif crn wn cv wcel bitri wb wal cdif breqi mpbiran
      wa brdif brtxpsd ) BCEKZBCLMNFLNOPZKQZARZCSULBFKUAAUBUIBCDKZUKJUIBCDUJUCZ
      KUMUKUFBCEUNIUDBCDUJUGTUEABCFGHUHT $.

    ${
      $d X x $.
      brtxpsd3.5 $e |- ( x e. X <-> x S A ) $.
      $( A third common abbreviation for quantifier-free definitions.
         (Contributed by Scott Fenton, 3-May-2014.) $)
      brtxpsd3 $p |- ( A R B <-> B = X ) $=
        ( cv wcel wb wal wbr wceq bibi2i albii dfcleq brtxpsd2 3bitr4ri ) AMZCN
        ZUDGNZOZAPUEUDBFQZOZAPCGRBCEQUGUIAUFUHUELSTACGUAABCDEFHIJKUBUC $.
    $}
  $}

  $( The ` Bigcup ` relationship is a relationship.  (Contributed by Scott
     Fenton, 11-Apr-2012.) $)
  relbigcup $p |- Rel Bigcup $=
    ( cbigcup wrel cvv cxp cep ctxp ccom csymdif crn cdif relxp ax-mp df-bigcup
    reldif releqi mpbir ) ABCCDZCEFEEGCFHIZJZBZQBTCCKQRNLASMOP $.

  ${
    $d A x y z $.  $d B x y z $.
    brbigcup.1 $e |- B e. _V $.
    $( Binary relationship over ` Bigcup ` .  (Contributed by Scott Fenton,
       11-Apr-2012.) $)
    brbigcup $p |- ( A Bigcup B <-> U. A = B ) $=
      ( vx vy vz cbigcup wbr cvv wcel cuni wceq relbigcup brrelexi eleq1 mpbiri
      cv cep vex wrex uniexb sylibr breq1 unieq eqeq1d ccom df-bigcup brxp epel
      cxp mpbir2an rexbii coep eluni2 3bitr4ri brtxpsd3 eqcom vtoclbg pm5.21nii
      bitri ) ABGHZAIJZAKZBLZABGMNVDVCIJZVBVDVEBIJZCVCBIOPAUAUBDQZBGHZVGKZBLZVA
      VDDAIVGABGUCVGALVIVCBVGAUDUEVHBVILVJEVGBIIUJZGRRUFZVIDSZCUGVGBVKHVGIJVFVM
      CVGBIIUHUKEQZFQZRHZFVGTVNVOJZFVGTVNVGVLHVNVIJVPVQFVGEFUIULFVNVGRESVMUMFVN
      VGUNUOUPBVIUQUTURUS $.
  $}

  ${
    $d x y z t $.
    $( ` Bigcup ` using maps-to notation.  (Contributed by Scott Fenton,
       16-Apr-2012.) $)
    dfbigcup2 $p |- Bigcup = ( x e. _V |-> U. x ) $=
      ( vy vz vt cbigcup cvv cuni cmpt relbigcup mptrel wceq wbr eqcom brbigcup
      cv vex wcel wa weq eleq1 unieq eqeq2d anbi12d biantrur syl6bbr eqeq1 brab
      df-mpt 3bitr4i eqbrriv ) BCEAFAOZGZHZIAFULJBOZGZCOZKUPUOKZUNUPELUNUPUMLUO
      UPMUNUPCPZNUKFQZDOZULKZRZUTUOKZUQADUNUPUMBPZURABSZVBUNFQZVCRVCVEUSVFVAVCU
      KUNFTVEULUOUTUKUNUAUBUCVFVCVDUDUEUTUPUOUFADFULUHUGUIUJ $.
  $}

  ${
    $d x y z $.
    $( ` Bigcup ` maps the universe onto itself.  (Contributed by Scott Fenton,
       16-Apr-2012.) $)
    fobigcup $p |- Bigcup : _V -onto-> _V $=
      ( vx vy cvv cbigcup wfo wfn crn wceq cuni wcel wral uniexg rgen dfbigcup2
      cv mptfng mpbi wrex cab rnmpt snex unisn eqcomi unieq eqeq2d rspcev mp2an
      vex csn 2th abbi2i eqtr4i df-fo mpbir2an ) CCDEDCFZDGZCHAOZIZCJZACKUOUSAC
      UQCLMACURDANZPQUPBOZURHZACRZBSCABCURDUTTVCBCVACJVCBUHZVAUIZCJVAVEIZHZVCVA
      UAVFVAVAVDUBUCVBVGAVECUQVEHURVFVAUQVEUDUEUFUGUJUKULCCDUMUN $.
  $}

  ${
    $d x y z $.
    $( ` Bigcup ` is a function over the universal class.  (Contributed by
       Scott Fenton, 11-Apr-2012.) $)
    fnbigcup $p |- Bigcup Fn _V $=
      ( cvv cbigcup wfo wfn fobigcup fofn ax-mp ) AABCBADEAABFG $.
  $}

  ${
    fvbigcup.1 $e |- A e. _V $.
    $( For sets, ` Bigcup ` yields union.  (Contributed by Scott Fenton,
       11-Apr-2012.) $)
    fvbigcup $p |- ( Bigcup ` A ) = U. A $=
      ( cbigcup cfv cuni wceq wbr eqid uniex brbigcup mpbir cvv wfn wb fnbigcup
      wcel fnbrfvb mp2an ) ACDAEZFZASCGZUASSFSHASABIJKCLMALPTUANOBLASCQRK $.
  $}

  ${
    $d A x $.  $d R x $.
    elfix.1 $e |- A e. _V $.
    $( Membership in the fixpoints of a class.  (Contributed by Scott Fenton,
       11-Apr-2012.) $)
    elfix $p |- ( A e. Fix R <-> A R A ) $=
      ( vx cfix wcel cid cin cdm cv wceq wbr wex df-fix eleq2i eldm brin 3bitri
      wa bitri ancom vex ideq eqcom anbi1i exbii breq2 ceqsexv ) ABEZFABGHZIZFZ
      DJZAKZAUMBLZSZDMZAABLZUIUKABNOULAUMUJLZDMUQDAUJCPUSUPDUSUOAUMGLZSUTUOSUPA
      UMBGQUOUTUAUTUNUOUTAUMKUNAUMDUBUCAUMUDTUERUFTUOURDACUMAABUGUHR $.
  $}

  ${
    $d A x $.  $d R x $.
    elfix2.1 $e |- Rel R $.
    $( Alternative membership in the fixpoint of a class.  (Contributed by
       Scott Fenton, 11-Apr-2012.) $)
    elfix2 $p |- ( A e. Fix R <-> A R A ) $=
      ( vx cfix wcel cvv wbr elex brrelexi cv eleq1 wceq wb breq12 anidms elfix
      vex vtoclbg pm5.21nii ) ABEZFZAGFAABHZAUAIAABCJDKZUAFUDUDBHZUBUCDAGUDAUAL
      UDAMUEUCNUDAUDABOPUDBDRQST $.
  $}

  ${
    $d A x y $.
    $( The fixpoints of a class in terms of its range.  (Contributed by Scott
       Fenton, 16-Apr-2012.) $)
    dffix2 $p |- Fix A = ran ( A i^i _I ) $=
      ( vx vy cfix cid cin crn cv wcel wbr vex elfix wex weq wa elrn brin ancom
      ideq 3bitri anbi1i exbii breq1 ceqsexv bitr4i eqriv ) BADZAEFZGZBHZUGIUJU
      JAJZUJUIIZUJABKZLULCHZUJUHJZCMCBNZUNUJAJZOZCMUKCUJUHUMPUOURCUOUQUNUJEJZOU
      SUQOURUNUJAEQUQUSRUSUPUQUNUJUMSUATUBUQUKCUJUMUNUJUJAUCUDTUEUF $.
  $}

  $( The fixpoints of a class are a subset of its domain.  (Contributed by
     Scott Fenton, 16-Apr-2012.) $)
  fixssdm $p |- Fix A C_ dom A $=
    ( cfix cid cin cdm df-fix wss inss1 dmss ax-mp eqsstri ) ABACDZEZAEZAFLAGMN
    GACHLAIJK $.

  $( The fixpoints of a class are a subset of its range.  (Contributed by Scott
     Fenton, 16-Apr-2012.) $)
  fixssrn $p |- Fix A C_ ran A $=
    ( cfix cid cin crn dffix2 wss inss1 rnss ax-mp eqsstri ) ABACDZEZAEZAFLAGMN
    GACHLAIJK $.

  ${
    $d A x $.
    $( The fixpoints of a class are the same as those of its converse.
       (Contributed by Scott Fenton, 16-Apr-2012.) $)
    fixcnv $p |- Fix A = Fix `' A $=
      ( vx cfix ccnv cv wbr wcel vex brcnv elfix 3bitr4ri eqriv ) BACZADZCZBEZP
      NFPPAFPOGPMGPPABHZQIPNQJPAQJKL $.
  $}

  $( The fixpoint operator distributes over union.  (Contributed by Scott
     Fenton, 16-Apr-2012.) $)
  fixun $p |- Fix ( A u. B ) = ( Fix A u. Fix B ) $=
    ( cun cid cin cdm cfix indir dmeqi dmun eqtri df-fix uneq12i 3eqtr4i ) ABCZ
    DEZFZADEZFZBDEZFZCZOGAGZBGZCQRTCZFUBPUEABDHIRTJKOLUCSUDUAALBLMN $.

  ${
    $d A x $.
    ellimits.1 $e |- A e. _V $.
    $( Membership in the class of all limit ordinals.  (Contributed by Scott
       Fenton, 11-Apr-2012.) $)
    ellimits $p |- ( A e. Limits <-> Lim A ) $=
      ( climits wcel con0 cbigcup cfix cin c0 csn cdif wn wlim df-limits eleq2i
      wa eldif wceq 3bitri anbi12i word wne cuni 3anan32 df-lim elin elon elfix
      w3a wbr brbigcup eqcom bitri elsnc necon3bbii 3bitr4ri ) ACDAEFGZHZIJZKZD
      AURDZAUSDZLZPZAMZCUTANOAURUSQAUAZAIUBZAAUCZRZUIVFVIPZVGPVEVDVFVGVIUDAUEVA
      VJVCVGVAAEDZAUQDZPVJAEUQUFVKVFVLVIABUGVLAAFUJVHARVIAFBUHAABUKVHAULSTUMVBA
      IAIBUNUOTUPS $.
  $}

  $( The class of all limit ordinals is a subclass of the class of all
     ordinals.  (Contributed by Scott Fenton, 11-Apr-2012.) $)
  limitssson $p |- Limits C_ On $=
    ( climits con0 cbigcup cfix cin c0 cdif df-limits difss inss1 sstri eqsstri
    csn ) ABCDZEZFMZGZBHQOBOPIBNJKL $.

  ${
    $d x y $.
    $( A quantifier-free definition of ` om ` that does not depend on
       ~ ax-inf .  (Note: label was changed from ~ dfom5 to ~ dfom5b to prevent
       naming conflict.  NM 12-Feb-2013) (Contributed by Scott Fenton,
       11-Apr-2012.) $)
    dfom5b $p |- om = ( On i^i |^| Limits ) $=
      ( vx vy com con0 climits cint cin cv wcel wlim wi wal wa vex elint imbi1i
      ellimits albii bitr2i anbi2i elom elin 3bitr4i eqriv ) ACDEFZGZAHZDIZBHZJ
      ZUGUIIZKZBLZMUHUGUEIZMUGCIUGUFIUMUNUHUNUIEIZUKKZBLUMBUGEANOUPULBUOUJUKUIB
      NQPRSTBUGUAUGDUEUBUCUD $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( A condition for subset and composition with identity.  (Contributed by
       Scott Fenton, 13-Apr-2018.) $)
    sscoid $p |- ( A C_ ( _I o. B ) <-> ( Rel A /\ A C_ B ) ) $=
      ( vx vy vz cid wss wrel cv wcel wi wal wa wex wbr vex bitri eleq1 df-br
      wb ccom relco relss mpi cop wceq elrel brco ancom ideq anbi1i exbii breq2
      weq ceqsexv a1i syl6bbr 3bitr4d exlimivv syl albidv dfss2 3bitr4g biadan2
      pm5.74da ) AFBUAZGZAHZABGZVGVFHVHFBUBAVFUCUDVHCIZAJZVJVFJZKZCLVKVJBJZKZCL
      VGVIVHVMVOCVHVKVLVNVHVKMVJDIZEIZUEZUFZENDNVLVNTZDEVJAUGVSVTDEVSVPVQVFOZVP
      VQBOZVLVNWAWBTVSWAVPVJBOZVJVQFOZMZCNZWBCVPVQFBDPEPZUHWFCEUNZWCMZCNWBWEWIC
      WEWDWCMWIWCWDUIWDWHWCVJVQWGUJUKQULWCWBCVQWGVJVQVPBUMUOQQUPVSVLVRVFJWAVJVR
      VFRVPVQVFSUQVSVNVRBJWBVJVRBRVPVQBSUQURUSUTVEVACAVFVBCABVBVCVD $.
  $}

  ${
    $d F x y z $.
    $( Another potential definition of functionhood.  Based on statements in
~ http://people.math.gatech.edu/~~belinfan/research/autoreas/otter/sum/fs/ .
       (Contributed by Scott Fenton, 30-Aug-2017.) $)
    dffun10 $p |- ( Fun F <-> F C_ ( _I o. ( _V \ ( ( _V \ _I ) o. F ) ) ) ) $=
      ( vx vy vz cv cop wcel wa weq wi wal cvv cid cdif ccom wss wn wbr wex vex
      wrel wfun ssrel impexp albii 19.21v opelco df-br brv brdif mpbiran equcom
      ideq bitri xchbinx anbi12i exbii exanali 3bitri con2bii opex eldif bitr4i
      imbi2i 2albii syl6rbbr pm5.32i dffun4 sscoid 3bitr4i ) AUAZBEZCEZFZAGZVLD
      EZFAGZHCDIZJZDKZCKBKZHVKALLMNZAOZNZPZHAUBAMWDOPVKWAWEVKWEVOVNWDGZJZCKBKWA
      BCAWDUCVTWGBCVTVOVQVRJZJZDKVOWHDKZJWGVSWIDVOVQVRUDUEVOWHDUFWJWFVOWJVNWCGZ
      QZWFWKWJWKVLVPARZVPVMWBRZHZDSVQVRQZHZDSWJQDVLVMWBABTCTZUGWOWQDWMVQWNWPVLV
      PAUHWNVPVMMRZVRWNVPVMLRWSQVPVMUIVPVMLMUJUKWSDCIVRVPVMWRUMDCULUNUOUPUQVQVR
      DURUSUTWFVNLGWLVLVMVAVNLWCVBUKVCVDUSVEVFVGBCDAVHAWDVIVJ $.
  $}

  ${
    $d F a x y z p q $.
    elfuns.1 $e |- F e. _V $.
    $( Membership in the class of all functions.  (Contributed by Scott Fenton,
       18-Feb-2013.) $)
    elfuns $p |- ( F e. Funs <-> Fun F ) $=
      ( vx vy vz vp vq va cv wcel wa weq cvv wbr wex wn syl6bb vex bitri 3bitri
      wrel cop wi wal c1st cdif c2nd ccom ctxp wfun cfuns wceq elrel ex anim12d
      cid adantrd pm4.71rd 19.41vvvv ee4anv anbi1i bitr2i 2exbidv excom13 excom
      exrot4 df-3an 2exbii opex eleq1 anbi1d breq2 anbi12d anbi2d breq1 br1steq
      w3a brtxp equcom brco br2ndeq exbii brv brdif mpbiran ideq notbii ceqsexv
      anbi12i ceqsex2v bitr3i opeq1 eleq1d exanali exnal con2bid pm5.32i dffun4
      an12 cxp cpw ccnv cfix df-funs eleq2i eldif elpw df-rel bitr4i wrex elfix
      cep wss coep coepr rexbii r2ex 3bitr4ri ) AUAZCIZDIZUBZAJZXTEIZUBZAJZKZDE
      LZUCEUDZDUDZCUDZKXSFIZAJZGIZAJZKZYNYLUEMUPUFZUGUHZUIZNZKZGOFOZPZKZAUJAUKJ
      ZXSYKUUCXSUUBYKXSUUBYLYBULZYNHIZYDUBZULZKZUUAKZEOHOZDOZCOZGOFOZYKPZXSUUAU
      UNFGXSUUAUUFDOCOZUUIEOHOZKZUUAKZUUNXSUUAUUSXSYPUUSYTXSYMUUQYOUURXSYMUUQCD
      YLAUMUNXSYOUURHEYNAUMUNUOUQURUUNUUJEOHODOCOZUUAKUUTUUJUUADHECUSUVAUUSUUAU
      UFUUICDHEUTVAVBQVCUUOUUMFOGOZCOYJPZCOUUPUUMFGCVDUVBUVCCUVBUULGOFOZDOYIPZD
      OUVCUULGFDVDUVDUVEDUVDUUKGOFOZEOHOUVFHOZEOZUVEUUKFGHEVFUVFHEVEUVHYGYHPZKZ
      EOUVEUVGUVJEUVGHCLZYCUUHAJZKZUVIKZKZHOUVJUVFUVOHUVFUUFUUIUUAVQZGOFOUVOUVP
      UUKFGUUFUUIUUAVGVHUUAYCYOKZYNYBYSNZKZUVOFGYBUUHXTYAVIUUGYDVIZUUFYPUVQYTUV
      RUUFYMYCYOYLYBAVJVKYLYBYNYSVLVMUUIUVSUVMUVKUVIKZKUVOUUIUVQUVMUVRUWAUUIYOU
      VLYCYNUUHAVJVNUUIUVRUUHYBYSNZUWAYNUUHYBYSVOUWBUUHXTUENZUUHYAYRNZKUWAUEYRU
      UHXTYAUVTCRZDRZVRUWCUVKUWDUVIUWCCHLUVKUUGYDXTHRZERZUWEVPCHVSSUWDUUHXTUGNZ
      XTYAYQNZKZCOCELZUWJKZCOUVICUUHYAYQUGUVTUWFVTUWKUWMCUWIUWLUWJUUGYDXTUWGUWH
      UWEWAVAWBUWJUVICYDUWHUWLUWJYDYAYQNZUVIXTYDYAYQVOUWNYDYAUPNZPZUVIUWNYDYAMN
      UWPYDYAWCYDYAMUPWDWEUWOYHUWOEDLYHYDYAUWFWFEDVSSWGSQWHTWISQVMUVMUVKUVIWSQW
      JWKWBUVNUVJHXTUWEUVKUVMYGUVIUVKUVLYFYCUVKUUHYEAUUGXTYDWLWMVNVKWHSWBYGYHEW
      NSTWBYIDWOTWBYJCWOTQWPWQCDEAWRUUEAMMWTZXAZXLYSXLXBUHZUHZXCZUFZJAUWRJZAUXA
      JZPZKUUDUKUXBAXDXEAUWRUXAXFUXCXSUXEUUCUXCAUWQXMXSAUWQBXGAXHXIUXDUUBUXDAAU
      WTNZYTGAXJZFAXJZUUBAUWTBXKUXFAYLUWSNZFAXJUXHFAAUWSBBXNUXIUXGFAGAYLYSBFRXO
      XPSYTFGAAXQTWGWITXR $.
  $}

  ${
    $d F f $.
    $( Closed form of ~ elfuns .  (Contributed by Scott Fenton, 2-May-2014.) $)
    elfunsg $p |- ( F e. V -> ( F e. Funs <-> Fun F ) ) $=
      ( vf cv cfuns wcel wfun eleq1 funeq vex elfuns vtoclbg ) CDZEFMGAEFAGCABM
      AEHMAIMCJKL $.
  $}

  ${
    $d A x $.  $d B x $.
    brsingle.1 $e |- A e. _V $.
    brsingle.2 $e |- B e. _V $.
    $( The binary relationship form of the singleton function.  (Contributed by
       Scott Fenton, 4-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    brsingle $p |- ( A Singleton B <-> B = { A } ) $=
      ( vx cvv cxp csingle cid csn df-singleton wcel brxp mpbir2an cv wceq elsn
      wbr ideq bitr4i brtxpsd3 ) EABFFGZHIAJZCDKABUBRAFLBFLCDABFFMNEOZUCLUDAPUD
      AIREAQUDACSTUA $.

  $}

  ${
    $d A x y z $.
    $( Membership in the class of all singletons.  (Contributed by Scott
       Fenton, 19-Feb-2013.) $)
    elsingles $p |- ( A e. Singletons <-> E. x A = { x } ) $=
      ( vy csingles wcel cvv csn wceq wex elex snex eleq1 mpbiri exlimiv exbidv
      cv eqeq1 csingle crn vex wbr df-singles eleq2i elrn brsingle exbii 3bitri
      vtoclbg pm5.21nii ) BDEZBFEZBAPZGZHZAIZBDJUNUKAUNUKUMFEULKBUMFLMNCPZDEZUP
      UMHZAIZUJUOCBFUPBDLUPBHURUNAUPBUMQOUQUPRSZEULUPRUAZAIUSDUTUPUBUCAUPRCTZUD
      VAURAULUPATVBUEUFUGUHUI $.
  $}

  ${
    $d x y z $.
    $( The singleton relationship is a function over the universe.
       (Contributed by Scott Fenton, 4-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    fnsingle $p |- Singleton Fn _V $=
      ( vx vy vz csingle cvv wfn wfun cdm wceq wrel cv wbr wa weq wal mpbir vex
      ctxp brsingle mpbir2an wi cxp cep cid csymdif crn cdif difss df-singleton
      wss df-rel releqi csn eqtr3 syl2anb ax-gen gen2 dffun2 wcel eqv eqid snex
      wex breq2 spcev ax-mp eldm mpgbir df-fn ) DEFDGZDHZEIZVJDJZAKZBKZDLZVNCKZ
      DLZMBCNZUAZCOZBOAOVMEEUBZEUCRUDERUEUFZUGZJZWEWDWBUJWBWCUHWDUKPDWDUIULPWAA
      BVTCVPVOVNUMZIVQWFIVSVRVNVOAQZBQSVNVQWGCQSVOVQWFUNUOUPUQABCDURTVLVNVKUSZA
      AVKUTWHVPBVCZVNWFDLZWIWJWFWFIWFVAVNWFWGVNVBZSPVPWJBWFWKVOWFVNDVDVEVFBVNDW
      GVGPVHDEVIT $.
  $}

  ${
    $d A x $.
    $( The value of the singleton function.  (Contributed by Scott Fenton,
       4-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.)  (Revised by
       Scott Fenton, 13-Apr-2018.) $)
    fvsingle $p |- ( Singleton ` A ) = { A } $=
      ( vx cvv wcel csingle cfv csn wceq cv fveq2 sneq eqeq12d wbr vex brsingle
      eqid snex mpbir wfn c0 wb fnsingle mp2an vtoclg fvprc snprc biimpi eqtr4d
      fnbrfvb wn pm2.61i ) ACDZAEFZAGZHZBIZEFZUPGZHZUOBACUPAHUQUMURUNUPAEJUPAKL
      USUPUREMZUTURURHURPUPURBNZUPQORECSUPCDUSUTUAUBVACUPUREUIUCRUDULUJZUMTUNAE
      UEVBUNTHAUFUGUHUK $.
  $}

  ${
    $d x y $.
    $( Alternate definition of the class of all singletons.  (Contributed by
       Scott Fenton, 20-Nov-2013.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    dfsingles2 $p |- Singletons = { x | E. y x = { y } } $=
      ( cv csn wceq wex csingles elsingles abbi2i ) ACZBCDEBFAGBJHI $.
  $}

  ${
    $d A x $.
    snelsingles.1 $e |- A e. _V $.
    $( A singleton is a member of the class of all singletons.  (Contributed by
       Scott Fenton, 19-Feb-2013.) $)
    snelsingles $p |- { A } e. Singletons $=
      ( vx csn csingles wcel cv wceq wex cvv isset eqcom exbii mpbi sneq eximii
      bitri elsingles mpbir ) ADZEFTCGZDHZCIAUAHZUBCAJFZUCCIZBUDUAAHZCIUECAKUFU
      CCUAALMQNAUAOPCTRS $.
  $}

  ${
    $d x y z w $.  $d ph y z w $.
    $( A definiton of iota using minimal quantifiers.  (Contributed by Scott
       Fenton, 19-Feb-2013.) $)
    dfiota3 $p |- ( iota x ph ) = U. U. ( { { x | ph } } i^i Singletons ) $=
      ( vy vz vw cab cv csn wceq cuni csingles cin wex wcel ceqsexv bitri exbii
      wa weq eqtri cio df-iota wb abeq1 wel exdistr vex sneq eqeq2d eqeq1 eleq2
      snex anbi12d eqcom elsn equcom anbi12ci syl6bb an13 excom eluniab 3bitr4i
      bitr3i mpgbir df-sn dfsingles2 ineq12i 19.42v bicomi abbii unieqi eqtr4i
      inab ) ABUAABFZCGZHZIZCFZJVNHZKLZJZJABCUBVRWAVRDGZVNIZWBEGZHZIZRZEMZDFZJZ
      WAVRWJIVQVOWJNZUCCVQCWJUDCDUEZWGRZEMDMZWLWHRDMVQWKWLWGDEUFVQWMDMZEMZWNVQE
      CSZVNWEIZRZEMWPWRVQEVOCUGWQWEVPVNWDVOUHUIOWSWOEWSWFWCWLRZRZDMWOWTWSDWEWDU
      LWFWTWEVNIZVOWENZRWSWFWCXBWLXCWBWEVNUJWBWEVOUKUMXBWRXCWQWEVNUNXCCESWQCWDU
      OCEUPPUQUROXAWMDWFWCWLUSQVCQVCWMEDUTPWHDVOVAVBVDVTWIVTWCDFZWFEMZDFZLZWIVS
      XDKXFDVNVEDEVFVGXGWCXERZDFWIWCXEDVMXHWHDWHXHWCWFEVHVIVJTTVKVLVKT $.
  $}

  ${
    $d F x $.  $d A x $.
    $( Another quantifier free definition of function value.  (Contributed by
       Scott Fenton, 19-Feb-2013.) $)
    dffv5 $p |- ( F ` A ) = U. U. ( { ( F " { A } ) } i^i Singletons ) $=
      ( vx cfv cv csn cima wcel cio cab csingles cuni dffv3 dfiota3 abid2 sneqi
      cin ineq1i unieqi 3eqtri ) ABDCEBAFGZHZCIUBCJZFZKQZLZLUAFZKQZLZLCABMUBCNU
      FUIUEUHUDUGKUCUACUAOPRSST $.
  $}

  $( Express union of singleton in terms of ` if ` .  (Contributed by Scott
     Fenton, 27-Mar-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  unisnif $p |- U. { A } = if ( A e. _V , A , (/) ) $=
    ( cvv wcel c0 cif csn cuni wceq iftrue unisng eqtr4d wn snprc biimpi unieqd
    iffalse uni0 syl6eq pm2.61i eqcomi ) ABCZADEZAFZGZUAUBUDHUAUBAUDUAADIABJKUA
    LZUBDUDUAADPUEUDDGDUEUCDUEUCDHAMNOQRKST $.

  ${
    $d A x y $.  $d B x y $.  $d R x y $.
    brimage.1 $e |- A e. _V $.
    brimage.2 $e |- B e. _V $.
    $( Binary relationship form of the Image functor.  (Contributed by Scott
       Fenton, 4-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    brimage $p |- ( A Image R B <-> B = ( R " A ) ) $=
      ( vx vy cvv cxp cimage cep ccnv ccom cima df-image wbr wcel cv wrex vex
      brxp mpbir2an brcnv rexbii coep elima 3bitr4ri brtxpsd3 ) FABHHIZCJKCLZMZ
      CANZDECOABUIPAHQBHQDEABHHUAUBFRZGRZUJPZGASUNUMCPZGASUMAUKPUMULQUOUPGAUMUN
      CFTZGTUCUDGUMAUJUQDUEGUMCAUQUFUGUH $.
  $}

  ${
    $d R x y $.  $d A x y $.  $d B x y $.
    $( Closed form of ~ brimage .  (Contributed by Scott Fenton, 4-Apr-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    brimageg $p |- ( ( A e. V /\ B e. W ) ->
               ( A Image R B <-> B = ( R " A ) ) ) $=
      ( vx vy cv cimage wbr cima wb breq1 imaeq2 eqeq2d bibi12d breq2 eqeq1 vex
      wceq brimage vtocl2g ) FHZGHZCIZJZUDCUCKZTZLAUDUEJZUDCAKZTZLABUEJZBUJTZLF
      GABDEUCATZUFUIUHUKUCAUDUEMUNUGUJUDUCACNOPUDBTUIULUKUMUDBAUEQUDBUJRPUCUDCF
      SGSUAUB $.
  $}

  ${
    $d A x y z t w $.
    $( ` Image A ` is a function.  (Contributed by Scott Fenton, 27-Mar-2014.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    funimage $p |- Fun Image A $=
      ( vx vy vz cimage wfun wrel cv wbr wa weq wal cvv cep ctxp mpbir wceq vex
      wi brimage cxp ccnv ccom csymdif crn cdif wss df-rel df-image releqi cima
      difss eqtr3 syl2anb gen2 ax-gen dffun2 mpbir2an ) AEZFUSGZBHZCHZUSIZVADHZ
      USIZJCDKZSZDLCLZBLUTMMUAZMNONAUBUCMOUDUEZUFZGZVLVKVIUGVIVJULVKUHPUSVKAUIU
      JPVHBVGCDVCVBAVAUKZQVDVMQVFVEVAVBABRZCRTVAVDAVNDRTVBVDVMUMUNUOUPBCDUSUQUR
      $.
  $}

  ${
    $d R x y $.
    $( ` Image R ` is a function over the set-like portion of ` R ` .
       (Contributed by Scott Fenton, 4-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    fnimage $p |- Image R Fn { x | ( R " x ) e. _V } $=
      ( cimage cima cvv wcel cab wfn wfun cdm wceq funimage wbr wex vex brimage
      vy cv eleq1 mpbii sylbi exlimiv eqid wb brimageg mpan mpbiri breq2 spcegv
      mpd impbii eldm weq imaeq2 eleq1d elab 3bitr4i eqriv df-fn mpbir2an ) BCZ
      BARZDZEFZAGZHVAIVAJZVEKBLQVFVEQRZVBVAMZANZBVGDZEFZVGVFFVGVEFVIVKVHVKAVHVB
      VJKZVKVGVBBQOZAOZPVLVBEFVKVNVBVJESTUAUBVKVGVJVAMZVIVKVOVJVJKZVJUCVGEFVKVO
      VPUDVMVGVJBEEUEUFUGVHVOAVJEVBVJVGVAUHUIUJUKAVGVAVMULVDVKAVGVMAQUMVCVJEVBV
      GBUNUOUPUQURVAVEUSUT $.
  $}

  ${
    $d R x y z $.
    $( The image functor in maps-to notation.  (Contributed by Scott Fenton,
       4-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    imageval $p |- Image R = ( x e. _V |-> ( R " x ) ) $=
      ( vy vz cimage cvv cv cima wfun wbr wcel cdm vex breldm wfn wceq syl6eleq
      ax-mp wb syl5bb cmpt wrel funimage funrel mptrel cab fndm crab eqid dmmpt
      fnimage rabab eqtri imaeq2 eleq1d elab brimage eqcom fvmptg eqeq1d funmpt
      cfv df-fn mpbir2an biimpri fnbrfvb sylancr bitr3d sylbi pm5.21nii eqbrriv
      mpan ) CDBEZAFBAGZHZUAZVMIVMUBBUCVMUDRAFVOUECGZDGZVMJZVQVOFKZAUFZKZVQVRVP
      JZVSVQVMLZWAVQVRVMCMZDMZNVMWAOWDWAPABUKWAVMUGRQWCVQVPLZWAVQVRVPWEWFNWGVTA
      FUHWAAFVOVPVPUIZUJVTAULUMZQWBBVQHZFKZVSWCSVTWKAVQWEVNVQPVOWJFVNVQBUNZUOUP
      ZVSVRWJPZWKWCVQVRBWEWFUQWNWJVRPZWKWCVRWJURWKVQVPVBZVRPZWOWCWKWPWJVRVQFKWK
      WPWJPWEAVQVOWJFFVPWLWHUSVLUTWKVPWAOZWBWQWCSWRVPIWGWAPAFVOVAWIVPWAVCVDWBWK
      WMVEWAVQVRVPVFVGVHTTVIVJVK $.
  $}

  ${
    $d R x $.  $d A x $.
    $( The value of the image functor.  (Contributed by Scott Fenton,
       4-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    fvimage $p |- ( ( A e. V /\ ( R " A ) e. W ) ->
             ( Image R ` A ) = ( R " A ) ) $=
      ( vx wcel cvv cima cimage cfv wceq elex cv imaeq2 imageval fvmptg sylan )
      ACFAGFBAHZDFABIZJRKACLEABEMZHRGDSTABNEBOPQ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    brcart.1 $e |- A e. _V $.
    brcart.2 $e |- B e. _V $.
    brcart.3 $e |- C e. _V $.
    $( Binary relationship form of the cartesian product operator.
       (Contributed by Scott Fenton, 11-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brcart $p |- ( <. A , B >. Cart C <-> C = ( A X. B ) ) $=
      ( vx vy vz cop cvv cxp ccart cep wbr wcel cv wex wa epelc cpprod mpbir2an
      opex df-cart opelvv brxp w3a 3anass anbi12i anbi2i bitri 2exbii brpprod3b
      wceq vex elxp 3bitr4ri brtxpsd3 ) GABJZCKKLZKLZMNNUAZABLZABUCFUDUSCVAOUSU
      TPCKPABDEUEFUSCUTKUFUBGQZHQZIQZJUNZVEANOZVFBNOZUGZIRHRVGVEAPZVFBPZSZSZIRH
      RVDUSVBOVDVCPVJVNHIVJVGVHVISZSVNVGVHVIUHVOVMVGVHVKVIVLVEADTVFBETUIUJUKULH
      INNVDABGUODEUMHIVDABUPUQUR $.
  $}

  ${
    $d A x p $.  $d B x p $.
    brdomain.1 $e |- A e. _V $.
    brdomain.2 $e |- B e. _V $.
    $( The binary relationship form of the domain function.  (Contributed by
       Scott Fenton, 11-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brdomain $p |- ( A Domain B <-> B = dom A ) $=
      ( c1st cvv cxp cres cimage wbr cima cdomain brimage df-domain breqi dfdm5
      wceq cdm eqeq2i 3bitr4i ) ABEFFGHZIZJBUAAKZQABLJBARZQABUACDMABLUBNOUDUCBA
      PST $.

    $( The binary relationship form of the range function.  (Contributed by
       Scott Fenton, 11-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brrange $p |- ( A Range B <-> B = ran A ) $=
      ( c2nd cvv cxp cres cimage wbr cima wceq crn brimage df-range breqi dfrn5
      crange eqeq2i 3bitr4i ) ABEFFGHZIZJBUAAKZLABRJBAMZLABUACDNABRUBOPUDUCBAQS
      T $.
  $}

  ${
    $d A a b $.  $d B a b $.
    $( Closed form of ~ brdomain .  (Contributed by Scott Fenton,
       2-May-2014.) $)
    brdomaing $p |- ( ( A e. V /\ B e. W ) ->
               ( A Domain B <-> B = dom A ) ) $=
      ( va vb cv cdomain wbr cdm wceq breq1 dmeq eqeq2d bibi12d breq2 eqeq1 vex
      wb brdomain vtocl2g ) EGZFGZHIZUCUBJZKZSAUCHIZUCAJZKZSABHIZBUHKZSEFABCDUB
      AKZUDUGUFUIUBAUCHLULUEUHUCUBAMNOUCBKUGUJUIUKUCBAHPUCBUHQOUBUCERFRTUA $.

    $( Closed form of ~ brrange .  (Contributed by Scott Fenton,
       3-May-2014.) $)
    brrangeg $p |- ( ( A e. V /\ B e. W ) ->
               ( A Range B <-> B = ran A ) ) $=
      ( va vb cv crange wbr crn wceq wb breq1 rneq eqeq2d bibi12d breq2 brrange
      eqeq1 vex vtocl2g ) EGZFGZHIZUCUBJZKZLAUCHIZUCAJZKZLABHIZBUHKZLEFABCDUBAK
      ZUDUGUFUIUBAUCHMULUEUHUCUBANOPUCBKUGUJUIUKUCBAHQUCBUHSPUBUCETFTRUA $.
  $}

  ${
    $d A a $.  $d a b $.  $d A b $.  $d a p $.  $d A p $.  $d a q $.  $d A q $.
    $d a x $.  $d A x $.  $d a y $.  $d A y $.  $d B a $.  $d B b $.  $d b p $.
    $d B p $.  $d b q $.  $d B q $.  $d b x $.  $d B x $.  $d b y $.  $d B y $.
    $d C a $.  $d p q $.  $d p x $.  $d p y $.  $d q x $.  $d q y $.  $d x y $.
    brimg.1 $e |- A e. _V $.
    brimg.2 $e |- B e. _V $.
    brimg.3 $e |- C e. _V $.
    $( The binary relationship form of the ` Img ` function.  (Contributed by
       Scott Fenton, 12-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brimg $p |- ( <. A , B >. Img C <-> C = ( A " B ) ) $=
      ( va vx vb vp vq cop wbr c1st wceq wa wex 3bitri wcel bitri cimg c2nd cvv
      ccom cres cimage ccart cima df-img breqi cv opex brco brcart anbi1i exbii
      cxp vex xpex breq1 ceqsexv brimage 19.42v anass an12 anbi2i 2exbii anbi2d
      excom wrex df-br risset brres ancom 3bitr3ri weq w3a opeq1 breq1d anbi12d
      elvv br1steq equcom br2ndeq anbi12i syl6bb pm5.32i df-3an 3bitr4i 19.41vv
      eqeq2d opeq2 ceqsex2v 3bitr4ri rexbii df-rex elima2 bitr4i exrot3 eqeq2i
      elxp eqriv ) ABLZCUAMXCCUBNUDZNUCUCUQZUEZUEZUFZUGUDZMZABUQZCXHMZCABUHZOZX
      CCUAXIUIUJXJXCGUKZUGMZXOCXHMZPZGQXOXKOZXQPZGQXLGXCCXHUGABULFUMXRXTGXPXSXQ
      ABXODEGURZUNUOUPXQXLGXKABDEUSZXOXKCXHUTVARXLCXGXKUHZOXNXKCXGYBFVBYCXMCHYC
      XMIUKZBSZYDHUKZAMZPZIQJUKZXOYDLZOZXOASZYEPZPZYIYFXGMZPZGQJQZIQZYFXMSYFYCS
      ZYHYQIYEYLYJYFXGMZPZPZGQZYEUUAGQZPYQYHYEUUAGVCYQYKYEYLYOPZPZPZGQJQUUGJQZG
      QUUCYPUUGJGYPYKYMYOPZPUUGYKYMYOVDUUIUUFYKUUIYLYEYOPPUUFYLYEYOVDYLYEYOVETV
      FTVGUUGJGVIUUHUUBGUUFUUBJYJXOYDULYKUUEUUAYEYKYOYTYLYIYJYFXGUTVHVHVAUPRYGU
      UDYEYGYDYFLZASZYTGAVJZUUDYDYFAVKUUKXOUUJOZGAVJUULGUUJAVLUUMYTGAYJYFXDMZXO
      XESZXOYDNMZPZPZUUNYJXFSZPUUMYTUUQUUSUUNXOYDXFMUUPUUOPUUSUUQXOYDNXEIURZVMX
      OYDXFVKUUPUUOVNVOVFUUMUUQUUNPZUURUUOUUPUUNPZPXOYIKUKZLZOZKQJQZUVBPZUVAUUM
      UUOUVFUVBJKXOWAUOUUOUUPUUNVDUVEUVBPZKQJQJIVPZKHVPZUVEVQZKQJQUVGUUMUVHUVKJ
      KUVEUVIUVJPZPUVLUVEPUVHUVKUVEUVLVNUVEUVBUVLUVEUVBUVDYDNMZUVDYDLZYFXDMZPUV
      LUVEUUPUVMUUNUVOXOUVDYDNUTUVEYJUVNYFXDXOUVDYDVRVSVTUVMUVIUVOUVJUVMIJVPUVI
      YIUVCYDJURZKURZUUTWBIJWCTUVOUVEXOYFUBMZPZGQZHKVPZUVJUVOUVNXONMZUVRPZGQUVT
      GUVNYFUBNUVDYDULHURZUMUWCUVSGUWBUVEUVRUVDYDXOYIUVCULZUUTYAWBUOUPTUVTUVDYF
      UBMZUWAUVRUWFGUVDUWEXOUVDYFUBUTVAYIUVCYFUVPUVQUWDWDTHKWCRWEWFWGUVIUVJUVEW
      HWIVGUVEUVBJKWJUVEXOYDUVCLZOUUMJKYDYFUUTUWDUVIUVDUWGXOYIYDUVCVRWKUVJUWGUU
      JXOUVCYFYDWLWKWMVOWNUUQUUNVNTYJYFXDXFUWDVMWIWOTYTGAWPRVFWNUPIYFABUWDWQYSY
      IXKSZYOPZJQYPIQGQZJQZYRJYFXGXKUWDWQUWIUWJJUWIYNIQGQZYOPUWJUWHUWLYOGIYIABX
      AUOYNYOGIWJWRUPUWKYPJQIQGQYRYPJGIWSYPGIJWSTRWNXBWTTR $.
  $}

  ${
    $d A a $.  $d a b $.  $d A b $.  $d a x $.  $d A x $.  $d A y $.  $d B a $.
    $d B b $.  $d b x $.  $d B x $.  $d B y $.  $d C x $.  $d C y $.  $d x y $.
    $d x z $.  $d y z $.  $d a z $.  $d A z $.  $d b z $.  $d B z $.
    brapply.1 $e |- A e. _V $.
    brapply.2 $e |- B e. _V $.
    brapply.3 $e |- C e. _V $.
    $( The binary relationship form of the ` Apply ` function.  (Contributed by
       Scott Fenton, 12-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brapply $p |- ( <. A , B >. Apply C <-> C = ( A ` B ) ) $=
      ( vx vy vz va vb csingles wceq wa wex wbr eqeq2d cbigcup cvv wcel cv cima
      csn cin cuni cop capply cfv snex inex1 unieq unieqd ceqsexv ccom cxp ctxp
      cep cres csymdif crn cdif csingle cimg cid cpprod df-apply breqi opex vex
      brco w3a brpprod3a 3anrot ideq eqcom bitri brsingle biid 3anbi123i 2exbii
      opeq1 opeq2 ceqsex2v 3bitri anbi1i exbii breq1 brimg anbi12i imaexg ax-mp
      sneq eqid brxp mpbir2an epel brres 3bitr4ri brtxpsd3 ineq1 brbigcup uniex
      elin dffv5 eqeq2i 3bitr4i ) GUAZABUCZUBZUCZLUDZMZCXGUEZUEZMZNZGOZCXKUEZUE
      ZMZABUFZCUGPZCBAUHZMXOXTGXKXJLXIUIZUJXLXNXSCXLXMXRXGXKUKULQUMYBYACRRUNZSS
      UOZSUQUPUQLURZSUPUSUTVAZVBVCUNZVDVBVEZUNZUNZUNZPYAXGYLPZXGCYEPZNZGOXQYACU
      GYMVFVGGYACYEYLABVHZFVJYPXPGYNXLYOXOYNYAHUAZYKPZYRXGYHPZNZHOYRXJMZXGYRLUD
      ZMZNZHOXLHYAXGYHYKYQGVIZVJUUAUUEHYSUUBYTUUDYSYAIUAZYJPZUUGYRYIPZNZIOUUGAX
      HUFZMZUUINZIOZUUBIYAYRYIYJYQHVIZVJUUJUUMIUUHUULUUIUUHUUGJUAZKUAZUFZMZAUUP
      VDPZBUUQVBPZVKZKOJOUUPAMZUUQXHMZUUSVKZKOJOUULJKVDVBABUUGDEIVIVLUVBUVEJKUV
      BUUTUVAUUSVKUVEUUSUUTUVAVMUUTUVCUVAUVDUUSUUSUUTAUUPMUVCAUUPJVIVNAUUPVOVPB
      UUQEKVIVQUUSVRVSVPVTUUSUUGAUUQUFZMUULJKAXHDBUIZUVCUURUVFUUGUUPAUUQWAQUVDU
      VFUUKUUGUUQXHAWBQWCWDWEWFUUNUUKYRYIPZUUKXGVCPZXGYRVBPZNZGOZUUBUUIUVHIUUKA
      XHVHZUUGUUKYRYIWGUMGUUKYRVBVCUVMUUOVJUVLXGXIMZYRXGUCZMZNZGOUUBUVKUVQGUVIU
      VNUVJUVPAXHXGDUVGUUFWHXGYRUUFUUOVQWIWFUVPUUBGXIASTXISTDAXHSWJWKUVNUVOXJYR
      XGXIWLQUMVPWDWDIYRXGYFYHYGUUCUUOUUFYHWMYRXGYFPYRSTXGSTUUOUUFYRXGSSWNWOUUG
      YRUQPZUUGLTZNUUGYRTZUVSNUUGYRYGPUUGUUCTUVRUVTUVSIHWPWEUUGYRUQLUUOWQUUGYRL
      XCWRWSWIWFUUDXLHXJYDUUBUUCXKXGYRXJLWTQUMWDYOXGYRRPZYRCRPZNZHOYRXMMZCYRUEZ
      MZNZHOXOHXGCRRUUFFVJUWCUWGHUWAUWDUWBUWFUWAXMYRMUWDXGYRUUOXAXMYRVOVPUWBUWE
      CMUWFYRCFXAUWECVOVPWIWFUWFXOHXMXGUUFXBUWDUWEXNCYRXMUKQUMWDWIWFWDYCXSCBAXD
      XEXF $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d C x y $.
    brcup.1 $e |- A e. _V $.
    brcup.2 $e |- B e. _V $.
    brcup.3 $e |- C e. _V $.
    $( Binary relationship form of the ` Cup ` function.  (Contributed by Scott
       Fenton, 14-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    brcup $p |- ( <. A , B >. Cup C <-> C = ( A u. B ) ) $=
      ( vx vy cvv cxp c1st ccnv cep ccom c2nd cun wbr wcel wa wex cop ccup opex
      df-cup opelvv brxp mpbir2an cv wceq wel epel brcnv br1steq bitri anbi12ci
      vex exbii brco clel3 3bitr4i br2ndeq orbi12i brun elun 3bitr4ri brtxpsd3
      wo ) GABUAZCIIJZIJZUBKLZMNZOLZMNZPZABPZABUCZFUDVHCVJQVHVIRCIRABDEUEFVHCVI
      IUFUGGUHZVHVLQZVRVHVNQZVGVRARZVRBRZVGVRVHVOQVRVPRVSWAVTWBVRHUHZMQZWCVHVKQ
      ZSZHTWCAUIZGHUJZSZHTVSWAWFWIHWDWHWEWGGHUKZWEVHWCKQWGWCVHKHUPZVQULABWCDEWK
      UMUNUOUQHVRVHVKMGUPZVQURHVRADUSUTWDWCVHVMQZSZHTWCBUIZWHSZHTVTWBWNWPHWDWHW
      MWOWJWMVHWCOQWOWCVHOWKVQULABWCDEWKVAUNUOUQHVRVHVMMWLVQURHVRBEUSUTVBVRVHVL
      VNVCVRABVDVEVF $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d C x $.
    brcap.1 $e |- A e. _V $.
    brcap.2 $e |- B e. _V $.
    brcap.3 $e |- C e. _V $.
    $( Binary relationship form of the ` Cap ` function.  (Contributed by Scott
       Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    brcap $p |- ( <. A , B >. Cap C <-> C = ( A i^i B ) ) $=
      ( vx vy cvv cxp c1st ccnv cep ccom c2nd cin wbr wcel wa wex cop ccap opex
      df-cap opelvv brxp mpbir2an cv wceq wel epel brcnv br1steq bitri anbi12ci
      vex exbii brco clel3 3bitr4i br2ndeq anbi12i brin elin 3bitr4ri brtxpsd3
      ) GABUAZCIIJZIJZUBKLZMNZOLZMNZPZABPZABUCZFUDVGCVIQVGVHRCIRABDEUEFVGCVHIUF
      UGGUHZVGVKQZVQVGVMQZSVQARZVQBRZSVQVGVNQVQVORVRVTVSWAVQHUHZMQZWBVGVJQZSZHT
      WBAUIZGHUJZSZHTVRVTWEWHHWCWGWDWFGHUKZWDVGWBKQWFWBVGKHUPZVPULABWBDEWJUMUNU
      OUQHVQVGVJMGUPZVPURHVQADUSUTWCWBVGVLQZSZHTWBBUIZWGSZHTVSWAWMWOHWCWGWLWNWI
      WLVGWBOQWNWBVGOWJVPULABWBDEWJVAUNUOUQHVQVGVLMWKVPURHVQBEUSUTVBVQVGVKVMVCV
      QABVDVEVF $.
  $}

  ${
    $d A a b x $.  $d B a b x $.
    brsuccf.1 $e |- A e. _V $.
    brsuccf.2 $e |- B e. _V $.
    $( Binary relationship form of the ` Succ ` function.  (Contributed by
       Scott Fenton, 14-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brsuccf $p |- ( A Succ B <-> B = suc A ) $=
      ( vx va vb csuccf wbr ccup cid csingle wceq cun cv wex bitri bitr4i exbii
      wa ctxp ccom csuc df-succf breqi csn cop brco w3a brtxp2 3anass vex eqcom
      ideq brsingle anbi12i anbi2i 2exbii anbi1i 19.41vv anass excom opex breq1
      brcup syl6bb anbi2d df-3an snex uneq1 eqeq2d uneq2 ceqsex2v 3bitri df-suc
      ceqsexv eqeq2i ) ABHIABJKLUAZUBZIZBAUCZMZABHVSUDUEVTBAAUFZNZMZWBVTAEOZVRI
      ZWFBJIZTZEPWFFOZGOZUGZMZWJAMZWKWCMZTZWHTZTZGPZFPZEPZWEEABJVRCDUHWIWTEWIWM
      WPTZWHTZGPFPZWTWIXBGPFPZWHTXDWGXEWHWGWMAWJKIZAWKLIZUIZGPFPXEFGAWFKLCUJXHX
      BFGXHWMXFXGTZTXBWMXFXGUKXIWPWMXFWNXGWOXFAWJMWNAWJFULZUNAWJUMQAWKCGULZUOUP
      UQQURQUSXBWHFGUTRXCWRFGWMWPWHVAURQSXAWSEPZFPWNWOBWJWKNZMZUIZGPZFPWEWSEFVB
      XLXPFXLWREPZGPXPWREGVBXQXOGXQWPXNTZXOWQXREWLWJWKVCWMWHXNWPWMWHWLBJIXNWFWL
      BJVDWJWKBXJXKDVEVFVGVPWNWOXNVHRSQSXNBAWKNZMWEFGAWCCAVIWNXMXSBWJAWKVJVKWOX
      SWDBWKWCAVLVKVMVNVNWAWDBAVOVQRQ $.
  $}

  ${
    $d A x y z $.  $d F x y z $.
    $( Lemma for ~ funpartfun .  Show membership in the restriction.
       (Contributed by Scott Fenton, 4-Dec-2017.) $)
    funpartlem $p |- (
    A e. dom ( ( Image F o. Singleton ) i^i ( _V X. Singletons ) ) <->
    E. x ( F " { A } ) = { x } ) $=
      ( vy vz csingle cvv csingles wcel csn cima cv wex vex c0 wbr exbii 3bitri
      wceq wa cimage ccom cxp cin cdm elex snid eleq2 mpbiri n0i biimpi imaeq2d
      wn snprc ima0 syl6eq nsyl2 syl exlimiv eleq1 sneq eqeq1d exbidv eldm brxp
      mpbiran elsingles bitri anbi2i 19.42v 3bitr4i excom exancom breq2 ceqsexv
      brin snex brco brsingle anbi1i breq1 brimage eqcom vtoclbg pm5.21nii ) BC
      UAZFUBZGHUCZUDZUEZIZBGIZCBJZKZALZJZSZAMZBWJUFWQWLAWQWOWNIZWLWQWSWOWPIWOAN
      UGWNWPWOUHUIWSWNOSWLWNWOUJWLUMZWNCOKOWTWMOCWTWMOSBUNUKULCUOUPUQURUSDLZWJI
      ZCXAJZKZWPSZAMZWKWRDBGXABWJUTXABSZXEWQAXGXDWNWPXGXCWMCXABVAULVBVCXBXAELZW
      IPZEMZXAXHWGPZXHWPSZTZEMZAMZXFEXAWIDNZVDXJXMAMZEMXOXIXQEXKXAXHWHPZTXKXLAM
      ZTXIXQXRXSXKXRXHHIZXSXRXAGIXTXPXAXHGHVEVFAXHVGVHVIXAXHWGWHVPXKXLAVJVKQXME
      AVLVHXNXEAXNXLXKTEMXAWPWGPZXEXKXLEVMXKYAEWPWOVQZXHWPXAWGVNVOYAXAXHFPZXHWP
      WFPZTZEMXHXCSZYDTZEMZXEEXAWPWFFXPYBVRYEYGEYCYFYDXAXHXPENVSVTQYHXCWPWFPZWP
      XDSXEYDYIEXCXAVQZXHXCWPWFWAVOXCWPCYJYBWBWPXDWCRRRQRWDWE $.
  $}

  ${
    $d F x y z w $.
    $( The functional part of ` F ` is a function.  (Contributed by Scott
       Fenton, 16-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    funpartfun $p |- Fun Funpart F $=
      ( vx vy vz vw wfun cv wbr wa weq wal wcel vex brres csn bitri cop anbi12i
      wi df-br cfunpart csingle ccom cvv csingles cxp cin cdm cres wrel simplbi
      cimage relres cima wceq wex ancom funpartlem anbi1i elimasn eleq2 anbi12d
      bitr4i elsn equtr2 syl2anb syl6bi syl5bi exlimiv sylanb sylan2 df-funpart
      impl gen2 ax-gen funeqi dffun2 mpbir2an ) AUAZFZAAULUBUCUDUEUFUGUHZUIZUJZ
      BGZCGZWBHZWDDGZWBHZICDJZSZDKCKZBKZAWAUMWKBWJCDWHWFWDWGAHZWIWHWMWDWALZWDWG
      AWADMZNUKWFAWDOUNZEGZOZUOZEUPZWDWEAHZIZWMWIWFXAWNIZXBWDWEAWACMZNXCWNXAIXB
      XAWNUQWNWTXAEWDAURUSPPWTXAWMWIWSXAWMIZWISEXEWEWPLZWGWPLZIZWSWIXEWDWEQALZW
      DWGQALZIXHXAXIWMXJWDWEATWDWGATRXFXIXGXJAWDWEBMZXDUTAWDWGXKWOUTRVCWSXHWEWR
      LZWGWRLZIWIWSXFXLXGXMWPWRWEVAWPWRWGVAVBXLCEJDEJWIXMCWQVDDWQVDCDEVEVFVGVHV
      IVMVJVKVNVOVTWBFWCWLIVSWBAVLVPBCDWBVQPVR $.
  $}

  $( The functional part of ` F ` is a subset of ` F ` .  (Contributed by Scott
     Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  funpartss $p |- Funpart F C_ F $=
    ( cfunpart cimage csingle ccom cvv csingles cxp cin cres df-funpart eqsstri
    cdm resss ) ABAACDEFGHIMZJAAKAONL $.

  ${
    $d A x $.  $d F x $.
    $( The function value of the functional part is identical to the original
       functional value.  (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised
       by Mario Carneiro, 19-Apr-2014.) $)
    funpartfv $p |- ( Funpart F ` A ) = ( F ` A ) $=
      ( vx cfunpart cfv cimage csingle ccom cvv csingles cxp cin cdm wcel wn c0
      wceq weu csn pm2.61i cres df-funpart fveq1i fvres nfvres wi cv funpartlem
      wbr cima wex bitr4i cop wb vex elimasng mpan2 df-br syl6bbr eubidv syl5bb
      eusn notbid tz6.12-2 syl6bi fvprc a1d eqtr4d eqtri ) ABDZEABBFGHIJKLMZUAZ
      EZABEZAVJVLBUBUCAVKNZVMVNQAVKBUDVOOZVMPVNAVKBUEAINZVPVNPQZUFVQVPACUGZBUIZ
      CRZOVRVQVOWAVOVSBASUJZNZCRZVQWAVOWBVSSQCUKWDCABUHCWBVBULVQWCVTCVQWCAVSUMB
      NZVTVQVSINWCWEUNCUOBAVSIIUPUQAVSBURUSUTVAVCCABVDVEVQOVRVPABVFVGTVHTVI $.
  $}

  ${
    $( The full functional part of ` F ` is a function over ` _V ` .
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    fullfunfnv $p |- FullFun F Fn _V $=
      ( cfullfn cvv wfn cfunpart cdm cdif c0 csn cxp cun wa cin wceq funpartfun
      wfun funfn mpbi wf 0ex fconst ax-mp pm3.2i disjdif fnun df-fullfun fneq1i
      ffn mp2an unvdif eqcomi fneq2i bitri mpbir ) ABZCDZAEZCUQFZGZHIZJZKZURUSK
      ZDZUQURDZVAUSDZLURUSMHNVDVEVFUQPVEAOUQQRUSUTVASVFUSHTUAUSUTVAUHUBUCURCUDU
      RUSUQVAUEUIUPVBCDVDCUOVBAUFUGCVCVBVCCURUJUKULUMUN $.
  $}

  ${
    $d F x $.  $d A x $.
    $( The function value of the full function of ` F ` agrees with ` F ` .
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    fullfunfv $p |- ( FullFun F ` A ) = ( F ` A ) $=
      ( vx cvv wcel cfullfn cfv wceq cv fveq2 c0 wfn wa 0ex mp3an12 mpan eqtr4d
      wn pm2.61i fvprc eqeq12d cfunpart cdm cdif csn cxp cun df-fullfun disjdif
      fveq1i cin wfun funpartfun funfn mpbi wf fconst ffn ax-mp fvun1 vex eldif
      mpbiran fvun2 fvconst2 eqtrd sylbir ndmfv funpartfv 3eqtri vtoclg ) ADEZA
      BFZGZABGZHZCIZVMGZVQBGZHVPCADVQAHVRVNVSVOVQAVMJVQABJUAVRVQBUBZDVTUCZUDZKU
      EZUFZUGZGZVQVTGZVSVQVMWEBUHUJVQWAEZWFWGHZWAWBUKKHZWHWIWADUIZVTWALZWDWBLZW
      JWHMWIVTULWLBUMVTUNUOZWBWCWDUPWMWBKNUQWBWCWDURUSZWAWBVTWDVQUTOPWHRZWFKWGW
      PVQWBEZWFKHWQVQDEWPCVAVQDWAVBVCWQWFVQWDGZKWJWQWFWRHZWKWLWMWJWQMWSWNWOWAWB
      VTWDVQVDOPWBKVQNVEVFVGVQVTVHQSVQBVIVJVKVLRVNKVOAVMTABTQS $.
  $}

  ${
    brfullfun.1 $e |- A e. _V $.
    brfullfun.2 $e |- B e. _V $.
    $( A binary relationship form condition for the full function.
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brfullfun $p |- ( A FullFun F B <-> B = ( F ` A ) ) $=
      ( cfullfn cfv wceq wbr eqcom cvv wfn wcel wb fullfunfnv fnbrfvb fullfunfv
      mp2an eqeq2i 3bitr3i ) ACFZGZBHZBUBHABUAIZBACGZHUBBJUAKLAKMUCUDNCODKABUAP
      RUBUEBACQST $.
  $}

  ${
    $d A a b x $.  $d B a b x $.  $d C x $.
    brrestrict.1 $e |- A e. _V $.
    brrestrict.2 $e |- B e. _V $.
    brrestrict.3 $e |- C e. _V $.
    $( The binary relationship form of the ` Restrict ` function.  (Contributed
       by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    brrestrict $p |- ( <. A , B >. Restrict C <-> C = ( A |` B ) ) $=
      ( vx va vb cop ccap c1st ccart crange wbr wceq wa wex w3a bitri c2nd ccom
      ctxp crn cxp cin crestrict cres cv opex brtxp2 3anrot vex br1steq br2ndeq
      brco anbi1i exbii breq1 ceqsexv brrange 3bitri biid 3anbi123i 2exbii rnex
      opeq1 eqeq2d opeq2 ceqsex2v brcart brcap df-restrict breqi dfres3 3bitr4i
      xpex eqeq2i ) ABJZCKLMUANLUBZUCZUBZUCZUBZOZCABAUDZUEZUFZPZVSCUGOCABUHZPWE
      GUIZAWGJZPZWKCKOZQZGRZWLCKOZWIWEVSWKWCOZWNQZGRWPGVSCKWCABUJZFUPWSWOGWRWMW
      NWRWKHUIZIUIZJZPZVSXALOZVSXBWBOZSZIRHRXAAPZXBWGPZXDSZIRHRWMHIVSWKLWBWTUKX
      GXJHIXGXEXFXDSXJXDXEXFULXEXHXFXIXDXDABXADEHUMZUNXFVSWKWAOZWKXBMOZQZGRZBWF
      JZXBMOZXIGVSXBMWAWTIUMZUPXOWKXPPZXMQZGRXQXNXTGXLXSXMXLXDVSXAUAOZVSXBVTOZS
      ZIRHRXABPZXBWFPZXDSZIRHRXSHIVSWKUAVTWTUKYCYFHIYCYAYBXDSYFXDYAYBULYAYDYBYE
      XDXDABXADEXKUOYBVSWKLOZWKXBNOZQZGRZAXBNOZYEGVSXBNLWTXRUPYJWKAPZYHQZGRYKYI
      YMGYGYLYHABWKDEGUMUNUQURYHYKGADWKAXBNUSUTTAXBDXRVAVBXDVCZVDTVEXDWKBXBJZPX
      SHIBWFEADVFZYDXCYOWKXABXBVGVHYEYOXPWKXBWFBVIVHVJVBUQURXMXQGXPBWFUJWKXPXBM
      USUTTBWFXBEYPXRVKVBYNVDTVEXDWKAXBJZPWMHIAWGDBWFEYPVQZXHXCYQWKXAAXBVGVHXIY
      QWLWKXBWGAVIVHVJVBUQURTWNWQGWLAWGUJWKWLCKUSUTAWGCDYRFVLVBVSCUGWDVMVNWJWHC
      ABVOVRVP $.
  $}

  ${
    $d A a b f x y z $.  $d F a b f x y z $.
    $( A quantifier-free definition of the recursive definition generator.
       (Contributed by Scott Fenton, 17-Apr-2014.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    dfrdg4 $p |- rec ( F , A ) = U.
       ( ( Funs i^i ( `' Domain " On ) ) \
         dom ( ( `' _E o. Domain ) \
         Fix ( `' Apply o.
               ( ( ( _V X. { (/) } ) X. { U. { A } } ) u.
                 ( ( ( Bigcup o. Img ) |` ( _V X. Limits ) ) u.
                   ( ( FullFun F o. ( Apply o. pprod ( _I , Bigcup ) ) ) |`
                     ( _V X. ran Succ ) ) ) ) ) ) ) $=
      ( vf vx vy vz va vb c0 wceq cvv wcel wa con0 capply wex 3bitri bitri wbr
      wn crdg cv wfn cfv cif wlim cima cuni wral wrex cab cfuns cdomain cin cep
      ccnv ccom csn cxp cbigcup cimg climits cres cfullfn cid cpprod csuccf crn
      cun cfix cdif cdm dfrdg3 wfun an12 df-fn ancom eqcom anass exbii vex dmex
      anbi1i eleq1 anbi12d ceqsexv df-rex brcnv anbi12i wi brco breq1 wb w3a wo
      cop brun opelxp mpbiran elsn brres opex brbigcup ax-mp unieq anbi12ci weq
      eqeq2d brapply fvex orbi12i limeq mtbiri intnanrd wne mpbiri neneqd orel2
      syl iftrue biimprd adantld biimpd anc2li orc syl6 rexlimivw orel1 iffalse
      impbid fveq2d ifbieq2d 3syld con2i adantl syl5bb syl6bb exbidv syl6bbr
      olcd raleq anbi2d eldif elin elfuns elima brdomain wal brdif epelc onelon
      3adant1 csuc brxp brimg imaexg eqeq1d ellimits brpprod3a 3anrot ideq biid
      equcom 3anbi123i 2exbii uniex opeq1 opeq2 ceqsex2v brfullfun elrn brsuccf
      fveq2 w3o onzsl nlim0 nsuceq0 neeq2 necomd nexdv sylanbrc unisnif syl6eqr
      ioran syld neeq1 nlimsucg df-ne mpbi eqtri eqeq1 3eqtr4a rexex olc ee12an
      mp2b exlimiv eqtrd 3jaoi sylbi df-br eqvinc 3bitr4g notbid 3expia pm5.32d
      a1i elfix annim exnal syl6rbb eldm con1bid df-ral pm5.32i 3bitr4ri abbi2i
      unieqi eqtr4i ) BAUACUBZDUBZUCZEUBZUXTUDZUYCIJZAKLAIUEZUYCUFZUXTUYCUGZUHZ
      UYCUHZUXTUDZBUDZUEZUEZJZEUYAUIZMZDNUJZCUKZUHULUMUPZNUGZUNZUOUPZUMUQZOUPZK
      IURZUSZAURUHZURZUSZUTVAUQZKVBUSZVCZBVDZOVEUTVFZUQZUQZKVGVHZUSZVCZVIZVIZUQ
      ZVJZVKZVLZVKZUHDECBAVMVVGUYSUYRCVVGUYANLZUYQMZDPZUXTVNZUXTVLZNLZUYOEVVLUI
      ZMZMZUYRUXTVVGLZVVJUYAVVLJZVVKVVHUYPMZMZMZDPVVPVVIVWADVVIUYBVVSMVVRVVKMZV
      VSMVWAVVHUYBUYPVOUYBVWBVVSUYBVVKVVLUYAJZMVWCVVKMVWBUXTUYAVPVVKVWCVQVWCVVR
      VVKVVLUYAVRWCQWCVVRVVKVVSVSQVTVVTVVPDVVLUXTCWAZWBZVVRVVSVVOVVKVVRVVHVVMUY
      PVVNUYAVVLNWDZUYOEUYAVVLUUAWEUUBWFRUYQDNWGVVQUXTVUBLZUXTVVFLZTZMVVKVVMMZV
      WIMZVVPUXTVUBVVFUUCVWGVWJVWIVWGUXTULLZUXTVUALZMVWJUXTULVUAUUDVWLVVKVWMVVM
      UXTVWDUUEVWMUYAUXTUYTSZDNUJVVHVWNMZDPZVVMDUXTUYTNVWDUUFVWNDNWGVWPVVRVVHMZ
      DPVVMVWOVWQDVWOVWNVVHMVWQVVHVWNVQVWNVVRVVHVWNUXTUYAUMSZVVRUYAUXTUMDWAZVWD
      WHUXTUYAVWDVWSUUGZRWCRVTVVHVVMDVVLVWEVWFWFRQWIRWCVWKVWJVVNMVVPVWJVWIVVNVW
      JVWIUYCVVLLZUYOWJZEUUHZVVNVWJVXCVWHVWJVXCTZUXTUYCVVESZEPZVWHVWJVXFVXBTZEP
      VXDVWJVXEVXGEVXEVXAUXTUYCVVDSZTZMZVWJVXGVXEUXTUYCVUDSZVXIMVXJUXTUYCVUDVVD
      UUIVXKVXAVXIVXKVWRUYAUYCVUCSZMZDPZVVLUYCVUCSZVXADUXTUYCVUCUMVWDEWAZWKVXNV
      VRVXLMZDPVXOVXMVXQDVWRVVRVXLVWTWCVTVXLVXODVVLVWEUYAVVLUYCVUCWLWFRVXOUYCVV
      LUOSVXAVVLUYCUOVWEVXPWHUYCVVLVWEUUJRQWCRVWJVXJVXAUYOTZMVXGVWJVXAVXIVXRVVK
      VVMVXAVXIVXRWMVVKVVMVXAWNZVXHUYOVXSUXTUYCWPZUYAVVBSZUYAVXTVUESZMZDPZUYAUY
      DJZUYAUYNJZMZDPVXHUYOVXSVYCVYGDVXSVYCVYFVYEMVYGVXSVYAVYFVYBVYEVXSUYCNLZVY
      AVYFWMVVMVXAVYHVVKVVLUYCUUKUULVYAUYEUYAVUHJZMZUYGUYAUYIJZMZUYCFUBZUUMZJZF
      PZUYAUYLJZMZWOZWOZVYHVYFVYAVXTUYAVUJSZVXTUYAVVASZWOVYTVXTUYAVUJVVAWQWUAVY
      JWUBVYSWUAVXTVUGLZUYAVUILZMVYJVXTUYAVUGVUIUUNWUCUYEWUDVYIWUCUYCVUFLZUYEWU
      CUXTKLZWUEVWDUXTUYCKVUFWRWSEIWTRDVUHWTWIRWUBVXTUYAVUMSZVXTUYAVUTSZWOVYSVX
      TUYAVUMVUTWQWUGVYLWUHVYRWUGVXTUYAVUKSZVXTVULLZMVYLVXTUYAVUKVULVWSXAWUIVYK
      WUJUYGWUIVXTVYMVASZVYMUYAUTSZMZFPVYMUYHJZVYMUHZUYAJZMZFPZVYKFVXTUYAUTVAUX
      TUYCXBZVWSWKWUMWUQFWUKWUNWULWUPUXTUYCVYMVWDVXPFWAZUUOVYMUYAVWSXCWIVTWURUY
      IUYAJZVYKWUPWVAFUYHWUFUYHKLVWDUXTUYCKUUPXDWUNWUOUYIUYAVYMUYHXEUUQWFUYIUYA
      VRRQWUJUYCVBLZUYGWUJWUFWVBVWDUXTUYCKVBWRWSUYCVXPUURRXFRWUHVXTUYAVUQSZVXTV
      USLZMVYRVXTUYAVUQVUSVWSXAWVCVYQWVDVYPWVCVXTGUBZVUPSZWVEUYAVUNSZMZGPWVEUYK
      JZUYAWVEBUDZJZMZGPVYQGVXTUYAVUNVUPWUSVWSWKWVHWVLGWVFWVIWVGWVKWVFVXTVYMVUO
      SZVYMWVEOSZMZFPVYMUXTUYJWPZJZWVNMZFPZWVIFVXTWVEOVUOWUSGWAZWKWVOWVRFWVMWVQ
      WVNWVMVYMWVEHUBZWPZJZUXTWVEVESZUYCWWAUTSZWNZHPGPGCXGZWWAUYJJZWWCWNZHPGPWV
      QGHVEUTUXTUYCVYMVWDVXPWUTUUSWWFWWIGHWWFWWDWWEWWCWNWWIWWCWWDWWEUUTWWDWWGWW
      EWWHWWCWWCWWDCGXGWWGUXTWVEWVTUVACGUVCRWWEUYJWWAJWWHUYCWWAHWAXCUYJWWAVRRWW
      CUVBUVDRUVEWWCVYMUXTWWAWPZJWVQGHUXTUYJVWDUYCVXPUVFZWWGWWBWWJVYMWVEUXTWWAU
      VGXHWWHWWJWVPVYMWWAUYJUXTUVHXHUVIQWCVTWVSWVPWVEOSZWVIWVNWWLFWVPUXTUYJXBVY
      MWVPWVEOWLWFUXTUYJWVEVWDWWKWVTXIRQWVEUYABWVTVWSUVJWIVTWVKVYQGUYKUYJUXTXJW
      VIWVJUYLUYAWVEUYKBUVMXHWFQWVDUYCVURLZVYMUYCVGSZFPVYPWVDWUFWWMVWDUXTUYCKVU
      RWRWSFUYCVGVXPUVKWWNVYOFVYMUYCWUTVXPUVLVTQXFRXKRXKRVYHUYEVYOFNUJZUYCKLZUY
      GMZUVNVYTVYFWMZFUYCUVOUYEWWRWWOWWQUYEVYTVYFUYEVYTVYJVYFUYEVYSTZVYTVYJWJUY
      EVYLTZVYRTZWWSUYEUYGVYKUYEUYGIUFUVPUYCIXLXMZXNUYEVYPVYQUYEVYOFUYEUYCVYNUY
      EVYNUYCUYEVYNUYCXOVYNIXOZVYMUVQZUYCIVYNUVRXPUVSXQUVTXNVYLVYRUWDUWAVYSVYJX
      RXSUYEVYIVYFUYEUYEVYFVYIUYEUYNVUHUYAUYEUYNUYFVUHUYEUYFUYMXTAUWBUWCXHZYAYB
      UWEUYEVYFVYJVYTUYEVYFVYIUYEVYFVYIWXEYCYDVYJVYSYEYFYJWWOVYTVYFWWOVYTVYSVYR
      VYFWWOVYJTZVYTVYSWJZVYOWXFFNVYOUYEVYIVYOUYCIVYOUYCIXOWXCWXDUYCVYNIUWFXPXQ
      XNYGVYJVYSYHZXSWWOWWTVYSVYRWJWWOUYGVYKVYOUYGTZFNVYOUYGVYNUFZVYMKLZWXJTZWU
      TVYMKUWGZXDUYCVYNXLZXMZYGXNVYLVYRYHXSWWOVYQVYFVYPWWOVYFVYQWWOUYNUYLUYAVYO
      UYNUYLJFNVYOVYNIJZUYFWXJUYIVYNUHZUXTUDZBUDZUEZUEZWXSUYNUYLWYAWXTWXSWXPTZW
      YAWXTJWXCWYBWXDVYNIUWHUWIWXPUYFWXTYIXDWXKWXLWXTWXSJWUTWXMWXJUYIWXSYIUWPUW
      JVYOUYEWXPUYMWXTUYFUYCVYNIUWKVYOUYGWXJUYLWXSUYIWXNVYOUYKWXRBVYOUYJWXQUXTU
      YCVYNXEYKYKZYLYLWYCUWLYGXHZYAYBYMWWOVYPVYFVYQVYTVYOFNUWMWWOVYFVYQWYDYCVYR
      VYSVYJVYRVYLUWNYTUWOYJWWQVYTVYFUYGVYTVYFWJWWPUYGVYTVYSVYLVYFUYGWXFWXGUYGU
      YEVYIUYEUYGWXBYNZXNWXHXSUYGWXAVYSVYLWJUYGVYPVYQVYPUYGVYOWXIFWXOUWQYNXNVYR
      VYLXRXSUYGVYKVYFUYGUYGVYFVYKUYGUYNUYIUYAUYGUYNUYMUYIUYGUYETUYNUYMJWYEUYEU
      YFUYMYIXSUYGUYIUYLXTUWRXHZYAYBYMYOUYGVYFVYTWJWWPUYGVYFVYLVYTUYGVYFVYKUYGV
      YFVYKWYFYCYDVYLVYSVYJVYLVYRYEYTYFYOYJUWSUWTYPXSVYBVYEWMVXSVYBVXTUYAOSVYEU
      YAVXTOVWSWUSWHUXTUYCUYAVWDVXPVWSXIRUXGWEVYFVYEVQYQYRVXHVXTVVDLVXTVXTVVCSV
      YDUXTUYCVVDUXAVXTVVCWUSUXHDVXTVXTVUEVVBWUSWUSWKQDUYDUYNUYCUXTXJUXBUXCUXDU
      XEUXFVXAUYOUXIYQYPYRVXBEUXJUXKEUXTVVEVWDUXLYSUXMUYOEVVLUXNYSUXOVVKVVMVVNV
      SRQUXPUXQUXRUXS $.
  $}

  ${
    $d f x $.  $d f y $.  $d f z $.  $d G f $.  $d G x $.  $d G y $.  $d G z $.
    $d x y $.  $d x z $.  $d y z $.

    $( Calculate a quantifier-free version of the function from ~ tfr1 through
       ~ tfr3 .  (Contributed by Scott Fenton, 29-Apr-2014.) $)
    tfrqfree $p |- ( ( Funs i^i ( `' Domain " On ) ) \
         dom ( ( `' _E o. Domain ) \
         Fix ( `' Apply o. ( FullFun G o. Restrict ) ) ) ) =
         { f | E. x e. On ( f Fn x /\ A. y e. x ( f ` y ) =
               ( G ` ( f |` y ) ) ) } $=
      ( vz cv wceq wa con0 wrex cdomain wcel wn vex wbr bitri anbi12i wex exbii
      3bitri wfn cfv cres wral cfuns ccnv cima cin cep capply cfullfn crestrict
      ccom cfix cdif cdm wfun elfuns brcnv brdomain rexbii elima risset 3bitr4i
      elin cop eldif wel opelco epel dmex eleq2 opex elfix brrestrict brfullfun
      ceqsexv brco resex fveq2 eqeq2d brapply anbi12ci fvex eqeq1 notbii df-rex
      eldm2 rexnal bitr2i con1bii anass df-fn ancom eqcom anbi1i anbi12d anbi2d
      an12 eleq1 raleq abbi2i ) CFZAFZUAZBFZXCUBZXCXFUCZDUBZGZBXDUDZHZAIJZCUEKU
      FZIUGZUHZUIUFZKUMZUJUFZDUKZULUMZUMZUNZUOZUPZUOZXCXPLZXCYELZMZHZXCUQZXCUPZ
      ILZXJBYLUDZHZHZXCYFLXMYJYKYMHZYNHYPYGYQYIYNYGXCUELZXCXOLZHYQXCUEXOVEYRYKY
      SYMXCCNZURXDXCXNOZAIJXDYLGZAIJYSYMUUAUUBAIUUAXCXDKOZUUBXDXCKANZYTUSXCXDYT
      UUDUTZPVAAXCXNIYTVBAYLIVCVDQPYNYHYHXJMZBYLJZYNMXCXFVFZYDLZBRXFYLLZUUFHZBR
      YHUUGUUIUUKBUUIUUHXRLZUUHYCLZMZHUUKUUHXRYCVGUULUUJUUNUUFUULUUCXDXFXQOZHZA
      RUUBBAVHZHZARUUJAXCXFXQKYTBNZVIUUPUURAUUCUUBUUOUUQUUEUUOXFXDUIOUUQXDXFUIU
      UDUUSUSBAVJPQSUUQUUJAYLXCYTVKZXDYLXFVLVQTUUMXJUUMUUHUUHYBOUUHXDYAOZXDUUHX
      SOZHZARZXJUUHYBXCXFVMZVNAUUHUUHXSYAUVEUVEVRUVDXDXGGZXDXIGZHZARXJUVCUVHAUV
      AUVGUVBUVFUVAUUHEFZULOZUVIXDXTOZHZERUVIXHGZXDUVIDUBZGZHZERUVGEUUHXDXTULUV
      EUUDVRUVLUVPEUVJUVMUVKUVOXCXFUVIYTUUSENZVOUVIXDDUVQUUDVPQSUVOUVGEXHXCXFYT
      VSUVMUVNXIXDUVIXHDVTWAVQTUVBUUHXDUJOUVFXDUUHUJUUDUVEUSXCXFXDYTUUSUUDWBPWC
      SUVGXJAXGXFXCWDXDXGXIWEVQPTWFQPSBXCYDYTWHUUFBYLWGVDXJBYLWIWJWKQYKYMYNWLPX
      CXPYEVGXMXDILZXLHZARUUBYKUVRXKHZHZHZARYPXLAIWGUVSUWBAUVSXEUVTHUUBYKHZUVTH
      UWBUVRXEXKWSXEUWCUVTXEYKYLXDGZHUWDYKHUWCXCXDWMYKUWDWNUWDUUBYKYLXDWOWPTWPU
      UBYKUVTWLTSUWAYPAYLUUTUUBUVTYOYKUUBUVRYMXKYNXDYLIWTXJBXDYLXAWQWRVQTVDXB
      $.
  $}

  ${
    $d A x y $.
    $( Quantifier-free definition of class intersection.  (Contributed by Scott
       Fenton, 13-Apr-2018.) $)
    dfint3 $p |- |^| A = ( _V \ ( `' ( _V \ _E ) " A ) ) $=
      ( vx vy cint wel wral cab cvv cep cdif ccnv cima dfint2 cv wbr wn mpbiran
      wcel vex bitr2i wrex ralnex brcnv brdif con1bii epel ralbii eldif xchbinx
      brv elima 3bitr4ri abbi2i eqtr4i ) ADBCEZCAFZBGHHIJZKZALZJZBCAMUPBUTCNZBN
      ZUROZPZCAFVCCAUAZPUPVBUTRZVCCAUBUOVDCAVDVBVAIOZUOVGVCVCVBVAUQOZVGPZVAVBUQ
      CSBSZUCVHVBVAHOVIVBVAUJVBVAHIUDQTUEBCUFTUGVFVBUSRZVEVFVBHRVKPVJVBHUSUHQCV
      BURAVJUKUIULUMUN $.
  $}

  ${
    $d x y z $.
    $( The Image functor applied to the converse of the subset relationship
       yields a subset of the subset relationship.  (Contributed by Scott
       Fenton, 14-Apr-2018.) $)
    imagesset $p |- Image `' SSet C_ SSet $=
      ( vx vy vz csset ccnv cimage wss cv cop wcel wi wal wrex sseq2 wbr brsset
      vex bitri df-br bitr3i cima wceq wel ssid rspcev mpan2 elima brcnv rexbii
      sylibr ssriv mpbiri brimage 3imtr3i gen2 wfun wrel wb funimage ssrel mp2b
      funrel mpbir ) DEZFZDGZAHZBHZIZVEJZVIDJZKZBLALZVLABVHVDVGUAZUBZVGVHGZVJVK
      VOVPVGVNGBVGVNBAUCZVHCHZGZCVGMZVHVNJZVQVHVHGZVTVHUDVSWBCVHVGVRVHVHNUEUFWA
      VRVHVDOZCVGMVTCVHVDVGBQZUGWCVSCVGWCVHVRDOVSVRVHDCQZWDUHVHVRWEPRUIRUJUKVHV
      NVGNULVOVGVHVEOVJVGVHVDAQWDUMVGVHVESTVPVGVHDOVKVGVHWDPVGVHDSTUNUOVEUPVEUQ
      VFVMURVDUSVEVBABVEDUTVAVC $.
  $}

  ${
    $d A x $.  $d R x $.  $d S x $.
    brub.1 $e |- S e. _V $.
    brub.2 $e |- A e. _V $.
    $( Binary relationship form of the upper bound functor.  (Contributed by
       Scott Fenton, 3-May-2018.) $)
    brub $p |- ( S UB R A <-> A. x e. S x R A ) $=
      ( cvv cxp cdif cep ccnv ccom wbr cv wrex wn cub wcel brdif mpbiran rexbii
      wral brxp mpbir2an coepr xchbinx df-ub breqi rexnal bitri con2bii 3bitr4i
      brv ) DBGGHZGCIZJKLZIZMZANZBUOMZADOZPDBCQZMUSBCMZADUBZURDBUPMZVAURDBUNMZV
      EPVFDGRBGREFDBGGUCUDDBUNUPSTADBUOEFUEUFDBVBUQCUGUHVAVDVAVCPZADOVDPUTVGADU
      TUSBGMVGUSBUMUSBGCSTUAVCADUIUJUKUL $.


    $( Binary relationship form of the lower bound functor.  (Contributed by
       Scott Fenton, 3-May-2018.) $)
    brlb $p |- ( S LB R A <-> A. x e. S A R x ) $=
      ( clb wbr ccnv cub cv wral df-lb breqi brub vex brcnv ralbii 3bitri ) DBC
      GZHDBCIZJZHAKZBUAHZADLBUCCHZADLDBTUBCMNABUADEFOUDUEADUCBCAPFQRS $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Alternate ordered pairs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c << >> XX. $.
  $( Declare the syntax for an alternate ordered pair. $)
  caltop $a class << A , B >> $.
  $( Declare the syntax for an alternate cross product. $)
  caltxp $a class ( A XX. B ) $.

  $( An alternative definition of ordered pairs.  This definition removes a
     hypothesis from its defining theorem (see ~ altopth ), making it more
     convenient in some circumstances.  (Contributed by Scott Fenton,
     22-Mar-2012.) $)
  df-altop $a |- << A , B >> = { { A } , { A , { B } } } $.

  ${
    $d A x y z $.  $d B x y z $.
    $( Define cross products of alternative ordered pairs.  (Contributed by
       Scott Fenton, 23-Mar-2012.) $)
    df-altxp $a |- ( A XX. B ) = { z | E. x e. A E. y e. B z = << x , y >> } $.
  $}

  $( Alternative ordered pairs always exist.  (Contributed by Scott Fenton,
     22-Mar-2012.) $)
  altopex $p |- << A , B >> e. _V $=
    ( caltop csn cpr cvv df-altop prex eqeltri ) ABCADZABDEZEFABGJKHI $.

  $( Two alternate ordered pairs are equal iff the singletons of their
     respective elements are equal.  Note that this holds regardless of sethood
     of any of the elements.  (Contributed by Scott Fenton, 16-Apr-2012.) $)
  altopthsn $p |- ( << A , B >> = << C , D >> <->
                    ( { A } = { C } /\ { B } = { D } ) ) $=
    ( caltop wceq csn cpr wa df-altop eqeq12i snex prex wss snsspr1 sseq2 df-pr
    cun preq2d preqr2 preq12b simpl mpbii adantl mpbiri adantr eqssd jaoi sylbi
    wo uneq1 3eqtr4g preq1 eqtrd eqeq1d biimpd syl syl6com jcai sylan9eq impbii
    preq2 bitri ) ABEZCDEZFAGZABGZHZHZCGZCDGZHZHZFZVFVJFZVGVKFZIZVDVIVEVMABJCDJ
    KVNVQVNVOVPVNVOVHVLFZIZVFVLFZVHVJFZIZUJVOVFVHVJVLALAVGMCLCVKMZUAVSVOWBVOVRU
    BWBVFVJWAVFVJNZVTWAVFVHNWDAVGOVHVJVFPUCUDVTVJVFNZWAVTWEVJVLNCVKOVFVLVJPUEUF
    UGUHUIVOVNVJCVGHZHZVMFZVPVOVNWHVOVIWGVMVOVIVFWFHWGVOVHWFVFVOVFVGGZRVJWIRVHW
    FVFVJWIUKAVGQCVGQULSVFVJWFUMUNZUOUPWHWFVLFVPWFVLVJCVGMWCTVGVKCBLDLTUQURUSVO
    VPVIWGVMWJVPWFVLVJVGVKCVBSUTVAVC $.

  $( Equality for alternate ordered pairs.  (Contributed by Scott Fenton,
     22-Mar-2012.) $)
  altopeq12 $p |- ( ( A = B /\ C = D ) -> << A , C >> = << B , D >> ) $=
    ( wceq wa csn caltop sneq anim12i altopthsn sylibr ) ABEZCDEZFAGBGEZCGDGEZF
    ACHBDHEMONPABICDIJACBDKL $.

  $( Equality for alternate ordered pairs.  (Contributed by Scott Fenton,
     22-Mar-2012.) $)
  altopeq1 $p |- ( A = B -> << A , C >> = << B , C >> ) $=
    ( wceq caltop eqid altopeq12 mpan2 ) ABDCCDACEBCEDCFABCCGH $.

  $( Equality for alternate ordered pairs.  (Contributed by Scott Fenton,
     22-Mar-2012.) $)
  altopeq2 $p |- ( A = B -> << C , A >> = << C , B >> ) $=
    ( wceq caltop eqid altopeq12 mpan ) CCDABDCAECBEDCFCCABGH $.

  $( Equality of the first members of equal alternate ordered pairs, which
     holds regardless of the second members' sethood.  (Contributed by Scott
     Fenton, 22-Mar-2012.) $)
  altopth1 $p |- ( A e. V -> ( << A , B >> = << C , D >> -> A = C ) ) $=
    ( caltop wceq csn wa wcel altopthsn sneqrg adantrd syl5bi ) ABFCDFGAHCHGZBH
    DHGZIAEJZACGZABCDKQORPACELMN $.

  $( Equality of the second members of equal alternate ordered pairs, which
     holds regardless of the first members' sethood.  (Contributed by Scott
     Fenton, 22-Mar-2012.) $)
  altopth2 $p |- ( B e. V -> ( << A , B >> = << C , D >> -> B = D ) ) $=
    ( caltop wceq csn wa wcel altopthsn sneqrg adantld syl5bi ) ABFCDFGAHCHGZBH
    DHGZIBEJZBDGZABCDKQPROBDELMN $.

  $( Alternate ordered pair theorem.  (Contributed by Scott Fenton,
     22-Mar-2012.) $)
  altopthg $p |- ( ( A e. V /\ B e. W ) ->
                   ( << A , B >> = << C , D >> <-> ( A = C /\ B = D ) ) ) $=
    ( caltop wceq csn wa wcel altopthsn sneqbg bi2anan9 syl5bb ) ABGCDGHAICIHZB
    IDIHZJAEKZBFKZJACHZBDHZJABCDLRPTSQUAACEMBDFMNO $.

  $( Alternate ordered pair theorem.  (Contributed by Scott Fenton,
     14-Apr-2012.) $)
  altopthbg $p |- ( ( A e. V /\ D e. W ) ->
                   ( << A , B >> = << C , D >> <-> ( A = C /\ B = D ) ) ) $=
    ( caltop wceq csn wa wcel altopthsn sneqbg eqcom 3bitr4g bi2anan9 syl5bb )
    ABGCDGHAICIHZBIZDIZHZJAEKZDFKZJACHZBDHZJABCDLUBRUDUCUAUEACEMUCTSHDBHUAUEDBF
    MSTNBDNOPQ $.

  ${
    altopth.1 $e |- A e. _V $.
    altopth.2 $e |- B e. _V $.
    $( The alternate ordered pair theorem.  If two alternate ordered pairs are
       equal, their first elements are equal and their second elements are
       equal.  Note that ` C ` and ` D ` are not required to be a set due to a
       peculiarity of our specific ordered pair definition, as opposed to the
       regular ordered pairs used here, which (as in ~ opth ), requires ` D `
       to be a set.  (Contributed by Scott Fenton, 23-Mar-2012.) $)
    altopth $p |- ( << A , B >> = << C , D >> <-> ( A = C /\ B = D ) ) $=
      ( cvv wcel caltop wceq wa wb altopthg mp2an ) AGHBGHABICDIJACJBDJKLEFABCD
      GGMN $.
  $}

  ${
    altopthb.1 $e |- A e. _V $.
    altopthb.2 $e |- D e. _V $.
    $( Alternate ordered pair theorem with different sethood requirements.  See
       ~ altopth for more comments.  (Contributed by Scott Fenton,
       14-Apr-2012.) $)
    altopthb $p |- ( << A , B >> = << C , D >> <-> ( A = C /\ B = D ) ) $=
      ( cvv wcel caltop wceq wa wb altopthbg mp2an ) AGHDGHABICDIJACJBDJKLEFABC
      DGGMN $.
  $}

  ${
    altopthc.1 $e |- B e. _V $.
    altopthc.2 $e |- C e. _V $.
    $( Alternate ordered pair theorem with different sethood requirements.  See
       ~ altopth for more comments.  (Contributed by Scott Fenton,
       14-Apr-2012.) $)
    altopthc $p |- ( << A , B >> = << C , D >> <-> ( A = C /\ B = D ) ) $=
      ( caltop wceq wa eqcom altopthb anbi12i 3bitri ) ABGZCDGZHONHCAHZDBHZIACH
      ZBDHZINOJCDABFEKPRQSCAJDBJLM $.
  $}

  ${
    altopthd.1 $e |- C e. _V $.
    altopthd.2 $e |- D e. _V $.
    $( Alternate ordered pair theorem with different sethood requirements.  See
       ~ altopth for more comments.  (Contributed by Scott Fenton,
       14-Apr-2012.) $)
    altopthd $p |- ( << A , B >> = << C , D >> <-> ( A = C /\ B = D ) ) $=
      ( caltop wceq wa eqcom altopth anbi12i 3bitri ) ABGZCDGZHONHCAHZDBHZIACHZ
      BDHZINOJCDABEFKPRQSCAJDBJLM $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.
    $( Equality for alternate cross products.  (Contributed by Scott Fenton,
       24-Mar-2012.) $)
    altxpeq1 $p |- ( A = B -> ( A XX. C ) = ( B XX. C ) ) $=
      ( vz vx vy wceq cv caltop wrex cab caltxp rexeq abbidv df-altxp 3eqtr4g )
      ABGZDHEHFHIGFCJZEAJZDKREBJZDKACLBCLQSTDREABMNEFDACOEFDBCOP $.

    $( Equality for alternate cross products.  (Contributed by Scott Fenton,
       24-Mar-2012.) $)
    altxpeq2 $p |- ( A = B -> ( C XX. A ) = ( C XX. B ) ) $=
      ( vz vx vy wceq cv caltop wrex cab caltxp rexbidv abbidv df-altxp 3eqtr4g
      rexeq ) ABGZDHEHFHIGZFAJZECJZDKSFBJZECJZDKCALCBLRUAUCDRTUBECSFABQMNEFDCAO
      EFDCBOP $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d X x y z $.
    $( Membership in alternate cross products.  (Contributed by Scott Fenton,
       23-Mar-2012.) $)
    elaltxp $p |- ( X e. ( A XX. B ) <->
                     E. x e. A E. y e. B X = << x , y >> ) $=
      ( vz caltxp wcel cvv cv caltop wceq wrex elex wi altopex eleq1 mpbiri a1i
      wa rexlimivv eqeq1 2rexbidv df-altxp elab2g pm5.21nii ) ECDGZHEIHZEAJZBJZ
      KZLZBDMACMZEUGNULUHABCDULUHOUICHUJDHTULUHUKIHUIUJPEUKIQRSUAFJZUKLZBDMACMU
      MFEUGIUNELUOULABCDUNEUKUBUCABFCDUDUEUF $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d X x y $.  $d Y x y $.
    $( Alternate ordered pair membership in a cross product.  Note that, unlike
       ~ opelxp , there is no sethood requirement here.  (Contributed by Scott
       Fenton, 22-Mar-2012.) $)
    altopelaltxp $p |- ( << X , Y >> e. ( A XX. B ) <->
                          ( X e. A /\ Y e. B ) ) $=
      ( vx vy caltop caltxp wcel cv wceq wrex wa elaltxp reeanv eqcom vex bitri
      altopth risset 2rexbii anbi12i 3bitr4i ) CDGZABHIUDEJZFJZGZKZFBLEALZCAIZD
      BIZMZEFABUDNUECKZUFDKZMZFBLEALUMEALZUNFBLZMUIULUMUNEFABOUHUOEFABUHUGUDKUO
      UDUGPUEUFCDEQFQSRUAUJUPUKUQECATFDBTUBUCR $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( An inclusion rule for alternate cross products.  (Contributed by Scott
       Fenton, 24-Mar-2012.) $)
    altxpsspw $p |- ( A XX. B ) C_ ~P ~P ( A u. ~P B ) $=
      ( vz vx vy caltxp cpw cun cv wcel wrex wa csn cpr wss snssi syl snex elpw
      prex caltop wceq elaltxp df-altop ssun3 adantr elun1 elun2 sylbir anim12i
      wi prss sylib prsspw bitri sylanbrc syl5eqel eleq1a rexlimivv sylbi ssriv
      vex ) CABFZABGZHZGZGZCIZVCJVHDIZEIZUAZUBZEBKDAKVHVGJZDEABVHUCVLVMDEABVIAJ
      ZVJBJZLZVKVGJVLVMUKVPVKVIMZVIVJMZNZNZVGVIVJUDVPVQVEOZVSVEOZVTVGJZVNWAVOVN
      VQAOWAVIAPVQAVDUEQUFVPVIVEJZVRVEJZLWBVNWDVOWEVIAVDUGVOVRBOZWEVJBPWFVRVDJW
      EVRBVJRZSVRVDAUHUIQUJVIVRVEDVBWGULUMWCVTVFOWAWBLVTVFVQVSTSVQVSVEVIRVIVRTU
      NUOUPUQVKVGVHURQUSUTVA $.
  $}

  $( The alternate cross product of two sets is a set.  (Contributed by Scott
     Fenton, 24-Mar-2012.) $)
  altxpexg $p |- ( ( A e. V /\ B e. W ) -> ( A XX. B ) e. _V ) $=
    ( wcel wa caltxp cpw cun wss cvv altxpsspw pwexg unexg sylan2 ssexg sylancr
    3syl ) ACEZBDEZFZABGZABHZIZHZHZJUFKEZUBKEABLUAUDKEZUEKEUGTSUCKEUHBDMAUCCKNO
    UDKMUEKMRUBUFKPQ $.

  $( Compute the rank of an alternate ordered pair.  (Contributed by Scott
     Fenton, 18-Dec-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  rankaltopb $p |- ( ( A e. U. ( R1 " On ) /\ B e. U. ( R1 " On ) ) -> ( rank
    ` << A , B >> ) = suc suc ( ( rank ` A ) u. suc ( rank ` B ) ) ) $=
    ( cr1 con0 cima wcel wa crnk cfv csn cun csuc wceq snwf cpr rankprb syl2anc
    fveq2i suceq eqtrd cuni caltop df-altop adantr prwf syl5eq wss snsspr1 mpbi
    ssequn1 rankunb 3eqtr3a syl sylan2 ranksnb uneq2d 3syl adantl ) ACDEUAZFZBU
    SFZGABUBZHIZAHIZBJZHIZKZLZLZVDBHILZKZLZLZVAUTVEUSFZVCVIMBNUTVNGZVCAJZHIAVEO
    ZHIZKZLZVIVOVCVPVQOZHIZVTVBWAHABUCRVOVPUSFZVQUSFZWBVTMUTWCVNANUDZAVEUEZVPVQ
    PQUFVOVSVHMVTVIMVOVPVQKZHIZVRVSVHWGVQHVPVQUGWGVQMAVEUHVPVQUJUIRVOWCWDWHVSMW
    EWFVPVQUKQAVEPULVSVHSUMTUNVAVIVMMZUTVAVGVKMVHVLMWIVAVFVJVDBUOUPVGVKSVHVLSUQ
    URT $.

  ${
    nfaltop.1 $e |- F/_ x A $.
    nfaltop.2 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for alternate ordered pairs.
       (Contributed by Scott Fenton, 25-Sep-2015.) $)
    nfaltop $p |- F/_ x << A , B >> $=
      ( caltop csn cpr df-altop nfsn nfpr nfcxfr ) ABCFBGZBCGZHZHBCIAMOABDJABND
      ACEJKKL $.
  $}

  ${
    $d x y A $.  $d y C $.  $d y D $.
    $( Distribution of class substitution over alternate ordered pairs.
       (Contributed by Scott Fenton, 25-Sep-2015.) $)
    sbcaltop $p |- ( A e. _V -> [_ A / x ]_ << C , D >> =
                                << [_ A / x ]_ C , [_ A / x ]_ D >> ) $=
      ( caltop csb cvv wnfc wcel nfcsb1v nfaltop wceq csbeq1a altopeq1 altopeq2
      a1i cv syl eqtrd csbiegf ) ABCDEZABCFZABDFZEZGAUDHBGIAUBUCABCJABDJKPAQBLZ
      UAUBDEZUDUECUBLUAUFLABCMCUBDNRUEDUCLUFUDLABDMDUCUBORST $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Tarskian geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c EE Btwn Cgr $.

  $( Declare the syntax for the Euclidean space generator. $)
  cee $a class EE $.

  $( Declare the syntax for the Euclidean betweenness predicate. $)
  cbtwn $a class Btwn $.

  $( Declare the syntax for the Euclidean congruence predicate. $)
  ccgr $a class Cgr $.

  $( Define the Euclidean space generator.  For details, see ~ elee .
     (Contributed by Scott Fenton, 3-Jun-2013.) $)
  df-ee $a |- EE = ( n e. NN |-> ( RR ^m ( 1 ... n ) ) ) $.

  ${
    $d n x y z t i $.
    $( Define the Euclidean betweenness predicate.  For details, see
       ~ brbtwn .  (Contributed by Scott Fenton, 3-Jun-2013.) $)
    df-btwn $a |- Btwn =
      `' { <. <. x , z >. , y >. |
         E. n e. NN (
           ( x e. ( EE ` n ) /\ z e. ( EE ` n ) /\ y e. ( EE ` n ) ) /\
           E. t e. ( 0 [,] 1 ) A. i e. ( 1 ... n )
             ( y ` i ) = ( ( ( 1 - t ) x. ( x ` i ) ) + ( t x. ( z ` i ) ) ) )
         } $.
  $}

  ${
    $d n x y i $.
    $( Define the Euclidean congruence predicate.  For details, see ~ brcgr .
       (Contributed by Scott Fenton, 3-Jun-2013.) $)
    df-cgr $a |- Cgr =
       { <. x , y >. |
         E. n e. NN
           ( ( x e. ( ( EE ` n ) X. ( EE ` n ) ) /\
             y e. ( ( EE ` n ) X. ( EE ` n ) ) ) /\
           sum_ i e. ( 1 ... n )
             ( ( ( ( 1st ` x ) ` i ) - ( ( 2nd ` x ) ` i ) ) ^ 2 ) =
           sum_ i e. ( 1 ... n )
             ( ( ( ( 1st ` y ) ` i ) - ( ( 2nd ` y ) ` i ) ) ^ 2 ) ) } $.
  $}

  ${
    $d N n $.
    $( Membership in a Euclidean space.  We define Euclidean space here using
       Cartesian coordinates over ` N ` space.  We later abstract away from
       this using Tarski's geometry axioms, so this exact definition is
       unimportant.  (Contributed by Scott Fenton, 3-Jun-2013.) $)
    elee $p |- ( N e. NN -> ( A e. ( EE ` N ) <-> A : ( 1 ... N ) --> RR ) ) $=
      ( vn cn wcel cee cfv cr c1 cfz co cmap wf cv wceq oveq2 oveq2d df-ee ovex
      fvmpt eleq2d reex elmap syl6bb ) BDEZABFGZEAHIBJKZLKZEUGHAMUEUFUHACBHICNZ
      JKZLKUHDFUIBOUJUGHLUIBIJPQCRHUGLSTUAHUGAUBIBJSUCUD $.
  $}

  ${
    $d N a k $.  $d A a $.  $d B a $.  $d F a $.
    $( A condition for a mapping to be an element of a Euclidean space.
       (Contributed by Scott Fenton, 7-Jun-2013.) $)
    mptelee $p |- ( N e. NN ->
      ( ( k e. ( 1 ... N ) |-> ( A F B ) ) e. ( EE ` N ) <->
        A. k e. ( 1 ... N ) ( A F B ) e. RR ) ) $=
      ( va cn wcel c1 cfz co cr wral wss cv wi wal rsp sylbir bitri cmpt cee wf
      cfv elee crn wfn ovex eqid fnmpti df-f mpbiran wceq wrex cab rnmpt sseq1i
      abss nfre1 nfv nfim nfal r19.23v albii ralcom4 clel2 syl6ibr nfra1 eleq1a
      ralrimi syl6 rexlimd alrimiv impbii syl6bb ) EGHCIEJKZABDKZUAZEUBUDHVPLVR
      UCZVQLHZCVPMZVREUEVSVRUFZLNZWAVSVRVPUGWCCVPVQVRABDUHZVRUIZUJVPLVRUKULWCFO
      ZVQUMZCVPUNZFUOZLNZWAWBWILCFVPVQVRWEUPUQWJWHWFLHZPZFQZWAWHFLURWMWAWMVTCVP
      WLCFWHWKCWGCVPUSWKCUTZVAVBWMWGWKPZCVPMZFQZCOVPHZVTPZWPWLFWGWKCVPVCVDWQWOF
      QZCVPMZWSWOCFVPVEXAWRWTVTWTCVPRFVQLWDVFVGSSVJWAWLFWAWGWKCVPVTCVPVHWNWAWRV
      TWOVTCVPRVQLWFVIVKVLVMVNTTTVO $.
  $}

  ${
    $( If ` A ` is in ` ( EE `` N ) ` , then ` N ` is a natural.  (Contributed
       by Scott Fenton, 1-Jul-2013.) $)
    eleenn $p |- ( A e. ( EE ` N ) -> N e. NN ) $=
      ( vn cee cfv wcel c0 wceq cn n0i cdm cr c1 cv cfz cmap ovex df-ee dmmpti
      co eleq2i ndmfv sylnbir nsyl2 ) ABDEZFUEGHZBIFZUEAJUGBDKZFUFUHIBCILMCNOTZ
      PTDLUIPQCRSUABDUBUCUD $.
  $}

  $( The forward direction of ~ elee .  (Contributed by Scott Fenton,
     1-Jul-2013.) $)
  eleei $p |- ( A e. ( EE ` N ) -> A : ( 1 ... N ) --> RR ) $=
    ( cee cfv wcel c1 cfz co cr wf cn wb eleenn elee syl ibi ) ABCDEZFBGHIAJZQB
    KEQRLABMABNOP $.

  $( A point belongs to at most one Euclidean space.  (Contributed by Scott
     Fenton, 1-Jul-2013.) $)
  eedimeq $p |- ( ( A e. ( EE ` N ) /\ A e. ( EE ` M ) ) -> N = M ) $=
    ( cee cfv wcel wa c1 wceq cfz co cr wf eleei cdm fdm sylan9req syl2an cuz
    wb cn eleenn nnuz syl6eleq adantr fzopth syl mpbid simprd ) ACDEFZABDEFZGZH
    HIZCBIZULHCJKZHBJKZIZUMUNGZUJUOLAMZUPLAMZUQUKACNABNUSUTUOAOUPUOLAPUPLAPQRUL
    CHSEZFZUQURTUJVBUKUJCUAVAACUBUCUDUEHBHCUFUGUHUI $.

  ${
    $d N a n x y z i t $.  $d A x y z i t n $.  $d B x y z i t n $.
    $d C x y z i t n $.
    $( The binary relationship form of the betweenness predicate.  The
       statement ` A Btwn <. B , C >. ` should be informally read as " ` A `
       lies on a line segment between ` B ` and ` C ` .  This exact definition
       is abstracted away by Tarski's geometry axioms later on.  (Contributed
       by Scott Fenton, 3-Jun-2013.) $)
    brbtwn $p |- (
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ->
      ( A Btwn <. B , C >. <->
        E. t e. ( 0 [,] 1 ) A. i e. ( 1 ... N )
           ( A ` i ) =
           ( ( ( 1 - t ) x. ( B ` i ) ) + ( t x. ( C ` i ) ) ) ) ) $=
      ( vn cv cfv wcel w3a c1 co cmul caddc wceq wral wrex wa cn vy vz vx cbtwn
      cop wbr cee cmin cfz cc0 cicc coprab ccnv df-btwn breqi wb cvv opex mpan2
      brcnvg 3ad2ant1 df-br eleq1 3anbi1d fveq1 oveq2d oveq1d eqeq2d rexralbidv
      anbi12d rexbidv 3anbi2d 3anbi3d eqeq1d eloprabg simp1 eedimeq syl2anr syl
      oveq2 raleqdv biimpd rexlimdvw eleenn fveq2 eleq2d 3anbi123d rspcev exp32
      expimpd wi mpcom impbid bitrd 3comr syl5bb ) BCDUEZUDUFBWQUAHZGHZUGIZJZUB
      HZWTJZUCHZWTJZKZEHZXDIZLAHZUHMZXGWRIZNMZXIXGXBIZNMZOMZPZELWSUIMZQAUJLUKMZ
      RZSZGTRZUAUBUCULZUMZUFZBFUGIZJZCYEJZDYEJZKZXGBIZXJXGCIZNMZXIXGDIZNMZOMZPZ
      ELFUIMZQZAXRRZBWQUDYCUAUCUBAEGUNUOYIYDWQBYBUFZYSYFYGYDYTUPZYHYFWQUQJUUACD
      URBWQYEUQYBUTUSVAYTWQBUEYBJZYIYSWQBYBVBYGYHYFUUBYSUPYGYHYFKZUUBCWTJZDWTJZ
      BWTJZKZYPEXQQZAXRRZSZGTRZYSYAUUDXCXEKZXHYLXNOMZPZEXQQAXRRZSZGTRUUDUUEXEKZ
      XHYOPZEXQQAXRRZSZGTRUUKUAUBUCCDBYEYEYEWRCPZXTUUPGTUVAXFUULXSUUOUVAXAUUDXC
      XEWRCWTVCVDUVAXPUUNAEXRXQUVAXOUUMXHUVAXLYLXNOUVAXKYKXJNXGWRCVEVFVGVHVIVJV
      KXBDPZUUPUUTGTUVBUULUUQUUOUUSUVBXCUUEUUDXEXBDWTVCVLUVBUUNUURAEXRXQUVBUUMY
      OXHUVBXNYNYLOUVBXMYMXINXGXBDVEVFVFVHVIVJVKXDBPZUUTUUJGTUVCUUQUUGUUSUUIUVC
      XEUUFUUDUUEXDBWTVCVMUVCUURYPAEXRXQUVCXHYJYOXGXDBVEVNVIVJVKVOUUCUUKYSUUCUU
      JYSGTUUCUUGUUIYSUUCUUGSZUUIYSUVDWSFPZUUIYSUPUUGUUDYGUVEUUCUUDUUEUUFVPYGYH
      YFVPCFWSVQVRUVEUUHYRAXRUVEYPEXQYQWSFLUIVTWAVKZVSWBWJWCFTJZUUCYSUUKWKYGYHU
      VGYFCFWDVAUVGUUCYSUUKUUJUUCYSSGFTUVEUUGUUCUUIYSUVEUUDYGUUEYHUUFYFUVEWTYEC
      WSFUGWEZWFUVEWTYEDUVHWFUVEWTYEBUVHWFWGUVFVJWHWIWLWMWNWOWPWNWP $.
  $}

  ${
    $d N n i x y $.  $d A n i x y $.  $d B n i x y $.  $d C n i x y $.
    $d D n i x y $.
    $( The binary relationship form of the congruence predicate.  The statement
       ` <. A , B >. Cgr <. C , D >. ` should be read informally as "the ` N `
       dimensional point ` A ` is as far from ` B ` as ` C ` is from ` D ` , or
       "the line segment ` A B ` is congruent to the line segment ` C D ` .
       This particular definition is encapsulated by Tarski's axioms later on.
       (Contributed by Scott Fenton, 3-Jun-2013.) $)
    brcgr $p |- ( ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
                    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
      ( <. A , B >. Cgr <. C , D >. <->
        sum_ i e. ( 1 ... N ) ( ( ( A ` i ) - ( B ` i ) ) ^ 2 ) =
        sum_ i e. ( 1 ... N ) ( ( ( C ` i ) - ( D ` i ) ) ^ 2 ) ) ) $=
      ( vn cfv wcel wa co c1st c2nd cmin c2 cexp csu wceq cn fveq1d vx cop ccgr
      vy wbr cv cee cxp c1 cfz wrex eleq1 anbi1d fveq2 oveq12d oveq1d sumeq2sdv
      opex eqeq1d anbi12d rexbidv anbi2d eqeq2d df-cgr brab wb opelxp2 ad2antll
      simplrr eedimeq syl2anc adantlr oveq2 sumeq1d syl op1stg op2ndg eqeqan12d
      eqeq12d ad2antrr bitrd biimpd expimpd rexlimdva wi eleenn opelxpi anim12i
      adantr biimpar jca xpeq12d eleq2d rspcev sylan2 exp32 mpcom impbid syl5bb
      ) ABUBZCDUBZUCUEWTGUFZUGHZXCUHZIZXAXDIZJZUIXBUJKZEUFZWTLHZHZXIWTMHZHZNKZO
      PKZEQZXHXIXALHZHZXIXAMHZHZNKZOPKZEQZRZJZGSUKZAFUGHZIBYGIJZCYGIZDYGIZJZJZU
      IFUJKZXIAHZXIBHZNKZOPKZEQZYMXICHZXIDHZNKZOPKZEQZRZUAUFZXDIZUDUFZXDIZJZXHX
      IUUELHZHZXIUUEMHZHZNKZOPKZEQZXHXIUUGLHZHZXIUUGMHZHZNKZOPKZEQZRZJZGSUKXEUU
      HJZXPUVCRZJZGSUKYFUAUDWTXAUCABURCDURUUEWTRZUVEUVHGSUVIUUIUVFUVDUVGUVIUUFX
      EUUHUUEWTXDULUMUVIUUPXPUVCUVIXHUUOXOEUVIUUNXNOPUVIUUKXKUUMXMNUVIXIUUJXJUU
      EWTLUNTUVIXIUULXLUUEWTMUNTUOUPUQUSUTVAUUGXARZUVHYEGSUVJUVFXGUVGYDUVJUUHXF
      XEUUGXAXDULVBUVJUVCYCXPUVJXHUVBYBEUVJUVAYAOPUVJUURXRUUTXTNUVJXIUUQXQUUGXA
      LUNTUVJXIUUSXSUUGXAMUNTUOUPUQVCUTVAUAUDEGVDVEYLYFUUDYLYEUUDGSYLXBSIZJZXGY
      DUUDUVLXGJZYDUUDUVMYDYMXOEQZYMYBEQZRZUUDUVMXBFRZYDUVPVFYLXGUVQUVKYLXGJDXC
      IZYJUVQXFUVRYLXECDXCXCVGVHYHYIYJXGVIDFXBVJVKVLUVQXPUVNYCUVOUVQXHYMXOEXBFU
      IUJVMZVNUVQXHYMYBEUVSVNVSZVOYLUVPUUDVFUVKXGYHYKUVNYRUVOUUCYHYMXOYQEYHXNYP
      OPYHXKYNXMYONYHXIXJAABYGYGVPTYHXIXLBABYGYGVQTUOUPUQYKYMYBUUBEYKYAUUAOPYKX
      RYSXTYTNYKXIXQCCDYGYGVPTYKXIXSDCDYGYGVQTUOUPUQVRZVTWAWBWCWDFSIZYLUUDYFWEY
      JUWBYHYIDFWFVHUWBYLUUDYFYLUUDJZUWBWTYGYGUHZIZXAUWDIZJZUVPJZYFUWCUWGUVPYLU
      WGUUDYHUWEYKUWFABYGYGWGCDYGYGWGWHWIYLUVPUUDUWAWJWKYEUWHGFSUVQXGUWGYDUVPUV
      QXEUWEXFUWFUVQXDUWDWTUVQXCYGXCYGXBFUGUNZUWIWLZWMUVQXDUWDXAUWJWMUTUVTUTWNW
      OWPWQWRWS $.
  $}

  $( The function value of a point is a real.  (Contributed by Scott Fenton,
     10-Jun-2013.) $)
  fveere $p |- ( ( A e. ( EE ` N ) /\ I e. ( 1 ... N ) ) ->
         ( A ` I ) e. RR ) $=
    ( cee cfv wcel c1 cfz co cr eleei ffvelrnda ) ACDEFGCHIJBAACKL $.

  $( The function value of a point is a complex.  (Contributed by Scott Fenton,
     10-Jun-2013.) $)
  fveecn $p |- ( ( A e. ( EE ` N ) /\ I e. ( 1 ... N ) ) ->
         ( A ` I ) e. CC ) $=
    ( cee cfv wcel c1 cfz co wa fveere recnd ) ACDEFBGCHIFJBAEABCKL $.

  ${
    $d A i $.  $d B i $.  $d N i $.
    $( Two points are equal iff they agree in all dimensions.  (Contributed by
       Scott Fenton, 10-Jun-2013.) $)
    eqeefv $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
       ( A = B <-> A. i e. ( 1 ... N ) ( A ` i ) = ( B ` i ) ) ) $=
      ( cee cfv wcel c1 cfz co wfn wceq cv wral wb cr wf eleei ffn syl eqfnfv
      syl2an ) ADEFZGZAHDIJZKZBUEKZABLCMZAFUHBFLCUENOBUCGZUDUEPAQUFADRUEPASTUIU
      EPBQUGBDRUEPBSTCUEABUAUB $.
  $}

  ${
    $d N i $.  $d A i $.  $d B i $.
    $( Two points are equal iff the square of the distance between them is
       zero.  (Contributed by Scott Fenton, 10-Jun-2013.)  (Revised by Mario
       Carneiro, 22-May-2014.) $)
    eqeelen $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
        ( A = B <->
          sum_ i e. ( 1 ... N ) ( ( ( A ` i ) - ( B ` i ) ) ^ 2 ) = 0 ) ) $=
      ( cee cfv wcel wa cv cmin co c2 cexp cc0 wceq c1 wral cr fveere recnd cfz
      csu cc adantlr adantll resubcld sqeq0 syl subeq0ad bitrd ralbidva resqcld
      wb fzfid sqge0d fsum00 eqeefv 3bitr4rd ) ADEFZGZBUSGZHZCIZAFZVCBFZJKZLMKZ
      NOZCPDUAKZQVDVEOZCVIQVIVGCUBNOABOVBVHVJCVIVBVCVIGZHZVHVFNOZVJVLVFUCGVHVMU
      MVLVFVLVDVEUTVKVDRGVAAVCDSUDZVAVKVERGUTBVCDSUEZUFZTVFUGUHVLVDVEVLVDVNTVLV
      EVOTUIUJUKVBVIVGCVBPDUNVLVFVPULVLVFVPUOUPABCDUQUR $.
  $}

  ${
    $d N i j k p t $.  $d A i j k p t $.  $d B i j k p t $.  $d C i j k p t $.
    $( Alternate characterization of betweenness, with no existential
       quantifiers.  (Contributed by Scott Fenton, 24-Jun-2013.) $)
    brbtwn2 $p |-
        ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ->
          ( A Btwn <. B , C >. <->
            ( A. i e. ( 1 ... N )
            ( ( ( B ` i ) - ( A ` i ) ) x. ( ( C ` i ) - ( A ` i ) ) ) <_ 0 /\
              A. i e. ( 1 ... N ) A. j e. ( 1 ... N )
            ( ( ( B ` i ) - ( A ` i ) ) x. ( ( C ` j ) - ( A ` j ) ) ) =
            ( ( ( B ` j ) - ( A ` j ) ) x. ( ( C ` i ) - ( A ` i ) ) ) ) ) ) $=
      ( wcel wbr c1 cmin co cmul caddc wceq cc0 cle wa cc oveq1d wb vk vt vp cv
      cfv wral wrex wi cr fveere 3ad2antl2 3ad2antl3 cneg resubcl 3adant3 recnd
      w3a oveq2d 1re 3ad2ant3 mul4d recn 3ad2ant1 3ad2ant2 subdid ax-1cn subdir
      sylancr mp3an1 syl2anc mulid2d 3eqtr3d remulcld subsub4d mulneg1d oveq12d
      simp1 3eqtrd eqtrd mpbird mulge0d mpbid eqbrtrd 3expa sylan an32s anim12i
      ralrimiva fveecn anandirs subcl ancoms mulcomd simp2r syl22anc simp3 mpan
      simp2l mulcld sub32d 3eqtr3rd 3eqtr2d syl2an fveq2 eqeq12d rspccva breq1d
      weq ralbidva oveqan12d anbi12d wo 3ad2antl1 syl3anc anbi1d simpl2 adantlr
      oveq2 eqeefv fveq1 orbi12d bitrd adantr 3adant1 eqeq2d ralbidv rspcev wne
      ex oveq1 wn cdiv breq12d simprr simprl clt resubcld subge0d necomd subcld
      cee cop cbtwn cfz cicc brbtwn jca c2 cexp sqvald 0re elicc2i negcld nncan
      simp1bi simp2 subsub3d negeqd readdcld negsubdi2d resqcld simp2bi simp3bi
      3eqtr2rd mulneg2d subge0 sqge0d le0neg2d anim12dan 3adantl1 simp1l simp1r
      mulsub2 ralrimivva syl oveqan12rd 2ralbidva biimprcd rexlimdva mulsuble0b
      anandis simpl1 letri3d pm4.25 breq2d anbi2d ad2antlr biimprd adantrd 3jca
      syl5bb 0elunit mulid2 mul02 addid1 eqtr2d subid1i syl6eq exp32 necon3abid
      ad2antll syldd df-ne rexbii rexnal bitri syl6bbr rspcv simpl lesub1d letr
      ad2antrl imp simplrr mpbir2and posdifd divelunit div2subd lesub2d eqeltrd
      ltlend jaodan rspc2v simp11 simp12 simp13 simpl23 simpl21 simpl12 simpl22
      syld simpl13 simpl3 subne0d divdird npncan2 adddird mul02d simpl11 add32d
      addid2d addsubd nnncan2d subdird eqtr3d eqtr4d simpr adddid npcand addcld
      addsubassd 3eqtr4d divmuld div23d divsubdird dividd 3expia com23 ralrimdv
      syl331anc anim12d syl6 rexlimdvaa sylbid pm2.61dne impbid ) AFUUAUEZGZBVV
      GGZCVVGGZUQZABCUUBUUCHUAUDZAUEZIUBUDZJKZVVLBUEZLKZVVNVVLCUEZLKZMKZNZUAIFU
      UDKZUFZUBOIUUEKZUGZDUDZBUEZVWFAUEZJKZVWFCUEZVWHJKZLKZOPHZDVWBUFZVWIEUDZCU
      EZVWOAUEZJKZLKZVWOBUEZVWQJKZVWKLKZNZEVWBUFDVWBUFZQZUBABCUAFUUFVVKVWEVXEVV
      KVWCVXEUBVWDVVKVVNVWDGZQZVWGVVOVWGLKZVVNVWJLKZMKZJKZVWJVXJJKZLKZOPHZDVWBU
      FZVXKVWPVVOVWTLKZVVNVWPLKZMKZJKZLKZVWTVXRJKZVXLLKZNZEVWBUFDVWBUFZVWCVXEUH
      VXGVXNDVWBVVKVWFVWBGZVXFVXNVVKVYEQZVWGUIGZVWJUIGZQVXFVXNVYFVYGVYHVVIVVHVY
      EVYGVVJBVWFFUJUKZVVJVVHVYEVYHVVICVWFFUJULZUUGVYGVYHVXFVXNVYGVYHVXFUQZVXMV
      VNVVOUMZLKZVWGVWJJKZUUHUUIKZLKZOPVYKVYPVYMVYNVYNLKZLKVVNVYNLKZVYLVYNLKZLK
      VXMVYKVYOVYQVYMLVYKVYNVYKVYNVYGVYHVYNUIGVXFVWGVWJUNUOZUPZUUJURVYKVVNVYNVY
      LVYNVXFVYGVVNRGZVYHVXFVVNVXFVVNUIGZOVVNPHZVVNIPHZOIVVNUUKUSUULZUUOZUPZUTZ
      WUAVYKVVOVYKVVOVXFVYGVVOUIGZVYHVXFIUIGZWUCWUJUSWUGIVVNUNVHZUTZUPZUUMWUAVA
      VYKVYRVXKVYSVXLLVYKVYRVVNVWGLKZVXIJKZVWGVXHJKZVXIJKZVXKVYKVVNVWGVWJWUIVYG
      VYHVWGRGZVXFVWGVBVCZVYHVYGVWJRGZVXFVWJVBVDZVEVYKWUOWUQVXIJVYKIVVOJKZVWGLK
      ZIVWGLKZVXHJKZWUOWUQVYKVVORGZWUSWVDWVFNZWUNWUTIRGZWVGWUSWVHVFIVVOVWGVGVIZ
      VJVYKWVCVVNVWGLVYKWVIWUBWVCVVNNZVFWUIIVVNUUNZVHSVYKWVEVWGVXHJVYKVWGWUTVKS
      VLSVYKVWGVXHVXIWUTVYKVXHVYKVVOVWGWUMVYGVYHVXFVQVMZUPZVYKVXIVYKVVNVWJVXFVY
      GWUCVYHWUGUTZVYGVYHVXFUUPVMZUPZVNVRVYKVYSVVOVYNLKZUMVXJVWJJKZUMVXLVYKVVOV
      YNWUNWUAVOVYKWVRWVSVYKWVRVXHVVOVWJLKZJKVXHVWJVXIJKZJKWVSVYKVVOVWGVWJWUNWU
      TWVBVEVYKWVTWWAVXHJVYKWVTIVWJLKZVXIJKZWWAVYKWUBWVAWVTWWCNZWUIWVBWVIWUBWVA
      WWDVFIVVNVWJVGVIZVJVYKWWBVWJVXIJVYKVWJWVBVKSVSURVYKVXHVWJVXIWVNWVBWVQUUQV
      RUURVYKVXJVWJVYKVXJVYKVXHVXIWVMWVPUUSUPWVBUUTVRVPUVDVYKVYPVVNVVOLKZVYOLKZ
      UMZOPVYKVYPWWFUMZVYOLKWWHVYKVYMWWIVYOLVYKVVNVVOWUIWUNUVESVYKWWFVYOVYKWWFV
      YKVVNVVOWVOWUMVMZUPVYKVYOVYKVYNVYTUVAZUPVOVSVYKOWWGPHWWHOPHVYKWWFVYOWWJWW
      KVXFVYGOWWFPHVYHVXFVVNVVOWUGWULVXFWUCWUDWUEWUFUVBVXFOVVOPHZWUEVXFWUCWUDWU
      EWUFUVCVXFWUKWUCWWLWUETUSWUGIVVNUVFVHVTWAUTVYKVYNVYTUVGWAVYKWWGVYKWWFVYOW
      WJWWKVMUVHWBWCWCWDWEWFWHVXGVYCDEVWBVWBVVKVYEVWOVWBGZQZVXFVYCVVKWWNQWUSWVA
      QZVWTRGZVWPRGZQZQZWUBVYCVXFVVIVVJWWNWWSVVHVVIVVJQVYEWWOWWMWWRVVIVVJVYEWWO
      VVIVYEQWUSVVJVYEQWVABVWFFWICVWFFWIWGWJVVIVVJWWMWWRVVIWWMQWWPVVJWWMQWWQBVW
      OFWICVWOFWIWGWJUVIUVJWUHWWOWWRWUBVYCWWOWWRWUBUQZWWFVYNVWPVWTJKZLKZLKZWWFV
      WTVWPJKZVWJVWGJKZLKZLKZVXTVYBWWTWXBWXFWWFLWWTWXBWXAVYNLKZWXFWWTVYNWXAWWOW
      WRVYNRGWUBVWGVWJWKVCZWWRWWOWXARGZWUBWWQWWPWXJVWPVWTWKWLVDZWMWWTWWQWWPWUSW
      VAWXHWXFNWWOWWPWWQWUBWNZWWOWWPWWQWUBWRZWUSWVAWWRWUBUVKZWUSWVAWWRWUBUVLZVW
      PVWTVWGVWJUVMWOVSURWWTWXCVYRVVOWXALKZLKVXTWWTVVNVVOVYNWXAWWOWWRWUBWPZWUBW
      WOWVGWWRWVIWUBWVGVFIVVNWKWQUTZWXIWXKVAWWTVYRVXKWXPVXSLWWTVYRWUPWURVXKWWTV
      VNVWGVWJWXQWXNWXOVEWWTWUOWUQVXIJWWTWVDWVFWUOWUQWWTWVGWUSWVHWXRWXNWVJVJWWT
      WVCVVNVWGLWUBWWOWVKWWRWVIWUBWVKVFWVLWQUTZSWWTWVEVWGVXHJWWTVWGWXNVKSVLSWWT
      VWGVXHVXIWXNWWTVVOVWGWXRWXNWSZWWTVVNVWJWXQWXOWSZVNVRWWTWXPVWPVXQJKZVXPJKZ
      VWPVXPJKVXQJKVXSWWTWXPVVOVWPLKZVXPJKWYCWWTVVOVWPVWTWXRWXLWXMVEWWTWYDWYBVX
      PJWWTWYDIVWPLKZVXQJKZWYBWWTWUBWWQWYDWYFNZWXQWXLWVIWUBWWQWYGVFIVVNVWPVGVIV
      JWWTWYEVWPVXQJWWTVWPWXLVKSVSSVSWWTVWPVXQVXPWXLWWTVVNVWPWXQWXLWSZWWTVVOVWT
      WXRWXMWSZWTWWTVWPVXPVXQWXLWYIWYHVNVRVPVSWWTWXGVVNWXDLKZVVOWXELKZLKVYBWWTV
      VNVVOWXDWXEWXQWXRWWRWWOWXDRGWUBVWTVWPWKVDWWOWWRWXERGZWUBWVAWUSWYLVWJVWGWK
      WLVCVAWWTWYJVYAWYKVXLLWWTWYJVVNVWTLKZVXQJKVWTVXPJKZVXQJKVYAWWTVVNVWTVWPWX
      QWXMWXLVEWWTWYNWYMVXQJWWTWVCVWTLKZIVWTLKZVXPJKZWYMWYNWWTWVGWWPWYOWYQNZWXR
      WXMWVIWVGWWPWYRVFIVVOVWTVGVIVJWWTWVCVVNVWTLWXSSWWTWYPVWTVXPJWWTVWTWXMVKSX
      ASWWTVWTVXPVXQWXMWYIWYHVNXBWWTWYKWVTVXHJKWWAVXHJKZVXLWWTVVOVWJVWGWXRWXOWX
      NVEWWTWVTWWAVXHJWWTWVTWWCWWAWWTWUBWVAWWDWXQWXOWWEVJWWTWWBVWJVXIJWWTVWJWXO
      VKSVSSWWTWYSVWJVXHJKVXIJKVXLWWTVWJVXIVXHWXOWYAWXTWTWWTVWJVXHVXIWXOWXTWYAV
      NVSVRVPVSVLWDXCWFUVNVWCVXEVXOVYDQVWCVWNVXOVXDVYDVWCVWMVXNDVWBVWCVYEQZVWHV
      XJNZVWMVXNTVWAXUAUAVWFVWBUADXHZVVMVWHVVTVXJVVLVWFAXDXUBVVQVXHVVSVXIMXUBVV
      PVWGVVOLVVLVWFBXDURXUBVVRVWJVVNLVVLVWFCXDURVPXEXFZXUAVWLVXMOPXUAVWIVXKVWK
      VXLLVWHVXJVWGJXRZVWHVXJVWJJXRZVPXGUVOXIVWCVXCVYCDEVWBVWBVWCVYEWWMVXCVYCTZ
      WYTXUAVWQVXRNZXUFVWCWWMQXUCVWAXUGUAVWOVWBUAEXHZVVMVWQVVTVXRVVLVWOAXDXUHVV
      QVXPVVSVXQMXUHVVPVWTVVOLVVLVWOBXDURXUHVVRVWPVVNLVVLVWOCXDURVPXEXFXUAXUGQV
      WSVXTVXBVYBXUAXUGVWIVXKVWRVXSLXUDVWQVXRVWPJXRXJXUGXUAVXAVYAVWKVXLLVWQVXRV
      WTJXRXUEUVPXEXCUWAUVQXKUVRVJUVSVVKVXEVWGVWHPHZVWHVWJPHZQZVWJVWHPHZVWHVWGP
      HZQZXLZDVWBUFZVXDQZVWEVVKVWNXUPVXDVVKVWMXUODVWBVYFVYGVWHUIGZVYHVWMXUOTVYI
      VVHVVIVYEXURVVJAVWFFUJXMZVYJVWGVWHVWJUVTXNXIXOVVKXUQVWEUHZBCVVKBCNZXUQBAN
      ZVWEVVKXVAXUQXVBUHVVKXVAQZXUPXVBVXDXVCXVBXUPXVCXVBVWGVWHNZDVWBUFZXUPXVCVV
      IVVHXVBXVETVVHVVIVVJXVAXPVVHVVIVVJXVAUWBBADFXSVJXVCXVDXUODVWBXVCVYEQZXVDX
      UIXUMQZXUOXVFVWGVWHVVKVYEVYGXVAVYIXQVVKVYEXURXVAXUSXQUWCXVGXVGXVGXLZXVFXU
      OXVGUWDXVAXVHXUOTVVKVYEXVAXVGXUKXVGXUNXVAXUMXUJXUIXVAVWGVWJVWHPVWFBCXTZUW
      EUWFXVAXUIXULXUMXVAVWGVWJVWHPXVIXGXOYAUWGUWKYBXIYBUWHUWIYIVVKXVAXVBVWEVVK
      XVAXVBQZQZOVWDGVVMIVVPLKZOVVRLKZMKZNZUAVWBUFZVWEUWLXVKXVOUAVWBVVKVVLVWBGZ
      XVJXVOVVKXVQQZVVMRGZVVPRGZVVRRGZUQZXVJXVOXVRXVSXVTXWAVVHVVIXVQXVSVVJAVVLF
      WIZXMVVIVVHXVQXVTVVJBVVLFWIZUKVVJVVHXVQXWAVVICVVLFWIZULUWJXWBXVJQXVNVVPVV
      MXWBXVNVVPNZXVJXVTXWAXWFXVSXVTXWAQXVNVVPOMKZVVPXVTXWAXVLVVPXVMOMVVPUWMVVR
      UWNXJXVTXWGVVPNXWAVVPUWOYCVSYDYCXVBVVPVVMNXWBXVAVVLBAXTUXAUWPWEWFWHVWCXVP
      UBOVWDVVNONZVWAXVOUAVWBXWHVVTXVNVVMXWHVVQXVLVVSXVMMXWHVVOIVVPLXWHVVOIOJKI
      VVNOIJXRIVFUWQUWRSVVNOVVRLYJVPYEYFYGVHUWSUXBVVKBCYHZUCUDZBUEZXWJCUEZYHZUC
      VWBUGZXUTVVKXWIXWKXWLNZUCVWBUFZYKZXWNVVKXWPBCVVIVVJXVAXWPTVVHBCUCFXSYDUWT
      XWNXWOYKZUCVWBUGXWQXWMXWRUCVWBXWKXWLUXCUXDXWOUCVWBUXEUXFUXGVVKXWMXUTUCVWB
      VVKXWJVWBGZXWMQZQZXUQXWJAUEZXWKJKZXWLXWKJKZYLKZVWDGZVVMIXXEJKZVVPLKZXXEVV
      RLKZMKZNZUAVWBUFZQVWEXXAXUPXXFVXDXXLXXAXUPXWKXXBPHZXXBXWLPHZQZXWLXXBPHZXX
      BXWKPHZQZXLZXXFXWSXUPXXSUHVVKXWMXUOXXSDXWJVWBDUCXHZXUKXXOXUNXXRXXTXUIXXMX
      UJXXNXXTVWGXWKVWHXXBPVWFXWJBXDZVWFXWJAXDZYMXXTVWHXXBVWJXWLPXYBVWFXWJCXDZY
      MXKXXTXULXXPXUMXXQXXTVWJXWLVWHXXBPXYCXYBYMXXTVWHXXBVWGXWKPXYBXYAYMXKYAUXH
      UXLXXAXXSXXFXXAXXOXXFXXRXXAXXOQZXXFXXCXXDPHZXYDXXNXYEXXAXXMXXNYNXXAXXNXYE
      TXXOXXAXXBXWLXWKVVKVVHXWSXXBUIGZXWTVVHVVIVVJVQXWSXWMUXIZAXWJFUJXCZVVKVVJX
      WSXWLUIGZXWTVVHVVIVVJWPXYGCXWJFUJXCZXXAVVIXWSXWKUIGZVVHVVIVVJXWTXPVVKXWSX
      WMYOBXWJFUJVJZUXJYCWBXYDXXCUIGZOXXCPHZXXDUIGZOXXDYPHZXXFXYETXXAXYMXXOXXAX
      XBXWKXYHXYLYQYCXYDXYNXXMXXAXXMXXNYOXXAXYNXXMTXXOXXAXXBXWKXYHXYLYRYCVTXXAX
      YOXXOXXAXWLXWKXYJXYLYQYCXYDXWKXWLYPHZXYPXYDXYQXWKXWLPHZXWLXWKYHZXXAXXOXYR
      XXAXYKXYFXYIXXOXYRUHXYLXYHXYJXWKXXBXWLUXKXNUXMXYDXWKXWLVVKXWSXWMXXOUXNYSX
      XAXYQXYRXYSQTXXOXXAXWKXWLXYLXYJUYAYCUXOXXAXYQXYPTXXOXXAXWKXWLXYLXYJUXPYCW
      BXXCXXDUXQWOVTXXAXXRQZXXEXWKXXBJKZXWKXWLJKZYLKZVWDXXAXXEYUCNXXRXXAXXBXWKX
      WLXWKXXAXXBXYHUPZXXAXWKXYLUPZXXAXWLXYJUPZYUEXXAXWKXWLVVKXWSXWMYNYSUXRYCXY
      TYUCVWDGZYUAYUBPHZXYTXXPYUHXXAXXPXXQYOXXAXXPYUHTXXRXXAXWLXXBXWKXYJXYHXYLU
      XSYCWBXYTYUAUIGZOYUAPHZYUBUIGZOYUBYPHZYUGYUHTXXAYUIXXRXXAXWKXXBXYLXYHYQYC
      XYTYUJXXQXXAXXPXXQYNXXAYUJXXQTXXRXXAXWKXXBXYLXYHYRYCVTXXAYUKXXRXXAXWKXWLX
      YLXYJYQYCXYTXWLXWKYPHZYULXYTYUMXWLXWKPHZXWMXXAXXRYUNXXAXYIXYFXYKXXRYUNUHX
      YJXYHXYLXWLXXBXWKUXKXNUXMVVKXWSXWMXXRUXNXXAYUMYUNXWMQTXXRXXAXWLXWKXYJXYLU
      YAYCUXOXXAYUMYULTXXRXXAXWLXWKXYJXYLUXPYCWBYUAYUBUXQWOVTUXTUYBYIUYKXXAVXDX
      XKUAVWBXXAXVQVXDXXKVVKXWTXVQVXDXXKUHVVKXWTXVQUQZVXDYUAVVRVVMJKZLKZVVPVVMJ
      KZXWLXXBJKZLKZNZXXKYUOXWSXVQVXDYVAUHVVKXWSXWMXVQWRVVKXWTXVQWPZVXCYVAYUAVW
      RLKZVXAYUSLKZNDEXWJVVLVWBVWBXXTVWSYVCVXBYVDXXTVWIYUAVWRLXXTVWGXWKVWHXXBJX
      YAXYBVPSXXTVWKYUSVXALXXTVWJXWLVWHXXBJXYCXYBVPURXEEUAXHZYVCYUQYVDYUTYVEVWR
      YUPYUALYVEVWPVVRVWQVVMJVWOVVLCXDVWOVVLAXDZVPURYVEVXAYURYUSLYVEVWTVVPVWQVV
      MJVWOVVLBXDYVFVPSXEUYCVJYUOXVSXVTXWAXXBRGZXWKRGZXWLRGZXYSYVAXXKUHYUOVVHXV
      QXVSVVHVVIVVJXWTXVQUYDYVBXWCVJYUOVVIXVQXVTVVHVVIVVJXWTXVQUYEYVBXWDVJYUOVV
      JXVQXWAVVHVVIVVJXWTXVQUYFYVBXWEVJVVKXWTYVGXVQYUDUOVVKXWTYVHXVQYUEUOVVKXWT
      YVIXVQYUFUOYUOXWKXWLVVKXWSXWMXVQWNYSXWBYVGYVHYVIUQZXYSUQZYVAXXKYVKYVAQZYU
      SVVPLKZXXCVVRLKZMKZXXDYLKZYVMXXDYLKZYVNXXDYLKZMKVVMXXJYVLYVMYVNXXDYVLYUSV
      VPYVLXWLXXBYVGYVHYVIXWBXYSYVAUYGZYVGYVHYVIXWBXYSYVAUYHZYTZXVSXVTXWAYVJXYS
      YVAUYIZWSZYVLXXCVVRYVLXXBXWKYVTYVGYVHYVIXWBXYSYVAUYJZYTZXVSXVTXWAYVJXYSYV
      AUYLZWSZYVLXWLXWKYVSYWDYTZYVLXWLXWKYVSYWDXWBYVJXYSYVAUYMUYNZUYOYVLYVPVVMN
      XXDVVMLKZYVONYVLYWJYUQYUSVVMLKZMKZYVNMKZYUTYWKMKZYVNMKYVOYVLYWJYUAVVRLKZY
      WJMKZYVNMKZYWMYVLYWOYVNMKZYWJMKOYWJMKYWQYWJYVLYWROYWJMYVLYUAXXCMKZVVRLKXV
      MYWROYVLYWSOVVRLYVLYVHYVGYWSONYWDYVTXWKXXBUYPVJSYVLYUAXXCVVRYVLXWKXXBYWDY
      VTYTZYWEYWFUYQYVLVVRYWFUYRVLSYVLYWOYVNYWJYVLYUAVVRYWTYWFWSZYWGYVLXXDVVMYW
      HXVSXVTXWAYVJXYSYVAUYSZWSZUYTYVLYWJYXCVUAXAYVLYWPYWLYVNMYVLYWOYWKMKYUAVVM
      LKZJKZYWOYXDJKZYWKMKYWPYWLYVLYWOYWKYXDYXAYVLYUSVVMYWAYXBWSZYVLYUAVVMYWTYX
      BWSZVUBYVLYWPYWOYWKYXDJKZMKYXEYVLYWJYXIYWOMYVLYUSYUAJKZVVMLKYWJYXIYVLYXJX
      XDVVMLYVLXWLXWKXXBYVSYWDYVTVUCSYVLYUSYUAVVMYWAYWTYXBVUDVUEURYVLYWOYWKYXDY
      XAYXGYXHVUKVUFYVLYUQYXFYWKMYVLYUAVVRVVMYWTYWFYXBVESVULSVSYVLYWLYWNYVNMYVL
      YUQYUTYWKMYVKYVAVUGSSYVLYWNYVMYVNMYVLYWNYUSYURLKZYWKMKYUSYURVVMMKZLKYVMYV
      LYUTYXKYWKMYVLYURYUSYVLVVPVVMYWBYXBYTZYWAWMSYVLYUSYURVVMYWAYXMYXBVUHYVLYX
      LVVPYUSLYVLVVPVVMYWBYXBVUIURXBSVRYVLYVOXXDVVMYVLYVMYVNYWCYWGVUJYWHYXBYWIV
      UMVTYVLYVQXXHYVRXXIMYVLYVQYUSXXDYLKZVVPLKXXHYVLYUSVVPXXDYWAYWBYWHYWIVUNYV
      LYXNXXGVVPLYVLXXDXXCJKZXXDYLKXXDXXDYLKZXXEJKYXNXXGYVLXXDXXCXXDYWHYWEYWHYW
      IVUOYVLYXOYUSXXDYLYVLXWLXXBXWKYVSYVTYWDVUCSYVLYXPIXXEJYVLXXDYWHYWIVUPSVLS
      VSYVLXXCVVRXXDYWEYWFYWHYWIVUNVPVLYIVUTUYKVUQVURVUSVVAVWCXXLUBXXEVWDVVNXXE
      NZVWAXXKUAVWBYXQVVTXXJVVMYXQVVQXXHVVSXXIMYXQVVOXXGVVPLVVNXXEIJXRSVVNXXEVV
      RLYJVPYEYFYGVVBVVCVVDVVEVVDVVFYB $.
  $}

  $( Lemma for ~ colinearalg .  Expand out a multiplication.  (Contributed by
     Scott Fenton, 24-Jun-2013.) $)
  colinearalglem1 $p |- (
    ( ( A e. CC /\ B e. CC /\ C e. CC ) /\
      ( D e. CC /\ E e. CC /\ F e. CC ) ) ->
    ( ( ( B - A ) x. ( F - D ) ) = ( ( E - D ) x. ( C - A ) ) <->
      ( ( B x. F ) - ( ( A x. F ) + ( B x. D ) ) ) =
      ( ( C x. E ) - ( ( A x. E ) + ( C x. D ) ) ) ) ) $=
    ( cc wcel w3a cmin co cmul caddc subcld subdid subdird oveq12d mulcl syl2an
    wceq simpl2 simpl1 simpr3 simpr1 simp2 simp3 simp1 subsub3d addsubd 3eqtrrd
    subsub4d oveq1d 3eqtr2d simpr2 simpl3 mulcomd eqtr3d 3eqtrd addcld addcan2d
    wa eqeq12d bitrd ) AGHZBGHZCGHZIZDGHZEGHZFGHZIZVAZBAJKZFDJKLKZEDJKZCAJKZLKZ
    TBFLKZAFLKZBDLKZMKZJKZADLKZMKZCELKZAELKZCDLKZMKZJKZWCMKZTWBWITVLVNWDVQWJVLV
    NVMFLKZVMDLKZJKZVRVSJKZVTJKZWCMKZWDVLVMFDVLBAVDVEVFVKUAZVDVEVFVKUBZNVGVHVIV
    JUCZVGVHVIVJUDZOVLWMWNVTWCJKZJKWNWCMKVTJKWPVLWKWNWLXAJVLBAFWQWRWSPVLBADWQWR
    WTPQVLWNVTWCVLVRVSVGVEVJVRGHVKVDVEVFUEZVHVIVJUFZBFRSZVGVDVJVSGHVKVDVEVFUGZX
    CAFRSZNZVGVEVHVTGHVKXBVHVIVJUGZBDRSZVGVDVHWCGHVKXEXHADRSZUHVLWNWCVTXGXJXIUI
    UJVLWOWBWCMVLVRVSVTXDXFXIUKULUMVLVQVPVOLKVPELKZVPDLKZJKZWJVLVOVPVLEDVGVHVIV
    JUNZWTNVLCAVDVEVFVKUOZWRNZUPVLVPEDXPXNWTOVLWEWFJKZWGJKZWCMKZXMWJVLXMXQWGWCJ
    KZJKXQWCMKWGJKXSVLXKXQXLXTJVLCAEXOWRXNPVLCADXOWRWTPQVLXQWGWCVLWEWFVGVFVIWEG
    HVKVDVEVFUFZVHVIVJUEZCERSZVGVDVIWFGHVKXEYBAERSZNZVGVFVHWGGHVKYAXHCDRSZXJUHV
    LXQWCWGYEXJYFUIUJVLXRWIWCMVLWEWFWGYCYDYFUKULUQURVBVLWBWIWCVLVRWAXDVLVSVTXFX
    IUSNVLWEWHYCVLWFWGYDYFUSNXJUTVC $.

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d N i j $.
    $( Lemma for ~ colinearalg .  Translate between two forms of the
       colinearity condition.  (Contributed by Scott Fenton, 24-Jun-2013.) $)
    colinearalglem2 $p |- (
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ->
       ( A. i e. ( 1 ... N ) A. j e. ( 1 ... N )
         ( ( ( B ` i ) - ( A ` i ) ) x. ( ( C ` j ) - ( A ` j ) ) ) =
         ( ( ( B ` j ) - ( A ` j ) ) x. ( ( C ` i ) - ( A ` i ) ) )
         <->
         A. i e. ( 1 ... N ) A. j e. ( 1 ... N )
         ( ( ( C ` i ) - ( B ` i ) ) x. ( ( A ` j ) - ( B ` j ) ) ) =
         ( ( ( C ` j ) - ( B ` j ) ) x. ( ( A ` i ) - ( B ` i ) ) ) ) ) $=
      ( cfv wcel w3a cmin co cmul wceq fveecn syl2an caddc mulcl subcld eqtrd
      cc cv c1 wa wb simp1 simpl simp2 simp3 simpr addcld subadd2d eqcom syl6bb
      cee cfz addsubd addcomd oveq1d eqtr3d eqeq2d bitrd subsub4d eqcomd oveq2d
      subsub3d subsubd 3eqtr2d eqeq1d subeqrev syl22anc 3bitr3rd subaddd sub32d
      addsub12d syl5rbbr colinearalglem1 syl2anb 3bitr4d syl33anc 2ralbidva
      3anrot ) AFUNGZHZBWBHZCWBHZIZDUAZBGZWGAGZJKEUAZCGZWJAGZJKLKWJBGZWLJKWGCGZ
      WIJKLKMZWNWHJKWLWMJKLKWKWMJKWIWHJKLKMZDEUBFUOKZWQWFWGWQHZWJWQHZUCZUCWITHZ
      WHTHZWNTHZWLTHZWMTHZWKTHZWOWPUDWFWCWRXAWTWCWDWEUEZWRWSUFZAWGFNOWFWDWRXBWT
      WCWDWEUGZXHBWGFNOWFWEWRXCWTWCWDWEUHZXHCWGFNOWFWCWSXDWTXGWRWSUIZAWJFNOWFWD
      WSXEWTXIXKBWJFNOWFWEWSXFWTXJXKCWJFNOXAXBXCIZXDXEXFIZUCZWHWKLKZWIWKLKZWHWL
      LKZPKZJKWNWMLKZWIWMLKZWNWLLKZPKZJKMZYAXQXSPKJKZXPXOXTPKZJKZMZWOWPXNYCXQYF
      PKZYAXSJKZMZYGXNXRXOJKZXTJKZYIMZYKYBXSJKZMZYJYCXNYMYKYIXTPKZMZYOXNYMYPYKM
      YQXNYKXTYIXNXRXOXNXPXQXLXAXFXPTHXMXAXBXCUEZXDXEXFUHZWIWKQOZXLXBXDXQTHXMXA
      XBXCUGZXDXEXFUEZWHWLQOZUJZXLXBXFXOTHZXMUUAYSWHWKQOZRXLXAXEXTTHXMYRXDXEXFU
      GZWIWMQOZXNYAXSXLXCXDYATHXMXAXBXCUHZUUBWNWLQOZXLXCXEXSTHZXMUUIUUGWNWMQOZR
      ZUKYPYKULUMXNYPYNYKXNYAXTPKZXSJKYPYNXNYAXTXSUUJUUHUULUPXNUUNYBXSJXNYAXTUU
      JUUHUQURUSUTVAXNYLYHYIXNYLXPXOJKZXQXTJKZPKZYHXNYLXRYEJKXPYEXQJKZJKZUUQXNX
      RXOXTUUDUUFUUHVBXNXPYEXQYTXNXOXTUUFUUHUJZUUCVEXNUUSXPXOUUPJKZJKUUQXNUURUV
      AXPJXNUVAUURXNXOXQXTUUFUUCUUHVEVCVDXNXPXOUUPYTUUFXNXQXTUUCUUHRVFSVGXNUUQX
      QUUOXTJKZPKYHXNUUOXQXTXNXPXOYTUUFRUUCUUHVNXNUVBYFXQPXNXPXOXTYTUUFUUHVBVDS
      SVHXNXRTHUUEYBTHUUKYOYCUDUUDUUFXNXTYAUUHUUJUJUULXRXOYBXSVIVJVKXNYJYFYDMZY
      GXNYJYFYIXQJKZMZUVCUVEUVDYFMXNYJUVDYFULXNYIXQYFUUMUUCXNXPYEYTUUTRVLVOXNUV
      DYDYFXNUVDYAXQJKXSJKYDXNYAXSXQUUJUULUUCVMXNYAXQXSUUJUUCUULVBSUTVAYFYDULUM
      VAWIWHWNWLWMWKVPXLXBXCXAIXEXFXDIWPYGUDXMXAXBXCWAXDXEXFWAWHWNWIWMWKWLVPVQV
      RVSVT $.

    $( Lemma for ~ colinearalg .  Translate between two forms of the
       colinearity condition.  (Contributed by Scott Fenton, 24-Jun-2013.) $)
    colinearalglem3 $p |- (
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ->
       ( A. i e. ( 1 ... N ) A. j e. ( 1 ... N )
         ( ( ( B ` i ) - ( A ` i ) ) x. ( ( C ` j ) - ( A ` j ) ) ) =
         ( ( ( B ` j ) - ( A ` j ) ) x. ( ( C ` i ) - ( A ` i ) ) )
         <->
         A. i e. ( 1 ... N ) A. j e. ( 1 ... N )
         ( ( ( A ` i ) - ( C ` i ) ) x. ( ( B ` j ) - ( C ` j ) ) ) =
         ( ( ( A ` j ) - ( C ` j ) ) x. ( ( B ` i ) - ( C ` i ) ) ) ) ) $=
      ( cee cfv wcel w3a cv cmin co cmul wceq c1 cfz wral colinearalglem2 wb
      3comr bitrd ) AFGHZIZBUCIZCUCIZJDKZBHZUGAHZLMEKZCHZUJAHZLMNMUJBHZULLMUGCH
      ZUILMNMOEPFQMZRDUORUNUHLMULUMLMNMUKUMLMUIUHLMNMOEUORDUORZUIUNLMUMUKLMNMUL
      UKLMUHUNLMNMOEUORDUORZABCDEFSUEUFUDUPUQTBCADEFSUAUB $.
  $}

  ${
    $d A i $.  $d C i $.  $d K i $.  $d N i $.
    $( Lemma for ~ colinearalg .  Prove a disjunction that will be needed in
       the final proof.  (Contributed by Scott Fenton, 27-Jun-2013.) $)
    colinearalglem4 $p |- (
       ( ( A e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\ K e. RR ) ->
       ( A. i e. ( 1 ... N ) ( ( ( ( K x. ( ( C ` i ) - ( A ` i ) ) ) +
         ( A ` i ) ) - ( A ` i ) ) x. ( ( C ` i ) - ( A ` i ) ) ) <_ 0 \/
         A. i e. ( 1 ... N ) ( ( ( C ` i ) - ( ( K x. ( ( C ` i ) -
         ( A ` i ) ) ) + ( A ` i ) ) ) x. ( ( A ` i ) -
         ( ( K x. ( ( C ` i ) - ( A ` i ) ) ) + ( A ` i ) ) ) ) <_ 0 \/
         A. i e. ( 1 ... N ) ( ( ( A ` i ) - ( C ` i ) ) x. ( ( ( K x.
         ( ( C ` i ) - ( A ` i ) ) ) + ( A ` i ) ) - ( C ` i ) ) ) <_ 0 ) ) $=
      ( wcel wa cr cc0 cle wbr c1 cmin co cmul recnd remulcld cc oveq2d cneg cv
      cee cfv w3o caddc cfz wral relin01 adantl fveere adantlr adantll jca cexp
      c2 simprl resubcl ancoms adantr mulassd recn pncand oveq1d sqvald 3eqtr4d
      ad2antrr wo simprr sqge0d wb resqcld mulle0b syl2anc mpbird eqbrtrd sylan
      orcd an32s ralrimiva expr sub32d wceq ax-1cn subdir mp3an1 mulid2d eqtr2d
      ad2antlr subsub4d 3eqtr3rd subidd syl6eqr oveq12d 1re mpan ad2antrl mul4d
      df-neg negeqd 3eqtrd simpl sylancr subge0 biimpar adantrl mulge0d breqtrd
      mulneg2d le0neg2d mpbid negsubdi2d simplr simpll peano2rem mulneg1d eqtrd
      mul12d eqtr4d mp3an2 subsub3d mpan2 3orim123d mpd ) AEUBUCZFZBYDFZGZDHFZG
      ZDIJKZIDJKZDLJKZGZLDJKZUDZDCUAZBUCZYPAUCZMNZONZYRUENZYRMNZYSONZIJKZCLEUFN
      ZUGZYQUUAMNZYRUUAMNZONZIJKZCUUEUGZYRYQMNZUUAYQMNZONZIJKZCUUEUGZUDYHYOYGDU
      HUIYIYJUUFYMUUKYNUUPYGYHYJUUFYGYHYJGZGUUDCUUEYGYPUUEFZUUQUUDYGUURGZYRHFZY
      QHFZGZUUQUUDUUSUUTUVAYEUURUUTYFAYPEUJUKYFUURUVAYEBYPEUJULUMZUVBUUQGZUUCDY
      SUOUNNZONZIJUVDYTYSONDYSYSONZONUUCUVFUVDDYSYSUVDDUVBYHYJUPZPUVDYSUVBYSHFZ
      UUQUVAUUTUVIYQYRUQZURZUSZPZUVMUTUVDUUBYTYSOUVDYTYRUVDYTUVDDYSUVHUVLQPUUTY
      RRFZUVAUUQYRVAZVFVBVCUVDUVEUVGDOUVDYSUVMVDSVEUVDUVFIJKZYJIUVEJKZGZYKUVEIJ
      KGZVGZUVDUVRUVSUVDYJUVQUVBYHYJVHUVDYSUVLVIUMVQUVDYHUVEHFUVPUVTVJUVHUVDYSU
      VLVKDUVEVLVMVNVOVPVRVSVTYGYHYMUUKYGYHYMGZGUUJCUUEYGUURUWAUUJUUSUVBUWAUUJU
      VCUVBUWAGZUUILDMNZDONZUVGONZTZIJUWBUUIUWCYSONZYTTZONUWGYTONZTUWFUWBUUGUWG
      UUHUWHOUWBYSYTMNZYQYTMNYRMNUWGUUGUWBYQYRYTUVAYQRFZUUTUWAYQVAZWHZUUTUVNUVA
      UWAUVOVFZUWBYTUWBDYSUVBYHYMUPZUVBUVIUWAUVKUSZQPZWAUWBUWGLYSONZYTMNZUWJUWB
      DRFZYSRFZUWGUWSWBZUWBDUWOPZUWBYSUWPPZLRFZUWTUXAUXBWCLDYSWDWEVMUWBUWRYSYTM
      UWBYSUXDWFVCWGUWBYQYTYRUWMUWQUWNWIWJUWBYRYRMNZYTMNZYRYTMNYRMNUWHUUHUWBYRY
      RYTUWNUWNUWQWAUWBUXGIYTMNUWHUWBUXFIYTMUWBYRUWNWKVCYTWRWLUWBYRYTYRUWNUWQUW
      NWIWJWMUWBUWGYTUWBUWGUWBUWCYSYHUWCHFZUVBYMLHFZYHUXHWNLDUQZWOWPZUWPQPUWQXH
      UWBUWIUWEUWBUWCYSDYSUWBUWCUXKPUXDUXCUXDWQWSWTUWBIUWEJKUWFIJKUWBIUWDUVEONU
      WEJUWBUWDUVEUWBUWCDUXKUWOQZUWBYSUWPVKUWAIUWDJKUVBUWAUWCDUWAUXIYHUXHWNYHYM
      XAZUXJXBUXMYHYLIUWCJKZYKYHUXNYLUXIYHUXNYLVJWNLDXCWOXDXEYHYKYLUPXFUIUWBYSU
      WPVIXFUWBUVEUVGUWDOUWBYSUXDVDSXGUWBUWEUWBUWDUVGUXLUWBYSYSUWPUWPQQXIXJVOVP
      VRVSVTYGYHYNUUPYGYHYNGZGUUOCUUEYGUURUXOUUOUUSUVBUXOUUOUVCUVBUXOGZUUNDLMNZ
      UVEONZTZIJUXPYSTZUXQYSONZONZUULUYAONUXSUUNUXPUXTUULUYAOUXPYQYRUVAUWKUUTUX
      OUWLWHZUUTUVNUVAUXOUVOVFZXKVCUXPUYBYSUYAONZTUXSUXPYSUYAUXPYSUXPUVAUUTUVIU
      UTUVAUXOXLUUTUVAUXOXMUVJVMZPZUXPUYAUXPUXQYSYHUXQHFUVBYNDXNWPZUYFQPXOUXPUY
      EUXRUXPUYEUXQUVGONUXRUXPYSUXQYSUYGUXPUXQUYHPUYGXQUXPUVEUVGUXQOUXPYSUYGVDS
      XRWSXPUXPUYAUUMUULOUXPUYAYTUWRMNZYTYSMNUUMUXPUWTUXAUYAUYIWBZUXPDUVBYHYNUP
      ZPUYGUWTUXEUXAUYJWCDLYSWDXSVMUXPUWRYSYTMUXPYSUYGWFSUXPYTYQYRUXPYTUXPDYSUY
      KUYFQPUYCUYDXTWTSWJUXPIUXRJKUXSIJKUXPUXQUVEUYHUXPYSUYFVKZUXPIUXQJKZYNUVBY
      HYNVHYHUYMYNVJZUVBYNYHUXIUYNWNDLXCYAWPVNUXPYSUYFVIXFUXPUXRUXPUXQUVEUYHUYL
      QXIXJVOVPVRVSVTYBYC $.
  $}

  ${
    $d N i j k p t $.  $d A i j k p t $.  $d B i j k p t $.  $d C i j k p t $.
    $( An algebraic characterization of colinearity.  Note the similarity to
       ~ brbtwn2 .  (Contributed by Scott Fenton, 24-Jun-2013.) $)
    colinearalg $p |-
        (
          ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ->
          ( ( A Btwn <. B , C >. \/ B Btwn <. C , A >. \/
              C Btwn <. A , B >. ) <->
            A. i e. ( 1 ... N ) A. j e. ( 1 ... N )
            ( ( ( B ` i ) - ( A ` i ) ) x. ( ( C ` j ) - ( A ` j ) ) ) =
            ( ( ( B ` j ) - ( A ` j ) ) x. ( ( C ` i ) - ( A ` i ) ) ) ) ) $=
      ( vp cfv wcel w3a wbr cmin co cmul cc0 cle wral wceq wa wb cee cop w3o cv
      cbtwn c1 brbtwn2 3comr colinearalglem3 anbi2d bitrd colinearalglem2 3coml
      3orbi123d wi cc fveecn subid oveq2d adantl subcl mul01d eqtrd syl2an 0le0
      anandirs syl6eqbr ralrimiva 3adant1 fveq1 oveq12d ralbidv syl5ibcom 3mix1
      cfz breq1d syl6 a1dd wne wrex simp3 simp1 eqeefv syl2anc necon3abid df-ne
      wn rexbii rexnal bitr2i syl6bb ralcom fveq2 oveq1d eqeq12d rspcv ad2antrl
      weq cr fveere 3ad2antl1 3ad2antl2 3ad2antl3 3jca anim1i anasss cdiv caddc
      adantlr recn 3anim123i adantr ad2antlr simplrr eqcom simp12 simp11 simp22
      simp21 subcld simp23 simpr3 simpr1 subeq0ad biimp3ar divcld simp13 mulcld
      necon3bid syl3anc syl5bb resubcld oveq1 ralimi ralbi syl oveq2 wo df-3or
      andir subadd2 bicomd div23d eqeq2d divmuld mulcomd eqeq1d ralbidva 3simpb
      3bitr2d simpl2 simpl1 simpl3 3ad2ant1 redivcld colinearalglem4 syl5ibrcom
      recnd biimpar sylbird syldan syld syl5bi sylbid pm2.61dne pm4.71rd orbi1i
      rexlimdvaa anbi1i bitri 3bitr4i syl6rbb ) AFUAHZIZBUVMIZCUVMIZJZABCUBUEKZ
      BCAUBUEKZCABUBUEKZUCDUDZBHZUWAAHZLMZUWACHZUWCLMZNMZOPKZDUFFVOMZQZUWDEUDZC
      HZUWKAHZLMZNMZUWKBHZUWMLMZUWFNMZRZEUWIQDUWIQZSZUWEUWBLMZUWCUWBLMZNMZOPKZD
      UWIQZUWTSZUWCUWELMZUWBUWELMZNMZOPKZDUWIQZUWTSZUCZUWTUVQUVRUXAUVSUXGUVTUXM
      ABCDEFUGUVQUVSUXFUXBUWMUWPLMNMUWLUWPLMUXCNMREUWIQDUWIQZSZUXGUVOUVPUVNUVSU
      XPTBCADEFUGUHUVQUXOUWTUXFUVOUVPUVNUXOUWTTBCADEFUIUHUJUKUVPUVNUVOUVTUXMTUV
      PUVNUVOJZUVTUXLUXHUWPUWLLMNMUWMUWLLMUXINMREUWIQDUWIQZSUXMCABDEFUGUXQUXRUW
      TUXLCABDEFULUJUKUMUNUVQUWTUWJUXFUXLUCZUWTSZUXNUVQUWTUXSUVQUWTUXSUOZCAUVQC
      ARZUXSUWTUVQUYBUWJUXSUVQUXIUWEUWELMZNMZOPKZDUWIQZUYBUWJUVOUVPUYFUVNUVOUVP
      SZUYEDUWIUYGUWAUWIIZSUYDOOPUVOUVPUYHUYDORZUVOUYHSUWBUPIZUWEUPIZUYIUVPUYHS
      BUWAFUQZCUWAFUQZUYJUYKSZUYDUXIONMZOUYKUYDUYORUYJUYKUYCOUXINUWEURUSUTUYNUX
      IUWBUWEVAVBVCVDVFVEVGVHVIUYBUYEUWHDUWIUYBUYDUWGOPUYBUXIUWDUYCUWFNUYBUWEUW
      CUWBLUWACAVJZUSUYBUWEUWCUWELUYPUSVKVPVLVMUWJUXFUXLVNVQVRUVQCAVSZGUDZCHZUY
      RAHZVSZGUWIVTZUYAUVQUYQUYSUYTRZGUWIQZWGZVUBUVQVUDCAUVQUVPUVNUYBVUDTUVNUVO
      UVPWAUVNUVOUVPWBCAGFWCWDWEVUBVUCWGZGUWIVTVUEVUAVUFGUWIUYSUYTWFWHVUCGUWIWI
      WJWKUVQVUAUYAGUWIUWTUWSDUWIQZEUWIQZUVQUYRUWIIZVUASZSZUXSUWSDEUWIUWIWLVUKV
      UHUWDUYSUYTLMZNMZUYRBHZUYTLMZUWFNMZRZDUWIQZUXSVUIVUHVURUOUVQVUAVUGVUREUYR
      UWIEGWRZUWSVUQDUWIVUSUWOVUMUWRVUPVUSUWNVULUWDNVUSUWLUYSUWMUYTLUWKUYRCWMUW
      KUYRAWMZVKUSVUSUWQVUOUWFNVUSUWPVUNUWMUYTLUWKUYRBWMVUTVKWNWOVLWPWQUVQVUJUY
      TWSIZVUNWSIZUYSWSIZJZVUASZVURUXSUOUVQVUIVUAVVEUVQVUISZVVDVUAVVFVVAVVBVVCU
      VNUVOVUIVVAUVPAUYRFWTXAUVOUVNVUIVVBUVPBUYRFWTXBUVPUVNVUIVVCUVOCUYRFWTXCXD
      XEXFUVQVVESZVURUWBVUOVULXGMZUWFNMZUWCXHMZRZDUWIQZUXSVVGVVKVUQDUWIVVGUYHSU
      WCUPIZUYJUYKJZUYTUPIZVUNUPIZUYSUPIZJZVUAVVKVUQTUVQUYHVVNVVEUVQUYHSVVMUYJU
      YKUVNUVOUYHVVMUVPAUWAFUQXAUVOUVNUYHUYJUVPUYLXBUVPUVNUYHUYKUVOUYMXCXDXIVVE
      VVRUVQUYHVVDVVRVUAVVAVVOVVBVVPVVCVVQUYTXJZVUNXJUYSXJXKXLXMUVQVVDVUAUYHXNV
      VKVVJUWBRZVVNVVRVUAJZVUQUWBVVJXOVWAVVTUWDVVIRZUWDVUPVULXGMZRZVUQVWAUYJVVM
      VVIUPIZVVTVWBTVVMUYJUYKVVRVUAXPZVVMUYJUYKVVRVUAXQZVWAVVHUWFVWAVUOVULVWAVU
      NUYTVVNVVOVVPVVQVUAXRVVNVVOVVPVVQVUAXSZXTZVWAUYSUYTVVNVVOVVPVVQVUAYAVWHXT
      ZVVNVVRVULOVSZVUAVVNVVRSZVULOUYSUYTVWLUYSUYTVVNVVOVVPVVQYBVVNVVOVVPVVQYCY
      DYIYEZYFVWAUWEUWCVVMUYJUYKVVRVUAYGVWGXTZYHUYJVVMVWEJVWBVVTUWBUWCVVIUUAUUB
      YJVWAVWCVVIUWDVWAVUOUWFVULVWIVWNVWJVWMUUCUUDVWDVWCUWDRZVWAVUQUWDVWCXOVWAV
      WOVULUWDNMZVUPRVUQVWAVUPVULUWDVWAVUOUWFVWIVWNYHVWJVWAUWBUWCVWFVWGXTZVWMUU
      EVWAVWPVUMVUPVWAVULUWDVWJVWQUUFUUGUKYKUUJYKYJUUHUVQUVNUVPSZVVHWSIZVVLUXSU
      OVVEUVNUVOUVPUUIVVEVUOVULVVEVUNUYTVVAVVBVVCVUAUUKVVAVVBVVCVUAUULZYLVVEUYS
      UYTVVAVVBVVCVUAUUMVWTYLVVDVWKVUAVVDVULOUYSUYTVVDUYSUYTVVDUYSVVAVVBVVCWAUU
      RVVAVVBVVOVVCVVSUUNYDYIUUSUUOVWRVWSSUXSVVLVVJUWCLMZUWFNMZOPKZDUWIQZUWEVVJ
      LMZUWCVVJLMZNMZOPKZDUWIQZUXHVVJUWELMZNMZOPKZDUWIQZUCACDVVHFUUPVVLUWJVXDUX
      FVXIUXLVXMVVLUWHVXCTZDUWIQUWJVXDTVVKVXNDUWIVVKUWGVXBOPVVKUWDVXAUWFNUWBVVJ
      UWCLYMWNVPYNUWHVXCDUWIYOYPVVLUXEVXHTZDUWIQUXFVXITVVKVXODUWIVVKUXDVXGOPVVK
      UXBVXEUXCVXFNUWBVVJUWELYQUWBVVJUWCLYQVKVPYNUXEVXHDUWIYOYPVVLUXKVXLTZDUWIQ
      UXLVXMTVVKVXPDUWIVVKUXJVXKOPVVKUXIVXJUXHNUWBVVJUWELYMUSVPYNUXKVXLDUWIYOYP
      UNUUQVDUUTUVAUVBUVCUVHUVDUVEUVFUWJUXFYRZUWTSZUXMYRZUXAUXGYRZUXMYRUXTUXNVX
      RVXTUXMUWJUXFUWTYTUVGUXTVXQUXLYRZUWTSVXSUXSVYAUWTUWJUXFUXLYSUVIVXQUXLUWTY
      TUVJUXAUXGUXMYSUVKUVLUK $.
  $}

  ${
    $d N i $.  $d A i $.  $d B i $.
    eleesub.1 $e |- C = ( i e. ( 1 ... N ) |-> ( ( A ` i ) - ( B ` i ) ) ) $.
    $( Membership of a subtraction mapping in a Euclidean space.  (Contributed
       by Scott Fenton, 17-Jul-2013.) $)
    eleesub $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
             C e. ( EE ` N ) ) $=
      ( cee cfv wcel wa c1 cfz co cv cmin cmpt cr wral fveere resubcl ralrimiva
      syl2an anandirs wb cn eleenn mptelee syl adantr mpbird syl5eqel ) AEGHZIZ
      BULIZJZCDKELMZDNZAHZUQBHZOMZPZULFUOVAULIZUTQIZDUPRZUOVCDUPUMUNUQUPIZVCUMV
      EJURQIUSQIVCUNVEJAUQESBUQESURUSTUBUCUAUMVBVDUDZUNUMEUEIVFAEUFURUSDOEUGUHU
      IUJUK $.
  $}

  ${
    $d N i $.  $d A i $.  $d B i $.
    eleesubd.1 $e |- ( ph ->
       C = ( i e. ( 1 ... N ) |-> ( ( A ` i ) - ( B ` i ) ) ) ) $.
    $( Membership of a subtraction mapping in a Euclidean space.  Deduction
       form of ~ eleesub .  (Contributed by Scott Fenton, 17-Jul-2013.) $)
    eleesubd $p |- ( ( ph /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
             C e. ( EE ` N ) ) $=
      ( cee cfv wcel w3a c1 cfz co cv cmin cmpt wa cr fveere wceq 3ad2ant1 wral
      resubcl syl2an anandirs ralrimiva wb cn eleenn mptelee syl adantr 3adant1
      mpbird eqeltrd ) ABFHIZJZCUQJZKDELFMNZEOZBIZVACIZPNZQZUQAURDVEUAUSGUBURUS
      VEUQJZAURUSRZVFVDSJZEUTUCZVGVHEUTURUSVAUTJZVHURVJRVBSJVCSJVHUSVJRBVAFTCVA
      FTVBVCUDUEUFUGURVFVIUHZUSURFUIJVKBFUJVBVCEPFUKULUMUOUNUP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Tarski's axioms for geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The unique dimensional axiom.  If a point is in ` N ` dimensional space
     and in ` M ` dimensional space, then ` N = M ` .  This axiom is not
     traditionally presented with Tarski's axioms, but we require it here as we
     are considering spaces in arbitrary dimensions.  (Contributed by Scott
     Fenton, 24-Sep-2013.) $)
  axdimuniq $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) ) /\
   ( M e. NN /\ A e. ( EE ` M ) ) ) -> N = M ) $=
    ( cee cfv wcel wceq cn eedimeq ad2ant2l ) ACDEFABDEFCBGCHFBHFABCIJ $.

  ${
    $d N i $.  $d A i $.  $d B i $.
    $( ` A ` is as far from ` B ` as ` B ` is from ` A ` .  Axiom A1 of
       [Schwabhauser] p. 10.  (Contributed by Scott Fenton, 3-Jun-2013.) $)
    axcgrrflx $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
       <. A , B >. Cgr <. B , A >. ) $=
      ( vi cee cfv wcel cop ccgr wbr cn wa co cmin c2 cexp csu wceq cc fveecn
      c1 cv sqsubswap syl2an anandirs sumeq2dv wb id simpr simpl brcgr syl12anc
      cfz mpbird 3adant1 ) ACEFZGZBUPGZABHBAHIJZCKGUQURLZUSUACUMMZDUBZAFZVBBFZN
      MOPMZDQVAVDVCNMOPMZDQRZUTVAVEVFDUQURVBVAGZVEVFRZUQVHLVCSGVDSGVIURVHLAVBCT
      BVBCTVCVDUCUDUEUFUTUTURUQUSVGUGUTUHUQURUIUQURUJABBADCUKULUNUO $.
  $}

  ${
    $d N i $.  $d A i $.  $d B i $.  $d C i $.  $d D i $.  $d E i $.  $d F i $.
    $( Congruence is transitive.  Axiom A2 of [Schwabhauser] p. 10.
       (Contributed by Scott Fenton, 3-Jun-2013.) $)
    axcgrtr $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( ( <. A , B >. Cgr <. C , D >. /\
           <. A , B >. Cgr <. E , F >. ) ->
         <. C , D >. Cgr <. E , F >. ) ) $=
      ( vi cfv wcel cop ccgr wbr wa co cmin c2 cexp csu wceq cee wi cn c1 eqtr2
      w3a cfz cv wb simpl1 simpl2 simpl3 simpr1 syl22anc simpr2 anbi12d imbi12d
      brcgr simpr3 mpbiri 3adant1 ) AGUAIZJZBVBJZCVBJZUFZDVBJZEVBJZFVBJZUFZABKZ
      CDKZLMZVKEFKZLMZNZVLVNLMZUBZGUCJVFVJNZVRUDGUGOZHUHZAIWABIPOQROHSZVTWACIWA
      DIPOQROHSZTZWBVTWAEIWAFIPOQROHSZTZNZWCWETZUBWBWCWEUEVSVPWGVQWHVSVMWDVOWFV
      SVCVDVEVGVMWDUIVCVDVEVJUJZVCVDVEVJUKZVCVDVEVJULZVFVGVHVIUMZABCDHGURUNVSVC
      VDVHVIVOWFUIWIWJVFVGVHVIUOZVFVGVHVIUSZABEFHGURUNUPVSVEVGVHVIVQWHUIWKWLWMW
      NCDEFHGURUNUQUTVA $.
  $}

  ${
    $d N i $.  $d A i $.  $d B i $.  $d C i $.
    $( If there is no distance between ` A ` and ` B ` , then ` A = B ` .
       Axiom A3 of [Schwabhauser] p. 10.  (Contributed by Scott Fenton,
       3-Jun-2013.) $)
    axcgrid $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( <. A , B >. Cgr <. C , C >. -> A = B ) ) $=
      ( vi cfv wcel cop wceq c1 co cmin csu cc0 wa cc fveecn syl wb bitrd wi cn
      cee w3a ccgr wbr cfz cv cexp wral subid sq0id sumeq2dv cfn fzfid cuz sumz
      c2 wss olcs eqtrd 3ad2ant3 eqeq2d fveere adantlr adantll resubcld resqcld
      cr sqge0d fsum00 subcl sqeq0 subeq0 anandirs ralbidva 3adant3 simp1 simp2
      syl2an simp3 brcgr syl22anc eqeefv 3bitr4d biimpd adantl ) ADUCFZGZBWHGZC
      WHGZUDZABHCCHUEUFZABIZUADUBGWLWMWNWLJDUGKZEUHZAFZWPBFZLKZURUIKZEMZWOWPCFZ
      XBLKZURUIKZEMZIZWQWRIZEWOUJZWMWNWLXFXANIZXHWLXENXAWKWIXENIWJWKXEWONEMZNWK
      WOXDNEWKWPWOGZOXBPGZXDNICWPDQXLXCXBUKULRUMWKWOUNGZXJNIZWKJDUOWOJUPFUSXMXN
      WOEJUQUTRVAVBVCWIWJXIXHSWKWIWJOZXIWTNIZEWOUJXHXOWOWTEXOJDUOXOXKOZWSXQWQWR
      WIXKWQVIGWJAWPDVDVEWJXKWRVIGWIBWPDVDVFVGZVHXQWSXRVJVKXOXPXGEWOWIWJXKXPXGS
      ZWIXKOWQPGZWRPGZXSWJXKOAWPDQBWPDQXTYAOZXPWSNIZXGYBWSPGXPYCSWQWRVLWSVMRWQW
      RVNTVTVOVPTVQTWLWIWJWKWKWMXFSWIWJWKVRWIWJWKVSWIWJWKWAZYDABCCEDWBWCWIWJWNX
      HSWKABEDWDVQWEWFWG $.
  $}

  ${
    $d N a t i k x $.  $d A a t i k x $.  $d B a t i k x $.  $d C a t i k x $.
    $d D a t i k x $.
    $( Lemma for ~ axsegcon .  Handle the degenerate case.  (Contributed by
       Scott Fenton, 7-Jun-2013.) $)
    axsegconlem1 $p |- ( ( A = B /\
     ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
       ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ) ->
      E. x e. ( EE ` N ) E. t e. ( 0 [,] 1 ) (
       A. i e. ( 1 ... N ) ( B ` i ) =
         ( ( ( 1 - t ) x. ( A ` i ) ) + ( t x. ( x ` i ) ) ) /\
       sum_ i e. ( 1 ... N ) ( ( ( B ` i ) - ( x ` i ) ) ^ 2 ) =
       sum_ i e. ( 1 ... N ) ( ( ( C ` i ) - ( D ` i ) ) ^ 2 ) ) ) $=
      ( vk wceq cfv wcel wa c1 cmin co cmul caddc wral cc0 cee cv cfz cexp cicc
      csu wrex w3a cmpt fveere 3ad2antl1 3ad2antl2 3ad2antl3 resubcld ralrimiva
      c2 cr wb cn eleenn mptelee 3ad2ant1 mpbird cc fveecn ax-1cn oveq1i mulid2
      syl subid1i syl5eq subcl sylan2 3impb mul02d oveq12d addid1 eqtr2d subcld
      syl3anc nncand oveq1d sumeq2dv 0elunit fveq1 weq fveq2 eqid ovex sylan9eq
      fvmpt oveq2d eqeq2d ralbidva eqeq1d anbi12d ralbidv anbi1d rspc2ev mp3an2
      oveq2 oveq1 syl12anc 3expb adantll 2rexbidv syl5ibr imp ) CDJZCHUAKZLZDXJ
      LZMEXJLZFXJLZMZMZGUBZDKZNBUBZOPZXQCKZQPZXSXQAUBZKZQPZRPZJZGNHUCPZSZYHXRYD
      OPZUPUDPZGUFZYHXQEKZXQFKZOPZUPUDPZGUFZJZMZBTNUEPZUGAXJUGZXPUUAXIXRXTXRQPZ
      YERPZJZGYHSZYRMZBYTUGAXJUGZXLXOUUGXKXLXMXNUUGXLXMXNUHZIYHIUBZDKZUUIEKZUUI
      FKZOPZOPZUIZXJLZXRNTOPZXRQPZTXRYOOPZQPZRPZJZGYHSZYHXRUUSOPZUPUDPZGUFZYQJZ
      UUGUUHUUPUUNUQLZIYHSZUUHUVHIYHUUHUUIYHLZMZUUJUUMXLXMUVJUUJUQLXNDUUIHUJUKU
      VKUUKUULXMXLUVJUUKUQLXNEUUIHUJULXNXLUVJUULUQLXMFUUIHUJUMUNUNUOXLXMUUPUVIU
      RZXNXLHUSLUVLDHUTUUJUUMIOHVAVIVBVCUUHUVBGYHUUHXQYHLZMZXRVDLZYMVDLZYNVDLZU
      VBXLXMUVMUVOXNDXQHVEUKZXMXLUVMUVPXNEXQHVEULZXNXLUVMUVQXMFXQHVEUMZUVOUVPUV
      QUHZUVAXRTRPZXRUWAUURXRUUTTRUWAUURNXRQPZXRUUQNXRQNVFVJVGUVOUVPUWCXRJUVQXR
      VHVBVKUWAUUSUVOUVPUVQUUSVDLZUVPUVQMUVOYOVDLUWDYMYNVLXRYOVLVMVNVOVPUVOUVPU
      WBXRJUVQXRVQVBVRVTUOUUHYHUVEYPGUVNUVDYOUPUDUVNXRYOUVRUVNYMYNUVSUVTVSWAWBW
      CUUPTYTLUVCUVGMZUUGWDUUFUWEXRUUBXSUUSQPZRPZJZGYHSZUVGMABUUOTXJYTYCUUOJZUU
      EUWIYRUVGUWJUUDUWHGYHUWJUVMMZUUCUWGXRUWKYEUWFUUBRUWKYDUUSXSQUWJUVMYDXQUUO
      KUUSXQYCUUOWEIXQUUNUUSYHUUOIGWFZUUJXRUUMYOOUUIXQDWGUWLUUKYMUULYNOUUIXQEWG
      UUIXQFWGVPVPUUOWHXRYOOWIWKWJZWLWLWMWNUWJYLUVFYQUWJYHYKUVEGUWKYJUVDUPUDUWK
      YDUUSXROUWMWLWBWCWOWPXSTJZUWIUVCUVGUWNUWHUVBGYHUWNUWGUVAXRUWNUUBUURUWFUUT
      RUWNXTUUQXRQXSTNOXAWBXSTUUSQXBVPWMWQWRWSWTXCXDXEXIYSUUFABXJYTXIYIUUEYRXIY
      GUUDGYHXIYFUUCXRXIYBUUBYERXIYAXRXTQXQCDWEWLWBWMWQWRXFXGXH $.
  $}

  ${
    $d A p $.  $d B p $.  $d C p $.  $d D p $.  $d N p $.
    axsegconlem2.1 $e |- S =
       sum_ p e. ( 1 ... N ) ( ( ( A ` p ) - ( B ` p ) ) ^ 2 ) $.
    $( Lemma for ~ axsegcon .  Show that the square of the distance between two
       points is a real number.  (Contributed by Scott Fenton, 17-Sep-2013.) $)
    axsegconlem2 $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) -> S e. RR ) $=
      ( cee cfv wcel wa c1 cfz co cv cmin c2 cexp csu cr fveere resubcl resqcld
      fzfid syl2an anandirs fsumrecl syl5eqel ) ADGHZIZBUHIZJZCKDLMZENZAHZUMBHZ
      OMZPQMZERSFUKULUQEUKKDUCUIUJUMULIZUQSIZUIURJUNSIZUOSIZUSUJURJAUMDTBUMDTUT
      VAJUPUNUOUAUBUDUEUFUG $.

    $( Lemma for ~ axsegcon .  Show that the square of the distance between two
       points is non-negative.  (Contributed by Scott Fenton, 17-Sep-2013.) $)
    axsegconlem3 $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) -> 0 <_ S ) $=
      ( cee cfv wcel wa cc0 c1 cfz co cv cmin c2 cexp cr fveere csu cle adantlr
      fzfid adantll resubcld resqcld sqge0d fsumge0 syl6breqr ) ADGHZIZBUKIZJZK
      LDMNZEOZAHZUPBHZPNZQRNZEUACUBUNUOUTEUNLDUDUNUPUOIZJZUSVBUQURULVAUQSIUMAUP
      DTUCUMVAURSIULBUPDTUEUFZUGVBUSVCUHUIFUJ $.

    $( Lemma for ~ axsegcon .  Show that the distance between two points is a
       real number.  (Contributed by Scott Fenton, 17-Sep-2013.) $)
    axsegconlem4 $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
                  ( sqr ` S ) e. RR ) $=
      ( cee cfv wcel wa axsegconlem2 axsegconlem3 resqrcld ) ADGHZIBNIJCABCDEFK
      ABCDEFLM $.

    $( Lemma for ~ axsegcon .  Show that the distance between two points is
       non-negative.  (Contributed by Scott Fenton, 17-Sep-2013.) $)
    axsegconlem5 $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
                  0 <_ ( sqr ` S ) ) $=
      ( cee cfv wcel wa axsegconlem2 axsegconlem3 sqrge0d ) ADGHZIBNIJCABCDEFKA
      BCDEFLM $.

    $( Lemma for ~ axsegcon .  Show that the distance between two distinct
       points is positive.  (Contributed by Scott Fenton, 17-Sep-2013.) $)
    axsegconlem6 $p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/= B ) ->
                   0 < ( sqr ` S ) ) $=
      ( cee cfv wcel wne w3a csqr cr axsegconlem4 3adant3 cc0 cle wbr wceq co
      axsegconlem5 wa c1 cfz cv cmin c2 csu eqeelen eqeq1i syl6bbr axsegconlem2
      cexp wb axsegconlem3 sqr00 syl2anc bitr4d necon3bid biimp3a ne0gt0d ) ADG
      HZIZBVBIZABJZKCLHZVCVDVFMIVEABCDEFNOVCVDPVFQRVEABCDEFUAOVCVDVEVFPJVCVDUBZ
      ABVFPVGABSZCPSZVFPSZVGVHUCDUDTEUEZAHVKBHUFTUGUMTEUHZPSVIABEDUICVLPFUJUKVG
      CMIPCQRVJVIUNABCDEFULABCDEFUOCUPUQURUSUTVA $.

    ${
      axsegconlem7.2 $e |- T = sum_ p e. ( 1 ... N )
                         ( ( ( C ` p ) - ( D ` p ) ) ^ 2 ) $.
      $( Lemma for ~ axsegcon .  Show that a particular ratio of distances is
         in the closed unit interval.  (Contributed by Scott Fenton,
         18-Sep-2013.) $)
      axsegconlem7 $p |- ( (
        ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/= B ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
        ( ( sqr ` S ) / ( ( sqr ` S ) + ( sqr ` T ) ) ) e. ( 0 [,] 1 ) ) $=
        ( cfv wcel wa csqr co cc0 cle wbr cr adantr cee wne w3a caddc cdiv cicc
        c1 axsegconlem5 adantl wb axsegconlem4 3adant3 addge01 syl2an mpbid clt
        readdcl 0re a1i axsegconlem6 ltletrd divelunit syl22anc mpbird ) AGUAKZ
        LZBVELZABUBZUCZCVELDVELMZMZENKZVLFNKZUDOZUEOPUGUFOLZVLVNQRZVKPVMQRZVPVJ
        VQVICDFGHJUHUIVIVLSLZVMSLZVQVPUJVJVFVGVRVHABEGHIUKULZCDFGHJUKZVLVMUMUNU
        OZVKVRPVLQRZVNSLZPVNUPRVOVPUJVIVRVJVTTZVIWCVJVFVGWCVHABEGHIUHULTVIVRVSW
        DVJVTWAVLVMUQUNZVKPVLVNPSLVKURUSWEWFVIPVLUPRVJABEGHIUTTWBVAVLVNVBVCVD
        $.

      ${
        $d A i k x $.  $d B i k x $.  $d C i k x $.  $d D i k x $.
        $d N i k x $.  $d S i k x $.  $d T i k x $.  $d i p x $.
        axsegconlem8.3 $e |- F = ( k e. ( 1 ... N ) |->
              ( ( ( ( ( sqr ` S ) + ( sqr ` T ) ) x. ( B ` k ) ) -
                  ( ( sqr ` T ) x. ( A ` k ) ) ) /
                ( sqr ` S ) ) ) $.
        $( Lemma for ~ axsegcon .  Show that a particular mapping generates a
           point.  (Contributed by Scott Fenton, 18-Sep-2013.) $)
        axsegconlem8 $p |- ( ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/=
              B
            ) /\
     ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) -> F e. ( EE ` N ) ) $=
          ( cfv wcel wne wa co csqr cr cee w3a c1 cfz caddc cmul cmin cdiv cmpt
          cv wral axsegconlem4 3adant3 ad2antrr ad2antlr readdcld simpl2 fveere
          sylan remulcld simpl1 resubcld cc0 axsegconlem6 redivcld ralrimiva cn
          gt0ne0d wb eleenn ad2antll mptelee syl mpbird syl5eqel ) AIUANZOZBVPO
          ZABPZUBZCVPOZDVPOZQZQZHGUCIUDRZESNZFSNZUERZGUJZBNZUFRZWGWIANZUFRZUGRZ
          WFUHRZUIZVPMWDWPVPOZWOTOZGWEUKZWDWRGWEWDWIWEOZQZWNWFXAWKWMXAWHWJXAWFW
          GVTWFTOZWCWTVQVRXBVSABEIJKULUMUNZWCWGTOVTWTCDFIJLULUOZUPWDVRWTWJTOVQV
          RVSWCUQBWIIURUSUTXAWGWLXDWDVQWTWLTOVQVRVSWCVAAWIIURUSUTVBXCVTWFVCPWCW
          TVTWFABEIJKVDVHUNVEVFWDIVGOZWQWSVIWBXEVTWADIVJVKWNWFGUHIVLVMVNVO $.

        $( Lemma for ~ axsegcon .  Show that ` B F ` is congruent to ` C D ` .
           (Contributed by Scott Fenton, 19-Sep-2013.) $)
        axsegconlem9 $p |- ( ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/=
              B
            ) /\
  ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
            sum_ i e. ( 1 ... N ) ( ( ( B ` i ) - ( F ` i ) ) ^ 2 ) =
            sum_ i e. ( 1 ... N ) ( ( ( C ` i ) - ( D ` i ) ) ^ 2 ) ) $=
          ( cfv wcel co cmin cmul recnd cee wne w3a wa c1 cfz cv cexp cdiv csqr
          c2 csu caddc wceq fveq2 oveq2d oveq12d oveq1d ovex fvmpt axsegconlem4
          adantl cr 3adant3 ad2antrr simpl2 fveere sylan remulcld syl2an adantr
          weq readdcl ad2antlr simpl1 resubcld cc0 axsegconlem6 gt0ne0d subsubd
          divsubdird cneg adddid addcomd negsubd eqtrd negsubdi2d negeqd eqtr3d
          renegcld pncan2d subdird cc mulneg12 syl2anc 3eqtr3rd divcan3d sqdivd
          sqmuld cle wbr axsegconlem2 axsegconlem3 resqrth 3eqtrd fzfid resqcld
          sumeq2dv fsummulc2 cbvsumv eqtri eqtr4i oveq12i sqr00 necon3bid mpbid
          eqid wb divmul3d mpbiri fsumdivc ) AJUAOZPZBYBPZABUBZUCZCYBPDYBPUDZUD
          ZUEJUFQZGUGZBOZYJIOZRQZUKUHQZGULYIFYJAOZYKRQZUKUHQZSQZEUIQZGULZYIYJCO
          ZYJDOZRQZUKUHQZGULZYHYIYNYSGYHYJYIPZUDZYNFUJOZYPSQZEUJOZUIQZUKUHQUUIU
          KUHQZUUJUKUHQZUIQYSUUGYMUUKUKUHUUGYMYKUUJUUHUMQZYKSQZUUHYOSQZRQZUUJUI
          QZRQZUUKUUGYLUURYKRUUFYLUURUNYHHYJUUNHUGZBOZSQZUUHUUTAOZSQZRQZUUJUIQU
          URYIIHGVLZUVEUUQUUJUIUVFUVBUUOUVDUUPRUVFUVAYKUUNSUUTYJBUOUPUVFUVCYOUU
          HSUUTYJAUOUPUQURNUUQUUJUIUSUTVBUPUUGUUJYKSQZUUQRQZUUJUIQUVGUUJUIQZUUR
          RQUUKUUSUUGUVGUUQUUJUUGUVGUUGUUJYKYFUUJVCPZYGUUFYCYDUVJYEABEJKLVAVDZV
          EZYHYDUUFYKVCPYCYDYEYGVFBYJJVGVHZVITZUUGUUQUUGUUOUUPUUGUUNYKYHUUNVCPZ
          UUFYFUVJUUHVCPZUVOYGUVKCDFJKMVAZUUJUUHVMVJVKZUVMVIZUUGUUHYOYGUVPYFUUF
          UVQVNZYHYCUUFYOVCPYCYDYEYGVOAYJJVGVHZVIZVPTUUGUUJUVLTZYFUUJVQUBZYGUUF
          YFUUJABEJKLVRVSZVEZWAUUGUVHUUIUUJUIUUGUVHUVGUUORQZUUPUMQZUUIUUGUVGUUO
          UUPUVNUUGUUOUVSTUUGUUPUWBTVTUUGUUHYKWBZYOUMQZSQUUHUWISQZUUPUMQUUIUWHU
          UGUUHUWIYOUUGUUHUVTTZUUGUWIUUGYKUVMWJTZUUGYOUWATZWCUUGUWJYPUUHSUUGUWJ
          YOUWIUMQYPUUGUWIYOUWMUWNWDUUGYOYKUWNUUGYKUVMTZWEWFUPUUGUWKUWGUUPUMUUG
          UUJUUNRQZYKSQUUHWBZYKSQZUWGUWKUUGUWPUWQYKSUUGUUNUUJRQZWBUWPUWQUUGUUNU
          UJUUGUUNUVRTZUWCWGUUGUWSUUHUUGUUJUUHUWCUWLWKWHWIURUUGUUJUUNYKUWCUWTUW
          OWLUUGUUHWMPYKWMPUWRUWKUNUWLUWOUUHYKWNWOWPURWPWFURUUGUVIYKUURRUUGYKUU
          JUWOUWCUWFWQURWPWFURUUGUUIUUJUUGUUIUUGUUHYPUVTUUGYOYKUWAUVMVPZVITUWCU
          WFWRUUGUULYRUUMEUIUUGUULUUHUKUHQZYQSQYRUUGUUHYPUWLUUGYPUXATWSUUGUXBFY
          QSUUGFVCPZVQFWTXAZUXBFUNYGUXCYFUUFCDFJKMXBZVNZYGUXDYFUUFCDFJKMXCVNFXD
          WOURWFYFUUMEUNZYGUUFYCYDUXGYEYCYDUDEVCPZVQEWTXAZUXGABEJKLXBZABEJKLXCZ
          EXDWOVDVEUQXEXHYHFYIYQGULZSQZEUIQZYIYRGULZEUIQUUEYTYHUXMUXOEUIYHYIYQF
          GYHUEJXFZYHFYGUXCYFUXEVBZTUUGYQUUGYPUXAXGZTXIURYHUXNUUEUNUXMUUEESQUNF
          UUEUXLESFYIKUGZCOZUXSDOZRQZUKUHQZKULUUEMYIUYCUUDKGKGVLZUYBUUCUKUHUYDU
          XTUUAUYAUUBRUXSYJCUOUXSYJDUOUQURXJXKUXLYIUXSAOZUXSBOZRQZUKUHQZKULEYIY
          QUYHGKGKVLZYPUYGUKUHUYIYOUYEYKUYFRYJUXSAUOYJUXSBUOUQURXJLXLXMYHUXMUUE
          EYHUXMYHFUXLUXQYFUXLVCPZYGYCYDUYJYEABUXLJGUXLXQXBVDVKVITYHUUEYGUUEVCP
          YFCDUUEJGUUEXQXBVBTYHEYFUXHYGYCYDUXHYEUXJVDZVKTZYFEVQUBZYGYFUWDUYMUWE
          YFUXHUXIUWDUYMXRUYKYCYDUXIYEUXKVDUXHUXIUDUUJVQEVQEXNXOWOXPVKZXSXTYHYI
          YREGUXPUYLUUGYRUUGFYQUXFUXRVITUYNYAWPWF $.

        $( Lemma for ~ axsegcon .  Show that the scaling constant from
           ~ axsegconlem7 produces the betweenness condition for ` A ` , ` B `
           and ` F ` .  (Contributed by Scott Fenton, 21-Sep-2013.) $)
        axsegconlem10 $p |- ( ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/=
              B
            ) /\
  ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
  A. i e. ( 1 ... N ) ( B ` i ) =
  ( ( ( 1 - ( ( sqr ` S ) / ( ( sqr ` S ) + ( sqr ` T ) ) ) ) x. ( A ` i ) ) +
  ( ( ( sqr ` S ) / ( ( sqr ` S ) + ( sqr ` T ) ) ) x. ( F ` i ) ) ) ) $=
          ( cfv wcel co cdiv cmul recnd cee wne w3a wa cv c1 csqr cmin wceq cfz
          caddc cr axsegconlem4 ad2antlr simpl1 sylan remulcld 3adant3 ad2antrr
          fveere axsegconlem8 readdcl cc0 0re a1i clt axsegconlem6 axsegconlem5
          syl2an adantr wbr cle adantl wb addge01 mpbid ltletrd gt0ne0d divdird
          fveq2 oveq2d oveq12d oveq1d ovex fvmpt simpl2 resubcld divcan2d eqtrd
          weq pncan3d readdcld divmul2d mpbird div23d divsubdird pncan2 3eqtr3d
          cc dividd ralrimiva ) AJUAOZPZBXBPZABUBZUCZCXBPDXBPUDZUDZGUEZBOZUFEUG
          OZXKFUGOZUKQZRQZUHQZXIAOZSQZXNXIIOZSQZUKQZUIGUFJUJQZXHXIYAPZUDZXLXPSQ
          ZXKXRSQZUKQZXMRQZYDXMRQZYEXMRQZUKQXJXTYCYDYEXMYCYDYCXLXPXGXLULPZXFYBC
          DFJKMUMZUNXHXCYBXPULPXCXDXEXGUOAXIJUTUPZUQZTZYCYEYCXKXRXFXKULPZXGYBXC
          XDYOXEABEJKLUMURZUSZXHIXBPYBXRULPABCDEFHIJKLMNVAIXIJUTUPZUQZTYCXMXHXM
          ULPZYBXFYOYJYTXGYPYKXKXLVBVIZVJZTZXHXMVCUBYBXHXMXHVCXKXMVCULPXHVDVEXF
          YOXGYPVJUUAXFVCXKVFVKXGABEJKLVGZVJXHVCXLVLVKZXKXMVLVKZXGUUEXFCDFJKMVH
          VMXFYOYJUUEUUFVNXGYPYKXKXLVOVIVPVQVRVJZVSYCYGXJUIYFXMXJSQZUIYCYFYDUUH
          YDUHQZUKQUUHYCYEUUIYDUKYCYEXKUUIXKRQZSQUUIYCXRUUJXKSYBXRUUJUIXHHXIXMH
          UEZBOZSQZXLUUKAOZSQZUHQZXKRQUUJYAIHGWJZUUPUUIXKRUUQUUMUUHUUOYDUHUUQUU
          LXJXMSUUKXIBVTWAUUQUUNXPXLSUUKXIAVTWAWBWCNUUIXKRWDWEVMWAYCUUIXKYCUUIY
          CUUHYDYCXMXJUUBXHXDYBXJULPXCXDXEXGWFBXIJUTUPZUQZYMWGTYCXKYQTZXFXKVCUB
          XGYBXFXKUUDVRUSWHWIWAYCYDUUHYNYCUUHUUSTWKWIYCYFXJXMYCYFYCYDYEYMYSWLTY
          CXJUURTUUCUUGWMWNYCYHXQYIXSUKYCYHXLXMRQZXPSQXQYCXLXPXMXGXLWSPZXFYBXGX
          LYKTZUNYCXPYLTUUCUUGWOYCUVAXOXPSYCXMXKUHQZXMRQXMXMRQZXNUHQUVAXOYCXMXK
          XMUUCUUTUUCUUGWPYCUVDXLXMRXHUVDXLUIZYBXFXKWSPUVBUVFXGXFXKYPTUVCXKXLWQ
          VIVJWCYCUVEUFXNUHYCXMUUCUUGWTWCWRWCWIYCXKXRXMUUTYCXRYRTUUCUUGWOWBWRXA
          $.
      $}
    $}
  $}

  ${
    $d N k p t i x $.  $d A k p t i x $.  $d B k p t i x $.  $d C k p t i x $.
    $d D k p t i x $.
    $( Any segment ` A B ` can be extended to a point ` x ` such that ` B x `
       is congruent to ` C D ` .  Axiom A4 of [Schwabhauser] p. 11.
       (Contributed by Scott Fenton, 4-Jun-2013.) $)
    axsegcon $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
       ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
       E. x e. ( EE ` N ) ( B Btwn <. A , x >. /\
                            <. B , x >. Cgr <. C , D >. ) ) $=
      ( vi vt vk vp cfv wcel wa cmin co cmul caddc wceq c2 cexp cee cv cop ccgr
      cbtwn wbr wrex cn c1 cfz wral csu cc0 cicc wi axsegconlem1 ex wne simprll
      simprlr simprr w3a csqr cdiv cmpt axsegconlem8 axsegconlem7 axsegconlem10
      simpl eqid axsegconlem9 fveq1 oveq2d eqeq2d ralbidv oveq1d eqeq1d anbi12d
      sumeq2sdv oveq2 oveq1 oveq12d anbi1d rspc2ev syl112anc syl31anc pm2.61ine
      wb simpllr simplll simpr syl3anc simplrl simplrr syl22anc r19.41v syl6bbr
      brbtwn brcgr rexbidva mpbird 3adant1 ) BFUAKZLZCXCLZMZDXCLZEXCLZMZCBAUBZU
      CUEUFZCXJUCDEUCUDUFZMZAXCUGZFUHLXFXIMZXNGUBZCKZUIHUBZNOZXPBKZPOZXRXPXJKZP
      OZQOZRZGUIFUJOZUKZYFXQYBNOZSTOZGULZYFXPDKXPEKNOSTOGULZRZMZHUMUIUNOZUGZAXC
      UGZXOYPUOBCBCRXOYPAHBCDEGFUPUQBCURZXOYPYQXOMXDXEYQXIYPYQXDXEXIUSYQXDXEXIU
      TYQXOVIYQXFXIVAXDXEYQVBXIMIYFYFJUBZBKYRCKNOSTOJULZVCKZYFYRDKYREKNOSTOJULZ
      VCKZQOZIUBZCKPOUUBUUDBKPONOYTVDOVEZXCLYTUUCVDOZYNLXQUIUUFNOZXTPOZUUFXPUUE
      KZPOZQOZRZGYFUKZYFXQUUINOZSTOZGULZYKRZYPBCDEYSUUAIUUEFJYSVJZUUAVJZUUEVJZV
      FBCDEYSUUAFJUURUUSVGBCDEYSUUAGIUUEFJUURUUSUUTVHBCDEYSUUAGIUUEFJUURUUSUUTV
      KYMUUMUUQMXQYAXRUUIPOZQOZRZGYFUKZUUQMAHUUEUUFXCYNXJUUERZYGUVDYLUUQUVEYEUV
      CGYFUVEYDUVBXQUVEYCUVAYAQUVEYBUUIXRPXPXJUUEVLZVMVMVNVOUVEYJUUPYKUVEYFYIUU
      OGUVEYHUUNSTUVEYBUUIXQNUVFVMVPVSVQVRXRUUFRZUVDUUMUUQUVGUVCUULGYFUVGUVBUUK
      XQUVGYAUUHUVAUUJQUVGXSUUGXTPXRUUFUINVTVPXRUUFUUIPWAWBVNVOWCWDWEWFUQWGXOXM
      YOAXCXOXJXCLZMZXMYGHYNUGZYLMYOUVIXKUVJXLYLUVIXEXDUVHXKUVJWHXDXEXIUVHWIZXD
      XEXIUVHWJXOUVHWKZHCBXJGFWRWLUVIXEUVHXGXHXLYLWHUVKUVLXFXGXHUVHWMXFXGXHUVHW
      NCXJDEGFWSWOVRYGYLHYNWPWQWTXAXB $.
  $}

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d N i j $.  $d T i j $.
    $( Lemma for ~ ax5seg .  Rexpress a one congruence sum given betweenness.
       (Contributed by Scott Fenton, 11-Jun-2013.) $)
    ax5seglem1 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( T e. ( 0 [,] 1 ) /\
         A. i e. ( 1 ... N ) ( B ` i ) =
          ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) ) ) ->
       sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( B ` j ) ) ^ 2 ) =
       ( ( T ^ 2 ) x.
         sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( C ` j ) ) ^ 2 ) ) ) $=
      ( wcel cfv wa c1 co cmin cmul wceq c2 cexp cc adantr oveq1d cn cee cc0 cv
      cicc caddc cfz w3a csu simpl2l fveecn sylancom simpl2r cr cle wbr 0re 1re
      wral elicc2i simp1bi 3ad2ant3 recnd fveq2 oveq12d eqeq12d rspccva adantll
      oveq2d 3ad2antl3 oveq2 subdi 3coml ax-1cn subcl mpan adantl subdir mp3an1
      simpl syl2anc nncan mulid2 3eqtr3rd 3adant2 simp1 ancoms 3adant1 subsub4d
      mulcl sylan 3eqtr2rd simp3 sqmuld eqtrd sylan9eqr syl31anc sumeq2dv fzfid
      3adant3 resqcld 3adant2r 3adant2l sqcld 3expa 3adantl3 fsummulc2 eqtr4d )
      GUAHZAGUBIZHZCXJHZJZDUCKUELHZEUDZBIZKDMLZXOAIZNLZDXOCIZNLZUFLZOZEKGUGLZUS
      ZJZUHZYDFUDZAIZYHBIZMLZPQLZFUIYDDPQLZYIYHCIZMLZPQLZNLZFUIYMYDYPFUINLYGYDY
      LYQFYGYHYDHZJYIRHZYNRHZDRHZYJXQYINLZDYNNLZUFLZOZYLYQOYGYRXKYSXKXLXIYFYRUJ
      AYHGUKZULYGYRXLYTXKXLXIYFYRUMCYHGUKZULYGUUAYRYGDYFXIDUNHZXMXNUUHYEXNUUHUC
      DUOUPDKUOUPUCKDUQURUTVAZSVBVCSYFXIYRUUEXMYEYRUUEXNYCUUEEYHYDXOYHOZXPYJYBU
      UDXOYHBVDUUJXSUUBYAUUCUFUUJXRYIXQNXOYHAVDVIUUJXTYNDNXOYHCVDVIVEVFVGVHVJUU
      EYSYTUUAUHZYLYIUUDMLZPQLZYQUUEYKUULPQYJUUDYIMVKTUUKUUMDYONLZPQLYQUUKUULUU
      NPQUUKUUNDYINLZUUCMLZYIUUBMLZUUCMLZUULUUAYSYTUUNUUPODYIYNVLVMYSUUAUURUUPO
      YTYSUUAJZUUQUUOUUCMUUSKXQMLZYINLZKYINLZUUBMLZUUOUUQUUSXQRHZYSUVAUVCOZUUAU
      VDYSKRHZUUAUVDVNKDVOVPZVQYSUUAVTUVFUVDYSUVEVNKXQYIVRVSWAUUAUVAUUOOYSUUAUU
      TDYINUVFUUAUUTDOVNKDWBVPTVQYSUVCUUQOUUAYSUVBYIUUBMYIWCTSWDTWEUUKYIUUBUUCY
      SYTUUAWFYSUUAUUBRHZYTUUAYSUVHUUAUVDYSUVHUVGXQYIWJWKWGWEYTUUAUUCRHZYSUUAYT
      UVIDYNWJWGWHWIWLTUUKDYOYSYTUUAWMYSYTYORHZUUAYIYNVOZWTWNWOWPWQWRYGYDYPYMFY
      GKGWSYFXIYMRHZXMXNUVLYEXNYMXNDUUIXAVCSVBXIXMYRYPRHZYFXIXMYRUVMXIXMYRUHZYO
      UVNYSYTUVJXIXKYRYSXLXKYRYSXIUUFWHXBXIXLYRYTXKXLYRYTXIUUGWHXCUVKWAXDXEXFXG
      XH $.

    $( Lemma for ~ ax5seg .  Rexpress another congruence sum given
       betweenness.  (Contributed by Scott Fenton, 11-Jun-2013.) $)
    ax5seglem2 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( T e. ( 0 [,] 1 ) /\
         A. i e. ( 1 ... N ) ( B ` i ) =
          ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) ) ) ->
       sum_ j e. ( 1 ... N ) ( ( ( B ` j ) - ( C ` j ) ) ^ 2 ) =
       ( ( ( 1 - T ) ^ 2 ) x.
         sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( C ` j ) ) ^ 2 ) ) ) $=
      ( wcel cfv wa cc0 c1 co cmin cmul caddc wceq c2 cexp cc cee cicc cfz wral
      cn cv w3a csu simpl2l fveecn sylancom simpl2r cle wbr 0re elicc2i simp1bi
      cr 1re recnd adantr 3ad2ant3 fveq2 oveq2d oveq12d eqeq12d rspccva adantll
      3ad2antl3 oveq1 oveq1d ax-1cn subcl mpan simp1 mulcld simp3 simp2 syl3an1
      addsubassd subdi 3coml subdir mp3an1 ancoms 3adant1 mulid2 3ad2ant2 eqtrd
      subsub2d 3eqtrd eqtr4d 3adant3 sqmuld sylan9eqr syl31anc sumeq2dv resubcl
      fzfid sylancr resqcld 3adant2r 3adant2l subcld sqcld 3adantl3 fsummulc2
      3expa ) GUEHZAGUAIZHZCXJHZJZDKLUBMHZEUFZBIZLDNMZXOAIZOMZDXOCIZOMZPMZQZELG
      UCMZUDZJZUGZYDFUFZBIZYHCIZNMZRSMZFUHYDXQRSMZYHAIZYJNMZRSMZOMZFUHYMYDYPFUH
      OMYGYDYLYQFYGYHYDHZJYNTHZYJTHZDTHZYIXQYNOMZDYJOMZPMZQZYLYQQYGYRXKYSXKXLXI
      YFYRUIAYHGUJZUKYGYRXLYTXKXLXIYFYRULCYHGUJZUKYGUUAYRYFXIUUAXMXNUUAYEXNDXND
      URHZKDUMUNDLUMUNKLDUOUSUPUQZUTVAVBVAYFXIYRUUEXMYEYRUUEXNYCUUEEYHYDXOYHQZX
      PYIYBUUDXOYHBVCUUJXSUUBYAUUCPUUJXRYNXQOXOYHAVCVDUUJXTYJDOXOYHCVCVDVEVFVGV
      HVIUUEYSYTUUAUGZYLUUDYJNMZRSMZYQUUEYKUULRSYIUUDYJNVJVKUUKUUMXQYOOMZRSMYQU
      UKUULUUNRSUUKUULUUBUUCYJNMPMZUUNUUKUUBUUCYJUUKXQYNUUAYSXQTHZYTLTHZUUAUUPV
      LLDVMVNZVBZYSYTUUAVOVPZUUKDYJYSYTUUAVQYSYTUUAVRZVPZUVAVTUUKUUNUUBXQYJOMZN
      MZUUBYJUUCNMZNMUUOUUAYSYTUUNUVDQZUUAUUPYSYTUVFUURXQYNYJWAVSWBUUKUVCUVEUUB
      NUUKUVCLYJOMZUUCNMZUVEYTUUAUVCUVHQZYSUUAYTUVIUUQUUAYTUVIVLLDYJWCWDWEWFYTY
      SUVHUVEQUUAYTUVGYJUUCNYJWGVKWHWIVDUUKUUBYJUUCUUTUVAUVBWJWKWLVKUUKXQYOUUSY
      SYTYOTHUUAYNYJVMWMWNWIWOWPWQYGYDYPYMFYGLGWSYFXIYMTHZXMXNUVJYEXNYMXNXQXNLU
      RHUUHXQURHUSUUILDWRWTXAUTVAVBXIXMYRYPTHZYFXIXMYRUVKXIXMYRUGZYOUVLYNYJXIXK
      YRYSXLXKYRYSXIUUFWFXBXIXLYRYTXKXLYRYTXIUUGWFXCXDXEXHXFXGWL $.
  $}

  $( Lemma for ~ ax5seg .  (Contributed by Scott Fenton, 7-May-2015.) $)
  ax5seglem3a $p |- ( ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
    ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) /\
      j e. ( 1 ... N ) ) ->
      ( ( ( A ` j ) - ( C ` j ) ) e. RR /\
        ( ( D ` j ) - ( F ` j ) ) e. RR ) ) $=
    ( cn wcel cee cfv w3a cv co cmin cr fveere sylancom resubcld c1 cfz simpl21
    wa simpl23 simpl31 simpl33 jca ) HIJZAHKLZJZBUJJZCUJJZMZDUJJZFUJJZGUJJZMZMZ
    ENZUAHUBOJZUDZUTALZUTCLZPOQJUTDLZUTGLZPOQJVBVCVDUSVAUKVCQJUKULUMUIURVAUCAUT
    HRSUSVAUMVDQJUKULUMUIURVAUECUTHRSTVBVEVFUSVAUOVEQJUOUPUQUIUNVAUFDUTHRSUSVAU
    QVFQJUOUPUQUIUNVAUGGUTHRSTUH $.

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d D i j $.  $d E i j $.
    $d F i j $.  $d N i j $.  $d S i j $.  $d T i j $.
    $( Lemma for ~ ax5seg .  Combine congruences for points on a line.
       (Contributed by Scott Fenton, 11-Jun-2013.) $)
    ax5seglem3 $p |-
        ( ( ( N e. NN /\
            ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
            ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) /\
            ( ( T e. ( 0 [,] 1 ) /\ S e. ( 0 [,] 1 ) ) /\
              ( A. i e. ( 1 ... N )
                ( B ` i ) =
                ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) /\
                A. i e. ( 1 ... N )
                ( E ` i ) =
                ( ( ( 1 - S ) x. ( D ` i ) ) + ( S x. ( F ` i ) ) ) ) ) /\
            ( <. A , B >. Cgr <. D , E >. /\
              <. B , C >. Cgr <. E , F >. ) ) ->
         sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( C ` j ) ) ^ 2 ) =
         sum_ j e. ( 1 ... N ) ( ( ( D ` j ) - ( F ` j ) ) ^ 2 ) ) $=
      ( wcel cfv c1 co cmul wceq wbr c2 cexp cn cee w3a cc0 cicc wa cv cmin cfz
      caddc wral cop ccgr csu csqr 1re cle 0re elicc2i simp1bi resubcl ad2antrr
      sylancr 3ad2ant2 fzfid ax5seglem3a simpld resqcld fsumrecl sqge0d fsumge0
      resqrcld 3ad2ant1 remulcld ad2antlr simprd simp3bi subge0 sqrge0d mulge0d
      cr wb mpbird resqrth syl2anc oveq2d cc ax-1cn recnd sqmuld simp3r simp122
      subcl simp123 simp132 simp133 brcgr syl22anc mpbid simp11 simp121 simp2ll
      simp2rl ax5seglem2 syl122anc simp131 simp2lr simp2rr 3eqtr3d sq11d simp3l
      3eqtr4d simp2bi oveq12d adddird npcan adantr oveq1d mulid2d eqtrd sqr11
      ax5seglem1 ) KUALZAKUBMZLZBYDLZCYDLZUCZDYDLZIYDLZJYDLZUCZUCZFUDNUEOZLZEYN
      LZUFZGUGZBMNFUHOZYRAMPOFYRCMPOUJOQGNKUIOZUKZYRIMNEUHOZYRDMPOEYRJMPOUJOQGY
      TUKZUFZUFZABULDIULUMRZBCULIJULUMRZUFZUCZYTHUGZAMZUUJCMZUHOZSTOZHUNZUOMZYT
      UUJDMZUUJJMZUHOZSTOZHUNZUOMZQZUUOUVAQZUUIYSFUJOZUUPPOZUUBEUJOZUVBPOZUUPUV
      BUUIYSUUPPOZFUUPPOZUJOUUBUVBPOZEUVBPOZUJOUVFUVHUUIUVIUVKUVJUVLUJUUIUVIUVK
      UUIYSUUPUUEYMYSWALZUUHYOUVMYPUUDYONWALZFWALZUVMUPYOUVOUDFUQRZFNUQRZUDNFUR
      UPUSZUTZNFVAVCVBVDZYMUUEUUPWALUUHYMUUOYMYTUUNHYMNKVEZYMUUJYTLUFZUUMUWBUUM
      WALZUUSWALZABCDHIJKVFZVGZVHZVIZYMYTUUNHUWAUWGUWBUUMUWFVJVKZVLZVMZVNUUIUUB
      UVBUUEYMUUBWALZUUHYPUWLYOUUDYPUVNEWALZUWLUPYPUWMUDEUQRZENUQRZUDNEURUPUSZU
      TZNEVAVCVOVDZYMUUEUVBWALUUHYMUVAYMYTUUTHUWAUWBUUSUWBUWCUWDUWEVPZVHZVIZYMY
      TUUTHUWAUWTUWBUUSUWSVJVKZVLZVMZVNUUIYSUUPUVTUWKUUEYMUDYSUQRZUUHYOUXEYPUUD
      YOUXEUVQYOUVOUVPUVQUVRVQYOUVNUVOUXEUVQWBUPUVSNFVRVCWCVBVDYMUUEUDUUPUQRUUH
      YMUUOUWHUWIVSVMZVTUUIUUBUVBUWRUXDUUEYMUDUUBUQRZUUHYPUXGYOUUDYPUXGUWOYPUWM
      UWNUWOUWPVQYPUVNUWMUXGUWOWBUPUWQNEVRVCWCVOVDYMUUEUDUVBUQRUUHYMUVAUXAUXBVS
      VMZVTUUIYSSTOZUUPSTOZPOUXIUUOPOZUVISTOUVKSTOZUUIUXJUUOUXIPYMUUEUXJUUOQZUU
      HYMUUOWALZUDUUOUQRZUXMUWHUWIUUOWDWEZVMWFUUIYSUUPUUINWGLZFWGLZYSWGLWHUUEYM
      UXRUUHYOUXRYPUUDYOFUVSWIZVBVDZNFWMVCZYMUUEUUPWGLUUHYMUUPUWJWIZVMZWJUUIUUB
      STOZUVBSTOZPOUYDUVAPOZUXLUXKUUIUYEUVAUYDPYMUUEUYEUVAQZUUHYMUVAWALZUDUVAUQ
      RZUYGUXAUXBUVAWDWEVMZWFUUIUUBUVBUUIUXQEWGLZUUBWGLWHUUEYMUYKUUHYPUYKYOUUDY
      PEUWQWIZVOVDZNEWMVCZYMUUEUVBWGLUUHYMUVBUXCWIZVMZWJUUIYTUUJBMZUULUHOSTOHUN
      ZYTUUJIMZUURUHOSTOHUNZUXKUYFUUIUUGUYRUYTQZYMUUEUUFUUGWKUUIYFYGYJYKUUGVUAW
      BYEYFYGYCYLUUEUUHWLZYEYFYGYCYLUUEUUHWNZYIYJYKYCYHUUEUUHWOZYIYJYKYCYHUUEUU
      HWPZBCIJHKWQWRWSUUIYCYEYGYOUUAUYRUXKQYCYHYLUUEUUHWTZYEYFYGYCYLUUEUUHXAZVU
      CYOYPUUDYMUUHXBZUUAUUCYQYMUUHXCZABCFGHKXDXEUUIYCYIYKYPUUCUYTUYFQVUFYIYJYK
      YCYHUUEUUHXFZVUEYOYPUUDYMUUHXGZUUAUUCYQYMUUHXHZDIJEGHKXDXEXIXLXLXJUUIUVJU
      VLUUIFUUPUUEYMUVOUUHYOUVOYPUUDUVSVBVDZUWKVNUUIEUVBUUEYMUWMUUHYPUWMYOUUDUW
      QVOVDZUXDVNUUIFUUPVUMUWKUUEYMUVPUUHYOUVPYPUUDYOUVOUVPUVQUVRXMVBVDUXFVTUUI
      EUVBVUNUXDUUEYMUWNUUHYPUWNYOUUDYPUWMUWNUWOUWPXMVOVDUXHVTUUIFSTOZUXJPOZVUO
      UUOPOZUVJSTOUVLSTOZYMUUEVUPVUQQUUHYMUXJUUOVUOPUXPWFVMUUIFUUPUXTUYCWJUUIES
      TOZUYEPOVUSUVAPOZVURVUQUUIUYEUVAVUSPUYJWFUUIEUVBUYMUYPWJUUIYTUUKUYQUHOSTO
      HUNZYTUUQUYSUHOSTOHUNZVUQVUTUUIUUFVVAVVBQZYMUUEUUFUUGXKUUIYEYFYIYJUUFVVCW
      BVUGVUBVUJVUDABDIHKWQWRWSUUIYCYEYGYOUUAVVAVUQQVUFVUGVUCVUHVUIABCFGHKYBXEU
      UIYCYIYKYPUUCVVBVUTQVUFVUJVUEVUKVULDIJEGHKYBXEXIXLXLXJXNUUIYSFUUPUYAUXTUY
      CXOUUIUUBEUVBUYNUYMUYPXOXLUUIUVFNUUPPOZUUPUUEYMUVFVVDQZUUHYQVVEUUDYQUVENU
      UPPYOUVENQZYPYOUXQUXRVVFWHUXSNFXPVCXQXRXQVDYMUUEVVDUUPQUUHYMUUPUYBXSVMXTU
      UIUVHNUVBPOZUVBUUEYMUVHVVGQZUUHYPVVHYOUUDYPUVGNUVBPYPUXQUYKUVGNQWHUYLNEXP
      VCXRVOVDYMUUEVVGUVBQUUHYMUVBUYOXSVMXTXIYMUUEUVCUVDWBZUUHYMUXNUXOUYHUYIVVI
      UWHUWIUXAUXBUUOUVAYAWRVMWS $.
  $}

  ${
    $d A i $.  $d B i $.  $d C i $.  $d N i $.  $d T i $.
    $( Lemma for ~ ax5seg .  Given two distinct points, the scaling constant in
       a betweenness statement is non-zero.  (Contributed by Scott Fenton,
       11-Jun-2013.) $)
    ax5seglem4 $p |-
       ( ( ( N e. NN /\
           ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) /\
           A. i e. ( 1 ... N )
               ( B ` i ) =
               ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) /\
            A =/= B ) -> T =/= 0 ) $=
      ( wcel cfv wa c1 cmin co cmul caddc wceq wral wne cc0 cc fveecn cn cee cv
      w3a cfz oveq2 ax-1cn subid1i syl6eq oveq1d oveq12d eqeq2d ralbidv biimpac
      oveq1 wb eqeefv 3adant1 3adant3r3 eqcom simplr1 sylancom mulid2 oveqan12d
      simplr3 mul02 addid1 adantr eqtrd syl2anc syl5rbbr ralbidva bitrd syl5ibr
      eqeq1d expdimp necon3d 3impia ) FUAGZAFUBHZGZBVTGZCVTGZUDIZEUCZBHZJDKLZWE
      AHZMLZDWECHZMLZNLZOZEJFUELZPZABQDRQWDWOIDRABWDWODROZABOZWOWPIWQWDWFJWHMLZ
      RWJMLZNLZOZEWNPZWPWOXBWPWMXAEWNWPWLWTWFWPWIWRWKWSNWPWGJWHMWPWGJRKLJDRJKUF
      JUGUHUIUJDRWJMUOUKULUMUNWDWQWHWFOZEWNPZXBVSWAWBWQXDUPZWCWAWBXEVSABEFUQURU
      SWDXCXAEWNXAWTWFOWDWEWNGZIZXCWTWFUTXGWTWHWFXGWHSGZWJSGZWTWHOWDXFWAXHWAWBW
      CVSXFVAAWEFTVBWDXFWCXIWAWBWCVSXFVECWEFTVBXHXIIWTWHRNLZWHXHXIWRWHWSRNWHVCW
      JVFVDXHXJWHOXIWHVGVHVIVJVOVKVLVMVNVPVQVR $.
  $}

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d T i $.  $d N i j $.
    $( Lemma for ~ ax5seg .  If ` B ` is between ` A ` and ` C ` , and ` A ` is
       distinct from ` B ` , then ` A ` is distinct from ` C ` .  (Contributed
       by Scott Fenton, 11-Jun-2013.) $)
    ax5seglem5 $p |-
        ( ( ( N e. NN /\
            ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) /\
            ( A =/= B /\ T e. ( 0 [,] 1 ) /\
              A. i e. ( 1 ... N )
                ( B ` i ) =
                ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) ) ) ->
         sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( C ` j ) ) ^ 2 ) =/= 0 ) $=
      ( wcel cfv wa wne cc0 c1 co cmul caddc wceq wral wb cc cn cee w3a cicc cv
      cmin cfz c2 cexp csu fveq1 oveq2d eqeq2d ralbidv biimparc simplr1 simplr2
      wi eqeefv syl2anc fveecn sylan cle wbr 0re elicc2i simp1bi recnd ad2antlr
      cr 1re ax-1cn npcan mpan oveq1d mulid2 sylan9eqr subcl adantl simpr simpl
      adddird eqtr3d eqeq1d eqcom syl6bb ralbidva bitrd syl5ibr impr necon3d ex
      exp3a com23 exp4a 3imp2 simplr3 eqeelen necon3bid mpbid ) GUAHZAGUBIZHZBX
      BHZCXBHZUCJZABKZDLMUDNHZEUEZBIZMDUFNZXIAIZONZDXICIZONZPNZQZEMGUGNZRZUCZJZ
      ACKZXRFUEZAIYCCIUFNUHUINFUJZLKXFXGXHXSYBXFXGXHXSYBXFXHXSJZXGYBXFYEXGYBURX
      FYEJACABXFXHXSACQZABQZURXFXHJZXSYFYGXSYFJYGYHXJXMDXLONZPNZQZEXRRZYFYLXSYF
      YKXQEXRYFYJXPXJYFYIXOXMPYFXLXNDOXIACUKULULUMUNUOYHYGXLXJQZEXRRZYLYHXCXDYG
      YNSXCXDXEXAXHUPZXCXDXEXAXHUQABEGUSUTYHYMYKEXRYHXIXRHZJZYMYJXJQZYKYQXLTHZD
      THZYMYRSYHXCYPYSYOAXIGVAVBXHYTXFYPXHDXHDVJHLDVCVDDMVCVDLMDVEVKVFVGVHVIYSY
      TJZXLYJXJUUAXKDPNZXLONZXLYJYTYSUUCMXLONXLYTUUBMXLOMTHZYTUUBMQVLMDVMVNVOXL
      VPVQUUAXKDXLYTXKTHZYSUUDYTUUEVLMDVRVNVSYSYTVTYSYTWAWBWCWDUTYJXJWEWFWGWHWI
      WMWJWKWLWNWOWPYAACYDLYAXCXEYFYDLQSXCXDXEXAXTUPXCXDXEXAXTWQACFGWRUTWSWT $.
  $}

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d D i j $.  $d E i j $.
    $d F i j $.  $d N i j $.  $d S i j $.  $d T i j $.
    $( Lemma for ~ ax5seg .  Given two line segments that are divided into
       pieces, if the pieces are congruent, then the scaling constant is the
       same.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    ax5seglem6 $p |-
        ( ( ( N e. NN /\
            ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
              ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ) /\
            ( A =/= B /\ ( T e. ( 0 [,] 1 ) /\ S e. ( 0 [,] 1 ) ) /\
              ( A. i e. ( 1 ... N )
                ( B ` i ) =
                ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) /\
                A. i e. ( 1 ... N )
                ( E ` i ) =
                ( ( ( 1 - S ) x. ( D ` i ) ) + ( S x. ( F ` i ) ) ) ) ) /\
            ( <. A , B >. Cgr <. D , E >. /\
              <. B , C >. Cgr <. E , F >. ) ) -> T = S ) $=
      ( vj wcel cfv wa cc0 c1 co cmin cmul wceq cn cee w3a wne cicc cv cfz wral
      caddc cop ccgr wbr c2 cexp csu simp22l cle 0re 1re elicc2i simp1bi resqcl
      cr cc recnd 3syl simp22r fzfid simprl1 3ad2ant1 fveecn sylan subcld sqcld
      simprl3 fsumcl simp1l simp1rl simp21 simp23l ax5seglem5 simp3l wb simprl2
      syl23anc simprr1 simprr2 brcgr mpbid ax5seglem1 syl122anc simprr3 simp23r
      syl22anc 3eqtr3d simp1rr simp22 simp23 simp3r ax5seglem3 syl322anc oveq2d
      eqtr4d mulcan2ad simp2bi jca syl sq11 syl2anc ) JUALZAJUBMZLZBXKLZCXKLZUC
      ZDXKLZHXKLZIXKLZUCZNZNZABUDZFOPUEQZLZEYCLZNZGUFZBMPFRQYGAMSQFYGCMSQUIQTGP
      JUGQZUHZYGHMPERQYGDMSQEYGIMSQUIQTGYHUHZNZUCZABUJDHUJUKULZBCUJHIUJUKULZNZU
      CZFUMUNQZEUMUNQZTZFETZYPYQYRYHKUFZAMZUUACMZRQZUMUNQZKUOZYPYDFVCLZYQVDLYDY
      EYBYKYAYOUPZYDUUGOFUQULZFPUQULZOPFURUSUTZVAZUUGYQFVBVEVFYPYEEVCLZYRVDLYDY
      EYBYKYAYOVGZYEUUMOEUQULZEPUQULZOPEURUSUTZVAZUUMYREVBVEVFYPYHUUEKYPPJVHYPU
      UAYHLZNZUUDUUTUUBUUCYPXLUUSUUBVDLYAYLXLYOXLXMXNXSXJVIZVJZAUUAJVKVLYPXNUUS
      UUCVDLYAYLXNYOXLXMXNXSXJVOVJZCUUAJVKVLVMVNVPYPXJXOYBYDYIUUFOUDXJXTYLYOVQZ
      XOXSXJYLYOVRZYAYBYFYKYOVSUUHYIYJYBYFYAYOVTZABCFGKJWAWEYPYQUUFSQZYRYHUUADM
      ZUUAIMRQUMUNQKUOZSQZYRUUFSQYPYHUUBUUABMRQUMUNQKUOZYHUVHUUAHMRQUMUNQKUOZUV
      GUVJYPYMUVKUVLTZYAYLYMYNWBZYAYLYMUVMWCZYOYAXLXMXPXQUVOUVAXLXMXNXSXJWDXPXQ
      XRXOXJWFZXPXQXRXOXJWGABDHKJWHWNVJWIYPXJXLXNYDYIUVKUVGTUVDUVBUVCUUHUVFABCF
      GKJWJWKYPXJXPXRYEYJUVLUVJTUVDYAYLXPYOUVPVJYAYLXRYOXPXQXRXOXJWLVJUUNYIYJYB
      YFYAYOWMDHIEGKJWJWKWOYPUUFUVIYRSYPXJXOXSYFYKYMYNUUFUVITUVDUVEXOXSXJYLYOWP
      YAYBYFYKYOWQYAYBYFYKYOWRUVNYAYLYMYNWSABCDEFGKHIJWTXAXBXCXDYPUUGUUINZUUMUU
      ONZYSYTWCYPYDUVQUUHYDUUGUUIUULYDUUGUUIUUJUUKXEXFXGYPYEUVRUUNYEUUMUUOUURYE
      UUMUUOUUPUUQXEXFXGFEXHXIWI $.
  $}

  ${
    ax5seglem7.1 $e |- A e. CC $.
    ax5seglem7.2 $e |- T e. CC $.
    ax5seglem7.3 $e |- C e. CC $.
    ax5seglem7.4 $e |- D e. CC $.
    $( Lemma for ~ ax5seg .  An algebraic calculation needed further down the
       line.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    ax5seglem7 $p |- ( T x. ( ( C - D ) ^ 2 ) ) =
       ( ( ( ( ( ( 1 - T ) x. A ) + ( T x. C ) ) - D ) ^ 2 ) +
         ( ( 1 - T ) x.
           ( ( T x. ( ( A - C ) ^ 2 ) ) - ( ( A - D ) ^ 2 ) ) ) ) $=
      ( cmin co c2 cexp cmul caddc oveq2i 2cn mulcli subcli cc wcel adddii wceq
      c1 binom2subi sqcli subdii oveq1i 3eqtri cc0 ax-1cn addcli subadd23 mp3an
      binom2i addsubassi addsubi 3eqtr4i eqtri oveq12i addsub4i subdiri mulid2i
      eqtr4i subsub3 subsub4 3eqtr2i addassi add32i subsub2 cneg addcomi sqmuli
      addsub12 sqvali mulassi mul12i mulcomi eqtr3i eqeltrri 3eqtrri negsubdi2i
      sub32 subsub mulneg2i negsubi subeq0i mpbir addid2i ) DBCIJKLJZMJZDBKLJZM
      JZDKBCMJZMJZMJZIJZDCKLJZMJZNJZUCDIJZAMJZDBMJZNJCIJZKLJZWTDABIJKLJZMJZACIJ
      KLJZIJZMJZNJZWJDWKWNIJZWQNJZMJDXKMJZWRNJWSWIXLDMBCGHUDODXKWQFWKWNBGUEZKWM
      PBCGHQZQZRCHUEZUAXMWPWRNDWKWNFXNXPUFUGUHXJXAKLJZKXAXBCIJZMJZMJZNJZXBKLJZW
      QNJZNJZWTDAKLJZKABMJZMJZIJZMJZYFKACMJZMJZIJZIJZMJZWQDWLMJZNJZIJZNJZWLWRNJ
      ZKXBCMJZMJZIJZNJZUIWSNJWSYEUUBIJZYTNJZYRNJZYEUUCNJZYRNJXJUUDUUFUUHYRNYEST
      ZUUBSTYTSTZUUFUUHUBYBYDXRYAXAWTAUCDUJFRZEQZUEKXTPXAXSUULXBCDBFGQZHRZQQUKZ
      YCWQXBUUMUEZXQUKZUKZKUUAPXBCUUMHQQZWLWRDWKFXNQZDWQFXQQZUKZYEUUBYTULUMUGXJ
      UUEYTYRNJZNJUUGXDUUEXIUVCNXAXSNJZKLJYBXSKLJZNJZXDUUEXAXSUULUUNUNXCUVDKLXA
      XBCUULUUMHUOUGUUEYBYDUUBIJZNJUVFYBYDUUBUUOUUQUUSUOUVEUVGYBNUVEYCUUBIJWQNJ
      UVGXBCUUMHUDYCWQUUBUUPXQUUSUPVCOVCUQXIWTYNWLWQIJZNJZMJYOWTUVHMJZNJZUVCXHU
      VIWTMXHYJWLNJZYMWQNJZIJUVIXFUVLXGUVMIXFDYIWKNJZMJUVLXEUVNDMABEGUDODYIWKFY
      FYHAEUEZKYGPABEGQQZRZXNUAURACEHUDUSYJWLYMWQDYIFUVQQZUUTYFYLUVOKYKPACEHQQZ
      RZXQUTUROWTYNUVHUUKYJYMUVRUVTRZWLWQUUTXQRZUAUVKYOYTYQIJZNJZUVCUVJUWCYONUV
      JUCUVHMJZDUVHMJZIJUVHYPWRIJZIJZUWCUCDUVHUJFUWBVAUWEUVHUWFUWGIUVHUWBVBDWLW
      QFUUTXQUFUSUWHUVHWRNJZYPIJZYTWQIJZYPIJZUWCUVHSTYPSTZWRSTUWHUWJUBUWBDWLFUU
      TQZUVAUVHYPWRVDUMUWKUWIYPIWLWRWQUUTUVAXQUPUGUUJWQSTUWMUWLUWCUBUVBXQUWNYTW
      QYPVEUMVFUHOYOSTZUUJYQSTZUWDUVCUBWTYNUUKUWAQZUVBWQYPXQUWNUKZYOYTYQVMUMURU
      HUSUUEYTYRYEUUBUURUUSRUVBYOYQUWQUWRRZVGVCYEYRUUCUURUWSYTUUBUVBUUSRVHUQYSU
      IUUCWSNYEYQYOIJZIJZYSUIUUIUWPUWOUXAYSUBUURUWRUWQYEYQYOVIUMUXAUIUBYEUWTUBY
      BYCNJZWQNJZYEUWTYBYCWQUUOUUPXQVGWQUXBNJWQYPYOIJZNJUXCUWTUXBUXDWQNUXBYCYBN
      JYPYOVJZNJUXDYBYCUUOUUPVKYCYPYBUXENYCDKLJZWKMJDDMJZWKMJYPDBFGVLUXFUXGWKMD
      FVNUGDDWKFFXNVOUHYBWTYMYJIJZMJZWTYNVJZMJUXEYBWTYFDYFMJZIJZMJZWTDYHMJZYLIJ
      ZMJZNJWTUXLUXONJZMJUXIXRUXMYAUXPNXRWTKLJZYFMJWTWTMJZYFMJZUXMWTAUUKEVLUXRU
      XSYFMWTUUKVNUGUXTWTWTYFMJZMJUXMWTWTYFUUKUUKUVOVOUYAUXLWTMUYAUCYFMJZUXKIJU
      XLUCDYFUJFUVOVAUYBYFUXKIYFUVOVBUGUROURUHYAXAKXSMJZMJWTAUYCMJZMJUXPKXAXSPU
      ULUUNVPWTAUYCUUKEKXSPUUNQVOUYDUXOWTMKAMJZXSMJZUYDUXOAKMJZXSMJUYFUYDUYGUYE
      XSMAKEPVQUGAKXSEPUUNVOVRUYFUYEXBMJZUYECMJZIJUXOUYEXBCKAPEQZUUMHUFUYHUXNUY
      IYLIUYHDUYEBMJZMJUXNUYEDBUYJFGVPUYKYHDMKABPEGVOOURKACPEHVOUSURVROUHUSWTUX
      LUXOUUKYFUXKUVODYFFUVOQZRZUXNYLDYHFUVPQZUVSRUAUXQUXHWTMUXHYFUXKUXNIJZIJZY
      LIJZUXLUXNNJZYLIJUXQUXHYMUYOIJZUYQYJUYOYMIDYFYHFUVOUVPUFZOYFSTZUYOSTYLSTU
      YQUYSUBUVOYJUYOSUYTUVRVSUVSYFUYOYLWBUMVCUYPUYRYLIVUAUXKSTUXNSTUYPUYRUBUVO
      UYLUYNYFUXKUXNWCUMUGUXLUXNYLUYMUYNUVSUOVTOVFUXJUXHWTMYJYMUVRUVTWAOWTYNUUK
      UWAWDVFUSYPYOUWNUWQWEUHOUXBWQYBYCUUOUUPUKXQVKWQYPYOXQUWNUWQUOUQVRYEUWTUUR
      YQYOUWRUWQRWFWGVRUUCYTWOIJWSUUBWOYTIUUBKDWMMJZMJWOUUAVUBKMDBCFGHVOOKDWMPF
      XOVPUROWLWRWOUUTUVADWNFXPQZUPURUSWSWPWRWLWOUUTVUCRUVAUKWHUHVC $.
  $}

  $( Lemma for ~ ax5seg .  Use the weak deduction theorem to eliminate the
     hypotheses from ~ ax5seglem7 .  (Contributed by Scott Fenton,
     11-Jun-2013.) $)
  ax5seglem8 $p |- ( ( ( A e. CC /\ T e. CC ) /\ ( C e. CC /\ D e. CC ) ) ->
       ( T x. ( ( C - D ) ^ 2 ) ) =
       ( ( ( ( ( ( 1 - T ) x. A ) + ( T x. C ) ) - D ) ^ 2 ) +
         ( ( 1 - T ) x.
           ( ( T x. ( ( A - C ) ^ 2 ) ) - ( ( A - D ) ^ 2 ) ) ) ) ) $=
    ( cc wcel cmin co c2 cexp cmul caddc wceq cc0 cif oveq2 oveq1d oveq1 oveq2d
    oveq12d c1 eqeq2d eqeq12d 0cn elimel ax5seglem7 dedth4h ) AEFZDEFZBEFZCEFZD
    BCGHZIJHZKHZUADGHZAKHZDBKHZLHZCGHZIJHZUODABGHZIJHZKHZACGHZIJHZGHZKHZLHZMUNU
    OUHANOZKHZUQLHZCGHZIJHZUODVIBGHZIJHZKHZVICGHZIJHZGHZKHZLHZMUIDNOZUMKHZUAWBG
    HZVIKHZWBBKHZLHZCGHZIJHZWDWBVOKHZVRGHZKHZLHZMWBUJBNOZCGHZIJHZKHZWEWBWNKHZLH
    ZCGHZIJHZWDWBVIWNGHZIJHZKHZVRGHZKHZLHZMWBWNUKCNOZGHZIJHZKHZWSXHGHZIJHZWDXDV
    IXHGHZIJHZGHZKHZLHZMADBCNNNNAVIMZVHWAUNXSUTVMVGVTLXSUSVLIJXSURVKCGXSUPVJUQL
    AVIUOKPQQQXSVFVSUOKXSVCVPVEVRGXSVBVODKXSVAVNIJAVIBGRQSXSVDVQIJAVICGRQTSTUBD
    WBMZUNWCWAWMDWBUMKRXTVMWIVTWLLXTVLWHIJXTVKWGCGXTVJWEUQWFLXTUOWDVIKDWBUAGPZQ
    DWBBKRTQQXTUOWDVSWKKYAXTVPWJVRGDWBVOKRQTTUCBWNMZWCWQWMXGYBUMWPWBKYBULWOIJBW
    NCGRQSYBWIXAWLXFLYBWHWTIJYBWGWSCGYBWFWRWELBWNWBKPSQQYBWKXEWDKYBWJXDVRGYBVOX
    CWBKYBVNXBIJBWNVIGPQSQSTUCCXHMZWQXKXGXRYCWPXJWBKYCWOXIIJCXHWNGPQSYCXAXMXFXQ
    LYCWTXLIJCXHWSGPQYCXEXPWDKYCVRXOXDGYCVQXNIJCXHVIGPQSSTUCVIWNXHWBANEUDUEDNEU
    DUEBNEUDUECNEUDUEUFUG $.

  ${
    $d A i j $.  $d B i j $.  $d C i j $.  $d D i j $.  $d N i j $.
    $d T i j $.
    $( Lemma for ~ ax5seg .  Take the calculation in ~ ax5seglem8 and turn it
       into a series of measurements.  (Contributed by Scott Fenton,
       12-Jun-2013.)  (Revised by Mario Carneiro, 22-May-2014.) $)
    ax5seglem9 $p |- ( ( ( N e. NN /\
            ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
              ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ) /\
            ( T e. ( 0 [,] 1 ) /\
              A. i e. ( 1 ... N )
                ( B ` i ) =
                ( ( ( 1 - T ) x. ( A ` i ) ) + ( T x. ( C ` i ) ) ) ) ) ->
         ( T x. sum_ j e. ( 1 ... N ) ( ( ( C ` j ) - ( D ` j ) ) ^ 2 ) ) =
         ( sum_ j e. ( 1 ... N ) ( ( ( B ` j ) - ( D ` j ) ) ^ 2 ) +
           ( ( 1 - T ) x.
             ( ( T x. sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( C ` j ) ) ^ 2 ) )
               -
             sum_ j e. ( 1 ... N ) ( ( ( A ` j ) - ( D ` j ) ) ^ 2 ) ) ) ) ) $=
      ( wcel cfv wa c1 co cmin cmul caddc c2 cexp csu cc cn cee cc0 cicc cv cfz
      wceq wral fzfid cr cle wbr 0re 1re elicc2i simp1bi recnd ad2antrl simprrl
      ad2antrr fveecn simprrr subcld sqcld simprll oveq1d adantr mulcld fsumsub
      sylancom fsummulc2 eqtr4d oveq2d ax-1cn subcl sylancr eqtrd simprlr fveq2
      fsumadd oveq12d eqeq12d rspccva adantll ax5seglem8 oveq1 eqcomd syl221anc
      sylan9eq 3impa sumeq2dv ) HUAIZAHUBJZIZBWMIZKZCWMIZDWMIZKZKKZEUCLUDMIZFUE
      ZBJZLENMZXBAJZOMZEXBCJZOMZPMZUGZFLHUFMZUHZKZKZEXKGUEZCJZXODJZNMZQRMZGSOMX
      KEXSOMZGSZXKXOBJZXQNMZQRMZGSZXDEXKXOAJZXPNMZQRMZGSOMZXKYFXQNMZQRMZGSZNMZO
      MZPMZXNXKXSEGXNLHUIZXAETIZWTXLXAEXAEUJIUCEUKULELUKULUCLEUMUNUOUPUQURZXNXO
      XKIZKZXRYTXPXQXNYSWQXPTIZWTWQXMYSWLWPWQWRUSUTCXOHVAVJZXNYSWRXQTIZWTWRXMYS
      WLWPWQWRVBUTDXOHVAVJZVCVDVKXNYOXKYDXDEYHOMZYKNMZOMZPMZGSZYAXNYOYEXKUUGGSZ
      PMUUIXNYNUUJYEPXNYNXDXKUUFGSZOMUUJXNYMUUKXDOXNYMXKUUEGSZYLNMUUKXNYIUULYLN
      XNXKYHEGYPYRYTYGYTYFXPXNYSWNYFTIZWTWNXMYSWLWNWOWSVEUTAXOHVAVJZUUBVCVDZVKV
      FXNXKUUEYKGYPYTEYHXNYQYSYRVGZUUOVHZYTYJYTYFXQUUNUUDVCVDZVIVLVMXNXKUUFXDGY
      PXNLTIZYQXDTIZVNYRLEVOZVPYTUUEYKUUQUURVCZVKVQVMXNXKYDUUGGYPYTYCYTYBXQXNYS
      WOYBTIWTWOXMYSWLWNWOWSVRUTBXOHVAVJUUDVCVDYTXDUUFYTUUSYQUUTVNUUPUVAVPUVBVH
      VTVLXNXKXTUUHGYTUUMYQUUAUUCYBXDYFOMZEXPOMZPMZUGZXTUUHUGZUUNUUPUUBUUDXMYSU
      VFWTXLYSUVFXAXJUVFFXOXKXBXOUGZXCYBXIUVEXBXOBVSUVHXFUVCXHUVDPUVHXEYFXDOXBX
      OAVSVMUVHXGXPEOXBXOCVSVMWAWBWCWDWDUUMYQKZUUAUUCKZUVFUVGUVIUVJKUVFXTUVEXQN
      MZQRMZUUGPMZUUHYFXPXQEWEUVFUUHUVMUVFYDUVLUUGPUVFYCUVKQRYBUVEXQNWFVFVFWGWI
      WJWHWKVLVL $.
  $}

  ${
    $d A i j t s $.  $d B i j t s $.  $d C i j t s $.  $d D i j t s $.
    $d E i j t s $.  $d F i j t s $.  $d G i j t s $.  $d H i j t s $.
    $d N i j t s $.
    $( The five segment axiom.  Take two triangles ` A D C ` and ` E H G ` , a
       point ` B ` on ` A C ` , and a point ` F ` on ` E G ` .  If all
       corresponding line segments except for ` C D ` and ` G H ` are
       congruent, then so are ` C D ` and ` G H ` .  Axiom A5 of [Schwabhauser]
       p. 11.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    ax5seg $p |-
    ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( ( ( A =/= B /\ B Btwn <. A , C >. /\
                     F Btwn <. E , G >. ) /\
        ( <. A , B >. Cgr <. E , F >. /\
          <. B , C >. Cgr <. F , G >. ) /\
        ( <. A , D >. Cgr <. E , H >. /\
          <. B , D >. Cgr <. F , H >. ) ) ->
       <. C , D >. Cgr <. G , H >. ) ) $=
      ( vi vt vj wcel cfv w3a cmin co cmul wa cop vs cn cee wne cv c1 caddc cfz
      wceq wral cc0 cicc wrex ccgr wbr c2 cexp csu cbtwn wi cc fzfid cr simpl21
      fveere sylancom simpl22 resubcld resqcld recnd adantr simpl32 simpl33 cle
      fsumrecl 0re elicc2i simp1bi ad2antrr adantl simpl11 simp12 simp13 simp21
      1re 3ad2ant1 3jca simprrl simp1rl ax5seglem4 syl211anc simpr3r wb simpl13
      simpl31 brcgr syl22anc mpbid simp23 simp31 simp32 simpr1l simprrr simpr2l
      jca simpr2r ax5seglem6 syl232anc oveq2d syl322anc oveq12d simpr3l simpl12
      ax5seglem3 simpl23 simp22 jca32 simp1ll ax5seglem9 3ad2ant3 jca31 simp1lr
      3simpc 3eqtr4d oveq1d eqtr4d mulcanad 3exp2 exp3a rexlimdvv 3impd syl3anc
      brbtwn anbi12d reeanv syl6bbr anbi2d 3anass r19.42v rexbii 3bitr4g simp33
      bitri 3anbi1d 3imtr4d ) IUBMZAIUCNZMZBUUGMZOZCUUGMZDUUGMZEUUGMZOZFUUGMZGU
      UGMZHUUGMZOZOZABUDZJUEZBNUFKUEZPQZUVAANRQUVBUVACNRQUGQUIJUFIUHQZUJZUVAFNU
      FUAUEZPQZUVAENRQUVFUVAGNRQUGQUIJUVDUJZSZSZUAUKUFULQZUMZKUVKUMZABTEFTUNUOZ
      BCTFGTUNUOZSZADTEHTUNUOZBDTFHTUNUOZSZOUVDLUEZCNZUVTDNZPQZUPUQQZLURZUVDUVT
      GNZUVTHNZPQZUPUQQZLURZUIZUUTBACTUSUOZFEGTUSUOZOZUVPUVSOCDTGHTUNUOZUUSUVMU
      VPUVSUWKUUSUVJUVPUVSUWKUTUTZKUAUVKUVKUUSUVBUVKMZUVFUVKMZSZUVJUWPUUSUWSUVJ
      SZUVPUVSUWKUUSUWTUVPUVSOZSZUWEUWJUVBUUSUWEVAMUXAUUSUWEUUSUVDUWDLUUSUFIVBZ
      UUSUVTUVDMZSZUWCUXEUWAUWBUUSUXDUUKUWAVCMUUKUULUUMUUJUURUXDVDCUVTIVEVFUUSU
      XDUULUWBVCMUUKUULUUMUUJUURUXDVGDUVTIVEVFVHVIVOVJVKUUSUWJVAMUXAUUSUWJUUSUV
      DUWILUXCUXEUWHUXEUWFUWGUUSUXDUUPUWFVCMUUOUUPUUQUUJUUNUXDVLGUVTIVEVFUUSUXD
      UUQUWGVCMUUOUUPUUQUUJUUNUXDVMHUVTIVEVFVHVIVOVJVKUXAUVBVAMZUUSUWTUVPUXFUVS
      UWQUXFUWRUVJUWQUVBUWQUVBVCMUKUVBVNUOUVBUFVNUOUKUFUVBVPWEVQVRVJVSWFVTUXBUU
      FUUHUUIUUKOZUVEUUTUVBUKUDUUFUUHUUIUUNUURUXAWAZUUSUXGUXAUUSUUHUUIUUKUUFUUH
      UUIUUNUURWBZUUFUUHUUIUUNUURWCZUUJUUKUULUUMUURWDZWGZVKZUXAUVEUUSUWTUVPUVEU
      VSUWSUUTUVEUVHWHWFVTZUXAUUTUUSUUTUVIUWSUVPUVSWIVTZABCUVBJIWJWKUXBUVBUWERQ
      ZUVFUWJRQZUVBUWJRQUXBUVDUVTBNUWBPQUPUQQLURZUVCUVBUVDUVTANZUWAPQUPUQQLURZR
      QZUVDUXSUWBPQUPUQQLURZPQZRQZUGQZUVDUVTFNUWGPQUPUQQLURZUVGUVFUVDUVTENZUWFP
      QUPUQQLURZRQZUVDUYGUWGPQUPUQQLURZPQZRQZUGQZUXPUXQUXBUXRUYFUYDUYLUGUXBUVRU
      XRUYFUIZUVQUVRUWTUVPUUSWLUXBUUIUULUUOUUQUVRUYNWMUUFUUHUUIUUNUURUXAWNUUKUU
      LUUMUUJUURUXAVGZUUOUUPUUQUUJUUNUXAWOUUOUUPUUQUUJUUNUXAVMZBDFHLIWPWQWRUXBU
      VCUVGUYCUYKRUXBUVBUVFUFPUXBUUFUXGUUMUUOUUPOZSZUUTUWSUVIUVNUVOUVBUVFUIUXHU
      USUYRUXAUUSUXGUYQUXLUUSUUMUUOUUPUUJUUKUULUUMUURWSZUUJUUNUUOUUPUUQWTZUUJUU
      NUUOUUPUUQXAZWGZXEVKUXOUWSUVJUVPUVSUUSXBZUXBUVEUVHUXNUXAUVHUUSUWTUVPUVHUV
      SUWSUUTUVEUVHXCWFVTZXEZUVNUVOUWTUVSUUSXDZUVNUVOUWTUVSUUSXFZABCEUVFUVBJFGI
      XGXHZXIUXBUYAUYIUYBUYJPUXBUVBUVFUXTUYHRVUHUXBUUFUXGUYQUWSUVIUVNUVOUXTUYHU
      IUXHUXMUUSUYQUXAVUBVKVUCVUEVUFVUGABCEUVFUVBJLFGIXNXJXKUXBUVQUYBUYJUIZUVQU
      VRUWTUVPUUSXLUXBUUHUULUUMUUQUVQVUIWMUUFUUHUUIUUNUURUXAXMUYOUUKUULUUMUUJUU
      RUXAXOUYPADEHLIWPWQWRXKXKXKUXBUUFUUHUUISZUUKUULSSZUWQUVEUXPUYEUIUXHUUSVUK
      UXAUUSVUJUUKUULUUSUUHUUIUXIUXJXEUXKUUJUUKUULUUMUURXPZXQVKUXAUWQUUSUWQUWRU
      VJUVPUVSXRVTUXNABCDUVBJLIXSWQUXBUUFUUMUUOSUUPUUQSZSZUWRUVHUXQUYMUIUXHUUSV
      UNUXAUUSUUMUUOVUMUYSUYTUURUUJVUMUUNUUOUUPUUQYCXTYAVKUXAUWRUUSUWQUWRUVJUVP
      UVSYBVTVUDEFGHUVFJLIXSWQYDUXBUVBUVFUWJRVUHYEYFYGYHYIYJYKUUSUWNUVMUVPUVSUU
      SUUTUWLUWMSZSUUTUVIUAUVKUMZKUVKUMZSZUWNUVMUUSVUOVUQUUTUUSVUOUVEKUVKUMZUVH
      UAUVKUMZSVUQUUSUWLVUSUWMVUTUUSUUIUUHUUKUWLVUSWMUXJUXIUXKKBACJIYMYLUUSUUOU
      UMUUPUWMVUTWMUYTUYSVUAUAFEGJIYMYLYNUVEUVHKUAUVKUVKYOYPYQUUTUWLUWMYRUVMUUT
      VUPSZKUVKUMVURUVLVVAKUVKUUTUVIUAUVKYSYTUUTVUPKUVKYSUUCUUAUUDUUSUUKUULUUPU
      UQUWOUWKWMUXKVULVUAUUJUUNUUOUUPUUQUUBCDGHLIWPWQUUE $.
  $}

  ${
    $d N t i $.  $d A t i $.  $d B t i $.
    $( Points are indivisible.  That is, if ` A ` lies between ` B ` and
       ` B ` , then ` A = B ` .  Axiom A6 of [Schwabhauser] p. 11.
       (Contributed by Scott Fenton, 3-Jun-2013.) $)
    axbtwnid $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
     ( A Btwn <. B , B >. -> A = B ) ) $=
      ( vi vt wcel cfv wbr cv c1 co cmul caddc wceq wral cc0 wb cc cle wa cbtwn
      cn cee w3a cop cmin cfz cicc simp2 simp3 brbtwn syl3anc wi cr 0re elicc2i
      wrex 1re simp1bi recnd eqeefv 3adant1 adantr ax-1cn npcan ad2antlr oveq1d
      mpan subcl simplr simpll3 fveecn sylancom adddird mulid2d 3eqtr3rd eqeq2d
      ralbidva bitrd biimprd sylan2 rexlimdva sylbid ) CUBFZACUCGZFZBWEFZUDZABB
      UEUAHZDIZAGZJEIZUFKZWJBGZLKWLWNLKMKZNZDJCUGKZOZEPJUHKZUQZABNZWHWFWGWGWIWT
      QWDWFWGUIWDWFWGUJZXBEABBDCUKULWHWRXAEWSWLWSFZWHWLRFZWRXAUMXCWLXCWLUNFPWLS
      HWLJSHPJWLUOURUPUSUTWHXDTZXAWRXEXAWKWNNZDWQOZWRWHXAXGQZXDWFWGXHWDABDCVAVB
      VCXEXFWPDWQXEWJWQFZTZWNWOWKXJWMWLMKZWNLKJWNLKWOWNXJXKJWNLXDXKJNZWHXIJRFZX
      DXLVDJWLVEVHVFVGXJWMWLWNXDWMRFZWHXIXMXDXNVDJWLVIVHVFWHXDXIVJXEXIWGWNRFWDW
      FWGXDXIVKBWJCVLVMZVNXJWNXOVOVPVQVRVSVTWAWBWC $.
  $}

  ${
    $d T p r $.  $d S p r $.
    $( Lemma for ~ axpasch .  Set up coefficents used in the proof.
       (Contributed by Scott Fenton, 5-Jun-2013.) $)
    axpaschlem $p |- ( ( T e. ( 0 [,] 1 ) /\ S e. ( 0 [,] 1 ) ) ->
       E. r e. ( 0 [,] 1 ) E. p e. ( 0 [,] 1 )
       ( p = ( ( 1 - r ) x. ( 1 - T ) ) /\
         r = ( ( 1 - p ) x. ( 1 - S ) ) /\
         ( ( 1 - r ) x. T ) = ( ( 1 - p ) x. S ) ) ) $=
      ( cc0 c1 co wcel cmin cmul wceq cr 1re cle recnd oveq2 oveq1d eqeq2d cdiv
      wbr cicc wa cv w3a wi 0re elicc2i simp1bi ad2antrl resubcl sylancr mul02d
      eqcomd ad2antll mulid2d adantr ax-1cn subid1i syl6eq eqtr2d mul01i eqtr4d
      wrex 1elunit 0elunit 1m1e0 eqeq1 eqeq1d 3anbi123d rspc2ev mp3an12 syl3anc
      wne caddc remulcld resubcld readdcld clt simp2bi simp3bi lemul1ad breqtrd
      ex simpl ne0gt0d ltaddpos2d mpbid lelttrd posdifd gt0ne0d redivcld mpbird
      a1i divge0 syl22anc ltled lesub1dd breqtrrd ledivmul2 syl112anc syl3anbrc
      subge0d wb lemul2ad mulid1d addge01d div23d cc subdi mp3an2 syl2anc eqtrd
      divsubdird nnncan2d 3eqtr3d mulcomd oveq12d pncan2d syl113anc pm2.61ine
      pncand dividd ) BEFUAGZHZAYCHZUBZDUCZFCUCZIGZFBIGZJGZKZYHFYGIGZFAIGZJGZKZ
      YIBJGZYMAJGZKZUDZDYCVCCYCVCZUEAEAEKZYFUUAUUBYFUBZEEYJJGZKZFFYNJGZKZEBJGZF
      AJGZKZUUAUUCUUDEUUCYJUUCYJUUCFLHZBLHZYJLHZMYDUULUUBYEYDUULEBNTZBFNTZEFBUF
      MUGZUHZUIZFBUJZUKOULUMUUCUUFYNFUUCYNUUCYNUUCUUKALHZYNLHZMYEUUTUUBYDYEUUTE
      ANTZAFNTZEFAUFMUGZUHZUNFAUJZUKOUOUUCYNFEIGZFUUBYNUVGKYFAEFIPUPFUQURZUSUTU
      UCUUHEUUIUUCBUUCBUUROULUUCUUIFEJGZEUUBUUIUVIKYFAEFJPUPFUQVAUSVBFYCHEYCHUU
      EUUGUUJUDZUUAVDVEYTUVJYGUUDKZFYOKZUUHYRKZUDCDFEYCYCYHFKZYLUVKYPUVLYSUVMUV
      NYKUUDYGUVNYIEYJJUVNYIFFIGEYHFFIPVFUSZQRYHFYOVGUVNYQUUHYRUVNYIEBJUVOQVHVI
      YGEKZUVKUUEUVLUUGUVMUUJYGEUUDVGUVPYOUUFFUVPYMFYNJUVPYMUVGFYGEFIPUVHUSZQRU
      VPYRUUIUUHUVPYMFAJUVQQRVIVJVKVLWCAEVMZYFUUAUVRYFUBZBABJGZIGZABVNGZUVTIGZS
      GZYCHZAUVTIGZUWCSGZYCHZUWGFUWDIGZYJJGZKZUWDFUWGIGZYNJGZKZUWIBJGZUWLAJGZKZ
      UUAUVSUWDLHEUWDNTZUWDFNTZUWEUVSUWAUWCUVSBUVTYDUULUVRYEUUQUIZUVSABYEUUTUVR
      YDUVEUNZUWTVOZVPZUVSUWBUVTUVSABUXAUWTVQZUXBVPZUVSUWCUVSUVTUWBVRTEUWCVRTZU
      VSUVTBUWBUXBUWTUXDUVSUVTFBJGBNUVSAFBUXAUUKUVSMWMZUWTYDUUNUVRYEYDUULUUNUUO
      UUPVSUIZYEUVCUVRYDYEUUTUVBUVCUVDVTUNWAUVSBUVSBUWTOZUOWBZUVSEAVRTBUWBVRTUV
      SAUXAYEUVBUVRYDYEUUTUVBUVCUVDVSUNZUVRYFWDWEUVSABUXAUWTWFWGZWHUVSUVTUWBUXB
      UXDWIWGZWJZWKUVSUWALHZEUWANTZUWCLHZUXFUWRUXCUVSUXPUVTBNTUXJUVSBUVTUWTUXBX
      BWLUXEUXMUWAUWCWNWOUVSUWSUWAFUWCJGZNTZUVSUWAUWCUXRNUVSBUWBUVTUWTUXDUXBUVS
      BUWBUWTUXDUXLWPWQUVSUWCUVSUWCUXEOZUOZWRUVSUXOUUKUXQUXFUWSUXSXCUXCUXGUXEUX
      MUWAFUWCWSWTWLEFUWDUFMUGXAUVSUWGLHEUWGNTZUWGFNTZUWHUVSUWFUWCUVSAUVTUXAUXB
      VPZUXEUXNWKUVSUWFLHZEUWFNTZUXQUXFUYBUYDUVSUYFUVTANTUVSUVTAFJGZANUVSBFAUWT
      UXGUXAUXKYDUUOUVRYEYDUULUUNUUOUUPVTUIXDUVSAUVSAUXAOZXEZWBUVSAUVTUXAUXBXBW
      LUXEUXMUWFUWCWNWOUVSUYCUWFUXRNTZUVSUWFUWCUXRNUVSAUWBUVTUXAUXDUXBUVSUUNAUW
      BNTUXHUVSABUXAUWTXFWGWQUYAWRUVSUYEUUKUXQUXFUYCUYJXCUYDUXGUXEUXMUWFFUWCWSW
      TWLEFUWGUFMUGXAUVSAYJJGZUWCSGAUWCSGZYJJGUWGUWJUVSAYJUWCUYHUVSYJUVSUUKUULU
      UMMUWTUUSUKOUXTUXNXGUVSUYKUWFUWCSUVSUYKUYGUVTIGZUWFUVSAXHHZBXHHZUYKUYMKZU
      YHUXIUYNFXHHZUYOUYPUQAFBXIXJXKUVSUYGAUVTIUYIQXLQUVSUYLUWIYJJUVSUWCUWAIGZU
      WCSGUWCUWCSGZUWDIGUYLUWIUVSUWCUWAUWCUXTUVSUWAUXCOUXTUXNXMUVSUYRAUWCSUVSUY
      RUWBBIGAUVSUWBBUVTUVSUWBUXDOZUXIUVSUVTUXBOZXNUVSABUYHUXIYAXLQUVSUYSFUWDIU
      VSUWCUXTUXNYBZQXOZQXOUVSBYNJGZUWCSGBUWCSGZYNJGUWDUWMUVSBYNUWCUXIUVSYNUVSU
      UKUUTUVAMUXAUVFUKOUXTUXNXGUVSVUDUWAUWCSUVSVUDBFJGZBAJGZIGZUWAUVSUYOUYNVUD
      VUHKZUXIUYHUYOUYQUYNVUIUQBFAXIXJXKUVSVUFBVUGUVTIUVSBUXIXEUVSBAUXIUYHXPXQX
      LQUVSVUEUWLYNJUVSUWCUWFIGZUWCSGUYSUWGIGVUEUWLUVSUWCUWFUWCUXTUVSUWFUYDOUXT
      UXNXMUVSVUJBUWCSUVSVUJUWBAIGBUVSUWBAUVTUYTUYHVUAXNUVSABUYHUXIXRXLQUVSUYSF
      UWGIVUBQXOZQXOUVSUVTUWCSGZVUGUWCSGZUWOUWPUVSUVTVUGUWCSUVSABUYHUXIXPQUVSVU
      LUYLBJGUWOUVSABUWCUYHUXIUXTUXNXGUVSUYLUWIBJVUCQXLUVSVUMVUEAJGUWPUVSBAUWCU
      XIUYHUXTUXNXGUVSVUEUWLAJVUKQXLXOYTUWKUWNUWQUDYGUWJKZUWDYOKZUWOYRKZUDCDUWD
      UWGYCYCYHUWDKZYLVUNYPVUOYSVUPVUQYKUWJYGVUQYIUWIYJJYHUWDFIPZQRYHUWDYOVGVUQ
      YQUWOYRVUQYIUWIBJVURQVHVIYGUWGKZVUNUWKVUOUWNVUPUWQYGUWGUWJVGVUSYOUWMUWDVU
      SYMUWLYNJYGUWGFIPZQRVUSYRUWPUWOVUSYMUWLAJVUTQRVIVJXSWCXT $.
  $}

  ${
    $d A i $.  $d A q $.  $d A r $.  $d B i $.  $d B q $.  $d B r $.  $d C i $.
    $d C q $.  $d C r $.  $d i q $.  $d i r $.  $d i s $.  $d i t $.  $d N i $.
    $d N q $.  $d N r $.  $d q r $.  $d q s $.  $d q t $.  $d r s $.  $d r t $.
    $d A s $.  $d A t $.  $d A x $.  $d B s $.  $d B t $.  $d B x $.  $d C s $.
    $d C t $.  $d C x $.  $d D i $.  $d D q $.  $d D r $.  $d D s $.  $d D t $.
    $d D x $.  $d E i $.  $d E q $.  $d E r $.  $d E s $.  $d E t $.  $d E x $.
    $d i x $.  $d N s $.  $d N t $.  $d N x $.  $d q x $.  $d r x $.  $d s t $.
    $d s x $.  $d t x $.  $d A k $.  $d B k $.  $d C k $.  $d i k $.  $d k q $.
    $d k r $.  $d k s $.  $d k t $.  $d k x $.  $d N k $.  $d D k $.  $d E k $.

    $( The inner Pasch axiom.  Take a triangle ` A C E ` , a point ` D ` on
       ` A C ` , and a point ` B ` extending ` C E ` .  Then ` A E ` and
       ` D B ` intersect at some point ` x ` .  Axiom A7 of [Schwabhauser]
       p. 12.  (Contributed by Scott Fenton, 3-Jun-2013.) $)
    axpasch $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) ->
       ( ( D Btwn <. A , C >. /\ E Btwn <. B , C >. ) ->
         E. x e. ( EE ` N ) ( x Btwn <. D , B >. /\
                              x Btwn <. E , A >. ) ) ) $=
      ( vi vr vq wcel wa c1 co cmul caddc wrex cr recnd remulcld vt cee cfv w3a
      vs vk cn cv cmin wceq cfz wral cc0 cicc cop cbtwn wbr axpaschlem 3ad2ant3
      wi simp1 oveq1d eqcomd simp2 oveq12d simp3 adantr 1re simpl2l cle elicc2i
      0re simp1bi resubcl sylancr simp13l simp121 fveere simp123 adddid mulassd
      syl sylan cc fveecn eqtr4d simp122 add32d simpl2r simp13r addcomd 3eqtr4d
      oveq2d ralrimiva 3expia anassrs reximdva mpd cmpt simplrl simpl3l simpl21
      eqtrd simpl23 readdcld simpl22 wb simpll1 mptelee mpbird fveq1 fveq2 eqid
      ovex fvmpt sylan9eq eqeq1d anbi12d biantrur ralbidva rspcev rexcom rexbii
      syl6bbr bitri sylib oveq2 eqeq2d bi2anan9 ralimi ralbi rexbidv syl5ibrcom
      ex 2rexbidv brbtwn syl3anc r19.26 2rexbii reeanv rexlimdvv 3adant3 simp3l
      simp21 simp23 simp3r simp22 simpr simpl3r rexbidva 3imtr4d ) GUGKZBGUBUCZ
      KZCUUMKZDUUMKZUDZEUUMKZFUUMKZLZUDZHUHZEUCZMUAUHZUINZUVBBUCZONZUVDUVBDUCZO
      NZPNZUJZUVBFUCZMUEUHZUINZUVBCUCZONZUVMUVHONZPNZUJZLZHMGUKNZULZUEUMMUNNZQU
      AUWCQZUVBAUHZUCZMIUHZUINZUVCONZUWGUVOONZPNZUJZUWFMJUHZUINZUVLONZUWMUVFONZ
      PNZUJZLZHUWAULZJUWCQZIUWCQZAUUMQZEBDUOUPUQZFCDUOUPUQZLZUWEECUOUPUQZUWEFBU
      OUPUQZLZAUUMQUULUUQUWDUXCUTUUTUULUUQLUWBUXCUAUEUWCUWCUULUUQUVDUWCKZUVMUWC
      KZLZUWBUXCUTUULUUQUXLUDZUXCUWBUWFUWHUVJONZUWJPNZUJZUWFUWNUVRONZUWPPNZUJZL
      ZHUWAULZJUWCQZIUWCQAUUMQZUXMUYAAUUMQZJUWCQZIUWCQZUYCUXMUXOUXRUJZHUWAULZJU
      WCQZIUWCQZUYFUXMUWMUWHUVEONZUJZUWGUWNUVNONZUJZUWHUVDONZUWNUVMONZUJZUDZJUW
      CQZIUWCQZUYJUXLUULUYTUUQUVMUVDIJURUSUXMUYSUYIIUWCUXMUWGUWCKZLZUYRUYHJUWCU
      XMVUAUWMUWCKZUYRUYHUTUXMVUAVUCLZUYRUYHUXMVUDUYRUDZUYGHUWAVUEUVBUWAKZLZUYK
      UVFONZUWJPNZUYOUVHONZPNZUWPUYMUVOONZPNZUYPUVHONZPNZUXOUXRVUEVUKVUOUJZVUFU
      YRUXMVUPVUDUYRVUIVUMVUJVUNPUYRVUHUWPUWJVULPUYRUWPVUHUYRUWMUYKUVFOUYLUYNUY
      QVAVBVCUYRUWGUYMUVOOUYLUYNUYQVDVBVEUYRUYOUYPUVHOUYLUYNUYQVFVBVEUSVGVUGUXO
      VUHVUJPNZUWJPNVUKVUGUXNVUQUWJPVUGUXNUWHUVGONZUWHUVIONZPNVUQVUGUWHUVGUVIVU
      GUWHVUGMRKZUWGRKZUWHRKZVHVUGVUAVVAVUAVUCUXMUYRVUFVIVUAVVAUMUWGVJUQUWGMVJU
      QUMMUWGVLVHVKVMZWBZMUWGVNZVOZSZVUGUVGVUGUVEUVFVUGVUTUVDRKZUVERKZVHVUGUXJV
      VHVUEUXJVUFUXJUXKUULUUQVUDUYRVPVGUXJVVHUMUVDVJUQUVDMVJUQUMMUVDVLVHVKVMZWB
      ZMUVDVNZVOZVUEUUNVUFUVFRKUUNUUOUUPUULUXLVUDUYRVQBUVBGVRWCZTSVUGUVIVUGUVDU
      VHVVKVUEUUPVUFUVHRKUUNUUOUUPUULUXLVUDUYRVSZDUVBGVRWCZTSVTVUGVUHVURVUJVUSP
      VUGUWHUVEUVFVVGVUGUVEVVMSVUGUVFVVNSWAVUGUWHUVDUVHVVGVUGUVDVVKSVUEUUPVUFUV
      HWDKVVODUVBGWEWCZWAVEWFVBVUGVUHVUJUWJVUGVUHVUGUYKUVFVUGUWHUVEVVFVVMTVVNTS
      VUGVUJVUGUYOUVHVUGUWHUVDVVFVVKTVVPTSVUGUWJVUGUWGUVOVVDVUEUUOVUFUVORKUUNUU
      OUUPUULUXLVUDUYRWGCUVBGVRWCZTSWHXCVUGUWNUVPONZUWNUVQONZPNZUWPPNVVSUWPPNZV
      VTPNUXRVUOVUGVVSVVTUWPVUGVVSVUGUWNUVPVUGVUTUWMRKZUWNRKVHVUGVUCVWCVUAVUCUX
      MUYRVUFWIVUCVWCUMUWMVJUQUWMMVJUQUMMUWMVLVHVKVMWBZMUWMVNVOZVUGUVNUVOVUGVUT
      UVMRKZUVNRKVHVUGUXKVWFVUEUXKVUFUXJUXKUULUUQVUDUYRWJVGUXKVWFUMUVMVJUQUVMMV
      JUQUMMUVMVLVHVKVMWBZMUVMVNVOZVVRTZTSZVUGVVTVUGUWNUVQVWEVUGUVMUVHVWGVVPTZT
      SVUGUWPVUGUWMUVFVWDVVNTSZWHVUGUXQVWAUWPPVUGUWNUVPUVQVUGUWNVWESZVUGUVPVWIS
      VUGUVQVWKSVTVBVUGVUMVWBVUNVVTPVUGVUMUWPVVSPNVWBVUGVULVVSUWPPVUGUWNUVNUVOV
      WMVUGUVNVWHSVUGUVOVVRSWAWMVUGUWPVVSVWLVWJWKXCVUGUWNUVMUVHVWMVUGUVMVWGSVVQ
      WAVEWLWLWNWOWPWQWQWRUXMUYIUYEIUWCVUBUYHUYDJUWCVUBVUCLZUFUWAUWHUVEUFUHZBUC
      ZONZUVDVWODUCZONZPNZONZUWGVWOCUCZONZPNZWSZUUMKZUYHUYDUTVWNVXFVXDRKZUFUWAU
      LZUXMVUAVUCVXHUXMVUDLZVXGUFUWAVXIVWOUWAKZLZVXAVXCVXKUWHVWTVXKVUTVVAVVBVHV
      XKVUAVVAUXMVUAVUCVXJWTVVCWBZVVEVOVXKVWQVWSVXKUVEVWPVXKVUTVVHVVIVHVXKUXJVV
      HVXIUXJVXJUXJUXKUULUUQVUDXAVGVVJWBZVVLVOVXIUUNVXJVWPRKUUNUUOUUPUULUXLVUDX
      BBVWOGVRWCTVXKUVDVWRVXMVXIUUPVXJVWRRKUUNUUOUUPUULUXLVUDXDDVWOGVRWCTXETVXK
      UWGVXBVXLVXIUUOVXJVXBRKUUNUUOUUPUULUXLVUDXFCVWOGVRWCTXEWNWPVWNUULVXFVXHXG
      UULUUQUXLVUAVUCXHVXAVXCUFPGXIWBXJVXFUYHUYDUYAUYHAVXEUUMUWEVXEUJZUXTUYGHUW
      AVXNVUFLZUXTUXOUXOUJZUYGLUYGVXOUXPVXPUXSUYGVXOUWFUXOUXOVXNVUFUWFUVBVXEUCU
      XOUVBUWEVXEXKUFUVBVXDUXOUWAVXEVWOUVBUJZVXAUXNVXCUWJPVXQVWTUVJUWHOVXQVWQUV
      GVWSUVIPVXQVWPUVFUVEOVWOUVBBXLWMVXQVWRUVHUVDOVWOUVBDXLWMVEWMVXQVXBUVOUWGO
      VWOUVBCXLWMVEVXEXMUXNUWJPXNXOXPZXQVXOUWFUXOUXRVXRXQXRVXPUYGUXOXMXSYDXTYAY
      NWBWQWQWRUYFUYBAUUMQZIUWCQUYCUYEVXSIUWCUYAJAUWCUUMYBYCUYBIAUWCUUMYBYEYFUW
      BUXAUYBAIUUMUWCUWBUWTUYAJUWCUWBUWSUXTXGZHUWAULUWTUYAXGUVTVXTHUWAUVKUWLUXP
      UVSUWRUXSUVKUWKUXOUWFUVKUWIUXNUWJPUVCUVJUWHOYGVBYHUVSUWQUXRUWFUVSUWOUXQUW
      PPUVLUVRUWNOYGVBYHYIYJUWSUXTHUWAYKWBYLYOYMWOUUAUUBUVAUXFUVKHUWAULZUAUWCQZ
      UVSHUWAULZUEUWCQZLZUWDUVAUXDVYBUXEVYDUVAUURUUNUUPUXDVYBXGUULUUQUURUUSUUCU
      ULUUNUUOUUPUUTUUDUULUUNUUOUUPUUTUUEZUAEBDHGYPYQUVAUUSUUOUUPUXEVYDXGUULUUQ
      UURUUSUUFUULUUNUUOUUPUUTUUGVYFUEFCDHGYPYQXRUWDVYAVYCLZUEUWCQUAUWCQVYEUWBV
      YGUAUEUWCUWCUVKUVSHUWAYRYSVYAVYCUAUEUWCUWCYTYEYDUVAUXIUXBAUUMUVAUWEUUMKZL
      ZUXIUWLHUWAULZIUWCQZUWRHUWAULZJUWCQZLZUXBVYIUXGVYKUXHVYMVYIVYHUURUUOUXGVY
      KXGUVAVYHUUHZUURUUSUULUUQVYHXAUUNUUOUUPUULUUTVYHXFIUWEECHGYPYQVYIVYHUUSUU
      NUXHVYMXGVYOUURUUSUULUUQVYHUUIUUNUUOUUPUULUUTVYHXBJUWEFBHGYPYQXRUXBVYJVYL
      LZJUWCQIUWCQVYNUWTVYPIJUWCUWCUWLUWRHUWAYRYSVYJVYLIJUWCUWCYTYEYDUUJUUK $.

  $}

  $( Lemma for ~ axlowdim .  Establish a particular constant function as a
     function.  (Contributed by Scott Fenton, 29-Jun-2013.) $)
  axlowdimlem1 $p |- ( ( 3 ... N ) X. { 0 } ) : ( 3 ... N ) --> RR $=
    ( c3 cfz co cc0 cr 0re fconst6 ) BACDEFGH $.

  $( Lemma for ~ axlowdim .  Show that two sets are disjoint.  (Contributed by
     Scott Fenton, 29-Jun-2013.) $)
  axlowdimlem2 $p |- ( ( 1 ... 2 ) i^i ( 3 ... N ) ) = (/) $=
    ( c2 c3 clt wbr c1 cfz co cin c0 wceq 2lt3 fzdisj ax-mp ) BCDEFBGHCAGHIJKLF
    BCAMN $.

  $( Lemma for ~ axlowdim .  Set up a union property for an interval of
     integers.  (Contributed by Scott Fenton, 29-Jun-2013.) $)
  axlowdimlem3 $p |- ( N e. ( ZZ>= ` 2 ) ->
    ( 1 ... N ) = ( ( 1 ... 2 ) u. ( 3 ... N ) ) ) $=
    ( c2 cuz cfv wcel c1 cfz co caddc cun c3 wceq cle wbr 1re 2re ltleii cz syl
    1lt2 a1i eluzle wa wb eluzelz 2z elfz mp3an12 mpbir2and fzsplit df-3 oveq1i
    1z uneq2i syl6eqr ) ABCDEZFAGHZFBGHZBFIHZAGHZJZURKAGHZJUPBUQEZUQVALUPVCFBMN
    ZBAMNZVDUPFBOPTQUABAUBUPAREZVCVDVEUCUDZBAUEBREFREVFVGUFUMBFAUGUHSUIBFAUJSVB
    UTURKUSAGUKULUNUO $.

  ${
    axlowdimlem4.1 $e |- A e. RR $.
    axlowdimlem4.2 $e |- B e. RR $.
    $( Lemma for ~ axlowdim .  Set up a particular constant function.
       (Contributed by Scott Fenton, 17-Apr-2013.) $)
    axlowdimlem4 $p |- { <. 1 , A >. , <. 2 , B >. } :
                  ( 1 ... 2 ) --> RR $=
      ( c1 c2 cfz co cpr cop wf cr wss wne 1ne2 1ex elexi ax-mp wcel df-2 caddc
      2re cz wceq 1z fzpr oveq2i preq2i 3eqtr4i feq2i mpbir wa pm3.2i prss mpbi
      fpr fss mp2an ) EFGHZABIZEAJFBJIZKZUTLMZUSLVAKVBEFIZUTVAKZEFNVEOEFABPFLUB
      QALCQZBLDQZUPRUSVDUTVAEEEUAHZGHZEVHIZUSVDEUCSVIVJUDUEEUFRFVHEGTUGFVHETUHU
      IUJUKALSZBLSZULVCVKVLCDUMABLVFVGUNUOUSUTLVAUQUR $.

    $( Lemma for ~ axlowdim .  Show that a particular union is a point in
       Euclidean space.  (Contributed by Scott Fenton, 29-Jun-2013.) $)
    axlowdimlem5 $p |- ( N e. ( ZZ>= ` 2 ) ->
       ( { <. 1 , A >. , <. 2 , B >. } u.
         ( ( 3 ... N ) X. { 0 } ) ) e. ( EE ` N ) ) $=
      ( c2 cuz cfv wcel c1 cop cpr c3 cfz co cc0 cun cr wf cn csn cxp cee wa c0
      cin wceq axlowdimlem4 axlowdimlem1 pm3.2i axlowdimlem2 mp2an axlowdimlem3
      fun2 feq2d mpbiri wb wss 2nn uznnssnn ax-mp sseli elee syl mpbird ) CFGHZ
      IZJAKFBKLZMCNOZPUAUBZQZCUCHIZJCNOZRVKSZVGVNJFNOZVIQZRVKSZVORVHSZVIRVJSZUD
      VOVIUFUEUGVQVRVSABDEUHCUIUJCUKVOVIRVHVJUNULVGVMVPRVKCUMUOUPVGCTIVLVNUQVFT
      CFTIVFTURUSFUTVAVBVKCVCVDVE $.
  $}

  ${
    $d N i j $.
    axlowdimlem6.1 $e |- A =
    ( { <. 1 , 0 >. , <. 2 , 0 >. } u. ( ( 3 ... N ) X. { 0 } ) ) $.
    axlowdimlem6.2 $e |- B =
    ( { <. 1 , 1 >. , <. 2 , 0 >. } u. ( ( 3 ... N ) X. { 0 } ) ) $.
    axlowdimlem6.3 $e |- C =
    ( { <. 1 , 0 >. , <. 2 , 1 >. } u. ( ( 3 ... N ) X. { 0 } ) ) $.
    $( Lemma for ~ axlowdim .  Show that three points are non-colinear.
       (Contributed by Scott Fenton, 29-Jun-2013.) $)
    axlowdimlem6 $p |- ( N e. ( ZZ>= ` 2 ) ->
    -. ( A Btwn <. B , C >. \/ B Btwn <. C , A >. \/
         C Btwn <. A , B >. ) ) $=
      ( c2 cfv wcel c1 cc0 cop co wbr cmin cmul wceq ax-mp syl6eq vi vj cuz cpr
      c3 cfz csn cxp cun cbtwn w3o cv wral wne wrex wn cz cle wa 1z a1i eluzelz
      wss 2nn uznnssnn nnuz sseqtri sseli eluzle syl leidi jctil elfz4 syl31anc
      cn 1re eluzel2 2re 1lt2 ltleii ax-1ne0 1t1e1 0cn mul01i neeq12i mpbir wfn
      fveq2 cin c0 cr wf 0re axlowdimlem4 ffn axlowdimlem1 axlowdimlem2 3pm3.2i
      w3a 2z pm3.2i mp2an fvun1 mp3an 1ne2 1ex fvpr1 eqtri elexi oveq12d ax-1cn
      subid1i oveq1d oveq2d neeq12d fvpr2 rspc2ev mp3an3 df-ne rexbii bitri cee
      syl2anc rexnal wb axlowdimlem5 colinearalg syl3anc mtbird opeq12i breq12i
      sylib 3orbi123i sylnibr ) DHUCIZJZKLMZHLMZUDZUEDUFNZLUGUHZUIZKKMYRUDZUUAU
      IZYQHKMUDZUUAUIZMZUJOZUUDUUFUUBMZUJOZUUFUUBUUDMZUJOZUKZABCMZUJOZBCAMZUJOZ
      CABMZUJOZUKYPUUMUAULZUUDIZUUTUUBIZPNZUBULZUUFIZUVDUUBIZPNZQNZUVDUUDIZUVFP
      NZUUTUUFIZUVBPNZQNZRZUBKDUFNZUMZUAUVOUMZYPUVHUVMUNZUBUVOUOZUAUVOUOZUVQUPZ
      YPKUVOJZHUVOJZUVTYPKUQJZDUQJZUWDKKUROZKDUROZUSUWBUWDYPUTVAZHDVBZUWHYPUWGU
      WFYPDKUCIZJUWGYOUWJDYOVOUWJHVOJYOVOVCVDHVESVFVGVHKDVIVJKVPVKZVLKKDVMVNYPU
      WDUWEHUQJZKHUROZHDUROZUSUWCUWHUWIHDVQYPUWNUWMHDVIKHVPVRVSVTZVLHKDVMVNUWBU
      WCKKQNZLLQNZUNZUVTUWRKLUNWAUWPKUWQLWBLWCWDWEWFUVRUWRKUVGQNZUVJLQNZUNUAUBK
      HUVOUVOUUTKRZUVHUWSUVMUWTUXAUVCKUVGQUXAUVCKLPNZKUXAUVAKUVBLPUXAUVAKUUDIZK
      UUTKUUDWHUXCKUUCIZKUUCKHUFNZWGZUUAYTWGZUXEYTWIWJRZKUXEJZUSZUXCUXDRUXEWKUU
      CWLUXFKLVPWMWNUXEWKUUCWOSZYTWKUUAWLUXGDWPYTWKUUAWOSZUXHUXIDWQZUWDUWLUWDWS
      UWFUWMUSUXIUWDUWLUWDUTWTUTWRUWFUWMUWKUWOXAKKHVMXBXAZUXEYTUUCUUAKXCXDKHUNZ
      UXDKRXEKHKLXFXFXGSXHTUXAUVBKUUBIZLUUTKUUBWHUXPKYSIZLYSUXEWGZUXGUXJUXPUXQR
      UXEWKYSWLUXRLLWMWMWNUXEWKYSWOSZUXLUXNUXEYTYSUUAKXCXDUXOUXQLRXEKHLLXFLWKWM
      XIZXGSXHTZXJKXKXLZTXMUXAUVLLUVJQUXAUVLLLPNZLUXAUVKLUVBLPUXAUVKKUUFIZLUUTK
      UUFWHUYDKUUEIZLUUEUXEWGZUXGUXJUYDUYERUXEWKUUEWLUYFLKWMVPWNUXEWKUUEWOSZUXL
      UXNUXEYTUUEUUAKXCXDUXOUYELRXEKHLKXFUXTXGSXHTUYAXJLWCXLZTXNXOUVDHRZUWSUWPU
      WTUWQUYIUVGKKQUYIUVGUXBKUYIUVEKUVFLPUYIUVEHUUFIZKUVDHUUFWHUYJHUUEIZKUYFUX
      GUXHHUXEJZUSZUYJUYKRUYGUXLUXHUYLUXMUWDUWLUWLWSUWMHHUROZUSUYLUWDUWLUWLUTWT
      WTWRUWMUYNUWOHVRVKXAHKHVMXBXAZUXEYTUUEUUAHXCXDUXOUYKKRXEKHLKHUQWTXIZXFXPS
      XHTUYIUVFHUUBIZLUVDHUUBWHUYQHYSIZLUXRUXGUYMUYQUYRRUXSUXLUYOUXEYTYSUUAHXCX
      DUXOUYRLRXEKHLLUYPUXTXPSXHTZXJUYBTXNUYIUVJLLQUYIUVJUYCLUYIUVILUVFLPUYIUVI
      HUUDIZLUVDHUUDWHUYTHUUCIZLUXFUXGUYMUYTVUARUXKUXLUYOUXEYTUUCUUAHXCXDUXOVUA
      LRXEKHKLUYPUXTXPSXHTUYSXJUYHTXMXOXQXRYCUVTUVPUPZUAUVOUOUWAUVSVUBUAUVOUVSU
      VNUPZUBUVOUOVUBUVRVUCUBUVOUVHUVMXSXTUVNUBUVOYDYAXTUVPUAUVOYDYAYLYPUUBDYBI
      ZJUUDVUDJUUFVUDJUUMUVQYELLDWMWMYFKLDVPWMYFLKDWMVPYFUUBUUDUUFUAUBDYGYHYIUU
      OUUHUUQUUJUUSUULAUUBUUNUUGUJEBUUDCUUFFGYJYKBUUDUUPUUIUJFCUUFAUUBGEYJYKCUU
      FUURUUKUJGAUUBBUUDEFYJYKYMYN $.
  $}

  ${
    axlowdimlem7.1 $e |- P = ( { <. 3 , -u 1 >. } u.
                 ( ( ( 1 ... N ) \ { 3 } ) X. { 0 } ) ) $.
    $( Lemma for ~ axlowdim .  Set up a point in Euclidean space.  (Contributed
       by Scott Fenton, 29-Jun-2013.) $)
    axlowdimlem7 $p |- ( N e. ( ZZ>= ` 3 ) -> P e. ( EE ` N ) ) $=
      ( c3 cfv wcel c1 csn cc0 cun cr wf wa wceq wss cn 3nn 1re ax-mp cz cuz co
      cneg cop cfz cdif cxp cee cin c0 elexi negex fsn mpbir renegcli snssi fss
      eqid mp2an 0re fconst6 pm3.2i disjdif fun2 cle wbr eluzle 3re 1lt3 ltleii
      jctil wb eluzelz nnzi 1z mp3an12 syl mpbird snssd undif sylib feq2d mpbii
      elfz uznnssnn sseli elee syl5eqel ) BDUAEZFZADGUCZUDHZGBUEUBZDHZUFZIHUGZJ
      ZBUHEZCWJWQWRFZWMKWQLZWJWNWOJZKWQLZWTWNKWLLZWOKWPLZMWNWOUIUJNXBXCXDWNWKHZ
      WLLZXEKOZXCXFWLWLNWLURDWKWLDPQUKGULUMUNWKKFXGGRUOWKKUPSWNXEKWLUQUSWOIKUTV
      AVBWNWMVCWNWOKWLWPVDUSWJXAWMKWQWJWNWMOXAWMNWJDWMWJDWMFZGDVEVFZDBVEVFZMZWJ
      XJXIDBVGGDRVHVIVJVKWJBTFZXHXKVLZDBVMDTFGTFXLXMDQVNVODGBWDVPVQVRVSWNWMVTWA
      WBWCWJBPFWSWTVLWIPBDPFWIPOQDWESWFWQBWGVQVRWH $.

    $( Lemma for ~ axlowdim .  Calulate the value of ` P ` at three.
       (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem8 $p |- ( P ` 3 ) = -u 1 $=
      ( c3 cfv c1 cneg cop csn cfz co cdif cc0 cxp cun fveq1i wfn cin c0 wceq
      wcel wa cr 3re elexi negex fnsn c0ex fconst ffn ax-mp disjdif snid pm3.2i
      wf fvun1 mp3an fvsn 3eqtri ) DAEDDFGZHIZFBJKZDIZLZMIZNZOZEZDVAEZUTDAVGCPV
      AVCQVFVDQZVCVDRSTZDVCUAZUBVHVITDUTDUCUDUEZFUFZUGVDVEVFUOVJVDMUHUIVDVEVFUJ
      UKVKVLVCVBULDVMUMUNVCVDVAVFDUPUQDUTVMVNURUS $.

    $( Lemma for ~ axlowdim .  Calulate the value of ` P ` away from three.
       (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem9 $p |- ( ( K e. ( 1 ... N ) /\ K =/= 3 ) -> ( P ` K ) = 0 ) $=
      ( c1 cfz co wcel c3 wne wa cfv cneg cop csn cdif cc0 wceq wfn c0ex fveq1i
      cxp cun eldifsn cin c0 disjdif cr 3re elexi negex fnsn fconst ax-mp fvun2
      wf ffn mp3an12 mpan fvconst2 eqtrd sylbir syl5eq ) BECFGZHBIJKZBALBIEMZNO
      ZVDIOZPZQOZUBZUCZLZQBAVLDUAVEBVIHZVMQRBVDIUDVNVMBVKLZQVHVIUEUFRZVNVMVORZV
      HVDUGVGVHSVKVISZVPVNKVQIVFIUHUIUJEUKULVIVJVKUPVRVIQTUMVIVJVKUQUNVHVIVGVKB
      UOURUSVIQBTUTVAVBVC $.
  $}

  ${
    axlowdimlem10.1 $e |- Q = ( { <. ( I + 1 ) , 1 >. } u.
                    ( ( ( 1 ... N ) \ { ( I + 1 ) } ) X. { 0 } ) ) $.
    $( Lemma for ~ axlowdim .  Set up a family of points in Euclidean space.
       (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem10 $p |- ( ( N e. NN /\ I e. ( 1 ... ( N - 1 ) ) ) ->
                Q e. ( EE ` N ) ) $=
      ( wcel c1 co cfz wa cr wf caddc csn cun cc0 wss wceq ax-mp mp2an snssi cn
      cmin cee cfv cdif cop cxp cin wf1o ovex 1ex f1osn f1of c0ex fconst pm3.2i
      c0 disjdif fun feq1i mpbir 1re 0re unssi fznatpl1 snssd undif sylib feq2d
      fss mpbii wb elee adantr mpbird ) CUAEZBFCFUBGHGEZIZACUCUDEZFCHGZJAKZVRBF
      LGZMZVTWCUEZNZJAKZWAWEFMZOMZNZAKZWIJPWFWJWEWIWBFUFMZWDWHUGZNZKZWCWGWKKZWD
      WHWLKZIWCWDUHUQQWNWOWPWCWGWKUIWOWBFBFLUJUKULWCWGWKUMRWDOUNUOUPWCVTURWCWDW
      GWHWKWLUSSWEWIAWMDUTVAWGWHJFJEWGJPVBFJTROJEWHJPVCOJTRVDWEWIJAVJSVRWEVTJAV
      RWCVTPWEVTQVRWBVTBCVEVFWCVTVGVHVIVKVPVSWAVLVQACVMVNVO $.

    $( Lemma for ~ axlowdim .  Calculate the value of ` Q ` at its
       distinguished point.  (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem11 $p |- ( Q ` ( I + 1 ) ) = 1 $=
      ( c1 caddc co cfv cop csn cfz cdif cc0 cxp cun fveq1i wfn cin wceq 1ex c0
      wcel wa ovex fnsn wf c0ex fconst ffn ax-mp disjdif snid pm3.2i fvun1 fvsn
      mp3an 3eqtri ) BEFGZAHURUREIJZECKGZURJZLZMJZNZOZHZURUSHZEURAVEDPUSVAQVDVB
      QZVAVBRUASZURVAUBZUCVFVGSUREBEFUDZTUEVBVCVDUFVHVBMUGUHVBVCVDUIUJVIVJVAUTU
      KURVKULUMVAVBUSVDURUNUPUREVKTUOUQ $.

    $( Lemma for ~ axlowdim .  Calculate the value of ` Q ` away from its
       distunguished point.  (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem12 $p |- ( ( K e. ( 1 ... N ) /\ K =/= ( I + 1 ) ) ->
                ( Q ` K ) = 0 ) $=
      ( c1 cfz co wcel caddc wne wa cfv cop csn cdif cc0 wceq wfn c0ex cxp ovex
      cun fveq1i eldifsn cin c0 disjdif 1ex fnsn fconst ffn ax-mp fvun2 mp3an12
      wf mpan fvconst2 eqtrd sylbir syl5eq ) CFDGHZICBFJHZKLZCAMCVCFNOZVBVCOZPZ
      QOZUAZUCZMZQCAVJEUDVDCVGIZVKQRCVBVCUEVLVKCVIMZQVFVGUFUGRZVLVKVMRZVFVBUHVE
      VFSVIVGSZVNVLLVOVCFBFJUBUIUJVGVHVIUPVPVGQTUKVGVHVIULUMVFVGVEVICUNUOUQVGQC
      TURUSUTVA $.
  $}

  ${
    axlowdimlem13.1 $e |- P = ( { <. 3 , -u 1 >. } u.
                 ( ( ( 1 ... N ) \ { 3 } ) X. { 0 } ) ) $.
    axlowdimlem13.2 $e |- Q = ( { <. ( I + 1 ) , 1 >. } u.
                    ( ( ( 1 ... N ) \ { ( I + 1 ) } ) X. { 0 } ) ) $.
    $( Lemma for ~ axlowdim .  Establish that ` P ` and ` Q ` are different
       points.  (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem13 $p |- ( ( N e. NN /\ I e. ( 1 ... ( N - 1 ) ) ) ->
                  P =/= Q ) $=
      ( wcel c1 co cfz c3 csn cc0 cun caddc wceq wne crn c2 ax-1cn cn cmin cneg
      wa cop cdif cxp wn cpr wo 2ne0 df-ne mpbi eqcom negidi eqcomi df-2 neg1cn
      eqeq12i addcani 3bitri mtbi intnanr ax-1ne0 cc negeq0 ax-mp pm3.2ni negex
      wb c0ex elexi preq12b mtbir cr 3re rnsnop a1i c0 cuz elnnuz eluzfz1 sylbi
      cfv df-3 1e0p1 2cn 0cn addcan2i bitri necon3bii mpbir necomi jctir sylibr
      eldifsn adantr ne0i rnxp 3syl uneq12d rnun 3eqtr4g ovex cz wss nnz fzssp1
      df-pr zcn npcan mpan2 oveq2d syl syl5sseq sselda elfzelz zred ltp1 adantl
      id ltned sylanbrc eqeq12d mtbiri rneq nsyl necon3abii ) DUAGZCHDHUBIZJIZG
      ZUDZKHUCZUELZHDJIZKLUFZMLZUGZNZCHOIZHUELZYPUUALUFZYRUGZNZPZUHABQYMYTRZUUE
      RZPZUUFYMUUIYNMUIZHMUIZPZUULYNHPZMMPZUDZYNMPZMHPZUDZUJUUOUURUUMUUNSMPZUUM
      SMQZUUSUHUKSMULUMUUSMSPHYNOIZHHOIZPUUMSMUNMUVASUVBUVAMHTUOUPUQUSHYNHTURTU
      TVAVBVCUUPUUQHMPZUUPHMQUVCUHVDHMULUMHVEGZUVCUUPVJTHVFVGVBVCVHYNMHMHVIVKHV
      ETVLVKVMVNYMUUGUUJUUHUUKYMYORZYSRZNYNLZYRNUUGUUJYMUVEUVGUVFYRUVEUVGPYMKYN
      KVOVPVLVQVRYMHYQGZYQVSQUVFYRPYIUVHYLYIHYPGZHKQZUDUVHYIUVIUVJYIDHVTWDGUVID
      WAHDWBWCKHKHQUUTUKKHSMKHPSHOIZMHOIZPUUSKUVKHUVLWEWFUSSMHWGWHTWIWJWKWLWMWN
      HYPKWPWOWQYQHWRYQYRWSWTXAYOYSXBYNMXIXCYMUUBRZUUDRZNHLZYRNUUHUUKYMUVMUVOUV
      NYRUVMUVOPYMUUAHCHOXDVQVRYMCUUCGZUUCVSQUVNYRPYMCYPGCUUAQZUVPYIYKYPCYIDXEG
      ZYKYPXFDXGUVRHYJHOIZJIZYKYPHYJXHUVRDVEGZUVTYPPDXJUWAUVSDHJUWAUVDUVSDPTDHX
      KXLXMXNXOXNXPYLUVQYIYLCVOGZUVQYLCCHYJXQXRUWBCUUAUWBYACXSYBXNXTCYPUUAWPYCU
      UCCWRUUCYRWSWTXAUUBUUDXBHMXIXCYDYEYTUUEYFYGUUFABAYTBUUEEFUSYHWO $.
  $}

  ${
    $d I i $.  $d N i $.  $d Q i $.  $d R i $.
    axlowdimlem14.1 $e |- Q = ( { <. ( I + 1 ) , 1 >. } u.
                    ( ( ( 1 ... N ) \ { ( I + 1 ) } ) X. { 0 } ) ) $.
    axlowdimlem14.2 $e |- R = ( { <. ( J + 1 ) , 1 >. } u.
                    ( ( ( 1 ... N ) \ { ( J + 1 ) } ) X. { 0 } ) ) $.
    $( Lemma for ~ axlowdim .  Take two possible ` Q ` from ~ axlowdimlem10 .
       They are the same iff their distunguished values are the same.
       (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem14 $p |- ( ( N e. NN /\ I e. ( 1 ... ( N - 1 ) ) /\
                            J e. ( 1 ... ( N - 1 ) ) ) ->
       ( Q = R -> I = J ) ) $=
      ( vi wcel c1 co wceq cfv wb wa cr adantr wne wn cc0 cmin cfz w3a wral wfn
      cn cv wf cee axlowdimlem10 elee mpbid ffn eqfnfv syl2an 3impdi wrex caddc
      syl fznatpl1 3adant3 ax-1ne0 axlowdimlem11 cc elfzelz zcnd ax-1cn addcan2
      a1i 3adant1 necon3bid biimpar axlowdimlem12 syl2anc 3netr4d df-ne neeq12d
      mp3an3 fveq2 syl5bbr rspcev ex rexnal 3imtr3g con4d sylbid ) EUFIZCJEJUAK
      ZUBKZIZDWIIZUCZABLZHUGZAMZWNBMZLZHJEUBKZUDZCDLZWGWJWKWMWSNZWGWJOZAWRUEZBW
      RUEZXAWGWKOZXBWRPAUHZXCXBAEUIMZIZXFACEFUJWGXHXFNWJAEUKQULWRPAUMUSXEWRPBUH
      ZXDXEBXGIZXIBDEGUJWGXJXINWKBEUKQULWRPBUMUSHWRABUNUOUPWLWTWSWLCDRZWQSZHWRU
      QZWTSWSSWLXKXMWLXKOZCJURKZWRIZXOAMZXOBMZRZXMWLXPXKWGWJXPWKCEUTVAQZXNJTXQX
      RJTRXNVBVIXQJLXNACEFVCVIXNXPXODJURKZRZXRTLXTWLYBXKWLXOYACDWJWKXOYALWTNZWG
      WJCVDIZDVDIZYCWKWJCCJWHVEVFWKDDJWHVEVFYDYEJVDIYCVGCDJVHVRUOVJVKVLBDXOEGVM
      VNVOXLXSHXOWRXLWOWPRWNXOLZXSWOWPVPYFWOXQWPXRWNXOAVSWNXOBVSVQVTWAVNWBCDVPW
      QHWRWCWDWEWF $.
  $}

  ${
    $d F j k $.  $d i j k x $.  $d N i $.  $d N j k x $.
    axlowdimlem15.1 $e |- F =
      ( i e. ( 1 ... ( N - 1 ) ) |-> if ( i = 1 ,
         ( { <. 3 , -u 1 >. } u. ( ( ( 1 ... N ) \ { 3 } ) X. { 0 } ) ) ,
         ( { <. ( i + 1 ) , 1 >. } u.
           ( ( ( 1 ... N ) \ { ( i + 1 ) } ) X. { 0 } ) ) ) ) $.
    $( Lemma for ~ axlowdim .  Set up a one-to-one function of points.
       (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem15 $p |- ( N e. ( ZZ>= ` 3 ) ->
                   F : ( 1 ... ( N - 1 ) ) -1-1-> ( EE ` N ) ) $=
      ( vj vk c3 cfv wcel c1 co wceq wi cop csn caddc wa syl5ibr ax-mp cvv cmin
      cuz cfz cee wf weq wral wf1 cneg cdif cc0 cxp cun cif ifeqor axlowdimlem7
      cv wo eqid adantr eleq1 wss uznnssnn sseli axlowdimlem10 sylan jaoi fmptd
      cn 3nn eqeq1 oveq1 opeq1d sneqd difeq2d xpeq1d uneq12d ifbieq2d snex ovex
      wb difexg xpex unex fvmpt eqeqan12d adantl eqtr3 a1d axlowdimlem13 neneqd
      ifex wn pm2.21d adantrl iftrue iffalse imbi1d adantrr axlowdimlem14 3expb
      necomd 4cases sylbid ralrimivva dff13 sylanbrc ) CGUBHZIZJCJUAKUCKZCUDHZB
      UEEUQZBHZFUQZBHZLZEFUFZMZFXJUGEXJUGXJXKBUHXIAXJAUQZJLZGJUINZOZJCUCKZGOZUJ
      ZUKOZULZUMZXSJPKZJNZOZYCYIOZUJZYFULZUMZUNZXKBYPYHLZYPYOLZURXIXSXJIZQZYPXK
      IZMZXTYHYOUOYQUUBYRYTUUAYQYHXKIZXIUUCYSYHCYHUSZUPUTYPYHXKVARYTUUAYRYOXKIZ
      XICVIIZYSUUEXHVICGVIIXHVIVBVJGVCSVDZYOXSCYOUSVEVFYPYOXKVARVGSDVHXIXREFXJX
      JXIXLXJIZXNXJIZQZQZXPXLJLZYHXLJPKZJNZOZYCUUMOZUJZYFULZUMZUNZXNJLZYHXNJPKZ
      JNZOZYCUVBOZUJZYFULZUMZUNZLZXQUUJXPUVJWAXIUUHUUIXMUUTXOUVIAXLYPUUTXJBAEUF
      ZXTUULYOUUSYHXSXLJVKUVKYKUUOYNUURUVKYJUUNUVKYIUUMJXSXLJPVLZVMVNUVKYMUUQYF
      UVKYLUUPYCUVKYIUUMUVLVNVOVPVQVRDUULYHUUSYBYGYAVSYEYFYCTIZYETIJCUCVTZYCYDT
      WBSUKVSZWCWDZUUOUURUUNVSUUQYFUVMUUQTIUVNYCUUPTWBSUVOWCWDWLWEAXNYPUVIXJBAF
      UFZXTUVAYOUVHYHXSXNJVKUVQYKUVDYNUVGUVQYJUVCUVQYIUVBJXSXNJPVLZVMVNUVQYMUVF
      YFUVQYLUVEYCUVQYIUVBUVRVNVOVPVQVRDUVAYHUVHUVPUVDUVGUVCVSUVFYFUVMUVFTIUVNY
      CUVETWBSUVOWCWDWLWEWFWGUULUVAUUKUVJXQMZMUULUVAQZUVSUUKUVTXQUVJXLXNJWHWIWI
      UUKUVSUULUVAWMZQZYHUVHLZXQMZXIUUFUUJUWDUUGUUFUUIUWDUUHUUFUUIQZUWCXQUWEYHU
      VHYHUVHXNCUUDUVHUSZWJWKWNWOVFUWBUVJUWCXQUULUWAUUTYHUVIUVHUULYHUUSWPUVAYHU
      VHWQZWFWRRUUKUVSUULWMZUVAQZUUSYHLZXQMZXIUUHUWKUUIXIUUFUUHUWKUUGUUFUUHQZUW
      JXQUWLUUSYHUWLYHUUSYHUUSXLCUUDUUSUSZWJXBWKWNVFWSUWIUVJUWJXQUWHUVAUUTUUSUV
      IYHUULYHUUSWQZUVAYHUVHWPWFWRRUUKUVSUWHUWAQZUUSUVHLZXQMZXIUUFUUJUWQUUGUUFU
      UHUUIUWQUUSUVHXLXNCUWMUWFWTXAVFUWOUVJUWPXQUWHUWAUUTUUSUVIUVHUWNUWGWFWRRXC
      XDXEEFXJXKBXFXG $.
  $}

  ${
    $d P i $.  $d I i $.  $d N i $.  $d Q i $.
    axlowdimlem16.1 $e |- P = ( { <. 3 , -u 1 >. } u.
                 ( ( ( 1 ... N ) \ { 3 } ) X. { 0 } ) ) $.
    axlowdimlem16.2 $e |- Q = ( { <. ( I + 1 ) , 1 >. } u.
                    ( ( ( 1 ... N ) \ { ( I + 1 ) } ) X. { 0 } ) ) $.
    $( Lemma for ~ axlowdim .  Set up a summation that will help establish
       distance.  (Contributed by Scott Fenton, 21-Apr-2013.) $)
    axlowdimlem16 $p |- ( ( N e. ( ZZ>= ` 3 ) /\ I e. ( 2 ... ( N - 1 ) ) )
          ->
      sum_ i e. ( 3 ... N ) ( ( P ` i ) ^ 2 ) =
      sum_ i e. ( 3 ... N ) ( ( Q ` i ) ^ 2 ) ) $=
      ( c3 wcel c2 c1 co cfz wa csu wceq caddc syl wbr cc0 cuz cfv cmin cv cexp
      wi elfz1eq oveq1 df-3 syl6reqr oveq12d sumeq1d cz cc syl6eqr 3nn syl6eqel
      ax-1cn sqcli fveq2 axlowdimlem11 syl6eq oveq1d fsum1 sylancl axlowdimlem8
      nnzi eqtrd cneg sqneg ax-mp mp2an a1i 3m1e2 oveq2d eleq2d eqeq12d wne clt
      oveq2 cle adantl simpl cr wb sylancr 3ad2ant1 elfzelz zred ltp1d fzfid cn
      3re wss sseli eleqtri fzss1 syl2an fveecn sqcld 3adantl2 3ad2ant3 elfzle2
      nnuz ltm1d lelttrd syl2anc mpbird imp adantr peano2re axlowdimlem12 sq0id
      eluz sumeq2dv cfn wo fzfi olci sumz sq1 1re 2re ltleii peano2nnd syl6eleq
      elfzle1 sselda oveq1i eqtri fsum1p ex pm2.61ine 2lt3 mp3an12 elfz 3adant3
      2z 1z wn 3imtr4d adantld simprl eluzle ltlen mpbir2and adantrr simprr w3a
      eluzelre cin c0 fzssp1 simp3 sseldi eluzelz zcnd npcan eleqtrd fzdisj cun
      fzsplit uznnssnn axlowdimlem10 fsumsplit peano2rem ltled fzss2 sseld syl5
      cee 2nn ltned peano2zd eqeq1d syl5ib letrd elnnz1 sylanbrc nnltp1le mpbid
      1lt2 simpr1 simpr3 ltletrd gtned addid1i 0p1e1 simp1 eluz1i mpbir2an lttr
      uztrn mpani ltle mpan sylc ltne necomd sumeq1i oveq2i fsumcl axlowdimlem7
      jctil addid2d 3eqtrrd ad2antrr zaddcl zrei 1lt3 ltp1i lttri mpbir intnanr
      ltnlei mpbi mtbiri eleq1 notbid syl5ibrcom necon2ad axlowdimlem9 3eqtr4rd
      syl3anc ) EHUAUBZIZDJEKUCLZMLZIZNZHEMLZCUDZAUBZJUELZCOZUYKUYLBUBZJUELZCOZ
      PZUFEHEHPZUYIUYSUYFUYTDJJMLZIZHHMLZUYNCOZVUCUYQCOZPZUYIUYSVUBVUFUFUYTVUBD
      JPZVUFDJUGVUGVUEKJUELZVUDVUGVUEDKQLZVUIMLZUYQCOZVUHVUGVUCVUJUYQCVUGHVUIHV
      UIMVUGVUIJKQLZHDJKQUHZUIUJZVUNUKULVUGVUIUMIZVUHUNIZVUKVUHPVUGVUIHUMVUGVUI
      VULHVUMUIUOHUPVGZUQKURUSZUYQVUHCVUIUYLVUIPZUYPKJUEVUSUYPVUIBUBZKUYLVUIBUT
      ZBDEGVAZVBVCZVDVEVHHUMIZVUPVUDVUHPVUQVURUYNVUHCHUYLHPZUYNKVIZJUELZVUHVVEU
      YMVVFJUEVVEUYMHAUBVVFUYLHAUTAEFVFVBVCZKUNIZVVGVUHPURKVJVKZVBVDVLUJRVMUYTU
      YHVUADUYTUYGJJMUYTUYGHKUCLJEHKUCUHVNVBVOVPUYTUYOVUDUYRVUEUYTUYKVUCUYNCEHH
      MVTZULUYTUYKVUCUYQCVVKULVQUUAUUBEHVRZUYJUYSVVLUYJNUYFHEVSSZUYIUYSVVLUYFUY
      IUUCVVLUYFVVMUYIVVLUYFNZVVMHEWASZVVLUYFVVOVVLHEUUDWBVVLUYFWCVVNHWDIZEWDIZ
      VVMVVOVVLNWEWMUYFVVQVVLHEUUJZWBHEUUEWFUUFUUGVVLUYFUYIUUHUYFVVMUYIUUIZJEML
      ZUYQCOZKUYRUYOVVSVWAJDMLZUYQCOZVUIEMLZUYQCOZQLZKVVSVWBVWDUYQVVTCVVSDVUIVS
      SVWBVWDUUKUULPVVSDVVSDVVSDVVTIZDUMIZVVSDJUYGKQLZMLZVVTVVSUYHVWJDJUYGUUMUY
      FVVMUYIUUNUUOVVSVWIEJMVVSEUNIVVIVWIEPVVSEUYFVVMEUMIZUYIHEUUPZWGZUUQUREKUU
      RVEVOUUSZDJEWHRWIWJJDVUIEUUTRVVSVWGVVTVWBVWDUVAPVWNDJEUVBRVVSJEWKUYFUYIUY
      LVVTIZUYQUNIZVVMUYJVWONUYPUYJBEUVKUBZIZUYLKEMLZIZUYPUNIZVWOUYFEWLIZDKUYGM
      LZIVWRUYIUYEWLEHWLIUYEWLWNUPHUVCVKWOZUYHVXCDJKUAUBZIZUYHVXCWNJWLVXEUVLXDW
      PZJKUYGWQVKWOBDEGUVDWRZVVTVWSUYLVXFVVTVWSWNVXGJKEWQVKWOBUYLEWSZWRWTXAZUVE
      VVSVWFTKQLKVVSVWCTVWEKQVVSVWCVWBTCOZTVVSVWBUYQTCVVSUYLVWBIZNZUYPVXMVWTUYL
      VUIVRZUYPTPZVVSVXLVWTVXLUYLKDMLZIVVSVWTVWBVXPUYLVXFVWBVXPWNVXGJKDWQVKWOVV
      SVXPVWSUYLVVSEDUAUBIZVXPVWSWNVVSVXQDEWASZVVSDEUYIUYFDWDIZVVMUYIDDJUYGWHZW
      IZXBZUYFVVMVVQUYIVVRWGZVVSDUYGEVYBVVSVVQUYGWDIZVYCEUVFZRVYCUYIUYFDUYGWASZ
      VVMDJUYGXCXBZVVSEVYCXEXFUVGVVSVWHVWKVXQVXRWEUYIUYFVWHVVMVXTXBZVWMDEXNXGXH
      DKEUVHRUVIUVJXIVXMUYLVUIVXLUYLWDIZVVSVXLUYLUYLJDWHWIWBZVXMUYLDVUIVYJVVSVX
      SVXLVYBXJZVVSVUIWDIZVXLUYIUYFVYLVVMUYIVXSVYLVYADXKZRZXBXJVXLUYLDWASVVSUYL
      JDXCWBVXMDVYKWJXFUVMBDUYLEGXLZXGXMXOVWBVXEWNZVWBXPIZXQVXKTPVYQVYPJDXRXSVW
      BCKXTVKVBVVSVWEKPZUFVUIEVVSVUKKPZVUIEPZVYRVVSVUOVVIVYSVVSDVYHUVNZURUYQKCV
      UIVUSUYQVUHKVVCYAVBVDVEVYTVUKVWEKVYTVUJVWDUYQCVUIEVUIMVTULUVOUVPVUIEVRZVV
      SVYRWUBVVSNZVWEKVUIKQLZEMLZUYQCOZQLZKWUCUYQKCVUIEWUCEVUIUAUBIZVUIEWASZWUC
      DEVSSZWUIWUCDUYGEWUCDVVSVWHWUBVYHWBZWIZWUCVVQVYDWUCEVVSVWKWUBVWMWBZWIZVYE
      RWUNVVSVYFWUBVYGWBWUCEWUNXEXFWUCDWLIZVXBWUJWUIWEWUCVWHKDWASZWUOWUKVVSWUPW
      UBUYIUYFWUPVVMUYIKJDKWDIUYIYBVMJWDIZUYIYCVMZVYAKJWASZUYIKJYBYCUWBYDZVMDJU
      YGYGZUVQXBWBDUVRUVSZVVSVXBWUBUYFVVMVXBUYIVXDWGWBDEUVTXGUWAWUCVUOVWKWUHWUI
      WEVVSVUOWUBWUAWBWUMVUIEXNXGXHWUCUYLVWDIZNZUYPWVDVWRVWTVXAWUCVWRWVCWUCUYFU
      YIVWRWUBUYFVVMUYIUWCWUBUYFVVMUYIUWDVXHXGXJWUCVWDVWSUYLWUCVUIVXEIVWDVWSWNW
      UCVUIWLVXEWUCDWVBYEZXDYFVUIKEWQRYHVXIXGWTVUSUYQVUTJUELZKVUSUYPVUTJUEVVAVC
      WVFVUHKVUTKJUEVVBYIYAYJVBYKWUCWUGKTQLZKWUCWUFTKQWUCWUFWUETCOZTWUCWUEUYQTC
      WUCUYLWUEIZNZUYPWVJVWTVXNVXOWUCWUEVWSUYLWUCWUDVXEIWUEVWSWNWUCWUDWLVXEWUCV
      UIWVEYEXDYFWUDKEWQRYHWVJVUIUYLWUCVYLWVIWUCVXSVYLWULVYMRXJZWVJVUIWUDUYLWVK
      WVJVYLWUDWDIWVKVUIXKRWVIVYIWUCWVIUYLUYLWUDEWHWIWBWVJVUIWVKWJWVIWUDUYLWASW
      UCUYLWUDEYGWBUWEUWFVYOXGXMXOWUEVXEWNZWUEXPIZXQWVHTPWVMWVLWUDEXRXSWUECKXTV
      KVBVOKURUWGZVBVHYLYMUKUWHVBVHVVSVWAJBUBZJUELZVULEMLZUYQCOZQLZTUYRQLZUYRVV
      SUYQWVPCJEVVSUYFHJUAUBZIZEWWAIUYFVVMUYIUWIWWBVVDJHWASVUQJHYCWMYNYDJHYRUWJ
      UWKHEJUWMVEVXJUYLJPUYPWVOJUEUYLJBUTVCYKVVSWVSTWVRQLWVTVVSWVPTWVRQVVSWVOVV
      SJVWSIZJVUIVRWVOTPUYFVVMWWCUYIUYFVVMNZWWCWUSJEWASZNZWWDWWEWUSWWDVVQJEVSSZ
      WWEWWDEUYFVWKVVMVWLXJZWIUYFVVMWWGUYFVVQVVMWWGUFVVRVVQJHVSSZVVMWWGYNWUQVVP
      VVQWWIVVMNWWGUFYCWMJHEUWLYOUWNRXIWUQVVQWWGWWEUFYCJEUWOUWPUWQWUTUXDWWDVWKW
      WCWWFWEZWWHJUMIKUMIZVWKWWJYRYSJKEYPYORXHYQVVSVUIJVVSWUQJVUIVSSZVUIJVRYCUY
      IUYFWWLVVMUYIJDVUIWURVYAVYNWVAUYIDVYAWJXFXBJVUIUWRWFUWSBDJEGXLXGXMVCUYRWV
      RTQUYKWVQUYQCHVULEMUIYIUWTUXAUOVVSUYRVVSUYKUYQCVVSHEWKUYFUYIUYLUYKIZVWPVV
      MUYJWWMNUYPUYJVWRVWTVXAWWMVXHUYKVWSUYLHVXEIUYKVWSWNHWLVXEUPXDWPHKEWQVKWOZ
      VXIWRWTXAUXBUXEUXFUYFVVMUYOKPUYIWWDUYOWVGKWWDUYOKHKQLZEMLZUYNCOZQLWVGWWDU
      YNKCHEUYFVVMWCWWDWWMNZUYMWWRAVWQIZVWTUYMUNIUYFWWSVVMWWMAEFUXCUXGWWMVWTWWD
      WWNWBAUYLEWSXGWTVVEUYNVVGKVVHVVGVUHKVVJYAYJVBYKWWDWWQTKQWWDWWQWWPTCOZTWWD
      WWPUYNTCWWDUYLWWPIZNZUYMWXBVWTUYLHVRZUYMTPWXAVWTWWDWWPVWSUYLWWOVXEIZWWPVW
      SWNWXDKWWOWASZKWWOYBWWOVVDWWKWWOUMIZVUQYSHKUXHVLZUXIZKHVSSHWWOVSSZKWWOVSS
      UXJHWMUXKZKHWWOYBWMWXHUXLVLYDWWKWXFWXDWXEWEYSWXGKWWOXNVLUXMWWOKEWQVKWOWBW
      WDWXAWXCWWDWXAUYLHWWDWXAYTVVEHWWPIZYTWWDWXKWWOHWASZVVONZWXLVVOWXIWXLYTWXJ
      HWWOWMWXHUXOUXPUXNWWDVWKWXKWXMWEZWWHVVDWXFVWKWXNVUQWXGHWWOEYPYORUXQVVEWXA
      WXKUYLHWWPUXRUXSUXTUYAXIAUYLEFUYBXGXMXOWWPVXEWNZWWPXPIZXQWWTTPWXPWXOWWOEX
      RXSWWPCKXTVKVBVOVHWVNVBYQUYCUYDYLYM $.

    ${
      $d A i $.  $d X i $.  $d Y i $.  $d i j $.  $d i k $.  $d N j $.
      $d N k $.  $d Q j $.  $d Q k $.  $d X j $.  $d X k $.  $d Y j $.
      $d Y k $.  $d P k $.  $d i x $.  $d N x $.  $d P x $.  $d Q x $.
      $d X x $.  $d Y x $.
      axlowdimlem17.3 $e |- A =
          ( { <. 1 , X >. , <. 2 , Y >. } u. ( ( 3 ... N ) X. { 0 } ) ) $.
      axlowdimlem17.4 $e |- X e. RR $.
      axlowdimlem17.5 $e |- Y e. RR $.
      $( Lemma for ~ axlowdim .  Establish a congruence result.  (Contributed
         by Scott Fenton, 22-Apr-2013.)  (Proof shortened by Mario Carneiro,
         22-May-2014.) $)
      axlowdimlem17 $p |- ( ( N e. ( ZZ>= ` 3 ) /\
               I e. ( 2 ... ( N - 1 ) ) ) ->
           <. P , A >. Cgr <. Q , A >. ) $=
        ( vi c3 cfv wcel c2 c1 co cc0 cuz cmin cfz wa cop ccgr wbr cv cexp wceq
        csu caddc wne wss cz cle 3nn nnzi 2re 3re 2lt3 ltleii 2z mpbir2an uztrn
        eluz1i mpan2 ad2antrr fzss2 syl simpr sseldd wn fznuz adantl uzid ax-mp
        df-3 fveq2i eleqtri eleq1 mpbiri necon3bi axlowdimlem9 syl2anc ad2antlr
        elfzuz eluzp1p1 ssneldd syl5ibrcom necon3bd axlowdimlem12 eqtr4d oveq1d
        uzss eluzelz mpd sumeq2dv axlowdimlem16 csn cxp cpr fveq1i axlowdimlem2
        cun cin c0 wfn cr wf axlowdimlem4 ffn axlowdimlem1 fvun2 mp3an12 syl5eq
        mpan c0ex fvconst2 eqtrd oveq2d cee cc axlowdimlem7 cn nnuz fzss1 sseli
        fveecn subid1d uznnssnn syl2an 3eqtr4d adantr wb mpbird sylancom subcld
        sqcld fsumsplit 2nn axlowdimlem10 oveq12d eluzelre eluzle wi letr mpani
        a1i sylc 1re 1lt2 jctil 1z elfz fzsplit oveq1i syl6eqr fzfid eluz mp2an
        uneq2i mpbir axlowdimlem5 syl5eqel sylan brcgr syl22anc ) ENUAOZPZDQERU
        BSZUCSZPZUDZBAUECAUEUFUGZREUCSZMUHZBOZUVQAOZUBSZQUISZMUKZUVPUVQCOZUVSUB
        SZQUISZMUKZUJZUVNRQUCSZUWAMUKZNEUCSZUWAMUKZULSUWHUWEMUKZUWJUWEMUKZULSUW
        BUWFUVNUWIUWLUWKUWMULUVNUWHUWAUWEMUVNUVQUWHPZUDZUVTUWDQUIUWOUVRUWCUVSUB
        UWOUVRTUWCUWOUVQUVPPZUVQNUMZUVRTUJUWOUWHUVPUVQUWOEQUAOZPZUWHUVPUNUVJUWS
        UVMUWNUVJNUWRPZUWSUWTNUOPZQNUPUGZNUQURZQNUSUTVAVBZQNVCVFVDNEQVEVGVHQREV
        IVJUVNUWNVKVLZUWOUVQQRULSZUAOZPZVMZUWQUWNUXIUVNUVQRQVNVOZUXHUVQNUVQNUJU
        XHNUXGPNUVIUXGUXANUVIPUXCNVPVQNUXFUAVRVSVTUVQNUXGWAWBWCVJBUVQEHWDWEUWOU
        WPUVQDRULSZUMZUWCTUJUXEUWOUVQUXKUAOZPZVMUXLUWOUXMUXGUVQUWOUXKUXGPZUXMUX
        GUNUWODUWRPZUXOUVMUXPUVJUWNDQUVKWGWFQDWHVJZUXFUXKWOVJUXJWIUWOUXNUVQUXKU
        WOUXNUVQUXKUJUXKUXMPZUWOUXKUOPZUXRUWOUXOUXSUXQUXFUXKWPVJUXKVPVJUVQUXKUX
        MWAWJWKWQCDUVQEIWLWEWMWNWNWRUVNUWJUVRQUISZMUKUWJUWCQUISZMUKUWKUWMBCMDEH
        IWSUVNUWJUWAUXTMUVNUVQUWJPZUDZUVTUVRQUIUYCUVTUVRTUBSUVRUYCUVSTUVRUBUYBU
        VSTUJUVNUYBUVSUVQUWJTWTXAZOZTUYBUVSUVQRFUEQGUEXBZUYDXEZOZUYEUVQAUYGJXCU
        WHUWJXFXGUJZUYBUYHUYEUJZEXDZUYFUWHXHZUYDUWJXHZUYIUYBUDUYJUWHXIUYFXJUYLF
        GKLXKUWHXIUYFXLVQUWJXIUYDXJUYMEXMUWJXIUYDXLVQUWHUWJUYFUYDUVQXNXOXQXPUWJ
        TUVQXRXSXTVOZYAUYCUVRUYCBEYBOZPZUWPUVRYCPZUVJUYPUVMUYBBEHYDZVHUYBUWPUVN
        UWJUVPUVQNRUAOZPUWJUVPUNNYEUYSUQYFVTNREYGVQYHZVOBUVQEYIZWEYJXTWNWRUVNUW
        JUWEUYAMUYCUWDUWCQUIUYCUWDUWCTUBSUWCUYCUVSTUWCUBUYNYAUYCUWCUVNCUYOPZUWP
        UWCYCPZUYBUVJEYEPDRUVKUCSZPVUBUVMUVIYEENYEPUVIYEUNUQNYKVQYHUVLVUDDQUYSP
        UVLVUDUNQYEUYSUUAYFVTQRUVKYGVQYHCDEIUUBYLZUYTCUVQEYIZYLYJXTWNWRYMUUCUVN
        UWHUWJUWAUVPMUYIUVNUYKUUIZUVNUVPUWHUXFEUCSZXEZUWHUWJXEUVNQUVPPZUVPVUIUJ
        UVNVUJRQUPUGZQEUPUGZUDZUVJVUMUVMUVJVULVUKUVJEXIPZNEUPUGZVULNEUUDNEUUEVU
        NUXBVUOVULUXDQXIPNXIPVUNUXBVUOUDVULUUFUSUTQNEUUGXOUUHUUJRQUUKUSUULVBUUM
        YNUVNEUOPZVUJVUMYOZUVJVUPUVMNEWPYNQUOPZRUOPVUPVUQVCUUNQREUUOXOVJYPQREUU
        PVJUWJVUHUWHNUXFEUCVRUUQUVBUURZUVNREUUSZUVNUWPUDZUVTVVAUVRUVSUVNUWPUYPU
        YQUVJUYPUVMUWPUYRVHVUAYQUVNUWPAUYOPZUVSYCPUVJVVBUVMUWPUVJUWSVVBUVIUWREU
        WTUVIUWRUNUWTUXBUXDVURUXAUWTUXBYOVCUXCQNUUTUVAUVCQNWOVQYHUWSAUYGUYOJFGE
        KLUVDUVEVJZVHAUVQEYIYQZYRYSYTUVNUWHUWJUWEUVPMVUGVUSVUTVVAUWDVVAUWCUVSUV
        NVUBUWPVUCVUEVUFUVFVVDYRYSYTYMUVNUYPVVBVUBVVBUVOUWGYOUVJUYPUVMUYRYNUVJV
        VBUVMVVCYNZVUEVVEBACAMEUVGUVHYP $.
    $}

  $}

  ${
    $d N x y $.
    $( The lower dimensional axiom for one dimension.  In any dimension, there
       are at least two distinct points.  Theorem 3.13 of [Schwabhauser] p. 32,
       where it is derived from ~ axlowdim2 .  (Contributed by Scott Fenton,
       22-Apr-2013.) $)
    axlowdim1 $p |- ( N e. NN ->
               E. x e. ( EE ` N ) E. y e. ( EE ` N ) x =/= y ) $=
      ( wcel c1 csn cxp cfv cc0 wne cv wrex cr fconst6 elee mpbiri crn wceq syl
      wf cn cfz co cee 1re 0re wn ax-1ne0 df-ne 1ex sneqr mto c0 elnnuz eluzfz1
      mpbi sylbi ne0i rnxp eqeq12d mtbiri rneq nsyl neneqad neeq1 neeq2 rspc2ev
      cuz syl3anc ) CUADZECUBUCZEFZGZCUDHZDZVKIFZGZVNDZVMVQJZAKZBKZJZBVNLAVNLVJ
      VOVKMVMTVKEMUENVMCOPVJVRVKMVQTVKIMUFNVQCOPVJVMVQVJVMQZVQQZRZVMVQRVJWEVLVP
      RZWFEIRZEIJWGUGUHEIUIUPEIUJUKULVJWCVLWDVPVJVKUMJZWCVLRVJEVKDZWHVJCEVHHDWI
      CUNECUOUQVKEURSZVKVLUSSVJWHWDVPRWJVKVPUSSUTVAVMVQVBVCVDWBVSVMWAJABVMVQVNV
      NVTVMWAVEWAVQVMVFVGVI $.
  $}

  ${
    $d N i j x y z $.
    $( The lower two-dimensional axiom.  In any space where the dimension is
       greater than one, there are three non-colinear points.  Axiom A8 of
       [Schwabhauser] p. 12.  (Contributed by Scott Fenton, 15-Apr-2013.) $)
    axlowdim2 $p |- ( N e. ( ZZ>= ` 2 ) ->
       E. x e. ( EE ` N ) E. y e. ( EE ` N ) E. z e. ( EE ` N )
        -. ( x Btwn <. y , z >. \/ y Btwn <. z , x >. \/
             z Btwn <. x , y >. ) ) $=
      ( c2 wcel c1 cc0 cop cpr cun cv cbtwn wbr w3o wn wrex axlowdimlem5 breq2d
      0re cuz cfv c3 cfz co csn cxp cee 1re eqid axlowdimlem6 opeq2 opeq1 breq1
      wceq 3orbi123d notbid rspcev syl2anc rexbidv rspc2ev syl3anc ) DEUAUBFZGH
      IZEHIZJUCDUDUEHUFUGZKZDUHUBZFGGIVEJVFKZVHFVGVICLZIZMNZVIVJVGIZMNZVJVGVIIZ
      MNZOZPZCVHQZALZBLZVJIZMNZWAVJVTIZMNZVJVTWAIZMNZOZPZCVHQZBVHQAVHQHHDTTRGHD
      UITRVCVDEGIJVFKZVHFVGVIWKIZMNZVIWKVGIZMNZWKVOMNZOZPZVSHGDTUIRVGVIWKDVGUJV
      IUJWKUJUKVRWRCWKVHVJWKUOZVQWQWSVLWMVNWOVPWPWSVKWLVGMVJWKVIULSWSVMWNVIMVJW
      KVGUMSVJWKVOMUNUPUQURUSWJVSVGWBMNZWAVMMNZVJVGWAIZMNZOZPZCVHQABVGVIVHVHVTV
      GUOZWIXECVHXFWHXDXFWCWTWEXAWGXCVTVGWBMUNXFWDVMWAMVTVGVJULSXFWFXBVJMVTVGWA
      UMSUPUQUTWAVIUOZXEVRCVHXGXDVQXGWTVLXAVNXCVPXGWBVKVGMWAVIVJUMSWAVIVMMUNXGX
      BVOVJMWAVIVGULSUPUQUTVAVB $.
  $}

  ${
    $d N i k p x y z $.
    $( The general lower dimensional axiom.  Take a dimension ` N ` greater
       than or equal to three.  Then, there are three non-colinear points in
       ` N ` dimensional space that are equidistant from ` N - 1 ` distinct
       points.  Derived from remarks in "Tarski's System of Geometry", by
       Alfred Tarski and Steven Givant, Bull.  Symbolic Logic Volume 5, Number
       2 (1999), 175-214.  (Contributed by Scott Fenton, 22-Apr-2013.) $)
    axlowdim $p |- ( N e. ( ZZ>= ` 3 ) ->
       E. p E. x e. ( EE ` N ) E. y e. ( EE ` N ) E. z e. ( EE ` N )
         ( p : ( 1 ... ( N - 1 ) ) -1-1-> ( EE ` N ) /\
           A. i e. ( 2 ... ( N - 1 ) ) (
            <. ( p ` 1 ) , x >. Cgr <. ( p ` i ) , x >. /\
            <. ( p ` 1 ) , y >. Cgr <. ( p ` i ) , y >. /\
            <. ( p ` 1 ) , z >. Cgr <. ( p ` i ) , z >. ) /\
        -. ( x Btwn <. y , z >. \/ y Btwn <. z , x >. \/
             z Btwn <. x , y >. ) ) ) $=
      ( c3 wcel c1 co wceq cop cc0 ccgr wbr w3a c2 cbtwn syl opeq1d vk cuz cmin
      cfv cfz cee cv cneg csn cdif cxp cun caddc cif cmpt wf1 wral w3o wrex wex
      wn cpr wss cle 2re 3re 2lt3 ltleii cz wb nnzi eluz mp2an mpbir uzss ax-mp
      2z 3nn sseli 0re axlowdimlem5 1re eqid axlowdimlem15 wa axlowdimlem17 a1i
      1z peano2zm 3ad2ant2 2m1e1 cr wi zre mp3an12 mpani 3adant1 lesub1 mp3an13
      letr imp mpbid syl5eqbrr eluz2 3imtr4i eluzfz1 adantr eqeq1 oveq1 difeq2d
      3jca sneqd xpeq1d uneq12d ifbieq2d snex ovex difexg xpex unex ifex iftrue
      cvv fvmpt syl6eq cn 2nn nnuz eleqtri notbid breq12d 3anbi123d opeq2 breq1
      ralbidv breq2d opeq1 3orbi123d 3anbi23d fveq1 adantl clt 1lt2 ltnlei mpbi
      fzss1 intnanr eluzelz elfz eleq1 syl5ibrcom con2d iffalse eqtrd mpbir3and
      mtbiri ralrimiva axlowdimlem6 3anbi1d 3anbi2d 3anbi3d rspc3ev mptex f1eq1
      syl33anc 3anbi12d rexbidv 2rexbidv spcev ) EGUBUDZHZIEIUCJZUEJZEUFUDZUAUV
      MUAUGZIKZGIUHLZUIZIEUEJZGUIZUJZMUIZUKZULZUVOIUMJZILZUIZUVSUWEUIZUJZUWBUKZ
      ULZUNZUOZUPZIUWMUDZAUGZLZDUGZUWMUDZUWPLZNOZUWOBUGZLZUWSUXBLZNOZUWOCUGZLZU
      WSUXFLZNOZPZDQUVLUEJZUQZUWPUXBUXFLZROZUXBUXFUWPLZROZUXFUWPUXBLZROZURZVAZP
      ZCUVNUSZBUVNUSAUVNUSZUVMUVNFUGZUPZIUYDUDZUWPLZUWRUYDUDZUWPLZNOZUYFUXBLZUY
      HUXBLZNOZUYFUXFLZUYHUXFLZNOZPZDUXKUQZUXTPZCUVNUSZBUVNUSAUVNUSZFUTUVKIMLZQ
      MLZVBGEUEJUWBUKZULZUVNHZIILVUCVBVUDULZUVNHZVUBQILVBVUDULZUVNHZUWNUWOVUELZ
      UWSVUELZNOZUWOVUGLZUWSVUGLZNOZUWOVUILZUWSVUILZNOZPZDUXKUQZVUEVUGVUILZROZV
      UGVUIVUELZROZVUIVUEVUGLZROZURZVAZUYCUVKEQUBUDZHZVUFUVJVVJEGVVJHZUVJVVJVCV
      VLQGVDOZQGVEVFVGVHZQVIHZGVIHZVVLVVMVJVQGVRVKQGVLVMVNQGVOVPVSZMMEVTVTWASUV
      KVVKVUHVVQIMEWBVTWASUVKVVKVUJVVQMIEVTWBWASUAUWMEUWMWCZWDUVKVUTDUXKUVKUWRU
      XKHZWEZVUTUWDVUELZUWRIUMJZILZUIZUVSVWBUIZUJZUWBUKZULZVUELZNOZUWDVUGLZVWHV
      UGLZNOZUWDVUILZVWHVUILZNOZVUEUWDVWHUWREMMUWDWCZVWHWCZVUEWCZVTVTWFVUGUWDVW
      HUWREIMVWQVWRVUGWCZWBVTWFVUIUWDVWHUWREMIVWQVWRVUIWCZVTWBWFVVTVUMVWJVUPVWM
      VUSVWPVVTVUKVWAVULVWINVVTUWOUWDVUEVVTUWOIIKZUWDIIUMJZILZUIZUVSVXCUIZUJZUW
      BUKZULZUNZUWDVVTIUVMHZUWOVXJKZUVKVXKVVSUVKUVLIUBUDZHZVXKVVPEVIHZGEVDOZPZI
      VIHZUVLVIHZIUVLVDOZPUVKVXNVXQVXRVXSVXTVXRVXQWHWGVXOVVPVXSVXPEWIZWJVXQIQIU
      CJZUVLVDWKVXQQEVDOZVYBUVLVDOZVXOVXPVYCVVPVXOVXPVYCVXOVVMVXPVYCVVNVXOEWLHZ
      VVMVXPWEVYCWMZEWNZQWLHZGWLHVYEVYFVEVFQGEWTWOSWPXAWQVXQVYEVYCVYDVJZVXOVVPV
      YEVXPVYGWJVYHVYEIWLHVYIVEWBQEIWRWSSXBXCXKGEXDIUVLXDXEIUVLXFSZXGUAIUWLVXJU
      VMUWMUVPUVPVXBUWKVXIUWDUVOIIXHUVPUWGVXEUWJVXHUVPUWFVXDUVPUWEVXCIUVOIIUMXI
      ZTXLUVPUWIVXGUWBUVPUWHVXFUVSUVPUWEVXCVYKXLXJXMXNXOVVRVXBUWDVXIUVRUWCUVQXP
      UWAUWBUVSYCHZUWAYCHIEUEXQZUVSUVTYCXRVPMXPZXSXTZVXEVXHVXDXPVXGUWBVYLVXGYCH
      VYMUVSVXFYCXRVPVYNXSXTYAYDZSVXBVXJUWDKIWCVXBUWDVXIYBVPZYEZTVVTUWSVWHVUEVV
      TUWSUWRIKZUWDVWHUNZVWHVVTUWRUVMHZUWSVYTKVVSWUAUVKUXKUVMUWRQVXMHUXKUVMVCQY
      FVXMYGYHYIQIUVLUUFVPVSUUAUAUWRUWLVYTUVMUWMUVOUWRKZUVPVYSUWKVWHUWDUVOUWRIX
      HWUBUWGVWDUWJVWGWUBUWFVWCWUBUWEVWBIUVOUWRIUMXIZTXLWUBUWIVWFUWBWUBUWHVWEUV
      SWUBUWEVWBWUCXLXJXMXNXOVVRVYSUWDVWHVYOVWDVWGVWCXPVWFUWBVYLVWFYCHVYMUVSVWE
      YCXRVPVYNXSXTYAYDSVVTVYSVAZVYTVWHKUVKVVSWUDUVKVYSVVSUVKVVSVAVYSIUXKHZVAUV
      KWUEQIVDOZVXTWEZWUFVXTIQUUBOWUFVAUUCIQWBVEUUDUUEUUGUVKVXSWUEWUGVJZUVKVXOV
      XSGEUUHVYASVXRVVOVXSWUHWHVQIQUVLUUIWOSUUPVYSVVSWUEUWRIUXKUUJYJUUKUULXAVYS
      UWDVWHUUMSUUNZTYKVVTVUNVWKVUOVWLNVVTUWOUWDVUGVYRTVVTUWSVWHVUGWUITYKVVTVUQ
      VWNVURVWONUVKVUQVWNKVVSUVKUWOUWDVUIUVKUWOVXJUWDUVKVXKVXLVYJVYPSVYQYETXGVV
      TUWSVWHVUIWUITYKYLUUOUUQUVKVVKVVIVVQVUEVUGVUIEVWSVWTVXAUURSUYAUWNVVAVVIPU
      WNVUMUXEUXIPZDUXKUQZVUEUXMROZUXBUXFVUELZROZUXFVUEUXBLZROZURZVAZPUWNVUMVUP
      UXIPZDUXKUQZVUEVUGUXFLZROZVUGWUMROZUXFVVFROZURZVAZPABCVUEVUGVUIUVNUVNUVNU
      WPVUEKZUXLWUKUXTWURUWNWVGUXJWUJDUXKWVGUXAVUMUXEUXIWVGUWQVUKUWTVULNUWPVUEU
      WOYMUWPVUEUWSYMYKUUSYOWVGUXSWUQWVGUXNWULUXPWUNUXRWUPUWPVUEUXMRYNWVGUXOWUM
      UXBRUWPVUEUXFYMYPWVGUXQWUOUXFRUWPVUEUXBYQYPYRYJYSUXBVUGKZWUKWUTWURWVFUWNW
      VHWUJWUSDUXKWVHUXEVUPVUMUXIWVHUXCVUNUXDVUONUXBVUGUWOYMUXBVUGUWSYMYKUUTYOW
      VHWUQWVEWVHWULWVBWUNWVCWUPWVDWVHUXMWVAVUERUXBVUGUXFYQYPUXBVUGWUMRYNWVHWUO
      VVFUXFRUXBVUGVUEYMYPYRYJYSUXFVUIKZWUTVVAWVFVVIUWNWVIWUSVUTDUXKWVIUXIVUSVU
      MVUPWVIUXGVUQUXHVURNUXFVUIUWOYMUXFVUIUWSYMYKUVAYOWVIWVEVVHWVIWVBVVCWVCVVE
      WVDVVGWVIWVAVVBVUERUXFVUIVUGYMYPWVIWUMVVDVUGRUXFVUIVUEYQYPUXFVUIVVFRYNYRY
      JYSUVBUVEVUAUYCFUWMUAUVMUWLIUVLUEXQUVCUYDUWMKZUYTUYBABUVNUVNWVJUYSUYACUVN
      WVJUYEUWNUYRUXLUXTUVMUVNUYDUWMUVDWVJUYQUXJDUXKWVJUYJUXAUYMUXEUYPUXIWVJUYG
      UWQUYIUWTNWVJUYFUWOUWPIUYDUWMYTZTWVJUYHUWSUWPUWRUYDUWMYTZTYKWVJUYKUXCUYLU
      XDNWVJUYFUWOUXBWVKTWVJUYHUWSUXBWVLTYKWVJUYNUXGUYOUXHNWVJUYFUWOUXFWVKTWVJU
      YHUWSUXFWVLTYKYLYOUVFUVGUVHUVIS $.
  $}

  $(
  @{
    @d A i @.  @d P i @.  @d Q i @.  @d N i @.
    @( Lemma for ~ axupdim .  A condition for two points to be equidistant from
       a third. @)
    axupdimlem1 @p |- ( ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\
       A e. ( EE ` N ) ) ->
       ( <. P , A >. Cgr <. Q , A >. <->
         sum_ i e. ( 1 ... N ) ( ( ( P ` i ) - ( Q ` i ) ) x. ( A ` i ) ) =
         ( sum_ i e. ( 1 ... N ) ( ( ( P ` i ) ^ 2 ) - ( ( Q ` i ) ^ 2 ) )
           / 2 ) ) ) @=
       ( cee cfv wcel w3a cop ccgr wbr c1 cfz co cv cmin c2 cexp csu wceq cmul
       cdiv wb brcgr 3impdir cc0 wa cc fveecn 3ad2antl1 3ad2antl2 3ad2antl3
       caddc binom2sub 3adant2 3adant1 oveq12d sqcl 3ad2ant1 2cn mulcl
       mulcl sylancr 3ad2ant2 sub4 syl22anc subcl syl2anc 3ad2ant3 pnpcan2
       syl3anc subdir oveq2d subdi mp3an1 eqtrd 3eqtr4d sumeq2dv eqeq1d cuz
       wral cn eleenn nnuz syl6eleq syl jca ralrimiva fsumsub fsumcl subeq0
       bitrd fsummulc1 mp3an2 eqeq2d 3bitr4d eqcom syl6bb wne 2ne0 pm3.2i
       divmul mp3an3 bitr4d 3bitr3d ) BEFGZHZCXGHZAXGHZIZBAJCAJKLZMENOZDPZBGZXN
       AGZQOZRSOZDTZXMXNCGZXPQOZRSOZDTZUAZXMXOXTQOZXPUBOZDTZXMXORSOZXTRSOZQOZDT
       ZRUCOZUAZXHXJXIXLYDUDBACADEUEUFXKXMXRYBQOZDTZUGUAZXMYJRYFUBOZQOZDTZUGUAZ
       YDYMXKYOYSUGXKXMYNYRDXKXNXMHZUHZXOUIHZXTUIHZXPUIHZYNYRUAXHXIUUAUUCXJBXNE
       UJUKZXIXHUUAUUDXJCXNEUJULZXJXHUUAUUEXIAXNEUJUMZUUCUUDUUEIZYNYHRXOXPUBOZU
       BOZQOZXPRSOZUNOZYIRXTXPUBOZUBOZQOZUUMUNOZQOZYRUUIXRUUNYBUURQUUCUUEXRUUNU
       AUUDXOXPUOUPUUDUUEYBUURUAUUCXTXPUOUQURUUIUULUUQQOZYJUUKUUPQOZQOZUUSYRUUI
       YHUIHZUUKUIHZYIUIHZUUPUIHZUUTUVBUAUUCUUDUVCUUEXOUSZUTZUUIRUIHZUUJUIHZUVD
       VAUUCUUEUVJUUDXOXPVBUPZRUUJVCVDZUUDUUCUVEUUEXTUSZVEZUUIUVIUUOUIHZUVFVAUU
       DUUEUVOUUCXTXPVBUQZRUUOVCVDZYHUUKYIUUPVFVGUUIUULUIHZUUQUIHZUUMUIHZUUSUUT
       UAUUIUVCUVDUVRUVHUVLYHUUKVHVIUUIUVEUVFUVSUVNUVQYIUUPVHVIUUEUUCUVTUUDXPUS
       VJUULUUQUUMVKVLUUIYQUVAYJQUUIYQRUUJUUOQOZUBOZUVAUUIYFUWARUBXOXTXPVMVNUUI
       UVJUVOUWBUVAUAZUVKUVPUVIUVJUVOUWCVARUUJUUOVOVPVIVQVNVRVQVLVSVTXKYPXSYCQO
       ZUGUAZYDXKYOUWDUGXKEMWAGZHZXRUIHZYBUIHZUHZDXMWBYOUWDUAXKEWCUWFXHXIEWCHXJ
       BEWDUTWEWFZXKUWJDXMUUBUWHUWIUUBXQUIHZUWHUUBUUCUUEUWLUUFUUHXOXPVHVIXQUSWG
       ZUUBYAUIHZUWIUUBUUDUUEUWNUUGUUHXTXPVHVIYAUSWGZWHWIXRYBDMEWJVIVTXKXSUIHZY
       CUIHZUWEYDUDXKUWGUWHDXMWBUWPUWKXKUWHDXMUWMWIXRDMEWKVIXKUWGUWIDXMWBUWQUWK
       XKUWIDXMUWOWIYBDMEWKVIXSYCWLVIWMXKYTYLYGUAZYMXKYTRYGUBOZYKUAZUWRXKYTYKUW
       SUAZUWTXKYKXMYQDTZQOZUGUAZYKUXBUAZYTUXAXKYKUIHZUXBUIHZUXDUXEUDXKUWGYJUIH
       ZDXMWBUXFUWKXKUXHDXMUUBUVCUVEUXHUUBUUCUVCUUFUVGWGUUBUUDUVEUUGUVMWGYHYIVH
       VIZWIYJDMEWKVIZXKUWGYQUIHZDXMWBUXGUWKXKUXKDXMUUBUVIYFUIHZUXKVAUUBYEUIHZU
       UEUXLUUBUUCUUDUXMUUFUUGXOXTVHVIUUHYEXPVCVIZRYFVCVDZWIYQDMEWKVIYKUXBWLVIX
       KYSUXCUGXKUWGUXHUXKUHZDXMWBYSUXCUAUWKXKUXPDXMUUBUXHUXKUXIUXOWHWIYJYQDMEW
       JVIVTXKUWSUXBYKXKUWGUXLDXMWBZUWSUXBUAZUWKXKUXLDXMUXNWIZUWGUVIUXQUXRVAYFR
       DMEWNWOVIWPWQYKUWSWRWSXKUXFYGUIHZUWRUWTUDZUXJXKUWGUXQUXTUWKUXSYFDMEWKVIU
       XFUXTUVIRUGWTZUHUYAUVIUYBVAXAXBYKYGRXCXDVIXEYLYGWRWSXFWM @.
       @( [19-Apr-2014] @) @( [8-Jul-2013] @)
  @}

  @{
    @d J j @.  @d K j k @.  @d N j k @.  @d P j k @.
    axupdimlem2.1 @e |- Q = ( k e. ( 1 ... ( N - 1 ) ) |->
       ( j e. ( 1 ... N ) |->
         ( ( ( P ` 1 ) ` j ) - ( ( P ` ( k + 1 ) ) ` j ) ) ) ) @.
    @( Lemma for ~ axupdim .  Calculate the value of a mapping used from here
       on out. @)
    axupdimlem2 @p |- ( ( K e. ( 1 ... ( N - 1 ) ) /\ J e. ( 1 ... N ) ) ->
       ( ( Q ` K ) ` J ) =
         ( ( ( P ` 1 ) ` J ) - ( ( P ` ( K + 1 ) ) ` J ) ) ) @=
       ( c1 cmin co cfz wcel cfv cv caddc cmpt wceq eqidd oveq1 fveq2d fveq1d
       oveq2d mpteq12dv cvv ovex mptexg ax-mp fvmpt fveq2 oveq12d eqid
       sylan9eq ) FIGIJKLKZMZEIGLKZMEFBNZNECUPCOZIANZNZURFIPKZANZNZJKZQZNEUSNZE
       VBNZJKZUOEUQVEDFCUPUTURDOZIPKZANZNZJKZQVEUNBVIFRZCUPVMUPVDVNUPSVNVLVCUTJ
       VNURVKVBVNVJVAAVIFIPTUAUBUCUDHUPUEMVEUEMIGLUFCUPVDUEUGUHUIUBCEVDVHUPVEUR
       ERUTVFVCVGJUREUSUJUREVBUJUKVEULVFVGJUFUIUM @.
       @( [19-Apr-2014] @) @( [17-Jul-2013] @)
  @}

  @{
    @d N i j @.  @d N k p q @.  @d P i j @.  @d P k j p q @.  @d Q i p q @.
    axupdimlem3.1 @e |- Q = ( k e. ( 1 ... ( N - 1 ) ) |->
       ( j e. ( 1 ... N ) |->
         ( ( ( P ` 1 ) ` j ) - ( ( P ` ( k + 1 ) ) ` j ) ) ) ) @.
    @( Lemma for ~ axupdim .  Show that the translation of the ` P ` points
       results in a one-to-one function into points. @)
    axupdimlem3 @p |- ( ( N e. NN /\ P : ( 1 ... N ) -1-1-> ( EE ` N ) ) ->
       Q : ( 1 ... ( N - 1 ) ) -1-1-> ( EE ` N ) ) @=
       ( vp vq vi cn wcel c1 cfz co cee cfv wf1 wa cmin wf cv wceq wi wral
       caddc cmpt f1f adantl cuz elnnuz eluzfz1 sylbi adantr ffvelrn syl2anc
       simplr syl fznatpl1 adantlr eqid eleesub ex fmptd simprl axupdimlem2
       sylan simprr eqeq12d cc wb syl2an ancoms fveecn simpl simpr subcan
       syl3anc bitrd ralbidva eqidd oveq1 fveq2d fveq1d oveq2d mpteq12dv
       cvv ovex mptexg ax-mp fvmpt eleesubd eqeefv 3bitr4d f1fveq syl12anc cz
       elfzelz zcn ax-1cn addcan2 mp3an3 biimpd ralrimivva jca dff13 sylibr )
       EJKZLEMNZEOPZAQZRZLELSNZMNZXIBTZGUAZBPZHUAZBPZUBZXOXQUBZUCZHXMUDGXMUDZRX
       MXIBQXKXNYBXKDXMCXHCUAZLAPZPZYCDUAZLUENZAPZPZSNZUFZXIBXKYFXMKZYKXIKZXKYL
       RZYDXIKZYHXIKZYMXKYOYLXKXHXIATZLXHKZYOXJYQXGXHXIAUGZUHXGYRXJXGELUIPKYREU
       JLEUKULZUMXHXILAUNZUOUMYNYQYGXHKZYPYNXJYQXGXJYLUPYSUQXGYLUUBXJYFEURUSXHX
       IYGAUNUOYDYHYKCEYKUTVAUOVBFVCXKYAGHXMXMXKXOXMKZXQXMKZRZRZXSXTUUFXSXOLUEN
       ZXQLUENZUBZXTUUFXSUUGAPZUUHAPZUBZUUIUUFIUAZXPPZUUMXRPZUBZIXHUDZUUMUUJPZU
       UMUUKPZUBZIXHUDZXSUULUUFUUPUUTIXHUUFUUMXHKZRZUUPUUMYDPZUURSNZUVDUUSSNZUB
       ZUUTUVCUUNUVEUUOUVFUUFUUCUVBUUNUVEUBXKUUCUUDVDZABCDUUMXOEFVEVFUUFUUDUVBU
       UOUVFUBXKUUCUUDVGZABCDUUMXQEFVEVFVHUVCUVDVIKZUURVIKZUUSVIKZUVGUUTVJUUFYO
       UVBUVJXKYOUUEXJXGYOXJYQYRYOXGYSYTUUAVKVLUMZYDUUMEVMVFUUFUUJXIKZUVBUVKUUF
       YQUUGXHKZUVNUUFXJYQXGXJUUEUPZYSUQZXKXGUUCUVOUUEXGXJVNZUUCUUDVNXOEURVKZXH
       XIUUGAUNUOZUUJUUMEVMVFUUFUUKXIKZUVBUVLUUFYQUUHXHKZUWAUVQXKXGUUDUWBUUEUVR
       UUCUUDVOXQEURVKZXHXIUUHAUNUOZUUKUUMEVMVFUVDUURUUSVPVQVRVSUUFXPXIKZXRXIKZ
       XSUUQVJUUFUUCYOUVNUWEUVHUVMUVTUUCYDUUJXPCEDXOYKCXHYEYCUUJPZSNZUFZXMBYFXO
       UBZCXHYJXHUWHUWJXHVTUWJYIUWGYESUWJYCYHUUJUWJYGUUGAYFXOLUEWAWBWCWDWEFXHWF
       KZUWIWFKLEMWGZCXHUWHWFWHWIWJWKVQUUFUUDYOUWAUWFUVIUVMUWDUUDYDUUKXRCEDXQYK
       CXHYEYCUUKPZSNZUFZXMBYFXQUBZCXHYJXHUWNUWPXHVTUWPYIUWMYESUWPYCYHUUKUWPYGU
       UHAYFXQLUEWAWBWCWDWEFUWKUWOWFKUWLCXHUWNWFWHWIWJWKVQXPXRIEWLUOUUFUVNUWAUU
       LUVAVJUVTUWDUUJUUKIEWLUOWMUUFXJUVOUWBUULUUIVJUVPUVSUWCXHXIUUGUUHAWNWOVRU
       UFXOVIKZXQVIKZUUIXTVJZUUEUWQXKUUCUWQUUDUUCXOWPKUWQXOLXLWQXOWRUQUMUHUUEUW
       RXKUUDUWRUUCUUDXQWPKUWRXQLXLWQXQWRUQUHUHUWQUWRLVIKUWSWSXOXQLWTXAUOVRXBXC
       XDGHXMXIBXEXF @.
       @( [19-Apr-2014] @) @( [17-Jul-2013] @)
  @}

  @{
    @d I a j k @.  @d N a j k @.  @d P a j k @.
    axupdimlem4.1 @e |- Q = ( k e. ( 1 ... ( N - 1 ) ) |->
       ( j e. ( 1 ... N ) |->
         ( ( ( P ` 1 ) ` j ) - ( ( P ` ( k + 1 ) ) ` j ) ) ) ) @.
    @( Lemma for ~ axupdim .  For all values of ` Q ` , there is some non-zero
       value of it. @)
    axupdimlem4 @p |- ( ( N e. NN /\ P : ( 1 ... N ) -1-1-> ( EE ` N ) /\
       I e. ( 1 ... ( N - 1 ) ) ) ->
       E. a e. ( 1 ... N ) ( ( Q ` I ) ` a ) =/= 0 ) @=
       ( cn wcel c1 cfz co cee cfv wf1 cmin w3a cv cc0 wne wrex caddc wceq
       wral wn cr clt wbr cz elfzelz peano2zd zre syl 3ad2ant3 1re a1i
       peano2re ltp1 cle elfzle1 wb leadd1 mp3an13 mpbid ltletrd ltneOLD mp3an1
       syl2anc simp2 fznatpl1 3adant2 cuz elnnuz eluzfz1 sylbi 3ad2ant1
       f1fveq syl12anc necon3bid mpbird necomd df-ne sylib wf f1f ffvelrn
       syl2an ancoms 3adant3 3ad2ant2 eqeefv mtbid rexbii rexnal bitri sylibr
       wa axupdimlem2 3ad2antl3 eqeq1d cc fveecn sylan subeq0 bitrd rexbidva )
       FIJZKFLMZFNOZAPZEKFKQMZLMJZRZGSZEBOOZTUAZGXIUBXOKAOZOZXOEKUCMZAOZOZUAZGX
       IUBZXNXSYBUDZGXIUEZUFZYDXNXRYAUDZYFXNXRYAUAYHUFXNYAXRXNYAXRUAXTKUAZXNXTU
       GJZKXTUHUIZYIXMXHYJXKXMXTUJJYJXMEEKXLUKZULXTUMUNUOZXNKKKUCMZXTKUGJZXNUPU
       QZXNYOYNUGJYPKURUNYMXNYOKYNUHUIYPKUSUNXNKEUTUIZYNXTUTUIZXMXHYQXKEKXLVAUO
       XNEUGJZYQYRVBZXMXHYSXKXMEUJJYSYLEUMUNUOYOYSYOYTUPUPKEKVCVDUNVEVFYOYJYKYI
       UPKXTVGVHVIXNYAXRXTKXNXKXTXIJZKXIJZYAXRUDXTKUDVBXHXKXMVJXHXMUUAXKEFVKVLZ
       XHXKUUBXMXHFKVMOJUUBFVNKFVOVPZVQXIXJXTKAVRVSVTWAWBXRYAWCWDXNXRXJJZYAXJJZ
       YHYFVBXHXKUUEXMXKXHUUEXKXIXJAWEZUUBUUEXHXIXJAWFZUUDXIXJKAWGWHWIWJZXNUUGU
       UAUUFXKXHUUGXMUUHWKUUCXIXJXTAWGVIZXRYAGFWLVIWMYDYEUFZGXIUBYGYCUUKGXIXSYB
       WCWNYEGXIWOWPWQXNXQYCGXIXNXOXIJZWRZXPTXSYBUUMXPTUDXSYBQMZTUDZYEUUMXPUUNT
       XMXHUULXPUUNUDXKABCDXOEFHWSWTXAUUMXSXBJZYBXBJZUUOYEVBXNUUEUULUUPUUIXRXOF
       XCXDXNUUFUULUUQUUJYAXOFXCXDXSYBXEVIXFVTXGWA @.
       @( [19-Apr-2014] @) @( [17-Jul-2013] @)
  @}

  @{
    @d A p x y @.  @d B p x y @.  @d N p x y @.
    axupdimlem5.1 @e |- T = ( x e. ( EE ` N ) , y e. ( EE ` N ) |->
        sum_ p e. ( 1 ... N ) ( ( x ` p ) x. ( y ` p ) ) ) @.
    @( Lemma for ~ axupdim .  Calculate the value of a dot product of two
       points. @)
    axupdimlem5 @p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
      ( A T B ) = sum_ p e. ( 1 ... N ) ( ( A ` p ) x. ( B ` p ) ) ) @=
       ( cee cfv c1 cfz co cv cmul csu wceq fveq1 oveq1d sumeq2sdv oveq2d
       sumex ovmpt2 ) ABCDFIJZUDKFLMZGNZANZJZUFBNZJZOMZGPUEUFCJZUFDJZOMZGPEUEUL
       UJOMZGPUGCQZUEUKUOGUPUHULUJOUFUGCRSTUIDQZUEUOUNGUQUJUMULOUFUIDRUATHUEUNG
       UBUC @.
       @( [19-Apr-2014] @) @( [8-Aug-2013] @)

    @{
      @d A i @.  @d N i @.  @d p i @.
      @( Lemma for ~ axupdim .  The dot product of a point with itself is zero
         iff all coordinates of the points are zero. @)
      axupdimlem6 @p |- ( A e. ( EE ` N ) ->
       ( ( A T A ) = 0 <-> A. i e. ( 1 ... N ) ( A ` i ) = 0 ) ) @=
       ( cee cfv wcel co cc0 wceq c1 cfz cv cmul csu wral axupdimlem5 anidms
       eqeq1d cuz cr cle wbr wa wb cn eleenn nnuz syl6eleq fveere remulcl
       msqge0 jca syl ralrimiva fsum00 syl2anc cc fveecn c2 cexp sqval sqeq0
       bitr3d ralbidva fveq2 cbvralv syl6bb bitrd ) CFIJKZCCDLZMNOFPLZGQZCJZVRR
       LZGSZMNZEQZCJZMNZEVPTZVNVOVTMVNVOVTNABCCDFGHUAUBUCVNWAVSMNZGVPTZWEVNFOUD
       JZKVSUEKZMVSUFUGZUHZGVPTWAWGUIVNFUJWHCFUKULUMVNWKGVPVNVQVPKUHZVRUEKZWKCV
       QFUNWMWIWJWMWIVRVRUOUBVRUPUQURUSVSGOFUTVAVNWGVRMNZGVPTWEVNWFWNGVPWLVRVBK
       ZWFWNUICVQFVCWOVRVDVELZMNWFWNWOWPVSMVRVFUCVRVGVHURVIWNWDGEVPVQWBNVRWCMVQ
       WBCVJUCVKVLVMVM @.
       @( [19-Apr-2014] @) @( [8-Aug-2013] @)
    @}

    @( Lemma for ~ axupdim .  The dot product of two points is a real. @)
    axupdimlem7 @p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
       ( A T B ) e. RR ) @=
       ( cee cfv wcel wa co c1 cfz cv cmul csu cr axupdimlem5 cuz wral cn
       eleenn nnuz syl6eleq adantr fveere remulcl syl2an anandirs ralrimiva
       fsumrecl syl2anc eqeltrd ) CFIJZKZDUPKZLZCDEMNFOMZGPZCJZVADJZQMZGRZSABC
       DEFGHTUSFNUAJZKZVDSKZGUTUBVESKUQVGURUQFUCVFCFUDUEUFUGUSVHGUTUQURVAUTKZVH
       UQVILVBSKVCSKVHURVILCVAFUHDVAFUHVBVCUIUJUKULVDGNFUMUNUO @.
       @( [19-Apr-2014] @) @( [8-Aug-2013] @)
  @}

  @{
    @d A i p @.  @d A k @.  @d B i @.  @d B k p @.  @d D p y @.  @d I i @.
    @d I j k p @.  @d I x y @.  @d N i @.  @d N j k p @.  @d N x y @.
    @d P i @.  @d P j k p @.  @d Q p x y @.  @d D x @.
    axupdimlem8.1 @e |- Q = ( k e. ( 1 ... ( N - 1 ) ) |->
       ( j e. ( 1 ... N ) |->
         ( ( ( P ` 1 ) ` j ) - ( ( P ` ( k + 1 ) ) ` j ) ) ) ) @.
    axupdimlem8.2 @e |- D = ( k e. ( 1 ... N ) |->
       ( ( B ` k ) - ( A ` k ) ) ) @.
    axupdimlem8.3 @e |- T = ( x e. ( EE ` N ) , y e. ( EE ` N ) |->
        sum_ p e. ( 1 ... N ) ( ( x ` p ) x. ( y ` p ) ) ) @.
    @( Lemma for ~ axupdim .  The dot product of a ` Q ` and ` D ` is zero. @)
    axupdimlem8 @p |- ( ( ( ( N e. NN /\ P : ( 1 ... N ) -1-1-> ( EE ` N ) )
       /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) /\
       A. i e. ( 2 ... N ) ( <. ( P ` 1 ) , A >. Cgr <. ( P ` i ) , A >. /\
           <. ( P ` 1 ) , B >. Cgr <. ( P ` i ) , B >. ) /\
       I e. ( 1 ... ( N - 1 ) ) ) -> ( ( Q ` I ) T D ) = 0 ) @=
       ( cn wcel c1 cfz co cee cfv wf1 wa cop cv ccgr wbr c2 wral cmin w3a
       cmul csu cc0 wceq caddc simp3 wf simp1lr f1f syl simp1ll cuz elnnuz
       eluzfz1 sylbi ffvelrn syl2anc fznatpl1 cmpt eqidd oveq1 fveq2d fveq1d
       oveq2d mpteq12dv cvv ovex mptexg ax-mp fvmpt eleesubd syl3anc
       simp1rr simp1rl eleesub axupdimlem5 cexp cdiv axupdimlem2 sylan fveq2
       oveq12d adantl cc fveecn subcl subdi eqtrd sumeq2dv sylib mulcl jca
       ralrimiva fsumsub cle df-2 elfzle1 cr wb cz elfzelz zre 1re leadd1
       mp3an13 mpbid 3ad2ant3 syl5eqbr elfzle2 peano2z nnz 2z elfz mp3an2
       mpbird simp2 opeq1d breq2d anbi12d rspcv sylc simprd axupdimlem1
       simpld sqcl fsumcl halfcl subid 3eqtrd ) MRSZTMUAUBZMUCUDZFUEZUFZCUUFSZD
       UUFSZUFZUFZTFUDZCUGZIUHZFUDZCUGZUIUJZUUMDUGZUUPDUGZUIUJZUFZIUKMUAUBZULZL
       TMTUMUBZUAUBZSZUNZLGUDZEHUBZUUENUHZUVIUDZUVKEUDZUOUBZNUPZUQUVHUVIUUFSZEU
       UFSZUVJUVOURUVHUVGUUMUUFSZLTUSUBZFUDZUUFSZUVPUULUVDUVGUTZUVHUUEUUFFVAZTU
       UESZUVRUVHUUGUWCUUDUUGUUKUVDUVGVBUUEUUFFVCVDZUVHUUDUWDUUDUUGUUKUVDUVGVEZ
       UUDMTVFUDSZUWDMVGZTMVHVIVDUUEUUFTFVJVKZUVHUWCUVSUUESZUWAUWEUVHUUDUVGUWJU
       WFUWBLMVLVKZUUEUUFUVSFVJVKZUVGUUMUVTUVIJMKLJUUEJUHZUUMUDZUWMKUHZTUSUBZFU
       DZUDZUMUBZVMJUUEUWNUWMUVTUDZUMUBZVMZUVFGUWOLURZJUUEUWSUUEUXAUXCUUEVNUXCU
       WRUWTUWNUMUXCUWMUWQUVTUXCUWPUVSFUWOLTUSVOVPVQVRVSOUUEVTSUXBVTSTMUAWAJUUE
       UXAVTWBWCWDWEWFUVHUUJUUIUVQUUIUUJUUHUVDUVGWGZUUIUUJUUHUVDUVGWHZDCEKMPWIV
       KABUVIEHMNQWJVKUVHUVOUUEUVKUUMUDZUVKUVTUDZUMUBZUVKDUDZUOUBZNUPZUUEUXHUVK
       CUDZUOUBZNUPZUMUBZUUEUXFUKWKUBZUXGUKWKUBZUMUBZNUPZUKWLUBZUXTUMUBZUQUVHUV
       OUUEUXJUXMUMUBZNUPZUXOUVHUUEUVNUYBNUVHUVKUUESZUFZUVNUXHUXIUXLUMUBZUOUBZU
       YBUYEUVLUXHUVMUYFUOUVHUVGUYDUVLUXHURUWBFGJKUVKLMOWMWNUYDUVMUYFURUVHKUVKU
       WODUDZUWOCUDZUMUBUYFUUEEUWOUVKURUYHUXIUYIUXLUMUWOUVKDWOUWOUVKCWOWPPUXIUX
       LUMWAWDWQWPUYEUXHWRSZUXIWRSZUXLWRSZUYGUYBURUYEUXFWRSZUXGWRSZUYJUVHUVRUYD
       UYMUWIUUMUVKMWSWNZUVHUWAUYDUYNUWLUVTUVKMWSWNZUXFUXGWTVKZUVHUUJUYDUYKUXDD
       UVKMWSWNZUVHUUIUYDUYLUXECUVKMWSWNZUXHUXIUXLXAWFXBXCUVHUWGUXJWRSZUXMWRSZU
       FZNUUEULUYCUXOURUVHUUDUWGUWFUWHXDZUVHVUBNUUEUYEUYTVUAUYEUYJUYKUYTUYQUYRU
       XHUXIXEVKUYEUYJUYLVUAUYQUYSUXHUXLXEVKXFXGUXJUXMNTMXHVKXBUVHUXKUXTUXNUXTU
       MUVHUUSUVTDUGZUIUJZUXKUXTURZUVHUUNUVTCUGZUIUJZVUEUVHUVSUVCSZUVDVUHVUEUFZ
       UVHVUIUKUVSXIUJZUVSMXIUJZUFZUVHVUKVULUVHUKTTUSUBZUVSXIXJUVGUULVUNUVSXIUJ
       ZUVDUVGTLXIUJZVUOLTUVEXKUVGLXLSZVUPVUOXMZUVGLXNSZVUQLTUVEXOZLXPVDTXLSZVU
       QVVAVURXQXQTLTXRXSVDXTYAYBUVHUWJVULUWKUVSTMYCVDXFUVHUVSXNSZMXNSZVUIVUMXM
       ZUVGUULVVBUVDUVGVUSVVBVUTLYDVDYAUVHUUDVVCUWFMYEVDVVBUKXNSVVCVVDYFUVSUKMY
       GYHVKYIUULUVDUVGYJUVBVUJIUVSUVCUUOUVSURZUURVUHUVAVUEVVEUUQVUGUUNUIVVEUUP
       UVTCUUOUVSFWOZYKYLVVEUUTVUDUUSUIVVEUUPUVTDVVFYKYLYMYNYOZYPUVHUVRUWAUUJVU
       EVUFXMUWIUWLUXDDUUMUVTNMYQWFXTUVHVUHUXNUXTURZUVHVUHVUEVVGYRUVHUVRUWAUUIV
       UHVVHXMUWIUWLUXECUUMUVTNMYQWFXTWPUVHUXTWRSZUYAUQURUVHUXSWRSZVVIUVHUWGUXR
       WRSZNUUEULVVJVUCUVHVVKNUUEUYEUXPWRSZUXQWRSZVVKUYEUYMVVLUYOUXFYSVDUYEUYNV
       VMUYPUXGYSVDUXPUXQWTVKXGUXRNTMYTVKUXSUUAVDUXTUUBVDUUCXB @.
       @( [19-Apr-2014] @) @( [17-Jul-2013] @)
  @}

  @{
    @d A i @.  @d A k @.  @d B i @.  @d B k @.  @d D i @.  @d D p @.  @d D x @.
    @d D y @.  @d i k @.  @d i p @.  @d N i @.  @d N k @.  @d N p @.  @d N x @.
    @d N y @.  @d p x @.  @d p y @.  @d x y @.
    axupdimlem9.1 @e |- D = ( k e. ( 1 ... N ) |->
       ( ( B ` k ) - ( A ` k ) ) ) @.
    axupdimlem9.2 @e |- T = ( x e. ( EE ` N ) , y e. ( EE ` N ) |->
        sum_ p e. ( 1 ... N ) ( ( x ` p ) x. ( y ` p ) ) ) @.
    @( Lemma for ~ axupdim .  The dot product of ` D ` with itself is non-zero
       iff ` A ` and ` B ` are distinct. @)
    axupdimlem9 @p |- ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
       ( ( D T D ) = 0 <-> A = B ) ) @=
       ( vi cee cfv wcel wa cv cc0 wceq c1 cfz co wral cmin wb fveq2 oveq12d
       ovex fvmpt eqeq1d adantl cc fveecn subeq0 syl2an ancoms anandirs eqcom
       syl6bb bitrd ralbidva eleesub axupdimlem6 syl eqeefv 3bitr4d ) CHMNZOZDV
       GOZPZLQZENZRSZLTHUAUBZUCZVKCNZVKDNZSZLVNUCEEFUBRSZCDSVJVMVRLVNVJVKVNOZPZ
       VMVQVPUDUBZRSZVRVTVMWCUEVJVTVLWBRGVKGQZDNZWDCNZUDUBWBVNEWDVKSWEVQWFVPUDW
       DVKDUFWDVKCUFUGJVQVPUDUHUIUJUKWAWCVQVPSZVRVHVIVTWCWGUEZVIVTPZVHVTPZWHWIV
       QULOVPULOWHWJDVKHUMCVKHUMVQVPUNUOUPUQVQVPURUSUTVAVJEVGOZVSVOUEVIVHWKDCEG
       HJVBUPABEFLHIKVCVDCDLHVEVF @.
       @( [19-Apr-2014] @) @( [11-Aug-2013] @)
  @}

  @{
    @d a p @.  @d I a j k @.  @d I p @.  @d I x y @.  @d N a j k @.  @d N p @.
    @d N x y @.  @d P a j k @.  @d p x y @.  @d Q a p @.  @d Q x y @.
    axupdimlem10.1 @e |- Q = ( k e. ( 1 ... ( N - 1 ) ) |->
       ( j e. ( 1 ... N ) |->
         ( ( ( P ` 1 ) ` j ) - ( ( P ` ( k + 1 ) ) ` j ) ) ) ) @.
    axupdimlem10.2 @e |- T = ( x e. ( EE ` N ) , y e. ( EE ` N ) |->
        sum_ p e. ( 1 ... N ) ( ( x ` p ) x. ( y ` p ) ) ) @.
    @( Lemma for ~ axupdim .  The dot product of a ` Q ` with itself is
       nonzero. @)
    axupdimlem10 @p |- ( ( N e. NN /\ P : ( 1 ... N ) -1-1-> ( EE ` N ) /\
       I e. ( 1 ... ( N - 1 ) ) ) -> ( ( Q ` I ) T ( Q ` I ) ) =/= 0 ) @=
       ( va cn wcel c1 cfz co cee cfv wf1 cmin w3a cc0 wceq wn wne cv wral
       wrex axupdimlem4 df-ne rexbii rexnal bitri sylib wb wa wf axupdimlem3
       f1f syl ffvelrn sylan 3impa axupdimlem6 mtbird sylibr ) INOZPIQRZISTZCUA
       ZHPIPUBRQRZOZUCZHDTZVPERZUDUEZUFVQUDUGVOVRMUHVPTZUDUEZMVJUIZVOVSUDUGZMVJ
       UJZWAUFZCDFGHIMKUKWCVTUFZMVJUJWDWBWEMVJVSUDULUMVTMVJUNUOUPVOVPVKOZVRWAUQ
       VIVLVNWFVIVLURZVMVKDUSZVNWFWGVMVKDUAWHCDFGIKUTVMVKDVAVBVMVKHDVCVDVEABVPE
       MIJLVFVBVGVQUDULVH @.
       @( [19-Apr-2014] @) @( [12-Aug-2013] @)
  @}

  @{
    @d A i j @.  @d B i j @.  @d C i j @.
    @( The upper dimensional axiom for one dimensional geometry.  In one
       dimensional space, all points are colinear.  Derived from remarks in
       "Tarski's System of Geometry", by Alfred Tarski and Steven Givant,
       Bull.  Symbolic Logic Volume 5, Number 2 (1999), 175-214.  Note the
       similarity to ~ axlowdim2 .  ( Contributed by Scott Fenton,
       3-Jul-2013). @)
    axupdim1 @p |- ( ( A e. ( EE ` 1 ) /\ B e. ( EE ` 1 ) /\ C e. ( EE ` 1 ) )
       -> ( A Btwn <. B , C >. \/ B Btwn <. C , A >. \/
            C Btwn <. A , B >. ) ) @=
       ( vi vj c1 cee cfv wcel w3a cop cbtwn wbr w3o cv cmin co cmul wceq cfz
       wral csn cz 1z fzsn ax-mp eleq2i elsn bitri wa fveq2 oveq12d
       oveqan12d oveqan12rd eqtr4d syl2anb rgen2a colinearalg mpbiri ) AFGHZI
       BUTICUTIJABCKLMBCAKLMCABKLMNDOZBHZVAAHZPQZEOZCHZVEAHZPQZRQZVEBHZVGPQZVAC
       HZVCPQZRQZSZEFFTQZUADVPUAVODEVPVAVPIZVAFSZVEFSZVOVEVPIZVQVAFUBZIVRVPWAVA
       FUCIVPWASUDFUEUFZUGDFUHUIVTVEWAIVSVPWAVEWBUGEFUHUIVRVSUJVIFBHZFAHZPQZFCH
       ZWDPQZRQVNVRVSVDWEVHWGRVRVBWCVCWDPVAFBUKVAFAUKZULVSVFWFVGWDPVEFCUKVEFAUK
       ZULUMVSVRVKWEVMWGRVSVJWCVGWDPVEFBUKWIULVRVLWFVCWDPVAFCUKWHULUNUOUPUQABCD
       EFURUS @.
       @( [19-Apr-2014] @) @( [3-Jul-2013] @)
  @}

  @{
    @d N a b c p i @.  @d A a b c p i @.  @d B a b c p i @.  @d C a b c p i @.
    @d P i p @.
    @( The general upper dimensional axiom for Euclidean geometry.  Given ` N `
       distinct points, the locus of all points equidistant from them forms a
       line in ` N ` dimensional geometry.  Derived from remarks in "Tarski's
       System of Geometry", by Alfred Tarski and Steven Givant, Bull.  Symbolic
       Logic Volume 5, Number 2 (1999), 175-214.  Note the similarity to
       ~ axlowdim . @)
    axupdim @p |- ( ( N e. ( ZZ>= ` 2 ) /\
      ( P : ( 1 ... N ) -1-1-> ( EE ` N ) /\ A e. ( EE ` N ) ) /\
      ( B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A. i e. ( 2 ... N ) ( <. ( P ` 1 ) , A >. Cgr <. ( P ` i ) , A >. /\
           <. ( P ` 1 ) , B >. Cgr <. ( P ` i ) , B >. /\
           <. ( P ` 1 ) , C >. Cgr <. ( P ` i ) , C >. ) ->
        ( A Btwn <. B , C >. \/ B Btwn <. C , A >. \/
          C Btwn <. A , B >. ) ) ) @= ? @.
      @( [19-Apr-2014] @) @( [12-Jul-2013] @)
  @}
  $)

  ${
    $d A i k r s u x y $.  $d B i k r s u x y $.  $d C i k r s u x y $.
    $d N i k r s u x y $.  $d P i k r s u x y $.  $d Q i k r s u x y $.
    $d T i k r s u x y $.
    $( Lemma for ~ axeuclid .  Handle the algebraic aspects of the theorem.
       (Contributed by Scott Fenton, 9-Sep-2013.) $)
    axeuclidlem $p |- (
      ( ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
          ( C e. ( EE ` N ) /\ T e. ( EE ` N ) ) ) /\
        ( P e. ( 0 [,] 1 ) /\ Q e. ( 0 [,] 1 ) /\ P =/= 0 ) /\
        A. i e. ( 1 ... N )
         ( ( ( 1 - P ) x. ( A ` i ) ) + ( P x. ( T ` i ) ) ) =
         ( ( ( 1 - Q ) x. ( B ` i ) ) + ( Q x. ( C ` i ) ) ) ) ->
      E. x e. ( EE ` N ) E. y e. ( EE ` N )
      E. r e. ( 0 [,] 1 ) E. s e. ( 0 [,] 1 ) E. u e. ( 0 [,] 1 )
      A. i e. ( 1 ... N )
       ( ( B ` i ) =
         ( ( ( 1 - r ) x. ( A ` i ) ) + ( r x. ( x ` i ) ) ) /\
         ( C ` i ) =
         ( ( ( 1 - s ) x. ( A ` i ) ) + ( s x. ( y ` i ) ) ) /\
         ( T ` i ) = (
         ( ( 1 - u ) x. ( x ` i ) ) + ( u x. ( y ` i ) ) ) ) ) $=
      ( wcel c1 co cmul caddc wceq wrex vk cee cfv wa cc0 cicc wne w3a cmin cfz
      cv wral simp21 simp22 cdiv cr fveere expcom anim12d impcom unitssre sseli
      cmpt 3ad2ant1 adantl peano2rem simplll remulcld simpllr readdcld redivcld
      syl simpr3 sylan an32s ralrimiva eleenn ad3antrrr mptelee 3adant3 simplrl
      cn wb mpbird wi cc fveecn eqcom ax-1cn simpr2 recnd subcl sylancr sylancl
      simpr1 mulcld addcld simplrr divmuld syl5bb cneg negsubdi2 mulneg1d npcan
      oveq1d adddird mulid2d 3eqtr3d oveq2d negsubd addcomd eqeq1d syl6bb add4d
      3eqtr3rd bitr4d adddid oveq12d eqtr4d divdird divassd 3eqtrd eqeq2d fveq1
      addassd addid2d divcan2d fveq2 eqid fvmpt sylan9eq oveq2 ralbidva ralbidv
      ovex oveq1 2rexbidv rexcom rexbii bitri subaddd 3bitr3rd biimpd mul02 jca
      npncan2 jctild df-3an syl6ibr ralimdva 3impia weq rspc2ev syl3anc 3anbi1d
      3anbi13d 3anbi23d 3anbi2d 3anbi3d rspc3ev syl31anc 3bitri sylib ) DKUBUCZ
      NZEUVDNZUDZFUVDNZIUVDNZUDZUDZGUEOUFPZNZHUVLNZGUEUGZUHZOGUIPZJUKZDUCZQPZGU
      VRIUCZQPZRPOHUIPZUVREUCZQPZHUVRFUCZQPZRPZSZJOKUJPZULZUHZUWDOMUKZUIPZUVSQP
      ZUWMUVRAUKZUCZQPZRPZSZUWFOLUKZUIPZUVSQPZUXAUVRBUKZUCZQPZRPZSZUWAOCUKZUIPZ
      UWQQPZUXIUXEQPZRPZSZUHZJUWJULZBUVDTZAUVDTZCUVLTZLUVLTZMUVLTZUXPCUVLTZLUVL
      TZMUVLTBUVDTZAUVDTZUWLUVMUVMUVNUWDUVTGUWQQPZRPZSZUWFUVTGUXEQPZRPZSZUWAUWC
      UWQQPZHUXEQPZRPZSZUHZJUWJULZBUVDTAUVDTZUYAUVKUVMUVNUVOUWKUMZUYSUVKUVMUVNU
      VOUWKUNUWLUAUWJGOUIPZUAUKZDUCZQPZVUAEUCZRPZGUOPZVCZUVDNZUAUWJVUCVUAFUCZRP
      ZGUOPZVCZUVDNZUWDUVTGUYTUVSQPZUWDRPZGUOPZQPZRPZSZUWFUVTGVUNUWFRPZGUOPZQPZ
      RPZSZUWAUWCVUPQPZHVVAQPZRPZSZUHZJUWJULZUYRUVKUVPVUHUWKUVKUVPUDZVUHVUFUPNZ
      UAUWJULZVVKVVLUAUWJUVKVUAUWJNZUVPVVLUVKVVNUDZVUBUPNZVUDUPNZUDZVUIUPNZVUAI
      UCUPNZUDZUDZUVPVVLVVNUVKVWBVVNUVGVVRUVJVWAVVNUVEVVPUVFVVQUVEVVNVVPDVUAKUQ
      URUVFVVNVVQEVUAKUQURUSVVNUVHVVSUVIVVTUVHVVNVVSFVUAKUQURUVIVVNVVTIVUAKUQUR
      USUSUTZVWBUVPUDZVUEGVWDVUCVUDVWDUYTVUBVWDGUPNZUYTUPNUVPVWEVWBUVMUVNVWEUVO
      UVLUPGVAVBZVDVEZGVFVLVVPVVQVWAUVPVGVHZVVPVVQVWAUVPVIVJVWGVWBUVMUVNUVOVMZV
      KVNVOVPVVKKWBNZVUHVVMWCUVEVWJUVFUVJUVPDKVQVRZVUEGUAUOKVSVLWDVTUVKUVPVUMUW
      KVVKVUMVUKUPNZUAUWJULZVVKVWLUAUWJUVKVVNUVPVWLVVOVWBUVPVWLVWCVWDVUJGVWDVUC
      VUIVWHVVRVVSVVTUVPWAVJVWGVWIVKVNVOVPVVKVWJVUMVWMWCVWKVUJGUAUOKVSVLWDVTUVK
      UVPUWKVVJVVKUWIVVIJUWJUVKUVRUWJNZUVPUWIVVIWEZUVKVWNUDUVSWFNZUWDWFNZUDZUWF
      WFNZUWAWFNZUDZUDZUVPVWOVWNUVKVXBVWNUVGVWRUVJVXAVWNUVEVWPUVFVWQUVEVWNVWPDU
      VRKWGURUVFVWNVWQEUVRKWGURUSVWNUVHVWSUVIVWTUVHVWNVWSFUVRKWGURUVIVWNVWTIUVR
      KWGURUSUSUTVXBUVPUDZUWIVUSVVDUDZVVHUDVVIVXCUWIVVHVXDVXCUWIVVHVXCUWAUWCVUN
      QPZHVUNQPZRPZUWHRPZGUOPZSZUWHUVTUIPZUWBSZVVHUWIVXCVXJUWBVXHSZVXLVXJVXIUWA
      SVXCVXMUWAVXIWHVXCVXHGUWAVXCVXGUWHVXCVXEVXFVXCUWCVUNVXCOWFNZHWFNZUWCWFNWI
      VXCUVNVXOVXBUVMUVNUVOWJUVNHUVLUPHVAVBWKVLZOHWLWMZVXCUYTUVSVXCGWFNZVXNUYTW
      FNVXCUVMVXRVXBUVMUVNUVOWOUVMGVWFWKVLZWIGOWLWNZVWPVWQVXAUVPVGZWPZWPZVXCHVU
      NVXPVYBWPZWQZVXCUWEUWGVXCUWCUWDVXQVWPVWQVXAUVPVIZWPZVXCHUWFVXPVWRVWSVWTUV
      PWAZWPZWQZWQVXSVWRVWSVWTUVPWRZVXBUVMUVNUVOVMZWSWTVXCVXLVXHUWBSVXMVXCVXKVX
      HUWBVXCUWHUVTXAZRPUWHVXGRPVXKVXHVXCVYMVXGUWHRVXCUVQXAZUVSQPVUNVYMVXGVXCVY
      NUYTUVSQVXCVXNVXRVYNUYTSWIVXSOGXBWMXEVXCUVQUVSVXCVXNVXRUVQWFNWIVXSOGWLWMZ
      VYAXCVXCUWCHRPZVUNQPOVUNQPVXGVUNVXCVYPOVUNQVXCVXNVXOVYPOSWIVXPOHXDWMXEVXC
      UWCHVUNVXQVXPVYBXFVXCVUNVYBXGXOXHXIVXCUWHUVTVYJVXCUVQUVSVYOVYAWPZXJVXCUWH
      VXGVYJVYEXKXHXLVXHUWBWHXMXPVXCVXIVVGUWAVXCVXIUWCVUOQPZHVUTQPZRPZGUOPVYRGU
      OPZVYSGUOPZRPVVGVXCVXHVYTGUOVXCVXHVXEUWERPZVXFUWGRPZRPVYTVXCVXEVXFUWEUWGV
      YCVYDVYGVYIXNVXCVYRWUCVYSWUDRVXCUWCVUNUWDVXQVYBVYFXQVXCHVUNUWFVXPVYBVYHXQ
      XRXSXEVXCVYRVYSGVXCUWCVUOVXQVXCVUNUWDVYBVYFWQZWPVXCHVUTVXPVXCVUNUWFVYBVYH
      WQZWPVXSVYLXTVXCWUAVVEWUBVVFRVXCUWCVUOGVXQWUEVXSVYLYAVXCHVUTGVXPWUFVXSVYL
      YAXRYBYCVXCUWHUVTUWBVYJVYQVXCGUWAVXSVYKWPUUAUUBUUCVXCVUSVVDVXCUWDUVTVUORP
      ZVURVXCUVTVUNRPZUWDRPUEUWDRPWUGUWDVXCWUHUEUWDRVXCUVQUYTRPZUVSQPUEUVSQPZWU
      HUEVXCWUIUEUVSQVXCVXNVXRWUIUESWIVXSOGUUFWMXEVXCUVQUYTUVSVYOVXTVYAXFVWPWUJ
      UESVWQVXAUVPUVSUUDVRXHZXEVXCUVTVUNUWDVYQVYBVYFYEVXCUWDVYFYFXOVXCVUQVUOUVT
      RVXCVUOGWUEVXSVYLYGXIXSVXCUWFUVTVUTRPZVVCVXCWUHUWFRPUEUWFRPWULUWFVXCWUHUE
      UWFRWUKXEVXCUVTVUNUWFVYQVYBVYHYEVXCUWFVYHYFXOVXCVVBVUTUVTRVXCVUTGWUFVXSVY
      LYGXIXSUUEUUGVUSVVDVVHUUHUUIVNVOUUJUUKUYQVVJVUSUYKUWAVVEUYMRPZSZUHZJUWJUL
      ABVUGVULUVDUVDUWPVUGSZUYPWUOJUWJWUPVWNUDUWQVUPSZUYPWUOWCWUPVWNUWQUVRVUGUC
      VUPUVRUWPVUGYDUAUVRVUFVUPUWJVUGUAJUULZVUEVUOGUOWURVUCVUNVUDUWDRWURVUBUVSU
      YTQVUAUVRDYHXIZVUAUVREYHXRXEVUGYIVUOGUOYOYJYKWUQUYHVUSUYOWUNUYKWUQUYGVURU
      WDWUQUYFVUQUVTRUWQVUPGQYLXIYCWUQUYNWUMUWAWUQUYLVVEUYMRUWQVUPUWCQYLXEYCUUP
      VLYMUXDVULSZWUOVVIJUWJWUTVWNUDUXEVVASZWUOVVIWCWUTVWNUXEUVRVULUCVVAUVRUXDV
      ULYDUAUVRVUKVVAUWJVULWURVUJVUTGUOWURVUCVUNVUIUWFRWUSVUAUVRFYHXRXEVULYIVUT
      GUOYOYJYKWVAUYKVVDWUNVVHVUSWVAUYJVVCUWFWVAUYIVVBUVTRUXEVVAGQYLXIYCWVAWUMV
      VGUWAWVAUYMVVFVVERUXEVVAHQYLXIYCUUQVLYMUUMUUNUXRUYRUYHUXHUXNUHZJUWJULZBUV
      DTAUVDTUYHUYKUXNUHZJUWJULZBUVDTAUVDTMLCGGHUVLUVLUVLUWMGSZUXPWVCABUVDUVDWV
      FUXOWVBJUWJWVFUWTUYHUXHUXNWVFUWSUYGUWDWVFUWOUVTUWRUYFRWVFUWNUVQUVSQUWMGOU
      IYLXEUWMGUWQQYPXRYCUUOYNYQUXAGSZWVCWVEABUVDUVDWVGWVBWVDJUWJWVGUXHUYKUYHUX
      NWVGUXGUYJUWFWVGUXCUVTUXFUYIRWVGUXBUVQUVSQUXAGOUIYLXEUXAGUXEQYPXRYCUURYNY
      QUXIHSZWVEUYQABUVDUVDWVHWVDUYPJUWJWVHUXNUYOUYHUYKWVHUXMUYNUWAWVHUXKUYLUXL
      UYMRWVHUXJUWCUWQQUXIHOUIYLXEUXIHUXEQYPXRYCUUSYNYQUUTUVAUYAUXQCUVLTZLUVLTZ
      AUVDTZMUVLTWVJMUVLTZAUVDTUYEUXTWVKMUVLUXTWVIAUVDTZLUVLTWVKUXSWVMLUVLUXQCA
      UVLUVDYRYSWVILAUVLUVDYRYTYSWVJMAUVLUVDYRWVLUYDAUVDWVLUYCBUVDTZMUVLTUYDWVJ
      WVNMUVLWVJUYBBUVDTZLUVLTWVNWVIWVOLUVLUXPCBUVLUVDYRYSUYBLBUVLUVDYRYTYSUYCM
      BUVLUVDYRYTYSUVBUVC $.
  $}

  ${
    $d A i p q r s u x y $.  $d B i p q r s u x y $.  $d C i p q r s u x y $.
    $d D i p q x y $.  $d N i p q r s u x y $.  $d T i p q r s u x y $.
    $( Euclid's axiom.  Take an angle ` B A C ` and a point ` D ` between ` B `
       and ` C ` .  Now, if you extend the segment ` A D ` to a point ` T ` ,
       then ` T ` lies between two points ` x ` and ` y ` that lie on the
       angle.  Axiom A10 of [Schwabhauser] p. 13.  (Contributed by Scott
       Fenton, 9-Sep-2013.) $)
    axeuclid $p |- ( ( N e. NN /\
                       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\
                         C e. ( EE ` N ) ) /\
                       ( D e. ( EE ` N ) /\ T e. ( EE ` N ) ) ) ->
     ( ( D Btwn <. A , T >. /\ D Btwn <. B , C >. /\ A =/= D ) ->
       E. x e. ( EE ` N ) E. y e. ( EE ` N )
         ( B Btwn <. A , x >. /\ C Btwn <. A , y >. /\
           T Btwn <. x , y >. ) ) ) $=
      ( vi vp vq wcel wa c1 co cmul caddc wceq cc0 wrex vr vs vu cn cee cfv w3a
      cv cmin cfz wral wne cicc cop wbr simpl21 simpl22 simpl23 simpl3r simprll
      cbtwn jca simprlr cc simp21 ad2antrr fveecn sylan simp3r mulid2 oveqan12d
      mul02 addid1 adantr eqtrd syl2anc wb ax-1cn subid1i syl6eq oveq1d oveq12d
      oveq2 oveq1 eqeq1d ad2antlr mpbird eqeq2d syl6bb biimpd ralimdva impancom
      eqcom adantrd simp3l eqeefv sylibrd necon3d impr anasss eqtr2 axeuclidlem
      ralimi ad2antll syl231anc rexlimdvv brbtwn syl3anc simp22 simp23 3anbi12d
      r19.26 2rexbii reeanv anbi1i r19.41v rexbii df-3an 3bitr4i syl6bbr simprl
      exp32 bitri simprr 3anbi123d r19.26-3 3reeanv 2rexbidva 3imtr4d ) HUDLZCH
      UEUFZLZDYKLZEYKLZUGZFYKLZGYKLZMZUGZIUHZFUFZNJUHZUIOZYTCUFZPOZUUBYTGUFZPOZ
      QOZRZUUANKUHZUIOYTDUFZPOUUJYTEUFZPOQOZRZMZINHUJOZUKZCFULZMZKSNUMOZTZJUUTT
      ZUUKNUAUHZUIOUUDPOUVCYTAUHZUFZPOQORZUULNUBUHZUIOUUDPOUVGYTBUHZUFZPOQORZUU
      FNUCUHZUIOUVEPOUVKUVIPOQORZUGIUUPUKZUCUUTTZUBUUTTUAUUTTZBYKTAYKTZFCGUNVAU
      OZFDEUNVAUOZUURUGZDCUVDUNVAUOZECUVHUNVAUOZGUVDUVHUNVAUOZUGZBYKTAYKTYSUUSU
      VPJKUUTUUTYSUUBUUTLZUUJUUTLZMZUUSUVPYSUWFUUSMZMZYLYMMYNYQMUWDUWEUUBSULZUU
      HUUMRZIUUPUKZUVPUWHYLYMYLYMYNYJYRUWGUPYLYMYNYJYRUWGUQVBUWHYNYQYLYMYNYJYRU
      WGURYPYQYJYOUWGUSVBYSUWDUWEUUSUTYSUWDUWEUUSVCYSUWFUUSUWIYSUWFMZUUQUURUWIU
      WLUUQMZUUBSCFUWMUUBSRZUUDUUARZIUUPUKZCFRZUWLUWNUUQUWPUWLUWNMZUUOUWOIUUPUW
      RYTUUPLZMZUUIUWOUUNUWTUUIUWOUWTUUIUUAUUDRUWOUWTUUHUUDUUAUWTUUHUUDRZNUUDPO
      ZSUUFPOZQOZUUDRZUWTUUDVDLZUUFVDLZUXEUWRYLUWSUXFYSYLUWFUWNYJYLYMYNYRVEZVFC
      YTHVGVHUWRYQUWSUXGYSYQUWFUWNYJYOYPYQVIZVFGYTHVGVHUXFUXGMUXDUUDSQOZUUDUXFU
      XGUXBUUDUXCSQUUDVJUUFVLVKUXFUXJUUDRUXGUUDVMVNVOVPUWNUXAUXEVQUWLUWSUWNUUHU
      XDUUDUWNUUEUXBUUGUXCQUWNUUCNUUDPUWNUUCNSUIONUUBSNUIWCNVRVSVTWAUUBSUUFPWDW
      BWEWFWGWHUUAUUDWMWIWJWNWKWLUWMYLYPUWQUWPVQYSYLUWFUUQUXHVFYSYPUWFUUQYJYOYP
      YQWOZVFCFIHWPVPWQWRWSWTUUSUWKYSUWFUUQUWKUURUUOUWJIUUPUUAUUHUUMXAXCVNXDABU
      CCDEUUBUUJGIHUBUAXBXEYBXFYSUVSUUIIUUPUKZJUUTTZUUNIUUPUKZKUUTTZUURUGZUVBYS
      UVQUXMUVRUXOUURYSYPYLYQUVQUXMVQUXKUXHUXIJFCGIHXGXHYSYPYMYNUVRUXOVQUXKYJYL
      YMYNYRXIYJYLYMYNYRXJKFDEIHXGXHXKUUQKUUTTZJUUTTZUURMZUXMUXOMZUURMUVBUXPUXR
      UXTUURUXRUXLUXNMZKUUTTJUUTTUXTUUQUYAJKUUTUUTUUIUUNIUUPXLXMUXLUXNJKUUTUUTX
      NYCXOUVBUXQUURMZJUUTTUXSUVAUYBJUUTUUQUURKUUTXPXQUXQUURJUUTXPYCUXMUXOUURXR
      XSXTYSUWCUVOABYKYKYSUVDYKLZUVHYKLZMZMZUWCUVFIUUPUKZUAUUTTZUVJIUUPUKZUBUUT
      TZUVLIUUPUKZUCUUTTZUGZUVOUYFUVTUYHUWAUYJUWBUYLUYFYMYLUYCUVTUYHVQYLYMYNYJY
      RUYEUQYLYMYNYJYRUYEUPZYSUYCUYDYAZUADCUVDIHXGXHUYFYNYLUYDUWAUYJVQYLYMYNYJY
      RUYEURUYNYSUYCUYDYDZUBECUVHIHXGXHUYFYQUYCUYDUWBUYLVQYPYQYJYOUYEUSUYOUYPUC
      GUVDUVHIHXGXHYEUVOUYGUYIUYKUGZUCUUTTZUBUUTTUAUUTTUYMUVNUYRUAUBUUTUUTUVMUY
      QUCUUTUVFUVJUVLIUUPYFXQXMUYGUYIUYKUAUBUCUUTUUTUUTYGYCXTYHYI $.
  $}

  ${
    $d D s t x y $.  $d i j s t x y N $.  $d U i j s t x y $.
    $d i Z j s t x y $.
    axcontlem1.1 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  Change bound variables for later use.
       (Contributed by Scott Fenton, 20-Jun-2013.) $)
    axcontlem1 $p |- F = { <. y , s >. |
        ( y e. D /\ ( s e. ( 0 [,) +oo ) /\
           A. j e. ( 1 ... N )
            ( y ` j ) = ( ( ( 1 - s ) x. ( Z ` j ) ) +
                          ( s x. ( U ` j ) ) ) ) ) } $=
      ( cv wcel co cfv c1 cmul caddc wa cc0 cpnf cico cmin wceq cfz wral weq wb
      copab eleq1 adantr adantl fveq1 oveq2 oveq1d oveq1 oveq12d ralbidv oveq2d
      eqeqan12d fveq2 eqeq12d cbvralv syl6bb anbi12d cbvopabv eqtri ) HAMZDNZCM
      ZUAUBUCOZNZFMZVIPZQVKUDOZVNJPZROZVKVNEPZROZSOZUEZFQIUFOZUGZTZTZACUJBMZDNZ
      KMZVLNZGMZWGPZQWIUDOZWKJPZROZWIWKEPZROZSOZUEZGWCUGZTZTZBKUJLWFXBACBKABUHZ
      CKUHZTZVJWHWEXAXCVJWHUIXDVIWGDUKULXEVMWJWDWTXDVMWJUIXCVKWIVLUKUMXEWDVNWGP
      ZWMVQROZWIVSROZSOZUEZFWCUGWTXEWBXJFWCXCXDVOXFWAXIVNVIWGUNXDVRXGVTXHSXDVPW
      MVQRVKWIQUDUOUPVKWIVSRUQURVAUSXJWSFGWCFGUHZXFWLXIWRVNWKWGVBXKXGWOXHWQSXKV
      QWNWMRVNWKJVBUTXKVSWPWIRVNWKEVBUTURVCVDVEVFVFVGVH $.
  $}

  ${
    $d Z k p x y t s i $.  $d U k p x y t s i $.  $d N k p x y s t i $.
    $d D k x y t $.
    axcontlem2.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    axcontlem2.2 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  The idea here is to set up a mapping ` F ` that
       will allow us to transfer ~ dedekind to two sets of points.  Here, we
       set up ` F ` and show its domain and range.  (Contributed by Scott
       Fenton, 17-Jun-2013.) $)
    axcontlem2 $p |-
       ( ( ( N e. NN /\ Z e. ( EE ` N ) /\ U e. ( EE ` N ) ) /\ Z =/= U ) ->
         F : D -1-1-onto-> ( 0 [,) +oo ) ) $=
      ( wcel wa cc0 co c1 cmul caddc wceq wral vs vy vk cfv w3a wne wfn ccnv cv
      cmin weu wreu wrex weq wi cop cbtwn wbr opeq2 breq2d breq1 orbi12d elrab2
      wo simpll3 simpll2 simpr brbtwn syl3anc biimpa simp-4r oveq2 ax-1cn oveq1
      wb oveq1d oveq12d eqeq2d ralbidv adantr eqeefv syl2anc cc ad2antrr fveecn
      sylancom mulid2 mul02 eqtrd ralbidva syl5ibr mpd cdiv cle 0re 1re elicc2i
      sylan clt 0le1 mpanl12 elrege0 sylanbrc adantll ad3antlr simplr ad3antrrr
      cr recnd reccl subcl sylancr mpan mulcld simprr simpl subdi mp3an2 oveq2d
      adddird mulid1d recid2 mulassd 3eqtr3rd simpll simprl mulcl syl2an rspcev
      ad2antll ralrimiva ralimi syl ex simplbi adantl sylib mpbird a1i copab cn
      cee cpnf cico wf1o cfz cicc subid1i syl6eq biimpac eqcom oveqan12d addid1
      simpllr bitr4d syl5bb expdimp necon3d simp1bi rereccl divge0 mp3an3 npcan
      simp2bi ne0gt0d addsubass addcld subeq0bd 3eqtr2d sylan9eq eqtr3d addassd
      ad2ant2r adddid eqtr4d addid2 ad2antrl syl22anc ralbi syl5ibrcom impancom
      rexbidv rexlimdva imp syldan wss 3simpa 3imtr4i ssriv ssrexv mpsyl jaodan
      anasss sylan2b r19.26 sylbir anim12i simpl2 ad2ant2rl ad2ant2l addsubeq4d
      simpl3 nnncan1 ad2antlr subdird eqeq12d mulcan1g 3bitr2d syl12anc r19.32v
      eqtr2 mp3an1 ancoms neneqd mtbid orel2 subeq0 sylibd syl5bi sylbid sylan2
      syl5 ralrimivva reu4 df-reu fnopabg cmpt resubcl remulcl 3adant3 readdcld
      wn 3adant2 simpll1 mptelee 0lt1 ltletrd divelunit gt0ne0d 3eqtr3d eqeltrd
      fveere letric npncan2 3eqtr2rd fveq2 eqid ovex ralbiia syl6bb 3jca anbi1i
      fvmpt rgen sylancl orim12d fveq1 eqeq1d ssrab2 eqsstri sseli eqtr3 bitr3i
      crab an12 opabbii eqtri cnveqi cnvopab dff1o4 ) GUUALZHGUUBUDZLZDVVLLZUEZ
      HDUFZMZFCUGZFUHZNUUCUUDOZUGZCVVTFUUEVVQBUIZVVTLZEUIZAUIZUDZPVWBUJOZVWDHUD
      ZQOZVWBVWDDUDZQOZROZSZEPGUUFOZTZMZBUKZACTVVRVVQVWQACVVQVWECLZMZVWOBVVTULZ
      VWQVWSVWOBVVTUMZVWOVWFPUAUIZUJOZVWHQOZVXBVWJQOZROZSZEVWNTZMZBUAUNZUOZUAVV
      TTBVVTTZVWTVWRVVQVWEVVLLZDHVWEUPZUQURZVWEHDUPZUQURZVDZMVXADHIUIZUPZUQURZV
      XSVXPUQURZVDZVXRIVWEVVLCIAUNZVYAVXOVYBVXQVYDVXTVXNDUQVXSVWEHUSUTVXSVWEVXP
      UQVAVBJVCZVVQVXMVXRVXAVVQVXMMZVXOVXAVXQVYFVXOVWJVXDVXBVWFQOZROZSZEVWNTZUA
      NPUUGOZUMZVXAVYFVXOVYLVYFVVNVVMVXMVXOVYLVOVVKVVMVVNVVPVXMVEZVVKVVMVVNVVPV
      XMVFZVVQVXMVGZUADHVWEEGVHVIVJVYFVYLVXAVYFVYJVXAUAVYKVYFVXBVYKLZMZVYJVXAVY
      QVYJMZVXBNUFZVXAVYRVVPVYSVVOVVPVXMVYPVYJVKVYRVXBNHDVYQVYJVXBNSZHDSZVYJVYT
      MWUAVYQVWJPVWHQOZNVWFQOZROZSZEVWNTZVYTVYJWUFVYTVYIWUEEVWNVYTVYHWUDVWJVYTV
      XDWUBVYGWUCRVYTVXCPVWHQVYTVXCPNUJOPVXBNPUJVLPVMUUHUUIVPVXBNVWFQVNVQVRVSUU
      JWUADHSZVYQWUFHDUUKVYQWUGVWJVWHSZEVWNTZWUFVYQVVNVVMWUGWUIVOVYFVVNVYPVYMVT
      VYFVVMVYPVYNVTDHEGWAWBVYQWUEWUHEVWNVYQVWDVWNLZMVWHWCLZVWFWCLZWUEWUHVOVYQW
      UJVVMWUKVYFVVMVYPWUJVYNWDHVWDGWEZWFVYQWUJVXMWULVVQVXMVYPWUJUUNVWEVWDGWEZW
      FWUKWULMZWUDVWHVWJWUOWUDVWHNROZVWHWUKWULWUBVWHWUCNRVWHWGVWFWHUULWUKWUPVWH
      SWULVWHUUMVTWIVRWBWJUUOUUPWKUUQUURWLVYQVYSVYJVXAVYQVYSMZVXAVYJVWFVWIVWBVY
      HQOZROZSZEVWNTZBVVTUMZWUQPVXBWMOZVVTLZVWFPWVCUJOZVWHQOZWVCVYHQOZROZSZEVWN
      TZWVBVYPVYSWVDVYFVYPVYSMZWVCXHLZNWVCWNURZWVDVYPVXBXHLZVYSWVLVYPWVNNVXBWNU
      RZVXBPWNURZNPVXBWOWPWQZUUSZVXBUUTWRWVKWVNNVXBWSURZWVMVYPWVNVYSWVRVTZWVKVX
      BWVTVYPWVOVYSVYPWVNWVOWVPWVQUVDVTVYPVYSVGUVEPXHLZNPWNURZWVNWVSMWVMWPWTPVX
      BUVAXAWBWVCXBXCXDWUQWVIEVWNWUQWUJMZVXBWCLZVYSWULWUKWVIWWCVXBVYPWVNVYFVYSW
      UJWVRXEXIVYQVYSWUJXFWUQWUJVXMWULVVQVXMVYPVYSWUJVKWUNWFWUQWUJVVMWUKVYFVVMV
      YPVYSWUJVYNXGWUMWFWWDVYSMZWULWUKMZMZWVFWVCVXDQOZROZWVCVYGQOZROZNVWFROZWVH
      VWFWWGWWINWWJVWFRWWGWWINVWHQOZNWWGWVEWVCVXCQOZROZVWHQOWVFWWNVWHQOZROWWMWW
      IWWGWVEWWNVWHWWEWVEWCLZWWFWWEPWCLZWVCWCLZWWQVMVXBXJZPWVCXKXLZVTZWWEWWNWCL
      WWFWWEWVCVXCWWTWWDVXCWCLZVYSWWRWWDWXCVMPVXBXKXMZVTZXNVTWWEWULWUKXOZXTWWGW
      WONVWHQWWEWWONSWWFWWEWWOWVEWVCPQOZWVCVXBQOZUJOZROZNWWEWWNWXIWVERWWEWWSWWD
      WWNWXISZWWTWWDVYSXPWWSWWRWWDWXKVMWVCPVXBXQXRWBXSWWEWXJWVEWVCPUJOZROZWVEWV
      CROZPUJOZNWWEWXIWXLWVERWWEWXGWVCWXHPUJWWEWVCWWTYAVXBYBZVQXSWWEWWQWWSWXOWX
      MSZWXAWWTWWQWWSWWRWXQVMWVEWVCPUVFUVBWBWWEWXNPWWEWVEWVCWXAWWTUVGWWEWWRWWSW
      XNPSVMWWTPWVCUVCXLUVHUVIWIVTVPWWGWWPWWHWVFRWWGWVCVXCVWHWWEWWSWWFWWTVTZWWD
      WXCVYSWWFWXDWDWXFYCXSYDWUKWWMNSZWWEWULVWHWHZYJWIWWGWXHVWFQOZWWJVWFWWGWVCV
      XBVWFWXRWWDVYSWWFYEWWEWULWUKYFYCWWEWWFWYAPVWFQOZVWFWWEWXHPVWFQWXPVPWULWYB
      VWFSWUKVWFWGVTUVJUVKVQWWGWWKWVFWWHWWJROZROWVHWWGWVFWWHWWJWWGWVEVWHWXBWXFX
      NWWGWVCVXDWXRWWEWXCWUKVXDWCLZWWFWXEWULWUKVGVXCVWHYGZYHZXNWWGWVCVYGWXRWWDW
      ULVYGWCLVYSWUKVXBVWFYGUVMZXNUVLWWGWVGWYCWVFRWWGWVCVXDVYGWXRWYFWYGUVNXSUVO
      WULWWLVWFSWWEWUKVWFUVPUVQYDUVRYKWVAWVJBWVCVVTVWBWVCSZWUTWVIEVWNWYHWUSWVHV
      WFWYHVWIWVFWURWVGRWYHVWGWVEVWHQVWBWVCPUJVLVPVWBWVCVYHQVNVQVRVSYIWBVYJVWOW
      VABVVTVYJVWMWUTVOZEVWNTVWOWVAVOVYIWYIEVWNVYIVWLWUSVWFVYIVWKWURVWIRVWJVYHV
      WBQVLXSVRYLVWMWUTEVWNUVSYMUWBUVTUWAWLYNUWCUWDUWEVYKVVTUWFVYFVXQMVWOBVYKUM
      ZVXAAVYKVVTVWEXHLZNVWEWNURZVWEPWNURZUEWYKWYLMVWEVYKLVWEVVTLWYKWYLWYMUWGNP
      VWEWOWPWQVWEXBUWHUWIVYFVXQWYJVYFVXMVVMVVNVXQWYJVOVYOVYNVYMBVWEHDEGVHVIVJV
      WOBVYKVVTUWJUWKUWLUWMUWNVVQVXLVWRVVQVXKBUAVVTVVTVXIVWLVXFSZEVWNTZVVQVWCVX
      BVVTLZMZMVXJVXIVWMVXGMZEVWNTWYOVWMVXGEVWNUWOWYRWYNEVWNVWFVWLVXFUXKYLUWPWY
      QVVQVWBWCLZWWDMZWYOVXJUOVWCWYSWYPWWDVWCVWBVWCVWBXHLZNVWBWNURZVWBXBZYOZXIW
      YPVXBWYPWVNWVOVXBXBYOXIUWQVVQWYTMZWYOVWBVXBUJOZNSZVWHVWJSZVDZEVWNTZVXJXUE
      WYNXUIEVWNXUEWUJMWYTWUKVWJWCLZWYNXUIVOVVQWYTWUJXFXUEWUJVVMWUKVVQVVMWYTWUJ
      VVKVVMVVNVVPUWRZWDWUMWFXUEWUJVVNXUKVVQVVNWYTWUJVVKVVMVVNVVPUXBZWDDVWDGWEZ
      WFWYTWUKXUKMZMZWYNVXDVWIUJOZVWKVXEUJOZSXUFVWHQOZXUFVWJQOZSZXUIXUPVWIVWKVX
      DVXEWYTVWGWCLZWUKVWIWCLZXUOWYSXVBWWDWWRWYSXVBVMPVWBXKXMZVTWUKXUKXPZVWGVWH
      YGZYHWYSXUKVWKWCLZWWDWUKVWBVWJYGZUWSWYTWXCWUKWYDXUOWWDWXCWYSWXDYPXVEWYEYH
      WWDXUKVXEWCLWYSWUKVXBVWJYGUWTUXAXUPXUSXUQXUTXURXUPVXCVWGUJOZVWHQOZXUSXUQW
      YTXVJXUSSXUOWYTXVIXUFVWHQWWDWYSXVIXUFSZWWRWWDWYSXVKVMPVXBVWBUXCUXLUXMVPVT
      XUPVXCVWGVWHWWDWXCWYSXUOWXDUXDWYSXVBWWDXUOXVDWDWYTWUKXUKYFZUXEUVKXUPVWBVX
      BVWJWYSWWDXUOYEWYSWWDXUOXFWYTWUKXUKXOZUXEUXFXUPXUFWCLZWUKXUKXVAXUIVOWYTXV
      NXUOVWBVXBXKVTXVLXVMXUFVWHVWJUXGVIUXHUXIWJXUJXUGXUHEVWNTZVDZXUEVXJXUGXUHE
      VWNUXJXUEXVPXUGVXJXUEXVOUYLXVPXUGUOXUEWUAXVOXUEHDVVOVVPWYTXFUXNXUEVVMVVNW
      UAXVOVOVVKVVMVVNVVPWYTVFVVKVVMVVNVVPWYTVEHDEGWAWBUXOXVOXUGUXPYMWYTXUGVXJV
      OVVQVWBVXBUXQYPUXRUXSUXTUYAUYBUYCVTVWOVXHBUAVVTVXJVWMVXGEVWNVXJVWLVXFVWFV
      XJVWIVXDVWKVXERVXJVWGVXCVWHQVWBVXBPUJVLVPVWBVXBVWJQVNVQVRVSUYDXCVWOBVVTUY
      EYQYKVWPABCFKUYFYQVVQVWRVWOMZAUKZBVVTTVWAVVQXVRBVVTVVQVWCMZVWOACUMZVWOVWD
      UBUIZUDZVWLSZEVWNTZMZAUBUNZUOZUBCTACTZXVRXVSUCVWNVWGUCUIZHUDZQOZVWBXWIDUD
      ZQOZROZUYGZCLZVWDXWOUDZVWLSZEVWNTZXVTXVSXWOVVLLZDHXWOUPZUQURZXWOVXPUQURZV
      DZXWPXVSXWTXWNXHLZUCVWNTZXVSXXEUCVWNXVSXWIVWNLZMXUAXWJXHLZXWLXHLZXXEVWCXU
      AVVQXXGXUDUXDXVSXXGVVMXXHVVQVVMVWCXXGXULWDHXWIGVUBWFXVSXXGVVNXXIVVQVVNVWC
      XXGXUMWDDXWIGVUBWFXUAXXHXXIUEXWKXWMXUAXXHXWKXHLZXXIXUAVWGXHLZXXHXXJWWAXUA
      XXKWPPVWBUYHXMVWGXWJUYIWRUYJXUAXXIXWMXHLXXHVWBXWLUYIUYMUYKVIYKXVSVVKXWTXX
      FVOVVKVVMVVNVVPVWCUYNXWKXWMUCRGUYOYMYRZXVSPVWBWNURZVWBPWNURZVDZXXDVWCXXOV
      VQVWCWWAXUAXXOWPXUDPVWBVUCXLYPXVSXXMXXBXXNXXCXVSXXMXXBXVSXXMMZXXBVWJVXDVX
      BXWQQOZROZSZEVWNTZUAVYKUMZXXPPVWBWMOZVYKLZVWJPXYBUJOZVWHQOZXYBVWLQOZROZSZ
      EVWNTZXYAVWCXXMXYCVVQVWCXXMMZXYCXXMVWCXXMVGZXYJXUANVWBWSURZXYCXXMVOZVWCXU
      AXXMXUDVTZXYJNPVWBNXHLXYJWOYSWWAXYJWPYSXYNNPWSURXYJUYPYSXYKUYQZWWAWWBXUAX
      YLMXYMWPWTPVWBUYRXAWBYRXDXXPXYHEVWNXXPWUJMZWYSVWBNUFZWUKXUKXYHXYPVWBVWCXU
      AVVQXXMWUJXUDXEXIXXPXYQWUJVWCXXMXYQVVQXYJVWBXYOUYSXDVTXXPWUJVVMWUKVVQVVMV
      WCXXMWUJXULXGWUMWFXXPWUJVVNXUKVVQVVNVWCXXMWUJXUMXGXUNWFWYSXYQMZXUOMZXYGXY
      EXYBVWIQOZXYBVWKQOZROZROXYEXYTROZYUAROZVWJXYSXYFYUBXYERXYSXYBVWIVWKXYRXYB
      WCLZXUOVWBXJZVTZXYRXVBWUKXVCXUOWYSXVBXYQXVDVTZXVEXVFYHZWYSXUKXVGXYQWUKXVH
      UWSUVNXSXYSXYEXYTYUAXYRXYDWCLZWUKXYEWCLXUOXYRWWRYUEYUJVMYUFPXYBXKXLZXVEXY
      DVWHYGYHXYSXYBVWIYUGYUIXNXYSYUAVWJWCXYSXYBVWBQOZVWJQOZPVWJQOZYUAVWJXYRYUM
      YUNSXUOXYRYULPVWJQVWBYBZVPVTXYSXYBVWBVWJYUGWYSXYQXUOYEXYRWUKXUKXOZYCXUKYU
      NVWJSXYRWUKVWJWGYJUYTZYUPVUAUVLXYSYUDNVWJROZVWJXYSYUCNYUAVWJRXYSXYDXYBVWG
      QOZROZVWHQOZXYEYUSVWHQOZRONYUCXYSXYDYUSVWHXYRYUJXUOYUKVTXYRYUSWCLXUOXYRXY
      BVWGYUFYUHXNVTXYRWUKXUKYFZXTXYSYVAWWMNXYSYUTNVWHQXYRYUTNSXUOXYRYUTXYDXYBP
      UJOZROZNXYRYUSYVDXYDRXYRYUSXYBPQOZYULUJOZYVDXYRYUEWYSYUSYVGSZYUFWYSXYQXPY
      UEWWRWYSYVHVMXYBPVWBXQXRWBXYRYVFXYBYULPUJXYRXYBYUFYAYUOVQWIXSXYRWWRYUEYVE
      NSVMYUFPXYBVUDXLWIVTVPWUKWXSXYRXUKWXTUVQWIXYSYVBXYTXYERXYSXYBVWGVWHYUGWYS
      XVBXYQXUOXVDWDYVCYCXSYDYUQVQXUKYURVWJSXYRWUKVWJUVPYJWIVUEUVRYKXXTXYIUAXYB
      VYKVXBXYBSZXXTVWJXYEXYBXWQQOZROZSZEVWNTXYIYVIXXSYVLEVWNYVIXXRYVKVWJYVIVXD
      XYEXXQYVJRYVIVXCXYDVWHQVXBXYBPUJVLVPVXBXYBXWQQVNVQVRVSYVLXYHEVWNWUJYVKXYG
      VWJWUJYVJXYFXYERWUJXWQVWLXYBQUCVWDXWNVWLVWNXWOUCEUNZXWKVWIXWMVWKRYVMXWJVW
      HVWGQXWIVWDHVUFXSYVMXWLVWJVWBQXWIVWDDVUFXSVQXWOVUGVWIVWKRVUHVUMZXSXSVRVUI
      VUJYIWBXXPVVNVVMXWTXXBXYAVOVVQVVNVWCXXMXUMWDVVQVVMVWCXXMXULWDXVSXWTXXMXXL
      VTUADHXWOEGVHVIYRYNXVSXXNXXCXVSXXNMZXXCXWQVXFSZEVWNTZUAVYKUMZYVOVWBVYKLZX
      WSYVRVWCXXNYVSVVQXUAXUBMZXXNMZXUAXUBXXNUEVWCXXNMYVSYWAXUAXUBXXNXUAXUBXXNY
      EXUAXUBXXNXFYVTXXNVGVUKVWCYVTXXNXUCVULNPVWBWOWPWQUWHXDXWREVWNYVNVUNZYVQXW
      SUAVWBVYKUABUNZYVPXWREVWNYWCVXFVWLXWQYWCVXDVWIVXEVWKRYWCVXCVWGVWHQVXBVWBP
      UJVLVPVXBVWBVWJQVNVQVRVSYIVUOYVOXWTVVMVVNXXCYVRVOXVSXWTXXNXXLVTVVQVVMVWCX
      XNXULWDVVQVVNVWCXXNXUMWDUAXWOHDEGVHVIYRYNVUPWLVYCXXDIXWOVVLCVXSXWOSZVYAXX
      BVYBXXCYWDVXTXXADUQVXSXWOHUSUTVXSXWOVXPUQVAVBJVCXCYWBVWOXWSAXWOCVWEXWOSZV
      WMXWREVWNYWEVWFXWQVWLVWDVWEXWOVUQVURVSYIVUOVVQXWHVWCVVQXWGAUBCCVWRXWACLZM
      VVQVXMXWAVVLLZMZXWGVWRVXMYWFYWGVWRVXMVXRVYEYOCVVLXWACVYCIVVLVVDVVLJVYCIVV
      LVUSVUTVVAUWQXWEXWFVVQYWHMVWFXWBSZEVWNTZXWEVWMXWCMZEVWNTYWJVWMXWCEVWNUWOY
      WKYWIEVWNVWFXWBVWLVVBYLUWPYWHXWFYWJVOVVQVWEXWAEGWAYPWKUYAUYCVTXVRVWOACULX
      VTXWHMVWOACUYEVWOXWDAUBCXWFVWMXWCEVWNXWFVWFXWBVWLVWDVWEXWAVUQVURVSUYDVVCX
      CYKXVQBAVVTVVSVVSVWCXVQMZABYTZUHYWLBAYTFYWMFVWRVWPMZABYTYWMKYWNYWLABVWRVW
      CVWOVVEVVFVVGVVHYWLABVVIVVGUYFYQCVVTFVVJXC $.
  $}

  ${
    $d A p x $.  $d B p x y $.  $d N p x y $.  $d U p x y $.  $d Z p x y $.
    axcontlem3.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    $( Lemma for ~ axcont .  Given the separation assumption, ` B ` is a subset
       of ` D ` .  (Contributed by Scott Fenton, 18-Jun-2013.) $)
    axcontlem3 $p |- ( (
       ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
                      A. x e. A A. y e. B x Btwn <. Z , y >. ) ) /\
        ( Z e. ( EE ` N ) /\ U e. A /\ Z =/= U ) ) ->
       B C_ D ) $=
      ( cn wcel wss cv cop cbtwn wbr wral w3a wa cee cfv wne wo simplr2 simplr3
      simpr2 anim1i adantr breq1 opeq2 breq2d rspc2v sylc orcd ralrimiva sseq2i
      weq crab ssrab bitri sylanbrc ) GKLZCGUAUBZMZDVDMZANZHBNZOZPQZBDRACRZSTZH
      VDLZFCLZHFUCZSZTZVFFHINZOZPQZVRHFOPQZUDZIDRZDEMZVEVFVKVCVPUEVQWBIDVQVRDLZ
      TZVTWAWFVNWETVKVTVQVNWEVLVMVNVOUGUHVQVKWEVEVFVKVCVPUFUIVJVTFVIPQABFVRCDVG
      FVIPUJBIURVIVSFPVHVRHUKULUMUNUOUPWDDWBIVDUSZMVFWCTEWGDJUQWBIVDDUTVAVB $.

  $}

  ${
    $d A b i r t p x $.  $d B b i r t p x y $.  $d N b i r s t p x y $.
    $d U b i r s t p x y $.  $d b i r s t p y $.  $d Z b i r s t $.
    $d Z p x y $.
    axcontlem4.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    $( Lemma for ~ axcont .  Given the separation assumption, ` A ` is a subset
       of ` D ` .  (Contributed by Scott Fenton, 18-Jun-2013.) $)
    axcontlem4 $p |- ( (
       ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
                      A. x e. A A. y e. B x Btwn <. Z , y >. ) ) /\
        ( ( Z e. ( EE ` N ) /\ U e. A /\ B =/= (/) ) /\ Z =/= U ) ) ->
       A C_ D ) $=
      ( vi wcel wral wa wceq c1 co cmul caddc cc0 vb vt vs vr cn cee cfv wss cv
      cop cbtwn wbr w3a c0 wne wo simplr1 wi wex n0 idd ssel adantr simp2 breq1
      rspccva sylan cmin wrex ralimi oveq2 ax-1cn oveq1d oveq12d eqeq1d ralbidv
      oveq1 wb syl2anc cc fveecn ad2antrr sylancom eqtrd mpd simp2l cle 0re 1re
      elicc2i simp1bi syl cdiv clt simp2bi a1i simp3 ne0gt0d divelunit syl22anc
      cr ltletrd simp13 recnd simplr adantl simpr2 sylancr simpll mulcld adddid
      divcl oveq2d addassd adddird mp3an2 mulid1d divcan1 npncan mp3an1 mulassd
      subcl subdi simp1 eqtr3d 3eqtr2rd syl23anc ralrimiva eqeq2d rspcev r19.43
      ex id ralbi orbi12d 3expia brbtwn syl3anc bitri syl6bbr com12 opeq2 rspcv
      breq2d ralimdv 3anim123d anim2d simplr2 sseldd simpr3 syl2an sselda jca32
      jca an4 sylib cfz cicc simpl2r simpl eqcom subid1i syl6eq biimpac simpl2l
      syl5bb simpl3l eqeefv simp1r mulid2 mul02 oveqan12d addid1 bitr4d syl5ibr
      ralbidva expdimp sylan2 necon3d simp1l simp2r letrid simpr mpbird simpll3
      3jca simp12 gt0ne0d 3eqtr3rd biimpar simp112 simp113 simp12r eqtr2d 3expa
      simp12l 3eqtrrd orim12d syl6ibr eqeqan12d eqeqan12rd syl5ibrcom com23 imp
      rexbidv simp3l simp3r anbi12d r19.26 2rexbii reeanv 3imtr4d imp3a sylanl2
      rexlimdvva 3adantr2 3exp2 syl6 exlimiv sylbi com4l 3impd imp32 crab ssrab
      sseq2i sylanbrc ) GUELZCGUFUGZUHZDUYIUHZAUIZHBUIZUJZUKULZBDMZACMZUMZNZHUY
      ILZFCLZDUNUOZUMZHFUOZNZNUYJFHIUIZUJUKULZVUFHFUJUKULZUPZICMZCEUHZUYJUYKUYQ
      UYHVUEUQUYSVUCVUDVUJUYSUYTVUAVUBVUDVUJURZVUBUYSUYTVUAVULVUBUAUIZDLZUAUSUY
      SUYTVUAVULURURZURZUADUTVUNVUPUAVUNUYSUYHUYJVUMUYILZUYLHVUMUJZUKULZACMZUMZ
      NZVUOVUNUYRVVAUYHVUNUYJUYJUYKVUQUYQVUTVUNUYJVAUYKVUNVUQDUYIVUMVBUUAVUNUYP
      VUSACUYOVUSBVUMDUYMVUMOUYNVURUYLUKUYMVUMHUUBUUDUUCUUEUUFUUGVVBUYTVUAVUDVU
      JVVBUYTVUAVUDUMZNZVUIICVVDVUFCLZNZFUYILZVUFUYILZNZFVURUKULZVUFVURUKULZNZN
      ZVUIVVFVVGVVJNZVVHVVKNNVVMVVFVVNVVHVVKVVFVVGVVJVVFCUYIFVVDUYJVVEUYJVUQVUT
      UYHVVCUQZVCUYTVUAVUDVVBVVEUUHUUIVVDVVJVVEVVBVUTVUAVVJVVCUYHUYJVUQVUTUUJZU
      YTVUAVUDVDVUSVVJAFCUYLFVURUKVEVFUUKVCUUNVVDCUYIVUFVVOUULVVDVUTVVEVVKVVBVU
      TVVCVVPVCVUSVVKAVUFCUYLVUFVURUKVEVFVGUUMVVGVVJVVHVVKUUOUUPVVDVVMVUIURZVVE
      VVBUYTVUDVVQVUAVVAUYHVUQUYTVUDNZVVQUYJVUQVUTVDUYHVUQNZVVRNVVIVVLVUIVVSVVR
      VVIVVLVUIURVVSVVRVVIUMZKUIZFUGZPUBUIZVHQZVWAHUGZRQZVWCVWAVUMUGZRQZSQZOZVW
      AVUFUGZPUCUIZVHQZVWERQZVWLVWGRQZSQZOZNZKPGUUQQZMZUCTPUURQZVIUBVXAVIZVWBPU
      DUIZVHQZVWERQZVXCVWKRQZSQZOZKVWSMZVWKVXEVXCVWBRQZSQZOZKVWSMZUPZUDVXAVIZVV
      LVUIVVTVWTVXOUBUCVXAVXAVVTVWCVXALZVWLVXALZNZNZVWTVXOVXSVWTNZVWCTUOZVXOVXT
      VUDVYAVXSVUDVWTUYTVUDVVSVVIVXRUUSVCVXTVWCTHFVWTVXSVWJKVWSMZVWCTOZHFOZURVW
      RVWJKVWSVWJVWQUUTVJVXSVYBVYCVYDVYBVYCNVYDVXSPVWERQZTVWGRQZSQZVWBOZKVWSMZV
      YCVYBVYIVYCVWJVYHKVWSVWJVWIVWBOVYCVYHVWBVWIUVAVYCVWIVYGVWBVYCVWFVYEVWHVYF
      SVYCVWDPVWERVYCVWDPTVHQPVWCTPVHVKPVLUVBUVCVMVWCTVWGRVQVNVOUVFVPUVDVXSVYDV
      WEVWBOZKVWSMZVYIVXSUYTVVGVYDVYKVRUYTVUDVVSVVIVXRUVEZVVGVVHVVSVVRVXRUVGHFK
      GUVHVSVXSVYHVYJKVWSVXSVWAVWSLZNZVYGVWEVWBVYNVWEVTLZVWGVTLZVYGVWEOVXSUYTVY
      MVYOVYLHVWAGWAZVGVXSVYMVUQVYPVVTVUQVXRVYMUYHVUQVVRVVIUVIZWBVUMVWAGWAZWCVY
      OVYPNZVYGVWETSQZVWEVYOVYPVYEVWEVYFTSVWEUVJVWGUVKUVLVYOWUAVWEOVYPVWEUVMVCW
      DVSVOUVPUVNUVOUVQUVRUVSWEVXSVWTVYAVXOURZVVTUYHUYTVUQUMZVXRVWTWUBURVVTUYHU
      YTVUQUYHVUQVVRVVIUVTVVSUYTVUDVVIWFZVYRUWFWUCVXRNVYAVWTVXOWUCVXRVYAVWTVXOU
      RWUCVXRVYAUMZVXOVWTVWIVXEVXCVWPRQZSQZOZKVWSMZVWPVXEVXCVWIRQZSQZOZKVWSMZUP
      ZUDVXAVIZWUEVWCVWLWGULZVWLVWCWGULZUPZWUOWUEVWCVWLWUEVXPVWCXALZWUCVXPVXQVY
      AWFZVXPWUSTVWCWGULZVWCPWGULZTPVWCWHWIWJZWKZWLZWUEVXQVWLXALZWUCVXPVXQVYAUW
      AZVXQWVFTVWLWGULZVWLPWGULZTPVWLWHWIWJZWKZWLZUWBWUEWURWUIUDVXAVIZWUMUDVXAV
      IZUPWUOWUEWUPWVMWUQWVNWUEWUPWVMWUEWUPNZVWCVWLWMQZVXALZVWIPWVPVHQZVWERQZWV
      PVWPRQZSQZOZKVWSMZWVMWVOWVQWUPWUEWUPUWCZWVOWUSWVAWVFTVWLWNULWVQWUPVRWUEWU
      SWUPWVEVCZWUEWVAWUPWUEVXPWVAWUTVXPWUSWVAWVBWVCWOWLZVCWUEWVFWUPWVLVCZWVOTV
      WCVWLTXALZWVOWHWPWWEWWGWUETVWCWNULZWUPWUEVWCWVEWWFWUCVXRVYAWQWRZVCWWDXBVW
      CVWLWSWTUWDWVOWWBKVWSWVOVYMNZVYOVYPVWCVTLZVWLVTLZVWLTUOZWWBWVOVYMUYTVYOWU
      EUYTWUPVYMUYHUYTVUQVXRVYAUWGWBVYQWCWVOVYMVUQVYPWUEVUQWUPVYMUYHUYTVUQVXRVY
      AXCWBVYSWCWUEWWLWUPVYMWUEVXPWWLWUTVXPVWCWVDXDZWLWBWUEWWMWUPVYMWUEVXQWWMWV
      GVXQVWLWVKXDZWLWBWWKVWLWWKTVWCVWLWWHWWKWHWPWUEWUSWUPVYMWVEWBZWUEWVFWUPVYM
      WVLWBWWKVWCWWQWUEWVAWUPVYMWWFWBWUCVXRVYAWUPVYMUWEWRWUEWUPVYMXEXBUWHVYTWWL
      WWMWWNUMZNZWWAWVSWVPVWNRQZWVPVWORQZSQZSQWVSWWTSQZWXASQVWIWWSWVTWXBWVSSWWS
      WVPVWNVWOWWRWVPVTLZVYTVWCVWLXLZXFZWWSVWMVWEWWSPVTLZWWMVWMVTLVLVYTWWLWWMWW
      NXGZPVWLYBXHZVYOVYPWWRXIZXJZWWSVWLVWGWXHVYOVYPWWRXEZXJZXKXMWWSWVSWWTWXAWW
      SWVRVWEWWSWXGWXDWVRVTLVLWXFPWVPYBXHZWXJXJWWSWVPVWNWXFWXKXJWWSWVPVWOWXFWXM
      XJXNWWSWXCVWFWXAVWHSWWSWVRWVPVWMRQZSQZVWERQWVSWXOVWERQZSQVWFWXCWWSWVRWXOV
      WEWXNWWSWVPVWMWXFWXIXJWXJXOWWSWXPVWDVWERWWRWXPVWDOVYTWWRWXPWVRWVPVWCVHQZS
      QZVWDWWRWXOWXRWVRSWWRWXOWVPPRQZWVPVWLRQZVHQZWXRWWRWXDWWMWXOWYBOZWXEWWLWWM
      WWNVDWXDWXGWWMWYCVLWVPPVWLYCXPVSWWRWXTWVPWYAVWCVHWWRWVPWXEXQVWCVWLXRZVNWD
      XMWWRWXDWWLWXSVWDOZWXEWWLWWMWWNYDWXGWXDWWLWYEVLPWVPVWCXSXTVSWDXFVMWWSWXQW
      WTWVSSWWSWVPVWMVWEWXFWXIWXJYAXMUWIWWSWYAVWGRQWXAVWHWWSWVPVWLVWGWXFWXHWXLY
      AWWSWYAVWCVWGRWWRWYAVWCOVYTWYDXFVMYEVNYFYGYHWUIWWCUDWVPVXAVXCWVPOZWUHWWBK
      VWSWYFWUGWWAVWIWYFVXEWVSWUFWVTSWYFVXDWVRVWERVXCWVPPVHVKVMVXCWVPVWPRVQVNYI
      VPYJVSYLWUEWUQWVNWUEWUQNZVWLVWCWMQZVXALZVWPPWYHVHQZVWERQZWYHVWIRQZSQZOZKV
      WSMZWVNWUEWYIWUQWUEWVFWVHWUSWWIWYIWUQVRWVLWUEVXQWVHWVGVXQWVFWVHWVIWVJWOWL
      WVEWWJVWLVWCWSWTUWJWYGWYNKVWSWUEWUQVYMWYNWUEWUQVYMUMZVYOVYPWWMWWLVYAWYNWY
      PUYTVYMVYOUYHUYTVUQVXRVYAWUQVYMUWKWUEWUQVYMWQZVYQVSWYPVUQVYMVYPUYHUYTVUQV
      XRVYAWUQVYMUWLWYQVYSVSWYPVXQWWMVXPVXQWUCVYAWUQVYMUWMWWPWLWYPVXPWWLVXPVXQW
      UCVYAWUQVYMUWPWWOWLWUCVXRVYAWUQVYMXCVYTWWMWWLVYAUMZNZWYMWYKWYHVWFRQZWYHVW
      HRQZSQZSQWYKWYTSQZXUASQVWPWYSWYLXUBWYKSWYSWYHVWFVWHWYRWYHVTLZVYTVWLVWCXLZ
      XFZWYSVWDVWEWYSWXGWWLVWDVTLVLVYTWWMWWLVYAXGZPVWCYBXHZVYOVYPWYRXIZXJZWYSVW
      CVWGXUGVYOVYPWYRXEZXJZXKXMWYSWYKWYTXUAWYSWYJVWEWYSWXGXUDWYJVTLVLXUFPWYHYB
      XHZXUIXJWYSWYHVWFXUFXUJXJWYSWYHVWHXUFXULXJXNWYSXUCVWNXUAVWOSWYSVWNWYJWYHV
      WDRQZSQZVWERQZWYKXUNVWERQZSQXUCWYRVWNXUPOVYTWYRVWMXUOVWERWYRXUOWYJWYHVWLV
      HQZSQZVWMWYRXUNXURWYJSWYRXUNWYHPRQZWYHVWCRQZVHQZXURWYRXUDWWLXUNXVBOZXUEWW
      MWWLVYAVDXUDWXGWWLXVCVLWYHPVWCYCXPVSWYRXUTWYHXVAVWLVHWYRWYHXUEXQVWLVWCXRZ
      VNWDXMWYRXUDWWMXUSVWMOZXUEWWMWWLVYAYDWXGXUDWWMXVEVLPWYHVWLXSXTVSUWNVMXFWY
      SWYJXUNVWEXUMWYSWYHVWDXUFXUHXJXUIXOWYSXUQWYTWYKSWYSWYHVWDVWEXUFXUHXUIYAXM
      UWQWYSXVAVWGRQZXUAVWOWYSWYHVWCVWGXUFXUGXUKYAWYRXVFVWOOVYTWYRXVAVWLVWGRXVD
      VMXFYEVNYFYGUWOYHWUMWYOUDWYHVXAVXCWYHOZWULWYNKVWSXVGWUKWYMVWPXVGVXEWYKWUJ
      WYLSXVGVXDWYJVWERVXCWYHPVHVKVMVXCWYHVWIRVQVNYIVPYJVSYLUWRWUIWUMUDVXAYKUWS
      WEVWTVXNWUNUDVXAVWTVXIWUIVXMWUMVWTVXHWUHVRZKVWSMVXIWUIVRVWRXVHKVWSVWJVWQV
      WBVWIVXGWUGVWJYMVWQVXFWUFVXESVWKVWPVXCRVKXMUWTVJVXHWUHKVWSYNWLVWTVXLWULVR
      ZKVWSMVXMWUMVRVWRXVIKVWSVWQVWJVWKVWPVXKWUKVWQYMVWJVXJWUJVXESVWBVWIVXCRVKX
      MUXAVJVXLWULKVWSYNWLYOUXEUXBYPUXCVGUXDWEYLUXOVVTVVLVYBUBVXAVIZVWQKVWSMZUC
      VXAVIZNZVXBVVTVVJXVJVVKXVLVVTVVGUYTVUQVVJXVJVRVVSVVRVVGVVHUXFZWUDVYRUBFHV
      UMKGYQYRVVTVVHUYTVUQVVKXVLVRVVSVVRVVGVVHUXGZWUDVYRUCVUFHVUMKGYQYRUXHVXBVY
      BXVKNZUCVXAVIUBVXAVIXVMVWTXVPUBUCVXAVXAVWJVWQKVWSUXIUXJVYBXVKUBUCVXAVXAUX
      KYSYTVVTVUIVXIUDVXAVIZVXMUDVXAVIZUPVXOVVTVUGXVQVUHXVRVVTVVGUYTVVHVUGXVQVR
      XVNWUDXVOUDFHVUFKGYQYRVVTVVHUYTVVGVUHXVRVRXVOWUDXVNUDVUFHFKGYQYRYOVXIVXMU
      DVXAYKYTUXLYPUXMUXNUXPVCWEYHUXQUXRUXSUXTUYAUYBUYCVUKCVUIIUYIUYDZUHUYJVUJN
      EXVSCJUYFVUIIUYICUYEYSUYG $.
  $}

  ${
    $d t D x $.  $d i p t x N $.  $d P i $.  $d t p $.  $d t P $.  $d x p $.
    $d x P $.  $d x T i t $.  $d U i p t x $.  $d i Z p t x $.
    axcontlem5.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    axcontlem5.2 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  Compute the value of ` F ` .  (Contributed by
       Scott Fenton, 18-Jun-2013.) $)
    axcontlem5 $p |- ( ( ( ( N e. NN /\ Z e. ( EE ` N ) /\ U e. ( EE ` N ) )
       /\ Z =/= U ) /\ P e. D ) -> ( ( F ` P ) = T <->
         ( T e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N ) ( P ` i ) =
              ( ( ( 1 - T ) x. ( Z ` i ) ) + ( T x. ( U ` i ) ) ) ) ) ) $=
      ( wcel cfv wa co wceq c1 cmul cn cee w3a wne cc0 cpnf cico cmin caddc cfz
      cv wral wf1o wf axcontlem2 f1of syl ffvelrnda eleq1 syl5ibcom wi simpl wb
      a1i wbr wfn f1ofn fnbrfvb sylan 3adant3 fveq1 eqeq1d ralbidv anbi2d oveq2
      anbi12d oveq1d oveq1 eqeq2d anass anidm anbi2i bitr2i anbi1i syl6bb brabg
      oveq12d 3bitr3i bianabs 3adant1 bitrd 3expia pm5.21ndd ) IUANJIUBOZNFWNNU
      CJFUDPZDCNZPZEUEUFUGQZNZDHOZERZWSGUKZDOZSEUHQZXBJOZTQZEXBFOZTQZUIQZRZGSIU
      JQZULZPZWQWTWRNXAWSWOCWRDHWOCWRHUMZCWRHUNABCFGHIJKLMUOZCWRHUPUQURWTEWRUSU
      TXMWSVAWQWSXLVBVDWOWPWSXAXMVCWOWPWSUCXADEHVEZXMWOWPXAXPVCZWSWOHCVFZWPXQWO
      XNXRXOCWRHVGUQCDEHVHVIVJWPWSXPXMVCWOWPWSPZXPXMAUKZCNZBUKZWRNZXBXTOZSYBUHQ
      ZXETQZYBXGTQZUIQZRZGXKULZPZPWPYCXCYHRZGXKULZPZPZXSXMPZABDECWRHXTDRZYAWPYK
      YNXTDCUSYQYJYMYCYQYIYLGXKYQYDXCYHXBXTDVKVLVMVNVPYBERZYOWPXMPZYPYRYNXMWPYR
      YCWSYMXLYBEWRUSYRYLXJGXKYRYHXIXCYRYFXFYGXHUIYRYEXDXETYBESUHVOVQYBEXGTVRWG
      VSVMVPVNXSXLPXSWSPZXLPYSYPXSYTXLYTWPWSWSPZPXSWPWSWSVTUUAWSWPWSWAWBWCWDWPW
      SXLVTXSWSXLVTWHWEMWFWIWJWKWLWM $.

    ${
      $d D s $.  $d D y $.  $d F i j s $.  $d F y $.  $d i y $.  $d j p $.
      $d j t $.  $d j x $.  $d j y $.  $d N j s $.  $d N y $.  $d P j s $.
      $d p s $.  $d p y $.  $d P y $.  $d s t $.  $d s x $.  $d s y $.
      $d t y $.  $d U j $.  $d U s $.  $d U y $.  $d x y $.  $d Z j $.
      $d Z s $.  $d Z y $.
      $( Lemma for ~ axcont .  State the defining properties of the value of
         ` F ` (Contributed by Scott Fenton, 19-Jun-2013.) $)
      axcontlem6 $p |- ( ( ( ( N e. NN /\ Z e. ( EE ` N ) /\ U e. ( EE ` N )
            )
       /\ Z =/= U ) /\ P e. D ) -> ( ( F ` P ) e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N ) ( P ` i ) =
              ( ( ( 1 - ( F ` P ) ) x. ( Z ` i ) ) +
                  ( ( F ` P ) x. ( U ` i ) ) )
              ) ) $=
        ( vj wcel cfv wa co cmul caddc wceq vy vs cn cee w3a wne cc0 cpnf cv c1
        cico cmin wral axcontlem1 axcontlem5 mpbii fveq2 oveq2d oveq12d eqeq12d
        cfz eqid cbvralv anbi2i sylib ) HUCNIHUDOZNEVFNUEIEUFPDCNPZDGOZUGUHUKQN
        ZMUIZDOZUJVHULQZVJIOZRQZVHVJEOZRQZSQZTZMUJHVAQZUMZPZVIFUIZDOZVLWBIOZRQZ
        VHWBEOZRQZSQZTZFVSUMZPVGVHVHTWAVHVBUAUBCDVHEMGHIJKAUABCEFMGHIUBLUNUOUPV
        TWJVIVRWIMFVSVJWBTZVKWCVQWHVJWBDUQWKVNWEVPWGSWKVMWDVLRVJWBIUQURWKVOWFVH
        RVJWBEUQURUSUTVCVDVE $.
    $}
  $}

  ${
    $d t D x $.  $d i F t $.  $d i p t x N $.  $d P i $.  $d t p $.  $d t P $.
    $d x p $.  $d x P $.  $d Q i t x $.  $d U i p t x $.  $d i Z p t x $.
    axcontlem7.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    axcontlem7.2 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  Given two points in ` D ` , one preceeds the other
       iff its scaling constant is less than the other point's.  (Contributed
       by Scott Fenton, 18-Jun-2013.) $)
    axcontlem7 $p |- ( ( ( ( N e. NN /\ Z e. ( EE ` N ) /\ U e. ( EE ` N ) )
       /\ Z =/= U ) /\ ( P e. D /\ Q e. D ) ) ->
          ( P Btwn <. Z , Q >. <-> ( F ` P ) <_ ( F ` Q ) ) ) $=
      ( wcel wa c1 co cmul wceq cc0 cn cee cfv w3a wne cop cbtwn wbr cmin caddc
      cv cfz wral cicc wrex wb wo crab ssrab2 eqsstri ad2antrl simpll2 ad2antll
      cle sseli brbtwn syl3anc cpnf cico axcontlem6 anim12dan an4 r19.26 anbi2i
      bitr4i id oveq2 oveq2d eqeqan12d ralimi ralbi syl rexbidv cc fveecn sylan
      simpll3 cr 0re elicc2i simp1bi recnd adantr elrege0 simplbi adantl ax-1cn
      1re simpr1 simpr3 mulcld subcl sylancr mpan simpll subdird simpr2 nnncan1
      3ad2ant2 mp3an1 syl2anc oveq1d subdi mp3an2 mulid1 npncan eqtr2d 3ad2ant1
      3ad2ant3 adddird mulassd 3eqtrd 3eqtr3d simplr eqeq12d addsubeq4d addassd
      eqtrd addcld adddid eqtr4d eqeq2d 3bitr2rd ralbidva a1i ad2antlr wi oveq1
      rspcev bitrd syl23anc subcld mulcan1g r19.32v neneqd biorf orcom subeq0ad
      wn syl6bb eqeefv 3adant1 orbi2d 3bitr3rd anassrs rexbidva simp3bi lemul1a
      syl5bb 3bitrd syl31anc mulid2d breqtrd breq1 syl5ibrcom rexlimdva 0elunit
      biimpi simpl mul02d adantrl a1d ex cdiv simp3 clt simprbi ne0gt0d ltletrd
      simp1 divelunit syl22anc mpbird gt0ne0d divcan1d 3exp pm2.61ine sylan9bbr
      eqcomd impbid anasss sylan2b syldan ) IUANZJIUBUCZNZFUWONZUDZJFUEZOZDCNZE
      CNZOZOZDJEUFUGUHZGUKZDUCZPBUKZUIQZUXFJUCZRQZUXHUXFEUCZRQZUJQZSZGPIULQZUMZ
      BTPUNQZUOZDHUCZEHUCZVDUHZUXDDUWONZUWPEUWONZUXEUXSUPUXAUYCUWTUXBCUWODCFJKU
      KZUFUGUHUYEJFUFUGUHUQZKUWOURUWOLUYFKUWOUSUTZVEVAUWNUWPUWQUWSUXCVBUXBUYDUW
      TUXACUWOEUYGVEVCBDJEGIVFVGUWTUXCUXTTVHVIQZNZUXGPUXTUIQZUXJRQZUXTUXFFUCZRQ
      ZUJQZSZGUXPUMZOZUYAUYHNZUXLPUYAUIQZUXJRQZUYAUYLRQZUJQZSZGUXPUMZOZOZUXSUYB
      UPZUWTUXAUYQUXBVUEABCDFGHIJKLMVJABCEFGHIJKLMVJVKVUFUWTUYIUYROZUYOVUCOZGUX
      PUMZOZVUGVUFVUHUYPVUDOZOVUKUYIUYPUYRVUDVLVUJVULVUHUYOVUCGUXPVMVNVOUWTVUHV
      UJVUGVUJUXSUYNUXKUXHVUBRQZUJQZSZGUXPUMZBUXRUOZUWTVUHOZUYBVUJUXQVUPBUXRVUJ
      UXOVUOUPZGUXPUMUXQVUPUPVUIVUSGUXPUYOVUCUXGUYNUXNVUNUYOVPVUCUXMVUMUXKUJUXL
      VUBUXHRVQVRVSVTUXOVUOGUXPWAWBWCVURVUQUXTUXHUYARQZSZBUXRUOZUYBVURVUPVVABUX
      RUWTVUHUXHUXRNZVUPVVAUPUWTVUHVVCOZOZVUPUXTVUTUIQZUXJRQZVVFUYLRQZSZGUXPUMV
      VFTSZUXJUYLSZUQZGUXPUMZVVAVVEVUOVVIGUXPVVEUXFUXPNZOZUXJWDNZUYLWDNZUXHWDNZ
      UXTWDNZUYAWDNZVUOVVIUPVVEUWPVVNVVPUWNUWPUWQUWSVVDVBJUXFIWEWFZVVEUWQVVNVVQ
      UWNUWPUWQUWSVVDWGFUXFIWEWFZVVEVVRVVNVVCVVRUWTVUHVVCUXHVVCUXHWHNZTUXHVDUHZ
      UXHPVDUHZTPUXHWIWRWJZWKZWLVCZWMZVVEVVSVVNVUHVVSUWTVVCUYIVVSUYRUYIUXTUYIUX
      TWHNZTUXTVDUHZUXTWNZWOZWLWMZVAZWMZVVEVVTVVNVUHVVTUWTVVCUYRVVTUYIUYRUYAUYR
      UYAWHNZTUYAVDUHZUYAWNZWOZWLZWPZVAZWMZVVPVVQOZVVRVVSVVTUDZOZVVIUXKUXHUYTRQ
      ZUJQZUYKUIQZUYMUXHVUARQZUIQZSUYNVXIVXKUJQZSVUOVXGVVGVXJVVHVXLVXGPVUTUIQZU
      YJUIQZUXJRQVXNUXJRQZUYKUIQVVGVXJVXGVXNUYJUXJVXGPWDNZVUTWDNZVXNWDNWQVXGUXH
      UYAVXEVVRVVSVVTWSZVXEVVRVVSVVTWTZXAZPVUTXBXCVXFUYJWDNZVXEVVSVVRVYBVVTVXQV
      VSVYBWQPUXTXBXDXIWPZVVPVVQVXFXEZXFVXGVXOVVFUXJRVXGVXRVVSVXOVVFSZVYAVXEVVR
      VVSVVTXGZVXQVXRVVSVYEWQPVUTUXTXHXJXKXLVXGVXPVXIUYKUIVXGVXPUXIUXHUYSRQZUJQ
      ZUXJRQUXKVYGUXJRQZUJQVXIVXGVXNVYHUXJRVXGVYHUXIUXHVUTUIQZUJQZVXNVXGVYGVYJU
      XIUJVXGVVRVVTVYGVYJSVXSVXTVVRVVTOZVYGUXHPRQZVUTUIQZVYJVVRVXQVVTVYGVYNSWQU
      XHPUYAXMXNVYLVYMUXHVUTUIVVRVYMUXHSVVTUXHXOWMXLYHXKVRVXGVVRVXRVYKVXNSZVXSV
      YAVXQVVRVXRVYOWQPUXHVUTXPXJXKXQXLVXGUXIVYGUXJVXFUXIWDNZVXEVVRVVSVYPVVTVXQ
      VVRVYPWQPUXHXBXDXRWPZVXGUXHUYSVXSVXFUYSWDNZVXEVVTVVRVYRVVSVXQVVTVYRWQPUYA
      XBXDXSWPZXAVYDXTVXGVYIVXHUXKUJVXGUXHUYSUXJVXSVYSVYDYAVRYBXLYCVXGVVHUYMVUT
      UYLRQZUIQVXLVXGUXTVUTUYLVYFVYAVVPVVQVXFYDZXFVXGVYTVXKUYMUIVXGUXHUYAUYLVXS
      VXTWUAYAVRYHYEVXGUYKUYMVXIVXKVXGUYJUXJVYCVYDXAVXGUXTUYLVYFWUAXAVXGUXKVXHV
      XGUXIUXJVYQVYDXAZVXGUXHUYTVXSVXGUYSUXJVYSVYDXAZXAZYIVXGUXHVUAVXSVXGUYAUYL
      VXTWUAXAZXAZYFVXGVXMVUNUYNVXGVXMUXKVXHVXKUJQZUJQVUNVXGUXKVXHVXKWUBWUDWUFY
      GVXGVUMWUGUXKUJVXGUXHUYTVUAVXSWUCWUEYJVRYKYLYMUUAYNVVEVVIVVLGUXPVVOVVFWDN
      VVPVVQVVIVVLUPVVOUXTVUTVWPVVOUXHUYAVWIVXDXAUUBVWAVWBVVFUXJUYLUUCVGYNVVMVV
      JVVKGUXPUMZUQZVVEVVAVVJVVKGUXPUUDVVEVVJVVJJFSZUQZVVAWUIVVEWUJUUIZVVJWUKUP
      VVEJFUWRUWSVVDYDUUEWULVVJWUJVVJUQWUKWUJVVJUUFWUJVVJUUGUUJWBVVEUXTVUTVWOVV
      EUXHUYAVWHVXCXAUUHVVEWUJWUHVVJUWTWUJWUHUPZVVDUWRWUMUWSUWPUWQWUMUWNJFGIUUK
      UULWMWMUUMUUNUUSUUTUUOUUPVUHVVBUYBUPUWTVUHVVBUYBVUHVVAUYBBUXRVVDUYBVVAVUT
      UYAVDUHVVDVUTPUYARQZUYAVDVVDVWCPWHNZVWQVWROZVWEVUTWUNVDUHVVCVWCVUHVWGWPWU
      OVVDWRYOUYRWUPUYIVVCUYRWUPVWSUVHYPVVCVWEVUHVVCVWCVWDVWEVWFUUQWPUXHPUYAUUR
      UVAVVDUYAUYRVVTUYIVVCVXAYPUVBUVCUXTVUTUYAVDUVDUVEUVFVUHUYBVVBYQZYQUXTTUXT
      TSZVUHWUQWURVUHOVVBUYBWURUYRVVBUYIWURUYROZTUXRNUXTTUYARQZSZVVBUVGWUSUXTTW
      UTWURUYRUVIUYRWUTTSWURUYRUYAVXAUVJWPYKVVAWVABTUXRUXHTSVUTWUTUXTUXHTUYARYR
      YLYSXCUVKUVLUVMUXTTUEZVUHUYBVVBWVBVUHUYBUDZUXTUYAUVNQZUXRNZUXTWVDUYARQZSZ
      VVBWVCWVEUYBWVBVUHUYBUVOZWVCVWJVWKVWQTUYAUVPUHWVEUYBUPVUHWVBVWJUYBUYIVWJU
      YRVWMWMXIZVUHWVBVWKUYBUYIVWKUYRUYIVWJVWKVWLUVQWMXIZVUHWVBVWQUYBUYRVWQUYIV
      WTWPXIZWVCTUXTUYATWHNWVCWIYOWVIWVKWVCUXTWVIWVJWVBVUHUYBUVTUVRWVHUVSZUXTUY
      AUWAUWBUWCWVCWVFUXTWVCUXTUYAVUHWVBVVSUYBVWNXIVUHWVBVVTUYBVXBXIWVCUYAWVLUW
      DUWEUWIVVAWVGBWVDUXRUXHWVDSVUTWVFUXTUXHWVDUYARYRYLYSXKUWFUWGUWJWPYTUWHUWK
      UWLUWMYT $.
  $}

  ${
    $d D p t x $.  $d F p i t $.  $d x i N p t $.  $d P i p t x $.
    $d Q i p t x $.  $d R i p t x $.  $d U i p t x $.  $d i Z p t x $.
    $d i F t $.
    axcontlem8.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    axcontlem8.2 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  A point in ` D ` is between two others if its
       function value falls in the middle.  (Contributed by Scott Fenton,
       18-Jun-2013.) $)
    axcontlem8 $p |- ( ( ( ( N e. NN /\ Z e. ( EE ` N ) /\ U e. ( EE ` N ) )
       /\ Z =/= U ) /\ ( P e. D /\ Q e. D /\ R e. D ) ) ->
          ( ( ( F ` P ) <_ ( F ` Q ) /\ ( F ` Q ) <_ ( F ` R ) ) ->
            Q Btwn <. P , R >. ) ) $=
      ( wcel c1 cmin co cmul caddc cn cee cfv w3a wne wa cle wbr cop cbtwn wceq
      cv cfz wral cc0 cicc wrex cpnf cico axcontlem6 ex 3anim123d imp adantr wi
      3an6 0elunit cc cr simplr1 ad2antlr elrege0 simplbi recnd simprrl simprrr
      syl simpl breqtrrd simplr2 letri3d simpll simpll2 fveecn sylancom simpll3
      mpbir2and ax-1cn subcl sylancr simprl mulcld mulcl adantrl addcld mulid2d
      mul02d oveq12d addid1d eqtr2d 3adant2 oveq2 oveq1d oveq1 oveq2d eqeqan12d
      wb 3ad2ant2 syl122anc ralrimiva subid1i eqeq2d ralbidv rspcev cdiv adantl
      mpbid resubcld mpbird necomd ad2antrl sylan divdird mulid1d mulcomd eqtrd
      clt subcld mp3an2 syl2anc subdird divmuld div23d 3eqtr3d 3eqtr4rd adddird
      subdi mulassd adddid sseli syl6eq simplr3 lesub1dd subge0d ltlend posdifd
      divelunit syl22anc simp2r simp2l simp1l subne0d addsub4d npncand npncan3d
      letrd simp1r subdid 3eqtr2d 3eqtr4d divsubdird dividd divcld simp3l add4d
      nnncan2d simp3r eqtr4d syl222anc pm2.61ine simp2 oveqan12d eqeq12d ralimi
      r19.26-3 ralbi rexbidv biimprcd syl5bir expimpd adantlr syl5bi mpd simpl1
      an32s wo crab ssrab2 eqsstri 3anim123i 3com12 brbtwn syl2an ) JUAOZKJUBUC
      ZOZGUWOOZUDKGUEZUFZDCOZECOZFCOZUDZUFZDIUCZEIUCZUGUHZUXFFIUCZUGUHZUFZEDFUI
      UJUHZUXDUXJUFZUXKHULZEUCZPBULZQRZUXMDUCZSRZUXOUXMFUCZSRZTRZUKZHPJUMRZUNZB
      UOPUPRZUQZUXLUXEUOURUSRZOZUXQPUXEQRZUXMKUCZSRZUXEUXMGUCZSRZTRZUKZHUYCUNZU
      FZUXFUYGOZUXNPUXFQRZUYJSRZUXFUYLSRZTRZUKZHUYCUNZUFZUXHUYGOZUXSPUXHQRZUYJS
      RZUXHUYLSRZTRZUKZHUYCUNZUFZUDZUYFUXDVUNUXJUWSUXCVUNUWSUWTUYQUXAVUEUXBVUMU
      WSUWTUYQABCDGHIJKLMNUTVAUWSUXAVUEABCEGHIJKLMNUTVAUWSUXBVUMABCFGHIJKLMNUTV
      AVBVCVDVUNUYHUYRVUFUDZUYPVUDVULUDZUFZUXLUYFUYHUYPUYRVUDVUFVULVFUWSUXJVUQU
      YFVEUXCUWSUXJUFVUOVUPUYFUWSVUOUXJVUPUYFVEZUWSVUOUFZUXJUFZVUBUXPUYNSRZUXOV
      UJSRZTRZUKZHUYCUNZBUYEUQZVURVUTVVFVEUXEUXHUXEUXHUKZVUTVVFVVGVUTUFZUOUYEOV
      UBPUYNSRZUOVUJSRZTRZUKZHUYCUNZVVFVGVVHVVLHUYCVVHUXMUYCOZUFZUXEVHOZUXEUXFU
      KZVVGUYJVHOZUYLVHOZVVLVVOUXEVVOUYHUXEVIOZVUTUYHVVGVVNUYHUYRVUFUWSUXJVJZVK
      UYHVVTUOUXEUGUHUXEVLVMZVQZVNVVOVVQUXGUXFUXEUGUHZVVHUXGVVNVVGVUSUXGUXIVOVD
      VVHVWDVVNVVHUXFUXHUXEUGVVGVUSUXGUXIVPVVGVUTVRVSVDVVOUXEUXFVWCVVOUYRUXFVIO
      ZVUTUYRVVGVVNUYHUYRVUFUWSUXJVTZVKUYRVWEUOUXFUGUHUXFVLVMZVQWAWGVVGVUTVVNWB
      VVHVVNUWPVVRVUTUWPVVGVVNVUSUWPUXJUWNUWPUWQUWRVUOWCZVDVKKUXMJWDZWEVVHVVNUW
      QVVSVUTUWQVVGVVNVUSUWQUXJUWNUWPUWQUWRVUOWFZVDVKGUXMJWDZWEVVPVVQVVGUFZVVRV
      VSUFZUDUYNVVIUOUYNSRZTRZUKZVVLVVPVWMVWPVWLVVPVWMUFZVWOUYNUOTRUYNVWQVVIUYN
      VWNUOTVWQUYNVWQUYKUYMVWQUYIUYJVWQPVHOZVVPUYIVHOZWHVVPVWMVRPUXEWIZWJVVPVVR
      VVSWKWLVVPVVSUYMVHOVVRUXEUYLWMWNWOZWPVWQUYNVXAWQWRVWQUYNVXAWSWTXAVWLVVPVW
      PVVLXGVWMVVQVVGUYNVUBVWOVVKVVQUYKUYTUYMVUATVVQUYIUYSUYJSUXEUXFPQXBXCUXEUX
      FUYLSXDWRVVGVWNVVJVVITVVGUYNVUJUOSVVGUYKVUHUYMVUITVVGUYIVUGUYJSUXEUXHPQXB
      XCUXEUXHUYLSXDWRXEXEXFXHXQXIXJVVEVVMBUOUYEUXOUOUKZVVDVVLHUYCVXBVVCVVKVUBV
      XBVVAVVIVVBVVJTVXBUXPPUYNSVXBUXPPUOQRPUXOUOPQXBPWHXKUUAXCUXOUOVUJSXDWRXLX
      MXNWJVAUXEUXHUEZVUTVVFVXCVUTUFZUXFUXEQRZUXHUXEQRZXORZUYEOZVUBPVXGQRZUYNSR
      ZVXGVUJSRZTRZUKZHUYCUNZVVFVXDVXHVXEVXFUGUHZVXDUXFUXHUXEVXDUYRVWEVUTUYRVXC
      VWFXPVWGVQZVXDVUFUXHVIOZVUTVUFVXCUYHUYRVUFUWSUXJUUBZXPVUFVXQUOUXHUGUHUXHV
      LVMZVQZVXDUYHVVTVUTUYHVXCVWAXPVWBVQZVXCVUSUXGUXIVPZUUCVXDVXEVIOUOVXEUGUHZ
      VXFVIOUOVXFYGUHZVXHVXOXGVXDUXFUXEVXPVYAXRVXDVYCUXGVXCVUSUXGUXIVOZVXDUXFUX
      EVXPVYAUUDXSVXDUXHUXEVXTVYAXRVXDUXEUXHYGUHZVYDVXDVYFUXEUXHUGUHUXHUXEUEVXD
      UXEUXFUXHVYAVXPVXTVYEVYBUUPVXDUXEUXHVXCVUTVRXTVXDUXEUXHVYAVXTUUEWGVXDUXEU
      XHVYAVXTUUFXQVXEVXFUUGUUHXSVXDVXMHUYCVXDVVNUFZVVPVXCUXFVHOZUXHVHOZVVRVVSV
      XMVYGUYHVVPVUTUYHVXCVVNVWAVKUYHUXEVWBVNVQVXCVUTVVNWBVYGUYRVYHVUTUYRVXCVVN
      VWFVKUYRUXFVWGVNVQVYGVUFVYIVUTVUFVXCVVNVXRVKVUFUXHVXSVNVQVXDUWPVVNVVRVUSU
      WPVXCUXJVWHYAVWIYBVXDUWQVVNVVSVUSUWQVXCUXJVWJYAVWKYBVVPVXCUFZVYHVYIUFZVWM
      UDZVUBVXIUYISRZVXGVUGSRZTRZUYJSRZVXIUXESRZVXGUXHSRZTRZUYLSRZTRZVXLVYLUYTV
      YPVUAVYTTVYLUYSVYOUYJSVYLUXHUXFQRZUYISRZVXEVUGSRZTRZVXFXORZWUCVXFXORZWUDV
      XFXORZTRUYSVYOVYLWUCWUDVXFVYLWUBUYIVYLUXHUXFVYJVYHVYIVWMUUIZVYJVYHVYIVWMU
      UJZYHZVYLVWRVVPVWSWHVVPVXCVYKVWMUUKZVWTWJZWLZVYLVXEVUGVYLUXFUXEWUJWULYHZV
      YLVWRVYIVUGVHOWHWUIPUXHWIWJZWLZVYLUXHUXEWUIWULYHZVYLUXHUXEWUIWULVYLUXEUXH
      VVPVXCVYKVWMUUQXTUULZYCVYLWUFUYSUKVXFUYSSRZWUEUKVYLVXFPSRZVXFUXFSRZQRZVXF
      UXFUXHSRZUXFUXESRZQRZQRZWUTWUEVYLWVAVXFWVBWVFQVYLVXFWURYDVYLWVBUXFVXFSRWV
      FVYLVXFUXFWURWUJYEVYLUXFUXHUXEWUJWUIWULUURYFZWRVYLVXFVHOZVYHWUTWVCUKZWURW
      UJWVIVWRVYHWVJWHVXFPUXFYQYIYJVYLWUEWUBUXEUXHSRZWVEQRZQRZVXEWVDWVKQRZQRZTR
      WUBVXETRZWVLWVNTRZQRWVGVYLWUCWVMWUDWVOTVYLWUCWUBPSRZWUBUXESRZQRZWVMVYLWUB
      VHOZVVPWUCWVTUKZWUKWULWWAVWRVVPWWBWHWUBPUXEYQYIYJVYLWVRWUBWVSWVLQVYLWUBWU
      KYDVYLWVSUXHUXESRZWVEQRWVLVYLUXHUXFUXEWUIWUJWULYKVYLWWCWVKWVEQVYLUXHUXEWU
      IWULYEXCYFZWRYFVYLWUDVXEPSRZVXEUXHSRZQRZWVOVYLVXEVHOZVYIWUDWWGUKZWUOWUIWW
      HVWRVYIWWIWHVXEPUXHYQYIYJVYLWWEVXEWWFWVNQVYLVXEWUOYDVYLUXFUXEUXHWUJWULWUI
      YKZWRYFWRVYLWUBVXEWVLWVNWUKWUOVYLWVKWVEVYLUXEUXHWULWUIWLZVYLUXFUXEWUJWULW
      LZYHVYLWVDWVKVYKVYJWVDVHOVWMUXFUXHWMXHZWWKYHUUMVYLWVPVXFWVQWVFQVYLUXHUXFU
      XEWUIWUJWULUUNVYLWVKWVEWVDWWKWWLWWMUUOZWRUUSUUTVYLWUEVXFUYSVYLWUCWUDWUNWU
      QWOWURVYLVWRVYHUYSVHOWHWUJPUXFWIWJWUSYLXSVYLWUGVYMWUHVYNTVYLWUGWUBVXFXORZ
      UYISRVYMVYLWUBUYIVXFWUKWUMWURWUSYMVYLWWOVXIUYISVYLVXFVXEQRZVXFXORVXFVXFXO
      RZVXGQRWWOVXIVYLVXFVXEVXFWURWUOWURWUSUVAVYLWWPWUBVXFXOVYLUXHUXFUXEWUIWUJW
      ULUVFXCVYLWWQPVXGQVYLVXFWURWUSUVBXCYNZXCYFVYLVXEVUGVXFWUOWUPWURWUSYMWRYNX
      CVYLUXFVYSUYLSVYLWVSWWFTRZVXFXORZWVSVXFXORZWWFVXFXORZTRUXFVYSVYLWVSWWFVXF
      VYLWUBUXEWUKWULWLZVYLVXEUXHWUOWUIWLZWURWUSYCVYLWWTUXFUKWVBWWSUKVYLWVQWVFW
      WSWVBWWNVYLWVSWVLWWFWVNTWWDWWJWRWVHYOVYLWWSVXFUXFVYLWVSWWFWXCWXDWOWURWUJW
      USYLXSVYLWXAVYQWXBVYRTVYLWXAWWOUXESRVYQVYLWUBUXEVXFWUKWULWURWUSYMVYLWWOVX
      IUXESWWRXCYFVYLVXEUXHVXFWUOWUIWURWUSYMWRYNXCWRVYLVXIUYKSRZVXGVUHSRZTRZVXI
      UYMSRZVXGVUISRZTRZTRWXEWXHTRZWXFWXITRZTRWUAVXLVYLWXEWXFWXHWXIVYLVXIUYKVYL
      VWRVXGVHOVXIVHOWHVYLVXEVXFWUOWURWUSUVCZPVXGWIWJZVYLUYIUYJWUMVYJVYKVVRVVSU
      VDZWLZWLVYLVXGVUHWXMVYLVUGUYJWUPWXOWLZWLVYLVXIUYMWXNVYLUXEUYLWULVYJVYKVVR
      VVSUVGZWLZWLVYLVXGVUIWXMVYLUXHUYLWUIWXRWLZWLUVEVYLVYPWXGVYTWXJTVYLVYPVYMU
      YJSRZVYNUYJSRZTRWXGVYLVYMVYNUYJVYLVXIUYIWXNWUMWLVYLVXGVUGWXMWUPWLWXOYPVYL
      WYAWXEWYBWXFTVYLVXIUYIUYJWXNWUMWXOYRVYLVXGVUGUYJWXMWUPWXOYRWRYFVYLVYTVYQU
      YLSRZVYRUYLSRZTRWXJVYLVYQVYRUYLVYLVXIUXEWXNWULWLVYLVXGUXHWXMWUIWLWXRYPVYL
      WYCWXHWYDWXITVYLVXIUXEUYLWXNWULWXRYRVYLVXGUXHUYLWXMWUIWXRYRWRYFWRVYLVXJWX
      KVXKWXLTVYLVXIUYKUYMWXNWXPWXSYSVYLVXGVUHVUIWXMWXQWXTYSWRYOUVHUVIXJVVEVXNB
      VXGUYEUXOVXGUKZVVDVXMHUYCWYEVVCVXLVUBWYEVVAVXJVVBVXKTWYEUXPVXIUYNSUXOVXGP
      QXBXCUXOVXGVUJSXDWRXLXMXNYJVAUVJVUPUYOVUCVUKUDZHUYCUNZVVFUYFUYOVUCVUKHUYC
      UVOWYGUYFVVFWYGUYDVVEBUYEWYGUYBVVDXGZHUYCUNUYDVVEXGWYFWYHHUYCWYFUXNVUBUYA
      VVCUYOVUCVUKUVKUYOVUKUYAVVCUKVUCUYOVUKUXRVVAUXTVVBTUXQUYNUXPSXBUXSVUJUXOS
      XBUVLXAUVMUVNUYBVVDHUYCUVPVQUVQUVRUVSVQUWEUVTUWAUWBUWCUXDUXKUYFXGZUXJUWSU
      WNEUWOOZDUWOOZFUWOOZUDZWYIUXCUWNUWPUWQUWRUWDUXAUWTUXBWYMUXAWYJUWTWYKUXBWY
      LCUWOECGKLULZUIUJUHWYNKGUIUJUHUWFZLUWOUWGUWOMWYOLUWOUWHUWIZYTCUWODWYPYTCU
      WOFWYPYTUWJUWKWYMWYIUWNBEDFHJUWLXPUWMVDXSVA $.
  $}

  ${
    $d A m n p x $.  $d B m n p x y $.  $d t D x $.  $d i F $.  $d m F $.
    $d t F $.  $d i p t x $.  $d m n x y $.  $d i N $.  $d m N n p $.
    $d t N $.  $d x n N y $.  $d t p x $.  $d y p $.  $d x t $.  $d U i $.
    $d U m n p $.  $d t U x $.  $d y U x $.  $d i Z $.  $d m Z n p $.
    $d t Z x $.  $d y Z $.  $d F p m $.  $d n p $.  $d A a b $.  $d B a b $.
    $d F a b $.  $d D a b $.  $d i a b $.  $d x a b $.  $d y a b $.
    $d m a b $.  $d n a b $.  $d t a b $.  $d N a b $.  $d U a b $.
    $d Z a b $.
    axcontlem9.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    axcontlem9.2 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  Given the separation assumption, all values of
       ` F ` over ` A ` are less than or equal to all values of ` F ` over
       ` B ` .  (Contributed by Scott Fenton, 20-Jun-2013.) $)
    axcontlem9 $p |- ( ( ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
                      A. x e. A A. y e. B x Btwn <. Z , y >. ) ) /\
        ( ( Z e. ( EE ` N ) /\ U e. A /\ B =/= (/) )
          /\ Z =/= U ) ) -> A. n e. ( F " A ) A. m e. ( F " B ) n <_ m ) $=
      ( va vb wcel wa cn cee cfv wss cv cop cbtwn wbr wral w3a c0 wne cima wceq
      cle wrex cc0 cpnf cico co wf1o wfun simpll simprl1 simplr1 simprl2 sseldd
      wi simprr axcontlem2 syl31anc f1ofun fvelima ex 3syl reeanv simplr3 breq1
      opeq2 breq2d rspc2v mpan9 wb simplll adantr 3jca simplrr axcontlem4 sseld
      simpl axcontlem3 syl13anc anim12d imp axcontlem7 syl21anc mpbid syl5ibcom
      breq12 rexlimdvva syl5bir syl2and ralrimivv ) LUASZDLUBUCZUDZEXEUDZAUEZMB
      UEZUFZUGUHZBEUIADUIZUJZTZMXESZGDSZEUKULZUJZMGULZTZTZJUEZIUEZUOUHZJIKDUMZK
      EUMZYAYBYESZQUEZKUCZYBUNZQDUPZYCYFSZRUEZKUCZYCUNZREUPZYDYAFUQURUSUTZKVAZK
      VBZYGYKVHYAXDXOGXESZXSYRXDXMXTVCXOXPXQXSXNVDZYADXEGXFXGXLXDXTVEXOXPXQXSXN
      VFZVGZXNXRXSVIZACFGHKLMNOPVJVKZFYQKVLZYSYGYKQYBDKVMVNVOYAYRYSYLYPVHUUEUUF
      YSYLYPRYCEKVMVNVOYKYPTYJYOTZREUPQDUPYAYDYJYOQRDEVPYAUUGYDQRDEYAYHDSZYMESZ
      TZTZYIYNUOUHZUUGYDUUKYHMYMUFZUGUHZUULYAXLUUJUUNXFXGXLXDXTVQXKUUNYHXJUGUHA
      BYHYMDEXHYHXJUGVRXIYMUNXJUUMYHUGXIYMMVSVTWAWBUUKXDXOYTUJXSYHFSZYMFSZTZUUN
      UULWCUUKXDXOYTXDXMXTUUJWDYAXOUUJUUAWEYAYTUUJUUCWEWFXNXRXSUUJWGYAUUJUUQYAU
      UHUUOUUIUUPYADFYHABDEFGLMNOWHWIYAEFYMYAXNXOXPXSEFUDXNXTWJUUAUUBUUDABDEFGL
      MNOWKWLWIWMWNACFYHYMGHKLMNOPWOWPWQYIYBYNYCUOWSWRWTXAXBXC $.
  $}

  ${
    $d A b p x $.  $d B b p x y $.  $d D p t x $.  $d F b $.  $d i F p t x $.
    $d y F $.  $d i p t x $.  $d N b $.  $d i N p t x $.  $d y N $.
    $d t p x $.  $d y p $.  $d x t $.  $d U b $.  $d U i p t x $.  $d y U x $.
    $d Z b $.  $d i Z p t x $.  $d y Z $.  $d p b $.  $d A k m n q r $.
    $d b k m n q r $.  $d B k m n q r $.  $d F k m n q r $.  $d i k m n q r $.
    $d p k m n q r $.  $d N k m n q r $.  $d p k m n q r $.  $d t k m n q r $.
    $d U k m n q r $.  $d x k m n q r $.  $d y k m n q r $.  $d Z k m n q r $.
    axcontlem10.1 $e |- D = { p e. ( EE ` N ) |
       ( U Btwn <. Z , p >. \/ p Btwn <. Z , U >. ) } $.
    axcontlem10.2 $e |- F = { <. x , t >. |
        ( x e. D /\ ( t e. ( 0 [,) +oo ) /\
           A. i e. ( 1 ... N )
            ( x ` i ) = ( ( ( 1 - t ) x. ( Z ` i ) ) +
                          ( t x. ( U ` i ) ) ) ) ) } $.
    $( Lemma for ~ axcont .  Given a handful of assumptions, derive the
       conclusion of the final theorem.  (Contributed by Scott Fenton,
       20-Jun-2013.) $)
    axcontlem10 $p |-
      ( ( ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
                      A. x e. A A. y e. B x Btwn <. Z , y >. ) ) /\
       ( ( Z e. ( EE ` N ) /\ U e. A /\ B =/= (/) ) /\
         Z =/= U ) ) ->
         E. b e. ( EE ` N ) A. x e. A A. y e. B b Btwn <. x , y >. ) $=
      ( wcel wbr wral wa cle vm vk vn vq vr cn cee cfv wss cv cop cbtwn w3a wne
      c0 cima cr wrex cc0 cpnf cico co crn imassrn wf1o wfo wceq simpll simprl1
      simplr1 simprl2 sseldd simprr axcontlem2 syl31anc f1ofo forn 3syl elrege0
      syl5sseq simplbi ssriv syl6ss axcontlem9 dedekindle syl3anc simpr simprl3
      wi wex ad2antrr n0 sylib 0re a1i wf syl axcontlem4 ffvelrnd sseldi simprl
      f1of simprbi wb f1of1 f1elima mpbird adantr simpl1 simpl2 3jca axcontlem3
      wf1 sylan2 sselda adantrl jca breq1 anbi1d breq2 anbi2d sylan an32s letrd
      rspc2va simpld expr exlimdv sylanbrc ex ccnv wo syl2an sseqtr4d funfvima2
      mpd syl2anc sylc breq2d weq crab ssrab2 eqsstri f1ocnvdm adantrr wfun cdm
      simplr f1ofun fdm anim12d imp simprll rspc2v f1ocnvfv2 anbi12d axcontlem8
      breq1d anassrs ralrimivva opeq1 opeq2 cbvral2v 2ralbidv rspcev syld com23
      rexlimdv ) JUFPZDJUGUHZUIZEUVJUIZAUJZKBUJZUKULQBERADRZUMZSZKUVJPZGDPZEUOU
      NZUMZKGUNZSZSZUAUJZUBUJZTQZUWFUCUJZTQZSZUCIEUPZRUAIDUPZRZUBUQURZMUJZUVMUV
      NUKZULQZBERADRZMUVJURZUWDUWLUQUIUWKUQUIUWEUWHTQUCUWKRUAUWLRUWNUWDUWLUSUTV
      AVBZUQUWDIVCZUWLUWTIDVDUWDFUWTIVEZFUWTIVFUXAUWTVGUWDUVIUVRGUVJPZUWBUXBUVI
      UVPUWCVHZUVRUVSUVTUWBUVQVIZUWDDUVJGUVKUVLUVOUVIUWCVJUVRUVSUVTUWBUVQVKZVLZ
      UVQUWAUWBVMZACFGHIJKLNOVNVOZFUWTIVPFUWTIVQVRZVTAUWTUQUVMUWTPUVMUQPUSUVMTQ
      UVMVSWAWBZWCUWDUWKUWTUQUWDUXAUWKUWTIEVDUXJVTUXKWCABCDEFGHUCUAIJKLNOWDUAUC
      UBUWLUWKWEWFUWDUWMUWSUBUQUWDUWMUWFUQPZUWSUWDUWMUXLUWSWIUWDUWMSZUXLUWFUWTP
      ZUWSUXMUXLUXNUXMUXLSZUXLUSUWFTQZUXNUXMUXLWGUXOUWOEPZMWJZUXPUXOUVTUXRUWDUV
      TUWMUXLUVRUVSUVTUWBUVQWHWKMEWLWMUXOUXQUXPMUXMUXLUXQUXPUXMUXLUXQSZSZUSGIUH
      ZUWFUSUQPUXTWNWOUWDUYAUQPZUWMUXSUWDUWTUQUYAUXKUWDFUWTGIUWDUXBFUWTIWPZUXIF
      UWTIXBZWQUWDDFGABDEFGJKLNWRZUXFVLZWSZWTWKUXMUXLUXQXAUWDUSUYATQZUWMUXSUWDU
      YAUWTPZUYHUYGUYIUYBUYHUYAVSXCWQWKUXTUYAUWFTQZUWFUWOIUHZTQZUWDUXSUWMUYJUYL
      SZUWDUXSSZUYAUWLPZUYKUWKPZSUWMUYMUYNUYOUYPUWDUYOUXSUWDUYOUVSUXFUWDFUWTIXM
      ZGFPDFUIUYOUVSXDUWDUXBUYQUXIFUWTIXEWQZUYFUYEFUWTIGDXFWFXGXHUWDUXQUYPUXLUW
      DUXQSZUYPUXQUWDUXQWGUYSUYQUWOFPEFUIZUYPUXQXDUWDUYQUXQUYRXHUWDEFUWOUWCUVQU
      VRUVSUWBUMUYTUWCUVRUVSUWBUVRUVSUVTUWBXIUVRUVSUVTUWBXJUWAUWBWGXKABDEFGJKLN
      XLXNZXOUWDUYTUXQVUAXHFUWTIUWOEXFWFXGXPXQUWJUYMUYJUWISUAUCUYAUYKUWLUWKUWEU
      YAVGUWGUYJUWIUWEUYAUWFTXRXSUWHUYKVGUWIUYLUYJUWHUYKUWFTXTYAYEYBYCYFYDYGYHY
      PUWFVSYIYJUWDUWMUXNUWSUWDUWMUXNSZSZUWFIYKUHZUVJPVUDUWPULQZBERADRZUWSVUCFU
      VJVUDFGKLUJZUKULQVUGKGUKULQYLZLUVJUUAUVJNVUHLUVJUUBUUCUWDUXBUXNVUDFPZVUBU
      XIUWMUXNWGFUWTUWFIUUDZYMWTVUCVUDUDUJZUEUJZUKZULQZUEERUDDRVUFVUCVUNUDUEDEU
      WDVUBVUKDPZVULEPZSZVUNUWDVUBVUQSZSZUVIUVRUXCUMZUWBSZVUKFPZVUIVULFPZUMZSVU
      KIUHZVUDIUHZTQZVVFVULIUHZTQZSZVUNVUSVVAVVDUWDVVAVURUWDVUTUWBUWDUVIUVRUXCU
      XDUXEUXGXKUXHXQXHVUSVVBVUIVVCUWDVUQVVBVUBUWDVUOVVBVUPUWDDFVUKUYEXOUUEXPUW
      DUXBUXNVUIVURUXIUWMUXNVUQUUHZVUJYMUWDVUQVVCVUBUWDVUPVVCVUOUWDEFVULVUAXOXP
      XPXKXQVUSVVJVVEUWFTQZUWFVVHTQZSZVUSVVEUWLPZVVHUWKPZSZUWMVVNUWDVUQVVQVUBUW
      DVUQVVQUWDVUOVVOVUPVVPUWDIUUFZDIUUGZUIVUOVVOWIUWDUXBVVRUXIFUWTIUUIWQZUWDD
      FVVSUYEUWDUXBUYCVVSFVGUXIUYDFUWTIUUJVRZYNDVUKIYOYQUWDVVREVVSUIVUPVVPWIVVT
      UWDEFVVSVUAVWAYNEVULIYOYQUUKUULXPUWDUWMUXNVUQUUMUWJVVNVVLUWISUAUCVVEVVHUW
      LUWKUWEVVEVGUWGVVLUWIUWEVVEUWFTXRXSUWHVVHVGUWIVVMVVLUWHVVHUWFTXTYAUUNYRVU
      SVVGVVLVVIVVMVUSVVFUWFVVETUWDUXBUXNVVFUWFVGVURUXIVVKFUWTUWFIUUOYMZYSVUSVV
      FUWFVVHTVWBUURUUPXGACFVUKVUDVULGHIJKLNOUUQYRUUSUUTVUNVUEVUDUVMVULUKZULQUD
      UEABDEUDAYTVUMVWCVUDULVUKUVMVULUVAYSUEBYTVWCUWPVUDULVULUVNUVMUVBYSUVCWMUW
      RVUFMVUDUVJUWOVUDVGUWQVUEABDEUWOVUDUWPULXRUVDUVEYQYGUVFYJUVGUVHYP $.
  $}

  ${
    $d A b x i j p q r t z $.  $d B b x y i j p q r t z $.
    $d N b x y i j p q r t z $.  $d U b x y i j p q r t z $.
    $d Z b x y i j p q r t z $.

    $( Lemma for ~ axcont .  Eliminate the hypotheses from ~ axcontlem10 .
       (Contributed by Scott Fenton, 20-Jun-2013.) $)
    axcontlem11 $p |-
      ( ( ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
                      A. x e. A A. y e. B x Btwn <. Z , y >. ) ) /\
       ( ( Z e. ( EE ` N ) /\ U e. A /\ B =/= (/) ) /\
         Z =/= U ) ) ->
         E. b e. ( EE ` N ) A. x e. A A. y e. B b Btwn <. x , y >. ) $=
      ( vt vq vz vr vj vp cv cop cbtwn wbr cfv co vi wo cee crab wcel cpnf cico
      cc0 c1 cmin cmul caddc wceq cfz wral wa copab opeq2 breq1 orbi12d cbvrabv
      breq2d eqid axcontlem1 axcontlem10 ) ABICDEGJOZPZQRZVFGEPZQRZUBZJFUCSZUDZ
      EUAKOZVMUELOZUHUFUGTUEMOZVNSUIVOUJTVPGSUKTVOVPESUKTULTUMMUIFUNTUOUPUPKLUQ
      ZFGNHVKEGNOZPZQRZVRVIQRZUBJNVLVFVRUMZVHVTVJWAWBVGVSEQVFVRGURVBVFVRVIQUSUT
      VAKALVMEMUAVQFGIVQVCVDVE $.
  $}

  ${
    $d A b x u $.  $d B b x y u $.  $d N b x y u $.  $d U b x y u $.
    $d Z b x y u $.

    $( Lemma for ~ axcont .  Eliminate the trivial cases from the previous
       lemmas.  (Contributed by Scott Fenton, 20-Jun-2013.) $)
    axcontlem12 $p |-
      ( ( ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
                      A. x e. A A. y e. B x Btwn <. Z , y >. ) ) /\
       Z e. ( EE ` N ) ) ->
         E. b e. ( EE ` N ) A. x e. A A. y e. B b Btwn <. x , y >. ) $=
      ( vu cv wne wrex wcel wss cbtwn wbr wral wa wi c0 wceq cn cee cfv cop w3a
      rzal ralrimivw 2ralbidv rspcev expcom syl adantld simprrl simprrr simprll
      breq1 simpl 3jca simprlr axcontlem11 syl12anc pm2.61ine rexlimiva con2bii
      ex wn df-ne ralbii ralnex bitri simpr3 eqeq2 rspccva opeq1 breq2d ralbidv
      wb bitr4d ralbidva biimpa sylan2 ancoms expl sylbir pm2.61i ) FHIZJZHCKZE
      UALZCEUBUCZMZDWJMZAIZFBIZUDZNOZBDPZACPZUEQZFWJLZQZGIZWMWNUDZNOZBDPACPZGWJ
      KZRZWGXGHCWFCLZWGQZXAXFXIXAQZXFRDSDSTZXAXFXIXKWTXFWSXKFXCNOZBDPZACPZWTXFR
      XKXMACXLBDUFUGWTXNXFXEXNGFWJXBFTXDXLABCDXBFXCNUPUHUIZUJUKULULDSJZXJXFXPXJ
      QZWSWTXHXPUEWGXFXPXIWSWTUMXQWTXHXPXPXIWSWTUNXPXHWGXAUOXPXJUQURXPXHWGXAUSA
      BCDWFEFGUTVAVEVBVEVCWHVFZFWFTZHCPZXGXTWGVFZHCPXRXSYAHCWGXSFWFVGVDVHWGHCVI
      VJXTWSWTXFWTXTWSQZXFYBWTXNXFWSXTWRXNWIWKWLWRVKXTWRXNXTWQXMACXTWMCLQFWMTZW
      QXMVQXSYCHWMCWFWMFVLVMYCWPXLBDYCWPWMXCNOXLYCWOXCWMNFWMWNVNVOFWMXCNUPVRVPU
      KVSVTWAXOWAWBWCWDWE $.
  $}

  ${
    $d A a b x y $.  $d B a b x y $.  $d N a b x y $.
    $( The axiom of continuity.  Take two sets of points ` A ` and ` B ` .  If
       all the points in ` A ` come before the points of ` B ` on a line, then
       there is a point separating the two.  Axiom A11 of [Schwabhauser]
       p. 13.  (Contributed by Scott Fenton, 20-Jun-2013.) $)
    axcont $p |-
      ( ( N e. NN /\ ( A C_ ( EE ` N ) /\ B C_ ( EE ` N ) /\
          E. a e. ( EE ` N ) A. x e. A A. y e. B x Btwn <. a , y >. ) )
        ->
        E. b e. ( EE ` N ) A. x e. A A. y e. B b Btwn <. x , y >. ) $=
      ( cn wcel cee wss cv cop cbtwn wbr wral wrex wi wa w3a cfv 3anim3i anim2i
      simpr simpr3l axcontlem12 syl2anc 3exp2 com4r rexlimiva com4l 3imp2 ) EHI
      ZCEJUAZKZDUNKZALZFLZBLZMNOBDPACPZFUNQZGLUQUSMNOBDPACPGUNQZVAUMUOUPVBUTUMU
      OUPVBRRRFUNUMUOUPURUNIZUTSZVBUMUOUPVDVBUMUOUPVDTZSUMUOUPUTTZSVCVBVEVFUMVD
      UTUOUPVCUTUDUBUCVCUTUOUPUMUEABCDEURGUFUGUHUIUJUKUL $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Congruence properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c OuterFiveSeg $.

  $( Declare the syntax for the outer five segment configuration. $)
  cofs $a class OuterFiveSeg $.

  ${
    $d a b c d x y z w p q n $.
    $( The outer five segment configuration is an abbreviation for the
       conditions of the Five Segment Axiom ( ~ ax5seg ).  See ~ brofs and
       ~ 5segofs for how it is used.  Definition 2.10 of [Schwabhauser] p. 28.
       (Contributed by Scott Fenton, 21-Sep-2013.) $)
    df-ofs $a |- OuterFiveSeg =
        { <. p , q >. |
           E. n e. NN E. a e. ( EE ` n ) E. b e. ( EE ` n ) E. c e. ( EE ` n )
           E. d e. ( EE ` n ) E. x e. ( EE ` n ) E. y e. ( EE ` n )
           E. z e. ( EE ` n ) E. w e. ( EE ` n ) (
           p = <. <. a , b >. , <. c , d >. >. /\
           q = <. <. x , y >. , <. z , w >. >. /\
           ( ( b Btwn <. a , c >. /\ y Btwn <. x , z >. ) /\
             ( <. a , b >. Cgr <. x , y >. /\
               <. b , c >. Cgr <. y , z >. ) /\
             ( <. a , d >. Cgr <. x , w >. /\
               <. b , d >. Cgr <. y , w >. ) ) ) } $.
  $}

  ${
    cgrrflx2d.1 $e |- ( ph -> N e. NN ) $.
    cgrrflx2d.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrrflx2d.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    $( Deduction form of ~ axcgrrflx .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrrflx2d $p |- ( ph -> <. A , B >. Cgr <. B , A >. ) $=
      ( cn wcel cee cfv cop ccgr wbr axcgrrflx syl3anc ) ADHIBDJKZICQIBCLCBLMNE
      FGBCDOP $.
  $}

  ${
    cgrtr4d.1 $e |- ( ph -> N e. NN ) $.
    cgrtr4d.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrtr4d.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrtr4d.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrtr4d.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrtr4d.6 $e |- ( ph -> E e. ( EE ` N ) ) $.
    cgrtr4d.7 $e |- ( ph -> F e. ( EE ` N ) ) $.
    cgrtr4d.8 $e |- ( ph -> <. A , B >. Cgr <. C , D >. ) $.
    cgrtr4d.9 $e |- ( ph -> <. A , B >. Cgr <. E , F >. ) $.
    $( Deduction form of ~ axcgrtr .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrtr4d $p |- ( ph -> <. C , D >. Cgr <. E , F >. ) $=
      ( cop ccgr wcel wbr cn cee cfv wa wi axcgrtr syl133anc mp2and ) ABCRZDERZ
      SUAZUJFGRZSUAZUKUMSUAZPQAHUBTBHUCUDZTCUPTDUPTEUPTFUPTGUPTULUNUEUOUFIJKLMN
      OBCDEFGHUGUHUI $.
  $}

  ${
    cgrtr4and.1 $e |- ( ph -> N e. NN ) $.
    cgrtr4and.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrtr4and.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrtr4and.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrtr4and.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrtr4and.6 $e |- ( ph -> E e. ( EE ` N ) ) $.
    cgrtr4and.7 $e |- ( ph -> F e. ( EE ` N ) ) $.
    cgrtr4and.8 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. C , D >. ) $.
    cgrtr4and.9 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. E , F >. ) $.
    $( Deduction form of ~ axcgrtr .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrtr4and $p |- ( ( ph /\ ps ) -> <. C , D >. Cgr <. E , F >. ) $=
      ( wcel adantr wa cn cee cfv cgrtr4d ) ABUACDEFGHIAIUBSBJTACIUCUDZSBKTADUF
      SBLTAEUFSBMTAFUFSBNTAGUFSBOTAHUFSBPTQRUE $.
  $}

  $( Reflexivity law for congruence.  Theorem 2.1 of [Schwabhauser] p. 27.
     (Contributed by Scott Fenton, 12-Jun-2013.) $)
  cgrrflx $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
    <. A , B >. Cgr <. A , B >. ) $=
    ( wcel cee cfv w3a simp1 simp3 simp2 cop ccgr wbr axcgrrflx 3com23 cgrtr4d
    cn ) CQDZACEFZDZBSDZGBAABABCRTUAHRTUAIZRTUAJZUCUBUCUBRUATBAKABKLMBACNOZUDP
    $.

  ${
    cgrrflxd.1 $e |- ( ph -> N e. NN ) $.
    cgrrflxd.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrrflxd.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    $( Deduction form of ~ cgrrflx .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrrflxd $p |- ( ph -> <. A , B >. Cgr <. A , B >. ) $=
      ( cn wcel cee cfv cop ccgr wbr cgrrflx syl3anc ) ADHIBDJKZICQIBCLZRMNEFGB
      CDOP $.
  $}

  $( Congruence commutes on the two sides.  Implication version.  Theorem 2.2
     of [Schwabhauser] p. 27.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
  cgrcomim $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( <. A , B >. Cgr <. C , D >. ->
      <. C , D >. Cgr <. A , B >. ) ) $=
    ( cn wcel cee cfv w3a cop ccgr wbr simp1 simp2l simp2r simp3l simp3r simpr
    wa simpl1 simpl2l simpl2r cgrrflxd cgrtr4and ex ) EFGZAEHIZGZBUHGZTZCUHGZDU
    HGZTZJZABKZCDKZLMZUQUPLMUOURABCDABEUGUKUNNUGUIUJUNOZUGUIUJUNPZUGUKULUMQUGUK
    ULUMRUSUTUOURSUOURTABEUGUKUNURUAUIUJUGUNURUBUIUJUGUNURUCUDUEUF $.

  $( Congruence commutes between the two sides.  (Contributed by Scott Fenton,
     12-Jun-2013.) $)
  cgrcom $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( <. A , B >. Cgr <. C , D >. <->
      <. C , D >. Cgr <. A , B >. ) ) $=
    ( cn wcel cee cfv wa w3a cop ccgr wbr cgrcomim wi 3com23 impbid ) EFGZAEHIZ
    GBTGJZCTGDTGJZKABLZCDLZMNZUDUCMNZABCDEOSUBUAUFUEPCDABEOQR $.

  ${
    cgrcomand.1 $e |- ( ph -> N e. NN ) $.
    cgrcomand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrcomand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrcomand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrcomand.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrcomand.6 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. C , D >. ) $.
    $( Deduction form of ~ cgrcom .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrcomand $p |- ( ( ph /\ ps ) -> <. C , D >. Cgr <. A , B >. ) $=
      ( wa cop ccgr wbr wb cn wcel cee cfv cgrcom syl122anc adantr mpbid ) ABNC
      DOZEFOZPQZUHUGPQZMAUIUJRZBAGSTCGUAUBZTDULTEULTFULTUKHIJKLCDEFGUCUDUEUF $.
  $}

  $( Transitivity law for congruence.  Theorem 2.3 of [Schwabhauser] p. 27.
     (Contributed by Scott Fenton, 24-Sep-2013.) $)
  cgrtr $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( ( <. A , B >. Cgr <. C , D >. /\
           <. C , D >. Cgr <. E , F >. ) ->
         <. A , B >. Cgr <. E , F >. ) ) $=
    ( cn wcel cee cfv w3a cop ccgr wbr wa simp1 simp23 simp31 simp21 cgrcomand
    simp22 simp32 simp33 simprl simprr cgrtr4and ex ) GHIZAGJKZIZBUJIZCUJIZLZDU
    JIZEUJIZFUJIZLZLZABMZCDMZNOZVAEFMZNOZPZUTVCNOUSVECDABEFGUIUNURQZUIUKULUMURR
    ZUIUNUOUPUQSZUIUKULUMURTZUIUKULUMURUBZUIUNUOUPUQUCUIUNUOUPUQUDUSVEABCDGVFVI
    VJVGVHUSVBVDUEUAUSVBVDUFUGUH $.

  ${
    cgrtrand.1 $e |- ( ph -> N e. NN ) $.
    cgrtrand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrtrand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrtrand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrtrand.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrtrand.6 $e |- ( ph -> E e. ( EE ` N ) ) $.
    cgrtrand.7 $e |- ( ph -> F e. ( EE ` N ) ) $.
    cgrtrand.8 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. C , D >. ) $.
    cgrtrand.9 $e |- ( ( ph /\ ps ) -> <. C , D >. Cgr <. E , F >. ) $.
    $( Deduction form of ~ cgrtr .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrtrand $p |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. E , F >. ) $=
      ( cop wcel wa ccgr wbr wi cn cee cfv cgrtr syl133anc adantr mp2and ) ABUA
      CDSZEFSZUBUCZUMGHSZUBUCZULUOUBUCZQRAUNUPUAUQUDZBAIUETCIUFUGZTDUSTEUSTFUST
      GUSTHUSTURJKLMNOPCDEFGHIUHUIUJUK $.
  $}

  $( Transitivity law for congruence.  (Contributed by Scott Fenton,
     7-Oct-2013.) $)
  cgrtr3 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( ( <. A , B >. Cgr <. E , F >. /\
           <. C , D >. Cgr <. E , F >. ) ->
         <. A , B >. Cgr <. C , D >. ) ) $=
    ( cn wcel cee cfv w3a cop ccgr wbr wa simp1 simp21 simp22 simp32 cgrcomand
    simp33 simp23 simp31 simprl simprr cgrtrand ex ) GHIZAGJKZIZBUJIZCUJIZLZDUJ
    IZEUJIZFUJIZLZLZABMZEFMZNOZCDMZVANOZPZUTVCNOUSVEABEFCDGUIUNURQZUIUKULUMURRU
    IUKULUMURSUIUNUOUPUQTZUIUNUOUPUQUBZUIUKULUMURUCZUIUNUOUPUQUDZUSVBVDUEUSVECD
    EFGVFVIVJVGVHUSVBVDUFUAUGUH $.

  ${
    cgrtr3and.1 $e |- ( ph -> N e. NN ) $.
    cgrtr3and.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrtr3and.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrtr3and.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrtr3and.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrtr3and.6 $e |- ( ph -> E e. ( EE ` N ) ) $.
    cgrtr3and.7 $e |- ( ph -> F e. ( EE ` N ) ) $.
    cgrtr3and.8 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. E , F >. ) $.
    cgrtr3and.9 $e |- ( ( ph /\ ps ) -> <. C , D >. Cgr <. E , F >. ) $.
    $( Deduction form of ~ cgrtr3 .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    cgrtr3and $p |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. C , D >. ) $=
      ( cop wcel wa ccgr wbr wi cn cee cfv cgrtr3 syl133anc adantr mp2and ) ABU
      ACDSZGHSZUBUCZEFSZUMUBUCZULUOUBUCZQRAUNUPUAUQUDZBAIUETCIUFUGZTDUSTEUSTFUS
      TGUSTHUSTURJKLMNOPCDEFGHIUHUIUJUK $.
  $}

  $( Congruence commutes on the left.  Biconditional version of Theorem 2.4 of
     [Schwabhauser] p. 27.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
  cgrcoml $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( <. A , B >. Cgr <. C , D >. <->
      <. B , A >. Cgr <. C , D >. ) ) $=
    ( cn wcel cee cfv wa w3a cop wbr simp1 cgrrflx2d wi axcgrtr syl133anc mpand
    ccgr simp2l simp2r simp3l simp3r impbid ) EFGZAEHIZGZBUGGZJZCUGGZDUGGZJZKZA
    BLZCDLZTMZBALZUPTMZUNUOURTMZUQUSUNABEUFUJUMNZUFUHUIUMUAZUFUHUIUMUBZOUNUFUHU
    IUIUHUKULUTUQJUSPVAVBVCVCVBUFUJUKULUCZUFUJUKULUDZABBACDEQRSUNURUOTMZUSUQUNB
    AEVAVCVBOUNUFUIUHUHUIUKULVFUSJUQPVAVCVBVBVCVDVEBAABCDEQRSUE $.

  $( Congruence commutes on the right.  Biconditional version of Theorem 2.5 of
     [Schwabhauser] p. 27.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
  cgrcomr $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( <. A , B >. Cgr <. C , D >. <->
      <. A , B >. Cgr <. D , C >. ) ) $=
    ( cn wcel cee cfv wa w3a cop ccgr wbr wb cgrcoml 3com23 cgrcom simp1 simp2l
    simp2r simp3r simp3l syl122anc 3bitr4d ) EFGZAEHIZGZBUGGZJZCUGGZDUGGZJZKZCD
    LZABLZMNZDCLZUPMNZUPUOMNUPURMNZUFUMUJUQUSOCDABEPQABCDERUNUFUHUIULUKUTUSOUFU
    JUMSUFUHUIUMTUFUHUIUMUAUFUJUKULUBUFUJUKULUCABDCERUDUE $.

  $( Congruence commutes on both sides.  (Contributed by Scott Fenton,
     12-Jun-2013.) $)
  cgrcomlr $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( <. A , B >. Cgr <. C , D >. <->
      <. B , A >. Cgr <. D , C >. ) ) $=
    ( cn wcel cee cfv wa w3a cop ccgr wbr cgrcoml ancom cgrcomr syl3an2b bitrd
    wb ) EFGZAEHIZGZBUBGZJZCUBGDUBGJZKABLCDLZMNBALZUGMNZUHDCLMNZABCDEOUEUAUDUCJ
    UFUIUJTUCUDPBACDEQRS $.

  ${
    cgrcomlrand.1 $e |- ( ph -> N e. NN ) $.
    cgrcomlrand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrcomlrand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrcomlrand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrcomlrand.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrcomlrand.6 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. C , D >. ) $.
    $( Deduction form of ~ cgrcoml .  (Contributed by Scott Fenton,
       14-Oct-2013.) $)
    cgrcomland $p |- ( ( ph /\ ps ) -> <. B , A >. Cgr <. C , D >. ) $=
      ( wa cop ccgr wbr wb cn wcel cee cfv cgrcoml syl122anc adantr mpbid ) ABN
      CDOEFOZPQZDCOUGPQZMAUHUIRZBAGSTCGUAUBZTDUKTEUKTFUKTUJHIJKLCDEFGUCUDUEUF
      $.

    $( Deduction form of ~ cgrcoml .  (Contributed by Scott Fenton,
       14-Oct-2013.) $)
    cgrcomrand $p |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. D , C >. ) $=
      ( wa cop ccgr wbr wb cn wcel cee cfv cgrcomr syl122anc adantr mpbid ) ABN
      CDOZEFOPQZUGFEOPQZMAUHUIRZBAGSTCGUAUBZTDUKTEUKTFUKTUJHIJKLCDEFGUCUDUEUF
      $.

    $( Deduction form of ~ cgrcomlr .  (Contributed by Scott Fenton,
       14-Oct-2013.) $)
    cgrcomlrand $p |- ( ( ph /\ ps ) -> <. B , A >. Cgr <. D , C >. ) $=
      ( cgrcomrand cgrcomland ) ABCDFEGHIJLKABCDEFGHIJKLMNO $.

  $}

  ${
    $d A x $.  $d B x $.  $d N x $.
    $( Degenerate segments are congruent.  Theorem 2.8 of [Schwabhauser]
       p. 28.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    cgrtriv $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
    <. A , A >. Cgr <. B , B >. ) $=
      ( vx cn wcel cee cfv w3a cv cop cbtwn wbr ccgr simp1 simp2 simp3 axsegcon
      wa wrex syl122anc wceq simpl1 simpl2 simpr simpl3 axcgrid syl13anc breq1d
      wi opeq2 biimprd syli adantld rexlimdva mpd ) CEFZACGHZFZBURFZIZAADJZKZLM
      ZVCBBKZNMZSZDURTZAAKZVENMZVAUQUSUSUTUTVHUQUSUTOUQUSUTPZVKUQUSUTQZVLDAABBC
      RUAVAVGVJDURVAVBURFZSZVFVJVDVFVNAVBUBZVJVNUQUSVMUTVFVOUJUQUSUTVMUCUQUSUTV
      MUDVAVMUEUQUSUTVMUFAVBBCUGUHVOVJVFVOVIVCVENAVBAUKUIULUMUNUOUP $.
  $}

  $( Identity law for congruence.  (Contributed by Scott Fenton,
     12-Jun-2013.) $)
  cgrid2 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( <. A , A >. Cgr <. B , C >. -> B = C ) ) $=
    ( cn wcel cee cfv w3a wa cop ccgr wceq wb simpl simpr1 simpr2 simpr3 cgrcom
    wbr syl122anc wi 3anrot axcgrid sylan2b sylbid ) DEFZADGHZFZBUHFZCUHFZIZJZA
    AKZBCKZLTZUOUNLTZBCMZUMUGUIUIUJUKUPUQNUGULOUGUIUJUKPZUSUGUIUJUKQUGUIUJUKRAA
    BCDSUAULUGUJUKUIIUQURUBUIUJUKUCBCADUDUEUF $.

  $( Two congruent segments are either both degenrate or both non-degenerate.
     (Contributed by Scott Fenton, 12-Jun-2013.) $)
  cgrdegen $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
      ( <. A , B >. Cgr <. C , D >. -> ( A = B <-> C = D ) ) ) $=
    ( cn wcel cee cfv wa cop ccgr wbr wceq opeq1 biimpac syl13anc syl5 expdimp
    wi wb breq1d simp1 simp2r simp3l simp3r cgrid2 breq2d simp2l axcgrid impbid
    w3a ex ) EFGZAEHIZGZBUOGZJZCUOGZDUOGZJZULZABKZCDKZLMZABNZCDNZUAVBVEJVFVGVBV
    EVFVGVEVFJBBKZVDLMZVBVGVFVEVIVFVCVHVDLABBOUBPVBUNUQUSUTVIVGTUNURVAUCZUNUPUQ
    VAUDZUNURUSUTUEUNURUSUTUFZBCDEUGQRSVBVEVGVFVEVGJVCDDKZLMZVBVFVGVEVNVGVDVMVC
    LCDDOUHPVBUNUPUQUTVNVFTVJUNUPUQVAUIVKVLABDEUJQRSUKUM $.

  ${
    $d N a b c d e f g h p q n $.  $d A a b c d e f g h p q n $.
    $d B a b c d e f g h p q n $.  $d C a b c d e f g h p q n $.
    $d D a b c d e f g h p q n $.  $d E a b c d e f g h p q n $.
    $d F a b c d e f g h p q n $.  $d G a b c d e f g h p q n $.
    $d H a b c d e f g h p q n $.
    $( Binary relationship form of the outer five segment predicate.
       (Contributed by Scott Fenton, 21-Sep-2013.) $)
    brofs $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. OuterFiveSeg
      <. <. E , F >. , <. G , H >. >. <-> ( ( B Btwn <. A , C >. /\
                     F Btwn <. E , G >. ) /\
        ( <. A , B >. Cgr <. E , F >. /\
          <. B , C >. Cgr <. F , G >. ) /\
        ( <. A , D >. Cgr <. E , H >. /\
          <. B , D >. Cgr <. F , H >. ) ) ) ) $=
      ( cv cop cbtwn wbr wa ccgr w3a wceq opeq1 breq2d opeq2 vb va vc vf ve cee
      vg vd vh vn vq vp cfv cofs anbi1d breq1d 3anbi123d breq1 anbi12d 3anbi12d
      cn anbi2d 3anbi3d fveq2 df-ofs br8 ) UAJZUBJZUCJZKZLMZUDJZUEJZUGJZKZLMZNZ
      VHVGKZVMVLKZOMZVGVIKZVLVNKZOMZNZVHUHJZKZVMUIJZKZOMZVGWEKZVLWGKZOMZNZPVGAV
      IKZLMZVPNZAVGKZVSOMZWCNZAWEKZWHOMZWLNZPBWNLMZVPNZABKZVSOMZBVIKZWBOMZNZXAB
      WEKZWKOMZNZPBACKZLMZVPNZXFBCKZWBOMZNZXLPXOXRADKZWHOMZBDKZWKOMZNZPXNVLEVNK
      ZLMZNZXEEVLKZOMZXQNZXSEWGKZOMZYBNZPXNFYDLMZNZXEEFKZOMZXPFVNKZOMZNZYKYAFWG
      KZOMZNZPXNFEGKZLMZNZYPXPFGKZOMZNZUUBPUUEUUHXSEHKZOMZYAFHKZOMZNZPUJABCDUJJ
      ZUFUMIUFUMUNVAUEUDUGUIEFGHIUKULUBUAUCUHVHAQZVQWPWDWSWMXBUUOVKWOVPUUOVJWNV
      GLVHAVIRSUOUUOVTWRWCUUOVRWQVSOVHAVGRUPUOUUOWIXAWLUUOWFWTWHOVHAWERUPUOUQVG
      BQZWPXDWSXIXBXLUUPWOXCVPVGBWNLURUOUUPWRXFWCXHUUPWQXEVSOVGBATUPUUPWAXGWBOV
      GBVIRUPUSUUPWLXKXAUUPWJXJWKOVGBWERUPVBUQVICQZXDXOXIXRXLUUQXCXNVPUUQWNXMBL
      VICATSUOUUQXHXQXFUUQXGXPWBOVICBTUPVBUTWEDQZXLYCXOXRUURXAXTXKYBUURWTXSWHOW
      EDATUPUURXJYAWKOWEDBTUPUSVCVMEQZXOYFXRYIYCYLUUSVPYEXNUUSVOYDVLLVMEVNRSVBU
      USXFYHXQUUSVSYGXEOVMEVLRSUOUUSXTYKYBUUSWHYJXSOVMEWGRSUOUQVLFQZYFYNYIYSYLU
      UBUUTYEYMXNVLFYDLURVBUUTYHYPXQYRUUTYGYOXEOVLFETSUUTWBYQXPOVLFVNRSUSUUTYBU
      UAYKUUTWKYTYAOVLFWGRSVBUQVNGQZYNUUEYSUUHUUBUVAYMUUDXNUVAYDUUCFLVNGETSVBUV
      AYRUUGYPUVAYQUUFXPOVNGFTSVBUTWGHQZUUBUUMUUEUUHUVBYKUUJUUAUULUVBYJUUIXSOWG
      HETSUVBYTUUKYAOWGHFTSUSVCUUNIUFVDUEUDUGUIUJUKULUBUAUCUHVEVF $.
  $}

  $( Rephrase ~ ax5seg using the outer five segment predicate.  Theorem 2.10 of
     [Schwabhauser] p. 28.  (Contributed by Scott Fenton, 21-Sep-2013.) $)
  5segofs $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( ( <. <. A , B >. , <. C , D >. >. OuterFiveSeg
        <. <. E , F >. , <. G , H >. >. /\ A =/= B ) ->
        <. C , D >. Cgr <. G , H >. ) ) $=
    ( cn wcel cee cfv w3a cop wbr wa cbtwn ccgr 3jca brofs anbi1d simpr simpl1l
    cofs wne simpl1r simpl2 simpl3 syl6bi ax5seg syld ) IJKAILMZKBUMKNCUMKDUMKE
    UMKNFUMKGUMKHUMKNNZABOZCDOZOEFOZGHOZOUEPZABUFZQZUTBACORPZFEGORPZNZUOUQSPBCO
    FGOSPQZADOEHOSPBDOFHOSPQZNZUPURSPUNVAVBVCQZVEVFNZUTQZVGUNUSVIUTABCDEFGHIUAU
    BVJVDVEVFVJUTVBVCVIUTUCVBVCVEVFUTUDVBVCVEVFUTUGTVHVEVFUTUHVHVEVFUTUITUJABCD
    EFGHIUKUL $.

  $( The outer five segment predicate commutes.  (Contributed by Scott Fenton,
     26-Sep-2013.) $)
  ofscom $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. OuterFiveSeg
      <. <. E , F >. , <. G , H >. >. <->
      <. <. E , F >. , <. G , H >. >. OuterFiveSeg
      <. <. A , B >. , <. C , D >. >. ) ) $=
    ( wcel w3a cop cbtwn wbr wa ccgr cofs wb cgrcom syl122anc cee cfv ancom a1i
    cn simp11 simp12 simp13 simp23 simp31 simp21 simp32 simp22 simp33 3anbi123d
    anbi12d brofs syl333anc 3bitr4d ) IUEJZAIUAUBZJZBVAJZKZCVAJZDVAJZEVAJZKZFVA
    JZGVAJZHVAJZKZKZBACLMNZFEGLMNZOZABLZEFLZPNZBCLZFGLZPNZOZADLZEHLZPNZBDLZFHLZ
    PNZOZKVOVNOZVRVQPNZWAVTPNZOZWEWDPNZWHWGPNZOZKZVQCDLLZVRGHLLZQNWTWSQNZVMVPWK
    WCWNWJWQVPWKRVMVNVOUCUDVMVSWLWBWMVMUTVBVCVGVIVSWLRUTVBVCVHVLUFZUTVBVCVHVLUG
    ZUTVBVCVHVLUHZVDVEVFVGVLUIZVDVHVIVJVKUJZABEFISTVMUTVCVEVIVJWBWMRXBXDVDVEVFV
    GVLUKZXFVDVHVIVJVKULZBCFGISTUPVMWFWOWIWPVMUTVBVFVGVKWFWORXBXCVDVEVFVGVLUMZX
    EVDVHVIVJVKUNZADEHISTVMUTVCVFVIVKWIWPRXBXDXIXFXJBDFHISTUPUOABCDEFGHIUQVMUTV
    GVIVJVKVBVCVEVFXAWRRXBXEXFXHXJXCXDXGXIEFGHABCDIUQURUS $.

  $( Link congruence over a pair of line segments.  Theorem 2.11 of
     [Schwabhauser] p. 29.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
  cgrextend $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
    ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
    ( ( ( B Btwn <. A , C >. /\ E Btwn <. D , F >. ) /\
        ( <. A , B >. Cgr <. D , E >. /\
          <. B , C >. Cgr <. E , F >. ) ) ->
      <. A , C >. Cgr <. D , F >. ) ) $=
    ( wcel w3a cop cbtwn wbr wa ccgr wi wceq wb opeq1 adantr 3jca cn cee breq1d
    cfv simp1 simp22 simp31 simp32 cgrid2 syl13anc adantl sylbid breqan12d syld
    exbiri imp3a adantld ex cofs simpl1 simpl21 simpl22 simpl23 simpl31 simpl32
    wne simpl33 simprrl simprrr cgrtriv syl3anc simpld cgrcomlr syl122anc mpbid
    jca brofs syl333anc mpbir3and simprl 5segofs sylc exp32 com12 pm2.61ine ) G
    UAHZAGUBUDZHZBWGHZCWGHZIZDWGHZEWGHZFWGHZIZIZBACJZKLEDFJZKLMZABJZDEJZNLZBCJZ
    EFJZNLZMZMZWQWRNLZOZOABABPZWPXIXJWPMZXFXHWSXKXBXEXHXKXBDEPZXEXHOZXKXBBBJZXA
    NLZXLXJXBXOQWPXJWTXNXANABBRUCSWPXOXLOZXJWPWFWIWLWMXPWFWKWOUEWFWHWIWJWOUFWFW
    KWLWMWNUGWFWKWLWMWNUHBDEGUIUJUKULXJXLXMOWPXJXLXHXEXJXLWQXCWRXDNABCRDEFRUMUO
    SUNUPUQURWPABVFZXIWPXQXGXHWPXQXGMZMZCAJZFDJZNLZXHXSWFWHWIIZWJWHWLIZWMWNWLIZ
    IWTXTJXAYAJUSLZXQMYBXSYCYDYEXSWFWHWIWFWKWOXRUTZWHWIWJWFWOXRVAZWHWIWJWFWOXRV
    BZTXSWJWHWLWHWIWJWFWOXRVCZYHWLWMWNWFWKXRVDZTXSWMWNWLWLWMWNWFWKXRVEZWLWMWNWF
    WKXRVGZYKTTXSYFXQXSYFWSXFAAJDDJNLZBAJEDJNLZMZWPXQWSXFVHWPXQWSXFVIZXSYNYOXSW
    FWHWLYNYGYHYKADGVJVKXSXBYOXSXBXEYQVLXSWFWHWIWLWMXBYOQYGYHYIYKYLABDEGVMVNVOV
    PXSWFWHWIWJWHWLWMWNWLYFWSXFYPIQYGYHYIYJYHYKYLYMYKABCADEFDGVQVRVSWPXQXGVTVPA
    BCADEFDGWAWBXSWFWJWHWNWLYBXHQYGYJYHYMYKCAFDGVMVNVOWCWDWE $.

  ${
    cgrextendand.1 $e |- ( ph -> N e. NN ) $.
    cgrextendand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    cgrextendand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    cgrextendand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    cgrextendand.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    cgrextendand.6 $e |- ( ph -> E e. ( EE ` N ) ) $.
    cgrextendand.7 $e |- ( ph -> F e. ( EE ` N ) ) $.
    cgrextendand.8 $e |- ( ( ph /\ ps ) -> B Btwn <. A , C >. ) $.
    cgrextendand.9 $e |- ( ( ph /\ ps ) -> E Btwn <. D , F >. ) $.
    cgrextendand.10 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. D , E >. ) $.
    cgrextendand.11 $e |- ( ( ph /\ ps ) -> <. B , C >. Cgr <. E , F >. ) $.
    $( Deduction form of ~ cgrextend .  (Contributed by Scott Fenton,
       14-Oct-2013.) $)
    cgrextendand $p |- ( ( ph /\ ps ) -> <. A , C >. Cgr <. D , F >. ) $=
      ( wa cop cbtwn wbr ccgr jca wi cn wcel cee cfv cgrextend syl133anc adantr
      mp2and ) ABUAZDCEUBZUCUDZGFHUBZUCUDZUAZCDUBFGUBUEUDZDEUBGHUBUEUDZUAZUQUSU
      EUDZUPURUTQRUFUPVBVCSTUFAVAVDUAVEUGZBAIUHUICIUJUKZUIDVGUIEVGUIFVGUIGVGUIH
      VGUIVFJKLMNOPCDEFGHIULUMUNUO $.
  $}

  $( Two points that satsify the conclusion of ~ axsegcon are identical.
     Uniqueness portion of Theorem 2.12 of [Schwabhauser] p. 29.  (Contributed
     by Scott Fenton, 12-Jun-2013.) $)
  segconeq $p |- ( ( N e. NN /\
   ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
   ( Q e. ( EE ` N ) /\ X e. ( EE ` N ) /\ Y e. ( EE ` N ) ) ) ->
   ( ( Q =/= A /\
     ( A Btwn <. Q , X >. /\ <. A , X >. Cgr <. B , C >. ) /\
     ( A Btwn <. Q , Y >. /\ <. A , Y >. Cgr <. B , C >. ) )
   -> X = Y ) ) $=
    ( wcel w3a cop cbtwn wbr ccgr wa jca cgrrflxd 3jca wb cgrcom wi cee cfv wne
    cn cofs wceq simpr2l simpl1 simpl31 simpl21 simpl32 simpl33 simpr3l simpl22
    simpl23 simpr3r syl122anc mpbid simpr2r cgrtr4d jca32 cgrextend sylc simp31
    simp1 simp21 simp32 simp33 brofs syl333anc sylibrd a1i jcad 5segofs axcgrid
    ex syl13anc 3syld ) EUDHZAEUAUBZHZBVTHZCVTHZIZDVTHZFVTHZGVTHZIZIZDAUCZADFJZ
    KLZAFJZBCJZMLZNZADGJZKLZAGJZWNMLZNZIZDAJZFGJZJXCFFJZJUELZWJNZXDXEMLZFGUFZWI
    XBXFWJWIXBWLWLNZXCXCMLZWMWMMLZNZWQWKMLZWSWMMLZNZIZXFWIXBXQWIXBNZXJXMXPXRWLW
    LWLWOWJXAWIUGZXSOXRXKXLXRDAEVSWDWHXBUHZWEWFWGVSWDXBUIZWAWBWCVSWHXBUJZPZXRAF
    EXTYBWEWFWGVSWDXBUKZPOXRXNXOXRVSWEWAWGIZWEWAWFIZIWRWLNZXKXONNXNXRVSYEYFXTXR
    WEWAWGYAYBWEWFWGVSWDXBULZQXRWEWAWFYAYBYDQQXRYGXKXOXRWRWLWRWTWJWPWIUMXSOYCXR
    BCAGAFEXTWAWBWCVSWHXBUNZWAWBWCVSWHXBUOZYBYHYBYDXRWTWNWSMLZWRWTWJWPWIUPXRVSW
    AWGWBWCWTYKRXTYBYHYIYJAGBCESUQURXRWOWNWMMLZWLWOWJXAWIUSXRVSWAWFWBWCWOYLRXTY
    BYDYIYJAFBCESUQURUTZVADAGDAFEVBVCYMOQVPWIVSWEWAWFWGWEWAWFWFXFXQRVSWDWHVEZVS
    WDWEWFWGVDZVSWAWBWCWHVFZVSWDWEWFWGVGZVSWDWEWFWGVHZYOYPYQYQDAFGDAFFEVIVJVKXB
    WJTWIWJWPXAVEVLVMWIVSWEWAWFWGWEWAWFWFXGXHTYNYOYPYQYRYOYPYQYQDAFGDAFFEVNVJWI
    VSWFWGWFXHXITYNYQYRYQFGFEVOVQVR $.

  ${
    $d N r s $.  $d A r s $.  $d B r s $.  $d C r s $.  $d D r s $.
    $( Existential uniqueness version of ~ segconeq .  (Contributed by Scott
       Fenton, 19-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    segconeu $p |- ( ( N e. NN /\
       ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) /\
         C =/= D ) ) ->
       E! r e. ( EE ` N ) ( D Btwn <. C , r >. /\
       <. D , r >. Cgr <. A , B >. ) ) $=
      ( vs cn wcel cee wa w3a cv cop cbtwn wbr ccgr wi wral opeq2 cfv wrex wreu
      wne simpl simpr2 simpr1 axsegcon syl3anc simpl23 simprl simprr 3jca simp1
      weq simp22r simp21l simp21r simp22l simp3l simp3r segconeq syl133anc syld
      ex 3expa ralrimivva breq2d breq1d anbi12d reu4 sylanbrc ) EHIZAEJUAZIZBVN
      IZKZCVNIZDVNIZKZCDUDZLZKZDCFMZNZOPZDWDNZABNZQPZKZFVNUBZWJDCGMZNZOPZDWLNZW
      HQPZKZKZFGUOZRZGVNSFVNSWJFVNUCWCVMVTVQWKVMWBUEVMVQVTWAUFVMVQVTWAUGFCDABEU
      HUIWCWTFGVNVNVMWBWDVNIZWLVNIZKZWTVMWBXCLZWRWAWJWQLZWSXDWRXEXDWRKWAWJWQVQV
      TWAVMXCWRUJXDWJWQUKXDWJWQULUMVEXDVMVSVOVPVRXAXBXEWSRVMWBXCUNVRVSVQWAVMXCU
      PVOVPVTWAVMXCUQVOVPVTWAVMXCURVRVSVQWAVMXCUSVMWBXAXBUTVMWBXAXBVADABCEWDWLV
      BVCVDVFVGWJWQFGVNWSWFWNWIWPWSWEWMDOWDWLCTVHWSWGWOWHQWDWLDTVIVJVKVL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Betweenness properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.  $d B x $.  $d N x $.
    $( Betweeness always holds for the second endpoint.  Theorem 3.1 of
       [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    btwntriv2 $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
      B Btwn <. A , B >. ) $=
      ( vx cn wcel cee cfv w3a cv cop cbtwn wbr ccgr wa wrex simp1 simp2 simp3
      wi axsegcon syl122anc simpl1 simpl3 simpr axcgrid syl13anc breq2d biimprd
      wceq opeq2 syl6 imp3a ancomsd rexlimdva mpd ) CEFZACGHZFZBURFZIZBADJZKZLM
      ZBVBKBBKNMZOZDURPZBABKZLMZVAUQUSUTUTUTVGUQUSUTQUQUSUTRUQUSUTSZVJVJDABBBCU
      AUBVAVFVIDURVAVBURFZOZVEVDVIVLVEVDVIVLVEBVBUJZVDVITVLUQUTVKUTVEVMTUQUSUTV
      KUCUQUSUTVKUDZVAVKUEVNBVBBCUFUGVMVIVDVMVHVCBLBVBAUKUHUIULUMUNUOUP $.
  $}

  ${
    $d N x $.  $d A x $.  $d B x $.  $d C x $.
    $( Betweeness commutes.  Implication version.  Theorem 3.2 of
       [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    btwncomim $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Btwn <. B , C >. -> A Btwn <. C , B >. ) ) $=
      ( vx cn wcel cee cfv w3a wa cop cbtwn wbr cv btwntriv2 3adant3r2 wi simpl
      wrex simpr2 simpr1 simpr3 axpasch syl132anc mpan2d simpr simplr1 axbtwnid
      wceq simpll syl3anc breq1 biimpd syl6 imp3a rexlimdva syld ) DFGZADHIZGZB
      UTGZCUTGZJZKZABCLMNZEOZAALMNZVGCBLZMNZKZEUTTZAVIMNZVEVFCACLMNZVLUSVAVCVNV
      BACDPQVEUSVBVAVCVAVCVFVNKVLRUSVDSUSVAVBVCUAUSVAVBVCUBZUSVAVBVCUCZVOVPEBAC
      ACDUDUEUFVEVKVMEUTVEVGUTGZKZVHVJVMVRVHVGAUJZVJVMRVRUSVQVAVHVSRUSVDVQUKVEV
      QUGVAVBVCUSVQUHVGADUIULVSVJVMVGAVIMUMUNUOUPUQUR $.
  $}

  $( Betweeness commutes.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
  btwncom $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Btwn <. B , C >. <-> A Btwn <. C , B >. ) ) $=
    ( cn wcel cee cfv w3a wa cop cbtwn wbr btwncomim wi 3ancomb sylan2b impbid
    ) DEFZADGHZFZBTFZCTFZIZJABCKLMZACBKLMZABCDNUDSUAUCUBIUFUEOUAUBUCPACBDNQR $.

  ${
    btwncomand.1 $e |- ( ph -> N e. NN ) $.
    btwncomand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    btwncomand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    btwncomand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    btwncomand.5 $e |- ( ( ph /\ ps ) -> A Btwn <. B , C >. ) $.
    $( Deduction form of ~ btwncom .  (Contributed by Scott Fenton,
       14-Oct-2013.) $)
    btwncomand $p |- ( ( ph /\ ps ) -> A Btwn <. C , B >. ) $=
      ( wa cop cbtwn wbr wb cn wcel cee cfv btwncom syl13anc adantr mpbid ) ABL
      CDEMNOZCEDMNOZKAUEUFPZBAFQRCFSTZRDUHREUHRUGGHIJCDEFUAUBUCUD $.
  $}

  $( Betweeness always holds for the first endpoint.  Theorem 3.3 of
     [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
  btwntriv1 $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
      A Btwn <. A , B >. ) $=
    ( cn wcel cee cfv w3a cop cbtwn wbr btwntriv2 3com23 wb simp1 simp2 btwncom
    simp3 syl13anc mpbird ) CDEZACFGZEZBUBEZHZAABIJKZABAIJKZUAUDUCUGBACLMUEUAUC
    UCUDUFUGNUAUCUDOUAUCUDPZUHUAUCUDRAABCQST $.

  ${
    $d N x $.  $d A x $.  $d B x $.  $d C x $.
    $( If you can swap the first two arguments of a betweenness statement, then
       those arguments are identical.  Theorem 3.4 of [Schwabhauser] p. 30.
       (Contributed by Scott Fenton, 12-Jun-2013.) $)
    btwnswapid $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
       ( ( A Btwn <. B , C >. /\ B Btwn <. A , C >. ) ->
         A = B ) ) $=
      ( vx cn wcel cee cfv w3a wa cop cbtwn wbr cv wrex wceq axbtwnid syl3anc
      wi simpl simpr2 simpr1 simpr3 axpasch simpr simplr1 simplr2 anim12d eqtr2
      syl132anc simpll syl6 rexlimdva syld ) DFGZADHIZGZBUQGZCUQGZJZKZABCLMNBAC
      LMNKZEOZAALMNZVDBBLMNZKZEUQPZABQZVBUPUSURUTURUSVCVHTUPVAUAUPURUSUTUBZUPUR
      USUTUCZUPURUSUTUDVKVJEBACABDUEUKVBVGVIEUQVBVDUQGZKZVGVDAQZVDBQZKVIVMVEVNV
      FVOVMUPVLURVEVNTUPVAVLULZVBVLUFZURUSUTUPVLUGVDADRSVMUPVLUSVFVOTVPVQURUSUT
      UPVLUHVDBDRSUIVDABUJUMUNUO $.
  $}

  $( If you can swap arguments one and three of a betweenness statement, then
     those arguments are identical.  (Contributed by Scott Fenton,
     7-Oct-2013.) $)
  btwnswapid2 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
       ( ( A Btwn <. B , C >. /\ C Btwn <. B , A >. ) ->
         A = C ) ) $=
    ( cn wcel cee cfv w3a wa cop cbtwn wbr btwncom wb 3anrev sylan2b anbi12d wi
    wceq 3ancomb btwnswapid sylbid ) DEFZADGHZFZBUEFZCUEFZIZJZABCKLMZCBAKLMZJAC
    BKLMZCABKLMZJZACTZUJUKUMULUNABCDNUIUDUHUGUFIULUNOUFUGUHPCBADNQRUIUDUFUHUGIU
    OUPSUFUGUHUAACBDUBQUC $.

  ${
    $d N x $.  $d A x $.  $d B x $.  $d C x $.  $d D x $.
    $( Inner transitivity law for betweenness.  Left-hand side of Theorem 3.5
       of [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    btwnintr $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
       ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
       ( ( B Btwn <. A , D >. /\ C Btwn <. B , D >. ) ->
         B Btwn <. A , C >. ) ) $=
      ( vx cn wcel cee cfv wa w3a cop cbtwn wbr cv wrex wi simp1 simp2l axpasch
      simp2r simp3r simp3l syl132anc wceq simpl1 simpr simpl2r axbtwnid syl3anc
      breq1 biimpa wb simpl3l simpl2l btwncom syl13anc syl5ib syland rexlimdva
      syld ) EGHZAEIJZHZBVDHZKZCVDHZDVDHZKZLZBADMNOCBDMNOKZFPZBBMNOZVMCAMZNOZKZ
      FVDQZBACMNOZVKVCVEVFVIVFVHVLVRRVCVGVJSVCVEVFVJTVCVEVFVJUBZVCVGVHVIUCVTVCV
      GVHVIUDFABDBCEUAUEVKVQVSFVDVKVMVDHZKZVNVMBUFZVPVSWBVCWAVFVNWCRVCVGVJWAUGZ
      VKWAUHVEVFVCVJWAUIZVMBEUJUKWCVPKBVONOZWBVSWCVPWFVMBVONULUMWBVCVFVHVEWFVSU
      NWDWEVHVIVCVGWAUOVEVFVCVJWAUPBCAEUQURUSUTVAVB $.

    $( Exchange the first endpoint in betweenness.  Left-hand side of Theorem
       3.6 of [Schwabhauser] p. 30.  (Contributed by Scott Fenton,
       12-Jun-2013.) $)
    btwnexch3 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
       ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
       ( ( B Btwn <. A , C >. /\ C Btwn <. A , D >. ) ->
         C Btwn <. B , D >. ) ) $=
      ( vx cn wcel cee cfv wa w3a cop cbtwn wbr cv wb btwncom syl13anc wi simp1
      wrex simp3l simp2l simp3r simp2r anbi12d axpasch syl132anc sylbid ancomsd
      wceq simpl1 simpr simpl3l axbtwnid breq1 biimpd syl6 imp3a rexlimdva syld
      syl3anc ) EGHZAEIJZHZBVEHZKZCVEHZDVEHZKZLZBACMNOZCADMNOZKFPZCCMNOZVOBDMZN
      OZKZFVEUBZCVQNOZVLVNVMVTVLVNVMKCDAMNOZBCAMNOZKZVTVLVNWBVMWCVLVDVIVFVJVNWB
      QVDVHVKUAZVDVHVIVJUCZVDVFVGVKUDZVDVHVIVJUEZCADERSVLVDVGVFVIVMWCQWEVDVFVGV
      KUFZWGWFBACERSUGVLVDVJVIVFVIVGWDVTTWEWHWFWGWFWIFDCACBEUHUIUJUKVLVSWAFVEVL
      VOVEHZKZVPVRWAWKVPVOCULZVRWATWKVDWJVIVPWLTVDVHVKWJUMVLWJUNVIVJVDVHWJUOVOC
      EUPVCWLVRWAVOCVQNUQURUSUTVAVB $.

    ${
      btwnexch3and.1 $e |- ( ph -> N e. NN ) $.
      btwnexch3and.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
      btwnexch3and.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
      btwnexch3and.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
      btwnexch3and.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
      btwnexch3and.6 $e |- ( ( ph /\ ps ) -> B Btwn <. A , C >. ) $.
      btwnexch3and.7 $e |- ( ( ph /\ ps ) -> C Btwn <. A , D >. ) $.
      $( Deduction form of ~ btwnexch3 .  (Contributed by Scott Fenton,
         13-Oct-2013.) $)
      btwnexch3and $p |- ( ( ph /\ ps ) -> C Btwn <. B , D >. ) $=
        ( wa cop cbtwn wbr wi wcel cn cee cfv btwnexch3 syl122anc adantr mp2and
        ) ABODCEPQRZECFPQRZEDFPQRZMNAUHUIOUJSZBAGUATCGUBUCZTDULTEULTFULTUKHIJKL
        CDEFGUDUEUFUG $.
    $}

    $( Outer transitivity law for betweenness.  Left-hand side of Theorem 3.1
       of [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 12-Jun-2013.) $)
    btwnouttr2 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
       ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
       ( ( B =/= C /\
           B Btwn <. A , C >. /\ C Btwn <. B , D >. ) ->
         C Btwn <. A , D >. ) ) $=
      ( vx cn wcel cee wa w3a cop cbtwn wbr ccgr syl122anc adantr wi jca mpd cv
      cfv wne simp1 simp2l simp3l simp3r axsegcon simprrl simprl1 simpl2 simprl
      wrex wceq adantl simpl1 simpl2l simpl2r simpl3l btwnexch3 simprrr simprl3
      simpr simpl3r cgrrflxd segconeq syl133anc mp3and opeq2d breqtrd rexlimdva
      expr an32s ex ) EGHZAEIUBZHZBVPHZJZCVPHZDVPHZJZKZBCUCZBACLMNZCBDLMNZKZCAD
      LZMNZWCWGJZCAFUAZLZMNZCWKLCDLZONZJZFVPUMZWIWCWQWGWCVOVQVTVTWAWQVOVSWBUDVO
      VQVRWBUEVOVSVTWAUFZWRVOVSVTWAUGFACCDEUHPQWJWPWIFVPWCWKVPHZWGWPWIRWCWSJZWG
      WPWIWTWGWPJZJZCWLWHMWTWGWMWOUIXBWKDAXBWDCBWKLMNZWOJZWFWNWNONZJZWKDUNZWDWE
      WFWPWTUJXBXCWOXBWEWMJZXCXAXHWTXAWEWMWDWEWFWPUKWGWMWOULSUOWTXHXCRZXAWTVOVQ
      VRVTWSXIVOVSWBWSUPZVQVRVOWBWSUQVQVRVOWBWSURZVTWAVOVSWSUSZWCWSVCZABCWKEUTP
      QTWTWGWMWOVASXBWFXEWDWEWFWPWTVBWTXEXAWTCDEXJXLVTWAVOVSWSVDZVEQSWTWDXDXFKX
      GRZXAWTVOVTVTWAVRWSWAXOXJXLXLXNXKXMXNCCDBEWKDVFVGQVHVIVJVLVMVKTVN $.
  $}

  $( Exchange the outer point of two betweenness statements.  Right-hand side
     of Theorem 3.5 of [Schwabhauser] p. 30.  (Contributed by Scott Fenton,
     14-Jun-2013.) $)
  btwnexch2 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
   ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
   ( ( B Btwn <. A , D >. /\ C Btwn <. B , D >. ) ->
     C Btwn <. A , D >. ) ) $=
    ( cn wcel cee cfv wa w3a cop cbtwn wbr wi wceq breq1 biimpd adantrd adantr
    a1i wne simprl simprr btwnintr simprrr btwnouttr2 mp3and exp32 pm2.61dne
    mpd ) EFGAEHIZGBULGJCULGDULGJKZBADLZMNZCBDLMNZJZCUNMNZOZBCBCPZUSOUMUTUOURUP
    UTUOURBCUNMQRSUAUMBCUBZUQURUMVAUQJZJZVABACLMNZUPURUMVAUQUCVCUQVDUMVAUQUDUMU
    QVDOVBABCDEUETUKUMVAUOUPUFUMVAVDUPKUROVBABCDEUGTUHUIUJ $.

  $( Outer transitivity law for betweenness.  Right-hand side of Theorem 3.7 of
     [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 14-Jun-2013.) $)
  btwnouttr $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
   ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
   ( ( B =/= C /\
       B Btwn <. A , C >. /\ C Btwn <. B , D >. ) ->
     B Btwn <. A , D >. ) ) $=
    ( cn wcel cee cfv wa w3a wne cop cbtwn wbr simp1 simp2r wb btwncom syl13anc
    simp3r simp2l necom a1i simp3l 3anbi123d 3ancomb syl6bb biimpa wi syl122anc
    btwnouttr2 adantr mpd btwncomand ex ) EFGZAEHIZGZBURGZJZCURGZDURGZJZKZBCLZB
    ACMNOZCBDMNOZKZBADMNOVEVIBDAEUQVAVDPZUQUSUTVDQZUQVAVBVCUAZUQUSUTVDUBZVEVIJC
    BLZCDBMNOZBCAMNOZKZBDAMNOZVEVIVQVEVIVNVPVOKVQVEVFVNVGVPVHVOVFVNRVEBCUCUDVEU
    QUTUSVBVGVPRVJVKVMUQVAVBVCUEZBACESTVEUQVBUTVCVHVORVJVSVKVLCBDESTUFVNVPVOUGU
    HUIVEVQVRUJZVIVEUQVCVBUTUSVTVJVLVSVKVMDCBAEULUKUMUNUOUP $.

  $( Outer transitivity law for betweenness.  Right-hand side of Theorem 3.6 of
     [Schwabhauser] p. 30.  (Contributed by Scott Fenton, 24-Sep-2013.) $)
  btwnexch $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
  ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
  ( ( B Btwn <. A , C >. /\ C Btwn <. A , D >. ) -> B Btwn <. A , D >. ) ) $=
    ( cn wcel cee cfv wa w3a cop cbtwn wbr simp1 simp2r simp2l btwncom syl13anc
    wb simp3l simp3r anbi12d ancom syl6bb wi btwnexch2 syl122anc sylbid sylibd
    ) EFGZAEHIZGZBULGZJZCULGZDULGZJZKZBACLMNZCADLZMNZJZBDALZMNZBVAMNZUSVCCVDMNZ
    BCALMNZJZVEUSVCVHVGJVIUSUTVHVBVGUSUKUNUMUPUTVHTUKUOUROZUKUMUNURPZUKUMUNURQZ
    UKUOUPUQUAZBACERSUSUKUPUMUQVBVGTVJVMVLUKUOUPUQUBZCADERSUCVHVGUDUEUSUKUQUPUN
    UMVIVEUFVJVNVMVKVLDCBAEUGUHUIUSUKUNUQUMVEVFTVJVKVNVLBDAERSUJ $.

  ${
    btwnexchand.1 $e |- ( ph -> N e. NN ) $.
    btwnexchand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    btwnexchand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    btwnexchand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    btwnexchand.5 $e |- ( ph -> D e. ( EE ` N ) ) $.
    btwnexchand.6 $e |- ( ( ph /\ ps ) -> B Btwn <. A , C >. ) $.
    btwnexchand.7 $e |- ( ( ph /\ ps ) -> C Btwn <. A , D >. ) $.
    $( Deduction form of ~ btwnexch .  (Contributed by Scott Fenton,
       13-Oct-2013.) $)
    btwnexchand $p |- ( ( ph /\ ps ) -> B Btwn <. A , D >. ) $=
      ( wa cop cbtwn wbr wi wcel cn cee cfv btwnexch syl122anc adantr mp2and )
      ABODCEPQRZECFPZQRZDUIQRZMNAUHUJOUKSZBAGUATCGUBUCZTDUMTEUMTFUMTULHIJKLCDEF
      GUDUEUFUG $.
  $}

  ${
    $d A c u v $.  $d B c u v $.  $d N c u v $.
    $( There is always a ` c ` distinct from ` B ` such that ` B ` lies between
       ` A ` and ` c ` .  Theorem 3.14 of [Schwabhauser] p. 32.  (Contributed
       by Scott Fenton, 24-Sep-2013.) $)
    btwndiff $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
       E. c e. ( EE ` N ) ( B Btwn <. A , c >. /\ B =/= c ) ) $=
      ( vu vv cn wcel cee cfv w3a cv wne wrex cop wbr wa syl122anc wi mpd cbtwn
      axlowdim1 3ad2ant1 ccgr simp11 simp12 simp13 simp2l axsegcon wceq simpl11
      simp2r weq wb simpl13 simpr simpl2l simpl2r cgrdegen bi1 necon3d 3ad2ant3
      com12 adantr syld anim2d reximdva 3exp rexlimdvv ) CGHZACIJZHZBVKHZKZELZF
      LZMZFVKNEVKNZBADLZOUAPZBVSMZQZDVKNZVJVLVRVMEFCUBUCVNVQWCEFVKVKVNVOVKHZVPV
      KHZQZVQWCVNWFVQKZVTBVSOVOVPOUDPZQZDVKNZWCWGVJVLVMWDWEWJVJVLVMWFVQUEVJVLVM
      WFVQUFVJVLVMWFVQUGVNWDWEVQUHVNWDWEVQULDABVOVPCUIRWGWIWBDVKWGVSVKHZQZWHWAV
      TWLWHBVSUJZEFUMZUNZWAWLVJVMWKWDWEWHWOSVJVLVMWFVQWKUKVJVLVMWFVQWKUOWGWKUPW
      DWEVNVQWKUQWDWEVNVQWKURBVSVOVPCUSRWGWOWASZWKVQVNWPWFWOVQWAWOBVSVOVPWMWNUT
      VAVCVBVDVEVFVGTVHVIT $.
  $}

  ${
    $d A q r $.  $d B q r $.  $d C q r $.  $d D q r $.  $d E q r $.
    $d N q r $.  $d P q r $.
    $( A line segment between two sides of a triange intersects a segment
       crossing from the remaining side to the opposite vertex.  Theorem 3.17
       of [Schwabhauser] p. 33.  (Contributed by Scott Fenton, 24-Sep-2013.) $)
    trisegint $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ P e. ( EE ` N ) ) ) ->
       ( ( B Btwn <. A , C >. /\ E Btwn <. D , C >. /\ P Btwn <. A , D >. ) ->
       E. q e. ( EE ` N ) ( q Btwn <. P , C >. /\ q Btwn <. B , E >. ) ) ) $=
      ( vr wcel w3a cop cbtwn wbr wa wrex 3jca jca sylc 3ad2ant1 cee cfv simpl1
      cn simpl23 simpl21 simpl31 simpl32 simpl33 simpr2 btwncom syl13anc simpr3
      cv mpbid axpasch simp1l1 simp2 simpl22 simp3l simp1r1 simpll1 syl simpll2
      wb simplr simpl3r anim1i btwnexch2 ex anim1d reximdva mpd rexlimdv3a ) GU
      DJZAGUAUBZJZBVPJZCVPJZKZDVPJZFVPJZEVPJZKZKZBACLMNZFDCLMNZEADLMNZKZHUNZECL
      ZMNZWJBFLMNZOZHVPPZWEWIOZIUNZFALMNZWQWKMNZOZIVPPZWOWPVOVSVQWAKZWBWCOZKFCD
      LMNZWHOXAWPVOXBXCVOVTWDWIUCZWPVSVQWAVQVRVSVOWDWIUEZVQVRVSVOWDWIUFZWAWBWCV
      OVTWIUGZQWPWBWCWAWBWCVOVTWIUHZWAWBWCVOVTWIUIZRQWPXDWHWPWGXDWEWFWGWHUJWPVO
      WBWAVSWGXDVEXEXIXHXFFDCGUKULUOWEWFWGWHUMRICADFEGUPSWPWTWOIVPWPWQVPJZWTKZW
      JWQCLMNZWMOZHVPPZWOXLVOWBVSVQKZXKVROZKWRBCALMNZOXOXLVOXPXQVOVTWDWIXKWTUQZ
      XLWBVSVQWPXKWBWTXITWPXKVSWTXFTZWPXKVQWTXGTZQXLXKVRWPXKWTURWPXKVRWTVQVRVSV
      OWDWIUSTZRQXLWRXRWPXKWRWSUTXLWFXRWFWGWHWEXKWTVAXLVOVRVQVSWFXRVEXSYBYAXTBA
      CGUKULUORHFCAWQBGUPSXLXNWNHVPXLWJVPJZOZXMWLWMYDXMWLYDXMOZVOWCXKOZYCVSOZKW
      SXMOWLYEVOYFYGYEWPVOWPXKWTYCXMVBZXEVCYEWCXKYEWPWCYHXJVCWPXKWTYCXMVDRYEYCV
      SXLYCXMVFYEWPVSYHXFVCRQYDWSXMWRWSWPXKYCVGVHEWQWJCGVISVJVKVLVMVNVMVJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Segment Transportation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c TransportTo $.

  $( Declare the syntax for the segment transport function. $)
  ctransport $a class TransportTo $.

  ${
    $d n p q r x $.
    $( Define the segment transport function.  See ~ fvtransport for an
       explanation of the function.  (Contributed by Scott Fenton,
       18-Oct-2013.) $)
    df-transport $a |- TransportTo =
       { <. <. p , q >. , x >. |
         E. n e. NN ( ( p e. ( ( EE ` n ) X. ( EE ` n ) ) /\
                        q e. ( ( EE ` n ) X. ( EE ` n ) ) /\
                        ( 1st ` q ) =/= ( 2nd ` q ) ) /\
                      x = ( iota_ r e. ( EE ` n )
                        ( ( 2nd ` q ) Btwn <. ( 1st ` q ) , r >. /\
                        <. ( 2nd ` q ) , r >. Cgr p ) ) ) } $.
  $}

  ${
    $d m n p q r x y $.
    $( The ` TransportTo ` relationship is a function.  (Contributed by Scott
       Fenton, 18-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    funtransport $p |- Fun TransportTo $=
      ( vp vn vq vx vr vm vy ctransport wfun cv cee cfv cxp wcel c1st w3a wa cn
      wceq wrex c2nd wne cop cbtwn wbr ccgr crio coprab wmo weq wi reeanv simp1
      anim12i anim1i an4s xp1st axdimuniq fveq2 riotaeqdv eqeq2d anbi2d syl6bir
      wal eqtr3 syl ex syl2ani imp3a syl5 rexlimivv sylbir gen2 rexbidv xpeq12d
      eqeq1 eleq2d 3anbi12d anbi12d cbvrexv syl6bb funoprab df-transport funeqi
      mo4 mpbir ) HIAJZBJZKLZWIMZNZCJZWJNZWLOLZWLUALZUBZPZDJZWOWNEJZUCUDUEWOWSU
      CWGUFUEQZEWIUGZSZQZBRTZACDUHZIXDACDXDDUIXDWGFJZKLZXGMZNZWLXHNZWPPZGJZWTEX
      GUGZSZQZFRTZQZDGUJZUKZGVDDVDXSDGXQXCXOQZFRTBRTXRXCXOBFRRULXTXRBFRRXTWKXIQ
      ZXBXNQZQZWHRNZXFRNZQZXRWQXKXBXNYCWQXKQYAYBWQWKXKXIWKWMWPUMXIXJWPUMUNUOUPY
      FYAYBXRWKYFWGOLZWINZYGXGNZYBXRUKZXIWGWIWIUQWGXGXGUQYFYHYIQYJYDYHYEYIYJYDY
      HQYEYIQQBFUJZYJYGXFWHURYKYBXBXLXASZQXRYKYLXNXBYKXAXMXLYKWTEWIXGWHXFKUSZUT
      VAZVBWRXLXAVEVCVFUPVGVHVIVJVKVLVMXDXPDGXRXDWQYLQZBRTXPXRXCYOBRXRXBYLWQWRX
      LXAVPVBVNYOXOBFRYKWQXKYLXNYKWKXIWMXJWPYKWJXHWGYKWIXGWIXGYMYMVOZVQYKWJXHWL
      YPVQVRYNVSVTWAWEWFWBHXEDBECAWCWDWF $.
  $}

  ${
    $d N n p q r x $.  $d A n p q r x $.  $d B n p q r x $.  $d C n p q r x $.
    $d D n p q r x $.
    $( Calculate the value of the ` TransportTo ` function.  This function
       takes four points, ` A ` through ` D ` , where ` C ` and ` D ` are
       distinct.  It then returns the point that extends ` C D ` by the length
       of ` A B ` .  (Contributed by Scott Fenton, 18-Oct-2013.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    fvtransport $p |- ( ( N e. NN /\
       ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) /\
         C =/= D ) ) ->
       ( <. A , B >. TransportTo <. C , D >. ) =
       ( iota_ r e. ( EE ` N ) ( D Btwn <. C , r >. /\
         <. D , r >. Cgr <. A , B >. ) ) ) $=
      ( vn cn wcel cfv wa w3a cop ctransport cv cbtwn wbr ccgr wceq cvv cee wne
      vp vq vx co crio df-ov cxp c1st c2nd wrex opelxpi 3ad2ant1 3ad2ant2 simp3
      op1stg op2ndg 3netr4d 3jca opeq1d breq12d breq1d anbi12d riotabidv eqcomd
      fveq2 xpeq12d eleq2d 3anbi12d riotaeqdv eqeq2d rspcev sylan2 coprab df-br
      jca df-transport eleq2i opex riotaex eleq1 3anbi1d anbi2d rexbidv neeq12d
      wb breq2 3anbi23d eqeq1 eloprabg mp3an wfun wi funtransport funbrfv ax-mp
      3bitri sylbir syl syl5eq ) EHIZAEUAJZIBXCIKZCXCIDXCIKZCDUBZLZKZABMZCDMZNU
      FXIXJMZNJZDCFOZMZPQZDXMMZXIRQZKZFXCUGZXIXJNUHXHXIGOZUAJZYAUIZIZXJYBIZXJUJ
      JZXJUKJZUBZLZXSYFYEXMMZPQZYFXMMZXIRQZKZFYAUGZSZKZGHULZXLXSSZXGXBXIXCXCUIZ
      IZXJYSIZYGLZXSYMFXCUGZSZKZYQXGUUBUUDXGYTUUAYGXDXEYTXFABXCXCUMUNXEXDUUAXFC
      DXCXCUMUOXGCDYEYFXDXEXFUPXEXDYECSXFCDXCXCUQUOZXEXDYFDSXFCDXCXCURUOZUSUTXG
      UUCXSXGYMXRFXCXGYJXOYLXQXGYFDYIXNPUUGXGYECXMUUFVAVBXGYKXPXIRXGYFDXMUUGVAV
      CVDVEVFVQYPUUEGEHXTESZYHUUBYOUUDUUHYCYTYDUUAYGUUHYBYSXIUUHYAXCYAXCXTEUAVG
      ZUUIVHZVIUUHYBYSXJUUJVIVJUUHYNUUCXSUUHYMFYAXCUUIVKVLVDVMVNYQXKXSNQZYRUUKX
      KXSMZNIUULUCOZYBIZUDOZYBIZUUOUJJZUUOUKJZUBZLZUEOZUURUUQXMMZPQZUURXMMZUUMR
      QZKZFYAUGZSZKZGHULZUCUDUEVOZIZYQXKXSNVPNUVKUULUEGFUDUCVRVSXITIXJTIXSTIUVL
      YQWGABVTCDVTXRFXCWAUVJYCUUPUUSLZUVAUVCUVDXIRQZKZFYAUGZSZKZGHULYHUVAYNSZKZ
      GHULYQUCUDUEXIXJXSTTTUUMXISZUVIUVRGHUWAUUTUVMUVHUVQUWAUUNYCUUPUUSUUMXIYBW
      BWCUWAUVGUVPUVAUWAUVFUVOFYAUWAUVEUVNUVCUUMXIUVDRWHWDVEVLVDWEUUOXJSZUVRUVT
      GHUWBUVMYHUVQUVSUWBUUPYDUUSYGYCUUOXJYBWBUWBUUQYEUURYFUUOXJUJVGZUUOXJUKVGZ
      WFWIUWBUVPYNUVAUWBUVOYMFYAUWBUVCYJUVNYLUWBUURYFUVBYIPUWDUWBUUQYEXMUWCVAVB
      UWBUVDYKXIRUWBUURYFXMUWDVAVCVDVEVLVDWEUVAXSSZUVTYPGHUWEUVSYOYHUVAXSYNWJWD
      WEWKWLWRNWMUUKYRWNWOXKXSNWPWQWSWTXA $.
  $}

  ${
    $d N r y $.  $d A r y $.  $d B r y $.  $d C r y $.  $d D r y $.
    $( Closure law for segment transport.  (Contributed by Scott Fenton,
       19-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    transportcl $p |- ( ( N e. NN /\
       ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) /\
         C =/= D ) ) ->
       ( <. A , B >. TransportTo <. C , D >. ) e. ( EE ` N ) ) $=
      ( vr cn wcel cee cfv wa wne w3a cop ctransport co cv cbtwn wbr ccgr crio
      fvtransport wreu segconeu riotacl syl eqeltrd ) EGHAEIJZHBUHHKCUHHDUHHKCD
      LMKZABNZCDNOPDCFQZNRSDUKNUJTSKZFUHUAZUHABCDEFUBUIULFUHUCUMUHHABCDEFUDULFU
      HUEUFUG $.

    $( Calculate the defining properties of the transport function (Contributed
       by Scott Fenton, 19-Oct-2013.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    transportprops $p |- ( ( N e. NN /\
       ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) /\
         C =/= D ) ) ->
         ( D Btwn <. C , ( <. A , B >. TransportTo <. C , D >. ) >. /\
           <. D , ( <. A , B >. TransportTo <. C , D >. ) >. Cgr
           <. A , B >. ) ) $=
      ( vr cn wcel cee cfv wa wne w3a cop ctransport cbtwn wbr ccgr wceq opeq2
      co cv crio fvtransport eqcomd wreu wb transportcl segconeu breq2d anbi12d
      breq1d riota2 syl2anc mpbird ) EGHAEIJZHBUPHKCUPHDUPHKCDLMKZDCABNZCDNOUAZ
      NZPQZDUSNZURRQZKZDCFUBZNZPQZDVENZURRQZKZFUPUCZUSSZUQUSVKABCDEFUDUEUQUSUPH
      VJFUPUFVDVLUGABCDEUHABCDEFUIVJVDFUPUSVEUSSZVGVAVIVCVMVFUTDPVEUSCTUJVMVHVB
      URRVEUSDTULUKUMUNUO $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Properties relating betweenness and congruence
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c InnerFiveSeg Cgr3 Colinear FiveSeg $.

  $( Declare the syntax for the inner five segment predicate. $)
  cifs $a class InnerFiveSeg $.

  $( Declare the syntax for the three place congruence predicate. $)
  ccgr3 $a class Cgr3 $.

  $( Declare the syntax for the colinearity predicate. $)
  ccolin $a class Colinear $.

  $( Declare the syntax for the five segment predicate. $)
  cfs $a class FiveSeg $.

  ${
    $d a b c d x y z w p q n $.
    $( The inner five segment configuration is an abbreviation for another
       congruence condition.  See ~ brifs and ~ ifscgr for how it is used.
       Definition 4.1 of [Schwabhauser] p. 34.  (Contributed by Scott Fenton,
       26-Sep-2013.) $)
    df-ifs $a |- InnerFiveSeg =
        { <. p , q >. |
           E. n e. NN E. a e. ( EE ` n ) E. b e. ( EE ` n ) E. c e. ( EE ` n )
           E. d e. ( EE ` n ) E. x e. ( EE ` n ) E. y e. ( EE ` n )
           E. z e. ( EE ` n ) E. w e. ( EE ` n ) (
           p = <. <. a , b >. , <. c , d >. >. /\
           q = <. <. x , y >. , <. z , w >. >. /\
           ( ( b Btwn <. a , c >. /\ y Btwn <. x , z >. ) /\
             ( <. a , c >. Cgr <. x , z >. /\
               <. b , c >. Cgr <. y , z >. ) /\
             ( <. a , d >. Cgr <. x , w >. /\
               <. c , d >. Cgr <. z , w >. ) ) ) } $.
  $}

  ${
    $d a b c d e f n p q $.
    $( The three place congruence predicate.  This is an abbreviation for
       saying that all three pair in a triple are congruent with each other.
       Three place form of Definition 4.4 of [Schwabhauser] p. 35.
       (Contributed by Scott Fenton, 4-Oct-2013.) $)
    df-cgr3 $a |- Cgr3 = { <. p , q >. |
       E. n e. NN E. a e. ( EE ` n ) E. b e. ( EE ` n ) E. c e. ( EE ` n )
       E. d e. ( EE ` n ) E. e e. ( EE ` n ) E. f e. ( EE ` n )
       ( p = <. a , <. b , c >. >. /\
       q = <. d , <. e , f >. >. /\
       ( <. a , b >. Cgr <. d , e >. /\ <. a , c >. Cgr <. d , f >. /\
         <. b , c >. Cgr <. e , f >. ) ) } $.
  $}

  ${
    $d a b c n $.
    $( The colinearity predicate states that the three points in its arguments
       sit on one line.  Definition 4.10 of [Schwabhauser] p. 36.  (Contributed
       by Scott Fenton, 25-Oct-2013.) $)
    df-colinear $a |- Colinear = `' { <. <. b , c >. , a >. |
       E. n e. NN ( ( a e. ( EE ` n ) /\ b e. ( EE ` n ) /\ c e. ( EE ` n ) )
         /\
         ( a Btwn <. b , c >. \/ b Btwn <. c , a >. \/
           c Btwn <. a , b >. ) ) } $.
  $}

  ${
    $d a b c d x y z w p q n $.
    $( The general five segment configuration is a generalization of the outer
       and inner five segment configurations.  See ~ brfs and ~ fscgr for its
       use.  Definition 4.15 of [Schwabhauser] p. 37.  (Contributed by Scott
       Fenton, 5-Oct-2013.) $)
    df-fs $a |- FiveSeg =
        { <. p , q >. |
           E. n e. NN E. a e. ( EE ` n ) E. b e. ( EE ` n ) E. c e. ( EE ` n )
           E. d e. ( EE ` n ) E. x e. ( EE ` n ) E. y e. ( EE ` n )
           E. z e. ( EE ` n ) E. w e. ( EE ` n ) (
           p = <. <. a , b >. , <. c , d >. >. /\
           q = <. <. x , y >. , <. z , w >. >. /\
           ( a Colinear <. b , c >. /\
             <. a , <. b , c >. >. Cgr3 <. x , <. y , z >. >. /\
             ( <. a , d >. Cgr <. x , w >. /\
               <. b , d >. Cgr <. y , w >. ) ) ) } $.
  $}

  ${
    $d N a b c d e f g h p q n $.  $d A a b c d e f g h p q n $.
    $d B a b c d e f g h p q n $.  $d C a b c d e f g h p q n $.
    $d D a b c d e f g h p q n $.  $d E a b c d e f g h p q n $.
    $d F a b c d e f g h p q n $.  $d G a b c d e f g h p q n $.
    $d H a b c d e f g h p q n $.
    $( Binary relationship form of the inner five segment predicate.
       (Contributed by Scott Fenton, 26-Sep-2013.) $)
    brifs $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. InnerFiveSeg
      <. <. E , F >. , <. G , H >. >. <-> ( ( B Btwn <. A , C >. /\
                     F Btwn <. E , G >. ) /\
        ( <. A , C >. Cgr <. E , G >. /\
          <. B , C >. Cgr <. F , G >. ) /\
        ( <. A , D >. Cgr <. E , H >. /\
          <. C , D >. Cgr <. G , H >. ) ) ) ) $=
      ( cv cop cbtwn wbr wa ccgr w3a wceq opeq1 breq2d breq1d vb va vc vf ve vg
      vd vh vn vq vp cee cifs cn anbi1d 3anbi123d breq1 anbi2d 3anbi12d anbi12d
      cfv opeq2 3anbi3d fveq2 df-ifs br8 ) UAJZUBJZUCJZKZLMZUDJZUEJZUFJZKZLMZNZ
      VJVOOMZVGVIKZVLVNKZOMZNZVHUGJZKZVMUHJZKZOMZVIWCKZVNWEKZOMZNZPVGAVIKZLMZVP
      NZWLVOOMZWANZAWCKZWFOMZWJNZPBWLLMZVPNZWOBVIKZVTOMZNZWSPBACKZLMZVPNZXEVOOM
      ZBCKZVTOMZNZWRCWCKZWIOMZNZPXGXKADKZWFOMZCDKZWIOMZNZPXFVLEVNKZLMZNZXEXTOMZ
      XJNZXOEWEKZOMZXRNZPXFFXTLMZNZYCXIFVNKZOMZNZYGPXFFEGKZLMZNZXEYMOMZXIFGKZOM
      ZNZYFXQGWEKZOMZNZPYOYSXOEHKZOMZXQGHKZOMZNZPUIABCDUIJZULVAIULVAUMUNUEUDUFU
      HEFGHIUJUKUBUAUCUGVHAQZVQWNWBWPWKWSUUIVKWMVPUUIVJWLVGLVHAVIRZSUOUUIVRWOWA
      UUIVJWLVOOUUJTUOUUIWGWRWJUUIWDWQWFOVHAWCRTUOUPVGBQZWNXAWPXDWSUUKWMWTVPVGB
      WLLUQUOUUKWAXCWOUUKVSXBVTOVGBVIRTURUSVICQZXAXGXDXKWSXNUULWTXFVPUULWLXEBLV
      ICAVBZSUOUULWOXHXCXJUULWLXEVOOUUMTUULXBXIVTOVICBVBTUTUULWJXMWRUULWHXLWIOV
      ICWCRTURUPWCDQZXNXSXGXKUUNWRXPXMXRUUNWQXOWFOWCDAVBTUUNXLXQWIOWCDCVBTUTVCV
      MEQZXGYBXKYDXSYGUUOVPYAXFUUOVOXTVLLVMEVNRZSURUUOXHYCXJUUOVOXTXEOUUPSUOUUO
      XPYFXRUUOWFYEXOOVMEWERSUOUPVLFQZYBYIYDYLYGUUQYAYHXFVLFXTLUQURUUQXJYKYCUUQ
      VTYJXIOVLFVNRSURUSVNGQZYIYOYLYSYGUUBUURYHYNXFUURXTYMFLVNGEVBZSURUURYCYPYK
      YRUURXTYMXEOUUSSUURYJYQXIOVNGFVBSUTUURXRUUAYFUURWIYTXQOVNGWERSURUPWEHQZUU
      BUUGYOYSUUTYFUUDUUAUUFUUTYEUUCXOOWEHEVBSUUTYTUUEXQOWEHGVBSUTVCUUHIULVDUEU
      DUFUHUIUJUKUBUAUCUGVEVF $.
  $}

  ${
    $d A e f $.  $d B e f $.  $d C e f $.  $d D e f $.  $d E e f $.
    $d F e f $.  $d G e f $.  $d H e f $.  $d N e f $.
    $( Inner five segment congruence.  Take two triangles, ` A D C ` and
       ` E H G ` , with ` B ` between ` A ` and ` C ` and ` F ` between ` E `
       and ` G ` .  If the other components of the triangles are congruent,
       then so are ` B D ` and ` F H ` .  Theorem 4.2 of [Schwabhauser] p. 34.
       (Contributed by Scott Fenton, 27-Sep-2013.) $)
    ifscgr $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. InnerFiveSeg
      <. <. E , F >. , <. G , H >. >. -> <. B , D >. Cgr <. F , H >. ) ) $=
      ( wcel w3a cop wbr cbtwn wa ccgr wi jca wb adantr ve vf cn cee cifs brifs
      cfv wceq simp1l simp11 simp13 simp21 axbtwnid syl3anc simp2r simp3r opeq2
      syl5 breq1d opeq1 anbi12d mpan9 simp31 simp32 cgrid2 syl13anc breq2d syl6
      biimprd imp3a exp3a mpdd anbi1d 3anbi12d imbi1d syl5ibr wne wrex btwndiff
      cv simpl11 simpl23 simpl32 simpl21 simpr axsegcon syl122anc anass simplrl
      simp12 cofs adantl simplll simpr2l simpllr ad2antrr simplrr mpbid simprr3
      cgrcom 3jca simpl12 simprl simpl22 simprr simpl33 brofs syl333anc sylibrd
      ex 5segofs syland simpr1l simpr1r jca32 simpl13 btwnexch3 simpl31 anim12d
      imp btwncom ad2antrl cgrcomlr simpr2r cgrcomlrand simpr3r necomd a1i jcad
      bitrd syld adantrd syl5bir anassrs rexlimdva mpd com3r pm2.61ine sylbid )
      IUCJZAIUDUGZJZBUUAJZKZCUUAJZDUUAJZEUUAJZKZFUUAJZGUUAJZHUUAJZKZKZABLCDLZLE
      FLGHLZLUEMBACLZNMZFEGLZNMZOZUUPUURPMZBCLZFGLZPMZOZADLEHLPMZUUNUUOPMZOZKZB
      DLZFHLZPMZABCDEFGHIUFUUMUVIUVLQZQACUUMUVMACUHZBCCLZNMZUUSOZUVOUURPMZUVDOZ
      UVHKZUVLQUUMUVTBCUHZUVLUVTUVPUUMUWAUVPUUSUVSUVHUIUUMYTUUCUUEUVPUWAQYTUUBU
      UCUUHUULUJZYTUUBUUCUUHUULUKZUUDUUEUUFUUGUULULZBCIUMUNURUUMUVTUWAUVLUVTUWA
      OBBLZUVCPMZUVJUUOPMZOZUUMUVLUVTUVDUVGOZUWAUWHUVTUVDUVGUVQUVRUVDUVHUOUVQUV
      SUVFUVGUPRUWAUWHUWIUWAUWFUVDUWGUVGUWAUWEUVBUVCPBCBUQUSUWAUVJUUNUUOPBCDUTU
      SVAVIVBUUMUWFUWGUVLUUMUWFFGUHZUWGUVLQUUMYTUUCUUIUUJUWFUWJQUWBUWCUUDUUHUUI
      UUJUUKVCUUDUUHUUIUUJUUKVDZBFGIVEVFUWJUVLUWGUWJUVKUUOUVJPFGHUTVGVIVHVJURVK
      VLUVNUVIUVTUVLUVNUUTUVQUVEUVSUVHUVNUUQUVPUUSUVNUUPUVOBNACCUTZVGVMUVNUVAUV
      RUVDUVNUUPUVOUURPUWLUSVMVNVOVPUUMUVIACVQZUVLUUMUVIUWMUVLUUMCAUAVTZLNMZCUW
      NVQZOZUAUUAVRZUVIUWMOZUVLQZUUMYTUUBUUEUWRUWBYTUUBUUCUUHUULWJUWDACIUAVSUNU
      UMUWQUWTUAUUAUUMUWNUUAJZOZUWQUWSUVLUXBGEUBVTZLNMZGUXCLZCUWNLZPMZOZUBUUAVR
      ZUWQUWSOZUVLQZUXBYTUUGUUJUUEUXAUXIYTUUBUUCUUHUULUXAWAUUEUUFUUGUUDUULUXAWB
      UUIUUJUUKUUDUUHUXAWCUUEUUFUUGUUDUULUXAWDUUMUXAWEUBEGCUWNIWFWGUXBUXHUXKUBU
      UAUUMUXAUXCUUAJZUXHUXKQUUMUXAUXLOZOZUXHUXJUVLUXHUXJOUXHUWQOZUWSOZUXNUVLUX
      HUWQUWSWHUXPUXOUVIOZUWMOZUXNUVLUXOUVIUWMWHUXNUXRUWNDLZUXCHLZPMZUVLUXNUXQU
      UPUXSLUURUXTLWKMZUWMUYAUXNUXQUWOUXDOZUVAUXFUXEPMZOZUVHKZUYBUXNUXQUYFUXNUX
      QOZUYCUYEUVHUYGUWOUXDUXQUWOUXNUXHUWOUWPUVIWIZWLUXQUXDUXNUXDUXGUWQUVIWMZWL
      RUYGUVAUYDUXQUVAUXNUVAUVDUUTUVHUXOWNWLUYGUXGUYDUXQUXGUXNUXDUXGUWQUVIWOZWL
      UYGYTUUJUXLUUEUXAUXGUYDSZUUMYTUXMUXQUWBWPUUMUUJUXMUXQUWKWPUUMUXAUXLUXQWQU
      UMUUEUXMUXQUWDWPUUMUXAUXLUXQWIGUXCCUWNIWTZWGWRRUUTUVEUVHUXOUXNWSXAXJUXNYT
      UUBUUEUXAUUFUUGUUJUXLUUKUYBUYFSYTUUBUUCUUHUULUXMWAZYTUUBUUCUUHUULUXMXBZUU
      EUUFUUGUUDUULUXMWDZUUMUXAUXLXCZUUEUUFUUGUUDUULUXMXDZUUEUUFUUGUUDUULUXMWBZ
      UUIUUJUUKUUDUUHUXMWCZUUMUXAUXLXEZUUIUUJUUKUUDUUHUXMXFZACUWNDEGUXCHIXGXHXI
      UXNYTUUBUUEUXAUUFUUGUUJUXLUUKUYBUWMOUYAQUYMUYNUYOUYPUYQUYRUYSUYTVUAACUWND
      EGUXCHIXKXHXLUXNUXQUYAUVLQUWMUXNUXQUYAUVLUXNUXQUYAOZUWNCLZUVJLUXCGLZUVKLW
      KMZUWNCVQZOZUVLUXNVUBVUEVUFUXNVUBCUWNBLNMZGUXCFLNMZOZVUCVUDPMZCBLGFLPMZOZ
      UYAUVGOZKZVUEUXNVUBVUOUXNVUBOZVUJVUMVUNVUPCBUWNLNMZGFUXCLNMZOZVUJUXNVUBVU
      SVUBUUQUWOOZUUSUXDOZOUXNVUSVUBVUTUUSUXDVUBUUQUWOUXQUUQUYAUUQUUSUVEUVHUXOX
      MTUXQUWOUYAUYHTRUXQUUSUYAUUQUUSUVEUVHUXOXNTUXQUXDUYAUYITXOUXNVUTVUQVVAVUR
      UXNYTUUBUUCUUEUXAVUTVUQQUYMUYNYTUUBUUCUUHUULUXMXPZUYOUYPABCUWNIXQWGUXNYTU
      UGUUIUUJUXLVVAVURQUYMUYRUUIUUJUUKUUDUUHUXMXRZUYSUYTEFGUXCIXQWGXSURXTUXNVU
      SVUJSVUBUXNVUQVUHVURVUIUXNYTUUEUUCUXAVUQVUHSUYMUYOVVBUYPCBUWNIYAVFUXNYTUU
      JUUIUXLVURVUISUYMUYSVVCUYTGFUXCIYAVFVATWRVUPVUKVULVUPUXGVUKUXQUXGUXNUYAUY
      JYBUXNUXGVUKSVUBUXNUXGUYDVUKUXNYTUUJUXLUUEUXAUYKUYMUYSUYTUYOUYPUYLWGUXNYT
      UUEUXAUUJUXLUYDVUKSUYMUYOUYPUYSUYTCUWNGUXCIYCWGYJTWRUXNVUBBCFGIUYMVVBUYOV
      VCUYSUXQUVDUXNUYAUVAUVDUUTUVHUXOYDYBYERVUPUYAUVGUXNUXQUYAXEUXQUVGUXNUYAUV
      FUVGUUTUVEUXOYFYBRXAXJUXNYTUXAUUEUUCUUFUXLUUJUUIUUKVUEVUOSUYMUYPUYOVVBUYQ
      UYTUYSVVCVUAUWNCBDUXCGFHIXGXHXIVUBVUFQUXNVUBCUWNUXQUWPUYAUXHUWOUWPUVIWQTY
      GYHYIUXNYTUXAUUEUUCUUFUXLUUJUUIUUKVUGUVLQUYMUYPUYOVVBUYQUYTUYSVVCVUAUWNCB
      DUXCGFHIXKXHYKVKYLVLYMYMVKYNYOYPVKYOYPVKYQYRYS $.
  $}

  $( Removing identical parts from the end of a line segment preserves
     congruence.  Theorem 4.3 of [Schwabhauser] p. 35.  (Contributed by Scott
     Fenton, 4-Oct-2013.) $)
  cgrsub $p |- ( ( N e. NN /\
         ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
         ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
         ( ( ( B Btwn <. A , C >. /\ E Btwn <. D , F >. ) /\
             ( <. A , C >. Cgr <. D , F >. /\ <. B , C >. Cgr <. E , F >. ) )
           -> <. A , B >. Cgr <. D , E >. ) ) $=
    ( cn wcel cee w3a cop cbtwn wbr wa ccgr wb cgrcomlr syl122anc mpbid simpl21
    cfv simprl simprr simpl1 simpl31 cgrtriv syl3anc simprrl simpl23 simpl33 wi
    jca simpl22 simpl32 cifs brifs ifscgr sylbird syl333anc mp3and ex ) GHIZAGJ
    UBZIZBVDIZCVDIZKZDVDIZEVDIZFVDIZKZKZBACLZMNEDFLZMNOZVNVOPNZBCLEFLPNZOZOZABL
    ZDELZPNZVMVTOZBALEDLPNZWCWDVPVSAALDDLPNZCALZFDLZPNZOZWEVMVPVSUCVMVPVSUDWDWF
    WIWDVCVEVIWFVCVHVLVTUEZVEVFVGVCVLVTUAZVIVJVKVCVHVTUFZADGUGUHWDVQWIVMVPVQVRU
    IWDVCVEVGVIVKVQWIQWKWLVEVFVGVCVLVTUJZWMVIVJVKVCVHVTUKZACDFGRSTUMWDVCVEVFVGV
    EVIVJVKVIVPVSWJKZWEULWKWLVEVFVGVCVLVTUNZWNWLWMVIVJVKVCVHVTUOZWOWMVCVEVFKVGV
    EVIKVJVKVIKKWPWAWGLWBWHLUPNWEABCADEFDGUQABCADEFDGURUSUTVAWDVCVFVEVJVIWEWCQW
    KWQWLWRWMBAEDGRSTVB $.

  ${
    $d A a b c d e f n p q $.  $d B a b c d e f n p q $.
    $d C a b c d e f n p q $.  $d D a b c d e f n p q $.
    $d E a b c d e f n p q $.  $d F a b c d e f n p q $.
    $d N a b c d e f n p q $.
    $( Binary relationship form of the three-place congruence predicate.
       (Contributed by Scott Fenton, 4-Oct-2013.) $)
    brcgr3 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         ( <. A , B >. Cgr <. D , E >. /\ <. A , C >. Cgr <. D , F >. /\
           <. B , C >. Cgr <. E , F >. ) ) ) $=
      ( va vb vd cv cop ccgr wbr w3a wceq opeq1 breq1d opeq2 breq2d ve vc vf vn
      vq vp cee cfv ccgr3 cn 3anbi12d 3anbi13d 3anbi23d fveq2 df-cgr3 br6 ) HKZ
      IKZLZJKZUAKZLZMNZUQUBKZLZUTUCKZLZMNZURVDLZVAVFLZMNZOAURLZVBMNZAVDLZVGMNZV
      KOABLZVBMNZVOBVDLZVJMNZOVQACLZVGMNZBCLZVJMNZOVPDVALZMNZVTDVFLZMNZWCOVPDEL
      ZMNZWGWBEVFLZMNZOWIVTDFLZMNZWBEFLZMNZOUDABCDUDKZUGUHGUGUHUIUJUAUCEFGUEUFH
      IUBJUQAPZVCVMVHVOVKWQUSVLVBMUQAURQRWQVEVNVGMUQAVDQRUKURBPZVMVQVKVSVOWRVLV
      PVBMURBASRWRVIVRVJMURBVDQRULVDCPZVOWAVSWCVQWSVNVTVGMVDCASRWSVRWBVJMVDCBSR
      UMUTDPZVQWEWAWGWCWTVBWDVPMUTDVAQTWTVGWFVTMUTDVFQTUKVAEPZWEWIWCWKWGXAWDWHV
      PMVAEDSTXAVJWJWBMVAEVFQTULVFFPZWGWMWKWOWIXBWFWLVTMVFFDSTXBWJWNWBMVFFESTUM
      WPGUGUNUAUCUDUEUFHIUBJUOUP $.
  $}

  $( Permutation law for three-place congruence.  (Contributed by Scott Fenton,
     5-Oct-2013.) $)
  cgr3permute3 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         <. B , <. C , A >. >. Cgr3 <. E , <. F , D >. >. ) ) $=
    ( wcel w3a cop ccgr wbr ccgr3 wa wb 3simpa cgrcomlr syl3an 3simpb 3anrot cn
    cee cfv id 3anbi12d syl6bbr brcgr3 biid syl3anb 3bitr4d ) GUAHZAGUBUCZHZBUL
    HZCULHZIZDULHZEULHZFULHZIZIZABJDEJKLZACJDFJKLZBCJZEFJZKLZIZVFBAJEDJKLZCAJZF
    DJZKLZIZAVDJDVEJMLBVIJEVJJMLZVAVGVHVKVFIVLVAVBVHVCVKVFUKUKUPUMUNNUTUQURNVBV
    HOUKUDZUMUNUOPUQURUSPABDEGQRUKUKUPUMUONUTUQUSNVCVKOVNUMUNUOSUQURUSSACDFGQRU
    EVFVHVKTUFABCDEFGUGUKUKUPUNUOUMIUTURUSUQIVMVLOUKUHUMUNUOTUQURUSTBCAEFDGUGUI
    UJ $.

  $( Permutation law for three-place congruence.  (Contributed by Scott Fenton,
     5-Oct-2013.) $)
  cgr3permute1 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         <. A , <. C , B >. >. Cgr3 <. D , <. F , E >. >. ) ) $=
    ( cn wcel cee w3a cop ccgr wbr ccgr3 wa wb 3simpc brcgr3 3ancomb cfv syl3an
    id cgrcomlr 3anbi3d 3ancoma syl6bb biid syl3anb 3bitr4d ) GHIZAGJUAZIZBULIZ
    CULIZKZDULIZEULIZFULIZKZKZABLDELMNZACLDFLMNZBCLZEFLZMNZKZVCVBCBLZFELZMNZKZA
    VDLDVELONAVHLDVILONZVAVGVBVCVJKVKVAVFVJVBVCUKUKUPUNUOPUTURUSPVFVJQUKUCUMUNU
    ORUQURUSRBCEFGUDUBUEVBVCVJUFUGABCDEFGSUKUKUPUMUOUNKUTUQUSURKVLVKQUKUHUMUNUO
    TUQURUSTACBDFEGSUIUJ $.

  $( Permutation law for three-place congruence.  (Contributed by Scott Fenton,
     5-Oct-2013.) $)
  cgr3permute2 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         <. B , <. A , C >. >. Cgr3 <. E , <. D , F >. >. ) ) $=
    ( cn wcel cee cfv w3a cop ccgr3 wbr cgr3permute3 biid 3anrot cgr3permute1
    wb syl3anb bitrd ) GHIZAGJKZIZBUDIZCUDIZLZDUDIZEUDIZFUDIZLZLABCMMDEFMMNOBCA
    MMEFDMMNOZBACMMEDFMMNOZABCDEFGPUCUCUHUFUGUELULUJUKUILUMUNTUCQUEUFUGRUIUJUKR
    BCAEFDGSUAUB $.

  $( Permutation law for three-place congruence.  (Contributed by Scott Fenton,
     5-Oct-2013.) $)
  cgr3permute4 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         <. C , <. A , B >. >. Cgr3 <. F , <. D , E >. >. ) ) $=
    ( cn wcel cee cfv w3a cop ccgr3 wbr cgr3permute3 wb biid 3anrot syl3anb
    bitrd ) GHIZAGJKZIZBUCIZCUCIZLZDUCIZEUCIZFUCIZLZLABCMMDEFMMNOBCAMMEFDMMNOZC
    ABMMFDEMMNOZABCDEFGPUBUBUGUEUFUDLUKUIUJUHLULUMQUBRUDUEUFSUHUIUJSBCAEFDGPTUA
    $.

  $( Permutation law for three-place congruence.  (Contributed by Scott Fenton,
     5-Oct-2013.) $)
  cgr3permute5 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         <. C , <. B , A >. >. Cgr3 <. F , <. E , D >. >. ) ) $=
    ( cn wcel cee cfv w3a cop ccgr3 wbr cgr3permute3 biid 3anrot cgr3permute2
    wb syl3anb bitrd ) GHIZAGJKZIZBUDIZCUDIZLZDUDIZEUDIZFUDIZLZLABCMMDEFMMNOBCA
    MMEFDMMNOZCBAMMFEDMMNOZABCDEFGPUCUCUHUFUGUELULUJUKUILUMUNTUCQUEUFUGRUIUJUKR
    BCAEFDGSUAUB $.

  $( Transitivity law for three-place congruence.  (Contributed by Scott
     Fenton, 5-Oct-2013.) $)
  cgr3tr4 $p |- ( ( N e. NN /\
    ( ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
      ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) /\
      ( G e. ( EE ` N ) /\ H e. ( EE ` N ) /\ I e. ( EE ` N ) ) ) ) ->
    ( ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. /\
        <. A , <. B , C >. >. Cgr3 <. G , <. H , I >. >. ) ->
      <. D , <. E , F >. >. Cgr3 <. G , <. H , I >. >. ) ) $=
    ( wcel w3a wa cop ccgr wbr ccgr3 wi axcgrtr syl133anc cn cee cfv 3an6 simpl
    simpr11 simpr12 simpr21 simpr22 simpr31 simpr32 simpr13 3anim123d wb brcgr3
    simpr23 simpr33 syl5bir 3adant3r3 3adant3r2 anbi12d 3adant3r1 3imtr4d ) JUA
    KZAJUBUCZKZBVEKZCVEKZLZDVEKZEVEKZFVEKZLZGVEKZHVEKZIVEKZLZLZMZABNZDENZOPZACN
    ZDFNZOPZBCNZEFNZOPZLZVTGHNZOPZWCGINZOPZWFHINZOPZLZMZWAWJOPZWDWLOPZWGWNOPZLZ
    AWFNZDWGNZQPZXBGWNNZQPZMXCXEQPZWQWBWKMZWEWMMZWHWOMZLVSXAWBWKWEWMWHWOUDVSXHW
    RXIWSXJWTVSVDVFVGVJVKVNVOXHWRRVDVRUEZVFVGVHVMVQVDUFZVFVGVHVMVQVDUGZVJVKVLVI
    VQVDUHZVJVKVLVIVQVDUIZVNVOVPVIVMVDUJZVNVOVPVIVMVDUKZABDEGHJSTVSVDVFVHVJVLVN
    VPXIWSRXKXLVFVGVHVMVQVDULZXNVJVKVLVIVQVDUPZXPVNVOVPVIVMVDUQZACDFGIJSTVSVDVG
    VHVKVLVOVPXJWTRXKXMXRXOXSXQXTBCEFHIJSTUMURVSXDWIXFWPVDVIVMXDWIUNVQABCDEFJUO
    USVDVIVQXFWPUNVMABCGHIJUOUTVAVDVMVQXGXAUNVIDEFGHIJUOVBVC $.

  $( Commutativity law for three-place congruence.  (Contributed by Scott
     Fenton, 5-Oct-2013.) $)
  cgr3com $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. <->
         <. D , <. E , F >. >. Cgr3 <. A , <. B , C >. >. ) ) $=
    ( wcel w3a cop ccgr wbr ccgr3 wa wb 3simpa cgrcom syl3an 3simpb 3simpc cee
    cn cfv id 3anbi123d brcgr3 3com23 3bitr4d ) GUBHZAGUAUCZHZBUJHZCUJHZIZDUJHZ
    EUJHZFUJHZIZIZABJZDEJZKLZACJZDFJZKLZBCJZEFJZKLZIVAUTKLZVDVCKLZVGVFKLZIZAVFJ
    ZDVGJZMLVNVMMLZUSVBVIVEVJVHVKUIUIUNUKULNURUOUPNVBVIOUIUDZUKULUMPUOUPUQPABDE
    GQRUIUIUNUKUMNURUOUQNVEVJOVPUKULUMSUOUPUQSACDFGQRUIUIUNULUMNURUPUQNVHVKOVPU
    KULUMTUOUPUQTBCEFGQRUEABCDEFGUFUIURUNVOVLODEFABCGUFUGUH $.

  $( Identity law for three-place congruence.  (Contributed by Scott Fenton,
     6-Oct-2013.) $)
  cgr3rflx $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    <. A , <. B , C >. >. Cgr3 <. A , <. B , C >. >. ) $=
    ( cn wcel cee cfv w3a wa cop wbr ccgr cgrrflx 3adant3r3 3adant3r2 3adant3r1
    ccgr3 wb brcgr3 3anidm23 mpbir3and ) DEFZADGHZFZBUDFZCUDFZIZJABCKZKZUJRLZAB
    KZULMLZACKZUNMLZUIUIMLZUCUEUFUMUGABDNOUCUEUGUOUFACDNPUCUFUGUPUEBCDNQUCUHUKU
    MUOUPISABCABCDTUAUB $.

  ${
    $d A e f g $.  $d B e f g $.  $d C e f g $.  $d D e f g $.  $d F e f g $.
    $d N e f g $.
    $( A line segment can be divided at the same place as a congruent line
       segment is divided.  Theorem 4.5 of [Schwabhauser] p. 35.  (Contributed
       by Scott Fenton, 4-Oct-2013.) $)
    cgrxfr $p |- ( ( N e. NN /\
            ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
            ( D e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
            ( ( B Btwn <. A , C >. /\ <. A , C >. Cgr <. D , F >. ) ->
              E. e e. ( EE ` N ) ( e Btwn <. D , F >. /\
               <. A , <. B , C >. >. Cgr3 <. D , <. e , F >. >. ) ) ) $=
      ( vg vf wcel w3a wa cop cbtwn wbr ccgr wrex simpl1 wi ad2antrl cn cee cfv
      ccgr3 wne simpl3r simpl3l btwndiff syl3anc simpr simpl21 simpl22 axsegcon
      cv syl122anc adantr anass simprl simprr simpl23 df-3an anbi2i bitr4i wceq
      simplrr necomd simpr1 simpr2 simpr3 btwnexchand btwnexch3and cgrextendand
      simprrl simplll simprrr jca simplrl btwncomand simpllr cgrcomand segconeq
      3jca ex syl133anc syld opeq2 breq2d breq1d anbi12d biimpa simpl btwnexch3
      syl2ani adantl wb brcgr3 mpbir3and expr syl5 exp3acom23 impr sylanb an32s
      imp mpd rexlimdva reximdva ) GUAJZAGUBUCZJZBXIJZCXIJZKZDXIJZFXIJZLZKZBACM
      ZNOZXRDFMZPOZLZEUNZXTNOZABCMZMDYCFMZMUDOZLZEXIQZXQYBLZDFHUNZMNOZDYKUEZLZH
      XIQZYIYJXHXOXNYOXHXMXPYBRXNXOXHXMYBUFXNXOXHXMYBUGFDGHUHUIYJYNYIHXIXQYKXIJ
      ZYBYNYISXQYPLZYBYNYIYQYBYNLZLZDYKYCMNOZDYCMZABMZPOZLZEXIQZYIYQUUEYRYQXHYP
      XNXJXKUUEXHXMXPYPRXQYPUJXNXOXHXMYPUGXJXKXLXHXPYPUKXJXKXLXHXPYPULEYKDABGUM
      UOUPYSUUDYHEXIYQYCXIJZYRUUDYHSZYQUUFLXQYPUUFLZLZYRUUGXQYPUUFUQUUIYRUUDYHU
      UIYRUUDLZLZYCYKIUNZMZNOZYCUULMZYEPOZLZIXIQZYHUUIUURUUJUUIXHYPUUFXKXLUURXH
      XMXPUUHRXQYPUUFURXQYPUUFUSXJXKXLXHXPUUHULXJXKXLXHXPUUHUTIYKYCBCGUMUOUPUUK
      UUQYHIXIUUIUULXIJZUUJUUQYHSZUUIUUSLZXQYPUUFUUSKZLZUUJUUTUVAXQUUHUUSLZLUVC
      XQUUHUUSUQUVBUVDXQYPUUFUUSVAVBVCUVCUUJUUQYHUVCUUJUUQLZLZUULFVDZYHUVCUVEUV
      GUVCUVEYKDUEZDUUMNOZDUULMXRPOZLZDYKFMZNOZXTXRPOZLZKZUVGUVCUVEUVPUVFUVHUVK
      UVOUVFDYKUUJYMUVCUUQYBYLYMUUDVETVFUVFUVIUVJUVCUVEYKDYCUULGXHXMXPUVBRZXQYP
      UUFUUSVGZXNXOXHXMUVBUGZXQYPUUFUUSVHZXQYPUUFUUSVIZUUJYTUVCUUQYRYTUUCURZTZU
      VCUUJUUNUUPVMZVJUVCUVEDYCUULABCGUVQUVSUVTUWAXJXKXLXHXPUVBUKZXJXKXLXHXPUVB
      ULZXJXKXLXHXPUVBUTZUVCUVEYKDYCUULGUVQUVRUVSUVTUWAUWCUWDVKUUJXSUVCUUQXSYAY
      NUUDVNTUUJUUCUVCUUQYRYTUUCUSTUVCUUJUUNUUPVOVLVPUVFUVMUVNUVCUVEDFYKGUVQUVS
      XNXOXHXMUVBUFZUVRUUJYLUVCUUQYBYLYMUUDVQTVRUVCUVEACDFGUVQUWEUWGUVSUWHUUJYA
      UVCUUQXSYAYNUUDVSZTVTVPWBWCUVCXHXNXJXLYPUUSXOUVPUVGSUVQUVSUWEUWGUVRUWAUWH
      DACYKGUULFWAWDWEXDUVCUUJUUQUVGYHSUVCUUJLZUVGUUQYHUVGUUQLYCUVLNOZYFYEPOZLZ
      UWJYHUVGUUQUWMUVGUUNUWKUUPUWLUVGUUMUVLYCNUULFYKWFWGUVGUUOYFYEPUULFYCWFWHW
      IWJUVCUUJUWMYHUVCUUJUWMLZLZYDYGUVCUWNYDUUJUVCYTUWKYDUWMUWBUWKUWLWKUVCXHYP
      XNUUFXOYTUWKLYDSUVQUVRUVSUVTUWHYKDYCFGWLUOWMXDUWOYGUUBUUAPOZYAYEYFPOZUVCU
      WNDYCABGUVQUVSUVTUWEUWFUWNUUCUVCYRYTUUCUWMVEWNVTUUJYAUVCUWMUWITUVCUWNYCFB
      CGUVQUVTUWHUWFUWGUVCUUJUWKUWLVOVTUVCYGUWPYAUWQKWOZUWNUVCXHXJXKXLXNUUFXOUW
      RUVQUWEUWFUWGUVSUVTUWHABCDYCFGWPWDUPWQVPWRWSWTXAXEWRXBXCXFXEWRXBXCXGXEWRX
      CXFXEWC $.
  $}

  ${
    $d N e $.  $d A e $.  $d B e $.  $d C e $.  $d D e $.  $d E e $.  $d F e $.
    $( A condition for extending betweenness to a new set of points based on
       congruence with another set of points.  Theorem 4.6 of [Schwabhauser]
       p. 36.  (Contributed by Scott Fenton, 4-Oct-2013.) $)
    btwnxfr $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( ( B Btwn <. A , C >. /\
           <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. ) ->
         E Btwn <. D , F >. ) ) $=
      ( ve wcel w3a cop cbtwn wbr ccgr3 wa ccgr wi imp jca simpr cn cee cv wrex
      cfv brcgr3 simp2 syl6bi simp21 simp22 simp23 simp31 simp33 cgrxfr sylan2d
      simp1 syl132anc wceq simprrl simpl1 simpl31 cgrrflxd adantr simpl2 simpl3
      simpl33 3jca cgr3tr4 wb cgr3com syl113anc simpl32 syl133anc simpr1 simpr3
      syl13anc cgrcomlrand ex sylbid syld syl2ani cifs ifscgr sylbird syl333anc
      brifs cgrid2 eqbrtrrd expr an32s rexlimdva mpd ) GUAIZAGUBUEZIZBWNIZCWNIZ
      JZDWNIZEWNIZFWNIZJZJZBACKZLMZABCKZKZDEFKZKZNMZOZEDFKZLMZXCXKOZHUCZXLLMZXG
      DXOFKZKZNMZOZHWNUDZXMXCXKYAXCXJXDXLPMZXEYAXCXJABKDEKZPMZYBXFXHPMZJYBABCDE
      FGUFYDYBYEUGUHXCWMWOWPWQWSXAXEYBOYAQWMWRXBUPWMWOWPWQXBUIWMWOWPWQXBUJWMWOW
      PWQXBUKWMWRWSWTXAULWMWRWSWTXAUMABCDHFGUNUQUORXNXTXMHWNXCXOWNIZXKXTXMQXCYF
      OZXKXTXMYGXKXTOZOZXOEXLLYGYHXOEURZYGYHXOXOKXOEKPMZYJYGYHXPXPOZXLXLPMZXQXQ
      PMZOZDXOKZYCPMZFXOKZFEKZPMZOZJZYKYGYHUUBYIYLYOUUAYIXPXPYGXKXPXSUSZUUCSYGY
      OYHYGYMYNYGDFGWMWRXBYFUTZWSWTXAWMWRYFVAZWSWTXAWMWRYFVFZVBYGXOFGUUDXCYFTZU
      UFVBSVCYGYHUUAXKYGXJXSUUAXTXEXJTXPXSTYGXJXSOZXIXRNMZUUAYGWMWRXBWSYFXAJUUH
      UUIQUUDWMWRXBYFVDWMWRXBYFVEZYGWSYFXAUUEUUGUUFVGABCDEFDXOFGVHVPYGUUIXRXINM
      ZUUAYGWMXBWSYFXAUUIUUKVIUUDUUJUUEUUGUUFDEFDXOFGVJVKYGUUKYQYMXQXHPMZJZUUAY
      GWMWSYFXAWSWTXAUUKUUMVIUUDUUEUUGUUFUUEWSWTXAWMWRYFVLZUUFDXOFDEFGUFVMYGUUM
      UUAYGUUMOYQYTYGYQYMUULVNYGUUMXOFEFGUUDUUGUUFUUNUUFYGYQYMUULVOVQSVRVSVSVTW
      ARVGVRYGWMWSYFXAYFWSYFXAWTUUBYKQUUDUUEUUGUUFUUGUUEUUGUUFUUNWMWSYFJXAYFWSJ
      YFXAWTJJUUBYPYRKYPYSKWBMYKDXOFXODXOFEGWFDXOFXODXOFEGWCWDWEVTYGWMYFYFWTYKY
      JQUUDUUGUUGUUNXOXOEGWGVPVTRUUCWHWIWJWKWLVR $.
  $}

  ${
    $d p q r n $.
    $( Colinearity is a relationship.  (Contributed by Scott Fenton,
       7-Nov-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    colinrel $p |- Rel Colinear $=
      ( vp vn vq vr ccolin wrel cv cee cfv wcel w3a cop cbtwn wbr w3o wa coprab
      cn wrex ccnv relcnv df-colinear releqi mpbir ) EFAGZBGHIZJCGZUFJDGZUFJKUE
      UGUHLMNUGUHUELMNUHUEUGLMNOPBRSCDAQZTZFUIUAEUJBACDUBUCUD $.
  $}

  ${
    $d n p $.  $d n q $.  $d n r $.  $d P n $.  $d P p $.  $d p q $.  $d P q $.
    $d p r $.  $d P r $.  $d Q n $.  $d Q p $.  $d Q q $.  $d q r $.  $d Q r $.
    $d R n $.  $d R p $.  $d R q $.  $d R r $.

    $( Alternate colinearity binary relationship.  (Contributed by Scott
       Fenton, 7-Nov-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    brcolinear2 $p |- ( ( Q e. V /\ R e. W ) ->
        ( P Colinear <. Q , R >. <-> E. n e. NN
          ( ( P e. ( EE ` n ) /\ Q e. ( EE ` n ) /\ R e. ( EE ` n ) ) /\
            ( P Btwn <. Q , R >. \/ Q Btwn <. R , P >. \/
              R Btwn <. P , Q >. ) ) ) ) $=
      ( vp vq vr wcel wa cvv cop ccolin wbr cv w3a cbtwn cn breq2d cee cfv wrex
      w3o wi colinrel brrelexi a1i elex 3ad2ant1 adantr rexlimivw wb ccnv df-br
      coprab df-colinear eleq2i bitri opex opelcnvg mpan2 3ad2ant3 syl5bb eleq1
      wceq 3anbi2d opeq1 breq1 opeq2 3orbi123d anbi12d rexbidv 3anbi3d eloprabg
      3anbi1d bitrd 3expia pm5.21ndd ) BEJZCFJZKZALJZABCMZNOZADPUAUBZJZBWFJZCWF
      JZQZAWDROZBCAMZROZCABMZROZUDZKZDSUCZWEWCUEWBAWDNUFUGUHWRWCUEWBWQWCDSWJWCW
      PWGWHWCWIAWFUIUJUKULUHVTWAWCWEWRUMVTWAWCQZWEWDAMGPZWFJZHPZWFJZIPZWFJZQZWT
      XBXDMZROZXBXDWTMZROZXDWTXBMZROZUDZKZDSUCZHIGUPZJZWRWEAWDMZXPUNZJZWSXQWEXR
      NJXTAWDNUONXSXRDGHIUQURUSWCVTXTXQUMZWAWCWDLJYABCUTAWDLLXPVAVBVCVDXOXAWHXE
      QZWTBXDMZROZBXIROZXDWTBMZROZUDZKZDSUCXAWHWIQZWTWDROZBCWTMZROZCYFROZUDZKZD
      SUCWRHIGBCAEFLXBBVFZXNYIDSYQXFYBXMYHYQXCWHXAXEXBBWFVEVGYQXHYDXJYEXLYGYQXG
      YCWTRXBBXDVHTXBBXIRVIYQXKYFXDRXBBWTVJTVKVLVMXDCVFZYIYPDSYRYBYJYHYOYRXEWIX
      AWHXDCWFVEVNYRYDYKYEYMYGYNYRYCWDWTRXDCBVJTYRXIYLBRXDCWTVHTXDCYFRVIVKVLVMW
      TAVFZYPWQDSYSYJWJYOWPYSXAWGWHWIWTAWFVEVPYSYKWKYMWMYNWOWTAWDRVIYSYLWLBRWTA
      CVJTYSYFWNCRWTABVHTVKVLVMVOVQVRVS $.
  $}

  ${
    $d A a b c n $.  $d B a b c n $.  $d C a b c n $.  $d N a b c n $.
    $( The binary relationship form of the colinearity predicate.  (Contributed
       by Scott Fenton, 5-Oct-2013.) $)
    brcolinear $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
       ( A Colinear <. B , C >. <->
         ( A Btwn <. B , C >. \/ B Btwn <. C , A >. \/
           C Btwn <. A , B >. ) ) ) $=
      ( vn cn wcel cee cfv w3a wa cop ccolin wbr cv cbtwn w3o wrex wb eleq2d
      brcolinear2 3adant1 adantl simpr rexlimivw fveq2 3anbi123d anbi1d impbid2
      wceq rspcev expr bitrd ) DFGZADHIZGZBUOGZCUOGZJZKZABCLZMNZAEOZHIZGZBVDGZC
      VDGZJZAVAPNBCALPNCABLPNQZKZEFRZVIUSVBVKSZUNUQURVLUPABCEUOUOUAUBUCUTVKVIVJ
      VIEFVHVIUDUEUNUSVIVKVJUSVIKEDFVCDUJZVHUSVIVMVEUPVFUQVGURVMVDUOAVCDHUFZTVM
      VDUOBVNTVMVDUOCVNTUGUHUKULUIUM $.
  $}

  ${
    $d a b $.  $d a c $.  $d a n $.  $d a x $.  $d b c $.  $d b n $.  $d b x $.
    $d c n $.  $d c x $.  $d n x $.
    $( The colinear predicate exists.  (Contributed by Scott Fenton,
       25-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    colinearex $p |- Colinear e. _V $=
      ( va vn vb vc vx ccolin cv cee cfv wcel cop cbtwn wbr wa cn wrex cxp xpex
      wex opelxpi w3a w3o coprab ccnv cvv df-colinear ciun nnex fvex iunex wceq
      cab 3adant1 simp1 syl2anc adantr reximi eliun sylibr eleq1 biimpar sylan2
      df-oprab exlimiv exlimivv abssi eqsstri ssexi cnvex eqeltri ) FAGZBGZHIZJ
      ZCGZVMJZDGZVMJZUAZVKVOVQKZLMVOVQVKKLMVQVKVOKLMUBZNZBOPZCDAUCZUDUEBACDUFWD
      WDBOVMVMQZVMQZUGZBOWFUHWEVMVMVMVLHUIZWHRWHRUJWDEGZVTVKKZUKZWCNZASZDSCSZEU
      LWGWCCDAEVCWNEWGWMWIWGJZCDWLWOAWCWKWJWGJZWOWCWJWFJZBOPWPWBWQBOVSWQWAVSVTW
      EJZVNWQVPVRWRVNVOVQVMVMTUMVNVPVRUNVTVKWEVMTUOUPUQBWJOWFURUSWKWOWPWIWJWGUT
      VAVBVDVEVFVGVHVIVJ $.
  $}

  ${
    $d A a $.  $d a b $.  $d A b $.  $d a c $.  $d A c $.  $d a n $.  $d A n $.
    $d B a $.  $d B b $.  $d b c $.  $d B c $.  $d b n $.  $d B n $.  $d C a $.
    $d C b $.  $d C c $.  $d c n $.  $d C n $.  $d N n $.  $d V n $.  $d W n $.
    $( If ` A ` is colinear with ` B ` and ` C ` , then ` A ` is in the same
       space as ` B ` .  (Contributed by Scott Fenton, 25-Oct-2013.)  (Revised
       by Mario Carneiro, 19-Apr-2014.) $)
    colineardim1 $p |- (
       ( N e. NN /\ ( A e. V /\ B e. ( EE ` N ) /\ C e. W ) ) ->
       ( A Colinear <. B , C >. ->
       A e. ( EE ` N ) ) ) $=
      ( va vn vb vc cop wbr cv wcel w3a cbtwn w3o wa cn breq2d ccolin wrex ccnv
      cee cfv coprab df-colinear breqi wb simpr1 opex brcnvg sylancl df-br wceq
      eleq1 3anbi2d opeq1 breq1 opeq2 3orbi123d anbi12d rexbidv 3anbi3d 3anbi1d
      eloprabg 3comr adantl simpl simp2 anim2i axdimuniq adantrrl simprrl fveq2
      cvv 3simpa eleq2d syl5ibrcom mpd syl2an exp32 syl7 rexlimdv sylbid syl5bi
      ) ABCKZUALAWGGMZHMZUDUEZNZIMZWJNZJMZWJNZOZWHWLWNKZPLZWLWNWHKZPLZWNWHWLKZP
      LZQZRZHSUBZIJGUFZUCZLZDSNZAENZBDUDUEZNZCFNZOZRZAXKNZAWGUAXGHGIJUGUHXOXHWG
      AXFLZXPXOXJWGVPNXHXQUIXIXJXLXMUJBCUKAWGEVPXFULUMXQWGAKXFNZXOXPWGAXFUNXOXR
      AWJNZBWJNZCWJNZOZAWGPLZBCAKZPLZCABKZPLZQZRZHSUBZXPXNXRYJUIZXIXLXMXJYKXEWK
      XTWOOZWHBWNKZPLZBWSPLZWNWHBKZPLZQZRZHSUBWKXTYAOZWHWGPLZBCWHKZPLZCYPPLZQZR
      ZHSUBYJIJGBCAXKFEWLBUOZXDYSHSUUGWPYLXCYRUUGWMXTWKWOWLBWJUPUQUUGWRYNWTYOXB
      YQUUGWQYMWHPWLBWNURTWLBWSPUSUUGXAYPWNPWLBWHUTTVAVBVCWNCUOZYSUUFHSUUHYLYTY
      RUUEUUHWOYAWKXTWNCWJUPVDUUHYNUUAYOUUCYQUUDUUHYMWGWHPWNCBUTTUUHWSUUBBPWNCW
      HURTWNCYPPUSVAVBVCWHAUOZUUFYIHSUUIYTYBUUEYHUUIWKXSXTYAWHAWJUPVEUUIUUAYCUU
      CYEUUDYGWHAWGPUSUUIUUBYDBPWHACUTTUUIYPYFCPWHABURTVAVBVCVFVGVHXOYIXPHSYIYB
      XOWISNZXPYBYHVIXOUUJYBXPXOXIXLRZUUJXSXTRZRZXPUUJYBRXNXLXIXJXLXMVJVKYBUULU
      UJXSXTYAVQVKUUKUUMRZDWIUOZXPUUKUUJXTUUOXSBWIDVLVMUUNXPUUOXSUUKUUJXSXTVNUU
      OXKWJADWIUDVOVRVSVTWAWBWCWDWEWFWEWF $.
  $}

  $( Permutation law for colinearity.  Part of theorem 4.11 of [Schwabhauser]
     p. 36.  (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colinearperm1 $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Colinear <. B , C >. <-> A Colinear <. C , B >. ) ) $=
    ( cn wcel cee cfv w3a wa cop cbtwn wbr w3o ccolin btwncom wb 3anrot sylan2b
    brcolinear sylan2br 3orbi123d 3orcomb syl6bb 3ancomb 3bitr4d ) DEFZADGHZFZB
    UHFZCUHFZIZJZABCKZLMZBCAKLMZCABKLMZNZACBKZLMZCBAKLMZBACKLMZNZAUNOMAUSOMZUMU
    RUTVBVANVCUMUOUTUPVBUQVAABCDPULUGUJUKUIIUPVBQUIUJUKRBCADPSULUGUKUIUJIUQVAQU
    KUIUJRCABDPUAUBUTVBVAUCUDABCDTULUGUIUKUJIVDVCQUIUJUKUEACBDTSUF $.

  $( Permutation law for colinearity.  Part of theorem 4.11 of [Schwabhauser]
     p. 36.  (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colinearperm3 $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Colinear <. B , C >. <-> B Colinear <. C , A >. ) ) $=
    ( cn wcel cee cfv w3a cop cbtwn wbr w3o ccolin 3orrot a1i brcolinear 3anrot
    wa wb sylan2b 3bitr4d ) DEFZADGHZFZBUDFZCUDFZIZSZABCJZKLZBCAJZKLZCABJKLZMZU
    MUNUKMZAUJNLBULNLZUOUPTUIUKUMUNOPABCDQUHUCUFUGUEIUQUPTUEUFUGRBCADQUAUB $.

  $( Permutation law for colinearity.  Part of theorem 4.11 of [Schwabhauser]
     p. 36.  (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colinearperm2 $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Colinear <. B , C >. <-> B Colinear <. A , C >. ) ) $=
    ( cn wcel cee cfv w3a wa cop ccolin wbr colinearperm3 colinearperm1 sylan2b
    wb 3anrot bitrd ) DEFZADGHZFZBUAFZCUAFZIZJABCKLMBCAKLMZBACKLMZABCDNUETUCUDU
    BIUFUGQUBUCUDRBCADOPS $.

  $( Permutation law for colinearity.  Part of theorem 4.11 of [Schwabhauser]
     p. 36.  (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colinearperm4 $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Colinear <. B , C >. <-> C Colinear <. A , B >. ) ) $=
    ( cn wcel cee cfv w3a wa cop ccolin wbr colinearperm3 3anrot sylan2b bitrd
    wb ) DEFZADGHZFZBTFZCTFZIZJABCKLMBCAKLMZCABKLMZABCDNUDSUBUCUAIUEUFRUAUBUCOB
    CADNPQ $.

  $( Permutation law for colinearity.  Part of theorem 4.11 of [Schwabhauser]
     p. 36.  (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colinearperm5 $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Colinear <. B , C >. <-> C Colinear <. B , A >. ) ) $=
    ( cn wcel cee cfv w3a wa cop ccolin colinearperm4 wb colinearperm1 sylan2br
    wbr 3anrot bitrd ) DEFZADGHZFZBUAFZCUAFZIZJABCKLQCABKLQZCBAKLQZABCDMUETUDUB
    UCIUFUGNUDUBUCRCABDOPS $.

  $( Trivial case of colinearity.  Theorem 4.12 of [Schwabhauser] p. 37.
     (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colineartriv1 $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
    A Colinear <. A , B >. ) $=
    ( cn wcel cee cfv w3a cop ccolin wbr cbtwn w3o btwntriv1 3mix1d simp1 simp2
    wb simp3 brcolinear syl13anc mpbird ) CDEZACFGZEZBUDEZHZAABIZJKZAUHLKZABAIL
    KZBAAILKZMZUGUJUKULABCNOUGUCUEUEUFUIUMRUCUEUFPUCUEUFQZUNUCUEUFSAABCTUAUB $.

  $( Trivial case of colinearity.  (Contributed by Scott Fenton, 18-Oct-2013.)
     (Revised by Mario Carneiro, 19-Apr-2014.) $)
  colineartriv2 $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
    A Colinear <. B , B >. ) $=
    ( cn wcel cee cfv w3a cop ccolin wbr cbtwn btwntriv1 3mix2d 3com23 wb simp1
    w3o simp2 simp3 brcolinear syl13anc mpbird ) CDEZACFGZEZBUEEZHZABBIZJKZAUIL
    KZBBAILKZBABILKZRZUDUGUFUNUDUGUFHULUKUMBACMNOUHUDUFUGUGUJUNPUDUFUGQUDUFUGSU
    DUFUGTZUOABBCUAUBUC $.

  $( Betweenness implies colinearity.  (Contributed by Scott Fenton,
     7-Oct-2013.) $)
  btwncolinear1 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( C Btwn <. A , B >. -> A Colinear <. B , C >. ) ) $=
    ( cop cbtwn wbr ccolin cn wcel cee cfv w3a wa w3o 3mix3 brcolinear syl5ibr
    ) CABEFGZABCEZHGDIJADKLZJBUAJCUAJMNATFGZBCAEFGZSOSUBUCPABCDQR $.

  $( Betweenness implies colinearity.  (Contributed by Scott Fenton,
     15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  btwncolinear2 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( C Btwn <. A , B >. -> A Colinear <. C , B >. ) ) $=
    ( cn cee cfv w3a wa cop cbtwn wbr ccolin btwncolinear1 colinearperm1 sylibd
    wcel ) DEQADFGZQBRQCRQHICABJKLABCJMLACBJMLABCDNABCDOP $.

  $( Betweenness implies colinearity.  (Contributed by Scott Fenton,
     15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  btwncolinear3 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( C Btwn <. A , B >. -> B Colinear <. A , C >. ) ) $=
    ( cn cee cfv w3a wa cop cbtwn wbr ccolin btwncolinear1 colinearperm2 sylibd
    wcel ) DEQADFGZQBRQCRQHICABJKLABCJMLBACJMLABCDNABCDOP $.

  $( Betweenness implies colinearity.  (Contributed by Scott Fenton,
     15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  btwncolinear4 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( C Btwn <. A , B >. -> B Colinear <. C , A >. ) ) $=
    ( cn cee cfv w3a wa cop cbtwn wbr ccolin btwncolinear1 colinearperm3 sylibd
    wcel ) DEQADFGZQBRQCRQHICABJKLABCJMLBCAJMLABCDNABCDOP $.

  $( Betweenness implies colinearity.  (Contributed by Scott Fenton,
     15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  btwncolinear5 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( C Btwn <. A , B >. -> C Colinear <. A , B >. ) ) $=
    ( cn cee cfv w3a wa cop cbtwn wbr ccolin btwncolinear1 colinearperm4 sylibd
    wcel ) DEQADFGZQBRQCRQHICABJZKLABCJMLCSMLABCDNABCDOP $.

  $( Betweenness implies colinearity.  (Contributed by Scott Fenton,
     15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  btwncolinear6 $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( C Btwn <. A , B >. -> C Colinear <. B , A >. ) ) $=
    ( cn cee cfv w3a wa cop cbtwn wbr ccolin btwncolinear1 colinearperm5 sylibd
    wcel ) DEQADFGZQBRQCRQHICABJKLABCJMLCBAJMLABCDNABCDOP $.

  $( Transfer law for colinearity.  Theorem 4.13 of [Schwabhauser] p. 37.
     (Contributed by Scott Fenton, 5-Oct-2013.) $)
  colinearxfr $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( ( B Colinear <. A , C >. /\
           <. A , <. B , C >. >. Cgr3 <. D , <. E , F >. >. ) ->
         E Colinear <. D , F >. ) ) $=
    ( wcel w3a cop ccolin wbr ccgr3 wi wa cbtwn btwnxfr exp3acom23 imp 3anrot
    cn cee cfv cgr3permute4 biid syl3anbr sylbid cgr3permute3 syl3anb 3orim123d
    w3o wb simp22 simp21 simp23 brcolinear syl13anc adantr simp32 simp31 simp33
    simp1 3imtr4d ex com23 imp3a ) GUAHZAGUBUCZHZBVHHZCVHHZIZDVHHZEVHHZFVHHZIZI
    ZBACJZKLZABCJJDEFJJMLZEDFJZKLZVQVTVSWBVQVTVSWBNVQVTOZBVRPLZACBJPLZCBAJPLZUK
    ZEWAPLZDFEJPLZFEDJPLZUKZVSWBWCWDWHWEWIWFWJVQVTWDWHNVQWDVTWHABCDEFGQRSVQVTWE
    WINZVQVTCABJJFDEJJMLZWLABCDEFGUDVQWEWMWIVGVGVLVKVIVJIVPVOVMVNIWEWMOWINVGUEZ
    VKVIVJTVOVMVNTCABFDEGQUFRUGSVQVTWFWJNZVQVTBCAJJEFDJJMLZWOABCDEFGUHVQWFWPWJV
    GVGVLVJVKVIIVPVNVOVMIWFWPOWJNWNVIVJVKTVMVNVOTBCAEFDGQUIRUGSUJVQVSWGULZVTVQV
    GVJVIVKWQVGVLVPVBZVGVIVJVKVPUMVGVIVJVKVPUNVGVIVJVKVPUOBACGUPUQURVQWBWKULZVT
    VQVGVNVMVOWSWRVGVLVMVNVOUSVGVLVMVNVOUTVGVLVMVNVOVAEDFGUPUQURVCVDVEVF $.

  ${
    $d N f $.  $d A f $.  $d B f $.  $d C f $.  $d D f $.  $d E f $.
    $( Extend a line with a missing point.  Theorem 4.14 of [Schwabhauser]
       p. 37.  (Contributed by Scott Fenton, 6-Oct-2013.) $)
    lineext $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) ->
       ( ( A Colinear <. B , C >. /\ <. A , B >. Cgr <. D , E >. ) ->
         E. f e. ( EE ` N )
            <. A , <. B , C >. >. Cgr3 <. D , <. E , f >. >. ) ) $=
      ( wcel w3a wa cop wbr ccgr cbtwn wrex wb wi 3jca adantr anbi2d cn cee cfv
      ccolin w3o ccgr3 brcolinear 3adant3 anbi1d simp1 simp3r simp3l jca simp21
      cv simp23 axsegcon syl simprlr simprrr an4 simpl1 simpl21 simpl22 simpl3l
      simpl3r cgrcomlr syl122anc simpl23 cgrextend syl133anc sylbid syl5bi expr
      simpr imp cgrcom simpl2 brcgr3 syl113anc 3imtr4d an32s reximdva mpd exp32
      3ancoma btwncom simp3 simp22 syl112anc simpll simplr adantl sylcom syl5bb
      sylan2b ex expdimp sylbird cgrxfr cgr3permute1 biimprd adantld syld exp3a
      syl131anc 3jaod imp3a ) GUAHZAGUBUCZHZBXJHZCXJHZIZDXJHZFXJHZJZIZABCKZUDLZ
      ABKZDFKZMLZJAXSNLZBCAKNLZCYANLZUEZYCJAXSKDFEUOZKZKUFLZEXJOZXRXTYGYCXIXNXT
      YGPXQABCGUGUHUIXRYGYCYKXRYDYCYKQZYEYFXRYDYCYKXRYDYCJZJZDYINLZDYHKZACKZMLZ
      JZEXJOZYKYNXIXPXOJZXKXMJZIZYTXRUUCYMXRXIUUAUUBXIXNXQUJZXRXPXOXIXNXOXPUKXI
      XNXOXPULUMXRXKXMXIXKXLXMXQUNZXIXKXLXMXQUPZUMRSEFDACGUQURYNYSYJEXJXRYHXJHZ
      YMYSYJQXRUUGJZYMJYOYQYPMLZJZYCUUIXSYIMLZIZYSYJUUHYMUUJUULUUHYMUUJJZJYCUUI
      UUKUUHYDYCUUJUSUUHYMYOUUIUTUUHUUMUUKUUMYDYOJZYCUUIJZJZUUHUUKYDYCYOUUIVAUU
      HUUPUUNBAKFDKMLZUUIJZJZUUKUUHUUOUURUUNUUHYCUUQUUIUUHXIXKXLXOXPYCUUQPXIXNX
      QUUGVBZXKXLXMXIXQUUGVCZXKXLXMXIXQUUGVDZXOXPXIXNUUGVEZXOXPXIXNUUGVFZABDFGV
      GVHUITUUHXIXLXKXMXPXOUUGUUSUUKQUUTUVBUVAXKXLXMXIXQUUGVIZUVDUVCXRUUGVOZBAC
      FDYHGVJVKVLVMVPRVNUUHYSUUJPYMUUHYRUUIYOUUHXIXOUUGXKXMYRUUIPUUTUVCUVFUVAUV
      EDYHACGVQVHTSUUHYJUULPZYMUUHXIXNXOXPUUGUVGUUTXIXNXQUUGVRZUVCUVDUVFABCDFYH
      GVSVTZSWAWBWCWDWEXRYEBYQNLZYLXIXNUVJYEPZXQXNXIXLXKXMIUVKXKXLXMWFBACGWGWPU
      HXRUVJYCYKXRUVJYCJZJZFYPNLZYIXSMLZJZEXJOZYKXRUVQUVLXRXIXQXLXMUVQUUDXIXNXQ
      WHZXIXKXLXMXQWIZUUFEDFBCGUQWJSUVMUVPYJEXJXRUUGUVLUVPYJQUUHUVLUVPYJUUHUVJU
      VNJZYCUUKJZJZUULUVLUVPJZYJUUHUWBUUIUULUUHXIXNXOXPUUGUWBUUIQUUTUVHUVCUVDUV
      FABCDFYHGVJVTUWAUUIUULQUVTUWAUUIUULUWAUUIJYCUUIUUKYCUUKUUIWKUWAUUIVOYCUUK
      UUIWLRWQWMWNUWCUVTYCUVOJZJUUHUWBUVJYCUVNUVOVAUUHUWDUWAUVTUUHUVOUUKYCUUHXI
      XPUUGXLXMUVOUUKPUUTUVDUVFUVBUVEFYHBCGVQVHTTWOUVIWAWRWBWCWDWEWSXRYFYCYKXRY
      FYCJZYHYBNLZACBKKDYHFKKUFLZJZEXJOZYKXRXIXKXMXLXQUWEUWIQUUDUUEUUFUVSUVRACB
      DEFGWTXFXRUWHYJEXJUUHUWGYJUWFUUHYJUWGUUHXIXNXOXPUUGYJUWGPUUTUVHUVCUVDUVFA
      BCDFYHGXAVTXBXCWCXDXEXGXHVL $.
  $}

  $( Change some conditions for outer five segment predicate.  (Contributed by
     Scott Fenton, 6-Oct-2013.) $)
  brofs2 $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. OuterFiveSeg
      <. <. E , F >. , <. G , H >. >. <->
      ( B Btwn <. A , C >. /\
        <. A , <. B , C >. >. Cgr3 <. E , <. F , G >. >. /\
        ( <. A , D >. Cgr <. E , H >. /\
          <. B , D >. Cgr <. F , H >. ) ) ) ) $=
    ( wcel w3a cop wbr cbtwn wa ccgr simpr1 syl133anc imp 3jca cn cee cfv ccgr3
    cofs brofs simpr1l simpr2l simpr2 jca ex simp11 simp12 simp13 simp21 simp23
    wi simp31 simp32 cgrextend syld simpr2r brcgr3 sylibrd simpr3 3simpa 3simpb
    wb btwnxfr syl5 syl6bi 3ad2antr2 impbida bitrd ) IUAJZAIUBUCZJZBVPJZKZCVPJZ
    DVPJZEVPJZKZFVPJZGVPJZHVPJZKZKZABLZCDLLEFLZGHLLUEMBACLZNMZFEGLZNMZOZWIWJPMZ
    BCLZFGLZPMZOZADLEHLPMBDLFHLPMOZKZWLAWQLEWRLUDMZXAKZABCDEFGHIUFWHXBXDWHXBOZW
    LXCXAWLWNWTXAWHUGWHXBXCWHXBWPWKWMPMZWSKZXCWHXBXGXEWPXFWSWPWSWOXAWHUHWHXBXFW
    HXBWOWTOZXFWHXBXHXEWOWTWHWOWTXAQWHWOWTXAUIUJUKWHVOVQVRVTWBWDWEXHXFUQVOVQVRW
    CWGULZVOVQVRWCWGUMZVOVQVRWCWGUNZVSVTWAWBWGUOZVSVTWAWBWGUPZVSWCWDWEWFURZVSWC
    WDWEWFUSZABCEFGIUTRVASWPWSWOXAWHVBTUKWHVOVQVRVTWBWDWEXCXGVHXIXJXKXLXMXNXOAB
    CEFGIVCRZVDSWHWOWTXAVETWHXDOZWOWTXAXQWLWNWHWLXCXAQWHXDWNXDWLXCOZWHWNWLXCXAV
    FWHVOVQVRVTWBWDWEXRWNUQXIXJXKXLXMXNXOABCEFGIVIRVJSUJWHWLXCWTXAWHXCWTWHXCXGW
    TXPWPXFWSVGVKSVLWHWLXCXAVETVMVN $.

  $( Change some conditions for inner five segment predicate.  (Contributed by
     Scott Fenton, 6-Oct-2013.) $)
  brifs2 $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. InnerFiveSeg
      <. <. E , F >. , <. G , H >. >. <->
      ( B Btwn <. A , C >. /\
        <. A , <. B , C >. >. Cgr3 <. E , <. F , G >. >. /\
        ( <. A , D >. Cgr <. E , H >. /\
          <. C , D >. Cgr <. G , H >. ) ) ) ) $=
    ( wcel w3a cop wbr cbtwn wa ccgr 3simpa syl133anc imp 3jca cn cee cfv ccgr3
    cifs brifs simpr1l wi simp11 simp12 simp13 simp21 simp23 simp31 simp32 syl5
    cgrsub simpr2l simpr2r ex wb brcgr3 sylibrd simpr3 simpr1 jca 3simpc syl6bi
    btwnxfr 3ad2antr2 impbida bitrd ) IUAJZAIUBUCZJZBVNJZKZCVNJZDVNJZEVNJZKZFVN
    JZGVNJZHVNJZKZKZABLZCDLZLEFLZGHLZLUEMBACLZNMZFEGLZNMZOZWKWMPMZBCLZFGLZPMZOZ
    ADLEHLPMWHWJPMOZKZWLAWQLEWRLUDMZXAKZABCDEFGHIUFWFXBXDWFXBOZWLXCXAWLWNWTXAWF
    UGWFXBXCWFXBWGWIPMZWPWSKZXCWFXBXGXEXFWPWSWFXBXFXBWOWTOZWFXFWOWTXAQWFVMVOVPV
    RVTWBWCXHXFUHVMVOVPWAWEUIZVMVOVPWAWEUJZVMVOVPWAWEUKZVQVRVSVTWEULZVQVRVSVTWE
    UMZVQWAWBWCWDUNZVQWAWBWCWDUOZABCEFGIUQRUPSWPWSWOXAWFURWPWSWOXAWFUSTUTWFVMVO
    VPVRVTWBWCXCXGVAXIXJXKXLXMXNXOABCEFGIVBRZVCSWFWOWTXAVDTWFXDOZWOWTXAXQWLWNWF
    WLXCXAVEWFXDWNXDWLXCOZWFWNWLXCXAQWFVMVOVPVRVTWBWCXRWNUHXIXJXKXLXMXNXOABCEFG
    IVIRUPSVFWFWLXCWTXAWFXCWTWFXCXGWTXPXFWPWSVGVHSVJWFWLXCXAVDTVKVL $.

  ${
    $d N a b c d e f g h p q n $.  $d A a b c d e f g h p q n $.
    $d B a b c d e f g h p q n $.  $d C a b c d e f g h p q n $.
    $d D a b c d e f g h p q n $.  $d E a b c d e f g h p q n $.
    $d F a b c d e f g h p q n $.  $d G a b c d e f g h p q n $.
    $d H a b c d e f g h p q n $.
    $( Binary relationship form of the general five segment predicate.
       (Contributed by Scott Fenton, 5-Oct-2013.) $)
    brfs $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
        ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
    ( <. <. A , B >. , <. C , D >. >. FiveSeg <. <. E , F >. , <. G , H >. >.
      <->
      ( A Colinear <. B , C >. /\
        <. A , <. B , C >. >. Cgr3 <. E , <. F , G >. >. /\
        ( <. A , D >. Cgr <. E , H >. /\ <. B , D >. Cgr <. F , H >. ) ) ) ) $=
      ( cv cop ccolin wbr ccgr3 ccgr wa w3a wceq opeq1 breq2d va vb vc ve vf vg
      vd vh vn vq vp cee cfv cfs cn breq1 breq1d anbi1d 3anbi123d opeq2d anbi2d
      opeq2 3anbi12d anbi12d 3anbi3d 3anbi23d 3anbi2d fveq2 df-fs br8 ) UAJZUBJ
      ZUCJZKZLMZVKVNKZUDJZUEJZUFJZKZKZNMZVKUGJZKZVQUHJZKZOMZVLWCKZVRWEKZOMZPZQA
      VNLMZAVNKZWANMZAWCKZWFOMZWJPZQABVMKZLMZAWRKZWANMZWPBWCKZWIOMZPZQABCKZLMZA
      XEKZWANMZXDQXFXHADKZWFOMZBDKZWIOMZPZQXFXGEVTKZNMZXIEWEKZOMZXLPZQXFXGEFVSK
      ZKZNMZXQXKFWEKZOMZPZQXFXGEFGKZKZNMZYDQXFYGXIEHKZOMZXKFHKZOMZPZQUIABCDUIJZ
      ULUMIULUMUNUOUDUEUFUHEFGHIUJUKUAUBUCUGVKARZVOWLWBWNWKWQVKAVNLUPYNVPWMWANV
      KAVNSUQYNWGWPWJYNWDWOWFOVKAWCSUQURUSVLBRZWLWSWNXAWQXDYOVNWRALVLBVMSZTYOWM
      WTWANYOVNWRAYPUTUQYOWJXCWPYOWHXBWIOVLBWCSUQVAUSVMCRZWSXFXAXHXDYQWRXEALVMC
      BVBZTYQWTXGWANYQWRXEAYRUTUQVCWCDRZXDXMXFXHYSWPXJXCXLYSWOXIWFOWCDAVBUQYSXB
      XKWIOWCDBVBUQVDVEVQERZXHXOXMXRXFYTWAXNXGNVQEVTSTYTXJXQXLYTWFXPXIOVQEWESTU
      RVFVRFRZXOYAXRYDXFUUAXNXTXGNUUAVTXSEVRFVSSUTTUUAXLYCXQUUAWIYBXKOVRFWESTVA
      VFVSGRZYAYGXFYDUUBXTYFXGNUUBXSYEEVSGFVBUTTVGWEHRZYDYLXFYGUUCXQYIYCYKUUCXP
      YHXIOWEHEVBTUUCYBYJXKOWEHFVBTVDVEYMIULVHUDUEUFUHUIUJUKUAUBUCUGVIVJ $.
  $}

  $( Congruence law for the general five segment configuration.  Theorem 4.16
     of [Schwabhauser] p. 37.  (Contributed by Scott Fenton, 5-Oct-2013.) $)
  fscgr $p |- ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
      ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
      ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
   ( ( <. <. A , B >. , <. C , D >. >. FiveSeg <. <. E , F >. , <. G , H >. >.
       /\ A =/= B ) -> <. C , D >. Cgr <. G , H >. ) ) $=
    ( wcel w3a cop wbr wa ccgr3 wi cbtwn wb syl333anc sylbid cn cee cfv cfs wne
    ccolin ccgr brfs anbi1d w3o simp11 simp12 simp13 simp21 brcolinear syl13anc
    cofs simp23 simp31 simp32 cgr3permute2 syl133anc a1i 3anbi23d simp22 simp33
    ancom brofs2 necom anbi12d 5segofs exp3a 3expd btwncom 3anbi1d cgr3permute1
    bitr4d cifs 3anbi2d brifs2 ifscgr a1dd 3jaod 3impd imp3a ) IUAJZAIUBUCZJZBW
    GJZKZCWGJZDWGJZEWGJZKZFWGJZGWGJZHWGJZKZKZABLZCDLZLZEFLGHLZLZUDMZABUEZNABCLZ
    UFMZAXGLEFGLLOMZADLEHLUGMZBDLZFHLZUGMZNZKZXFNXAXCUGMZWSXEXOXFABCDEFGHIUHUIW
    SXOXFXPWSXHXIXNXFXPPZWSXHAXGQMZBCALQMZCWTQMZUJZXIXNXQPPZWSWFWHWIWKXHYARWFWH
    WIWNWRUKZWFWHWIWNWRULZWFWHWIWNWRUMZWJWKWLWMWRUNZABCIUOUPWSXRYBXSXTWSXRXIXNX
    QWSXRXIXNKZXFXPWSYGXFNBALXALFELXCLUQMZBAUEZNZXPWSYGYHXFYIWSYGXRBACLZLFEGLZL
    OMZXMXJNZKZYHWSXIYMXNYNXRWSWFWHWIWKWMWOWPXIYMRYCYDYEYFWJWKWLWMWRURZWJWNWOWP
    WQUSZWJWNWOWPWQUTZABCEFGIVAVBXNYNRWSXJXMVGVCVDWSWFWIWHWKWLWOWMWPWQYHYORYCYE
    YDYFWJWKWLWMWRVEZYQYPYRWJWNWOWPWQVFZBACDFEGHIVHSVQXFYIRWSABVIVCVJWSWFWIWHWK
    WLWOWMWPWQYJXPPYCYEYDYFYSYQYPYRYTBACDFEGHIVKSTVLVMWSXSXIXNXQWSXSXIXNKZXFXPW
    SUUAXFNXBXDUQMZXFNXPWSUUAUUBXFWSUUABYKQMZXIXNKUUBWSXSUUCXIXNWSWFWIWKWHXSUUC
    RYCYEYFYDBCAIVNUPVOABCDEFGHIVHVQUIABCDEFGHIVKTVLVMWSXTXIXNXQWSXTXIXNKZXPXFW
    SUUDYKXKLYLXLLVRMZXPWSUUDXTACBLLEGFLLOMZXNKZUUEWSXIUUFXTXNWSWFWHWIWKWMWOWPX
    IUUFRYCYDYEYFYPYQYRABCEFGIVPVBVSWSWFWHWKWIWLWMWPWOWQUUEUUGRYCYDYFYEYSYPYRYQ
    YTACBDEGFHIVTSVQWSWFWHWKWIWLWMWPWOWQUUEXPPYCYDYFYEYSYPYRYQYTACBDEGFHIWASTWB
    VMWCTWDWET $.

  $( Congruence rule for lines.  Theorem 4.17 of [Schwabhauser] p. 37.
     (Contributed by Scott Fenton, 6-Oct-2013.) $)
  linecgr $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
    ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) ) ) ->
    ( ( ( A =/= B /\ A Colinear <. B , C >. ) /\
        ( <. A , P >. Cgr <. A , Q >. /\ <. B , P >. Cgr <. B , Q >. ) ) ->
      <. C , P >. Cgr <. C , Q >. ) ) $=
    ( cn wcel cee cfv w3a wa wne cop ccolin wbr ccgr ccgr3 simprlr cgr3rflx jca
    3adant3 adantr simprr 3jca simprll ex wi simp21 simp22 simp23 simp3l simp3r
    simp1 cfs brfs anbi1d fscgr sylbird syl333anc syld ) FGHZAFIJZHZBVCHZCVCHZK
    ZDVCHZEVCHZLZKZABMZABCNZOPZLZADNAENQPBDNBENQPLZLZVNAVMNZVRRPZVPKZVLLZCDNZCE
    NZQPZVKVQWAVKVQLZVTVLWEVNVSVPVKVLVNVPSVKVSVQVBVGVSVJABCFTUBUCVKVOVPUDUEVKVL
    VNVPUFUAUGVKVBVDVEVFVHVDVEVFVIWAWDUHVBVGVJUNVBVDVEVFVJUIZVBVDVEVFVJUJZVBVDV
    EVFVJUKZVBVGVHVIULWFWGWHVBVGVHVIUMVBVDVEKVFVHVDKVEVFVIKKZWAABNZWBNWJWCNUOPZ
    VLLWDWIWKVTVLABCDABCEFUPUQABCDABCEFURUSUTVA $.

  ${
    linecgrand.1 $e |- ( ph -> N e. NN ) $.
    linecgrand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    linecgrand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    linecgrand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    linecgrand.5 $e |- ( ph -> P e. ( EE ` N ) ) $.
    linecgrand.6 $e |- ( ph -> Q e. ( EE ` N ) ) $.
    linecgrand.7 $e |- ( ( ph /\ ps ) -> A =/= B ) $.
    linecgrand.8 $e |- ( ( ph /\ ps ) -> A Colinear <. B , C >. ) $.
    linecgrand.9 $e |- ( ( ph /\ ps ) -> <. A , P >. Cgr <. A , Q >. ) $.
    linecgrand.10 $e |- ( ( ph /\ ps ) -> <. B , P >. Cgr <. B , Q >. ) $.
    $( Deduction form of ~ linecgr .  (Contributed by Scott Fenton,
       14-Oct-2013.) $)
    linecgrand $p |- ( ( ph /\ ps ) -> <. C , P >. Cgr <. C , Q >. ) $=
      ( cop wcel wa wne ccolin wbr ccgr jca wi cee cfv linecgr syl132anc adantr
      cn mp2and ) ABUAZCDUBZCDESUCUDZUAZCFSCGSUEUDZDFSDGSUEUDZUAZEFSEGSUEUDZUOU
      PUQOPUFUOUSUTQRUFAURVAUAVBUGZBAHUMTCHUHUIZTDVDTEVDTFVDTGVDTVCIJKLMNCDEFGH
      UJUKULUN $.
  $}

  $( Identity law for points on lines.  Theorem 4.18 of [Schwabhauser] p. 38.
     (Contributed by Scott Fenton, 7-Oct-2013.) $)
  lineid $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( ( ( A =/= B /\ A Colinear <. B , C >. ) /\
        ( <. A , C >. Cgr <. A , D >. /\ <. B , C >. Cgr <. B , D >. ) ) ->
      C = D ) ) $=
    ( cn wcel cee cfv wa w3a wne cop ccolin wbr ccgr wceq wi simp2l simp2r 3jca
    simp3l linecgr syld3an2 simp1 simp3r cgrid2 syl13anc syld ) EFGZAEHIZGZBUKG
    ZJZCUKGZDUKGZJZKZABLABCMZNOJACMADMPOUSBDMPOJJZCCMCDMPOZCDQZUJULUMUOKUNUQUTV
    ARURULUMUOUJULUMUQSUJULUMUQTUJUNUOUPUBZUAABCCDEUCUDURUJUOUOUPVAVBRUJUNUQUEV
    CVCUJUNUOUPUFCCDEUGUHUI $.

  $( Law for finding a point inside a segment.  Theorem 4.19 of [Schwabhauser]
     p. 38.  (Contributed by Scott Fenton, 7-Oct-2013.) $)
  idinside $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
   ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
   ( ( C Btwn <. A , B >. /\ <. A , C >. Cgr <. A , D >. /\
       <. B , C >. Cgr <. B , D >. ) -> C = D ) ) $=
    ( cn wcel wa w3a cop cbtwn wbr ccgr wceq wi simp1 syl13anc opeq1 imbi1d idd
    cee simp3l simp3r cgrid2 axbtwnid syl3anc breq12d biimpcd ax-1 syl8 sylsyld
    cfv simp2l 3impd opeq2 breq2d 3anbi1d syl5ib ccolin simpr2l simpr2r simpr3l
    wne simpr1 btwncolinear1 3anim123d anim2i 3simpc adantl lineid exp3a impcom
    jca syl5 syld ex pm2.61ine ) EFGZAEUAULZGZBVSGZHZCVSGZDVSGZHZIZCABJZKLZACJZ
    ADJZMLZBCJZBDJMLZIZCDNZOZOABWFCAAJZKLZWKWMIZWOOABNZWPWFWRWKWMWOWFCCJZCDJZML
    ZWOOZWRCANZWKWMWOOZOWFVRWCWCWDXDVRWBWEPZVRWBWCWDUBZXHVRWBWCWDUCCCDEUDQWFVRW
    CVTWRXEOXGXHVRVTWAWEUMCAEUEUFXDXEWKWOXFXEXDWKWOOXEXCWKWOXEXAWIXBWJMCACRCADR
    UGSUHWOWMUIUJUKUNWTWSWNWOWTWRWHWKWMWTWQWGCKABAUOUPUQSURABVCZWFWPXIWFHZWNAWL
    USLZWKWMIZWOXJWHXKWKWKWMWMXJVRVTWAWCWHXKOXIVRWBWEVDVTWAVRWEXIUTVTWAVRWEXIVA
    WCWDVRWBXIVBABCEVEQXJWKTXJWMTVFWFXIXLWOOWFXIXLWOXIXLHZXIXKHZWKWMHZHWFWOXMXN
    XOXLXKXIXKWKWMPVGXLXOXIXKWKWMVHVIVMABCDEVJVNVKVLVOVPVQ $.

  $( If ` A ` , ` B ` , and ` C ` fall in order on a line, and ` A B ` and
     ` A C ` are congruent, then ` C = B ` .  (Contributed by Scott Fenton,
     7-Oct-2013.) $)
  endofsegid $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
    ( ( B Btwn <. A , C >. /\ <. A , C >. Cgr <. A , B >. ) ->
      C = B ) ) $=
    ( cn wcel cee cfv w3a wa cop cbtwn ccgr wceq wb simpl syl3an3br 3anidm23 wi
    wbr ccgr3 simpr1 simpr3 simpr2 cgrcom syl122anc idd axcgrrflx 3adant3r1 a1d
    biimpd 3jcad 3ancomb brcgr3 sylibrd btwnxfr sylan2d jcad 3anrot btwnswapid2
    a1i sylan2br syld ) DEFZADGHZFZBVEFZCVEFZIZJZBACKZLTZVKABKZMTZJZCVMLTZVLJZC
    BNZVJVOVPVLVJVNABCKZKACBKZKUATZVLVPVJVNVMVKMTZVNVSVTMTZIZWAVJVNWBVNWCVJVNWB
    VJVDVFVHVFVGVNWBOVDVIPVDVFVGVHUBZVDVFVGVHUCWEVDVFVGVHUDACABDUEUFUKVJVNUGVJW
    CVNVDVGVHWCVFBCDUHUIUJULVDVIWAWDOZVIVDVIVFVHVGIZWFVFVHVGUMZABCACBDUNQRUOVDV
    IVLWAJVPSZVIVDVIWGWIWHABCACBDUPQRUQVOVLSVJVLVNPVAURVIVDVHVFVGIVQVRSVHVFVGUS
    CABDUTVBVC $.

  ${
    endofsegidand.1 $e |- ( ph -> N e. NN ) $.
    endofsegidand.2 $e |- ( ph -> A e. ( EE ` N ) ) $.
    endofsegidand.3 $e |- ( ph -> B e. ( EE ` N ) ) $.
    endofsegidand.4 $e |- ( ph -> C e. ( EE ` N ) ) $.
    endofsegidand.5 $e |- ( ( ph /\ ps ) -> C Btwn <. A , B >. ) $.
    endofsegidand.6 $e |- ( ( ph /\ ps ) -> <. A , B >. Cgr <. A , C >. ) $.
    $( Deduction form of ~ endofsegid .  (Contributed by Scott Fenton,
       15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    endofsegidand $p |- ( ( ph /\ ps ) -> B = C ) $=
      ( wa cop cbtwn wbr ccgr wceq wi wcel cn endofsegid syl13anc adantr mp2and
      cee cfv ) ABMECDNZOPZUHCENQPZDERZKLAUIUJMUKSZBAFUATCFUFUGZTEUMTDUMTULGHJI
      CEDFUBUCUDUE $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Connectivity of betweenness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Lemma for ~ btwnconn1 .  The next several lemmas introduce various
     properties of hypothetical points that end up eliminating alternatives to
     connectivity.  We begin by showing a congruence property of those
     hypothetical points.  (Contributed by Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem1 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ X e. ( EE ` N ) ) ) /\
         ( ( ( A =/= B /\ B =/= C ) /\
             ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
           ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
             ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
           ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
             ( d Btwn <. A , X >. /\ <. d , X >. Cgr <. D , B >. ) ) ) ) ->
     <. B , c >. Cgr <. X , C >. ) $=
    ( wcel w3a cv wne wa cop cbtwn wbr ccgr adantl btwnexch3and cee cfv simp1rr
    cn simp11 simp13 simp22 simp23 simp33 simp31 simp21 simp2ll simp2rl simp3rl
    simp12 btwncomand simp3rr cgrcomand simp2lr simp2rr cgrcomland cgrextendand
    cgrcomlrand cgrtr3and ) EUDJZAEUAUBZJZBVFJZKZCVFJZDVFJZHLZVFJZKZILZVFJZGLZV
    FJZFVFJZKZKZABMBCMNZBACOPQZBADOPQZNNZDAVLOPQZDVLOCDOZRQZNZCAVOOPQZCVOOWGRQZ
    NZNZVLAVQOPQVLVQOCBORQNZVOAFOPQZVOFODBORQZNNZKZBDVLFVOCEVEVGVHVNVTUEZVEVGVH
    VNVTUFZVIVJVKVMVTUGZVIVJVKVMVTUHZVIVNVPVRVSUIZVIVNVPVRVSUJZVIVJVKVMVTUKZWAW
    RABDVLEWSVEVGVHVNVTUOZWTXAXBWRWDWAWCWDWBWMWQUCSWRWFWAWFWHWLWEWQULSTWAWRVOCF
    EWSXDXEXCWAWRACVOFEWSXFXEXDXCWRWJWAWJWKWIWEWQUMSWRWOWAWOWPWNWEWMUNSTUPWAWRD
    BVOFEWSXAWTXDXCWAWRVOFDBEWSXDXCXAWTWRWPWAWOWPWNWEWMUQSURVCWAWRDVLVOCCDEWSXA
    XBXDXEXEXAWRWHWAWFWHWLWEWQUSSWAWRCVOCDEWSXEXDXEXAWRWKWAWJWKWIWEWQUTSVAVDVB
    $.

  $( Lemma for ~ btwnconn1 .  Now, we show that two of the hypotheticals we
     introduced in the first lemma are identical.  (Contributed by Scott
     Fenton, 8-Oct-2013.) $)
  btwnconn1lem2 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ X e. ( EE ` N ) ) ) /\
         ( ( ( A =/= B /\ B =/= C ) /\
             ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
           ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
             ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
           ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
             ( d Btwn <. A , X >. /\ <. d , X >. Cgr <. D , B >. ) ) ) ) ->
     X = b ) $=
    ( wcel w3a cv wa cop cbtwn wbr ccgr adantl jca adantr cn cee cfv wne simp11
    simp1ll simp12 simp13 simp21 simp33 simp1rl simp2rl simp3rl simp31 btwnexch
    wi syl122anc mpd btwnexchand cgrrflx2d simp23 simp32 simp1rr simp2ll simp22
    simp3ll btwnexch3and btwncomand btwnconn1lem1 simp3lr cgrextendand segconeq
    wceq syl133anc mp3and ) EUAJZAEUBUCZJZBVQJZKZCVQJZDVQJZHLZVQJZKZILZVQJZGLZV
    QJZFVQJZKZKZABUDZBCUDZMZBACNOPZBADNOPZMZMZDAWCNZOPZDWCNCDNZQPZMZCAWFNOPZCWF
    NXBQPZMZMZWCAWHNZOPZWCWHNCBNQPZMZWFAFNZOPZWFFNDBNQPZMZMZKZMZWMBXMOPZBFNFBNZ
    QPZMZBXIOPZBWHNYAQPZMZFWHVMZXRWMWLWMWNWRXHXQUFRXSXTYBWLXRABCFEVPVRVSWEWKUEZ
    VPVRVSWEWKUGZVPVRVSWEWKUHZVTWAWBWDWKUIZVTWEWGWIWJUJZXRWPWLWPWQWOXHXQUKRZXSX
    EXNMZCXMOPZXRYNWLXRXEXNXEXFXDWSXQULXNXOXLWSXHUMSRWLYNYOUPZXRWLVPVRWAWGWJYPY
    HYIYKVTWEWGWIWJUNYLACWFFEUOUQTURZUSWLYBXRWLBFEYHYJYLUTTSXSYDYEWLXRABWCWHEYH
    YIYJVTWAWBWDWKVAZVTWEWGWIWJVBZXSWQXAMZBWTOPZXRYTWLXRWQXAWPWQWOXHXQVCXAXCXGW
    SXQVDSRWLYTUUAUPZXRWLVPVRVSWBWDUUBYHYIYJVTWAWBWDWKVEYRABDWCEUOUQTURZXRXJWLX
    JXKXPWSXHVFRZUSWLXRBWCWHFCBEYHYJYRYSYLYKYJWLXRABWCWHEYHYIYJYRYSUUCUUDVGWLXR
    CBFEYHYKYJYLWLXRABCFEYHYIYJYKYLYMYQVGVHABCDEFGHIVIXRXKWLXJXKXPWSXHVJRVKSWLW
    MYCYFKYGUPZXRWLVPVSWJVSVRWJWIUUEYHYJYLYJYIYLYSBFBAEFWHVLVNTVO $.

  $( Lemma for ~ btwnconn1 .  Establish the next congruence in the series.
     (Contributed by Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem3 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) ) ) /\
         ( ( ( A =/= B /\ B =/= C ) /\
             ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
           ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
             ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
           ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
             ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) ) ->
     <. B , d >. Cgr <. b , D >. ) $=
    ( wcel w3a cv wa cop cbtwn wbr ccgr adantl syl122anc adantr wb cn simp11 wi
    cee cfv simp13 simp21 simp3l simp3r simp23 simp22 simp1rl simp2rl btwnexch3
    wne jca simp12 mpd simp2ll simp3ll btwncomand simp3lr cgrcomlr cgrcom bitrd
    mpbid simp2rr simp2lr cgrcomland cgrtr3and cgrextendand ) EUAIZAEUDUEZIZBVM
    IZJZCVMIZDVMIZGKZVMIZJZHKZVMIZFKZVMIZLZJZABUOBCUOLZBACMNOZBADMNOZLLZDAVSMNO
    ZDVSMCDMZPOZLZCAWBMNOZCWBMWMPOZLZLZVSAWDMZNOZVSWDMCBMPOZLWBWTNOWBWDMDBMPOLZ
    LZJZBCWBWDVSDEVLVNVOWAWFUBZVLVNVOWAWFUFZVPVQVRVTWFUGZVPWAWCWEUHZVPWAWCWEUIZ
    VPVQVRVTWFUJZVPVQVRVTWFUKZWGXELZWIWPLZCBWBMNOZXEXNWGXEWIWPWIWJWHWSXDULWPWQW
    OWKXDUMUPQWGXNXOUCZXEWGVLVNVOVQWCXPXFVLVNVOWAWFUQZXGXHXIABCWBEUNRSURWGXEVSD
    WDEXFXKXLXJXMWLXALZVSDWDMNOZXEXRWGXEWLXAWLWNWRWKXDUSXAXBXCWKWSUTUPQWGXRXSUC
    ZXEWGVLVNVRVTWEXTXFXQXLXKXJADVSWDEUNRSURVAXMXBBCMZWDVSMZPOZXEXBWGXAXBXCWKWS
    VBQWGXBYCTXEWGXBYBYAPOZYCWGVLVTWEVQVOXBYDTXFXKXJXHXGVSWDCBEVCRWGVLWEVTVOVQY
    DYCTXFXJXKXGXHWDVSBCEVDRVESVFWGXECWBVSDCDEXFXHXIXKXLXHXLXEWQWGWPWQWOWKXDVGQ
    WGXEDVSCDEXFXLXKXHXLXEWNWGWLWNWRWKXDVHQVIVJVK $.

  $( Lemma for ~ btwnconn1 .  Assuming ` C =/= c ` , we now attempt to force
     ` D = d ` from here out via a series of congruences.  (Contributed by
     Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem4 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) ) ) /\
         ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
             ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
           ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
             ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
           ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
             ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) ) ->
     <. d , c >. Cgr <. D , C >. ) $=
    ( wcel w3a cv wa wne cop cbtwn wbr ccgr adantl adantr wb cn cee cfv simp1rl
    ccgr3 simp2rl jca wi simp11 simp12 simp13 simp21 simp3l btwnexch3 syl122anc
    mpd simp3lr simp23 simp3r cgrcomlr cgrcom bitrd 3simpa anim1i btwnconn1lem3
    mpbid syl3anr1 simp22 simp2rr simp2lr cgrcomland cgrtr3and brcgr3 syl133anc
    mpbir3and simpl 3jca 3anim3i 3anim1i btwnconn1lem1 syl2an cgrrflx2d simp1l2
    simpr cofs brofs2 anbi1d 5segofs sylbird syl333anc mp2and ) EUAIZAEUBUCZIZB
    WMIZJZCWMIZDWMIZGKZWMIZJZHKZWMIZFKZWMIZLZJZABMZBCMZCWSMZJZBACNOPZBADNOPZLZL
    ZDAWSNOPZDWSNCDNZQPZLZCAXBNOPZCXBNZXQQPZLZLZWSAXDNZOPZWSXDNCBNQPZLXBYEOPXBX
    DNDBNQPLZLZJZLZCBXBNZOPZBYANXDWSDNZNUEPZBWSNXDCNQPZCWSNWSCNQPZLZJZXIXBWSNZD
    CNZQPZYKYMYOYRYKXLXTLZYMYJUUCXGYJXLXTXLXMXKYDYIUDXTYBXSXOYIUFUGRXGUUCYMUHZY
    JXGWLWNWOWQXCUUDWLWNWOXAXFUIZWLWNWOXAXFUJWLWNWOXAXFUKZWPWQWRWTXFULZWPXAXCXE
    UMZABCXBEUNUOSUPYKYOBCNZXDWSNZQPZYLXDDNQPZYAYNQPZYKYGUUKYJYGXGYFYGYHXOYDUQR
    XGYGUUKTYJXGYGUUJUUIQPZUUKXGWLWTXEWQWOYGUUNTUUEWPWQWRWTXFURZWPXAXCXEUSZUUGU
    UFWSXDCBEUTUOXGWLXEWTWOWQUUNUUKTUUEUUPUUOUUFUUGXDWSBCEVAUOVBSVFXOXHXILZXNLZ
    XGYDYIUULXKUUQXNXHXIXJVCVDZABCDEFGHVEVGXGYJCXBWSDCDEUUEUUGUUHUUOWPWQWRWTXFV
    HZUUGUUTYJYBXGXTYBXSXOYIVIRXGYJDWSCDEUUEUUTUUOUUGUUTYJXRXGXPXRYCXOYIVJRVKVL
    XGYOUUKUULUUMJTZYJXGWLWOWQXCXEWTWRUVAUUEUUFUUGUUHUUPUUOUUTBCXBXDWSDEVMVNSVO
    YKYPYQXGWPXAXCXEXEJZJUURYDYIJYPYJXFUVBWPXAXFXCXEXEXCXEVPXCXEWDZUVCVQVRXOUUR
    YDYIUUSVSABCDEXDFGHVTWAXGYQYJXGCWSEUUEUUGUUOWBSUGVQYJXIXGXHXIXJXNYDYIWCRXGY
    SXILZUUBUHZYJXGWLWOWQXCWTXEWTWRWQUVEUUEUUFUUGUUHUUOUUPUUOUUTUUGWLWOWQJXCWTX
    EJWTWRWQJJZUVDUUIYTNUUJUUANWEPZXILUUBUVFUVGYSXIBCXBWSXDWSDCEWFWGBCXBWSXDWSD
    CEWHWIWJSWK $.

  $( Lemma for ~ btwnconn1 .  Now, we introduce ` E ` , the intersection of
     ` C c ` and ` D d ` .  We begin by showing that it is the midpoint of
     ` C ` and ` c ` (Contributed by Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem5 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) ) ) ->
         <. E , C >. Cgr <. E , c >. ) $=
    ( wcel w3a cv wne cop cbtwn wbr wa ccgr adantr wb cn cee cfv simprrr simp11
    ccgr3 simp22 simp33 simp31 cgr3rflx syl13anc simp2lr ad2antrl simp23 simp21
    cgrcomr cgrcom bitrd mpbid simp2rr cgrcomlrand 3simpa 3anim3i btwnconn1lem4
    syl122anc simpl syl2an cgrtr3and jca wi cifs brifs2 ifscgr syl333anc mp3and
    sylbird ) FUAJZAFUBUCZJZBVRJZKZCVRJZDVRJZHLZVRJZKZILZVRJZGLZVRJZEVRJZKZKZAB
    MBCMCWDMKBACNOPBADNOPQQZDAWDNOPZDWDNZCDNZRPZQZCAWGNOPZCWGNWQRPZQZQWDAWINZOP
    WDWINCBNRPQWGXCOPWGWINDBNRPQQZKZECWDNOPZEDWGNOPZQZQZQZXGDEWGNNZXKUFPZDCNZWP
    RPZWGCNZWGWDNZRPZQZECNEWDNRPZWMXEXFXGUDWMXLXIWMVQWCWKWHXLVQVSVTWFWLUEZWAWBW
    CWEWLUGZWAWFWHWJWKUHZWAWFWHWJWKUIZDEWGFUJUKSXJXNXQXJWRXNXEWRWMXHWOWRXBWNXDU
    LUMWMWRXNTXIWMWRWPXMRPZXNWMVQWCWEWBWCWRYDTXTYAWAWBWCWEWLUNZWAWBWCWEWLUOZYAD
    WDCDFUPVEWMVQWCWEWCWBYDXNTXTYAYEYAYFDWDDCFUQVEURSUSWMXIWGCWGWDDCFXTYCYFYCYE
    YAYFWMXICWGCDFXTYFYCYFYAXEXAWMXHWTXAWSWNXDUTUMVAWMWAWFWHWJQZKXEXPXMRPXIWLYG
    WAWFWHWJWKVBVCXEXHVFABCDFGHIVDVGVHVIWMXGXLXRKZXSVJZXIWMVQWCWKWHWBWCWKWHWEYI
    XTYAYBYCYFYAYBYCYEVQWCWKKWHWBWCKWKWHWEKKYHDENZXONYJXPNVKPXSDEWGCDEWGWDFVLDE
    WGCDEWGWDFVMVPVNSVO $.

  $( Lemma for ~ btwnconn1 .  Next, we show that ` E ` is the midpoint of ` D `
     and ` d ` (Contributed by Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem6 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) ) ) ->
         <. E , D >. Cgr <. E , d >. ) $=
    ( wcel w3a cv wne cop cbtwn wbr wa ccgr jca cgrrflxd cee cfv simprrl simp11
    cn simp21 simp23 simp33 adantr simp31 simp2rr ad2antrl cgrcomand cgrcomrand
    simp22 simp2lr 3simpa 3anim3i btwnconn1lem4 syl2an cgrtr3and cgrcomlrand wi
    simpl cifs brifs ifscgr sylbird syl333anc mp3and ) FUEJZAFUAUBZJZBVLJZKZCVL
    JZDVLJZHLZVLJZKZILZVLJZGLZVLJZEVLJZKZKZABMBCMCVRMKBACNOPBADNOPQQZDAVRNOPZDV
    RNCDNZRPZQZCAWANOPZCWANZWJRPZQZQVRAWCNZOPVRWCNCBNRPQWAWQOPWAWCNDBNRPQQZKZEC
    VRNZOPZEDWANOPZQZQZQZXAXAQZWTWTRPZEVRNZXHRPZQZWJWNRPZVRDNZVRWANZRPZQZEDNEWA
    NRPZXEXAXAWGWSXAXBUCZXQSWGXJXDWGXGXIWGCVRFVKVMVNVTWFUDZVOVPVQVSWFUFZVOVPVQV
    SWFUGZTWGEVRFXRVOVTWBWDWEUHZXTTSUIXEXKXNWGXDCWACDFXRXSVOVTWBWDWEUJZXSVOVPVQ
    VSWFUOZWSWOWGXCWMWOWLWHWRUKULUMWGXDDVRWAVRFXRYCXTYBXTWGXDDVRWAVRDCFXRYCXTYB
    XTYCXSWGXDDVRCDFXRYCXTXSYCWSWKWGXCWIWKWPWHWRUPULUNWGVOVTWBWDQZKWSWAVRNDCNRP
    XDWFYDVOVTWBWDWEUQURWSXCVDABCDFGHIUSUTVAVBSWGXFXJXOKZXPVCZXDWGVKVPWEVSVQVPW
    EVSWBYFXRXSYAXTYCXSYAXTYBVKVPWEKVSVQVPKWEVSWBKKYECENZXLNYGXMNVEPXPCEVRDCEVR
    WAFVFCEVRDCEVRWAFVGVHVIUIVJ $.

  $( Lemma for ~ btwnconn1 .  Under our assumptions, ` C ` and ` d ` are
     distinct.  (Contributed by Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem7 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
         ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) ) ) ->
        C =/= d ) $=
    ( wcel w3a cv wne cop cbtwn wbr wa ccgr wi syl5 cee simp1l3 simp2rr simp2lr
    cfv adantr 3jca simp11 simp21 simp22 simp23 simp31 simpr1 wceq opeq2 breq1d
    cn 3anbi2d biimparc simp2 simp1 simp2l simp2r cgrid2 syl13anc opeq1 breq12d
    imp simp3l axcgrid expdimp 3ad2antr3 mpd ex necon3d syl122anc ) FUQJZAFUAUE
    ZJZBVRJZKZCVRJZDVRJZHLZVRJZKZILZVRJZGLZVRJZEVRJZKZKZABMZBCMZCWDMZKBACNOPBAD
    NOPQZQZDAWDNOPZDWDNZCDNZRPZQZCAWGNOPZCWGNZXARPZQZQZWDAWINZOPWDWINCBNRPQWGXI
    OPWGWINDBNRPQQZKZECWDNZOPEDWGNOPQZQZCWGMZXNWPXFXBKZWMXOXNWPXFXBXKWPXMWNWOWP
    WQXHXJUBUFXKXFXMXDXFXCWRXJUCUFXKXBXMWSXBXGWRXJUDUFUGWMVQWBWCWEWHXPXOSVQVSVT
    WFWLUHWAWBWCWEWLUIWAWBWCWEWLUJWAWBWCWEWLUKWAWFWHWJWKULVQWBWCQZWEWHQZKZXPXOX
    SXPQZWPXOXSWPXFXBUMXTCWGCWDXSXPCWGUNZCWDUNZXPYAQWPCCNZXARPZXBKZXSYBYAYEXPYA
    YDXFWPXBYAYCXEXARCWGCUOUPURUSXSYEYBXSYEQCDUNZYBXSYEYFYEYDXSYFWPYDXBUTXSVQWB
    WBWCYDYFSVQXQXRVAZVQWBWCXRVBZYHVQWBWCXRVCCCDFVDVETVHXSWPXBYFYBSYDXSXBYFYBXB
    YFQXLYCRPZXSYBYFYIXBYFXLWTYCXARCDWDVFCDCUOVGUSXSVQWBWEWBYIYBSYGYHVQXQWEWHVI
    YHCWDCFVJVETVKVLVMVNTVKVOVMVNVPTVH $.

  $( Lemma for ~ btwnconn1 .  Now, we introduce the last three points used in
     the construction: ` P ` , ` Q ` , and ` R ` will turn out to be equal
     further down, and will provide us with the key to the final statement.  We
     begin by establishing congruence of ` R P ` and ` E d ` (Contributed by
     Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem8 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
           ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ R e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) /\
             ( ( C Btwn <. c , P >. /\ <. C , P >. Cgr <. C , d >. ) /\
               ( C Btwn <. d , R >. /\ <. C , R >. Cgr <. C , E >. ) /\
               ( R Btwn <. P , Q >. /\ <. R , Q >. Cgr <. R , P >. ) ) ) ) ) ->
       <. R , P >. Cgr <. E , d >. ) $=
    ( wcel w3a wa wne cop cbtwn wbr ccgr cn cee cfv cv simpr2l ad2antll simpr1r
    ccgr3 wb simp11 simp2l1 simp31 cgrcomlr syl122anc cgrcom bitrd adantr mpbid
    simp2r1 simp33 simp2r3 simp2l3 simpr1l btwncomand adantl wi btwnintr mp2and
    simprll simpr2r cgrextendand brcgr3 syl133anc mpbir3and cgrrflx2d jca simp1
    3jca simp2l simp2r simprl btwnconn1lem7 syl2an necomd brofs2 anbi1d 5segofs
    simpl cofs sylbird syl333anc ) IUAMZAIUBUCZMZBWMMZNZCWMMZDWMMZKUDZWMMZNZLUD
    ZWMMZJUDZWMMZHWMMZNZOZEWMMZFWMMZGWMMZNZNZABPBCPCWSPNBACQRSBADQRSOODAWSQRSDW
    SQCDQZTSOCAXBQRSCXBQZXNTSOOWSAXDQZRSWSXDQCBQTSOXBXPRSXBXDQDBQTSOONZHCWSQRSZ
    HDXBQRSZOZCWSEQRSZCEQXOTSZOZCXBGQZRSZCGQZCHQZTSZOZGEFQRSGFQGEQZTSOZNZOZOZOZ
    YEXBYFQEYGQUHSZXBEQEXBQTSZYBOZNZXBCPZYJHXBQZTSZYOYEYPYRYMYEXMXQYEYHYCYKXTUE
    UFZYOYPXBCQZECQZTSZYDEHQZTSZYHYOYBUUFYMYBXMXQYAYBYIYKXTUGUFZXMYBUUFUIYNXMYB
    UUEUUDTSZUUFXMWLWQXIWQXCYBUUJUIWLWNWOXHXLUJZWQWRWTXGWPXLUKZWPXHXIXJXKULZUUL
    XCXEXFXAWPXLUSZCECXBIUMUNXMWLXIWQXCWQUUJUUFUIUUKUUMUULUUNUULECXBCIUOUNUPUQU
    RZXMYNXBCGECHIUUKUUNUULWPXHXIXJXKUTZUUMUULXCXEXFXAWPXLVAZUUCYOCEWSQRSZXRCUU
    GRSZXMYNCWSEIUUKUULWQWRWTXGWPXLVBZUUMYMYAXMXQYAYBYIYKXTVCUFVDYNXRXMXQXRXSYL
    VIVEXMUURXROUUSVFZYNXMWLXIWQXFWTUVAUUKUUMUULUUQUUTECHWSIVGUNUQVHUUOYMYHXMXQ
    YEYHYCYKXTVJUFZVKUVBXMYPUUFUUHYHNUIZYNXMWLXCWQXKXIWQXFUVCUUKUUNUULUUPUUMUUL
    UUQXBCGECHIVLVMUQVNYOYQYBXMYQYNXMXBEIUUKUUNUUMVOUQUUIVPVRYOCXBXMWPXAXGNXQXT
    OCXBPYNXMWPXAXGWPXHXLVQWPXAXGXLVSWPXAXGXLVTVRYNXQXTXQYMWHXQXTYLWAVPABCDHIJK
    LWBWCWDXMYSYTOZUUBVFZYNXMWLXCWQXKXIXIWQXFXCUVEUUKUUNUULUUPUUMUUMUULUUQUUNWL
    XCWQNXKXIXINWQXFXCNNZUVDUUDYJQUUEUUAQWISZYTOUUBUVFUVGYSYTXBCGEECHXBIWEWFXBC
    GEECHXBIWGWJWKUQVH $.

  $( Lemma for ~ btwnconn1 .  Now, a quick use of transitivity to establish
     congruence on ` R Q ` and ` E D ` (Contributed by Scott Fenton,
     8-Oct-2013.) $)
  btwnconn1lem9 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
           ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ R e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) /\
             ( ( C Btwn <. c , P >. /\ <. C , P >. Cgr <. C , d >. ) /\
               ( C Btwn <. d , R >. /\ <. C , R >. Cgr <. C , E >. ) /\
               ( R Btwn <. P , Q >. /\ <. R , Q >. Cgr <. R , P >. ) ) ) ) ) ->
       <. R , Q >. Cgr <. E , D >. ) $=
    ( wcel w3a cv wa cop cbtwn wbr ccgr cn cee cfv simp11 simp33 simp32 simp2r3
    simp2l2 simp2r1 simp31 simpr3r ad2antll btwnconn1lem8 cgrtrand simp1 simp2l
    wne simp2r 3jca simpl simprl jca btwnconn1lem6 syl2an cgrtr3and ) IUAMZAIUB
    UCZMZBVGMZNZCVGMZDVGMZKOZVGMZNZLOZVGMZJOZVGMZHVGMZNZPZEVGMZFVGMZGVGMZNZNZAB
    UQBCUQCVMUQNBACQRSBADQRSPPDAVMQRSDVMQCDQZTSPCAVPQRSCVPQZWHTSPPVMAVRQZRSVMVR
    QCBQTSPVPWJRSVPVRQDBQTSPPNZHCVMQRSHDVPQRSPZCVMEQRSCEQWITSPZCVPGQRSCGQCHQTSP
    ZGEFQRSZGFQGEQTSZPNZPZPZGFHDHVPIVFVHVIWBWFUDZVJWBWCWDWEUEZVJWBWCWDWEUFZVQVS
    VTVOVJWFUGZVKVLVNWAVJWFUHXCVQVSVTVOVJWFUIZWGWSGFGEHVPIWTXAXBXAVJWBWCWDWEUJX
    CXDWRWPWGWKWOWPWMWNWLUKULABCDEFGHIJKLUMUNWGVJVOWANWKWLPHDQHVPQTSWSWGVJVOWAV
    JWBWFUOVJVOWAWFUPVJVOWAWFURUSWSWKWLWKWRUTWKWLWQVAVBABCDHIJKLVCVDVE $.

  $( Lemma for ~ btwnconn1 .  Now we establish a congruence that will give us
     ` D = d ` when we compute ` P = Q ` later on.  (Contributed by Scott
     Fenton, 8-Oct-2013.) $)
  btwnconn1lem10 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
           ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ R e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) /\
             ( ( C Btwn <. c , P >. /\ <. C , P >. Cgr <. C , d >. ) /\
               ( C Btwn <. d , R >. /\ <. C , R >. Cgr <. C , E >. ) /\
               ( R Btwn <. P , Q >. /\ <. R , Q >. Cgr <. R , P >. ) ) ) ) ) ->
       <. d , D >. Cgr <. P , Q >. ) $=
    ( wcel w3a cv wa cop cbtwn wbr ccgr cn cee cfv simp11 simp2r1 simp31 simp33
    wne simp2r3 simp2l2 simp32 simprlr adantl btwncomand ad2antll btwnconn1lem8
    simpr3l wb cgrcomlr syl122anc cgrcom bitrd mpbid btwnconn1lem9 cgrextendand
    adantr cgrcomand ) IUAMZAIUBUCZMZBVIMZNZCVIMZDVIMZKOZVIMZNZLOZVIMZJOZVIMZHV
    IMZNZPZEVIMZFVIMZGVIMZNZNZABUHBCUHCVOUHNBACQRSBADQRSPPDAVOQRSDVOQCDQZTSPCAV
    RQRSCVRQZWJTSPPVOAVTQZRSVOVTQCBQTSPVRWLRSVRVTQDBQTSPPNZHCVOQRSZHDVRQRSZPZCV
    OEQRSCEQWKTSPZCVRGQRSCGQCHQTSPZGEFQRSZGFQGEQZTSZPNZPZPZVRHDEGFIVHVJVKWDWHUD
    ZVSWAWBVQVLWHUEZVSWAWBVQVLWHUIZVMVNVPWCVLWHUJZVLWDWEWFWGUFZVLWDWEWFWGUGZVLW
    DWEWFWGUKZWIXDHDVRIXEXGXHXFXDWOWIWMWNWOXBULUMUNXCWSWIWMWSXAWQWRWPUQUOWIXDPW
    THVRQTSZVRHQZEGQZTSZABCDEFGHIJKLUPWIXLXOURXDWIXLXNXMTSZXOWIVHWGWEWBVSXLXPUR
    XEXJXIXGXFGEHVRIUSUTWIVHWEWGVSWBXPXOURXEXIXJXFXGEGVRHIVAUTVBVFVCWIXDGFHDIXE
    XJXKXGXHABCDEFGHIJKLVDVGVE $.

  $( Lemma for ~ btwnconn1 .  Now, we establish that ` D ` and ` Q ` are
     equidistant from ` C ` (Contributed by Scott Fenton, 8-Oct-2013.) $)
  btwnconn1lem11 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
           ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ R e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) /\
             ( ( C Btwn <. c , P >. /\ <. C , P >. Cgr <. C , d >. ) /\
               ( C Btwn <. d , R >. /\ <. C , R >. Cgr <. C , E >. ) /\
               ( R Btwn <. P , Q >. /\ <. R , Q >. Cgr <. R , P >. ) ) ) ) ) ->
       <. D , C >. Cgr <. Q , C >. ) $=
    ( wcel w3a wa cop cbtwn wbr ccgr wb cee cfv wne btwnconn1lem8 btwnconn1lem9
    cn cv wceq btwnconn1lem10 adantr wi simpr3r adantl simpr2r jca opeq2 breq2d
    anbi2d 3anbi12d anbi12d biimpar simpr1 simp11 simp33 simp31 simp2r1 axcgrid
    3jca opeq1 syl5 breq12d breq1d biimpac simpll simp32 simprlr simpr3 simp2l2
    syl13anc imp opeq2d simp2l1 cgrcomlr syl122anc cgrcom bitrd mpbid ex anbi1d
    3anbi23d imbi12d syl5ibcom com23 exp3a exp4d imp31 ccgr3 simp2r3 btwncomand
    mpdd mpd cgrcomand brcgr3 syl133anc mpbir3and simpr1r ad2antll simpr brofs2
    cofs 5segofs sylbird syl333anc ad2antrr mp2and pm2.61dane ) IUFMZAIUAUBZMZB
    XRMZNZCXRMZDXRMZKUGZXRMZNZLUGZXRMZJUGZXRMZHXRMZNZOZEXRMZFXRMZGXRMZNZNZABUCB
    CUCCYDUCNBACPQRBADPQROODAYDPQRDYDPCDPZSROCAYGPQRCYGPZYSSROOYDAYIPZQRYDYIPCB
    PSROYGUUAQRYGYIPDBPSROONZHCYDPQRZHDYGPQRZOZCYDEPQRZCEPZYTSRZOZCYGGPQRZCGPZC
    HPZSRZOZGEFPZQRZGFPZGEPZSRZOZNZOZOZOZDCPZFCPZSRZYGHUVDYGHUHZOUURHYGPZSRZUUQ
    HDPZSRZYGDPZUUOSRZNZUVGUVDUVOUVHUVDUVJUVLUVNABCDEFGHIJKLUDZABCDEFGHIJKLUEZA
    BCDEFGHIJKLUIZVHUJYRUVCUVHUVOUVGUKZUVCUUSUUMOZYRUVHUVSUKUVCUUSUUMUVBUUSUUBU
    UPUUSUUIUUNUUEULUMUVBUUMUUBUUJUUMUUIUUTUUEUNZUMUOYRUVHUVTUVSYRUVHUVTUVOUVGU
    VHUVTUVOOZOUUSUUKYTSRZOZUURYGYGPZSRZUUQUVMSRZUVNNZOZYRUVGUVHUWIUWBUVHUWDUVT
    UWHUVOUVHUWCUUMUUSUVHYTUULUUKSYGHCUPUQURUVHUWFUVJUWGUVLUVNUVHUWEUVIUURSYGHY
    GVIUQUVHUVMUVKUUQSYGHDVIUQUSUTVAYRUWIGEUHZUVGUWIUWFYRUWJUWDUWFUWGUVNVBYRXQY
    PYNYHUWFUWJUKXQXSXTYMYQVCZYAYMYNYOYPVDZYAYMYNYOYPVEZYHYJYKYFYAYQVFZGEYGIVGV
    SVJYRUWIUWJUVGUWIUWJOUUOEEPZSRZUUHOZUWOUWESRZUUOUVMSRZUVNNZOZYRUVGUWJUWIUXA
    UWJUWDUWQUWHUWTUWJUUSUWPUWCUUHUWJUUQUUOUURUWOSGEFVIZGEEVIZVKUWJUUKUUGYTSGEC
    UPVLUTUWJUWFUWRUWGUWSUVNUWJUURUWOUWESUXCVLUWJUUQUUOUVMSUXBVLUSUTVMYRUXAEFUH
    ZUVGUXAUWPYRUXDUWPUUHUWTVNYRXQYNYOYNUWPUXDUKUWKUWMYAYMYNYOYPVOZUWMEFEIVGVSV
    JYRUXDUXAUVGYRUWOUWOSRZUUHOZUWRUWOUVMSRZUVMUWOSRZNZOZUVEECPZSRZUKUXDUXAUVGU
    KYRUXKUXMYRUXKOZUUHUXMYRUXFUUHUXJVPUXNUUHUUGYSSRZUXMUXNYTYSUUGSUXNYGDCYRUXK
    YGDUHZUXKUXIYRUXPUXGUWRUXHUXIVQYRXQYHYCYNUXIUXPUKUWKUWNYBYCYEYLYAYQVRZUWMYG
    DEIVGVSVJVTWAUQYRUXOUXMTUXKYRUXOUXLUVESRZUXMYRXQYBYNYBYCUXOUXRTUWKYBYCYEYLY
    AYQWBZUWMUXSUXQCECDIWCWDYRXQYNYBYCYBUXRUXMTUWKUWMUXSUXQUXSECDCIWEWDWFUJWFWG
    WHUXDUXKUXAUXMUVGUXDUXGUWQUXJUWTUXDUXFUWPUUHUXDUWOUUOUWOSEFEUPZVLWIUXDUXHUW
    SUXIUVNUWRUXDUWOUUOUVMSUXTVLUXDUWOUUOUVMSUXTUQWJUTUXDUXLUVFUVESEFCVIUQWKWLW
    MWTVJWNWTVJWOWMVJWPXAUVDYGHUCZOHUVMQRZYGUVKPEUUQPWQRZYGCPZUXLSRZHCPZGCPZSRZ
    OZNZUYAUVGUVDUYJUYAUVDUYBUYCUYIYRUVCHDYGIUWKYHYJYKYFYAYQWRZUXQUWNUVCUUDYRUU
    BUUCUUDUVAVPUMWSUVDUYCYGHPZEGPZSRZUVNUVKUUQSRZUVDUVJUYNUVPYRUVJUYNTUVCYRUVJ
    UYMUYLSRZUYNYRXQYPYNYKYHUVJUYPTUWKUWLUWMUYKUWNGEHYGIWCWDYRXQYNYPYHYKUYPUYNT
    UWKUWMUWLUWNUYKEGYGHIWEWDWFUJWGUVRYRUVCGFHDIUWKUWLUXEUYKUXQUVQXBYRUYCUYNUVN
    UYONTZUVCYRXQYHYKYCYNYPYOUYQUWKUWNUYKUXQUWMUWLUXEYGHDEGFIXCXDUJXEUVDUYEUYHU
    VDUUHUYEUVBUUHYRUUBUUFUUHUUNUUTUUEXFXGYRUUHUYETUVCYRUUHUXLUYDSRZUYEYRXQYBYN
    YBYHUUHUYRTUWKUXSUWMUXSUWNCECYGIWCWDYRXQYNYBYHYBUYRUYETUWKUWMUXSUWNUXSECYGC
    IWEWDWFUJWGUVDUUMUYHUVBUUMYRUUBUWAXGYRUUMUYHTUVCYRUUMUYGUYFSRZUYHYRXQYBYPYB
    YKUUMUYSTUWKUXSUWLUXSUYKCGCHIWCWDYRXQYPYBYKYBUYSUYHTUWKUWLUXSUYKUXSGCHCIWEW
    DWFUJWGUOVHUJUVDUYAXHYRUYJUYAOZUVGUKZUVCUYAYRXQYHYKYCYBYNYPYOYBVUAUWKUWNUYK
    UXQUXSUWMUWLUXEUXSXQYHYKNYCYBYNNYPYOYBNNZUYTUYLUVEPUYMUVFPXJRZUYAOUVGVUBVUC
    UYJUYAYGHDCEGFCIXIWIYGHDCEGFCIXKXLXMXNXOXP $.

  $( Lemma for ~ btwnconn1 .  Using a long string of invocations of ~ linecgr ,
     we show that ` D = d ` .  (Contributed by Scott Fenton, 9-Oct-2013.) $)
  btwnconn1lem12 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
           ( d e. ( EE ` N ) /\ b e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) /\
         ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ R e. ( EE ` N ) ) ) /\
         ( ( ( ( A =/= B /\ B =/= C /\ C =/= c ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) /\
           ( ( E Btwn <. C , c >. /\ E Btwn <. D , d >. ) /\
             ( ( C Btwn <. c , P >. /\ <. C , P >. Cgr <. C , d >. ) /\
               ( C Btwn <. d , R >. /\ <. C , R >. Cgr <. C , E >. ) /\
               ( R Btwn <. P , Q >. /\ <. R , Q >. Cgr <. R , P >. ) ) ) ) ) ->
       D = d ) $=
    ( wcel w3a wa cop cbtwn wbr ccgr wi cee cfv wne wceq simp11 simp2l1 simp2l3
    cn cv simp31 simp32 simp1l3 ad2antrl ccolin ad2antll btwncolinear5 syl13anc
    simpr1l simp2l2 simp2r1 simpr1r simp2rr cgrtrand btwnconn1lem11 cgrcomlrand
    adantr mpd weq simp12 simp13 simp2r2 simp1rr btwnexchand btwnexch3and opeq1
    simp2ll simp3ll breq2d biimpac axbtwnid syl5 exp3a simp1 simp2l simp2r 3jca
    syl3anc simpl simprl jca btwnconn1lem7 syl2an simp2rl simp3rl btwncolinear2
    simp33 simpr2r btwnconn1lem5 breq1d simp2r3 breq12d biimpar necon3d simpr2l
    anbi1d cgrid2 syland mp2and btwncolinear4 simpr3r cgrcomand linecgrand ee21
    opeq2 biimprd adantrl btwncolinear1 simp1rl btwncolinear6 ex btwnconn1lem10
    com12 an12s pm2.61ine biimpa axcgrid eqcomd ) IUHMZAIUAUBZMZBYIMZNZCYIMZDYI
    MZKUIZYIMZNZLUIZYIMZJUIZYIMZHYIMZNZOZEYIMZFYIMZGYIMZNZNZABUCZBCUCZCYOUCZNZB
    ACPQRZBADPQRZOZOZDAYOPQRZDYOPCDPZSRZOZCAYRPQRZCYRPZUUSSRZOZOZYOAYTPZQRZYOYT
    PCBPSRZOZYRUVGQRZYRYTPZDBPSRZOZOZNZHCYOPZQRHDYRPQROZCYOEPZQRZCEPUVCSRZOZCYR
    GPQRZCGPZCHPZSRZOZGEFPZQRZGFPGEPSRZOZNZOZOZOZYRDUWOEFUDZYRDPZUWHSRZYRDUDZUW
    OEEPUWHSRZUWPUUIUWNCYOEEFIYHYJYKUUDUUHUEZYMYNYPUUCYLUUHUFZYMYNYPUUCYLUUHUGZ
    YLUUDUUEUUFUUGUJZUXDYLUUDUUEUUFUUGUKZUVPUULUUIUWMUUJUUKUULUUPUVFUVOULUMZUWO
    UVTCUVSUNRZUWMUVTUUIUVPUVTUWAUWGUWKUVRURUOUUIUVTUXGTZUWNUUIYHYPUUEYMUXHUXAU
    XCUXDUXBYOECIUPUQVFVGUUIUWNCECDCFIUXAUXBUXDUXBYMYNYPUUCYLUUHUSZUXBUXEUUIUWN
    CECYRCDIUXAUXBUXDUXBYSUUAUUBYQYLUUHUTZUXBUXIUWMUWAUUIUVPUVTUWAUWGUWKUVRVAUO
    UVPUVDUUIUWMUVBUVDUVAUUQUVOVBUMVCUUIUWNDCFCIUXAUXIUXBUXEUXBABCDEFGHIJKLVDVE
    VCZUWOUVSYOFPZSRZTBYTUWOBYTUDZUXMUWOUXNKJVHZYTEPZYTFPZSRZUXMUWOYOBYTPZQRZUX
    NUXOTZUUIUWNABYOYTIUXAYHYJYKUUDUUHVIZYHYJYKUUDUUHVJZUXCYSUUAUUBYQYLUUHVKZUU
    IUWNABDYOIUXAUYBUYCUXIUXCUVPUUOUUIUWMUUNUUOUUMUVFUVOVLUMUVPUURUUIUWMUURUUTU
    VEUUQUVOVPUMVMUVPUVHUUIUWMUVHUVIUVNUUQUVFVQUMVNZUUIUXTUYATUWNUUIUXTUXNUXOUX
    TUXNOYOYTYTPZQRZUUIUXOUXNUXTUYGUXNUXSUYFYOQBYTYTVOVRVSUUIYHYPUUAUYGUXOTUXAU
    XCUYDYOYTIVTWGWAWBVFVGUUIUWNCYRYTEFIUXAUXBUXJUYDUXDUXEUUIYLYQUUCNZUVPUVROZC
    YRUCUWNUUIYLYQUUCYLUUDUUHWCYLYQUUCUUHWDYLYQUUCUUHWEWFZUWNUVPUVRUVPUWMWHUVPU
    VRUWLWIWJZABCDHIJKLWKWLZUWOYRCYTPQRZCUVLUNRZUUIUWNACYRYTIUXAUYBUXBUXJUYDUVP
    UVBUUIUWMUVBUVDUVAUUQUVOWMUMZUVPUVKUUIUWMUVKUVMUVJUUQUVFWNUMVNUUIUYMUYNTZUW
    NUUIYHYMUUAYSUYPUXAUXBUYDUXJCYTYRIWOUQVFVGUXKUUIUWNGCYREFIUXAYLUUDUUEUUFUUG
    WPZUXBUXJUXDUXEUWOUULGCUCUXFUWOGCCYOUWOUWFHCPZHYOPZSRZGCUDZCYOUDZTZUWMUWFUU
    IUVPUWCUWFUWBUWKUVRWQUOUUIUYHUYIUYTUWNUYJUYKABCDHIJKLWRWLUUIUWFUYTOZVUCTUWN
    UUIVUDVUAVUBVUDVUAOCCPZUWESRZUYTOZUUIVUBVUAVUDVUGVUAUWFVUFUYTVUAUWDVUEUWESG
    CCXNWSXEVSUUIVUFCHUDZUYTVUBUUIYHYMYMUUBVUFVUHTUXAUXBUXBYSUUAUUBYQYLUUHWTCCH
    IXFUQVUHUYTOVUEUVQSRZUUIVUBVUHVUIUYTVUHVUEUYRUVQUYSSCHCVOCHYOVOXAXBUUIYHYMY
    MYPVUIVUBTUXAUXBUXBUXCCCYOIXFUQWAXGWAWBVFXHXCVGUWOUWCGUVCUNRZUWMUWCUUIUVPUW
    CUWFUWBUWKUVRXDUOUUIUWCVUJTZUWNUUIYHYSUUGYMVUKUXAUXJUYQUXBYRGCIXIUQVFVGUUIU
    WNGFGEIUXAUYQUXEUYQUXDUWMUWJUUIUVPUWIUWJUWBUWGUVRXJUOXKUXKXLZXLZUXOUXMUXRUX
    OUVSUXPUXLUXQSYOYTEVOYOYTFVOXAXOXMYBBYTUCZUWOUXMUUIVUNUWNUXMUUIVUNUWNOZBYTY
    OEFIUXAUYCUYDUXCUXDUXEUUIVUNUWNWIUUIVUOOUXTBYTYOPUNRZUUIUWNUXTVUNUYEXPUUIUX
    TVUPTZVUOUUIYHYKUUAYPVUQUXAUYCUYDUXCBYTYOIXQUQVFVGUUIUWNBEPBFPSRVUNUUIUWNCY
    RBEFIUXAUXBUXJUYCUXDUXEUYLUWOCBYRPQRZCYRBPUNRZUUIUWNABCYRIUXAUYBUYCUXBUXJUV
    PUUNUUIUWMUUNUUOUUMUVFUVOXRUMUYOVNUUIVURVUSTZUWNUUIYHYKYSYMVUTUXAUYCUXJUXBB
    YRCIXSUQVFVGUXKVULXLXPUUIUWNUXRVUNVUMXPXLYCXTYDXLUUIUWTUWPTZUWNUUIYHUUEUUEU
    UFVVAUXAUXDUXDUXEEEFIXFUQVFVGABCDEFGHIJKLYAUUIUWPUWROZUWSTUWNVVBUWQFFPZSRZU
    UIUWSUWPUWRVVDUWPUWHVVCUWQSEFFVOVRYEUUIYHYSYNUUFVVDUWSTUXAUXJUXIUXEYRDFIYFU
    QWAVFXHYG $.

  ${
    $d A e p q r $.  $d B e p q r $.  $d C e p q r $.  $d D e p q r $.
    $d N e p q r $.  $d b e p q r $.  $d c e p q r $.  $d d e p q r $.
    $( Lemma for ~ btwnconn1 .  Begin back-filling and eliminating hypotheses.
       (Contributed by Scott Fenton, 9-Oct-2013.) $)
    btwnconn1lem13 $p |- (
     ( ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ c e. ( EE ` N ) ) /\
           ( d e. ( EE ` N ) /\ b e. ( EE ` N ) ) ) ) /\
         ( ( ( A =/= B /\ B =/= C ) /\
               ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) /\
             ( ( D Btwn <. A , c >. /\ <. D , c >. Cgr <. C , D >. ) /\
               ( C Btwn <. A , d >. /\ <. C , d >. Cgr <. C , D >. ) ) /\
             ( ( c Btwn <. A , b >. /\ <. c , b >. Cgr <. C , B >. ) /\
               ( d Btwn <. A , b >. /\ <. d , b >. Cgr <. D , B >. ) ) ) ) ->
       ( C = c \/ D = d ) ) $=
      ( vp vr wcel w3a cv wa cop cbtwn wbr ccgr adantr ad3antrrr ve cee cfv wne
      vq cn wceq wn df-ne wrex simp2rl simp2ll wb simpl1 simprl1 simpl2 simprrl
      btwncom syl13anc simprl2 simprl3 anbi12d syl5ib wi axpasch syl132anc syld
      jca imp simpll1 axsegcon syl122anc reeanv sylanbrc ad2antrr simprl simprr
      simpr simp-4l simplrl simprrr simpllr 3jca simplrr simp1ll btwnconn1lem12
      simp1lr simpl1r simpll2 simpl3l simpl3r jca32 syl2an an4s rexlimddv exp32
      rexlimdvv mpd expr syl5bir orrd ) EUFKZAEUBUCZKZBXCKZLZCXCKZDXCKZGMZXCKZL
      ZHMZXCKZFMZXCKZNZNZNZABUDZBCUDZNZBACOPQBADOPQNZNZDAXIOPQZDXIOCDOZRQZNZCAX
      LOPQZCXLOZYERQZNZNZXIAXNOZPQXIXNOCBORQNZXLYMPQXLXNODBORQNZNZLZNZCXIUGZDXL
      UGZYSUHCXIUDZYRYTCXIUIXRYQUUAYTXRYQUUANZNUAMZCXIOPQUUCDXLOPQNZYTUAXCXRUUB
      UUDUAXCUJZXRUUBCXLAOPQZDXIAOPQZNZUUEUUBYHYDNXRUUHUUBYHYDYQYHUUAYHYJYGYCYP
      UKSYQYDUUAYDYFYKYCYPULSVHXRYHUUFYDUUGXRXBXGXDXMYHUUFUMXBXDXEXQUNZXGXHXJXP
      XFUOZXBXDXEXQUPZXFXKXMXOUQZCAXLEURUSXRXBXHXDXJYDUUGUMUUIXGXHXJXPXFUTZUUKX
      GXHXJXPXFVAZDAXIEURUSVBVCXRXBXMXJXDXGXHUUHUUEVDUUIUULUUNUUKUUJUUMUAXLXIAC
      DEVEVFVGVIXRUUCXCKZUUBUUDYTXRUUONZUUBUUDNZNZCXIIMZOPQCUUSOYIRQNZCXLJMZOPQ
      CUVAOCUUCORQNZNZJXCUJIXCUJZYTUUPUVDUUQUUPUUTIXCUJZUVBJXCUJZUVDUUPXBXJXGXG
      XMUVEXBXDXEXQUUOVJZXRXJUUOUUNSXRXGUUOUUJSZUVHXRXMUUOUULSZIXICCXLEVKVLUUPX
      BXMXGXGUUOUVFUVGUVIUVHUVHXRUUOVRJXLCCUUCEVKVLUUTUVBIJXCXCVMVNSUURUVCYTIJX
      CXCUURUUSXCKZUVAXCKZNZUVCYTUUPUVLUUQUVCYTUUPUVLNZUUQUVCNZNUVAUUSUEMZOPQUV
      AUVOOUVAUUSORQNZYTUEXCUVMUVPUEXCUJZUVNUVMXBUVJUVKUVKUVJUVQXRXBUUOUVLUUIVO
      UUPUVJUVKVPZUUPUVJUVKVQZUVSUVRUEUUSUVAUVAUUSEVKVLSUVMUVOXCKZUVNUVPYTUVMUV
      TNZXFXKXMXOUUOLZNZUVJUVTUVKLZLXSXTUUALZYBNZYLYPLZUUDUUTUVBUVPLZNNYTUVNUVP
      NZUWAXFUWCUWDXFXQUUOUVLUVTVSUWAXKUWBUUPXKUVLUVTXFXKXPUUOVTVOUWAXMXOUUOXRX
      MUUOUVLUVTUULTXRXOUUOUVLUVTXFXKXMXOWATXRUUOUVLUVTWBWCVHUWAUVJUVTUVKUUPUVJ
      UVKUVTVTUVMUVTVRUUPUVJUVKUVTWDWCWCUWIUWGUUDUWHUWIUWFYLYPUWIUWEYBUWIXSXTUU
      AUVNXSUVPYQXSUUAUUDUVCXSXTYBYLYPWETSUVNXTUVPYQXTUUAUUDUVCXSXTYBYLYPWGTSUV
      NUUAUVPYQUUAUUDUVCWBSWCUUBYBUUDUVCUVPYAYBYLYPUUAWHTVHUUQYLUVCUVPYCYLYPUUA
      UUDWIVOUWIYNYOUUBYNUUDUVCUVPYNYOYCYLUUAWJTUUBYOUUDUVCUVPYNYOYCYLUUAWKTVHW
      CUUBUUDUVCUVPWBUWIUUTUVBUVPUUQUUTUVBUVPVTUUQUUTUVBUVPWDUVNUVPVRWCWLABCDUU
      SUVOUVAUUCEFGHWFWMWNWOWNWPWQWRWNWOWSWTXA $.
  $}

  ${
    $d A b c d x $.  $d B b c d x $.  $d C b c d x $.  $d D b c d x $.
    $d N b c d x $.
    $( Lemma for ~ btwnconn1 .  Final statement of the theorem when
       ` B =/= C ` .  (Contributed by Scott Fenton, 9-Oct-2013.) $)
    btwnconn1lem14 $p |- ( (
     ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
       ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) /\
       ( ( A =/= B /\ B =/= C ) /\
         ( B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ) ) ->
         ( C Btwn <. A , D >. \/ D Btwn <. A , C >. ) ) $=
      ( vc vd vb vx wcel wa w3a cop cbtwn wbr cv ccgr wrex axsegcon 3jca cn cee
      cfv wne simp1 simp2l simp3r simp3 syl121anc simp3l reeanv sylanbrc adantr
      wo wceq simpl1 simpl2l simprl simpl3l simpl2r syl122anc simprr jca sylibr
      simpl3r weq simplrr simpll simplr simpr btwnconn1lem2 syl2an opeq2 breq2d
      breq1d anbi12d anbi2d biimpac jca32 btwnconn1lem13 syl5 expdimp mpd exp32
      ex an4s rexlimdvv orcom simprrl adantl syl5ibrcom simprll orim12d syl5bi
      ) EUAJZAEUBUCZJZBWPJZKZCWPJZDWPJZKZLZABUDBCUDKBACMZNOBADMZNOKKZKZDAFPZMZN
      OZDXHMCDMZQOZKZCAGPZMZNOZCXNMXKQOZKZKZGWPRFWPRZCXENOZDXDNOZUNZXCXTXFXCXMF
      WPRZXRGWPRZXTXCWOWQXAXBYDWOWSXBUEZWOWQWRXBUFZWOWSWTXAUGWOWSXBUHZFADCDESUI
      XCWOWQWTXBYEYFYGWOWSWTXAUJYHGACCDESUIXMXRFGWPWPUKULUMXGXSYCFGWPWPXGXHWPJZ
      XNWPJZKZXSYCXCYKXFXSYCXCYKKZXFXSKZKZCXHUOZDXNUOZUNZYCYNXHAHPZMZNOXHYRMCBM
      QOKZXNAIPZMZNOZXNUUAMZDBMZQOZKZKZIWPRHWPRZYQYNYTHWPRZUUGIWPRZKZUUIYLUULYM
      YLUUJUUKYLWOWQYIWTWRUUJWOWSXBYKUPZWQWRWOXBYKUQZXCYIYJURZWTXAWOWSYKUSZWQWR
      WOXBYKUTZHAXHCBESVAYLWOWQYJXAWRUUKUUMUUNXCYIYJVBWTXAWOWSYKVEZUUQIAXNDBESV
      AVCUMYTUUGHIWPWPUKVDYNUUHYQHIWPWPYNYRWPJZUUAWPJZKZUUHYQYLUVAYMUUHYQYLUVAK
      ZYMUUHKZKIHVFZYQUVBWOWQWRLZWTXAYILZYJUUSUUTLZLXFXSUUHLUVDUVCUVBUVEUVFUVGY
      LUVEUVAYLWOWQWRUUMUUNUUQTUMZYLUVFUVAYLWTXAYIUUPUURUUOTUMZUVBYJUUSUUTXCYIY
      JUVAVGZYLUUSUUTURZYLUUSUUTVBTTUVCXFXSUUHXFXSUUHVHXFXSUUHVIYMUUHVJTABCDEUU
      AHFGVKVLUVBUVCUVDYQUVCUVDKYMYTXNYSNOZXNYRMZUUEQOZKZKZKZUVBYQUVDUVCUVQUVDU
      UHUVPYMUVDUUGUVOYTUVDUUCUVLUUFUVNUVDUUBYSXNNUUAYRAVMVNUVDUUDUVMUUEQUUAYRX
      NVMVOVPVQVQVRUVBUVQYQUVBUVEUVFYJUUSKZKKXFXSUVPLYQUVQUVBUVEUVFUVRUVHUVIUVB
      YJUUSUVJUVKVCVSUVQXFXSUVPXFXSUVPVHXFXSUVPVIYMUVPVJTABCDEHFGVTVLWEWAWBWCWF
      WDWGWCYQYPYOUNYNYCYOYPWHYNYPYAYOYBYNYAYPXPYMXPYLXFXMXPXQWIWJYPXEXOCNDXNAV
      MVNWKYNYBYOXJYMXJYLXFXJXLXRWLWJYOXDXIDNCXHAVMVNWKWMWNWCWFWDWGWC $.
  $}

  $( Connectitivy law for betweenness.  Theorem 5.1 of [Schwabhauser]
     p. 39-41.  (Contributed by Scott Fenton, 9-Oct-2013.) $)
  btwnconn1 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
     ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
     ( ( A =/= B /\ B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ->
       ( C Btwn <. A , D >. \/ D Btwn <. A , C >. ) ) ) $=
    ( cn wcel cee cfv wa w3a wne cop cbtwn wbr wo wi wceq breq1 ex orc 3ad2ant3
    3anbi3d syl6bi simpr1 simpl 3simpc adantl jca31 btwnconn1lem14 sylan2 an12s
    adantld pm2.61ine ) EFGAEHIZGBUOGJCUOGDUOGJKZABLZBACMZNOZBADMZNOZKZCUTNOZDU
    RNOZPZUPVBJZVEQBCBCRZVBVEUPVGVBUQUSVCKVEVGVAVCUQUSBCUTNSUCVCUQVEUSVCVDUAUBU
    DUMBCLZVFVEUPVHVBVEVHVBJZUPUQVHJUSVAJZJVEVIUQVHVJVHUQUSVAUEVHVBUFVBVJVHUQUS
    VAUGUHUIABCDEUJUKULTUNT $.

  $( Another connectivity law for betweenness.  Theorem 5.2 of [Schwabhauser]
     p. 41.  (Contributed by Scott Fenton, 9-Oct-2013.) $)
  btwnconn2 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( ( A =/= B /\ B Btwn <. A , C >. /\ B Btwn <. A , D >. ) ->
      ( C Btwn <. B , D >. \/ D Btwn <. B , C >. ) ) ) $=
    ( cn wcel cee cfv wa w3a wne cop cbtwn wbr wo btwnconn1 wi btwnexch3 ex mpd
    simpr2 anim1i ad2antrr simpr3 simp3r simp3l jca syld3an3 mpand orim12d mpdd
    adantr ) EFGZAEHIZGBUOGJZCUOGZDUOGZJZKZABLZBACMZNOZBADMZNOZKZCVDNOZDVBNOZPZ
    CBDMNOZDBCMNOZPZABCDEQUTVFVIVLRUTVFJZVGVJVHVKVMVGVJVMVGJVCVGJZVJVMVCVGUTVAV
    CVEUBUCUTVNVJRVFVGABCDESUDUATVMVEVHVKUTVAVCVEUEUTVEVHJVKRZVFUNUPUSURUQJVOUT
    URUQUNUPUQURUFUNUPUQURUGUHABDCESUIUMUJUKTUL $.

  ${
    $d N p $.  $d A p $.  $d B p $.  $d C p $.  $d D p $.
    $( Inner connectivity law for betweenness.  Theorem 5.3 of [Schwabhauser]
       p. 41.  (Contributed by Scott Fenton, 9-Oct-2013.) $)
    btwnconn3 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
    ( ( B Btwn <. A , D >. /\ C Btwn <. A , D >. ) ->
      ( B Btwn <. A , C >. \/ C Btwn <. A , B >. ) ) ) $=
      ( vp cn wcel cee cfv wa w3a cv cop cbtwn wbr wne btwncomand btwnexch3and
      wi wo simp1 simp3r simp2l btwndiff syl3anc simprlr necomd simpl2l simpl2r
      wrex simpr simpl3r simprrl simprll simpl3l simprrr ex btwnconn2 syl122anc
      simpl1 3jca syld exp3a rexlimdva mpd ) EGHZAEIJZHZBVHHZKZCVHHZDVHHZKZLZAD
      FMZNOPZAVPQZKZFVHUKZBADNZOPZCWAOPZKZBACNOPCABNOPUAZTZVOVGVMVIVTVGVKVNUBVG
      VKVLVMUCVGVIVJVNUDDAEFUEUFVOVSWFFVHVOVPVHHZKZVSWDWEWHVSWDKZVPAQZAVPBNOPZA
      VPCNOPZLZWEWHWIWMWHWIKZWJWKWLWNAVPWHVQVRWDUGUHWHWIABVPEVGVKVNWGVAZVIVJVGV
      NWGUIZVIVJVGVNWGUJZVOWGULZWHWIDBAVPEWOVLVMVGVKWGUMZWQWPWRWHWIBADEWOWQWPWS
      WHVSWBWCUNRWHVQVRWDUOZSRWHWIACVPEWOWPVLVMVGVKWGUPZWRWHWIDCAVPEWOWSXAWPWRW
      HWICADEWOXAWPWSWHVSWBWCUQRWTSRVBURWHVGWGVIVJVLWMWETWOWRWPWQXAVPABCEUSUTVC
      VDVEVF $.
  $}

  $( If two points fall in the same place in the middle of a segment, then they
     are identical.  (Contributed by Scott Fenton, 16-Oct-2013.)  (Revised by
     Mario Carneiro, 19-Apr-2014.) $)
  midofsegid $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
   ( D e. ( EE ` N ) /\ E e. ( EE ` N ) ) ) ->
   ( ( D Btwn <. A , B >. /\ E Btwn <. A , B >. /\
       <. A , D >. Cgr <. A , E >. ) -> D = E ) ) $=
    ( cn wcel cee cfv wa w3a cop cbtwn wbr ccgr wceq simprl3 endofsegidand expr
    simprr simp2l simp3r simp3l cgrcomand eqcomd 3simpa adantl simp2r btwnconn3
    simp1 wo wi syl122anc adantr mpd mpjaod ex ) EFGZAEHIZGZBUSGZJZCUSGZDUSGZJZ
    KZCABLZMNZDVGMNZACLZADLZONZKZCDPZVFVMJZCVKMNZVNDVJMNZVFVMVPVNVFVMVPJZJDCVFV
    RADCEURVBVEUJZURUTVAVEUAZURVBVCVDUBZURVBVCVDUCZVFVMVPTVFVRACADEVSVTWBVTWAVH
    VIVLVPVFQUDRUESVFVMVQVNVFVMVQJACDEVSVTWBWAVFVMVQTVHVIVLVQVFQRSVOVHVIJZVPVQU
    KZVMWCVFVHVIVLUFUGVFWCWDULZVMVFURUTVCVDVAWEVSVTWBWAURUTVAVEUHACDBEUIUMUNUOU
    PUQ $.

  ${
    $d Q a x $.  $d N a x $.  $d A a x $.  $d B a x $.  $d C a x $.
    $( Generalization of ~ axsegcon .  This time, we generate an endpoint for a
       segment on the ray ` Q A ` congruent to ` B C ` and starting at ` Q ` ,
       as opposed to ~ axsegcon , where the segment starts at ` A `
       (Contributed by Scott Fenton, 14-Oct-2013.)  (Removed unneeded
       inequality, 15-Oct-2013.) $)
    segcon2 $p |- ( ( N e. NN /\
       ( Q e. ( EE ` N ) /\ A e. ( EE ` N ) ) /\
       ( B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
         E. x e. ( EE ` N ) ( ( A Btwn <. Q , x >. \/ x Btwn <. Q , A >. ) /\
           <. Q , x >. Cgr <. B , C >. ) ) $=
      ( va wcel wa w3a cv cop cbtwn wbr wrex wne axsegcon adantr wi mpd cee cfv
      cn ccgr wceq breq1 orbi1d anbi1d rexbidv simp1 simp2 ancomd syl3anc simpr
      wo simpl1 simpl2l simpl3 syl121anc anass df-3an simpr1 wb simpr2r simpl2r
      simprl syl122anc necon3bid mpbird necomd simpr2l btwncomand simpr3 simprr
      cgrdegen btwnconn2 mp3and sylan2br anim1d sylanb an32s reximdva rexlimdva
      expr simp2l simp3 orc anim1i reximi syl pm2.61ne ) FUCHZEFUAUBZHZBWMHZIZC
      WMHDWMHIZJZBEAKZLZMNZWSEBLMNZUOZWTCDLUDNZIZAWMOZEWTMNZXBUOZXDIZAWMOZBEBEU
      EZXEXIAWMXKXCXHXDXKXAXGXBBEWTMUFUGUHUIWRBEPZIZEBGKZLMNZEXNLBELUDNZIZGWMOZ
      XFWRXRXLWRWLWOWNIZXSXRWLWPWQUJZWRWNWOWLWPWQUKULZYAGBEBEFQUMRXMXQXFGWMWRXN
      WMHZXLXQXFSWRYBIZXLXQXFYCXLXQIZIZEXNWSLMNZXDIZAWMOZXFYCYHYDYCWLYBWNWQYHWL
      WPWQYBUPWRYBUNWNWOWLWQYBUQWLWPWQYBURAXNECDFQUSRYEYGXEAWMYCWSWMHZYDYGXESZY
      CYIIWRYBYIIZIZYDYJWRYBYIUTYLYDIYFXCXDYLYDYFXCYDYFIYLXLXQYFJZXCXLXQYFVAYLY
      MIZXNEPZEXNBLMNZYFXCYNEXNYNEXNPXLYLXLXQYFVBYNEXNBEYNXPEXNUEXKVCZXOXPXLYFY
      LVDYLXPYQSZYMYLWLWNYBWOWNYRWLWPWQYKUPZWNWOWLWQYKUQZWRYBYIVFZWNWOWLWQYKVEZ
      YTEXNBEFVOVGRTVHVIVJYLYMEBXNFYSYTUUBUUAXOXPXLYFYLVKVLYLXLXQYFVMYLYOYPYFJX
      CSZYMYLWLYBWNWOYIUUCYSUUAYTUUBWRYBYIVNXNEBWSFVPVGRVQVRWDVSVTWAWBTWDWAWCTW
      RXGXDIZAWMOZXJWRWLWNWNWQUUEXTWLWNWOWQWEZUUFWLWPWQWFAEECDFQUSUUDXIAWMXGXHX
      DXGXBWGWHWIWJWK $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Segment less than or equal to
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Seg<_ $.

  $( Declare the constant for the segment less than or equal to
     relationship. $)
  csegle $a class Seg<_ $.

  ${
    $d p q n a b c d y $.
    $( Define the segment length comparison relationship.  This relationship
       expresses that the segment ` A B ` is no longer than ` C D ` .  In this
       section, we establish various properties of this relationship showing
       that it is a transitive, reflexive relationship on pairs of points that
       is substitutive under congruence.  Definition 5.4 of [Schwabhauser]
       p. 41.  (Contributed by Scott Fenton, 11-Oct-2013.) $)
    df-segle $a |- Seg<_ = { <. p , q >. |
       E. n e. NN E. a e. ( EE ` n ) E. b e. ( EE ` n ) E. c e. ( EE ` n )
       E. d e. ( EE ` n ) ( p = <. a , b >. /\ q = <. c , d >. /\
         E. y e. ( EE ` n ) ( y Btwn <. c , d >. /\
                              <. a , b >. Cgr <. c , y >. ) ) } $.
  $}

  ${
    $d A a $.  $d a b $.  $d A b $.  $d a c $.  $d A c $.  $d a d $.  $d A d $.
    $d a n $.  $d A n $.  $d a p $.  $d A p $.  $d a q $.  $d A q $.  $d a y $.
    $d A y $.  $d B a $.  $d B b $.  $d b c $.  $d B c $.  $d b d $.  $d B d $.
    $d b n $.  $d B n $.  $d b p $.  $d B p $.  $d b q $.  $d B q $.  $d b y $.
    $d B y $.  $d C a $.  $d C b $.  $d C c $.  $d c d $.  $d C d $.  $d c n $.
    $d C n $.  $d c p $.  $d C p $.  $d c q $.  $d C q $.  $d c y $.  $d C y $.
    $d D a $.  $d D b $.  $d D c $.  $d D d $.  $d d n $.  $d D n $.  $d d p $.
    $d D p $.  $d d q $.  $d D q $.  $d d y $.  $d D y $.  $d N a $.  $d N b $.
    $d N c $.  $d N d $.  $d N n $.  $d n p $.  $d n q $.  $d n y $.  $d N y $.
    $d p q $.  $d p y $.  $d q y $.
    $( Binary relationship form of the segment comparison relationship.
       (Contributed by Scott Fenton, 11-Oct-2013.) $)
    brsegle $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
        ( <. A , B >. Seg<_ <. C , D >. <->
          E. y e. ( EE ` N ) ( y Btwn <. C , D >. /\
                  <. A , B >. Cgr <. C , y >. ) ) ) $=
      ( va vb vc vd vn cop wbr cv wceq wa wrex w3a cn wcel vp csegle cbtwn ccgr
      cee cfv opex eqeq1 eqcom syl6bb 3anbi1d rexbidv 2rexbidv 3anbi2d df-segle
      vq brab vex opth biid 3anbi123i 2rexbii rexbii wi simpl2l ad2antrl eleenn
      syl simprlr simprll adantl axdimuniq syl22anc fveq2d rexeqdv exbiri eleq1
      anassrs bi2anan9 anbi2d opeq12 breq1d breq2d opeq1 adantr sylan9bb imbi1d
      wb anbi12d 3imtr4d com12 exp3a expr rexlimdvv rexlimdvva rexlimdva syl5bi
      3impd simpl1 simpl2r simpl3l simpl3r eqidd eqeq1d 3anbi23d anbi1d rspc2ev
      simpr opeq2 syl113anc 3anbi13d syl3anc fveq2 3anbi3d rexeqbidv syl2anc ex
      rspcev impbid syl5bb ) BCLZDELZUBMGNZHNZLZYAOZINZJNZLZYBOZANZYIUCMZYEYGYK
      LZUDMZPZAKNZUEUFZQZRZJYQQZIYQQZHYQQZGYQQZKSQZFSTZBFUEUFZTZCUUFTZPZDUUFTZE
      UUFTZPZRZYKYBUCMZYADYKLZUDMZPZAUUFQZUANZYEOZUPNZYIOZYRRZJYQQZIYQQHYQQZGYQ
      QKSQYFUVBYRRZJYQQZIYQQHYQQZGYQQKSQUUDUAUPYAYBUBBCUGDEUGUUSYAOZUVEUVHKGSYQ
      UVIUVDUVGHIYQYQUVIUVCUVFJYQUVIUUTYFUVBYRUVIUUTYAYEOYFUUSYAYEUHYAYEUIUJUKU
      LUMUMUVAYBOZUVHUUBKGSYQUVJUVGYTHIYQYQUVJUVFYSJYQUVJUVBYJYFYRUVJUVBYBYIOYJ
      UVAYBYIUHYBYIUIUJUNULUMUMAKUPUAGHIJUOUQUUMUUDUURUUDYCBOZYDCOZPZYGDOZYHEOZ
      PZYRRZJYQQIYQQZHYQQGYQQZKSQUUMUURUUCUVSKSUUAUVRGHYQYQYSUVQIJYQYQYFUVMYJUV
      PYRYRYCYDBCGURHURUSYGYHDEIURJURUSYRUTVAVBVBVCUUMUVSUURKSUUMYPSTZPZUVRUURG
      HYQYQUWAYCYQTZYDYQTZPZPUVQUURIJYQYQUWAUWDYGYQTZYHYQTZPZUVQUURVDUWAUWDUWGP
      ZPZUVMUVPYRUURUWIUVMUVPYRUURVDZUVMUVPPZUWIUWJUWKUWABYQTZCYQTZPZDYQTZEYQTZ
      PZPZPZUUQAYQQZUURVDZUWIUWJUVKUVLUVPUWSUXAVDUVKUVLUVPPPZUWSUURUWTUXBUWSPZU
      UQAUUFYQUXCFYPUEUXCUUEUUGUVTUWLFYPOUXCUUGUUEUWAUUGUXBUWRUUGUUHUUEUULUVTVE
      VFZBFVGVHUXDUXBUUMUVTUWRVIUWSUWLUXBUWAUWLUWMUWQVJVKBYPFVLVMVNVOVPVRUWKUWH
      UWRUWAUVMUWDUWNUVPUWGUWQUVKUWBUWLUVLUWCUWMYCBYQVQYDCYQVQVSUVNUWEUWOUVOUWF
      UWPYGDYQVQYHEYQVQVSVSVTUWKYRUWTUURUWKYOUUQAYQUVMYOYLYAYMUDMZPZUVPUUQUVMYN
      UXEYLUVMYEYAYMUDYCYDBCWAWBVTUVPYLUUNUXEUUPUVPYIYBYKUCYGYHDEWAWCUVNUXEUUPW
      HUVOUVNYMUUOYAUDYGDYKWDWCZWEWIWFULWGWJWKWLWRWMWNWOWPWQUUMUURUUDUUMUURPZUU
      EYFYJYOAUUFQZRZJUUFQZIUUFQZHUUFQZGUUFQZUUDUUEUUIUULUURWSUXHUUGUUHYAYAOZYJ
      UXFAUUFQZRZJUUFQIUUFQZUXNUUGUUHUUEUULUURVEUUGUUHUUEUULUURWTUXHUUJUUKUXOYB
      YBOZUURUXRUUJUUKUUEUUIUURXAUUJUUKUUEUUIUURXBUXHYAXCUXHYBXCUUMUURXHUXQUXOU
      XSUURRUXODYHLZYBOZYKUXTUCMZUUPPZAUUFQZRIJDEUUFUUFUVNYJUYAUXPUYDUXOUVNYIUX
      TYBYGDYHWDZXDUVNUXFUYCAUUFUVNYLUYBUXEUUPUVNYIUXTYKUCUYEWCUXGWIULXEUVOUYAU
      XSUYDUURUXOUVOUXTYBYBYHEDXIZXDUVOUYCUUQAUUFUVOUYBUUNUUPUVOUXTYBYKUCUYFWCX
      FULXEXGXJUXLUXRBYDLZYAOZYJYLUYGYMUDMZPZAUUFQZRZJUUFQIUUFQGHBCUUFUUFUVKUXJ
      UYLIJUUFUUFUVKYFUYHUXIUYKYJUVKYEUYGYAYCBYDWDZXDUVKYOUYJAUUFUVKYNUYIYLUVKY
      EUYGYMUDUYMWBVTULXKUMUVLUYLUXQIJUUFUUFUVLUYHUXOUYKUXPYJUVLUYGYAYAYDCBXIZX
      DUVLUYJUXFAUUFUVLUYIUXEYLUVLUYGYAYMUDUYNWBVTULXKUMXGXLUUCUXNKFSYPFOZUUBUX
      MGYQUUFYPFUEXMZUYOUUAUXLHYQUUFUYPUYOYTUXKIYQUUFUYPUYOYSUXJJYQUUFUYPUYOYRU
      XIYFYJUYOYOAYQUUFUYPVOXNXOXOXOXOXRXPXQXSXT $.
  $}

  ${
    $d N x y $.  $d A x y $.  $d B x y $.  $d C x y $.  $d D x y $.
    $( Alternate characterization of segment comparison.  Theorem 5.5 of
       [Schwabhauser] p. 41-42.  (Contributed by Scott Fenton, 11-Oct-2013.) $)
    brsegle2 $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
        ( <. A , B >. Seg<_ <. C , D >. <->
          E. x e. ( EE ` N ) ( B Btwn <. A , x >. /\
                  <. A , x >. Cgr <. C , D >. ) ) ) $=
      ( vy wcel wa w3a cop wbr ccgr wrex wi adantr mpd mp2and wb 3ad2ant1 cn cv
      cee csegle cbtwn brsegle ccgr3 ccolin simprl simpl1 simpl3l simpl3r simpr
      btwncolinear2 syl13anc simpl2l simpl2r simprr cgrcomand lineext syl131anc
      simpl2 simpll1 simplr brcgr3 syl133anc simp2l simp3 mpbird btwnxfr simp32
      an32 cgrcom syl122anc mpbid 3expia sylbid sylanb an32s reximdva rexlimdva
      cfv jca btwncolinear1 simpl3 3jca syl113anc simp2r simp33 cgrcomlr impbid
      ex bitrd ) FUAHZBFUCWBZHZCWOHZIZDWOHZEWOHZIZJZBCKZDEKZUDLGUBZXDUELZXCDXEK
      ZMLZIZGWONZCBAUBZKZUELZXLXDMLZIZAWONZGBCDEFUFXBXJXPXBXIXPGWOXBXEWOHZIZXIX
      PXRXIIZDXEEKZKZBCXKKZKZUGLZAWONZXPXSDXTUHLZXGXCMLZYEXSXFYFXRXFXHUIXRXFYFO
      ZXIXRWNWSWTXQYHWNWRXAXQUJZWSWTWNWRXQUKZWSWTWNWRXQULZXBXQUMZDEXEFUNUOPQXRX
      IBCDXEFYIWPWQWNXAXQUPWPWQWNXAXQUQYJYLXRXFXHURUSXRYFYGIYEOZXIXRWNWSXQWTWRY
      MYIYJYLYKWNWRXAXQVBDXEEBACFUTVAPRXSYDXOAWOXRXKWOHZXIYDXOOZXRYNIXBYNIZXQIZ
      XIYOXBXQYNVLYQXIIYDYGXDXLMLZXTYBMLZJZXOYQYDYTSZXIYQWNWSXQWTWPWQYNUUAWNWRX
      AYNXQVCZYPWSXQWSWTWNWRYNUKPZYPXQUMZYPWTXQWSWTWNWRYNULPZYPWPXQWPWQWNXAYNUP
      ZPZYPWQXQWPWQWNXAYNUQZPZXBYNXQVDZDXEEBCXKFVEVFZPYQXIYTXOYQXIYTJZXMXNUULXF
      YDXMYQXFXHYTVGUULYDYTYQXIYTVHYQXIUUAYTUUKTVIYQXIXFYDIXMOZYTYQWNWSXQWTWPWQ
      YNUUMUUBUUCUUDUUEUUGUUIUUJDXEEBCXKFVJVFTRUULYRXNYQXIYGYRYSVKYQXIYRXNSZYTY
      QWNWSWTWPYNUUNUUBUUCUUEUUGUUJDEBXKFVMVNTVOWCVPVQVRVSVTQWLWAXBXOXJAWOYPXOX
      JYPXOIZBXKCKZKDEXEKZKUGLZGWONZXJUUOBUUPUHLZXNUUSUUOXMUUTYPXMXNUIUUOWNWPYN
      WQXMUUTOWNWRXAYNXOVCYPWPXOUUFPXBYNXOVDYPWQXOUUHPBXKCFWDUOQYPXMXNURYPUUTXN
      IUUSOZXOYPWNWPYNWQXAUVAWNWRXAYNUJUUFXBYNUMZUUHWNWRXAYNWEBXKCDGEFUTVAPRUUO
      UURXIGWOYPXQXOUURXIOYQXOIUURXNXHUUPUUQMLZJZXIYQUURUVDSZXOYQWNWPYNWQJZWSWT
      XQUVEUUBYPUVFXQYPWPYNWQUUFUVBUUHWFPUUCUUEUUDBXKCDEXEFVEWGPYQXOUVDXIYQXOUV
      DJZXFXHUVGXMYCYAUGLZXFYQXMXNUVDVGUVGUVHXHXNYBXTMLZJZUVGXHXNUVIYQXOXNXHUVC
      VKZYQXMXNUVDWHUVGUVCUVIYQXOXNXHUVCWIYQXOUVCUVISZUVDYQWNYNWQWTXQUVLUUBUUJU
      UIUUEUUDXKCEXEFWJVNTVOWFYQXOUVHUVJSZUVDYQWNWPWQYNWSXQWTUVMUUBUUGUUIUUJUUC
      UUDUUEBCXKDXEEFVEVFTVIYQXOXMUVHIXFOZUVDYQWNWPWQYNWSXQWTUVNUUBUUGUUIUUJUUC
      UUDUUEBCXKDXEEFVJVFTRUVKWCVPVQVSVTQWLWAWKWM $.
  $}

  ${
    $d N y z $.  $d A y z $.  $d B y z $.  $d C y z $.  $d D y z $.
    $d E y z $.  $d F y z $.  $d G y z $.  $d H y z $.
    $( Substitution law for segment comparison under congruence.  Theorem 5.6
       of [Schwabhauser] p. 42.  (Contributed by Scott Fenton, 11-Oct-2013.) $)
    seglecgr12im $p |- (
       ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
         ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
       ( ( <. A , B >. Cgr <. E , F >. /\ <. C , D >. Cgr <. G , H >. /\
           <. A , B >. Seg<_ <. C , D >. ) ->
           <. E , F >. Seg<_ <. G , H >. ) ) $=
      ( vy vz wcel w3a cop ccgr wbr wi wa wrex adantr cn cee csegle cbtwn ccgr3
      cv simprrl simprlr simpl11 simpl21 simpr simpl22 simpl32 cgrxfr syl132anc
      cfv simpl33 mp2and anass wb simprl simprr brcgr3 syl133anc df-3an simpl23
      simpl31 simpl12 simpl13 simpr1l simpr2r cgrtr4and simpr31 cgrtrand sylbid
      sylan2br expr anim2d sylanb an32s reximdva rexlimdva simp11 simp12 simp13
      simp21 simp22 brsegle syl122anc simp23 simp31 simp32 simp33 3imtr4d exp32
      mpd 3impd ) IUALZAIUBUPZLZBWSLZMZCWSLZDWSLZEWSLZMZFWSLZGWSLZHWSLZMZMZABNZ
      EFNZOPZCDNZGHNZOPZXLXOUCPZXMXPUCPZXKXNXQXRXSQXKXNXQRZRZJUFZXOUDPZXLCYBNZO
      PZRZJWSSZKUFZXPUDPZXMGYHNZOPZRZKWSSZXRXSYAYFYMJWSXKYBWSLZXTYFYMQXKYNRZXTY
      FYMYOXTYFRZRZYICYBDNZNGYHHNZNUEPZRZKWSSZYMYQYCXQUUBYOXTYCYEUGYOXNXQYFUHYO
      YCXQRUUBQZYPYOWRXCYNXDXHXIUUCWRWTXAXFXJYNUIXCXDXEXBXJYNUJXKYNUKXCXDXEXBXJ
      YNULXGXHXIXBXFYNUMXGXHXIXBXFYNUQCYBDGKHIUNUOTURYQUUAYLKWSYOYHWSLZYPUUAYLQ
      ZYOUUDRXKYNUUDRZRZYPUUEXKYNUUDUSUUGYPRZYTYKYIUUHYTYDYJOPZXQYRYSOPZMZYKUUG
      YTUUKUTZYPUUGWRXCYNXDXHUUDXIUULWRWTXAXFXJUUFUIZXCXDXEXBXJUUFUJZXKYNUUDVAZ
      XCXDXEXBXJUUFULXGXHXIXBXFUUFUMZXKYNUUDVBZXGXHXIXBXFUUFUQCYBDGYHHIVCVDTUUG
      YPUUKYKYPUUKRUUGXTYFUUKMZYKXTYFUUKVEUUGUUREFCYBGYHIUUMXCXDXEXBXJUUFVFZXGX
      HXIXBXFUUFVGZUUNUUOUUPUUQUUGUURABEFCYBIUUMWRWTXAXFXJUUFVHWRWTXAXFXJUUFVIU
      USUUTUUNUUOXNXQYFUUKUUGVJYCYEXTUUKUUGVKVLUUIXQUUJXTYFUUGVMVNVPVQVOVRVSVTW
      AWPVQVTWBXKXRYGUTZXTXKWRWTXAXCXDUVAWRWTXAXFXJWCZWRWTXAXFXJWDWRWTXAXFXJWEX
      BXCXDXEXJWFXBXCXDXEXJWGJABCDIWHWITXKXSYMUTZXTXKWRXEXGXHXIUVCUVBXBXCXDXEXJ
      WJXBXFXGXHXIWKXBXFXGXHXIWLXBXFXGXHXIWMKEFGHIWHWITWNWOWQ $.
  $}

  $( Substitution law for segment comparison under congruence.  Biconditional
     version.  (Contributed by Scott Fenton, 15-Oct-2013.)  (Revised by Mario
     Carneiro, 19-Apr-2014.) $)
  seglecgr12 $p |- (
       ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
         ( C e. ( EE ` N ) /\ D e. ( EE ` N ) /\ E e. ( EE ` N ) ) /\
         ( F e. ( EE ` N ) /\ G e. ( EE ` N ) /\ H e. ( EE ` N ) ) ) ->
       ( ( <. A , B >. Cgr <. E , F >. /\ <. C , D >. Cgr <. G , H >. ) ->
           ( <. A , B >. Seg<_ <. C , D >. <->
             <. E , F >. Seg<_ <. G , H >. ) ) ) $=
    ( wcel w3a cop ccgr wbr wa csegle df-3an seglecgr12im syl5bir exp3a cee cfv
    cn simp11 simp12 simp13 simp23 simp31 cgrcom syl122anc simp21 simp22 simp32
    wi wb simp33 anbi12d syl333anc sylbid impbidd ) IUCJZAIUAUBZJZBVBJZKZCVBJZD
    VBJZEVBJZKZFVBJZGVBJZHVBJZKZKZABLZEFLZMNZCDLZGHLZMNZOZVOVRPNZVPVSPNZVNWAWBW
    CWAWBOVQVTWBKVNWCVQVTWBQABCDEFGHIRSTVNWAVPVOMNZVSVRMNZOZWCWBUNVNVQWDVTWEVNV
    AVCVDVHVJVQWDUOVAVCVDVIVMUDZVAVCVDVIVMUEZVAVCVDVIVMUFZVEVFVGVHVMUGZVEVIVJVK
    VLUHZABEFIUIUJVNVAVFVGVKVLVTWEUOWGVEVFVGVHVMUKZVEVFVGVHVMULZVEVIVJVKVLUMZVE
    VIVJVKVLUPZCDGHIUIUJUQVNWFWCWBWFWCOWDWEWCKZVNWBWDWEWCQVNVAVHVJVKVLVCVDVFVGW
    PWBUNWGWJWKWNWOWHWIWLWMEFGHABCDIRURSTUSUT $.

  ${
    $d A y $.  $d B y $.  $d N y $.
    $( Segment comparison is reflexive.  Theorem 5.7 of [Schwabhauser] p. 42.
       (Contributed by Scott Fenton, 11-Oct-2013.) $)
    seglerflx $p |- ( ( N e. NN /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ->
        <. A , B >. Seg<_ <. A , B >. ) $=
      ( vy cn wcel cee cfv w3a cop csegle cv cbtwn ccgr wa wrex simp3 btwntriv2
      wbr cgrrflx wceq breq1 opeq2 breq2d anbi12d rspcev syl12anc simp1 brsegle
      wb simp2 syl122anc mpbird ) CEFZACGHZFZBUOFZIZABJZUSKSZDLZUSMSZUSAVAJZNSZ
      OZDUOPZURUQBUSMSZUSUSNSZVFUNUPUQQZABCRABCTVEVGVHODBUOVABUAZVBVGVDVHVABUSM
      UBVJVCUSUSNVABAUCUDUEUFUGURUNUPUQUPUQUTVFUJUNUPUQUHUNUPUQUKZVIVKVIDABABCU
      IULUM $.
  $}

  ${
    $d N y $.  $d A y $.  $d B y $.  $d C y $.
    $( Any segment is at least as long as a degenerate segment.  Theorem 5.11
       of [Schwabhauser] p. 42.  (Contributed by Scott Fenton, 11-Oct-2013.) $)
    seglemin $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
       <. A , A >. Seg<_ <. B , C >. ) $=
      ( vy cn wcel cee cfv w3a wa cop csegle wbr cv cbtwn ccgr simpr2 btwntriv1
      wrex 3adant3r1 cgrtriv 3adant3r3 wceq breq1 opeq2 breq2d anbi12d syl12anc
      rspcev wb simpl simpr1 simpr3 brsegle syl122anc mpbird ) DFGZADHIZGZBUSGZ
      CUSGZJZKZAALZBCLZMNZEOZVFPNZVEBVHLZQNZKZEUSTZVDVABVFPNZVEBBLZQNZVMURUTVAV
      BRZURVAVBVNUTBCDSUAURUTVAVPVBABDUBUCVLVNVPKEBUSVHBUDZVIVNVKVPVHBVFPUEVRVJ
      VOVEQVHBBUFUGUHUJUIVDURUTUTVAVBVGVMUKURVCULURUTVAVBUMZVSVQURUTVAVBUNEAABC
      DUOUPUQ $.
  $}

  ${
    $d N y z w $.  $d A y z w $.  $d B y z w $.  $d C y z w $.  $d D y z w $.
    $d E y z w $.  $d F y z w $.
    $( Segment less than is transitive.  Theorem 5.8 of [Schwabhauser] p. 42.
       (Contributed by Scott Fenton, 11-Oct-2013.) $)
    segletr $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) /\
       ( D e. ( EE ` N ) /\ E e. ( EE ` N ) /\ F e. ( EE ` N ) ) ) ->
       ( ( <. A , B >. Seg<_ <. C , D >. /\ <. C , D >. Seg<_ <. E , F >. ) ->
         <. A , B >. Seg<_ <. E , F >. ) ) $=
      ( vy vz vw wcel w3a cv cop cbtwn wbr ccgr wa wrex wb cee cfv csegle ccgr3
      cn simprll simprrr wi simpl1 simpl23 simprl simpl31 simpl32 simprr cgrxfr
      jca syl132anc adantr mpd df-3an anbi2i bitr4i simpr1 simpr3 simpr2 brcgr3
      anass simpl33 simpr3l simpr2l btwnexchand simpl21 simpl22 simpr1r simp3r1
      syl133anc anbi2d adantl cgrtrand sylan2br sylbid an32s reximdva rexlimdvv
      expr sylanb exp31 simp1 simp21 simp22 simp23 simp31 brsegle simp32 simp33
      syl122anc anbi12d reeanv syl6bbr 3imtr4d ) GUEKZAGUAUBZKZBXBKZCXBKZLZDXBK
      ZEXBKZFXBKZLZLZHMZCDNZOPZABNZCXLNZQPZRZIMZEFNZOPZXMEXSNZQPZRZRZIXBSHXBSZJ
      MZXTOPZXOEYGNZQPZRZJXBSZXOXMUCPZXMXTUCPZRZXOXTUCPZXKYEYLHIXBXBXKXLXBKZXSX
      BKZRZYEYLXKYSRZYERZYGYBOPZCXLDNZNEYGXSNZNUDPZRZJXBSZYLUUAXNYCRZUUGUUAXNYC
      YTXNXQYDUFYTXRYAYCUGUPYTUUHUUGUHZYEYTXAXEYQXGXHYRUUIXAXFXJYSUIXCXDXEXAXJY
      SUJXKYQYRUKXGXHXIXAXFYSULXGXHXIXAXFYSUMXKYQYRUNCXLDEJXSGUOUQURUSUUAUUFYKJ
      XBYTYGXBKZYEUUFYKUHZYTUUJRZXKYQYRUUJLZRZYEUUKUULXKYSUUJRZRUUNXKYSUUJVGUUM
      UUOXKYQYRUUJUTVAVBUUNYERUUFUUBXPYIQPZYCUUCUUDQPZLZRZYKUUNUUFUUSTYEUUNUUEU
      URUUBUUNXAXEYQXGXHUUJYRUUEUURTXAXFXJUUMUIZXCXDXEXAXJUUMUJZXKYQYRUUJVCZXGX
      HXIXAXFUUMULXGXHXIXAXFUUMUMZXKYQYRUUJVDZXKYQYRUUJVEZCXLDEYGXSGVFVPVQURUUN
      YEUUSYKYEUUSRUUNXRYDUUSLZYKXRYDUUSUTUUNUVFRYHYJUUNUVFEYGXSFGUUTUVCUVDUVEX
      GXHXIXAXFUUMVHUUBUURXRYDUUNVIYAYCXRUUSUUNVJVKUUNUVFABCXLEYGGUUTXCXDXEXAXJ
      UUMVLXCXDXEXAXJUUMVMUVAUVBUVCUVDXNXQYDUUSUUNVNUVFUUPUUNUUPYCUUQUUBXRYDVOV
      RVSUPVTWEWAWFWBWCUSWGWDXKYOXRHXBSZYDIXBSZRYFXKYMUVGYNUVHXKXAXCXDXEXGYMUVG
      TXAXFXJWHZXAXCXDXEXJWIZXAXCXDXEXJWJZXAXCXDXEXJWKZXAXFXGXHXIWLZHABCDGWMWPX
      KXAXEXGXHXIYNUVHTUVIUVLUVMXAXFXGXHXIWNZXAXFXGXHXIWOZICDEFGWMWPWQXRYDHIXBX
      BWRWSXKXAXCXDXHXIYPYLTUVIUVJUVKUVNUVOJABEFGWMWPWT $.
  $}

  ${
    $d N y t $.  $d A y t $.  $d B y t $.  $d C y t $.  $d D y t $.
    $( Antisymmetry law for segment comparison.  Theorem 5.9 of [Schwabhauser]
       p. 42.  (Contributed by Scott Fenton, 14-Oct-2013.) $)
    segleantisym $p |- ( ( N e. NN /\
        ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
        ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
        ( ( <. A , B >. Seg<_ <. C , D >. /\ <. C , D >. Seg<_ <. A , B >. ) ->
          <. A , B >. Cgr <. C , D >. ) ) $=
      ( vy vt wcel wa cop csegle wbr cv cbtwn ccgr wrex anbi12d simprll simprrl
      simprlr cn cee cfv w3a brsegle brsegle2 3com23 reeanv syl6bbr weq simpl3l
      simpl1 simprr simprl simpl3r btwnexchand simpl2l simpl2r simprrr cgrtrand
      wb endofsegidand opeq2 breq2d breq1d anbi2d wceq btwncomand wi btwnswapid
      syl13anc adantr mp2and syl5ibrcom mpd syl6bi mpcom exp31 rexlimdvv sylbid
      ) EUAHZAEUBUCZHZBWBHZIZCWBHZDWBHZIZUDZABJZCDJZKLZWKWJKLZIZFMZWKNLZWJCWOJZ
      OLZIZDCGMZJZNLZXAWJOLZIZIZGWBPFWBPZWJWKOLZWIWNWSFWBPZXDGWBPZIXFWIWLXHWMXI
      FABCDEUEWAWHWEWMXIVAGCDABEUFUGQWSXDFGWBWBUHUIWIXEXGFGWBWBWIWOWBHZWTWBHZIZ
      XEXGGFUJZWIXLIZXEIZXGXNXECWTWOEWAWEWHXLULZWFWGWAWEXLUKZWIXJXKUMZWIXJXKUNZ
      XNXECWODWTEXPXQXSWFWGWAWEXLUOZXRXNWPWRXDRXNWSXBXCSUPXNXECWTABCWOEXPXQXRWC
      WDWAWHXLUQWCWDWAWHXLURXQXSXNWSXBXCUSXNWPWRXDTUTVBXMXOXNWSDWQNLZWQWJOLZIZI
      ZIZXGXMXEYDXNXMXDYCWSXMXBYAXCYBXMXAWQDNWTWOCVCZVDXMXAWQWJOYFVEQVFVFYEDWOV
      GZXGYEDWOCJNLZWODCJNLZYGXNYDDCWOEXPXTXQXSXNWSYAYBSVHXNYDWOCDEXPXSXQXTXNWP
      WRYCRVHXNYHYIIYGVIZYDXNWAWGXJWFYJXPXTXSXQDWOCEVJVKVLVMYEXGYGWRXNWPWRYCTYG
      WKWQWJODWOCVCVDVNVOVPVQVRVSVT $.
  $}

  ${
    $d N x $.  $d A x $.  $d B x $.  $d C x $.  $d D x $.
    $( Linearity law for segment comparison.  Theorem 5.10 of [Schwabhauser]
       p. 42.  (Contributed by Scott Fenton, 14-Oct-2013.) $)
    seglelin $p |- ( ( N e. NN /\
     ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
     ( C e. ( EE ` N ) /\ D e. ( EE ` N ) ) ) ->
     ( <. A , B >. Seg<_ <. C , D >. \/ <. C , D >. Seg<_ <. A , B >. ) ) $=
      ( vx cn wcel cee cfv wa w3a cop cbtwn wbr wo ccgr wrex csegle wb cv andir
      segcon2 simpl1 simpl2l simpr simpl3 cgrcom syl121anc anbi2d orbi2d syl5bb
      rexbidva brsegle2 brsegle 3com23 orbi12d r19.43 syl6bbr bitr4d mpbid ) EG
      HZAEIJZHZBVCHZKZCVCHDVCHKZLZBAFUAZMZNOZVIABMZNOZPVJCDMZQOZKZFVCRZVLVNSOZV
      NVLSOZPZFBCDAEUCVHVQVKVOKZVMVNVJQOZKZPZFVCRZVTVHVPWDFVCVPWAVMVOKZPVHVIVCH
      ZKZWDVKVMVOUBWHWFWCWAWHVOWBVMWHVBVDWGVGVOWBTVBVFVGWGUDVDVEVBVGWGUEVHWGUFV
      BVFVGWGUGAVICDEUHUIUJUKULUMVHVTWAFVCRZWCFVCRZPWEVHVRWIVSWJFABCDEUNVBVGVFV
      SWJTFCDABEUOUPUQWAWCFVCURUSUTVA $.
  $}

  ${
    $d N x $.  $d A x $.  $d B x $.  $d C x $.
    $( If ` B ` falls between ` A ` and ` C ` , then ` A B ` is no longer than
       ` A C ` .  (Contributed by Scott Fenton, 16-Oct-2013.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    btwnsegle $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
       ( B Btwn <. A , C >. -> <. A , B >. Seg<_ <. A , C >. ) ) $=
      ( vx cn wcel cee cfv w3a wa cop cbtwn wbr csegle ccgr wrex simplr2 adantr
      cv simpr simpl simpr1 simpr2 cgrrflxd breq1 opeq2 breq2d anbi12d syl12anc
      wceq rspcev wb simpr3 brsegle syl122anc mpbird ex ) DFGZADHIZGZBUTGZCUTGZ
      JZKZBACLZMNZABLZVFONZVEVGKZVIETZVFMNZVHAVKLZPNZKZEUTQZVJVBVGVHVHPNZVPVAVB
      VCUSVGRVEVGUAVEVQVGVEABDUSVDUBZUSVAVBVCUCZUSVAVBVCUDZUESVOVGVQKEBUTVKBUKZ
      VLVGVNVQVKBVFMUFWAVMVHVHPVKBAUGUHUIULUJVEVIVPUMZVGVEUSVAVBVAVCWBVRVSVTVSU
      SVAVBVCUNEABACDUOUPSUQUR $.
  $}

  $( Given three colinear points ` A ` , ` B ` , and ` C ` , ` B ` falls in the
     middle iff the two segments to ` B ` are no longer than ` A C ` .  Theorem
     5.12 of [Schwabhauser] p. 42.  (Contributed by Scott Fenton,
     15-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  colinbtwnle $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( A Colinear <. B , C >. ->
        ( B Btwn <. A , C >. <->
          ( <. A , B >. Seg<_ <. A , C >. /\
            <. B , C >. Seg<_ <. A , C >. ) ) ) ) $=
    ( wcel w3a wa cop wbr cbtwn csegle btwnsegle sylan2b ccgr mp2and adantr imp
    wb wi ex cn cee ccolin 3anrev 3ancoma btwncom simpl simpr2 simpr3 cgrrflx2d
    cfv simpr1 seglecgr12 syl333anc 3imtr4d jcad w3o brcolinear wceq btwncomand
    simprl biimpa adantrl 3anrot sylan2br sylbid adantrr segleantisym syl122anc
    endofsegidand btwntriv1 3adant3r2 breq1 syl5ibrcom mpd expr adantld biimprd
    a1dd simprr 3ancomb btwntriv2 adantrd 3jaod impbid ) DUAEZADUBUKZEZBWGEZCWG
    EZFZGZABCHZUCIZBACHZJIZABHZWOKIZWMWOKIZGZRWLWNGWPWTWLWPWTSWNWLWPWRWSABCDLWL
    BCAHZJIZCBHZXAKIZWPWSWKWFWJWIWHFXBXDSWHWIWJUDCBADLMWKWFWIWHWJFWPXBRWHWIWJUE
    BACDUFMZWLWMXCNIZWOXANIZWSXDRZWLBCDWFWKUGZWFWHWIWJUHZWFWHWIWJUIZUJWLACDXIWF
    WHWIWJULZXKUJWLWFWIWJWHWJWJWIWJWHXFXGGXHSXIXJXKXLXKXKXJXKXLBCACCBCADUMUNOZU
    OUPPWLWNWTWPSZWLWNAWMJIZXBCWQJIZUQXNABCDURWLXOXNXBXPWLXOXNWLXOGWSWPWRWLXOWS
    WPWLXOWSGZGZBAUSZWPWLXQCBADXIXKXJXLWLXQABCDXIXLXJXKWLXOWSVAUTXRXDXAXCKIZXCX
    ANIZWLWSXDXOWLWSXDXMVBVCWLXOXTWSWLXOXTWLXOAXCJIZXTABCDUFWKWFWJWHWIFYBXTSWJW
    HWIVDCABDLVEVFQVGWLXDXTGYASZXQWLWFWJWIWJWHYCXIXKXJXKXLCBCADVHVIPOVJWLXSWPSX
    QWLWPXSAWOJIZWFWHWJYDWIACDVKVLBAWOJVMVNPVOVPVQTWLXBWPWTWLWPXBXEVRVSWLXPXNWL
    XPGWRWPWSWLXPWRWPWLXPWRGZGZBCUSZWPWLYEABCDXIXLXJXKWLXPWRVAYFWRWOWQKIZWQWONI
    ZWLXPWRVTWLXPYHWRWLXPYHWKWFWHWJWIFXPYHSWHWIWJWAACBDLMQVGWLWRYHGYISZYEWLWFWH
    WIWHWJYJXIXLXJXLXKABACDVHVIPOVJWLYGWPSYEWLWPYGCWOJIZWFWHWJYKWIACDWBVLBCWOJV
    MVNPVOVPWCTWDVFQWET $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Outside of relationship
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c OutsideOf $.

  $( Declare the syntax for the outside of constant. $)
  coutsideof $a class OutsideOf $.

  $( The outside of relationship.  This relationship expresses that ` P ` ,
     ` A ` , and ` B ` fall on a line, but ` P ` is not on the segment
     ` A B ` .  This definition is taken from theorem 6.4 of [Schwabhauser]
     p. 43, since it requires no dummy variables.  (Contributed by Scott
     Fenton, 17-Oct-2013.) $)
  df-outsideof $a |- OutsideOf = ( Colinear \ Btwn ) $.

  $( Binary relationship form of ` OutsideOf ` .  Theorem 6.4 of [Schwabhauser]
     p. 43.  (Contributed by Scott Fenton, 17-Oct-2013.)  (Revised by Mario
     Carneiro, 19-Apr-2014.) $)
  broutsideof $p |- ( P OutsideOf <. A , B >. <->
    ( P Colinear <. A , B >. /\ -. P Btwn <. A , B >. ) ) $=
    ( cop coutsideof wbr ccolin cbtwn cdif wn wa df-outsideof breqi brdif bitri
    ) CABDZEFCPGHIZFCPGFCPHFJKCPEQLMCPGHNO $.

  $( Alternate form of ` OutsideOf ` .  Definition 6.1 of [Schwabhauser]
     p. 43.  (Contributed by Scott Fenton, 17-Oct-2013.)  (Revised by Mario
     Carneiro, 19-Apr-2014.) $)
  broutsideof2 $p |- ( ( N e. NN /\
    ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) ->
    ( P OutsideOf <. A , B >. <->
      ( A =/= P /\ B =/= P /\
        ( A Btwn <. P , B >. \/ B Btwn <. P , A >. ) ) ) ) $=
    ( cop wbr cbtwn wa wcel w3a wne wceq 3adant3r1 breq1 syl5ibcom necon3bd imp
    adantrl wi a1i coutsideof ccolin wn cee cfv broutsideof btwntriv1 btwntriv2
    cn wo w3o brcolinear pm2.24 wb 3anrot btwncom sylan2b orc syl6bi a1dd 3jaod
    olc sylbid imp32 3jca simp3 3ancomb btwncolinear2 btwncolinear1 jaod simpr2
    a1d syl5 neneqd simprl1 simprr simpl simpr1 simpr3 btwnswapid adantr mp2and
    syl13anc expr mtod 3exp2 btwncomand sylan2br com12 com4l jca impbida syl5bb
    3imp2 ) CABEZUAFCWOUBFZCWOGFZUCZHZDUIIZCDUDUEZIZAXAIZBXAIZJZHZACKZBCKZACBEG
    FZBCAEGFZUJZJZABCUFXFWSXLXFWSHXGXHXKXFWRXGWPXFWRXGXFWQACXFAWOGFZACLZWQWTXCX
    DXMXBABDUGMACWOGNOPQRXFWRXHWPXFWRXHXFWQBCXFBWOGFZBCLZWQWTXCXDXOXBABDUHMBCWO
    GNOPQRXFWPWRXKXFWPWQABCEGFZXJUKWRXKSZCABDULXFWQXRXQXJWQXRSXFWQXKUMTXFXQXKWR
    XFXQXIXKXEWTXCXDXBJXQXIUNXBXCXDUOABCDUPUQXIXJURUSUTXJXRSXFXJXKWRXJXIVBVLTVA
    VCVDVEXFXLHWPWRXFXLWPXLXKXFWPXGXHXKVFXFXIWPXJXEWTXBXDXCJXIWPSXBXCXDVGCBADVH
    UQCABDVIVJVMQXFXGXHXKWRXKXFXGXHWRXFXKXGXHWRSSZXFXIXSXJXFXIXGXHWRXFXIXGXHJZH
    ZWQXNYAACXFXIXGXHVKVNXFXTWQXNXFXTWQHZHXIWQXNXIXGXHWQXFVOXFXTWQVPXFXIWQHXNSZ
    YBXFWTXCXBXDYCWTXEVQZWTXBXCXDVKZWTXBXCXDVRZWTXBXCXDVSZACBDVTWCWAWBWDWEWFXFX
    JXGXHWRXFXJXGXHJZHZWQXPYIBCXFXJXGXHVSVNXFYHWQXPXFYHWQHZHXJCBAEGFZXPXJXGXHWQ
    XFVOXFYJCABDYDYFYEYGXFYHWQVPWGXFXJYKHXPSZYJXEWTXDXBXCJYLXDXBXCUOBCADVTWHWAW
    BWDWEWFVJWIWJWNWKWLWM $.

  $( Outsideness implies inequality.  (Contributed by Scott Fenton,
     18-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  outsidene1 $p |- ( ( N e. NN /\
   ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) ->
   ( P OutsideOf <. A , B >. -> A =/= P ) ) $=
    ( cn wcel cee cfv w3a wa cop coutsideof wbr wne cbtwn wo broutsideof2 simp1
    syl6bi ) DEFCDGHZFATFBTFIJCABKLMACNZBCNZACBKOMBCAKOMPZIUAABCDQUAUBUCRS $.

  $( Outsideness implies inequality.  (Contributed by Scott Fenton,
     18-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  outsidene2 $p |- ( ( N e. NN /\
   ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) ->
   ( P OutsideOf <. A , B >. -> B =/= P ) ) $=
    ( cn wcel cee cfv w3a wa cop coutsideof wbr wne cbtwn wo broutsideof2 simp2
    syl6bi ) DEFCDGHZFATFBTFIJCABKLMACNZBCNZACBKOMBCAKOMPZIUBABCDQUAUBUCRS $.

  $( A principle linking outsideness to betweenness.  Theorem 6.2 of
     [Schwabhauser] p. 43.  (Contributed by Scott Fenton, 18-Oct-2013.)
     (Revised by Mario Carneiro, 19-Apr-2014.) $)
  btwnoutside $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ P e. ( EE ` N ) ) ) ->
    ( ( ( A =/= P /\ B =/= P /\ C =/= P ) /\ P Btwn <. A , C >. ) ->
      ( P Btwn <. B , C >. <-> P OutsideOf <. A , B >. ) ) ) $=
    ( wcel wa w3a wne cop cbtwn wbr wb df-3an simpr2 btwncomand simpr3 sylan2br
    adantr expr cee cfv coutsideof simpr11 simpr12 simpr13 simp3r simp2l simp3l
    cn wo simp1 simp2r wi btwnconn2 3com23 mp3and simp3 btwnouttr2 btwnexch3and
    3jca syl122anc jaod syl5 impbid broutsideof2 syl13anc bitr4d ex ) EUJFZAEUA
    UBZFZBVKFZGZCVKFZDVKFZGZHZADIZBDIZCDIZHZDACJKLZGZDBCJKLZDABJUCLZMVRWDGZWEVS
    VTADBJKLZBDAJKLZUKZHZWFWGWEWKVRWDWEWKWDWEGVRWBWCWEHZWKWBWCWENVRWLGZVSVTWJVS
    VTWAWCWEVRUDVSVTWAWCWEVRUEWMWADCAJKLZDCBJKLZWJVSVTWAWCWEVRUFVRWLDACEVJVNVQU
    LZVJVNVOVPUGZVJVLVMVQUHZVJVNVOVPUIZVRWBWCWEOPVRWLDBCEWPWQVJVLVMVQUMZWSVRWBW
    CWEQPVRWAWNWOHWJUNZWLVJVQVNXACDABEUOUPSUQVARTWKWJWGWEVSVTWJURWGWHWEWIVRWDWH
    WEWDWHGVRWBWCWHHZWEWBWCWHNVRXBGVSABDJKLZWCWEVSVTWAWCWHVRUDVRXBADBEWPWRWQWTV
    RWBWCWHQPVRWBWCWHOVRVSXCWCHWEUNZXBVRVJVMVLVPVOXDWPWTWRWQWSBADCEUSVBSUQRTVRW
    DWIWEWDWIGVRWBWCWIHZWEWBWCWINVRXEABDCEWPWRWTWQWSVRXEBDAEWPWTWQWRVRWBWCWIQPV
    RWBWCWIOUTRTVCVDVEVRWFWKMZWDVRVJVPVLVMXFWPWQWRWTABDEVFVGSVHVI $.

  ${
    $d N c $.  $d A c $.  $d B c $.  $d P c $.
    $( Characterization of outsideness in terms of relationship to a fourth
       point.  Theorem 6.3 of [Schwabhauser] p. 43.  (Contributed by Scott
       Fenton, 18-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    broutsideof3 $p |- ( ( N e. NN /\
       ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) ->
       ( P OutsideOf <. A , B >. <->
         ( A =/= P /\ B =/= P /\
           E. c e. ( EE ` N ) ( c =/= P /\ P Btwn <. A , c >. /\
                                P Btwn <. B , c >. ) ) ) ) $=
      ( wcel w3a wa cop wbr wne cbtwn simpr3 adantr wi df-3an btwncomand simpr2
      wrex expr cn cee cfv coutsideof wo cv broutsideof2 simpl btwndiff syl3anc
      simpr1 3anass necomd simp1 simp23 simp22 simp21 simpr1r btwnexch3and 3jca
      simp3 syl2anbr an32s reximdva jaod simprr1 simpll simplr1 simplr2 simprr2
      simpr simplr3 simprr3 btwnconn2 syl122anc mp3and rexlimdva impbid 3bitr4g
      mpd pm5.32da bitrd ) DUAFZCDUBUCZFZAWDFZBWDFZGZHZCABIUDJACKZBCKZACBILJZBC
      AILJZUEZGZWJWKEUFZCKZCAWPILJZCBWPILJZGZEWDSZGZABCDUGWIWJWKHZWNHXCXAHWOXBW
      IXCWNXAWIXCHZWNXAXDWLXAWMWIXCWLXAWIXCWLHZHZWSCWPKZHZEWDSZXAWIXIXEWIWCWGWE
      XIWCWHUHZWCWEWFWGMWCWEWFWGUKZBCDEUIUJNXFXHWTEWDWIWPWDFZXEXHWTOWIXLHZXEXHW
      TXMWCWHXLGZXEWSXGGZWTXEXHHWCWHXLPZXEWSXGULXNXOHZWQWRWSXQCWPXNXEWSXGMUMXNX
      OBACWPDWCWHXLUNZWCWEWFWGXLUOZWCWEWFWGXLUPZWCWEWFWGXLUQZWCWHXLVAZXNXOACBDX
      RXTYAXSXCWLWSXGXNURQXNXEWSXGRZUSYCUTVBTVCVDVTTWIXCWMXAWIXCWMHZHZWRXGHZEWD
      SZXAWIYGYDWIWCWFWEYGXJWCWEWFWGRXKACDEUIUJNYEYFWTEWDWIXLYDYFWTOXMYDYFWTXMX
      NYDWRXGGZWTYDYFHXPYDWRXGULXNYHHZWQWRWSYICWPXNYDWRXGMUMXNYDWRXGRZXNYHABCWP
      DXRXTXSYAYBXNYHBCADXRXSYAXTXCWMWRXGXNURQYJUSUTVBTVCVDVTTVEXDWTWNEWDWIXLXC
      WTWNOXMXCWTWNXMXCWTHZHWQCWPAILJZCWPBILJZWNWQWRWSXCXMVFXMYKCAWPDWCWHXLVGZW
      EWFWGWCXLVHZWEWFWGWCXLVIZWIXLVKZWQWRWSXCXMVJQXMYKCBWPDYNYOWEWFWGWCXLVLZYQ
      WQWRWSXCXMVMQXMWQYLYMGWNOZYKXMWCXLWEWFWGYSYNYQYOYPYRWPCABDVNVONVPTVCVQVRW
      AWJWKWNPWJWKXAPVSWB $.
  $}

  $( Reflexitivity of outsideness.  Theorem 6.5 of [Schwabhauser] p. 44.
     (Contributed by Scott Fenton, 18-Oct-2013.)  (Revised by Mario Carneiro,
     19-Apr-2014.) $)
  outsideofrflx $p |- ( ( N e. NN /\ P e. ( EE ` N ) /\ A e. ( EE ` N ) ) ->
    ( A =/= P -> P OutsideOf <. A , A >. ) ) $=
    ( cn wcel cee cfv w3a wne cop ccolin wbr cbtwn wn coutsideof axbtwnid eqcom
    wa wceq syl6ib necon3ad colineartriv2 jctild broutsideof syl6ibr ) CDEBCFGZ
    EAUFEHZABIZBAAJZKLZBUIMLZNZRBUIOLUGUHULUJUGUKABUGUKBASABSBACPBAQTUABACUBUCA
    ABUDUE $.

  $( Commutitivity law for outsideness.  Theorem 6.6 of [Schwabhauser] p. 44.
     (Contributed by Scott Fenton, 18-Oct-2013.)  (Revised by Mario Carneiro,
     19-Apr-2014.) $)
  outsideofcom $p |- ( ( N e. NN /\
    ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) ->
    ( P OutsideOf <. A , B >. <-> P OutsideOf <. B , A >. ) ) $=
    ( cn cee cfv w3a wa wne cop cbtwn wbr wo coutsideof wb 3ancoma broutsideof2
    wcel orcom 3anbi3i bitri a1i 3ancomb sylan2b 3bitr4d ) DESZCDFGZSZAUHSZBUHS
    ZHZIZACJZBCJZACBKLMZBCAKLMZNZHZUOUNUQUPNZHZCABKOMCBAKOMZUSVAPUMUSUOUNURHVAU
    NUOURQURUTUOUNUPUQTUAUBUCABCDRULUGUIUKUJHVBVAPUIUJUKUDBACDRUEUF $.

  ${
    $( Transitivity law for outsideness.  Theorem 6.7 of [Schwabhauser] p. 44.
       (Contributed by Scott Fenton, 18-Oct-2013.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    outsideoftr $p |- ( ( N e. NN /\ ( A e. ( EE ` N ) /\ B e. ( EE ` N ) )
          /\
    ( C e. ( EE ` N ) /\ P e. ( EE ` N ) ) ) ->
    ( ( P OutsideOf <. A , B >. /\ P OutsideOf <. B , C >. ) ->
      P OutsideOf <. A , C >. ) ) $=
      ( wcel wa w3a wne cop cbtwn wbr wo coutsideof wi simprr df-3an expr jaod
      wb cee cfv simpll simplr 3jca simplr1 simplr3 simp3r simp2l simp2r simp3l
      simp1 simpr2 simpr3 btwnexchand orcd sylan2br simprlr btwnconn3 syl122anc
      cn adantr mp2and simpll2 adantl necomd btwnconn1 mp3and imp32 exp31 imp3a
      olcd syl5 broutsideof2 syl13anc anbi12d anbi12i an4 bitr4i syl6bb 3imtr4d
      ) EVAFZAEUAUBZFZBWCFZGZCWCFZDWCFZGZHZADIZBDIZGZWLCDIZGZGZADBJZKLZBDAJZKLZ
      MZBDCJZKLZCWQKLZMZGZGZWKWNAXBKLZCWSKLZMZHZDABJNLZDBCJNLZGZDACJNLZWJWPXFXK
      WPWKWLWNHZWJXFXKOWPWKWLWNWKWLWOUCWKWLWOUDWMWLWNPUEWJXPXFXKWJXPGZXFGWKWNXJ
      WKWLWNWJXFUFWKWLWNWJXFUGXQXAXEXJXQWRXEXJOZWTWJXPWRXRWJXPWRGZGXCXJXDWJXSXC
      XJXSXCGWJXPWRXCHZXJXPWRXCQWJXTGXHXIWJXTDABCEWBWFWIULZWBWFWGWHUHZWBWDWEWIU
      IZWBWDWEWIUJZWBWFWGWHUKZWJXPWRXCUMWJXPWRXCUNUOUPUQRWJXSXDXJWJXSXDGZGWRXDX
      JWJXPWRXDURWJXSXDPWJWRXDGXJOZYFWJWBWHWDWGWEYGYAYBYCYEYDDACBEUSUTVBVCRSRWJ
      XPWTXRWJXPWTGZGXCXJXDWJYHXCXJWJYHXCGZGZDBIZWTXCXJYJBDYIWLWJWKWLWNWTXCVDVE
      VFWJXPWTXCURWJYHXCPWJYKWTXCHXJOZYIWJWBWHWEWDWGYLYAYBYDYCYEDBACEVGUTVBVHRW
      JYHXDXJYHXDGWJXPWTXDHZXJXPWTXDQWJYMGXIXHWJYMDCBAEYAYBYEYDYCWJXPWTXDUNWJXP
      WTXDUMUOVLUQRSRSVIUEVJVMVKWJXNWKWLXAHZWLWNXEHZGZXGWJXLYNXMYOWJWBWHWDWEXLY
      NTYAYBYCYDABDEVNVOWJWBWHWEWGXMYOTYAYBYDYEBCDEVNVOVPYPWMXAGZWOXEGZGXGYNYQY
      OYRWKWLXAQWLWNXEQVQWMWOXAXEVRVSVTWJWBWHWDWGXOXKTYAYBYCYEACDEVNVOWA $.
  $}

  $( Uniqueness law for ` OutsideOf ` .  Analog of ~ segconeq .  (Contributed
     by Scott Fenton, 24-Oct-2013.)  (Revised by Mario Carneiro,
     19-Apr-2014.) $)
  outsideofeq $p |- ( ( N e. NN /\
    ( A e. ( EE ` N ) /\ R e. ( EE ` N ) /\ B e. ( EE ` N ) ) /\
    ( C e. ( EE ` N ) /\ X e. ( EE ` N ) /\ Y e. ( EE ` N ) ) ) ->
    ( ( ( A OutsideOf <. X , R >. /\ <. A , X >. Cgr <. B , C >. ) /\
        ( A OutsideOf <. Y , R >. /\ <. A , Y >. Cgr <. B , C >. ) ) ->
      X = Y ) ) $=
    ( wcel w3a cop wbr wa wne cbtwn simprlr simprrr simprll exp32 endofsegidand
    adantl cn cee cfv coutsideof ccgr wo wceq simp21 simp32 simp22 broutsideof2
    wb syl13anc anbi1d simp33 anbi12d simpll3 simprl3 jca simpll2 simp23 simp31
    simp1 cgrtr3and wi midofsegid syl122anc adantr mp3and btwnexchand cgrcomand
    jca32 eqcomd simprr simplrr simprrl necomd btwnconn1 mpjaod ccased imp32 ex
    expr syldan sylbid ) EUAHZAEUBUCZHZDWGHZBWGHZIZCWGHZFWGHZGWGHZIZIZAFDJUDKZA
    FJZBCJZUEKZLZAGDJUDKZAGJZWSUEKZLZLFAMZDAMZFADJZNKZDWRNKZUFZIZWTLZGAMZXGGXHN
    KZDXCNKZUFZIZXDLZLZFGUGZWPXAXMXEXSWPWQXLWTWPWFWHWMWIWQXLULWFWKWOVCZWFWHWIWJ
    WOUHZWFWKWLWMWNUIZWFWHWIWJWOUJZFDAEUKUMUNWPXBXRXDWPWFWHWNWIXBXRULYBYCWFWKWL
    WMWNUOZYEGDAEUKUMUNUPWPXTYAWPXTXKXQLZXGWRXCUEKZLZLYAWPXTLYGXGYHXTYGWPXTXKXQ
    XFXGXKWTXSUQXNXGXQXDXMURUSTXTXGWPXFXGXKWTXSUTTWPXTAFAGBCEYBYCYDYCYFWFWHWIWJ
    WOVAWFWKWLWMWNVBWPXLWTXSOWPXMXRXDPVDVLWPYGYIYAWPXIXOXJXPYIYAVEWPXIXOLZYIYAW
    PYJYILZLXIXOYHYAWPXIXOYIQWPXIXOYIOWPYJXGYHPWPXIXOYHIYAVEZYKWPWFWHWIWMWNYLYB
    YCYEYDYFADFGEVFVGVHVIRWPXJXOLZYIYAWPYMYILZAFGEYBYCYDYFWPYNAGDFEYBYCYFYEYDWP
    XJXOYIOWPXJXOYIQVJWPYMXGYHPSRWPXIXPLZYIYAWPYOYILZLGFWPYPAGFEYBYCYFYDWPYPAFD
    GEYBYCYDYEYFWPXIXPYIQWPXIXPYIOVJWPYPAFAGEYBYCYDYCYFWPYOXGYHPVKSVMRWPXJXPLZY
    IYAWPYQYILZLZFXCNKZYAGWRNKZWPYRYTYAWPYRYTLZLGFWPUUBAGFEYBYCYFYDWPYRYTVNWPUU
    BAFAGEYBYCYDYCYFUUBYHWPYQXGYHYTVOTVKSVMWCWPYRUUAYAWPYRUUALZAFGEYBYCYDYFWPYR
    UUAVNUUCYHWPYQXGYHUUAVOTSWCYSADMZXJXPYTUUAUFZYSDAWPYQXGYHVPVQWPXJXPYIQWPXJX
    PYIOWPUUDXJXPIUUEVEZYRWPWFWHWIWMWNUUFYBYCYEYDYFADFGEVRVGVHVIVSRVTWAWDWBWE
    $.

  ${
    $d A x $.  $d A y $.  $d B x $.  $d B y $.  $d C x $.  $d C y $.  $d N x $.
    $d N y $.  $d R x $.  $d R y $.  $d x y $.
    $( Given a non-degenerate ray, there is a unique point congruent to the
       segment ` B C ` lying on the ray ` A R ` .  Theorem 6.11 of
       [Schwabhauser] p. 44.  (Contributed by Scott Fenton, 23-Oct-2013.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    outsideofeu $p |- ( ( N e. NN /\
      ( A e. ( EE ` N ) /\ R e. ( EE ` N ) ) /\
      ( B e. ( EE ` N ) /\ C e. ( EE ` N ) ) ) ->
      ( ( R =/= A /\ B =/= C ) ->
        E! x e. ( EE ` N ) ( A OutsideOf <. x , R >. /\
         <. A , x >. Cgr <. B , C >. ) ) ) $=
      ( vy wcel wa w3a wne cv cop coutsideof wbr ccgr wrex adantr wb 3jca cn wi
      cee cfv wreu weq wral cbtwn wo segcon2 simpl2l simpr simpl2r broutsideof2
      simpl1 syl13anc simpllr adantl wceq simprlr simp2l anim1i simpl3 cgrdegen
      simp3 syl3anc mpd necon3bid mpbird necomd simplll simprr expr bitrd orcom
      impbid2 syl6bb pm5.32rd an32s rexbidva simpl3l simpl3r simprl outsideofeq
      imp syl2an an4s exp32 ralrimivv opeq1 breq2d breq1d anbi12d reu4 sylanbrc
      opeq2 ex ) FUAHZBFUCUDZHZEWSHZIZCWSHZDWSHZIZJZEBKZCDKZIZBALZEMZNOZBXJMZCD
      MZPOZIZAWSUEZXFXIIZXPAWSQZXPBGLZEMZNOZBXTMZXNPOZIZIZAGUFZUBZGWSUGAWSUGXQX
      RXSEXMUHOZXJBEMUHOZUIZXOIZAWSQZXFYMXIAECDBFUJRXRXPYLAWSXFXJWSHZXIXPYLSXFY
      NIZXIIXOXLYKYOXIXOXLYKSYOXIXOIZIZXLYJYIUIZYKYQXLXJBKZXGYRJZYRYOXLYTSZYPYO
      WRWTYNXAUUAWRXBXEYNUOZWTXAWRXEYNUKXFYNULWTXAWRXEYNUMXJEBFUNUPRYQYTYRYSXGY
      RVEYOYPYRYTYOYPYRIZIZYSXGYRUUDBXJUUDBXJKXHUUCXHYOXGXHXOYRUQURUUDBXJCDUUDX
      OBXJUSCDUSSZYOXIXOYRUTYOXOUUEUBZUUCYOWRWTYNIXEUUFUUBXFWTYNWRWTXAXEVAVBWRX
      BXEYNVCBXJCDFVDVFRVGVHVIVJUUCXGYOXGXHXOYRVKURYOYPYRVLTVMVPVNYJYIVOVQVMVRV
      SVTVIXRYHAGWSWSXRYNXTWSHZIZYFYGXFUUHXIYFYGXFUUHIZWRWTXAXCJZXDYNUUGJZJZYFY
      GXIYFIUUIWRUUJUUKWRXBXEUUHUOUUIWTXAXCWTXAWRXEUUHUKWTXAWRXEUUHUMXCXDWRXBUU
      HWATUUIXDYNUUGXCXDWRXBUUHWBXFYNUUGWCXFYNUUGVLTTXIYFULUULYFYGBCDEFXJXTWDWE
      WFWGWHWIXPYEAGWSYGXLYBXOYDYGXKYABNXJXTEWJWKYGXMYCXNPXJXTBWPWLWMWNWOWQ $.
  $}

  ${
    $d A y $.  $d B y $.  $d P y $.  $d N y $.
    $( Relate ` OutsideOf ` to ` Seg<_ ` .  Theorem 6.13 of [Schwabhauser]
       p. 45.  (Contributed by Scott Fenton, 24-Oct-2013.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    outsidele $p |- ( ( N e. NN /\
    ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ B e. ( EE ` N ) ) ) ->
    ( P OutsideOf <. A , B >. ->
      ( <. P , A >. Seg<_ <. P , B >. <-> A Btwn <. P , B >. ) ) ) $=
      ( vy wcel w3a wa cop coutsideof cbtwn wb ccgr simpr3 adantr wceq ad2antrr
      wbr wi mpd cn cee cfv csegle cv wrex simpl simpr1 simpr2 syl122anc simprl
      brsegle2 outsideofcom mpbid simpll simplr1 simplr3 cgrrflxd jca ccolin wn
      simprrl simpr simplr2 btwncolinear1 syl13anc wne outsidene1 neneqd df-3an
      simpr2l btwncomand btwnswapid2 mp2and sylan2br expr mtod sylanbrc simprrr
      broutsideof outsideofeq syl133anc opeq2 breq2d syl5ibrcom an4s rexlimdvaa
      sylbid btwnsegle impbid ex ) DUAFZCDUBUCZFZAWMFZBWMFZGZHZCABIJRZCAICBIZUD
      RZAWTKRZLWRWSHZXAXBXCXAACEUEZIZKRZXEWTMRZHZEWMUFZXBWRXAXILZWSWRWLWNWOWNWP
      XJWLWQUGWLWNWOWPUHZWLWNWOWPUIXKWLWNWOWPNECACBDULUJOXCXHXBEWMWRXDWMFZWSXHX
      BWRXLHZWSXHHZHZBXDPZXBXOCBAIJRZWTWTMRZHZCXDAIZJRZXGHZXPXOXQXRXOWSXQXMWSXH
      UKZWRWSXQLXLXNABCDUMQUNXMXRXNXMCBDWLWQXLUOZWNWOWPWLXLUPZWNWOWPWLXLUQZUROU
      SXOYAXGXOCXTUTRZCXTKRZVAYAXOXFYGXMWSXFXGVBZXMXFYGSZXNXMWLWNXLWOYJYDYEWRXL
      VCZWNWOWPWLXLVDZCXDADVEVFOTXOYHACPZXOACXOWSACVGZYCWRWSYNSXLXNABCDVHQTVIXM
      XNYHYMXNYHHXMWSXHYHGZYMWSXHYHVJXMYOHAXDCIKRZYHYMXMYOACXDDYDYLYEYKXFXGWSYH
      XMVKVLXMWSXHYHNXMYPYHHYMSZYOXMWLWOXLWNYQYDYLYKYEAXDCDVMVFOVNVOVPVQXDACVTV
      RXMWSXFXGVSUSXMXSYBHXPSZXNXMWLWNWOWNWPWPXLYRYDYEYLYEYFYFYKCCBADBXDWAWBOVN
      XOXBXPXFYIXPWTXEAKBXDCWCWDWETWFWGWHWRXBXASWSCABDWIOWJWK $.
  $}

  $( Outside of implies colinearity.  (Contributed by Scott Fenton,
     26-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
  outsideofcol $p |- ( P OutsideOf <. Q , R >. -> P Colinear <. Q , R >. ) $=
    ( cop coutsideof wbr ccolin cbtwn wn broutsideof simplbi ) ABCDZEFALGFALHFI
    BCAJK $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Lines and Rays
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Line LinesEE Ray $.

  $( Declare the constant for the line function. $)
  cline2 $a class Line $.

  $( Declare the constant for the ray function. $)
  cray $a class Ray $.

  $( Declare the constant for the set of all lines. $)
  clines2 $a class LinesEE $.

  ${
    $d a b l n $.
    $( Define the ` Line ` function.  This function generates the line passing
       through the distinct points ` a ` and ` b ` .  Adapted from definition
       6.14 of [Schwabhauser] p. 45.  (Contributed by Scott Fenton,
       25-Oct-2013.) $)
    df-line2 $a |- Line = { <. <. a , b >. , l >. |
       E. n e. NN ( ( a e. ( EE ` n ) /\ b e. ( EE ` n ) /\ a =/= b ) /\
         l = [ <. a , b >. ] `' Colinear ) } $.
  $}

  ${
    $d p a r n x $.
    $( Define the ` Ray ` function.  This function generates the set of all
       points that lie on the ray starting at ` p ` and passing through
       ` a ` .  Definition 6.8 of [Schwabhauser] p. 44.  (Contributed by Scott
       Fenton, 21-Oct-2013.) $)
    df-ray $a |- Ray = { <. <. p , a >. , r >. |
       E. n e. NN ( ( p e. ( EE ` n ) /\ a e. ( EE ` n ) /\ p =/= a ) /\
         r = { x e. ( EE ` n ) | p OutsideOf <. a , x >. } ) } $.
  $}

  $( Define the set of all lines.  Definition 6.14, part 2 of [Schwabhauser]
     p. 45.  See ~ ellines for membership.  (Contributed by Scott Fenton,
     28-Oct-2013.) $)
  df-lines2 $a |- LinesEE = ran Line $.

  ${
    $d a m $.  $d a n $.  $d a p $.  $d a r $.  $d a s $.  $d a x $.  $d m n $.
    $d m p $.  $d m r $.  $d m s $.  $d m x $.  $d n p $.  $d n r $.  $d n s $.
    $d n x $.  $d p r $.  $d p s $.  $d p x $.  $d r s $.  $d r x $.  $d s x $.

    $( Show that the ` Ray ` relationship is a function.  (Contributed by Scott
       Fenton, 21-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    funray $p |- Fun Ray $=
      ( vp vn va vr vx vm vs cray wfun cv cee cfv wcel w3a crab wceq wa cn wrex
      wi wne cop coutsideof wbr coprab wmo weq wal reeanv simp1 axdimuniq fveq2
      rabeq syl eqeq2d anbi1d eqtr3 syl6bi an4s ex com3l syl2an com12 rexlimivv
      imp sylbir gen2 anbi2d rexbidv eleq2d 3anbi12d anbi12d cbvrexv syl6bb mo4
      eqeq1 mpbir funoprab df-ray funeqi ) HIAJZBJZKLZMZCJZWCMZWAWEUAZNZDJZWAWE
      EJUBUCUDZEWCOZPZQZBRSZACDUEZIWNACDWNDUFWNWAFJZKLZMZWEWQMZWGNZGJZWJEWQOZPZ
      QZFRSZQZDGUGZTZGUHDUHXHDGXFWMXDQZFRSBRSXGWMXDBFRRUIXIXGBFRRXIWBRMZWPRMZQZ
      XGWHWTWLXCXLXGTZWHWTQWLXCQZXMWHWDWRXNXMTWTWDWFWGUJWRWSWGUJXLWDWRQZXNXGXLX
      OXNXGTZXJWDXKWRXPXJWDQXKWRQQBFUGZXPWAWPWBUKXQXNWIXBPZXCQXGXQWLXRXCXQWKXBW
      IXQWCWQPWKXBPWBWPKULZWJEWCWQUMUNZUOUPWIXAXBUQURUNUSUTVAVBVEUSVCVDVFVGWNXE
      DGXGWNWHXAWKPZQZBRSXEXGWMYBBRXGWLYAWHWIXAWKVPVHVIYBXDBFRXQWHWTYAXCXQWDWRW
      FWSWGXQWCWQWAXSVJXQWCWQWEXSVJVKXQWKXBXAXTUOVLVMVNVOVQVRHWOEBDACVSVTVQ $.
  $}

  ${
    $d A a $.  $d a n $.  $d A n $.  $d a p $.  $d A p $.  $d a r $.  $d A r $.
    $d a x $.  $d A x $.  $d N a $.  $d N n $.  $d n p $.  $d N p $.  $d n r $.
    $d N r $.  $d n x $.  $d N x $.  $d P a $.  $d P n $.  $d P p $.  $d p r $.
    $d P r $.  $d p x $.  $d P x $.  $d r x $.
    $( Calculate the value of the ` Ray ` function.  (Contributed by Scott
       Fenton, 21-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    fvray $p |- ( ( N e. NN /\
           ( P e. ( EE ` N ) /\ A e. ( EE ` N ) /\ P =/= A ) ) ->
           ( P Ray A ) =
             { x e. ( EE ` N ) | P OutsideOf <. A , x >. } ) $=
      ( vp vn va vr cn wcel cee w3a wa cray cop cv coutsideof wbr crab wceq cfv
      wne df-ov wrex coprab eqid fveq2 eleq2d 3anbi12d rabeq syl eqeq2d anbi12d
      co rspcev mpanr2 wb simpr1 simpr2 fvex rabex eleq1 neeq1 3anbi13d rabbidv
      cvv breq1 rexbidv neeq2 3anbi23d opeq1 breq2d eqeq1 anbi2d mp3an3 syl2anc
      eloprabg mpbird df-br df-ray eleq2i bitri wi funray funbrfv sylbir syl5eq
      wfun ax-mp ) DIJZCDKUAZJZBWKJZCBUBZLZMZCBNUNCBOZNUAZCBAPZOZQRZAWKSZCBNUCW
      PWQXBOZEPZFPZKUAZJZGPZXFJZXDXHUBZLZHPZXDXHWSOZQRZAXFSZTZMZFIUDZEGHUEZJZWR
      XBTZWPXTCXFJZBXFJZWNLZXBXAAXFSZTZMZFIUDZWJWOXBXBTZYHXBUFYGWOYIMFDIXEDTZYD
      WOYFYIYJYBWLYCWMWNYJXFWKCXEDKUGZUHYJXFWKBYKUHUIYJYEXBXBYJXFWKTYEXBTYKXAAX
      FWKUJUKULUMUOUPWPWLWMXTYHUQZWJWLWMWNURWJWLWMWNUSWLWMXBVFJYLXAAWKDKUTVAXRY
      BXICXHUBZLZXLCXMQRZAXFSZTZMZFIUDYDXLYETZMZFIUDYHEGHCBXBWKWKVFXDCTZXQYRFIU
      UAXKYNXPYQUUAXGYBXJYMXIXDCXFVBXDCXHVCVDUUAXOYPXLUUAXNYOAXFXDCXMQVGVEULUMV
      HXHBTZYRYTFIUUBYNYDYQYSUUBXIYCYMWNYBXHBXFVBXHBCVIVJUUBYPYEXLUUBYOXAAXFUUB
      XMWTCQXHBWSVKVLVEULUMVHXLXBTZYTYGFIUUCYSYFYDXLXBYEVMVNVHVQVOVPVRXTWQXBNRZ
      YAUUDXCNJXTWQXBNVSNXSXCAFHEGVTWAWBNWHUUDYAWCWDWQXBNWEWIWFUKWG $.
  $}

  ${
    $d a b $.  $d a k $.  $d a l $.  $d a m $.  $d a n $.  $d b k $.  $d b l $.
    $d b m $.  $d b n $.  $d k l $.  $d k m $.  $d k n $.  $d l m $.  $d l n $.
    $d m n $.
    $( Show that the ` Line ` relationship is a function.  (Contributed by
       Scott Fenton, 25-Oct-2013.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    funline $p |- Fun Line $=
      ( va vn vb vl vm vk cline2 wfun cv cee cfv wcel w3a wceq wa cn weq wi wal
      wrex wne cop ccolin cec coprab wmo reeanv eqtr3 ad2ant2l rexlimivv sylbir
      ccnv a1i eqeq1 anbi2d rexbidv fveq2 eleq2d 3anbi12d anbi1d cbvrexv syl6bb
      gen2 mo4 mpbir funoprab df-line2 funeqi ) GHAIZBIZJKZLZCIZVKLZVIVMUAZMZDI
      ZVIVMUBUCULUDZNZOZBPTZACDUEZHWAACDWADUFWAVIEIZJKZLZVMWDLZVOMZFIZVRNZOZEPT
      ZOZDFQZRZFSDSWNDFWLVTWJOZEPTBPTWMVTWJBEPPUGWOWMBEPPWOWMRVJPLWCPLOVSWIWMVP
      WGVQWHVRUHUIUMUJUKVCWAWKDFWMWAVPWIOZBPTWKWMVTWPBPWMVSWIVPVQWHVRUNUOUPWPWJ
      BEPBEQZVPWGWIWQVLWEVNWFVOWQVKWDVIVJWCJUQZURWQVKWDVMWRURUSUTVAVBVDVEVFGWBB
      ACDVGVHVE $.
  $}

  ${
    $d A l $.  $d A n $.  $d A x $.  $d A y $.  $d l n $.  $d l x $.  $d l y $.
    $d n x $.  $d n y $.  $d x y $.
    $( When ` Line ` is applied with the same argument, the result is the empty
       set.  (Contributed by Scott Fenton, 29-Oct-2013.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    linedegen $p |- ( A Line A ) = (/) $=
      ( vx vn vy vl cline2 cop wcel wn wceq cv wne w3a cec wa wrex wex cvv syl
      cn co cfv c0 df-ov cdm cee ccolin ccnv copab neirr simp3 mto intnanr nrex
      a1i nex wb eleq1 neeq1 3anbi13d opeq1 eceq1 eqeq2d anbi12d rexbidv exbidv
      neeq2 3anbi23d opeq2 opelopabg anidms mtbiri cxp wrel relopab df-rel mpbi
      wss sseli opelxp1 con3i pm2.61i coprab df-line2 dmeqi dmoprab eqtri mtbir
      eleq2i ndmfv ax-mp ) AAFUAAAGZFUBZUCAAFUDWLFUEZHZIWMUCJWOWLBKZCKZUFUBZHZD
      KZWRHZWPWTLZMZEKZWPWTGZUGUHZNZJZOZCTPZEQZBDUIZHZARHZXMIXNXMAWRHZXOAALZMZX
      DWLXFNZJZOZCTPZEQZYAEXTCTXTIWQTHXQXSXQXPAUJXOXOXPUKULUMUOUNUPXNXMYBUQXKXO
      XAAWTLZMZXDAWTGZXFNZJZOZCTPZEQYBBDAARRWPAJZXJYIEYJXIYHCTYJXCYDXHYGYJWSXOX
      BYCXAWPAWRURWPAWTUSUTYJXGYFXDYJXEYEJXGYFJWPAWTVAXEYEXFVBSVCVDVEVFWTAJZYIY
      AEYKYHXTCTYKYDXQYGXSYKXAXOYCXPXOWTAWRURWTAAVGVHYKYFXRXDYKYEWLJYFXRJWTAAVI
      YEWLXFVBSVCVDVEVFVJVKVLXMXNXMWLRRVMZHXNXLYLWLXLVNXLYLVRXKBDVOXLVPVQVSAARR
      VTSWAWBWNXLWLWNXJBDEWCZUEXLFYMCBDEWDWEXJBDEWFWGWIWHWLFWJWKWG $.
  $}

  ${
    $d A a $.  $d a b $.  $d A b $.  $d a l $.  $d A l $.  $d a n $.  $d A n $.
    $d A x $.  $d B a $.  $d B b $.  $d b l $.  $d B l $.  $d b n $.  $d B n $.
    $d B x $.  $d l n $.  $d N n $.
    $( Calculate the value of the ` Line ` function.  (Contributed by Scott
       Fenton, 25-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    fvline $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/= B ) ) ->
       ( A Line B ) = { x | x Colinear <. A , B >. } ) $=
      ( va vn vb vl cn wcel cee w3a wa cline2 cop ccolin cv wceq wrex cvv fveq2
      cfv wne ccnv cec wbr cab coprab eqid eleq2d 3anbi12d anbi1d rspcev mpanr2
      co wb simpr1 simpr2 colinearex cnvex ecexg ax-mp eleq1 neeq1 3anbi13d syl
      opeq1 eceq1 eqeq2d anbi12d rexbidv neeq2 3anbi23d anbi2d eloprabg syl2anc
      opeq2 eqeq1 mp3an3 mpbird df-ov df-br df-line2 bitri wfun funline funbrfv
      eleq2i wi sylbir syl5eq opex dfec2 vex brcnv abbii eqtri syl6eq ) DIJZBDK
      UBZJZCWTJZBCUCZLZMZBCNUOZBCOZPUDZUEZAQZXGPUFZAUGZXEXGXIOZEQZFQZKUBZJZGQZX
      PJZXNXRUCZLZHQZXNXROZXHUEZRZMZFISZEGHUHZJZXFXIRXEYIBXPJZCXPJZXCLZXIXIRZMZ
      FISZWSXDYMYOXIUIYNXDYMMFDIXODRZYLXDYMYPYJXAYKXBXCYPXPWTBXODKUAZUJYPXPWTCY
      QUJUKULUMUNXEXAXBYIYOUPZWSXAXBXCUQWSXAXBXCURXAXBXITJZYRXHTJYSPUSUTXGTXHVA
      VBYGYJXSBXRUCZLZYBBXROZXHUEZRZMZFISYLYBXIRZMZFISYOEGHBCXIWTWTTXNBRZYFUUEF
      IUUHYAUUAYEUUDUUHXQYJXTYTXSXNBXPVCXNBXRVDVEUUHYDUUCYBUUHYCUUBRYDUUCRXNBXR
      VGYCUUBXHVHVFVIVJVKXRCRZUUEUUGFIUUIUUAYLUUDUUFUUIXSYKYTXCYJXRCXPVCXRCBVLV
      MUUIUUCXIYBUUIUUBXGRUUCXIRXRCBVQUUBXGXHVHVFVIVJVKUUFUUGYNFIUUFUUFYMYLYBXI
      XIVRVNVKVOVSVPVTYIXFXGNUBZXIBCNWAYIXGXINUFZUUJXIRZUUKXMNJYIXGXINWBNYHXMFE
      GHWCWHWDNWEUUKUULWIWFXGXINWGVBWJWKVFXIXGXJXHUFZAUGZXLXGTJXIUUNRBCWLZAXGXH
      TWMVBUUMXKAXGXJPUUOAWNWOWPWQWR $.
  $}

  ${
    $d N x $.  $d A x $.  $d B x $.
    $( A line is a subset of the space its two points lie in.  (Contributed by
       Scott Fenton, 25-Oct-2013.)  (Revised by Mario Carneiro,
       19-Apr-2014.) $)
    liness $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/= B ) ) ->
       ( A Line B ) C_ ( EE ` N ) ) $=
      ( vx cn wcel cee cfv wne w3a wa cline2 co cop ccolin wbr cab fvline cvv
      cv wi vex a1i simp1 simp2 3jca colineardim1 sylan2 abssdv eqsstrd ) CEFZA
      CGHZFZBULFZABIZJZKZABLMDTZABNOPZDQULDABCRUQUSDULUPUKURSFZUMUNJUSURULFUAUP
      UTUMUNUTUPDUBUCUMUNUOUDUMUNUOUEUFURABCSULUGUHUIUJ $.

    $( Alternate definition of a line.  (Contributed by Scott Fenton,
       25-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    fvline2 $p |- ( ( N e. NN /\
       ( A e. ( EE ` N ) /\ B e. ( EE ` N ) /\ A =/= B ) ) ->
       ( A Line B ) = { x e. ( EE ` N ) | x Colinear <. A , B >. } ) $=
      ( cn wcel cee cfv wne w3a wa cline2 co cv cop ccolin wbr cab cin crab wss
      fvline wceq liness eqsstr3d df-ss sylib eqtr4d dfrab2 syl6eqr ) DEFBDGHZF
      CUKFBCIJKZBCLMZANBCOPQZARZUKSZUNAUKTULUMUOUPABCDUBZULUOUKUAUPUOUCULUOUMUK
      UQBCDUDUEUOUKUFUGUHUNAUKUIUJ $.
  $}

  ${
    $d N x $.  $d P x $.  $d Q x $.  $d R x $.
    $( A line is composed of a point and the two rays emerging from it.
       Theorem 6.15 of [Schwabhauser] p. 45.  (Contributed by Scott Fenton,
       26-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    lineunray $p |- ( ( N e. NN /\
       ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ R e. ( EE ` N ) ) /\
       ( P =/= Q /\ P =/= R ) ) ->
       ( P Btwn <. Q , R >. ->
       ( P Line Q ) = ( ( ( P Ray Q ) u. { P } ) u. ( P Ray R ) ) ) ) $=
      ( vx wcel w3a wne wa cop cbtwn wbr cun wceq crab wo wb syl13anc adantr wi
      cn cee cfv cline2 co cray csn cv ccolin coutsideof simpl1 simpl21 simpl22
      w3o simpr brcolinear olc orcd simpl3l necomd simprl simprr 3jca btwnconn2
      a1i simpl23 syl122anc olcd expr btwncom syl6bi 3jaod sylbid colineartriv1
      mpd orc syl6 syl3anc breq1 syl5ibrcom btwncolinear3 btwncolinear5 simpl3r
      jaod btwnouttr btwncolinear4 btwncomand btwnexch3and btwncolinear2 impbid
      pm5.63 df-ne anbi1i andi bitr3i orbi2i syl6bb broutsideof2 3simpc simprrl
      wn bitri simprrr impbid2 bitrd orbi12d orbi2d bitr4d orcom an32s rabbidva
      or32 simp1 simp21 simp22 simp3l fvline2 fvray rabsn eqcomd uneq12d simp23
      syl simp3r unrab uneq1i eqtri syl6eq 3eqtr4d ex ) DUAFZADUBUCZFZBYLFZCYLF
      ZGZABHZACHZIZGZABCJKLZABUDUEZABUFUEZAUGZMZACUFUEZMZNYTUUAIZEUHZABJZUILZEY
      LOZABUUIJZUJLZUUIANZPZACUUIJUJLZPZEYLOZUUBUUGUUHUUKUUREYLYTUUIYLFZUUAUUKU
      URQYTUUTIZUUAIZUUKUUOUUNUUQPZPZUURUVBUUKUUOUUIAHZBAUUIJZKLZUUIUUJKLZPZIZU
      VECUVFKLZUUIACJKLZPZIZPZPZUVDUVBUUKUUOUVIUVMPZPZUVPUVBUUKUVRUVBUUKUVQUVRU
      VBUUKUVHAUUMKLZBUUIAJKLZUNZUVQUVAUUKUWAQZUUAUVAYKUUTYMYNUWBYKYPYSUUTUKZYT
      UUTUOZYMYNYOYKYSUUTULZYMYNYOYKYSUUTUMZUUIABDUPRSUVBUVHUVQUVSUVTUVHUVQTUVB
      UVHUVIUVMUVHUVGUQURVEUVAUUAUVSUVQUVAUUAUVSIZIZUVMUVIUWHBAHZUUAUVSGZUVMUWH
      UWIUUAUVSUVAUWIUWGUVAABYQYRYKYPUUTUSUTSUVAUUAUVSVAUVAUUAUVSVBVCUVAUWJUVMT
      ZUWGUVAYKYNYMYOUUTUWKUWCUWFUWEYMYNYOYKYSUUTVFZUWDBACUUIDVDVGSVOVHVIUVAUVT
      UVQTUUAUVAUVTUVGUVQUVAYKYNUUTYMUVTUVGQUWCUWFUWDUWEBUUIADVJRUVGUVIUVMUVGUV
      HVPURVKSVLVMUVQUUOUQVQUVBUUOUUKUVQUVAUUOUUKTUUAUVAUUKUUOAUUJUILZUVAYKYMYN
      UWMUWCUWEUWFABDVNVRUUIAUUJUIVSVTSUVBUVIUUKUVMUVAUVIUUKTUUAUVAUVGUUKUVHUVA
      YKYMUUTYNUVGUUKTUWCUWEUWDUWFAUUIBDWARUVAYKYMYNUUTUVHUUKTUWCUWEUWFUWDABUUI
      DWBRWDSUVBUVKUUKUVLUVAUUAUVKUUKUVAUUAUVKIZIZUVSUUKUWOYRUUAUVKGZUVSUWOYRUU
      AUVKUVAYRUWNYQYRYKYPUUTWCSUVAUUAUVKVAUVAUUAUVKVBVCUVAUWPUVSTZUWNUVAYKYNYM
      YOUUTUWQUWCUWFUWEUWLUWDBACUUIDWEVGSVOUVAUVSUUKTZUWNUVAYKYNUUTYMUWRUWCUWFU
      WDUWEBUUIADWFRSVOVIUVAUUAUVLUUKUVAUUAUVLIZIAUUIBJKLZUUKUVAUWSCUUIABDUWCUW
      LUWDUWEUWFUVAUWSUUIACDUWCUWDUWEUWLUVAUUAUVLVBWGUVAUWSABCDUWCUWEUWFUWLUVAU
      UAUVLVAWGWHUVAUWTUUKTZUWSUVAYKUUTYNYMUXAUWCUWDUWFUWEUUIBADWIRSVOVIWDWDWDW
      JUVRUUOUUOXAZUVQIZPUVPUUOUVQWKUXCUVOUUOUXCUVEUVQIUVOUVEUXBUVQUUIAWLWMUVEU
      VIUVMWNWOWPXBWQUVBUVCUVOUUOUVAUVCUVOQUUAUVAUUNUVJUUQUVNUVAUUNUWIUVEUVIGZU
      VJUVAYKYMYNUUTUUNUXDQUWCUWEUWFUWDBUUIADWRRUVAUXDUVJUWIUVEUVIWSYTUUTUVJUXD
      YTUUTUVJIZIZUWIUVEUVIUXFABYQYRYKYPUXEUSUTYTUUTUVEUVIWTYTUUTUVEUVIXCVCVIXD
      XEUVAUUQCAHZUVEUVMGZUVNUVAYKYMYOUUTUUQUXHQUWCUWEUWLUWDCUUIADWRRUVAUXHUVNU
      XGUVEUVMWSYTUUTUVNUXHYTUUTUVNIZIZUXGUVEUVMUXJACYQYRYKYPUXIWCUTYTUUTUVEUVM
      WTYTUUTUVEUVMXCVCVIXDXEXFSXGXHUVDUVCUUOPUURUUOUVCXIUUNUUQUUOXLXBWQXJXKYTU
      UBUULNZUUAYTYKYMYNYQUXKYKYPYSXMZYKYMYNYOYSXNZYKYMYNYOYSXOZYKYPYQYRXPZEABD
      XQRSUUHUUGUUNEYLOZUUOEYLOZMZUUQEYLOZMZUUSYTUUGUXTNUUAYTUUEUXRUUFUXSYTUUCU
      XPUUDUXQYTYKYMYNYQUUCUXPNUXLUXMUXNUXOEBADXRRYTUXQUUDYTYMUXQUUDNUXMEYLAXSY
      CXTYAYTYKYMYOYRUUFUXSNUXLUXMYKYMYNYOYSYBYKYPYQYRYDECADXRRYASUXTUUPEYLOZUX
      SMUUSUXRUYAUXSUUNUUOEYLYEYFUUPUUQEYLYEYGYHYIYJ $.
  $}

  ${
    $d N x $.  $d P x $.  $d Q x $.  $d S x $.
    $( If ` S ` lies on ` P Q ` , then ` P Q = P S ` .  Theorem 6.16 of
       [Schwabhauser] p. 45.  (Contributed by Scott Fenton, 27-Oct-2013.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    lineelsb2 $p |- ( ( N e. NN /\
      ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ P =/= Q ) /\
      ( S e. ( EE ` N ) /\ P =/= S ) ) ->
        ( S e. ( P Line Q ) -> ( P Line Q ) = ( P Line S ) ) ) $=
      ( vx w3a wa cop wbr cbtwn syl13anc adantr syl122anc mpd simprl btwncomand
      wi expr simprr mp3and cn wcel cee cfv wne ccolin cv crab cline2 co wb w3o
      wceq simpl1 simpl3l simpl21 simpl22 brcolinear biimpa simpr btwnconn3 imp
      btwncolinear3 btwncolinear5 btwnexch3and btwncolinear4 btwnexchand sylbid
      wo 3jaod simpl3r necomd btwnouttr2 btwnconn1 impbid btwncolinear2 simpl23
      jaod btwnconn2 btwnouttr mp2and 3jaodan adantrl an32s rabbidva ex fvline2
      syldan 3adant3 eleq2d breq1 syl6bb simp21 simp3l simp3r eqeq12d 3imtr4d
      elrab simp1 ) DUAUBZADUCUDZUBZBXAUBZABUEZFZCXAUBZACUEZGZFZXFCABHZUFIZGZEU
      GZXJUFIZEXAUHZXMACHZUFIZEXAUHZUMZCABUIUJZUBZXTACUIUJZUMXIXLXSXIXLGXNXQEXA
      XIXMXAUBZXLXNXQUKZXIYCGZXKYDXFYEXKCXJJIZABCHJIZBCAHJIZULZYDYEXKYIYEWTXFXB
      XCXKYIUKWTXEXHYCUNZXFXGWTXEYCUOZXBXCXDWTXHYCUPZXBXCXDWTXHYCUQZCABDURKUSYE
      YFYDYGYHYEYFGZXNXQYNXNXMXJJIZABXMHJIZBXMAHZJIZULZXQYEXNYSUKZYFYEWTYCXBXCY
      TYJXIYCUTZYLYMXMABDURKZLYNYOXQYPYRYEYFYOXQYEYFYOGZGCAXMHZJIZXMXPJIZVIZXQY
      EUUCUUGYEWTXBXFYCXCUUCUUGQYJYLYKUUAYMACXMBDVAMVBYEUUGXQQZUUCYEUUEXQUUFYEW
      TXBYCXFUUEXQQZYJYLUUAYKAXMCDVCKZYEWTXBXFYCUUFXQQZYJYLYKUUAACXMDVDKZVRZLNR
      YEYFYPXQYEYFYPGZGACXMHJIZXQYEUUNBCAXMDYJYMYKYLUUAYEUUNCABDYJYKYLYMYEYFYPO
      PYEYFYPSVEYEUUOXQQZUUNYEWTXFYCXBUUPYJYKUUAYLCXMADVFKZLNRYEYFYRXQYEYFYRGZG
      UUEXQYEUURACBXMDYJYLYKYMUUAYEYFYROYEUURBXMADYJYMUUAYLYEYFYRSPVGYEUUIUURUU
      JLNRVJVHYNXQUUFUUOCYQJIZULZXNYEXQUUTUKZYFYEWTYCXBXFUVAYJUUAYLYKXMACDURKZL
      YNUUFXNUUOUUSYEYFUUFXNYEYFUUFGZGYOXNYEUVCAXMCBDYJYLUUAYKYMYEYFUUFSYEYFUUF
      OVGYEYOXNQZUVCYEWTXBXCYCUVDYJYLYMUUAABXMDVDKZLNRYEYFUUOXNYEYFUUOGZGZYPXNU
      VGCAUEZCBAHJIZUUOYPYEUVHUVFYEACXFXGWTXEYCVKZVLZLYEUVFCABDYJYKYLYMYEYFUUOO
      PYEYFUUOSYEUVHUVIUUOFYPQZUVFYEWTXCXFXBYCUVLYJYMYKYLUUABCAXMDVMMLTYEYPXNQZ
      UVFYEWTXCYCXBUVMYJYMUUAYLBXMADVFKZLNRYEYFUUSXNYEYFUUSGZGZBUUDJIZYOVIZXNUV
      PXGYFUUEUVRYEXGUVOUVJLYEYFUUSOYEUVOCXMADYJYKUUAYLYEYFUUSSPYEXGYFUUEFUVRQZ
      UVOYEWTXBXFXCYCUVSYJYLYKYMUUAACBXMDVNMLTYEUVRXNQZUVOYEUVQXNYOYEWTXBYCXCUV
      QXNQZYJYLUUAYMAXMBDVCKZUVEVRZLNRVJVHVOYEYGGZXNXQUWDXNYSXQYEYTYGUUBLUWDYOX
      QYPYRYEYGYOXQYEYGYOGZGAXMCHJIZXQYEUWEBXMACDYJYMUUAYLYKYEUWEXMABDYJUUAYLYM
      YEYGYOSPYEYGYOOVEYEUWFXQQZUWEYEWTYCXFXBUWGYJUUAYKYLXMCADVPKLNRYEYGYPXQYEY
      GYPGZGZUUGXQUWIBAUEZYGYPUUGYEUWJUWHYEABXBXCXDWTXHYCVQZVLZLYEYGYPOYEYGYPSY
      EUWJYGYPFUUGQZUWHYEWTXCXBXFYCUWMYJYMYLYKUUABACXMDVSMLTYEUUHUWHUUMLNRYEYGY
      RXQYEYGYRGZGZUUOXQUWOXDACBHJIZUVQUUOYEXDUWNUWKLYEUWNABCDYJYLYMYKYEYGYROPY
      EUWNBXMADYJYMUUAYLYEYGYRSPYEXDUWPUVQFUUOQZUWNYEWTXFXBXCYCUWQYJYKYLYMUUACA
      BXMDVTMLTYEUUPUWNUUQLNRVJVHUWDXQUUTXNYEUVAYGUVBLUWDUUFXNUUOUUSYEYGUUFXNYE
      YGUUFGZGAXMBHJIZXNYEUWRCXMABDYJYKUUAYLYMYEUWRXMACDYJUUAYLYKYEYGUUFSPYEUWR
      ABCDYJYLYMYKYEYGUUFOPVEYEUWSXNQZUWRYEWTYCXCXBUWTYJUUAYMYLXMBADVPKLNRYEYGU
      UOXNYEYGUUOGZGZUVRXNUXBUVHUWPUUOUVRYEUVHUXAUVKLYEUXAABCDYJYLYMYKYEYGUUOOP
      YEYGUUOSYEUVHUWPUUOFUVRQZUXAYEWTXFXBXCYCUXCYJYKYLYMUUACABXMDVSMLTYEUVTUXA
      UWCLNRYEYGUUSXNYEYGUUSGZGZYPXNUXEXGYGUUEYPYEXGUXDUVJLYEYGUUSOYEUXDCXMADYJ
      YKUUAYLYEYGUUSSPYEXGYGUUEFYPQZUXDYEWTXCXBXFYCUXFYJYMYLYKUUABACXMDVTMLTYEU
      VMUXDUVNLNRVJVHVOYEYHGZXNXQUXGXNYSXQYEYTYHUUBLUXGYOXQYPYRYEYHYOXQYEYHYOGZ
      GUUFXQYEUXHAXMBCDYJYLUUAYMYKYEYHYOSYEUXHBCADYJYMYKYLYEYHYOOPVGYEUUKUXHUUL
      LNRYEYHYPXQYEYHYPGZGZUUOXQUXJUWJYHYPUUOYEUWJUXIUWLLYEYHYPOYEYHYPSYEUWJYHY
      PFUUOQZUXIYEWTXFXCXBYCUXKYJYKYMYLUUACBAXMDVMMLTYEUUPUXIUUQLNRYEYHYRXQYEYH
      YRGZGZUUGXQUXMXDBXPJIZUVQUUGYEXDUXLUWKLYEUXLBCADYJYMYKYLYEYHYROPYEUXLBXMA
      DYJYMUUAYLYEYHYRSPYEXDUXNUVQFUUGQZUXLYEWTXBXCXFYCUXOYJYLYMYKUUAABCXMDVNML
      TYEUUHUXLUUMLNRVJVHUXGXQUUTXNYEUVAYHUVBLUXGUUFXNUUOUUSYEYHUUFXNYEYHUUFGZG
      ZUVRXNUXQUXNUUFUVRYEUXPBCADYJYMYKYLYEYHUUFOPYEYHUUFSYEUXNUUFGUVRQZUXPYEWT
      XBXCYCXFUXRYJYLYMUUAYKABXMCDVAMLWAYEUVTUXPUWCLNRYEYHUUOXNYEYHUUOGZGYPXNYE
      UXSCBAXMDYJYKYMYLUUAYEYHUUOOYEYHUUOSVEYEUVMUXSUVNLNRYEYHUUSXNYEYHUUSGZGUV
      QXNYEUXTABCXMDYJYLYMYKUUAYEUXTBCADYJYMYKYLYEYHUUSOPYEUXTCXMADYJYKUUAYLYEY
      HUUSSPVGYEUWAUXTUWBLNRVJVHVOWBWHWCWDWEWFXIYACXOUBXLXIXTXOCWTXEXTXOUMXHEAB
      DWGWIZWJXNXKECXAXMCXJUFWKWRWLXIXTXOYBXRUYAXIWTXBXFXGYBXRUMWTXEXHWSWTXBXCX
      DXHWMWTXEXFXGWNWTXEXFXGWOEACDWGKWPWQ $.
  $}

  ${
    $d N x $.  $d P x $.  $d Q x $.
    $( Reflexivity law for line membership.  Part of theorem 6.17 of
       [Schwabhauser] p. 45.  (Contributed by Scott Fenton, 28-Oct-2013.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    linerflx1 $p |- ( ( N e. NN /\
        ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ P =/= Q ) ) ->
        P e. ( P Line Q ) ) $=
      ( vx cn wcel cee cfv wne w3a wa cv cop ccolin wbr cline2 co colineartriv1
      crab simpr1 3adant3r3 breq1 elrab sylanbrc fvline2 eleqtrrd ) CEFZACGHZFZ
      BUHFZABIZJKZADLZABMZNOZDUHSZABPQULUIAUNNOZAUPFUGUIUJUKTUGUIUJUQUKABCRUAUO
      UQDAUHUMAUNNUBUCUDDABCUEUF $.

    $( Commutativity law for lines.  Part of theorem 6.17 of [Schwabhauser]
       p. 45.  (Contributed by Scott Fenton, 28-Oct-2013.)  (Revised by Mario
       Carneiro, 19-Apr-2014.) $)
    linecom $p |- ( ( N e. NN /\
        ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ P =/= Q ) ) ->
        ( P Line Q ) = ( Q Line P ) ) $=
      ( vx cn wcel cee cfv wne w3a wa cv cop ccolin wbr crab cline2 co fvline2
      wb simp1 simp3 simp21 simp22 colinearperm1 syl13anc rabbidva wceq 3anbi3i
      3expa necom 3ancoma bitri sylan2b 3eqtr4d ) CEFZACGHZFZBUQFZABIZJZKZDLZAB
      MNOZDUQPVCBAMNOZDUQPZABQRBAQRZVBVDVEDUQUPVAVCUQFZVDVETZUPVAVHJUPVHURUSVIU
      PVAVHUAUPVAVHUBUPURUSUTVHUCUPURUSUTVHUDVCABCUEUFUJUGDABCSVAUPUSURBAIZJZVG
      VFUHVAURUSVJJVKUTVJURUSABUKUIURUSVJULUMDBACSUNUO $.
  $}

  $( Reflexivity law for line membership.  Part of theorem 6.17 of
     [Schwabhauser] p. 45.  (Contributed by Scott Fenton, 28-Oct-2013.)
     (Revised by Mario Carneiro, 19-Apr-2014.) $)
  linerflx2 $p |- ( ( N e. NN /\
        ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ P =/= Q ) ) ->
        Q e. ( P Line Q ) ) $=
    ( cn wcel cee cfv wne w3a wa cline2 necom 3anbi3i 3ancoma linerflx1 sylan2b
    co bitri linecom eleqtrrd ) CDEZACFGZEZBUBEZABHZIZJBBAKQZABKQUFUAUDUCBAHZIZ
    BUGEUFUCUDUHIUIUEUHUCUDABLMUCUDUHNRBACOPABCST $.

  ${
    $d A n $.  $d A p $.  $d A q $.  $d A x $.  $d n p $.  $d n q $.  $d n x $.
    $d p q $.  $d p x $.  $d q x $.
    $( Membership in the set of all lines.  (Contributed by Scott Fenton,
       28-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    ellines $p |- ( A e. LinesEE <->
             E. n e. NN E. p e. ( EE ` n ) E. q e. ( EE ` n )
                ( p =/= q /\ A = ( p Line q ) ) ) $=
      ( vx clines2 wcel cvv cv cline2 wceq wa wrex cn ccolin bitr3i bitri anass
      wex cab wne co cee cfv elex wi ovex mpbiri adantl rexlimivw a1i rexlimivv
      eleq1 eqeq1 anbi2d rexbidv 2rexbidv w3a cop ccnv cec crn coprab df-lines2
      df-line2 rneqi rnoprab 3eqtri eleq2i df-rex 2exbii exrot3 r19.42v simplrl
      abid r2ex simplrr simpll simpr 3jca jca simpr2 simpl simpr1 simpr3 impbii
      jca32 anbi1i wbr fvline opex dfec2 ax-mp brcnv abbii eqtri syl6eqr eqeq2d
      vex pm5.32i 3bitrri 3exbii 3bitr4ri vtoclbg pm5.21nii ) AFGZAHGZDIZCIZUAZ
      AXHXIJUBZKZLZCBIZUCUDZMZDXOMBNMZAFUEXPXGBDNXOXPXGUFXNNGZXHXOGZLZXMXGCXOXL
      XGXJXLXGXKHGXHXIJUGAXKHUMUHUIUJUKULEIZFGZXJYAXKKZLZCXOMZDXOMBNMZXFXQEAHYA
      AFUMYAAKZYEXPBDNXOYGYDXMCXOYGYCXLXJYAAXKUNUOUPUQYBYAXSXIXOGZXJURZYAXHXIUS
      ZOUTZVAZKZLZBNMZCSDSZETZGZYFFYQYAFJVBYODCEVCZVBYQVDJYSBDCEVEVFYODCEVGVHVI
      YRYPYFYPEVOYPXRYNLZBSZCSDSZYFYOUUADCYNBNVJVKYHXTYDLZLZCSZDSBSZUUDBSCSDSYF
      UUBUUDBDCVLYFXTYELZDSBSUUFYEBDNXOVPUUGUUEBDUUGUUCCXOMUUEXTYDCXOVMUUCCXOVJ
      PVKQYTUUDDCBUUDXRYILZYCLZUUHYMLYTUUDYHXTLZYDLZUUIYHXTYDRUUKUUJXJLZYCLUUIU
      UJXJYCRUULUUHYCUULUUHUULXRYIYHXRXSXJVNUULXSYHXJYHXRXSXJVQYHXTXJVRUUJXJVSV
      TWAUUHUUJXJUUHYHXRXSXRXSYHXJWBXRYIWCXRXSYHXJWDWGXRXSYHXJWEWAWFWHPPUUHYCYM
      UUHXKYLYAUUHXKYAYJOWIZETZYLEXHXIXNWJYLYJYAYKWIZETZUUNYJHGYLUUPKXHXIWKZEYJ
      YKHWLWMUUOUUMEYJYAOUUQEWSWNWOWPWQWRWTXRYIYMRXAXBXCQQQXDXE $.
  $}

  ${
    $d A a $.  $d a b $.  $d A b $.  $d a n $.  $d A n $.  $d b n $.  $d P a $.
    $d P b $.  $d P n $.  $d Q a $.  $d Q b $.  $d Q n $.
    $( If ` A ` is a line containing two distinct points ` P ` and ` Q ` , then
       ` A ` is the line through ` P ` and ` Q ` .  Theorem 6.18 of
       [Schwabhauser] p. 45.  (Contributed by Scott Fenton, 28-Oct-2013.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    linethru $p |- ( ( A e. LinesEE /\ ( P e. A /\ Q e. A ) /\ P =/= Q ) ->
       A = ( P Line Q ) ) $=
      ( va vb vn wcel wa cline2 co wceq cv wrex cn wi syl13anc necomd lineelsb2
      wne syl132anc clines2 cee cfv ellines w3a simpll1 simpll2 simpll3 simprll
      wss simplr liness sseldd simprlr simplll adantl simprrl mpd linecom eqtrd
      neeq2 anbi2d anbi1d eqeq2d imbi12d mpbiri syl2anc simp1l1 simp1l2 simp1l3
      oveq2 simp1 simp2l simp1r simp2rr simp3 simpll syl eleqtrd simp2rl 3eqtrd
      simp2lr 3expa expcom pm2.61ine expr mp2and eleq2 anbi12d eqeq1 syl5ibrcom
      ex expimpd rexlimdva rexlimivv sylbi 3impib ) AUAGZBAGZCAGZHZBCSZABCIJZKZ
      WRDLZELZSZAXEXFIJZKZHZEFLZUBUCZMZDXLMFNMXAXBHZXDOZAFEDUDXMXOFDNXLXKNGZXEX
      LGZHXJXOEXLXPXQXFXLGZXJXOOXPXQXRUEZXGXIXOXSXGHZXOXIBXHGZCXHGZHZXBHZXHXCKZ
      OXTYDYEXTYDHZBXLGZCXLGZYEYFXHXLBYFXPXQXRXGXHXLUJXPXQXRXGYDUFXPXQXRXGYDUGX
      PXQXRXGYDUHXSXGYDUKXEXFXKULPZXTYAYBXBUIUMYFXHXLCYIXTYAYBXBUNZUMXTYDYGYHHZ
      YEXTYDYKHZHZYEOZCXECXEKZYNXTYCBXESZHZYKHZHZXHBXEIJZKZOYSXHXEBIJZYTYSYAXHU
      UBKZYRYAXTYAYBYPYKUOUPYSXPXQXRXGYGXEBSZYAUUCOXPXQXRXGYRUFZXPXQXRXGYRUGZXP
      XQXRXGYRUHXSXGYRUKXTYQYGYHUQZYSBXEXTYCYPYKUNQZXEXFBXKRTURYSXPXQYGUUDUUBYT
      KUUEUUFUUGUUHXEBXKUSPUTYOYMYSYEUUAYOYLYRXTYOYDYQYKYOXBYPYCCXEBVAVBVCVBYOX
      CYTXHCXEBIVKVDVEVFYMCXESZYEXTYLUUIYEXTYLUUIUEZXHCXEIJZCBIJZXCUUJXHXECIJZU
      UKUUJYBXHUUMKZUUJXTYDYBXTYLUUIVLXTYDYKUUIVMZYJVGUUJXPXQXRXGYHXECSZYBUUNOX
      PXQXRXGYLUUIVHZXPXQXRXGYLUUIVIZXPXQXRXGYLUUIVJXSXGYLUUIVNYGYHYDXTUUIVOZUU
      JCXEXTYLUUIVPZQZXEXFCXKRTURUUJXPXQYHUUPUUMUUKKUUQUURUUSUVAXECXKUSPUTZUUJB
      UUKGZUUKUULKZUUJBXHUUKUUJYDYAUUOYAYBXBVQVRUVBVSUUJXPYHXQUUIYGCBSZUVCUVDOU
      UQUUSUURUUTYGYHYDXTUUIVTZUUJBCYCXBYKXTUUIWBQZCXEBXKRTURUUJXPYHYGUVEUULXCK
      UUQUUSUVFUVGCBXKUSPWAWCWDWEWFWGWLXIXNYDXDYEXIXAYCXBXIWSYAWTYBAXHBWHAXHCWH
      WIVCAXHXCWJVEWKWMWCWNWOWPWQ $.
  $}

  ${
    $d N n $.  $d n p $.  $d N p $.  $d n q $.  $d N q $.  $d P n $.  $d P p $.
    $d p q $.  $d P q $.  $d P x $.  $d Q n $.  $d Q p $.  $d Q q $.  $d Q x $.
    $( There is a line through any two distinct points.  Hilbert's axiom I.1
       for geometry.  (Contributed by Scott Fenton, 29-Oct-2013.)  (Revised by
       Mario Carneiro, 19-Apr-2014.) $)
    hilbert1.1 $p |- ( ( N e. NN /\
       ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ P =/= Q ) ) ->
       E. x e. LinesEE ( P e. x /\ Q e. x ) ) $=
      ( vp vq vn cn wcel cee cfv wne wa cline2 co clines2 cv wrex wceq anbi12d
      simp1 simp2 simp3 eqidd neeq1 oveq1 neeq2 oveq2 rspc2ev syl112anc rexeqdv
      w3a eqeq2d fveq2 rexeqbidv rspcev sylan2 sylibr linerflx1 linerflx2 eleq2
      ellines syl12anc ) DHIZBDJKZIZCVEIZBCLZULZMZBCNOZPIZBVKIZCVKIZBAQZIZCVOIZ
      MZAPRVJEQZFQZLZVKVSVTNOZSZMZFGQZJKZRZEWFRZGHRZVLVIVDWDFVERZEVERZWIVIVFVGV
      HVKVKSZWKVFVGVHUAVFVGVHUBVFVGVHUCVIVKUDWDVHWLMBVTLZVKBVTNOZSZMEFBCVEVEVSB
      SZWAWMWCWOVSBVTUEWPWBWNVKVSBVTNUFUMTVTCSZWMVHWOWLVTCBUGWQWNVKVKVTCBNUHUMT
      UIUJWHWKGDHWEDSZWGWJEWFVEWEDJUNZWRWDFWFVEWSUKUOUPUQVKGFEVBURBCDUSBCDUTVRV
      MVNMAVKPVOVKSVPVMVQVNVOVKBVAVOVKCVATUPVC $.
  $}

  ${
    $d P x $.  $d P y $.  $d Q x $.  $d Q y $.  $d x y $.
    $( There is at most one line through any two distinct points.  Hilbert's
       axiom I.2 for geometry.  (Contributed by Scott Fenton, 29-Oct-2013.)
       (Revised by NM, 17-Jun-2017.) $)
    hilbert1.2 $p |- ( P =/= Q -> E* x e. LinesEE ( P e. x /\ Q e. x ) ) $=
      ( vy wne cv wcel wa weq wi clines2 wral wceq simprl simprr simpl linethru
      syl3anc ex eleq2 wrmo cline2 co anim12d eqtr3 syl6 syl5bi exp3a ralrimivv
      an4 anbi12d rmo4 sylibr ) BCEZBAFZGZCUOGZHZBDFZGZCUSGZHZHZADIZJZDKLAKLURA
      KUAUNVEADKKUNUOKGZUSKGZHZVCVDVHVCHVFURHZVGVBHZHZUNVDVFVGURVBUJUNVKUOBCUBU
      CZMZUSVLMZHVDUNVIVMVJVNUNVIVMUNVIHVFURUNVMUNVFURNUNVFUROUNVIPUOBCQRSUNVJV
      NUNVJHVGVBUNVNUNVGVBNUNVGVBOUNVJPUSBCQRSUDUOUSVLUEUFUGUHUIURVBADKVDUPUTUQ
      VAUOUSBTUOUSCTUKULUM $.
  $}

  ${
    $d P x $.  $d Q x $.
    $( There is a unique line going through any two distinct points.  Theorem
       6.19 of [Schwabhauser] p. 46.  (Contributed by Scott Fenton,
       29-Oct-2013.)  (Revised by Mario Carneiro, 19-Apr-2014.) $)
    linethrueu $p |- ( ( N e. NN /\
       ( P e. ( EE ` N ) /\ Q e. ( EE ` N ) /\ P =/= Q ) ) ->
       E! x e. LinesEE ( P e. x /\ Q e. x ) ) $=
      ( cn wcel cee cfv wne w3a wa clines2 wrex wrmo wreu hilbert1.1 hilbert1.2
      cv simpr3 syl reu5 sylanbrc ) DEFZBDGHZFZCUDFZBCIZJKZBARZFCUIFKZALMUJALNZ
      UJALOABCDPUHUGUKUCUEUFUGSABCQTUJALUAUB $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( Two distinct lines intersect in at most one point.  Theorem 6.21 of
       [Schwabhauser] p. 46.  (Contributed by Scott Fenton, 29-Oct-2013.)
       (Revised by Mario Carneiro, 19-Apr-2014.) $)
    lineintmo $p |- ( ( A e. LinesEE /\ B e. LinesEE /\ A =/= B ) ->
       E* x ( x e. A /\ x e. B ) ) $=
      ( vy clines2 wcel wne w3a cv wa weq wi wal wmo an4 wceq linethru 3expa ex
      eleq1 cline2 co eqtr3 syl2an anandirs necon1d an4s sylan2b com23 alrimivv
      3impia anbi12d mo4 sylibr ) BEFZCEFZBCGZHZAIZBFZUSCFZJZDIZBFZVCCFZJZJZADK
      ZLZDMAMVBANURVIADUOUPUQVIUOUPJZVGUQVHVJVGUQVHLZVGVJUTVDJZVAVEJZJVKUTVAVDV
      EOUOVLUPVMVKUOVLJZUPVMJZJZUSVCBCVPUSVCGZBCPZVNVOVQVRVNVQJBUSVCUAUBZPZCVSP
      ZVRVOVQJUOVLVQVTBUSVCQRUPVMVQWACUSVCQRBCVSUCUDUESUFUGUHSUIUKUJVBVFADVHUTV
      DVAVEUSVCBTUSVCCTULUMUN $.
  $}

  $(
  @{
    @d a n @.  @d a p @.  @d a q @.  @d n p @.  @d n q @.  @d P a @.  @d P n @.
    @d P p @.  @d p q @.  @d P q @.  @d p x @.  @d P x @.  @d Q a @.  @d Q n @.
    @d Q p @.  @d Q q @.  @d q x @.  @d Q x @.  @d R a @.  @d R n @.  @d R p @.
    @d R q @.  @d R x @.
    @( Three points are colinear iff there is a line through all three of
       them.  Theorem 6.23 of [Schwabhauser] p. 46.  ( Contributed by Scott
       Fenton, 7-Nov-2013). @)
    colinline @p |- ( ( Q e. V /\ R e. W ) -> ( P Colinear <. Q , R >. <->
          E. a e. LinesEE ( P e. a /\ Q e. a /\ R e. a ) ) ) @=
      ( vp vq vn vx wcel wa cop ccolin wbr cv w3a clines2 wrex wne cline2 co
      wceq cee cfv cn wi ellines df-3an cab fvline eqeq2d cvv eleq2 3anbi123d
      breq1 eqid elab4g 3anbi123i syl6bb pm5.32i 3an6 syl5bi adantld exp3a
      sylbid sylan2br expr imp3a anassrs rexlimdva rexlimivv sylbi rexlimiv
      impbid1 ) BDKCEKLABCMNOZAFPZKZBVQKZCVQKZQZFRS?WAVPFRVQRKGPZHPZTZVQWBWCUAU
      BZUCZLZHIPZUDUEZSZGWISIUFSWAVPUGZVQIHGUHWJWKIGUFWIWHUFKZWBWIKZLWGWKHWIWLW
      MWCWIKZWGWKUGWLWMWNLZLWDWFWKWLWOWDWFWKUGZWOWDLWLWMWNWDQZWPWMWNWDUIWLWQLZW
      FVQJPZWBWCMZNOZJUJZUCZWKWRWEXBVQJWBWCWHUKULWRXCWAVPXCWALXCAUMKZAWTNOZLZBU
      MKZBWTNOZLZCUMKZCWTNOZLZQZLWRVPXCWAXMXCWAAXBKZBXBKZCXBKZQXMXCVRXNVSXOVTXP
      VQXBAUNVQXBBUNVQXBCUNUOXNXFXOXIXPXLXAXEJAXBWSAWTNUPXBUQZURXAXHJBXBWSBWTNU
      PXQURXAXKJCXBWSCWTNUPXQURUSUTVAWRXMVPXCXMXDXGXJQXEXHXKQLWRVPXDXEXGXHXJXKV
      B?VCVDVCVEVFVGVHVIVJVKVLVMVNVO @.
      @( [19-Apr-2014] @) @( [7-Nov-2013] @)
  @}
  $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Bernoulli polynomials and sums of k-th powers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c BernPoly $.

  $( Declare the constant for the Bernoulli polynomial operator. $)
  cbp $a class BernPoly $.

  ${
    $d e f g k m n s x $.
    $( Define the Bernoulli polynomials.  Here we use well-founded recursion to
       define the Bernoulli polynomials.  This agrees with most textbook
       definitions, although explicit formulae do exist.  (Contributed by Scott
       Fenton, 22-May-2014.) $)
    df-bpoly $a |- BernPoly =
       ( m e. NN0 , x e. CC |->
         ( wrecs ( < , NN0 , ( g e. _V |-> [_ ( # ` dom g ) / n ]_
            ( ( x ^ n ) - sum_ k e. dom g ( ( n _C k ) x.
              ( ( g ` k ) / ( ( n - k )
              + 1 ) ) ) ) ) ) ` m ) ) $.
  $}

  ${
    $d e f g k m n s x F $.  $d e g k m n x N $.  $d a b c e f g k m n s x X $.
    $d e f s G $.
    ${
      bpoly.1 $e |- G = ( g e. _V |-> [_ ( # ` dom g ) / n ]_
         ( ( X ^ n ) - sum_ k e. dom g ( ( n _C k ) x.
           ( ( g ` k ) / ( ( n - k ) + 1 ) ) ) ) ) $.
      bpoly.2 $e |- F = wrecs ( < , NN0 , G ) $.
      $( Lemma for ~ bpolyval .  (Contributed by Scott Fenton, 22-May-2014.)
         (Revised by Mario Carneiro, 23-Aug-2014.) $)
      bpolylem $p |- ( ( N e. NN0 /\ X e. CC ) ->
         ( N BernPoly X ) = ( ( X ^ N ) -
            sum_ k e. ( 0 ... ( N - 1 ) ) ( ( N _C k ) x.
              ( ( k BernPoly X ) / ( ( N - k ) + 1 ) ) ) ) ) $=
        ( cn0 wcel co cfv clt c1 cmin cdiv cmul cvv wceq vm vx cc wa cpred cres
        cbp cexp cc0 cfz cbc caddc csu cdm chash csb cmpt cwrecs oveq1 csbeq2dv
        cv oveq1d mpteq2dv syl6eqr wrecseq3 syl fveq1d fveq2 sylan9eqr df-bpoly
        fvex ovmpt2a wwe cuz ltweuz nn0uz weeq2 ax-mp mpbir wse nn0ex exse wfr2
        adantr prednn0 reseq2d fveq2d wfun wfr1 fnfun ovex resfunexg mp2an dmeq
        wb wfn wss elfznn0 ssriv fnssres syl6eq fveq1 fvres sylan9eq sumeq12rdv
        fndm oveq2d csbeq1d eqtrd csbex fvmpt nfcvd oveq2 oveq12d sumeq2sdv cen
        csbiegf wbr cz nn0z fz01en cfn fzfi hashen sylibr hashfz1 axia2 syl2anr
        weq sumeq2dv 3eqtr4d syl5eq 3eqtrd ) FJKZGUCKZUDZFGUGLFDMZDJNFUEZUFZEMZ
        GFUHLZUIFOPLZUJLZFBVAZUKLZUUDGUGLZFUUDPLZOULLZQLZRLZBUMZPLZUAUBFGJUCUAV
        AZJNASCAVAZUNZUOMZUBVAZCVAZUHLZUUOUURUUDUKLZUUDUUNMZUURUUDPLZOULLZQLZRL
        ZBUMZPLZUPZUQZURZMZYQUGUUQGTZUUMFTUVKUUMDMZYQUVLUUMUVJDUVLUVJJNEURZDUVL
        UVIETUVJUVNTUVLUVIASCUUPGUURUHLZUVFPLZUPZUQEUVLASUVHUVQUVLCUUPUVGUVPUVL
        UUSUVOUVFPUUQGUURUHUSVBUTVCHVDJNUVIEVEVFIVDVGZUUMFDVHVIUBABUACVJZFDVKVL
        YNYQYTTYOJNDEFJNVMZUIVNMZNVMZUIVOJUWATUVTUWBWOVPJUWANVQVRVSZJSKJNVTWAJN
        SWBVRZIWCWDYPYTDUUCUFZEMZUULYPYSUWEEYPYRUUCDYNYRUUCTYOFWEWDWFWGYPUWFCUU
        CUOMZUVOUUCUUTUUDDMZUVCQLZRLZBUMZPLZUPZUULUWESKZUWFUWMTDWHZUUCSKUWNDJWP
        ZUWOJNDEUWCUWDIWIZJDWJVRUIUUBUJWKDUUCSWLWMAUWEUVQUWMSEUUNUWETZUVQCUUPUW
        LUPUWMUWRCUUPUVPUWLUWRUVFUWKUVOPUWRUUOUUCUVEUWJBUWRUUOUWEUNZUUCUUNUWEWN
        UWEUUCWPZUWSUUCTUWPUUCJWQUWTUWQBUUCJUUDUUBWRZWSJUUCDWTWMUUCUWEXFVRXAZUW
        RUUDUUCKZUDZUVDUWIUUTRUXDUVAUWHUVCQUWRUXCUVAUUDUWEMUWHUUDUUNUWEXBUUDUUC
        DXCXDVBXGXEXGUTUWRCUUPUWGUWLUWRUUOUUCUOUXBWGXHXIHCUWGUWLUVOUWKPWKXJXKVR
        YPCFUWLUPZUUAUUCUUEUWHUUHQLZRLZBUMZPLZUWMUULYNUXEUXITYOCFUWLUXIJYNCUXIX
        LUURFTZUVOUUAUWKUXHPUURFGUHXMUXJUUCUWJUXGBUXJUUTUUEUWIUXFRUURFUUDUKUSUX
        JUVCUUHUWHQUXJUVBUUGOULUURFUUDPUSVBXGXNXOXNXQWDYPCUWGFUWLYNUWGFTYOYNUWG
        OFUJLZUOMZFYNUUCUXKXPXRZUWGUXLTZYNFXSKUXMFXTFYAVFUUCYBKUXKYBKUXNUXMWOUI
        UUBYCOFYCUUCUXKYDWMYEFYFXIWDXHYPUUKUXHUUAPYPUUCUUJUXGBYPUXCUDZUUIUXFUUE
        RUXOUUFUWHUUHQUXCUUDJKYOUUFUWHTYPUXAYNYOYGUAUBUUDGJUCUVKUWHUGUVLUABYIUV
        KUVMUWHUVRUUMUUDDVHVIUVSUUDDVKVLYHVBXGYJXGYKYLXIYM $.
    $}

    $( The value of the Bernoulli polynomials.  (Contributed by Scott Fenton,
       16-May-2014.) $)
    bpolyval $p |- ( ( N e. NN0 /\ X e. CC ) ->
       ( N BernPoly X ) = ( ( X ^ N ) -
          sum_ k e. ( 0 ... ( N - 1 ) ) ( ( N _C k ) x.
            ( ( k BernPoly X ) / ( ( N - k ) + 1 ) ) ) ) ) $=
      ( vg vn vc vm cv chash cfv cexp co cbc cmin caddc cdiv cmul csu oveq12d
      c1 cn0 clt cvv cdm cmpt cwrecs csb weq fvex nfcv wceq oveq2 oveq1d oveq2d
      oveq1 sumeq2sdv csbief fveq2 cbvsumv dmeq fveq1 adantr sumeq12dv csbeq2dv
      wcel syl5eq syl5eqr fveq2d csbeq1d eqtrd cbvmptv eqid bpolylem ) DAEUAUBF
      UCCFHZUDZIJZKLZVOVPGHZMLZVRVNJZVPVRNLZTOLZPLZQLZGRZNLZUEZUFZWGBCFDUCWFEDH
      ZUDZIJZCEHZKLZWJWLAHZMLZWNWIJZWLWNNLZTOLZPLZQLZARZNLZUGZFDUHZWFEVPXBUGZXC
      XDWFEVPWMVOWLVRMLZVTWLVRNLZTOLZPLZQLZGRZNLZUGXEEVPXLWFVOIUIEWFUJWLVPUKZWM
      VQXKWENWLVPCKULXMVOXJWDGXMXFVSXIWCQWLVPVRMUOXMXHWBVTPXMXGWATOWLVPVRNUOUMU
      NSUPSUQXDEVPXLXBXDXKXAWMNXDXKVOWOWNVNJZWRPLZQLZARXAVOXJXPGAGAUHZXFWOXIXOQ
      VRWNWLMULXQVTXNXHWRPVRWNVNURXQXGWQTOVRWNWLNULUMSSUSXDVOWJXPWTAVNWIUTZXDXP
      WTUKWNVOVEXDXOWSWOQXDXNWPWRPWNVNWIVAUMUNVBVCVFUNVDVGXDEVPWKXBXDVOWJIXRVHV
      IVJVKWHVLVM $.
  $}

  ${
    $d X k $.
    $( The value of the Bernoulli polynomials at zero.  (Contributed by Scott
       Fenton, 16-May-2014.) $)
    bpoly0 $p |- ( X e. CC -> ( 0 BernPoly X ) = 1 ) $=
      ( vk cc wcel cc0 cbp co cexp c1 cmin cfz cv cbc caddc cdiv cmul csu eqtri
      cn0 c0 wceq 0nn0 mpan exp0 oveq1d risefall0lem sumeq1i sum0 oveq2i ax-1cn
      bpolyval subid1i syl6eq eqtrd ) ACDZEAFGZAEHGZEEIJGKGZEBLZMGUSAFGEUSJGING
      OGPGZBQZJGZIESDUOUPVBUAUBBEAUKUCUOVBIVAJGZIUOUQIVAJAUDUEVCIEJGIVAEIJVATUT
      BQEURTUTBUFUGUTBUHRUIIUJULRUMUN $.
  $}

  ${
    $d X k $.
    $( The value of the Bernoulli polynomials at one.  (Contributed by Scott
       Fenton, 16-May-2014.) $)
    bpoly1 $p |- ( X e. CC -> ( 1 BernPoly X ) = ( X - ( 1 / 2 ) ) ) $=
      ( vk cc wcel c1 cbp cc0 cmin cfz cbc caddc cdiv cmul csu wceq 1nn0 syl6eq
      co c2 oveq12d cexp cv cn0 bpolyval mpan 1m1e0 oveq2i sumeq1i cz 0z bpoly0
      exp1 oveq1d oveq2d ax-1cn ax-mp mulid2i syl6eqel oveq2 bcn0 oveq1 subid1i
      halfcl df-2 syl6eqr fsum1 sylancr eqtrd syl5eq ) ACDZEAFRZAEUARZGEEHRZIRZ
      EBUBZJRZVOAFRZEVOHRZEKRZLRZMRZBNZHRZAESLRZHREUCDZVJVKWCOPBEAUDUEVJVLAWBWD
      HAULVJWBGGIRZWABNZWDVNWFWABVMGGIUFUGUHVJWGEGAFRZSLRZMRZWDVJGUIDWJCDWGWJOU
      JVJWJWDCVJWJEWDMRWDVJWIWDEMVJWHESLAUKUMUNWDECDWDCDUOEVCUPZUQQZWKURWAWJBGV
      OGOZVPEVTWIMWMVPEGJRZEVOGEJUSWEWNEOPEUTUPQWMVQWHVSSLVOGAFVAWMVSEEKRSWMVRE
      EKWMVREGHREVOGEHUSEUOVBQUMVDVETTVFVGWLVHVITVH $.
  $}

  ${
    $d N n $.  $d X k m n $.
    $( Closure law for Bernoulli polynomials.  (Contributed by Scott Fenton,
       16-May-2014.)  (Proof shortened by Mario Carneiro, 22-May-2014.) $)
    bpolycl $p |- ( ( N e. NN0 /\ X e. CC ) -> ( N BernPoly X ) e. CC ) $=
      ( vn vk vm cn0 wcel cc cbp co cv wi wceq oveq1 eleq1d imbi2d cc0 cmin cfz
      c1 wral r19.21v w3a cexp cbc caddc cdiv cmul bpolyval 3adant3 simp2 simp1
      expcld fzfid wa cz elfzelz bccl syl2an nn0cnd rspccva 3ad2antl3 cn fzssp1
      ax-1cn npcan sylancl oveq2d syl5sseq sselda fznn0sub nn0p1nn nncnd nnne0d
      csu 3syl divcld mulcld fsumcl subcld eqeltrd 3exp a2d syl5bi nn0sinds imp
      ) AFGBHGZABIJZHGZWGCKZBIJZHGZLZWGDKZBIJZHGZLZWGWILCDAWJWNMZWLWPWGWRWKWOHW
      JWNBINOPWJAMZWLWIWGWSWKWHHWJABINOPWQDQWJTRJZSJZUAWGWPDXAUAZLWJFGZWMWGWPDX
      AUBXCWGXBWLXCWGXBWLXCWGXBUCZWKBWJUDJZXAWJEKZUEJZXFBIJZWJXFRJZTUFJZUGJZUHJ
      ZEVOZRJZHXCWGWKXNMXBEWJBUIUJXDXEXMXDBWJXCWGXBUKXCWGXBULZUMXDXAXLEXDQWTUNX
      DXFXAGZUOZXGXKXQXGXDXCXFUPGXGFGXPXOXFQWTUQXFWJURUSUTXQXHXJXBXCXPXHHGZWGWP
      XRDXFXAWNXFMWOXHHWNXFBINOVAVBXQXJXQXFQWJSJZGXIFGXJVCGXDXAXSXFXDQWTTUFJZSJ
      XAXSQWTVDXDXTWJQSXDWJHGTHGXTWJMXDWJXOUTVEWJTVFVGVHVIVJXFQWJVKXIVLVPZVMXQX
      JYAVNVQVRVSVTWAWBWCWDWEWF $.
  $}

  ${
    $d N k $.  $d X k $.
    $( A sum for Bernoulli polynomials.  (Contributed by Scott Fenton,
       16-May-2014.)  (Proof shortened by Mario Carneiro, 22-May-2014.) $)
    bpolysum $p |- ( ( N e. NN0 /\ X e. CC ) ->
      sum_ k e. ( 0 ... N ) ( ( N _C k ) x. ( ( k BernPoly X ) / ( ( N - k ) +
        1 ) ) ) = ( X ^ N ) ) $=
      ( cn0 wcel cc wa cc0 cfz co cbc cbp cmin c1 cdiv cmul wceq oveq12d oveq2d
      caddc cv csu cexp cuz cfv simpl nn0uz syl6eleq elfzelz bccl syl2an nn0cnd
      cz elfznn0 simpr bpolycl syl2anr fznn0sub adantl nn0p1nn syl nncnd nnne0d
      cn divcld mulcld oveq2 oveq1 oveq1d fsumm1 bcnn adantr nn0cn subidd 0p1e1
      syl6eq div1d eqtrd bpolyval eqcomd expcl ancoms fzfid fzssp1 ax-1cn npcan
      mulid2d sylancl syl5sseq sselda syldan fsumcl subaddd mpbid 3eqtrd ) BDEZ
      CFEZGZHBIJZBAUAZKJZWTCLJZBWTMJZNTJZOJZPJZAUBHBNMJZIJZXFAUBZBBKJZBCLJZBBMJ
      ZNTJZOJZPJZTJXIXKTJZCBUCJZWRXFXOAHBWRBDHUDUEWPWQUFZUGUHWRWTWSEZGZXAXEXTXA
      WRWPWTUMEXADEXSXRWTHBUIWTBUJUKULXTXBXDXSWTDEWQXBFEWRWTBUNWPWQUOWTCUPUQXTX
      DXTXCDEZXDVDEXSYAWRWTHBURUSXCUTVAZVBXTXDYBVCVEVFZWTBQZXAXJXEXNPWTBBKVGYDX
      BXKXDXMOWTBCLVHYDXCXLNTWTBBMVGVIRRVJWRXOXKXITWRXONXKPJXKWRXJNXNXKPWPXJNQW
      QBVKVLWRXNXKNOJXKWRXMNXKOWRXMHNTJNWRXLHNTWRBWPBFEZWQBVMVLZVNVIVOVPSWRXKBC
      UPZVQVRRWRXKYGWGVRSWRXQXIMJZXKQXPXQQWRXKYHABCVSVTWRXQXIXKWQWPXQFECBWAWBWR
      XHXFAWRHXGWCWRWTXHEXSXFFEWRXHWSWTWRHXGNTJZIJXHWSHXGWDWRYIBHIWRYENFEYIBQYF
      WEBNWFWHSWIWJYCWKWLYGWMWNWO $.
  $}

  ${
    $d k m n N $.  $d k m ph $.  $d k m n X $.
    ${
      bpolydiflem.1 $e |- ( ph -> N e. NN ) $.
      bpolydiflem.2 $e |- ( ph -> X e. CC ) $.
      bpolydiflem.3 $e |- ( ( ph /\ k e. ( 1 ... ( N - 1 ) ) ) ->
                            ( ( k BernPoly ( X + 1 ) ) - ( k BernPoly X ) ) =
                              ( k x. ( X ^ ( k - 1 ) ) ) ) $.
      $( Lemma for ~ bpolydif .  (Contributed by Scott Fenton, 12-Jun-2014.) $)
      bpolydiflem $p |- ( ph ->
                          ( ( N BernPoly ( X + 1 ) ) - ( N BernPoly X ) ) =
                            ( N x. ( X ^ ( N - 1 ) ) ) ) $=
        ( vm c1 caddc co cmin cc0 cfz cdiv cmul wcel cc wceq oveq12d cbp cv cbc
        csu cn0 nnnn0d peano2cn syl bpolyval syl2anc expcld fzfid wa cz elfzelz
        cexp syl2an nn0cnd elfznn0 bpolycl syl2anr cn fzssp1 nncnd ax-1cn npcan
        bccl sylancl oveq2d syl5sseq sselda nn0p1nn nnne0d divcld mulcld fsumcl
        fznn0sub sub4d addcom oveq1d binom1p eqtrd cuz cfv nn0uz syl6eleq bccl2
        adantl expcl oveq2 fsumm1 bcnn mulid2d 3eqtrd syldan pncand nnm1nn0 a1i
        c2 subsub4d oveq2i syl6eqr sumeq1d bcnm1 oveq1 fsum1p bpoly0 0z subid1d
        df-2 eqeltrd peano2nnd nnrecred recnd fzp1ss ax-mp sseli sylan2 pnpcand
        wss 1z nnzd 2z zsubcl 2m1e1 2cn subsubd syl5reqr fsumshft oveq1i eleq2i
        0p1e1 bcm1k adantr elfznn sylbir wne divsubdird 3eqtr3d mulassd sylan2b
        div23d subdid nn0zd divcan6d sumeq2dv fsumsub 3eqtr2rd pncan2d ) ACDIJK
        ZUAKZCDUAKZLKUUJCUPKZMCILKZNKZCBUBZUCKZUUPUUJUAKZCUUPLKZIJKZOKZPKZBUDZL
        KZDCUPKZUUOUUQUUPDUAKZUUTOKZPKZBUDZLKZLKUUMUVELKZUVCUVILKZLKZCDUUNUPKZP
        KZAUUKUVDUULUVJLACUEQZUUJRQZUUKUVDSACEUFZADRQZUVQFDUGUHZBCUUJUIUJAUVPUV
        SUULUVJSUVRFBCDUIUJTAUUMUVCUVEUVIAUUJCUVTUVRUKAUUOUVBBAMUUNULZAUUPUUOQZ
        UMZUUQUVAUWCUUQAUVPUUPUNQUUQUEQUWBUVRUUPMUUNUOUUPCVGUQURZUWCUURUUTUWBUU
        PUEQZUVQUURRQZAUUPUUNUSZUVTUUPUUJUTVAZUWCUUTUWCUUSUEQZUUTVBQUWCUUPMCNKZ
        QUWIAUUOUWJUUPAMUUNIJKZNKUUOUWJMUUNVCAUWKCMNACRQIRQZUWKCSACEVDZVECIVFVH
        ZVIVJZVKUUPMCVQUHUUSVLUHZVDZUWCUUTUWPVMZVNVOZVPADCFUVRUKZAUUOUVHBUWAUWC
        UUQUVGUWDUWCUVFUUTUWBUWEUVSUVFRQZAUWGFUUPDUTVAZUWQUWRVNVOZVPVRAUVMMCWSL
        KZNKZCHUBZUCKZDUXFUPKZPKZHUDZUVOJKZUXJLKUVOAUVKUXKUVLUXJLAUVKUUOUXIHUDZ
        MUUNILKZNKZUXIHUDZCUUNUCKZUVNPKZJKUXKAUVKUXLUVEJKZUVELKUXLAUUMUXRUVELAU
        UMUWJUXIHUDZUXLCCUCKZUVEPKZJKUXRAUUMIDJKZCUPKZUXSAUUJUYBCUPAUVSUWLUUJUY
        BSFVEDIVSVHVTAUVSUVPUYCUXSSFUVRDHCWAUJWBAUXIUYAHMCACUEMWCWDZUVRWEWFAUXF
        UWJQZUMZUXGUXHUYFUXGUYEUXGVBQAUXFCWGWHVDAUVSUXFUEQUXHRQUYEFUXFCUSDUXFWI
        UQVOZUXFCSUXGUXTUXHUVEPUXFCCUCWJUXFCDUPWJTWKAUYAUVEUXLJAUYAIUVEPKUVEAUX
        TIUVEPAUVPUXTISUVRCWLUHVTAUVEUWTWMWBVIWNVTAUXLUVEAUUOUXIHUWAAUXFUUOQZUY
        EUXIRQZAUUOUWJUXFUWOVKUYGWOZVPUWTWPWBAUXIUXQHMUUNAUUNUEUYDACVBQZUUNUEQE
        CWQUHZWEWFZUYJUXFUUNSUXGUXPUXHUVNPUXFUUNCUCWJUXFUUNDUPWJTWKAUXOUXJUXQUV
        OJAUXNUXEUXIHAUXMUXDMNAUXMCIIJKZLKUXDACIIUWMUWLAVEWRZUYOWTWSUYNCLXJXAXB
        VIXCAUXPCUVNPAUVPUXPCSUVRCXDUHVTTWNAUVLCMUCKZICMLKZIJKZOKZPKZMIJKZUUNNK
        ZUVBBUDZJKZUYTVUBUVHBUDZJKZLKVUCVUELKZUXJAUVCVUDUVIVUFLAUVCUYPMUUJUAKZU
        YROKZPKZVUCJKVUDAUVBVUJBMUUNUYMUWSUUPMSZUUQUYPUVAVUIPUUPMCUCWJZVUKUURVU
        HUUTUYROUUPMUUJUAXEVUKUUSUYQIJUUPMCLWJVTZTTXFAVUJUYTVUCJAVUIUYSUYPPAVUH
        IUYROAUVQVUHISUVTUUJXGUHVTVIVTWBAUVIUYPMDUAKZUYROKZPKZVUEJKVUFAUVHVUPBM
        UUNUYMUXCVUKUUQUYPUVGVUOPVULVUKUVFVUNUUTUYROUUPMDUAXEVUMTTXFAVUPUYTVUEJ
        AVUOUYSUYPPAVUNIUYROAUVSVUNISFDXGUHVTVIVTWBTAUYTVUCVUEAUYPUYSAUYPAUVPMU
        NQZUYPUEQUVRXHMCVGVHURAUYSAUYRAUYQAUYQCVBACUWMXIEXKXLXMXNVOAVUBUVBBAVUA
        UUNULZUUPVUBQZAUWBUVBRQVUBUUOUUPVUQVUBUUOXTXHMUUNXOXPXQZUWSXRZVPAVUBUVH
        BVURVUSAUWBUVHRQVUTUXCXRZVPXSAUXJVUBCUUPILKZUCKZDVVCUPKZPKZBUDZVUBUVBUV
        HLKZBUDVUGAUXJVUAUXDIJKZNKZVVFBUDVVGAUXIVVFHBIMUXDIUNQAYAWRVUQAXHWRACUN
        QWSUNQUXDUNQACEYBYCCWSYDVHAUXFUXEQUYHUYIAUXEUUOUXFAMVVINKUXEUUOMUXDVCAV
        VIUUNMNAUUNCWSILKZLKVVIVVKICLYEXAACWSIUWMWSRQAYFWRUYOYGYHZVIVJVKUYJWOZU
        XFVVCSUXGVVDUXHVVEPUXFVVCCUCWJUXFVVCDUPWJTYIAVVJVUBVVFBAVVIUUNVUANVVLVI
        XCWBAVUBVVHVVFBVUSAUUPIUUNNKZQZVVHVVFSVUBVVNUUPVUAIUUNNYLYJYKZAVVOUMZUU
        QUVAUVGLKZPKVVDUUTUUPOKZPKZUUPUUTOKZVVEPKZPKZVVHVVFVVQUUQVVTVVRVWBPVVQU
        UQVVDCVVCLKZUUPOKZPKZVVTVVQUUPICNKZQUUQVWFSAVVNVWGUUPAIUWKNKVVNVWGIUUNV
        CAUWKCINUWNVIVJVKUUPCYMUHVVQVWEVVSVVDPVVQVWDUUTUUPOVVQCUUPIVVQCAUYKVVOE
        YNZVDVVQUUPVVOUUPVBQZAUUPUUNYOWHZVDZUWLVVQVEWRYGVTVIWBVVQUURUVFLKZUUTOK
        UUPVVEPKZUUTOKVVRVWBVVQVWLVWMUUTOGVTVVQUURUVFUUTVVOAUWBUWFVVOVUSUWBVVPV
        UTYPZUWHXRZVVOAUWBUXAVWNUXBXRZVVOAUWBUUTRQVWNUWQXRZVVOAUWBUUTMYQVWNUWRX
        RZYRVVQUUPVVEUUTVWKVVQDVVCAUVSVVOFYNVVQVWIVVCUEQVWJUUPWQUHZUKZVWQVWRUUB
        YSTVVQUUQUVAUVGVVOAUWBUUQRQVWNUWDXRVVQUURUUTVWOVWQVWRVNVVQUVFUUTVWPVWQV
        WRVNUUCVVQVWCVVDVVSVWBPKZPKVVFVVQVVDVVSVWBVVQVVDVVQUVPVVCUNQVVDUEQVVQCV
        WHUFVVQVVCVWSUUDVVCCVGUJURVVQUUTUUPVWQVWKVVQUUPVWJVMZVNZVVQVWAVVEVVQUUP
        UUTVWKVWQVWRVNZVWTVOYTVVQVXAVVEVVDPVVQVVSVWAPKZVVEPKIVVEPKVXAVVEVVQVXEI
        VVEPVVQUUTUUPVWQVWKVWRVXBUUEVTVVQVVSVWAVVEVXCVXDVWTYTVVQVVEVWTWMYSVIWBY
        SUUAUUFAVUBUVBUVHBVURVVAVVBUUGUUHWNTAUXJUVOAUXEUXIHAMUXDULVVMVPACUVNUWM
        ADUUNFUYLUKVOUUIWBWN $.
    $}

    $( Calculate the difference between successive values of the Bernoulli
       polynomials.  (Contributed by Scott Fenton, 16-May-2014.)  (Proof
       shortened by Mario Carneiro, 26-May-2014.) $)
    bpolydif $p |- ( ( N e. NN /\ X e. CC ) ->
       ( ( N BernPoly ( X + 1 ) ) - ( N BernPoly X ) ) =
       ( N x. ( X ^ ( N - 1 ) ) ) ) $=
      ( vn vk wcel c1 co cbp cmin cexp cmul wceq cv wi oveq1 oveq12d id eqeq12d
      oveq2d imbi2d vm cn cc caddc cfz wral w3a simp1 simp3 wa simpl3 3ad2antl2
      rspccva mpd bpolydiflem 3exp nnsinds imp ) AUBEBUCEZABFUDGZHGZABHGZIGZABA
      FIGZJGZKGZLZUSCMZUTHGZVHBHGZIGZVHBVHFIGZJGZKGZLZNUSDMZUTHGZVPBHGZIGZVPBVP
      FIGZJGZKGZLZNZUSVGNCDAVHVPLZVOWCUSWEVKVSVNWBWEVIVQVJVRIVHVPUTHOVHVPBHOPWE
      VHVPVMWAKWEQWEVLVTBJVHVPFIOSPRTVHALZVOVGUSWFVKVCVNVFWFVIVAVJVBIVHAUTHOVHA
      BHOPWFVHAVMVEKWFQWFVLVDBJVHAFIOSPRTVHUBEZWDDFVLUEGZUFZUSVOWGWIUSUGZUAVHBW
      GWIUSUHWGWIUSUIWJUAMZWHEZUJUSWKUTHGZWKBHGZIGZWKBWKFIGZJGZKGZLZWGWIUSWLUKW
      IWGWLUSWSNZUSWDWTDWKWHVPWKLZWCWSUSXAVSWOWBWRXAVQWMVRWNIVPWKUTHOVPWKBHOPXA
      VPWKWAWQKXAQXAVTWPBJVPWKFIOSPRTUMULUNUOUPUQUR $.
  $}

  ${
    $d K k n $.  $d M k n $.
    $( A closed-form expression for the sum of ` K ` -th powers.  (Contributed
       by Scott Fenton, 16-May-2014.)  (Revised by Mario Carneiro,
       16-Jun-2014.) $)
    fsumkthpow $p |- ( ( K e. NN0 /\ M e. NN0 ) ->
       sum_ n e. ( 0 ... M ) ( n ^ K ) =
       ( ( ( ( K + 1 ) BernPoly ( M + 1 ) ) - ( ( K + 1 ) BernPoly 0 ) ) /
         ( K + 1 ) ) ) $=
      ( vk cn0 wcel wa c1 caddc co cc0 cexp csu cmul cdiv cbp cmin oveq2 adantl
      cc cfz cv fzfid elfzelz zcnd simpl expcl syl2anr fsumcl cn nn0p1nn adantr
      nncnd nnne0d divcan3d fsummulc2 wceq bpolydif syl2an nn0cn ad2antrr pncan
      ax-1cn sylancl oveq2d eqtrd sumeq2dv cz nn0z cuz peano2nn0 nn0uz syl6eleq
      cfv elfznn0 nn0cnd bpolycl syl2anc fsumtscop2 3eqtr2d oveq1d eqtr3d ) BEF
      ZCEFZGZBHIJZKCUAJZAUBZBLJZAMZNJZWFOJWJWFCHIJZPJZWFKPJZQJZWFOJWEWJWFWEWGWI
      AWEKCUCZWHWGFZWHTFZWCWITFWEWQWHWHKCUDUEZWCWDUFWHBUGUHZUIWEWFWCWFUJFZWDBUK
      ULZUMZWEWFXBUNUOWEWKWOWFOWEWKWGWFWINJZAMWGWFWHHIJZPJZWFWHPJZQJZAMWOWEWGWI
      WFAWPXCWTUPWEWGXHXDAWEWQGZXHWFWHWFHQJZLJZNJZXDWEXAWRXHXLUQWQXBWSWFWHURUSX
      IXKWIWFNXIXJBWHLXIBTFZHTFXJBUQWCXMWDWQBUTVAVCBHVBVDVEVEVFVGWEWFDUBZPJZXGX
      FWNADWMKCXNWHWFPRXNXEWFPRXNKWFPRXNWLWFPRWDCVHFWCCVISWEWLEKVJVNWDWLEFWCCVK
      SVLVMWEXNKWLUAJFZGZWFEFZXNTFXOTFWCXRWDXPBVKVAXQXNXPXNEFWEXNWLVOSVPWFXNVQV
      RVSVTWAWB $.
  $}

  ${
    $d X k $.
    $( The Bernoulli polynomials at two.  (Contributed by Scott Fenton,
       8-Jul-2015.) $)
    bpoly2 $p |- ( X e. CC ->
       ( 2 BernPoly X ) =
       ( ( ( X ^ 2 ) - X ) + ( 1 / 6 ) ) ) $=
      ( vk cc wcel c2 cbp co cc0 c1 cmin cfz cbc caddc cdiv cmul c6 wceq syl6eq
      c3 oveq12d cexp cv csu cn0 2nn0 bpolyval mpan 2m1e1 eqtr4i oveq2i sumeq1i
      0p1e1 cneg cuz cfv 0nn0 nn0uz eleqtri a1i wo cpr cz fzpr ax-mp eleq2i vex
      0z elpr bitri wa oveq2 bcn0 oveq1 oveq1d 2cn subid1i oveq1i bpoly0 oveq2d
      df-3 3cn 3ne0 reccli mulid2i sylan9eqr syl6eqel eqeq2i ax-1cn npcan mp2an
      bcn1 sylbi bpoly1 halfcl subcl mpan2 wne divcan2 mp3an23 syl eqtrd adantr
      eqeltrd jaodan sylan2b fsump1 fsum1 sylancr addsub12 negsubdi2i halfthird
      2ne0 mp3an13 negeqi eqtr3i 6re recni gt0ne0ii negsub 3eqtrd syl5eq subsub
      6pos sqcl mp3an3 mpancom ) ACDZEAFGZAEUAGZHEIJGZKGZEBUBZLGZYLAFGZEYLJGZIM
      GZNGZOGZBUCZJGZYIAIPNGZJGZJGZYIAJGUUAMGZEUDDZYGYHYTQUEBEAUFUGYGYSUUBYIJYG
      YSHHIMGZKGZYRBUCZUUBYKUUGYRBYJUUFHKYJIUUFUHULUIUJUKYGUUHISNGZAIENGZJGZMGZ
      AUUAUMZMGZUUBYGUUHHHKGYRBUCZEIAFGZENGZOGZMGUULYGYRUURBHHHHUNUOZDYGHUDUUSU
      PUQURUSYLUUGDZYGYLHQZYLUUFQZUTZYRCDZUUTYLHUUFVAZDUVCUUGUVEYLHVBDZUUGUVEQV
      GHVCVDVEYLHUUFBVFVHVIYGUVAUVDUVBYGUVAVJYRUUICUVAYGYRIHAFGZSNGZOGZUUIUVAYM
      IYQUVHOUVAYMEHLGZIYLHELVKUUEUVJIQUEEVLVDRUVAYNUVGYPSNYLHAFVMUVAYPEHJGZIMG
      ZSUVAYOUVKIMYLHEJVKVNUVLEIMGSUVKEIMEVOVPVQVTUIRTTZYGUVIIUUIOGUUIYGUVHUUII
      OYGUVGISNAVRVNVSUUISWAWBWCZWDRZWEUVNWFYGUVBVJYRUUKCUVBYGYRUURUUKUVBYLIQZY
      RUURQUUFIYLULWGUVPYMEYQUUQOUVPYMEILGZEYLIELVKUUEUVQEQUEEWKVDRUVPYNUUPYPEN
      YLIAFVMUVPYPYJIMGZEUVPYOYJIMYLIEJVKVNECDZICDZUVREQVOWHEIWIWJRTTWLZYGUUREU
      UKENGZOGZUUKYGUUQUWBEOYGUUPUUKENAWMVNVSYGUUKCDZUWCUUKQZYGUUJCDZUWDUVTUWFW
      HIWNVDZAUUJWOWPZUWDUVSEHWQUWEVOXLUUKEWRWSWTXAZWEYGUWDUVBUWHXBXCXDXEUWAXFY
      GUUOUUIUURUUKMYGUUOUVIUUIYGUVFUVICDUUOUVIQVGYGUVIUUICUVOUVNWFYRUVIBHUVMXG
      XHUVOXAUWITXAYGUULAUUIUUJJGZMGZUUNUUICDYGUWFUULUWKQUVNUWGUUIAUUJXIXMUWJUU
      MAMUUJUUIJGZUMUWJUUMUUJUUIUWGUVNXJUWLUUAXKXNXOUJRYGUUACDZUUNUUBQPPXPXQPXP
      YCXRWCZAUUAXSWPXTYAVSYICDZYGUUCUUDQZAYDUWOYGUWMUWPUWNYIAUUAYBYEYFXT $.

    $( The Bernoulli polynomials at three.  (Contributed by Scott Fenton,
       8-Jul-2015.) $)
    bpoly3 $p |- ( X e. CC ->
       ( 3 BernPoly X ) =
       ( ( ( X ^ 3 ) - ( ( 3 / 2 ) x. ( X ^ 2 ) ) ) + ( ( 1 / 2 ) x. X ) ) ) $=
      ( vk cc wcel c3 cbp co cc0 c1 cmin caddc cdiv cmul wceq oveq2i 3cn ax-1cn
      c2 c4 2cn cexp cfz cv cbc csu 3nn0 bpolyval mpan 3m1e2 df-2 eqtri sumeq1i
      cn0 c6 cuz cfv 1nn0 nn0uz eleqtri a1i w3o ctp cpr csn cz fzpr ax-mp 0p1e1
      cun 0z preq2i 3eqtr3ri sneqi uneq12i df-tp fzsuc 3eqtr4ri eleq2i vex eltp
      bitri wa oveq2 bcn0 syl6eq oveq1 oveq1d subid1i oveq1i df-4 eqtr4i bpoly0
      oveq12d oveq2d 4cn 4re 4pos gt0ne0ii reccli sylan9eqr syl6eqel bcn1 npcan
      mulid2i mp2an bpoly1 halfcl subcl mpan2 3ne0 divcan2 mp3an23 eqtrd adantr
      wne syl eqeltrd bcn2 2ne0 divcan4i 2p1e3 subaddrii pm3.2i mp3an13 sylancl
      2nn0 6re syl2anc subdi 3eqtr2d 3eqtrd mulcl sylancr sylan2b eqeq2i fsump1
      cneg 2t2e4 divcan5 mp3an bpolycl div12 divcli mulcom bpoly2 sqcl id recni
      6pos subsub mp3an3 mp3an1 subcld 3jaodan sylbir 0nn0 wo elpr jaodan sylbi
      fsum1 addcl addsub12d negsubdi2d addsub12 mulcli negsub negsubdi2i mul12i
      syl5eqr 3t2e6 3eqtr3i mulid1i oveq12i divdiri negeqi eqtr3i subcli negcli
      divmuldivi subeq0i mpbir subadd4d subdir divsubdir dividi mulid2 3eqtr3rd
      mp3an12 subid1d 3eqtr3a negeqd eqtr3d negsubd syl5eq expcl subsubd ) ACDZ
      EAFGZAEUAGZHEIJGZUBGZEBUCZUDGZUXCAFGZEUXCJGZIKGZLGZMGZBUEZJGZUWTERLGZARUA
      GZMGZIRLGZAMGZJGZJGUWTUXNJGUXPKGEUMDZUWRUWSUXKNUFBEAUGUHUWRUXJUXQUWTJUWRU
      XJHIIKGZUBGZUXIBUEZUXQUXBUXTUXIBUXAUXSHUBUXARUXSUIUJUKOULUWRUYAHIUBGZUXIB
      UEZERAFGZRLGZMGZKGUYCUXNUXLAIUNLGZJGZMGZJGZKGZUXQUWRUXIUYFBHIIHUOUPZDZUWR
      IUMUYLUQURUSZUTUXCUXTDZUWRUXCHNZUXCINZUXCRNZVAZUXICDZUYOUXCHIRVBZDUYSUXTV
      UAUXCHIVCZRVDZVIUYBUXSVDZVIZVUAUXTVUBUYBVUCVUDHHIKGZUBGZHVUFVCZUYBVUBHVED
      ZVUGVUHNVJHVFVGZVUFIHUBVHOZVUFIHVHVKZVLRUXSUJVMVNHIRVOUYMUXTVUENUYNHIVPVG
      VQVRUXCHIRBVSZVTWAUWRUYPUYTUYQUYRUWRUYPWBUXIISLGZCUYPUWRUXIIHAFGZSLGZMGZV
      UNUYPUXDIUXHVUPMUYPUXDEHUDGZIUXCHEUDWCUXRVURINUFEWDVGWEUYPUXEVUOUXGSLUXCH
      AFWFUYPUXGEHJGZIKGZSUYPUXFVUSIKUXCHEJWCWGVUTEIKGSVUSEIKEPWHWIWJWKWEWMWMZU
      WRVUQIVUNMGVUNUWRVUPVUNIMUWRVUOISLAWLWGWNVUNSWOSWPWQWRZWSZXDWEZWTVVCXAZUW
      RUYQWBUXIAUXOJGZCUYQUWRUXIEIAFGZELGZMGZVVFUYQUXDEUXHVVHMUYQUXDEIUDGZEUXCI
      EUDWCUXRVVJENUFEXBVGWEUYQUXEVVGUXGELUXCIAFWFUYQUXGUXAIKGZEUYQUXFUXAIKUXCI
      EJWCWGECDZICDZVVKENPQEIXCXEWEWMWMZUWRVVIEVVFELGZMGZVVFUWRVVHVVOEMUWRVVGVV
      FELAXFWGWNUWRVVFCDZVVPVVFNZUWRUXOCDZVVQVVMVVSQIXGVGZAUXOXHXIZVVQVVLEHXOZV
      VRPXJVVFEXKXLXPXMZWTUWRVVQUYQVWAXNXQZUWRUYRWBUXIUYJCUYRUWRUXIUYFUYJUYRUXD
      EUXHUYEMUYRUXDERUDGZEUXCREUDWCVWEEUXAMGZRLGZEUXRVWEVWGNUFEXRVGVWGERMGZRLG
      EVWFVWHRLUXAREMUIOWIERPTXSXTUKUKWEUYRUXEUYDUXGRLUXCRAFWFUYRUXGERJGZIKGZRU
      YRUXFVWIIKUXCREJWCWGVWJUXSRVWIIIKERIPTQYAYBZWIUJWKWEWMWMZUWRUYFUYDUXLMGZU
      XLUYDMGZUYJUWRUYDCDZUYFVWMNZRUMDUWRVWOYFRAUUAUHZVVLVWORCDZRHXOZWBZVWPPVWR
      VWSTXSYCZEUYDRUUBYDXPUWRVWOUXLCDZVWMVWNNVWQERPTXSUUCZUYDUXLUUDYEUWRVWNUXL
      UXMAJGUYGKGZMGUXLUXMUYHJGZMGZUYJUWRUYDVXDUXLMAUUEWNUWRVXEVXDUXLMUWRUXMCDZ
      UWRVXEVXDNZAUUFZUWRUUGZVXGUWRUYGCDZVXHUNUNYGUUHZUNYGUUIWRZWSZUXMAUYGUUJUU
      KYHWNUWRVXGUYHCDZVXFUYJNZVXIUWRVXKVXOVXNAUYGXHXIZVXBVXGVXOVXPVXCUXLUXMUYH
      YIUULYHYJYKZWTUWRUYJCDUYRUWRUXNUYIUWRVXBVXGUXNCDVXCVXIUXLUXMYLYMZUWRVXBVX
      OUYICDVXCVXQUXLUYHYLYMZUUMXNXQUUNYNUXCUXSNUYRUXIUYFNRUXSUXCUJYOVWLUUOYPUW
      RUYFUYJUYCKVXRWNUWRUYKUXNVUNVVFKGZUYIJGZKGZUXNUXPYQZKGUXQUWRUYKVYAUYJKGVY
      CUWRUYCVYAUYJKUWRUYCVUGUXIBUEZVYAVUGUYBUXIBVUKULUWRVYEHHUBGUXIBUEZVVIKGVY
      AUWRUXIVVIBHHHUYLDUWRHUMUYLUUPURUSUTUXCVUGDZUWRUYPUYQUUQZUYTVYGUXCVUBDVYH
      VUGVUBUXCVUGVUHVUBVUJVULUKVRUXCHIVUMUURWAUWRUYPUYTUYQVVEVWDUUSYNUXCVUFNUY
      QUXIVVINVUFIUXCVHYOVVNUUTYPUWRVYFVUNVVIVVFKUWRVYFVUQVUNUWRVUIVUQCDVYFVUQN
      VJUWRVUQVUNCVVDVVCXAUXIVUQBHVVAUVAYMVVDXMVWCWMXMUVJWGUWRVYAUXNUYIUWRVUNCD
      ZVVQVYACDVVCVWAVUNVVFUVBYMZVXSVXTUVCXMUWRVYBVYDUXNKUWRUYIVYAJGZYQVYBVYDUW
      RUYIVYAVXTVYJUVDUWRVYKUXPUWRVYKUXLAMGZUXLUYGMGZJGZAVUNUXOJGZKGZJGVYLVYMYQ
      ZKGZVYPJGZUXPUWRUYIVYNVYAVYPJVXBUWRVXKUYIVYNNVXCVXNUXLAUYGYIYDVYIUWRVVSVY
      AVYPNVVCVVTVUNAUXOUVEYDWMUWRVYRVYNVYPJUWRVYLCDZVYMCDVYRVYNNVXBUWRVYTVXCUX
      LAYLUHZUXLUYGVXCVXNUVFZVYLVYMUVGYEWGUWRVYLAJGZVYOVYQJGZJGWUCHJGZVYSUXPWUD
      HWUCJWUDHNVYOVYQNUXOVUNJGZYQVYOVYQUXOVUNVVTVVCUVHWUFVYMEIMGZRUNMGZLGZVUNV
      YMWUFWUIWUGESMGZLGZVUNWUHWUJWUGLRVWHMGERRMGZMGWUHWUJRERTPTUVIVWHUNRMUVKOW
      ULSEMYROUVLOVVMSCDZSHXOZWBVVLVWBWBWUKVUNNQWUMWUNWOVVBYCVVLVWBPXJYCISEYSYT
      UKERIUNPTQVXLXSVXMUVTUXOVUNVUNVVTVVCVVCRIMGZWULLGZUXSSLGUXOVUNVUNKGWUOUXS
      WULSLWUORUXSRTUVMUJUKYRUVNVVMVWTVWTWUPUXONQVXAVXAIRRYSYTIISQQWOVVBUVOVLYB
      VQUVPUVQVYOVYQVUNUXOVVCVVTUVRZVYMWUBUVSZUWAUWBOUWRVYLAVYOVYQWUAVXJVYOCDUW
      RWUQUTVYQCDUWRWURUTUWCUWRWUEUXPHJGUXPUWRWUCUXPHJUWRUXLIJGZAMGZVYLIAMGZJGZ
      UXPWUCVXBVVMUWRWUTWVBNVXCQUXLIAUWDUWIWUTUXPNUWRWUSUXOAMVWIRLGZUXLRRLGZJGZ
      UXOWUSVVLVWRVWTWVCWVENPTVXAERRUWEYTVWIIRLVWKWIWVDIUXLJRTXSUWFOVLWIUTUWRWV
      AAVYLJAUWGWNUWHWGUWRUXPVVSUWRUXPCDVVTUXOAYLUHZUWJXMUWKYJUWLUWMWNUWRUXNUXP
      VXSWVFUWNYKYKUWOWNUWRUWTUXNUXPUWRUXRUWTCDUFAEUWPXIVXSWVFUWQYK $.

    $( The Bernoulli polynomials at four.  (Contributed by Scott Fenton,
       8-Jul-2015.) $)
    bpoly4 $p |- ( X e. CC ->
       ( 4 BernPoly X ) =
       ( ( ( ( X ^ 4 ) - ( 2 x. ( X ^ 3 ) ) ) + ( X ^ 2 ) ) - ( 1 / ; 3 0 ) ) )
        $=
      ( vk cc wcel c4 co cc0 c1 cmin cfz caddc cdiv cmul c2 c6 wceq 3cn oveq12d
      c3 a1i cbp cexp cv cbc csu c5 cdc cn0 4nn0 bpolyval mpan 4cn ax-1cn 3p1e4
      addcomli subaddrii df-3 eqtri oveq2i sumeq1i cuz 2nn0 nn0uz eleqtri wa cz
      cfv elfzelz bccl sylancr nn0cnd adantl elfznn0 bpolycl ancoms cr 4re zred
      sylan resubcld peano2re syl recnd wne clt wbr sylbir divcld mulcld eqeq2i
      oveq2 syl6eq oveq1 oveq1d oveq1i df-2 eqtr4i fsump1 1nn0 sseli sylan2 2cn
      0p1e1 0nn0 ax-mp 2p1e3 recni 0re gtneii oveq2d reccli mulid2i 3ne0 div12d
      eqtrd 3t2e6 divmuli mpbir mulcomd syl5eq 3nn0 2ne0 expcl mpan2 c10 subcld
      eqnetri subsubd addcld adddid subdid recidi mulassd 3eqtr3a add12d 3eqtrd
      addassd 3eqtr2d subdird eqtr3d 1re 3re elfzle2 3lt4 lelttrd posdifd mpbid
      eleq2i 0lt1 addgt0d gt0ne0d 4bc3eq4 fzssp1 sseqtr4i 4bc2eq6 2p2e4 wss 3nn
      cn nnuz fzss2 3sstr4i bcn1 df-4 sylbi 0z 5re 5pos bcn0 4p1e5 fsum1 bpoly0
      subid1i nn0cn mp1i 4pos divcan2d bpoly1 syl5eqr bpoly2 4d2e2 bpoly3 deccl
      6re sqcl nn0cni df-dec 10re mulcli addid1i mulne0i id 6pos divcli addcomd
      10pos mulid2 divcan2i syl5reqr mul32i eqeltri 3eqtr3ri addsub12d subsub4d
      divreci add4d mulid2d 2m1e1 subadd23d 3eqtr3d npncand halfthird 5recm6rec
      subcli addsubassd 3eqtr4d ) ACDZEAUAFZAEUBFZGEHIFZJFZEBUCZUDFZUYBAUAFZEUY
      BIFZHKFZLFZMFZBUEZIFZUXSHUFLFZAHNLFZIFZKFZNANUBFZAIFZHOLFZKFZMFZKFZNASUBF
      ZSNLFZUYOMFZIFZUYLAMFZKFZMFZKFZIFZUXSNVUAMFZIFZUYOKFHSGUGZLFZIFZEUHDZUXQU
      XRUYJPUIBEAUJUKUXQUYIVUHUXSIUXQUYIGNHKFZJFZUYHBUEZVUHUYAVUQUYHBUXTVUPGJUX
      TSVUPEHSULUMQSHEQUMUNUOUPZUQURUSUTUXQVURGNJFZUYHBUEZESAUAFZNLFZMFZKFVUHUX
      QUYHVVDBGNNGVAVGZDUXQNUHVVEVBVCVDTUXQUYBVUQDZVEZUYCUYGVVFUYCCDUXQVVFUYCVV
      FVUOUYBVFDUYCUHDUIUYBGVUPVHZUYBEVIVJVKVLVVGUYDUYFVVFUXQUYDCDZVVFUYBUHDUXQ
      VVIUYBVUPVMUYBAVNVSVOVVFUYFCDUXQVVFUYFVVFUYEVPDUYFVPDVVFEUYBEVPDZVVFVQTZV
      VFUYBVVHVRZVTZUYEWAWBWCVLVVFUYFGWDUXQVVFUYFVVFUYEHVVMHVPDVVFUUATVVFUYBEWE
      WFZGUYEWEWFVVFUYBGSJFZDZVVNVVOVUQUYBSVUPGJUQUSUUHVVPUYBSEVVPUYBUYBGSVHVRS
      VPDVVPUUBTVVJVVPVQTUYBGSUUCSEWEWFVVPUUDTUUEWGVVFUYBEVVLVVKUUFUUGGHWEWFVVF
      UUITUUJUUKVLWHWIZUYBVUPPUYBSPZUYHVVDPSVUPUYBUQWJVVRUYCEUYGVVCMVVRUYCESUDF
      EUYBSEUDWKUULWLVVRUYDVVBUYFNLUYBSAUAWMVVRUYFESIFZHKFZNVVRUYEVVSHKUYBSEIWK
      WNVVTHHKFZNVVSHHKESHULQUMUNUPWOWPWQWLRRWGWRUXQVVAUYTVVDVUGKUXQVVAGVWAJFZU
      YHBUEZUYTVUTVWBUYHBNVWAGJWPUSUTUXQVWCGHJFZUYHBUEZONAUAFZSLFZMFZKFUYTUXQUY
      HVWHBGHHVVEDUXQHUHVVEWSVCVDTUYBVWBDUXQVVFUYHCDZVWBVUQUYBVWBGVWAHKFZJFVUQG
      VWAUUMVUPVWJGJNVWAHKWPWOUSUUNWTVVQXAUYBVWAPUYBNPZUYHVWHPNVWAUYBWPWJVWKUYC
      OUYGVWGMVWKUYCENUDFOUYBNEUDWKUUOWLVWKUYDVWFUYFSLUYBNAUAWMVWKUYFENIFZHKFZS
      VWKUYEVWLHKUYBNEIWKWNVWMVUPSVWLNHKENNULXBXBUUPUPWOUQWQWLRRWGWRUXQVWEUYNVW
      HUYSKUXQVWEGGHKFZJFZUYHBUEZUYNVWOVWDUYHBVWNHGJXCUSZUTUXQVWPGGJFUYHBUEZEHA
      UAFZELFZMFZKFUYNUXQUYHVXABGGGVVEDUXQGUHVVEXDVCVDTUYBVWODUXQVVFVWIVWOVUQUY
      BVWDVVOVWOVUQSHVAVGZDVWDVVOUUQSUUSVXBUURUUTVDHGSUVAXEVWQVUPSGJXFUSUVBWTVV
      QXAUYBVWNPUYBHPZUYHVXAPVWNHUYBXCWJVXCUYCEUYGVWTMVXCUYCEHUDFZEUYBHEUDWKVUO
      VXDEPUIEUVCXEWLVXCUYDVWSUYFELUYBHAUAWMVXCUYFUXTHKFZEVXCUYEUXTHKUYBHEIWKWN
      VXESHKFEUXTSHKVUSWOUVDWQWLRRUVEWRUXQVWRUYKVXAUYMKUXQVWRHGAUAFZUFLFZMFZUYK
      UXQGVFDVXHCDVWRVXHPUVFUXQHVXGHCDUXQUMTZUXQVXFUFGUHDUXQVXFCDXDGAVNUKUFCDUX
      QUFUVGXGZTUFGWDUXQGUFXHUVHXIZTWHWIUYHVXHBGUYBGPZUYCHUYGVXGMVXLUYCEGUDFZHU
      YBGEUDWKVUOVXMHPUIEUVIXEWLVXLUYDVXFUYFUFLUYBGAUAWMVXLUYFEGIFZHKFZUFVXLUYE
      VXNHKUYBGEIWKWNVXOEHKFUFVXNEHKEULUVMWOUVJURWLRRUVKVJUXQVXHHUYKMFUYKUXQVXG
      UYKHMUXQVXFHUFLAUVLWNXJUYKUFVXJVXKXKZXLWLXOUXQVXAVWSUYMUXQVWSEHUHDUXQVWSC
      DWSHAVNUKVUOECDUXQUIEUVNUVOZEGWDUXQGEXHUVPXITUVQAUVRXORXOUVSUXQVWHVWFOSLF
      ZMFZUYSUXQOVWFSOCDUXQOUWDXGZTNUHDUXQVWFCDVBNAVNUKZSCDUXQQTZSGWDUXQXMTXNUX
      QVXSVWFNMFZUYSVXRNVWFMVXRNPSNMFZOPXPOSNVXTQXBXMXQXRUSUXQVYCNVWFMFUYSUXQVW
      FNVYANCDUXQXBTZXSUXQVWFUYRNMAUVTXJXOXTXORXOXTUXQVVDVVBENLFZMFZVUGUXQEVVBN
      VXQSUHDZUXQVVBCDYASAVNUKZVYENGWDUXQYBTXNUXQVYGVVBNMFZVUGVYFNVVBMUWAUSUXQV
      YJNVVBMFVUGUXQVVBNVYIVYEXSUXQVVBVUFNMAUWBXJXOXTXORXOXTXJUXQUXSVUJUYOVUMIF
      ZIFZIFVUKVYKKFVUIVUNUXQUXSVUJVYKUXQVUOUXSCDUIAEYCYDZUXQNVUAVYEUXQVYHVUACD
      YAASYCYDZWIZUXQUYOVUMAUWEZVUMCDUXQVULVULSGYAXDUWCUWFVULYESMFZGVULVYQGKFVY
      QSGUWGVYQYESYEUWHXGZQUWIUWJURYESVYRQGYEXHUWPXIXMUWKYGXKTZYFYHUXQVUHVYLUXS
      IUXQVUHVUGUYTKFVUJNVUCMFZIFZAKFZUYTKFZVYLUXQUYTVUGUXQUYNUYSUXQUYKUYMUYKCD
      UXQVXPTZUXQAUYLUXQUWLZUYLCDUXQNXBYBXKZTZYFZYIZUXQNUYRVYEUXQUYPUYQUXQUYOAV
      YPWUEYFZUYQCDUXQOVXTGOXHUWMXIZXKTZYIWIZYIZUXQNVUFVYEUXQVUDVUEUXQVUAVUCVYN
      UXQVUBUYOVUBCDUXQSNQXBYBUWNTZVYPWIZYFZUXQUYLAWUGWUEWIZYIWIUWOUXQVUGWUBUYT
      KUXQVUGNVUDMFZNVUEMFZKFWUBUXQNVUDVUEVYEWUQWURYJUXQWUSWUAWUTAKUXQNVUAVUCVY
      EVYNWUPYKUXQNUYLMFZAMFHAMFZWUTAWVAHAMNXBYBYLWOUXQNUYLAVYEWUGWUEYMAUWQZYNR
      XOWNUXQWUCWUAAUYTKFZKFVUJVYTWVDIFZIFVYLUXQWUAAUYTUXQVUJVYTVYOUXQNVUCVYEWU
      PWIZYFWUEWUNYQUXQVUJVYTWVDVYOWVFUXQAUYTWUEWUNYIYHUXQWVEVYKVUJIUXQWVESUYOM
      FZWVDIFWVGUYNNUYOMFZANAMFZIFZKFZHSLFZKFZKFZIFZVYKUXQVYTWVGWVDIUXQWVGNVUBM
      FZUYOMFVYTWVPSUYOMSNQXBYBUWRWOUXQNVUBUYOVYEWUOVYPYMUWSWNUXQWVDWVNWVGIUXQW
      VDUYNAUYSKFZKFWVNUXQAUYNUYSWUEWUIWUMYOUXQWVQWVMUYNKUXQWVQAWVHWVIIFZWVLKFZ
      KFAWVRKFZWVLKFWVMUXQUYSWVSAKUXQUYSNUYPMFZNUYQMFZKFWVSUXQNUYPUYQVYEWUJWULY
      JUXQWWAWVRWWBWVLKUXQNUYOAVYEVYPWUEYKWWBWVLPUXQNVYDLFZNOLFWVLWWBVYDONLXPUS
      WWCWVLPVYDWVLMFZNPWWDSWVLMFZNMFZNSNWVLQXBSQXMXKZUWTWWFHNMFNWWEHNMSQXMYLWO
      NXBXLURURNVYDWVLXBVYDOCXPVXTUXAWWGVYDOGXPWUKYGXQXRNOXBVXTWUKUXEUXBTRXOXJU
      XQAWVRWVLWUEUXQWVHWVIUXQNUYOVYEVYPWIZUXQNAVYEWUEWIZYFWVLCDUXQWWGTZYQUXQWV
      TWVKWVLKUXQAWVHWVIWUEWWHWWIUXCWNYRXJXOXJUXQWVOWVGWVHUYKWVJKFZUYMWVLKFZKFZ
      KFZIFWVGWVHIFZWWMIFVYKUXQWVNWWNWVGIUXQWVNUYKWVKKFZWWLKFWVHWWKKFZWWLKFWWNU
      XQUYKUYMWVKWVLWUDWUHUXQWVHWVJWWHUXQAWVIWUEWWIYFZYIWWJUXFUXQWWPWWQWWLKUXQU
      YKWVHWVJWUDWWHWWRYOWNUXQWVHWWKWWLWWHUXQUYKWVJWUDWWRYIZUXQUYMWVLWUHWWJYIZY
      QYPXJUXQWVGWVHWWMUXQSUYOVYBVYPWIWWHUXQWWKWWLWWSWWTYIUXDUXQWWOUYOWWMVUMIUX
      QSNIFZUYOMFHUYOMFWWOUYOWXAHUYOMSNHQXBUMXFUPWOUXQSNUYOVYBVYEVYPYSUXQUYOVYP
      UXGYNUXQUYKAIFZAUYLWVLIFZIFZKFZWWMVUMUXQWXBWWKWXDWWLKUXQUYKWVIAIFZIFUYKWV
      IIFAKFWXBWWKUXQUYKWVIAWUDWWIWUEYHUXQWXFAUYKIUXQWVIWVBIFZWXFAUXQWVBAWVIIWV
      CXJUXQNHIFZAMFWVBWXGAWXHHAMUXHWOUXQNHAVYEVXIWUEYSWVCYNYTXJUXQUYKWVIAWUDWW
      IWUEUXIUXJUXQAUYLWVLWUEWUGWWJYHRUXQWXEUYKWXCIFZVUMUXQUYKAWXCWUDWUEWXCCDUX
      QUYLWVLWUFWWGUXNTUXKWXIUYKUYQIFVUMWXCUYQUYKIUXLUSUXMURWLYTRYRYPXJYRYPXJUX
      QVUKUYOVUMUXQUXSVUJVYMVYOYFVYPVYSUXOUXPYP $.
  $}

  ${
    $d k t $.  $d k x $.  $d T k $.  $d t x $.  $d T x $.
    $( Express the sum of cubes in closed terms.  (Contributed by Scott Fenton,
       16-Jun-2015.) $)
    fsumcube $p |- ( T e. NN0 -> sum_ k e. ( 0 ... T ) ( k ^ 3 ) =
            ( ( ( T ^ 2 ) x. ( ( T + 1 ) ^ 2 ) ) / 4 ) ) $=
      ( wcel cc0 co c3 cexp c1 caddc cbp cmin cdiv c2 cmul c4 cc syl 2cn oveq2d
      wceq cn0 cfz cv csu 3nn0 fsumkthpow mpan df-4 oveq1i oveq12i cdc peano2cn
      cneg nn0cn bpoly4 4nn 0exp ax-mp 3nn oveq2i mul01i eqtri 0cn subid1i 00id
      sq0 df-neg 3eqtr4i a1i oveq12d 4nn0 expcl mpan2 mulcl sylancr subcld sqcl
      addcld 0nn0 deccl nn0cni nn0rei 10pos declti gt0ne0ii reccli subcl subneg
      cn sylancl npcan 2p2e4 eqcomi df-3 2nn0 expadd mp3an23 1nn0 sqcld mulid1d
      eqcomd eqeltrd mp3an1 syl2anc subdid 3eqtr4d oveq1d ax-1cn mp3an3 mp3an13
      exp1d mul12 adddi eqtr4d mulid1i syl6eq 2m1e1 eqtrd subsub binom21 addass
      addsubass pncand 3eqtr3d mulcomd 3eqtrd syl5eq syl5eqr ) AUACZDAUBEBUCFGE
      BUDZFHIEZAHIEZJEZYKDJEZKEZYKLEZAMGEZYLMGEZNEZOLEZFUACZYIYJYPTUEBFAUFUGYIY
      POYLJEZODJEZKEZOLEYTUUDYOOYKLUUBYMUUCYNKOYKYLJUHUIOYKDJUHUIUJUHUJYIUUDYSO
      LYIUUDYLOGEZMYLFGEZNEZKEZYRIEZHFDUKZLEZKEZUUKUMZKEZUULUUKIEZYSYIUUBUULUUC
      UUMKYIYLPCZUUBUULTYIAPCZUUPAUNZAULZQYLUOQUUCUUMTYIDOGEZMDFGEZNEZKEZDMGEZI
      EZUUKKEZDUUKKEUUCUUMUVEDUUKKUVEDDIEDUVCDUVDDIUVCDDKEDUUTDUVBDKOWICUUTDTUP
      OUQURUVBMDNEDUVADMNFWICUVADTUSFUQURUTMRVAVBUJDVCVDVBVFUJVEVBUIDPCUUCUVFTV
      CDUOURUUKVGVHVIVJYIUULPCZUUKPCZUUNUUOTYIUUIPCZUVHUVGYIUUQUVIUURUUQUUPUVIU
      USUUPUUHYRUUPUUEUUGUUPOUACUUEPCVKYLOVLVMUUPMPCZUUFPCZUUGPCRUUPUUAUVKUEYLF
      VLVMMUUFVNVOVPYLVQVRQZQUUJUUJFDUEVSVTZWAUUJUUJUVMWBFDDUSVSVSWCWDWEWFZUUIU
      UKWGWJUVNUULUUKWHWJYIUUOUUIYSYIUUQUUOUUITZUURUUQUVIUVHUVOUVLUVNUUIUUKWKWJ
      QYIUUIYLMMIEZGEZMYLMHIEZGEZNEZKEZYRIEZYSUUHUWAYRIUUEUVQUUGUVTKOUVPYLGUVPO
      WLWMUTUUFUVSMNFUVRYLGWNUTUTUJUIYIUUQUWBYSTUURUUQUWBYRYRNEZMYRYLHGEZNEZNEZ
      KEZYRHNEZIEZYSUUQUWAUWGYRUWHIUUQUUPUWAUWGTUUSUUPUVQUWCUVTUWFKUUPMUACZUWJU
      VQUWCTWOWOYLMMWPWQUUPUVSUWEMNUUPUWJHUACUVSUWETWOWRYLMHWPWQSVJQUUQUWHYRUUQ
      YRUUQYLUUSWSZWTXAVJUUQUWIYRYRMYLNEZKEZHIEZNEZYRYQNEYSUUQUWIYRUWMNEZUWHIEZ
      UWOUUQUWGUWPUWHIUUQUWCYRMUWDNEZNEZKEUWCYRUWLNEZKEUWGUWPUUQUWSUWTUWCKUUQUW
      RUWLYRNUUQUWDYLMNUUQYLUUSXKZSSSUUQUWFUWSUWCKUUQYRPCZUWDPCZUWFUWSTZUWKUUQU
      WDYLPUXAUUSXBUVJUXBUXCUXDRMYRUWDXLXCXDSUUQYRYRUWLUWKUWKUUQUVJUUPUWLPCZRUU
      SMYLVNVOZXEXFXGUUQUXBUWMPCZUWOUWQTZUWKUUQYRUWLUWKUXFVPUXBUXGHPCZUXHXHYRUW
      MHXMXIXDXNUUQUWNYQYRNUUQYRUWLHKEZKEZYRMANEZHIEZKEZUWNYQUUQUXJUXMYRKUUQUXJ
      UXLMIEZHKEZUXMUUQUWLUXOHKUUQUWLUXLMHNEZIEZUXOUVJUUQUXIUWLUXRTRXHMAHXMXJUX
      QMUXLIMRXOUTXPXGUUQUXPUXLMHKEZIEZUXMUUQUXLPCZUXPUXTTZUVJUUQUYARMAVNUGZUYA
      UVJUXIUYBRXHUXLMHYBWQQUXSHUXLIXQUTXPXRSUUQUXBUXEUXKUWNTZUWKUXFUXBUXEUXIUY
      DXHYRUWLHXSXIXDUUQUXNYQUXMIEZUXMKEYQUUQYRUYEUXMKUUQYRYQUXLIEHIEZUYEAXTUUQ
      YQPCZUYAUYFUYETZAVQZUYCUYGUYAUXIUYHXHYQUXLHYAXIXDXRXGUUQYQUXMUYIUUQUYAUXM
      PCUYCUXLULQYCXRYDSUUQYRYQUWKUYIYEYFXRQYGXRYFXGYHXR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Rank theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.  $d A y $.  $d B y $.  $d x y $.
    $( The rank of the union of two sets.  Closed form of ~ rankun .
       (Contributed by Scott Fenton, 15-Jul-2015.) $)
    rankung $p |- ( ( A e. V /\ B e. W ) ->
          ( rank ` ( A u. B ) ) = ( ( rank ` A ) u. ( rank ` B ) ) ) $=
      ( vx vy cv cun crnk cfv wceq uneq1 fveq2d fveq2 uneq1d eqeq12d uneq2d vex
      uneq2 rankun vtocl2g ) EGZFGZHZIJZUBIJZUCIJZHZKAUCHZIJZAIJZUGHZKABHZIJZUK
      BIJZHZKEFABCDUBAKZUEUJUHULUQUDUIIUBAUCLMUQUFUKUGUBAINOPUCBKZUJUNULUPURUIU
      MIUCBASMURUGUOUKUCBINQPUBUCERFRTUA $.

    $( The rank of a singleton.  Closed form of ~ ranksn .  (Contributed by
       Scott Fenton, 15-Jul-2015.) $)
    ranksng $p |- ( A e. V -> ( rank ` { A } ) = suc ( rank ` A ) ) $=
      ( vx cv csn crnk cfv csuc wceq sneq fveq2d fveq2 suceq syl eqeq12d ranksn
      vex vtoclg ) CDZEZFGZSFGZHZIAEZFGZAFGZHZICABSAIZUAUEUCUGUHTUDFSAJKUHUBUFI
      UCUGISAFLUBUFMNOSCQPR $.

    $( The membership relation is inherited by the rank function.  Closed form
       of ~ rankel .  (Contributed by Scott Fenton, 16-Jul-2015.) $)
    rankelg $p |- ( ( B e. V /\ A e. B ) -> ( rank ` A ) e. ( rank ` B ) ) $=
      ( vy wcel crnk cfv cv wi eleq2 fveq2 eleq2d imbi12d vex rankel vtoclg imp
      wceq ) BCEABEZAFGZBFGZEZADHZEZTUCFGZEZISUBIDBCUCBRZUDSUFUBUCBAJUGUEUATUCB
      FKLMAUCDNOPQ $.

    $( The rank of a power set.  Closed form of ~ rankpw .  (Contributed by
       Scott Fenton, 16-Jul-2015.) $)
    rankpwg $p |- ( A e. V -> ( rank ` ~P A ) = suc ( rank ` A ) ) $=
      ( vx cv cpw crnk cfv csuc wceq pweq fveq2d fveq2 suceq syl eqeq12d rankpw
      vex vtoclg ) CDZEZFGZSFGZHZIAEZFGZAFGZHZICABSAIZUAUEUCUGUHTUDFSAJKUHUBUFI
      UCUGISAFLUBUFMNOSCQPR $.

  $}

  $( The rank of the empty set is ` (/) ` (Contributed by Scott Fenton,
     17-Jul-2015.) $)
  rank0 $p |- ( rank ` (/) ) = (/) $=
    ( c0 wceq crnk cfv eqid 0ex rankeq0 mpbi ) AABACDABAEAFGH $.

  ${
    $d A x $.  $d x y $.
    $( The only set with rank ` 1o ` is the singleton of the empty set.
       (Contributed by Scott Fenton, 17-Jul-2015.) $)
    rankeq1o $p |- ( ( rank ` A ) = 1o <-> A = { (/) } ) $=
      ( vx vy crnk cfv c1o wceq c0 cvv wcel wne mpbiri wi csuc con0 df1o2 ax-mp
      cr1 cpw pweqi csn 1n0 neeq1 neneqd fvprc nsyl2 fveq2 eqeq1d eqeq1 imbi12d
      cv vex rankeq0 necon3bii sylibr crab cint rankval eqeq1i cpr wa wss elirr
      ssrab2 p0ex eqeltri id syl5eleq inteq int0 syl6eq mtbiri necon2ai sylancr
      mto onint eleq1 mpbid suceq fveq2d df-1o fveq2i 0elon r1suc r10 pw0 pwpw0
      3eqtri 3eqtrri 1on eqtr4i syl6eqr eleq2d elrab sylib wo df-ne orel1 sylbi
      elpr wn eqeq2 eqcomd syl6com adantl syl mpd vtoclg mpcom cdm wf1 eleqtrri
      r111 f1dm rankonid mpbi impbii eqeq2i bitri ) ADEZFGZAFGZAHUAZGYAYBAIJZYA
      YBYAXTHGYDYAXTHYAXTHKFHKZUBXTFHUCLUDADUEUFBUKZDEZFGZYFFGZMYAYBMBAIYFAGZYH
      YAYIYBYJYGXTFYFADUGUHYFAFUIUJYHYFHKZYIYHYGHKZYKYHYLYEUBYGFHUCLYFHYGHYFBUL
      ZUMUNUOYHYFCUKZNZREZJZCOUPZUQZFGZYKYIMZYGYSFCYFYMURUSYTFOJZYFHYCUTZJZVAZU
      UAYTFYRJZUUEYTYSYRJZUUFYTYROVBYRHKUUGYQCOVDYTYRHYRHGZYTIFGZUUIFFJFVCUUIFI
      FFYCIPVEVFUUIVGVHVOUUHYSIFUUHYSHUQIYRHVIVJVKUHVLVMYRVPVNYSFYRVQVRYQUUDCFO
      YNFGZYPUUCYFUUJYPFNZREZUUCUUJYOUUKRYNFVSVTUUCFREZSZUULUUNHSZSYCSUUCUUMUUO
      UUMHNZREZHREZSZUUOFUUPRWAWBHOJUUQUUSGWCHWDQUURHWETWHTUUOYCWFTWGWIUUBUULUU
      NGWJFWDQWKWLWMWNWOUUDUUAUUBUUDYFHGZYFYCGZWPZUUAYFHYCYMWTYKUVBUVAYIYKUUTXA
      UVBUVAMYFHWQUUTUVAWRWSUVAFYFUVAFYFGFYCGPYFYCFXBLXCXDWSXEXFWSXGXHXIYBXTFDE
      ZFAFDUGFRXJZJUVCFGFOUVDWJOIRXKUVDOGXMOIRXNQXLFXOXPVKXQFYCAPXRXS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Hereditarily Finite Sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Declare the constants for HF sets. $)
  $c Hf $.

  $( The constant ` Hf ` is a class. $)
  chf $a class Hf $.

  $( Define the hereditarily finite sets.  These are the finite sets whose
     elements are finite, and so forth.  (Contributed by Scott Fenton,
     9-Jul-2015.) $)
  df-hf $a |- Hf = U. ( R1 " om ) $.

  ${
    $d A x $.
    $( Membership in the hereditarily finite sets.  (Contributed by Scott
       Fenton, 9-Jul-2015.) $)
    elhf $p |- ( A e. Hf <-> E. x e. om A e. ( R1 ` x ) ) $=
      ( chf wcel cr1 com cima cuni cfv wrex df-hf eleq2i con0 cvv wf1 wfun r111
      cv wb f1fun eluniima mp2b bitri ) BCDBEFGHZDZBAREIDAFJZCUDBKLMNEOEPUEUFSQ
      MNETAFBEUAUBUC $.
  $}

  ${
    $d A x $.
    elhf2.1 $e |- A e. _V $.
    $( Alternate form of membership in the hereditarily finite sets.
       (Contributed by Scott Fenton, 13-Jul-2015.) $)
    elhf2 $p |- ( A e. Hf <-> ( rank ` A ) e. om ) $=
      ( vx chf wcel cv cr1 cfv com wrex con0 wceq nnon syl adantl expcom adantr
      wb wa cvv crnk elhf wo omon rankr1a elnn sylbid rexlimdva csuc peano2 cpw
      wss r1rankid mp1i elpw sylibr r1suc eleqtrrd eleq2d rspcev syl2anc impbid
      wi fveq2 tz9.13 rankon 2th rexeq eleq2 bibi12d mpbiri jaoi ax-mp bitri )
      ADEACFZGHZEZCIJZAUAHZIEZCAUBIKEZIKLZUCVRVTRZUDWAWCWBWAVRVTWAVQVTCIWAVOIEZ
      SVQVSVOEZVTWDVQWERZWAWDVOKEWFVOMAVOBUENOWDWEVTVCWAWEWDVTVSVOUFPOUGUHVTWAV
      RVTWASZVSUIZIEZAWHGHZEZVRVTWIWAVSUJQWGAVSGHZUKZWJWGAWLULZAWMEATEWNWGBATUM
      UNAWLBUOUPVTWJWMLZWAVTVSKEZWOVSMVSUQNQURVQWKCWHIVOWHLVPWJAVOWHGVDUSUTVAPV
      BWBWCVQCKJZWPRWQWPCABVEAVFVGWBVRWQVTWPVQCIKVHIKVSVIVJVKVLVMVN $.
  $}

  ${
    $d A x $.
    $( Hereditarily finiteness via rank.  Closed form of ~ elhf2 .
       (Contributed by Scott Fenton, 15-Jul-2015.) $)
    elhf2g $p |- ( A e. V -> ( A e. Hf <-> ( rank ` A ) e. om ) ) $=
      ( vx cv chf wcel crnk cfv com eleq1 wceq fveq2 eleq1d vex elhf2 vtoclbg )
      CDZEFQGHZIFAEFAGHZIFCABQAEJQAKRSIQAGLMQCNOP $.
  $}

  ${
    $( The empty set is a hereditarily finite set.  (Contributed by Scott
       Fenton, 9-Jul-2015.) $)
    0hf $p |- (/) e. Hf $=
      ( vx c0 chf wcel cr1 cfv com wrex csuc peano1 peano2 ax-mp cpw 0elpw con0
      cv wceq 0elon r1suc eleqtrri fveq2 eleq2d rspcev mp2an elhf mpbir ) BCDBA
      PZEFZDZAGHZBIZGDZBUKEFZDZUJBGDULJBKLBBEFZMZUMUONBODUMUPQRBSLTUIUNAUKGUGUK
      QUHUMBUGUKEUAUBUCUDABUEUF $.
  $}


  $( The union of two HF sets is an HF set.  (Contributed by Scott Fenton,
     15-Jul-2015.) $)
  hfun $p |- ( ( A e. Hf /\ B e. Hf ) -> ( A u. B ) e. Hf ) $=
    ( chf wcel wa cun crnk cfv com elhf2g ibi wceq wi wss wo word nnord ssequn1
    syl2an cvv rankung eleq1a adantl uncom eqeq1i biimpi eleq1d biimprcd adantr
    ordtri2or2 orbi12i sylib mpjaod eqeltrd wb unexg syl mpbird ) ACDZBCDZEZABF
    ZCDZVBGHZIDZVAVDAGHZBGHZFZIABCCUAUSVFIDZVGIDZVHIDZUTUSVIACJKUTVJBCJKVIVJEZV
    HVGLZVKVGVFFZVFLZVJVMVKMVIVGIVHUBUCVIVOVKMVJVOVKVIVOVHVFIVOVHVFLVNVHVFVGVFU
    DUEUFUGUHUIVLVFVGNZVGVFNZOZVMVOOVIVFPVGPVRVJVFQVGQVFVGUJSVPVMVQVOVFVGRVGVFR
    UKULUMSUNVAVBTDVCVEUOABCCUPVBTJUQUR $.

  $( The singleton of an HF set is an HF set.  (Contributed by Scott Fenton,
     15-Jul-2015.) $)
  hfsn $p |- ( A e. Hf -> { A } e. Hf ) $=
    ( chf wcel csn crnk cfv com csuc ranksng elhf2g ibi peano2 syl eqeltrd snex
    elhf2 sylibr ) ABCZADZEFZGCSBCRTAEFZHZGABIRUAGCZUBGCRUCABJKUALMNSAOPQ $.

  $( Adjoining one HF element to an HF set preserves HF status.  (Contributed
     by Scott Fenton, 15-Jul-2015.) $)
  hfadj $p |- ( ( A e. Hf /\ B e. Hf ) -> ( A u. { B } ) e. Hf ) $=
    ( chf wcel csn cun hfsn hfun sylan2 ) BCDACDBEZCDAJFCDBGAJHI $.


  $( Any member of an HF set is itself an HF set.  (Contributed by Scott
     Fenton, 16-Jul-2015.) $)
  hfelhf $p |- ( ( A e. B /\ B e. Hf ) -> A e. Hf ) $=
    ( wcel chf wa crnk cfv rankelg ancoms com wi elhf2g elnn syl5ibr exp3acom23
    ibi imp sylan2 mpd ) ABCZBDCZEAFGZBFGZCZADCZUATUDABDHIUATUCJCZUDUEKZUAUFBDL
    PTUFUGTUDUFUEUDUFEUETUBJCUBUCMABLNOQRS $.

  ${
    $d x y $.
    $( The class of all hereditarily finite sets is transitive.  (Contributed
       by Scott Fenton, 16-Jul-2015.) $)
    hftr $p |- Tr Hf $=
      ( vx vy chf wtr wel cv wcel wa wi wal dftr2 hfelhf ax-gen mpgbir ) CDABEB
      FZCGHAFZCGIZBJAABCKQBPOLMN $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Extensionality for HF sets depends only on comparison of HF elements.
       (Contributed by Scott Fenton, 16-Jul-2015.) $)
    hfext $p |- ( ( A e. Hf /\ B e. Hf ) ->
       ( A = B <-> A. x e. Hf ( x e. A <-> x e. B ) ) ) $=
      ( chf wcel wa cv wb wral cvv cdif wceq wn vex eldif mpbiran hfelhf expcom
      con3and adantlr adantll 2falsed sylan2b ralrimiva biantrud wal cun dfcleq
      unvdif raleqi ralv bitr2i ralunb 3bitri syl6rbbr ) BDEZCDEZFZAGZBEZUSCEZH
      ZADIZVCVBAJDKZIZFZBCLZURVEVCURVBAVDUSVDEZURUSDEZMZVBVHUSJEVJANUSJDOPURVJF
      UTVAUPVJUTMUQUPUTVIUTUPVIUSBQRSTUQVJVAMUPUQVAVIVAUQVIUSCQRSUAUBUCUDUEVGVB
      AUFZVBADVDUGZIZVFABCUHVMVBAJIVKVBAVLJDUIUJVBAUKULVBADVDUMUNUO $.
  $}

  $( The union of an HF set is itself hereditarily finite.  (Contributed by
     Scott Fenton, 16-Jul-2015.) $)
  hfuni $p |- ( A e. Hf -> U. A e. Hf ) $=
    ( chf wcel cuni crnk cfv com rankuni wss wtr rankon ontrci df-tr elhf2g ibi
    mpbi word wa wi cvv con0 eqeltrri onordi ordom ordtr2 mp2an syl5eqel uniexg
    sylancr wb syl mpbird ) ABCZADZBCZUNEFZGCZUMUPAEFZDZGAHZUMUSURIZURGCZUSGCZU
    RJVAURAKLURMPUMVBABNOUSQGQVAVBRVCSUSUPUSUAUTUNKUBUCUDUSURGUEUFUIUGUMUNTCUOU
    QUJABUHUNTNUKUL $.

  $( The power class of an HF set is hereditarily finite.  (Contributed by
     Scott Fenton, 16-Jul-2015.) $)
  hfpw $p |- ( A e. Hf -> ~P A e. Hf ) $=
    ( chf wcel cpw crnk cfv com rankpwg elhf2g ibi peano2 syl eqeltrd cvv pwexg
    csuc wb mpbird ) ABCZADZBCZTEFZGCZSUBAEFZPZGABHSUDGCZUEGCSUFABIJUDKLMSTNCUA
    UCQABOTNILR $.

  $( ` om ` is not hereditarily finite.  (Contributed by Scott Fenton,
     16-Jul-2015.) $)
  hfninf $p |- -. om e. Hf $=
    ( com chf wcel wn wi elirr crnk cfv elhf2g con0 wceq ordom elong mpbiri cr1
    word cdm cvv wf1 ax-mp r111 f1dm eleq2i rankonid bitr3i sylib eleq1d mtbiri
    bitrd pm2.01 ) ABCZUKDZEULUKUKAACZAFUKUKAGHZACUMABIUKUNAAUKAJCZUNAKZUKUOAPL
    ABMNUOAOQZCUPUQJAJROSUQJKUAJROUBTUCAUDUEUFUGUIUHUKUJT $.

  $(
  @{ @d t y @. @d t z @. @d x y @.
     @( The hereditarily finite sets are a subset of the finite sets. @)
     hfssfin @p |- Hf C_ Fin @=
       ( vx vy vt vz cr1 com cfn wss cv wcel cfv wceq con0 cvv fveq2 sseq1d weq
       c0 eqsstri syl chf cima cuni df-hf wral wrex wfun wf1 r111 f1fun fvelima
       ax-mp mpan wi csuc r10 0ss cpw r1suc sylibrd finds sseq1 biimpd rexlimiv
       nnon com12 rgen unissb mpbir ) UAEFUBZUCZGUDVKGHAIZGHZAVJUEVMAVJVLVJJZBI
       ZEKZVLLZBFUFZVMEUGZVNVRMNEUHVSUIMNEUJULBVLFEUKUMVQVMBFVOFJVPGHZVQVMUNCIZ
       EKZGHREKZGHDIZEKZGHZWDUOZEKZGHZVTCDVOWARLWBWCGWAREOPCDQWBWEGWAWDEOPWAWGL
       WBWHGWAWGEOPCBQWBVPGWAVOEOPWCRGUPGUQSWDFJZWFWEURZGHWI?WJWHWKGWJWDMJWHWKL
       WDVEWDUSTPUTVAVQVTVMVQVTVMVPVLGVBVCVFTVDTVGAVJGVHVIS @.
       @( [20-Jul-2015] @)

     @( Any finite set of HF sets is itself an HF set. @)
     hffinhf @p |- ( ( A C_ Hf /\ A e. Fin ) -> A e. Hf ) @= ? @.

  @}

  @{ @d A z @. @d x z @. @d y z @. @d A a @. @d a b @. @d A b @. @d a c @.
     @d A c @. @d a w @. @d A w @. @d a x @. @d a y @. @d a z @. @d b c @.
     @d b x @. @d b y @. @d b z @. @d c x @. @d c y @. @d c z @. @d w x @.
     @d w y @. @d w z @.

     @( Induction rule for hereditarily finite sets.  If the empty class
        is in a class ` A ` , and ` A ` is closed under adjunction of HF sets,
        then all HF sets are elements of ` A ` . @)
     hfind @p |- ( ( (/) e. A /\ A. x e. A A. y e. A ( ( x e. Hf /\ y e. Hf )
           -> ( x u. { y } ) e. A ) ) -> Hf C_ A ) @=
       ( vz vw va vb vc c0 wcel cv chf wa wi wral crnk cfv com wceq wal csn cun
       wrex risset eqeq1 imbi1d albidv fveq2 eqeq2d eleq1 imbi2d imbi12d cbvalv
       weq syl6bb nn0suc eqcom vex rankeq0 bicomi bitr3i biimprd syl6bi adantrd
       com23 a1dd a1i jaod mpd bi2.04 albii 19.21v bitri ralbii r19.21v 3imtr4g
       a2d alrimdv omsinds sp syl com12 rexlimdv syl5bi elhf2 anbi12i 2ralbii
       imbi1i anbi2i 3imtr4i ssrdv ) ICJZAKZLJZBKZLJZMZWMWOUAUBCJZNZBCOACOZMZDL
       CWLWMPQRJZWOPQRJZMZWRNZBCOACOZMZDKZPQZRJZXHCJZNXAXHLJZXKNXJEKZXISZERUCXG
       XKEXIRUDXGXNXKERXMRJZXGXNXKNXOXNXGXKXOXNXGXKNZNZDTZXQFKZXISZXPNZDTZGKZHK
       ZPQZSZXGYDCJZNZNZHTZXRFGXMFGUNZYBYCXISZXPNZDTYJYKYAYMDYKXTYLXPXSYCXIUEUF
       UGYMYIDHDHUNZYLYFXPYHYNXIYEYCXHYDPUHUIYNXKYGXGXHYDCUJUKULUMUOFEUNZYAXQDY
       OXTXNXPXSXMXIUEUFUGXSRJZYJGXSOZYADYPXGYFYGNZHTZGXSOZNZXGXTXKNZNYQYAYPXGY
       TUUBYP?XGYTUUBNNZ?XSUPYPXSISZUUC?UUDUUCNYPUUDXGUUBYTUUDWLUUBXFUUDXTWLXKU
       UDXTXHISZWLXKNUUDXTIXISZUUEXSIXIUEUUFXIISZUUEXIIUQUUEUUGXHDURZUSUTVAUOUU
       EXKWLXHICUJVBVCVEVDVFVG?VHVIVQYQXGYSNZGXSOUUAYJUUIGXSYJXGYRNZHTUUIYIUUJH
       YFXGYGVJVKXGYRHVLVMVNXGYSGXSVOVMXTXGXKVJVPVRVSXQDVTWAVEWBWCWDWTXFWLWSXEA
       BCCWQXDWRWNXBWPXCWMAURWEWOBURWEWFWHWGWIXLXJXKXHUUHWEWHWJWK @.
       @( [17-Jul-2015] @)
  @}
  $)


$( (End of Scott Fenton's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                   Mathbox for Anthony Hart
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Propositional Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( The first of three axioms in the Tarski-Bernays axiom system.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tb-ax1 $p |- ( ( ph -> ps ) -> ( ( ps -> ch ) -> ( ph -> ch ) ) ) $=
    ( imim1 ) ABCD $.

  $( The second of three axioms in the Tarski-Bernays axiom system.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  tb-ax2 $p |- ( ph -> ( ps -> ph ) ) $=
    ( ax-1 ) ABC $.

  $( The third of three axioms in the Tarski-Bernays axiom system.

     This axiom, along with ~ ax-mp , ~ tb-ax1 , and ~ tb-ax2 , can be used to
     derive any theorem or rule that uses only ` -> ` .  (Contributed by
     Anthony Hart, 16-Aug-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  tb-ax3 $p |- ( ( ( ph -> ps ) -> ph ) -> ph ) $=
    ( peirce ) ABC $.

  ${
    tbsyl.1 $e |- ( ph -> ps ) $.
    tbsyl.2 $e |- ( ps -> ch ) $.
    $( The weak syllogism from Tarski-Bernays'.  (Contributed by Anthony Hart,
       16-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    tbsyl $p |- ( ph -> ch ) $=
      ( wi tb-ax1 ax-mp ) BCFZACFZEABFIJFDABCGHH $.
  $}

  $( Lemma for ~ re1ax2 .  (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  re1ax2lem $p |- ( ( ph -> ( ps -> ch ) ) -> ( ps -> ( ph -> ch ) ) ) $=
    ( wi tb-ax2 tb-ax1 tbsyl tb-ax3 mpsyl ) BBCDZCDZDAJDKACDZDBLDBJKDZKBJBDMBJE
    JBCFGMKCDKDKJKCFKCHGGAJCFBKLFI $.

  $( ~ ax-2 rederived from the Tarski-Bernays axiom system.  Often ~ tb-ax1 is
     replaced with this theorem to make a "standard" system.  This is because
     this theorem is easier to work with, despite it being longer.
     (Contributed by Anthony Hart, 16-Aug-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  re1ax2 $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( ph -> ps )
     -> ( ph -> ch ) ) ) $=
    ( wi re1ax2lem tb-ax1 tb-ax3 tbsyl ax-mp mpsyl ) ABCDDBACDZDZABDZKDZABCEAKD
    ZKDZLMODZNOKCDKDKAKCFKCGHMLODDLQDABKFMLOEIQPNDDPQNDDMOKFQPNEIJH $.

  $( Constructor theorem for ` -/\ ` .  (Contributed by Anthony Hart,
     1-Sep-2011.) $)
  naim1 $p |- ( ( ph -> ps ) -> ( ( ps -/\ ch ) -> ( ph -/\ ch ) ) ) $=
    ( wi wn wo wnan con3 orim1d wa pm3.13 pm3.14 imim12i df-nan 3imtr4g syl ) A
    BDZBEZCEZFZAEZSFZDZBCGZACGZDQRUASABHIUCBCJEZACJEZUDUEUFTUBUGBCKACLMBCNACNOP
    $.

  $( Constructor theorem for ` -/\ ` .  (Contributed by Anthony Hart,
     1-Sep-2011.) $)
  naim2 $p |- ( ( ph -> ps ) -> ( ( ch -/\ ps ) -> ( ch -/\ ph ) ) ) $=
    ( wi wn wo wnan con3 orim2d wa pm3.13 pm3.14 imim12i df-nan 3imtr4g syl ) A
    BDZCEZBEZFZRAEZFZDZCBGZCAGZDQSUARABHIUCCBJEZCAJEZUDUEUFTUBUGCBKCALMCBNCANOP
    $.

  ${
    naim1i.1 $e |- ( ph -> ps ) $.
    naim1i.2 $e |- ( ps -/\ ch ) $.
    $( Constructor rule for ` -/\ ` .  (Contributed by Anthony Hart,
       2-Sep-2011.) $)
    naim1i $p |- ( ph -/\ ch ) $=
      ( wi wnan naim1 mp2 ) ABFBCGACGDEABCHI $.
  $}

  ${
    naim2i.1 $e |- ( ph -> ps ) $.
    naim2i.2 $e |- ( ch -/\ ps ) $.
    $( Constructor rule for ` -/\ ` .  (Contributed by Anthony Hart,
       2-Sep-2011.) $)
    naim2i $p |- ( ch -/\ ph ) $=
      ( wi wnan naim2 mp2 ) ABFCBGCAGDEABCHI $.
  $}

  ${
    naim12i.1 $e |- ( ph -> ps ) $.
    naim12i.2 $e |- ( ch -> th ) $.
    naim12i.3 $e |- ( ps -/\ th ) $.
    $( Constructor rule for ` -/\ ` .  (Contributed by Anthony Hart,
       2-Sep-2011.) $)
    naim12i $p |- ( ph -/\ ch ) $=
      ( naim1i naim2i ) CDAFABDEGHI $.
  $}

  $( Constructor theorem for ` -/\ ` .  (Contributed by Anthony Hart,
     1-Sep-2011.) $)
  nabi1 $p |- ( ( ph <-> ps ) -> ( ( ph -/\ ch ) <-> ( ps -/\ ch ) ) ) $=
    ( nanbi1 ) ABCD $.

  $( Constructor theorem for ` -/\ ` .  (Contributed by Anthony Hart,
     1-Sep-2011.) $)
  nabi2 $p |- ( ( ph <-> ps ) -> ( ( ch -/\ ph ) <-> ( ch -/\ ps ) ) ) $=
    ( nanbi2 ) ABCD $.

  ${
    nabi1i.1 $e |- ( ph <-> ps ) $.
    nabi1i.2 $e |- ( ps -/\ ch ) $.
    $( Constructor rule for ` -/\ ` .  (Contributed by Anthony Hart,
       2-Sep-2011.) $)
    nabi1i $p |- ( ph -/\ ch ) $=
      ( wnan bicomi nanbi1i mpbi ) BCFACFEBACABDGHI $.
  $}

  ${
    nabi2i.1 $e |- ( ph <-> ps ) $.
    nabi2i.2 $e |- ( ch -/\ ps ) $.
    $( Constructor rule for ` -/\ ` .  (Contributed by Anthony Hart,
       2-Sep-2011.) $)
    nabi2i $p |- ( ch -/\ ph ) $=
      ( wnan bicomi nanbi2i mpbi ) CBFCAFEBACABDGHI $.
  $}

  ${
    nabi12i.1 $e |- ( ph <-> ps ) $.
    nabi12i.2 $e |- ( ch <-> th ) $.
    nabi12i.3 $e |- ( ps -/\ th ) $.
    $( Constructor rule for ` -/\ ` .  (Contributed by Anthony Hart,
       2-Sep-2011.) $)
    nabi12i $p |- ( ph -/\ ch ) $=
      ( nabi1i nabi2i ) CDAFABDEGHI $.
  $}

  $( The double nand. $)
  w3nand $a wff ( ph -/\ ps -/\ ch ) $.

  $( The double nand.  This definition allows us to express the input of three
     variables only being false if all three are true.  (Contributed by Anthony
     Hart, 2-Sep-2011.) $)
  df-3nand $a |- ( ( ph -/\ ps -/\ ch ) <-> ( ph -> ( ps -> -. ch ) ) ) $.

  $( The double nand expressed in terms of pure nand.  (Contributed by Anthony
     Hart, 2-Sep-2011.) $)
  df3nandALT1 $p |- ( ( ph -/\ ps -/\ ch ) <-> ( ph -/\ ( ( ps -/\ ch )
    -/\ ( ps -/\ ch ) ) ) ) $=
    ( wn wi wnan wa w3nand iman biimpi jca biimpri adantl impbii df-nan anbi12i
    imnan bitr4i imbi2i 3bitr4i anbi2i notbii df-3nand ) ABCDEZEZABCFZUFFZGZDZA
    BCHAUGFAUFUFGZEAUJDZGZDUEUIAUJIUDUJAUDBCGDZUMGZUJUDUNUDUMUMUDUMBCQZJZUPKUMU
    DUMUDUMUOLMNUFUMUFUMBCOZUQPRSUHULUGUKAUFUFOUAUBTABCUCAUGOT $.

  $( The double nand expressed in terms of negation and and.  (Contributed by
     Anthony Hart, 13-Sep-2011.) $)
  df3nandALT2 $p |- ( ( ph -/\ ps -/\ ch ) <-> -. ( ph /\ ps /\ ch ) ) $=
    ( w3nand wn wi wa w3a df-3nand imnan imbi2i 3anass xchbinxr 3bitri ) ABCDAB
    CEFZFABCGZEZFZABCHZEABCIOQABCJKRAPGSAPJABCLMN $.

  $( Double and in terms of double nand.  (Contributed by Anthony Hart,
     2-Sep-2011.) $)
  andnand1 $p |- ( ( ph /\ ps /\ ch ) <-> ( ( ph -/\ ps -/\ ch ) -/\
    ( ph -/\ ps -/\ ch ) ) ) $=
    ( w3a wn wi w3nand wnan wa 3anass pm4.63 anbi2i annim 3bitr2i notbii nannot
    df-3nand ) ABCDZABCEFZFZEZABCGZEUBUBHRABCIZIASEZIUAABCJUDUCABCKLASMNUBTABCQ
    OUBPN $.

  $( An ` -> ` nand relation.  (Contributed by Anthony Hart, 2-Sep-2011.) $)
  imnand2 $p |- ( ( -. ph -> ps ) <-> ( ( ph -/\ ph ) -/\ ( ps -/\ ps ) ) ) $=
    ( wn wa wnan wi nannot anbi12i notbii iman df-nan 3bitr4i ) ACZBCZDZCAAEZBB
    EZDZCMBFPQEORMPNQAGBGHIMBJPQKL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Predicate Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x ph $.
    $( Any wff can be trivially quantified, so long as the quantifier's set is
       distinct from said wff.

       See also ~ 19.9v .  (Contributed by Anthony Hart, 13-Sep-2011.) $)
    quantriv $p |- ( A. x ph <-> ph ) $=
      ( 19.3v ) ABC $.
  $}

  $( For all sets, ` T. ` is true.  (Contributed by Anthony Hart,
     13-Sep-2011.) $)
  allt $p |- A. x T. $=
    ( wtru tru ax-gen ) BACD $.

  $( For all sets, ` F. ` is not true.  (Contributed by Anthony Hart,
     13-Sep-2011.) $)
  alnof $p |- A. x -. F. $=
    ( wfal wn fal ax-gen ) BCADE $.

  $( Not all sets hold ` F. ` as true.  (Contributed by Anthony Hart,
     13-Sep-2011.) $)
  nalf $p |- -. A. x F. $=
    ( wfal wal wn alnof falim sps mt2 ) BACBDACZAEBIDZAJFGH $.

  $( There exists a set that holds ` T. ` as true.  (Contributed by Anthony
     Hart, 13-Sep-2011.) $)
  extt $p |- E. x T. $=
    ( wtru wal wex allt 19.2 ax-mp ) BACBADAEBAFG $.

  $( There does not exist a set, such that ` T. ` is not true.  (Contributed by
     Anthony Hart, 13-Sep-2011.) $)
  nextnt $p |- -. E. x -. T. $=
    ( wtru wn tru notnoti nex ) BCABDEF $.

  $( There does not exist a set, such that ` F. ` is true.  (Contributed by
     Anthony Hart, 13-Sep-2011.) $)
  nextf $p |- -. E. x F. $=
    ( wfal fal nex ) BACD $.

  $( There does not exist exactly one set, such that ` F. ` is true.
     (Contributed by Anthony Hart, 13-Sep-2011.) $)
  unnf $p |- -. E! x F. $=
    ( wfal weu wex nextf euex mto ) BACBADAEBAFG $.

  $( There does not exist exactly one set, such that ` T. ` is true.
     (Contributed by Anthony Hart, 13-Sep-2011.) $)
  unnt $p |- -. E! x T. $=
    ( wtru weu wn wex nextnt eunex mto ) BACBDAEAFBAGH $.

  $( There does not exist at most one set, such that ` T. ` is true.
     (Contributed by Anthony Hart, 13-Sep-2011.) $)
  mont $p |- -. E* x T. $=
    ( wtru wmo wex weu wi wn extt unnt mth8 mp2 df-mo mtbir ) BACBADZBAEZFZNOGP
    GAHAINOJKBALM $.

  $( There exist at most one set, such that ` F. ` is true.  (Contributed by
     Anthony Hart, 13-Sep-2011.) $)
  mof $p |- E* x F. $=
    ( wfal wex wmo nextf exmo mtp-or ) BACBADAEBAFG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Misc. Single Axiom Systems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A single axiom for propositional calculus offered by Meredith.
     (Contributed by Anthony Hart, 13-Aug-2011.) $)
  meran1 $p |- ( -. ( -. ( -. ph \/ ps ) \/ ( ch \/ ( th \/ ta ) ) ) \/
          ( -. ( -. th \/ ph ) \/ ( ch \/ ( ta \/ ph ) ) ) ) $=
    ( wn wo wi orc olc imim1i pm2.24 idd jaod com12 pm1.5 imor 3imtr3i orim2i
    ja pm2.3 pm2.21 mth8 imim12i pm2.43d con4d 4syl 3syl 3imtr4i syl2im imori )
    AFZBGZFCDEGZGZGZDFZAGZFCEAGZGZGZUMUOHZURUTHUPVAVBABHZUOHZURDAHZUTVCUMUOABUM
    ULBIBULJTKDURADUQAADALDAMNOVCFZUOGZVEFZUTGZVDVEUTHVGCVFUNGZGCVHUSGZGVIVFCUN
    PVJVKCVJVFEDGGEVFDGZGEVHAGZGVKVFDEUAVFEDPVLVMEVCDHZVEAHVLVMVNAVEVNULVHULVCD
    ULVHHABUBDAUCUDUEUFVCDQVEAQRSEVHAPUGSCVHUSPUHVCUOQVEUTQUIUJUMUOQURUTQRUK $.

  $( A single axiom for propositional calculus offered by Meredith.
     (Contributed by Anthony Hart, 13-Aug-2011.) $)
  meran2 $p |- ( -. ( -. ( -. ph \/ ps ) \/ ( ch \/ ( th \/ ta ) ) ) \/
          ( -. ( -. ta \/ th ) \/ ( ch \/ ( ph \/ th ) ) ) ) $=
    ( wn wo meran1 imorri syl imori ) AFBGFCDEGGGZEFDGFCADGGGZLDFAGFCEAGGGZMLNA
    BCDEHINMDACEAHIJK $.

  $( A single axiom for propositional calculus offered by Meredith.
     (Contributed by Anthony Hart, 13-Aug-2011.) $)
  meran3 $p |- ( -. ( -. ( -. ph \/ ps ) \/ ( ch \/ ( th \/ ta ) ) ) \/
          ( -. ( -. ch \/ ph ) \/ ( ta \/ ( th \/ ph ) ) ) ) $=
    ( wn wo wi pm2.3 imim2i pm1.5 syl6 imor 3imtr3i meran1 imorri syl imori ) A
    FBGZFZCDEGGZGZCFAGFEDAGGGZUBTECDGGZGZUCSUAHZSUDHUBUEUFSCEDGGZUDUAUGSCDEIJCE
    DKLSUAMSUDMNUEUCABECDOPQR $.

  $( A single axiom for propositional calculus offered by Wajsberg.
     (Contributed by Anthony Hart, 13-Aug-2011.) $)
  waj-ax $p |- ( ( ph -/\ ( ps -/\ ch ) ) -/\ ( ( ( th -/\ ch ) -/\ ( ( ph
         -/\ th ) -/\ ( ph -/\ th ) ) ) -/\ ( ph -/\ ( ph -/\ ps ) ) ) ) $=
    ( wnan wa wi nannan simpr imim2i pm2.27 anim2d expdimp syl5com con3d df-nan
    wn 3imtr4g nanim sylib pm3.21 adantr com12 a2i sylibr jca sylbi mpbir ) ABC
    EEZDCEZADEZUKEEZAABEEZEEUIULUMFZGUIABCFZGZUNACBHUPULUMUPUJUKGULUPDCFZQADFZQ
    UJUKUPURUQUPACGZURUQUOCABCIJADUSUQAUSCDACKLMNODCPADPRUJUKSTUPAABFZGZUMAUOUT
    UOAUTBVACBAUAUBUCUDABAHUEUFUGUIUMULHUH $.

  $( A single axiom for propositional calculus offered by Lukasiewicz.
     (Contributed by Anthony Hart, 14-Aug-2011.) $)
  lukshef-ax2 $p |- ( ( ph -/\ ( ps -/\ ch ) ) -/\ ( ( ph -/\ ( ch -/\ ph ) )
          -/\ ( ( th -/\ ps ) -/\ ( ( ph -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    ( wnan wa wi nannan biimpi simpr imim2i simpl pm2.27 anim2d expdimp syl5com
    ancr anim1i wn df-nan syl2anc con3 3imtr4g biimpri nanim anim12i 4syl mpbir
    anim2i ) ABCEEZACAEEZDBEZADEZUMEEZEEUJUKUNFZGUJABCFZGZACAFGZADFZDBFZGZFZURU
    LUMGZFUOUJUQACBHIUQACGZVAVBUPCABCJKUQABGZUSUTUPBABCLKADVEUTAVEBDABMNOPVDURV
    AACQRUAVAVCURVAUTSUSSULUMUSUTUBDBTADTUCUIURUKVCUNUKURAACHUDVCUNULUMUEIUFUGU
    JUNUKHUH $.

  $( ?  (Contributed by Anthony Hart, 14-Aug-2011.) $)
  arg-ax $p |- ( ( ph -/\ ( ps -/\ ch ) ) -/\ ( ( ph -/\ ( ps -/\ ch ) )
          -/\ ( ( th -/\ ch ) -/\ ( ( ch -/\ th ) -/\ ( ph -/\ th ) ) ) ) ) $=
    ( wnan wa wi wn df-nan pm4.57 com12 pm3.45 anim12i jaob 3imtr4i syl6 syl5bi
    wo biimpri nannan orel2 simpr a1i jad syl pm3.22 con1d ancli mpbir ) ABCEEZ
    UJDCEZCDEZADEZEEZEEUJUJUNFGUJUNABCFZGZUKULUMFZGUJUNUKDCFZHZUPUQDCIUPUSCDFZH
    ZADFZHZFZUQUPVDURVDHUTVBRZUPURUTVBJUPVEUTURUPCARZCGZVEUTGZVFUPCVFAUOCAHVFCA
    CUAKUOCGVFBCUBUCUDKCCGZACGZFUTUTGZVBUTGZFVGVHVIVKVJVLCCDLACDLMCCANUTUTVBNOU
    ECDUFPQUGVAULVCUMULVACDISUMVCADISMPQACBTUKUMULTOUHUJUNUJTUI $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Connective Symmetry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( In the paper "On Variable Functors of Propositional Arguments",
     Lukasiewicz introduced a system that can handle variable connectives.
     This was done by introducing a variable, marked with a lowercase delta,
     which takes a wff as input.  In the system, "delta ` ph ` " means that
     "something is true of ` ph ` ."  "delta ` ph ` " can be substituted with
     ` -. ph ` , ` ps /\ ph ` , ` A. x ph ` , etc.

     Later on, Meredith discovered a single axiom, in the form of ` ( ` delta
     delta ` F. -> ` delta ` ph ` ` ) ` .  This represents the shortest theorem
     in the extended propositional calculus that cannot be derived as an
     instance of a theorem in propositional calculus.

     A symmetry with ` -. ` .  (Contributed by Anthony Hart, 4-Sep-2011.) $)
  negsym1 $p |- ( -. -. F. -> -. ph ) $=
    ( wfal wn fal pm2.24i ) BCACDE $.

  $( A symmetry with ` -> ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.) $)
  imsym1 $p |- ( ( ps -> ( ps -> F. ) ) -> ( ps -> ph ) ) $=
    ( wfal wi pm2.21 falim imim2i ja ) BBCDBADBAECABAFGH $.

  $( A symmetry with ` <-> ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.) $)
  bisym1 $p |- ( ( ps <-> ( ps <-> F. ) ) -> ( ps <-> ph ) ) $=
    ( wfal wb wn nbfal bibi2i pm5.19 pm2.21i sylbir ) BBCDZDBBEZDZBADZLKBBFGMNB
    HIJ $.

  $( A symmetry with ` /\ ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.) $)
  consym1 $p |- ( ( ps /\ ( ps /\ F. ) ) -> ( ps /\ ph ) ) $=
    ( wfal wa wi falim ad2antll pm2.43i ) BBCDDZBADZCIJEZBBKFGH $.

  $( A symmetry with ` \/ ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.) $)
  dissym1 $p |- ( ( ps \/ ( ps \/ F. ) ) -> ( ps \/ ph ) ) $=
    ( wo wfal orc falim orim2i jaoi ) BBACBDCBAEDABAFGH $.

  $( A symmetry with ` -/\ ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.) $)
  nandsym1 $p |- ( ( ps -/\ ( ps -/\ F. ) ) -> ( ps -/\ ph ) ) $=
    ( wfal wnan wa wn df-nan biimpi anbi2i sylnib simpl fal intnan jctir sylibr
    nsyl ) BBCDZDZBAEZFBADRBBCEFZEZSRBQEZUARUBFBQGHQTBBCGIJSBTBAKCBLMNPBAGO $.

  $( A symmetry with ` A. ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.)  (Proof shortened by Mario Carneiro, 11-Dec-2016.) $)
  unisym1 $p |- ( A. x A. x F. -> A. x ph ) $=
    ( wfal wal falim sps ) CBDABDZBCGBGEFF $.

  $( A symmetry with ` E. ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     4-Sep-2011.) $)
  exisym1 $p |- ( E. x E. x F. -> E. x ph ) $=
    ( wfal wex nfe1 falim eximi exlimi ) CBDABDBABECABAFGH $.

  $( A symmetry with ` E! ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     6-Sep-2011.) $)
  unqsym1 $p |- ( E! x E! x F. -> E! x ph ) $=
    ( wfal weu wex unnf nex euex mto pm2.21i ) CBDZBDZABDLKBEKBBFGKBHIJ $.

  $( A symmetry with ` E* ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     13-Sep-2011.) $)
  amosym1 $p |- ( E* x E* x F. -> E* x ph ) $=
    ( wfal wmo wex weu wi df-mo mof 19.8a pm2.24d pm2.01d ax-mp pm2.21i notnoti
    wn nex eunex mto ja sylbi ) CBDZBDUBBEZUBBFZGABDZUBBHUCUDUEUCPZUEUBUFPZBIZU
    BUFUBUCUGUBBJKLMNUDUEUDUBPZBEUIBUBUHOQUBBRSNTUA $.

  $( A symmetry with ` [ x / y ] ` .

     See ~ negsym1 for more information.  (Contributed by Anthony Hart,
     11-Sep-2011.) $)
  subsym1 $p |- ( [ x / y ] [ x / y ] F. -> [ x / y ] ph ) $=
    ( wfal wsb weq wi wa wex fal intnan nex df-sb mtbir pm2.21i ) DCBEZCBEZACBE
    QCBFZPGZRPHZCIZHUASTCPRPRDGZRDHZCIZHUDUBUCCDRJKLKDCBMNKLKPCBMNO $.

$( (End of Anthony Hart's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Mathbox for Chen-Pang He
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                Ordinal topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d B x y $.
    $( An ordinal number is a topological basis.  (Contributed by Chen-Pang He,
       8-Oct-2015.) $)
    ontopbas $p |- ( B e. On -> B e. TopBases ) $=
      ( vx vy con0 wcel cv cin wral ctb wa onelon anim12dan ex onin syl6 anc2ri
      wss wi inss1 jctl adantr a1i ontr2 syl6c ralrimivv fiinbas mpdan ) ADEZBF
      ZCFZGZAEZCAHBAHAIEUHULBCAAUHUIAEZUJAEZJZUKDEZUHJUKUIQZUMJZULUHUOUPUHUOUID
      EZUJDEZJZUPUHUOVAUHUMUSUNUTAUIKAUJKLMUIUJNOPUOURRUHUMURUNUMUQUIUJSTUAUBUK
      UIAUCUDUEBCADUFUG $.
  $}

  $( The class of ordinal numbers is a subclass of the class of topological
     bases.  (Contributed by Chen-Pang He, 8-Oct-2015.) $)
  onsstopbas $p |- On C_ TopBases $=
    ( vx con0 ctb cv ontopbas ssriv ) ABCADEF $.

  $( The class of ordinal numbers is a proper subclass of the class of
     topological bases.  (Contributed by Chen-Pang He, 9-Oct-2015.) $)
  onpsstopbas $p |- On C. TopBases $=
    ( con0 ctb wss c0 csn wcel wn wa wpss onsstopbas ctop indistop topbas ax-mp
    cpr wi snex prid2 snsn0non mp2 mth8 onelon ex mto pm3.2i ssnelpss ) ABCDDEZ
    EZOZBFZUIAFZGZHABIJUJULUIKFUJUHLUIMNUKUHUIFZUHAFZPZUMUNGUOGDUHUGQRSUMUNUATU
    KUMUNUIUHUBUCUDUEABUIUFT $.

  ${
    $d B x $.
    $( The topology generated from an ordinal number ` B ` is ` suc U. B ` .
       (Contributed by Chen-Pang He, 10-Oct-2015.) $)
    ontgval $p |- ( B e. On -> ( topGen ` B ) = suc U. B ) $=
      ( vx con0 wcel ctg cfv cuni csuc cv wa wss cpw cin cvv inex1g onss syl wi
      wceq jctird ssinss1 ssonuni sylc eleq1 biimprd syl5com onuni suceloni tg1
      eltg4i sucidg ontr2 syl6c wo elsuci word eloni orduniss bastg sstrd sseld
      a1i ssid eltg3i mpan2 eleq1a jaod syl5 impbid eqrdv ) ACDZBAEFZAGZHZVKBIZ
      VLDZVOVNDZVKVPVOCDZVNCDZJVOVMKZVMVNDZJVQVKVPVRVSVKAVOLZMZGZCDZVPVRVKWCNDW
      CCKZWEAWBCOVKACKWFAPAWBCUAQWCNUBUCVPVOWDSZWEVRRVOAUJWGVRWEVOWDCUDUEQUFVKV
      MCDZVSAUGZVMUHQTVKVPVTWAVPVTRVKVOAUIVBVKWHWAWIVMCUKQTVOVMVNULUMVQVOVMDZVO
      VMSZUNVKVPVOVMUOVKWJVPWKVKVMVLVOVKVMAVLVKAUPVMAKAUQAURQACUSUTVAVKVMVLDZWK
      VPRVKAAKWLAVCAACVDVEVMVLVOVFQVGVHVIVJ $.
  $}

  $( The topology generated from a successor ordinal number is itself.
     (Contributed by Chen-Pang He, 11-Oct-2015.) $)
  ontgsucval $p |- ( A e. On -> ( topGen ` suc A ) = suc A ) $=
    ( con0 wcel csuc ctg cuni wceq suceloni ontgval eloni ordunisuc suceq eqtrd
    cfv syl word ) ABCZADZENZRFZDZRQRBCSUAGAHRIOQTAGZUARGQAPUBAJAKOTALOM $.

  $( A successor ordinal number is a topology.  (Contributed by Chen-Pang He,
     11-Oct-2015.) $)
  onsuctop $p |- ( A e. On -> suc A e. Top ) $=
    ( con0 wcel csuc ctg ctop ontgsucval suceloni ontopbas tgcl 3syl eqeltrrd
    cfv ctb ) ABCZADZEMZPFAGOPBCPNCQFCAHPIPJKL $.

  $( One of the topologies on an ordinal number is its successor.  (Contributed
     by Chen-Pang He, 7-Nov-2015.) $)
  onsuctopon $p |- ( A e. On -> suc A e. ( TopOn ` A ) ) $=
    ( con0 wcel csuc ctop cuni wceq ctopon onsuctop word eloni ordunisuc eqcomd
    cfv syl istopon sylanbrc ) ABCZADZECASFZGZSAHNCAIRAJZUAAKUBTAALMOASPQ $.

  ${
    ordtoplem.1 $e |- ( U. A e. On -> suc U. A e. S ) $.
    $( Membership of the class of successor ordinals.  (Contributed by
       Chen-Pang He, 1-Nov-2015.) $)
    ordtoplem $p |- ( Ord A -> ( A =/= U. A -> A e. S ) ) $=
      ( cuni wne wceq wn word wcel df-ne con0 csuc wo ordeleqon eqcomi id unieq
      unon 3eqtr4a ord orim2i sylbi orcomd orduniorsuc onuni eleq1a 3syl syl5bi
      wi syl6c ) AADZEAUKFZGZAHZABIZAUKJUNUMAKIZAUKLZFZUOUNULUPUNUPULUNUPAKFZMU
      PULMANUSULUPUSKKDZAUKUTKROUSPAKQSUAUBUCTUNULURAUDTUPUKKIUQBIURUOUIAUECUQB
      AUFUGUJUH $.
  $}

  $( An ordinal is a topology iff it is not its supremum (union), proven
     without the Axiom of Regularity.  (Contributed by Chen-Pang He,
     1-Nov-2015.) $)
  ordtop $p |- ( Ord J -> ( J e. Top <-> J =/= U. J ) ) $=
    ( word ctop wcel cuni wne eqid topopn nordeq syl5 onsuctop ordtoplem impbid
    ex ) ABZACDZAAEZFZPQADZORAQQGHOSRAQINJACQKLM $.

  ${
    $d A x $.
    onsucconi.1 $e |- A e. On $.
    $( A successor ordinal number is a connected topology.  (Contributed by
       Chen-Pang He, 16-Oct-2015.) $)
    onsucconi $p |- suc A e. Con $=
      ( vx csuc ccon wcel c0 wss con0 wa wceq wo oneli on0eln0 biimprd necon1bd
      wi wn wne syl ctop ccld cfv cin cpr onsuctop ax-mp cv elin cdif onunisuci
      elsuci cuni eqcomi cldopn onsuci elndif ssdif0 sylbir syl56 sylcom orim1d
      onssneli con2d impcom vex elpr sylibr syl2an sylbi ssriv iscon2 mpbir2an
      ) ADZEFVNUAFZVNVNUBUCZUDZGAUEZHAIFVOBAUFUGCVQVRCUHZVQFVSVNFZVSVPFZJVSVRFZ
      VSVNVPUIVTVSAFZVSAKZLZAVSUJZVNFZWBWAVSAULVSVNAVNUMAABUKUNZUOWEWGJVSGKZWDL
      ZWBWGWEWJWGWCWIWDWGWFIFZWCWIQVNWFABUPMWKWCGVSFZRWIWKWLWCWLGWFFZRWKWFGKZWC
      RZGVSAUQWKWMWFGWKWMWFGSWFNOPWNAVSHWOAVSURAVSBVCUSUTVDWCWLVSGWCVSIFZVSGSZW
      LQAVSBMWPWLWQVSNOTPVATVBVEVSGACVFVGVHVIVJVKVNAWHVLVM $.
  $}

  $( A successor ordinal number is a connected topology.  (Contributed by
     Chen-Pang He, 16-Oct-2015.) $)
  onsuccon $p |- ( A e. On -> suc A e. Con ) $=
    ( con0 wcel csuc ccon c0 cif wceq suceq eleq1d 0elon elimel onsucconi dedth
    ) ABCZADZECOAFGZDZECAFAQHPREAQIJQAFBKLMN $.

  $( An ordinal topology is connected.  (Contributed by Chen-Pang He,
     1-Nov-2015.) $)
  ordtopcon $p |- ( Ord J -> ( J e. Top <-> J e. Con ) ) $=
    ( word ctop wcel ccon cuni ordtop onsuccon ordtoplem sylbid contop impbid1
    wne ) ABZACDZAEDZNOAAFZMPAGAEQHIJAKL $.

  $( An ordinal topology is connected, expressed in constants.  (Contributed by
     Chen-Pang He, 16-Oct-2015.) $)
  onintopsscon $p |- ( On i^i Top ) C_ Con $=
    ( vx con0 ctop cin ccon cv wcel wa elin wb eloni ordtopcon syl biimpa sylbi
    word ssriv ) ABCDZEAFZRGSBGZSCGZHSEGZSBCITUAUBTSPUAUBJSKSLMNOQ $.

  ${
    $d A o x y $.
    $( A successor ordinal number is a T_0 space.  (Contributed by Chen-Pang
       He, 8-Nov-2015.) $)
    onsuct0 $p |- ( A e. On -> suc A e. Kol2 ) $=
      ( vx vo vy con0 wcel csuc wel wb wral wi word cv wa wal ordelon wn ancoms
      wss syl ct0 weq eloni df-ral anim12dan ordsuc sylbi adantr ontri1 onsssuc
      ex notbi bitr3d adantrr adantrl bibi12d syl5bb biimpd ee12an a2d ordelord
      ordelss ordsucsssuc syldan mpbid ssneld jcad pm5.21 idd jad alimdv syl5bi
      syl6 syld dfcleq suc11 syl5bbr sylibd ralrimivva ctopon onsuctopon ist0-2
      wceq cfv mpbird ) AEFZAGZUAFZBCHZDCHZIZCWGJZBDUBZKZDAJBAJZWFALZWOAUCWPWNB
      DAAWPBMZAFZDMZAFZNZNZWLCMZWQGZFZXCWSGZFZIZCOZWMWLXCWGFZWKKZCOXBXIWKCWGUDX
      BXKXHCXBXKXJXHKXHXBXJWKXHXBWQEFZWSEFZNZXJXCEFZWKXHKWPWRXLWTXMAWQPAWSPUEZW
      PXJXOKZXAWPWGLZXQAUFXRXJXOWGXCPUKUGUHXNXONZWKXHWKWIQZWJQZIZXSXHWIWJULXOXN
      YBXHIXOXNNXTXEYAXGXOXLXTXEIXMXOXLNXCWQSXTXEXCWQUIXCWQUJUMUNXOXMYAXGIXLXOX
      MNXCWSSYAXGXCWSUIXCWSUJUMUOUPRUQURUSUTXBXJXHXHXBXJQZXEQZXGQZNXHXBYCYDYEWP
      WRYCYDKWTWPWRNZXDWGXCYFWQASZXDWGSZAWQVBWPWRWQLZYGYHIZAWQVAYIWPYJWQAVCRVDV
      EVFUNWPWTYCYEKWRWPWTNZXFWGXCYKWSASZXFWGSZAWSVBWPWTWSLZYLYMIZAWSVAYNWPYOWS
      AVCRVDVEVFUOVGXEXGVHVMXBXHVIVJVNVKVLXBXNXIWMIXPXIXDXFWCXNWMCXDXFVOWQWSVPV
      QTVRVSTWFWGAVTWDFWHWOIAWABDCWGAWBTWE $.
  $}

  $( An ordinal topology is T_0.  (Contributed by Chen-Pang He, 8-Nov-2015.) $)
  ordtopt0 $p |- ( Ord J -> ( J e. Top <-> J e. Kol2 ) ) $=
    ( word ctop wcel ct0 cuni wne ordtop onsuct0 ordtoplem sylbid t0top impbid1
    ) ABZACDZAEDZNOAAFZGPAHAEQIJKALM $.

  ${
    $d A y z $.
    onsucsuccmpi.1 $e |- A e. On $.
    $( The successor of a successor ordinal number is a compact topology,
       proven without the Axiom of Regularity.  (Contributed by Chen-Pang He,
       18-Oct-2015.) $)
    onsucsuccmpi $p |- suc suc A e. Comp $=
      ( vy vz csuc ccmp wcel ctop cv cuni wceq cpw cfn cin wi con0 onunisuci wa
      wss eqcomi wrex wral onsuci onsuctop ax-mp wn onirri onsucssi sseq1 mtbii
      mtbi elpwi unissd syl6sseq nsyl csn cun cdif eldif elpwunsn sylbir df-suc
      ex pweqi eleq2s snelpwi snfi jctr sylibr elexi unisn unieq eqeq2d sylancl
      elin rspcev syl syl56 rgen iscmp mpbir2an ) AEZEZFGWCHGZWBCIZJZKZWBDIZJZK
      ZDWELZMNZUAZOZCWCLZUBWBPGWDABUCZWBUDUEWNCWOWGWEWBLZGZUFZWEWOGWBWEGZWMWGWF
      ASZWRWGWBASZXAAAGXBABUGAABBUHUKWBWFAUIUJWRWFWBJAWRWEWBWEWBULUMABQUNUOWSWT
      OWEWBWBUPZUQZLZWOWEXEGZWSWTXFWSRWEXEWQURGWTWEXEWQUSWEWBWBUTVAVCWCXDWBVBVD
      VEWTXCWKGZWMWBWEVFXGXCWLGZWBXCJZKZWMXGXGXCMGZRXHXGXKWBVGVHXCWKMVOVIXIWBWB
      WBPWPVJVKTWJXJDXCWLWHXCKWIXIWBWHXCVLVMVPVNVQVRVSCDWCWBWCJWBWBWPQTVTWA $.
  $}

  $( The successor of a successor ordinal number is a compact topology.
     (Contributed by Chen-Pang He, 18-Oct-2015.) $)
  onsucsuccmp $p |- ( A e. On -> suc suc A e. Comp ) $=
    ( con0 wcel csuc ccmp c0 cif wceq suceq syl eleq1d 0elon onsucsuccmpi dedth
    elimel ) ABCZADZDZECPAFGZDZDZECAFASHZRUAEUBQTHRUAHASIQTIJKSAFBLOMN $.

  ${
    $d A y z $.
    limsucncmpi.1 $e |- Lim A $.
    $( The successor of a limit ordinal is not compact.  (Contributed by
       Chen-Pang He, 20-Oct-2015.) $)
    limsucncmpi $p |- -. suc A e. Comp $=
      ( vy vz wcel ctop cuni wceq cpw cfn wrex wi wa wn cvv wss ax-mp wne con0
      c0 csuc ccmp cin wral elex sucexb sylibr sssucid elpwg mpbiri wlim limuni
      cv elin elpwi anim1i sylbi wb nlim0 2th xor3 mpbir necon3bi uni0 neeqtrri
      limeq unieq neeq2d a1i word limord ordsson mp2b sstr2 mpi ordunifi 3expia
      sylan ssel nordeq mpan syl6 adantr syld pm2.61dne neneqd nrex eqeq2d pweq
      syl ineq1d rexeqdv notbid anbi12d rspcev mpanr12 rexanali sylib 3syl mpbi
      imnan ordunisuc eqcomi iscmp mtbir ) AUAZUBEXFFEZACUMZGZHZADUMZGZHZDXHIZJ
      UCZKZLCXFIZUDZMZXGXRNZLXSNXGAOEZAXQEZXTXGXFOEYAXFFUEAUFUGYAYBAXFPAUHAXFOU
      IUJYBXJXPNZMZCXQKZXTYBAAGZHZXMDAIZJUCZKZNZYEAUKZYGBAULQXMDYIXKYIEZAXLYMXK
      APZXKJEZMZAXLRZYMXKYHEZYOMYPXKYHJUNYRYNYOXKAUOUPUQYPYQXKTXKTHZYQLYPYSYQAT
      GZRATYTYLTUKZURZNZATRUUCYLUUANZURYLUUDBUSUTYLUUAVAVBUUBATATVFVCQVDVEYSXLY
      TAXKTVGVHUJVIYPXKTRZXLXKEZYQYNXKSPZYOUUEUUFLYNASPZUUGYLAVJZUUHBAVKZAVLVMX
      KASVNVOUUGYOUUEUUFXKVPVQVRYNUUFYQLYOYNUUFXLAEZYQXKAXLVSUUIUUKYQYLUUIBUUJQ
      AXLVTWAWBWCWDWEWJWFWGYDYGYKMCAXQXHAHZXJYGYCYKUULXIYFAXHAVGWHUULXPYJUULXMD
      XOYIUULXNYHJXHAWIWKWLWMWNWOWPXJXPCXQWQWRWSXGXRXAWTCDXFAXFGZAYLUUIUUMAHBUU
      JAXBVMXCXDXE $.
  $}

  $( The successor of a limit ordinal is not compact.  (Contributed by
     Chen-Pang He, 20-Oct-2015.) $)
  limsucncmp $p |- ( Lim A -> -. suc A e. Comp ) $=
    ( wlim csuc ccmp wcel con0 cif wceq suceq eleq1d notbid limeq limon elimhyp
    wn limsucncmpi dedth ) ABZACZDEZORAFGZCZDEZOAFAUAHZTUCUDSUBDAUAIJKUARUABFBA
    FAUALFUALMNPQ $.

  $( An ordinal topology is compact iff the underlying set is its supremum
     (union) only when the ordinal is ` 1o ` .  (Contributed by Chen-Pang He,
     1-Nov-2015.) $)
  ordcmp $p |- ( Ord A -> ( A e. Comp <-> ( U. A = U. U. A -> A = 1o ) ) ) $=
    ( word ccmp wcel cuni wceq c1o wi c0 wo biimpd syl ctop cmptop wn csuc syl6
    a1i con0 ord csn wss wlim orduni unizlim uni0b orbi1i syl6bb sssn 0ntop mto
    eleq1 mtbiri pm2.21d df1o2 syl6eqr a1d jaoi sylbi wne ordtop necon2bd con3i
    id a1dd limsucncmp notbid syl5ibr orduniorsuc mpjaod pm2.21 com23 ordeleqon
    jaod syl5d unon eqcomi unieqi unieq unieqd 3eqtr4a orim2i orcomd syl5 suceq
    eqtr ex syl6c onuni onsucsuccmp eleq1a 4syl syl6eq 0cmp syl6eqel jad impbid
    ) ABZACDZAEZWTEZFZAGFZHWRXBAIUAZUBZWTUCZJZWSXCWRWTBZXBXGHAUDZXHXBXGXHXBWTIF
    ZXFJXGWTUEXJXEXFAUFUGUHKLWRXGWSXCWRXEWSXCHZXFXEXKHWRXEAIFZAXDFZJXKAIUIXLXKX
    MXLWSXCXLWSICDZXNIMDUJINUKAICULUMUNXMXCWSXMAXDGXMVDUOUPUQURUSRWRXFWSOZXKWRA
    WTFZXFXOHZAWTPZFZWRXPXOXFWRXPAMDZOXOWRXTAWTWRXTAWTUTAVAKVBWSXTANVCQVEXSXQHW
    RXFXOXSXRCDZOWTVFXSWSYAAXRCULVGVHRAVIZVJWSXCVKQVNVLVOWRXBXCWSWRXBOZASDZAXAP
    ZPZFZWSWRXBYDWRYDXBWRYDASFZJYDXBJAVMYHXBYDYHSEZYIEWTXASYIYISVPVQVRASVSZYHWT
    YIYJVTWAWBUSWCTWRYCXSXRYFFZYGYCXPOWRXSXPXBAWTVSVCWRXPXSYBTWDWRYCWTYEFZYKWRX
    BYLWRXHXBYLJXIWTVILTWTYEWEQXSYKYGAXRYFWFWGWHYDWTSDXASDYFCDYGWSHAWIWTWIXAWJY
    FCAWKWLWHXCWSHWRXCAXDCXCAGXDXCVDUOWMWNWORWPWQ $.

  $( The ordinal topologies ` 1o ` and ` 2o ` are Hausdorff.  (Contributed by
     Chen-Pang He, 10-Nov-2015.) $)
  ssoninhaus $p |- { 1o , 2o } C_ ( On i^i Haus ) $=
    ( c1o c2o cpr con0 cha wcel wss 1on 2on prssi mp2an c0 cpw csn df1o2 eqtr4i
    cvv dishaus ax-mp eqeltri pw0 0ex df2o2 pwpw0 p0ex ssini ) ABCZDEADFBDFUGDG
    HIABDJKAEFBEFUGEGALMZEALNZUHOUAPLQFUHEFUBLQRSTBUIMZEBLUICUJUCUDPUIQFUJEFUEU
    IQRSTABEJKUF $.

  ${
    $d j a $.
    $( The ordinal T_1 spaces are ` 1o ` and ` 2o ` , proven without the Axiom
       of Regularity.  (Contributed by Chen-Pang He, 9-Nov-2015.) $)
    onint1 $p |- ( On i^i Fre ) = { 1o , 2o } $=
      ( vj va con0 ct1 cin c1o c2o cpr c0 csn cdif wcel wa wne wceq wss cun cha
      wn wb csuc cv elin ccld cuni wral ctop eqid ist1 simprbi onelon neldifsnd
      cfv ex p0ex prid2 df2o2 eleqtrri elunii mpan df1o2 eqeltrri onirri eldifd
      1on a1i ne0i syl 2thd nbbn sylib on0eln0 nsyli imp 0ex prid1 adantl simpr
      nsyl sneqd eleq1d rspcdv cldopn syl6 mtod con2d 2on ontri1 onsssuc bitr3d
      syl5 mpan2 sylibd 0ntop t1top mto nelneq elsni sylbi ssriv df-suc difeq1i
      difundir eqtri df-pr df2o3 difid disjsn2 ax-mp difeq2i difin dif0 3eqtr3i
      1n0 uneq12i uncom un0 3eqtri eqtr4i sseqtri ssoninhaus haust1 sslin sstri
      2on0 eqssi ) CDEZFGHZYGGUAZIJZKZYHAYGYKAUBZYGLYLCLZYLDLZMZYLYKLYLCDUCYOYL
      YIYJYMYNYLYILZYMYNGYLLZSZYPYNBUBZJZYLUDUMZLZBYLUEZUFZYMYRYNYLUGLUUDYLUUCB
      UUCUHZUIUJYMYQUUDYMYQUUDSYMYQMZUUDUUCYJKZYLLZYMYQUUHSYMUUHUUGCLZYQYMUUHUU
      IYLUUGUKUNYQIUUGLZUUGINZTZUUIYQUUJSZUUKTUULSYQUUMUUKYQIUUCULYQYJUUGLUUKYQ
      YJUUCYJYJGLYQYJUUCLYJIYJHZGIYJUOUPUQURYJGYLUSUTYJYJLSYQYJFYJCVAVEVBVCVFVD
      UUGYJVGVHVIUUJUUKVJVKUUGVLVSVMVNUUFUUDYJUUALZUUHUUFUUBUUOBIUUCYQIUUCLZYMI
      GLYQUUPIUUNGIYJVOVPUQURIGYLUSUTVQUUFYSIOZMZYTYJUUAUURYSIUUFUUQVRVTWAWBYJY
      LUUCUUEWCWDWEUNWFWKYMGCLZYRYPTWGYMUUSMYLGPYRYPYLGWHYLGWIWJWLWMVNYNYLYJLZS
      YMYNYLIOZUUTYNIDLZSUVASUVBIUGLWNIWOWPYLIDWQWLYLIWRVSVQVDWSWTYKGYJKZGJZYJK
      ZQZYHYKGUVDQZYJKUVFYIUVGYJGXAXBGUVDYJXCXDYHFJZUVDQUVFFGXEUVCUVHUVEUVDUVCY
      JUVHQZYJKYJYJKZUVHYJKZQZUVHGUVIYJGIFHUVIXFIFXEXDXBYJUVHYJXCUVLIUVHQUVHIQU
      VHUVJIUVKUVHYJXGUVHUVHYJEZKUVHIKUVKUVHUVMIUVHFINUVMIOXNFIXHXIXJUVHYJXKUVH
      XLXMXOIUVHXPUVHXQXRXRUVDUVDYJEZKUVDIKUVEUVDUVNIUVDGINUVNIOYEGIXHXIXJUVDYJ
      XKUVDXLXMXOXSXSXTYHCREZYGYARDPUVOYGPARDYLYBWTRDCYCXIYDYF $.
  $}

  $( The ordinal Hausdorff spaces are ` 1o ` and ` 2o ` .  (Contributed by
     Chen-Pang He, 10-Nov-2015.) $)
  oninhaus $p |- ( On i^i Haus ) = { 1o , 2o } $=
    ( vx cha cin c1o c2o cpr ct1 wss cv haust1 ssriv sslin ax-mp onint1 sseqtri
    con0 ssoninhaus eqssi ) PBCZDEFZSPGCZTBGHSUAHABGAIJKBGPLMNOQR $.

$( (End of Chen-Pang He's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Jeff Hoffman
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Inferences for finite induction on generic function values
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( findrec.mm - Inferences for finite induction on generic function values
     and specifically, functions defined via rec(G, A). $)

  $( Please add description here.  (Contributed by Jeff Hoffman,
     12-Feb-2008.) $)
  fveleq $p |- ( A = B ->
             ( ( ph -> ( F ` A ) e. P ) <-> ( ph -> ( F ` B ) e. P ) ) ) $=
    ( wceq cfv wcel fveq2 eleq1d imbi2d ) BCFZBEGZDHCEGZDHALMNDBCEIJK $.

  ${
    $d F x y $.  $d P x y $.  $d x y ph $.  $d x A $.
    findfvcl.1 $e |- ( ph -> ( F ` (/) ) e. P ) $.
    findfvcl.2 $e |- ( y e. om -> ( ph -> ( ( F ` y ) e. P ->
                     ( F ` suc y ) e. P ) ) ) $.
    $( Please add description here.  (Contributed by Jeff Hoffman,
       12-Feb-2008.) $)
    findfvcl $p |- ( A e. om -> ( ph -> ( F ` A ) e. P ) ) $=
      ( vx cv cfv wcel wi c0 csuc fveleq com a2d finds ) AHIZEJDKLAMEJDKLABIZEJ
      DKZLATNZEJDKZLACEJDKLHBCASMDEOASTDEOASUBDEOASCDEOFTPKAUAUCGQR $.
  $}

  ${
    $d y z $.  $d G y $.  $d A y $.  $d P y $.  $d G z $.  $d A z $.  $d P z $.
    findreccl.1 $e |- ( z e. P -> ( G ` z ) e. P ) $.
    $( Please add description here.  (Contributed by Jeff Hoffman,
       19-Feb-2008.) $)
    findreccl $p |- ( C e. om -> ( A e. P -> ( rec ( G , A ) ` C ) e. P ) ) $=
      ( vy wcel crdg c0 cfv wceq rdg0g eleq1a mpd cv com csuc wi eleq1d vtoclga
      con0 nnon fveq2 rdgsuc syl5ibr syl a1d findfvcl ) BDHZGCDEBIZUJJUKKZBLULD
      HBDEMBDULNOGPZQHZUMUKKZDHZUMRUKKZDHZSZUJUNUMUBHZUSUMUCUPURUTUOEKZDHZAPZEK
      ZDHVBAUODVCUOLVDVADVCUOEUDTFUAUTUQVADBUMEUETUFUGUHUI $.
  $}

  ${
    $d G x y $.  $d A x y $.  $d C x y $.  $d P y $.  $d G z $.  $d A z $.
    $d P z $.
    findabrcl.1 $e |- ( z e. P -> ( G ` z ) e. P ) $.
    $( Please add description here.  (Contributed by Jeff Hoffman,
       16-Feb-2008.)  (Revised by Mario Carneiro, 11-Sep-2015.) $)
    findabrcl $p |- ( ( C e. om /\ A e. P ) ->
                  ( ( x e. _V |-> ( rec ( G , A ) ` x ) ) ` C ) e. P ) $=
      ( com wcel wa cvv cv crdg cfv cmpt wceq elex fveq2 eqid fvex fvmpt adantr
      syl findreccl imp eqeltrd ) DHIZCEIZJDAKALZFCMZNZOZNZDUJNZEUGUMUNPZUHUGDK
      IUODHQADUKUNKULUIDUJRULSDUJTUAUCUBUGUHUNEIBCDEFGUDUEUF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              gdc.mm
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( gdc.mm  9-Apr-2008 $)

  ${
    nnssi2.1 $e |- NN C_ D $.
    nnssi2.2 $e |- ( B e. NN -> ph ) $.
    nnssi2.3 $e |- ( ( A e. D /\ B e. D /\ ph ) -> ps ) $.
    $( Convert a theorem for real/complex numbers into one for natural
       numbers.  (Contributed by Jeff Hoffman, 17-Jun-2008.) $)
    nnssi2 $p |- ( ( A e. NN /\ B e. NN ) -> ps ) $=
      ( cn wcel wa w3a sseli 3anim123i 3anidm23 syl ) CIJZDIJZKCEJZDEJZALZBQRUA
      QSRTRAIECFMIEDFMGNOHP $.
  $}

  ${
    nnssi3.1 $e |- NN C_ D $.
    nnssi3.2 $e |- ( C e. NN -> ph ) $.
    nnssi3.3 $e |- ( ( ( A e. D /\ B e. D /\ C e. D ) /\ ph ) -> ps ) $.
    $( Convert a theorem for real/complex numbers into one for natural
       numbers.  (Contributed by Jeff Hoffman, 17-Jun-2008.) $)
    nnssi3 $p |- ( ( A e. NN /\ B e. NN /\ C e. NN ) -> ps ) $=
      ( cn wcel w3a sseli 3anim123i 3ad2ant3 syl2anc ) CJKZDJKZEJKZLCFKZDFKZEFK
      ZLABQTRUASUBJFCGMJFDGMJFEGMNSQARHOIP $.
  $}

  $( Please add description here.  (Contributed by Jeff Hoffman,
     17-Jun-2008.) $)
  nndivsub $p |- ( ( ( A e. NN /\ B e. NN /\ C e. NN )
                       /\ ( ( A / C ) e. NN /\ A < B ) )
                    -> ( ( B / C ) e. NN <-> ( ( B - A ) / C ) e. NN ) ) $=
    ( cn wcel cdiv co clt wbr wa cmin wi cr cc0 wb nnre jca biimpd cc nncn wceq
    w3a nngt0 ltdiv1 syl3an nnsub sylan9bb exp32 com34 imp32 nnaddcl expcom wne
    caddc nnsscn nnne0 divcl nnssi2 anim12i 3impdir npcan ancoms eleq1d sylan9r
    adantrr impbid 3ad2ant2 3ad2ant1 3ad2ant3 divsubdir syl3anc adantr bitr4d
    syl ) ADEZBDEZCDEZUBZACFGZDEZABHIZJZJZBCFGZDEZWDVSKGZDEZBAKGCFGZDEZWCWEWGVR
    VTWAWEWGLVRVTWEWAWGVRVTWEWAWGLVRVTWEJZJWAWGVRWAVSWDHIZWJWGVOAMEVPBMEVQCMEZN
    CHIZJWAWKOAPBPVQWLWMCPCUCQABCUDUEVSWDUFUGRUHUIUJVRVTWGWELWAVTWGWFVSUNGZDEZV
    RWEWGVTWOWFVSUKULVRWOWEVRWNWDDVRVSSEZWDSEZJZWNWDUAZVOVQVPWRVOVQJWPVPVQJWQCN
    UMZWPACSUOCUPZACUQURWTWQBCSUOXABCUQURUSUTWQWPWSWDVSVAVBVNVCRVDVEVFVRWIWGOWB
    VRWHWFDVRBSEZASEZCSEZWTJZWHWFUAVPVOXBVQBTVGVOVPXCVQATVHVQVOXEVPVQXDWTCTXAQV
    IBACVJVKVCVLVM $.

  $( A factor of a natural number cannot exceed it.  (Contributed by Jeff
     Hoffman, 17-Jun-2008.) $)
  nndivlub $p |- ( ( A e. NN /\ B e. NN )
        -> ( ( A / B ) e. NN -> B <_ A ) ) $=
    ( cn wcel cr cc0 clt wbr wa cdiv co cle wi nnre nngt0 jca c1 nnge1 lediv2
    wb 3anidm23 cc recn adantr gt0ne0 divid breq1d syl2anc adantl bitrd syl5ibr
    wne syl2anr ) BCDZBEDZFBGHZIZAEDZFAGHZIZABJKZCDZBALHZMACDZUNUOUPBNBOPVDURUS
    ANAOPVBVCUQUTIZQVALHZVARVEVCAAJKZVALHZVFUQUTVCVHTBAASUAUTVHVFTZUQUTAUBDZAFU
    LZVIURVJUSAUCUDAUEVJVKIVGQVALAUFUGUHUIUJUKUM $.

  $c gcdOLD $. $( The greatest common divisor $)

  $( Extend class notation to include the gdc function.
     (New usage is discouraged.) $)
  cgcdOLD $a class gcdOLD ( A , B ) $.

  ${
    $d x A $.  $d x B $.
    $( ` gcdOLD ( A , B ) ` is the largest natural number that evenly divides
       both ` A ` and ` B ` .  (Contributed by Jeff Hoffman, 17-Jun-2008.)
       (New usage is discouraged.) $)
    df-gcdOLD $a |- gcdOLD ( A , B ) = sup ( { x e. NN | ( ( A / x ) e. NN
                                           /\ ( B / x ) e. NN ) } , NN , < ) $.

    $( Lemma for Euclid's Elements, Book 7, proposition 2.  The original
       mentions the smaller measure being 'continually subtracted' from the
       larger.  Many authors interpret this phrase as ` A ` mod ` B ` .  Here,
       just one subtraction step is proved to preserve the ` gcdOLD ` .  The
       ` rec ` function will be used in other proofs for iterated subtraction.
       (Contributed by Jeff Hoffman, 17-Jun-2008.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee7.2aOLD $p |- ( ( A e. NN /\ B e. NN )
         -> ( A < B -> gcdOLD ( A , B ) = gcdOLD ( A , ( B - A ) ) ) ) $=
      ( vx cn wcel wa clt wbr cgcdOLD cmin co wceq cv cdiv crab com23 df-gcdOLD
      csup wi imp wb w3a nndivsub exp32 3expia pm5.32d rabbidva supeq1d 3eqtr4g
      ex ) ADEZBDEZFZABGHZABIZABAJKZIZLUMUNFZACMZNKDEZBUSNKDEZFZCDOZDGRUTUPUSNK
      DEZFZCDOZDGRUOUQURDVCVFGURVBVECDURUSDEZFUTVAVDURVGUTVAVDUAZSZUMUNVGVISUMV
      GUNVIUKULVGUNVISUKULVGUBZUTUNVHVJUTUNVHABUSUCUDPUEPTTUFUGUHCABQCAUPQUIUJ
      $.
  $}

$( (End of Jeff Hoffman's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Wolf Lammen
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  Most of the theorems in the section "Logical implication" are about
  handling chains of implications: ` ph -> ( ps -> ( ch -> ... `.  With
  respect to chains, a rich set of rules clarify

  - how to swap antecedents (com12, ...);

  - how to drop antecedents (ax-mp, pm2.43, ...);

  - how to add antecedents (a1i, ...)

  - how to replace an antecedent (syl, ...);

  - how to replace a consequent (ax-mp, syl, ...);

  - what is, when an antecedent equals the consequent (ax-1, id, ...).

  In all these cases, the operands of the chain have no inner structure, or
  it is of no importance.  These chains are called "simple" here.

  There is less support, when the operands are structured themselves.  Some
  kinds of inner structure involving the ` -. ` operator are best handled by
  the symmetric operators ` /\ ` and ` \/ `.  But a nested, simple chain
  has no such convenient replacement.  I can focus on antecedents here,
  since a consequent representing a chain is, in conjunction with its
  antecedents, just an extended simple chain again.

  The following theorems show, how operations on nested chains appear
  somehow mirrored: The minor premises of the syllogisms look reverted, in
  comparison to their normal counterparts, and while adding an antecedent to
  a chain via ~ a1i is easy, in nested chains they can be easily dropped.

$)

  ${
    wl-jarri.1 $e |- ( ( ph -> ps ) -> ch ) $.
    $( Dropping a nested antecedent.  This theorem is one of two reversions of
       ~ ja .  Since ~ ja is reversible, one can conclude, that a nested (chain
       of) implication(s) is just a packed notation of two or more theorems/
       hypotheses with a common consequent.  (Contributed by Wolf Lammen,
       20-Sep-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.)

       ~ ax46 is an instance of this idea. $)
    wl-jarri $p |- ( ps -> ch ) $=
      ( wi ax-1 syl ) BABECBAFDG $.
  $}

  ${
    wl-jarli.1 $e |- ( ( ph -> ps ) -> ch ) $.
    $( Dropping a nested consequent.  This theorem is one of two reversions of
       ~ ja .  Since ~ ja is reversible, one can conclude, that a nested (chain
       of) implication(s) is just a packed notation of two or more theorems/
       hypotheses with a common consequent.  (Contributed by Wolf Lammen,
       4-Oct-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.)

       ~ ax46 is an instance of this idea. $)
    wl-jarli $p |- ( -. ph -> ch ) $=
      ( wn wi pm2.21 syl ) AEABFCABGDH $.
  $}

  ${
    wl-mps.1 $e |- ( ph -> ( ps -> ch ) ) $.
    wl-mps.2 $e |- ( ( ph -> ch ) -> th ) $.
    $( Replacing a nested consequent.  A sort of modus ponens in antecedent
       position.  (Contributed by Wolf Lammen, 20-Sep-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    wl-mps $p |- ( ( ph -> ps ) -> th ) $=
      ( wi a2i syl ) ABGACGDABCEHFI $.
  $}

  ${
    wl-syls1.1 $e |- ( ps -> ch ) $.
    wl-syls1.2 $e |- ( ( ph -> ch ) -> th ) $.
    $( Replacing a nested consequent.  A sort of syllogism in antecedent
       position.  (Contributed by Wolf Lammen, 20-Sep-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    wl-syls1 $p |- ( ( ph -> ps ) -> th ) $=
      ( wi a1i wl-mps ) ABCDBCGAEHFI $.
  $}

  ${
    wl-syls2.1 $e |- ( ph -> ps ) $.
    wl-syls2.2 $e |- ( ( ph -> ch ) -> th ) $.
    $( Replacing a nested antecedent.  A sort of syllogism in antecedent
       position.  (Contributed by Wolf Lammen, 20-Sep-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    wl-syls2 $p |- ( ( ps -> ch ) -> th ) $=
      ( wi imim1i syl ) BCGACGDABCEHFI $.
  $}

  ${
    wl-embant.1 $e |- ph $.
    wl-embant.2 $e |- ( ps -> ch ) $.
    $( A true wff can always be added as a nested antecedent to an antecedent.
       Note: this theorem is intuitionistically valid (see ~ wl-embantALT ).
       (Contributed by Wolf Lammen, 4-Oct-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    wl-embant $p |- ( ( ph -> ps ) -> ch ) $=
      ( pm2.24i ja ) ABCACDFEG $.

    $( Proof of ~ wl-embant not based on ~ ax-3 .  (Contributed by Wolf Lammen,
       4-Oct-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    wl-embantALT $p |- ( ( ph -> ps ) -> ch ) $=
      ( wi imim2i mpi ) ABFACDBCAEGH $.
  $}

  ${
    wl-embantd.1 $e |- ( ph -> ps ) $.
    wl-embantd.2 $e |- ( ph -> ( ch -> th ) ) $.
    $( Deduction version of ~ wl-embant .  Generalization of ~ a2i ,
       ~ imim12i , ~ imim1i and ~ imim2i , which can be proved by specializing
       its hypotheses, and some trivial rearrangements.  This theorem clarifies
       in a more general way, under what conditions a wff may be introduced as
       a nested antecedent to an antecedent.  Note: this theorem is not
       intuitionistically valid (see ~ embantd ).  (Contributed by Wolf Lammen,
       4-Oct-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    wl-embantd $p |- ( ph -> ( ( ps -> ch ) -> th ) ) $=
      ( pm2.24d jad ) ABCDABDEGFH $.
  $}

  $( Being free does not depend on an outside negation in an expression.  This
     theorem is slightly more general than ~ nfn or ~ nfnd .  (Contributed by
     Wolf Lammen, 5-May-2018.) $)
  wl-nfnbi $p |- ( F/ x ph <-> F/ x -. ph ) $=
    ( wnf wn id nfnd notnot nfbii sylibr impbii ) ABCZADZBCZKABKEFMLDZBCKMLBMEF
    ANBAGHIJ $.

  $( The semantics of ` E. x y = z ` .  (Contributed by Wolf Lammen,
     27-Apr-2018.) $)
  wl-exeq $p |- ( E. x y = z <-> ( y = z \/ A. x x = y \/ A. x x = z ) ) $=
    ( weq wex wal w3o wo wn wa nfeqf 19.9d impancom expcom 3orrot wi a9e eximii
    orrd 19.35i 3orass bitri sylibr 19.8a ax-8 com12 3jaoi impbii ) BCDZAEZUIAB
    DZAFZACDZAFZGZUJULUNUIHZHZUOUJULUPULIZUJUPURUJJUNUIURUNIZUJUIUIURUSJABCAKLM
    SNSUOULUNUIGUQUIULUNOULUNUIUAUBUCUIUJULUNUIAUDUKUIAUMUKUIPAACQUKUMUIABCUEZU
    FRTUMUIAUKUMUIPAABQUTRTUGUH $.

  $( The semantics of ` A. x y = z ` .  (Contributed by Wolf Lammen,
     27-Apr-2018.) $)
  wl-aleq $p |- ( A. x y = z <-> ( y = z /\ ( A. x x = y <-> A. x x = z ) ) )
    $=
    ( weq wal wb wa sp equequ2 alimi albi syl jca ax-8 al2imi a1dd ax12o impcom
    wi bija impbii ) BCDZAEZUBABDZAEZACDZAEZFZGUCUBUHUBAHUCUDUFFZAEUHUBUIABCAIJ
    UDUFAKLMUHUBUCUEUGUBUCSUEUGUCUBUDUFUBAABCNOPBCAQTRUA $.

  $( A tautological version of ~ nfth .  This convenience theorem allows easy
     replacement of ` F/ x ph ` antecedents with ` A. x ph ` , for example in
     ~ 19.9t .  (Contributed by Wolf Lammen, 19-Aug-2018.) $)
  wl-nftht $p |- ( A. x ph -> F/ x ph ) $=
    ( wal wn wo wnf orc nf4 sylibr ) ABCZJADBCZEABFJKGABHI $.

  $( The expression ` x = y ` in antecedent position plays an important role in
     predicate logic, namely in implicit substitution.  However, occasionally
     it is irrelevant, and can safely be dropped.  A sufficient condition for
     this is when ` x ` (or ` y ` or both) is not free in ` ph ` . ~ ax11b
     gives a different criterion.

     This theorem is more fundamental than ~ equsal , ~ spimt or ~ sbft , to
     which it is related.  (Contributed by Wolf Lammen, 19-Aug-2018.) $)
  wl-equsal1t $p |- ( F/ x ph -> ( A. x ( x = y -> ph ) <-> ph ) ) $=
    ( wnf weq wi wal wex a9e exim mpi 19.9t syl5ib nfr ax-1 alimi syl6 impbid )
    ABDZBCEZAFZBGZAUBABHZSAUBTBHUCBCITABJKABLMSAABGUBABNAUABATOPQR $.

  $( This simple equivalence eases substitution of one expression for the
     other.  (Contributed by Wolf Lammen, 1-Sep-2018.) $)
  wl-equsalcom $p |- ( A. x ( x = y -> ph ) <-> A. x ( y = x -> ph ) ) $=
    ( weq wi equcom imbi1i albii ) BCDZAECBDZAEBIJABCFGH $.

  ${
    wl-equsal1i.1 $e |- ( F/ x ph \/ F/ y ph ) $.
    wl-equsal1i.2 $e |- ( x = y -> ph ) $.
    $( The antecedent ` x = y ` is irrelevant, if one or both set variables are
       not free in ` ph ` .  (Contributed by Wolf Lammen, 1-Sep-2018.) $)
    wl-equsal1i $p |- ph $=
      ( wnf wo weq wi wal sp a7s wl-equsal1t syl5ib wl-equsalcom biimpd syl5bir
      gen2 spsd jaoi mp2 ) ABFZACFZGBCHAIZCJZBJZADUDBCERUBUFAIUCUFUDBJZUBAUDUGC
      BUGCKLABCMNUCUEABUECBHAICJZUCAACBOUCUHAACBMPQSTUA $.
  $}

  $( Substituting ` y ` for ` x ` and then ` z ` for ` y ` is equivalent to
     substituting ` z ` for both ` x ` and ` y ` .  The swapped order of the
     substitutions on the right side avoid a dependency on ~ ax-7 .
     (Contributed by Giovanni Mascellani, 8-Apr-2018.)  (Proof shortened by
     Wolf Lammen, 15-Sep-2018.) $)
  wl-sbcom3a $p |- ( [ z / y ] [ y / x ] ph <-> [ z / y ] [ z / x ] ph ) $=
    ( weq wal wsb wb nfa1 sbequ sps sbbid wn pm5.74i albii sb4b 3bitr4d pm2.61i
    wi a1i ) CDEZCFZABCGZCDGZABDGZCDGZHUBUCUECDUACIUAUCUEHCACDBJZKLUBMZUAUCSZCF
    ZUAUESZCFZUDUFUJULHUHUIUKCUAUCUEUGNOTUCCDPUECDPQR $.

  $( Substituting ` y ` for ` x ` and then ` z ` for ` y ` is equivalent to
     substituting ` z ` for both ` x ` and ` y ` .  (Contributed by Giovanni
     Mascellani, 8-Apr-2018.)  (Proof shortened by Wolf Lammen,
     15-Sep-2018.) $)
  wl-sbcom3 $p |- ( [ z / y ] [ y / x ] ph <-> [ z / x ] [ z / y ] ph ) $=
    ( wsb weq wal wb nfa1 sbequ sps sbbid wn pm5.74i albii sb4b 3bitr4d pm2.61i
    wi a1i sbcom bitri ) ABCEZCDEZABDEZCDEZACDEBDECDFZCGZUDUFHUHUCUECDUGCIUGUCU
    EHCACDBJZKLUHMZUGUCSZCGZUGUESZCGZUDUFULUNHUJUKUMCUGUCUEUINOTUCCDPUECDPQRABD
    CUAUB $.

$( (End of Wolf Lammen's mathbox.) $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Brendan Leahy
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  ${
    $d y ph $.  $d x A $.  $d x y $.
    $( Abstraction restricted to an indexed union.  (Contributed by Brendan
       Leahy, 26-Oct-2017.) $)
    rabiun $p |- { x e. U_ y e. A B | ph } = U_ y e. A { x e. B | ph }
        $=
      ( ciun crab cv wcel wa cab eliun anbi1i r19.41v bitr4i abbii df-rab iunab
      wrex 3eqtr4i wceq a1i iuneq2i eqtr4i ) ABCDEFZGZCDBHZEIZAJZBKZFZCDABEGZFU
      GUEIZAJZBKUICDSZBKUFUKUNUOBUNUHCDSZAJUOUMUPACUGDELMUHACDNOPABUEQUICBDRTCD
      ULUJULUJUACHDIABEQUBUCUD $.
  $}

  ${
    $d y A $.  $d y B $.  $d x y C $.
    $( Indexed union of class difference with the subtrahend held constant.
       (Contributed by Brendan Leahy, 6-Aug-2018.) $)
    iundif1 $p |- U_ x e. A ( B \ C ) = ( U_ x e. A B \ C ) $=
      ( vy cdif ciun cv wcel wrex wn wa r19.41v eldif rexbii eliun anbi1i eqriv
      3bitr4i ) EABCDFZGZABCGZDFZEHZTIZABJZUDUBIZUDDIKZLZUDUAIUDUCIUDCIZUHLZABJ
      UJABJZUHLUFUIUJUHABMUEUKABUDCDNOUGULUHAUDBCPQSAUDBTPUDUBDNSR $.
  $}

  ${
    $d x y z b v w a A $.  $d x y z b v w a B $.  $d x w a C $.
    $d z b v w a ph $.
    supadd.a1 $e |- ( ph -> A C_ RR ) $.
    supadd.a2 $e |- ( ph -> A =/= (/) ) $.
    supadd.a3 $e |- ( ph -> E. x e. RR A. y e. A y <_ x ) $.
    ${
      supaddc.b $e |- ( ph -> B e. RR ) $.
      supaddc.c $e |- C = { z | E. v e. A z = ( v + B ) } $.
      $( The supremum function distributes over addition in a sense similar to
         that in ~ supmul1 .  (Contributed by Brendan Leahy, 25-Sep-2017.) $)
      supaddc $p |- ( ph -> ( sup ( A , RR , < ) + B ) =
          sup ( C , RR , < ) ) $=
        ( vw va cr cle wbr wcel wrex clt csup caddc co wceq wn cv vex weq oveq1
        wral eqeq2d cbvrexv eqeq1 rexbidv syl5bb elab2 wa sselda wss wne suprcl
        c0 syl3anc adantr 3jca suprub sylan leadd1dd breq1 syl5ibrcom rexlimdva
        w3a syl5bi ralrimiv wb readdcld eleq1a syl ssrdv wex ovex isseti r19.2z
        wi rgenw sylancl exbii n0 rexcom4 3bitr4i sylibr ralbidv rspcev syl2anc
        breq2 suprleub syl31anc mpbird ltsubaddd biimpar resubcld suprlub mpbid
        cmin rspe adantl simplrr adantlr eqbrtrrd mpdan expr exlimdv mpi lenltd
        ad2antrr mtbird nrexdv pm2.65da eqleltd mpbir2and eqcomd ) AHPUAUBZFPUA
        UBZGUCUDZAYCYEUEYCYEQRZYCYEUARZUFAYFNUGZYEQRZNHUKZAYINHYHHSZYHOUGZGUCUD
        ZUEZOFTZAYIDUGZEUGZGUCUDZUEZEFTZYODYHHNUHYTYPYMUEZOFTDNUIZYOYSUUAEOFEOU
        IYRYMYPYQYLGUCUJULUMUUBUUAYNOFYPYHYMUNUOUPMUQZAYNYIOFAYLFSZURZYIYNYMYEQ
        RUUEYLYDGAFPYLIUSZAYDPSZUUDAFPUTZFVCVAZCUGBUGZQRCFUKBPTZUUGIJKBCFVBVDZV
        EAGPSZUUDLVEZAUUHUUIUUKVMUUDYLYDQRAUUHUUIUUKIJKVFBCFYLVGVHVIYHYMYEQVJVK
        VLVNVOZAHPUTZHVCVAZYHUUJQRZNHUKZBPTZYEPSZYFYJVPANHPYKYOAYHPSZUUCAYNUVBO
        FUUEYMPSZYNUVBWEUUEYLGUUFUUNVQZYMPYHVRVSVLVNVTZAYNNWAZOFTZUUQAUUIUVFOFU
        KUVGJUVFOFNYMYLGUCWBWCZWFUVFOFWDWGYKNWAYONWAUUQUVGYKYONUUCWHNHWIYNONFWJ
        WKWLZAUVAYJUUTAYDGUULLVQZUUOUUSYJBYEPUUJYEUEUURYINHUUJYEYHQWPWMWNWOZUVJ
        BNNHYEWQWRWSAYGYCGXEUDZYLUARZOFTZAYGURZUVLYDUARZUVNAUVPYGAYCGYDAUUPUUQU
        UTYCPSZUVEUVIUVKBNHVBVDZLUULWTXAAUVPUVNVPZYGAUUHUUIUUKUVLPSUVSIJKAYCGUV
        RLXBBCOFUVLXCWRVEXDUVOUVMOFUVOUUDURZUVMYCYMUARZUVTYMYCQRZUWAUFAUUDUWBYG
        UUEUVFUWBUVHUUEYNUWBNAUUDYNUWBAUUDYNURZURZYKUWBUWCYKAUWCYOYKYNOFXFUUCWL
        XGUWDYKURYHYMYCQAUUDYNYKXHAYKYHYCQRZUWCAUUPUUQUUTVMYKUWEAUUPUUQUUTUVEUV
        IUVKVFBNHYHVGVHXIXJXKXLXMXNXIUVTYMYCAUUDUVCYGUVDXIAUVQYGUUDUVRXPZXOXDUV
        TYCGYLUWFAUUMYGUUDLXPAUUDYLPSYGUUFXIWTXQXRXSAYCYEUVRUVJXTYAYB $.
    $}
    supadd.b1 $e |- ( ph -> B C_ RR ) $.
    supadd.b2 $e |- ( ph -> B =/= (/) ) $.
    supadd.b3 $e |- ( ph -> E. x e. RR A. y e. B y <_ x ) $.
    supadd.c $e |- C = { z | E. v e. A E. b e. B z = ( v + b ) } $.
    $( The supremum function distributes over addition in a sense similar to
       that in ~ supmul .  (Contributed by Brendan Leahy, 26-Sep-2017.) $)
    supadd $p |- ( ph -> ( sup ( A , RR , < ) + sup ( B , RR , < ) ) =
        sup ( C , RR , < ) ) $=
      ( va vw cr wrex clt csup caddc co wceq cle wbr cv cab wss wne wral suprcl
      c0 wcel syl3anc eqid supaddc wa sselda recnd adantr addcomd eqeq2d abbidv
      rexbidva supeq1d eqtrd vex eqeq1 rexbidv elab adantlr rspe oveq1 2rexbidv
      weq cbvrexv syl5bb elab2 sylibr ex sseld anim12d readdcl eleq1a rexlimdvv
      wi syl6 syl5bi ssrdv wex ovex isseti rgenw r19.2z sylancl sylib ralrimivw
      rexcom4 syl2anc n0 exbii bitri readdcld adantrr adantrl 3jca suprub sylan
      le2addd breq1 biimprcd ralrimiv breq2 ralbidv rspcev sylan9r wb rexlimdva
      w3a syl abssdv abn0 suprleub syl31anc mpbird eqbrtrd syl5ibrcom mpbir2and
      letri3d ) AFSUAUBZGSUAUBZUCUDZHSUAUBZUEYNYOUFUGYOYNUFUGZAYNDUHZYMQUHZUCUD
      ZUEZQFTZDUIZSUAUBZYOUFAYNYQYRYMUCUDZUEZQFTZDUIZSUAUBUUCABCDQFYMUUGJKLAGSU
      JZGUNUKZCUHBUHZUFUGZCGULBSTZYMSUOZMNOBCGUMUPZUUGUQURASUUGUUBUAAUUFUUADAUU
      EYTQFAYRFUOZUSZUUDYSYQUUPYRYMUUPYRAFSYRJUTZVAUUPYMAUUMUUOUUNVBZVAVCVDVFVE
      VGVHAUUCYOUFUGZRUHZYOUFUGZRUUBULZAUVARUUBUUTUUBUOUUTYSUEZQFTZAUVAUUAUVDDU
      UTRVIZDRVQZYTUVCQFYQUUTYSVJVKVLAUVCUVAQFUUPUVAUVCYSYOUFUGUUPYSYQYRIUHZUCU
      DZUEZIGTZDUIZSUAUBZYOUFUUPYSYQUVGYRUCUDZUEZIGTZDUIZSUAUBUVLUUPBCDIGYRUVPA
      UUHUUOMVBAUUIUUONVBAUULUUOOVBUUQUVPUQURUUPSUVPUVKUAUUPUVOUVJDUUPUVNUVIIGU
      UPUVGGUOZUSZUVMUVHYQUVRUVGYRUVRUVGAUVQUVGSUOZUUOAGSUVGMUTZVMZVAUVRYRUUPYR
      SUOZUVQUUQVBZVAVCVDVFVEVGVHUUPUVLYOUFUGZUVARUVKULZUUPUVARUVKUUTUVKUOUUTUV
      HUEZIGTZUUPUVAUVJUWGDUUTUVEUVFUVIUWFIGYQUUTUVHVJZVKVLUUOUWGUUTHUOZAUVAUUO
      UWGUWIUUOUWGUSUWGQFTZUWIUWGQFVNYQEUHZUVGUCUDZUEZIGTZEFTZUWJDUUTHUVEUWOUVJ
      QFTUVFUWJUWNUVJEQFEQVQZUWMUVIIGUWPUWLUVHYQUWKYRUVGUCVOVDVKVRUVFUVIUWFQIFG
      UWHVPVSPVTZWAWBAHSUJZHUNUKZUUTUUJUFUGZRHULZBSTZUWIUVAWHARHSUWIUWJAUUTSUOZ
      UWQAUWFUXCQIFGAUUOUVQUSZUVHSUOZUWFUXCWHAUXDUWBUVSUSUXEAUUOUWBUVQUVSAFSYRJ
      WCAGSUVGMWCWDYRUVGWEWIUVHSUUTWFWIWGWJWKZAUWJRWLZUWSAUWGRWLZQFTZUXGAFUNUKZ
      UXHQFULUXIKAUXHQFAUWFRWLZIGTZUXHAUUIUXKIGULUXLNUXKIGRUVHYRUVGUCWMZWNWOUXK
      IGWPWQUWFIRGWTWRWSUXHQFWPXAUWGQRFWTWRUWSUWIRWLUXGRHXBUWIUWJRUWQXCXDWAZAYN
      SUOZUUTYNUFUGZRHULZUXBAYLYMAFSUJZUXJUUKCFULBSTZYLSUOZJKLBCFUMUPZUUNXEZAUX
      PRHUWIUWJAUXPUWQAUWFUXPQIFGAUXDUVHYNUFUGZUWFUXPWHAUXDUYCAUXDUSYRUVGYLYMAU
      UOUWBUVQUUQXFAUVQUVSUUOUVTXGAUXTUXDUYAVBAUUMUXDUUNVBAUUOYRYLUFUGZUVQAUXRU
      XJUXSYAUUOUYDAUXRUXJUXSJKLXHBCFYRXIXJXFAUVQUVGYMUFUGZUUOAUUHUUIUULYAUVQUY
      EAUUHUUIUULMNOXHBCGUVGXIXJXGXKWBUWFUXPUYCUUTUVHYNUFXLXMWIWGWJXNZUXAUXQBYN
      SUUJYNUEUWTUXPRHUUJYNUUTUFXOXPXQXAZUWRUWSUXBYAUWIUVABRHUUTXIWBUPXRWJXNZUU
      PUVKSUJUVKUNUKZUWTRUVKULZBSTZYOSUOZUWDUWEXSUUPUVJDSUUPUVIYQSUOZIGUVRUXEUV
      IUYMWHUVRYRUVGUWCUWAXEUVHSYQWFYBXTYCAUYIUUOAUVJDWLZUYIAUVIDWLZIGTZUYNAUUI
      UYOIGULUYPNUYOIGDUVHUXMWNWOUYOIGWPWQUVIIDGWTWRUVJDYDWAVBUUPUYLUWEUYKAUYLU
      UOAUWRUWSUXBUYLUXFUXNUYGBRHUMUPZVBZUYHUYJUWEBYOSUUJYOUEZUWTUVARUVKUUJYOUU
      TUFXOZXPXQXAUYRBRRUVKYOYEYFYGYHUUTYSYOUFXLYIXTWJXNZAUUBSUJUUBUNUKZUWTRUUB
      ULZBSTZUYLUUSUVBXSAUUADSAYTUYMQFUUPYSSUOYTUYMWHUUPYMYRUURUUQXEYSSYQWFYBXT
      YCAUUADWLZVUBAYTDWLZQFTZVUEAUXJVUFQFULVUGKVUFQFDYSYMYRUCWMWNWOVUFQFWPWQYT
      QDFWTWRUUADYDWAAUYLUVBVUDUYQVUAVUCUVBBYOSUYSUWTUVARUUBUYTXPXQXAUYQBRRUUBY
      OYEYFYGYHAYPUXQUYFAUWRUWSUXBUXOYPUXQXSUXFUXNUYGUYBBRRHYNYEYFYGAYNYOUYBUYQ
      YKYJ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Theorem to move the floor function across a strict inequality.
       (Contributed by Brendan Leahy, 25-Oct-2017.) $)
    ltflcei $p |- ( ( A e. RR /\ B e. RR ) -> ( ( |_ ` A ) < B <->
        A < -u ( |_ ` -u B ) ) ) $=
      ( vx cr wcel wa clt wbr cle c1 caddc co wceq cz syl wi adantl wb adantr
      cc cfl cneg flltp1 ad3antrrr cv crio renegcl flval ad3antlr fllep1 reflcl
      peano2re letr mpd3an3 mpan2d leneg sylan2 sylibd ancoms ltneg sylan recnd
      ax-1cn cmin negdi2 oveq1d negcl npcan eqtr2d sylancl breq2d bitrd anim12d
      cfv biimpd ancomsd impl wreu peano2zd znegcld rebtwnz breq1 oveq1 anbi12d
      flcl riota2 syl2an ad2antrr mpbid eqtrd zcnd flcld negcon2 mpbird breqtrd
      peano2cn ex wn ltnle ceige ceicl zred ltletr sylbird ceim1l peano2rem w3a
      pm2.61d ltle 3adant2 3com13 mpand biimprd peano2zm syl2anr eqbrtrd lelttr
      syld flle 3coml impbida ) ADEZBDEZFZAUAVNZBGHZABUBZUAVNZUBZGHZYDYFFZBAIHZ
      YJYKYLYJYKYLFZAYEJKLZYIGYBAYNGHYCYFYLAUCUDYMYNYIMZYHYNUBZMZYMYHCUEZYGIHZY
      GYRJKLZGHZFZCNUFZYPYCYHUUCMZYBYFYLYCYGDEZUUDBUGZCYGUHOUIYMYPYGIHZYGYPJKLZ
      GHZFZUUCYPMZYDYFYLUUJYDYLYFUUJYDYLUUGYFUUIYCYBYLUUGPYCYBFZYLBYNIHZUUGUULY
      LAYNIHZUUMYBUUNYCAUJQYCYBYNDEZYLUUNFUUMPYBUUOYCYBYEDEZUUOAUKZYEULOZQBAYNU
      MUNUOYBYCUUOUUMUUGRUURBYNUPUQURUSYDYFUUIYDYFYGYEUBZGHZUUIYBUUPYCYFUUTRUUQ
      YEBUTVAYBUUTUUIRYCYBUUSUUHYGGYBYETEZJTEZUUSUUHMYBYEUUQVBVCUVAUVBFZUUHUUSJ
      VDLZJKLZUUSUVCYPUVDJKYEJVEVFUVAUUSTEUVBUVEUUSMYEVGUUSJVHVAVIVJVKSVLVOVMVP
      VQYDUUJUUKRZYFYLYBYPNEUUBCNVRZUVFYCYBYNYBYEAWEZVSVTYCUUEUVGUUFCYGWAOUUBUU
      JCNYPYRYPMZYSUUGUUAUUIYRYPYGIWBUVIYTUUHYGGYRYPJKWCVKWDWFWGWHWIWJYDYOYQRZY
      FYLYBYNTEZYHTEUVJYCYBUVAUVKYBYEUVHWKYEWPOYCYHYCYGUUFWLWKYNYHWMWGWHWNWOWQY
      DYLWRZYJPYFYDUVLABGHZYJABWSZYDUVMBYIIHZYJYCUVOYBBWTQYBYCYIDEZUVMUVOFYJPYC
      UVPYBYCYIBXAZXBZQABYIXCUNUOXDSXHYDYJFZYLYFUVSYLYFUVSYLFZYEYIJVDLZBGUVTYEY
      RAIHZAYTGHZFZCNUFZUWAYBYEUWEMYCYJYLCAUHUDUVTUWAAIHZAUWAJKLZGHZFZUWEUWAMZY
      DYJYLUWIYDYLYJUWIYDYLUWFYJUWHYDUWABGHZYLUWFYCUWKYBBXEZQYBYCUWADEZUWKYLFZU
      WFPZYCUWMYBYCUVPUWMUVRYIXFOQUWMYCYBUWOUWMYCYBXGUWNUWAAGHZUWFUWABAXCUWMYBU
      WPUWFPYCUWAAXIXJXRXKUNXLYCYJUWHPYBYCUWHYJYCUWGYIAGYCYITEUVBUWGYIMYCYIUVQW
      KVCYIJVHVJVKXMQVMVPVQYDUWIUWJRZYJYLYCUWANEZUWDCNVRUWQYBYCYINEUWRUVQYIXNOC
      AWAUWDUWICNUWAYRUWAMZUWBUWFUWCUWHYRUWAAIWBUWSYTUWGAGYRUWAJKWCVKWDWFXOWHWI
      WJYCUWKYBYJYLUWLUIXPWQYDUVLYFPYJYDUVLUVMYFUVNYDYEAIHZUVMYFYBUWTYCAXSSYBYC
      UUPUWTUVMFYFPZYBUUPYCUUQSUUPYBYCUXAYEABXQXTUNXLXDSXHYA $.

    $( Theorem to move the floor function across a non-strict inequality.
       (Contributed by Brendan Leahy, 25-Oct-2017.) $)
    leceifl $p |- ( ( A e. RR /\ B e. RR ) ->
          ( -u ( |_ ` -u A ) <_ B <-> A <_ ( |_ ` B ) ) ) $=
      ( cr wcel wa cfl cfv clt wbr wn cle wb ltflcei ancoms notbid reflcl lenlt
      cneg sylan2 ceicl zred sylan 3bitr4rd ) ACDZBCDZEZBFGZAHIZJZBARFGRZHIZJZA
      UGKIZUJBKIZUFUHUKUEUDUHUKLBAMNOUEUDUGCDUMUILBPAUGQSUDUJCDUEUNULLUDUJATUAU
      JBQUBUC $.

    $( Theorem to move floor function between strict and non-strict
       inequality.  (Contributed by Brendan Leahy, 25-Oct-2017.) $)
    lxflflp1 $p |- ( ( A e. RR /\ B e. RR ) -> ( ( |_ ` A ) <_ B <->
          A < ( ( |_ ` B ) + 1 ) ) ) $=
      ( vx cr wcel wa cfl cle wbr c1 caddc co clt cz wceq simplr adantr mpd3an3
      wi adantl cfv flltp1 ad3antrrr cv crio flval ad3antlr reflcl peano2re syl
      lttr ancoms mpan2d imp adantlr wb wreu rebtwnz breq1 oveq1 breq2d anbi12d
      riota2 syl2an ad2antrr mpbi2and eqtrd oveq1d breqtrrd ex wn lenlt sylbird
      flcl lelttr pm2.61d ad2antlr simpll flle simpr lelttrd ltled syl2anr letr
      eqbrtrd 3coml mpand impbida ) ADEZBDEZFZAGUAZBHIZABGUAZJKLZMIZWKWMFZBAMIZ
      WPWQWRWPWQWRFZAWLJKLZWOMWIAWTMIZWJWMWRAUBZUCWSWNWLJKWSWNCUDZBHIZBXCJKLZMI
      ZFZCNUEZWLWJWNXHOWIWMWRCBUFUGWSWMBWTMIZXHWLOZWKWMWRPWKWRXIWMWKWRXIWKWRXAX
      IWIXAWJXBQWJWIWRXAFXISZWJWIWTDEZXKWIXLWJWIWLDEZXLAUHZWLUIUJTBAWTUKRULUMUN
      UOWKWMXIFZXJUPZWMWRWIWLNEXGCNUQXPWJAVNCBURXGXOCNWLXCWLOZXDWMXFXIXCWLBHUSX
      QXEWTBMXCWLJKUTVAVBVCVDVEVFVGVHVIVJWKWRVKZWPSWMWKXRABHIZWPABVLZWKXSBWOMIZ
      WPWJYAWIBUBTWIWJWODEZXSYAFWPSWJYBWIWJWNDEZYBBUHZWNUIUJTABWOVORUMVMQVPWKWP
      FZWRWMYEWRWMYEWRFZWLWNBHYFWLXCAHIZAXEMIZFZCNUEZWNWIWLYJOWJWPWRCAUFUCYFWNA
      HIZWPYJWNOZWKWRYKWPWKWRFZWNAWJYCWIWRYDVQZWIWJWRVRZYMWNBAYNWIWJWRPYOWJWNBH
      IZWIWRBVSZVQWKWRVTWAWBUOWKWPWRPWKYKWPFZYLUPZWPWRWJWNNEYICNUQYSWIBVNCAURYI
      YRCNWNXCWNOZYGYKYHWPXCWNAHUSYTXEWOAMXCWNJKUTVAVBVCWCVEVFVGWJYPWIWPWRYQUGW
      EVJWKXRWMSWPWKXRXSWMXTWKWLAHIZXSWMWIUUAWJAVSQWIWJXMUUAXSFWMSZWIXMWJXNQXMW
      IWJUUBWLABWDWFRWGVMQVPWH $.

  $}

  ${
    $( Half-angle rule for sine.  (Contributed by Brendan Leahy,
       3-Aug-2018.) $)
    sin2h $p |- ( A e. ( 0 [,] ( 2 x. pi ) ) -> ( sin ` ( A / 2 ) ) =
      ( sqr ` ( ( 1 - ( cos ` A ) ) / 2 ) ) ) $=
      ( cc0 c2 cpi cmul co wcel cdiv cfv c1 ccos cmin cr sylancr cle wbr syl cc
      wceq 2cn cicc csin csqr wss 0re 2re pire remulcli iccssre mp2an rehalfcld
      sseli resincld 1re recoscl resubcl cneg cosbnd simprd wb subge0 halfnneg2
      bitr3d mpbid resqrcld w3a elicc2i clt 2pos pm3.2i ledivmul mp3an23 bicomd
      wa anbi12d cxr rehalfcl rexrd 0xr rexri elicc4 bitr4d biimpd 3impib sylbi
      mp3an12 sqrge0d cexp recnd ax-1cn coscl subcl halfcld sqsqrd halfcl caddc
      sinq12ge0 sqcld mulcom sylancl oveq2d mulid2i eqtri oveq1i syl6eq mp3an13
      df-2 subdir mulcl subsub3 3eqtr4d sincl pncand sincossq oveq1d eqtr3d wne
      cos2t 2ne0 divcan2 fveq2d eqtrd sincld divcan4 3eqtr2rd sq11d ) ABCDEFZUA
      FZGZACHFZUBIZJAKIZLFZCHFZUCIZYIYJYIAYHMABMGYGMGYHMUDUECDUFUGUHZBYGUIUJULZ
      UKUMYIAMGZYOMGYQYRYNYRYMYRJMGZYLMGZYMMGZUNAUOZJYLUPNZUKZYRYLJOPZBYNOPZYRJ
      UQYLOPUUEAURUSYRBYMOPZUUEUUFYRYSYTUUGUUEUTUNUUBJYLVANYRUUAUUGUUFUTUUCYMVB
      QVCVDZVEQYIYJBDUAFGZBYKOPYIYRBAOPZAYGOPZVFUUIBYGAUEYPVGYRUUJUUKUUIYRUUJUU
      KVNZUUIYRUULBYJOPZYJDOPZVNZUUIYRUUJUUMUUKUUNAVBYRUUNUUKYRDMGCMGZBCVHPZVNU
      UNUUKUTUGUUPUUQUFVIVJADCVKVLVMVOYRYJVPGZUUIUUOUTZYRYJAVQVRBVPGDVPGUURUUSV
      SDUGVTBDYJWAWFQWBWCWDWEYJWQQYIYRBYOOPYQYRYNUUDUUHWGQYIARGZYKCWHFZYOCWHFZS
      YIAYQWIUUTUVBYNUVACEFZCHFZUVAUUTYNUUTYMUUTJRGZYLRGYMRGWJAWKJYLWLNWMWNUUTU
      VCYMCHUUTUVCJCYJEFZKIZLFZYMUUTYJRGZUVCUVHSAWOZUVIJYJKIZCWHFZLFZCEFZJCUVLE
      FZJLFZLFZUVCUVHUVIJCEFZUVLCEFZLFZJJWPFZUVOLFZUVNUVQUVIUVTUVRUVOLFUWBUVIUV
      SUVOUVRLUVIUVLRGZCRGZUVSUVOSUVIUVKYJWKWRZTUVLCWSWTXAUVRUWAUVOLUVRCUWACTXB
      XGXCXDXEUVIUWCUVNUVTSZUWEUVEUWCUWDUWFWJTJUVLCXHXFQUVIUVORGZUVQUWBSZUVIUWD
      UWCUWGTUWECUVLXINUVEUWGUVEUWHWJWJJUVOJXJXFQXKUVIUVAUVMCEUVIUVAUVLWPFZUVLL
      FUVAUVMUVIUVAUVLUVIYKYJXLWRUWEXMUVIUWIJUVLLYJXNXOXPXOUVIUVGUVPJLYJXRXAXKQ
      UUTUVGYLJLUUTUVFAKUUTUWDCBXQZUVFASTXSACXTVLYAXAYBXOUUTUVARGZUVDUVASZUUTYK
      UUTYJUVJYCWRUWKUWDUWJUWLTXSUVACYDVLQYEQYF $.
    $( Half-angle rule for cosine.  (Contributed by Brendan Leahy,
       4-Aug-2018.) $)
    cos2h $p |- ( A e. ( -u pi [,] pi ) -> ( cos ` ( A / 2 ) ) =
      ( sqr ` ( ( 1 + ( cos ` A ) ) / 2 ) ) ) $=
      ( cpi co wcel c2 cdiv ccos cfv c1 caddc cr pire cc0 cle wbr wb wa cc wceq
      syl cneg cicc wss renegcli iccssre mp2an sseli rehalfcld recoscld readdcl
      csqr 1re sylancr cosbnd simpld recoscl subneg addcom ancoms eqtr4d syl2an
      cmin recn breq2d renegcl subge0 sylan2 halfnneg2 3bitr3d sylancl resqrcld
      mpbid w3a elicc2i clt 2re 2pos pm3.2i lediv1 mp3an13 wne recni 2cn divneg
      2ne0 mp3an breq1i syl6bbr mp3an23 anbi12d cxr rehalfcl rexrd rexri elicc4
      halfpire mp3an12 bitr4d biimpd 3impib sylbi cosq14ge0 sqrge0d cexp ax-1cn
      recnd cmul coscl addcl halfcld sqsqrd divcan2 fveq2d halfcl eqtr3d oveq2d
      cos2t oveq1d coscld sqcld mulcl mpan pncan3 divcan3 eqtrd 3eqtrrd sq11d )
      ABUAZBUBCZDZAEFCZGHZIAGHZJCZEFCZUKHZYJYKYJAYIKAYHKDZBKDZYIKUCBLUDZLYHBUEU
      FUGZUHUIYJYOYJYNYJIKDZYMKDZYNKDZULYJAYTUIIYMUJZUMUHZYJAKDZMYONOZYTUUFIUAZ
      YMNOZUUGUUFUUIYMINOAUNUOUUFUUBUUAUUIUUGPAUPULUUBUUAQZMYMUUHVBCZNOZMYNNOZU
      UIUUGUUJUUKYNMNUUBYMRDZIRDZUUKYNSUUAYMVCIVCUUNUUOQUUKYMIJCZYNYMIUQUUOUUNY
      NUUPSIYMURUSUTVAVDUUAUUBUUHKDUULUUIPIVEYMUUHVFVGUUJUUCUUMUUGPUUAUUBUUCUUD
      USYNVHTVIVJVLTZVKYJYKBEFCZUAZUURUBCDZMYLNOYJUUFYHANOZABNOZVMUUTYHBAYSLVNU
      UFUVAUVBUUTUUFUVAUVBQZUUTUUFUVCUUSYKNOZYKUURNOZQZUUTUUFUVAUVDUVBUVEUUFUVA
      YHEFCZYKNOZUVDYQUUFEKDZMEVOOZQZUVAUVHPYSUVIUVJVPVQVRZYHAEVSVTUUSUVGYKNBRD
      ERDZEMWAZUUSUVGSBLWBWCWEBEWDWFWGWHUUFYRUVKUVBUVEPLUVLABEVSWIWJUUFYKWKDZUU
      TUVFPZUUFYKAWLWMUUSWKDUURWKDUVOUVPUUSUURWPUDWNUURWPWNUUSUURYKWOWQTWRWSWTX
      AYKXBTYJYOUUEUUQXCYJARDZYLEXDCZYPEXDCZSYJAYTXFUVQUVSYOIEUVRXGCZIVBCZJCZEF
      CZUVRUVQYOUVQYNUVQUUOUUNYNRDXEAXHIYMXIUMXJXKUVQYNUWBEFUVQYMUWAIJUVQEYKXGC
      ZGHZYMUWAUVQUWDAGUVQUVMUVNUWDASWCWEAEXLWIXMUVQYKRDUWEUWASAXNZYKXQTXOXPXRU
      VQUVRRDZUWCUVRSUVQYLUVQYKUWFXSXTUWGUWCUVTEFCZUVRUWGUWBUVTEFUWGUUOUVTRDZUW
      BUVTSXEUVMUWGUWIWCEUVRYAYBIUVTYCUMXRUWGUVMUVNUWHUVRSWCWEUVREYDWIYETYFTYG
      $.
    $( Half-angle rule for tangent.  (Contributed by Brendan Leahy,
       4-Aug-2018.) $)
    tan2h $p |- ( A e. ( 0 [,) pi ) -> ( tan ` ( A / 2 ) ) =
      ( sqr ` ( ( 1 - ( cos ` A ) ) / ( 1 + ( cos ` A ) ) ) ) ) $=
      ( cc0 cpi co wcel c2 cdiv cfv c1 cc wceq cr cxr pire cle wbr clt wb syl
      wa cico ctan ccos cmin csqr caddc wne wss rexri icossre mp2an sseli recnd
      csin 0re halfcld cre cneg cioo rehalfcld rered elico2 pipos lt0neg2 ax-mp
      w3a mpbi wi renegcli ltletr mp3an12 mpani 2re pm3.2i ltdiv1 mp3an13 recni
      2pos 2cn 2ne0 divneg mp3an breq1i syl6bbr sylibd mp3an23 anim12d rehalfcl
      biimpd rexrd halfpire elioo5 sylibrd 3impib eqeltrd cosne0 syl2anc tanval
      sylbi cmul cicc 0xr elico1 remulcli ltmulgt12 xrlttr mp3an2 mpan2i xrltle
      1lt2 syld mpan2 anim2d elicc4 sin2h ltleii le0neg2 xrletr cos2h eqtrd 1re
      oveq12d resubcl sylancr cosbnd simprd recoscl subge0 bitr3d mpbid sylancl
      recoscld halfnneg2 coscld ax-1cn syl6eqr a1i cexp 0cn sqcld simpld subneg
      readdcl recn addcom breq2d csn cun snunioo eleq2i elun bitr3i elsni fveq2
      cos0 syl6eq oveq2d df-2 eqnetrd sinq12gt0 ltne mpan elioore df-neg eqeq1i
      oveq1 coscl subadd syl5bb sincl addcan2d sincossq sqneg sq1 eqtri addid2d
      wo eqeq12d sqeq0 3bitr3d 3imtr3d necon3d syl5 mpd ne0gt0d elrpd rphalfcld
      jaoi sqrdivd subcl addcl divcan7 mp3an3 syl12anc fveq2d 3eqtr2d ) ABCUADZ
      EZAFGDZUBHZIAUCHZUDDZFGDZUEHZIUXAUFDZFGDZUEHZGDZUXCUXFGDZUEHUXBUXEGDZUEHU
      WRUWTUWSUNHZUWSUCHZGDZUXHUWRUWSJEZUXLBUGZUWTUXMKUWRAUWRAUWQLABLEZCMEZUWQL
      UHUOCNUIZBCUJUKULZUMZUPZUWRUXNUWSUQHZCFGDZURZUYCUSDZEUXOUYAUWRUYBUWSUYEUW
      RUWSUWRAUXSUTVAUWRALEZBAOPZACQPZVFZUWSUYEEZUXPUXQUWRUYIRUOUXRBCAVBUKUYFUY
      GUYHUYJUYFUYGUYHTZUYDUWSQPZUWSUYCQPZTZUYJUYFUYGUYLUYHUYMUYFUYGCURZAQPZUYL
      UYFUYOBQPZUYGUYPBCQPZUYQVCCLEZUYRUYQRNCVDVEVGUYOLEZUXPUYFUYQUYGTUYPVHCNVI
      ZUOUYOBAVJVKVLUYFUYPUYOFGDZUWSQPZUYLUYTUYFFLEZBFQPZTZUYPVUCRVUAVUDVUEVMVR
      VNZUYOAFVOVPUYDVUBUWSQCJEFJEZFBUGZUYDVUBKCNVQVSVTCFWAWBWCWDWEUYFUYHUYMUYF
      UYSVUFUYHUYMRNVUGACFVOWFWIWGUYFUWSMEZUYJUYNRZUYFUWSAWHWJUYDMEUYCMEVUJVUKU
      YDUYCWKVIUIUYCWKUIUYDUYCUWSWLVKSWMWNWSWOUWSWPWQUWSWRWQUWRUXKUXDUXLUXGGUWR
      ABFCWTDZXADEZUXKUXDKUWRAMEZUYGUYHVFZVUMBMEZUXQUWRVUORXBUXRBCAXCUKZVUNUYGU
      YHVUMVUNUYKUYGAVULOPZTZVUMVUNUYHVURUYGVUNVULMEZUYHVURVHVULFCVMNXDUIZVUNVU
      TTZUYHAVULQPZVURVVBUYHCVULQPZVVCIFQPZVVDXJUYSVUDUYRVVEVVDRNVMVCCFXEWBVGVU
      NUXQVUTUYHVVDTVVCVHUXRACVULXFXGXHAVULXIXKXLXMVUPVUTVUNVUMVUSRXBVVABVULAXN
      VKWMWNWSAXOSUWRAUYOCXADEZUXLUXGKUWRVUOVVFVUQVUNUYGUYHVVFVUNUYKUYOAOPZACOP
      ZTZVVFVUNUYGVVGUYHVVHVUNUYOBOPZUYGVVGBCOPZVVJBCUONVCXPUYSVVKVVJRNCXQVEVGU
      YOMEZVUPVUNVVJUYGTVVGVHUYOVUAUIZXBUYOBAXRVKVLVUNUXQUYHVVHVHUXRACXIXLWGVVL
      UXQVUNVVFVVIRVVMUXRUYOCAXNVKWMWNWSAXSSYBXTUWRUXCUXFUWRUXBUWRILEZUXALEZUXB
      LEZYAUWRAUXSYLZIUXAYCZYDUTUWRUYFBUXCOPZUXSUYFUXAIOPZVVSUYFIURZUXAOPZVVTAY
      EZYFUYFVVNVVOVVTVVSRYAAYGZVVNVVOTZBUXBOPZVVTVVSIUXAYHVWEVVPVWFVVSRVVRUXBY
      MSYIYDYJSUWRUXEUWRUXEUWRVVNVVOUXELEYAVVQIUXAUUCYDZUWRUXEVWGUWRUYFBUXEOPZU
      XSUYFVWBVWHUYFVWBVVTVWCUUAUYFBUXAVWAUDDZOPZVWBVWHUYFVVOVWALEVWJVWBRVWDIYA
      VIUXAVWAYHYKUYFVWIUXEBOUYFUXAJEZIJEZVWIUXEKUYFAAUUDYNYOVWKVWLTVWIUXAIUFDU
      XEUXAIUUBUXAIUUEXTYKUUFYIYJSUWRABUUGZEZABCUSDZEZUVQZUXEBUGZUWRAVWMVWOUUHZ
      EVWQVWSUWQAVUPUXQUYRVWSUWQKXBUXRVCBCUUIWBUUJAVWMVWOUUKUULVWNVWRVWPVWNABKZ
      VWRABUUMVWTUXEFBVWTUXEIIUFDFVWTUXAIIUFVWTUXABUCHIABUCUUNUUOUUPUUQUURYPVUI
      VWTVTYQUUSSVWPBAUNHZQPZVWRAUUTVXBVXABUGZVWPVWRUXPVXBVXCUOBVXAUVAUVBVWPUXE
      BVXABVWPAJEZUXEBKZVXABKZVHVWPAABCUVCUMVXDVWAUXAKZVWAFYRDZUXAFYRDZKZVXEVXF
      VXGVXJVHVXDVWAUXAFYRUVFYQVXGBIUDDZUXAKZVXDVXEVWAVXKUXAIUVDUVEVXDVWKVXLVXE
      RZAUVGZBJEZVWLVWKVXMYSYOBIUXAUVHVKSUVIVXDVXAFYRDZVXIUFDZBVXIUFDZKVXPBKZVX
      JVXFVXDVXPBVXIVXDVXAAUVJZYTVXOVXDYSYQVXDUXAVXNYTZUVKVXDVXQVXHVXRVXIVXDVXQ
      IVXHAUVLVXHIFYRDZIVWLVXHVYBKYOIUVMVEUVNUVOYPVXDVXIVYAUVPUVRVXDVXAJEVXSVXF
      RVXTVXAUVSSUVTUWASUWBUWCUWDUWHWSZUWEUWFUWGUWIUWRUXIUXJUEUWRUXBJEZUXEJEZVW
      RUXIUXJKZUWRVWLVWKVYDYOUWRAUXTYNZIUXAUWJYDUWRVWLVWKVYEYOVYGIUXAUWKYDVYCVY
      DVYEVWRTVUHVUITVYFVUHVUIVSVTVNUXBUXEFUWLUWMUWNUWOUWP $.
  $}

  ${
    $d b c d f g p s w x y z ph $.  $d b c d f g p s w x y z C $.
    $d b c d f g p s w x y z D $.  $d b c d f g p s w x y z X $.
    $d b c d f g p s w x y z Y $.
    heicant.c $e |- ( ph -> C e. ( *Met ` X ) ) $.
    heicant.d $e |- ( ph -> D e. ( *Met ` Y ) ) $.
    heicant.j $e |- ( ph -> ( MetOpen ` C ) e. Comp ) $.
    heicant.x $e |- ( ph -> X =/= (/) ) $.
    heicant.y $e |- ( ph -> Y =/= (/) ) $.
    $( Heine-Cantor theorem: a continuous mapping between metric spaces whose
       domain is compact is uniformly continuous.  Theorem on [Rosenlicht]
       p. 80.  (Contributed by Brendan Leahy, 13-Aug-2018.) $)
    heicant $p |- ( ph -> ( ( metUnif ` C ) uCn ( metUnif ` D ) ) =
      ( ( MetOpen ` C ) Cn ( MetOpen ` D ) ) ) $=
      ( vx co clt wbr wi wral crp wa wcel adantr vf vw vz vd vy vs vg vb vc cfv
      vp cmetu cmopn cv wrex weq breq2 imbi2d 2ralbidv rexbidv cbvralv rphalfcl
      wf c2 cdiv wceq ralbidv rspcva cuni c1st c2nd caddc cfn wel ad3antrrr cxr
      cxmt ad2antrr anim1i rpxrd eqid 3expa syl2an sylan2 adantll rpcn 2halvesd
      cc0 imbi1d oveq2 breq1d fveq2 oveq2d imbi12d syl6bb oveq12d oveq1d fveq2d
      vex breq12d rspcev syl2anc eleq2 anbi12d ex rexlimdva imp wb syl mpbid cr
      crn simpll wss syl6ss adantl wne simplr cen breqtrd sylan syl3anc nfv cle
      c0 ad2ant2r xmetcl 3expb rexrd simpr ffvelrnda ffvelrn xrltle mpd xmetge0
      rpred xrrege0 mpand syld cxad ccn r19.12 ralimi sylbi cxp cbl wex cpw cin
      cucn ccmp blopn rpgt0d jca xblcntr cop opelxpi breq2d biimpar ovex op1std
      op2ndd eqcomd bitr3d eqeq1 anbi1d syl12anc mopnuni raleqdv eqeq2d cmpcovf
      biantrurd ralimdva inss2 sseli ccnv csup frn rnss rnxpss cdm wfun fundmen
      ffun ensymd fdm enfii rnfi 3syl eqtr eqnetrrd uni0 syl6eq necon3i eqnetrd
      unieq dm0rn0 necon3bii sylib wrel relxp relss ee10 relrn0 adantllr rpssre
      necon3bid wor w3a ltso cnvso mpbi fisupcl mpan sseldd simpl eleq2d eluni2
      sylanl1 biimpa nfra1 nfan rsp anim12i anandirs adantrl adantlll 0re rpge0
      prth rgen breq1 sylancr wfn ffn fnfvelrn 2ndrn infmrlb ne0i infmrcl xp2nd
      ssralv xrltletr mpan2d adantlr ad6antr simpllr ad3antlr ad5antr sylan9bbr
      xp1st elbl biimpd an32s impr simprd simplrl an4s mp2and readdcld rpaddcld
      xmettri syl13anc rexadd lt2addd xrlelttrd ltaddrpd xrlttrd jctild anassrs
      anim12dan simp-5r ffvelrnd adantrr ad4antlr readdcl anandis rpxr ad6antlr
      xmetsym eqtrd lt2add expcom syl2and pm2.43d imim12d adantlrr expr rexlimd
      exp32 ralrimivva expl exlimdv expimpd syl5 exp4b ralrimiv r19.21v impbid2
      mpdi ralcom pm5.32da cpsmet xmetpsmet metucn metcn 3bitr4d eqrdv ) AUABUL
      UJZCULUJZUUJLZBUMUJZCUMUJZUUALZADEUAUNZVCZKUNZUBUNZBLZUCUNZMNZVXQVXOUJZVX
      RVXOUJZCLZUDUNZMNZOZUBDPKDPZUCQUOZUDQPZRVXPVYAVYDUEUNZMNZOZUBDPZUCQUOZUEQ
      PKDPZRZVXOVXKSVXOVXNSZAVXPVYJVYPAVXPRZVYJVYOKDPZUEQPZVYPVYSVYJWUAVYJVYNKD
      PZUCQUOZUEQPWUAVYIWUCUDUEQUDUEUPZVYHWUBUCQWUDVYGVYMKUBDDWUDVYFVYLVYAVYEVY
      KVYDMUQURUSUTVAWUCVYTUEQVYNUCKQDUUBUUCUUDVYSWUAVYIOZUDQPWUAVYJOVYSWUEUDQV
      YSVYEQSZVYEVDVELZQSZWUEVYEVBZVYSWUFWUHWUAVYIWUHWUARVYAVYDWUGMNZOZUBDPZUCQ
      UOZKDPZVYSWUFRZVYIVYTWUNUEWUGQVYKWUGVFZVYOWUMKDWUPVYNWULUCQWUPVYMWUKUBDWU
      PVYLWUJVYAVYKWUGVYDMUQURVGUTVGVHWUOWUNVXLVIZUFUNZVIZVFZWURDQUUEZUGUNZVCZU
      HUNZWVDWVBUJZVJUJZWVEVKUJZBUUFUJZLZVFZWVFUIUNZBLZWVGWVGVLLZMNZWVFVXOUJZWV
      KVXOUJZCLZWUGMNZOZUIDPZRZUHWURPZRZUGUUGZRZUFVXLUUHZVMUUIZUOZVYIWUOWUNWWHW
      UOWUNRZVXLUUKSZKUHVNZWVDUKUNZVJUJZWWLVKUJZWVHLZVFZWWMWVKBLZWWNWWNVLLZMNZW
      WMVXOUJZWVPCLZWUGMNZOZUIDPZRZUKWVAUOZRZUHVXLUOZKWUQPZWWHAWWJVXPWUFWUNHVOW
      WIWXHKDPZWXIWUOWUNWXJWUOWUMWXHKDWUOVXQDSZRZWULWXHUCQWXLVXTQSZRZWULWXHWXNW
      ULRZVXQVXTVDVELZWVHLZVXLSZVXQWXQSZWXQWWOVFZWXDRZUKWVAUOZWXHWXNWXRWULWXLBD
      VQUJSZWXKRZWXPVPSZWXRWXMWUOWYCWXKAWYCVXPWUFFVRVSZWXMWXPVXTVBZVTZWYCWXKWYE
      WXRBVXQWXPVXLDVXLWAZUULWBWCTWXNWXSWULWXLWYDWYEWHWXPMNZRZWXSWXMWYFWXMWYEWY
      JWYHWXMWXPWYGUUMUUNWYCWXKWYKWXSBVXQWXPDUUOWBWCTWXOVXQWXPUUPZWVASZVXQWVKBL
      ZWXPWXPVLLZMNZVYBWVPCLZWUGMNZOZUIDPZWYBWXNWYMWULWXKWXMWYMWUOWXMWXKWXPQSWY
      MWYGVXQWXPDQUUQWDWETWXMWULWYTWXLWXMWYTWULWXMWYTWYNVXTMNZWYROZUIDPWULWXMWY
      SXUBUIDWXMWYPXUAWYRWXMWYOVXTWYNMWXMVXTVXTWFWGUURWIVGXUBWUKUIUBDUIUBUPZXUA
      VYAWYRWUJXUCWYNVXSVXTMWVKVXRVXQBWJWKXUCWYQVYDWUGMXUCWVPVYCVYBCWVKVXRVXOWL
      ZWMWKWNVAWOUUSWEWYAWYTUKWYLWVAWWLWYLVFZWXDWYAWYTXUEWXTWXDXUEWWOWXQXUEWWMV
      XQWWNWXPWVHVXQWXPWWLKWSZVXTVDVEUUTZUVAZVXQWXPWWLXUFXUGUVBZWPUVCUVLXUEWXCW
      YSUIDXUEWWSWYPWXBWYRXUEWWQWYNWWRWYOMXUEWWMVXQWVKBXUHWQXUEWWNWXPWWNWXPVLXU
      IXUIWPWTXUEWXAWYQWUGMXUEWWTVYBWVPCXUEWWMVXQVXOXUHWRWQWKWNVGUVDXAXBWXGWXSW
      YBRUHWXQVXLWVDWXQVFZWWKWXSWXFWYBWVDWXQVXQXCXUJWXEWYAUKWVAXUJWWPWXTWXDWVDW
      XQWWOUVEUVFUTXDXAUVGXEXFUVMXGAWXJWXIXHVXPWUFWUNAWXHKDWUQAWYCDWUQVFZFBVXLD
      WYIUVHXIZUVIVOXJWXEWWAKUHUKWVAUGVXLWUQUFWUQWAWWLWVEVFZWWPWVJWXDWVTXUMWWOW
      VIWVDXUMWWMWVFWWNWVGWVHWWLWVEVJWLZWWLWVEVKWLZWPUVJXUMWXCWVSUIDXUMWWSWVNWX
      BWVRXUMWWQWVLWWRWVMMXUMWWMWVFWVKBXUNWQXUMWWNWVGWWNWVGVLXUOXUOWPWTXUMWXAWV
      QWUGMXUMWWTWVOWVPCXUMWWMWVFVXOXUNWRWQWKWNVGXDUVKXBXEWUOWWEVYIUFWWGWURWWGS
      WUOWURVMSZWWEVYIOWWGVMWURWWFVMUVNUVOWUOXUPRZWUTWWDVYIXUQWUTRZWWCVYIUGXURW
      VCWWBVYIXURWVCRZWWBRZWVBXLZXLZXKMUVPZUVQZQSZVXSXVDMNZVYFOZUBDPKDPZVYIXUSX
      VEWWBXUQAXUPRZWUTWVCXVEWUOAXUPAVXPWUFXMVSXVIWUTRZWVCRZXVBQXVDWVCXVBQXNZXV
      JWVCXVBWVAXLZQWVCXVAWVAXNZXVBXVMXNWURWVAWVBUVRZXVAWVAUVSXIDQUVTXOZXPZXVKX
      VBVMSZXVBYEXQZXVBXKXNZXVDXVBSZXVJXUPWVCXVRAXUPWUTXRXUPWVCRWVBVMSZXVAVMSXV
      RWVCXUPWVBWURXSNXWBWVCWVBWVBUWAZWURXSWVCWVBUWBZWVBXWCXSNWURWVAWVBUWDXWDXW
      CWVBWVBUGWSUWCUWEXIWURWVAWVBUWFZXTWVBWURUWGWDWVBUWHXVAUWHUWIYAAWUTWVCXVSX
      UPAWUTRZWVCRZXVAYEXQZXVSXWGXWCYEXQXWHXWGXWCWURYEWVCXWCWURVFXWFXWEXPXWFWUR
      YEXQZWVCXWFWUSYEXQXWIXWFDWUSYEAXUKWUTDWUSVFXULDWUQWUSUWJZYAADYEXQWUTITUWK
      WURYEWUSYEWURYEVFWUSYEVIYEWURYEUWPUWLUWMUWNXITUWOXWCYEXVAYEWVBUWQUWRUWSWV
      CXWHXVSXHZXWFWVCXVAUWTZXWKWVCXVNWVAUWTXWLXVODQUXAXVAWVAUXBUXCZXWLXVAYEXVB
      YEXVAUXDUXGXIXPXJUXEXVKXVBQXKXVQUXFXOXKXVCUXHZXVRXVSXVTUXIXWAXKMUXHXWNUXJ
      XKMUXKUXLXKXVBXVCUXMUXNYBUXOUXSTXUTXVGKUBDDXUTWXKVXRDSZRZRZWWKUHWURUOZXVG
      XUTXUKWUTRZWXKXWRXWPXURXWSWVCWWBXUQXUKWUTAXUKVXPWUFXUPXULVOVSVRWXKXWOUXPZ
      XWSWXKXWRXWSWXKVXQWUSSXWRXWSDWUSVXQXWJUXQUHVXQWURUXRWOUXTWCXWQWWKXVGUHWUR
      XUTXWPUHXUSWWBUHXUSUHYCWWAUHWURUYAUYBXWPUHYCUYBXVGUHYCXUSXWPWWBUHUFVNZWWK
      XVGOZOZXUSXWPRZWWBRXXAXXBXXDWWBXXAXXCWWBXXARXXDWWAXXCWWBXXAWWAWWAUHWURUYC
      XGXXDWWARZXXAWWKXVGXXEXXAWWKRZRWVFVXQBLZWVMMNZWVFVXRBLZWVMMNZRZWVOVYBCLZW
      UGMNZWVOVYCCLZWUGMNZRZOZXVGXWPWWAXXFXXQXUSXWPWWARXXQXXFXWPWVTXXQWVJXWPWVT
      RXXHXXMOZXXJXXOOZRZXXQWXKXWOWVTXXTWXKWVTRXXRXWOWVTRXXSWVSXXRUIVXQDUIKUPZW
      VNXXHWVRXXMXYAWVLXXGWVMMWVKVXQWVFBWJWKXYAWVQXXLWUGMXYAWVPVYBWVOCWVKVXQVXO
      WLWMWKWNVHWVSXXSUIVXRDXUCWVNXXJWVRXXOXUCWVLXXIWVMMWVKVXRWVFBWJWKXUCWVQXXN
      WUGMXUCWVPVYCWVOCXUDWMWKWNVHUYDUYEXXHXXMXXJXXOUYJXIUYFTUYGXXDWVJXXFXXQXVG
      OZWVTXXDWUOWVCRZXWPRZWVJXXFXYBXUSXYCXWPXURWUOWVCWUOXUPWUTXMVSVSXYDWVJRZXX
      FRZXVFXXKXXPVYFXYFXVFVXSWVGMNZXXKXYDXXFXVFXYGOWVJXYDXXFRZXVFXVDWVGYDNZXYG
      XYCXXAXYIXWPWWKWVCXXAXYIWUOWVCXXARZXVTVXQVYKYDNZUEXVBPZKXKUOZWVGXVBSZXYIW
      VCXVTXXAWVCXVBQXKXVPUXFXOTZWVCXYMXXAWVCWHXKSWHVYKYDNZUEXVBPZXYMUYHWVCXVLX
      YPUEQPXYQXVPXYPUEQVYKUYIUYKXYPUEXVBQVUBUXCXYLXYQKWHXKVXQWHVFXYKXYPUEXVBVX
      QWHVYKYDUYLVGXAUYMTZXYJXWLWVEXVASZXYNWVCXWLXXAXWMTWVCWVBWURUYNXXAXYSWURWV
      AWVBUYOWURWVDWVBUYPYAWVEXVAUYQXBZKUEWVGXVBUYRYBWEYFXYHVXSVPSZXVDVPSZWVGVP
      SZXVFXYIRXYGOXYDYUAXXFXYCWYCXWPYUAAWYCVXPWUFWVCFVOZWYCWXKXWOYUAVXQVXRBDYG
      YHYATZXYDWVCXXAYUBXXFWUOWVCXWPXRZXXAWWKUXPZXYJXVDXYJXVTXVSXYMXVDXKSXYOXYJ
      XYNXVSXYTXVBWVGUYSXIXYRKUEXVBUYTYBYIWCXYCXXAYUCXWPWWKXYCXXARZWVGYUHWVEWVA
      SZWVGQSZXYCWURWVAWVDWVBWUOWVCYJYKWVEDQVUAZXIZVTYFZVXSXVDWVGVUCYBVUDVUEXYF
      XYGXXJXXHXYFXYGXXJXYFXYGRZXXIXXGVXSVLLZWVMXYFXXIVPSZXYGXYFWYCWVFDSZXWOYUP
      AWYCVXPWUFWVCXWPWVJXXFFVUFZXYEWVCXXAYUQXXFWUOWVCXWPWVJVUGZYUGXYJYUIYUQWUR
      WVAWVDWVBYLZWVEDQVUKZXIZWCZXWPXWOXYCWVJXXFWXKXWOYJVUHZWVFVXRBDYGYBTYUNYUO
      YUNXXGVXSXYFXXGXKSZXYGXYFWVGXKSZXXGWVGYDNZYVEXYFWVGXYDXXAYUJWVJWWKXYDWVCX
      XAYUJYUFXYJYUIYUJYUTYUKXIZYAZYFZYPZXYFXXGWVGMNZYVGXYFWXKYVLXYEXXAWWKWXKYV
      LRZXYDXXAWVJWWKYVMOXYDXXARZWVJRWWKYVMWVJWWKVXQWVISZYVNYVMWVDWVIVXQXCYVNWY
      CYUQYUCYVOYVMXHAWYCVXPWUFWVCXWPXXAFVUIZXYDWVCXXAYUQYUFYVBYAYVNWVGYVIVTVXQ
      BWVFWVGDVULYBVUJVUMVUNVUOVUPZXYFXXGVPSZYUCYVLYVGOXYFWYCYUQWXKYVRYURYVCXWP
      WXKXYCWVJXXFXWTVUHZWVFVXQBDYGZYBZXYEWVCXXAYUCXXFYUSYUGXYJWVGYVHVTWCZXXGWV
      GYMXBYNXYDXXAYVFYVGRZYVEOZWVJWWKYVNYVRWHXXGYDNZYWDYVNWYCYUQWXKYVRYVPYVNYU
      IYUQXYDWURWVAWVDWVBYUFYKYVAXIZXYCWXKXWOXXAVUQZYVTYBYVNWYCYUQWXKYWEYVPYWFY
      WGWVFVXQBDYOYBYVRYWERYWCYVEYVRYVFYWEYVGYVEXXGWVGYQVURXEXBYFVUSTZXYFXYGVXS
      XKSZXYDXXFXYGYWIOWVJXYHXYGVXSWVGYDNZYWIXYHYUAYUCXYGYWJOYUEYUMVXSWVGYMXBXY
      HWHVXSYDNZYWJYWIXYDYWKXXFXYCWYCXWPYWKYUDWYCWXKXWOYWKVXQVXRBDYOYHYATXYHYUA
      YVFYWKYWJRZYWIOYUEXYCXXAYVFXWPWWKYUHWVGYULYPYFYUAYVFRYWLYWIVXSWVGYQXEXBYR
      YSVUEXGZVUTYIXYFWVMVPSXYGXYFWVMXYFWVGWVGYVJYVJVVAVTZTYUNXXIXXGVXSYTLZYUOY
      DXYFXXIYWOYDNZXYGXYFWYCYUQXWOWXKYWPYURYVCYVDYVSWVFVXRVXQBDVVBVVCTYUNYVEYW
      IYWOYUOVFYWHYWMXXGVXSVVDXBXTYUNXXGVXSWVGWVGYWHYWMXYFYVFXYGYVKTZYWQXYFYVLX
      YGYVQTXYFXYGYJVVEVVFXEXYFXXGWVGWVMYWAYWBYWNYVQXYEWVCXXAWVGWVMMNXXFYUSYUGX
      YJWVGWVGXYJWVGYVHYPYVHVVGWCVVHVVIYSXYFXXPVYFXYFXXPRZVYDXXLXXNVLLZVYEXYDVY
      DVPSZWVJXXFXXPXYCVYSXWPYWTVYSWUFWVCXMAVXPXWPYWTACEVQUJSZVYBESZVYCESZRYWTV
      XPXWPRGVXPWXKYXBXWOYXCDEVXQVXOYLDEVXRVXOYLVVKYXAYXBYXCYWTVYBVYCCEYGYHWCVV
      JYAVOYWRYWSXYFXXMXXOYWSXKSZXYFXXMRZXXLXKSZXXNXKSZYXDXYFXXORZXYFXXMYXFXYDX
      XAXXMYXFOWVJWWKYVNXXMXXLWUGYDNZYXFYVNXXLVPSZWUGVPSZXXMYXIOYVNYXAWVOESZYXB
      YXJAYXAVXPWUFWVCXWPXXAGVUIZYVNDEWVFVXOAVXPWUFWVCXWPXXAVVLYWFVVMZXYDYXBXXA
      XYCWXKYXBXWOXYCDEVXQVXOAVXPWUFWVCVUGZYKVVNTZWVOVYBCEYGYBZWUFYXKVYSWVCXWPX
      XAWUFWUGWUIVTVVOZXXLWUGYMXBYVNWHXXLYDNZYXIYXFYVNYXAYXLYXBYXSYXMYXNYXPWVOV
      YBCEYOYBYVNYXJWUGXKSZYXSYXIRZYXFOYXQWUFYXTVYSWVCXWPXXAWUFWUGWUIYPVVOZYXJY
      XTRYYAYXFXXLWUGYQXEXBYRYSZYFXGZXYFXXOYXGXYDXXAXXOYXGOWVJWWKYVNXXOXXNWUGYD
      NZYXGYVNXXNVPSZYXKXXOYYEOYVNYXAYXLYXCYYFYXMYXNXYDYXCXXAXYCXWOYXCWXKXYCDEV
      XRVXOYXOYKUYFTZWVOVYCCEYGYBZYXRXXNWUGYMXBYVNWHXXNYDNZYYEYXGYVNYXAYXLYXCYY
      IYXMYXNYYGWVOVYCCEYOYBYVNYYFYXTYYIYYERZYXGOYYHYYBYYFYXTRYYJYXGXXNWUGYQXEX
      BYRYSZYFXGZXXLXXNVVPWCVVQYIWUFVYEVPSVYSWVCXWPWVJXXFXXPVYEVVRVVSYWRVYDVYBW
      VOCLZXXNYTLZYWSYDXYFVYDYYNYDNZXXPXYDXXAYYOWVJWWKYVNYXAYXBYXCYXLYYOYXMYXPY
      YGYXNVYBVYCWVOCEVVBVVCYFTYWRYYNXXLXXNYTLZYWSYWRYYMXXLXXNYTXYFYYMXXLVFZXXP
      XYDXXAYYQWVJWWKYVNYXAYXBYXLYYQYXMYXPYXNVYBWVOCEVVTYBYFTWQXYFXXMXXOYYPYWSV
      FZYXEYXFYXGYYRYXHYYDYYLXXLXXNVVDWCVVQVWAXTYWRYWSWUGWUGVLLZVYEMXYFXXPYWSYY
      SMNZXYDXXAXXPYYTOZWVJWWKYVNXXPYYTYVNXXMYXFXXOYXGUUUAYYCYYKYVNYXTYXTYXFYXG
      RZUUUAOYYBYYBUUUBYXTYXTRUUUAXXLXXNWUGWUGVWBVWCXBVWDVWEYFXGWUFYYSVYEVFVYSW
      VCXWPWVJXXFXXPWUFVYEVYEWFWGVVSXTVVFXEVWFUXSVWGYNVWJWDVWHVWEVUNVWIYNVWKVYH
      XVHUCXVDQVXTXVDVFZVYGXVGKUBDDUUUCVYAXVFVYFVXTXVDVXSMUQWIUSXAXBVWLVWMVWNWD
      XFYSVWOVWPVWTVWQWUAVYIUDQVWRUWSVWSVYOUEKQDVXAWOVXBAKUBBCVXIVXOVXJDEUCUDVX
      IWAVXJWAIJAWYCBDVXCUJSFBDVXDXIAYXACEVXCUJSGCEVXDXIVXEAWYCYXAVYRVYQXHFGKUE
      UCUBBCVXOVXLVXMDEWYIVXMWAVXFXBVXGVXH $.
  $}

  ${
    $d a b c n r s w x y z A $.
    $( Lemma for ~ ismblfin ; could also be used to shorten proof of
       ~ opnmbllem .  (Contributed by Brendan Leahy, 13-Jul-2018.) $)
    opnmbllem0 $p |- ( A e. ( topGen ` ran (,) ) -> U. ( [,] " { z e.
      ran ( x e. ZZ , y e. NN0 |-> <. ( x / ( 2 ^ y ) ) ,
        ( ( x + 1 ) / ( 2 ^ y ) ) >. ) | ( [,] ` z ) C_ A } ) = A ) $=
      ( vr cfv wcel cicc cv wss c2 co cdiv c1 caddc wa cxr cr clt wbr vw vs crn
      vn cioo ctg cz cn0 cexp cop cmpt2 crab cima cuni cpw wral weq fveq2 elrab
      sseq1d simprr fvex elpw sylibr sylan2b ralrimiva wfun cdm wb wf iccf ffun
      cxp ax-mp ssrab2 cle cin oveq1 oveq1d opeq12d oveq2 oveq2d cbvmpt2v dyadf
      frn inss2 ressxr xpss12 mp2an sstri fdmi sseqtr4i funimass4 sspwuni sylib
      cabs cmin ccom cres cbl crp wrex cxmt eqid rexmet cmopn tgioo mopni2 wceq
      mp3an1 elssuni uniretop syl6sseqr sselda rpre bl2ioo syl2an 1lt2 expnlbnd
      cn 2re mp3an23 ad2antrl cmul cfl ad2antrr nnnn0 nnexpcl sylancr syl112anc
      2nn syl mpbird nndivred syl2anc rexrd readdcld recnd ltadd2dd eqbrtrd cc0
      nnred remulcld fllelt simpld reflcl nngt0d peano2re simprd ltmuldiv mpbid
      ledivmul2 ltled w3a elicc2 mpbir3and flcld dyadval df-ov syl6eqr eleqtrrd
      fveq2d wfn ffn fnovrn simplrl rpred resubcld cc ax-1cn a1i nnne0d divdird
      nnrecred lttrd ltsubaddd leadd1dd lelttrd iccssioo syl22anc eqsstrd sstrd
      simplrr sylanbrc wi funfvima2 elunii rexlimddv sylbid rexlimdva mpd ssrdv
      expr ex eqssd ) DUEUCUFFZGZHCIZHFZDJZCABUGUHAIZKBIZUILZMLZUXANOLZUXCMLZUJ
      ZUKZUCZULZUMZUNZDUWQUXKDUOZJZUXLDJUWQUAIZHFZUXMGZUAUXJUPZUXNUWQUXQUAUXJUX
      OUXJGUWQUXOUXIGZUXPDJZPZUXQUWTUXTCUXOUXICUAUQUWSUXPDUWRUXOHURUTUSUWQUYAPU
      XTUXQUWQUXSUXTVAUXPDUXOHVBVCVDVEVFHVGZUXJHVHZJZUXNUXRVIQQVMZQUOZHVJUYBVKU
      YEUYFHVLVNZUXJUYEUYCUXJUXIUYEUWTCUXIVOUXIVPRRVMZVQZUYEUGUHVMZUYIUXHVJZUXI
      UYIJEUBUXHABEUBUGUHUXGEIZKUBIZUILZMLZUYLNOLZUYNMLZUJUYLUXCMLZUYPUXCMLZUJA
      EUQZUXDUYRUXFUYSUXAUYLUXCMVRUYTUXEUYPUXCMUXAUYLNOVRVSVTBUBUQZUYRUYOUYSUYQ
      VUAUXCUYNUYLMUXBUYMKUIWAZWBVUAUXCUYNUYPMVUBWBVTWCZWDZUYJUYIUXHWEVNUYIUYHU
      YEVPUYHWFRQJZVUEUYHUYEJWGWGRQRQWHWIWJWJWJUYEUYFHVKWKWLZUAUXJUXMHWMWIVDUXK
      DWNWOUWQUADUXLUWQUXODGZUXOUXLGZUWQVUGPZUXOUYLWPWQWRUYHWSZWTFLZDJZEXAXBZVU
      HVUJRXCFGUWQVUGVUMVUJVUJXDZXEEDVUJUXOUWPRVUJVUJXFFZVUNVUOXDXGXHXJVUIVULVU
      HEXAVUIUYLXAGZPZVULUXOUYLWQLZUXOUYLOLZUELZDJZVUHVUQVUKVUTDVUIUXORGZUYLRGV
      UKVUTXIVUPUWQDRUXOUWQDUWPUNRDUWPXKXLXMXNZUYLXOUXOUYLVUJVUNXPXQUTVUIVUPVVA
      VUHVUIVUPVVAPZPZNKUDIZUILZMLZUYLSTZVUHUDXTVUPVVIUDXTXBZVUIVVAVUPKRGNKSTVV
      JYAXRUYLKUDXSYBYCVVEVVFXTGZVVIPZPZUXOUXOVVGYDLZYEFZVVFUXHLZHFZGVVQUXKGZVU
      HVVMUXOVVOVVGMLZVVONOLZVVGMLZHLZVVQVVMUXOVWBGZVVBVVSUXOVPTZUXOVWAVPTZVUIV
      VBVVDVVLVVCYFZVVMVWDVVOVVNVPTZVVMVWGVVNVVTSTZVVMVVNRGZVWGVWHPVVMUXOVVGVWF
      VVMVVGVVMKXTGVVFUHGZVVGXTGYKVVKVWJVVEVVIVVFYGYCZKVVFYHYIZUUBZUUCZVVNUUDYL
      ZUUEVVMVVORGZVVBVVGRGZUUAVVGSTZVWDVWGVIVVMVWIVWPVWNVVNUUFYLZVWFVWMVVMVVGV
      WLUUGZVVOUXOVVGUULYJYMZVVMUXOVWAVWFVVMVVTVVGVVMVWPVVTRGZVWSVVOUUHYLZVWLYN
      ZVVMVWHUXOVWASTZVVMVWGVWHVWOUUIVVMVVBVXBVWQVWRVWHVXEVIVWFVXCVWMVWTUXOVVTV
      VGUUJYJUUKZUUMVVMVVSRGVWARGVWCVVBVWDVWEUUNVIVVMVVOVVGVWSVWLYNZVXDVVSVWAUX
      OUUOYOUUPVVMVVQVVSVWAUJZHFVWBVVMVVPVXHHVVMVVOUGGZVWJVVPVXHXIVVMVVNVWNUUQZ
      VWKEUBVVOVVFUXHVUCUURYOUVBVVSVWAHUUSUUTZUVAVVMVVPUXJGZVVRVVMVVPUXIGZVVQDJ
      ZVXLVVMVXIVWJVXMVXJVWKUXHUYJUVCZVXIVWJVXMUYKVXOVUDUYJUYIUXHUVDVNUGUHVVOVV
      FUXHUVEXJYOVVMVVQVUTDVVMVVQVWBVUTVXKVVMVURQGVUSQGVURVVSSTZVWAVUSSTVWBVUTJ
      VVMVURVVMUXOUYLVWFVVMUYLVUIVUPVVAVVLUVFUVGZUVHYPVVMVUSVVMUXOUYLVWFVXQYQZY
      PVVMVXPUXOVVSUYLOLZSTVVMUXOVWAVXSVWFVXDVVMVVSUYLVXGVXQYQVXFVVMVWAVVSVVHOL
      ZVXSSVVMVVONVVGVVMVVOVWSYRNUVIGVVMUVJUVKVVMVVGVWMYRVVMVVGVWLUVLUVMZVVMVVH
      UYLVVSVVMVVGVWLUVNZVXQVXGVVEVVKVVIVAZYSYTUVOVVMUXOUYLVVSVWFVXQVXGUVPYMVVM
      VWAUXOVVHOLZVUSVXDVVMUXOVVHVWFVYBYQVXRVVMVWAVXTVYDVPVYAVVMVVSUXOVVHVXGVWF
      VYBVXAUVQYTVVMVVHUYLUXOVYBVXQVWFVYCYSUVRVURVUSVVSVWAUVSUVTUWAVUIVUPVVAVVL
      UWCUWBUWTVXNCVVPUXIUWRVVPXIUWSVVQDUWRVVPHURUTUSUWDUYBUYDVXLVVRUWEUYGVUFUX
      JVVPHUWFWIYLUXOVVQUXKUWGYOUWHUWMUWIUWJUWKUWNUWLUWO $.
  $}

  ${
    $d a b c f g m n p s t u v w x y z A $.
    $d a b c f g m n p s t u v w x y z B $.
    $( Lemma for ~ ismblfin , ordering the sets of dyadic intervals that are
       antichains under subset and whose unions are contained entirely in
       ` A ` .  (Contributed by Brendan Leahy, 13-Jul-2018.) $)
    mblfinlem1 $p |- ( ( A e. ( topGen ` ran (,) ) /\ A =/= (/) ) ->
      E. f f : NN -1-1-onto-> { a e. { b e. ran ( x e. ZZ , y e. NN0 |->
        <. ( x / ( 2 ^ y ) ) , ( ( x + 1 ) / ( 2 ^ y ) ) >. ) |
      ( [,] ` b ) C_ A } | A. c e. { b e. ran ( x e. ZZ , y e. NN0 |->
        <. ( x / ( 2 ^ y ) ) , ( ( x + 1 ) / ( 2 ^ y ) ) >. ) |
      ( [,] ` b ) C_ A } ( ( [,] ` a ) C_ ( [,] ` c ) -> a = c ) } ) $=
      ( vz vn cfv wcel wa cn cicc wss co wral wbr cr cq vu vv crn ctg c0 wne cv
      cioo weq wi cz cn0 c2 cexp cdiv c1 caddc cop cmpt2 crab cen wf1o wex cdom
      csdm wn cima cuni wceq cfn cle wrex clt peano2re ltp1 rspcev syl2anc rgen
      breq2 ltnle rexbidva rexnal syl6bb ralbiia ralnex bitri raleq rexbidv cxp
      mpbi ssrab2 wf cc0 syl jca w3a redivcl syl3an1 opelxpi 3expb syl2an rgen2
      mpan fmpt2 frn ax-mp sstri adantl cxr iccf ressxr mp2an c1st c2nd 1st2nd2
      wb sseli fveq2d df-ov syl6eqr ad2antll xp2nd rexrd xp1st sylan2 ex adantr
      cvv uniretop a1i oveq1 opeq12d oveq2d com mpan2 sylibr qex qdivcl qnnen
      zq mtbiri zre 2re reexpcl nn0z cc 2ne0 expne0i mp3an12 eqid rnss syl6sseq
      2cn rnxpid fimaxre2 sylancr wel eluni2 wfn cpw xpss12 eleq2 rexima eleq2d
      rnfi ffn imdistani iccssxr ad2antrl simpllr iccleub 3expa sylan wrel xpss
      biimpd df-rel mpbir 2ndrn breq1 rspccva ad2ant2lr xrletrd syl5bi ralrimiv
      rexlimdvaa ad2antrr mpbid reximdva mpd nsyl retopcon simpll simplr simprl
      ccon ccld ciun wfun ffun funiunfv icccld eqeltrd iuncld mp3an13 syl5eqelr
      retop eqeltrrd conclo necon3ad imp pm2.61dane oveq1d oveq2 cbvmpt2v fveq2
      ctop sseq1d imbi12d ralbidv cbvrabv dyadmbllem opnmbllem0 eqtr3d sdomentr
      eqeq1 nnenom isfinite anim12i mtand xpex 2nn nnq qexpcl qaddcl ssdomg mp2
      1z xpen xpnnen entri domentr jctil bren2 ensymd bren sylib ) CUHUCUDJZKZC
      UEUFZLZMEUGZNJZGUGZNJZOZEGUIZUJZGFUGNJCOZFABUKULAUGZUMBUGZUNPZUOPZVUTUPUQ
      PZVVBUOPZURZUSZUCZUTZQZEVVIUTZVARMVVKDUGVBDVCVUKVVKMVUKVVKMVDRZVVKMVERZVF
      ZLVVKMVARVUKVVNVVLVUKVVMNVVKVGZVHZCVIZVVKVJKZLZVUKVVSVFZCSCSVIZVVTVUKVWAH
      UGZIUGZVKRZHCQZISVLZVVSVWAVWFVWDHSQZISVLZVWCVWBVMRZHSVLZISQZVWHVFZVWJISVW
      CSKZVWCUPUQPZSKVWCVWNVMRZVWJVWCVNVWCVOVWIVWOHVWNSVWBVWNVWCVMVSVPVQVRVWKVW
      GVFZISQVWLVWJVWPISVWMVWJVWDVFZHSVLVWPVWMVWIVWQHSVWCVWBVTWAVWDHSWBWCWDVWGI
      SWEWFWJVWAVWEVWGISVWDHCSWGWHUUAVVSUAUGZVWCVKRZUAVVKUCZQZISVLZVWFVVRVXBVVQ
      VVRVWTSOZVWTVJKVXBVVKSSWIZOZVXCVVKVVIVXDVVJEVVIWKZVVIVVHVXDVUSFVVHWKZUKUL
      WIZVXDVVGWLZVVHVXDOVVFVXDKZBULQAUKQVXIVXJABUKULVUTUKKZVUTSKZVVBSKZVVBWMUF
      ZLVXJVVAULKZVUTUUBVXOVXMVXNUMSKVXOVXMUUCUMVVAUUDXCVXOVVAUKKZVXNVVAUUEUMUU
      FKUMWMUFVXPVXNUUMUUGUMVVAUUHUUIWNZWOVXLVXMVXNVXJVXLVXMVXNWPVVCSKVVESKZVXJ
      VUTVVBWQVXLVVDSKVXMVXNVXRVUTVNVVDVVBWQWRVVCVVESSWSVQWTXAXBABUKULVVFVXDVVG
      VVGUUJZXDWJVXHVXDVVGXEXFXGXGZVXEVWTVXDUCSVVKVXDUUKSUUNUULXFVVKUVEIUAVWTUU
      OUUPXHVVQVXBVWFUJVVRVVQVXAVWEISVVQVWMLZVXAVWEVYAVXALZVWDHVVPQZVWEVYBVWDHV
      VPVWBVVPKZVWBUBUGZNJZKZUBVVKVLZVYBVWDVYDHUAUUQZUAVVOVLZVYHUAVWBVVOUURNXIX
      IWIZUUSZVVKVYKOVYJVYHXPVYKXIUUTZNWLZVYLXJVYKVYMNUVFXFVVKVXDVYKVXTSXIOZVYO
      VXDVYKOXKXKSXISXIUVAXLXGVYIVYGUAUBVYKVVKNVWRVYFVWBUVBUVCXLWFVYBVYGVWDUBVV
      KVYEVVKKZVYGLVYBVYPVWBVYEXMJZVYEXNJZNPZKZLZVWDVYPVYGVYTVYPVYGVYTVYPVYEVXD
      KZVYGVYTXPVVKVXDVYEVXTXQZWUBVYFVYSVWBWUBVYFVYQVYRURZNJVYSWUBVYEWUDNVYESSX
      OXRVYQVYRNXSXTUVDWNUVPUVGVYBWUALZVWBVYRVWCVYTVWBXIKVYBVYPVYSXIVWBVYQVYRUV
      HXQYAVYPVYRXIKZVYBVYTVYPWUBWUFWUCWUBVYRVYESSYBYCZWNUVIWUEVWCVVQVWMVXAWUAU
      VJYCWUAVWBVYRVKRZVYBVYPVYQXIKZWUFLZVYTWUHVYPWUBWUJWUCWUBWUIWUFWUBVYQVYESS
      YDYCWUGWOWNWUIWUFVYTWUHVYQVYRVWBUVKUVLUVMXHVXAVYPVYRVWCVKRZVYAVYTVYPVXAVY
      RVWTKZWUKVVKUVNZVYPWULWUMVVKYHYHWIZOVVKVXDWUNVXTSSUVOXGVVKUVQUVRVYEVVKUVS
      XCVWSWUKUAVYRVWTVWRVYRVWCVKUVTUWAYEUWBUWCYEUWFUWDUWEVVQVYCVWEXPVWMVXAVWDH
      VVPCWGUWGUWHYFUWIYGUWJUWKXHVUKCSUFVVTVUKVVSCSVUKVVSVWAVUKVVSLZCVUHSYIVUHU
      WPKWUOUWLYJVUIVUJVVSUWMVUIVUJVVSUWNWUOVVPCVUHUWQJZVUKVVQVVRUWOVVRVVPWUPKV
      UKVVQVVRVVPHVVKVWBNJZUWRZWUPNUWSZWURVVPVIVYNWUSXJVYKVYMNUWTXFHVVKNUXAXFVU
      HUXQKVVRWUQWUPKZHVVKQWURWUPKUXGWUTHVVKVWBVVKKVWBVXDKZWUTVVKVXDVWBVXTXQWVA
      WUQVWBXMJZVWBXNJZNPZWUPWVAWUQWVBWVCURZNJWVDWVAVWBWVENVWBSSXOXRWVBWVCNXSXT
      WVAWVBSKWVCSKWVDWUPKVWBSSYDVWBSSYBWVBWVCUXBVQUXCWNVRHVVKWUQVUHSYIUXDUXEUX
      FYAUXHUXIYFUXJUXKUXLVUKVVQVVMVVRVUIVVQVUJVUINVVIVGVHVVPCVUIUAUBHGVVIVVGVV
      KABUAUBUKULVVFVWRUMVYEUNPZUOPZVWRUPUQPZWVFUOPZURVWRVVBUOPZWVHVVBUOPZURAUA
      UIZVVCWVJVVEWVKVUTVWRVVBUOYKWVLVVDWVHVVBUOVUTVWRUPUQYKUXMYLBUBUIZWVJWVGWV
      KWVIWVMVVBWVFVWRUOVVAVYEUMUNUXNZYMWVMVVBWVFWVHUOWVNYMYLUXOVVJWUQVUOOZHGUI
      ZUJZGVVIQEHVVIEHUIZVURWVQGVVIWVRVUPWVOVUQWVPWVRVUMWUQVUOVULVWBNUXPUXRVULV
      WBVUNUYFUXSUXTUYAVVIVVHOVUIVXGYJUYBABFCUYCUYDYGVVMVVKYNVERZVVRVVMMYNVARWV
      SUYGVVKMYNUYEYOVVKUYHYPUYIUYJVVKTTWIZVDRZWVTMVARVVLWVTYHKVVKWVTOWWATTYQYQ
      UYKVVKVVIWVTVXFVVIVVHWVTVXGVXHWVTVVGWLZVVHWVTOVVFWVTKZBULQAUKQWWBWWCABUKU
      LVXKVUTTKZVVBTKZVXNLWWCVXOVUTYTVXOWWEVXNUMTKZVXOWWEUMMKWWFUYLUMUYMXFUMVVA
      UYNXCVXQWOWWDWWEVXNWWCWWDWWEVXNWPVVCTKVVETKZWWCVUTVVBYRWWDVVDTKZWWEVXNWWG
      WWDUPTKZWWHUPUKKWWIUYRUPYTXFVUTUPUYOYOVVDVVBYRWRVVCVVETTWSVQWTXAXBABUKULV
      VFWVTVVGVXSXDWJVXHWVTVVGXEXFXGXGVVKWVTYHUYPUYQWVTMMWIZMTMVARZWWKWVTWWJVAR
      YSYSTMTMUYSXLUYTVUAVVKWVTMVUBXLVUCVVKMVUDYPVUEMVVKDVUFVUG $.

    $d a b c f g m n p s t u v w x y z M $.
    $( Lemma for ~ ismblfin , effectively one direction of the same fact for
       open sets, made necessary by Viaclovsky's slightly different defintion
       of outer measure.  Note that unlike the main theorem, this holds for
       sets of infinite measure.  (Contributed by Brendan Leahy, 21-Feb-2018.)
       (Revised by Brendan Leahy, 13-Jul-2018.) $)
    mblfinlem2 $p |- ( ( A e. ( topGen ` ran (,) ) /\ M e. RR /\
      M < ( vol* ` A ) ) -> E. s e. ( Clsd ` ( topGen ` ran (,) ) )
        ( s C_ A /\ M < ( vol* ` s ) ) ) $=
      ( vz vm cfv wcel cr wbr wss wa c0 wceq adantl cn cicc co c1 caddc cc0 crn
      va vc vb vx vy vf vn vu vv vp vt cioo covol clt w3a cv ax-mp fveq2 breq2d
      wrex sylancr wne weq wi cz cn0 cexp cdiv cop wral cfz ciun cabs cmin ccom
      c2 cseq cxr cuni cima syl oveq2d sseq1d imbi12d ralbidv a1i adantr fveq2d
      eqeq1 wf cle cxp cin frn sstri sylancl wdisj ffvelrn sseldi syl2anc sylan
      wo elrab simprbi eqeq2 syl2anr syl2an eqeq1d sylibr eqid wb cc subf mp2an
      fco opelxpi nnuz 1z ressxr mpbid wfn cuz cun cif ffvelrnda 0re ifcl df-ov
      orbi2d eqidd eqtrd elfznn sylan2 adantlr cvv adantlll ltletrd ralrimiva
      wn ctg ccld ctop retop 0cld simpl3 breqtrd 0ss jctil sseq1 anbi12d rspcev
      cmpt2 crab wf1o wex mblfinlem1 3ad2antl1 csup wfo f1ofo rnco2 forn syl5eq
      imaeq2d unieqd oveq1 opeq12d oveq2 cbvmpt2v cbvrabv dyadmbllem opnmbllem0
      oveq1d ssrab2 3ad2ant1 3eqtr2d f1of dyadf fss w3o adantrr dyaddisj df-3or
      adantrl sylib elrabi sseq2d rspcva eqcom syl6ib jaod anandis wf1 f1veqaeq
      f1of1 orim1d mpd ralrimivva ineq1d orbi12d cbvralv ineq2d ralbii 3bitr4ri
      syld disjor uniiccvol absf zre 2re reexpcl mpan nn0z 2ne0 expne0i mp3an12
      eqtr3d 2cn jca redivcl peano2re syl3an1 3expb rgen2 mpbi ax-resscn xpss12
      fmpt2 mpan2 serfre syl6ss 4syl 3ad2ant2 supxrlub seqfn fneq2i mpbir breq2
      rexr rexrn cmpt 0le0 df-br elin mpbir2an fmptd iooid eqtr3i ineq1i 3eqtri
      incom in0 olci ineq1 ifboth eqtri ineq2 disjeq2 eleq1 ifbieq12d fvex opex
      ineq2i ifex fvmpt fvif syl6eq mprg bitri 0xr cpw iccf feqmptd fmptco cfzo
      rneqd peano2nn syl6eleq fzouzsplit nnz fzval3 uneq1d eqtr4d dfiun3 iunxun
      iuneq12d 3eqtr3g iftrue iuneq2i uznfz ax-1cn pncan eleq2d notbid iuneq2dv
      iffalse uneq12d sylan9eq wor xrltso elnnuz biimpi readdcl seqcl sylan9eqr
      nncn rexrd fvmptd fnmpti fvco2 ffn 3eqtr4d seqfveq fnfvelrn eqeltrrd recn
      addass syl3an nnltp1le biimpa nnzd eluz mpbird ad3antlr seqsplit ad2antrr
      0cn simplll fvco3 subidi fveq2i abs0 elfzelz nnred ad3antrrr zred elfzle1
      csn nngt0d elnnz sylanbrc simpll nnre ltp1d ltnled breq1 equcoms sylan9bb
      elfzle2 nsyl elfzuz c0ex fvconst2 3eqtr4a ser0 oveq12d recnd 3eqtrd leidd
      addid1d eqbrtrd ad2antlr simpr simplr letrd elfz mp3an2 mpbir2and eqeltrd
      id biimpar absge0d breqtrrd syldan ltlecasei ralrn r19.21bi sselda lenltd
      sermono supmax 3eqtr3rd 1st2nd2 syl6eqr xp1st xp2nd iccssre eqsstrd iunss
      c1st c2nd uzid ne0i iunconst iccid snssi syl6eqss ovolsn ovolunnul biimpd
      syl3anc reximdva icccld fzfi uniretop iuncld 3syl simprr syl12anc adantll
      cfn rexlimddv exlimddv pm2.61dane ) AUMUAUUAFZGZBHGZBAUNFZUOIZUPZCUQZAJZB
      WYBUNFZUOIZKZCWXPUUBFZVAZALWYAALMZKZLWYGGZLAJZBLUNFZUOIZKZWYHWXPUUCGZWYKU
      UDWXPUUEURWYJWYNWYLWYJBWXSWYMUOWXQWXRWXTWYIUUFWYIWXSWYMMWYAALUNUSNUUGAUUH
      UUIWYFWYOCLWYGWYBLMZWYCWYLWYEWYNWYBLAUUJWYQWYDWYMBUOWYBLUNUSUTUUKUULVBWYA
      ALVCZKOUBUQZPFZUCUQZPFZJZUBUCVDZVEZUCUDUQZPFZAJZUDUEUFVFVGUEUQZVQUFUQZVHQ
      ZVIQZXUIRSQZXUKVIQZVJZUUMZUAZUUNZVKZUBXURUUNZUGUQZUUOZWYHUGWXQWXRWYRXVBUG
      UUPWXTUEUFAUGUBUDUCUUQUURWYAXVBWYHWYRWYAXVBKZBDRUHUQZVLQZDUQZXVAFZPFZVMZU
      NFZUOIZWYHUHOXVCBXVDSVNVOVPZXVAVPZRVRZFZUOIZUHOVAZXVKUHOVAZXVCBXVFUOIZDXV
      NUAZVAZXVQXVCBXVTVSUOUUSZUOIZXWAXVCBWXSXWBUOWXQWXRWXTXVBUUFXVCPXVAVPUAZVT
      ZUNFZWXSXWBXVCXWEAUNXVCXWEPXUTWAZVTZPXURWAVTZAXVBXWEXWHMZWYAXVBOXUTXVAUUT
      ZXWJOXUTXVAUVAXWKXWDXWGXWKXWDPXVAUAZWAXWGPXVAUVBXWKXWLXUTPOXUTXVAUVCUVEUV
      DUVFWBNWYAXWIXWHMXVBWYAUIUJDUCXURXUPXUTUEUFUIUJVFVGXUOUIUQZVQUJUQZVHQZVIQ
      ZXWMRSQZXWOVIQZVJXWMXUKVIQZXWQXUKVIQZVJUEUIVDZXULXWSXUNXWTXUIXWMXUKVIUVGX
      XAXUMXWQXUKVIXUIXWMRSUVGUVNUVHUFUJVDZXWSXWPXWTXWRXXBXUKXWOXWMVIXUJXWNVQVH
      UVIZWCXXBXUKXWOXWQVIXXCWCUVHUVJZXUSXVFPFZXUBJZDUCVDZVEZUCXURVKUBDXURUBDVD
      ZXUEXXHUCXURXXIXUCXXFXUDXXGXXIWYTXXEXUBWYSXVFPUSWDWYSXVFXUAWJWEWFUVKXURXU
      QJWYAXUHUDXUQUVOZWGUVLWHWYAXWIAMZXVBWXQWXRXXKWXTUEUFUDAUVMUVPWHUVQWIXVBXW
      FXWBMWYAXVBDXVNXVAXVBOXUTXVAWKZXUTWLHHWMZWNZJOXXNXVAWKOXUTXVAUVRZXUTXURXX
      NXUSUBXURUVOZXURXUQXXNXXJVFVGWMZXXNXUPWKXUQXXNJUIUJXUPXXDUVSXXQXXNXUPWOUR
      WPWPOXUTXXNXVAUVTWQZXVBEDVDZEUQZXVAFZUMFZXVGUMFZWNZLMZXCZDOVKZEOVKZDOXYCW
      RZXVBXYFEDOOXVBXXTOGZXVFOGZKZKZXYAPFZXVHJZXVHXYNJZXCZXYEXCZXYFXYMXYOXYPXY
      EUWAZXYRXVBXXLXYLXYSXXOXXLXYLKXYAXUQGZXVGXUQGZXYSXXLXYJXYTXYKXXLXYJKZXUTX
      UQXYAXUTXURXUQXXPXXJWPZOXUTXXTXVAWSZWTUWBXXLXYKYUAXYJXXLXYKKZXUTXUQXVGYUC
      OXUTXVFXVAWSZWTUWEUIUJXYAXVGXUPXXDUWCXAXBXYOXYPXYEUWDUWFXYMXYQXXSXYEXYMXY
      QXYAXVGMZXXSXVBXXLXYLXYQYUGVEZXXOXXLXYJXYKYUHYUBXYAXUTGZXVGXUTGZYUHYUEYUD
      YUFYUIYUJKZXYOYUGXYPYUJXVGXURGZXYNXUBJZXYAXUAMZVEZUCXURVKZXYOYUGVEZYUIXUS
      UBXVGXURUWGZYUIXYAXURGZYUPXUSYUPUBXYAXURWYSXYAMZXUEYUOUCXURYUTXUCYUMXUDYU
      NYUTWYTXYNXUBWYSXYAPUSWDWYSXYAXUAWJWEWFXDXEYUOYUQUCXVGXURXUAXVGMZYUMXYOYU
      NYUGYVAXUBXVHXYNXUAXVGPUSUWHXUAXVGXYAXFWEUWIXGYUKXYPXVGXYAMZYUGYUIYUSXVHX
      UBJZXVGXUAMZVEZUCXURVKZXYPYVBVEZYUJXUSUBXYAXURUWGYUJYULYVFXUSYVFUBXVGXURW
      YSXVGMZXUEYVEUCXURYVHXUCYVCXUDYVDYVHWYTXVHXUBWYSXVGPUSWDWYSXVGXUAWJWEWFXD
      XEYVEYVGUCXYAXURXUAXYAMZYVCXYPYVDYVBYVIXUBXYNXVHXUAXYAPUSUWHXUAXYAXVGXFWE
      UWIXHXVGXYAUWJUWKUWLXHUWMXBXVBOXUTXVAUWNXYLYUGXXSVEOXUTXVAUWPOXUTXXTXVFXV
      AUWOXBUXFUWQUWRZUWSEUKVDZXYBUKUQZXVAFZUMFZWNZLMZXCZUKOVKZEOVKDUKVDZXYCYVN
      WNZLMZXCZUKOVKZDOVKXYHXYIYVRYWCEDOXXSYVQYWBUKOXXSYVKYVSYVPYWAXXTXVFYVLWJX
      XSYVOYVTLXXSXYBXYCYVNXXSXYAXVGUMXXTXVFXVAUSWIZUWTXIUXAWFUXBXYGYVREOXYFYVQ
      DUKOYVSXXSYVKXYEYVPXVFYVLXXTXFYVSXYDYVOLYVSXYCYVNXYBYVSXVGYVMUMXVFYVLXVAU
      SWIZUXCXIUXAUXBUXDOXYCYVNDUKYWEUXGUXEXJXVNXKUXHNUXRUUGXVBXVTVSJZBVSGZXWCX
      WAXLWYAXVBXXLOHXVMWKZOHXVNWKZYWFXXOXXLXMXMWMZHXVLWKZOYWJXVAWKZYWHXMHVNWKY
      WJXMVOWKZYWKUXIXNYWJXMHVNVOXPXOZXXLXUTYWJJYWLXUTXXMYWJXUTXURXXMXXPXURXUQX
      XMXXJXXQXXMXUPWKZXUQXXMJXUOXXMGZUFVGVKUEVFVKYWOYWPUEUFVFVGXUIVFGXUIHGZXUK
      HGZXUKTVCZKYWPXUJVGGZXUIUXJYWTYWRYWSVQHGYWTYWRUXKVQXUJUXLUXMYWTXUJVFGZYWS
      XUJUXNVQXMGVQTVCYXAYWSUXSUXOVQXUJUXPUXQWBUXTYWQYWRYWSYWPYWQYWRYWSUPXULHGX
      UNHGZYWPXUIXUKUYAYWQXUMHGYWRYWSYXBXUIUYBXUMXUKUYAUYCXULXUNHHXQXAUYDXHUYEU
      EUFVFVGXUOXXMXUPXUPXKUYIUYFXXQXXMXUPWOURWPWPZHXMJZYXDXXMYWJJUYGUYGHXMHXMU
      YHXOWPZOXUTYWJXVAUVTUYJZOYWJHXVLXVAXPVBZYWHUHXVMROXRRVFGZYWHXSWGOHXVDXVMW
      SUYKYWIXVTHVSOHXVNWOXTUYLUYMWXRWXQYWGWXTBUYTUYNDXVTBUYOXGYAXVNOYBZXWAXVQX
      LYXIXVNRYCFZYBZYXHYXKXSSXVMRUYPUROYXJXVNXRUYQUYRXVSXVPDUHOXVNXVFXVOBUOUYS
      VUAURUWFXVBXVQXVRVEWYAXVBXVPXVKUHOXVBXVDOGZKZXVPXVKYXMXVOXVJBUOYXMXVOXVID
      XVDRSQZYCFZTTVJZPFZVMZYDZUNFZXVJYXMPDOXVFXVEGZXVGYXPYEZVUBZVPZUAZVTZUNFZS
      XVLYYCVPZRVRZUAZVSUOUUSZYXTXVOXVBYYGYYKMYXLXVBEYYIYYCXVBDOYYBXXNYYCXVBXYK
      KXVGXXNGYXPXXNGZYYBXXNGXVBOXXNXVFXVAXXRYFYYLYXPWLGZYXPXXMGZTTWLIYYMVUCTTW
      LVUDUYFTHGZYYOYYNYGYGTTHHXQXOYXPWLXXMVUEVUFYYAXVGYXPXXNYHWQYYCXKZVUGXVBXX
      SXXTXVEGZXYBYXPUMFZYEZYYAXYCYYRYEZWNZLMZXCZDOVKEOVKZEOXXTYYCFZUMFZWRZXVBU
      UUCEDOOXYMXXSYYSXYCWNZLMZXCZXXSYYSYYRWNZLMZXCZUUUCXYMXYFXXSYYRXYCWNZLMZXC
      ZUUUJYVJUUUOXXSUUUNLXYCWNXYCLWNLYYRLXYCTTUMQYYRLTTUMYITVUHVUIZVUJLXYCVULX
      YCVUMVUKVUNYYQXYFUUUPUUUJXYBYYRXYBYYSMZXYEUUUIXXSUUURXYDUUUHLXYBYYSXYCVUO
      XIYJYYRYYSMZUUUOUUUIXXSUUUSUUUNUUUHLYYRYYSXYCVUOXIYJVUPWQUUULXXSUUUKYYSLW
      NLYYRLYYSUUUQVVDYYSVUMVUQVUNYYAUUUJUUUMUUUCXYCYYRXYCYYTMZUUUIUUUBXXSUUUTU
      UUHUUUALXYCYYTYYSVURXIYJYYRYYTMZUUULUUUBXXSUUVAUUUKUUUALYYRYYTYYSVURXIYJV
      UPWQUWSUUUGEOYYSWRZUUUDUUUFYYSMUUUGUUVBXLEOEOUUUFYYSVUSXYJUUUFYYQXYAYXPYE
      ZUMFYYSXYJUUUEUUVCUMDXXTYYBUUVCOYYCDEVDZYYAYYQXVGYXPXYAYXPXVFXXTXVEVUTXVF
      XXTXVAUSZUUVDYXPYKVVAZYYPYYQXYAYXPXXTXVAVVBZTTVVCZVVEVVFWIYYQXYAYXPUMVVGV
      VHVVIOYYSYYTEDXXSYYQYYAXYBYYRXYCYYRXXTXVFXVEVUTYWDXXSYYRYKVVAUXGVVJXJYYIX
      KUXHWHYXMYYFYXSUNXVBYXLYYFDOYYBPFZVUBZUAZVTZYXSXVBYYEUUVKXVBYYDUUVJXVBXXL
      YYDUUVJMXXOXXLDEOVSVSWMZYYBXXTPFUUVIYYCPYUEXVGUUVMGYXPUUVMGZYYBUUVMGYUEXU
      TUUVMXVGXUTXXMUUVMYXCHVSJZUUVOXXMUUVMJXTXTHVSHVSUYHXOWPYUFWTTVSGZUUVPUUVN
      VVKVVKTTVSVSXQXOYYAXVGYXPUUVMYHWQXXLYYCYKXXLEUUVMVSVVLZPUUVMUUVQPWKXXLVVM
      WGVVNXXTYYBPUSVVOWBVVQUVFYXLUUVLDXVEYYAXVHYXQYEZVMZDYXOUUVRVMZYDZYXSYXLDO
      UUVIVMDXVEYXOYDZUUVRVMUUVLUUWAYXLDOUUWBUUVIUUVRYXLORYXNVVPQZYXOYDZUUWBYXL
      OYXJUUWDXRYXLYXNYXJGYXJUUWDMYXLYXNOYXJXVDVVRZXRVVSRYXNVVTWBUVDYXLXVEUUWCY
      XOYXLXVDVFGZXVEUUWCMXVDVWAZRXVDVWBWBVWCVWDUUVIUUVRMYXLYYAXVGYXPPVVGWGVWGD
      OUUVIYYBPVVBVWEDXVEYXOUUVRVWFVWHYXLUUVSXVIUUVTYXRUUVSXVIMYXLDXVEUUVRXVHYY
      AXVHYXQVWIVWJWGYXLDYXOUUVRYXQYXLXVFYXOGZKZYYAYTZUUVRYXQMUUWIXVFRYXNRVOQZV
      LQZGZYTZUUWJUUWHUUWNYXLXVFRYXNVWKNYXLUUWNUUWJXLUUWHYXLUUWMYYAYXLUUWLXVEXV
      FYXLUUWKXVDRVLYXLXVDXMGRXMGUUWKXVDMXVDVXGVWLXVDRVWMWQWCVWNVWOWHYAYYAXVHYX
      QVWQWBVWPVWRYLVWSWIXVBXXLYXLYYKXVOMXXOXXLYXLKZEVSYYJXVOUOVSUOVWTUUWOVXAWG
      UUWOXVOUUWOUIUJSHXVMRXVDYXLXVDYXJGZXXLYXLUUWPXVDVXBVXCZNZXXLXWMXVEGZXWMXV
      MFHGZYXLUUWSXXLXWMOGUUWTXWMXVDYMXXLOHXWMXVMYXGYFYNYOXWMHGZXWNHGZKXWMXWNSQ
      ZHGUUWOXWMXWNVXDNVXEZVXHUUWOXVDYYIFZXVOYYJUUWOSEYYHXVMRXVDUUWRXXLYYQXXTYY
      HFZXXTXVMFZMYXLXXLYYQKZUUUEXVLFZXYAXVLFZUUXFUUXGUUXHUUUEXYAXVLYYQUUUEXYAM
      XXLYYQDXXTYYBXYAOYYCYPYYQYYCYKUUVDYYQYYBUUVCXYAUUVFYYQXYAYXPVWIVXFXXTXVDY
      MZXYAYPGZYYQUUVGWGVXINWIYYQUUXFUUXIMZXXLYYQYYCOYBZXYJUUXMDOYYBYYCYYAXVGYX
      PXVFXVAVVBUUVHVVEYYPVXJZUUXKOXVLYYCXXTVXKZVBNXXLXVAOYBXYJUUXGUUXJMZYYQOXU
      TXVAVXLUUXKOXVLXVAXXTVXKXHVXMYOVXNZXXLYYIOYBZYXLUUXEYYJGXXLOHYYIWKZUUXSXX
      LEYYHROXRYXHXXLXSWGXXLOHXXTYYHXXLYWKOYWJYYCWKOHYYHWKYWNXXLDOYYBYWJYYCYUEX
      VGYWJGYXPYWJGZYYBYWJGYUEXUTYWJXVGYXEYUFWTTXMGZUUYBUUYAVYHVYHTTXMXMXQXOZYY
      AXVGYXPYWJYHWQYYPVUGOYWJHXVLYYCXPVBYFZUYKZOHYYIVXLWBZOXVDYYIVXOXBVXPUUWOX
      XTYYJGZKZXXTXVOWLIZXVOXXTUOIYTUUWOUUYIEYYJUUWOUUYIEYYJVKZULUQZYYIFZXVOWLI
      ZULOVKZUUWOUUYMULOUUWOUUYKOGZKZUUYMXVDUUYKUUYPXVDUUYKUOIZKZUUYLXVOXVOWLUU
      YRUUYLUUXEUUYKSYYHYXNVRFZSQXVOTSQXVOUUYREUIUJSHYYHRXVDUUYKXXTHGZUUXAKXXTX
      WMSQZHGUUYRXXTXWMVXDNZUUYTUUXAUUXBUPUVUAXWNSQXXTUUXCSQMZUUYRUUYTXXTXMGUUX
      AXWMXMGUUXBXWNXMGUVUCXXTVXQXWMVXQXWNVXQXXTXWMXWNVXRVXSNYXLUUYOUUYQUUYKYXO
      GZXXLYXLUUYOKZUUYQKZUVUDYXNUUYKWLIZUVUEUUYQUVUGXVDUUYKVXTVYAUVUEUVUDUVUGX
      LZUUYQYXLYXNVFGZUUYKVFGZUVUHUUYOYXLYXNUUWEVYBZUUYKVWAZYXNUUYKVYCXHWHVYDZY
      QYXLUUWPXXLUUYOUUYQUUWQVYEZUUYRXXLXYJUUXFHGXXTRUUYKVLQGZXXLYXLUUYOUUYQVYI
      XXTUUYKYMZUUYDXHVYFUUYRUUXEXVOUUYSTSUUWOUUXEXVOMUUYOUUYQUUXRVYGYXLUUYOUUY
      QUUYSTMXXLUVUFUUYSUUYKSYXOTVYSZWMZYXNVRFZTUVUFSEYYHUVURYXNUUYKUVUMUVUFXXT
      YXNUUYKVLQGZKZYXPXVLFZTUUXFXXTUVURFZUVVBYXPVOFZVNFZTVNFTYWMUUYAUVVBUVVEMX
      NUUYCYWJXMYXPVNVOVYJXOUVVDTVNTTVOQUVVDTTTVOYITVYHVYKVUIVYLVYMVUKUVVAUUXFU
      UXIUVVBUVVAUUXNXYJUUXMUUXOUVVAXXTVFGZTXXTUOIZXYJUVUTUVVFUVUFXXTYXNUUYKVYN
      ZNUVVATYXNXXTYYOUVVAYGWGYXLYXNHGZUUYOUUYQUVUTYXLYXNUUWEVYOZVYPUVUTUUYTUVU
      FUVUTXXTUVVHVYQZNYXLTYXNUOIZUUYOUUYQUVUTYXLYXNUUWEVYTZVYPUVUTYXNXXTWLIZUV
      UFXXTYXNUUYKVYRZNYRXXTWUAZWUBUUXPVBUVVAUUUEYXPXVLUVUFYXLUVUTUUUEYXPMYXLUU
      YOUUYQWUCYXLUVUTKZDXXTYYBYXPOYYCYPUVVQYYCYKUVVQUUVDKZUUWJYYBYXPMUVVRXVFXV
      DWLIZYYAUVVRXVDXXTUOIZUVVSYTZUVVQUVVTUUVDUVVQXVDYXNXXTYXLXVDHGZUVUTXVDWUD
      ZWHZYXLUVVIUVUTUVVJWHZUVUTUUYTYXLUVVKNZYXLXVDYXNUOIUVUTYXLXVDUVWCWUEWHUVU
      TUVVNYXLUVVONZYRWHUVVQUVVTXXTXVDWLIZYTUUVDUVWAUVVQXVDXXTUVWDUVWFWUFUUVDUV
      WHUVVSUVWHUVVSXLEDXXTXVFXVDWLWUGWUHVWOWUIYAXVFRXVDWUJWUKYYAXVGYXPVWQWBUVV
      QUVVFUVVGXYJUVUTUVVFYXLUVVHNUVVQTYXNXXTYYOUVVQYGWGUVWEUVWFYXLUVVLUVUTUVVM
      WHUVWGYRUVVPWUBYXPYPGUVVQUUVHWGVXIXBWIYLUVUTUVVCTMZUVUFUVUTXXTYXOGUVWIXXT
      YXNUUYKWULYXOTXXTWUMWUNWBNWUOVXNUVUFUVUDUVUSTMUVUMYXNUUYKYXOYXOXKWUPWBYLY
      QWUQUUYRXVOUUYRXVOUUWOXVOHGZUUYOUUYQUUWOEUJSHXVMRXVDUUWRXXLYYQUUXGHGZYXLY
      YQXXLXYJUVWKUUXKXXLOHXXTXVMYXGYFZYNYOUUYTUUXBKXXTXWNSQHGUUWOXXTXWNVXDNVXE
      VYGWURWVAWUSUUYRXVOUUYREUISHXVMRXVDUVUNYYQUUYRXYJUVWKUUXKUUYPXYJUVWKUUYQU
      UYPXXLXYJUVWKXXLYXLUUYOWUCUVWLXBYOYNUVUBVXEWUTWVBUUYPUUYKXVDWLIZKZUUYLUUY
      KXVNFXVOWLUVWNSEYYHXVMRUUYKUUYOUUYKYXJGZUUWOUVWMUUYOUVWOUUYKVXBVXCWVCZUVW
      NUVUOKZUUXIUUXJUUXFUUXGUVWQUUUEXYAXVLUVWQDXXTYYBXYAOYYCYPUVWQYYCYKUVWQUUV
      DKZYYBXVGXYAUVWRYYAYYBXVGMUVWRXVFXXTXVEUVWQUUVDWVDUVWQYYQUUVDUVWNUVUEUVWM
      KZUVUOYYQYXLUUYOUVWMUVWSXXLUVWSWVKYQUVWSUVUOKZYYQRXXTWLIZUVWHUVUOUVXAUVWS
      XXTRUUYKVYRNUVWTXXTUUYKXVDUVUOUUYTUVWSUVUOXXTUVUPVYONUUYOUUYKHGZYXLUVWMUV
      UOUUYKWUDZVYEYXLUVWBUUYOUVWMUVUOUVWCVYPUVUOXXTUUYKWLIUVWSXXTRUUYKWUJNUVUE
      UVWMUVUOWVEWVFUVUOUVVFUUWFYYQUVXAUVWHKXLZUVWSXXTRUUYKVYNYXLUUWFUUYOUVWMUU
      WGVYGUVVFYXHUUWFUVXDXSXXTRXVDWVGWVHXGWVIXBWHWVJYYAXVGYXPVWIWBUUVDYVBUVWQU
      UVENYLUVUOXYJUVWNUVUPNUUXLUVWQUUVGWGVXIWIUVUOUUXMUVWNUVUOUUXNXYJUUXMUUXOU
      VUPUUXPVBNUVWNXXLXYJUUXQUVUOXXLYXLUUYOUVWMVYIZUVUPOXUTXXTXVLXVAVYJZXHVXMV
      XNUVWNEXVMUUYKRXVDUVWPYXLUUYOUVWMXVDUUYKYCFGZXXLUVUEUVXGUVWMUUYOUVUJUUWFU
      VXGUVWMXLYXLUVULUUWGUUYKXVDVYCXGWVLYQUVWNXXLXYJUVWKYYQUVXEUUXKUVWLXHUVWNX
      XTUUYKRSQZXVDVLQGZXYJTUUXGWLIZUUYOUVWMUVXIXYJUUWOUUYOUVXIXYJUVWMUUYOUVXIK
      ZUVVFUVVGXYJUVXIUVVFUUYOXXTUVXHXVDVYNZNUVXKTUVXHXXTYYOUVXKYGWGUUYOUVXHHGU
      VXIUUYOUVXHUUYKVVRZVYOWHUVXIUUYTUUYOUVXIXXTUVXLVYQNUUYOTUVXHUOIUVXIUUYOUV
      XHUVXMVYTWHUVXIUVXHXXTWLIUUYOXXTUVXHXVDVYRNYRUVVPWUBYOYQUVWNXXLXYJUVXJUVX
      EYUBTXYAVOFZVNFZUUXGWLYUBUVXNYUBYWMXYAYWJGZUVXNXMGXNXXLOYWJXXTXVAYXFYFZYW
      JXMXYAVOWSVBWVMYUBUUXGUUXJUVXOUVXFYUBYWMUVXPUUXJUVXOMXNUVXQYWJXMXYAVNVOVY
      JVBYLWVNXBWVOWWAWVBYXLUVWBXXLUUYOUVWCWVCUUYOUVXBUUWOUVXCNWVPYSXXLUUYJUUYN
      XLZYXLXXLUUXSUVXRUUYFUUYIUUYMEULOYYIXXTUUYLXVOWLWUGWVQWBWHVYDWVRUUYHXXTXV
      OUUWOYYJHXXTXXLYYJHJZYXLXXLUUXTUVXSUUYEOHYYIWOWBWHWVSUUWOUVWJUUYGUUXDWHWV
      TYAWWBXBWWCYXMXVIHJZYXRHJZYXRUNFZTMYXTXVJMXVBUVXTYXLXVBXVHHJZDXVEVKUVXTXV
      BUVYCDXVEXVBXXLXYKUVYCYYAXXOXVFXVDYMZYUEXVGXXMGZUVYCYUEXUTXXMXVGYXCYUFWTZ
      UVYEXVHXVGWWKFZXVGWWLFZPQZHUVYEXVHUVYGUVYHVJZPFUVYIUVYEXVGUVYJPXVGHHWWDWI
      UVYGUVYHPYIWWEZUVYEUVYGHGZUVYHHGZUVYIHJXVGHHWWFZXVGHHWWGZUVYGUVYHWWHXAWWI
      WBXHYSDXVEXVHHWWJXJWHYXLUVYAXVBYXLYXRUVUQHYXLYXRYXQUVUQYXLUVUIYXNYXOGYXOL
      VCYXRYXQMUVUKYXNWWMYXOYXNWWNDYXOYXQWWOUYMTTPQZUVUQYXQUUVPUVYPUVUQMVVKTWWP
      URTTPYIVUIWWEZYYOUVUQHJYGTHWWQURWWRNYXMUVYBUVUQUNFZTYXLUVYBUVYRMXVBYXLYXR
      UVUQUNUVYQWINYYOUVYRTMYGTWWSURVVHXVIYXRWWTWXBYLUTWXAWXCNUWRXVBYXLXVKKZWYH
      WYAXVBXXLUVYSWYHXXOXXLUVYSKXVIWYGGZXVIAJZXVKWYHXXLUVYTUVYSXXLXVHWYGGZDXVE
      VKZUVYTXXLUWUBDXVEYYAXXLXYKUWUBUVYDYUEUVYEUWUBUVYFUVYEXVHUVYIWYGUVYKUVYEU
      VYLUVYMUVYIWYGGUVYNUVYOUVYGUVYHWXDXAWVJWBYNYSWYPXVEWXLGUWUCUVYTUUDRXVDWXE
      DXVEXVHWXPHWXFWXGUXQWBWHXXLUWUAUVYSXXLXVHAJZDXVEVKUWUAXXLUWUDDXVEYYAXXLXY
      KUWUDUVYDYUEYUJYULUWUDYUFYURYULYUAUWUDXUHUWUDUDXVGXUQXUFXVGMXUGXVHAXUFXVG
      PUSWDXDXEWXHYNYSDXVEXVHAWWJXJWHXXLYXLXVKWXIWYFUWUAXVKKCXVIWYGWYBXVIMZWYCU
      WUAWYEXVKWYBXVIAUUJUWUEWYDXVJBUOWYBXVIUNUSUTUUKUULWXJXBWXKWXMYOWXNWXO $.

    $( The difference between two sets measurable by the criterion in
       ~ ismblfin is itself measurable by the same.  Corollary 0.3 of
       [Viaclovsky7] p. 3.  (Contributed by Brendan Leahy, 25-Mar-2018.)
       (Revised by Brendan Leahy, 13-Jul-2018.) $)
    mblfinlem3 $p |- ( ( ( A C_ RR /\ ( vol* ` A ) e. RR ) /\
      ( B C_ RR /\ ( vol* ` B ) e. RR ) /\
        ( ( vol* ` A ) = sup ( { y | E. b e. ( Clsd ` ( topGen ` ran (,) ) )
      ( b C_ A /\ y = ( vol ` b ) ) } , RR , < ) /\
        ( vol* ` B ) = sup ( { y | E. b e. ( Clsd ` ( topGen ` ran (,) ) )
      ( b C_ B /\ y = ( vol ` b ) ) } , RR , < ) ) ) -> sup ( { y |
        E. b e. ( Clsd ` ( topGen ` ran (,) ) ) ( b C_ ( A \ B ) /\
      y = ( vol ` b ) ) } , RR , < ) = ( vol* ` ( A \ B ) ) ) $=
      ( vv cr wss covol cfv wcel wa wceq wrex clt wbr cle syl co adantr c0 cvol
      vu vs vw vz vx vf cv cioo crn cab csup w3a cdif a1i difss ovolsscl mp3an1
      wn weq eqeq1 anbi2d rexbidv simprl ssdifss ovolss syl2anr wb cxr uniretop
      cldss ovolcl adantrr sylib opnmbl difmbl eqeltrrd mblvol sylan9eqr breq2d
      sylancr adantl mpbid rexlimdvaa imp adantlr wi c3 crp cc0 ancoms cn ax-mp
      cmin sylancl sylan ltsubrpd simpr breqtrd wne wral cvv reex sseq1 anbi12d
      ssex fveq2 3expb sylan2 eqeltrd retop rspcev mp2an breq2 resubcld syl2anc
      wex rexab ex ad2antlr ccom caddc cin sstri ad5antr inss1 readdcld mp3an12
      c1 jctil ad2antrr ad3antrrr eqcomd fveq2d mblsplit recnd cc mpbird cmul
      c2 ctg ccld wor ltso 3ad2ant1 vex elab xrlenlt id cdm dfss4 cldopn notbid
      rembl adantrl bitr4d sylan2b 3ad2antl1 simplr resubcl posdif biimpd elrpd
      cdiv impr nnrp rpdivcl eleq1d sseq2 anbi1d abbidv sseq1d neeq1d 3anbi123d
      3nn raleqdv imbi12d abssdv ctop 0cld 0mbl ovol0 eqtr2i pm3.2i eqeq2d c0ex
      0ss spcev abn0 biimpri mp1i wal eqbrtrd alrimiv ralab sylibr ralbidv 3jca
      vtoclg mpcom rpred suprlub ad2antll expr sylbid rexlimiva exlimiv simplrr
      sylbi anim12d reeanv syl6ibr cuni cxp cmap cabs cseq ovolgelb 3expa an32s
      eqid elmapi ssid ovollb mpan2 cpnf cico ovolsf frn icossxr syl6ss supxrcl
      wf 3syl readdcl rexrd rncoss unissi unirnioo sseqtr4i xrletr mpand anim2d
      reximdva mpd rexex indif2 df-ss biimpi difeq1d syl5eq ctb retopbas uniopn
      bastg opncld incld simprll simplll ssdif2d eqcoms biantrud adantlll simpl
      bitr3d ad4antlr difdif2 fveq2i unssi ovolge0 xrrege0 syl2an jctir ad4antr
      cun jca ovolun syl22anc ssdif incom eqtri simprrl syl5eqss unss12 ad6antr
      unss syl21anc letrd eleq1 vtoclga sseqin2 sylan9eq oveq2d adantll simp-6r
      subaddd simpll simp-4l simprlr ltsub23d eqbrtrrd ad5antlr simp-4r npncand
      eqtrd simplrl sylan9ssr eqtr4d 3eqtrd ad3antlr simprr lesubadd2d leltaddd
      dfss1 simprrr lt2addd df-3 2cn ax-1cn addcomi oveq1i rpcnd adddir mulid2d
      2timesd oveq12d 3cn 3ne0 divcan2 mp3an23 eqtr3d lelttrd syl5eqbr ltsub13d
      subadd2d 3eqtr4rd breqtrrd fvex rexlimdvva syld exp31 com34 3imp1 eqsupd
      exlimddv ) BFGZBHIZFJZKZCFGZCHIZFJZKZWUGDUHZBGZAUHZWUNUAIZLZKZDUIUJZUUAIZ
      UUBIZMZAUKZFNULZLZWUKWUNCGZWURKZDWVBMZAUKZFNULZLZKZUMZUBEFWUNBCUNZGZWURKZ
      DWVBMZAUKZWVOHIZNFNUUCWVNUUDUOWUIWUMWVTFJZWVMWVOBGZWUFWUHWWABCUPZWVOBUQUR
      ZUUEWUIWUMUBUHZWVSJZWVTWWENOZUSZWVMWUFWWFWWHWUHWWFWUFWVPWWEWUQLZKZDWVBMZW
      WHWVRWWKAWWEUBUUFAUBUTZWVQWWJDWVBWWLWURWWIWVPWUPWWEWUQVAVBVCUUGWUFWWKWWHW
      UFWWJWWHDWVBWUFWUNWVBJZWWJKZKZWUNHIZWVTPOZWWHWWNWVPWVOFGZWWQWUFWWMWVPWWIV
      DBFCVEZWUNWVOVFVGWWOWWQWVTWWPNOZUSZWWHWUFWWMWWQWXAVHZWWJWWMWWPVIJZWVTVIJZ
      WXBWUFWWMWUNFGZWXCWUNWVAFVJVKZWUNVLQWUFWWRWXDWWSWVOVLQWWPWVTUUHVGVMWWNWWH
      WXAVHZWUFWWMWWIWXGWVPWWMWWIKZWWGWWTWXHWWEWWPWVTNWWIWWMWWEWUQWWPWWIUUIWWMW
      UNUAUUJZJZWUQWWPLWWMFFWUNUNZUNZWUNWXIWWMWXEWXLWUNLWXFWUNFUUKVNWWMFWXIJWXK
      WXIJZWXLWXIJUUNWWMWXKWVAJWXMWUNWVAFVJUULWXKVOQFWXKVPWAVQZWUNVRQZVSVTUUMUU
      OWBUUPWCWDWEUUQWFUURWUIWUMWVMWWEFJZWWEWVTNOZKZWWEEUHZNOZEWVSMZWUIWUMWXRWV
      MWYAWUIWUMWXRWVMWYAWGWUIWUMKZWXRKZWVMUCUHZBGZWUGWVTWWEWNRZWHUVDRZWNRZWYDU
      AIZNOZKZUDUHZCGZWUKWYGWNRZWYLUAIZNOZKZKZUDWVBMUCWVBMZWYAWYCWVMWYKUCWVBMZW
      YQUDWVBMZKWYSWYCWVFWYTWVLXUAWUIWXRWVFWYTWGWUMWUIWXRKZWVFWYTXUBWVFKZWYHWXS
      NOZEWVDMZWYTXUCWYHWVENOZXUEXUCWYHWUGWVENXUBWYHWUGNOWVFXUBWUGWYGWUFWUHWXRU
      USZWUIWWAWXRWYGWIJZWWDWWAWXRKZWYFWIJWHWIJZXUHXUIWYFWWAWXPWYFFJZWXQWVTWWEU
      UTZVMWWAWXPWXQWJWYFNOZWWAWXPKWXQXUMWXPWWAWXQXUMVHWWEWVTUVAWKUVBUVEUVCWHWL
      JXUJUVOWHUVFWMWYFWHUVGWOWPZWQSXUBWVFWRWSXUBXUFXUEVHZWVFXUBWVDFGZWVDTWTZUE
      UHZUFUHZPOZUEWVDXAZUFFMZUMZWYHFJXUOWUIXVCWXRBXBJZWUIXVCWUFXVDWUHBFXCXFSWX
      SFGZWXSHIZFJZKZWUNWXSGZWURKZDWVBMZAUKZFGZXVLTWTZXUTUEXVLXAZUFFMZUMZWGZWUI
      XVCWGEBXBWXSBLZXVHWUIXVQXVCXVSXVEWUFXVGWUHWXSBFXDXVSXVFWUGFWXSBHXGUVHXEXV
      SXVMXUPXVNXUQXVPXVBXVSXVLWVDFXVSXVKWVCAXVSXVJWUSDWVBXVSXVIWUOWURWXSBWUNUV
      IUVJVCUVKZUVLXVSXVLWVDTXVTUVMXVSXVOXVAUFFXVSXUTUEXVLWVDXVTUVPVCUVNUVQXVHX
      VMXVNXVPXVHXVKAFXVHXVJWUPFJDWVBXVHWWMXVJKZKWUPWWPFXWAWUPWWPLXVHXVJWWMWUPW
      UQWWPXVIWURWRWXOVSWBXWAXVHXVIWWPFJZWWMXVIWURVDXVIXVHXWBXVIXVEXVGXWBWUNWXS
      UQXHWKXIXJWDUVRXVKAXQZXVNXVHXVIWJWUQLZKZDWVBMZXWCTWVBJZTWXSGZWJTUAIZLZKZX
      WFWVAUVSJZXWGXKWVAUVTWMXWHXWJWXSUWGXWITHIZWJTWXIJXWIXWMLUWATVRWMUWBUWCUWD
      XWEXWKDTWVBWUNTLZXVIXWHXWDXWJWUNTWXSXDXWNWUQXWIWJWUNTUAXGUWEXEXLXMXVKXWFA
      WJUWFWUPWJLZXVJXWEDWVBXWOWURXWDXVIWUPWJWUQVAVBVCUWHWMXVNXWCXVKAUWIUWJUWKX
      VGXVEXVPXVEXVGXURXVFPOZUEXVLXAZXVPXVEXVIXURWUQLZKZDWVBMZXWPWGZUEUWLXWQXVE
      XXAUEXVEXWSXWPDWVBXVEWWMXWSKZKXURWWPXVFPXXBXURWWPLXVEXWSWWMXURWUQWWPXVIXW
      RWRWXOVSWBXXBXVEXVIWWPXVFPOZWWMXVIXWRVDXVIXVEXXCWUNWXSVFWKXIUWMWDUWNXVKXW
      TXWPUEAAUEUTZXVJXWSDWVBXXDWURXWRXVIWUPXURWUQVAVBVCUWOUWPXVOXWQUFXVFFXUSXV
      FLXUTXWPUEXVLXUSXVFXURPXNUWQXLXIWKUWRZUWSUWTSXUBWUGWYGXUGXUBWYGXUNUXAZXOU
      FUEEWVDWYHUXBXPSWCXUEWUOWXSWUQLZKZDWVBMZXUDKZEXQWYTWVCXXIXUDEAAEUTZWUSXXH
      DWVBXXKWURXXGWUOWUPWXSWUQVAZVBVCXRXXJWYTEXXIXUDWYTXXHXUDWYTWGDWVBWWMXXHKX
      UDWYHWUQNOZWYTXXGXUDXXMVHWWMWUOWXSWUQWYHNXNUXCWWMWUOXXMWYTWGXXGWWMWUOXXMW
      YTWYKWUOXXMKUCWUNWVBUCDUTZWYEWUOWYJXXMWYDWUNBXDXXNWYIWUQWYHNWYDWUNUAXGVTX
      EXLUXDVMUXEUXFWEUXGUXIQXSWFWYCWVLXUAWYCWVLKZWYNWXSNOZEWVJMZXUAXXOWYNWVKNO
      ZXXQXXOWYNWUKWVKNWYCWYNWUKNOWVLWYCWUKWYGWUIWUJWULWXRUXHZWUIWXRXUHWUMXUNWF
      WQSWYCWVLWRWSWYCXXRXXQVHZWVLWYCWVJFGZWVJTWTZXUTUEWVJXAZUFFMZUMZWYNFJXXTWU
      MXYEWUIWXRCXBJZWUMXYEWUJXYFWULCFXCXFSXVRWUMXYEWGECXBWXSCLZXVHWUMXVQXYEXYG
      XVEWUJXVGWULWXSCFXDXYGXVFWUKFWXSCHXGUVHXEXYGXVMXYAXVNXYBXVPXYDXYGXVLWVJFX
      YGXVKWVIAXYGXVJWVHDWVBXYGXVIWVGWURWXSCWUNUVIUVJVCUVKZUVLXYGXVLWVJTXYHUVMX
      YGXVOXYCUFFXYGXUTUEXVLWVJXYHUVPVCUVNUVQXXEUWSUWTXTWYCWUKWYGXXSWUIWXRWYGFJ
      ZWUMXXFWFZXOUFUEEWVJWYNUXBXPSWCXXQWVGXXGKZDWVBMZXXPKZEXQXUAWVIXYLXXPEAXXK
      WVHXYKDWVBXXKWURXXGWVGXXLVBVCXRXYMXUAEXYLXXPXUAXYKXXPXUAWGDWVBWWMXYKKXXPW
      YNWUQNOZXUAXXGXXPXYNVHWWMWVGWXSWUQWYNNXNUXCWWMWVGXYNXUAWGXXGWWMWVGXYNXUAW
      YQWVGXYNKUDWUNWVBUDDUTZWYMWVGWYPXYNWYLWUNCXDXYOWYOWUQWYNNWYLWUNUAXGVTXEXL
      UXDVMUXEUXFWEUXGUXIQXSUXJWYKWYQUCUDWVBWVBUXKUXLWYCCUIUGUHZYAUJZUXMZGZXYRH
      IZWUKWYGYBRZPOZKZWYSWYAWGUGWYCYUCUGPFFUXNYCZWLUXORZMZYUCUGXQWYCXYSYBUXPWN
      YAXYPYAZYIUXQZUJZVINULZYUAPOZKZUGYUEMZYUFWUIWXRWUMYUMWUMXUBYUMXUBWUMXUHYU
      MXUNWUJWULXUHYUMCWYGYUHUGYUHUYAZUXRUXSXIWKUXTWYCYULYUCUGYUEWYCXYPYUEJZKYU
      KYUBXYSYUOWYCWLYUDXYPUYMZYUKYUBWGXYPYUDWLUYBWYCYUPKXYTYUJPOZYUKYUBYUPYUQW
      YCYUPXYRXYRGYUQXYRUYCXYRYUHXYPYUNUYDUYEWBYUPYUJVIJZYUAVIJZYUQYUKKYUBWGZWY
      CYUPWLWJUYFUYGRZYUHUYMZYUIVIGYURYUHXYPYUGYUGUYAYUNUYHYVBYUIYVAVIWLYVAYUHU
      YIWJUYFUYJUYKYUIUYLUYNWUIWXRWUMYUSXUBWUMKYUAWUMWULXYIYUAFJZXUBWUJWULWRZXX
      FWUKWYGUYOVGUYPUXTXYTVIJZYURYUSYUTXYRFGZYVEXYRWUTUXMFXYQWUTUIXYPUYQZUYRUY
      SUYTZXYRVLWMZXYTYUJYUAVUAURVGVUBXIVUCVUDVUEYUCUGYUEVUFQWYCYUCKZWYRWYAUCUD
      WVBWVBYVJWYDWVBJZWYLWVBJZKZKZWYRWYAYVNWYRKZWVPXXGKZDWVBMZWXTKZEXQZWYAYVOW
      VPWYDXYRUNZUAIZWUQLZKZDWVBMZWWEYWANOZYVSYUCYVMWYRYWDWYCYUCYVMKZWYRKZYVTWV
      BJZYVTWVOGZYWDYVMYWHYUCWYRYVKYWHYVLYVKWYDFXYRUNZYCZYVTWVBYVKWYDFGZYWKYVTL
      WYDWVAFVJVKYWLYWKWYDFYCZXYRUNYVTWYDFXYRVUGYWLYWMWYDXYRYWLYWMWYDLWYDFVUHVU
      IVUJVUKQYVKYWJWVBJZYWKWVBJXWLXYRWVAJZYWNXKXWLXYQWVAGYWOXKXYQWUTWVAYVGWUTV
      ULJWUTWVAGVUMWUTVULVUOWMYDXYQWVAVUNXMZXYRWVAFVJVUPXMWYDYWJWVAVUQUYEVQSXTY
      WGWYDBCXYRYWFWYEWYJWYQVURXYSYUBYVMWYRVUSVUTZYWCYWIDYVTWVBWUNYVTLZWVPYWCYW
      IYWRYWBWVPYWBYVTWUNYVTWUNUAXGVVAVVBWUNYVTWVOXDVVEXLXPVVCYVOWWEWVTWVOYVTUN
      ZHIZWNRZYWANYVOYWTWVTWWEWUIYWTFJZWUMWXRYUCYVMWYRYWSBGWUFWUHYXBYWSWVOBWVOY
      VTUPWWCYDYWSBUQURYEZWUIWWAWUMWXRYUCYVMWYRWWDYEZWXRWXPWYBYUCYVMWYRWXPWXQVV
      DVVFYVOYWTWVOWYDUNZWVOXYRYCZVVOZHIZWYFNYWSYXGHWVOWYDXYRVVGVVHYVOYXHBWYDUN
      ZHIZXYRWYLUNZHIZYBRZWYFWUIYXHFJZWUMWXRYUCYVMWYRYXGBGWUFWUHYXNYXEYXFBYXEWV
      OBWVOWYDUPWWCYDYXFWVOBWVOXYRYFWWCYDVVIYXGBUQURYEZYVOYXJYXLWUIYXJFJZWUMWXR
      YUCYVMWYRYXIBGWUFWUHYXPBWYDUPYXIBUQURZYEZYVJYXLFJZYVMWYRYVJXYTFJZYXSWYCYV
      EYVCKWJXYTPOZYUBKYXTYUCWYCYVCYVEWYCWUKWYGXXSXYJYGYVIYJYUCYUBYYAXYSYUBWRYV
      FYYAYVHXYRVVJWMYJXYTYUAVVKVVLZYXKXYRGYVFYXTYXSXYRWYLUPZYVHYXKXYRUQYHQZYKZ
      YGZWYCXUKYUCYVMWYRWUIWXRXUKWUMWUIWXPXUKWXQWUIWWAWXPXUKWWDXULWPVMZWFYLYVOY
      XHYXIYXKVVOZHIZYXMYXOYVJYYIFJZYVMWYRYVJYYIVIJZYXMFJWJYYIPOZYYIYXMPOZYYJWU
      FYYKWUHWUMWXRYUCWUFYYHFGZYYKWUFYXIFGZYXKFGZKYYNWUFYYOYYPBFWYDVEZYXKXYRFYY
      CYVHYDZVVMYXIYXKFVWFVNZYYHVLQVVNYVJYXJYXLWUIYXPWUMWXRYUCYXQYLYYDYGWUFYYLW
      UHWUMWXRYUCWUFYYNYYLYYSYYHVVJQVVNYVJYYOYXPKZYYPYXSKZYYMWUIYYTWUMWXRYUCWUI
      YYOYXPWUFYYOWUHYYQSYXQVVPYLYVJYXSYYPYYDYYRYJYXIYXKVVQZXPYYIYXMVVKVVRYKYYF
      YVOYXGYYHGZYYNYXHYYIPOYVOYXEYXIGZYXFYXKGUUUCWWBUUUDWWCWVOBWYDVVSWMYVOYXFX
      YRBYCZCUNZYXKYXFXYRWVOYCUUUFWVOXYRVVTXYRBCVUGVWAYVOUUUEXYRWYLCUUUEXYRGYVO
      XYRBYFUOYVNWYKWYMWYPVWBVUTVWCYXEYXIYXFYXKVWDWAWUFYYNWUHWUMWXRYUCYVMWYRYYS
      VWEYXGYYHVFXPYVOYYOYXPUUUAYYMWUFYYOWUHWUMWXRYUCYVMWYRYYQVWEYXRYVOYXSYYPYY
      EYYRYJUUUBVWGVWHYVOYXMWYGWYGWYGYBRZYBRZWYFNYVOYXJYXLWYGUUUGYXRYYEWYCXYIYU
      CYVMWYRXYJYLZWYCUUUGFJYUCYVMWYRWYCWYGWYGXYJXYJYGYLYVOWUGWYIWNRZYXJWYGNYVO
      UUUJWUGBWYDYCZHIZWNRZYXJYVMWYRUUUJUUUMLYVJYVMWYRKWYIUUULWUGWNYVMWYRWYIWYD
      HIZUUULYVKWYIUUUNLZYVLYVKWYDWXIJZUUUOWXJUUUPDWYDWVBWUNWYDWXIVWIWXNVWJZWYD
      VRQSZWYEUUUNUUULLWYJWYQWYEWYDUUUKHWYEUUUKWYDWYEUUUKWYDLWYDBVWKVUIYMYNYKVW
      LVWMVWNYVOUUUMYXJLUUULYXJYBRZWUGLZYVNUUUTWYRYVMUUUPWUIUUUTYVJYVKUUUPYVLUU
      UQSWUIWUMWXRYUCVUSUUUPWUFWUHUUUTUUUPWUFWUHUMWUGUUUSWYDBYOYMXHVGSYVOWUGUUU
      LYXJYVOWUGWUFWUHWUMWXRYUCYVMWYRVWOZYPWUIUUULYQJWUMWXRYUCYVMWYRWUIUUULUUUK
      BGWUFWUHUUULFJBWYDYFUUUKBUQURYPYEWUIYXJYQJWUMWXRYUCYVMWYRWUIYXJYXQYPYEVWP
      YRVXEYVOWUGWYGWYIUUVAUUUIYVOWYIUUUNFYVMUUUOYVJWYRUUURXTWYRWYEWUIUUUNFJZYV
      NWYEWYJWYQVWQWUIWUMWXRYUCYVMVWRWYEWUFWUHUUVBWYDBUQXHVGXJYVNWYEWYJWYQVWSVW
      TVXAYVOXYTWUKWNRZWUKWYOWNRZYBRZYXLUUUGNYVOUUVEXYTWYOWNRXYTXYRWYLYCZHIZWNR
      ZYXLYVOXYTWUKWYOYVJXYTYQJYVMWYRYVJXYTYYBYPZYKYVOWUKWUMWULWUIWXRYUCYVMWYRY
      VDVXBZYPYVOWYOYVOWYOWYLHIZFYVMWYOUUVKLZYVJWYRYVLUUVLYVKYVLWYLWXIJZUUVLWXJ
      UUVMDWYLWVBWUNWYLWXIVWIWXNVWJZWYLVRQWBXTZWYRWYMWUMUUVKFJZYVNWYKWYMWYPVDZW
      UIWUMWXRYUCYVMVXCWYMWUJWULUUVPWYLCUQXHVGXJZYPVXDYVOWYOUUVGXYTWNYVOWYOUUVK
      UUVGUUVOYVOUUVFWYLHYVOWYLXYRGUUVFWYLLWYRYVNWYLCXYRUUVQWYCXYSYUBYVMVXFVXGW
      YLXYRVXNVNYNVXHVWMYVOUUVHYXLLZUUVGYXLYBRZXYTLZYVNUUWAWYRYVMUUVMYVFYXTKUUW
      AYVJYVLUUVMYVKUUVNWBYVJYXTYVFYYBYVHYJUUVMYVFYXTUUWAUUVMYVFYXTUMXYTUUVTWYL
      XYRYOYMXHVGSYVJUUVSUUWAVHYVMWYRYVJXYTUUVGYXLUUVIYVJUUVGYVJYXTUUVGFJZYYBUU
      VFXYRGYVFYXTUUWBXYRWYLYFYVHUUVFXYRUQYHQYPYVJYXLYYDYPVWPYKYRVXIYVOUUVCUUVD
      WYGWYGYVJUUVCFJYVMWYRYVJXYTWUKYYBWUMWULWUIWXRYUCYVDVXJZXOYKYVOWUKWYOUUVJU
      UVRXOUUUIUUUIYVJUUVCWYGPOZYVMWYRYVJUUWDYUBWYCXYSYUBVXKYVJXYTWUKWYGYYBUUWC
      WYCXYIYUCXYJSVXLYRYKYVOWUKWYGWYOUUVJUUUIUUVRYVNWYKWYMWYPVXOVWTVXMVXAVXPWY
      CUUUHWYFLZYUCYVMWYRWUIWXRUUWEWUMXUBWHWYGYSRZUUUHWYFXUBUUWFYIYTYBRZWYGYSRZ
      UUUHWHUUWGWYGYSWHYTYIYBRUUWGVXQYTYIVXRVXSVXTVWAVYAXUBUUWHYIWYGYSRZYTWYGYS
      RZYBRZUUUHXUBWYGYQJZUUWHUUWKLZXUBWYGXUNVYBZYIYQJYTYQJUUWLUUWMVXSVXRYIYTWY
      GVYCYHQXUBUUWIWYGUUWJUUUGYBXUBWYGUUWNVYDXUBWYGUUWNVYEVYFVXEVUKXUBWYFYQJZU
      UWFWYFLZXUBWYFYYGYPUUWOWHYQJWHWJWTUUWPVYGVYHWYFWHVYIVYJQVYKWFYLWSVYLVYMVY
      NYVOWVOYVTYCZHIZYVTHIZYXAYWAYVOUUWQYVTHYVOYWIUUWQYVTLYUCYVMWYRYWIWYCYWQVV
      CYVTWVOVXNVNYNYVOYXAUUWRLUUWRYWTYBRZWVTLZYVOYVTWXIJZWWRWWAKZUUXAYVMUUXBYV
      JWYRYVKUUXBYVLYVKUUUPXYRWXIJZUUXBUUUQYWOUUXDYWPXYRVOWMZWYDXYRVPZWOSXTWUIU
      UXCWUMWXRYUCYVMWYRWUIWWRWWAWUFWWRWUHWWSSWWDVVPYEUUXBUUXCKWVTUUWTUUXBWWRWW
      AWVTUUWTLYVTWVOYOXHYMXPYVOWVTYWTUUWRYVOWVTYXDYPYVOYWTYXCYPYVOUUWRWUIUUWRF
      JZWUMWXRYUCYVMWYRUUWQBGWUFWUHUUXGUUWQWVOBWVOYVTYFWWCYDUUWQBUQURYEYPVYOYRY
      VMYWAUUWSLZYVJWYRYVKUUXHYVLYVKUUUPUUXDUUXHUUUQUUXEUUUPUUXDKUUXBUUXHUUXFYV
      TVRQWOSXTVYPVYQYVRYWDYWEKEYWAYVTUAVYRWXSYWALZYVQYWDWXTYWEUUXIYVPYWCDWVBUU
      XIXXGYWBWVPWXSYWAWUQVAVBVCWXSYWAWWENXNXEUWHXPWVRYVQWXTEAXXKWVQYVPDWVBXXKW
      URXXGWVPXXLVBVCXRUWPXSVYSWUEVYTWUAWUBWUCWUD $.

    $( Backward direction of ~ ismblfin .  (Contributed by Brendan Leahy,
       28-Mar-2018.)  (Revised by Brendan Leahy, 13-Jul-2018.) $)
    mblfinlem4 $p |- ( ( ( A C_ RR /\ ( vol* ` A ) e. RR ) /\ A e. dom vol ) ->
      ( vol* ` A ) = sup ( { y | E. b e. ( Clsd ` ( topGen ` ran (,) ) )
        ( b C_ A /\ y = ( vol ` b ) ) } , RR , < ) ) $=
      ( cr wss covol cfv wcel wa wceq wrex clt wbr cle cxr cdif caddc co adantr
      syl vu vv vf vg vs cvol cv cioo crn wn wi weq eqeq1 anbi2d rexbidv simprl
      csup ovolss wb ovolcl adantl syl2anc ancoms sylan2 simprrr uniretop cldss
      sylib opnmbl difmbl eqeltrrd mblvol ad2antrl ad2antrr wex ccom cuni c1 cn
      cin cmin cseq crp eqid ovolgelb wf elmapi ssid ovollb cc0 cpnf ovolsf frn
      mpan2 syl6ss supxrcl rexrd rncoss unissi unirnioo sseqtr4i xrletr syl2anr
      ax-mp mp3an1 mpand adantll anim2d reximdva mpd rexex difss sstri ad4antlr
      3syl jctil mp2an mp3an12 ovolge0 xrrege0 adantrr readdcld ad3antlr syl2an
      impr sylan resubcld retop ctb uniopn ovolsscl ad5antr inss1 mp3an2 eqcomd
      mblsplit recnd mpbird dfss1 fveq2d cdm ctg ccld cab wor ltso a1i vex elab
      simplr sstr xrlenlt mpbid dfss4 rembl cldopn sylancr breq2d mtbird syl5bi
      eqtrd rexlimdvaa imp cxp cmap cabs 1rp mp3an3 cico icossxr peano2re mpani
      c2 cdiv resubcl posdif biimpd elrpd rphalfcld rehalfcld ltsubrpd retopbas
      jctl ctop bastg mblfinlem2 indif2 df-ss difeq1d syl5eq opncld incld simpr
      simpl ssdif2d dfin4 inss2 eqsstr3i sseq1 anbi1d fveq2 eqcoms bitr4d an12s
      biantrud rspcev adantrrr adantlr simp-6r cun difdif2 fveq2i unssi ssdifss
      ad3antrrr ssinss1 ovolun syl22anc ssdif sylancl vtoclga cc subaddd biimpi
      eleq1 oveq2d ad2antll eqtr3d breqtrd ltsub23d lelttrd ad4antr ssun2 incom
      3sstr4i pm3.2i mp1i mpan oveq1d eqtr2d lesubadd2d eqbrtrrd letrd ltleaddd
      simprr 2halvesd ad2ant2r syl5eqbr ltsub13d ad2ant2rl eqtr4d simp-4l 3expb
      recn subadd2d breqtrrd fvex breq2 anbi12d spcev rexlimddv exlimddv sylibr
      rexab eqsupd ) BDEZBFGZDHZIZBUFUUAZHZIZCUGZBEZAUGZVVMUFGZJZIZCUHUIZUUBGZU
      UCGZKZAUUDZDLUQVVGVVLUAUBDVWCVVGLDLUUEVVLUUFUUGVVFVVHVVKUUJZVVLUAUGZVWCHZ
      VVGVWELMZUJZVVFVWFVWHUKVVHVVKVWFVVNVWEVVPJZIZCVWAKZVVFVWHVWBVWKAVWEUAUUHA
      UAULZVVRVWJCVWAVWLVVQVWIVVNVVOVWEVVPUMUNUOUUIVVFVWJVWHCVWAVVFVVMVWAHZVWJI
      ZIZVWGVVGVVMFGZLMZVWNVVFVVNVWQUJZVWMVVNVWIUPVVNVVFVWRVVNVVFIZVWPVVGNMZVWR
      VVMBURVWSVWPOHZVVGOHZVWTVWRUSVWSVVMDEZVXAVVMBDUUKVVMUTTVVFVXBVVNBUTVAVWPV
      VGUULVBUUMVCVDVWOVWEVWPVVGLVWOVWEVVPVWPVVFVWMVVNVWIVEVWMVVPVWPJZVVFVWJVWM
      VVMVVJHZVXDVWMDDVVMPZPZVVMVVJVWMVXCVXGVVMJVVMVVTDVFVGVVMDUUNVHVWMDVVJHVXF
      VVJHZVXGVVJHUUOVWMVXFVVTHVXHVVMVVTDVFUUPVXFVITDVXFVJUUQVKZVVMVLTVMUVAUURU
      USUVBUUTVNUVCVVLVWEDHZVWEVVGLMZIZIZVVNUBUGZVVPJZIZCVWAKZVWEVXNLMZIZUBVOZV
      XRUBVWCKVXMBUHUCUGZVPUIZVQZEZVYCFGZVVGVRQRZNMZIZVXTUCVVIVYHUCVOZVVKVXLVVI
      VYHUCNDDUVDVTZVSUVERZKZVYIVVIVYDQUVFWAVPZVYAVPZVRWBZUIZOLUQZVYFNMZIZUCVYK
      KZVYLVVFVVHVRWCHVYTUVGBVRVYOUCVYOWDZWEUVHVVIVYSVYHUCVYKVVIVYAVYKHZIVYRVYG
      VYDWUBVVIVSVYJVYAWFZVYRVYGUKZVYAVYJVSWGVVHWUCWUDVVFVVHWUCIVYEVYQNMZVYRVYG
      WUCWUEVVHWUCVYCVYCEWUEVYCWHVYCVYOVYAWUAWIWNVAWUCVYQOHZVYFOHZWUEVYRIVYGUKZ
      VVHWUCVSWJWKUVIRZVYOWFZVYPOEWUFVYOVYAVYNVYNWDWUAWLWUJVYPWUIOVSWUIVYOWMWJW
      KUVJZWOVYPWPXOVVHVYFVVGUVKZWQZVYEOHZWUFWUGWUHVYCDEZWUNVYCVVSVQZDVYBVVSUHV
      YAWRZWSWTXAZVYCUTXDZVYEVYQVYFXBXEXCXFXGVDXHXIXJVYHUCVYKXKTVNVXMVYHIZVYCBP
      ZUHUDUGZVPUIZVQZEZWVDFGZWVAFGZVVGVWEWARZUVMUVNRZQRZNMZIZVXTUDWUTWVLUDVYKK
      ZWVLUDVOWUTWVEQVYMWVBVPZVRWBZUIZOLUQZWVJNMZIZUDVYKKZWVMWUTWVGDHZWVIWCHZWV
      TWUTWVGOHZVYFDHZIZWJWVGNMZWVGVYFNMZIWWAVVHWWEVVFVVKVXLVYHVVHWWDWWCWULWVAD
      EZWWCWVAVYCDVYCBXLZWURXMZWVAUTXDZXPXNWUTWWGWWFVXMVYDVYGWWGVVHVYGWWGUKVVFV
      VKVXLVYDVVHWVGVYENMZVYGWWGWVAVYCEWUOWWLWWIWURWVAVYCURXQVVHWUGWWLVYGIWWGUK
      ZWUMWWCWUNWUGWWMWWKWUSWVGVYEVYFXBXRTUVLXNYEWWHWWFWWJWVAXSXDXPWVGVYFXTVBZV
      XMWWBVYHVVLVVHVXLWWBVWDVVHVXLIZWVHWWOWVHVVHVXJWVHDHZVXKVVGVWEUVOZYAZVVHVX
      JVXKWJWVHLMZVVHVXJIZVXKWWSVXJVVHVXKWWSUSVWEVVGUVPVCUVQYEUVRUVSYFSZWWHWWAW
      WBWVTWWJWVAWVIWVOUDWVOWDZWEXEVBWUTWVSWVLUDVYKWUTWVBVYKHZIWVRWVKWVEWXCWUTV
      SVYJWVBWFZWVRWVKUKWVBVYJVSWGWUTWXDIWVFWVQNMZWVRWVKWXDWXEWUTWXDWVDWVDEWXEW
      VDWHWVDWVOWVBWXBWIWNVAWXDWVQOHZWVJOHZWXEWVRIWVKUKZWUTWXDVSWUIWVOWFZWVPOEW
      XFWVOWVBWVNWVNWDWXBWLWXIWVPWUIOVSWUIWVOWMWUKWOWVPWPXOWUTWVJWUTWVGWVIWWNVX
      MWVIDHZVYHVVLVVHVXLWXJVWDWWOWVHWWRUVTYFZSZYBZWQWVFOHZWXFWXGWXHWVDDEZWXNWV
      DWUPDWVCVVSUHWVBWRZWSWTXAZWVDUTXDZWVFWVQWVJXBXEXCXFVDXHXIXJWVLUDVYKXKTWUT
      WVLIZUEUGZVYCEZVYEWVIWARZWXTFGZLMZIZVXTUEVWAWUTWYEUEVWAKZWVLWUTWYBDHZWYBV
      YELMZWYFWUTVYEWVIVXMWUNWWDIZWJVYENMZVYGIZVYEDHZVYHVVHWYIVVFVVKVXLVVHWWDWU
      NWULWUSXPYCVYGWYKVYDVYGWYJWUOWYJWURVYCXSXDUWCVAVYEVYFXTYDZWXLYGWUTVYEWVIW
      YMWXAUWAVYCVVTHZWYGWYHWYFVVTUWDHZVYBVVTEWYNYHVYBVVSVVTWUQVVSYIHVVSVVTEUWB
      VVSYIUWEXDZXMVYBVVTYJXQZVYCWYBUEUWFXEVBSWXSWXTVWAHZWYEIZIZVVNWXTWVDPZUFGZ
      VVPJZIZCVWAKZVWEXUBLMZVXTWVLWYSXUEWUTWVEWYSXUEWVKWVEWYRWYAXUEWYDWYRWVEWYA
      XUEWYRXUAVWAHXUABEZXUEWVEWYAIZWYRWXTDWVDPZVTZXUAVWAWYRXUJWXTDVTZWVDPXUAWX
      TDWVDUWGWYRXUKWXTWVDWYRWXTDEXUKWXTJWXTVVTDVFVGWXTDUWHVHUWIUWJWYRXUIVWAHZX
      UJVWAHWYOWVDVVTHZXULYHWYOWVCVVTEXUMYHWVCVVSVVTWXPWYPXMWVCVVTYJXQZWVDVVTDV
      FUWKXQWXTXUIVVTUWLWNVKXUHXUAVYCWVAPZBXUHWXTVYCWVAWVDWVEWYAUWMWVEWYAUWNUWO
      XUOVYCBVTBVYCBUWPVYCBUWQUWRWOZXUDXUGCXUAVWAVVMXUAJZXUDXUGXUCIXUGXUQVVNXUG
      XUCVVMXUABUWSUWTXUQXUCXUGXUCXUAVVMXUAVVMUFUXAUXBUXEUXCUXFYDUXDUXGUXHXGWYT
      VWEVVGBXUAPZFGZWARZXUBLWYTXUSVVGVWEVVIXUSDHZVVKVXLVYHWVLWYSXURBEVVFVVHXVA
      BXUAXLXURBYKXEZYLVVFVVHVVKVXLVYHWVLWYSUXIVXLVXJVVLVYHWVLWYSVXJVXKUWNZXNWY
      TXUSBWXTPZBWVDVTZUXJZFGZWVHLXURXVFFBWXTWVDUXKUXLWYTXVGXVDFGZXVEFGZQRZWVHV
      VIXVGDHZVVKVXLVYHWVLWYSXVFBEVVFVVHXVKXVDXVEBBWXTXLZBWVDYMZUXMXVFBYKXEYLWY
      TXVHXVIVVIXVHDHZVVKVXLVYHWVLWYSXVDBEVVFVVHXVNXVLXVDBYKXEZYLZVVIXVIDHZVVKV
      XLVYHWVLWYSXVEBEVVFVVHXVQXVMXVEBYKXEZYLZYBVXMWWPVYHWVLWYSVVLVVHVXJWWPVXLV
      WDXVCWWQYDUXOVVIXVGXVJNMZVVKVXLVYHWVLWYSVVIXVDDEZXVNXVEDEZXVQXVTVVFXWAVVH
      BDWXTUXNSXVOVVFXWBVVHBWVDDUXPSXVRXVDXVEUXQUXRYLWYTXVJWVIWVIQRZWVHLWYTXVHX
      VIWVIWVIXVPXVSWXSWXJWYSVXMWXJVYHWVLWXKVNZSZXWEWYTXVHVYEWYCWARZWVIXVPWYTVY
      EWYCWUTWYLWVLWYSWYMVNZWYSWYAWYLWYCDHZWXSWYRWYAWYDUPWUTWYLWVLWYMSZWYAWUOWY
      LXWHWURWXTVYCYKYNXCZYGXWEWYTXVHVYCWXTPZFGZXWFNVYHXVHXWLNMZVXMWVLWYSVYDXWM
      VYGVYDXVDXWKEXWKDEXWMBVYCWXTUXSXWKVYCDVYCWXTXLZWURXMXVDXWKURUXTSYCWYTVYEV
      YCWXTVTZFGZWARZXWLXWFWYTXWQXWLJXWPXWLQRZVYEJWYTVYEXWRWYSWXTVVJHZWYLVYEXWR
      JZWXSWYRXWSWYEVXEXWSCWXTVWAVVMWXTVVJUYEVXIUYAZSXWIXWSWUOWYLXWTWURWXTVYCYP
      YNXCYOWYTVYEXWPXWLWYTVYEXWGYQWYTXWPWUTXWPDHZWVLWYSWUTWYLXXBWYMXWOVYCEWUOW
      YLXXBVYCWXTYMWURXWOVYCYKXRTVNYQWUTXWLUYBHWVLWYSWUTXWLWUTWYLXWLDHZWYMXWKVY
      CEWUOWYLXXCXWNWURXWKVYCYKXRTYQVNUYCYRWYEXWQXWFJZWXSWYRWYAXXDWYDWYAXWPWYCV
      YEWAWYAXWOWXTFWYAXWOWXTJWXTVYCYSUYDYTUYFSUYGUYHUYIWYTVYEWVIWYCXWGXWEXWJWX
      SWYRWYAWYDVEUYJUYKWXSXVIWVINMWYSWXSXVIWVDWVAPZFGZWVIVVIXVQVVKVXLVYHWVLXVR
      UYLWXSWVFDHZXXFDHZWUTWXNWVJDHZIWJWVFNMZWVKIXXGWVLWUTXXIWXNWXMWXRXPWVLWVKX
      XJWVEWVKUWMWXOXXJWXQWVDXSXDXPWVFWVJXTYDZXXEWVDEWXOXXGXXHWVDWVAXLZWXQXXEWV
      DYKXRTZXWDXVEXXEEZXXEDEZIXVIXXFNMWXSXXNXXOWVDBVTZWVDVYCPZXXPUXJXVEXXEXXPX
      XQUYMBWVDUYNWVDVYCBUXKUYOXXEWVDDXXLWXQXMUYPXVEXXEURUYQWXSWVFWVGWARZXXFWVI
      NWXSXXRXXFJWVGXXFQRZWVFJWXSWVFWVDWVAVTZFGZXXFQRZXXSWXSWVAVVJHZXXGWVFXYBJZ
      VVKXYCVVIVXLVYHWVLVYCVVJHZVVKXYCWYNXYEWYQVYCVIXDVYCBVJUYRXNXXKXYCWXOXXGXY
      DWXQWVAWVDYPYNVBWVEXYBXXSJWUTWVKWVEXYAWVGXXFQWVEXXTWVAFWVEXXTWVAJWVAWVDYS
      UYDYTUYSVMUYTWXSWVFWVGXXFWXSWVFXXKYQWXSWVGWUTWWAWVLWWNSZYQWXSXXFXXMYQUYCY
      RWXSXXRWVINMWVKWUTWVEWVKVUEWXSWVFWVGWVIXXKXYFXWDVUAYRVUBVUCSVUDVXMXWCWVHJ
      ZVYHWVLWYSVVIVXJXYGVVKVXKVVHVXJXYGVVFWWTWVHWWTWVHWWQYQVUFXGVUGUXOUYIUYKVU
      HVUIWYTXUBBXUAVTZFGZXUTWVLWYSXUBXYIJWUTWVLWYSIXUBXUAFGZXYIWYRXUBXYJJZWVLW
      YEWYRXUAVVJHZXYKWYRXWSWVDVVJHZXYLXXAXUMXYMXUNWVDVIXDWXTWVDVJUXTZXUAVLTVMW
      VEWYEXYIXYJJZWVKWYRWVEWYAXYOWYDXUHXYHXUAFXUHXUGXYHXUAJXUPXUABYSVHYTYAVUJV
      UKXGWYTXUTXYIJZXYIXUSQRZVVGJZWYSXYLVVIXYRWXSWYRXYLWYEXYNSVVIVVKVXLVYHWVLV
      ULXYLVVIIVVGXYQXYLVVFVVHVVGXYQJXUABYPVUMYOXCVVIXYPXYRUSVVKVXLVYHWVLWYSVVI
      VVGXUSXYIVVHVVGUYBHVVFVVGVUNVAVVIXUSXVBYQVVIXYIXYHBEVVFVVHXYIDHBXUAYMXYHB
      YKXEYQVUOYLYRVUKVUPVXSXUEXUFIUBXUBXUAUFVUQVXNXUBJZVXQXUEVXRXUFXYSVXPXUDCV
      WAXYSVXOXUCVVNVXNXUBVVPUMUNUOVXNXUBVWELVURVUSVUTVBVVAVVBVVBVWBVXQVXRUBAAU
      BULZVVRVXPCVWAXYTVVQVXOVVNVVOVXNVVPUMUNUOVVDVVCVVEYO $.


    $( Measurability in terms of inner and outer measure.  Proposition 7 of
       [Viaclovsky8] p. 3.  (Contributed by Brendan Leahy, 4-Mar-2018.)
       (Revised by Brendan Leahy, 28-Mar-2018.) $)
    ismblfin $p |- ( ( A C_ RR /\ ( vol* ` A ) e. RR ) -> ( A e. dom vol <->
        ( vol* ` A ) = sup ( { y | E. b e. ( Clsd ` ( topGen ` ran (,) ) )
          ( b C_ A /\ y = ( vol ` b ) ) } , RR , < ) ) ) $=
      ( vv vu va vz vc cr wss cfv wcel wa wceq wrex clt cle wbr cc0 c0 vw vf vx
      vt covol cvol cv cioo crn cab csup cin cdif caddc co wi wral ccom cuni cn
      cxr wf inss1 ovolsscl mp3an1 difss readdcld ad3antlr ovolcl mp1i ad2antlr
      cpnf eqid syl ad2antrr simpr breqtrrd adantlll wn wb ax-mp eleq1 uniretop
      cldss sylib sylancr vtoclga mblvol sylan9eqr adantl mpan2 ad2antrl mp3an2
      wne ancoms sylan2 eqeltrd rexlimdvaa abssdv weq eqeq1 anbi2d ralab ovolss
      rexbidv sylancl eqbrtrd rexlimiva mpgbir breq2 ralbidv rspcev retop sseq1
      0ss pm3.2i fveq2 eqeq2d anbi12d mp2an c0ex elab mpbir ne0i suprcl syl2anc
      mp3an12 sstri simpll abbii supeq1i a1i id vex adantr mpbid wex ex cbvrexv
      sylan cdm ctg ccld mblfinlem4 cpw elpwi cabs cmin cseq cxp cmap crab ccnv
      c1 elmapi rexrd rncoss unissi unirnioo sseqtr4i ovolsf frn icossxr syl6ss
      cico supxrcl 3syl pnfge nltpnft necon2abii ovolge0 0re xrre3 mpanl12 mpan
      sylbir dfss4 rembl cldopn opnmbl difmbl sstr ctop 0cld 0mbl eqtr2i difss2
      eqeltrrd ovol0 ssrin ssdif le2addd dfin4 fveq2i oveq1i sseq2i anbi1i jctl
      syl6breq rexbii jctil wor ltso xrlenlt notbid adantrl bitr4d ctb retopbas
      sylbi bastg uniopn mblfinlem2 eqcomd anim1i anim2d fvex spcev anasss syl6
      reximia r19.41v rexcom4 3bitr4i eqsupd syl6eq syl6bb cbvabv eqeq2i biimpi
      exbii rexab mblfinlem3 syl112anc syl5eq oveq12d supadd wal reeanv anbi12i
      syl5reqr bitr4i an4 cun oveq12 ss2in ineq1i incom disjdif 3eqtri syl6sseq
      jctir 3expa ad2ant2r ad2ant2rl volun syl32anc unmbl syl2an eqtr3d anim12i
      ss0 eqtr unss syl5bir rexlimdvva rexlimdvv alrimiv 2rexbidv sylibr sselda
      expl w3a readdcl anandis 00id eqcomi rspceov mp3an mpdan suprleub mpancom
      abn0 3jca mpbird letrd pm2.61dane adantlr ssid ovollb rexlimdva ralrimivw
      xrletrd ralrab ssrab2 infmxrgelb ovolval ralrimiva ismbl2 baibr impbida
      expr ) BIJZBUEKZILZMZBUFUUAZLZVXDCUGZBJZAUGZVXIUFKZNZMZCUHUIZUUBKZUUCKZOZ
      AUJZIPUKZNZABCUUDVXFVYAMZUAUGZUEKZILZVYCBULZUEKZVYCBUMZUEKZUNUOZVYDQRZUPZ
      UAIUUEZUQZVXHVYBVYLUAVYMVYCVYMLVYBVYCIJZVYLVYCIUUFVYBVYOVYEVYKVYBVYOVYEMZ
      MZVYJVYCUHUBUGZURUIZUSZJZDUGZUNUUGUUHURVYRURZUUNUUIZUIZVAPUKZNZMZUBQIIUUJ
      ULZUTUUKUOZOZDVAUULZVAPUUMUKZVYDQVYQVYJWUMQRZVYJEUGZQRZEWULUQZVYQWUAWUOWU
      FNZMZUBWUJOZWUPUPZEVAUQWUQVYQWVAEVAVYQWUSWUPUBWUJVYRWUJLVYQUTWUIVYRVBZWUS
      WUPUPVYRWUIUTUUOVYQWVBMZWUAWURWUPWVCWUAMZWURMVYJWUFWUOQWVDVYJWUFQRWURWVDV
      YJVYTUEKZWUFVYPVYJVALZVYBWVBWUAVYPVYJVYPVYGVYIVYFVYCJVYOVYEVYGILZVYCBVCVY
      FVYCVDVEZVYHVYCJVYOVYEVYIILZVYCBVFVYHVYCVDVEZVGZUUPZVHVYTIJZWVEVALZWVDVYT
      VXOUSIVYSVXOUHVYRUUQZUURUUSUUTZVYTVIZVJWVBWUFVALZVYQWUAWVBUTSVLUVEUOZWUDV
      BZWUEVAJWVRWUDVYRWUCWUCVMWUDVMZUVAWVTWUEWVSVAUTWVSWUDUVBSVLUVCUVDWUEUVFUV
      GVKVYQWUAVYJWVEQRZWVBVYQWUAMZWWBWVEVLVYPWUAWVEVLNZWWBVYBVYPWUAMZWWDMVYJVL
      WVEQVYPVYJVLQRZWUAWWDVYPWVFWWFWVLVYJUVHVNVOWWEWWDVPVQVRWVEVLWNZWWCWVEILZW
      WBWWGWVEVLPRZWWHWWIWVEVLWVNWWDWWIVSVTWVMWVNWVPWVQWAZWVEUVIWAUVJSWVEQRZWWI
      WWHWVMWWKWVPVYTUVKWAWVNSILWWKWWIMWWHWWJUVLWVESUVMUVNUVOUVPWWCWWHMZVYJFUGZ
      VYTBULZJZGUGZWWMUFKZNZMZFVXQOZGUJZIPUKZHUGZVYTBUMZJZWWPWXCUFKZNZMZHVXQOZG
      UJZIPUKZUNUOZWVEVYPVYJILVYBWUAWWHWVKVHWWHWXLILWWCWWHWXBWXKWWHWXAIJZVXKUCU
      GZQRZAWXAUQZUCIOZWXBILZWWHWWTGIWWHWWSWWPILZFVXQWWHWWMVXQLZWWSMZMWWPWWMUEK
      ZIWYAWWPWYBNWWHWWSWXTWWPWWQWYBWWOWWRVPWXTWWMVXGLZWWQWYBNZVXIVXGLZWYCCWWMV
      XQVXIWWMVXGWBVXIVXQLZIIVXIUMZUMZVXIVXGWYFVXIIJWYHVXINVXIVXPIWCWDVXIIUVQWE
      WYFIVXGLWYGVXGLZWYHVXGLUVRWYFWYGVXPLWYIVXIVXPIWCUVSWYGUVTVNIWYGUWAWFUWHZW
      GZWWMWHVNZWIWJWYAWWHWWMVYTJZWYBILZWWOWYMWXTWWRWWOWWNVYTJZWYMVYTBVCZWWMWWN
      VYTUWBWKZWLWYMWWHWYNWYMWVMWWHWYNWVPWWMVYTVDZWMWOWPWQWRWSZWWHVXKWVEQRZAWXA
      UQZWXQXUAWWOVXKWWQNZMZFVXQOZWYTUPAWWTXUDWYTAGGAWTZWWSXUCFVXQXUEWWRXUBWWOW
      WPVXKWWQXAXBXEXCXUCWYTFVXQWXTXUCMVXKWYBWVEQXUCWXTVXKWWQWYBWWOXUBVPWYLWIWW
      OWYBWVEQRZWXTXUBWWOWYMWVMXUFWYQWVPWWMVYTXDXFWLXGXHXIWXPXUAUCWVEIWXNWVENZW
      XOWYTAWXAWXNWVEVXKQXJZXKXLWKZWXMWXATWNZWXQWXRSWXALZXUJXUKWWOSWWQNZMZFVXQO
      ZTVXQLZTWWNJZSTUFKZNZMZXUNVXPUWCLZXUOXMVXPUWDWAZXUPXURWWNXOXUQTUEKZSTVXGL
      XUQXVBNUWETWHWAUWIUWFZXPXUMXUSFTVXQWWMTNZWWOXUPXULXURWWMTWWNXNXVDWWQXUQSW
      WMTUFXQXRXSXLXTWWTXUNGSYAWWPSNZWWSXUMFVXQXVEWWRXULWWOWWPSWWQXAXBXEYBYCZWX
      ASYDZWAUCAWXAYEWMYFWWHWXJIJZWXOAWXJUQZUCIOZWXKILZWWHWXIGIWWHWXHWXSHVXQWWH
      WXCVXQLZWXHMZMWWPWXCUEKZIXVMWWPXVNNWWHWXHXVLWWPWXFXVNWXEWXGVPXVLWXCVXGLZW
      XFXVNNZWYEXVOCWXCVXQVXIWXCVXGWBWYJWGZWXCWHVNZWIWJXVMWWHWXCVYTJZXVNILZWXEX
      VSXVLWXGWXCVYTBUWGZWLXVSWWHXVTXVSWVMWWHXVTWVPWXCVYTVDZWMWOWPWQWRWSZWWHWYT
      AWXJUQZXVJXWDWXEVXKWXFNZMZHVXQOZWYTUPAWXIXWGWYTAGXUEWXHXWFHVXQXUEWXGXWEWX
      EWWPVXKWXFXAZXBXEXCXWFWYTHVXQXVLXWFMVXKXVNWVEQXWFXVLVXKWXFXVNWXEXWEVPXVRW
      IWXEXVNWVEQRZXVLXWEWXEXVSWVMXWIXWAWVPWXCVYTXDZXFWLXGXHXIXVIXWDUCWVEIXUGWX
      OWYTAWXJXUHXKXLWKZXVHWXJTWNZXVJXVKSWXJLZXWLXWMWXESWXFNZMZHVXQOZXUOTWXDJZX
      URMZXWPXVAXWQXURWXDXOXVCXPXWOXWRHTVXQWXCTNZWXEXWQXWNXURWXCTWXDXNXWSWXFXUQ
      SWXCTUFXQXRXSXLXTWXIXWPGSYAXVEWXHXWOHVXQXVEWXGXWNWXEWWPSWXFXAXBXEYBYCZWXJ
      SYDZWAUCAWXJYEWMYFVGWJWWCWWHVPWWLVYJVYTWXDUMZUEKZWXDUEKZUNUOZWXLQVYPWUAWW
      HVYJXXEQRVYBWWEWWHMZVYJWWNUEKZXXDUNUOXXEQXXFVYGVYIXXGXXDVYPWVGWUAWWHWVHVO
      VYPWVIWUAWWHWVJVOWWHXXGILZWWEWYOWVMWWHXXHWYPWVPWWNVYTVDYGWJWWHXXDILZWWEWX
      DVYTJWVMWWHXXIVYTBVFZWVPWXDVYTVDYGZWJWUAVYGXXGQRZVYPWWHWUAVYFWWNJWWNIJXXL
      VYCVYTBUWJWWNVYTIWYPWVPYHVYFWWNXDXFVKWUAVYIXXDQRZVYPWWHWUAVYHWXDJWXDIJZXX
      MVYCVYTBUWKWXDVYTIXXJWVPYHZVYHWXDXDXFVKUWLXXGXXCXXDUNWWNXXBUEVYTBUWMZUWNU
      WOUWSVRWWCVYBWWHWXLXXENVYBVYPWUAYIVYBWWHMZWXBXXCWXKXXDUNXXQWXBWWMXXBJZWWR
      MZFVXQOZGUJZIPUKZXXCIWXAXYAPWWTXXTGWWSXXSFVXQWWOXXRWWRWWNXXBWWMXXPUWPUWQU
      WTYJYKXXQWVMWWHMZXXNXXIMZWVEWYMWWRMZFVXQOZGUJZIPUKZNXXDWWMWXDJZWWRMZFVXQO
      ZGUJZIPUKZNXYBXXCNWWHXYCVYBWWHWVMWVPUWRWJZWWHXYDVYBWWHXXIXXNXXKXXOUXAWJXX
      QWVEXVSWXGMZHVXQOZGUJZIPUKZXYHWWHWVEXYRNZVYBWWHXYRWVEWWHUCAIXYQWVEPIPUXBW
      WHUXCYLWWHYMWXNXYQLZWVEWXNPRZVSZWWHXYTXVSWXNWXFNZMZHVXQOZYUBXYPYUEGWXNUCY
      NGUCWTZXYOYUDHVXQYUFWXGYUCXVSWWPWXNWXFXAXBXEYBYUDYUBHVXQXVLYUDMZXWIYUBXVS
      XWIXVLYUCXVSWVMXWIWVPXWJWKWLYUGXWIWVEXVNPRZVSZYUBXVLXWIYUIVTZYUDXVLXVNVAL
      ZWVNYUJXVLWXCIJYUKWXCVXPIWCWDWXCVIVNWWJXVNWVEUXDXFYOXVLYUCYUBYUIVTZXVSXVL
      YUCMWXNXVNNZYULYUCXVLWXNWXFXVNYUCYMXVRWIYUMYUAYUHWXNXVNWVEPXJUXEVNUXFUXGY
      PXHUXJWJWXNILZWXNWVEPRZMZWXNVXKPRZAXYQOZWWHYUPXVSXWEMZYUQMZAYQZHVXQOZYURY
      UPXVSWXNXVNPRZMZHVXQOZYVBVYTVXPLZYUNYUOYVEXUTVYSVXPJYVFXMVYSVXOVXPWVOVXOU
      XHLVXOVXPJUXIVXOUXHUXKWAYHVYSVXPUXLXTVYTWXNHUXMVEYVDYVAHVXQXVLYVDXVSXVNWX
      FNZYVCMZMYVAXVLYVCYVHXVSXVLYVCYVHXVLYVGYVCXVLWXFXVNXVRUXNUXOYRUXPXVSYVGYV
      CYVAYUTXVSYVGMZYVCMAXVNWXCUEUXQVXKXVNNZYUSYVIYUQYVCYVJXWEYVGXVSVXKXVNWXFX
      AXBVXKXVNWXNPXJXSUXRUXSUXTUYAVNYUTHVXQOZAYQYUSHVXQOZYUQMZAYQYVBYURYVKYVMA
      YUSYUQHVXQUYBUYKYUTHAVXQUYCXYPYVLYUQAGXUEXYOYUSHVXQXUEWXGXWEXVSXWHXBXEUYL
      UYDWEWJUYEUXNWJZIXYQXYGPXYPXYFGXYOXYEHFVXQHFWTZXVSWYMWXGWWRWXCWWMVYTXNYVO
      WXFWWQWWPWXCWWMUFXQXRZXSYSYJYKUYFXXQXYMWXKXXDIWXJXYLPWXIXYKGWXHXYJHFVXQYV
      OWXEXYIWXGWWRWXCWWMWXDXNYVPXSYSYJYKXXQXYCVXFXYSVXDWXCBJZWXGMZHVXQOZGUJZIP
      UKZNZWXKXXDNXYNVXFVYAWWHYIYVNVYAYWBVXFWWHVYAYWBVXTYWAVXDIVXSYVTPVXRYVSAGA
      GWTZVXRVXJWWPVXLNZMZCVXQOYVSYWCVXNYWECVXQYWCVXMYWDVXJVXKWWPVXLXAXBXEYWEYV
      RCHVXQCHWTZVXJYVQYWDWXGVXIWXCBXNYWFVXLWXFWWPVXIWXCUFXQXRXSYSUYGUYHYKUYIUY
      JVKGVYTBHUYMUYNZVUAGVYTWXDFUYMUYNUYOYWGUYPYTVQWWHWXLWVEQRWWCWWHWXLUDUGZWU
      OWUBUNUOZNZDWXJOEWXAOZUDUJZIPUKZWVEQWWHUCAUDEWXAWXJYWLDWYSXUKXUJWWHXVFXVG
      VJXUIXWCXWMXWLWWHXWTXXAVJXWKYWLVMUYQWWHYWMWVEQRZWYTAYWLUQZWWHVXKYWINZDWXJ
      OEWXAOZWYTUPZAUYRYWOWWHYWRAWWHYWPWYTEDWXAWXJWUOWXALZWUBWXJLZMZWWOWUOWWQNZ
      MZWXEWUBWXFNZMZMZHVXQOFVXQOZWWHYWPWYTUPZYXGYXCFVXQOZYXEHVXQOZMYXAYXCYXEFH
      VXQVXQUYSYWSYXIYWTYXJWWTYXIGWUOEYNGEWTZWWSYXCFVXQYXKWWRYXBWWOWWPWUOWWQXAX
      BXEYBWXIYXJGWUBDYNGDWTZWXHYXEHVXQYXLWXGYXDWXEWWPWUBWXFXAXBXEYBUYTVUBWWHYX
      FYXHFHVXQVXQYXFWWOWXEMZYXBYXDMZMWWHWXTXVLMZMZYXHWWOWXEYXBYXDVUCYXPYXMYXNY
      XHYXPYXMMZYXNMZYWPWYTYXRYWPMVXKWWMWXCVUDZUEKZWVEQYXRYWIYXTNZYWPVXKYXTNZYX
      NYXQYWIWWQWXFUNUOZYXTWUOWWQWUBWXFUNVUEYXQYXSUFKZYYCYXTYXQWYCXVOWWMWXCULZT
      NZWWQILWXFILYYDYYCNYXOWYCWWHYXMWXTWYCXVLWYKYOVKYXOXVOWWHYXMXVLXVOWXTXVQWJ
      VKYXMYYFYXPYXMYYETJYYFYXMYYEWWNWXDULZTWWMWWNWXCWXDVUFYYGXXBWXDULWXDXXBULT
      WWNXXBWXDXXPVUGXXBWXDVUHWXDVYTVUIVUJVUKYYEVVBVNWJYXQWWQWYBIYXOWYDWWHYXMWX
      TWYDXVLWYLYOVKWWHWWOWYNYXOWXEWWOWWHWYNWWOWYMWVMMWWHWYNWWOWYMWVMWYQWVPVULW
      YMWVMWWHWYNWYRVUMYTWOVUNWQYXQWXFXVNIYXOXVPWWHYXMXVLXVPWXTXVRWJVKWWHWXEXVT
      YXOWWOWXEWWHXVTWXEXVSWVMMWWHXVTWXEXVSWVMXWAWVPVULXVSWVMWWHXVTXWBVUMYTWOVU
      OWQWWMWXCVUPVUQYXOYYDYXTNZWWHYXMYXOYXSVXGLZYYHWXTWYCXVOYYIXVLWYKXVQWWMWXC
      VURVUSYXSWHVNVKVUTWIYWPYYAYYBVXKYWIYXTVVCWOYTYXMYXTWVEQRZYXPYXNYWPYXMYXSV
      YTJZWVMYYJYXMWYMXVSMYYKWWOWYMWXEXVSWYQXWAVVAWWMWXCVYTVVDWEWVPYXSVYTXDXFVH
      XGYRVVLVVEVVFVVEVVGVVHYWKYWQWYTAUDUDAWTYWJYWPEDWXAWXJYWHVXKYWIXAVVIXCVVJZ
      YWLIJZYWLTWNZWXOAYWLUQZUCIOZVVMWWHYWNYWOVTWWHYYMYYNYYPWWHYWKUDIWWHYWJYWHI
      LZEDWXAWXJWWHYXAMZYWJYYQYYRYWJMYWHYWIIYYRYWJVPYYRYWIILZYWJWWHYWSYWTYYSWWH
      YWSMWUOILWUBILYYSWWHYWTMWWHWXAIWUOWYSVVKWWHWXJIWUBXWCVVKWUOWUBVVNVUSVVOYO
      WQYRVVFWSYYNWWHYYNYWKUDYQZSYWINZDWXJOEWXAOZYYTXUKXWMSSSUNUOZNUUUBXVFXWTUU
      UCSVVPVVQEDWXAWXJSSSUNVVRVVSYWKUUUBUDSYAYWHSNYWJUUUAEDWXAWXJYWHSYWIXAVVIU
      XRWAYWKUDVWCYCYLWWHYWOYYPYYLYYOYWOUCWVEIXUGWXOWYTAYWLXUHXKXLVVTVWDUCAAYWL
      WVEVWAVWBVWEXGWJVWFWPVWGVWHWVBWVEWUFQRZVYQWUAWVBVYTVYTJUUUDVYTVWIVYTWUDVY
      RWWAVWJWKVKVWMYOWVDWURVPVQVVLWPVWKVWLWUKWUTWUPEDVADEWTZWUHWUSUBWUJUUUEWUG
      WURWUAWUBWUOWUFXAXBXEVWNVVJVYQWULVAJWVFWUNWUQVTWUKDVAVWOVYPWVFVYBWVLWJEWU
      LVYJVWPWFVWEVYOVYDWUMNVYBVYEDVYCUBWULWULVMVWQWLVQVXBWPVWRVXCVYNVXHVTVXEVY
      AVXHVXCVYNUABVWSVWTVOYPVXA $.
  $}

  ${
    $d f n m l x A $.
    ${
      ovoliunnfl.0 $e |- ( ( f Fn NN /\
          A. n e. NN ( ( f ` n ) C_ RR /\ ( vol* ` ( f ` n ) ) e. RR ) ) ->
            ( vol* ` U_ m e. NN ( f ` m ) ) <_
          sup ( ran seq 1 ( + , ( m e. NN |-> ( vol* ` ( f ` m ) ) ) ) ,
            RR* , < ) ) $.
      $( ~ ovoliun is incompatible with the Feferman-Levy model.  (Contributed
         by Brendan Leahy, 21-Nov-2017.) $)
      ovoliunnfl $p |- ( ( A ~<_ NN /\ A. x e. A x ~<_ NN ) -> U. A =/= RR ) $=
        ( vl cn wbr wral wa cr cc0 covol cfv wceq c0 wcel c1 cxr cdom cv wss wi
        cuni wne unieq syl6eq fveq2d ovol0 syl6req a1d cle ovolge0 ad2antll wfo
        uni0 wex csdm wb reldom brrelexi 0sdomg biimparc fodomr sylancom unissb
        cvv syl anbi1i r19.26 bitr4i cfn cen wo brdom2 com nnenom sdomen2 ax-mp
        isfinite orbi1i bitri ovolfi expcom ovolctb jaod syl5bi imdistani sylbi
        ex ralimi ancoms cima foima raleqdv wfn fofn sseq1 fveq2 eqeq1d anbi12d
        ssid ralima sylancl bitr3d ciun caddc cmpt cseq crn clt csup weq sseq1d
        cbvralv 0re eleq1a anim2i syl2an wfun fofun unieqd eqtrd adantr rspccva
        funiunfv simprd mpteq2dva seqeq3d rneqd supeq1d csn cxp fconstmpt eqtri
        cmul co 0xr cpnf cc 0cn ser1const mpan mul01d mpteq2ia seqeq3 cuz cz 1z
        nncn seqfn nnuz fneq2i dffn5 bitr3i mpbi eqtr3i 3eqtr4i rneqi ne0i rnxp
        1nn supeq1i wor xrltso supsn mp2an adantl 3brtr3d sylbid exlimiv ovolcl
        mp2b imp xrletri3 sylancr mpbir2and expl pm2.61ine mp1i ovolre neeqtrrd
        renepnf necon2i expr eqimss necon3bi pm2.61d1 ) BHUAIZAUBZHUAIZABJZKBUE
        ZLUCZUWNLUFZUWJUWMUWOUWPUWJUWMUWOKZKZMUWNNOZPZUWPUWRUWTUDBQBQPZUWTUWRUX
        AUWSQNOMUXAUWNQNUXAUWNQUEQBQUGUQUHUIUJUKULBQUFZUWJUWQUWTUXBUWJKZUWQKUWT
        MUWSUMIZUWSMUMIZUWOUXDUXCUWMUWNUNUOUXCHBCUBZUPZCURZUWKLUCZUWKNOZMPZKZAB
        JZUXEUWQUXBUWJQBUSIZUXHUWJUXNUXBUWJBVHRUXNUXBUTBHUAVAVBBVHVCVIVDHBCVEVF
        UWOUWMUXMUWOUWMKZUXIUWLKZABJZUXMUXOUXIABJZUWMKUXQUWOUXRUWMABLVGVJUXIUWL
        ABVKVLUXPUXLABUXIUWLUXKUWLUWKVMRZUWKHVNIZVOZUXIUXKUWLUWKHUSIZUXTVOUYAUW
        KHVPUYBUXSUXTUYBUWKVQUSIZUXSHVQVNIUYBUYCUTVRHVQUWKVSVTUWKWAVLWBWCUXIUXS
        UXKUXTUXSUXIUXKUWKWDWEUXIUXTUXKUWKWFWKWGWHWIWLWJWMUXHUXMUXEUXGUXMUXEUDC
        UXGUXMGUBZUXFOZLUCZUYENOZMPZKZGHJZUXEUXGUXLAUXFHWNZJZUXMUYJUXGUXLAUYKBH
        BUXFWOZWPUXGUXFHWQZHHUCUYLUYJUTHBUXFWRZHXCUXLUYIAGHHUXFUWKUYEPZUXIUYFUX
        KUYHUWKUYELWSUYPUXJUYGMUWKUYENWTXAXBXDXEXFUXGUYJUXEUXGUYJKDHDUBZUXFOZXG
        ZNOZXHDHUYRNOZXIZSXJZXKZTXLXMZUWSMUMUXGUYNEUBZUXFOZLUCZVUGNOZLRZKZEHJZU
        YTVUEUMIUYJUYOUYJVUHVUIMPZKZEHJVULUYIVUNGEHGEXNZUYFVUHUYHVUMVUOUYEVUGLU
        YDVUFUXFWTZXOVUOUYGVUIMVUOUYEVUGNVUPUIXAXBXPVUNVUKEHVUMVUJVUHMLRZVUMVUJ
        UDXQMLVUIXRVTXSWLWJFXTUXGUYTUWSPUYJUXGUYSUWNNUXGUYSUYKUEZUWNUXGUXFYAUYS
        VURPHBUXFYBDHUXFYGVIUXGUYKBUYMYCYDUIYEUYJVUEMPUXGUYJVUEXHDHMXIZSXJZXKZT
        XLXMZMUYJTVUDVVAXLUYJVUCVUTUYJVUBVUSXHSUYJDHVUAMUYJUYQHRKUYRLUCZVUAMPZU
        YIVVCVVDKGUYQHGDXNZUYFVVCUYHVVDVVEUYEUYRLUYDUYQUXFWTZXOVVEUYGVUAMVVEUYE
        UYRNVVFUIXAXBYFYHYIYJYKYLVVBMYMZTXLXMZMTVVAVVGXLVVAHVVGYNZXKZVVGVUTVVIG
        HUYDXHVVISXJZOZXIZGHMXIVUTVVIGHVVLMUYDHRZVVLUYDMYQYRZMMUUARVVNVVLVVOPUU
        BMUYDUUCUUDVVNUYDUYDUUKUUEYDUUFVVKVUTVVMVVIVUSPVVKVUTPDHMYOXHVVIVUSSUUG
        VTVVKSUUHOZWQZVVKVVMPZSUUIRVVQUUJXHVVISUULVTVVQVVKHWQVVRHVVPVVKUUMUUNGH
        VVKUUOUUPUUQUURGHMYOUUSUUTSHRHQUFVVJVVGPUVCHSUVAHVVGUVBUVNYPUVDTXLUVEMT
        RZVVHMPUVFYSTMXLUVGUVHYPUHUVIUVJWKUVKUVLUVOXTUWOUWTUXDUXEKUTZUXCUWMUWOV
        VSUWSTRVVTYSUWNUVMMUWSUVPUVQUOUVRUVSUVTUWNLMUWSUWNLPZMYTUWSVUQMYTUFVWAX
        QMUWDUWAVWAUWSLNOYTUWNLNWTUWBUHUWCUWEVIUWFUWOUWNLUWNLUWGUWHUWI $.
    $}

    $( Demonstration of ~ ovoliunnfl .  (Contributed by Brendan Leahy,
       21-Nov-2017.) $)
    ex-ovoliunnfl $p |- ( ( A ~<_ NN /\ A. x e. A x ~<_ NN ) -> U. A =/= RR )
        $=
      ( vf vm vn cv cn wfn cfv cr covol wcel wa wral caddc cmpt c1 eqid adantll
      wss cseq fveq2 sseq1d fveq2d eleq1d anbi12d rspccva simpld simprd ovoliun
      weq ovoliunnfl ) ABCDECFZGHZEFZUMIZJTZUPKIZJLZMZEGNZMDFZUMIZODGVCKIZPZQUA
      ZDVEVFRVERVAVBGLZVCJTZUNVAVGMZVHVDJLZUTVHVJMEVBGEDUKZUQVHUSVJVKUPVCJUOVBU
      MUBZUCVKURVDJVKUPVCKVLUDUEUFUGZUHSVAVGVJUNVIVHVJVMUISUJUL $.
  $}

  ${
    $d f g m n l x A $.
    voliunnfl.1 $e |- S = seq 1 ( + , G ) $.
    voliunnfl.2 $e |- G = ( n e. NN |-> ( vol ` ( f ` n ) ) ) $.
    voliunnfl.3 $e |- ( ( A. n e. NN ( ( f ` n ) e. dom vol /\
      ( vol ` ( f ` n ) ) e. RR ) /\ Disj_ n e. NN ( f ` n ) ) ->
        ( vol ` U_ n e. NN ( f ` n ) ) = sup ( ran S , RR* , < ) ) $.
    $( ~ voliun is incompatible with the Feferman-Levy model; in that model,
       therefore, the Lebesgue measure as we've defined it isn't actually a
       measure.  (Contributed by Brendan Leahy, 16-Dec-2017.) $)
    voliunnfl $p |- ( ( A ~<_ NN /\ A. x e. A x ~<_ NN ) -> U. A =/= RR ) $=
      ( vm cn wa cr cc0 cvol cfv wceq wcel c1 cxr vg cdom wbr wral cuni wss wne
      vl cv wi unieq uni0 syl6eq fveq2d covol cdm 0mbl mblvol ax-mp ovol0 eqtri
      c0 syl6req a1d wfo wex csdm cvv wb reldom brrelexi 0sdomg biimparc fodomr
      syl sylancom unissb anbi1i r19.26 bitr4i ovolctb2 imdistani ralimi ancoms
      sylbi cima foima raleqdv wfn fofn ssid sseq1 fveq2 eqeq1d anbi12d sylancl
      ex ralima bitr3d cfzo co ciun cdif caddc cmpt cseq crn clt csup ovolssnul
      wdisj difss mp3an1 ssdifss nulmbl biimpar 0re syl6eqel expcom ancld sylan
      adantl mpd syldan weq oveq2 iuneq1d difeq12d eleq1d adantr seqeq3 supeq1i
      rneqi seqeq3d rneqd supeq1d mpteq2ia eqtrd fconstmpt cpnf eqid fvex fvmpt
      difexg ralbiia cbvralv bitri iundisj2 disjeq2 mprg mpbir nnex mptex fveq1
      sylibr ralbidv disjeq2dv iuneq2d mpteq2dv eqeq12d imbi12d iuneq2i 3eqtr3g
      syl5eq vtocl fveq2i iundisj wfun fofun funiunfv syl5eqr unieqd sseq1d jca
      rspccva 3syl mpteq2dva csn cxp cmul cc 0cn ser1const mpan nncn mul01d cuz
      cz 1z seqfn nnuz fneq2i bitr3i mpbi eqtr3i 3eqtr4i 1nn ne0i rnxp mp2b wor
      dffn5 xrltso 0xr supsn mp2an 3eqtr3rd sylbid syl5 exlimiv expimpd renepnf
      pm2.61ine mp1i rembl ovolre neeqtrrd necon2i eqimss necon3bi pm2.61d1
      expr ) BKUBUCZAUIZKUBUCZABUDZLBUEZMUFZUYGMUGZUYCUYFUYHUYIUYCUYFUYHLZLZNUY
      GOPZQZUYIUYKUYMUJBVBBVBQZUYMUYKUYNUYLVBOPZNUYNUYGVBOUYNUYGVBUEVBBVBUKULUM
      UNUYOVBUOPZNVBOUPZRUYOUYPQUQVBURUSUTVAVCVDBVBUGZUYCUYJUYMUYRUYCLKBUAUIZVE
      ZUAVFZUYJUYMUJZUYRUYCVBBVGUCZVUAUYCVUCUYRUYCBVHRVUCUYRVIBKUBVJVKBVHVLVOVM
      KBUAVNVPUYTVUBUAUYJUYDMUFZUYDUOPZNQZLZABUDZUYTUYMUYHUYFVUHUYHUYFLZVUDUYEL
      ZABUDZVUHVUIVUDABUDZUYFLVUKUYHVULUYFABMVQVRVUDUYEABVSVTVUJVUGABVUDUYEVUFV
      UDUYEVUFUYDWAWQWBWCWEWDUYTVUHJUIZUYSPZMUFZVUNUOPZNQZLZJKUDZUYMUYTVUGAUYSK
      WFZUDZVUHVUSUYTVUGAVUTBKBUYSWGZWHUYTUYSKWIKKUFVVAVUSVIKBUYSWJKWKVUGVURAJK
      KUYSUYDVUNQZVUDVUOVUFVUQUYDVUNMWLVVCVUEVUPNUYDVUNUOWMWNWOWRWPWSUYTVUSUYMU
      YTVUSLEKEUIZUYSPZUHSVVDWTXAZUHUIZUYSPZXBZXCZXBZOPZXDEKVVJOPZXEZSXFZXGZTXH
      XIZUYLNVUSVVLVVQQZUYTVUSVVDJKVUNUHSVUMWTXAZVVHXBZXCZXEZPZUYQRZVWCOPZMRZLZ
      EKUDZEKVWCXKZVVRVUSVWAUYQRZVWAOPZMRZLZJKUDZVWHVURVWMJKVUOVUQVWAUOPZNQZVWM
      VWAVUNUFVUOVUQVWPVUNVVTXLVWAVUNXJXMVUOVWAMUFZVWPVWMVUNMVVTXNVWQVWPLVWJVWM
      VWAXOVWPVWJVWMUJVWQVWPVWJVWLVWJVWPVWLVWJVWPLVWKNMVWJVWKNQVWPVWJVWKVWONVWA
      URWNXPXQXRXSXTYBYCYAYDWCVWHVVJUYQRZVVMMRZLZEKUDVWNVWGVWTEKVVDKRZVWDVWRVWF
      VWSVXAVWCVVJUYQJVVDVWAVVJKVWBJEYEZVUNVVEVVTVVIVUMVVDUYSWMZVXBUHVVSVVFVVHV
      UMVVDSWTYFYGYHVWBUUAVVEVHRVVJVHRVVDUYSUUBVVEVVIVHUUDUSUUCZYIVXAVWEVVMMVXA
      VWCVVJOVXDUNZYIWOUUEVWTVWMEJKEJYEZVWRVWJVWSVWLVXFVVJVWAUYQVXFVVEVUNVVIVVT
      VVDVUMUYSWMVXFUHVVFVVSVVHVVDVUMSWTYFYGYHZYIVXFVVMVWKMVXFVVJVWAOVXGUNYIWOU
      UFUUGUUOVWIEKVVJXKZVVEVVHUHEVVDVVGUYSWMZUUHVWCVVJQVWIVXHVIEKEKVWCVVJUUIVX
      DUUJUUKVWHVWILZEKVWCXBZOPZXDEKVWEXEZSXFZXGZTXHXIZVVLVVQVVDDUIZPZUYQRZVXRO
      PZMRZLZEKUDZEKVXRXKZLZEKVXRXBZOPZCXGZTXHXIZQZUJVXJVXLVXPQZUJDVWBJKVWAUULU
      UMVXQVWBQZVYEVXJVYJVYKVYLVYCVWHVYDVWIVYLVYBVWGEKVYLVXSVWDVYAVWFVYLVXRVWCU
      YQVVDVXQVWBUUNZYIVYLVXTVWEMVYLVXRVWCOVYMUNZYIWOUUPVYLEKVXRVWCVYLVXRVWCQVX
      AVYMYJUUQWOVYLVYGVXLVYIVXPVYLVYFVXKOVYLEKVXRVWCVYMUURUNVYLVYIXDEKVXTXEZSX
      FZXGZTXHXIVXPTVYHVYQXHCVYPCXDFSXFZVYPGFVYOQVYRVYPQHXDFVYOSYKUSVAYMYLVYLTV
      YQVXOXHVYLVYPVXNVYLVYOVXMXDSVYLEKVXTVWEVYNUUSYNYOYPUVDUUTUVAIUVEVXKVVKOEK
      VWCVVJVXDUVBUVFTVXOVVPXHVXNVVOVXMVVNQVXNVVOQEKVWEVVMVXEYQXDVXMVVNSYKUSYMY
      LUVCWPYBUYTVVLUYLQVUSUYTVVKUYGOUYTVVKVUTUEZUYGUYTVVKEKVVEXBZVYSVVEVVHUHEV
      XIUVGUYTUYSUVHVYTVYSQKBUYSUVIEKUYSUVJVOUVKUYTVUTBVVBUVLYRUNYJVUSVVQNQUYTV
      USVVQXDEKNXEZSXFZXGZTXHXIZNVUSTVVPWUCXHVUSVVOWUBVUSVVNWUAXDSVUSEKVVMNVUSV
      XALVVEMUFZVVEUOPZNQZLZVVMNQVURWUHJVVDKVXBVUOWUEVUQWUGVXBVUNVVEMVXCUVMVXBV
      UPWUFNVXBVUNVVEUOVXCUNWNWOUVOWUHVVMVVJUOPZNWUHVVJMUFZWUINQZLVWRVVMWUIQWUH
      WUJWUKWUEWUJWUGVVEMVVIXNYJVVJVVEUFWUEWUGWUKVVEVVIXLVVJVVEXJXMZUVNVVJXOVVJ
      URUVPWULYRVOUVQYNYOYPWUDNUVRZTXHXIZNTWUCWUMXHWUCKWUMUVSZXGZWUMWUBWUOJKVUM
      XDWUOSXFZPZXEZJKNXEWUBWUOJKWURNVUMKRZWURVUMNUVTXAZNNUWARWUTWURWVAQUWBNVUM
      UWCUWDWUTVUMVUMUWEUWFYRYQWUQWUBWUSWUOWUAQWUQWUBQEKNYSXDWUOWUASYKUSWUQSUWG
      PZWIZWUQWUSQZSUWHRWVCUWIXDWUOSUWJUSWVCWUQKWIWVDKWVBWUQUWKUWLJKWUQUXBUWMUW
      NUWOJKNYSUWPYMSKRKVBUGWUPWUMQUWQKSUWRKWUMUWSUWTVAYLTXHUXANTRWUNNQUXCUXDTN
      XHUXEUXFVAUMYBUXGWQUXHUXIUXJVOUXKUXMUYGMNUYLUYGMQZNYTUYLNMRNYTUGWVEXQNUXL
      UXNWVEUYLMOPZYTUYGMOWMWVFMUOPZYTMUYQRWVFWVGQUXOMURUSUXPVAUMUXQUXRVOUYBUYH
      UYGMUYGMUXSUXTUYA $.
  $}

  ${
    $d f g n m l x A $.
    volsupnfl.0 $e |- ( ( f : NN --> dom vol /\
      A. n e. NN ( f ` n ) C_ ( f ` ( n + 1 ) ) ) ->
        ( vol ` U. ran f ) = sup ( ( vol " ran f ) , RR* , < ) ) $.
    $( ~ volsup is incompatible with the Feferman-Levy model.  (Contributed by
       Brendan Leahy, 2-Jan-2018.) $)
    volsupnfl $p |- ( ( A ~<_ NN /\ A. x e. A x ~<_ NN ) -> U. A =/= RR ) $=
      ( vm vl cn wral wa cr wss cc0 cvol cfv wceq c0 wcel syl c1 vg cdom wbr cv
      cuni wne unieq uni0 syl6eq fveq2d covol cdm 0mbl mblvol ax-mp ovol0 eqtri
      wi syl6req a1d wfo wex csdm cvv wb reldom brrelexi 0sdomg biimparc fodomr
      sylancom unissb anbi1i r19.26 bitr4i ovolctb2 nulmbl expcom adantl syldan
      eqtr syl5 jcai ralimi sylbi ancoms cfz co ciun cmpt crn cima cxr clt csup
      wf caddc cfn fzfi cuz fzssuz nnuz sseqtr4i ffvelrnda fveq2 eqeq1d anbi12d
      fof sylan an32s ralrimiva ssralv mpsyl sylancr adantr oveq2 iuneq1d iunex
      weq ovex fvmpt sseq12d fveq1 unieqd supeq1d sylancl cab df-iun rspcev wfn
      wrex eqtrd syl5eqr cpnf volf cle csu mblss 0re 0xr eleq1 simpld finiunmbl
      rspccva eqid fmptd fzssp1 iunss1 fvex mpbiri rgen nnex mptex feq1 ralbidv
      peano2nn rneq imaeq2d eqeq12d imbi12d vtocl eluzfz2 eleq2s eleq2d rexeqdv
      rexlimiva ssrexv cbvrexv sylib rexlimivw impbii eliun rexbii abbii dfiun3
      3eqtr2i fofn fniunfv forn csn ccom rnco2 cxp eqidd cicc a1i fmptco eleq1a
      feqmptd syl6bi imp jca ssid sseq1 eleq1d ralima raleqdv bitr3d ovolfiniun
      foima mpbird simprd sylan2 eqtr3d sumeq2d olci sumz breqtrd iunss ovolge0
      sylibr ovolcl xrletri3 mpbir2and mpteq2dva fconstmpt syl6eqr frn ffn fnco
      wo fnmpti mp3an12 3syl 1nn ne0i fconst5 mpbid xrltso supsn mp2an 3eqtr3rd
      wor ex exlimiv expimpd pm2.61ine renepnf mp1i rembl neeqtrrd necon2i expr
      ovolre eqimss necon3bi pm2.61d1 ) BHUBUCZAUDZHUBUCZABIZJBUEZKLZVULKUFZVUH
      VUKVUMVUNVUHVUKVUMJZJZMVULNOZPZVUNVUPVURURBQBQPZVURVUPVUSVUQQNOZMVUSVULQN
      VUSVULQUEQBQUGUHUIUJVUTQUKOZMQNULZRVUTVVAPUMQUNUOUPUQUSUTBQUFZVUHVUOVURVV
      CVUHJHBUAUDZVAZUAVBZVUOVURURZVVCVUHQBVCUCZVVFVUHVVHVVCVUHBVDRVVHVVCVEBHUB
      VFVGBVDVHSVIHBUAVJVKVVEVVGUAVUOVUIVVBRZVUINOZMPZJZABIZVVEVURVUMVUKVVMVUMV
      UKJZVUIKLZVUJJZABIZVVMVVNVVOABIZVUKJVVQVUMVVRVUKABKVLVMVVOVUJABVNVOVVPVVL
      ABVVOVUJVUIUKOZMPZVVLVUIVPVVOVVTJVVIVVKVUIVQVVTVVIVVKURVVOVVIVVJVVSPZVVTV
      VKVUIUNZVWAVVTVVKVVJVVSMWAVRWBVSWCVTWDWEWFVVEVVMVURVVEVVMJZFHGTFUDZWGWHZG
      UDZVVDOZWIZWJZWKZUEZNOZNVWJWLZWMWNWOZVUQMVWCHVVBVWIWPZDUDZVWIOZVWPTWQWHZV
      WIOZLZDHIZVWLVWNPZVWCFHVWHVVBVWIVWCVWHVVBRZVWDHRZVWCVWEWRRZVWGVVBRZGVWEIZ
      VXCTVWDWSZVWEHLZVWCVXFGHIVXGVWETWTOZHTVWDXAXBXCZVWCVXFGHVVEVWFHRZVVMVXFVV
      EVXLJZVWGBRZVVMVXFVVEHBVWFVVDHBVVDXHXDZVVMVXNVXFVVMVXNJZVXFVWGNOZMPZVVLVX
      FVXRJAVWGBVUIVWGPZVVIVXFVVKVXRVUIVWGVVBUUAVXSVVJVXQMVUIVWGNXEXFXGUUDZUUBW
      FXIXJZXKVXFGVWEHXLXMZVWEVWGGUUCXNXOZVWIUUEZUUFZVWTDHVWPHRZVWTGTVWPWGWHZVW
      GWIZGTVWRWGWHZVWGWIZLZVYGVYILVYKTVWPUUGGVYGVYIVWGUUHUOVYFVWQVYHVWSVYJFVWP
      VWHVYHHVWIFDXSGVWEVYGVWGVWDVWPTWGXPXQVYDGVYGVWGTVWPWGXTVWFVVDUUIZXRYAVYFV
      WRHRVWSVYJPVWPUUPFVWRVWHVYJHVWIVWDVWRPGVWEVYIVWGVWDVWRTWGXPXQVYDGVYIVWGTV
      WRWGXTVYLXRYASYBUUJUUKHVVBCUDZWPZVWPVYMOZVWRVYMOZLZDHIZJZVYMWKZUEZNOZNVYT
      WLZWMWNWOZPZURVWOVXAJZVXBURCVWIFHVWHUULUUMVYMVWIPZVYSWUFWUEVXBWUGVYNVWOVY
      RVXAHVVBVYMVWIUUNWUGVYQVWTDHWUGVYOVWQVYPVWSVWPVYMVWIYCVWRVYMVWIYCYBUUOXGW
      UGWUBVWLWUDVWNWUGWUAVWKNWUGVYTVWJVYMVWIUUQZYDUJWUGWMWUCVWMWNWUGVYTVWJNWUH
      UURYEUUSUUTEUVAYFVVEVWLVUQPVVMVVEVWKVULNVVEVWKAHVUIVVDOZWIZVULWUJVWPVWHRZ
      FHYKZDYGZFHVWHWIVWKWUJVWPWUIRZAHYKZDYGWUMADHWUIYHWUOWULDWUOVWPVWGRZGVWEYK
      ZFHYKZWULWUOWURWUNWURAHVUIHRZWUNWUPGTVUIWGWHZYKZWURWUSVUIWUTRZWUNWVAWVBVU
      IVXJHTVUIUVBXBUVCWUPWUNGVUIWUTGAXSVWGWUIVWPVWFVUIVVDXEUVDZYIXIWUQWVAFVUIH
      FAXSWUPGVWEWUTVWDVUITWGXPUVEYIVTUVFWUQWUOFHWUQWUPGHYKZWUOVXIWUQWVDURVXKWU
      PGVWEHUVGUOWUPWUNGAHWVCUVHUVIUVJUVKWUKWUQFHGVWPVWEVWGUVLUVMVOUVNUQFDHVWHY
      HFHVWHGVWEVWGTVWDWGXTVYLXRZUVOUVPVVEWUJVVDWKZUEZVULVVEVVDHYJZWUJWVGPHBVVD
      UVQZAHVVDUVRSVVEWVFBHBVVDUVSYDYLYMUJXOVWCVWNMUVTZWMWNWOZMVWCWMVWMWVJWNVWC
      VWMNVWIUWAZWKZWVJNVWIUWBVWCWVLHWVJUWCZPZWVMWVJPZVWCWVLFHVWHNOZWJZWVNVWCFD
      HVVBVWHVWPNOWVQVWINVYCVWCVWIUWDVWCDVVBMYNUWEWHZNVVBWVSNWPZVWCYOUWFUWIVWPV
      WHNXEUWGVWCWVRFHMWJWVNVWCFHWVQMVWCVXDJZWVQVWHUKOZMWWAVXCWVQWWBPVYCVWHUNSW
      WAWWBMPZWWBMYPUCZMWWBYPUCZWWAWWBVWEVWGUKOZGYQZMYPWWAVXEVWGKLZWWFKRZJZGVWE
      IZWWBWWGYPUCVXHVWCWWKVXDVXIVWCWWJGHIZWWKVXKVWCWWLVVOVVSKRZJZABIZVVMWWOVVE
      VVLWWNABVVLVVOWWMVVIVVOVVKVUIYRXOVVIVVKWWMVVIVVKVVTWWMVVIVVJVVSMVWBXFMKRZ
      VVTWWMURYSMKVVSUWHUOUWJUWKUWLWDVSVVEWWLWWOVEVVMVVEWWNAVVDHWLZIZWWLWWOVVEW
      VHHHLWWRWWLVEWVIHUWMWWNWWJAGHHVVDVXSVVOWWHWWMWWIVUIVWGKUWNVXSVVSWWFKVUIVW
      GUKXEUWOXGUWPYFVVEWWNAWWQBHBVVDUWTUWQUWRXOUXAWWJGVWEHXLXMXOVWEVWGGUWSXNWW
      AWWGVWEMGYQZMWWAVWEWWFMGVWCWWFMPZGVWEIZVXDVXIVWCWWTGHIWXAVXKVWCWWTGHVWCVX
      LJZVXQWWFMWXBVXFVXQWWFPVYAVWGUNSVVEVXLVVMVXRVVMVXMVXRVXMVVMVXNVXRVXOVXPVX
      FVXRVXTUXBUXCWFXJUXDXKWWTGVWEHXLXMXOUXEVWEVXJLZVXEUYAWWSMPVXEWXCVXHUXFVWE
      GTUXGUOUIUXHWWAVWHKLZWWEVWCWXDVXDVWCWWHGVWEIZWXDVWCVXGWXEVYBVXFWWHGVWEVWG
      YRWDSGVWEVWGKUXIUXKZXOVWHUXJSWWAWWBWMRZMWMRZWWCWWDWWEJVEVWCWXGVXDVWCWXDWX
      GWXFVWHUXLSXOYTWWBMUXMYFUXNYLUXOFHMUXPUXQYLVWCWVLHYJZHQUFZWVOWVPVEVWCVWOV
      WJVVBLZWXIVYEHVVBVWIUXRNVVBYJZVWIHYJWXKWXIWVTWXLYOVVBWVSNUXSUOFHVWHVWIWVE
      VYDUYBVVBHNVWIUXTUYCUYDTHRWXJUYEHTUYFUOHMWVLUYGYFUYHYMYEWMWNUYMWXHWVKMPUY
      IYTWMMWNUYJUYKUIUYLUYNWBUYOSUYPUYQVULKMVUQVULKPZMYNVUQWWPMYNUFWXMYSMUYRUY
      SWXMVUQKNOZYNVULKNXEWXNKUKOZYNKVVBRWXNWXOPUYTKUNUOVUDUQUIVUAVUBSVUCVUMVUL
      KVULKVUEVUFVUG $.
  $}

  ${
    $( The empty function is measurable.  (Contributed by Brendan Leahy,
       28-Mar-2018.) $)
    0mbf $p |- (/) e. MblFn $=
      ( c0 c1 csn cxp cmbf 0xp cvol wcel cc 0mbl ax-1cn mbfconst mp2an eqeltrri
      cdm ) ABCZDZAEPFAGOHBIHQEHJKABLMN $.
  $}

  ${
    $d a b f g h r s t ph $.  $d a b f g h r s t A $.  $d a b f g h r s t F $.
    $d a b f g h r s t S $.
    mbfresfi.1 $e |- ( ph -> F : A --> CC ) $.
    mbfresfi.2 $e |- ( ph -> S e. Fin ) $.
    mbfresfi.3 $e |- ( ph -> A. s e. S ( F |` s ) e. MblFn ) $.
    mbfresfi.4 $e |- ( ph -> U. S = A ) $.
    $( Measurability of a piecewise function across arbitrarily many subsets.
       (Contributed by Brendan Leahy, 31-Mar-2018.) $)
    mbfresfi $p |- ( ph -> F e. MblFn ) $=
      ( va vf cc wf cres cmbf wcel wa wceq cvv wi vr vb vg vt vh cv wral uniexg
      cuni cfn syl eqeltrrd fex ex jcai feq2 anbi1d eqeq2 anbi12d imbi1d imbi2d
      feq1 reseq1 eleq1d ralbidv eleq1 imbi12d wal csn cun rzal biantrud bicomd
      c0 unieq syl6eq eqeq1d 2albidv weq raleq anbi2d simpl simpr feq12d adantr
      uni0 adantl cbval2v syl6bb wrel cdm frel fdm eqcom biimpi sylan9eq reldm0
      wb biimpar 0mbf syl2anc cre ccom cim ref fco mpan ad2antrl elexi vex coex
      resex feq123 mp3an3 bitr3d spc2gv wss ax-resscn fss fssres syl2an adantlr
      cr mp2an resabs1 resco reseq2 sylan2 cin fresin ismbfcn eqeltrd ralrimiva
      cbvralv sylib pm2.27 mpan9 syl5eqel mbfres2 imf syl6eqel gen2 ccncf uniex
      co recncf eqid ssun1 unissi id syl5sseq wel elssuni elun1 rspccva adantll
      biimpd ad2antrr mpd simpld snid elun2 rspcv mp2b uniun unisn uneq2i eqtri
      simprbda ad2antll imcncf simprd simplbda mpbir2and alrimivv a1i findcard2
      syl5eqr sp sps 3syl vtocl2g mpcom mpan2d mp2and ) ABLDMZDEUFZNZOPZECUGZDO
      PZFHAUWFUWJQZCUIZBRZUWKIBSPZDSPZQAUWLUWNQZUWKTZAUWOUWPAUWMBSIACUJPZUWMSPG
      CUJUHUKULAUWFUWOUWPTFUWFUWOUWPBLSDUMUNUKUOAJUFZLKUFZMZUXAUWGNZOPZECUGZQZU
      WMUWTRZQZUXAOPZTZTABLUXAMZUXEQZUWNQZUXITZTAUWRTJKBDSSUWTBRZUXJUXNAUXOUXHU
      XMUXIUXOUXFUXLUXGUWNUXOUXBUXKUXEUWTBLUXAUPUQUWTBUWMURUSUTVAUXADRZUXNUWRAU
      XPUXMUWQUXIUWKUXPUXLUWLUWNUXPUXKUWFUXEUWJBLUXADVBUXPUXDUWIECUXPUXCUWHOUXA
      DUWGVCVDVEUSUQUXADOVFVGVAAUWSUXJJVHZKVHZUXJGUXBUXDEUAUFZUGZQZUXSUIZUWTRZQ
      ZUXITZJVHKVHZUXBVNUWTRZQZUXITZJVHKVHUBUFZLUCUFZMZUYKUWGNZOPZEUDUFZUGZQZUY
      OUIZUYJRZQZUYKOPZTZUBVHUCVHZUXBUXDEUYOUEUFZVIZVJZUGZQZVUFUIZUWTRZQZUXITZJ
      VHKVHZUXRUAUDUECUXSVNRZUYEUYIKJVUNUYDUYHUXIVUNUYAUXBUYCUYGVUNUXBUYAVUNUXT
      UXBUXDEUXSVKVLVMVUNUYBVNUWTVUNUYBVNUIVNUXSVNVOWFVPVQUSUTVRUAUDVSZUYFUXBUX
      DEUYOUGZQZUYRUWTRZQZUXITZJVHKVHVUCVUOUYEVUTKJVUOUYDVUSUXIVUOUYAVUQUYCVURV
      UOUXTVUPUXBUXDEUXSUYOVTWAVUOUYBUYRUWTUXSUYOVOVQUSUTVRVUTVUBKJUCUBKUCVSZJU
      BVSZQZVUSUYTUXIVUAVVCVUQUYQVURUYSVVCUXBUYLVUPUYPVVCUWTUYJLUXAUYKVVAVVBWBV
      VAVVBWCWDVVCUXDUYNEUYOVVCUXCUYMOVVAUXCUYMRVVBUXAUYKUWGVCWEVDVEUSVVBVURUYS
      WRVVAUWTUYJUYRURWGUSVVAUXIVUAWRVVBUXAUYKOVFWEVGWHWIUXSVUFRZUYEVULKJVVDUYD
      VUKUXIVVDUYAVUHUYCVUJVVDUXTVUGUXBUXDEUXSVUFVTWAVVDUYBVUIUWTUXSVUFVOVQUSUT
      VRUXSCRZUYEUXJKJVVEUYDUXHUXIVVEUYAUXFUYCUXGVVEUXTUXEUXBUXDEUXSCVTWAVVEUYB
      UWMUWTUXSCVOVQUSUTVRUYIKJUYHUXAWJZUXAWKZVNRZUXIUXBVVFUYGUWTLUXAWLWEUXBUYG
      VVGUWTVNUWTLUXAWMUYGUWTVNRVNUWTWNWOWPVVFVVHQUXAVNOVVFUXAVNRVVHUXAWQWSWTUU
      AXAUUBVUCVUMTUYOUJPVUCVULKJVUCVUKUXIVUCVUKQZUXIXBUXAXCZOPZXDUXAXCZOPZVVIU
      WTUYRVUDVVJVUHUWTYCVVJMZVUCVUJUXBVVNVUGLYCXBMZUXBVVNXEUWTLYCXBUXAXFXGWEXH
      VUCUYRLVVJUYRNZMZVVPUWGNZOPZEUYOUGZQZVVPOPZTZVUKVWBVVPSPUYRSPZVUCVWCTVVJU
      YRXBUXAXBLYCUUCUUEZUUFXIKXJZXKXLUYOUDXJUUDZVUBVWCUCUBVVPUYRSSUYKVVPRZUYJU
      YRRZQZUYTVWAVUAVWBVWJUYQUYTVWAVWJUYSUYQVWIUYSVWHVWIUYSUYJUYRWNWOZWGVLVWJU
      YLVVQUYPVVTVWHVWILLRZUYLVVQWRLUUGZUYJLUYRLUYKVVPXMXNVWJUYNVVSEUYOVWHUYNVV
      SWRVWIVWHUYMVVROUYKVVPUWGVCVDWEVEUSXOVWHVUAVWBWRVWIUYKVVPOVFWEVGXPYDVUKVV
      QVVTVWCVWBTUXBVUJVVQVUGUXBUWTLVVJMZUYRUWTXQZVVQVUJLLXBMZUXBVWNVVOYCLXQZVW
      PXEXRLYCLXBXSYDUWTLLXBUXAXFXGVUJVUIUYRUWTUYOVUFUYOVUEUUHUUIVUJUUJZUUKZUWT
      LUYRVVJXTYAYBVUHVVTVUJVUHVVPUXSNZOPZUAUYOUGVVTVUHVXAUAUYOVUHUAUDUULZQZVWT
      XBUXAUXSNZXCZOVXBVWTVXERVUHVXBVWTVVJUXSNZVXEVXBUXSUYRXQZVWTVXFRUXSUYOUUMZ
      VVJUXSUYRYEUKXBUXAUXSYFVPWGVXCVXEOPZXDVXDXCZOPZVXCVXDOPZVXIVXKQZVUGVXBVXL
      UXBVXBVUGUXSVUFPVXLUXSUYOVUEUUNUXDVXLEUXSVUFEUAVSUXCVXDOUWGUXSUXAYGVDUUOY
      HUUPUXBVXLVXMTVUGVXBUXBVXLVXMUXBUWTUXSYIZLVXDMVXLVXMWRUWTLUXAUXSYJVXNVXDY
      KUKUUQUURUUSZUUTYLYMVXAVVSUAEUYOUAEVSZVWTVVROUXSUWGVVPYGVDYNYOWEVWAVWBYPX
      AYQVUHVVJVUDNZOPZVUCVUJVUGUXBUXAVUDNZOPZVXRVUDVUEPVUDVUFPVUGVXTTVUDUEXJZU
      VAVUDVUEUYOUVBUXDVXTEVUDVUFEUEVSUXCVXSOUWGVUDUXAYGVDUVCUVDZUXBVXTQZVXQXBV
      XSXCZOXBUXAVUDYFUXBVXTVYDOPZXDVXSXCZOPZUXBUWTVUDYIZLVXSMVXTVYEVYGQWRUWTLU
      XAVUDYJVYHVXSYKUKZUVIYRYHXHVUJUYRVUDVJZUWTRVUCVUHVUJVYJVUIUWTVUIUYRVUEUIZ
      VJVYJUYOVUEUVEVYKVUDUYRVUDVYAUVFUVGUVHVWRUVRUVJZYSVVIUWTUYRVUDVVLVUHUWTYC
      VVLMZVUCVUJUXBVYMVUGLYCXDMZUXBVYMYTUWTLYCXDUXAXFXGWEXHVUCUYRLVVLUYRNZMZVY
      OUWGNZOPZEUYOUGZQZVYOOPZTZVUKWUAVYOSPVWDVUCWUBTVVLUYRXDUXAXDVWEUVKXIVWFXK
      XLVWGVUBWUBUCUBVYOUYRSSUYKVYORZVWIQZUYTVYTVUAWUAWUDUYQUYTVYTWUDUYSUYQVWIU
      YSWUCVWKWGVLWUDUYLVYPUYPVYSWUCVWIVWLUYLVYPWRVWMUYJLUYRLUYKVYOXMXNWUDUYNVY
      REUYOWUCUYNVYRWRVWIWUCUYMVYQOUYKVYOUWGVCVDWEVEUSXOWUCVUAWUAWRVWIUYKVYOOVF
      WEVGXPYDVUKVYPVYSWUBWUATUXBVUJVYPVUGUXBUWTLVVLMZVWOVYPVUJLLXDMZUXBWUEVYNV
      WQWUFYTXRLYCLXDXSYDUWTLLXDUXAXFXGVWSUWTLUYRVVLXTYAYBVUHVYSVUJVUHVYOUXSNZO
      PZUAUYOUGVYSVUHWUHUAUYOVXCWUGVXJOVXBWUGVXJRVUHVXBWUGVVLUXSNZVXJVXBVXGWUGW
      UIRVXHVVLUXSUYRYEUKXDUXAUXSYFVPWGVXCVXIVXKVXOUVLYLYMWUHVYRUAEUYOVXPWUGVYQ
      OUXSUWGVYOYGVDYNYOWEVYTWUAYPXAYQVUHVVLVUDNZOPZVUCVUJVUGUXBVXTWUKVYBVYCWUJ
      VYFOXDUXAVUDYFUXBVXTVYEVYGVYIUVMYRYHXHVYLYSVUHUXIVVKVVMQWRZVUCVUJUXBWULVU
      GUWTUXAYKWEXHUVNUNUVOUVPUVQUXQUXJKUXJJUVSUVTUWAUWBUWCUWDUWE $.
  $}

  ${
    $d x ph $.  $d x A $.
    mbfposadd.1 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    mbfposadd.2 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    mbfposadd.3 $e |- ( ph -> ( x e. A |-> C ) e. MblFn ) $.
    mbfposadd.4 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    mbfposadd.5 $e |- ( ph -> ( x e. A |-> ( B + C ) ) e. MblFn ) $.
    $( If the sum of two measurable functions is measurable, the sum of their
       nonnegative parts is measurable.  (Contributed by Brendan Leahy,
       2-Apr-2018.) $)
    mbfposadd $p |- ( ph -> ( x e. A |-> ( if ( 0 <_ B , B , 0 ) +
      if ( 0 <_ C , C , 0 ) ) ) e. MblFn ) $=
      ( cc0 cmpt cr wcel wa cmbf wceq ax-mp cima syl2anc cle wbr crab cif caddc
      wn co cv 0re ifcl sylancl readdcld eqid fmptd cres wf ssrab2 fssres inss2
      cin wss resabs1 elin rabid bitri iftrue oveqan12d ad2ant2l sylbi mpteq2ia
      anbi12i inss1 sstri nfcv nfrab1 nfin resmptf 3eqtr4i eqtri cvol ccnv cpnf
      cdm csn cioo cun biantrurd elrege0 syl6bbr rabbidva cxr clt pnfxr snunioo
      0xr ltpnf mp3an imaeq2i imaundi mptpreima 3eqtr3ri syl6eq mbfimasn mp3an3
      cico mbfima unmbl eqeltrd mbfres syl5eqel anandi 3bitr4i iffalse ad2antll
      inmbl recnd addid2d adantrr eqtrd sylan2b mpteq2dva 3eqtr4g cmnf elioomnf
      syl5eq wb ltnle bitr3d syl5bb eqeltrrd ssid dfrab3ss rabxm ineq1i 3eqtrri
      indir a1i mbfres2 oveq2d addid1d sylan9eqr anasss mbfpos eqcomi ) ACKEUAU
      BZBCUCZUUEUFZBCUCZBCKDUAUBZDKUDZUUEEKUDZUEUGZLZABCUULMUUMABUHZCNZOZUUJUUK
      UUPDMNZKMNZUUJMNGUIUUIDKMUJUKZUUPEMNZUURUUKMNIUIUUEEKMUJUKULUUMUMUNZAUUFU
      UIBCUCZUUFUTZUUIUFZBCUCZUUFUTZUUMUUFUOZACMUUMUPUUFCVAUUFMUVGUPUVAUUEBCUQC
      MUUFUUMURUKAUVGUVCUOZBCDEUEUGZLZUVCUOZPUVHUUMUVCUOZUVKUVCUUFVAUVHUVLQUVBU
      UFUSUUMUVCUUFVBRBUVCUULLZBUVCUVILZUVLUVKBUVCUULUVIUUNUVCNZUUOUUIOZUUOUUEO
      ZOZUULUVIQZUVOUUNUVBNZUUNUUFNZOUVRUUNUVBUUFVCUVTUVPUWAUVQUUIBCVDUUEBCVDZV
      KVEUUIUUEUVSUUOUUOUUIUUEUUJDUUKEUEUUIDKVFUUEEKVFZVGVHVIVJUVCCVAZUVLUVMQUV
      CUVBCUVBUUFVLUUIBCUQVMZBCUVCUULBCVNZBUVBUUFUUIBCVOUUEBCVOZVPZVQRUWDUVKUVN
      QUWEBCUVCUVIUWFUWHVQRVRVSAUVJPNUVCVTWCZNZUVKPNJAUVBUWINUUFUWINZUWJAUVBBCD
      LZWAZKWDZSZUWMKWBWEUGZSZWFZUWIAUVBDKWBXEUGZNZBCUCZUWRAUUIUWTBCUUPUUIUUQUU
      IOUWTUUPUUQUUIGWGDWHWIWJUWMUWNUWPWFZSUWMUWSSUWRUXAUXBUWSUWMKWKNZWBWKNKWBW
      LUBZUXBUWSQWOWMUURUXDUIKWPRKWBWNWQZWRUWMUWNUWPWSBCDUWSUWLUWLUMZWTXAXBAUWL
      PNZCMUWLUPZUWRUWINZFABCDMUWLGUXFUNZUXGUXHOUWOUWINZUWQUWINUXIUXGUXHUURUXKU
      ICKUWLXCXDCKWBUWLXFUWOUWQXGTTXHAUUFBCELZWAZUWNSZUXMUWPSZWFZUWIAUUFEUWSNZB
      CUCZUXPAUUEUXQBCUUPUUEUUTUUEOUXQUUPUUTUUEIWGEWHWIWJUXMUXBSUXMUWSSUXPUXRUX
      BUWSUXMUXEWRUXMUWNUWPWSBCEUWSUXLUXLUMZWTXAXBAUXLPNZCMUXLUPZUXPUWINZHABCEM
      UXLIUXSUNZUXTUYAOUXNUWINZUXOUWINUYBUXTUYAUURUYDUICKUXLXCXDCKWBUXLXFUXNUXO
      XGTTXHZUVBUUFXOTUVCUVJXITXJAUVGUVFUOZUXLUVFUOZPAUYFUUMUVFUOZUYGUVFUUFVAUY
      FUYHQUVEUUFUSUUMUVFUUFVBRABUVFUULLZBUVFELZUYHUYGABUVFUULEUUNUVFNZAUUOUVDU
      UEOZOZUULEQUUNUVENZUWAOUUOUVDOZUVQOUYKUYMUYNUYOUWAUVQUVDBCVDUWBVKUUNUVEUU
      FVCUUOUVDUUEXKXLAUYMOUULKEUEUGZEUYLUULUYPQAUUOUVDUUEUUJKUUKEUEUUIDKXMUWCV
      GXNAUUOUYPEQUYLUUPEUUPEIXPXQXRXSXTYAUVFCVAZUYHUYIQUVFUVECUVEUUFVLUVDBCUQV
      MZBCUVFUULUWFBUVEUUFUVDBCVOUWGVPZVQRUYQUYGUYJQUYRBCUVFEUWFUYSVQRYBYEAUXTU
      VFUWINZUYGPNHAUVEUWINUWKUYTAUWMYCKWEUGZSZUVEUWIAVUBDVUANZBCUCUVEBCDVUAUWL
      UXFWTAVUCUVDBCVUCUUQDKWLUBZOZUUPUVDUXCVUCVUEYFWOKDYDRUUPVUDVUEUVDUUPUUQVU
      DGWGUUPUUQUURVUDUVDYFGUIDKYGUKYHYIWJYEAUXGUXHVUBUWINFUXJCYCKUWLXFTYJUYEUV
      EUUFXOTUVFUXLXITXHUVCUVFWFZUUFQAUUFCUUFUTZUVBUVEWFZUUFUTVUFCCVAUUFVUGQCYK
      UUEBCCYLRCVUHUUFUUIBCYMYNUVBUVEUUFYPYOYQYRAUUMUUHUOZBCUUJLZUUHUOZPABUUHUU
      LLZBUUHUUJLZVUIVUKABUUHUULUUJUUNUUHNAUUOUUGOUULUUJQZUUGBCVDAUUOUUGVUNUUGU
      UPUULUUJKUEUGUUJUUGUUKKUUJUEUUEEKXMYSUUPUUJUUPUUJUUSXPYTUUAUUBXTYAUUHCVAZ
      VUIVULQUUGBCUQZBCUUHUULUWFUUGBCVOZVQRVUOVUKVUMQVUPBCUUHUUJUWFVUQVQRYBAVUJ
      PNUUHUWINVUKPNABCDGFUUCAUXMVUASZUUHUWIAVUREVUANZBCUCUUHBCEVUAUXLUXSWTAVUS
      UUGBCVUSUUTEKWLUBZOZUUPUUGUXCVUSVVAYFWOKEYDRUUPVUTVVAUUGUUPUUTVUTIWGUUPUU
      TUURVUTUUGYFIUIEKYGUKYHYIWJYEAUXTUYAVURUWINHUYCCYCKUXLXFTYJUUHVUJXITXHUUF
      UUHWFZCQACVVBUUEBCYMUUDYQYR $.
  $}

  ${
    $d b f x y F $.  $d b f x y A $.
    $( A real-valued, a.e. continuous function is measurable.  (Contributed by
       Brendan Leahy, 4-Apr-2018.) $)
    cnambfre $p |- ( ( F : A --> RR /\ A e. dom vol /\ ( vol* ` ( A \
      ( ( `' ( ( ( topGen ` ran (,) ) |`t A ) CnP ( topGen ` ran (,) ) )
        o. _E ) " { F } ) ) ) = 0 ) -> F e. MblFn ) $=
      ( vb vx vy vf cr wcel cfv cep cima cdif wceq wral wss crab adantr syl2anc
      wa c0 wf cvol cdm cioo crn ctg crest co ccnp ccnv ccom csn covol cc0 cmbf
      w3a cv wel wrex wn cmpt id feqmptd cnveqd imaeq1d ad2antrr exmid biantrur
      cun wo andir bitri ctb retopbas bastg ax-mp sseli ad2antlr cnpimaex 3expa
      3com12 sylanl1 ex wi simprrr wfn ffn restsspw elpwid simpl fnfvima syl3an
      cpw 3expb sseldd rexlimdvaa impbid pm5.32da r19.42v syl6bbr orbi1d syl5bb
      ad3antrrr rabbidva eqid mptpreima unrab 3eqtr4g eqtrd 3adantl3 ciun incom
      cin dfin4 inrab a1i iuneq2i iunin2 iunrab 3eqtr3i cif eqeq2 abbidv df-rab
      cab jca ctop sylan ralrimiva difss ssrab2 syl5ss wb cmap ctopon ovolssnul
      syl retopon nulmbl syl5rbb simprrl sselda pm3.22 adantll cvjust ralrimivw
      impbida simpr con3i rabeq0 sylibr adantl ifbothda retop resttop mpan 0opn
      ifcl ancoms iunopn subopnmbl mpdan syl5eqel rgenw iunss mpbir sstri mblss
      ssdif ovex rabex fnmpti resttopon sylancr cnpfval sylancl fneq1d elpreima
      mpbiri wrel rele elrelimasn fvex epelc bitr2i anbi2i syl6rbbr imaco abid2
      wbr eqtr4i difeq2d syl5sseq difmbl syl5eqelr eleq2i ibar sylan9bb adantrd
      notbid biimpd ss2rabdv dfdif2 unmbl 3adant1 eqeltrd ismbf 3ad2ant1 mpbird
      syl6sseqr ) AGBUAZAUBUCZHZAUDUEZUFIZAUGUHZUXOUIUHZUJZJUKBULZKZLZUMIUNMZUP
      ZBUOHZBUJZCUQZKZUXLHZCUXNNZUYCUYHCUXNUYCUYFUXNHZSUYGBDUQZUXQIZHZDEURZBEUQ
      ZKZUYFOZSZSZEUXPUSZDAPZUYMUTZUYKBIZUYFHZSZDAPZVIZUXLUXKUXMUYJUYGVUGMUYBUX
      KUXMSZUYJSZUYGDAVUCVAZUJZUYFKZVUGUXKUYGVULMUXMUYJUXKUYEVUKUYFUXKBVUJUXKDA
      GBUXKVBVCVDVEVFVUIVUDDAPUYTVUEVJZDAPVULVUGVUIVUDVUMDAVUDUYMVUDSZVUEVJZVUI
      UYKAHZSZVUMVUDUYMVUBVJZVUDSVUOVURVUDUYMVGVHUYMVUBVUDVKVLVUQVUNUYTVUEVUQVU
      NUYMUYREUXPUSZSUYTVUQUYMVUDVUSVUQUYMSZVUDVUSVUTVUDVUSVUQUYFUXOHZUYMVUDVUS
      UYJVVAVUHVUPUXNUXOUYFUXNVMHUXNUXOOVNUXNVMVOVPVQVRVVAUYMVUDVUSUYMVVAVUDVUS
      EUYFUYKBUXPUXOVSWAVTWBWCVUHVUSVUDWDUYJVUPUYMVUHUYRVUDEUXPVUHUYOUXPHZUYRSS
      UYPUYFVUCVUHVVBUYNUYQWEVUHVVBUYRVUCUYPHZVUHBAWFZVVBUYOAOZUYRUYNVVCUXKVVDU
      XMAGBWGQVVBUYOAUXPAWMUYOAUXOWHVQWIZUYNUYQWJAUYOBUYKWKWLWNWOWPXCWQWRUYMUYR
      EUXPWSWTXAXBXDDAVUCUYFVUJVUJXEXFUYTVUEDAXGXHXIXJUYCVUGUXLHZUYJUXMUYBVVGUX
      KUXMUYBSZVUAUXLHVUFUXLHZVVGVVHVUAEUXPUYRDAPZXKZVVKUYMDAPZLZLZUXLVVKVVLXMV
      VLVVKXMZVVNVUAVVKVVLXLVVKVVLXNEUXPVVLVVJXMZXKEUXPUYSDAPZXKVVOVUAEUXPVVPVV
      QVVPVVQMVVBUYMUYRDAXOXPXQEUXPVVLVVJXRUYSEDUXPAXSXTXTVVHVVKUXLHZVVMUXLHZVV
      NUXLHUXMVVRUYBUXMVVKEUXPUYQUYOTYAZXKZUXLEUXPVVJVVTUYQVVJUYOMVVJTMZVVJVVTM
      VVBUYOTUYOVVTVVJYBTVVTVVJYBVVBUYQSZVUPUYRSZDYEUYNDYEVVJUYOVWCVWDUYNDVWCVW
      DUYNVWCVUPUYNUYQUUAVWCUYNSVUPUYRVWCUYOAUYKVVBVVEUYQVVFQUUBUYQUYNUYRVVBUYQ
      UYNUUCUUDYFUUGYCUYRDAYDEDUUEXHUYQUTZVWBVVBVWEUYRUTZDANVWBVWEVWFDAUYRUYQUY
      NUYQUUHUUIUUFUYRDAUUJUUKUULUUMXQUXMVWAUXPHZVWAUXLHUXMUXPYGHZVVTUXPHZEUXPN
      VWGUXOYGHUXMVWHUUNAUXOUXLUUOUUPZUXMVWIEUXPUXMTUXPHZVVBVWIUXMVWHVWKVWJUXPU
      UQYQVVBVWKVWIUYQUYOTUXPUURUUSYHYIEUXPVVTUXPUUTRAVWAUXPUXPXEUVAUVBUVCQVVHV
      VMGOZVVMUMIUNMZVVSUXMVWLUYBUXMVVMAGVVMVVKAVVKVVLYJVVKAOZVVJAOZEUXPNVWOEUX
      PUYRDAYKUVDEUXPVVJAUVEUVFZUVGAUVHZYLQUXMVVMUYAOZUYAGOZSUYBVWMUXMVWRVWSUXM
      AVVLLZVVMUYAVWNVVMVWTOVWPVVKAVVLUVIVPUXMVVLUXTAUXMVUPUYMSZDYEUYKUXRJUXSKZ
      KZHZDYEZVVLUXTUXMVXAVXDDUXMVXDVUPUYLVXBHZSZVXAUXMUXQAWFZVXDVXGYMUXMVXHDAU
      YKFUQZIUYFHUYNVXIUYOKUYFOSEUXPUSWDCUXONZFGAYNUHZPZVAZAWFDAVXLVXMVXJFVXKGA
      YNUVJUVKVXMXEUVLUXMAUXQVXMUXMUXPAYOIHZUXOGYOIHZUXQVXMMUXMVXOAGOVXNYRVWQAU
      XOGUVMUVNYRDCEFUXPUXOAGUVOUVPUVQUVSAUYKVXBUXQUVRYQZUYMVXFVUPVXFBUYLJUWJZU
      YMJUVTVXFVXQYMUWABUYLJUWBVPBUYLUYKUXQUWCUWDUWEZUWFUWGYCUYMDAYDUXTVXCVXEUX
      RJUXSUWHZDVXCUWIUWKXHUWLUWMUXMUYAAGAUXTYJVWQYLZYFVWRVWSUYBVWMVVMUYAYPVTYH
      VVMYSRVVKVVMUWNRUWOVVHVUFGOZVUFUMIUNMZVVIUXMVYAUYBUXMVUFAGVUEDAYKVWQYLQUX
      MVUFUYAOZVWSSUYBVYBUXMVYCVWSUXMVUFUYKUXTHZUTZDAPUYAUXMVUEVYEDAUXMVUPSZVUB
      VYEVUDVYFVUBVYEVYFUYMVYDVYDVXDVYFUYMUXTVXCUYKVXSUWPUXMVXDVXGVUPUYMVXPUYMV
      XFVUPVXGVXRVUPVXFUWQYTUWRYTUWTUXAUWSUXBDAUXTUXCUXJVXTYFVYCVWSUYBVYBVUFUYA
      YPVTYHVUFYSRVUAVUFUXDRUXEQUXFYIUXKUXMUYDUYIYMUYBCABUXGUXHUXI $.
  $}

  ${
    $d x y $.
    $( Lemma for ~ dvtan - the domain of the tangent is open.  (Contributed by
       Brendan Leahy, 8-Aug-2018.) $)
    dvtanlem $p |- ( `' cos " ( CC \ { 0 } ) ) e. ( TopOpen ` CCfld ) $=
      ( vx vy ccos cc cc0 cpi cdiv co cz wcel wceq cr halfpire syl cmin clt wbr
      wb wa pire ccnv csn cdif cima c2 cv caddc crab ccnfld ctopn cfv wfun cosf
      wf ffun difpreima mp2b fimacnv ax-mp 0re wfn cmpt ffn mpbi mptiniseg csin
      dffn5 sinhalfpip eqeq1d recni addcl mpan sineq0 bitr3d rabbiia eqtri ccld
      difeq12i crest eqid recld2 cioo crn ctg cmul ciun wtru nftru nfrab1 nfdif
      c1 nfcv eliun elioore adantl wn wo wi zre w3a cxr remulcl resubcl sylancl
      rexrd peano2re sylancr elioo2 syl2anc ltadd2 mp3an3 readdcl pm3.2i ltdiv1
      wrex sylan pipos syl2an recn mulcl pncan3 oveq1d wne gtneii divcan3 eqtrd
      mp3an23 adantr breq1d 3bitrd sylan2 breq2d ancoms anbi12d exp4b 3impd a1i
      biimpd retop mp2an sylbid imp btwnnz 3expb syldan olcd ianor rabid sylibr
      xchnxbir eldifd rexlimiva biantrurd syl6bbr notbid pm5.32i bitr4i redivcl
      eldif cfl flcld cle flle nelne2 necomd zred elrpii ltmul2d ltlend ltsub1d
      simpl 3bitr3rd mpbir2and divcan2 pncan2 flltp1 ltmul2dd ltsub1dd eqbrtrrd
      crp breqtrd mpbir3and oveq2 oveq1 oveq2d eleq2d rspcev sylbi impbii bitri
      oveq12d eqrd trud ctop wral iooretop rgenw iunopn eqeltrri divcan1 eleq1d
      rabss syl5ib mprgbir uniretop iscld2 mpbir tgioo2 fveq2i eleqtri restcldr
      wss cnfldtopon toponunii cldopn eqeltri ) CUAZDEUBZUCUDZDFUEGHZAUFZUGHZFG
      HZIJZADUHZUCZUIUJUKZUXSUXQDUDZUXQUXRUDZUCZUYFDDCUNZCULUXSUYJKUMDDCUODUXRC
      UPUQUYHDUYIUYEUYKUYHDKUMDDCURUSUYIUYACUKZEKZADUHZUYEELJUYIUYNKUTADUYLECLC
      DVAZCADUYLVBKUYKUYOUMDDCVCUSADCVGVDVEUSUYMUYDADUYADJZUYBVFUKZEKZUYMUYDUYP
      UYQUYLEUYAVHVIUYPUYBDJZUYRUYDRUXTDJZUYPUYSUXTMVJZUXTUYAVKVLZUYBVMNVNVOVPV
      RVPUYEUYGVQUKZJZUYFUYGJLVUCJUYEUYGLVSHZVQUKZJVUDUYGUYGVTZWAUYEWBWCWDUKZVQ
      UKZVUFUYEVUIJZLUYEUCZVUHJZBIFBUFZWEHZUXTOHZFVUMWKUGHZWEHZUXTOHZWBHZWFZVUK
      VUHVUTVUKKWGAVUTVUKAWHAVUTWLALUYEALWLUYDADWIWJUYAVUTJZUYAVUKJZRWGVVAUYAVU
      SJZBIXOZVVBBUYAIVUSWMVVDVVBVVCVVBBIVUMIJZVVCSZUYALUYEVVCUYALJZVVEUYAVUOVU
      RWNWOVVFUYPWPZUYDWPZWQZUYAUYEJZWPZVVFVVIVVHVVEVVCVUMUYCPQZUYCVUPPQZSZVVIV
      VEVVCVVOVVEVUMLJZVVCVVOWRVUMWSVVPVVCVVGVUOUYAPQZUYAVURPQZWTZVVOVVPVUOXAJV
      URXAJVVCVVSRVVPVUOVVPVUNLJZUXTLJZVUOLJZFLJZVVPVVTTFVUMXBVLMVUNUXTXCXDZXEV
      VPVURVVPVUQLJZVWAVURLJZVVPVWCVUPLJZVWETVUMXFZFVUPXBZXGMVUQUXTXCZXDXEVUOVU
      RUYAXHXIVVPVVGVVQVVRVVOVVPVVGVVQVVRVVOVVPVVGSZVVQVVRSVVOVWKVVQVVMVVRVVNVW
      KVVQUXTVUOUGHZUYBPQZVWLFGHZUYCPQZVVMVVPVWBVVGVVQVWMRZVWDVWBVVGVWAVWPMVUOU
      YAUXTXJXKXPVVPVWLLJZUYBLJZVWMVWORZVVGVVPVWAVWBVWQMVWDUXTVUOXLXGVWAVVGVWRM
      UXTUYAXLVLZVWQVWRVWCEFPQZSZVWSVWCVXATXQXMZVWLUYBFXNXKXRVWKVWNVUMUYCPVVPVW
      NVUMKZVVGVVPVUMDJZVXDVUMXSVXEVWNVUNFGHZVUMVXEVWLVUNFGVXEUYTVUNDJZVWLVUNKV
      UAFDJZVXEVXGFTVJZFVUMXTVLUXTVUNYAXGYBVXEVXHFEYCZVXFVUMKVXIEFUTXQYDZVUMFYE
      YGYFNYHYIYJVVGVVPVVRVVNRZVVPVVGVWGVXLVWHVVGVWGSZVVRUYBUXTVURUGHZPQZUYCVXN
      FGHZPQZVVNVWGVVGVWFVVRVXORZVWGVWEVWAVWFVWCVWGVWETVWIVLMVWJXDZVVGVWFVWAVXR
      MUYAVURUXTXJXKYKVVGVWRVXNLJZVXOVXQRZVWGVWTVWGVWAVWFVXTMVXSUXTVURXLXGVWRVX
      TVXBVYAVXCUYBVXNFXNXKXRVXMVXPVUPUYCPVWGVXPVUPKZVVGVWGVUPDJZVYBVUPXSVYCVXP
      VUQFGHZVUPVYCVXNVUQFGVYCUYTVUQDJZVXNVUQKVUAVXHVYCVYEVXIFVUPXTVLUXTVUQYAXG
      YBVYCVXHVXJVYDVUPKVXIVXKVUPFYEYGYFNWOYLYJYKYMYNYRYOYPUUANUUBVVEVVMVVNVVIV
      UMUYCUUCUUDUUEUUFUYPUYDSZVVJVVKUYPUYDUUGUYDADUUHZUUJUUIUUKUULVVBVVGVVISZV
      VDVVBVVGVVLSVYHUYALUYEUUSVVGVVIVVLVVGUYDVVKVVGUYDVYFVVKVVGUYPUYDUYAXSZUUM
      VYGUUNUUOUUPUUQVYHUYCUUTUKZIJZUYAFVYJWEHZUXTOHZFVYJWKUGHZWEHZUXTOHZWBHZJZ
      VVDVVGVYKVVIVVGUYCVVGVWRUYCLJZVWTVWRVWCVXJVYSTVXKUYBFUURYGNZUVAZYHVYHVYRV
      VGVYMUYAPQZUYAVYPPQZVVGVVIUVKVYHVYMFUYCWEHZUXTOHZUYAPVYHVYMWUEPQZVYJUYCUV
      BQZUYCVYJYCZVVGWUGVVIVVGVYSWUGVYTUYCUVCNYHVVGVYKVVIWUHWUAVYKVVISVYJUYCVYJ
      UYCIUVDUVEXPVVGWUFWUGWUHSZRVVIVVGVYJUYCPQVYLWUDPQWUIWUFVVGVYJUYCFVVGVYJWU
      AUVFZVYTFUVTJVVGFTXQUVGYQZUVHVVGVYJUYCWUJVYTUVIVVGVYLWUDUXTVVGVWCVYJLJZVY
      LLJZTWUJFVYJXBXGZVVGVWCVYSWUDLJTVYTFUYCXBXGZVWAVVGMYQZUVJUVLYHUVMVVGWUEUY
      AKZVVIVVGUYPWUQVYIUYPWUEUYBUXTOHZUYAUYPWUDUYBUXTOUYPUYSWUDUYBKZVUBUYSVXHV
      XJWUSVXIVXKUYBFUVNYGNYBUYTUYPWURUYAKVUAUXTUYAUVOVLZYFNZYHUWAVVGWUCVVIVVGW
      UEUYAVYPPWVAVVGWUDVYOUXTWUOVVGVWCVYNLJZVYOLJZTVVGWULWVBWUJVYJXFNZFVYNXBXG
      ZWUPVVGUYCVYNFVYTWVDWUKVVGVYSUYCVYNPQVYTUYCUVPNUVQUVRUVSYHVVGVYRVVGWUBWUC
      WTRZVVIVVGVYMXAJVYPXAJWVFVVGVYMVVGWUMVWAVYMLJWUNMVYLUXTXCXDXEVVGVYPVVGWVC
      VWAVYPLJWVEMVYOUXTXCXDXEVYMVYPUYAXHXIYHUWBVVCVYRBVYJIVUMVYJKZVUSVYQUYAWVG
      VUOVYMVURVYPWBWVGVUNVYLUXTOVUMVYJFWEUWCYBWVGVUQVYOUXTOWVGVUPVYNFWEVUMVYJW
      KUGUWDUWEYBUWKUWFUWGXIUWHUWIUWJYQUWLUWMVUHUWNJZVUSVUHJZBIUWOVUTVUHJYSWVIB
      IVUOVURUWPUWQBIVUSVUHUWRYTUWSWVHUYELUXLZVUJVULRYSWVJUYDVVGWRADUYDADLUXBUY
      DUYCFWEHZUXTOHZLJZUYPVVGUYDWVKLJZVWAWVMUYDVYSVWCWVNUYCWSTUYCFXBXDMWVKUXTX
      CXDUYPWVLUYALUYPWVLWURUYAUYPWVKUYBUXTOUYPUYSWVKUYBKZVUBUYSVXHVXJWVOVXIVXK
      UYBFUWTYGNYBWUTYFUXAUXCUXDUYEVUHLUXEUXFYTUXGVUHVUEVQUYGVUGUXHUXIUXJLUYEUY
      GUXKYTUYEUYGDDUYGUYGVUGUXMUXNUXOUSUXP $.
    $( Derivative of tangent.  (Contributed by Brendan Leahy, 7-Aug-2018.) $)
    dvtan $p |- ( CC _D tan ) = ( x e. dom tan |-> ( ( cos ` x ) ^ -u 2 ) ) $=
      ( vy cc ctan cdv co ccos cc0 csin c1 cdiv cmul cmpt cexp wcel adantl wceq
      c2 wtru a1i ccnv csn cdif cima cv cfv cneg caddc cdm df-tan cnvimass cosf
      fdmi sseqtri sseli sincld coscld wa wne wf wfn ffn elpreima mp2b eldifsni
      wb sylbi divrecd mpteq2ia eqtri oveq2i cvv cr cpr cnex prid2 difss imass2
      ax-mp fimacnv ccnfld ctopn sincl coscl dvsin feqmptd oveq2d 3eqtr3a crest
      wss sinf ctopon eqid cnfldtopon toponunii restid eqcomi dvtanlem dvmptres
      reccld ovex simprbi negcld eldifi negex dvcos syl5reqr ax-1cn dvrec oveq2
      mp1i oveq1 negeqd dvmptco dvmptmul trud dmmpti sqcld sqne0 mpbird divdird
      wral syl addcomd sincossq eqtrd oveq1d eqtr3d recidd dividd eqtr4d div23d
      sqvald mul2negd divrec2d 3eqtr4rd oveq12d cn0 2nn0 expneg sylancl 3eqtr4d
      rgen mpteq12 mp2an 3eqtri ) CDEFCAGUAZCHUBZUCZUDZAUEZIUFZJUUKGUFZKFZLFZMZ
      EFZAUUJUUMUUNLFZJUUMRNFZKFZUGZUULUGZLFZUULLFZUHFZMZADUIZUUMRUGNFZMZDUUPCE
      DAUUJUULUUMKFZMUUPAUJZAUUJUVJUUOUUKUUJOZUULUUMUVLUUKUUJCUUKUUJGUICGUUIUKC
      CGULUMUNUOZUPZUVLUUKUVMUQZUVLUUKCOZUUMUUIOZURZUUMHUSZCCGUTZGCVAUVLUVRVFUL
      CCGVBCUUKUUIGVCVDZUVQUVSUVPUUMCHVEPVGZVHVIVJVKUUQUVFQSAUULUUMUUNUVCCCVLUU
      JCVMCVNOSVMCVOVPTZUVLUULCOZSUVLUUKUUJCUUKUUJUUGCUDZCUUICWJUUJUWEWJCUUHVQU
      UICUUGVRVSUVTUWECQULCCGVTVSUNZUOUPPZUVLUUMCOZSUVOPSAUULUUMCWAWBUFZUWICCUU
      JUWCUVPUWDSUUKWCPZUVPUWHSUUKWDPZSCIEFGCACUULMZEFACUUMMZWESIUWLCESACCICCIU
      TSWKTWFWGSACCGUVTSULTWFZWHUUJCWJSUWFTZUWICWIFZUWIUWICWLUFZOUWPUWIQUWIUWIW
      MZWNZUWIUWQCCUWIUWSWOWPVSWQZUWRUUJUWIOSWRTZWSUVLUUNCOSUVLUUMUVOUWBWTPUVCV
      LOSUVLURZUVAUVBLXATSABUUMUVBJBUEZKFZJUXCRNFZKFZUGZCCUUNUVACVLUUJUUIUWCUWC
      UVLUVQSUVLUVPUVQUWAXBPUXBUULUWGXCUXCUUIOZUXDCOSUXHUXCUXCCUUHXDUXCCHVEWTPU
      XGVLOSUXHURUXFXETSAUUMUVBCUWIUWICCUUJUWCUWKSUVPURUULUWJXCSACUVBMCGEFCUWME
      FAXFSGUWMCEUWNWGXGUWOUWTUWRUXAWSJCOCBUUIUXDMEFBUUIUXGMQSXHBJXIXKUXCUUMJKX
      JUXCUUMQZUXFUUTUXIUXEUUSJKUXCUUMRNXLWGXMXNXOXPUUJUVGQUVEUVHQZAUUJYBUVFUVI
      QUVGUUJAUUJUVJDUULUUMKXAUVKXQWQUXJAUUJUVLUUSUUSKFZUULRNFZUUSKFZUHFZUUTUVE
      UVHUVLUUSUXLUHFZUUSKFUXNUUTUVLUUSUXLUUSUVLUUMUVOXRZUVLUULUVNXRZUXPUVLUUSH
      USZUVSUWBUVLUWHUXRUVSVFUVOUUMXSYCXTZYAUVLUXOJUUSKUVLUXOUXLUUSUHFZJUVLUUSU
      XLUXPUXQYDUVLUVPUXTJQUVMUUKYEYCYFYGYHUVLUURUXKUVDUXMUHUVLUURJUXKUVLUUMUVO
      UWBYIUVLUUSUXPUXSYJYKUVLUULUULLFZUUSKFUULUUSKFZUULLFUXMUVDUVLUULUULUUSUVN
      UVNUXPUXSYLUVLUXLUYAUUSKUVLUULUVNYMYGUVLUVCUYBUULLUVLUVCUUTUULLFUYBUVLUUT
      UULUVLUUSUXPUXSWTUVNYNUVLUULUUSUVNUXPUXSYOYKYGYPYQUVLUWHRYROUVHUUTQUVOYSU
      UMRYTUUAUUBUUCAUUJUVEUVGUVHUUDUUEUUF $.
  $}

  ${
    $d s t u v x y z w f g h a b c d F $.
    $d s t u v x y z w f g h a b c d G $.
    $d s t u v x y z w f g h a b c d ph $.

    ${
      itg2addnclem.1 $e |- L = { x | E. g e. dom S.1
          ( E. y e. RR+ ( z e. RR |-> if ( ( g ` z ) = 0 ,
            0 , ( ( g ` z ) + y ) ) ) oR <_ F /\ x = ( S.1 ` g ) ) } $.
      $( An alternate expression for the ` S.2 ` integral that includes an
         arbitrarily small but strictly positive "buffer zone" wherever the
         simple function is nonzero.  (Contributed by Brendan Leahy,
         10-Oct-2017.)  (Revised by Brendan Leahy, 10-Mar-2018.) $)
      itg2addnclem $p |- ( F : RR --> ( 0 [,] +oo ) ->
          ( S.2 ` F ) = sup ( L , RR* , < ) ) $=
        ( cr cc0 co cle wbr wceq wa cxr clt wcel adantr cvv cmin vf vb va vs vu
        wf cfv citg1 cdm wrex csup eqid caddc cif cmpt crp a1i wss itg1cl rexrd
        cv wn weq fveq1 oveq1d mpteq2dv breq1d rexbidv fveq2 anbi12d wral breq2
        id adantl ad2antlr ffvelrnda adantlr mpbid ifbothda adantlll wi sylancr
        0re mpan2 ad2antrr reex eqidd feqmptd ofrfval2 syl imp wb breq2d wne c2
        cmnf c0ex mpbird iftrue bitr3d rspcev eqeq1 anbi2d sylan ad3antlr simpr
        syl2an anim12i cdif cima ad3antrrr simplrl syl6eq eleq2d sylbid syl2anc
        simpl cmul cdiv simprl fvex ovex ifex offval2 oveq2 ifsb eqtrd oveq1 c1
        syl5eq eqeltrrd recnd ifbieq12d eqtr4d iffalse adantlrl halfcld oveq2d
        cc ex cpnf cicc citg2 cofr cab itg2val supeq1i xrltso eqeltrd rexlimiva
        wor simprr abssi supxrcl mp1i eqeq1d ifbieq2d eqeq2d cbvrexv 0le0 rpge0
        syl6eqbr i1ff rpre addge01d readdcld ifcl iccssxr xrletr mpand ralimdva
        fss syl3anc 3imtr4d rexlimdva anim1d reximdva syl5bi ss2abdv w3a simp3r
        sseld 3ad2ant2 rexlimdv3a abssdv xrsupss syld supxrlub mpan wex simprrr
        supub simplll csn cxp i1f0 c0 2rp ax-mp ffvelrn elxrge0 sylib ralrimiva
        ne0i simprd ralrimivw r19.2z itg10 biantrud fvconst2 sylan9eq mpteq2dva
        syl6req mnflt eqbrtrd spcev simp-4r simpllr ngtmnft biimprd xrltle xrre
        necon1ad syl22anc ccnv crn covol cnvimass fdm syl5sseq eqcomd wfun ffun
        difpreima cnvimarndm difeq1i difeq12d dfss4 mpbi fniniseg syl6bi itg10a
        wfn ffn breqtrd cof difeq1d biantrurd eldif syl6bbr bitr4d con2bid 3syl
        0cn subidi ifeq2da simpll fconstmpt resubcl cvol i1fima mblvol neldifsn
        1ex 2re i1fima2 remulcl 2cn 2ne0 mulne0d mulid1d mul01d ifeq12d i1fmulc
        redivcld i1f1 i1fsub eleq1 fvmpt sylan9eqr ianor ifbid sylancl pm2.61d1
        wo ifboth sylbi pm2.61i syl6reqr mpteq2ia i1fpos ad2antrl posdifd mblss
        jaoi ovolge0 ltlen 2pos mulgt0 mpanl12 divgt0d elrpd inidm anim2i breq1
        ofrfval divcld npcand pm2.24d impcom adantll ifeq2d eqcoms nfmpt1 nfeq2
        sylanl1 mpd fvmpt2 mpteq2da simplrr ltdiv1d recn 2halvesd pncand eqtr3d
        rehalfcl rehalfcld ltsubaddd 3bitr2d itg1mulc mulcomd divassd divcan5rd
        fveq2d itg11 3eqtr3d 3eqtrd itg1sub divsubdird subsubd 3eqtrrd breqtrrd
        3eqtr4d resubcld leidd ltnled biimpar ltled pm2.61dan iba bicomd syl6bb
        breq12d notbid pm4.53 simplbda jaod sylbir olcs itg1le ltletrd adantllr
        pm2.61dane expr an32s rexlimdvaa expimpd ancomsd exlimdv 3imtr4g eqsupd
        rexab impr ) HIUUAUUBJZEUFZEUUCUGUAVAZEKUUDZLZAVAZWVPUHUGZMZNZUAUHUIZUJ
        ZAUUEZOPUKZFOPUKZAUAEWWEWWEULUUFWVOWWGCHCVAZDVAZUGZIMZIWWJBVAZUMJZUNZUO
        ZEWVQLZBUPUJZWVSWWIUHUGZMZNZDWWCUJZAUUEZOPUKWWFOFWXBPGUUGWVOUBUCOWXBWWF
        POPUUKWVOUUHUQZWWEOURZWWFOQWVOWWDAOWWBWVSOQZUAWWCWVPWWCQZWWBNWVSWVTOWXF
        WVRWWAUULWXFWVTOQZWWBWXFWVTWVPUSZUTZRUUIUUJUUMZWWEUUNUUOWVOUBVAZWXBQZWW
        FWXKPLVBZWVOWXLWXKWWEQWXMWVOWXBWWEWXKWVOWXAWWDAWXACHWWHWVPUGZIMZIWXNWWL
        UMJZUNZUOZEWVQLZBUPUJZWWANZUAWWCUJWVOWWDWWTWYADUAWWCDUAVCZWWQWXTWWSWWAW
        YBWWPWXSBUPWYBWWOWXREWVQWYBCHWWNWXQWYBWWKWXOWWMWXPIWYBWWJWXNIWWHWWIWVPV
        DZUUPWYBWWJWXNWWLUMWYCVEUUQVFVGVHWYBWWRWVTWVSWWIWVPUHVIUURVJUUSWVOWYAWW
        BUAWWCWVOWXFNZWXTWVRWWAWYDWXSWVRBUPWYDWWLUPQZNZWXQWWHEUGZKLZCHVKWXNWYGK
        LZCHVKZWXSWVRWYFWYHWYICHWYFWWHHQZNZWXNWXQKLZWYHWYIWXFWYEWYKWYMWVOWXOWXN
        IKLZWXNWXPKLZWYMWXFWYENWYKNZIWXPIWXQWXNKVLWXPWXQWXNKVLWXOWYNWYPWXOWXNII
        KWXOVMUUTUVBVNWYPWYOWXOVBWYPIWWLKLZWYOWYEWYQWXFWYKWWLUVAVOWYPWXNWWLWXFW
        YKWXNHQZWYEWXFHHWWHWVPWVPUVCZVPZVQWYEWWLHQZWXFWYKWWLUVDZVOUVEVRRVSVTWYL
        WXNOQWXQOQWYGOQZWYMWYHNWYIWAWYLWXNWYFHHWWHWVPWXFHHWVPUFZWVOWYEWYSVOVPZU
        TWYLWXQWYLIHQZWXPHQWXQHQWCWYLWXNWWLXUEWYEXUAWYDWYKXUBVOUVFWXOIWXPHUVGWB
        ZUTWYFHOWWHEWVOHOEUFZWXFWYEWVOWVNOURXUHIUUAUVHHWVNOEUVLWDWEVPZWXNWXQWYG
        UVIUVMUVJUVKWYFCHWXQWYGKWXRESHOHSQZWYFWFUQZXUGXUIWYFWXRWGWVOECHWYGUOMWX
        FWYEWVOCHWVNEWVOVMWHZWEZWIWYFCHWXNWYGKWVPESHOXUKXUEXUIWXFWVPCHWXNUOMZWV
        OWYEWXFCHHWVPWYSWHZVOXUMWIUVNUVOUVPUVQUVRUVSUWBWVOUCUBUDOWWEWXKPWXCWVOW
        XDUCVAZWXKPLVBUBWWEVKWXKXUPPLZWXKUDVAZPLZUDWWEUJZWAUBOVKNUCOUJWVOWWDAOW
        VOWWBWXEUAWWCWVOWXFWWBUVTWVSWVTOWVOWXFWVRWWAUWAWXFWVOWXGWWBWXIUWCUUIUWD
        UWEUCUBUDWWEUWFWJUWLUWGWKWVOWXKOQZWXKWWFPLZXUQUCWXBUJZWVOXVANZXVBXUTXVC
        XVAXVBXUTWLZWVOWXDXVAXVEWXJUDWWEWXKUWHUWIVNXVDWVRXURWVTMZNZUAWWCUJZXUSN
        ZUDUWJWWQXUPWWRMZNZDWWCUJZXUQNZUCUWJZXUTXVCXVDXVIXVNUDXVDXUSXVHXVNXVDXU
        SXVHXVNXVDXUSNXVGXVNUAWWCXVDWXFXVGNZXUSXVNXVDXVONZXUSXVNXVPXUSWXKWVTPLZ
        XVNXVPXURWVTWXKPXVDWXFWVRXVFUWKWMXVPXVQXVNXVPXVQNZXVNWXKWPXVRWVOWXKWPMZ
        XVNWVOXVAXVOXVQUWMWVOWWQIWWRMZNZDWWCUJZWXKIPLZXVNXVSWVOHIUWNZUWOZWWCQCH
        IUOZEWVQLZBUPUJZXWBUWPWVOUPUWQWNZXWGBUPVKXWHWOUPQZXWIUWRUPWOUXDUWSWVOXW
        GBUPWVOXWGIWYGKLZCHVKWVOXWKCHWVOWYKNZXUCXWKXWLWYGWVNQZXUCXWKNZHWVNWWHEU
        WTZWYGUXAZUXBUXEUXCWVOCHIWYGKXWFESSWVNXUJWVOWFUQZISQXWLWQUQXWOWVOXWFWGX
        ULWIWRUXFXWGBUPUXGWBXWAXWHDXWEWWCWWIXWEMZWWQXWAXWHXWRXVTWWQXWRWWRXWEUHU
        GIWWIXWEUHVIUXHUXMUXIXWRWWPXWGBUPXWRWWOXWFEWVQXWRCHWWNIXWRWYKNWWKWWNIMX
        WRWYKWWJWWHXWEUGIWWHWWIXWEVDHIWWHWQUXJUXKWWKIWWMWSWJUXLVGVHWTXAWBZXVSWX
        KWPIPXVSVMXUFWPIPLXVSWCIUXNUUOUXOXVMXWBXWCNUCIWQXUPIMZXVLXWBXUQXWCXWTXV
        KXWADWWCXWTXVJXVTWWQXUPIWWRXBXCVHXUPIWXKPVLVJUXPZXGXDXVRWXKWPWNZNZWXKHQ
        ZXVNXXCXVAWVTHQZWPWXKPLZWXKWVTKLZXXDWVOXVAXVOXVQXXBUXQXVOXXEXVDXVQXXBWX
        FXXEXVGWXHRZXEXVRXVAXXBXXFWVOXVAXVOXVQUXRXVAXXBXXFXVAXXFWXKWPXVAXVSXXFV
        BWXKUXSUXTUYCWKXDXVRXXGXXBXVPXVAWXGNZXVQXXGXVDXVAXVOWXGWVOXVAXFWXFWXGXV
        GWXIRXHXXIXVQXXGWXKWVTUYAWKXDRWXKWVTUYBUYDXVRXXDXVNWAZXXBWVOXVOXVQXXJXV
        AWVOXVONZXVQXXDXVNXXKXVQXXDNZNZXVNWVPUYEZWVPUYFZXWDXIZXJZUYGUGZIXXMXXRI
        MZNZXWBXWCXVNWVOXWBXVOXXLXXSXWSXKXXTWXKWVTIPXXKXVQXXDXXSXLXXMWXFXXSWVTI
        MWVOWXFXVGXXLXLWXFXXSNCXXQWVPWXFXXSXQWXFXXQHURZXXSWXFWVPUIZXXQHWVPXXPUY
        HWXFXUDXYBHMWYSHHWVPUYIZWJUYJRWXFXXSXFWXFWWHHXXQXIZQZWXOXXSWXFXYEWXOWXF
        XUDXYEWXOWAWYSXUDXYEWWHXXNXWDXJZQZWXOXUDXYDXYFWWHXUDXYDXYBXYBXYFXIZXIZX
        YFXUDHXYBXXQXYHXUDXYBHXYCUYKXUDXXQXXNXXOXJZXYFXIZXYHXUDWVPUYLXXQXYKMHHW
        VPUYMXXOXWDWVPUYNWJZXYJXYBXYFWVPUYOZUYPXMUYQXYFXYBURXYIXYFMWVPXWDUYHXYF
        XYBUYRUYSXMXNXUDWVPHVUCZXYGWXOWAZHHWVPVUDZXYNXYGWYKWXONWXOHIWWHWVPUYTZW
        YKWXOXFVUAWJXOWJWKVQVUBXDVUEXXAXPXXMXXRIWNZNZWWQCHIWXNWVTWXKTJZWOXXRXRJ
        ZXSJZTJZKLZWWHXXQQZNZYUCIUNZUOZUHUGZWWRMZNZDWWCUJZWXKYUIPLZXVNXYSYUHWWC
        QZCHYUGIMZIYUGWWLUMJZUNZUOZEWVQLZBUPUJZYULXXMWXFXXDNZXYRYUNXXKWXFXXLXXD
        WVOWXFXVGXTXVQXXDXFZXHZYVAXYRNZUEHUEVAZXXQQZYVEWVPUGZYUBTJZIUNZUOZWWCQY
        UNYVDWVPUEHYVFYUBIUNZUOZTVUFZJZYVJWWCYVDYVNUEHYVGYVKTJZUOYVJYVDUEHYVGYV
        KTWVPYVLSSSXUJYVDWFUQZYVGSQYVDYVEHQZNZYVEWVPYAUQYVKSQYVRYVFYUBIXYTYUAXS
        YBZWQYCUQWXFWVPUEHYVGUOMXXDXYRWXFUEHHWVPWYSWHWEYVDYVLWGYDYVDUEHYVOYVIYV
        RYVOYVFYVHYVGITJZUNYVIYVFYUBIYVOYVHYVTYVKYUBYVGTYEYVKIYVGTYEYFYVRYVFYVT
        IYVHYVRYVFVBZYVTIMZYVRYWAYVQYVGIMZNZYWBYVRYVEXYFQZYWAYWDYVRYVFYWEYVRYVF
        YVEHXYFXIZQZYWEVBZWXFYVFYWGWLZXXDXYRYVQWXFXUDYWIWYSXUDXXQYWFYVEXUDXXQXY
        KYWFXYLXUDXYJHXYFXUDXYJXYBHXYMXYCYJZVUGYGXNWJXKYVRYWHYVQYWHNYWGYVRYVQYW
        HYVDYVQXFVUHYVEHXYFVUIVUJVUKVULWXFYWEYWDWLZXXDXYRYVQWXFXUDXYNYWKWYSXYPH
        IYVEWVPUYTVUMXKWTYWCYWBYVQYWCYVTIITJZIYVGIITYHIVUNVUOZXMVNVUAWKVUPYJUXL
        YGYVDWXFYVLWWCQYVNWWCQWXFXXDXYRVUQZYVDHYUBUWNUWOZUEHYVFYIIUNZUOZXRVUFZJ
        ZYVLWWCYVDYWSUEHYUBYWPXRJZUOYVLYVDUEHYUBYWPXRYWOYWQSSSYVPYUBSQZYVRYVSUQ
        YWPSQYVRYVFYIIVVDWQYCUQYWOUEHYUBUOMYVDUEHYUBVURUQYVDYWQWGYDYVDUEHYWTYVK
        YVDYWTYVFYUBYIXRJZYUBIXRJZUNYVKYVFYIIYWTYXBYXCYWPYIYUBXRYEYWPIYUBXRYEYF
        YVDYVFYXBYUBYXCIYVDYUBYVDYUBYVDXYTYUAYVAXYTHQZXYRWXFXXEXXDYXDWXHWVTWXKV
        USZXDZRWXFYUAHQZXXDXYRWXFWOHQZXXRHQZYXGVVEWXFXXQVUTUGZXXRHWXFXXQVUTUIQZ
        YXJXXRMZXXPWVPVVAZXXQVVBWJZWXFIXXPQVBYXJHQZIXXOVVCXXPWVPVVFWDZYKZWOXXRV
        VGWBZWEYVDWOXXRWOYSQYVDVVHUQZYVDXXRWXFYXIXXDXYRYXQWEYLZWOIWNYVDVVIUQZYV
        AXYRXFZVVJZVVOZYLZVVKZYVDYUBYYEVVLZVVMYJVFYGYVDYUBYWQWXFYWQWWCQZXXDXYRW
        XFYXKYXOYYHYXMYXPUEXXQYWQYWQULVVPXPWEYYDVVNYKWVPYVLVVQXPYKCYVJYUHCHYUGI
        WWHYVJUGZKLZYYIIUNZWYKYYKIYUEYUCIUNZKLZYYLIUNZYUGWYKYYJYYMYYIIYYLIWYKYY
        IYYLIKUEWWHYVIYYLHYVJUECVCZYVFYUEYVHIYUCIYVEWWHXXQVVRYYOYVGWXNYUBTYVEWW
        HWVPVIVEYYOIWGYMYVJULYUEYUCIWXNYUBTYBZWQYCVVSZWMYYQWYKIWGYMYUFYUGYYNMYU
        FYUGYUCYYNYUFYUCIWSYUEYUDYYNYUDYUCIUNZYUCYUEYYMYUDYYLIYUCIYUEYYLYUCIKYU
        EYUCIWSZWMZYYSYUEIWGYMYUDYUCIWSZVVTYNYUFVBZYUGIYYNYUFYUCIYOZUUUBYUDVBZY
        UEVBZVWEZYYNIMZYUDYUEVWAZUUUDUUUGUUUEUUUDYUEUUUGUUUDYUEUUUGYUEUUUDYYNYU
        DYYLIUNIYUEYYMYUDYYLIYYTVWBYUDYYLIYOVVTYTUUUEYYLIMZIIMZUUUGYUEYUCIYOIUL
        YYMUUUIUUUJUUUGYYLIYYLYYNIXBIYYNIXBVWFVWCZVWDUUUKVWOVWGYNVWHVWIVWJVWKWJ
        ZXDXYSYUBUPQCHYUOIYUGYUBUMJZUNZUOZEWVQLZYUTXYSYUBXXMYVAXYRYUBHQZYVCYYDX
        DXYSXYTYUAXXMYXDXYRXXKXXEXXDYXDXXLWXFXXEWVOXVGWXHVWLYVBYXEXGRXVOYXGWVOX
        XLXYRWXFYXGXVGYXRRXEXXMIXYTPLZXYRXXMXVQUUURXXKXVQXXDXTXXMWXKWVTXXKXVQXX
        DUULXVOXXEWVOXXLXXHVOVWMVRRXYSYXIIXXRPLZIYUAPLZXVOYXIWVOXXLXYRWXFYXIXVG
        YXQRXEXXKXYRUUUSXXLXXKXYRUUUSWXFXYRUUUSWAWVOXVGWXFIXXRKLZXYRUUUSWXFYXKX
        YAUUVAYXMXXQVWNXXQVWPVUMWXFUUUSUUVAXYRNZWXFXUFYXIUUUSUUVBWLWCYXQIXXRVWQ
        WBUXTUVJVWLWKVQYXHIWOPLYXIUUUSNUUUTVVEVWRWOXXRVWSVWTXPVXAVXBXYSUUUPUUUN
        WYGKLZCHVKZXYSWVRUUVDXVOWVRWVOXXLXYRWXFWVRXVFXTXEXYSWVRWYJUUVDXXKWVRWYJ
        WLZXXLXYRWVOEHVUCZXYNUUVEXVOHWVNEVUDWXFXYNXVGWXFXUDXYNWYSXYPWJRUUVFXYNN
        ZCHHWXNWYGKHWVPESSUUVFXYNXFUUVFXYNXQXUJUUVGWFUQZUUVHHVXCUUVGWYKNZWXNWGU
        UVIWYGWGVXFXGWEXYSWYIUUVCCHXXMWYDXXDNZXYRWYKWYIUUVCWAXXKWYDXXLXXDXVOWXF
        WVOWXFXVGXQVXDYVBXHUUVJXYRNZWYKNZWYIUUVCYUOXWKUUUMWYGKLZUUVCUUVLWYINZIU
        UUMIUUUNWYGKVXEUUUMUUUNWYGKVXEUUVLXWKWYIYUOUUVLXUCXWKUUVLXWMXWNUUVKHWVN
        WWHEWVOWXFXXDXYRUWMVPXWPUXBUXEWEYUFYUCYUBUMJZWYGKLZIYUBUMJZWYGKLZUUVMUU
        VNYUOVBZNYUCIYUCYUGMUUVOUUUMWYGKYUCYUGYUBUMYHVGIYUGMUUVQUUUMWYGKIYUGYUB
        UMYHVGUUVNUUVPUUVSYUFUUVNUUVOWXNWYGKUUVLUUVOWXNMWYIUUVLWXNYUBUUVLWXNUUV
        KHHWWHWVPWXFXUDWVOXXDXYRWYSXEVPYLUUVKYUBYSQZWYKWXFXXDXYRUUVTWVOYVDXYTYU
        AYVAXYTYSQXYRYVAXYTYXFYLRZWXFYUAYSQXXDXYRWXFYUAYXRYLWEZYYCVXGVTRVXHRUUV
        LWYIXFUXOWEUUVSUUUBUUVRUUVNUUUBUUVSUUVRUUUBYUOUUVRUUUCVXIVXJVXKVSVSYTVX
        PUVKXOVXQWVOUUUPUUVDWLXVOXXLXYRWVOCHUUUNWYGKUUUOESSWVNXWQUUUNSQXWLYUOIU
        UUMWQYUGYUBUMYBYCUQXWOWVOUUUOWGXULWIXKWRYUSUUUPBYUBUPWWLYUBMZYURUUUOEWV
        QUUWCCHYUQUUUNUUWCYUOYUPUUUMIWWLYUBYUGUMYEVXLVFVGXAXPYUKYUTDYUHWWCWWIYU
        HMZWWQYUKYUTUUWDYUJWWQYUJYUHWWIYUHWWIUHVIVXMUXIUUWDWWPYUSBUPUUWDWWOYURE
        WVQUUWDCHWWNYUQCWWIYUHCHYUGVXNVXOUUWDWYKNZWWKYUOWWMYUPIUUWEWWJYUGIUUWDW
        YKWWJWWHYUHUGZYUGWWHWWIYUHVDWYKYUGSQZUUWFYUGMYUFYUCIYYPWQYCZCHYUGSYUHYU
        HULVXRWDUXKZUUPUUWEWWJYUGWWLUMUUWIVEUUQVXSVGVHWTXAXPXVOXXLXYRYUMWVOWXFX
        XLXYRYUMXVGWXFXXLNXYRNZWXKWVPCHYUEYUBIUNZUOZYVMJZUHUGZYUIWXFXVQXXDXYRVX
        TWXFXXDXYRUUWNHQZXVQYVDUUWMWWCQZUUWOYVDWXFUUWLWWCQZUUWPYWNYVDYWOCHYUEYI
        IUNZUOZYWRJZUUWLWWCYVDUUWTCHYUBUUWRXRJZUOUUWLYVDCHYUBUUWRXRYWOUUWSSSSYV
        PYXAYVDWYKNZYVSUQUUWRSQUUXBYUEYIIVVDWQYCUQYWOCHYUBUOMYVDCHYUBVURUQYVDUU
        WSWGYDYVDCHUUXAUUWKYVDUUXAYUEYXBYXCUNUUWKYUEYIIUUXAYXBYXCUUWRYIYUBXRYEU
        UWRIYUBXRYEYFYVDYUEYXBYUBYXCIYYFYYGVVMYJVFYGZYVDYUBUUWSWXFUUWSWWCQZXXDX
        YRWXFYXKYXOUUXDYXMYXPCXXQUUWSUUWSULZVVPXPWEZYYDVVNYKZWVPUUWLVVQXPZUUWMU
        SWJYPUUWJYUNYUIHQWXFXXDXYRYUNXVQUUULYPZYUHUSWJUUWJWXKWVTWOXSJZWXKWOXSJZ
        UMJZUUWNPUUWJXVQWXKUUXLPLZWXFXVQXXDXYRXLWXFXXDXYRXVQUUXMWLZXVQYVAUUXNXY
        RYVAXVQUUXKUUXJPLZWXKUUXKTJZUUXJPLZUUXMYVAWXKWVTWOWXFXXDXFZWXFXXEXXDWXH
        RXWJYVAUWRUQVYAXXDUUXQUUXOWLWXFXXDUUXPUUXKUUXJPXXDUUXKUUXKUMJZUUXKTJUUX
        PUUXKXXDUUXSWXKUUXKTXXDWXKWXKVYBZVYCVEXXDUUXKUUXKXXDWXKUUXTYQZUUYAVYDVY
        EVGVNYVAWXKUUXKUUXJUUXRXXDUUXKHQWXFWXKVYFVNWXFUUXJHQXXDWXFWVTWXHVYGRVYH
        VYIRYPVRWXFXXDXYRUUWNUUXLMXVQYVDWVTUUWLUHUGZTJZWVTXYTWOXSJZTJZUUWNUUXLY
        VDUUYBUUYDWVTTYVDUUWTUHUGYUBUUWSUHUGZXRJZUUYBUUYDYVDYUBUUWSUUXFYYDVYJYV
        DUUWTUUWLUHUUXCVYNYVDUUYGYUBYXJXRJZYXJYUBXRJZUUYDWXFUUYGUUYHMXXDXYRWXFU
        UYFYXJYUBXRWXFYXKYXOUUYFYXJMYXMYXPCXXQUUWSUUXEVYOXPYRWEYVDYUBYXJYYEWXFY
        XJYSQXXDXYRWXFYXJYXPYLWEZVYKYVDYXJXYTXRJZYUAXSJXYTXXRXRJZYUAXSJUUYIUUYD
        YVDUUYKUUYLYUAXSYVDUUYKXXRXYTXRJUUYLYVDYXJXXRXYTXRWXFYXLXXDXYRYXNWEVEYV
        DXXRXYTYXTUUWAVYKYGVEYVDYXJXYTYUAUUYJUUWAUUWBYYCVYLYVDXYTWOXXRUUWAYXSYX
        TYYAYYBVYMVYPVYQVYPYRYVDWXFUUWQUUWNUUYCMYWNUUXGWVPUUWLVYRXPYVDUUYEWVTUU
        XJUUXKTJZTJZWVTUUXJTJZUUXKUMJZUUXLYVDUUYDUUYMWVTTYVDWVTWXKWOWXFWVTYSQZX
        XDXYRWXFWVTWXHYLZWEXXDWXKYSQWXFXYRUUXTVOYXSYYAVYSYRYVAUUYNUUYPMXYRYVAWV
        TUUXJUUXKWXFUUYQXXDUUYRRZYVAWVTUUYSYQXXDUUXKYSQWXFUUYAVNVYTRWXFUUYPUUXL
        MXXDXYRWXFUUYOUUXJUUXKUMWXFUUXJUUXJUMJZUUXJTJUUYOUUXJWXFUUYTWVTUUXJTWXF
        WVTUUYRVYCVEWXFUUXJUUXJWXFWVTUUYRYQZUVUAVYDVYEVEWEWUAWUCYPWUBUUWJUUWPYU
        NUUWMYUHWVQLZUUWNYUIKLWXFXXDXYRUUWPXVQUUXHYPUUXIUUWJUVUBWXNUUWKTJZYUGKL
        ZCHVKUUWJUVUDCHUUWJWYKNZYUEUVUDUVUEYUENUVUDYUCYYRKLZUVUEUVUFYUEUUWJYVDW
        YKUVUFWXFXXDXYRYVDXVQYVDVMYPUUXBYUDUVUFUUXBYUDNUVUFYUCYUCKLZUUXBUVUGYUD
        UUXBYUCUUXBWXNYUBYVDWXFWYKWYRYWNWYTXDYVDUUUQWYKYYDRWUDZWUERYUDUVUFUVUGW
        LUUXBYUDYYRYUCYUCKUUUAWMVNWRUUXBUUUDNZUVUFYUCIKLZUVUIYUCIUUXBYUCHQUUUDU
        VUHRXUFUVUIWCUQUUXBYUCIPLUUUDUUXBYUCIUVUHXUFUUXBWCUQWUFWUGWUHUUUDUVUFUV
        UJWLUUXBUUUDYYRIYUCKYUDYUCIYOWMVNWRWUIXDRYUEUVUDUVUFWLUVUEYUEUVUCYUCYUG
        YYRKYUEUUWKYUBWXNTYUEYUBIWSYRYUEYUFYUDYUCIYUEYUDYUFYUEYUDWUJWUKVWBWUMVN
        WRUVUEUUUENZUVUDWXNITJZIKLZUVUKUVULIIKUVUKUVULYWLIUVUKWXNIITUUWJXUDWYKU
        UUEWXOWXFXUDXXLXYRWYSWEXUDWYKNZUUUEWXOUVUNUUUEWWHXYJQZXYGVBNZVBZWXOXUDU
        UUEUVUQWLWYKXUDYUEUVUPXUDYUEWWHXYKQUVUPXUDXXQXYKWWHXYLXNWWHXYJXYFVUIWUL
        WUNRUVUQUVUOVBZXYGVWEUVUNWXOUVUOXYGWUOUVUNUVURWXOXYGUVUNUVUOWXOXUDUVUOW
        YKXUDXYJHWWHYWJXNWUGVXIXUDXYOWYKXUDXYNXYOXYPXYNXYGWXOXYNXYGWYKWXOXYQWUP
        YTWJRWUQUVRXOWKVXPVEYWMXMUUTUVBUUUEUVUDUVUMWLUVUEUUUEUVUCUVULYUGIKUUUEU
        UWKIWXNTYUEYUBIYOYRUUUDUUUEYUOUUUFUUUBYUOUUUHUUUCWURWUSWUMVNWRWUIUXCUUW
        JCHUVUCYUGKUUWMYUHSSSXUJUUWJWFUQZUVUCSQUVUEWXNUUWKTYBUQUUWGUVUEUUWHUQUU
        WJCHWXNUUWKTWVPUUWLSSSUVUSWXNSQUVUEWWHWVPYAUQUUWKSQUVUEYUEYUBIYVSWQYCUQ
        WXFXUNXXLXYRXUOWEUUWJUUWLWGYDUUWJYUHWGWIWRUUWMYUHWUTUVMWVAWVBVTXVMYULYU
        MNUCYUIYUHUHYAXUPYUIMZXVLYULXUQYUMUVUTXVKYUKDWWCUVUTXVJYUJWWQXUPYUIWWRX
        BXCVHXUPYUIWXKPVLVJUXPXPWVCWVDWVBRVXQWVCYTXOWKWVEWVFWVGWVHWVIWWDXVHXUSU
        DAAUDVCZWWBXVGUAWWCUVVAWWAXVFWVRWVSXURWVTXBXCVHWVLWXAXVLXUQUCAAUCVCZWWT
        XVKDWWCUVVBWWSXVJWWQWVSXUPWWRXBXCVHWVLWVJXOWVMWVKYJYN $.
    $}

    itg2addnc.f1 $e |- ( ph -> F e. MblFn ) $.
    itg2addnc.f2 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    $( Lemma for ~ itg2addnc .  The function described is a simple function.
       (Contributed by Brendan Leahy, 29-Oct-2017.) $)
    itg2addnclem2 $p |- ( ( ( ph /\ h e. dom S.1 ) /\ v e. RR+ ) ->
        ( x e. RR |-> if ( ( ( ( ( |_ ` ( ( F ` x ) / ( v / 3 ) ) ) - 1 ) x.
          ( v / 3 ) ) <_ ( h ` x ) /\ ( h ` x ) =/= 0 ) ,
        ( ( ( |_ ` ( ( F ` x ) / ( v / 3 ) ) ) - 1 ) x. ( v / 3 ) ) ,
          ( h ` x ) ) ) e. dom S.1 ) $=
      ( vt wcel wa cr co cle wbr cc0 syl syl2anc wceq cima crab vy cdm crp cdiv
      cv cfv c3 cfl c1 cmin cmul wne cmpt cpnf cico wss cxr pnfxr mp2an sylancl
      0re ad2antrr ffvelrnda 3ne0 pm3.2i redivcl 3expb ad2antlr redivcld reflcl
      wf cc remulcld eqid crn clt caddc cun cfn ax-mp mpan2 sylib adantr c0 frn
      wral sylibr ad3antlr wi syl3anc lemuldivd 1re a1i bitrd peano2re cz wb wn
      csn cdif ccnv cin cvol mptpreima wo unrab inrab eqtri eqcom elsnc rabbiia
      imdistani ciun eqtr3i syl5eqr rabbidva imassrn syl5eq eqtr4d cmnf adantlr
      rabeq cioo rexrd 3bitr4d imaeq1d syl6eq ad3antrrr mbfima eqeltrd mbfimasn
      inmbl ralrimiva eqeltrrd i1fima unmbl recnd ad4antr adantl eqtrd cif rpre
      citg1 icossre fss 3re rpcnne0 3cn peano2rem i1ff ifcl fmptd csup cneg cfz
      divne0 wfo fzfi wfn ovex fnmpti dffn4 mpbi fofi i1frn unfi sylancr cn0 cn
      wrex 3nn rpdivcl elrege0 simprd divge0d flge0nn0 nn0ge0d w3a i1f0rn elex2
      nnrp wex fimaxre2 3jca ffn dffn3 suprub suprcl letr lesubaddd ceige ceicl
      n0 zred mpan2d sylbid syld adantrd imp flcld elfz mpbir2and oveq1d eqeq2d
      oveq1 rspcev cvv elrnmpt elun1 elun2 ifclda ssfi ineq1i uneq12i fvex ifex
      0z ianor nne orbi2i bitr2i anbi1i eqif bitr4i 3bitr4i 3eqtr4ri sseld syl5
      eldifi rabiun cnvimarndm imaeq2i imaiun fdm fniniseg 3syl simplbda breq2d
      iunid inrab2 syl5sseq sselda ltdivmuld lxflflp1 elioomnf biantrurd bitr4d
      dfdm4 dfss1 3bitrd feqmptd cnveqd cmbf i1fmbf jca 3expa finiunmbl uneq12d
      sylan lttri2 ibar andi 0xr elioopnf orbi12d syl6bb ax-1cn simplr subadd2d
      3eqtr4a recn divmul3d syl5bb bitr3d imaundi zre peano2z zcn mulcomd ltp1d
      ltmul2dd eqbrtrd snunioo imaeq12d 3biant1d ad4antlr bicomd anbi12d elico2
      flbi an32s ex con3and rabeq0 0mbl syl6eqel pm2.61dan notbid sylan2 ancoms
      simpr adantll ltpnf imaeq2d elicopnf 3bitr2d ltadd1d ltaddsubd ltdivmul2d
      ltnled 3eqtrd bitri syl5eqel mblvol eldifsn anim1d syl5bi ineq12d biimpri
      covol intnand iffalse eqtr mpancom simpll necomd eqnetrd orcom necon3bbii
      imor imbi12i ad2antll dmmpti sseqtri reldisj wfun ffun difpreima sseqtr4d
      difeq1d neldifsn i1fima2 ovolsscl i1fd ) ADUEZUUCUBIZJZCUEZUCIZJZHBKBUEZE
      UFZWUHUGUDLZUDLZUHUFZUIUJLZWUMUKLZWUKWUEUFZMNZWUROULZJZWUQWURUUAZUMZWUJBK
      WVBKWVCWUJWUKKIZJZWUQKIZWURKIZWVBKIWVEWUPWUMWVEWUOKIZWUPKIZWVEWUNKIZWVHWV
      EWULWUMWUJKKWUKEAKKEVKZWUFWUIAKOUNUOLZEVKZWVLKUPZWVKGOKIZUNUQIZWVNVAUROUN
      UUDUSKWVLKEUUEUTZVBVCZWUIWUMKIZWUGWVDWUIWUHKIZUGKIZUGOULZJWVSWUHUUBWWAWWB
      UUFVDVEWVTWWAWWBWVSWUHUGVFVGUTZVHZWUIWUMOULZWUGWVDWUIWUHVLIWUHOULJUGVLIZW
      WBJWWEWUHUUGWWFWWBUUHVDVEWUHUGUUPUTZVHZVIZWUNVJZPZWUOUUIZPZWWDVMZWUJKKWUK
      WUEWUFKKWUEVKZAWUIWUEUUJZVHVCZWVAWUQWURKUUKQWVCVNZUULZWUJHOWUEVOZKVPUUMZW
      UMUDLZUIVQLZUUNUHUFUUNZUUOLZHUEZUIUJLZWUMUKLZUMZVOZWWTVRZVSIZWVCVOZWXKUPZ
      WXMVSIWUJWXJVSIZWWTVSIZWXLWXEVSIWXEWXJWXIUUQZWXOOWXDUURWXIWXEUUSWXQHWXEWX
      HWXIWXGWUMUKUUTWXIVNZUVAWXEWXIUVBUVCWXEWXJWXIUVDUSWUFWXPAWUIWUEUVEZVHZWXJ
      WWTUVFUVGWUJKWXKWVCVKWXNWUJBKWVBWXKWVCWVEWVAWUQWURWXKWVEWVAJZWUQWXJIZWUQW
      XKIWYAWUQWXHRZHWXEUVJZWYBWYAWUOWXEIZWUQWUQRZWYDWYAWYEOWUOMNZWUOWXDMNZWVEW
      YGWVAWVEWUOWVEWVJOWUNMNWUOUVHIWWIWVEWULWUMWVRWUIWUMUCIZWUGWVDWUIUGUCIZWYI
      UGUVIIWYJUVKUGUWAVTWUHUGUVLWAZVHZWVEWULKIZOWULMNZWVEWULWVLIWYMWYNJWUJKWVL
      WUKEAWVMWUFWUIGVBVCWULUVMWBUVNUVOWUNUVPQUVQWCWVEWVAWYHWVEWUSWYHWUTWVEWUSW
      URWXAMNZWYHWVEWWTKUPZWWTWDULZUAUEWUKMNUAWWTWFBKUVJZUVRZWURWWTIZWYOWUFWYSA
      WUIWVDWUFWYPWYQWYRWUFWWOWYPWWPKKWUEWEPZWUFWUKWWTIBUWBZWYQWUFOWWTIXUBWUEUV
      SBOWWTUVTPBWWTUWMWGZWUFWYPWXPWYRXUAWXSBUAWWTUWCQZUWDWHWUJKWWTWUKWUEWUFKWW
      TWUEVKZAWUIWUFWUEKUUSZXUEWUFWWOXUFWWPKKWUEUWEZPKWUEUWFWBVHVCZBUAWWTWURUWG
      QWVEWUSWYOJZWUQWXAMNZWYHWVEWVFWVGWXAKIZXUIXUJWIWWNWWQWUFXUKAWUIWVDWUFWYPW
      YQWYRXUKXUAXUCXUDBUAWWTUWHWJWHZWUQWURWXAUWIWJWVEXUJWUOWXCMNZWYHWVEXUJWUPW
      XBMNXUMWVEWUPWXAWUMWWMXULWYLWKWVEWUOUIWXBWWKUIKIZWVEWLWMWVEWXAWUMXULWWDWW
      HVIZUWJWNWVEXUMWXCWXDMNZWYHWVEWXCKIZXUPWVEWXBKIXUQXUOWXBWOPZWXCUWKPWVEWVH
      XUQWXDKIXUMXUPJWYHWIWWKXURWVEWXDWVEXUQWXDWPIZXURWXCUWLPZUWNWUOWXCWXDUWIWJ
      UWOUWPUWQUWOUWRUWSWYAWUOWPIZOWPIZXUSWYEWYGWYHJWQWVEXVAWVAWVEWUNWWIUWTWCXV
      BWYAUXQWMWVEXUSWVAXUTWCWUOOWXDUXAWJUXBWUQVNWYCWYFHWUOWXEWXFWUORZWXHWUQWUQ
      XVCWXGWUPWUMUKWXFWUOUIUJUXEUXCUXDUXFUTWUQUXGIWYBWYDWQWUPWUMUKUUTZHWXEWXHW
      UQWXIUXGWXRUXHVTWGWUQWXJWWTUXIPWVEWURWXKIZWVAWRZWVEWYTXVEXUHWURWWTWXJUXJP
      WCUXKWWRUULKWXKWVCWEPWXKWXMUXLQWUJWXFWXMOWSZWTIZJZWVCXAZWXFWSZSZWUSBKTZWU
      TBKTZXBZWXFWUQRZBKTZXBZWUSWRZBKTZWURORZBKTZVRZWXFWURRZBKTZXBZVRZXCUBZXVLW
      VBXVKIZBKTZXWGBKWVBXVKWVCWWRXDZWVAXVPJZBKTZXVSXWAXEZXWDJZBKTZVRXWLXWOXEZB
      KTXWGXWJXWLXWOBKXFXVRXWMXWFXWPXVRWVABKTZXVQXBXWMXVOXWRXVQWUSWUTBKXGUXMWVA
      XVPBKXGXHXWFXWNBKTZXWEXBXWPXWCXWSXWEXVSXWABKXFUXMXWNXWDBKXGXHUXNXWIXWQBKX
      WIXWQWQWVDWVBWXFRWXFWVBRZXWIXWQWVBWXFXIWVBWXFWVAWUQWURXVDWUKWUEUXOZUXPZXJ
      ZXWQXWLXVFXWDJZXEXWTXWOXXDXWLXWNXVFXWDXVFXVSWUTWRZXEXWNWUSWUTUXRXXEXWAXVS
      WUROUXSZUXTUYAUYBUXTWVAWXFWUQWURUYCUYDUYEWMXKUYFXHXVIWUJWXFKIZJZXWGXWHIZW
      UJXVHXXGXVHWXFWXMIZWUJXXGWXFWXMXVGUYIWUJWXMKWXFWUJKKWVCVKWXMKUPWWSKKWVCWE
      PUYGZUYHXLXXHXVRXWHIZXWFXWHIZXXIXXHXVOXWHIZXVQXWHIXXLWUJXXNXXGWUJXVMXWHIX
      VNXWHIZXXNWUJHWWTWUSBWUEXAZXVKSZTZXMZXVMXWHWUJXXSWUSBHWWTXXQXMZTZXVMWUSBH
      WWTXXQUYJWUJXXTKRZXYAXVMRWUFXYBAWUIWUFXXTWUEUBZKXXPWWTSZXYCXXTWUEUYKZXXPH
      WWTXVKXMZSXYDXXTXYFWWTXXPHWWTUYSUYLHXXPWWTXVKUYMXNXNWUFWWOXYCKRWWPKKWUEUY
      NZPZXOZVHWUSBXXTKYBPXOWUJWXPXXRXWHIZHWWTWFXXSXWHIWXTWUJXYJHWWTWUJWXFWWTIZ
      JZXXRWUQWXFMNZBKTZXXQXBZXWHWUFXXRXYORAWUIXYKWUFXXRXYMBXXQTZXYOWUFWUSXYMBX
      XQWUFWUKXXQIZJZWURWXFWUQMWUFXYQWVDWURWXFRZWUFWWOXUFXYQWVDXYSJWQWWPXUGKWXF
      WUKWUEUYOUYPUYQUYRZXPWUFXYOXYMBKXXQXBZTZXYPXYMBKXXQUYTWUFYUAXXQRZYUBXYPRW
      UFXXQKUPYUCWUFXXPVOZXXQKXXPXVKXQWUFYUDXYCKWUEVUHXYHXOZVUAXXQKVUIWBZXYMBYU
      AXXQYBPXRXSWHXYLXYNXWHIXXQXWHIZXYOXWHIXYLXYNEXAZXTWUMWXFWUMUDLZUIVQLZUHUF
      ZUIVQLZUKLZYCLZSZXWHXYLXYNWULYUNIZBKTZYUOXYLXYMYUPBKXYLWVDJZXYMWUPYUIMNWU
      OYUJMNZYUPYURWUPWXFWUMWUJWVDWVIXYKWWMYAXYLXXGWVDWUJWWTKWXFWUFWYPAWUIXUAVH
      VUBWCZWUIWYIWUGXYKWVDWYKWHZWKYURWUOUIYUIWUJWVDWVHXYKWWKYAXUNYURWLWMYURWXF
      WUMYUTWUIWVSWUGXYKWVDWWCWHZWUIWWEWUGXYKWVDWWGWHVIZUWJYURWUNYULVPNZWULYUMV
      PNZYUSYUPYURWULYULWUMWUJWVDWYMXYKWVRYAZYURYUKKIZYULKIYURYUJKIZYVGYURYUIKI
      ZYVHYVCYUIWOZPZYUJVJPYUKWOPZYVAVUCYURWVJYVHYUSYVDWQWUJWVDWVJXYKWWIYAYVKWU
      NYUJVUDQYURYUPWYMYVEJZYVEYURYUMUQIYUPYVMWQYURYUMYURWUMYULYVBYVLVMYDYUMWUL
      VUEPYURWYMYVEYVFVUFVUGYEVUJXPAYUOYUQRWUFWUIXYKAYUOBKWULUMZXAZYUNSYUQAYUHY
      VOYUNAEYVNABKWVLEGVUKVULZYFBKWULYUNYVNYVNVNZXDYGYHXSAYUOXWHIZWUFWUIXYKAEV
      UMIZWVKYVRFWVQKXTYUMEYIQYHYJXYLXXHYUGWUJXYKXXGWUFXYKXXGWIAWUIWUFWWTKWXFXU
      AUYGVHXLZWUJWUEVUMIZWWOJZXXGYUGWUFYWBAWUIWUFYWAWWOWUEVUNWWPVUOVHYWAWWOXXG
      YUGKWXFWUEYKVUPVUSZPZXYNXXQYLQYJYMWWTXXRHVUQQYNWUFXXOAWUIWUFXXPXTOYCLZSZX
      XPOUNYCLZSZVRZXVNXWHWUFWURYWEIZBKTZWURYWGIZBKTZVRYWJYWLXEZBKTYWIXVNYWJYWL
      BKXFWUFYWFYWKYWHYWMWUFYWFBKWURUMZXAZYWESYWKWUFXXPYWPYWEWUFWUEYWOWUFBKKWUE
      WWPVUKVULZYFBKWURYWEYWOYWOVNZXDYGWUFYWHYWPYWGSYWMWUFXXPYWPYWGYWQYFBKWURYW
      GYWOYWRXDYGVURWUFWUTYWNBKWUFWVDJWVGWUTYWNWQWUFKKWUKWUEWWPVCWVGWUTWUROVPNZ
      OWURVPNZXEZYWNWVGWVOWUTYXAWQVAWUROVUTWAWVGYXAWVGYXAJZYWNWVGYXAVVAYXBWVGYW
      SJZWVGYWTJZXEZYWNWVGYWSYWTVVBOUQIZYWNYXEWQVVCYXFYWJYXCYWLYXDOWURVUEOWURVV
      DVVEVTUYDVVFWNPXPVVJWUFYWFXWHIYWHXWHIYWIXWHIYWEWUEYOYWGWUEYOYWFYWHYPQYNVH
      XVMXVNYLQWCXXHYUJWUORZBKTZXVQXWHXXHYXGXVPBKXXHWVDJZWUPYUIRZYXGXVPYXIWUOUI
      YUIWUJWVDWUOVLIXXGWVEWUOWWKYQYAUIVLIYXIVVGWMYXIYUIYXIWXFWUMWUJXXGWVDVVHZW
      UIWVSWUGXXGWVDWWCWHZWUIWWEWUGXXGWVDWWGWHZVIZYQVVIYXJYUIWUPRYXIXVPWUPYUIXI
      YXIWXFWUPWUMXXGWXFVLIWUJWVDWXFVVKVHWUJWVDWUPVLIXXGWVEWUPWWMYQYAWUIWUMVLIZ
      WUGXXGWVDWUIWUMWWCYQZWHYXMVVLVVMVVNXPXXHYUJWPIZYXHXWHIXXHYXQJZYUHYUJWUMUK
      LZWSZSZYUHYXSWUMYUJUIVQLZUKLZYCLZSZVRZYXHXWHYXRYYFYVOYXSYYCUOLZSZYXHYXRYY
      FYUHYXTYYDVRZSYYHYUHYXTYYDVVOYXRYUHYVOYYIYYGAYUHYVORWUFWUIXXGYXQYVPYRYXRY
      XSUQIYYCUQIZYXSYYCVPNYYIYYGRYXRYXSYXRYUJWUMYXQYVHXXHYUJVVPZYSZWUIWVSWUGXX
      GYXQWWCWHZVMZYDYXRYYCYXRWUMYYBYYMYXQYYBKIZXXHYXQYYBYUJVVQUWNZYSZVMYDZYXRY
      XSWUMYUJUKLYYCVPYXRYUJWUMYXQYUJVLIXXHYUJVVRYSWUIYXOWUGXXGYXQYXPWHVVSYXRYU
      JYYBWUMYYLYYQWUIWYIWUGXXGYXQWYKWHYXQYUJYYBVPNXXHYXQYUJYYKVVTYSVWAVWBYXSYY
      CVWCWJVWDXOYXRYYHWULYYGIZBKTYXHBKWULYYGYVNYVQXDYXRYYSYXGBKXXHWVDYXQYYSYXG
      WQYXIYXQJZWYMYXSWULMNZWULYYCVPNZUVRZYUJWUNMNZWUNYYBVPNZJZYYSYXGYYTUUUAUUU
      BJZUUUCUUUFYXIUUUGUUUCWQYXQYXIUUUBUUUAWYMXXHKKWUKEAWVKWUFWUIXXGWVQYHZVCZV
      WEWCYYTUUUAUUUDUUUBUUUEYYTYUJWULWUMYXQYVHYXIYYKYSYXIWYMYXQUUUIWCZWUIWYIWU
      GXXGWVDYXQWYKVWFZWKYYTUUUEUUUBYYTWULYYBWUMUUUJYXQYYOYXIYYPYSUUUKVUCVWGVWH
      VVNXXHYXQYYSUUUCWQZWVDYXRYXSKIZYYJUUULYYNYYRYXSYYCWULVWIQYAYXGWUOYUJRZYYT
      UUUFYUJWUOXIYXIWVJYXQUUUNUUUFWQWUJWVDWVJXXGWWIYAZWUNYUJVWJVUSVVMYEVWKXPXR
      YTYXRYYAXWHIZYYEXWHIZYYFXWHIYXRYVSWVKUUUMUUUPAYVSWUFWUIXXGYXQFYRAWVKWUFWU
      IXXGYXQWVQYRYYNKYXSEYKWJAUUUQWUFWUIXXGYXQAYVSWVKUUUQFWVQKYXSYYCEYIQYRYYAY
      YEYPQYNXXHYXQWRZJZYXHWDXWHUUUSYXGWRZBKWFYXHWDRUUUSUUUTBKXXHWVDUUURUUUTYXI
      YXGYXQYXIYXGYXQYXIYXGJYUJWUOWPYXIYXGVXAYXIXVAYXGYXIWUNUUUOUWTWCYJVWLVWMVW
      KYMYXGBKVWNWGVWOVWPVWQYNXVOXVQYLQXXHXWCXWHIZXWEXWHIXXMWUJUUVAXXGWUJXVTXWH
      IXWBXWHIZUUVAWUJHWWTXVSBXXQTZXMZXVTXWHWUFUUVDXVTRAWUIWUFUUVDXVSBXXTTZXVTX
      VSBHWWTXXQUYJWUFXYBUUVEXVTRXYIXVSBXXTKYBPXOVHWUJWXPUUVCXWHIZHWWTWFUUVDXWH
      IWXTWUJUUVFHWWTXYLUUVCXYMWRZBKTZXXQXBZXWHWUFUUVCUUVIRAWUIXYKWUFUUVCUUVGBX
      XQTZUUVIWUFXVSUUVGBXXQXYRWUSXYMXYTVWRXPWUFUUVIUUVGBYUATZUUVJUUVGBKXXQUYTW
      UFYUCUUVKUUVJRYUFUUVGBYUAXXQYBPXRXSWHXYLUUVHXWHIZYUGUUVIXWHIXYLXXHUUVLYVT
      XXHYUHYYBUHUFZWUMUKLZWSZSZYUHUUVNUNYCLZSZVRZUUVHXWHXXHUUVSYUHUUVNUNUOLZSZ
      WULUUVTIZBKTZUUVHXXHUUVSYUHUUVOUUVQVRZSUUWAYUHUUVOUUVQVVOXXHUUWDUUVTYUHXX
      HUUVNUQIWVPUUVNUNVPNZUUWDUUVTRXXHUUVNXXHUUVMWUMXXHYVHYYOUUVMKIZXXHYVIYVHW
      UIXXGYVIWUGXXGWUIYVIWUIXXGWVSWWEJYVIWUIWVSWWEWWCWWGVUOXXGWVSWWEYVIWXFWUMV
      FVGVWSVWTVXBYVJPZYUJWOZYYBVJUYPZWUIWVSWUGXXGWWCVHVMZYDWVPXXHURWMXXHUUVNKI
      ZUUWEUUWJUUVNVXCPUUVNUNVWCWJVXDXOAUUWAUUWCRWUFWUIXXGAUUWAYVOUUVTSUUWCAYUH
      YVOUUVTYVPYFBKWULUUVTYVNYVQXDYGYHXXHUUWBUUVGBKYXIUUWBYUIWUPVPNZWXFWUQVPNU
      UVGYXIUUWBYUJWUOVPNZUUWLYXIUUVMWUNMNZYYBWUOUIVQLVPNZUUWBUUWMYXIYYOWVJUUWN
      UUWOWQXXHYYOWVDXXHYVHYYOUUWGUUWHPWCUUUOYYBWUNVUDQYXIUUWBWYMUUVNWULMNZJZUU
      WPUUWNYXIUUWKUUWBUUWQWQXXHUUWKWVDUUWJWCUUVNWULVXEPYXIWYMUUWPUUUIVUFYXIUUV
      MWULWUMXXHUUWFWVDUUWIWCUUUIWUIWYIWUGXXGWVDWYKWHZWKVXFYXIYUJWUOUIXXHYVHWVD
      UUWGWCYXIWVJWVHUUUOWWJPZXUNYXIWLWMZVXGYEYXIYUIUIWUOYXNUUWTUUWSVXHWNYXIWXF
      WUPWUMYXKYXIWVHWVIUUWSWWLPZUUWRVXIYXIWXFWUQYXKYXIWUPWUMUUXAYXLVMVXJVUJXPV
      XKXXHUUVPXWHIZUUVRXWHIZUUVSXWHIXXHYVSWVKUUWKUUXBAYVSWUFWUIXXGFYHUUUHUUWJK
      UUVNEYKWJAUUXCWUFWUIXXGAYVSWVKUUXCFWVQKUUVNUNEYIQYHUUVPUUVRYPQYNPYWDUUVHX
      XQYLQYJYMWWTUUVCHVUQQYNWUFUUVBAWUIWUFXXPXVGSZXWBXWHWUFUUXDYWPXVGSZXWBWUFX
      XPYWPXVGYWQYFZUUXEWURXVGIZBKTZXWBBKWURXVGYWOYWRXDZUUXGXWABKUUXGXWAWQWVDWU
      ROXXAXJZWMXKXHYGXVGWUEYOYNVHXVTXWBYPQWCXXHXXQXWEXWHWUFXXQXWERAWUIXXGWUFXX
      QYWPXVKSZXWEWUFXXPYWPXVKYWQYFUUXKWURXVKIZBKTXWEBKWURXVKYWOYWRXDUUXLXWDBKU
      UXLXWDWQWVDUUXLXYSXWDWURWXFXXAXJWURWXFXIVXLWMXKXHYGWHYWCYNXWCXWEYLQXVRXWF
      YPQPVXMZXVIXVLXCUFZXVLVXTUFZKXVIXVLXWHIUUXNUUXORUUXMXVLVXNPXVIWUJXXGWXFOU
      LZJZJZUUXOKIZWUJXVHUUXQXVHXXJUUXPJWUJUUXQWXFWXMOVXOWUJXXJXXGUUXPXXKVXPVXQ
      XLUUXRXVLXXPWWTXVGWTZSZUPUUYAKUPZUUYAVXTUFZKIZUUXSUUXRXVLKUUXDWTZUUYAUUXR
      XVLUUXDXBZWDRZXVLUUYEUPZUUXRUUYFXWIUUXGJZBKTZWDWUFUUYFUUYJRAWUIUUXQWUFUUY
      FXWJUUXHXBUUYJWUFXVLXWJUUXDUUXHXVLXWJRWUFXWKWMWUFUUXDUUXEUUXHUUXFUUXIYGVX
      RXWIUUXGBKXGYGWHUUXPUUYJWDRZWUJXXGUUXPUUYIWRZBKWFUUYKUUXPUUYLBKUUXPWVDJZX
      WAWVBWXFULZWIZUUYLUUYMXWAUUYNUUYMXWAJZWVBOWXFXWAWVBORZUUYMWVBWURRZXWAUUYQ
      XWAXVFUUYRXWAWUTWUSXXEXWAXXFVXSVYAWVAWUQWURVYBPWVBWUROVYCVYDYSUUYPWXFOUUX
      PWVDXWAVYEVYFVYGVWLUUYLUUXGXWIWRZWIZUUYOUUYSUUXGWRZXEUVUAUUYSXEUUYLUUYTUU
      YSUVUAVYHXWIUUXGUXRUUXGUUYSVYJUYEUUXGXWAUUYSUUYNUUXJXWIWVBWXFXXCVYIVYKVXL
      WGYMUUYIBKVWNWGVYLYTXVLKUPUUYGUUYHWQXVLXVJVOZKXVJXVKXQWVCUBUVUBKWVCVUHBKW
      VBWVCXXBWWRVYMXNVYNXVLUUXDKVYOVTWBWUFUUYAUUYERZAWUIUUXQWUFWWOUVUCWWPWWOUU
      YAXYDUUXDWTZUUYEWWOWUEVYPUUYAUVUDRKKWUEVYQWWTXVGWUEVYRPWWOXYDKUUXDWWOXYDX
      YCKXYEXYGXRVYTYTPWHVYSWUFUUYBAWUIUUXQWUFYUDUUYAKXXPUUXTXQYUEVUAWHWUFUUYDA
      WUIUUXQWUFUUYAXCUFZUUYCKWUFUUYAXWHIUVUEUUYCRUUXTWUEYOUUYAVXNPWUFOUUXTIWRU
      VUEKIOWWTWUAUUXTWUEWUBWAYNWHXVLUUYAWUCWJPYJWUD $.
    itg2addnc.f3 $e |- ( ph -> ( S.2 ` F ) e. RR ) $.
    itg2addnc.g2 $e |- ( ph -> G : RR --> ( 0 [,) +oo ) ) $.
    itg2addnc.g3 $e |- ( ph -> ( S.2 ` G ) e. RR ) $.
    $( Lemma incomprehensible in isolation split off to shorten proof of
       ~ itg2addnc .  (Contributed by Brendan Leahy, 11-Mar-2018.) $)
    itg2addnclem3 $p |- ( ph -> ( E. h e. dom S.1 ( E. y e. RR+
      ( z e. RR |-> if ( ( h ` z ) = 0 , 0 , ( ( h ` z ) + y ) ) ) oR <_
        ( F oF + G ) /\ s = ( S.1 ` h ) ) -> E. t E. u ( E. f e. dom S.1
      E. g e. dom S.1 ( ( E. c e. RR+ ( z e. RR |-> if ( ( f ` z ) = 0 , 0 ,
        ( ( f ` z ) + c ) ) ) oR <_ F /\ t = ( S.1 ` f ) ) /\ ( E. d e. RR+
      ( z e. RR |-> if ( ( g ` z ) = 0 , 0 , ( ( g ` z ) + d ) ) ) oR <_ G /\
        u = ( S.1 ` g ) ) ) /\ s = ( t + u ) ) ) ) $=
      ( cr co vx cv cfv cc0 wceq caddc cif cmpt cof cle wbr crp wrex citg1 wcel
      wa wex wi c3 cdiv cfl c1 cmin cmul wne adantrr syl2anc adantl wral oveq1d
      fveq2 fveq2d ovex fvex ifex eqeq1d ifbieq2d breq1 cpnf ad2antrr ffvelrnda
      anbi12d wf elrege0 sylib simprd adantr neeq1 oveq1 breq1d sseldi ad2antlr
      wn imbi12d rerpdivcld reflcl peano2rem 3syl remulcld syl 1re a1i lesub1dd
      lemul1d mpbid leadd1dd cc recnd ax-1cn sylancl rpcnd adddird oveq2d eqtrd
      mulid2d bitri readdcld ifbothda imp eqbrtrd reex c0ex eqidd feqmptd oveq2
      cvv ofrfval2 mpteq2dv wb oveq12d resubcld c2 eqtr3d offval2 eqeq2d anbi1d
      cneg 2exbidv rexcom4 rexbii cofr cdm itg2addnclem2 simplr i1fsub 3nn nnrp
      cn ax-mp rpdivcl mpan2 weq breq12d neeq1d ifbieq12d eqid fvmpt cico df-ne
      cxr wss 0re pnfxr icossre mp2an rpred flle subcl 3eqtr3rd rpne0d divcan1d
      npcan breqtrd a1d ianor anbi1i oranabs i1ff ad3antlr clt biimpar ltadd1dd
      ltnled ltletrd ltled sylan2b expr ralrimiva mpbird ifeq2d rspcev ad2antrl
      wo syl5bir wfn fnmpti inidm ofval id simpr necon2bi iffalse subidi syl6eq
      ffn 0cn con3i subsubd rpre readdcli resubcl peano2re fllep1 addcli negcli
      negsub df-2 negeqi oveq1i mulneg1 sylancr syl5eqr 3eqtr3d rpcn negsubdi2d
      2cn 3cn divcan2 mp3an23 3m1e2 subdir mp3an12 syl5reqr negeqd mulcl negcld
      3ne0 pncand peano2cn subsub4 3brtr3d addassd addcld addcomd breqtrrd letr
      pncan syl3anc mpan2d lesubaddd leadd1d bitrd eqbrtrrd sylbid an32s subidd
      ex sylan9eqr pm2.24d ralimdva 3imtr4d impr ifcl pncan3d mpteq2dva 3eqtr4d
      itg1add iba bi2anan9 bicomd oveq12 spc2ev syl21anc rexbidv anbi2d rspc2ev
      fveq1 eqeq1 2rexbidv syl5ibrcom rexlimdvaa imp3a rexlimdva r19.41v 2exbii
      exbii 3bitrri syl6ibr ) ACSCUBZHUBZUCZUDUEZUDVWKBUBZUFTZUGZUHZIJUFUIZTZUJ
      UUAZUKZBULUMZKUBZVWJUNUCZUEZUPZHUNUUBZUMCSVWIFUBZUCZUDUEZUDVXHLUBZUFTZUGZ
      UHZIVWSUKZLULUMZEUBZVXGUNUCZUEZUPZCSVWIGUBZUCZUDUEZUDVYAMUBZUFTZUGZUHZJVW
      SUKZMULUMZDUBZVXTUNUCZUEZUPZUPZVXBVXPVYIUFTZUEZUPZDUQZEUQZGVXFUMZFVXFUMZV
      YMGVXFUMZFVXFUMVYOUPZDUQEUQZAVXEVYTHVXFAVWJVXFUOZUPZVXAVXDVYTWUEVWTVXDVYT
      URBULWUEVWMULUOZVWTUPUPZVYTVXDVYMVXCVYNUEZUPZDUQEUQZGVXFUMFVXFUMZWUGUASUA
      UBZIUCZVWMUSUTTZUTTZVAUCZVBVCTZWUNVDTZWULVWJUCZUJUKZWUSUDVEZUPZWURWUSUGZU
      HZVXFUOZVWJWVDVCUITZVXFUOZCSVWIWVDUCZUDUEZUDWVHVXJUFTZUGZUHZIVWSUKZLULUMZ
      VXPWVDUNUCZUEZUPZCSVWIWVFUCZUDUEZUDWVRVYCUFTZUGZUHZJVWSUKZMULUMZVYIWVFUNU
      CZUEZUPZUPZWUHUPZDUQEUQZWUKWUEWUFWVEVWTAUABHINOUUCZVFWUEWUFWVGVWTWUEWUFUP
      ZWUDWVEWVGAWUDWUFUUDWWKVWJWVDUUEVGZVFWUGWVNWWDVXCWVOWWEUFTZUEZWWJWUEWUFWV
      NVWTWWLWUNULUOZCSWVIUDWVHWUNUFTZUGZUHZIVWSUKZWVNWUFWWPWUEWUFUSULUOZWWPUSU
      UHUOWXAUUFUSUUGUUIVWMUSUUJUUKZVHWWLWWTWWRVWIIUCZUJUKZCSVIWWLWXDCSWWLVWISU
      OZUPZWWRWXCWUNUTTZVAUCZVBVCTZWUNVDTZVWKUJUKZVWKUDVEZUPZWXJVWKUGZUDUEZUDWX
      NWUNUFTZUGZWXCUJWXEWWRWXQUEWWLWXEWVIWXOWWQWXPUDWXEWVHWXNUDUAVWIWVCWXNSWVD
      UACUULZWVBWXMWURWUSWXJVWKWXRWUTWXKWVAWXLWXRWURWXJWUSVWKUJWXRWUQWXIWUNVDWX
      RWUPWXHVBVCWXRWUOWXGVAWXRWUMWXCWUNUTWULVWIIVKVJVLVJVJZWULVWIVWJVKZUUMWXRW
      USVWKUDWXTUUNWBWXSWXTUUOWVDUUPZWXMWXJVWKWXIWUNVDVMVWIVWJVNVOUUQZVPWXEWVHW
      XNWUNUFWYBVJVQVHWXOUDWXCUJUKZWXPWXCUJUKZWXQWXCUJUKWXFUDWXPUDWXQWXCUJVRWXP
      WXQWXCUJVRWXFWYCWXOWXFWXCSUOZWYCWXFWXCUDVSUURTZUOWYEWYCUPWWLSWYFVWIIASWYF
      IWCWUDWUFOVTZWAZWXCWDWEWFWGWXFWXOWMZWYDWYIWXNUDVEZWXFWYDWXNUDUUSWXMWXJUDV
      EZWXJWUNUFTZWXCUJUKZURWXLVWKWUNUFTZWXCUJUKZURWYJWYDURWXFWXJVWKWXJWXNUEZWY
      KWYJWYMWYDWXJWXNUDWHWYPWYLWXPWXCUJWXJWXNWUNUFWIWJWNVWKWXNUEZWXLWYJWYOWYDV
      WKWXNUDWHWYQWYNWXPWXCUJVWKWXNWUNUFWIWJWNWXFWXMUPWYMWYKWXFWYMWXMWXFWYLWXGV
      BVCTZWUNVDTZWUNUFTZWXCUJWXFWXJWYSWUNWXFWXIWUNWXFWXGSUOZWXHSUOZWXISUOWXFWX
      CWUNWXFWYFSWXCUDSUOVSUUTUOWYFSUVAUVBUVCUDVSUVDUVEZWYHWKZWUFWWPWUEWXEWXBWL
      ZWOZWXGWPZWXHWQWRZWUFWUNSUOZWUEWXEWUFWUNWXBUVFZWLZWSZWXFWYRWUNWXFXUAWYRSU
      OXUFWXGWQWTZXUKWSXUKWXFWXIWYRUJUKWXJWYSUJUKWXFWXHWXGVBWXFXUAXUBXUFXUGWTZX
      UFVBSUOWXFXAXBWXFXUAWXHWXGUJUKXUFWXGUVGWTXCWXFWXIWYRWUNXUHXUMXUEXDXEXFWXF
      WYTWXGWUNVDTZWXCWXFWYRVBUFTZWUNVDTWYSVBWUNVDTZUFTXUOWYTWXFWYRVBWUNWXFWXGX
      GUOZVBXGUOZWYRXGUOWXFWXGXUFXHZXIWXGVBUVHXJXUSWXFXIXBWXFWUNXUEXKZXLWXFXUPW
      XGWUNVDWXFXURXUSXUPWXGUEXUTXIWXGVBUVLXJVJWXFXUQWUNWYSUFWXFWUNXVAXOXMUVIWX
      FWXCWUNWXFWXCXUDXHZXVAWXFWUNXUEUVJUVKZXNUVMZWGUVNWXFWXMWMZWXLWYOXVEWXLUPZ
      WXFWXKWMZWXLUPZWYOXVFXVGWXLWMUWMZWXLUPXVHXVEXVIWXLWXKWXLUVOUVPXVGWXLUVQXP
      WXFXVGWYOWXLWXFXVGUPZWYNWXCWXFWYNSUOXVGWXFVWKWUNWWLSSVWIVWJWUDSSVWJWCZAWU
      FVWJUVRZWLZWAZXUKXQWGZWXFWYEXVGXUDWGZXVJWYNWYLWXCXVOWXFWYLSUOXVGWXFWXJWUN
      XULXUKXQWGXVPXVJVWKWXJWUNWXFVWKSUOXVGXVNWGWXFWXJSUOXVGXULWGWUFXUIWUEWXEXV
      GXUJUVSWXFVWKWXJUVTUKXVGWXFVWKWXJXVNXULUWCUWAUWBWXFWYMXVGXVDWGUWDUWEVFUWF
      UWGXRUWNXSXRXTUWHWWLCSWWRWXCUJWWSIYFYFWYFSYFUOZWWLYAXBZWWRYFUOWXFWVIUDWWQ
      YBWVHWUNUFVMVOXBWYHWWLWWSYCAICSWXCUHUEWUDWUFACSWYFIOYDZVTYGUWIWVMWWTLWUNU
      LVXJWUNUEZWVLWWSIVWSXVTCSWVKWWRXVTWVIWVJWWQUDVXJWUNWVHUFYEUWJYHWJUWKVGVFW
      UGWWPCSWVSUDWVRWUNUFTZUGZUHZJVWSUKZWWDWUFWWPWUEVWTWXBUWLWUEWUFVWTXWDWWLVW
      OWXCVWIJUCZUFTZUJUKZCSVIZXWBXWEUJUKZCSVIZVWTXWDWWLXWGXWICSWXFXWGXWIWXFXWG
      UPZXWBVWKWXNVCTZUDUEZUDXWLWUNUFTZUGZXWEUJWXFXWBXWOUEXWGWXFWVSXWMXWAXWNUDW
      XFWVRXWLUDWWLSSVWKWXNVCSVWJWVDYFYFVWIWUDVWJSUWOZAWUFWUDXVKXWPXVLSSVWJUXEW
      TWLWVDSUWOWWLUASWVCWVDWVBWURWUSWUQWUNVDVMWULVWJVNVOWYAUWPXBXVRXVRSUWQWXFV
      WKYCWXEWVHWXNUEWWLWYBVHUWRZVPWXFWVRXWLWUNUFXWQVJVQWGXWMUDXWEUJUKZXWNXWEUJ
      UKZXWOXWEUJUKXWKUDXWNUDXWOXWEUJVRXWNXWOXWEUJVRWXFXWRXWGXWMWXFXWESUOZXWRWX
      FXWEWYFUOXWTXWRUPWWLSWYFVWIJASWYFJWCWUDWUFQVTWAZXWEWDWEWFVTWXMVWKWXJVCTZW
      UNUFTZXWEUJUKZVWKVWKVCTZWUNUFTZXWEUJUKZXWSXWKXWMWMZUPZWXJVWKWYPXXCXWNXWEU
      JWYPXXBXWLWUNUFWXJWXNVWKVCYEVJWJWYQXXFXWNXWEUJWYQXXEXWLWUNUFVWKWXNVWKVCYE
      VJWJXXIXXDWXMWXFXXHXWGXXDWXFXXHUPZXWGXXDXXJXWGVWNXWFUJUKZXXDXXHXWGXXKYIZW
      XFXXHVWLWMZXXLVWLXWMVWLXWLUDUDVCTUDVWLVWKUDWXNUDVCVWLUWSZVWLWXNVWKUDVWLXV
      EWXNVWKUEWXMVWKUDWXKWXLUWTUXAWXMWXJVWKUXBZWTXXNXNYJUDUXFUXCUXDUXGXXMVWOVW
      NXWFUJVWLUDVWNUXBWJWTVHWXFXXKXXDURXXHWXFXXKXXDWXFXXKUPZVWKWXJWUNVCTZVCTZX
      XCXWEUJWXFXXRXXCUEXXKWXFVWKWXJWUNWXFVWKXVNXHZWXFWXJXULXHZXVAUXHWGXXPXXRXW
      EUJUKZVWNXWEXXQUFTZVWMUFTZUJUKZWXFXXKXYDWXFXXKXWFXYCUJUKZXYDWXFXWFXXQVWMU
      FTZXWEUFTZXYCUJWXFWXCXYFXWEXUDWXFXXQVWMWXFWXJWUNXULXUKYKZWUFVWMSUOWUEWXEV
      WMUXIZWLZXQWXFWYFSXWEXUCXXAWKZWXFWXGVBVBUFTZVCTZWUNVDTZWUNVWMVCTZVCTZWXHV
      BUFTZXYLVCTZWUNVDTZXYOVCTZWXCXYFUJWXFXYNXYSXYOWXFXYMWUNWXFXUAXYLSUOZXYMSU
      OXUFVBVBXAXAUXJZWXGXYLUXKXJZXUKWSWXFXYRWUNWXFXYQSUOZYUAXYRSUOWXFXUBYUDXUN
      WXHUXLWTZYUBXYQXYLUXKXJZXUKWSWUFXYOSUOWUEWXEWUFWUNVWMXUJXYIYKWLWXFXYMXYRU
      JUKXYNXYSUJUKWXFWXGXYQXYLXUFYUEYUAWXFYUBXBWXFXUAWXGXYQUJUKXUFWXGUXMWTXCWX
      FXYMXYRWUNYUCYUFXUEXDXEXCWXFXYPWXCYLWUNVDTZYQZUFTZYUHVCTWXCWXFXYNYUIXYOYU
      HVCWXFWXGXYLYQZUFTZWUNVDTXUOYUJWUNVDTZUFTXYNYUIWXFWXGYUJWUNXUTYUJXGUOWXFX
      YLVBVBXIXIUXNZUXOXBXVAXLWXFYUKXYMWUNVDWXFXURXYLXGUOYUKXYMUEXUTYUMWXGXYLUX
      PXJVJWXFXUOWXCYULYUHUFXVCWUFYULYUHUEWUEWXEWUFYULYLYQZWUNVDTZYUHYUNYUJWUNV
      DYLXYLUXQUXRUXSWUFYLXGUOZWUNXGUOZYUOYUHUEUYFWUFWUNWXBXKZYLWUNUXTUYAUYBWLY
      JUYCWUFXYOYUHUEWUEWXEWUFVWMWUNVCTZYQXYOYUHWUFVWMWUNVWMUYDZYURUYEWUFYUSYUG
      WUFUSWUNVDTZXUQVCTZYUSYUGWUFYVAVWMXUQWUNVCWUFVWMXGUOZYVAVWMUEZYUTYVCUSXGU
      OZUSUDVEYVDUYGUYQVWMUSUYHUYIWTWUFWUNYURXOYJWUFYUGUSVBVCTZWUNVDTZYVBYVFYLW
      UNVDUYJUXSWUFYUQYVGYVBUEZYURYVEXUSYUQYVHUYGXIUSVBWUNUYKUYLWTUYMYMUYNYMWLY
      JWXFWXCYUHXVBWUFYUHXGUOWUEWXEWUFYUGWUFWWPYUGXGUOZWXBWWPYUPYUQYVIUYFWUNUYD
      YLWUNUYOUYAWTUYPWLUYRXNWXFXYTWXJXYOVCTXYFWXFXYSWXJXYOVCWXFXYRWXIWUNVDWXFX
      YQVBVCTZVBVCTZXYRWXIWXFWXHXGUOZXYQXGUOZYVKXYRUEZWXFWXHXUNXHZWXHUYSYVMXUSX
      USYVNXIXIXYQVBVBUYTUYIWRWXFYVJWXHVBVCWXFYVLXUSYVJWXHUEYVOXIWXHVBVUGXJVJYM
      VJVJWXFWXJWUNVWMXXTXVAWXFVWMXYJXHUXHXNVUAXFWXFXYCXWEXYFUFTXYGWXFXWEXXQVWM
      WXFXWEXYKXHZWXFXXQXYHXHZWUFYVCWUEWXEYUTWLZVUBWXFXWEXYFYVPWXFXXQVWMYVQYVRV
      UCVUDXNVUEWXFVWNSUOXWFSUOXYCSUOXXKXYEUPXYDURWXFVWKVWMXVNXYJXQWXFWXCXWEXUD
      XYKXQWXFXYBVWMWXFXWEXXQXYKXYHXQZXYJXQVWNXWFXYCVUFVUHVUIXSWXFXYAXYDYIXXKWX
      FXYAVWKXYBUJUKXYDWXFVWKXXQXWEXVNXYHXYKVUJWXFVWKXYBVWMXVNYVSXYJVUKVULWGUWI
      VUMVUQWGVUNXSVUOWGXWKXVEXXHXXGXWKXVEUPZXXHXXGYVTXWMXXGXVEXWKXWLXXEUDXVEWX
      NVWKVWKVCXXOXMWXFXXEUDUEXWGWXFVWKXXSVUPWGVURVUSXSVUOXRXRXTVUQVUTAVWTXWHYI
      WUDWUFACSVWOXWFUJVWPVWRYFYFSXVQAYAXBZVWOYFUOAWXEUPZVWLUDVWNYBVWKVWMUFVMVO
      XBYWBWXCXWEYWBWYFSWXCXUCASWYFVWIIOWAZWKYWBWYFSXWEXUCASWYFVWIJQWAZWKXQAVWP
      YCACSWXCXWEUFIJYFWYFWYFYWAYWCYWDXVSACSWYFJQYDZYNYGVTAXWDXWJYIWUDWUFACSXWB
      XWEUJXWCJYFYFWYFYWAXWBYFUOYWBWVSUDXWAYBWVRWUNUFVMVOXBYWDAXWCYCYWEYGVTVVAV
      VBWWCXWDMWUNULVYCWUNUEZWWBXWCJVWSYWFCSWWAXWBYWFWVSWVTXWAUDVYCWUNWVRUFYEUW
      JYHWJUWKVGWUEWUFWWOVWTWWLWVDWVFVWQTZUNUCVXCWWNWWLYWGVWJUNWWLUASWVCWUSWVCV
      CTZUFTZUHUASWUSUHZYWGVWJWWLUASYWIWUSWWLWULSUOZUPZWVCWUSYWLWVCYWLWURSUOWUS
      SUOWVCSUOYWLWUQWUNYWLWUOSUOWUPSUOWUQSUOYWLWUMWUNYWLWYFSWUMXUCWWLSWYFWULIW
      YGWAWKWUFWWPWUEYWKWXBWLWOWUOWPWUPWQWRWUFXUIWUEYWKXUJWLWSWWLSSWULVWJXVMWAZ
      WVBWURWUSSVVCVGZXHYWLWUSYWMXHVVDVVEWWLUASWVCYWHUFWVDWVFYFSSXVRYWNYWLWUSWV
      CYWMYWNYKWWLWVDYCZWWLUASWUSWVCVCVWJWVDYFSSXVRYWMYWNWUDVWJYWJUEAWUFWUDUASS
      VWJXVLYDWLZYWOYNYNYWPVVFVLWWLWVDWVFWWKWWMVVGYMVFWWIWVNWWDUPZWWOUPEDWVOWWE
      WVDUNVNWVFUNVNWVPWWFUPZWWHYWQWUHWWOYWRYWQWWHWVPWVNWVQWWFWWDWWGWVPWVNVVHWW
      FWWDVVHVVIVVJYWRVYNWWNVXCVXPWVOVYIWWEUFVVKYOWBVVLVVMWUJWWJWVQVYLUPZWUHUPZ
      DUQEUQFGWVDWVFVXFVXFVXGWVDUEZWUIYWTEDYXAVYMYWSWUHYXAVXSWVQVYLYXAVXOWVNVXR
      WVPYXAVXNWVMLULYXAVXMWVLIVWSYXACSVXLWVKYXAVXIWVIVXKWVJUDYXAVXHWVHUDVWIVXG
      WVDVVQZVPYXAVXHWVHVXJUFYXBVJVQYHWJVVNYXAVXQWVOVXPVXGWVDUNVKYOWBYPYPYRVXTW
      VFUEZYWTWWIEDYXCYWSWWHWUHYXCVYLWWGWVQYXCVYHWWDVYKWWFYXCVYGWWCMULYXCVYFWWB
      JVWSYXCCSVYEWWAYXCVYBWVSVYDWVTUDYXCVYAWVRUDVWIVXTWVFVVQZVPYXCVYAWVRVYCUFY
      XDVJVQYHWJVVNYXCVYJWWEVYIVXTWVFUNVKYOWBVVOYPYRVVPVUHVXDVYRWUJFGVXFVXFVXDV
      YPWUIEDVXDVYOWUHVYMVXBVXCVYNVVRVVOYRVVSVVTVWAVWBVWCVYTVYQGVXFUMZFVXFUMZEU
      QZVYPGVXFUMZFVXFUMZDUQZEUQWUCVYTYXEEUQZFVXFUMYXGVYSYXKFVXFVYQGEVXFYSYTYXE
      FEVXFYSXPYXFYXJEYXFYXHDUQZFVXFUMYXJYXEYXLFVXFVYPGDVXFYSYTYXHFDVXFYSXPVWFY
      XIWUBEDYXIWUAVYOUPZFVXFUMWUBYXHYXMFVXFVYMVYOGVXFVWDYTWUAVYOFVXFVWDXPVWEVW
      GVWH $.
    $( Alternate proof of ~ itg2add using the "buffer zone" definition from the
       first lemma, in which every simple function in the set is divided into
       to by dividing its buffer by a third and finding the largest allowable
       function locked to a grid laid out in increments of the new, smaller
       buffer up to the original simple function.  The measurability of this
       function follows from that of the augend, and subtracting it from the
       original simple function yields another simple function by ~ i1fsub ,
       which is allowable by the fact that the grid must have a mark between
       one third and two thirds the original buffer.  This has two advantages
       over the current approach: first, eliminating ~ ax-cc , and second,
       weakening the measurability hypothesis to only the augend.  (Contributed
       by Brendan Leahy, 31-Oct-2017.)  (Revised by Brendan Leahy,
       13-Mar-2018.) $)
    itg2addnc $p |- ( ph ->
        ( S.2 ` ( F oF + G ) ) = ( ( S.2 ` F ) + ( S.2 ` G ) ) ) $=
      ( vz cr cc0 wceq caddc co cle wbr crp wrex wa wcel vf vc vx vg vd cfv cif
      vs vt vu va vb vh vy cv cmpt citg1 cab clt citg2 wss simprr itg1cl adantr
      csup eqeltrd rexlimiva abssi a1i c0 i1f0 wral ne0i cpnf ffvelrnda elrege0
      wne c3 sylib simprd ralrimiva cvv reex c0ex eqidd feqmptd ofrfval2 mpbird
      ralrimivw r19.2z sylancr fveq2 iftrue syl mpteq2dva breq1d rexbidv rspcev
      fveq1 eqeq1 anbi2d sylibr wf eqid itg2addnclem supxrub mpan breq2 ralbidv
      cxr supxrre syl3anc adantl wex simpr ad2antlr breq1 imbi1d sylan ad2antrr
      wi eqbrtrd recnd sylan9eqr oveq1d rpred readdcld letr imp adantlr syl2anc
      mpand ex ifbothda ovex ifex wfn ffn rexlimdvva weq cdm cof csn cxp cn 3nn
      cofr nnrp mp2b cico itg10 biantrud fvconst2 sylan9eq bitr3d elab icossicc
      syl6req cicc mpan2 3syl eqeltrrd ressxr sstri rgen sylancl supadd oveq12d
      fss eqtrd rexr anim1i elxrge0 3imtr4i ssriv ge0addcl sseldi itg2addnclem3
      inidm off i1fadd ad3antlr reeanv biimpri ad2ant2r ifcl anbi1d oveq12 00id
      simpl syl6eq adantll simpll simplbi addge0d wn oveq1 simplrr i1ff addid2d
      a1d rpre min2 syl2an leadd2dd addge02d mpbid letrd ifboth adantld simplrl
      oveq2 addid1d min1 addge01d adantrd addassd ltaddrpd ltled le2add syl2and
      syl22anc ralimdva wb anbi12d r19.26 syl6bbr ofval eqeq1d ifbieq2d 3imtr4d
      offval ifeq2d mpteq2dv syl5 a1dd imp31 ad2ant2l eqcomd eqtr ancoms eqeq2d
      syl12anc exp31 imp3a impbid rexab anbi2i 19.42v anbi1i anass bitr2i exbii
      itg1add exlimdvv 3bitr2i bitri abbidv supeq1d sseli eqcomi rspceov mp3an3
      rexlimivv 2rexbidv spcev abn0 wal ad2antrl ad2antll le2addd alrimiv ralab
      syl6bb 3eqtrd 3eqtr4rd ) AIJIUOZUAUOZUFZKLZKVVSUBUOZMNZUGZUPZBOUUGZPZUBQR
      ZUCUOZVVRUQUFZLZSZUAUQUUAZRZUCURZJUSVEZIJVVQUDUOZUFZKLZKVWQUEUOZMNZUGZUPZ
      CVWEPZUEQRZVWHVWPUQUFZLZSZUDVWLRZUCURZJUSVEZMNUHUOZUIUOZUJUOZMNZLZUJVXIRZ
      UIVWNRZUHURZJUSVEZBUTUFZCUTUFZMNBCMUUBZNZUTUFZAUKULUHUIVWNVXIVXRUJVWNJVAZ
      AVWMUCJVWKVWHJTZUAVWLVVRVWLTZVWKSVWHVWIJVYGVWGVWJVBVYGVWIJTVWKVVRVCVDVFVG
      VHZVIZAKVWNTZVWNVJVQZAVWGKVWILZSZUAVWLRZVYJAJKUUCUUDZVWLTZIJKUPZBVWEPZUBQ
      RZVYNVKAQVJVQZVYRUBQVLVYSVRUUETVRQTVYTUUFVRUUHQVRVMUUIZAVYRUBQAVYRKVVQBUF
      ZOPZIJVLAWUCIJAVVQJTZSZWUBJTZWUCWUEWUBKVNUUJNZTZWUFWUCSAJWUGVVQBEVOZWUBVP
      ZVSVTZWAAIJKWUBOVYQBWBWBWUGJWBTZAWCVIZKWBTWUEWDVIZWUIAVYQWEZAIJWUGBEWFZWG
      WHWIVYRUBQWJWKVYMVYSUAVYOVWLVVRVYOLZVWGVYMVYSWUQVYLVWGWUQVWIVYOUQUFZKVVRV
      YOUQWLUUKUURUULWUQVWFVYRUBQWUQVWDVYQBVWEWUQIJVWCKWUQWUDSVVTVWCKLWUQWUDVVS
      VVQVYOUFZKVVQVVRVYOWSJKVVQWDUUMZUUNVVTKVWBWMWNWOWPWQUUOWRWKVWMVYNUCKWDVWH
      KLZVWKVYMUAVWLWVAVWJVYLVWGVWHKVWIWTXAWQUUPXBZVWNKVMWNZAVWNXJUSVEZJTZULUOZ
      WVDOPZULVWNVLZWVFUKUOZOPZULVWNVLZUKJRZAVXTWVDJAJWUGBXCZJKVNUUSNZBXCZVXTWV
      DLEWVMWUGWVNVAZWVOKVNUUQZJWUGWVNBUVIUUTUCUBIUABVWNVWNXDXEUVAZFUVBZWVGULVW
      NVWNXJVAZWVFVWNTWVGVWNJXJVYHUVCUVDZVWNWVFXFXGUVEWVKWVHUKWVDJWVIWVDLWVJWVG
      ULVWNWVIWVDWVFOXHXIWRUVFZVXIJVAZAVXHUCJVXGVYFUDVWLVWPVWLTZVXGSVWHVXEJWWDV
      XDVXFVBWWDVXEJTVXGVWPVCVDVFVGVHZVIZAKVXITZVXIVJVQZAVXDKVXELZSZUDVWLRZWWGA
      VYPVYQCVWEPZUEQRZWWKVKAVYTWWLUEQVLWWMWUAAWWLUEQAWWLKVVQCUFZOPZIJVLAWWOIJW
      UEWWNJTZWWOWUEWWNWUGTZWWPWWOSAJWUGVVQCGVOZWWNVPZVSVTZWAAIJKWWNOVYQCWBWBWU
      GWUMWUNWWRWUOAIJWUGCGWFZWGWHWIWWLUEQWJWKWWJWWMUDVYOVWLVWPVYOLZVXDWWJWWMWX
      BWWIVXDWXBVXEWURKVWPVYOUQWLUUKUURUULWXBVXCWWLUEQWXBVXBVYQCVWEWXBIJVXAKWXB
      WUDSVWRVXAKLWXBWUDVWQWUSKVVQVWPVYOWSWUTUUNVWRKVWTWMWNWOWPWQUUOWRWKVXHWWKU
      CKWDWVAVXGWWJUDVWLWVAVXFWWIVXDVWHKVXEWTXAWQUUPXBZVXIKVMWNZAVXIXJUSVEZJTZW
      VFWXEOPZULVXIVLZWVJULVXIVLZUKJRZAVYAWXEJAJWUGCXCZJWVNCXCZVYAWXELGWXKWVPWX
      LWVQJWUGWVNCUVIUUTUCUEIUDCVXIVXIXDXEUVAZHUVBZWXGULVXIVXIXJVAZWVFVXITWXGVX
      IJXJWWEUVCUVDZVXIWVFXFXGUVEWXIWXHUKWXEJWVIWXELWVJWXGULVXIWVIWXEWVFOXHXIWR
      UVFZVXRXDUVGAVXTVWOVYAVXJMAVXTWVDVWOWVRAVYEVYKWVLWVDVWOLVYIWVCWWBUKULVWNX
      KXLUVJAVYAWXEVXJWXMAWWCWWHWXJWXEVXJLWWFWXDWXQUKULVXIXKXLUVJUVHAVYDIJVVQUM
      UOZUFZKLZKWXSUNUOZMNZUGZUPZVYCVWEPZUNQRZVXKWXRUQUFZLZSZUMVWLRZUHURZXJUSVE
      ZVXRXJUSVEZVXSAJWVNVYCXCVYDWYLLAUCUNJJJMWUGWUGWVNBCWBWBVWHWUGTZWYAWUGTSZV
      WHWYAMNZWVNTAWYOWUGWVNWYPUCWUGWVNVYFKVWHOPZSVWHXJTZWYQSWYNVWHWVNTVYFWYRWY
      QVWHUVKUVLVWHVPVWHUVMUVNUVOVWHWYAUVPUVQXMEGWUMWUMJUVSZUVTUHUNIUMVYCWYKWYK
      XDXEWNAXJWYKVXRUSAWYJVXQUHAWYJVWGVXLVWILZSZVXDVXMVXELZSZSZUDVWLRUAVWLRZVX
      OSZUJXNZUIXNZVXQAWYJXUHAUNIUJUIUAUDUMBCUHUBUEDEFGHUVRAXUFWYJUIUJAXUEVXOWY
      JAXUDVXOWYJYAUAUDVWLVWLAVYGWWDSZSZXUDVXOWYJXUJXUDSZVXOSVVRVWPVYBNZVWLTZIJ
      VVQXULUFZKLZKXUNWYAMNZUGZUPZVYCVWEPZUNQRZVXKXULUQUFZLZWYJXUIXUMAXUDVXOXUI
      VVRVWPVYGWWDUWJZVYGWWDXOZUWAUWBXUJXUDVXOXUTXUJXUDXUTVXOXUDVWFVXCSZUEQRUBQ
      RZXUJXUTVWGVXDXVFWYTXUBXVFVWGVXDSVWFVXCUBUEQQUWCUWDUWEXUJXVEXUTUBUEQQXUJV
      WAQTZVWSQTZSZSZXVEXUTXVJXVESVWAVWSOPZVWAVWSUGZQTZIJXUOKXUNXVLMNZUGZUPZVYC
      VWEPZXUTXVIXVMXUJXVEXVKVWAVWSQUWFZXPXVJXVEXVQXVJVWCWUBOPZVXAWWNOPZSZIJVLZ
      VVSVWQMNZKLZKXWCXVLMNZUGZWUBWWNMNZOPZIJVLXVEXVQXVJXWAXWHIJVVTWUCXVTSZXWHY
      AZVWBWUBOPZXVTSZXWHYAZXWAXWHYAXVJWUDSZKVWBKVWCLZXWIXWAXWHXWOWUCXVSXVTKVWC
      WUBOXQUWGXRVWBVWCLZXWLXWAXWHXWPXWKXVSXVTVWBVWCWUBOXQUWGXRVWRWUCWWOSZXWHYA
      WUCVWTWWNOPZSZXWHYAZXWJXWNVVTSZKVWTKVXALZXWQXWIXWHXXBWWOXVTWUCKVXAWWNOXQZ
      XAXRVWTVXALZXWSXWIXWHXXDXWRXVTWUCVWTVXAWWNOXQZXAXRXXAVWRSZXWHXWQXXFXWFKXW
      GOVVTVWRXWFKLZXWNVVTVWRSZXWDXXGXXHXWCKKMNZKVVSKVWQKMUWHUWIUWKXWDKXWEWMWNU
      WLXWNKXWGOPZVVTVWRXVJAWUDXXJAXUIXVIUWMZWUEWUBWWNWUEWUHWUFWUIWUHWUFWUCWUJU
      WNWNZWUEWWQWWPWWRWWQWWPWWOWWSUWNWNZWUKWWTUWOXSZXTYBUXAXXAXWTVWRUWPZXXAXWR
      XWHWUCXXAXWRXWHXXAXWRSZXXJXWEXWGOPZXWHXWNXXJVVTXWRXXNXTXXPXWEVWQXVLMNZXWG
      OXXAXWEXXRLXWRXXAXWCVWQXVLMVVTXWNXWCKVWQMNVWQVVSKVWQMUWQXWNVWQXWNVWQXVJWW
      DWUDVWQJTAVYGWWDXVIUWRWWDJJVVQVWPVWPUWSZVOXSZYCZUWTYDYEVDXWNXWRXXRXWGOPVV
      TXWNXWRSXXRWWNXWGXWNXXRJTZXWRXWNVWQXVLXXTXVIXVLJTXUJWUDXVIXVLXVRYFXPZYGZV
      DXWNWWPXWRXVJAWUDWWPXXKXXMXSZVDXWNXWGJTZXWRXWNWUBWWNXVJAWUDWUFXXKXXLXSZXY
      EYGZVDXWNXWRXXRWWNOPZXWNXXRVWTOPZXWRXYIXWNXVLVWSVWQXYCXWNVWSXUJXVGXVHWUDU
      WRYFZXXTXVIXVLVWSOPZXUJWUDXVGVWAJTZVWSJTZXYLXVHVWAUXBZVWSUXBZVWAVWSUXCUXD
      XPUXEXWNXYBVWTJTWWPXYJXWRSXYIYAXYDXWNVWQVWSXXTXYKYGXYEXXRVWTWWNYHXLYLZYIX
      WNWWNXWGOPZXWRXVJAWUDXYRXXKWUEWUCXYRWUKWUEWWNWUBXXMXXLUXFUXGXSVDUXHYJYBXW
      DXXJXXQXWHKXWEKXWFXWGOXQXWEXWFXWGOXQUXIZYKYMUXJVDYNVWRXWKWWOSZXWHYAXWKXWR
      SZXWHYAZXWMXWNVVTUWPZSZKVWTXXBXYTXWLXWHXXBWWOXVTXWKXXCXAXRXXDYUAXWLXWHXXD
      XWRXVTXWKXXEXAXRYUDVWRSXWKXWHWWOXWNVWRXWKXWHYAYUCXWNVWRSZXWKXWHYUEXWKSZXX
      JXXQXWHXWNXXJVWRXWKXXNXTYUFXWEVVSXVLMNZXWGOYUEXWEYUGLXWKYUEXWCVVSXVLMVWRX
      WNXWCVVSKMNVVSVWQKVVSMUXLXWNVVSXWNVVSXVJVYGWUDVVSJTZAVYGWWDXVIUXKVYGJJVVQ
      VVRVVRUWSZVOXSZYCZUXMYDYEVDXWNXWKYUGXWGOPVWRXWNXWKSYUGWUBXWGXWNYUGJTZXWKX
      WNVVSXVLYUJXYCYGZVDXWNWUFXWKXYGVDXWNXYFXWKXYHVDXWNXWKYUGWUBOPZXWNYUGVWBOP
      ZXWKYUNXWNXVLVWAVVSXYCXWNVWAXUJXVGXVHWUDUXKZYFZYUJXVIXVLVWAOPZXUJWUDXVGXY
      MXYNYURXVHXYOXYPVWAVWSUXNUXDXPUXEXWNYULVWBJTZWUFYUOXWKSYUNYAYUMXWNVVSVWAY
      UJYUQYGZXYGYUGVWBWUBYHXLYLYIXWNWUBXWGOPZXWKXVJAWUDYVAXXKWUEWWOYVAWWTWUEWU
      BWWNXXLXXMUXOUXGXSVDUXHYJYBXYSYKYMYJUXPXWNYUBYUCXXOXWNYUAXWHXWNYUASZXXJXX
      QXWHXWNXXJYUAXXNVDYVBXWEVVSXXRMNZXWGOXWNXWEYVCLYUAXWNVVSVWQXVLYUKXYAXWNXV
      LXYCYCUXQVDXWNYUAYVCXWGOPZXWNXWKVVSWUBOPZXWRXYIYVDXWNVVSVWBOPZXWKYVEXWNVV
      SVWBYUJYUTXWNVVSVWAYUJYUPUXRUXSXWNYUHYUSWUFYVFXWKSYVEYAYUJYUTXYGVVSVWBWUB
      YHXLYLXYQXWNYUHXYBWUFWWPYVEXYISYVDYAYUJXYDXYGXYEVVSXXRWUBWWNUXTUYBUYAYIYB
      XYSYKYMXTYNYNUYCAXVEXWBUYDXUIXVIAXVEXVSIJVLZXVTIJVLZSXWBAVWFYVGVXCYVHAIJV
      WCWUBOVWDBWBWBWUGWUMVWCWBTWUEVVTKVWBWDVVSVWAMYOYPVIWUIAVWDWEWUPWGAIJVXAWW
      NOVXBCWBWBWUGWUMVXAWBTWUEVWRKVWTWDVWQVWSMYOYPVIWWRAVXBWEWXAWGUYEXVSXVTIJU
      YFUYGXTXVJIJXWFXWGOXVPVYCWBWBWBWULXVJWCVIZXWFWBTXWNXWDKXWEWDXWCXVLMYOYPVI
      XWGWBTXWNWUBWWNMYOVIXVJIJXVOXWFXWNXUOXWDXVNXWEKXWNXUNXWCKXVJJJVVSVWQMJVVR
      VWPWBWBVVQXUIVVRJYQZAXVIVYGYVJWWDVYGJJVVRXCYVJYUIJJVVRYRWNVDXPXUIVWPJYQZA
      XVIWWDYVKVYGWWDJJVWPXCYVKXXSJJVWPYRWNXMXPYVIYVIWYSXWNVVSWEXWNVWQWEUYHZUYI
      XWNXUNXWCXVLMYVLYEUYJWOAVYCIJXWGUPLXUIXVIAIJJWUBWWNMJBCWBWBAWVMBJYQEJWUGB
      YRWNAWXKCJYQGJWUGCYRWNWUMWUMWYSWUEWUBWEWUEWWNWEUYLXTWGUYKYIXUSXVQUNXVLQWY
      AXVLLZXURXVPVYCVWEYVMIJXUQXVOYVMXUOXUPXVNKWYAXVLXUNMUXLUYMUYNWPWRYKYMYSUY
      OUYPUYQXUKVXNXVALZVXOXVBXUDXUJVXNVWIVXEMNZXVAWYTXUBVXNYVOLVWGVXDVXLVWIVXM
      VXEMUWHUYRXUIYVOXVALAXUIXVAYVOXUIVVRVWPXVCXVDVUNUYSXMYDVXOYVNXVBVXKVXNXVA
      UYTVUAXSWYIXUTXVBSUMXULVWLWXRXULLZWYFXUTWYHXVBYVPWYEXUSUNQYVPWYDXURVYCVWE
      YVPIJWYCXUQYVPWXTXUOWYBXUPKYVPWXSXUNKVVQWXRXULWSZUYIYVPWXSXUNWYAMYVQYEUYJ
      UYNWPWQYVPWYGXVAVXKWXRXULUQWLVUBUYEWRVUCVUDYSVUEVUOVUFVXQXUAUAVWLRZVXPSZU
      IXNXUHVWMYVRVXPUIUCUCUIYTZVWKXUAUAVWLYVTVWJWYTVWGVWHVXLVWIWTXAWQVUGYVSXUG
      UIYVSYVRXUCUDVWLRZVXOSZUJXNZSYVRYWBSZUJXNXUGVXPYWCYVRVXHYWAVXOUJUCUCUJYTZ
      VXGXUCUDVWLYWEVXFXUBVXDVWHVXMVXEWTXAWQVUGVUHYVRYWBUJVUIYWDXUFUJXUFYVRYWAS
      ZVXOSYWDXUEYWFVXOXUAXUCUAUDVWLVWLUWCVUJYVRYWAVXOVUKVULVUMVUPVUMVUQUYGVURV
      USAVXRJVAZVXRVJVQZWVJULVXRVLZUKJRZWYMVXSLYWGAVXQUHJVXOVXKJTZUIUJVWNVXIVXL
      VWNTZVXMVXITZSZVXOYWKYWNVXOSZVXKVXNJYWNVXOXOYWOVXLVXMYWLVXLJTZYWMVXOVWNJV
      XLVYHVUTZXTYWMVXMJTZYWLVXOVXIJVXMWWEVUTZXPYGVFYMVVDVHVIAVXQUHXNZYWHAKVXNL
      ZUJVXIRUIVWNRZYWTAVYJWWGYXBWVBWXCVYJWWGKXXILYXBXXIKUWIVVAUIUJVWNVXIKKKMVV
      BVVCYKVXQYXBUHKWDVXKKLVXOYXAUIUJVWNVXIVXKKVXNWTVVEVVFWNVXQUHVVGXBAWVDWXEM
      NZJTWVFVXNLZUJVXIRUIVWNRZWVFYXCOPZYAZULVVHZYWJAWVDWXEWVSWXNYGAYXGULAYXDYX
      FUIUJVWNVXIAYWNSZYXDYXFYXIYXDSWVFVXNYXCOYXIYXDXOYXIVXNYXCOPYXDYXIVXLVXMWV
      DWXEYWLYWPAYWMYWQVVIYWMYWRAYWLYWSVVJAWVEYWNWVSVDAWXFYWNWXNVDYWLVXLWVDOPZA
      YWMWVTYWLYXJWWAVWNVXLXFXGVVIYWMVXMWXEOPZAYWLWXOYWMYXKWXPVXIVXMXFXGVVJVVKV
      DYBYMYSVVLYWIYXHUKYXCJWVIYXCLZYWIYXFULVXRVLYXHYXLWVJYXFULVXRWVIYXCWVFOXHX
      IVXQYXEYXFULUHUHULYTVXOYXDUIUJVWNVXIVXKWVFVXNWTVVEVVMVVNWRYKUKULVXRXKXLVV
      OVVP $.
  $}

  ${
    $d x y z w u v X $.  $d x y z w u v Y $.  $d x y z w u v F $.
    $d x y z w u v ph $.
    itg2gt0cn.2 $e |- ( ph -> X < Y ) $.
    itg2gt0cn.3 $e |- ( ph -> F : RR --> ( 0 [,) +oo ) ) $.
    itg2gt0cn.5 $e |- ( ( ph /\ x e. ( X (,) Y ) ) -> 0 < ( F ` x ) ) $.
    itg2gt0cn.cn $e |- ( ph ->
      ( F |` ( X (,) Y ) ) e. ( ( X (,) Y ) -cn-> CC ) ) $.
    $( ~ itg2gt0 holds on functions continuous on an open interval in the
       absence of ~ ax-cc .  The fourth hypothesis is made unnecessary by the
       continuity hypothesis.  (Contributed by Brendan Leahy, 16-Nov-2017.) $)
    itg2gt0cn $p |- ( ph -> 0 < ( S.2 ` F ) ) $=
      ( vw cc0 clt wbr co cxr wa cfv wcel cr cle vy vv vz vu cv cioo wrex citg2
      cq 0xr a1i wss cpnf wf syl wral wb sylib mpbird ralrimiva syl2anc sylancl
      supxrlub breq2 rexima bitrd syl3anc cmpt adantr simpr elrpd anim1i simplr
      cif crp cmin cabs wi ad3antrrr mpan2 elrege0 ssriv fss ffvelrnda ad2antlr
      cc rpre resubcld posdifd biimpa ex fvres breq2d adantl wceq fveq2d oveq1d
      caddc 0le0 elxrge0 ifcl eqid fmptd itg2cl ad5antlr cvol ad4antlr ad3antlr
      imp ax-mp wn rexrd simpld ad5antr simprd ad4antr ifclda readdcld syl22anc
      rpgt0 mpbid xrlttrd ifboth breq1 ltled breqtrrd weq breq1d fveq2 ad6antlr
      cmnf cneg absltd recnd sylan2 iftrue cvv eqidd rexlimdva ad2antrr imassrn
      cima csup crn cico frn icossxr syl6ss syl5ss supxrcl c0 wne ltrelxr ssbri
      cxp brxp ioon0 r19.2z wfn ffn ioossre qbtwnxr crab qre anasss rpxr syl2an
      cres ccncf fssres simplbi oveq12d breq12d imbi2d ralbidva rexbidv 3imtr3d
      3syl cncfi cin cicc ioorp ioossicc eqsstr3i sseli mpbir2an cmul covol cdm
      ioombl mblvol elioore xrltnle biimpar xrre2 syl32anc mnfxr xrlelttrd xrre
      mnfle ltsubposd eliooord ltaddpos2d ovolioo syl5eq eqeltrd mulgt0d eleq2d
      lttrd iooin ifbid mpteq2dv rpge0 sylanbrc itg2const eqtrd imbi12d rspccva
      cofr oveq1 w3a elioo2 3anass syl6bb renegcld ltaddsub2d negsubd ltsubaddd
      leidd bitr3d anbi12d pm5.32da bitr4d pm3.35 ancoms sseldi rpcn negsubdi2d
      anbi1d simprbda ltsub1d an4s syldan ifbothda anassrs 3brtr4d iffalse elin
      pm2.61d1 ifbi ifan eqtri 3brtr4g ralrimivw reex ofrfval2 itg2le xrltletrd
      elrab mpd sylbid rexr 3imtr4i simprbi fvex feqmptd expl reximdv2 xrltletr
      jca32 syl5 syld ) AKUAUEZLMZVVMCDEUFNZUUBZOLUUCZLMZPZUAUIUGZKCUHQZLMZAKOR
      ZVVQORZKVVQLMZVVTVWCAUJUKAVVPOULZVWDAVVPCUUDZOCVVOUUAAVWGKUMUUENZOASVWHCU
      NZVWGVWHULGSVWHCUUFUOKUMUUGUUHUUIZVVPUUJUOAVWEKBUEZCQZLMZBVVOUGZAVVOUUKUU
      LZVWMBVVOUPVWNAVWODELMZFADORZEORZPZVWOVWPUQADEOOUUOZMZVWSAVWPVXAFLVWTDEUU
      MUUNUODEOOUUPURZDEUUQUOUSAVWMBVVOHUTVWMBVVOUURVAAVWEVVNUAVVPUGZVWNAVWFVWC
      VWEVXCUQVWJUJUAVVPKVCVBACSUUSZVVOSULZVXCVWNUQAVWIVXDGSVWHCUUTUOZDEUVAZVVN
      VWMUABSVVOCVVMVWLKLVDVEVBVFUSUAKVVQUVBVGAVVTKJSJUEZVVMUBUEZCQZTMZUBVVOUVC
      RZVVMKVNZVHZUHQZLMZVXOVWATMZPZUAVOUGVWBAVVSVXRUAUIVOVVMUIRZVVSPVVMVORZVVR
      PZAVXTVXRPZVXSVVNVVRVYAVXSVVNPZVXTVVRVYCVVMVXSVVMSRZVVNVVMUVDVIVXSVVNVJVK
      VLUVEAVXTVVRVYBAVXTPZVVRPZVXTVXPVXQAVXTVVRVMVYEVVRVXPVYEVVRVVMVWLLMZBVVOU
      GZVXPVYEVVRVVMUCUEZLMZUCVVPUGZVYHAVWFVVMORVVRVYKUQVXTVWJVVMUVFUCVVPVVMVCU
      VGAVYKVYHUQZVXTAVXDVXEVYLVXFVXGVYJVYGUCBSVVOCVYIVWLVVMLVDVEVBVIVFVYEVYGVX
      PBVVOVYEVWKVVORZPZVYGVXPVYNVYGPZUDUEZVWKVPNZVQQZVYILMZVYPCQZVWLVPNZVQQZVW
      LVVMVPNZLMZVRZUDVVOUPZUCVOUGZVXPVYNVYGWUGVYNVVMVWKCVVOUVHZQZLMZVYSVYPWUHQ
      ZWUIVPNZVQQZWUIVVMVPNZLMZVRZUDVVOUPZUCVOUGZVYGWUGVYNWUJWURVYNWUJPZWUHVVOW
      FUVINRZVYMWUNVORWURAWUTVXTVYMWUJIVSVYEVYMWUJVMWUSWUNVYNWUNSRWUJVYNWUIVVMV
      YEVVOSVWKWUHAVVOSWUHUNZVXTAVWIVVOVWHWUHUNZWVAGVWIVXEWVBVXGSVWHVVOCUVJVTWV
      BVWHSULWVABVWHSVWKVWHRZVWKSRZKVWKTMZVWKWAZUVKWBZVVOVWHSWUHWCVTUVRVIWDZVXT
      VYDAVYMVVMWGZWEZWHVIVYNWUJKWUNLMVYNVVMWUIWVJWVHWIWJVKUCUDVVOWFVWKWUNWUHUV
      SVGWKVYMWUJVYGUQVYEVYMWUIVWLVVMLVWKVVOCWLZWMWNVYNWUQWUFUCVOVYNWUPWUEUDVVO
      VYNVYPVVORZPZWUOWUDVYSWVMWUMWUBWUNWUCLWVMWULWUAVQWVMWUKVYTWUIVWLVPWVLWUKV
      YTWOVYNVYPVVOCWLWNVYMWUIVWLWOVYEWVLWVKWEUVLWPVYMWUNWUCWOVYEWVLVYMWUIVWLVV
      MVPWVKWQWEUVMUVNUVOUVPUVQXIVYOWUFVXPUCVOVYOVYIVORZPZWUFVXPWVOWUFPZKJSVXHV
      VOVWKVYIVPNZVYIVWKWRNZUFNZUVTZRZVVMKVNZVHZUHQZVXOVWCWVPUJUKVXTWWDORZAVYMV
      YGWVNWUFVXTSKUMUWANZWWCUNZWWEVXTJSWWBWWFWWCVXTWWBWWFRZVXHSRZVXTVVMWWFRZKW
      WFRZWWHVOWWFVVMVOKUMUFNWWFUWBKUMUWCUWDUWEZWWKVWCKKTMZUJWSKWTUWFZWWAVVMKWW
      FXAVBZVIWWCXBXCZWWCXDUOXEVXTVXOORZAVYMVYGWVNWUFVXTSWWFVXNUNZWWQVXTJSVXMWW
      FVXNVXTVXMWWFRZWWIVXTWWJWWKWWSWWLWWNVXLVVMKWWFXAVBZVIVXNXBXCZVXNXDUOZXEWV
      OKWWDLMWUFWVOKVVMDWVQTMZWVQDVNZEWVRTMZEWVRVNZUFNZXFQZUWGNZWWDLWVOVVMWXHVX
      TVYDAVYMVYGWVNWVIXGWVOWXHWXFWXDVPNZSWVOWXHWXGUWHQZWXJWXGXFUWIRZWXHWXKWOWX
      DWXFUWJZWXGUWKXJWVOWXDSRWXFSRWXDWXFTMWXKWXJWOWVOWXCWVQDSWVOWVQSRWXCWVOVWK
      VYIVYMWVDVYEVYGWVNVWKDEUWLZXHZWVNVYISRZVYOVYIWGZWNZWHZVIWVOWXCXKZPWVQORZV
      WQVWRWVQDLMZVWPDSRWVOWYAWXTWVOWVQWXSXLZVIAVWQVXTVYMVYGWVNWXTAVWQVWRVXBXMZ
      XNAVWRVXTVYMVYGWVNWXTAVWQVWRVXBXOZXNWVOWYBWXTWVOWYAVWQWYBWXTUQWYCAVWQVXTV
      YMVYGWVNWYDXPZWVQDUWMVAUWNAVWPVXTVYMVYGWVNWXTFXNWVQDEUWOUWPXQZWVOWXEEWVRS
      WVOWXEPVWRWVRSRZYKELMZWXEESRAVWRVXTVYMVYGWVNWXEWYEXNWVOWYHWXEWVOVYIVWKWXR
      WXOXRZVIAWYIVXTVYMVYGWVNWXEAYKDEYKORAUWQUKWYDWYEAVWQYKDTMWYDDUWTUOFUWRXNW
      VOWXEVJEWVRUWSXSWVOWYHWXEXKWYJVIXQZWVOWXDWXFWYGWYKWVOWVQWXFLMZDWXFLMZWXDW
      XFLMZWVOWVQELMZWVQWVRLMZWYLWVOWVQVWKEWYCWVOVWKWXOXLZAVWRVXTVYMVYGWVNWYEXP
      ZWVOKVYILMZWVQVWKLMWVNWYSVYOVYIXTWNZWVOVYIVWKWXRWXOUXAYAZVYMVWKELMZVYEVYG
      WVNVYMDVWKLMZXUBVWKDEUXBZXOXHYBWVOWVQVWKWVRWXSWXOWYJXUAWVOWYSVWKWVRLMWYTW
      VOVYIVWKWXRWXOUXCYAZUXIWXEWYOWYPWYLEWVREWXFWVQLVDWVRWXFWVQLVDYCVAWVOVWPDW
      VRLMZWYMAVWPVXTVYMVYGWVNFXPWVODVWKWVRWYFWYQWVOWVRWYJXLZVYMXUCVYEVYGWVNVYM
      XUCXUBXUDXMXHXUEYBWXEVWPXUFWYMEWVREWXFDLVDWVRWXFDLVDYCVAWXCWYLWYMWYNWVQDW
      VQWXDWXFLYDDWXDWXFLYDYCVAZYEWXDWXFUXDVGUXEZWVOWXFWXDWYKWYGWHUXFZVXTVVNAVY
      MVYGWVNVVMXTXGWVOKWXJWXHLWVOWYNKWXJLMXUHWVOWXDWXFWYGWYKWIYAXUIYFUXGWVOWWD
      JSVXHWXGRZVVMKVNZVHZUHQZWXIWVOWWCXUMUHWVOJSWWBXULWVOWWAXUKVVMKWVOWVTWXGVX
      HWVOVWQVWRWYAWVRORZWVTWXGWOWYFWYRWYCXUGDEWVQWVRUXJXSUXHUXKUXLWPWVOWXLWXHS
      RVVMVWHRZXUNWXIWOWXLWVOWXMUKXUJVXTXUPAVYMVYGWVNVXTVYDKVVMTMZXUPWVIVVMUXMZ
      VVMWAUXNXGJWXGVVMUXOVGUXPYFVIWVPWWGWWRWWCVXNTUXSZMZWWDVXOTMVXTWWGAVYMVYGW
      VNWUFWWPXEVXTWWRAVYMVYGWVNWUFWXAXEWVPXUTWWBVXMTMZJSUPWVPXVAJSWVPVXHVVORZV
      XHWVSRZVVMKVNZKVNZXVBVVMVXHCQZTMZVVMKVNZKVNZWWBVXMTWVPXVBXVEXVITMZWVPXVBX
      VJWVPXVBPXVDXVHXVEXVITWVOWUFXVBXVDXVHTMZWUFXVBPWVOVXHVWKVPNZVQQZVYILMZXVF
      VWLVPNZVQQZWUCLMZVRZXVKWUEXVRUDVXHVVOUDJYGZVYSXVNWUDXVQXVSVYRXVMVYILXVSVY
      QXVLVQVYPVXHVWKVPUXTWPYHXVSWUBXVPWUCLXVSWUAXVOVQXVSVYTXVFVWLVPVYPVXHCYIWQ
      WPYHUXQUXRXVCVVMXVHTMKXVHTMZXVKWVOXVRPZVVMKVVMXVDXVHTYDKXVDXVHTYDXWAXVCPZ
      VVMVVMXVHTVXTVVMVVMTMAVYMVYGWVNXVRXVCVXTVVMWVIUYIYJXWBXVGXVHVVMWOXWAXVCWW
      IXVNPZXVGXWAXVCXWCXWAXVCWWIWVQVXHLMZVXHWVRLMZPZPZXWCXWAXVCWWIXWDXWEUYAZXW
      GXWAWYAXUOXVCXWHUQXWAWVQXWAVWKVYIVYMWVDVYEVYGWVNXVRWXNXGZWVNWXPVYOXVRWXQW
      EZWHXLXWAWVRXWAVYIVWKXWJXWIXRXLWVQWVRVXHUYBVAWWIXWDXWEUYCUYDXWAWWIXVNXWFX
      WAWWIPZXVNVYIYLZXVLLMZXVLVYILMZPXWFXWKXVLVYIXWKVXHVWKXWAWWIVJZVYMWVDVYEVY
      GWVNXVRWWIWXNXEZWHWVNWXPVYOXVRWWIWXQXHZYMXWKXWMXWDXWNXWEXWKVWKXWLWRNZVXHL
      MXWMXWDXWKVWKXWLVXHXWPXWKVYIXWQUYEXWOUYFXWKXWRWVQVXHLXWKVWKVYIXWKVWKXWPYN
      XWKVYIXWQYNUYGYHUYJXWKVXHVWKVYIXWOXWPXWQUYHUYKVFUYLUYMWJWVOWWIXVRXVNXVGXV
      RXVNPWVOWWIPZXVQXVGXVNXVRXVQXVNXVQUYNUYOXWSXVQPZVVMXVFVXTVYDAVYMVYGWVNWWI
      XVQWVIYJZXWSXVFSRZXVQXWSVWHSXVFWVGWVOSVWHVXHCAVWIVXTVYMVYGWVNGXPWDUYPZVIZ
      XWTVVMXVFLMVVMVWLVPNZXVOLMZXWSXVQXXFXVOWUCLMZXWSXVQWUCYLZXVOLMZXXGPXXFXXG
      PXWSXVOWUCXWSXVFVWLXXCVYNVWLSRZVYGWVNWWIVYMVYEWVDXXJWXNVYEWVDPVWHSVWLWVGV
      YESVWHVWKCAVWIVXTGVIWDUYPYOZVSWHVYNWUCSRVYGWVNWWIVYNVWLVVMXXKWVJWHVSYMXWS
      XXIXXFXXGXWSXXHXXEXVOLVYNXXHXXEWOVYGWVNWWIVYNVWLVVMVYNVWLXXKYNVXTVVMWFRAV
      YMVVMUYQWEUYRVSYHUYSVFUYTXWTVVMXVFVWLXXAXXDVYNXXJVYGWVNWWIXVQXXKXPVUAUSYE
      YOVUBVUCXVGVVMKYPUOYFVXTXVTAVYMVYGWVNXVRXVCXKVXTXUQWWMXVTXURWSXVGXUQWWMXV
      TVVMKVVMXVHKTVDKXVHKTVDYCVBYJVUDYOVUEXVBXVEXVDWOWVPXVBXVDKYPWNXVBXVIXVHWO
      WVPXVBXVHKYPWNVUFWKXVBXKZKKXVEXVITWWMXXLWSUKXVBXVDKVUGXVBXVHKVUGVUFVUIWWB
      XVBXVCPZVVMKVNZXVEWWAXXMUQWWBXXNWOVXHVVOWVSVUHWWAXXMVVMKVUJXJXVBXVCVVMKVU
      KVULVXMXVBXVGPZVVMKVNZXVIVXLXXOUQVXMXXPWOVXKXVGUBVXHVVOUBJYGVXJXVFVVMTVXI
      VXHCYIWMVUSZVXLXXOVVMKVUJXJXVBXVGVVMKVUKVULVUMVUNWVPJSWWBVXMTWWCVXNYQWWFW
      WFSYQRZWVPVUOUKVXTWWHAVYMVYGWVNWUFWWIWWOYJVXTWWSAVYMVYGWVNWUFWWIWWTYJWVPW
      WCYRWVPVXNYRVUPUSWWCVXNVUQVGVURWKYSVUTWKYSVVAXIVYFWWRSWWFCUNZVXNCXUSMZVXQ
      VXTWWRAVVRWXAWEAXXSVXTVVRAVWIVWHWWFULXXSGBVWHWWFWVDWVEPVWKORZWVEPWVCVWKWW
      FRWVDXYAWVEVWKVVBVLWVFVWKWTVVCWBSVWHWWFCWCVBZYTVYFXXTVXMXVFTMZJSUPZAXYDVX
      TVVRAXYCJSVXLXVGKXVFTMZXYCAWWIPZVVMKVVMVXMXVFTYDKVXMXVFTYDVXLXVGXYFVXLXVB
      XVGXXQVVDWNXYFXYEVXLXKXYFXXBXYEXYFXVFVWHRXXBXYEPASVWHVXHCGWDXVFWAURXOVIVU
      DUTYTVYFJSVXMXVFTVXNCYQWWFYQXXRVYFVUOUKVXTWWSAVVRWWIWWTXHXVFYQRVYFWWIPVXH
      CVVEUKVYFVXNYRACJSXVFVHWOVXTVVRAJSVWHCGVVFYTVUPUSVXNCVUQVGVVJVVGVVKVVHAVX
      RVWBUAVOVYEVWCWWQVWAORZVXRVWBVRVWCVYEUJUKVXTWWQAWXBWNAXYGVXTAXXSXYGXYBCXD
      UOVIKVXOVWAVVIVGYSVVLVUT $.
  $}

  ${
    $d x A $.  $d x ph $.
    ibladdnclem.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
    ibladdnclem.2 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
    ibladdnclem.3 $e |- ( ( ph /\ x e. A ) -> D = ( B + C ) ) $.
    ibladdnclem.4 $e |- ( ph -> ( x e. A |-> B ) e. MblFn ) $.
    ibladdnclem.6 $e |- ( ph -> ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ B ) , B , 0 ) ) ) e. RR ) $.
    ibladdnclem.7 $e |- ( ph -> ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ C ) , C , 0 ) ) ) e. RR ) $.
    $( Lemma for ~ ibladdnc ; cf ~ ibladdlem , whose fifth hypothesis is
       rendered unnecessary by the weakened hypotheses of ~ itg2addnc .
       (Contributed by Brendan Leahy, 31-Oct-2017.) $)
    ibladdnclem $p |- ( ph -> ( S.2 ` ( x e. RR |->
      if ( ( x e. A /\ 0 <_ D ) , D , 0 ) ) ) e. RR ) $=
      ( cr cc0 wcel cle wbr cif caddc 0re cpnf cicc co cv wa cmpt wf citg2 ifan
      cfv cxr readdcld eqeltrd ifcl sylancl rexrd max1 sylancr elxrge0 sylanbrc
      wn 0xr 0le0 mpbir2an a1i ifclda adantr syl5eqel eqid fmptd cof reex eqidd
      cvv offval2 wceq iftrue ibar ifbid oveq12d eqtr2d simpl con3i iffalse syl
      00id 3eqtr4a pm2.61i mpteq2i syl6eq fveq2d cvol cdm wss mbfdm2 mblss cdif
      rembl eldifn adantl intnanrd cmbf mpteq2ia mbfpos syl5eqelr mbfss elrege0
      cico itg2addnc eqtr3d cofr addge0d wral max2 le2addd eqbrtrd breq1 ifboth
      syl2anc 3brtr4d pm2.61d1 syl5eqbr ofrfval2 mpbird itg2le syl3anc itg2lecl
      ex ralrimivw ) AMNUAUBUCZBMBUDZCOZNFPQZUEFNRZUFZUGZBMYLNDPQZDNRZNEPQZENRZ
      SUCZNRZUFZUHUJZMOYOUHUJZUUDPQZUUEMOABMYNYJYOAYKMOZUEYNYLYMFNRZNRZYJYLYMFN
      UIZAUUIYJOUUGAYLUUHNYJAYLUEZUUHUKONUUHPQZUUHYJOUUKUUHUUKFMOZNMOZUUHMOUUKF
      DESUCZMIUUKDEGHULUMZTYMFNMUNUOUPUUKUUNUUMUULTUUPNFUQURUUHUSUTNYJOZAYLVAZU
      EZUUQNUKONNPQZVBVCNUSVDVEZVFVGVHZYOVIVJZAUUDBMYLYQUEZDNRZUFZUHUJZBMYLYSUE
      ZENRZUFZUHUJZSUCZMAUVFUVJSVKUCZUHUJUUDUVLAUVMUUCUHAUVMBMUVEUVISUCZUFUUCAB
      MUVEUVISUVFUVJVNMMMVNOAVLVEZAUVEMOZUUGAUVEYLYRNRZMYLYQDNUIZAYLYRNMUUKDMOZ
      UUNYRMOZGTYQDNMUNUOZUUNUUSTVEZVFVHZVGAUVIMOUUGAUVIYLYTNRZMYLYSENUIZAYLYTN
      MUUKEMOZUUNYTMOZHTYSENMUNUOZUWBVFVHVGAUVFVMAUVJVMVOBMUVNUUBYLUVNUUBVPYLUU
      BUUAUVNYLUUANVQZYLYRUVEYTUVISYLYQUVDDNYLYQVRVSZYLYSUVHENYLYSVRVSVTWAUURNN
      SUCNUVNUUBWFUURUVENUVINSUURUVDVAZUVENVPZUVDYLYLYQWBWCUVDDNWDZWEUURUVHVAUV
      INVPUVHYLYLYSWBWCUVHENWDWEVTYLUUANWDZWGWHWIWJWKAUVFUVJABCMUVEMACWLWMZOCMW
      NABCDMJGWOCWPWEMUWOOAWRVEAUVPYLUWCVGAYKMCWQOZUEZUWKUWLUWQYLYQUWPUURAYKMCW
      SWTXAUWMWEABCUVEUFBCYRUFXBBCYRUVEUWJXCABCDGJXDXEXFABMUVENUAXHUCZUVFAUVEUW
      ROUUGAUVEUVQUWRUVRAYLYRNUWRUUKUVTNYRPQZYRUWROUWAUUKUUNUVSUWSTGNDUQURZYRXG
      UTNUWROZUUSUXAUUNUUTTVCNXGVDVEZVFVHVGUVFVIVJKABMUVIUWRUVJAUVIUWROUUGAUVIU
      WDUWRUWEAYLYTNUWRUUKUWGNYTPQZYTUWROUWHUUKUUNUWFUXCTHNEUQURZYTXGUTUXBVFVHV
      GUVJVIVJLXIXJAUVGUVKKLULUMAYPMYJUUCUGYOUUCPXKQZUUFUVCABMUUBYJUUCAUUBYJOUU
      GAYLUUANYJUUKUUAUKONUUAPQZUUAYJOUUKUUAUUKYRYTUWAUWHULUPUUKYRYTUWAUWHUWTUX
      DXLZUUAUSUTUVAVFVGZUUCVIVJAUXEYNUUBPQZBMXMAUXIBMAYNUUIUUBPUUJAYLUUIUUBPQZ
      AYLUXJUUKUUHUUAUUIUUBPUUKFUUAPQZUXFUUHUUAPQZUUKFUUOUUAPIUUKDEYRYTGHUWAUWH
      UUKUUNUVSDYRPQTGNDXNURUUKUUNUWFEYTPQTHNEXNURXOXPUXGYMUXKUXFUXLFNFUUHUUAPX
      QNUUHUUAPXQXRXSYLUUIUUHVPAYLUUHNVQWTYLUUBUUAVPAUWIWTXTYHUURNNUUIUUBPUUTUU
      RVCVEYLUUHNWDUWNXTYAYBYIABMYNUUBPYOUUCVNYJYJUVOUVBUXHAYOVMAUUCVMYCYDYOUUC
      YEYFUUDYOYGYF $.
  $}

  ${
    $d x A $.  $d x V $.  $d x ph $.
    ibladdnc.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    ibladdnc.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    ibladdnc.3 $e |- ( ( ph /\ x e. A ) -> C e. V ) $.
    ibladdnc.4 $e |- ( ph -> ( x e. A |-> C ) e. L^1 ) $.
    ${
      ibladdnc.m $e |- ( ph -> ( x e. A |-> ( B + C ) ) e. MblFn ) $.
      $( Choice-free analogue of ~ itgadd .  A measurability hypothesis is
         necessitated by the loss of ~ mbfadd ; for large classes of functions,
         such as continuous functions, it should be relatively easy to show.
         (Contributed by Brendan Leahy, 1-Nov-2017.) $)
      ibladdnc $p |- ( ph -> ( x e. A |-> ( B + C ) ) e. L^1 ) $=
        ( cmpt wcel cr cc0 cfv cle wbr wa cif caddc co cibl cmbf cre citg2 cneg
        cim iblmbf syl mbfmptcl recld readdd ismbfcn2 mpbid simpld w3a iblcnlem
        simp2d ibladdnclem renegcld negeqd recnd negdid eqtrd mbfneg simprd jca
        cv eqid imcld imaddd simp3d cvv ovex a1i mpbir3and ) ABCDEUAUBZLZUCMVSU
        DMBNBVICMZOVRUEPZQRSWAOTLUFPZNMZBNVTOWAUGZQRSWDOTLUFPZNMZSBNVTOVRUHPZQR
        SWGOTLUFPZNMZBNVTOWGUGZQRSWJOTLUFPZNMZSKAWCWFABCDUEPZEUEPZWAAVTSZDABCDF
        ABCDLZUCMZWPUDMZHWPUIUJZGUKZULZWOEABCEFABCELZUCMZXBUDMZJXBUIUJIUKZULZWO
        DEWTXEUMZABCWMLUDMZBCDUHPZLUDMZAWRXHXJSWSABCDWTUNUOZUPZABNVTOWMQRSWMOTL
        UFPZNMZBNVTOWMUGZQRSXOOTLUFPZNMZAWRXNXQSZBNVTOXIQRSXIOTLUFPZNMZBNVTOXIU
        GZQRSYAOTLUFPZNMZSZAWQWRXRYDUQHABCDXMXPXSYBFXMVJXPVJXSVJYBVJGURUOZUSZUP
        ABNVTOWNQRSWNOTLUFPZNMZBNVTOWNUGZQRSYIOTLUFPZNMZAXDYHYKSZBNVTOEUHPZQRSY
        MOTLUFPZNMZBNVTOYMUGZQRSYPOTLUFPZNMZSZAXCXDYLYSUQJABCEYGYJYNYQFYGVJYJVJ
        YNVJYQVJIURUOZUSZUPUTABCXOYIWDWOWMXAVAWOWNXFVAWOWDWMWNUAUBZUGXOYIUAUBWO
        WAUUBXGVBWOWMWNWOWMXAVCWOWNXFVCVDVEABCWMNXAXLVFAXNXQYFVGAYHYKUUAVGUTVHA
        WIWLABCXIYMWGWODWTVKZWOEXEVKZWODEWTXEVLZAXHXJXKVGZAXTYCAWRXRYDYEVMZUPAY
        OYRAXDYLYSYTVMZUPUTABCYAYPWJWOXIUUCVAWOYMUUDVAWOWJXIYMUAUBZUGYAYPUAUBWO
        WGUUIUUEVBWOXIYMWOXIUUCVCWOYMUUDVCVDVEABCXINUUCUUFVFAXTYCUUGVGAYOYRUUHV
        GUTVHABCVRWBWEWHWKVNWBVJWEVJWHVJWKVJVRVNMWODEUAVOVPURVQ $.

      ${
        itgaddnclem.1 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
        itgaddnclem.2 $e |- ( ( ph /\ x e. A ) -> C e. RR ) $.
        ${
          itgaddnclem.3 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
          itgaddnclem.4 $e |- ( ( ph /\ x e. A ) -> 0 <_ C ) $.
          $( Lemma for ~ itgaddnc ; cf. ~ itgaddlem1 .  (Contributed by Brendan
             Leahy, 7-Nov-2017.) $)
          itgaddnclem1 $p |- ( ph -> S. A ( B + C ) _d x =
              ( S. A B _d x + S. A C _d x ) ) $=
            ( caddc co cr wcel cc0 citg cv cif cmpt citg2 cfv readdcld ibladdnc
            wa addge0d itgposval cof oveq12d cpnf cico cvol cdm wss cibl iblmbf
            syl mbfdm2 mblss rembl a1i cle wbr elrege0 sylanbrc wn 0re mpbir2an
            cmbf 0le0 ifclda adantr cdif eldifn adantl iftrue mpteq2ia syl5eqel
            wceq iffalse mbfss eqid fmptd iblpos mpbid itg2addnc cvv reex eqidd
            simprd offval2 eqtr4d 00id syl6eq pm2.61i mpteq2i fveq2d 3eqtr2d )
            ABCDEPQZUABRBUBZCSZXCTUCZUDZUEUFZBCDUAZBCEUAZPQZABCXCAXEUIZDELMUGAB
            CDEFGHIJKUHXLDELMNOUJUKAXKBRXEDTUCZUDZUEUFZBRXEETUCZUDZUEUFZPQXNXQP
            ULQZUEUFXHAXIXOXJXRPABCDLHNUKABCEMJOUKUMAXNXQABCRXMTUNUOQZACUPUQZSC
            RURABCDFABCDUDZUSSZYBVMSZHYBUTVAZGVBCVCVARYASAVDVEAXMXTSZXEAXEDTXTX
            LDRSTDVFVGDXTSLNDVHVITXTSZAXEVJZUIYGTRSTTVFVGVKVNTVHVLVEZVOZVPAXDRC
            VQSZUIYHXMTWCYKYHAXDRCVRVSXEDTWDZVAABCXMUDYBVMBCXMDXEDTVTZWAYEWBWEA
            BRXMXTXNAYFXDRSZYJVPZXNWFWGAYDXORSZAYCYDYPUIHABCDLNWHWIWNABRXPXTXQA
            XPXTSYNAXEETXTXLERSTEVFVGEXTSMOEVHVIYIVOVPZXQWFWGABCEUDZVMSZXRRSZAY
            RUSSYSYTUIJABCEMOWHWIWNWJAXSXGUEAXSBRXMXPPQZUDXGABRXMXPPXNXQWKXTXTR
            WKSAWLVEYOYQAXNWMAXQWMWOBRUUAXFXEUUAXFWCXEUUAXCXFXEXMDXPEPYMXEETVTU
            MXEXCTVTWPYHUUATXFYHUUATTPQTYHXMTXPTPYLXEETWDUMWQWRXEXCTWDWPWSWTWRX
            AXBWP $.
        $}

        $( Lemma for ~ itgaddnc ; cf. ~ itgaddlem2 .  (Contributed by Brendan
           Leahy, 10-Nov-2017.)  (Revised by Brendan Leahy, 3-Apr-2018.) $)
        itgaddnclem2 $p |- ( ph -> S. A ( B + C ) _d x =
            ( S. A B _d x + S. A C _d x ) ) $=
          ( cc0 caddc co cle wceq wcel cr wbr cif citg cneg cmin cv max0sub syl
          wa oveq12d 0re ifcl sylancl recnd renegcld addsub4d readdcld 3eqtr4rd
          addsubeq4d mpbird itgeq2dv cmpt cibl ibladdnc iblre mpbid simprd cmbf
          simpld iblmbf mbfposadd sylancr iftrue oveq2d mpteq2dva mbfneg negdid
          max1 addge0d oveq1d add4d negeq neg0 syl6eq 0le0 syl5breqr eqtrd 00id
          id adantl wne oveq2 wn clt wb negne0bd biimpa wo le0neg2d leloe bitrd
          df-ne biorf sylbi orcom syl6rbb sylan9bb syldan adantr addcomd negidd
          ifsb ltnle addid1d ifbieq12d ifnot syl5eq pm2.61dane eqeltrrd eqeltrd
          3eqtrd itgaddnclem1 le0neg1d bitr3d 3eqtr3d itgcl cc itgreval 3eqtr4d
          addcld ) ABCNDEOPZQUAZYKNUBZUCZBCNYKUDZQUAZYONUBZUCZUEPZBCNDQUAZDNUBZ
          UCZBCNDUDZQUAZUUCNUBZUCZUEPZBCNEQUAZENUBZUCZBCNEUDZQUAZUUKNUBZUCZUEPZ
          OPZBCYKUCBCDUCZBCEUCZOPAYSBCUUAUUIOPZUCZBCUUEUUMOPZUCZUEPZUUBUUJOPZUU
          FUUNOPZUEPUUPAYRUUTOPZYNUVBOPZRYSUVCRABCYQUUSOPZUCBCYMUVAOPZUCUVFUVGA
          BCUVHUVIABUFCSUIZUVHUVIRYMYQUEPZUUSUVAUEPZRUVJUUAUUEUEPZUUIUUMUEPZOPY
          KUVLUVKUVJUVMDUVNEOUVJDTSZUVMDRLDUGUHUVJETSZUVNERMEUGUHUJUVJUUAUUIUUE
          UUMUVJUUAUVJUVONTSZUUATSLUKYTDNTULUMZUNZUVJUUIUVJUVPUVQUUITSMUKUUHENT
          ULUMZUNZUVJUUEUVJUUCTSZUVQUUETSUVJDLUOZUKUUDUUCNTULUMZUNZUVJUUMUVJUUK
          TSZUVQUUMTSUVJEMUOZUKUULUUKNTULUMZUNZUPUVJYKTSZUVKYKRUVJDELMUQZYKUGUH
          URUVJYQUUSYMUVAUVJYQUVJYOTSZUVQYQTSUVJYKUWKUOZUKYPYONTULUMZUNUVJUUSUV
          JUUAUUIUVRUVTUQZUNUVJYMUVJUWJUVQYMTSUWKUKYLYKNTULUMZUNUVJUVAUVJUUEUUM
          UWDUWHUQZUNUSUTVAABCYQUUSTUWNABCYMVBVCSZBCYQVBVCSZABCYKVBVCSUWRUWSUIA
          BCDETLHMJKVDZABCYKUWKVEVFZVGZUWOABCUUAUUITUVRABCUUAVBVCSZBCUUEVBVCSZA
          BCDVBZVCSZUXCUXDUIHABCDLVEVFZVIZUVTABCUUIVBVCSZBCUUMVBVCSZABCEVBZVCSZ
          UXIUXJUIJABCEMVEVFZVIZABCDEAUXFUXEVHSHUXEVJUHZLAUXLUXKVHSJUXKVJUHZMKV
          KZVDABCYQNUUSQUAZUUSNUBZOPZVBBCUVHVBVHABCUXTUVHUVJUXSUUSYQOUVJUXRUXSU
          USRUVJUUAUUIUVRUVTUVJUVQUVONUUAQUAUKLNDVRVLZUVJUVQUVPNUUIQUAUKMNEVRVL
          ZVSZUXRUUSNVMUHVNVOABCYOUUSABCYKTUWKKVPZUWMUXQUWOABCYOUUSOPZVBBCUVAVB
          VHABCUYEUVAUVJUYEUUCUUKOPZUUSOPUUCUUAOPZUUKUUIOPZOPUVAUVJYOUYFUUSOUVJ
          DEUVJDLUNZUVJEMUNZVQZVTUVJUUCUUKUUAUUIUVJUUCUWCUNZUVJUUKUWGUNZUVSUWAW
          AUVJUYGUUEUYHUUMOUVJUYGUUERZDNDNRZUYNUVJUYOUUCNUUEUYGUYOUUCNUDZNDNWBW
          CWDZUYOUUDUUEUUCRUYONNUUCQWEUYQWFUUDUUCNVMUHZUYOUYGNNOPZNUYOUUCNUUANO
          UYQUYOUUADNUYOYTUUADRUYONNDQWEUYOWIZWFYTDNVMUHZUYTWGUJWHWDURWJUVJDNWK
          ZUIZUYGYTUUCDOPZUUCNOPZUBZUUEYTDNUYGVUDVUEUUADUUCOWLUUANUUCOWLXLVUCVU
          FUUDWMZNUUCUBUUEVUCYTVUGVUDVUENUUCVUCYTUUCNWNUAZVUGUVJVUBUUCNWKZYTVUH
          WOUVJVUBVUIUVJDUYIWPWQUVJYTVUHUUCNRZWRZVUIVUHUVJYTUUCNQUAZVUKUVJDLWSU
          VJUWBUVQVULVUKWOUWCUKUUCNWTUMXAVUIVUHVUJVUHWRZVUKVUIVUJWMVUHVUMWOUUCN
          XBVUJVUHXCXDVUJVUHXEXFXGXHUVJVUHVUGWOZVUBUVJUWBUVQVUNUWCUKUUCNXMUMXIX
          AUVJVUDNRVUBUVJVUDDUUCOPZNUVJUUCDUYLUYIXJUVJDUYIXKZWGXIUVJVUEUUCRVUBU
          VJUUCUYLXNXIXOUUDNUUCXPWDXQXRUVJUYHUUMRZENENRZVUQUVJVURUUKNUUMUYHVURU
          UKUYPNENWBWCWDZVURUULUUMUUKRVURNNUUKQWEVUSWFUULUUKNVMUHZVURUYHUYSNVUR
          UUKNUUINOVUSVURUUIENVURUUHUUIERVURNNEQWEVURWIZWFUUHENVMUHZVVAWGUJWHWD
          URWJUVJENWKZUIZUYHUUHUUKEOPZUUKNOPZUBZUUMUUHENUYHVVEVVFUUIEUUKOWLUUIN
          UUKOWLXLVVDVVGUULWMZNUUKUBUUMVVDUUHVVHVVEVVFNUUKVVDUUHUUKNWNUAZVVHUVJ
          VVCUUKNWKZUUHVVIWOUVJVVCVVJUVJEUYJWPWQUVJUUHVVIUUKNRZWRZVVJVVIUVJUUHU
          UKNQUAZVVLUVJEMWSUVJUWFUVQVVMVVLWOUWGUKUUKNWTUMXAVVJVVIVVKVVIWRZVVLVV
          JVVKWMVVIVVNWOUUKNXBVVKVVIXCXDVVKVVIXEXFXGXHUVJVVIVVHWOZVVCUVJUWFUVQV
          VOUWGUKUUKNXMUMXIXAUVJVVENRVVCUVJVVEEUUKOPZNUVJUUKEUYMUYJXJUVJEUYJXKZ
          WGXIUVJVVFUUKRVVCUVJUUKUYMXNXIXOUULNUUKXPWDXQXRUJYAVOABCUUCUUKABCDTLU
          XOVPUWCABCETMUXPVPUWGABCYOVBBCUYFVBVHABCYOUYFUYKVOUYDXSVKZXTVKXSUWNUW
          OUVJUVQUWLNYQQUAUKUWMNYOVRVLUYCYBABCYMUVATUWPAUWRUWSUXAVIZUWQABCUUEUU
          MTUWDAUXCUXDUXGVGZUWHAUXIUXJUXMVGZVVRVDABCYMNUVAQUAZUVANUBZOPZVBBCUVI
          VBVHABCVWDUVIUVJVWCUVAYMOUVJVWBVWCUVARUVJUUEUUMUWDUWHUVJUVQUWBNUUEQUA
          UKUWCNUUCVRVLZUVJUVQUWFNUUMQUAUKUWGNUUKVRVLZVSZVWBUVANVMUHVNVOABCYKUV
          AKUWKVVRUWQABCYKUVAOPZVBBCUUSVBVHABCVWHUUSUVJVWHDUUEOPZEUUMOPZOPUUSUV
          JDEUUEUUMUYIUYJUWEUWIWAUVJVWIUUAVWJUUIOUVJVWIUUARZDNUYOVWKUVJUYODNUUA
          VWIUYTVUAUYOVWIUYSNUYODNUUENOUYTUYOUUEUUCNUYRUYQWGUJWHWDURWJVUCVWIUUD
          VUODNOPZUBZUUAUUDUUCNVWIVUOVWLUUEUUCDOWLUUENDOWLXLVUCVWMYTWMZNDUBUUAV
          UCUUDVWNVUOVWLNDVUCUUDDNWNUAZVWNUVJUUDVWOUYOWRZVUBVWOUVJDNQUAZUUDVWPU
          VJDLYCUVJUVOUVQVWQVWPWOLUKDNWTUMYDVUBVWOUYOVWOWRZVWPVUBUYOWMVWOVWRWOD
          NXBUYOVWOXCXDUYOVWOXEXFXGUVJVWOVWNWOZVUBUVJUVOUVQVWSLUKDNXMUMXIXAUVJV
          UONRVUBVUPXIUVJVWLDRVUBUVJDUYIXNXIXOYTNDXPWDXQXRUVJVWJUUIRZENVURVWTUV
          JVURENUUIVWJVVAVVBVURVWJUYSNVURENUUMNOVVAVURUUMUUKNVUTVUSWGUJWHWDURWJ
          VVDVWJUULVVPENOPZUBZUUIUULUUKNVWJVVPVXAUUMUUKEOWLUUMNEOWLXLVVDVXBUUHW
          MZNEUBUUIVVDUULVXCVVPVXANEVVDUULENWNUAZVXCUVJUULVXDVURWRZVVCVXDUVJENQ
          UAZUULVXEUVJEMYCUVJUVPUVQVXFVXEWOMUKENWTUMYDVVCVXDVURVXDWRZVXEVVCVURW
          MVXDVXGWOENXBVURVXDXCXDVURVXDXEXFXGUVJVXDVXCWOZVVCUVJUVPUVQVXHMUKENXM
          UMXIXAUVJVVPNRVVCVVQXIUVJVXAERVVCUVJEUYJXNXIXOUUHNEXPWDXQXRUJWGVOUXQX
          TVKXSUWPUWQUVJUVQUWJNYMQUAUKUWKNYKVRVLVWGYBYEAYRUUTYNUVBABCYQTUWNUXBY
          FAUUTUVDYGABCUUAUUITUVRUXHUVTUXNUXQUVRUVTUYAUYBYBZAUUBUUJABCUUATUVRUX
          HYFZABCUUITUVTUXNYFZYJXTABCYMTUWPVVSYFAUVBUVEYGABCUUEUUMTUWDVVTUWHVWA
          VVRUWDUWHVWEVWFYBZAUUFUUNABCUUETUWDVVTYFZABCUUMTUWHVWAYFZYJXTUSVFAUUT
          UVDUVBUVEUEVXIVXLUJAUUBUUJUUFUUNVXJVXKVXMVXNUPYAABCYKUWKUWTYHAUUQUUGU
          URUUOOABCDLHYHABCEMJYHUJYI $.
      $}

      $d x y $.  $d y B $.  $d y C $.
      $( Choice-free analogue of ~ itgadd .  (Contributed by Brendan Leahy,
         11-Nov-2017.) $)
      itgaddnc $p |- ( ph -> S. A ( B + C ) _d x =
          ( S. A B _d x + S. A C _d x ) ) $=
        ( caddc co cre citg ci wcel cmpt cr cc vy cfv cim cmul cibl cmbf iblmbf
        cv wa syl mbfmptcl readdd itgeq2dv recld iblcn mpbid simpld ccom addcld
        eqidd wf ref feqmptd fveq2 fmptco mpteq2dva eqtrd wb eqid fmptd ismbfcn
        a1i eqeltrrd itgaddnclem2 imaddd imcld simprd imf oveq2d ax-icn oveq12d
        itgcl adddid mulcl sylancr add4d cvv ovex ibladdnc itgcnval 3eqtr4d ) A
        BCDELMZNUBZOZPBCWLUCUBZOZUDMZLMZBCDNUBZOZPBCDUCUBZOZUDMZLMZBCENUBZOZPBC
        EUCUBZOZUDMZLMZLMZBCWLOBCDOZBCEOZLMAWRWTXFLMZXCXILMZLMXKAWNXNWQXOLAWNBC
        WSXELMZOXNABCWMXPABUHCQUIZDEABCDFABCDRZUEQZXRUFQHXRUGUJGUKZABCEFABCERZU
        EQZYAUFQJYAUGUJIUKZULZUMABCWSXESXQDXTUNZABCWSRUEQZBCXARUEQZAXSYFYGUIHAB
        CDXTUOUPZUQZXQEYCUNZABCXERUEQZBCXGRUEQZAYBYKYLUIJABCEYCUOUPZUQZANBCWLRZ
        URZBCXPRZUFAYPBCWMRYQABUACTWLUAUHZNUBWMYONXQDEXTYCUSZAYOUTZAUATSNTSNVAA
        VBVLVCYRWLNVDVEABCWMXPYDVFVGAYPUFQZUCYOURZUFQZAYOUFQZUUAUUCUIZKACTYOVAU
        UDUUEVHABCWLTYOYSYOVIVJCYOVKUJUPZUQVMYEYJVNVGAWQPXBXHLMZUDMXOAWPUUGPUDA
        WPBCXAXGLMZOUUGABCWOUUHXQDEXTYCVOZUMABCXAXGSXQDXTVPZAYFYGYHVQZXQEYCVPZA
        YKYLYMVQZAUUBBCUUHRZUFAUUBBCWORUUNABUACTWLYRUCUBWOYOUCYSYTAUATSUCTSUCVA
        AVRVLVCYRWLUCVDVEABCWOUUHUUIVFVGAUUAUUCUUFVQVMUUJUULVNVGVSAPXBXHPTQZAVT
        VLABCXASUUJUUKWBZABCXGSUULUUMWBZWCVGWAAWTXFXCXIABCWSSYEYIWBABCXESYJYNWB
        AUUOXBTQXCTQVTUUPPXBWDWEAUUOXHTQXITQVTUUQPXHWDWEWFVGABCWLWGWLWGQXQDELWH
        VLABCDEFGHIJKWIWJAXLXDXMXJLABCDFGHWJABCEFIJWJWAWK $.
    $}

    iblsubnc.m $e |- ( ph -> ( x e. A |-> ( B - C ) ) e. MblFn ) $.
    $( Choice-free analogue of ~ iblsub .  (Contributed by Brendan Leahy,
       11-Nov-2017.) $)
    iblsubnc $p |- ( ph -> ( x e. A |-> ( B - C ) ) e. L^1 ) $=
      ( cneg co cmpt cibl wcel cmbf iblmbf syl mbfmptcl caddc cmin cv mpteq2dva
      wa negsubd cc negcld iblneg eqeltrd ibladdnc eqeltrrd ) ABCDELZUAMZNZBCDE
      UBMZNZOABCUNUPABUCCPUEZDEABCDFABCDNZOPUSQPHUSRSGTZABCEFABCENZOPVAQPJVARSI
      TZUFUDZABCDUMUGUTHUREVBUHABCEFIJUIAUOUQQVCKUJUKUL $.
    $( Choice-free analogue of ~ itgsub .  (Contributed by Brendan Leahy,
       11-Nov-2017.) $)
    itgsubnc $p |- ( ph -> S. A ( B - C ) _d x =
      ( S. A B _d x - S. A C _d x ) ) $=
      ( cneg caddc co citg cmin cmpt cibl wcel cmbf cc iblmbf syl negcld iblneg
      mbfmptcl negsubd mpteq2dva eqeltrd itgaddnc itgneg oveq2d eqtr4d itgeq2dv
      cv wa itgcl 3eqtr3d ) ABCDELZMNZOZBCDOZBCEOZLZMNZBCDEPNZOVBVCPNAVAVBBCUSO
      ZMNVEABCDUSUAABCDFABCDQZRSVHTSHVHUBUCGUFZHABUOCSUPZEABCEFABCEQZRSVKTSJVKU
      BUCIUFZUDABCEFIJUEABCUTQBCVFQTABCUTVFVJDEVIVLUGZUHKUIUJAVDVGVBMABCEFIJUKU
      LUMABCUTVFVMUNAVBVCABCDFGHUQABCEFIJUQUGUR $.
  $}

  ${
    $d x y A $.  $d x y ph $.  $d y B $.  $d y V $.
    iblabsnc.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    iblabsnc.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    ${
      $d y G $.  $d y F $.
      iblabsnclem.1 $e |- G =
        ( x e. RR |-> if ( x e. A , ( abs ` ( F ` B ) ) , 0 ) ) $.
      iblabsnclem.2 $e |- ( ph -> ( x e. A |-> ( F ` B ) ) e. L^1 ) $.
      iblabsnclem.3 $e |- ( ( ph /\ x e. A ) -> ( F ` B ) e. RR ) $.
      $( Lemma for ~ iblabsnc ; cf. ~ iblabslem .  (Contributed by Brendan
         Leahy, 7-Nov-2017.) $)
      iblabsnclem $p |- ( ph -> ( G e. MblFn /\ ( S.2 ` G ) e. RR ) ) $=
        ( wcel cr cc0 cmpt wbr wa co caddc cmbf citg2 cfv cabs cif cvol cdm wss
        vy cle cneg cibl w3a iblrelem mpbid simp1d mbfdm2 mblss syl rembl recnd
        cv a1i abscld 0re ifcl sylancl cdif wceq eldifn adantl iffalse mpteq2ia
        wn iftrue eqid fmptd ccnv cpnf cioo cima cmnf cun crab wo clt biantrurd
        adantlr simplr absled notbid ltnled cxr renegcl rexrd ad2antlr elioomnf
        renegcld 3bitr2d rexr elioopnf orbi12d ianor syl6bbr 3bitr4rd mptpreima
        wb rabbidva uneq12i unrab eqtri 3eqtr4g wf iblmbf mbfima syl2anc adantr
        unmbl eqeltrd absltd bitrd 3anass elioo2 ismbf2d syl5eqel mbfss cof cvv
        bitr4d cico ifan max1 sylancr elrege0 ifclda eqidd oveq12d syl5eq eqtrd
        sylanbrc reex 0le0 mpbir2an offval2 oveq12i max0add 3eqtr4d ex pm2.61d1
        00id mpteq2dv syl6reqr fveq2d ibar ifbid mbfpos syl5eqelr simp2d simp3d
        3eqtr4a itg2addnc readdcld jca ) AFUAMFUBUCZNMAFBNBVBZCMZDEUCZUDUCZOUEZ
        PZUAJABCNUVINACUFUGZMCNUHABCUVGNABCUVGPZUAMZBNUVFOUVGUJQZRZUVGOUEZPZUBU
        CZNMZBNUVFOUVGUKZUJQZRUVTOUEZPZUBUCZNMZAUVLULMZUVMUVSUWEUMKABCUVGLUNUOZ
        UPZLUQZCURUSZNUVKMAUTVCZAUVFRZUVHNMZONMZUVINMUWLUVGUWLUVGLVAVDZVEUVFUVH
        ONVFVGAUVENCVHMZRZUVFVNZUVIOVIUWPUWRAUVENCVJVKZUVFUVHOVLZUSABCUVIPBCUVH
        PZUABCUVIUVHUVFUVHOVOZVMAUICUXAABCUVHNUXAUWOUXAVPZVQUWIAUIVBZNMZRZUXAVR
        ZUXDVSVTSZWAZUVLVRZWBUXDUKZVTSZWAZUXJUXHWAZWCZUVKUXFUVHUXHMZBCWDUVGUXLM
        ZUVGUXHMZWEZBCWDZUXIUXOUXFUXPUXSBCUXFUVFRZUXDUVHWFQZUWMUYBRZUXSUXPUYAUW
        MUYBAUVFUWMUXEUWOWHZWGUYAUVHUXDUJQZVNUXKUVGUJQZUVGUXDUJQZRZVNZUYBUXSUYA
        UYEUYHUYAUVGUXDAUVFUVGNMZUXELWHZAUXEUVFWIZWJWKUYAUXDUVHUYLUYDWLUYAUXSUY
        FVNZUYGVNZWEUYIUYAUXQUYMUXRUYNUYAUXQUYJUVGUXKWFQZRZUYOUYMUYAUXKWMMZUXQU
        YPXGUXEUYQAUVFUXEUXKUXDWNWOZWPUXKUVGWQUSUYAUYJUYOUYKWGUYAUVGUXKUYKUYAUX
        DUYLWRWLWSUYAUXRUYJUXDUVGWFQZRZUYSUYNUYAUXDWMMZUXRUYTXGUXEVUAAUVFUXDWTZ
        WPZUXDUVGXAUSUYAUYJUYSUYKWGUYAUXDUVGUYLUYKWLWSXBUYFUYGXCXDXEUYAVUAUXPUY
        CXGVUCUXDUVHXAUSXEXHBCUVHUXHUXAUXCXFUXOUXQBCWDZUXRBCWDZWCUXTUXMVUDUXNVU
        EBCUVGUXLUVLUVLVPZXFBCUVGUXHUVLVUFXFXIUXQUXRBCXJXKXLAUXOUVKMZUXEAUVMCNU
        VLXMZVUGAUWFUVMKUVLXNUSZABCUVGNUVLLVUFVQZUVMVUHRUXMUVKMUXNUVKMVUGCWBUXK
        UVLXOCUXDVSUVLXOUXMUXNXRXPXPXQXSUXFUXGWBUXDVTSZWAZUXJUXKUXDVTSZWAZUVKUX
        FUVHVUKMZBCWDUVGVUMMZBCWDVULVUNUXFVUOVUPBCUYAVUOUYJUXKUVGWFQZUVGUXDWFQZ
        UMZVUPUYAVUOUYJVUQVURRZRZVUSUYAVUOVUTVVAUYAVUOUWMUVHUXDWFQZRZVVBVUTUYAV
        UAVUOVVCXGVUCUXDUVHWQUSUYAUWMVVBUYDWGUYAUVGUXDUYKUYLXTWSUYAUYJVUTUYKWGY
        AUYJVUQVURYBXDUXEVUPVUSXGZAUVFUXEUYQVUAVVDUYRVUBUXKUXDUVGYCXPWPYIXHBCUV
        HVUKUXAUXCXFBCUVGVUMUVLVUFXFXLAVUNUVKMZUXEAUVMVUHVVEVUIVUJCUXKUXDUVLXOX
        PXQXSYDYEYFYEAUVDUVRUWDTSZNAUVDUVQUWCTYGSZUBUCVVFAFVVGUBAVVGUVJFAVVGBNU
        VPUWBTSZPUVJABNUVPUWBTUVQUWCYHOVSYJSZVVINYHMAUUAVCAUVPVVIMZUVENMZAUVPUV
        FUVNUVGOUEZOUEZVVIUVFUVNUVGOYKZAUVFVVLOVVIUWLVVLNMZOVVLUJQZVVLVVIMUWLUY
        JUWNVVOLVEUVNUVGONVFVGUWLUWNUYJVVPVELOUVGYLYMVVLYNYTOVVIMZAUWRRVVQUWNOO
        UJQVEUUBOYNUUCVCZYOYEZXQZAUWBVVIMVVKAUWBUVFUWAUVTOUEZOUEZVVIUVFUWAUVTOY
        KZAUVFVWAOVVIUWLVWANMZOVWAUJQZVWAVVIMUWLUVTNMZUWNVWDUWLUVGLWRZVEUWAUVTO
        NVFVGUWLUWNVWFVWEVEVWGOUVTYLYMVWAYNYTVVRYOYEXQZAUVQYPAUWCYPUUDABNVVHUVI
        AVVHVVMVWBTSZUVIUVPVVMUWBVWBTVVNVWCUUEAUVFVWIUVIVIZAUVFVWJUWLVVLVWATSZU
        VHVWIUVIUWLUYJVWKUVHVILUVGUUFUSUWLVVMVVLVWBVWATUVFVVMVVLVIAUVFVVLOVOVKU
        VFVWBVWAVIAUVFVWAOVOVKYQUVFUVIUVHVIAUXBVKUUGUUHUWROOTSOVWIUVIUUJUWRVVMO
        VWBOTUVFVVLOVLZUVFVWAOVLYQUWTUUTUUIYRUUKYSJUULUUMAUVQUWCABCNUVPVVIUWJUW
        KAVVJUVFVVSXQUWQUWRUVPOVIUWSUWRUVPVVMOVVNVWLYRUSABCUVPPBCVVLPUABCVVLUVP
        UVFUVNUVOUVGOUVFUVNUUNUUOVMABCUVGLUWHUUPUUQYFABNUVPVVIUVQVVTUVQVPVQAUVM
        UVSUWEUWGUURZABNUWBVVIUWCVWHUWCVPVQAUVMUVSUWEUWGUUSZUVAYSAUVRUWDVWMVWNU
        VBXSUVC $.
    $}
    iblabsnc.m $e |- ( ph -> ( x e. A |-> ( abs ` B ) ) e. MblFn ) $.
    $( Choice-free analogue of ~ iblabs .  As with ~ ibladdnc , a measurability
       hypothesis is needed.  (Contributed by Brendan Leahy, 7-Nov-2017.) $)
    iblabsnc $p |- ( ph -> ( x e. A |-> ( abs ` B ) ) e. L^1 ) $=
      ( cabs cfv cmpt wcel cr cc0 citg2 co caddc cle wbr ci cibl cmbf cpnf cicc
      cv cif wf cre cim wa cxr iblmbf syl mbfmptcl abscld rexrd absge0d elxrge0
      sylanbrc 0xr 0le0 mpbir2an a1i ifclda adantr eqid fmptd cof cvv cico reex
      wn recld recnd elrege0 0re imcld eqidd offval2 wceq iftrue oveq12d eqtr4d
      00id iffalse 3eqtr4a pm2.61i fveq2d iblcn mpbid simpld iblabsnclem simprd
      mpteq2i syl6req itg2addnc eqtrd readdcld eqeltrd cofr addge0d wral ax-icn
      cmul cc mulcl sylancr abstrid adantl replimd absmul c1 absi oveq1i syl5eq
      mulid2d eqtr2d oveq2d 3brtr4d ex pm2.61d1 ralrimivw mpbird itg2le syl3anc
      ofrfval2 itg2lecl iblpos mpbir2and ) ABCDIJZKZUALYKUBLBMBUEZCLZYJNUFZKZOJ
      ZMLZHAMNUCUDPZYOUGZBMYMDUHJZIJZDUIJZIJZQPZNUFZKZOJZMLYPUUGRSZYQABMYNYRYOA
      YNYRLYLMLZAYMYJNYRAYMUJZYJUKLNYJRSYJYRLUUJYJUUJDABCDEABCDKZUALZUUKUBLGUUK
      ULUMFUNZUOZUPUUJDUUMUQZYJURUSNYRLZAYMVLZUJZUUPNUKLNNRSZUTVANURVBVCZVDVEZY
      OVFVGZAUUGBMYMUUANUFZKZOJZBMYMUUCNUFZKZOJZQPZMAUUGUVDUVGQVHPZOJUVIAUUFUVJ
      OAUVJBMUVCUVFQPZKUUFABMUVCUVFQUVDUVGVINUCVJPZUVLMVILAVKVCZAUVCUVLLUUIAYMU
      UANUVLUUJUUAMLNUUARSUUAUVLLUUJYTUUJYTUUJDUUMVMZVNZUOZUUJYTUVOUQZUUAVOUSNU
      VLLZUURUVRNMLUUSVPVANVOVBVCZVDVEZAUVFUVLLUUIAYMUUCNUVLUUJUUCMLNUUCRSUUCUV
      LLUUJUUBUUJUUBUUJDUUMVQZVNZUOZUUJUUBUWBUQZUUCVOUSUVSVDVEZAUVDVRAUVGVRVSBM
      UVKUUEYMUVKUUEVTYMUVKUUDUUEYMUVCUUAUVFUUCQYMUUANWAYMUUCNWAWBYMUUDNWAZWCUU
      QNNQPNUVKUUEWDUUQUVCNUVFNQYMUUANWEYMUUCNWEWBYMUUDNWEZWFWGWNWOWHAUVDUVGAUV
      DUBLZUVEMLZABCDUHUVDEFGUVDVFZABCYTKUALZBCUUBKUALZAUULUWKUWLUJGABCDUUMWIWJ
      ZWKUVNWLZWKABMUVCUVLUVDUVTUWJVGAUWHUWIUWNWMZABMUVFUVLUVGUWEUVGVFZVGAUVGUB
      LUVHMLABCDUIUVGEFGUWPAUWKUWLUWMWMUWAWLWMZWPWQAUVEUVHUWOUWQWRWSAYSMYRUUFUG
      YOUUFRWTSZUUHUVBABMUUEYRUUFAUUEYRLUUIAYMUUDNYRUUJUUDUKLNUUDRSUUDYRLUUJUUD
      UUJUUAUUCUVPUWCWRUPUUJUUAUUCUVPUWCUVQUWDXAUUDURUSUUTVDVEZUUFVFVGAUWRYNUUE
      RSZBMXBAUWTBMAYMUWTAYMUWTUUJYTTUUBXDPZQPZIJZUUAUXAIJZQPZYNUUERUUJYTUXAUVO
      UUJTXELZUUBXELZUXAXELXCUWBTUUBXFXGXHUUJYNYJUXCYMYNYJVTAYMYJNWAXIUUJDUXBIU
      UJDUUMXJWHWQUUJUUEUUDUXEYMUUEUUDVTAUWFXIUUJUUCUXDUUAQUUJUXDTIJZUUCXDPZUUC
      UUJUXFUXGUXDUXIVTXCUWBTUUBXKXGUUJUXIXLUUCXDPUUCUXHXLUUCXDXMXNUUJUUCUUJUUC
      UWCVNXPXOXQXRWQXSXTUUQNNYNUUERUUSUUQVAVCYMYJNWEUWGXSYAYBABMYNUUERYOUUFVIY
      RYRUVMUVAUWSAYOVRAUUFVRYFYCYOUUFYDYEUUGYOYGYEABCYJUUNUUOYHYI $.
  $}

  ${
    $d k x A $.  $d k B $.  $d k x C $.  $d k x ph $.  $d x V $.
    itgmulc2nc.1 $e |- ( ph -> C e. CC ) $.
    itgmulc2nc.2 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgmulc2nc.3 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itgmulc2nc.m $e |- ( ph -> ( x e. A |-> ( C x. B ) ) e. MblFn ) $.
    ${
      $( Choice-free analogue of ~ iblmulc2 .  (Contributed by Brendan Leahy,
         17-Nov-2017.) $)
      iblmulc2nc $p |- ( ph -> ( x e. A |-> ( C x. B ) ) e. L^1 ) $=
        ( cmul co cmpt wcel cr cc0 cfv cle wbr wceq vk cibl cmbf cv ci cexp cre
        cdiv wa cif citg2 c3 cfz wral cpnf cicc wf cabs cim caddc cxr cc adantr
        ifan iblmbf syl mbfmptcl mulcld adantlr cz elfzelz ad2antlr ax-icn ine0
        wne expclz mp3an12 expne0i divcld recld ifcl sylancl rexrd max1 sylancr
        0re elxrge0 sylanbrc wn 0xr 0le0 mpbir2an a1i ifclda syl5eqel fmptd csn
        eqid cxp cof cico recnd imcld readdcld absge0d addge0d elrege0 cvv reex
        abscld eqidd offval2 iftrue oveq12d eqtr4d 00id iffalse 3eqtr4a pm2.61i
        mpteq2i syl6req fveq2d iblcn mpbid simpld iblabsnclem itg2addnc eqeltrd
        simprd eqtrd itg2mulc oveq2d adantl remulcld absi 3brtr4d breq1 syl3anc
        c1 oveq1i fconstmpt 3eqtr4d pm2.61dan mpteq2dv 3eqtr3d mulge0d ad2antrr
        mul01d cofr releabsd absdivd elfznn0 absexp syl5eq div1d 3eqtrd absmuld
        cn0 breqtrd mulcl abstrid replimd absmul syl6eq mulid2d eqtr2d lemul2ad
        letrd ifboth syl2anc pm2.61d1 syl5eqbr ralrimivw ofrfval2 mpbird itg2le
        1exp ex itg2lecl ralrimiva isibl2 mpbir2and ) ABCEDKLZMZUBNUWDUCNBOBUDZ
        CNZPUWCUEUAUDZUFLZUHLZUGQZRSZUIUWJPUJZMZUKQZONZUAPULUMLZUNJAUWOUAUWPAUW
        GUWPNZUIZOPUOUPLZUWMUQZBOUWFEURQZDUGQZURQZDUSQZURQZUTLZKLZPUJZMZUKQZONZ
        UWNUXJRSZUWOUWRBOUWLUWSUWMUWRUWEONZUIUWLUWFUWKUWJPUJZPUJZUWSUWFUWKUWJPV
        DZUWRUXOUWSNUXMUWRUWFUXNPUWSUWRUWFUIZUXNVANPUXNRSZUXNUWSNUXQUXNUXQUWJON
        ZPONZUXNONUXQUWIUXQUWCUWHAUWFUWCVBNUWQAUWFUIZEDAEVBNUWFGVCZABCDFABCDMZU
        BNZUYCUCNIUYCVEVFHVGZVHZVIZUXQUWGVJNZUWHVBNZUWQUYHAUWFUWGPULVKZVLZUEVBN
        ZUEPVOZUYHUYIVMVNUEUWGVPVQVFZUXQUYHUWHPVOZUYKUYLUYMUYHUYOVMVNUEUWGVRVQV
        FZVSZVTZWFUWKUWJPOWAWBWCUXQUXTUXSUXRWFUYRPUWJWDWEUXNWGWHPUWSNZUWRUWFWIZ
        UIUYSPVANPPRSZWJWKPWGWLZWMWNVCWOZUWMWRWPZAUXKUWQAUXJUXABOUWFUXCPUJZMZUK
        QZBOUWFUXEPUJZMZUKQZUTLZKLZOAOUXAWQWSZBOUWFUXFPUJZMZKWTLZUKQUXAVUOUKQZK
        LUXJVULAUXAVUOABOVUNPUOXALZVUOAVUNVURNUXMAUWFUXFPVURUYAUXFONPUXFRSUXFVU
        RNUYAUXCUXEUYAUXBUYAUXBUYADUYEVTZXBZXJZUYAUXDUYAUXDUYADUYEXCZXBZXJZXDZU
        YAUXCUXEVVAVVDUYAUXBVUTXEZUYAUXDVVCXEZXFZUXFXGWHPVURNZAUYTUIZVVIUXTVUAW
        FWKPXGWLWMZWNVCZVUOWRWPAVUQVUKOAVUQVUFVUIUTWTLZUKQVUKAVUOVVMUKAVVMBOVUE
        VUHUTLZMVUOABOVUEVUHUTVUFVUIXHVURVUROXHNZAXIWMZAVUEVURNUXMAUWFUXCPVURUY
        AUXCONPUXCRSUXCVURNVVAVVFUXCXGWHVVKWNVCZAVUHVURNUXMAUWFUXEPVURUYAUXEONP
        UXERSUXEVURNVVDVVGUXEXGWHVVKWNVCZAVUFXKAVUIXKXLBOVVNVUNUWFVVNVUNTUWFVVN
        UXFVUNUWFVUEUXCVUHUXEUTUWFUXCPXMUWFUXEPXMXNUWFUXFPXMZXOUYTPPUTLPVVNVUNX
        PUYTVUEPVUHPUTUWFUXCPXQUWFUXEPXQXNUWFUXFPXQZXRXSXTYAYBAVUFVUIAVUFUCNZVU
        GONZABCDUGVUFFHIVUFWRZABCUXBMUBNZBCUXDMUBNZAUYDVWDVWEUIIABCDUYEYCYDZYEV
        USYFZYEABOVUEVURVUFVVQVWCWPAVWAVWBVWGYIZABOVUHVURVUIVVRVUIWRZWPAVUIUCNV
        UJONABCDUSVUIFHIVWIAVWDVWEVWFYIVVBYFYIZYGYJZAVUGVUJVWHVWJXDZYHAUXAONZPU
        XARSZUXAVURNAEGXJZAEGXEZUXAXGWHYKAVUPUXIUKAVUPBOUXAVUNKLZMUXIABOUXAVUNK
        VUMVUOXHOVURVVPAVWMUXMVWOVCVVLVUMBOUXAMTABOUXAUUAWMAVUOXKXLABOVWQUXHAUW
        FVWQUXHTZUWFVWRAUWFVWQUXGUXHUWFVUNUXFUXAKVVSYLUWFUXGPXMZXOYMVVJUXAPKLZP
        VWQUXHAVWTPTUYTAUXAAUXAVWOXBUUHVCVVJVUNPUXAKUYTVUNPTAVVTYMYLUYTUXHPTAUW
        FUXGPXQZYMUUBUUCUUDYJYBAVUQVUKUXAKVWKYLUUEAUXAVUKVWOVWLYNYHVCUWRUWTOUWS
        UXIUQUWMUXIRUUISZUXLVUDUWRBOUXHUWSUXIAUXHUWSNUWQUXMAUWFUXGPUWSUYAUXGVAN
        PUXGRSZUXGUWSNUYAUXGUYAUXAUXFAVWMUWFVWOVCZVVEYNZWCUYAUXAUXFVXDVVEAVWNUW
        FVWPVCZVVHUUFZUXGWGWHUYSVVJVUBWMWNUUGZUXIWRWPUWRVXBUWLUXHRSZBOUNUWRVXIB
        OUWRUWLUXOUXHRUXPUWRUWFUXOUXHRSZUWRUWFVXJUXQUXNUXGUXOUXHRUXQUWJUXGRSZVX
        CUXNUXGRSZUXQUWJUXADURQZKLZUXGUYRAUWFVXNONUWQUYAUXAVXMVXDUYADUYEXJZYNVI
        AUWFUXGONUWQVXEVIUXQUWJUWIURQZVXNRUXQUWIUYQUUJUXQVXPUWCURQZVXNUXQVXPVXQ
        UWHURQZUHLZVXQYSUHLZVXQUXQUWCUWHUYGUYNUYPUUKUWQVXSVXTTAUWFUWQVXRYSVXQUH
        UWQVXRUEURQZUWGUFLZYSUWQUYLUWGUURNVXRVYBTVMUWGULUULUEUWGUUMWEUWQVYBYSUW
        GUFLZYSVYAYSUWGUFYOYTUWQUYHVYCYSTUYJUWGUVQVFUUNYJYLVLUXQVXQAUWFVXQVBNUW
        QUYAVXQUYAUWCUYFXJXBVIUUOUUPAUWFVXQVXNTUWQUYAEDUYBUYEUUQVIYJUUSAUWFVXNU
        XGRSUWQUYAVXMUXFUXAVXOVVEVXDVXFUYAUXBUEUXDKLZUTLZURQUXCVYDURQZUTLVXMUXF
        RUYAUXBVYDVUTUYAUYLUXDVBNZVYDVBNVMVVCUEUXDUUTWEUVAUYADVYEURUYADUYEUVBYB
        UYAUXEVYFUXCUTUYAVYFYSUXEKLZUXEUYAVYFVYAUXEKLZVYHUYAUYLVYGVYFVYITVMVVCU
        EUXDUVCWEVYAYSUXEKYOYTUVDUYAUXEUYAUXEVVDXBUVEUVFYLYPUVGVIUVHAUWFVXCUWQV
        XGVIUWKVXKVXCVXLUWJPUWJUXNUXGRYQPUXNUXGRYQUVIUVJUWFUXOUXNTUWRUWFUXNPXMY
        MUWFUXHUXGTUWRVWSYMYPUVRUYTPPUXOUXHRVUAUYTWKWMUWFUXNPXQVXAYPUVKUVLUVMUW
        RBOUWLUXHRUWMUXIXHUWSUWSVVOUWRXIWMVUCVXHUWRUWMXKUWRUXIXKUVNUVOUWMUXIUVP
        YRUXJUWMUVSYRUVTABCUWCUWJUAUWMVBAUWMXKUYAUWJXKUYFUWAUWB $.
    $}

    ${
      itgmulc2nc.4 $e |- ( ph -> C e. RR ) $.
      itgmulc2nc.5 $e |- ( ( ph /\ x e. A ) -> B e. RR ) $.
      ${
        itgmulc2nc.6 $e |- ( ph -> 0 <_ C ) $.
        itgmulc2nc.7 $e |- ( ( ph /\ x e. A ) -> 0 <_ B ) $.
        $( Lemma for ~ itgmulc2nc ; cf. ~ itgmulc2lem1 .  (Contributed by
           Brendan Leahy, 17-Nov-2017.) $)
        itgmulc2nclem1 $p |- ( ph ->
          ( C x. S. A B _d x ) = S. A ( C x. B ) _d x ) $=
          ( cr wcel cc0 cmpt cmul co cv cif citg2 cfv citg csn cxp cpnf cico wa
          cof cle wbr elrege0 sylanbrc 0re 0le0 mpbir2an a1i ifclda adantr eqid
          wn fmptd cmbf cibl iblpos mpbid simprd itg2mulc cvv cc reex fconstmpt
          wceq eqidd offval2 oveq2 mul01d ifeq2d syl5eq mpteq2dva fveq2d eqtr3d
          ifsb eqtrd itgposval oveq2d remulcld iblmulc2nc mulge0d 3eqtr4d ) AEB
          OBUAZCPZDQUBZRZUCUDZSTZBOWNEDSTZQUBZRZUCUDZEBCDUEZSTBCWSUEAOEUFUGZWPS
          UKTZUCUDWRXBAEWPABOWOQUHUITZWPAWOXFPWMOPZAWNDQXFAWNUJZDOPQDULUMDXFPLN
          DUNUOQXFPZAWNVCUJXIQOPQQULUMUPUQQUNURUSUTVAZWPVBVDABCDRZVEPZWQOPZAXKV
          FPXLXMUJIABCDLNVGVHVIAEOPZQEULUMZEXFPKMEUNUOVJAXEXAUCAXEBOEWOSTZRXAAB
          OEWOSXDWPVKVLXFOVKPAVMUSAEVLPXGGVAXJXDBOERVOABOEVNUSAWPVPVQABOXPWTAXG
          UJZXPWNWSEQSTZUBWTWNDQXPWSXRWODESVRWOQESVRWEXQWNXRQWSAXRQVOXGAEGVSVAV
          TWAWBWFWCWDAXCWQESABCDLINWGWHABCWSXHEDAXNWNKVAZLWIABCDEFGHIJWJXHEDXSL
          AXOWNMVANWKWGWL $.
      $}

      $( Lemma for ~ itgmulc2nc ; cf. ~ itgmulc2lem2 .  (Contributed by Brendan
         Leahy, 19-Nov-2017.) $)
      itgmulc2nclem2 $p |- ( ph ->
        ( C x. S. A B _d x ) = S. A ( C x. B ) _d x ) $=
        ( cmul co citg cc0 cmin wcel cr cmpt cle wbr cif cneg cv wa max0sub syl
        wceq oveq1d adantr cc 0re ifcl sylancl renegcld subdird eqtr3d itgeq2dv
        recnd cvv ovex a1i csn cxp cof cmbf cvol mbfdm2 fconstmpt eqidd offval2
        cdm cibl iblmbf fmptd mbfmulc2re eqeltrrd iblmulc2nc mpteq2dva itgsubnc
        eqid iblre mpbid simpld mbfpos simprd mbfneg oveq2d eqtrd itgreval max1
        subdid sylancr itgmulc2nclem1 oveq12d 3eqtrd 3eqtr4d 3eqtr2d 3eqtrrd
        itgcl ) ABCEDMNZOBCPEUAUBZEPUCZDMNZPEUDZUAUBZXFPUCZDMNZQNZOBCXEOZBCXIOZ
        QNZEBCDOZMNZABCXBXJABUECRZUFZXDXHQNZDMNZXBXJAXSXBUIXPAXREDMAESRZXREUIKE
        UGUHZUJUKXQXDXHDAXDULRXPAXDAXTPSRZXDSRZKUMXCEPSUNUOZUTZUKZAXHULRXPAXHAX
        FSRZYBXHSRZAEKUPZUMXGXFPSUNUOZUTZUKZXQDLUTZUQURZUSABCXEXIVAXEVARXQXDDMV
        BVCABCDXDSYELIACXDVDVEZBCDTZMVFZNZBCXETZVGABCXDDMYOYPVHVMZSSABCXBVAJXBV
        ARXQEDMVBVCVIZAYCXPYDUKZLYOBCXDTUIABCXDVJVCZAYPVKZVLZACXDYPAYPVNRZYPVGR
        IYPVOUHZYDABCDULYPYMYPWBVPZVQZVRVSXIVARXQXHDMVBVCABCDXHSYKLIACXHVDVEZYP
        YQNZBCXITZVGABCXHDMUUJYPYTSSUUAAYHXPYJUKZLUUJBCXHTUIABCXHVJVCZUUDVLZACX
        HYPUUGYJUUHVQZVRVSABCXBTBCXJTVGABCXBXJYNVTJVRWAAXMXDXNMNZXHXNMNZQNXRXNM
        NXOAXKUUQXLUURQABCXDPDUAUBZDPUCZMNZXDPDUDZUAUBZUVBPUCZMNZQNZOBCUVAOZBCU
        VEOZQNZXKUUQABCUVAUVEVAUVAVARXQXDUUTMVBVCABCUUTXDSYEXQDSRZYBUUTSRLUMUUS
        DPSUNUOZABCUUTTZVNRZBCUVDTZVNRZAUUFUVMUVOUFIABCDLWCWDZWEZAYOUVLYQNBCUVA
        TVGABCXDUUTMYOUVLYTSSUUAUUBUVKUUCAUVLVKZVLACXDUVLABCDLUUGWFZYDABCUUTULU
        VLXQUUTUVKUTZUVLWBVPZVQVRZVSUVEVARXQXDUVDMVBVCABCUVDXDSYEXQUVBSRZYBUVDS
        RXQDLUPZUMUVCUVBPSUNUOZAUVMUVOUVPWGZAYOUVNYQNBCUVETVGABCXDUVDMYOUVNYTSS
        UUAUUBUWEUUCAUVNVKZVLACXDUVNABCUVBUWDABCDSLUUGWHWFZYDABCUVDULUVNXQUVDUW
        EUTZUVNWBVPZVQVRZVSAYRBCUVFTZVGAYRYSUWLUUEABCXEUVFXQXDUUTUVDQNZMNXEUVFX
        QUWMDXDMXQUVJUWMDUILDUGUHZWIXQXDUUTUVDYFUVTUWIWMURZVTWJUUIVRWAABCXEUVFU
        WOUSAUUQXDBCUUTOZBCUVDOZQNZMNXDUWPMNZXDUWQMNZQNUVIAXNUWRXDMABCDLIWKZWIA
        XDUWPUWQYEABCUUTSUVKUVQXAZABCUVDSUWEUWFXAZWMAUWSUVGUWTUVHQABCUUTXDSYEUV
        KUVQUWBYDUVKAYBXTPXDUAUBUMKPEWLWNZXQYBUVJPUUTUAUBUMLPDWLWNZWOABCUVDXDSY
        EUWEUWFUWKYDUWEUXDXQYBUWCPUVDUAUBUMUWDPUVBWLWNZWOWPWQWRABCXHUUTMNZXHUVD
        MNZQNZOBCUXGOZBCUXHOZQNZXLUURABCUXGUXHVAUXGVARXQXHUUTMVBVCABCUUTXHSYKUV
        KUVQAUUJUVLYQNBCUXGTVGABCXHUUTMUUJUVLYTSSUUAUUMUVKUUNUVRVLACXHUVLUVSYJU
        WAVQVRZVSUXHVARXQXHUVDMVBVCABCUVDXHSYKUWEUWFAUUJUVNYQNBCUXHTVGABCXHUVDM
        UUJUVNYTSSUUAUUMUWEUUNUWGVLACXHUVNUWHYJUWJVQVRZVSAUUKBCUXITZVGAUUKUULUX
        OUUOABCXIUXIXQXHUWMMNXIUXIXQUWMDXHMUWNWIXQXHUUTUVDYLUVTUWIWMURZVTWJUUPV
        RWAABCXIUXIUXPUSAUURXHUWRMNXHUWPMNZXHUWQMNZQNUXLAXNUWRXHMUXAWIAXHUWPUWQ
        YKUXBUXCWMAUXQUXJUXRUXKQABCUUTXHSYKUVKUVQUXMYJUVKAYBYGPXHUAUBUMYIPXFWLW
        NZUXEWOABCUVDXHSYKUWEUWFUXNYJUWEUXSUXFWOWPWQWRWPAXDXHXNYEYKABCDSLIXAUQA
        XREXNMYAUJWSWT $.
    $}

    $( Choice-free analogue of ~ itgmulc2 .  (Contributed by Brendan Leahy,
       19-Nov-2017.) $)
    itgmulc2nc $p |- ( ph -> ( C x. S. A B _d x ) = S. A ( C x. B ) _d x ) $=
      ( ci cmul co caddc citg cc wcel cmpt cmbf cr vk cre cfv cim cneg cv recld
      wa recnd adantr iblmbf syl mbfmptcl mulcld iblcn mpbid simpld csn cxp cof
      cibl cvol cdm cvv ovex a1i mbfdm2 wceq fconstmpt eqidd offval2 eqid fmptd
      mbfmulc2re eqeltrrd iblmulc2nc itgcl ax-icn imcld simprd sylancr renegcld
      mulcl negcld adddird itgcnval oveq2d adddid itgmulc2nclem2 mul12d oveq12d
      add4d eqtrd 3eqtrd mulassd mul4d ixi oveq1i mulm1d syl5eq mulneg1d eqtr3d
      c1 addcomd cmin ccom wf ref feqmptd fveq2 fmptco remuld mpteq2dva ismbfcn
      wb itgsubnc itgeq2dv itgneg eqtr4d negsubd 3eqtr4d immuld itgaddnc oveq1d
      imf replimd ) AEUBUCZKEUDUCZLMZNMZBCDOZLMZBCEDLMZUBUCZOZKBCYMUDUCZOZLMZNM
      ZEYKLMBCYMOABCYGDUBUCZLMZOZKBCYGDUDUCZLMZOZLMZNMZBCYHUEZUUCLMZOZKBCYHYTLM
      ZOZLMZNMZNMZUUBUUJNMZUUFUUMNMZNMYLYSAUUBUUFUUJUUMABCUUAPABUFCQZUHZYGYTAYG
      PQUURAYGAEGUGZUIZUJZUUSYTUUSDABCDFABCDRZVAQZUVCSQIUVCUKULHUMZUGZUIZUNZABC
      YTYGTUVAUVFABCYTRZVAQZBCUUCRZVAQZAUVDUVJUVLUHIABCDUVEUOUPZUQZACYGURUSZUVI
      LUTZMBCUUARSABCYGYTLUVOUVIVBVCZPTABCYMVDJYMVDQUUSEDLVEVFVGZUVBUVFUVOBCYGR
      VHABCYGVIVFZAUVIVJZVKACYGUVIAUVJUVISQUVNUVIUKULZUUTABCYTPUVIUVGUVIVLVMZVN
      VOZVPZVQZAKPQZUUEPQUUFPQVRABCUUDPUUSYGUUCUVBUUSUUCUUSDUVEVSZUIZUNZABCUUCY
      GTUVAUWGAUVJUVLUVMVTZAUVOUVKUVPMBCUUDRSABCYGUUCLUVOUVKUVQPTUVRUVBUWGUVSAU
      VKVJZVKACYGUVKAUVLUVKSQUWJUVKUKULZUUTABCUUCPUVKUWHUVKVLVMZVNVOZVPZVQZKUUE
      WCWAABCUUIPUUSUUHUUCAUUHPQUURAYHAYHAEGVSZUIZWDZUJZUWHUNABCUUCUUHTUWSUWGUW
      JACUUHURUSZUVKUVPMBCUUIRSABCUUHUUCLUXAUVKUVQPTUVRUWTUWGUXABCUUHRVHABCUUHV
      IVFUWKVKACUUHUVKUWLAYHUWQWBZUWMVNVOZVPVQZAUWFUULPQUUMPQVRABCUUKPUUSYHYTAY
      HPQUURUWRUJZUVGUNZABCYTYHTUWRUVFUVNACYHURUSZUVIUVPMBCUUKRSABCYHYTLUXGUVIU
      VQPTUVRUXEUVFUXGBCYHRVHABCYHVIVFZUVTVKACYHUVIUWAUWQUWBVNVOZVPZVQZKUULWCWA
      ZWLAYLYGYKLMZYIYKLMZNMUUOAYGYIYKUVAAKYHUWFAVRVFZUWRUNZABCDFHIVQWEAUXMUUGU
      XNUUNNAUXMYGBCYTOZKBCUUCOZLMZNMZLMYGUXQLMZYGUXSLMZNMUUGAYKUXTYGLABCDFHIWF
      ZWGAYGUXQUXSUVAABCYTTUVFUVNVQZAUWFUXRPQUXSPQVRABCUUCTUWGUWJVQZKUXRWCWAZWH
      AUYAUUBUYBUUFNABCYTYGTUVAUVFUVNUWCUUTUVFWIAUYBKYGUXRLMZLMUUFAYGKUXRUVAUXO
      UYEWJAUYGUUEKLABCUUCYGTUVAUWGUWJUWNUUTUWGWIWGWMWKWNAUXNYIUXTLMYIUXQLMZYIU
      XSLMZNMZUUNAYKUXTYILUYCWGAYIUXQUXSUXPUYDUYFWHAUYJUUMUUJNMUUNAUYHUUMUYIUUJ
      NAUYHKYHUXQLMZLMUUMAKYHUXQUXOUWRUYDWOAUYKUULKLABCYTYHTUWRUVFUVNUXIUWQUVFW
      IWGWMAUYIKKLMZYHUXRLMZLMZUYMUEZUUJAKYHKUXRUXOUWRUXOUYEWPAUYNXCUEZUYMLMUYO
      UYLUYPUYMLWQWRAUYMAYHUXRUWRUYEUNWSWTAUUHUXRLMUYOUUJAYHUXRUWRUYEXAABCUUCUU
      HTUWSUWGUWJUXCUXBUWGWIXBWNWKAUUMUUJUXLUXDXDWMWNWKWMAYOUUPYRUUQNABCUUAYHUU
      CLMZXEMZOUUBBCUYQOZXEMZYOUUPABCUUAUYQPUVHUWDUUSYHUUCUXEUWHUNZABCUUCYHTUWR
      UWGUWJAUXGUVKUVPMBCUYQRSABCYHUUCLUXGUVKUVQPTUVRUXEUWGUXHUWKVKACYHUVKUWLUW
      QUWMVNVOVPZAUBBCYMRZXFZBCUYRRZSAVUDBCYNRVUEABUACPYMUAUFZUBUCYNVUCUBUUSEDA
      EPQUURGUJZUVEUNZAVUCVJZAUAPTUBPTUBXGAXHVFXIVUFYMUBXJXKABCYNUYRUUSEDVUGUVE
      XLZXMWMAVUDSQZUDVUCXFZSQZAVUCSQZVUKVUMUHZJACPVUCXGVUNVUOXOABCYMPVUCVUHVUC
      VLVMCVUCXNULUPZUQVOXPABCYNUYRVUJXQAUUBUYSUEZNMUUPUYTAVUQUUJUUBNAVUQBCUYQU
      EZOUUJABCUYQPVUAVUBXRABCUUIVURUUSYHUUCUXEUWHXAXQXSWGAUUBUYSUWEABCUYQPVUAV
      UBVQXTXBYAAYRKUUEUULNMZLMUUQAYQVUSKLAYQBCUUDUUKNMZOVUSABCYPVUTUUSEDVUGUVE
      YBZXQABCUUDUUKPUWIUWOUXFUXJAVULBCVUTRZSAVULBCYPRVVBABUACPYMVUFUDUCYPVUCUD
      VUHVUIAUAPTUDPTUDXGAYEVFXIVUFYMUDXJXKABCYPVUTVVAXMWMAVUKVUMVUPVTVOYCWMWGA
      KUUEUULUXOUWPUXKWHWMWKYAAEYJYKLAEGYFYDABCYMPVUHABCDEFGHIJVPWFYA $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y ph $.  $d x y V $.
    itgabsnc.1 $e |- ( ( ph /\ x e. A ) -> B e. V ) $.
    itgabsnc.2 $e |- ( ph -> ( x e. A |-> B ) e. L^1 ) $.
    itgabsnc.m1 $e |- ( ph -> ( x e. A |-> ( abs ` B ) ) e. MblFn ) $.
    itgabsnc.m2 $e |- ( ph ->
      ( y e. A |-> ( ( * ` S. A B _d x ) x. [_ y / x ]_ B ) ) e. MblFn ) $.
    $( Choice-free analogue of ~ itgabs .  (Contributed by Brendan Leahy,
       19-Nov-2017.)  (Revised by Brendan Leahy, 19-Jun-2018.) $)
    itgabsnc $p |- ( ph ->
      ( abs ` S. A B _d x ) <_ S. A ( abs ` B ) _d x ) $=
      ( cc0 citg cabs cfv cmul co cmpt wcel cc cr clt wbr cle wa ccj cv csb cre
      wceq cibl cim itgcl cjcld wral cmbf iblmbf syl mbfmptcl ralrimiva nfcsb1v
      nfv nfel1 weq csbeq1a eleq1d cbvral sylib r19.21bi nfcv cbvmpt iblmulc2nc
      syl5eqelr adantr mulcld iblcn mpbid simpld csn cxp absmuld mpteq2dva cvol
      cof cdm mbfdm2 abscld fconstmpt a1i nffv fveq2d offval2 eqtr4d recnd eqid
      fmptd mbfmulc2re eqeltrd iblabsnc recld releabsd c2 cexp sqvald absvalsqd
      itgle mulcomd cbvitg oveq2i itgmulc2nc syl5eq 3eqtrd rered cvv ovex itgre
      resqcld 3eqtr3d eqtr3d eqeltrrd abscjd oveq1d itgeq2dv 3brtr4d wb itgrecl
      eqtrd simpr lemul2 syl112anc mpbird ex absge0d itgge0 breq1 syl5ibcom 0re
      wo leloe sylancr mpjaod ) AKBDELZMNZUAUBZUUBBDEMNZLZUCUBZKUUBUIZAUUCUUFAU
      UCUDZUUFUUBUUBOPZUUBUUEOPZUCUBZAUUKUUCACDUUAUENZBCUFZEUGZOPZUHNZLZCDUUOMN
      ZLZUUIUUJUCACDUUPUURACDUUPQUJRZCDUUOUKNQUJRZACDUUOQUJRUUTUVAUDACDUUNUULSA
      UUAABDEFGHULZUMZAUUNSRZCDAESRZBDUNUVDCDUNAUVEBDABDEFABDEQZUJRUVFUORHUVFUP
      UQZGURZUSUVEUVDBCDUVECVABUUNSBUUMEUTZVBBCVCZEUUNSBUUMEVDZVEVFVGVHZACDUUNQ
      UVFUJBCDEUUNCEVIZUVIUVKVJHVLZJVKZACDUUOAUUMDRZUDZUULUUNAUULSRUVPUVCVMZUVL
      VNZVOVPVQACDUUOSUVSUVOACDUURQZDUULMNZVRVSZBDUUDQZOWCZPZUOAUVTCDUWAUUNMNZO
      PZQUWEACDUURUWGUVQUULUUNUVRUVLVTZWAACDUWAUWFOUWBUWCWBWDZTTABDEFUVGGWEZUVQ
      UULUVRWFUVQUUNUVLWFZUWBCDUWAQUIACDUWAWGWHUWCCDUWFQZUIABCDUUDUWFCUUDVIZBUU
      NMBMVIUVIWIZUVJEUUNMUVKWJZVJZWHZWKWLADUWAUWCIAUULUVCWFABDUUDSUWCABUFDRUDZ
      UUDUWREUVHWFZWMUWCWNWOZWPWQWRUVQUUOUVSWSUVQUUOUVSWFUVQUUOUVSWTXEAUUBXAXBP
      ZUUIUUQAUUBAUUBAUUAUVBWFZWMZXCAUXAUHNCDUUOLZUHNUXAUUQAUXAUXDUHAUXAUUAUULO
      PUULUUAOPZUXDAUUAUVBXDAUUAUULUVBUVCXFAUXEUULCDUUNLZOPUXDUUAUXFUULOBCDEUUN
      UVKUVMUVIXGXHACDUUNUULSUVCUVLUVNJXIXJXKWJAUXAAUUBUXBXPXLACDUUOXMUUOXMRUVQ
      UULUUNOXNWHUVOXOXQXRAUUJUUBCDUWFLZOPZUUSUUEUXGUUBOBCDUUDUWFUWOUWMUWNXGXHA
      UXHCDUUBUWFOPZLUUSACDUWFUUBTUXCUWKAUWLUWCUJUWPABDEFGHIWRZVLADUUBVRVSZUWCU
      WDPCDUXIQUOACDUUBUWFOUXKUWCUWITTUWJAUUBTRZUVPUXBVMUWKUXKCDUUBQUIACDUUBWGW
      HUWQWKADUUBUWCIUXBUWTWPXSXIACDUURUXIUVQUURUWGUXIUWHUVQUWAUUBUWFOUVQUUAAUU
      ASRUVPUVBVMXTYAYFYBWLXJYCVMUUHUXLUUETRZUXLUUCUUFUUKYDAUXLUUCUXBVMZAUXMUUC
      ABDUUDUWSUXJYEVMUXNAUUCYGUUBUUEUUBYHYIYJYKAKUUEUCUBUUGUUFABDUUDUXJUWSUWRE
      UVHYLYMKUUBUUEUCYNYOAKUUBUCUBZUUCUUGYQZAUUAUVBYLAKTRUXLUXOUXPYDYPUXBKUUBY
      RYSVPYT $.
  $}

  ${
    $d x y z F $.  $d x y A $.  $d x y B $.
    $( Choice-free proof of ~ bddibl .  (Contributed by Brendan Leahy,
       2-Nov-2017.)  (Revised by Brendan Leahy, 6-Nov-2017.) $)
    bddiblnc $p |- ( ( F e. MblFn /\ ( vol ` dom F ) e. RR /\
      E. x e. RR A. y e. dom F ( abs ` ( F ` y ) ) <_ x ) -> F e. L^1 ) $=
      ( vz wcel cfv cr cabs cle wbr cmpt wceq wa cc0 syl3anc eqid breq1 3brtr4d
      c0 cif cmbf cdm cvol cv wral wrex cibl mbff feqmptd 3ad2ant1 rzal mpteq12
      w3a cc mpdan csn cxp fconstmpt 0mbl ax-mp eqeltrri syl6eqel adantl r19.2z
      ibl0 wne anim1i an31s wi ad2antrr ffvelrnda absge0d 0re a1i abscld simplr
      wf letr mpand rexlimdva ex com23 imp32 sylan2 anassrs an32 cre citg2 cneg
      cim id eqeltrrd cpnf cicc co ad3antrrr recld rexrd adantrr simprr elxrge0
      cxr sylanbrc wn 0xr 0le0 mpbir2an ifclda fmptd cmul cico biimpri ad2antrl
      mbfdm eqeltrd adantr adantll letrd ifboth syl2anc iftrue iffalse pm2.61d1
      ifan syl5eqbr ralrimivw cvv eqidd ofrfval2 mpbird itg2lecl renegcld recnd
      itg2le leabsd absnegd breqtrd syl jca imcld elrege0 simprll remulcld cofr
      itg2const rexr sylan sylancl releabsd fveq2 fveq2d breq1d rspccva simprlr
      ifcl weq absrele absimle iblcnlem1 mpbir3and syldan pm2.61dane rexlimdvaa
      reex sylan2b 3impia ) CUAEZCUBZUCFZGEZBUDZCFZHFZAUDZIJZBUVHUEZAGUFZUMCDUV
      HDUDZCFZKZUGUVGUVJCUVTLUVQUVGDUVHUNCCUHZUIZUJUVGUVJUVQUVTUGEZUVGUVJMZUVPU
      WCAGUWDUVNGEZUVPMZMZUWCUVHSUVHSLZUWCUWGUWHUVTDSNKZUGUWHUVSNLZDUVHUEUVTUWI
      LUWJDUVHUKDUVHUVSSNULUOSNUPUQZUWIUGDSNURSUCUBZEUWKUGEUSSVEUTVAVBVCUWGUVHS
      VFZNUVNIJZUWCUWDUWFUWMUWNUWFUWMMUWDUVOBUVHUFZUWEMZUWNUWMUVPUWEUWPUWMUVPMU
      WOUWEUVOBUVHVDVGVHUWDUWOUWEUWNUWDUWEUWOUWNUWDUWEUWOUWNVIUWDUWEMZUVOUWNBUV
      HUWQUVKUVHEZMZNUVMIJZUVOUWNUWSUVLUWQUVHUNUVKCUVGUVHUNCVQZUVJUWEUWAVJVKZVL
      UWSNGEZUVMGEUWEUWTUVOMUWNVIUXCUWSVMVNUWSUVLUXBVOUWDUWEUWRVPNUVMUVNVROVSVT
      WAWBWCWDWEUWDUWFUWNUWCUWFUWNMUWDUWEUWNMZUVPMZUWCUWEUVPUWNWFUWDUXEMZUWCUVT
      UAEZDGUVRUVHEZNUVSWGFZIJZMZUXINTZKZWHFZGEZDGUXHNUXIWIZIJZMZUXPNTZKZWHFZGE
      ZMDGUXHNUVSWJFZIJZMZUYCNTZKZWHFZGEZDGUXHNUYCWIZIJZMZUYJNTZKZWHFZGEZMUVGUX
      GUVJUXEUVGCUVTUAUWBUVGWKWLVJUXFUXOUYBUXFGNWMWNWOZUXMVQZDGUXHUVNNTZKZWHFZG
      EZUXNVUAIJZUXOUXFDGUXLUYQUXMUXFUVRGEZMZUXKUXINUYQVUEUXKMUXIXBEZUXJUXIUYQE
      VUEUXHVUFUXJVUEUXHMZUXIVUGUVSVUEUVHUNUVRCUVGUXAUVJUXEVUDUWAWPVKZWQZWRWSVU
      EUXHUXJWTUXIXAXCNUYQEZVUEUXKXDMVUJNXBENNIJZXEXFNXAXGZVNXHZUXMPXIZUXFVUAUV
      NUVIXJWOZGUXFUVHUWLEZUVJUVNNWMXKWOEZVUAVUOLUVGVUPUVJUXECXNVJUVGUVJUXEVPZU
      XDVUQUWDUVPVUQUXDUVNUUAXLXMDUVHUVNUUEOUXFUVNUVIUWDUWEUWNUVPUUBZVURUUCXOZU
      XFUYRGUYQUYTVQZUXMUYTIUUDZJZVUCVUNUXFDGUYSUYQUYTVUEUVNUYQEZVUJUYSUYQEUXFV
      VDVUDUXDVVDUWDUVPUWEUVNXBEZUWNVVDUVNUUFVVDVVEUWNMUVNXAXLUUGXMXPVULUXHUVNN
      UYQUUOUUHZUYTPXIZUXFVVCUXLUYSIJZDGUEUXFVVHDGUXFUXLUXHUXJUXINTZNTZUYSIUXHU
      XJUXINYDUXFUXHVVJUYSIJZUXFUXHVVKUXFUXHMZVVIUVNVVJUYSIVVLUXIUVNIJZUWNVVIUV
      NIJZVVLUXIUVSHFZUVNVVLUVSUXFUVHUNUVRCUVGUXAUVJUXEUWAVJVKZWQZVVLUVSVVPVOZU
      XFUWEUXHVUSXPZVVLUVSVVPUUIUXEUXHVVOUVNIJZUWDUVPUXHVVTUXDUVOVVTBUVRUVHBDUU
      PZUVMVVOUVNIVWAUVLUVSHUVKUVRCUUJUUKUULUUMXQXQZXRUXFUWNUXHUWDUWEUWNUVPUUNX
      PZUXJVVMUWNVVNUXINUXIVVIUVNIQNVVIUVNIQXSXTUXHVVJVVILUXFUXHVVINYAVCUXHUYSU
      VNLUXFUXHUVNNYAVCZRWAUXHXDZNNVVJUYSIVUKVWEXFVNZUXHVVINYBUXHUVNNYBZRYCYEYF
      UXFDGUXLUYSIUXMUYTYGUYQUYQGYGEUXFUVDVNZVUMVVFUXFUXMYHUXFUYTYHZYIYJUXMUYTY
      NOVUAUXMYKOUXFGUYQUXTVQZVUBUYAVUAIJZUYBUXFDGUXSUYQUXTVUEUXRUXPNUYQVUEUXRM
      UXPXBEZUXQUXPUYQEVUEUXHVWLUXQVUGUXPVUGUXIVUIYLWRWSVUEUXHUXQWTUXPXAXCVUJVU
      EUXRXDMVULVNXHZUXTPXIZVUTUXFVWJVVAUXTUYTVVBJZVWKVWNVVGUXFVWOUXSUYSIJZDGUE
      UXFVWPDGUXFUXSUXHUXQUXPNTZNTZUYSIUXHUXQUXPNYDUXFUXHVWRUYSIJZUXFUXHVWSVVLV
      WQUVNVWRUYSIVVLUXPUVNIJZUWNVWQUVNIJZVVLUXPVVOUVNVVLUXIVVQYLZVVRVVSVVLUXPU
      XIHFZVVOVXBVVLUXIVVLUXIVVQYMZVOVVRVVLUXPUXPHFVXCIVVLUXPVXBYOVVLUXIVXDYPYQ
      VVLUVSUNEZVXCVVOIJVVPUVSUUQYRXRVWBXRVWCUXQVWTUWNVXAUXPNUXPVWQUVNIQNVWQUVN
      IQXSXTUXHVWRVWQLUXFUXHVWQNYAVCVWDRWAVWENNVWRUYSIVWFUXHVWQNYBVWGRYCYEYFUXF
      DGUXSUYSIUXTUYTYGUYQUYQVWHVWMVVFUXFUXTYHVWIYIYJUXTUYTYNOVUAUXTYKOYSUXFUYI
      UYPUXFGUYQUYGVQZVUBUYHVUAIJZUYIUXFDGUYFUYQUYGVUEUYEUYCNUYQVUEUYEMUYCXBEZU
      YDUYCUYQEVUEUXHVXHUYDVUGUYCVUGUVSVUHYTZWRWSVUEUXHUYDWTUYCXAXCVUJVUEUYEXDM
      VULVNXHZUYGPXIZVUTUXFVXFVVAUYGUYTVVBJZVXGVXKVVGUXFVXLUYFUYSIJZDGUEUXFVXMD
      GUXFUYFUXHUYDUYCNTZNTZUYSIUXHUYDUYCNYDUXFUXHVXOUYSIJZUXFUXHVXPVVLVXNUVNVX
      OUYSIVVLUYCUVNIJZUWNVXNUVNIJZVVLUYCVVOUVNVVLUVSVVPYTZVVRVVSVVLUYCUYCHFZVV
      OVXSVVLUYCVVLUYCVXSYMZVOZVVRVVLUYCVXSYOVVLVXEVXTVVOIJVVPUVSUURYRZXRVWBXRV
      WCUYDVXQUWNVXRUYCNUYCVXNUVNIQNVXNUVNIQXSXTUXHVXOVXNLUXFUXHVXNNYAVCVWDRWAV
      WENNVXOUYSIVWFUXHVXNNYBVWGRYCYEYFUXFDGUYFUYSIUYGUYTYGUYQUYQVWHVXJVVFUXFUY
      GYHVWIYIYJUYGUYTYNOVUAUYGYKOUXFGUYQUYNVQZVUBUYOVUAIJZUYPUXFDGUYMUYQUYNVUE
      UYLUYJNUYQVUEUYLMUYJXBEZUYKUYJUYQEVUEUXHVYFUYKVUGUYJVUGUYCVXIYLWRWSVUEUXH
      UYKWTUYJXAXCVUJVUEUYLXDMVULVNXHZUYNPXIZVUTUXFVYDVVAUYNUYTVVBJZVYEVYHVVGUX
      FVYIUYMUYSIJZDGUEUXFVYJDGUXFUYMUXHUYKUYJNTZNTZUYSIUXHUYKUYJNYDUXFUXHVYLUY
      SIJZUXFUXHVYMVVLVYKUVNVYLUYSIVVLUYJUVNIJZUWNVYKUVNIJZVVLUYJVVOUVNVVLUYCVX
      SYLZVVRVVSVVLUYJVXTVVOVYPVYBVVRVVLUYJUYJHFVXTIVVLUYJVYPYOVVLUYCVYAYPYQVYC
      XRVWBXRVWCUYKVYNUWNVYOUYJNUYJVYKUVNIQNVYKUVNIQXSXTUXHVYLVYKLUXFUXHVYKNYAV
      CVWDRWAVWENNVYLUYSIVWFUXHVYKNYBVWGRYCYEYFUXFDGUYMUYSIUYNUYTYGUYQUYQVWHVYG
      VVFUXFUYNYHVWIYIYJUYNUYTYNOVUAUYNYKOYSUXFDUVHUVSUXNUYAUYHUYOUXNPUYAPUYHPU
      YOPVVPUUSUUTUVEWEUVAUVBUVCUVFXO $.

    $( Choice-free proof of ~ cniccibl .  (Contributed by Brendan Leahy,
       2-Nov-2017.) $)
    cnicciblnc $p |- ( ( A e. RR /\ B e. RR /\
      F e. ( ( A [,] B ) -cn-> CC ) ) -> F e. L^1 ) $=
      ( vy vx cr wcel cicc co cc ccncf w3a cmbf cdm cvol cfv wral wrex 3adant3
      cv cabs cle wbr cibl iccmbl simp3 cnmbf syl2anc wf wceq cncff 3syl fveq2d
      fdm iccvolcl eqeltrd cniccbdd raleqdv rexbidv mpbird bddiblnc syl3anc ) A
      FGZBFGZCABHIZJKIGZLZCMGZCNZOPZFGDTCPUAPETUBUCZDVIQZEFRZCUDGVGVEONGZVFVHVC
      VDVNVFABUESVCVDVFUFZVECUGUHVGVJVEOPZFVGVIVEOVGVFVEJCUIVIVEUJVOVEJCUKVEJCU
      NULZUMVCVDVPFGVFABUOSUPVGVMVKDVEQZEFREDABCUQVGVLVREFVGVKDVIVEVQURUSUTEDCV
      AVB $.
  $}

  ${
    $d x y X $.  $d x y Y $.  $d y B $.  $d x y ph $.
    itggt0cn.1 $e |- ( ph -> X < Y ) $.
    itggt0cn.2 $e |- ( ph -> ( x e. ( X (,) Y ) |-> B ) e. L^1 ) $.
    itggt0cn.3 $e |- ( ( ph /\ x e. ( X (,) Y ) ) -> B e. RR+ ) $.
    itggt0cn.cn $e |- ( ph ->
      ( x e. ( X (,) Y ) |-> B ) e. ( ( X (,) Y ) -cn-> CC ) ) $.
    $( ~ itggt0 holds for continuous functions in the absence of ~ ax-cc .
       (Contributed by Brendan Leahy, 16-Nov-2017.) $)
    itggt0cn $p |- ( ph -> 0 < S. ( X (,) Y ) B _d x ) $=
      ( vy cc0 cr co wcel cmpt cfv clt wbr crp wceq cv cioo cif citg2 citg cpnf
      cico wa cle rpred rpge0d elrege0 sylanbrc wn 0re 0le0 mpbir2an a1i ifclda
      adantr eqid fmptd wral rpgt0d elioore adantl iftrue eqeltrd syl2anc eqtrd
      fvmpt2 breqtrrd ralrimiva nfcv nffvmpt1 nfbr nfv weq breq2d cbvral sylibr
      fveq2 r19.21bi cres cc ccncf ioossre resmpt ax-mp mpteq2ia eqtri syl5eqel
      wss itg2gt0cn itgposval ) AKBLBUAZDEUBMZNZCKUCZOZUDPBWQCUEQAJWTDEFABLWSKU
      FUGMZWTAWSXANWPLNZAWRCKXAAWRUHZCLNKCUIRCXANXCCHUJZXCCHUKZCULUMKXANZAWRUNU
      HXFKLNKKUIRUOUPKULUQURUSUTWTVAZVBAKJUAZWTPZQRZJWQAKWPWTPZQRZBWQVCXJJWQVCA
      XLBWQXCKCXKQXCCHVDXCXKWSCXCXBWSSNXKWSTWRXBAWPDEVEVFXCWSCSWRWSCTAWRCKVGZVF
      ZHVHBLWSSWTXGVKVIXNVJVLVMXJXLJBWQBKXIQBKVNBQVNBLWSXHVOVPXLJVQJBVRXIXKKQXH
      WPWTWBVSVTWAWCAWTWQWDZBWQCOZWQWEWFMXOBWQWSOZXPWQLWMXOXQTDEWGBLWQWSWHWIBWQ
      WSCXMWJWKIWLWNABWQCXDGXEWOVL $.
  $}

  ${
    $d x y z t s u v w A $.  $d x y z t s u v w B $.  $d x y z t s u v w F $.
    $d x y z t s u v w ph $.  $d y z s u v w G $.  $d x y z t s u v w c $.
    ftc1cnnc.g $e |- G = ( x e. ( A [,] B ) |->
      S. ( A (,) x ) ( F ` t ) _d t ) $.
    ftc1cnnc.a $e |- ( ph -> A e. RR ) $.
    ftc1cnnc.b $e |- ( ph -> B e. RR ) $.
    ftc1cnnc.le $e |- ( ph -> A <_ B ) $.
    ftc1cnnc.f $e |- ( ph -> F e. ( ( A (,) B ) -cn-> CC ) ) $.
    ftc1cnnc.i $e |- ( ph -> F e. L^1 ) $.
    ${
      $d x z t u v X $.  $d y t E $.  $d y H $.  $d x t u v Y $.  $d y R $.
      ftc1cnnclem.c $e |- ( ph -> c e. ( A (,) B ) ) $.
      ftc1cnnclem.h $e |- H = ( z e. ( ( A [,] B ) \ { c } ) |->
        ( ( ( G ` z ) - ( G ` c ) ) / ( z - c ) ) ) $.
      ftc1cnnclem.e $e |- ( ph -> E e. RR+ ) $.
      ftc1cnnclem.r $e |- ( ph -> R e. RR+ ) $.
      ftc1cnnclem.fc $e |- ( ( ph /\ y e. ( A (,) B ) ) ->
        ( ( abs ` ( y - c ) ) < R ->
          ( abs ` ( ( F ` y ) - ( F ` c ) ) ) < E ) ) $.
      ftc1cnnclem.x1 $e |- ( ph -> X e. ( A [,] B ) ) $.
      ftc1cnnclem.x2 $e |- ( ph -> ( abs ` ( X - c ) ) < R ) $.
      ftc1cnnclem.y1 $e |- ( ph -> Y e. ( A [,] B ) ) $.
      ftc1cnnclem.y2 $e |- ( ph -> ( abs ` ( Y - c ) ) < R ) $.
      $( Lemma for ~ ftc1cnnc ; cf. ~ ftc1lem4 .  The stronger assumptions of
         ~ ftc1cn are exploited to make use of weaker theorems.  (Contributed
         by Brendan Leahy, 19-Nov-2017.) $)
      ftc1cnnclem $p |- ( ( ph /\ X < Y ) ->
        ( abs ` ( ( ( ( G ` Y ) - ( G ` X ) ) / ( Y - X ) ) - ( F ` c ) ) )
          < E ) $=
        ( vu vv clt wbr wa cfv cmin co cdiv cv cabs cioo citg caddc cmul cle cr
        wceq wcel wi cicc wss iccssre syl2anc sseldd ltle imp a1i ioossre ccncf
        ssid cc wf cncff syl ftc1lem1 syldan cxr rexrd w3a elicc1 biimpa simp2d
        syl21anc iccleub syl3anc df-ioo xrlelttr xrltletr ixxss12 cvv cvol cmpt
        adantr cibl eqeltrrd csn fconstmpt covol mblvol iblconst syl5eqelr cmbf
        cxp ax-resscn cncfmptc mp3an23 cncfmpt2f cnmbf iblsubnc itgconst oveq2d
        sylancr eqtrd 3eqtrd oveq1d resubcld posdifd fveq2d abscld rpred adantl
        cc0 absdifltd mpbid simpld lttrd simprd breq1d wb syl22anc ffvelrnd cdm
        sselda ffvelrnda npcand itgeq2dv subcld ioombl fvex feqmptd iblss ax-mp
        ioossicc iccmbl mblss iccvolcl ovolsscl syl5eqel ccnfld ctopn ctx subcn
        eqid ccn cres feqresmpt rescncf sylc sstri eqtr4d iblmbf mbfres sylancl
        mpteq2dva eqeltrd eqtr3d ovolioo syl5eq ovex itgcl recnd mulcld gt0ne0d
        itgaddnc divdird divcan4d divcld pncand absdivd 0re absidd cncfss mp2an
        mpd abscncf sselii cncfmpt1f iblabsnc itgrecl remulcld mulcn cjcld nfcv
        ccj csb nfcsb1v csbeq1a cbvmpt itgabsnc simpr crp wral ralrimiva sseldi
        rpcnd elioore eliooord readdcld mpbir2and weq oveq1 fveq2 imbi12d rspcv
        syl3c difrp adantlr itggt0cn itgsubnc mulcomd breqtrd biimpar syl112anc
        lelttrd ltdivmul mpbird eqbrtrd ) AMNUMUNZUOZNKUPMKUPUQURZNMUQURZUSURZO
        UTZJUPZUQURZVAUPZEMNVBURZEUTZJUPZVUEUQURZVCZVAUPZVUBUSURZIUMUYTVUGVULVU
        BUSURZVAUPVUMVUBVAUPZUSURVUNUYTVUFVUOVAUYTVUFVUOVUEVDURZVUEUQURVUOUYTVU
        CVUQVUEUQUYTVUCVULVUEVUBVEURZVDURZVUBUSURVUOVURVUBUSURZVDURVUQUYTVUAVUS
        VUBUSUYTVUAEVUHVUJVCZVULEVUHVUEVCZVDURZVUSAUYSMNVFUNZVUAVVAVHAUYSVVDAMV
        GVIZNVGVIZUYSVVDVJAFGVKURZVGMAFVGVIGVGVIVVGVGVLQRFGVMVNZUGVOZAVVGVGNVVH
        UIVOZMNVPVNVQZABEFGFGVBURZJKMNPQRSVVLVVLVLAVVLWAVRVVLVGVLAFGVSZVRUAAJVV
        LWBVTURVIZVVLWBJWCTVVLWBJWDWEZUGUIWFWGAVVAVVCVHUYSAEVUHVUKVUEVDURZVCVVA
        VVCAEVUHVVPVUJAVUIVUHVIZUOZVUJVUEAVVQVUIVVLVIZVUJWBVIAVUHVVLVUIAFWHVIZG
        WHVIZFMVFUNZNGVFUNZVUHVVLVLZAFQWIZAGRWIZAVVTVWAMVVGVIZVWBVWEVWFUGVVTVWA
        UOZVWGUOMWHVIZVWBMGVFUNZVWHVWGVWIVWBVWJWJFGMWKWLWMWNAVVTVWANVVGVIVWCVWE
        VWFUIFGNWOWPUKULEBFGMNVBUMUMUMUMVBVFVFUKULEWQZVWKFMBUTZWRVWLNGWSWTUUAZU
        UDZAVVLWBVUIJVVOUUEWGZAVUEWBVIZVVQAVVLWBVUDJVVOUBUUBZXDZUUFZUUGAEVUHVUK
        VUEWBVVRVUJVUEVWOVWRUUHZAEVUHVUJVUEWBVWOAEVUHVVLVUJXAVWMVUHXBUUCZVIZAMN
        UUIZVRZVUJXAVIAVVSUOVUIJUUJVRAJEVVLVUJXCXEAEVVLWBJVVOUUKUAXFUULVWRAEVUH
        VUEXCZVUHVUEXGXNZXEEVUHVUEXHAVXBVUHXBUPZVGVIZVWPVXFXEVIVXDAVXGVUHXIUPZV
        GVXBVXGVXIVHVXCVUHXJUUMZAVUHMNVKURZVLZVXKVGVLZVXKXIUPZVGVIVXIVGVIVXLAMN
        UUNVRAVXKVXAVIZVXMAVVEVVFVXOVVIVVJMNUUOVNZVXKUUPWEAVXKXBUPZVXNVGAVXOVXQ
        VXNVHVXPVXKXJWEAVVEVVFVXQVGVIVVIVVJMNUUQVNXFVUHVXKUURWPUUSZVWQVUHVUEXKW
        PXLZAVXBEVUHVUKXCZVUHWBVTURZVIVXTXMVIVXCAEVUJVUEUQUUTUVAUPZVUHVYBUVDZUQ
        VYBVYBUVBURVYBUVEURZVIAVYBVYCUVCVRZAJVUHUVFZEVUHVUJXCZVYAAEVVLWBVUHJVVO
        VWMUVGZAVWDVVNVYFVYAVIVWMTVVLWBVUHJUVHUVIXFAVWPVXEVYAVIZVWQVWPVUHWBVLZW
        BWBVLZVYIVUHVGWBMNVSXOUVJZWBWAZEVUEVUHWBXPXQWEXRZVUHVXTXSYCXTZVWRVXSAEV
        UHVVPXCZVYFXMAVYPVYGVYFAEVUHVVPVUJVWSUVOVYHUVKAJXMVIZVXBVYFXMVIAJXEVIVY
        QUAJUVLWEVXCVUHJUVMUVNUVPUWEUVQXDUYTVVBVURVULVDUYTVVBVUEVXGVEURZVURAVVB
        VYRVHZUYSAVXBVXHVWPVYSVXDVXRVWQEVUHVUEYAWPXDUYTVXGVUBVUEVEUYTVXGVXIVUBV
        XJUYTVVEVVFVVDVXIVUBVHAVVEUYSVVIXDAVVFUYSVVJXDVVKMNUVRWPUVSZYBYDYBYEYFU
        YTVULVURVUBAVULWBVIUYSAEVUHVUKXAVUKXAVIVVRVUJVUEUQUVTVRZVYOUWAZXDZUYTVU
        EVUBAVWPUYSVWQXDZAVUBWBVIUYSAVUBANMVVJVVIYGZUWBZXDZUWCWUGUYTVUBAUYSYMVU
        BUMUNZAMNVVIVVJYHWLZUWDZUWFUYTVUTVUEVUOVDUYTVUEVUBWUDWUGWUJUWGYBYEYFUYT
        VUOVUEUYTVULVUBWUCWUGWUJUWHWUDUWIYDYIUYTVULVUBWUCWUGWUJUWJUYTVUPVUBVUMU
        SUYTVUBAVUBVGVIZUYSWUEXDZUYTWUHYMVUBVFUNZWUIUYTYMVGVIWUKWUHWUMVJUWKWULY
        MVUBVPYCUWOUWLYBYEUYTVUNIUMUNZVUMVUBIVEURZUMUNZUYTVUMEVUHVUKVAUPZVCZWUO
        UYTVULWUCYJZAWURVGVIUYSAEVUHWUQVVRVUKVWTYJZAEVUHVUKXAWUAVYOAVXBEVUHWUQX
        CZVYAVIWVAXMVIVXCAEVUKVAVUHVAWBWBVTURZVIAWBVGVTURZWVBVAVGWBVLVYKWVCWVBV
        LXOVYMWBVGWBUWMUWNUWPUWQVRVYNUWRZVUHWVAXSYCZUWSZUWTZXDAWUOVGVIUYSAVUBIW
        UEAIUDYKZUXAZXDAVUMWURVFUNUYSAEBVUHVUKWBVWTVYOWVEAVXBBVUHVULUXEUPZEVWLV
        UKUXFZVEURXCZVYAVIWVLXMVIVXCABWVJWVKVEVYBVUHVYCVEVYDVIAVYBVYCUXBVRAWVJW
        BVIZBVUHWVJXCVYAVIZAVULWUBUXCWVMVYJVYKWVNVYLVYMBWVJVUHWBXPXQWEABVUHWVKX
        CVXTVYAEBVUHVUKWVKBVUKUXDEVWLVUKUXGEVWLVUKUXHUXIVYNXLXRVUHWVLXSYCUXJXDA
        UYSYMWUOWURUQURZUMUNZWURWUOUMUNZUYTYMEVUHIWUQUQURZVCZWVOUMUYTEWVRMNAUYS
        UXKAEVUHWVRXCZXEVIUYSAEVUHIWUQVGAIVGVIZVVQWVHXDZAEVUHIXCZVUHIXGXNZXEEVU
        HIXHAVXBVXHIWBVIZWWDXEVIVXDVXRAIUDUXPZVUHIXKWPXLZWUTWVFAVXBWVTVYAVIZWVT
        XMVIVXCAEIWUQUQVYBVUHVYCVYEAWWEWWCVYAVIZWWFWWEVYJVYKWWIVYLVYMEIVUHWBXPX
        QWEWVDXRZVUHWVTXSYCZXTXDAVVQWVRUXLVIZUYSVVRWUQIUMUNZWWLVVRVVSCUTZVUDUQU
        RZVAUPZHUMUNZWWNJUPZVUEUQURZVAUPZIUMUNZVJZCVVLUXMZVUIVUDUQURZVAUPZHUMUN
        ZWWMVWNAWXCVVQAWXBCVVLUFUXNXDVVRWXFVUDHUQURZVUIUMUNVUIVUDHVDURZUMUNVVRW
        XGMVUIAWXGVGVIVVQAVUDHAVVLVGVUDVVMUBUXOZAHUEYKZYGXDAVVEVVQVVIXDVVQVUIVG
        VIAVUIMNUXQYLZAWXGMUMUNZVVQAWXLMWXHUMUNZAMVUDUQURVAUPHUMUNWXLWXMUOUHAMV
        UDHVVIWXIWXJYNYOYPXDVVRMVUIUMUNZVUINUMUNZVVQWXNWXOUOAVUIMNUXRYLZYPYQVVR
        VUINWXHWXKAVVFVVQVVJXDAWXHVGVIVVQAVUDHWXIWXJUXSXDVVRWXNWXOWXPYRANWXHUMU
        NZVVQAWXGNUMUNZWXQANVUDUQURVAUPHUMUNWXRWXQUOUJANVUDHVVJWXIWXJYNYOYRXDYQ
        VVRVUIVUDHWXKAVUDVGVIVVQWXIXDAHVGVIVVQWXJXDYNUXTWXBWXFWWMVJCVUIVVLCEUYA
        ZWWQWXFWXAWWMWXSWWPWXEHUMWXSWWOWXDVAWWNVUIVUDUQUYBYIYSWXSWWTWUQIUMWXSWW
        SVUKVAWXSWWRVUJVUEUQWWNVUIJUYCYFYIYSUYDUYEUYFVVRWUQVGVIWWAWWMWWLYTWUTWW
        BWUQIUYGVNYOUYHAWWHUYSWWJXDUYIUYTWVSEVUHIVCZWURUQURZWVOAWVSWYAVHUYSAEVU
        HIWUQVGWWBWWGWUTWVFWWKUYJXDUYTWXTWUOWURUQUYTWXTIVXGVEURZIVUBVEURZWUOAWX
        TWYBVHZUYSAVXBVXHWWEWYDVXDVXRWWFEVUHIYAWPXDUYTVXGVUBIVEVYTYBAWYCWUOVHUY
        SAIVUBWWFWUFUYKXDYEYFYDUYLAWVQWVPAWURWUOWVGWVIYHUYMWGUYOUYTVUMVGVIWWAWU
        KWUHWUNWUPYTWUSAWWAUYSWVHXDWULWUIVUMIVUBUYPUYNUYQUYR $.
    $}

    $d c A $.  $d c B $.  $d c F $.  $d c ph $.  $d c G $.
    $( Choice-free proof of ~ ftc1cn .  (Contributed by Brendan Leahy,
       20-Nov-2017.) $)
    ftc1cnnc $p |- ( ph -> ( RR _D G ) = F ) $=
      ( co cr cc cfv wcel cmin clt vc vs vz vv vw vu cioo cdv wfun cdm wceq wfn
      vy wf dvf a1i ffun syl cicc crn ctg cnt ccnfld wss ax-resscn ssid ioossre
      ctopn ccncf cncff ftc1lem2 iccssre syl2anc tgioo2 dvbssntr iccntr sseqtrd
      eqid cv wbr crest csn cdif cdiv cmpt climc retop eqeltrri adantr iooretop
      wa ctop eleqtri ioossicc cuni uniretop eqtri ssntr syl22anc simpr cabs wi
      unieqi wral crp wrex ffvelrnda cxmt ccnp cnxmet toponunii syl6eleq ctopon
      mp2an simpllr recnd adantl sseli ad3antlr cnmetdval eqtrd breq1d ad2antrr
      elioore ssdifssd ad2ant2r weq fveq2 oveq1d oveq1 ad2antlr ad3antrrr sylan
      imbi12d fveq2d cc0 eqbrtrd ftc1cnnclem expr mpbir2and sseldd wne ccom cxp
      cres cmopn sstri xmetres2 ccn cnfldtop cnfldtopon restid eqcomi resttopon
      ax-mp cncfcn eleq2i biimpi cncnpi syl2an cnfldtopn oveq1i fveq1i metcnpi2
      metrest ovresd ralbidva simprll eldifsni wo sselda lttri2d biimpa oveq12d
      ovex fvmpt ad4antr eldifi ffvelrnd sylan2 ad4antlr ltne div2subd cle cibl
      necomd simplrl simplrr simprlr rspccva simprr subidd rpgt0d jaodan syldan
      abs00bd mpdan adantld ralrimdva sylbid anassrs mpd ralrimiva syl6ss dvlem
      reximdva fmptd ellimc3 wb eldv vex fvex breldm ssrdv eqssd df-fn sylanbrc
      ex ffn funbrfv sylc eqfnfvd ) AUADEUGNZOGUHNZFAUYDUIZUYDUJZUYCUKUYDUYCULA
      UYFPUYDUNZUYEUYGAGUOUPUYFPUYDUQURZAUYFUYCAUYFDEUSNZUGUTVAQZVBQQZUYCAUYIOG
      UYJVCVHQZOPVDAVEUPZABCDEUYCFGHIJKUYCUYCVDAUYCVFUPUYCOVDADEVGZUPMAFUYCPVIN
      ZRZUYCPFUNZLUYCPFVJURZVKZADORZEORZUYIOVDZIJDEVLVMZUYLUYLVRZVNZVUDVOAUYTVU
      AUYKUYCUKIJDEVPVMVQAUAUYCUYFAUAVSZUYCRZVUFUYFRZAVUGWKZVUFVUFFQZUYDVTZVUHV
      UIVUKVUFUYIUYLOWANZVBQQZRZVUJUBUYIVUFWBZWCZUBVSZGQZVUFGQZSNZVUQVUFSNZWDNZ
      WEZVUFWFNRZVUIUYCVUMVUFVUIVULWLRZVUBUYCVULRZUYCUYIVDZUYCVUMVDVVEVUIUYJVUL
      WLVUEWGWHUPAVUBVUGVUCWIVVFVUIUYCUYJVULDEWJVUEWMUPVVGVUIDEWNZUPUYIVULUYCOO
      UYJWOVULWOWPUYJVULVUEXCWQWRWSAVUGWTUUAVUIVVDVUJPRZUCVSZVUFUUBZVVJVUFSNZXA
      QUDVSZTVTZWKVVJVVCQZVUJSNZXAQZUEVSZTVTZXBZUCVUPXDZUDXEXFZUEXEXDAUYCPVUFFU
      YRXGZVUIVWBUEXEVUIVVRXERZWKZUFVSZVUFXASUUCZUYCUYCUUDUUEZNZVVMTVTZVWFFQZVU
      JVWGNZVVRTVTZXBZUFUYCXDZUDXEXFZVWBVWEVWHUYCXHQRZVWGPXHQRZFVUFVWHUUFQZUYLX
      INZQZRZVWDVWPVWQVWEVWRUYCPVDZVWQXJUYCOPUYNVEUUGZVWGUYCPUUHXNUPVWRVWEXJUPV
      UIVXBVWDVUIFVUFUYLUYCWANZUYLXINZQZVXAAFVXEUYLUUINZRVUFVXEWOZRZFVXGRVUGAFU
      YOVXHLVXCPPVDUYOVXHUKVXDPVFUYCPUYLVXEUYLVUDVXEVRUYLPWANZUYLUYLWLRVXKUYLUK
      UYLVUDUUJUYLWLPPUYLUYLVUDUUKZXKUULUUOUUMUUPXNXLVUGVXJUYCVXIVUFUYCVXEUYLPX
      MQRVXCVXEUYCXMQRVXLVXDUYCUYLPUUNXNXKUUQUURVUFFVXEUYLVXIVXIVRUUSUUTVUFVXFV
      WTVXEVWSUYLXIVWRVXCVXEVWSUKXJVXDVWGVWHUYLVWSPUYCVWHVRUYLVUDUVAZVWSVRZUVEX
      NUVBUVCXLWIVUIVWDWTUDUFVVRVWHVWGVUFFVWSUYLUYCPVXNVXMUVDWSVWEVWOVWAUDXEVUI
      VWDVVMXERZVWOVWAXBVUIVWDVXOWKZWKZVWOVWFVUFSNZXAQZVVMTVTZVWKVUJSNZXAQZVVRT
      VTZXBZUFUYCXDZVWAVXQVWNVYDUFUYCVXQVWFUYCRZWKZVWJVXTVWMVYCVYGVWIVXSVVMTVYG
      VWIVWFVUFVWGNZVXSVYGVWFVUFVWGUYCVXQVYFWTAVUGVXPVYFXOUVFVYGVWFPRZVUFPRZVYH
      VXSUKVYFVYIVXQVYFVWFVWFDEYDXPXQVUGVYJAVXPVYFUYCPVUFVXDXRZXSVWFVUFVWGVWGVR
      ZXTVMYAYBVYGVWLVYBVVRTVYGVWKPRVVIVWLVYBUKVXQUYCPVWFFAUYQVUGVXPUYRYCXGVUIV
      VIVXPVYFVWCYCVWKVUJVWGVYLXTVMYBYNUVGVXQVYEVVTUCVUPVXQVVJVUPRZVYEVVTVXQVYM
      VYEWKZWKVVNVVSVVKVXQVYNVVNVVSVXQVYNVVNWKZWKZVVKVVSVYPVYMVVKVXQVYMVYEVVNUV
      HZVVJUYIVUFUVIURVYPVVKVVJVUFTVTZVUFVVJTVTZUVJZVVSVYPVVKVYTVYPVVJVUFVUIVYN
      VVJORZVXPVVNAVYMWUAVUGVYEAVUPOVVJAUYIOVUOVUCYEUVKYFYFZVUGVUFORAVXPVYOVUFD
      EYDZXSUVLUVMVYPVYRVVSVYSVYPVYRWKZVVQVUSVVJGQZSNVUFVVJSNWDNZVUJSNZXAQVVRTW
      UDVVPWUGXAWUDVVOWUFVUJSWUDVVOWUEVUSSNZVVLWDNZWUFVYOVVOWUIUKZVXQVYRVYMWUJV
      YEVVNUBVVJVVBWUIVUPVVCUBUCYGZVUTWUHVVAVVLWDWUKVURWUEVUSSVUQVVJGYHYIVUQVVJ
      VUFSYJUVNVVCVRZWUHVVLWDUVOUVPZYCYKWUDWUEVUSVVJVUFWUDUYIPVVJGAUYIPGUNZVUGV
      XPVYOVYRUYSUVQVYOVVJUYIRZVXQVYRVYMWUOVYEVVNVVJUYIVUOUVRZYCYKUVSVUIVUSPRZV
      XPVYOVYRVUGAVUFUYIRZWUQUYCUYIVUFVVHXRZAUYIPVUFGUYSXGUVTYLWUDVVJVYPWUAVYRW
      UBWIXPVUGVYJAVXPVYOVYRVYKUWAVYPWUAVYRVVKWUBWUAVYRWKVUFVVJVVJVUFUWBUWFYMUW
      CYAYIYOVYPBUMUBCDEVVMVVRFGVVCVVJVUFUAHAUYTVUGVXPVYOIYLZAVUAVUGVXPVYOJYLZA
      DEUWDVTVUGVXPVYOKYLZAUYPVUGVXPVYOLYLZAFUWERVUGVXPVYOMYLZAVUGVXPVYOXOZWULV
      UIVWDVXOVYOUWGZVUIVWDVXOVYOUWHZVYPVYEUMVSZUYCRWVHVUFSNZXAQZVVMTVTZWVHFQZV
      UJSNZXAQZVVRTVTZXBZVXQVYMVYEVVNUWIVYDWVPUFWVHUYCUFUMYGZVXTWVKVYCWVOWVQVXS
      WVJVVMTWVQVXRWVIXAVWFWVHVUFSYJYOYBWVQVYBWVNVVRTWVQVYAWVMXAWVQVWKWVLVUJSVW
      FWVHFYHYIYOYBYNUWJYMZVYPVYMWUOVYQWUPURZVXQVYNVVNUWKZVUGWURAVXPVYOWUSXSZVY
      PVUFVUFSNZXAQZYPVVMTVUGWWCYPUKAVXPVYOVUGWWBVUGVUFVUGVUFWUCXPUWLUWPXSVYPVV
      MWVGUWMYQZYRYQVYPVYSWKVVQWUIVUJSNZXAQZVVRTVYOVVQWWFUKZVXQVYSVYMWWGVYEVVNV
      YMVVPWWEXAVYMVVOWUIVUJSWUMYIYOYCYKVYPBUMUBCDEVVMVVRFGVVCVUFVVJUAHWUTWVAWV
      BWVCWVDWVEWULWVFWVGWVRWWAWWDWVSWVTYRYQUWNUWOUWQYSUWRYSUWSUWTUXAUXFUXBUXCV
      UIUEUDUCVUPVUFVUJVVCVUIUBVUPVVBPVVCVUIVUQVUFUYIGAWUNVUGUYSWIAUYIPVDVUGAUY
      IOPVUCVEUXDZWIVUGWURAWUSXQUXEWULUXGAVUPPVDVUGAUYIPVUOWWHYEWIVUGVYJAVYKXQU
      XHYTAVUKVUNVVDWKUXIVUGAUBUYIVUFVUJOVULGVVCUYLVULVRVUDWULUYMUYSVUCUXJWIYTZ
      VUFVUJUYDUAUXKVUFFUXLUXMURUXRUXNUXOUYDUYCUXPUXQAUYQFUYCULUYRUYCPFUXSURVUI
      UYEVUKVUFUYDQVUJUKAUYEVUGUYHWIWWIVUFVUJUYDUXTUYAUYB $.
  $}

  ${
    $d t x F $.  $d t x A $.  $d t x ph $.
    $( Lemma for ~ ftc1anc - the absolute value of a real-valued measurable
       function is measurable.  Would be trivial with ~ cncombf , but this
       proof avoids ~ ax-cc .  (Contributed by Brendan Leahy, 18-Jun-2018.) $)
    ftc1anclem1 $p |- ( ( F : A --> RR /\ F e. MblFn ) ->
      ( abs o. F ) e. MblFn ) $=
      ( vt vx cr wcel wa cabs wceq adantr cioo co cima crab wb clt wn biantrurd
      wbr syl wf cmbf ccom cv cfv cmpt cc ffvelrn recnd feqmptd absf a1i fmptco
      fveq2 abscld eqid fmptd cdm cvol fdm mbfdm adantl eqeltrrd ccnv cpnf cmnf
      id cneg cun cle rexr elioopnf bicomd sylan9bbr ltnle ancoms sylan renegcl
      cxr absle lenlt syl2anr rexrd elioomnf sylan9bb notbid bitrd anbi12d elun
      oran bitri syl6bbr 3bitrd an32s rabbidva mptpreima 3eqtr4g cnveqd imaeq1d
      wo simpl eqtr4d imaundi syl6eq adantlr mbfima unmbl syl2anc eqeltrd abslt
      jca elioo5 3expa 3bitr4d ismbf2d ) AEBUAZBUBFZGZHBUCZCACUDZBUEZHUEZUFZUBX
      PXSYCIXQXPCDAUGYADUDZHUEYBBHXPXTAFZGZYAAEXTBUHZUIZXPCAEBXPVGUJXPDUGEHUGEH
      UAXPUKULUJYDYAHUNUMJXRDAYCXPAEYCUAXQXPCAYBEYCYFYAYHUOZYCUPZUQJXRBURZAUSUR
      ZXPYKAIXQAEBUTJXQYKYLFXPBVAVBVCXRYDEFZGZYCVDZYDVEKLZMZBVDZVFYDVHZKLZMZYRY
      PMZVIZYLXPYMYQUUCIXQXPYMGZYQYRYTYPVIZMZUUCUUDYQCAYAUFZVDZUUEMZUUFUUDYBYPF
      ZCANYAUUEFZCANYQUUIUUDUUJUUKCAXPYEYMUUJUUKOYFYMGZUUJYDYBPSZYBYDVJSZQZUUKY
      MUUJYBEFZUUMGZYFUUMYMYDVSFZUUJUUQOYDVKZYDYBVLTYFUUMUUQYFUUPUUMYIRVMVNYFUU
      PYMUUMUUOOZYIYMUUPUUTYDYBVOVPVQUULUUOYAYTFZQZYAYPFZQZGZQZUUKUULUUNUVEUULU
      UNYSYAVJSZYAYDVJSZGZUVEYFYAEFZYMUUNUVIOYGYAYDVTVQUULUVGUVBUVHUVDUULUVGYAY
      SPSZQZUVBYMYSEFUVJUVGUVLOYFYDVRZYGYSYAWAWBUULUVKUVAYFUVKUVJUVKGZYMUVAYFUV
      JUVKYGRYMUVAUVNYMYSVSFZUVAUVNOYMYSUVMWCZYSYAWDTVMWEWFWGUULUVHYDYAPSZQZUVD
      YFUVJYMUVHUVROYGYAYDWAVQUULUVQUVCYFUVQUVJUVQGZYMUVCYFUVJUVQYGRYMUVCUVSYMU
      URUVCUVSOUUSYDYAVLTVMWEWFWGWHWGWFUUKUVAUVCWTUVFYAYTYPWIUVAUVCWJWKWLWMWNWO
      CAYBYPYCYJWPCAYAUUEUUGUUGUPZWPWQUUDYRUUHUUEUUDBUUGUUDCAEBXPYMXAUJWRZWSXBY
      RYTYPXCXDXEXRUUCYLFZYMXQXPUWBXQXPGUUAYLFUUBYLFUWBAVFYSBXFAYDVEBXFUUAUUBXG
      XHVPJXIYNYOVFYDKLZMZYRYSYDKLZMZYLXPYMUWDUWFIXQUUDUWDUUHUWEMZUWFUUDYBUWCFZ
      CANYAUWEFZCANUWDUWGUUDUWHUWICAXPYEYMUWHUWIOUULYBYDPSZYSYAPSYAYDPSGZUWHUWI
      YFUVJYMUWJUWKOYGYAYDXJVQYMUWHUUPUWJGZYFUWJYMUURUWHUWLOUUSYDYBWDTYFUWJUWLY
      FUUPUWJYIRVMVNYMUVOUURGYAVSFZUWIUWKOZYFYMUVOUURUVPUUSXKYFYAYGWCUVOUURUWMU
      WNYSYDYAXLXMWBXNWNWOCAYBUWCYCYJWPCAYAUWEUUGUVTWPWQUUDYRUUHUWEUWAWSXBXEXRU
      WFYLFZYMXQXPUWOAYSYDBXFVPJXIXOXI $.
  $}


  ${
    $d t x F $.  $d t x A $.  $d t x G $.  $d t x ph $.
    $( Lemma for ~ ftc1anc - restriction of an integrable function to the
       absolute value of its real or imaginary part.  (Contributed by Brendan
       Leahy, 19-Jun-2018.)  (Revised by Brendan Leahy, 8-Aug-2018.) $)
    ftc1anclem2 $p |- ( ( F : A --> CC /\ F e. L^1 /\ G e. { Re , Im } ) ->
      ( S.2 ` ( t e. RR |-> if ( t e. A , ( abs ` ( G ` ( F ` t ) ) ) ,
        0 ) ) ) e. RR ) $=
      ( vx cc cibl wcel cre cim cr cfv cabs cc0 cmpt citg2 wa wceq cmbf adantr
      wf cpr cv cif wo elpri fveq1 fveq2d ifeq1d mpteq2dv ffvelrn recld adantlr
      adantl simpl feqmptd simpr eqeltrrd iblcn biimpa syldan simpld ccom recnd
      eqidd absf fveq2 fmptco eqid iblmbf ismbfcn2 ftc1anclem1 syl2anc iblabsnc
      a1i fmptd wb abscld absge0d iblpos mpbid simprd imcld jaodan sylan2 3impa
      eqeltrd ) BFCUAZCGHZDIJUBHZAKAUCZBHZWKCLZDLZMLZNUDZOZPLZKHZWJWHWIQZDIRZDJ
      RZUEWSDIJUFWTXAWSXBWTXAQWRAKWLWMILZMLZNUDZOZPLZKXAWRXGRWTXAWQXFPXAAKWPXEX
      AWLWOXDNXAWNXCMWMDIUGUHUIUJUHUNWTXGKHZXAWTABXDOZSHZXHWTXIGHZXJXHQZWTABXCK
      WHWLXCKHWIWHWLQZWMBFWKCUKZULZUMWTABXCOZGHZABWMJLZOZGHZWHWIABWMOZGHZXQXTQZ
      WTCYAGWTABFCWHWIUOUPZWHWIUQURWHYBYCWHABWMXNUSUTVAZVBWTMXPVCZXISWHYFXIRWIW
      HAEBFXCEUCZMLZXDXPMXMXCXOVDZWHXPVEWHEFKMFKMUAWHVFVOUPZYGXCMVGVHTWTBKXPUAZ
      XPSHZYFSHWHYKWIWHABXCKXPXOXPVIVPTWTYLXSSHZWHWIYASHZYLYMQZWTCYASYDWICSHWHC
      VJUNURWHYNYOWHABWMXNVKUTVAZVBBXPVLVMURVNWHXKXLVQWIWHABXDXMXCYIVRXMXCYIVSV
      TTWAWBTWGWTXBQWRAKWLXRMLZNUDZOZPLZKXBWRYTRWTXBWQYSPXBAKWPYRXBWLWOYQNXBWNX
      RMWMDJUGUHUIUJUHUNWTYTKHZXBWTABYQOZSHZUUAWTUUBGHZUUCUUAQZWTABXRFWHWLXRFHW
      IXMXRXMWMXNWCZVDZUMWTXQXTYEWBWTMXSVCZUUBSWHUUHUUBRWIWHAEBFXRYHYQXSMUUGWHX
      SVEYJYGXRMVGVHTWTBKXSUAZYMUUHSHWHUUIWIWHABXRKXSUUFXSVIVPTWTYLYMYPWBBXSVLV
      MURVNWHUUDUUEVQWIWHABYQXMXRUUGVRXMXRUUGVSVTTWAWBTWGWDWEWF $.
  $}

  ${
    $d u v x y z F $.  $d u v x y z G $.
    $( Lemma for ~ ftc1anc - the absolute value of the sum of a simple function
       and ` _i ` times another simple function is itself a simple function.
       (Contributed by Brendan Leahy, 27-May-2018.) $)
    ftc1anclem3 $p |- ( ( F e. dom S.1 /\ G e. dom S.1 ) -> ( abs o.
      ( F oF + ( ( RR X. { _i } ) oF x. G ) ) ) e. dom S.1 ) $=
      ( vx vy wcel wa cr cmul co caddc csqr cfv cmpt wceq cc cvv a1i adantl cc0
      wf vz citg1 cdm cabs ci csn cxp cof ccom cv c2 cexp i1ff ffvelrnda syl2an
      absreim anandirs recnd sqvald oveqan12d fveq2d eqtrd ax-icn mulcl sylancr
      mpteq2dva addcl reex adantlr ovex feqmptd adantr fconstmpt offval2 fmptco
      absf fveq2 mulcld adantll sqrf 3eqtr4d cpnf cico cres cle elrege0 resqrcl
      wbr sylbi id ax-mp reseq1i wss simplbi ssriv ax-resscn sstri resmpt eqtri
      fmptd ge0addcl oveq12 anidms feq1d remulcld msqge0d sylanbrc eqid vtoclga
      mpbird inidm off fco2 syl2anc crn cfn rnco wfn ffn readdcl remulcl syl6ss
      frn syl fnssres i1fmul i1frn fnfi rnfi syl5eqel ccnv cima cvol cdif cnvco
      i1fadd imaeq1i wn xchnxbir sylibr imaco i1fima fveq2i eldifsni c0ex elsnc
      wo eqcom bitri necon3bbii sqr0 eleq1i olcd ianor wb elpreima mp2b i1fima2
      wne i1fd eqeltrd ) AUBUCZEZBUVBEZFZUDAGUEUFUGZBHUHZIZJUHZIZUIZKAAUVGIZBBU
      VGIZUVIIZUIZUVBUVECGCUJZALZUEUVPBLZHIZJIZUDLZMCGUVQUVQHIZUVRUVRHIZJIZKLZM
      UVKUVOUVECGUWAUWEUVEUVPGEZFZUWAUVQUKULIZUVRUKULIZJIZKLZUWEUVCUVDUWFUWAUWK
      NZUVCUWFFZUVQGEZUVRGEUWLUVDUWFFZUVCGGUVPAAUMZUNZUVDGGUVPBBUMZUNZUVQUVRUPU
      OUQUWGUWJUWDKUVCUVDUWFUWJUWDNUWMUWOUWHUWBUWIUWCJUWMUVQUWMUVQUWQURZUSUWOUV
      RUWOUVRUWSURZUSUTUQVAVBVFUVECDGOUVTDUJZUDLUWAUVJUDUVCUVDUWFUVTOEZUWMUVQOE
      UVSOEZUXCUWOUWTUWOUEOEZUVROEUXDVCUXAUEUVRVDVEUVQUVSVGUOUQUVECGUVQUVSJAUVH
      PGPGPEZUVEVHQZUVCUWFUWNUVDUWQVIUVSPEUWGUEUVRHVJQUVCACGUVQMNUVDUVCCGGAUWPV
      KZVLUVDUVHCGUVSMNUVCUVDCGUEUVRHUVFBPOGUXFUVDVHQZUXEUWOVCQUWSUVFCGUEMNUVDC
      GUEVMQUVDCGGBUWRVKZVNRVNUVEDOGUDOGUDTUVEVPQVKUXBUVTUDVQVOUVECDGOUWDUXBKLU
      WEUVNKUVCUVDUWFUWDOEZUWMUWBOEZUWCOEZUXKUWOUWMUVQUVQUWTUWTVRZUWOUVRUVRUXAU
      XAVRZUWBUWCVGUOUQUVECGUWBUWCJUVLUVMPOOUXGUVCUWFUXLUVDUXNVIUVDUWFUXMUVCUXO
      VSUVCUVLCGUWBMNUVDUVCCGUVQUVQHAAPGGUXFUVCVHQZUWQUWQUXHUXHVNVLUVDUVMCGUWCM
      NUVCUVDCGUVRUVRHBBPGGUXIUWSUWSUXJUXJVNRVNUVEDOOKOOKTZUVEVTQVKUXBUWDKVQVOW
      AUVECUVOUVESWBWCIZGKUXRWDZTGUXRUVNTGGUVOTUVECUXRUVPKLZGUXSUVPUXREZUXTGEZU
      VEUYAUWFSUVPWEWHZFUYBUVPWFZUVPWGWIRUXSCOUXTMZUXRWDZCUXRUXTMZKUYEUXRUXQKUY
      ENVTUXQCOOKUXQWJVKWKWLUXROWMUYFUYGNUXRGOCUXRGUYAUWFUYCUYDWNWOWPWQCOUXRUXT
      WRWKWSWTUVECDGGGJUXRUXRUXRUVLUVMPPUYAUXBUXREFUVPUXBJIZUXREUVEUVPUXBXARUVC
      GUXRUVLTZUVDGUXRUAUJZUYJUVGIZTZUYIUAAUVBUYJANZGUXRUYKUVLUYMUYKUVLNUYJAUYJ
      AUVGXBXCXDUYJUVBEZUYLGUXRCGUVPUYJLZUYOHIZMZTUYNCGUYPUXRUYQUYNUWFFZUYPGESU
      YPWEWHUYPUXREUYRUYOUYOUYNGGUVPUYJUYJUMZUNZUYTXEUYRUYOUYTXFUYPWFXGUYQXHWTU
      YNGUXRUYKUYQUYNCGUYOUYOHUYJUYJPGGUXFUYNVHQUYTUYTUYNCGGUYJUYSVKZVUAVNXDXJZ
      XIVLUVDGUXRUVMTZUVCUYLVUCUABUVBUYJBNZGUXRUYKUVMVUDUYKUVMNUYJBUYJBUVGXBXCX
      DVUBXIRUXGUXGGXKZXLGUXRGKUVNXMXNUVEUVOXOZKUVNXOZWDZXOZXPKUVNXQUVEVUHXPEZV
      UIXPEUVEVUHVUGXRZVUGXPEZVUJUVEKOXRZVUGOWMVUKUXQVUMVTOOKXSZWKUVEVUGGOUVEGG
      UVNTVUGGWMUVECDGGGJGGGUVLUVMPPUWFUXBGEFZUYHGEUVEUVPUXBXTRUVCGGUVLTUVDUVCC
      DGGGHGGGAAPPVUOUVPUXBHIGEZUVCUVPUXBYAZRUWPUWPUXPUXPVUEXLVLUVDGGUVMTUVCUVD
      CDGGGHGGGBBPPVUOVUPUVDVUQRUWRUWRUXIUXIVUEXLRUXGUXGVUEXLGGUVNYCYDWPYBOVUGK
      YEVEUVEUVNUVBEZVULUVEUVLUVMUVCUVLUVBEUVDUVCAAUVCWJZVUSYFVLUVDUVMUVBEUVCUV
      DBBUVDWJZVUTYFRYPZUVNYGYDVUGVUHYHXNVUHYIYDYJUVEUVOYKZUVPUFZYLZYMUCZEUVPVU
      FSUFYNEZUVEVVDUVNYKZKYKZVVCYLZYLZVVEVVDVVGVVHUIZVVCYLVVJVVBVVKVVCKUVNYOYQ
      VVGVVHVVCUUAWSZUVEVURVVJVVEEVVAVVIUVNUUBYDYJVLUVEVVFFVVDYMLVVJYMLZGVVDVVJ
      YMVVLUUCUVEVURSVVIEZYRZVVMGEVVFVVAVVFSOEZYRZSKLZVVCEZYRZUUGZVVOVVFVVTVVQV
      VFUVPSUUSZVVTUVPVUFSUUDSVVCEZVWBVVSVWCUVPSVWCSUVPNUVPSNSUVPUUEUUFSUVPUUHU
      UIUUJVVRSVVCUUKUULYSYTUUMVVPVVSFZVWAVVNVVPVVSUUNUXQVUMVVNVWDUUOVTVUNOSVVC
      KUUPUUQYSYTVVIUVNUURUOYJUUTUVA $.
  $}

  ${
    $d t x F $.  $d t x G $.  $d t x A $.
    $( Lemma for ~ ftc1anc .  (Contributed by Brendan Leahy, 17-Jun-2018.) $)
    ftc1anclem4 $p |- ( ( F e. dom S.1 /\ G e. L^1 /\ G : RR --> RR ) ->
      ( S.2 ` ( t e. RR |-> ( abs ` ( ( G ` t ) - ( F ` t ) ) ) ) ) e. RR ) $=
      ( vx wcel cr wf cc0 co cfv cabs cmpt citg2 cle wbr wa cc cvv a1i cmbf cdm
      citg1 cibl w3a cpnf cicc cv cmin caddc ffvelrn recnd i1ff ffvelrnda subcl
      syl2anr anandirs abscld rexrd absge0d elxrge0 sylanbrc eqid fmptd 3adant2
      cxr reex fvex eqidd offval2 fveq2d ccom wceq id feqmptd absf fveq2 fmptco
      cof adantl iblmbf ftc1anclem1 sylan2 ancoms eqeltrrd 3adant1 cico elrege0
      3ad2ant3 iftrue mpteq2ia fveq2i adantll simpr simpl iblabsnc iblpos mpbid
      simprd syl5eqelr 3ad2ant1 i1fibl i1fmbf syl2anc itg2addnc eqtr3d readdcld
      cif eqeltrd cofr readdcl adantlr addge0d wral abs2dif2 ralrimiva ofrfval2
      mpbird itg2le syl3anc itg2lecl ) BUBUAEZCUCEZFFCGZUDZFHUEUFIZAFAUGZCJZYFB
      JZUHIZKJZLZGZAFYGKJZYHKJZUIIZLZMJZFEYKMJZYQNOZYRFEYAYCYLYBYAYCPZAFYJYEYKY
      TYFFEZPZYJVEEHYJNOYJYEEUUBYJUUBYIYAYCUUAYIQEZYCUUAPZYGQEZYHQEZUUCYAUUAPZU
      UDYGFFYFCUJZUKZUUGYHYAFFYFBBULZUMZUKZYGYHUNUOUPZUQZURUUBYIUUMUSYJUTVAYKVB
      VCVDZYDYQAFYMLZMJZAFYNLZMJZUIIZFYDUUPUURUIVRIZMJYQUUTYDUVAYPMYDAFYMYNUIUU
      PUURRRRFREZYDVFSYMREYDUUAPZYGKVGSYNREUVCYHKVGSYDUUPVHYDUURVHVIVJYDUUPUURY
      BYCUUPTEZYAYBYCPZKCVKZUUPTYCUVFUUPVLYBYCADFQYGDUGZKJZYMCKUUIYCAFFCYCVMVNY
      CDQFKQFKGZYCVOSVNUVGYGKVPVQVSYCYBUVFTEZYBYCCTEUVJCVTFCWAWBWCWDZWEYCYAFHUE
      WFIZUUPGYBYCAFYMUVLUUPUUDYMFEZHYMNOZYMUVLEUUDYGUUIUQZUUDYGUUIUSZYMWGVAUUP
      VBVCWHYBYCUUQFEYAUVEUUQAFUUAYMHXGZLZMJZFUVRUUPMAFUVQYMUUAYMHWIWJWKUVEUVDU
      VSFEZUVEUUPUCEUVDUVTPUVEAFYGFYCUUAYGFEYBUUHWLUVECAFYGLUCUVEAFFCYBYCWMVNYB
      YCWNWDUVKWOUVEAFYMYCUUAUVMYBUVOWLYCUUAUVNYBUVPWLWPWQWRWSWEZYAYBFUVLUURGYC
      YAAFYNUVLUURUUGYNFEZHYNNOZYNUVLEUUGYHUULUQZUUGYHUULUSZYNWGVAUURVBVCWTYAYB
      UUSFEYCYAUUSAFUUAYNHXGZLZMJZFUWGUURMAFUWFYNUUAYNHWIWJWKYAUURTEZUWHFEZYAUU
      RUCEUWIUWJPYAAFYHFUUKYABAFYHLUCYAAFFBUUJVNZBXAWDYAKBVKZUURTYAADFQYHUVHYNB
      KUULUWKYADQFKUVIYAVOSVNUVGYHKVPVQYAFFBGBTEUWLTEUUJBXBFBWAXCWDWOYAAFYNUWDU
      WEWPWQWRWSWTZXDXEYDUUQUUSUWAUWMXFXHYDYLFYEYPGZYKYPNXIOZYSUUOYAYCUWNYBYTAF
      YOYEYPUUBYOVEEHYONOYOYEEUUBYOYAYCUUAYOFEZUUDUVMUWBUWPUUGUVOUWDYMYNXJUOUPZ
      URUUBYMYNYCUUAUVMYAUVOWLYAUUAUWBYCUWDXKYCUUAUVNYAUVPWLYAUUAUWCYCUWEXKXLYO
      UTVAYPVBVCVDYAYCUWOYBYTUWOYJYONOZAFXMYTUWRAFYAYCUUAUWRUUDUUEUUFUWRUUGUUIU
      ULYGYHXNUOUPXOYTAFYJYONYKYPRFFUVBYTVFSUUNUWQYTYKVHYTYPVHXPXQVDYKYPXRXSYQY
      KXTXS $.
  $}

  ${
    $d a b f g r s t u w x y z A $.  $d a b f g r s t u w x y z B $.
    $d a b f g r s t u w x y z D $.  $d a b f g r s t u w x y z F $.
    $d a b f g r s t u w x y z ph $.  $d a b f g r s u w y z G $.
    ftc1anc.g $e |- G = ( x e. ( A [,] B ) |-> S. ( A (,) x ) ( F ` t ) _d t )
      $.
    ftc1anc.a $e |- ( ph -> A e. RR ) $.
    ftc1anc.b $e |- ( ph -> B e. RR ) $.
    ftc1anc.le $e |- ( ph -> A <_ B ) $.
    ftc1anc.s $e |- ( ph -> ( A (,) B ) C_ D ) $.
    ftc1anc.d $e |- ( ph -> D C_ RR ) $.
    ftc1anc.i $e |- ( ph -> F e. L^1 ) $.
    ftc1anc.f $e |- ( ph -> F : D --> CC ) $.
    ${
      $d a b f g r s t u w x y z Y $.
      $( Lemma for ~ ftc1anc , the existence of a simple function the integral
         of whose pointwise difference from the function is less than a given
         positive real.  (Contributed by Brendan Leahy, 17-Jun-2018.) $)
      ftc1anclem5 $p |- ( ( ph /\ Y e. RR+ ) -> E. f e. dom S.1 ( S.2 `
        ( t e. RR |-> ( abs ` ( ( Re ` if ( t e. D , ( F ` t ) , 0 ) ) -
          ( f ` t ) ) ) ) ) < Y ) $=
        ( cr cc0 vg wcel wa cv cfv cif cre cabs cmpt cle citg1 citg2 cmin co wn
        wbr cdm wrex clt wi wral iftrue mpteq2ia fveq2i cmbf cibl ffvelrnda 0cn
        cc a1i adantr rembl cdif wceq adantl iffalse fveq2d re0 syl cim feqmptd
        eqeltrrd mpbid simpld syl5eqel ccom recnd eqidd fveq2 eqid fmptd abscld
        wf syl2anc absge0d syl5eqelr sylan resubcl syl2an ltnled cpnf cxr rexrd
        wb sylanbrc cneg ad2antrr itg1cl ad2antlr 0re sylancr ralrimiva csn wfn
        fvex c0ex ifex reex sylancl mpbird caddc elrege0 ifbieq12d fvmpt breq2d
        cvv ifcl oveq12d cima cun c1 cmul ffn mpteq2dva oveq2d eqtrd wtru mpan2
        an32s syldan crp cofr ifclda recld cvol eldifn syl6eq iblcn iblss2 absf
        fmptco iblmbf ismbfcn2 mbfss ftc1anclem1 iblabsnc iblpos simprd ltsubrp
        rpre cicc elxrge0 itg2leub rexanali sylibr c0p i1fpos i1ff max1 cxp wss
        mtbid ax-resscn fnmpti 0pledm fconstmpt ofrfval2 bitrd itg2itg1 eqeltrd
        ltnle biimpar max2 itg1le mpd3an23 breqtrrd ltletrd adantrl i1fmbf cico
        cof negcld subcl anassrs weq eleq1 negeqd negex ccnv ovex crn frn ax-mp
        wo ref fnco mp3an1 elpreima fco biantrurd syl6bbr fvco3 bitr3d pm5.32da
        3syl breqtrri biantru eldif baibr syl5rbbr orbi12d elimif 3bitr4g ifbid
        0le0 elun offval2 eqtr4d pm2.61i addid1d mulm1d addid2d syl5eq sylan9eq
        ifeq12d cioo pnfxr ltpnf snunioo mp3an imaeq2i imaundi ismbfcn mbfimasn
        0xr eqtr3i mp3an3 mbfima unmbl fdm mbfdm difmbl eqcomd ifeq1d i1fres id
        1re renegcli i1fmulc cmmbl ifnot tru fconst mp1i inidm fvconst2 syl5eqr
        ofval i1fadd syl2anr cbvmptv jca ftc1anclem4 3expb itg2addnc eqtr3d nfv
        mpan nfcv nfmpt1 nfbr anass fvmpt2 ofrval 3com23 3expa adantll adantllr
        nfan absid biimpa ifboth sylancom subge0 absidd oveq1d 3eqtr4d renegcld
        breq1 ad3antlr ad3antrrr sylbird absnid sylanl1 lenegcon2d simpll negeq
        ltle neg0 suble0 absnidd subneg negdi2 pm2.61dan pncan3 sylanb mpteq2da
        imp breq1d adantlr ltadd2d ltsubadd syl3an 3bitr4d adantrr fveq1 rspcev
        ex reximdva rexlimdva syld mpd ) AJUUAUBZUCZUAUDZCSCUDZFUBZVYPHUEZTUFZU
        GUEZUHUEZUIZUJUUBZUPZVYOUKUEZWUBULUEZJUMUNZUJUPZUOZUCZUAUKUQZURZCSVYTVY
        PGUDZUEZUMUNZUHUEZUIZULUEZJUSUPZGWUKURZVYNWUDWUHUTUAWUKVAZUOWULVYNWUFWU
        GUJUPZWVAVYNWUGWUFUSUPZWVBUOAWUFSUBZVYMWVCAWUFCSVYPSUBZWUATUFZUIZULUEZS
        WVGWUBULCSWVFWUAWVEWUATVBVCVDAWUBVEUBZWVHSUBZAWUBVFUBWVIWVJUCACSVYTSAVY
        TSUBZWVEAVYSAVYQVYRTVIAFVIVYPHRVGZTVIUBZAVYQUOZUCVHVJUUCUUDZVKZACFSVYTS
        PSUUEUQZUBZAVLVJZAWVKVYQWVOVKZAVYPSFVMZUBZUCWVNVYTTVNWWBWVNAVYPSFUUFVOW
        VNVYTTUGUEZTWVNVYSTUGVYQVYRTVPVQVRUUGVSZACFVYTUIZCFVYRUGUEZUIZVFCFVYTWW
        FVYQVYSVYRUGVYQVYRTVBVQVCZAWWGVFUBZCFVYRVTUEUIZVFUBZACFVYRUIZVFUBWWIWWK
        UCAHWWLVFACFVIHRWAZQWBACFVYRWVLUUHWCWDWEUUIZAUHCSVYTUIZWFZWUBVEACBSVIVY
        TBUDZUHUEWUAWWOUHAVYTVIUBZWVEAVYTWVOWGZVKAWWOWHABVISUHVISUHWMAUUJVJWAWW
        QVYTUHWIUUKASSWWOWMWWOVEUBWWPVEUBACSVYTSWWOWVPWWOWJWKACFSVYTSPWVSWVTWWD
        AWWEWWGVEWWHAWWGVEUBZWWJVEUBZAWWLVEUBWWTWXAUCAHWWLVEWWMAHVFUBHVEUBZQHUU
        LVSZWBACFVYRWVLUUMWCWDWEUUNSWWOUUOWNWBUUPACSWUAAWUASUBWVEAVYTWWSWLZVKAT
        WUAUJUPZWVEAVYTWWSWOZVKUUQWCUURWPZWUFJUUSWQVYNWUGWUFAWVDJSUBZWUGSUBZVYM
        WXGJUUTZWUFJWRWSZAWVDVYMWXGVKWTWCVYNSTXAUVAUNZWUBWMZWUGXBUBWVBWVAXDAWXM
        VYMACSWUAWXLWUBAWUAWXLUBZWVEAWUAXBUBWXEWXNAWUAWXDXCWXFWUAUVBXEVKWUBWJZW
        KVKVYNWUGWXKXCWUGUAWUBUVCWNUVLWUDWUHUAWUKUVDUVEVYNWULCSVYTTVYTUJUPZTVYP
        VYOUEZUJUPZWXQTUFZWXSXFZUFZUMUNZUHUEZUIZULUEZJUSUPZUAWUKURZWUTVYNWUJWYF
        UAWUKVYNVYOWUKUBZUCZWUJWYFWYIWUJUCWYFWUGCSWXSUIZULUEZUSUPZWYIWUIWYLWUDW
        YIWUIUCWUGWUEWYKVYNWXIWYHWUIWXKXGWYHWUESUBZVYNWUIVYOXHZXIWYHWYKSUBZVYNW
        UIWYHWYKWYJUKUEZSWYHWYJWUKUBZUVFWYJWUCUPZWYKWYPVNCVYOWYJWYJWJZUVGZWYHWY
        RTWXSUJUPZCSVAZWYHXUACSWYHWVEUCZTSUBZWXQSUBZXUAXJWYHSSVYPVYOVYOUVHZVGZT
        WXQUVIXKZXLWYHWYRSTXMZUVJZWYJWUCUPXUBWYHSWYJSVIUVKWYHUVMVJWYJSXNZWYHCSW
        XSWYJWXRWXQTVYPVYOXOXPXQZWYSUVNZVJUVOWYHCSTWXSUJXUJWYJYFYFSSYFUBZWYHXRV
        JZTYFUBXUCXPVJXUCXUEXUDWXSSUBZXUGXJWXRWXQTSYGXSZXUJCSTUIVNWYHCSTUVPVJWY
        HWYJWHZUVQUVRXTWYJUVSWNZWYHWYQWYPSUBWYTWYJXHVSUVTZXIWYIWUGWUEUSUPZWUIVY
        NWXIWYMXVAWUIXDWYHWXKWYNWUGWUEUWAWSUWBWYHWUEWYKUJUPVYNWUIWYHWUEWYPWYKUJ
        WYHWYQVYOWYJWUCUPZWUEWYPUJUPWYTWYHXVBWXQWXSUJUPZCSVAWYHXVCCSXUCXUDXUEXV
        CXJXUGTWXQUWCXKXLWYHCSWXQWXSUJVYOWYJYFSSXUOXUGXUQWYHCSSVYOXUFWAXURUVQXT
        VYOWYJUWDUWEXUSUWFXIUWGUWHWYIWUDWYFWYLXDWUIWYIWUDUCWYKWYEYAUNZWYKJYAUNZ
        USUPZWUFXVEUSUPZWYFWYLAWYHWUDXVFXVGXDVYMAWYHUCZWUDUCZXVDWUFXVEUSXVIXVDC
        SWXSWYCYAUNZUIZULUEZWUFXVHXVDXVLVNWUDXVHWYJWYDYAUWKZUNZULUEXVDXVLXVHWYJ
        WYDWYHWYJVEUBZAWYHWYQXVOWYTWYJUWIVSVOWYHSTXAUWJUNZWYJWMAWYHCSWXSXVPWYJX
        UCXUPXUAWXSXVPUBXUQXUHWXSYBXEWYSWKVOWYHWYOAXUTVOXVHCSWYCXVPWYDXVHWVEUCZ
        WYCSUBTWYCUJUPWYCXVPUBXVQWYBAWYHWVEWYBVIUBZAWWRWYAVIUBZXVRXUCWWSXUCWXSV
        IUBZWXTVIUBXVSXUCWXSXUQWGZXUCWXSXWAUWLWXPWXSWXTVIYGWNVYTWYAUWMWSUWNZWLZ
        XVQWYBXWBWOWYCYBXEWYDWJWKXVHWYECSVYPBSWWQFUBZWWQHUEZTUFZUGUEZUIZUEZVYPB
        STXWGUJUPZTWWQVYOUEZUJUPZXWKTUFZXWMXFZUFZUIZUEZUMUNZUHUEZUIZULUEZSXWTWY
        DULCSXWSWYCWVEXWRWYBUHWVEXWIVYTXWQWYAUMBVYPXWGVYTSXWHBCUWOZXWFVYSUGXXBX
        WDVYQXWETVYRTWWQVYPFUWPWWQVYPHWIXXBTWHZYCVQZXWHWJVYSUGXOYDBVYPXWOWYASXW
        PXXBXWJWXPXWMXWNWXSWXTXXBXWGVYTTUJXXDYEXXBXWLWXRXWKTWXQTXXBXWKWXQTUJWWQ
        VYPVYOWIZYEXXEXXCYCZXXBXWMWXSXXFUWQYCXWPWJWXPWXSWXTXULWXSUWRXQYDZYHVQVC
        VDXVHXWPWUKUBZXWHVFUBZSSXWHWMZUCZXXASUBZXVHBSWWQUGHWFZUWSZXVPYIZWWAYJZU
        BZXWMTUFZUIZBSXXQTYKXFZXWMYLUNZUFZUIZXVMUNZXWPWUKAWYHXYDBSXWJXWMTUFZXWJ
        TXYAUFZYAUNZUIXWPABSXYEXYFYAXXSXYCYFYFYFXUNAXRVJXYEYFUBAWWQSUBZUCZXWJXW
        MTXWLXWKTWWQVYOXOXPXQZXPXQVJXYFYFUBXYIXWJTXYAXPXXTXWMYLUWTXQVJABSXXRXYE
        XYIXXQXWJXWMTXYIWWQXXOUBZWWQWWAUBZUXDXWDTXWEUGUEZUJUPZUCZXWDUOZTWWCUJUP
        ZUCZUXDXXQXWJXYIXYKXYOXYLXYRAXYKXYOXDXYHAXYKXWDWWQXXMUEZXVPUBZUCZXYOAFV
        IHWMZXXMFXNZXYKYUAXDRYUBHFXNZHUXAVIUVKZYUCFVIHYMFVIHUXBUGVIXNZYUDYUEYUC
        VISUGWMZYUFUXEVISUGYMUXCVIFUGHUXFUXGWNFWWQXVPXXMUXHUXOAXWDXYTXYNAXWDUCZ
        TXYSUJUPZXYTXYNYUHYUIXYSSUBZYUIUCXYTYUHYUJYUIAFSWWQXXMAYUGYUBFSXXMWMZUX
        ERFVISUGHUXIXKZVGUXJXYSYBUXKYUHXYSXYMTUJAYUBXWDXYSXYMVNRFVIWWQUGHUXLWQY
        EUXMUXNUVRVKXYHXYLXYRXDAXYRXYPXYHXYLXYQXYPTTWWCUJUYEVRUXPUXQXYLXYHXYPWW
        QSFUXRUXSUXTVOUYAWWQXXOWWAUYFXWDXWJXYNXYQXWETXWFXWEVNXWGXYMTUJXWFXWEUGW
        IYEXWFTVNXWGWWCTUJXWFTUGWIYEUYBUYCZUYDYNABSXYBXYFXYIXXQXWJTXYAYUMUYDYNU
        YGWYHBSXYGXWOWYHXYHUCZXYGXWJXWMTYAUNZTXYAYAUNZUFZXWOXWJXYGYUQVNXWJXYGYU
        OYUQXWJXYEXWMXYFTYAXWJXWMTVBXWJTXYAVBYHXWJYUOYUPVBUYHXWJUOZXYGYUPYUQYUR
        XYETXYFXYAYAXWJXWMTVPXWJTXYAVPYHXWJYUOYUPVPUYHUYIYUNXWJYUOXWMYUPXWNYUNX
        WMYUNXWKVIUBWVMXWMVIUBYUNXWKWYHSSWWQVYOXUFVGWGVHXWLXWKTVIYGXSZUYJYUNYUP
        TXWNYAUNXWNYUNXYAXWNTYAYUNXWMYUSUYKYOYUNXWNYUNXWMYUSUWLUYLYPUYOUYMYNUYN
        WYHWYQXXPWVQUBZXYDWUKUBAWYTAXXOWVQUBWWAWVQUBZYUTAXXOXXNXUIYIZXXNTXAUYPU
        NZYIZYJZWVQXXNXUIYVCYJZYIXXOYVEYVFXVPXXNTXBUBXAXBUBTXAUSUPZYVFXVPVNVUEU
        YQXUDYVGXJTUYRUXCTXAUYSUYTVUAXXNXUIYVCVUBVUFAXXMVEUBZYUKYVEWVQUBZAYVHVT
        HWFVEUBZAWXBYVHYVJUCZWXCAYUBWXBYVKXDRFHVUCVSWCWDYULYVHYUKUCYVBWVQUBZYVD
        WVQUBYVIYVHYUKXUDYVLXJFTXXMVUDVUGFTXAXXMVUHYVBYVDVUIWNWNWEAWVRFWVQUBYVA
        VLAHUQZFWVQAYUBYVMFVNRFVIHVUJVSAWXBYVMWVQUBWXCHVUKVSWBSFVULXKXXOWWAVUIW
        NWYQYUTUCXXSXYCBXXPWYJXXSBSXXRXXQWWQWYJUEZTUFXYHXXQXWMYVNTXYHYVNXWMCWWQ
        WXSXWMSWYJCBUWOZWXRXWLWXQTXWKTYVOWXQXWKTUJVYPWWQVYOWIZYEYVPYVOTWHYCWYSX
        YJYDZVUMVUNVCVUOWYQSXXTXMZUVJZWYJYLUWKUNZWUKUBSXXPVMZWVQUBXYCWUKUBYUTWY
        QXXTWYJWYQVUPXXTSUBWYQYKVUQVURVJVUSXXPVUTBYWAYVTXYCBSXYBWWQYWAUBZWWQYVT
        UEZTUFZXYHXYBXXQUOZXYATUFYWDXXQXYATVVAXYHYWEYWBXYATYWCTYWBXYHYWEWWQSXXP
        UXRUXSXYHYWCXYAYQXYHYWCXYAVNVVBYQSSXXTXWMYLSYVSWYJYFYFWWQSYVRYVSWMYVSSX
        NYQSXXTYKUWRZVVCSYVRYVSYMVVDXUKYQXUMVJXUNYQXRVJZYWGSVVEZXYHWWQYVSUEXXTV
        NYQSXXTWWQYWFVVFVOXYHYVNXWMVNYQYVQVOVVHVVRVUMXYHTWHYCVVGVCVUOWSVVIVVJWB
        ZAXXKWYHAXXIXXJAXWHWWOVFBCSXWGVYTXXDVVKZWWNWEACSVYTSXWHWVPYWJWKVVLVKXXH
        XXIXXJXXLCXWPXWHVVMVVNWNWPZVVOXVHXVNXVKULXVHCSWXSWYCYAWYJWYDYFYFSXUNXVH
        XRVJWXSYFUBXVQXULVJXWCXVHWYJWHXVHWYDWHUYGVQVVPVKXVIXVKWUBULXVICSXVJWUAX
        VHWUDCXVHCVVQCVYOWUBWUCCVYOVVSCWUCVVSCSWUAVVTVWAVWIXVHWVEWUDXVJWUAVNZXV
        QAXUCUCZWUDYWLAWYHWVEVWBYWMWUDWXQWUAUJUPZYWLXUCWUDYWNAWYHWVEWUDYWNWYHWU
        DWVEYWNWYHSSWXQWUAUJSVYOWUBYFYFVYPWYHSSVYOWMVYOSXNXUFSSVYOYMVSWUBSXNWYH
        CSWUAWUBVYTUHXOZWXOUVNVJXUOXUOYWHXUCWXQWHWVEVYPWUBUEWUAVNZWYHWVEWUAYFUB
        YWPYWOCSWUAYFWUBWXOVWCYRVOVWDVWEVWFVWGYWMYWNUCZXVJWXSWUAWXSUMUNZYAUNZWU
        AYWQWYCYWRWXSYAYWQWXPWYCYWRVNYWQWXPUCZVYTWXSUMUNZUHUEZYXAWYCYWRYWTYXAYW
        MYXASUBZYWNWXPAWVKXUPYXCXUCWVOXUQVYTWXSWRWSXGYWTTYXAUJUPZWXSVYTUJUPZYWQ
        WXPWXQVYTUJUPZYXEAYWNWXPYXFXUCAWXPYWNYXFAWXPUCZYWNYXFYXGWUAVYTWXQUJAWVK
        WXPWUAVYTVNWVOVYTVWJZWQYEVWKYSVWHWXRYXFWXPYXEWXQTWXQWXSVYTUJVWSTWXSVYTU
        JVWSVWLVWMYWMYXDYXEXDZYWNWXPAWVKXUPYXIXUCWVOXUQVYTWXSVWNWSXGXTVWOWXPWYC
        YXBVNYWQWXPWYBYXAUHWXPWYAWXSVYTUMWXPWXSWXTVBYOVQVOYWQWVKWXPYWRYXAVNAWVK
        XUCYWNWVOXGWVKWXPUCWUAVYTWXSUMYXHVWPWQVWQYWQWXPUOZUCZVYTWXTUMUNZUHUEZVY
        TXFZWXSUMUNZWYCYWRYXKYXMYXLXFZYXOYXKYXLYWMYXLSUBZYWNYXJAWVKWXTSUBZYXQXU
        CWVOXUCWXSXUQVWRZVYTWXTWRWSXGYXKYXLTUJUPZVYTWXTUJUPZYXKVYTWXQXFZUJUPZVY
        TTUJUPZYYAYXKWXQVYTXUCXUEAYWNYXJXUGVWTAWVKXUCYWNYXJWVOVXAYWMWVKYWNYXJWX
        QYXNUJUPZAWVKXUCWVOVKWVKYXJYWNYYEWVKYXJUCZYWNYYEYYFWUAYXNWXQUJWVKYXJYYD
        WUAYXNVNZWVKYXJYYDWVKYXJVYTTUSUPZYYDWVKXUDYYHYXJXDXJVYTTUWAYRWVKXUDYYHY
        YDUTZXJVYTTVXHZYRVXBVXRVYTVXCZYTYEVWKYSVXDVXEYWQAYXJYYDAXUCYWNVXFZAYXJY
        YDAYXJYYHYYDAVYTTWVOXUDAXJVJWTAWVKXUDYYIWVOXJYYJXSVXBVXRZWQWXRYYCYYDYYA
        WXQTWXQWXSVNYYBWXTVYTUJWXQWXSVXGYETWXSVNZTWXTVYTUJYYNTTXFWXTVXITWXSVXGV
        VGYEVWLWNYWMYXTYYAXDZYWNYXJAWVKYXRYYOXUCWVOYXSVYTWXTVXJWSXGXTVXKYWMYXPY
        XOVNZYWNYXJAWWRXVTYYPXUCWWSXWAWWRXVTUCZYXPVYTWXSYAUNZXFYXOYYQYXLYYRVYTW
        XSVXLUWQVYTWXSVXMYPWSXGYPYXJWYCYXMVNYWQYXJWYBYXLUHYXJWYAWXTVYTUMWXPWXSW
        XTVPYOVQVOYWQAYXJYWRYXOVNYYLAYXJUCWUAYXNWXSUMAYXJYYDYYGYYMAWVKYYDYYGWVO
        YYKWQYTVWPWQVWQVXNYOYWMYWSWUAVNZYWNXUCXVTWUAVIUBYYSAXWAAWUAWXDWGWXSWUAV
        XOVVJVKYPYTVXPYSVXQVQYPVXSVWHWYIWYFXVFXDWUDWYIWYEJWYKAWYHWYESUBVYMYWKVX
        TVYMWXHAWYHWXJXIWYHWYOVYNXUTVOVYAVKWYIWYLXVGXDZWUDAVYMWYHYYTAWVDVYMWXHW
        YHWYOYYTWXGWXJXUTWUFJWYKVYBVYCVWFVKVYDVYEXTVYHVYIAWYGWUTUTVYMAWYFWUTUAW
        UKXVHXXHWYFWUTUTYWIXXHWYFWUTWUSWYFGXWPWUKWUMXWPVNZWURWYEJUSUUUAWUQWYDUL
        UUUACSWUPWYCUUUAWVEUCZWUOWYBUHUUUBWUNWYAVYTUMUUUAWVEWUNXWQWYAVYPWUMXWPV
        YFXXGUYNYOVQYNVQVXSVYGVYHVSVYJVKVYKVYL $.
      $( Lemma for ~ ftc1anc - construction of simple functions within an
         arbitrary absolute distance of the given function.  Similar to Lemma
         565Ib of [Fremlin5] p. 218, but without Fremlin's additional step of
         converting the simple function into a continuous one, which is
         unnecessary to this lemma's use; also, two simple functions are used
         to allow for complex-valued ` F ` .  (Contributed by Brendan Leahy,
         31-May-2018.) $)
      ftc1anclem6 $p |- ( ( ph /\ Y e. RR+ ) -> E. f e. dom S.1 E. g e. dom S.1
        ( S.2 ` ( t e. RR |-> ( abs ` ( if ( t e. D , ( F ` t ) , 0 ) -
          ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ) ) ) < Y ) $=
        ( cr vy crp wcel wa cv cfv cc0 cif cre cmin co cabs cmpt citg2 cdiv clt
        wbr cdm wrex cim ci cmul caddc ftc1anclem5 sylan2 cicc cioo eqid ax-icn
        c1 ine0 a1i ffvelrnda cibl feqmptd eqeltrrd cmbf wceq mp3an23 mpteq2dva
        syl cneg weq fveq2 fveq2d recld recnd adantlr adantl syl6eqr adantr cvv
        cc sylancr eleq1d anbi12d ismbfcn2 mpbid mulcl fmptd fvmpt eqtri oveq1d
        wb ovex wi eqidd fvex mpteq2ia wf jca syl2an cle cpnf cxr anassrs rexrd
        abscld absge0d sylanbrc elrege0 adantrr adantrl wral ccnv cima cin ciun
        syl5eq wss ad2antlr crab ineq2d mptpreima ineq12i inrab syl6eq ad3antlr
        syl2anc cmnf c2 citg1 rphalfcl reccli wne divrec2 iblmbf cbvmptv eleq1i
        citg biimpri mbfneg sylan2b negnegd negex negeqd impbida w3a divcl imre
        biimpi mulneg1 divcan2 eqtrd reneg 3eqtrd bitr4d imval ancom iblmulc2nc
        syl6bb 3bitr4d 0cn ifclda oveq2d eqtr4d ifeq1da oveq1 div0i ifeq2 ax-mp
        ifsb mpteq2dv breq1d rexbidv mpbird reeanv eleq1 ifbieq12d fveq2i rembl
        wn cvol cdif eldifn iftrue iblss2 iblcn simpld ftc1anclem4 3expb ancoms
        syl5eqelr simprd imcld anim12dan rpred lt2add an32s cof cofr i1ff subcl
        iffalse adantlrr adantlrl addcld elxrge0 cico rexr anim1i 3imtr4i ssriv
        ge0addcl sseldi reex inidm abstrid ralrimiva absmul absi oveq1i mulid2d
        off eqtr2d offval2 ofrfval2 itg2le syl3anc ccom absf fmptco resubcl crn
        csn iunin2 imaiun iunid imaeq2i eqtr3i ineq2i dmmpti sseqtri cnvimarndm
        cnvimass fdm syl5sseqr df-ss sylib frn sselda ad2antrr ltaddsub syl3an3
        sylan 2thd 3comr 3expa readdcl adantll elioopnf oveq2 bibi1d syl5ibrcom
        3bitr4rd pm5.32rd adantllr syldan rabbidv imaeq1d vex mptiniseg 3eqtr4d
        cnveqd iuneq2dv eqtr3d cfn i1frn mbfss mbfima inmbl ralrimivw finiunmbl
        eqeltrd ltsubadd syl3an1 elioomnf ismbf2d ftc1anclem1 itg2addnc breqtrd
        i1fima itg2cl anandis rpaddcld rpxrd mpand syld anim12i addsub4 replimd
        xrlelttr anandirs mp3an1 3eqtr4rd rpcn 2halvesd breq12d sylibd reximdva
        subdi syl5bir mp2and ) AKUBUCZUDZCTCUEZFUCZVYFIUFZUGUHZUIUFZVYFGUEZUFZU
        JUKZULUFZUMZUNUFZKUUAUOUKZUPUQZGUUBURZUSZCTVYIUTUFZVYFHUEZUFZUJUKZULUFZ
        UMZUNUFZVYQUPUQZHVYSUSZCTVYIVYLVAWUCVBUKZVCUKZUJUKZULUFZUMZUNUFZKUPUQZH
        VYSUSZGVYSUSZVYDAVYQUBUCZVYTKUUCZABCDEFGIJVYQLMNOPQRSVDVEVYEWUICTVYGVYF
        UAFVJVAUOUKZUAUEZIUFZVBUKZUMZUFZUGUHZUIUFZWUCUJUKZULUFZUMZUNUFZVYQUPUQZ
        HVYSUSZVYDAWUSWVNWUTABCDEFHWVEBDEVFUKCDBUEZVGUKWVFUUJUMZVYQWVPVHMNOPQAU
        AFWVCWVAWMWVAWMUCZAVAVIVKUUDZVLAFWMWVBISVMZAIUAFWVCUMZVNAUAFWMISVORVPZA
        UAFWVCVAUOUKZUMZWVEVQAUAFWWBWVDAWVBFUCZUDZWVCWMUCZWWBWVDVRZWVSWWFVAWMUC
        ZVAUGUUEZWWGVIVKWVCVAUUFVSWAVTAWVTVQUCZWWCVQUCZAWVTVNUCWWJWWAWVTUUGWAAU
        AFWVCUIUFZUMZVQUCZUAFWVCUTUFZUMZVQUCZUDZUAFWWBUIUFZUMZVQUCZUAFWWBUTUFZU
        MZVQUCZUDZWWJWWKAWWRWXDWXAUDWXEAWWNWXDWWQWXAAWWNUAFWWLWBZUMZVQUCZWXDAWW
        NWXHWWNABFWVOIUFZUIUFZUMZVQUCZWXHWWMWXKVQUABFWWLWXJUABWCZWVCWXIUIWVBWVO
        IWDWEZUUHZUUIZAWXLUDUAFWWLWMAWWDWWLWMUCWXLWWEWWLWWEWVCWVSWFWGWHWXLWWNAW
        WNWXLWXPUUKWIUULUUMAWXHUDZBFWXJWBZWBZUMZWWMVQAWXTWWMVRWXHAWXTWXKWWMABFW
        XSWXJAWVOFUCZUDZWXJWYBWXJWYBWXIAFWMWVOISVMZWFWGUUNVTWXOWJWKWXQBFWXRWLWX
        RWLUCWXQWYAUDWXJUUOVLWXHBFWXRUMZVQUCZAWXHWYEWXGWYDVQUABFWXFWXRWXMWWLWXJ
        WXNUUPUUHUUIUVAWIUULVPUUQAWXCWXGVQAUAFWXBWXFWWEWWFWXBWXFVRWVSWWFWXBVAWB
        WWBVBUKZUIUFZWVCWBZUIUFWXFWWFWWHWWIWXBWYGVRZVIVKWWFWWHWWIUURWWBWMUCZWYI
        WVCVAUUSZWWBUUTWAVSWWFWYFWYHUIWWFWYFVAWWBVBUKZWBZWYHWWFWWHWYJWYFWYMVRVI
        WWFWWHWWIWYJVIVKWYKVSZVAWWBUVBWNWWFWYLWVCWWFWWHWWIWYLWVCVRVIVKWVCVAUVCV
        SUUPUVDWEWVCUVEUVFWAVTWOUVGAWWPWWTVQAUAFWWOWWSWWEWWFWWOWWSVRWVSWVCUVHWA
        VTWOWPWXDWXAUVIUVKAUAFWVCWVSWQAUAFWWBWWEWWFWYJWVSWYNWAWQUVLWRVPUVJAUAFW
        VDWMWVEWWEWVQWWFWVDWMUCWVRWVSWVAWVCWSWNWVEVHZWTVDVEAWUIWVNXDVYDAWUHWVMH
        VYSAWUGWVLVYQUPAWUFWVKUNACTWUEWVJAWUDWVIULAWUAWVHWUCUJAWUAVYIVAUOUKZUIU
        FZWVHAVYIWMUCZWUAWYQVRAVYGVYHUGWMAFWMVYFISVMZUGWMUCZAVYGUWLZUDUVMVLUVNZ
        VYIUVHWAAWVGWYPUIAWVGVYGVYHVAUOUKZUGUHZWYPAVYGWVFXUCUGAVYGUDZWVFWVAVYHV
        BUKZXUCVYGWVFXUFVRAUAVYFWVDXUFFWVEUACWCWVCVYHWVAVBWVBVYFIWDUVOWYOWVAVYH
        VBXEXAWIXUEVYHWMUCZXUCXUFVRZWYSXUGWWHWWIXUHVIVKVYHVAUUFVSWAUVPUVQWYPVYG
        XUCUGVAUOUKZUHZXUDVYGVYHUGWYPXUCXUIVYIVYHVAUOUVRVYIUGVAUOUVRUWBXUIUGVRX
        UJXUDVRVAVIVKUVSVYGXUIUGXUCUVTUWAXBWJWEUVPXCWEUWCWEUWDUWEWKUWFVYTWUIUDV
        YRWUHUDZHVYSUSZGVYSUSVYEWURVYRWUHGHVYSVYSUWGVYEXULWUQGVYSVYEVYKVYSUCZUD
        XUKWUPHVYSVYEXUMWUBVYSUCZXUKWUPXFVYEXUMXUNUDZUDZXUKCTVYMVAWUDVBUKZVCUKZ
        ULUFZUMZUNUFZVYQVYQVCUKZUPUQZWUPXUPXUKVYPWUGVCUKZXVBUPUQZXVCAXUOVYDXUKX
        VEXFZAXUOUDZVYPTUCZWUGTUCZUDVYQTUCZXVJUDXVFVYDAXUMXVHXUNXVIAXUMUDZVYPCT
        VYFBTWYAWXIUGUHZUIUFZUMZUFZVYLUJUKZULUFZUMZUNUFZTXVRVYOUNCTXVQVYNVYFTUC
        ZXVPVYMULXVTXVOVYJVYLUJBVYFXVMVYJTXVNBCWCZXVLVYIUIXWAWYAVYGWXIUGVYHUGWV
        OVYFFUWHWVOVYFIWDXWAUGXGUWIZWEXVNVHZVYIUIXHXAXCWEXIUWJXUMAXVSTUCZAXUMXV
        NVNUCZTTXVNXJZUDXWDAXWEXWFAXWEBTXVLUTUFZUMZVNUCZABTXVLUMVNUCXWEXWIUDABF
        TXVLWMQTUWMURZUCZAUWKVLZAXVLWMUCZWYAAWYAWXIUGWMWYCWYTAWYAUWLZUDUVMVLUVN
        ZWKAWVOTFUWNZUCZUDXWNXVLUGVRXWQXWNAWVOTFUWOWIWYAWXIUGUXNWAAIBFXVLUMZVNA
        IBFWXIUMXWRABFWMISVOBFXVLWXIWYAWXIUGUWPXIWJRVPUWQABTXVLAXWMWVOTUCZXWOWK
        ZUWRWRZUWSABTXVMTXVNAXWSUDZXVLXWTWFXWCWTXKXUMXWEXWFXWDCVYKXVNUWTUXAVEUX
        BUXCZAXUNUDZWUGCTVYFXWHUFZWUCUJUKZULUFZUMZUNUFZTXXHWUFUNCTXXGWUEXVTXXFW
        UDULXVTXXEWUAWUCUJBVYFXWGWUATXWHXWAXVLVYIUTXWBWEXWHVHZVYIUTXHXAXCWEXIUW
        JXUNAXXITUCZAXUNXWITTXWHXJZUDXXKAXWIXXLAXWEXWIXXAUXDABTXWGTXWHAXWGTUCXW
        SAXVLXWOUXEWKXXJWTXKXUNXWIXXLXXKCWUBXWHUWTUXAVEUXBUXCZUXFVYDXVJXVJVYDVY
        QWUTUXGZXXNXKVYPWUGVYQVYQUXHXLUXIXUPXVAXVDXMUQZXVEXVCAXUOXXOVYDXVGXVAVY
        OWUFVCUXJUKZUNUFZXVDXMXVGTUGXNVFUKZXUTXJZTXXRXXPXJXUTXXPXMUXKUQZXVAXXQX
        MUQXVGCTXUSXXRXUTXVGXVTUDZXUSXOUCUGXUSXMUQXUSXXRUCXYAXUSXYAXURXYAVYMXUQ
        AXUMXVTVYMWMUCZXUNAXUMXVTXYBAVYJWMUCZVYLWMUCZXYBXUMXVTUDZAVYJAVYIXUBWFZ
        WGZXYEVYLXUMTTVYFVYKVYKUXLZVMZWGZVYJVYLUXMXLXPZUXOZAXUNXVTXUQWMUCZXUMXX
        DXVTUDZWWHWUDWMUCZXYMVIAXUNXVTXYOAWUAWMUCZWUCWMUCZXYOXUNXVTUDZAWUAAVYIX
        UBUXEWGZXYRWUCXUNTTVYFWUBWUBUXLVMWGZWUAWUCUXMXLXPZVAWUDWSWNUXPZUXQZXRZX
        QXYAXURYUCXSXUSUXRXTXUTVHWTZXVGBUATTTVCUGXNUXSUKZYUFXXRVYOWUFWLWLWVOYUF
        UCZWVBYUFUCUDZWVOWVBVCUKZXXRUCXVGYUHYUFXXRYUIBYUFXXRXWSUGWVOXMUQZUDWVOX
        OUCZYUJUDYUGWVOXXRUCXWSYUKYUJWVOUXTZUYAWVOYAWVOUXRUYBUYCWVOWVBUYDUYEWIA
        XUMTYUFVYOXJXUNXVKCTVYNYUFVYOXVKXVTUDZVYNTUCUGVYNXMUQVYNYUFUCYUMVYMXYKX
        RYUMVYMXYKXSVYNYAXTVYOVHWTYBZAXUNTYUFWUFXJXUMXXDCTWUEYUFWUFXYNWUETUCUGW
        UEXMUQWUEYUFUCXYNWUDYUAXRZXYNWUDYUAXSWUEYAXTWUFVHWTYCZTWLUCXVGUYFVLZYUQ
        TUYGUYNXVGXXTXUSVYNXUQULUFZVCUKZXMUQZCTYDXVGYUTCTXYAVYMXUQXYLYUBUYHUYIX
        VGCTXUSYUSXMXUTXXPWLTWLYUQYUDYUSWLUCXYAVYNYURVCXEVLXVGXUTXGXVGCTVYNYURV
        CVYOWUFWLWLWLYUQVYNWLUCXYAVYMULXHVLYURWLUCXYAXUQULXHVLXVGVYOXGAXUNWUFCT
        YURUMVRXUMXXDCTWUEYURXYNYURVAULUFZWUEVBUKZWUEXYNWWHXYOYURYVBVRVIYUAVAWU
        DUYJWNXYNYVBVJWUEVBUKWUEYVAVJWUEVBUYKUYLXYNWUEXYNWUEYUOWGUYMYIUYOVTYCUY
        PUYQUWFXUTXXPUYRUYSXVGVYOWUFAXUMVYOVQUCXUNXVKULCTVYMUMZUYTZVYOVQXVKCBTW
        MVYMWVOULUFVYNYVCULXYKXVKYVCXGXVKBWMTULWMTULXJXVKVUAVLVOWVOVYMULWDVUBXV
        KTTYVCXJYVCVQUCYVDVQUCXVKCTVYMTYVCAXUMXVTVYMTUCZAVYJTUCZVYLTUCYVEXYEXYF
        XYIVYJVYLVUCXLXPYVCVHZWTZXVKBTYVCYVHXWKXVKUWKVLXVKXWSUDZYVCYEZWVOXNVGUK
        ZYFZUAVYKVUDZCTVYJUMZYEZYUIXNVGUKZYFZVYKYEZWVBVUEZYFZYGZYHZXWJYVIUAYVMY
        VLYVTYGZYHZYVLYWBXUMYWDYVLVRAXWSXUMYWDYVLYVRYVMYFZYGZYVLYWDYVLUAYVMYVTY
        HZYGYWFUAYVMYVLYVTVUFYWGYWEYVLYVRUAYVMYVSYHZYFYWGYWEUAYVRYVMYVSVUGYWHYV
        MYVRUAYVMVUHVUIVUJZVUKXBXUMYVLYWEYJYWFYVLVRXUMTYVLYWEYVLYVCURZTYVCYVKVU
        OCTVYMYVCVYJVYLUJXEYVGVULZVUMXUMYWEVYKURZTVYKVUNXUMTTVYKXJZYWLTVRXYHTTV
        YKVUPWAYIZVUQYVLYWEVURVUSYIYKYVIUAYVMYWCYWAYVIWVBYVMUCZUDZVYMYVKUCZVYLW
        VBVRZUDZCTYLZVYJYVPUCZYWRUDZCTYLZYWCYWAYWPYWSYXBCTYVIYWOWVBTUCZYWSYXBXD
        ZYVIYVMTWVBXUMYVMTYJZAXWSXUMYWMYXFXYHTTVYKVUTWAYKVVAZAXWSYXDYXEXUMXXBYX
        DUDZYWRYWQYXAYXHYWQYXAXDYWRVYJWVBUJUKZYVKUCZYXAXDYXHYVFYUIVYJUPUQZUDZYX
        ITUCZWVOYXIUPUQZUDZYXAYXJYXHYVFYXMYXKYXNYXHYVFYXMAYVFXWSYXDXYFVVBZAYXDY
        XMXWSAYVFYXDYXMXYFVYJWVBVUCVVEWHZVVFAXWSYXDYXKYXNXDZXWSYXDAYXRAXWSYXDYV
        FYXRXYFWVOWVBVYJVVCVVDVVGVVHWPYXHYUIXOUCZYXAYXLXDXWSYXDYXSAXWSYXDUDYUIW
        VOWVBVVIXQVVJZYUIVYJVVKWAYXHYUKYXJYXOXDXWSYUKAYXDYULYKZWVOYXIVVKWAVVOYW
        RYWQYXJYXAYWRVYMYXIYVKVYLWVBVYJUJVVLZWOVVMVVNVVPVVQVVRVVSXUMYWCYWTVRAXW
        SYWOXUMYWCYVLCTVYLUMZYEZYVSYFZYGZYWTXUMYVTYYEYVLXUMYVRYYDYVSXUMVYKYYCXU
        MCTTVYKXYHVOVWDVVTZYMYYFYWQCTYLZYWRCTYLZYGYWTYVLYYHYYEYYICTVYMYVKYVCYVG
        YNWVBWLUCYYEYYIVRUAVWACTVYLWVBYYCWLYYCVHVWBUWAZYOYWQYWRCTYPXBYQYRXUMYWA
        YXCVRAXWSYWOXUMYWAYVQYYEYGZYXCXUMYVTYYEYVQYYGYMYYKYXACTYLZYYIYGYXCYVQYY
        LYYEYYICTVYJYVPYVNYVNVHZYNYYJYOYXAYWRCTYPXBYQYRVWCVWEVWFXVKYWBXWJUCZXWS
        XVKYVMVWGUCZYWAXWJUCZUAYVMYDYYNXUMYYOAVYKVWHWIZXVKYYPUAYVMAYVQXWJUCZYVT
        XWJUCZYYPXUMAYVNVQUCZTTYVNXJZYYRAYYTCTWUAUMVQUCZACTVYIUMVQUCYYTUUUBUDAC
        FTVYIWMQXWLAWYRVYGXUBWKAVYFXWPUCZUDXUAVYIUGVRUUUCXUAAVYFTFUWOWIVYGVYHUG
        UXNWAAICFVYIUMZVQAICFVYHUMUUUDACFWMISVOCFVYIVYHVYGVYHUGUWPXIWJAIVNUCIVQ
        UCRIUUGWAVPVWIACTVYIAWYRXVTXUBWKWQWRUWSZACTVYJTYVNAYVFXVTXYFWKYYMWTZTYU
        IXNYVNVWJYSYVSVYKVXBZYVQYVTVWKXLVWLYVMYWAUAVWMYSWKVWNYVIYVJYTWVOVGUKZYF
        ZUAYVMYVOYTYUIVGUKZYFZYVTYGZYHZXWJYVIUAYVMUUUIYVTYGZYHZUUUIUUUMXUMUUUOU
        UUIVRAXWSXUMUUUOUUUIYWEYGZUUUIUUUOUUUIYWGYGUUUPUAYVMUUUIYVTVUFYWGYWEUUU
        IYWIVUKXBXUMUUUIYWEYJUUUPUUUIVRXUMTUUUIYWEUUUIYWJTYVCUUUHVUOYWKVUMYWNVU
        QUUUIYWEVURVUSYIYKYVIUAYVMUUUNUUULYWPVYMUUUHUCZYWRUDZCTYLZVYJUUUJUCZYWR
        UDZCTYLZUUUNUUULYWPUUURUUVACTYVIYWOYXDUUURUUVAXDZYXGAXWSYXDUUVCXUMYXHYW
        RUUUQUUUTYXHUUUQUUUTXDYWRYXIUUUHUCZUUUTXDYXHYXMYXIWVOUPUQZUDZYVFVYJYUIU
        PUQZUDZUUVDUUUTYXHYXMYVFUUVEUUVGYXHYXMYVFYXQYXPVVFAYXDXWSUUVEUUVGXDZAYX
        DXWSUUVIAYVFYXDXWSUUVIXYFVYJWVBWVOVWOVWPVVHUXIWPYXHYUKUUVDUUVFXDYYAWVOY
        XIVWQWAYXHYXSUUUTUUVHXDYXTYUIVYJVWQWAUVLYWRUUUQUUVDUUUTYWRVYMYXIUUUHYYB
        WOVVMVVNVVPVVQVVRVVSXUMUUUNUUUSVRAXWSYWOXUMUUUNUUUIYYEYGZUUUSXUMYVTYYEU
        UUIYYGYMUUVJUUUQCTYLZYYIYGUUUSUUUIUUVKYYEYYICTVYMUUUHYVCYVGYNYYJYOUUUQY
        WRCTYPXBYQYRXUMUUULUUVBVRAXWSYWOXUMUUULUUUKYYEYGZUUVBXUMYVTYYEUUUKYYGYM
        UUVLUUUTCTYLZYYIYGUUVBUUUKUUVMYYEYYICTVYJUUUJYVNYYMYNYYJYOUUUTYWRCTYPXB
        YQYRVWCVWEVWFXVKUUUMXWJUCZXWSXVKYYOUUULXWJUCZUAYVMYDUUVNYYQXVKUUVOUAYVM
        AUUUKXWJUCZYYSUUVOXUMAYYTUUUAUUVPUUUEUUUFTYTYUIYVNVWJYSUUUGUUUKYVTVWKXL
        VWLYVMUUULUAVWMYSWKVWNVWRTYVCVWSYSVPYBYUNAXUMXVHXUNXXCYBYUPAXUNXVIXUMXX
        MYCVWTVXAWHXUPXVAXOUCZXVDXOUCZXVBXOUCZXXOXVEUDXVCXFAXUOUUVQVYDXVGXXSUUV
        QYUEXUTVXCWAWHAXUOUUVRVYDXVGXVDAXUMXUNXVDTUCZXVKXVHXVIUUVTXXDXXCXXMVYPW
        UGVVIXLVXDXQWHVYDUUVSAXUOVYDXVBVYDVYQVYQWUTWUTVXEVXFYKXVAXVDXVBVXLUYSVX
        GVXHXUPXVAWUOXVBKUPAXUOXVAWUOVRVYDXVGXUTWUNUNXVGCTXUSWUMXYAXURWULULXYAV
        YJVAWUAVBUKZVCUKZWUKUJUKZVYMUUWAWUJUJUKZVCUKZWULXURAXUOXVTUUWCUUWEVRZAX
        YCUUWAWMUCZUDXYDWUJWMUCZUDZUUWFXUOXVTUDZAXYCUUWGXYGAWWHXYPUUWGVIXYSVAWU
        AWSWNXKXUMXUNXVTUUWIXYEXYDXYRUUWHXYJXYRWWHXYQUUWHVIXYTVAWUCWSWNVXIVXMVY
        JUUWAVYLWUJVXJXLXPXYAVYIUUWBWUKUJAVYIUUWBVRXUOXVTAVYIXUBVXKVVBXCXYAXUQU
        UWDVYMVCAXUOXVTXUQUUWDVRZAXYPXYQUUWKUUWJXYSXUNXVTXYQXUMXYTVVJWWHXYPXYQU
        UWKVIVAWUAWUCVYAVXNXLXPUVOVXOWEVTWEWHVYDXVBKVRAXUOVYDKKVXPVXQYKVXRVXSXP
        VXTVXTVYBVYC $.
    $}
    $( Lemma for ~ ftc1anc .  (Contributed by Brendan Leahy, 13-May-2018.) $)
    ftc1anclem7 $p |- ( ( ( ( ( ( ( ph /\ ( f e. dom S.1 /\ g e. dom S.1 ) ) /\
      ( S.2 ` ( t e. RR |-> ( abs ` ( if ( t e. D , ( F ` t ) , 0 ) -
        ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ) ) ) < ( y / 2 ) ) /\
      E. r e. ( ran f u. ran g ) r =/= 0 ) /\ y e. RR+ ) /\
        ( u e. ( A [,] B ) /\ w e. ( A [,] B ) /\ u <_ w ) ) /\
      ( abs ` ( w - u ) ) < ( ( y / 2 ) / ( 2 x. sup ( ( abs "
        ( ran f u. ran g ) ) , RR , < ) ) ) ) -> ( ( S.2 ` ( t e. RR |->
      if ( t e. ( u (,) w ) , ( abs ` ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ,
        0 ) ) ) + ( S.2 ` ( t e. RR |-> if ( t e. ( u (,) w ) , ( abs `
      ( ( F ` t ) - ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ) , 0 ) ) ) ) <
        ( ( y / 2 ) + ( y / 2 ) ) ) $=
      ( vz cv citg1 cdm wcel wa cr cfv cc0 cif ci cmul co caddc cmin cabs citg2
      cmpt c2 cdiv clt wbr wne crn wrex crp cicc cle w3a cioo csn cxp ffvelrnda
      cvol cof cc recnd ax-icn sylancr syl2an anandirs cvv reex adantlr feqmptd
      wceq adantr adantl wf absf fveq2 eqid fvex sylancl wral wi absge0d sylan2
      a1i 0le0 wss ax-resscn wfn c0ex eqidd ofrfval2 mpbird eqeltrd syl2anc cxr
      ifex rexrd 3adantr3 sselda syldan adantllr adantll abscld sylanbrc ifclda
      elxrge0 fmptd sylan syl ad3antrrr iftrue ad2antrr syl3anc frn ffn fnfvima
      wb ax-mp mp3an1 cfn suprub syl2anr breqtrd cima csup cofr ccom i1ff mulcl
      cun c0p addcl fconstmpt offval2 fmptco ftc1anclem3 eqeltrrd ioombl oveq2d
      ovex weq oveq12d fveq2d fvmpt eqcomd ifeq1d mpteq2ia i1fres breq2 elioore
      eleq1 anbi2d eleq1d imbi12d chvarv ifbothda ralrimivw fnmpti 0pledm bitrd
      wn itg2itg1 itg1cl ad6antlr cpnf simplll jca df-icc elixx3g simpld simprd
      simprbi anim12i df-ioo xrlelttr xrltletr ixxss12 subcld 0xr mpbir2an rpre
      sstrd rehalfcld ad2antlr simpll itg2cl subcl anassrs rphalfcl rpxrd breq1
      0cn leidd oveq1d breqtrrd ralrimiva itg2le simpllr xrlelttrd mpd itg2lecl
      xrltle ad3antlr c0 imassrn sstri unssd syl6ss i1f0rn elun1 ne0i wfun ffun
      2rp i1frn unfi imafi fimaxre2 suprcl adantrr absgt0 biimpa anasss ltletrd
      0re elrpd rexlimdvaa imp rpmulcl rerpdivcld simp-4l iccssre anandis rpred
      3jca rpdivcl adantlll sseld idd 3anim123d ifcl 2timesd readdcld syl5eqelr
      abs0 addge0d readdcl abstri c1 absmul absi oveq1i syl6eq mulid2d fnfvelrn
      eqtrd elun2 le2addd letrd 3brtr4d ex iffalse pm2.61d1 cico mblvol ovolioo
      covol syl5eq resubcl ancoms 3adant3 elrege0 itg2const ledivmuld abssubge0
      ge0addcl eqtr4d simpr lelttrd ltdiv1d lt2addd ) AJUDZUEUFZUGZKUDZVWTUGZUH
      ZUHZFUIFUDZIUGZVXFLUJZUKULZVXFVWSUJZUMVXFVXBUJZUNUOZUPUOZUQUOZURUJZUTZUSU
      JZCUDZVAVBUOZVCVDZUHZNUDZUKVEZNVWSVFZVXBVFZUUGZVGZUHZVXRVHUGZUHZEUDZGHVIU
      OZUGZDUDZVYLUGZVYKVYNVJVDZVKZUHZVYNVYKUQUOZURUJZVXSVAURVYFUUAZUIVCUUBZUNU
      OZVBUOZVCVDZUHZFUIVXFVYKVYNVLUOZUGZVXMURUJZUKULZUTZUSUJZFUIWUHVXHVXMUQUOZ
      URUJZUKULZUTZUSUJZVXSVXSVXDWULUIUGZAVXTVYGVYIVYQWUEVXDWUKVWTUGZUUHWUKVJUU
      CZVDZWURVXDBUIBUDZVWSUJZUMWVBVXBUJZUNUOZUPUOZURUJZUTZVWTUGWUGVPUFUGZWUSVX
      DURVWSUIUMVMVNZVXBUNVQUOZUPVQUOZUUDWVHVWTVXDBFUIVRWVFVXFURUJWVGWVLURVXAVX
      CWVBUIUGZWVFVRUGZVXAWVMUHZWVCVRUGWVEVRUGZWVNVXCWVMUHZWVOWVCVXAUIUIWVBVWSV
      WSUUEZVOZVSWVQUMVRUGZWVDVRUGWVPVTWVQWVDVXCUIUIWVBVXBVXBUUEZVOZVSUMWVDUUFW
      AWVCWVEUUIWBWCZVXDBUIWVCWVEUPVWSWVKWDUIWDUIWDUGZVXDWEXAZVXAWVMWVCUIUGVXCW
      VSWFWVEWDUGVXDWVMUHZUMWVDUNUUQXAVXAVWSBUIWVCUTWHVXCVXABUIUIVWSWVRWGWIVXCW
      VKBUIWVEUTWHVXAVXCBUIUMWVDUNWVJVXBWDVRUIWWDVXCWEXAWVTWVQVTXAWWBWVJBUIUMUT
      WHVXCBUIUMUUJXAVXCBUIUIVXBWWAWGUUKWJUUKVXDFVRUIURVRUIURWKZVXDWLXAWGVXFWVF
      URWMUULVWSVXBUUMUUNVYKVYNUUOZFWUGWVHWUKFUIWUJWUHVXFWVHUJZUKULVXFUIUGZWUHW
      UIWWIUKWWJWWIWUIBVXFWVGWUIUIWVHBFUURZWVFVXMURWWKWVCVXJWVEVXLUPWVBVXFVWSWM
      WWKWVDVXKUMUNWVBVXFVXBWMUUPUUSZUUTWVHWNVXMURWOZUVAUVBUVCUVDUVEWPVXDWVAUKW
      UJVJVDZFUIWQZVXDWWNFUIWUHUKWUIVJVDZUKUKVJVDZWWNVXDWUIUKWUIWUJUKVJUVFUKWUJ
      UKVJUVFWUHVXDWWJWWPVXFVYKVYNUVGZVXDWWJUHZVXMWWFWVNWRWWSVXMVRUGZWRBFWWKWWF
      WWSWVNWWTWWKWVMWWJVXDWVBVXFUIUVHUVIWWKWVFVXMVRWWLUVJUVKWWCUVLZWSZWTWWQVXD
      WUHUVRZUHXBXAUVMUVNVXDWVAUIUKVMVNZWUKWUTVDWWOVXDUIWUKUIVRXCVXDXDXAWUKUIXE
      VXDFUIWUJWUKWUHWUIUKWWMXFXMZWUKWNZUVOXAUVPVXDFUIUKWUJVJWXDWUKWDWDWDWWEUKW
      DUGWWSXFXAWUJWDUGWWSWXEXAZWXDFUIUKUTWHVXDFUIUKUUJXAVXDWUKXGZXHUVQXIWUSWVA
      UHWULWUKUEUJZUIWUKUVSWUSWXIUIUGWVAWUKUVTWIXJXKZUWAVYRWUQUIUGZWUEVYRUIUKUW
      BVIUOZWUPWKZVXSUIUGZWUQVXSVJVDZWXKVYJVXEVYQWXMVXEVXTVYGVYIUWCVXEVYQUHZFUI
      WUOWXLWUPWXPWUOWXLUGZWWJWXPWUHWUNUKWXLWXPWUHUHZWUNXLUGZUKWUNVJVDZWUNWXLUG
      ZWXRWUNWXRWUMWXRVXHVXMAVYQWUHVXHVRUGZVXDAVYQUHZWUHVXGWYBWYCWUGIVXFAVYMVYO
      WUGIXCVYPAVYMVYOUHZUHZWUGGHVLUOZIAGXLUGZHXLUGZUHGVYKVJVDZVYNHVJVDZUHWUGWY
      FXCWYDAWYGWYHAGPXNAHQXNUWDVYMWYIVYOWYJVYMWYIVYKHVJVDZVYMWYGWYHVYKXLUGVKWY
      IWYKUHBCFGHVYKVJVJVIBCFUWEZUWFUWIUWGVYOGVYNVJVDZWYJVYOWYGWYHVYNXLUGVKWYMW
      YJUHBCFGHVYNVJVJVIWYLUWFUWIUWHUWJBCFUCGHVYKVYNVLVCVCVCVCVLVJVJBCFUWKZWYNG
      VYKUCUDZUWLWYOVYNHUWMUWNWBAWYFIXCWYDSWIUWSZXOXPAVXGWYBVYQAIVRVXFLUBVOZWFX
      QXRVXEWUHWWTVYQWUHVXEWWJWWTWWRVXDWWJWWTAWXAXSZWTWFUWOZXTXNWXRWUMWYSWSWUNY
      CZYAUKWXLUGZWXPWXCUHXUAUKXLUGWWQUWPXBUKYCUWQZXAYBWIWUPWNZYDYEVYIWXNVYHVYQ
      VYIVXRVXRUWRUWTZUXAVYJVYMVYOWXOVYPVYAVYIWYDWXOVYGVYAVYIUHZWYDUHZWUQVXSVCV
      DZWXOXUFWUQVXQVXSXUEVXEWYDWUQXLUGZVXEVXTVYIUXBZVXEWYDUHZWXMXUHXUJFUIWUOWX
      LWUPXUJWXQWWJXUJWUHWUNUKWXLXUJWUHUHWXSWXTWYAXUJWUHVXGWXSAWYDWUHVXGVXDWYEW
      UGIVXFWYPXPXRZVXEVXGWXSWYDVXEVXGUHZWUNXULWUMXULVXHVXMAVXGWYBVXDWYQWFVXEVX
      GWWJWWTAVXGWWJVXDAIUIVXFTXPWFWYRXQUWOZXTZXNWFXQXUJWUHVXGWXTXUKVXEVXGWXTWY
      DXULWUMXUMWSWFXQWYTYAXUAXUJWXCUHXUBXAYBWIXUCYDZWUPUXCYFYEZVXEVXQXLUGZVXTV
      YIWYDVXEUIWXLVXPWKZXUQVXEFUIVXOWXLVXPVXEWWJUHZVXOXLUGUKVXOVJVDZVXOWXLUGXU
      SVXOXUSVXNAVXDWWJVXNVRUGZAVXIVRUGWWTXVAWWSAVXGVXHUKVRWYQUKVRUGAVXGUVRUHUX
      IXAYBWXAVXIVXMUXDWBUXEZXTXNXUSVXNXVBWSZVXOYCYAVXPWNYDZVXPUXCYFYGVYIVXSXLU
      GZVYAWYDVYIVXSVXRUXFZUXGUXAZXUEVXEWYDWUQVXQVJVDZXUIXUJWXMXURWUPVXPWUTVDZX
      VHXUOVXEXURWYDXVDWIXUJXVIWUOVXOVJVDZFUIWQZXUJXVJFUIWUHWUNVXOVJVDZXUTXVJXU
      JWWJUHZWUNUKWUNWUOVXOVJUXHUKWUOVXOVJUXHXUJWUHXVLWWJXUJWUHVXGXVLXUKVXEVXGX
      VLWYDXULWUNWUNVXOVJXULWUNXUNUXJVXGVXOWUNWHVXEVXGVXNWUMURVXGVXIVXHVXMUQVXG
      VXHUKYHUXKUUTWJUXLWFXQWFXVMXUTWXCVXEWWJXUTWYDXVCWFWIUVMUXMAXVIXVKYNVXDWYD
      AFUIWUOVXOVJWUPVXPWDWDWDWWDAWEXAWUOWDUGAWWJUHZWUHWUNUKWUMURWOXFXMXAVXOWDU
      GXVNVXNURWOXAAWUPXGAVXPXGXHYIXIWUPVXPUXNYJYEVXEVXTVYIWYDUXOUXPZXUFXUHXVEX
      UGWXOWRXUPXVGWUQVXSUXSXKUXQXRXOVXSWUPUXRYJWIVYIWXNVYHVYQWUEXUDUXTZXVPWUFW
      ULVXSVCVDZWULWUCVBUOZWUDVCVDZWUFXVRVYTWUDVYHXVRUIUGZVYIVYQWUEVXEVYGXVTVXT
      VXDVYGXVTAVXDVYGUHZWULWUCVXDWURVYGWXJWIXWAVAVHUGWUBVHUGZWUCVHUGZUYKVXDVYG
      XWBVXDVYCXWBNVYFVXDVYBVYFUGZVYCUHZUHZWUBVXDWUBUIUGZXWEVXDWUAUIXCZWUAUYAVE
      ZVXRWVBVJVDCWUAWQBUIVGZXWGXWHVXDWUAURVFZUIURVYFUYBWWGXWKUIXCWLVRUIURYKYOU
      YCZXAZVXDUKURUJZWUAUGZXWIVXDVYFVRXCZUKVYFUGZXWOVXDVYFUIVRVXDVYDVYEUIVXAVY
      DUIXCZVXCVXAUIUIVWSWKZXWRWVRUIUIVWSYKYFWIVXCVYEUIXCZVXAVXCUIUIVXBWKZXWTWW
      AUIUIVXBYKYFWJUYDXDUYEZVXAXWQVXCVXAUKVYDUGXWQVWSUYFUKVYDVYEUYGYFWIURVRXEZ
      XWPXWQXWOWWGXXCWLVRUIURYLYOZVRVYFURUKYMYPXKZWUAXWNUYHYFZVXDXWHWUAYQUGZXWJ
      XWLVXDURUYIZVYFYQUGZXXGWWGXXHWLVRUIURUYJYOVXAVYDYQUGVYEYQUGXXIVXCVWSUYLVX
      BUYLVYDVYEUYMWBURVYFUYNWABCWUAUYOWAZBCWUAUYPYJZWIZXWFUKVYBURUJZWUBUKUIUGX
      WFVUBXAVXDXWDXXMUIUGVYCVXDXWDUHZVYBVXDVYFVRVYBXXBXPZXTUYQXXLVXDXWDVYCUKXX
      MVCVDZXXNVYCXXPXXNVYBVRUGVYCXXPYNXXOVYBUYRYFUYSUYTVXDXWDXXMWUBVJVDZVYCXXN
      XWHXWIXWJVKZXXMWUAUGZXXQVXDXXRXWDVXDXWHXWIXWJXWMXXFXXJVULZWIVXDXWPXWDXXSX
      XBXXCXWPXWDXXSXXDVRVYFURVYBYMYPYEBCWUAXXMYRXKUYQVUAVUCVUDVUEVAWUBVUFWAZVU
      GXSWFYGVYRVYTUIUGZWUEVYJAVYQXYBAVXDVXTVYGVYIVUHAVYMVYOXYBVYPWYEVYSAVYMVYO
      VYSVRUGZAVYOUHVYNVRUGVYKVRUGXYCAVYMUHAVYLVRVYNAVYLUIVRAGUIUGHUIUGVYLUIXCP
      QGHVUIXKZXDUYEZXPAVYLVRVYKXYEXPVYNVYKUXDYSVUJXTXOYEWIVYJWUDUIUGZVYQWUEVXE
      VYGVYIXYFVXTVXDVYGVYIXYFAXWAVYIUHWUDVYIVXSVHUGXWCWUDVHUGXWAXVFXYAVXSWUCVU
      MYSVUKVUNXRYIVYRXVRVYTVJVDZWUEVYHVYQXYGVYIVXEVYGVYQXYGVXTVXEVYGUHZVYQVYKU
      IUGZVYNUIUGZVYPVKZXYGXYHVYQXYKAVYQXYKWRVXDVYGAVYMXYIVYOXYJVYPVYPAVYLUIVYK
      XYDVUOAVYLUIVYNXYDVUOAVYPVUPVUQYIVUEXYHXYKUHZXVRWUGVPUJZVYTVJXYLXVRXYMVJV
      DWULWUCXYMUNUOZVJVDZVXEXYKXYOVYGVXDXYKXYOAVXDXYKUHWULFUIWUHWUCUKULZUTZUSU
      JZXYNVJVXDWULXYRVJVDZXYKVXDUIWXLWUKWKUIWXLXYQWKWUKXYQWUTVDZXYSVXDFUIWUJWX
      LWUKWWSWUIWXLUGZXUAWUJWXLUGWWSWUIXLUGWWPYUAWWSWUIWWSVXMWXAXTZXNWXBWUIYCYA
      XUBWUHWUIUKWXLVURWPWXFYDVXDFUIXYPWXLXYQVXDXYPWXLUGZWWJVXDWUCWXLUGXUAYUCVX
      DWUCWUBWUBUPUOZWXLVXDWUBVXDWUBXXKVSVUSZVXDYUDXLUGUKYUDVJVDYUDWXLUGVXDYUDV
      XDWUBWUBXXKXXKVUTZXNVXDWUBWUBXXKXXKVXDXXRUKWUAUGUKWUBVJVDZXXTVXDUKXWNWUAV
      VBXXEVVABCWUAUKYRXKZYUHVVCYUDYCYAXJXUBWUHWUCUKWXLVURWPWIXYQWNYDVXDXYTWUJX
      YPVJVDZFUIWQVXDYUIFUIVXDWUHYUIVXDWUHYUIVXDWUHUHWUIWUCWUJXYPVJWUHVXDWWJWUI
      WUCVJVDWWRWWSWUIYUDWUCVJWWSWUIVXJURUJZVXKURUJZUPUOZYUDYUBVXAVXCWWJYULUIUG
      ZVXAWWJUHZYUJUIUGZYUKUIUGZYUMVXCWWJUHZYUNVXJYUNVXJVXAUIUIVXFVWSWVRVOVSZXT
      ZYUQVXKYUQVXKVXCUIUIVXFVXBWWAVOVSZXTZYUJYUKVVDWBWCVXDYUDUIUGWWJYUFWIWWSWU
      IYUJVXLURUJZUPUOZYULVJVXAVXCWWJWUIYVCVJVDZYUNVXJVRUGVXLVRUGZYVDYUQYURYUQW
      VTVXKVRUGZYVEVTYUTUMVXKUUFWAVXJVXLVVEWBWCWWSYVBYUKYUJUPVXCWWJYVBYUKWHVXAY
      UQYVBVVFYUKUNUOZYUKYUQYVBUMURUJZYUKUNUOZYVGYUQWVTYVFYVBYVIWHVTYUTUMVXKVVG
      WAYVHVVFYUKUNVVHVVIVVJYUQYUKYUQYUKYVAVSVVKVVMXSUUPYTWWSYUJYUKWUBWUBVXAWWJ
      YUOVXCYUSWFVXCWWJYUPVXAYVAXSVXDXWGWWJXXKWIZYVJWWSXXRYUJWUAUGZYUJWUBVJVDVX
      DXXRWWJXXTWIZWWSXWPVXJVYFUGZYVKVXDXWPWWJXXBWIZVXAWWJYVMVXCYUNVXJVYDUGZYVM
      VXAVWSUIXEZWWJYVOVXAXWSYVPWVRUIUIVWSYLYFUIVXFVWSVVLYEVXJVYDVYEUYGYFWFXXCX
      WPYVMYVKXXDVRVYFURVXJYMYPXKBCWUAYUJYRXKWWSXXRYUKWUAUGZYUKWUBVJVDYVLWWSXWP
      VXKVYFUGZYVQYVNVXCWWJYVRVXAYUQVXKVYEUGZYVRVXCVXBUIXEZWWJYVSVXCXXAYVTWWAUI
      UIVXBYLYFUIVXFVXBVVLYEVXKVYEVYDVVNYFXSXXCXWPYVRYVQXXDVRVYFURVXKYMYPXKBCWU
      AYUKYRXKVVOVVPVXDWUCYUDWHWWJYUEWIUXLWTWUHWUJWUIWHVXDWUHWUIUKYHWJWUHXYPWUC
      WHVXDWUHWUCUKYHWJVVQVVRWXCUKUKWUJXYPVJWWQWXCXBXAWUHWUIUKVVSWUHWUCUKVVSVVQ
      VVTUVNVXDFUIWUJXYPVJWUKXYQWDWDWDWWEWXGXYPWDUGWWSWUHWUCUKVAWUBUNUUQXFXMXAW
      XHVXDXYQXGXHXIWUKXYQUXNYJWIXYKXYMUIUGZWUCUKUWBVWAUOZUGZXYRXYNWHZVXDXYKXYM
      VYSUIXYKXYMWUGVWDUJZVYSWVIXYMYWEWHWWHWUGVWBYOZVYKVYNVWCZVWEXYIXYJVYSUIUGZ
      VYPXYJXYIYWHVYNVYKVWFVWGVWHXJZVXDWUCYUDYWBYUEVXDWUBYWBUGZYWJYUDYWBUGVXDXW
      GYUGYWJXXKYUHWUBVWIYAZYWKWUBWUBVWMXKXJWVIYWAYWCYWDWWHFWUGWUCVWJYPYSYTXSWF
      XYLWULXYMWUCVXDWURAVYGXYKWXJUXTXYKYWAXYHYWIWJXYHXWCXYKVXDVYGXWCAXYAXSZWIV
      WKXIXYKXYMVYTWHXYHXYKXYMYWEVYTYWFXYKYWEVYSVYTYWGVYKVYNVWLVWNVWEWJYTXQXRWF
      WIVYRWUEVWOVWPVYJXVQXVSYNVYQWUEVYJWULVXSWUCVXEWURVXTVYGVYIVXDWURAWXJWJYGV
      YIWXNVYHXUDWJVYHXWCVYIVXEVYGXWCVXTYWLWFWIVWQYIXIVYRXUGWUEVYJVYMVYOXUGVYPV
      YAVYIWYDXUGVYGXVOXRXOWIVWR $.
    $( Lemma for ~ ftc1anc .  (Contributed by Brendan Leahy, 29-May-2018.) $)
    ftc1anclem8 $p |- ( ( ( ( ( ( ( ph /\ ( f e. dom S.1 /\
      g e. dom S.1 ) ) /\ ( S.2 ` ( t e. RR |-> ( abs ` ( if ( t e. D ,
        ( F ` t ) , 0 ) - ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ) )
      ) < ( y / 2 ) ) /\ E. r e. ( ran f u. ran g ) r =/= 0 ) /\ y e. RR+ ) /\
        ( u e. ( A [,] B ) /\ w e. ( A [,] B ) /\ u <_ w ) ) /\ ( abs `
      ( w - u ) ) < ( ( y / 2 ) / ( 2 x. sup ( ( abs " ( ran f u. ran g ) ) ,
        RR , < ) ) ) ) -> ( S.2 ` ( t e. RR |-> if ( t e. ( u (,) w ) ,
      ( ( abs ` ( ( F ` t ) - ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ) +
        ( abs ` ( ( f ` t ) + ( _i x. ( g ` t ) ) ) ) ) , 0 ) ) ) < y ) $=
      ( cv cdm wcel wa cr cfv cc0 cif ci cmul co caddc cmin cabs cmpt citg2 clt
      wbr cicc cle w3a cioo wceq cmbf cvv wss a1i c0ex ifex adantl iffalse cres
      syl iftrue mpteq2ia ax-mp ccom cc ffvelrnda recnd ax-icn sylancr anandirs
      syl2an reex adantlr adantll feqmptd adantr offval2 wf absf fmptco sylancl
      eqeltrrd mbfss absge0d elrege0 sylanbrc 0re 0le0 ifcl eqid fmptd ad2antlr
      abscld cxr rexrd elxrge0 0xr wfn syl2anc sylan syl6eq wral breq1 c1 eqtrd
      ffn oveq2d eqidd ofrfval2 mpbird syl3anc itg2lecl adantllr breq2 ifbothda
      itg2le syldan ad2antrr ifclda cre cim readdcld fveq2d 3brtr4d oveq12d wne
      vz citg1 c2 cdiv crn cun wrex crp cima ftc1anclem7 simplll 3simpa ioossre
      csup cof cvol rembl fvex cdif wn eldifn resmpt eqtr4i csn cxp mulcl addcl
      i1ff fconstmpt fveq2 ftc1anclem3 i1fmbf ioombl syl5eqel cpnf mpbir2an c0p
      mbfres cico cofr frn ax-resscn syl6ss mp3an1 inidm fvco3 offval mpteq2dva
      fnco addid1d mul01i mpteq2i 3eqtr4d coeq2d mpan2 weq coeq2 eleq1d vtoclga
      i1fadd ge0addcl 0plef sylib simprd itg2itg1 itg1cl eqeltrd anim1i 3imtr4i
      i1f0 rexr ssriv readdcl leidd ifboth abstri absmul oveq1i mulid2d breqtrd
      fss absi letrd ralrimiva elioore sylan2 jca df-icc elixx3g simprbi simpld
      anim12i df-ioo xrlelttr xrltletr ixxss12 sselda breqtrrd ralrimivw subcld
      sstrd cibl cpr ccncf recncf prid1g ftc1anclem2 mp3an3 imcncf prid2g recld
      wb off cneg negcld addcld abstrid absnegd replimd eqtr2d leadd2dd abssubd
      imcld negsubd pm2.61d1 eqtr4d 00id oveq2i eqtri 3eqtr4a pm2.61i syl6breqr
      xrletrd ovex reseq1d sylan9eqr syl6eqr fdm iblmbf mbfdm 3syl syl2anr fvif
      0cn abs0 ifeq2 ismbfcn2 mpbid ftc1anclem1 itg2addnc eqeq2 mpteq2dv simplr
      ex addcomd ifeq1da eqtr3d rpcn 2halvesd ad3antlr 3brtr3d ) AJUCZUUCUDZUEZ
      KUCZVXDUEZUFZUFZFUGFUCZIUEZVXJLUHZUIUJVXJVXCUHZUKVXJVXFUHZULUMZUNUMZUOUMU
      PUHUQURUHCUCZUUDUUEUMZUSUTZUFNUCUIUUANVXCUUFZVXFUUFZUUGZUUHZUFZVXQUUIUEZU
      FZEUCZGHVAUMZUEZDUCZVYHUEZVYGVYJVBUTZVCZUFZVYJVYGUOUMUPUHVXRUUDUPVYBUUJUG
      USUUOULUMUUEUMUSUTZUFFUGVXJVYGVYJVDUMZUEZVXPUPUHZUIUJZUQZURUHZFUGVYQVXLVX
      PUOUMZUPUHZUIUJZUQZURUHZUNUMZVXRVXRUNUMZFUGVYQWUCVYRUNUMZUIUJZUQZURUHZVXQ
      USABCDEFGHIJKLMNOPQRSTUAUBUUKVYNWUGWULVEZVYOVYFVXIVYIVYKUFZWUMVYMVXIVXSVY
      CVYEUULVYIVYKVYLUUMVXIWUNUFZVYTWUEUNUUPZUMZURUHWUGWULWUOVYTWUEVXIVYTVFUEW
      UNVXIFVYPUGVYSVGVYPUGVHZVXIVYGVYJUUNZVIUGUUQUDZUEZVXIUURVIZVYSVGUEZVXIVYQ
      UFVYQVYRUIVXPUPUUSZVJVKZVIVXIVXJUGVYPUUTUEZUFVYQUVAZVYSUIVEWVFWVGVXIVXJUG
      VYPUVBVLVYQVYRUIVMZVOVXHFVYPVYSUQZVFUEAVXHWVIFUGVYRUQZVYPVNZVFWVIFVYPVYRU
      QZWVKFVYPVYSVYRVYQVYRUIVPZVQWURWVKWVLVEWUSFUGVYPVYRUVCVRUVDVXHWVJVFUEZVYP
      WUTUEWVKVFUEVXHWVJVXDUEWVNVXHUPVXCUGUKUVEUVFZVXFULUUPZUMZWUPUMZVSZWVJVXDV
      XHFBUGVTVXPBUCZUPUHZVYRWVRUPVXEVXGVXJUGUEZVXPVTUEZVXEWWBUFZVXMVTUEZVXOVTU
      EZWWCVXGWWBUFZWWDVXMVXEUGUGVXJVXCVXCUVIZWAZWBZWWGUKVTUEZVXNVTUEZWWFWCWWGV
      XNVXGUGUGVXJVXFVXFUVIZWAZWBZUKVXNUVGWDZVXMVXOUVHWFWEZVXHFUGVXMVXOUNVXCWVQ
      VGUGVTUGVGUEZVXHWGVIZVXEWWBVXMUGUEVXGWWIWHZVXGWWBWWFVXEWWPWIVXEVXCFUGVXMU
      QZVEVXGVXEFUGUGVXCWWHWJZWKZVXGWVQFUGVXOUQVEVXEVXGFUGUKVXNULWVOVXFVGVTUGWW
      RVXGWGVIWWKWWGWCVIWWNWVOFUGUKUQVEZVXGFUGUKUVJZVIVXGFUGUGVXFWWMWJWLVLZWLVX
      HBVTUGUPVTUGUPWMZVXHWNVIWJZWVTVXPUPUVKZWOVXCVXFUVLZWQWVJUVMVOVYGVYJUVNVYP
      WVJUVSWPUVOVLWRWKVXHUGUIUVPUVTUMZVYTWMAWUNVXHFUGVYSWXKVYTVXHWWBUFZVYRWXKU
      EZUIWXKUEZVYSWXKUEWXLVYRUGUEZUIVYRVBUTZWXMWXLVXPWWQXHZWXLVXPWWQWSZVYRWTXA
      ZWXNUIUGUEZUIUIVBUTZXBXCUIWTUVQZVYQVYRUIWXKXDWPVYTXEZXFXGWUOUGUIUVPVAUMZV
      YTWMZFUGVXKVYRUIUJZUQZURUHZUGUEZWUAWYHVBUTZWUAUGUEVXHWYEAWUNVXHFUGVYSWYDV
      YTWXLVYRWYDUEZUIWYDUEZVYSWYDUEWXLVYRXIUEWXPWYKWXLVYRWXQXJWXRVYRXKXAZWYLUI
      XIUEZWYAXLXCUIXKUVQZVYQVYRUIWYDXDWPWYCXFXGZVXHWYIAWUNVXHUGWYDWYGWMZFUGVXM
      UPUHZVXNUPUHZUNUMZUQZURUHZUGUEZWYHXUBVBUTZWYIVXHFUGWYFWYDWYGWXLWYKWYLWYFW
      YDUEWYMWYOVXKVYRUIWYDXDWPWYGXEZXFZVXHXUAVXDUEZUVRXUAVBUWAZUTZXUCVXHUPVXCV
      SZUPVXFVSZWUPUMXUAVXDVXHFUGUGWYRWYSUNUGXUJXUKVGVGVXEXUJUGXMZVXGVXEUGUGVXC
      WMZXULWWHXUMVXCUGXMZVXTVTVHZXULUGUGVXCYAXUMVXTUGVTUGUGVXCUWBUWCUWDUPVTXMZ
      XUNXUOXULWXGXUPWNVTUGUPYAVRZVTUGUPVXCUWJUWEXNVOWKVXGXUKUGXMZVXEVXGUGUGVXF
      WMZXURWWMXUSVXFUGXMZVYAVTVHZXURUGUGVXFYAXUSVYAUGVTUGUGVXFUWBUWCUWDXUPXUTX
      VAXURXUQVTUGUPVXFUWJUWEXNVOVLWWSWWSUGUWFZVXHXUMWWBVXJXUJUHWYRVEVXEXUMVXGW
      WHWKUGUGVXJUPVXCUWGXOVXHXUSWWBVXJXUKUHWYSVEVXGXUSVXEWWMVLUGUGVXJUPVXFUWGX
      OUWHVXHXUJXUKVXEXUJVXDUEZVXGVXEUPVXCWVOUGUIUVEUVFZWVPUMZWUPUMZVSZXUJVXDVX
      EXVFVXCUPVXEFUGVXMUIUNUMZUQWXAXVFVXCVXEFUGXVHVXMWWDVXMWWJUWKUWIVXEFUGVXMU
      IUNVXCXVEVGUGVGWWRVXEWGVIZWWIUIVGUEWWDVJVIZWXBVXEXVEFUGUKUIULUMZUQFUGUIUQ
      ZVXEFUGUKUIULWVOXVDVGVTVGXVIWWKWWDWCVIXVJWXDVXEWXEVIXVDXVLVEVXEFUGUIUVJVI
      WLFUGXVKUIUKWCUWLUWMXPWLWXBUWNUWOVXEXVDVXDUEXVGVXDUEUXKVXCXVDUVLUWPWQZWKV
      XGXUKVXDUEZVXEXVCXVNJVXFVXDJKUWQXUJXUKVXDVXCVXFUPUWRUWSXVMUWTVLUXAWQVXHUG
      UGXUAWMZXUIVXHUGWXKXUAWMZXVOXUIUFVXHFUGWYTWXKXUAVXEVXGWWBWYTWXKUEZWWDWYRW
      XKUEZWYSWXKUEZXVQWWGWWDWYRUGUEZUIWYRVBUTXVRWWDVXMWWJXHZWWDVXMWWJWSWYRWTXA
      WWGWYSUGUEZUIWYSVBUTXVSWWGVXNWWOXHZWWGVXNWWOWSWYSWTXAWYRWYSUXBWFWEXUAXEXF
      ZXUAUXCUXDUXEXUGXUIUFXUBXUAUUCUHZUGXUAUXFXUGXWEUGUEXUIXUAUXGWKUXHXNVXHWYQ
      UGWYDXUAWMZWYGXUAXUHUTZXUDXUFVXHXVPWXKWYDVHZXWFXWDBWXKWYDWVTUGUEZUIWVTVBU
      TZUFWVTXIUEZXWJUFWVTWXKUEZWVTWYDUEXWIXWKXWJWVTUXLUXIWVTWTWVTXKUXJUXMZUGWX
      KWYDXUAUYBWPVXHXWGWYFWYTVBUTZFUGXQVXHXWNFUGWXLWYFVYRWYTWXLWXOWXTWYFUGUEWX
      QXBVXKVYRUIUGXDWPZWXQVXEVXGWWBWYTUGUEZWWDXVTXWBXWPWWGXWAXWCWYRWYSUXNWFWEZ
      WXLVYRVYRVBUTZWXPWYFVYRVBUTZWXLVYRWXQUXOZWXRVXKXWRWXPXWSVYRUIVYRWYFVYRVBX
      RUIWYFVYRVBXRUXPXNWXLVYRWYRVXOUPUHZUNUMZWYTVBVXEVXGWWBVYRXXBVBUTZWWDWWEWW
      FXXCWWGWWJWWPVXMVXOUXQWFWEWXLXXAWYSWYRUNVXGWWBXXAWYSVEVXEWWGXXAXSWYSULUMZ
      WYSWWGXXAUKUPUHZWYSULUMZXXDWWGWWKWWLXXAXXFVEWCWWOUKVXNUXRWDXXEXSWYSULUYCU
      XSXPWWGWYSWWGWYSXWCWBUXTXTWIYBUYAUYDUYEVXHFUGWYFWYTVBWYGXUAVGUGUGWWSXWOXW
      QVXHWYGYCVXHXUAYCYDYEWYGXUAYKYFXUBWYGYGYFZXGZWUOWYEWYQVYTWYGXUHUTZWYJWYPV
      XHWYQAWUNXUFXGWUOXXIVYSWYFVBUTZFUGXQZWUOXXJFUGVYQVYRWYFVBUTUIWYFVBUTZXXJW
      UOVYRUIVYRVYSWYFVBXRUIVYSWYFVBXRWUOVYQUFZVYRVYRWYFVBVXIVYQXWRWUNVXHVYQXWR
      AVYQVXHWWBXWRVXJVYGVYJUYFZXWTUYGWIWHAWUNVYQWYFVYRVEZVXHAWUNUFZVYQUFVXKXXO
      XXPVYPIVXJXXPVYPGHVDUMZIAGXIUEZHXIUEZUFGVYGVBUTZVYJHVBUTZUFVYPXXQVHWUNAXX
      RXXSAGPXJAHQXJUYHVYIXXTVYKXYAVYIXXTVYGHVBUTZVYIXXRXXSVYGXIUEVCXXTXYBUFBCF
      GHVYGVBVBVABCFUYIZUYJUYKUYLVYKGVYJVBUTZXYAVYKXXRXXSVYJXIUEVCXYDXYAUFBCFGH
      VYJVBVBVAXYCUYJUYKUXEUYMBCFUUBGHVYGVYJVDUSUSUSUSVDVBVBBCFUYNZXYEGVYGUUBUC
      ZUYOXYFVYJHUYPUYQWFAXXQIVHWUNSWKVUBUYRZVXKVYRUIVPZVOYHUYSVXIXXLWUNWVGVXKW
      XPWYAXXLVXIVYRUIVYRWYFUIVBYIUIWYFUIVBYIVXIVXKWWBWXPAVXKWWBVXHAIUGVXJTUYRW
      HZVXHWWBWXPAWXRWIYLWYAVXIVXKUVAZUFZXCVIZYJYMYJUYTAXXIXXKVUMVXHWUNAFUGVYSW
      YFVBVYTWYGVGVGVGWWRAWGVIZWVCAWWBUFZWVEVIZWYFVGUEZXYNVXKVYRUIWVDVJVKZVIZAV
      YTYCZAWYGYCZYDYMYEVYTWYGYKYFWYHVYTYGYFWUOFUGWUDWXKWUEWUOWUDWXKUEWWBWUOVYQ
      WUCUIWXKXXMWUCUGUEUIWUCVBUTZWUCWXKUEXXMWUBXXMVXLVXPAWUNVYQVXLVTUEZVXHXXPV
      YQVXKYUBXYGAVXKYUBWUNAIVTVXJLUBWAZWHYLYHVXIVYQWWCWUNVXHVYQWWCAVYQVXHWWBWW
      CXXNWWQUYGZWIWHVUAZXHZXXMWUBYUEWSZWUCWTXAWXNWUOWVGUFZWYBVIYNWKWUEXEZXFWUO
      UGWYDWUEWMZWYHFUGVXKVXLYOUHZUPUHZUIUJZUQZURUHZFUGVXKVXLYPUHZUPUHZUIUJZUQZ
      URUHZUNUMZUNUMZUGUEWUFYVBVBUTWUFUGUEWUOFUGWUDWYDWUEWUOWUDWYDUEWWBWUOVYQWU
      CUIWYDXXMWUCXIUEYUAWUCWYDUEXXMWUCYUFXJZYUGWUCXKXAWYLYUHWYOVIYNWKYUIXFZWUO
      WYHYVAXXHAYVAUGUEVXHWUNAYUOYUTAIVTLWMZLVUCUEZYUOUGUEZUBUAYVEYVFYOYOYPVUDZ
      UEZYVGYOVTUGVUEUMZUEYVIVUFYOYPYVJVUGVRFILYOVUHVUIXNZAYVEYVFYUTUGUEZUBUAYV
      EYVFYPYVHUEZYVLYPYVJUEYVMVUJYOYPYVJVUKVRFILYPVUHVUIXNZYQZYMYQWUOWUFWYGYUN
      YUSWUPUMZWUPUMZURUHZYVBVBWUOYUJUGWYDYVQWMZWUEYVQXUHUTZWUFYVRVBUTYVDVXIYVS
      WUNVXIUGWXKYVQWMXWHYVSVXIBCUGUGUGUNWXKWXKWXKWYGYVPVGVGXWLVXQWXKUEUFZWVTVX
      QUNUMWXKUEZVXIWVTVXQUXBZVLVXHUGWXKWYGWMAVXHFUGWYFWXKWYGWXLWXMWXNWYFWXKUEW
      XSWYBVXKVYRUIWXKXDWPXUEXFVLZAUGWXKYVPWMVXHABCUGUGUGUNWXKWXKWXKYUNYUSVGVGY
      WAYWBAYWCVLAFUGYUMWXKYUNAYUMWXKUEWWBAVXKYULUIWXKAVXKUFZYULUGUEUIYULVBUTYU
      LWXKUEYWEYUKYWEYUKYWEVXLYUCVULZWBZXHZYWEYUKYWGWSYULWTXAWXNAXYJUFZWYBVIZYN
      WKYUNXEXFZAFUGYURWXKYUSAYURWXKUEWWBAVXKYUQUIWXKYWEYUQUGUEUIYUQVBUTYUQWXKU
      EYWEYUPYWEYUPYWEVXLYUCVVDWBZXHZYWEYUPYWLWSYUQWTXAYWJYNWKYUSXEXFZXYMXYMXVB
      VUNWKZWWRVXIWGVIZYWPXVBVUNXWMUGWXKWYDYVQUYBWPWKWUOYVTWUDWYFYUMYURUNUMZUNU
      MZVBUTZFUGXQZWUOYWSFUGWUOWUDVXKWUCUIUJZYWRWUOVYQWUCUIXIYVCWYNYUHXLVIYNVXI
      YXAXIUEWUNVXIVXKWUCUIXIVXIVXKUFZWUCYXBWUBYXBVXLVXPAVXKYUBVXHYUCWHZVXIVXKW
      WBWWCXYIVXHWWBWWCAWWQWIYLZVUAZXHZXJWYNXYKXLVIYNWKVXIYWRXIUEWUNVXIYWRVXIWY
      FYWQVXIVXKVYRUIUGYXBVXPYXDXHZWXTXYKXBVIYNAYWQUGUEVXHAYUMYURAVXKYULUIUGYWH
      WXTYWIXBVIZYNZAVXKYUQUIUGYWMYXHYNZYQWKYQXJWKVYQWUCYXAVBUTZUIYXAVBUTZWUDYX
      AVBUTWUOWUCUIWUCWUDYXAVBXRUIWUDYXAVBXRWUOVYQVXKYXKAWUNVYQVXKVXHXYGYHWUOVX
      KUFWUCWUCYXAVBVXIVXKWUCWUCVBUTWUNYXBWUCYXFUXOWHVXKYXAWUCVEZWUOVXKWUCUIVPZ
      VLUYSYLVXIYXLWUNWVGVXKYUAWYAYXLVXIWUCUIWUCYXAUIVBYIUIYXAUIVBYIYXBWUBYXEWS
      XYLYJYMYJVXIYXAYWRVBUTWUNVXIYXAVXKVYRYULYUQUNUMZUNUMZUIUJZYWRVBVXIVXKYXAY
      XQVBUTZVXIVXKYXRYXBVXPVXLVUOZUNUMZUPUHZYXPYXAYXQVBYXBYYAVYRYXSUPUHZUNUMYX
      PYXBYXTYXBVXPYXSYXDAVXKYXSVTUEVXHYWEVXLYUCVUPZWHZVUQXHYXBVYRYYBYXGAVXKYYB
      UGUEVXHYWEYXSYYCXHWHZYQYXBVYRYXOYXGAVXKYXOUGUEVXHYWEYULYUQYWHYWMYQWHZYQYX
      BVXPYXSYXDYYDVURYXBYYBYXOVYRYYEYYFYXGAVXKYYBYXOVBUTVXHYWEYUKUKYUPULUMZUNU
      MZUPUHZYULYYGUPUHZUNUMYYBYXOVBYWEYUKYYGYWGYWEWWKYUPVTUEZYYGVTUEWCYWLUKYUP
      UVGWDVURYWEYYBVXLUPUHYYIYWEVXLYUCVUSYWEVXLYYHUPYWEVXLYUCVUTYRXTYWEYUQYYJY
      ULUNYWEYYJXSYUQULUMZYUQYWEYYJXXEYUQULUMZYYLYWEWWKYYKYYJYYMVEWCYWLUKYUPUXR
      WDXXEXSYUQULUYCUXSXPYWEYUQYWEYUQYWMWBUXTVVAYBYSWHVVBUYDYXBWUCVXPVXLUOUMZU
      PUHYXAYYAYXBVXLVXPYXCYXDVVCVXKYXMVXIYXNVLYXBYXTYYNUPYXBVXPVXLYXDYXCVVEYRU
      WNVXKYXQYXPVEVXIVXKYXPUIVPZVLYSVWOXYJUIUIYXAYXQVBWYAXYJXCVIVXKWUCUIVMVXKY
      XPUIVMZYSVVFVXKYWRYXQVEVXKYWRYXPYXQVXKWYFVYRYWQYXOUNXYHVXKYUMYULYURYUQUNV
      XKYULUIVPVXKYUQUIVPYTYTYYOVVGXYJUIUIUIUNUMZUNUMZUIYWRYXQYYRYYQUIYYQUIUIUN
      VVHVVIVVHVVJXYJWYFUIYWQYYQUNVXKVYRUIVMZXYJYUMUIYURUIUNVXKYULUIVMVXKYUQUIV
      MYTYTYYPVVKVVLVVMWKVVNUYTAYVTYWTVUMVXHWUNAFUGWUDYWRVBWUEYVQVGVGVGXYMWUDVG
      UEXYNVYQWUCUIWUBUPUUSVJVKVIZYWRVGUEXYNWYFYWQUNVVOVIAWUEYCZAFUGWYFYWQUNWYG
      YVPVGVGVGXYMXYRYWQVGUEXYNYUMYURUNVVOVIXYTAFUGYUMYURUNYUNYUSVGUGUGXYMAYUMU
      GUEWWBYXIWKAYURUGUEWWBYXJWKAYUNYCAYUSYCWLWLYDYMYEWUEYVQYKYFVXIYVRYVBVEWUN
      VXIYVRWYHYVPURUHZUNUMYVBVXIWYGYVPVXIFIUGWYFVGAIUGVHZVXHTWKWVBXYPYXBXYQVIV
      XJUGIUUTUEZWYFUIVEZVXIUUUDXYJUUUEVXJUGIUVBZYYSVOVLVXIWVSIVNZFIWYFUQZVFVXI
      UUUGFIVYRUQZUUUHVXHAUUUGWVJIVNZUUUIVXHWVSWVJIVXHFBUGVTVXPWWAVYRWVRUPWWQVX
      HFUGVXMVXOUNVXCWVQVGUGVGWWSWWTVXOVGUEWXLUKVXNULVVOVIWXCWXFWLWXHWXIWOVVPAU
      UUCUUUJUUUIVETFUGIVYRUVCVOVVQFIWYFVYRXYHVQVVRVXHWVSVFUEZIWUTUEUUUGVFUEAVX
      HWVSVXDUEUUUKWXJWVSUVMVOALUDZIWUTAYVEUUULIVEUBIVTLVVSVOAYVFLVFUEZUUULWUTU
      EUALVVTZLVWAVWBWQIWVSUVSVWCWQWRYWDVXHWYIAXXGVLYWOAUUUBUGUEVXHAUUUBYVAUGAY
      UNYUSAUPFUGVXKYUKUIUJZUQZVSZYUNVFAFBUGVTUUUOWWAYUMUUUPUPAUUUOVTUEWWBAVXKY
      UKUIVTYWGUIVTUEYWIVWEVIYNWKAUUUPYCABVTUGUPWXGAWNVIWJWVTUUUOVEWWAUUUOUPUHZ
      YUMWVTUUUOUPUVKUUURVXKYULUIUPUHZUJZYUMVXKYUKUIUPVWDUUUSUIVEUUUTYUMVEVWFVX
      KUUUSUIYULVWGVRVVJXPWOAUGUGUUUPWMUUUPVFUEUUUQVFUEAFUGUUUOUGUUUPAUUUOUGUEZ
      WWBAVXKYUKUIUGYWFYXHYNZWKUUUPXEXFAFIUGUUUOUGTWVAAUURVIAUUVAVXKUUVBWKAUUUD
      UFXYJUUUOUIVEUUUDXYJAUUUFVLVXKYUKUIVMVOAFIUUUOUQFIYUKUQZVFFIUUUOYUKVXKYUK
      UIVPVQAUUVCVFUEZFIYUPUQVFUEZAFIVXLUQZVFUEUUVDUUVEUFALUUVFVFAFIVTLUBWJAYVF
      UUUMUAUUUNVOWQAFIVXLYUCVWHVWIUYLUVOWRUGUUUPVWJXNWQYWKYVKYWNYVNVWKZYVOUXHW
      KVWKVXIUUUBYVAWYHUNAUUUBYVAVEVXHUUVGWKYBXTWKUYAYVBWUEYGYFVWKWUOWUQWUKURWU
      OWUQFUGVYQVYRWUCUNUMZUIUJZUQZWUKAWUQUUVJVEVXHWUNAWUQFUGVYSWUDUNUMZUQUUVJA
      FUGVYSWUDUNVYTWUEVGVGVGXYMXYOYYTXYSUUUAWLAFUGUUVKUUVIVYQUUVKUUVHVEZUUVKUI
      VEZUUVKUUVIVEAUUVHUIUUVHUUVIUUVKVWLUIUUVIUUVKVWLVYQUUVLAVYQVYSVYRWUDWUCUN
      WVMVYQWUCUIVPYTVLWVGUUVMAWVGUUVKYYQUIWVGVYSUIWUDUIUNWVHVYQWUCUIVMYTVVHXPV
      LYJVWMXTYMWUOFUGUUVIWUJWUOVYQUUVHWUIUIXXMVYRWUCWUOVXHVYQVYRVTUEAVXHWUNVWN
      VXHVYQUFZVYRUUVNVXPYUDXHWBXOXXMWUCYUFWBVWPVWQVWMXTYRVWRWFWKVYEWUHVXQVEVYD
      VYMVYOVYEVXQVXQVWSVWTVXAVXB $.
    ftc1anc.t $e |- ( ph -> A. s e. ( (,) " ( ( A [,] B ) X. ( A [,] B ) ) )
      ( abs ` S. s ( F ` t ) _d t ) <_ ( S.2 ` ( t e. RR |-> if ( t e. s ,
        ( abs ` ( F ` t ) ) , 0 ) ) ) ) $.
    $( ~ ftc1a holds for functions that obey the triangle inequality in the
       absence of ~ ax-cc .  Theorem 565Ma of [Fremlin5] p. 220.  (Contributed
       by Brendan Leahy, 11-May-2018.) $)
    ftc1anc $p |- ( ph -> G e. ( ( A [,] B ) -cn-> CC ) ) $=
      ( wcel cr vw vu vz vy vf vg vr vb va cicc co cc wf cv cmin cfv clt wbr wi
      cabs wral crp wrex wa cc0 cif ci cmul caddc cmpt citg2 sylan2 wne crn cle
      c2 wss frn syl adantr adantl wfn absf ax-mp fnfvima mp3an1 syl2anc syl2an
      ffn cfn sylancr a1i sselda abscld adantrr wb w3a anassrs adantlr an32 weq
      sylan wceq fveq2d fveq2 oveqan12rd imbi12d syl2anr anandis ffvelrnda cioo
      breq1d cxr cpnf rexrd absge0d syldan wn ifclda eqid fmptd itg2cl 3adantr3
      adantll ad3antlr ex ralrimivw cvv c0ex ifex eqidd syl3anc oveq2 3ad2antr2
      citg itgeq1 3ad2antr1 cibl eqtrd breq2 ccncf ftc1lem2 cdiv citg1 rphalfcl
      cdm ftc1anclem6 adantrl cun cima csup ad2antll 2rp unssd ax-resscn syl6ss
      c0 i1ff i1f0rn elun1 ne0i imassrn sstri wfun ffun i1frn unfi imafi suprcl
      fimaxre2 0re absgt0 biimpd impr 3jca ltletrd rexlimdvaa imp elrpd rpmulcl
      suprub rpdivcl ancom anbi2i anbi1i 3bitr4i oveq12 iccssre ad4antr simp-4l
      bitri anass ancoms abssub jca df-icc elixx3g simprbi simpld simprd df-ioo
      anim12i xrlelttr xrltletr ixxss12 sstrd elxrge0 sylanbrc 0xr pnfxr lbicc2
      pnfge mp3an simplll adantllr elioore recnd ax-icn mulcl anandirs readdcld
      addcl subcld addge0d rpxr cofr npcand abstrid iftrue 3brtr4d 0le0 iffalse
      eqbrtrrd pm2.61d1 reex ofrfval2 ad2antrr mpbird itg2le ftc1anclem8 anim1i
      fvex ovex xrlelttrd simpr2 itgex fvmpt elicc1 biimpa simp2d simpr3 iooss2
      mpbir3and eleq1 anbi2d mpteq1d eleq1d cvol ioombl feqmptd eqeltrrd chvarv
      iblss itgsplitioo simpr1 oveq12d itgcl pncan2d wel cxp df-ov opelxpi ioof
      cop cpw iccssxr xpss12 mp2an mp3an12 syl5eqel eleq2 ifbid breq12d rspccva
      mpteq2dv eqbrtrd subcl ad2antlr mpand mpd wlogle sylanb ralrimiva ralbidv
      imbi1d rspcev ralnex nne ralbii bitr3i fnfvelrn eqeq1 rspcva elun2 oveq2d
      mul01i syl6eq adantlll an32s 00id subid1d ad3antrrr fvif abs0 ifeq2 eqtri
      0cn mpteq2dva com23 imp32 anasss 1rp adantlrr rpre rehalfcld leidd ifboth
      breq1 ssneld syl6eqbr ifbothda xrletrd simplr rphalflt a1d r19.2z sylan2b
      c1 lttrd pm2.61dan rexlimdvva ralrimivva ssid elcncf2 sylancl mpbir2and )
      AHDEUJUKZULUUAUKSZWUGULHUMZUAUNZUBUNZUOUKZUTUPZUCUNZUQURZWUJHUPZWUKHUPZUO
      UKZUTUPZUDUNZUQURZUSZUAWUGVAZUCVBVCZUDVBVAUBWUGVAZABCDEFGHJKLMNOPQUUBZAWV
      DUBUDWUGVBAWUKWUGSZWUTVBSZVDZVDZCTCUNZFSZWVKGUPZVEVFZWVKUEUNZUPZVGWVKUFUN
      ZUPZVHUKZVIUKZUOUKZUTUPZVJZVKUPZWUTVPUUCUKZUQURZUFUUDUUFZVCUEWWGVCZWVDAWV
      HWWHWVGWVHAWWEVBSZWWHWUTUUEZABCDEFUEUFGHWWEJKLMNOPQUUGVLUUHWVJWWFWVDUEUFW
      WGWWGWVJWVOWWGSZWVQWWGSZVDZVDZWWFWVDWWNWWFVDZUGUNZVEVMZUGWVOVNZWVQVNZUUIZ
      VCZWVDWWOWXAVDZWWEVPUTWWTUUJZTUQUUKZVHUKZUUCUKZVBSZWUMWXFUQURZWVAUSZUAWUG
      VAZWVDWWNWXAWXGWWFWVJWWMWXAWXGWVJWWIWXEVBSZWXGWWMWXAVDZWVHWWIAWVGWWJUULWX
      LVPVBSWXDVBSWXKUUMWXLWXDWWMWXDTSZWXAWWMWXCUUQVMZWUTBUNZVOURUDWXCVABTVCZWX
      MWWMVEUTUPZWXCSZWXNWWMWWTULVQZVEWWTSZWXRWWMWWTTULWWMWWRWWSTWWKWWRTVQZWWLW
      WKTTWVOUMZWYAWVOUURZTTWVOVRVSVTWWLWWSTVQZWWKWWLTTWVQUMZWYDWVQUURZTTWVQVRV
      SWAUUNUUOUUPZWWKWXTWWLWWKVEWWRSWXTWVOUUSVEWWRWWSUUTVSVTUTULWBZWXSWXTWXRUL
      TUTUMZWYHWCULTUTWIWDZULWWTUTVEWEWFWGWXCWXQUVAVSZWWMWXCTVQZWXCWJSZWXPWXCUT
      VNZTUTWWTUVBWYIWYNTVQWCULTUTVRWDUVCZWWMUTUVDZWWTWJSZWYMWYIWYPWCULTUTUVEWD
      WWKWWRWJSWWSWJSWYQWWLWVOUVFWVQUVFWWRWWSUVGWHUTWWTUVHWKBUDWXCUVJWKZWYLWXNW
      XPWXMWYOBUDWXCUVIWFWGZVTWWMWXAVEWXDUQURZWWMWWQWYTUGWWTWWMWWPWWTSZWWQVDZVD
      ZVEWWPUTUPZWXDVETSXUCUVKWLWWMXUAXUDTSWWQWWMXUAVDZWWPWWMWWTULWWPWYGWMZWNWO
      WWMWXMXUBWYSVTWWMXUAWWQVEXUDUQURZXUEWWQXUGXUEWWPULSWWQXUGWPXUFWWPUVLVSUVM
      UVNWWMXUAXUDWXDVOURZWWQXUEWYLWXNWXPWQZXUDWXCSZXUHWWMXUIXUAWWMWYLWXNWXPWYL
      WWMWYOWLWYKWYRUVOVTWWMWXSXUAXUJWYGWYHWXSXUAXUJWYJULWWTUTWWPWEWFXBBUDWXCXU
      DUWAWGWOUVPUVQUVRUVSVPWXDUVTWKWWEWXEUWBWHWRWSWXBWXIUAWUGWXBAWWMVDZWWFVDZW
      XAVDZWVHVDZWVGVDZWUJWUGSZWXIXUMWVIVDZXUMWVHWVGVDZVDWXBXUOWVIXURXUMWVGWVHU
      WCUWDWXBXULWVIVDZWXAVDXUQWWOXUSWXAWWOXUKWVIVDZWWFVDXUSWWNXUTWWFAWVIWWMWTU
      WEXUKWVIWWFWTUWKUWEXULWVIWXAWTUWKXUMWVHWVGUWLUWFXUNWVGXUPWXIXUNUHUNZUIUNZ
      UOUKZUTUPZWXFUQURZXVAHUPZXVBHUPZUOUKZUTUPZWUTUQURZUSWXIWUKWUJUOUKZUTUPZWX
      FUQURZWUQWUPUOUKZUTUPZWUTUQURZUSZUBUAUIUHWUGUIUBXAZUHUAXAZVDZXVEWXHXVJWVA
      XVTXVDWUMWXFUQXVTXVCWULUTXVSXVRXVCWULXCXVAWUJXVBWUKUOUWGUWMXDXLXVTXVIWUSW
      UTUQXVTXVHWURUTXVSXVRXVFWUPXVGWUQUOXVAWUJHXEZXVBWUKHXEZXFXDXLXGUIUAXAZUHU
      BXAZVDZXVEXVMXVJXVPXWEXVDXVLWXFUQXWEXVCXVKUTXWDXWCXVCXVKXCXVAWUKXVBWUJUOU
      WGUWMXDXLXWEXVIXVOWUTUQXWEXVHXVNUTXWDXWCXVFWUQXVGWUPUOXVAWUKHXEZXVBWUJHXE
      ZXFXDXLXGAWUGTVQZWWMWWFWXAWVHADTSZETSXWHKLDEUWHWGZUWIXUNAWVGXUPVDZWXIXVQW
      PAWWMWWFWXAWVHUWJZAXWKVDZWXHXVMWVAXVPXWMWUMXVLWXFUQAWVGXUPWUMXVLXCZAXUPVD
      ZWUJULSWUKULSXWNAWVGVDZAWUGULWUJAWUGTULXWJUUOUUPZWMAWUGULWUKXWQWMWUJWUKUW
      NXHXIXLXWMWUSXVOWUTUQAWVGXUPWUSXVOXCZXWOWUPULSZWUQULSZXWRXWPAWUGULWUJHWVF
      XJZAWUGULWUKHWVFXJZWUPWUQUWNXHXIZXLXGXBXUNWVGXUPWUKWUJVOURZWQZVDZWXHWVAXX
      FWXHVDZCTWVKWUKWUJXKUKZSZWVMUTUPZVEVFZVJZVKUPZWUTUQURZWVAXXGXXMCTXXIWVMWV
      TUOUKZUTUPZWVTUTUPZVIUKZVEVFZVJZVKUPZWUTXXFXXMXMSZWXHXUNAXXEXYBXWLAWVGXUP
      XYBXXDXWMTVEXNUJUKZXXLUMZXYBXWMCTXXKXYCXXLXWMXXKXYCSZWVKTSZXWMXXIXXJVEXYC
      XWMXXIWVLXXJXYCSZXWMXXHFWVKXWMXXHDEXKUKZFADXMSZEXMSZVDDWUKVOURZWUJEVOURZV
      DXXHXYHVQXWKAXYIXYJADKXOZAELXOZUWOWVGXYKXUPXYLWVGXYKWUKEVOURZWVGXYIXYJWUK
      XMSZWQXYKXYOVDBUDCDEWUKVOVOUJBUDCUWPZUWQUWRUWSXUPDWUJVOURZXYLXUPXYIXYJWUJ
      XMSZWQXYRXYLVDBUDCDEWUJVOVOUJXYQUWQUWRUWTZUXBBUDCUCDEWUKWUJXKUQUQUQUQXKVO
      VOBUDCUXAZYUADWUKWUNUXCWUNWUJEUXDUXEWHAXYHFVQZXWKNVTUXFZWMZAWVLXYGXWKAWVL
      VDZXXJXMSVEXXJVOURZXYGYUEXXJYUEWVMAFULWVKGQXJZWNZXOYUEWVMYUGXPZXXJUXGUXHZ
      WSXQVEXYCSZXWMXXIXRZVDVEXMSZXNXMSVEXNVOURZYUKUXIUXJYUMYUNUXIVEUXLWDVEXNUX
      KUXMZWLXSZVTXXLXTZYAZXXLYBVSZYCZXBVTXXFXYAXMSZWXHXUNXUKXXEYVAXUKWWFWXAWVH
      UXNZXUKWVGXUPYVAXXDXUKXWKVDZTXYCXXTUMZYVAYVCCTXXSXYCXXTYVCXXSXYCSXYFYVCXX
      IXXRVEXYCYVCXXIVDZXXRXMSVEXXRVOURXXRXYCSYVEXXRYVEXXPXXQYVEXXOYVEWVMWVTAXW
      KXXIWVMULSZWWMXWMXXIWVLYVFYUDAWVLYVFXWKYUGWSXQUXOZXUKXXIWVTULSZXWKWWMXXIY
      VHAXXIWWMXYFYVHWVKWUKWUJUXPZWWKWWLXYFYVHWWKXYFVDZWVPULSWVSULSZYVHWWLXYFVD
      ZYVJWVPWWKTTWVKWVOWYCXJUXQYVLVGULSWVRULSYVKUXRYVLWVRWWLTTWVKWVQWYFXJUXQVG
      WVRUXSWKWVPWVSUYBWHUXTZVLZYDWSZUYCZWNZXUKXXIXXQTSZXWKWWMXXIYVRAWWMXXIVDWV
      TYVNWNYDWSZUYAXOYVEXXPXXQYVQYVSYVEXXOYVPXPXUKXXIVEXXQVOURZXWKWWMXXIYVTAXX
      IWWMXYFYVTYVIWWMXYFVDZWVTYVMXPVLYDWSUYDXXRUXGUXHYUKYVCYULVDYUOWLXSVTXXTXT
      YAZXXTYBVSYCXBVTWVHWUTXMSZXUMXXEWXHWUTUYEZYEXXFXXMXYAVOURZWXHXUNXUKXXEYWE
      YVBXUKWVGXUPYWEXXDYVCXYDYVDXXLXXTVOUYFZURZYWEYVCCTXXKXYCXXLYVCXYEXYFAXWKX
      YEWWMYUPWSVTYUQYAYWBYVCYWGXXKXXSVOURZCTVAZYVCYWHCTYVCXXIYWHYVCXXIYWHYVEXX
      JXXRXXKXXSVOYVEXXOWVTVIUKZUTUPXXJXXRVOYVEYWJWVMUTYVEWVMWVTYVGYVOUYGXDYVEX
      XOWVTYVPYVOUYHUYMXXIXXKXXJXCYVCXXIXXJVEUYIWAXXIXXSXXRXCYVCXXIXXRVEUYIWAUY
      JYFYULVEVEXXKXXSVOVEVEVOURYULUYKWLXXIXXJVEUYLZXXIXXRVEUYLUYJUYNYGAYWGYWIW
      PWWMXWKACTXXKXXSVOXXLXXTYHYHYHTYHSAUYOWLZXXKYHSAXYFVDZXXIXXJVEWVMUTVUBZYI
      YJWLZXXSYHSYWMXXIXXRVEXXPXXQVIVUCYIYJWLAXXLYKZAXXTYKUYPUYQUYRXXLXXTUYSYLY
      CXBVTABUDUAUBCDEFUEUFGHUGJKLMNOPQUYTVUDXXFXXNWVAUSZWXHXUNAWVHVDZXXEYWQXUM
      AWVHAWWMWWFWXAUXNVUAYWRXXEVDZWUSXXMVOURZXXNWVAAXXEYWTWVHAXXEVDZWUSCXXHWVM
      YOZUTUPZXXMVOYXAWURYXBUTYXAWURCDWUKXKUKZWVMYOZYXBVIUKZYXEUOUKZYXBYXAWUPYX
      FWUQYXEUOYXAWUPCDWUJXKUKZWVMYOZYXFYXAXUPWUPYXIXCAWVGXUPXXDVUEBWUJCDWXOXKU
      KZWVMYOZYXIWUGHBUAXAYXJYXHXCYXKYXIXCWXOWUJDXKYMCYXJYXHWVMYPVSJCYXHWVMVUFV
      UGVSYXACDWUKWUJWVMAXWIXXEKVTAWVGXUPWUJTSXXDAWUGTWUJXWJWMZYNYXAWUKDWUJUJUK
      SZXYPXYKXXDAXUPWVGXYPXXDXWPWUKAWUGTWUKXWJWMXOYQAXUPWVGXYKXXDXWPXYPXYKXYOA
      WVGXYPXYKXYOWQZAXYIXYJWVGYXNWPXYMXYNDEWUKVUHWGVUIVUJYQAWVGXUPXXDVUKAWVGXU
      PYXMXYPXYKXXDWQWPZXXDXWOXYIXYSYXOAXYIXUPXYMVTXWOWUJYXLXODWUJWUKVUHWGYNVUM
      YXAWVKYXHSWVLYVFYXAYXHFWVKAWVGXUPYXHFVQXXDXWOYXHXYHFAXYJXYLYXHXYHVQXUPXYN
      XYTDWUJEVULWHAYUBXUPNVTUXFZYNWMAWVLYVFXXEYUGWSXQAXUPWVGCYXDWVMVJZYRSZXXDX
      WOCYXHWVMVJZYRSZUSXWPYXRUSUAUBUAUBXAZXWOXWPYXTYXRYYAXUPWVGAWUJWUKWUGVUNVU
      OYYAYXSYXQYRYYACYXHYXDWVMWUJWUKDXKYMVUPVUQXGXWOCYXHFWVMULYXPYXHVURUUFZSXW
      ODWUJVUSWLAWVLYVFXUPYUGWSACFWVMVJZYRSZXUPAGYYCYRACFULGQVUTPVVAZVTVVCVVBZY
      QAWVGXUPCXXHWVMVJYRSXXDXWMCXXHFWVMYHYUCXXHYYBSXWMWUKWUJVUSWLWVMYHSZXWMWVL
      VDWVKGVUBZWLAYYDXWKYYEVTVVCZYCVVDYSYXAWVGWUQYXEXCAWVGXUPXXDVVEBWUKYXKYXEW
      UGHBUBXAYXJYXDXCYXKYXEXCWXOWUKDXKYMCYXJYXDWVMYPVSJCYXDWVMVUFVUGVSVVFAWVGX
      UPYXGYXBXCXXDXWMYXEYXBAWVGYXEULSXUPXWPCYXDWVMYHYYGXWPWVKYXDSVDYYHWLYYFVVG
      WOXWMCXXHWVMYHYYGXWMXXIVDYYHWLYYIVVGZVVHYCYSXDZAWVGXUPYXCXXMVOURZXXDACIUN
      ZWVMYOZUTUPZCTCIVVIZXXJVEVFZVJZVKUPZVOURZIXKWUGWUGVVJZUUJZVAXXHUUUBSYYLXW
      KRXWKXXHWUKWUJVVNZXKUPZUUUBWUKWUJXKVVKXWKUUUCUUUASZUUUDUUUBSZWUKWUJWUGWUG
      VVLXKXMXMVVJZWBZUUUAUUUGVQZUUUEUUUFUUUGTVVOZXKUMUUUHVVMUUUGUUUJXKWIWDWUGX
      MVQZUUUKUUUIDEVVPZUUULWUGXMWUGXMVVQVVRUUUGUUUAXKUUUCWEVVSVSVVTYYTYYLIXXHU
      UUBYYMXXHXCZYYOYXCYYSXXMVOUUUMYYNYXBUTCYYMXXHWVMYPXDUUUMYYRXXLVKUUUMCTYYQ
      XXKUUUMYYPXXIXXJVEYYMXXHWVKVWAVWBVWEXDVWCVWDWHZYCVWFWSYWSWUSXMSZXYBYWCYWT
      XXNVDWVAUSAXXEUUUOWVHAWVGXUPUUUOXXDXWMWUSXWMWURAWVGXUPWURULSZXWOXWSXWTUUU
      PXWPXXAXXBWUPWUQVWGXHXIZWNXOYCWSAXXEXYBWVHYUTWSWVHYWCAXXEYWDVWHWUSXXMWUTU
      XCYLVWIXBVTVWJYFVWKWRVWLVWMWVCWXJUCWXFVBWUNWXFXCZWVBWXIUAWUGUUURWUOWXHWVA
      WUNWXFWUMUQYTVWOVWNVWPWGWXAXRZWWOWWPVEXCZUGWWTVAZWVDUUUSWWQXRZUGWWTVAUUVA
      WWQUGWWTVWQUUVBUUUTUGWWTWWPVEVWRVWSVWTWWNWWFUUVAWVDWVJWWMWWFUUVAVDZWVDWVJ
      WWMUUVCVDZCTWVLXXJVEVFZVJZVKUPZWWEUQURZWVDAUUVDUUVHWVIAWWMUUVCUUVHXUKWWFU
      UVAUUVHXUKUUVAWWFUUVHXUKUUVAWWFUUVHUSXUKUUVAVDZWWFUUVHUUVIWWDUUVGWWEUQUUV
      IWWCUUVFVKUUVICTWWBUUVEUUVIXYFVDZWWBWVNUTUPZUUVEUUVJWWAWVNUTUUVJWWAWVNVEU
      OUKZWVNUUVJWVTVEWVNUOWWMUUVAXYFWVTVEXCAWWMUUVAVDXYFVDWVTVEVEVIUKZVEWWMXYF
      UUVAWVTUUVMXCYWAUUVAVDWVPVEWVSVEVIWWKXYFUUVAWVPVEXCZWWLYVJWVPWWTSZUUVAUUV
      NYVJWVPWWRSZUUVOWWKWVOTWBZXYFUUVPWWKWYBUUVQWYCTTWVOWIVSTWVKWVOVXAXBWVPWWR
      WWSUUTVSUUUTUUVNUGWVPWWTWWPWVPVEVXBVXCXBUXOWWLXYFUUVAWVSVEXCZWWKYVLWVRWWT
      SZUUVAUUVRYVLWVRWWSSZUUVSWWLWVQTWBZXYFUUVTWWLWYEUUWAWYFTTWVQWIVSTWVKWVQVX
      AXBWVRWWSWWRVXDVSUUVSUUVAVDZWVSVGVEVHUKVEUUWBWVRVEVGVHUUUTWVRVEXCUGWVRWWT
      WWPWVRVEVXBVXCVXEVGUXRVXFVXGXBVXHVVFVXIVXJVXGVXHVXEAUUVLWVNXCWWMUUVAXYFAW
      VNAWVLWVMVEULYUGVEULSAWVLXRZVDZVXQWLXSVXKVXLYSXDUUVKWVLXXJWXQVFZUUVEWVLWV
      MVEUTVXMWXQVEXCUUWEUUVEXCVXNWVLWXQVEXXJVXOWDVXPVXGVXRXDXLUVMYFVXSVXTVYAWS
      WVJUUVHVDZVBUUQVMZWVCUCVBVAWVDVYRVBSUUWGVYBVBVYRUVAWDUUWFWVCUCVBUUWFWVBUA
      WUGUUWFXUPVDZWVAWUOUUWHWUSWWEWUTWVJXUPWUSTSZUUVHAWVGXUPUUWIWVHXWPXUPVDWUR
      AWVGXUPUUUPUUUQWRWNVYCWSZWVIWWETSZAUUVHXUPWVHUUWKWVGWVHWUTWUTVYDZVYEWAYEZ
      WVIWUTTSZAUUVHXUPWVHUUWNWVGUUWLWAYEUUWHWUSUUVGWWEUUWHWUSUUWJXOAUUVGXMSZWV
      IUUVHXUPATXYCUUVFUMZUUWOACTUUVEXYCUUVFAUUVEXYCSXYFAWVLXXJVEXYCYUJYUKUUWDY
      UOWLXSVTUUVFXTYAZUUVFYBVSZVXLUUWHWWEUUWMXOWVJXUPWUSUUVGVOURZUUVHAWVGXUPUU
      WSWVHAWVGXUPUUWSAXVGXVFUOUKZUTUPZUUVGVOURUUWSXVOUUVGVOURUBUAUHUIWUGXWDXWC
      VDZUUXAWUSUUVGVOUUXBUUWTWURUTXWCXWDXVGWUPXVFWUQUOXWGXWFXFXDXLXVSXVRVDZUUX
      AXVOUUVGVOUUXCUUWTXVNUTXVRXVSXVGWUQXVFWUPUOXWBXWAXFXDXLXWJXWMWUSXVOUUVGVO
      XXCXLYXAWUSYXCUUVGVOYYKAWVGXUPYXCUUVGVOURXXDXWMYXCXXMUUVGXWMYXCXWMYXBYYJW
      NXOYUSAUUWOXWKUUWRVTUUUNXWMXYDUUWPXXLUUVFYWFURZXXMUUVGVOURYURAUUWPXWKUUWQ
      VTXWMUUXDXXKUUVEVOURZCTVAZXWMUUXECTWVLXXKXXJVOURZXXKVEVOURZUUXEXWMXXJVEXX
      JUUVEXXKVOYTVEUUVEXXKVOYTAWVLUUXGXWKYUEXXJXXJVOURZYUFUUXGYUEXXJYUHVYFYUIX
      XIUUXIYUFUUXGXXJVEXXJXXKXXJVOVYHVEXXKXXJVOVYHVYGWGWSXWMUUWCVDYULUUXHXWMUU
      WCYULXWMXXHFWVKYUCVYIUVRYULXXKVEVEVOYWKUYKVYJVSVYKYGAUUXDUUXFWPXWKACTXXKU
      UVEVOXXLUUVFYHYHYHYWLYWOUUVEYHSYWMWVLXXJVEYWNYIYJWLYWPAUUVFYKUYPVTUYRXXLU
      UVFUYSYLVYLYCVWFVWKWRVYCWSWVJUUVHXUPVYMVUDWVIWWEWUTUQURZAUUVHXUPWVHUUXJWV
      GWUTVYNWAYEVYSVYOVWMYGWVCUCVBVYPWKXQWRWRVYQVYTYFWUAVWJWUBAWUGULVQULULVQWU
      HWUIWVEVDWPXWQULWUCUBUDUCUAWUGULHWUDWUEWUF $.
  $}

  ${
    $d s t x y z A $.  $d s t x y z B $.  $d s t x y z F $.  $d s t x y z ph $.
    ftc2nc.a $e |- ( ph -> A e. RR ) $.
    ftc2nc.b $e |- ( ph -> B e. RR ) $.
    ftc2nc.le $e |- ( ph -> A <_ B ) $.
    ftc2nc.c $e |- ( ph -> ( RR _D F ) e. ( ( A (,) B ) -cn-> CC ) ) $.
    ftc2nc.i $e |- ( ph -> ( RR _D F ) e. L^1 ) $.
    ftc2nc.f $e |- ( ph -> F e. ( ( A [,] B ) -cn-> CC ) ) $.
    $( Choice-free proof of ~ ftc2 .  (Contributed by Brendan Leahy,
       19-Jun-2018.) $)
    ftc2nc $p |- ( ph -> S. ( A (,) B ) ( ( RR _D F ) ` t ) _d t =
      ( ( F ` B ) - ( F ` A ) ) ) $=
      ( vx vs cfv cioo co cr cmpt wcel cc vy vz cv cdv citg cmin caddc cneg csn
      cicc cxp wceq cxr cle wbr rexrd ubicc2 syl3anc fvex fvconst2 ccnfld ctopn
      syl eqid ctx ccn subcn a1i wss ssid ioossre ccncf wf cncff cabs wel citg2
      cc0 cif cima wrex wfun cpw ioof ffun ax-mp fvelima mpan c1st c2nd 1st2nd2
      wa wb cop fveq2d df-ov syl6eqr eqeq1d adantl jca adantr xp1st w3a syl2anc
      elicc1 biimpa simp2d sylan2 xp2nd iccleub syl2an clt df-ioo ffvelrnda cvv
      3expa ioombl cibl feqmptd eqeltrrd iblss cmbf ax-resscn cres sylancr cmul
      cnmbf itgcl cncfmpt2f itgeq1 dvmptntr 3eqtr3d oveq2d oveq2 fveq2 fvmpt c0
      oveq12d syl6eq ffvelrnd xrlelttr xrltletr ixxss12 syl12anc sselda adantlr
      syldan cvol cncfss mp2an abscncf sselii reseq1d resmpt eqtrd rescncf sylc
      cdm cncfmpt1f ccj mulcn cjcld sstri cncfmptc mp3an23 nfcv nfcsb1v csbeq1a
      cbvmpt syl5eqelr itgabsnc abscld iblabsnc absge0d itgposval breqtrd eleq2
      csb mpteq2dv breq12d syl5ibcom sylbid rexlimdva syl5 ralrimiv ftc1anc crn
      ifbid ctg iccssre elicc2 simp3d iooss2 subcld tgioo2 cnt iccntr cpr prid1
      reex ioossicc sseli ftc1cnnc 3eqtr3rd dvmptsub subidd mpteq2dva fconstmpt
      3eqtrd dveq0 fveq1d ovex eqtr3d lbicc2 iooid df-neg negex pncan3d negsubd
      itg0 ) ADENZBCDOPZBUCZQEUDPZNZUEZUYAUFPZUGPUYACENZUHZUGPUYFUYAUYHUFPAUYGU
      YIUYAUGADCDUJPZCLUYJBCLUCZOPZUYEUEZUYKENZUFPZRZNZUIUKZNZUYQUYGUYIADUYJSZU
      YSUYQULACUMSZDUMSZCDUNUOZUYTACFUPZADGUPZHCDUQURZUYJUYQDCUYPUSUTVCADUYPNZU
      YSUYGADUYPUYRACDUYPFGALUYMUYNUFVAVBNZUYJVUHVDZUFVUHVUHVEPVUHVFPZSAVUHVUIV
      GVHALBCDUYBUYDLUYJUYMRZMVUKVDZFGHUYBUYBVIAUYBVJVHUYBQVIACDVKVHJAUYDUYBTVL
      PSZUYBTUYDVMIUYBTUYDVNVCZABMUCZUYEUEZVONZBQBMVPZUYEVONZVRVSZRZVQNZUNUOZMO
      UYJUYJUKZVTZVUOVVESZUYKONZVUOULZLVVDWAZAVVCOWBZVVFVVIUMUMUKZQWCZOVMVVJWDV
      VKVVLOWEWFLVUOVVDOWGWHAVVHVVCLVVDAUYKVVDSZWLZVVHUYKWINZUYKWJNZOPZVUOULZVV
      CVVMVVHVVRWMAVVMVVGVVQVUOVVMVVGVVOVVPWNZONVVQVVMUYKVVSOUYKUYJUYJWKWOVVOVV
      POWPWQWRWSVVNBVVQUYEUEZVONZBQUYCVVQSZVUSVRVSZRZVQNZUNUOVVRVVCVVNVWABVVQVU
      SUEVWEUNVVNBMVVQUYETVVNVWBUYCUYBSZUYETSZVVNVVQUYBUYCVVNVUAVUBWLZCVVOUNUOZ
      VVPDUNUOZVVQUYBVIZAVWHVVMAVUAVUBVUDVUEWTZXAVVMAVVOUYJSZVWIUYKUYJUYJXBAVWM
      WLVVOUMSZVWIVVODUNUOZAVWMVWNVWIVWOXCZAVUAVUBVWMVWPWMVUDVUECDVVOXEXDXFXGXH
      AVWHVVPUYJSZVWJVVMVWLUYKUYJUYJXIVUAVUBVWQVWJCDVVPXJXPXKMBUAUBCDVVOVVPOXLX
      LXLXLOUNUNMBUAXMZVWRCVVOUBUCZUUAVWSVVPDUUBUUCUUDZUUEAVWFVWGVVMAUYBTUYCUYD
      VUNXNUUFUUGZVVNBVVQUYBUYEXOVWTVVQUUHUURZSZVVNVVOVVPXQZVHUYEXOSZVVNVWFWLUY
      CUYDUSZVHABUYBUYERZXRSZVVMAUYDVXGXRABUYBTUYDVUNXSZJXTZXAYAZVVNVXCBVVQVUSR
      ZVVQTVLPZSVXLYBSVXDVVNBUYEVOVVQVOTTVLPZSVVNTQVLPZVXNVOQTVIZTTVIZVXOVXNVIY
      CTVJZTQTUUIUUJUUKUULVHVVNUYDVVQYDZBVVQUYERZVXMVVNVXSVXGVVQYDZVXTAVXSVYAUL
      VVMAUYDVXGVVQVXIUUMXAVVNVWKVYAVXTULVWTBUYBVVQUYEUUNVCUUOVVNVWKVUMVXSVXMSV
      WTAVUMVVMIXAUYBTVVQUYDUUPUUQXTZUUSVVQVXLYGYEZVVNVXCMVVQVVTUUTNZBVUOUYEUVR
      ZYFPRZVXMSVYFYBSVXDVVNMVYDVYEYFVUHVVQVUIYFVUJSVVNVUHVUIUVAVHVVNVYDTSZMVVQ
      VYDRVXMSZVVNVVTVVNBVVQUYETVXAVXKYHUVBVYGVVQTVIVXQVYHVVQQTVVOVVPVKYCUVCVXR
      MVYDVVQTUVDUVEVCVVNMVVQVYERVXTVXMBMVVQUYEVYEMUYEUVFBVUOUYEUVGBVUOUYEUVHUV
      IVYBUVJYIVVQVYFYGYEUVKVVNBVVQVUSVVNVWBWLZUYEVXAUVLVVNBVVQUYEXOVXEVYIVXFVH
      VXKVYCUVMVYIUYEVXAUVNUVOUVPVVRVWAVUQVWEVVBUNVVRVVTVUPVOBVVQVUOUYEYJWOVVRV
      WDVVAVQVVRBQVWCVUTVVRVWBVURVUSVRVVQVUOUYCUVQUWHUVSWOUVTUWAUWBUWCUWDUWEUWF
      AELUYJUYNRZUYJTVLPZALUYJTEAEVYKSUYJTEVMKUYJTEVNVCZXSZKXTYIAQUYPUDPZLUYBVR
      RZUYBVRUIUKAVYNQLUYBUYORUDPLUYBUYKUYDNZVYPUFPZRVYOALUYOQOUWGUWINZVUHUYJUY
      BVXPAYCVHZACQSZDQSZUYJQVIFGCDUWJXDZAUYKUYJSZWLZUYMUYNWUDBUYLUYEXOVXEWUDUY
      CUYLSWLVXFVHWUDBUYLUYBUYEXOWUDVUBUYKDUNUOZUYLUYBVIWUDDAWUAWUCGXAUPWUDUYKQ
      SZCUYKUNUOZWUEAWUCWUFWUGWUEXCZAVYTWUAWUCWUHWMFGCDUYKUWKXDXFUWLCUYKDUWMXDU
      YLVXBSWUDCUYKXQVHVXEWUDVWFWLVXFVHAVXHWUCVXJXAYAYHZAUYJTUYKEVYLXNZUWNVUHVU
      IUWOZVUIAVYTWUAUYJVYRUWPNNUYBULFGCDUWQXDZYKALUYMVYPUYNVYPQTTUYBQQTUWRSAQT
      UWTUWSVHUYKUYBSZAWUCUYMTSUYBUYJUYKCDUXAUXBZWUIXHAUYBTUYKUYDVUNXNZAQVUKUDP
      UYDQLUYBUYMRUDPLUYBVYPRZALBCDUYDVUKVULFGHIJUXCALUYMQVYRVUHUYJUYBVYSWUBWUI
      WUKVUIWULYKALUYBTUYDVUNXSZYLWUMAWUCUYNTSWUNWUJXHWUOAUYDQVYJUDPWUPQLUYBUYN
      RUDPAEVYJQUDVYMYMWUQALUYNQVYRVUHUYJUYBVYSWUBWUJWUKVUIWULYKUXDUXEALUYBVYQV
      RAWUMWLVYPWUOUXFUXGUXILUYBVRUXHWQUXJUXKAUYTVUGUYGULVUFLDUYOUYGUYJUYPUYKDU
      LZUYMUYFUYNUYAUFWURUYLUYBULUYMUYFULUYKDCOYNBUYLUYBUYEYJVCUYKDEYOYRUYPVDZU
      YFUYAUFUXLYPVCUXMACUYJSZUYQUYIULAVUAVUBVUCWUTVUDVUEHCDUXNURZLCUYOUYIUYJUY
      PUYKCULZUYOVRUYHUFPUYIWVBUYMVRUYNUYHUFWVBUYMBYQUYEUEZVRWVBUYLYQULUYMWVCUL
      WVBUYLCCOPYQUYKCCOYNCUXOYSBUYLYQUYEYJVCBUYEUXTYSUYKCEYOYRUYHUXPWQWUSUYHUX
      QYPVCYLYMAUYAUYFAUYJTDEVYLVUFYTZABUYBUYEXOVXEAVWFWLVXFVHVXJYHUXRAUYAUYHWV
      DAUYJTCEVYLWVAYTUXSYL $.
  $}

  ${
    $d x y $.
    $( Real derivative of arcsine.  (Contributed by Brendan Leahy,
       3-Aug-2017.) $)
    dvreasin $p |- ( RR _D ( arcsin |` ( -u 1 (,) 1 ) ) ) =
      ( x e. ( -u 1 (,) 1 ) |-> ( 1 / ( sqr ` ( 1 - ( x ^ 2 ) ) ) ) ) $=
      ( cr c1 co cdv ci cmul c2 cmpt cdiv wceq wtru a1i wcel syl cvv adantl cc0
      cc wbr vy casin cneg cioo cres cv cexp cmin csqr cfv caddc clog asinf wss
      wf ioossre ax-resscn sstri feqresmpt elioore recnd asinval mpteq2ia eqtri
      trud oveq2i cpr reex prid1 ax-icn mulcld ax-1cn sqcl subcld sqrcld addcld
      id asinlem logcld wa ovex cmnf cioc cdif prid2 clt wn cle wo wi simpr cre
      cnex asinlem3 adantr wb rere breq2d mpbid wne ne0gt0d 0re ltnled ex sylib
      imor orcomd w3a w3o cxr mnfxr mp2an ax-mp eqid dvmptres dvmptcmul mpteq2i
      crn syl6eq crp 1re rexri sq1 sqcld oveq2d fveq2 dvmptco 2cn oveq1d negcld
      mp1i eqneltrd con2i divrec2d 3eqtr3rd ixi divcan4d divassd eqtr3d 3eqtri
      olcd 3ianor 3orrot 3orass 3bitrri elioc2 xchbinxr eldifd eldifi 0xr mnflt
      eldifn ubioc1 mp3an eleq1 mpbiri necon3bi ctg ccnfld ctopn dvmptid tgioo2
      recn iooretop mulid1i resqcld resubcld renegcli elioo2 cabs abscld lt2sqd
      absge0d absltd absresq breq12d resqcl posdifd bitrd 3bitr3d biimpd 3impib
      0le1 sylbi elrpd negex rpcn dvmptc ctopon cnfldtopon toponmax cin mpbi cn
      df-ss 2nn dvexp 2m1e1 exp1 eqtrd dvmptres3 dvmptsub df-neg dvsqr mulneg2d
      syl6eqr ubioo lbioo sylanbrc sqr00d subeq0d syl5req sqeqor sylancl sylibd
      ioran necon3bd mpd 2ne0 divcan5d mulne0d dvmptadd divdird mulassd addcomd
      mulm1 adddid dvlog csn wf1o logf1o f1of snssi sscon syl5reqr oveq2 reccld
      3eqtr4d negcli mulneg1i negeqi negnegi ) BUBCUCZCUDDZUEZEDBAVUDFUCZFAUFZG
      DZCVUGHUGDZUHDZUIUJZUKDZULUJZGDZIZEDZAVUDVUFFVUKJDZGDZIZAVUDCVUKJDZIVUEVU
      OBEVUEAVUDVUGUBUJZIZVUOVUEVVBKLASSVUDUBSSUBUOLUMMVUDSUNLVUDBSVUCCUPZUQURM
      USVEAVUDVVAVUNVUGVUDNZVUGSNZVVAVUNKVVDVUGVUGVUCCUTZVAZVUGVBOVCVDVFVUPVUSK
      LAVUMVUQVUFBPVUDBBSVGZNLBSVHVIMZVVDVUMSNZLVVDVVEVVJVVGVVEVULVVEVUHVUKVVEF
      VUGFSNZVVEVJMZVVEVQZVKZVVEVUJVVECVUICSNZVVEVLMVUGVMZVNVOZVPZVUGVRZVSOQVUQ
      PNLVVDVTZFVUKJWAMLBAVUDVUMIEDAVUDCVULJDZFVULGDZVUKJDZGDZIAVUDVUQILAUAVULV
      WCUAUFZULUJZCVWEJDZBSVUMVWAPPVUDSWBRWCDZWDZVVISVVHNLBSWMWEMVVDVULVWINLVVD
      VULSVWHVVDVVEVULSNVVGVVROZVVDWBVULWFTZWGZVULRWHTZWGZVULBNZWGZWIZWIZVULVWH
      NZWGVVDVWQVWLVVDVWPVWNVVDVWOVWNWJZVWPVWNWIVVDVVEVWTVVGVVEVWOVWNVVEVWOVTZR
      VULWFTVWNVXAVULVVEVWOWKZVXARVULWLUJZWHTZRVULWHTZVVEVXDVWOVUGWNWOVWOVXDVXE
      WPVVEVWOVXCVULRWHVULWQWRQWSVVEVULRWTZVWOVVSWOXAVXARVULRBNZVXAXBMVXBXCWSXD
      OVWOVWNXFXEXGUUAVWRVWOVWKVWMXHZVWSVXHWGVWPVWLVWNXIVWLVWNVWPXIVWRVWOVWKVWM
      UUBVWPVWLVWNUUCVWLVWNVWPUUDUUEWBXJNZVXGVWSVXHWPXKXBWBRVULUUFXLUUGXEUUHQVW
      CPNVVTVWBVUKJWAMVWEVWINZVWFSNLVXJVWEVWESVWHUUIVXJVWEVWHNZWGVWERWTVWESVWHU
      ULVXKVWERVWERKVXKRVWHNZVXIRXJNWBRWFTZVXLXKUUJVXGVXMXBRUUKXMWBRUUMUUNZVWER
      VWHUUOUUPUUQOVSQVWGPNLVXJVTCVWEJWAMLBAVUDVULIEDAVUDFVUGUCZVUKJDZUKDZIAVUD
      VWCILAVUHFVUKVXPBSPVUDVVIVVDVUHSNZLVVDVVEVXRVVGVVNOZQVVKVVTVJMLBAVUDVUHIE
      DAVUDFCGDZIAVUDFILAVUGCFBSVUDVVIVVDVVELVVGQVVOVVTVLMLAVUGCBUDXRUURUJZUUSU
      UTUJZSBVUDVVIVUGBNZVVELVUGUVCZQVVOLVYCVTZVLMZLABVVIUVAVUDBUNLVVCMZVYBVYBX
      NZUVBZVYHVUDVYANLVUCCUVDMZXOVVKLVJMXPAVUDVXTFFVJUVEXQXSVVDVUKSNZLVVDVVEVY
      KVVGVVQOZQVXPPNVVTVXOVUKJWAMLBAVUDVUKIEDAVUDCHVUKGDZJDZHVUGGDZUCZGDZIAVUD
      VXPILAUAVUJVYPVWEUIUJZCHVYRGDZJDZBBVUKVYNPPVUDXTVVIVVIVVDVUJXTNLVVDVUJVVD
      CVUICBNZVVDYAMVVDVUGVVFUVFUVGVVDVYCVUCVUGWFTZVUGCWFTZXHZRVUJWFTZVUCXJNCXJ
      NVVDWUDWPVUCCYAUVHYBCYAYBVUCCVUGUVIXLVYCWUBWUCWUEVYCWUBWUCVTZWUEVYCVUGUVJ
      UJZCWFTWUGHUGDZCHUGDZWFTZWUFWUEVYCWUGCVYCVUGVYDUVKWUAVYCYAMZVYCVUGVYDUVMR
      CWHTVYCUWCMUVLVYCVUGCVYCVQWUKUVNVYCWUJVUICWFTWUEVYCWUHVUIWUICWFVUGUVOWUIC
      KVYCYCMUVPVYCVUICVUGUVQWUKUVRUVSUVTUWAUWBUWDUWEQVYPPNZVVTVYOUWFZMVWEXTNZV
      YRSNLWUNVWEVWEUWGVOQVYTPNLWUNVTCVYSJWAMLAVUJVYPBVYAVYBPBVUDVVIVYCVUJSNLVY
      CCVUIVVOVYCVLMVYCVUGVYDYDZVNQWULVYEWUMMLBABVUJIEDABRVYOUHDZIABVYPILACRVUI
      VYOBBPBVVIVYFVXGVYEXBMLACBVVIVVOLVLMUWHVYCVUISNZLWUOQVYOPNZVYEHVUGGWAZMLA
      VUIVYOBVYBPSBVYHVVIVYBSUWIUJNSVYBNLVYBVYHUWJSVYBUWKYKBSUWLBKZLBSUNWUTUQBS
      UWOUWMMVVEWUQLVVPQWURLVVEVTWUSMSASVUIIEDZASVYOIZKLWVAASHVUGHCUHDZUGDZGDZI
      ZWVBHUWNNWVAWVFKUWPAHUWQXMASWVEVYOVVEWVDVUGHGVVEWVDVUGCUGDVUGVVEWVCCVUGUG
      WVCCKVVEUWRMYEVUGUWSUWTYEVCVDMUXAUXBABVYPWUPVYOUXCXQUXFVYGVYIVYHVYJXOBUAX
      TVYRIEDUAXTVYTIKLUAUXDMVWEVUJUIYFZVWEVUJKZVYSVYMCJWVHVYRVUKHGWVGYEYEYGAVU
      DVYQVXPVVDHVXOGDZVYMJDVYPVYMJDVXPVYQVVDWVIVYPVYMJVVDHVUGHSNZVVDYHMZVVGUXE
      YIVVDVXOVUKHVVDVUGVVGYJZVYLWVKVVDVUGCKZVUGVUCKZWIZWGZVUKRWTVVDWVMWGWVNWGW
      VPWVMVVDWVMVUGCVUDWVMVQCVUDNWGWVMVUCCUXGMYLYMWVNVVDWVNVUGVUCVUDWVNVQVUCVU
      DNWGWVNVUCCUXHMYLYMWVMWVNUXPUXIVVDWVOVUKRVVDVUKRKZVUIWUIKZWVOVVDWVQWVRVVD
      WVQVTZWUICVUIYCWVSCVUIVVOWVSVLMZVVDWUQWVQVVDVUGVVGYDWOZWVSVUJWVSCVUIWVTWW
      AVNVVDWVQWKUXJUXKUXLXDVVDVVEVVOWVRWVOWPVVGVLVUGCUXMUXNUXOUXQUXRZHRWTVVDUX
      SMZUXTVVDVYPVYMVVDVYOVVDHVUGWVKVVGVKYJVVDVVEVYMSNVVGVVEHVUKWVJVVEYHMVVQVK
      OVVDHVUKWVKVYLWWCWWBUYAYNYOVCXSUYBAVUDVXQVWCVVDFVUKGDZVXOUKDZVUKJDWWDVUKJ
      DZVXPUKDVWCVXQVVDWWDVXOVUKVVDFVUKVVKVVDVJMZVYLVKZWVLVYLWWBUYCVVDWWEVWBVUK
      JVVDVXOWWDUKDFVUHGDZWWDUKDWWEVWBVVDVXOWWIWWDUKVVDVVEVXOWWIKVVGVVEFFGDZVUG
      GDVUCVUGGDWWIVXOVVEWWJVUCVUGGWWJVUCKVVEYPMYIVVEFFVUGVVLVVLVVMUYDVUGUYFYOO
      YIVVDWWDVXOWWHWVLUYEVVDFVUHVUKWWGVXSVYLUYGUYRYIVVDWWFFVXPUKVVDFVUKWWGVYLW
      WBYQYIYOVCXSLUAVWIVWGISULVWIUEZEDSUAVWIVWFIZEDUAVWIVWIXNUYHLWWKWWLSELUASR
      UYIZWDZULXRZVWIULWWNWWOULUYJWWNWWOULUOLUYKWWNWWOULUYLYKWWMVWHUNZVWIWWNUNL
      VXLWWPVXNRVWHUYMXMWWMVWHSUYNYKUSYEUYOVWEVULULYFVWEVULCJUYPYGAVUDVWDVUQVVD
      VWAVWBGDZVUKJDVWDVUQVVDVWAVWBVUKVVDVVEVWASNVVGVVEVULVVRVVSUYQOVVDFVULWWGV
      WJVKZVYLWWBYRVVDWWQFVUKJVVDVWBVULJDWWQFVVDVWBVULWWRVWJVVDVVEVXFVVGVVSOZYN
      VVDFVULWWGVWJWWSYQYSYIYSVCXSVUFSNZLFVJUYSZMXPVEAVUDVURVUTVVDVUFFGDZVUKJDV
      URVUTVVDVUFFVUKWWTVVDWXAMWWGVYLWWBYRVVDWXBCVUKJWXBCKVVDWXBWWJUCVUCUCCFFVJ
      VJUYTWWJVUCYPVUACVLVUBYTMYIYSVCYT $.
  $}

  $( Real derivative of arccosine.  (Contributed by Brendan Leahy,
     3-Aug-2017.) $)
  dvreacos $p |- ( RR _D ( arccos |` ( -u 1 (,) 1 ) ) ) =
      ( x e. ( -u 1 (,) 1 ) |-> ( -u 1 / ( sqr ` ( 1 - ( x ^ 2 ) ) ) ) ) $=
    ( cr cacos c1 co cdv cc0 c2 cmin cfv cdiv cmpt wceq wtru cpi casin a1i wcel
    cc wa cneg cioo cres cv cexp wf acosf wss ioossre ax-resscn sstri feqresmpt
    csqr elioore recnd acosval syl mpteq2ia syl6eq oveq2d reex prid1 pire recni
    cvv cpr 2cn divcli 0cn crn ctg ccnfld ctopn dvmptc tgioo2 iooretop dvmptres
    2ne0 eqid asincl adantl ovex dvreasin asinf syl5reqr dvmptsub df-neg ax-1cn
    eqtrd trud subcld sqrcld cabs wne abscld clt wbr eliooord 1re absltd mpbird
    sqcld ltned adantr simpr sqr00d subid mp1i eqtr4d subcand sq1 syl6eqr sqabs
    wb sylancl mpbid abs1 ex necon3d mpd divnegd syl5eqr eqtri ) BCDUAZDUBEZUCZ
    FEZAYEGDDAUDZHUEEZIEZUMJZKEZIEZLZAYEYDYKKEZLYGYNMNYGBAYEOHKEZYHPJZIEZLZFEYN
    NYFYSBFNYFAYEYHCJZLYSNASSYECSSCUFNUGQYESUHNYEBSYDDUIZUJUKQZULAYEYTYRYHYERZY
    HSRZYTYRMUUCYHYHYDDUNZUOZYHUPUQURUSUTNAYPGYQYLBSVEYEBBSVFRNBSVAVBQZYPSRZNUU
    CTZOHOVCVDVGVRVHZQGSRZUUIVIQNAYPGBUBVJVKJZVLVMJZSBYEUUGUUHNYHBRZTZUUJQUUKUU
    OVIQNAYPBUUGUUHNUUJQVNYEBUHNUUAQUUMUUMVSZVOUUPYEUULRNYDDVPQVQUUCYQSRZNUUCUU
    DUUQUUFYHVTUQWAYLVERUUIDYKKWBQNAYEYLLBPYEUCZFEBAYEYQLZFEAWCNUURUUSBFNASSYEP
    SSPUFNWDQUUBULUTWEWFWIWJAYEYMYOUUCYMYLUAYOYLWGUUCDYKDSRZUUCWHQZUUCYJUUCDYIU
    VAUUCYHUUFXBZWKZWLUUCYHWMJZDWNYKGWNUUCUVDDUUCYHUUFWOUUCUVDDWPWQYDYHWPWQYHDW
    PWQTYHYDDWRUUCYHDUUEDBRZUUCWSQWTXAXCUUCYKGUVDDUUCYKGMZUVDDMUUCUVFTZUVDDWMJZ
    DUVGYIDHUEEZMZUVDUVHMZUVGYIDUVIUVGDYIDUUTUVGWHQZUUCYISRUVFUVBXDUVLUVGYJGDDI
    EZUVGYJUUCYJSRUVFUVCXDUUCUVFXEXFUUTUVMGMUVGWHDXGXHXIXJXKXLUVGUUNUVEUVJUVKXN
    UUCUUNUVFUUEXDWSYHDXMXOXPXQUSXRXSXTYAYBURYC $.

  ${
    $d x y t u v w R $.  $d t u v w S $.  $d ph u v w $.
    $( Antiderivative of cross-section of circle.  (Contributed by Brendan
       Leahy, 28-Aug-2017.)  (Revised by Brendan Leahy, 11-Jul-2018.) $)
    areacirclem1 $p |- ( R e. RR+ ->
      ( RR _D ( t e. ( -u R (,) R ) |->
        ( ( R ^ 2 ) x. ( ( arcsin ` ( t / R ) ) +
          ( ( t / R ) x. ( sqr ` ( 1 - ( ( t / R ) ^ 2 ) ) ) ) ) ) ) ) =
      ( t e. ( -u R (,) R ) |->
        ( 2 x. ( sqr ` ( ( R ^ 2 ) - ( t ^ 2 ) ) ) ) ) ) $=
      ( vu wcel cr co c2 cdiv cmul caddc cmpt cvv a1i adantl adantr cc0 clt wbr
      c1 cc vv crp cneg cioo cexp cv casin cfv cmin csqr cdv reex prid1 elioore
      cpr wa recnd rpcn wne rpne0 divcld asincl syl ax-1cn subcld sqrcld mulcld
      sqcld addcld ovex w3a wb rpre renegcld rexrd rpxr elioo2 syl2anc redivcld
      cxr simpr a1d wceq mulm1d breq1d 1re renegcli simpl bitr3d biimpd mulid1d
      ltdivmuld exp4b 3impd sylbid imp rexri mp2an id recn dvmptid wss iooretop
      ioossre dvmptres ax-resscn oveq2d resqcld resubcld cabs absltd abscld cle
      absge0d lt2sqd absresq breq12d resqcl posdifd 3bitrd elrpd mpteq2ia fveq2
      0re dvmptco mulneg2d oveq1d negcld 3eqtr3rd syl6eq mulcomd sqvald 3eqtr2d
      2cn oveq12d eqtrd divcan3d reccld fveq2d sqdivd ltmuldivd adantrd adantld
      breq2d bitr2d 3jcad sylibr sqcl crn ctg ccnfld eqid tgioo2 dvmptdivc cres
      ctopn dvreasin asinf sstri feqresmpt syl5reqr 0le1 sq1 3impib sylbi negex
      wf dvmptc ctopon cnfldtopon toponmax mp1i df-ss mpbi cn dvexp ax-mp 2m1e1
      cin 2nn oveq2i exp1 syl5eq eqtri dvmptres3 dvmptsub mpteq2i syl6eqr dvsqr
      df-neg gt0ne0d sqr00d necon3d mpd 2ne0 divcan5d mulne0d divrec2d dvmptmul
      ex dvmptadd mulid2d divassd negeqd eqtr4d addcomd 2timesd negsubd divdird
      sqsqrd addassd 3eqtrrd oveq1 mulassd divrecd 3eqtr3d mul12d sqge0d eqcomd
      dvmptcmul rpge0 rpgt0 sq0 bitrd mpbid 3bitr3rd ltled sqrmuld subdid sqne0
      0le0 mpbird divcan2d sqrsqd 3eqtrd mpteq2dva ) BUBDZEABUCZBUDFZBGUEFZAUFZ
      BHFZUGUHZVUBSVUBGUEFZUIFZUJUHZIFZJFZIFKUKFAUYSUYTGVUFIFZSBHFZIFZIFZKAUYSG
      UYTVUAGUEFZUIFZUJUHZIFZKUYQAVUHVUKUYTELUYSEETUODUYQETULUMMZUYQVUAUYSDZUPZ
      VUCVUGVUSVUBTDVUCTDVUSVUABVURVUATDZUYQVURVUAVUAUYRBUNZUQZNZUYQBTDZVURBURZ
      OZUYQBPUSZVURBUTZOZVAZVUBVBVCVUSVUBVUFVVJVUSVUEVUSSVUDSTDZVUSVDMZVUSVUBVV
      JVHZVEVFZVGVIVUKLDVUSVUIVUJIVJMUYQACVUBVUJCUFZUGUHZVVOSVVOGUEFZUIFZUJUHZI
      FZJFZGVVSIFZEEVUHVUILLUYSSUCZSUDFZVUQVUQVUSVUBEDZVWCVUBQRZVUBSQRZVKZVUBVW
      DDZUYQVURVWHUYQVURVUAEDZUYRVUAQRZVUABQRZVKZVWHUYQUYRVTDBVTDVURVWMVLUYQUYR
      UYQBBVMZVNVOBVPUYRBVUAVQVRZUYQVWJVWKVWLVWHUYQVWJVWKVWLVWHUYQVWJUPZVWKVWLU
      PZVWEVWFVWGVWPVWEVWQVWPVUABUYQVWJWAZUYQBEDZVWJVWNOZUYQVVGVWJVVHOZVSZWBVWP
      VWKVWFVWLVWPVWKVWFVWPVWCBIFZVUAQRVWKVWFVWPVXCUYRVUAQUYQVXCUYRWCVWJUYQBVVE
      WDOWEVWPVWCVUABVWCEDVWPSWFWGZMVWRUYQVWJWHZUUAWIWJUUBVWPVWLVWGVWKVWPVWLVWG
      VWPVWGVUABSIFZQRVWLVWPVUASBVWRSEDZVWPWFMZVXEWLVWPVXFBVUAQUYQVXFBWCVWJUYQB
      VVEWKOUUDUUEWJUUCUUFWMWNWOWPVWCVTDZSVTDZVWIVWHVLVWCVXDWQZSWFWQZVWCSVUBVQW
      RUUGVUJLDVUSSBHVJMVVOVWDDZVWATDZUYQVXMVVOTDZVXNVXMVVOVVOVWCSUNZUQZVXOVVPV
      VTVVOVBZVXOVVOVVSVXOWSVXOVVRVXOSVVQVVKVXOVDMZVVOUUHZVEZVFZVGZVIVCNVWBLDUY
      QVXMUPZGVVSIVJMUYQAVUASBETUYSVUQVVCVVLUYQAVUASEUDUUIUUJUHZUUKUUPUHZTEUYSV
      UQVWJVUTUYQVUAWTZNZVVKVWPVDMUYQAEVUQXAUYSEXBUYQUYRBXDMVYFVYFUULZUUMZVYIUY
      SVYEDUYQUYRBXCMXEVVEVVHUUNUYQECVWDVWAKUKFCVWDSVVSHFZSVVSIFZVVOUCZVVSHFZVV
      OIFZJFZJFZKCVWDVWBKUYQCVVPVYKVVTVYPELLVWDVUQVXMVVPTDZUYQVXMVXOVYRVXQVXRVC
      NVYKLDVYDSVVSHVJMUYQCVWDVYKKEUGVWDUUOZUKFECVWDVVPKZUKFCUUQUYQVYSVYTEUKUYQ
      CTTVWDUGTTUGUVGUYQUURMVWDTXBUYQVWDETVWCSXDZXFUUSMUUTXGUVAVXMVVTTDZUYQVXMV
      XOWUBVXQVYCVCNVYPLDVYDVYLVYOJVJMUYQCVVOSVVSVYNETLVWDVUQVXMVXOUYQVXQNVVKVY
      DVDMUYQCVVOSEVYEVYFTEVWDVUQVVOEDZVXOUYQVVOWTZNVVKUYQWUCUPZVDMZUYQCEVUQXAV
      WDEXBUYQWUAMZVYJVYIVWDVYEDUYQVWCSXCMZXEVXMVVSTDZUYQVXMVXOWUIVXQVYBVCZNVYN
      LDVYDVYMVVSHVJMUYQECVWDVVSKUKFCVWDSVWBHFZGVVOIFZUCZIFZKCVWDVYNKUYQCUAVVRW
      UMUAUFZUJUHZSGWUPIFZHFZEEVVSWUKLLVWDUBVUQVUQVXMVVRUBDUYQVXMVVRVXMSVVQVXGV
      XMWFMVXMVVOVXPXHXIVXMWUCVWCVVOQRZVVOSQRZVKZPVVRQRZVXIVXJVXMWVAVLVXKVXLVWC
      SVVOVQWRWUCWUSWUTWVBWUCWUSWUTUPZWVBWUCVVOXJUHZSQRZWVCWVBWUCVVOSWUCWSVXGWU
      CWFMZXKWUCWVEWVDGUEFZSGUEFZQRVVQSQRWVBWUCWVDSWUCVVOWUDXLWVFWUCVVOWUDXNPSX
      MRWUCUVBMXOWUCWVGVVQWVHSQVVOXPWVHSWCWUCUVCMXQWUCVVQSVVOXRWVFXSXTWIWJUVDUV
      EZYANWUMLDZVYDWULUVFZMWUOUBDZWUPTDUYQWVLWUOWUOURVFNWURLDUYQWVLUPSWUQHVJMU
      YQCVVRWUMEVYEVYFLEVWDVUQWUCVVRTDZUYQWUCSVVQVVKWUCVDMWUCVVOWUDVHZVENWVJWUE
      WVKMUYQECEVVRKUKFCEPWULUIFZKCEWUMKUYQCSPVVQWULEELEVUQWUFPEDZWUEYDMUYQCSEV
      UQVVKUYQVDMUVHWUCVVQTDZUYQWVNNWULLDZWUEGVVOIVJZMUYQCVVQWULEVYFLTEVYIVUQVY
      FTUVIUHDTVYFDUYQVYFVYIUVJTVYFUVKUVLETUVSEWCZUYQETXBWVTXFETUVMUVNMVXOWVQUY
      QVXTNWVRUYQVXOUPWVSMTCTVVQKUKFZCTWULKZWCUYQWWACTGVVOGSUIFZUEFZIFZKZWWBGUV
      ODWWAWWFWCUVTCGUVPUVQCTWWEWULVXOWWDVVOGIVXOWWDVVOSUEFVVOWWCSVVOUEUVRUWAVV
      OUWBUWCXGYBUWDMUWEUWFCEWUMWVOWULUWJUWGUWHWUGVYJVYIWUHXEEUAUBWUPKUKFUAUBWU
      RKWCUYQUAUWIMWUOVVRUJYCZWUOVVRWCZWUQVWBSHWWHWUPVVSGIWWGXGXGYECVWDWUNVYNVX
      MGVYMIFZVWBHFWUMVWBHFVYNWUNVXMWWIWUMVWBHVXMGVVOGTDZVXMYNMZVXQYFYGVXMVYMVV
      SGVXMVVOVXQYHZWUJWWKVXMVVRPUSVVSPUSVXMVVRWVIUWKVXMVVSPVVRPVXMVVSPWCZVVRPW
      CVXMWWMUPVVRVXMWVMWWMVXMVXOWVMVXQVYAVCOVXMWWMWAUWLUWTUWMUWNZGPUSVXMUWOMZU
      WPVXMWUMVWBVXMWULVXMGVVOWWKVXQVGYHVXMGVVSWWKWUJVGVXMGVVSWWKWUJWWOWWNUWQUW
      RYIYBYJUWSUXACVWDVYQVWBVXMVYQVYKVVQUCZVVSHFZVVSJFZJFZVWBVXMVYPWWRVYKJVXMV
      YPVVSWWQJFWWRVXMVYLVVSVYOWWQJVXMVVSWUJUXBVXMVYOVVOVYNIFVVOVYMIFZVVSHFWWQV
      XMVYNVVOVXMVYMVVSWWLWUJWWNVAVXQYKVXMVVOVYMVVSVXQWWLWUJWWNUXCVXMWWTWWPVVSH
      VXMWWTVVOVVOIFZUCWWPVXMVVOVVOVXQVXQYFVXMVVQWXAVXMVVOVXQYLUXDUXEYGYMYOVXMV
      VSWWQWUJVXMWWPVVSVXMVVQVXMVVOVXQVHYHZWUJWWNVAZUXFYPXGVXMVWBVVSVVSJFVYKWWQ
      JFZVVSJFWWSVXMVVSWUJUXGVXMVVSWXDVVSJVXMSWWPJFZVVSHFVVSVVSIFZVVSHFWXDVVSVX
      MWXEWXFVVSHVXMVXOWXEWXFWCVXQVXOWXEVVRVVSGUEFWXFVXOSVVQVXSVXTUXHVXOVVRVYAU
      XJVXOVVSVYBYLYMVCYGVXMSWWPVVSVVKVXMVDMWXBWUJWWNUXIVXMVVSVVSWUJWUJWWNYQYIY
      GVXMVYKWWQVVSVXMVVSWUJWWNYRWXCWUJUXKUXLYPYBYJVVOVUBWCZVVPVUCVVTVUGJVVOVUB
      UGYCWXGVVOVUBVVSVUFIWXGWSWXGVVRVUEUJWXGVVQVUDSUIVVOVUBGUEUXMXGYSZYOYOWXGV
      VSVUFGIWXHXGYEUYQBVVEVHZUXTUYQAUYSVULVUPVUSVULUYTVUJVUIIFZIFUYTVUJIFZVUII
      FZVUPVUSVUKWXJUYTIVUSVUIVUJVUSGVUFWWJVUSYNMZVVNVGZUYQVUJTDVURUYQBVVEVVHYR
      OZYKXGVUSUYTVUJVUIUYQUYTTDZVURWXIOZWXOWXNUXNVUSWXLBVUIIFGBVUFIFZIFVUPVUSW
      XKBVUIIUYQWXKBWCVURUYQUYTBHFBBIFZBHFWXKBUYQUYTWXSBHUYQBVVEYLYGUYQUYTBWXIV
      VEVVHUXOUYQBBVVEVVEVVHYQUXPOYGVUSBGVUFVVFWXMVVNUXQVUSWXRVUOGIVUSUYTVUEIFZ
      UJUHUYTUJUHZVUFIFVUOWXRVUSUYTVUEUYQUYTEDVURUYQBVWNXHZOUYQPUYTXMRVURUYQBVW
      NUXROVUSSVUDVXGVUSWFMVUSVUBVUSVUABVURVWJUYQVVANUYQVWSVURVWNOVVIVSXHXIZVUS
      PVUEWVPVUSYDMWYCUYQVURPVUEQRZUYQVURVWMWYDVWOUYQVWJVWKVWLWYDUYQVWJVWKVWLWY
      DVWPVWQWYDVWPVUAXJUHZBQRZVWQWYDVWPVUABVWRVWTXKVWPWYFWYEGUEFZUYTQRVUMUYTSI
      FZQRZWYDVWPWYEBVWJWYEEDUYQVWJVUAVYGXLNVWTVWJPWYEXMRUYQVWJVUAVYGXNNUYQPBXM
      RVWJBUYAZOXOVWPWYGVUMUYTWYHQVWJWYGVUMWCUYQVUAXPNVWPWYHUYTVWPUYTUYQWXPVWJW
      XIOWKUXSXQVWPVUDSQRVUMUYTHFZSQRWYDWYIVWPVUDWYKSQVWPVUABVYHUYQVVDVWJVVEOVX
      AYTWEVWPVUDSVWPVUBVXBXHVXHXSVWPVUMSUYTVWJVUMEDUYQVUAXRNVXHUYQUYTUBDVWJUYQ
      UYTWYBUYQPBQRZPUYTQRZBUYBUYQWYLPGUEFZUYTQRWYMUYQPBWVPUYQYDMVWNPPXMRUYQUYK
      MWYJXOUYQWYNPUYTQWYNPWCUYQUYCMWEUYDUYEYAOWLUYFXTWIWJWMWNWOWPUYGUYHVUSWXTV
      UNUJVUSWXTWYHUYTVUDIFZUIFVUNVUSUYTSVUDWXQVVLVVMUYIVUSWYHUYTWYOVUMUIVUSUYT
      WXQWKVUSWYOUYTWYKIFVUMVUSVUDWYKUYTIVUSVUABVVCVVFVVIYTXGVUSVUMUYTVURVUMTDU
      YQVURVUAVVBVHNWXQUYQUYTPUSZVURUYQWYPVVGVVHUYQVVDWYPVVGVLVVEBUYJVCUYLOUYMY
      PYOYPYSVUSWYABVUFIUYQWYABWCVURUYQBVWNWYJUYNOYGYIXGUYOYMUYPYP $.

    $( Endpoint-inclusive continuity of Cartesian ordinate of circle.
       (Contributed by Brendan Leahy, 29-Aug-2017.)  (Revised by Brendan Leahy,
       11-Jul-2018.) $)
    areacirclem2 $p |- ( ( R e. RR /\ 0 <_ R ) ->
      ( t e. ( -u R [,] R ) |-> ( sqr ` ( ( R ^ 2 ) - ( t ^ 2 ) ) ) )
        e. ( ( -u R [,] R ) -cn-> CC ) ) $=
      ( vu cr wcel cc0 cle wbr wa co cfv cmpt wceq adantr wss 3ad2ant3 ccn eqid
      cc a1i cneg cicc c2 cexp cv cmin csqr cpnf cico cres ccncf resqcl renegcl
      iccssre mpancom sselda resqcld adantlr resubcld w3a wb elicc2 wi 3ad2ant1
      cabs subge0d absresq breq1d bitr4d recn abscld simp1 absge0d simp2 le2sqd
      simp3 absled 3bitr2d biimprd 3expa exp4b 3impd imp elrege0 sylanbrc fvres
      sylbid mpteq2dva ccnfld ctopn crest ctopon cnfldtopon ax-resscn resttopon
      syl syl6ss sylancr resmpt sqcld cnmptc sqcn ctx cnmpt12f toponunii cnrest
      subcn syl2anc eqeltrrd crn wrex rnmpt 3adant3 eqeltrd rexlimdv3a syl5eqss
      cab abssdv cxr 0re pnfxr icossre mp2an sstri cnrest2 syl3anc mpbid cncfss
      ssid resqrcn sselii cncfcn eleqtri cnmpt11f sylancl eleqtrrd ) BDEZFBGHZI
      ZABUAZBUBJZBUCUDJZAUEZUCUDJZUFJZUGFUHUIJZUJZKZLZAUUAUUEUGKZLUUASUKJZYSAUU
      AUUHUUJYSUUCUUAEZIZUUEUUFEZUUHUUJMUUMUUEDEFUUEGHZUUNUUMUUBUUDYSUUBDEZUULY
      QUUPYRBULZNNYQUULUUDDEZYRYQUULIUUCYQUUADUUCYTDEZYQUUADOBUMZYTBUNUOZUPUQUR
      USYSUULUUOYSUULUUCDEZYTUUCGHZUUCBGHZUTZUUOYQUULUVEVAZYRUUSYQUVFUUTYTBUUCV
      BUONYSUVBUVCUVDUUOYSUVBUVCUVDUUOYQYRUVBUVCUVDIZUUOVCYQYRUVBUTZUUOUVGUVHUU
      OUUCVEKZUCUDJZUUBGHZUVIBGHUVGUVHUUOUUDUUBGHUVKUVHUUBUUDYQYRUUPUVBUUQVDUVB
      YQUURYRUUCULPVFUVHUVJUUDUUBGUVBYQUVJUUDMYRUUCVGPVHVIUVHUVIBUVBYQUVIDEYRUV
      BUUCUUCVJZVKPYQYRUVBVLZUVBYQFUVIGHYRUVBUUCUVLVMPYQYRUVBVNVOUVHUUCBYQYRUVB
      VPUVMVQVRVSVTWAWBWGWCUUEWDWEZUUEUUFUGWFWPWHYSUUIWIWJKZUUAWKJZUVOSWKJZQJZU
      UKYSAUUEUUGUVPUVOUUFWKJZUVQUUAYQUVPUUAWLKEZYRYQUVOSWLKEZUUASOZUVTUVOUVORZ
      WMZYQUUADSUVAWNWQZUUAUVOSWOWRNYSAUUAUUELZUVPUVOQJZEZUWFUVPUVSQJEZYQUWHYRY
      QASUUELZUUAUJZUWFUWGYQUWBUWKUWFMUWEASUUAUUEWSWPYQUWJUVOUVOQJZEUWBUWKUWGEY
      QAUUBUUDUFUVOUVOUVOUVOSUWAYQUWDTZYQAUUBUVOUVOSSUWMUWMYQBBVJWTXAASUUDLUWLE
      YQAUVOUWCXBTUFUVOUVOXCJUVOQJEYQUVOUWCXGTXDUWEUUAUWJUVOUVOSSUVOUWDXEXFXHXI
      NYSUWAUWFXJZUUFOUUFSOZUWHUWIVAUWAYSUWDTYSUWNCUEZUUEMZAUUAXKZCXQUUFACUUAUU
      EUWFUWFRXLYSUWRCUUFYSUWQUWPUUFEAUUAYSUULUWQUTUWPUUEUUFYSUULUWQVPYSUULUUNU
      WQUVNXMXNXOXRXPUWOYSUUFDSFDEUHXSEUUFDOXTYAFUHYBYCWNYDZTUUFUWFUVPUVOSYEYFY
      GUUGUVSUVQQJZEYSUUGUUFSUKJZUWTUUFDUKJZUXAUUGDSOSSOZUXBUXAOWNSYIZUUFDSYHYC
      YJYKUWOUXCUXAUWTMUWSUXDUUFSUVOUVSUVQUWCUVSRUVQRZYLYCYMTYNYQUUKUVRMZYRYQUW
      BUXCUXFUWEUXDUUASUVOUVPUVQUWCUVPRUXEYLYONYPXI $.

    $( Integrability of cross-section of circle.  (Contributed by Brendan
       Leahy, 26-Aug-2017.)  (Revised by Brendan Leahy, 11-Jul-2018.) $)
    areacirclem3 $p |- ( ( R e. RR /\ 0 <_ R ) -> ( t e. ( -u R [,] R ) |->
      ( 2 x. ( sqr ` ( ( R ^ 2 ) - ( t ^ 2 ) ) ) ) ) e. L^1 ) $=
      ( cr wcel cc0 cle wbr wa cneg cicc co c2 cexp cfv cmul cc a1i wss syl3anc
      cmpt cv cmin csqr ccncf cibl renegcl adantr simpl ccnfld ctopn eqid mulcn
      ctx ccn 2cn iccssre ax-resscn syl6ss ssid cncfmptc areacirclem2 cncfmpt2f
      syl2anc cnicciblnc ) BCDZEBFGZHZBIZCDZVEAVHBJKZLBLMKAUALMKUBKUCNZOKTZVJPU
      DKZDVLUEDVEVIVFBUFUGZVEVFUHZVGALVKOUIUJNZVJVPUKZOVPVPUMKVPUNKDVGVPVQULQVG
      LPDZVJPRPPRZAVJLTVMDVRVGUOQVGVJCPVGVIVEVJCRVNVOVHBUPVCUQURVSVGPUSQALVJPUT
      SABVAVBVHBVLVDS $.

    $( Endpoint-inclusive continuity of antiderivative of cross-section of
       circle.  (Contributed by Brendan Leahy, 31-Aug-2017.)  (Revised by
       Brendan Leahy, 11-Jul-2018.) $)
    areacirclem4 $p |- ( R e. RR+ -> ( t e. ( -u R [,] R ) |->
      ( ( R ^ 2 ) x. ( ( arcsin ` ( t / R ) ) +
        ( ( t / R ) x. ( sqr ` ( 1 - ( ( t / R ) ^ 2 ) ) ) ) ) ) ) e.
      ( ( -u R [,] R ) -cn-> CC ) ) $=
      ( wcel co cfv c1 cmin csqr cmul a1i cc cmpt cr syl2anc ci cc0 wceq adantr
      cle wbr crp c2 cexp cv cdiv casin caddc ccnfld ctopn cneg cicc eqid mulcn
      ctx ccn wss ccncf rpcn sqcld rpre renegcld ax-resscn syl6ss ssid cncfmptc
      iccssre syl3anc addcn clog cmnf cioc cdif cres wa sselda wne rpne0 divcld
      asinval syl ax-icn mulcld ax-1cn subcld sqrcld addcld wn wo w3a clt simp3
      0lt1 oveq1d div0d 3ad2ant1 oveq2d mul01i syl6eq fveq2d sq0 oveq2i subid1i
      eqtrd eqtri fveq2i sqr1 oveq12d 0p1e1 breq2d 0re 1re eqeltrd ltnled mpbii
      bitr3d 3expa olcd inelr wi 3adant3 mulassd mulid1d simpr redivcld resqcld
      resubcld adantl sqdivd breq1d bitrd mp2an eqtr4d mpteq2dva crest divrec2d
      wb ctopon cncfmpt2f mpbird cncfcn pncand 3eqtrrd elicc2 recn resqcl rpgt0
      divcan6d subge0d 0le0 rpge0 mpbid elrpd ledivmuld cabs absresq breqan12rd
      lt2sqd eqcomd abscld absge0d le2sqd absled 3bitr2d biimpd exp4b 3impd imp
      3bitrrd sylbid resqrcld remulcld ex mtoi orcd pm2.61dane ianor sylibr cxr
      mnfxr elioc2 3simpb sylbi nsyl eldifd fvres cnfldtopon resttopon wf fmptd
      negcli difssd reccld divcan3d sqge0d sqrmuld subdid sqne0 divcan2d sqrsqd
      cncfmptid 3eqtr3rd 3eqtr3d areacirclem2 cncffvrn eleqtrd eleqtri cnmpt11f
      logcn difss eleqtrrd divrecd 3eqtr2d ) BUACZABUBUCDZAUDZBUEDZUFEZUXPFUXPU
      BUCDZGDZHEZIDZUGDIUHUIEZBUJZBUKDZUYBULZIUYBUYBUNDUYBUODZCUXMUYBUYEUMJZUXM
      UXNKCZUYDKUPZKKUPZAUYDUXNLUYDKUQDZCUXMBBURZUSZUXMUYDMKUXMUYCMCZBMCZUYDMUP
      UXMBBUTZVAZUYPUYCBVFNZVBVCZUYJUXMKVDZJZAUXNUYDKVEVGUXMAUXQUYAUGUYBUYDUYEU
      GUYFCUXMUYBUYEVHJZUXMAUYDUXQLAUYDOUJZOUXPIDZUXTUGDZVIKVJPVKDZVLZVMZEZIDZL
      UYKUXMAUYDUXQVUJUXMUXOUYDCZVNZUXQVUCVUEVIEZIDZVUJVULUXPKCZUXQVUNQVULUXOBU
      XMUYDKUXOUYSVOZUXMBKCZVUKUYLRZUXMBPVPZVUKBVQZRZVRZUXPVSVTVULVUIVUMVUCIVUL
      VUEVUGCVUIVUMQVULVUEKVUFVULVUDUXTVULOUXPOKCZVULWAJZVVBWBZVULUXSVULFUXRFKC
      VULWCJZVULUXPVVBUSZWDWEZWFVULVUEMCZVUEPSTZVNZVUEVUFCZVULVVIWGZVVJWGZWHZVV
      KWGVULVVOUXOPVULUXOPQZVNVVNVVMUXMVUKVVPVVNUXMVUKVVPWIZPFWJTZVVNWLVVQPVUEW
      JTVVRVVNVVQVUEFPWJVVQVUEPFUGDFVVQVUDPUXTFUGVVQVUDOPIDPVVQUXPPOIVVQUXPPBUE
      DZPVVQUXOPBUEUXMVUKVVPWKWMUXMVUKVVSPQVVPUXMBUYLVUTWNWOXCZWPOWAWQWRVVQUXTF
      PUBUCDZGDZHEZFVVQUXSVWBHVVQUXRVWAFGVVQUXPPUBUCVVTWMWPWSVWCFHEFVWBFHVWBFPG
      DFVWAPFGWTXAFWCXBXDXEXFXDWRXGXHWRZXIVVQPVUEPMCZVVQXJJVVQVUEFMVWDFMCZVVQXK
      JXLXMXOXNXPXQVULUXOPVPZVNZVVMVVNVWHVVIOMCZXRUXMVUKVWGVVIVWIXSUXMVUKVWGWIZ
      VVIVWIVWJVVIVNZOVUEUXTGDZBUXOUEDZIDZMVWJOVWNQVVIVWJVWNOUXPVWMIDZIDZOFIDOV
      WJVWNVUDVWMIDVWPVWJVWLVUDVWMIUXMVUKVWLVUDQVWGVULVUDUXTVVEVVHUUAXTWMVWJOUX
      PVWMVVCVWJWAJZUXMVUKVUOVWGVVBXTVWJBUXOUXMVUKVUQVWGUYLWOZUXMVUKUXOKCZVWGVU
      PXTZUXMVUKVWGWKZVRYAXCVWJVWOFOIVWJUXOBVWTVWRVXAUXMVUKVUSVWGVUTWOUUGWPVWJO
      VWQYBUUBRVWKVWLVWMVWKVUEUXTVWJVVIYCVWJUXTMCZVVIUXMVUKVXBVWGVULUXSVULFUXRV
      WFVULXKJVULUXPVULUXOBUXMUYDMUXOUYRVOZUXMUYOVUKUYPRZVVAYDYEYFZUXMVUKPUXSST
      ZUXMVUKUXOMCZUYCUXOSTZUXOBSTZWIZVXFUXMUYNUYOVUKVXJYPUYQUYPUYCBUXOUUCNUXMV
      XGVXHVXIVXFUXMVXGVXHVXIVXFUXMVXGVNZVXHVXIVNZVXFVXKVXFUXRFSTUXOUBUCDZUXNUE
      DZFSTZVXLVXKFUXRVWFVXKXKJZVXKUXPVXKUXOBUXMVXGYCZUXMUYOVXGUYPRZUXMVUSVXGVU
      TRZYDYEUUHVXKUXRVXNFSVXKUXOBVXGVWSUXMUXOUUDZYGUXMVUQVXGUYLRVXSYHYIVXKVXOV
      XMUXNFIDZSTZVXLVXKVXMFUXNVXGVXMMCUXMUXOUUEYGVXPUXMUXNUACVXGUXMUXNUXMBUYPY
      EZUXMPBWJTZPUXNWJTZBUUFUXMVYDVWAUXNWJTVYEUXMPBVWEUXMXJJUYPPPSTUXMUUIJBUUJ
      ZUUQUXMVWAPUXNWJVWAPQUXMWTJYIYJUUKUULRUUMVXKVYBUXOUUNEZUBUCDZUXNSTVYGBSTV
      XLVXGUXMVXMVYHVYAUXNSVXGVYHVXMUXOUUOUURUXMUXNUYMYBUUPVXKVYGBVXGVYGMCUXMVX
      GUXOVXTUUSYGVXRVXGPVYGSTUXMVXGUXOVXTUUTYGUXMPBSTZVXGVYFRUVAVXKUXOBVXQVXRU
      VBUVCYJUVHUVDUVEUVFUVIUVGZUVJXTRYFVWJVWMMCVVIVWJBUXOUXMVUKUYOVWGUYPWOUXMV
      UKVXGVWGVXCXTVXAYDRUVKXLUVLXPUVMUVNUVOVVIVVJUVPUVQVVLVVIVJVUEWJTZVVJWIZVV
      KVJUVRCVWEVVLVYLYPUVSXJVJPVUEUVTYKVVIVYKVVJUWAUWBUWCUWDZVUEVUGVIUWEVTWPYL
      YMUXMAVUCVUIIUYBUYDUYEUYGUXMVUCKCZUYIUYJAUYDVUCLUYKCVYNUXMOWAUWJJUYSVUAAV
      UCUYDKVEVGUXMAUYDVUILUYBUYDYNDZUYBKYNDZUODZUYKUXMAVUEVUHVYOUYBVUGYNDZVYPU
      YDUXMUYBKYQECZUYIVYOUYDYQECVYSUXMUYBUYEUWFJUYSUYDUYBKUWGNUXMAUYDVUELZUYDV
      UGUQDZVYOVYRUODZUXMVYTWUACZUYDVUGVYTUWHZUXMAUYDVUEVUGVYTVYMVYTULUWIUXMVUG
      KUPZVYTUYKCWUCWUDYPUXMKVUFUWKZUXMAVUDUXTUGUYBUYDUYEVUBUXMAUYDVUDLAUYDOFBU
      EDZIDZUXOIDZLUYKUXMAUYDVUDWUIVULVUDOWUGUXOIDZIDWUIVULUXPWUJOIVULUXOBVUPVU
      RVVAYOWPVULOWUGUXOVVDUXMWUGKCZVUKUXMBUYLVUTUWLZRZVUPYAYLYMUXMAWUHUXOIUYBU
      YDUYEUYGUXMWUHKCUYIUYJAUYDWUHLUYKCUXMOWUGVVCUXMWAJWULWBUYSVUAAWUHUYDKVEVG
      UXMUYIUYJAUYDUXOLUYKCUYSVUAAUYDKUWTNZYRXLUXMAUYDUXTLAUYDWUGUXNVXMGDZHEZID
      ZLUYKUXMAUYDUXTWUQVULBUXTIDZBUEDWUGWURIDUXTWUQVULWURBVULBUXTVURVVHWBVURVV
      AYOVULUXTBVVHVURVVAUWMVULWURWUPWUGIVULUXNUXSIDZHEUXNHEZUXTIDWUPWURVULUXNU
      XSUXMUXNMCVUKVYCRUXMPUXNSTVUKUXMBUYPUWNRVXEVYJUWOVULWUSWUOHVULWUSVYAUXNUX
      RIDZGDWUOVULUXNFUXRUXMUYHVUKUYMRZVVFVVGUWPVULVYAUXNWVAVXMGVULUXNWVBYBVULW
      VAUXNVXNIDVXMVULUXRVXNUXNIVULUXOBVUPVURVVAYHWPVULVXMUXNVULUXOVUPUSZWVBUXM
      UXNPVPZVUKUXMWVDVUSVUTUXMVUQWVDVUSYPUYLBUWQVTYSRUWRXCXGXCWSVULWUTBUXTIVUL
      BVXDUXMVYIVUKVYFRUWSWMUXAWPUXBZYMUXMAWUGWUPIUYBUYDUYEUYGUXMWUKUYIUYJAUYDW
      UGLUYKCWULUYSVUAAWUGUYDKVEVGUXMUYOVYIAUYDWUPLUYKCUYPVYFABUXCNZYRXLYRUYDKV
      UGVYTUXDNYSUXMUYIWUEWUAWUBQUYSWUFUYDVUGUYBVYOVYRUYEVYOULZVYRULZYTNUXEVUHV
      YRVYPUODZCUXMVUHVUGKUQDZWVIVUGVUGULUXHWUEUYJWVJWVIQKVUFUXIUYTVUGKUYBVYRVY
      PUYEWVHVYPULZYTYKUXFJUXGUXMUYIUYJUYKVYQQUYSVUAUYDKUYBVYOVYPUYEWVGWVKYTNUX
      JYRXLUXMAUYDUYALAUYDUXOWUGWUGIDZIDZWUPIDZLUYKUXMAUYDUYAWVNVULUYAUXPWUQIDU
      XPWUGIDZWUPIDWVNVULUXTWUQUXPIWVEWPVULUXPWUGWUPVVBWUMVULWUOVULUXNVXMWVBWVC
      WDWEYAVULWVOWVMWUPIVULWVOUXOWUGIDZWUGIDWVMVULUXPWVPWUGIVULUXOBVUPVURVVAUX
      KWMVULUXOWUGWUGVUPWUMWUMYAXCWMUXLYMUXMAWVMWUPIUYBUYDUYEUYGUXMAUXOWVLIUYBU
      YDUYEUYGWUNUXMWVLKCUYIUYJAUYDWVLLUYKCUXMWUGWUGWULWULWBUYSVUAAWVLUYDKVEVGY
      RWVFYRXLYRYR $.

    areacirc.1 $e |- S = { <. x , y >. | ( ( x e. RR /\ y e. RR ) /\
      ( ( x ^ 2 ) + ( y ^ 2 ) ) <_ ( R ^ 2 ) ) } $.
    $( Finding the cross-section of a circle.  (Contributed by Brendan Leahy,
       31-Aug-2017.)  (Revised by Brendan Leahy, 22-Sep-2017.)  (Revised by
       Brendan Leahy, 11-Jul-2018.) $)
    areacirclem5 $p |- ( ( R e. RR /\ 0 <_ R /\ t e. RR ) -> ( S " { t } ) =
      if ( ( abs ` t ) <_ R ,
        ( -u ( sqr ` ( ( R ^ 2 ) - ( t ^ 2 ) ) ) [,]
          ( sqr ` ( ( R ^ 2 ) - ( t ^ 2 ) ) ) ) , (/) ) ) $=
      ( vu cr wcel cc0 cle wbr c2 cexp co wa c0 wceq adantr clt cv w3a csn cima
      caddc cab cabs cfv cmin csqr cneg cicc cif copab imaeq1i cvv imasng ax-mp
      vex cop df-br weq eleq1 anbi1d oveq1 oveq1d breq1d anbi2d oveq2d opelopab
      anass 3bitri abbii 3eqtri simp3 biantrurd abbidv cxr crab resqcl 3ad2ant1
      anbi12d 3ad2ant3 resubcld absresq recn abscld simp1 absge0d simp2 subge0d
      le2sqd 3bitr4d biimpa resqrcld renegcld rexrd iccval syl2anc iftrue recnd
      adantl cc sqsqrd breqan12rd sqrge0d wb leaddsub2d adantlr 3bitr4rd absled
      simpr rexr 3bitrd pm5.32da cmnf mnfxr a1i mnflt simprrl xrltletrd simprrr
      simprl xrre syl22anc ex pm4.71rd bitr4d df-rab syl6eqr 3eqtr4rd wn ltnled
      syl biimprd imdistani wral readdcld lt2sqd mpbid 3adant3 addge01d ltletrd
      breq2d bitrd sqge0 3expa ralrimiva rabeq0 sylibr syl5eqr eqtr4d pm2.61dan
      iffalse eqtr3d syl5eq ) DHIZJDKLZCUAZHIZUBZEUUSUCZUDZUUTGUAZHIZUUSMNOZUVD
      MNOZUEOZDMNOZKLZPZPZGUFZUUSUGUHZDKLZUVIUVFUIOZUJUHZUKZUVQULOZQUMZUVCAUAZH
      IZBUAZHIZPZUWAMNOZUWCMNOZUEOZUVIKLZPZABUNZUVBUDZUUSUVDUWKLZGUFZUVMEUWKUVB
      FUOUUSUPIUWLUWNRCUSZGUUSUPUWKUQURUWMUVLGUWMUUSUVDUTUWKIUUTUVEPZUVJPZUVLUU
      SUVDUWKVAUWJUUTUWDPZUVFUWGUEOZUVIKLZPUWQABUUSUVDUWOGUSACVBZUWEUWRUWIUWTUX
      AUWBUUTUWDUWAUUSHVCVDUXAUWHUWSUVIKUXAUWFUVFUWGUEUWAUUSMNVEVFVGWBBGVBZUWRU
      WPUWTUVJUXBUWDUVEUUTUWCUVDHVCVHUXBUWSUVHUVIKUXBUWGUVGUVFUEUWCUVDMNVEVIVGW
      BVJUUTUVEUVJVKVLVMVNUVAUVKGUFZUVMUVTUVAUVKUVLGUVAUUTUVKUUQUURUUTVOVPVQUVA
      UVOUXCUVTRUVAUVOPZUVSUVRUVDKLZUVDUVQKLZPZGVRVSZUVTUXCUXDUVRVRIUVQVRIUVSUX
      HRUXDUVRUXDUVQUXDUVPUVAUVPHIUVOUVAUVIUVFUUQUURUVIHIZUUTDVTWAZUUTUUQUVFHIZ
      UURUUSVTWCZWDZSZUVAUVOJUVPKLZUVAUVNMNOZUVIKLUVFUVIKLUVOUXOUVAUXPUVFUVIKUU
      TUUQUXPUVFRUURUUSWEWCZVGUVAUVNDUUTUUQUVNHIUURUUTUUSUUSWFZWGWCZUUQUURUUTWH
      ZUUTUUQJUVNKLUURUUTUUSUXRWIWCZUUQUURUUTWJZWLUVAUVIUVFUXJUXLWKWMWNZWOZWPZW
      QUXDUVQUYDWQGUVRUVQWRWSUVOUVTUVSRUVAUVOUVSQWTXBUXDUXCUVDVRIZUXGPZGUFUXHUX
      DUVKUYGGUXDUVKUVEUYGPUYGUXDUVEUVJUYGUXDUVEPZUVJUVDUGUHZUVQKLZUXGUYGUYHUYI
      MNOZUVQMNOZKLUVGUVPKLZUYJUVJUVEUXDUYKUVGUYLUVPKUVDWEUXDUVPUVAUVPXCIUVOUVA
      UVPUXMXASXDXEUYHUYIUVQUVEUYIHIUXDUVEUVDUVDWFZWGXBUXDUVQHIZUVEUYDSZUVEJUYI
      KLUXDUVEUVDUYNWIXBUXDJUVQKLUVEUXDUVPUXNUYCXFSWLUVAUVEUVJUYMXGUVOUVAUVEPUV
      FUVGUVIUVAUXKUVEUXLSUVEUVGHIZUVAUVDVTZXBUVAUXIUVEUXJSXHXIXJUYHUVDUVQUXDUV
      EXLUYPXKUYHUYFUXGUVEUYFUXDUVDXMXBVPXNXOUXDUYGUVEUXDUYGUVEUXDUYGPZUYFUYOXP
      UVDTLUXFUVEUXDUYFUXGYCZUXDUYOUYGUYDSUYSXPUVRUVDXPVRIUYSXQXRUYSUVRUXDUVRHI
      ZUYGUYESWQUYTUXDXPUVRTLZUYGUXDVUAVUBUYEUVRXSYNSUXDUYFUXEUXFXTYAUXDUYFUXEU
      XFYBUVDUVQYDYEYFYGYHVQUXGGVRYIYJYKUVAUVOYLZPZUXCQUVTVUDUVADUVNTLZPZUXCQRU
      VAVUCVUEUVAVUEVUCUVADUVNUXTUXSYMYOYPVUFUXCUVJGHVSZQUVJGHYIVUFUVJYLZGHYQVU
      GQRVUFVUHGHUVAVUEUVEVUHUVAVUEUVEUBZUVIUVHTLVUHVUIUVIUVFUVHUVAVUEUXIUVEUXJ
      WAZUVAVUEUXKUVEUXLWAZVUIUVFUVGVUKUVEUVAUYQVUEUYRWCZYRZUVAVUEUVIUVFTLZUVEU
      VAVUEVUNUVAVUEUVIUXPTLVUNUVADUVNUXTUXSUYBUYAYSUVAUXPUVFUVITUXQUUDUUEWNUUA
      VUIJUVGKLZUVFUVHKLUVEUVAVUOVUEUVDUUFWCVUIUVFUVGVUKVULUUBYTUUCVUIUVIUVHVUJ
      VUMYMYTUUGUUHUVJGHUUIUUJUUKYNVUCUVTQRUVAUVOUVSQUUNXBUULUUMUUOUUP $.

    $( The area of a circle of radius ` R ` is ` pi x. R ^ 2 ` .  (Contributed
       by Brendan Leahy, 31-Aug-2017.)  (Revised by Brendan Leahy,
       22-Sep-2017.)  (Revised by Brendan Leahy, 11-Jul-2018.) $)
    areacirc $p |- ( ( R e. RR /\ 0 <_ R ) ->
         ( area ` S ) = ( pi x. ( R ^ 2 ) ) ) $=
      ( vt vu cr wcel cc0 cle wbr wa cfv c2 co cmul wceq a1i c1 carea cima cvol
      csn citg cpi cexp cdm wss cmpt cibl caddc wex eqtri adantr adantl eqeltrd
      cv simpl w3a cmin csqr cneg cicc resqcl 3ad2ant1 3ad2ant3 resubcld breq1d
      c0 recn simp1 subge0d resqrcld renegcld iccmbl syl2anc mblvol syl sqrge0d
      covol addge0d cc sqcld subcld sqrcld subnegd breq2d bitr3d mpbid eqtrd wb
      syl3anc volf elpreima mp2b 0mbl ax-mp 0re 3expa fveq2d mpteq2dva cvv cdif
      wn eldif 3anass biantrurd bitrd 3bitr4rd biimpd 3expia syl5bi imp biimprd
      wi imp3a syl6eq exp3a 3impd sylbid 3impia recnd cioo sylan2 clt cxr oveq1
      negeqd oveq12d sqr0 simpr oveq2d cdiv casin divcld ax-1cn fvmptd oveq1d
      ovex cxp ccnv cop cab copab df-opab opelxpi exlimivv eqsstri areacirclem5
      wral abssi cif absresq abscld absge0d simp2 le2sqd 3bitr4d biimpa ovolicc
      cabs cpnf wf wfn sylanbrc ovol0 eqeltri mpbir2an ifclda ralrimiva renegcl
      ffn iccssre rembl elicc2 simp3 absled con3d iffalse iftrue mpancom sselda
      fvex 3adant2 resqcld 2timesd 3eqtr4d 3eqtrd areacirclem3 iblss2 syl3anbrc
      3bitr3rd dmarea areaval elioore itgeq2dv ioossre rexrd rexr elioo2 absltd
      notbid lenltd bitr4d anim1i eqle 3syl eqtr3d subidd negeqi neg0 sylan9eqr
      mp2an 0xr iccid ovolsn syldan wne ltnled simpl1 leltned syl6bir pm2.61dne
      ex itgss negeq id iooid itgeq1 itg0 sq0 oveq2i pire recni mul01i syl6reqr
      eqtr2i syl5eq crp biimp3ar elrpd cdv rpre rpxr exp4b ltled lt2sqd posdifd
      rpge0 crn ctg ccnfld ctopn ax-resscn rpcn rpne0 asincl mulcld addcld eqid
      tgioo2 cnt iccntr dvmptntr areacirclem1 weq 3eqtr4rd eqtr4d ccncf ctx ccn
      mulcn sstri ssid 3pm3.2i cncfmptc mp1i cres ioossicc areacirclem2 rescncf
      resmpt mpsyl syl5eqelr cncfmpt2f ioombl areacirclem4 ftc2nc ubicc2 dividd
      2cn iblss eqidd asin1 sq1 mul01d 2ne0 divcli addid1d lbicc2 divnegd sqneg
      asinneg negcli subnegi 2halves subdid mulcomd 3eqtr3d pm2.61dane ) CHIZJC
      KLZMZDUANZFHDFURZUDUBZUCNZUEZUFCOUGPZQPZVXNDUAUHIZVXOVXSRVXNDHHUUAZUIZVXQ
      UCUUBHUBZIZFHUUKFHVXRUJZUKIVYBVYDVXNDGURZAURZBURZUUCZRZVYIHIVYJHIMZVYIOUG
      PVYJOUGPULPVXTKLZMZMZBUMAUMZGUUDZVYCDVYOABUUEVYREVYOABGUUFUNVYQGVYCVYPVYH
      VYCIABVYPVYHVYKVYCVYLVYOUSVYOVYKVYCIZVYLVYMVYSVYNVYIVYJHHUUGUOUPUQUUHUULU
      UISVXNVYFFHVXLVXMVXPHIZVYFVXLVXMVYTUTZVXQVXPUVBNZCKLZVXTVXPOUGPZVAPZVBNZV
      CZWUFVDPZVJUUMZVYEABFCDEUUJZWUAWUCWUHVJVYEWUAWUCMZWUHUCUHZIZWUHUCNZHIZWUH
      VYEIZWUKWUGHIZWUFHIZWUMWUKWUFWUKWUEWUAWUEHIZWUCWUAVXTWUDVXLVXMVXTHIZVYTCV
      EZVFZVYTVXLWUDHIZVXMVXPVEZVGZVHUOZWUAWUCJWUEKLZWUAWUBOUGPZVXTKLZWUDVXTKLZ
      WUCWVGWUAWVHWUDVXTKVYTVXLWVHWUDRZVXMVXPUUNZVGZVIZWUAWUBCVYTVXLWUBHIZVXMVY
      TVXPVXPVKZUUOZVGZVXLVXMVYTVLZVYTVXLJWUBKLZVXMVYTVXPWVPUUPZVGVXLVXMVYTUUQU
      URZWUAVXTWUDWVBWVEVMZUUSUUTZVNZVOZWWEWUGWUFVPZVQZWUKWUNWUFWUGVAPZHWUKWUNW
      UHWANZWWIWUKWUMWUNWWJRZWWHWUHVRZVSWUKWUQWURWUGWUFKLZWWJWWIRZWWFWWEWUKJWUF
      WUFULPZKLZWWMWUKWUFWUFWWEWWEWUKWUEWVFWWDVTZWWQWBWUKJWWIKLZWWPWWMWUKWWIWWO
      JKWUKWUFWUFWUAWUFWCIZWUCWUAWUEWUAVXTWUDVXLVXMVXTWCIZVYTVXLCCVKWDVFVYTVXLW
      UDWCIZVXMVYTVXPWVPWDVGWEWFUOZWXBWGWHWUKWUFWUGWWEWWFVMWIWJWUGWUFUVAZWMWKWU
      KWUFWUGWWEWWFVHUQWULJUVCVDPZUCUVDZUCWULUVEZWUPWUMWUOMWLWNWULWXDUCUVMZWULW
      UHHUCWOWPUVFVJVYEIZWUAWUCXEZMWXHVJWULIZVJUCNZHIZWQWXKJHWXKVJWANZJWXJWXKWX
      MRWQVJVRWRUVGUNZWSUVHWXEWXFWXHWXJWXLMWLWNWXGWULVJHUCWOWPUVISUVJUQWTUVKVXN
      VYGFHWUIUCNZUJUKVXNFHVXRWXOVXLVXMVYTVXRWXORWUAVXQWUIUCWUJXAWTXBVXNFCVCZCV
      DPZHWXOXCVXNWXPHIZVXLWXQHUIZVXLWXRVXMCUVLZUOZVXLVXMUSZWXPCUVNZVQHWULIVXNU
      VOSWXOXCIVXNVXPWXQIZMWUIUCUWDSVXNVXPHWXQXDIZMWXIWXOJRZVXNWYEWXIWYEVYTWYDX
      EZMVXNWXIVXPHWXQXFVXNVYTWYGWXIVXLVXMVYTWYGWXIXPWUAWUCWYDWUAWUCWYDWUAVYTWX
      PVXPKLZVXPCKLZUTZVYTWYHWYIMZMZWYDWUCWYJWYLWLWUAVYTWYHWYIXGSWUAWXRVXLWYDWY
      JWLZVXLVXMWXRVYTWXTVFWVSWXPCVXPUVPZVQWUAWUCWYKWYLWUAVXPCVXLVXMVYTUVQZWVSU
      VRZWUAVYTWYKWYOXHXIXJXKUVSXLXQXMXNWXIWXOWXKJWXIWUIVJUCWUCWUHVJUVTXAWXNXRZ
      VSVXNFWXQWXOUJFWXQOWUFQPZUJUKVXNFWXQWXOWYRVXLVXMWYDWXOWYRRVXLVXMWYDUTZWXO
      WUNWWJWYRWYSWUCWXOWUNRZVXLVXMWYDWUCVXNWYDWYJWUCVXNWXRVXLWYMWYAWYBWYNVQVXN
      VYTWYHWYIWUCVXLVXMVYTWYHWYIWUCXPXPWUAWYHWYIWUCWUAWUCWYKWYPXOXSXLXTYAYBWUC
      WUIWUHUCWUCWUHVJUWAXAZVSWYSWUMWWKWYSWUQWURWUMWYSWUFWYSWUEWYSVXTWUDVXLVXMW
      UTWYDWVAVFWYSVXPVXLWYDVYTVXMVXLWXQHVXPWXRVXLWXSWXTWYCUWBUWCUWEUWFVHZVXLVX
      MWYDWVGVXNWYDWYJWVGVXLWYMVXMWXRVXLWYMWXTWYNUWBUOVXNVYTWYHWYIWVGVXLVXMVYTW
      YHWYIWVGXPXPWUAWYHWYIWVGWUAWVGWYKWUAWVGWVJWYKWWCWUAWUCWVIWYKWVJWWBWYPWVNU
      WMXIXOXSXLXTYAYBZVNZVOZXUDWWGVQWWLVSWYSWWIWWOWWJWYRWYSWUFWUFWYSWUEWYSWUEX
      UBYCWFZXUFWGZWYSWUQWURWWMWWNXUEXUDWYSWWPWWMWYSWUFWUFXUDXUDWYSWUEXUBXUCVTZ
      XUHWBWYSWWRWWPWWMWYSWWIWWOJKXUGWHWYSWUFWUGXUDXUEVMWIWJWXCWMWYSWUFXUFUWGUW
      HUWIWTXBFCUWJUQUWKUQFDUWNUWLFDUWOVSVXNFWXPCYDPZVXRUEFXUIWXOUEZVXSVYAVXNFX
      UIVXRWXOVXNVXPXUIIZMVXQWUIUCXUKVXNVYTVXQWUIRZVXPWXPCUWPZVXLVXMVYTXULWUJWT
      YEXAUWQVXNFXUIHVXRXUIHUIVXNWXPCUWRZSVXNVXPHXUIXDIZVXRJRZXUOVYTXUKXEZMVXNX
      UPVXPHXUIXFVXNVYTXUQXUPVXLVXMVYTXUQXUPXPWUAXUQCWUBKLZXUPWUAXUQWUBCYFLZXEX
      URWUAXUKXUSWUAXUKVYTWXPVXPYFLZVXPCYFLZUTZXUSVXLVXMXUKXVBWLZVYTVXLWXPYGIZC
      YGIZXVCVXLWXPWXTUWSCUWTWXPCVXPUXAZVQVFWUAXUTXVAMZVYTXVGMZXUSXVBWUAVYTXVGW
      YOXHWUAVXPCWYOWVSUXBXVBXVHWLWUAVYTXUTXVAXGSXJXIUXCWUACWUBWVSWVRUXDUXEWUAX
      URXUPWUAXURMZVXRWXOJXVIVXQWUIUCWUAXULXURWUJUOXAXVIWYFWUBCWUAWUBCRZWYFXPXU
      RWUAXVJWYFWUAXVJMZWXOWUNJXVKWVOXVJMWUCWYTWUAWVOXVJWVRUXFWUBCUXGXUAUXHWUAX
      VJVXTWUDRZWUNJRXVKWVHVXTWUDXVJWVHVXTRWUAWUBCOUGYHUPWUAWVKXVJWVMUOUXIWUAXV
      LMZWUNJJVDPZUCNZJXVMWUHXVNUCXVLWUAWUHWUDWUDVAPZVBNZVCZXVQVDPZXVNXVLWUGXVR
      WUFXVQVDXVLWUFXVQXVLWUEXVPVBVXTWUDWUDVAYHXAZYIXVTYJVYTVXLXVSXVNRVXMVYTXVR
      JXVQJVDVYTXVRJVBNZVCZJVYTXVQXWAVYTXVPJVBVYTWUDVYTWUDWVDYCZUXJXAZYIXWBJVCZ
      JXWAJYKUXKUXLUNXRVYTXVQXWAJXWDYKXRYJVGUXMXAXVOXVNWANZJXVNWULIZXVOXWFRJHIZ
      XWHXWGWSWSJJVPUXNXVNVRWRXWFJUDZWANZJJYGIZXWFXWJRUXOXWKXVNXWIWAJUXPXAWRXWH
      XWJJRWSJUXQWRUNUNXRUXRWKUYEUOXVIWUBCUXSZWXIWYFXVICWUBYFLZWXIXWLWUAXWMWXIW
      LXURWUACWUBWVSWVRUXTUOXVICWUBVXLVXMVYTXURUYAWUAWVOXURWVRUOWUAXURYLUYBWIWY
      QUYCUYDWKUYEYAXLXQXMXNUYFVXNXUJVYARZCJVXNCJRZMZXUJFVJWXOUEZVYAXWPXUIVJRZX
      UJXWQRXWOXWRVXNXWOXUIJJYDPVJXWOWXPJCJYDXWOWXPXWEJCJUYGUXLXRXWOUYHYJJUYIXR
      UPFXUIVJWXOUYJVSXWPXWQJVYAFWXOUYKXWOJVYARVXNXWOVYAUFJOUGPZQPZJXWOVXTXWSUF
      QCJOUGYHYMXWTUFJQPJXWSJUFQUYLUYMUFUFUYNUYOZUYPUYRUYQUPUYSWKVXNCJUXSZMCUYT
      IZXWNVXLVXMXXBXXCVXLVXMXXBUTCVXLVXMXXBVLVXLVXMJCYFLXXBVXNJCXWHVXNWSSWYBVX
      LVXMYLUYBVUAVUBWTXXCXUJFXUIVXPHGWXQVXTVYHCYNPZYONZXXDTXXDOUGPZVAPZVBNZQPZ
      ULPZQPZUJZVUCPZNZUECXXLNZWXPXXLNZVAPZVYAXXCFXUIWXOXXNXXCXUKMZWXOWUNXXNXXR
      WUCWYTXXRWUBCXUKWVOXXCXUKVYTWVOXUMWVQVSUPXXCVXLXUKCVUDZUOXXCXUKXUSXXCXUKX
      VBXUSXXCXVDXVEXVCXXCWXPXXCCXXSVOZUWSZCVUEZXVFVQZXXCVYTXUTXVAXUSXXCVYTXUTX
      VAXUSXXCVYTMZXUSXVGXYDVXPCXXCVYTYLXXCVXLVYTXXSUOZUXBZXOVUFXTYAXNVUGXUAVSX
      XRWWIWWOWUNXXNXUKXXCVYTWWIWWORXUMXYDWUFWUFXYDWUEXYDVXTWUDXXCWWTVYTXXCVXTX
      XCCXXSUWFZYCUOVYTWXAXXCXWCUPWEWFZXYHWGYEZXXRWUNWWJWWIXXRWUMWWKXXRWUQWURWU
      MXXRWUFXXRWUEXUKXXCVYTWUSXUMXYDVXTWUDXXCWUTVYTXYGUOZVYTWVCXXCWVDUPZVHYEZX
      XRJWUEXWHXXRWSSXYLXXCXUKJWUEYFLZXXCXUKXVBXYMXYCXXCVYTXUTXVAXYMXXCVYTXUTXV
      AXYMXYDXVGXYMXYDWUDVXTYFLZXVGXYMXYDXUSWVHVXTYFLXVGXYNXYDWUBCVYTWVOXXCWVQU
      PXYEVYTWVTXXCWWAUPXXCVXMVYTCVUJZUOVUHXYFXYDWVHWUDVXTYFVYTWVKXXCWVLUPVIUWM
      XYDWUDVXTXYKXYJVUIWIXKVUFXTYAXNVUGZVNZVOZXYQWWGVQWWLVSXXRWUQWURWWMWWNXYRX
      YQXXRWWPWWMXXRWUFWUFXYQXYQXXRWUEXYLXYPVTZXYSWBXXRWWRWWPWWMXXRWWIWWOJKXYIW
      HXXRWUFWUGXYQXYRVMWIWJWXCWMWKXXRXXNWYRWWOXXRGVXPOVXTVYHOUGPZVAPZVBNZQPZWY
      RXUIXXMXCXXCXXMGXUIYUCUJZRXUKXXCXXMHGXUIXXKUJVUCPYUDXXCGXXKHYDVUKVULNZVUM
      VUNNZWXQXUIHWCUIXXCVUOSXXCWXRVXLWXSXXTXXSWYCVQZXXCVYHWXQIZMZVXTXXJXXCWWTY
      UHXXCCCVUPZWDZUOYUIXXEXXIYUIXXDWCIXXEWCIYUIVYHCYUIVYHXXCWXQHVYHYUGUWCYCXX
      CCWCIYUHYUJUOXXCXXBYUHCVUQZUOYPZXXDVURVSYUIXXDXXHYUMYUIXXGYUITXXFTWCIZYUI
      YQSYUIXXDYUMWDWEWFVUSVUTVUSYUFYUFVVAZVVBYUOXXCWXRVXLWXQYUEVVCNNXUIRXXTXXS
      WXPCVVDVQVVEGCVVFWKZUOGFVVGZYUCWYRRXXRYUQYUBWUFOQYUQYUAWUEVBYUQXYTWUDVXTV
      AVYHVXPOUGYHYMXAYMUPXXCXUKYLWYRXCIXXROWUFQYTSYRXXRWUFXUKXXCVYTWWSXUMXYHYE
      UWGWKVVHVVIUWQXXCFWXPCXXLXXTXXSXXCJCCULPZKLZWXPCKLZXXCCCXXSXXSXYOXYOWBXXC
      JCWXPVAPZKLYUSYUTXXCYVAYURJKXXCCCYUJYUJWGWHXXCCWXPXXSXXTVMWIWJZXXCXXMYUDX
      UIWCVVJPZYUPXXCGOYUBQYUFXUIYUOQYUFYUFVVKPYUFVVLPIXXCYUFYUOVVMSOWCIZXUIWCU
      IZWCWCUIZUTGXUIOUJYVCIXXCYVDYVEYVFVWLXUIHWCXUNVUOVVNWCVVOVVPGOXUIWCVVQVVR
      XXCGXUIYUBUJZGWXQYUBUJZXUIVVSZYVCXUIWXQUIZYVIYVGRWXPCVVTZGWXQXUIYUBVWCWRY
      VJXXCYVHWXQWCVVJPIZYVIYVCIYVKXXCVXLVXMYVLXXSXYOGCVWAVQWXQWCXUIYVHVWBVWDVW
      EVWFUQXXCXXMYUDUKYUPXXCVXLVXMYUDUKIXXSXYOVXNGXUIWXQYUCXCYVJVXNYVKSXUIWULI
      VXNWXPCVWGSYUCXCIVXNYUHMOYUBQYTSGCUWJVWMVQUQGCVWHVWIXXCXXQVXTUFOYNPZQPZVX
      TYVMVCZQPZVAPZVYAXXCXXOYVNXXPYVPVAXXCXXOVXTCCYNPZYONZYVRTYVROUGPZVAPZVBNZ
      QPZULPZQPZYVNXXCGCXXKYWEWXQXXLXCXXCXXLVWNZVYHCRZXXKYWERXXCYWGXXJYWDVXTQYW
      GXXEYVSXXIYWCULYWGXXDYVRYOVYHCCYNYHZXAYWGXXDYVRXXHYWBQYWHYWGXXGYWAVBYWGXX
      FYVTTVAYWGXXDYVROUGYWHYSYMXAYJYJYMUPXXCXVDXVEYUTCWXQIXYAXYBYVBWXPCVWJWMYW
      EXCIXXCVXTYWDQYTSYRXXCYWDYVMVXTQXXCYWDYVMJULPYVMXXCYVSYVMYWCJULXXCYVSTYON
      ZYVMXXCYVRTYOXXCCYUJYULVWKZXAVWOXRXXCYWCYVRJQPJXXCYWBJYVRQXXCYWBXWAJXXCYW
      AJVBXXCYWATTVAPZJXXCYVTTTVAXXCYVTTOUGPZTXXCYVRTOUGYWJYSVWPXRYMXXCTYUNXXCY
      QSUXJZWKXAYKXRYMXXCYVRXXCCCYUJYUJYULYPVWQWKYJXXCYVMYVMWCIXXCUFOXXAVWLVWRV
      WSZSZVWTWKYMWKXXCXXPVXTWXPCYNPZYONZYWPTYWPOUGPZVAPZVBNZQPZULPZQPZYVPXXCGW
      XPXXKYXCWXQXXLXCYWFXXCVYHWXPRZMXXJYXBVXTQYXDXXJYXBRXXCYXDXXEYWQXXIYXAULYX
      DXXDYWPYOVYHWXPCYNYHZXAYXDXXDYWPXXHYWTQYXEYXDXXGYWSVBYXDXXFYWRTVAYXDXXDYW
      POUGYXEYSYMXAYJYJUPYMXXCXVDXVEYUTWXPWXQIXYAXYBYVBWXPCVXAWMYXCXCIXXCVXTYXB
      QYTSYRXXCYXBYVOVXTQXXCYXBYVOJULPYVOXXCYWQYVOYXAJULXXCYWQTVCZYONZYVOXXCYWP
      YXFYOXXCYVRVCYWPYXFXXCCCYUJYUJYULVXBXXCYVRTYWJYIUXIZXAYXGYWIVCZYVOYUNYXGY
      XIRYQTVXDWRYWIYVMVWOUXKUNXRXXCYXAYWPJQPJXXCYWTJYWPQXXCYWTXWAJXXCYWSJVBXXC
      YWSYWKJXXCYWRTTVAXXCYWRYXFOUGPZTXXCYWPYXFOUGYXHYSYXJYWLTYUNYXJYWLRYQTVXCW
      RVWPUNXRYMYWMWKXAYKXRYMXXCYWPXXCWXPCXXCWXPXXTYCYUJYULYPVWQWKYJXXCYVOYVOWC
      IXXCYVMYWNVXESZVWTWKYMWKYJXXCVXTYVMYVOVAPZQPVXTUFQPYVQVYAXXCYXLUFVXTQYXLU
      FRXXCYXLYVMYVMULPZUFYVMYVMYWNYWNVXFUFWCIZYXMUFRXXAUFVXGWRUNSYMXXCVXTYVMYV
      OYUKYWOYXKVXHXXCVXTUFYUKYXNXXCXXASVXIVXJWKUWIVSVXKVXJWK $.

  $}

$( (End of Brendan Leahy's mathbox.) $)

$( As of 10-Dec-2017, FL's mathbox has been removed per FL's request.  We
   will keep it in commented-out form temporarily, so that any desired
   theorems can be exported and any label changes can be kept up to date.
   Note that "@" was changed to "%", followed by changing "$" to "@".
   Reverse these changes to recover the original.  If you export a theorem
   to the main set.mm or to your mathbox, please delete it from this
   commented-out section to keep it up to date. -NM

@(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Fr&eacute;d&eacute;ric Lin&eacute;
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  In the sequel "JFM" is the "Journal of Formalized Mathematics".
  http://mizar.uwb.edu.pl/JFM/mmlident.html

  "CAT_1" means  Bylinski Czeslaw, Introduction to Categories and Functors,
  Journal of Formalized Mathematics, 1990, volume 1, no 2, pages 409--420

  "CAT_2" means Bylinski Czeslaw, Subcategories and Products of Categories,
  Journal of Formalized Mathematics, 1990, volume 1, no 4, pages 725--732

  "CLASSES1" means Grzegorz Bancerek, Tarski's Classes and Ranks,
   Journal of Formalized Mathematics, 1990, volume 1, no 3, pages 563--567

  "CLASSES2" means Bogdan Nowak and Grzegorz Bancerek, Universal Classes,
   Journal of Formalized Mathematics, may-august 1990, volume 1,
   nb 3, pages 595--600

  "Bourbaki" means Bourbaki's treatise. The book
   General Topology is called TG (for Topologie G&eacute;n&eacute;rale).
   The book Set Theory is called E (for th&eacute;orie des Ensembles).

   The treatise is translated in English.

   More precisely, here are two examples of references:

   "Bourbaki E II.32" means Set Theory, chapter II, 32nd page,
   "Bourbaki TG III.1" means General Topology, chapter III, 1st page.

   The references are given according to the French edition.

  "Viro" means O. Ya. Viro, O. A. Ivanov, N. Yu. Netsvetaev, V. M. Kharlamov,
  Elementary topology. Available on the net.

  "Goldblatt" means Robert Goldblatt, Topoi, the categorial analysis
  of logic, revised edition, Dover publications, Mineola, New-York, 2006

  "Gallier" means Jean H. Gallier, "Logic For Computer Science --
  Foundations of Automatic Theorem Proving". A new edition must be published
  in 2014 at Dover.

  "Harju" means Tero Harju, "Lecture Notes on SemiGroups", unpublished, 1996.
  Available on the net.

  In  the  following notices  "experimental"  means  I  have not  yet
  sufficiently used a definition to be sure it is correct. Anyway I'm
  not the owner of  the definition and you can use it  as you wish if
  you think it  is correct or replace it by a  definition of your own
  if you think it is not.
@)

@( The following comment is to assist editor searches @)
@( Mathbox for Frederic Line @)
@( Mathbox for FL @)

  @v A1 @.
  @v A2 @.
  @v B1 @.
  @v B2 @.
  @v C1 @.
  @v C2 @.
  @v D1 @.
  @v D2 @.
  @v F1 @.
  @v F2 @.
  @v F3 @.
  @v G1 @.
  @v G2 @.
  @v H1 @.
  @v H2 @.
  @v I1 @.
  @v I2 @.
  @v L1 @.
  @v L2 @.
  @v L3 @.
  @v M1 @.
  @v M2 @.
  @v O1 @.
  @v O2 @.
  @v Ro1 @.
  @v Ro2 @.
  @v S1 @.
  @v S2 @.
  @v V1 @.
  @v V2 @.
  @v V3 @.
  @v W2 @.


  @( Let ` A1 ` be a class variable. @)
  cA1 @f class A1 @.
  @( Let ` A2 ` be a class variable. @)
  cA2 @f class A2 @.

  @( Let ` B1 ` be a class variable. @)
  cB1 @f class B1 @.
  @( Let ` B2 ` be a class variable. @)
  cB2 @f class B2 @.

  @( Let ` O1 ` be a class variable. @)
  cO1 @f class O1 @.
  @( Let ` M1 ` be a class variable. @)
  cm1 @f class M1 @.

  @( Let ` O2 ` be a class variable. @)
  co2 @f class O2 @.
  @( Let ` M2 ` be a class variable. @)
  cm2 @f class M2 @.

  @( Let ` I1 ` be a class variable. @)
  ci1 @f class I1 @.
  @( Let ` D1 ` be a class variable. @)
  cd1 @f class D1 @.
  @( Let ` C1 ` be a class variable. @)
  cc1 @f class C1 @.
  @( Let ` Ro1 ` be a class variable. @)
  cro1 @f class Ro1 @.

  @( Let ` I2 ` be a class variable. @)
  ci2 @f class I2 @.
  @( Let ` D2 ` be a class variable. @)
  cd2 @f class D2 @.
  @( Let ` C2 ` be a class variable. @)
  cc2 @f class C2 @.
  @( Let ` Ro2 ` be a class variable. @)
  cro2 @f class Ro2 @.

  @( Let ` F1 ` be a class variable. @)
  cF1 @f class F1 @.
  @( Let ` F2 ` be a class variable. @)
  cF2 @f class F2 @.
  @( Let ` F3 ` be a class variable. @)
  cF3 @f class F3 @.


  @( Let ` G1 ` be a class variable. @)
  cG1 @f class G1 @.
  @( Let ` G2 ` be a class variable. @)
  cG2 @f class G2 @.

  @( Let ` H1 ` be a class variable. @)
  cH1 @f class H1 @.
  @( Let ` H2 ` be a class variable. @)
  cH2 @f class H2 @.

  @( Let ` L1 ` be a class variable. @)
  cL1 @f class L1 @.
  @( Let ` L2 ` be a class variable. @)
  cL2 @f class L2 @.
  @( Let ` L3 ` be a class variable. @)
  cL3 @f class L3 @.


  @( Let ` S1 ` be a class variable. @)
  cS1 @f class S1 @.
  @( Let ` S2 ` be a class variable. @)
  cS2 @f class S2 @.

  @( Let ` V1 ` be a class variable. @)
  cV1 @f class V1 @.
  @( Let ` V2 ` be a class variable. @)
  cV2 @f class V2 @.
  @( Let ` V3 ` be a class variable. @)
  cV3 @f class V3 @.
  cW2 @f class W2 @.

  @v +t @.
  @v -t @.
  @v .t @.
  @v /t @.
  @v ~t @.
  @v 0t @.
  @v 1t @.
  @v +w @.
  @v -w @.
  @v .w @.
  @v 0w @.
  @v ~w @.
  @v <_a @.
  @v <_b @.

  @( Let ` +t ` be a class variable.  I suggest to use variables consisting
     in the symbols ` + ` , ` . ` , etc. and in letters to name the various
     occurences of the highly overloaded addition, multiplication, etc.
     symbols.  For instance ` +w ` and ` .w ` to denote the addition of
     vectors and the multiplication of a vector by a scalar and ` .t ` to
     denote scalar multiplication.  (I would prefer to use ` +v ` or ` .s `
     but they are already in use.)  Since ` +w ` etc. are variables, they can
     be used in several contexts.  @)
  cpls @f class +t @.

  @( Let ` -t ` be a class variable. @)
  cmnu @f class -t @.

  @( Let ` .t ` be a class variable. @)
  cmus @f class .t @.

  @( Let ` /t ` be a class variable. @)
  cdis @f class /t @.

  @( Let ` ~t ` be a class variable. @)
  cnes @f class ~t @.

  @( Let ` 0t ` be a class variable. @)
  czert @f class 0t @.

  @( Let ` 1t ` be a class variable. @)
  conet @f class 1t @.

  @( Let ` +w ` be a class variable. @)
  cplw @f class +w @.

  @( Let ` -w ` be a class variable. @)
  cminw @f class -w @.

  @( Let ` .w ` be a class variable. @)
  cmw @f class .w @.

  @( Let ` 0w ` be a class variable. @)
  czerw @f class 0w @.

  @( Let ` ~w ` be a class variable. @)
  cnegw @f class ~w @.

  @( Let ` <_a ` be a class variable. @)
  cleqa @f class <_a @.

  @( Let ` <_b ` be a class variable. @)
  cleqb @f class <_b @.


  @v o' @.
  @v s' @.
  @v v' @.
  @v o" @.
  @v s" @.
  @v v" @.
  @v a0 @.
  @v b0 @.
  @v o0 @.
  @v a1 @.
  @v b1 @.
  @v o1 @.
  @v v2 @.
  bnjvom @f set o' @.
  bnjvsm @f set s' @.
  bnjvvm @f set v' @.
  bnjvon @f set o" @.
  bnjvsn @f set s" @.
  bnjvvn @f set v" @.
  bnjva0 @f set a0 @.
  bnjvb0 @f set b0 @.
  bnjvo0 @f set o0 @.
  bnjva1 @f set a1 @.
  bnjvb1 @f set b1 @.
  bnjvo1 @f set o1 @.
  bnjvv2 @f set v2 @.


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Theorems from other workspaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)


  @{
    @d a b c A @.  @d a b c D @.  @d a b c E @.  @d a b c F @.  @d a b c G @.
    @d b c B @.  @d c C @.
    tpssg.1 @e |- ( ph -> A e. E ) @.
    tpssg.2 @e |- ( ph -> B e. F ) @.
    tpssg.3 @e |- ( ph -> C e. G ) @.
    @( A triplet of elements of a class is a subset of the class.  (Contributed
       by NM, 9-Apr-1994.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.)
       (Revised by FL, 17-May-2016.) @)
    tpssg @p |- ( ph -> ( ( A e. D /\ B e. D /\ C e. D ) <->
       { A , B , C } C_ D ) ) @=
      ( va vb vc wcel w3a ctp wss wb cv wceq eleq1 3anbi1d tpeq1 sseq1d bibi12d
      3anbi2d tpeq2 3anbi3d tpeq3 vex tpss a1i vtocl3ga syl3anc ) ABFOCGODHOBEO
      ZCEOZDEOZPZBCDQZERZSZIJKLTZEOZMTZEOZNTZEOZPZVCVEVGQZERZSZUPVFVHPZBVEVGQZE
      RZSUPUQVHPZBCVGQZERZSVBLMNBCDFGHVCBUAZVIVMVKVOVSVDUPVFVHVCBEUBUCVSVJVNEVC
      BVEVGUDUEUFVECUAZVMVPVOVRVTVFUQUPVHVECEUBUGVTVNVQEVECBVGUHUEUFVGDUAZVPUSV
      RVAWAVHURUPUQVGDEUBUIWAVQUTEVGDBCUJUEUFVLVCFOVEGOVGHOPVCVEVGELUKMUKNUKULU
      MUNUO @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Propositional and predicate calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)


  @( Theorem 19.26 of [Margaris] p. 90 with 3 restricted quantifiers.
     (Contributed by FL, 20-May-2016.) @)
  r19.26-2a @p |- ( A. x e. A A. y e. B A. z e. C ( ph /\ ps ) <->
               ( A. x e. A A. y e. B A. z e. C ph /\
                  A. x e. A A. y e. B A. z e. C ps ) ) @=
    ( wa wral r19.26 2ralbii r19.26-2 bitri ) ABIEHJZDGJCFJAEHJZBEHJZIZDGJCFJPD
    GJCFJQDGJCFJIORCDFGABEHKLPQCDFGMN @.


  @{
    @d x A @.  @d x B @.  @d x ph @.
    reubidvag.1 @e |- ( ph -> ( ps <-> ch ) ) @.
    reubidvag.2 @e |- ( ph -> A = B ) @.
    @( Formula-building rule for restricted existential quantifier (deduction
       rule).  (Contributed by FL, 17-Nov-2014.) @)
    reubidvag @p |- ( ph -> ( E! x e. A ps <-> E! x e. B ch ) ) @=
      ( wreu wceq wb reueq1 syl reubidv bitrd ) ABDEIZBDFIZCDFIAEFJPQKHBDEFLMAB
      CDFGNO @.
  @}


  @{
    intn3and.1OLD @e |- ( ph -> -. ps ) @.
    @( Introduction of a triple conjunct inside a contradiction.  (Contributed
       by FL, 27-Dec-2007.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) @)
    intn3an1dOLD @p |- ( ph -> -. ( ps /\ ch /\ th ) ) @=
      ( w3a simp1 nsyl ) ABBCDFEBCDGH @.

    @( Introduction of a triple conjunct inside a contradiction.  (Contributed
       by FL, 27-Dec-2007.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) @)
    intn3an2dOLD @p |- ( ph -> -. ( ch /\ ps /\ th ) ) @=
      ( w3a simp2 nsyl ) ABCBDFECBDGH @.

    @( Introduction of a triple conjunct inside a contradiction.  (Contributed
       by FL, 27-Dec-2007.)  (Proof shortened by Andrew Salmon,
       26-Jun-2011.) @)
    intn3an3dOLD @p |- ( ph -> -. ( ch /\ th /\ ps ) ) @=
      ( w3a simp3 nsyl ) ABCDBFECDBGH @.
  @}

  @( A consequence of ` /\ ` associativity in a triple conjunct.  (Contributed
     by FL, 14-Jul-2007.) @)
  and4as @p |- ( ( ph /\ ps /\ ( ch /\ th ) ) <->
    ( ( ph /\ ps /\ ch ) /\ th ) ) @=
    ( wa w3a wi pm3.2 3exp imp4a 3imp id exp4a 3imp1 impbii ) ABCDEZFZABCFZDEZA
    BPSABCDSABCDSGRDHIJKABCDQABCDQABPQQLIMNO @.

  @( A consequence of ` /\ ` associativity in a triple conjunct.  (Contributed
     by FL, 14-Jul-2007.)  (Proof shortened by Andrew Salmon, 25-May-2011.) @)
  and4com @p |- ( ( ph /\ ( ps /\ ch /\ th ) ) <->
    ( ( ph /\ ps /\ ch ) /\ th ) ) @=
    ( w3a wa 3anass anbi2i and4as 3bitr2i ) ABCDEZFABCDFZFZFABLEABCEDFKMABCDGHA
    BLGABCDIJ @.

  @{
    @( Conjunction of triple disjunctions.  (Contributed by FL, 5-Jan-2009.)
       (Proof shortened by Andrew Salmon, 25-May-2011.) @)
    anddi2 @p |- ( ( ( ph \/ ps \/ ch ) /\ ( th \/ ta \/ et ) ) <->
              ( ( ( ph /\ th ) \/ ( ph /\ ta ) \/ ( ph /\ et ) ) \/
              ( ( ps /\ th ) \/ ( ps /\ ta ) \/ ( ps /\ et ) ) \/
              ( ( ch /\ th ) \/ ( ch /\ ta ) \/ ( ch /\ et ) ) ) ) @=
      ( w3o wa wo df-3or anbi12i andir orbi1i orbi12i 3orbi123i 3bitr4ri 3bitri
      andi ) ABCGZDEFGZHABIZCIZDEIZFIZHUAUDHZCUDHZIZADHZAEHZAFHZGZBDHZBEHZBFHZG
      ZCDHZCEHZCFHZGZGZSUBTUDABCJDEFJKUACUDLUGAUDHZBUDHZIZUFIAUCHZUJIZBUCHZUNIZ
      IZCUCHZURIZIZUTUEVCUFABUDLMVCVHUFVJVAVEVBVGAUCFRBUCFRNCUCFRNUHUIIZUJIZULU
      MIZUNIZUPUQIZURIZGVMVOIZVQIUTVKVMVOVQJUKVMUOVOUSVQUHUIUJJULUMUNJUPUQURJOV
      HVRVJVQVEVMVGVOVDVLUJADERMVFVNUNBDERMNVIVPURCDERMNPQQ @.
  @}

  @{
    condis.1 @e |- ( ph -> ps ) @.
    condis.2 @e |- ( -. ph -> ch ) @.
    @( Proof by contradiction combined with a disjunction.  (Contributed by FL,
       20-Apr-2011.) @)
    condis @p |- ( ps \/ ch ) @=
      ( wn wo exmid orim12i ax-mp ) AAFZGBCGAHABKCDEIJ @.
  @}

  @{
    condisd.1 @e |- ( ( ph /\ ps ) -> ch ) @.
    condisd.2 @e |- ( ( ph /\ -. ps ) -> th ) @.
    @( Proof by contradiction combined with a disjunction.  (Contributed by FL,
       20-Apr-2011.) @)
    condisd @p |- ( ph -> ( ch \/ th ) ) @=
      ( wn wo exmid wa andi orim12i sylbi mpan2 ) ABBGZHZCDHZBIAPJABJZAOJZHQABO
      KRCSDEFLMN @.
  @}

  @{
    @d ch w x z @.  @d ph x y @.  @d ph x z @.  @d ps w y @.  @d ps w z @.
    @d th w x y @.
    @( Rearrange existential quantifiers.  (Contributed by FL, 14-Jul-2007.) @)
    eeeeanv @p |- ( E. w E. x E. y E. z ( ( ph /\ ps /\ ch ) /\ th ) <->
                 ( ( E. w ph /\ E. x ps /\ E. y ch ) /\ E. z th ) ) @=
      ( w3a wex 19.41vvv eeeanv anbi2ci bitri exbii 19.41v ancom and4com 3exbii
      wa 3bitr3i ) BCDIZATZGJFJEJZHJZAHJZBEJZCFJZDGJZIZTZABCIDTZGJFJEJZHJUFUGUH
      IUITUEAUJTZHJUKUDUNHUDUBGJFJEJZATUNUBAEFGKUOUJABCDEFGLMNOAUJHPNUDUMHUCULE
      FGUCAUBTULUBAQABCDRNSOUFUGUHUIRUA @.
  @}

  @( Negation of a complex predicate calculus formula.  (Contributed by FL,
     31-Jul-2009.) @)
  negcmpprcal1OLD @p |- ( -. E. x e. A A. y e. B ( ph -> ps )
     <-> A. x e. A E. y e. B ( ph /\ -. ps ) ) @=
    ( wn wa wrex wral wi rexanali ralbii ralnex bitr2i ) ABGHDFIZCEJABKDFJZGZCE
    JQCEIGPRCEABDFLMQCENO @.

  @( Negation of a complex predicated inequality.  (Contributed by FL,
     31-Jul-2009.) @)
  negcmpprcal2 @p |- ( -. E. x e. A A. y e. B C =/= D
    <-> A. x e. A E. y e. B C = D ) @=
    ( wne wral wn wrex wceq rexnal bicomi ralbii ralnex nne rexbii 3bitr3i ) EF
    GZBDHZIZACHSIZBDJZACHTACJIEFKZBDJZACHUAUCACUCUASBDLMNTACOUCUEACUBUDBDEFPQNR
    @.

  @{
    eqriv2.1 @e |- F/_ x A @.
    eqriv2.2 @e |- F/_ x B @.
    eqriv2.3 @e |- ( x e. A <-> x e. B ) @.
    @( Infer equality of classes from equivalence of membership.  (Contributed
       by FL, 22-Nov-2010.)  (Revised by Mario Carneiro, 11-Dec-2016.) @)
    eqriv2 @p |- A = B @=
      ( wceq cv wcel wb cleqf mpgbir ) BCGAHZBIMCIJAABCDEKFL @.
  @}

  @( Alternate definition of true.  In fact any tautology is a definition of
     true.  (Contributed by FL, 23-Mar-2011.) @)
  altdftru @p |- ( T. <-> ( ph \/ -. ph ) ) @=
    ( wtru wb wn wo df-tru exmid a1i biidd impbii bitri ) BAACZAADEZAFLMMLAGHMA
    IJK @.

  @( A true antecedent can be removed.  (Contributed by FL, 16-Apr-2012.) @)
  trant @p |- ( ( T. -> ph ) <-> ph ) @=
    ( wtru wi wb pm5.5 trud ) BACADBAEF @.

  @( Vacuous universal quantification is true.  (Contributed by FL,
     16-Apr-2012.) @)
  vutr @p |- ( T. <-> A. x e. (/) ph ) @=
    ( wtru c0 wral tru ral0 2th ) CABDEFABGH @.

  @( True is not false.  (Contributed by FL, 20-Mar-2011.) @)
  tnf @p |- ( T. <-> -. F. ) @=
    ( wfal wtru df-fal con2bii ) ABCD @.

  @( False can be removed from a disjunction.  (Contributed by FL,
     20-Mar-2011.) @)
  facrm @p |- ( ( F. \/ ph ) <-> ph ) @=
    ( wfal wo falim id jaoi olc impbii ) BACABAAADAEFABGH @.

  @{
    @( If ` ( ph \/ ps ) ` is true for all ` x ` and ` ps ` is not true for all
       ` x ` then ` ph ` is true for some ` x ` .  (Contributed by FL,
       20-Apr-2011.) @)
    fordisxex @p |- ( ( A. x e. A ( ph \/ ps ) /\ -. A. x e. A ps )
        -> E. x e. A ph ) @=
      ( wral wn wo wrex rexnal wa r19.29 pm5.61 simplbi reximi syl sylan2br ) B
      CDEFABGZCDEZBFZCDHZACDHZBCDIRTJQSJZCDHUAQSCDKUBACDUBASABLMNOP @.
  @}

  @{
    @d A x @.
    fates.1 @e |- A e. B @.
    @( Equivalence of ` A. ` and ` E. ` in the case of quantifiers restricted
       to a singleton.  (Contributed by FL, 1-Jun-2011.) @)
    fates @p |- ( A. x e. { A } ph <-> E. x e. { A } ph ) @=
      ( cv csn wcel wi wal wex wral wrex wceq elexi alexeq elsn imbi1i 3bitr4i
      wa albii anbi1i exbii df-ral df-rex ) BFZCGZHZAIZBJZUHATZBKZABUGLABUGMUFC
      NZAIZBJUMATZBKUJULABCCDEOPUIUNBUHUMABCQZRUAUKUOBUHUMAUPUBUCSABUGUDABUGUES
      @.
  @}

  @{
    @d A a x @.  @d a ph @.
    @( Equivalence of ` A. ` and ` E. ` in the case of quantifiers restricted
       to a singleton.  (Contributed by FL, 1-Jun-2011.) @)
    fatesg @p |- ( A e. V -> ( A. x e. { A } ph <-> E. x e. { A } ph ) ) @=
      ( va cv csn wral wrex wceq sneq raleqdv rexeqdv cvv vex fates vtoclbg ) A
      BEFZGZHABSIABCGZHABTIECDRCJZABSTRCKZLUAABSTUBMABRNEOPQ @.
  @}

  @{
    @d A x @.  @d ps x @.
    r19.2zr.1 @e |- ( ph -> ps ) @.
    @( Quantifying a hypothesis with a universal restricted quantifier.
       (Contributed by FL, 19-Sep-2011.) @)
    r19.2zr @p |- ( ( A =/= (/) /\ A. x e. A ph ) -> ps ) @=
      ( c0 wne wral wa wrex r19.2z rexlimivw syl ) DFGACDHIACDJBACDKABCDELM @.
  @}

  @{
    @d A x @.  @d ph x @.
    @( Removing a universal restricted quantifier when the variable doesn't
       occur in the proposition.  (Contributed by FL, 19-Sep-2011.) @)
    r19.2zrr @p |- ( ( A =/= (/) /\ A. x e. A ph ) -> ph ) @=
      ( id r19.2zr ) AABCADE @.
  @}

  @{
    @d A x @.
    rexlimib.1 @e |- F/ x ps @.
    rexlimib.2 @e |- ( x e. A -> ( ph -> ps ) ) @.
    @( Removal of a universal restricted quantifier in an antecedent.  See also
       ~ reximdva0 .  (Contributed by FL, 19-Apr-2012.)  (Revised by Mario
       Carneiro, 11-Dec-2016.) @)
    rexlimib @p |- ( ( A =/= (/) /\ A. x e. A ph ) -> ps ) @=
      ( c0 wne wral wa wrex r19.2z rexlimi syl ) DGHACDIJACDKBACDLABCDEFMN @.
  @}

  @{
    @d A x @.  @d ps x @.
    eqint.1 @e |- ( x = A -> ( ph <-> ps ) ) @.
    eqint.2 @e |- ps @.
    eqint.3 @e |- ( ph -> A C_ x ) @.
    @( To prove that a set ` A ` is the finest one that has the property
       ` ph ` , prove that ` A ` is a part of all sets that has this property
       and that ` A ` has also that property.  (Contributed by FL,
       21-Apr-2012.) @)
    eqint @p |- ( A e. V -> A = |^| { x | ph } ) @=
      ( wcel cab cint wss cv wi ssintab mpgbir a1i intmin3 eqssd ) DEIZDACJKZDU
      ALZTUBADCMLNCACDOHPQABCDEFGRS @.
  @}

  @{
    @d A x @.  @d ch x @.  @d ph x @.
    eqintg.1 @e |- ( x = A -> ( ch <-> ps ) ) @.
    eqintg.2 @e |- ( ph -> ch ) @.
    eqintg.3 @e |- ( ( ph /\ ps ) -> A C_ x ) @.
    @( To prove that a set ` A ` is the finest one that has the property ` ph `
       prove that ` A ` is a part of all sets that has this property and that
       ` A ` has also that property.  (Contributed by FL, 15-Oct-2012.) @)
    eqintg @p |- ( ( ph /\ A e. V ) -> A = |^| { x | ps } ) @=
      ( wcel wa cab cint cv wss wi wal ex adantr wb alrimiv ssintab sylibr wceq
      simpr bicomd ax-gen elabgt sylancl mpbird intss1 syl eqssd ) AEFJZKZEBDLZ
      MZUOBEDNZOZPZDQZEUQOAVAUNAUTDABUSIRUASBDEUBUCUOEUPJZUQEOUOVBCACUNHSUOUNUR
      EUDZBCTPZDQVBCTAUNUEVDDVCCBGUFUGBCDEFUHUIUJEUPUKULUM @.
  @}

  @{
    @d A x @.
    @( Two ways to express substitution of ` A ` for ` x ` in ` ph ` .
       (Contributed by FL, 4-Jun-2012.) @)
    alexeqd @p |- ( A e. V
      -> ( A. x ( x = A -> ph ) <-> E. x ( x = A /\ ph ) ) ) @=
      ( wcel cvv cv wceq wi wal wa wex wb elex cif eqeq2 imbi1d albidv anbi1d
      c0 exbidv bibi12d 0ex elimel alexeq dedth syl ) CDECFEZBGZCHZAIZBJZUJAKZB
      LZMZCDNUHUOUIUHCTOZHZAIZBJZUQAKZBLZMCTCUPHZULUSUNVAVBUKURBVBUJUQACUPUIPZQ
      RVBUMUTBVBUJUQAVCSUAUBABUPCTFUCUDUEUFUG @.
  @}

  @{
    @d A x y @.  @d B y @.  @d C x @.  @d D x y @.  @d ch y @.  @d ph x y @.
    @d th x @.
    rspc2edv.1 @e |- ( x = A -> ( ps <-> th ) ) @.
    rspc2edv.2 @e |- ( y = B -> ( th <-> ch ) ) @.
    @( 2-variable restricted existential specialization, using implicit
       substitution.  ( ~ rspc2ev with an antecedent.)  (Contributed by FL,
       2-Jul-2012.) @)
    rspc2edv @p |- ( ( ph /\ A e. C /\ B e. D )
        -> ( ch -> E. x e. C E. y e. D ps ) ) @=
      ( wcel wrex wi wa cv wceq anbi2d reximi w3a rspc2ev simpr syl exp4b com3r
      3expia 3imp ) AGIMZHJMZCBFJNZEINZOZUIUJAUMUIUJACULUIUJACPZULUIUJUNUAABPZF
      JNZEINULUOUNADPEFGHIJEQGRBDAKSFQHRDCALSUBUPUKEIUOBFJABUCTTUDUGUEUFUH @.
  @}

  @{
    pm11.53g.1 @e |- F/ y ph @.
    pm11.53g.2 @e |- F/ x ps @.
    @( Theorem *11.53 in [WhiteheadRussell] p. 164.  (Contributed by FL,
       27-Oct-2013.) @)
    pm11.53g @p |- ( A. x A. y ( ph -> ps ) <-> ( E. x ph -> A. y ps ) ) @=
      ( wi wal wex 19.21 albii nfal 19.23 bitri ) ABGDHZCHABDHZGZCHACIPGOQCABDE
      JKAPCBCDFLMN @.
  @}

  @{
    @d x y z A @.  @d x y z B @.  @d x y z C @.  @d x y z D @.
    eqvinopb.1 @e |- B e. _V @.
    eqvinopb.2 @e |- C e. _V @.
    eqvinopb.3 @e |- D e. _V @.
    @( A variable introduction law for ordered triples.  See ~ eqvinop .
       (Contributed by FL, 6-Nov-2013.) @)
    eqvinopb @p |- ( A = <. <. B , C >. , D >. <-> E. x E. y E. z
      ( A = <. <. x , y >. , z >. /\
                  <. <. x , y >. , z >. = <. <. B , C >. , D >. ) ) @=
      ( cv cop wceq wa wex vex anbi2i 3bitri exbii eqeq2d w3a otth2 ancom anass
      df-3an anbi1i bicomi bitri 19.42v 3anan12 anbi2d ceqsexv opeq1d bitr2i
      opeq2 opeq1 ) DAKZBKZLZCKZLZMZVAEFLZGLZMZNZCOZBOZAOUQEMZDUQFLZGLZMZNZAODV
      DMZVHVMAVHVIURFMZDUSGLZMZNZNZBOVIVRBOZNVMVGVSBVGVIVOUTGMZVBUAZNZCOVIWBCOZ
      NVSVFWCCVFVBVIVOWAUAZNWEVBNZWCVEWEVBUQUREFUTGAPBPCPUBQVBWEUCWFVIVONWANZVB
      NVIVOWANZNZVBNZWCWEWGVBVIVOWAUEUFWGWIVBVIVOWAUDUFWJVIWHVBNZNWCVIWHVBUDWKW
      BVIWBWKVOWAVBUEUGQUHRRSVIWBCUIWDVRVIWDWAVOVBNZNZCOVRWBWMCVOWAVBUJSWLVRCGJ
      WAVBVQVOWAVAVPDUTGUSUOTUKULUHQRSVIVRBUIVTVLVIVQVLBFIVOVPVKDVOUSVJGURFUQUO
      UMTULQRSVLVNAEHVIVKVDDVIVJVCGUQEFUPUMTULUN @.
  @}

  @{
    @d ph w v u @.  @d x y z w v u A @.
    @( Substitution of class ` A ` for ordered triple
       ` <. <. x , y >. , z >. ` .  See ~ copsexg .  (Contributed by FL,
       10-Nov-2013.)  (Proof shortened by Mario Carneiro, 11-Dec-2016.) @)
    copsexgb @p |- ( A = <. <. x , y >. , z >. ->
                  ( ph <-> E. x E. y E. z
                    ( A = <. <. x , y >. , z >. /\ ph ) ) ) @=
      ( vu vv vw cv cop wceq wa wex 19.8a wi vex bitri syl6bb exbidv weu ex w3a
      3syl eqvinopb eqeq1 eqcom otth2 df-3an anbi1d 19.42v adantr simpr1 euequ1
      wb anass eupick mpan syl5com simpr2 simpr3 3syld sylan2b exlimiv exlimivv
      sylbid sylbi impbid ) EBIZCIZJDIZJZKZAVLALZDMZCMZBMZVLAVPVMVNVOVPVMDNVNCN
      VOBNUCUAVLEFIZGIZJHIZJZKZVTVKKZLZHMZGMFMVPAOZFGHEVHVIVJBPZCPZDPZUDWDWEFGW
      CWEHWCVPVHVQKZVIVRKZVJVSKZALZDMZLZCMZLZBMZAWAVPWQUNWBWAVOWPBWAVOWIWNLZCMW
      PWAVNWRCWAVNWIWJLZWLLZDMZWRWAVMWTDWAVMWSWKLZALWTWAVLXBAWAVLWBXBEVTVKUEWBW
      IWJWKUBZXBWBVKVTKXCVTVKUFVHVIVQVRVJVSWFWGWHUGQZWIWJWKUHQRUIWSWKAUORSXAWSW
      MLWRWSWLDUJWIWJWMUOQRSWIWNCUJRSUKWBWAXCWQAOXDWAXCLZWQWOWMAXEWIWQWOWAWIWJW
      KULWIBTWQWIWOOBFUMWIWOBUPUQURXEWJWOWMWAWIWJWKUSWJCTWOWJWMOCGUMWJWMCUPUQUR
      XEWKWMAWAWIWJWKUTWKDTWMWKAODHUMWKADUPUQURVAVBVEVCVDVFVG @.
  @}

  @{
    3netr3.1 @e |- A =/= B @.
    3netr3.2 @e |- A = C @.
    3netr3.3 @e |- B = D @.
    @( Inequality.  (Contributed by FL, 30-May-2014.) @)
    3netr3 @p |- C =/= D @=
      ( eqnetrri neeqtri ) CBDACBFEHGI @.
  @}

  @{
    @d x ph @.
    sbcbidv2.1 @e |- ( ph -> A = B ) @.
    sbcbidv2.2 @e |- ( ph -> ( ps <-> ch ) ) @.
    @( Formula-building deduction rule for class substitution with different
       classes.  (For my private use only.  Don't use.)  (Contributed by FL,
       16-Sep-2016.) @)
    sbcbidv2 @p |- ( ph -> ( [. A / x ]. ps <-> [. B / x ]. ch ) ) @=
      ( wsbc sbcbidv wceq wb dfsbcq syl bitrd ) ABDEICDEIZCDFIZABCDEHJAEFKPQLGC
      DEFMNO @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Linear temporal logic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

   Propositional Linear temporal logic (LTL) is a kind of modal logic.  It is
   composed of the axioms of classical logic plus the axioms ~ ax-ltl1 ,
   ~ ax-ltl2 , ~ ax-ltl3 , ax-ltl4 , ~ ax-lmp , and ~ ax-nmp .  In classical
   logic, propositions don't depend on the time.  In LTL the "world"
   evolves.  We will imagine the world as a sequence of states with a first
   state and future states.  Instead of state I will also use the term "step"
   to emphasize that LTL is used to formalize the evolution of process in a
   computer.  A proposition that is true in one state of the "world" may be
   false in the next one.  The proposition ` [.] ph ` means ` ph ` is true in
   every state of the world, in the first state as well as in the future
   states.  It is read " ` ph ` is always true " or " ` ph ` always holds ".
   The proposition ` () ph ` means ` ph ` is true in the next state of the
   world.  The proposition ` <> ph ` means that ` ph ` is true in one state
   of the world at least, but we don't know exactly which one.  It can be the
   first state, it can be a future state.  It is read " ` ph ` is eventually
   true " or " ` ph ` eventually holds".  When no operator is used in front
   of a proposition, it means that ` ph ` is unconditionnaly true or that it
   is true in the current state ( depending on the context). ` ph until ps `
   means ` ph ` is true in every state of the world until ` ps ` is true.

@)

  @c [.] @. @( A box. @)
  @c <> @. @( A diamond. @)
  @c () @. @( A circle. @)
  @c until @. @( Until. @)

  @( An always true proposition is well-formed. @)
  wbox @a wff [.] ph @.

  @( An eventually true proposition is well-formed. @)
  wdia @a wff <> ph @.

  @( A proposition true in the next step is well-formed. @)
  wcirc @a wff () ph @.

  @( The proposition " ` ph ` is true until ` ps ` is true " is well-formed. @)
  wunt @a wff ( ph until ps ) @.

  @( @j primitive 'wbox' 'wcirc' 'wunt'; @)

  @( If ` ( ph -> ps ) ` and ` ph ` always hold then ` ps ` always holds.
     (Contributed by FL, 22-Feb-2011.) @)
  ax-ltl1 @a |- ( [.] ( ph -> ps ) -> ( [.] ph -> [.] ps ) ) @.

  @( ` ph ` doesn't hold in the next step iff in the next step ` -. ph `
     holds.  (Contributed by FL, 20-Mar-2011.) @)
  ax-ltl2 @a |- ( -. () ph <-> () -. ph ) @.

  @( If, in the next step, ` ph -> ps ` and ` ph ` hold then, in the next step,
     ` ps ` holds.  (Contributed by FL, 20-Mar-2011.) @)
  ax-ltl3 @a |- ( () ( ph -> ps ) -> ( () ph -> () ps ) ) @.

  @( Suppose that it is always true that if ` ph ` is true in the current step
     then ` ph ` is true in the next step.  Suppose that ` ph ` is true in the
     first step.  Then ` ph ` is always true.  (Contributed by FL,
     20-Mar-2011.) @)
  ax-ltl4 @a |- ( ( [.] ( ph -> () ph ) /\ ph ) -> [.] ph ) @.

  @{
    ax-lmp.1 @e |- ph @.
    @( If ` ph ` is a theorem, then it always holds.  (Contributed by FL,
       22-Feb-2011.) @)
    ax-lmp @a |- [.] ph @.
  @}

  @{
    ax-nmp.1 @e |- ph @.
    @( If ` ph ` is a theoremm then it holds in the next step.  (Contributed by
       FL, 20-Mar-2011.) @)
    ax-nmp @a |- () ph @.
  @}

  @( ` ph ` eventually holds iff it is not true that ` -. ph ` always holds.
     (Contributed by FL, 22-Feb-2011.) @)
  df-dia @a |- ( <> ph <-> -. [.] -. ph ) @.

  @{
    impbox.1 @e |- ( ph -> ps ) @.
    @( If ` ph -> ps ` is unconditionally true and if ` ph ` is always true,
       then ` ps ` is always true.  (Contributed by FL, 22-Feb-2011.) @)
    impbox @p |- ( [.] ph -> [.] ps ) @=
      ( wi wbox ax-lmp ax-ltl1 ax-mp ) ABDZEAEBEDICFABGH @.
  @}

  @{
    bibox.1 @e |- ( ph <-> ps ) @.
    @( If ` ph <-> ps ` is unconditionally true, then ` ph ` is always true is
       equivalent to ` ps ` is always true.  (Contributed by FL,
       22-Feb-2011.) @)
    bibox @p |- ( [.] ph <-> [.] ps ) @=
      ( wbox biimpi impbox biimpri impbii ) ADBDABABCEFBAABCGFH @.

    @( @j congruence 'bibox'; @)
  @}

  @{
    impxt.1 @e |- ( ph -> ps ) @.
    @( If ` ph -> ps ` holds unconditionally and if ` ph ` holds in the next
       state, then ` ps ` holds in the next state.  (Contributed by FL,
       20-Mar-2011.) @)
    impxt @p |- ( () ph -> () ps ) @=
      ( wi wcirc ax-nmp ax-ltl3 ax-mp ) ABDZEAEBEDICFABGH @.
  @}

  @{
    binxt.1 @e |- ( ph <-> ps ) @.
    @( If ` ph <-> ps ` holds unconditionally, then ` ph ` holds in the next
       state of the world iff ` ps ` holds in the next state.  (Contributed by
       FL, 20-Mar-2011.) @)
    binxt @p |- ( () ph <-> () ps ) @=
      ( wcirc biimpi impxt biimpri impbii ) ADBDABABCEFBAABCGFH @.

    @( @j congruence 'binxt'; @)
  @}

  @( ` ( ph \/ ps ) ` holds in the next step iff ` ph ` holds in the next step
     or ` ps ` holds in the next step.  (Contributed by FL, 20-Mar-2011.)
     (Proof shortened by Andrew Salmon, 9-Jul-2011.) @)
  nxtor @p |- ( () ( ph \/ ps ) <-> ( () ph \/ () ps ) ) @=
    ( wo wcirc wn ax-ltl2 wi df-or binxt ax-ltl3 sylbi syl5bi orrd orc olc jaoi
    impxt impbii ) ABCZDZADZBDZCTUAUBUAEAEZDZTUBAFTUCBGZDUDUBGSUEABHIUCBJKLMUAT
    UBASABNQBSBAOQPR @.

  @( ` ( ph /\ ps ) ` holds in the next step iff ` ph ` holds in the next step
     and ` ps ` holds in the next step.  (Contributed by FL, 20-Mar-2011.)
     (Proof shortened by Andrew Salmon, 9-Jul-2011.) @)
  nxtand @p |- ( () ( ph /\ ps ) <-> ( () ph /\ () ps ) ) @=
    ( wa wcirc simpl impxt simpr jca wi pm3.2 ax-ltl3 syl imp impbii ) ABCZDZAD
    ZBDZCPQROAABEFOBABGFHQRPQBOIZDRPIASABJFBOKLMN @.

  @( ` ph ` holds now and will always hold in the future iff it is not true
     that ` -. ph ` holds now or sometimes in the future.  (Contributed by FL,
     22-Feb-2011.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) @)
  boxeq @p |- ( [.] ph <-> -. <> -. ph ) @=
    ( wn wdia wbox df-dia notnot bicomi bibox xchbinx con2bii ) ABZCZADZLKBZDMK
    ENAANAFGHIJ @.

  @{
    diaimi.1 @e |- ( ph -> ps ) @.
    @( If ` ph ` implies ` ps ` unconditionally, then if ` ph ` eventually
       holds so does ` ps ` .  (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    diaimi @p |- ( <> ph -> <> ps ) @=
      ( wn wbox wdia con3i impbox df-dia 3imtr4i ) ADZEZDBDZEZDAFBFNLMKABCGHGAI
      BIJ @.
  @}

  @{
    bidia.1 @e |- ( ph <-> ps ) @.
    @( If ` ph <-> ps ` holds then ` ph ` eventually holds iff ` ps `
       eventually holds.  (Contributed by FL, 20-Mar-2011.)  (Proof shortened
       by Mario Carneiro, 30-Aug-2016.) @)
    bidia @p |- ( <> ph <-> <> ps ) @=
      ( wdia biimpi diaimi biimpri impbii ) ADBDABABCEFBAABCGFH @.
  @}

  @( It's false that ` ph ` eventually holds iff ` -. ph ` always holds.
     (Contributed by FL, 20-Mar-2011.) @)
  notev @p |- ( -. <> ph <-> [.] -. ph ) @=
    ( wn wbox wdia df-dia bicomi con1bii ) ABCZADZIHBAEFG @.

  @( It's false that ` ph ` always holds iff ` -. ph ` eventually holds.
     (Contributed by FL, 20-Mar-2011.) @)
  notal @p |- ( -. [.] ph <-> <> -. ph ) @=
    ( wn wdia wbox boxeq bicomi con1bii ) ABCZADZIHBAEFG @.

  @( The contrapositive of ~ ax-ltl4 .  If the truth of ` ph ` in each step
     implies it is true in the previous step, and ` ph ` is eventually true,
     then ` ph ` is true in the first step.  (Contributed by Mario Carneiro,
     30-Aug-2016.) @)
  ltl4ev @p |- ( ( [.] ( () ph -> ph ) /\ <> ph ) -> ph ) @=
    ( wcirc wi wbox wdia wn df-dia con34b ax-ltl2 imbi2i bitri bibox ax-ltl4 ex
    sylbi con1d syl5bi imp ) ABZACZDZAEZAUBAFZDZFUAAAGUAAUDUAUCUCBZCZDZUCUDCTUF
    TUCSFZCUFSAHUHUEUCAIJKLUGUCUDUCMNOPQR @.

  @( ` ph ` holds until ` ps ` iff ` ps ` holds in the current step or ` ph `
     holds in the current step and in the next step ` ph ` holds until
     ` ps ` .  (Contributed by FL, 27-Feb-2011.) @)
  ax-ltl5 @a |- ( ( ph until ps ) <->
   ( ps \/ ( ph /\ () ( ph until ps ) ) ) ) @.

  @( If ` ph ` holds until ` ps ` then eventually ` ps ` holds.  (Contributed
     by FL, 20-Mar-2011.) @)
  ax-ltl6 @a |- ( ( ph until ps ) -> <> ps ) @.

  @( If ` ps ` doesn't hold in the first step and ` ph ` holds until ` ps `
     then ` ph ` holds.  (Contributed by FL, 20-Mar-2011.)  (Proof shortened by
     Andrew Salmon, 9-Jul-2011.) @)
  nopsthph @p |- ( ( -. ps /\ ( ph until ps ) ) -> ph ) @=
    ( wunt wn wcirc wa wo wi ax-ltl5 simpl orim2i ord sylbi impcom ) ABCZBDZAOB
    AOEZFZGZPAHABISBARABAQJKLMN @.

  @( If ` ph ` doesn't hold in the current step and ` ph ` holds until ` ps `
     then ` ps ` holds in the current step.  (Contributed by FL,
     20-Mar-2011.) @)
  phthps @p |- ( ( -. ph /\ ( ph until ps ) ) -> ps ) @=
    ( wunt wn nopsthph expcom con1d impcom ) ABCZADBIBABDIAABEFGH @.

  @( If ` ps ` is true, then ` ph ` is true until ` ps ` .  (Contributed by
     Mario Carneiro, 30-Aug-2016.) @)
  imunt @p |- ( ps -> ( ph until ps ) ) @=
    ( wunt wcirc wa wo orc ax-ltl5 sylibr ) BBAABCZDEZFJBKGABHI @.

  @( Eventually ` ph ` expressed with the ` until ` operator.  (Contributed by
     FL, 20-Mar-2011.)  (Proof shortened by Mario Carneiro, 30-Aug-2016.) @)
  evpexun @p |- ( <> ph <-> ( T. until ph ) ) @=
    ( wdia wtru wunt wcirc wi wbox wa wo truan biimpri ax-ltl5 sylibr ax-lmp wn
    olcd orc con3i impbox notev 3imtr4i con4i ltl4ev sylancr ax-ltl6 impbii ) A
    BZCADZUGUHEZUHFZGUHBZUHUJUIACUIHZIZUHUIULAULUIUIJKPCALZMNUKUGUHOZGAOZGUKOUG
    OUOUPAUHAUMUHAULQUNMRSUHTATUAUBUHUCUDCAUEUF @.

  @( ` ph ` always holds iff ` ph ` holds in the first step and always holds in
     the next step.  (Contributed by FL, 20-Mar-2011.) @)
  albineal @p |- ( [.] ph <-> ( ph /\ () [.] ph ) ) @=
    ( wbox wn wdia wtru wunt wcirc wa boxeq evpexun ax-ltl5 bitri notbii notnot
    wo ioran bicomi truan ax-ltl2 3bitri bitr2i binxt anbi12i ) ABZACZDZCZUEEEU
    EFZGZHZOZCZAUDGZHZAIZUFUKUFUHUKUEJZEUEKLMULUECZUJCZHUNUEUJPUQAURUMAUQANQURU
    ICUHCZGUMUJUIUIRMUHSUSUDUDUGUSUOUFUHUPMUAUBTUCLT @.

  @( If ` ph ` always holds, it holds in the first step.  (Contributed by FL,
     20-Mar-2011.) @)
  alneal1 @p |- ( [.] ph -> ph ) @=
    ( wbox wcirc albineal simplbi ) ABZAFCADE @.

  @( If ` ph ` always holds, it always holds in the next step.  (Contributed by
     FL, 20-Mar-2011.) @)
  alneal2 @p |- ( [.] ph -> () [.] ph ) @=
    ( wbox wcirc albineal simprbi ) ABZAFCADE @.

  @( If ` ph ` always holds, it holds in the next step.  (Contributed by FL,
     20-Mar-2011.) @)
  alne @p |- ( [.] ph -> () ph ) @=
    ( wbox wcirc alneal2 alneal1 impxt syl ) ABZHCACADHAAEFG @.

  @( It is always true that ` ph ` always holds iff ` ph ` always holds.
     (Contributed by FL, 20-Mar-2011.) @)
  alalifal @p |- ( [.] [.] ph <-> [.] ph ) @=
    ( wbox alneal1 wcirc wi alneal2 a1i impbox ax-ltl4 mpancom impbii ) ABZBZLL
    CLLDEZBLMANNAAFGHLIJK @.

  @{
    alneal1a.1 @e |- ( [.] ph -> ps ) @.
    @( Removing a box in the consequent.  (For my private use only.  Don't
       use.)  (Contributed by FL, 16-Sep-2016.) @)
    alneal1a @p |- ( [.] ph -> [.] ps ) @=
      ( wbox alalifal impbox sylbir ) ADZHDBDAEHBCFG @.
  @}

  @{
    impbox2.1 @e |- ( ch -> ( ph -> ps ) ) @.
    @( Removing boxes in the antecedents and consequent.  (Contributed by FL,
       16-Sep-2016.) @)
    impbox2 @p |- ( [.] ch -> ( [.] ph -> [.] ps ) ) @=
      ( wbox wi impbox ax-ltl1 syl ) CEABFZEAEBEFCJDGABHI @.
  @}

  @( Distributivity of ` [.] ` over ` /\ ` .  (Contributed by FL,
     1-Sep-2016.) @)
  boxand @p |- ( [.] ( ph /\ ps ) <-> ( [.] ph /\ [.] ps ) ) @=
    ( wa wbox simpl impbox simpr jca pm3.2 impbox2 imp impbii ) ABCZDZADZBDZCNO
    PMAABEFMBABGFHOPNBMAABIJKL @.

  @{
    boxrim.1 @e |- ( [.] ph -> ps ) @.
    @( If ` [.] ph ` implies ` ps ` in the current world, then it implies
       ` ps ` in every world.  (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    boxrim @p |- ( [.] ph -> [.] ps ) @=
      ( wbox alalifal impbox sylbir ) ADZHDBDAEHBCFG @.
  @}

  @{
    boximd.1 @e |- ( [.] ph -> ( ps -> ch ) ) @.
    @( Distribute 'always' over implication when the context is always true.
       (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    boximd @p |- ( [.] ph -> ( [.] ps -> [.] ch ) ) @=
      ( wbox wi boxrim ax-ltl1 syl ) AEBCFZEBECEFAJDGBCHI @.

    @( Distribute 'next' over implication when the context is always true.
       (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    nxtimd @p |- ( [.] ph -> ( () ps -> () ch ) ) @=
      ( wbox wi wcirc boxrim alne ax-ltl3 3syl ) AEBCFZELGBGCGFALDHLIBCJK @.

    @( Distribute 'eventually' over implication when the context is always
       true.  (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    diaimd @p |- ( [.] ph -> ( <> ps -> <> ch ) ) @=
      ( wbox wn wdia con3d boximd df-dia 3imtr4g ) AEZBFZEZFCFZEZFBGCGLPNAOMLBC
      DHIHBJCJK @.
  @}

  @{
    boxbid.1 @e |- ( [.] ph -> ( ps <-> ch ) ) @.
    @( Distribute 'always' over biconditional when the context is always true.
       (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    boxbid @p |- ( [.] ph -> ( [.] ps <-> [.] ch ) ) @=
      ( wbox biimpd boximd biimprd impbid ) AEZBECEABCJBCDFGACBJBCDHGI @.

    @( Distribute 'next' over biconditional when the context is always true.
       (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    nxtbid @p |- ( [.] ph -> ( () ps <-> () ch ) ) @=
      ( wbox wcirc biimpd nxtimd biimprd impbid ) AEZBFCFABCKBCDGHACBKBCDIHJ @.

    @( Distribute 'eventually' over biconditional when the context is always
       true.  (Contributed by Mario Carneiro, 30-Aug-2016.) @)
    diabid @p |- ( [.] ph -> ( <> ps <-> <> ch ) ) @=
      ( wbox wdia biimpd diaimd biimprd impbid ) AEZBFCFABCKBCDGHACBKBCDIHJ @.
  @}

  @( It is eventually true that ` ph ` eventually holds iff ` ph ` eventually
     holds.  (Contributed by FL, 20-Mar-2011.)  (Proof shortened by Andrew
     Salmon, 9-Jul-2011.) @)
  evevifev @p |- ( <> <> ph <-> <> ph ) @=
    ( wdia wn wbox notev bibox alalifal bitri notbii df-dia 3bitr4i ) ABZCZDZCA
    CZDZCLBLNPNPDPMPAEFOGHILJAJK @.

  @( If ` ph ` is always true, then it is always true that ` ph ` holds in the
     next step.  (Contributed by FL, 20-Mar-2011.)  (Proof shortened by Mario
     Carneiro, 30-Aug-2016.) @)
  althalne @p |- ( [.] ph -> [.] () ph ) @=
    ( wcirc alne boxrim ) AABACD @.

  @( ` T. ` is true in every step.  (Contributed by FL, 20-Mar-2011.)  (Proof
     shortened by Mario Carneiro, 30-Aug-2016.) @)
  trtrst @p |- [.] T. @=
    ( wtru tru ax-lmp ) ABC @.

  @( It's true that ` ph ` is true until true is true.  (Contributed by FL,
     27-Feb-2011.)  (Proof shortened by Mario Carneiro, 30-Aug-2016.) @)
  unttr @p |- ( ph until T. ) @=
    ( wtru wunt imunt trud ) ABCABDE @.

  @( An "induction principle" for until, roughly stating that it is the least
     fixed point satisfying a property like ~ ax-ltl5 .  (Contributed by Mario
     Carneiro, 30-Aug-2016.) @)
  untind @p |- ( [.] ( ( ps \/ ( ph /\ () th ) ) -> th ) ->
    ( ( ph until ps ) -> th ) ) @=
    ( wcirc wa wo wi wbox wunt simpr wdia ax-ltl5 ax-ltl3 anim2d orim2d alneal1
    sylan9r syl5bi ex boxrim adantr ax-ltl6 orc syl5 a1dd diaimd sylan2 syl2anc
    imp ltl4ev mpd ) BACDZEZFZCGZHZABIZCUPUQEZUQCUPUQJURUQCGZDZUSGZHZUSKZUSUPVB
    UQUOVAUPUTUSUQBAUQDZEZFZUPUTECABLUTVFUNUPCUTVEUMBUTVDULAUQCMNOUOPZQRSTUAUQU
    PBKZVCABUBUPVHVCUOBUSUPBCUQBUNUPCBUMUCVGUDUEUFUIUGUSUJUHUKS @.

  @{
    untindd.1 @e |- ( ps -> th ) @.
    untindd.2 @e |- ( ( ph /\ () th ) -> th ) @.
    @( An "induction principle" for until, roughly stating that it is the least
       fixed point satisfying a property like ~ ax-ltl5 .  (Contributed by
       Mario Carneiro, 30-Aug-2016.) @)
    untindd @p |- ( ( ph until ps ) -> th ) @=
      ( wcirc wa wo wi wbox wunt jaoi ax-lmp untind ax-mp ) BACFGZHCIZJABKCIQBC
      PDELMABCNO @.
  @}

  @{
    untim1d.1 @e |- ( [.] ph -> ( ps -> ch ) ) @.
    @( Congruence axiom for until.  (Contributed by Mario Carneiro,
       30-Aug-2016.) @)
    untim1d @p |- ( [.] ph -> ( ( ps until th ) -> ( ch until th ) ) ) @=
      ( wbox wunt wcirc wa wo anim1d orim2d ax-ltl5 syl6ibr boxrim untind syl
      wi ) AFZDBCDGZHZIZJZTRZFBDGTRAUDSUCDCUAIZJTSUBUEDSBCUAEKLCDMNOBDTPQ @.

    @( Congruence axiom for until.  (Contributed by Mario Carneiro,
       11-Aug-2016.) @)
    untim2d @p |- ( [.] ph -> ( ( th until ps ) -> ( th until ch ) ) ) @=
      ( wbox wunt wcirc wa wo wi orim1d ax-ltl5 syl6ibr boxrim untind syl ) AFZ
      BDDCGZHIZJZSKZFDBGSKAUBRUACTJSRBCTELDCMNODBSPQ @.
  @}

  @{
    untbi12d.1 @e |- ( [.] ph -> ( ps <-> ch ) ) @.
    untbi12d.2 @e |- ( [.] ph -> ( th <-> ta ) ) @.
    @( Congruence axiom for until.  (Contributed by Mario Carneiro,
       30-Aug-2016.) @)
    untbi12d @p |- ( [.] ph -> ( ( ps until th ) <-> ( ch until ta ) ) ) @=
      ( wbox wunt biimpd untim1d biimprd impbid untim2d bitrd ) AHZBDIZCDIZCEIZ
      PQRABCDPBCFJKACBDPBCFLKMPRSADECPDEGJNAEDCPDEGLNMO @.
  @}

  @{
    untbi12i.1 @e |- ( ph <-> ps ) @.
    untbi12i.2 @e |- ( ch <-> th ) @.
    @( Congruence axiom for until.  (Contributed by Mario Carneiro,
       30-Aug-2016.) @)
    untbi12i @p |- ( ( ph until ch ) <-> ( ps until th ) ) @=
      ( wtru wbox wunt wb trtrst a1i untbi12d ax-mp ) GHZACIBDIJKGABCDABJOELCDJ
      OFLMN @.

    @( @j congruence 'untbi12i'; @)
  @}

  @{
    axlmp1.1 @e |- [.] ph @.
    @( If ` ph ` always holds, then it is a theorem.  (Contributed by FL,
       16-Sep-2016.) @)
    axlmp1 @p |- ph @=
      ( wbox alneal1 ax-mp ) ACABADE @.
  @}

  @{
    axlmp2.1 @e |- A. x [.] ph @.
    @( Moving a universal quantifier inside and outside a box.  (Contributed by
       FL, 16-Sep-2016.) @)
    axlmp2 @p |- [.] A. x ph @=
      ( wal wbox spi axlmp1 ax-gen ax-lmp ) ABDABAAEBCFGHI @.
  @}

  @{
    axlmp3.1 @e |- [.] A. x ph @.
    @( Moving a universal quantifier inside and outside a box.  (Contributed by
       FL, 16-Sep-2016.) @)
    axlmp3 @p |- A. x [.] ph @=
      ( wbox wal axlmp1 spi ax-lmp ax-gen ) ADBAABABECFGHI @.
  @}

  @( Set equality is true in all worlds.  (Contributed by Mario Carneiro,
     30-Aug-2016.) @)
  ax-lll @a |- ( x = y -> [.] x = y ) @.

  @( One can add or remove a box in front of ` x = y ` .  (For my private use
     only.  Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
  axlll2 @p |- ( [.] x = y <-> x = y ) @=
    ( weq wbox alneal1 ax-lll impbii ) ABCZDHHEABFG @.

  @{
    cdeqbox.1 @e |- CondEq ( x = y -> ( ph <-> ps ) ) @.
    @( Distribute conditional equality over 'always'.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) @)
    cdeqbox @p |- CondEq ( x = y -> ( [.] ph <-> [.] ps ) ) @=
      ( wbox wb cv wceq ax-lll alneal1 cdeqri syl boxbid cdeqi ) AFBFGZCDCHDHIZ
      QFZPCDJQABRQABGZQKSCDELMNMO @.

    @( Distribute conditional equality over 'next'.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) @)
    cdeqnxt @p |- CondEq ( x = y -> ( () ph <-> () ps ) ) @=
      ( wcirc wb cv wceq wbox ax-lll alneal1 cdeqri syl nxtbid cdeqi ) AFBFGZCD
      CHDHIZRJZQCDKRABSRABGZRLTCDEMNONP @.

    cdequnt.2 @e |- CondEq ( x = y -> ( ch <-> th ) ) @.
    @( Distribute conditional equality over 'until'.  (Contributed by Mario
       Carneiro, 11-Aug-2016.) @)
    cdequnt @p |- CondEq ( x = y ->
      ( ( ph until ch ) <-> ( ps until th ) ) ) @=
      ( wunt wb cv wceq wbox ax-lll alneal1 cdeqri syl untbi12d cdeqi ) ACIBDIJ
      ZEFEKFKLZUAMZTEFNUAABCDUBUAABJZUAOZUCEFGPQUBUACDJZUDUEEFHPQRQS @.
  @}

  @( @j condcongruence 'cdeqbox' 'cdeqnxt' 'cdequnt'; @)


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d ch u @.  @d ph u x z @.  @d ph u y z @.  @d ps u @.
    ssoprab2g.1 @e |- ( ph -> ( ps -> ch ) ) @.
    @( Inference of operation class abstraction subclass from implication.
       (Contributed by FL, 24-Jan-2010.) @)
    ssoprab2g @p |- ( ph -> { <. <. x , y >. , z >. | ps } C_
        { <. <. x , y >. , z >. | ch } ) @=
      ( vu cv cop wa wex copab coprab anim2d 2eximdv ssopab2dv dfoprab2 3sstr4g
      wceq ) AHIDIEIJTZBKZELDLZHFMUACKZELDLZHFMBDEFNCDEFNAUCUEHFAUBUDDEABCUAGOP
      QBDEFHRCDEFHRS @.
  @}

  @{
    @d A x y z @.  @d B x y z @.
    @( The domain of an operation class abstraction.  Compare ~ dmoprabss .
       (Contributed by FL, 24-Jan-2010.) @)
    dmoprabsss @p |- dom { <. <. x , y >. , z >. |
    ( <. x , y >. e. ( A X. B ) /\ ph ) } C_ ( A X. B ) @=
      ( cv cop cxp wcel wa coprab cdm oprab4 dmeqi dmoprabss eqsstri ) BGZCGZHE
      FIZJAKBCDLZMREJSFJKAKBCDLZMTUAUBABCDEFNOABCDEFPQ @.
  @}

  @( Value returned by the operation ` G ` in terms of the value returned by
     the "super"-operation ` F ` .  (A version of ~ oprssov adapted to partial
     operations.)  (Contributed by FL, 5-Oct-2009.) @)
  oprssopvg @p |- ( ( Fun F /\ G C_ F /\ <. A , B >. e. dom G )
    -> ( A F B ) = ( A G B ) ) @=
    ( wfun wss cop cdm wcel w3a cres wceq fvres df-ov 3eqtr4g 3ad2ant3 funssres
    co cfv wa oveqd 3adant3 eqtr3d ) CEZDCFZABGZDHZIZJABCUGKZRZABCRZABDRZUHUDUJ
    UKLUEUHUFUISUFCSUJUKUFUGCMABUINABCNOPUDUEUJULLUHUDUETUIDABCDQUAUBUC @.

  @{
    @d A x y z @.  @d B z @.
    dmoprabss5.1 @e |- B e. C @.
    @( The domain of an operation class abstraction.  (A version of ~ dmoprabss
       adapted to partial operations.)  (Contributed by FL, 18-Apr-2010.) @)
    dmoprabss6 @p |- ( Rel A ->
     dom { <. <. x , y >. , z >. | ( <. x , y >. e. A /\ z = B ) } = A ) @=
      ( wrel cv cop wcel wceq wa coprab cdm wex copab dmoprab opabbii syl5eq
      19.42v simpl elexi isseti jctr impbii eqtri opabid2 ) DHZAIBIJDKZCIELZMZA
      BCNOULCPZABQZDULABCRUIUNUJABQZDUNUJUKCPZMZABQUOUMUQABUJUKCUASUQUJABUQUJUJ
      UPUBUJUPCEEFGUCUDUEUFSUGABDUHTT @.
  @}

  @{
    @d A z @.  @d B x y z @.  @d R x y z @.
    @( Existence of an operation class abstraction.  (A version of ~ mptex
       adapted to partial operations.)  (Contributed by FL, 18-Apr-2010.) @)
    oprabex2gpop @p |- ( ( R e. B /\ Rel R ) -> { <. <. x , y >. , z >.
      | ( <. x , y >. e. R /\ z = A ) } e. _V ) @=
      ( wrel cv cop wcel wceq wa coprab cdm crn wss cvv cxp relssdmrn sseld
      opelxp syl6ib anim1d ssoprab2g dmexg rnexg df-mpt2 eqcomi mpt2exg syl2anc
      cmpt2 ssexg syl2anr ) FGZAHZBHZIZFJZCHDKZLZABCMZUOFNZJUPFOZJLZUSLZABCMZPV
      FQJZVAQJFEJZUNUTVEABCUNURVDUSUNURUQVBVCRZJVDUNFVIUQFSTUOUPVBVCUAUBUCUDVHV
      BQJVCQJVGFEUEFEUFABVBVCDQQVFABVBVCDUKVFABCVBVCDUGUHUIUJVAVFQULUM @.
  @}

  @{
    @d R w x y z @.  @d ph x y @.  @d ps w @.
    dfoprab4pop.1 @e |- ( w = <. x , y >. -> ( ph <-> ps ) ) @.
    @( Class abstraction for operations in terms of class abstraction of
       ordered pairs.  (A version of ~ dfoprab4 adapted to partial
       operations.)  (Contributed by FL, 18-Apr-2010.) @)
    dfoprab4pop @p |- ( Rel R ->
         { <. w , z >. | ( w e. R /\ ph ) } =
         { <. <. x , y >. , z >. | ( <. x , y >. e. R /\ ps ) } ) @=
      ( wrel cv wcel wa copab cop wceq wex coprab elrel adantrr ex eleq1 2exbii
      pm4.71rd 19.41vv anbi12d pm5.32i bitr3i syl6bb opabbidv dfoprab2 syl6eqr
      ) GIZFJZGKZALZFEMUMCJDJNZOZUPGKZBLZLZDPCPZFEMUSCDEQULUOVAFEULUOUQDPCPZUOL
      ZVAULUOVBULUOVBULUNVBACDUMGRSTUCVCUQUOLZDPCPVAUQUOCDUDVDUTCDUQUOUSUQUNURA
      BUMUPGUAHUEUFUBUGUHUIUSCDEFUJUK @.
  @}

  @{
    @d F w x y z @.  @d R w x y z @.
    @( Representation of an operation class abstraction in terms of its
       values.  (A version of ~ fnov adapted to partial operations.)
       (Contributed by FL, 18-Apr-2010.)  (Revised by Mario Carneiro,
       10-Sep-2015.) @)
    fnovpop @p |- ( Rel R -> ( F Fn R <-> F = { <. <. x , y >. , z >. |
      ( <. x , y >. e. R /\ z = ( x F y ) ) } ) ) @=
      ( vw wfn cv cfv cmpt wceq wrel cop wcel co wa coprab dffn5 copab eqeq2d
      df-mpt fveq2 df-ov syl6eqr dfoprab4pop syl5eq syl5bb ) EDGEFDFHZEIZJZKDLZ
      EAHZBHZMZDNCHZULUMEOZKZPABCQZKFDERUKUJUREUKUJUHDNUOUIKZPFCSURFCDUIUAUSUQA
      BCFDUHUNKZUIUPUOUTUIUNEIUPUHUNEUBULUMEUCUDTUEUFTUG @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              General Set Theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d A x @.  @d B x @.  @d C x @.
    @( Inference from membership to difference.  (Contributed by FL,
       6-Jun-2007.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.) @)
    difeqri2 @p |- ( A. x ( ( x e. A /\ -. x e. B ) <-> x e. C )
      -> ( A \ B ) = C ) @=
      ( cv wcel wn wa wb wal cdif wceq eldif bibi1i albii dfcleq biimpri sylbir
      ) AEZBFSCFGHZSDFZIZAJSBCKZFZUAIZAJZUCDLZUEUBAUDTUASBCMNOUGUFAUCDPQR @.

  @}

  @{
    @d A u v w y z @.  @d B u v w y z @.  @d C u v w y z @.  @d D u v w y z @.
    @d ph u x @.  @d ta u v w y z @.  @d v w x y z @.
    elo.1 @e |- ( y = A -> ( ph <-> ps ) ) @.
    elo.2 @e |- ( z = B -> ( ps <-> ch ) ) @.
    elo.3 @e |- ( v = C -> ( ch <-> th ) ) @.
    elo.4 @e |- ( w = D -> ( th <-> ta ) ) @.
    @( The law of concretion for operation class abstraction.  Compare with
       ~ eloprabg .  This version is to be used with categories.  (Contributed
       by FL, 14-Jul-2007.)  (Revised by Mario Carneiro, 3-May-2015.) @)
    elo @p |- ( ( ( A e. Q /\ B e. R /\ C e. S ) /\ D e. T ) ->
      ( <. <. A , B >. , <. C , D >. >. e. { x | E. y E. z E. v E. w
      ( x = <. <. y , z >. , <. v , w >. >. /\ ph ) } <-> ta ) ) @=
      ( vu wcel w3a cvv cop cv wceq wa wex cab wb elex 3anim123i wi opex eqeq1d
      simpr vex opth anbi12i anass 3bitr4i df-3an anbi1i syl6bb anbi1d syl3an9b
      eqcom sylan9bb pm5.32i 4exbidv eqeq1 eleq1 syl5bbr adantl elisset anim12i
      eeeeanv sylibr biantrurd 19.41vvvv syl6rbbr adantr 3bitr3d expcom vtocle
      elab syl2an ) KOUDZLPUDZMQUDZUEKUFUDZLUFUDZMUFUDZUEZNUFUDZKLUGZMNUGZUGZFU
      HZGUHZHUHZUGZJUHZIUHZUGZUGZUIZAUJZIUKJUKHUKGUKZFULZUDZEUMZNRUDWKWNWLWOWMW
      PKOUNLPUNMQUNUONRUNWQWRUJZXOUPUCXAWSWTUQXPUCUHZXAUIZXOXPXRUJZXQXIUIZAUJZI
      UKJUKHUKGUKZXCKUIZXDLUIZXFMUIZUEZXGNUIZUJZEUJZIUKJUKHUKGUKZXNEXSYAYIGHJIX
      SYAYHAUJYIXSXTYHAXSXTXAXIUIZYHXSXQXAXIXPXRUSURXIXAUIZYCYDUJZYEUJZYGUJZYKY
      HXEWSUIZXHWTUIZUJYMYEYGUJZUJYLYOYPYMYQYRXCXDKLGUTHUTVAXFXGMNJUTIUTVAVBXEX
      HWSWTXCXDUQXFXGUQVAYMYEYGVCVDXAXIVJYFYNYGYCYDYEVEVFVDVGVHYHAEYFADYGEYCABY
      DCYEDSTUAVIUBVKVLVGVMXRYBXNUMXPYBXQXMUDXRXNXLYBFXQUCUTXBXQUIZXKYAGHJIYSXJ
      XTAXBXQXIVNVHVMWIXQXAXMVOVPVQXPYJEUMXRXPEYHIUKJUKHUKGUKZEUJYJXPYTEXPYCGUK
      ZYDHUKZYEJUKZUEZYGIUKZUJYTWQUUDWRUUEWNUUAWOUUBWPUUCGKUFVRHLUFVRJMUFVRUOIN
      UFVRVSYCYDYEYGHJIGVTWAWBYHEHJIGWCWDWEWFWGWHWJ @.
  @}

  @( An intersection with a member of a powerset belongs to this powerset.
     (Contributed by FL, 25-Sep-2007.) @)
  inpws1 @p |- ( A e. ~P C -> ( A i^i B ) e. ~P C ) @=
    ( cin cvv wcel cpw inex1g wss elpwi ssinss1 syl elpwg syl5ibr mpcom ) ABDZE
    FZACGZFZPRFZABRHSTQPCIZSACIUAACJABCKLPCEMNO @.

  @( An intersection with a member of a powerset belongs to this powerset.
     (Contributed by FL, 26-Oct-2007.) @)
  inpws2 @p |- ( B e. ~P C -> ( A i^i B ) e. ~P C ) @=
    ( cpw wcel cin incom inpws1 syl5eqel ) BCDZEABFBAFJABGBACHI @.

  @{
    @d v x @.  @d w x @.  @d x y @.  @d x z @.
    @( Structure of the class abstraction used by ` Alg ` , ` Cat ` and
       ` Ded ` .  (Contributed by FL, 26-Oct-2007.) @)
    stcat @p |- { x | E. y E. z E. v E. w ( x = <. <. y , z >. , <. v , w >. >.
       /\ ph ) } C_ ( ( _V X. _V ) X. ( _V X. _V ) ) @=
      ( cv cop wceq wa wex cvv cxp wcel simpl vex opelvv opelxpi mp2an exlimivv
      syl6eqel abssi ) BGZCGZDGZHZFGZEGZHZHZIZAJZEKFKZDKCKBLLMZUNMZUMUCUONZCDUL
      UPFEULUCUJUOUKAOUFUNNUIUNNUJUONUDUECPDPQUGUHFPEPQUFUIUNUNRSUATTUB @.
  @}

  @( A theorem of the ~ 1st2nd family.  (Contributed by FL, 26-Oct-2007.) @)
  11st22nd @p |- ( ( ( Rel B /\ Rel dom B /\ Rel ran B ) /\ A e. B ) ->
     A = <. <. ( 1st ` ( 1st ` A ) ) , ( 2nd ` ( 1st ` A ) ) >. ,
            <. ( 1st ` ( 2nd ` A ) ) , ( 2nd ` ( 2nd ` A ) ) >. >. ) @=
    ( wrel cdm crn w3a wcel wa c1st cfv c2nd cop wceq 1st2nd 3ad2antl1 wi exp32
    sylan2 a1i 3imp1 1stdm com13 2ndrn com3r opeq12d eqtrd ) BCZBDZCZBEZCZFABGZ
    HZAAIJZAKJZLZUNIJUNKJLZUOIJUOKJLZLUGUIULAUPMUKABNOUMUNUQUOURUGUIUKULUNUQMZU
    KUIUGULUSPZUIUGUTPPUKUIUGULUSUGULHZUIUNUHGUSABUAUNUHNRQSUBTUGUIUKULUOURMZUI
    UKUGULVBPZUKUGVCPPUIUKUGULVBVAUKUOUJGVBABUCUOUJNRQSUDTUEUF @.

  @{
    @d A x @.
    @( The union of a part of a powerset belongs to it.  (Contributed by FL,
       16-Nov-2007.) @)
    ump @p |- ( A e. V -> U. { x e. ~P A | ph } e. ~P A ) @=
      ( wcel cpw crab cuni wss ssrab2 sspwuni mpbi elpw2g mpbiri ) CDEABCFZGZHZ
      OEQCIZPOIRABOJPCKLQCDMN @.
  @}

  @( Moving an element ` B ` out from the intersection of a class ` A ` .
     (Contributed by FL, 29-Nov-2007.) @)
  moec @p |- ( B e. A -> |^| A = ( B i^i |^| ( A \ { B } ) ) ) @=
    ( wcel cint csn cdif cun cin eqcomd inteqd intun intsng ineq2d incom syl6eq
    difsnid syl5eq eqtrd ) BACZADABEZFZTGZDZBUADZHZSAUBSUBAABPIJSUCUDTDZHZUEUAT
    KSUGUDBHUESUFBUDBALMUDBNOQR @.

  @{
    @d A x y @.  @d B x y @.  @d C y @.
    @( Splitting an intersection.  (Contributed by FL, 15-Oct-2012.) @)
    splint @p |- ( B C_ A ->
    |^|_ x e. A C = ( |^|_ x e. ( A \ B ) C i^i |^|_ x e. B C ) ) @=
      ( vy wss ciin cdif cin cv wcel wral wa cvv wb vex eliin mp1i cun wceq a1i
      undif equncom biimpi eqcoms sylbi raleqdv ralunb syl6bb ax-mp bicomi elin
      bicomd anbi12d syl6bbr 3bitrd eqrdv ) CBFZEABDGZABCHZDGZACDGZIZUREJZUSKZV
      DDKZABLZVFAUTLZVFACLZMZVDVCKZVDNKZVEVGOUREPZAVDBDNQRURVGVFAUTCSZLVJURVFAB
      VNURCUTSZBTBVNTZCBUBVPBVOBVOTVPBCUTUCUDUEUFUGVFAUTCUHUIURVJVDVAKZVDVBKZMV
      KURVHVQVIVRVHVQOURVQVHVLVQVHOVMAVDUTDNQUJUKUAURVRVIVLVRVIOURVMAVDCDNQRUMU
      NVDVAVBULUOUPUQ @.
  @}

  @{
    @d A x @.  @d B x @.  @d D x @.
    splintx.1 @e |- ( x = B -> C = D ) @.
    @( Moving an element out from an intersection.  (Contributed by FL,
       15-Oct-2012.) @)
    splintx @p |- ( B e. A ->
     |^|_ x e. A C = ( |^|_ x e. ( A \ { B } ) C i^i D ) ) @=
      ( wcel ciin csn cdif cin wss wceq snssi splint syl iinxsng ineq2d eqtrd )
      CBGZABDHZABCIZJDHZAUBDHZKZUCEKTUBBLUAUEMCBNABUBDOPTUDEUCACDEBFQRS @.
  @}

  @{
    @( A function's value belongs to its range.  A more general version of
       ~ fnovrn .  To be used with partial operations.  (Contributed by FL,
       10-Mar-2008.) @)
    fnovrn2 @p |- ( ( Fun F /\ <. A , B >. e. dom F ) ->
      ( A F B ) e. ran F ) @=
      ( wfun cop cdm wcel wa co cfv crn df-ov fvelrn syl5eqel ) CDABEZCFGHABCIO
      CJCKABCLOCMN @.
  @}

  @( If an intersection is not empty, its operands are not empty.  (Contributed
     by FL, 27-Apr-2008.) @)
  neiopne @p |- ( ( A i^i B ) =/= (/) -> ( A =/= (/) /\ B =/= (/) ) ) @=
    ( cin c0 wne wceq wo wn wa ineq1 incom eqtr in0 sylancl ineq2 jaoi necon3ai
    syl6eq neanior sylibr ) ABCZDEADFZBDFZGZHADEBDEIUDUADUBUADFZUCUBUADBCZFZUFB
    DCZFZUEADBJDBKUGUIIUAUHDUAUFUHLBMRNUCUAADCDBDAOAMRPQADBDST @.

  @( Image of a preimage.  (Contributed by FL, 1-Jun-2008.) @)
  f2imacnv @p |- ( ( F : A -1-1-onto-> B /\ C C_ B ) ->
                 ( F " ( `' F " C ) ) = C ) @=
    ( wf1o ccnv wf1 wss cima wceq f1ocnv f1of1 imacnvcnv f1imacnv syl5eqr sylan
    syl wa ) ABDEZBADFZGZCBHZDTCIZIZCJSBATEUAABDKBATLQUAUBRUDTFUCICDUCMBACTNOP
    @.

  @( Symmetrical equality of the images and of their antecedents when the
     mapping is one-to-one.  (Contributed by FL, 1-Jun-2008.) @)
  oooeqim2 @p |- ( ( F : A -1-1-> B /\ X C_ A /\ Y C_ A )
     -> ( ( F " X ) = ( F " Y ) <-> X = Y ) ) @=
    ( wf1 wss w3a cima wceq ccnv wa f1imacnv ex anim12d 3impib imaeq2 eqtr syl
    wi com23 eqcoms imp syl2im impbid1 ) ABCFZDAGZEAGZHZCDIZCEIZJZDEJZUICKZUJIZ
    DJZUNUKIZEJZLZULUOUQJZUMUFUGUHUSUFUGUPUHURUFUGUPABDCMNUFUHURABECMNOPUJUKUNQ
    UPURUTUMTZURVATDUODUOJZUTURUMVBUTURUMTZVBUTLDUQJZVCDUOUQRVDURUMDUQERNSNUAUB
    UCUDDECQUE @.

  @( A theorem about things which don't exist ` _V ` and ` ( _V X. _V ) ` .
     (Contributed by FL, 22-Sep-2008.) @)
  vxveqv @p |- ( _V X. _V ) =/= _V @=
    ( vx cvv cxp wne wceq wn wpss wss ssv cv wcel wa wex c0 0nelxp eleq1 notbid
    0ex anbi12d mpbir spcev mp2an nss dfpss3 mpbir2an pssv mpbi df-ne ) BBCZBDU
    IBEFZUIBGZUJUKUIBHBUIHFZUIIULAJZBKZUMUIKZFZLZAMZNBKZNUIKZFZURRBBOUQUSVALANR
    UMNEZUNUSUPVAUMNBPVBUOUTUMNUIPQSUAUBABUIUCTUIBUDUEUIUFUGUIBUHT @.

  @( The double union of the converse of a class ` A ` is included in the
     double union of the class.  (Contributed by FL, 31-Jul-2009.) @)
  ducidu @p |- U. U. `' A C_ U. U. A @=
    ( ccnv cuni cdm crn cun unidmrn dmrnssfld eqsstri ) ABCCADAEFACCAGAHI @.

  @( The field of a class equals the field of its converse.  (Contributed by
     FL, 16-Apr-2012.) @)
  fldcnv @p |- ( dom A u. ran A ) = ( dom `' A u. ran `' A ) @=
    ( cdm crn cun ccnv uncom df-rn dfdm4 uneq12i eqtri ) ABZACZDLKDAEZBZMCZDKLF
    LNKOAGAHIJ @.

  @{
    @d R x @.
    @( The domain of a reflexive class equals its field.  (Contributed by FL,
       29-Dec-2011.) @)
    domfldrefc @p |- ( A. x e. ( dom R u. ran R ) x R x
      -> dom R = ( dom R u. ran R ) ) @=
      ( cv wbr cdm crn cun wral wss wa wceq wcel wi wal vex breldm ralimi sylib
      df-ral sylibr dfss2 ssun1 jctil eqss ) ACZUEBDZABEZBFZGZHZUGUIIZUIUGIZJUG
      UIKUJULUKUJUEUILUEUGLZMANZULUJUMAUIHUNUFUMAUIUEUEBAOZUOPQUMAUISRAUIUGUATU
      GUHUBUCUGUIUDT @.

    @( The range of a reflexive class equals its field.  (Contributed by FL,
       29-Dec-2011.) @)
    ranfldrefc @p |- ( A. x e. ( dom R u. ran R ) x R x
      -> ran R = ( dom R u. ran R ) ) @=
      ( cv wbr cdm crn cun wral wss wa wceq wcel wi wal vex brelrn ralimi sylib
      df-ral sylibr dfss2 ssun2 jctil eqss ) ACZUEBDZABEZBFZGZHZUHUIIZUIUHIZJUH
      UIKUJULUKUJUEUILUEUHLZMANZULUJUMAUIHUNUFUMAUIUEUEBAOZUOPQUMAUISRAUIUHUATU
      HUGUBUCUHUIUDT @.

    @( The domain and range of a reflexive class are equal.  (Contributed by
       FL, 29-Dec-2011.) @)
    dranfldrefc @p |- ( A. x e. ( dom R u. ran R ) x R x
      -> dom R = ran R ) @=
      ( cv wbr cdm crn cun wral domfldrefc ranfldrefc eqtr4d ) ACZLBDABEZBFZGZH
      MONABIABJK @.
  @}

  @{
    @d R x @.
    @( Domain and range of a reflexive relation are equal.  (Contributed by FL,
       6-Oct-2008.) @)
    domrngref @p |- ( ( Rel R /\ A. x e. U. U. R x R x ) -> dom R = ran R ) @=
      ( wrel cv wbr cuni wral wa cdm wcel crn wal wceq df-ral cun relfld imim2i
      wb wi sylbi eqcomd eleq2d biimpd imim1d wo elun imbi1i jaob brelrn adantr
      vex breldm adantl impbid syl6 alimdv syl5bi imp dfcleq sylibr ) BCZADZVBB
      EZABFFZGZHVBBIZJZVBBKZJZRZALZVFVHMVAVEVKVEVBVDJZVCSZALVAVKVCAVDNVAVMVJAVA
      VMVBVFVHOZJZVCSZVJVAVOVLVCVAVOVLVAVNVDVBVAVDVNBPUAUBUCUDVPVGVIUEZVCSZVJVO
      VQVCVBVFVHUFUGVRVGVCSZVIVCSZHZVJVGVCVIUHWAVGVIVSVGVISVTVCVIVGVBVBBAUKZWBU
      IQUJVTVIVGSVSVCVGVIVBVBBWBWBULQUMUNTTUOUPUQURAVFVHUSUT @.

    @( The domain of a reflexive relation is equal to its field .  (Contributed
       by FL, 6-Oct-2008.) @)
    domfldref @p |- ( ( Rel R /\ A. x e. U. U. R x R x )
        -> dom R = U. U. R ) @=
      ( wrel cv wbr cuni wral cdm wceq crn cun wa relfld domrngref uneq2 eqcomd
      wi eqtr unidm syl5com syl6req ex syl anabsi5 ) BCZADZUFBEABFFZGZBHZUGIZUE
      UGUIBJZKZIZUEUHLZUJBMUNUIUKIZUMUJQABNUOULUIUIKZIZUMUJUOUPULUIUKUIOPUMUQUJ
      UMUQLUGUPUIUGULUPRUISUAUBTUCTUD @.
  @}

  @{
    @d A x @.  @d R x @.
    @( In a reflexive class ` R ` , an element ` A ` belongs to the field iff
       the pair ` <. A , A >. ` belongs to ` R ` .  (Contributed by FL,
       30-Dec-2011.) @)
    domintreflemb @p |- ( ( A e. B /\ A. x e. dom R x R x )
        -> ( A e. dom R <-> A R A ) ) @=
      ( wcel cv wbr cdm wral wa wi wceq id breq12d rspccv adantl breldmg 3expia
      anidms adantr impbid ) BCEZAFZUCDGZADHZIZJBUEEZBBDGZUFUGUHKUBUDUHABUEUCBL
      ZUCBUCBDUIMZUJNOPUBUHUGKZUFUBUKUBUBUHUGBBCCDQRSTUA @.
  @}

  @{
    @d R x @.  @d S x @.
    @( The domain of the intersection of two reflexive classes is the
       intersection of their domains.  Compare with ~ dmin .  (Contributed by
       FL, 30-Dec-2011.) @)
    domintrefb @p |- ( ( A. x e. dom R x R x /\
     A. x e. dom S x S x ) ->
      dom ( R i^i S ) = ( dom R i^i dom S ) ) @=
      ( cv wbr cdm wral wa cin wss wceq inss1 sseli imim1i ralimi2 inss2 r19.26
      wcel sylbir sylibr brin vex breldm ralimi dfss3 syl2an dmin jctil eqss )
      ADZUJBEZABFZGZUJUJCEZACFZGZHZBCIZFZULUOIZJZUTUSJZHUSUTKUQVBVAUMUKAUTGZUNA
      UTGZVBUPUKUKAULUTUJUTRZUJULRUKUTULUJULUOLMNOUNUNAUOUTVEUJUORUNUTUOUJULUOP
      MNOVCVDHUKUNHZAUTGZVBUKUNAUTQVGUJUSRZAUTGVBVFVHAUTVFUJUJUREVHUJUJBCUAUJUJ
      URAUBZVIUCSUDAUTUSUETSUFBCUGUHUSUTUIT @.
  @}

  @{
    @d A x y @.  @d R x y @.
    @( If ` R ` is a reflexive relation and ` A ` a part of its field, ` A ` is
       a part of the image of ` A ` by ` R ` .  (Contributed by FL,
       3-Jul-2009.) @)
    imgfldref2 @p |- ( ( A. x e. U. U. R x R x /\ A C_ U. U. R )
    -> A C_ ( R " A ) ) @=
      ( vy cv wbr cuni wral wss wa wrex cab cima wcel wi wal nfra1 nfan syl6com
      nfv ssel rsp breq1 rspcev expcom com24 pm2.43i com3l alrimi sylibr dfima2
      imp ssab syl6sseqr ) AEZUOCFZACGGZHZBUQIZJZBDEZUOCFZDBKZALZCBMUTUOBNZVCOZ
      APBVDIUTVFAURUSAUPAUQQUSATRURUSVFVEURUSVCVEURUSVCOOVEUSURVEVCUSVEUOUQNZUR
      VFOBUQUOUAURVGUPVFUPAUQUBVEUPVCVBUPDUOBVAUOUOCUCUDUESSUFUGUHULUIVCABUMUJD
      ACBUKUN @.
  @}

  @{
    @d R x @.
    @( The converse of a reflexive class is reflexive.  (Contributed by FL,
       31-Jul-2009.) @)
    cnvref @p |- ( A. x e. ( dom R u. ran R ) x R x <->
    A. x e. ( dom `' R u. ran `' R ) x `' R x ) @=
      ( cv wbr cdm crn wral ccnv wcel wb wa brcnvg bicomd anidms ralbiia fldcnv
      cun raleqi bitri ) ACZTBDZABEBFQZGTTBHZDZAUBGUDAUCEUCFQZGUAUDAUBTUBIZUAUD
      JUFUFKUDUATTUBUBBLMNOUDAUBUEBPRS @.
  @}

  @{
    @d R x @.
    @( The converse of a reflexive relation is reflexive.  (Contributed by FL,
       19-Sep-2011.) @)
    cnvref2 @p |- ( Rel R -> ( A. x e. U. U. R x R x <->
    A. x e. U. U. `' R x `' R x ) ) @=
      ( wrel wbr cuni wral ccnv cdm crn cun relfld raleqdv cnvref syl6bb relcnv
      cv wceq eqcomd mp1i bitrd ) BCZAPZUBBDZABEEZFZUBUBBGZDZAUFHUFIJZFZUGAUFEE
      ZFUAUEUCABHBIJZFUIUAUCAUDUKBKLABMNUAUGAUHUJUFCZUHUJQUABOULUJUHUFKRSLT @.
  @}

  @{
    @d R y @.  @d x y @.
    @( Strong reflexivity implies weak reflexivity.  (Strong and weak
       reflexivity is the difference between a toset and a poset).
       (Contributed by FL, 29-Dec-2011.) @)
    srefwref @p |- ( A. x e. ( dom R u. ran R ) A. y e. ( dom R u. ran R )
   ( x R y \/ y R x ) -> A. x e. ( dom R u. ran R ) x R x ) @=
      ( cv wbr wo cdm crn cun wral wcel wa weq breq2 breq1 rspcva pm4.25 sylibr
      orbi12d ralimiaa ) ADZBDZCEZUBUACEZFZBCGCHIZJZUAUACEZAUFUAUFKUGLUHUHFZUHU
      EUIBUAUFBAMUCUHUDUHUBUAUACNUBUAUACOSPUHQRT @.
  @}

  @( A class whose union is finite is finite.  (Contributed by FL,
     22-Dec-2008.) @)
  unfinsef @p |- ( U. A e. Fin -> A e. Fin ) @=
    ( cuni cfn wcel cpw pwfi wss pwuni ssfi mpan2 sylbi ) ABZCDLEZCDZACDZLFNAMG
    OAHMAIJK @.

  @( If the domain of a bijection is finite its range is finite and
     reciprocally.  (Contributed by FL, 31-Jul-2009.) @)
  f1ofi @p |- ( F : A -1-1-onto-> B -> ( A e. Fin <-> B e. Fin ) ) @=
    ( wf1o cfn wcel wfo f1ofo fofi ex syl5com ccnv wi f1ocnv expcom 3syl impbid
    ) ABCDZAEFZBEFZRABCGZSTABCHSUATABCIJKRBACLZDBAUBGZTSMABCNBAUBHTUCSBAUBIOPQ
    @.

  @( A square cross product ` ( A X. A ) ` is reflexive.  (Contributed by FL,
     31-Jul-2009.) @)
  scprefat @p |- ( _I |` U. U. ( A X. A ) ) C_ ( A X. A ) @=
    ( cxp cuni wceq cid cres wss unixpid reseq2 wf1o f1oi f1of fssxp mp2b sseq1
    wf mpbiri ) AABZCCZADESFZEAFZDZTRGZAHSAEIUBUCUARGZAAUAJAAUAPUDAKAAUALAAUAMN
    TUAROQN @.

  @( Todo: combine scprefat and scprefat2. @)
  @( A square cross product ` ( A X. A ) ` is reflexive.  (Contributed by FL,
     31-Jul-2009.) @)
  scprefat2 @p |- ( _I |` A ) C_ ( A X. A ) @=
    ( cxp cuni wceq cid cres unixpid reseq2 scprefat sseq1 mpbiri eqcoms mp2b
    wss ) AABZCCZADEPFZEAFZDRONZAGPAEHSRQRQDSQONAIRQOJKLM @.

  @( A square cross product is symmetric.  (Contributed by FL, 31-Jul-2009.) @)
  sqpsym @p |- `' ( A X. A ) C_ ( A X. A ) @=
    ( cxp ccnv cnvxp eqimssi ) AABZCFAADE @.

  @{
    @d A x @.  @d B x @.
    @( If an infinite set ` A ` is included in the underlying set of a finite
       cover ` B ` , then there exists a set of the cover that contains an
       infinite number of element of ` A ` .  (Contributed by FL,
       2-Aug-2009.) @)
    isunscovOLD @p |- ( ( -. A e. Fin /\ B e. Fin /\ A C_ U. B ) ->
    E. x e. B -. ( A i^i x ) e. Fin ) @=
      ( cfn wcel wn cuni wss w3a cv cin wrex wral dfral2 wi wa ciun sylbi com12
      eleq1i iunfi iunin2 uniiun eqcomi ineq2i df-ss eleq1 pm2.24 syl6bi syl ex
      wceq com24 3imp syl5bir pm2.18d ) BDEZFZCDEZBCGZHZIZBAJZKZDEZFACLZVFFVEAC
      MZVBVFVEACNURUSVAVGVFOZUSURVAVHOUSVGVAURVFUSVGVAURVFOZOZUSVGPACVDQZDEZVJA
      CVDUAVLBACVCQZKZDEZVJVKVNDACBVCUBTVOBUTKZDEZVJVNVPDVMUTBUTVMACUCUDUETVAVQ
      VIVAVPBULZVQVIOBUTUFVRVQUQVIVPBDUGUQVFUHUIRSRRUJUKUMSUNUOUP @.
  @}

  @{
    @d A f x @.
    @( ~ ac5 with the premisse transformed into an antecedent.  (Contributed by
       FL, 2-Aug-2009.) @)
    ac5g @p |- ( A e. _V ->
      E. f ( f Fn A /\ A. x e. A ( x =/= (/) -> ( f ` x ) e. x ) ) ) @=
      ( cvv wcel cv wfn c0 wne cfv wi wral wa wex cif wceq fneq2 anbi12d exbidv
      raleq 0ex elimel ac5 dedth ) BDEZCFZBGZAFZHIUHUFJUHEKZABLZMZCNUFUEBHOZGZU
      IAULLZMZCNBHBULPZUKUOCUPUGUMUJUNBULUFQUIABULTRSAULCBHDUAUBUCUD @.
  @}

  @{
    @d A x y @.
    @( Restriction of the identity to a singleton.  (Contributed by FL,
       2-Aug-2009.) @)
    restidsing @p |- ( _I |` { A } ) = ( { A } X. { A } ) @=
      ( vx vy cid csn cres cxp relres cv wcel wa wceq elsn wi cvv imp jca bitri
      ex sylbi relxp cop wbr df-br bicomi anbi1i simpr ideqg biimpd ax-mp eqtr2
      vex syl6ibr syl syl5bi eqtr3 ideq equcom sylibr com12 simpl impbii opelxp
      opelres 3bitr4i eqrelriiv ) BCDAEZFZVGVGGZDVGHVGVGUABIZCIZUBZDJZVJVGJZKZV
      NVKVGJZKZVLVHJVLVIJVOVJVKDUCZVNKZVQVMVRVNVRVMVJVKDUDUEUFVSVQVSVNVPVRVNUGV
      RVNVPVNVJALZVRVPBAMZVRVJVKLZVTVPNVKOJZVRWBNCULZWCVRWBVJVKOUHUIUJWBVTVKALZ
      VPWBVTWEVJVKAUKSCAMZUMUNUOPQVQVRVNVNVPVRVNVTVPVRNWAVPVTVRVPWEVTVRNWFWEVTV
      RWEVTKVKVJLZVRVKVJAUPVRWBWGVJVKWDUQBCURRUSSTUTTPVNVPVAQVBRVJVKDVGWDVDVJVK
      VGVGVCVEVF @.
  @}

  @( The intersection of the identity function with a square cross product.
     (Contributed by FL, 2-Aug-2009.) @)
  residcp @p |- ( _I i^i ( A X. A ) ) = ( _I |` A ) @=
    ( cid cxp cin cres cvv wss ssid ssv xpss12 mp2an sslin ax-mp sseqtr4i resss
    df-res scprefat2 ssini eqssi ) BAACZDZBAEZUABAFCZDZUBTUCGZUAUDGAAGAFGUEAHAI
    AAAFJKTUCBLMBAPNUBBTBAOAQRS @.

  @{
    @d R x y @.
    @( Two ways of saying a relation is symmetric.  (Contributed by FL,
       31-Aug-2009.) @)
    twsymr @p |- ( Rel R -> ( R = `' R <-> A. x A. y ( x R y -> y R x ) ) ) @=
      ( ccnv wceq wss wa wrel cv wbr wi wal eqss cnvsym biimpi a1d adantl com12
      dfrel2 cnvss sseq1 syl5ibcom sylbir sylbi imp biimpri jca impbid syl5bb
      ex ) CCDZECUKFZUKCFZGZCHZAIZBIZCJUQUPCJKBLALZCUKMUOUNURUNUOURUMUOURKULUMU
      RUOUMURABCNZOPQRUOURUNUOURGULUMUOURULUOUKDZCEZURULKCSURVAULURUMVAULKUSUMU
      TUKFVAULUKCTUTCUKUAUBUCRUDUEURUMUOUMURUSUFQUGUJUHUI @.
  @}

  @{
    @d R x y z @.
    @( Projection of the first elements of the pairs of a relation ` R ` .
       (Contributed by FL, 15-Oct-2012.) @)
    prj1b @p |- ( Rel R -> ( 1st " R ) =
    { x | E. y <. x , y >. e. R } ) @=
      ( vz cv cop wcel c1st wbr vex wi c2nd cfv cvv wceq wa df-br fnopfvb sylbi
      wb wrel wex cima wrex elima cxp wss df-rel ssel elxp6 wfn wfo fo1st ax-mp
      fofn mp2an eleq1 opeq1 eleq1d syl6bi com3r sylbir com3l adantr syli com23
      biimpcd com13 fvex opeq2 spcev syl8 rexlimiv com12 op1st opex mpbir breq1
      mpbi rspcev mpan2 exlimiv impbid1 syl5bb abbi2dv ) CUAZAEZBEZFZCGZBUBZAHC
      UCZWGWLGDEZWGHIZDCUDZWFWKDWGHCAJZUEWFWOWKWOWFWKWNWFWKKDCWMCGZWNWFWGWMLMZF
      ZCGZWKWFWNWQWTWFCNNUFZUGZWNWQWTKZKCUHXBWQWNWTWQXBWMXAGZWNWTKZCXAWMUIXDWMW
      MHMZWRFZOZXFNGWRNGPZPWQXEKZWMNNUJXHXJXIWNXHWQWTWNWMWGFHGZXHXCKZWMWGHQXKXF
      WGOZXLHNUKZWMNGXMXKTNNHULXNUMNNHUOUNZDJNWMWGHRUPXHWQXMWTXHWQXGCGZXMWTKWMX
      GCUQXMXPWTXMXGWSCXFWGWRURUSVGUTVAVBSVCVDSVEVFSVHWJWTBWRWMLVIWHWROWIWSCWHW
      RWGVJUSVKVLVMVNWJWOBWJWIWGHIZWOXQWIWGFHGZWIHMWGOZXRWGWHWPBJVOXNWINGXSXRTX
      OWGWHVPNWIWGHRUPVSWIWGHQVQWNXQDWICWMWIWGHVRVTWAWBWCWDWE @.
  @}

  @{
    @d R x y z @.
    @( Use fnopfvb instead of fnopovb. @)
    @( Projection of the second elements of the pairs of a relation ` R ` .
       (Contributed by FL, 15-Oct-2012.) @)
    prj3 @p |- ( Rel R -> ( 2nd " R ) = { y | E. x <. x , y >. e. R } ) @=
      ( vz cv cop wcel c2nd wbr vex wi c1st cfv cvv wceq wa df-br fnopfvb sylbi
      wb wrel wex cima wrex elima cxp wss df-rel ssel elxp6 wfn wfo fo2nd ax-mp
      fofn mp2an eleq1 opeq2 eleq1d syl6bi com3r sylbir com3l adantr syli com23
      biimpcd com13 fvex opeq1 spcev syl8 rexlimiv com12 op2nd opex mpbir breq1
      mpbi rspcev mpan2 exlimiv impbid1 syl5bb abbi2dv ) CUAZAEZBEZFZCGZAUBZBHC
      UCZWHWLGDEZWHHIZDCUDZWFWKDWHHCBJZUEWFWOWKWOWFWKWNWFWKKDCWMCGZWNWFWMLMZWHF
      ZCGZWKWFWNWQWTWFCNNUFZUGZWNWQWTKZKCUHXBWQWNWTWQXBWMXAGZWNWTKZCXAWMUIXDWMW
      RWMHMZFZOZWRNGXFNGPZPWQXEKZWMNNUJXHXJXIWNXHWQWTWNWMWHFHGZXHXCKZWMWHHQXKXF
      WHOZXLHNUKZWMNGXMXKTNNHULXNUMNNHUOUNZDJNWMWHHRUPXHWQXMWTXHWQXGCGZXMWTKWMX
      GCUQXMXPWTXMXGWSCXFWHWRURUSVGUTVAVBSVCVDSVEVFSVHWJWTAWRWMLVIWGWROWIWSCWGW
      RWHVJUSVKVLVMVNWJWOAWJWIWHHIZWOXQWIWHFHGZWIHMWHOZXRWGWHAJWPVOXNWINGXSXRTX
      OWGWHVPNWIWHHRUPVSWIWHHQVQWNXQDWICWMWIWHHVRVTWAWBWCWDWE @.
  @}

  @{
    @d A x @.
    @( The image under ` 1st ` of a class with no pairs inside.  (Contributed
       by FL, 31-Aug-2009.) @)
    imfstnrelc @p |- ( ( ( A i^i ( _V X. _V ) ) = (/) /\ A =/= (/) )
   -> ( 1st " A ) = { (/) } ) @=
      ( vx cvv cxp cin c0 wceq wne wa c1st cima cv cfv csn ciun cdm fo1st ax-mp
      wss wcel wfun wfo fofun ssv wfn fofn fndm sseqtr4i pm3.2i dfimafn2 1stval
      mp1i cuni wn wi wral wal biimpi df-ral sylib 19.21bi adantr dmsnn0 bicomi
      disj imp necon1bbii sseq1 mpbiri sylbi uni0b sylibr syl5eq sneqd iuneq2dv
      0ss syl iunconst adantl 3eqtrd ) ACCDZEFGZAFHZIZJAKZBABLZJMZNZOZBAFNZOZWJ
      JUAZAJPZSZIWEWIGWDWLWNCCJUBZWLQCCJUCRACWMAUDJCUEZWMCGWOWPQCCJUFRCJUGRUHUI
      BAJUJULWDBAWHWJWDWFATZIZWGFWRWGWFNPZUMZFWFUKWRWSWJSZWTFGWRWFWATZUNZXAWDWQ
      XCWBWQXCUOZWCWBXDBWBXCBAUPZXDBUQWBXEBAWAVEURXCBAUSUTVAVBVFXCWSFGZXAXBWSFX
      BWSFHWFVCVDVGXFXAFWJSWJVPWSFWJVHVIVJVQWSVKVLVMVNVOWCWKWJGWBBAWJVRVSVT @.
  @}

  @{
    @d R x y @.
    @( The projection of the first elements of the pairs of a relation ` R ` is
       its domain.  (Contributed by FL, 5-Oct-2009.) @)
    prjdmn @p |- ( Rel R -> ( 1st " R ) = dom R ) @=
      ( vx vy wrel c1st cima cv cop wcel wex cab cdm prj1b dfdm3 syl6eqr ) ADEA
      FBGCGHAICJBKALBCAMBCANO @.
  @}

  @{
    @d R x y @.
    @( The projection of the second elements of the pairs of a relation ` R `
       is its range.  (Contributed by FL, 15-Oct-2012.) @)
    prjrn @p |- ( Rel R -> ( 2nd " R ) = ran R ) @=
      ( vx vy wrel c2nd cima cv cop wcel wex cab crn prj3 dfrn3 syl6eqr ) ADEAF
      BGCGHAIBJCKALBCAMBCANO @.
  @}

  @( Projection of a cross product.  (Contributed by FL, 5-Oct-2009.) @)
  prjcp1 @p |- ( B =/= (/) -> ( 1st " ( A X. B ) ) = A ) @=
    ( c0 wne c1st cxp cima cdm wrel wceq relxp prjdmn mp1i dmxp eqtrd ) BCDZEAB
    FZGZQHZAQIRSJPABKQLMABNO @.

  @( Projection of a cross product.  (Contributed by FL, 15-Oct-2012.) @)
  prjcp2 @p |- ( A =/= (/) -> ( 2nd " ( A X. B ) ) = B ) @=
    ( c0 wne c2nd cxp cima crn wrel wceq relxp prjrn mp1i rnxp eqtrd ) ACDZEABF
    ZGZQHZBQIRSJPABKQLMABNO @.

  @{
    @d A v w x y z @.  @d ph x @.  @d ta v w y z @.
    eloi.1 @e |- ( y = ( 1st ` ( 1st ` A ) ) -> ( ph <-> ps ) ) @.
    eloi.2 @e |- ( z = ( 2nd ` ( 1st ` A ) ) -> ( ps <-> ch ) ) @.
    eloi.3 @e |- ( v = ( 1st ` ( 2nd ` A ) ) -> ( ch <-> th ) ) @.
    eloi.4 @e |- ( w = ( 2nd ` ( 2nd ` A ) ) -> ( th <-> ta ) ) @.
    @( A consequence of membership in a class abstraction whose elements belong
       to ` ( ( _V X. _V ) X. ( _V X. _V ) ) ` using ordered pair extractors.
       (Used by category theory).  (Contributed by FL, 24-Sep-2007.) @)
    eloi @p |- ( A e. { x | E. y E. z E. v E. w
      ( x = <. <. y , z >. , <. v , w >. >. /\ ph ) } -> ta ) @=
      ( cop wceq wex wcel cvv cv wa cab c1st cfv eqeq1 anbi1d 4exbidv elabg ibi
      c2nd cxp opex opelvv syl6eqel 1st2nd2 syl op1std vex op2ndd opeq12d eqtrd
      id adantr exlimivv eleq1 w3a wb fvex 3pm3.2i elo mp2an syl6bb biimpcd mpd
      ) KFUAZGUAZHUAZPZJUAZIUAZPZPZQZAUBZIRJRHRGRZFUCZSZKKUDUEZUDUEZWIUKUEZPZKU
      KUEZUDUEZWMUKUEZPZPZQZEWHKWCQZAUBZIRJRZHRGRZWRWHXBWFXBFKWGVPKQZWEWTGHJIXC
      WDWSAVPKWCUFUGUHUIUJXAWRGHWTWRJIWSWRAWSKWIWMPZWQWSKTTULZSKXDQWSKWCXEWSVCV
      SWBVQVRUMZVTWAUMZUNUOKTTUPUQWSWIWLWMWPWSWIXESWIWLQWSWIVSXEVSWBKXFXGURVQVR
      GUSHUSUNUOWITTUPUQWSWMXESWMWPQWSWMWBXEVSWBKXFXGUTVTWAJUSIUSUNUOWMTTUPUQVA
      VBVDVEVEUQWRWHEWRWHWQWGSZEKWQWGVFWJTSZWKTSZWNTSZVGWOTSXHEVHXIXJXKWIUDVIWI
      UKVIWMUDVIVJWMUKVIABCDEFGHIJWJWKWNWOTTTTLMNOVKVLVMVNVO @.
  @}

  @( The double union of an intersection is a part of the intersections of the
     unions.  (Contributed by FL, 24-Jan-2010.) @)
  uuniin @p |- U. U. ( A i^i B ) C_ ( U. U. A i^i U. U. B ) @=
    ( cin cuni wss uniin uniss syl6ss ax-mp ) ABCDZADZBDZCZEZJDZKDLDCZEABFNOMDP
    JMGKLFHI @.

  @( A class builder defined by an implication.  (Contributed by FL,
     18-Sep-2010.) @)
  clsbldimp @p |- { x | ( ph -> ps ) } =
                  ( { x | -. ph } u. { x | ps } ) @=
    ( wi cab wn wo cun imor abbii unab eqtr4i ) ABDZCEAFZBGZCENCEBCEHMOCABIJNBC
    KL @.

  @( A mapping is a member of the powerset of the cross product of its domain
     and codomain.  (Contributed by FL, 30-Dec-2010.) @)
  mappow @p |- ( ( A e. R /\ B e. S ) ->
    ( F : A --> B -> F e. ~P ( A X. B ) ) ) @=
    ( wcel wa wf cmap co cxp cpw wb elmapg ancoms mapsspw sseli syl6bir ) ACFZB
    DFZGABEHZEBAIJZFZEABKLZFTSUCUAMBAEDCNOUBUDEBAPQR @.

  @{
    @d A x y @.  @d ph y @.
    @( Membership in the intersection of a class abstraction.  (Contributed by
       FL, 30-Dec-2010.) @)
    elintabg @p |- ( A e. V ->
      ( A e. |^| { x | ph } <-> A. x ( ph -> A e. x ) ) ) @=
      ( vy cv cab cint wcel wi wal eleq1 wceq imbi2d albidv vex elintab vtoclbg
      ) EFZABGHZIASBFZIZJZBKCTIACUAIZJZBKECDSCTLSCMZUCUEBUFUBUDASCUALNOABSEPQR
      @.
  @}

  @( A singleton of a set belongs to the power class of a class containing the
     set.  (Contributed by FL, 30-Dec-2010.) @)
  snelpwg @p |- ( A e. V -> ( A e. B <-> { A } e. ~P B ) ) @=
    ( wcel cvv csn cpw wb elex c0 cif wceq eleq1 sneq eleq1d bibi12d 0ex elimel
    snelpw dedth syl ) ACDAEDZABDZAFZBGZDZHZACIUBUGUBAJKZBDZUHFZUEDZHAJAUHLZUCU
    IUFUKAUHBMULUDUJUEAUHNOPUHBAJEQRSTUA @.

  @{
    @d A x y @.  @d x y @.
    dff1o6f.1 @e |- F/_ x F @.
    dff1o6f.2 @e |- F/_ y F @.
    @( A one-to-one onto function in terms of function values.  (Contributed by
       FL, 1-Jan-2011.)  (Proof shortened by Mario Carneiro, 11-Dec-2016.) @)
    dff1o6f @p |- ( F : A -1-1-onto-> B <-> ( F Fn A /\ ran F = B /\
             A. x e. A A. y e. A ( ( F ` x ) = ( F ` y ) -> x = y ) ) ) @=
      ( wfo cv cfv wceq wi wral wa wfn crn wf1o w3a df-fo anbi1i wf1 df-f1o fof
      ancom wf wb dff13f baib syl pm5.32i 3bitri df-3an 3bitr4i ) CDEHZAIZEJBIZ
      EJKUOUPKLBCMACMZNZECOZEPDKZNZUQNCDEQZUSUTUQRUNVAUQCDESTVBCDEUAZUNNUNVCNUR
      CDEUBVCUNUDUNVCUQUNCDEUEZVCUQUFCDEUCVCVDUQABCDEFGUGUHUIUJUKUSUTUQULUM @.
  @}

  @( The non-empty components of a finite cross product are finite.
     (Contributed by FL, 22-Feb-2011.) @)
  fixpb @p |- ( ( A =/= (/) /\ B =/= (/) ) ->
    ( ( A X. B ) e. Fin <-> ( A e. Fin /\ B e. Fin ) ) ) @=
    ( c0 wne wa cxp cfn wcel wi xpnz xpfir expcom sylbi xpfi impbid1 ) ACDBCDEZ
    ABFZGHZAGHBGHEZPQCDZRSIABJRTSABKLMABNO @.

  @( A cross product is finite iff one of its components is empty or both its
     components are finite.  (Contributed by FL, 22-Feb-2011.) @)
  fixpc @p |- ( ( A X. B ) e. Fin <->
       ( A = (/) \/ B = (/) \/ ( A e. Fin /\ B e. Fin ) ) ) @=
    ( cxp cfn wcel c0 wceq wa w3o wo wn wne wi neanior fixpb biimpd sylbir 0fin
    eqeltri syl6eqel com12 orrd df-3or sylibr xpeq1 0xp xpeq2 xp0 3jaoi impbii
    xpfi ) ABCZDEZAFGZBFGZADEBDEHZIZUMUNUOJZUPJUQUMURUPURKZUMUPUSAFLBFLHZUMUPMA
    FBFNUTUMUPABOPQUAUBUNUOUPUCUDUNUMUOUPUNULFBCZDAFBUEVAFDBUFRSTUOULAFCZDBFAUG
    VBFDAUHRSTABUKUIUJ @.

  @( Absorption law for multiplication with an infinite cardinal.  Equivalent
     to Proposition 10.41 of [TakeutiZaring] p. 95.  (Contributed by FL,
     22-Feb-2011.) @)
  infxpg @p |- ( ( om ~<_ A /\ B =/= (/) /\ ( A e. C /\ B e. D ) ) ->
                   ( A X. B ) ~~ ( A u. B ) ) @=
    ( com cdom wbr c0 wne wcel wa w3a ccrd cdm cxp cun cen simp3l numth3 syl
    simp1 simp3r simp2 infxp syl22anc ) EAFGZBHIZACJZBDJZKZLZAMNZJZUFBULJZUGABO
    ABPQGUKUHUMUFUGUHUIRACSTUFUGUJUAUKUIUNUFUGUHUIUBBDSTUFUGUJUCABUDUE @.

  @( An infinite set strictly dominates a natural number.  (Contributed by FL,
     22-Feb-2011.)  (Revised by Mario Carneiro, 3-May-2015.) @)
  infsdomnng @p |- ( A e. V -> ( ( om ~<_ A /\ B e. om ) -> B ~< A ) ) @=
    ( com cdom wbr wcel wa csdm wi infsdomnn a1i ) DAEFBDGHBAIFJACGABKL @.

  @( Any operation can be restricted to ` ( _V X. _V ) ` .  (Contributed by FL,
     20-Mar-2011.) @)
  resid2 @p |- ( ( Rel A /\ Rel dom A ) -> ( A |` ( _V X. _V ) ) = A ) @=
    ( cdm wrel cvv cxp wss cres wceq df-rel relssres sylan2b ) ABZCACLDDEZFAMGA
    HLIAMJK @.

  @( Image of an element of transitive class ` B ` under a class restricted by
     ` B ` .  (Contributed by FL, 20-Mar-2011.) @)
  imrestr @p |- ( ( Tr B /\ A e. B ) -> ( ( C |` B ) " A ) = ( C " A ) ) @=
    ( wtr wcel cres cima wceq wss trss resima2 syl6 imp ) BDZABEZCBFAGCAGHZNOAB
    IPBAJCABKLM @.

  @( Image of an element of an ordinal ` B ` under a class restricted by
     ` B ` .  (Contributed by FL, 20-Mar-2011.) @)
  imresord @p |- ( ( Ord B /\ A e. B ) -> ( ( C |` B ) " A ) = ( C " A ) ) @=
    ( word wtr wcel cres cima wceq ordtr imrestr sylan ) BDBEABFCBGAHCAHIBJABCK
    L @.

  @( If ` A ` is a part of ` B ` and ` B ` a part of ` C ` and ` A ` is
     equipotent to ` C ` then ` A ` is equipotent to ` B ` .  The art of
     sandwich applied to set theory.  (Contributed by FL, 16-Apr-2011.)
     (Revised by Mario Carneiro, 3-May-2015.) @)
  sndw @p |- ( ( A C_ B /\ B C_ C /\ C e. _V )
     -> ( A ~~ C -> A ~~ B ) ) @=
    ( wss cvv wcel w3a cen wbr wa cdom simpl2 simpl3 syl2anc simpl1 ssdomg sylc
    ssexg wb domen2 adantl mpbird sbth ex ) ABDZBCDZCEFZGZACHIZABHIZUHUIJZABKIZ
    BAKIZUJUKBEFZUEULUKUFUGUNUEUFUGUILZUEUFUGUIMZBCERNUEUFUGUIOABEPQUKUMBCKIZUK
    UGUFUQUPUOBCEPQUIUMUQSUHACBTUAUBABUCNUD @.

  @( If ` A ` is a part of ` B ` and ` B ` a part of ` C ` and ` A ` is
     equipotent to ` C ` then ` A ` is equipotent to ` B ` .  The art of
     sandwich applied to set theory.  (Contributed by FL, 16-Apr-2011.) @)
  sndw2 @p |- ( ( A C_ B /\ B C_ C /\ C e. D )
     -> ( A ~~ C -> A ~~ B ) ) @=
    ( wcel wss cvv cen wbr wi elex sndw syl3an3 ) CDEABFBCFCGEACHIABHIJCDKABCLM
    @.

  @( If a successor of ` A ` belongs to an ordinal, so does ` A ` .
     (Contributed by FL, 20-Mar-2011.) @)
  ordsuccl @p |- ( ( Ord B /\ suc A e. B ) -> A e. B ) @=
    ( word wtr csuc wcel ordtr trsuc sylan ) BCBDAEBFABFBGBAHI @.

  @( If a successor of ` A ` belongs to an ordinal, so does ` A ` .
     (Contributed by FL, 20-Mar-2011.) @)
  ordsuccl2 @p |- ( ( B e. On /\ suc A e. B ) -> A e. B ) @=
    ( con0 wcel wtr csuc word eloni ordtr syl trsuc sylan ) BCDZBEZAFBDABDMBGNB
    HBIJBAKL @.

  @( If a successor of ` A ` belongs to an ordinal, ` A ` is a part of the
     ordinal.  (Contributed by FL, 20-Mar-2011.) @)
  ordsuccl3 @p |- ( ( B e. On /\ suc A e. B ) -> A C_ B ) @=
    ( con0 wcel csuc wa wtr wss word eloni ordtr syl adantr ordsuccl2 trss sylc
    ) BCDZAEBDZFBGZABDABHQSRQBISBJBKLMABNBAOP @.

  @( Trichotomy law for dominance and strict dominance.  This theorem is
     equivalent to the Axiom of Choice.  (Contributed by FL, 16-Apr-2011.) @)
  domtri3 @p |- ( ( A e. C /\ B e. D ) -> ( -. A ~<_ B <-> B ~< A ) ) @=
    ( wcel wa csdm wbr cdom wn domtri bicomd con1bid ) ACEBDEFZBAGHZABIHZNPOJAB
    CDKLM @.

  @( Omega strictly dominates a finite set.  (Contributed by FL,
     16-Apr-2011.) @)
  isfinite1b @p |- ( A e. Fin -> A ~< om ) @=
    ( cfn wcel com csdm wbr isfinite biimpi ) ABCADEFAGH @.

  @( The cross product of two finite sets is finite.  (Contributed by FL,
     16-Apr-2011.) @)
  cptwff @p |- ( ( A ~< om /\ B ~< om ) -> ( A X. B ) ~< om ) @=
    ( com csdm wbr wa cxp cfn wcel isfinite xpfi syl2anbr sylib ) ACDEZBCDEZFAB
    GZHIZPCDENAHIBHIQOAJBJABKLPJM @.

  @( The intersection of a non-empty element of a transitive class is a part of
     the class.  (Contributed by FL, 15-Apr-2011.) @)
  inttrp @p |- ( ( Tr A /\ B e. A /\ B =/= (/) ) -> |^| B C_ A ) @=
    ( wtr wcel c0 wne w3a cint wss wi wa trss imp cuni uniss df-tr sstr syl5com
    syl pm2.43i intssuni sstr2 3ad2ant3 ex com3l sylbi 3ad2ant1 3adant3 ) ACZBA
    DZBEFZGZBHZAIZUIUJULUNJZUKUIUJKBAIZUOUIUJUPABLMUPBNZANZIZULUNBAOULUSUNJZUIU
    JULUTJZUKUIURAIZVAAPUSVBULUNUSVBUOUSVBKUQAIZULUNUQURAQUKUIVCUNJZUJUKUMUQIVD
    BUAUMUQAUBSUCRUDUEUFUGTRSUHT @.

  @( The union of two transitive classes is transitive.  JFM CLASSES1. th. 55
     (Contributed by FL, 16-Apr-2011.) @)
  trunitr @p |- ( ( Tr A /\ Tr B ) -> Tr ( A u. B ) ) @=
    ( wtr wa cun cuni wss uniun df-tr unss12 syl2anb syl5eqss sylibr ) ACZBCZDZ
    ABEZFZQGQCPRAFZBFZEZQABHNSAGTBGUAQGOAIBISATBJKLQIM @.

  @{
    @d A x @.
    @( Union of a cumulative hierarchy of sets.  (Contributed by FL,
       23-Apr-2011.) @)
    uncum2 @p |- ( A e. On -> U_ x e. A ( R1 ` x ) C_ ( R1 ` A ) ) @=
      ( con0 wcel cv cr1 cfv wss wral ciun r1ord2 ralrimiv iunss sylibr ) BCDZA
      EZFGZBFGZHZABIABQJRHOSABPBKLABQRMN @.
  @}

  @{
    @d A x y @.
    @( If all the elements of a set ` A ` are ordinal numbers and are parts of
       the set then ` A ` is an ordinal number.  (Contributed by FL,
       20-Apr-2011.) @)
    celsor @p |- ( ( A e. B /\ A. x e. A ( x e. On /\ x C_ A ) )
      -> A e. On ) @=
      ( vy wcel cv con0 wss wa wral wtr weq w3o r19.26 dftr3 biimpri word eloni
      ralimi sylbi eleq1 cbvralv raaanv ordtri3or syl2an sylbir pm2.43i anim12i
      wi expcom ancoms adantl wb elong adantr dford2 syl6bb mpbird ) BCEZAFZGEZ
      UTBHZIABJZIZBGEZBKZUTDFZEADLVGUTEMZDBJZABJZIZVCVKUSVCVAABJZVBABJZIVKVAVBA
      BNVMVLVKVMVFVLVJVFVMABOPVLVJVLVGGEZDBJZVLVJUIVAVNADBUTVGGUAUBVLVOVJVLVOIV
      AVNIZDBJZABJVJVAVNADBUCVQVIABVPVHDBVAUTQVGQVHVNUTRVGRUTVGUDUESSUFUJTUGUHU
      KTULVDVEBQZVKUSVEVRUMVCBCUNUOADBUPUQUR @.
  @}

  @{
    @( If a relation ` R ` is reflexive, it is included in ` ( R o. R ) ` .
       (Contributed by FL, 8-May-2011.) @)
    reflincror @p |- ( ( Rel R /\ ( _I |` U. U. R ) C_ R )
       -> R C_ ( R o. R ) ) @=
      ( wrel cid cuni cres wss ccom wceq relcoi2 coss1 sseq1 biimpd syl2im imp
      ) ABZCADDEZAFZAAAGZFZOPAGZAHZQTRFZSAIPAAJUAUBSTARKLMN @.
  @}

  @{
    fldrels.1 @e |- X = U. U. R @.
    @( The field of a relation is a set.  (Contributed by FL, 23-May-2011.) @)
    fldrels @p |- ( R e. S -> X e. _V ) @=
      ( wcel cuni cvv uniexg syl syl5eqel ) ABEZCAFZFZGDKLGEMGEABHLGHIJ @.
  @}

  @{
    @( Value when ` C ` doesn't belong to the domain.  (Contributed by FL,
       26-Jun-2011.)  (Revised by Mario Carneiro, 3-May-2015.) @)
    fvsnn @p |- ( C =/= A -> ( { <. A , B >. } ` C ) = (/) ) @=
      ( wne cop csn cdm wcel wn cfv c0 wceq dmsnopss sseli elsni necon3ai ndmfv
      syl ) CADCABEFZGZHZICSJKLUACAUACAFZHCALTUBCABMNCAORPCSQR @.
  @}

  @{
    @d A x @.  @d B x @.  @d C x @.  @d D x @.
    fvsn2.1 @e |- A e. E @.
    fvsn2.2 @e |- B e. F @.
    fvsn2.3 @e |- C e. G @.
    fvsn2.4 @e |- D e. H @.
    @( Value of a function with a domain of two different values.  (Contributed
       by FL, 26-Jun-2011.) @)
    fvsn2a @p |- ( A =/= B ->
       ( { <. A , C >. , <. B , D >. } ` A ) = C ) @=
      ( elexi fvpr1 ) ABCDAEIMCGKMN @.

    @( Value of a function with a domain of two different values.  (Contributed
       by FL, 26-Jun-2011.) @)
    fvsn2b @p |- ( A =/= B ->
       ( { <. A , C >. , <. B , D >. } ` B ) = D ) @=
      ( elexi fvpr2 ) ABCDBFJMDHLMN @.
  @}

  @{
    @d R x @.
    @( A relation is reflexive iff its converse is reflexive.  (Contributed by
       FL, 19-Sep-2011.) @)
    relrefcnv @p |- ( Rel R -> ( ( _I |` U. U. R ) C_ R <->
      ( _I |` U. U. `' R ) C_ `' R ) ) @=
      ( vx wrel cv wbr cuni wral ccnv cid cres wss cnvref2 issref 3bitr4g ) ACB
      DZOAEBAFFZGOOAHZEBQFFZGIPJAKIRJQKBALBPAMBRQMN @.
  @}

  @{
    @d A x @.  @d B x @.  @d F i x @.  @d G i x @.  @d I x @.
    @( If a family of sets ` A ` indexed by ` I ` covers the common domain
       ` B ` of two functions ` F ` and ` G ` , the restrictions of ` F ` and
       ` G ` to ` ( A i^i B ) ` are equal iff ` F = G ` .  Compare ~ eqfnun .
       (Contributed by FL, 5-Nov-2011.) @)
    eqfnung2 @p |- ( ( B C_ U_ i e. I A /\ F Fn B /\ G Fn B ) ->
    ( A. i e. I ( F |` A ) = ( G |` A ) <-> F = G ) ) @=
      ( vx wfn w3a cres wceq wral wa cfv wcel wi wrex fvres syl ex wss cv eqidd
      ciun ssel eliun r19.29 fveq1 eqeq12 biimpd syl2anc rexlimivw a1d a1i a1ii
      mpan9 com4r com4t 3imp com3l sylbi syl6com pm2.43a com14 pm2.43i ralrimiv
      3expd 3imp1 wb 3simpc adantr eqfnfv2 mpbir2and reseq1 ralrimivw impbid1 )
      BCFAUDZUAZDBHZEBHZIZDAJZEAJZKZCFLZDEKZWAWEWFWAWEMZWFBBKZGUBZDNZWIENZKZGBL
      ZWGBUCWGWLGBVRVSVTWEWIBOZWLPZVRVSVTWEWOVRVSVTWEIZWOPWNVRWPVRWLVRWNWPVRWLP
      ZPZVRWNWIVQOZWNWRPZBVQWIUEWSWIAOZCFQZWTCWIFAUFWPXBWNWQVSVTWEXBWNWQPZPWEXB
      VSVTXCWEXBVSVTXCPPZWEXBMWDXAMZCFQZXDWDXACFUGVSVTWNXFWQVSVTWNXFWQPZPXGWNXF
      WLVRXEWLCFWDWIWBNZWIWCNZKZXAWLWIWBWCUHXAXHWJKZXIWKKZXJWLPWIADRWIAERXKXLMX
      JWLXHWJXIWKUIUJUKUPULUMUNUOUQSTURUSUTVAVBVCVDVEVGVHVFWGVSVTMZWFWHWMMVIWAX
      MWEVRVSVTVJVKGBBDEVLSVMTWFWDCFDEAVNVOVP @.
  @}

  @{
    @d A r @.  @d B r @.  @d F r @.
    @( A function is an injection iff a retraction exists.  Bourbaki E.II.18
       prop. 8.  (Contributed by FL, 11-Nov-2011.) @)
    injrec2 @p |- ( ( F : A --> B /\ A e. C )
      -> ( F : A -1-1-> B <-> E. r ( Fun r /\
        ( r o. F ) = ( _I |` A ) ) ) ) @=
      ( wf wcel wa wf1 cv wfun ccom cid cres wceq wex wi ccnv cvv adantr cnvexg
      f1f fex sylan syl df-f1 simprbi f1cocnv1 funeq eqeq1d anbi12d spcegv sylc
      jca coeq1 expcom adantl fcof1 ex adantld exlimdv impbid ) ABDFZACGZHABDIZ
      EJZKZVFDLZMANZOZHZEPZVDVEVLQVCVEVDVLVEVDHZDRZSGZVNKZVNDLZVIOZHZVLVMDSGZVO
      VEVCVDVTABDUBABCDUCUDDSUAUEVEVSVDVEVPVRVEVCVPABDUFUGABDUHUNTVKVSEVNSVFVNO
      ZVGVPVJVRVFVNUIWAVHVQVIVFVNDUOUJUKULUMUPUQVCVLVEQVDVCVKVEEVCVJVEVGVCVJVEA
      BVFDURUSUTVATVB @.
  @}

  @{
    @d s x y A @.  @d s x y B @.  @d s x C @.  @d s x D @.  @d s x y F @.
    @( A function is a surjection iff a section exists.  Bourbaki E.II.18 prop.
       8.  (Contributed by FL, 18-Nov-2011.)  (Proof shortened by Mario
       Carneiro, 27-Dec-2014.) @)
    surjsec2 @p |- ( ( F : A --> B /\ A e. C /\ B e. D )
      -> ( F : A -onto-> B <-> E. s ( s : B --> A /\
        ( F o. s ) = ( _I |` B ) ) ) ) @=
      ( vx vy wf wcel w3a wfo cv wceq wa wex wi cfv wral wfn ccom cid cres wrex
      simprr dffo3 simprbi adantr fveq2 eqeq2d ac6sg sylc fof ad2antrr sylancom
      wb fco ffn syl fnresi eqfnfv sylancl adantll fvresi adantl eqeq12d syl6bb
      fvco3 eqcom ralbidva bitrd pm5.32da exbidv mpbird expcom 3adant1 3ad2ant1
      fcofo 3expib exlimdv impbid ) ABEIZACJZBDJZKZABELZBAFMZIZEWGUAZUBBUCZNZOZ
      FPZWCWDWFWMQWBWFWCWDOZWMWFWNOZWMWHGMZWPWGRZERZNZGBSZOZFPZWOWDWPHMZERZNZHA
      UDGBSZXBWFWCWDUEWFXFWNWFWBXFHGABEUFUGUHXEWSGHBAFDXCWQNXDWRWPXCWQEUIUJUKUL
      WOWLXAFWOWHWKWTWOWHOZWKWPWIRZWPWJRZNZGBSZWTXGWIBTZWJBTWKXKUPXGBBWIIZXLWOW
      HWBXMWFWBWNWHABEUMUNBABEWGUQUOBBWIURUSBUTGBWIWJVAVBXGXJWSGBXGWPBJZOZXJWRW
      PNWSXOXHWRXIWPWHXNXHWRNWOBAWPEWGVHVCXNXIWPNXGBWPVDVEVFWRWPVIVGVJVKVLVMVNV
      OVPWEWLWFFWBWCWLWFQWDWBWHWKWFABWGEVRVSVQVTWA @.
  @}

  @{
    @d A x z @.  @d B y z @.  @d C z @.  @d D x z @.
    @( Existence of a class abstraction of existentially restricted sets.
       (Contributed by FL, 15-Oct-2012.) @)
    ab2rexexg2 @p |- ( ( A e. D /\ A. x e. A B e. E )
       -> { z | E. x e. A E. y e. B z = C } e. _V ) @=
      ( wcel wral cv wceq wrex cab cvv abrexexg ralimi abrexex2g sylan2 ) EHIZA
      DJDGICKFLBEMZCNOIZADJUAADMCNOITUBADBCEFHPQUAACDGORS @.
  @}

  @{
    @d A x z @.  @d B x z @.  @d B y z @.  @d C z @.
    @( Can I remove the distinct variables statement %d B x %. @)
    @( Existence of a class abstraction of existentially restricted sets.
       (Contributed by FL, 19-Apr-2012.) @)
    ab2rexexg @p |- ( ( A e. D /\ B e. E )
       -> { z | E. x e. A E. y e. B z = C } e. _V ) @=
      ( wcel cvv wceq wrex cab elex c0 cif rexeq abbidv eleq1d 0ex cv ab2rexex
      rexbidv elimel dedth2h syl2an ) DGIDJIZEJIZCUAFKZBELZADLZCMZJIZEHIDGNEHNU
      GUHUMUJAUGDOPZLZCMZJIUIBUHEOPZLZAUNLZCMZJIDEOODUNKZULUPJVAUKUOCUJADUNQRSE
      UQKZUPUTJVBUOUSCVBUJURAUNUIBEUQQUCRSABCUNUQFDOJTUDEOJTUDUBUEUF @.
  @}

  @{
    @d A x y z @.  @d B x y z @.  @d C x y z @.  @d D x y z @.
    ov2gc.1 @e |- O = ( x e. C , y e. D |-> ( x o. y ) ) @.
    @( Value of a composition. ~ ovmpt2g adapted to this special case of a
       composite.  (Contributed by FL, 14-Jul-2012.) @)
    ov2gc @p |- ( ( A e. C /\ B e. D ) -> ( A O B ) = ( A o. B ) ) @=
      ( wcel ccom cvv co wceq coexg cv coeq1 coeq2 ovmpt2g mpd3an3 ) CEIDFICDJZ
      KICDGLTMCDEFNABCDEFAOZBOZJTGCUBJKUACUBPUBDCQHRS @.
  @}

  @{
    @d C x y z @.  @d D x y z @.
    ov4gc.1 @e |- O = ( x e. C , y e. D |-> ( x o. y ) ) @.
    @( Value of a composition. ~ ovmpt4g adapted to the special case of a
       composite.  (Contributed by FL, 14-Jul-2012.) @)
    ov4gc @p |- ( ( x e. C /\ y e. D ) -> ( x O y ) = ( x o. y ) ) @=
      ( cv wcel ccom cvv co wceq coexg ovmpt4g mpd3an3 ) AGZCHBGZDHPQIZJHPQEKRL
      PQCDMABCDREJFNO @.
  @}

  @{
    @d A y @.  @d R x y @.  @d i y @.
    @( The domain of the intersection of a family of reflexive classes is the
       intersection of the domains.  (Contributed by FL, 15-Oct-2012.) @)
    domintrefc @p |- ( A. i e. A A. x e. dom R x R x ->
      dom |^|_ i e. A R = |^|_ i e. A dom R ) @=
      ( vy cv wbr cdm wral ciin wss dmiin a1i wcel cvv wb eliin ax-mp wa sylbi
      wi vex r19.26 weq id breq12d rspcva ralimi cop df-br ralbii bicomd opeldm
      opex syl sylbir ex com12 ssrdv eqssd ) AFZVACGZACHZIZDBIZDBCJZHZDBVCJZVGV
      HKVEDBCLMVEEVHVGEFZVHNZVEVIVGNZVJVIVCNZDBIZVEVKUAVIONVJVMPEUBZDVIBVCOQRVM
      VEVKVMVESVLVDSZDBIZVKVLVDDBUCVPVIVICGZDBIZVKVOVQDBVBVQAVIVCAEUDZVAVIVAVIC
      VSUEZVTUFUGUHVRVIVIUIZCNZDBIZVKVQWBDBVIVICUJUKWCWAVFNZVKWAONZWCWDPVIVIUNW
      EWDWCDWABCOQULRVIVIVFVNVNUMTTUOUPUQTURUSUT @.
  @}

  @{
    @d A x @.
    @( The range of an intersection is a part of the intersection of the
       ranges.  (The case ` A = (/) ` works as well, the intersection gives
       ` _V ` ).  (Contributed by FL, 15-Oct-2012.) @)
    rnintintrn @p |- ran |^|_ x e. A B C_ |^|_ x e. A ran B @=
      ( ciin crn wss c0 wceq cvv iineq1 0iin wa ssv eqtr syl5sseqr sylancl ccnv
      cdm a1i df-rn wne cnviin dmeqd dmiin eqsstrd cv iineq2i 3sstr4g pm2.61ine
      wcel ) ABCDZEZABCEZDZFZBGBGHUNAGUMDZHZUPIHZUOABGUMJAUMKUQURLIULUNULMUNUPI
      NOPBGUAZUKQZRZABCQZRZDZULUNUSVAABVBDZRZVDUSUTVEABCUBUCVFVDFUSABVBUDSUEUKT
      ABUMVCUMVCHAUFBUJCTSUGUHUI @.
  @}

  @( Projection of a part of a cross product.  (Contributed by FL,
     15-Oct-2012.) @)
  prjpacp1 @p |- ( ( B =/= (/) /\ C C_ ( A X. B ) ) -> ( 1st " C ) C_ A ) @=
    ( cxp wss c0 wne c1st cima imass2 wi prjcp1 sseq2 biimpd syl syl5com impcom
    wceq ) CABDZEZBFGZHCIZAEZTUBHSIZEZUAUCCSHJUAUDARZUEUCKABLUFUEUCUDAUBMNOPQ
    @.

  @( Projection of a part of a cross product.  (Contributed by FL,
     15-Oct-2012.) @)
  prjpacp2 @p |- ( ( A =/= (/) /\ C C_ ( A X. B ) ) -> ( 2nd " C ) C_ B ) @=
    ( cxp wss c0 wne c2nd cima imass2 wi prjcp2 sseq2 biimpd syl syl5com impcom
    wceq ) CABDZEZAFGZHCIZBEZTUBHSIZEZUAUCCSHJUAUDBRZUEUCKABLUFUEUCUDBUBMNOPQ
    @.

  @( A relation is included in the cross product of its projections.
     (Contributed by FL, 15-Oct-2012.) @)
  relinccppr @p |- ( Rel A -> A C_ ( ( 1st " A ) X. ( 2nd " A ) ) ) @=
    ( wrel c1st cima c2nd cxp wss cdm wceq crn wi prjdmn prjrn xpeq12 relssdmrn
    wa sseq2 syl5ibr syl syl2anc pm2.43i ) ABZACADZEADZFZGZUBUCAHZIZUDAJZIZUBUF
    KZALAMUHUJPUEUGUIFZIZUKUCUGUDUINUBUFUMAULGAOUEULAQRSTUA @.

  @{
    @d x y A @.  @d y F @.
    dffn5a.1 @e |- F/_ x F @.
    @( Representation of a function in terms of its values.  (Contributed by
       FL, 14-Sep-2013.)  (Proof shortened by Mario Carneiro, 3-May-2015.) @)
    dffn5a @p |- ( F Fn A <->
                   F = { <. x , y >. | ( x e. A /\ y = ( F ` x ) ) } ) @=
      ( wfn cv cfv cmpt wceq wcel wa copab dffn5f df-mpt eqeq2i bitri ) DCFDACA
      GZDHZIZJDRCKBGSJLABMZJACDENTUADABCSOPQ @.
  @}

  @( A function's value belongs to its codomain.  (Contributed by FL,
     14-Sep-2013.) @)
  ffvelrnb @p |- ( ( A e. D /\ B e. E ) -> ( ( F e. ( B ^m A ) /\ C e. A )
    -> ( F ` C ) e. B ) ) @=
    ( wcel wa cmap co cfv wf wi wb elmapg ancoms ffvelrn ex syl6bi imp3a ) ADGZ
    BEGZHZFBAIJGZCAGZCFKBGZUCUDABFLZUEUFMUBUAUDUGNBAFEDOPUGUEUFABCFQRST @.

  @( opabssxp dfoprab2 @)

  @{
    @d x z A @.  @d x z B @.  @d y z B @.
    @( Existence of an existentially restricted class abstraction. ` ph ` is
       normally has free-variable parameters ` x ` , ` y ` , and ` z ` .
       Compare ~ abrexex2g .  (Contributed by FL, 6-Nov-2013.) @)
    ab2rexex2g @p |- ( ( A e. _V /\ B e. _V /\
         A. x e. A A. y e. B { z | ph } e. _V )
        -> { z | E. x e. A E. y e. B ph } e. _V ) @=
      ( cvv wcel cab wral w3a wrex simp1 wa simplr simpr jca ex abrexex2g syl6
      ralimdv 3impia syl2anc ) EGHZFGHZADIGHCFJZBEJZKUDACFLZDIGHZBEJZUHBELDIGHU
      DUEUGMUDUEUGUJUDUENZUFUIBEUKUFUEUFNZUIUKUFULUKUFNUEUFUDUEUFOUKUFPQRACDFGG
      STUAUBUHBDEGGSUC @.
  @}

  @{
    @d x A @.  @d x B @.  @d x C @.  @d x D @.
    @( Condition for a closed interval to be a subset of another closed
       interval.  See iccss (Contributed by FL, 29-May-2014.) @)
    iccss3 @p |- ( ( ( A e. RR* /\ B e. RR* ) /\ ( C e. RR* /\ D e. RR* ) /\
      ( A <_ C /\ D <_ B ) ) ->
        ( C [,] D ) C_ ( A [,] B ) ) @=
      ( vx cxr wcel wa cle wbr w3a cicc co cv simpr1 simpl1l simpl2l xrletrd wb
      elicc1 simpl3l simpr2 simpl2r simpl1r simpr3 simpl3r ex 3ad2ant2 3ad2ant1
      3jca 3imtr4d ssrdv ) AFGZBFGZHZCFGZDFGZHZACIJZDBIJZHZKZECDLMZABLMZVBENZFG
      ZCVEIJZVEDIJZKZVFAVEIJZVEBIJZKZVEVCGZVEVDGZVBVIVLVBVIHZVFVJVKVBVFVGVHOZVO
      ACVEUMUNURVAVIPUPUQUOVAVIQVPUSUTUOURVIUAVBVFVGVHUBRVOVEDBVPUPUQUOVAVIUCUM
      UNURVAVIUDVBVFVGVHUEUSUTUOURVIUFRUJUGURUOVMVISVACDVETUHUOURVNVLSVAABVETUI
      UKUL @.
  @}

  @( An element of a closed interval is more than or equal to its lower bound.
     (Contributed by FL, 29-May-2014.) @)
  iccleub2 @p |- ( ( A e. RR* /\ B e. RR* /\ C e. ( A [,] B ) ) -> A <_ C ) @=
    ( cxr wcel cicc co cle wbr wa w3a elicc1 simp2 syl6bi 3impia ) ADEZBDEZCABF
    GEZACHIZPQJRCDEZSCBHIZKSABCLTSUAMNO @.

  @( An element of a closed interval is less than or equal to its upper bound.
     (Contributed by FL, 29-May-2014.) @)
  iccleub3 @p |- ( ( A e. RR* /\ B e. RR* /\ C e. ( A [,] B ) )
      -> C e. RR* ) @=
    ( cxr wcel cicc co wa cle wbr w3a elicc1 simp1 syl6bi 3impia ) ADEZBDEZCABF
    GEZCDEZPQHRSACIJZCBIJZKSABCLSTUAMNO @.

  @( Absorption law for intersection.  (Contributed by FL, 30-May-2014.) @)
  inabs2 @p |- ( B i^i ( A u. B ) ) = B @=
    ( cun cin uncom ineq2i inabs eqtri ) BABCZDBBACZDBIJBABEFBAGH @.

  @{
    @d a b c x A @.  @d a b c z A @.  @d a b c x D @.  @d a b c x E @.
    @d a b c x F @.  @d b c x B @.  @d c x C @.  @d z B @.  @d z C @.
    @( Two ways of saying that two triples have no common element.
       (Contributed by FL, 29-May-2014.)  (Proof shortened by Mario Carneiro,
       26-Apr-2015.) @)
    inttpemp @p |- ( ( A e. G /\ B e. H /\ C e. I ) ->
    ( ( { A , B , C } i^i { D , E , F } ) = (/) <->
       ( ( A =/= D /\ A =/= E /\ A =/= F )
    /\ ( B =/= D /\ B =/= E /\ B =/= F )
    /\ ( C =/= D /\ C =/= E /\ C =/= F ) ) ) ) @=
      ( vx wceq wcel wn w3a wne w3o eleq1 cvv wb id ctp cin c0 cv wral disj vex
      syl6eqelr eltpg syl bitrd notbid ne3anior syl6bbr raltpg syl5bb ) ABCUAZD
      EFUAZUBUCKJUDZURLZMZJUQUEAGLBHLCILNADOAEOAFONZBDOBEOBFONZCDOCEOCFONZNJUQU
      RUFVAVBVCVDJABCGHIUSAKZVAADKAEKAFKPZMVBVEUTVFVEUTAURLZVFUSAURQVEARLVGVFSV
      EAUSRVETJUGZUHADEFRUIUJUKULADAEAFUMUNUSBKZVABDKBEKBFKPZMVCVIUTVJVIUTBURLZ
      VJUSBURQVIBRLVKVJSVIBUSRVITVHUHBDEFRUIUJUKULBDBEBFUMUNUSCKZVACDKCEKCFKPZM
      VDVLUTVMVLUTCURLZVMUSCURQVLCRLVNVMSVLCUSRVLTVHUHCDEFRUIUJUKULCDCECFUMUNUO
      UP @.
  @}

  @{
    @d f A @.  @d f B @.
    @( Two ways to express a subset of mappings.  (Contributed by FL,
       17-Nov-2014.) @)
    mapex2 @p |- ( ( A e. C /\ B e. D ) -> { f | ( f : A --> B /\ ph ) } =
        { f e. ( B ^m A ) | ph } ) @=
      ( wcel wa cv wf cab cin cmap co crab inab wceq mapvalg ineq1d a1i syl6eqr
      ancoms eqcomd abid2 eqcomi df-rab 3eqtrd syl5eqr ) BDGZCEGZHZBCFIZJZAHFKU
      MFKZAFKZLZAFCBMNZOZUMAFPUKUPUQUOLULUQGZFKZUOLZURUKUNUQUOUKUQUNUJUIUQUNQCB
      EDFRUBUCSUKUQUTUOUQUTQUKUTUQFUQUDUETSUKVAUSAHFKZURVAVBQUKUSAFPTAFUQUFUAUG
      UH @.
  @}

  @( Equality of a class difference and it subtrahend.  (For my private use
     only.  Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
  sssu @p |- ( ( B \ A ) = A <-> ( A = (/) /\ B = (/) ) ) @=
    ( cdif wceq c0 wa wss eqss wi ssdifeq0 cun ssundif id uneq12d eqtr ex sseq2
    un0 ss0b sylbi pm3.21 syl6bi syl6 ee10 pm2.43i syl5bir impcom difeq1 syl6eq
    com23 0dif eqcom biimpi sylan9eqr impbii ) BACZADZAEDZBEDZFZUQUPAGZAUPGZFUT
    UPAHVBVAUTVBURVAUTIABJVABAAKZGZURUTBAALURVDUTIZURVCEEKZDZVFEDZURVEIZURAEAEU
    RMZVJNERVGVHVCEDZVIVGVHVKVCVFEOPVKVDURUTVKVDBEGZURUTIZVCEBQVLUSVMBSUSURUATU
    BUJUCUDUEUFTUGTUSURUPEAUSUPEACEBEAUHAUKUIUREADAEULUMUNUO @.

  @( End of General Set Theory. @)


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The "maps to" notation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d A x y @.  @d B y @.
    cmpdom.1 @e |- F = ( x e. A |-> B ) @.
    @( Domain of a class given by the "maps to" notation.  (Contributed by FL,
       17-Feb-2008.) @)
    cmpdom @p |- ( A. x e. A B e. _V <-> dom F = A ) @=
      ( cvv wcel wral cdm wceq wfun funmpt2 wfn wa df-fn ancom 3bitr4i mpbiran2
      mptfng ) CFGABHZDIBJZDKZABCDELDBMUBUANTUAUBNDBOABCDESUAUBPQR @.
  @}

  @{
    @d A x @.
    cmpdom2.1 @e |- F = ( x e. A |-> ( B G C ) ) @.
    @( Domain of a class given by the "maps to" notation.  (Contributed by FL,
       21-Jun-2010.) @)
    cmpdom2 @p |- dom F = A @=
      ( co ovex dmmpti ) ABCDFHECDFIGJ @.
  @}

  @{
    @d A x y z @.  @d B x y z @.  @d C y z @.  @d F x z @.
    @( Functionality of an ordered-pair class abstraction given by the "maps
       to" notation.  (Contributed by FL, 17-May-2010.)  (Proof shortened by
       Mario Carneiro, 31-May-2014.) @)
    fopab2g @p |- ( F = ( x e. A |-> C ) ->
       ( A. x e. A C e. B <-> F : A --> B ) ) @=
      ( cmpt wceq wf wcel wral feq1 eqid fmpt syl6rbbr ) EABDFZGBCEHBCOHDCIABJB
      CEOKABCDOOLMN @.
  @}

  @{
    @d A x @.
    @( Composition of a restricted identity and a mapping (using the maps to
       notation).  See ~ fcoi1 .  (Contributed by FL, 25-Apr-2012.) @)
    crimmt1 @p |- ( F : A --> B -> ( F o. ( x e. A |-> x ) ) = F ) @=
      ( wf cv cmpt ccom cid cres mptresid coeq2i fcoi1 syl5eq ) BCDEDABAFGZHDIB
      JZHDOPDABKLBCDMN @.
  @}

  @{
    @d A x @.  @d B x @.
    @( Composition of a restricted identity and a mapping (using the maps to
       notation).  See ~ fcoi2 .  (Contributed by FL, 25-Apr-2012.) @)
    crimmt2 @p |- ( F : A --> B -> ( ( x e. B |-> x ) o. F ) = F ) @=
      ( wf cv cmpt ccom cid cres mptresid coeq1i fcoi2 syl5eq ) BCDEACAFGZDHICJ
      ZDHDOPDACKLBCDMN @.
  @}

  @{
    @d A f x @.  @d A1 f x @.  @d B f x @.  @d B1 f x @.  @d E f x @.
    @d F1 x @.  @d G f x @.
    injsurinj.1 @e |- F1 = ( f e. ( B ^m A ) |-> ( ( E o. f ) o. G ) ) @.
    @( Function returning a composite.  (Contributed by FL, 19-Nov-2011.) @)
    mapmapmap @p |- ( ( E : B --> B1 /\ G : A1 --> A /\
      ( ( A e. _V /\ B e. _V ) /\ ( A1 e. _V /\ B1 e. _V ) ) )
      -> F1 : ( B ^m A ) --> ( B1 ^m A1 ) ) @=
      ( vx wf cvv wcel wa wral ccom wi coexg syl adantr w3a cmap co wfn cfv fex
      cv expcom ad2antlr impcom 3adant2 vex sylancl ad2antrl com12 a1i 3imp jca
      ralrimivw ralimi mptfng sylib simpr syl2anc coeq2 coeq1d fvmptg simpl1 wb
      wceq pm3.22 3ad2ant3 elmapg biimpa simpl2 syl6 feq1 sylibrd adantl mpbird
      fco mpcom ralrimiva ffnfv sylanbrc ) BGDKZFAEKZALMZBLMZNZFLMZGLMZNZNZUAZH
      BAUBUCZUDZJUGZHUEZGFUBUCZMZJWPOWPWTHKWODCUGZPZEPZLMZCWPOZWQWOXCLMZELMZNZC
      WPOXFWOXICWPWOXGXHWODLMZXBLMXGWFWNXJWGWNWFXJWIWFXJQWHWMWFWIXJBGLDUFUHUIUJ
      UKZCULDXBLLRUMWFWGWNXHWGWNXHQQWFWNWGXHWKWGXHQWJWLWGWKXHFALEUFUHUNUOUPUQZU
      RUSXIXECWPXCELLRUTSCWPXDHIVAVBWOXAJWPWOWRWPMZNZXAFGWSKZWSDWRPZEPZVJZXNXOX
      NXMXQLMZXRWOXMVCXNXPLMZXHXSXNXJWRLMXTWOXJXMXKTJULDWRLLRUMWOXHXMXLTXPELLRV
      DCWRXDXQWPLHXBWRVJXCXPEXBWRDVEVFIVGVDXRXNFGXQKZXOXRXNAGXPKZWGNZYAXNYCQXRX
      NYBWGXNWFABWRKZYBWFWGWNXMVHWOXMYDWOWIWHNZXMYDVIWNWFYEWGWJYEWMWHWIVKTVLBAW
      RLLVMSVNABGDWRWAVDWFWGWNXMVOURUPFAGXPEWAVPFGWSXQVQVRWBXNWLWKNZXAXOVIWOYFX
      MWNWFYFWGWMYFWJWKWLVKVSVLTGFWSLLVMSVTWCJWPWTHWDWE @.
  @}

  @{
    @d A f x y @.  @d A1 f x y @.  @d B f x y @.  @d B1 f x y @.  @d E f x y @.
    @d F1 x y @.  @d G f x y @.
    injsuinj.1 @e |- F1 = ( f e. ( B ^m A ) |-> ( ( E o. f ) o. G ) ) @.
    @( If ` E ` is an injection and ` G ` a surjection
       ` ( f |-> ( ( E o. f ) o. G ) ) ` is an injection.  Bourbaki E.II.31
       prop. 2.  (Contributed by FL, 20-Nov-2011.) @)
    injsurinj @p |- ( ( E : B -1-1-> B1 /\ G : A1 -onto-> A
       /\ ( ( A e. _V /\ B e. _V ) /\ ( A1 e. _V /\ B1 e. _V ) ) )
        -> F1 : ( B ^m A ) -1-1-> ( B1 ^m A1 ) ) @=
      ( vx vy cvv wcel wa wf wceq wi ccom syl2anc 3ad2ant3 wf1 wfo w3a cmap cfv
      co cv wral f1f fof id mapmapmap syl3an simp1 adantr simprlr 3adant2 coexg
      fex vex sylancl 3ad2ant2 simp3rl coeq2 coeq1d fvmptg eqtr simp32 3ad2ant1
      wb elmapg ancoms biimpd impcom fco 3adant1 wfn ffn cocan2 syl3anc simpr31
      simp2 adantl cocan1 mpbid ex syl eqcoms com4t mpcom com12 ralrimivv dff13
      mpd 3expia sylanbrc ) BGDUAZFAEUBZALMZBLMZNZFLMZGLMZNZNZUCZBAUDUFZGFUDUFZ
      HOZJUGZHUEZKUGZHUEZPZXJXLPZQZKXGUHJXGUHXGXHHUAWQBGDOZWRFAEOZXEXEXIBGDUIZF
      AEUJZXEUKABCDEFGHIULUMXFXPJKXGXGXJXGMZXLXGMZNXFXPYAYBXFXPYAYBXFUCZXKDXJRZ
      ERZPZXPYCYAYELMZYFYAYBXFUNXFYAYGYBXFYDLMZELMZYGXFDLMZXJLMYHWQXEYJWRWQXENX
      QWTYJWQXQXEXSUOWQWSWTXDUPBGLDUSSUQZJUTDXJLLURVAXFXRXBYIWRWQXRXEXTVBXBXCXA
      WQWRVCFALEUSSZYDELLURSTCXJDCUGZRZERZYEXGLHYMXJPYNYDEYMXJDVDVEIVFSXMDXLRZE
      RZPZYCYFXPQYCYBYQLMZYRYAYBXFWBYCYPLMZYIYSYCYJXLLMYTXFYAYJYBYKTKUTDXLLLURV
      AXFYAYIYBYLTYPELLURSCXLYOYQXGLHYMXLPYNYPEYMXLDVDVEIVFSYFXNYRYCXOXNYRYCXOQ
      ZQZQYEXKYEXKPZXNUUBUUCXNNYEXMPZUUBYEXKXMVGUUDYRUUAUUDYRNYEYQPZUUAYEXMYQVG
      UUEYCXOUUEYCNZYDYPPZXOYCUUEUUGYCWRAGYDOZAGYPOZUUEUUGQYAYBWQWRXEVHYCXQABXJ
      OZUUHXFYAXQYBWQWRXQXEXSVITZYAXFUUJYBXFYAUUJXEWQYAUUJQZWRXAUULXDXAYAUUJWTW
      SYAUUJVJBAXJLLVKVLVMUOTVNUQZABGDXJVOSYCXQABXLOZUUIUUKYBXFUUNYAXFYBUUNXEWQ
      YBUUNQZWRXAUUOXDXAYBUUNWTWSYBUUNVJBAXLLLVKVLVMUOTVNVPZABGDXLVOSWRUUHUUIUC
      UUEUUGWRWRUUHYDAVQUUIYPAVQUUEUUGVJWRUKAGYDVRAGYPVRFAEYDYPVSUMVMVTVNUUFWQU
      UJUUNUUGXOVJWQWRXEYAYBUUEWAYCUUJUUEUUMWCYCUUNUUEUUPWCABGDXJXLWDVTWEWFWGWF
      WGWFWHWIWJWNWOWKWLJKXGXHHWMWP @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Cartesian Products
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  In what follows I will call nuple an element of a cartesian product.

  If ` X ` is a cartesian product, ` N ` a nuple of ` X ` , ` I ` an
  indice, ` ( ( X pr I ) `` N ) ` is the ` I ` th coordinate of the nuple
  ` N ` .

  Suppose the set of indices is ` { 1 , 2 } ` and ` X ` is the cartesian
  product
  ` { { <. 1 , a >. , <. 2 , u >. } , { <. 1 , a >. , <. 2 , v >. } } `
  then ` ( ( X pr 1 ) `` { <. 1 , a >. , <. 2 , u >. } ) = a ` and
  ` ( ( X pr 2 ) `` { <. 1 , a >. , <. 2 , u >. } ) = u ` .

@)

  @( Declare the projection symbol. @)
  @c pr @.

  @( Extend class notation to include the projection mapping. @)
  cpro @a class pr @.

  @( Declare the projection symbol. @)
  @c prj @.

  @( Extend class notation to include the projection mapping. @)
  cproj @a class prj @.

  @{
    @d x y f @.
    @( Definition of a projection (also called a coordinate mapping).
       Meaninful if ` x ` is a cartesian product and ` y ` is an index.
       (Contributed by FL, 19-Jun-2011.) @)
    df-pro @a |- pr = ( x e. _V , y e. _V |-> ( f e. x |-> ( f ` y ) ) ) @.
    @( Definition of a projection.  Meaninful if ` x ` is a cartesian product
       and ` y ` is a set of indices.  Suppose ` X = { { <. 1 , a >. , <. 2 , `
       ` u >. } , { <. 1 , a >. , <. 2 , v >. } } ` then
       ` ( X prj 1 ) = { a } ` and ` ( X prj 2 ) = { u , v } ` .  (Contributed
       by FL, 19-Jun-2011.) @)
    df-prj @a |- prj = ( x e. _V , y e. _V |-> ( f e. x |-> ( f |` y ) ) ) @.
  @}

  @{
    @d A f @.  @d B f @.  @d F f x @.
    @( The base class of the elements of a nuple.  (Contributed by FL,
       6-Jun-2011.)  (Revised by Mario Carneiro, 12-Aug-2016.) @)
    elixp2b @p |- ( F e. X_ x e. A B -> A. x e. A ( F ` x ) e. B ) @=
      ( vf cixp wcel cv cfv wral cab wfn df-ixp simpr ss2abi eqsstri sseli wceq
      wa fveq1 eleq1d ralbidv elabg mpbid ) DABCFZGDAHZEHZIZCGZABJZEKZGUFDIZCGZ
      ABJZUEUKDUEUGUFBGAKLZUJSZEKUKABCEMUPUJEUOUJNOPQUJUNEDUEUGDRZUIUMABUQUHULC
      UFUGDTUAUBUCUD @.
  @}

  @{
    @d A x @.  @d C x @.  @d F x @.  @d I x @.
    bcelnu.1 @e |- ( x = I -> B = C ) @.
    @( The base class of an element of a nuple.  (Contributed by FL,
       19-Jun-2011.) @)
    bclelnu @p |- ( ( F e. X_ x e. A B /\ I e. A ) -> ( F ` I ) e. C ) @=
      ( cixp wcel cv cfv wral elixp2b wceq fveq2 eleq12d rspccva sylan ) EABCHI
      AJZEKZCIZABLFBIFEKZDIZABCEMUAUCAFBSFNTUBCDSFEOGPQR @.
  @}

  @{
    @d I f g x y z @.  @d P f g x y z @.
    @( Definition of the coordinate mapping (or projection ) of index ` I ` .
       ` P ` is a cartesian product.  (Contributed by FL, 19-Jun-2011.)
       (Revised by Mario Carneiro, 23-Aug-2014.) @)
    ispr1 @p |- ( ( P e. V /\ I e. W ) -> ( P pr I ) =
                  ( f e. P |-> ( f ` I ) ) ) @=
      ( vx vy wcel wa cvv cv cfv cmpt cpro co wceq elex adantr adantl mptexg
      mpteq1 fveq2 mpteq2dv df-pro ovmpt2g syl3anc ) ADHZCEHZIAJHZCJHZBACBKZLZM
      ZJHZACNOUMPUGUIUHADQRUHUJUGCEQSUGUNUHBAULDTRFGACJJBFKZGKZUKLZMUMNBAUQMJBU
      OAUQUAUPCPBAUQULUPCUKUBUCFGBUDUEUF @.
  @}

  @{
    @d f x A @.  @d f x C @.  @d f x I @.  @d f P @.  @d f V @.
    prmapcp2.1 @e |- P = X_ x e. A B @.
    prmapcp2.2 @e |- ( x = I -> B = C ) @.
    @( A projection is a mapping from a cartesian product to an element of the
       family implied in the product.  Bourbaki E.II.34 cor. 1.  (Contributed
       by FL, 19-Jun-2011.) @)
    prmapcp2 @p |- ( ( P e. V /\ I e. A ) -> ( P pr I ) : P --> C ) @=
      ( vf wcel wa cpro co wf cv cfv cmpt cixp eleq2i biimpi simpr bclelnu eqid
      syl2anr fmptd ispr1 feq1d mpbird ) EGKZFBKZLZEDEFMNZOEDJEFJPZQZRZOULJEUOD
      UPUNEKZUNABCSZKZUKUODKULUQUSEURUNHTUAUJUKUBABCDUNFIUCUEUPUDUFULEDUMUPEJFG
      BUGUHUI @.
  @}

  @{
    @d F f g @.  @d I f g @.  @d P f g @.
    @( The ` I ` th coordinate of the nuple ` F ` .  (Contributed by FL,
       19-Jun-2011.) @)
    valpr @p |- ( ( P e. V /\ I e. W /\ F e. P )
      -> ( ( P pr I ) ` F ) = ( F ` I ) ) @=
      ( vf wcel cpro co cfv wceq wa cv cmpt ispr1 fveq1d fveq1 eqid fvex fvmpt
      sylan9eq 3impa ) ADGZCEGZBAGZBACHIZJZCBJZKUCUDLZUEUGBFACFMZJZNZJUHUIBUFUL
      AFCDEOPFBUKUHAULCUJBQULRCBSTUAUB @.
  @}

  @{
    @d f x A @.  @d f x F @.  @d f x P @.  @d f x Q @.
    npincppr.1 @e |- P = X_ x e. A B @.
    @( A set of nuples is included in the cartesian product of the projections
       of the nuples.  Bourbaki E.II.32.  (Contributed by FL, 20-Jun-2011.)
       (Proof shortened by Mario Carneiro, 31-May-2014.) @)
    npincppr @p |- ( ( F C_ P /\ P e. Q )
      -> F C_ X_ x e. A ( ( P pr x ) " F ) ) @=
      ( vf wss wcel wa cv cpro co cixp wfn cfv wceq syl2anc syl cima wral ssel2
      ciun wf adantlr syl6eleq ixpf ffn 3syl simplr simprr adantrr valpr simprl
      syl3anc wfun cdm cmpt fvex eqid fnmpti ispr1 fneq1d mpbiri fnfun eleqtrrd
      wi fndm funfvima mpd eqeltrrd anassrs ralrimiva vex elixp sylanbrc ssrdv
      ex ) FDIZDEJZKZHFABDALZMNZFUAZOZWBHLZFJZWGWFJZWBWHKZWGBPZWCWGQZWEJZABUBWI
      WJWGABCOZJBABCUDZWGUEWKWJWGDWNVTWHWGDJZWAFDWGUCUFZGUGABCWGUHBWOWGUIUJWJWM
      ABWBWHWCBJZWMWBWHWRKZKZWGWDQZWLWEWTWAWRWPXAWLRVTWAWSUKZWBWHWRULZWBWHWPWRW
      QUMZDWGWCEBUNUPWTWHXAWEJZWBWHWRUOWTWDUQZWGWDURZJWHXEVHWTWDDPZXFWTXHHDWLUS
      ZDPHDWLXIWCWGUTXIVAVBWTDWDXIWTWAWRWDXIRXBXCDHWCEBVCSVDVEZDWDVFTWTWGDXGXDW
      TXHXGDRXJDWDVITVGFWGWDVJSVKVLVMVNABWEWGHVOVPVQVSVR @.
  @}

  @{
    @d x y M @.  @d x A f a b @.  @d x f I a b @.  @d x f J a b @.  @d x y N @.
    @d B f a b @.  @d M a b @.  @d N a b @.
    repcpwti.1 @e |- A = { I , J } @.
    repcpwti.2 @e |- B = if ( x = I , M , N ) @.
    repcpwti.3 @e |- I e. C @.
    repcpwti.4 @e |- J e. D @.
    @( A representation of a cartesian product with two indices.  (Contributed
       by FL, 26-Jun-2011.)  (Proof shortened by Mario Carneiro,
       26-Apr-2015.) @)
    repcpwti @p |- ( I =/= J -> X_ x e. A B = { f | E. a e. M E. b e. N
                          f = { <. I , a >. , <. J , b >. } } ) @=
      ( wceq wcel wa cvv wne cv cop cpr wrex cixp wfn cfv wral vex elixp fneq2i
      wb a1i cif raleqi elexi fveq2 iftrue syl5eq eqeq1 ifbid ralpr bitri necom
      eleq12d wn df-ne iffalse sylbi eleq2d anbi2d syl5bb anbi12d biimpa preq1d
      eqeq2d preq2d rspc2ev 3expia syl5com expimpd pm3.2i mp3an12 adantr fvsn2a
      fnpr opeq2 fnprg simprl fvsn2b simprr jca32 fneq1 fveq1 eleq1d syl5ibrcom
      eqeltrd rexlimdvva impbid bitrd abbi2dv ) GHUAZFUBZGKUBZUCZHLUBZUCZUDZQZL
      JUEKIUEZFABCUFZXCXDXLRZXDGHUDZUGZGXDUHZIRZHXDUHZJRZSZSZXKXMXDBUGZAUBZXDUH
      ZCRZABUIZSXCYAABCXDFUJUKXCYBXOYFXTYBXOUMXCBXNXDMULUNYFXQXRHGQZIJUOZRZSZXC
      XTYFYEAXNUIYJYEABXNMUPYEXQYIAGHGDOUQZHEPUQZYCGQZYDXPCIYCGXDURYMCYMIJUOZIN
      YMIJUSUTVFYCHQZYDXRCYHYCHXDURYOCYNYHNYOYMYGIJYCHGVAVBUTVFVCVDXCYIXSXQXCYH
      JXRXCYGVGZYHJQXCHGUAYPGHVEHGVHVDYGIJVIVJVKVLVMVNVMXCYAXKXCXOXTXKXCXOSXDGX
      PUCZHXRUCZUDZQZXTXKXCXOYTXDGHYKYLWGVOXQXSYTXKXJYTXDYQXHUDZQKLXPXRIJXEXPQZ
      XIUUAXDUUBXFYQXHXEXPGWHVPVQXGXRQZUUAYSXDUUCXHYRYQXGXRHWHVRVQVSVTWAWBXCXJY
      AKLIJXCXEIRZXGJRZSZSZYAXJXIXNUGZGXIUHZIRZHXIUHZJRZSZSUUGUUHUUJUULXCUUHUUF
      GDRZHERZSXETRZXGTRZSXCUUHUUNUUOOPWCUUPUUQKUJZLUJZWCGHXEXGDETTWIWDWEUUGUUI
      XEIXCUUIXEQUUFGHXEXGDETTOPUURUUSWFWEXCUUDUUEWJWRUUGUUKXGJXCUUKXGQUUFGHXEX
      GDETTOPUURUUSWKWEXCUUDUUEWLWRWMXJXOUUHXTUUMXNXDXIWNXJXQUUJXSUULXJXPUUIIGX
      DXIWOWPXJXRUUKJHXDXIWOWPVNVNWQWSWTXAXB @.
  @}

  @{
    @( Warning: a b x distincts seem curious. @)
    @d A a b f x @.  @d B a b f @.  @d F c d e f y @.  @d F e f x y @.
    @d I a b c d e f @.  @d I a b e f x @.  @d I c d e f y @.
    @d J a b c d e f @.  @d J a b e f x @.  @d J c d e f y @.
    @d M a b c d e f @.  @d M a b e f x @.  @d M c d e f y @.
    @d N a b c d e f @.  @d N a b e f x @.  @d N c d e f y @.
    cbcpcp.1 @e |- A = { I , J } @.
    cbcpcp.2 @e |- B = if ( x = I , M , N ) @.
    cbcpcp.3 @e |- F = ( a e. M , b e. N |-> { <. I , a >. , <. J , b >. } ) @.
    cbcpcp.4 @e |- I e. C @.
    cbcpcp.5 @e |- J e. D @.
    @( The canonical bijection between a cross product and a cartesian product
       (whose set of indices is composed of two different elements).  Bourbaki
       E.II.33 .  (Contributed by FL, 26-Jun-2011.) @)
    cbcpcp @p |- ( I =/= J -> F : ( M X. N ) -1-1-onto-> X_ x e. A B ) @=
      ( wceq wi wa vy vf ve vc vd wne cxp wfn crn cixp cv cfv wral wf1o cop cpr
      cvv wcel prex rgen2w fnmpt2 mp1i wrex cab repcpwti rnmpt2 syl6reqr wex co
      elxp w3a df-ov opeq2 preq1d preq2d ovmpt2g eqtr wo opex preq12b elexi vex
      opth opeq12 ad2ant2l syl2anb a1d wn opth1 necon1ad jaoi sylbi com12 eqeq2
      adantr imbi1d syl5ibr syl ex eqcoms mpsyl mp3an3 eqeq1 imbi2d com3l ax-mp
      3expia fveq2 eqeq2d imbi12d exlimivv eqeq1d ralrimivv dff1o6 syl3anbrc
      imp ) GHUFZFIJUGZUHZFUIZABCUJZRAUKZFULZUAUKZFULZRZYBYDRZSZUAXRUMAXRUMXRYA
      FUNGKUKZUOZHLUKZUOZUPZUQURZLJUMKIUMXSXQYNKLIJYJYLUSUTKLIJYMFUQOVAVBXQYAUB
      UKZYMRLJVCKIVCUBVDXTABCDEUBGHIJKLMNPQVEKLUBIJYMFOVFVGXQYHAUAXRXRYBXRURZYD
      XRURZTXQYHYPYQXQYHSZYPYBUCUKZYOUOZRZYSIURZYOJURZTZTZUBVHUCVHYQYRSZUCUBYBI
      JVJUUEUUFUCUBUUAUUDUUFUUDUUFUUAYQXQYTFULZYERZYTYDRZSZSZSYQUUDUUKYQYDUDUKZ
      UEUKZUOZRZUULIURZUUMJURZTZTZUEVHUDVHUUDUUKSZUDUEYDIJVJUUSUUTUDUEUUOUURUUT
      UURUUTUUOUUDXQUUGUUNFULZRZYTUUNRZSZSZSZGYSUOZHYOUOZUPZUQURZUURUVFSUVGUVHU
      SUUDUVJUURUVEUUBUUCUVJUURUVESZYSYOFVIZUUGRUUBUUCUVJVKUVLUVIRZUVKYSYOFVLKL
      YSYOIJYMUVIFUVGYLUPUQYIYSRYJUVGYLYIYSGVMVNYKYORYLUVHUVGYKYOHVMVOOVPUVMUVK
      SUUGUVLUUGUVLRZUVMUVKUVNUVMTUUGUVIRZUVKUUGUVLUVIVQUURUVEUVOXQUVIUVARZUVCS
      ZSZUUPUUQGUULUOZHUUMUOZUPZUQURZUVRUVSUVTUSUULUUMFVIZUVARUUPUUQUWBVKUWCUWA
      RZUVRUULUUMFVLKLUULUUMIJYMUWAFUVSYLUPUQYIUULRYJUVSYLYIUULGVMVNYKUUMRYLUVT
      UVSYKUUMHVMVOOVPUWDUVRSUVAUWCUVAUWCRZUWDUVRUWEUWDTUVAUWARZUVRUVAUWCUWAVQX
      QUVQUWFUVIUWARZUVCSUWGXQUVCUWGUVGUVSRZUVHUVTRZTZUVGUVTRZUVHUVSRZTZVRXQUVC
      SZUVGUVHUVSUVTGYSVSHYOVSGUULVSHUUMVSVTUWJUWNUWMUWJUVCXQUWHGGRZYSUULRZTHHR
      ZYOUUMRZTUVCUWIGYSGUULGDPWAZUCWBZWCHYOHUUMHEQWAUBWBWCUWPUWRUVCUWOUWQYSYOU
      ULUUMWDWEWFWGUWKUWNUWLUWKUVCGHUWKGHRUVCWHGYSHUUMUWSUWTWIWGWJWOWKWLWMUWFUV
      PUWGUVCUVAUWAUVIWNWPWQWRWSWTXAXBUVOUVDUVQXQUVOUVBUVPUVCUUGUVIUVAXCWPXDWQW
      RWSWTXAXGXEXFUUOUUKUVEUUDUUOUUJUVDXQUUOUUHUVBUUIUVCUUOYEUVAUUGYDUUNFXHXIY
      DUUNYTWNXJXDXDWQXPXKWLWMUUAYRUUKYQUUAYHUUJXQUUAYFUUHYGUUIUUAYCUUGYEYBYTFX
      HXLYBYTYDXCXJXDXDWQXPXKWLXPWMXMAUAXRYAFXNXO @.
  @}

  @{
    @d I f g x y z @.  @d P f g x y z @.
    @( Definition of a projection. ` I ` is a set of indices. ` P ` is a
       cartesian product.  (Contributed by FL, 19-Jun-2011.)  (Revised by Mario
       Carneiro, 23-Aug-2014.) @)
    isprj1 @p |- ( ( P e. V /\ I e. W ) -> ( P prj I ) =
                   ( f e. P |-> ( f |` I ) ) ) @=
      ( vx vy wcel wa cvv cv cres cmpt cproj co wceq elex adantr adantl mptexg
      mpteq1 reseq2 mpteq2dv df-prj ovmpt2g syl3anc ) ADHZCEHZIAJHZCJHZBABKZCLZ
      MZJHZACNOUMPUGUIUHADQRUHUJUGCEQSUGUNUHBAULDTRFGACJJBFKZUKGKZLZMUMNBAUQMJB
      UOAUQUAUPCPBAUQULUPCUKUBUCFGBUDUEUF @.
  @}

  @{
    @d A x @.  @d I f g @.  @d P f g @.
    isprj2.1 @e |- P = X_ x e. A B @.
    @( Definition of a projection. ` I ` is a set of indices. ` P ` is a
       cartesian product.  (Contributed by FL, 19-Jun-2011.)  (Revised by Mario
       Carneiro, 26-Jan-2015.) @)
    isprj2 @p |- ( ( I e. V /\ A. x e. A B e. D ) ->
                   ( P prj I ) = ( f e. P |-> ( f |` I ) ) ) @=
      ( wcel wral cvv cproj co cv cres cmpt wceq cixp ixpexg syl5eqel id isprj1
      syl2anr ) CDJABKZELJGHJZEGMNFEFOGPQRUFUEEABCSLIABCDTUAUFUBEFGLHUCUD @.
  @}

  @{
    @d A f x y @.  @d B f y @.  @d C f @.  @d D f @.  @d I f x y @.
    @( A projection is a mapping from a cartesian product to one of its
       restriction.  (Contributed by FL, 19-Jun-2011.)  (Revised by Mario
       Carneiro, 26-Jan-2015.) @)
    prjmapcp @p |- ( ( I C_ A /\ A e. C /\ A. x e. A B e. D )
      -> ( X_ x e. A B prj I ) : X_ x e. A B --> X_ x e. I B ) @=
      ( vf wss wcel wral w3a cixp cproj co wf cv cres cmpt eqid cvv resixp wceq
      3ad2antl1 fmptd wa ssexg isprj2 sylan 3impa feq1d mpbird ) FBHZBDIZCEIABJ
      ZKZABCLZAFCLZUPFMNZOUPUQGUPGPZFQZRZOUOGUPUTUQVAULUMUSUPIUTUQIUNABFCUSUAUC
      VASUDUOUPUQURVAULUMUNURVAUBZULUMUEFTIUNVBFBDUFABCEUPGFTUPSUGUHUIUJUK @.
  @}

  @{
    @d f x y A @.  @d f y B @.  @d f x y C @.  @d f y V @.  @d f x y W @.
    cbicp.1 @e |- ( x = A -> B = C ) @.
    @( Canonical bijection between a cartesian product indexed by a singleton
       and the base class of the elements of the 1-uple.  Bourbaki E II.32
       (Contributed by FL, 6-Jun-2011.)  (Proof shortened by Mario Carneiro,
       31-May-2014.) @)
    cbicp @p |- ( ( A e. V /\ C e. W ) ->
                  ( X_ x e. { A } B pr A ) : X_ x e. { A } B -1-1-onto-> C ) @=
      ( vf wcel wa csn wf1o cv cfv syl2anc wral syl wceq wf cvv vy cixp cpro co
      cmpt cop eqid simpr snidg ad2antrr bclelnu wfn f1osng f1ofn eqeq1d ralsng
      adantlr mpbiri wss f1of snssi fss ffvelrn ralrimiva eleq2 biimprd ral2imi
      adantl sylc elixp sylanbrc fvsng ad2ant2rl eqcomd fveq1 eqeq2d syl5ibrcom
      snex simpll ixpfn ad2antrl dffn2 sylib sneq feq2d fveq2 eleq1d id opeq12d
      sneqd anbi12d vex fsn2 vtoclbg biimpa simprd opeq2 impbid f1o2d wb ixpexg
      biimpar simpl ispr1 f1oeq1 mpbird ) BEIZDFIZJZABKZCUBZDXKBUCUDZLZXKDHXKBH
      MZNZUEZLZXIHUAXKDXOBUAMZUFZKZXPXPUGXIXNXKIZJYABXJIZXODIXIYAUHXGYBXHYABEUI
      UJAXJCDXNBGUKOXIXRDIZJZXTXJULZAMZXTNZCIZAXJPZXTXKIYDXJXRKZXTLZYEXGYCYKXHB
      XREDUMUQZXJYJXTUNQYDCDRZAXJPZYGDIZAXJPZYIXGYNXHYCXGYNDDRZDUGYMYQABEYFBRZC
      DDGUOUPURUJYDXJDXTSZYPYDXJYJXTSZYJDUSZYSYDYKYTYLXJYJXTUTQYCUUAXIXRDVAVHXJ
      YJDXTVBOYSYOAXJXJDYFXTVCVDQYMYOYHAXJYMYHYOCDYGVEVFVGVIAXJCXTXSVRVJVKXIYAY
      CJZJZXNXTRZXRXORZUUCUUEUUDXRBXTNZRUUCUUFXRXGYCUUFXRRXHYABXREDVLVMVNUUDXOU
      UFXRBXNXTVOVPVQUUCUUDUUEXNBXOUFZKZRZUUCXOTIZUUIUUCXGXJTXNSZUUJUUIJZXGXHUU
      BVSUUCXNXJULZUUKYAUUMXIYCAXJCXNVTWAXJXNWBWCXGUUKUULYFKZTXNSYFXNNZTIZXNYFU
      UOUFZKZRZJUUKUULABEYRUUNXJTXNYFBWDWEYRUUPUUJUUSUUIYRUUOXOTYFBXNWFZWGYRUUR
      UUHXNYRUUQUUGYRYFBUUOXOYRWHUUTWIWJVPWKYFTXNAWLWMWNWOOWPUUEXTUUHXNUUEXSUUG
      XRXOBWQWJVPVQWRWSXIXLXPRZXMXQWTXIXKTIZXGUVAXICFIZAXJPZUVBXGUVDXHUVCXHABEY
      RCDFGWGUPXBAXJCFXAQXGXHXCXKHBTEXDOXKDXLXPXEQXF @.
  @}

  @{
    @d A f h x @.  @d B f h x @.  @d B g x @.  @d C f h @.  @d C g @.
    @d G f h @.  @d G g @.  @d G x @.
    prl.1 @e |- A e. D @.
    @( Existence of a "prolongement" of a cartesian product.  Bourbaki E.II.34
       prop. 6.  (Contributed by FL, 7-Nov-2011.) @)
    prl @p |- ( ( A. x e. A C =/= (/) /\ B C_ A /\ G e. X_ x e. B C )
     -> E. f e. X_ x e. A C G C_ f ) @=
      ( vh cv cixp wcel wex c0 wne wss w3a wi a1d exlimiv cdif wral elexi difss
      wrex ac9s n0 wa cres resixp eleq1 spcegv sylc mpan sylbi 3adant3 undifixp
      imp cun ssun1 sseq2 rspcev mpan2 syl 3exp com34 com4t 3imp com12 mpcom )
      IJZABCUAZDKZLZIMZDNOABUBZCBPZGACDKLZQZGFJZPZFABDKZUEZVPVQVOVRVPVQVOVPWBNO
      ZVQVORZABDBEHUCUFWDVTWBLZFMWEFWBUGWFWEFWFVOVQVLBPZWFVOBCUDWGWFUHVTVLUIZVM
      LZWIVOABVLDVTUJZWJVNWIIWHVMVKWHVMUKULUMUNSTUOUOURUPVNVSWCRIVSVNWCVPVQVRVN
      WCRVRVNVPVQWCVRVNVQVPWCVRVNVQVPWCRZVRVNVQQGVKUSZWBLZWKABCDGVKUQWMWCVPWMGW
      LPZWCGVKUTWAWNFWLWBVTWLGVAVBVCSVDVEVFVGVHVITVJ @.
  @}

  @{
    @d A g @.  @d B f g @.  @d C g @.  @d f g x @.  @d A f @.  @d A x @.
    @d B x @.  @d C f @.
    prl1.1 @e |- A e. D @.
    @( Existence of a "prolongement" of a cartesian product.  Bourbaki E.II.34
       prop. 6.  (Contributed by FL, 20-Nov-2011.) @)
    prl1 @p |- ( ( A. x e. A C =/= (/) /\ B C_ A )
     -> A. g e. X_ x e. B C E. f e. X_ x e. A C g C_ f ) @=
      ( c0 wne wral wss wa cv cixp wrex wcel prl 3expia ralrimiv ) DIJABKZCBLZM
      GNZFNLFABDOPZGACDOZUAUBUCUEQUDABCDEFUCHRST @.
  @}

  @{
    @d A f g @.  @d B f g u @.  @d C f g @.  @d f g x @.  @d A x @.  @d B x @.
    prl2.1 @e |- A e. D @.
    @( Existence of a "prolongement" of a cartesian product.  Bourbaki E.II.34
       prop. 6.  (Contributed by FL, 20-Nov-2011.) @)
    prl2 @p |- ( ( A. x e. A C =/= (/) /\ B C_ A )
     -> A. g e. X_ x e. B C E. f e. X_ x e. A C g = ( f |` B ) ) @=
      ( vu wral wss wa cv wceq wrex wcel cfv wfn wi com12 c0 wne cres cixp prl1
      cdm ixpfn fndm wfun fnfun w3a fvres eleq2 eqcomd 3exp com13 syl6bi eqcoms
      funssfv com24 3imp eqeq2 imbi2d mpcom ancld ralrimiv ssid jctil reximdvai
      syl5ibr 3syl ralimia syl ad2antlr fnssresb biimprcd syl5 eqfnfv3 rexbidva
      wb imp syl2anc ralbidva mpbird ) DUAUBABJZCBKZLZGMZFMZCUCZNZFABDUDZOZGACD
      UDZJCCKZIMZCPZWPWHQZWPWJQZNZLZICJZLZFWLOZGWNJZWGWHWIKZFWLOZGWNJXEABCDEFGH
      UEXGXDGWNWHWNPZWHCRZWHUFZCNZXGXDSACDWHUGZCWHUHXKXFXCFWLWIWLPZXKXFXCSZXMWI
      BRZWIUIZXKXNSABDWIUGZBWIUJXPXKXFXCXPXKXFUKZXBWOXRXAICXRWQWTWQXRWTWSWPWIQZ
      NZWQXRWTSZWPCWIULWQYAXTXRWRXSNZSXRWQYBXPXKXFWQYBSZXKXPXFYCSXKWQXFXPYBWQXF
      XPYBSSZSCXJCXJNWQWPXJPZYDCXJWPUMXPXFYEYBXPXFYEYBXPXFYEUKXSWRWPWIWHUSUNUOU
      PUQURUTTVATXTWTYBXRWSXSWRVBVCVJVDTVEVFCVGVHUOVKTVIVKVLVMWGWMXDGWNWGXHLZWK
      XCFWLYFXMLXIWJCRZWKXCVTXHXIWGXMXLVNYFXMYGXMXOYFYGXQWFXOYGSWEXHXOYGWFBCWIV
      OVPVNVQWAICCWHWJVRWBVSWCWD @.
  @}

  @{
    @d A a f x y @.  @d A f u v x @.  @d B a f y @.  @d B f u v @.  @d C f y @.
    @d D a f y @.  @d I a f x y @.  @d I f u v x @.
    @( A projection is a mapping from a cartesian product onto one of its
       restriction.  Bourbaki E.II.33 prop. 5.  (Contributed by FL,
       20-Nov-2011.)  (Revised by Mario Carneiro, 31-May-2014.) @)
    prjmapcp2 @p |- ( ( I C_ A /\ A e. C /\
      ( A. x e. A B e. D /\ A. x e. A B =/= (/) ) )
      -> ( X_ x e. A B prj I ) : X_ x e. A B -onto-> X_ x e. I B ) @=
      ( vy vf va vu wss wcel wral wa cixp cv wceq wrex wi cvv wne w3a cproj cfv
      c0 co wf wfo prjmapcp 3adant3r sseq2 raleq anbi12d ixpeq1 rexeqdv ralbidv
      cres imbi12d pm3.2 adantl vex prl2 syl6com vtoclg com12 3imp cmpt simpl3l
      ixpexg ssexg 3adant3 adantr isprj1 syl2anc fveq1d reseq1 eqid resex fvmpt
      syl eqtrd eqeq2d rexbidva mpbird dffo3 sylanbrc ) FBKZBDLZCELZABMZCUEUAZA
      BMZNZUBZABCOZAFCOZWOFUCUFZUGZGPZHPZWQUDZQZHWORZGWPMZWOWPWQUHWGWHWJWRWLABC
      DEFUIUJWNXDWSWTFUQZQZHWORZGWPMZWGWHWMXHWHWGWMXHSZFIPZKZWIAXJMZWKAXJMZNZXF
      HAXJCOZRZGWPMZSZSWGXISIBDXJBQZXKWGXRXIXJBFUKXSXNWMXQXHXSXLWJXMWLWIAXJBULW
      KAXJBULUMXSXPXGGWPXSXFHXOWOAXJBCUNUOUPURURXNXKXMXKNZXQXMXKXTSXLXMXKUSUTAX
      JFCTHGIVAVBVCVDVEVFWNXCXGGWPWNXBXFHWOWNWTWOLZNZXAXEWSYBXAWTJWOJPZFUQZVGZU
      DZXEYBWTWQYEYBWOTLZFTLZWQYEQYBWJYGWJWLWGWHYAVHABCEVIVTWNYHYAWGWHYHWMFBDVJ
      VKVLWOJFTTVMVNVOYAYFXEQWNJWTYDXEWOYEYCWTFVPYEVQWTFHVAVRVSUTWAWBWCUPWDHGWO
      WPWQWEWF @.
  @}

  @{
    @d A f x z @.  @d B f y z @.  @d C f z @.  @d D y z @.  @d X z @.
    @d x y z @.
    dstr.1 @e |- ( y = ( f ` x ) -> C = D ) @.
    dstr.2 @e |- X = X_ x e. A B @.
    dstr.3 @e |- A e. E @.
    @( Distribution of union over intersection.  Bourbaki E.II.35 prop. 8.
       (Contributed by FL, 18-Jun-2011.) @)
    dstr @p |- U_ x e. A |^|_ y e. B C = |^|_ f e. X U_ x e. A D @=
      ( vz cv wcel wrex wral ralimi 3imtr4i wn ciin ciun wi cixp elixp2b eleq2d
      cfv wceq rspcv rexim 3syl eleq2s com12 ralrimiv cvv wb eliin ax-mp rexbii
      vex eliun ralbii crab c0 wne rabn0 biimpri wex wss ss2ixp ssrab2 a1i mprg
      wa n0 sseli syl6eleqr notbid elrab simprbi syl jca eximi sylbi elexi ac9s
      df-rex rexnal ralnex 3imtr3i con4i impbii eqriv ) MACBDEUAZUBZGIACFUBZUAZ
      MNZWOOZWRWQOZWRWNOZACPZWRWPOZGIQZWSWTWREOZBDQZACPZWRFOZACPZGIQZXBXDXGXIGI
      GNZIOZXGXIXGXIUCZXKACDUDZIXKXNOANZXKUGZDOZACQXFXHUCZACQXMACDXKUEXQXRACXEX
      HBXPDBNXPUHZEFWRJUFZUIRXFXHACUJUKKULUMUNXAXFACWRUOOZXAXFUPMUTZBWRDEUOUQUR
      USZXCXIGIAWRCFVAVBZSAWRCWNVAZYAWTXDUPYBGWRIWPUOUQURZSXDXBWTWSXJXGXDXBXGXJ
      XFTZACQZXITZGIPZXGTXJTXETZBDPZACQZXHTZACQZGIPZYHYJYMYKBDVCZVDVEZACQZYPYLY
      RACYRYLYKBDVFVGRACYQUDZVDVEZXLYOVNZGVHZYSYPUUAXKYTOZGVHUUCGYTVOUUDUUBGUUD
      XLYOUUDXKXNIYTXNXKYQDVIZYTXNVIACACYQDVJUUEXOCOYKBDVKVLVMVPKVQUUDXPYQOZACQ
      YOACYQXKUEUUFYNACUUFXQYNYKYNBXPDXSXEXHXTVRVSVTRWAWBWCWDACYQCHLWEWFYOGIWGS
      WAYLYGACXEBDWHVBYOYIGIXHACWIUSWJXFACWIXIGIWHWJWKYDYCSYFYESWLWM @.

  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Operations on subsets and functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c cset @.

  @( Extend class notation with an operator that derives an operation on
     subsets of a set from an operation on the elements of this set. @)
  ccst @a class cset @.

  @{
    @d g h x y z a u v @.
    @( Define an operation on the subsets derived from an operation ` g ` on
       the elements.  Meaningful if ` g ` is a binary internal operation.
       (Contributed by FL, 18-Apr-2010.) @)
    df-cst @a |- cset = ( g e. _V |->
      ( x e. ~P dom dom g , y e. ~P dom dom g |->
          ran ( u e. x , v e. y |-> ( u g v ) ) ) ) @.
  @}

  @{
    iscst1.1 @e |- X = dom dom G @.
    iscst1.2 @e |- H = ( cset ` G ) @.
    @{
      @d G a g h u v x y z @.  @d X g h x y z @.
      @( An operation on the subsets derived from an operation on the
         elements.  (Contributed by FL, 18-Apr-2010.)  (Revised by Mario
         Carneiro, 10-Sep-2015.) @)
      iscst1 @p |- ( G e. A -> H = ( x e. ~P X , y e. ~P X |->
           ran ( u e. x , v e. y |-> ( u G v ) ) ) ) @=
        ( vg wcel ccst cpw cv co cmpt2 crn cvv cdm cfv wceq elex dmexg syl5eqel
        pwexg 3syl mpt2exga syl2anc dmeq dmeqd pweqd w3a simp1 oveqd mpt2eq3dva
        syl6eqr rneqd mpt2eq123dv df-cst fvmptg syl5eq ) FELZGFMUAZABHNZVEDCAOZ
        BOZDOZCOZFPZQZRZQZJVCFSLVMSLZVDVMUBFEUCVCVESLZVOVNVCFTZSLZHSLVOFEUDVQHV
        PTZSIVPSUDUEHSUFUGZVSABVEVEVLSSUHUIKFABKOZTZTZNZWCDCVFVGVHVIVTPZQZRZQVM
        SSMVTFUBZABWCWCWFVEVEVLWGWBHWGWBVRHWGWAVPVTFUJUKIUQULZWHWGWEVKWGDCVFVGW
        DVJWGVHVFLZVIVGLZUMVTFVHVIWGWIWJUNUOUPURUSABCDKUTVAUIVB @.
    @}

    @{
      @d u v x y A @.  @d u v x y B @.  @d u v x y G @.  @d x y M @.
      @d x y X @.
      @( The value of the couple ` <. A , B >. ` through the derived
         operation.  (Contributed by FL, 18-Apr-2010.)  (Revised by Mario
         Carneiro, 10-Sep-2015.) @)
      iscst2 @p |- ( ( G e. M /\ A e. ~P X /\ B e. ~P X ) ->
        ( A H B ) = ran ( u e. A , v e. B |-> ( u G v ) ) ) @=
        ( vx vy wcel cpw cv cmpt2 crn cvv wceq wa w3a co iscst1 3ad2ant1 adantl
        mpt2eq12 rneqd simp2 simp3 mpt2exga 3adant1 rnexg syl ovmpt2d ) EGMZCHN
        ZMZDUPMZUAZKLCDUPUPBAKOZLOZBOAOEUBZPZQZBACDVBPZQZFRUOUQFKLUPUPVDPSURKLA
        BGEFHIJUCUDUSUTCSVADSTZTVCVEVGVCVESUSBAUTVACDVBUFUEUGUOUQURUHUOUQURUIUS
        VERMZVFRMUQURVHUOBACDVBUPUPUJUKVERULUMUN @.
    @}

    @{
      @d A a u v @.  @d B a u v @.  @d C a u v @.  @d G a u v @.
      @( Property equivalent to the fact of belonging to the value of a pair
         through the derived operation.  (Contributed by FL, 18-Apr-2010.) @)
      iscst3 @p |- ( ( G e. M /\ A e. ~P X /\ B e. ~P X ) ->
        ( C e. ( A H B ) <->
           E. u e. A E. v e. B C = ( u G v ) ) ) @=
        ( wcel cpw w3a co cv cmpt2 crn wceq wrex iscst2 eleq2d eqid ovex syl6bb
        elrnmpt2 ) FHLCIMZLDUGLNZECDGOZLEBACDBPZAPZFOZQZRZLEULSADTBCTUHUIUNEABC
        DFGHIJKUAUBBACDULEUMUMUCUJUKFUDUFUE @.
    @}

    @{
      @d a x y z A @.  @d a x y B @.  @d a x y z G @.  @d a x M @.  @d a x X @.
      @d a H @.
      @( The value of the couple ` <. A , B >. ` through the derived operation
         ` H ` (expressed with a union).  (Contributed by FL, 31-Dec-2010.)
         (Revised by Mario Carneiro, 10-Sep-2015.) @)
      iscst4 @p |- ( ( G e. M /\ A e. ~P X /\ B e. ~P X )
        -> ( A H B ) = U_ x e. B ( A H { x } ) ) @=
        ( va vy vz wcel cpw w3a co cv wceq wrex iscst3 ciun wa wb simpl1 simpl2
        csn wss elpwi 3ad2ant3 sselda snelpwi syl3anc oveq2 eqeq2d rexsn rexbii
        syl vex syl6bb rexbidva eliun rexcom 3bitr4g bitr4d eqrdv ) DFMZBGNZMZC
        VGMZOZJBCEPZACBAQZUFZEPZUAZVJJQZVKMVPKQZVLDPZRZACSKBSZVPVOMZAKBCVPDEFGH
        ITVJVPVNMZACSVSKBSZACSWAVTVJWBWCACVJVLCMZUBZWBVPVQLQZDPZRZLVMSZKBSZWCWE
        VFVHVMVGMZWBWJUCVFVHVIWDUDVFVHVIWDUEWEVLGMWKVJCGVLVIVFCGUGVHCGUHUIUJVLG
        UKUQLKBVMVPDEFGHITULWIVSKBWHVSLVLAURWFVLRWGVRVPWFVLVQDUMUNUOUPUSUTAVPCV
        NVAVSKABCVBVCVDVE @.
    @}
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    3timesi.1 @e |- A e. CC @.
    @( Three times a number.  (Contributed by FL, 17-Oct-2010.) @)
    3timesi @p |- ( 3 x. A ) = ( A + ( A + A ) ) @=
      ( c3 cmul co c2 c1 df-3 oveq1i 2cn ax-1cn adddiri 2timesi mulid2i oveq12i
      caddc addassi eqtri ) CADEFGPEZADEZAAAPEZPEZCSADHITFADEZGADEZPEZUBFGAJKBL
      UEUAAPEUBUCUAUDAPABMABNOAAABBBQRRR @.
  @}

  @{
    @d N x y z @.
    @( Two ways to define ` n ZZ ` .  In the first way I multiply the set
       ` { N } ` by the set ` ZZ ` ( I think this is this sort of
       multiplication that is at the origin of the denotation ` n ZZ ` ).  In
       the second way I multiply the integer ` N ` by an element of ` ZZ ` .
       (Contributed by FL, 18-Apr-2010.)  (Proof shortened by Mario Carneiro,
       10-Sep-2015.) @)
    nZdef @p |- ( N e. ZZ -> ( { N } ( cset ` ( x. |` ( ZZ X. ZZ ) ) ) ZZ ) =
      { x | E. y e. ZZ x = ( N x. y ) } ) @=
      ( vz cz wcel cv cmul co wceq wrex cxp cvv cc wf wss zsscn mp2an zex cdm
      csn cres ccst cfv cpw wb snelpwi ax-mulf xpss12 xpex cnex fex2 mp3an pwid
      fssres fdmi dmeqi dmxpid eqtr2i eqid iscst3 mp3an13 eqeq2d rexbidv rexsng
      syl oveq1 wa ovres rexbidva 3bitrd abbi2dv ) CEFZAGZCBGZHIZJZBEKZACUAZEHE
      ELZUBZUCUDZIZVMVNWCFZVNDGZVOWAIZJZBEKZDVSKZVNCVOWAIZJZBEKZVRVMVSEUEZFZWDW
      IUFZCEUGWAMFZWNEWMFWOVTNWAOZVTMFNMFWPNNLZNHOVTWRPZWQUHENPZWTWSQQENENUIRWR
      NVTHUORZEESSUJUKVTNWAMMULUMESUNBDVSEVNWAWBMEWATZTVTTEXBVTVTNWAXAUPUQEURUS
      WBUTVAVBVFWHWLDCEWECJZWGWKBEXCWFWJVNWECVOWAVGVCVDVEVMWKVQBEVMVOEFVHWJVPVN
      CVOEEHVIVCVJVKVL @.
  @}

  @( { ... -4 , -3 , -2 , -1 , 0 , 1 , 2 , 3 , 4 ... } / { ... , -4 , -2 , 0 ,
      2 , 4 , ... } @)

  @( Z/2Z will return { ... , -4 , -2 , 0 , 2 , 4 ... } and
                      { ... , -3 , -1 , 0 , 1 , 3 , ... } @)


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Lattice (algebraic definition)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c LatAlg @.

  @( Extend class notation to include the class of lattices. @)
  clatalg @a class LatAlg @.

  @{
    @d j m t x y z @.
    @( Algebraic definition of a lattice. ` j ` is called the join of the
       lattice (and is denoted by ` \/ ` in textbooks) , ` m ` is called the
       meet (and is denoted by ` /\ ` in textbooks).  (Contributed by FL,
       11-Dec-2009.) @)
    df-latalg @a |- LatAlg = { <. j , m >. | E. t ( j : ( t X. t ) --> t /\
    m : ( t X. t ) --> t /\
    A. x e. t A. y e. t ( ( x j y ) = ( y j x ) /\ ( x m y ) = ( y m x ) /\
     ( ( x m ( x j y ) ) = x /\ ( x j ( x m y ) ) = x /\
     A. z e. t ( ( x m ( y m z ) ) = ( ( x m y ) m z ) /\
                 ( x j ( y j z ) ) = ( ( x j y ) j z ) ) ) ) ) } @.
  @}

  @{
    @d J j m t x y z @.  @d M j m x y z @.  @d X j m t x y z @.
    islatalg.1 @e |- X = dom dom J @.
    @( The predicate "is a lattice".  (Contributed by FL, 11-Dec-2009.) @)
    islatalg @p |- ( ( J e. A /\ M e. B ) -> ( <. J , M >. e. LatAlg <->
   ( J : ( X X. X ) --> X /\ M : ( X X. X ) --> X /\
    A. x e. X A. y e. X ( ( x J y ) = ( y J x ) /\ ( x M y ) = ( y M x ) /\
     ( ( x M ( x J y ) ) = x /\ ( x J ( x M y ) ) = x /\
     A. z e. X ( ( x M ( y M z ) ) = ( ( x M y ) M z ) /\
                 ( x J ( y J z ) ) = ( ( x J y ) J z ) ) ) ) ) ) ) @=
      ( vt wcel wa cv wf co wceq wral w3a oveq cvv vj cop clatalg cxp wex copab
      df-latalg a1i eleq2d cdm fdm dmxpid dmeq syl5eqr eqcoms 3ad2ant1 pm4.71ri
      vm wb syl exbii dmeqd eqeq2d feq1 eqeq12d oveq2d eqeq1d id eqidd oveq123d
      anbi2d ralbidv 3anbi123d 3anbi13d anbi12d exbidv eqcomi eqeq2i anbi1d vex
      2ralbidv bitrd dmex eleq1 biimpd eleq1i syl6ib ee10 xpeq12 anidms mpancom
      feq23 raleq 3anbi3d raleqbi1dv ceqsexgv 3bitrd 3anbi23d opelopabg ) FDKGE
      KLZFGUBZUCKXAJMZXBUDZXBUAMZNZXCXBURMZNZAMZBMZXDOZXIXHXDOZPZXHXIXFOZXIXHXF
      OZPZXHXJXFOZXHPZXHXMXDOZXHPZXHXICMZXFOZXFOZXMXTXFOZPZXHXIXTXDOZXDOZXJXTXD
      OZPZLZCXBQZRZRZBXBQAXBQZRZJUEZUAURUFZKHHUDZHFNZYQHGNZXHXIFOZXIXHFOZPZXHXI
      GOZXIXHGOZPZXHYTGOZXHPZXHUUCFOZXHPZXHXIXTGOZGOZUUCXTGOZPZXHXIXTFOZFOZYTXT
      FOZPZLZCHQZRZRZBHQAHQZRZWTUCYPXAUCYPPWTABCJUAURUGUHUIYOYRYQHXFNZUUBXOXHYT
      XFOZXHPZXHXMFOZXHPZYDUUQLZCHQZRZRZBHQZAHQZRZUVCUAURFGDEXDFPZYOXBXDUJZUJZP
      ZYNLZJUEZXBHPZXCXBFNZXGUUBXOUVFUVHUVICXBQZRZRZBXBQZAXBQZRZLZJUEZUVOYOUWAU
      SUVPYNUVTJYNUVSXEXGUVSYMXEUVQXCPUVSXCXBXDUKUVSXCUVQXCUVQPXBXCUJUVRXBULXCU
      VQUMUNUOUTUPUQVAUHUVPUWAXBFUJZUJZPZUWILZJUEUWKUVPUVTUWOJUVPUVSUWNYNUWIUVP
      UVRUWMXBUVPUVQUWLXDFUMVBZVCUVPXEUWCYMUWHXGXCXBXDFVDUVPYLUWFABXBXBUVPXLUUB
      YKUWEXOUVPXJYTXKUUAXHXIXDFSZXIXHXDFSVEUVPXQUVFXSUVHYJUWDUVPXPUVEXHUVPXJYT
      XHXFUWQVFVGUVPXRUVGXHXHXMXDFSVGUVPYIUVICXBUVPYHUUQYDUVPYFUUOYGUUPUVPXHXHY
      EUUNXDFUVPVHZUVPXHVIXIXTXDFSVJUVPXJYTXTXTXDFUWRUWQUVPXTVIVJVEVKVLVMVNWAVN
      VOVPUVPUWOUWJJUVPUWNUWBUWIUWNUWBUSUVPUWMHXBHUWMIVQZVRUHVSVPWBUVPHTKZUWKUV
      OUSUVPUVRUWMPZUVRTKZUWTUWPUVQXDUAVTWCWCUXAUXBUWMTKZUWTUXAUXBUXCUVRUWMTWDW
      EUWMHTUWSWFWGWHUWIUVOJHTUWBUWCYRXGUVDUWHUVNXCYQPZUWBUWCYRUSUWBUXDXBHXBHWI
      WJZXCXBYQHFWLWKUXDUWBXGUVDUSUXEXCXBYQHXFWLWKUWGUVMAXBHUWFUVLBXBHUWBUWEUVK
      UUBXOUWBUWDUVJUVFUVHUVICXBHWMWNWNWOWOVMWPUTWQXFGPZUVDYSUVNUVBYRYQHXFGVDUX
      FUVLUVAABHHUXFXOUUEUVKUUTUUBUXFXMUUCXNUUDXHXIXFGSZXIXHXFGSVEUXFUVFUUGUVHU
      UIUVJUUSUXFUVEUUFXHXHYTXFGSVGUXFUVGUUHXHUXFXMUUCXHFUXGVFVGUXFUVIUURCHUXFY
      DUUMUUQUXFYBUUKYCUULUXFXHXHYAUUJXFGUXFVHZUXFXHVIXIXTXFGSVJUXFXMUUCXTXTXFG
      UXHUXGUXFXTVIVJVEVSVLVMWRWAWRWSWB @.
  @}

  @{
    @d J x y z @.  @d M x y z @.  @d X x y z @.
    jop1 @e |- X = dom dom J @.
    @{
      @( Join is a binary internal operation.  (Contributed by FL,
         12-Dec-2009.) @)
      jop @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> J : ( X X. X ) --> X ) @=
        ( vx vy vz wcel cop clatalg cxp wf wa cv co wceq wral w3a syl6bi 3impia
        islatalg simp1 ) CAJZDBJZCDKLJZEEMZECNZUEUFOUGUIUHEDNZGPZHPZCQZULUKCQRU
        KULDQZULUKDQRUKUMDQUKRUKUNCQUKRUKULIPZDQDQUNUODQRUKULUOCQCQUMUOCQROIEST
        THESGESZTUIGHIABCDEFUCUIUJUPUDUAUB @.
    @}

    @{
      @d J x y z @.  @d M x y z @.  @d X x y z @.
      @( Meet is a binary internal operation.  (Contributed by FL,
         12-Dec-2009.) @)
      mop @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> M : ( X X. X ) --> X ) @=
        ( vx vy vz wcel cop clatalg cxp wf wa cv co wceq wral w3a syl6bi 3impia
        islatalg simp2 ) CAJZDBJZCDKLJZEEMZEDNZUEUFOUGUHECNZUIGPZHPZCQZULUKCQRU
        KULDQZULUKDQRUKUMDQUKRUKUNCQUKRUKULIPZDQDQUNUODQRUKULUOCQCQUMUOCQROIEST
        THESGESZTUIGHIABCDEFUCUJUIUPUDUAUB @.
    @}

    @{
      @d J x y z @.  @d M x y z @.  @d X x y z @.
      @( Closure of join.  (Contributed by FL, 12-Dec-2009.) @)
      cljo @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> ( ( P e. X /\ Q e. X ) -> ( P J Q ) e. X ) ) @=
        ( wcel cop clatalg w3a wa cxp wf co jop adantr simprl simprr 3jca fovrn
        ex syl6 ) EAIFBIEFJKILZCGIZDGIZMZGGNGEOZUFUGLZCDEPGIUEUHUJUEUHMUIUFUGUE
        UIUHABEFGHQRUEUFUGSUEUFUGTUAUCCDGGGEUBUD @.
    @}

    @{
      @d J x y z @.  @d M x y z @.  @d X x y z @.
      @( Closure of meet.  (Contributed by FL, 12-Dec-2009.) @)
      clme @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> ( ( P e. X /\ Q e. X ) -> ( P M Q ) e. X ) ) @=
        ( wcel cop clatalg w3a wa cxp wf co mop adantr simprl simprr 3jca fovrn
        ex syl6 ) EAIFBIEFJKILZCGIZDGIZMZGGNGFOZUFUGLZCDFPGIUEUHUJUEUHMUIUFUGUE
        UIUHABEFGHQRUEUFUGSUEUFUGTUAUCCDGGGFUBUD @.
    @}

    @{
      @d J x y z @.  @d M x y z @.  @d X x y z @.
      @( Absorption law. ` ( x /\ ( x \/ y ) ) = x ` .  (Contributed by FL,
         12-Dec-2009.) @)
      labs1 @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
         -> A. x e. X A. y e. X ( x M ( x J y ) ) = x ) @=
        ( vz wcel cop clatalg cv co wceq wral wa wf w3a ralimi islatalg simp31
        cxp 3ad2ant3 syl6bi 3impia ) ECJZFDJZEFKLJZAMZUJBMZENZFNUJOZBGPZAGPZUGU
        HQUIGGUCZGERZUPGFRZULUKUJENOZUJUKFNZUKUJFNOZUMUJUTENUJOZUJUKIMZFNFNUTVC
        FNOUJUKVCENENULVCENOQIGPZSSZBGPZAGPZSUOABICDEFGHUAVGUQUOURVFUNAGVEUMBGU
        SVAUMVBVDUBTTUDUEUF @.
    @}

    @{
      @d J x y @.  @d M x y @.  @d P x y @.  @d Q y @.  @d X x y @.
      @( Absorption law. ` ( P /\ ( P \/ Q ) ) = P ` .  (Contributed by FL,
         12-Dec-2009.) @)
      labss1 @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
           -> ( ( P e. X /\ Q e. X ) -> ( P M ( P J Q ) ) = P ) ) @=
        ( vx vy wcel cop clatalg w3a cv co wceq wral wa labs1 id oveq12d oveq2d
        oveq1 eqeq12d oveq2 eqeq1d rspc2v syl5com ) EAKFBKEFLMKNIOZUJJOZEPZFPZU
        JQZJGRIGRCGKDGKSCCDEPZFPZCQZIJABEFGHTUNUQCCUKEPZFPZCQIJCDGGUJCQZUMUSUJC
        UTUJCULURFUTUAZUJCUKEUDUBVAUEUKDQZUSUPCVBURUOCFUKDCEUFUCUGUHUI @.
    @}

    @{
      @d J x y z @.  @d M x y z @.  @d X x y z @.
      @( Absorption law. ` ( x \/ ( x /\ y ) ) = x ` .  (Contributed by FL,
         12-Dec-2009.) @)
      labs2 @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
           -> A. x e. X A. y e. X ( x J ( x M y ) ) = x ) @=
        ( vz wcel cop clatalg cv co wceq wral wa wf w3a ralimi islatalg simp32
        cxp 3ad2ant3 syl6bi 3impia ) ECJZFDJZEFKLJZAMZUJBMZFNZENUJOZBGPZAGPZUGU
        HQUIGGUCZGERZUPGFRZUJUKENZUKUJENOZULUKUJFNOZUJUSFNUJOZUMUJUKIMZFNFNULVC
        FNOUJUKVCENENUSVCENOQIGPZSSZBGPZAGPZSUOABICDEFGHUAVGUQUOURVFUNAGVEUMBGU
        TVAVBUMVDUBTTUDUEUF @.
    @}

    @{
      @d J x y @.  @d M x y @.  @d P x y @.  @d Q y @.  @d X x y @.
      @( Absorption law. ` ( P \/ ( P /\ Q ) ) = P ` .  (Contributed by FL,
         12-Dec-2009.) @)
      labss2 @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg )
           -> ( ( P e. X /\ Q e. X ) -> ( P J ( P M Q ) ) = P ) ) @=
        ( vx vy wcel cop clatalg w3a cv co wceq wral wa labs2 id oveq12d oveq2d
        oveq1 eqeq12d oveq2 eqeq1d rspc2v syl5com ) EAKFBKEFLMKNIOZUJJOZFPZEPZU
        JQZJGRIGRCGKDGKSCCDFPZEPZCQZIJABEFGHTUNUQCCUKFPZEPZCQIJCDGGUJCQZUMUSUJC
        UTUJCULUREUTUAZUJCUKFUDUBVAUEUKDQZUSUPCVBURUOCEUKDCFUFUCUGUHUI @.
    @}

    @( Join is idempotent. ` ( P \/ P ) = P ` .  (Contributed by FL,
       12-Dec-2009.) @)
    jidd @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg ) ->
      ( P e. X -> ( P J P ) = P ) ) @=
      ( wcel cop clatalg w3a co wceq wi wa labss1 imp simpl simprl sylc cljo ex
      jca labss2 oveq2 eqtr eqcoms syl expcom anidms com12 ) CFHZDAHEBHDEIJHKZC
      CDLZCMZULUMUONUMULULOZUOUMUPOZCUNELZCMZCURDLZCMZUOUMUPUSABCCDEFGPQUQUMULU
      NFHZOVAUMUPRUQULVBUMULULSUMUPVBABCCDEFGUAQUCABCUNDEFGUDTUSUTUNMVAUONZURCC
      DUEVCUNUTUNUTMVAUOUNUTCUFUBUGUHTUIUJUK @.

    @( Meet is idempotent. ` ( P /\ P ) = P ` .  (Contributed by FL,
       12-Dec-2009.) @)
    midd @p |- ( ( J e. A /\ M e. B /\ <. J , M >. e. LatAlg ) ->
      ( P e. X -> ( P M P ) = P ) ) @=
      ( wcel cop clatalg w3a co wceq wi wa labss2 imp simpl simprl sylc clme ex
      jca labss1 oveq2 eqtr eqcoms syl expcom anidms com12 ) CFHZDAHEBHDEIJHKZC
      CELZCMZULUMUONUMULULOZUOUMUPOZCUNDLZCMZCURELZCMZUOUMUPUSABCCDEFGPQUQUMULU
      NFHZOVAUMUPRUQULVBUMULULSUMUPVBABCCDEFGUAQUCABCUNDEFGUDTUSUTUNMVAUONZURCC
      EUEVCUNUTUNUTMVAUOUNUTCUFUBUGUHTUIUJUK @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Currying and Partial Mappings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c cur1 @.
  @c cur2 @.

  @( Extend class notation with the definition of currying. @)
  ccur1 @a class cur1 @.

  @( Extend class notation with the definition of currying. @)
  ccur2 @a class cur2 @.

  @{
    @d f g x y @.
    @( Definition of currying (1st sort).  Currying the operation ` f `
       consists in creating a mapping that returns for every value ` x ` of
       ` dom dom f ` the partial application of ` f ` to ` x ` .  (Contributed
       by FL, 24-Jan-2010.) @)
    df-cur1 @a |- cur1 = { <. f , g >. | ( ( Fun f /\ Rel dom f ) /\
   g = ( x e. dom dom f |-> ( f o. `' ( 2nd |` ( { x } X. _V ) ) ) ) ) } @.

    @( Definition of currying (2nd sort).  Currying the operation ` f `
       consists in creating a mapping that returns for every value ` x ` of
       ` ran dom f ` the partial application of ` f ` to ` x ` .  (Contributed
       by FL, 24-Jan-2010.) @)
    df-cur2 @a |- cur2 = { <. f , g >. | ( Fun f /\ Rel dom f /\
   g = ( x e. ran dom f |-> ( f o. `' ( 1st |` ( _V X. { x } ) ) ) ) ) } @.
  @}

  @{
    @d F f g x y @.
    @( The value of a curried operation.  (Contributed by FL, 24-Jan-2010.) @)
    cur1val @p |- ( ( F e. A /\ Fun F /\ Rel dom F ) -> ( cur1 ` F )
      = ( x e. dom dom F |-> ( F o. `' ( 2nd |` ( { x } X. _V ) ) ) ) ) @=
      ( vf vg wcel wfun cdm wrel w3a cvv cv ccom cmpt ccur1 wceq 3ad2ant1 dmexg
      wa syl c2nd csn cxp cres ccnv cfv elex mptexg 3simpc df-cur1 funeq releqd
      dmeq anbi12d dmeqd coeq1 mpteq12dv fvopab6 syl3anc ) CBFZCGZCHZIZJZCKFZAV
      BHZCUAALUBKUCUDUEZMZNZKFZVAVCSZCOUFVIPUTVAVEVCCBUGQVDVFKFZVJUTVAVLVCUTVBK
      FVLCBRVBKRTQAVFVHKUHTUTVAVCUIDLZGZVMHZIZSVKDECAVOHZVMVGMZNVIKKOADEUJVMCPZ
      VNVAVPVCVMCUKVSVOVBVMCUMZULUNVSAVQVRVFVHVSVOVBVTUOVMCVGUPUQURUS @.
  @}

  @{
    @d A x y @.  @d B x y @.  @d C x y @.  @d D x y @.  @d F x y @.
    @( The value of a curried operation.  (Contributed by FL, 17-May-2010.) @)
    cur1vald @p |- ( ( ( F Fn ( A X. B ) /\ B =/= (/) ) /\
        ( A e. C /\ B e. D ) ) -> ( cur1 ` F ) =
      ( x e. A |-> ( F o. `' ( 2nd |` ( { x } X. _V ) ) ) ) ) @=
      ( cxp wa wcel cdm cvv cmpt wrel wceq wi adantr imp ad2antrr eqcoms syl c0
      wfn wne ccur1 cfv c2nd cv csn cres ccnv ccom wfun w3a simp1 xpexg 3adant1
      fnex syl2anc 3expib fnfun fndm relxp wb releq mpbii cur1val syl3anc dmeqd
      dmxp eqeq1d biimpcd mpteq1 eqtr4d ) FBCGZUBZCUAUCZHZBDIZCEIZHZHZFUDUEZAFJ
      ZJZFUFAUGUHKGUIUJUKZLZABWELZWAFKIZFULZWCMZWBWFNVQVTWHVOVTWHOVPVOVRVSWHVOV
      RVSUMVOVNKIZWHVOVRVSUNVRVSWKVOBCDEUOUPVNKFUQURUSPQVOWIVPVTVNFUTRVOWJVPVTV
      OWCVNNZWJVNFVAZWLVNMZWJBCVBWNWJVCVNWCVNWCVDSVETRAKFVFVGWABWDNZWGWFNVQWOVT
      VOVPWOVOWDVNJZNVPWOOZVOWCVNWMVHWQWPWDVPWPWDNWOVPWPBWDBCVIVJVKSTQPABWDWEVL
      TVM @.
  @}

  @{
    @d A x y @.  @d B f x y @.  @d C x y @.  @d D x y @.  @d F f x y @.
    domrancur1b.1 @e |- A e. C @.
    domrancur1b.2 @e |- B e. D @.
    domrancur1b.3 @e |- B =/= (/) @.
    domrancur1b.4 @e |- F Fn ( A X. B ) @.
    @( The currying of a mapping ` F ` whose domain is ` ( A X. B ) ` is a
       mapping whose domain is ` A ` and the range, the class of all the
       functions from ` B ` to ` ran F ` .  (Contributed by FL,
       28-Apr-2010.) @)
    domrancur1b @p |-
      ( cur1 ` F ) : A --> { f | f : B --> ran F } @=
      ( vx crn c2nd cvv cxp cres wcel wceq cin syl5eq cv wf cab ccnv ccom ccur1
      csn cfv wfn c0 wne cmpt cur1vald mp4an wss wfun fnfun ax-mp wf1o 2ndconst
      cdm wfo dff1o3 simprbi syl funco sylancr cima dmco imacnvcnv fndm imaeq2i
      df-ima resres rneqi inxp snssi df-ss sylib incom inv1 a1i xpeq12d reseq2d
      eqtri rneqd snnzg fo2ndres forn 3syl eqtrd df-fn sylanbrc rncoss df-f cpm
      elex adantl elexi xpexg mp2an eqeltri funrnex mp2 fpm feq1 elabg pm5.21nd
      co mpbird fmpti ) KABFLZEUAZUBZEUCZFMKUAZUGZNOZPZUDZUEZFUFUHZFABOZUIZBUJU
      KACQZBDQZYBKAYAULRJIGHKABCDFUMUNXPAQZYAXOQZBXLYAUBZYGYABUIZYALXLUOZYIYGYA
      UPZYAVAZBRYJYGFUPZXTUPZYLYDYNJYCFUQURZYGXRNXSUSZYOXPNAUTYQXRNXSVBYOXRNXSV
      CVDVEFXTVFVGYGYMXTUDFVAZVHZBFXTVIYGYSXSYRVHZBXSYRVJYGYTXSYCVHZBYRYCXSYDYR
      YCRJYCFVKURZVLYGUUAXSYCPZLZBXSYCVMYGUUDMXRYCSZPZLZBUUCUUFMXRYCVNVOYGUUGMX
      QBOZPZLZBYGUUFUUIYGUUEUUHMYGUUEXQASZNBSZOUUHXQNABVPYGUUKXQUULBYGXQAUOUUKX
      QRXPAVQXQAVRVSUULBRYGUULBNSBNBVTBWAWEWBWCTWDWFYGXQUJUKUUHBUUIVBUUJBRXPAWG
      XQBWHUUHBUUIWIWJWKTTTTTYABWLWMYKYGFXTWNWBBXLYAWOWMYGYHYIYANQZYHUUMYGYAXOW
      QWRYIUUMYGYIYAXLBWPXIZQUUMBXLYABDHWSYRNQYNXLNQYRYCNUUBYEYFYCNQGHABCDWTXAX
      BYPNFXCXDXEYAUUNWQVEWRXNYIEYANBXLXMYAXFXGXHXJXK @.
  @}

  @{
    @( Lemma for ~ domrancur1c .  (Contributed by FL, 17-May-2010.) @)
    domrancur1clem @p |- ( ( F Fn ( A X. B ) /\ ( A e. C /\ B e. D ) )
       -> ( F o. `' ( 2nd |` M ) ) e. _V ) @=
      ( cxp wfn wcel wa cvv c2nd cres ccnv wfun ccom xpexg fnex sylan2 ax-mp
      wfo fo2nd fofun funres funcnvcnv cofunex2g sylancl ) EABGZHZACIBDIJZJEKIZ
      LFMZNZNOZEUMPKIUJUIUHKIUKABCDQUHKERSULOZUNLOZUOKKLUAUPUBKKLUCTFLUDTULUETE
      UMKUFUG @.
  @}

  @{
    @d A x y @.  @d B f x y @.  @d C x y @.  @d D x y @.  @d F f x y @.
    @( The currying of a mapping ` F ` whose domain is ` ( A X. B ) ` is a
       mapping whose domain is ` A ` and the range, the class of all the
       functions from ` B ` to ` ran F ` .  (Contributed by FL,
       17-May-2010.) @)
    domrancur1c @p |-
      ( ( ( A e. C /\ B e. D ) /\ ( B =/= (/) /\ F Fn ( A X. B ) ) ) ->
        ( cur1 ` F ) : A --> { f | f : B --> ran F } ) @=
      ( vx wcel wa cxp c2nd cvv cres ccnv crn wf wfun wceq wi cin c0 wne wfn cv
      csn ccom cab wral ccur1 cfv wss cdm wf1o vex 2ndconst ax-mp f1ocnv f1ofun
      fnfun funco ex adantl ad2antlr syl5com mp2b cima cnvcnvres imaeq1i df-ima
      syl dmco resres a1i rneqd rescnvcnv fndm simpr reseq2d inxp reseq2i rneqi
      ineq2d snssi df-ss sylib incom inv1 eqtri sylancl ad2antrr wfo f1ofo forn
      xpeq12 mp1i eqtrd syl5eq exp31 com13 impcom imp df-fn sylanbrc rncoss fss
      dffn3 wb xpexg fnex adantr fo2nd fofun funres funcnvcnv cofunex2g syl2anc
      syl5 feq1 elabg mpbird ralrimiva cmpt pm3.22 simpl cur1vald fopab2g mpbid
      ) ACHBDHIZBUAUBZFABJZUCZIZIZFKGUDZUEZLJZMZNZUFZBFOZEUDZPZEUGZHZGAUHZAUUCF
      UIUJZPZYMUUDGAYMYNAHZIZUUDBYTYSPZUUIBYSOZYSPZUUKYTUKUUJUUIYSBUCZUULUUIYSQ
      ZYSULZBRUUMYPLYQUMZLYPYRUMZUUIUUNSYNLHZUUPGUNZYNLLUOUPYPLYQUQUUQYRQZUUIUU
      NLYPYRURYLUUTUUNSZYHUUHYKUVAYIYKFQZUVAYJFUSUVBUUTUUNFYRUTVAVJVBVCVDVEUUIU
      UOYRNZFULZVFZBFYRVKUUIUVEKNNZYPMZUVDVFZBUVCUVGUVDKYPVGVHUUIUVHUVGUVDMZOZB
      UVGUVDVIUUIUVJUVFYPUVDTZMZOZBUUIUVIUVLUVIUVLRUUIUVFYPUVDVLVMVNUUIUVMKUVKM
      ZOZBUUIUVLUVNUVLUVNRUUIKUVKVOVMVNYMUUHUVOBRZYLYHUUHUVPSZYKYHUVQSZYIYKUVDY
      JRZUVRYJFVPUUHYHUVSUVPUUHYHUVSUVPUUHYHIZUVSIZUVOKYPYJTZMZOZBUWAUVNUWCUWAU
      VKUWBKUWAUVDYJYPUVTUVSVQWBVRVNUWAUWDKYOATZLBTZJZMZOZBUWCUWHUWBUWGKYOLABVS
      VTWAUWAUWIKYOBJZMZOZBUUHUWIUWLRYHUVSUUHUWHUWKUUHUWGUWJKUUHUWEYORZUWFBRUWG
      UWJRUUHYOAUKUWMYNAWCYOAWDWEUWFBLTBLBWFBWGWHUWEYOUWFBWNWIVRVNWJUWJBUWKWKZU
      WLBRUWAUURUWJBUWKUMUWNUUSYNBLUOUWJBUWKWLVEUWJBUWKWMWOWPWQWPWRWSVJVBWTXAWP
      WPWQWQWQYSBXBXCBYSXFWEFYRXDBUUKYTYSXEWIUUIYSLHZUUDUUJXGUUIFLHZUVCQZUWOYMU
      WPUUHYLYHUWPYKYHUWPSYIYHYJLHZYKUWPABCDXHYKUWRUWPYJLFXIVAXQVBWTXJYQQZUWQUU
      ILLKWKKQUWSXKLLKXLYPKXMVEYQXNWOFYRLXOXPUUBUUJEYSLBYTUUAYSXRXSVJXTYAYMUUFG
      AYSYBRZUUEUUGXGYMYKYIIZYHUWTYLUXAYHYIYKYCVBYHYLYDGABCDFYEXPGAUUCYSUUFYFVJ
      YG @.
  @}

  @{
    @d B f @.  @d F f @.  @d O f @.
    @( The value of a curried function at ` O e. A ` is a mapping.
       (Contributed by FL, 17-May-2010.) @)
    valcurfn @p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ O e. A )
        ->
        ( ( cur1 ` F ) ` O ) : B --> ran F ) @=
      ( vf wcel wa c0 wne cxp wfn crn ccur1 cfv wf cv cab wi ffvelrn fvex sylib
      domrancur1c feq1 elab ex syl 3impia ) ACHBDHIZBJKEABLMIZFAHZBENZFEOPZPZQZ
      UJUKIABUMGRZQZGSZUNQZULUPTABCDGEUDUTULUPUTULIUOUSHUPAUSFUNUAURUPGUOFUNUBB
      UMUQUOUEUFUCUGUHUI @.
  @}

  @{
    @d F x y @.  @d G x y @.  @d O x y @.
    valcurfn1.1 @e |- G = ( F o. `' ( 2nd |` ( { O } X. _V ) ) ) @.
    @( The value of a curried function at ` O e. A ` is a partial application.
       (Contributed by FL, 17-May-2010.) @)
    valcurfn1 @p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ O e. A )
        -> ( ( cur1 ` F ) ` O ) = G ) @=
      ( vx wcel wa cxp cfv cdm c2nd csn cvv wceq adantl syl c0 wne wfn ccur1 cv
      w3a cres ccnv ccom cmpt wfun wrel wi xpexg fnex syl5 impcom 3adant3 fnfun
      ex 3ad2ant2 fndm relxp releq mpbiri cur1val syl3anc fveq1d dmeq dmxp eqtr
      eqcomd syl2im eleq2d biimpa simprr simpl jca domrancur1clem syl5eqel sneq
      3adant1 xpeq1d reseq2d cnveqd coeq2d syl6eqr eqid fvmptg syl2anc eqtrd )
      ACJBDJKZBUAUBZEABLZUCZKZGAJZUFZGEUDMZMGIENZNZEOIUEZPZQLZUGZUHZUIZUJZMZFWR
      GWSXHWREQJZEUKZWTULZWSXHRWLWPXJWQWPWLXJWOWLXJUMWMWLWNQJZWOXJABCDUNWOXMXJW
      NQEUOUTUPSUQURWPWLXKWQWOXKWMWNEUSSVAWPWLXLWQWOXLWMWOWTWNRZXLWNEVBZXNXLWNU
      LABVCWTWNVDVETSVAIQEVFVGVHWRGXAJZFQJXIFRWPWQXPWLWPWQXPWPAXAGWOWMAXARZWOXN
      WMXQUMXOXNXAWNNZRZWMXRARZXQWTWNVIABVJXSXTXQXSXTKXAAXAXRAVKVLUTVMTUQVNVOWB
      WRFEOGPZQLZUGZUHZUIZQHWRWOWLKZYEQJWLWPYFWQWLWPKWOWLWLWMWOVPWLWPVQVRURABCD
      EYBVSTVTIGXGFXAQXHXBGRZXGYEFYGXFYDEYGXEYCYGXDYBOYGXCYAQXBGWAWCWDWEWFHWGXH
      WHWIWJWK @.

  @}

  @{
    @d A x y @.  @d B x y @.  @d F x y @.  @d O x y @.
    @( The value of a curried function at ` O e. A ` is a partial application.
       (Contributed by FL, 17-May-2010.) @)
    valcurfn2 @p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ O e. A )
        -> ( ( cur1 ` F ) ` O ) = ( x e. B |-> ( O F x ) ) ) @=
      ( wcel wa c0 wne cxp wfn w3a ccur1 cfv c2nd csn cvv cres ccnv ccom simp2r
      cv co cmpt eqid valcurfn1 wceq simp3 curry1 syl2anc eqtrd ) BDHCEHIZCJKZF
      BCLMZIZGBHZNZGFOPPFQGRSLTUAUBZACGAUDFUEUFZBCDEFUTGUTUGZUHUSUPURUTVAUIUNUO
      UPURUCUNUQURUJABCGFUTVBUKULUM @.
  @}

  @{
    @d A x y @.  @d B x y @.  @d F x y @.  @d O x y @.  @d P x y @.
    @( The value at ` P e. B ` of the value of a curried function at ` O e. A `
       equals ` ( O F P ) ` .  (Contributed by FL, 17-May-2010.) @)
    valvalcurfn @p |- ( ( ( A e. C /\ B e. D ) /\
               ( B =/= (/) /\ F Fn ( A X. B ) ) /\ ( O e. A /\ P e. B ) )
        -> ( ( ( cur1 ` F ) ` O ) ` P ) = ( O F P ) ) @=
      ( vx wcel wa c0 wne cxp wfn w3a ccur1 cfv cv co wceq cmpt 3adant3r fveq1d
      valcurfn2 simp3r oveq2 eqid ovex fvmpt syl eqtrd ) ACIBDIJZBKLFABMNJZGAIZ
      EBIZJOZEGFPQQZQEHBGHRZFSZUAZQZGEFSZUPEUQUTULUMUNUQUTTUOHABCDFGUDUBUCUPUOV
      AVBTULUMUNUOUEHEUSVBBUTUREGFUFUTUGGEFUHUIUJUK @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Order theory (Extensible Structure Builder)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c OrHom @.

  @( Extend class notation with the class of all decreasing functions. @)
  corhom @a class OrHom @.

  @c OrIso @.

  @( Extend class notation with the class of all the order isomorphisms. @)
  coriso @a class OrIso @.

  @{
    @d r s f a b @.
    @( Increasing functions also called "order homomorphisms", "isotone,
       monotone or order preserving mappings".  To have the class of decreasing
       functions use ` ( r OrHom ``' s ) ` .  Experimental.  Bourbaki E.III.7
       (Contributed by FL, 17-Nov-2014.) @)
    df-orhom @a |- OrHom = ( r e. _V , s e. _V
       |-> { f e. ( ( Base ` s ) ^m ( Base ` r ) ) |
         A. a e. ( Base ` r ) A. b e. ( Base ` r ) ( a ( le ` r ) b ->
           ( f ` a ) ( le ` s ) ( f ` b ) ) } ) @.

    @( Order isomorphisms.  Experimental.  Bourbaki E.III.5 (Contributed by FL,
       17-Nov-2014.) @)
    df-oriso @a |- OrIso = ( r e. _V , s e. _V
       |-> { f | ( f : ( Base ` r ) -1-1-onto-> ( Base ` s ) /\
         A. a e. ( Base ` r ) A. b e. ( Base ` r ) ( a ( le ` r ) b <->
           ( f ` a ) ( le ` s ) ( f ` b ) ) ) } ) @.
  @}

  @{
    @d r s <_a @.  @d a b f r s A @.  @d r s <_b @.  @d a b f r s B @.
    @d f r s X @.  @d f r s Y @.
    isorhom.1 @e |- X = ( Base ` A ) @.
    isorhom.2 @e |- Y = ( Base ` B ) @.
    isorhom.3 @e |- <_a = ( le ` A ) @.
    isorhom.4 @e |- <_b = ( le ` B ) @.
    @( The predicate is an order homomorphism.  (Contributed by FL,
       17-Nov-2014.) @)
    isorhom @p |- ( ( A e. C /\ B e. D ) ->
      ( A OrHom B ) = { f e. ( Y ^m X ) |
         A. a e. X A. b e. X ( a <_a b ->
           ( f ` a ) <_b ( f ` b ) ) } ) @=
      ( wcel cfv wral cmap cple vr vs cvv corhom co cv wbr crab wceq elex fveq2
      wi cbs oveq2d eleq2d imbi1d imbi12d ralbidv2 rabeqbidv syl6eqr eqcomi a1i
      breqd oveq12d df-orhom ovex rabex ovmpt2 syl2an ) ACPAUCPBUCPABUDUEHUFZIU
      FZJUGZVJEUFZQZVKVMQZKUGZULZIFRZHFRZEGFSUEZUHZUIBDPACUJBDUJUAUBABUCUCVJVKU
      AUFZTQZUGZVNVOUBUFZTQZUGZULZIWBUMQZRZHWIRZEWEUMQZWISUEZUHWAUDVJVKATQZUGZW
      GULZIAUMQZRZHWQRZEWLWQSUEZUHWBAUIZWKWSEWMWTXAWIWQWLSWBAUMUKZUNXAWJWRHWIWQ
      XAVJWIPVJWQPZWJWRXAWIWQVJXBUOXAWHWPIWIWQXAVKWIPVKWQPZWHWPXAWIWQVKXBUOXAWD
      WOWGXAWCWNVJVKWBATUKVCUPUQURUQURUSWEBUIZWSVSEWTVTXEWLGWQFSXEWLBUMQGWEBUMU
      KMUTWQFUIXEFWQLVAVBZVDXEWRVRHWQFXEXCVJFPWRVRXEWQFVJXFUOXEWPVQIWQFXEXDVKFP
      WPVQXEWQFVKXFUOXEWOVLWGVPXEWNJVJVKWNJUIXEJWNNVAVBVCXEWFKVNVOXEWFBTQKWEBTU
      KOUTVCUQUQURUQURUSEUBUAHIVEVSEVTGFSVFVGVHVI @.
  @}

  @{
    isoriso.1 @e |- X = ( Base ` A ) @.
    isoriso.2 @e |- Y = ( Base ` B ) @.
    isoriso.3 @e |- <_a = ( le ` A ) @.
    isoriso.4 @e |- <_b = ( le ` B ) @.
    @{
      @d r s <_a @.  @d a b f r s A @.  @d r s <_b @.  @d a b f r s B @.
      @d f r s X @.  @d f r s Y @.
      @( Order isomorphisms.  (Contributed by FL, 17-Nov-2014.) @)
      isoriso @p |- ( ( A e. C /\ B e. D ) -> ( A OrIso B ) =
         { f | ( f : X -1-1-onto-> Y /\ A. a e. X A. b e. X
           ( a <_a b <-> ( f ` a ) <_b ( f ` b ) ) ) } ) @=
        ( wcel cfv wral wceq cbs vr vs cvv coriso co cv wf1o wbr wb wa cab elex
        cple fveq2 eqidd f1oeq23 syl2anc bibi1d raleqbidv anbi12d abbidv bibi2d
        breqd 2ralbidv eqcomi mp2an breqi bibi12i imbi12i ralbii2 anbi12i abbii
        eleq2i syl6eq df-oriso fvex eqeltri adantr pm4.71ri fabex ovmpt2 syl2an
        wf f1of ) ACPAUCPBUCPABUDUEFGEUFZUGZHUFZIUFZJUHZWGWEQZWHWEQZKUHZUIZIFRZ
        HFRZUJZEUKZSBDPACULBDULUAUBABUCUCUAUFZTQZUBUFZTQZWEUGZWGWHWRUMQZUHZWJWK
        WTUMQZUHZUIZIWSRZHWSRZUJZEUKWQUDATQZXAWEUGZWGWHAUMQZUHZXFUIZIXKRZHXKRZU
        JZEUKZWRASZXJXREXTXBXLXIXQXTWSXKSXAXASXBXLUIWRATUNZXTXAUOWSXKXAXAWEUPUQ
        XTXHXPHWSXKYAXTXGXOIWSXKYAXTXDXNXFXTXCXMWGWHWRAUMUNVCURUSUSUTVAWTBSZXSX
        KBTQZWEUGZXNWJWKBUMQZUHZUIZIXKRZHXKRZUJZEUKWQYBXRYJEYBXLYDXQYIYBXKXKSXA
        YCSXLYDUIYBXKUOWTBTUNXKXKXAYCWEUPUQYBXOYGHIXKXKYBXFYFXNYBXEYEWJWKWTBUMU
        NVCVBVDUTVAYJWPEYDWFYIWOXKFSYCGSYDWFUIFXKLVEZGYCMVEXKFYCGWEUPVFYHWNHXKF
        WGXKPWGFPYHWNXKFWGYKVMYGWMIXKFWHXKPWHFPYGWMXKFWHYKVMXNWIYFWLWGWHXMJJXMN
        VEVGWJWKYEKKYEOVEVGVHVIVJVIVJVKVLVNEUBUAHIVOWPEFGWQFXKUCLATVPVQGYCUCMBT
        VPVQWPFGWEWCZWPUJEWPYLWFYLWOFGWEWDVRVSVLVTWAWB @.
    @}

    @{
      @d a b f A @.  @d a b f B @.  @d a b f F @.  @d b f X @.  @d f <_a @.
      @d f <_b @.  @d f Y @.
      @( Order isomorphisms.  (Contributed by FL, 17-Nov-2014.) @)
      isoriso2 @p |- ( ( A e. C /\ B e. D /\ F e. E ) ->
        ( F e. ( A OrIso B ) <-> ( F : X -1-1-onto-> Y /\
         A. a e. X A. b e. X ( a <_a b <->
           ( F ` a ) <_b ( F ` b ) ) ) ) ) @=
        ( vf wcel cfv wral w3a coriso co cv wf1o wbr wb wa wceq isoriso 3adant3
        cab eleq2d f1oeq1 fveq1 breq12d bibi2d 2ralbidv anbi12d elabg 3ad2ant3
        bitrd ) ACRZBDRZFERZUAZFABUBUCZRFGHQUDZUEZIUDZJUDZKUFZVJVHSZVKVHSZLUFZU
        GZJGTIGTZUHZQULZRZGHFUEZVLVJFSZVKFSZLUFZUGZJGTIGTZUHZVFVGVSFVCVDVGVSUIV
        EABCDQGHIJKLMNOPUJUKUMVEVCVTWGUGVDVRWGQFEVHFUIZVIWAVQWFGHVHFUNWHVPWEIJG
        GWHVOWDVLWHVMWBVNWCLVJVHFUOVKVHFUOUPUQURUSUTVAVB @.
    @}

    @{
      @d a b x y <_a @.  @d a b x y <_b @.  @d a b x y A @.  @d a b x y B @.
      @d a b C @.  @d a b D @.  @d a b x y F @.  @d a b x y X @.  @d a b Y @.
      @( If ` F ` is an order isomorphism so is ` ``' F ` .  (Contributed by
         FL, 11-Nov-2014.) @)
      oriso @p |- ( ( A e. C /\ B e. D ) ->
        ( F e. ( A OrIso B ) -> `' F e. ( B OrIso A ) ) ) @=
        ( wcel wa wi wbr cfv wb cvv vx vy va vb coriso co ccnv w3a wf1o cv wral
        f1ocnv ad2antrl wf f1of ffvelrn ex syl im2anan9 wceq breq1 fveq2 breq1d
        bibi12d breq2 breq2d rspc2v bicom simp3 simp2l f1ocnvfv2 syl2anc simp2r
        breq12d bibi1d biimpd 3exp com14 sylbi syl6 com25 pm2.43i com24 a1d imp
        syli adantl ralrimivv jca isoriso2 elex cnvexg 3anim123i 3com12 3imtr4d
        3expia pm2.43d ) ACNZBDNZOEABUEUFZNZEUGZBAUEUFNZWRWSXAXAXCPWRWSXAUHZFGE
        UIZUAUJZUBUJZHQZXFERZXGERZIQZSZUBFUKUAFUKZOZGFXBUIZUCUJZUDUJZIQZXPXBRZX
        QXBRZHQZSZUDGUKUCGUKZOZXAXCXDXNYDXDXNOZXOYCXEXOXDXMFGEULZUMYEYBUCUDGGXN
        XPGNZXQGNZOZYBPZXDXNYJXEXMXNYJPZXEXMYKPZXEXOXOXEYLPYFYFXOXOOZXNXMXEYJYM
        XMXEYJPPXNYMYIXEXMYBYIYMXSFNZXTFNZOZXEXMYBPPZXOYGYNXOYHYOXOGFXBUNZYGYNP
        GFXBUOZYRYGYNGFXPXBUPUQURXOYRYHYOPYSYRYHYOGFXQXBUPUQURUSYPYIYQPYPXMYIXE
        YPYBYPXMYAXSERZXTERZIQZSZYIXEYPYBPPPZXLUUCXSXGHQZYTXJIQZSUAUBXSXTFFXFXS
        UTZXHUUEXKUUFXFXSXGHVAUUGXIYTXJIXFXSEVBVCVDXGXTUTZUUEYAUUFUUBXGXTXSHVEU
        UHXJUUAYTIXGXTEVBVFVDVGUUCUUBYASZUUDYAUUBVHYPYIXEUUIYBYPYIXEUUIYBPYPYIX
        EUHZUUIYBUUJUUBXRYAUUJYTXPUUAXQIUUJXEYGYTXPUTYPYIXEVIZYPYGYHXEVJFGXPEVK
        VLUUJXEYHUUAXQUTUUKYPYGYHXEVMFGXQEVKVLVNVOVPVQVRVSVTWAWBWFWCWDWCVLWBWEW
        BWGWHWIUQABCDWTEFGUAUBHIJKLMWJXDBTNZATNZXBTNZUHZXCYDSWSWRXAUUOWSUULWRUU
        MXAUUNBDWKACWKEWTWLWMWNBATTTXBGFUCUDIHKJMLWJURWOWPWQ @.
    @}

  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Order theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c mxl @.
  @c mnl @.
  @c ub @.
  @c lb @.
  @c PresetRel @.
  @c ge @.
  @c leR @.
  @c AntiDir @.

  @( Extend class notation with the class of all the presets. @)
  cpresetrel @a class PresetRel @.

  @( Extend class notation with a function that returns the maximal elements of
     a preset. @)
  cmxl @a class mxl @.

  @( Extend class notation with a function that returns the minimal elements of
     a preset. @)
  cmnl @a class mnl @.

  @( Extend class notation with a function that returns the upper bounds of a
     part of a preset. @)
  cub @a class ub @.

  @( Extend class notation with a function that returns the lower bounds of a
     part of a preset. @)
  clb @a class lb @.

  @( Extend class notation with a function that returns the greatest element of
     a poset. @)
  cge @a class ge @.

  @( Extend class notation with a function that returns the smallest element of
     a poset. @)
  cse @a class leR @.

  @( Extend class notation with the class of all the anti-directions. @)
  cantidir @a class AntiDir @.

  @( Define the class of all presets.  A preset is a transitive and reflexive
     relation.  ("preset" is the short for preordered set.)  (Contributed by
     FL, 1-May-2011.) @)
  df-prs @a |- PresetRel = { r | ( Rel r /\ ( r o. r ) C_ r /\
              ( _I |` U. U. r ) C_ r ) } @.

  @{
    @d R r @.
    @( The predicate "is a preset".  (Contributed by FL, 1-May-2011.) @)
    isprsr @p |- ( R e. A -> ( R e. PresetRel <->
       ( Rel R /\ ( R o. R ) C_ R /\ ( _I |` U. U. R ) C_ R ) ) ) @=
      ( vr cv wrel ccom wss cid cuni cres w3a cpresetrel wceq releq coeq1 coeq2
      wb eqtrd sseq12 mpancom unieq unieqd reseq2d 3anbi123d df-prs elab2g ) CD
      ZEZUGUGFZUGGZHUGIZIZJZUGGZKBEZBBFZBGZHBIZIZJZBGZKCBLAUGBMZUHUOUJUQUNVAUGB
      NUIUPMVBUJUQQVBUIBUGFUPUGBUGOUGBBPRUIUPUGBSTUMUTMVBUNVAQVBULUSHVBUKURUGBU
      AUBUCUMUTUGBSTUDCUEUF @.
  @}

  @( A preset is a relation.  (Contributed by FL, 18-May-2011.) @)
  preorel @p |- ( R e. PresetRel -> Rel R ) @=
    ( cpresetrel wcel wrel ccom wss cid cuni cres w3a isprsr ibi simp1d ) ABCZA
    DZAAEAFZGAHHIAFZNOPQJBAKLM @.

  @{
    @d R x @.
    @( The domain of a preset equals its field.  (Contributed by FL,
       22-May-2011.) @)
    preodom2 @p |- ( R e. PresetRel -> dom R = U. U. R ) @=
      ( vx cpresetrel wcel cdm cuni wceq wrel ccom wss cid cres w3a isprsr wral
      cv wbr issref domfldref sylan2b 3adant2 syl6bi pm2.43i ) ACDZAEAFFZGZUDUD
      AHZAAIAJZKUELAJZMUFCANUGUIUFUHUIUGBPZUJAQBUEOUFBUEARBASTUAUBUC @.
  @}

  @{
    preoref12.1 @e |- X = dom R @.
    @( The field of a preset is a set.  (Contributed by FL, 19-Sep-2011.) @)
    ppldrels @p |- ( R e. PresetRel -> X e. _V ) @=
      ( cpresetrel wcel cdm cvv dmexg syl5eqel ) ADEBAFGCADHI @.

    @( A preset is reflexive.  (Contributed by FL, 18-May-2011.) @)
    preoref12 @p |- ( R e. PresetRel -> ( _I |` X ) C_ R ) @=
      ( cpresetrel wcel cid cres cuni cdm preodom2 syl5eq reseq2d wrel ccom wss
      w3a isprsr ibi simp3d eqsstrd ) ADEZFBGFAHHZGZAUABUBFUABAIUBCAJKLUAAMZAAN
      AOZUCAOZUAUDUEUFPDAQRST @.

    @{
      @d A x @.  @d R x @.
      @( A preset is reflexive.  (Contributed by FL, 22-May-2011.) @)
      preoref22 @p |- ( ( R e. PresetRel /\ A e. X ) -> A R A ) @=
        ( vx cpresetrel wcel wbr cdm cuni wceq cid wss wi preodom2 preoref12 wa
        cres eqtr cv wral idref breq12 anidms rspccv sylbi reseq2 sseq1d imbi1d
        wb eleq2 imbi12d mpbiri syl mpan sylc imp ) BFGZACGZAABHZURBIZBJJZKZLCR
        ZBMZUSUTNZBOBCDPCVAKZVCVEVFNZDVGVCQCVBKZVHCVAVBSVIVHLVBRZBMZAVBGZUTNZNV
        KETZVNBHZEVBUAVMEVBBUBVOUTEAVBVNAKVOUTUJVNAVNABUCUDUEUFVIVEVKVFVMVIVDVJ
        BCVBLUGUHVIUSVLUTCVBAUKUIULUMUNUOUPUQ @.
    @}

    @{
      @d R x @.
      @( The range of a preset equals its field.  (Contributed by FL,
         22-May-2011.) @)
      preoran2 @p |- ( R e. PresetRel -> ran R = X ) @=
        ( vx cpresetrel wcel crn wceq wrel ccom wss cid cuni cres w3a isprsr cv
        wbr wral idref wa cdm domrngref syl5req sylan2b 3adant2 syl6bi pm2.43i
        ) AEFZAGZBHZUIUIAIZAAJAKZLAMMZNAKZOUKEAPULUOUKUMUOULDQZUPARDUNSZUKDUNAT
        ULUQUABAUBUJCDAUCUDUEUFUGUH @.
    @}

    @( If ` A <_ B ` , then ` A ` belongs to the field of the preset.
       (Contributed by FL, 23-May-2011.) @)
    pre1befi2 @p |- ( ( R e. PresetRel /\ A R B ) -> A e. X ) @=
      ( cpresetrel wcel wbr wa cdm wrel preorel releldm sylan syl6eleqr ) CFGZA
      BCHZIACJZDPCKQARGCLABCMNEO @.

    @( If ` A <_ B ` , then ` B ` belongs to the field of the preset.
       (Contributed by FL, 23-May-2011.)  (Revised by Mario Carneiro,
       3-May-2015.) @)
    pre2befi2 @p |- ( ( R e. PresetRel /\ A R B ) -> B e. X ) @=
      ( cpresetrel wcel wbr crn wrel preorel relelrn sylan wceq preoran2 adantr
      wa eleqtrd ) CFGZABCHZQBCIZDSCJTBUAGCKABCLMSUADNTCDEOPR @.
  @}

  @{
    domcprere.1 @e |- X = dom R @.
    @( If ` R ` is a preset, its domain and the domain of its converse are
       equal.  (Contributed by FL, 19-Sep-2011.) @)
    domcnvpre @p |- ( R e. PresetRel -> X = dom `' R ) @=
      ( cpresetrel wcel ccnv cdm crn df-rn preoran2 syl5reqr ) ADEAFGAHBAIABCJK
      @.
  @}

  @( A preset is transitive.  (Contributed by FL, 22-May-2011.) @)
  preotr1 @p |- ( R e. PresetRel -> ( R o. R ) C_ R ) @=
    ( cpresetrel wcel wrel ccom wss cid cuni cres w3a isprsr ibi simp2d ) ABCZA
    DZAAEAFZGAHHIAFZNOPQJBAKLM @.

  @{
    @d A x y z @.  @d B x y z @.  @d C x y z @.  @d R x y z @.
    @( A preset is transitive.  (Contributed by FL, 23-May-2011.)  (Revised by
       Mario Carneiro, 3-May-2015.) @)
    preotr2 @p |- ( ( R e. PresetRel /\ ( A R B /\ B R C ) ) -> A R C ) @=
      ( vx vy vz cpresetrel wcel wbr wa cv wi wal ccom adantrr brrelex2 breq12d
      cvv wceq wss preotr1 adantr cotr sylib simpr wrel preorel brrelex adantrl
      w3a simp1 simp2 simp3 anbi12d imbi12d spc3gv syl3anc sylan mp2d ) DHIZABD
      JZBCDJZKZKZELZFLZDJZVGGLZDJZKZVFVIDJZMZGNFNENZVDACDJZVEDDODUAZVNVAVPVDDUB
      UCEFGDUDUEVAVDUFVADUGZVDVNVDVOMZMZDUHVQVDKASIZBSIZCSIZVSVQVBVTVCABDUIPVQV
      BWAVCABDQPVQVCWBVBBCDQUJVMVREFGABCSSSVFATZVGBTZVICTZUKZVKVDVLVOWFVHVBVJVC
      WFVFAVGBDWCWDWEULZWCWDWEUMZRWFVGBVICDWHWCWDWEUNZRUOWFVFAVICDWGWIRUPUQURUS
      UT @.
  @}

  @( The composite of a preset with itself.  (Contributed by FL,
     13-May-2011.) @)
  altprs2 @p |- ( R e. PresetRel -> ( R o. R ) = R ) @=
    ( cpresetrel wcel ccom wceq wrel wss cid cuni cres w3a isprsr simp2 3adant2
    reflincror eqssd syl6bi pm2.43i ) ABCZAADZAEZSSAFZTAGZHAIIJAGZKZUABALUETAUB
    UCUDMUBUDATGUCAONPQR @.

  @( The intersection of two presets is a preset.  (Contributed by FL,
     28-Dec-2011.) @)
  int2pre @p |- ( ( R e. PresetRel /\ S e. PresetRel )
    -> ( R i^i S ) e. PresetRel ) @=
    ( cpresetrel wcel wa cin wrel ccom wss cid cuni w3a isprsr adantr wi expcom
    cres 3ad2ant2 com12 imp bi2anan9 3ad2ant1 trin2 wceq resindi ss2in wb sseq1
    relin1 eqcoms uuniin ssres2 ax-mp sstr mpan mpsyl 3ad2ant3 3jca pm2.43i cvv
    syl6bi inex1g syl mpbird ) ACDZBCDZEZABFZCDZVHGZVHVHHVHIZJVHKKZQZVHIZLZVGVO
    VGVGAGZAAHAIZJAKKZQZAIZLZBGZBBHBIZJBKKZQZBIZLZEZVOVEVEWAVFVFWGCAMCBMUAWHVJV
    KVNWAVJWGVPVQVJVTABUIUBNWAWGVKVQVPWGVKOVTWGVQVKWCWBVQVKOWFVQWCVKABUCPRSRTWA
    WGVNVTVPWGVNOVQWGVTVNWFWBVTVNOWCVTWFVNJVRWDFZQZVSWEFZUDZVTWFEWKVHIZVNJVRWDU
    EVSAWEBUFWLWMWJVHIZVNWMWNUGWKWJWKWJVHUHUJVMWJIZWNVNVLWIIWOABUKVLWIJULUMVMWJ
    VHUNUOVAUPPUQSUQTURVAUSVGVHUTDZVIVOUGVEWPVFABCVBNUTVHMVCVD @.

  @( A square product is a preset.  (Contributed by FL, 28-Dec-2011.) @)
  sqpre @p |- ( A e. V -> ( A X. A ) e. PresetRel ) @=
    ( wcel cxp cvv cpresetrel xpexg anidms wrel ccom wss cuni cres relxp xpidtr
    cid a1i scprefat isprsr mpbir3and syl ) ABCZAADZECZUCFCZUBUDAABBGHUDUEUCIZU
    CUCJUCKZPUCLLMUCKZUFUDAANQUGUDAOQUHUDARQEUCSTUA @.

  @( The relation induced by a preset on a part of its field is a preset.
     (Contributed by FL, 28-Dec-2011.) @)
  indpre @p |- ( ( R e. PresetRel /\ A e. B )
        -> ( R i^i ( A X. A ) ) e. PresetRel ) @=
    ( wcel cpresetrel cxp cin sqpre int2pre sylan2 ) ABDCEDAAFZEDCKGEDABHCKIJ
    @.

  @( A partial order is a preset.  (Contributed by FL, 1-May-2011.) @)
  posprsr @p |- PosetRel C_ PresetRel @=
    ( vr wrel ccom wss ccnv cin cid cuni cres wceq w3a cab cps cpresetrel inss1
    cv sseq1 mpbiri eqcoms 3anim3i ss2abi df-ps df-prs 3sstr4i ) APZBZUEUECUEDZ
    UEUEEZFZGUEHHIZJZKZALUFUGUJUEDZKZALMNULUNAUKUMUFUGUMUJUIUJUIJUMUIUEDUEUHOUJ
    UIUEQRSTUAAUBAUCUD @.

  @( A poset is a preset.  (Contributed by FL, 19-Sep-2011.) @)
  posispre @p |- ( A e. PosetRel -> A e. PresetRel ) @=
    ( cps cpresetrel posprsr sseli ) BCADE @.

  @( The empty set is a poset.  (Contributed by FL, 6-Oct-2008.) @)
  empos @p |- (/) e. PosetRel @=
    ( cps wcel wrel ccom wss ccnv cin cid cuni cres wceq rel0 co01 eqimssi cnv0
    c0 ineq2i uni0 eqtri cvv res0 unieqi reseq2i inidm 3eqtr4ri w3a wb 0ex isps
    ax-mp mpbir3an ) PABZPCZPPDZPEZPPFZGZHPIZIZJZKZLUNPPMNUQPPGZUTUPPPOQHPJPUTV
    BHUAUSPHUSURPURPRUBRSUCPUDUESPTBULUMUOVAUFUGUHTPUIUJUK @.

  @( The converse of a preset is a preset.  The case
     ` ( ``' R e. PresetRel -> R e. PresetRel ) ` is true only if ` R ` is a
     relation.  See ~ dupre2 .  (Contributed by FL, 5-Jan-2009.) @)
  dupre1 @p |- ( R e. PresetRel -> `' R e. PresetRel ) @=
    ( cpresetrel wcel ccnv wrel ccom wss cid cuni w3a relcnv preorel a1d impbid
    cres a1ii wb syl isprsr cvv relcnvtr relrefcnv 3anbi123d cnvexg 3bitr4d ibi
    ) ABCZADZBCZUGAEZAAFAGZHAIIOAGZJUHEZUHUHFUHGZHUHIIOUHGZJZUGUIUGUJUMUKUNULUO
    UGUJUMUGUJUMAKPUGUJUMALZMNUGUJUKUNQUQAUARUGUJULUOQUQAUBRUCBASUGUHTCUIUPQABU
    DTUHSRUEUF @.

  @( The converse of a preset is a preset.  (Contributed by FL,
     19-Sep-2011.) @)
  dupre2 @p |- ( Rel R -> ( R e. PresetRel <-> `' R e. PresetRel ) ) @=
    ( wrel cpresetrel wcel ccnv dupre1 wceq dfrel2 eleq1 syl5ibr eqcoms impbid2
    wi sylbi ) ABZACDZAEZCDZAFOQEZAGRPMZAHTASRPASGSCDQFASCIJKNL @.

  @{
    @d A r x y @.  @d R r x y @.
    @( An infimum is the supremum of the converse relation.  (Contributed by
       FL, 6-Sep-2009.)  (Revised by Mario Carneiro, 10-Sep-2015.) @)
    nfwval @p |- ( ( R e. U /\ A e. W ) -> ( R infw A ) = ( `' R supw A ) ) @=
      ( vr vx wcel cvv cinf co ccnv cspw wceq elex cv cnveq oveq1d oveq2 df-nfw
      ovex ovmpt2 syl2an ) BCGBHGAHGBAIJBKZALJZMADGBCNADNEFBAHHEOZKZFOZLJUDIUCU
      GLJUEBMUFUCUGLUEBPQUGAUCLRFESUCALTUAUB @.
  @}

  @{
    @d r y a b @.
    @( Define the maximal elements of a set.  I.e. the elements of the set that
       are not smaller than the other elements.  Meaningful if ` r ` is at
       least a preset.  Read ` ( mxl `` R ) ` as the maximal elements of the
       set ` U. U. R ` preordered by ` R ` .  Bourbaki E III 8.  Experimental.
       (Contributed by FL, 16-May-2011.) @)
    df-mxl @a |- mxl = ( r e. _V |->
       { a e. U. U. r | A. b e. U. U. r ( a r b -> a = b ) } ) @.
  @}

  @{
    @d r y a b @.
    @( Define the minimal elements of a set.  I.e. the elements of the set that
       are not greater than the other elements.  Meaningful is ` r ` is at
       least a preset.  Read ` ( mnl `` R ) ` as the minimal elements of the
       set ` U. U. R ` preordered by ` R ` .  Bourbaki E III 8.  Experimental.
       (Contributed by FL, 19-Sep-2011.) @)
    df-mnl @a |- mnl = ( r e. _V |->
       { a e. U. U. r | A. b e. U. U. r ( b r a -> b = a ) } ) @.
  @}

  @{
    @d r y @.
    @( Define the greatest element of a poset.  I.e. the element of the poset
       that is larger than the other elements.  Meaningful is ` r ` is at least
       a poset (otherwise there could be more than one supremum due to
       cycles).  Bourbaki E III 10.  Experimental.  (Contributed by FL,
       19-Sep-2011.) @)
    df-ge @a |- ge = ( r e. _V |-> ( r supw dom r ) ) @.
  @}

  @{
    @d r y @.
    @( Define the least element of a poset.  I.e. the element of the poset that
       is smaller than the other elements.  Meaningful is ` r ` is at least a
       poset.  Experimental.  (Contributed by FL, 19-Sep-2011.) @)
    df-ler @a |- leR = ( r e. _V |-> ( r infw dom r ) ) @.
  @}

  @{
    @d R r x @.  @d X r x @.
    gepsup.1 @e |- X = dom R @.
    @( The greatest element of a poset is the supremum of the poset.
       (Contributed by FL, 19-Sep-2011.) @)
    gepsup @p |- ( R e. A -> ( ge ` R ) = ( R supw X ) ) @=
      ( vr wcel cvv cge cfv cspw co wceq elex cv cdm dmeq syl6eqr oveq12d df-ge
      id ovex fvmpt syl ) BAFBGFBHIBCJKZLBAMEBENZUEOZJKUDGHUEBLZUEBUFCJUGTUGUFB
      OCUEBPDQRESBCJUAUBUC @.
  @}

  @{
    @d R r x @.  @d X r x @.
    seinf.1 @e |- X = dom R @.
    @( The least element of a poset is the infimum of the poset.  (Contributed
       by FL, 19-Sep-2011.) @)
    seinf @p |- ( R e. A -> ( leR ` R ) = ( R infw X ) ) @=
      ( vr wcel cvv cse cfv cinf co wceq elex cv id dmeq syl6eqr oveq12d df-ler
      cdm ovex fvmpt syl ) BAFBGFBHIBCJKZLBAMEBENZUETZJKUDGHUEBLZUEBUFCJUGOUGUF
      BTCUEBPDQRESBCJUAUBUC @.
  @}

  @( The least element of a poset is the greatest element of the converse
     poset.  (Contributed by FL, 30-Dec-2011.) @)
  sege @p |- ( R e. PosetRel -> ( leR ` R ) = ( ge ` `' R ) ) @=
    ( cps wcel cse cfv cdm cinf ccnv cspw cge eqid seinf cvv dmexg nfwval mpdan
    co wceq eqcomd syl cpresetrel posispre domcnvpre cnvps gepsup eqcoms eqeq1d
    oveq2 syl5ibr mpcom 3eqtrd ) ABCZADEAAFZGQZAHZUMIQZUOJEZBAUMUMKZLULUMMCUNUP
    RABNUMABMOPUOFZUMRZULUPUQRZULAUACZUTAUBVBUMUSAUMURUCSTULVAUTUOUSIQZUQRULUQV
    CULUOBCUQVCRAUDBUOUSUSKUETSUTUPVCUQUPVCRUMUSUMUSUOIUHUFUGUIUJUK @.

  @{
    @d r x y a b @.
    @( In French, "majorants". @)
    @( Define the upper bounds of a set ` x ` .  Meaningful if ` r ` is at
       least a preset, and ` x ` a subset of the field of ` r ` .  Bourbaki
       E.III.9 def. 5.  Experimental.  (Contributed by FL, 16-May-2011.) @)
    df-ub @a |- ub = ( r e. _V , x e. _V |->
      { a e. U. U. r | A. b e. x b r a } ) @.

    @( In French, "minorants". @)
    @( Define the lower bounds of a set ` x ` .  Meaningful if ` r ` is at
       least a preset, and ` x ` a subset of the field of ` r ` .
       Experimental.  (Contributed by FL, 16-May-2011.) @)
    df-lb @a |- lb = ( r e. _V , x e. _V |->
       { a e. U. U. r | A. b e. x a r b } ) @.
  @}

  @{
    @d r x y z @.
    @( An antidirected set (also called a set filtering on the left by
       Bourbaki) is a preset whose every pair of elements has a lower bound.
       (Contributed by FL, 17-Oct-2011.) @)
    df-antidir @a |- AntiDir = ( PresetRel i^i
     { r | A. x e. U. U. r A. y e. U. U. r
          E. z e. U. U. r z e. ( r lb { x , y } ) } ) @.
  @}

  @{
    @d A a b r x y @.  @d R a b r x y @.  @d X a r x y @.
    ubos.1 @e |- X = U. U. R @.
    @( The upper bounds of ` A ` .  (Contributed by FL, 16-May-2011.) @)
    ubos @p |- ( ( R e. S /\ A e. B ) -> ( R ub A ) = { a e. X |
      A. b e. A b R a } ) @=
      ( vr vx wcel wa cvv cv wbr wral crab cub wceq cuni co elex anim12i adantr
      fldrels rabexg unieq unieqd rabeq breq ralbidv rabbidv eqcoms mp1i 3eqtrd
      syl raleq df-ub ovmpt2g 3expia sylc ) CDKZABKZLZCMKZAMKZLGNZFNZCOZGAPZFEQ
      ZMKZCARUAVKSZVBVEVCVFCDUBABUBUCVDEMKZVLVBVNVCCDEHUEUDVJFEMUFUPVEVFVLVMIJC
      AMMVGVHINZOZGJNZPZFVOTZTZQZVKRVIGVQPZFEQZMVOCSZWAVRFCTZTZQZWBFWFQZWCWDVTW
      FSWAWGSWDVSWEVOCUGUHVRFVTWFUIUPWDVRWBFWFWDVPVIGVQVGVHVOCUJUKULEWFSWHWCSZW
      DHWIWFEWBFWFEUIUMUNUOVQASWBVJFEVIGVQAUQULJIFGURUSUTVA @.
  @}

  @{
    @d A a b r x y @.  @d R a b r x y @.  @d X a @.
    ubos2.1 @e |- X = dom R @.
    @( The upper bounds of ` A ` .  (Contributed by FL, 18-Sep-2011.)  (Revised
       by Mario Carneiro, 10-Sep-2015.) @)
    ubos2 @p |- ( ( R e. PresetRel /\ A e. B ) -> ( R ub A ) = { a e. X |
      A. b e. A b R a } ) @=
      ( cpresetrel wcel wa cub co cv wbr wral cuni crab eqid ubos wceq preodom2
      cdm syl5eq adantr rabeq syl eqtr4d ) CHIZABIZJZCAKLFMEMCNFAOZECPPZQZUKEDQ
      ZABCHULEFULRSUJDULTZUNUMTUHUOUIUHDCUBULGCUAUCUDUKEDULUEUFUG @.
  @}

  @{
    @d A b x @.  @d R b x @.  @d U b x @.  @d X x @.
    puub2.1 @e |- X = dom R @.
    @( The predicate " ` U ` is an upper bound of ` A ` ."  (Contributed by FL,
       16-May-2011.) @)
    puub2 @p |- ( ( R e. PresetRel /\ A e. B ) -> ( U e. ( R ub A )
      <-> ( U e. X /\ A. b e. A b R U ) ) ) @=
      ( vx cpresetrel wcel wa cub co cv wbr wral crab ubos2 eleq2d wceq ralbidv
      breq2 elrab syl6bb ) CIJABJKZDCALMZJDFNZHNZCOZFAPZHEQZJDEJUGDCOZFAPZKUEUF
      UKDABCEHFGRSUJUMHDEUHDTUIULFAUHDUGCUBUAUCUD @.
  @}

  @{
    @d A a b @.  @d R a b @.  @d U a b @.  @d X a @.
    puub.1 @e |- X = U. U. R @.
    @( The predicate " ` U ` is an upper bound of ` A ` ."  (Contributed by FL,
       16-May-2011.) @)
    puub @p |- ( ( R e. S /\ A e. B ) -> ( U e. ( R ub A ) <-> ( U e. X /\
      A. b e. A b R U ) ) ) @=
      ( va wcel wa cub co cv wbr wral crab ubos eleq2d wceq breq2 ralbidv elrab
      syl6bb ) CDJABJKZECALMZJEGNZINZCOZGAPZIFQZJEFJUGECOZGAPZKUEUFUKEABCDFIGHR
      SUJUMIEFUHETUIULGAUHEUGCUAUBUCUD @.
  @}

  @{
    @d b A @.  @d b B @.  @d b R @.  @d b U @.  @d b V @.
    @( If ` R ` is a preset, ` U R V ` and ` U ` is an upper bound of ` A `
       then ` V ` is an upper bound of ` A ` .  Bourbaki E.III.9 nb 8.
       (Contributed by FL, 23-May-2011.)  (Proof shortened by Mario Carneiro,
       3-May-2015.) @)
    prltub @p |- ( ( R e. PresetRel /\ A e. B /\
      ( U e. ( R ub A ) /\ U R V ) ) -> V e. ( R ub A ) ) @=
      ( vb cpresetrel wcel cub co wbr wa w3a cdm cv wral simp1 wb puub2 3adant3
      simp3r eqid pre2befi2 syl2anc simp3l mpbid simprd preotr2 3ad2ant1 mpan2d
      wi ex ralimdv mpd mpbir2and ) CGHZABHZDCAIJZHZDECKZLZMZEURHZECNZHZFOZECKZ
      FAPZVBUPUTVEUPUQVAQUPUQUSUTUAZDECVDVDUBZUCUDVBVFDCKZFAPZVHVBDVDHZVLVBUSVM
      VLLZUPUQUSUTUEUPUQUSVNRVAABCDVDFVJSTUFUGVBVKVGFAVBVKUTVGVIUPUQVKUTLZVGUKV
      AUPVOVGVFDECUHULUIUJUMUNUPUQVCVEVHLRVAABCEVDFVJSTUO @.
  @}

  @{
    @d A x @.  @d B x @.  @d R x @.  @d U x @.
    @( If ` U ` is an upper bound of ` A ` and ` B C_ A ` then ` U ` is an
       upper bound of ` B ` .  Bourbaki E.III.9 n 8.  (Contributed by FL,
       23-May-2011.) @)
    ubpar @p |- ( ( R e. PresetRel /\ A e. C /\ B C_ A )
      -> ( U e. ( R ub A ) -> U e. ( R ub B ) ) ) @=
      ( vx cpresetrel wcel wss w3a cub co cdm cv wbr wral wa wi puub2 cvv com12
      biimpd 3adant3 simprl ssralv 3ad2ant3 adantl impcom wb simp1 ssexg ancoms
      eqid 3adant1 jca adantr syl mpbir2and ex syld ) DGHZACHZBAIZJZEDAKLHZEDMZ
      HZFNEDOZFAPZQZEDBKLHZVAVBVEVJRVCVAVBQVEVJACDEVFFVFUMZSUBUCVDVJVKVDVJQZVKV
      GVHFBPZVDVGVIUDVJVDVNVIVDVNRVGVDVIVNVCVAVIVNRVBVHFBAUEUFUAUGUHVMVABTHZQZV
      KVGVNQUIVDVPVJVDVAVOVAVBVCUJVBVCVOVAVCVBVOBACUKULUNUOUPBTDEVFFVLSUQURUSUT
      @.
  @}

  @{
    @d A x y z @.  @d R x y z @.  @d X x y @.
    supdef.1 @e |- X = dom R @.
    @( If it exists, a supremum of ` A ` is greater or equal to every element
       of ` A ` and is the least upper bound of ` A ` .  Here the existence of
       the supremum is expressed by the idiom ` ( R supw A ) e. X ` .
       (Contributed by FL, 23-May-2011.) @)
    supdef @p |- ( ( R e. PosetRel /\ A e. W /\ ( R supw A ) e. X ) ->
       ( A. y e. A y R ( R supw A ) /\
         A. y e. X ( A. z e. A z R y -> ( R supw A ) R y ) ) ) @=
      ( vx cps wcel cspw cv wbr wral wi wa wceq cvv syl ralbidv w3a crab spwval
      co crio 3adant3 wreu cdm dmexg syl5eqel 3ad2ant1 simp3 eqeltrrd riotaclbg
      biimpar syl2anc riotacl2 eqeltrd breq2 breq1 imbi2d anbi12d elrab simprbi
      ) DIJZCEJZDCKUDZFJZUAZVGALZHLZDMZACNZBLVJDMBCNZVKVJDMZOZAFNZPZHFUBZJZVJVG
      DMZACNZVNVGVJDMZOZAFNZPZVIVGVRHFUEZVSVEVFVGWGQVHHABCDEFGUCUFZVIVRHFUGZWGV
      SJVIFRJZWGFJZWIVEVFWJVHVEFDUHRGDIUIUJUKVIVGWGFWHVEVFVHULUMWJWIWKVRHFRUNUO
      UPVRHFUQSURVTVHWFVRWFHVGFVKVGQZVMWBVQWEWLVLWAACVKVGVJDUSTWLVPWDAFWLVOWCVN
      VKVGVJDUTVATVBVCVDS @.
  @}

  @{
    @d A x @.  @d R x y @.  @d X x y @.
    supdefa.1 @e |- X = dom R @.
    @( The greatest element of a poset is greater than the other elements of
       the poset.  (Contributed by FL, 19-Sep-2011.) @)
    supdefa @p |- ( ( R e. PosetRel /\ A e. X /\ ( R supw X ) e. X )
       -> A R ( R supw X ) ) @=
      ( vx vy cps wcel cspw co w3a cv wbr wral simp2 wi cvv wa cdm dmexg supdef
      syl5eqel 3ad2ant1 syld3an2 simpld breq1 rspcv sylc ) BGHZACHZBCIJZCHZKZUJ
      ELZUKBMZECNZAUKBMZUIUJULOUMUPFLUNBMFCNUKUNBMPECNZUICQHZUJULUPURRUIUJUSULU
      ICBSQDBGTUBUCEFCBQCDUAUDUEUOUQEACUNAUKBUFUGUH @.
  @}

  @{
    @d R a b r x @.  @d X a r x @.
    mxlelt.1 @e |- X = U. U. R @.
    @( The maximal elements of the preset ` R ` .  (Contributed by FL,
       16-May-2011.)  (Revised by Mario Carneiro, 11-Sep-2015.) @)
    mxlelt @p |- ( R e. S -> ( mxl ` R ) = { a e. X | A. b e. X ( a R b
      -> a = b ) } ) @=
      ( vr wcel cvv cv wbr wceq wi wral crab cmxl cfv elex fldrels cuni syl6eqr
      rabexg syl unieq unieqd eleq2d breq imbi1d imbi12d ralbidv2 df-mxl fvmptg
      rabeqbidv syl2anc ) ABHZAIHDJZEJZAKZUPUQLZMZECNZDCOZIHZAPQVBLABRUOCIHVCAB
      CFSVADCIUBUCGAUPUQGJZKZUSMZEVDTZTZNZDVHOVBIIPVDALZVIVADVHCVJVHATZTCVJVGVK
      VDAUDUEFUAZVJVFUTEVHCVJUQVHHUQCHVFUTVJVHCUQVLUFVJVEURUSUPUQVDAUGUHUIUJUMG
      DEUKULUN @.
  @}

  @{
    @d R a b r x @.  @d X a b @.
    mxlelt2.1 @e |- X = dom R @.
    @( The maximal elements of the preset ` R ` .  (Contributed by FL,
       16-May-2011.)  (Revised by Mario Carneiro, 11-Sep-2015.) @)
    mxlelt2 @p |- ( R e. PresetRel
      -> ( mxl ` R ) = { a e. X | A. b e. X ( a R b -> a = b ) } ) @=
      ( cpresetrel wcel cmxl cfv cv wbr weq cuni wral crab eqid mxlelt preodom2
      wi cdm syl5eq raleqdv rabeqbidv eqtr4d ) AFGZAHICJDJAKCDLSZDAMMZNZCUGOUFD
      BNZCBOAFUGCDUGPQUEUIUHCBUGUEBATUGEARUAZUEUFDBUGUJUBUCUD @.
  @}

  @{
    @d R a b r x @.  @d X a b @.
    mnlelt2.1 @e |- X = dom R @.
    @( The minimal elements of the preset ` R ` .  (Contributed by FL,
       19-Sep-2011.) @)
    mnlelt2 @p |- ( R e. PresetRel
     -> ( mnl ` R ) = { a e. X | A. b e. X ( b R a -> b = a ) } ) @=
      ( vr cpresetrel wcel cmnl cfv cv wbr wceq wi cuni wral crab cvv rabeqbidv
      uniexg elex rabexg 3syl unieq unieqd breq imbi1d raleqbidv df-mnl syl2anc
      fvmptg cdm preodom2 syl5eq raleqdv eqtr4d ) AGHZAIJZDKZCKZALZUSUTMZNZDAOZ
      OZPZCVEQZVCDBPZCBQUQARHVGRHZURVGMAGUAUQVDRHVERHVIAGTVDRTVFCVERUBUCFAUSUTF
      KZLZVBNZDVJOZOZPZCVNQVGRRIVJAMZVOVFCVNVEVPVMVDVJAUDUEZVPVLVCDVNVEVQVPVKVA
      VBUSUTVJAUFUGUHSFCDUIUKUJUQVHVFCBVEUQBAULVEEAUMUNZUQVCDBVEVRUOSUP @.
  @}

  @{
    @d A a b @.  @d R a b @.  @d X a b @.
    ismxl2.1 @e |- X = dom R @.
    @( The predicate " ` A ` is a maximal element of the preset ` R ` " .
       (Contributed by FL, 22-May-2011.) @)
    ismxl2 @p |- ( R e. PresetRel -> ( A e. ( mxl ` R ) <->
       ( A e. X /\ A. b e. X ( A R b -> A = b ) ) ) ) @=
      ( va cpresetrel wcel cmxl cfv cv wbr weq wi wral crab wceq mxlelt2 eleq2d
      wa breq1 eqeq1 imbi12d ralbidv elrab syl6bb ) BGHZABIJZHAFKZDKZBLZFDMZNZD
      COZFCPZHACHAUJBLZAUJQZNZDCOZTUGUHUOABCFDERSUNUSFACUIAQZUMURDCUTUKUPULUQUI
      AUJBUAUIAUJUBUCUDUEUF @.
  @}

  @{
    @d A b x @.  @d R b x @.  @d X b x @.
    ismnl2.1 @e |- X = dom R @.
    @( The predicate " ` A ` is a minimal element of the preset ` R ` " .
       (Contributed by FL, 19-Sep-2011.) @)
    ismnl2 @p |- ( R e. PresetRel -> ( A e. ( mnl ` R ) <->
       ( A e. X /\ A. b e. X ( b R A -> b = A ) ) ) ) @=
      ( vx cpresetrel wcel cmnl cfv cv wbr weq wi wral crab wceq mnlelt2 eleq2d
      wa breq2 eqeq2 imbi12d ralbidv elrab syl6bb ) BGHZABIJZHADKZFKZBLZDFMZNZD
      COZFCPZHACHUIABLZUIAQZNZDCOZTUGUHUOABCFDERSUNUSFACUJAQZUMURDCUTUKUPULUQUJ
      AUIBUAUJAUIUBUCUDUEUF @.
  @}

  @{
    @d R x y @.
    @( The minimal elements of a preset are the maximal elements of the
       converse preset.  (Contributed by FL, 19-Sep-2011.) @)
    mnlmxl2 @p |- ( R e. PresetRel -> ( mnl ` R ) = ( mxl ` `' R ) ) @=
      ( vy vx cpresetrel wcel cv wbr weq wi cdm wral crab ccnv cmnl cfv cmxl wb
      eqid cvv vex domcnvpre wa brcnvg bicomd mp2an imbi12i raleqbidv rabeqbidv
      equcom a1i mnlelt2 wceq dupre1 mxlelt2 syl 3eqtr4d ) ADEZBFZCFZAGZBCHZIZB
      AJZKZCVCLUSURAMZGZCBHZIZBVEJZKZCVILZANOVEPOZUQVDVJCVCVIAVCVCRZUAZUQVBVHBV
      CVIVNVBVHQUQUTVFVAVGUSSEZURSEZUTVFQCTBTVOVPUBVFUTUSURSSAUCUDUEBCUIUFUJUGU
      HAVCCBVMUKUQVEDEVLVKULAUMVEVICBVIRUNUOUP @.
  @}

  @{
    @( The maximal elements of a preset are the minimal elements of the
       converse preset.  (Contributed by FL, 19-Sep-2011.) @)
    mxlmnl2 @p |- ( R e. PresetRel -> ( mxl ` R ) = ( mnl ` `' R ) ) @=
      ( ccnv wceq cpresetrel wcel cmxl cmnl wrel preorel dfrel2 sylib wi dupre1
      cfv mnlmxl2 syl eqcomd fveq2 eqeq1d syl5ibr eqcoms mpcom ) ABZBZACZADEZAF
      NZUCGNZCZUFAHUEAIAJKUFUILAUDUFUIAUDCZUDFNZUHCUFUHUKUFUCDEUHUKCAMUCOPQUJUG
      UKUHAUDFRSTUAUB @.
  @}

  @{
    @d R x y @.  @d X x y @.
    defge3.1 @e |- X = dom R @.
    @( The greatest element of a poset is an element, when it exists, that is
       greater than the other elements of the poset.  Use the idiom
       ` ( ge `` R ) e. X ` when you mean the greatest element of ` X `
       exists.  (Contributed by FL, 30-Dec-2011.) @)
    defge3 @p |- ( ( R e. PosetRel /\ ( ge ` R ) e. X )
       -> A. x e. X x R ( ge ` R ) ) @=
      ( vy cps wcel cge cfv cv wbr wral cspw co wceq wa wi gepsup cvv simpl cdm
      dmexg syl5eqel adantr supdef syl3anc simpld anbi2d ralbidv imbi12d mpbiri
      simpr eleq1 breq2 syl anabsi5 ) BFGZBHIZCGZAJZURBKZACLZUQURBCMNZOZUQUSPZV
      BQZFBCDRVDVFUQVCCGZPZUTVCBKZACLZQVHVJEJUTBKECLVCUTBKQACLZVHUQCSGZVGVJVKPU
      QVGTUQVLVGUQCBUASDBFUBUCUDUQVGULAECBSCDUEUFUGVDVEVHVBVJVDUSVGUQURVCCUMUHV
      DVAVIACURVCUTBUNUIUJUKUOUP @.
  @}

  @{
    @d R x @.  @d X x @.
    defse3.1 @e |- X = dom R @.
    @( The least element of a poset is an element, when it exists, that is less
       than the other elements of the poset.  Use the idiom
       ` ( leR `` R ) e. X ` when you mean the least element of ` X ` exists.
       (Contributed by FL, 30-Dec-2011.) @)
    defse3 @p |- ( ( R e. PosetRel /\ ( leR ` R ) e. X )
       -> A. x e. X ( leR ` R ) R x ) @=
      ( cps wcel cse cfv wbr wral cge wceq wi cdm eqid syl imbi12d eqcoms mpcom
      syl5ibr cv ccnv sege cpresetrel posispre domcnvpre eqcomd wa cnvps defge3
      eqtr ex eleq2 raleq expcom ax-mp vex fvex brcnv bicomi ralbii eleq1 breq1
      syl6ibr ralbidv imp ) BEFZBGHZCFZVHAUAZBIZACJZVHBUBZKHZLZVGVIVLMZBUCVGVPV
      OVNCFZVNVJBIZACJZMVGVQVJVNVMIZACJZVSVMNZBNZLZVGVQWAMZVGBUDFZWDBUEWFWCWBBW
      CWCOUFUGPCWCLWDVGWEMZMZDWHWCCWDWCCLZWGWDWIUHWBCLWGWBWCCUKWGCWBVGWECWBLZVN
      WBFZVTAWBJZMZVGVMEFZWMBUIWNWKWLAVMWBWBOUJULPWJVQWKWAWLCWBVNUMVTACWBUNQTRP
      UORUPSVRVTACVTVRVJVNBAUQVMKURUSUTVAVDVOVIVQVLVSVHVNCVBVOVKVRACVHVNVJBVCVE
      QTSVF @.
  @}

  @( If the underlying set of a PresetRel is not empty, the PresetRel is not
     empty . See ~ reldm0 . @)

  @{
    @d A x y @.  @d R x y @.  @d X x @.
    supaub.1 @e |- X = dom R @.
    @( If it exists, a supremum of ` A ` is an upper bound for ` A ` .
       (Contributed by FL, 19-Sep-2011.) @)
    supaub @p |- ( ( R e. PosetRel /\ A e. W /\ ( R supw A ) e. X ) ->
        ( R supw A ) e. ( R ub A ) ) @=
      ( vx vy cps wcel cspw co w3a cub cdm cv wbr wral eleq2i biimpi 3ad2ant3
      wi supdef simpld wa wb cpresetrel posispre puub2 sylan 3adant3 mpbir2and
      eqid ) BHIZACIZBAJKZDIZLZUOBAMKIZUOBNZIZFOZUOBPFAQZUPUMUTUNUPUTDUSUOERSTU
      QVBGOVABPGAQUOVABPUAFDQFGABCDEUBUCUMUNURUTVBUDUEZUPUMBUFIUNVCBUGACBUOUSFU
      SULUHUIUJUK @.
  @}

  @{
    @d A x z @.  @d R x z @.  @d W x @.  @d X x @.
    supwlub.1 @e |- X = dom R @.
    @( If it exists, a supremum of ` A ` is the least upper bound for ` A ` .
       (Contributed by FL, 19-Sep-2011.) @)
    supwlub @p |- ( ( R e. PosetRel /\ A e. W /\ ( R supw A ) e. X ) ->
        A. x e. ( R ub A ) ( R supw A ) R x ) @=
      ( vz cps wcel cspw co w3a cv wbr cub cdm wral wa wi wb cpresetrel 3adant3
      posispre eqid puub2 sylan eleq2i supdef syl3an3b simprd r19.21bi ex com3l
      imp syl6bi pm2.43a ralrimiv ) CHIZBDIZCBJKZEIZLZUTAMZCNZACBOKZVCVEIZVBVDV
      BVFVCCPZIZGMVCCNGBQZRZVBVDSZURUSVFVJTZVAURCUAIUSVLCUCBDCVCVGGVGUDZUEUFUBV
      HVIVKVBVHVIVDVBVHVIVDSZVBVNAVGVBVCUTCNABQZVNAVGQZVAURUSUTVGIVOVPREVGUTFUG
      AGBCDVGVMUHUIUJUKULUMUNUOUPUQ @.
  @}

  @{
    @d R x @.  @d X x @.
    geme2.1 @e |- X = dom R @.
    @( The greatest element of ` X ` is a maximal element.  (Contributed by FL,
       19-Sep-2011.) @)
    geme2 @p |- ( ( R e. PosetRel /\ ( R supw X ) e. X ) ->
     ( R supw X ) e. ( mxl ` R ) ) @=
      ( vx cps wcel cspw co wa cmxl cfv cdm cv wbr wceq wral eleq2i biimpi w3a
      wi adantl simpll simpr oveq2i eleq12i ad2antlr eqid supdefa syl3anc oveq2
      breq2d 3anbi3d psasym syl6bi eqcoms ax-mp 3exp com23 ralrimiva cpresetrel
      sylc wb posispre ismxl2 syl adantr mpbir2and ) AEFZABGHZBFZIZVIAJKFZVIALZ
      FZVIDMZANZVIVOOZTZDVMPZVJVNVHVJVNBVMVICQRUAVKVRDVMVKVOVMFZIZVHVOAVMGHZANZ
      VRVHVJVTUBZWAVHVTWBVMFZWCWDVKVTUCVJWEVHVTVJWEVIWBBVMBVMAGCUDCUERUFVOAVMVM
      UGZUHUIVHVPWCVQVHVPWCVQBVMOVHVPWCSZVQTZCWHVMBVMBOZWGVHVPVOVIANZSVQWIWCWJV
      HVPWIWBVIVOAVMBAGUJUKULVIVOAUMUNUOUPUQURVAUSVHVLVNVSIVBZVJVHAUTFWKAVCVIAV
      MDWFVDVEVFVG @.
  @}

  @{
    @d A x y @.  @d B x y @.
    inposetlem.1 @e |- A e. _V @.
    inposetlem.2 @e |- B e. _V @.
    inposetlem.3 @e |- C = { <. x , y >. | x C_ y } @.
    @( Lemma for ~ inposet .  Definition of inclusion of sets using a class.
       (Contributed by FL, 22-Sep-2008.) @)
    inposetlem @p |- ( A C B <-> A C_ B ) @=
      ( cv wss sseq1 sseq2 brab ) AIZBIZJCOJCDJABCDEFGNCOKODCLHM @.
  @}

  @{
    @d x y @.
    inpc.1 @e |- C = { <. x , y >. | x C_ y } @.
    @( Inclusion is a proper class.  (Contributed by FL, 22-Sep-2008.) @)
    inpc @p |- -. C e. _V @=
      ( cvv wcel cdm vprc cv wss copab wex dmeqi dmopab wceq abeq1 ssid equcomi
      cab wb sseq2d biimpd spimev ax-mp vex 2th mpgbir 3eqtri eleq1i mtbir mto
      dmexg ) CEFCGZEFZUNEEFHUMEEUMAIZBIZJZABKZGUQBLZASZECURDMUQABNUTEOUSUOEFZT
      AUSAEPUSVAUOUOJZUSUOQVBUQBAUPUOOZVBUQVCUOUPUOBARUAUBUCUDAUEUFUGUHUIUJCEUL
      UK @.
  @}

  @{
    @d A a b x y z @.  @d C a b x y z @.
    inposet.1 @e |- C = { <. x , y >. | x C_ y } @.
    @( Inclusion partially orders any set.  (Contributed by FL,
       22-Sep-2008.) @)
    inposet @p |- ( A e. B -> ( C i^i ( A X. A ) ) e. PosetRel ) @=
      ( vz va vb wcel cin wss cuni w3a cv wbr wa brinxp2 wi inposetlem cxp wrel
      cps ccom ccnv cid cres wceq relxp ax-mp wex copab weq breq1 sseq1 imbi12d
      relin2 imbi2d breq2 sseq2 vex sstr2 sylbi com12 chvarv 3ad2ant3 imp simp1
      simp2 anim12i jca syl2anb exlimiv df-co ineq1i df-xp ineq2i inopab 3eqtri
      ssopab2i 3sstr4i wb wal asymref uniin uniss sseli sseldi elin cun unixpss
      unidm syl6eleq adantl anbi12i eqss simplbi2com a1i syl5bi mpbir syl3anbrc
      id ssid anidmdbi eleq1 anbi12d mpbiri impbid alrimiv 3syl mprgbir 3pm3.2i
      cvv xpexg anidms incom inex1g syl5eqel isps ) CDJZECCUAZKZUCJZYBUBZYBYBUD
      ZYBLZYBYBUEKUFYBMZMZUGUHZNZYDYFYIYAUBYDCCUIEYAUQUJAOZGOZYBPZYLBOZYBPZQZGU
      KZABULYKYNLZYKCJZYNCJZQZQZABULZYEYBYQUUBABYPUUBGYMYSYLCJZYKYLEPZNZUUDYTYL
      YNEPZNZUUBYOYKYLCCERYLYNCCERUUFUUHQYRUUAUUFUUHYRUUEYSUUHYRSUUDUUHUUEYRUUG
      UUDUUEYRSZYTUUGHOZYLEPZUUJYNLZSZSZUUGUUISHAHAUMZUUMUUIUUGUUOUUKUUEUULYRUU
      JYKYLEUNUUJYKYNUOUPURYLIOZEPZUUKUUJUUPLZSZSUUNIBIBUMZUUQUUGUUSUUMUUPYNYLE
      USUUTUURUULUUKUUPYNUUJUTURUPUUQYLUUPLZUUSABYLUUPEGVAZIVAZFTUUKUVAUURUUKUU
      JYLLUVAUURSABUUJYLEHVAZUVBFTUUJYLUUPVBVCVDVCVEVEVFVDVFVGUUFYSUUHYTYSUUDUU
      EVHUUDYTUUGVIVJVKVLVMVTABGYBYBVNYBYRABULZYAKUVEUUAABULZKUUCEUVEYAFVOYAUVF
      UVEABCCVPVQYRUUAABVRVSWAYIUUJUUPYBPZUUPUUJYBPZQZHIUMZWBZIWCZHYHHIYBWDUUJY
      HJZUUJEMZMZYAMZMZKZJZUUJCJZUVLUVMUVNUVPKZMZUVRUUJUVNUVPWEYHUWBUUJYGUWALYH
      UWBLEYAWEYGUWAWFUJWGWHUVSUUJUVOJZUUJUVQJZQUVTUUJUVOUVQWIUWDUVTUWCUWDUUJCC
      WJZCUVQUWEUUJCCWKWGCWLWMWNVCUVTUVKIUVTUVIUVJUVIUVTUUPCJZUUJUUPEPZNZUWFUVT
      UUPUUJEPZNZQZUVTUVJUVGUWHUVHUWJUUJUUPCCERUUPUUJCCERWOUWKUVJSUVTUWHUWJUVJU
      WGUVTUWJUVJSZUWFUWGUURUWLABUUJUUPEUVDUVCFTUWJUURUVJUWIUWFUURUVJSZUVTUWIUU
      PUUJLZUWMABUUPUUJEUVCUVDFTUVJUURUWNUUJUUPWPWQVCVFVDVCVFVGWRWSUVJUVTUVIUVJ
      UVTUVISUWFUUPUUPYBPZUWOQZSZUWQUWFUWOSUWFUWFUWFUUPUUPEPZUWOUWFXBZUWSUWRUWF
      UWRUUPUUPLUUPXCABUUPUUPEUVCUVCFTWTWRUUPUUPCCERXAUWFUWOXDWTUVJUVTUWFUVIUWP
      UUJUUPCXEUVJUVGUWOUVHUWOUUJUUPUUPYBUNUUJUUPUUPYBUSXFUPXGVDXHXIXJXKXLXTYAX
      MJZYBXMJYCYJWBXTUWTCCDDXNXOUWTYBYAEKXMEYAXPYAEXMXQXRXMYBXSXJXG @.
  @}

  @{
    @d F x y @.  @d G x y @.
    definc.1 @e |- G e. X @.
    definc.2 @e |- F e. Y @.
    definc.3 @e |- C = { <. x , y >. | x C_ y } @.
    @( Note: remove definc. 1 using opelxp1. @)
    @( Definition of the inclusion.  (Contributed by FL, 6-Sep-2009.) @)
    definc @p |- ( G ( C i^i ( A X. B ) ) F <->
      ( G e. A /\ F e. B /\ G C_ F ) ) @=
      ( cxp cin wbr wa wss wcel w3a elexi brin inposetlem anbi12i simprl simprr
      brxp simpl 3jca simp3 3simpa jca impbii 3bitri ) GFECDMZNOGFEOZGFUNOZPGFQ
      ZGCRZFDRZPZPZURUSUQSZGFEUNUAUOUQUPUTABGFEGHJTFIKTLUBGFCDUFUCVAVBVAURUSUQU
      QURUSUDUQURUSUEUQUTUGUHVBUQUTURUSUQUIURUSUQUJUKULUM @.
  @}

  @{
    @d C x @.  @d x y @.
    dominc.1 @e |- C = { <. x , y >. | x C_ y } @.
    @( The domain of the inclusion relation is ` _V ` .  (Contributed by FL,
       6-Sep-2009.) @)
    dominc @p |- dom C = _V @=
      ( cdm cvv wceq cv wcel eqv wss wex cab ssid wb sseq2 equcoms biimpd ax-mp
      spimev abid mpbir copab dmeqi dmopab eqtri eleqtrri mpgbir ) CEZFGAHZUIIA
      AUIJUJUJBHZKZBLZAMZUIUJUNIUMUJUJKZUMUJNUOULBAUKUJGUOULUOULOABUJUKUJPQRTSU
      MAUAUBUIULABUCZEUNCUPDUDULABUEUFUGUH @.
  @}

  @{
    @d C y @.  @d x y @.
    rninc.1 @e |- C = { <. x , y >. | x C_ y } @.
    @( The range of the inclusion relation is ` _V ` .  (Contributed by FL,
       6-Sep-2009.) @)
    rninc @p |- ran C = _V @=
      ( crn cvv wceq cv wcel eqv wss wex cab ssid wb sseq1 equcoms biimpd ax-mp
      spimev abid mpbir copab rneqi rnopab eqtri eleqtrri mpgbir ) CEZFGBHZUIIB
      BUIJUJAHZUJKZALZBMZUIUJUNIUMUJUJKZUMUJNUOULABUKUJGUOULUOULOBAUJUKUJPQRTSU
      MBUAUBUIULABUCZEUNCUPDUDULABUEUFUGUH @.
  @}

  @{
    @d A x y @.
    domncnt.1 @e |- C = { <. x , y >. | x C_ y } @.
    @( Domain of the intersection of the inclusion with a square cross
       product.  (Contributed by FL, 6-Sep-2009.) @)
    domncnt @p |- dom ( C i^i ( A X. A ) ) = A @=
      ( cxp cin cdm cv wss copab wa df-xp dmeqi simprl simprr simpl jca32 eqtri
      wcel ineq12i inopab impbii opabbii wral wceq wrex ssid sseq2 rspcev mpan2
      wex df-rex sylib rgen dmopab3 mpbi ) DCCFZGZHAIZBIZJZABKZUTCTZVACTZLZABKZ
      GZHZCUSVHDVCURVGEABCCMUANVIVDVEVBLZLZABKZHZCVHVLVHVBVFLZABKVLVBVFABUBVNVK
      ABVNVKVNVDVEVBVBVDVEOVBVDVEPVBVFQRVKVBVDVEVDVEVBPVDVJQVDVEVBORUCUDSNVJBUL
      ZACUEVMCUFVOACVDVBBCUGZVOVDUTUTJZVPUTUHVBVQBUTCVAUTUTUIUJUKVBBCUMUNUOVJAB
      CUPUQSS @.
  @}

  @{
    @d A x y @.
    ranncnt.1 @e |- C = { <. x , y >. | x C_ y } @.
    @( Range of the intersection of the inclusion with a square cross product.
       (Contributed by FL, 6-Sep-2009.) @)
    ranncnt @p |- ran ( C i^i ( A X. A ) ) = A @=
      ( cxp cin crn cv wss copab wcel wa df-xp rneqi eqtri cdm dmeqi jca 3eqtri
      ineq12i incom inopab ccnv df-rn cnvopab simplr simpll simpr simprl simprr
      simpl impbii opabbii wral wceq ssid wrex sseq1 rspcev ancoms df-rex sylib
      wex mpan rgen dmopab3 mpbi ) DCCFZGZHAIZBIZJZABKZVKCLZVLCLZMZABKZGZHVQVMM
      ZABKZHZCVJVSDVNVIVREABCCNUAOVSWAVSVRVNGWAVNVRUBVQVMABUCPOWBWAUDZQVTBAKZQZ
      CWAUEWCWDVTABUFRWEVPVOVMMZMZBAKZQZCWDWHVTWGBAVTWGVTVPWFVOVPVMUGVTVOVMVOVP
      VMUHVQVMUISSWGVQVMWGVOVPVPVOVMUJVPWFULSVPVOVMUKSUMUNRWFAVDZBCUOWICUPWJBCV
      LVLJZVPWJVLUQWKVPMVMACURZWJVPWKWLVMWKAVLCVKVLVLUSUTVAVMACVBVCVEVFWFBACVGV
      HPTT @.
  @}

  @{
    @( Value of an infimum under a weak ordering.  (Contributed by FL,
       19-Sep-2011.) @)
    supwval @p |- ( ( Rel R /\ R e. U /\ A e. W ) ->
       ( R supw A ) = ( `' R infw A ) ) @=
      ( wrel wcel w3a cspw co ccnv cinf wceq dfrel2 oveq1 eqcoms sylbi 3ad2ant1
      cvv cnvexg 3ad2ant2 simp3 wa nfwval eqcomd syl2anc eqtrd ) BEZBCFZADFZGZB
      AHIZBJZJZAHIZULAKIZUGUHUKUNLZUIUGUMBLUPBMUPBUMBUMAHNOPQUJULRFZUIUNUOLUHUG
      UQUIBCSTUGUHUIUAUQUIUBUOUNAULRDUCUDUEUF @.
  @}

  @{
    @( Infimum of an unordered pair of comparable elements.  (Contributed by
       FL, 19-Sep-2011.) @)
    nfwpr4c @p |- ( ( R e. PosetRel /\ A R B ) -> ( R infw { A , B } ) = A ) @=
      ( cps wcel wbr wa cpr cinf co ccnv cspw cvv wceq simpl nfwval prcom sylan
      prex syl2anc oveq2i syl6eq sylancl cnvps adantr simpr wrel psrel brrelex2
      wb brrelex brcnvg mpbird spwpr4c eqtrd ) CDEZABCFZGZCABHZIJZCKZBAHZLJZAUR
      UPUSMEZUTVCNUPUQOABSUPVDGUTVAUSLJVCUSCDMPUSVBVALABQUAUBUCURVADEZBAVAFZVCA
      NUPVEUQCUDUEURVFUQUPUQUFURBMEZAMEZVFUQUJUPCUGZUQVGCUHZABCUIRUPVIUQVHVJABC
      UKRBAMMCULTUMBAVAUNTUO @.
  @}

  @{
    @d u v x @.
    @( A totally ordered set is a lattice.  (Contributed by FL,
       19-Sep-2011.) @)
    tolat @p |- TosetRel C_ LatRel @=
      ( vx vu vv ctsr cla cv wcel wbr wral wa cpr cspw cinf wceq spwpr4c ancoms
      co pre2befi2 sylan eqeltrd cps wo cdm wi cpresetrel posispre eqid nfwpr4c
      vex breldm adantr jca ex wb prcom oveq2 eleq1d ax-mp sylibr syl5eqel jaoi
      oveq2i com12 ralimdv imdistani istsr2 isla 3imtr4i ssriv ) ADEAFZUAGZBFZC
      FZVJHZVMVLVJHZUBZCVJUCZIZBVQIZJVKVJVLVMKZLQZVQGZVJVTMQZVQGZJZCVQIZBVQIZJV
      JDGVJEGVKVSWGVKVRWFBVQVKVPWECVQVPVKWEVNVKWEUDVOVNVKWEVNVKJZWBWDWHWAVMVQVK
      VNWAVMNVLVMVJOPVKVNVMVQGZVKVJUEGZVNWIVJUFZVLVMVJVQVQUGZRSPTWHWCVLVQVKVNWC
      VLNVLVMVJUHPVNVLVQGZVKVLVMVJBUIZCUIZUJUKTULUMVOVKWEVOVKJZWBWDWPVJVMVLKZLQ
      ZVQGZWBWPWRVLVQVKVOWRVLNVMVLVJOPVKVOWMVKWJVOWMWKVMVLVJVQWLRSPTVTWQNZWBWSU
      NVLVMUOZWTWAWRVQVTWQVJLUPUQURUSWPWCVJWQMQZVQVTWQVJMXAVBWPXBVMVQVKVOXBVMNV
      MVLVJUHPVOWIVKVMVLVJWOWNUJUKTUTULUMVAVCVDVDVEBCVJVQWLVFBCVJVQWLVGVHVI @.

  @}

  @( A restriction of the identity is a poset.  (Contributed by FL,
     2-Aug-2009.) @)
  dispos @p |- ( A e. V -> ( _I |` A ) e. PosetRel ) @=
    ( wcel cid cres cps wrel ccom wss ccnv cin cuni wceq w3a relres wf wf1o cun
    ax-mp cvv f1oi fcoi1 eqimssi cnvresid ineq2i inidm cdm relfld dmresi rnresi
    f1of crn uneq12i unidm 3eqtrri reseq2i 3eqtri 3pm3.2i wb resiexg syl mpbiri
    isps ) ABCZDAEZFCZVEGZVEVEHZVEIZVEVEJZKZDVELLZEZMZNZVGVIVNDAOZVHVEAAVEPZVHV
    EMAAVEQVQAUAAAVEUKSAAVEUBSUCVKVEVEKVEVMVJVEVEAUDUEVEUFAVLDVLVEUGZVEULZRZAAR
    AVGVLVTMVPVEUHSVRAVSAAUIAUJUMAUNUOUPUQURVDVETCVFVOUSABUTTVEVCVAVB @.

  @( An idiom to "dereflexivate" a relation.  (Contributed by FL,
     30-Dec-2010.) @)
  deref @p |- ( A e. B -> -. A ( C \ _I ) A ) @=
    ( wcel cop cid cdif wbr wn ididg df-br sylib notnot intnand eldif sylnibr
    wa ) ABDZAAEZCFGZDZAATHRSCDZSFDZIZQUARUDUBRUCUDIRAAFHUCABJAAFKLUCMLNSCFOPAA
    TKP @.

  @{
    @d r x @.
    @( Alternate definition of a poset.  Bourbaki E.III.2 prop. 1.
       (Contributed by FL, 30-Dec-2010.) @)
    dfps2 @p |- PosetRel = { r | ( Rel r /\ ( r o. r ) = r /\
              ( r i^i `' r ) = ( _I |` U. U. r ) ) } @=
      ( vx cv ccom wss cid cuni cres wceq w3a cab simp1 wi wa eqcoms syl6bi syl
      eqtr ex com3l cps wrel ccnv cin df-ps eqimss2 ssin wbr wral idref cdm crn
      domrngref domfldref reseq2 eqeq2d inss1 ssid cores ax-mp sseq1 coss1 coi2
      eqss simplbi2com com23 sylc pm2.43a com4l sylbi adantr sylbir mpcom com13
      mp2 3imp simp3 3jca eqimss 3ad2ant2 impbii abbii eqtri ) UAACZUBZWDWDDZWD
      EZWDWDUCZUDZFWDGGZHZIZJZAKWEWFWDIZWLJZAKAUEWMWOAWMWOWMWEWNWLWEWGWLLWEWGWL
      WNWLWGWEWNWKWIEZWLWGWEWNMMZWKWIUFWPWKWDEZWKWHEZNWLWQMZWKWDWHUGWRWTWSWRBCZ
      XAWDUHBWJUIZWTBWJWDUJWEXBWLWGWNXBWEWLWGWNMZMZWEXBWEXDMZWEXBNWDUKZWDULZIXF
      WJIZXEBWDUMBWDUNXHXEMXGXFXGXFIZXHXEXIXHNXGWJIZXEXGXFWJRXJWLWEXCXJWLWIFXGH
      ZIZWEXCMZXJWKXKWIWKXKIWJXGWJXGFUOOUPWIWDEZXKWDDZFWDDZIZXLXMMWDWHUQXGXGEXQ
      XGURFWDXGUSUTXLXNXQXMXLXNXKWDEZXQXMMZWIXKWDVAXRXOWFEZXSXKWDWDVBWEXTXQXCWE
      XPWDIZXTXQXCMMWDVCXQYAXTXCXQYAXTXCMZXQYANXOWDIZYBXOXPWDRYCXTWDWFEZXCXOWDW
      FVAWNWGYDWFWDVDVEPQSTQTQPTVOPVFQSOVGSVHVIVJVKVLVMVNVPWEWGWLVQVRWOWEWGWLWE
      WNWLLWNWEWGWLWFWDVSVTWEWNWLVQVRWAWBWC @.
  @}

  @{
    @d C a u v x y @.  @d J a u v x y @.
    toplat.1 @e |- C = { <. u , v >. | u C_ v } @.
    @( A topology when ordered by the inclusion is a lattice.  This fact leads
       to the idea of pointless topology, that is a lattice looked at with the
       eyes of a topologist.  (Contributed by FL, 6-Sep-2009.) @)
    toplat @p |- ( J e. Top -> ( C i^i ( J X. J ) ) e. LatRel ) @=
      ( vx vy va wcel wa wral wbr wi wss a1i cvv definc syl3anbrc biimpi brcnvg
      ctop cxp cin cps cv cpr cspw cinf cla inposet cuni wceq adantr simprl vex
      co prss uniopn sylan2b prid1 ssuni sylancr zfpair2 uniex simprr prid2 w3a
      ssid cun unss ad2antrl unipr eqcomi sseq1i ex sylbi expcom 3ad2ant3 com12
      imp ralrimiva cdm domncnt spwpr4 syl121anc eqeltrd ccnv cint nfwval cnvps
      sylancl syl simpr intpr inopn 3expb syl5eqel eleq1i adantl simpl syl5eqbr
      inss1 inex1 mpbird adantlr inss2 eqsstri c0 wne prnz mpbi adantll syl2anc
      intex jca wb sylan biimpd simprr1 ad2antrr ssin syl6sseqr syl2ani syl2and
      pm3.2i exp31 ralrimiv ranncnt df-rn eqtr3i syl3anc 3eqtrd ralrimivva isla
      crn sylanbrc ) DUAIZCDDUBUCZUDIZYRFUEZGUEZUFZUGUPZDIZYRUUBUHUPZDIZJZGDKFD
      KYRUIIBADUACEUJZYQUUGFGDDYQYTDIZUUADIZJZJZUUDUUFUULUUCUUBUKZDUULYSYTUUMYR
      LZUUAUUMYRLZYTHUEZYRLZUUAUUPYRLZJZUUMUUPYRLZMZHDKUUCUUMULYQYSUUKUUHUMZUUL
      UUIUUMDIZYTUUMNZUUNYQUUIUUJUNZUUKYQUUBDNUVCYTUUADFUOZGUOZUQUUBDURUSZUULYT
      YTNYTUUBIZUVDYTVHUVIUULYTUUAUVFUTOYTYTUUBVAVBBADDCUUMYTPPUVFUUBFGVCZVDZEQ
      RUULUUJUVCUUAUUMNZUUOYQUUIUUJVEZUVHUULUUAUUANUUAUUBIZUVLUUAVHUVNUULYTUUAU
      VGVFOUUAUUAUUBVAVBBADDCUUMUUAPPUVGUVKEQRUULUVAHDUUSUULUUPDIZJZUUTUUQUURUV
      PUUTMZUUQUUIUVOYTUUPNZVGUURUVQMZBADDCUUPYTPPUVFHUOZEQUVRUUIUVSUVOUURUVRUV
      QUURUUJUVOUUAUUPNZVGUVRUVQMZBADDCUUPUUAPPUVGUVTEQUWAUUJUWBUVOUVRUWAUVQUVR
      UWAJYTUUAVIZUUPNZUVQYTUUAUUPVJUWDUVPUUTUWDUVPJUVCUVOUUMUUPNZUUTUULUVCUWDU
      VOUVHVKUWDUULUVOVEUWDUWEUVPUWDUWEUWCUUMUUPUUMUWCYTUUAUVFUVGVLVMVNSUMBADDC
      UUPUUMPPUVKUVTEQRVOVPVQVRVPVSVRVPVTVSWAHYTUUAUUMYRDYRWBDBADCEWCVMZWDWEUVH
      WFUULUUEYTUUAUCZDUULUUEYRWGZUUBUGUPZUUBWHZUWGUULYSUUBPIUUEUWIULUVBUVJUUBY
      RUDPWIWKUULUWHUDIZYTUWJUWHLZUUAUWJUWHLZJZYTUUPUWHLZUUAUUPUWHLZJZUWJUUPUWH
      LZMZHDKUWIUWJULYQUWKUUKYQYSUWKUUHYRWJWLUMUULUUKUWJDIZUWNYQUUKWMUULUWJUWGD
      YTUUAUVFUVGWNZYQUUIUUJUWGDIZYTUUADWOWPZWQZUUKUWTJUWLUWMUUIUWTUWLUUJUUIUWT
      JZUWLUWJYTYRLUXEUWJUWGYTYRUXAUXEUXBUUIUWGYTNZUWGYTYRLUWTUXBUUIUWTUXBUWJUW
      GDUXAWRSWSUUIUWTWTUXFUXEYTUUAXBOBADDCYTUWGPPYTUUAUVFXCUVFEQRXAYTUWJDDYRTX
      DXEUUJUWTUWMUUIUUJUWTJZUWMUWJUUAYRLZUXGUWTUUJUWJUUANZUXHUUJUWTWMUUJUWTWTU
      XIUXGUWJUWGUUAUXAYTUUAXFXGOBADDCUUAUWJPPUUBXHXIUWJPIZYTUUAUVFXJUUBXNXKZUV
      GEQRUUAUWJDDYRTXDXLXOXMUULUWSHDUULUVOUWQUWRUVPUWQJZUWRUUPUWJYRLZUVPUWQUXM
      UVPUWOUUPYTYRLZUWPUUPUUAYRLZUXMUVPUWOUXNUULUUIUVOUWOUXNXPUVEYTUUPDDYRTXQX
      RUVPUWPUXOUULUUJUVOUWPUXOXPUVMUUAUUPDDYRTXQXRUXNUVPUVOUUIUUPYTNZVGZUVOUUJ
      UUPUUANZVGZUXMUXOUXNUXQBADDCYTUUPPPUVTUVFEQSUXOUXSBADDCUUAUUPPPUVTUVGEQSU
      VPUXQUXSJZUXMUVPUXTJUVOUWTUUPUWJNZUXMUVOUUJUXRUXQUVPXSUULUWTUVOUXTUXDXTUX
      TUYAUVPUXQUXSUYAUXPUVOUXSUYAMUUIUXSUXPUYAUXRUVOUXPUYAMUUJUXPUXRUYAUXPUXRJ
      ZUUPUWGUWJUYBUUPUWGNUUPYTUUAYASUXAYBVQVRVSVRVTWSBADDCUWJUUPPPUVTUXKEQRVOY
      CYDVTUXLUXJUUPPIZJZUWRUXMXPUYDUXLUXJUYCUXKUVTYEOUWJUUPPPYRTWLXDYFYGHYTUUA
      UWJUWHDYRYODUWHWBBADCEYHYRYIYJWDYKUWJUWGULUULUXAOYLUXCWFXOYMFGYRDUWFYNYP
      @.
  @}

  @{
    @d r u x y z @.
    @( A directed set (also called a set filtering on the right by Bourbaki) is
       a preordered set whose every pair of elements has an upper bound.
       (Contributed by FL, 19-Sep-2011.)  (Revised by Mario Carneiro,
       21-Nov-2013.) @)
    dfdir2 @p |- DirRel = ( PresetRel i^i { r | A. x e. U. U. r A. y e. U. U. r
      E. z e. U. U. r z e. ( r ub { x , y } ) } ) @=
      ( vu cdir cv wcel cuni wral cpresetrel cab wss wa ccom cvv vex wbr bitr4i
      wb cpr cub co wrex crab cin wrel cid cres cxp ccnv w3a isprsr ax-mp bitri
      3anan32 wex codir cop df-br opeluu simprd sylbi adantr breq1 ralpr anbi2i
      pm4.71ri zfpair eqid puub mp2an simplbi exbii df-rex 2ralbii bitr2i anass
      anbi12i abbii df-dir df-rab 3eqtr4i dfrab3 eqtri ) FCGZDGZAGZBGZUAZUBUCHZ
      CWGIIZUDZBWLJAWLJZDKUEZKWNDLUFWGUGZUHWLUIWGMZNZWGWGOWGMZWLWLUJWGUKWGOMZNN
      ZDLWGKHZWNNZDLFWOXAXCDXCWRWSNZWTNXAXBXDWNWTXBWPWSWQULZXDWGPHZXBXETDQZPWGU
      MUNWPWSWQUPUOWTWHWFWGRZWIWFWGRZNZCUQZBWLJAWLJWNABCWLWLWGURXKWMABWLWLXKWFW
      LHZWKNZCUQWMXJXMCXJWKXMXJXLEGZWFWGRZEWJJZNZWKXJXLXJNXQXJXLXHXLXIXHWHWFUSW
      GHZXLWHWFWGUTXRWHWLHXLWHWFWGAQZCQVAVBVCVDVHXPXJXLXOXHXIEWHWIXSBQXNWHWFWGV
      EXNWIWFWGVEVFVGSXFWJPHWKXQTXGABVIWJPWGPWFWLEWLVJVKVLZSWKXLWKXLXPXTVMVHUOV
      NWKCWLVOSVPVQVSWRWSWTVRVQVTDWAWNDKWBWCWNDKWDWE @.
  @}

  @{
    @d D d x y z @.  @d X x y z @.
    isdir2.1 @e |- X = dom D @.
    @( Alternate definition of a direction.  (Contributed by FL,
       19-Sep-2011.) @)
    isdir2 @p |- ( D e. DirRel <-> ( D e. PresetRel /\
     A. x e. X A. y e. X E. z e. X z e. ( D ub { x , y } ) ) ) @=
      ( vd cdir wcel cpresetrel cv cub cuni wrex wral wceq raleqbidv raleqbi1dv
      co wa cpr cab cin dfdir2 eleq2i unieq unieqd oveq1 eleq2d rexeqbidv elabg
      elin cdm wb preodom2 eqtr rexeq eqcoms syl sylancr bitrd pm5.32i 3bitri )
      DHIDJCKZGKZAKBKUAZLSZIZCVEMZMZNZBVJOZAVJOZGUBZUCZIDJIZDVNIZTVPVDDVFLSZIZC
      ENZBEOZAEOZTHVODABCGUDUEDJVNULVPVQWBVPVQVSCDMZMZNZBWDOZAWDOZWBVMWGGDJVEDP
      ZVLWFAVJWDWHVIWCVEDUFUGZWHVKWEBVJWDWIWHVHVSCVJWDWIWHVGVRVDVEDVFLUHUIUJQQU
      KVPEDUMZPZWJWDPZWGWBUNZFDUOWKWLTEWDPWMEWJWDUPWMWDEWFWAAWDEWEVTBWDEVSCWDEU
      QRRURUSUTVAVBVC @.
  @}

  @{
    @d D x y z @.
    @( A direction is a preset.  (Contributed by FL, 19-Sep-2011.) @)
    dirpre @p |- ( D e. DirRel -> D e. PresetRel ) @=
      ( vz vx vy cdir wcel cpresetrel cpr cub cdm wrex wral eqid isdir2 simplbi
      cv co ) AEFAGFBPACPDPHIQFBAJZKDRLCRLCDBARRMNO @.
  @}

  @{
    @d D x y z @.  @d X x y z @.
    dirub.1 @e |- X = dom D @.
    @( In a direction, every pair of elements has an upper bound.  (Contributed
       by FL, 19-Sep-2011.) @)
    dirub @p |- ( D e. DirRel -> A. x e. X A. y e. X E. z e. X z e.
      ( D ub { x , y } ) ) @=
      ( cdir wcel cpresetrel cv cpr cub co wrex wral isdir2 simprbi ) DGHDIHCJD
      AJBJKLMHCENBEOAEOABCDEFPQ @.
  @}

  @{
    @d p x y z @.
    @( A lattice is a direction.  (Contributed by FL, 19-Sep-2011.) @)
    latdir @p |- LatRel C_ DirRel @=
      ( vp vx vy vz cla cdir cv cps wcel cpr cspw co cdm cinf wa wral adantr wi
      cvv ralimdv cpresetrel wrex posispre zfpair eqid supaub com3l ax-mp eleq1
      cub 3exp rspcev ex syld com12 imp jca isla isdir2 3imtr4i ssriv ) AEFAGZH
      IZVBBGCGJZKLZVBMZIZVBVDNLVFIZOZCVFPZBVFPZOZVBUAIZDGZVBVDUJLZIZDVFUBZCVFPZ
      BVFPZOVBEIVBFIVLVMVSVCVMVKVBUCQVCVKVSVCVJVRBVFVCVIVQCVFVIVCVQVGVCVQRVHVGV
      CVEVOIZVQVDSIZVGVCVTRRBCUDVCWAVGVTVCWAVGVTVDVBSVFVFUEZUFUKUGUHVGVTVQVPVTD
      VEVFVNVEVOUIULUMUNQUOTTUPUQBCVBVFWBURBCDVBVFWBUSUTVA @.
  @}

  @c BndLat @.
  @( Extend class notation to include bound lattice. @)
  clbl @a class BndLat @.

  @( A bound lattice is a lattice that has the greatest and the least element.
     (Contributed by FL, 21-May-2012.) @)
  df-bnlat @a |- BndLat =
    { r e. LatRel | ( ( leR ` r ) e. dom r /\ ( ge ` r ) e. dom r ) } @.

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Finite composites ( i.e. finite sums, products ... )
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c gprod_ @. @( Product sign. @)

  @( Extend class notation to include finite products/sums. @)
  cgprd @a class gprod_ k e. A G B @.

  @{
    @d x m n k @.  @d x m n A @.  @d x m n G @.  @d x m n B @.
    @( Define the composite for the law ` G ` of a finite sequence of elements
       whose values are defined by the expression ` B ` and whose set of
       indices is ` A ` . ` A ` may be empty.  It may be thougt as a product
       (if ` G ` is a multiplication), a sum (if ` G ` is an addition) or
       whatever.  The variable ` k ` is normally a free variable in ` B `
       ( i.e. ` B ` can be thought of as ` B ( k ) ` ).  The definition is
       meaningful when ` A ` is a finite set of sequential integers and ` G `
       is an internal operation.  Our definition corresponds to the first part
       of the definition of ~ df-sum .  The operation ` + ` has been replaced
       by the generic operation ` G ` .  The reference to the concept of limit
       has been removed because one wants to use the product in contexts where
       limits are irrelevant.  I could be still more generic and replace
       ` ( m ... n ) ` by a finite totally ordered set.  I would then get the
       definition given by Bourbaki in the first chapter of the algebra book of
       his treatise ( A I.3 def.4 ).  I don't because the present definition is
       easier to deal with and because there exists an order isomorphism
       between any finite totally ordered set and any finite sets of integers.
       I don't specify anything about ` G ` because nothing is required of
       ` g ` in the definition of ` seq ` .  I hope it will be ok.  Otherwise,
       one could add ` G e. Magma ` .  (Contributed by FL, 5-Sep-2010.) @)
    df-gprod @a |- gprod_ k e. A G B = if ( A = (/) , ( GId ` G ) ,
                  { x | E. m E. n e. ( ZZ>= ` m ) ( A = ( m ... n ) /\
                    x e. ( seq m ( G , ( k e. _V |-> B ) ) ` n ) ) } ) @.
    @(
    df-gprod %a |- gprod_ k e. A G B =
      if ( A. k e. A B = ( 0g ` G ) , ( 0g ` G ) ,
      if ( A e. ran ... ,
        ( iota x E. m E. n e. ( ZZ>= ` m ) ( A = ( m ... n ) /\
          x = ( seq m ( ( +g ` G ) , ( k e. _V |-> B ) ) ` n ) ) ) ,
      [_ ( z e. ( ( ~P A i^i Fin ) \ { (/) } ) |->
        ( iota x E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto-> z /\
          x = ( seq 1 ( ( +g ` G ) ,
            ( n e. NN |-> [_ ( f ` n ) / k ]_ B ) ) ` m ) ) ) ) / j ]_
        if ( { x e. A | B =/= ( 0g ` G ) } e. Fin ,
          ( j ` { x e. A | B =/= ( 0g ` G ) } ) ,
        U. ( ( ( TopOpen ` G ) fLimf { x |
          E. z e. ( ( ~P A i^i Fin ) \ { (/) } ) x =
          { y e. ( ( ~P A i^i Fin ) \ { (/) } ) | z C_ y } } ) ` j ) ) ) ) %.
    @)

  @}

  @c prod2_ @. @( Product sign. @)

  @( Extend class notation to include finite supports products/sums. @)
  cgprd2 @a class prod2_ k e. A G B @.

  @c prod3_ @. @( Product sign. @)

  @( Extend class notation to include finite supports products/sums. @)
  cgprd3 @a class prod3_ k e. A G B @.

  @{
    @d f m n x A @.  @d f m n x B @.  @d f k m n x @.  @d f m n x G @.
    @( Definition of a sum or product operator to be used with generic
       structures defined by extensible structures. ` A ` is the set of
       indices, ` G ` the operation, ` B ` an expression, ` k ` is normally a
       free variable in ` B ` . ` A ` may be any extensible structure with a
       base set.  Its base set may be infinite provided that the "support" is
       finite.  The support is the set:
       ` { k e. ( Base `` A ) | B =/= ( 0g `` G ) } ` .  The base set of ` A `
       may be empty. ` G ` must be an extensible structure with a law
       commutative, associative with a neutral element.  (Contributed by FL,
       17-Oct-2011.) @)
    df-gprod2 @a |- prod2_ k e. A G B =
      if ( ( Base ` G ) = (/) , ( 0g ` G ) ,
        ( iota x E. m e. NN E. f ( f : ( 1 ... m ) -1-1-onto->
          { k e. ( Base ` A ) | B =/= ( 0g ` G ) } /\
              x = ( seq 1 ( ( +g ` G ) ,
                ( n e. NN |-> [_ ( f ` n ) / k ]_ B ) ) ` m ) ) ) ) @.
  @}

  @{
    @d f m n x A @.  @d f m n x B @.  @d f k m n x @.  @d f m n x G @.
    @( Definition of a sum or product operator to be used with generic
       structures defined by extensible structures. ` A ` is the set of
       indices, ` G ` the operation, ` B ` an expression, ` k ` is normally a
       free variable in ` B ` . ` A ` must be a total order.  Its base set may
       be infinite provided that the "support" is finite.  The support is the
       set: ` { k e. ( Base `` A ) | B =/= ( 0g `` G ) } ` .  The base set of
       ` A ` may be empty. ` G ` must be an associative law with a neutral
       element.  (Contributed by FL, 17-Oct-2011.) @)
    df-gprod3 @a |- prod3_ k e. A G B =
      if ( ( Base ` G ) = (/) , ( 0g ` G ) ,
        ( iota x E. m e. NN E. f ( f e. ( ( 1 ... m ) OrIso
          { k e. ( Base ` A ) | B =/= ( 0g ` G ) } ) /\
              x = ( seq 1 ( ( +g ` G ) ,
                ( n e. NN |-> [_ ( f ` n ) / k ]_ B ) ) ` m ) ) ) ) @.
  @}

  @{
    @d A m n x y @.  @d B m n x y @.  @d G m n x y @.  @d k m n x y @.
    @( A finite composite is a set.  (Contributed by FL, 19-Sep-2011.)
       (Revised by Mario Carneiro, 26-May-2014.) @)
    gprodex @p |- gprod_ k e. A G B e. _V @=
      ( vm vn vx cgprd wceq cgi cfv cv cvv wa wrex cab fvex cz zex eqeltri cmpt
      c0 cfz co cseq wcel cuz wex cif df-gprod cle wbr 2rexuz abbii abssi ssexi
      simprr ab2rexex2 ifex ) ABCDHAUBIZDJKZAELZFLZUCUDIZGLVCDCMBUAVBUEZKZUFZNZ
      FVBUGKOEUHZGPZUIMGABCEFDUJUTVAVJDJQVJVBVCUKULZVHNZFROEROZGPMVIVMGVHEFUMUN
      VLEFGRRSSVLGPVFVCVEQVLGVFVKVDVGUQUOUPURTUST @.

    @( The value of ` gprod_ k e. (/) G B ` .  (Contributed by FL,
       19-Sep-2011.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    gprod0 @p |- gprod_ k e. (/) G B = ( GId ` G ) @=
      ( vm vn vx c0 cgprd wceq cgi cfv cv cfz co cvv cmpt cseq wcel wa cuz wrex
      wex cab cif df-gprod eqid iftrue ax-mp eqtri ) GABCHGGIZCJKZGDLZELZMNIFLU
      MCBOAPULQKRSEULTKUADUBFUCZUDZUKFGABDECUEUJUOUKIGUFUJUKUNUGUHUI @.
  @}

  @{
    @d A m n x y @.  @d B m n x y @.  @d C m n x y @.  @d G m n x y @.
    @d k m n x y @.
    @( Equality theorem for a composite.  (Contributed by FL, 19-Sep-2011.)
       (Revised by Mario Carneiro, 26-May-2014.) @)
    gprodeq1 @p |- ( A = B -> gprod_ k e. A G C = gprod_ k e. B G C ) @=
      ( vm vn vx wceq c0 cfv cv wa wrex wex cab cif cgprd eqeq1 df-gprod cgi co
      cfz cvv cmpt cseq wcel cuz anbi1d rexbidv exbidv abbidv ifbieq2d 3eqtr4g
      ) ABIZAJIZEUAKZAFLZGLZUCUBZIZHLUSEDUDCUEURUFKUGZMZGURUHKZNZFOZHPZQBJIZUQB
      UTIZVBMZGVDNZFOZHPZQACDERBCDERUOUPVHVGVMUQABJSUOVFVLHUOVEVKFUOVCVJGVDUOVA
      VIVBABUTSUIUJUKULUMHACDFGETHBCDFGETUN @.
  @}

  @{
    @d A m n x y @.  @d C m n x y @.  @d G m n x y @.  @d H m n x y @.
    @d k m n x y @.
    @( Equality theorem for a composite.  (Contributed by FL, 19-Sep-2011.)
       (Revised by Mario Carneiro, 26-May-2014.) @)
    gprodeq2 @p |- ( G = H -> gprod_ k e. A G C = gprod_ k e. A H C ) @=
      ( vm vn vx wceq cgi cfv cv cseq wcel wa wrex wex cab cif cgprd c0 cfz cvv
      cmpt cuz fveq2 seqeq2 fveq1d eleq2d anbi2d rexbidv exbidv abbidv df-gprod
      co ifeq12d 3eqtr4g ) DEIZAUAIZDJKZAFLZGLZUBUOIZHLZVBDCUCBUDZVAMZKZNZOZGVA
      UEKZPZFQZHRZSUSEJKZVCVDVBEVEVAMZKZNZOZGVJPZFQZHRZSABCDTABCETURUSUTVNVMWAD
      EJUFURVLVTHURVKVSFURVIVRGVJURVHVQVCURVGVPVDURVBVFVODEVEVAUGUHUIUJUKULUMUP
      HABCFGDUNHABCFGEUNUQ @.
  @}

  @{
    @d A k m n x y @.  @d B m n x y @.  @d C m n x y @.  @d G m n x y @.
    @( Equality theorem for a composite.  (Contributed by Mario Carneiro,
       26-May-2014.) @)
    gprodeq3ii @p |- ( A. k e. A ( _I ` B ) = ( _I ` C ) ->
      gprod_ k e. A G B = gprod_ k e. A G C ) @=
      ( vm vn vx cid cfv wceq cv cvv cmpt cseq wcel wa wrex wex cab wral c0 cgi
      cfz co cuz cif cgprd simplr eleq2 biimprd simpl nfmpt1 nfcv nffv nfeq vex
      eqid fvmpt2i eqeq12d ax-mp fveq2 syl5bbr rspc syl5com sylan9r imp seqfveq
      wb eleq2d pm5.32da rexbidva exbidv abbidv ifeq2d df-gprod 3eqtr4g ) BIJZC
      IJZKZDAUAZAUBKZEUCJZAFLZGLZUDUEZKZHLZWEEDMBNZWDOJZPZQZGWDUFJZRZFSZHTZUGWB
      WCWGWHWEEDMCNZWDOJZPZQZGWMRZFSZHTZUGABDEUHACDEUHWAWBWPXCWCWAWOXBHWAWNXAFW
      AWLWTGWMWAWEWMPZQZWGWKWSXEWGQZWJWRWHXFEHWIWQWDWEWAXDWGUIXFWHWFPZWHWIJZWHW
      QJZKZWGXGWHAPZXEXJWGXKXGAWFWHUJUKXEWAXKXJWAXDULVTXJDWHADXHXIDWHWIDMBUMDWH
      UNZUODWHWQDMCUMXLUOUPVTDLZWIJZXMWQJZKZXMWHKZXJXMMPZXPVTVIDUQXRXNVRXOVSDMB
      WIWIURUSDMCWQWQURUSUTVAXQXNXHXOXIXMWHWIVBXMWHWQVBUTVCVDVEVFVGVHVJVKVLVMVN
      VOHABDFGEVPHACDFGEVPVQ @.
  @}

  @{
    @d A k m n x y @.  @d B m n x y @.  @d C m n x y @.  @d G m n x y @.
    @( Equality theorem for a composite.  (Contributed by FL, 19-Sep-2011.)
       (Proof shortened by Mario Carneiro, 26-May-2014.) @)
    gprodeq3 @p |- ( A. k e. A B = C ->
      gprod_ k e. A G B = gprod_ k e. A G C ) @=
      ( wceq wral cid cfv cgprd fveq2 ralimi gprodeq3ii syl ) BCFZDAGBHICHIFZDA
      GABDEJACDEJFOPDABCHKLABCDEMN @.
  @}

  @{
    @d A k m n x y @.  @d B m n x y @.  @d G m n x y @.
    nfprod1.1 @e |- F/_ k A @.
    nfprod1.2 @e |- F/_ k G @.
    @( Bound-variable hypothesis builder for ` gprod_ ` .  (Contributed by FL,
       14-Sep-2010.)  (Revised by Mario Carneiro, 11-Dec-2016.) @)
    nfprod1 @p |- F/_ k gprod_ k e. A G B @=
      ( vm vn vy cgprd c0 wceq cgi cfv cv cfz co cvv nfcv nffv cmpt cseq wa cuz
      wcel wrex wex cab cif df-gprod nfeq1 nfv nfseq nfcri nfan nfrex nfex nfab
      nfmpt1 nfif nfcxfr ) CABCDJAKLZDMNZAGOZHOZPQLZIOVEDCRBUAZVDUBZNZUEZUCZHVD
      UDNZUFZGUGZIUHZUIIABCGHDUJVBCVCVOCAKEUKCDMCMSFTVNCIVMCGVKCHVLCVLSVFVJCVFC
      ULCIVICVEVHCDVGVDCVDSFCRBUSUMCVESTUNUOUPUQURUTVA @.
  @}

  @{
    @d A m n y z @.  @d B m n y z @.  @d G m n y z @.  @d k m n x y z @.
    nfprod.1 @e |- F/_ x A @.
    nfprod.2 @e |- F/_ x G @.
    nfprod.3 @e |- F/_ x B @.
    @( Bound-variable hypothesis builder for ` gprod_ ` .  If ` x ` is
       (effectively) not free in ` A ` , ` G ` and ` B ` , it is not free in
       ` gprod_ k e. A G B ` .  (Contributed by FL, 19-Sep-2011.)  (Revised by
       Mario Carneiro, 11-Dec-2016.) @)
    nfprod @p |- F/_ x gprod_ k e. A G B @=
      ( vm vn vz c0 wceq cgi cfv cv cvv nfeq1 nfcv nffv cgprd co cmpt cseq wcel
      cfz cuz wrex wex cab df-gprod nfmpt nfseq nfcri nfan nfrex nfex nfab nfif
      wa cif nfcxfr ) ABCDEUABLMZENOZBIPZJPZUFUBZMZKPVFEDQCUCZVEUDZOZUEZUTZJVEU
      GOZUHZIUIZKUJZVAKBCDIJEUKVCAVDVQABLFRAENANSGTVPAKVOAIVMAJVNAVNSVHVLAABVGF
      RAKVKAVFVJAEVIVEAVESGADQCAQSHULUMAVFSTUNUOUPUQURUSVB @.
  @}

  @{
    @d A m n x y @.  @d B m n x y @.  @d C m n x y @.  @d G m n x y @.
    @d j m n x y @.  @d k m n x y @.
    cbvprod.1 @e |- F/_ k B @.
    cbvprod.2 @e |- F/_ j C @.
    cbvprod.3 @e |- ( j = k -> B = C ) @.
    @( Change bound variable in a finite composite.  (Contributed by FL,
       19-Sep-2011.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    cbvprodi @p |- gprod_ j e. A G B = gprod_ k e. A G C @=
      ( vm vn vx wceq cfv cv cvv cmpt cseq wcel wa cgi cfz cuz wrex wex cab cif
      c0 co cgprd cbvmpt seqeq3 ax-mp fveq1i eleq2i anbi2i exbii abbii df-gprod
      rexbii ifeq2 3eqtr4i ) AUHMZFUANZAJOZKOZUBUIMZLOZVFFDPBQZVERZNZSZTZKVEUCN
      ZUDZJUEZLUFZUGZVCVDVGVHVFFEPCQZVERZNZSZTZKVNUDZJUEZLUFZUGZABDFUJACEFUJVQW
      FMVRWGMVPWELVOWDJVMWCKVNVLWBVGVKWAVHVFVJVTVIVSMVJVTMDEPBCGHIUKFVIVSVEULUM
      UNUOUPUTUQURVCVQWFVDVAUMLABDJKFUSLACEJKFUSVB @.
  @}

  @{
    gprodeq1d.1 @e |- ( ph -> A = B ) @.
    @( Conditions for two composites to be equal.  (Contributed by FL,
       5-Sep-2010.) @)
    gprodeq1d @p |- ( ph -> gprod_ k e. A G C = gprod_ k e. B G C ) @=
      ( wceq cgprd gprodeq1 syl ) ABCHBDEFICDEFIHGBCDEFJK @.
  @}

  @{
    gprodeq2d.2 @e |- ( ph -> G = H ) @.
    @( Conditions for two composites to be equal.  (Contributed by FL,
       5-Sep-2010.) @)
    gprodeq2d @p |- ( ph -> gprod_ k e. A G C = gprod_ k e. A H C ) @=
      ( wceq cgprd gprodeq2 syl ) AEFHBCDEIBCDFIHGBCDEFJK @.
  @}

  @{
    @d A k @.
    gprodeq3d.3 @e |- ( ph -> A. k e. A C = D ) @.
    @( Conditions for two composites to be equal.  (Contributed by FL,
       5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    gprodeq3d @p |- ( ph -> gprod_ k e. A G C = gprod_ k e. A G D ) @=
      ( wceq wral cgprd gprodeq3 syl ) ACDHEBIBCEFJBDEFJHGBCDEFKL @.
  @}

  @{
    @d A k @.
    gprodeq123d.1 @e |- ( ph -> A = B ) @.
    gprodeq123d.2 @e |- ( ph -> G = H ) @.
    gprodeq123d.3 @e |- ( ph -> A. k e. A C = D ) @.
    @( Conditions for two composites to be equal.  (Contributed by FL,
       5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    gprodeq123d @p |- ( ph -> gprod_ k e. A G C = gprod_ k e. B H D ) @=
      ( cgprd gprodeq3d gprodeq2d gprodeq1d 3eqtrd ) ABDFGLBEFGLBEFHLCEFHLABDEF
      GKMABEFGHJNABCEFHIOP @.
  @}

  @{
    @d A k @.
    gprodeq123i.1 @e |- A = B @.
    gprodeq123i.2 @e |- G = H @.
    gprodeq123i.3 @e |- ( k e. A -> C = D ) @.
    @( Conditions for two composites to be equal.  (Contributed by FL,
       6-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    gprodeq123i @p |- gprod_ k e. A G C = gprod_ k e. B H D @=
      ( cgprd wceq wtru a1i wral rgen gprodeq123d trud ) ACEFKBDEGKLMABCDEFGABL
      MHNFGLMINCDLZEAOMSEAJPNQR @.
  @}

  @{
    @d k m @.  @d k B @.  @d k x C @.  @d m x F @.  @d x G @.
    gprodeqfv.2 @e |- F = ( k e. B |-> A ) @.
    @( Convert a composite of function values to a composite of classes
       ` A ( k ) ` .  (Contributed by FL, 19-Sep-2011.)  (Revised by Mario
       Carneiro, 26-May-2014.) @)
    gprodeqfv @p |- ( C C_ B -> gprod_ m e. C G ( F ` m ) =
     gprod_ k e. C G A ) @=
      ( wss cv cfv cgprd cmpt nfcv cid wceq wcel cvv syl5eq syl nfmpt1 cbvprodi
      nfcxfr nffv fveq2 wral ssel2 fvex fvi ax-mp fvmpt2i ralrimiva gprodeq3ii
      wa ) CBIZCEJZFKZEGLCDJZFKZDGLZCADGLZCUQUSEDGDUPFDFDBAMHDBAUAUCDUPNUDEUSNU
      PURFUEUBUOUSOKZAOKZPZDCUFUTVAPUOVDDCUOURCQUNURBQZVDCBURUGVEVBUSVCUSRQVBUS
      PURFUHUSRUIUJDBAFHUKSTULCUSADGUMTS @.
  @}

  @{
    @d A m n x y @.  @d G m n x y @.  @d M m n x y @.  @d N m n x y @.
    @d k m n x y @.
    @( Special case of composite over a finite index set.  (Contributed by FL,
       5-Sep-2010.)  (Proof shortened by Mario Carneiro, 26-May-2014.) @)
    dffprod @p |- ( N e. ( ZZ>= ` M ) -> gprod_ k e. ( M ... N ) G A =
                    ( seq M ( G , ( k e. _V |-> A ) ) ` N ) ) @=
      ( vm vn vx cuz cfv wcel cfz co cv wceq cseq wa wrex eleq2d cz cvv wex cab
      cgprd cmpt c0 cgi cif df-gprod wn eluzfz1 n0i iffalse syl5eq fzopth simpl
      3syl seqeq1d simpr fveq12d biimprd syl6bi imp3a rexlimdvw exlimdv eluzel2
      wi adantr oveq2 eqcomd biantrurd fveq2 bitr3d rspcev eqeq2d seqeq1 fveq1d
      oveq1 anbi12d rexeqbidv spcegv sylc ex impbid abbi1dv eqtrd ) EDIJZKZDELM
      ZABCUDZWIFNZGNZLMZOZHNZWLCBUAAUEZWKPZJZKZQZGWKIJZRZFUBZHUCZECWPDPZJZWHWJW
      IUFOZCUGJZXDUHZXDHWIABFGCUIWHDWIKXGUJXIXDODEUKWIDULXGXHXDUMUQUNWHXCHXFWHX
      CWOXFKZWHXBXJFWHWTXJGXAWHWNWSXJWHWNDWKOZEWLOZQZWSXJVGWKWLDEUOXMXJWSXMXFWR
      WOXMEWLXEWQXMDWKCWPXKXLUPURXKXLUSUTSVAVBVCVDVEWHXJXCWHXJQDTKZWIDWLLMZOZWO
      WLXEJZKZQZGWGRZXCWHXNXJDEVFVHXSXJGEWGWLEOZXRXSXJYAXPXRYAXOWIWLEDLVIVJVKYA
      XQXFWOWLEXEVLSVMVNXBXTFDTWKDOZWTXSGXAWGWKDIVLYBWNXPWSXRYBWMXOWIWKDWLLVRVO
      YBWRXQWOYBWLWQXECWPWKDVPVQSVSVTWAWBWCWDWEWF @.
  @}

  @{
    @d k m F @.  @d m M @.  @d m N @.
    @( A finite composite expressed in terms of a partial composite of an
       infinite series.  (Contributed by FL, 5-Sep-2010.)  (Revised by Mario
       Carneiro, 26-May-2014.) @)
    fprodser @p |- ( N e. ( ZZ>= ` M ) ->
      gprod_ k e. ( M ... N ) G ( F ` k ) = ( seq M ( G , F ) ` N ) ) @=
      ( vm cuz cfv wcel cfz co cv cgprd cvv cmpt cseq dffprod eluzel2 wceq wa
      vex fveq2 eqid fvex fvmpt mp1i seqfeq fveq1d eqtrd ) EDGHZIZDEJKALZBHZACM
      ECANUMOZDPZHECBDPZHUMACDEQUKEUOUPUKCFUNBDDERFLZNIUQUNHUQBHZSUKUQUJITFUAAU
      QUMURNUNULUQBUBUNUCUQBUDUEUFUGUHUI @.

  @}

  @{
    @d F j x @.  @d G x @.  @d M x @.  @d N x @.  @d j k x @.
    fprodserf.1 @e |- F/_ k F @.
    @( Version of ~ fprodser with a bound-variable hypothesis instead of a
       distinct variable condition.  (Contributed by FL, 5-Sep-2010.) @)
    fprodserf @p |- ( N e. ( ZZ>= ` M ) ->
      gprod_ k e. ( M ... N ) G ( F ` k ) = ( seq M ( G , F ) ` N ) ) @=
      ( vj cuz cfv wcel cfz co cv cgprd cseq nfcv nffv fveq2 cbvprodi fprodser
      syl5eq ) EDHIJDEKLZAMZBIZACNUBGMZBIZGCNECBDOIUBUDUFAGCGUDPAUEBFAUEPQUCUEB
      RSGBCDETUA @.
  @}

  @{
    @d A x y @.  @d B k y @.  @d G x @.  @d M k x y @.
    fprod1.1 @e |- ( k = M -> A = B ) @.
    @( The finite composite of ` A ( k ) ` from ` k = M ` to ` M ` (i.e. a
       composite with only one term) is ` B ` i.e. ` A ( M ) ` .  (Contributed
       by FL, 5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    fprod1i @p |- ( ( M e. ZZ /\ B e. V ) ->
                   gprod_ k e. ( M ... M ) G A = B ) @=
      ( cz wcel wa cfz co cgprd cvv cmpt cseq cfv cuz wceq adantr uzid syl seq1
      dffprod elex eqid fvmptg sylan 3eqtrd ) EHIZBFIZJZEEKLACDMZEDCNAOZEPQZEUN
      QZBULEERQIZUMUOSUJUQUKEUATACDEEUDUBUJUOUPSUKDUNEUCTUJENIUKUPBSEHUECEABNFU
      NGUNUFUGUHUI @.
  @}

  @{
    @d A x y @.  @d B k y @.  @d G x @.  @d M k x @.  @d N k x y @.
    fprodp1.1 @e |- ( k = ( N + 1 ) -> A = B ) @.
    @( The composite of the next term in a finite composite of ` A ( k ) ` is
       the previous term composed with ` A ( N + 1 ) = B ` .  (Contributed by
       Mario Carneiro, 26-May-2014.) @)
    fprodp1 @p |- ( ( N e. ( ZZ>= ` M ) /\ B e. V ) ->
                    gprod_ k e. ( M ... ( N + 1 ) ) G A =
                  ( gprod_ k e. ( M ... N ) G A G B ) ) @=
      ( cuz cfv wcel c1 caddc co cvv cfz cgprd wceq adantr dffprod wa cmpt cseq
      seqp1 peano2uz syl ovex eqid fvmptg mpan adantl eqcomd oveq12d 3eqtr4d )
      FEIJZKZBGKZUAZFLMNZDCOAUBZEUCZJZFVAJZUSUTJZDNZEUSPNACDQZEFPNACDQZBDNUPVBV
      ERUQDUTEFUDSURUSUOKZVFVBRUPVHUQEFUESACDEUSTUFURVGVCBVDDUPVGVCRUQACDEFTSUR
      VDBUQVDBRZUPUSOKUQVIFLMUGCUSABOGUTHUTUHUIUJUKULUMUN @.

    fprodp1i.2 @e |- B e. _V @.
    @( The composite of the next term in a finite composite of ` A ( k ) ` is
       the previous term composed with ` A ( N + 1 ) = B ` .  (Contributed by
       FL, 5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    fprodp1i @p |- ( N e. ( ZZ>= ` M ) -> gprod_ k e. ( M ... ( N + 1 ) ) G A =
                ( gprod_ k e. ( M ... N ) G A G B ) ) @=
      ( cuz cfv wcel cvv c1 caddc co cfz cgprd wceq fprodp1 mpan2 ) FEIJKBLKEFM
      NOPOACDQEFPOACDQBDORHABCDEFLGST @.
  @}

  @{
    @d k m x @.  @d m x A @.  @d x G @.  @d m x M @.
    @( The finite composite of a sequence ` A ( k ) ` from ` M ` to ` M ` (i.e.
       a composite with only one term) is ` A ( M ) ` .  (Contributed by FL,
       5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    fprod1s @p |- ( ( M e. ZZ /\ [_ M / k ]_ A e. V ) ->
                  gprod_ k e. ( M ... M ) G A = [_ M / k ]_ A ) @=
      ( vm cz wcel csb wa cfz co cgprd cv nfcv nfcsb1v csbeq1a cbvprodi fprod1i
      csbeq1 syl5eq ) DGHBDAIZEHJDDKLZABCMUCBFNZAIZFCMUBUCAUEBFCFAOBUDAPBUDAQRU
      EUBFCDEBUDDATSUA @.
  @}

  @{
    @d x B @.  @d k x M @.
    fprod1fi.1 @e |- F/_ k B @.
    fprod1fi.2 @e |- ( k = M -> A = B ) @.
    @( The finite composite of a term ` A ( k ) ` from ` M ` to ` M ` (i.e. a
       composite with only one term) is ` A ( M ) = B ` , where ` k ` is
       effectively not free in ` B ` .  (Contributed by FL, 5-Sep-2010.)
       (Revised by Mario Carneiro, 26-May-2014.) @)
    fprod1fi @p |- ( ( M e. ZZ /\ B e. V )
       -> gprod_ k e. ( M ... M ) G A = B ) @=
      ( cz wcel wa cfz co cgprd csb wceq wnfc a1i csbiegf adantr eqeltrd syldan
      simpr fprod1s eqtrd ) EIJZBFJZKZEELMACDNZCEAOZBUFUGUJFJUIUJPUHUJBFUFUJBPU
      GCEABICBQUFGRHSTZUFUGUCUAACDEFUDUBUKUE @.
  @}

  @{
    @d k m x @.  @d m x A @.  @d x G @.  @d m x M @.  @d m x N @.
    @( The composite of the next term in a finite sum of ` A ( k ) ` is the
       previous term composed with ` A ( N + 1 ) ` .  (Contributed by FL,
       19-Sep-2011.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    fprodp1s @p |- ( ( N e. ( ZZ>= ` M ) /\ [_ ( N + 1 ) / k ]_ A e. V ) ->
                     gprod_ k e. ( M ... ( N + 1 ) ) G A =
                   ( gprod_ k e. ( M ... N ) G A G [_ ( N + 1 ) / k ]_ A ) ) @=
      ( vm cuz cfv wcel c1 caddc co csb wa cfz cv cgprd csbeq1 cbvprodi fprodp1
      nfcv nfcsb1v csbeq1a oveq1i 3eqtr4g ) EDHIJBEKLMZANZFJODUGPMZBGQZANZGCRDE
      PMZUKGCRZUHCMUIABCRULABCRZUHCMUKUHGCDEFBUJUGASUAUIAUKBGCGAUBZBUJAUCZBUJAU
      DZTUNUMUHCULAUKBGCUOUPUQTUEUF @.
  @}

  @{
    @d k x @.  @d x B @.  @d k N @.
    fprodp1fi.1 @e |- B e. _V @.
    fprodp1fi.2 @e |- F/_ k B @.
    fprodp1fi.3 @e |- ( k = ( N + 1 ) -> A = B ) @.
    @( The composite of the next term in a finite composite of ` A ( k ) ` is
       the previous term composed with ` A ( N + 1 ) = B ` .  (Contributed by
       FL, 5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    fprodp1fi @p |- ( N e. ( ZZ>= ` M ) ->
    gprod_ k e. ( M ... ( N + 1 ) ) G A =
    ( gprod_ k e. ( M ... N ) G A G B ) ) @=
      ( cuz cfv wcel c1 caddc co cfz cgprd csb cvv wceq csbief eqeltri fprodp1s
      ovex mpan2 oveq2i syl6eq ) FEJKLZEFMNOZPOACDQZEFPOACDQZCUIARZDOZUKBDOUHUL
      SLUJUMTULBSCUIABFMNUDHIUAZGUBACDEFSUCUEULBUKDUNUFUG @.
  @}

  @{
    @d m A @.  @d k m M @.  @d k m N @.
    @( Relation between ` sum_ ` and ` gprod_ ` .  (Contributed by FL,
       5-Sep-2010.)  (Revised by Mario Carneiro, 26-May-2014.) @)
    fsumprd @p |- ( A. k e. ( M ... N ) A e. CC ->
        sum_ k e. ( M ... N ) A = gprod_ k e. ( M ... N ) + A ) @=
      ( vm cc wcel cfz co wral csu caddc cgprd wceq wi c0 cc0 cgi cfv wa gprod0
      cnid sum0 3eqtr4i sumeq1 gprodeq1 3eqtr4a a1d wne fzn0 cv cmpt cseq eqidd
      cuz simpl wf simpr eqid fmpt sylib ffvelrn fsumser fprodser adantr eqtr4d
      sylan sumfc wss ssid gprodeqfv ax-mp 3eqtr3g ex sylbi pm2.61ine ) AFGBCDH
      IZJZVQABKZVQABLMZNZOZVQPVQPNZWAVRWCPABKZPABLMZVSVTQLRSWDWEUBABUCABLUAUDVQ
      PABUEVQPABLUFUGUHVQPUIDCUOSGZWBCDUJWFVRWAWFVRTZVQEUKZBVQAULZSZEKZVQWJELMZ
      VSVTWGWKDLWICUMSZWLWGWJEWICDWGWHVQGZTWJUNWFVRUPWGVQFWIUQZWNWJFGWGVRWOWFVR
      URBVQFAWIWIUSZUTVAVQFWHWIVBVGVCWFWLWMNVREWILCDVDVEVFVQAEBVHVQVQVIWLVTNVQV
      JAVQVQBEWILWPVKVLVMVNVOVP @.
  @}

  @{
    @d B1 k @.  @d B2 a k @.  @d C k @.  @d M k @.
    fprod2.1 @e |- ( k = M -> A = B1 ) @.
    fprod2.2 @e |- ( k = ( M + 1 ) -> A = B2 ) @.
    @( The finite composite of ` A ( k ) ` from ` k = M ` to ` ( M + 1 ) `
       (i.e. a composite with two terms) is ` ( B1 G B2 ) ` i.e.
       ` ( A ( M ) G A ( M + 1 ) ) ` .  (Contributed by FL, 22-Nov-2010.)
       (Revised by Mario Carneiro, 26-May-2014.) @)
    fprod2 @p |- ( ( M e. ZZ /\ B1 e. V /\ B2 e. W ) ->
                   gprod_ k e. ( M ... ( M + 1 ) ) G A = ( B1 G B2 ) ) @=
      ( cz wcel w3a c1 caddc co cfz cgprd cuz wceq cfv 3ad2ant1 fprodp1 syl2anc
      uzid simp3 fprod1i 3adant3 oveq1d eqtrd ) DKLZGELZHFLZMZDDNOPQPABCRZDDQPA
      BCRZHCPZGHCPUNDDSUALZUMUOUQTUKULURUMDUEUBUKULUMUFAHBCDDFJUCUDUNUPGHCUKULU
      PGTUMAGBCDEIUGUHUIUJ @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Operation properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Com1 @.

  @( Extend class notation with a class that adds commutativity to semi-groups,
     monoids and so on. @)
  ccm1 @a class Com1 @.

  @{
    @d g x y @.
    @( A device to add commutativity to magmas, semi-groups, monoids and so
       on.  A commutative group is composed of 5 properties (internal
       operation, commutativity, associativity, existence of a neutral element
       and an inverse).  If we switch on or off those four properties we get 32
       structures.  Instead of giving a name to those 32 structures, I suggest
       we use intersected classes and speak of ` ( Magma i^i Com1 ) ` or
       ` ( Magma i^i ExId ) ` .  (Contributed by FL, 5-Sep-2010.) @)
    df-com1 @a |- Com1 = { g | A. x e. dom dom g A. y e. dom dom g
      ( x g y ) = ( y g x ) } @.
  @}

  @{
    iscom.1 @e |- X = dom dom G @.
    @{
      @d G a x y @.  @d X a @.
      @( The predicate "is a commutative operation".  (Contributed by FL,
         5-Sep-2010.) @)
      iscom @p |- ( G e. A -> ( G e. Com1 <-> A. x e. X A. y e. X
      ( x G y ) = ( y G x ) ) ) @=
        ( va cv co wceq wral ccm1 wcel dmeq eqcomd eleq2d oveq imbi12d ralbidv2
        cdm dmeqd syl5req eqeq12d df-com1 elab2g ) AHZBHZGHZIZUGUFUHIZJZBUHTZTZ
        KZAUMKUFUGDIZUGUFDIZJZBEKZAEKGDLCUHDJZUNURAUMEUSUFUMMUFEMUNURUSUMEUFUSE
        DTZTUMFUSUTULUSULUTUHDNOUAUBZPUSUKUQBUMEUSUGUMMUGEMUKUQUSUMEUGVAPUSUIUO
        UJUPUFUGUHDQUGUFUHDQUCRSRSABGUDUE @.
    @}

    @{
      @d A x y @.  @d B y @.  @d G x y @.  @d X x y @.
      @( The predicate "is a commutative operation".  (Contributed by FL,
         14-Sep-2010.) @)
      iscomb @p |- ( ( G e. Com1 /\ A e. X /\ B e. X )
       -> ( A G B ) = ( B G A ) ) @=
        ( vx vy ccm1 wcel co wceq wi cv wral iscom oveq1 oveq2 eqeq12d rspc2v
        ex com3r syl6bi pm2.43i 3imp ) CHIZADIZBDIZABCJZBACJZKZUEUFUGUJLLZUEUEF
        MZGMZCJZUMULCJZKZGDNFDNZUKFGHCDEOUFUGUQUJUFUGUQUJLUPUJAUMCJZUMACJZKFGAB
        DDULAKUNURUOUSULAUMCPULAUMCQRUMBKURUHUSUIUMBACQUMBACPRSTUAUBUCUD @.
    @}
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Groups and related structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d G x @.  @d U x @.  @d V x @.  @d X x @.
    @( If a magma has a left identity element and a right identity element,
       they are equal.  (Contributed by FL, 25-Sep-2011.) @)
    ridlideq @p |- ( ( U e. X /\ V e. X ) ->
      ( A. x e. X ( ( U G x ) = x /\ ( x G V ) = x )
        -> U = V ) ) @=
      ( cv co wceq wa wral wcel wi oveq2 id eqeq12d oveq1 anbi12d im2anan9 eqtr
      rspcv ex eqcoms adantrd adantl imp syl6com anidms com12 ) BAFZCGZUIHZUIDC
      GZUIHZIZAEJZBEKZDEKZIZBDHZUOURUSLURUOUOIBBCGZBHZBDCGZBHZIZVBDHZDDCGZDHZIZ
      IUSUPUOVDUQUOVHUNVDABEUIBHZUKVAUMVCVIUJUTUIBUIBBCMVINZOVIULVBUIBUIBDCPVJO
      QTUNVHADEUIDHZUKVEUMVGVKUJVBUIDUIDBCMVKNZOVKULVFUIDUIDDCPVLOQTRVDVHUSVCVH
      USLVAVCVEUSVGVEUSLBVBBVBHVEUSBVBDSUAUBUCUDUEUFUGUH @.
  @}

  @{
    @d G x @.  @d U x @.  @d V x @.  @d X x @.
    @( If a magma has a left zero element and a right zero element, they are
       equal.  (Contributed by FL, 25-Dec-2011.) @)
    rzrlzreq @p |- ( ( U e. X /\ V e. X ) ->
      ( A. x e. X ( ( U G x ) = U /\ ( x G V ) = V )
        -> U = V ) ) @=
      ( cv co wceq wa wral wcel wi oveq2 eqeq1d oveq1 anbi12d rspcva eqtr com12
      ex eqcoms adantr adantl imp syl2an an4s expcom anidms ) BAFZCGZBHZUIDCGZD
      HZIZAEJZBEKZDEKZIZBDHZUOURUSLURUOUOIUSUPUOUQUOUSUPUOIBBCGZBHZBDCGZDHZIZVB
      BHZDDCGZDHZIZUSUQUOIUNVDABEUIBHZUKVAUMVCVIUJUTBUIBBCMNVIULVBDUIBDCONPQUNV
      HADEUIDHZUKVEUMVGVJUJVBBUIDBCMNVJULVFDUIDDCONPQVDVHUSVCVHUSLVAVHVCUSVEVCU
      SLZVGVKBVBBVBHVCUSBVBDRTUAUBSUCUDUEUFUGUHS @.
  @}

  @{
    @d G x y z @.  @d U x y z @.  @d X x y z @.
    mgmlion.1 @e |- X = dom dom G @.
    @( If a magma has a left identity element, it is onto.  (Contributed by FL,
       25-Sep-2011.) @)
    mgmlion @p |- ( ( G e. Magma /\ U e. X /\ A. x e. X ( U G x ) = x )
      -> G : ( X X. X ) -onto-> X ) @=
      ( vy vz cmagm wcel cv co wceq wral w3a cxp wf wrex wa eqeq2d rspcev ismgm
      wfo ibi 3ad2ant1 simpllr simplr id eqcoms adantl weq oveq2 syl2anc jca ex
      oveq1 rexbidv syl6 ralimdva 3impia foov sylanbrc ) CHIZBDIZBAJZCKZVDLZADM
      ZNDDOZDCPZVDFJZGJZCKZLZGDQZFDQZADMZVHDCUBVBVCVIVGVBVIHCDEUAUCUDVBVCVGVPVB
      VCRZVFVOADVQVDDIZRZVFVCVDBVKCKZLZGDQZRZVOVSVFWCVSVFRZVCWBVBVCVRVFUEWDVRVD
      VELZWBVQVRVFUFVFWEVSWEVDVEWEUGUHUIWAWEGVDDGAUJVTVEVDVKVDBCUKSTULUMUNVNWBF
      BDVJBLZVMWAGDWFVLVTVDVJBVKCUOSUPTUQURUSFGADDDCUTVA @.
  @}

  @( ` RR ` is a group for addition.  (Contributed by FL, 22-Dec-2008.) @)
  rrisgrp @p |- ( + |` ( RR X. RR ) ) e. GrpOp @=
    ( caddc cgr wcel cxp cres wss csubgo cfv w3a readdsubgo issubgo mpbi simp2i
    cr ) ABCZANNDEZBCZPAFZPAGHCOQRIJAPKLM @.

  @( A way to express the domain of a group.  (Contributed by FL,
     9-Jan-2011.) @)
  dmrngrp @p |- ( G e. GrpOp -> dom G = ( ran G X. ran G ) ) @=
    ( cgr wcel crn cxp wfo wf cdm wceq eqid grpofo fof fdm 3syl ) ABCADZOEZOAFP
    OAGAHPIAOOJKPOALPOAMN @.

  @{
    @d G x y @.  @d X x y @.
    bsmgrli.1 @e |- X = ran G @.
    @( The base set of an operation with a right and left identity element is
       not empty.  (Contributed by FL, 18-Feb-2010.)  (Revised by Mario
       Carneiro, 23-Dec-2013.) @)
    bsmgrli @p |- ( G e. ( Magma i^i ExId ) -> X =/= (/) ) @=
      ( vy vx cmagm cexid cin wcel cv co wceq wa wral wrex c0 wne isexid2 rexn0
      syl ) AFGHIDJZEJZAKUBLUBUAAKUBLMEBNZDBOBPQEDABCRUCDBST @.
  @}

  @{
    @d A x y z @.  @d B y z @.  @d C z @.  @d G x y z @.  @d X x y z @.
    smgrpass2.1 @e |- X = dom dom G @.
    @( A semi-group is associative.  (Contributed by FL, 12-Dec-2009.) @)
    smgrpass2 @p |- ( ( G e. SemiGrp /\ ( A e. X /\ B e. X /\ C e. X ) )
      -> ( ( A G B ) G C ) = ( A G ( B G C ) ) ) @=
      ( vx vy vz csem wcel cv co wceq wral oveq1 oveq1d eqeq12d oveq2 oveq2d
      w3a smgrpass rspc3v mpan9 ) DJKGLZHLZDMZILZDMZUEUFUHDMZDMZNZIEOHEOGEOAEKB
      EKCEKUAABDMZCDMZABCDMZDMZNZGHIDEFUBULUQAUFDMZUHDMZAUJDMZNUMUHDMZABUHDMZDM
      ZNGHIABCEEEUEANZUIUSUKUTVDUGURUHDUEAUFDPQUEAUJDPRUFBNZUSVAUTVCVEURUMUHDUF
      BADSQVEUJVBADUFBUHDPTRUHCNZVAUNVCUPUHCUMDSVFVBUOADUHCBDSTRUCUD @.
  @}

  @{
    @d G x y @.
    @( An abelian group is a commutative group.  (Contributed by FL,
       14-Sep-2010.) @)
    ablocomgrp @p |- ( G e. AbelOp -> G e. ( GrpOp i^i Com1 ) ) @=
      ( vx vy cgr wcel cv co wceq crn wral wa ccm1 cablo cin cdm grporndm iscom
      wi eqid biimprd raleq raleqbi1dv imbi1d syl5ibr mpcom isablo elin 3imtr4i
      imdistani ) ADEZBFZCFZAGULUKAGHZCAIZJZBUNJZKUJALEZKAMEADLNEUJUPUQUNAOOZHZ
      UJUPUQRZAPUJUTUSUMCURJZBURJZUQRUJUQVBBCDAURURSQTUSUPVBUQUOVABUNURUMCUNURU
      AUBUCUDUEUIBCAUNUNSUFADLUGUH @.
  @}

  @{
    reacomsmgrp1.1 @e |- X = dom dom G @.
    @( Rearrangement of three terms in a commutative semi-group.  (Contributed
       by FL, 14-Sep-2010.) @)
    reacomsmgrp1 @p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( A G ( B G C ) ) = ( B G ( A G C ) ) ) @=
      ( csem ccm1 cin wcel w3a wa wceq inss1 sseli smgrpass2 eqcomd sylan inss2
      co adantr simpr1 simpr2 iscomb syl3anc oveq1d simp2 simp1 syl2an 3eqtrd
      simp3 3jca ) DGHIZJZAEJZBEJZCEJZKZLZABCDTDTZABDTZCDTZBADTZCDTZBACDTDTZUND
      GJZURUTVBMUMGDGHNOZVFURLVBUTABCDEFPQRUSVAVCCDUSDHJZUOUPVAVCMUNVHURUMHDGHS
      OUAUNUOUPUQUBUNUOUPUQUCABDEFUDUEUFUNVFUPUOUQKVDVEMURVGURUPUOUQUOUPUQUGUOU
      PUQUHUOUPUQUKULBACDEFPUIUJ @.

    @( Rearrangement of three terms in a commutative semi-group.  (Contributed
       by FL, 14-Sep-2010.) @)
    reacomsmgrp2 @p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( A G ( B G C ) ) = ( C G ( B G A ) ) ) @=
      ( csem ccm1 cin wcel w3a wa co wceq inss1 smgrpass2 eqcomd iscomb syl3anc
      sseli sylan inss2 adantr simpr1 simpr2 oveq1d cmagm smgrpismgm clmgm 3exp
      syl wi com13 imp 3adant3 mpan9 simpr3 3eqtrd ) DGHIZJZAEJZBEJZCEJZKZLZABC
      DMDMZABDMZCDMZBADMZCDMZCVIDMZUTDGJZVDVFVHNUSGDGHOTZVLVDLVHVFABCDEFPQUAVEV
      GVICDVEDHJZVAVBVGVINUTVNVDUSHDGHUBTUCZUTVAVBVCUDUTVAVBVCUEABDEFRSUFVEVNVI
      EJZVCVJVKNVOUTDUGJZVDVPUTVLVQVMDUHUKVAVBVQVPULZVCVAVBVRVQVBVAVPVQVBVAVPBA
      DEFUIUJUMUNUOUPUTVAVBVCUQVICDEFRSUR @.

    @( Rearrangement of three terms in a commutative semi-group.  (Contributed
       by FL, 14-Sep-2010.) @)
    reacomsmgrp3 @p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( ( A G B ) G C ) = ( ( A G C ) G B ) ) @=
      ( csem ccm1 cin wcel w3a wa wceq inss2 sseli adantr clmgm syl3anc iscomb
      co cmagm inss1 smgrpismgm syl simpr1 simpr2 simpr3 simp3 simp1 simp2 3jca
      reacomsmgrp2 sylan2 3eqtrd ) DGHIZJZAEJZBEJZCEJZKZLZABDTZCDTZCVBDTZBACDTZ
      DTZVEBDTZVADHJZVBEJZUSVCVDMUPVHUTUOHDGHNOPZVADUAJZUQURVIUPVKUTUPDGJVKUOGD
      GHUBODUCUDPZUPUQURUSUEZUPUQURUSUFZABDEFQRUPUQURUSUGZVBCDEFSRUTUPUSUQURKVD
      VFMUTUSUQURUQURUSUHUQURUSUIUQURUSUJUKCABDEFULUMVAVHURVEEJZVFVGMVJVNVAVKUQ
      USVPVLVMVOACDEFQRBVEDEFSRUN @.

    @( Rearrangement of terms in a commutative semi-group.  (Contributed by FL,
       18-Sep-2010.) @)
    reacomsmgrp4 @p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
      ( A e. X /\ B e. X /\ C e. X ) )
        -> ( A G ( B G C ) ) = ( ( C G B ) G A ) ) @=
      ( csem ccm1 cin wcel w3a wa co reacomsmgrp2 inss1 sseli simp3 simp2 simp1
      wceq 3jca smgrpass2 eqcomd syl2an eqtrd ) DGHIZJZAEJZBEJZCEJZKZLABCDMDMCB
      ADMDMZCBDMADMZABCDEFNUGDGJZUJUIUHKZULUMTUKUFGDGHOPUKUJUIUHUHUIUJQUHUIUJRU
      HUIUJSUAUNUOLUMULCBADEFUBUCUDUE @.

  @}

  @{
    @d m x y A @.  @d x y G @.  @d k m x y M @.  @d k m x y N @.  @d k x y X @.
    clfsebs.1 @e |- X = dom dom G @.
    @( Closure of a finite composite of elements of the base set of an internal
       operation.  (Contributed by FL, 14-Sep-2010.)  (Proof shortened by Mario
       Carneiro, 26-May-2014.) @)
    clfsebs @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Magma /\
                      A. k e. ( M ... N ) A e. X )
       -> gprod_ k e. ( M ... N ) G A e. X ) @=
      ( vm vx vy cuz cfv wcel cmagm cfz co wral cgprd cv wceq w3a cmpt cseq wss
      ssid eqid gprodeqfv ax-mp fprodser 3ad2ant1 syl5eqr simp1 wf fmpt ffvelrn
      sylanb 3ad2antl3 wa clmgm 3expb 3ad2antl2 seqcl eqeltrd ) EDKLMZCNMZAFMBD
      EOPZQZUAZVFABCRZECBVFAUBZDUCLZFVHVIVFHSVJLHCRZVKVFVFUDVLVITVFUEAVFVFBHVJC
      VJUFZUGUHVDVEVLVKTVGHVJCDEUIUJUKVHIJCFVJDEVDVEVGULVGVDISZVFMZVNVJLFMZVEVG
      VFFVJUMVOVPBVFFAVJVMUNVFFVNVJUOUPUQVEVDVNFMZJSZFMZURVNVRCPFMZVGVEVQVSVTVN
      VRCFGUSUTVAVBVC @.
  @}

  @{
    @d G k @.  @d M k @.  @d N k @.
    @( Closure of a finite composite of elements of the base set of an internal
       operation.  (Closed version.)  (Contributed by FL, 14-Sep-2010.) @)
    clfsebsg @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. Magma /\
                      A. k e. ( M ... N ) A e. dom dom G )
       -> gprod_ k e. ( M ... N ) G A e. dom dom G ) @=
      ( cdm eqid clfsebs ) ABCDECFFZIGH @.
  @}

  @{
    @d G k @.  @d M k @.  @d N k @.
    clfsebsr.1 @e |- X = ran G @.
    @( Closure of a finite composite of elements of the base set of an internal
       operation.  (Case of a magma with a right and left identity element.)
       (Contributed by FL, 14-Sep-2010.) @)
    clfsebsr @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. ( Magma i^i ExId ) /\
                      A. k e. ( M ... N ) A e. X )
       -> gprod_ k e. ( M ... N ) G A e. X ) @=
      ( cuz cfv wcel cmagm cexid cin cfz co wral cdm 3ad2ant2 wi wceq w3a cgprd
      simp1 inss1 sseli crn rngopid eqcomi eqeq1i biimpi eleq2d ralbidv syl a1i
      biimpd 3imp clfsebsg syl3anc syl5eq eleqtrrd ) EDHIJZCKLMZJZAFJZBDENOZPZU
      AZVEABCUBZCQQZFVGVACKJZAVIJZBVEPZVHVIJVAVCVFUCVCVAVJVFVBKCKLUDUERVAVCVFVL
      VCVFVLSZSVAVCCUFZVITZVMCUGZVOVFVLVOVDVKBVEVOFVIAVOFVITZVNFVIFVNGUHUIUJUKU
      LUOUMUNUPABCDEUQURVCVAVQVFVCFVNVIGVPUSRUT @.
  @}

  @{
    @d x y G @.  @d k m x y M @.  @d k m x y N @.  @d k m x y U @.
    fincmpzer.1 @e |- U = ( GId ` G ) @.
    @( Finite composite of identity elements.  (Contributed by FL,
       14-Sep-2010.)  (Proof shortened by Mario Carneiro, 15-Dec-2014.) @)
    fincmpzer @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. ( Magma i^i ExId ) )
       -> gprod_ k e. ( M ... N ) G U = U ) @=
      ( vm vx cuz cfv wcel cmagm wa co cgprd wceq cv eqid adantl cgi cexid cmpt
      cin cfz cseq ssid gprodeqfv ax-mp fprodser syl5eqr adantr iorlid cmpidelt
      wss crn mpdan simpld simpl eqidd cvv fvex eqeltri fvmpt seqid3 eqtrd ) ED
      IJKZCLUAUCKZMZDEUDNZABCOZECBVIAUBZDUEJZAVFVJVLPVGVFVJVIGQVKJGCOZVLVIVIUNV
      MVJPVIUFAVIVIBGVKCVKRZUGUHGVKCDEUIUJUKVHHCVKDEAVGAACNAPZVFVGVOVOVGACUOZKV
      OVOMACVPVPRZFULAACVPVQFUMUPUQSVFVGURHQZVIKVRVKJAPVHBVRAAVIVKBQVRPAUSVNACT
      JUTFCTVAVBVCSVDVE @.
  @}

  @{
    resgcom.1 @e |- X = dom dom G @.
    @( Rearrangement of four terms in a commutative, associative magma.
       (Contributed by FL, 14-Sep-2010.) @)
    resgcom @p |- ( ( G e. ( SemiGrp i^i Com1 ) /\
  ( ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X ) ) )
   -> ( ( A G B ) G ( C G D ) ) = ( ( A G C ) G ( B G D ) ) ) @=
      ( csem ccm1 wcel wa co wceq wi clmgm 3exp imp adantl mpan9 smgrpass2 3jca
      inss1 sseli adantr simprll simprlr cmagm smgrpismgm com3l syl13anc simplr
      cin syl w3a simprl simprr reacomsmgrp1 sylan2 oveq2d simprrl com13 eqcomd
      com12 3eqtrd ) EHIULZJZAFJZBFJZKZCFJZDFJZKZKZKZABELCDELZELZABVOELZELZACBD
      ELZELZELZACELVSELZVNEHJZVGVHVOFJZVPVRMVFWCVMVEHEHIUBUCZUDZVFVGVHVLUEZVFVG
      VHVLUFVFEUGJZVMWDVFWCWHWEEUHUMZVLWHWDNZVIVJVKWJWHVJVKWDWHVJVKWDCDEFGOPUIQ
      RSABVOEFGTUJVNVQVTAEVMVFVHVJVKUNVQVTMVMVHVJVKVGVHVLUKVIVJVKUOVIVJVKUPUABC
      DEFGUQURUSVNWCVGVJVSFJZWAWBMWFWGVFVIVJVKUTVFWHVMWKWIVIVLWHWKNZVHVLWLNVGVL
      VHWLVKVHWLNVJWHVHVKWKWHVHVKWKBDEFGOPVARVCRQSWCVGVJWKUNKWBWAACVSEFGTVBUJVD
      @.
  @}

  @{
    @d k m n x y z G @.  @d k m n x y z M @.  @d k m n x y z N @.
    @d m n x y z A @.  @d m n x y z B @.  @d k n x y z X @.
    fprodadd.1 @e |- X = dom dom G @.
    @( The composite of two finite composites.  (Contributed by FL,
       14-Sep-2010.)  (Proof shortened by Mario Carneiro, 30-May-2014.) @)
    fprodadd @p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
       ( A e. X /\ B e. X ) /\ G e. ( SemiGrp i^i Com1 ) ) ->
       gprod_ k e. ( M ... N ) G ( A G B ) =
         ( gprod_ k e. ( M ... N ) G A G gprod_ k e. ( M ... N ) G B ) ) @=
      ( vm cfv wcel wa co wral csem cv cgprd sylan wceq oveq12d vx vy vz vn cuz
      cfz ccm1 cin w3a cmpt cseq cmagm simp3 elin sylib simpld smgrpismgm clmgm
      3expb simprd iscomb smgrpass2 simp1 wf simpl ralimi 3ad2ant2 eqid ffvelrn
      syl fmpt simpr cvv ovex fvmpt2 mpan2 adantr adantrr adantrl eqtr4d nfmpt1
      ralimiaa nfcv nffv nfov nfeq fveq2 eqeq12d rspc seqcaopr fprodser 3eqtr4d
      mpan9 wss ssid gprodeqfv ax-mp 3eqtr3g ) FEUEJKZAGKZBGKZLZCEFUFMZNZDOUGUH
      KZUIZXCIPZCXCABDMZUJZJIDQZXCXGCXCAUJZJIDQZXCXGCXCBUJZJIDQZDMZXCXHCDQZXCAC
      DQZXCBCDQZDMZXFFDXIEUKJZFDXKEUKJZFDXMEUKJZDMZXJXOXFUAUBUCDGUDXKXMXIEFXFDU
      LKZUAPZGKZUBPZGKZLZYEYGDMZGKZXFDOKZYDXFYLDUGKZXFXEYLYMLWSXDXEUMDOUGUNUOZU
      PZDUQVJYDYFYHYKYEYGDGHURUSRXFYMYIYJYGYEDMSZXFYLYMYNUTYMYFYHYPYEYGDGHVAUSR
      XFYLYFYHUCPZGKUIYJYQDMYEYGYQDMDMSYOYEYGYQDGHVBRWSXDXEVCZXFXCGXKVDZUDPZXCK
      ZYTXKJZGKXFWTCXCNZYSXDWSUUCXEXBWTCXCWTXAVEVFVGCXCGAXKXKVHZVKUOXCGYTXKVIRX
      FXCGXMVDZUUAYTXMJZGKXFXACXCNZUUEXDWSUUGXEXBXACXCWTXAVLVFVGCXCGBXMXMVHZVKU
      OXCGYTXMVIRXFCPZXIJZUUIXKJZUUIXMJZDMZSZCXCNZUUAYTXIJZUUBUUFDMZSZXDWSUUOXE
      XBUUNCXCUUIXCKZXBLZUUJXHUUMUUSUUJXHSZXBUUSXHVMKUVAABDVNCXCXHVMXIXIVHZVOVP
      VQUUTUUKAUULBDUUSWTUUKASXACXCAGXKUUDVOVRUUSXAUULBSWTCXCBGXMUUHVOVSTVTWBVG
      UUNUURCYTXCCUUPUUQCYTXICXCXHWACYTWCZWDCUUBUUFDCYTXKCXCAWAUVCWDCDWCCYTXMCX
      CBWAUVCWDWEWFUUIYTSZUUJUUPUUMUUQUUIYTXIWGUVDUUKUUBUULUUFDUUIYTXKWGUUIYTXM
      WGTWHWIWMWJXFWSXJXTSYRIXIDEFWKVJXFWSXOYCSYRWSXLYAXNYBDIXKDEFWKIXMDEFWKTVJ
      WLXCXCWNZXJXPSXCWOZXHXCXCCIXIDUVBWPWQUVEXOXSSUVFUVEXLXQXNXRDAXCXCCIXKDUUD
      WPBXCXCCIXMDUUHWPTWQWR @.
  @}

  @{
    ablinvop.1 @e |- X = ran G @.
    ablinvop.2 @e |- N = ( inv ` G ) @.
    @( The inverse of the abelian group operation doesn't reverse the
       arguments. cf ~ grpoinvop .  (Contributed by FL, 14-Sep-2010.) @)
    abloinvop @p |- ( ( G e. AbelOp /\ A e. X /\ B e. X ) ->
                   ( N ` ( A G B ) ) = ( ( N ` A ) G ( N ` B ) ) ) @=
      ( cablo wcel w3a co cfv cgr wceq ablogrpo grpoinvop syl3an1 simp1 3adant2
      grpoinvcl 3adant3 ablocom syl3anc eqtrd ) CHIZAEIZBEIZJZABCKDLZBDLZADLZCK
      ZUKUJCKZUECMIZUFUGUIULNCOZABCDEFGPQUHUEUJEIZUKEIZULUMNUEUFUGRUEUNUFUGUPUO
      UNUGUPUFBCDEFGTSQUEUNUFUGUQUOUNUFUQUGACDEFGTUAQUJUKCEFUBUCUD @.
  @}

  @{
    @d x y z F @.  @d x y z G @.  @d x y z M @.  @d x y z N @.  @d x y z X @.
    @d x y z Z @.
    isppm.1 @e |- X = dom dom G @.
    isppm.2 @e |- Z = ( ZZ>= ` M ) @.
    @( The sequence of partial composites of elements of a magma is a sequence
       of elements of this magma.  (Contributed by FL, 24-Jan-2010.)  (Revised
       by Mario Carneiro, 30-May-2014.) @)
    isppm @p |- ( ( G e. Magma /\ M e. ZZ /\ F : Z --> X ) ->
      seq M ( G , F ) : Z --> X ) @=
      ( vx vy cmagm wcel cz wf w3a simp2 cv cfv ffvelrn 3ad2antl3 wa clmgm seqf
      co 3expb 3ad2antl1 ) BJKZCLKZEDAMZNHIBDACEGUFUGUHOUHUFHPZEKUIAQDKUGEDUIAR
      SUFUGUIDKZIPZDKZTUIUKBUCDKZUHUFUJULUMUIUKBDFUAUDUEUB @.

    seqzp2.1 @e |- G e. SemiGrp @.
    seqzp2.2 @e |- F : Z --> X @.
    @( Value of the arbitrary-based recursive sequence builder at a successor
       value when the operation ` G ` is associative.  Compare with ~ seqp1 .
       (Contributed by FL, 24-Jan-2010.) @)
    seqzp2 @p |- ( N e. Z ->
      ( seq M ( G , F ) ` ( N + 1 ) ) =
        ( ( F ` M ) G ( seq ( M + 1 ) ( G , F ) ` ( N + 1 ) ) ) ) @=
      ( vx vy vz wcel c1 caddc co cv adantl cfv wa cmagm smgrpismgm ax-mp clmgm
      csem mp3an1 w3a wceq smgrpass2 mpan cuz eluzp1p1 eleq2s cz eluzel2 elfzuz
      cfz syl6eleqr ffvelrni syl seq1p ) DFNZKLMBEACDOPQZKRZENZLRZENZUAVEVGBQZE
      NZVCBUBNZVFVHVJBUFNZVKIBUCUDVEVGBEGUEUGSVFVHMRZENUHZVIVMBQVEVGVMBQBQUIZVC
      VLVNVOIVEVGVMBEGUJUKSVDCOPQULTNDCULTZFCDUMHUNCUONDVPFCDUPHUNVECVDURQNZVEA
      TENZVCVQVEFNVRVQVEVPFVECVDUQHUSFEVEAJUTVASVB @.
  @}

  @( A monoid is associative.  (Contributed by FL, 2-Nov-2009.) @)
  mndoisass @p |- ( G e. MndOp -> G e. Ass ) @=
    ( cmndo wcel csem cass mndoissmgrp smgrpisass syl ) ABCADCAECAFAGH @.

  @{
    @d G x y z @.  @d X x y z @.
    mndoid.1 @e |- X = ran G @.
    @( A monoid has an identity element.  (Contributed by FL, 2-Nov-2009.)
       (Revised by Mario Carneiro, 23-Dec-2013.) @)
    mndoid @p |- ( G e. MndOp -> E. x e. X A. y e. X
      ( ( x G y ) = y /\ ( y G x ) = y ) ) @=
      ( vz cmndo wcel cv co wceq wa wral wrex cxp wf w3a ismndo2 simp3 syl6bi
      pm2.43i ) CGHZAIZBIZCJZUDKUDUCCJUDKLBDMADNZUBUBDDODCPZUEFIZCJUCUDUHCJCJKF
      DMBDMADMZUFQUFABFGCDERUGUIUFSTUA @.

    @( A monoid is an internal operation.  (Contributed by FL, 2-Nov-2009.)
       (Revised by Mario Carneiro, 23-Dec-2013.) @)
    mndoio @p |- ( G e. MndOp -> G : ( X X. X ) --> X ) @=
      ( vx vy vz cmndo wcel cxp wf cv co wceq wral wa wrex ismndo2 simp1 syl6bi
      w3a pm2.43i ) AGHZBBIBAJZUBUBUCDKZEKZALZFKZALUDUEUGALALMFBNEBNDBNZUFUEMUE
      UDALUEMOEBNDBPZTUCDEFGABCQUCUHUIRSUA @.

    @( A monoid is associative.  (Contributed by FL, 2-Nov-2009.)  (Revised by
       Mario Carneiro, 23-Dec-2013.) @)
    mndoass @p |- ( G e. MndOp ->
        A. x e. X A. y e. X A. z e. X
          ( ( x G y ) G z ) = ( x G ( y G z ) ) ) @=
      ( cmndo wcel cv co wceq wral cxp wf wa wrex w3a ismndo2 simp2 syl6bi
      pm2.43i ) DGHZAIZBIZDJZCIZDJUCUDUFDJDJKCELBELAELZUBUBEEMEDNZUGUEUDKUDUCDJ
      UDKOBELAEPZQUGABCGDEFRUHUGUISTUA @.

    @d A x y z @.  @d B y z @.  @d C z @.
    @( A monoid is associative.  (Contributed by FL, 12-Dec-2009.) @)
    mndoass2 @p |- ( ( G e. MndOp /\ ( A e. X /\ B e. X /\ C e. X ) )
      -> ( ( A G B ) G C ) = ( A G ( B G C ) ) ) @=
      ( vx vy vz cmndo wcel cv co wceq wral oveq1 oveq1d eqeq12d oveq2 oveq2d
      w3a mndoass rspc3v mpan9 ) DJKGLZHLZDMZILZDMZUEUFUHDMZDMZNZIEOHEOGEOAEKBE
      KCEKUAABDMZCDMZABCDMZDMZNZGHIDEFUBULUQAUFDMZUHDMZAUJDMZNUMUHDMZABUHDMZDMZ
      NGHIABCEEEUEANZUIUSUKUTVDUGURUHDUEAUFDPQUEAUJDPRUFBNZUSVAUTVCVEURUMUHDUFB
      ADSQVEUJVBADUFBUHDPTRUHCNZVAUNVCUPUHCUMDSVFVBUOADUHCBDSTRUCUD @.
  @}

  @( Declare the symbol for the monoid exponentiation. @)
  @c ^md @.

  @( Extend class notation with monoid exponentiation. @)
  clsg @a class ^md @.

  @{
    @d g f x y z @.
    @( Define the exponentiation of an element of a monoid.  Experimental.  I
       define exponentiation on a monoid (and not on a semi-group or a magma )
       because I need an identity element for the basis hypothesis and
       associativity for interesting properties such as the composite of two
       exponentiated elements. ` ZZ ` is used in ~ df-gx here I used ` NN0 `
       because the inverse is not defined in a monoid.  (Contributed by FL,
       2-Sep-2013.) @)
    df-expsg @a |- ^md = ( g e. MndOp |-> ( x e. ran g , y e. NN0 |->
      if ( y = 0 , ( GId ` g ) , ( seq 1 ( g , ( NN x. { x } ) ) ` y ) ) ) ) @.
  @}

  @{
    expmiz.2 @e |- F =
        ( rec ( ( a e. _V |-> ( a G A ) ) , ( GId ` G ) ) |` om ) @.
    @{
      @( Value of a member of a monoid (or any other structure where ` GId ` is
         defined ) raised to the 0th power.  (Contributed by FL,
         12-Dec-2009.) @)
      expmiz @p |- ( F ` (/) ) = ( GId ` G ) @=
        ( c0 cfv cvv cv co cmpt cgi crdg com cres fveq1i wcel wceq fvex fr0g
        ax-mp eqtri ) FBGFDHDIACJKZCLGZMNOZGZUDFBUEEPUDHQUFUDRCLSUDHUCTUAUB @.
    @}

    @{
      @d A a b @.  @d F b @.  @d G a b @.  @d N a b @.
      @( Exponentiation of a monoid.  The value at a successor.  What I am
         calculating is ` ( A ( ^md `` G ) N ) ` .  (Contributed by FL,
         12-Dec-2009.) @)
      expm @p |- ( N e. om ->
      ( F ` suc N ) = ( ( F ` N ) G A ) ) @=
        ( vb com wcel cfv co cvv csuc wceq ovex cgi cv oveq1 frsucmpt2 mpan2 )
        DHIDBJZACKZLIDMBJUBNUAACOEGCPJDEQZACKUBGQZACKBLFUDUCACRUDUAACRST @.
    @}

    expus.1 @e |- G e. MndOp @.
    expus.3 @e |- A e. X @.
    expus.4 @e |- X = ran G @.
    @{
      @d A a b @.  @d F a b y @.  @d F x y @.  @d G a b @.  @d X x y @.
      @( The exponentiation of a member of a monoid belongs to the underlying
         set.  (Contributed by FL, 12-Dec-2009.) @)
      expus @p |- ( x e. om -> ( F ` x ) e. X ) @=
        ( vy cv cfv wcel c0 csuc wceq fveq2 eleq1d ax-mp cmagm cexid cin expmiz
        cmndo mndomgmid iorlid com wa co expm adantr cxp wf mndoio fovrn adantl
        mp3an13 eqeltrd ex finds1 ) ALZCMZENOCMZENZKLZCMZENZVFPZCMZENZAKVBOQVCV
        DEVBOCRSVBVFQVCVGEVBVFCRSVBVIQVCVJEVBVICRSDUAUBUCNZVEDUENZVLHDUFTVDDEJB
        CDFGUDUGTVFUHNZVHVKVNVHUIVJVGBDUJZEVNVJVOQVHBCDVFFGUKULVHVOENZVNEEUMEDU
        NZVHBENVPVMVQHDEJUOTIVGBEEEDUPURUQUSUTVA @.
    @}

  @}

  @( The range of the domain of a magma equals the domain of the domain.
     (Contributed by FL, 17-May-2010.) @)
  mgmrddd @p |- ( G e. Magma -> ran dom G = dom dom G ) @=
    ( cmagm wcel cdm crn wceq cxp eqid ismgm fdm rneq rnxpid syl6eq syl pm2.43i
    wf syl6bi ) ABCZADZEZSDZFZRRUAUAGZUAAPZUBBAUAUAHIUDSUCFZUBUCUAAJUETUCEUASUC
    KUALMNQO @.

  @{
    unsgrp.1 @e |- X = ran G @.
    @( The underlying set of a group is a set.  (Contributed by FL,
       17-May-2010.) @)
    unsgrp @p |- ( G e. GrpOp -> X e. _V ) @=
      ( cgr wcel crn cvv rnexg syl5eqel ) ADEBAFGCADHI @.
  @}

  @{
    @d x y A @.  @d x y V @.  @d x y X @.
    symgfo.1 @e |- G = ( SymGrp ` A ) @.
    symgfo.2 @e |- X = ( Base ` G ) @.
    symgfo.3 @e |- P = ( +g ` G ) @.
    @( The operation of a symetry group is onto.  (Contributed by FL,
       17-May-2010.)  (Proof shortened by Mario Carneiro, 13-Jan-2015.) @)
    symgfo @p |- ( A e. V -> P : ( X X. X ) -onto-> X ) @=
      ( vx vy wcel cmnd cxp wfn wfo cgrp symggrp grpmnd cv vex syl ccom fnmpt2i
      symgplusg coex mndfo sylancl ) ADKZCLKZBEEMZNUJEBOUHCPKUIACDFQCRUAIJEEISZ
      JSZUBBAEBIJCFGHUDUKULITJTUEUCEBCGHUFUG @.
  @}

  @{
    @d x y A @.  @d x G @.  @d x y .(+) @.  @d x V @.  @d x y X @.  @d x y Y @.
    gapm2.1 @e |- X = ( Base ` G ) @.
    @( The action of a particular group element is a permutation of the base
       set. ~ gapm expressed with the currying operator.  (Contributed by FL,
       17-May-2010.)  (Revised by Mario Carneiro, 3-May-2015.) @)
    gapm2 @p |- ( ( .(+) e. ( G GrpAct Y ) /\ ( A e. X /\ Y =/= (/) ) ) ->
        ( ( cur1 ` .(+) ) ` A ) : Y -1-1-onto-> Y ) @=
      ( vx cga co wcel c0 wne wa ccur1 cfv wf1o cvv cbs adantr syl cv cmpt eqid
      gapm adantrr wceq wb cxp wfn fvex eqeltri a1i gaset simprr gaf ffn simprl
      wf valcurfn2 syl221anc f1oeq1 mpbird ) BCEHIJZADJZEKLZMZMZEEABNOOZPZEEGEA
      GUABIUBZPZVCVDVKVEGABVJCDEFVJUCUDUEVGVHVJUFZVIVKUGVGDQJZEQJZVEBDEUHZUIZVD
      VLVMVGDCROQFCRUJUKULVCVNVFBCEUMSVCVDVEUNVGVOEBURZVPVCVQVFBCDEFUOSVOEBUPTV
      CVDVEUQGDEQQBAUSUTEEVHVJVATVB @.

    @( The range of the action of a particular group element equals the range
       of the action.  (Contributed by FL, 17-May-2010.)  (Revised by Mario
       Carneiro, 3-May-2015.) @)
    rngapm @p |- ( ( .(+) e. ( G GrpAct Y ) /\ ( A e. X /\ Y =/= (/) ) )
        -> ran ( ( cur1 ` .(+) ) ` A ) = ran .(+) ) @=
      ( cga co wcel c0 wne wa ccur1 cfv crn wf1o wfo wceq gapm2 forn f1ofo 3syl
      cxp gafo adantr syl eqtr4d ) BCEGHIZADIEJKLZLZABMNNZOZEBOZUJEEUKPEEUKQULE
      RABCDEFSEEUKUAEEUKTUBUJDEUCZEBQZUMERUHUOUIBCDEFUDUEUNEBTUFUG @.
  @}

  @{
    @( The proof has been designed so that B and x needn't be distinct. @)
    @d A x y @.  @d B y @.  @d C x y @.  @d F t @.  @d G t @.  @d H t x @.
    @d H x y @.
    fnopabco2b.2 @e |- F = ( x e. A |-> B ) @.
    fnopabco2b.3 @e |- G = ( x e. A |-> ( H ` B ) ) @.
    @( Composition of a function with a function abstraction.  Adapted from
       ~ fnopabco .  (Contributed by FL, 17-May-2010.)  (Proof shortened by
       Mario Carneiro, 27-Dec-2014.) @)
    fnopabco2b @p |- ( ( A. x e. A B e. C /\ H Fn C )
        -> G = ( H o. F ) ) @=
      ( vy wcel wral wfn wa ccom cfv cmpt cv simpl wceq simpr dffn5 sylib fveq2
      a1i fmptcof syl6reqr ) CDKABLZGDMZNZGEOABCGPZQFUJAJBDCJRZGPZUKEGUHUISEABC
      QTUJHUEUJUIGJDUMQTUHUIUAJDGUBUCULCGUDUFIUG @.
  @}

  @{
    @d x y z G @.  @d x y z .(+) @.  @d x y V @.  @d x y z Y @.
    @( The currying of a group action is a group homomorphism between the group
       ` G ` and the symmetry group ` ( SymGrp `` Y ) ` .  (Contributed by FL,
       17-May-2010.)  (Proof shortened by Mario Carneiro, 13-Jan-2015.) @)
    curgrpact @p |- ( ( .(+) e. ( G GrpAct Y ) /\ Y =/= (/) ) ->
      ( cur1 ` .(+) ) e. ( G GrpHom ( SymGrp ` Y ) ) ) @=
      ( vx vy vz cga co wcel c0 wa cfv cbs cv cmpt wf cvv adantr eqid syl22anc
      wne ccur1 csymg cghm crn cab cxp wfn fvex a1i gaset simpr gaf domrancur1c
      ffn syl feqmptd wi valcurfn2 3expia imp mpteq2dva eqtrd galactghm eqeltrd
      wceq ) ABCGHIZCJUAZKZAUBLZDBMLZECDNZENAHOZOZBCUCLZUDHZVIVJDVKVLVJLZOVNVID
      VKCAUEFNPFUFZVJVIVKQIZCQIZVHAVKCUGZUHZVKVRVJPVSVIBMUIUJZVGVTVHABCUKRZVGVH
      ULZVIWACAPZWBVGWFVHABVKCVKSZUMRWACAUOUPZVKCQQFAUNTUQVIDVKVQVMVIVLVKIZVQVM
      VFZVIVSVTVHWBWIWJURWCWDWEWHVSVTKVHWBKWIWJEVKCQQAVLUSUTTVAVBVCVGVNVPIVHDEA
      VNBVOVKCWGVOSVNSVDRVE @.
  @}

  @{
    grpdivfo.1 @e |- X = ran G @.
    grpdivfo.2 @e |- D = ( /g ` G ) @.
    @{
      grpdivfo.3 @e |- U = ( GId ` G ) @.
      @( "Division" by the neutral element of a group.  (Contributed by FL,
         21-Jun-2010.) @)
      grpodivone @p |- ( ( G e. GrpOp /\ A e. X ) -> ( A D U ) = A ) @=
        ( cgr wcel co wceq grpoidcl w3a cgn cfv eqid wi eqtr ex grporid syl5com
        grpodivval grpoinvid oveq2d wa 3adant3 com12 com3l syl 3ad2ant1 pm2.43i
        syl6 mpd 3exp mpid imp ) DIJZAEJZACBKZALZURUSCEJZVACDEFHMURUSVBVAURUSVB
        NZUTACDOPZPZDKZLZVAACBDVDEFVDQZGUCVCVGVARZURUSVCVIRZVBURVFACDKZLZVJURVE
        CADCDVDHVHUDUEVGVLVCVAVGVLUTVKLZVCVARVGVLVMUTVFVKSTVCVMVAURUSVMVARVBURU
        SUFVKALZVMVAACDEFHUAVMVNVAUTVKASTUBUGUHUMUIUJUKULUNUOUPUQ @.
    @}

    @{
      @d D x y z @.  @d G x y z @.  @d X x y z @.
      @( Todo: maybe suppress grpdivf. @)
      @( A "division" maps onto the group's underlying set.  (Contributed by
         FL, 21-Jun-2010.) @)
      grpodivfo @p |- ( G e. GrpOp -> D : ( X X. X ) -onto-> X ) @=
        ( vx vy vz cgr wcel cxp wf crn wceq cv co wrex wi syl 3exp wfo grpodivf
        cab wfn ffn fnrnov 3syl w3a fovrn com4l rexlimdv rexlimiv com12 cgi cfv
        eleq1a eqid grpoidcl wa grpodivone rspceov adantl com3r eqcoms mpcom ex
        mpid impbid abbi1dv eqtrd dffo2 sylanbrc ) BIJZCCKZCALZAMZCNVNCAUAABCDE
        UBZVMVPFOZGOZHOZAPZNZHCQZGCQZFUCZCVMVOAVNUDVPWENVQVNCAUEGHFCCAUFUGVMWDF
        CVMWDVRCJZWDVMWFWCVMWFRZGCVSCJZWBWGHCVMWHVTCJZWBWFVMVOWHWIWBWFRZRRVQVOW
        HWIWJVOWHWIUHWACJWJVSVTCCCAUIWACVRUPSTSUJUKULUMVMWFBUNUOZCJZWDWKBCDWKUQ
        ZURVMWFWLWDRZVRWKAPZVRNVMWFUSZWNVRAWKBCDEWMUTWPWNRVRWOWPWLVRWONZWDWFWLW
        QWDRRVMWFWLWQWDGHCCVRWKVRAVATVBVCVDVEVFVGVHVIVJVNCAVKVL @.
    @}
  @}

  @{
    grpdrcan.1 @e |- X = ran G @.
    grpdrcan.2 @e |- D = ( /g ` G ) @.
    @( Right cancellation law for group "subtraction" (or "division").
       (Contributed by FL, 14-Sep-2010.) @)
    grpodrcan @p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( A D C ) = ( B D C ) <-> A = B ) ) @=
      ( co cgn cfv wceq cgr wcel w3a wb grpodivval bibi1d syl5ibr mpcom wa eqid
      3adant3r2 3adant3r1 simpr1 simpr2 grpoinvcl 3ad2antr3 3jca grporcan eqeq2
      syldan eqeq1 ) ACDIZACEJKZKZEIZLZEMNZAFNZBFNZCFNZOZUAZUNBCDIZLZABLZPZUSUT
      VBURVAACDEUOFGUOUBZHQUCVDVHURUQVELZVGPZVEBUPEIZLZVDVKUSVAVBVMUTBCDEUOFGVI
      HQUDVDVKVMUQVLLZVGPZUSVCUTVAUPFNZOVOVDUTVAVPUSUTVAVBUEUSUTVAVBUFUSUTVBVPV
      ACEUOFGVIUGUHUIABUPEFGUJULVMVJVNVGVEVLUQUKRSTURVFVJVGUNUQVEUMRST @.

    @( Left cancellation law for group "subtraction" (or "division").
       (Contributed by FL, 14-Sep-2010.) @)
    grpodlcan @p |- ( ( G e. GrpOp /\ ( A e. X /\ B e. X /\ C e. X ) ) ->
                  ( ( C D A ) = ( C D B ) <-> A = B ) ) @=
      ( co cfv wceq wa wcel w3a wb wi grpodivval 3exp com13 imp cgn cgr 3adant2
      eqid impcom 3adant1 jca simpl grpoinvcl 3ad2antr1 3ad2antr2 simpr3 adantl
      3jca grpolcan syl wf1 wf1o grpoinvf f1of1 ad2antrl 3simpa ad2antll f1fveq
      syl2anc bitrd ex eqeq12 bibi1d sylibrd mpcom ) CADIZCAEUAJZJZEIZKZCBDIZCB
      VMJZEIZKZLZEUBMZAFMZBFMZCFMZNZLZVLVQKZABKZOZWGVPVTWFWBVPWCWEWBVPPZWDWCWEW
      KWBWEWCVPWBWEWCVPCADEVMFGVMUDZHQRSTUCUEWFWBVTWDWEWBVTPZWCWDWEWMWBWEWDVTWB
      WEWDVTCBDEVMFGWLHQRSTUFUEUGWAWGVOVSKZWIOZWJWAWGWOWAWGLZWNVNVRKZWIWPWBVNFM
      ZVRFMZWENZLZWNWQOWGXAWAWGWBWTWBWFUHWGWRWSWEWBWDWCWRWEAEVMFGWLUIUJWBWCWDWS
      WEBEVMFGWLUIUKWBWCWDWEULUNUGUMVNVRCEFGUOUPWPFFVMUQZWCWDLZWQWIOWBXBWAWFWBF
      FVMURXBEVMFGWLUSFFVMUTUPVAWFXCWAWBWCWDWEVBVCFFABVMVDVEVFVGWAWHWNWIVLVOVQV
      SVHVIVJVK @.
  @}

  @{
    grpdivzer.1 @e |- X = ran G @.
    grpdivzer.2 @e |- U = ( GId ` G ) @.
    grpdivzer.3 @e |- D = ( /g ` G ) @.
    @( Condition for a "subtraction" (or "division") value to be equal to the
       identity element.  (Contributed by FL, 14-Sep-2010.) @)
    grpodivzer @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                   ( ( A D B ) = U <-> A = B ) ) @=
      ( cgr wcel w3a co wceq cgn cfv eqid grpodivval eqeq1d wb 3adant2 syld3an3
      grpoinvcl grpoinvid1 wf1 wa wf1o grpoinvf f1of1 syl 3simpc f1fveq syl2anc
      3ad2ant1 3bitr2d ) EJKZAFKZBFKZLZABCMZDNABEOPZPZEMZDNZAVAPVBNZABNZUSUTVCD
      ABCEVAFGVAQZIRSUPUQURVBFKZVEVDTUPURVHUQBEVAFGVGUCUAAVBDEVAFGHVGUDUBUSFFVA
      UEZUQURUFVEVFTUPUQVIURUPFFVAUGVIEVAFGVGUHFFVAUIUJUNUPUQURUKFFABVAULUMUO
      @.
  @}

  @{
    @d m x y A @.  @d k m x y M1 @.  @d k m x y M2 @.  @d k m x y N @.
    @d x y G @.  @d k x y X @.
    fprodneg.1 @e |- X = ran G @.
    fprodneg.2 @e |- N = ( inv ` G ) @.
    @( The inverse of a finite composite in the case of an abelian group.
       (Contributed by FL, 14-Sep-2010.)  (Proof shortened by Mario Carneiro,
       30-May-2014.) @)
    fprodneg @p |- ( ( M2 e. ( ZZ>= ` M1 ) /\ A. k e. ( M1 ... M2 )
       A e. X /\ G e. AbelOp ) ->
       ( N ` gprod_ k e. ( M1 ... M2 ) G A ) =
         gprod_ k e. ( M1 ... M2 ) G ( N ` A ) ) @=
      ( vm cfv wcel co cv cgprd wa sylan wceq fveq2d nffv vx cuz cfz wral cablo
      vy w3a cmpt cseq cgr simp3 ablogrpo grpocl 3expb wf simp2 eqid fmpt sylib
      ffvelrn simp1 ablocom adantr simprr simprl grpoinvop syl3anc eqtrd fvmpt2
      syl cvv fvex mpan2 eqtr4d ralimiaa 3ad2ant2 nfcv nfmpt1 nfeq eqeq12d rspc
      fveq2 mpan9 seqhomo fprodser 3ad2ant1 3eqtr4d ssid gprodeqfv ax-mp fveq2i
      wss 3eqtr3g ) GFUBKLZAELZBFGUCMZUDZCUELZUGZWPJNZBWPAUHZKJCOZDKZWPWTBWPADK
      ZUHZKJCOZWPABCOZDKWPXDBCOZWSGCXAFUIKZDKGCXEFUIKZXCXFWSUAUFCCEXAXEDFGWSCUJ
      LZUANZELZUFNZELZPZXLXNCMZELZWSWRXKWNWQWRUKZCULVJZXKXMXOXRXLXNCEHUMUNQWSWP
      EXAUOZXLWPLZXLXAKZELWSWQYAWNWQWRUPBWPEAXAXAUQZURUSWPEXLXAUTQWNWQWRVAWSXPP
      ZXQDKXNXLCMZDKZXLDKXNDKCMZYEXQYFDWSWRXPXQYFRZXSWRXMXOYIXLXNCEHVBUNQSYEXKX
      OXMYGYHRWSXKXPXTVCWSXMXOVDWSXMXOVEXNXLCDEHIVFVGVHWSBNZXAKZDKZYJXEKZRZBWPU
      DZYBYCDKZXLXEKZRZWQWNYOWRWOYNBWPYJWPLZWOPZYLXDYMYTYKADBWPAEXAYDVISYSYMXDR
      ZWOYSXDVKLUUAADVLBWPXDVKXEXEUQZVIVMVCVNVOVPYNYRBXLWPBYPYQBYCDBDVQBXLXABWP
      AVRBXLVQZTTBXLXEBWPXDVRUUCTVSYJXLRZYLYPYMYQUUDYKYCDYJXLXAWBSYJXLXEWBVTWAW
      CWDWSXBXIDWNWQXBXIRWRJXACFGWEWFSWNWQXFXJRWRJXECFGWEWFWGXBXGDWPWPWLZXBXGRW
      PWHZAWPWPBJXACYDWIWJWKUUEXFXHRUUFXDWPWPBJXECUUBWIWJWM @.
  @}

  @{
    @d n u v w x y z A @.  @d k n t u v w x y z M @.  @d k n t u v w x y z N @.
    @d n t v w x y z B @.  @d k n v w x y z D @.  @d k n w x y z X @.
    @d n w x y z G @.
    fprodsub.1 @e |- X = ran G @.
    fprodsub.2 @e |- D = ( /g ` G ) @.
    @( The "difference" (or "quotient") of two finite composites.  (Contributed
       by FL, 14-Sep-2010.)  (Revised by Mario Carneiro, 30-May-2014.) @)
    fprodsub @p |- ( ( N e. ( ZZ>= ` M ) /\ A. k e. ( M ... N )
       ( A e. X /\ B e. X ) /\ G e. AbelOp ) ->
       gprod_ k e. ( M ... N ) G ( A D B ) =
         ( gprod_ k e. ( M ... N ) G A D gprod_ k e. ( M ... N ) G B ) ) @=
      ( vv vu cfv wcel wa co cv cgprd sylan wceq vt vx vy vz vw vn cuz cfz wral
      cablo w3a cmpt cseq cgr simp3 ablogrpo syl grpocl 3expb grpodivcl simprll
      simpl simprlr ablomuldiv syl13anc oveq1d adantr ablodivdiv4 grpomuldivass
      simprrl syl3anc simprrr 3eqtr3rd simp1 wf ralimi 3ad2ant2 eqid fmpt sylib
      ffvelrn simpr cvv ovex fvmpt2 mpan2 anim12dan oveq12 eqtr4d ralimiaa nfcv
      nfmpt1 nffv nfov nfeq fveq2 oveq12d eqeq12d rspc mpan9 seqcaopr2 fprodser
      3ad2ant1 3eqtr4d wss ssid gprodeqfv ax-mp 3eqtr3g ) GFUGMNZAHNZBHNZOZDFGU
      HPZUIZEUJNZUKZXNKQDXNABCPZULZMKERZXNLQDXNAULZMLERZXNUAQDXNBULZMUAERZCPZXN
      XRDERZXNADERZXNBDERZCPZXQGEXSFUMMZGEYAFUMMZGEYCFUMMZCPZXTYEXQUBUCUDUEECHU
      FYAYCXSFGXQEUNNZUBQZHNZUCQZHNZOZYOYQEPZHNZXQXPYNXJXOXPUOZEUPZUQZYNYPYRUUA
      YOYQEHIURZUSSXQYNYSYOYQCPHNZUUDYNYPYRUUFYOYQCEHIJUTUSSXQXPYSUDQZHNZUEQZHN
      ZOZOZYOUUGCPZYQUUICPEPZYTUUGUUIEPCPZTUUBXPUULOZYTUUGCPZUUICPZUUMYQEPZUUIC
      PZUUOUUNUUPUUQUUSUUICUUPXPYPYRUUHUUQUUSTXPUULVBZXPYPYRUUKVAZXPYPYRUUKVCZX
      PYSUUHUUJVJZYOYQUUGCEHIJVDVEVFUUPXPUUAUUHUUJUURUUOTUVAUUPYNYPYRUUAXPYNUUL
      UUCVGZUVBUVCUUEVKUVDXPYSUUHUUJVLZYTUUGUUICEHIJVHVEUUPYNUUMHNZYRUUJUUTUUNT
      UVEUUPYNYPUUHUVGUVEUVBUVDYOUUGCEHIJUTVKUVCUVFUUMYQUUICEHIJVIVEVMSXJXOXPVN
      XQXNHYAVOZUFQZXNNZUVIYAMZHNXQXKDXNUIZUVHXOXJUVLXPXMXKDXNXKXLVBVPVQDXNHAYA
      YAVRZVSVTXNHUVIYAWASXQXNHYCVOZUVJUVIYCMZHNXQXLDXNUIZUVNXOXJUVPXPXMXLDXNXK
      XLWBVPVQDXNHBYCYCVRZVSVTXNHUVIYCWASXQDQZXSMZUVRYAMZUVRYCMZCPZTZDXNUIZUVJU
      VIXSMZUVKUVOCPZTZXOXJUWDXPXMUWCDXNUVRXNNZXMOZUVSXRUWBUWHUVSXRTZXMUWHXRWCN
      UWJABCWDDXNXRWCXSXSVRZWEWFVGUWIUVTATZUWABTZOUWBXRTUWHXKUWLXLUWMDXNAHYAUVM
      WEDXNBHYCUVQWEWGUVTAUWABCWHUQWIWJVQUWCUWGDUVIXNDUWEUWFDUVIXSDXNXRWLDUVIWK
      ZWMDUVKUVOCDUVIYADXNAWLUWNWMDCWKDUVIYCDXNBWLUWNWMWNWOUVRUVITZUVSUWEUWBUWF
      UVRUVIXSWPUWOUVTUVKUWAUVOCUVRUVIYAWPUVRUVIYCWPWQWRWSWTXAXJXOXTYJTXPKXSEFG
      XBXCXJXOYEYMTXPXJYBYKYDYLCLYAEFGXBUAYCEFGXBWQXCXDXNXNXEZXTYFTXNXFZXRXNXND
      KXSEUWKXGXHUWPYEYITUWQUWPYBYGYDYHCAXNXNDLYAEUVMXGBXNXNDUAYCEUVQXGWQXHXI
      @.
  @}

  @{
    clfsebs3.1 @e |- X = ran G @.
    @{
      @d G k @.  @d M k @.  @d N k @.
      @( Closure of a finite composite of elements of the base set of an
         internal operation.  (When the operation is a monoid.)  (Contributed
         by FL, 22-Nov-2010.) @)
      clfsebs3 @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. MndOp /\
                      A. k e. ( M ... N ) A e. X )
       -> gprod_ k e. ( M ... N ) G A e. X ) @=
        ( cmndo wcel cuz cfv cmagm cexid cin cfz wral cgprd mndomgmid clfsebsr
        co syl3an2 ) CHIEDJKICLMNIAFIBDEOTZPUBABCQFICRABCDEFGSUA @.
    @}

    @{
      @d G k @.  @d M k @.  @d N k @.
      @( Closure of a finite composite of elements of the base set of an
         internal operation.  (When the operation is a group.)  (Contributed by
         FL, 22-Nov-2010.) @)
      clfsebs4 @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. GrpOp /\
                      A. k e. ( M ... N ) A e. X )
       -> gprod_ k e. ( M ... N ) G A e. X ) @=
        ( cgr wcel cuz cfv cmndo cfz co wral cgprd grpomndo clfsebs3 syl3an2 )
        CHIEDJKICLIAFIBDEMNZOTABCPFICQABCDEFGRS @.
    @}

    @{
      @d G k @.  @d M k @.  @d N k @.
      @( Closure of a finite composite of elements of the base set of an
         internal operation.  (When the operation is an abelian group.)
         (Contributed by FL, 22-Nov-2010.) @)
      clfsebs5 @p |- ( ( N e. ( ZZ>= ` M ) /\ G e. AbelOp /\
                      A. k e. ( M ... N ) A e. X )
       -> gprod_ k e. ( M ... N ) G A e. X ) @=
        ( cablo wcel cuz cfv cgr cfz co wral cgprd ablogrpo clfsebs4 syl3an2 )
        CHIEDJKICLIAFIBDEMNZOTABCPFICQABCDEFGRS @.
    @}
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Free structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c SubSemiGrp @.

  @( Extend class notation to include the class of subsemigroups. @)
  csubsmg @a class SubSemiGrp @.

  @{
    @d g h s @.
    @( Define the set of subsemigroups of ` g ` .  Experimental.  (Contributed
       by FL, 2-Sep-2013.) @)
    df-subsmg @a |- SubSemiGrp =
      ( g e. SemiGrp |-> { h e. SemiGrp | h C_ g } ) @.
  @}

  @c subSemiGrpGen @.

  @( Extend class notation with a function that returns the subsemigroup of a
     group generated by a set. @)
  csbsgrg @a class subSemiGrpGen @.

  @{
    @d g x h @.
    @( the subsemigroup of ` g ` generated by ` x ` .  Experimental.
       (Contributed by FL, 15-Jul-2012.) @)
    df-sggen @a |- subSemiGrpGen = ( g e. SemiGrp , x e. ~P dom dom g |->
     |^| { h e. ( SubSemiGrp ` g ) | x C_ dom dom h } ) @.
  @}

  @c SemiGrpHom @.

  @( Extend class notation to include the class of semigroup homomorphisms. @)
  csmhom @a class SemiGrpHom @.

  @{
    @d f g h s x y @.
    @( Define the set of semigroup homomorphisms from ` g ` to ` h ` .
       Experimental.  (Contributed by FL, 15-Jul-2012.) @)
    df-gsmhom @a |- SemiGrpHom = ( g e. SemiGrp , h e. SemiGrp |->
      { f | ( f : dom dom g --> dom dom h /\ A. x e. dom dom g
     A. y e. dom dom g ( ( f ` x ) h ( f ` y ) ) = ( f ` ( x g y ) ) ) } ) @.
  @}

  @c FreeSemiGrp @.

  @( Extend class notation to include the class of free semigroup. @)
  cfsm @a class FreeSemiGrp @.

  @{
    @d g x h a u @.
    @( Definition of a free semigroup.  The definition is somewhat cryptic.
       Let's say it guarantees the elements of the semigroup can be decomposed
       into elementary components and that the decomposition is unique.  As a
       consequence you define the elements of the semigroup with nice recursive
       function ` h ` by giving the value ` h ( x ) ` for every elementary
       component ` x ` and the recursive equation
       ` h ( x + y ) = h ( x ) + h ( y ) ` .  This is not true in every
       semigroup.  For intance if you take the semigroup of strings generated
       by the elementary components "ab", "c", "a", "bc", the string "abc" is
       equal to "ab" ` + ` "c" or to "a" ` + ` "bc" and those beautiful
       recursive function can't exist.  (See a nice explanation in Gallier
       p. 20.)  Experimental.  (Contributed by FL, 15-Jul-2012.) @)
    df-frsmgrp @a |- FreeSemiGrp = { <. g , x >. | ( g = ( subSemiGrpGen
      ` <. g , x >. ) /\ A. h e. SemiGrp A. a e. ( dom dom h ^m x )
      E. u e. ( SemiGrpHom ` <. g , h >. ) ( u |` x ) = a ) } @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Translations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    trfun.2 @e |- F = ( x e. X |-> ( x G A ) ) @.
    trinv.1 @e |- X = ran G @.
    @{
      @d A x @.  @d G x @.  @d X x @.
      @( The domain of a right translation.  The term ` A ` is a constant:
         ` x ` is not present.  (Contributed by FL, 21-Jun-2010.) @)
      trdom2 @p |- ( ( G e. GrpOp /\ A e. X ) -> dom F = X ) @=
        ( cgr wcel wa cv co cvv wral cdm wceq ovex a1i ralrimiva cmpdom sylib )
        DHIBEIJZAKZBDLZMIZAENCOEPUBUEAEUEUBUCEIJUCBDQRSAEUDCFTUA @.
    @}

    @{
      @d X x @.
      @( A right translation is a set.  (Contributed by FL, 19-Sep-2010.) @)
      trset @p |- ( G e. GrpOp -> F e. _V ) @=
        ( cgr wcel wfun cdm cv co funmpt2 cmpdom2 unsgrp syl5eqel funex sylancr
        cvv ) DHIZCJCKZTICTIAEALZBDMCFNUAUBETAEUCBCDFODEGPQTCRS @.
    @}

    @{
      @d A x y @.  @d G x y @.  @d X x y @.
      @( The range of a right translation.  The term ` A ` is a constant: ` x `
         is not present.  (Contributed by FL, 21-Jun-2010.) @)
      trran2 @p |- ( ( G e. GrpOp /\ A e. X ) -> ran F = X ) @=
        ( vy cgr wcel wa cv co wceq wi grpocl cfv eqid adantr eqcomd wrex rnmpt
        crn cab 3exp com23 impcom eleq1 syl5ibrcom expcom rexlimdv simpll simpr
        imp cgn grpoinvcl syl3anc cgi grpolinv grporid adantlr grpoass syl13anc
        oveq2d simplr 3eqtr4d oveq1 eqeq2d rspcev syl2anc impbid abbi1dv syl5eq
        ex ) DIJZBEJZKZCUCHLZALZBDMZNZAEUAZHUDEAHEVTCFUBVQWBHEVQWBVREJZVQWAWCAE
        VSEJZVQWAWCOWDVQKWCWAVTEJZVQWDWEVOVPWDWEOVOWDVPWEVOWDVPWEVSBDEGPUEUFUNU
        GVRVTEUHUIUJUKVQWCWBVQWCKZVRBDUOQZQZDMZEJZVRWIBDMZNZWBWFVOWCWHEJZWJVOVP
        WCULZVQWCUMZVQWMWCBDWGEGWGRZUPSZVRWHDEGPUQWFVRDURQZDMZVRWHBDMZDMZVRWKWF
        WRWTVRDWFWTWRVQWTWRNWCBWRDWGEGWRRZWPUSSTVDVOWCVRWSNVPVOWCKWSVRVRWRDEGXB
        UTTVAWFVOWCWMVPWKXANWNWOWQVOVPWCVEVRWHBDEGVBVCVFWAWLAWIEVSWINVTWKVRVSWI
        BDVGVHVIVJVNVKVLVM @.
    @}

    @{
      @d A x y z @.  @d G x y z @.  @d X x y z @.
      @( A right translation is a bijection.  The term ` A ` is a constant.
         (Contributed by FL, 21-Jun-2010.) @)
      trooo @p |- ( ( G e. GrpOp /\ A e. X ) -> F : X -1-1-onto-> X ) @=
        ( vy wcel wa wfn crn wceq cv cfv wi wral wf1o cvv wb cgr co ovex mptfng
        rgenw a1i mpbii trran2 fvmpt2 mpan2 simpr jctir adantl oveq1 fvmptg syl
        ad2antrl biimpd grporcan 3exp2 imp3a com23 imp31 sylibd ralrimivva cmpt
        eqeq12d w3a nfmpt1 nfcv dff1o6f f1oeq1 ax-mp fneq1i rneqi eqeq1i fveq1i
        eqeq12i imbi1i 2ralbii 3anbi123i 3bitr4i syl3anbrc ) DUAIZBEIZJZCEKZCLZ
        EMZANZCOZHNZCOZMZWJWLMZPZHEQAEQZEECRZWFWJBDUBZSIZAEQZWGWTAEWJBDUCZUEXAW
        GTWFAEWSCFUDUFUGABCDEFGUHWFWPAHEEWFWJEIZWLEIZJZJZWNWSWLBDUBZMZWOXFWNXHX
        FWKWSWMXGXCWKWSMZWFXDXCWTXIXBAEWSSCFUIUJUQXFXDXGSIZJZWMXGMXEXKWFXEXDXJX
        CXDUKWLBDUCULUMAWLWSXGESCWJWLBDUNFUOUPVGURWDWEXEXHWOTZWDXEWEXLWDXCXDWEX
        LPWDXCXDWEXLWJWLBDEGUSUTVAVBVCVDVEEEAEWSVFZRZXMEKZXMLZEMZWJXMOZWLXMOZMZ
        WOPZHEQAEQZVHWRWGWIWQVHAHEEXMAEWSVIHXMVJVKCXMMWRXNTFEECXMVLVMWGXOWIXQWQ
        YBECXMFVNWHXPECXMFVOVPWPYAAHEEWNXTWOWKXRWMXSWJCXMFVQWLCXMFVQVRVSVTWAWBW
        C @.
    @}

    @{
      @d A x y z @.  @d D y z @.  @d G x y z @.  @d X x y z @.
      trinv.2 @e |- D = ( /g ` G ) @.
      @( The converse of a right translation.  The term ` A ` is a constant.
         (Contributed by FL, 21-Jun-2010.) @)
      trinv @p |- ( ( G e. GrpOp /\ A e. X )
          -> `' F = ( x e. X |-> ( x D A ) ) ) @=
        ( vy wcel wa co cmpt wceq cfv wral cvv wfn wb ccnv cv wf1o trooo adantr
        cgr grpodivcl 3exp com23 imp31 jca oveq1 cbvmptv eqtri fvmptg grponpcan
        ovex sylancl eqtrd f1ocnvfv sylc fvmpt2 eqtr4d ralrimiva dff1o4 simprbi
        simpr eqid syl rgenw mptfng a1i mpbii cnveqi fneq1i nfmpt1 nfcnv sylanb
        eqfnfv2f eqeq1i fveq1i ralbii 3bitr4g syl2anc mpbird ) EUFKZBFKZLZDUAZA
        FAUBZBCMZNZOZWJWIPZWJWLPZOZAFQZWHWPAFWHWJFKZLZWNWKWOWSFFDUCZWKFKZLWKDPZ
        WJOWNWKOWSWTXAWHWTWRABDEFGHUDZUEWFWGWRXAWFWRWGXAWFWRWGXAWJBCEFHIUGUHUIU
        JZUKWSXBWKBEMZWJWSXAXERKXBXEOXDWKBEUQJWKJUBZBEMZXEFRDXFWKBEULDAFWJBEMZN
        ZJFXGNGAJFXHXGWJXFBEULUMUNUOURWFWGWRXEWJOZWFWRWGXJWFWRWGXJWJBCEFHIUPUHU
        IUJUSFFWKWJDUTVAWSWRWKRKZWOWKOWHWRVGWJBCUQZAFWKRWLWLVHZVBURVCVDWHWIFSZW
        LFSZWMWQTWHWTXNXCWTDFSXNFFDVEVFVIWHXKAFQZXOXKAFXLVJXPXOTWHAFWKWLXMVKVLV
        MXNXOLXIUAZWLOZWJXQPZWOOZAFQZWMWQXNXQFSXOXRYATFWIXQDXIGVNZVOAFXQWLAXIAF
        XHVPVQAFWKVPVSVRWIXQWLYBVTWPXTAFWNXSWOWJWIXQYBWAVTWBWCWDWE @.
    @}

    @{
      @d A a b x y @.  @d B a b x y @.  @d F x @.  @d G a b x y @.
      @d X a b x y @.
      cmprtr.1 @e |- H = ( x e. X |-> ( x G B ) ) @.
      @( Composite of two right translations.  The terms ` A ` and ` B ` are
         constant.  Don't use.  See ~ cmprtr2 .  (Contributed by FL,
         17-Oct-2010.) @)
      cmprtr @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
           ( F o. H ) = ( x e. X |-> ( x G ( B G A ) ) ) ) @=
        ( vy cgr wcel w3a cv co cmpt wceq a1i oveq1 grpocl 3expa an32s 3adantl2
        ccom cbvmptv eqtri fmptco simpl1 simpr simpl3 simpl2 syl13anc mpteq2dva
        wa grpoass eqtrd ) ELMZBGMZCGMZNZDFUEAGAOZCEPZBEPZQAGVBCBEPEPZQVAAKGGVC
        KOZBEPZVDFDURUTVBGMZVCGMZUSURVHUTVIURVHUTVIVBCEGIUAUBUCUDFAGVCQRVAJSDKG
        VGQZRVADAGVBBEPZQVJHAKGVKVGVBVFBETUFUGSVFVCBETUHVAAGVDVEVAVHUOURVHUTUSV
        DVERURUSUTVHUIVAVHUJURUSUTVHUKURUSUTVHULVBCBEGIUPUMUNUQ @.
    @}

    @{
      @d A x y @.  @d B x y @.  @d F y @.  @d G x y @.  @d X x y @.
      cmprtr2.1 @e |- H = ( x e. X |-> ( x G B ) ) @.
      @( Composite of two right translations.  ( ~ cmprtr with a distinct
         variable condition relaxed.)  (Contributed by FL, 1-Jan-2011.) @)
      cmprtr2 @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
           ( F o. H ) = ( x e. X |-> ( x G ( B G A ) ) ) ) @=
        ( vy cgr wcel w3a cv co cmpt oveq1 cbvmptv eqtri ccom cmprtr syl6eq ) E
        LMBGMCGMNDFUAKGKOZCBEPZEPZQAGAOZUEEPZQKBCDEFGDAGUGBEPZQKGUDBEPZQHAKGUIU
        JUGUDBERSTIFAGUGCEPZQKGUDCEPZQJAKGUKULUGUDCERSTUBKAGUFUHUDUGUEERSUC @.
    @}

    @{
      @d A x @.  @d B a u @.  @d F a u @.  @d G x @.  @d X x @.
      @( The image of a set through a translation.  (Contributed by FL,
         30-Dec-2010.) @)
      imtr @p |- ( ( G e. GrpOp /\ A e. X /\ B e. ~P X ) ->
       ( F " B ) = { a | E. u e. B a = ( F ` u ) } ) @=
        ( cgr wcel cpw w3a cima cv wceq wrex cab wi cfv wfun cdm wss co funmpt2
        wa trdom2 pweq eleq2d biimpd eqcoms elpwi syl6 syl 3impia dfimafn eqcom
        sylancr rexbii abbii syl6eq ) FKLZCGLZDGMZLZNZEDOZBPEUAZHPZQZBDRZHSZVJV
        IQZBDRZHSVGEUBDEUCZUDZVHVMQAGAPCFUEEIUFVCVDVFVQVCVDUGVPGQZVFVQTACEFGIJU
        HVRVFDVPMZLZVQVFVTTGVPGVPQZVFVTWAVEVSDGVPUIUJUKULDVPUMUNUOUPBHDEUQUSVLV
        OHVKVNBDVIVJURUTVAVB @.
    @}

    @{
      @d a x y A @.  @d a x y B @.  @d a F @.  @d a x y G @.  @d a x X @.
      @d a H @.
      prsubrtr.1 @e |- H = ( cset ` G ) @.
      @( The product of a subset ` B ` of ` X ` by an element of ` X ` is the
         image of ` B ` by a right translation.  (Contributed by FL,
         30-Dec-2010.)  (Proof shortened by Mario Carneiro, 10-Sep-2015.) @)
      prsubrtr @p |- ( ( G e. GrpOp /\ A e. X /\ B e. ~P X )
        -> ( B H { A } ) = ( F " B ) ) @=
        ( va vy wcel co cv wceq wrex crn syl5eq eleq2d cgr cpw w3a csn wb oveq2
        cima eqeq2d rexsng rexbidv 3ad2ant2 simp1 grporndm pweqd biimpa 3adant2
        cdm 3adant3 snelpwi syl eqid iscst3 syl3anc cmpt cres reseq1i wss elpwi
        df-ima 3ad2ant3 resmpt rneqd ovex elrnmpti syl6bb 3bitr4d eqrdv ) EUAMZ
        BGMZCGUBZMZUCZKCBUDZFNZDCUGZWBKOZAOZLOZENZPZLWCQZACQZWFWGBENZPZACQZWFWD
        MZWFWEMZVSVRWLWOUEWAVSWKWNACWJWNLBGWHBPWIWMWFWHBWGEUFUHUIUJUKWBVRCEUQUQ
        ZUBZMZWCWSMZWPWLUEVRVSWAULVRWAWTVSVRWAWTVRVTWSCVRGWRVRGERWRIEUMSZUNTUOU
        PWBBWRMZXAVRVSXCWAVRVSXCVRGWRBXBTUOURBWRUSUTLACWCWFEFUAWRWRVAJVBVCWBWQW
        FACWMVDZRZMWOWBWEXEWFWBWEDCVEZRXEDCVIWBXFXDWBXFAGWMVDZCVEZXDDXGCHVFWBCG
        VGZXHXDPWAVRXIVSCGVHVJAGCWMVKUTSVLSTACWMWFXDXDVAWGBEVMVNVOVPVQ @.
    @}

    @{
      @d A x @.  @d G x @.  @d X x @.
      caytr.1 @e |- H = ( cset ` G ) @.
      @( "It follows that if the entire group is multiplied by any one of the
         symbols, either as further or nearer factor, the effect is simply to
         reproduce the group... ."  Cayley, On the theory of groups, as
         depending on the symbolic equation th^n = 1, 1854.  (it is the
         original paper where the axiomatic definition of a group was given for
         the first time.)  (Contributed by FL, 15-Oct-2012.) @)
      caytr @p |- ( ( G e. GrpOp /\ A e. X ) -> ( X H { A } ) = X ) @=
        ( cgr wcel wa csn co cima crn cpw wceq wss cvv ssid unsgrp adantr elpwg
        wb syl mpbiri prsubrtr mpd3an3 wf1o wfn trooo f1ofn fnima trran2 3eqtrd
        3syl ) DJKZBFKZLZFBMENZCFOZCPZFURUSFFQKZVAVBRUTVDFFSZFUAUTFTKZVDVEUEURV
        FUSDFHUBUCFFTUDUFUGABFCDEFGHIUHUIUTFFCUJCFUKVBVCRABCDFGHULFFCUMFCUNUQAB
        CDFGHUOUP @.
    @}

  @}

  @{
    ltrdom.1 @e |- F = ( x e. X |-> ( A G x ) ) @.
    ltrdom.2 @e |- X = ran G @.
    @{
      @d A x @.  @d G x @.  @d X x @.
      @( The domain of a left translation.  The term ` A ` is a constant.
         (Contributed by FL, 26-Apr-2012.) @)
      ltrdom @p |- ( ( G e. GrpOp /\ A e. X ) -> dom F = X ) @=
        ( cgr wcel wa cv co cvv wral cdm wceq ovex a1i ralrimiva cmpdom sylib )
        DHIBEIJZBAKZDLZMIZAENCOEPUBUEAEUEUBUCEIJBUCDQRSAEUDCFTUA @.
    @}

    @{
      @d X x @.
      @( A left translation is a set.  (Contributed by FL, 28-Apr-2012.) @)
      ltrset @p |- ( G e. GrpOp -> F e. _V ) @=
        ( cgr wcel wfun cdm cv co funmpt2 cmpdom2 unsgrp syl5eqel funex sylancr
        cvv ) DHIZCJCKZTICTIAEBALZDMCFNUAUBETAEBUCCDFODEGPQTCRS @.
    @}

    @{
      @d A x y @.  @d G x y @.  @d X x y @.
      @( The range of a left translation.  The term ` A ` is a constant.
         (Contributed by FL, 28-Apr-2012.) @)
      ltrran2 @p |- ( ( G e. GrpOp /\ A e. X ) -> ran F = X ) @=
        ( vy cgr wcel wa crn cv co wceq grpocl cfv eqid adantr eqcomd cab rnmpt
        wrex wi 3expia impcom eleq1 syl5ibrcom expcom rexlimdv simpll grpoinvcl
        cgn syl3anc cgi grpolid adantlr grporinv oveq1d simplr grpoass syl13anc
        simpr 3eqtrd oveq2 eqeq2d rspcev syl2anc ex impbid abbi1dv syl5eq ) DIJ
        ZBEJZKZCLHMZBAMZDNZOZAEUCZHUAEAHEVRCFUBVOVTHEVOVTVPEJZVOVSWAAEVQEJZVOVS
        WAUDWBVOKWAVSVREJZVOWBWCVMVNWBWCBVQDEGPUEUFVPVREUGUHUIUJVOWAVTVOWAKZBDU
        MQZQZVPDNZEJZVPBWGDNZOZVTWDVMWFEJZWAWHVMVNWAUKZVOWKWABDWEEGWERZULSZVOWA
        VCZWFVPDEGPUNWDVPDUOQZVPDNZBWFDNZVPDNZWIVMWAVPWQOVNVMWAKWQVPVPWPDEGWPRZ
        UPTUQWDWPWRVPDVOWPWROWAVOWRWPBWPDWEEGWTWMURTSUSWDVMVNWKWAWSWIOWLVMVNWAU
        TWNWOBWFVPDEGVAVBVDVSWJAWGEVQWGOVRWIVPVQWGBDVEVFVGVHVIVJVKVL @.
    @}

    @{
      @d A a b x z @.  @d G a b x z @.  @d X a b x z @.
      @( A left translation is a bijection.  The term ` A ` is a constant.
         (Contributed by FL, 29-Apr-2012.) @)
      ltrooo @p |- ( ( G e. GrpOp /\ A e. X ) -> F : X -1-1-onto-> X ) @=
        ( va vb cv co wceq wcel wa wf1o wi cfv wral 3exp 3adant3 cmpt cgr rgenw
        wfn crn weq cvv ovex a1i eqid mptfng sylib ltrran2 simprl grpocl adantr
        w3a com3r com3l imp31 oveq2 fvmptg syl2anc eqcomd simprr 3expia adantld
        simp3 imp jca 3eqtrd wb grpolcan expcom com34 mpbid ralrimivv syl3anbrc
        syl dff1o6 f1oeq1 syl5ibr ax-mp ) CAEBAJZDKZUAZLZDUBMZBEMZNZEECOZPFWJWK
        WGEEWFOZWJWFEUDZWFUEELHJZWFQZIJZWFQZLZHIUFZPZIERHERWLWJWEUGMZAERZWMXBWJ
        XAAEBWDDUHUCUIAEWEWFWFUJZUKULABWFDEXCGUMWJWTHIEEWJWNEMZWPEMZNZWRWSWJXFW
        RUQZBWNDKZBWPDKZLZWSXGXHWOWQXIWJXFXHWOLWRWJXFNZWOXHXKXDXHEMZWOXHLWJXDXE
        UNWHWIXFXLXFWHWIXLXDWHWIXLPPXEWHWIXDXLWHWIXDXLBWNDEGUOSURUPUSUTAWNWEXHE
        EWFWDWNBDVAXCVBVCVDTWJXFWRVHXGXEXIEMZNZWQXILWJXFXNWRXKXEXMWJXDXEVEWJXFX
        MWJXEXMXDWHWIXEXMBWPDEGUOVFVGVIVJTAWPWEXIEEWFWDWPBDVAXCVBVSVKWJXFXJWSVL
        ZWRWHWIXFXOXFWHWIXOXDXEWHWIXOPPXDXEWIWHXOXDXEWIWHXOPWHXDXEWIUQXOWNWPBDE
        GVMVNSVOVIUSUTTVPSVQHIEEWFVTVREECWFWAWBWC @.
    @}

    @{
      @d A x y @.  @d G x y @.  @d X x y @.
      @( Left translation expressed as a composite.  (Contributed by FL,
         3-Jul-2012.) @)
      ltrcmp @p |- ( ( G e. GrpOp /\ A e. X ) ->
        F = ( G o. ( x e. X |-> <. A , x >. ) ) ) @=
        ( vy cgr wcel wa cv cop cmpt ccom co cxp cfv opelxpi adantll wfo grpofo
        eqidd fof syl adantr feqmptd wceq fveq2 df-ov syl6eqr fmptco syl6reqr
        wf ) DIJZBEJZKZDAEBALZMZNZOAEBURDPZNCUQAHEEEQZUSHLZDRZVAUTDUPUREJUSVBJU
        OBUREESTUQUTUCUQHVBEDUOVBEDUNZUPUOVBEDUAVEDEGUBVBEDUDUEUFUGVCUSUHVDUSDR
        VAVCUSDUIBURDUJUKULFUM @.
    @}

    @{
      @d A x y z @.  @d F z @.  @d G x y z @.  @d N x y z @.  @d X x y z @.
      ltrinvlem.2 @e |- D = ( /g ` G ) @.
      ltrinvlem.3 @e |- N = ( inv ` G ) @.
      @( The converse of a left translation.  The term ` A ` is a constant.
         (Contributed by FL, 30-Apr-2012.) @)
      ltrinvlem @p |- ( ( G e. GrpOp /\ A e. X )
          -> `' F = ( x e. X |-> ( ( N ` A ) G x ) ) ) @=
        ( vy wcel wa cfv co cmpt wceq wf1o adantr ccnv cv wral ltrooo grpoinvcl
        cgr simpll simpr grpocl syl3anc jca simplr oveq2 cbvmptv fvmptg syl2anc
        eqtri w3a grpoass eqcomd syl13anc cgi eqid oveq1d grpolid adantlr eqtrd
        grporinv 3eqtrd f1ocnvfv sylc fvmpt2 eqtr4d ralrimiva wfn wb f1ofn 3syl
        f1ocnv syldan syl nfmpt1 nfcxfr nfcnv eqfnfv2f mpbird ) EUFMZBGMZNZDUAZ
        AGBFOZAUBZEPZQZRZWLWJOZWLWNOZRZAGUCZWIWRAGWIWLGMZNZWPWMWQXAGGDSZWMGMZNW
        MDOZWLRWPWMRXAXBXCWIXBWTABDEGHIUDZTXAWGWKGMZWTXCWGWHWTUGZWIXFWTBEFGIKUE
        ZTZWIWTUHZWKWLEGIUIUJZUKXAXDBWMEPZBWKEPZWLEPZWLXAXCXLGMZXDXLRXKXAWGWHXC
        XOXGWGWHWTULZXKBWMEGIUIUJLWMBLUBZEPZXLGGDXQWMBEUMDAGBWLEPZQZLGXRQHALGXS
        XRWLXQBEUMUNUQUOUPXAWGWHXFWTXLXNRXGXPXIXJWGWHXFWTURNXNXLBWKWLEGIUSUTVAX
        AXNEVBOZWLEPZWLXAXMYAWLEWIXMYARWTBYAEFGIYAVCZKVHTVDWGWTYBWLRWHWLYAEGIYC
        VEVFVGVIGGWMWLDVJVKXAWTXCWQWMRXJXKAGWMGWNWNVCZVLUPVMVNWIWJGVOZWNGVOZWOW
        SVPWIXBGGWJSYEXEGGDVSGGWJVQVRWIGGWNSZYFWGWHXFYGXHAWKWNEGYDIUDVTGGWNVQWA
        AGWJWNADADXTHAGXSWBWCWDAGWMWBWEUPWF @.
    @}

    @{
      @d A x z @.  @d B x z @.  @d G x z @.  @d X x z @.
      cmpltr2.2 @e |- H = ( x e. X |-> ( B G x ) ) @.
      @( Composite of two left translations.  The terms ` A ` and ` B ` are
         constant.  (Contributed by FL, 2-Jul-2012.) @)
      cmpltr2 @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
           ( F o. H ) = ( x e. X |-> ( ( A G B ) G x ) ) ) @=
        ( vz cgr wcel cv co cmpt wceq oveq2 cbvmptv a1i w3a ccom 3expa 3adantl2
        grpocl eqtri fmptco grpoass 3exp2 3imp1 mpteq2dva oveq2d syl6req eqtrd
        ) ELMZBGMZCGMZUAZDFUBKGBCKNZEOZEOZPZAGBCEOANZEOZPZURKAGGUTBVCEOZVAFDUOU
        QUSGMZUTGMZUPUOUQVGVHCUSEGIUEUCUDFKGUTPZQURFAGCVCEOZPVIJAKGVJUTVCUSCERZ
        SUFTDAGVFPQURHTVCUTBERUGURVEAGBVJEOZPVBURAGVDVLUOUPUQVCGMZVDVLQZUOUPUQV
        MVNBCVCEGIUHUIUJUKAKGVLVAVCUSQVJUTBEVKULSUMUN @.
    @}

    @{
      @d A x z @.  @d B x z @.  @d G x z @.  @d X x z @.
      cmpltr.2 @e |- H = ( x e. X |-> ( B G x ) ) @.
      @( Composite of two left translations.  The terms ` A ` and ` B ` are
         constant.  Don't use.  See ~ cmpltr2 .  (Contributed by FL,
         2-Jul-2012.)  (Revised by Mario Carneiro, 2-Jun-2014.) @)
      cmpltr @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
           ( F o. H ) = ( x e. X |-> ( ( A G B ) G x ) ) ) @=
        ( cmpltr2 ) ABCDEFGHIJK @.

    @}

  @}

  @{
    @d A x y @.  @d B x y @.  @d E x @.  @d G x y @.  @d X x y @.
    cmperltr.1 @e |- F = ( x e. X |-> ( ( A G x ) G B ) ) @.
    cmperltr.2 @e |- E = ( y e. X |-> ( A G y ) ) @.
    cmperltr.3 @e |- H = ( x e. X |-> ( x G B ) ) @.
    cmperltr.4 @e |- X = ran G @.
    @( A right and left translation expressed as a composite.  Note that ` x `
       and ` y ` can't be the same.  (Contributed by FL, 2-Jul-2012.) @)
    cmperltr @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X )
      -> F = ( E o. H ) ) @=
      ( cgr wcel cv co cmpt wceq a1i grpoass 3exp2 com34 3imp1 mpteq2dva syl5eq
      w3a ccom grpocl 3expa an32s 3adantl2 oveq2 fmptco eqtr4d ) GNOZCIOZDIOZUG
      ZFAICAPZDGQZGQZRZEHUHUSFAICUTGQDGQZRVCJUSAIVDVBUPUQURUTIOZVDVBSZUPUQVEURV
      FUPUQVEURVFCUTDGIMUAUBUCUDUEUFUSABIIVACBPZGQZVBHEUPURVEVAIOZUQUPVEURVIUPV
      EURVIUTDGIMUIUJUKULHAIVARSUSLTEBIVHRSUSKTVGVACGUMUNUO @.
  @}

  @{
    @d A x y @.  @d B x y @.  @d C x y @.  @d D x y @.  @d F x @.  @d G x y @.
    @d X x y @.
    cmprltr.1 @e |- F = ( y e. X |-> ( ( A G y ) G C ) ) @.
    cmprltr.2 @e |- E = ( x e. X |-> ( ( B G x ) G D ) ) @.
    cmprltr.3 @e |- X = ran G @.
    @( Composite of two right and left translations.  Note that ` x ` and ` y `
       can't be the same.  See ~ cmprltr2 for a more general version.
       (Contributed by FL, 2-Jul-2012.)  (Proof shortened by Mario Carneiro,
       26-Jul-2014.) @)
    cmprltr @p |- ( ( G e. GrpOp /\
      ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X ) ) -> ( F o. E ) =
         ( x e. X |-> ( ( ( A G B ) G x ) G ( D G C ) ) ) ) @=
      ( wcel wa co cmpt grpocl syl3anc wceq cgr w3a ccom simpl1 simpl2r simpl3r
      cv simpr a1i oveq2 oveq1d fmptco simpl2l grpoass syl13anc eqtrd mpteq2dva
      simpl3l eqtr3d ) IUANZCJNZDJNZOZEJNZFJNZOZUBZHGUCAJCDAUGZIPZFIPZIPZEIPZQA
      JCDIPZVHIPZFEIPIPZQVGABJJVJCBUGZIPZEIPZVLGHVGVHJNZOZUTVIJNZVEVJJNUTVCVFVS
      UDZVTUTVBVSWAWBVAVBUTVFVSUEZVGVSUHZDVHIJMRSZVDVEUTVCVSUFZVIFIJMRSGAJVJQTV
      GLUIHBJVRQTVGKUIVPVJTVQVKEIVPVJCIUJUKULVGAJVLVOVTVNFIPZEIPZVLVOVTWGVKEIVT
      WGCVIIPZFIPZVKVTVNWIFIVTUTVAVBVSVNWITWBVAVBUTVFVSUMZWCWDCDVHIJMUNUOUKVTUT
      VAWAVEWJVKTWBWKWEWFCVIFIJMUNUOUPUKVTUTVNJNZVEVDWHVOTWBVTUTVMJNZVSWLWBVTUT
      VAVBWMWBWKWCCDIJMRSWDVMVHIJMRSWFVDVEUTVCVSURVNFEIJMUNUOUSUQUP @.
  @}

  @{
    @d A a u x @.  @d A u z @.  @d B a u x @.  @d B u z @.  @d C a u x @.
    @d C u z @.  @d D a u x @.  @d D u z @.  @d F u @.  @d G a u x @.
    @d G u z @.  @d X u x @.  @d X u z @.
    cmprltr2.1 @e |- F = ( z e. X |-> ( ( A G z ) G C ) ) @.
    cmprltr2.2 @e |- E = ( x e. X |-> ( ( B G x ) G D ) ) @.
    cmprltr2.3 @e |- X = ran G @.
    @( Composite of two right and left translations.  No restriction: ` x ` and
       ` z ` can be equal.  (Contributed by FL, 2-Jul-2012.) @)
    cmprltr2 @p |- ( ( G e. GrpOp /\
      ( A e. X /\ B e. X ) /\ ( C e. X /\ D e. X ) ) -> ( F o. E ) =
         ( x e. X |-> ( ( ( A G B ) G x ) G ( D G C ) ) ) ) @=
      ( vu wcel wa co cv cmpt weq cgr oveq2 oveq1d cbvmptv eqtri cmprltr syl6eq
      w3a ccom ) IUAOCJODJOPEJOFJOPUHHGUINJCDIQZNRZIQZFEIQZIQZSAJUJARZIQZUMIQZS
      NBCDEFGHIJKGAJDUOIQZFIQZSNJDUKIQZFIQZSLANJUSVAANTURUTFIUOUKDIUBUCUDUEMUFN
      AJUNUQNATULUPUMIUKUOUJIUBUCUDUG @.
  @}

  @{
    rltr.1 @e |- F = ( x e. X |-> ( ( A G x ) G B ) ) @.
    rltr.2 @e |- X = ran G @.

    @{
      @d X x @.
      @( The domain of a right and left translation.  (Contributed by FL,
         2-Jul-2012.) @)
      rltrdom @p |- dom F = X @=
        ( cv co cmpdom2 ) AFBAIEJCDEGK @.
    @}

    @{
      @d X x @.
      @( A right and left translation is a set.  (Contributed by FL,
         2-Jul-2012.) @)
      rltrset @p |- ( G e. GrpOp -> F e. _V ) @=
        ( cgr wcel wfun cdm cvv cv co funmpt2 rltrdom unsgrp syl5eqel funex
        sylancr ) EIJZDKDLZMJDMJAFBANEOCEODGPUBUCFMABCDEFGHQEFHRSMDTUA @.
    @}

    @{
      @d A x y @.  @d B x y @.  @d G x y @.  @d X x y @.
      @( The range of a right and left translation.  Note that ` A ` and ` B `
         are constant.  (Contributed by FL, 2-Jul-2012.) @)
      rltrran @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) -> ran F = X ) @=
        ( vy wcel w3a co wceq wa grpocl syl3anc cfv syl2anc eqcomd oveq1d rnmpt
        cgr crn cv wrex wi simpr1 simpr2 simpl simpr3 3jca ex syl6 eleq1 imbi2d
        cab syl5ibrcom rexlimiv com12 cgn simpl1 grpoinvcl 3adant3 adantr simpr
        eqid 3adant2 simpl3 grpoass syl13anc grpolinv oveq2d 3ad2antl1 3eqtr2rd
        grporid grpolid simpl2 grporinv 3eqtrd eqtrd oveq2 eqeq2d rspcev impbid
        cgi abbi1dv syl5eq ) EUBJZBFJZCFJZKZDUCIUDZBAUDZELZCELZMZAFUEZIUPFAIFWO
        DGUAWKWQIFWKWQWLFJZWQWKWRWPWKWRUFZAFWMFJZWSWPWKWOFJZUFWTWKWHWNFJZWJKZXA
        WTWKXCWTWKNZWHXBWJWTWHWIWJUGZXDWHWIWTXBXEWTWHWIWJUHWTWKUIBWMEFHOPWTWHWI
        WJUJUKULWNCEFHOUMWPWRXAWKWLWOFUNUOUQURUSWKWRWQWKWRNZBEUTQZQZWLCXGQZELZE
        LZFJZWLBXKELZCELZMZWQXFWHXHFJZXJFJZXLWHWIWJWRVAZWKXPWRWHWIXPWJBEXGFHXGV
        FZVBVCVDZXFWHWRXIFJZXQXRWKWRVEZWKYAWRWHWJYAWICEXGFHXSVBVGVDZWLXIEFHOPZX
        HXJEFHOPXFWLBXHELZXJELZCELZXNXFWLXJCELZEWEQZXJELZCELYGXFYHWLXICELZELZWL
        YIELZWLXFWHWRYAWJYHYLMXRYBYCWHWIWJWRVHZWLXICEFHVIVJXFYIYKWLEXFYKYIXFWHW
        JYKYIMXRYNCYIEXGFHYIVFZXSVKRSVLWHWIWRYMWLMWJWLYIEFHYOVOVMVNXFXJYJCEXFWH
        XQXJYJMXRYDWHXQNYJXJXJYIEFHYOVPSRTXFYJYFCEXFYIYEXJEXFYEYIXFWHWIYEYIMXRW
        HWIWJWRVQZBYIEXGFHYOXSVRRSTTVSXFYFXMCEXFWHWIXPXQYFXMMXRYPXTYDBXHXJEFHVI
        VJTVTWPXOAXKFWMXKMZWOXNWLYQWNXMCEWMXKBEWATWBWCRULWDWFWG @.
    @}

    @{
      @d A u x y @.  @d B u x y @.  @d G u x y @.  @d X u x y @.
      @( A right and left translation is a bijection.  (Contributed by FL,
         2-Jul-2012.) @)
      rltrooo @p |- ( ( G e. GrpOp /\ A e. X /\ B e. X )
           -> F : X -1-1-onto-> X ) @=
        ( vy cv co wceq wcel w3a wf1o wi cfv wral cvv wa cmpt cgr wfn crn rgenw
        ovex eqid mptfng sylib rltrran fvmpt2 mpan2 ad2antrl oveq2 oveq1d fvmpt
        a1i ad2antll eqeq12d simprl1 simpl1 simpl2 simprl grpocl syl3anc simprr
        simpl simpl3 3jca adantl grporcan syl2anc mpbid simprrl simprrr simprl2
        wb grpolcan syl13anc ex syl6bi pm2.43a ralrimivva nfmpt1 nfcv syl3anbrc
        dff1o6f f1oeq1 syl5ibr ax-mp ) DAFBAJZEKZCEKZUAZLZEUBMZBFMZCFMZNZFFDOZP
        GWSWTWOFFWNOZWSWNFUCZWNUDFLWKWNQZIJZWNQZLZWKXDLZPZIFRAFRXAWSWMSMZAFRZXB
        XJWSXIAFWLCEUFZUEUQAFWMWNWNUGZUHUIABCWNEFXLHUJWSXHAIFFXFWSWKFMZXDFMZTZT
        ZXGXPXFWMBXDEKZCEKZLZXPXGPXPXCWMXEXRXMXCWMLZWSXNXMXIXTXKAFWMSWNXLUKULUM
        XNXEXRLWSXMAXDWMXRFWNXGWLXQCEWKXDBEUNUOXLXQCEUFUPURUSXSXPXGXSXPTZWLXQLZ
        XGYAXSYBXSXPVGYAWPWLFMZXQFMZWRNZXSYBVQWPWQWRXOXSUTZXPYEXSXPYCYDWRXPWPWQ
        XMYCWPWQWRXOVAZWPWQWRXOVBZWSXMXNVCBWKEFHVDVEXPWPWQXNYDYGYHWSXMXNVFBXDEF
        HVDVEWPWQWRXOVHVIVJWLXQCEFHVKVLVMYAWPXMXNWQYBXGVQYFXSWSXMXNVNXSWSXMXNVO
        WPWQWRXOXSVPWKXDBEFHVRVSVMVTWAWBWCAIFFWNAFWMWDIWNWEWGWFFFDWNWHWIWJ @.
    @}
  @}

  @( Compare fnopab2g and fnopab2 . If an antecedent, the condition B e. _V
     must be quantified. If a premisse it needn't. @)


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Fields and Rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d H g h @.  @d R a b g h @.  @d X a b g h @.
    com2i.1 @e |- G = ( 1st ` R ) @.
    com2i.2 @e |- H = ( 2nd ` R ) @.
    com2i.3 @e |- X = ran G @.
    @( Property of a commutative structure with two operation.  (Contributed by
       FL, 14-Feb-2010.) @)
    com2i @p |- ( R e. Com2 -> A. a e. X A. b e. X ( a H b ) = ( b H a ) ) @=
      ( vh vg cv co wceq wral crn cfv wb eqcomi eqeq2i copab ccm2 syl6eqr raleq
      c1st rneq raleqbi1dv syl sylbi c2nd oveq eqeq12d 2ralbidv elopabi df-com2
      eleq2s ) ELZFLZCMZURUQCMZNZFDOEDOZAUQURJLZMZURUQVCMZNZFKLZPZOZEVHOZKJUAUB
      VJVFFDOZEDOZVBKJAVGAUEQZNVGBNZVJVLRZVMBVGBVMGSTVNVHDNVOVNVHBPDVGBUFIUCVIV
      KEVHDVFFVHDUDUGUHUIVCAUJQZNZVFVAEFDDVQVCCNZVFVARVPCVCCVPHSTVRVDUSVEUTUQUR
      VCCUKURUQVCCUKULUIUMUNKJEFUOUP @.
  @}

  @{
    @d X u @.
    @( The domain of the first variable of an internal operation with a left
       and right identity element equals its base set.  (Contributed by FL,
       24-Jan-2010.) @)
    rngmgmbs3 @p |- ( ( G : ( X X. X ) --> X /\
      E. u e. X A. x e. X ( ( x G u ) = x /\ ( u G x ) = x ) )
         -> dom dom G = X ) @=
      ( cv co wceq wa wral wrex cxp wf cdm c0 wne rexn0 wi fdm dmeq dmxp syl2im
      eqtr ex syl syl5com impcom ) AEZBEZCFUGGUHUGCFUGGHADIZBDJZDDKZDCLZCMZMZDG
      ZUJDNOZULUOUIBDPULUMUKGZUPUOQUKDCRUQUNUKMZGZUPURDGZUOUMUKSDDTUSUTUOUNURDU
      BUCUAUDUEUF @.
  @}

  @{
    mlrngmgex.1 @e |- H = ( 2nd ` R ) @.
    @( In a unital ring the range of the multiplication equals the domain of
       the first variable.  (Contributed by FL, 24-Jan-2010.) @)
    rngodmdmrn @p |- ( R e. RingOps -> dom dom H = ran H ) @=
      ( crngo wcel c1st cfv crn cdm eqid rngorn1 rngorn1eq eqtr3d ) ADEAFGZHBII
      BHANBCNJZKANBCOLM @.
  @}

  @{
    rnplrnml3.1 @e |- G = ( 1st ` R ) @.
    @( In a unital ring the domain of the first operand of the addition equals
       the domain of the second operand of the addition.  (Contributed by FL,
       11-Feb-2010.) @)
    rngodmeqrn @p |- ( R e. RingOps -> dom dom G = ran dom G ) @=
      ( crngo wcel cgr cdm crn wceq rngogrpo cxp wfo wf wi eqid grpofo fof eqtr
      c0 wne grpon0 dmeq dmxpid syl6eq rneq rnxp ex syl5com expcom eqcoms syl56
      fdm com13 mpcom syl2im 3syl sylc ) ADEBFEZURBGZGZUSHZIZABCJZVCURBHZVDKZVD
      BLVEVDBMZURVBNBVDVDOZPVEVDBQVFUSVEIZURVDSTZVBVEVDBULBVDVGUAUTVDIZVHVIVBNV
      HUTVEGVDUSVEUBVDUCUDVIVHVJVBVHVAVEHZIZVIVAVDIZVJVBNZUSVEUEVIVKVDIZVLVMVDV
      DUFVLVOVMVAVKVDRUGUHVNVDVAVJVDVAIVBUTVDVARUIUJUKUMUNUOUPUQ @.
  @}

  @{
    ununr.1 @e |- H = ( 2nd ` R ) @.
    ununr.2 @e |- X = ran ( 1st ` R ) @.
    @d H x y @.  @d X x y @.
    @( The unit of a unital ring is unique.  (Contributed by FL, 12-Jul-2009.)
       (Proof shortened by Mario Carneiro, 23-Dec-2013.) @)
    ununr @p |- ( R e. RingOps -> E! x e. X
        A. y e. X ( ( x H y ) = y /\ ( y H x ) = y ) ) @=
      ( crngo wcel cv co wceq wa crn wral wreu cmndo cmagm cexid eqid mndomgmid
      cin rngomndo exidu1 3syl wb c1st cfv rngorn1eq syl5req raleq reueqd mpbid
      syl ) CHIZAJZBJZDKUQLUQUPDKUQLMZBDNZOZAUSPZURBEOZAEPZUODQIDRSUBIVACDFUCDU
      ABADUSUSTUDUEUOUSELVAVCUFUOECUGUHZNUSGCVDDFVDTUIUJUTVBAUSEURBUSEUKULUNUM
      @.
  @}

  @{
    rnginvcl.1 @e |- X = ran G @.
    rnginvcl.2 @e |- N = ( inv ` G ) @.
    @( The additive inverse of a unital ring element pertains to the unital
       ring.  (Contributed by FL, 18-Apr-2010.) @)
    rngoinvcl @p |- ( ( <. G , H >. e. RingOps /\ A e. X )
         -> ( N ` A ) e. X ) @=
      ( cop crngo wcel cgr cfv cablo rngoablo2 ablogrpo syl grpoinvcl sylan ) B
      CHIJZBKJZAEJADLEJSBMJTBCNBOPABDEFGQR @.
  @}

  @{
    multinv.1 @e |- X = ran G @.
    multinv.2 @e |- G = ( 1st ` R ) @.
    multinv.3 @e |- H = ( 2nd ` R ) @.
    @( Multiplication by an additive inverse.  (Contributed by FL,
       2-Sep-2009.) @)
    multinv @p |- ( ( R e. RingOps /\ A e. X /\ B e. X )
    -> ( ( ( inv ` G ) ` A ) H B ) = ( ( inv ` G ) ` ( A H B ) ) ) @=
      ( crngo wcel w3a co cgn cfv wceq cgi eqid eqcomd rngocl simp1 wi rngogrpo
      simp2 cgr grpoinvcl ex a1dd 3imp simp3 rngodir syl13anc 3ad2ant1 grporinv
      syl wa syl2anc oveq1d rngolz 3adant2 3eqtrd wb syld3an2 grpoinvid1 mpbird
      syl3anc ) CJKZAFKZBFKZLZABEMZDNOZOZAVLOZBEMZVJVMVOPZVKVODMZDQOZPZVJVQAVND
      MZBEMZVRBEMZVRVJVGVHVNFKZVIVQWAPVGVHVIUAVGVHVIUDZVGVHVIWCVGVHWCVIVGDUEKZV
      HWCUBCDHUCZWEVHWCADVLFGVLRZUFUGUOUHUIZVGVHVIUJVGVHWCVILUPWAVQAVNBCDEFHIGU
      KSULVJVTVRBEVJWEVHVTVRPVGVHWEVIWFUMZWDAVRDVLFGVRRZWGUNUQURVGVIWBVRPVHBCDE
      FVRWJGHIUSUTVAVJWEVKFKVOFKZVPVSVBWIABCDEFHIGTVGWCVHVIWKWHVNBCDEFHIGTVCVKV
      OVRDVLFGWJWGVDVFVES @.

    @( Multiplication by an additive inverse.  (Contributed by FL,
       6-Sep-2009.) @)
    multinvb @p |- ( ( R e. RingOps /\ A e. X /\ B e. X )
     -> ( A H ( ( inv ` G ) ` B ) ) = ( ( inv ` G ) ` ( A H B ) ) ) @=
      ( crngo wcel w3a co cgn cfv wceq cgi cgr eqid rngocl simp3 syl2anc oveq2d
      rngogrpo 3ad2ant1 grporinv simp1 simp2 wi grpoinvcl syl a1d 3imp syl13anc
      rngodi rngorz 3adant3 3eqtr3d syld3an3 grpoinvid1 syl3anc mpbird eqcomd
      ex wb ) CJKZAFKZBFKZLZABEMZDNOZOZABVKOZEMZVIVLVNPZVJVNDMZDQOZPZVIABVMDMZE
      MZAVQEMZVPVQVIVSVQAEVIDRKZVHVSVQPVFVGWBVHCDHUDZUEZVFVGVHUAZBVQDVKFGVQSZVK
      SZUFUBUCVIVFVGVHVMFKZVTVPPVFVGVHUGVFVGVHUHWEVFVGVHWHVFVHWHUIZVGVFWBWIWCWB
      VHWHBDVKFGWGUJVDUKULUMZABVMCDEFHIGUOUNVFVGWAVQPVHACDEFVQWFGHIUPUQURVIWBVJ
      FKVNFKZVOVRVEWDABCDEFHIGTVFVGVHWHWKWJAVMCDEFHIGTUSVJVNVQDVKFGWFWGUTVAVBVC
      @.
  @}

  @{
    mult2inv.1 @e |- X = ran G @.
    mult2inv.2 @e |- G = ( 1st ` R ) @.
    mult2inv.3 @e |- H = ( 2nd ` R ) @.
    @( Multiplication of two additive inverses.  (Contributed by FL,
       6-Sep-2009.) @)
    mult2inv @p |- ( ( R e. RingOps /\ A e. X /\ B e. X )
     -> ( ( ( inv ` G ) ` A ) H ( ( inv ` G ) ` B ) ) = ( A H B ) ) @=
      ( crngo wcel w3a cgn cfv co wceq cgr rngogrpo 3ad2ant1 syl2anc simp3 eqid
      grpoinvcl multinv syld3an3 multinvb fveq2d rngocl grpo2inv 3eqtrd ) CJKZA
      FKZBFKZLZADMNZNBUONZEOZAUPEOZUONZABEOZUONZUONZUTUKULUMUPFKZUQUSPUNDQKZUMV
      CUKULVDUMCDHRSZUKULUMUABDUOFGUOUBZUCTAUPCDEFGHIUDUEUNURVAUOABCDEFGHIUFUGU
      NVDUTFKVBUTPVEABCDEFHIGUHUTDUOFGVFUITUJ @.
  @}

  @{
    @d H u x @.  @d X u x @.  @d R u @.
    rngunval2.1 @e |- X = ran ( 1st ` R ) @.
    rngunval2.2 @e |- H = ( 2nd ` R ) @.
    rngunval2.3 @e |- U = ( GId ` H ) @.
    @( The value of the unit of a ring.  (Contributed by FL, 12-Feb-2010.)
       (Revised by Mario Carneiro, 23-Dec-2013.) @)
    rngounval2 @p |- ( R e. RingOps -> U = ( iota_ u e. X
     A. x e. X ( ( u H x ) = x /\ ( x H u ) = x ) ) ) @=
      ( wcel cv co wceq wral crio crn cfv eqid cvv c2nd crngo wa c1st rngorn1eq
      syl5eq raleqdv riotaeqbidv cgi fvex eqeltri gidval ax-mp eqtri syl6reqr )
      CUAJZBKZAKZELUQMUQUPELUQMUBZAFNZBFOURAEPZNZBUTOZDUOUSVABFUTUOFCUCQZPUTGCV
      CEHVCRUDUEZUOURAFUTVDUFUGDEUHQZVBIESJVEVBMECTQSHCTUIUJABESUTUTRUKULUMUN
      @.
  @}

  @{
    @d G x y @.  @d H x y @.
    @( The predicate "is a field".  (Contributed by FL, 6-Sep-2009.) @)
    isfldOLD @p |- ( ( G e. A /\ H e. B ) -> ( <. G , H >. e. Fld <->
      ( <. G , H >. e. DivRingOps
      /\ A. x e. ran G A. y e. ran G ( x H y ) = ( y H x ) ) ) ) @=
      ( wcel wa cop cfld cdrng ccm2 cin cv co wceq crn wral df-fld a1i wb elin
      eleq2d iscom2 anbi2d 3bitrd ) ECGFDGHZEFIZJGUHKLMZGZUHKGZUHLGZHZUKANZBNZF
      OUOUNFOPBEQZRAUPRZHUGJUIUHJUIPUGSTUCUJUMUAUGUHKLUBTUGULUQUKCDEFABUDUEUF
      @.
  @}

  @{
    fldi.1 @e |- G = ( 1st ` R ) @.
    fldi.2 @e |- H = ( 2nd ` R ) @.
    fldi.3 @e |- X = ran G @.
    fldi.4 @e |- Z = ( GId ` G ) @.
    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      @( The "axioms" of a field.  (Contributed by FL, 15-Sep-2010.) @)
      fldi @p |- ( R e. Fld ->
         (
              ( G e. AbelOp /\ H : ( X X. X ) --> X )
              /\ (
                 A. x e. X A. y e. X A. z e. X (
                         ( ( x H y ) H z ) = ( x H ( y H z ) )
                        /\ ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) )
                        /\ ( ( x G y ) H z ) = ( ( x H z ) G ( y H z ) ) )
                 /\ E. x e. X A. y e. X (
                         ( x H y ) = y
                        /\ ( y H x ) = y ) )
               /\ (
                  ( H |` ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. GrpOp
                 /\ A. x e. X A. y e. X ( x H y ) = ( y H x ) ) ) ) @=
        ( wcel wa cv co wceq wral cdrng ccm2 cablo cxp wf w3a wrex csn cdif cgr
        cres cin cfld elin crngo drngoi com2i wi rngoi id 3expia expdimp syl2im
        syl imp sylbi df-fld eleq2s ) EUAMGGUBGFUCNZAOZBOZFPZCOZFPVHVIVKFPZFPQV
        HVIVKEPFPVJVHVKFPZEPQVHVIEPVKFPVMVLEPQUDCGRBGRAGRVJVIQVIVHFPZVIQNBGRAGU
        ENZFGHUFUGZVPUBUIUHMZVJVNQBGRAGRZNZUDZDSTUJZUKDWAMDSMZDTMZNVTDSTULWBWCV
        TWBDUMMZVQNWCVRVTDEFGHIJKLUNDEFGABIJKUOWDVQVRVTWDVGVONVSVTUPABCDEFGIJKU
        QVGVOVSVTVTURUSVBUTVAVCVDVEVF @.
    @}
  @}

  @{
    @d G x y z @.  @d R x y z @.
    fldax1.1 @e |- G = ( 1st ` R ) @.
    @( 1st "axiom" of a field.  The addition is an abelian group.  (Contributed
       by FL, 11-Jul-2010.) @)
    fldax1 @p |- ( R e. Fld -> G e. AbelOp ) @=
      ( vx vy vz cfld wcel cablo crn cxp c2nd cfv wf wa cv co wceq wral eqid
      w3a wrex cgi csn cdif cres cgr fldi simp1d simpld ) AGHZBIHZBJZUMKUMALMZN
      ZUKULUOODPZEPZUNQZFPZUNQUPUQUSUNQZUNQRUPUQUSBQUNQURUPUSUNQZBQRUPUQBQUSUNQ
      VAUTBQRUAFUMSEUMSDUMSURUQRUQUPUNQZUQROEUMSDUMUBOUNUMBUCMZUDUEZVDKUFUGHURV
      BREUMSDUMSODEFABUNUMVCCUNTUMTVCTUHUIUJ @.
  @}

  @{
    fldax.1 @e |- G = ( 1st ` R ) @.
    fldax.2 @e |- H = ( 2nd ` R ) @.
    fldax.3 @e |- X = ran G @.

    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      @( 2nd "axiom" of a field.  The multiplication is an internal operation.
         (Contributed by FL, 11-Jul-2010.) @)
      fldax2 @p |- ( R e. Fld -> H : ( X X. X ) --> X ) @=
        ( vx vy vz cfld wcel cablo cxp wf wa cv co wceq wral w3a wrex cdif cres
        cgi cfv csn cgr eqid fldi simp1d simprd ) AKLZBMLZDDNDCOZUMUNUOPHQZIQZC
        RZJQZCRUPUQUSCRZCRSUPUQUSBRCRURUPUSCRZBRSUPUQBRUSCRVAUTBRSUAJDTIDTHDTUR
        UQSUQUPCRZUQSPIDTHDUBPCDBUEUFZUGUCZVDNUDUHLURVBSIDTHDTPHIJABCDVCEFGVCUI
        UJUKUL @.
    @}

    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      @( 3rd "axiom" of a field.  The multiplication is associative.
         (Contributed by FL, 11-Jul-2010.) @)
      fldax3 @p |- ( R e. Fld -> A. x e. X A. y e. X A. z e. X
                         ( ( x H y ) H z ) = ( x H ( y H z ) ) ) @=
        ( cfld wcel cv co wceq w3a wral wa cxp ralimi wrex cablo wf cgi cfv csn
        cdif cres cgr eqid fldi simp2d simp1 adantr syl ) DKLZAMZBMZFNZCMZFNUQU
        RUTFNZFNOZUQURUTENFNUSUQUTFNZENOZUQURENUTFNVCVAENOZPZCGQZBGQZAGQZUSUROU
        RUQFNZURORBGQAGUAZRZVBCGQZBGQZAGQZUPEUBLGGSGFUCRVLFGEUDUEZUFUGZVQSUHUIL
        USVJOBGQAGQRABCDEFGVPHIJVPUJUKULVIVOVKVHVNAGVGVMBGVFVBCGVBVDVEUMTTTUNUO
        @.
    @}

    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      @( 4th "axiom" of a field.  The multiplication is distributive.
         (Contributed by FL, 11-Jul-2010.) @)
      fldax4 @p |- ( R e. Fld -> A. x e. X A. y e. X A. z e. X
                        ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) ) @=
        ( cfld wcel cv co wceq w3a wral wa cxp ralimi wrex cablo wf cgi cfv csn
        cdif cres cgr eqid fldi simp2d simp2 adantr syl ) DKLZAMZBMZFNZCMZFNUQU
        RUTFNZFNOZUQURUTENFNUSUQUTFNZENOZUQURENUTFNVCVAENOZPZCGQZBGQZAGQZUSUROU
        RUQFNZURORBGQAGUAZRZVDCGQZBGQZAGQZUPEUBLGGSGFUCRVLFGEUDUEZUFUGZVQSUHUIL
        USVJOBGQAGQRABCDEFGVPHIJVPUJUKULVIVOVKVHVNAGVGVMBGVFVDCGVBVDVEUMTTTUNUO
        @.
    @}

    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      @( 5th "axiom" of a field.  Existence of a neutral element.  (Contributed
         by FL, 11-Jul-2010.) @)
      fldax5 @p |- ( R e. Fld -> E. x e. X A. y e. X ( y H x ) = y ) @=
        ( vz cfld wcel cv co wceq wa wral wrex w3a cxp wf cgi cfv csn cdif cres
        cablo cgr eqid fldi simp2d simprd simpr ralimi reximi syl ) CKLZAMZBMZE
        NZUSOZUSURENZUSOZPZBFQZAFRZVCBFQZAFRUQUTJMZENURUSVHENZENOURUSVHDNENUTUR
        VHENZDNOURUSDNVHENVJVIDNOSJFQBFQAFQZVFUQDUGLFFTFEUAPVKVFPEFDUBUCZUDUEZV
        MTUFUHLUTVBOBFQAFQPABJCDEFVLGHIVLUIUJUKULVEVGAFVDVCBFVAVCUMUNUOUP @.
    @}

    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      fldax.4 @e |- Z = ( GId ` G ) @.
      @( 6th "axiom" of a field.  The multiplication is a group on the
         underlying set deprived from zero.  (Contributed by FL,
         11-Jul-2010.) @)
      fldax6 @p |- ( R e. Fld -> ( H |`
        ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. GrpOp ) @=
        ( vx vy vz cfld wcel cxp cv co wceq wral wa csn cdif cres cgr cablo w3a
        wf wrex fldi simp3d simpld ) AMNZCDEUAUBZUMOUCUDNZJPZKPZCQZUPUOCQZRKDSJ
        DSZULBUENDDODCUGTUQLPZCQUOUPUTCQZCQRUOUPUTBQCQUQUOUTCQZBQRUOUPBQUTCQVBV
        ABQRUFLDSKDSJDSUQUPRURUPRTKDSJDUHTUNUSTJKLABCDEFGHIUIUJUK @.
    @}

    @{
      @d G x y z @.  @d H x y z @.  @d R x y @.  @d X x y z @.
      @( 7th "axiom" of a field.  The multiplication is commutative.
         (Contributed by FL, 11-Jul-2010.) @)
      fldax7 @p |- ( R e. Fld
        -> A. x e. X A. y e. X ( x H y ) = ( y H x ) ) @=
        ( vz cfld wcel cgi cfv cxp cv co wceq wral wa csn cdif cgr cablo wf w3a
        cres wrex eqid fldi simp3d simprd ) CKLZEFDMNZUAUBZUOOUGUCLZAPZBPZEQZUR
        UQEQZRBFSAFSZUMDUDLFFOFEUETUSJPZEQUQURVBEQZEQRUQURVBDQEQUSUQVBEQZDQRUQU
        RDQVBEQVDVCDQRUFJFSBFSAFSUSURRUTURRTBFSAFUHTUPVATABJCDEFUNGHIUNUIUJUKUL
        @.
    @}

  @}

  @{
    zrfld.1 @e |- A e. _V @.
    @( The zero ring is not a field.  (Contributed by FL, 24-Jan-2010.)
       (Revised by Mario Carneiro, 15-Dec-2013.) @)
    zrfld @p |- -. <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >.
      e. Fld @=
      ( cop csn cfld wcel cdrng zrdivrng flddivrng mto ) AACACDZKCZEFLGFABHLIJ
      @.
  @}

  @{
    @d x y @.
    @( ` ZZ ` is a commutative ring.  (Contributed by FL, 18-Apr-2010.) @)
    zintdom @p |- <. + , x. >. e. ( RingOps i^i Com2 ) @=
      ( vx vy caddc cmul cop crngo ccm2 cin wcel cnrngo cv co wceq wral syl cdm
      cc ax-mp eleq2i cvv crn cxp cablo cnaddablo cmndo ablogrpo grpomndo cmagm
      wfo cgr cexid mndomgmid wf ax-addf fdm dmeqd dmxpid syl6req opidon mulcom
      forn syl2anb rgen2a wb addex mulex iscom2 mp2an mpbir elin mpbir2an ) CDE
      ZFGHIVLFIVLGIZJVMAKZBKZDLVOVNDLMZBCUAZNAVQNZVPABVQVNVQIVNQIVOQIVPVOVQIVQQ
      VNQQUBZQCUIZVQQMCUCIZVTUDWACUEIZVTWACUJIWBCUFCUGOWBCUHUKHIVTCULCQVSQCUMZQ
      CPZPZMUNWCWEVSPQWCWDVSVSQCUOUPQUQURRUSOORVSQCVARZSVQQVOWFSVNVOUTVBVCCTIDT
      IVMVRVDVEVFTTCDABVGVHVIVLFGVJVK @.
  @}

  @c Tofld @.

  @( Extend class notation with the class of all totally ordered fields. @)
  ctofld @a class Tofld @.

  @{
    @d g h r x y z @.
    @( Definition of a totally ordered field.  Experimental.  (Contributed by
       FL, 27-Jun-2011.) @)
    df-tofld @a |- Tofld = { <. <. g , h >. , r >. | ( <. g , h >. e. Fld
     /\ ( r e. TosetRel /\ U. U. r = ran g ) /\ A. x e. U. U. r A. y e. U. U. r
        A. z e. U. U. r ( ( x r y -> ( x g z ) r ( y g z ) ) /\
        ( ( GId ` g ) r z -> ( x h z ) r ( y h z ) ) ) ) } @.
  @}

  @c zeroDiv @.

  @( Extend class notation with the class of all the zero divisors. @)
  czerodiv @a class zeroDiv @.

  @{
    @d r y a b @.
    @( Definition of the zero divisors of a ring.  Experimental.  (Contributed
       by FL, 27-Jun-2011.) @)
    df-zd @a |- zeroDiv = { <. r , y >. | y = { a e. ran ( 1st ` r ) |
        ( a =/= ( GId ` ( 1st ` r ) ) /\
          E. b e. ran ( 1st ` r )
             ( b =/= ( GId ` ( 1st ` r ) ) /\
             ( a ( 2nd ` r ) b ) = ( GId ` ( 1st ` r ) ) ) ) } } @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Ideals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c IdlNEW @.

  @( Extend class notation with the class of ideals. @)
  cidln @a class IdlNEW @.

  @{
    @d r i x y z @.
    @( Define the class of (two-sided) ideals of a ring ` R ` .  A subset of
       ` R ` is an ideal if it contains ` 0 ` , is closed under addition, and
       is closed under multiplication on either side by any element of ` R ` .
       (Contributed by Jeff Madsen, 10-Jun-2010.)  (Revised by FL,
       29-Oct-2014.) @)
    df-idlNEW @a |- IdlNEW = ( r e. Ring |->
      { i e. ~P ( Base ` r ) |
       ( ( 0g ` r ) e. i
       /\ A. x e. i ( A. y e. i ( x ( +g ` r ) y ) e. i
       /\ A. z e. ( Base ` r ) ( ( z ( .r ` r ) x ) e. i /\
                              ( x ( .r ` r ) z ) e. i ) ) ) } ) @.
  @}

  @{
    @d i r x y z R @.  @d i r B @.  @d r P @.  @d r T @.  @d r Z @.
    idlvalNEW.1 @e |- P = ( +g ` R ) @.
    idlvalNEW.2 @e |- T = ( .r ` R ) @.
    idlvalNEW.3 @e |- B = ( Base ` R ) @.
    idlvalNEW.4 @e |- Z = ( 0g ` R ) @.
    @( The class of ideals of a ring.  (Contributed by Jeff Madsen,
       10-Jun-2010.)  (Revised by FL, 29-Oct-2014.) @)
    idlvalNEW @p |- ( R e. Ring -> ( IdlNEW ` R ) = { i e. ~P B | ( Z e. i /\
      A. x e. i ( A. y e. i ( x P y ) e. i /\
          A. z e. B ( ( z T x ) e. i /\ ( x T z ) e. i ) ) ) } ) @=
      ( cv cfv wcel co wral wa cbs vr c0g cplusg cmulr cpw crab crg cidln fveq2
      wceq syl6eqr pweqd eleq1d wb oveqd ralbidv adantr eleq2d anbi12d ralbidv2
      wi imbi12d ralbidva rabeqbidv df-idlNEW cvv fvex eqeltri pwex rabex fvmpt
      ) UAFUANZUBOZHNZPZANZBNZVLUCOZQZVNPZBVNRZCNZVPVLUDOZQZVNPZVPWBWCQZVNPZSZC
      VLTOZRZSZAVNRZSZHWIUEZUFIVNPZVPVQEQZVNPZBVNRZWBVPGQZVNPZVPWBGQZVNPZSZCDRZ
      SZAVNRZSZHDUEZUFUGUHVLFUJZWMXGHWNXHXIWIDXIWIFTOZDVLFTUILUKZULXIVOWOWLXFXI
      VMIVNXIVMFUBOIVLFUBUIMUKUMXIWKXEAVNXIVPVNPZSZWAWRWJXDXIWAWRUNXLXIVTWQBVNX
      IVSWPVNXIVREVPVQXIVRFUCOEVLFUCUIJUKUOUMUPUQXMWHXCCWIDXIWBWIPZWHVAWBDPZXCV
      AUNXLXIXNXOWHXCXIWIDWBXKURXIWEWTWGXBXIWDWSVNXIWCGWBVPXIWCFUDOGVLFUDUIKUKZ
      UOUMXIWFXAVNXIWCGVPWBXPUOUMUSVBUQUTUSVCUSVDABCHUAVEXGHXHDDXJVFLFTVGVHVIVJ
      VK @.

    @d i r x y z R @.  @d i r B @.  @d i x y z I @.  @d i r P @.  @d i r T @.
    @d i r Z @.
    @( The predicate "is an ideal of the ring ` R ` ."  (Contributed by Jeff
       Madsen, 10-Jun-2010.)  (Revised by FL, 29-Oct-2014.) @)
    isidlNEW @p |- ( R e. Ring -> ( I e. ( IdlNEW ` R ) <->
          ( I C_ B /\ Z e. I /\ A. x e. I ( A. y e. I ( x P y ) e. I /\
             A. z e. B ( ( z T x ) e. I /\ ( x T z ) e. I ) ) ) ) ) @=
      ( vi wcel cv co wral wa eleq2 crg cidln cfv cpw crab wss idlvalNEW eleq2d
      w3a cbs fvex eqeltri elpw2 anbi1i raleqbi1dv anbi12d ralbidv elrab 3anass
      cvv wceq 3bitr4i syl6bb ) FUAOZHFUBUCZOHINPZOZAPZBPEQZVFOZBVFRZCPZVHGQZVF
      OZVHVLGQZVFOZSZCDRZSZAVFRZSZNDUDZUEZOZHDUFZIHOZVIHOZBHRZVMHOZVOHOZSZCDRZS
      ZAHRZUIZVDVEWCHABCDEFGNIJKLMUGUHHWBOZWFWNSZSWEWQSWDWOWPWEWQHDDFUJUCUTLFUJ
      UKULUMUNWAWQNHWBVFHVAZVGWFVTWNVFHITVSWMAVFHWRVKWHVRWLVJWGBVFHVFHVITUOWRVQ
      WKCDWRVNWIVPWJVFHVMTVFHVOTUPUQUPUOUPURWEWFWNUSVBVC @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Generic modules and vector spaces (New Structure builder)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @(
  %c Hom %. %( The class of linear mappings. %)

  %( Extend class notation to include linear mappings. %)
  clinm %a class Hom %.

  %{
    %d m n f u v x %.
    %( Definition of a linear mapping.  (Contributed by FL, 24-Dec-2013.) %)
    df-linm %a |- Hom = ( m e. LMod , n e. LMod |->
      { f e. ( ( Base ` n ) ^m ( Base ` m ) ) |
        ( A. u e. ( Base ` m ) A. v e. ( Base ` m )
      ( f ` ( u ( +g ` m ) v ) ) = ( ( f ` u ) ( +g ` n ) ( f ` v ) )
         /\ A. x e. ( Base ` m ) A. u e. ( Base ` m )
            ( f ` ( x ( .s ` m ) u ) )
               = ( x ( .s ` n ) ( f ` u ) ) ) } ) %.
  %}
  @)

  @c Action @. @( The class of actions. @)

  @( Extend class notation to include actions. @)
  cact @a class Action @.

  @{
    @d f k v s r w @.
    @( Definition of an action law.  The action is the function ( k ^m ( v ^m
       v ).  Definitions equivalent through currying.  (Contributed by FL,
       24-Dec-2013.) @)
    df-act @a |- Action = { f | E. k E. v E. s
    ( ( k = ( Base ` ( Scalar ` f ) ) /\ v = ( Base ` f ) /\ s = ( .s ` f ) )
     /\ A. r e. k A. w e. v ( r s w ) e. v ) } @.
  @}

  @( @c GrpWOp @. @) @( The class of groups with operators. @)

  @( Extend class notation to include groups with operators. @)
  @( cgwo @a class GrpWOp @. @)

  @( The definition df-grpwop is not sound, since it has free variables
     s, k, v, a.  I commented out the definition. - NM 18-May-2014 @)
 @(
  %{
    %d a f k r s v w x %.
    %( Definition of a group with operators. %)
    df-grpwop %a |- GrpWOp = { f e. ( Grp i^i Action ) | ( E. k E. v E. a
      ( k = ( Base ` ( Scalar ` f ) ) /\ v = ( Base ` f ) /\ a = ( +g ` f ) )
        /\ A. r e. k A. x e. v A. w e. v
              ( r s ( w a x ) ) = ( ( r s w ) a ( r s x ) ) ) } %.
  %}
 @)

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Generic modules and vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Vec @.

  @( Extend class notation with the class of all generic vector spaces and
     modules. @)
  cvec @a class Vec @.

  @{
    @d g h s a b u x v y z @.
    @( Definition of a vector space ( ` <. g , h >. ` is a field ), or of a
       module ( ` <. g , h >. ` is a ring ).  (Contributed by FL,
       12-Jul-2010.) @)
    df-vec @a |- Vec = { z | E. g E. h E. a E. b
     ( z = <. <. g , h >. , <. a , b >. >. /\
        ( a e. AbelOp
         /\ b : ( ran g X. ran a ) --> ran a
         /\ A. u e. ran a ( ( ( GId ` h ) b u ) = u /\ A. x e. ran g
           ( A. v e. ran a ( x b ( u a v ) ) = ( ( x b u ) a ( x b v ) )
              /\ A. y e. ran g ( ( ( x g y ) b u ) = ( ( x b u ) a ( y b u ) )
              /\ ( ( x h y ) b u ) = ( x b ( y b u ) ) ) ) ) ) ) } @.
  @}

  @{
    @d A a b g h u v x y @.  @d B a b g h u v x y @.  @d G a b g h u x y @.
    @d H a b g h u x y @.  @d a b g h u v x y z @.
    vecval1b.1 @e |- X = ran G @.
    vecval1b.4 @e |- W = ran A @.
    @( The predicate "is a vector space" or "is a module".  (Contributed by FL,
       12-Jul-2010.) @)
    vecval1b @p |- ( ( ( G e. M /\ H e. N /\ A e. O ) /\ B e. P )
      -> ( <. G , H >. Vec <. A , B >. <->
      ( A e. AbelOp /\ B : ( X X. W ) --> W
       /\ A. u e. W ( ( ( GId ` H ) B u ) = u
          /\ A. x e. X (
             A. v e. W
                 ( x B ( u A v ) ) = ( ( x B u ) A ( x B v ) )
             /\ A. y e. X ( ( ( x G y ) B u ) = ( ( x B u ) A ( y B u ) )
             /\ ( ( x H y ) B u ) = ( x B ( y B u ) ) ) ) ) ) ) ) @=
      ( wa co wceq wral vz vg vh va wcel w3a cop cvec wbr cablo crn cxp cgi cfv
      vb wf cv df-br wex cab df-vec eleq2i rneq xpeq1d feq2d oveq oveq1d eqeq1d
      anbi1d raleqbidv anbi2d ralbidv fveq2 anbi12d 3anbi3d eleq1 xpeq2d feq23d
      3anbi23d oveq2d eqeq12d eqeq2d 3anbi123d oveq12d id eqidd oveq123d syl5bb
      feq1 elo biid eqcomi xpeq12i feq23i imbi1i ralbii2 anbi12i imbi12i anbi2i
      3anbi123i syl6bb ) HJUEIKUEELUEUFFGUEQZHIUGZEFUGZUHUIZEUJUEZHUKZEUKZULZXH
      FUPZIUMUNZDUQZFRZXLSZAUQZXLCUQZERZFRZXOXLFRZXOXPFRZERZSZCXHTZXOBUQZHRZXLF
      RZXSYDXLFRZERZSZXOYDIRZXLFRZXOYGFRZSZQZBXGTZQZAXGTZQZDXHTZUFZXFNMULZMFUPZ
      XNYBCMTZYNBNTZQZANTZQZDMTZUFXEXCXDUGZUHUEZXBYTXCXDUHURUUJUUIUAUQUBUQZUCUQ
      ZUGUDUQZUOUQZUGUGSUUMUJUEZUUKUKZUUMUKZULZUUQUUNUPZUULUMUNZXLUUNRZXLSZXOXL
      XPUUMRZUUNRZXOXLUUNRZXOXPUUNRZUUMRZSZCUUQTZXOYDUUKRZXLUUNRZUVEYDXLUUNRZUU
      MRZSZXOYDUULRZXLUUNRZXOUVLUUNRZSZQZBUUPTZQZAUUPTZQZDUUQTZUFZQUOUSUDUSUCUS
      UBUSUAUTZUEXBYTUHUWFUUIABUACDUBUCUDUOVAVBUWEUUOXGUUQULZUUQUUNUPZUVBUVIYEX
      LUUNRZUVMSZUVRQZBXGTZQZAXGTZQZDUUQTZUFUUOUWHXKXLUUNRZXLSZUVIUWJYJXLUUNRZU
      VQSZQZBXGTZQZAXGTZQZDUUQTZUFXFXIXHUUNUPZUWRXOXQUUNRZUVEUVFERZSZCXHTZUWIUV
      EUVLERZSZUWTQZBXGTZQZAXGTZQZDXHTZUFYTUAUBUCUOUDHIEFJKLGUUKHSZUUSUWHUWDUWP
      UUOUXTUURUWGUUQUUNUXTUUPXGUUQUUKHVCZVDVEUXTUWCUWODUUQUXTUWBUWNUVBUXTUWAUW
      MAUUPXGUYAUXTUVTUWLUVIUXTUVSUWKBUUPXGUYAUXTUVNUWJUVRUXTUVKUWIUVMUXTUVJYEX
      LUUNXOYDUUKHVFVGVHVIVJVKVJVKVLVSUULISZUWPUXFUUOUWHUYBUWOUXEDUUQUYBUVBUWRU
      WNUXDUYBUVAUWQXLUYBUUTXKXLUUNUULIUMVMVGVHUYBUWMUXCAXGUYBUWLUXBUVIUYBUWKUX
      ABXGUYBUVRUWTUWJUYBUVPUWSUVQUYBUVOYJXLUUNXOYDUULIVFVGVHVKVLVKVLVNVLVOUUME
      SZUUOXFUWHUXGUXFUXSUUMEUJVPUYCUWGUUQXIXHUUNUYCUUQXHXGUUMEVCZVQUYDVRUYCUXE
      UXRDUUQXHUYDUYCUXDUXQUWRUYCUXCUXPAXGUYCUVIUXKUXBUXOUYCUVHUXJCUUQXHUYDUYCU
      VDUXHUVGUXIUYCUVCXQXOUUNXLXPUUMEVFVTUVEUVFUUMEVFWAVJUYCUXAUXNBXGUYCUWJUXM
      UWTUYCUVMUXLUWIUVEUVLUUMEVFWBVIVLVNVLVKVJWCUUNFSZUXGXJUXSYSXFXIXHUUNFWIUY
      EUXRYRDXHUYEUWRXNUXQYQUYEUWQXMXLXKXLUUNFVFVHUYEUXPYPAXGUYEUXKYCUXOYOUYEUX
      JYBCXHUYEUXHXRUXIYAXOXQUUNFVFUYEUVEXSUVFXTEXOXLUUNFVFZXOXPUUNFVFWDWAVLUYE
      UXNYNBXGUYEUXMYIUWTYMUYEUWIYFUXLYHYEXLUUNFVFUYEUVEXSUVLYGEUYFYDXLUUNFVFZW
      DWAUYEUWSYKUVQYLYJXLUUNFVFUYEXOXOUVLYGUUNFUYEWEUYEXOWFUYGWGWAVNVLVNVLVNVL
      VSWJWHWHXFXFXJUUBYSUUHXFWKXIXHUUAMFXGNXHMNXGOWLZMXHPWLZWMUYIWNYRUUGDXHMXL
      XHUEXLMUEYRUUGXHMXLUYIVBYQUUFXNYPUUEAXGNXOXGUEXONUEYPUUEXGNXOUYHVBYCUUCYO
      UUDYBYBCXHMXPXHUEXPMUEYBXHMXPUYIVBWOWPYNYNBXGNYDXGUEYDNUEYNXGNYDUYHVBWOWP
      WQWRWPWSWRWPWTXA @.
  @}

  @{
    @d A a b g h @.  @d B a b g h @.  @d G a b g h @.  @d H a b g h @.
    @d R a b g h u v x y z @.  @d W a b g h @.  @d X a b g h @.
    vecval3b.1 @e |- X = ran G @.
    vecval3b.2 @e |- G = ( 1st ` ( 1st ` R ) ) @.
    vecval3b.3 @e |- H = ( 2nd ` ( 1st ` R ) ) @.
    vecval3b.4 @e |- A = ( 1st ` ( 2nd ` R ) ) @.
    vecval3b.5 @e |- B = ( 2nd ` ( 2nd ` R ) ) @.
    vecval3b.6 @e |- W = ran A @.
    @( The "axioms" of a vector space or module.  (Contributed by FL,
       12-Jul-2010.) @)
    vecval3b @p |- ( R e. Vec ->
      ( A e. AbelOp /\ B : ( X X. W ) --> W
       /\ A. u e. W ( ( ( GId ` H ) B u ) = u
          /\ A. x e. X (
             A. v e. W
                 ( x B ( u A v ) ) = ( ( x B u ) A ( x B v ) )
             /\ A. y e. X ( ( ( x G y ) B u ) = ( ( x B u ) A ( y B u ) )
             /\ ( ( x H y ) B u ) = ( x B ( y B u ) ) ) ) ) ) ) @=
      ( wceq co wral vz vg vh va vb cvec cv cop cablo crn cxp wf cgi cfv wa w3a
      wcel wex cab df-vec eleq2i c1st c2nd rneq xpeq1d feq2d oveq oveq1d eqeq1d
      anbi1d raleqbidv anbi2d ralbidv fveq2 anbi12d 3anbi3d eleq1 xpeq2d feq23d
      3anbi23d oveq2d eqeq12d eqeq2d 3anbi123d oveq12d id eqidd oveq123d eqcomi
      feq1 wb eleq1i a1i rneqi eqtr4i feq123 mp3an fveq2i equid oveq123i eqeq1i
      xpeq12i oveqi eqeq12i imbi12i ralbii2 anbi12i bitrd eloi sylbi ) GUFUQGUA
      UGUBUGZUCUGZUHUDUGZUEUGZUHUHRXMUIUQZXKUJZXMUJZUKZXQXNULZXLUMUNZDUGZXNSZYA
      RZAUGZYACUGZXMSZXNSZYDYAXNSZYDYEXNSZXMSZRZCXQTZYDBUGZXKSZYAXNSZYHYMYAXNSZ
      XMSZRZYDYMXLSZYAXNSZYDYPXNSZRZUOZBXPTZUOZAXPTZUOZDXQTZUPZUOUEURUDURUCURUB
      URUAUSZUQEUIUQZKJUKZJFULZIUMUNZYAFSZYARZYDYAYEESZFSZYDYAFSZYDYEFSZESZRZCJ
      TZYDYMHSZYAFSZUUSYMYAFSZESZRZYDYMISZYAFSZYDUVFFSZRZUOZBKTZUOZAKTZUOZDJTZU
      PZUFUUJGABUACDUBUCUDUEUTVAUUIXOGVBUNZVBUNZUJZXQUKZXQXNULZYCYLYDYMUWASZYAX
      NSZYQRZUUBUOZBUWBTZUOZAUWBTZUOZDXQTZUPXOUWDUVTVCUNZUMUNZYAXNSZYARZYLUWGYD
      YMUWNSZYAXNSZUUARZUOZBUWBTZUOZAUWBTZUOZDXQTZUPGVCUNZVBUNZUIUQZUWBUXHUJZUK
      ZUXJXNULZUWQYDYAYEUXHSZXNSZYHYIUXHSZRZCUXJTZUWFYHYPUXHSZRZUWTUOZBUWBTZUOZ
      AUWBTZUOZDUXJTZUPZUVSUAUBUCUEUDGXKUWARZXSUWDUUHUWMXOUYGXRUWCXQXNUYGXPUWBX
      QXKUWAVDZVEVFUYGUUGUWLDXQUYGUUFUWKYCUYGUUEUWJAXPUWBUYHUYGUUDUWIYLUYGUUCUW
      HBXPUWBUYHUYGYRUWGUUBUYGYOUWFYQUYGYNUWEYAXNYDYMXKUWAVGVHVIVJVKVLVKVLVMVTX
      LUWNRZUWMUXFXOUWDUYIUWLUXEDXQUYIYCUWQUWKUXDUYIYBUWPYAUYIXTUWOYAXNXLUWNUMV
      NVHVIUYIUWJUXCAUWBUYIUWIUXBYLUYIUWHUXABUWBUYIUUBUWTUWGUYIYTUWSUUAUYIYSUWR
      YAXNYDYMXLUWNVGVHVIVLVMVLVMVOVMVPXMUXHRZXOUXIUWDUXLUXFUYEXMUXHUIVQUYJUWCX
      QUXKUXJXNUYJXQUXJUWBXMUXHVDZVRUYKVSUYJUXEUYDDXQUXJUYKUYJUXDUYCUWQUYJUXCUY
      BAUWBUYJYLUXQUXBUYAUYJYKUXPCXQUXJUYKUYJYGUXNYJUXOUYJYFUXMYDXNYAYEXMUXHVGW
      AYHYIXMUXHVGWBVKUYJUXAUXTBUWBUYJUWGUXSUWTUYJYQUXRUWFYHYPXMUXHVGWCVJVMVOVM
      VLVKWDXNUXGVCUNZRZUYFUXIUXKUXJUYLULZUWOYAUYLSZYARZYDUXMUYLSZYDYAUYLSZYDYE
      UYLSZUXHSZRZCUXJTZUWEYAUYLSZUYRYMYAUYLSZUXHSZRZUWRYAUYLSZYDVUDUYLSZRZUOZB
      UWBTZUOZAUWBTZUOZDUXJTZUPUVSUYMUXLUYNUYEVUOUXIUXKUXJXNUYLWJUYMUYDVUNDUXJU
      YMUWQUYPUYCVUMUYMUWPUYOYAUWOYAXNUYLVGVIUYMUYBVULAUWBUYMUXQVUBUYAVUKUYMUXP
      VUACUXJUYMUXNUYQUXOUYTYDUXMXNUYLVGUYMYHUYRYIUYSUXHYDYAXNUYLVGZYDYEXNUYLVG
      WEWBVMUYMUXTVUJBUWBUYMUXSVUFUWTVUIUYMUWFVUCUXRVUEUWEYAXNUYLVGUYMYHUYRYPVU
      DUXHVUPYMYAXNUYLVGZWEWBUYMUWSVUGUUAVUHUWRYAXNUYLVGUYMYDYDYPVUDXNUYLUYMWFU
      YMYDWGVUQWHWBVOVMVOVMVOVMVTUYMUXIUUKUYNUUMVUOUVRUXIUUKWKUYMUXHEUIEUXHOWIZ
      WLWMUYNUUMWKZUYMUYLFRUXKUULRUXJJRVUSFUYLPWIZUWBKUXJJUWBHUJKUWAHHUWAMWIZWN
      LWOZUXJEUJJUXHEVURWNQWOZXBVVCUXKUXJUULJUYLFWPWQWMVUOUVRWKUYMVUNUVQDUXJJYA
      UXJUQYAJUQVUNUVQUXJJYAVVCVAUYPUUPVUMUVPUYOUUOYAUWOYAUUNYAUYLFUWNIUMIUWNNW
      IZWRDWSZVUTWTXAVULUVOAUWBKYDUWBUQYDKUQVULUVOUWBKYDVVBVAVUBUVCVUKUVNVUAUVB
      CUXJJYEUXJUQYEJUQVUAUVBUXJJYEVVCVAUYQUURUYTUVAYDUXMYDUUQUYLFAWSZUXHEYAYEV
      URXCVUTWTUYRUYSUUSUUTUXHEUYLFYDYAVUTXCZUYLFYDYEVUTXCVURWTXDXEXFVUJUVMBUWB
      KYMUWBUQYMKUQVUJUVMUWBKYMVVBVAVUFUVHVUIUVLVUCUVEVUEUVGUWEYAUVDYAUYLFUWAHY
      DYMVVAXCVVEVUTWTUYRVUDUUSUVFUXHEVVGUYLFYMYAVUTXCZVURWTXDVUGUVJVUHUVKUWRYA
      UVIYAUYLFUWNIYDYMVVDXCVVEVUTWTYDVUDYDUVFUYLFVVFVVHVUTWTXDXGXEXFXGXEXFXGXE
      XFWMWDXHXIXJ @.
  @}

  @{
    @d R w x y z @.
    vecax1.1 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    @( 1st "axiom" of a vector space or module.  The vector addition is an
       abelian group.  (This theorem demonstrates the use of symbols as
       variable names, first proposed by FL in 2010.)  (Contributed by FL,
       14-Sep-2010.) @)
    vecax1 @p |- ( R e. Vec -> +w e. AbelOp ) @=
      ( vw vx vz vy cvec wcel cablo c1st cfv crn c2nd cv co wceq wral wa eqid
      cxp wf cgi vecval3b simp1d ) AHIBJIAKLZKLZMZBMZUAUIANLNLZUBUFNLZUCLDOZUJP
      ULQEOZULFOZBPUJPUMULUJPZUMUNUJPBPQFUIRUMGOZUGPULUJPUOUPULUJPZBPQUMUPUKPUL
      UJPUMUQUJPQSGUHRSEUHRSDUIREGFDBUJAUGUKUIUHUHTUGTUKTCUJTUITUDUE @.
  @}

  @{
    @d R w x y z @.
    vecax2.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    vecax2.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax2.6 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    @( 2nd "axiom" of a vector space or module.  Domain, codomain and
       functionality of the multiplication of a vector by a scalar.
       (Contributed by FL, 14-Sep-2010.) @)
    vecax2 @p |- ( R e. Vec -> .w : ( X X. W ) --> W ) @=
      ( vw vx vz vy wcel cfv c1st cv co wceq wral wa eqid cvec cablo cxp wf cgi
      c2nd vecval3b simp2d ) AUALAUFMNMZUBLCBUCBDUDANMZUFMZUEMHOZDPULQIOZULJOZU
      IPDPUMULDPZUMUNDPUIPQJBRUMKOZUJNMZPULDPUOUPULDPZUIPQUMUPUKPULDPUMURDPQSKC
      RSICRSHBRIKJHUIDAUQUKBCEUQTUKTUITFGUGUH @.
  @}

  @{
    @d R u x y z @.
    vecax3.2 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax3.3 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    vecax3.4 @e |- 1t = ( GId ` ( 2nd ` ( 1st ` R ) ) ) @.
    @( 3rd "axiom" of a vector space or module.  Multiplication by 1.
       (Contributed by FL, 13-Sep-2010.) @)
    vecax3 @p |- ( R e. Vec -> A. u e. W ( 1t .w u ) = u ) @=
      ( vx vz vy wcel cv co wceq cfv c1st wral wa eqid cvec c2nd crn cxp wf cgi
      cablo w3a vecval3b oveq1i eqeq1i anbi1i ralbii sylibr simp3d simpl ralimi
      3anbi3i syl ) BUALZDAMZENZVAOZIMZVAJMZBUBPQPZNENVDVAENZVDVEENVFNOJCRVDKMZ
      BQPZQPZNVAENVGVHVAENZVFNOVDVHVIUBPZNVAENVDVKENOSKVJUCZRSIVMRZSZACRZVCACRU
      TVFUGLZVMCUDCEUEZVPUTVQVRVLUFPZVAENZVAOZVNSZACRZUHVQVRVPUHIKJAVFEBVJVLCVM
      VMTVJTVLTVFTFGUIVPWCVQVRVOWBACVCWAVNVBVTVADVSVAEHUJUKULUMURUNUOVOVCACVCVN
      UPUQUS @.
  @}

  @{
    @d R u v x y @.
    vecax4.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    vecax4.4 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    vecax4.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax4.6 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    @( 4th "axiom" of a vector space or module.  Multiplication by a scalar
       distributes over vector addition.  (Contributed by FL, 13-Sep-2010.) @)
    vecax4 @p |- ( R e. Vec ->
          A. u e. W A. x e. X
             A. v e. W
                 ( x .w ( u +w v ) ) = ( ( x .w u ) +w ( x .w v ) ) ) @=
      ( vy c1st cfv cv co wceq wral wa cvec wcel c2nd cgi cablo cxp wf eqid crn
      eqcomi rneqi eqtri vecval3b simp3d simpl ralimi adantl syl ) DUAUBZDNOZUC
      OZUDOCPZHQVBRZAPZVBBPZGQHQVDVBHQZVDVEHQGQRBESZVDMPZUTNOZQVBHQVFVHVBHQZGQR
      VDVHVAQVBHQVDVJHQRTMFSZTZAFSZTZCESZVGAFSZCESUSGUEUBFEUFEHUGVOAMBCGHDVIVAE
      FIVIUHVAUHJKEDUCONOZUIGUILVQGGVQJUJUKULUMUNVNVPCEVMVPVCVLVGAFVGVKUOUPUQUP
      UR @.
  @}

  @{
    @d R u x y z @.
    vecax5.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    vecax5.2 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    vecax5.4 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    vecax5.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax5.6 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    @( 5th "axiom" of a vector space or module.  Multiplication by a sum of
       scalars.  (Contributed by FL, 13-Sep-2010.) @)
    vecax5 @p |- ( R e. Vec -> A. u e. W A. x e. X A. y e. X
        ( ( x +t y ) .w u ) = ( ( x .w u ) +w ( y .w u ) ) ) @=
      ( cfv cv co wceq wral crn vz cvec wcel c1st cgi wa cablo cxp eqcomi rneqi
      c2nd wf eqtri eqid vecval3b simp3d simpl ralimi adantl syl ) DUBUCZDUDOZU
      KOZUEOCPZIQVDRZAPZVDUAPZHQIQVFVDIQZVFVGIQHQRUAESZVFBPZGQVDIQVHVJVDIQZHQRZ
      VFVJVCQVDIQVFVKIQRZUFZBFSZUFZAFSZUFZCESZVLBFSZAFSZCESVAHUGUCFEUHEIULVSABU
      ACHIDGVCEFFVBUDOZTGTJWBGGWBKUIUJUMKVCUNLMEDUKOUDOZTHTNWCHHWCLUIUJUMUOUPVR
      WACEVQWAVEVPVTAFVOVTVIVNVLBFVLVMUQURUSURUSURUT @.
  @}

  @{
    @d R u x y z @.
    vecax6.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    vecax6.3 @e |- .t = ( 2nd ` ( 1st ` R ) ) @.
    vecax6.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax6.6 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    @( 6th "axiom" of a vector space or module.  Relation between scalar
       multiplication and vector multiplication.  (Contributed by FL,
       13-Sep-2010.) @)
    vecax6 @p |- ( R e. Vec -> A. u e. W A. x e. X A. y e. X
       ( ( x .t y ) .w u ) = ( x .w ( y .w u ) ) ) @=
      ( vz cfv cv co wceq c1st wral wa cvec wcel cgi c2nd cablo cxp wf vecval3b
      eqid simp3d simpr ralimi adantl syl ) DUAUBZGUCNCOZHPUPQZAOZUPMOZDUDNRNZP
      HPURUPHPZURUSHPUTPQMESZURBOZDRNRNZPUPHPVAVCUPHPZUTPQZURVCGPUPHPURVEHPQZTZ
      BFSZTZAFSZTZCESZVGBFSZAFSZCESUOUTUEUBFEUFEHUGVMABMCUTHDVDGEFIVDUIJUTUIKLU
      HUJVLVOCEVKVOUQVJVNAFVIVNVBVHVGBFVFVGUKULUMULUMULUN @.
  @}

  @{
    @d +t u x y @.  @d +w u x y @.  @d .w u x y @.  @d A x y @.  @d B y @.
    @d R u x y @.  @d U u x y @.  @d W u @.  @d X u x y @.
    vecax5b.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    vecax5b.2 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    vecax5b.4 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    vecax5b.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax5b.6 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    @( Multiplication by a sum of scalars.  (Contributed by FL,
       13-Sep-2010.) @)
    vecax5b @p |- ( ( R e. Vec /\ ( U e. W /\ A e. X /\ B e. X ) ) ->
        ( ( A +t B ) .w U ) = ( ( A .w U ) +w ( B .w U ) ) ) @=
      ( vx vy vu wcel co wceq cvec wral w3a vecax5 oveq2 oveq12d eqeq12d oveq1d
      cv oveq1 oveq2d rspc3v mpan9 ) CUAROUIZPUIZGSZQUIZISZUNUQISZUOUQISZHSZTZP
      FUBOFUBQEUBDERAFRBFRUCABGSZDISZADISZBDISZHSZTZOPQCEFGHIJKLMNUDVBVHUPDISZU
      NDISZUODISZHSZTAUOGSZDISZVEVKHSZTQOPDABEFFUQDTZURVIVAVLUQDUPIUEVPUSVJUTVK
      HUQDUNIUEUQDUOIUEUFUGUNATZVIVNVLVOVQUPVMDIUNAUOGUJUHVQVJVEVKHUNADIUJUHUGU
      OBTZVNVDVOVGVRVMVCDIUOBAGUEUHVRVKVFVEHUOBDIUJUKUGULUM @.
  @}

  @{
    claddinvvec.1 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    claddinvvec.2 @e |- ~w = ( inv ` ( 1st ` ( 2nd ` R ) ) ) @.
    @( Closure of the additive inverse of a vector.  (Contributed by FL,
       13-Sep-2010.) @)
    claddinvvec @p |- ( ( R e. Vec
        /\ U e. W )
          -> ( ~w ` U ) e. W ) @=
      ( cvec wcel c2nd cfv c1st cgr cablo eqid vecax1 ablogrpo grpoinvcl sylan
      syl ) AGHZAIJKJZLHZBCHBDJCHTUAMHUBAUAUANOUAPSBUADCEFQR @.

    @( Double inverse law for vector additive inverse.  (Contributed by FL,
       13-Sep-2010.) @)
    vec2inv @p |- ( ( R e. Vec /\ U e. W ) -> ( ~w ` ( ~w ` U ) ) = U ) @=
      ( cvec wcel c2nd cfv c1st cgr wceq cablo eqid ablogrpo syl grpo2inv sylan
      vecax1 ) AGHZAIJKJZLHZBCHBDJDJBMUAUBNHUCAUBUBOTUBPQBUBDCEFRS @.
  @}

  @{
    sum2vv.1 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    sum2vv.2 @e |- W = ran +w @.
    @( The sum of two vectors is a vector.  (Contributed by FL,
       13-Sep-2010.) @)
    sum2vv @p |- ( ( R e. Vec /\ V1 e. W /\ V2 e. W )
      -> ( V1 +w V2 ) e. W ) @=
      ( cvec wcel cgr co cablo vecax1 ablogrpo syl grpocl syl3an1 ) AHIZEJIZCBI
      DBICDEKBIRELISAEFMENOCDEBGPQ @.

    @{
      addnull1.1 @e |- 0w = ( GId ` +w ) @.
      @( Addition of the null vector.  (Contributed by FL, 13-Sep-2010.) @)
      addnull1 @p |- ( ( R e. Vec /\ U e. W )
        -> ( U +w 0w ) = U ) @=
        ( cvec wcel cgr co wceq cablo vecax1 ablogrpo syl grporid sylan ) AIJZD
        KJZBCJBEDLBMTDNJUAADFODPQBEDCGHRS @.

      @( Addition of the null vector.  (Contributed by FL, 13-Sep-2010.) @)
      addnull2 @p |- ( ( R e. Vec /\ U e. W )
        -> ( 0w +w U ) = U ) @=
        ( cvec wcel cgr co wceq cablo vecax1 ablogrpo syl grpolid sylan ) AIJZD
        KJZBCJEBDLBMTDNJUAADFODPQBEDCGHRS @.
    @}

    @( The addition of vectors is associative.  (Contributed by FL,
       13-Sep-2010.) @)
    addvecass @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) )
       -> ( V1 +w ( V2 +w V3 ) ) = ( ( V1 +w V2 ) +w V3 ) ) @=
      ( cvec wcel cgr w3a co wceq cablo vecax1 ablogrpo syl wa grpoass eqcomd
      sylan ) AIJZFKJZCBJDBJEBJLZCDEFMFMZCDFMEFMZNUCFOJUDAFGPFQRUDUESUGUFCDEFBH
      TUAUB @.

    @( The addition of vectors is associative.  (Contributed by FL,
       13-Sep-2010.) @)
    addvecom @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
       -> ( V1 +w V2 ) = ( V2 +w V1 ) ) @=
      ( cvec wcel wa co wceq cablo wi vecax1 ablocom 3expib syl imp ) AHIZCBIZD
      BIZJZCDEKDCEKLZTEMIZUCUDNAEFOUEUAUBUDCDEBGPQRS @.

    @{
      invaddvec.2 @e |- ~w = ( inv ` +w ) @.
      @( Additive inverse of a sum of vectors.  (Contributed by FL,
         13-Sep-2010.) @)
      invaddvec @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
         -> ( ~w ` ( V1 +w V2 ) ) = ( ( ~w ` V1 ) +w ( ~w ` V2 ) ) ) @=
        ( cvec wcel wa co cfv wceq cablo crn eqtri cgn claddinvvec cgr ablogrpo
        wi vecax1 grpoinvop 3expib 3syl c2nd c1st rneqi fveq2i anim12dan ancomd
        imp addvecom syldan eqtrd ) AJKZCBKZDBKZLZLZCDEMFNZDFNZCFNZEMZVEVDEMZUR
        VAVCVFOZUREPKEUAKZVAVHUCAEGUDEUBVIUSUTVHCDEFBHIUEUFUGUNURVAVDBKZVEBKZLV
        FVGOVBVKVJURUSVKUTVJACBFBEQAUHNUINZQHEVLGUJRZFESNVLSNIEVLSGUKRZTADBFVMV
        NTULUMABVDVEEGHUOUPUQ @.
    @}
  @}

  @{
    prodvs.1 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    prodvs.2 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    prodvs.3 @e |- W = ran +w @.
    prodvs.4 @e |- X = ran +t @.
    prodvs.5 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    @( The product of a vector by a scalar is a vector.  (Contributed by FL,
       12-Sep-2010.) @)
    prodvs @p |- ( ( R e. Vec /\ A e. X /\ U e. W )
      -> ( A .w U ) e. W ) @=
      ( cvec wcel crn c1st cfv rneqi eqtri cxp wf co c2nd vecax2 fovrn syl3an1
      ) BNOEDUADHUBAEOCDOACHUCDOBDEHEFPBQRQRZPLFUHMSTJDGPBUDRQRZPKGUIISTUEACDED
      HUFUG @.
  @}

  @{
    vecsrcan.1 @e |- -w = ( /g ` +w ) @.
    vecsrcan.2 @e |- W = ran +w @.
    vecsrcan.3 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    @( Right cancellation law for vector subtraction.  (Contributed by FL,
       12-Sep-2010.) @)
    vecsrcan @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V1 -w V3 ) = ( V2 -w V3 ) <-> V1 = V2 ) ) @=
      ( cvec wcel cgr w3a co wceq wb cablo vecax1 ablogrpo syl grpodrcan sylan
      ) AKLZFMLZCBLDBLEBLNCEGODEGOPCDPQUDFRLUEAFJSFTUACDEGFBIHUBUC @.

    @( Left cancellation law for vector subtraction.  (Contributed by FL,
       12-Sep-2010.) @)
    vecslcan @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V3 -w V1 ) = ( V3 -w V2 ) <-> V1 = V2 ) ) @=
      ( cvec wcel cgr w3a co wceq wb cablo vecax1 ablogrpo syl grpodlcan sylan
      ) AKLZFMLZCBLDBLEBLNECGOEDGOPCDPQUDFRLUEAFJSFTUACDEGFBIHUBUC @.

  @}

  @{
    vwit.1 @e |- 0w = ( GId ` +w ) @.
    vwit.2 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    vwit.3 @e |- -w = ( /g ` +w ) @.
    vwit.4 @e |- W = ran +w @.
    @( A vector minus itself equals zero.  (Contributed by FL, 12-Sep-2010.) @)
    vwit @p |- ( ( R e. Vec /\ U e. W ) -> ( U -w U ) = 0w ) @=
      ( cvec wcel cgr co wceq cablo vecax1 ablogrpo syl grpodivid sylan ) AKLZD
      MLZBCLBBENFOUBDPLUCADHQDRSBEFDCJIGTUA @.

    @{
      vwit.5 @e |- ~w = ( inv ` +w ) @.
      @( Definition of the subtraction of two vectors.  (Contributed by FL,
         12-Sep-2010.) @)
      sub2vec @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
        -> ( V1 -w V2 ) = ( V1 +w ( ~w ` V2 ) ) ) @=
        ( cvec wcel wa cgr co cfv wceq vecax1 ablogrpo syl adantr simprl simprr
        cablo grpodivval syl3anc ) ANOZCBOZDBOZPZPEQOZUKULCDFRCDHSERTUJUNUMUJEU
        GOUNAEJUAEUBUCUDUJUKULUEUJUKULUFCDFEHBLMKUHUI @.
    @}

    @( Moving a vector from the right member of an equation into the left
       member.  (Contributed by FL, 12-Sep-2010.) @)
    mvecrtol @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W ) )
         -> ( V1 = V2 <-> ( V1 -w V2 ) = 0w ) ) @=
      ( cvec wcel wa co wceq cgr wb cablo vecax1 adantr simprl simprr grpodrcan
      ablogrpo syl syl13anc vwit adantrl eqeq2d bitr3d ) ALMZCBMZDBMZNZNZCDFOZD
      DFOZPZCDPZUQGPUPEQMZUMUNUNUSUTRULVAUOULESMVAAEITEUEUFUAULUMUNUBULUMUNUCZV
      BCDDFEBKJUDUGUPURGUQULUNURGPUMADBEFGHIJKUHUIUJUK @.

    @( Double subtraction of vectors.  (Contributed by FL, 12-Sep-2010.) @)
    dblsubvec @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) )
         -> ( ( V1 -w V2 ) -w V3 ) = ( V1 -w ( V2 +w V3 ) ) ) @=
      ( wcel w3a wa co cgn cfv wceq sub2vec cvec eqid 3adantr3 oveq1d simpl crn
      simpr1 c2nd c1st rneqi fveq2i claddinvvec 3ad2antr2 sum2vv syl3anc simpr3
      syl12anc invaddvec 3adantr1 eqcomd oveq2d 3ad2antr3 3jca addvecass syldan
      eqtri 3adant3r1 3eqtr4d 3eqtrd ) AUAMZCBMZDBMZEBMZNZOZCDGPZEGPCDFQRZRZFPZ
      EGPZVSEVQRZFPZCDEFPZGPZVOVPVSEGVJVKVLVPVSSVMABCDFGHVQIJKLVQUBZTUCUDVOVJVS
      BMZVMVTWBSVJVNUEZVOVJVKVRBMZWFWGVJVKVLVMUGZVJVKVLWHVMADBVQBFUFAUHRUIRZUFL
      FWJJUJVFZFWJQJUKZULUMZABCVRFJLUNUOVJVKVLVMUPABVSEFGHVQIJKLWETUQVOCVRWAFPZ
      FPZCWCVQRZFPZWBWDVOWNWPCFVOWPWNVJVLVMWPWNSVKABDEFVQJLWEURUSUTVAVJVNVKWHWA
      BMZNZWBWOSVOVKWHWRWIWMVJVKVMWRVLAEBVQWKWLULVBVCVJWSOWOWBABCVRWAFJLVDUTVEV
      OVJVKWCBMZWDWQSWGWIVJVLVMWTVKABDEFJLUNVGABCWCFGHVQIJKLWETUQVHVI @.

    @{
      vecrcan.1 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
      vecrcan.2 @e |- W = ran +w @.
      @( Right cancellation law for vector addition.  (Contributed by FL,
         12-Sep-2010.) @)
      vecrcan @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V1 +w V3 ) = ( V2 +w V3 ) <-> V1 = V2 ) ) @=
        ( cvec wcel cgr w3a co wceq wb cablo vecax1 ablogrpo syl grporcan sylan
        ) AOPZFQPZCBPDBPEBPRCEFSDEFSTCDTUAUHFUBPUIAFJUCFUDUECDEFBLUFUG @.

      @( Left cancellation law for vector addition.  (Contributed by FL,
         12-Sep-2010.) @)
      veclcan @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) ) ->
                  ( ( V3 +w V1 ) = ( V3 +w V2 ) <-> V1 = V2 ) ) @=
        ( cvec wcel cgr w3a co wceq wb cablo vecax1 ablogrpo syl grpolcan sylan
        ) AOPZFQPZCBPDBPEBPRECFSEDFSTCDTUAUHFUBPUIAFJUCFUDUECDEFBLUFUG @.
    @}

    @( Moving a vector from the right member of an equation into the left
       member.  (Contributed by FL, 12-Sep-2010.) @)
    mvecrtol2 @p |- ( ( R e. Vec /\ ( V1 e. W /\ V2 e. W /\ V3 e. W ) )
         -> ( V1 = ( V2 +w V3 ) <-> ( V1 -w V2 ) = V3 ) ) @=
      ( wcel w3a wa co wceq sum2vv cfv eqtrd cvec cgr cablo vecax1 ablogrpo syl
      adantr simpr1 3adant3r1 simpr2 grpodrcan syl13anc addvecom 3adantr1 simpl
      wb oveq1d cgn 3exp com3l impcom 3adant1 eqid sub2vec syl12anc simpr3 c2nd
      wi crn c1st rneqi eqtri fveq2i claddinvvec 3ad2antr2 3jca addvecass simp2
      syldan sylan2 eqcomd oveq2d 3eqtr2d vwit addnull1 3ad2antr3 eqeq2d bitr3d
      jca ) AUAMZCBMZDBMZEBMZNZOZCDGPZDEFPZDGPZQZCWQQZWPEQWOFUBMZWKWQBMZWLWSWTU
      PWJXAWNWJFUCMXAAFJUDFUEUFUGWJWKWLWMUHWJWLWMXBWKABDEFJLRUIWJWKWLWMUJZCWQDG
      FBLKUKULWOWREWPWOWREDFPZDGPZEWOWQXDDGWJWLWMWQXDQWKABDEFJLUMUNUQWOXEEDDGPZ
      FPZEWOXEXDDFURSZSZFPZEDXIFPZFPZXGWOWJXDBMZWLXEXJQWJWNUOWNWJXMWLWMWJXMVHZW
      KWMWLXNWJWMWLXMWJWMWLXMABEDFJLRUSUTVAVBVAXCABXDDFGHXHIJKLXHVCZVDVEWJWNWMW
      LXIBMZNXLXJQWOWMWLXPWJWKWLWMVFXCWJWKWLXPWMADBXHBFVIAVGSVJSZVILFXQJVKVLFXQ
      URJVMVNVOVPABEDXIFJLVQVSWOXKXFEFWOXFXKWNWJWLWLOXFXKQWNWLWLWKWLWMVRZXRWIAB
      DDFGHXHIJKLXOVDVTWAWBWCWOXGEHFPZEWOXFHEFWJWKWLXFHQWMADBFGHIJKLWDVOWBWJWKW
      MXSEQWLAEBFHJLIWEWFTTTWGWH @.
  @}

  @{
    prvs.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    prvs.2 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    prvs.3 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    @( The product of a vector by a scalar is a vector.  (Contributed by FL,
       12-Sep-2010.) @)
    prvs @p |- ( ( R e. Vec /\ A e. X /\ U e. W ) -> ( A .w U ) e. W ) @=
      ( cvec wcel cxp wf co vecax2 fovrn syl3an1 ) BJKEDLDFMAEKCDKACFNDKBDEFGIH
      OACDEDFPQ @.
  @}

  @{
    mulveczer.1 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    mulveczer.2 @e |- 0t = ( GId ` +t ) @.
    mulveczer.3 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    mulveczer.4 @e |- .t = ( 2nd ` ( 1st ` R ) ) @.
    mulveczer.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    mulveczer.6 @e |- 0w = ( GId ` ( 1st ` ( 2nd ` R ) ) ) @.
    @( Multiplication of a vector by zero.  (Contributed by FL,
       12-Sep-2010.) @)
    mulveczer @p |- ( ( R e. Vec /\ <. +t , .t >. e. RingOps /\
         U e. W ) -> ( 0t .w U ) = 0w ) @=
      ( wcel co cfv c1st wceq eqid cvec cop crngo w3a c2nd cgs crn fvex eqeltri
      op1st eqcomi rngo0cl wa rngo0lid eqcomd mpdan 3ad2ant2 oveq1d simp1 simp3
      cvv rneqi vecax5b syl13anc eqtrd wb prodvs syl3an2 mvecrtol2 vwit syl2anc
      mpbid eqtr3d ) AUAOZDEUBZUCOZBCOZUDZFBGPZVSAUEQRQZUFQZPZVSHVRVSVSVSVTPZSZ
      WBVSSZVRVSFFDPZBGPZWCVRFWFBGVPVNFWFSZVQVPFDUGZOZWHVODWIFVORQDDEDARQZRQZVA
      KWKRUHUIEWKUEQVALWKUEUHUIUJUKZWITZJULZVPWJUMWFFFVODWIFWMWNJUNUOUPUQURVRVN
      VQFWLUGZOZWQWGWCSVNVPVQUSZVNVPVQUTVPVNWQVQVODWPFWMWLDDWLKUKVBJULUQZWSFFAB
      CWPDVTGWPTKVTTZMIVCVDVEVRVNVSCOZXAXAWDWEVFWRVPVNWJVQXAWOFABCWIDVTGWTMIWNK
      VGVHZXBXBACVSVSVSVTWAHNWTWATZIVIVDVLVRVNXAWBHSWRXBAVSCVTWAHNWTXCIVJVKVM
      @.
  @}

  @{
    mulinvsca.1 @e |- X = ran +t @.
    mulinvsca.2 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    mulinvsca.3 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    mulinvsca.4 @e |- ~t = ( inv ` +t ) @.
    mulinvsca.5 @e |- ~w = ( inv ` ( 1st ` ( 2nd ` R ) ) ) @.
    mulinvsca.6 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    mulinvsca.7 @e |- .t = ( 2nd ` ( 1st ` R ) ) @.
    @( Multiplication by the inverse of a scalar.  (Contributed by FL,
       12-Sep-2010.) @)
    mulinvsca @p |- ( ( R e. Vec /\ <. +t , .t >. e. RingOps
        /\ ( A e. X /\ U e. W ) )
          -> ( ( ~t ` A ) .w U ) = ( ~w ` ( A .w U ) ) ) @=
      ( wcel cfv wceq cvec cop crngo wa w3a co c2nd c1st simp1 simp3r rngoinvcl
      simp3l adantrr 3adant1 crn rneqi eqtri eqid vecax5b syl13anc prodvs 3expb
      cgs 3adant2 jca cgi wi vwit simpl mulveczer 3adant3l cgr cvv fvex eqeltri
      op1st eqcomi rngogrpo 3ad2ant2 grporinv eqcomd oveq1d eqtr3d adantl eqtrd
      syl2anc ex mpcom prvs syl3anc sub2vec syl12anc wb cablo ablogrpo 3ad2ant1
      syl vecax1 claddinvvec grpolcan mpbid ) BUARZFGUBZUCRZAERZCDRZUDZUEZACIUF
      ZAHSZCIUFZBUGSUHSZUFZXIXIJSZXLUFZTZXKXNTZXHAXJFUFZCIUFZXMXOXHXBXFXEXJERZX
      SXMTXBXDXGUIZXBXDXEXFUJZXBXDXEXFULZXDXGXTXBXDXEXTXFAFGHEKNUKUMUNZAXJBCDEF
      XLIEFUOBUHSZUHSZUOKFYFPUPUQZPXLURZMLUSUTXHXIXIXLVCSZUFZXSXOXBXIDRZUDZXHYJ
      XSTZXHXBYKYAXBXGYKXDXBXEXFYKABCDEFXLIYHMLKPVAVBVDZVEYLYJXLVFSZTZXHYMVGBXI
      DXLYIYOYOURZYHYIURZLVHYPXHYMYPXHUDYJYOXSYPXHVIXHYOXSTYPXHFVFSZCIUFZYOXSXB
      XDXFYTYOTXEBCDFGYSIYOLYSURZPQMYQVJVKXHYSXRCIXHXRYSXHFVLRZXEXRYSTXDXBUUBXG
      XCFXCUHSFFGFYFVMPYEUHVNVOGYEUGSVMQYEUGVNVOVPVQVRVSYCAYSFHEKUUANVTWFWAWBWC
      WDWEWGWQWHXHXBYKYKYJXOTYAXHXBXEXFYKYAYCYBABCDEIYGLMWIWJZUUCBDXIXIXLYIYOJY
      QYHYRLOWKWLWCWCXHXLVLRZXKDRZXNDRZYKXPXQWMXBXDUUDXGXBXLWNRUUDBXLYHWRXLWOWQ
      WPXHXBXTXFUUEYAYDYBXJBCDEIYGLMWIWJXHXBYKUUFYAYNBXIDJLOWSWFYNXKXNXIXLDLWTU
      TXA @.
  @}

  @{
    @d +t u x y @.  @d .t u x y @.  @d R u x y @.  @d W x y @.  @d X y @.
    muldisc.1 @e |- X = ran ( 1st ` ( 1st ` R ) ) @.
    muldisc.2 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    muldisc.4 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    muldisc.5 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    muldisc.6 @e |- W = ran ( 1st ` ( 2nd ` R ) ) @.
    muldisc.7 @e |- -t = ( /g ` +t ) @.
    muldisc.8 @e |- -w = ( /g ` +w ) @.
    muldisc.9 @e |- .t = ( 2nd ` ( 1st ` R ) ) @.
    @( Multiplication by a difference of scalars.  (Contributed by FL,
       12-Sep-2010.) @)
    muldisc @p |- ( ( R e. Vec /\ <. +t , .t >. e. RingOps )
        -> A. u e. W A. x e. X A. y e. X
          ( ( x -t y ) .w u ) = ( ( x .w u ) -w ( y .w u ) ) ) @=
      ( cvec wcel cop crngo wa cv co wceq wral cgn cfv cgr c1st crn cvv eqeltri
      fvex op1st eqcomi rngogrpo adantl ad2antrr eleq2i biimpi rneqi grpodivval
      c2nd ad2antlr eqid syl3anc oveq1d simplll simplrl simplrr syl5eqelr sylan
      fveq2i grpoinvcl vecax5b syl13anc mulinvsca syl112anc oveq2d 3eqtrd cablo
      simpllr vecax1 ablogrpo syl adantr prvs 3exp com3l impcom com12 imp com3r
      wi eqtri eqtr4d ralrimiva ralrimivva ) DUAUBZGIUCZUDUBZUEZAUFZBUFZHUGZCUF
      ZLUGZXGXJLUGZXHXJLUGZKUGZUHZBFUICAEFXFXJEUBZXGFUBZUEZUEZXOBFXSXHFUBZUEZXK
      XLXMJUJUKZUKZJUGZXNYAXKXGXHGUJUKZUKZGUGZXJLUGZXLYFXJLUGZJUGZYDYAXIYGXJLYA
      GULUBZXGDUMUKZUMUKZUNZUBZXHYNUBZXIYGUHXFYKXRXTXEYKXCXDGXDUMUKGGIGYMUONYLU
      MUQUPIYLVGUKUOTYLVGUQUPURUSUTZVAVBXRYOXFXTXQYOXPXQYOFYNXGMVCVDVAVHXTYPXSX
      TYPFYNXHMVCVDVAZXGXHHGYEYNGUNYNGYMNVEUSYEVIZRVFVJVKYAXCXPXQYFFUBZYHYJUHXC
      XEXRXTVLZXFXPXQXTVMZXFXPXQXTVNXSYMULUBZXTYTXEUUCXCXRXEYMGULNYQVOVHXHYMYEF
      MGYMUJNVQVRVPXGYFDXJEFGJLMNOPQVSVTYAYIYCXLJYAXCXEYPXPYIYCUHUUAXCXEXRXTWFY
      RUUBXHDXJEYNGIYELYBYMGGYMNUSVEQPYSJDVGUKUMUKZUJOVQNTWAWBWCWDYAJULUBZXLEUB
      ZXMEUBZXNYDUHXFUUEXRXTXCUUEXEXCJWEUBUUEDJOWGJWHWIWJVBXSUUFXTXFXRUUFXCXRUU
      FWRXEXRXCUUFXQXPXCUUFWRXCXQXPUUFXCXQXPUUFXGDXJEFLMQPWKWLWMWNWOWJWPWJXSXTU
      UGXRXFXTUUGWRZXPXFUUHWRXQXFXTXPUUGXCXTXPUUGWRWRXEXCXTXPUUGXHDXJEFLMQPWKWL
      WJWQWJWNWPXLXMKJYBEEUUDUNJUNQUUDJJUUDOUSVEWSYBVISVFVJWTXAXB @.
  @}

  @{
    @d a b c d x y z +t @.  @d a b c d x y z .t @.  @d a b c d x R @.
    glmring.1 @e |- +t = ( 1st ` R ) @.
    glmring.2 @e |- .t = ( 2nd ` R ) @.
    @( Generating a left module from a ring.  (Contributed by FL,
       29-May-2014.) @)
    glmrngo @p |- ( R e. RingOps
        -> <. <. +t , .t >. , <. +t , .t >. >. e. Vec ) @=
      ( va vb vc vd vx vy vz wcel cv co wceq wral wa wi cvv crngo cablo crn cxp
      wf cgi cfv w3a cvec wrex eqid rngoi simplll simpllr rngorn1eq cmagm cexid
      cop cin cmndo rngomndo mndomgmid syl cmpidelt simpld eleq2 imbi1d syl5ibr
      ex mpcom adantl imp adantr simplr simpr rngodi syl13anc ralrimiva rngodir
      simp1 ralimi weq oveq1 oveq1d eqeq12d oveq2 oveq2d 3exp com4r com34 com23
      rspc3v ad2antrl imp41 jca 3jca mpancom c1st fvex eqeltri c2nd 3pm3.2i wbr
      wb df-br vecval1b syl5bbr mp2an sylibr ) AUAMZBUBMZBUCZXLUDXLCUEZCUFUGZFN
      ZCOXOPZGNZXOHNZBOCOXQXOCOZXQXRCOBOPZHXLQZXQINZBOXOCOXSYBXOCOZBOPZXQYBCOZX
      OCOZXQYCCOZPZRZIXLQZRZGXLQZRZFXLQZUHZBCURZYPURUIMZXKXMRZJNZKNZCOZLNZCOZYS
      YTUUBCOZCOZPZYSYTUUBBOCOUUAYSUUBCOZBOPZYSYTBOUUBCOUUGUUDBOPZUHZLXLQZKXLQZ
      JXLQZUUAYTPYTYSCOYTPRKXLQJXLUJZRZRZXJYOJKLABCXLDEXLUKZULUUPXJRZXKXMYNXKXM
      UUOXJUMXKXMUUOXJUNUURYMFXLUURXOXLMZRZXPYLUURUUSXPXJUUSXPSZUUPXLCUCZPZXJUV
      AABCEDUOXJUVAUVCXOUVBMZXPSZXJCUPUQUSMZUVEXJCUTMUVFACEVACVBVCUVFUVDXPUVFUV
      DRXPXOXNCOXOPXOXNCUVBUVBUKXNUKVDVEVIVCUVCUUSUVDXPXLUVBXOVFVGVHVJVKVLUUTYK
      GXLUUTXQXLMZRZYAYJUVHXTHXLUVHXRXLMZRXJUVGUUSUVIXTUVHXJUVIUUPXJUUSUVGUNZVM
      UUTUVGUVIVNUURUUSUVGUVIUNUVHUVIVOXQXOXRABCXLDEUUQVPVQVRUVHYIIXLUVHYBXLMZR
      ZYDYHUVLXJUVGUVKUUSYDUVHXJUVKUVJVMUUTUVGUVKVNUVHUVKVOUURUUSUVGUVKUNXQYBXO
      ABCXLDEUUQVSVQUURUUSUVGUVKYHUUPUUSUVGUVKYHSZSSZXJUUMUVNYRUUNUUMUVGUUSUVMU
      UMUVGUVKUUSYHUUMUUFLXLQZKXLQZJXLQZUVGUVKUUSYHSSSUULUVPJXLUUKUVOKXLUUJUUFL
      XLUUFUUHUUIVTWAWAWAUVGUVKUUSUVQYHUVGUVKUUSUVQYHSUUFYHXQYTCOZUUBCOZXQUUDCO
      ZPYEUUBCOZXQYBUUBCOZCOZPJKLXQYBXOXLXLXLJGWBZUUCUVSUUEUVTUWDUUAUVRUUBCYSXQ
      YTCWCWDYSXQUUDCWCWEKIWBZUVSUWAUVTUWCUWEUVRYEUUBCYTYBXQCWFWDUWEUUDUWBXQCYT
      YBUUBCWCWGWELFWBZUWAYFUWCYGUUBXOYECWFUWFUWBYCXQCUUBXOYBCWFWGWEWLWHWIVCWJW
      KWMVMWNWOVRWOVRWOVRWPWQBTMZCTMZUWGUHZUWHYQYOXDUWGUWHUWGBAWRUGTDAWRWSWTZCA
      XAUGTEAXAWSWTZUWJXBUWKYQYPYPUIXCUWIUWHRYOYPYPUIXEGIHFBCTBCTTTXLXLUUQUUQXF
      XGXHXI @.

  @}

  @{
    @d +t u x y @.  @d -t u x y @.  @d -w u x y @.  @d .t u x y @.
    @d .w u x y @.  @d A x y @.  @d B y @.  @d R u x y @.  @d U u x y @.
    @d W u x y @.  @d X u x y @.
    vecax5c.1 @e |- X = ran +t @.
    vecax5c.2 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    vecax5c.3 @e |- -t = ( /g ` +t ) @.
    vecax5c.4 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    vecax5c.5 @e |- -w = ( /g ` +w ) @.
    vecax5c.6 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    vecax5c.7 @e |- W = ran +w @.
    vecax5c.8 @e |- .t = ( 2nd ` ( 1st ` R ) ) @.
    @( Multiplication by a difference of scalars.  (Contributed by FL,
       12-Sep-2010.) @)
    vecax5c @p |- ( ( R e. Vec /\ <. +t , .t >. e. RingOps ) -> (
        ( U e. W /\ A e. X /\ B e. X ) ->
          ( ( A -t B ) .w U ) = ( ( A .w U ) -w ( B .w U ) ) ) ) @=
      ( vx vy vu cvec wcel cop crngo wa cv co wceq wral w3a crn cfv rneqi eqtri
      c1st muldisc oveq2 oveq12d eqeq12d oveq1 oveq1d oveq2d rspc3v syl5com
      c2nd ) CUDUEGIUFUGUEUHUAUIZUBUIZHUJZUCUIZLUJZVIVLLUJZVJVLLUJZKUJZUKZUBFUL
      UAFULUCEULDEUEAFUEBFUEUMABHUJZDLUJZADLUJZBDLUJZKUJZUKZUAUBUCCEFGHIJKLFGUN
      CURUOURUOZUNMGWDNUPUQNPREJUNCVHUOURUOZUNSJWEPUPUQOQTUSVQWCVKDLUJZVIDLUJZV
      JDLUJZKUJZUKAVJHUJZDLUJZVTWHKUJZUKUCUAUBDABEFFVLDUKZVMWFVPWIVLDVKLUTWMVNW
      GVOWHKVLDVILUTVLDVJLUTVAVBVIAUKZWFWKWIWLWNVKWJDLVIAVJHVCVDWNWGVTWHKVIADLV
      CVDVBVJBUKZWKVSWLWBWOWJVRDLVJBAHUTVDWOWHWAVTKVJBDLVCVEVBVFVG @.
  @}

  @{
    @d +t k s u y @.  @d +w k s @.  @d .t k @.  @d .w s @.  @d 0t s @.
    @d 0w k s @.  @d N k s u y @.  @d R k @.  @d S1 s u y @.  @d S2 s u y @.
    @d U s @.  @d W k @.  @d X k s y @.
    svli2.1 @e |- X = ran +t @.
    svli2.2 @e |- 0t = ( GId ` +t ) @.
    svli2.7 @e |- +t = ( 1st ` ( 1st ` R ) ) @.
    svli2.3 @e |- .t = ( 2nd ` ( 1st ` R ) ) @.
    svli2.4 @e |- 0w = ( GId ` +w ) @.
    svli2.5 @e |- +w = ( 1st ` ( 2nd ` R ) ) @.
    svli2.6 @e |- W = ran +w @.
    svli2.8 @e |- .w = ( 2nd ` ( 2nd ` R ) ) @.
    @( If a finite sequence of vectors ` U ( k ) ` are linearly independant,
       two combinations of those vectors are equal iff the scalars are equal.
       (Contributed by FL, 9-Nov-2010.) @)
    svli2 @p |-
       ( ( ( R e. Vec
                /\ <. +t , .t >. e. RingOps
                /\ N e. NN )
         /\ (
                   A. k e. ( 1 ... N ) U e. W
                /\ A. k e. ( 1 ... N ) S1 e. X
                /\ A. k e. ( 1 ... N ) S2 e. X )
         /\ A. s e. ( X ^m ( 1 ... N ) )
                  ( gprod_ k e. ( 1 ... N ) +w ( ( s ` k ) .w U ) = 0w
                           -> A. k e. ( 1 ... N ) ( s ` k ) = 0t ) )
        -> (
               gprod_ k e. ( 1 ... N ) +w ( S1 .w U ) =
               gprod_ k e. ( 1 ... N ) +w ( S2 .w U )
                   <-> A. k e. ( 1 ... N ) S1 = S2 ) ) @=
      ( cvec wcel cop crngo cn w3a c1 cfz co wral cv cfv cgprd wceq wi cmap cgs
      wa wb simp11 cuz cablo elnnuz biimpi 3ad2ant3 adantr vecax1 r19.26 prodvs
      3ad2ant1 3exp com13 com12 ralimdv sylbir 3adant3 clfsebs5 syl3anc 3adant2
      imp jca eqid mvecrtol syl2anc sylanbrc fprodsub eqcomd syl eqeq1d vecax5c
      3jca r19.26-3 ex syl5bir gprodeq3d cmpt wf cgr c1st cvv fvex eqeltri c2nd
      op1st eqcomi rngogrpo grpodivcl 3expib 3adant1 syl5com 3ad2ant2 sylib crn
      fmpt rnex ovex elmap sylibr nfmpt1 nfeq2 fveq1 oveq1d a1d ralrimi imbi12d
      ralbid gprodeq3 fvmpt2 mpan2 mprg eqeq1i ralbiia imbi12i eqtri cgi 3bitrd
      ad2antrr syl6bb rspccv oveq1 ralimi adantl rneqi fveq2i cmagm cexid cmndo
      mulveczer 3expia ablogrpo grpomndo mndomgmid 3syl fincmpzer 3eqtrd impbid
      cin mpdan grpodivzer com3l ralbi syl6com impcom ) AUDUEZJKUFZUGUEZDUHUEZU
      IZBEUEZCUJDUKULZUMZHFUEZCUVMUMZIFUEZCUVMUMZUIZUVMCUNZGUNZUOZBNULZCMUPZOUQ
      ZUWBLUQZCUVMUMZURZGFUVMUSULZUMZUIZUVMHBNULZCMUPZUVMIBNULZCMUPZUQZUWMUWOMU
      TUOZULZOUQZUVMUWLUWNUWQULZCMUPZOUQZHIUQZCUVMUMZUWKUVGUWMEUEZUWOEUEZVAZUWP
      UWSVBUVGUVIUVJUVSUWJVCUVKUVSUXGUWJUVKUVSVAZUXEUXFUXHDUJVDUOUEZMVEUEZUWLEU
      EZCUVMUMZUXEUVKUXIUVSUVJUVGUXIUVIUVJUXIDVFVGVHZVIZUVKUXJUVSUVGUVIUXJUVJAM
      UAVJZVMVIZUVKUVSUXLUVGUVIUVSUXLURUVJUVSUVGUXLUVNUVPUVGUXLURZUVRUVNUVPVAUV
      LUVOVAZCUVMUMZUXQUVLUVOCUVMVKUVGUXSUXLUVGUXRUXKCUVMUXRUVGUXKUVLUVOUVGUXKU
      RUVGUVOUVLUXKUVGUVOUVLUXKHABEFJMNUAUCUBPRVLVNVOWCVPVQVPVRVSVPVMWCZUWLCMUJ
      DEUBVTWAUXHUXIUXJUWNEUEZCUVMUMZUXFUXNUXPUVKUVSUYBUVGUVIUVSUYBURUVJUVSUVGU
      YBUVNUVRUVGUYBURZUVPUVNUVRVAUVLUVQVAZCUVMUMZUYCUVLUVQCUVMVKUVGUYEUYBUVGUY
      DUYACUVMUYDUVGUYAUVLUVQUVGUYAURUVGUVQUVLUYAUVGUVQUVLUYAIABEFJMNUAUCUBPRVL
      VNVOWCVPVQVPVRWBVPVMWCZUWNCMUJDEUBVTWAWDVSAEUWMUWOMUWQOTUAUWQWEZUBWFWGUWK
      UWRUXAOUWKUXIUXKUYAVACUVMUMZUXJUIZUWRUXAUQUVKUVSUYIUWJUXHUXIUYHUXJUXNUXHU
      XLUYBUYHUXTUYFUXKUYACUVMVKWHUXPWNVSUYIUXAUWRUWLUWNUWQCMUJDEUBUYGWIWJWKWLU
      WKUXBUVMHIJUTUOZULZBNULZCMUPZOUQZUYKLUQZCUVMUMZUXDUWKUXAUYMOUWKUVMUWTUYLC
      MUVKUVSUWTUYLUQZCUVMUMZUWJUVKUVSUYRUVSUVLUVOUVQUIZCUVMUMZUVKUYRUVLUVOUVQC
      UVMWOZUVKUYSUYQCUVMUVKUYSUYQUVKUYSVAUYLUWTUVKUYSUYLUWTUQZUVGUVIUYSVUBURUV
      JHIABEFJUYJKMUWQNPRUYJWEZUAUYGUCUBSWMVSWCWJWPVQWQWCVSWRWLUWKCUVMUYKWSZUWI
      UEZUYNUYPVBUVKUVSVUEUWJUXHUVMFVUDWTZVUEUXHUYKFUEZCUVMUMZVUFUVKUVSVUHUVIUV
      GUVSVUHURUVJUVIJXAUEZUVSVUHUVHJUVHXBUOJJKJAXBUOZXBUOXCRVUJXBXDXEZKVUJXFUO
      XCSVUJXFXDXEXGXHXIZUVPUVRVUIVUHURZUVNUVPUVRVAUVOUVQVAZCUVMUMZVUMUVOUVQCUV
      MVKVUIVUOVUHVUIVUNVUGCUVMVUIUVOUVQVUGHIUYJJFPVUCXJXKVQVPVRXLXMXNWCCUVMFUY
      KVUDVUDWEZXQXOFUVMVUDFJXPXCPJVUKXRXEUJDUKXSXTYAVSUWKVUEVAZUYNUYPUWKVUEUYN
      UYPURZUWJUVKVUEVURURUVSUWHVURGVUDUWIUWAVUDUQZUWHUVMUVTVUDUOZBNULZCMUPZOUQ
      ZVUTLUQZCUVMUMZURVURVUSUWEVVCUWGVVEVUSUWDVVBOVUSUVMUWCVVACMVUSUWCVVAUQZCU
      VMCUWAVUDCUVMUYKYBYCZVUSVVFUVTUVMUEZVUSUWBVUTBNUVTUWAVUDYDZYEYFYGWRWLVUSU
      WFVVDCUVMVVGVUSUWBVUTLVVIWLYIYHVVCUYNVVEUYPVVBUYMOVVAUYLUQVVBUYMUQCUVMUVM
      VVAUYLCMYJVVHVUTUYKBNVVHUYKXCUEVUTUYKUQHIUYJXSCUVMUYKXCVUDVUPYKYLZYEYMYNV
      VDUYOCUVMVVHVUTUYKLVVJWLYOYPUUAUUBVHWCVUQUYPUYNVUQUYPVAUYMUVMLBNULZCMUPZU
      VMOCMUPZOUYPUYMVVLUQVUQUYPUVMUYLVVKCMUYOUYLVVKUQCUVMUYKLBNUUCUUDWRUUEUWKV
      VLVVMUQZVUEUYPUVKUVSVVNUWJUXHUVMVVKOCMUVKUVSVVKOUQZCUVMUMZUVGUVIUVSVVPURU
      VJUVSUVGUVIVAZVVPUVNUVPVVQVVPURUVRVVQUVNVVPVVQUVLVVOCUVMUVGUVIUVLVVOABEJK
      LNOEMXPAXFUOXBUOZXPUBMVVRUAUUFYQQRSUCOMYRUOVVRYRUOTMVVRYRUAUUGYQUUKUULVQV
      PVMVPVSWCWRVSYTUWKVVMOUQZVUEUYPUVKUVSVVSUWJUVKUXIMUUHUUIUUTUEZVVSUXMUVGUV
      IVVTUVJUVGUXJMUUJUEZVVTUXOUXJMXAUEVWAMUUMMUUNWKMUUOUUPVMOCMUJDTUUQWGVMYTU
      URWPUUSUVAUVKUVSUYPUXDVBZUWJUVSUVKVWBUVSUYTUVKVWBURVUAUVKUYTUYOUXCVBZCUVM
      UMZVWBUVIUVGUYTVWDURZUVJUVIVUIVWEVULVUIUYSVWCCUVMUYSVUIVWCUVOUVQVUIVWCURZ
      UVLUVOUVQVWFVUIUVOUVQVWCVUIUVOUVQVWCHIUYJLJFPQVUCUVBVNUVCWCXLVPVQWKXNUYOU
      XCCUVMUVDUVEVRUVFVSYSYS @.
  @}

  @c SubVec @.

  @( Extend class notation with the class of all generic subspace vector spaces
     and modules. @)
  csvec @a class SubVec @.

  @{
    @d x y v w @.
    @( A sub-vector space ` v ` of a vector space ` x ` is a vector space that
       has the same scalar set than ` x ` , whose addition and whose
       multiplication are restrictions of those of ` x ` .  (Contributed by FL,
       30-Dec-2010.) @)
    df-svs @a |- SubVec = ( x e. Vec |-> { v e. Vec |
     ( ( 1st ` v ) = ( 1st ` x ) /\
       ( 1st ` ( 2nd ` v ) ) C_ ( 1st ` ( 2nd ` x ) ) /\
       ( 2nd ` ( 2nd ` v ) ) = ( ( 2nd ` ( 2nd ` x ) ) |`
          ( ran ( 1st ` ( 1st ` x ) ) X. ran ( 1st ` ( 2nd ` v ) ) ) ) ) } ) @.

    @( A textbook definition.  A sub-vector space of a vector space ` x ` is a
       subset that is itself a vector space under the inherited operations.
       (Contributed by FL, 31-Dec-2010.) @)
    svs2 @p |- SubVec = ( x e. Vec |-> { v e. Vec |
      ( ( 1st ` v ) = ( 1st ` x ) /\
         E. w e. ~P ran ( 1st ` ( 2nd ` x ) )
         ( ( 1st ` ( 2nd ` v ) ) = ( ( 1st ` ( 2nd ` x ) ) |` ( w X. w ) ) /\
           ( 2nd ` ( 2nd ` v ) ) = ( ( 2nd ` ( 2nd ` x ) ) |`
             ( ran ( 1st ` ( 1st ` x ) ) X. w ) ) ) ) } ) @=
      ( cvec c1st cfv wceq wss cxp cres w3a wa wcel wi syl cdm ex eqtr imp 3exp
      csvec cv c2nd crn crab cmpt wrex df-svs 3anass rnss fvex rnex elpw sylibr
      cpw cgr cablo eqid vecax1 ablogrpo wfun wfo grpofo fofun funssres dmrngrp
      reseq2d eqcomd eqcoms adantr 3adant3 simp3 jca xpeq12 anidms eqeq2d xpeq2
      syl9 anbi12d rspcev syl5com com14 mpcom com12 resss sseq1 mpbiri 3ad2ant2
      dmeq dmxpid vex xpss12 sseq2 ssdmres idd com13 com3l sylancl sylbi syl6bi
      com24 3imp sylancb impcom biimpd rexlimiv impbid pm5.32da syl5bb rabbidva
      a1i mpteq2ia eqtri ) UAADCUBZEFAUBZEFZGZXNUCFZEFZXOUCFZEFZHZXRUCFZXTUCFZX
      PEFUDZXSUDZIZJZGZKZCDUEZUFADXQXSYABUBZYLIZJZGZYCYDYEYLIZJZGZLZBYAUDZUOZUG
      ZLZCDUEZUFACUHADYKUUDXODMZYJUUCCDYJXQYBYILZLUUEXNDMZLZUUCXQYBYIUIUUHXQUUF
      UUBUUHXQLZUUFUUBUUFUUIUUBYBYIUUIUUBNZYFUUAMZYBYIUUJNYBYFYTHUUKXSYAUJYFYTX
      SXREUKULUMUNUUIYBYIUUKUUBUUIYBYIUUKUUBNUUIYBYIKZXSYAYFYFIZJZGZYILZUUKUUBU
      ULUUOYIUUIYBUUOYIUUIYBUUOUUHYBUUONZXQUUEUUGUUQUUEYAUPMZUUGUUQNZUUEYAUQMUU
      RXOYAYAURUSYAUTOZUURYAVAZUUSUURYTYTIZYTYAVBUVAYAYTYTURVCUVBYTYAVDOUVAYBYA
      XSPZJZXSGZUUGUUOUVAYBUVEYAXSVEQUUGXSUPMZUVEUUONZUUGXSUQMUVFXNXSXSURUSXSUT
      OZUVFUVDUUNGUVGUVFUVCUUMYAXSVFZVGUVGUUNUVDUUNUVDGZUVEUUOUVJUVELUUNXSUUNUV
      DXSRVHQVIOOVROOSVJSVKUUIYBYIVLVMUUKUUPUUBYSUUPBYFUUAYLYFGZYOUUOYRYIUVKYNU
      UNXSUVKYMUUMYAUVKYMUUMGYLYFYLYFVNVOVGVPUVKYQYHYCUVKYPYGYDYLYFYEVQZVGVPVSV
      TQWATWBWCSWDUUBUUIUUFYSUUIUUFNBUUAYLUUAMZYSUUIUUFUVMYSUUIKYBYIYSUVMYBUUIY
      OYBYRYOYBYNYAHYAYMWEXSYNYAWFWGVJWHUVMYSUUIYIYSUVMUUIYINZYOYRUVMUVNNYOUUIU
      VMYRYIYOUUIUVMYRYINYOUUIUVMKZYRYIUVOYQYHYCUVOYPYGYDUVOUVKYPYGGYOUUIUVMUVK
      UUIYOUVMUVKNZUUHXQYOUVPNZUUGUUEXQUVQNZUVFUUGUUEUVRNZUVHUVFUVCUUMGZUUGUVSN
      ZUVIUVTUVCPZUUMPZGZUWCYFGZUWAUVCUUMWIYFWJUWDUWELUWBYFGZUWAUWBUWCYFRUUEUUG
      UWFUVRUUEUURUUGUWFUVRNNZUUTUURYAPZUVBGZUWGYAVFUWIUUGUWFUVRUWIUUGUWFKZXQYO
      UVPUVMUWJXQYOKZUVKUVMYLYTHZUWLUWKUVKNYLYTBWKUMZUWMUWLUWLLYMUVBHZUWKUVKYLY
      TYLYTWLUWJXQYOUWNUVKNUWJUWNYOXQUVKUWIUUGUWFUWNYOXQUVKNZNZNUWIUWNUWFUUGUWP
      UWNUWFUUGUWPNNZNUVBUWHUVBUWHGUWNYMUWHHZUWQUVBUWHYMWMUWRYNPZYMGZUWQYMYAWNU
      WTUWSPZYMPZGZUXBYLGZUWQUWSYMWIYLWJUXCUXDLUXAYLGZUWQUXAUXBYLRYOUWFUUGUXEUW
      OYOUWBUXAGZUWFUUGUXEUWONNZNZYOUVCUWSGUXFXSYNWIUVCUWSWIOUXHUXAUWBUXAUWBGZU
      WFUXGUXIUWFLUXAYFGZUXGUXAUWBYFRUXEUXJUUGUWOUXJUUGUWONZNYLUXAYLUXAGZUXJUXK
      UXLUXJLUVKUXKYLUXAYFRXQUUGUVKUVKUUGUVKUVKNNXQUUGUVKWOXKWPOQVIWQOQVIOWBOWR
      WSWTVIXAXBXAXBWAXCWDTTOOWPOWROWCXDSWDXBUVLOVGVPXETXASWDXBVMTXFWDXGXHXIXJX
      LXM @.

    @( A very concise definition of a subspace of a vector space.  (Contributed
       by FL, 30-Dec-2010.) @)
    svs3 @p |- SubVec = ( x e. Vec |-> { v e. Vec |
     ( ( 1st ` v ) = ( 1st ` x ) /\
       ( 1st ` ( 2nd ` v ) ) C_ ( 1st ` ( 2nd ` x ) ) /\
       ( 2nd ` ( 2nd ` v ) ) C_ ( 2nd ` ( 2nd ` x ) ) ) } ) @=
      ( cvec cv c1st cfv wceq c2nd wss crn cxp cres w3a crab cmpt wcel wa wi wf
      eqid csvec df-svs resss sseq1 mpbiri cdm vecax2 fdm eqcomd syl a1d adantl
      fveq2 rneqd eqcoms xpeq1d eqeq1d imbi2d syl5ib impcom adantr reseq2d wfun
      imp ffun ad3antrrr funssres sylan eqtr2d impbid2 pm5.32da 3anass rabbidva
      ex 3bitr4g mpteq2ia eqtri ) UAACBDZEFZADZEFZGZVRHFZEFZVTHFZEFZIZWCHFZWEHF
      ZWAEFZJZWDJZKZLZGZMZBCNZOACWBWGWHWIIZMZBCNZOABUBACWQWTVTCPZWPWSBCXAVRCPZQ
      ZWBWGWOQZQWBWGWRQZQWPWSXCWBXDXEXCWBQZWGWOWRXFWGQZWOWRWOWRWNWIIWIWMUCWHWNW
      IUDUEXGWRWOXGWRQZWNWIWHUFZLZWHXHWMXIWIXGWMXIGZWRXFWGXKWBXCWGXKRZXCXLRWAVS
      XCWGVSEFZJZWLKZXIGZRZWAVSGZXLXBXQXAXBXPWGXBXOWLWHSZXPVRWLXNWHXNTWHTWLTUGX
      SXIXOXOWLWHUHUIUJUKULXRXPXKWGXRXOWMXIXRXNWKWLXNWKGVSWAWBXMWJVSWAEUMUNUOUP
      UQURUSUOUTVDVAVBXGWIVCZWRXJWHGXAXTXBWBWGXAWKWFJZKZYAWISXTVTYAWKWIWKTWITYA
      TUGYBYAWIVEUJVFWIWHVGVHVIVNVJVKVKWBWGWOVLWBWGWRVLVOVMVPVQ @.

  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Generic algebra (new structure builder)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

@(
  df-LAlg %a |- LAlg = { f e. LMod | (
    k = ( Base ` ( Scalar ` f ) )
    v = ( Base ` f )
    a = ( +g ` f )
    s = ( .s ` f )
    m = ( vmul ` f )
    A. q e. k A. x e. v A. y e. v A. z e. v
          ( x m y ) e. v
          ( ( q s x ) m y ) = ( q s ( x m y ) )
          ( ( q s x ) m y ) = ( x m ( q s y ) )
          ( ( x a y ) m z ) = ( ( x m z ) a ( y m z ) )
          ( x m ( y a z ) ) = ( ( x m y ) a ( x m z ) )
  }
@)


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Real vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c RVec @.

  @( Extend class notation with the class of all real vector spaces. @)
  cvr @a class RVec @.

  @{
    @d g s x y z @.
    @( Define the class of all real vector spaces.  The definition of a
       ` RVec ` and a ` CVecOLD ` don't much differ.  There may be a way to get
       both in only one definition.  A ` RVec ` seems mandatory if one wants to
       do classical cartesian geometry.  We can't use a ` CVecOLD ` instead.
       Changing the field changes important properties such as the dimension.
       (Contributed by FL, 16-Nov-2008.) @)
    df-vr @a |- RVec = { <. g , s >. | ( g e. AbelOp /\
     s : ( RR X. ran g ) --> ran g /\ A. x e. ran g ( ( 1 s x ) = x /\
       A. y e. RR ( A. z e. ran g ( y s ( x g z ) ) = ( ( y s x ) g ( y s z ) )
         /\ A. z e. RR ( ( ( y + z ) s x ) = ( ( y s x ) g ( z s x ) ) /\
           ( ( y x. z ) s x ) = ( y s ( z s x ) ) ) ) ) ) } @.

    @( The class of all real vector spaces is a relation.  (Contributed by FL,
       16-Nov-2008.) @)
    vrrel @p |- Rel RVec @=
      ( vg vs vx vy vz cv cablo wcel cr crn cxp wf c1 co wceq wral caddc wa w3a
      cmul cvr df-vr relopabi ) AFZGHIUDJZKUEBFZLMCFZUFNUGODFZUGEFZUDNUFNUHUGUF
      NZUHUIUFNUDNOEUEPUHUIQNUGUFNUJUIUGUFNZUDNOUHUITNUGUFNUHUKUFNOREIPRDIPRCUE
      PSABUACDEABUBUC @.
  @}

  @{
    @d G g s x y z @.  @d S g s x y z @.  @d W g s @.  @d X g s x z @.
    vri.1 @e |- G = ( 1st ` W ) @.
    vri.2 @e |- S = ( 2nd ` W ) @.
    vri.3 @e |- X = ran G @.
    @( The properties of a real vector space, which is an abelian group (i.e.
       the vectors, with the operation of vector addition) accompanied by a
       scalar multiplication operation on the field of real numbers.  The
       variable ` W ` was chosen because ` _V ` is already used for the
       universal class.  (Contributed by FL, 16-Nov-2008.) @)
    vri @p |- ( W e. RVec ->
              ( G e. AbelOp /\
         S : ( RR X. X ) --> X /\ A. x e. X ( ( 1 S x ) = x /\
       A. y e. RR ( A. z e. X ( y S ( x G z ) ) = ( ( y S x ) G ( y S z ) )
         /\ A. z e. RR ( ( ( y + z ) S x ) = ( ( y S x ) G ( z S x ) ) /\
           ( ( y x. z ) S x ) = ( y S ( z S x ) ) ) ) ) ) ) @=
      ( vg vs cr cv co wceq wral wa oveq ralbidv cablo wcel cxp wf c1 caddc w3a
      cmul crn copab cvr c1st cfv wb eqeq2i eleq1 rneq syl6eqr eqidd xpeq2 3jca
      id feq123 oveq2d eqeq12d raleqbidv eqeq2d anbi1d anbi12d anbi2d 3anbi123d
      3syl sylbir c2nd feq1 eqeq1d oveq12d eqtrd 3anbi23d elopabi df-vr eleq2s
      ) EUAUBZMGUCZGDUDZUEANZDOZWFPZBNZWFCNZEOZDOZWIWFDOZWIWJDOZEOZPZCGQZWIWJUF
      OZWFDOZWMWJWFDOZEOZPZWIWJUHOZWFDOZWIWTDOZPZRZCMQZRZBMQZRZAGQZUGZFKNZUAUBZ
      MXNUIZUCZXPLNZUDZUEWFXROZWFPZWIWFWJXNOZXROZWIWFXROZWIWJXROZXNOZPZCXPQZWRW
      FXROZYDWJWFXROZXNOZPZXCWFXROZWIYJXROZPZRZCMQZRZBMQZRZAXPQZUGZKLUJUKUUBWCW
      DGXRUDZYAWIWKXROZYDYEEOZPZCGQZYIYDYJEOZPZYORZCMQZRZBMQZRZAGQZUGZXMKLFXNFU
      LUMZPXNEPZUUBUUPUNEUUQXNHUOUURXOWCXSUUCUUAUUOXNEUAUPUURXPGPZXRXRPZXQWDPZU
      USUGXSUUCUNUURXPEUIGXNEUQJURZUUSUUTUVAUUSUUSXRUSXPGMUTUUSVBVAXQXPWDGXRXRV
      CVLUURYTUUNAXPGUVBUURYSUUMYAUURYRUULBMUURYHUUGYQUUKUURYGUUFCXPGUVBUURYCUU
      DYFUUEUURYBWKWIXRWFWJXNESVDYDYEXNESVEVFUURYPUUJCMUURYLUUIYOUURYKUUHYIYDYJ
      XNESVGVHTVITVJVFVKVMXRFVNUMZPXRDPZUUPXMUNDUVCXRIUOUVDUUCWEUUOXLWCWDGXRDVO
      UVDUUNXKAGUVDYAWHUUMXJUVDXTWGWFUEWFXRDSVPUVDUULXIBMUVDUUGWQUUKXHUVDUUFWPC
      GUVDUUDWLUUEWOWIWKXRDSUVDYDWMYEWNEWIWFXRDSZWIWJXRDSVQVETUVDUUJXGCMUVDUUIX
      BYOXFUVDYIWSUUHXAWRWFXRDSUVDYDWMYJWTEUVEWJWFXRDSZVQVEUVDYMXDYNXEXCWFXRDSU
      VDYNWIWTXROXEUVDYJWTWIXRUVFVDWIWTXRDSVRVEVITVITVITVSVMVTABCKLWAWB @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Matrices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c +m @.
  @c xm @.
  @c .m @.

  @( Addition of matrices. @)
  cmmat @a class +m @.

  @( Scalar multiplication of matrices. @)
  csmat @a class .m @.

  @( Multiplication of matrices. @)
  cxmat @a class xm @.

  @{
    @d g h m n o j k x y @.
    @( Matrix addition.  Meaningful if ` g ` is a ` Magma ` (a binary internal
       operation) at least.  Experimental.  (Contributed by FL,
       29-Aug-2010.) @)
    df-amat @a |- +m = ( g e. _V |-> { <. <. m , n >. , o >. | E. j e. NN
       E. k e. NN ( m : ( ( 1 ... j ) X. ( 1 ... k ) ) --> dom dom g /\
        n : ( ( 1 ... j ) X. ( 1 ... k ) ) --> dom dom g /\
        o = ( x e. ( 1 ... j ) , y e. ( 1 ... k )
              |-> ( ( m ` <. x , y >. ) g ( n ` <. x , y >. ) ) ) ) } ) @.
  @}

  @{
    @d g h m a o j k x y @.
    @( Matrix left scalar multiplication.  Meaningful if ` g ` is a binary
       external operation.  Experimental.  (Contributed by FL, 29-Aug-2010.) @)
    df-smat @a |- .m = ( g e. _V |-> { <. <. m , a >. , o >. | E. j e. NN
       E. k e. NN ( m : ( ( 1 ... j ) X. ( 1 ... k ) ) --> ran dom g /\
         a e. dom dom g /\ o = ( x e. ( 1 ... j ) , y e. ( 1 ... k )
           |-> ( a g ( m ` <. x , y >. ) ) ) ) } ) @.
  @}

  @{
    @d g h f m n o j k l x y z @.
    @( Matrix multiplication.  Meaningful if ` <. g , h >. ` is a ring at
       least. ` gprod_ ` here should be ` sum_ ` (to be traditional).  But in
       set.mm ` sum_ ` is ` CC ` oriented and has a limit definition embedded
       and thus doesn't fit the needs of this generic definition.
       Experimental.  (Contributed by FL, 29-Aug-2010.) @)
    df-mmat @a |- xm = ( g e. _V , h e. _V |->
      { <. <. m , n >. , o >. | E. j e. NN E. k e. NN E. l e. NN (
          m : ( ( 1 ... j ) X. ( 1 ... k ) ) --> dom dom g /\
          n : ( ( 1 ... k ) X. ( 1 ... l ) ) --> dom dom g /\
          o = ( x e. ( 1 ... j ) , y e. ( 1 ... l )
            |-> gprod_ z e. ( 1 ... k ) g
            ( ( m ` <. x , z >. ) h ( n ` <. z , y >. ) ) ) ) } ) @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Affine spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c RAffSp @.

  @( Extend class notation with the class of all R affine spaces. @)
  craffsp @a class RAffSp @.

  @{
    @d x y t a b v @.
    @( Define a ` RR ` affine space id est a ` RR ` vector space ` x ` ( called
       the free vectors class ) together with a function ` y ` . ` y `
       associates to each vector a bijection from a set ` t ` (called the
       space) to itself (here ` t ` is retrieved from the operation.)
       Technically speaking, ` y ` is a faithful (i.e. injective) and
       transitive group action (id est a group homomorphism whose range is the
       underlying set of a symmetry group ).  Informally speaking the aim of
       all of that is to associate to each point of ` t ` a unique point of
       ` t ` through the "action" of a vector of ` x ` and thus to formalize
       the idea of translation.  When we have embedded the idea of translation
       it is easy to define a repere and thus all the cartesian geometry is
       available.  (Contributed by FL, 29-Aug-2010.) @)
    df-raffsp @a |- RAffSp = { <. x , y >. | ( x e. RVec /\ E. t
      ( y e. ( ( 1st ` x ) GrpOpHom ( SymGrp ` t ) ) /\
      y : ran ( 1st ` x ) -1-1-> t /\
     A. a e. t A. b e. t E. v e. ran ( 1st ` x ) ( ( y ` v ) ` a ) = b ) ) } @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Intervals of reals and extended reals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d A x y z @.  @d w x y z @.
    @( Membership to the set of open intervals implied the existence of two
       bounds in the set of the extended reals.  (Contributed by FL,
       31-Oct-2007.)  (Revised by Mario Carneiro, 3-Nov-2013.) @)
    bsi @p |- ( A e. ran (,) <->
      E. x e. RR* E. y e. RR* A = ( x (,) y ) ) @=
      ( cxr cxp cr cpw cioo wf wfn crn wcel cv co wceq wrex wb ioof ffn ovelrn
      mp2b ) DDEZFGZHIHUBJCHKLCAMBMHNOBDPADPQRUBUCHSABDDCHTUA @.
  @}

  @( If an open interval has an element, then ` A < B ` .  (Contributed by FL,
     14-Aug-2007.) @)
  elioo1t3 @p |- ( C e. ( A (,) B ) -> A < B ) @=
    ( cxr wcel wa cioo co clt wi elioo1 xrlttr exp3a 3com23 3expia 3impd sylbid
    wbr w3a c0 wn wceq ndmioo eleq2 noel pm2.21i syl6bi syl pm2.61i ) ADEZBDEZF
    ZCABGHZEZABIRZJZULUNCDEZACIRZCBIRZSUOABCKULUQURUSUOUJUKUQURUSUOJJZUJUQUKUTU
    JUQUKSURUSUOACBLMNOPQULUAUMTUBZUPABUCVAUNCTEZUOUMTCUDVBUOCUEUFUGUHUI @.

  @( An open interval with its upper bound equal to ` -oo ` is empty.
     (Contributed by FL, 12-Sep-2007.) @)
  oisbmi @p |- ( A (,) -oo ) = (/) @=
    ( cxr wcel cmnf wa cioo co c0 wceq cle wbr mnfle adantr ioo0 mpbird pm2.61i
    ndmioo ) ABCZDBCZEZADFGHIZTUADAJKZRUBSALMADNOADQP @.

  @( An open interval with its lower bound equal to ` +oo ` is empty.
     (Contributed by FL, 12-Sep-2007.) @)
  oisbmj @p |- ( +oo (,) A ) = (/) @=
    ( cpnf cxr wcel wa cioo co c0 wceq cle wbr pnfge adantl ioo0 mpbird pm2.61i
    ndmioo ) BCDZACDZEZBAFGHIZTUAABJKZSUBRALMBANOBAQP @.

  @( Closure of translation in a half-infinite interval.  (Contributed by FL,
     11-Sep-2007.) @)
  truni1 @p |- ( ( A e. RR* /\ D e. RR /\ 0 < D ) ->
   ( C e. ( A (,) +oo ) -> ( C + D ) e. ( A (,) +oo ) ) ) @=
    ( cxr wcel cr clt wbr cpnf caddc co wa wi ex 3ad2ant1 com12 3ad2ant2 adantl
    w3a imp cc0 cioo readdcl simpl1 rexr rexrd simpr2 ltaddpos2 biimpd com23 cc
    imp31 recn ad2antrr addcomd breqtrrd expcom 3adant1 xrlttrd ltpnf syl simp1
    3jca wb pnfxr elioo2 sylancl 3imtr4d ) ADEZCFEZUACGHZSZBFEZABGHZBIGHZSZBCJK
    ZFEZAVQGHZVQIGHZSZBAIUBKZEZVQWBEZVLVPWAVLVPLZVRVSVTVLVPVRVJVIVPVRMVKVPVJVRV
    MVNVJVRMVOVMVJVRBCUCZNOPQTWEABVQVIVJVKVPUDVPBDEZVLVMVNWGVOBUEORVLVPVQDEZVJV
    IVPWHMVKVPVJWHVMVNVJWHMVOVMVJWHVMVJLZVQWFUFNOPQTVLVMVNVOUGVLVPBVQGHZVJVKVPW
    JMVIVPVJVKLZWJVMVNWKWJMVOWKVMWJWKVMLZBCBJKZVQGVJVKVMBWMGHZVJVMVKWNVJVMVKWNM
    VJVMLVKWNCBUHUINUJULWLBCVMBUKEWKBUMRVJCUKEVKVMCUMUNUOUPUQOPURTUSVLVPVTVJVIV
    PVTMVKVPVJVTVMVNVJVTMVOVMVJVTWIVRVTWFVQUTVANOPQTVCNVLVIIDEZWCVPVDVIVJVKVBZV
    EAIBVFVGVLVIWOWDWAVDWPVEAIVQVFVGVH @.

  @( Closure of translation in a half-infinite interval.  (Contributed by FL,
     26-Jan-2009.) @)
  truni2 @p |- ( ( D e. RR /\ 0 < D ) ->
    ( C e. ( A (,) +oo ) -> ( C + D ) e. ( A (,) +oo ) ) ) @=
    ( cpnf cioo co wcel cr cc0 clt wbr wa caddc cxr eliooxr truni1 3expib com23
    wi adantr mpcom com12 ) BADEFZGZCHGZICJKZLZBCMFUCGZANGZDNGZLUDUGUHSZBADOUIU
    DUKSUJUIUGUDUHUIUEUFUDUHSABCPQRTUAUB @.

  @( Closure of translation in a half-infinite interval.  (Contributed by FL,
     26-Jan-2009.) @)
  truni3 @p |- ( ( D e. RR /\ 0 < D ) ->
    ( C e. ( -oo (,) A ) -> ( C - D ) e. ( -oo (,) A ) ) ) @=
    ( cmnf cioo co wcel cr cc0 clt wbr wa cmin cxr wi w3a 3ad2ant2 rexrd elioo2
    3imp eliooxr elioore resubcl adantrr sylan 3adant1 mnflt syl simp3l syl2anc
    simp1r ltsubpos biimpd impancom syl5com a1i syl6bi a1dd xrlttrd wb 3ad2ant1
    simp3 mpbir3and 3exp mpcom com12 ) BDAEFZGZCHGZICJKZLZBCMFZVGGZDNGZANGZLZVH
    VKVMOBDAUAVPVHVKVMVPVHVKPZVMVLHGZDVLJKZVLAJKZVHVKVRVPVHBHGZVKVRBDAUBZWAVIVR
    VJBCUCZUDUEUFZVQVRVSWDVLUGUHVQVLBAVQWAVIVLNGVHVPWAVKWBQVPVHVIVJUIWAVILVLWCR
    UJVHVPBNGVKVHBWBRQVNVOVHVKUKVPVHVKVLBJKZVHVKWEOOVPVHWAVKWEWBVIWAVJWEVIWALVJ
    WECBULUMUNUOUPTVPVHVKBAJKZVPVHWFVKVPVHWADBJKZWFPWFDABSWAWGWFVBUQURTUSVPVHVM
    VRVSVTPUTVKDAVLSVAVCVDVEVF @.

  @( The center belongs to a centered interval.  (Contributed by FL,
     5-Jan-2009.) @)
  cbci @p |- ( ( A e. RR /\ B e. RR+ ) ->
     A e. ( ( A - B ) (,) ( A + B ) ) ) @=
    ( cr wcel crp wa cmin co cxr caddc w3a clt cioo rpre resubcl sylan2 readdcl
    wbr rexrd rexr adantr 3jca ltsubrp ltaddrp jca elioo3g sylanbrc ) ACDZBEDZF
    ZABGHZIDZABJHZIDZAIDZKUKALRZAUMLRZFAUKUMMHDUJULUNUOUJUKUIUHBCDZUKCDBNZABOPS
    UIUHURUNUSUHURFUMABQSPUHUOUIATUAUBUJUPUQABUCABUDUEUKUMAUFUG @.

  @( An open interval is included in a bound below interval.  (Contributed by
     FL, 26-Jan-2009.)  (Revised by Mario Carneiro, 3-May-2015.) @)
  oibbi1 @p |- ( A (,) B ) C_ ( A (,) +oo ) @=
    ( cxr wcel wa cioo co cpnf wss cle wbr pnfxr pnfge adantl iooss2 sylancr wn
    c0 wceq ndmioo 0ss sseq1 mpbiri syl pm2.61i ) ACDZBCDZEZABFGZAHFGZIZUHHCDBH
    JKZUKLUGULUFBMNABHOPUHQUIRSZUKABTUMUKRUJIUJUAUIRUJUBUCUDUE @.

  @( An open interval is included in a bound above interval.  (Contributed by
     FL, 26-Jan-2009.) @)
  oibbi2 @p |- ( A (,) B ) C_ ( -oo (,) B ) @=
    ( cxr wcel wa cioo co cmnf wss cle wbr mnfxr mnfle adantr iooss1 sylancr wn
    c0 wceq ndmioo 0ss sseq1 mpbiri syl pm2.61i ) ACDZBCDZEZABFGZHBFGZIZUHHCDHA
    JKZUKLUFULUGAMNHABOPUHQUIRSZUKABTUMUKRUJIUJUAUIRUJUBUCUDUE @.

  @( Membership in an open interval of extended reals.  (Contributed by FL,
     7-Dec-2010.) @)
  nelioo5 @p |- ( ( A e. RR* /\ B e. RR* /\ C e. RR* )
           -> ( -. C e. ( A (,) B ) <-> ( C <_ A \/ B <_ C ) ) ) @=
    ( cxr wcel w3a cioo co wn clt wbr wa wo cle elioo5 notbid wb xrlenlt bicomd
    ianor a1i ancoms 3adant2 3adant1 orbi12d 3bitrd ) ADEZBDEZCDEZFZCABGHEZIACJ
    KZCBJKZLZIZULIZUMIZMZCANKZBCNKZMUJUKUNABCOPUOURQUJULUMTUAUJUPUSUQUTUGUIUPUS
    QUHUGUILUSUPUIUGUSUPQCARUBSUCUHUIUQUTQUGUHUILUTUQBCRSUDUEUF @.

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

@(
  %c dst %.
  %c absv %.
  %c nrm %.

  %( Extend class notation with the component of a distance. %)
  cdst %a class dst %.

  %( Extend class notation with the component of an absolute value. %)
  cabsv %a class absv %.

  %( Extend class notation with the component of a norm. %)
  cnrm2 %a class nrm %.

  %( Define the distance component of a metric space. %)
  df-dst %a |- dst = ( f e. _V |-> ( f ` ; 1 2 ) ) %.

  %( Define the absolute value component of a valued space. %)
  df-absv %a |- absv = ( f e. _V |-> ( f ` ; 1 3 ) ) %.

  %( Define the norm component of a normed space. %)
  df-norm %a |- norm = ( f e. _V |-> ( f ` ; 1 4 ) ) %.
@)

  @( A topology is not empty.  (Contributed by FL, 1-Jun-2008.) @)
  topnem @p |- ( J e. Top -> J =/= (/) ) @=
    ( ctop wcel c0 wn wne 0ntop nelne2 mpan2 ) ABCDBCEADFGADBHI @.

  @{
    clsint.1 @e |- X = U. J @.
    @( The closure of an intersection is included in the intersection of the
       closures.  (Contributed by FL, 23-Feb-2009.) @)
    clsint @p |- ( ( J e. Top /\ S C_ X /\ T C_ X )
     -> ( ( cls ` J ) ` ( S i^i T ) ) C_
     ( ( ( cls ` J ) ` S ) i^i ( ( cls ` J ) ` S ) ) ) @=
      ( ctop wcel wss w3a cin ccl cfv inss1 a1i clsss syld3an3 jca ssin sylib
      wa ) CFGZADHZBDHZIZABJZCKLZLZAUFLZHZUITUGUHUHJHUDUIUIUAUBUCUEAHZUIUJUDABM
      NAUECDEOPZUKQUGUHUHRS @.
  @}

  @{
    @d J x @.  @d P x @.  @d S x @.  @d X x @.
    islp3.1 @e |- X = U. J @.
    @( The predicate " ` P ` is a limit point of ` S ` " in terms of open sets.
       see ~ islp2 , ~ elcls , ~ islp .  (Contributed by FL, 31-Jul-2009.) @)
    islp3 @p |- ( ( J e. Top /\ S C_ X /\ P e. X ) ->
     ( P e. ( ( limPt ` J ) ` S ) <->
        A. x e. J ( P e. x -> ( x i^i ( S \ { P } ) ) =/= (/) ) ) ) @=
      ( ctop wcel wss w3a clp cfv csn cdif ccl cv cin c0 wne wb wi wral 3adant3
      islp difss simp2 syl5ss elcls syld3an2 bitrd ) DGHZCEIZBEHZJZBCDKLLHZBCBM
      ZNZDOLLHZBAPZHUSUQQRSUAADUBZUKULUOURTUMBCDEFUDUCUKUQEIULUMURUTTUNUQCECUPU
      EUKULUMUFUGABUQDEFUHUIUJ @.
  @}

  @{
    @d I u v x @.  @d J u v @.
    @( The intersection of a family of topologies is a topology.  (Contributed
       by FL, 19-Sep-2011.) @)
    inttop2 @p |- ( ( I =/= (/) /\ A. x e. I J e. Top )
      -> |^|_ x e. I J e. Top ) @=
      ( vu vv ctop wcel wral wa cv wss wi ral2imi adantl cvv wb vex eliin ax-mp
      com12 c0 wne ciin cuni wal cin uniopn ex ssiin uniex 3imtr4g r19.26 inopn
      alrimiv 3expib sylbir inex1 syl6ibr ralrimivv iinexg istopg syl mpbir2and
      syl2anb ) BUAUBZCFGZABHZIZABCUCZFGZDJZVIKZVKUDZVIGZLZDUEZVKEJZUFZVIGZEVIH
      DVIHZVHVODVHVKCKZABHZVMCGZABHZVLVNVGWBWDLVEVFWAWCABVFWAWCVKCUGUHMNABCVKUI
      VMOGVNWDPVKDQZUJAVMBCORSUKUNVHVSDEVIVIVKVIGZVQVIGZIVHVSWFVKCGZABHZVQCGZAB
      HZVHVSLWGVKOGWFWIPWEAVKBCORSVQOGWGWKPEQAVQBCORSWIWKIZVHVRCGZABHZVSWLWHWJI
      ZABHZVHWNLWHWJABULVHWPWNVGWPWNLVEVFWOWMABVFWHWJWMVKVQCUMUOMNTUPVROGVSWNPV
      KVQWEUQAVRBCORSURVDTUSVHVIOGVJVPVTIPABCFUTDEOVIVAVBVC @.
  @}

  @{
    @d J i @.
    @( The intersection of a family of topologies is a topology.  (Contributed
       by FL, 19-Sep-2011.) @)
    inttop3 @p |- ( ( J =/= (/) /\ J C_ Top )
      -> |^| J e. Top ) @=
      ( vi c0 wne ctop wss wa cint ciin intiin wcel wral dfss3 inttop2 syl5eqel
      cv sylan2b ) ACDZAEFZGAHBABPZIZEBAJSRTEKBALUAEKBAEMBATNQO @.
  @}

  @( The intersection of two topologies is a topology.  (Contributed by FL,
     19-Sep-2011.) @)
  inttop4 @p |- ( ( J e. Top /\ K e. Top )
      -> ( J i^i K ) e. Top ) @=
    ( ctop wcel wa cin cpr wss prssg biimpd cint intprg eqcomd adantl wi c0 wne
    wceq prnzg ex inttop3 syl adantr impcom eqeltrd syli pm2.43i ) ACDZBCDZEZAB
    FZCDZUJUJABGZCHZULUJUJUNABCCCIJUNUJULUNUJEUKUMKZCUJUKUORUNUJUOUKABCCLMNUJUN
    UOCDZUHUNUPOZUIUHUMPQZUQABCSURUNUPUMUATUBUCUDUETUFUG @.

  @{
    @d J x y @.  @d K x y @.
    @( The intersection of two topologies over the same underlying set ` U. J `
       is a topology over ` U. J ` . compare ~ uniin .  (Contributed by FL,
       27-Nov-2011.) @)
    unint2t @p |- ( ( J e. Top /\ K e. Top /\ U. J = U. K )
     -> U. ( J i^i K ) = U. J ) @=
      ( vx vy ctop wcel cuni wceq w3a cin uniin wss inss1 a1i syl5ss cv wi eqid
      topopn syl wrex wral wb eleq1 eqcoms elin simplbi2com syl6bi syl5com 3imp
      com3l elssuni sseq2 rspcev syl2an ralrimiva uniss2 eqssd ) AEFZBEFZAGZBGZ
      HZIZABJZGZVAVDVFVAVBJZVAABKVGVALVDVAVBMNOVDCPZDPZLZDVEUAZCAUBVAVFLVDVKCAV
      DVAVEFZVHVALZVKVHAFUSUTVCVLUSVAAFZUTVCVLQZAVAVARSUTVBBFZVNVOQBVBVBRSVCVPV
      NVLVCVPVABFZVNVLQVPVQUCVBVAVBVABUDUEVLVNVQVAABUFUGUHUKTUIUJVHAULVJVMDVAVE
      VIVAVHUMUNUOUPCDAVEUQTUR @.
  @}

  @{
    @d J a b @.  @d J a x @.  @d T a b @.  @d T a x @.
    @( The intersection of a family of topologies over the same underying set
       ` U. J ` is a topology over ` U. J ` .  (Contributed by FL,
       27-Nov-2011.) @)
    intfmu2 @p |- ( ( T C_ Top
      /\ J e. T /\ A. x e. T U. x = U. J )
         -> U. |^| T = U. J ) @=
      ( va vb ctop wss wcel cv cuni wceq wral w3a intss1 3ad2ant2 syl wa wb cvv
      cint uniss wrex wi ssel eqid topopn syl6 adantr imp eleq1 eqcoms ralimdva
      syl5ibrcom 3impia uniexg elintg mpbird elssuni sseq2 rspcev syl2an uniss2
      ralrimiva eqssd ) BFGZCBHZAIZJZCJZKZABLZMZBTZJZVIVLVMCGZVNVIGVFVEVOVKCBNO
      VMCUAPVLDIZEIZGZEVMUBZDCLVIVNGVLVSDCVLVIVMHZVPVIGZVSVPCHVLVTVIVGHZABLZVEV
      FVKWCVEVFQZVJWBABWDVGBHZQWBVJVHVGHZWDWEWFVEWEWFUCVFVEWEVGFHWFBFVGUDVGVHVH
      UEUFUGUHUIWBWFRVIVHVIVHVGUJUKUMULUNVLVISHZVTWCRVFVEWGVKCBUOOAVIBSUPPUQVPC
      URVRWAEVIVMVQVIVPUSUTVAVCDECVMVBPVD @.
  @}

  @{
    @d A v @.  @d J v @.  @d X v @.
    apnei.1 @e |- X = U. J @.
    @( Any point has a neighborhood.  (Contributed by FL, 15-Oct-2012.) @)
    apnei @p |- ( ( J e. Top /\ A e. X )
        -> E. v v e. ( ( nei ` J ) ` { A } ) ) @=
      ( ctop wcel wa cv csn cnei cfv wex wss snssi tpnei syl5ibcom impcom eleq1
      wrex rspcev syl2anc df-rex anidm exbii bitri sylib ) CFGZBDGZHZAIZBJZCKLL
      ZGZAUMTZUNAMZUJDUMGZUQUOUIUHUQUIULDNUHUQBDOULCDEPQRZURUNUQADUMUKDUMSUAUBU
      OUNUNHZAMUPUNAUMUCUSUNAUNUDUEUFUG @.
  @}

  @{
    @( A neighborhood of a point can't be empty.  (Contributed by FL,
       15-Oct-2012.) @)
    npmp @p |- ( ( J e. Top /\ A e. X /\ N e. ( ( nei ` J ) ` { A } ) )
     -> N =/= (/) ) @=
      ( ctop wcel csn cnei cfv w3a c0 wn wne simp1 snnzg 3ad2ant2 0nnei syl2anc
      wi nelne2 ex 3ad2ant3 mpd ) BEFZADFZCAGZBHIIZFZJZKUGFLZCKMZUIUDUFKMZUJUDU
      EUHNUEUDULUHADOPUFBQRUHUDUJUKSUEUHUJUKCKUGTUAUBUC @.

  @}

  @{
    @d x y z w @.
    @( A basis for the standard topology over the extended reals.  (Contributed
       by FL, 14-Sep-2013.)  (Proof shortened by Mario Carneiro,
       30-Jan-2014.) @)
    basexre @p |- ( ran (,) u. { RR* } ) e. TopBases @=
      ( vz vw vx vy cioo cxr ctb wcel cv cin wss wa wrex wral ax-mp syl wceq cr
      sseq2d anbi2d crn csn cun retopbas isbasis2g rspec wi ssun1 ssrexv ralimi
      ibi elun1 wo elun cpw cxp ioof frn sseli elpwi ressxr syl6ss elsni eqimss
      wf jaoi sylbi df-ss sylib eleq2d biimpa simpr eqimss2 adantr elequ2 sseq1
      anbi12d rspcev syldan rgen2 ineq1 rexbidv raleqbidv rspcv ee10 xrex ineq2
      jca ralsn sylibr ralun syl2anc incom syl5eq ralbidv mpbir mp2an cvv iooex
      rgen wb rnex snex unex ) EUAZFUBZUCZGHZAIZBIZHZXJCIZDIZJZKZLZBXGMZAXNNZDX
      GNZCXGNZXSCXENXSCXFNZXTXSCXEXLXEHZXRDXENZXRDXFNZXSYBXPBXEMZAXNNZDXENZYCYG
      CXEXEGHZYGCXENZUDYHYICDABXEGUEUKOUFYFXRDXEYEXQAXNXEXGKYEXQUGXEXFUHXPBXEXG
      UIOUJUJPYBXKXJXLFJZKZLZBXGMZAYJNZYDYBXLXGHXKXJXMFJZKZLZBXGMZAYONZDXGNZYNX
      LXEXFULYRDAXGYOXMXGHZXIYOHZXIXMHZYRUUAUUBUUCUUAYOXMXIUUAXMFKZYOXMQZUUAXMX
      EHZXMXFHZUMUUDXMXEXFUNUUFUUDUUGUUFXMRFUUFXMRUOZHXMRKXEUUHXMFFUPZUUHEVEXEU
      UHKUQUUIUUHEUROUSXMRUTPVAVBUUGXMFQZUUDXMFVCXMFVDPVFVGXMFVHVIZVJVKUUAUUCUU
      CXMYOKZLZYRUUAUUCLUUCUULUUAUUCVLUUAUULUUCUUAUUEUULUUKXMYOVMPVNWHYQUUMBXMX
      GXJXMQXKUUCYPUULBDAVOXJXMYOVPVQVRVSVSVTZYSYNDXLXGXMXLQZYRYMAYOYJXMXLFWAZU
      UOYQYLBXGUUOYPYKXKUUOYOYJXJUUPSTWBWCWDWEXRYNDFWFUUJXQYMAXNYJXMFXLWGZUUJXP
      YLBXGUUJXOYKXKUUJXNYJXJUUQSTWBWCWIWJXRDXEXFWKWLWTYAYTUUNXSYTCFWFXLFQZXRYS
      DXGUURXQYRAXNYOUURXNXMXLJYOXLXMWMXLFXMWGWNZUURXPYQBXGUURXOYPXKUURXNYOXJUU
      SSTWBWCWOWIWPXSCXEXFWKWQXGWRHXHXTXAXEXFEWSXBFXCXDCDABXGWRUEOWP @.
  @}

  @( The standard topology over ` RR* ` .  (Contributed by FL, 15-Sep-2013.) @)
  stovr @p |- ( topGen ` ( ran (,) u. { RR* } ) ) e. Top @=
    ( cioo crn cxr csn cun ctb wcel ctg cfv ctop basexre tgcl ax-mp ) ABCDEZFGN
    HIJGKNLM @.

  @{
    cldifemp.1 @e |- X = U. J @.
    @( The closure of a class ` S ` is empty iff ` S ` is empty.  (Contributed
       by FL, 15-Sep-2013.) @)
    cldifemp @p |- ( ( J e. Top /\ S C_ X ) ->
      ( ( ( cls ` J ) ` S ) = (/) <-> S = (/) ) ) @=
      ( ctop wcel wss wa ccl cfv c0 wceq wi sscls sseq0 syl cls0 fveq2 eqeq1d
      ex syl5ibrcom adantr impbid ) BEFZACGZHZABIJZJZKLZAKLZUFAUHGZUIUJMABCDNUK
      UIUJAUHOTPUDUJUIMUEUDUIUJKUGJZKLBQUJUHULKAKUGRSUAUBUC @.
  @}

@( End of Topology @)

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Continuous functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d x F @.  @d x J @.  @d x K @.  @d x L @.
    @( A mapping remains continuous when the topology associated to its domain
       is replaced by a finer one.  (Contributed by FL, 22-May-2008.) @)
    cnrsfin @p |- ( ( J e. Top /\ K e. Top /\ L e. Top ) ->
      ( ( F e. ( J Cn L ) /\ U. J = U. K /\ J C_ K ) -> F e. ( K Cn L ) ) ) @=
      ( ctop wcel w3a ccn co cuni wceq wss wa ctopon cfv simpl2 simpr2 sylanbrc
      istopon simpr3 eqid cnss1 syl2anc simpr1 sseldd ex ) BEFZCEFZDEFZGZABDHIZ
      FZBJZCJKZBCLZGZACDHIZFUJUPMZUKUQAURCUMNOFZUOUKUQLURUHUNUSUGUHUIUPPUJULUNU
      OQUMCSRUJULUNUOTBCDUMUMUAUBUCUJULUNUOUDUEUF @.
  @}

  @{
    @d x F @.  @d x J @.  @d x K @.  @d x L @.
    @( A mapping remains continuous when the topology associated to its range
       is replaced by a coarser one.  (Contributed by FL, 1-Jun-2008.) @)
    cnrscoa @p |- ( ( J e. Top /\ K e. Top /\ L e. Top ) ->
      ( ( F e. ( J Cn L ) /\ U. L = U. K /\ K C_ L ) ->
         F e. ( J Cn K ) ) ) @=
      ( ctop wcel w3a ccn co cuni wceq wss wa ctopon cfv simpl2 simpr2 sylanbrc
      istopon simpr3 eqid cnss2 syl2anc simpr1 sseldd ex ) BEFZCEFZDEFZGZABDHIZ
      FZDJZCJKZCDLZGZABCHIZFUJUPMZUKUQAURCUMNOFZUOUKUQLURUHUNUSUGUHUIUPPUJULUNU
      OQUMCSRUJULUNUOTBDCUMUMUAUBUCUJULUNUOUDUEUF @.
  @}

  @{
    @d A a @.  @d B a f @.  @d F a f @.  @d J a f @.
    mapdiscn2.2 @e |- B = U. J @.
    @( Any mapping whose domain is associated to the discrete topology is
       continuous.  (Contributed by FL, 19-Sep-2011.)  (Proof shortened by
       Mario Carneiro, 7-Apr-2015.) @)
    mapdiscn @p |- ( ( J e. Top /\ F : A --> B /\ A e. D ) ->
      F e. ( ~P A Cn J ) ) @=
      ( ctop wcel wf w3a cmap co cpw ccn simp2 wb topopn 3ad2ant1 simp3 syl2anc
      elmapg mpbird ctopon cfv wceq simp1 toptopon sylib cndis eleqtrrd ) EGHZA
      BDIZACHZJZDBAKLZAMENLZUNDUOHZULUKULUMOUNBEHZUMUQULPUKULURUMEBFQRUKULUMSZB
      ADECUATUBUNUMEBUCUDHZUPUOUEUSUNUKUTUKULUMUFEBFUGUHAECBUITUJ @.
  @}

  @{
    @d A x @.  @d B x @.  @d F x @.  @d J x @.
    mapudiscn.2 @e |- A = U. J @.
    mapudiscn.3 @e |- B e. _V @.
    @( Any mapping whose range is associated to the undiscrete topology is
       continuous.  (Contributed by FL, 1-Jun-2008.)  (Revised by Mario
       Carneiro, 10-Sep-2015.) @)
    mapudiscn @p |- ( ( J e. Top /\ F : A --> B ) ->
      F e. ( J Cn { (/) , B } ) ) @=
      ( ctop wcel wf wa cmap co c0 cpr ccn cvv wb topopn elmapg sylancr biimpar
      ctopon cfv wceq simpl toptopon sylib cnindis sylancl eleqtrrd ) DGHZABCIZ
      JZCBAKLZDMBNOLZUKCUNHZULUKBPHZADHUPULQFDAERBACPDSTUAUMDAUBUCHZUQUOUNUDUMU
      KURUKULUEDAEUFUGFBDPAUHUIUJ @.
  @}

  @{
    @d J g s v @.  @d X g s v @.
    sallnei.1 @e |- X = U. J @.
    @( Two ways to state the set of all the neighborhoods.  (Contributed by FL,
       2-Aug-2009.)  (Revised by Mario Carneiro, 11-Nov-2013.) @)
    sallnei @p |- ( J e. Top
                      -> U. ran ( nei ` J )
                         = { v
                           | ( v C_ X /\ E. g e. J g C_ v ) } ) @=
      ( vs ctop wcel cfv cv ciun wss wa wrex cab wceq syl vex elpw c0 cnei cuni
      crn cpw wfn neif eqcomd wral crab neival df-rab anbi1i abbii eqtri syl6eq
      fniunfv ex syl5bi ralrimiv iuneq2 iunab simpr reximi anim2i rexlimivw 0ss
      wb biantrur rexbii 0elpw anbi1d rexbidv anbi2d rspcev mpan sylan2b impbii
      sseq1 a1i abbidv syl5eq 3eqtrd ) CGHZCUAIZUCUBZFDUDZFJZWDIZKZFWFAJZDLZWGB
      JZLZWLWJLZMZBCNZMZAOZKZWKWNBCNZMZAOZWCWDWFUEZWEWIPCDEUFXCWIWEFWFWDUPUGQWC
      WHWRPZFWFUHWIWSPWCXDFWFWGWFHWGDLZWCXDWGDFRSWCXEXDWCXEMWHWPAWFUIZWRAWGBCDE
      UJXFWJWFHZWPMZAOWRWPAWFUKXHWQAXGWKWPWJDARSULUMUNUOUQURUSFWFWHWRUTQWCWSWQF
      WFNZAOXBWQFAWFVAWCXIXAAXIXAVGWCXIXAWQXAFWFWPWTWKWOWNBCWMWNVBVCVDVEWTWKTWL
      LZWNMZBCNZXIWNXKBCXJWNWLVFVHVITWFHWKXLMZXIDVJWQXMFTWFWGTPZWPXLWKXNWOXKBCX
      NWMXJWNWGTWLVRVKVLVMVNVOVPVQVSVTWAWB @.
  @}

  @{
    @d J x y z @.  @d X y @.
    nsn.1 @e |- X = U. J @.
    @( The neighborhoods of the singletons are neighborhoods.  (Contributed by
       FL, 2-Aug-2009.) @)
    nsn @p |- ( J e. Top ->
      U_ x e. X ( ( nei ` J ) ` { x } ) C_ U. ran ( nei ` J ) ) @=
      ( vy vz ctop wcel cv csn cnei cfv cuni wrex wi cpw wfn wceq neif 3syl crn
      ciun cdm eliun snelpw fndm eleq2 biimpd eqcoms syl5bi fveq2 eleq2d rspcev
      vex ex syl6 com3l rexlimiv sylbi com12 wfun wb eqid fnfun elunirn sylibrd
      ssrdv ) BGHZEACAIZJZBKLZLZUBZVKUAMZVHEIZVMHZVOFIZVKLZHZFVKUCZNZVOVNHZVPVH
      WAVPVOVLHZACNVHWAOZAVOCVLUDWCWDACVHVICHZWCWAVHWEVJVTHZWCWAOWEVJCPZHZVHWFV
      ICAUNUEVHVKWGQVTWGRWHWFOZBCDSWGVKUFWIWGVTWGVTRWHWFWGVTVJUGUHUITUJWFWCWAVS
      WCFVJVTVQVJRVRVLVOVQVJVKUKULUMUOUPUQURUSUTVHVKBMZPZQVKVAWBWAVBBWJWJVCSWKV
      KVDFVOVKVETVFVG @.
  @}

  @{
    @d A a f @.  @d A f x y @.  @d J a f @.  @d J f x y @.  @d X f x y @.
    osneisi.1 @e |- X = U. J @.
    @( The non-empty open sets are neighborhoods of the singletons.
       (Contributed by FL, 16-Jul-2009.) @)
    osneisi @p |- ( ( J e. Top /\ A =/= (/) ) -> ( A e. J ->
       A e. U_ x e. X ( ( nei ` J ) ` { x } ) ) ) @=
      ( vy vf va ctop wcel c0 wne wa cv cfv wrex wss wi wceq ex csn cvv wfn wex
      cnei ciun wral elex ac5g neeq1 fveq2 id eleq12d imbi12d rspcv pm2.27 cuni
      elunii eqcomi eleq2i elssuni syl6sseqr ad2antlr snssi jctir sseq2 anbi12d
      ssid sseq1 rspcev mpan9 adantr sneq sseq1d anbi1d rexbidva anbi2d syl5com
      jca syl5bi mpid syl6 com4l pm2.43a adantl exlimiv pm2.43i imp31 wb simpll
      3syl isnei syl2an mpbird eliun sylibr ) CIJZBKLZMZBCJZBADANZUAZCUEOOZUFJZ
      WSWTMZBXCJZADPZXDXEXGBDQZXBFNZQZXIBQZMZFCPZMZADPZWQWRWTXOWQWRWTXORRZWQCUB
      JGNZCUCZHNZKLZXSXQOZXSJZRZHCUGZMZGUDWQXPRZCIUHHCGUIYEYFGYDYFXRWTYDWQWRXOY
      DWTWQWRXORRZWTYDWRBXQOZBJZRZWTYGRYCYJHBCXSBSZXTWRYBYIXSBKUJYKYAYHXSBXSBXQ
      UKYKULUMUNUOWRYJWTWQXOWRYJYIWTWQXORZRWRYIUPYIWTYLYIWTMZWQYHCUQZJZXOYHBCUR
      YMWQYOXORYOYHDJZYMWQMZXOYNDYHDYNEUSUTYQXHYHUAZXIQZXKMZFCPZMZYPXOYQXHUUAWT
      XHYIWQWTBYNDBCVAEVBVCYMUUAWQYIYRBQZBBQZMZWTUUAYIUUCUUDYHBVDBVHVEWTUUEUUAY
      TUUEFBCXIBSYSUUCXKUUDXIBYRVFXIBBVIVGVJTVKVLVSYPUUBXOXNUUBAYHDXAYHSZXMUUAX
      HUUFXLYTFCUUFXICJZMZXJYSXKUUHXBYRXIUUFXBYRSUUGXAYHVMVLVNVOVPVQVJTVRVTTWAT
      WBWCWBWDWCWEWFWKWGWHXEXFXNADXEWQXBDQXFXNWIXADJWQWRWTWJXADVDXBFCBDEWLWMVPW
      NABDXCWOWPT @.
  @}

  @{
    elsubops.1 @e |- K = ( topGen ` ( fi ` S ) ) @.
    @( The elements of a subbase are open sets.  (Contributed by FL,
       16-Apr-2012.)  (Revised by Mario Carneiro, 14-Dec-2013.) @)
    elsubops @p |- ( S e. A -> S C_ K ) @=
      ( wcel cfi cfv ctg ssfii ctb wss fibas bastg ax-mp syl6ss syl6sseqr ) BAE
      ZBBFGZHGZCQBRSBAIRJERSKBLRJMNODP @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Homeomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( In this section every %d statement has been checked. 10-Feb-2008 @)

  @{
    @d x y z @.
    @( ` ~= ` is a relation whose domain is included in ` Top ` .  (Contributed
       by FL, 23-Mar-2007.)  (Revised by Mario Carneiro, 30-May-2014.) @)
    dmhmph @p |- dom ~= C_ Top @=
      ( vx vy chmph cdm ctop wcel wbr wex vex eldm hmphtop1 exlimiv sylbi ssriv
      cv ) ACDZEAOZPFQBOZCGZBHQEFZBQCAIJSTBQRKLMN @.

    @( ` ~= ` is a relation whose range is included in ` Top ` .  (Contributed
       by FL, 23-Mar-2007.)  (Revised by Mario Carneiro, 30-May-2014.) @)
    rnhmph @p |- ran ~= C_ Top @=
      ( vy vx chmph crn ctop wcel wbr wex vex elrn hmphtop2 exlimiv sylbi ssriv
      cv ) ACDZEAOZPFBOZQCGZBHQEFZBQCAIJSTBRQKLMN @.
  @}

  @{
    @d x y A @.  @d x y B @.  @d f g h G @.  @d f g h x y J @.
    hmeogrp.1 @e |- G = ( x e. ( J Homeo J ) , y e. ( J Homeo J ) |->
                          ( x o. y ) ) @.
    @( Lemma for ~ hmeogrp .  (Contributed by FL, 30-May-2014.) @)
    hmeogrplem @p |- ( ( A e. ( J Homeo J ) /\ B e. ( J Homeo J ) ) ->
                       ( A G B ) = ( A o. B ) ) @=
      ( chmeo co ov2gc ) ABCDFFHIZKEGJ @.

    @{
      hmeogrpi.2 @e |- J e. Top @.
      @( Lemma for ~ hmeogrp .  (Contributed by FL, 31-May-2014.) @)
      hmeogrpi @p |- G e. GrpOp @=
        ( vf vg vh cv chmeo co ccom wcel wral wf hmeoco wceq syl2anc hmeogrplem
        cid cuni cres ccnv ovex cxp ancoms rgen2a fmpt2 coass simp2 simp1 simp3
        mpbi w3a 3eqtr4a 3adant3 oveq1d 3adant1 oveq2d 3eqtr4d ctopon ctop eqid
        toptopon idhmeo ax-mp mpan wf1o hmeof1o f1of fcoi2 3syl hmeocnv mpancom
        cfv eqtrd f1ococnv1 syl isgrpoi ) GHIUADUBZUCZCGJZUDZDDKLZDDKUEAJZBJZMZ
        WENZBWEOAWEOWEWEUFWECPWIABWEWGWENWFWENWIWGWFDDDQUGUHABWEWEWHWECEUIUNWCW
        ENZHJZWENZIJZWENZUOZWCWKMZWMCLZWCWKWMMZCLZWCWKCLZWMCLWCWKWMCLZCLWOWPWMM
        ZWCWRMZWQWSWCWKWMUJWOWPWENZWNWQXBRWOWLWJXDWJWLWNUKZWJWLWNULZWKWCDDDQSWJ
        WLWNUMZABWPWMCDETSWOWJWRWENZWSXCRXFWOWNWLXHXGXEWMWKDDDQSABWCWRCDETSUPWO
        WTWPWMCWJWLWTWPRWNABWCWKCDETUQURWOXAWRWCCWLWNXAWRRWJABWKWMCDETUSUTVADWA
        VBVPNZWBWENZDVCNXIFDWAWAVDZVEUNDWAVFVGZWJWBWCCLZWBWCMZWCXJWJXMXNRXLABWB
        WCCDETVHWJWAWAWCVIZWAWAWCPXNWCRWCDDWAWAXKXKVJZWAWAWCVKWAWAWCVLVMVQWCDDV
        NZWJWDWCCLZWDWCMZWBWDWENWJXRXSRXQABWDWCCDETVOWJXOXSWBRXPWAWAWCVRVSVQVT
        @.
    @}

    @( Homeomorphisms on a topology ` J ` is a group for composition.  This
       means from Felix Klein's point of view that a set equipped with a
       topology is a geometry, namely the so-called rubber sheet geometry.
       (Contributed by FL, 3-Feb-2008.)  (Proof shortened by Mario Carneiro,
       31-May-2014.) @)
    hmeogrp @p |- ( J e. Top -> G e. GrpOp ) @=
      ( ctop wcel cgr c0 csn chmeo co cv ccom cmpt2 wceq oveq12 anidms mpt2eq12
      cif syl2anc syl5eq eleq1d eqid sn0top elimel hmeogrpi dedth ) DFGZCHGABUI
      DIJZTZUKKLZULAMBMNZOZHGDUJDUKPZCUNHUOCABDDKLZUPUMOZUNEUOUPULPZURUQUNPUOUR
      DUKDUKKQRZUSABUPUPULULUMSUAUBUCABUNUKUNUDDUJFUEUFUGUH @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Initial and final topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d i o t x y I @.  @d i t x y A @.  @d i o t x y X @.  @d o t x y F @.
    @d i o t x y K @.  @d i t y B @.
    intopcoacon.1 @e |- J = ( topGen ` ( fi ` { x | E. i e. I
        E. o e. K x = ( `' F " o ) } ) ) @.
    @{
      @d o J @.
      @( The underlying set of the initial topology is the domain of the
         mappings ` F ` .  (Contributed by FL, 24-Apr-2012.)  (Revised by Mario
         Carneiro, 25-Nov-2013.) @)
      intopcoaconlem3b @p |-
      ( ( ( I e. A /\ X e. B ) /\ I =/= (/) /\
        A. i e. I ( K e. Top /\ F : X --> U. K ) )
           -> U. J = X ) @=
        ( vt wcel wa cuni wceq wrex wss cvv wi c0 wne ctop wf wral cv ccnv cima
        w3a cab cfi cfv unieqi simp1l abrexexg adantr ralimi 3ad2ant3 abrexex2g
        ctg syl2anc elsubops topopn fimacnv eqcomd anim12i imaeq2 eqeq2d rspcev
        eqid syl syl6 reximdva0 ancoms r19.35 sylib expcom 3imp wb simp1r eqeq1
        a1i 2rexbidv elabg mpbird sseldd tg1 fiuni vex elab r19.29 cdm cnvimass
        fdm sseq1 mpbiri rexlimivw sseq2 syl5ibr adantl imp ex impcom ralrimiva
        com12 sylbi unissb sylibr sstr2 syl5com imbi1d eqcoms mpcom syl5 syl5eq
        ralrimiv ssunieq ) GBMZJCMZNZGUAUBZIUCMZJIOZFUDZNZDGUEZUIZHOAUFZFUGZEUF
        ZUHZPZEIQZDGQZAUJZUKULZUTULZOZJHYQKUMYGJYQMZLUFZJRZLYQUEZYRJPYGYOYQJYGY
        OSMZYOYQRYGXRYMAUJSMZDGUEZUUCXRXSYAYFUNYFXTUUEYAYEUUDDGYBUUDYDEAIYKUCUO
        UPUQURYMDAGBSUSVAZSYOYQYQVJVBVKYGJYOMZJYKPZEIQZDGQZXTYAYFUUJYAXTYFUUJTZ
        YAXTNYEUUITZDGQZUUKXTYAUUMXTUULDGXTDUFGMNZYEYCIMZJYIYCUHZPZNZUUIYEUURTU
        UNYBUUOYDUUQIYCYCVJVCYDUUPJJYCFVDVEVFWBUUHUUQEYCIYJYCPYKUUPJYJYCYIVGVHV
        IVLVMVNYEUUIDGVOVPVQVRYGXSUUGUUJVSXRXSYAYFVTYNUUJAJCYHJPYLUUHDEGIYHJYKW
        AWCWDVKWEWFYGUUALYQYTYQMYTYPOZRZYGUUAYTYPWGYOOZUUSPZYGUUTUUATZYGUUCUVBU
        UFYOSWHVKYGUVCTUUSUVAYGUVCUUSUVAPZYTUVARZUUATYGUVAJRZUVEUUAYGUUALYOUEUV
        FYGUUALYOYTYOMZYGUUAUVGYTYKPZEIQZDGQZYGUUATYNUVJAYTLWIYHYTPYLUVHDEGIYHY
        TYKWAWCWJYGUVJUUAYFXTUVJUUATYAYFUVJUUAYFUVJNYEUVINZDGQUUAYEUVIDGWKUVKUU
        ADGYEUVIUUAYDUVIUUATZYBYDJFWLZPZUVLYDUVMJJYCFWNVEUVIUUAUVNYTUVMRZUVHUVO
        EIUVHUVOYKUVMRFYJWMYTYKUVMWOWPWQJUVMYTWRWSVKWTXAWQVKXBURXEXFXCXDLYOJXGX
        HYTUVAJXIXJUVDUUTUVEUUAUUSUVAYTWRXKWSXLXMXNXPYSUUBNJYRLJYQXQVEVAXO @.
    @}

    intopcoacon.2 @e |- I e. A @.
    intopcoacon.3 @e |- X e. B @.
    intopcoacon.4 @e |- A. i e. I ( K e. Top /\ F : X --> U. K ) @.
    intopcoacon.5 @e |- I =/= (/) @.
    @{
      @d o J @.
      @( The underlying set of the initial topology is the domain of the
         mappings ` F ` .  (Contributed by FL, 21-Apr-2012.)  (Revised by Mario
         Carneiro, 25-Nov-2013.) @)
      intopcoaconlem3 @p |- U. J = X @=
        ( wcel wss wceq wrex cvv vy cuni cv wral ccnv cima cab elexi ctop wf wa
        rspec simpld abrexexg syl rgen abrexex2g mp2an elsubops ax-mp c0 wne wi
        r19.2zb mpbi simprd eqid topopn eqcomd imaeq2 eqeq2d rspcev expcom sylc
        fimacnv mprg eqeq1 2rexbidv mpbir sselii cfi cfv ctg fiuni sseq2 unissb
        tg1 vex cdm fdm cnvimass sseq1 mpbiri rexlimivw syl5ibr eqcoms rexlimiv
        elab 3syl sylbi mprgbir sstr2 mpi syl6bi mpsyl eleq2s ssunieq eqcomi )
        JHUBZJHPEUCZJQZEHUDJXIRAUCZFUEZXJUFZRZEISZDGSZAUGZHJXRTPZXRHQGTPXPAUGTP
        ZDGUDZXSGBLUHXTDGDUCGPZIUIPZXTYBYCJIUBZFUJZYCYEUKDGNULZUMZEAIXNUIUNUOUP
        ZXPDAGTTUQURTXRHKUSUTJXRPJXNRZEISZDGSZYJYKDGGVAVBYJDGUDYKVCOYJDGVDVEYBY
        EYDIPZYJYBYCYEYFVFZYBYCYLYGIYDYDVGVHUOYEJXMYDUFZRZYLYJVCYEYNJJYDFVOVIYL
        YOYJYIYOEYDIXJYDRXNYNJXJYDXMVJVKVLVMUOVNVPXQYKAJJCMUHXLJRXOYIDEGIXLJXNV
        QVRWRVSVTXKEHXKXJXRWAWBZWCWBZHXRUBZYPUBZRZXJYQPXJYSQZXKXSYTGBPYAXSLYHXP
        DAGBTUQURXRTWDUTXJYPWGUUAXKVCYSYRYSYRRUUAXJYRQZXKYSYRXJWEUUBYRJQZXKUUCU
        AUCZJQZUAXRUAXRJWFUUDXRPUUDXNRZEISZDGSZUUEXQUUHAUUDUAWHXLUUDRXOUUFDEGIX
        LUUDXNVQVRWRUUGUUEDGYBYEFWIZJRUUGUUEVCZYMJYDFWJUUJJUUIUUGUUEJUUIRUUDUUI
        QZUUFUUKEIUUFUUKXNUUIQFXJWKUUDXNUUIWLWMWNJUUIUUDWEWOWPWSWQWTXAXJYRJXBXC
        XDWPXEKXFUPEJHXGURXH @.
    @}

    @( The initial topology is the coarsest one making the functions ` F `
       continuous .  (Contributed by FL, 14-May-2012.)  (Revised by Mario
       Carneiro, 26-Nov-2013.) @)
    intopcoaconb @p |- J = |^| { t e. Top | A. i e. I F e. ( t Cn K ) } @=
      ( wcel wral wa cvv ccnv cima wceq wrex cab cfi cfv ctg ctop ccn cint crab
      cv co fvex eleq1 nfcv nfre1 nfab nffv nfeq2 oveq1 eleq2d ralbid ctb fibas
      anbi12d tgcl ax-mp cuni wf rspec simprd imaeq2 eqeq2d rexbii abbii fveq2i
      cbvrexv intopcoaconlem3 a1i feq2d mpbird wex wi wal w3a biimpi reximi syl
      rsp2e 3expia alrimiv wb wfn ffn fnex cnvexg sylancl adantl ralimi alexeqd
      imaexg bicomd 3syl adantr clelab sylibr wss simpl abrexexg rgen abrexex2g
      ex mp2an eqid elsubops sseli syl6 ralrimiv iscn2 sylancr mpbir2and pm3.2i
      r19.29 eleq1a imp rexlimivw syl6bi com4l imp3a com3r abssdv tgfiss syldan
      baib eqint df-rab inteqi 3eqtr4i ) AUMZGUAZFUMZUBZUCZFJUDZEHUDZAUEZUFUGZU
      HUGZBUMZUIQZGUUKJUJUNZQZEHRZSZBUEZUKZIUUOBUIULZUKUUJTQUUJUURUCUUIUHUOUUPU
      UJUIQZGUUJJUJUNZQZEHRZSBUUJTUUKUUJUCZUULUUTUUOUVCUUKUUJUIUPUVDUUNUVBEHEUU
      KUUJEUUIUHEUHUQEUUHUFEUFUQUUGEAUUFEHURUSUTUTVAUVDUUMUVAGUUKUUJJUJVBVCVDVG
      UUTUVCUUIVEQUUTUUHVFUUIVHVIZUVBEHEUMHQZUVBUUJVJZJVJZGVKZUUBUUKUBZUUJQZBJR
      ZUVFUVIKUVHGVKZUVFJUIQZUVMUVNUVMSZEHOVLVMUVFUVGKUVHGUVGKUCUVFACDEBGHUUJJK
      UUIUUAUVJUCZBJUDZEHUDZAUEZUFUGUHUUHUVSUFUUGUVRAUUFUVQEHUUEUVPFBJUUCUUKUCU
      UDUVJUUAUUCUUKUUBVNVOVSVPVQVRVRMNOPVTWAWBWCUVFUVKBJUVFUUKJQZUVJUUHQZUVKUV
      FUVTUWAUVFUVTSZUVPUUGSAWDZUWAUWBUWCUVPUUGWEZAWFZUWBUWDAUVFUVTUVPUUGUVFUVT
      UVPWGUVRUUGUVPEBHJWKUVQUUFEHUVQUUFUVPUUEBFJUUKUUCUCUVJUUDUUAUUKUUCUUBVNVO
      VSWHWIWJWLWMUVFUWCUWEWNZUVTUVFUUBTQZUVJTQZUWFUWGEHUVOEHRZUWGEHROUVOUWGEHU
      VMUWGUVNUVMGKWOZKDQZUWGKUVHGWPNUWJUWKSGTQUWGKDGWQGTWRWJWSWTXAVIVLUUBUUKTX
      CUWHUWEUWCUUGAUVJTXBXDXEXFWCUUGAUVJXGXHXNUUHUUJUVJUUHTQZUUHUUJXIHCQUUFAUE
      TQZEHRUWLMUWMEHUVFUVNUWMUVNEHUWIUVNEHROUVOUVNEHUVNUVMXJXAVIVLZFAJUUDUIXKW
      JXLUUFEAHCTXMXOTUUHUUJUUJXPXQVIXRXSXTUVFUUTUVNUVBUVIUVLSZWNUVEUWNUVBUUTUV
      NSUWOBGUUJJUVGUVHUVGXPUVHXPZYAYPYBYCXLYDUULUUOUUHUUKXIUUJUUKXIUUPUUGAUUKU
      ULUUOUUGUUAUUKQZWEUUOUUGUULUWQUUOUUGUULUWQWEZUUOUUGSUWIUUNUUFSZEHUDZUWROU
      UNUUFEHYEUWIUWTSUVOUWSSZEHUDUWRUVOUWSEHYEUXAUWREHUVOUWSUWRUVNUWSUWRWEUVMU
      VNUUNUUFUWRUULUVNUUNUUFUWQUULUVNUUNUUFUWQWEZWEUULUVNSZUUNUUKVJZUVHGVKZUUD
      UUKQZFJRZSZUXBUUNUXCUXHFGUUKJUXDUVHUXDXPUWPYAYPUXGUXBUXEUXGUUFUWQUXGUUFSU
      XFUUESZFJUDUWQUXFUUEFJYEUXIUWQFJUXFUUEUWQUUDUUKUUAYFYGYHWJXNWTYIXNYJYKXFY
      GYHWJYBXNYLYGYMUUHUUKYNYOYQVILUUSUUQUUOBUIYRYSYT @.

    @d o J @.
    @( The initial topology makes the functions ` F ` continuous.  (Contributed
       by FL, 15-Oct-2012.)  (Revised by Mario Carneiro, 26-Nov-2013.) @)
    intopcoaconc @p |- A. i e. I F e. ( J Cn K ) @=
      ( vy wcel ctop wa cvv co cv cuni wf ccnv cima wral rspec simprd crab cint
      ccn wi rsp com12 ad2antrr simprr simplr cnima syl2anc expr syld ralrimiva
      wb wfn ffn adantl fnex sylancl cnvexg imaexg 3syl elintrabg adantr mpbird
      intopcoaconb syl6eleqr wceq wrex cab cfi cfv ctg fibas tgcl ax-mp eqeltri
      ctb simpl ralimi intopcoaconlem3 eqcomi eqid iscn2 baib sylancr mpbir2and
      rgen ) FHIULUAQZDGDUBGQZWSJIUCZFUDZFUEZEUBZUFZHQZEIUGZWTIRQZXBXHXBSZDGNUH
      ZUIWTXFEIWTXDIQZSZXEFPUBZIULUAQZDGUGZPRUJUKZHXLXEXPQZXOXEXMQZUMZPRUGZXLXS
      PRXLXMRQZSXOXNXRWTXOXNUMXKYAXOWTXNXNDGUNUOUPXLYAXNXRXLYAXNSZSXNXKXRXLYAXN
      UQWTXKYBURXDFXMIUSUTVAVBVCWTXQXTVDZXKWTXIXETQZYCXJXIFTQZXCTQYDXIFJVEZJCQY
      EXBYFXHJXAFVFVGMJCFVHVIFTVJXCXDTVKVLXOPXERTVMVLVNVOAPBCDEFGHIJKLMNOVPVQVC
      WTHRQZXHWSXBXGSZVDHAUBXEVREIVSDGVSAVTZWAWBZWCWBZRKYJWHQYKRQYIWDYJWEWFWGXH
      DGXIDGUGXHDGUGNXIXHDGXHXBWIWJWFUHWSYGXHSYHEFHIJXAHUCJABCDEFGHIJKLMNOWKWLX
      AWMWNWOWPWQWR @.
  @}

  @{
    @d X x y z @.  @d J x y z @.  @d R x y z @.
    qusp.1 @e |- X = U. J @.
    qusp.2 @e |- R Er A @.
    @( A quotient space is a topology.  (Contributed by FL, 4-Jun-2007.) @)
    qusp @p |- ( J e. Top ->
      { x | ( x C_ ( X /. R ) /\ U. x e. J ) } e. Top ) @=
      ( vy vz wcel wss cuni wa wi wal wral wceq adantl sseq1 cvv cv cqs cab cin
      ctop df-ral r19.26 unissb simplr wex uniuni simpll nfa1 nfv eleq1a imim2i
      com23 imp3a sps exlimd alrimiv sylbi sylibr uniopn syl2anc syl5eqel exp31
      abss jca syl5bir syl5bi ssab vex uniex unieq anbi12d elab 3imtr4g ssinss1
      eleq1d an4 ad2antrr uniinqs ad2antrl inopn 3expib com12 impcom eqeltrd ex
      expdimp inex1 ralrimiv wb cpw bicomi a1i anbi1d abbidv ssab2 uniexg qsexg
      elpw pwexg 3syl ssexg syldan mpan istopg syl mpbir2and ) DUEJZAUAZECUBZKZ
      XMLZDJZMZAUCZUEJZHUAZXSKZYALZXSJZNZHOZYAIUAZUDZXSJZIXSPZHXSPZXLYEHXLXMYAJ
      ZXRNAOZYCXNKZYCLZDJZMZYBYDYMXRAYAPZXLYQXRAYAUFYRXOAYAPZXQAYAPZMXLYQXOXQAY
      AUGXLYSYTYQYSYNXLYTYQNAYAXNUHXLYNYTYQXLYNMZYTMZYNYPXLYNYTUIUUBYOYGXPQZYLM
      ZAUJZIUCZLZDIAYAUKUUBXLUUFDKZUUGDJXLYNYTULUUBUUEYGDJZNZIOZUUHYTUUKUUAYTYL
      XQNZAOZUUKXQAYAUFUUMUUJIUUMUUDUUIAUULAUMUUIAUNUULUUDUUINAUULUUCYLUUIUULYL
      UUCUUIXQUUCUUINYLXPDYGUOUPUQURUSUTVAVBRUUEIDVHVCUUFDVDVEVFVIVGVJURVKVJXRA
      YAVLXRYQAYCYAHVMZVNXMYCQZXOYNXQYPXMYCXNSUUOXPYODXMYCVOVTVPVQVRVAXLYJHXSYA
      XSJYAXNKZYCDJZMZXLYJXRUURAYAUUNXMYAQZXOUUPXQUUQXMYAXNSUUSXPYCDXMYAVOVTVPV
      QXLUURYJXLUURMZYIIXSUUTYGXNKZYGLZDJZMZYHXNKZYHLZDJZMZYGXSJYIXLUURUVDUVHUU
      RUVDMUUPUVAMZUUQUVCMZMZXLUVHUUPUUQUVAUVCWAXLUVKUVHXLUVKMZUVEUVGUVKUVEXLUU
      PUVEUVAUVJYAYGXNVSWBRUVLUVFYCUVBUDZDUVIUVFUVMQXLUVJEYAYGCBGWCWDUVKXLUVMDJ
      ZUVJXLUVNNUVIXLUVJUVNXLUUQUVCUVNYCUVBDWEWFWGRWHWIVIWJVKWKXRUVDAYGIVMXMYGQ
      ZXOUVAXQUVCXMYGXNSUVOXPUVBDXMYGVOVTVPVQXRUVHAYHYAYGUUNWLXMYHQZXOUVEXQUVGX
      MYHXNSUVPXPUVFDXMYHVOVTVPVQVRWMWJVKWMXLXSTJXTYFYKMWNXLXSXMXNWOZJZXQMZAUCZ
      TXLXRUVSAXLXOUVRXQXOUVRWNXLUVRXOXMXNAVMXCWPWQWRWSUVTUVQKZXLUVTTJZXQAUVQWT
      UWAXLUVQTJZUWBUWAXLMETJZXNTJUWCXLUWDUWAXLEDLTFDUEXAVFRECTXBXNTXDXEUVTUVQT
      XFXGXHWIHITXSXIXJXK @.
  @}

  @{
    @d F x @.  @d J x @.  @d K x @.  @d L x @.
    @( If ` F ` is continous over two topologies ` J ` and ` K ` then it is
       continuous over ` ( J i^i K ) ` .  (Contributed by FL, 27-Nov-2011.) @)
    intcont @p |- ( ( ( J e. Top /\ K e. Top /\ L e. Top ) /\ U. J = U. K
    /\ ( F e. ( J Cn L ) /\ F e. ( K Cn L ) ) )
    -> F e. ( ( J i^i K ) Cn L ) ) @=
      ( vx ctop wcel w3a cuni wceq ccn co wa wf wral wb eqid iscn2 baib wi ccnv
      cin cima 3adant2 adantr 3adant1 anbi12d biimp3a pm3.2an3 imp 3adant3 feq2
      cv unint2t biimpd eqcoms 3syl adantrd elin simplbi2 ral2imi anim12d com12
      a1i an4s mpcom inttop4 3ad2ant1 simp13 syl2anc mpbird ) BFGZCFGZDFGZHZBIZ
      CIZJZABDKLGZACDKLGZMZHZABCUBZDKLGZWCIZDIZANZAUAEUMUCZWCGZEDOZMZVPWFANZWHB
      GZEDOZMZVQWFANZWHCGZEDOZMZMZWBWKVOVRWAWTVOVRMVSWOVTWSVOVSWOPZVRVLVNXAVMVS
      VLVNMWOEABDVPWFVPQWFQZRSUDUEVOVTWSPZVRVMVNXCVLVTVMVNMWSEACDVQWFVQQXBRSUFU
      EUGUHWLWPWNWRWBWKTWBWLWPMZWNWRMZMWKWBXDWGXEWJWBWLWGWPWBVLVMVRHZWEVPJWLWGT
      ZVOVRXFWAVOVRXFVLVMVRXFTZVNVLVMXHVLVMVRUIUJUKUJUKBCUNXGVPWEVPWEJWLWGVPWEW
      FAULUOUPUQURXEWJTWBWNWRWJWMWQWIEDWIWMWQWHBCUSUTVAUJVDVBVCVEVFWBWCFGZVNWDW
      KPVOVRXIWAVLVMXIVNBCVGUKVHVLVMVNVRWAVIWDXIVNMWKEAWCDWEWFWEQXBRSVJVK @.
  @}

  @c topX @.

  @( Extend class notation with a function whose value is a product
     topology. @)
  ctopx @a class topX @.

  @{
    @d f y t x i @.
    @( Note: does the intersection give us the coarsest topology. Yes by
       iinss and inttop3 . It works with an empty family. The topology is
       { (/) } . @)
    @( The product topology of a family ` f ` of topologies is the coarsest
       topology over the product of the underlying sets that makes the
       projections continuous.  (Bourbaki TG I.14 ex. 3) Experimental.
       (Contributed by FL, 4-Dec-2011.) @)
    df-prtop @a |- topX = { <. f , y >. | ( f : dom f --> Top /\
       y = |^| { t e. Top | (
       U. t = X_ x e. dom f U. ( f ` x ) /\ A. i e. dom f
         ( X_ x e. dom f U. ( f ` x ) pr i ) e. ( t Cn ( f ` i ) ) ) } ) } @.
  @}

  @{
    @d A i @.  @d F i t x @.  @d I i t x @.
    @( Lemma for ~ usptop .  (Contributed by FL, 5-Dec-2011.)  (Revised by
       Mario Carneiro, 26-Jan-2015.) @)
    usptoplem @p |- ( ( F : I --> Top /\ I e. A ) -> ~P X_ x e. I U. ( F ` x )
      e. { t e. Top | ( U. t = X_ x e. I U. ( F ` x ) /\
       A. i e. I ( X_ x e. I U. ( F ` x ) pr i ) e. ( t Cn ( F ` i ) ) ) } ) @=
      ( ctop wf wcel wa cv cfv cuni wceq co ccn wral a1i cvv ax-mp cixp ffvelrn
      cpro crab unipw adantlr fvex uniex rgenw ixpexg simpr eqid fveq2 prmapcp2
      cpw unieqd sylancr mapdiscn syl3anc ralrimiva distop unieq eqeq1d ralbidv
      oveq1 eleq2d anbi12d elrab mpbiran sylanbrc ) FGEHZFCIZJZAFAKZELZMZUAZUOZ
      MZVQNZVQDKZUCOZVRWAELZPOZIZDFQZVRBKZMZVQNZWBWGWCPOZIZDFQZJZBGUDIZVTVMVQUE
      RVMWEDFVMWAFIZJZWCGIZVQWCMZWBHZVQSIZWEVKWOWQVLFGWAEUBUFWPWTWOWSVPSIZAFQWT
      XAAFVOVNEUGUHUIAFVPSUJTZVMWOUKAFVPWRVQWASVQULVNWANVOWCVNWAEUMUPUNUQWTWPXB
      RVQWRSWBWCWRULURUSUTWNVRGIZVTWFJZWTXCXBVQSVATWMXDBVRGWGVRNZWIVTWLWFXEWHVS
      VQWGVRVBVCXEWKWEDFXEWJWDWBWGVRWCPVEVFVDVGVHVIVJ @.
  @}

  @{
    @d A i @.  @d F f i t x y @.  @d I i t x @.
    @( Definition of the product topology of a family of topologies ` F ` .
       (Contributed by FL, 4-Dec-2011.)  (Revised by Mario Carneiro,
       26-Jan-2015.) @)
    istopx @p |- ( ( F : I --> Top /\ I e. A )
      -> ( topX ` F ) = |^| { t e. Top | (
        U. t = X_ x e. I U. ( F ` x ) /\ A. i e. I
          ( X_ x e. I U. ( F ` x ) pr i ) e. ( t Cn ( F ` i ) ) ) } ) @=
      ( ctop wf wcel cfv cv cuni cixp wceq cpro co ccn wral wa cvv vf crab cint
      vy ctopx cdm wi fdm fex wne wrex cpw fvex uniex rgenw ixpexg ax-mp distop
      ffvelrn adantlr simpr eqid fveq2 unieqd prmapcp2 sylancr mapdiscn syl3anc
      c0 ralrimiva unipw jctil unieq eqeq1d oveq1 eleq2d ralbidv anbi12d rspcev
      a1i rabn0 sylibr intex sylib simpl df-prtop feq1 feq2d bitrd fveq1 ixpeq2
      ralrimivw syl ixpeq1 eqtrd eqeq2d oveq1d oveq2d eleq12d raleqbidv rabbidv
      dmeq inteqd fvopab6 feq2 eleq1 eleq1d raleqbi1dv imbi12d mpbii anabsi5 )
      FGEHZFCIZEUEJZBKZLZAFAKZEJZLZMZNZXTDKZOPZXOYBEJZQPZIZDFRZSZBGUBZUCZNZXLEU
      FZFNZXLXMSZYKUGZFGEUHYMYLGEHZYLCIZSZXNXPAYLXSMZNZYSYBOPZYEIZDYLRZSZBGUBZU
      CZNZUGYOYRETIUUFTIZYPUUGYLGCEUIYRUUEVIUJZUUHYRUUDBGUKZUUIYRYSULZGIZUUKLZY
      SNZUUAUUKYDQPZIZDYLRZSZUUJYSTIZUULXSTIZAYLRUUSUUTAYLXRXQEUMUNUOAYLXSTUPUQ
      ZYSTURUQYRUUQUUNYRUUPDYLYRYBYLIZSZYDGIZYSYDLZUUAHZUUSUUPYPUVBUVDYQYLGYBEU
      SUTUVCUUSUVBUVFUVAYRUVBVAAYLXSUVEYSYBTYSVBXQYBNXRYDXQYBEVCVDVEVFUUSUVCUVA
      VTYSUVETUUAYDUVEVBVGVHVJYSVKVLUUDUURBUUKGXOUUKNZYTUUNUUCUUQUVGXPUUMYSXOUU
      KVMVNUVGUUBUUPDYLUVGYEUUOUUAXOUUKYDQVOVPVQVRVSVFUUDBGWAWBUUEWCWDYPYQWEUAK
      ZUFZGUVHHZYPUAUDEXPAUVIXQUVHJZLZMZNZUVMYBOPZXOYBUVHJZQPZIZDUVIRZSZBGUBZUC
      UUFTTUEAUDBUADWFUVHENZUVJUVIGEHYPUVIGUVHEWGUWBUVIYLGEUVHEXBZWHWIUWBUWAUUE
      UWBUVTUUDBGUWBUVNYTUVSUUCUWBUVMYSXPUWBUVMAUVIXSMZYSUWBUVLXSNZAUVIRUVMUWDN
      UWBUWEAUVIUWBUVKXRXQUVHEWJVDWLAUVIUVLXSWKWMUWBUVIYLNUWDYSNUWCAUVIYLXSWNWM
      WOZWPUWBUVRUUBDUVIYLUWCUWBUVOUUAUVQYEUWBUVMYSYBOUWFWQUWBUVPYDXOQYBUVHEWJW
      RWSWTVRXAXCXDVHYMYRYNUUGYKYMYPXLYQXMYLFGEXEYLFCXFVRYMUUFYJXNYMUUEYIYMUUDY
      HBGYMYTYAUUCYGYMYSXTXPAYLFXSWNZWPUUBYFDYLFYMUUAYCYEYMYSXTYBOUWGWQXGXHVRXA
      XCWPXIXJWMXK @.
  @}

  @{
    @d x t i F @.  @d x t i I @.  @d x t i J @.  @d x X a @.  @d A t i @.
    @d i I a @.
    istopxc.1 @e |- X = U. J @.
    @( Product of ` I ` topology ` J ` .  (Contributed by FL, 15-Sep-2013.) @)
    istopxc @p |- ( ( F : I --> { J } /\ I e. A /\ J e. Top )
      -> ( topX ` F ) = |^| { t e. Top | (
        U. t = ( X ^m I ) /\ A. i e. I
          ( ( X ^m I ) pr i ) e. ( t Cn J ) ) } ) @=
      ( vx wcel ctop cfv cv cuni wceq cpro co ccn wral wa csn wf w3a ctopx cixp
      crab cint cmap wss snssi fss sylan2 3adant2 istopx syl2anc fvconst unieqd
      simp2 syl6eqr ralrimiva 3ad2ant1 ixpeq2 syl cvv uniexg syl5eqel ixpconstg
      3adant1 eqtrd eqeq2d adantr oveq1d oveq2d eleq12d ralbidva anbi12d inteqd
      3ad2antl1 rabbidv ) EFUAZDUBZEBJZFKJZUCZDUDLZAMZNZIEIMZDLZNZUEZOZWKCMZPQZ
      WFWMDLZRQZJZCESZTZAKUFZUGZWGGEUHQZOZXBWMPQZWFFRQZJZCESZTZAKUFZUGWDEKDUBZW
      BWEXAOWAWCXJWBWCWAVTKUIXJFKUJEVTKDUKULUMWAWBWCURIABCDEUNUOWDWTXIWDWSXHAKW
      DWLXCWRXGWDWKXBWGWDWKIEGUEZXBWDWJGOZIESZWKXKOZWAWBXMWCWAXLIEWAWHEJTZWJFNZ
      GXOWIFEFWHDUPUQHUSUTVAZIEWJGVBZVCWBWCXKXBOZWAWCWBGVDJXSWCGXPVDHFKVEVFIEGB
      VDVGULVHZVIVJWDWQXFCEWDWMEJZTZWNXDWPXEYBWKXBWMPYBWKXKXBYBXMXNWDXMYAXQVKXR
      VCWDXSYAXTVKVIVLYBWOFWFRWAWBYAWOFOWCEFWMDUPVRVMVNVOVPVSVQVI @.
  @}

  @{
    @d A i t @.  @d F i t x @.  @d I i t x @.
    @( The product topology of a family ` F ` of topologies is a topology.
       (Contributed by FL, 5-Dec-2011.)  (Proof shortened by Mario Carneiro,
       26-Jan-2015.) @)
    prtoptop @p |- ( ( F : I --> Top /\ I e. A )
      -> ( topX ` F ) e. Top ) @=
      ( vt vx vi ctop wf wcel wa ctopx cfv cv cuni cixp wceq cpro co ccn cvv c0
      wral crab cint istopx wne wss fvex syl6eqelr intex sylibr inttop3 sylancl
      ssrab2 eqeltrd ) CGBHCAIJZBKLZDMZNECEMBLNOZPUSFMZQRURUTBLSRIFCUBJZDGUCZUD
      ZGEDAFBCUEZUPVBUAUFZVBGUGVCGIUPVCTIVEUPVCUQTVDBKUHUIVBUJUKVADGUNVBULUMUO
      @.
  @}

  @{
    @d A i @.  @d F a i t x @.  @d I a i t x @.
    @( The underlying set of a product topology.  (Contributed by FL,
       5-Dec-2011.) @)
    usptop @p |- ( ( F : I --> Top /\ I e. A )
      -> U. ( topX ` F ) = X_ x e. I U. ( F ` x ) ) @=
      ( vt vi va ctop wf wcel wa ctopx cfv cuni cv wceq co ccn wral a1i cpw wss
      cixp cpro crab cint istopx unieqd ssrab2 usptoplem weq unieq eqeq1d oveq1
      eleq2d ralbidv anbi12d elrab unipw eqcomi eqeq2i ad2antrl intfmu2 syl3anc
      biimpi sylbi rgen 3eqtrd ) DHCIDBJKZCLMZNEOZNZADAOCMNUCZPZVMFOZUDQZVKVOCM
      ZRQZJZFDSZKZEHUEZUFZNZVMUAZNZVMVIVJWCAEBFCDUGUHVIWBHUBZWEWBJGOZNZWFPZGWBS
      ZWDWFPWGVIWAEHUITAEBFCDUJWKVIWJGWBWHWBJWHHJZWIVMPZVPWHVQRQZJZFDSZKZKWJWAW
      QEWHHEGUKZVNWMVTWPWRVLWIVMVKWHULUMWRVSWOFDWRVRWNVPVKWHVQRUNUOUPUQURWMWJWL
      WPWMWJVMWFWIWFVMVMUSZUTVAVEVBVFVGTGWBWEVCVDWFVMPVIWSTVH @.
  @}

  @{
    @d A i o u @.  @d F i o u x @.  @d F i t u x @.  @d I i o u x @.
    @d I i t u x @.
    @( The projections are continuous.  (Contributed by FL, 18-Apr-2012.) @)
    prcnt @p |- ( ( F : I --> Top /\ I e. A ) -> A. i e. I
      ( X_ x e. I U. ( F ` x ) pr i ) e. ( ( topX ` F ) Cn ( F ` i ) ) ) @=
      ( vo vu vt ctop wf wcel wa cv cuni co ccn wral cvv wceq wi cfv cixp ctopx
      cpro ccnv cima fvex uniex rgenw ixpexg ax-mp simpr fveq2 prmapcp2 sylancr
      eqid unieqd usptop adantr feq2d mpbird wal ad2antll com12 ad2antlr simplr
      rsp imp jca ex cnima syl6 alrimiv crab cint wb istopx eleq2d ad2antrr a1i
      cnvexg syl imaexg elintg df-ral syl6bb bitrd unieq eqeq1d ralbidv anbi12d
      oveq1 elrab imbi1i albii ralrimiva prtoptop ffvelrn adantlr iscn2 syl2anc
      ovex baib mpbir2and ) EIDJZEBKZLZAEAMZDUAZNZUBZCMZUDOZDUCUAZXLDUAZPOKZCEX
      GXLEKZLZXPXNNZXONZXMJZXMUEZFMZUFZXNKZFXOQZXRYAXKXTXMJZXRXKRKZXQYGXJRKZAEQ
      YHYIAEXIXHDUGUHUIAEXJRUJUKXGXQULAEXJXTXKXLRXKUPXHXLSXIXOXHXLDUMUQUNUOXRXS
      XKXTXMXGXSXKSXQABDEURUSUTVAXRYEFXOXRYCXOKZLZYEGMZIKZYLNZXKSZXMYLXOPOZKZCE
      QZLZLZYDYLKZTZGVBZYKUUBGYKYTYQYJLZUUAYKYTUUDYKYTLYQYJYKYTYQXQYTYQTXGYJYTX
      QYQYRXQYQTYMYOYQCEVGVCVDVEVHXRYJYTVFVIVJYCXMYLXOVKVLVMYKYEYLHMZNZXKSZXMUU
      EXOPOZKZCEQZLZHIVNZKZUUATZGVBZUUCYKYEYDUULVOZKZUUOXGYEUUQVPXQYJXGXNUUPYDA
      HBCDEVQVRVSYKYDRKZUUQUUOVPYKYBRKZUURYKXMRKZUUSUUTYKXKXLUDXBVTXMRWAWBYBYCR
      WCWBUURUUQUUAGUULQUUOGYDUULRWDUUAGUULWEWFWBWGUUNUUBGUUMYTUUAUUKYSHYLIUUEY
      LSZUUGYOUUJYRUVAUUFYNXKUUEYLWHWIUVAUUIYQCEUVAUUHYPXMUUEYLXOPWLVRWJWKWMWNW
      OWFVAWPXRXNIKZXOIKZXPYAYFLZVPXGUVBXQBDEWQUSXEXQUVCXFEIXLDWRWSXPUVBUVCLUVD
      FXMXNXOXSXTXSUPXTUPWTXCXAXDWP @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Filters
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d A x @.  @d B x @.
    @( A filter containing a set ` A ` exists iff ` A ` has the finite
       intersection property (i.e. no finite intersection of elements of ` A `
       is empty).  Bourbaki TG I.37 prop. 1.  (Contributed by FL,
       20-Nov-2007.)  (Revised by Stefan O'Rear, 9-Aug-2015.) @)
    efilcp @p |- ( ( A C_ ~P B /\ B e. V /\ B =/= (/) ) ->
        ( -. (/) e. ( fi ` A ) <-> E. x e. ( Fil ` B ) A C_ x ) ) @=
      ( wss wcel c0 wne w3a cfi cfv wn wrex wi wa sseq2 rspcev syl cvv syl2anc
      cpw cv cfil wceq csn snfil 3adant1 0ss sylancl rexbidv syl5ibrcom imp a1d
      sseq1 cfg co cfbas simpl1 simprl simprr wb simpl2 fsubbas mpbir3and pwexg
      fgcl ssexg ssfii ssfg sstrd expr pm2.61dane filfbas fbasfip vex fiss mpan
      sseld con3rr3 3syl rexlimiv impbid1 ) BCUAZEZCDFZCGHZIZGBJKZFZLZBAUBZEZAC
      UCKZMZWGWJWNNBGWGBGUDZOWNWJWGWOWNWGWNWOGWKEZAWMMZWGCUEZWMFZGWREZWQWEWFWSW
      DCDUFUGWRUHWPWTAWRWMWKWRGPQUIWOWLWPAWMBGWKUNUJUKULUMWGBGHZWJWNWGXAWJOZOZC
      WHUOUPZWMFZBXDEZWNXCWHCUQKZFZXEXCXHWDXAWJWDWEWFXBURZWGXAWJUSWGXAWJUTXCWEX
      HWDXAWJIVAWDWEWFXBVBZBDCVCRVDZWHCVFRXCBWHXDXCWDWCSFZBWHEZXIXCWEXLXJCDVERW
      DXLOBSFXMBWCSVGBSVHRTXCXHWHXDEXKWHCVIRVJWLXFAXDWMWKXDBPQTVKVLWLWJAWMWKWMF
      WKXGFGWKJKZFZLWLWJNWKCVMWKCVNWLWIXOWLWHXNGWKSFWLWHXNEAVOBWKSVPVQVRVSVTWAW
      B @.
  @}

  @{
    @d A y @.  @d F x y @.
    @( A filter is closed under taking finite intersections.  (Contributed by
       FL, 27-Apr-2008.)  (Revised by Stefan O'Rear, 6-Aug-2015.) @)
    filint2 @p |- ( F e. ( Fil ` X ) -> ( ( A C_ F /\ A =/= (/) /\ A e. Fin )
           -> |^| A e. F ) ) @=
      ( cfil cfv wcel wss c0 wne cfn w3a cint cfi elfir ex filfi eleq2d sylibd
      ) BCDEZFZABGAHIAJFKZALZBMEZFZUBBFTUAUDABSNOTUCBUBBCPQR @.
  @}

  @{
    @d A y z @.  @d B y @.  @d C y z @.
    fisub.1 @e |- B = { z | E. y ( y C_ A /\ y e. Fin /\ z = |^| y ) } @.
    fisub.2 @e |- D = { z | E. y ( y C_ C /\ y e. Fin /\ z = |^| y ) } @.
    @( If a set has the finite intersection property, its subsets have also
       this property.  (Contributed by FL, 27-Apr-2008.) @)
    fisub @p |- ( C C_ A -> ( -. (/) e. B -> -. (/) e. D ) ) @=
      ( wss c0 wcel cv wceq w3a wex 0ex 3anbi3d exbidv elab2 wi cint eqeq1 sstr
      cfn biimpri 19.23bi 3exp syl expcom com4l 3imp exlimiv com12 syl5bi con3d
      wa ) ECIZJFKZJDKZURALZEIZUTUDKZJUTUAZMZNZAOZUQUSVAVBBLZVCMZNZAOVFBJFPVGJM
      ZVIVEAVJVHVDVAVBVGJVCUBZQRHSVFUQUSVEUQUSTZAVAVBVDVLUQVAVBVDUSVAUQVBVDUSTT
      ZVAUQUPUTCIZVMUTECUCVNVBVDUSVNVBVDNZUSAUSVOAOZVNVBVHNZAOVPBJDPVJVQVOAVJVH
      VDVNVBVKQRGSUEUFUGUHUIUJUKULUMUNUO @.
  @}

  @{
    @d x y z A @.  @d x y z X @.
    @( Filter generated by a subbasis ` A ` .  Bourbaki TG I.37 paragraph above
       prop. 1.  (The theorem has been slightly modified because the
       definitions of the empty set are different in Bourbaki and Metamath.)
       (Contributed by FL, 27-Apr-2008.)  (Revised by Stefan O'Rear,
       6-Aug-2015.) @)
    fgsb2 @p |- ( ( A C_ ~P X /\ X e. _V /\ A =/= (/) ) ->
    ( -. (/) e. ( fi ` A ) ->
         { x e. ~P X | E. y e. ( fi ` A ) y C_ x } e. ( Fil ` X ) ) ) @=
      ( vz cpw wss cvv wcel c0 wne w3a cfi cfv wn cfbas cv wrex crab wa cfil wb
      simpl1 simpl3 simpr simpl2 fsubbas syl mpbir3and ex cfg weq sseq2 rexbidv
      co elrab elfg vex elpw anbi1i syl6rbbr syl5bb eqrdv fgcl eqeltrd syl6 ) C
      DFZGZDHIZCJKZLZJCMNZIOZVLDPNIZBQZAQZGZBVLRZAVGSZDUANZIVKVMVNVKVMTZVNVHVJV
      MVHVIVJVMUCVHVIVJVMUDVKVMUEWAVIVNVHVJVMLUBVHVIVJVMUFCHDUGUHUIUJVNVSDVLUKU
      OZVTVNEVSWBEQZVSIWCVGIZVOWCGZBVLRZTZVNWCWBIZVRWFAWCVGAEULVQWEBVLVPWCVOUMU
      NUPVNWHWCDGZWFTWGBWCVLDUQWDWIWFWCDEURUSUTVAVBVCVLDVDVEVF @.
  @}

  @{
    @d g A @.  @d g F @.  @d g X @.  @d x y A @.  @d x y F @.  @d x y X @.
    @( Condition to have a filter finer than a given filter and containing a
       set ` A ` .  Bourbaki T.G. I.37 cor. 1 (Contributed by FL,
       27-Apr-2008.)  (Revised by Stefan O'Rear, 9-Aug-2015.) @)
    cnfilca @p |- ( ( F e. ( Fil ` X ) /\ A C_ X /\ A =/= (/) ) ->
        ( E. g e. ( Fil ` X ) ( A e. g /\ F C_ g ) <->
          A. x e. F ( x i^i A ) =/= (/) ) ) @=
      ( vy cfv wcel wss c0 wne cv wa wrex cin wral cvv wb syl 3ad2ant1 cfil w3a
      csn cun wn filtop ssexg sylan2 ancoms 3adant3 snssg anbi1d syl6bb rexbidv
      cfi unss cpw cfbas simplr simpr snfbas syl3anc fbsspw 3impa filsspw unssd
      ad2antrr 3adant1 efilcp filfbas fbunfip syl2anc ineq1 incom syl6eq neeq1d
      ssn0 wceq ralbidv ralsng bitrd 3bitr2d ) DEUAGZHZBEIZBJKZUBZBCLZHZDWHIZMZ
      CWCNBUCZDUDZWHIZCWCNZJWMUOGHUEZALZBOZJKZADPZWGWKWNCWCWGBQHZWKWNRWDWEXAWFW
      EWDXAWDWEEDHZXADEUFZBEDUGUHUIUJZXAWKWLWHIZWJMWNXAWIXEWJBWHQUKULWLDWHUPUMS
      UNWGWMEUQZIXBEJKZWPWORWGWLDXFWDWEWFWLXFIZWDWEMZWFMZWLEURGZHZXHXJWEWFXBXLW
      DWEWFUSXIWFUTWDXBWEWFXCVGBEDVAVBZEWLVCSVDWDWEDXFIWFDEVETVFWDWEXBWFXCTWEWF
      XGWDBEVQVHCWMEDVIVBWGWPFLZWQOZJKZADPZFWLPZWTWGXLDXKHZWPXRRWDWEWFXLXMVDWDW
      EXSWFDEVJTFAWLDEEVKVLWGXAXRWTRXDXQWTFBQXNBVRZXPWSADXTXOWRJXTXOBWQOWRXNBWQ
      VMBWQVNVOVPVSVTSWAWB @.
  @}

  @{
    @d F x y @.  @d G x y @.  @d X x y @.  @d Y x y @.
    @( A condition for a filter to be finer than another filter.  Compare
       ~ fgss2 .  (Contributed by FL, 8-Aug-2011.)  (Revised by Mario Carneiro,
       6-Aug-2015.) @)
    fil2ss @p |- ( ( F e. ( Fil ` X ) /\ G e. ( Fil ` X ) ) ->
        ( F C_ G <-> A. x e. F E. y e. G y C_ x ) ) @=
      ( cfbas cfv wcel wa cfil wss cv wrex wral wb filfbas cfg co wceq fgfil
      anim12i fgss2 adantr adantl sseq12d bibi1d syl5ibcom mpcom ) CEFGZHZDUIHZ
      IZCEJGZHZDUMHZIZCDKZBLALKBDMACNZOZUNUJUOUKCEPDEPUAULECQRZEDQRZKZUROUPUSAB
      CDEUBUPVBUQURUPUTCVADUNUTCSUOCETUCUOVADSUNDETUDUEUFUGUH @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    plimfil.x @e |- X = U. J @.
    @( The predicate "is a limit of a filter".  (Contributed by FL,
       5-Jan-2009.)  (Revised by Mario Carneiro, 7-Aug-2015.) @)
    plimfil @p |- ( ( J e. Top /\ F e. ( Fil ` X ) /\ L e. X ) ->
        ( L e. ( J fLim F ) <-> ( ( nei ` J ) ` { L } ) C_ F ) ) @=
      ( ctop wcel cfil cfv cflim co csn wss wb wa ctopon toptopon elflim sylanb
      cnei baibd 3impa ) BFGZADHIGZCDGZCBAJKGZCLBTIIAMZNUCUDOUFUEUGUCBDPIGUDUFU
      EUGONBDEQCABDRSUAUB @.
  @}

  @{
    @d F a @.  @d J a @.  @d L a @.  @d X a @.  @d Y a @.
    limvinlv.x @e |- X = U. J @.
    limvinlv.a @e |- A = U. ( ( J fLimf L ) ` F ) @.
    @( The limit value of a convergent function whose values are in a Hausdorff
       space belongs to the set of the limit values.  (Contributed by FL,
       14-Nov-2010.)  (Revised by Stefan O'Rear, 6-Aug-2015.) @)
    limvinlv @p |- ( ( ( J e. Haus /\ L e. ( Fil ` Y ) /\ F : Y --> X ) /\
          ( ( J fLimf L ) ` F ) =/= (/) ) -> A e. ( ( J fLimf L ) ` F ) ) @=
      ( cha wcel cfil cfv wf w3a cflf co c0 wne wa cuni csn fvex uniex snid c1o
      cen wbr wceq hausflf2 en1b sylib syl5eleqr syl5eqel ) CIJDFKLJFEBMNBCDOPZ
      LZQRSZAUOTZUOHUPUQUQUAZUOUQUOBUNUBUCUDUPUOUEUFUGUOURUHBCDEFGUIUOUJUKULUM
      @.
  @}

  @{
    @d s F @.  @d s J @.  @d s L @.  @d s N @.  @d s X @.  @d s Y @.
    flfneih.x @e |- X = U. J @.
    flfneih.a @e |- A = U. ( ( J fLimf L ) ` F ) @.
    @( A neighborhood of the limit value of a convergent function whose values
       are in a Hausdorff space contains the image of a filter element.
       (Contributed by FL, 18-Nov-2010.)  (Revised by Mario Carneiro,
       6-Aug-2015.) @)
    flfneih @p |- ( ( ( J e. Haus /\ L e. ( Fil ` Y ) /\ F : Y --> X ) /\
          ( ( J fLimf L ) ` F ) =/= (/) /\ N e. ( ( nei ` J ) ` { A } ) ) ->
        E. s e. L ( F " s ) C_ N ) @=
      ( cha wcel cfil cfv wf w3a cflf co c0 wne csn cnei cima wss wrex limvinlv
      cv 3adant3 ctop haustop 3anim1i flfneii syl3an1 syld3an2 ) CKLZDGMNLZGFBO
      ZPZABCDQRNZLZUSSTZEAUACUBNNLZBHUGUCEUDHDUEZURVAUTVBABCDFGIJUFUHURCUILZUPU
      QPUTVBVCUOVDUPUQCUJUKABCDEFGHIULUMUN @.
  @}

  @{
    limfilnei.1 @e |- X = U. J @.
    limfilnei.2 @e |- F = ( ( nei ` J ) ` { A } ) @.
    @( ` A ` is a limit of the filter of the neighborhoods of ` A ` .
       (Contributed by FL, 27-May-2011.)  (Proof shortened by Mario Carneiro,
       9-Apr-2015.) @)
    limfilnei @p |- ( ( J e. Top /\ A e. X )
      -> A e. ( J fLim F ) ) @=
      ( ctop wcel wa csn cnei cflim co ctopon toptopon neiflim sylanb syl6eleqr
      cfv oveq2i ) CGHZADHZIACAJCKSSZLMZCBLMUACDNSHUBAUDHCDEOACDPQBUCCLFTR @.
  @}

  @{
    conttnf2.1 @e |- L = ( ( nei ` J ) ` { A } ) @.
    conttnf2.2 @e |- X = U. K @.
    conttnf2.3 @e |- Y = U. J @.
    @( ` F ` is continous at point ` A ` iff ` ( F `` A ) ` is a limit of the
       image filter of the neighborhoods of ` A ` .  (Contributed by FL,
       7-Aug-2011.)  (Revised by Mario Carneiro, 6-Aug-2015.) @)
    conttnf2 @p |- ( ( J e. Top /\ K e. Top /\ ( A e. Y /\ F : Y --> X ) )
      -> ( F e. ( ( J CnP K ) ` A ) <->
         ( F ` A ) e. ( K fLim ( ( X FilMap F ) ` L ) ) ) ) @=
      ( ctop wcel wa co cfv ctopon toptopon sylib adantr 3ad2ant3 w3a ccnp cflf
      wf cfm cflim wb biid cnpflf2 syl3anb 3adant3r simp3r biantrurd cfil simp2
      wceq csn cnei wss c0 wne simp1 snssi snnzg neifil syl3anc syl5eqel flfval
      eleq2d 3bitr2d ) CKLZDKLZAGLZGFBUDZMZUAZBACDUBNOLZVNABOZBDEUCNOZLZMZVTVRD
      EFBUENOUFNZLVKVLVMVQWAUGZVNVKCGPOLZVLDFPOLZVMVMWCCGJQZDFIQZVMUHABCDEGFHUI
      UJUKVPVNVTVKVLVMVNULZUMVPVSWBVRVPWEEGUNOZLVNVSWBUPVPVLWEVKVLVOUOWGRVPEAUQ
      ZCUROOZWIHVPWDWJGUSZWJUTVAZWKWILVPVKWDVKVLVOVBWFRVOVKWLVLVMWLVNAGVCSTVOVK
      WMVLVMWMVNAGVDSTWJCGVEVFVGWHBDEFGVHVFVIVJ @.
  @}

  @{
    @d x y z F @.  @d x y z J @.  @d x y z K @.  @d x y z P @.  @d x y z X @.
    @d x y z Y @.
    @( The predicate " ` F ` is a continuous function from topology ` J ` to
       topology ` K ` at point ` P ` ." in terms of neighborhoods.
       (Contributed by FL, 18-Jul-2011.)  (Revised by Mario Carneiro,
       10-Sep-2015.) @)
    iscnp4 @p |- ( ( J e. ( TopOn ` X ) /\ K e. ( TopOn ` Y ) /\ P e. X ) ->
      ( F e. ( ( J CnP K ) ` P ) <-> ( F : X --> Y
          /\ A. y e. ( ( nei ` K ) ` { ( F ` P ) } )
          E. x e. ( ( nei ` J ) ` { P } ) ( F " x ) C_ y ) ) ) @=
      ( vz cfv wcel cv cima wss wrex wa syl syl2anc wb syl3anc ctopon w3a co wf
      ccnp csn cnei wral cnpf2 3expa 3adantl3 simplr ctop cuni simpll2 topontop
      cnt eqid neii1 sylancom ntropn simpr adantr simpll3 ffvelrn wceq toponuni
      eleqtrd snssd neiint mpbid sylibr cnpimaex simpl1 ad2antrr simprl simprrl
      fvex opnneip simprrr ntrss2 sstrd jca ex reximdv2 mpd ralrimiva wi simprr
      snss snssg mpbird imass2 eleq2 imaeq2 sseq1d anbi12d rspcev syl12anc expr
      rexlimdva embantd com23 exp4a ralimdv2 imdistanda iscnp sylibrd impbid )
      EGUAJKZFHUAJKZCGKZUBZDCEFUEUCJKZGHDUDZDALZMZBLZNZACUFZEUGJJZOZBCDJZUFZFUG
      JJZUHZPZXMXNYGXMXNPZXOYFXJXKXNXOXLXJXKXNXOCDEFGHUIUJUKZYHYBBYEYHXRYEKZPZC
      XPKZXQXRFUQJJZNZPZAEOZYBYKXNYMFKZYCYMKZYPXMXNYJULYKFUMKZXRFUNZNZYQYKXKYSX
      JXKXLXNYJUOZHFUPZQZYHYJYSUUAUUDYDFXRYTYTURZUSUTZXRFYTUUEVARYKYDYMNZYRYKYJ
      UUGYHYJVBYKYSYDYTNUUAYJUUGSUUDYKYCYTYKYCHYTYKXOXLYCHKYHXOYJYIVCXJXKXLXNYJ
      VDGHCDVERYKXKHYTVFUUBHFVGQVHVIUUFYDFXRYTUUEVJTVKYCYMCDVRWJVLAYMCDEFVMTYKY
      OXSAEYAYKXPEKZYOPZXPYAKZXSPZYKUUIPZUUJXSUULEUMKZUUHYLUUJUULXJUUMYHXJYJUUI
      XJXKXLXNVNVOGEUPZQYKUUHYOVPYKUUHYLYNVQCEXPVSTUULXQYMXRYKUUHYLYNVTYKYMXRNZ
      UUIYKYSUUAUUOUUDUUFXRFYTUUEWARVCWBWCWDWEWFWGWCWDXMYGXOYCXRKZCILZKZDUUQMZX
      RNZPZIEOZWHZBFUHZPXNXMXOYFUVDXMXOPZYBUVCBYEFUVEYJYBWHZXRFKZUUPUVBUVEUVGUU
      PPZUVFUVBUVEUVHUVFUVBWHUVEUVHPZYJYBUVBUVIYSUVGUUPYJUVIXKYSXJXKXLXOUVHUOUU
      CQUVEUVGUUPVPUVEUVGUUPWIYCFXRVSTUVIXSUVBAYAUVIUUJXSUVBUVIUUKPZXPEUQJJZEKZ
      CUVKKZDUVKMZXRNZUVBUVJUUMXPEUNZNZUVLUVJXJUUMUVEXJUVHUUKXJXKXLXOVNVOZUUNQZ
      UVJUUMUUJUVQUVSUVIUUJXSVPZXTEXPUVPUVPURZUSRZXPEUVPUWAVARUVJUVMXTUVKNZUVJU
      UJUWCUVTUVJUUMXTUVPNUVQUUJUWCSUVSUVJCUVPUVJCGUVPUVIXLUUKXJXKXLXOUVHVDVCZU
      VJXJGUVPVFUVRGEVGQVHVIUWBXTEXPUVPUWAVJTVKUVJXLUVMUWCSUWDCUVKGWKQWLUVJUVNX
      QXRUVJUVKXPNZUVNXQNUVJUUMUVQUWEUVSUWBXPEUVPUWAWARUVKXPDWMQUVIUUJXSWIWBUVA
      UVMUVOPIUVKEUUQUVKVFZUURUVMUUTUVOUUQUVKCWNUWFUUSUVNXRUUQUVKDWOWPWQWRWSWTX
      AXBWDXCXDXEXFIBCDEFGHXGXHXI @.
  @}

  @{
    cnpflf4.1 @e |- X = U. J @.
    cnpflf4.2 @e |- Y = U. K @.
    @( If ` G ` is continuous at point ` A ` , and the filter base ` F `
       converges to ` A ` then ` G ( F ) ` converges to ` G ( A ) ` .  Bourbaki
       TG I.50 cor 1.  (Contributed by FL, 19-Sep-2011.)  (Revised by Stefan
       O'Rear, 7-Aug-2015.) @)
    cnpflf4 @p |- ( ( ( K e. Top /\ F e. ( fBas ` X ) ) /\
       ( G e. ( ( J CnP K ) ` A ) /\ A e. ( J fLim ( X filGen F ) ) ) ) ->
       ( G ` A ) e. ( K fLim ( ( Y FilMap G ) ` F ) ) ) @=
      ( ctop wcel cfbas cfv wa ccnp co cfg cflim wceq syl3anc cfm simprr simprl
      cflf cnpflfi syl2anc ctopon cfil simpll toptopon sylib fgcl ad2antlr cnpf
      wf syl flfval topopn ad2antrr simplr eqid fmfg oveq2d eqtr4d eleqtrd ) EJ
      KZBFLMKZNZCADEOPMKZADFBQPZRPKZNZNZACMZCEVJUDPMZEBGCUAPZMZRPZVMVKVIVNVOKVH
      VIVKUBVHVIVKUCZACDEVJUEUFVMVOEVJVPMZRPZVRVMEGUGMKZVJFUHMKZFGCUOZVOWASVMVF
      WBVFVGVLUIEGIUJUKVGWCVFVLBFULUMVMVIWDVSACDEFGHIUNUPZCEVJGFUQTVMVQVTERVMGE
      KZVGWDVQVTSVFWFVGVLEGIURUSVFVGVLUTWEBECVJGFVJVAVBTVCVDVE @.
  @}

  @{
    @d x y z F @.  @d x y z J @.  @d x y z L @.  @d x y z X @.  @d x y z Y @.
    limfn.x @e |- X = U. J @.
    @( The limits of a function are elements of its range.  (Contributed by FL,
       15-Oct-2012.)  (Revised by Stefan O'Rear, 7-Aug-2015.) @)
    limfn @p |- ( ( J e. Top /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( ( J fLimf L ) ` F ) C_ X ) @=
      ( vx vy vz ctop wcel cfil cfv wf w3a cflf co cv cima wss wrex wral ctopon
      wi wa wb toptopon isflf syl3an1b simpl syl6bi ssrdv ) BJKZCELMKZEDANZOZGA
      BCPQMZDUPGRZUQKZURDKZURHRZKAIRSVATICUAUDHBUBZUEZUTUMBDUCMKUNUOUSVCUFBDFUG
      URHABCDEIUHUIUTVBUJUKUL @.

    @( If ` A ` is a limit of a function ` F ` , ` A ` is an element of the
       range of ` F ` .  (Contributed by FL, 15-Oct-2012.)  (Revised by Mario
       Carneiro, 29-Jul-2015.) @)
    limfn2 @p |- ( ( J e. Top /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( A e. ( ( J fLimf L ) ` F ) -> A e. X ) ) @=
      ( ctop wcel cfil cfv wf w3a cflf co limfn sseld ) CHIDFJKIFEBLMBCDNOKEABC
      DEFGPQ @.

    limfn3.a @e |- A = U. ( ( J fLimf L ) ` F ) @.
    @( If ` A ` is the limit of a convergent function in a Hausdorff space,
       ` A ` is an element of the range of the function.  (Contributed by FL,
       15-Oct-2012.)  (Revised by Mario Carneiro, 7-Aug-2015.) @)
    limfn3 @p |- ( ( J e. Haus /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
        ( ( ( J fLimf L ) ` F ) =/= (/) -> A e. X ) ) @=
      ( cha wcel cfil cfv wf w3a cflf co c0 wne limvinlv ex wss haustop syl3an1
      ctop limfn sseld syld ) CIJZDFKLJZFEBMZNZBCDOPLZQRZAULJZAEJUKUMUNABCDEFGH
      STUKULEAUHCUDJUIUJULEUACUBBCDEFGUEUCUFUG @.
  @}

  @{
    @d A o o' s @.  @d F o o' s @.  @d G o o' s @.  @d J o o' s @.
    @d K o o' s @.  @d L o o' s @.  @d X o o' s @.  @d Y o o' s @.
    cmptdst.y @e |- Y = U. J @.
    @( ` G o. F ` tends to ` G ( A ) ` if ` G ` is continuous at point ` A `
       and ` F ` tends to A .  Bourbaki TG I.50 cor. 2.  (Contributed by FL,
       15-Oct-2012.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
    cmptdst @p |- ( ( ( J e. Top /\ K e. Top /\ L e. ( Fil ` X ) ) /\ ( F : X
    --> Y /\ A e. ( ( J fLimf L ) ` F ) /\ G e. ( ( J CnP K ) ` A ) ) )
    -> ( G ` A ) e. ( ( K fLimf L ) ` ( G o. F ) ) ) @=
      ( vo vs bnjvom wcel cfv w3a wa cima wss wrex wi ctop cfil wf cflf co ccnp
      ccom cuni wral simpr3 eqid syl ctopon simpl1 toptopon sylib simpl3 simpr1
      cv cnpf simpr2 flfelbas syl31anc ffvelrn syl2anc syl3anc ccnv simpl2 biid
      isflf iscnp3 syl3anb biimpd rsp impcom r19.29r pm3.35 sstr imaco wfun cdm
      wb ffun 3ad2ant2 adantr crn imassrn frn 3ad2ant1 wceq fdm sseqtr4d syl5ss
      3exp adantl 3adant1 funimass3 bicomd biimpcd anabsi5 syl5eqss 3exp1 com4l
      ex 3imp com24 com23 reximdvai com12 3expd imp31 rexlimiv com5l com13 syl9
      imp com3l syl6 pm2.43b 3ad2ant3 anabsi7 sylbid mpd ralrimiv fco mpbir2and
      ) DUAMZEUAMZFGUBNMZOZGHBUCZABDFUDUENMZCADEUFUENMZOZPZACNZCBUGZEFUDUENMZYP
      EUHZMZYPJUSZMZYQKUSZQZUUARZKFSZTZJEUIZYOHYSCUCZAHMZYTYOYMUUIYJYKYLYMUJACD
      EHYSIYSUKZUTULZYODHUMNMZYIYKYLUUJYOYGUUMYGYHYIYNUNZDHIUOZUPZYGYHYIYNUQZYJ
      YKYLYMURZYJYKYLYMVAZABDFHGVBVCZHYSACVDVEYOUUGJEYOYLUUAEMZUUGTZUUSYOYLUUJA
      LUSZMZBUUCQZUVCRZKFSZTZLDUIZPZUVBYOUUMYIYKYLUVJWBUUPUUQUURALBDFHGKVJVFYJY
      NUVJUVBTZYMYKYOUVKTZYLYMYOUVKYOYMUUIUUBUVDUVCCVGUUAQZRZPZLDSZTZJEUIZPZUVL
      YOYGYHUUJYMUVSTUUNYGYHYIYNVHZUUTYGYHUUJOYMUVSYGUUMYHEYSUMNMZUUJUUJYMUVSWB
      UUOEYSUUKUOZUUJVILJACDEHYSVKVLVMVFUVRUUIUVLUVRUUIYOUVJUVBUVAUVRUUIYOUVJOZ
      UUGUVAUVRUWCUUGTUVAUVRPUUBUVPUWCUUFUVRUVAUVQUVQJEVNVOUUIYOUVJUVPUUFTZUVJY
      OUUIUWDUVIUUJYOUUIUWDTTUVPUVIUUJYOUUIUUFUVPUVIUUJYOUUIUUFTTZTZUVPUVIPUVOU
      VHPZLDSUWFUVOUVHLDVPUWGUWFLDUWGUVCDMZUWFUVDUVNUVHUWHUWFTZUVDUVHUVNUWIUVDU
      VHUVNUWITZUVDUVHPUVGUWJUVDUVGVQUVGUVNUWHUUJUWEUVGUVNUWHUUJOZYOUUIUUFUWKYO
      UUIOZUVGUUFUWLUVFUUEKFUWLUVFUUCFMZUUEUWKYOUUIUVFUWMUUETZTUWKUVFUUIYOUWNUV
      NUWHUUJUVFUUIYOUWNTTZTUVFUVNUWHUUJUWOUVFUVNUWHUUJUWOTTZUVFUVNPUVEUVMRZUWP
      UVEUVCUVMVRUWQUWHUUJUWOUWQUWHUUJOZUUIYOUWMUUEUWRUUIYOOZUWMPZUUDCUVEQZUUAC
      BUUCVSUWSUWMUXAUUARZUWRUUIUWTUXBTZYOUWQUWHUXCUUJUWTUWQUXBUWTCVTZUVECWAZRZ
      UWQUXBWBUWSUXDUWMUUIUWRUXDYOHYSCWCWDWEUWSUWMUXFUUIYOUWMUXFTZUWRYOUUIUXGYN
      UUIUXGTZYJYKYLUXHYMYKUUIUWMUXFYKUUIUWMOZUVEBWFZUXEBUUCWGUXIUXJHUXEYKUUIUX
      JHRUWMGHBWHWIUUIYKUXEHWJUWMHYSCWKWDWLWMWNWIWOVOWPXPUXDUXFPUXBUWQUVEUUACWQ
      WRVEWSWIWIWTXAXBWNULXDXCXEXFXEXGXHXIXJXJULXDXGXKXIXLULXDXMVOXNXEXOXDXQXJV
      OXRXSXTYAYBYCYDYOUWAYIGYSYQUCZYRYTUUHPWBYOYHUWAUVTUWBUPUUQYOUUIYKUXKUULUU
      RGHYSCBYEVEYPJYQEFYSGKVJVFYF @.
  @}

  @{
    @d A x @.  @d B x @.
    @( If ` A ` is an element of ` B ` and ` B ` has a unique element,
       ` U. B = A ` .  (Contributed by FL, 15-Oct-2012.) @)
    unexun @p |- ( ( A e. B /\ E! x x e. B ) -> U. B = A ) @=
      ( cv wcel weu c1o cen wbr cuni euen1b wa csn en1eqsn unieqd unisng adantr
      wceq eqtrd sylan2br ) ADCEAFBCEZCGHIZCJZBRACKUAUBLZUCBMZJZBUDCUEBCNOUAUFB
      RUBBCPQST @.
  @}

  @{
    @d F x @.  @d J x @.  @d L x @.  @d X x @.  @d Y x @.  @d A x @.
    limhun.x @e |- X = U. J @.
    limhun.l1 @e |- L1 = U. ( ( J fLimf L ) ` F ) @.
    @( In a Hausdorff space if ` A ` is a limit of a convergent function
       ` F ` , then ` A ` is the unique limit of ` F ` .  (Contributed by FL,
       15-Oct-2012.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
    limhun @p |- ( ( ( J e. Haus /\ L e. ( Fil ` Y ) /\ F : Y --> X ) /\
         A e. ( ( J fLimf L ) ` F ) ) -> L1 = A ) @=
      ( cha wcel cfil cfv wf w3a cflf co wa cuni wceq csn simpr c1o cen wbr wne
      c0 ne0i hausflf2 sylan2 en1b sylib eleqtrd elsni syl syl6reqr ) CJKDFLMKF
      EBNOZABCDPQMZKZRZAURSZGUTAVAUAZKAVATUTAURVBUQUSUBUTURUCUDUEZURVBTUSUQURUG
      UFVCURAUHBCDEFHUIUJURUKULUMAVAUNUOIUP @.
  @}

  @{
    cmptdst2.y @e |- Y = U. J @.
    cmptdst2.l1 @e |- L1 = U. ( ( J fLimf L ) ` F ) @.
    cmptdst2.l2 @e |- L2 = U. ( ( K fLimf L ) ` ( G o. F ) ) @.
    @( ` G o. F ` tends to ` G ( L1 ) ` if ` G ` is continuous at point ` L1 `
       and ` F ` tends to ` L1 ` .  ( ~ cmptdst in the Hausdorff case.)
       Bourbaki TG I.50 cor. 2.  (Contributed by FL, 15-Oct-2012.)  (Revised by
       Mario Carneiro, 8-Aug-2015.) @)
    cmptdst2 @p |- ( ( ( J e. Haus /\ K e. Haus /\ L e. ( Fil ` X ) ) /\ ( F :
        X
    --> Y /\ ( ( J fLimf L ) ` F ) =/= (/) /\ G e. ( ( J CnP K ) ` L1 ) ) )
    -> L2 = ( G ` L1 ) ) @=
      ( cha wcel cfv w3a wf cflf co ctop cfil c0 wne ccnp cuni ccom wceq simpl2
      wa simpl3 simpr3 eqid cnpf syl simpr1 syl2anc haustop id 3anim123i adantr
      fco simpl1 simpr2 limvinlv syl31anc cmptdst syl13anc limhun ) CMNZDMNZEFU
      AONZPZFGAQZACERSOZUBUCZBHCDUDSONZPZUIZVJVKFDUEZBAUFZQZHBOZVTDERSONZIWBUGV
      IVJVKVQUHVIVJVKVQUJZVRGVSBQZVMWAVRVPWEVLVMVOVPUKZHBCDGVSJVSULZUMUNVLVMVOV
      PUOZFGVSBAVAUPVRCTNZDTNZVKPZVMHVNNZVPWCVLWKVQVIWIVJWJVKVKCUQDUQVKURUSUTWH
      VRVIVKVMVOWLVIVJVKVQVBWDWHVLVMVOVPVCHACEGFJKVDVEWFHABCDEFGJVFVGWBVTDEVSFI
      WGLVHVE @.
  @}

  @{
    @d o p q u v x A @.  @d o C @.  @d o u v N @.  @d o p q T @.  @d o p q U @.
    @d o p q u v x B @.  @d o p q u v x R @.  @d o p q u v x S @.  @d p q X @.
    @d o D @.  @d o p q V @.  @d p q Y @.
    exopcopn.1 @e |- T = ( R tX S ) @.
    @( For every neighborhood ` N ` of ` <. A , B >. ` in a product topology,
       there exist two open sets ` u ` and ` v ` of the component topologies so
       that ` ( u X. v ) ` is an open neighborhood of ` <. A , B >. ` and a
       part of ` N ` .  (Use ~ opelxp to have ` A e. u ` and ` B e. v ` .)
       (Contributed by FL, 15-Oct-2012.)  (Revised by Mario Carneiro,
       10-Sep-2015.) @)
    exopcopn @p |- ( ( ( R e. Top /\ S e. Top ) /\ ( A e. C /\ B e. D ) /\
      N e. ( ( nei ` T ) ` { <. A , B >. } ) ) -> E. u e. R E. v e. S
          ( <. A , B >. e. ( u X. v ) /\ ( u X. v ) C_ N ) ) @=
      ( vo vx ctop wcel wa cfv cv wss wrex cop csn cnei w3a cxp simp3 wb ctx co
      cuni txtop 3ad2ant1 syl5eqel eqid neii1 syl2anc cvv opex a1i elnei sseldd
      syl3anc isneip simprd wi wral simprr simprl syl6eleq simpl1 eltx syl wceq
      mpbid eleq1 anbi1d 2rexbidv rspcv sylc sstr2 com12 anim2d reximdv syl5com
      anassrs expimpd rexlimdva mpd ) GNOHNOPZCEODFOPZJCDUAZUBZIUCQQOZUDZWKLRZO
      ZWOJSZPZLITZWKBRARUEZOZWTJSZPZAHTZBGTZWNJIUJZSZWSWNWMXGWSPZWIWJWMUFZWNINO
      ZWKXFOWMXHUGWNIGHUHUIZNKWIWJXKNOWMGHUKULUMZWNJXFWKWNXJWMXGXLXIWLIJXFXFUNZ
      UOUPWNXJWKUQOZWMWKJOXLXNWNCDURUSXIUQWKIJUTVBVAWKLIJXFXMVCUPVNVDWNWRXELIWN
      WOIOZPWPWQXEWNXOWPWQXEVEWNXOWPPZPZXAWTWOSZPZAHTZBGTZWQXEXQWPMRZWTOZXRPZAH
      TBGTZMWOVFZYAWNXOWPVGXQWOXKOZYFXQWOIXKWNXOWPVHKVIXQWIYGYFUGWIWJWMXPVJBAWO
      GHNNMVKVLVNYEYAMWKWOYBWKVMZYDXSBAGHYHYCXAXRYBWKWTVOVPVQVRVSWQXTXDBGWQXSXC
      AHWQXRXBXAXRWQXBWTWOJVTWAWBWCWCWDWEWFWGWH @.

    prdnei.2 @e |- X = U. R @.
    prdnei.3 @e |- Y = U. S @.
    @( The product of two neighborhoods is a neighborhood.  (Contributed by FL,
       15-Oct-2012.)  (Revised by Mario Carneiro, 10-Jun-2014.) @)
    prdnei @p |- ( ( ( R e. Top /\ S e. Top ) /\ ( A e. X /\ B e. Y ) /\ ( U e.
        ( ( nei ` R ) ` { A } )
    /\ V e. ( ( nei ` S ) ` { B } ) ) ) -> ( U X. V ) e. ( ( nei ` T ) ` { <. A
        , B >. } ) ) @=
      ( vo ctop wcel wa cfv wss syl2anc wi vp vq csn cnei w3a cxp cop cuni wrex
      cv simp1l simp3l neii1 simp1r simp3r xpss12 co wceq txuni 3ad2ant1 unieqi
      syl6eqr sseqtrd wb isneip ad2ant2r ad2ant2l anbi12d biimp3a simp31 simp12
      ctx simp111 txopn syl6eleqr simp13l simp12l opelxpi simp13r simp12r eleq2
      syl12anc sseq1 rspcev com4l rexlimiv impcom com12 mpcom syl5eqel 3ad2ant2
      3exp txtop eleqtrd eqid mpbir2and ) CNOZDNOZPZAHOZBIOZPZFAUCZCUDQQOZGBUCZ
      DUDQQOZPZUEZFGUFZABUGZUCEUDQQOZXIEUHZRZXJMUJZOZXNXIRZPZMEUIZXHXIHIUFZXLXH
      FHRZGIRZXIXSRXHWQXDXTWQWRXBXGUKWSXBXDXFULXCCFHKUMSXHWRXFYAWQWRXBXGUNWSXBX
      DXFUOXEDGILUMSFHGIUPSXHXSCDVLUQZUHZXLWSXBXSYCURXGCDHIKLUSUTEYBJVAVBZVCXTA
      UAUJZOZYEFRZPZUACUIZPZYABUBUJZOZYKGRZPZUBDUIZPZPZXHXRWSXBXGYQWSXBPXDYJXFY
      PWQWTXDYJVDWRXAAUACFHKVEVFWRXAXFYPVDWQWTBUBDGILVEVGVHVIYPYJXHXRTZYOYAYJYR
      TZYNYAYSTUBDYKDOZYNYAYSYJYTYNYAUEZYRYIXTUUAYRTZYHXTUUBTUACUUAYECOZYHXTYRU
      UAUUCYHXTYRTUUAUUCYHUEZXTXHXRUUDXTXHUEZYEYKUFZEOXJUUFOZUUFXIRZXRUUEUUFYBE
      UUEWSUUCYTUUFYBOUUDXTWSXBXGVJUUAUUCYHXTXHVKYTYNYAUUCYHXTXHVMYEYKCDNNVNWBJ
      VOUUEYFYLUUGYFYGUUAUUCXTXHVPUUDXTYLXHYLYMYTYAUUCYHVQUTABYEYKVRSUUEYGYMUUH
      YFYGUUAUUCXTXHVSUUDXTYMXHYLYMYTYAUUCYHVTUTYEFYKGUPSXQUUGUUHPMUUFEXNUUFURX
      OUUGXPUUHXNUUFXJWAXNUUFXIWCVHWDWBWLWLWEWFWGWHWLWFWGWGWIXHENOXJXLOXKXMXRPV
      DXHEYBNJWSXBYBNOXGCDWMUTWJXHXJXSXLXBWSXJXSOXGABHIVRWKYDWNXJMEXIXLXLWOVESW
      P @.
  @}

  @{
    @d A s v" v' @.  @d F s v v" v' @.  @d L s v v" v' @.  @d L1 s v v" v' @.
    @d L2 s v v" v' @.  @d R s v" v' @.  @d S s v" v' @.  @d T s v v" v' @.
    @d W s v v" v' @.  @d X s v" v' @.  @d Y s v" v' @.  @d Z s v" v' @.
    limptlimpr2.t @e |- T = ( R tX S ) @.
    limptlimpr2.x @e |- X = U. R @.
    limptlimpr2.y @e |- Y = U. S @.
    limptlimpr2.z @e |- Z = ( X X. Y ) @.
    @( Lemma for ~ limptlimpr .  (Contributed by FL, 15-Oct-2012.)  (Revised by
       Mario Carneiro, 9-Aug-2015.) @)
    limptlimpr2lem1 @p |- ( ( ( R e. Top /\ S e. Top /\ L e. ( Fil ` W ) ) /\
      ( F : W --> Z /\ L2 e. A ) )
         -> ( <. L1 , L2 >. e. ( ( T fLimf L ) ` F )
         -> ( L1 e. ( ( R fLimf L ) ` ( 1st o. F ) )
               /\ L2 e. ( ( S fLimf L ) ` ( 2nd o. F ) ) ) ) ) @=
      ( cfv wcel wa wi vs vv bnjvvm bnjvvn cop cflf co ctop cfil c1st ccom c2nd
      w3a wf cuni cv cima wss wrex csn cnei wral ctopon wb txtop 3adant3 adantr
      ctx syl5eqel eqid toptopon sylib simpl3 wceq cxp txuni unieqi 3eqtr4g syl
      biimpcd impcom flfnei syl3anc syl6reqr eleq2d opelxp syl6bb imp simpl wex
      feq3 simprl1 adantl simpll simprl2 simplr apnei anim12i syl22anc ad2antlr
      simplrl simpr prdnei syl212anc sseq2 rexbidv rspcva imaco c0 wne 3ad2ant1
      simp2l2 simp2rr simp12 npmp simp3 prjpacp1 syl2anc 3exp reximdvai syl5com
      syl5eqss ex com3l 3expd ralrimiva exlimiv 3simpa ad2antrl syl112anc com12
      mpd rspccv prjpacp2 adantrd 3adant1 reximdv 3exp1 mpdd mpcom anim12ii an4
      ancoms sylanbrc simprl3 ax-mp biimpi 1stcof 2ndcof anbi12d mpbird mpancom
      ad2antll syl6bi pm2.43a ) KLUEZEDFUFUGQRZBUHRZCUHRZFGUIQRZUMZGJEUNZLARZSZ
      SZKUJEUKZBFUFUGQRZLULEUKZCFUFUGQRZSZUVEUUQUUPDUOZRZEUAUPZUQZUBUPZURZUAFUS
      ZUBUUPUTDVAQQZVBZSZUVEUVJTUVEDUVKVCQRZUUTGUVKEUNZUUQUVTVDUVEDUHRUWAUVEDBC
      VHUGZUHMUVAUWCUHRZUVDUURUUSUWDUUTBCVEVFVGVIDUVKUVKVJVKVLUURUUSUUTUVDVMUVD
      UVAUWBUVBUVAUWBTUVCUVAUVBUWBUURUUSUVBUWBVDZUUTUURUUSSZJUVKVNUWEUWFHIVOZUW
      CUOZJUVKBCHINOVPZPDUWCMVQZVRJUVKGEWKVSVFVTVGWAUUPUBEDFUVKGUAWBWCUVTUVEUVJ
      KHRZLIRZSZUVTUVESZUVJUVTUVEUWMUVLUVEUWMTUVSUVEUVLUWMUVEUVLUUPUWGRUWMUVEUV
      KUWGUUPUVEUWGUWHUVKUVAUWGUWHVNZUVDUURUUSUWOUUTUWIVFVGUWJWDWEKLHIWFWGVTVGW
      HUWMUWNSZUVJUWKUVFUVMUQZUCUPZURZUAFUSZUCKUTBVAQQZVBZSZUWLUVHUVMUQZUDUPZUR
      ZUAFUSZUDLUTCVAQQZVBZSZSZUWPUWMUXBUXISZUXKUWMUWNWIUWRUXARZUCWJZUXEUXHRZUD
      WJZSZUWPUXLUWPUURUWKUUSUWLUXQUWNUURUWMUURUUSUUTUVDUVTWLWMZUWKUWLUWNWNUWNU
      USUWMUURUUSUUTUVDUVTWOWMZUWKUWLUWNWPUURUWKSUXNUUSUWLSUXPUCKBHNWQUDLCIOWQW
      RWSUXPUXNUWPUXLTUXPUWPUXBUXNUXIUXOUWPUXBTUDUXOUWPUXBUXOUWPSZUWTUCUXAUXTUX
      MSZUWRUXEVOZUVRRZUWTUYAUURUUSUWMUXMUXOUYCUWPUURUXOUXMUXRWTUWPUUSUXOUXMUXS
      WTUXOUWMUWNUXMXAUXTUXMXBUXOUWPUXMWNKLBCDUWRUXEHIMNOXCZXDUXTUXMUYCUWTTZUWP
      UXOUXMUYETZUWNUWMUXOUYFTZUVTUVEUWMUYGTZUVSUVLUVEUYHTUVSUVLUVEUWMUYGUVSUVL
      UVEUWMUMZUXOUXMUYEUYCUVSUYIUXOUXMUMZUWTUYCUVSUYJUWTTUYCUVSSUVNUYBURZUAFUS
      ZUYJUWTUVQUYLUBUYBUVRUVOUYBVNUVPUYKUAFUVOUYBUVNXEXFZXGUYJUYKUWSUAFUYJUVMF
      RZUYKUWSUYJUYNUYKUMZUWQUJUVNUQZUWRUJEUVMXHUYOUXEXIXJZUYKUYPUWRURUYOUUSUVC
      UXOUYQUYJUYNUUSUYKUYIUXOUUSUXMUURUUSUUTUVDUVLUWMXLXKXKUYJUYNUVCUYKUYIUXOU
      VCUXMUVBUVCUVAUVLUWMXMXKXKUYIUXOUXMUYNUYKXNLCUXEAXOWCUYJUYNUYKXPUWRUXEUVN
      XQXRYBXSXTYAYCYDYEYEWAWHWAWAWHYLYFYCYGUXMUWPUXITUCUXMUWPUXIUXMUWPSZUXGUDU
      XHUYCUYRUXOSZUXGUYSUWFUWMUXMUXOUYCUWPUWFUXMUXOUWNUWFUWMUVAUWFUVTUVDUURUUS
      UUTYHYIWMWTUXMUWMUWNUXOXAUXMUWPUXOWNUYRUXOXBUYDYJUYCUYSUYLUXGUYSUYCUYLUWP
      UYCUYLTZUXMUXOUWNUYTUWMUVSUYTUVLUVEUVQUYLUBUYBUVRUYMYMWTWMWTYKUYSUYCUYLUX
      GTZUYRUXOUYCVUATZUWPUXMUXOVUBTZUWNUWMUXMVUCTZUVTUVEUWMVUDTZUVLUVEVUETUVSU
      VLUVEUWMVUDUYIUXMUXOUYCVUAUYIUXMUXOUMZUYCSUYKUXFUAFVUFUYKUXFTZUYCUYIUXMVU
      GUXOUYIUXMVUGUVEUWMUXMVUGTZUVLUVEUWMVUHUVAUWMVUHTZUVDUURUUSVUIUUTUURUWKVU
      HUWLUURUWKUXMVUGUURUWKUXMUMUWRXIXJZVUGKBUWRHXOVUJUYKUXFVUJUYKSUXDULUVNUQU
      XEULEUVMXHUWRUXEUVNYNYBYCVSXSYOXKVGWHYPWHVFVGYQYRXSVGWHWAWAWHYKYSYTYFYCYG
      UUAUUCYTUWKUXBUWLUXIUUBUUDUWPUVGUXCUVIUXJUWPBHVCQRZUUTGHUVFUNZUVGUXCVDUWP
      UURVUKUXRBHNVKVLUWNUUTUWMUURUUSUUTUVDUVTUUEWMZUWPGUWGEUNZVULUVEVUNUWMUVTU
      VBVUNUVAUVCUVBVUNJUWGVNUVBVUNVDPJUWGGEWKUUFUUGYIUUMZGHIEUUHVSKUCUVFBFHGUA
      WBWCUWPCIVCQRZUUTGIUVHUNZUVIUXJVDUWPUUSVUPUXSCIOVKVLVUMUWPVUNVUQVUOGHIEUU
      IVSLUDUVHCFIGUAWBWCUUJUUKUULYCUUNUUO @.
  @}

  @{
    @d F o" o' s s" s' v v' v" @.  @d L o" o' s s" s' v v' v" @.
    @d L1 o" o' v v' @.  @d L2 o" o' v v" @.  @d R o" o' s" s' v @.
    @d R o" o' s' v v' @.  @d S o" o' s" s' v v" @.  @d T s v @.
    @d W o" o' s s" s' v v' v" @.  @d X o" o' s' v v' @.  @d Y o" o' s" v v" @.
    @d Z o" o' s" s' v @.
    limptlimpr2lem2.t @e |- T = ( R tX S ) @.
    limptlimpr2lem2.x @e |- X = U. R @.
    limptlimpr2lem2.y @e |- Y = U. S @.
    limptlimpr2lem2.z @e |- Z = ( X X. Y ) @.
    @( Lemma for ~ limptlimpr .  (Contributed by FL, 15-Oct-2012.)  (Revised by
       Mario Carneiro, 9-Aug-2015.) @)
    limptlimpr2lem2 @p |- ( ( ( R e. Top /\ S e. Top /\ L e. ( Fil ` W ) ) /\
      F : W --> Z )
         -> ( ( L1 e. ( ( R fLimf L ) ` ( 1st o. F ) )
               /\ L2 e. ( ( S fLimf L ) ` ( 2nd o. F ) ) )
             -> <. L1 , L2 >. e. ( ( T fLimf L ) ` F ) ) ) @=
      ( wcel cfv wa wss wi vs vv bnjvsm bnjvvm bnjvsn bnjvvn bnjvom bnjvon ctop
      cfil w3a wf c1st ccom cflf co c2nd cop cuni cv cima wrex cnei wral ctopon
      csn simpl1 toptopon sylib simpl3 cxp wceq feq3 ax-mp biimpi adantl 1stcof
      wb syl flfnei syl3anc simpl2 biimpa 2ndcof anbi12d opelxpi ad2ant2r txuni
      a1i syl2anc unieqi syl6eqr eleq2d biimpac simprl1 simprl2 simplll simplrl
      ctx sylan exopcopn 3expia syl22anc opelxp an6 opnneip sseq2 rexbidv rspcv
      im2anan9 cin filin inss1 imass2 inss2 sstr sseq1i xpss12 syl2anb wrel crn
      imaco imassrn frn biimpd relxp mpsyl sstr2 syl5com ex com23 anabsi5 com3l
      3exp rexlimiv imp syl6 3adant3 pm2.43a adantr relss syl6mpi sylancr com24
      relinccppr 3syl mp2b 3imp imaeq2 sseq1d rspcev syl9r 3expd com34 3ad2ant3
      com5l adantld ad2ant2l syl2an sylbir com25 pm2.43i syl5bi com4l rexlimivv
      ad2antrl com12 ralrimiv syl6bi txtop syl5eqel eqid simpll3 3eqtr4g mpbird
      jca ) AUIPZBUIPZEFUJQPZUKZFIDULZRZJUMDUNZAEUOUPQPZKUQDUNZBEUOUPQPZRZJKURZ
      DCEUOUPQPZUWBUWGRZUWIUWHCUSZPZDUAUTZVAZUBUTZSZUAEVBZUBUWHVFCVCQQZVDZRZUWB
      UWGUWTUWGUWBUWTUWBUWGJGPZUWCUCUTZVAZUDUTZSZUCEVBZUDJVFAVCQQZVDZRZKHPZUWEU
      EUTZVAZUFUTZSZUEEVBZUFKVFBVCQQZVDZRZRZUWBUWTTUWBUWDUXIUWFUXRUWBAGVEQPZUVS
      FGUWCULZUWDUXIVRUWBUVQUXTUVQUVRUVSUWAVGZAGMVHVIUVQUVRUVSUWAVJZUWBFGHVKZDU
      LZUYAUWAUYEUVTUWAUYEIUYDVLZUWAUYEVRZOIUYDFDVMVNZVOVPFGHDVQVSJUDUWCAEGFUCV
      TWAUWBBHVEQPZUVSFHUWEULZUWFUXRVRUWBUVRUYIUVQUVRUVSUWAWBZBHNVHVIUYCUWBUYEU
      YJUVTUWAUYEUYGUVTUYHWIWCFGHDWDVSKUFUWEBEHFUEVTWAWEUXSUWBUWTUXSUWBRZUWLUWS
      UXSUWHUYDPZUWBUWLUXAUXJUYMUXHUXQJKGHWFWGUWBUYMUWLUWBUYDUWKUWHUWBUYDABWSUP
      ZUSZUWKUWBUVQUVRUYDUYOVLUYBUYKABGHMNWHZWJCUYNLWKZWLWMWNWTUYLUWQUBUWRUWOUW
      RPZUYLUWQUYLUYRUWHUGUTZUHUTZVKZPZVUAUWOSZRZUHBVBUGAVBZUYLUWQTZUYLUVQUVRUX
      AUXJUYRVUETUVQUVRUVSUWAUXSWOUVQUVRUVSUWAUXSWPUXAUXHUXRUWBWQUXIUXJUXQUWBWR
      UVQUVRRZUXAUXJRUYRVUEUHUGJKGHABCUWOLXAXBXCVUDVUFUGUHABVUDUYSAPZUYTBPZRZVU
      FVUBVUCVUJVUFTUYLVUBVUCVUJUWQVUBJUYSPZKUYTPZRZUYLVUCVUJUWQTTZJKUYSUYTXDUY
      LVUMVUNTZUVTUYLVUOTZUXSUWAUVQUVRVUPUVSVUGVUJVUMVUCUYLUWQVUGVUJVUMVUCVUFTZ
      VUGVUJVUMUKUVQVUHVUKUKZUVRVUIVULUKZRVUQUVQVUHVUKUVRVUIVULXEVURUYSUXGPZUYT
      UXPPZVUQVUSJAUYSXFKBUYTXFUYLVUTVVARZVUCUWQUXSUWBVVBVUCUWQTZTZUXHUXQUYLVVD
      TUXAUXJVVBUXHUXQRZUYLVVCVVBVVEUXCUYSSZUCEVBZUXLUYTSZUEEVBZRZUYLVVCTVUTUXH
      VVGVVAUXQVVIUXFVVGUDUYSUXGUXDUYSVLUXEVVFUCEUXDUYSUXCXGXHXIUXOVVIUFUYTUXPU
      XMUYTVLUXNVVHUEEUXMUYTUXLXGXHXIXJVVJUWBVVCUXSVVGVVIUWBVVCTZVVFVVIVVKTUCEV
      VIUXBEPZVVFVVKVVHVVLVVFVVKTZTUEEVVLUXKEPZVVHVVMUWBVVLVVNVVHVVFVVCUVTUWAVV
      LVVNVVHVVFVVCTTZTZTZUVSUVQUWBVVQTUVRUVSVVLUWBVVPUVSVVLVVNUWBVVOUVSVVLVVNU
      WBVVOTZUVSVVLVVNUKUXBUXKXKZEPZVVRUXBUXKEFXLVVTUWBVVHVVFVVCUWBVVHVVFUKZVUC
      DVVSVAZUWOSZVVTUWQVWAVWBVUASZVUCVWCTUWBVVHVVFVWDUWAVVHVVFVWDTTZUVTVVSUXBS
      UWCVVSVAZUXCSZUWAVWETUXBUXKXMVVSUXBUWCXNVWGVVFVVHUWAVWDVWGVVFVVHUWAVWDTZT
      ZVVSUXKSZVWGVVFRVWFUYSSZVWIUXBUXKXOVWFUXCUYSXPVWJUWEVVSVAZUXLSZVWKVWITVVS
      UXKUWEXNVWMVVHVWKVWHVWMVVHVWKVWHTVWMVVHRVWLUYTSZVWKVWHVWLUXLUYTXPVWKVWNVW
      HVWKVWNRUMVWBVAZUQVWBVAZVKZVUASZUWAVWDVWKVWOUYSSVWPUYTSVWRVWNVWFVWOUYSUMD
      VVSYBXQVWLVWPUYTUQDVVSYBXQVWOUYSVWPUYTXRXSUWAVWBXTZVWBVWQSVWRVWDTUWAVWBDY
      AZSZVWTISZVWSDVVSYCFIDYDUYFVXAVXBRVWBISZVWSOVWBVWTIXPUYFVXCVWBUYDSZUYDXTV
      WSUYFVXCVXDIUYDVWBXGYEGHYFVWBUYDUUAUUBYGUUCVWBUUEVWBVWQVUAYHUUFYIYJYIYJYK
      VSYGYJUUDUUGVPUUHVWBVUAUWOYHVSVVTVWCUWQUWPVWCUAVVSEUWMVVSVLUWNVWBUWOUWMVV
      SDUUIUUJUUKYJUULUUMVSYNUUNYKUUOYLUUPYMYOYMYOYPUUQYQYMUURYLYMUUSUUTYNUVAYR
      UVFUVBUVCUVDYPUVGUVEYQYSUVHUVPYJUVIYSYPUWJCUWKVEQPZUVSFUWKDULZUWIUWTVRUWJ
      CUIPZVXEUWBVXGUWGUWBCUYNUILUWBUVQUVRUYNUIPUYBUYKABUVJWJUVKYTCUWKUWKUVLVHV
      IUVQUVRUVSUWAUWGUVMUWBVXFUWGUVTUWAVXFUVQUVRUWAVXFTUVSVUGUWAVXFVUGIUWKVLUW
      AVXFVRVUGUYDUYOIUWKUYPOUYQUVNIUWKFDVMVSYEYRYPYTUWHUBDCEUWKFUAVTWAUVOYJ @.
  @}

  @{
    limptlimpr.t @e |- T = ( R tX S ) @.
    limptlimpr.x @e |- X = U. R @.
    limptlimpr.y @e |- Y = U. S @.
    limptlimpr.z @e |- Z = ( X X. Y ) @.
    @( A limit in a product topology exists iff the limits of the projections
       exist.  (Contributed by FL, 15-Oct-2012.)  (Revised by Mario Carneiro,
       9-Aug-2015.) @)
    limptlimpr @p |- ( ( ( R e. Top /\ S e. Top /\ L e. ( Fil ` W ) ) /\
        ( F : W --> Z /\ L2 e. A ) )
         -> ( <. L1 , L2 >. e. ( ( T fLimf L ) ` F )
         <-> ( L1 e. ( ( R fLimf L ) ` ( 1st o. F ) )
               /\ L2 e. ( ( S fLimf L ) ` ( 2nd o. F ) ) ) ) ) @=
      ( wcel cfv wa cflf ctop cfil w3a wf cop co c1st ccom c2nd limptlimpr2lem1
      wi limptlimpr2lem2 adantrr impbid ) BUAQCUAQFGUBRQUCZGJEUDZLAQZSSKLUEEDFT
      UFRQZKUGEUHBFTUFRQLUIEUHCFTUFRQSZABCDEFGHIJKLMNOPUJUOUPUSURUKUQBCDEFGHIJK
      LMNOPULUMUN @.
  @}

  @{
    @d A n l @.  @d n F l @.  @d n J l @.  @d n L l @.  @d n X l @.
    @d n Y l @.
    flfnei2.x @e |- X = U. J @.
    @( The property of being a limit point of a function in terms of filter and
       of preimage of a neighborhood.  (Contributed by FL, 13-Dec-2013.)
       (Revised by Mario Carneiro, 8-Aug-2015.) @)
    flfnei2 @p |- ( ( J e. Top /\ L e. ( Fil ` Y ) /\ F : Y --> X ) ->
      ( A e. ( ( J fLimf L ) ` F ) <->
        ( A e. X /\ A. n e. ( ( nei ` J ) ` { A } ) ( `' F " n ) e. L ) ) ) @=
      ( vl wcel cfv cv cima wss wral wa wb wceq simpl3 syl ctop cfil wf cflf co
      w3a wrex cnei ccnv ctopon toptopon flfnei syl3an1b simpl2 simprl cnvimass
      csn cdm fdm syl5sseq wfun ffun filelss 3ad2antl2 funimass3 syl2anc biimpd
      sseqtr4d impr filss syl13anc expr rexlimdva wi 3ad2ant3 crn cin funimacnv
      inss1 a1i eqsstrd imaeq2 sseq1d rspcev expcom impbid ralbidv anbi2d bitrd
      ) DUAJZEGUBKJZGFCUCZUFZACDEUDUEKJZAFJZCILZMZBLZNZIEUGZBAUQDUHKKZOZPZWOCUI
      WRMZEJZBXAOZPWJDFUJKJWKWLWNXCQDFHUKABCDEFGIULUMWMXBXFWOWMWTXEBXAWMWTXEWMW
      SXEIEWMWPEJZWSXEWMXGWSPZPZWKXGXDGNWPXDNZXEWJWKWLXHUNWMXGWSUOXICURZXDGCWRU
      PXIWLXKGRZWJWKWLXHSGFCUSZTUTWMXGWSXJWMXGPZWSXJXNCVAZWPXKNWSXJQXNWLXOWJWKW
      LXGSZGFCVBZTXNWPGXKWKWJXGWPGNWLWPEGVCVDXNWLXLXPXMTVHWPWRCVEVFVGVIWPXDEGVJ
      VKVLVMWMCXDMZWRNZXEWTVNWMXOXSWLWJXOWKXQVOXOXRWRCVPZVQZWRWRCVRYAWRNXOWRXTV
      SVTWATXEXSWTWSXSIXDEWPXDRWQXRWRWPXDCWBWCWDWETWFWGWHWI @.
  @}

  @c fLimfrs @.

  @( Extend the definition of a class to include the limit of a function
     relatively to a subspace. @)
  cflimfrs @a class fLimfrs @.

  @{
    @d j k a p f u v @.
    @( Gives the limits of a function ` f : a --> U. j ` at a point
       ` p e. ( ( cls `` k ) `` a ) ` relatively to a subspace ` a ` of a
       topology ` k ` .  ( The condition ` p e. ( ( cls `` k ) `` a ) ` ensures
       the traces of the neighborhoods of ` p ` over ` a ` is a filter ( see
       ~ trnei ).  The set ` a ` can't be empty since its closure is not empty
       ( see ~ cldifemp ).  Experimental.  (Contributed by FL, 15-Sep-2013.) @)
    df-flimfrs @a |- fLimfrs = ( j e. Top , k e. Top |->
      ( a e. ~P U. k |->
         ( p e. ( ( cls ` k ) ` a ) , f e. ( U. j ^m a ) |->
            ( ( j fLimf ( ( ( nei ` k ) ` { p } ) |`t a ) ) ` f ) ) ) ) @.
  @}

  @{
    islimrs.1 @e |- L = ( ( ( nei ` K ) ` { P } ) |`t A ) @.
    islimrs.2 @e |- X = U. J @.
    islimrs.3 @e |- Y = U. K @.

    @{
      @d a f p u v A @.  @d f p F @.  @d a f j k p J @.  @d a f j k p u v K @.
      @d f p L @.  @d f p u v P @.
      @( The limits of ` F ` at point ` P ` when one only considers the traces
         of the neighborhoods of ` P ` over ` A ` . ` F ` is a function whose
         domain is ` A ` .  The point ` P ` must belong to
         ` ( ( cls `` K ) `` A ) ` (see also the comments under
         ~ df-flimfrs ) .  (Contributed by FL, 15-Sep-2013.) @)
      islimrs @p |- ( ( ( J e. Top /\ K e. Top ) /\
      ( A C_ Y /\ P e. ( ( cls ` K ) ` A ) ) /\ F e. ( X ^m A ) ) ->
        ( ( ( J fLimfrs K ) ` A ) ` <. P , F >. ) = ( ( J fLimf L ) ` F ) ) @=
        ( va vp vf wcel cfv co cflf cvv fveq1d vj vk ctop wss ccl cmap cflimfrs
        wa w3a cop cuni cpw csn cnei crest cmpt2 cmpt wceq simp1l simp1r uniexg
        cv pwexg adantl 3ad2ant1 mptexg eqidd unieq oveq1d mpt2eq123dv mpteq2dv
        syl oveq1 pweqd fveq2 oveq2d mpteq12dv df-flimfrs ovmpt2g syl3anc sseq2
        wi elpw2g biimprcd syl6bi ax-mp adantr com12 3adant3 fvex ovex mpt2exga
        wb imp a1i sylancr oveq2 eqid fvmptg syl2anc df-ov simp2r oveq1i eleq2i
        biimpi 3ad2ant3 sneq fveq2d syl6eqr syl5eqr 3eqtrd ) DUCOZEUCOZUHZAHUDZ
        BAEUEPZPZOZUHZCGAUFQZOZUIZBCUJZADEUGQZPZPYCALEUKZULZMNLVBZXPPZDUKZYHUFQ
        ZNVBZDMVBZUMZEUNPZPZYHUOQZRQZPZUPZUQZPZPYCMNXQYJAUFQZYLDYPAUOQZRQZPZUPZ
        PZCDFRQZPZYBYCYEUUBYBAYDUUAYBXLXMUUASOZYDUUAURXLXMXSYAUSXLXMXSYAUTYBYGS
        OZUUKXNXSUULYAXMUULXLXMYFSOZUULEUCVAZYFSVCVLVDVELYGYTSVFVLUAUBDEUCUCLUB
        VBZUKZULZMNYHUUOUEPZPZUAVBZUKZYHUFQZYLUUTYNUUOUNPZPZYHUOQZRQZPZUPZUQUUA
        UGLUUQMNUUSYKYLDUVERQZPZUPZUQSUUTDURZLUUQUVHUVKUVLMNUUSUVBUVGUUSYKUVJUV
        LUUSVGUVLUVAYJYHUFUUTDVHVIUVLYLUVFUVIUUTDUVERVMTVJVKUUOEURZLUUQUVKYGYTU
        VMUUPYFUUOEVHVNUVMMNUUSYKUVJYIYKYSUVMYHUURXPUUOEUEVOTUVMYKVGUVMYLUVIYRU
        VMUVEYQDRUVMUVDYPYHUOUVMYNUVCYOUUOEUNVOTVIVPTVJVQNUAUBMLVRVSVTTTYBYCUUB
        UUGYBAYGOZUUGSOZUUBUUGURXNXSUVNYAXNXSUVNXMXSUVNWBXLXSXMUVNXOXMUVNWBZXRH
        YFURZXOUVPWBKUVQXOAYFUDZUVPHYFAWAXMUVNUVRXMUUMUVNUVRWMUUNAYFSWCVLWDWEWF
        WGWHVDWNWIYBXQSOUUCSOZUVOAXPWJUVSYBYJAUFWKWOMNXQUUCUUFSSWLWPLAYTUUGYGSU
        UAYHAURZMNYIYKYSXQUUCUUFYHAXPVOYHAYJUFWQUVTYLYRUUEUVTYQUUDDRYHAYPUOWQVP
        TVJUUAWRWSWTTYBUUHBCUUGQZUUJBCUUGXAYBXRCUUCOZUUJSOZUWAUUJURXNXOXRYAXBYA
        XNUWBXSYAUWBXTUUCCGYJAUFJXCXDXEXFUWCYBCUUIWJWOMNBCXQUUCUUFUUJUUGYLUUIPS
        YMBURZYLUUEUUIUWDUUDFDRUWDUUDBUMZYOPZAUOQFUWDYPUWFAUOUWDYNUWEYOYMBXGXHV
        IIXIVPTYLCUUIVOUUGWRVSVTXJXK @.
    @}

    @{
      @d u v x A @.  @d u v x B @.  @d u v x F @.  @d u v x J @.  @d u v x K @.
      @d u x L @.  @d u v x P @.  @d u v x X @.  @d u v x Y @.
      @( The limits of ` F ` at point ` P ` relatively to ` A ` is a limit of
         ` F ` at point ` P ` relatively to ` B C_ A ` .  The opposite
         direction doesn't hold.  (Contributed by FL, 13-Dec-2013.) @)
      islimrs3 @p |- ( ( ( J e. Top /\ K e. Top /\ B C_ A ) /\
        ( A C_ Y /\ P e. ( ( cls ` K ) ` B ) ) /\ F e. ( X ^m A ) ) ->
          ( ( ( J fLimfrs K ) ` A ) ` <. P , F >. )
            C_ ( ( ( J fLimfrs K ) ` B ) ` <. P , ( F |` B ) >. ) ) @=
        ( wcel cfv wa co cvv wb wi syl3anc vx vu vv ctop wss w3a cmap cflf cres
        ccl csn cnei crest cop cflimfrs cv ccnv cima wral wceq wrex eleq2i fvex
        cin cuni uniexg eleq1 eqcoms simp2 ssexg ancoms 3adant2 jca 3exp syl6bi
        ax-mp com12 syl2an adantrd 3adant3 simprd ad2antrr elrest syl5bb simp13
        imp sylancr ad3antrrr dfss1 sylib ineq2d adantr syl2anc elrestr eqeltrd
        a1i simpr cnvresima ineq1 syl5eq inass syl6eq eleq1d rexlimdva ralimdva
        syl5ibrcom sylbid imdistanda cfil simp11 simpl2 simpl3 clsss sseld impr
        ctopon simp12 toptopon simp2l clsss3 sseldd trnei mpbid syl5eqel elmapg
        simp3 syl flfnei2 simp2r sstr2 3ad2ant3 fssres expcom a1d imbi1d mpbird
        wf pm5.74da 3imtr4d islimrs 3simpa 3ad2ant1 simprl simprr simpld adantl
        3imp ssrdv sylc 3impia eqid 3sstr4d ) EUDMZFUDMZBAUEZUFZAIUEZCBFUJNZNZM
        ZOZDHAUGPMZUFZDEGUHPNZDBUIZECUKZFULNZNZBUMPZUHPNZCDUNAEFUOPZNNZCUVEUNBU
        VKNNZUVCUAUVDUVJUVCUAUPZHMZDUQUBUPZURZGMZUBUVNUKEULNNZUSZOZUVOUVEUQUVPU
        RZUVIMZUBUVSUSZOZUVNUVDMZUVNUVJMZUVCUVOUVTUWDUVCUVOOZUVRUWCUBUVSUWHUVPU
        VSMZOZUVRUVQUCUPZAVDZUTZUCUVHVAZUWCUVRUVQUVHAUMPZMZUWJUWNGUWOUVQJVBUWJU
        VHQMZAQMZUWPUWNRUVFUVGVCZUVCUWRUVOUWIUVCHQMZUWRUUPUVAUWTUWROZUVBUUPUVAU
        XAUUMUUNUVAUXASUUOUUMUUNOZUUQUXAUUTUUMEVEZQMZFVEZQMZUUQUXASZUUNEUDVFFUD
        VFUXDUXFUXGHUXCUTZUXDUXFUXGSZSKUXHUXDUWTUXIUXDUWTRUXCHUXCHQVGVHUXFUWTUX
        GIUXEUTZUXFUWTUXGSZSLUXJUXFIQMZUXKUXFUXLRUXEIUXEIQVGVHUXLUWTUUQUXAUXLUW
        TUUQUFUWTUWRUXLUWTUUQVIUXLUUQUWRUWTUUQUXLUWRAIQVJVKVLVMVNVOVPVQVOVPWFVR
        VSVTWFZVTZWAWBZUCUVQAUVHQQWCWGWDUWJUWMUWCUCUVHUWJUWKUVHMZOZUWCUWMUWKABV
        DZVDZUVIMUXQUXSUWKBVDZUVIUXQUXRBUWKUXQUUOUXRBUTUVCUUOUVOUWIUXPUUMUUNUUO
        UVAUVBWEWHZBAWIWJWKUXQUWQBQMZUXPUXTUVIMUWQUXQUWSWPUXQUUOUWRUYBUYAUWJUWR
        UXPUXOWLBAQVJZWMUWJUXPWQUWKBUVHQQWNTWOUWMUWBUXSUVIUWMUWBUWLBVDZUXSUWMUW
        BUVQBVDUYDBUVPDWRUVQUWLBWSWTUWKABXAXBXCXFXDXGXEXHUVCUUMGAXINZMAHDYQZUWF
        UWARUUMUUNUUOUVAUVBXJZUVCGUWOUYEJUVCCAUURNZMZUWOUYEMZUUPUVAUYIUVBUUPUUQ
        UUTUYIUUPUUQOUUNUUQUUOUUTUYISUUMUUNUUOUUQXKUUPUUQWQUUMUUNUUOUUQXLUUNUUQ
        UUOUFUUSUYHCABFILXMXNTXOZVTZUVCFIXPNMZUUQCIMZUYIUYJRUVCUUNUYMUUMUUNUUOU
        VAUVBXQZFILXRWJZUUPUUQUUTUVBXSZUVCUYHICUVCUUNUUQUYHIUEUYOUYQAFILXTWMUYL
        YAZACFIYBTYCYDUVCUVBUYFUUPUVAUVBYFZUVCUXAUVBUYFRZUXNHADQQYEZYGYCUVNUBDE
        GHAKYHTUVCUUMUVIBXINMZBHUVEYQZUWGUWERUYGUVCUUTVUBUUPUUQUUTUVBYIUVCUYMBI
        UEZUYNUUTVUBRUYPUUPUVAVUDUVBUUPUVAVUDUUOUUMUVAVUDSUUNUUOUUQVUDUUTBAIYJV
        SYKWFZVTUYRBCFIYBTYCUUPUVAUVBVUCUUPUVAUVBVUCSZSUVAUYFVUCSZSUUPVUGUVAUUO
        UUMVUGUUNUYFUUOVUCAHBDYLYMYKZYNUUPUVAVUFVUGUUPUVAOZUVBUYFVUCVUIUXAUYTUX
        MVUAYGZYOYRYPUUGUVNUBUVEEUVIHBKYHTYSUUHUVCUXBUUQUYIOZUVBUVLUVDUTUUPUVAU
        XBUVBUUMUUNUUOUUAUUBZUUPUVAVUKUVBVUIUUQUYIUUPUUQUUTUUCUYKVMVTUYSACDEFGH
        IJKLYTTUVCUXBVUDUUTOZUVEHBUGPMZUVMUVJUTVULUUPUVAVUMUVBVUIVUDUUTVUEUUPUU
        QUUTUUDVMVTUUPUVAUVBVUNVUIUYFVUCUVBVUNUUPVUGUVAVUHWLVUJVUIUWTUYBVUNVUCR
        VUIUWTUWRUXMUUEVUIUXAUUOUYBUXMUUMUUNUUOUVAXLUWRUUOUYBSUWTUUOUWRUYBUYCYM
        UUFUUIHBUVEQQYEWMYSUUJBCUVEEFUVIHIUVIUUKKLYTTUUL @.
    @}

    @{
      @d n u v w x A @.  @d n u v w x F @.  @d n u w x J @.  @d n u v w x K @.
      @d n u v w x N @.  @d n u v w x P @.  @d n u w x X @.  @d n u w x Y @.
      @d u x L @.
      @( The limits of ` F ` at point ` P ` relatively to ` A ` is a limit of
         ` F ` at point ` P ` relatively to ` B ` .  (Contributed by FL,
         13-Dec-2013.) @)
      islimrs4 @p |- ( (
        ( J e. Top /\ K e. Top /\ N e. ( ( nei ` K ) ` { P } ) ) /\
        ( A C_ Y /\ P e. ( ( cls ` K ) ` A ) ) /\ F e. ( X ^m A ) ) ->
          ( ( ( J fLimfrs K ) ` A ) ` <. P , F >. ) =
    ( ( ( J fLimfrs K ) ` ( A i^i N ) ) ` <. P , ( F |` ( A i^i N ) ) >. ) ) @=
        ( wcel cfv wa cin wceq wi syl cvv vn vx vu vv ctop csn cnei w3a wss ccl
        vw cmap co cop cflimfrs cres simp11 simp12 inss1 a1i simp2l cv wne wral
        incom inass eqtr innei 3expia 3adant1 3ad2ant1 imp jca ad2antrl simpl2r
        c0 adantl simpl neindisj syl12anc neeq1 syl5ibr ax-mp mpancom ralrimiva
        mp2an wb ssinss1 3adant3 clsss3 sseld 3ad2ant2 neindisj2 syl3anc mpbird
        imp32 simp3 islimrs3 syl321anc crest cflf ccnv cima wrex eqeq2d cbvrexv
        ex ineq1 ineq2i eqtr4i cnvresima cdm cuni uniexg syl5eqel elmapg expcom
        ssexg syl6 ad2antrr cun adantr com3l sylbi mpcom sylancl eqcoms sylancr
        wf mpsyl com12 syl2anc inex1g elrest 3imtr4d cfil trnei flfnei2 islimrs
        mpbid cnvimass biimpd com13 syl2an adantrd 3imp fdm syl5sseq df-ss cdif
        inundif uneq1 undir difss sstr ssequn1 uncom ineq2d simpl12 simpr neii1
        simpl13 sylan simpl2l sstrd unssd ssun1 jctil jca31 ssnei2 rspcev com3r
        mpan com23 3impd 3exp mpan2 rexlimiv fvex topopn eleq2i syl5bb ralimdva
        ssdifss ctopon toptopon sylib eqcomi eleq1i impcom biimp3a fssres ssrdv
        imdistanda simp2r 3simpa simp13 syl121anc simp2 syl211anc 3sstr4d eqssd
        eqid ) DUEMZEUEMZGBUFZEUGNZNZMZUHZAIUIZBAEUJNZNZMZOZCHAULUMMZUHZBCUNADE
        UOUMZNNZBCAGPZUPZUNUXTUXRNNZUXQUXDUXEUXTAUIZUXKBUXTUXLNMZUXPUXSUYBUIUXD
        UXEUXIUXOUXPUQZUXDUXEUXIUXOUXPURZUYCUXQAGUSZUTUXJUXKUXNUXPVAZUXQUYDUAVB
        ZUXTPZVPVCZUAUXHVDZUXQUYKUAUXHUYJUXTUYIPZQZUYMAGUYIPZPZQZUXQUYIUXHMZOZU
        YKRZUYIUXTVEAGUYIVFUYNUYQOUYJUYPQZUYTUYJUYMUYPVGUYSUYKVUAUYPVPVCZUYOUXH
        MZUYSVUBUXQUYRVUCUXJUXOUYRVUCRZUXPUXEUXIVUDUXDUXEUXIUYRVUCUXFEUYIGVHVIV
        JVKVLUYPUYOAPZQZVUCUYSOZVUBRAUYOVEVUGVUBVUFVUEVPVCZVUGUXEUXKOZUXNVUCVUH
        UXQVUIVUCUYRUXQUXEUXKUYFUYHVMVNUYSUXNVUCUXKUXNUXJUXPUYRVOVQVUCUYSVRBAEU
        YOILVSVTUYPVUEVPWAWBWCWDUYJUYPVPWAWBSWFWEUXQUXEUXTIUIZBIMZUYDUYLWGUYFUX
        JUXOVUJUXPUXKVUJUXJUXNAGIWHVNWIZUXJUXOVUKUXPUXJUXKUXNVUKUXEUXDUXKUXNVUK
        RZRUXIUXEUXKVUMVUIUXMIBAEILWJWKXGWLWPWIZBUXTUAEILWMWNWOZUXJUXOUXPWQZAUX
        TBCDEFHIJKLWRWSUXQUYADUXHUXTWTUMZXAUMNZCDFXAUMNZUYBUXSUXQUBVURVUSUXQUBV
        BZHMZUYAXBUCVBZXCZVUQMZUCVUTUFDUGNNZVDZOZVVACXBVVBXCZFMZUCVVEVDZOZVUTVU
        RMZVUTVUSMZUXQVVAVVFVVJUXQVVAOZVVDVVIUCVVEVVNVVBVVEMZOZVVCUDVBZUXTPZQZU
        DUXHXDZVVHVVQAPZQZUDUXHXDZVVDVVIVVTVVPVWCVVTVVCUKVBZUXTPZQZUKUXHXDVVPVW
        CRZVVSVWFUDUKUXHVVQVWDQVVRVWEVVCVVQVWDUXTXHXEXFVWFVWGUKUXHVWFVWDUXHMZVW
        GVWFVWEVWDGPZAPZQZVWHVWGRZVWEVWDGAPZPVWJUXTVWMVWDAGVEZXIVWDGAVFXJVWFVWK
        OVVCVWJQZVWLVVCVWEVWJVGVWOVWHVVPVWCVVCVVHUXTPZQVWOVWHVVPUHVWCRZUXTVVBCX
        KVWQVWPVVCVWPVVCQZVWOVWHVVPVWCVWRVWOVWLVWRVWOOVVHAPZGPZVWPQZVWPVWJQZVWL
        VVHAGVFVWPVVCVWJVGVXAVXBOVWTVWJQZVWLVWTVWPVWJVGVVPVXCVWHVWCVVHAUIZVVPVX
        CVWHVWCRZRZVVPCXLZVVHACVVBUUAVVPAHCYIZVXGAQUXQVXHVVAVVOUXJUXOUXPVXHUXJU
        XKUXPVXHRZUXNUXDUXEUXKVXIRZUXIUXDHTMZITMZVXJUXEUXDHDXMTKDUEXNXOZUXEIEXM
        ZTLEUEXNZXOVXKVXLVXJUXKVXLVXKVXIUXKVXLATMZVXKVXIRUXKVXLVXPAITXRZXGVXKVX
        PVXIVXKVXPOUXPVXHHACTTXPZUUBXQXSUUCVLUUDWIUUEUUFZXTAHCUUGSUUHZVXDVWSVVH
        QZVVPVXFRZVVHAUUIVYAVWTVVHGPZQVYBVWSVVHGXHVYBVYCVWTVYCVWTQZVXCVVPVXEVYD
        VXCVVPVXERZVYDVXCOVYCVWJQZVYEVYCVWTVWJVGVYCVVHGUUJZYAZVVHQVYFVYHVWJVYGY
        AZQZVYEVVHGUUKVYCVWJVYGUULVYJVYERVVHVYHVVHVYHQZVYJVYEVYKVYJOVVHVYIQZVYI
        VWIVYGYAZAVYGYAZPZQZVYEVVHVYHVYIVGVWIAVYGUUMVYGVVHUIZVYLVYPOVVHVYOQZVYE
        VVHGUUNVVHVYIVYOVGVVPVYQVYRVXEVXDVVPVYQVYRVXERZRVXTVYQVXDVVPVYSVYQVXDVV
        PVYSRZVYQVXDOVYGAUIZVYTVYGVVHAUUOWUAVYGAYAZAQZVYTVYGAUUPVYNWUBQZWUCVYTA
        VYGUUQWUDWUCOZVYOVYMAPZQZVYTWUEVYNAVYMVYNWUBAVGUURVYRWUGVVPVXEVYRWUGVYE
        VYRWUGOVVHWUFQZVYEVVHVYOWUFVGVVPVWHWUHVWCVVPVWHVYMUXHMZWUHVWCRVVPVWHUXE
        VWIUXHMZOVWIVYMUIZVYMIUIZOZOZWUIVVPVWHWUNVVPVWHOZUXEWUJWUMVVNUXEVVOVWHU
        XDUXEUXIUXOUXPVVAUUSZXTZWUOUXEVWHUXIWUJWUQVVPVWHUUTVVNUXIVVOVWHUXDUXEUX
        IUXOUXPVVAUVBXTUXFEGVWDVHWNWUOWULWUKWUOVWIVYGIWUOVWDIUIZVWIIUIVVPUXEVWH
        WURVVNUXEVVOWUPYBZUXFEVWDILUVAUVCVWDGIWHSWUOVVHIUIVYGIUIWUOVVHAIVVPVXDV
        WHVXTYBVVNUXKVVOVWHUXKUXNUXJUXPVVAUVDZXTUVEVVHIGUWDSUVFVWIVYGUVGUVHUVIX
        GUXFEVYMVWIILUVJXSWUIWUHVWCVWBWUHUDVYMUXHVVQVYMQVWAWUFVVHVVQVYMAXHXEUVK
        XGXSUVLSXGYCSUVMYDSXGYCYEYCYJYFXGYGYJSXGUVNYGSYDYEYCSYHXGUVOYGWCUVPSUVQ
        YKUVRYDYKVVPUXHTMZUXTTMZVVDVVTWGUXFUXGUVSZVVPVXPWVBVVPUXKIEMZVXPVVNUXKV
        VOWUTYBVVPUXEWVDWUSEILUVTSAIEXRYLZAGTYMSUDVVCUXTUXHTTYNYHVVIVVHUXHAWTUM
        ZMZVVPVWCFWVFVVHJUWAVVPWVAVXPWVGVWCWGWVCWVEUDVVHAUXHTTYNYHUWBYOUWCUWNUX
        QUXDVUQUXTYPNMZUXTHUYAYIZVVLVVGWGUYEUXQUYDWVHVUOUXQEIUWENMZVUJVUKUYDWVH
        WGUXQUXEWVJUYFEILUWFUWGZVULVUNUXTBEIYQWNYTUXQVXHUYCWVIUXJUXOUXPVXHUXJUX
        OOVXKVXPUXPVXHWGUXJVXKUXOUXDUXEVXKUXIVXMVKZYBUXOUXJVXPUXKUXJVXPRUXNUXJU
        XKVXPUXEUXDUXKVXPRZUXIUXEVXNTMZWVMVXOWVNVXLWVMVXNITIVXNLUWHUWIUXKVXLVXP
        VXQXQYDSWLYKYBUWJVXRYLUWKUYGAHUXTCUWLYFZVUTUCUYADVUQHUXTKYRWNUXQUXDFAYP
        NZMVXHVVMVVKWGUYEUXQFWVFWVPJUXQUXNWVFWVPMZUXJUXKUXNUXPUWOUXQWVJUXKVUKUX
        NWVQWGWVKUYHVUNABEIYQWNYTXOVXSVUTUCCDFHAKYRWNYOUWMUXQUXDUXEOZVUJUYDUYAH
        UXTULUMMZUYBVURQUXJUXOWVRUXPUXDUXEUXIUWPVKVULVUOUXQWVSWVIWVOUXQVXKWVBWV
        SWVIWGUXJUXOVXKUXPWVLVKUXQUXTVWMTVWNUXQUXIVWMTMUXDUXEUXIUXOUXPUWQGAUXHY
        MSXOHUXTUYATTXPYLWOUXTBUYADEVUQHIVUQUXCKLYSUWRUXQUXDUXEUXOUXPUXSVUSQUYE
        UYFUXJUXOUXPUWSVUPABCDEFHIJKLYSUWTUXAUXB @.
    @}
  @}

  @c IsolatedPt @.

  @( Extend class notation to include isolated points. @)
  cisopt @a class IsolatedPt @.

  @{
    @d j a x v @.
    @( Definition of an isolated point.  Experimental.  (Contributed by FL,
       16-Sep-2013.) @)
    df-islpt @a |- IsolatedPt = ( j e. Top |-> ( a e. ~P U. j |->
      { x e. a |
        E. v e. ( ( nei ` j ) ` { x } ) ( v i^i a ) = { x } } ) ) @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Uniform spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c UnifSp @. @( The class of all uniform spaces. @)

  @( Extend class notation with the class of all uniform spaces. @)
  cunifsp @a class UnifSp @.

  @{
    @d f y x t v u w s a z @.
    @( Definition of a uniform space.  Bourbaki TG II.1 def. 1.  A uniform
       structure is used to give a generalization of the idea of Cauchy's
       sequence.  We consider the space is equipped with the topology induced
       by the uniform structure.  (Contributed by FL, 29-May-2014.) @)
    df-unifsp @a |- UnifSp = { f | E. y E. x E. t
     ( ( y = ( Base ` f ) /\ x = ( Unif ` f ) /\ t = ( TopOpen ` f ) )
     /\ ( x C_ ~P ( y X. y )
           /\ ( y X. y ) e. x
           /\ A. v e. x (
               A. u e. ~P ( y X. y ) ( v C_ u -> u e. x )
               /\ A. w e. x ( v i^i w ) e. x
               /\ ( ( _I |` y ) C_ v
                    /\ `' v e. x
                    /\ E. w e. x ( w o. w ) C_ v ) ) )
      /\ t = ( iota_ s e. Top ( U. s = y /\ A. a e. y
             ( ( nei ` s ) ` { a } ) =
                   { z | E. u e. x z = ( u " { a } ) } ) ) ) } @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Separated spaces: T0, T1, T2 (Hausdorff) ...
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( A Hausdorff space is a T1 space.  (Contributed by FL, 18-Jun-2007.) @)
  hst1 @p |- Haus C_ Fre @=
    ( vx cha ct1 cv haust1 ssriv ) ABCADEF @.

  @{
    dtt1.1 @e |- A e. _V @.
    @( A discrete topology is T1.  Morris, Topology without tears.
       (Contributed by FL, 8-Jun-2007.) @)
    dtt1 @p |- ~P A e. Fre @=
      ( cvv wcel cpw cha ct1 dishaus haust1 mp2b ) ACDAEZFDKGDBACHKIJ @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Compactness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( The indiscrete topology is compact.  (Contributed by FL, 2-Aug-2009.) @)
  indcomp @p |- { (/) , A } e. Comp @=
    ( c0 cpr ctop cfn cin wcel ccmp indistop prfi elin mpbir2an fincmp ax-mp )
    BACZDEFGZOHGPODGOEGAIBAJODEKLOMN @.

  @( A topology whose underlying set is finite is compact.  (Contributed by FL,
     22-Dec-2008.) @)
  topunfincomp @p |- ( ( J e. Top /\ U. J e. Fin ) -> J e. Comp ) @=
    ( cuni cfn wcel ctop ccmp unfinsef wa cin elin fincmp sylbir sylan2 ) ABCDA
    EDZACDZAFDZAGNOHAECIDPAECJAKLM @.

  @{
    @( The subspace topology induced by a finite part of the underlying set of
       a topology is compact.  (Contributed by FL, 2-Aug-2009.)  (Proof
       shortened by Mario Carneiro, 21-Mar-2015.) @)
    stfincomp @p |- ( ( J e. Top /\ A e. Fin ) -> ( J |`t A ) e. Comp ) @=
      ( ctop wcel cfn wa crest co cuni ccmp resttop cin eqid restuni2 wss simpr
      inss1 ssfi sylancl eqeltrrd topunfincomp syl2anc ) BCDZAEDZFZBAGHZCDUFIZE
      DUFJDABEKUEABIZLZUGEABEUHUHMNUEUDUIAOUIEDUCUDPAUHQAUIRSTUFUAUB @.
  @}

  @{
    @d b f o x z A @.  @d a b f o x z J @.  @d a b f o x z X @.
    bwt2.1 @e |- X = U. J @.
    @( The glorious Bolzano-Weierstrass theorem.  Certainly the first general
       topology theorem ever proved.  In his course Weierstrass called it a
       lemma.  He certainly didn't know how famous this theorem would be.  He
       used an euclidian space instead of a general compact space.  And he was
       not conscious of the Heine-Borel property.  Cantor was one of his
       students.  He used the concept of neighborhood and limit point invented
       by his master when he studied the linear point sets and the rest of the
       general topology followed from that.  (Contributed by FL, 2-Aug-2009.)
       (Revised by Mario Carneiro, 15-Dec-2013.) @)
    bwt2OLD @p |- ( ( J e. Comp /\ A C_ X /\ -. A e. Fin ) ->
     E. x e. X x e. ( ( limPt ` J ) ` A ) ) @=
      ( vo vz wcel wss cfn wn cv wrex cdif cin c0 wi wa syl wceq vf va ccmp w3a
      vb clp cfv csn wne wral wb ctop cmptop islp3 3exp rexbidva notbid 3adant3
      imp31 nrexralim wf wex cvv cuni uniexg syl5eqel eleq2 nne ineq1 eqeq1d
      syl5bb anbi12d 3ad2ant1 crn cpw frn vex rnex elpw sylibr adantr syl6sseqr
      ac6sg wal df-ral pm2.27 cdm fdm biimpd wfun ffun fvelrn ex elunii idd a1i
      uniss com13 com4l com23 mpcom syl6com eqcoms impcom pm2.43a alimdv syl5bi
      syl6 com12 3impia dfss2 simp1 eqssd imp iscmp unieq eqeq2d ineq1d rexeqdv
      jca pweq imbi12d rspcv elin sseq2 infssuni elelpwi wfn nfim eqtr difindir
      com3l eqtr2 mpan adantl sylbi com3r syl6bi rexlimiv syl8 ffn nfra1 eleq1d
      fvelrnb nfre1 ineq2 difeq1 0dif difabs ineq2i eqcomi incom difeq1i eleq1i
      0fin eleq1 syl5bbr mpbiri snfi difinf mpan2 con4i 3syl pm2.24d ax-mp ee10
      nfv imim2i sps rexlimi com24 com4r 3impd 3imp exlimiv syld sylbid pm2.18d
      3expd ) CUCHZBDIZBJHKZUDZALZBCUFUGUGHZADMZUWCUWFKZUWDFLZHZUWHBUWDUHZNZOZP
      UIZQFCUJZADMZKZUWFUVTUWAUWGUWPUKUWBUVTUWARZUWFUWOUWQUWEUWNADUVTUWAUWDDHZU
      WEUWNUKZUVTCULHZUWAUWRUWSQQCUMUWTUWAUWRUWSFUWDBCDEUNUOSUSUPUQURUWPUWIUWMK
      ZRZFCMADUJZUWCUWFUWIUWMAFDCUTUWCUXCDCUALZVAZUWDUWDUXDUGZHZUXFUWKOZPTZRZAD
      UJZRZUAVBZUWFUVTUWAUXCUXMQZUWBUVTDVCHUXNUVTDCVDZVCECUCVEVFUXBUXJAFDCUAVCU
      WHUXFTZUWIUXGUXAUXIUWHUXFUWDVGUXAUWLPTUXPUXIUWLPVHUXPUWLUXHPUWHUXFUWKVIVJ
      VKVLWCSVMUXMUWCUWFUXLUWCUWFQZUAUXDVNZCVOZHZDUXRVDZTZRZUXLUXQUXLUXTUYBUXEU
      XTUXKUXEUXRCIZUXTDCUXDVPZUXRCUXDUAVQVRVSVTWAUXEUXKUYBUYADIZUXEUXKUYBQUXEU
      YAUXODUXEUYDUYAUXOIUYEUXRCWQSEWBUYFUXEUXKUYBUYFUXEUXKUDZDUYAUYGUWRUWDUYAH
      ZQZAWDZDUYAIUYFUXEUXKUYJUXKUWRUXJQZAWDZUYFUXERZUYJUXJADWEZUYMUYKUYIAUWRUY
      KUYMUYHUYKUWRUYMUYHQZUWRUYKUXJUWRUYOQZUWRUXJWFUXGUYPUXIUYMUWRUXGUYHUXEUYF
      UWRUXGUYHQZQZUXDWGZDTUXEUYFUYRQZDCUXDWHUXEUYTQDUYSUWRDUYSTZUXEUYFUYQVUAUW
      RUWDUYSHZUXEUYFUYQQZQZVUAUWRVUBDUYSUWDVGWIUXEVUBVUCUXDWJZUXEVUBVUCQDCUXDW
      KVUEVUBUXEVUCVUEVUBUXFUXRHZVUDVUEVUBVUFUWDUXDWLWMUXGVUFUXEUYFUYHUXGVUFUYH
      UXEUYFUYHQQUXGVUFUYHUWDUXFUXRWNWMUYFUXEUYHUYHUXEUYHUYHQQUYFUXEUYHWOWPWRXH
      WSXHWTXAXIXBWSXCXAXDWRWAXHXEWRXFXGXJADUYAXKVTUYFUXEUXKXLXMUOXAXNXTUWCUXLU
      YCUWFUVTUWAUWBUXLUYCUWFQZQZUVTUWTDUBLZVDZTZDGLZVDZTZGVUIVOZJOZMZQZUBUXSUJ
      ZRUWAUWBVUHQQZUBGCDEXOVUSVUTUWTVUSUWAUWBUXLVUGUYCVUSUWAUWBUXLUDZUWFUXTUYB
      VUSVVAUWFQZQUXTVUSUYBVVBUXTVUSUYBVUNGUXRVOZJOZMZVVBVURUYBVVEQUBUXRUXSVUIU
      XRTZVUKUYBVUQVVEVVFVUJUYADVUIUXRXPXQVVFVUNGVUPVVDVVFVUOVVCJVUIUXRYAXRXSYB
      YCVVEUWAUWBUXLUWFVUNUWAUWBUXLUWFQZQZQZGVVDVULVVDHVULVVCHZVULJHZRZVUNVVIQV
      ULVVCJYDVUNUWAVVLVVHVUNUWABVUMIZVVLVVHQDVUMBYEVVLVVMVVHVVJVVKVVMVVHQVVKVV
      MUWBVVJVVGVVKVVMUWBBUELZOZJHZKZUEVULMZVVJVVGQZUWBVVKVVMVVRUWBVVKVVMVVRUEB
      VULYFUOYLVVQVVSUEVULVVNVULHZVVJVVQVVGVVTVVJVVNUXRHZVVQVVGQVVTVVJVWAVVNVUL
      UXRYGWMUXLVVQVWAUWFUXEUXKVVQVWAUWFQQZUXEUXDDYHZUXKVWBQDCUXDUUAVWCVWAVVQUX
      KUWFVWCVWAUXFVVNTZADMVVQUXKUWFQZQZADVVNUXDUUDVWDVWFADVVQVWEAVVQAUVGUXKUWF
      AUXJADUUBUWEADUUEYIYIVWDVVQUWRVWEVWDVVQBUXFOZJHZKZUWRVWEQVVQVWIQVVNUXFVVN
      UXFTZVVQVWIVWJVVPVWHVWJVVOVWGJVVNUXFBUUFUUCUQWIXCUXKUWRVWIUWFUXKUYLUWRVWI
      UWFQZQZUYNUYKVWLAUXJVWKUWRUXIVWKUXGUXIUXHUWJNZPUWJNZTZVWNPTZVWKUXHPUWJUUG
      UWJUUHVWOVWPVWMPTZVWKVWOVWPVWQVWMVWNPYJWMVWMUXFUWJNZUWKUWJNZOZTVWQVWKQZUX
      FUWKUWJYKVXAVWTVWMVWTVWMTZVWQVWKVXBVWQRVWTPTZVWKVWTVWMPYJVXCVWHUWFVWTVWRU
      WKOZTZVXCVWHVWSUWKVWRBUWJUUIUUJVXEVXCRVXDPTZVWHVWTVXDPYMVXDUXFBOZUWJNZTZV
      XFVWHVXHVXDUXFBUWJYKUUKVXIVXFRVXHPTZVWGUWJNZJHZVWHVXDVXHPYMVXJVXLPJHZUUOV
      XLVXHJHVXJVXMVXHVXKJVXGVWGUWJUXFBUULUUMUUNVXHPJUUPUUQUURVWHVXLVWIUWJJHVXL
      KUWDUUSVWGUWJUUTUVAUVBUVCYNSYNUVDSWMXCUVEXHUVFYOUVHUVIYPWRXHYQUVJYRUVKSXN
      WRXHWTYSYTUVLXNXIYRYQYPYSUVMYTWTXNYLUVSYOYPUVNWRXAUVOXIUVPXGUVQUVR @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Connectedness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( The singleton of the empty set is a connected topology.  (Contributed by
     FL, 22-Dec-2008.)  (Revised by Mario Carneiro, 11-Nov-2013.) @)
  singempcon @p |- { (/) } e. Con @=
    ( c0 csn cpr ccon dfsn2 indiscon eqeltri ) ABAACDAEAFG @.

  @{
    @d x y A @.  @d x y J @.  @d x y X @.  @d y B @.
    usinuniopb.1 @e |- X = U. J @.
    @( If a topology is connected, its underlying set can't be partitioned into
       two non-empty non-overlapping open sets.  (Contributed by FL,
       29-May-2014.)  (Revised by Mario Carneiro, 8-Apr-2015.) @)
    usinuniopb @p |- ( ( J e. Con /\ A e. J /\ B e. J ) ->
       ( ( A =/= (/) /\ B =/= (/) /\ ( A i^i B ) = (/) )
         -> X =/= ( A u. B ) ) ) @=
      ( ccon wcel w3a c0 wne cin wceq cun wa simpl1 simpl2 simpr1 simpl3 simpr2
      simpr3 conndisj necomd ex ) CFGZACGZBCGZHZAIJZBIJZABKILZHZDABMZJUGUKNZULD
      UMABCDEUDUEUFUKOUDUEUFUKPUGUHUIUJQUDUEUFUKRUGUHUIUJSUGUHUIUJTUAUBUC @.
  @}

  @c opfn @.

  @( Extend class notation with an operator that derives an operation on
     functions from an operation on the elements of the common range of those
     functions. @)
  copfn @a class opfn @.

  @{
    @d g i h x y z a b @.
    @( Multiplication or addition of two functions ` x ` and ` y ` derived from
       the operation ` g ` on the elements of the common range of ` x ` and
       ` y ` .  The functions ` x ` and ` y ` must also have the same domain
       ` i ` .  (Contributed by FL, 15-Oct-2012.) @)
    df-opfn @a |- opfn = ( g e. _V , i e. _V |->
       ( x e. ( dom dom g ^m i ) , y e. ( dom dom g ^m i ) |->
         ( a e. dom x |-> ( ( x ` a ) g ( y ` a ) ) ) ) ) @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Topological fields
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c TopFld @.

  @( Extend class notation to include TopFld. @)
  ctopfld @a class TopFld @.

  @{
    @d g h j @.
    @( A topological field is a field whose addition, multiplication and
       inverse are continuous.  (Contributed by FL, 21-May-2012.) @)
    df-topfld @a |- TopFld = { <. <. g , h >. , j >. | ( <. g , h >. e. Fld /\
      <. <. g , h >. , j >. e. TopRing /\
      ( h |` ( ( ran g \ { ( GId ` g ) } ) X. ( ran g \ { ( GId ` g ) } ) ) )
      e. ( ( j tX j ) Cn j ) ) } @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Standard topology on RR
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( Condition for an interval to belong to the range of ` (,) ` (Contributed
     by FL, 5-Jan-2009.) @)
  intrn @p |- ( ( A e. RR* /\ B e. RR* ) -> ( A (,) B ) e. ran (,) ) @=
    ( cxr cxp cr cpw cioo wf wfn wcel wa co crn wi ioof ffn fnovrn 3expib mp2b
    ) CCDZEFZGHGTIZACJZBCJZKABGLGMJZNOTUAGPUBUCUDUECCABGQRS @.

  @{
    @d a b r u y A @.
    @( Alternate definition of the standard topology of the reals.  (Morris.
       Def. 2.1.1 p. 34).  Morris calls the standard topology of the reals the
       euclidean topology.  (Contributed by FL, 26-Jan-2009.)  (Proof shortened
       by Mario Carneiro, 10-Sep-2015.) @)
    altretop @p |- ( A e. ( topGen ` ran (,) ) <-> ( A C_ RR
              /\ A. y e. A E. a e. RR E. b e. RR
            ( y e. ( a (,) b ) /\ ( a (,) b ) C_ A ) ) ) @=
      ( vr vu cioo cfv wcel cr wss cv co wa wrex wral crp wceq cxr ax-mp ctopon
      crn ctg retopon toponss mpan cabs cmin ccom cxp cres cbl cxmt eqid rexmet
      cmopn tgioo mopni2 mp3an1 sselda ad2antrr rpre ad2antlr resubcld readdcld
      caddc simplr blcntr syl2anc bl2ioo eleqtrd eqsstr3d eleq2d sseq1d anbi12d
      simpr oveq1 oveq2 rspc2ev syl112anc ex rexlimdva mpd ralrimiva jca ressxr
      wi ssrexv reximi mpsyl cvv wb ovex rgen2w wfn cmpt2 cpw wf ioof fnov mpbi
      ffn eleq2 sseq1 rexrnmpt2 sylibr ralimi adantl ctb retopbas eltg2b impbii
      ) BGUBZUCHZIZBJKZALZCLZDLZGMZIZXTBKZNZDJOZCJOZABPZNZXOXPYFXNJUAHIXOXPUDBX
      NJUEUFZXOYEABXOXQBIZNZXQELZUGUHUIJJUJUKZULHMZBKZEQOZYEYLJUMHIZXOYIYOYLYLU
      NZUOZEBYLXQXNJYLYLUPHZYQYSUNUQURUSYJYNYEEQYJYKQIZNZYNYEUUAYNNZXQYKUHMZJIX
      QYKVFMZJIXQUUCUUDGMZIZUUEBKZYEUUBXQYKYJXQJIZYTYNXOBJXQYHUTVAZYTYKJIZYJYNY
      KVBVCZVDUUBXQYKUUIUUKVEUUBXQYMUUEUUBUUHYTXQYMIZUUIYJYTYNVGYPUUHYTUULYRYLX
      QYKJVHUSVIUUBUUHUUJYMUUERUUIUUKXQYKYLYQVJVIZVKUUBUUEYMBUUMUUAYNVPVLYCUUFU
      UGNXQUUCXSGMZIZUUNBKZNCDUUCUUDJJXRUUCRZYAUUOYBUUPUUQXTUUNXQXRUUCXSGVQZVMU
      UQXTUUNBUURVNVOXSUUDRZUUOUUFUUPUUGUUSUUNUUEXQXSUUDUUCGVRZVMUUSUUNUUEBUUTV
      NVOVSVTWAWBWCWDWEYGXQFLZIZUVABKZNZFXMOZABPZXOYFUVFXPYEUVEABYEYCDSOZCSOZUV
      EJSKZYEUVGCJOUVHWFYDUVGCJUVIYDUVGWGWFYCDJSWHTWIUVGCJSWHWJXTWKIZDSPCSPUVEU
      VHWLUVJCDSSXRXSGWMWNUVDYCCDFSSXTGWKGSSUJZWOZGCDSSXTWPRUVKJWQZGWRUVLWSUVKU
      VMGXBTCDSSGWTXAUVAXTRUVBYAUVCYBUVAXTXQXCUVAXTBXDVOXETXFXGXHXMXIIXOUVFWLXJ
      AFBXMXIXKTXFXL @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Standard topology of intervals of RR
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d A x y @.  @d B x y @.
    @( The underlying set of the standard topology on an open interval is the
       open interval itself.  (Contributed by FL, 31-May-2007.)  (Revised by
       Mario Carneiro, 15-Dec-2013.) @)
    stoi @p |- { <. ( Base ` ndx ) , ( A (,) B ) >. ,
 <. ( TopSet ` ndx ) , ( ( topGen ` ran (,) ) |`t ( A (,) B ) ) >.
    } e. TopSp @=
      ( cioo crn ctg cfv crest ctopon wcel cnx cbs cop cts cpr ctps wss retopon
      co cr ioossre resttopon mp2an eqid eltpsg ax-mp ) CDEFZABCRZGRZUGHFIZJKFU
      GLJMFUHLNZOIUFSHFIUGSPUIQABTUGUFSUAUBUGUHUJUJUCUDUE @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Cantor's set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    @d f k n x @.
    cntrset.1 @e |- C = { x | E. f e. ( { 0 , 2 } ^m NN )
          x = sum_ k e. NN ( ( f ` k ) / ( 3 ^ k ) ) } @.
    @( Cantor's set is between ` 0 ` and ` 1 ` .  Viro p. 15.  (Contributed by
       FL, 17-Oct-2010.)  (Proof shortened by Mario Carneiro, 2-Jun-2014.) @)
    cntrset @p |- C C_ ( 0 [,] 1 ) @=
      ( vn cn c3 cexp co cdiv wceq cc0 c2 c1 wcel cr cle wbr a1i cv cfv csu cpr
      cmap wrex cab cicc wi wf prex nnex elmap cmpt nnuz cz fveq2 oveq2 oveq12d
      1z eqid ovex fvmpt adantl wa ffvelrn fvex elpr sylib 0re eleq1 mpbiri 2re
      wo jaoi syl cn0 3nn nnnn0 nnexpcl sylancr nndivred oveq2d nndivre eqeltrd
      1nn caddc cseq cmul cli cdm cc 2cn cmin nnrecre ax-mp recnd cabs clt 1lt3
      3re recgt1i mp2an simpli ltleii absid simpri syl6eqbr cuz simpr syl6eleqr
      1nn0 geolim2 recni exp1 ax-1cn 3ne0 pm3.2i divsubdir mp3an 2p1e3 subadd2i
      wne 3cn mpbir oveq1i 3eqtr3ri oveq12i 2ne0 divcan7 eqtri syl6breq reexpcl
      dividi nnred nnne0d leidi breq2 syldan breq1 divrecd exprecd eqtrd breldm
      3eqtr4d isermulc2 seqex 2pos nngt0d divge0 syl22anc breqtrrd wb syl112anc
      nnz lediv1 3brtr4d cvgcmp isumrecl isumge0 isumle recidi isumclim breqtrd
      mpbid 1re elicc2i syl3anbrc sylbi eleq1a rexlimiv abssi eqsstri ) BAUAZGD
      UAZCUAZUBZHUVOIJZKJZDUCZLZCMNUDZGUEJZUFZAUGMOUHJZEUWDAUWEUWAUVNUWEPZCUWCU
      VPUWCPZUVTUWEPZUWAUWFUIUWGGUWBUVPUJZUWHUWBGUVPMNUKULUMUWIUVTQPMUVTRSUVTOR
      SUWHUWIUVSDFGFUAZUVPUBZHUWJIJZKJZUNZOGUOOUPPUWIUTTZUVOGPZUVOUWNUBZUVSLUWI
      FUVOUWMUVSGUWNUWJUVOLZUWKUVQUWLUVRKUWJUVOUVPUQUWJUVOHIURZUSUWNVAUVQUVRKVB
      VCVDZUWIUWPVEZUVQUVRUXAUVQMLZUVQNLZVNZUVQQPZUXAUVQUWBPUXDGUWBUVOUVPVFUVQM
      NUVOUVPVGVHVIZUXBUXEUXCUXBUXEMQPVJUVQMQVKVLUXCUXENQPZVMUVQNQVKVLVOVPZUXAH
      GPZUVOVQPZUVRGPZVRUWPUXJUWIUVOVSVDZHUVOVTWAZWBZUWIDFGNUWLKJZUNZUWNOOGUOOG
      PUWIWFTUXAUVOUXPUBZNUVRKJZQUWPUXQUXRLUWIFUVOUXOUXRGUXPUWRUWLUVRNKUWSWCUXP
      VANUVRKVBVCVDZUXAUXGUXKUXRQPVMUXMNUVRWDWAZWEUXAUWQUVSQUWTUXNWEUWIWGUXPOWH
      ZNONKJZWIJZWJSUYAWJWKPUWIUYBNDFGOHKJZUWJIJZUNZUXPOGUOUWONWLPZUWIWMTUWIWGU
      YFOWHUYDOIJZOUYDWNJZKJZUYBWJUWIUYDDUYFOUWIUYDUYDQPZUWIUXIUYKVRHWOWPZTWQUW
      IUYDWRUBZUYDOWSUWIUYKMUYDRSZUYMUYDLUYLUYNUWIMUYDVJUYLMUYDWSSZUYDOWSSZHQPO
      HWSSUYOUYPVEXAWTHXBXCZXDXETUYDXFWAUYOUYPUYQXGXHOVQPUWIXLTUWIUVOOXIUBZPZVE
      ZUWPUVOUYFUBZUYDUVOIJZLZUYTUVOUYRGUWIUYSXJUOXKZFUVOUYEVUBGUYFUWJUVOUYDIUR
      UYFVAUYDUVOIVBVCZVPXMUYJUYDNHKJZKJZUYBUYHUYDUYIVUFKUYDWLPUYHUYDLUYDUYLXNU
      YDXOWPHOWNJZHKJZHHKJZUYDWNJZVUFUYIHWLPZOWLPZVULHMYCZVEZVUIVUKLYDXPVULVUNY
      DXQXRZHOHXSXTVUHNHKVUHNLNOWGJHLYAHONYDXPWMYBYEYFVUJOUYDWNHYDXQYNYFYGYHVUM
      UYGNMYCZVEVUOVUGUYBLXPUYGVUQWMYIXRVUPONHYJXTYKYLUXAVUAUXAVUAVUBQUWPVUCUWI
      VUEVDZUXAUYKUXJVUBQPUYLUXLUYDUVOYMWAWEWQUXAUXRNOUVRKJZWIJUXQNVUAWIJUXANUV
      RUYGUXAWMTUXAUVRUXAUVRUXMYOZWQUXAUVRUXMYPUUAUXSUXAVUAVUSNWIUXAVUAVUBVUSVU
      RUXAHUVOVULUXAYDTVUNUXAXQTUWPUVOUPPUWIUVOUUOVDUUBUUCWCUUEUUFZUYAUYCWJWGUX
      POUUGNUYBWIVBUUDVPZUWIUYSUWPMUWQRSVUDUXAMUVSUWQRUXAUXEMUVQRSZUVRQPZMUVRWS
      SZMUVSRSUXHUXAUXDVVCUXFUXBVVCUXCUXBVVCMMRSMVJYQUVQMMRYRVLUXCVVCMNRSZMNVJV
      MUUHXEZUVQNMRYRVLVOVPVUTUXAUVRUXMUUIZUVQUVRUUJUUKZUWTUULYSUWIUYSUWPUWQUXQ
      RSVUDUXAUVSUXRUWQUXQRUXAUVQNRSZUVSUXRRSZUXAUXDVVJUXFUXBVVJUXCUXBVVJVVFVVG
      UVQMNRYTVLUXCVVJNNRSNVMYQUVQNNRYTVLVOVPUXAUXEUXGVVDVVEVVJVVKUUMUXHUXGUXAV
      MTVUTVVHUVQNUVRUUPUUNUVEZUWTUXSUUQYSUURZUUSUWIUVSDUWNOGUOUWOUWTUXNVVMVVIU
      UTUWIUVTGUXRDUCORUWIUVSUXRDUWNUXPOGUOUWOUWTUXNUXSUXTVVLVVMVVBUVAUWIUXRODU
      XPOGUOUWOUXSUXAUXRUXTWQUWIUYAUYCOWJVVANWMYIUVBYLUVCUVDMOUVTVJUVFUVGUVHUVI
      UVTUWEUVNUVJVPUVKUVLUVM @.

  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
         Pre-calculus and Cartesian geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( Distance between the middle of a segment and one of its extremities is a
     positive real.  (Contributed by FL, 27-Dec-2007.) @)
  dmse1 @p |- ( ( A e. RR /\ B e. RR /\ A =/= B ) ->
    ( ( abs ` ( A - B ) ) / 2 ) e. RR+ ) @=
    ( cr wcel wne w3a cmin co cabs cfv cc wa resubcl recnd 3adant3 wceq wn recn
    cc0 wb subeq0 syl2an biimpd necon3ad 3impia df-ne sylibr absrpcld rphalfcld
    ) ACDZBCDZABEZFZABGHZIJUMUNUJUKUNKDULUJUKLZUNABMNOUMUNSPZQZUNSEUJUKULUQUOUP
    ABUOUPABPZUJAKDBKDUPURTUKARBRABUAUBUCUDUEUNSUFUGUHUI @.

  @( Distance between the middle of a segment and one of its extremities is a
     positive real.  (Contributed by FL, 27-Dec-2007.) @)
  dmse2 @p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
    ( ( abs ` ( A - B ) ) / 2 ) e. RR+ ) @=
    ( cr wcel clt wbr wne cmin co cabs cfv c2 cdiv crp w3a ltneOLD necomd dmse1
    syld3an3 ) ACDZBCDZABEFZABGABHIJKLMINDTUAUBOBAABPQABRS @.

  @( The midpoint of a segment AB of the real line is a real.  (Contributed by
     FL, 27-Dec-2007.) @)
  msr3 @p |- ( ( A e. RR /\ B e. RR ) ->
   ( B - ( ( abs ` ( A - B ) ) / 2 ) ) e. RR ) @=
    ( cr wcel wa cmin co cabs cfv c2 cdiv simpr recnd abscld rehalfcld resubcld
    resubcl ) ACDZBCDZEZBABFGZHIZJKGRSLTUBTUATUAABQMNOP @.

  @( The midpoint of a segment AB of the real line is a real.  (To FL:  The
     proof was shortened.  Also, it is too specialized, and set.mm size will be
     reduced if it is placed directly in the proof using it. --NM) (Contributed
     by FL, 27-Dec-2007.) @)
  msr4 @p |- ( ( A e. RR /\ B e. RR ) ->
    ( A + ( ( abs ` ( B - A ) ) / 2 ) ) e. RR ) @=
    ( cr wcel cmin co cabs cfv c2 cdiv caddc wa resubcl ancoms abscld rehalfcld
    cc recnd readdcl syldan ) ACDZBCDZBAEFZGHZIJFZCDAUEKFCDUAUBLZUDUFUCUBUAUCQD
    UBUALUCBAMRNOPAUEST @.

  @( The midpoint of a segment AB of the real line is on the "left" of ` B ` .
     (Contributed by FL, 2-Jan-2008.) @)
  mslb1 @p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
     ( A + ( ( abs ` ( B - A ) ) / 2 ) ) < B ) @=
    ( cr wcel clt wbr c2 cmul co cmin caddc wceq cc wa 3adant3 syl recnd mpbird
    cc0 adantr w3a cdiv cabs cfv 2cn a1i recn 3ad2ant1 crp ancoms abssub oveq1d
    anim12i dmse2 eqeltrd rpcnd adddid subcl wne 2ne0 divcan2d resubcl cle ltle
    abscld 3impia wb pm3.22 subge0 absidd oveq2d 2re remulcl mpan readdcld msr4
    eqtrd pm3.2i divmul mp3an3 syl2anc simp3 simp1 simpl3 jca 3ad2ant2 breqtrrd
    2timesd pncan simp2 3brtr4d eqbrtrd mpdan cneg negsubd sub32d negidd subidd
    eqcomd anidms adantl negcl subaddd 3eqtr2rd mulcl 3jca addass eqtr4d addcld
    simpr negsub 3eqtr3d breq1d biimpa ltsub1 2pos ltdivmul eqbrtrrd ) ACDZBCDZ
    ABEFZUAZGAHIZBAJIZKIZGUBIZAYDUCUDZGUBIZKIZBEYBYFYILZGYIHIZYELZYBYKYCGYHHIZK
    IYEYBGAYHGMDZYBUEUFZXSXTAMDZYAAUGZUHZYBYHYBYHABJIUCUDZGUBIUIYBYGYSGUBYBBMDZ
    YPNZYGYSLXSXTUUAYAXTXSUUAXTYTXSYPBUGZYQUMUJOZBAUKPULABUNUOUPUQYBYMYDYCKYBYM
    YGYDYBYGGYBYGYBYDYBUUAYDMDZUUCBAURZPVEQYOGSUSZYBUTUFVAYBYDXSXTYDCDZYAXTXSUU
    GBAVBUJZOZYBSYDVCFZABVCFZXSXTYAUUKABVDVFYBXTXSNZUUJUUKVGXSXTUULYAXSXTVHOBAV
    IPRVJVQVKVQXSXTYJYLVGZYAXSXTNZYEMDZYIMDZUUMUUNYEUUNYCYDXSYCCDZXTGCDZXSUUQVL
    GAVMVNZTUUHVOQUUNYIABVPQUUOUUPYNUUFNUUMYNUUFUEUTVRYEYIGVSVTWAORYBYFBEFZYEGB
    HIZEFZYBYCAJIZUVABJIZEFZUVBYBYAUVEXSXTYAWBYBYANZUVCAAKIZAJIZUVDEUVFYCUVGAJY
    BYCUVGLYAYBAYBAXSXTYAWCQZWHTULUVFABBKIZBJIZUVHUVDEUVFABUVKEXSXTYAYAWDUVFYTY
    TNZUVKBLYBUVLYAXTXSUVLYAXTYTYTUUBUUBWEWFTBBWIPWGUVFYPYPNZUVHALYBUVMYAXSXTUV
    MYAXSYPYPYQYQWEUHTAAWIPUVFUVAUVJBJYBUVAUVJLYAYBBYBBXSXTYAWJZQWHTULWKWLWMYBU
    VENZUVBYEBJIZUVDEFZYBUVEUVQYBUVCUVPUVDEYBYCAWNZKIZYEBWNZKIZUVCUVPYBUVSYCYDU
    VTKIZKIZUWAYBUVRUWBYCKYBUWBYDBJIBBJIZAJIZUVRYBYDBYBYPYTNZUUDXSXTUWFYAXSYPXT
    YTYQUUBUMOZYTYPUUDUUEUJZPXTXSYTYAUUBWFZWOYBBBAUWIUWIYRWPYBUWEUVRLAUVRKIZUWD
    LYBUWJSUWDYBAUVIWQXTXSSUWDLYAXTUWDSXTBUUBWRWSWFVQYBUWDAUVRYBUWFUWDMDZUWGYTU
    WKYPYTUWKBBURWTXAPYRYBYPUVRMDUVIAXBPXCRXDVKYBYCMDZUUDUVTMDZUAZUWAUWCLYBUWFU
    WNUWGUWFUWLUUDUWMYPUWLYTYNYPUWLUEGAXEVNZTZUWHYTUWMYPBXBXAXFPYCYDUVTXGPXHYBY
    CAYBYPUWLUVIUWOPYRWOYBUUOYTNZUWAUVPLYBUWFUWQUWGUWFUUOYTUWFYCYDUWPUWHXIYPYTX
    JWEPYEBXKPXLXMXNUVOYECDZUVACDZXTUAZUVBUVQVGYBUWTUVEYBUWRUWSXTYBYCYDXSXTUUQY
    AUUSUHUUIVOZXTXSUWSYAUURXTUWSVLGBVMVNWFUVNXFTYEUVABXOPRWMYBUWRXTUUTUVBVGZUX
    AUVNUWRXTUURSGEFZNUXBUURUXCVLXPVRYEBGXQVTWARXR @.

  @( Two ways to state the midpoint of a segment.  (Contributed by FL,
     3-Jan-2008.) @)
  2wsms @p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
    ( ( A + B ) / 2 ) = ( B - ( ( abs ` ( A - B ) ) / 2 ) ) ) @=
    ( cr wcel wbr w3a c2 caddc co cdiv cmul cmin wceq cc wa 3adant3 syl subaddd
    recnd mpbid clt cabs cfv recn anim12i subcl abscld 2cn a1i cc0 wne divcan2d
    2ne0 resubcl eqeltrd 3ad2ant1 3ad2ant2 addass eqcomd syl3anc addcld addcomd
    simp2 2timesd oveq1d jca pncan cle 3impia abssuble0 syld3an3 eqtr2d 3eqtr2d
    ltle eqtrd mulcl 3eqtrd addcl mpbird dmse2 rpcnd subdid halfaddsubcl simpld
    sylancr 3eqtr4rd msr3 mulcand ) ACDZBCDZABUAEZFZGABHIZGJIZKIZGBABLIZUBUCZGJ
    IZLIZKIZMWNWSMWLGBKIZGWRKIZLIZWMWTWOWLXCWMMXBWMHIZXAMWLXDXBAHIZBHIZBXEHIZXA
    WLXBNDZANDZBNDZXDXFMWLXBWQNWLWQGWLWQWLWPWLXIXJOZWPNDWIWJXKWKWIXIWJXJAUDZBUD
    ZUEPZABUFQUGSGNDZWLUHUIZGUJUKWLUMUIZULZWLWQWLWPWLWPWIWJWPCDWKABUNPSUGSUOZWI
    WJXIWKXLUPZWJWIXJWKXMUQZXHXIXJFXFXDXBABURUSUTWLXEBWLXBAXSXTVAZYAVBWLXABLIZX
    EMXGXAMWLYCBBHIZBLIZXEWLXAYDBLWLBWLBWIWJWKVCSZVDVEWLYEBAXBHIZXEWLXJXJOZYEBM
    WJWIYHWKWJXJXJXMXMVFUQBBVGQWLBALIZXBMYGBMWLXBWQYIXRWIWJWKABVHEZWQYIMWIWJWKY
    JABVNVIABVJVKVLWLBAXBYAXTXSRTWLAXBXTXSVBVMVOWLXABXEWLXOXJXANDUHYFGBVPWEZYAY
    BRTVQWLXAXBWMYKXSWLXKWMNDXNABVRQZRVSWLGBWRXPYAWLWRABVTWAWBWLWMGYLXPXQULWFWL
    WNWSGWLXKWNNDZXNXKYMWPGJINDABWCWDQWLWSWIWJWSCDWKABWGPSXPXQWHT @.

  @( The midpoint of a segment AB of the real line is on the "right" of
     ` A ` .  (Contributed by FL, 3-Jan-2008.) @)
  msra3 @p |- ( ( A e. RR /\ B e. RR /\ A < B ) ->
    A < ( B - ( ( abs ` ( A - B ) ) / 2 ) ) ) @=
    ( cr wcel clt wbr w3a caddc co c2 cdiv cmin cabs cfv cmul simp1 recnd simp2
    times2d simp3 ltadd2dd eqbrtrd readdcl 3adant3 cc0 2re 2pos pm3.2i ltmuldiv
    wb wa mp3an3 syl2anc mpbid 2wsms breqtrd ) ACDZBCDZABEFZGZAABHIZJKIZBABLIMN
    JKILIEUTAJOIZVAEFZAVBEFZUTVCAAHIVAEUTAUTAUQURUSPZQSUTABAVFUQURUSRVFUQURUSTU
    AUBUTUQVACDZVDVEUJZVFUQURVGUSABUCUDUQVGJCDZUEJEFZUKVHVIVJUFUGUHAVAJUIULUMUN
    ABUOUP @.

  @{
    @d A x @.  @d x y @.
    @( Lemma for ~ iint .  (Contributed by FL, 27-Dec-2007.) @)
    iintlem1 @p |- ( ( A e. RR
                          /\ y e. |^|_ x e. RR+ ( ( A - x ) (,) ( A + x ) ) )
                       -> ( y e. RR -> y = A ) ) @=
      ( cr wcel crp co caddc wa wi wn ancoms adantr cc0 wb cxr clt wbr ad2antrl
      cmin cv cioo ciin wceq wral eliin wrex cabs cfv c2 cdiv resubcl recnd wne
      cc recn subeq0 syl2anr biimpd con3and df-ne sylibr absrpcld rphalfcld w3a
      simplr pm3.22 ad2antrr adantl msr3 syl simpll 0re ltsubadd2 simp2 addid1d
      breq2d bitrd 3exp com13 ax-mp imp msra3 syl3anc ltnsymd intn3an2d simprll
      impcom msr4 cle rexrd xrlenlt sylancr subge0 ltlen biimprcd com12 syl5bir
      0xr exp3a sylbid sylbird mslb1 intn3an3d pm2.61ian rpre sylan2 readdcl ex
      elioo1 mtbird jcai oveq2 oveq12d eleq2d notbid rspcev rexnal syl6ib con4d
      jca syl6 syl6bi pm2.43i impancom ) CDEZBUAZDEZYGAFCAUAZTGZCYIHGZUBGZUCZEZ
      YGCUDZYNYFYHIZYOYNYPYOJZYNYNYGYLEZAFUEZYQAYGFYLYMUFYPYSYOYPYOYSYPYOKZYRKZ
      AFUGZYSKYPYTYGCTGZUHUIZUJUKGZFEZYGCUUETGZCUUEHGZUBGZEZKZIZUUBYPYTUULYPYTI
      ZUUFUUKUUMUUDUUMUUCYPUUCUOEYTYPUUCYHYFUUCDEYGCULZLUMMUUMUUCNUDZKUUCNUNYPU
      UOYOYPUUOYOYHYGUOECUOEUUOYOOYFYGUPCUPYGCUQURUSUTUUCNVAVBVCVDUUMUUFUUKUUMU
      UFIZUUJYGPEZUUGYGQRZYGUUHQRZVEZUUCNQRZUUPUUTKUVAUUPIZUURUUQUUSUVBYGUUGUUM
      YHUVAUUFYFYHYTVFZSZUVBYHYFIZUUGDEZUUPUVEUVAYPUVEYTUUFYFYHVGVHVIYGCVJVKUVB
      YHYFYGCQRZYGUUGQRUVDUUMYFUVAUUFYFYHYTVLZSUUPUVAUVGYPUVAUVGJZYTUUFYFYHUVIN
      DEZYFYHUVIJJVMYHYFUVJUVIYHYFUVJUVIYHYFUVJVEZUVAUVGUVKUVAYGCNHGZQRUVGYGCNV
      NUVKUVLCYGQUVKCUVKCYHYFUVJVOUMVPVQVRUSVSVTWAWBVHWHYGCWCWDWEWFUVAKZUUPIZUU
      SUUQUURUVNUUHYGUVNYPUUHDEZUVMYPYTUUFWGCYGWIVKUUMYHUVMUUFUVCSZUVNYFYHCYGQR
      ZUUHYGQRUUMYFUVMUUFUVHSUVPUUPUVMUVQUUMUVMUVQJUUFUUMUVMNUUCWJRZUVQUUMNPEUU
      CPEZUVRUVMOWSYPUVSYTYHYFUVSUVEUUCUUNWKLMNUUCWLWMUUMUVRCYGWJRZUVQYPUVRUVTO
      ZYTYHYFUWAYGCWNLMYPYTUVTUVQJZYTYGCUNZYPUWBYGCVAYPUWCUVTUVQUWCUVTIYPUVQUVT
      UWCYPUVQJYPUVQUVTUWCICYGWOWPLWQWTWRWBXAXBMWHCYGXCWDWEXDXEUUPUUGPEZUUHPEZI
      ZUUJUUTOUUMUUFUWFYFUUFUWFJYHYTYFUUFUWFYFUUFIZUWDUWEUWGUUGUUFYFUUEDEZUVFUU
      EXFZCUUEULXGWKUWGUUHUUFYFUWHUVOUWICUUEXHXGWKYAXIVHWBUUGUUHYGXJVKXKXIXLXIU
      UAUUKAUUEFYIUUEUDZYRUUJUWJYLUUIYGUWJYJUUGYKUUHUBYIUUECTXMYIUUECHXMXNXOXPX
      QYBYRAFXRXSXTWQYCYDWQYE @.
  @}

  @{
    @d A x @.
    @( Lemma for ~ iint .  (Contributed by FL, 23-Dec-2007.) @)
    iintlem2 @p |- ( y e. |^|_ x e. RR+ ( ( A - x ) (,) ( A + x ) )
                    -> y e. RR ) @=
      ( crp cv cmin co caddc cioo ciin cr wss wrex c1 wcel ioossre wceq oveq12d
      1rp oveq2 sseq1d rspcev mp2an iinss ax-mp sseli ) ADCAEZFGZCUGHGZIGZJZKBE
      UJKLZADMZUKKLNDOCNFGZCNHGZIGZKLZUMSUNUOPULUQANDUGNQZUJUPKURUHUNUIUOIUGNCF
      TUGNCHTRUAUBUCADUJKUDUEUF @.
  @}

  @{
    @d A x y @.
    @( Indexed intersection of a set of open intervals centered on ` A ` .
       This theorem is a rough justification for taking finite intersections in
       the definition of a topology.  If we consider we are in the standard
       topology of ` RR ` , this theorem means a non finite intersection of
       open sets can result in a closed set.  (Contributed by FL,
       27-Dec-2007.) @)
    iint @p |- ( A e. RR
        -> |^|_ x e. RR+ ( ( A - x ) (,) ( A + x ) ) = { A } ) @=
      ( vy cr wcel crp cv cmin co caddc cioo ciin wceq crab csn iintlem2 adantl
      wa iintlem1 jcai ex wral cbci ralrimiva eliin mpbird eleq1 syl5ibr impbid
      wi com12 eqeq1 elrab syl6bbr eqrdv rabsn eqtrd ) BDEZAFBAGZHIBUSJIKIZLZUS
      BMZADNZBOURCVAVCURCGZVAEZVDDEZVDBMZRZVDVCEURVEVHURVEVHURVERVFVGVEVFURACBP
      QACBSTUAVHURVEVGURVEUJVFURVEVGBVAEZURVIBUTEZAFUBURVJAFBUSUCUDABFUTDUEUFVD
      BVAUGUHQUKUIVBVGAVDDUSVDBULUMUNUOADBUPUQ @.
  @}

  @{
    @d A x @.
    trdom.1 @e |- F = ( x e. RR |-> ( x + A ) ) @.
    @( Domain of a translation.  (Contributed by FL, 17-Feb-2008.) @)
    trdom @p |- ( A e. RR -> dom F = RR ) @=
      ( cr wcel cv caddc co cvv wral cdm wceq readdcl elex syl ancoms ralrimiva
      wa cmpdom sylib ) BEFZAGZBHIZJFZAEKCLEMUBUEAEUCEFZUBUEUFUBSUDEFUEUCBNUDEO
      PQRAEUDCDTUA @.
  @}

  @{
    @d A x y @.
    trran.1 @e |- F = ( x e. RR |-> ( x + A ) ) @.
    @( Range of a translation.  (Contributed by FL, 17-Feb-2008.) @)
    trran @p |- ( A e. RR -> ran F = RR ) @=
      ( vy cr wcel crn cv caddc co wceq wrex cab rnmpt wi wa expcom cc recn
      readdcl eleq1 syl5ibrcom rexlimdv cmin resubcl npcan syl2an eqcomd eqeq2d
      oveq1 rspcev syl2anc impbid abbi1dv syl5eq ) BFGZCHEIZAIZBJKZLZAFMZENFAEF
      UTCDOUQVBEFUQVBURFGZUQVAVCAFUSFGZUQVAVCPVDUQQVCVAUTFGUSBUAURUTFUBUCRUDVCU
      QVBVCUQQZURBUEKZFGURVFBJKZLZVBURBUFVEVGURVCURSGBSGVGURLUQURTBTURBUGUHUIVA
      VHAVFFUSVFLUTVGURUSVFBJUKUJULUMRUNUOUP @.
  @}

  @{
    @d A u v x y @.  @d F x y @.
    trnij.1 @e |- F = ( x e. RR |-> ( x + A ) ) @.
    @( A translation is 1-1-onto.  (Contributed by FL, 17-Feb-2008.) @)
    trnij @p |- ( A e. RR -> F : RR -1-1-onto-> RR ) @=
      ( vy vv vu cr wcel cv cfv wceq wral wa caddc co adantr cc recn sylanbrc
      wf1 wfo wf1o wf wi wfn crn wss cdm trdom funmpt2 jctil df-fn sylibr trran
      wfun eqimss anim2i syl2anc df-f readdcl expcom anim12d simpr fveq1i copab
      cmpt df-mpt wb eleq1 eqeq1 oveq1 eqeq2d sylan9bbr anbi12d cbvopabv 3eqtri
      imp eqtr4i 3eqtr3g simprl ad2antrr simplrl eqid fvmpt2 simplrr simprr jca
      syl 3eqtr3d w3a ad2antrl ad2antll 3jca addcan2 mpbid exp31 mpd ralrimivva
      dff13 df-fo df-f1o ) BHIZHHCUAZHHCUBZHHCUCXCHHCUDZAJZCKZEJZCKZLZXGXILZUEZ
      EHMAHMXDXCCHUFZCUGZHUHZNZXFXCXNXOHLZXQXCCUPZCUIHLZNXNXCXTXSABCDUJAHXGBOPZ
      CDUKULCHUMUNZABCDUOZXRXPXNXOHUQURUSHHCUTUNXCXMAEHHXCXGHIZXIHIZNZNZYAHIZXI
      BOPZHIZNZXMXCYFYKXCYDYHYEYJYDXCYHXGBVAVBYEXCYJXIBVAVBVCVRYGYKXKXLYGYKNZXK
      NZYAYILZXLYMXGAHYAVGZKZXIEHYIVGZKZYAYIYMXHXJYPYRYLXKVDXGCYODVEXICYQCYEFJZ
      YILZNZEFVFZYQCYOYDGJZYALZNZAGVFUUBDAGHYAVHUUEUUAAGEFXLUUCYSLZNYDYEUUDYTXL
      YDYEVIUUFXGXIHVJQUUFUUDYSYALXLYTUUCYSYAVKXLYAYIYSXGXIBOVLVMVNVOVPVQEFHYIV
      HVSVEVTYMYDYHYPYALYGYDYKXKXCYDYEWAWBYGYHYJXKWCAHYAHYOYOWDWEUSYMYEYJNZYRYI
      LYLUUGXKYLYEYJXCYDYEYKWFYGYHYJWGWHQEHYIHYQYQWDWEWIWJYMXGRIZXIRIZBRIZWKZYN
      XLVIYGUUKYKXKYGUUHUUIUUJYDUUHXCYEXGSWLYEUUIXCYDXISWMXCUUJYFBSQWNWBXGXIBWO
      WIWPWQWRWSAEHHCWTTXCXNXRXEYBYCHHCXATHHCXBT @.
  @}

  @{
    @d A u v x y @.  @d A w x y z @.
    @( Converse of a translation.  (Contributed by FL, 3-Aug-2009.)  (Proof
       shortened by Mario Carneiro, 11-Sep-2015.) @)
    cnvtr @p |- ( A e. RR -> `' ( x e. RR |-> ( x + A ) ) =
      ( x e. RR |-> ( x - A ) ) ) @=
      ( vy cr wcel cv caddc co cmpt ccnv cmin wf1o wceq eqid readdcl wa cc recn
      ancoms eqcom resubcl wb subadd2 syl3an 3coml 3expb 3bitr4g f1ocnv2d oveq1
      simprd cbvmptv syl6eq ) BDEZADAFZBGHZIZJZCDCFZBKHZIZADUNBKHZIUMDDUPLUQUTM
      UMACDDUOUSUPUPNUNDEZUMUODEUNBOSURDEZUMUSDEURBUASUMVBVCPPUSUNMZUOURMZUNUSM
      URUOMUMVBVCVDVEUBZVCUMVBVFVCURQEUMBQEVBUNQEVFURRBRUNRURBUNUCUDUEUFUNUSTUR
      UOTUGUHUJCADUSVAURUNBKUIUKUL @.
  @}

  @( The members of a 'less than or equal' relationship are extended reals.
     (Contributed by FL, 31-Jul-2009.)  (Proof shortened by Mario Carneiro,
     4-May-2015.) @)
  mlteqer @p |- ( A <_ B -> ( A e. RR* /\ B e. RR* ) ) @=
    ( cxr cle lerelxr brel ) ABCCDEF @.

  @( Transitive law for ordering on extended reals ( compare ~ xrletr ).
     (Contributed by FL, 2-Aug-2009.)  (Revised by Mario Carneiro,
     4-May-2015.) @)
  xrletr2 @p |- ( ( A <_ B /\ B <_ C ) -> A <_ C ) @=
    ( cxr wcel w3a cle wa mlteqer simpld adantr simprd adantl 3jca xrletr mpcom
    wbr ) ADEZBDEZCDEZFABGQZBCGQZHZACGQUCRSTUARUBUARSABIZJKUASUBUARSUDLKUBTUAUB
    STBCILMNABCOP @.


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Extended Real numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @{
    nolimf.j @e |- J = ( topGen ` ran (,) ) @.
    @{
      @d F x @.  @d J x @.  @d L x @.  @d Y x @.
      @( A numerical function has at most one limit value.  (Contributed by FL,
         14-Nov-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
      nolimf @p |- ( ( L e. ( Fil ` Y ) /\ F : Y --> RR )
       -> E* x x e. ( ( J fLimf L ) ` F ) ) @=
        ( cha wcel cfil cfv cr wf cv cflf co wmo cioo crn ctg cuni uniretop
        rehaus eqeltri unieqi eqtr4i hausflf mp3an1 ) CGHDEIJHEKBLAMBCDNOJHAPCQ
        RSJZGFUBUCABCDKEKUHTCTUACUHFUDUEUFUG @.
    @}

    @{
      @d F x @.  @d J x @.  @d L x @.  @d Y x @.
      @( A numerical convergent function has one limit value.  (Contributed by
         FL, 14-Nov-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
      nolimf2 @p |- ( ( L e. ( Fil ` Y ) /\ F : Y --> RR /\
            ( ( J fLimf L ) ` F ) =/= (/) ) -> E! x x e. ( ( J fLimf L ) ` F )
          ) @=
        ( cfil cfv wcel cr wf cflf co c0 wne w3a cv wmo weu nolimf n0moeu mpbid
        3adant3 wb 3ad2ant3 ) DEGHIZEJBKZBCDLMHZNOZPAQUHIZARZUJASZUFUGUKUIABCDE
        FTUCUIUFUKULUDUGAUHUAUEUB @.
    @}

  @}

  @{
    flfnein.a @e |- A = U. ( ( J fLimf L ) ` F ) @.
    flfnein.j @e |- J = ( topGen ` ran (,) ) @.

    @{
      @d F s @.  @d L s @.  @d N s @.  @d Y s @.  @d s J @.
      @( A neighborhood of the limit value ` A ` of a convergent numerical
         function ` F ` contains the image of a filter element.  (Contributed
         by FL, 18-Nov-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
      flfnein @p |- ( ( ( L e. ( Fil ` Y ) /\ F : Y --> RR )
         /\ ( ( J fLimf L ) ` F ) =/= (/)
         /\ N e. ( ( nei ` J ) ` { A } ) ) -> E. s e. L ( F " s ) C_ N ) @=
        ( cfil cfv wcel cr wf wa cha w3a cflf co cuni c0 wne csn cnei cima wrex
        cv wss cioo crn ctg rehaus eqeltri a1i simpl simpr 3jca uniretop unieqi
        eqtr4i flfneih syl3an1 ) DFJKLZFMBNZOZCPLZVCVDQBCDRSKUAUBEAUCCUDKKLBGUG
        UEEUHGDUFVEVFVCVDVFVECUIUJUKKZPIULUMUNVCVDUOVCVDUPUQABCDEMFGMVGTCTURCVG
        IUSUTHVAVB @.
    @}

    @{
      @( The limit of a numerical convergent function belongs to ` RR ` .
         (Contributed by FL, 22-Nov-2010.)  (Revised by Mario Carneiro,
         8-Aug-2015.) @)
      limnumrr @p |- ( ( L e. ( Fil ` Y ) /\ F : Y --> RR /\
       ( ( J fLimf L ) ` F ) =/= (/) )
         -> A e. RR ) @=
        ( cfil cfv wcel cr wf cflf co c0 wne eqeltri a1i cha syl31anc w3a simp1
        ctopon cioo crn retopon simp2 rehaus simp3 toponunii limvinlv flfelbas
        ctg ) DEHIJZEKBLZBCDMNIZOPZUAZCKUCIZJZUNUOAUPJZAKJUTURCUDUEUMIZUSGUFQZR
        UNUOUQUBZUNUOUQUGZURCSJZUNUOUQVAVFURCVBSGUHQRVDVEUNUOUQUIABCDKEKCVCUJFU
        KTABCDKEULT @.
    @}

  @}

  @{
    cinei.1 @e |- J = ( topGen ` ran (,) ) @.
    @( A centered interval is a neighborhood of its center.  (Contributed by
       FL, 18-Nov-2010.) @)
    cinei @p |- ( ( A e. RR /\ B e. RR+ )
      -> ( ( A - B ) (,) ( A + B ) ) e. ( ( nei ` J ) ` { A } ) ) @=
      ( cr wcel crp wa ctop cmin co caddc cioo csn cnei cfv crn ctg retop a1i
      eqeltri iooretop eleqtrri cbci opnneip syl3anc ) AEFBGFHZCIFZABJKZABLKZMK
      ZCFZAUKFUKANCOPPFUHUGCMQRPZIDSUATULUGUKUMCUIUJUBDUCTABUDACUKUEUF @.
  @}

  @{
    flfneic.x @e |- X = U. J @.
    flfneic.a @e |- A = U. ( ( J fLimf L ) ` F ) @.
    flfneic.j @e |- J = ( topGen ` ran (,) ) @.
    flfneic.n @e |- N = ( ( A - B ) (,) ( A + B ) ) @.
    @( A centered interval of the limit value ` A ` of a convergent numerical
       function ` F ` contains the image of a filter element.  (Contributed by
       FL, 18-Nov-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
    flfneic @p |- ( ( ( L e. ( Fil ` Y ) /\ F : Y --> X )
       /\ ( ( J fLimf L ) ` F ) =/= (/)
       /\ B e. RR+ ) -> A e. ( ( J fLimf L ) ` F ) ) @=
      ( cfil cfv wcel wf wa cflf cha cuni co c0 wne crp w3a cioo crn ctg rehaus
      eqeltri a1i simp1l wceq wb unieqi eqtri feq3 ax-mp biimpi adantl 3ad2ant1
      simp2 eqcomi limvinlv syl31anc ) EHMNOZHGCPZQZCDERUANZUBUCZBUDOZUEZDSOZVF
      HUFUGUHNZTZCPZVJAVIOVMVLDVNSKUIUJUKVFVGVJVKULVHVJVPVKVGVPVFVGVPGVOUMVGVPU
      NGDTZVOIDVNKUOZUPGVOHCUQURUSUTVAVHVJVKVBACDEVOHVQVOVRVCJVDVE @.
  @}

  @{
    @d F s @.  @d L s @.  @d N s @.  @d Y s @.  @d J s @.
    flfneicn.a @e |- A = U. ( ( J fLimf L ) ` F ) @.
    flfneicn.j @e |- J = ( topGen ` ran (,) ) @.
    flfneicn.n @e |- N = ( ( A - B ) (,) ( A + B ) ) @.
    @( A centered interval of the limit value ` A ` of a convergent numerical
       function ` F ` contains the image of a filter element.  (Contributed by
       FL, 18-Nov-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
    flfneicn @p |- ( ( ( L e. ( Fil ` Y ) /\ F : Y --> RR )
       /\ ( ( J fLimf L ) ` F ) =/= (/)
       /\ B e. RR+ ) -> E. s e. L ( F " s ) C_ N ) @=
      ( cfv wcel cr wa co cioo eqeltri cha ex cfil wf cflf c0 wne crp cnei cima
      csn cv wss wrex ctopon crn ctg retopon a1i simpll simplr rehaus toponunii
      wi limvinlv mp3anl1 flfelbas syl31anc cmin caddc cinei syl5eqel syl6 3imp
      flfnein syld3an3 ) EGUALMZGNCUBZOZCDEUCPLZUDUEZBUFMZFAUIDUGLLZMZCHUJUHFUK
      HEULVQVSVTWBVQVSANMZVTWBVBVQVSWCVQVSOZDNUMLZMZVOVPAVRMZWCWFWDDQUNUOLZWEJU
      PRZUQVOVPVSURVOVPVSUSDSMVOVPVSWGDWHSJUTRACDENGNDWIVAIVCVDACDENGVEVFTWCVTW
      BWCVTOFABVGPABVHPQPWAKABDJVIVJTVKVLACDEFGHIJVMVN @.
  @}

  @{
    lvsovso.l1 @e |- L1 = U. ( ( J fLimf F ) ` F1 ) @.
    lvsovso.l2 @e |- L2 = U. ( ( J fLimf F ) ` F2 ) @.
    lvsovso.j @e |- J = ( topGen ` ran (,) ) @.

    @{
      @d F a r s x @.  @d F1 a r s x @.  @d F2 a r s x @.  @d J r s x @.
      @d L1 r s x @.  @d L2 r s x @.  @d Y r s x @.
      @( If the limit values of two convergent numerical functions are strictly
         ordered, the values of the functions are strictly ordered for some
         element of the filter.  Bourbaki TG IV.18 prop. 2.  (Contributed by
         FL, 6-Dec-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
      lvsovso @p |- ( ( ( F e. ( Fil ` Y ) /\ F1 : Y --> RR /\ F2 : Y --> RR )
          /\
           ( ( ( J fLimf F ) ` F1 ) =/= (/) /\
             ( ( J fLimf F ) ` F2 ) =/= (/) /\
             L1 < L2 ) )
         -> E. a e. F A. x e. a ( F1 ` x ) < ( F2 ` x ) ) @=
        ( co wss wa wcel cr w3a clt wi vr vs cv cima cmin cabs cfv c2 cdiv cioo
        caddc wrex cfil wf cflf c0 wne wbr wral crp simpl1 simpl2 jca simpr1 cc
        limnumrr recnd 3expia com12 3ad2ant2 3adant2 imp 3ad2ant1 subcld abscld
        3adant3 rehalfcld simpr3 posdifd mpbid gt0ne0d wb absgt0 halfpos2 elrpd
        cc0 syl simpl3 simpr2 eqid flfneicn anim12i syl33anc filin inss1 imass2
        inss2 mp2an sstr2 im2anan9 ax-mp ad2antlr simprl1 simplr filelss sselda
        cin syl2anc ffvelrn adantl resubcld 3jca wfun cdm ffun 3adant1 wceq fdm
        adantr sseqtr4d 3exp impcom funfvima2 syl6 3imp 3ad2ant3 3ad2antl1 recn
        3impia imp31 subcl halfcld addcl subadd ssel2 eliooord expcom rexlimiva
        an4s ex syl2anr add12d 2halvesd resubcl ancoms cle jctil posdif biimp3a
        ltle sylc absidd eqtr2d eqtrd syldan mpbird syl3anc simprd simpld breq2
        0re 3syl anbi1d imbi2d syl5ibr lttr ralrimiv raleq rspcev com14 pm2.43i
        mpd syl7 3expib com23 anabsi5 com3l mpcom ) FUAUCZUDZHIHUEMZUFUGZUHUIMZ
        UEMZHUWCUKMZUJMZNZUABULZGUBUCZUDZIUWCUEMZIUWCUKMZUJMZNZUBBULZOZBDUMUGPZ
        DQFUNZDQGUNZRZFCBUOMZUGUPUQZGUXAUGUPUQZHISURZRZOZAUCZFUGZUXGGUGZSURZAEU
        CZUSZEBULZUXFUWQUWROZUXBUWCUTPZUWQUWSOZUXCUXOUWPUXFUWQUWRUWQUWRUWSUXEVA
        ZUWQUWRUWSUXEVBZVCUWTUXBUXCUXDVDUXFUWCUXFUWBUXFUWAUXFIHUWTUXEIVEPZUWQUW
        SUXEUXSTUWRUXEUXPUXSUXCUXBUXPUXSTUXDUXPUXCUXSUWQUWSUXCUXSUWQUWSUXCRIIGC
        BDKLVFZVGVHVIVJVIVKVLUWTUXEHVEPZUWQUWRUXEUYATUWSUXEUXNUYAUXBUXCUXNUYATU
        XDUXNUXBUYAUWQUWRUXBUYAUWQUWRUXBRHHFCBDJLVFZVGVHVIVMVIVPVLVNZVOZVQZUXFW
        FUWBSURZWFUWCSURZUXFUWAWFUQZUYFUXFUWAUXFUXDWFUWASURZUWTUXBUXCUXDVRZUXFH
        IUWTUXEHQPZUWQUWRUXEUYKTUWSUXEUXNUYKUXBUXCUXNUYKTUXDUXNUXBUYKUWQUWRUXBU
        YKUYBVHVIVMVIVPVLZUWTUXEIQPZUWQUWSUXEUYMTUWRUXEUXPUYMUXCUXBUXPUYMTUXDUX
        PUXCUYMUWQUWSUXCUYMUXTVHVIVJVIVKVLZVSVTWAUXFUWAVEPZUYHUYFWBUYCUWAWCWGVT
        UXFUWBQPUYFUYGWBUYDUWBWDWGVTWEZUXFUWQUWSUXQUWQUWRUWSUXEWHZVCUWTUXBUXCUX
        DWIUYPUXNUXBUXORUWHUXPUXCUXORUWOHUWCFCBUWFDUAJLUWFWJWKIUWCGCBUWMDUBKLUW
        MWJWKWLWMUWHUWOUXFUXMTZUWGUWOUYRTUABUWOUVSBPZUWGOZUYRUWNUYTUYRTUBBUYTUW
        IBPZUWNOUYRUYSVUAUWGUWNUYRUYSVUAOZUWGUWNOZUYRUXFVUBVUCUXMUWTUXEVUBVUCUX
        MTZTZUWQUWRUXFVUETUWSUWQVUBUXFVUDUWQUYSVUAUXFVUDTZUWQUYSVUARUVSUWIXGZBP
        ZVUFUVSUWIBDWNVUCFVUGUDZUWFNZGVUGUDZUWMNZOZVUHUXFUXMVUIUVTNZVUKUWJNZOZV
        UCVUMTVUGUVSNZVUGUWINZVUPUVSUWIWOUVSUWIWQVUQVUNVURVUOVUGUVSFWPVUGUWIGWP
        WLWRVUNUWGVUJVUOUWNVULVUIUVTUWFWSVUKUWJUWMWSWTXAVUHUXFVUMUXMTTVUMVUHUXF
        VUHUXMVUMVUHUXFVUHUXMTZTVUMVUHOZUXFUXJAVUGUSZVUSVUTUXFVVAVUTUXFOZUXJAVU
        GVVBUXGVUGPZUXHQPZUWKQPZUXIQPZRZUXHUWKSURZUWKUXISURZOZOZUXJVVBVVCVVKVVB
        VVCOZVVGVVJVVLVVDVVEVVFVVLUWRUXGDPZVVDUXFUWRVUTVVCUXRXBVVBVUGDUXGVVBUWQ
        VUHVUGDNZUWQUWRUWSUXEVUTXCVUMVUHUXFXDVUGBDXEZXHXFZDQUXGFXIXHVVBVVEVVCVV
        BIUWCUXFUYMVUTUYNXJUXFUWCQPZVUTUYEXJXKXSVVLUWSVVMVVFUXFUWSVUTVVCUYQXBVV
        PDQUXGGXIXHXLVVLUXHVUIPZUXIVUKPZOZVVJVUTUXFVVCVVTVUHUXFVVCVVTTZTVUMUXFV
        UHVWAUWTVUHVWATUXEUWTVUHVVCVVTUWTVUHVVCRVVRVVSUWTVUHVVCVVRUWTVUHFXMZVUG
        FXNZNZOZVVCVVRTUWQUWRVUHVWETZUWSUWRUWQVWFUWRUWQVUHVWEUWRUWQVUHRZVWBVWDU
        WRUWQVWBVUHDQFXOVMVWGVUGDVWCUWQVUHVVNUWRVVOXPUWRUWQVWCDXQVUHDQFXRVMXTVC
        YAYBVPVUGUXGFYCYDYEUWTVUHVVCVVSUWTVUHOZGXMZVUGGXNZNVVCVVSTUWTVWIVUHUWSU
        WQVWIUWRDQGXOYFXSVWHVUGDVWJUWQUWRVUHVVNUWSVVOYGVWHUWSVWJDXQUWQUWRUWSVUH
        WHDQGXRWGXTVUGUXGGYCXHYIVCYAXSVIXJYJVVBVVTVVJTZVVCVUTUXFVWKVUMUXFVWKTVU
        HUXFVUMVWKUXFUWKUWEXQZVUMVWKTUXFUYKUYMUXDVWLUYLUYNUYJUYKUYMUXDRZVWLUWCU
        WEUKMZIXQZVWMVWNHUWCUWCUKMZUKMZIVWMUWCHUWCUYKUYMUWCVEPZUXDUYKUYMOZUWBVW
        SUWBVWSUWAUYMUXSUYAUYOUYKIYHZHYHZIHYKUUAVOZVGZYLVPZUYKUYMUYAUXDVXAVMVXD
        UUBVWMUWAVWPXQZVWQIXQZVWMVWPUWBUWAVWMUWBUYKUYMUWBVEPUXDVXCVPUUCVWMUWAUY
        KUYMUWAQPZUXDUYMUYKVXGIHUUDUUEZVPVWMWFQPZVXGOZUYIWFUWAUUFURUYKUYMVXJUXD
        VWSVXGVXIVXHUVAUUGVPUYKUYMUXDUYIHIUUHUUIWFUWAUUJUUKUULUUMVWMUXSUYAVWPVE
        PZRZVXEVXFWBUYKUYMVXLUXDVWSUXSUYAVXKUYMUXSUYKVWTXJZUYKUYAUYMVXAXSVWSVVQ
        VWRVWROVXKVWSUWBVXBVQZVVQVWRVWRUWCYHZVXOVCUWCUWCYMUVBXLVPIHVWPYNWGVTUUN
        VWMUXSVWRUWEVEPZRZVWLVWOWBUYKUYMVXQUXDVWSUXSVWRVXPVXMVWSUWBVWSUWBVWSUWA
        VWSUWAVXHVGVOVGYLVWSUYAVWROZVXPUYKUYMVVQVXRVXNUYKUYAVVQVWRVXAVXOWLUUOHU
        WCYMWGXLVPIUWCUWEYNWGUUPUUQVUMVWKVWLVVTUXHUWESURZVVIOZTVUMVVTVXTVUJVVRV
        ULVVSVXTVUJVVROZVXSVULVVSOZVVIVYAUWDUXHSURZVXSVYAUXHUWFPVYCVXSOVUIUWFUX
        HYOUXHUWDUWEYPWGUURVYBVVIUXIUWLSURZVYBUXIUWMPVVIVYDOVUKUWMUXIYOUXIUWKUW
        LYPWGUUSWLYSYTVWLVVJVXTVVTVWLVVHVXSVVIUWKUWEUXHSUUTUVCUVDUVEWGVIXSVLXSU
        VLVCYTVVGVVJUXJUXHUWKUXIUVFVLYDUVGYTVUHVVAUXMUXLVVAEVUGBUXJAUXKVUGUVHUV
        IYQYDYTUVJUVKUVMWGUVNUVOVMUVPUVQVLYSYQYRVIYRVLUVR @.
    @}

    @{
      @d F a x @.  @d F1 a x @.  @d F2 a x @.  @d J a x @.  @d L1 x @.
      @d L2 x @.  @d Y a x @.
      @( Condition on the elements of the filter so that the limits are weakly
         ordered.  Bourbaki TG IV.18 prop. 1.  (Contributed by FL,
         30-Dec-2010.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
      lvsovso2 @p |- ( ( ( F e. ( Fil ` Y ) /\ F1 : Y --> RR /\ F2 : Y --> RR )
          /\
           ( ( ( J fLimf F ) ` F1 ) =/= (/) /\
             ( ( J fLimf F ) ` F2 ) =/= (/) /\
             A. a e. F E. x e. a ( F1 ` x ) <_ ( F2 ` x ) ) )
         -> L1 <_ L2 ) @=
        ( cfv wbr wrex w3a wcel cr wi wn cflf co c0 wne cv cle wral cfil wf clt
        lvsovso ex 3com23 3expd com13 3imp simp31 simp33 simp2 limnumrr syl3anc
        simp32 simp1 ltnled bicomd rexnal wa ralnex ad2antrr wss filelss sselda
        sylan ffvelrn syl2anc ralbidva syl5bbr rexbidva con4d 3exp com34 impcom
        3imtr4d ) FCBUAUBZMUCUDZGWDMUCUDZAUEZFMZWGGMZUFNZAEUEZOZEBUGZPBDUHMQZDR
        FUIZDRGUIZPZHIUFNZWEWFWMWQWRSWEWFWQWMWRWEWFWQWMWRSWEWFWQPZWRWMWSIHUJNZW
        IWHUJNZAWKUGZEBOZWRTZWMTZWEWFWQWTXCSZWQWFWEXFWQWFWEWTXCWNWPWOWFWEWTPZXC
        SWNWPWOPXGXCABCDEGFIHKJLUKULUMUNUOUPWSWTXDWSIHWSWNWPWFIRQWEWFWNWOWPUQZW
        EWFWNWOWPURZWEWFWQUSIGCBDKLUTVAWSWNWOWEHRQXHWEWFWNWOWPVBZWEWFWQVCHFCBDJ
        LUTVAVDVEXEWLTZEBOWSXCWLEBVFWSXKXBEBXKWJTZAWKUGWSWKBQZVGZXBWJAWKVHXNXLX
        AAWKXNWGWKQZVGZXAXLXPWIWHXPWPWGDQZWIRQWSWPXMXOXIVIXNWKDWGWSWNXMWKDVJXHW
        KBDVKVMVLZDRWGGVNVOXPWOXQWHRQWSWOXMXOXJVIXRDRWGFVNVOVDVEVPVQVRVQWCVSVTW
        AUPWB @.
    @}

    @{
      @d F a x @.  @d F1 a x @.  @d F2 a x @.  @d J a x @.  @d L1 x @.
      @d L2 x @.  @d Y a x @.
      @( Condition on the values of two numerical functions so that their
         limits are weakly ordered.  Bourbaki TG IV.18 th. 1.  (Contributed by
         FL, 18-Jul-2011.)  (Revised by Mario Carneiro, 8-Aug-2015.) @)
      lvsovso3 @p |- ( ( ( F e. ( Fil ` Y ) /\ F1 : Y --> RR /\ F2 : Y --> RR )
          /\
           ( ( ( J fLimf F ) ` F1 ) =/= (/) /\
             ( ( J fLimf F ) ` F2 ) =/= (/) /\
             A. x e. Y ( F1 ` x ) <_ ( F2 ` x ) ) )
         -> L1 <_ L2 ) @=
        ( va cfv wcel cr wf w3a c0 wne wral cfil cflf co cv cle wbr wrex simpr1
        wa simpr2 simpl1 fileln0 wss filelss simplr3 ssralv sylc r19.2z syl2anc
        sylan ralrimiva 3jca lvsovso2 syldan ) BDUAMNZDOEPZDOFPZQZECBUBUCZMRSZF
        VIMRSZAUDZEMVLFMUEUFZADTZQZVJVKVMALUDZUGZLBTZQGHUEUFVHVOUIZVJVKVRVHVJVK
        VNUHVHVJVKVNUJVSVQLBVSVPBNZUIZVPRSZVMAVPTZVQVSVEVTWBVEVFVGVOUKZVPBDULUT
        WAVPDUMZVNWCVSVEVTWEWDVPBDUNUTVJVKVNVHVTUOVMAVPDUPUQVMAVPURUSVAVBABCDLE
        FGHIJKVCVD @.
    @}
  @}

  @{
    @d A x y z @.  @d C x y z @.  @d F w x @.  @d F x y z @.
    @( The supremum of a numerical function ` F ` is greater or equal to every
       element of ` ( F `` A ) ` .  Bourbaki TG IV.20.  (Contributed by FL,
       25-Dec-2011.) @)
    supnuf @p |- ( ( F : A --> RR* /\ A e. _V /\ C e. A ) -> ( F ` C ) <_ ( <_
        supw ran F ) ) @=
      ( vx vy vz cv cle wbr wral wi cxr wa cvv wcel syl 3ad2ant1 wrex syl2anc
      wn vw crn cspw co wf w3a cfv cps ctsr letsr tsrps mp1i cdm wfun fdm eleq1
      wceq biimpd eqcoms imp 3adant3 ffun funrnex sylc wss frn xrex clt xrsupss
      ssex wb adantr sselda simplr xrlenlt ralbidva con34b simpr xrltnle bicomd
      rexnal sseld ad2antrr rexbidva syl5bbr imbi12d syl5bb anbi12d mpbird ledm
      biid spwcl syl3anc supdef eqcomd eleq2d biimpa 3adant2 fvelrn breq1 rspcv
      com12 mpcom ) DGZHCUBZUCUDZHIZDXEJZUAGXDHIUAXEJXFXDHIKDLJZMZALCUEZANOZBAO
      ZUFZBCUGZXFHIZXNHUHOZXENOZXFLOZXJHUIOXQXNUJHUKULZXNCUMZNOZCUNZXRXKXLYBXMX
      KXLYBXKYAAUQXLYBKZALCUOZYDAYAAYAUQXLYBAYANUPURUSPUTVAXKXLYCXMALCVBQZNCVCV
      DXNXQXREGZXDHIZEXEJZFGZYGHIZFXEJZXDYGHIZKZELJZMZDLRZXSXTXKXLXRXMXKXELVEZX
      RALCVFZXELVGVJPQXNYQXDYGVHITZEXEJZYGXDVHIZYGYJVHIZFXERZKZELJZMZDLRZXNYRUU
      HXKXLYRXMYSQZDEFXEVIPXNYPUUGDLXNXDLOZMZYIUUAYOUUFUUKYHYTEXEUUKYGXEOZMYGLO
      ZUUJYHYTVKUUKXELYGXNYRUUJUUIVLVMXNUUJUULVNYGXDVOSVPUUKYNUUEELYNYMTZYLTZKU
      UKUUMMZUUEYLYMVQUUPUUNUUBUUOUUDUUPUUBUUNUUPUUMUUJUUBUUNVKUUKUUMVRXNUUJUUM
      VNYGXDVSSVTUUOYKTZFXERUUPUUDYKFXEWAUUPUUQUUCFXEUUPYJXEOZMZUUCUUQUUSUUMYJL
      OZUUCUUQVKUUKUUMUURVNUUPUURUUTXNUURUUTKZUUJUUMXKXLUVAXMXKXELYJYSWBQWCUTYG
      YJVSSVTWDWEWFWGVPWHWDWIYPDEFXEHNLWJYPWKWLWMDUAXEHNLWJWNWMXHXNXPKXIXNXHXPX
      NXOXEOZXHXPKXNYCBYAOZUVBYFXKXMUVCXLXKXMUVCXKAYABXKYAAYEWOWPWQWRBCWSSXGXPD
      XOXEXDXOXFHWTXAPXBVLXC @.
  @}

  @{
    @d A x @.  @d C x @.  @d V x @.
    supnufb.1 @e |- F = ( x e. A |-> U ) @.
    supnufb.2 @e |- ( x = C -> U = V ) @.
    @( The supremum of a numerical function ` F ` is greater or equal to every
       element of ` ( F `` A ) ` .  Bourbaki TG IV.20.  (Contributed by FL,
       25-Dec-2011.) @)
    supnufb @p |- ( ( A. x e. A U e. RR* /\ A e. M
       /\ ( C e. A /\ V e. N ) ) -> V <_ ( <_ supw ran F ) ) @=
      ( cxr wcel wral wa w3a cfv cle crn cspw co wceq fvmptg 3ad2ant3 wf biimpi
      cvv wbr fmpt 3ad2ant1 elex 3ad2ant2 simp3l supnuf syl3anc eqbrtrrd ) DKLA
      BMZBFLZCBLZHGLZNZOZCEPZHQERSTZQUTUPVBHUAUQACDHBGEJIUBUCVABKEUDZBUFLZURVBV
      CQUGUPUQVDUTUPVDABKDEIUHUEUIUQUPVEUTBFUJUKUPUQURUSULBCEUMUNUO @.
  @}

  @{
    @d A x y z @.
    @( Two ways to express the supremum of a set of extended reals.
       (Contributed by FL, 25-Dec-2011.)  (Revised by Mario Carneiro,
       20-Nov-2013.) @)
    supexr @p |- ( A C_ RR* -> ( <_ supw A ) = sup ( A , RR* , < ) ) @=
      ( vy vx vz cxr cv cle wbr wral wi wa crab cuni clt wceq wcel wrex wn ssel
      wb wss crio cspw co csup wreu ctsr letsr tsrps ax-mp xrsupss xrlenlt syl6
      cps ex com23 imp31 ralbidva con34b xrltnle ancoms bicomd adantll rexbidva
      rexnal adantr syl5bbr imbi12d syl5bb anbi12d mpbird biid sylancr riotauni
      spweu syl xrex ssex lefld spwval2 rabbidva unieqd df-sup syl6reqr 3eqtr4d
      cvv ) AEUAZBFZCFZGHZBAIZDFZWHGHZDAIZWIWHGHZJZBEIZKZCEUBZWRCELZMZGAUCUDZAE
      NUEZWGWRCEUFZWSXAOWGGUNPZWRCEQZXDGUGPXEUHGUIUJZWGXFWIWHNHRZBAIZWHWINHZWHW
      LNHZDAQZJZBEIZKZCEQCBDAUKWGWRXOCEWGWIEPZKZWKXIWQXNXQWJXHBAWGXPWHAPZWJXHTZ
      WGXRXPXSWGXRWHEPZXPXSJAEWHSXTXPXSWHWIULUOUMUPUQURXQWPXMBEWPWORZWNRZJXQXTK
      ZXMWNWOUSYCYAXJYBXLXPXTYAXJTWGXPXTKXJYAXTXPXJYATWHWIUTVAVBVCYBWMRZDAQYCXL
      WMDAVEYCYDXKDAXQXTWLAPZYDXKTZWGXTYEYFJJXPWGYEXTYFWGYEWLEPZXTYFJAEWLSYGXTY
      FYGXTKXKYDXTYGXKYDTWHWLUTVAVBUOUMUPVFUQVDVGVHVIURVJZVDVKWRCBDAGEWRVLVOVMW
      RCEVNVPWGXEAWFPXBWSOXGAEVQVRCBDAGWFEVSVTVMWGXAXOCELZMXCWGWTYIWGWRXOCEYHWA
      WBCBDAENWCWDWE @.
  @}

  @c sup_ @. @( The supremum of an indexed class. @)
  @( Extend class notation to include the supremum of the class B. @)
  clsupp @a class sup_ x e. A B @.

  @c inf_ @. @( The infimum of an indexed class. @)
  @( Extend class notation to include the infimum of the class B. @)
  clinfp @a class inf_ x e. A B @.

  @( Definition of the supremum of an indexed class of extended reals.
     (Contributed by FL, 16-Apr-2012.) @)
  df-supp @a |- sup_ x e. A B = ( <_ supw ( ( x e. A |-> B ) " A ) ) @.

  @( Definition of the infimum of an indexed class of extended reals.
     (Contributed by FL, 21-May-2012.) @)
  df-infp @a |- inf_ x e. A B = ( <_ infw ( ( x e. A |-> B ) " A ) ) @.

  @( The supremum of a set of extended reals always exists. see supxrcl @)

  @{
    @d A x y @.  @d B y @.
    supbrr.1 @e |- B e. C @.
    @( The supremum of a set of extended reals always exists.  (Contributed by
       FL, 16-Apr-2012.) @)
    supbrr @p |- ( A. x e. A B e. RR* -> sup_ x e. A B e. RR* ) @=
      ( cxr wcel wral clsupp cle cmpt cima cspw df-supp clt csup wss wceq syl
      co crn imassrn eqid fmpt frn sylbi syl5ss supexr supxrcl eqeltrd syl5eqel
      wf ) CFGABHZABCIJABCKZBLZMTZFABCNUMUPUOFOPZFUMUOFQZUPUQRUMUOUNUAZFUNBUBUM
      BFUNULUSFQABFCUNUNUCUDBFUNUEUFUGZUOUHSUMURUQFGUTUOUISUJUK @.
  @}

  @c Frf @. @( Frechet' s filter. @)

  @( Extends class notation with Frechet's filter. @)
  cfrf @a class Frf @.

  @{
    @d x b @.
    @( Frechet's filter.  Used to define the limit of a sequence.  (Contributed
       by FL, 21-May-2012.) @)
    df-frf @a |- Frf = { x | E. b ( b C_ NN /\ b e. Fin /\ x = ( NN \ b ) ) }
        @.
  @}

  @{
    @d x y A @.
    @( Membership to the set of closed intervals.  (Contributed by FL,
       29-May-2014.) @)
    bsi2 @p |- ( A e. ran [,] <->
      E. x e. RR* E. y e. RR* A = ( x [,] y ) ) @=
      ( cxr cxp cpw cicc wf wfn crn wcel cv co wceq wrex iccf ffn ovelrn mp2b
      wb ) DDEZDFZGHGUAICGJKCALBLGMNBDOADOTPUAUBGQABDDCGRS @.
  @}

  @{
    @d x y z @.
    @( The set of closed-below, open-above intervals of extended reals maps to
       subsets of extended reals.  (Contributed by FL, 29-May-2014.) @)
    icof @p |- [,) : ( RR* X. RR* ) --> ~P RR* @=
      ( vx vy vz cle clt cico df-ico ixxf ) ABCDEFABCGH @.
  @}

  @{
    @d x y A @.
    @( Membership to the set of closed-above, open-below intervals.
       (Contributed by FL, 29-May-2014.) @)
    bsi3 @p |- ( A e. ran [,) <->
      E. x e. RR* E. y e. RR* A = ( x [,) y ) ) @=
      ( cxr cxp cpw cico wf wfn crn wcel cv co wceq wrex icof ffn ovelrn mp2b
      wb ) DDEZDFZGHGUAICGJKCALBLGMNBDOADOTPUAUBGQABDDCGRS @.
  @}

  @{
    @d x y z @.
    @( The set of closed-below, open-above intervals of extended reals maps to
       subsets of extended reals.  (Contributed by FL, 29-May-2014.) @)
    iocf @p |- (,] : ( RR* X. RR* ) --> ~P RR* @=
      ( vx vy vz clt cle cioc df-ioc ixxf ) ABCDEFABCGH @.
  @}

  @{
    @d x y A @.
    @( Membership to the set of open-below, closed-above intervals.
       (Contributed by FL, 29-May-2014.) @)
    bsi4 @p |- ( A e. ran (,] <->
      E. x e. RR* E. y e. RR* A = ( x (,] y ) ) @=
      ( cxr cxp cpw cioc wf wfn crn wcel cv co wceq wrex iocf ffn ovelrn mp2b
      wb ) DDEZDFZGHGUAICGJKCALBLGMNBDOADOTPUAUBGQABDDCGRS @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        ( RR ^ N ) and ( CC ^ N )
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c +cv @. @( Addition of complex vectors. @)

  @( Extends class notation with addition of complex vectors. @)
  cplcv @a class +cv @.

  @{
    @d n u v x @.
    @( Addition of complex vectors in a space of dimension ` n ` .
       Experimental.  (Contributed by FL, 14-Sep-2013.) @)
    df-addcv @a |- +cv = ( n e. NN |-> ( u e. ( CC ^m ( 1 ... n ) ) ,
        v e. ( CC ^m ( 1 ... n ) ) |->
        ( x e. ( 1 ... n ) |-> ( ( u ` x ) + ( v ` x ) ) ) ) ) @.
  @}

  @( ( ( ringLMod ` CCfld ) ^s ( 1 ... N ) ) @)


  @{
    isaddrv.1 @e |- +w = ( +cv ` N ) @.
    @{
      @d x v u U @.  @d x v u n N @.  @d x u v V @.
      @( Addition of complex vectors.  Experimental.  (Contributed by FL,
         14-Sep-2013.) @)
      isaddrv @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) /\
      V e. ( CC ^m ( 1 ... N ) ) ) -> ( U +w V ) =
      ( x e. ( 1 ... N ) |-> ( ( U ` x ) + ( V ` x ) ) ) ) @=
        ( vu vv vn wcel cc c1 cfz co cmap cv cfv caddc cmpt wceq cn cmpt2 cplcv
        w3a oveq2 oveq2d eqidd mpteq12dv mpt2eq123dv df-addcv ovex mpt2ex fvmpt
        syl5eq 3ad2ant1 oveqd fveq1 oveq1d mpteq2dv mptex ovmpt2 3adant1 eqtrd
        eqid ) CUAJZBKLCMNZONZJZDVGJZUDZBDENBDGHVGVGAVFAPZGPZQZVKHPZQZRNZSZUBZN
        ZAVFVKBQZVKDQZRNZSZVJEVRBDVEVHEVRTVIVEECUCQVRFICGHKLIPZMNZONZWFAWEVPSZU
        BVRUAUCWDCTZGHWFWFWGVGVGVQWHWEVFKOWDCLMUEZUFZWJWHAWEVPVFVPWIWHVPUGUHUIA
        HGIUJGHVGVGVQKVFOUKZWKULUMUNUOUPVHVIVSWCTVEGHBDVGVGVQWCVRAVFVTVORNZSVLB
        TZAVFVPWLWMVMVTVORVKVLBUQURUSVNDTZAVFWLWBWNVOWAVTRVKVNDUQUFUSVRVDAVFWBL
        CMUKUTVAVBVC @.
    @}

    @{
      @d x U @.  @d x N @.  @d x V @.
      @( Closure of addition of complex vectors.  (Contributed by FL,
         14-Sep-2013.) @)
      claddrv @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) /\
            V e. ( CC ^m ( 1 ... N ) ) )
          -> ( U +w V ) e. ( CC ^m ( 1 ... N ) ) ) @=
        ( vx wcel cc c1 cfz co cfv wf wa wi cnex elmap ffvelrn ex cvv cn w3a cv
        cmap caddc cmpt isaddrv ovex sylbi 3ad2ant2 imp 3ad2ant3 addcld eqid wb
        fmptd pm3.2i elmapg mp1i mpbird eqeltrd ) BUAGZAHIBJKZUDKZGZCVDGZUBZACD
        KFVCFUCZALZVHCLZUEKZUFZVDFABCDEUGVGVLVDGZVCHVLMZVGFVCVKHVLVGVHVCGZNVIVJ
        VGVOVIHGZVEVBVOVPOZVFVEVCHAMZVQHVCAPIBJUHZQVRVOVPVCHVHARSUIUJUKVGVOVJHG
        ZVFVBVOVTOZVEVFVCHCMZWAHVCCPVSQWBVOVTVCHVHCRSUIULUKUMVLUNUPHTGZVCTGZNVM
        VNUOVGWCWDPVSUQHVCVLTTURUSUTVA @.
    @}

    @{
      @d x N @.  @d x U @.  @d x V @.
      @( Closure of addition of real vectors.  (Contributed by FL,
         29-May-2014.) @)
      claddrvr @p |- ( ( N e. NN /\ U e. ( RR ^m ( 1 ... N ) ) /\
            V e. ( RR ^m ( 1 ... N ) ) )
          -> ( U +w V ) e. ( RR ^m ( 1 ... N ) ) ) @=
        ( vx wcel cr c1 cfz co cmap cfv cc wf ax-resscn reex elmap wa wi cn w3a
        caddc cmpt wceq simp1 wss fss mpan2 ovex cnex 3imtr4i 3ad2ant2 3ad2ant3
        cv isaddrv syl3anc wral ffvelrn im2anan9 readdcl ancoms syl6 exp3acom3r
        pm2.43i sylbi com12 imp ralrimiv 3adant1 eqid fmpt sylib sylibr eqeltrd
        ex ) BUAGZAHIBJKZLKZGZCVSGZUBZACDKZFVRFUOZAMZWDCMZUCKZUDZVSWBVQANVRLKZG
        ZCWIGZWCWHUEVQVTWAUFVTVQWJWAVRHAOZVRNAOZVTWJWLHNUGZWMPVRHNAUHUIHVRAQIBJ
        UJZRZNVRAUKWORULUMWAVQWKVTVRHCOZVRNCOZWAWKWQWNWRPVRHNCUHUIHVRCQWORZNVRC
        UKWORULUNFABCDEUPUQWBVRHWHOZWHVSGWBWGHGZFVRURZWTVTWAXBVQVTWASXAFVRVTWAW
        DVRGZXATZVTWLWAXDTWPWAWLXDWAWQWLXDTWSXCWQWLXAXCWQWLSZXATXEXCXCXAXEXCXCS
        WFHGZWEHGZSXAWQXCXFWLXCXGWQXCXFVRHWDCUSVPWLXCXGVRHWDAUSVPUTXGXFXAWEWFVA
        VBVCVDVEVDVFVGVFVHVIVJFVRHWGWHWHVKVLVMHVRWHQWORVNVO @.
    @}

  @}

  @{
    @d n u v x N @.
    sigadd.1 @e |- +w = ( +cv ` N ) @.
    @( Functionality of vector addition.  (Contributed by FL, 29-May-2014.) @)
    sigadd @p |- ( N e. NN -> +w :
      ( ( CC ^m ( 1 ... N ) ) X. ( CC ^m ( 1 ... N ) ) )
          --> ( CC ^m ( 1 ... N ) ) ) @=
      ( vu vv vx vn wcel cc c1 cfz co cmap wf cv cfv wral wa cvv wceq cxp caddc
      cn cmpt cmpt2 wi cnex ovex elmap ffvelrn addcl syl2an an42s ex exp3acom3r
      pm2.43i com12 ralrimiv a1d syl2anb impcom eqid fmpt wb a1i elmapg sylancr
      sylib mpbird ralrimivva fmpt2 cplcv pm3.2i mpt2exga mp1i oveq2 oveq2d syl
      mpteq1 mpt2eq123dv df-addcv fvmptg mpdan syl5eq feq1d ) AUCHZIJAKLZMLZWHU
      AZWHBNWIWHDEWHWHFWGFOZDOZPZWJEOZPZUBLZUDZUEZNZWFWPWHHZEWHQDWHQWRWFWSDEWHW
      HWFWKWHHZWMWHHZRZRZWSWGIWPNZXCWOIHZFWGQZXDXBWFXFWTWGIWKNZWGIWMNZWFXFUFXAI
      WGWKUGJAKUHZUIIWGWMUGXIUIXGXHRZXFWFXJXEFWGWJWGHZXJXEXKXJXEUFXJXKXKXEXJXKX
      KRXEXGXKXHXKXEXGXKRWLIHWNIHXEXHXKRWGIWJWKUJWGIWJWMUJWLWNUKULUMUNUOUPUQURU
      SUTVAFWGIWOWPWPVBVCVHXCISHWGSHZWSXDVDUGXLXCXIVEIWGWPSSVFVGVIVJDEWHWHWPWHW
      QWQVBVKVHWFWIWHBWQWFBAVLPZWQCWFWQSHZXMWQTWHSHZXORXNWFXOXOIWGMUHZXPVMDEWHW
      HWPSSVNVOGADEIJGOZKLZMLZXSFXRWOUDZUEWQUCSVLXQATZDEXSXSXTWHWHWPYAXRWGIMXQA
      JKVPZVQZYCYAXRWGTXTWPTYBFXRWGWOVSVRVTFEDGWAWBWCWDWEVI @.
  @}

  @c 0cv @.

  @( Extends class notation with null vector. @)
  c0cv @a class 0cv @.

  @{
    @d n x @.
    @( The null vector in a space of dimension ` n ` .  Experimental.
       (Contributed by FL, 15-Sep-2013.) @)
    df-nullcv @a |- 0cv = ( n e. NN |-> ( x e. ( 1 ... n ) |-> 0 ) ) @.
  @}

  @{
    isnullcv.1 @e |- 0w = ( 0cv ` N ) @.
    @{
      @( The null vector. @)
      @d x n N @.
      @( The null vector in a space of dimension ` n ` .  (Contributed by FL,
         15-Sep-2013.) @)
      isnullcv @p |- ( N e. NN -> 0w = ( x e. ( 1 ... N ) |-> 0 ) ) @=
        ( vn cn wcel c1 cfz co cc0 cmpt cvv wceq ovex mptex wa c0cv cfv cv
        oveq2 eqidd mpteq12dv df-nullcv fvmptg syl5eq mpan2 ) BFGZAHBIJZKLZMGZC
        UJNAUIKHBIOPUHUKQCBRSUJDEBAHETZIJZKLUJFMRULBNZAUMKUIKULBHIUAUNKUBUCAEUD
        UEUFUG @.
    @}

    @{
      @d x N @.
      @( The null vector is a complex vector.  (Contributed by FL,
         15-Sep-2013.) @)
      zernpl @p |- ( N e. NN -> 0w e. ( CC ^m ( 1 ... N ) ) ) @=
        ( vx cn wcel c1 cfz co cc0 cmpt cc cmap isnullcv wf cv wa 0cn a1i eqid
        fmptd cnex ovex elmap sylibr eqeltrd ) AEFZBDGAHIZJKZLUHMIZDABCNUGUHLUI
        OUIUJFUGDUHJLUIJLFUGDPUHFQRSUITUALUHUIUBGAHUCUDUEUF @.
    @}

    @{
      @d x A @.  @d x n N @.
      @( Value of the complex vector at a specific coordinate.  (Contributed by
         FL, 15-Sep-2013.) @)
      valvze @p |- ( ( N e. NN /\ A e. ( 1 ... N ) ) -> ( 0w ` A ) = 0 ) @=
        ( vn vx cn wcel c1 cfz co cfv c0cv cc0 cv cmpt wceq fveq1d cvv eqidd wa
        fveq1i df-nullcv a1i ovex mptexg mp1i oveq2 mpteq12dv eqid fvmptg mpdan
        adantr cc simpr 0cn sylancl 3eqtrd syl5eq ) BGHZAIBJKZHZUAZACLABMLZLZNA
        CVDDUBVCVEABEGFIEOZJKZNPZPZLZLAFVANPZLZNVCAVDVJVCBMVIMVIQVCFEUCUDRRVCAV
        JVKUTVJVKQZVBUTVKSHZVMVASHVNUTIBJUEFVANSUFUGEBVHVKGSVIVFBQZFVGNVANVFBIJ
        UHVONTUIVIUJUKULUMRVCVBNUNHVLNQUTVBUOUPFANNVAUNVKFOAQNTVKUJUKUQURUS @.
    @}
  @}

  @{
    addcomv.1 @e |- +w = ( +cv ` N ) @.
    @{
      @d x A @.  @d x B @.  @d x N @.
      @( Vector addition is commutative.  (Contributed by FL, 15-Sep-2013.) @)
      addcomv @p |- ( ( N e. NN /\ A e. ( CC ^m ( 1 ... N ) )
      /\ B e. ( CC ^m ( 1 ... N ) ) )
      -> ( A +w B ) = ( B +w A ) ) @=
        ( vx wcel cc c1 cfz co w3a cfv caddc cmpt wa wceq wi wf cnex cn cmap cv
        ovex elmap ffvelrn 3adant1 3adant2 jca sylbi com12 imp addcom mpteq2dva
        3exp syl isaddrv 3com23 3eqtr4d ) CUAGZAHICJKZUBKZGZBVBGZLZFVAFUCZAMZVF
        BMZNKZOFVAVHVGNKZOZABDKBADKZVEFVAVIVJVEVFVAGZPVGHGZVHHGZPZVIVJQVEVMVPVC
        VDVMVPRZUTVCVDVQVCVAHASZVDVQRHVAATICJUDZUEVDVRVQVDVAHBSZVRVQRHVABTVSUEV
        TVRVMVPVTVRVMLVNVOVRVMVNVTVAHVFAUFUGVTVMVOVRVAHVFBUFUHUIUOUJUKUJULUGULV
        GVHUMUPUNFACBDEUQUTVDVCVLVKQFBCADEUQURUS @.
    @}

    @{
      @d x y A @.  @d x y B @.  @d x y C @.  @d x y N @.
      @( Vector addition is associative.  (Contributed by FL, 15-Sep-2013.) @)
      addassv @p |- ( ( N e. NN /\ ( A e. ( CC ^m ( 1 ... N ) ) /\
        B e. ( CC ^m ( 1 ... N ) ) /\ C e. ( CC ^m ( 1 ... N ) ) ) ) ->
        ( ( A +w B ) +w C ) = ( A +w ( B +w C ) ) ) @=
        ( vx vy wcel cc co wa cfv caddc wceq cvv wi cnex ffvelrnb mp2an cn cmap
        c1 cfz w3a cv cmpt isaddrv 3adant3r3 oveq1d simpl wf simpr1 ovex simpr2
        sylan addcld eqid wb pm3.2i elmapg mp1i mpbird simpr3 syl3anc 3adant3r1
        fmptd oveq2d ex 3ad2ant1 adantl 3ad2ant2 3ad2ant3 addassd simpr oveq12d
        imp fveq2 fvmptg sylancl 3eqtr4d mpteq2dva 3eqtr4rd 3eqtrd ) DUAIZAJUCD
        UDKZUBKZIZBWGIZCWGIZUEZLZABEKZCEKGWFGUFZAMZWNBMZNKZUGZCEKZHWFHUFZWRMZWT
        CMZNKZUGZABCEKZEKZWLWMWRCEWEWHWIWMWROWJGADBEFUHUIUJWLWEWRWGIZWJWSXDOWEW
        KUKZWLXGWFJWRULZWLGWFWQJWRWLWNWFIZLZWOWPWLWHXJWOJIZWEWHWIWJUMZWFPIZJPIZ
        WHXJLXLQUCDUDUNZRWFJWNPPASTUPWLWIXJWPJIZWEWHWIWJUOXNXOWIXJLXQQXPRWFJWNP
        PBSTUPZUQWRURZVGXOXNLZXGXIUSWLXOXNRXPUTZJWFWRPPVAVBVCWEWHWIWJVDZHWRDCEF
        UHVEWLAGWFWPWNCMZNKZUGZEKZHWFWTAMZWTYEMZNKZUGZXFXDWLWEWHYEWGIZYFYJOXHXM
        WLYKWFJYEULZWLGWFYDJYEXKWPYCXRWLWJXJYCJIZYBXNXOWJXJLYMQXPRWFJWNPPCSTUPU
        QYEURZVGXTYKYLUSWLYAJWFYEPPVAVBVCHADYEEFUHVEWLXEYEAEWEWIWJXEYEOWHGBDCEF
        UHVFVHWLHWFXCYIWLWTWFIZLZYGWTBMZNKZXBNKZYGYQXBNKZNKZXCYIYPYGYQXBWLYOYGJ
        IZWKYOUUBQZWEWHWIUUCWJWHYOUUBXNXOWHYOLUUBQXPRWFJWTPPASTVIVJVKVQWLYOYQJI
        ZWKYOUUDQZWEWIWHUUEWJWIYOUUDXNXOWIYOLUUDQXPRWFJWTPPBSTVIVLVKVQWLYOXBJIZ
        WKYOUUFQZWEWJWHUUGWIWJYOUUFXNXOWJYOLUUFQXPRWFJWTPPCSTVIVMVKVQVNYPYOYRPI
        ZXCYSOWLYOVOZYGYQNUNYOUUHLXAYRXBNGWTWQYRWFPWRWNWTOZWOYGWPYQNWNWTAVRWNWT
        BVRZVPXSVSUJVTYPYOYTPIZYIUUAOUUIYQXBNUNYOUULLYHYTYGNGWTYDYTWFPYEUUJWPYQ
        YCXBNUUKWNWTCVRVPYNVSVHVTWAWBWCWD @.
    @}
  @}

  @{
    @d x A a @.  @d x N @.  @d x 0w @.
    addidv2.1 @e |- 0w = ( 0cv ` N ) @.
    addidv2.2 @e |- +w = ( +cv ` N ) @.
    @( The null vector is a left identity for vector addition.  (Contributed by
       FL, 15-Sep-2013.) @)
    addidv2 @p |- ( ( N e. NN /\ A e. ( CC ^m ( 1 ... N ) ) )
      -> ( 0w +w A ) = A ) @=
      ( vx cn wcel cc c1 cfz co wa cfv caddc cmpt cc0 wceq wi cv valvze adantlr
      cmap oveq1d wf cnex ovex elmap ffvelrn a1i syl5bi imp31 addid2d mpteq2dva
      ex eqtrd simpl zernpl adantr simpr isaddrv syl3anc sylib feqmptd 3eqtr4d
      ) BHIZAJKBLMZUDMZIZNZGVHGUAZDOZVLAOZPMZQZGVHVNQDACMZAVKGVHVOVNVKVLVHIZNZV
      ORVNPMVNVSVMRVNPVGVRVMRSVJVLBDEUBUCUEVSVNVGVJVRVNJIZVJVHJAUFZVGVRVTTZJVHA
      UGKBLUHUIZWAWBTVGWAVRVTVHJVLAUJUPUKULUMUNUQUOVKVGDVIIZVJVQVPSVGVJURVGWDVJ
      BDEUSUTVGVJVAZGDBACFVBVCVKGVHJAVKVJWAWEWCVDVEVF @.

    @( The null vector is a right identity for vector addition.  (Contributed
       by FL, 15-Sep-2013.) @)
    addidrv2 @p |- ( ( N e. NN /\ A e. ( CC ^m ( 1 ... N ) ) )
      -> ( A +w 0w ) = A ) @=
      ( cn wcel cc c1 cfz co cmap wa wceq zernpl adantr addcomv mpd3an3 addidv2
      eqtrd ) BGHZAIJBKLMLZHZNADCLZDACLZAUBUDDUCHZUEUFOUBUGUDBDEPQADBCFRSABCDEF
      TUA @.
  @}

  @{
    @d u v +w @.  @d u v N @.
    vecaddonto.1 @e |- +w = ( +cv ` N ) @.
    @( Vector addition is onto.  (Contributed by FL, 29-May-2014.) @)
    vecaddonto @p |- ( N e. NN ->
     +w : ( ( CC ^m ( 1 ... N ) ) X. ( CC ^m ( 1 ... N ) ) )
       -onto-> ( CC ^m ( 1 ... N ) ) ) @=
      ( vu vv cn wcel cc c1 cfz co cmap cxp wf cv cfv wceq wrex wral sylanbrc
      wfo sigadd wa c0cv eqid zernpl adantr simpr opelxp df-ov addidv2 syl5reqr
      cop fveq2 eqeq2d rspcev syl2anc ralrimiva dffo3 ) AFGZHIAJKLKZVAMZVABNDOZ
      EOZBPZQZEVBRZDVASVBVABUAABCUBUTVGDVAUTVCVAGZUCZAUDPZVCUMZVBGZVCVKBPZQZVGV
      IVJVAGZVHVLUTVOVHAVJVJUEZUFUGUTVHUHVJVCVAVAUITVIVMVJVCBKVCVJVCBUJVCABVJVP
      CUKULVFVNEVKVBVDVKQVEVMVCVDVKBUNUOUPUQUREDVBVABUST @.
  @}

  @{
    cnegvex2.1 @e |- +w = ( +cv ` N ) @.
    cnegvex2.2 @e |- 0w = ( 0cv ` N ) @.
    cnegvex2.3 @e |- N e. NN @.
    @{
      @d x y A i @.  @d x y i N @.
      @( Existence of a left inverse for vector addition.  (Contributed by FL,
         15-Sep-2013.) @)
      cnegvex2 @p |- ( A e. ( CC ^m ( 1 ... N ) ) ->
       E. x e. ( CC ^m ( 1 ... N ) ) ( x +w A ) = 0w ) @=
        ( vi cc c1 co wcel wceq cfv caddc cmpt cc0 ci cmul cfz cmap wrex ax-icn
        cv wf wa mulcli cnex ovex elmap ffvelrn sylanb mulcl sylancr eqid fmptd
        sylibr ax-1cn adddir mp3an12 oveq1i mul02 syl5eq mulid2 oveq2d 3eqtr3rd
        ax-i2m1 syl mpteq2dva nfmpt1 nfeq2 wi fveq1 fvmpt2 eqtr expcom ex com3l
        cvv mpsyl oveq1d mpteq2da eqeq1d rspcev syl2anc cplcv cn isaddrv mp3an1
        imp ancoms oveq syl5ibr ax-mp c0cv isnullcv a1i eqeq12d rexbidva mpbird
        eqtri ) BJKCUALZUBLZMZAUEZBDLZENZAXDUCIXCIUEZXFOZXIBOZPLZQZIXCRQZNZAXDU
        CZXEIXCSSTLZXKTLZQZXDMZIXCXRXKPLZQZXNNZXPXEXCJXSUFXTXEIXCXRJXSXEXIXCMZU
        GZXQJMZXKJMZXRJMSSUDUDUHZXEXCJBUFYDYGJXCBUIKCUAUJZUKXCJXIBULUMZXQXKUNUO
        XSUPZUQJXCXSUIYIUKURXEIXCYARYEYGYARNYJYGXQKPLZXKTLZXRKXKTLZPLZRYAYFKJMY
        GYMYONYHUSXQKXKUTVAYGYMRXKTLRYLRXKTVHVBXKVCVDYGYNXKXRPXKVEVFVGVIVJXOYCA
        XSXDXFXSNZXMYBXNYPIXCXLYAIXFXSIXCXRVKVLYPYDUGXJXRXKPYPYDXJXRNZXRVTMZYPX
        JXIXSOZNZYDYQVMXQXKTUJXIXFXSVNYDYRYTYQYDYRYTYQVMZYDYRUGYSXRNZUUAIXCXRVT
        XSYKVOYTUUBYQXJYSXRVPVQVIVRVSWAWKWBWCWDWEWFXEXHXOAXDXEXFXDMZUGZXGXMEXND
        CWGOZNZUUDXGXMNZVMFUUDUUGUUFXFBUUELZXMNZUUCXEUUICWHMZUUCXEUUIHIXFCBUUEU
        UEUPWIWJWLUUFXGUUHXMXFBDUUEWMWDWNWOEXNNUUDECWPOZXNGUUJUUKXNNHICUUKUUKUP
        WQWOXBWRWSWTXA @.
    @}

    @{
      @d i x y A @.  @d i x y N @.
      @( Existence of a left inverse for vector addition.  (Contributed by FL,
         29-May-2014.) @)
      rnegvex2 @p |- ( A e. ( RR ^m ( 1 ... N ) ) ->
       E. x e. ( RR ^m ( 1 ... N ) ) ( x +w A ) = 0w ) @=
        ( vi cr co wcel wceq cfv caddc cmpt wf wa elmap cc c1 cfz cmap wrex cc0
        cneg ffvelrn renegcld eqid fmptd reex ovex 3imtr4i recnd sylanb addcomd
        cv negcld negidd eqtrd mpteq2dva nfmpt1 nfeq2 cvv wi negex fveq1 fvmpt2
        eqtr expcom syl ex com3l mpsyl imp oveq1d mpteq2da eqeq1d syl2anc cplcv
        rspcev cn id wss ax-resscn mpan2 cnex isaddrv syl3an mp3an1 ancoms oveq
        fss syl5ibr ax-mp isnullcv mp1i eqeq12d rexbidva mpbird ) BJUACUBKZUCKZ
        LZAUQZBDKZEMZAXBUDIXAIUQZXDNZXGBNZOKZPZIXAUEPZMZAXBUDZXCIXAXIUFZPZXBLZI
        XAXOXIOKZPZXLMZXNXAJBQZXAJXPQXCXQYAIXAXOJXPYAXGXALZRZXIXAJXGBUGZUHXPUIZ
        UJJXABUKUACUBULZSZJXAXPUKYFSUMXCIXAXRUEXCYBRZXRXIXOOKUEYHXOXIYHXIXCYAYB
        XITLYGYCXIYDUNUOZURYIUPYHXIYIUSUTVAXMXTAXPXBXDXPMZXKXSXLYJIXAXJXRIXDXPI
        XAXOVBVCYJYBRXHXOXIOYJYBXHXOMZXOVDLZYJXHXGXPNZMZYBYKVEXIVFXGXDXPVGYBYLY
        NYKYBYLYNYKVEZYBYLRYMXOMZYOIXAXOVDXPYEVHYNYPYKXHYMXOVIVJVKVLVMVNVOVPVQV
        RWAVSXCXFXMAXBXCXDXBLZRZXEXKEXLDCVTNZMZYRXEXKMZVEFYRUUAYTXDBYSKZXKMZYQX
        CUUCCWBLZYQXCUUCHUUDUUDYQXDTXAUCKZLZXCBUUELZUUCUUDWCXAJXDQZXATXDQZYQUUF
        UUHJTWDZUUIWEXAJTXDWMWFJXAXDUKYFSTXAXDWGYFSUMYAXATBQZXCUUGYAUUJUUKWEXAJ
        TBWMWFYGTXABWGYFSUMIXDCBYSYSUIWHWIWJWKYTXEUUBXKXDBDYSWLVRWNWOUUDEXLMYRH
        ICEGWPWQWRWSWT @.
    @}
  @}

  @{
    @d x A @.  @d x N @.
    cnegvex2b.1 @e |- +w = ( +cv ` N ) @.
    cnegvex2b.2 @e |- 0w = ( 0cv ` N ) @.
    @( Existence of a left inverse for vector addition.  (Contributed by FL,
       15-Sep-2013.) @)
    cnegvex2b @p |- ( ( N e. NN /\ A e. ( CC ^m ( 1 ... N ) ) ) ->
       E. x e. ( CC ^m ( 1 ... N ) ) ( x +w A ) = 0w ) @=
      ( cn wcel cc c1 cfz co cmap cplcv cfv c0cv wceq wrex wi cif oveq2d eleq2d
      wa cv oveq2 fveq2 oveqd eqeq12d rexeqbidv imbi12d eqid 1nn cnegvex2 dedth
      elimel imp oveqi eqeq12i rexbii sylibr ) CHIZBJKCLMZNMZIZUDAUEZBCOPZMZCQP
      ZRZAVDSZVFBDMZERZAVDSVBVEVKVBVEVKTBJKVBCKUAZLMZNMZIZVFBVNOPZMZVNQPZRZAVPS
      ZTCKCVNRZVEVQVKWBWCVDVPBWCVCVOJNCVNKLUFUBZUCWCVJWAAVDVPWDWCVHVSVIVTWCVGVR
      VFBCVNOUGUHCVNQUGUIUJUKABVNVRVTVRULVTULCKHUMUPUNUOUQVMVJAVDVLVHEVIDVGVFBF
      URGUSUTVA @.
  @}

  @{
    @d x A @.  @d x N @.
    rnegvex2b.1 @e |- +w = ( +cv ` N ) @.
    rnegvex2b.2 @e |- 0w = ( 0cv ` N ) @.
    @( Existence of a left inverse for vector addition.  (Contributed by FL,
       29-May-2014.) @)
    rnegvex2b @p |- ( ( N e. NN /\ A e. ( RR ^m ( 1 ... N ) ) ) ->
       E. x e. ( RR ^m ( 1 ... N ) ) ( x +w A ) = 0w ) @=
      ( cn wcel cr c1 cfz co cmap cplcv cfv c0cv wceq wrex wi cif oveq2d eleq2d
      wa cv oveq2 fveq2 oveqd eqeq12d rexeqbidv imbi12d eqid 1nn rnegvex2 dedth
      elimel imp oveqi eqeq12i rexbii sylibr ) CHIZBJKCLMZNMZIZUDAUEZBCOPZMZCQP
      ZRZAVDSZVFBDMZERZAVDSVBVEVKVBVEVKTBJKVBCKUAZLMZNMZIZVFBVNOPZMZVNQPZRZAVPS
      ZTCKCVNRZVEVQVKWBWCVDVPBWCVCVOJNCVNKLUFUBZUCWCVJWAAVDVPWDWCVHVSVIVTWCVGVR
      VFBCVNOUGUHCVNQUGUIUJUKABVNVRVTVRULVTULCKHUMUPUNUOUQVMVJAVDVLVHEVIDVGVFBF
      URGUSUTVA @.
  @}

  @c -cv @. @( Substraction of complex vectors. @)

  @( Extends class notation with substraction of complex vectors. @)
  cmcv @a class -cv @.

  @{
    @d n u v w @.
    @( Substraction of complex vectors in a space of dimension ` n ` .
       Experimental.  (Contributed by FL, 15-Sep-2013.) @)
    df-subcatv @a |- -cv = ( n e. NN |-> ( u e. ( CC ^m ( 1 ... n ) ) ,
        v e. ( CC ^m ( 1 ... n ) ) |->
        ( iota_ w e. ( CC ^m ( 1 ... n ) ) ( v ( +cv ` n ) w ) = u ) ) ) @.
  @}

  @{
    @d x A @.  @d x B @.  @d x C @.  @d x N @.  @d x +w @.
    addcanri.1 @e |- +w = ( +cv ` N ) @.
    addcanri.2 @e |- N e. NN @.
    addcanri.3 @e |- A e. ( CC ^m ( 1 ... N ) ) @.
    addcanri.4 @e |- B e. ( CC ^m ( 1 ... N ) ) @.
    addcanri.5 @e |- C e. ( CC ^m ( 1 ... N ) ) @.
    @( Cancellation law for vector addition.  (Contributed by FL,
       15-Sep-2013.) @)
    addcanri @p |- ( ( A +w B ) = ( A +w C ) <-> B = C ) @=
      ( vx co wceq wcel wi w3a oveq2 3jca 3adant3 addassv c0cv cfv cc c1 cfz cv
      cmap wrex eqid cnegvex2 3ad2ant3 cn wa simpr simpl3 simpl2 sylancr simpl1
      3eqtr4d 3exp mp3an wb oveq1 eqeq12d eqcoms imbi2d syl5ibrcom mp2b addidv2
      rexlimiv mp2an 3eqtr3g impbii ) ABELZACELZMZBCMVPDUAUBZBELZVQCELZBCAUCUDD
      UELUGLZNZKUFZAELZVQMZKVTUHVPVRVSMZOZHKADEVQFVQUIZGUJWDWFKVTWBVTNZWFWDVPWC
      BELZWCCELZMZOZCVTNZBVTNZWAWHWLOJIHWMWNWAPZWHVPWKWOWHVPPZWBVNELZWBVOELZWIW
      JVPWOWQWRMWHVNVOWBEQUKWPDULNZWHWAWNPZWIWQMGWOWHWTVPWOWHUMZWHWAWNWOWHUNZWM
      WNWAWHUOZWMWNWAWHUPRSWBABDEFTUQWPWSWHWAWMPZWJWRMGWOWHXDVPXAWHWAWMXBXCWMWN
      WAWHURRSWBACDEFTUQUSUTVAWDWEWKVPWEWKVBVQWCVQWCMVRWIVSWJVQWCBEVCVQWCCEVCVD
      VEVFVGVJVHWSWNVRBMGIBDEVQWGFVIVKWSWMVSCMGJCDEVQWGFVIVKVLBCAEQVM @.
  @}

  @{
    @d x A @.  @d x B @.  @d x C @.  @d x N @.
    addcanrg.1 @e |- +w = ( +cv ` N ) @.
    @( Cancellation law for vector addition.  (Contributed by FL,
       15-Sep-2013.) @)
    addcanrg @p |- ( ( N e. NN /\
      ( A e. ( CC ^m ( 1 ... N ) ) /\ B e. ( CC ^m ( 1 ... N ) ) /\
        C e. ( CC ^m ( 1 ... N ) ) ) )
     -> ( ( A +w B ) = ( A +w C ) <-> B = C ) ) @=
      ( vx wcel co w3a wa wceq cfv oveqi eqid syl wi oveq2 simpll ex cn cc cmap
      c1 cfz cplcv eqeq12i c0cv cv wrex simpr1 jca adantr cnegvex2b oveq eqeq1d
      simpl simprr simplr1 simplr2 addassv eqcomd syl13anc simplr3 eqtr eqeq12d
      simpr oveq1 biimpcd eqcoms expcom com3l com4l com13 imp impcom mpd syl6bi
      com3r com12 ax-mp rexlimiv mpcom addidv2 syl2anc 3eqtr3d syl5bi impbid1 )
      DUAHZAUBUDDUEIUCIZHZBWJHZCWJHZJZKZABEIZACEIZLZBCLZWRABDUFMZIZACWTIZLZWOWS
      WPXAWQXBEWTABFNEWTACFNUGWOXCWSWOXCKZDUHMZBWTIZXECWTIZBCGUIZAEIZXELZGWJUJZ
      XDXFXGLZXDWIWKKZXKWOXMXCWOWIWKWIWNUQWIWKWLWMUKULUMGADEXEFXEOZUNPXJXDXLQZG
      WJXJXHWJHZXOEWTLZXJXPXOQZQFXQXJXHAWTIZXELZXRXQXIXSXEXHAEWTUOUPXTXPXOXDXTX
      PKZXLXCWOYAXLQZXCXHXAWTIZXHXBWTIZLZWOYBQXAXBXHWTRWOYAYEXLWOYAYEXLQZWOYAKZ
      YCXSBWTIZLZYFYGWIXPWKWLYIWIWNYASWOXTXPURWKWLWMWIYAUSWKWLWMWIYAUTWIXPWKWLJ
      KYHYCXHABDWTWTOZVAVBVCYAWOYIYFQZXTXPWOYKQWOXPXTYKWOXPXTYKQZWOXPKZXSCWTIZY
      DLZYLYMWIXPWKWMYOWIWNXPSWOXPVGWKWLWMWIXPUSWKWLWMWIXPVDXHACDWTYJVAVCYEYOXT
      YIXLYOXTYIXLQQZQYDYCYOYDYCLZYPYOYQKYNYCLZYPYNYDYCVEYIYRXTXLYRYIXTXLQZYRYI
      KYNYHLYSYNYCYHVEYSYHYNXTYHYNLXLXTYHXFYNXGXSXEBWTVHXSXECWTVHVFVIVJPVKVLPVK
      VJVMPTVNVOVPVQTVSPVPVTTVRWAVTWBWCXDWIWLXFBLWIWNXCSZWKWLWMWIXCUTBDWTXEXNYJ
      WDWEXDWIWMXGCLYTWKWLWMWIXCVDCDWTXEXNYJWDWEWFTWGBCAERWH @.
  @}

  @{

    negveud.1 @e |- +w = ( +cv ` N ) @.
    @{
      @d x y A @.  @d x y B @.  @d x y N @.  @d x y +w @.
      @( Existential uniqueness of vector negatives.  (Contributed by FL,
         15-Sep-2013.) @)
      negveud @p |- ( ( N e. NN /\ A e. ( CC ^m ( 1 ... N ) )
      /\ B e. ( CC ^m ( 1 ... N ) ) )
          -> E! x e. ( CC ^m ( 1 ... N ) ) ( A +w x ) = B ) @=
        ( vy wcel co w3a cv wceq wrex wa wi 3adant2 impcom eqtr ex syl cn cc c1
        cfz cmap wral wreu c0cv cfv eqid cnegvex2b 3adant3 claddrv 3exp addcomv
        com23 imp 3expia addassv eqcomd 3exp2 com34 3imp 3ad2ant3 oveq1d expcom
        addidv2 com4l 3ad2ant2 mp2d oveq2 eqeq1d rspcev syl2anc rexlimiv simpl1
        mpd mpcom simpl2 simprl simprr addcanrg biimpd syl13anc com3r ralrimivv
        eqcoms com3l reu4 sylanbrc ) DUAHZBUBUCDUDIUEIZHZCWLHZJZBAKZEIZCLZAWLMZ
        WRBGKZEIZCLZNZWPWTLZOZGWLUFAWLUFWRAWLUGWTBEIZDUHUIZLZGWLMZWOWSWKWMXIWNG
        BDEXGFXGUJZUKULXHWOWSOGWLWTWLHZXHWOWSXKXHWOJZWTCEIZWLHZBXMEIZCLZWSXKWOX
        NXHWOXKXNWKWNXKXNOZWMWKWNXQWKXKWNXNWKXKWNXNWTDCEFUMUNUPUQPQPXLXAXFLZXPX
        KWOXRXHWOXKXRWKWMXKXROWNWKWMXKXRBWTDEFUOURULQPXLXOXACEIZLZXGCEIZCLZXRXP
        OZXKWOXTXHWOXKXTWKWMWNXKXTOWKWMXKWNXTWKWMXKWNXTWKWMXKWNJNXSXOBWTCDEFUSU
        TVAVBVCQPWOXKYBXHWKWNYBWMCDEXGXJFVGPVDXHXKXTYBYCOOWOXRXHXTYBXPXRXHXTYBX
        POZOZXRXHNZXSYALZYEYFXAXGCEXAXFXGRVEXTYGYDXTYGNXOYALZYDXOXSYARYHYBXPXOY
        ACRSTVFTSVHVIVJVQWRXPAXMWLWPXMLWQXOCWPXMBEVKVLVMVNUNVOVRWOXEAGWLWLXCWOW
        PWLHZXKNZXDXBWRWOYJXDOOZWRYKOCXAWRCXALZYKWRYLNWQXALZYKWQCXARWOYJYMXDWOY
        JYMXDOZWOYJNWKWMYIXKYNWKWMWNYJVPWKWMWNYJVSWOYIXKVTWOYIXKWAWKWMYIXKJNYMX
        DBWPWTDEFWBWCWDSWETVFWGQWHWFWRXBAGWLXDWQXACWPWTBEVKVLWIWJ @.
    @}

    @{
      @d x y +w @.  @d x y A @.  @d x y B @.  @d x y N @.
      @( Existential uniqueness of vector negatives.  (Contributed by FL,
         29-May-2014.) @)
      negveudr @p |- ( ( N e. NN /\ A e. ( RR ^m ( 1 ... N ) )
      /\ B e. ( RR ^m ( 1 ... N ) ) )
          -> E! x e. ( RR ^m ( 1 ... N ) ) ( A +w x ) = B ) @=
        ( vy wcel cr co w3a wceq wa wi 3adant2 impcom cc eqtr wf elmap cfz cmap
        cn c1 cv wrex wral wreu c0cv eqid rnegvex2b 3adant3 claddrvr 3exp com23
        cfv imp cvv wss cnex ax-resscn mapss mp2an sseli addcomv syl3an addassv
        id 3expia eqcomd expcom com12 3expd 3imp addidv2 sylan2 3ad2ant3 oveq1d
        com34 ex syl com4l 3ad2ant2 mp2d mpd oveq2 eqeq1d rspcev rexlimiv mpcom
        syl2anc simpl1 adantr fss mpan2 reex 3imtr4i ad2antrl ad2antll addcanrg
        ovex biimpd syl13anc com3r eqcoms com3l ralrimivv reu4 sylanbrc ) DUCHZ
        BIUDDUAJZUBJZHZCXLHZKZBAUEZEJZCLZAXLUFZXRBGUEZEJZCLZMZXPXTLZNZGXLUGAXLU
        GXRAXLUHXTBEJZDUIUPZLZGXLUFZXOXSXJXMYIXNGBDEYGFYGUJZUKULYHXOXSNGXLXTXLH
        ZYHXOXSYKYHXOKZXTCEJZXLHZBYMEJZCLZXSYKXOYNYHXOYKYNXJXNYKYNNZXMXJXNYQXJY
        KXNYNXJYKXNYNXTDCEFUMUNUOUQOPOYLYAYFLZYPYKXOYRYHXOYKYRXJXMYKYRNXNXJXMYK
        YRXJXJXMBQXKUBJZHZYKXTYSHZYRXJVHXLYSBQURHIQUSZXLYSUSUTVAIQXKURVBVCZVDZX
        LYSXTUUCVDZBXTDEFVEVFVIULPOYLYOYACEJZLZYGCEJZCLZYRYPNZYKXOUUGYHXOYKUUGX
        JXMXNYKUUGNXJXMYKXNUUGXJXMYKXNUUGXMYKXNKXJUUGXMYTYKUUAXNCYSHZXJUUGNUUDU
        UEXLYSCUUCVDZXJYTUUAUUKKZUUGXJUUMMUUFYOBXTCDEFVGVJVKVFVLVMVSVNPOXOYKUUI
        YHXJXNUUIXMXNXJUUKUUIUULCDEYGYJFVOVPOVQYHYKUUGUUIUUJNNXOYRYHUUGUUIYPYRY
        HUUGUUIYPNZNZYRYHMZUUFUUHLZUUOUUPYAYGCEYAYFYGRVRUUGUUQUUNUUGUUQMYOUUHLZ
        UUNYOUUFUUHRUURUUIYPYOUUHCRVTWAVKWAVTWBWCWDWEXRYPAYMXLXPYMLXQYOCXPYMBEW
        FWGWHWKUNWIWJXOYEAGXLXLYCXOXPXLHZYKMZYDYBXRXOUUTYDNNZXRUVANCYAXRCYALZUV
        AXRUVBMXQYALZUVAXQCYARXOUUTUVCYDXOUUTUVCYDNZXOUUTMXJYTXPYSHZUUAUVDXJXMX
        NUUTWLXOYTUUTXMXJYTXNUUDWCWMUUSUVEXOYKXKIXPSZXKQXPSZUUSUVEUVFUUBUVGVAXK
        IQXPWNWOIXKXPWPUDDUAXAZTQXKXPUTUVHTWQWRYKUUAXOUUSXKIXTSZXKQXTSZYKUUAUVI
        UUBUVJVAXKIQXTWNWOIXKXTWPUVHTQXKXTUTUVHTWQWSXJYTUVEUUAKMUVCYDBXPXTDEFWT
        XBXCVTXDWAVKXEPXFXGXRYBAGXLYDXQYACXPXTBEWFWGXHXI @.
    @}

  @}

  @{
    @d w v u U @.  @d w v u n N @.  @d w u v V @.  @d w +w @.
    issubcv.1 @e |- +w = ( +cv ` N ) @.
    issubcv.2 @e |- -w = ( -cv ` N ) @.
    @( Substraction of complex vectors in a space of dimension ` n ` .
       (Contributed by FL, 15-Sep-2013.) @)
    issubcv @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) /\
                       V e. ( CC ^m ( 1 ... N ) ) )
     -> ( U -w V ) =
       ( iota_ w e. ( CC ^m ( 1 ... N ) ) ( V +w w ) = U ) ) @=
      ( vu vv vn wcel cc c1 co cmap cv wceq crio eqeq1d cn cfz cmcv cplcv cmpt2
      w3a wi oveq2 oveq2d fveq2 oveqd riotaeqbidv mpt2eq123dv df-subcatv mpt2ex
      cfv ovex fvmpt cvv riotaex eqeq2 riotabidv oveq1 eqid ovmpt2g 3exp imbi2d
      mpii oveq syl5ibr 3imp wb wa adantr riotabidva eqeq2d ax-mp syl6bb sylibr
      syl ) CUALZBMNCUBOZPOZLZDWCLZUFBDCUCUPZOZDAQZCUDUPZOZBRZAWCSZRZBDFOZDWHEO
      ZBRZAWCSZRZWAWDWEWMWAWFIJWCWCJQZWHWIOZIQZRZAWCSZUEZRZWDWEWMUGZUGKCIJMNKQZ
      UBOZPOZXIWSWHXGUDUPZOZXARZAXISZUEXDUAUCXGCRZIJXIXIXMWCWCXCXNXHWBMPXGCNUBU
      HUIZXOXNXLXBAXIWCXOXNXKWTXAXNXJWIWSWHXGCUDUJUKTULUMAJIKUNIJWCWCXCMWBPUQZX
      PUOURWDXFXEWEBDXDOZWLRZUGWDWEWLUSLZXRWKAWCUTWDWEXSXRIJBDWCWCXCWLXDWTBRZAW
      CSUSXABRXBXTAWCXABWTVAVBWSDRZXTWKAWCYAWTWJBWSDWHWIVCTVBXDVDVEVFVHXEWMXRWE
      XEWGXQWLBDWFXDVITVGVJVTVKEWIRZWRWMVLGYBWRWNWLRZWMYBWQWLWNYBWPWKAWCYBWHWCL
      ZVMWOWJBYBWOWJRYDDWHEWIVIVNTVOVPFWFRZYCWMVLHYEWNWGWLBDFWFVITVQVRVQVS @.
  @}

  @{
    @d x y +w @.  @d x y A @.  @d x y B @.  @d x y C @.  @d x y N @.
    subaddv.1 @e |- +w = ( +cv ` N ) @.
    subaddv.2 @e |- -w = ( -cv ` N ) @.
    @( Relationship between subtraction and addition.  (Contributed by FL,
       30-May-2014.) @)
    subaddv @p |- ( ( N e. NN /\ ( A e. ( CC ^m ( 1 ... N ) ) /\
       B e. ( CC ^m ( 1 ... N ) ) /\ C e. ( CC ^m ( 1 ... N ) ) ) ) ->
                  ( ( A -w B ) = C <-> ( B +w C ) = A ) ) @=
      ( vx cn wcel cc co w3a wa wceq wb eqeq1d wi imp c1 cmap cv crio 3adant3r3
      cfz issubcv wreu simpll negveud 3exp com3l adantl oveq2 riota2 syl2anc ex
      3impb 3com13 impcom bitr4d ) DJKZALUADUFMUBMZKZBVCKZCVCKZNZOABFMZCPZBIUCZ
      EMZAPZIVCUDZCPZBCEMZAPZVBVDVEVIVNQVFVBVDVENVHVMCIADBEFGHUGRUEVGVBVPVNQZVF
      VEVDVBVQSZVFVEVDVRVFVEVDOZOZVBVQVTVBOVFVLIVCUHZVQVFVSVBUIVTVBWAVSVBWASZVF
      VEVDWBVBVEVDWAVBVEVDWAIBADEGUJUKULTUMTVLVPIVCCVJCPVKVOAVJCBEUNRUOUPUQURUS
      UTVA @.
  @}

  @{
    @d x y A @.  @d x y B @.  @d x y N @.
    issubrv.2 @e |- -w = ( -cv ` N ) @.
    @( Addition of complex vectors.  (Contributed by FL, 29-May-2014.) @)
    issubrv @p |- ( ( N e. NN /\ A e. ( CC ^m ( 1 ... N ) ) /\
          B e. ( CC ^m ( 1 ... N ) ) )
        -> ( A -w B ) = ( x e. ( 1 ... N ) |-> ( ( A ` x ) - ( B ` x ) ) ) ) @=
      ( vy wcel cc co cfv cmin cmpt wceq cvv wi cnex ffvelrn ex sylbi cn c1 cfz
      cmap w3a cv cplcv caddc wa simpr ovex fveq2 oveq12d fvmptg sylancl oveq2d
      eqid elmap 3ad2ant3 imp 3ad2ant2 pncan3d eqtrd mpteq2dva simp1 simp3 wral
      wf jcad subcl syl6 ralrimiv fmpt sylib pm3.2i elmapg mp1i isaddrv syl3anc
      wb mpbird simp2 feqmptd 3eqtr4d sylibr subaddv syl13anc ) DUAHZBIUBDUCJZU
      DJZHZCWJHZUEZBCEJAWIAUFZBKZWNCKZLJZMZNZCWRDUGKZJZBNZWMGWIGUFZCKZXCWRKZUHJ
      ZMZGWIXCBKZMXABWMGWIXFXHWMXCWIHZUIZXFXDXHXDLJZUHJXHXJXEXKXDUHXJXIXKOHXEXK
      NWMXIUJXHXDLUKAXCWQXKWIOWRWNXCNWOXHWPXDLWNXCBULWNXCCULUMWRUQZUNUOUPXJXDXH
      WMXIXDIHZWLWHXIXMPZWKWLWIICVHZXNIWICQUBDUCUKZURZXOXIXMWIIXCCRSTUSUTWMXIXH
      IHZWKWHXIXRPZWLWKWIIBVHZXSIWIBQXPURZXTXIXRWIIXCBRSTVAUTVBVCVDWMWHWLWRWJHZ
      XAXGNWHWKWLVEZWHWKWLVFZWMYBWIIWRVHZWMWQIHZAWIVGYEWMYFAWIWMWNWIHZWOIHZWPIH
      ZUIYFWMYGYHYIWKWHYGYHPZWLWKXTYJYAXTYGYHWIIWNBRSTVAWLWHYGYIPZWKWLXOYKXQXOY
      GYIWIIWNCRSTUSVIWOWPVJVKVLAWIIWQWRXLVMVNZIOHZWIOHZUIYBYEVTWMYMYNQXPVOIWIW
      ROOVPVQWAGCDWRWTWTUQZVRVSWMGWIIBWMWKXTWHWKWLWBZYAVNWCWDWMWHWKWLYBWSXBVTYC
      YPYDWMYEYBYLIWIWRQXPURWEBCWRDWTEYOFWFWGWA @.
  @}

  @{
    @d x U @.  @d x N @.  @d x V @.
    subclcvd.1 @e |- -w = ( -cv ` N ) @.
    @( Closure law for vector substraction.  (Contributed by FL,
       15-Sep-2013.) @)
    subclcvd @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) /\
       V e. ( CC ^m ( 1 ... N ) ) )
       -> ( U -w V ) e. ( CC ^m ( 1 ... N ) ) ) @=
      ( vx cn wcel cc c1 cfz co cmap w3a cv cplcv cfv wceq crio eqid wreu sylib
      issubcv negveud 3com23 ovex riotaclb eqeltrd ) BGHZAIJBKLZMLZHZCUKHZNZACD
      LCFOBPQZLARZFUKSZUKFABCUODUOTZEUCUNUPFUKUAZUQUKHUIUMULUSFCABUOURUDUEUPFUK
      IUJMUFUGUBUH @.

    @( Closure law for vector substraction.  (Contributed by FL,
       29-May-2014.) @)
    subclrvd @p |- ( ( N e. NN /\ U e. ( RR ^m ( 1 ... N ) ) /\
       V e. ( RR ^m ( 1 ... N ) ) )
       -> ( U -w V ) e. ( RR ^m ( 1 ... N ) ) ) @=
      ( vx wcel cr c1 cfz co cmap w3a cfv cc cvv wss wf wi reex cn cv cmin cmpt
      wceq id cnex ax-resscn mapss mp2an sseli issubrv syl3an wral ovex ffvelrn
      wa elmap 3adant1 3adant2 resubcld 3exp sylbi com12 imp ralrimiv eqid fmpt
      sylib wb pm3.2i elmapg mp1i mpbird eqeltrd ) BUAGZAHIBJKZLKZGZCVRGZMZACDK
      ZFVQFUBZANZWCCNZUCKZUDZVRVPVPVSAOVQLKZGVTCWHGWBWGUEVPUFVRWHAOPGHOQVRWHQUG
      UHHOVQPUIUJZUKVRWHCWIUKFACBDEULUMWAWGVRGZVQHWGRZWAWFHGZFVQUNZWKVSVTWMVPVS
      VTUQWLFVQVSVTWCVQGZWLSZVSVQHARZVTWOSHVQATIBJUOZURVTWPWOVTVQHCRZWPWOSHVQCT
      WQURWRWPWNWLWRWPWNMWDWEWPWNWDHGWRVQHWCAUPUSWRWNWEHGWPVQHWCCUPUTVAVBVCVDVC
      VEVFUSFVQHWFWGWGVGVHVIHPGZVQPGZUQWJWKVJWAWSWTTWQVKHVQWGPPVLVMVNVO @.
  @}

  @c -ucv @. @( Negative of a complex vector. @)

  @( Extends class notation with the negative of a complex vector. @)
  cnegcv @a class -ucv @.

  @{
    @d n u @.
    @( Negative of a complex vector.  Experimental.  (Contributed by FL,
       15-Sep-2013.) @)
    df-ucv @a |- -ucv = ( n e. NN |-> ( u e. ( CC ^m ( 1 ... n ) )
      |-> ( ( 0cv ` n ) ( -cv ` n ) u ) ) ) @.
  @}

  @{
    @d u U @.  @d u n N @.
    isucv.1 @e |- ~w = ( -ucv ` N ) @.
    isucv.2 @e |- 0w = ( 0cv ` N ) @.
    isucv.3 @e |- -w = ( -cv ` N ) @.
    @( Negative of a complex vector.  (Contributed by FL, 15-Sep-2013.) @)
    isucv @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) ) ->
       ( ~w ` U ) = ( 0w -w U ) ) @=
      ( vu vn cfv wceq wcel cc c1 cfz co cmap wi cvv cnegcv cn wa c0cv cv simpl
      cmcv cmpt mptex oveq2 oveq2d fveq2 eqidd oveq123d mpteq12dv df-ucv fvmptg
      ovex sylancl fveq1d simpr eqid eqtrd oveq eqeq2d ax-mp oveq1 fveq1 eqeq1d
      syl5ibr ) EBUAKZLZBUBMZANOBPQZRQZMZUCZAEKZDACQZLZSFVQVTVLAVKKZVSLZDBUDKZL
      ZVQWBSGVQWBWDWAWCACQZLZCBUGKZLZVQWFSHVQWFWHWAWCAWGQZLVQWAAIVOWCIUEZWGQZUH
      ZKZWIVQAVKWLVQVMWLTMVKWLLVMVPUFIVOWKNVNRURUIJBINOJUEZPQZRQZWNUDKZWJWNUGKZ
      QZUHWLUBTUAWNBLZIWPWSVOWKWTWOVNNRWNBOPUJUKWTWQWCWJWJWRWGWNBUGULWNBUDULWTW
      JUMUNUOIJUPUQUSUTVQVPWITMWMWILVMVPVAWCAWGURIAWKWIVOTWLWJAWCWGUJWLVBUQUSVC
      WHWEWIWAWCACWGVDVEVJVFWDVSWEWADWCACVGVEVJVFVLVRWAVSAEVKVHVIVJVF @.
  @}

  @{
    isucvr.1 @e |- ~w = ( -ucv ` N ) @.
    @( Negative of a complex vector.  (Contributed by FL, 29-May-2014.) @)
    isucvr @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) ) ->
       ( ~w ` U ) e. ( CC ^m ( 1 ... N ) ) ) @=
      ( cn wcel cc c1 cfz co cmap cfv c0cv cmcv eqid isucv simpl zernpl adantr
      wa simpr subclcvd syl3anc eqeltrd ) BEFZAGHBIJKJZFZTZACLBMLZABNLZJZUFABUJ
      UICDUIOZUJOZPUHUEUIUFFZUGUKUFFUEUGQUEUNUGBUIULRSUEUGUAUIBAUJUMUBUCUD @.
  @}

  @c .cv @. @( Multiplication of complex vectors by a scalar. @)

  @( Extends class notation with scalar multiplication of complex vectors. @)
  csmcv @a class .cv @.

  @{
    @d n s u x @.
    @( Multiplication of complex vectors by a scalar in a space of dimension
       ` n ` .  Experimental.  (Contributed by FL, 15-Sep-2013.) @)
    df-mulcv @a |- .cv = ( n e. NN |->
      ( s e. CC , u e. ( CC ^m ( 1 ... n ) ) |->
        ( x e. ( 1 ... n ) |-> ( s x. ( u ` x ) ) ) ) ) @.
  @}

  @{
    ismulcv.1 @e |- .t = ( .cv ` N ) @.
    @{
      @d n s u x N @.  @d s u x S @.  @d s u x U @.
      @( Multiplication of complex vectors by a scalar in a space of dimension
         ` n ` .  (Contributed by FL, 15-Sep-2013.)  (Revised by Mario
         Carneiro, 23-Aug-2014.) @)
      ismulcv @p |- ( ( N e. NN /\ S e. CC /\ U e. ( CC ^m ( 1 ... N ) ) )
       -> ( S .t U ) = ( x e. ( 1 ... N ) |-> ( S x. ( U ` x ) ) ) ) @=
        ( vs vu vn wceq wcel cc c1 cfz co cmap cv cmul cmpt cvv csmcv cfv cn wi
        cmpt2 simp1 cnex ovex mpt2ex eqidd oveq2 mpteq12dv mpt2eq123dv df-mulcv
        oveq2d fvmptg sylancl oveqd simp2 simp3 mptex oveq1 mpteq2dv fveq1 eqid
        w3a a1i ovmpt2g syl3anc eqtrd oveq eqeq1d syl5ibr ax-mp ) EDUAUBZJZDUCK
        ZBLKZCLMDNOZPOZKZVFZBCEOZAVSBAQZCUBZROZSZJZUDFWBWHVPBCVOOZWGJWBWIBCGHLV
        TAVSGQZWDHQZUBZROZSZUEZOZWGWBVOWOBCWBVQWOTKVOWOJVQVRWAUFGHLVTWNUGLVSPUH
        UIIDGHLLMIQZNOZPOZAWRWMSZUEWOUCTUAWQDJZGHLWSWTLVTWNXALUJXAWRVSLPWQDMNUK
        ZUOXAAWRWMVSWMXBXAWMUJULUMAHIGUNUPUQURWBVRWAWGTKZWPWGJVQVRWAUSVQVRWAUTX
        CWBAVSWFMDNUHVAVGGHBCLVTWNWGWOAVSBWLROZSTWJBJAVSWMXDWJBWLRVBVCWKCJZAVSX
        DWFXEWLWEBRWDWKCVDUOVCWOVEVHVIVJVPWCWIWGBCEVOVKVLVMVN @.
    @}

    @{
      @d x N @.  @d x S @.  @d x U @.
      @( Closure of scalar multiplication.  (Contributed by FL,
         29-May-2014.) @)
      clsmulcv @p |- ( ( N e. NN /\ S e. CC /\ U e. ( CC ^m ( 1 ... N ) ) )
       -> ( S .t U ) e. ( CC ^m ( 1 ... N ) ) ) @=
        ( vx cn wcel cc c1 cfz co cmap w3a cv wf wi cnex wa cvv cmul cmpt elmap
        cfv ismulcv wral ovex ffvelrn mulcl expcom syl ex com23 a1d sylbi com3l
        3imp ralrimiv eqid fmpt sylib wb pm3.2i elmapg mp1i mpbird eqeltrd ) CG
        HZAIHZBIJCKLZMLZHZNZABDLFVJAFOZBUDZUALZUBZVKFABCDEUEVMVQVKHZVJIVQPZVMVP
        IHZFVJUFVSVMVTFVJVHVIVLVNVJHZVTQZVLVHVIWBVLVJIBPZVHVIWBQZQIVJBRJCKUGZUC
        WCWDVHWCWAVIVTWCWAVIVTQZWCWASVOIHZWFVJIVNBUHVIWGVTAVOUIUJUKULUMUNUOUPUQ
        URFVJIVPVQVQUSUTVAITHZVJTHZSVRVSVBVMWHWIRWEVCIVJVQTTVDVEVFVG @.
    @}

    @{
      @d x N @.  @d x S @.  @d x U @.
      @( Closure of scalar multiplication.  (Contributed by FL,
         29-May-2014.) @)
      clsmulrv @p |- ( ( N e. NN /\ S e. RR /\ U e. ( RR ^m ( 1 ... N ) ) )
       -> ( S .t U ) e. ( RR ^m ( 1 ... N ) ) ) @=
        ( vx wcel cr c1 cfz co cmap w3a cc wf reex elmap wa 3adant1 cvv cn cmul
        cv cfv cmpt wceq recn wss ax-resscn fss mpan2 ovex cnex 3imtr4i ismulcv
        id syl3an wral wi simp1 ffvelrn sylanb jca 3expia remulcl syl6 ralrimiv
        eqid fmpt sylib wb pm3.2i elmapg mp1i mpbird eqeltrd ) CUAGZAHGZBHICJKZ
        LKZGZMZABDKZFVSAFUCZBUDZUBKZUEZVTVQVQVRANGWABNVSLKGZWCWGUFVQUPAUGVSHBOZ
        VSNBOZWAWHWIHNUHWJUIVSHNBUJUKHVSBPICJULZQZNVSBUMWKQUNFABCDEUOUQWBWGVTGZ
        VSHWGOZWBWFHGZFVSURWNWBWOFVSWBWDVSGZVRWEHGZRZWOVRWAWPWRUSVQVRWAWPWRVRWA
        WPMVRWQVRWAWPUTWAWPWQVRWAWIWPWQWLVSHWDBVAVBSVCVDSAWEVEVFVGFVSHWFWGWGVHV
        IVJHTGZVSTGZRWMWNVKWBWSWTPWKVLHVSWGTTVMVNVOVP @.
    @}

    @{
      @d n s u x N @.
      @( Functionality of scalar multiplication.  (Contributed by FL,
         29-May-2014.) @)
      fnmulcv @p |- ( N e. NN -> .t : ( CC X. ( CC ^m ( 1 ... N ) ) )
          --> ( CC ^m ( 1 ... N ) ) ) @=
        ( vs vu vx vn wcel cc c1 cfz co cmap wf cv wral wa wi cvv wceq cxp cmul
        cfv cmpt cmpt2 cnex ovex elmap ffvelrn mulcl expcom syl ralrimdva sylbi
        cn a1dd impcom eqid fmpt sylib wb pm3.2i elmapg mpbird ralrimivva fmpt2
        mp1i csmcv mpt2exga eqidd oveq2 oveq2d mpteq1 mpt2eq123dv fvmptg syl5eq
        df-mulcv mpdan feq1d ) AUOHZIIJAKLZMLZUAZWBBNWCWBDEIWBFWADOZFOZEOZUCZUB
        LZUDZUEZNZVTWIWBHZEWBPDIPWKVTWLDEIWBVTWDIHZWFWBHZQZQZWLWAIWINZWPWHIHZFW
        APZWQWOVTWSWNWMVTWSRZWNWAIWFNZWMWTRIWAWFUFJAKUGZUHXAWMWSVTXAWMWRFWAXAWE
        WAHQWGIHZWMWRRWAIWEWFUIWMXCWRWDWGUJUKULUMUPUNUQUQFWAIWHWIWIURUSUTISHZWA
        SHZQWLWQVAWPXDXEUFXBVBIWAWISSVCVGVDVEDEIWBWIWBWJWJURVFUTVTWCWBBWJVTBAVH
        UCZWJCVTWJSHZXFWJTXDWBSHZQXGVTXDXHUFIWAMUGVBDEIWBWISSVIVGGADEIIJGOZKLZM
        LZFXJWHUDZUEWJUOSVHXIATZDEIXKXLIWBWIXMIVJXMXJWAIMXIAJKVKZVLXMXJWATXLWIT
        XNFXJWAWHVMULVNFEGDVQVOVRVPVSVD @.
    @}

  @}

  @{
    mulone.1 @e |- .t = ( .cv ` N ) @.
    @{
      @d x N @.  @d x U @.
      @( Multiplication of a vector by 1.  (Contributed by FL, 29-May-2014.)
         (Revised by Mario Carneiro, 9-Jan-2015.) @)
      mulone @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) )
       -> ( 1 .t U ) = U ) @=
        ( vx cn wcel cc c1 cfz co cmap wa cv cfv cmul cmpt wf simpr cnex ax-1cn
        ovex elmap sylib ffvelrn sylan mulid2d mpteq2dva ismulcv mp3an2 feqmptd
        wceq 3eqtr4d ) BFGZAHIBJKZLKGZMZEUOIENZAOZPKZQZEUOUSQIACKZAUQEUOUTUSUQU
        RUOGZMUSUQUOHARZVCUSHGUQUPVDUNUPSHUOATIBJUBUCUDZUOHURAUEUFUGUHUNIHGUPVB
        VAULUAEIABCDUIUJUQEUOHAVEUKUM @.
    @}

    @{
      @d u x .t @.  @d u x N @.
      @( Vector addition is onto.  (Contributed by FL, 29-May-2014.) @)
      vecscmonto @p |- ( N e. NN -> .t : ( CC X. ( CC ^m ( 1 ... N ) ) )
       -onto-> ( CC ^m ( 1 ... N ) ) ) @=
        ( vu vx cn wcel cc c1 cfz co cmap cxp wf cv cfv wceq wrex wral sylanbrc
        wfo fnmulcv wa cop ax-1cn a1i simpr opelxp df-ov mulone syl5reqr eqeq2d
        fveq2 rspcev syl2anc ralrimiva dffo3 ) AFGZHHIAJKLKZMZUSBNDOZEOZBPZQZEU
        TRZDUSSUTUSBUAABCUBURVEDUSURVAUSGZUCZIVAUDZUTGZVAVHBPZQZVEVGIHGZVFVIVLV
        GUEUFURVFUGIVAHUSUHTVGVJIVABKVAIVABUIVAABCUJUKVDVKEVHUTVBVHQVCVJVAVBVHB
        UMULUNUOUPEDUTUSBUQT @.
    @}

    @{
      @d x .t @.  @d x N @.  @d x S @.  @d x T @.  @d x U @.
      @( Connection between multiplication of complex numbers and scalar
         multiplication.  (Contributed by FL, 29-May-2014.) @)
      mulmulvec @p |- ( ( N e. NN /\ S e. CC /\
      ( T e. CC /\ U e. ( CC ^m ( 1 ... N ) ) ) )
      -> ( ( S x. T ) .t U ) = ( S .t ( T .t U ) ) ) @=
        ( vx wcel cc co cmul cfv cmpt cvv wceq oveq2d ismulcv syl3anc 3eqtr4d
        wa cn c1 cfz cmap w3a cv ovex eqid fvmpt2 sylancl eqcomd simpl2 simpl3l
        simpr wf elmapi adantl 3ad2ant3 ffvelrn sylan mulassd simpl3r mpteq2dva
        simpl1 fveq1d simp1 adantrr 3adant1 simp3r simp3l clsmulcv syld3an3
        mulcl ) DUAHZAIHZBIHZCIUBDUCJZUDJZHZTZUEZGVQABKJZGUFZCLZKJZMZGVQAWCBCEJ
        ZLZKJZMZWBCEJZAWGEJZWAGVQWEWIWAWCVQHZTZABWDKJZKJAWCGVQWOMZLZKJWEWIWNWOW
        QAKWNWQWOWNWMWONHWQWOOWAWMUNBWDKUGGVQWONWPWPUHUIUJUKPWNABWDVNVOVTWMULVP
        VSVNVOWMUMZWAVQICUOZWMWDIHVTVNWSVOVSWSVPCIVQUPUQURVQIWCCUSUTVAWNWHWQAKW
        NWCWGWPWNVNVPVSWGWPOVNVOVTWMVDWRVPVSVNVOWMVBGBCDEFQRVEPSVCWAVNWBIHZVSWK
        WFOVNVOVTVFZVOVTWTVNVOVPWTVSABVMVGVHVNVOVPVSVIZGWBCDEFQRVNVOVTWGVRHZWLW
        JOWAVNVPVSXCXAVNVOVPVSVJXBBCDEFVKRGAWGDEFQVLS @.
    @}

    @{
      distmlva.1 @e |- +w = ( +cv ` N ) @.
      @{
        @d x +w @.  @d x .t @.  @d x N @.  @d x S @.  @d x U @.  @d x V @.
        @( Distribution of scalar multiplication over vector addition.
           (Contributed by FL, 29-May-2014.) @)
        distmlva @p |- ( ( N e. NN /\ S e. CC /\
      ( U e. ( CC ^m ( 1 ... N ) ) /\ V e. ( CC ^m ( 1 ... N ) ) ) )
      -> ( S .t ( U +w V ) ) = ( ( S .t U ) +w ( S .t V ) ) ) @=
          ( vx wcel cc co wa cfv cmul cmpt caddc wceq wi cvv cn c1 cfz cmap w3a
          cv wf wb cnex ovex elmapg anbi12d mp2an ffvelrn expcom im2anan9 simpr
          simpll simplr 3jca a1d syl6 anidms com4l sylbi com3l 3imp1 adddi eqid
          syl fvmpt2 sylancl oveq2d oveq12d 3eqtr4d simpl simprl simprr 3adant2
          adantr isaddrv fveq1d ismulcv simpl1 simpl2 simpl3r syl3anc mpteq2dva
          ex 3adant3r claddrv 3expb syld3an3 simp1 clsmulcv 3adant3l ) CUAJZAKJ
          ZBKUBCUCLZUDLZJZDWTJZMZUEZIWSAIUFZBDFLZNZOLZPZIWSXEABELZNZXEADELZNZQL
          ZPZAXFELZXJXLFLZXDIWSXHXNXDXEWSJZMZAXEIWSXEBNZXEDNZQLZPZNZOLZXEIWSAXT
          OLZPZNZXEIWSAYAOLZPZNZQLZXHXNXSAYBOLZYFYIQLZYEYLXSWRXTKJZYAKJZUEZYMYN
          RWQWRXCXRYQXCWQWRXRYQSZXCWSKBUGZWSKDUGZMZWQWRYRSSKTJZWSTJZXCUUAUHUIUB
          CUCUJUUBUUCMXAYSXBYTKWSBTTUKKWSDTTUKULUMXRUUAWQWRYQXRUUAWQWRYQSZSZSXR
          XRMUUAYOYPMZUUEXRYSYOXRYTYPYSXRYOWSKXEBUNUOYTXRYPWSKXEDUNUOUPUUFUUDWQ
          UUFWRYQUUFWRMWRYOYPUUFWRUQYOYPWRURYOYPWRUSUTWIVAVBVCVDVEVFVGAXTYAVHVJ
          XSYDYBAOXSXRYBTJYDYBRXDXRUQZXTYAQUJIWSYBTYCYCVIVKVLVMXSYHYFYKYIQXSXRY
          FTJYHYFRUUGAXTOUJIWSYFTYGYGVIVKVLXSXRYITJYKYIRUUGAYAOUJIWSYITYJYJVIVK
          VLVNVOXSXGYDAOXSXEXFYCXSWQXAXBUEZXFYCRXDUUHXRWQXCUUHWRWQXCMWQXAXBWQXC
          VPWQXAXBVQWQXAXBVRUTVSVTIBCDFHWAVJWBVMXSXKYHXMYKQXSXEXJYGXDXJYGRZXRWQ
          WRXAUUIXBIABCEGWCWJVTWBXSXEXLYJXSWQWRXBXLYJRWQWRXCXRWDWQWRXCXRWEXAXBW
          QWRXRWFIADCEGWCWGWBVNVOWHWQWRXCXFWTJZXPXIRWQXCUUJWRWQXAXBUUJBCDFHWKWL
          VSIAXFCEGWCWMXDWQXJWTJZXLWTJZXQXORWQWRXCWNWQWRXAUUKXBABCEGWOWJWQWRXBU
          ULXAADCEGWOWPIXJCXLFHWAWGVO @.
      @}

      @{
        @d x .t @.  @d x N @.  @d x S @.  @d x T @.  @d x U @.
        @( "Distribution" of scalar addition.  (Contributed by FL,
           29-May-2014.) @)
        distsava @p |- ( ( N e. NN /\ S e. CC /\
      ( T e. CC /\ U e. ( CC ^m ( 1 ... N ) ) ) )
      -> ( ( S + T ) .t U ) = ( ( S .t U ) +w ( T .t U ) ) ) @=
          ( vx wcel cc co w3a caddc cfv cmul cmpt cvv wceq wi cn c1 cfz cmap wa
          cv simpr ovex eqid fvmpt2 sylancl eqcomd cnex elmap ffvelrn 3exp a1dd
          wf simp2 syl com12 anabsi7 ex sylbi com25 impcom com3l oveq12d simpl2
          3imp1 simpl3l adantl 3ad2ant3 imp adddird simp1 simp3r adantr ismulcv
          3jca fveq1d 3eqtr4d mpteq2dva addcl adantrd a1i 3imp syl3anc clsmulcv
          simp3l 3adant3l 3expb 3adant2 isaddrv ) DUAJZAKJZBKJZCKUBDUCLZUDLZJZU
          EZMZIWRABNLZIUFZCOZPLZQZIWRXDACELZOZXDBCELZOZNLZQZXCCELZXHXJFLZXBIWRX
          FXLXBXDWRJZUEZAXEPLZBXEPLZNLXDIWRXRQZOZXDIWRXSQZOZNLXFXLXQXRYAXSYCNXQ
          YAXRXQXPXRRJYAXRSXBXPUGAXEPUHIWRXRRXTXTUIUJUKULWOWPXAXPXSYCSZXAWOWPXP
          YDTZWTWQWOWPYETTWTXPWOWPWQYDWTWRKCURZXPWOWPWQYDTZTZTZTZKWRCUMUBDUCUHU
          NZYFXPYIYFXPYIYFXPUEZXPYIYLXEKJZYJWRKXDCUOZYMXPYHWOYMXPYGWPYMXPWQYDYM
          XPWQMZYCXSYOXPXSRJYCXSSYMXPWQUSBXEPUHIWRXSRYBYBUIUJUKULUPUQUQUTVAVBVC
          VDVEVFVGVJVHXQABXEWOWPXAXPVIWQWTWOWPXPVKXBXPYMXAWOXPYMTZWPWTYPWQWTYFY
          PYKYFXPYMYNVCVDVLVMVNVOXQXIYAXKYCNXQXDXHXTXQWOWPWTMZXHXTSXBYQXPXBWOWP
          WTWOWPXAVPZWOWPXAUSWOWPWQWTVQZVTVRIACDEGVSUTWAXQXDXJYBXQWOWQWTMZXJYBS
          XBYTXPXBWOWQWTYRWOWPWQWTWJYSVTVRIBCDEGVSUTWAVHWBWCXBWOXCKJZWTXNXGSYRW
          OWPXAUUAWPXAUUATTWOWPWQUUAWTWPWQUUAABWDVCWEWFWGYSIXCCDEGVSWHXBWOXHWSJ
          ZXJWSJZXOXMSYRWOWPWTUUBWQACDEGWIWKWOXAUUCWPWOWQWTUUCBCDEGWIWLWMIXHDXJ
          FHWNWHWB @.
      @}
    @}

  @}

  @{
    @d s u v +w @.  @d s u v .t @.  @d s u v N @.  @d u v w x y +w @.
    @d w x y N @.
    tcnvec.1 @e |- +w = ( +cv ` N ) @.
    tcnvec.2 @e |- .t = ( .cv ` N ) @.
    @( Nuples of complex numbers has a structure of vector space.  (Contributed
       by FL, 29-May-2014.) @)
    tcnvec @p |- ( N e. NN -> <. +w , .t >. e. CVecOLD ) @=
      ( vu vs vv vw vx vy wcel cc co cv wceq wral wa wrex raleqbi1dv cn cop cvc
      cablo c1 cfz cmap cxp caddc cmul cgr sigadd w3a claddrv 3adant3r3 addassv
      wf jca ralrimivvva c0cv cfv eqid zernpl addidv2 cnegvex2b ralrimiva oveq1
      adantr eqeq1d simpl eqeq2d rexbidv anbi12d ralbidva syl2anc cplcv wfo crn
      rspcev wb vecaddonto forn fvex eqeltri rneqi eqcomi isgrpo2 ax-mp xpeq12d
      id feq23d eleq2 anbi1d rexeq anbi2d rexeqbi1dv 3anbi123d syl5bb mpbir3and
      cvv 3syl addcomv 3expib ralrimivv raleq eqcoms syl6rbbr mpbir2and fnmulcv
      isablo mulone simplll simpllr simpr distmlva syl112anc distsava mulmulvec
      simplr xpeq2 ralbidv 3anbi23d isvc ) AUALZCBUBUCLZCUDLZMMUEAUFNUGNZUHZYGB
      UQZUEFOZBNYJPZGOZYJHOZCNZBNYLYJBNZYLYMBNCNPZHYGQZYLYMUINYJBNYOYMYJBNZCNPZ
      YLYMUJNYJBNYLYRBNPZRZHMQZRZGMQZRZFYGQZYDYFCUKLZYNYMYJCNPZHYGQZFYGQZYDUUGY
      GYGUHZYGCUQZYNYGLZYNIOZCNYJYMUUNCNCNPZRZIYGQZHYGQZFYGQZJOZYJCNZYJPZKOYJCN
      ZUUTPZKYGSZRZFYGQZJYGSZACDULYDUUPFHIYGYGYGYDYJYGLZYMYGLZUUNYGLZUMRUUMUUOY
      DUVIUVJUUMUVKYJAYMCDUNUOYJYMUUNACDUPURUSYDAUTVAZYGLUVLYJCNZYJPZUVCUVLPZKY
      GSZRZFYGQZUVHAUVLUVLVBZVCYDUVQFYGYDUVIRZUVNUVPYJACUVLUVSDVDKYJACUVLDUVSVE
      URVFUVGUVRJUVLYGUUTUVLPZUVFUVQFYGUWAUVIRZUVBUVNUVEUVPUWBUVAUVMYJUWAUVAUVM
      PUVIUUTUVLYJCVGVHVIUWBUVDUVOKYGUWBUUTUVLUVCUWAUVIVJVKVLVMVNVSVOYDUUKYGAVP
      VAZVQZUWCVRZYGPZUUGUULUUSUVHUMZVTAUWCUWCVBWAZUUKYGUWCWBZUUGUWEUWEUHZUWECU
      QZYNUWELZUUORZIUWEQZHUWEQZFUWEQZUVBUVDKUWESZRZFUWEQZJUWESZUMZUWFUWGCWTLUU
      GUXAVTCUWCWTDAVPWCWDFHIJWTKCUWECVRZUWECUWCDWEWFZWGWHUWFUWKUULUWPUUSUWTUVH
      UWFUWJUWEUUKYGCUWFUWEYGUWEYGUWFWJZUXDWIUXDWKUWOUURFUWEYGUWNUUQHUWEYGUWMUU
      PIUWEYGUWFUWLUUMUUOUWEYGYNWLWMTTTUWSUVGJUWEYGUWRUVFFUWEYGUWFUWQUVEUVBUVDK
      UWEYGWNWOTWPWQWRXAWSYDUUHFHYGYGYDUVIUVJUUHYJYMACDXBXCXDYDUWDUWFYFUUGUUJRZ
      VTUWHUWIUWFUXEUUGUUHHUWEQZFUWEQZRYFUWFUUJUXGUUGUUJUXGVTYGUWEUUIUXFFYGUWEU
      UHHYGUWEXETXFWOFHCUWEUXCXJXGXAXHABEXIYDUUEFYGUVTYKUUDYJABEXKUVTUUCGMUVTYL
      MLZRZYQUUBUXIYPHYGUXIUVJRYDUXHUVIUVJYPYDUVIUXHUVJXLUVTUXHUVJXSYDUVIUXHUVJ
      XMUXIUVJXNYLYJAYMBCEDXOXPVFUXIUUAHMUXIYMMLZRZYSYTUXKYDUXHUXJUVIYSYDUVIUXH
      UXJXLZUVTUXHUXJXSZUXIUXJXNZYDUVIUXHUXJXMZYLYMYJABCEDXQXPUXKYDUXHUXJUVIYTU
      XLUXMUXNUXOYLYMYJABEXRXPURVFURVFURVFYDUUKYGCVQUXBYGPYEYFYIUUFUMZVTZACDWAU
      UKYGCWBUXQYGUXBYGUXBPZUXPYFMUXBUHZUXBBUQZYKYPHUXBQZUUBRZGMQZRZFUXBQZUMYEU
      XRYIUXTUUFUYEYFUXRYHYGUXSUXBBYGUXBMXTUXRWJWKUUEUYDFYGUXBUXRUUDUYCYKUXRUUC
      UYBGMUXRYQUYAUUBYPHYGUXBXEWMYAWOTYBFGHBCUXBUXBVBYCXGXFXAWS @.
  @}

  @c /cv @. @( Division of complex vectors by a scalar. @)

  @( Extends class notation with scalar division of complex vectors. @)
  cdivcv @a class /cv @.

  @{
    @d n u s @.
    @( Division of a complex vector by a scalar in a space of dimension
       ` n ` .  Experimental.  (Contributed by FL, 29-May-2014.) @)
    df-divcv @a |- /cv = ( n e. NN |-> ( u e. ( CC ^m ( 1 ... n ) ) ,
        s e. ( CC \ { 0 } ) |-> ( ( 1 / s ) ( .cv ` n ) u ) ) ) @.
  @}

  @{
    @d n s u N @.  @d s u .t @.  @d s u S @.  @d s u U @.
    isdivcv2.1 @e |- /t = ( /cv ` N ) @.
    isdivcv2.2 @e |- .t = ( .cv ` N ) @.
    @( Division of complex vectors by a scalar in a space of dimension ` N ` .
       (Contributed by FL, 29-May-2014.) @)
    isdivcv2 @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) /\
     S e. ( CC \ { 0 } ) ) -> ( U /t S ) = ( ( 1 / S ) .t U ) ) @=
      ( vu vs vn wcel cc c1 cfz co cmap cfv cv wceq cvv cc0 csn cdif w3a cdivcv
      cn cdiv csmcv cmpt2 a1i oveqd simp1 ovex difexg ax-mp mpt2ex oveq2 oveq2d
      eqidd fveq2 mpt2eq123dv df-divcv fvmptg sylancl simp2 simp3 eqcomi adantl
      cnex wa simpl oveq123d eqid ovmpt2ga syl3anc 3eqtrd ) CUFKZBLMCNOZPOZKZAL
      UAUBZUCZKZUDZBAEOBACUEQZOBAHIVSWBMIRZUGOZHRZCUHQZOZUIZOZMAUGOZBDOZWDEWEBA
      EWESWDFUJUKWDWEWKBAWDVQWKTKWEWKSVQVTWCULHIVSWBWJLVRPUMLTKWBTKVILWATUNUOUP
      JCHILMJRZNOZPOZWBWGWHWOUHQZOZUIWKUFTUEWOCSZHIWQWBWSVSWBWJWTWPVRLPWOCMNUQU
      RWTWBUSWTWRWIWGWHWOCUHUTUKVAHJIVBVCVDUKWDVTWCWNTKZWLWNSVQVTWCVEVQVTWCVFXA
      WDWMBDUMUJHIBAVSWBWJWNWKTWHBSZWFASZVJZWGWMWHBWIDWIDSXDDWIGVGUJXCWGWMSXBWF
      AMUGUQVHXBXCVKVLWKVMVNVOVP @.
  @}

  @{
    divclcvd.1 @e |- /t = ( /cv ` N ) @.
    @( Closure law for vector division by a scalar.  (Contributed by FL,
       29-May-2014.) @)
    divclcvd @p |- ( ( N e. NN /\ U e. ( CC ^m ( 1 ... N ) ) /\
       S e. ( CC \ { 0 } ) )
       -> ( U /t S ) e. ( CC ^m ( 1 ... N ) ) ) @=
      ( cn wcel cc c1 cfz co cmap cc0 csn cdif w3a cdiv csmcv cfv eqid isdivcv2
      simp1 wne wa eldifsn reccl sylbi 3ad2ant3 simp2 clsmulcv syl3anc eqeltrd
      ) CFGZBHICJKLKZGZAHMNOGZPZBADKIAQKZBCRSZKZUNABCUSDEUSTZUAUQUMURHGZUOUTUNG
      UMUOUPUBUPUMVBUOUPAHGAMUCUDVBAHMUEAUFUGUHUMUOUPUIURBCUSVAUJUKUL @.

    @( Closure law for vector division by a scalar.  (Contributed by FL,
       29-May-2014.) @)
    divclrvd @p |- ( ( N e. NN /\ U e. ( RR ^m ( 1 ... N ) ) /\
       S e. ( RR \ { 0 } ) )
       -> ( U /t S ) e. ( RR ^m ( 1 ... N ) ) ) @=
      ( cn wcel cr c1 cfz co cmap cc0 cdif cc wf elmap 3imtr4i wa eldifsn csmcv
      csn w3a cdiv cfv wceq id wss ax-resscn fss reex ovex cnex wne recn anim1i
      mpan2 isdivcv2 syl3an simp1 rereccl sylbi 3ad2ant3 simp2 clsmulrv syl3anc
      eqid eqeltrd ) CFGZBHICJKZLKZGZAHMUBZNGZUCZBADKZIAUDKZBCUAUEZKZVKVIVIVLBO
      VJLKGZVNAOVMNGZVPVSUFVIUGVJHBPZVJOBPZVLVTWBHOUHWCUIVJHOBUJUQHVJBUKICJULZQ
      OVJBUMWDQRAHGZAMUNZSZAOGZWFSVNWAWEWHWFAUOUPAHMTZAOMTRABCVRDEVRVGZURUSVOVI
      VQHGZVLVSVKGVIVLVNUTVNVIWKVLVNWGWKWIAVAVBVCVIVLVNVDVQBCVRWJVEVFVH @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Intvl @.

  @( Extend class notation to include intervals. @)
  cintvl @a class Intvl @.

  @( The intervals of ` RR ` .  (Contributed by FL, 29-May-2014.) @)
  df-intvl @a |- Intvl =
    ( ( ran (,) u. ( ran (,] u. ( ran [,) u. ran [,] ) ) ) i^i ~P RR ) @.

  @( The set of intervals is a set.  (Contributed by FL, 29-May-2014.) @)
  intvlset @p |- Intvl e. _V @=
    ( cintvl cioo crn cioc cico cicc cun cpw cin cvv df-intvl reex pwex eqeltri
    cr inex2 ) ABCDCECFCGGGZOHZIJKRQOLMPN @.

  @( An interval is a part of ` RR ` .  (Contributed by FL, 29-May-2014.) @)
  intrr @p |- ( I e. Intvl -> I C_ RR ) @=
    ( cr wss cioo crn cioc cico cicc cun cpw cin cintvl wcel elpwi adantl sylbi
    wa elin df-intvl eleq2s ) ABCZADEFEGEHEIIIZBJZKZLAUDMAUBMZAUCMZQUAAUBUCRUFU
    AUEABNOPST @.

  @{
    @d x y z A @.  @d x y z B @.
    @( A closed-below, open-above interval is connected.  (Contributed by FL,
       30-May-2014.) @)
    icccon2 @p |- ( ( A e. RR /\ B e. RR* ) ->
     ( ( topGen ` ran (,) ) |`t ( A [,) B ) ) e. Con ) @=
      ( vx vy cr wcel cxr wa co cv cle wbr w3a clt rexr adantl wi adantr wb syl
      cioo crn ctg cfv cico crest ccon cicc wss 3ad2ant1 elico2 biimpd im2anan9
      wral simplrl simpll1 simpr1 simpll2 simpr2 letrd exp31 syl6 com23 pm2.43i
      vz anidms imp31 simplrr simpr3 simplr3 xrlelttrd ex icossre sseld anim12d
      3jca imp elicc2 anim1i elico1 3imtr4d ssrdv ralrimivva reconn mpbird ) AE
      FZBGFZHZUAUBUCUDABUEIZUFIUGFZCJZDJZUHIZWIUIZDWIUNCWIUNZWHWNCDWIWIWHWKWIFZ
      WLWIFZHZHZVEWMWIWSVEJZEFZWKWTKLZWTWLKLZMZWTGFZAWTKLZWTBNLZMZWTWMFZWTWIFZW
      SXDXHWSXDHXEXFXGXDXEWSXAXBXEXCWTOUJZPWHWRXDXFWHWRXDXFQZQZWHWHXMQWHWHHZWRW
      HXLXNWRWKEFZAWKKLZWKBNLZMZWLEFZAWLKLZWLBNLZMZHZWHXLQWHWPXRWHWQYBWHWPXRABW
      KUKULWHWQYBABWLUKULUMZYCWHXDXFYCWHHZXDHZAWKWTYCWFWGXDUOYEXOXDXOXPXQYBWHUP
      RYEXAXBXCUQYEXPXDXOXPXQYBWHURRYEXAXBXCUSUTVAVBVCVFVDVGWHWRXDXGWHWRXDXGQZQ
      ZWHWHYHQXNWRWHYGXNWRYCWHYGQYDYCWHXDXGYFWTWLBXDXEYEXKPYEWLGFZXDYCYIWHYBYIX
      RXSXTYIYAWLOUJPRRYCWFWGXDVHYEXAXBXCVIYEYAXDXSXTYAXRWHVJRVKVAVBVCVFVDVGVPV
      LWSXOXSHZXIXDSWHWRYJWHWPXOWQXSWHWIEWKABVMZVNWHWIEWLYKVNVOVQWKWLWTVRTWSAGF
      ZWGHZXJXHSWHYMWRWFYLWGAOVSRABWTVTTWAWBWCWHWIEUIWJWOSYKCDWIWDTWE @.
  @}

  @{
    @d x y z A @.  @d x y z B @.
    @( An open-below, closed-above interval is connected.  (Contributed by FL,
       30-May-2014.)  (Revised by Mario Carneiro, 4-Jul-2014.) @)
    icccon3 @p |- ( ( A e. RR* /\ B e. RR ) ->
     ( ( topGen ` ran (,) ) |`t ( A (,] B ) ) e. Con ) @=
      ( vx vy vz wcel cr wa co cv wss clt wbr cle wb elioc2 adantr mpbid simp1d
      w3a cxr cioo crn ctg cfv cioc crest ccon cicc wral simprr simprll simprlr
      elicc2 syl2anc simpll rexrd simp2d xrltletrd simplr simp3d mpbir3and expr
      letrd ssrdv ralrimivva iocssre reconn syl mpbird ) AUAFZBGFZHZUBUCUDUEABU
      FIZUGIUHFZCJZDJZUIIZVNKZDVNUJCVNUJZVMVSCDVNVNVMVPVNFZVQVNFZHZHEVRVNVMWCEJ
      ZVRFZWDVNFZVMWCWEHZHZWFWDGFZAWDLMZWDBNMZWHWIVPWDNMZWDVQNMZWHWEWIWLWMTZVMW
      CWEUKWHVPGFZVQGFZWEWNOWHWOAVPLMZVPBNMZWHWAWOWQWRTZVMWAWBWEULVMWAWSOWGABVP
      PQRZSZWHWPAVQLMZVQBNMZWHWBWPXBXCTZVMWAWBWEUMVMWBXDOWGABVQPQRZSZVPVQWDUNUO
      RZSZWHAVPWDVKVLWGUPWHVPXAUQWHWDXHUQWHWOWQWRWTURWHWIWLWMXGURUSWHWDVQBXHXFV
      KVLWGUTWHWIWLWMXGVAWHWPXBXCXEVAVDVMWFWIWJWKTOWGABWDPQVBVCVEVFVMVNGKVOVTOA
      BVGCDVNVHVIVJ @.
  @}

  @{
    @d x y z A @.  @d x y z B @.
    @( An open interval is connected.  (Contributed by FL, 30-May-2014.) @)
    icccon4 @p |- ( ( A e. RR* /\ B e. RR* ) ->
     ( ( topGen ` ran (,) ) |`t ( A (,) B ) ) e. Con ) @=
      ( vx vy vz cxr wcel wa cioo co cv wss wral cr wbr w3a clt rexr 3ad2ant1
      wb crn ctg cfv crest ccon cicc cle wi elioo2 biimpd anim12d simp2l adantr
      simp1l2 simp32 xrltletrd adantl simp2r simp33 simp1r3 xrlelttrd 3jca 3exp
      3ad2ant3 syl6 pm2.43a imp elioore anim12i elicc2 syl elioo1 3imtr4d ssrdv
      ralrimivva ioossre reconn mp1i mpbird ) AFGZBFGZHZIUAUBUCABIJZUDJUEGZCKZD
      KZUFJZWCLZDWCMCWCMZWBWHCDWCWCWBWEWCGZWFWCGZHZHZEWGWCWMEKZNGZWEWNUGOZWNWFU
      GOZPZWNFGZAWNQOZWNBQOZPZWNWGGZWNWCGZWBWLWRXBUHZWLWBXEWBWLWENGZAWEQOZWEBQO
      ZPZWFNGZAWFQOZWFBQOZPZHZWBXEUHWBWJXIWKXMWBWJXIABWEUIUJWBWKXMABWFUIUJUKXNW
      BWRXBXNWBWRPZWSWTXAWRXNWSWBWOWPWSWQWNRSVDZXOAWEWNXNVTWAWRULXNWBWEFGZWRXIX
      QXMXFXGXQXHWERSUMSXPXFXGXHXMWBWRUNXNWBWOWPWQUOUPXOWNWFBXPXNWBWFFGZWRXMXRX
      IXJXKXRXLWFRSUQSXNVTWAWRURXNWBWOWPWQUSXJXKXLXIWBWRUTVAVBVCVEVFVGWMXFXJHZX
      CWRTWLXSWBWJXFWKXJWEABVHWFABVHVIUQWEWFWNVJVKWBXDXBTWLABWNVLUMVMVNVOWCNLWD
      WITWBABVPCDWCVQVRVS @.
  @}

  @{
    @d x y I @.
    @( All the intervals of ` RR ` are connected.  (Contributed by FL,
       29-May-2014.) @)
    intvconlem1 @p |- ( I e. Intvl ->
      ( ( topGen ` ran (,) ) |`t I ) e. Con ) @=
      ( vx vy crest co ccon wcel cr wa wi wceq wrex oveq2 eleq1d sylbi ex com3l
      cxr syl c0 cioo crn ctg cfv cioc cico cicc cun cpw cintvl elin wo elun cv
      cin bsi icccon4 a1d eleq1 imbi12d syl5ibrcom rexlimivv bsi4 wss ovex elpw
      clt wbr w3a ubioc1 ssel2 icccon3 adantr syl5com 3expia pm2.43a wn xrlenlt
      cle wb ancoms ioc0 ctop retop csn rest0 singempcon syl6eqel ax-mp syl5ibr
      a1i syl6bir sylbird pm2.61i com12 bsi3 lbico1 icccon2 adantld ico0 ubicc2
      bsi2 icc0 lbicc2 iccconn com3r a1dd sylc jaoi imp df-intvl eleq2s ) UAUBZ
      UCUDZADEZFGZAXMUEUBZUFUBZUGUBZUHZUHZUHZHUIZUOZUJAYDGAYBGZAYCGZIXPAYBYCUKY
      EYFXPYEAXMGZAYAGZULYFXPJZAXMYAUMYGYIYHYGABUNZCUNZUAEZKZCRLBRLYIBCAUPYMYIB
      CRRYJRGZYKRGZIZYIYMYLYCGZXNYLDEZFGZJYPYSYQYJYKUQURYMYFYQXPYSAYLYCUSYMXOYR
      FAYLXNDMNUTVAVBOYHAXQGZAXTGZULYIAXQXTUMYTYIUUAYTAYJYKUEEZKZCRLBRLYIBCAVCU
      UCYIBCRRYPYIUUCUUBYCGZXNUUBDEZFGZJUUDYPUUFUUDUUBHVDZYPUUFJZUUBHYJYKUEVEVF
      YJYKVGVHZUUGUUHJYPUUIUUGUUFUUIYPUUGUUFJZYNYOUUIYPUUJJZYNYOUUIVIZYKUUBGZUU
      KYJYKVJUUGUUMYPUUFUUGUUMUUHUUGUUMIYKHGZYPUUFUUBHYKVKYNUUNUUFJYOYNUUNUUFYJ
      YKVLPVMVNPQSVOVPQYPUUIVQZUUGUUFYPUUOYKYJVSVHZUUJYOYNUUPUUOVTYKYJVRWAZYPUU
      PUUBTKZUUJYJYKWBUUGUUFUURXNTDEZFGZUUTUUGXNWCGZUUTWDUVAUUSTWEFXNWFWGWHWIZW
      KUURUUEUUSFUUBTXNDMNWJWLWMQWNOWOUUCYFUUDXPUUFAUUBYCUSUUCXOUUEFAUUBXNDMNUT
      VAVBOUUAAXRGZAXSGZULYIAXRXSUMUVCYIUVDUVCAYJYKUFEZKZCRLBRLYIBCAWPUVFYIBCRR
      YPYIUVFUVEYCGZXNUVEDEZFGZJUVGYPUVIUVGUVEHVDZYPUVIJZUVEHYJYKUFVEVFUUIUVJUV
      KJYPUUIUVJUVIUUIYPUVJUVIJZYNYOUUIYPUVLJZUULYJUVEGZUVMYJYKWQUVJUVNYPUVIUVJ
      UVNUVKUVJUVNIYJHGZUVKUVEHYJVKUVOYOUVIYNUVOYOUVIYJYKWRPWSSPQSVOVPQYPUUOUVJ
      UVIYPUUOUUPUVLUUQYPUUPUVETKZUVLYJYKWTUVPUVIUVJUVPUVHUUSFUVETXNDMUVBWHURWL
      WMQWNOWOUVFYFUVGXPUVIAUVEYCUSUVFXOUVHFAUVEXNDMNUTVAVBOUVDAYJYKUGEZKZCRLBR
      LYIBCAXBUVRYIBCRRYPYIUVRUVQYCGZXNUVQDEZFGZJUVSYPUWAUVSUVQHVDZYPUWAJZUVQHY
      JYKUGVEVFYKYJVGVHZUWBUWCJYPUWDUWBUWAYPUWDUVQTKZUWBUWAJZYJYKXCUWEUWAUWBUWE
      UVTUUSFUVQTXNDMUVBWHURWLQYPUWDVQZUWBUWAYPUWGYJYKVSVHZUWFYJYKVRUWHYPUWFYNY
      OUWHYPUWFJZYNYOUWHVIYKUVQGZYJUVQGZUWIYJYKXAYJYKXDUWJUWKUWFYPUWBUWJUWKUWAU
      WJUWBUWKUWAJZUWBUWJUWBUWLJZUWBUWJIUUNUWMUVQHYKVKUWBUWKUUNUWAUWBUWKUUNUWAJ
      ZUWBUWKIUVOUWNUVQHYJVKUVOUUNUWAYJYKXEPSPXFSPVPQXGXHVOVPWMQWNOWOUVRYFUVSXP
      UWAAUVQYCUSUVRXOUVTFAUVQXNDMNUTVAVBOXIOXIOXIOXJOXKXL @.

  @}

  @( Declare the derivative of a function. @)
  @c der @.

  @( Extend class notation to include the derivative of a function. @)
  cder @a class der @.

  @{
    @d n i f p x @.
    @( Derivative of a function ` f ` at ` p ` .  Meaningful when the domain of
       ` f ` is an interval of ` RR ` , ` p ` belongs to the domain of ` f ` ,
       the domain of ` f ` is not ` { p } ` and the values of ` f ` are in
       ` ( RR ^m ( 1 ... n ) ) ` .

       Bourbaki doesn't explain why he requires the domain of ` f ` be an
       interval.  Here are some hints.  The domain of ` f ` is an interval,
       ` p ` belongs to the domain of ` f ` and ` dom f = { p } ` guarantee
       ` p ` is not an isolated point in ` dom f ` ( ~ df-islpt ).  We have
       ` ( v i^i ( dom f \ { p } ) ) = ( ( v i^i dom f ) \ { p } ) `
       ( ~ indif2 ) but ` ( v i^i dom f ) =/= { p } ` since ` p ` is not an
       isolated point in ` dom f ` and ` ( v i^i ( dom f \ { p } ) ) =/= (/) `
       what is the condition required by ~ trfil2 .  And in this case the class
       ` { u | E. v e. ( ( nei `` ( topGen `` ran (,) ) ) `` { p } ) u `
       ` = ( v i^i ( dom f \ { p } ) ) } ` is a filter.  This latter condition
       is required by ~ df-flimfrs and this definition is used by ~ df-der .

       This sort of derivative might be extended easily to work with functions
       ` f ` whose domain is a field ` A ` and whose values are in a
       topological vector space whose scalars are in ` A ` .  The topologies
       would be changed accordingly.  The domain of ` f ` would be a
       neighborhood of ` p ` .  Experimental.  (Contributed by FL,
       29-May-2014.) @)
    df-der @a |- der = ( n e. NN , i e. Intvl |-> (
      f e. ( ( RR ^m ( 1 ... n ) ) ^m i ) , p e. i |->
      ( ( ( ( topX ` ( x e. ( 1 ... n ) |-> ( topGen ` ran (,) ) ) )
      fLimfrs ( topGen ` ran (,) ) ) ` ( i \ { p } ) ) ` <. p ,
        ( x e. ( i \ { p } ) |-> ( ( ( f ` x ) ( -cv ` n ) ( f ` p ) )
            ( /cv ` n ) ( x - p ) ) ) >. ) ) ) @.
  @}

  @( Hard to describe.  A picture can help.  (Contributed by FL,
     29-May-2014.) @)
  hdrmp @p |- ( ( ( A i^i B ) =/= (/) /\ ( C =/= (/) /\ D =/= (/) ) /\
   ( A u. B ) = ( C u. D ) )
      -> ( ( ( A i^i C ) =/= (/) /\ ( A i^i D ) =/= (/) ) \/
         ( ( B i^i C ) =/= (/) /\ ( B i^i D ) =/= (/) ) ) ) @=
    ( cin c0 wceq wne wa cun wi eqtr expcom adantr syl ex eqcoms com3l 3imp wss
    w3a uneq12 un0 indi uncom ineq2i ineq2 inabs neiopne nonconne pm2.21i com12
    wo a1i syl5com mpsyl com24 sylancr sylancl ineq1 incom indir uneq1 pm13.181
    wn mp2an imp 3adant1 impcom eqss unss disjssun inss1 sstr inidm ssrin sseq1
    wb bi1 sseq2 ss0 syl6bi ax-mp necon3d a1dd mpan syl6 3impd 3exp sylbi inass
    sylbir in0 syl6eq syl5eq necon3i jca olcd pm2.61i com23 syl6com syl5 inabs2
    adantl com4l df-ne orc pm2.61ine ) ACEZFGZABEZFHZCFHZDFHZIZABJZCDJZGZUAZXIF
    HZADEZFHZIZBCEZFHZBDEZFHZIZUMZKZYAFGZXJYJKYKXJYJYKXJIYAXIJZFFJZGZYMFGZYJYAF
    XIFUBFUCYNYOIADCJZEZYLGZYLFGZYJADCUDYLYMFLYRYSIAXQEZYQGZYQFGZYJXQYPACDUEZUF
    YQYLFLUUAUUBIYTFGZXSYIYTYQFLXLXOXRUUDYIKZXRXLXOUUEXRAXPEZYTGZXLXOUUEKKXPXQA
    UGUUGUUDXOXLYIUUGUUDXOXLYIKZKZUUFAGUUGUUDIUUFFGZUUIABUHUUFYTFLUUJUUIKAUUFAU
    UFGZUUJUUIUUKUUJIAFGZXOUUHAUUFFLUULUUHKXOXLUULYIXLAFHZBFHZIUULYIKZABUIUUMUU
    OUUNUULUUMYIUULUUMIYIAFUJUKMNOULUNUOPQUPPUQORSUOURURUSPYKVEZXJXSYIUUPXJXSUA
    ZYHYCUUQYEYGXJXSYEUUPXSXJYEXOXRXJYEKZXLXOXRUURXMXRUURKXNXRXMUURXRXPCEZXQCEZ
    GZXMUURKZXPXQCUTUUTCXQEZGZUVCCGZUVAUVBKZXQCVACDUHUVDUVEIUUTCGZUVFUUTUVCCLUV
    AUVGUVBUUSXIYDJZGUVAUVGIUUSCGZUVBABCVBUUSUUTCLUVIUVBKUVHUUSUVHUUSGZUVIUVBUV
    JUVIIUVHCGZUVBUVHUUSCLXJUVKXMYEXJUVHFYDJZGZUVKXMYEKZKZXIFYDVCUVLYDFJZGZUVPY
    DGZUVMUVOKZFYDUEYDUCUVQUVRIUVLYDGZUVSUVLUVPYDLUVMUVTUVOUVMUVTIUVHYDGUVOUVHU
    VLYDLUVOYDUVHYDUVHGZUVKUVNUWAUVKIYDCGZUVNYDUVHCLUWBXMYEYDCFVDPOPQOMOVFOROPQ
    UPMOVFOULNVGVHVIVHUUQXKDEZFHZYGUUPXJXSUWDXSUUPXJUWDXLXOXRUUPXJUWDKKZXRXLXOU
    WEXRXPXQTZXQXPTZIZXLXOUWEKKZXPXQVJZUWFUWIUWGUWFAXQTZBXQTZIZUWIABXQVKZUWKUWI
    UWLUWKXLXOUWEXJUWKXLXOUAZUUPUWDXJUWKADTZVRZUWOUUPUWDKZKACDVLUWQUWKXLXOUWRUW
    QUWKUWPXLXOUWRKKZUWKUWPVSXKATZUWPUWSABVMZUWTUWPIXKDTZUWSXKADVNUXBXLUWRXOUXB
    XLUWDUUPUXBUWCFXKFXKXKEZXKGZUXBUXCDXKEZTZUWCFGZXKFGZKZXKVOZXKDXKVPUXDUXFXKU
    XETZUXIUXCXKUXEVQUWCUXEGUXKUXIKZXKDVAUXLUXEUWCUXEUWCGUXKXKUWCTZUXIUXEUWCXKV
    TUXGUXMUXHUXGUXMXKFTZUXHUWCFXKVTXKWAZWBULWBQWCWBUPWDWEWEOWFWGWHORWINWLNWJRS
    RSYFFUWCFYFFGZUWCAYFEZFABDWKUXPUXQAFEZFYFFAUGAWMZWNWOWPOWQWRWIWSXJVEZYJKYAF
    YKUXTXSYIYKUXTXSUAZYHYCUYAYEYGUYAXKCEZFHZYEYKUXTXSUYCXSYKUXTUYCXLXOXRYKUXTU
    YCKZKZXRXLXOUYEXRUWHXLXOUYEKKZUWJUWFUYFUWGUWFUWMUYFUWNUWKUYFUWLUWKXLXOUYEYK
    AYPTZACTZVRZUWOUYDADCVLUWKXLXOUYIUYDKZXQYPGZUWKXLXOUYJKKZKUUCUYKUWKUYGUYLXQ
    YPAVTUYGUYIXOXLUYDUYIUYGUYHXOXLUYDKZKZUYGUYHVSUWTUYHUYNUXAUWTUYHIXKCTZXOUYM
    XKACVNUYOUYMKXOUYOXLUYCUXTUYOUYBFXKFUXDUYOUXCCXKEZTZUYBFGZUXHKZUXJXKCXKVPUX
    DUYQXKUYPTZUYSUXCXKUYPVQUYPUYBGZUYTUYSKCXKVAVUAUYRUYTUXHVUAUYRUYTUXHKZVUAUY
    RIUYPFGZVUBUYPUYBFLVUCUYTUXNUXHUYPFXKVTUXOWBOPWTWCWBUPWDWEUNUOWFXAUQWBWCSXB
    WINWLNWJRSRSYDFUYBFYDFGZUYBAYDEZFABCWKVUDVUEUXRFYDFAUGUXSWNWOWPOYKUXTXSYGXS
    YKUXTYGXLXOXRYKUXTYGKZKZXRXLXOVUGXPDEZYAYFJZGXRVUHXQDEZGZXLXOVUGKKZABDVBXPX
    QDUTVUKVULKVUIVUHVUIVUHGZVUKVULVUMVUKIVUIVUJGZVULVUIVUHVUJLYKVUNXLXOVUFYKVU
    IFYFJZGZVUNXLXOVUFKZKZKZYAFYFVCVUOYFFJZGZVUTYFGZVUPVUSKZFYFUEYFUCVVAVVBIVUO
    YFGZVVCVUOVUTYFLVUPVVDVUSVUPVVDIVUIYFGVUSVUIVUOYFLVUSYFVUIYFVUIGZVUNVURVVEV
    UNIYFVUJGZVURYFVUIVUJLVUJDXQEZGZVVGDGZVVFVURKZXQDVACDXCVVHVVIIVUJDGZVVJVUJV
    VGDLVVFVVKVURVVFVVKIYFDGZXLVUQYFVUJDLVVLVUQKXLXOVVLVUFXNVVLVUFKXMXNVVLYGUXT
    VVLXNYGYFDFVDMWEXDULUNUOMOVFOPQOMOVFOXEOPQUPRSRSWQWRWIUXTYBYJUXTXTYBYJKXIFX
    FXTYBYIXSXTYBYIYCYHXGPWEWLULXHWS @.

  @{
    @{
      @d f i n p x I @.  @d f p x F @.  @d f i n p x N @.  @d f p x P @.
      isder.1 @e |- J =
        ( topX ` ( x e. ( 1 ... N ) |-> ( topGen ` ran (,) ) ) ) @.
      isder.2 @e |- K = ( topGen ` ran (,) ) @.
      isder.4 @e |- S = ( x e. ( I \ { P } )
        |-> ( ( ( F ` x ) ( -cv ` N ) ( F ` P ) ) ( /cv ` N ) ( x - P ) ) ) @.
      isder.5 @e |- D = ( N der I ) @.
      @( The derivative of ` F ` at point ` P ` is the limit of the slope
         ` F ( x ) - F ( P ) / x - P ` when ` x ` tends to ` P ` .  Definition
         1 of [BourbakiFVR] p.  I.11.  (Contributed by FL, 29-May-2014.) @)
      isder @p |- ( ( ( N e. NN /\ I e. Intvl /\ P e. I ) /\ ( I =/= { P } /\
        F : I --> ( RR ^m ( 1 ... N ) ) ) ) -> ( F D P ) =
        ( ( ( J fLimfrs K ) ` ( I \ { P } ) ) ` <. P , S >. ) ) @=
        ( vf wcel co cmap cfv cvv wceq vp vn vi cn cintvl w3a csn wne cr c1 cfz
        wf wa cder cop cdif cflimfrs oveqi cmcv cmin cdivcv cmpt cioo crn ctopx
        cv cmpt2 simpl1 simpl2 ovex mpt2exga sylancr simpl oveq2d simpr oveq12d
        ctg mpteq1 fveq2d oveq1d difeq1d fveq12d oveqd eqidd oveq123d mpteq12dv
        syl opeq2d mpt2eq123dv df-der ovmpt2ga wi wb simpr2 elmapg exbiri com23
        syl3anc imp impcom simpl3 fvex a1i adantl difeq2d fveq1d opeq12d eqcomi
        sneq eqid 3eqtrd syl5eq ) IUDOZFUEOZCFOZUFZFCUGZUHZFUIUJIUKPZQPZEULZUMZ
        UMZECBPECIFUNPZPZCDUOZFXQUPZGHUQPZRZRZBYDECMURYCYEECNUAXTFQPZFUAVFZAFYL
        UGZUPZAVFZNVFZRZYLYPRZIUSRZPZYOYLUTPZIVARZPZVBZUOZYNAXSVCVDVQRZVBZVERZU
        UFUQPZRZRZVGZPZCAYGYOERZCERZYSPZYOCUTPZUUBPZVBZUOZYGUUIRZRZYJYCYDUULECY
        CXMXNUULSOZYDUULTXMXNXOYBVHXMXNXOYBVIZYCYKSOXNUVCXTFQVJUVDNUAYKFUUKSUEV
        KVLUBUCIFUDUENUAUIUJUBVFZUKPZQPZUCVFZQPZUVHYLAUVHYMUPZYQYRUVEUSRZPZUUAU
        VEVARZPZVBZUOZUVJAUVFUUFVBZVERZUUFUQPZRZRZVGUULUNSUVEITZUVHFTZUMZNUAUVI
        UVHUWAYKFUUKUWDUVGXTUVHFQUWDUVFXSUIQUWDUVEIUJUKUWBUWCVMZVNZVNUWBUWCVOZV
        PUWGUWDUVPUUEUVTUUJUWDUVJYNUVSUUIUWDUVRUUHUUFUQUWDUVQUUGVEUWDUVFXSTUVQU
        UGTUWFAUVFXSUUFVRWGVSVTUWDUVHFYMUWGWAZWBUWDUVOUUDYLUWDAUVJUVNYNUUCUWHUW
        DUVLYTUUAUUAUVMUUBUWDUVEIVAUWEVSUWDUVKYSYQYRUWDUVEIUSUWEVSWCUWDUUAWDWEW
        FWHWBWIANUCUBUAWJWKWRWCYCEYKOZXOUVBSOZUUMUVBTYBXPUWIXRYAXPUWIWLXRXPYAUW
        IXRXPUWIYAXRXPUMXTSOXNUWIYAWMUIXSQVJXRXMXNXOWNXTFESUEWOVLWPWQWSWTXMXNXO
        YBXAUWJYCUUTUVAXBXCNUAECYKFUUKUVBUULSYPETZYLCTZUMZUUEUUTUUJUVAUWMYNYGUU
        IUWMYMXQFUWLYMXQTUWKYLCXIXDXEZVSUWMYLCUUDUUSUWKUWLVOZUWMAYNUUCYGUURUWNU
        WMYTUUPUUAUUQUUBUWMYQUUNYRUUOYSUWMYOYPEUWKUWLVMZXFUWMYLCYPEUWPUWOWBVPUW
        MYLCYOUTUWOVNVPWFXGWBUULXJWKWRYCUUTYFUVAYIYCYGUUIYHYCUUHGUUFHUQUUHGTYCG
        UUHJXHXCUUFHTYCHUUFKXHXCVPXFYCUUSDCUUSDTYCDUUSLXHXCWHWBXKXL @.
    @}

  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Directed multi graphs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Dgra @. @( The class of all directed multi graphs. @)

  @( Extend class notation with the class of directed multi graphs. @)
  cmgra @a class Dgra @.

  @{
    @d d c u @.
    @( Definition of a directed multi graph.  Loops are allowed and there may
       be more than one edge between the same pair of vertices.  Isolated
       points are allowed.  (Contributed by FL, 10-Jan-2008.) @)
    df-mgra @a |- Dgra = { <. <. d , c >. , u >. |
      ( d : dom d --> u /\ c : dom d --> u ) } @.
  @}

  @{
    @d C c d u @.  @d D c d u @.  @d U c d u @.
    @( The predicate "is a directed multi graph".  (Contributed by FL,
       10-Jan-2008.) @)
    ismgra @p |- ( ( D e. A /\ C e. B /\ U e. F ) ->
    ( <. <. D , C >. , U >. e. Dgra <->
    ( D : dom D --> U /\ C : dom D --> U ) ) ) @=
      ( vd vu vc cop cmgra wcel cv cdm wf wa wceq feq1 feq2d anbi12d coprab w3a
      df-mgra eleq2i dmeq bitrd anbi2d feq3 eloprabg syl5bb ) DCJEJZKLUKGMZNZHM
      ZULOZUMUNIMZOZPZGIHUAZLDALCBLEFLUBDNZEDOZUTECOZPZKUSUKHIGUCUDURUTUNDOZUTU
      NUPOZPVDUTUNCOZPVCGIHDCEABFULDQZUOVDUQVEVGUOUMUNDOVDUMUNULDRVGUMUTUNDULDU
      EZSUFVGUMUTUNUPVHSTUPCQVEVFVDUTUNUPCRUGUNEQVDVAVFVBUNEUTDUHUNEUTCUHTUIUJ
      @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Category and deductive system underlying "structure"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Alg @. @( The class of all the "structures" used by ` Ded `
               and ` CatOLD ` . @)

  @c dom_ @. @( Function returning the function domain of a category. Despite
  its name the domain of a category is not the same concept as the domain of
  a relation. @)

  @c cod_ @. @( Function returning the function codomain of a category. @)

  @c id_ @. @( Function returning the function identity of a category. @)

  @c o_ @. @( Function returning the composition of morphisms of a category. @)

  @( Extend class notation with the class of structures used by ` CatOLD ` and
     ` Ded ` . @)
  calg @a class Alg @.

  @( Extend class notation with the function returning the function domain of a
     category. @)
  cdom_ @a class dom_ @.

  @( Extend class notation with the function returning the function codomain of
     a category. @)
  ccod_ @a class cod_ @.

  @( Extend class notation with the function returning the function identity of
     a category. @)
  cid_ @a class id_ @.

  @( Extend class notation with the function returning the composition of
     morphisms of a category. @)
  co_ @a class o_ @.

  @{
    @d x d c j r @.
    @( ` Ded ` and ` CatOLD ` structure.  Metamath for internal reasons doesn't
       like too large definitions.  Then ` CatOLD ` has been split giving birth
       to ` Ded ` and ` Alg ` .  If ` Ded ` has a real mathematical use,
       ` Alg ` is only here to give relief to Metamath.  (Contributed by FL,
       24-Oct-2007.) @)
    df-alg @a |- Alg = { x | E. d E. c E. j E. r
      ( x = <. <. d , c >. , <. j , r >. >. /\
      ( d : dom d --> dom j /\ c : dom d --> dom j /\ j : dom j --> dom d ) /\
      ( Fun r /\ dom r C_ ( dom d X. dom d ) /\ ran r C_ dom d ) ) } @.
  @}

  @( Definition of ` dom_ ` .  (Contributed by FL, 24-Oct-2007.) @)
  df-dom_ @a |- dom_ = ( 1st o. 1st ) @.

  @( Definition of ` cod_ ` .  (Contributed by FL, 26-Oct-2007.) @)
  df-cod_ @a |- cod_ = ( 2nd o. 1st ) @.

  @( Definition of ` id_ ` .  (Contributed by FL, 26-Oct-2007.) @)
  df-id_ @a |- id_ = ( 1st o. 2nd ) @.

  @( Definition of ` o_ ` .  (Contributed by FL, 26-Oct-2007.) @)
  df-cmpa @a |- o_ = ( 2nd o. 2nd ) @.

  @{
    @d C c d j r @.  @d D c d j r @.  @d J c d j r @.  @d M c d j r @.
    @d O c d j r @.  @d R c d j r @.  @d c d j r x @.
    isalg.1 @e |- M = dom D @.
    isalg.2 @e |- O = dom J @.
    @( The predicate "has the structure required by ` Ded ` and ` CatOLD ` ."
       (Contributed by FL, 24-Oct-2007.) @)
    isalg @p |- ( ( ( D e. A /\ C e. B /\ J e. F ) /\ R e. G )
                -> ( <. <. D , C >. , <. J , R >. >. e. Alg
                  <-> ( ( D : M --> O /\ C : M --> O /\ J : O --> M )
                    /\ ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) ) ) @=
      ( vx vd wcel wceq wf w3a wex wa vc vj vr cop calg cv cdm wfun cxp wss crn
      cab df-alg eleq2i 3anass exbii 3exbii abbii feq1 dmeq syl6eqr feq2d bitrd
      wb feq3 syl 3anbi123d xpeq12d sseq2d 3anbi23d anbi12d anbi1d funeq sseq1d
      3anbi2d rneq anbi2d elo syl5bb ) DCUDHEUDUDZUEOVTMUFNUFZUAUFZUDUBUFZUCUFZ
      UDUDPZWAUGZWCUGZWAQZWFWGWBQZWGWFWCQZRZWDUHZWDUGZWFWFUIZUJZWDUKZWFUJZRZRZU
      CSZUBSUASNSZMULZOZDAOCBOHFOREGOTZIJDQZIJCQZJIHQZRZEUHZEUGZIIUIZUJZEUKZIUJ
      ZRZTZUEXBVTMUBUCUANUMUNXCVTWEWKWRTZTZUCSZUBSUASNSZMULZOXDXPXBYAVTXAXTMWTX
      SNUAUBWSXRUCWEWKWRUOUPUQURUNXQIWGDQZIWGWBQZWGIWCQZRZWLWMXKUJZWPIUJZRZTYBI
      WGCQZYDRZYHTXHYHTXPMNUAUCUBDCHEABFGWADPZWKYEWRYHYKWHYBWIYCWJYDYKWHWFWGDQY
      BWFWGWADUSYKWFIWGDYKWFDUGIWADUTKVAZVBVCYKWFIWGWBYLVBYKWFIPWJYDVDYLWFIWGWC
      VEVFVGYKWOYFWQYGWLYKWNXKWMYKWFIWFIYLYLVHVIYKWFIWPYLVIVJVKWBCPZYEYJYHYMYCY
      IYBYDIWGWBCUSVOVLWCHPZYJXHYHYNYBXEYIXFYDXGYNWGJPZYBXEVDYNWGHUGJWCHUTLVAZW
      GJIDVEVFYNYOYIXFVDYPWGJICVEVFYNYDWGIHQXGWGIWCHUSYNWGJIHYPVBVCVGVLWDEPZYHX
      OXHYQWLXIYFXLYGXNWDEVMYQWMXJXKWDEUTVNYQWPXMIWDEVPVNVGVQVRVSVS @.
  @}

  @{
    1alg.1 @e |- A e. _V @.
    @( CatOLDegory ` 1 ` has the structure required by ` Ded ` and
       ` CatOLD ` .  (Contributed by FL, 30-Oct-2007.) @)
    1alg @p |- <. <. { <. <. A , A >. , A >. } , { <. <. A , A >. , A >. } >. ,
      <. { <. A , <. A , A >. >. } , { <. <. <. A , A >. , <. A , A >. >. ,
      <. A , A >. >. } >. >. e. Alg @=
      ( cop csn calg wcel w3a cdm wss wf1o opex f1osn f1of ax-mp 3pm3.2i dmsnop
      wf cvv snex eqcomi cxp crn funsn fssxp eqsstri rnsnop eqimssi wa wb isalg
      wfun mp2an mpbir2an ) AACZACZDZUPCAUNCZDZUNUNCZUNCZDZCCEFZUNDZADZUPQZVEVD
      VCURQZGZVAUKZVAHZVCVCUAZIZVAUBZVCIZGZVEVEVFVCVDUPJVEUNAAAKZBLVCVDUPMNZVPV
      DVCURJVFAUNBVOLVDVCURMNOVHVKVMUSUNUNUNKZVOUCVIUSDZVJUSUNVOPVCVCVRQZVRVJIV
      CVCVRJVSUNUNVOVOLVCVCVRMNVCVCVRUDNUEVLVCUSUNVQUFUGOUPRFZVTURRFZGVARFVBVGV
      NUHUIVTVTWAUOSZWBUQSOUTSRRUPUPVARRURVCVDUPHVCUNABPTURHVDAUNVOPTUJULUM @.
  @}

  @{
    domval.1 @e |- D = ( dom_ ` T ) @.
    @( Value of the domain function expressed with the ` 1st ` function.
       (Contributed by FL, 24-Oct-2007.) @)
    domval @p |- D = ( 1st ` ( 1st ` T ) ) @=
      ( cdom_ cfv c1st cvv wcel wceq ccom df-dom_ fveq1i wf wfo fo1st fof ax-mp
      fvco3 c0 fvprc mpan syl5eq wn fveq2d 1st0 syl6req eqtrd pm2.61i eqtri ) A
      BDEZBFEZFEZCBGHZUJULIUMUJBFFJZEZULBDUNKLGGFMZUMUOULIGGFNUPOGGFPQGGBFFRUAU
      BUMUCZUJSULBDTUQULSFESUQUKSFBFTUDUEUFUGUHUI @.
  @}

  @{
    codval.1 @e |- C = ( cod_ ` T ) @.
    @( Value of the function codomain expressed with the ` 1st ` and ` 2nd `
       functions.  (Contributed by FL, 26-Oct-2007.) @)
    codval @p |- C = ( 2nd ` ( 1st ` T ) ) @=
      ( ccod_ cfv c1st c2nd cvv wcel wceq df-cod_ fveq1i wf wfo fo1st fof ax-mp
      ccom c0 fvprc fvco3 mpan syl5eq fveq2d 2nd0 syl6req eqtrd pm2.61i eqtri
      wn ) ABDEZBFEZGEZCBHIZUKUMJUNUKBGFRZEZUMBDUOKLHHFMZUNUPUMJHHFNUQOHHFPQHHB
      GFUAUBUCUNUJZUKSUMBDTURUMSGESURULSGBFTUDUEUFUGUHUI @.
  @}

  @{
    idval.1 @e |- J = ( id_ ` T ) @.
    @( Value of the identity function expressed with the ` 1st ` and ` 2nd `
       functions.  (Contributed by FL, 26-Oct-2007.) @)
    idval @p |- J = ( 1st ` ( 2nd ` T ) ) @=
      ( cid_ cfv c2nd c1st cvv wcel wceq ccom df-id_ fveq1i wfo fo2nd fof ax-mp
      wf c0 fvprc fvco3 mpan syl5eq wn fveq2d 1st0 syl6req eqtrd pm2.61i eqtri
      ) BADEZAFEZGEZCAHIZUKUMJUNUKAGFKZEZUMADUOLMHHFRZUNUPUMJHHFNUQOHHFPQHHAGFU
      AUBUCUNUDZUKSUMADTURUMSGESURULSGAFTUEUFUGUHUIUJ @.
  @}

  @{
    cmpval.1 @e |- G = ( o_ ` T ) @.
    @( Value of the identity function expressed with the ` 2nd ` functions.
       (Contributed by FL, 26-Oct-2007.) @)
    cmpval @p |- G = ( 2nd ` ( 2nd ` T ) ) @=
      ( co_ cfv c2nd cvv wcel wceq ccom df-cmpa fveq1i wf wfo fo2nd ax-mp fvco3
      fof c0 fvprc mpan syl5eq wn fveq2d 2nd0 syl6req eqtrd pm2.61i eqtri ) BAD
      EZAFEZFEZCAGHZUJULIUMUJAFFJZEZULADUNKLGGFMZUMUOULIGGFNUPOGGFRPGGAFFQUAUBU
      MUCZUJSULADTUQULSFESUQUKSFAFTUDUEUFUGUHUI @.
  @}

  @{
    @d C c d j r @.  @d D c d j r @.  @d J c d j r @.  @d M c d j r @.
    @d O c d j r @.  @d R c d j r @.  @d T c d j r x @.
    algi.1 @e |- D = ( dom_ ` T ) @.
    algi.2 @e |- C = ( cod_ ` T ) @.
    algi.3 @e |- J = ( id_ ` T ) @.
    algi.4 @e |- R = ( o_ ` T ) @.
    algi.5 @e |- M = dom D @.
    algi.6 @e |- O = dom J @.
    @( "Axiomatic" properties of ` Alg ` .  (Contributed by FL,
       24-Oct-2007.) @)
    algi @p |- ( T e. Alg
         -> ( ( D : M --> O /\ C : M --> O /\ J : O --> M )
               /\ ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) ) @=
      ( vx vd wf w3a wceq wex wb vc vj vr wfun cdm cxp wss crn wa cop calg wcel
      cab 3anass bicomi exbii 3exbii abbii eleq2i c1st cfv domval eqcomi eqeq2i
      cv feq1 dmeq feq2d feq2i syl6bbr bitrd feq2 syl6eqr feq3 3anbi123d xpid11
      syl sseq2 sylbir 3anbi23d anbi12d sylbi c2nd codval 3anbi2d anbi1d cmpval
      idval funeq sseq1d rneq anbi2d eloi df-alg eleq2s ) FGBPZFGAPZGFEPZQZCUDZ
      CUEZFFUFZUGZCUHZFUGZQZUIZDNVEOVEZUAVEZUJUBVEZUCVEZUJUJRZXHUEZXJUEZXHPZXMX
      NXIPZXNXMXJPZQZXKUDZXKUEZXMXMUFZUGZXKUHZXMUGZQZQZUCSZUBSUASOSZNUMZUKDYIUL
      DXLXRYEUIZUIZUCSZUBSUASOSZNUMZULXGYNYIDYMYHNYLYGOUAUBYKYFUCYFYKXLXRYEUNUO
      UPUQURUSYJFXNBPZFXNXIPZXNFXJPZQZXSXTXBUGZYCFUGZQZUIZYOFXNAPZYQQZUUAUIZWSU
      UAUIZXGNOUAUCUBDXHDUTVAZUTVAZRXHBRZYJUUBTUUHBXHBUUHBDHVBVCVDUUIXRYRYEUUAU
      UIXOYOXPYPXQYQUUIXOXMXNBPZYOXMXNXHBVFUUIUUJBUEZXNBPYOUUIXMUUKXNBXHBVGZVHF
      UUKXNBLVIVJVKUUIXMUUKRZXPYPTUULUUMXPUUKXNXIPYPXMUUKXNXIVLFUUKXNXILVIVJVQU
      UIXMFRZXQYQTUUIXMUUKFUULLVMZXMFXNXJVNVQVOUUIUUNYEUUATUUOUUNYBYSYDYTXSUUNY
      AXBRYBYSTXMFVPYAXBXTVRVSXMFYCVRVTVQWAWBXIUUGWCVAZRXIARZUUBUUETUUPAXIAUUPA
      DIWDVCVDUUQYRUUDUUAUUQYPUUCYOYQFXNXIAVFWEWFWBXJDWCVAZUTVAZRXJERZUUEUUFTUU
      SEXJEUUSDEJWHVCVDUUTUUDWSUUAUUTYOWPUUCWQYQWRUUTXNGRZYOWPTUUTXNEUEGXJEVGMV
      MZXNGFBVNVQUUTUVAUUCWQTUVBXNGFAVNVQUUTYQXNFEPWRXNFXJEVFUUTXNGFEUVBVHVKVOW
      FWBXKUURWCVAZRXKCRZUUFXGTUVCCXKCUVCDCKWGVCVDUVDUUAXFWSUVDXSWTYSXCYTXEXKCW
      IUVDXTXAXBXKCVGWJUVDYCXDFXKCWKWJVOWLWBWMVSNUBUCUAOWNWO @.
  @}

  @{

    alg.1 @e |- M = dom D @.
    alg.3 @e |- D = ( dom_ ` T ) @.
    @{
      alg.2 @e |- O = dom J @.
      alg.5 @e |- J = ( id_ ` T ) @.

      @{
        @( ` ( dom_ `` T ) ` is a mapping from the morphisms of ` T ` to the
           objects of ` T ` .  (Contributed by FL, 24-Oct-2007.) @)
        doma @p |- ( T e. Alg -> D : M --> O ) @=
          ( calg wcel wf ccod_ cfv w3a co_ wfun cdm wss eqid algi simpld simp1d
          cxp crn ) BJKZDEALZDEBMNZLZEDCLZUFUGUIUJOBPNZQUKRDDUDSUKUEDSOUHAUKBCD
          EGUHTIUKTFHUAUBUC @.
      @}

      @{
        alg.4 @e |- C = ( cod_ ` T ) @.
        @( ` ( cod_ `` T ) ` is a mapping from the morphisms of ` T ` to the
           objects of ` T ` .  (Contributed by FL, 26-Oct-2007.) @)
        coda @p |- ( T e. Alg -> C : M --> O ) @=
          ( calg wcel wf w3a co_ cfv wfun cdm wss cxp eqid algi simpld simp2d
          crn ) CLMZEFBNZEFANZFEDNZUGUHUIUJOCPQZRUKSEEUATUKUFETOABUKCDEFHKJUKUB
          GIUCUDUE @.

      @}

      @{
        @( ` ( id_ `` A ) ` is a mapping from the objects of ` T ` to the
           morphisms of ` T ` .  (Contributed by FL, 26-Oct-2007.) @)
        ida @p |- ( T e. Alg -> J : O --> M ) @=
          ( calg wcel wf ccod_ cfv w3a co_ wfun cdm wss eqid algi simpld simp3d
          cxp crn ) BJKZDEALZDEBMNZLZEDCLZUFUGUIUJOBPNZQUKRDDUDSUKUEDSOUHAUKBCD
          EGUHTIUKTFHUAUBUC @.

        @( An identity is a morphism.  (Contributed by FL, 10-Jan-2008.) @)
        idmoa @p |- ( ( T e. Alg /\ A e. O ) -> ( J ` A ) e. M ) @=
          ( calg wcel wf cfv ida ffvelrn sylan ) CKLFEDMAFLADNELBCDEFGHIJOFEADP
          Q @.
      @}
    @}

    @{
      alg.6 @e |- R = ( o_ ` T ) @.
      @( ` ( o_ `` T ) ` is a partial operation on the morphisms of ` T ` .
         (Contributed by FL, 26-Oct-2007.) @)
      cmppfa @p |- ( T e. Alg ->
        ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) @=
        ( calg wcel cid_ cfv cdm wf ccod_ w3a wfun cxp wss crn eqid algi simprd
        ) CHIDCJKZLZAMDUDCNKZMUDDUCMOBPBLDDQRBSDROUEABCUCDUDFUETUCTGEUDTUAUB @.
    @}
  @}

  @{
    dcsda.1 @e |- D = ( dom_ ` T ) @.
    dcsda.2 @e |- C = ( cod_ ` T ) @.
    @( ` ( dom_ `` T ) ` and ` ( cod_ `` T ) ` have the same domain.
       (Contributed by FL, 10-Jan-2008.) @)
    dcsda @p |- ( T e. Alg -> dom D = dom C ) @=
      ( calg wcel cdm cid_ cfv wf wceq eqid coda fdm eqcomd syl ) CFGBHZCIJZHZA
      KZRAHZLABCSRTRMDTMSMENUAUBRRTAOPQ @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Deductive systems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Ded @. @( The class of all deductive systems. @)

  @( Extend class notation with the class of deductive systems. @)
  cded @a class Ded @.

  @{
    @d x d c j r a f g @.
    @( Definition of a deductive system.  Lambeck and Scott.  Introduction to
       higher order categorical logic. p. 47. 1986.  Unformally we can say a
       deductive system is a directed multi graph where for each object a
       specific morphism called identity of the object exists and where for
       some pairs of morphisms the composite exists.  Deductive system are
       named so because morphisms may be interpreted as logical deductions,
       objects as sets of formulas and compositions as inferences.
       (Contributed by FL, 24-Oct-2007.) @)
    df-ded @a |- Ded = { x | E. d E. c E. j E. r
    ( x = <. <. d , c >. , <. j , r >. >. /\ ( (
      <. <. d , c >. , <. j , r >. >. e. Alg /\
      A. a e. dom j
         ( ( d ` ( j ` a ) ) = a /\ ( c ` ( j ` a ) ) = a ) /\
      A. f e. dom d A. g e. dom d ( <. g , f >. e. dom r
        <-> ( d ` g ) = ( c ` f ) ) ) /\ (
      A. f e. dom d A. g e. dom d
         ( ( d ` g ) = ( c ` f ) -> ( d ` ( g r f ) ) = ( d ` f ) ) /\
      A. f e. dom d A. g e. dom d
         ( ( d ` g ) = ( c ` f ) -> ( c ` ( g r f ) ) = ( c ` g ) ) ) ) ) } @.
  @}

  @{
    @d C a c d f g j r @.  @d D a c d f g j r @.  @d J a c d j r @.
    @d M c d j r @.  @d O c d j r @.  @d R c d f g j r @.
    @d a c d f g j r x @.
    isded.1 @e |- M = dom D @.
    isded.2 @e |- O = dom J @.
    @( The predicate "is a deductive system".  (Contributed by FL,
       24-Oct-2007.) @)
    isded @p |- ( ( ( D e. A /\ C e. B /\ J e. F ) /\ R e. G )
      -> ( <. <. D , C >. , <. J , R >. >. e. Ded
        <-> ( ( <. <. D , C >. , <. J , R >. >. e. Alg /\
      A. a e. O
         ( ( D ` ( J ` a ) ) = a /\ ( C ` ( J ` a ) ) = a ) /\
      A. f e. M A. g e. M ( <. g , f >. e. dom R
        <-> ( D ` g ) = ( C ` f ) ) ) /\ (
      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( D ` ( g R f ) ) = ( D ` f ) ) /\
      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( C ` ( g R f ) ) = ( C ` g ) ) ) ) ) ) @=
      ( wcel wceq cfv wa wral vx vd vc vj vr cop cded cv calg cdm wb w3a co wex
      wi cab df-ded eleq2i opeq1 opeq1d eleq1d fveq1 eqeq1d anbi1d ralbidv dmeq
      syl6eqr eleq2d bibi2d imbi12d ralbidv2 eqeq12d imbi1d opeq2 anbi2d eqeq2d
      3anbi123d 2ralbidv opeq2d fveq2d 3anbi12d bibi1d 3anbi13d oveq imbi2d elo
      anbi12d syl5bb ) DCUFZJEUFZUFZUGPWKUAUHUBUHZUCUHZUFZUDUHZUEUHZUFZUFZQWRUI
      PZMUHZWORZWLRZWTQZXAWMRZWTQZSZMWOUJZTZGUHZFUHZUFZWPUJZPZXIWLRZXJWMRZQZUKZ
      GWLUJZTZFXRTZULZXPXIXJWPUMZWLRZXJWLRZQZUOZGXRTZFXRTZXPYBWMRZXIWMRZQZUOZGX
      RTZFXRTZSZSZSUEUNUDUNUCUNUBUNUAUPZPDAPCBPJHPULEIPSWKUIPZWTJRZDRZWTQZYSCRZ
      WTQZSZMLTZXKEUJZPZXIDRZXJCRZQZUKZGKTFKTZULZUUJXIXJEUMZDRZXJDRZQZUOZGKTFKT
      ZUUJUUNCRZXICRZQZUOZGKTFKTZSZSZUGYQWKUAFGUDUEMUCUBUQURYPDWMUFZWQUFZUIPZXA
      DRZWTQZXESZMXGTZXMUUHXOQZUKZGKTZFKTZULZUVNYBDRZUUPQZUOZGKTZFKTZUVNYKUOZGK
      TZFKTZSZSWIWQUFZUIPZUVKXACRZWTQZSZMXGTZXMUUJUKZGKTFKTZULZUUJUVTUOZGKTFKTZ
      UUJYBCRZUVAQZUOZGKTFKTZSZSWIJWPUFZUFZUIPZUUEUWOULZUXCSUVFUAUBUCUEUDDCJEAB
      HIWLDQZYAUVRYOUWGUXHWSUVIXHUVMXTUVQUXHWRUVHUIUXHWNUVGWQWLDWMUSUTVAUXHXFUV
      LMXGUXHXCUVKXEUXHXBUVJWTXAWLDVBVCVDVEUXHXSUVPFXRKUXHXJXRPZXJKPZXSUVPUXHXR
      KXJUXHXRDUJKWLDVFNVGZVHZUXHXQUVOGXRKUXHXIXRPZXIKPZXQUVOUXHXRKXIUXKVHZUXHX
      PUVNXMUXHXNUUHXOXIWLDVBVCZVIVJVKVJVKVQUXHYHUWCYNUWFUXHYGUWBFXRKUXHUXIUXJY
      GUWBUXLUXHYFUWAGXRKUXHUXMUXNYFUWAUXOUXHXPUVNYEUVTUXPUXHYCUVSYDUUPYBWLDVBX
      JWLDVBVLVJVJVKVJVKUXHYMUWEFXRKUXHUXIUXJYMUWEUXLUXHYLUWDGXRKUXHUXMUXNYLUWD
      UXOUXHXPUVNYKUXPVMVJVKVJVKWGWGWMCQZUVRUWPUWGUXCUXQUVIUWIUVMUWMUVQUWOUXQUV
      HUWHUIUXQUVGWIWQWMCDVNUTVAUXQUVLUWLMXGUXQXEUWKUVKUXQXDUWJWTXAWMCVBVCVOVEU
      XQUVOUWNFGKKUXQUVNUUJXMUXQXOUUIUUHXJWMCVBVPZVIVRVQUXQUWCUWRUWFUXBUXQUWAUW
      QFGKKUXQUVNUUJUVTUXRVMVRUXQUWDUXAFGKKUXQUVNUUJYKUWTUXRUXQYIUWSYJUVAYBWMCV
      BXIWMCVBVLVJVRWGWGWOJQZUWPUXGUXCUXSUWIUXFUWMUUEUWOUXSUWHUXEUIUXSWQUXDWIWO
      JWPUSVSVAUXSUWLUUDMXGLUXSWTXGPWTLPUWLUUDUXSXGLWTUXSXGJUJLWOJVFOVGVHUXSUVK
      UUAUWKUUCUXSUVJYTWTUXSXAYSDWTWOJVBZVTVCUXSUWJUUBWTUXSXAYSCUXTVTVCWGVJVKWA
      VDWPEQZUXGUUMUXCUVEUYAUXFYRUWOUULUUEUYAUXEWKUIUYAUXDWJWIWPEJVNVSVAUYAUWNU
      UKFGKKUYAXMUUGUUJUYAXLUUFXKWPEVFVHWBVRWCUYAUWRUUSUXBUVDUYAUWQUURFGKKUYAUV
      TUUQUUJUYAUVSUUOUUPUYAYBUUNDXIXJWPEWDZVTVCWEVRUYAUXAUVCFGKKUYAUWTUVBUUJUY
      AUWSUUTUVAUYAYBUUNCUYBVTVCWEVRWGWGWFWH @.
  @}

  @{
    @d C a c d f g j r @.  @d D a c d f g j r @.  @d J a c d j r @.
    @d M c d j r @.  @d O c d j r @.  @d R c d f g j r @.  @d T c d j r x @.
    @d a c d f g j r x @.
    dedi.1 @e |- D = ( dom_ ` T ) @.
    dedi.2 @e |- C = ( cod_ ` T ) @.
    dedi.3 @e |- J = ( id_ ` T ) @.
    dedi.4 @e |- R = ( o_ ` T ) @.
    dedi.5 @e |- M = dom D @.
    dedi.6 @e |- O = dom J @.
    @( Properties of a deductive system.  (Contributed by FL, 24-Oct-2007.) @)
    dedi @p |- ( T e. Ded
        -> ( ( <. <. D , C >. , <. J , R >. >. e. Alg /\
      A. a e. O
         ( ( D ` ( J ` a ) ) = a /\ ( C ` ( J ` a ) ) = a ) /\
      A. f e. M A. g e. M ( <. g , f >. e. dom R
        <-> ( D ` g ) = ( C ` f ) ) ) /\ (
      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( D ` ( g R f ) ) = ( D ` f ) ) /\
      A. f e. M A. g e. M
         ( ( D ` g ) = ( C ` f ) -> ( C ` ( g R f ) ) = ( C ` g ) ) ) ) ) @=
      ( wcel wceq cfv wral vx vd vc vj vr cded cv cop calg wa cdm wb w3a co wex
      wi cab df-ded eleq2i c1st domval eqcomi eqeq2i opeq1 opeq1d eleq1d eqeq1d
      fveq1 anbi1d ralbidv dmeq syl6eqr eleq2d bibi2d imbi12d 3anbi123d eqeq12d
      ralbidv2 imbi1d anbi12d sylbi codval anbi2d eqeq2d 2ralbidv opeq2d fveq2d
      c2nd opeq2 idval 3anbi12d cmpval bibi1d 3anbi13d oveq imbi2d eloi ) DUFQD
      UAUGUBUGZUCUGZUHZUDUGZUEUGZUHZUHZRXDUIQZJUGZXASZWRSZXFRZXGWSSZXFRZUJZJXAU
      KZTZFUGZEUGZUHZXBUKZQZXOWRSZXPWSSZRZULZFWRUKZTZEYDTZUMZYBXOXPXBUNZWRSZXPW
      RSZRZUPZFYDTZEYDTZYBYHWSSZXOWSSZRZUPZFYDTZEYDTZUJZUJZUJUEUOUDUOUCUOUBUOUA
      UQZQBAUHZGCUHZUHZUIQZXFGSZBSZXFRZUUHASZXFRZUJZJITZXQCUKZQZXOBSZXPASZRZULZ
      FHTEHTZUMZUUSXOXPCUNZBSZXPBSZRZUPZFHTEHTZUUSUVCASZXOASZRZUPZFHTEHTZUJZUJZ
      UFUUCDUAEFUDUEJUCUBURUSUUBBWSUHZXCUHZUIQZXGBSZXFRZXKUJZJXMTZXSUUQYARZULZF
      HTZEHTZUMZUWCYHBSZUVERZUPZFHTZEHTZUWCYQUPZFHTZEHTZUJZUJZUUDXCUHZUIQZUVTXG
      ASZXFRZUJZJXMTZXSUUSULZFHTEHTZUMZUUSUWIUPZFHTEHTZUUSYHASZUVJRZUPZFHTEHTZU
      JZUJZUUDGXBUHZUHZUIQZUUNUXEUMZUXMUJZUVOUAUBUCUEUDDWRDUTSZUTSZRWRBRZUUBUWQ
      ULUYABWRBUYABDKVAVBVCUYBYGUWGUUAUWPUYBXEUVRXNUWBYFUWFUYBXDUVQUIUYBWTUVPXC
      WRBWSVDVEVFUYBXLUWAJXMUYBXIUVTXKUYBXHUVSXFXGWRBVHVGVIVJUYBYEUWEEYDHUYBXPY
      DQZXPHQZYEUWEUYBYDHXPUYBYDBUKHWRBVKOVLZVMZUYBYCUWDFYDHUYBXOYDQZXOHQZYCUWD
      UYBYDHXOUYEVMZUYBYBUWCXSUYBXTUUQYAXOWRBVHVGZVNVOVRVOVRVPUYBYNUWLYTUWOUYBY
      MUWKEYDHUYBUYCUYDYMUWKUYFUYBYLUWJFYDHUYBUYGUYHYLUWJUYIUYBYBUWCYKUWIUYJUYB
      YIUWHYJUVEYHWRBVHXPWRBVHVQVOVOVRVOVRUYBYSUWNEYDHUYBUYCUYDYSUWNUYFUYBYRUWM
      FYDHUYBUYGUYHYRUWMUYIUYBYBUWCYQUYJVSVOVRVOVRVTVTWAWSUXTWHSZRWSARZUWQUXNUL
      UYKAWSAUYKADLWBVBVCUYLUWGUXFUWPUXMUYLUVRUWSUWBUXCUWFUXEUYLUVQUWRUIUYLUVPU
      UDXCWSABWIVEVFUYLUWAUXBJXMUYLXKUXAUVTUYLXJUWTXFXGWSAVHVGWCVJUYLUWDUXDEFHH
      UYLUWCUUSXSUYLYAUURUUQXPWSAVHWDZVNWEVPUYLUWLUXHUWOUXLUYLUWJUXGEFHHUYLUWCU
      USUWIUYMVSWEUYLUWMUXKEFHHUYLUWCUUSYQUXJUYMUYLYOUXIYPUVJYHWSAVHXOWSAVHVQVO
      WEVTVTWAXADWHSZUTSZRXAGRZUXNUXSULUYOGXAGUYODGMWJVBVCUYPUXFUXRUXMUYPUWSUXQ
      UXCUUNUXEUYPUWRUXPUIUYPXCUXOUUDXAGXBVDWFVFUYPUXBUUMJXMIUYPXFXMQXFIQUXBUUM
      UYPXMIXFUYPXMGUKIXAGVKPVLVMUYPUVTUUJUXAUULUYPUVSUUIXFUYPXGUUHBXFXAGVHZWGV
      GUYPUWTUUKXFUYPXGUUHAUYQWGVGVTVOVRWKVIWAXBUYNWHSZRXBCRZUXSUVOULUYRCXBCUYR
      DCNWLVBVCUYSUXRUVBUXMUVNUYSUXQUUGUXEUVAUUNUYSUXPUUFUIUYSUXOUUEUUDXBCGWIWF
      VFUYSUXDUUTEFHHUYSXSUUPUUSUYSXRUUOXQXBCVKVMWMWEWNUYSUXHUVHUXLUVMUYSUXGUVG
      EFHHUYSUWIUVFUUSUYSUWHUVDUVEUYSYHUVCBXOXPXBCWOZWGVGWPWEUYSUXKUVLEFHHUYSUX
      JUVKUUSUYSUXIUVIUVJUYSYHUVCAUYTWGVGWPWEVTVTWAWQWA @.
  @}

  @{
    @d A x y z @.
    1ded.1 @e |- A e. _V @.
    @( Category ` 1 ` is a deductive system.  We can think of the morphism of
       Category ` 1 ` as corresponding to ` ph |- ph ` .  (Contributed by FL,
       30-Oct-2007.) @)
    1ded @p |- <. <. { <. <. A , A >. , A >. } ,
      { <. <. A , A >. , A >. } >. , <. { <. A , <. A , A >. >. } ,
      { <. <. <. A , A >. , <. A , A >. >. , <. A , A >. >. } >. >. e. Ded @=
      ( vz vy vx cop csn wcel cv cfv wceq wa cdm co wi fveq2i fveq2d eqcomd cvv
      wral cded calg wb w3a 1alg elsni opex eqtri fveq2 id 3eqtr4a syl anidmdbi
      fvsn mpbir rgen snid dmsnop eleqtrri eqid 2th opeq12 ancoms eleq1d adantl
      a1i adantr eqeq12d 3bitr3d syl2an rgen2a 3pm3.2i df-ov oveq2 oveq1 syl5ib
      sylan9eq sylan9eqr pm3.2i snex eqcomi isded mp2an mpbir2an ) AAFZAFZGZWGF
      AWEFZGZWEWEFZWEFZGZFFZUAHZWMUBHZCIZWIJZWGJZWPKZWSLZCAGZTZDIZEIZFZWLMZHZXC
      WGJZXDWGJZKZUCZDWEGZTEXLTZUDZXJXCXDWLNZWGJZXIKZOZDXLTEXLTZXJXPXHKZOZDXLTE
      XLTZLZWOXBXMABUEWTCXAWPXAHZWTOYDWSOYDWPAKZWSWPAUFYEAWIJZWGJZAWRWPYGWEWGJZ
      AYFWEWGAWEBAAUGZUNPWEAYIBUNUHYEWQYFWGWPAWIUIQYEUJUKULYDWSUMUOUPXKEDXLXDXL
      HZXDWEKZXCWEKZXKXCXLHZXDWEUFZXCWEUFZYKYLLZWJXFHZYHYHKZXGXJYQYRUCYPYQYRWJW
      JGXFWJWEWEUGZUQWJWEYIURUSYHUTVAVFYPWJXEXFYLYKWJXEKYLYKLXEWJXCXDWEWEVBRVCV
      DYPYHXHYHXIYPWEXCWGYLWEXCKYKYLXCWEYLUJRVEQYKYHXIKZYLYKWEXDWGYKXDWEYKUJRQV
      GVHVIVJVKVLXSYBXREDXLYJYKYLXRYMYNYOXJWEWEWLNZWGJZYHKZYPXQUUCXJUUAWEWGUUAW
      JWLJZWEWEWEWLVMZWJWEYSYIUNZUHPVFYPUUBXPYHXIYKYLUUBWEXDWLNZWGJXPYKUUAUUGWG
      YKUUGUUAXDWEWEWLVNRQYLUUGXOWGYLXOUUGXCWEXDWLVORQVQYKYTYLYKXIYHXDWEWGUIRVG
      VHVPVJVKYAEDXLYJYKYLYAYMYNYOXJUUCYPXTUUCXJUUBUUDWGJYHUUAUUDWGUUEPUUDWEWGU
      UFPUHVFYPUUBXPYHXHYPUUAXOWGYLYKUUAXCWEWLNZXOYLUUHUUAXCWEWEWLVORYKXOUUHXDW
      EXCWLVNRVRQYLYHXHKYKYLXHYHXCWEWGUIRVEVHVPVJVKVSWGSHZUUIWISHZUDWLSHWNXNYCL
      UCUUIUUIUUJWFVTZUUKWHVTVLWKVTSSWGWGWLEDSSWIXLXACWGMXLWEABURWAWIMXAAWEYIUR
      WAWBWCWD @.
  @}

  @{
    @d f t u v w x y z @.
    @( Structure of a deductive system.  (Contributed by FL, 28-Oct-2007.) @)
    strded @p |- Ded C_ ( ( _V X. _V ) X. ( _V X. _V ) ) @=
      ( vx vf vt vw vv vu vz vy cv cop wceq wcel cfv wa cdm wral wi wex cvv cxp
      cded calg wb w3a co cab df-ded stcat eqsstri ) UAAIBIZCIZJDIZEIZJJZKUNUBL
      FIZULMZUJMUOKUPUKMUOKNFULOPGIZHIZJUMOLUQUJMURUKMKZUCGUJOZPHUTPUDUSUQURUMU
      EZUJMURUJMKQGUTPHUTPUSVAUKMUQUKMKQGUTPHUTPNNZNERDRCRBRAUFSSTZVCTAHGDEFCBU
      GVBABCEDUHUI @.
  @}

  @( A deductive system is a relation.  (Contributed by FL, 28-Oct-2007.) @)
  relded @p |- Rel Ded @=
    ( cded wrel cvv cxp wss strded xpss sstri df-rel mpbir ) ABACCDZEAKKDKFKKGH
    AIJ @.

  @( The domain of a deductive system is a relation.  (Contributed by FL,
     28-Oct-2007.) @)
  reldded @p |- Rel dom Ded @=
    ( cded cdm wrel cvv cxp wss strded dmss ax-mp dmxpid sseqtri df-rel mpbir )
    ABZCNDDEZFNOOEZBZOAPFNQFGAPHIOJKNLM @.

  @( The range of a deductive system is a relation.  (Contributed by FL,
     28-Oct-2007.) @)
  relrded @p |- Rel ran Ded @=
    ( cded crn wrel cvv cxp wss strded rnss ax-mp rnxpid sseqtri df-rel mpbir )
    ABZCNDDEZFNOOEZBZOAPFNQFGAPHIOJKNLM @.

  @{
    @d T x y z @.
    @( A deductive system is an "algebra".  (Contributed by FL,
       28-Oct-2007.) @)
    dedalg @p |- ( T e. Ded -> T e. Alg ) @=
      ( vz vy vx cded wcel cfv cop calg c1st c2nd wrel cdm wceq eqid opeq12i cv
      w3a wa wral cdom_ ccod_ cid_ co_ crn relded reldded relrded 11st22nd mpan
      3pm3.2i domval codval idval cmpval syl6eqr wb co wi simpld simp1d eqeltrd
      dedi ) AEFZAAUAGZAUBGZHZAUCGZAUDGZHZHZIVDAAJGZJGZVLKGZHZAKGZJGZVPKGZHZHZV
      KELZEMLZEUELZRVDAVTNWAWBWCUFUGUHUKAEUIUJVGVOVJVSVEVMVFVNVEAVEOZULVFAVFOZU
      MPVHVQVIVRAVHVHOZUNAVIVIOZUOPPUPVDVKIFZBQZVHGZVEGWINWJVFGWINSBVHMZTZCQZDQ
      ZHVIMFWMVEGWNVFGNZUQCVEMZTDWPTZVDWHWLWQRWOWMWNVIURZVEGWNVEGNUSCWPTDWPTWOW
      RVFGWMVFGNUSCWPTDWPTSVFVEVIADCVHWPWKBWDWEWFWGWPOWKOVCUTVAVB @.
  @}

  @{
    @d A x @.  @d C x y z @.  @d D x y z @.  @d J x @.  @d O x @.  @d T y z @.
    idosd.1 @e |- O = dom J @.
    idosd.2 @e |- D = ( dom_ ` T ) @.
    idosd.3 @e |- J = ( id_ ` T ) @.
    idosd.4 @e |- C = ( cod_ ` T ) @.
    @( The identity is a morphism which has the same object as its domain and
       its codomain.  (Contributed by FL, 28-Oct-2007.) @)
    idosd @p |- ( ( T e. Ded /\ A e. O ) -> ( ( D ` ( J ` A ) ) = A /\
        ( C ` ( J ` A ) ) = A ) ) @=
      ( vx vz vy wcel cfv wceq wa cop cv wral cded co_ calg cdm wb co eqid dedi
      w3a wi fveq2 fveq2d id eqeq12d anbi12d rspccv 3ad2ant2 adantr syl imp ) D
      UANZAFNZAEOZCOZAPZVCBOZAPZQZVACBREDUBOZRRUCNZKSZEOZCOZVKPZVLBOZVKPZQZKFTZ
      LSZMSZRVIUDNVSCOVTBOPZUELCUDZTMWBTZUIZWAVSVTVIUFZCOVTCOPUJLWBTMWBTWAWEBOV
      SBOPUJLWBTMWBTQZQVBVHUJZBCVIDMLEWBFKHJIVIUGWBUGGUHWDWGWFVRVJWGWCVQVHKAFVK
      APZVNVEVPVGWHVMVDVKAWHVLVCCVKAEUKZULWHUMZUNWHVOVFVKAWHVLVCBWIULWJUNUOUPUQ
      URUSUT @.
  @}

  @{
    @d C f g x @.  @d D f g x @.  @d F f g @.  @d G g @.  @d M f g @.
    @d R f g @.  @d T x @.
    ded.1 @e |- M = dom D @.
    ded.2 @e |- D = ( dom_ ` T ) @.
    ded.3 @e |- C = ( cod_ ` T ) @.
    ded.4 @e |- R = ( o_ ` T ) @.
    @( ` ( G ( o_ `` T ) F ) ` is only defined when the domain of ` G ` is the
       codomain of ` F ` .  (Contributed by FL, 29-Oct-2007.) @)
    cmppfd @p |- ( ( T e. Ded /\ F e. M /\ G e. M ) ->
          ( <. G , F >. e. dom R <-> ( D ` G ) = ( C ` F ) ) ) @=
      ( vx vg vf wcel cop cfv wceq wa wral cded cdm wb cid_ calg cv w3a co eqid
      dedi opeq2 eleq1d fveq2 eqeq2d bibi12d opeq1 eqeq1d rspc2v com12 3ad2ant3
      wi adantr syl 3impib ) DUAOZEGOZFGOZFEPZCUBZOZFBQZEAQZRZUCZVEBAPDUDQZCPPU
      EOZLUFZVOQZBQVQRVRAQVQRSLVOUBZTZMUFZNUFZPZVIOZWABQZWBAQZRZUCZMGTNGTZUGZWG
      WAWBCUHZBQWBBQRVAMGTNGTWGWKAQWAAQRVAMGTNGTSZSVFVGSZVNVAZABCDNMVOGVSLIJVOU
      IKHVSUIUJWJWNWLWIVPWNVTWMWIVNWHVNWAEPZVIOZWEVLRZUCNMEFGGWBERZWDWPWGWQWRWC
      WOVIWBEWAUKULWRWFVLWEWBEAUMUNUOWAFRZWPVJWQVMWSWOVHVIWAFEUPULWSWEVKVLWAFBU
      MUQUOURUSUTVBVCVD @.

    @( When ` ( G ( o_ `` T ) F ) ` is defined, its domain is the domain of
       ` F ` .  (Contributed by FL, 29-Oct-2007.) @)
    domcmpd @p |- ( ( T e. Ded /\ F e. M /\ G e. M ) ->
            ( ( D ` G ) = ( C ` F ) -> ( D ` ( G R F ) ) = ( D ` F ) ) ) @=
      ( vg vf wcel cfv wceq wi cop wa wral vx cded co cid_ calg cv cdm w3a eqid
      wb fveq2 eqeq2d oveq2 fveq2d eqeq12d imbi12d eqeq1d oveq1 rspc2v ad2antrl
      dedi com12 syl 3impib ) DUBNZEGNZFGNZFBOZEAOZPZFECUCZBOZEBOZPZQZVEBARDUDO
      ZCRRUENUAUFZVPOZBOVQPVRAOVQPSUAVPUGZTLUFZMUFZRCUGNVTBOZWAAOZPZUJLGTMGTUHZ
      WDVTWACUCZBOZWABOZPZQZLGTMGTZWDWFAOVTAOPQLGTMGTZSSVFVGSZVOQZABCDMLVPGVSUA
      IJVPUIKHVSUIVAWKWNWEWLWMWKVOWJVOWBVIPZVTECUCZBOZVMPZQMLEFGGWAEPZWDWOWIWRW
      SWCVIWBWAEAUKULWSWGWQWHVMWSWFWPBWAEVTCUMUNWAEBUKUOUPVTFPZWOVJWRVNWTWBVHVI
      VTFBUKUQWTWQVLVMWTWPVKBVTFECURUNUQUPUSVBUTVCVD @.

    @( When ` ( G ( o_ `` T ) F ) ` is defined, its codomain is the codomain of
       ` G ` .  (Contributed by FL, 29-Oct-2007.) @)
    codcmpd @p |- ( ( T e. Ded /\ F e. M /\ G e. M ) ->
             ( ( D ` G ) = ( C ` F )
             -> ( C ` ( G R F ) ) = ( C ` G ) ) ) @=
      ( vg vf wcel cfv wceq wi cop wa wral vx cded co cid_ calg cv cdm w3a eqid
      wb fveq2 eqeq2d oveq2 fveq2d eqeq1d imbi12d oveq1 eqeq12d rspc2v ad2antll
      dedi com12 syl 3impib ) DUBNZEGNZFGNZFBOZEAOZPZFECUCZAOZFAOZPZQZVEBARDUDO
      ZCRRUENUAUFZVPOZBOVQPVRAOVQPSUAVPUGZTLUFZMUFZRCUGNVTBOZWAAOZPZUJLGTMGTUHZ
      WDVTWACUCZBOWABOPQLGTMGTZWDWFAOZVTAOZPZQZLGTMGTZSSVFVGSZVOQZABCDMLVPGVSUA
      IJVPUIKHVSUIVAWLWNWEWGWMWLVOWKVOWBVIPZVTECUCZAOZWIPZQMLEFGGWAEPZWDWOWJWRW
      SWCVIWBWAEAUKULWSWHWQWIWSWFWPAWAEVTCUMUNUOUPVTFPZWOVJWRVNWTWBVHVIVTFBUKUO
      WTWQVLWIVMWTWPVKAVTFECUQUNVTFAUKURUPUSVBUTVCVD @.
  @}

  @{
    @d D a @.  @d O a @.  @d T a @.
    rdmob.1 @e |- O = dom ( id_ ` T ) @.
    rdmob.2 @e |- D = ( dom_ ` T ) @.
    @( The range of ` ( dom_ `` T ) ` is the class of the objects.
       (Contributed by FL, 10-Jan-2008.) @)
    rdmob @p |- ( T e. Ded -> ran D = O ) @=
      ( va cded wcel crn calg cdm wf cfv eqid doma 3syl wa wceq wi ex dedalg cv
      wss cid_ frn ccod_ cdom_ idosd ida ffvelrn wfun ffun fvelrn fveq1i eleq1i
      syl syl6ibr syld imp eleq1 rneqi eleq2i syl6bbr biimpd adantr ssrdv eqssd
      sylc ) BGHZAIZCVIBJHZAKZCALVJCUCBUAZABBUDMZVLCVLNEDVNNZOVLCAUEPVIFCVJVIFU
      BZCHZVPVJHZVIVQQVPVNMZAMZVPRZVSBUFMZMVPRZQVTBUGMZIZHZVRVPWBABVNCDEVOWBNUH
      VIVQWFVIVQVSWDKZHZWFVIVKCWGVNLZVQWHSVMWDBVNWGCWGNZWDNZDVOUIWIVQWHCWGVPVNU
      JTPVIVKWGVNKZWDLZWHWFSVMWDBVNWGWLWJWKWLNVOOWMWHVSWDMZWEHZWFWMWDUKZWHWOSWG
      WLWDULWPWHWOVSWDUMTUPVTWNWEVSAWDEUNUOUQPURUSWAWFVRSWCWAWFVRWAWFVPWEHVRVTV
      PWEUTVJWEVPAWDEVAVBVCVDVEVHTVFVG @.

  @}

  @{
    @d C a @.  @d O a @.  @d T a @.
    rcmob.1 @e |- O = dom ( id_ ` T ) @.
    rcmob.2 @e |- C = ( cod_ ` T ) @.
    @( The range of ` ( cod_ `` T ) ` is the class of the objects.
       (Contributed by FL, 10-Jan-2008.) @)
    rcmob @p |- ( T e. Ded -> ran C = O ) @=
      ( va cded wcel crn calg cdom_ cfv cdm wf wss eqid 3syl wa wceq adantr frn
      dedalg cid_ coda idosd simprd wfun ffun idmoa dcsda eqcomd eleqtrrd sylan
      cv fvelrn syl2anc eqeltrrd ex ssrdv eqssd ) BGHZAIZCVABJHZBKLZMZCANZVBCOB
      UBZAVDBBUCLZVECVEPZVDPZDVHPZEUDZVECAUAQVAFCVBVAFUNZCHZVMVBHVAVNRZVMVHLZAL
      ZVMVBVOVPVDLVMSVQVMSVMAVDBVHCDVJVKEUEUFVOAUGZVPAMZHZVQVBHVAVRVNVAVCVFVRVG
      VLVECAUHQTVAVCVNVTVGVCVNRVPVEVSVMVDBVHVECVIVJDVKUIVCVSVESVNVCVEVSAVDBVJEU
      JUKTULUMVPAUOUPUQURUSUT @.
  @}

  @{
    aidm2.1 @e |- D = ( dom_ ` T ) @.
    aidm2.2 @e |- C = ( cod_ ` T ) @.
    @( The underlying directed multi graph of a deductive system.  (Contributed
       by FL, 20-Sep-2009.) @)
    aidm2 @p |- ( T e. Ded -> <. <. D , C >. , ran D >. e. Dgra ) @=
      ( wcel cop crn cdm wf cfv eqid syl wceq wb feq3 mpbird cdom_ cvv a1i cded
      cmgra cid_ calg dedalg doma rdmob dmeqi coda wa fvex syl6eqel ccod_ rneqd
      rnexg mp1i eqeltrd ismgra syl3anc mpbir2and ) CUAFZBAGBHZGUBFZBIZVBBJZVDV
      BAJZVAVEVDCUCKZIZBJZVACUDFZVICUEZBCVGVDVHVDLDVHLZVGLZUFMVAVBVHNZVEVIOBCVH
      VLDUGZVBVHVDBPMQVAVFVDVHAJZVAVJVPVKACRKZCVGVDVHBVQDUHVQLVLVMEUIMVAVNVFVPO
      VOVBVHVDAPMQVABSFASFVBSFVCVEVFUJOVABVQSBVQNVADTZCRUKZULVAACUMKZSAVTNVAETC
      UMUKULVAVBVQHZSVABVQVRUNVQSFWASFVAVSVQSUOUPUQSSABVBSURUSUT @.
  @}

  @{
    @d M x @.  @d R a x @.  @d T a x @.
    dmrngcmp.1 @e |- R = ( o_ ` T ) @.
    dmrngcmp.2 @e |- M = dom ( dom_ ` T ) @.
    @( Domain and range of the domain of the composition.  (Contributed by FL,
       5-Oct-2009.) @)
    dmrngcmp @p |- ( T e. Ded ->
    ( dom dom R = M /\ ran dom R = M ) ) @=
      ( vx va wcel cdm wceq crn cv cfv wss eqid syl wa cop sylan syldan co_ cxp
      cded wfun cdom_ w3a wi calg dedalg cmppfa dmss dmxpss sstr eqcomi 3sstr3g
      dmeqi sylancl 3ad2ant2 sseld wex cid_ ccod_ wf doma ffvelrn simprd eqcomd
      idosd simpl idmoa eleq2i biimpi adantl cmppfd syl3anc mpbird opeq2 eleq1d
      wb fvex spcev vex eldm2 sylibr impbid eqrdv rnss rnxpss rneqi coda simpld
      ex opeq1 elrn2 jca ) BUCHZAIZIZCJWQKZCJWPFWRCWPFLZWRHZWTCHZWPBUAMZUDZXCIZ
      BUEMZIZXGUBZNZXCKXGNZUFZXAXBUGWPBUHHZXKBUIZXFXCBXGXGOZXFOZXCOUJPZXKWRCWTX
      IXDWRCNZXJXIXEIZXHIZNZXSXGNZXQXEXHUKXGXGULXTYAQXRXGWRCXRXSXGUMXEWQXCAAXCD
      UNUPZUPCXGEUNZUOUQURUSPWPXBXAWPXBQZWTGLZRZWQHZGUTZXAYDWTWTXFMZBVAMZMZRZWQ
      HZYHYDYMYIYKBVBMZMZJZYDYOYIYDYKXFMYIJZYOYIJZWPXBYIYJIZHZYQYRQWPCYSXFVCZXB
      YTWPXLUUAXMXFBYJCYSEXOYSOZYJOZVDZPCYSWTXFVEZSYIYNXFBYJYSUUBXOUUCYNOZVHTVF
      VGYDWPYKXGHZWTXGHZYMYPVSWPXBVIZWPXLXBUUGXMXLXBYTUUGXLUUAXBYTUUDUUESYIXFBY
      JXGYSXNXOUUBUUCVJTSXBUUHWPXBUUHCXGWTEVKVLVMZYNXFABYKWTXGXNXOUUFDVNVOVPYGY
      MGYKYIYJVTYEYKJYFYLWQYEYKWTVQVRWAPGWTWQFWBZWCWDWLWEWFWPFWSCWPWTWSHZXBWPXK
      UULXBUGXPXKWSCWTXIXDWSCNZXJXIXEKZXHKZNZUUOXGNZUUMXEXHWGXGXGWHUUPUUQQUUNXG
      WSCUUNUUOXGUMXEWQYBWIYCUOUQURUSPWPXBUULYDYEWTRZWQHZGUTZUULYDWTYNMZYJMZWTR
      ZWQHZUUTYDUVDUVBXFMUVAJZWPXBUVAYSHZUVEWPCYSYNVCZXBUVFWPXLUVGXMYNXFBYJCYSE
      XOUUBUUCUUFWJZPCYSWTYNVEZSWPUVFQUVEUVBYNMUVAJUVAYNXFBYJYSUUBXOUUCUUFVHWKT
      YDWPUUHUVBXGHZUVDUVEVSUUIUUJWPXLXBUVJXMXLXBUVFUVJXLUVGXBUVFUVHUVISUVAXFBY
      JXGYSXNXOUUBUUCVJTSYNXFABWTUVBXGXNXOUUFDVNVOVPUUSUVDGUVBUVAYJVTYEUVBJUURU
      VCWQYEUVBWTWMVRWAPGWTWQUUKWNWDWLWEWFWO @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Categories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c CatOLD @. @( The class of all categories. @)

  @( Extend class notation with the class of categories. @)
  ccatOLD @a class CatOLD @.

  @{
    @d x d c j r f g h a @.
    @( A category is a deductive system where composition is associative, and
       identities are neutral elements.  A category is an abstraction of a
       structure (a group, a topology, an order...)  Category theory consists
       in finding new formulation of the concepts associated to those
       structures (product, substructure...) using morphisms instead of the
       belonging relation.  That trick has the interesting property that
       heterogeneous structures like topologies or groups for instance become
       comparable.  (Note: in category theory morphisms are also called
       arrows.)  (Contributed by FL, 24-Oct-2007.) @)
    df-catOLD @a |- CatOLD = { x | E. d E. c E. j E. r
    ( x = <. <. d , c >. , <. j , r >. >. /\
           ( ( <. <. d , c >. , <. j , r >. >. e. Ded /\
           A. f e. dom d A. g e. dom d A. h e. dom d
              (
                ( ( d ` h ) = ( c ` g ) /\ ( d ` g ) = ( c ` f ) )
              ->
                ( h r ( g r f ) ) = ( ( h r g ) r f )
               ) ) /\
          ( A. a e. dom j A. f e. dom d ( ( c ` f ) = a ->
             ( ( j ` a ) r f ) = f ) /\
          A. a e. dom j A. f e. dom d ( ( d ` f ) = a ->
             ( f r ( j ` a ) ) = f ) ) ) ) } @.
  @}

  @{
    @d C a c d f g h j r @.  @d D a c d f g h j r @.  @d J a c d f j r @.
    @d M c d j r f @.  @d O c d j r @.  @d R a c d f g h j r @.
    @d a c d f g h j r x @.
    iscatOLD.1 @e |- M = dom D @.
    iscatOLD.2 @e |- O = dom J @.
    @( The predicate "is a category".  (Contributed by FL, 24-Oct-2007.) @)
    iscatOLD @p |- ( ( ( D e. A /\ C e. B /\ J e. F ) /\ R e. G )
      -> ( <. <. D , C >. , <. J , R >. >. e. CatOLD
        <-> ( ( <. <. D , C >. , <. J , R >. >. e. Ded /\
           A. f e. M A. g e. M A. h e. M
              (
                ( ( D ` h ) = ( C ` g ) /\ ( D ` g ) = ( C ` f ) )
              ->
                ( h R ( g R f ) ) = ( ( h R g ) R f )
               ) ) /\
          ( A. a e. O A. f e. M ( ( C ` f ) = a ->
             ( ( J ` a ) R f ) = f ) /\
          A. a e. O A. f e. M ( ( D ` f ) = a ->
             ( f R ( J ` a ) ) = f ) ) ) ) ) @=
      ( wcel wceq wa wral vx vd vc vj vr cop ccatOLD cv cded cfv co cdm wex cab
      w3a df-catOLD eleq2i opeq1 opeq1d eleq1d dmeq syl6eqr eleq2d fveq1 eqeq1d
      wi anbi12d imbi1d imbi12d ralbidv2 raleqdv ralbidv eqeq2d 2ralbidv anbi1d
      opeq2 opeq2d oveq1d imbi2d oveq2d oveq eqtrd eqeq12d elo syl5bb ) DCUFZKE
      UFZUFZUGQWHUAUHUBUHZUCUHZUFZUDUHZUEUHZUFZUFZRWOUIQZHUHZWIUJZGUHZWJUJZRZWS
      WIUJZFUHZWJUJZRZSZWQWSXCWMUKZWMUKZWQWSWMUKZXCWMUKZRZVFZHWIULZTZGXMTZFXMTZ
      SZXDNUHZRZXRWLUJZXCWMUKZXCRZVFZFXMTZNWLULZTZXCWIUJZXRRZXCXTWMUKZXCRZVFZFX
      MTZNYETZSZSZSUEUMUDUMUCUMUBUMUAUNZQDAQCBQKIQUOEJQSWHUIQZWQDUJZWSCUJZRZWSD
      UJZXCCUJZRZSZWQWSXCEUKZEUKZWQWSEUKZXCEUKZRZVFZHLTZGLTFLTZSZUUBXRRZXRKUJZX
      CEUKZXCRZVFZFLTNMTZXCDUJZXRRZXCUUOEUKZXCRZVFZFLTNMTZSZSZUGYPWHUAFGHUDUENU
      CUBUPUQYODWJUFZWNUFZUIQZYRWTRZUUAXDRZSZXKVFZHLTZGLTZFLTZSZYCFLTZNYETZUVAY
      JVFZFLTZNYETZSZSWFWNUFZUIQZUUDXKVFZHLTZGLTFLTZSZUUNYBVFZFLTZNYETZUWCSZSWF
      KWMUFZUFZUIQZUWISZUUNUUOXCWMUKZXCRZVFZFLTZNMTZUVAXCUUOWMUKZXCRZVFZFLTZNMT
      ZSZSUVGUAUBUCUEUDDCKEABIJWIDRZXQUVRYNUWDUXJWPUVJXPUVQUXJWOUVIUIUXJWKUVHWN
      WIDWJURUSUTUXJXOUVPFXMLUXJXCXMQZXCLQZXOUVPUXJXMLXCUXJXMDULLWIDVAOVBZVCZUX
      JXNUVOGXMLUXJWSXMQWSLQXNUVOUXJXMLWSUXMVCUXJXLUVNHXMLUXJWQXMQWQLQXLUVNUXJX
      MLWQUXMVCUXJXFUVMXKUXJXAUVKXEUVLUXJWRYRWTWQWIDVDVEUXJXBUUAXDWSWIDVDVEVGVH
      VIVJVIVJVIVJVGUXJYFUVTYMUWCUXJYDUVSNYEUXJYCFXMLUXMVKVLUXJYLUWBNYEUXJYKUWA
      FXMLUXJUXKUXLYKUWAUXNUXJYHUVAYJUXJYGUUTXRXCWIDVDVEVHVIVJVLVGVGWJCRZUVRUWJ
      UWDUWNUXOUVJUWFUVQUWIUXOUVIUWEUIUXOUVHWFWNWJCDVPUSUTUXOUVOUWHFGLLUXOUVNUW
      GHLUXOUVMUUDXKUXOUVKYTUVLUUCUXOWTYSYRWSWJCVDVMUXOXDUUBUUAXCWJCVDZVMVGVHVL
      VNVGUXOUVTUWMUWCUXOYCUWKNFYELUXOXSUUNYBUXOXDUUBXRUXPVEVHVNVOVGWLKRZUWJUWR
      UWNUXIUXQUWFUWQUWIUXQUWEUWPUIUXQWNUWOWFWLKWMURVQUTVOUXQUWMUXCUWCUXHUXQUWL
      UXBNYEMUXQXRYEQZXRMQZUWLUXBUXQYEMXRUXQYEKULMWLKVAPVBVCZUXQUWKUXAFLUXQYBUW
      TUUNUXQYAUWSXCUXQXTUUOXCWMXRWLKVDZVRVEVSVLVIVJUXQUWBUXGNYEMUXQUXRUXSUWBUX
      GUXTUXQUWAUXFFLUXQYJUXEUVAUXQYIUXDXCUXQXTUUOXCWMUYAVTVEVSVLVIVJVGVGWMERZU
      WRUUMUXIUVFUYBUWQYQUWIUULUYBUWPWHUIUYBUWOWGWFWMEKVPVQUTUYBUWHUUKFGLLUYBUW
      GUUJHLUYBXKUUIUUDUYBXHUUFXJUUHUYBXHWQUUEWMUKUUFUYBXGUUEWQWMWSXCWMEWAVTWQU
      UEWMEWAWBUYBXJXIXCEUKUUHXIXCWMEWAUYBXIUUGXCEWQWSWMEWAVRWBWCVSVLVNVGUYBUXC
      UUSUXHUVEUYBUXAUURNFMLUYBUWTUUQUUNUYBUWSUUPXCUUOXCWMEWAVEVSVNUYBUXFUVDNFM
      LUYBUXEUVCUVAUYBUXDUVBXCXCUUOWMEWAVEVSVNVGVGWDWE @.
  @}

  @{
    @d C a c d f g h j r @.  @d D a c d f g h j r @.  @d J a c d f j r @.
    @d M c d j r f @.  @d O c d j r @.  @d R a c d f g h j r @.
    @d T c d j r x @.  @d a c d f g h j r x @.
    cati.1 @e |- D = ( dom_ ` T ) @.
    cati.2 @e |- C = ( cod_ ` T ) @.
    cati.3 @e |- J = ( id_ ` T ) @.
    cati.4 @e |- R = ( o_ ` T ) @.
    cati.5 @e |- M = dom D @.
    cati.6 @e |- O = dom J @.
    @( Definitional properties of a category.  (Contributed by FL,
       24-Oct-2007.) @)
    cati @p |- ( T e. CatOLD
       -> ( ( <. <. D , C >. , <. J , R >. >. e. Ded /\
           A. f e. M A. g e. M A. h e. M
              (
                ( ( D ` h ) = ( C ` g ) /\ ( D ` g ) = ( C ` f ) )
              ->
                ( h R ( g R f ) ) = ( ( h R g ) R f )
               ) ) /\
          ( A. a e. O A. f e. M ( ( C ` f ) = a ->
             ( ( J ` a ) R f ) = f ) /\
          A. a e. O A. f e. M ( ( D ` f ) = a ->
             ( f R ( J ` a ) ) = f ) ) ) ) @=
      ( wceq wa wral vx vd vc vj vr ccatOLD wcel cv cop cded cfv co cdm wex cab
      wi df-catOLD eleq2i c1st wb domval eqcomi eqeq2i opeq1 opeq1d eleq1d dmeq
      syl6eqr eleq2d fveq1 eqeq1d anbi12d imbi1d imbi12d ralbidv2 raleqdv sylbi
      ralbidv c2nd codval opeq2 eqeq2d anbi1d idval opeq2d oveq1d imbi2d oveq2d
      2ralbidv cmpval oveq eqtrd eqeq12d eloi ) DUFUGDUAUHUBUHZUCUHZUIZUDUHZUEU
      HZUIZUIZRXAUJUGZGUHZWOUKZFUHZWPUKZRZXEWOUKZEUHZWPUKZRZSZXCXEXIWSULZWSULZX
      CXEWSULZXIWSULZRZUPZGWOUMZTZFXSTZEXSTZSZXJKUHZRZYDWRUKZXIWSULZXIRZUPZEXST
      ZKWRUMZTZXIWOUKZYDRZXIYFWSULZXIRZUPZEXSTZKYKTZSZSZSUEUNUDUNUCUNUBUNUAUOZU
      GBAUIZHCUIZUIZUJUGZXCBUKZXEAUKZRZXEBUKZXIAUKZRZSZXCXEXICULZCULZXCXECULZXI
      CULZRZUPZGITZFITEITZSZUUKYDRZYDHUKZXICULZXIRZUPZEITKJTZXIBUKZYDRZXIUVDCUL
      ZXIRZUPZEITKJTZSZSZUFUUBDUAEFGUDUEKUCUBUQURUUABWPUIZWTUIZUJUGZUUGXFRZUUJX
      JRZSZXQUPZGITZFITZEITZSZYIEITZKYKTZUVJYPUPZEITZKYKTZSZSZUUCWTUIZUJUGZUUMX
      QUPZGITZFITEITZSZUVCYHUPZEITZKYKTZUWLSZSZUUCHWSUIZUIZUJUGZUWSSZUVCUVDXIWS
      ULZXIRZUPZEITZKJTZUVJXIUVDWSULZXIRZUPZEITZKJTZSZSZUVPUAUBUCUEUDDWODUSUKZU
      SUKZRWOBRZUUAUWNUTUYCBWOBUYCBDLVAVBVCUYDYCUWGYTUWMUYDXBUVSYBUWFUYDXAUVRUJ
      UYDWQUVQWTWOBWPVDVEVFUYDYAUWEEXSIUYDXIXSUGZXIIUGZYAUWEUYDXSIXIUYDXSBUMIWO
      BVGPVHZVIZUYDXTUWDFXSIUYDXEXSUGXEIUGXTUWDUYDXSIXEUYGVIUYDXRUWCGXSIUYDXCXS
      UGXCIUGXRUWCUYDXSIXCUYGVIUYDXLUWBXQUYDXGUVTXKUWAUYDXDUUGXFXCWOBVJVKUYDXHU
      UJXJXEWOBVJVKVLVMVNVOVNVOVNVOVLUYDYLUWIYSUWLUYDYJUWHKYKUYDYIEXSIUYGVPVRUY
      DYRUWKKYKUYDYQUWJEXSIUYDUYEUYFYQUWJUYHUYDYNUVJYPUYDYMUVIYDXIWOBVJVKVMVNVO
      VRVLVLVQWPUYBVSUKZRWPARZUWNUXEUTUYIAWPAUYIADMVTVBVCUYJUWGUWTUWMUXDUYJUVSU
      WPUWFUWSUYJUVRUWOUJUYJUVQUUCWTWPABWAVEVFUYJUWDUWREFIIUYJUWCUWQGIUYJUWBUUM
      XQUYJUVTUUIUWAUULUYJXFUUHUUGXEWPAVJWBUYJXJUUKUUJXIWPAVJZWBVLVMVRWIVLUYJUW
      IUXCUWLUYJYIUXAKEYKIUYJYEUVCYHUYJXJUUKYDUYKVKVMWIWCVLVQWRDVSUKZUSUKZRWRHR
      ZUXEUYAUTUYMHWRHUYMDHNWDVBVCUYNUWTUXIUXDUXTUYNUWPUXHUWSUYNUWOUXGUJUYNWTUX
      FUUCWRHWSVDWEVFWCUYNUXCUXNUWLUXSUYNUXBUXMKYKJUYNYDYKUGZYDJUGZUXBUXMUYNYKJ
      YDUYNYKHUMJWRHVGQVHVIZUYNUXAUXLEIUYNYHUXKUVCUYNYGUXJXIUYNYFUVDXIWSYDWRHVJ
      ZWFVKWGVRVNVOUYNUWKUXRKYKJUYNUYOUYPUWKUXRUYQUYNUWJUXQEIUYNYPUXPUVJUYNYOUX
      OXIUYNYFUVDXIWSUYRWHVKWGVRVNVOVLVLVQWSUYLVSUKZRWSCRZUYAUVPUTUYSCWSCUYSDCO
      WJVBVCUYTUXIUVBUXTUVOUYTUXHUUFUWSUVAUYTUXGUUEUJUYTUXFUUDUUCWSCHWAWEVFUYTU
      WRUUTEFIIUYTUWQUUSGIUYTXQUURUUMUYTXNUUOXPUUQUYTXNXCUUNWSULUUOUYTXMUUNXCWS
      XEXIWSCWKWHXCUUNWSCWKWLUYTXPUUPXIWSULUUQUYTXOUUPXIWSXCXEWSCWKWFUUPXIWSCWK
      WLWMWGVRWIVLUYTUXNUVHUXSUVNUYTUXLUVGKEJIUYTUXKUVFUVCUYTUXJUVEXIUVDXIWSCWK
      VKWGWIUYTUXQUVMKEJIUYTUXPUVLUVJUYTUXOUVKXIXIUVDWSCWKVKWGWIVLVLVQWNVQ @.
  @}

  @( Lemma for ~ 0ded .  (Contributed by FL, 10-Jan-2008.) @)
  0alg @p |- <. <. (/) , (/) >. , <. (/) , (/) >. >. e. Alg @=
    ( c0 cop calg wcel wf w3a wfun cdm cxp wss crn f0 3pm3.2i fun0 ssid 3sstr4i
    dm0 0xp cvv 0ex rn0 eqimssi wa wb eqcomi isalg mp2an mpbir2an ) AABZUIBCDZ
    AAAEZUKUKFZAGZAHZAAIZJZAKZAJZFZUKUKUKALZUTUTMUMUPURNAAUNUOAOQARPUQAUAUBMASD
    ZVAVAFVAUJULUSUCUDVAVAVATTTMTSSAAASSAAAUNAQUEZVBUFUGUH @.

  @{
    @d a f g @.
    @( A deductive system with no object and no morphism.  (Contributed by FL,
       10-Jan-2008.) @)
    0ded @p |- <. <. (/) , (/) >. , <. (/) , (/) >. >. e. Ded @=
      ( va vg vf c0 cop wcel cv cfv wceq wa wral wb w3a pm2.21i dm0 eleq2s rgen
      wi cvv 0ex cded calg cdm co 0alg noel 3pm3.2i pm3.2i isded mp2an mpbir2an
      eqid ) DDEZUMEZUAFZUNUBFZAGZDHDHUQIZURJZADUCZKZBGZCGZEUTFVBDHZVCDHZIZLBUT
      KZCUTKZMZVFVBVCDUDDHZVEIRBUTKZCUTKZVFVJVDIRBUTKZCUTKZJZUPVAVHUEUSAUTUSUQD
      UTUQDFUSUQUFNOPQVGCUTVGVCDUTVCDFZVGVCUFZNOPQUGVLVNVKCUTVKVCDUTVPVKVQNOPQV
      MCUTVMVCDUTVPVMVQNOPQUHDSFZVRVRMVRUOVIVOJLVRVRVRTTTUGTSSDDDCBSSDUTUTAUTUL
      ZVSUIUJUK @.
  @}

  @{
    @d a f g h @.
    @( Category ` 0 ` has no object and no morphism.  (Contributed by FL,
       10-Jan-2008.) @)
    0catOLD @p |- <. <. (/) , (/) >. , <. (/) , (/) >. >. e. CatOLD @=
      ( vh vg vf va c0 cop wcel cv cfv wceq wa wral pm2.21i dm0 eleq2s rgen cvv
      co wi 0ex ccatOLD cded cdm 0ded noel pm3.2i w3a wb 3pm3.2i iscatOLD mp2an
      eqid mpbir2an ) EEFZUNFZUAGZUOUBGZAHZEIBHZEIZJUTCHZEIZJKURUSVAERERURUSERV
      AERJSAEUCZLBVCLZCVCLZKZVBDHZJZVGEIZVAERVAJSCVCLZDVCLZVHVAVIERVAJSCVCLZDVC
      LZKZUQVEUDVDCVCVDVAEVCVAEGVDVAUEMNOPUFVKVMVJDVCVJVGEVCVGEGZVJVGUEZMNOPVLD
      VCVLVGEVCVOVLVPMNOPUFEQGZVQVQUGVQUPVFVNKUHVQVQVQTTTUITQQEEECBAQQEVCVCDVCU
      LZVRUJUKUM @.
  @}

  @{
    @d A u x y z @.
    1cat.1 @e |- A e. _V @.
    @( Category ` 1 ` has one object and one morphism.  (Contributed by FL,
       30-Oct-2007.) @)
    1cat @p |- <. <. { <. <. A , A >. , A >. } ,
     { <. <. A , A >. , A >. } >. , <. { <. A , <. A , A >. >. } ,
     { <. <. <. A , A >. , <. A , A >. >. , <. A , A >. >. } >. >.
     e. CatOLD @=
      ( vu vz vy vx cop csn wcel cv cfv wceq wa co wral elsni id eqcomd oveq12d
      cvv ccatOLD cded wi 1ded w3a df-ov opex eqtr2i eqtri oveq12i a1i 3ad2ant3
      3ad2ant2 3ad2ant1 oveq1d oveq2d 3eqtrd eqeq12d syl5ib syl3an rgen3 pm3.2i
      fvsn oveq1i adantr fveq2d adantl syl2an oveq2i wb snex 3pm3.2i cdm dmsnop
      rgen2 eqcomi iscatOLD mp2an mpbir2an ) AAGZAGZHZWBGAVTGZHZVTVTGZVTGZHZGGZ
      UAIZWHUBIZCJZWBKDJZWBKZLWMEJZWBKZLMZWKWLWNWGNZWGNZWKWLWGNZWNWGNZLZUCZCVTH
      ZODXCOEXCOZMZWOFJZLZXFWDKZWNWGNZWNLZUCZEXCOFAHZOZXGWNXHWGNZWNLZUCZEXCOFXL
      OZMZWJXDABUDXBEDCXCXCXCWNXCIZWNVTLZWLXCIWLVTLZWKXCIWKVTLZXBWNVTPZWLVTPWKV
      TPWPVTVTVTWGNZWGNZYDVTWGNZLZXTYAYBUEZXAYGWPVTYDYDVTWGYDWEWGKZVTVTVTWGUFZW
      EVTVTVTUGAAUGZVCZUHYDYIVTYJYLUIZUJUKYHYEWRYFWTYHVTWKYDWQWGYBXTVTWKLYAYBWK
      VTYBQRZULYHVTWLVTWNWGYAXTVTWLLYBYAWLVTYAQRZUMXTYAVTWNLZYBXTWNVTXTQRZUNSSY
      HYFWKVTWGNZVTWGNZWSVTWGNZWTYBXTYFYSLYAYBYDYRVTWGYBVTWKVTWGYNUOUOULYAXTYSY
      TLYBYAYRWSVTWGYAVTWLWKWGYOUPUOUMXTYAYTWTLYBXTVTWNWSWGYQUPUNUQURUSUTVAVBXM
      XQXKFEXLXCXFXLIZXFALZXTXKXSXFAPZYCXGAWDKZVTWGNZVTLZUUBXTMZXJUUFXGUUEYDVTU
      UDVTVTWGAVTBYKVCZVDYMUIUKUUGUUEXIVTWNUUGUUDXHVTWNWGUUGAXFWDUUBAXFLXTUUBXF
      AUUBQRVEVFZXTYPUUBYQVGZSUUJURUSVHVOXPFEXLXCUUAUUBXTXPXSUUCYCXGVTUUDWGNZVT
      LZUUGXOUULXGUUKYDVTUUDVTVTWGUUHVIYMUIUKUUGUUKXNVTWNUUGVTWNUUDXHWGUUJUUISU
      UJURUSVHVOVBWBTIZUUMWDTIZUEWGTIWIXEXRMVJUUMUUMUUNWAVKZUUOWCVKVLWFVKTTWBWB
      WGEDCTTWDXCXLFWBVMXCVTABVNVPWDVMXLAVTYKVNVPVQVRVS @.
  @}

  @{
    @d f g t u v w x y z @.
    @( Structure of a category.  (Contributed by FL, 26-Oct-2007.) @)
    strcat @p |- CatOLD C_ ( ( _V X. _V ) X. ( _V X. _V ) ) @=
      ( vx vg vf vv vu vw vz vy vt cv cop wceq cfv wa co wi cdm wral wex cvv
      ccatOLD cded wcel cab cxp df-catOLD stcat eqsstri ) UAAJBJZCJZKDJZEJZKKZL
      UMUBUCFJZUIMGJZUJMLUOUIMHJZUJMZLNUNUOUPULOULOUNUOULOUPULOLPFUIQZRGURRHURR
      NUQIJZLUSUKMZUPULOUPLPHURRIUKQZRUPUIMUSLUPUTULOUPLPHURRIVARNNZNESDSCSBSAU
      DTTUEZVCUEAHGFDEICBUFVBABCEDUGUH @.
  @}

  @( A category is a relation.  (Contributed by FL, 26-Oct-2007.) @)
  relcat @p |- Rel CatOLD @=
    ( ccatOLD wrel cvv cxp wss strcat xpss sstri df-rel mpbir ) ABACCDZEAKKDKFK
    KGHAIJ @.

  @( The domain of a category is a relation.  (Contributed by FL,
     26-Oct-2007.) @)
  reldcat @p |- Rel dom CatOLD @=
    ( ccatOLD cdm wrel cvv cxp strcat dmss ax-mp dmxpid sseqtri df-rel mpbir
    wss ) ABZCNDDEZMNOOEZBZOAPMNQMFAPGHOIJNKL @.

  @( The range of a category is a relation.  (Contributed by FL,
     26-Oct-2007.) @)
  relrcat @p |- Rel ran CatOLD @=
    ( ccatOLD crn wrel cvv cxp strcat rnss ax-mp rnxpid sseqtri df-rel mpbir
    wss ) ABZCNDDEZMNOOEZBZOAPMNQMFAPGHOIJNKL @.

  @{
    @d T w x y z @.
    @( A category is a deductive system.  (Contributed by FL, 26-Oct-2007.) @)
    catded @p |- ( T e. CatOLD -> T e. Ded ) @=
      ( vz vy vx vw ccatOLD cfv cop c1st c2nd wrel cdm wceq opeq12i cv wa co wi
      eqid wral wcel cdom_ cid_ co_ cded crn w3a relcat reldcat relrcat 3pm3.2i
      ccod_ 11st22nd mpan domval codval idval cmpval syl6eqr simpld eqeltrd
      cati ) AFUAZAAUBGZAULGZHZAUCGZAUDGZHZHZUEVCAAIGZIGZVKJGZHZAJGZIGZVOJGZHZH
      ZVJFKZFLKZFUFKZUGVCAVSMVTWAWBUHUIUJUKAFUMUNVFVNVIVRVDVLVEVMVDAVDSZUOVEAVE
      SZUPNVGVPVHVQAVGVGSZUQAVHVHSZURNNUSVCVJUEUAZBOZVDGCOZVEGMWIVDGDOZVEGZMPWH
      WIWJVHQVHQWHWIVHQWJVHQMRBVDLZTCWLTDWLTZVCWGWMPWKEOZMWNVGGZWJVHQWJMRDWLTEV
      GLZTWJVDGWNMWJWOVHQWJMRDWLTEWPTPVEVDVHADCBVGWLWPEWCWDWEWFWLSWPSVBUTUTVA
      @.
  @}

  @{
    cat.1 @e |- M = dom D @.
    cat.3 @e |- D = ( dom_ ` T ) @.
    @{
      cat.2 @e |- O = dom J @.
      cat.5 @e |- J = ( id_ ` T ) @.
      @{
        @( The 1st "axiom" of a category: ` ( dom_ `` T ) ` is a mapping from
           the morphisms of ` T ` to the objects of ` T ` .  (Contributed by
           FL, 2-Jan-2008.) @)
        domc @p |- ( T e. CatOLD -> D : M --> O ) @=
          ( ccatOLD wcel cded calg wf catded dedalg doma 3syl ) BJKBLKBMKDEANBO
          BPABCDEFGHIQR @.
      @}

      @{
        cat.4 @e |- C = ( cod_ ` T ) @.
        @( The 2nd "axiom" of a category ` ( cod_ `` T ) ` is a mapping from
           the morphisms of ` T ` to the objects of ` T ` .  (Contributed by
           FL, 2-Jan-2008.) @)
        codc @p |- ( T e. CatOLD -> C : M --> O ) @=
          ( ccatOLD wcel cded calg wf catded dedalg coda 3syl ) CLMCNMCOMEFAPCQ
          CRABCDEFGHIJKST @.
      @}

      @{
        @( The 3rd "axiom" of a category ` ( id_ `` T ) ` is a mapping from the
           objects of ` T ` to the morphisms of ` T ` .  (Contributed by FL,
           5-Dec-2007.) @)
        idc @p |- ( T e. CatOLD -> J : O --> M ) @=
          ( ccatOLD wcel cded calg wf catded dedalg ida 3syl ) BJKBLKBMKEDCNBOB
          PABCDEFGHIQR @.
      @}
    @}

    @{
      cat.6 @e |- R = ( o_ ` T ) @.
      @( The 4th "axiom" of a category: ` ( o_ `` T ) ` is a partial operation
         from the morphisms of ` T ` to the morphisms of ` T ` .  (Contributed
         by FL, 10-Mar-2008.) @)
      cmppfc @p |- ( T e. CatOLD ->
        ( Fun R /\ dom R C_ ( M X. M ) /\ ran R C_ M ) ) @=
        ( ccatOLD wcel cded calg wfun cdm cxp wss crn w3a catded dedalg cmppfa
        3syl ) CHICJICKIBLBMDDNOBPDOQCRCSABCDEFGTUA @.
    @}
  @}

  @{
    idosc.1 @e |- O = dom J @.
    idosc.2 @e |- D = ( dom_ ` T ) @.
    idosc.3 @e |- J = ( id_ ` T ) @.
    idosc.4 @e |- C = ( cod_ ` T ) @.
    @( The 5th "axiom" of a category: identities are morphisms whose domains
       and codomains are equal.  (Contributed by FL, 5-Dec-2007.) @)
    idosc @p |- ( ( T e. CatOLD /\ A e. O ) -> ( ( D ` ( J ` A ) ) = A /\
        ( C ` ( J ` A ) ) = A ) ) @=
      ( ccatOLD wcel cded cfv wceq wa catded idosd sylan ) DKLDMLAFLAENZCNAOTBN
      AOPDQABCDEFGHIJRS @.
  @}

  @{
    cmppfcd.1 @e |- M = dom D @.
    cmppfcd.2 @e |- D = ( dom_ ` T ) @.
    cmppfcd.3 @e |- C = ( cod_ ` T ) @.
    cmppfcd.4 @e |- R = ( o_ ` T ) @.
    @( The 6th "axiom" of a category: ` ( G ( o_ `` T ) F ) ` is only defined
       when the domain of ` F ` equals the codomain of ` G ` .  (Contributed by
       FL, 10-Mar-2008.) @)
    cmppfcd @p |- ( ( T e. CatOLD /\ F e. M /\ G e. M ) ->
           ( <. G , F >. e. dom R <-> ( D ` G ) = ( C ` F ) ) ) @=
      ( ccatOLD wcel cded cop cdm cfv wceq wb catded cmppfd syl3an1 ) DLMDNMEGM
      FGMFEOCPMFBQEAQRSDTABCDEFGHIJKUAUB @.

    @( The 7th "axiom" of a category: when ` ( G ( o_ `` T ) F ) ` is defined
       its domain is the domain of ` F ` .  (Contributed by FL,
       10-Mar-2008.) @)
    domcmpc @p |- ( ( T e. CatOLD /\ F e. M /\ G e. M ) ->
        ( ( D ` G ) = ( C ` F ) -> ( D ` ( G R F ) ) = ( D ` F ) ) ) @=
      ( ccatOLD wcel cded cfv wceq co wi catded domcmpd syl3an1 ) DLMDNMEGMFGMF
      BOEAOPFECQBOEBOPRDSABCDEFGHIJKTUA @.

    @( The 8th "axiom" of a category: when ` ( G ( o_ `` T ) F ) ` is defined
       its codomain is the codomain of ` G ` .  (Contributed by FL,
       10-Jan-2008.) @)
    codcmpc @p |- ( ( T e. CatOLD /\ F e. M /\ G e. M ) ->
              ( ( D ` G ) = ( C ` F )
              -> ( C ` ( G R F ) ) = ( C ` G ) ) ) @=
      ( ccatOLD wcel cded cfv wceq co wi catded codcmpd syl3an1 ) DLMDNMEGMFGMF
      BOEAOPFECQAOFAOPRDSABCDEFGHIJKTUA @.
  @}

  @{
    @d C f g h x @.  @d D f g h x @.  @d F f g h @.  @d G g h @.  @d H h @.
    @d M f g h @.  @d R f g h x @.  @d T f x @.
    cmpasso.1 @e |- M = dom D @.
    cmpasso.2 @e |- D = ( dom_ ` T ) @.
    cmpasso.5 @e |- C = ( cod_ ` T ) @.
    cmpasso.6 @e |- R = ( o_ ` T ) @.
    @( The 9th "axiom" of a category: ` ( o_ `` T ) ` is associative.
       (Contributed by FL, 29-Oct-2007.) @)
    cmpasso @p |- ( ( T e. CatOLD /\ ( F e. M /\ G e. M /\ H e. M ) ) ->
              (
                ( ( D ` H ) = ( C ` G ) /\
                ( D ` G ) = ( C ` F ) )
              ->
                ( H R ( G R F ) ) =
                  ( ( H R G ) R F )
               ) ) @=
      ( vf wcel cfv wceq wa co wi wral vh vg ccatOLD w3a cop cid_ cded cdm eqid
      vx cv cati fveq2 eqeq2d anbi2d oveq2 oveq2d eqeq12d imbi12d anbi12d oveq1
      eqeq1d oveq1d anbi1d rspc3v com12 ad2antlr syl imp ) DUCNZEHNFHNGHNUDZGBO
      ZFAOZPZFBOZEAOZPZQZGFECRZCRZGFCRZECRZPZSZVJBAUEDUFOZCUEUEUGNZUAUKZBOZUBUK
      ZAOZPZWIBOZMUKZAOZPZQZWGWIWMCRZCRZWGWICRZWMCRZPZSZUAHTUBHTMHTZQWNUJUKZPXD
      WEOZWMCRWMPSMHTUJWEUHZTWMBOXDPWMXECRWMPSMHTUJXFTQZQVKWDSZABCDMUBUAWEHXFUJ
      JKWEUILIXFUIULXCXHWFXGVKXCWDXBWDWKWLVPPZQZWGWIECRZCRZWSECRZPZSWHVMPZVQQZW
      GVSCRZWGFCRZECRZPZSMUBUAEFGHHHWMEPZWPXJXAXNYAWOXIWKYAWNVPWLWMEAUMUNUOYAWR
      XLWTXMYAWQXKWGCWMEWICUPUQWMEWSCUPURUSWIFPZXJXPXNXTYBWKXOXIVQYBWJVMWHWIFAU
      MUNYBWLVOVPWIFBUMVBUTYBXLXQXMXSYBXKVSWGCWIFECVAUQYBWSXRECWIFWGCUPVCURUSWG
      GPZXPVRXTWCYCXOVNVQYCWHVLVMWGGBUMVBVDYCXQVTXSWBWGGVSCVAYCXRWAECWGGFCVAVCU
      RUSVEVFVGVHVI @.
  @}

  @{
    @d A a f @.  @d C a f x y @.  @d D a f x y @.  @d F f @.  @d J a f @.
    @d M a f @.  @d O a @.  @d R a f x y @.
    cmpida.1 @e |- M = dom D @.
    cmpida.2 @e |- D = ( dom_ ` T ) @.
    cmpida.3 @e |- O = dom J @.
    cmpida.4 @e |- J = ( id_ ` T ) @.
    cmpida.5 @e |- R = ( o_ ` T ) @.
    cmpida.6 @e |- C = ( cod_ ` T ) @.
    @( The 10th "axiom" of a category: ` ( J `` A ) ` is a left neutral
       element.  (Contributed by FL, 29-Oct-2007.) @)
    cmpida @p |- ( ( T e. CatOLD /\ A e. O /\ F e. M ) -> ( ( C ` F ) = A
         -> ( ( J ` A ) R F ) = F ) ) @=
      ( vf cfv wceq co wral vy vx va ccatOLD wcel wi cop cded cv wa eqeq2 fveq2
      cati oveq1d eqeq1d imbi12d oveq2 eqeq12d rspc2v com12 ad2antrl syl 3impib
      id ) EUDUEZAIUEZFHUEZFBQZARZAGQZFDSZFRZUFZVECBUGGDUGUGUHUEUAUIZCQUBUIZBQR
      VOCQPUIZBQZRUJVNVOVPDSDSVNVODSVPDSRUFUAHTUBHTPHTUJZVQUCUIZRZVSGQZVPDSZVPR
      ZUFZPHTUCITZVPCQVSRVPWADSVPRUFPHTUCITZUJUJVFVGUJZVMUFZBCDEPUBUAGHIUCKOMNJ
      LUMWEWHVRWFWGWEVMWDVMVQARZVJVPDSZVPRZUFUCPAFIHVSARZVTWIWCWKVSAVQUKWLWBWJV
      PWLWAVJVPDVSAGULUNUOUPVPFRZWIVIWKVLWMVQVHAVPFBULUOWMWJVKVPFVPFVJDUQWMVDUR
      UPUSUTVAVBVC @.
  @}

  @{
    @d A a f @.  @d D a f x y @.  @d F f @.  @d J a f @.  @d M a f @.
    @d O a @.  @d R a f x y @.  @d T a f x y @.
    cmpidb.1 @e |- M = dom D @.
    cmpidb.2 @e |- D = ( dom_ ` T ) @.
    cmpidb.3 @e |- O = dom J @.
    cmpidb.4 @e |- J = ( id_ ` T ) @.
    cmpidb.5 @e |- R = ( o_ ` T ) @.
    @( The 11th "axiom" of a category: ` ( J `` A ) ` is a right neutral
       element.  (Contributed by FL, 24-Oct-2007.) @)
    cmpidb @p |- ( ( T e. CatOLD /\ A e. O /\ F e. M ) -> ( ( D ` F ) = A
         -> ( F R ( J ` A ) ) = F ) ) @=
      ( vf va cfv wceq co wi wral vy vx ccatOLD wcel ccod_ cded cv wa eqid cati
      cop eqeq2 fveq2 oveq2d eqeq1d imbi12d oveq1 eqeq12d rspc2v com12 ad2antll
      id syl 3impib ) DUCUDZAHUDZEGUDZEBPZAQZEAFPZCRZEQZSZVEBDUEPZUKFCUKUKUFUDU
      AUGZBPUBUGZVNPQVPBPNUGZVNPZQUHVOVPVQCRCRVOVPCRVQCRQSUAGTUBGTNGTUHZVROUGZQ
      VTFPZVQCRVQQSNGTOHTZVQBPZVTQZVQWACRZVQQZSZNGTOHTZUHUHVFVGUHZVMSZVNBCDNUBU
      AFGHOJVNUILMIKUJWHWJVSWBWIWHVMWGVMWCAQZVQVJCRZVQQZSONAEHGVTAQZWDWKWFWMVTA
      WCULWNWEWLVQWNWAVJVQCVTAFUMUNUOUPVQEQZWKVIWMVLWOWCVHAVQEBUMUOWOWLVKVQEVQE
      VJCUQWOVBURUPUSUTVAVCVD @.
  @}

  @{
    dmo.1 @e |- M = dom ( dom_ ` T ) @.
    dmo.3 @e |- O = dom ( id_ ` T ) @.

    @{
      dmo.2 @e |- D = ( dom_ ` T ) @.
      @( The domain of a morphism is an object.  (Contributed by FL,
         2-Jan-2008.) @)
      dmo @p |- ( ( T e. CatOLD /\ F e. M ) -> ( D ` F ) e. O ) @=
        ( ccatOLD wcel wf cfv cid_ cdom_ cdm eqcomi dmeqi eqtri eqid domc sylan
        ffvelrn ) BIJDEAKCDJCALEJABBMLZDEDBNLZOAOFUDAAUDHPQRHGUCSTDECAUBUA @.

    @}

    @{
      cdmo.2 @e |- C = ( cod_ ` T ) @.
      @( The codomain of a morphism is an object.  (Contributed by FL,
         2-Jan-2008.) @)
      cdmo @p |- ( ( T e. CatOLD /\ F e. M ) -> ( C ` F ) e. O ) @=
        ( ccatOLD wcel wf cfv cdom_ cid_ eqid codc ffvelrn sylan ) BIJDEAKCDJCA
        LEJABMLZBBNLZDEFSOGTOHPDECAQR @.
    @}

    @{
      jdmo.2 @e |- J = ( id_ ` T ) @.
      @( An identity is a morphism.  (Contributed by FL, 10-Jan-2008.) @)
      jdmo @p |- ( ( T e. CatOLD /\ A e. O ) -> ( J ` A ) e. M ) @=
        ( ccatOLD wcel wf cfv cdom_ eqid cid_ cdm dmeqi eqtr4i idc ffvelrn
        sylan ) BIJEDCKAEJACLDJBMLZBCDEFUBNEBOLZPCPGCUCHQRHSEDACTUA @.
    @}

  @}

  @{
    cmpmorp.1 @e |- M = dom ( dom_ ` T ) @.
    cmpmorp.2 @e |- D = ( dom_ ` T ) @.
    cmpmorp.3 @e |- C = ( cod_ ` T ) @.
    cmpmorp.4 @e |- R = ( o_ ` T ) @.
    @( Conditions for a composite to be a morphism.  (Contributed by FL,
       10-Mar-2008.) @)
    cmpmorp @p |- ( ( T e. CatOLD /\ F e. M /\ G e. M ) ->
      ( ( D ` G ) = ( C ` F ) -> ( G R F ) e. M ) ) @=
      ( ccatOLD wcel w3a cfv wceq co cdm wa wss crn wfun cop cxp cdom_ 3ad2ant1
      eqid cmppfc simp1d adantr eqcomi dmeqi eqtri cmppfcd biimpar fnovrn2 syl6
      jca ex simp3d sseld syld ) DLMZEGMZFGMZNZFBOEAOPZFECQZCUAZMZVHGMVFVGCUBZF
      EUCCRZMZSZVJVFVGVNVFVGSVKVMVFVKVGVFVKVLGGUDTZVIGTZVCVDVKVOVPNVEDUEOZCDGHV
      QUGKUHUFZUIUJVFVMVGABCDEFGGVQRBRHVQBBVQIUKULUMIJKUNUOURUSFECUPUQVFVIGVHVF
      VKVOVPVRUTVAVB @.
  @}

  @( Two ways to define the set of the morphisms of a category.  (Contributed
     by FL, 19-Sep-2009.) @)
  morcat @p |- ( T e. CatOLD -> dom ( dom_ ` T ) = dom ( cod_ ` T ) ) @=
    ( ccatOLD wcel cdom_ cfv cdm cid_ ccod_ wf wceq eqid codc fdm eqcomd syl )
    ABCADEZFZAGEZFZAHEZIZQTFZJTPARQSQKPKSKRKTKLUAUBQQSTMNO @.

  @{
    cmppfc1.1 @e |- R = ( o_ ` T ) @.
    @( Composition is a function.  (Contributed by FL, 5-Oct-2009.) @)
    cmppfc1 @p |- ( T e. CatOLD -> Fun R ) @=
      ( ccatOLD wcel wfun cdm cdom_ cfv cxp wss crn eqid cmppfc simp1d ) BDEAFA
      GBHIZGZQJKALQKPABQQMPMCNO @.

  @}

  @{
    dualcat2.1 @e |- D = ( dom_ ` T ) @.
    dualcat2.2 @e |- C = ( cod_ ` T ) @.
    dualcat2.3 @e |- J = ( id_ ` T ) @.
    dualcat2.4 @e |- R = ( o_ ` T ) @.
    @{
      @d C w x y z @.  @d R w x y z @.  @d T x y z @.
      @( The dual of a ` Alg ` is a ` Alg ` .  (Contributed by FL,
         18-Apr-2010.)  (Proof shortened by Mario Carneiro, 10-Sep-2015.) @)
      dualalg @p |- ( T e. Alg ->
        <. <. C , D >. , <. J , tpos R >. >. e. Alg ) @=
        ( wcel cop cdm wf w3a wss syl cvv cfv fvex eqeltri calg ctpos wfun eqid
        cxp crn coda dcsda feq2d mpbid doma ida wceq wb feq3 3jca cmppfa simp1d
        tposfun ccnv simp2d cnvss wrel relxp relss dmtpos cnvxp xpeq12d syl5req
        ee10 3sstr4d rntpos simp3d sseqtrd eqsstrd ccod_ cdom_ cid_ 3pm3.2i co_
        wa tposex pm3.2i isalg mp1i mpbir2and ) DUAJZABKECUBZKKUAJZALZELZAMZWJW
        KBMZWKWJEMZNZWHUCZWHLZWJWJUEZOZWHUFZWJOZNZWGWLWMWNWGBLZWKAMWLABDEXCWKXC
        UDZFWKUDZHGUGWGXCWJWKAABDFGUHZUIUJWGXCWKBMWMBDEXCWKXDFXEHUKWGXCWJWKBXFU
        IUJWGWKXCEMZWNBDEXCWKXDFXEHULWGXCWJUMXGWNUNXFXCWJWKEUOPUJUPWGWPWSXAWGCU
        CZWPWGXHCLZXCXCUEZOZCUFZXCOZBCDXCXDFIUQZURCUSPWGXIUTZXJUTZWQWRWGXKXOXPO
        WGXHXKXMXNVAZXIXJVBPWGXIVCZWQXOUMWGXKXJVCXRXQXCXCVDXIXJVEVJZCVFPWGXPXJW
        RXCXCVGWGXCWJXCWJXFXFVHVIVKWGWTXLWJWGXRWTXLUMXSCVLPWGXLXCWJWGXHXKXMXNVM
        XFVNVOUPAQJZBQJZEQJZNZWHQJZWAWIWOXBWAUNWGYCYDXTYAYBADVPRQGDVPSTBDVQRQFD
        VQSTEDVRRQHDVRSTVSCCDVTRQIDVTSTWBWCQQBAWHQQEWJWKWJUDXEWDWEWF @.
    @}

    @{
      @d C a f g @.  @d C f g x y z @.  @d D a f g @.  @d D f g x y z @.
      @d J a @.  @d R f g x y z @.  @d T a f g @.  @d T f g x y z @.
      @( The dual of a deductive system is a deductive system.  (Contributed by
         FL, 18-Apr-2010.)  (Proof shortened by Mario Carneiro,
         10-Sep-2015.) @)
      dualded @p |- ( T e. Ded ->
        <. <. C , D >. , <. J , tpos R >. >. e. Ded ) @=
        ( va vg vf wcel cop cfv wceq wa cdm wral cvv cded ctpos cv wb w3a co wi
        calg dedalg dualalg syl eqid idosd ancomd ralrimiva ancom dcsda anbi12d
        eleq2d syl5rbb ccnv wrel cxp wfun cmppfa simp2d relxp relss ee10 dmtpos
        wss crn 3ad2ant1 cmppfd vex opelcnv eqcom bitrd 3expib sylbid ralrimivv
        3bitr4g 3jca codcmpd ovtpos fveq2i eqeq1i 3imtr4g domcmpd ccod_ eqeltri
        jca fvex cdom_ cid_ co_ tposex isded mpan2 mp3an sylanbrc ) DUAMZABNECU
        BZNNZUHMZJUCZEOZAOXFPZXGBOXFPZQZJERZSZKUCZLUCZNZXCRZMZXMAOZXNBOZPZUDZKA
        RZSLYBSZUEZXTXMXNXCUFZAOZXNAOZPZUGZKYBSLYBSZXTYEBOZXMBOZPZUGZKYBSLYBSZQ
        ZXDUAMZXBXEXLYCXBDUHMZXEDUIZABCDEFGHIUJUKXBXJJXKXBXFXKMQXIXHXFABDEXKXKU
        LZFHGUMUNUOXBYALKYBYBXBXNYBMZXMYBMZQZXMBRZMZXNUUDMZQZYAUUGUUFUUEQXBUUCU
        UEUUFUPXBUUFUUAUUEUUBXBUUDYBXNXBYRUUDYBPYSABDFGUQUKZUSXBUUDYBXMUUHUSURU
        TZXBUUEUUFYAXBUUEUUFUEZXQXOCRZVAZMZXTUUJXPUULXOXBUUEXPUULPZUUFXBUUKVBZU
        UNXBUUKUUDUUDVCZVKZUUPVBUUOXBCVDZUUQCVLUUDVKZXBYRUURUUQUUSUEYSBCDUUDUUD
        ULZFIVEUKVFUUDUUDVGUUKUUPVHVICVJUKVMUSUUJXNXMNUUKMXSXRPZUUMXTABCDXMXNUU
        DUUTFGIVNXMXNUUKKVOLVOVPXRXSVQZWBVRVSVTWAWCXBYJYOXBYILKYBYBXBUUCUUGYIUU
        IXBUUEUUFYIUUJUVAXNXMCUFZAOZYGPXTYHABCDXMXNUUDUUTFGIWDUVBYFUVDYGYEUVCAX
        MXNCWEZWFWGWHVSVTWAXBYNLKYBYBXBUUCUUGYNUUIXBUUEUUFYNUUJUVAUVCBOZYLPXTYM
        ABCDXMXNUUDUUTFGIWIUVBYKUVFYLYEUVCBUVEWFWGWHVSVTWAWLATMZBTMZETMZYQYDYPQ
        UDZADWJOTGDWJWMWKBDWNOTFDWNWMWKEDWOOTHDWOWMWKUVGUVHUVIUEXCTMUVJCCDWPOTI
        DWPWMWKWQTTBAXCLKTTEYBXKJYBULYTWRWSWTXA @.
    @}

    @{
      @d C a f g h x y z @.  @d D a f g h x y z @.  @d J a f x y z @.
      @d R a f g h x y z @.  @d T a f g h x y z @.
      @( The dual of a category is a category.  Joy of cats 3.5 (Contributed by
         FL, 4-Apr-2010.)  (Proof shortened by Mario Carneiro, 10-Sep-2015.) @)
      dualcat2 @p |- ( T e. CatOLD ->
      <. <. C , D >. , <. J , tpos R >. >. e. CatOLD ) @=
        ( vf va wcel cfv wceq wa co wral w3a ovtpos cvv vh vg ccatOLD cop ctpos
        cded cv wi cdm catded dualded 3anrev calg dedalg dcsda eleq2d 3anbi123d
        syl 3syl syl5bb biimpar eqid cmpasso eqcom anbi12i oveq1i eqtri eqeq12i
        oveq2i 3imtr4g ancom syldan ralrimivvva jca anbi2d cmpidb eqeq1i 3expib
        syl6ibr sylbird ralrimivv cmpida wb ccod_ fvex eqeltri cdom_ co_ tposex
        cid_ iscatOLD mpan2 mp3an sylanbrc ) DUCLZABUDECUEZUDUDZUFLZUAUGZAMZUBU
        GZBMZNZXAAMZJUGZBMZNZOZWSXAXEWPPZWPPZWSXAWPPZXEWPPZNZUHZUAAUIZQUBXOQJXO
        QZOZXFKUGZNZXREMZXEWPPZXENZUHZJXOQKEUIZQZXEAMXRNZXEXTWPPZXENZUHZJXOQKYD
        QZOZWQUCLZWOWRXPWODUFLZWRDUJZABCDEFGHIUKURWOXNJUBUAXOXOXOWOXEXOLZXAXOLZ
        WSXOLZRZWSBUIZLZXAYSLZXEYSLZRZXNWOUUCYRUUCUUBUUAYTRWOYRYTUUAUUBULWOUUBY
        OUUAYPYTYQWOYSXOXEWOYMDUMLYSXONYNDUNABDFGUOUSZUPZWOYSXOXAUUDUPWOYSXOWSU
        UDUPUQUTVAWOUUCOZXGXCOZXLXJNZXHXMUUFXFXDNZXBWTNZOXEXAWSCPZCPZXEXACPZWSC
        PZNUUGUUHABCDWSXAXEYSYSVBZFGIVCXGUUIXCUUJXDXFVDWTXBVDVEXLUULXJUUNXLUUKX
        EWPPUULXKUUKXEWPWSXACSVFUUKXECSVGXJWSUUMWPPUUNXIUUMWSWPXAXECSVIWSUUMCSV
        GVHVJXCXGVKXJXLVDVJVLVMVNWOYEYJWOYCKJYDXOWOXRYDLZYOOZUUPUUBOZYCWOUUBYOU
        UPUUEVOZWOUUPUUBYCWOUUPUUBRZXSXEXTCPZXENYBXRBCDXEEYSYDUUOFYDVBZHIVPYAUV
        AXEXTXECSVQVSVRVTWAWOYIKJYDXOWOUUQUURYIUUSWOUUPUUBYIUUTYFXTXECPZXENYHXR
        ABCDXEEYSYDUUOFUVBHIGWBYGUVCXEXEXTCSVQVSVRVTWAVNATLZBTLZETLZYLXQYKOWCZA
        DWDMTGDWDWEWFBDWGMTFDWGWEWFEDWJMTHDWJWEWFUVDUVEUVFRWPTLUVGCCDWHMTIDWHWE
        WFWITTBAWPJUBUATTEXOYDKXOVBUVBWKWLWMWN @.
    @}
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Homsets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c hom @.

  @( Extend class notation with the function returning all the morphisms
     between two objects. @)
  chomOLD @a class hom @.

  @{
    @d x y a b c f @.
    @( ` ( hom `` x ) ` is a function which returns for each pair of objects
       ` <. a , b >. ` the morphisms whose domain is ` a ` and codomain
       ` b ` .  JFM CAT_1 def. 6 (Contributed by FL, 6-May-2007.) @)
    df-homOLD @a |- hom = ( x e. CatOLD |->
     ( a e. dom ( id_ ` x ) , b e. dom ( id_ ` x ) |->
       { f e. dom ( dom_ ` x ) | ( ( ( dom_ ` x ) ` f ) = a /\
                   ( ( cod_ ` x ) ` f ) = b ) } ) ) @.
  @}

  @{
    @d x C @.  @d x D @.  @d f x M @.  @d a b x O @.  @d a b f x T @.
    ishoma.1 @e |- O = dom ( id_ ` T ) @.
    ishoma.2 @e |- M = dom ( dom_ ` T ) @.
    ishoma.3 @e |- D = ( dom_ ` T ) @.
    ishoma.4 @e |- C = ( cod_ ` T ) @.
    @( Definition of ` ( hom `` T ) ` .  (Contributed by FL, 6-May-2007.)
       (Revised by Mario Carneiro, 10-Sep-2015.) @)
    ishoma @p |- ( T e. CatOLD -> ( hom ` T ) = ( a e. O , b e. O |->
      { f e. M | ( ( D ` f ) = a /\ ( C ` f ) = b ) } ) ) @=
      ( vx cv cid_ cfv cdm cdom_ wceq syl6eqr ccod_ wa crab cmpt2 ccatOLD fveq2
      chomOLD dmeqd fveq1d eqeq1d rabeqbidv mpt2eq123dv df-homOLD cvv fvex dmex
      anbi12d eqeltri mpt2ex fvmpt ) MCGHMNZOPZQZVCDNZVARPZPZGNZSZVDVAUAPZPZHNZ
      SZUBZDVEQZUCZUDGHFFVDBPZVGSZVDAPZVKSZUBZDEUCZUDUEUGVACSZGHVCVCVOFFWAWBVCC
      OPZQZFWBVBWCVACOUFUHITZWEWBVMVTDVNEWBVNCRPZQEWBVEWFVACRUFZUHJTWBVHVQVLVSW
      BVFVPVGWBVDVEBWBVEWFBWGKTUIUJWBVJVRVKWBVDVIAWBVICUAPAVACUAUFLTUIUJUQUKULM
      DGHUMGHFFWAFWDUNIWCCOUOUPURZWHUSUT @.
  @}

  @{
    @d f x y A @.  @d f x y B @.  @d x y C @.  @d f x y M @.  @d f x y T @.
    @d x y D @.  @d x y O @.
    ishomb.1 @e |- O = dom ( id_ ` T ) @.
    ishomb.2 @e |- M = dom ( dom_ ` T ) @.
    ishomb.3 @e |- D = ( dom_ ` T ) @.
    ishomb.4 @e |- C = ( cod_ ` T ) @.
    ishomb.5 @e |- H = ( hom ` T ) @.
    ishomb.6 @e |- T e. CatOLD @.
    @( The homset ` ( ( hom `` T ) `` <. A , B >. ) ` .  (Contributed by FL,
       18-May-2007.) @)
    ishomb @p |- ( ( A e. O /\ B e. O ) ->
     ( H ` <. A , B >. ) = { f e. M | ( ( D ` f ) = A /\ ( C ` f ) = B ) } ) @=
      ( vx vy wa cfv wceq wcel cop co crab df-ov eqeq2 bi2anan9 rabbidv chomOLD
      cv cmpt2 ccatOLD ishoma ax-mp eqtri cdom_ cdm cvv fvex dmex eqeltri rabex
      ovmpt2a syl5eqr ) AIUABIUARABUBGSABGUCFUJZDSZATZVECSZBTZRZFHUDZABGUEPQABI
      IVFPUJZTZVHQUJZTZRZFHUDZVKGVLATZVNBTZRVPVJFHVRVMVGVSVOVIVLAVFUFVNBVHUFUGU
      HGEUISZPQIIVQUKZNEULUAVTWATOCDEFHIPQJKLMUMUNUOVJFHHEUPSZUQURKWBEUPUSUTVAV
      BVCVD @.
  @}

  @{
    @d A x @.  @d B x @.  @d M x @.  @d D x @.  @d C x @.  @d T x @.  @d F x @.
    ishomc.1 @e |- O = dom ( id_ ` T ) @.
    ishomc.2 @e |- M = dom ( dom_ ` T ) @.
    ishomc.3 @e |- D = ( dom_ ` T ) @.
    ishomc.4 @e |- C = ( cod_ ` T ) @.
    ishomc.5 @e |- H = ( hom ` T ) @.
    ishomc.6 @e |- T e. CatOLD @.
    @( The predicate ` F e. ( ( hom `` T ) `` <. A , B >. ) ` JFM vol. 1.2
       p. 411 th. 18.  (Contributed by FL, 30-Nov-2007.) @)
    ishomc @p |- ( ( A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) <->
        ( F e. M /\ ( D ` F ) = A /\ ( C ` F ) = B ) ) ) @=
      ( vx wcel wa cfv wceq cop cv w3a ishomb eleq2d fveq2 eqeq1d anbi12d elrab
      crab 3anass bitr4i syl6bb ) AIQBIQRZFABUAGSZQFPUBZDSZATZUPCSZBTZRZPHUJZQZ
      FHQZFDSZATZFCSZBTZUCZUNUOVBFABCDEPGHIJKLMNOUDUEVCVDVFVHRZRVIVAVJPFHUPFTZU
      RVFUTVHVKUQVEAUPFDUFUGVKUSVGBUPFCUFUGUHUIVDVFVHUKULUM @.
  @}

  @{
    ishomd.1 @e |- O = dom ( id_ ` T ) @.
    ishomd.2 @e |- M = dom ( dom_ ` T ) @.
    ishomd.3 @e |- D = ( dom_ ` T ) @.
    ishomd.4 @e |- C = ( cod_ ` T ) @.
    ishomd.5 @e |- H = ( hom ` T ) @.
    @( The predicate ` F e. ( ( hom `` T ) `` <. A , B >. ) ` JFM vol. 1.2
       p. 411 th. 18.  (Contributed by FL, 30-Nov-2007.) @)
    ishomd @p |- ( ( T e. CatOLD /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) <->
        ( F e. M /\ ( D ` F ) = A /\ ( C ` F ) = B ) ) ) @=
      ( wcel cop cfv wceq syl5eq eqid vx ccatOLD w3a wb wa csn cif cid_ chomOLD
      wi cv cdm cdom_ ccod_ fveq2 dmeqd eleq2d anbi12d fveq1d 3anbi123d bibi12d
      eqeq1d imbi12d vex 1cat elimel ishomc dedth 3impib ) EUBOZAIOZBIOZFABPZGQ
      ZOZFHOZFDQZARZFCQZBRZUCZUDZVJVKVLUEZWBUJAVJEUAUKZWDPZWDPUFZWFPWDWEPUFWEWE
      PWEPUFPPZUGZUHQZULZOZBWJOZUEZFVMWHUIQZQZOZFWHUMQZULZOZFWQQZARZFWHUNQZQZBR
      ZUCZUDZUJEWGEWHRZWCWMWBXFXGVKWKVLWLXGIWJAXGIEUHQZULWJJXGXHWIEWHUHUOUPSZUQ
      XGIWJBXIUQURXGVOWPWAXEXGVNWOFXGVMGWNXGGEUIQWNNEWHUIUOSUSUQXGVPWSVRXAVTXDX
      GHWRFXGHEUMQZULWRKXGXJWQEWHUMUOZUPSUQXGVQWTAXGFDWQXGDXJWQLXKSUSVBXGVSXCBX
      GFCXBXGCEUNQXBMEWHUNUOSUSVBUTVAVCABXBWQWHFWNWRWJWJTWRTWQTXBTWNTEWGUBWDUAV
      DVEVFVGVHVI @.
  @}

  @{
    ehm.1 @e |- O = dom ( id_ ` T ) @.
    ehm.2 @e |- M = dom ( dom_ ` T ) @.
    ehm.5 @e |- H = ( hom ` T ) @.
    @( The elements of a homset are morphisms.  JFM CAT_1 th. 21.  (Contributed
       by FL, 5-Dec-2007.) @)
    ehm @p |- ( ( T e. CatOLD /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> F e. M ) ) @=
      ( ccatOLD wcel w3a cop cfv wa cdom_ wceq ccod_ eqid ishomd biimpa simp1d
      ex ) CKLAGLBGLMZDABNEOLZDFLZUEUFPUGDCQOZOARZDCSOZOBRZUEUFUGUIUKMABUJUHCDE
      FGHIUHTUJTJUAUBUCUD @.
  @}

  @{
    dehm.1 @e |- O = dom ( id_ ` T ) @.
    dehm.2 @e |- D = ( dom_ ` T ) @.
    dehm.5 @e |- H = ( hom ` T ) @.
    @( Domain of an element of a homset.  JFM CAT_1 th. 23.  (Contributed by
       FL, 5-Dec-2007.) @)
    dehm @p |- ( ( T e. CatOLD /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( D ` F ) = A ) ) @=
      ( ccatOLD wcel w3a cop cfv wceq wa cdom_ cdm eqid ishomd biimpa simp2d ex
      ccod_ ) DKLAGLBGLMZEABNFOLZECOAPZUFUGQEDROSZLZUHEDUEOZOBPZUFUGUJUHULMABUK
      CDEFUIGHUITIUKTJUAUBUCUD @.
  @}

  @{
    cehm.1 @e |- O = dom ( id_ ` T ) @.
    cehm.2 @e |- C = ( cod_ ` T ) @.
    cehm.5 @e |- H = ( hom ` T ) @.
    @( Codomain of an element of a homset.  JFM CAT_1 th. 23.  (Contributed by
       FL, 5-Dec-2007.) @)
    cehm @p |- ( ( T e. CatOLD /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( C ` F ) = B ) ) @=
      ( ccatOLD wcel w3a cop cfv wceq wa cdom_ cdm eqid ishomd biimpa simp3d ex
      ) DKLAGLBGLMZEABNFOLZECOBPZUEUFQEDROZSZLZEUHOAPZUGUEUFUJUKUGMABCUHDEFUIGH
      UITUHTIJUAUBUCUD @.
  @}

  @{
    mrdmcd.1 @e |- M = dom ( dom_ ` T ) @.
    mrdmcd.2 @e |- H = ( hom ` T ) @.
    mrdmcd.3 @e |- D = ( dom_ ` T ) @.
    mrdmcd.4 @e |- C = ( cod_ ` T ) @.
    @( A morphism belongs to the homset between its domain and its codomain.
       JFM CAT_1 th. 22.  (Contributed by FL, 1-Nov-2007.) @)
    mrdmcd @p |- ( T e. CatOLD -> ( F e. M ->
      F e. ( H ` <. ( D ` F ) , ( C ` F ) >. ) ) ) @=
      ( wcel cfv cdm wa wi syl wf eqid ffvelrn ex ccatOLD cid_ calg cded catded
      cop dedalg cdom_ eqcomi dmeqi eqtri doma coda jcad wceq w3a ishomd 3expib
      biimprcd com3l mp2an com23 mpdd ) CUAKZDFKZDBLZCUBLZMZKZDALZVHKZNZDVFVJUF
      ELKZVDVEVIVKVDCUCKZVEVIOZVDCUDKVNCUECUGPZVNFVHBQZVOBCVGFVHFCUHLZMBMGVRBBV
      RIUIUJUKZIVHRZVGRZULVQVEVIFVHDBSTPPVDVNVEVKOZVPVNFVHAQZWBABCVGFVHVSIVTWAJ
      UMWCVEVKFVHDASTPPUNVDVLVEVMVDVIVKVEVMOZVFVFUOZVJVJUOZVDVIVKUPZWDOVFRVJRVE
      WEWFNWGVMVEWEWFWGVMOWGVMVEWEWFUPVFVJABCDEFVHVTGIJHUQUSURUTVAURVBVC @.
  @}

  @( JFM CAT_1 th. 44.  Not included. use idosd instead @)

  @{
    eqidob.1 @e |- O = dom J @.
    eqidob.2 @e |- J = ( id_ ` C ) @.
    @( When the identities are equal, the objects are equal.  JFM CAT_1 th.
       45.  (Contributed by FL, 24-Apr-2007.) @)
    eqidob @p |- ( ( C e. CatOLD /\ A e. O /\ B e. O ) -> ( ( J ` A ) =
    ( J ` B ) -> A = B ) ) @=
      ( ccatOLD wcel w3a cfv cdom_ wceq ccod_ wa cded catded eqid idosd 3adant3
      3adant2 jca syl3an1 fveq2 wi eqeq12 biimpd ad2ant2r syl2im ) CHIZAEIZBEIZ
      JADKZCLKZKZAMZUMCNKZKAMZOZBDKZUNKZBMZUTUQKBMZOZOZUMUTMUOVAMZABMZUJCPIZUKU
      LVECQVHUKULJUSVDVHUKUSULAUQUNCDEFUNRZGUQRZSTVHULVDUKBUQUNCDEFVIGVJSUAUBUC
      UMUTUNUDUPVBVFVGUEURVCUPVBOVFVGUOAVABUFUGUHUI @.
  @}

  @{
    homib.1 @e |- O = dom ( id_ ` T ) @.
    homib.2 @e |- J = ( id_ ` T ) @.
    homib.3 @e |- H = ( hom ` T ) @.
    @( The homset which ` ( ( id_ `` T ) `` A ) ` belongs to.  JFM CAT_1 th.
       55.  (Contributed by FL, 5-Dec-2007.) @)
    homib @p |- ( ( T e. CatOLD /\ A e. O ) -> ( J ` A ) e.
      ( H ` <. A , A >. ) ) @=
      ( ccatOLD wcel wa cfv cdom_ ccod_ cop cdm eqid jdmo adantr wceq wi mrdmcd
      mpd cid_ idosc eqcomi fveq1i fveq2i eqeq1i biimpi cded catded dmeqi eqtri
      syl idosd ancomd sylan simpld opeq12d fveq2d eleqtrd ) BIJZAEJZKZADLZVFBM
      LZLZVFBNLZLZOZCLZAAOZCLVEVFVGPZJZVFVLJZABDVNEVNQZFGRVCVOVPUAVDVIVGBVFCVNV
      QHVGQZVIQZUBSUCVEVKVMCVEVHAVJAVEABUDLZLZVGLZATZWAVILATZKVHATZAVIVGBVTEFVR
      VTQVSUEWCWEWDWCWEWBVHAWAVFVGAVTDDVTGUFZUGUHUIUJSUOVEVJATZWEVCBUKJZVDWGWEK
      BULWHVDKWEWGAVIVGBDEEVTPDPFVTDWFUMUNVRGVSUPUQURUSUTVAVB @.
  @}

  @{
    hine.1 @e |- O = dom ( id_ ` T ) @.
    hine.2 @e |- H = ( hom ` T ) @.
    @( Obvious.  Only here to have the complete set of Mizar theorems. @)
    @( The homset ` ( H `` <. A , A >. ) ` is not empty.  JFM CAT_1 th. 56.
       (Contributed by FL, 3-Jan-2008.) @)
    hine @p |- ( ( T e. CatOLD /\ A e. O ) ->
      ( H ` <. A , A >. ) =/= (/) ) @=
      ( ccatOLD wcel wa cid_ cfv cop c0 wne eqid homib ne0i syl ) BGHADHIABJKZK
      ZAALCKZHUAMNABCSDESOFPUATQR @.
  @}

  @{
    cmphmia.1 @e |- O = dom ( id_ ` T ) @.
    cmphmia.2 @e |- H = ( hom ` T ) @.
    cmphmia.3 @e |- J = ( id_ ` T ) @.
    cmphmia.4 @e |- R = ( o_ ` T ) @.
    @( Composite of the member of a homset with the identity.  JFM CAT_1 th. 57
       (Contributed by FL, 5-Dec-2007.) @)
    cmphmia @p |- ( ( T e. CatOLD /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( ( J ` B ) R F ) = F ) ) @=
      ( ccatOLD wcel w3a cfv cdm wceq eqid wi cop cdom_ ccod_ wa cehm jcad cid_
      co ehm eqcomi dmeqi eqtri cmpida 3exp imp4b 3adant2 syld ) DMNZAHNZBHNZOZ
      EABUAFPNZEDUBPZQZNZEDUCPZPBRZUDZBGPECUHERZVAVBVEVGABDEFVDHIVDSZJUIABVFDEF
      HIVFSZJUEUFURUTVHVITUSURUTVEVGVIURUTVEVGVITBVFVCCDEGVDHVJVCSHDUGPZQGQIVLG
      GVLKUJUKULKLVKUMUNUOUPUQ @.
  @}

  @{
    cmphmib.1 @e |- O = dom ( id_ ` T ) @.
    cmphmib.2 @e |- H = ( hom ` T ) @.
    cmphmib.3 @e |- J = ( id_ ` T ) @.
    cmphmib.4 @e |- R = ( o_ ` T ) @.
    @( Composite of a member of a homset with the identity.  JFM CAT_1 th. 58
       (Contributed by FL, 5-Dec-2007.) @)
    cmphmib @p |- ( ( T e. CatOLD /\ A e. O /\ B e. O ) ->
      ( F e. ( H ` <. A , B >. ) -> ( F R ( J ` A ) ) = F ) ) @=
      ( ccatOLD wcel w3a cfv cdm wceq eqid wi cop cdom_ wa ehm dehm jcad eqcomi
      co cid_ dmeqi eqtri cmpidb 3exp imp4b 3adant3 syld ) DMNZAHNZBHNZOZEABUAF
      PNZEDUBPZQZNZEVBPARZUCZEAGPCUHERZUTVAVDVEABDEFVCHIVCSZJUDABVBDEFHIVBSZJUE
      UFUQURVFVGTUSUQURVDVEVGUQURVDVEVGTAVBCDEGVCHVHVIHDUIPZQGQIVJGGVJKUGUJUKKL
      ULUMUNUOUP @.
  @}

  @{
    iri.1 @e |- O = dom ( id_ ` T ) @.
    iri.2 @e |- J = ( id_ ` T ) @.
    iri.3 @e |- R = ( o_ ` T ) @.
    @( Composite of an identity with itself.  JFM CAT_1 th. 59 (Contributed by
       FL, 5-Dec-2007.) @)
    iri @p |- ( ( T e. CatOLD /\ A e. O ) ->
      ( ( J ` A ) R ( J ` A ) ) = ( J ` A ) ) @=
      ( ccatOLD wcel wa cfv cdom_ cdm ccod_ wceq co eqid jdmo cid_ eqcomi dmeqi
      eqtri idosc simprd wi cmpida 3exp imp4b mp2and ) CIJZAEJZKZADLZCMLZNZJZUN
      COLZLAPZUNUNBQUNPZACDUPEUPRZFGSUMUNUOLAPUSAURUOCDEECTLZNDNFVBDDVBGUAUBUCZ
      UORZGURRZUDUEUKULUQUSUTUKULUQUSUTUFAURUOBCUNDUPEVAVDVCGHVEUGUHUIUJ @.
  @}

  @{
    cmpassoh.1 @e |- O = dom ( id_ ` T ) @.
    cmpassoh.2 @e |- H = ( hom ` T ) @.
    cmpassoh.3 @e |- R = ( o_ ` T ) @.
    @( ` o_ ` is associative.  Homset-based version of ~ cmpasso .
       (Contributed by FL, 10-Mar-2008.) @)
    cmpassoh @p |- ( ( T e. CatOLD /\ ( A e. O /\ B e. O ) /\
      ( C e. O /\ D e. O ) ) -> ( ( L e. ( H ` <. A , B >. ) /\
         M e. ( H ` <. B , C >. ) /\ N e. ( H ` <. C , D >. ) )
           -> ( N R ( M R L ) ) = ( ( N R M ) R L ) ) ) @=
      ( wcel wa cfv wceq wi 3imp ccatOLD w3a cop co cdom_ cdm ccod_ simpl1 eqid
      ehm 3expib a1dd 3exp com13 adantr com3l com12 a1d 3anim123d imp jca simp3
      adantl dehm syl5 simp2 cehm eqtr4d 3simpa 3adant3r1 adantld 3impia eqcomd
      ex com3r 3adant3 eqtrd 3expia cmpasso sylc ) FUAOZAKOZBKOZPZCKOZDKOZPZUBZ
      HABUCGQOZIBCUCGQOZJCDUCGQOZUBZJIHEUDEUDJIEUDHEUDRZWHWLPZWAHFUEQZUFZOZIWPO
      ZJWPOZUBZPJWOQZIFUGQZQZRZIWOQZHXBQZRZPWMWNWAWTWAWDWGWLUHWHWLWTWHWIWQWJWRW
      KWSWAWDWGWIWQSZWAWDXHWGWAWBWCXHABFHGWPKLWPUIZMUJUKULTWAWDWGWJWRSZWDWAWGXJ
      SZWCWAXKSWBWGWCWAXJWEWCWAXJSSWFWAWCWEXJWAWCWEXJBCFIGWPKLXIMUJUMUNUOUPVCUQ
      TWAWDWGWKWSSZWAWGXLSWDWAWEWFXLCDFJGWPKLXIMUJUKURTUSUTVAWNXDXGWNXACXCWHWLX
      ACRZWLWKWHXMWIWJWKVBWAWDWGWKXMSZWAWGXNSWDWAWEWFXNCDWOFJGKLWOUIZMVDUKURTVE
      UTWHWLXCCRZWLWJWHXPWIWJWKVFWAWDWGWJXPSZWDWAWGXQSZWCWAXRSWBWGWCWAXQWEWCWAX
      QSSWFWAWCWEXQWAWCWEXQBCXBFIGKLXBUIZMVGUMUNUOUPVCUQTVEUTVHWHWLXGWLWIWJPZWH
      XGWIWJWKVIWAWDWGXTXGSZWGWDWAYAWEWDWAYASZSWFWDWEYBWBWCWEYBWAWBWCWEUBZYAWAY
      CXTXGWAYCXTUBXEBXFWAYCXTXEBRZWAYCPWJYDWIWAWCWEWJYDSWBBCWOFIGKLXOMVDVJVKVL
      WAYCXTBXFRZYCWAXTYESZWBWCWAYFSWEXTWAWDYEWIWAWDYESSWJWAWDWIYEWAWBWCWIYESWA
      WBWCUBZWIYEYGWIPXFBYGWIXFBRABXBFHGKLXSMVGUTVMVNUKVOUOUNVPUQTVQUMUQVRUQUOU
      NTVEUTVAXBWOEFHIJWPXIXOXSNVSVTVN @.
  @}

  @{
    homgrf.1 @e |- O = dom ( id_ ` T ) @.
    homgrf.2 @e |- H = ( hom ` T ) @.
    homgrf.3 @e |- R = ( o_ ` T ) @.
    @( Homset of a composite.  JFM CAT_1 th. 51 (Contributed by FL,
       10-Mar-2008.) @)
    homgrf @p |- ( ( T e. CatOLD /\ ( A e. O /\ B e. O /\ C e. O ) ) ->
   ( ( F e. ( H ` <. A , B >. ) /\ G e. ( H ` <. B , C >. ) ) ->
     ( G R F ) e. ( H ` <. A , C >. ) ) ) @=
      ( wcel w3a cfv wceq wi com12 adantr impcom ccatOLD wa cop cdom_ cdm ccod_
      co eqid ehm 3adant3r3 3adant3r1 adantl dehm cehm imp eqcomd ex eqtrd 3jca
      cmpmorp 3exp syld cded catded ad2antrr eqtr4d domcmpd sylc codcmpd ishomd
      3impd wb 3adant3r2 sylibrd ) EUAMZAIMZBIMZCIMZNZUBZFABUCHOMZGBCUCHOMZUBZG
      FDUGZEUDOZUEZMZWDWEOZAPZWDEUFOZOZCPZNZWDACUCHOMZVTWCWMVTWCUBZWGWIWLVTWCWG
      VTWCFWFMZGWFMZGWEOZFWJOZPZNZWGVTWCXAWOWPWQWTWCVTWPWAVTWPQWBVTWAWPVOVPVQWA
      WPQVRABEFHWFIJWFUHZKUIUJRSTZWCVTWQWBVTWQQWAVTWBWQVOVQVRWBWQQVPBCEGHWFIJXB
      KUIUKRULTZWOWRBWSWCVTWRBPZWBVTXEQWAVTWBXEVOVQVRWBXEQVPBCWEEGHIJWEUHZKUMUK
      RULTZWCVTBWSPZWAVTXHQWBVTWAXHVOVPVQWAXHQVRVOVPVQNZWAXHXIWAUBWSBXIWAWSBPZA
      BWJEFHIJWJUHZKUNZUOUPUQUJRSTURUSUQVOXAWGQVSVOWPWQWTWGVOWPWQWTWGQWJWEDEFGW
      FXBXFXKLUTVAVKSVBUOWOWHFWEOZAWOEVCMZWPWQNZWTWHXMPWOXNWPWQVOXNVSWCEVDVEXCX
      DUSZWOWRBWSXGWCVTXJWAVTXJQWBVTWAXJVOVPVQWAXJQVRXLUJRSTVFZWJWEDEFGWFXBXFXK
      LVGVHWCVTXMAPZWAVTXRQWBVTWAXRVOVPVQWAXRQVRABWEEFHIJXFKUMUJRSTURWOWKGWJOZC
      WOXOWTWKXSPXPXQWJWEDEFGWFXBXFXKLVIVHWCVTXSCPZWBVTXTQWAVTWBXTVOVQVRWBXTQVP
      BCWJEGHIJXKKUNUKRULTURUSUQVOVPVRWNWMVLVQACWJWEEWDHWFIJXBXFXKKVJVMVN @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Monomorphisms, Epimorphisms, Isomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Epic @. @( The class of all epimorphisms. @)
  @c MonoOLD @. @( The class of all monomorphisms. @)
  @c IsoOLD @. @( The class of all isomorphisms. @)

  @( Extend class notation with the class of all epimorphisms. @)
  cepiOLD @a class Epic @.

  @( Extend class notation with the class of all monomorphisms. @)
  cmonOLD @a class MonoOLD @.

  @( Extend class notation with the class of all isomorphisms. @)
  cisoOLD @a class IsoOLD @.

  @{
    @d x y f g h @.
    @( Function returning the monomorphisms of the category ` x ` .  JFM CAT_1
       def. 10.  (Contributed by FL, 5-Dec-2007.) @)
    df-monOLD @a |- MonoOLD = ( x e. CatOLD |-> { f e. dom ( dom_ ` x ) |
      A. g e. dom ( dom_ ` x ) A. h e. dom ( dom_ ` x )
        ( ( ( ( dom_ ` x ) ` g ) = ( ( dom_ ` x ) ` h ) /\
            ( ( cod_ ` x ) ` g ) = ( ( dom_ ` x ) ` f ) /\
            ( ( cod_ ` x ) ` h ) = ( ( dom_ ` x ) ` f ) ) ->
              ( ( f ( o_ ` x ) g ) = ( f ( o_ ` x ) h ) -> g = h ) ) } ) @.
  @}

  @{
    @d x y f g h @.
    @( Function returning the epimorphisms of the category ` x ` .  JFM CAT_1
       def. 11.  (Contributed by FL, 8-Aug-2008.) @)
    df-epiOLD @a |- Epic = ( x e. CatOLD |-> { f e. dom ( dom_ ` x ) |
      A. g e. dom ( dom_ ` x ) A. h e. dom ( dom_ ` x )
        ( ( ( ( cod_ ` x ) ` g ) = ( ( cod_ ` x ) ` h ) /\
            ( ( dom_ ` x ) ` g ) = ( ( cod_ ` x ) ` f ) /\
            ( ( dom_ ` x ) ` h ) = ( ( cod_ ` x ) ` f ) ) ->
              ( ( g ( o_ ` x ) f ) = ( h ( o_ ` x ) f ) -> g = h ) ) } ) @.
  @}

  @{
    @d x y f g @.
    @( Function returning the isomorphisms of the category ` x ` .  The Joy of
       Cats p. 28.  (Contributed by FL, 9-Jun-2014.) @)
    df-isoc @a |- IsoOLD = ( x e. CatOLD |-> { f e. dom ( dom_ ` x ) |
       E. g e. dom ( dom_ ` x ) (
     ( ( dom_ ` x ) ` g ) = ( ( cod_ ` x ) ` f ) /\
     ( ( cod_ ` x ) ` g ) = ( ( dom_ ` x ) ` f ) /\
     ( ( f ( o_ ` x ) g ) = ( ( id_ ` x ) ` ( ( dom_ ` x ) ` g ) ) /\
     ( g ( o_ ` x ) f ) = ( ( id_ ` x ) ` ( ( dom_ ` x ) ` f ) ) ) ) } ) @.
  @}

  @{
    @d C x y @.  @d D x y @.  @d M f g h x y @.  @d R x y @.  @d T f g h x y @.
    ismona.1 @e |- M = dom ( dom_ ` T ) @.
    ismona.2 @e |- D = ( dom_ ` T ) @.
    ismona.3 @e |- C = ( cod_ ` T ) @.
    ismona.4 @e |- R = ( o_ ` T ) @.
    @( Monomorphisms of a category.  (Contributed by FL, 5-Dec-2007.) @)
    ismona @p |- ( T e. CatOLD -> ( MonoOLD ` T ) = { f e. M |
      A. g e. M A. h e. M
        ( ( ( D ` g ) = ( D ` h ) /\
            ( C ` g ) = ( D ` f ) /\
            ( C ` h ) = ( D ` f ) ) ->
              ( ( f R g ) = ( f R h ) -> g = h ) ) } ) @=
      ( cv cfv wceq co wral fveq1d fveq1i syl6eq vx cdom_ ccod_ w3a co_ wi crab
      cdm ccatOLD cmonOLD fveq2 dmeqd syl6eqr raleqdv raleqbidv 3anbi123d oveqd
      eqcomi eqeq12d oveq eqcoms ax-mp eqeq12i syl6bb imbi1d 2ralbidv rabeqbidv
      imbi12d bitrd df-monOLD cvv fvex dmex eqeltri rabex fvmpt ) UADFMZUAMZUBN
      ZNZGMZVSNZOZVQVRUCNZNZEMZVSNZOZWAWDNZWGOZUDZWFVQVRUENZPZWFWAWLPZOZVQWAOZU
      FZUFZGVSUHZQZFWSQZEWSUGVQBNZWABNZOZVQANZWFBNZOZWAANZXFOZUDZWFVQCPZWFWACPZ
      OZWPUFZUFZGHQFHQZEHUGUIUJVRDOZXAXPEWSHXQWSDUBNZUHZHXQVSXRVRDUBUKZULIUMZXQ
      XAWRGHQZFHQXPXQWTYBFWSHYAXQWRGWSHYAUNUOXQWRXOFGHHXQWKXJWQXNXQWCXDWHXGWJXI
      XQVTXBWBXCXQVTVQXRNXBXQVQVSXRXTRVQXRBBXRJURZSTXQWBWAXRNXCXQWAVSXRXTRWAXRB
      YCSTUSXQWEXEWGXFXQWEVQDUCNZNXEXQVQWDYDVRDUCUKZRVQYDAAYDKURZSTXQWGWFXRNXFX
      QWFVSXRXTRWFXRBYCSTZUSXQWIXHWGXFXQWIWAYDNXHXQWAWDYDYERWAYDAYFSTYGUSUPXQWO
      XMWPXQWOWFVQDUENZPZWFWAYHPZOXMXQWMYIWNYJXQWLYHWFVQVRDUEUKZUQXQWLYHWFWAYKU
      QUSYIXKYJXLCYHOZYIXKOZLYMYHCWFVQYHCUTVAVBYLYJXLOZLYNYHCWFWAYHCUTVAVBVCVDV
      EVHVFVIVGUAEFGVJXPEHHXSVKIXRDUBVLVMVNVOVP @.
  @}

  @{
    @d C f @.  @d D f @.  @d F f g h @.  @d M f g h @.  @d R f @.
    @d T f g h @.
    ismonb.1 @e |- M = dom ( dom_ ` T ) @.
    ismonb.2 @e |- D = ( dom_ ` T ) @.
    ismonb.3 @e |- C = ( cod_ ` T ) @.
    ismonb.4 @e |- R = ( o_ ` T ) @.
    @( The predicate "is a monomorphism".  (Contributed by FL, 2-Jan-2008.) @)
    ismonb @p |- ( T e. CatOLD -> ( F e. ( MonoOLD ` T )
      <-> ( F e. M /\ A. g e. M A. h e. M
        ( ( ( D ` g ) = ( D ` h ) /\
            ( C ` g ) = ( D ` F ) /\
            ( C ` h ) = ( D ` F ) ) ->
              ( ( F R g ) = ( F R h ) -> g = h ) ) ) ) ) @=
      ( vf wcel cfv cv wceq co wi wral ccatOLD cmonOLD w3a crab wa ismona fveq2
      eleq2d eqeq2d 3anbi23d oveq1 eqeq12d imbi1d imbi12d 2ralbidv elrab syl6bb
      ) DUANZGDUBOZNGEPZBOFPZBOQZUTAOZMPZBOZQZVAAOZVEQZUCZVDUTCRZVDVACRZQZUTVAQ
      ZSZSZFHTEHTZMHUDZNGHNVBVCGBOZQZVGVRQZUCZGUTCRZGVACRZQZVMSZSZFHTEHTZUEURUS
      VQGABCDMEFHIJKLUFUHVPWGMGHVDGQZVOWFEFHHWHVIWAVNWEWHVFVSVHVTVBWHVEVRVCVDGB
      UGZUIWHVEVRVGWIUIUJWHVLWDVMWHVJWBVKWCVDGUTCUKVDGVACUKULUMUNUOUPUQ @.

    @( The predicate "is a monomorphism".  (Contributed by FL, 2-Jan-2008.) @)
    ismonb1 @p |- ( ( T e. CatOLD /\ F e. M ) -> ( F e. ( MonoOLD ` T ) <->
      A. g e. M A. h e. M
        ( ( ( D ` g ) = ( D ` h ) /\
            ( C ` g ) = ( D ` F ) /\
            ( C ` h ) = ( D ` F ) ) ->
              ( ( F R g ) = ( F R h ) -> g = h ) ) ) ) @=
      ( ccatOLD wcel cfv cv wceq co wi wral cmonOLD w3a ismonb baibd ) DMNGDUAO
      NGHNEPZBOFPZBOQUEAOGBOZQUFAOUGQUBGUECRGUFCRQUEUFQSSFHTEHTABCDEFGHIJKLUCUD
      @.
  @}

  @{
    @d C g j @.  @d D g j @.  @d F g j @.  @d G g j @.  @d J j @.  @d M g j @.
    @d R g j @.  @d T g j @.
    ismonb2.1 @e |- M = dom ( dom_ ` T ) @.
    ismonb2.2 @e |- D = ( dom_ ` T ) @.
    ismonb2.3 @e |- C = ( cod_ ` T ) @.
    ismonb2.4 @e |- R = ( o_ ` T ) @.
    @( A monomorphism is a left-cancelable morphism.  (Contributed by FL,
       2-Jan-2008.) @)
    ismonb2 @p |- ( ( T e. CatOLD /\ ( F e. M /\ G e. M /\ J e. M ) ) ->
      ( F e. ( MonoOLD ` T ) ->
        ( ( ( D ` G ) = ( D ` J ) /\
            ( C ` G ) = ( D ` F ) /\
            ( C ` J ) = ( D ` F ) ) ->
              ( ( F R G ) = ( F R J ) -> G = J ) ) ) ) @=
      ( vg vj wcel w3a cfv wceq co wi ccatOLD wa cmonOLD wral ismonb1 3ad2antr1
      cv 3simpc adantl fveq2 eqeq1d 3anbi12d oveq2 eqeq1 imbi12d 3anbi13d eqeq2
      wb eqeq2d rspc2v syl sylbid ) DUAOZEHOZFHOZGHOZPZUBZEDUCQOZMUGZBQZNUGZBQZ
      RZVJAQZEBQZRZVLAQZVPRZPZEVJCSZEVLCSZRZVJVLRZTZTZNHUDMHUDZFBQZGBQZRZFAQZVP
      RZGAQZVPRZPZEFCSZEGCSZRZFGRZTZTZVCVEVDVIWGURVFABCDMNEHIJKLUEUFVHVEVFUBZWG
      XATVGXBVCVDVEVFUHUIWFXAWHVMRZWLVSPZWPWBRZFVLRZTZTMNFGHHVJFRZVTXDWEXGXHVNX
      CVQWLVSXHVKWHVMVJFBUJUKXHVOWKVPVJFAUJUKULXHWCXEWDXFXHWAWPWBVJFECUMUKVJFVL
      UNUOUOVLGRZXDWOXGWTXIXCWJVSWNWLXIVMWIWHVLGBUJUSXIVRWMVPVLGAUJUKUPXIXEWRXF
      WSXIWBWQWPVLGECUMUSVLGFUQUOUOUTVAVB @.
  @}

  @{
    @d B a g h @.  @d C a g h @.  @d F a g h @.  @d H a g h @.  @d O a g h @.
    @d R a @.  @d T a g h @.
    imonclem.1 @e |- O = dom ( id_ ` T ) @.
    imonclem.2 @e |- H = ( hom ` T ) @.
    imonclem.3 @e |- R = ( o_ ` T ) @.
    @( Lemma for ~ ismonc .  (Contributed by FL, 1-Jan-2008.) @)
    imonclem @p |- ( ( T e. CatOLD
                         /\ ( B e. O /\ C e. O )
                         /\ F e. ( H ` <. B , C >. ) )
                      -> ( A. a
                            e. O
                               A. g
                               e. ( H ` <. a , B >. )
                                  A. h
                                  e. ( H ` <. a , B >. )
                                     ( ( F R g ) = ( F R h ) -> g = h )
                         -> ( F e. dom ( dom_ ` T )
                            /\ A. g
                               e. dom ( dom_ ` T )
                                  A. h
                                  e. dom ( dom_ ` T )
                                     ( ( ( ( dom_ ` T ) ` g )
                                           = ( ( dom_ ` T ) ` h )
                                        /\ ( ( cod_ ` T ) ` g )
                                           = ( ( dom_ ` T ) ` F )
                                        /\ ( ( cod_ ` T ) ` h )
                                           = ( ( dom_ ` T ) ` F ) )
                                     -> ( ( F R g ) = ( F R h ) -> g = h ) ) )
                         ) ) @=
      ( wcel wa cfv wceq wi wral adantr ccatOLD cop w3a cv cdom_ cdm ccod_ eqid
      ehm 3expib 3imp wal nfv nfra2 nfan nfcv nfral simp1 dmo expcom mpan9 r2al
      co ralbii sp sps ralimi simpr fveq2d eleq2d anbi12d imbi1d adantl simpll1
      wb opeq1 simp2l ad2antrr ishomd syl3anc dehm simplr simp2 eqcomd ad2antll
      eqtr3 3ad2ant3 com12 imp 3jca simplrl eqidd eqtr 3ad2ant2 simplrr impbida
      ex jca syl2anc 3bitrd adantlr rspcdv syl5com sylbi impancom alrimi sylibr
      mpdan ) DUANZAINZBINZOZGABUBHPNZUCZGEUDZCVCGFUDZCVCQXOXPQRZFJUDZAUBZHPZSZ
      EXTSZJISZGDUEPZUFZNZXOYDPZXPYDPZQZXODUGPZPZGYDPZQZXPYJPZYLQZUCZXQRZFYESEY
      ESZOXNYCOZYFYRXNYFYCXIXLXMYFXIXJXKXMYFRABDGHYEIKYEUHZLUIUJUKTYSXOYENZXPYE
      NZOZYQRZFULZEULYRYSUUEEXNYCEXNEUMYAJEIXTUNUOYSUUDFXNYCFXNFUMYBFJIFIUPXQEF
      XTXTUNUQUOXNUUCYCYQXNUUCOZYGINZYCYQRXNXIUUCUUGXIXLXMURUUAXIUUGRUUBXIUUAUU
      GYDDXOYEIYTKYDUHZUSUTTVAZYCUUFUUGOZYQYCXOXTNZXPXTNZOZXQRZFULZEULZJISZUUJY
      QRYBUUPJIXQEFXTXTVBVDUUQUUNJISUUJYQUUPUUNJIUUOUUNEUUNFVEVFVGUUJUUNYQJYGIU
      UFUUGVHUUFXRYGQZUUNYQVOUUGUUFUUROZUUNXOYGAUBZHPZNZXPUVANZOZXQRZUUAYGYGQZY
      KAQZUCZUUBYHYGQZYNAQZUCZOZXQRZYQUURUUNUVEVOUUFUURUUMUVDXQUURUUKUVBUULUVCU
      URXTUVAXOUURXSUUTHXRYGAVPVIZVJUURXTUVAXPUVNVJVKVLVMUUSXIUUGXJUVEUVMVOXIXL
      XMUUCUURVNUUFUUGUURUUITXNXJUUCUURXIXJXKXMVQVRXIUUGXJUCZUVDUVLXQUVOUVBUVHU
      VCUVKYGAYJYDDXOHYEIKYTUUHYJUHZLVSYGAYJYDDXPHYEIKYTUUHUVPLVSVKVLVTUUSUVLYP
      XQUUSYLAQZUUCUVLYPVOXNUVQUUCUURXIXLXMUVQXIXJXKXMUVQRABYDDGHIKUUHLWAUJUKVR
      XNUUCUURWBUVQUUCOZUVLYPUVRUVLOYIYMYOUVKYIUVRUVHUVKYHYGUUBUVIUVJWCWDWEUVRU
      VLYMUVQUVLYMRUUCUVLUVQYMUVHUVQYMRZUVKUVGUUAUVSUVFUVGUVQYMYKYLAWFWQWGTWHTW
      IUVRUVLYOUVQUVLYORUUCUVLUVQYOUVKUVQYORZUVHUVJUUBUVTUVIUVJUVQYOYNYLAWFWQWG
      VMWHTWIWJUVRYPOZUVHUVKUWAUUAUVFUVGUVQUUAUUBYPWKUWAYGWLUVRYPUVGUVQYPUVGRUU
      CYPUVQUVGYMYIUVQUVGRYOYMUVQUVGYKYLAWMWQWNWHTWIWJUWAUUBUVIUVJUVQUUAUUBYPWO
      YPUVIUVRYPYGYHYIYMYOURWDVMUVRYPUVJUVQYPUVJRUUCYPUVQUVJYOYIUVQUVJRYMYOUVQU
      VJYNYLAWMWQWGWHTWIWJWRWPWSVLWTXAXBXCXDWHXHXEXFXFYQEFYEYEVBXGWRWQ @.
  @}

  @{
    @d B a g h @.  @d C a g h @.  @d F a g h @.  @d H a g h @.  @d O a g h @.
    @d R a @.  @d T a g h @.
    ismonc.1 @e |- O = dom ( id_ ` T ) @.
    ismonc.2 @e |- H = ( hom ` T ) @.
    ismonc.3 @e |- R = ( o_ ` T ) @.
    @( The predicate "is a monomorphism" when the morphism belongs to a
       homset.  (Contributed by FL, 2-Jan-2008.) @)
    ismonc @p |- ( ( T e. CatOLD /\ ( B e. O /\ C e. O ) /\
      F e. ( H ` <. B , C >. ) ) -> ( F e. ( MonoOLD ` T ) <->
        A. a e. O A. g e. ( H ` <. a , B >. ) A. h e. ( H ` <. a , B >. )
        ( ( F R g ) = ( F R h ) -> g = h ) ) ) @=
      ( wcel wa cfv w3a wceq wi wral ccatOLD cop cmonOLD cdom_ cv ccod_ co eqid
      cdm wb ismonb 3ad2ant1 wal nfv nfra1 nfan nfra2 rsp2 pm3.31 simplr simp2l
      simpll1 ad2antrr ishomd biimpd anim12d syl3anc simp1 a1i dehm simp2 eqtr3
      anim12i syl2an adantl 3ad2ant3 adantr impcom 3jca syl6 3expib 3imp imim1d
      ex jcad syld com13 3syl alrimi exp31 com23 imp alrimiv r2al ralbii df-ral
      bitri sylibr imonclem impbid bitrd ) DUANZAINZBINZOZGABUBHPNZQZGDUCPNZGDU
      DPZUIZNZEUEZXIPZFUEZXIPZRZXLDUFPZPZGXIPZRZXNXQPZXSRZQZGXLCUGGXNCUGRXLXNRS
      ZSZFXJTZEXJTZOZYDFJUEZAUBHPZTEYJTZJITZXBXEXHYHUJXFXQXICDEFGXJXJUHZXIUHZXQ
      UHZMUKULXGYHYLXGYHYLXGYHOZYIINZXLYJNZXNYJNZOZYDSZFUMZEUMZSZJUMZYLYPUUDJXG
      YHUUDXGYQYHUUCXGYQYHUUCXGYQOZYHOZUUBEUUFYHEUUFEUNXKYGEXKEUNYFEXJUOUPUPUUG
      UUAFUUFYHFUUFFUNXKYGFXKFUNYEEFXJXJUQUPUPYHUUFUUAYGXKUUFUUASZYGXLXJNZXNXJN
      ZOZYESUUKYCOZYDSZXKUUHSYEEFXJXJURUUKYCYDUSUUFXKUUMUUAUUFXKUUMUUASUUFXKOZY
      TUULYDUUNYTUUIXMYIRZXRARZQZUUJXOYIRZYAARZQZOZUULUUNXBYQXCYTUVASXBXEXFYQXK
      VBXGYQXKUTXGXCYQXKXBXCXDXFVAVCXBYQXCQZYRUUQYSUUTUVBYRUUQYIAXQXIDXLHXJIKYM
      YNYOLVDVEUVBYSUUTYIAXQXIDXNHXJIKYMYNYOLVDVEVFVGUUNUVAUUKYCUVAUUKSUUNUUQUU
      IUUTUUJUUIUUOUUPVHUUJUURUUSVHVMVIXGUVAYCSZYQXKXBXEXFUVCXBXCXDXFUVCSXBXCXD
      QXFXSARZUVCABXIDGHIKYNLVJUVDUVAYCUVDUVAOXPXTYBUVAXPUVDUUQUUOUURXPUUTUUIUU
      OUUPVKUUJUURUUSVKXMXOYIVLVNVOUVAUVDXTUUQUVDXTSZUUTUUPUUIUVEUUOUUPUVDXTXRX
      SAVLWDVPVQVRUVAUVDYBUUTUVDYBSZUUQUUSUUJUVFUURUUSUVDYBYAXSAVLWDVPVOVRVSWDV
      TWAWBVCWEWFWCWDWGWHVRVRWIWIWJWKWLWMYLUUCJITUUEYKUUCJIYDEFYJYJWNWOUUCJIWPW
      QWRWDABCDEFGHIJKLMWSWTXA @.
  @}

  @{
    @d A a g h @.  @d B a g h k l @.  @d C a g h k l @.  @d F a g h k l @.
    @d G a g h k l @.  @d H a g h k l @.  @d O a g h k l @.  @d R a g h k l @.
    @d T a g h k l @.
    cmpmon.1 @e |- O = dom ( id_ ` T ) @.
    cmpmon.2 @e |- H = ( hom ` T ) @.
    cmpmon.3 @e |- R = ( o_ ` T ) @.
    @( The composite of two monomorphisms is a monomorphism.  JFM CAT_1 th. 61
       (Contributed by FL, 10-Mar-2008.) @)
    cmpmon @p |- ( ( T e. CatOLD /\ ( ( A e. O /\ B e. O /\ C e. O ) /\
         ( F e. ( H ` <. A , B >. ) /\ G e. ( H ` <. B , C >. ) )
           /\ ( F e. ( MonoOLD ` T ) /\ G e. ( MonoOLD ` T ) ) ) ) ->
              ( G R F ) e. ( MonoOLD ` T ) ) @=
      ( vg vh va wcel wa wi wceq ex vk vl ccatOLD w3a cop cfv cmonOLD co 3simpa
      cv wral ismonc biimpd 3exp com13 adantr syl5 3imp 3simpc adantl nfv nfra1
      nfan nfra2 nfcv nfral cmpassoh 3expib com3r com23 com14 exp43 3impd com34
      imp31 ad2antrr eqcom biimpi eqcomd 3exp1 com3l com12 com4r impcom 3eqtr2d
      imp 3impia homgrf adantrd com24 3adant3 jca ad2antll oveq2 eqeq1d imbi12d
      rsp eqeq1 eqeq2d eqeq2 rspc2v sylc wal r3al 19.21bbi ad2antrl 3expd imp41
      19.21bi 3syld ralrimi simp1 3simpb 3ad2ant2 syl3anc sylibrd syl2and 3imp2
      wb ) EUCPZAIPZBIPZCIPZUDZFABUEHUFPZGBCUEHUFPZQZFEUGUFZPZGYHPZQZGFDUHZYHPZ
      XTYDYGYKYMRXTYDYGUDZYIFMUJZDUHZFNUJZDUHZSZYOYQSZRZNOUJZAUEHUFZUKZMUUCUKZO
      IUKZYJGUAUJZDUHZGUBUJZDUHZSZUUGUUISZRZUBUUBBUEHUFZUKUAUUNUKZOIUKZYMXTYDYG
      YIUUFRZYDYAYBQZXTYGUUQRYAYBYCUIZYGUURXTUUQYEUURXTUUQRRYFXTUURYEUUQXTUURYE
      UUQXTUURYEUDYIUUFABDEMNFHIOJKLULUMUNUOUPUOUQURXTYDYGYJUUPRZYDYBYCQZXTYGUU
      TRYAYBYCUSYGUVAXTUUTYFUVAXTUUTRRYEXTUVAYFUUTXTUVAYFUUTXTUVAYFUDYJUUPBCDEU
      AUBGHIOJKLULUMUNUOUTUOUQURYNUUFUUPQZYLYODUHZYLYQDUHZSZYTRZNUUCUKZMUUCUKZO
      IUKZYMYNUVBUVIYNUVBQZUVHOIYNUVBOYNOVAUUFUUPOUUEOIVBUUOOIVBVCVCUVJUUBIPZUV
      HUVJUVKQZUVGMUUCUVJUVKMYNUVBMYNMVAUUFUUPMUUDOMIUUCVDUUPMVAVCVCUVKMVAVCUVL
      YOUUCPZUVGUVLUVMQZUVFNUUCUVLUVMNUVJUVKNYNUVBNYNNVAUUFUUPNUUENOINIVEUUAMNU
      UCUUCVDVFUUPNVAVCVCUVKNVAVCUVMNVAVCUVNYQUUCPZUVFUVNUVOQZUVEGYPDUHZGYRDUHZ
      SZYSYTUVPUVEUVSUVPUVEQUVQUVCUVDUVRUVNUVQUVCSZUVOUVEUVJUVKUVMUVTYNUVKUVMUV
      TRZRZUVBXTYDYGUWBXTYDUVKYGUWAUVKYDXTYGUWARZUVKYAYBYCXTUWCRZUVKYAYBYCUWDUV
      MXTYGUVKYAQZUVAQZUVTUVMYGXTUWFUVTRZUVMYEYFXTUWGRXTUWFUVMYEYFUDZUVTXTUWEUV
      AUWHUVTRUUBABCDEHYOFGIJKLVGVHVIVHVJVKVLVMUOVNURUPVOVPUVEUVDUVCSZUVPUVEUWI
      UVCUVDVQVRUTUVPUVDUVRSZUVEUVNUVOUWJUVLUVOUWJRZUVMUVJUVKUWKYNUVKUWKRZUVBXT
      YDYGUWLUVOYGUVKXTYDQZUWJUVOYEYFUVKUWMUWJRRUWMUVKUVOYEYFUDZUWJYDXTUVKUWNUW
      JRZRZYAYBYCXTUWPRYBYCXTYAUWPYBYCXTYAUWPRZRXTUVAUWQUVKUVAYAXTUWOUVKYAUVAXT
      UWORZUVKYAUVAUWRRXTUWEUVAUWOXTUWEUVAUWNUWJXTUWEUVAUDZUWNQUVRUVDUWSUWNUVRU
      VDSUUBABCDEHYQFGIJKLVGWFVSVTWATVJVKWBTWCURWDUOVHVKWGUPWFUPWFUPWETUVPYPUUN
      PZYRUUNPZQUUOUVSYSRZUVPUWTUXAUVNUWTUVOUVJUVKUVMUWTYNUVKUVMUWTRZRZUVBXTYDY
      GUXDYGYDXTUXDYEYDXTUXDRZRYFYDUURYEUXEUUSUVKUURXTYEUXCUVKYAYBXTYEUXCRRUVMX
      TYEUVKYAYBUDZUWTUVMYEXTUXFUWTRZUVMYEXTUXGRXTUXFUVMYEQZUWTXTUXFUXHUWTRUUBA
      BDEYOFHIJKLWHTVITVJVKVHVKUQUPUOURUPVOUPUVNUVOUXAUVLUVOUXARZUVMUVJUVKUXIYN
      UVKUXIRZUVBXTYDYGUXJYDXTYGUXJRZYAYBXTUXKRYCUURUVKYGXTUXIUVKUURYGXTUXIRZRZ
      UVKYAYBUXMUXFYEUXLYFUVOYEXTUXFUXAUVOYEXTUXFUXARRXTUXFUVOYEQZUXAXTUXFUXNUX
      ARUUBABDEYQFHIJKLWHTVITVKWIVHWBWJWKWBURUPWFUPWFWLUVLUUOUVMUVOUVJUVKUUOUUP
      UVKUUORYNUUFUUOOIWQWMWFVPUUMUXBUVQUUJSZYPUUISZRUAUBYPYRUUNUUNUUGYPSZUUKUX
      OUULUXPUXQUUHUVQUUJUUGYPGDWNWOUUGYPUUIWRWPUUIYRSZUXOUVSUXPYSUXRUUJUVRUVQU
      UIYRGDWNWSUUIYRYPWTWPXAXBUVJUVKUVMUVOUUAUVJUVKUVMUVOUUAUUFUVKUVMUVOUDUUAR
      ZYNUUPUUFUXSMNUUFUXSNXCMXCZOUUFUXTOXCUUAOMNIUUCUUCXDVRXIXEXFXGXHXJTXKTXKT
      XKTYNXTYAYCQZYLACUEHUFPZYMUVIXSXTYDYGXLYDXTUYAYGYAYBYCXMXNXTYDYGUYBABCDEF
      GHIJKLWHWGACDEMNYLHIOJKLULXOXPXQUNXR @.
  @}

  @{
    @d A a m n @.  @d B a m n @.  @d C a m n @.  @d F a m n @.  @d G a m n @.
    @d H a m n @.  @d O a m n @.  @d R a m n @.  @d T a m n @.
    icmpmon.1 @e |- O = dom ( id_ ` T ) @.
    icmpmon.2 @e |- H = ( hom ` T ) @.
    icmpmon.3 @e |- R = ( o_ ` T ) @.
    @( If ` ( G R F ) ` is a monomorphism, then ` F ` is a monomorphism.  JFM
       CAT_1 th. 62 (Contributed by FL, 17-Mar-2008.) @)
    icmpmon @p |- ( ( T e. CatOLD /\ ( ( A e. O /\ B e. O /\ C e. O ) /\
         ( F e. ( H ` <. A , B >. ) /\ G e. ( H ` <. B , C >. ) )
           /\ ( G R F ) e. ( MonoOLD ` T ) ) ) ->
              F e. ( MonoOLD ` T ) ) @=
      ( vm vn va wcel wa co wceq wi ccatOLD w3a cop cfv cmonOLD cv simp1 3simpb
      wb 3ad2ant2 homgrf 3impia ismonc syl3anc cmpassoh com3l exp4b 3impd com13
      wral 3exp 3expib com14 imp31 eqcomd adantr 3exp1 com23 oveq2 simpr simpll
      imp 3imp simplr 3eqtr4d ex imim1d syl7 ralimdva sylbid 3imp2 simpl 3simpa
      syl2anc 3ad2ant1 adantl simpr2l mpbird ) EUAPZAIPZBIPZCIPZUBZFABUCHUDPZGB
      CUCHUDPZQZGFDRZEUEUDZPZUBZQZFWRPZFMUFZDRZFNUFZDRZSZXCXESZTZNOUFZAUCHUDZUT
      ZMXKUTZOIUTZWIWMWPWSXNWIWMWPWSXNTWIWMWPUBZWSWQXCDRZWQXEDRZSZXHTZNXKUTZMXK
      UTZOIUTZXNXOWIWJWLQZWQACUCHUDPZWSYBUIWIWMWPUGWMWIYCWPWJWKWLUHUJWIWMWPYDAB
      CDEFGHIJKLUKULACDEMNWQHIOJKLUMUNXOYAXMOIXOXJIPZQZXTXLMXKYFXCXKPZQZXSXINXK
      YHXEXKPZQXPGXDDRZSZXQGXFDRZSZXSXITYHYKYIYHYJXPXOYEYGYJXPSZWIWMWPYEYGYNTTY
      GWPYEWIWMQZYNYGWNWOYEYOYNTTYOYEYGWNWOUBZYNWIWMYEYPYNTZTYEWMWIYQYEWJWKWLWI
      YQTZYEWJWKWLYRWIYEWJQZWKWLQZYQWIYSYTYQXJABCDEHXCFGIJKLUOVAUPUQURUSVLUSVBV
      CULVDVEVFYHYIYMYFYIYMTZYGXOYEUUAXOYIYEYMWIWMWPYIYEYMTZTYIWMWPWIUUBYIWPWMW
      IUUBTZYIWNWOWMUUCTYEWMWIYIWNWOUBZYMYEWJWKWLWIUUDYMTZTZYEWJWKWLUUFWIYSYTUU
      EWIYSYTUUDYMWIYSYTUBZUUDQYLXQUUGUUDYLXQSXJABCDEHXEFGIJKLUOVLVEVGUPUQURVCV
      BVHVCVMVHVLVFVLXGYJYLSZYKYMQZXSXHXDXFGDVIUUIUUHXRXHUUIUUHXRUUIUUHQYJYLXPX
      QUUIUUHVJYKYMUUHVKYKYMUUHVNVOVPVQVRWDVSVSVSVTVAWAXAWIWJWKQZWNXBXNUIWIWTWB
      WTUUJWIWMWPUUJWSWJWKWLWCWEWFWNWOWMWSWIWGABDEMNFHIOJKLUMUNWH @.
  @}

  @{
    @d A c f g @.  @d B c f g @.  @d F c f g @.  @d G c f g @.  @d H c f g @.
    @d J c f g @.  @d O c f g @.  @d R c f g @.  @d T c f g @.
    idmon.1 @e |- O = dom ( id_ ` T ) @.
    idmon.2 @e |- H = ( hom ` T ) @.
    idmon.3 @e |- R = ( o_ ` T ) @.
    idmon.4 @e |- J = ( id_ ` T ) @.
    @( If there exists ` G ` such as ` ( G R F ) = ( J `` B ) ` then F is a
       monomorphism.  JFM CAT_1 th. 63.  (Contributed by FL, 5-May-2008.) @)
    idmon @p |- ( ( T e. CatOLD /\ ( A e. O /\ B e. O ) /\
      ( G e. ( H ` <. A , B >. ) /\ F e. ( H ` <. B , A >. ) ) ) ->
      ( ( G R F ) = ( J ` B ) -> F e. ( MonoOLD ` T ) ) ) @=
      ( wcel wa cfv w3a co wceq ad2antrr vf vg vc ccatOLD cmonOLD cv wral oveq2
      cop simpl1 simplrl simpl2r jca simpl2l 3jca simplrr simpl3r cmpassoh sylc
      simpl3l eqeq12d simpllr oveq1d biimpd simpll1 adantr cmphmia syl3anc impr
      wi simpr cdm cdom_ ccod_ eqcomi dmeqi eqtri eleq2i biimpi adantl 3ad2ant2
      cid_ simprl eqid ehm imp cehm cmpida sylibd sylbid syl5 ralrimivva ismonc
      ralrimiva wb syl121anc mpbird ex ) DUDNZAINZBINZOZFABUIGPNZEBAUIGPNZOZQZF
      ECRZBHPZSZEDUEPNZXFXIOZXJEUAUFZCRZEUBUFZCRZSZXLXNSZVJZUBUCUFZBUIGPZUGZUAX
      TUGUCIUGZXKYAUCUAIXTXKXSINZXLXTNZOZOZXRUBXTXPFXMCRZFXOCRZSZYFXNXTNZOZXQXM
      XOFCUHYKYIXGXLCRZXGXNCRZSZXQYKYGYLYHYMYKWSYCXAOZXBQZYDXDXCQYGYLSYKWSYOXBX
      KWSYEYJWSXBXEXIUJZTZYKYCXAXKYCYDYJUKXKXAYEYJWTXAWSXEXIULZTZUMYKWTXAXKWTYE
      YJWTXAWSXEXIUNZTYTUMUOZYKYDXDXCXKYCYDYJUPXKXDYEYJXCXDWSXBXIUQZTZXKXCYEYJX
      CXDWSXBXIUTTZUOXSBABCDGXLEFIJKLURUSYKYPYJXDXCQYHYMSUUBYKYJXDXCYFYJVKUUDUU
      EUOXSBABCDGXNEFIJKLURUSVAYKYNXHXLCRZXHXNCRZSZXQYKYNUUHYKYLUUFYMUUGYKXGXHX
      LCXFXIYEYJVBZVCYKXGXHXNCUUIVCVAVDYKUUFXLUUGXNYFUUFXLSZYJXKYCYDUUJXKYCOWSY
      CXAYDUUJVJWSXBXEXIYCVEXKYCVKXKXAYCYSVFXSBCDXLGHIJKMLVGVHVIVFYKWSBHVLZNZXN
      DVMPZVLZNZQXNDVNPZPBSZUUGXNSYKWSUULUUOYRXKUULYEYJXFUULXIXBWSUULXEXAUULWTX
      AUULIUUKBIDWBPZVLUUKJUURHHUURMVOVPVQVRVSVTWAVFTYFYJUUOYFWSYCXAYJUUOVJWSXB
      XEXIYEVEZXKYCYDWCZXKXAYEYSVFZXSBDXNGUUNIJUUNWDZKWEVHWFUOYFYJUUQYFWSYCXAYJ
      UUQVJUUSUUTUVAXSBUUPDXNGIJUUPWDZKWGVHWFBUUPUUMCDXNHUUNUUKUVBUUMWDUUKWDMLU
      VCWHUSVAWIWJWKWNWLXKWSXAWTXDXJYBWOYQYSUUAUUCBACDUAUBEGIUCJKLWMWPWQWR @.
  @}

  @{
    immon.1 @e |- O = dom ( id_ ` T ) @.
    immon.2 @e |- J = ( id_ ` T ) @.
    @( A morphism identity is a monomorphism.  JFM CAT_1 th. 64.  (Contributed
       by FL, 5-May-2008.) @)
    immon @p |- ( ( T e. CatOLD /\ A e. O )
         -> ( J ` A ) e. ( MonoOLD ` T ) ) @=
      ( ccatOLD wcel wa cfv cop chomOLD w3a co_ co wceq cmonOLD simpl jca eqid
      simpr homib 3jca iri idmon sylc ) BGHZADHZIZUGUHUHIZACJZAAKBLJZJHZUMIZMUK
      UKBNJZOUKPUKBQJHUIUGUJUNUGUHRUIUHUHUGUHUAZUPSUIUMUMABULCDEFULTZUBZURSUCAU
      OBCDEFUOTZUDAAUOBUKUKULCDEUQUSFUEUF @.
  @}

  @{
    @d C x y @.  @d D x y @.  @d M f g h x y @.  @d R x y @.  @d T f g h x y @.
    isepia.1 @e |- M = dom ( dom_ ` T ) @.
    isepia.2 @e |- D = ( dom_ ` T ) @.
    isepia.3 @e |- C = ( cod_ ` T ) @.
    isepia.4 @e |- R = ( o_ ` T ) @.
    @( Epimorphisms of a category ` T ` .  (Contributed by FL, 8-Aug-2008.)
       (Revised by Mario Carneiro, 11-Sep-2015.) @)
    isepia @p |- ( T e. CatOLD -> ( Epic ` T ) = { f e. M |
      A. g e. M A. h e. M
        ( ( ( C ` g ) = ( C ` h ) /\
            ( D ` g ) = ( C ` f ) /\
            ( D ` h ) = ( C ` f ) ) ->
              ( ( g R f ) = ( h R f ) -> g = h ) ) } ) @=
      ( cv cfv wceq cdom_ co wi wral fveq1d vx w3a co_ cdm crab ccatOLD cepiOLD
      ccod_ fveq2 dmeqd syl6eqr eqcomi a1i eqtrd eqeq12d 3anbi123d oveqd imbi1d
      imbi12d raleqbidv rabeqbidv df-epiOLD cvv fvex dmex eqeltri rabex fvmpt )
      UADFMZUAMZUHNZNZGMZVKNZOZVIVJPNZNZEMZVKNZOZVMVPNZVSOZUBZVIVRVJUCNZQZVMVRW
      DQZOZVIVMOZRZRZGVPUDZSZFWKSZEWKUEVIANZVMANZOZVIBNZVRANZOZVMBNZWROZUBZVIVR
      CQZVMVRCQZOZWHRZRZGHSZFHSZEHUEUFUGVJDOZWMXIEWKHXJWKDPNZUDZHXJVPXKVJDPUIZU
      JIUKZXJWLXHFWKHXNXJWJXGGWKHXNXJWCXBWIXFXJVOWPVTWSWBXAXJVLWNVNWOXJVLVIDUHN
      ZNWNXJVIVKXOVJDUHUIZTXJVIXOAXOAOXJAXOKULUMZTUNXJVMVKAXJVKXOAXPKUKTUOXJVQW
      QVSWRXJVIVPBXJVPXKBXMJUKZTXJVSVRXONWRXJVRVKXOXPTXJVRXOAXQTUNZUOXJWAWTVSWR
      XJVMVPBXRTXSUOUPXJWGXEWHXJWEXCWFXDXJWEVIVRDUCNZQXCXJWDXTVIVRVJDUCUIZUQXJX
      TCVIVRXTCOXJCXTLULUMZUQUNXJWFVMVRXTQXDXJWDXTVMVRYAUQXJXTCVMVRYBUQUNUOURUS
      UTUTVAUAEFGVBXIEHHXLVCIXKDPVDVEVFVGVH @.
  @}

  @{
    @d C f @.  @d D f @.  @d F f g h @.  @d M f g h @.  @d R f @.
    @d T f g h @.
    isepib.1 @e |- M = dom ( dom_ ` T ) @.
    isepib.2 @e |- D = ( dom_ ` T ) @.
    isepib.3 @e |- C = ( cod_ ` T ) @.
    isepib.4 @e |- R = ( o_ ` T ) @.
    @( The predicate "is an epimorphism".  (Contributed by FL, 8-Aug-2008.) @)
    isepib @p |- ( T e. CatOLD -> ( F e. ( Epic ` T )
      <-> ( F e. M /\ A. g e. M A. h e. M
        ( ( ( C ` g ) = ( C ` h ) /\
            ( D ` g ) = ( C ` F ) /\
            ( D ` h ) = ( C ` F ) ) ->
              ( ( g R F ) = ( h R F ) -> g = h ) ) ) ) ) @=
      ( vf wcel cfv cv wceq co wi wral ccatOLD cepiOLD w3a crab wa isepia fveq2
      eleq2d eqeq2d 3anbi23d oveq2 eqeq12d imbi1d imbi12d 2ralbidv elrab syl6bb
      ) DUANZGDUBOZNGEPZAOFPZAOQZUTBOZMPZAOZQZVABOZVEQZUCZUTVDCRZVAVDCRZQZUTVAQ
      ZSZSZFHTEHTZMHUDZNGHNVBVCGAOZQZVGVRQZUCZUTGCRZVAGCRZQZVMSZSZFHTEHTZUEURUS
      VQGABCDMEFHIJKLUFUHVPWGMGHVDGQZVOWFEFHHWHVIWAVNWEWHVFVSVHVTVBWHVEVRVCVDGA
      UGZUIWHVEVRVGWIUIUJWHVLWDVMWHVJWBVKWCVDGUTCUKVDGVACUKULUMUNUOUPUQ @.
  @}

  @{
    @d F g h @.  @d M g h @.  @d T g h @.
    isepib1.1 @e |- M = dom ( dom_ ` T ) @.
    isepib1.2 @e |- D = ( dom_ ` T ) @.
    isepib1.3 @e |- C = ( cod_ ` T ) @.
    isepib1.4 @e |- R = ( o_ ` T ) @.
    @( The predicate "is an epimorphism".  (Contributed by FL, 10-Aug-2008.) @)
    isepib1 @p |- ( ( T e. CatOLD /\ F e. M ) -> ( F e. ( Epic ` T ) <->
      A. g e. M A. h e. M
        ( ( ( C ` g ) = ( C ` h ) /\
            ( D ` g ) = ( C ` F ) /\
            ( D ` h ) = ( C ` F ) ) ->
              ( ( g R F ) = ( h R F ) -> g = h ) ) ) ) @=
      ( ccatOLD wcel cfv cv wceq co wi wral cepiOLD w3a isepib baibd ) DMNGDUAO
      NGHNEPZAOFPZAOQUEBOGAOZQUFBOUGQUBUEGCRUFGCRQUEUFQSSFHTEHTABCDEFGHIJKLUCUD
      @.
  @}

  @{
    @d C g j @.  @d D g j @.  @d F g j @.  @d G g j @.  @d J j @.  @d M g j @.
    @d R g j @.  @d T g j @.
    isepib2.1 @e |- M = dom ( dom_ ` T ) @.
    isepib2.2 @e |- D = ( dom_ ` T ) @.
    isepib2.3 @e |- C = ( cod_ ` T ) @.
    isepib2.4 @e |- R = ( o_ ` T ) @.
    @( An epimorphism is a right-cancelable morphism.  (Contributed by FL,
       10-Aug-2008.) @)
    isepib2 @p |- ( ( T e. CatOLD /\ ( F e. M /\ G e. M /\ J e. M ) ) ->
      ( F e. ( Epic ` T ) ->
        ( ( ( C ` G ) = ( C ` J ) /\
            ( D ` G ) = ( C ` F ) /\
            ( D ` J ) = ( C ` F ) ) ->
              ( ( G R F ) = ( J R F ) -> G = J ) ) ) ) @=
      ( vg vj wcel w3a cfv wceq co wi ccatOLD wa cepiOLD wral isepib1 3ad2antr1
      cv 3simpc adantl fveq2 eqeq1d 3anbi12d oveq1 eqeq1 imbi12d 3anbi13d eqeq2
      wb eqeq2d rspc2v syl sylbid ) DUAOZEHOZFHOZGHOZPZUBZEDUCQOZMUGZAQZNUGZAQZ
      RZVJBQZEAQZRZVLBQZVPRZPZVJECSZVLECSZRZVJVLRZTZTZNHUDMHUDZFAQZGAQZRZFBQZVP
      RZGBQZVPRZPZFECSZGECSZRZFGRZTZTZVCVEVDVIWGURVFABCDMNEHIJKLUEUFVHVEVFUBZWG
      XATVGXBVCVDVEVFUHUIWFXAWHVMRZWLVSPZWPWBRZFVLRZTZTMNFGHHVJFRZVTXDWEXGXHVNX
      CVQWLVSXHVKWHVMVJFAUJUKXHVOWKVPVJFBUJUKULXHWCXEWDXFXHWAWPWBVJFECUMUKVJFVL
      UNUOUOVLGRZXDWOXGWTXIXCWJVSWNWLXIVMWIWHVLGAUJUSXIVRWMVPVLGBUJUKUPXIXEWRXF
      WSXIWBWQWPVLGECUMUSVLGFUQUOUOUTVAVB @.
  @}

  @{
    @d A c g h @.  @d B c g h @.  @d F c g h @.  @d H c g h @.  @d O c g h @.
    @d R c @.  @d T c g h @.
    iepiclem.1 @e |- O = dom ( id_ ` T ) @.
    iepiclem.2 @e |- H = ( hom ` T ) @.
    iepiclem.3 @e |- R = ( o_ ` T ) @.
    @( Lemma for ~ isepic .  (Contributed by FL, 6-Oct-2008.) @)
    iepiclem @p |- ( ( T e. CatOLD
                         /\ ( A e. O /\ B e. O )
                         /\ F e. ( H ` <. A , B >. ) )
                      -> ( A. c
                            e. O
                               A. g
                               e. ( H ` <. B , c >. )
                                  A. h
                                  e. ( H ` <. B , c >. )
                                     ( ( g R F ) = ( h R F ) -> g = h )
                         -> ( F e. dom ( dom_ ` T )
                            /\ A. g
                               e. dom ( dom_ ` T )
                                  A. h
                                  e. dom ( dom_ ` T )
                                     ( ( ( ( cod_ ` T ) ` g )
                                           = ( ( cod_ ` T ) ` h )
                                        /\ ( ( dom_ ` T ) ` g )
                                           = ( ( cod_ ` T ) ` F )
                                        /\ ( ( dom_ ` T ) ` h )
                                           = ( ( cod_ ` T ) ` F ) )
                                     -> ( ( g R F ) = ( h R F ) -> g = h ) ) )
                         ) ) @=
      ( wcel wa cfv w3a wceq wi wb ccatOLD cop cv wral cdom_ cdm ccod_ eqid ehm
      3expib 3imp adantr wal nfv nfra2 nfan nfcv nfral rsp2 ralimi cdmo adantrd
      co ex 3ad2ant1 imp opeq2 fveq2d eleq2d anbi12d anim12d ancrd ishomd com12
      adantl impcom 3adant3 adantrr biimpd eqeq2 eqcoms 3anbi2d biimpi 3ad2ant3
      3exp eqcom simpl2 simpr2 3jca simpll eqidd simplr simpr3 impbid2 sylan9bb
      jca bitrd syld sylan9bbr imbi1d rspcdv syl5 impancom alrimi r2al sylibr
      syl ) DUANZAINZBINZOZGABUBHPNZQZEUCZGCVCFUCZGCVCRXNXORSZFBJUCZUBZHPZUDZEX
      SUDZJIUDZGDUEPZUFZNZXNDUGPZPZXOYFPZRZXNYCPZGYFPZRZXOYCPZYKRZQZXPSZFYDUDEY
      DUDZOXMYBOZYEYQXMYEYBXHXKXLYEXHXIXJXLYESABDGHYDIKYDUHZLUIUJUKULYRXNYDNZXO
      YDNZOZYPSZFUMZEUMYQYRUUDEXMYBEXMEUNXTJEIXSUOUPYRUUCFXMYBFXMFUNYAFJIFIUQXP
      EFXSXSUOURUPXMUUBYBYPYBXNXSNZXOXSNZOZXPSZJIUDXMUUBOZYPYAUUHJIXPEFXSXSUSUT
      UUIUUHYPJYGIXMUUBYGINZXHXKUUBUUJSXLXHYTUUJUUAXHYTUUJYFDXNYDIYSKYFUHZVAVDZ
      VBVEVFUUIXQYGRZOUUGYOXPUUMUUGXNBYGUBZHPZNZXOUUONZOZUUIYOUUMUUEUUPUUFUUQUU
      MXSUUOXNUUMXRUUNHXQYGBVGVHZVIUUMXSUUOXOUUSVIVJXMUUBUURYOTZXMUUBUUJYHINZOZ
      UUBOZUUTXMUUBUVBXHXKUUBUVBSXLXHYTUUJUUAUVAUULXHUUAUVAYFDXOYDIYSKUUKVAVDVK
      VEVLXMUVCUUTXMUVCOUURYTYJBRZYGYGRZQZUUAYMBRZYHYGRZQZOZYOXMUVBUURUVJTUUBXM
      UVBOUUPUVFUUQUVIUVBXMUUPUVFTZUUJXMUVKSUVAXMUUJUVKXHXKUUJUVKSZXLXKXHUVLXJX
      HUVLSXIXHXJUVLXHXJUUJUVKBYGYFYCDXNHYDIKYSYCUHZUUKLVMWEVNVOVPVQVNULVPUVBXM
      UUQUVITZUUJXMUVNSUVAXMUUJUVNXHXKUUJUVNSZXLXKXHUVOXJXHUVOSXIXHXJUVOXHXJUUJ
      UVNBYGYFYCDXOHYDIKYSUVMUUKLVMWEVNVOVPVQVNULVPVJVRUVCXMUVJYOTZUUBXMUVPSUVB
      XMUUBUVPXMYEGYCPARZYKBRZQZUUBUVPSZXHXKXLUVSXHXIXJXLUVSSXHXIXJQXLUVSABYFYC
      DGHYDIKYSUVMUUKLVMVSUJUKUVRYEUVTUVQUVRUUBUVPUVRUVJYTYLUVEQZUUAYNUVHQZOZUU
      BYOUVRUVFUWAUVIUWBUVRUVDYLYTUVEUVDYLTBYKBYKYJVTWAWBUVRUVGYNUUAUVHUVGYNTBY
      KBYKYMVTWAWBVJUUBUWCYOUWCYIYLYNUWBYIUWAUVHUUAYIYNUVHYIYHYGWFWCWDVOYTYLUVE
      UWBWGUWAUUAYNUVHWHWIUUBYOUWCUUBYOOZUWAUWBUWDYTYLUVEYTUUAYOWJUUBYIYLYNWHUW
      DYGWKWIUWDUUAYNUVHYTUUAYOWLUUBYIYLYNWMYOUVHUUBYIYLUVHYNYIUVHYGYHWFWCVEVOW
      IWPVDWNWOVDWDXGVNVOVPWQVDWRVFWSWTXAXBXCXDXDYPEFYDYDXEXFWPVD @.
  @}

  @{
    @d A c g h @.  @d B c g h @.  @d F c g h @.  @d H c g h @.  @d O c g h @.
    @d R c @.  @d T c g h @.
    isepic.1 @e |- O = dom ( id_ ` T ) @.
    isepic.2 @e |- H = ( hom ` T ) @.
    isepic.3 @e |- R = ( o_ ` T ) @.
    @( The predicate "is an epimorphism" when the morphism belongs to a
       homset.  (Contributed by FL, 27-Oct-2008.) @)
    isepic @p |- ( ( T e. CatOLD /\ ( A e. O /\ B e. O ) /\
      F e. ( H ` <. A , B >. ) ) -> ( F e. ( Epic ` T ) <->
        A. c e. O A. g e. ( H ` <. B , c >. ) A. h e. ( H ` <. B , c >. )
        ( ( g R F ) = ( h R F ) -> g = h ) ) ) @=
      ( wcel wa cfv w3a wceq wi wral ccatOLD cop cepiOLD cdom_ cv ccod_ co eqid
      cdm isepib 3ad2ant1 wal nfv nfra1 nfan nfra2 rsp2 pm3.31 simpll1 ad2antrr
      simp2r simplr ishomd biimpd anim12d syl3anc simp1 anim12i a1i cehm expcom
      wb eqtr eqcoms 3ad2ant3 com12 imp adantl 3ad2ant2 adantr impcom 3jca syl6
      3expib 3imp jcad syld imim1d com13 3syl alrimi exp31 com23 alrimiv ralbii
      ex r2al df-ral bitri sylibr iepiclem impbid bitrd ) DUANZAINZBINZOZGABUBH
      PNZQZGDUCPNZGDUDPZUIZNZEUEZDUFPZPZFUEZXOPZRZXNXKPZGXOPZRZXQXKPZYARZQZXNGC
      UGXQGCUGRXNXQRSZSZFXLTZEXLTZOZYFFBJUEZUBHPZTEYLTZJITZXDXGXJYJVLXHXOXKCDEF
      GXLXLUHZXKUHZXOUHZMUJUKXIYJYNXIYJYNXIYJOZYKINZXNYLNZXQYLNZOZYFSZFULZEULZS
      ZJULZYNYRUUFJXIYJUUFXIYSYJUUEXIYSYJUUEXIYSOZYJOZUUDEUUHYJEUUHEUMXMYIEXMEU
      MYHEXLUNUOUOUUIUUCFUUHYJFUUHFUMXMYIFXMFUMYGEFXLXLUPUOUOYJUUHUUCYIXMUUHUUC
      SZYIXNXLNZXQXLNZOZYGSUUMYEOZYFSZXMUUJSYGEFXLXLUQUUMYEYFURUUHXMUUOUUCUUHXM
      UUOUUCSUUHXMOZUUBUUNYFUUPUUBUUKXTBRZXPYKRZQZUULYCBRZXRYKRZQZOZUUNUUPXDXFY
      SUUBUVCSXDXGXHYSXMUSXIXFYSXMXDXEXFXHVAUTXIYSXMVBXDXFYSQZYTUUSUUAUVBUVDYTU
      USBYKXOXKDXNHXLIKYOYPYQLVCVDUVDUUAUVBBYKXOXKDXQHXLIKYOYPYQLVCVDVEVFUUPUVC
      UUMYEUVCUUMSUUPUUSUUKUVBUULUUKUUQUURVGUULUUTUVAVGVHVIXIUVCYESZYSXMXDXGXHU
      VEXDXEXFXHUVESXDXEXFQXHYABRZUVEABXODGHIKYQLVJUVFUVCYEUVFUVCOXSYBYDUVCXSUV
      FUUSUVBXSUURUUKUVBXSSUUQUVBUURXSUVAUULUURXSSZUUTUVGYKXRUURYKXRRXSXPYKXRVM
      VKVNVOVPVOVQVRUVCUVFYBUUSUVFYBSZUVBUUQUUKUVHUURUVFUUQYBUUQYBSBYAUUQBYARZY
      BXTBYAVMVKVNVPVSVTWAUVCUVFYDUVBUVFYDSZUUSUUTUULUVJUVAUVFUUTYDUUTYDSBYAUUT
      UVIYDYCBYAVMVKVNVPVSVRWAWBWPWCWDWEUTWFWGWHWPWIWJWAWAWKWKWLWMVQWNYNUUEJITU
      UGYMUUEJIYFEFYLYLWQWOUUEJIWRWSWTWPABCDEFGHIJKLMXAXBXC @.
  @}

  @{
    @d x C @.  @d x D @.  @d x J @.  @d f g x M @.  @d x R @.  @d f g x T @.
    isiso.1 @e |- M = dom ( dom_ ` T ) @.
    isiso.2 @e |- D = ( dom_ ` T ) @.
    isiso.3 @e |- C = ( cod_ ` T ) @.
    isiso.4 @e |- R = ( o_ ` T ) @.
    isiso.5 @e |- J = ( id_ ` T ) @.
    @( Isomorphisms of a category.  (Contributed by FL, 9-Jun-2014.)  (Revised
       by Mario Carneiro, 11-Sep-2015.) @)
    isiso @p |- ( T e. CatOLD -> ( IsoOLD ` T ) = { f e. M | E. g e. M
      ( ( D ` g ) = ( C ` f ) /\
        ( C ` g ) = ( D ` f ) /\
        ( ( f R g ) = ( J ` ( D ` g ) ) /\ ( g R f ) = ( J ` ( D ` f ) ) )
      ) } ) @=
      ( cdom_ cfv wceq co fveq2 syl6eqr fveq1d vx cv ccod_ co_ cid_ wa w3a wrex
      ccatOLD cisoOLD dmeqd eqeq12d oveqd fveq12d 3anbi123d rexeqbidv rabeqbidv
      cdm crab anbi12d df-isoc cvv fvex dmex eqeltri rabex fvmpt ) UADFUBZUAUBZ
      NOZOZEUBZVIUCOZOZPZVHVMOZVLVJOZPZVLVHVIUDOZQZVKVIUEOZOZPZVHVLVSQZVQWAOZPZ
      UFZUGZFVJURZUHZEWIUSVHBOZVLAOZPZVHAOZVLBOZPZVLVHCQZWKGOZPZVHVLCQZWOGOZPZU
      FZUGZFHUHZEHUSUIUJVIDPZWJXEEWIHXFWIDNOZURZHXFVJXGVIDNRZUKISZXFWHXDFWIHXJX
      FVOWMVRWPWGXCXFVKWKVNWLXFVHVJBXFVJXGBXIJSZTZXFVLVMAXFVMDUCOAVIDUCRKSZTULX
      FVPWNVQWOXFVHVMAXMTXFVLVJBXKTZULXFWCWSWFXBXFVTWQWBWRXFVSCVLVHXFVSDUDOCVID
      UDRLSZUMXFVKWKWAGXFWADUEOGVIDUERMSZXLUNULXFWDWTWEXAXFVSCVHVLXOUMXFVQWOWAG
      XPXNUNULUTUOUPUQUAEFVAXEEHHXHVBIXGDNVCVDVEVFVG @.
  @}

  @c cinvOLD @.
  @( Extend class notation to include a function that returns the inverses of a
     morphism. @)
  ccinv @a class cinvOLD @.

  @{
    @d x y f z g @.
    @( Function ( indexed by the category ` x ` ) returning the inverses of a
       morphism ` f ` .  (Contributed by FL, 22-Dec-2008.) @)
    df-cinv @a |- cinvOLD = ( x e. CatOLD |->
      ( f e. dom ( dom_ ` x ) |->
        { g e. dom ( dom_ ` x ) | ( ( f ( o_ ` x ) g ) =
      ( ( id_ ` x ) ` ( ( cod_ ` x ) ` f ) ) /\
     ( g ( o_ ` x ) f ) = ( ( id_ ` x ) ` ( ( dom_ ` x ) ` f ) ) ) } ) ) @.
  @}

  @{
    @d t C @.  @d t D @.  @d t J @.  @d f g t M @.  @d t R @.  @d f g t T @.
    cinvlem1.1 @e |- M = dom ( dom_ ` T ) @.
    cinvlem1.2 @e |- D = ( dom_ ` T ) @.
    cinvlem1.3 @e |- C = ( cod_ ` T ) @.
    cinvlem1.4 @e |- R = ( o_ ` T ) @.
    cinvlem1.5 @e |- J = ( id_ ` T ) @.
    @( The set of the inverses of all the morphisms .  (Contributed by FL,
       22-Dec-2008.) @)
    cinvlem1 @p |- ( T e. CatOLD -> ( cinvOLD ` T ) = ( f e. M |-> { g e. M |
    ( ( f R g ) = ( J ` ( C ` f ) ) /\ ( g R f ) = ( J ` ( D ` f ) ) ) } ) ) @=
      ( vt cdom_ cfv co wceq fveq2 syl6eqr cdm co_ ccod_ cid_ crab cmpt ccatOLD
      cv ccinv dmeqd fveq1d fveq12d eqeq12d anbi12d rabeqbidv mpteq12dv df-cinv
      wa oveqd cvv fvex dmex eqeltri mptex fvmpt ) NDENUHZOPZUAZEUHZFUHZVFUBPZQ
      ZVIVFUCPZPZVFUDPZPZRZVJVIVKQZVIVGPZVOPZRZURZFVHUEZUFEHVIVJCQZVIAPZGPZRZVJ
      VICQZVIBPZGPZRZURZFHUEZUFUGUIVFDRZEVHWCHWMWNVHDOPZUAZHWNVGWOVFDOSZUJITZWN
      WBWLFVHHWRWNVQWGWAWKWNVLWDVPWFWNVKCVIVJWNVKDUBPCVFDUBSLTZUSWNVNWEVOGWNVOD
      UDPGVFDUDSMTZWNVIVMAWNVMDUCPAVFDUCSKTUKULUMWNVRWHVTWJWNVKCVJVIWSUSWNVSWIV
      OGWTWNVIVGBWNVGWOBWQJTUKULUMUNUOUPNEFUQEHWMHWPUTIWODOVAVBVCVDVE @.
  @}

  @{
    @d C f z @.  @d D f z @.  @d F f g z @.  @d J f z @.  @d M f g z @.
    @d R f z @.  @d T f g z @.
    cinvlem2.1 @e |- M = dom ( dom_ ` T ) @.
    cinvlem2.2 @e |- D = ( dom_ ` T ) @.
    cinvlem2.3 @e |- C = ( cod_ ` T ) @.
    cinvlem2.4 @e |- R = ( o_ ` T ) @.
    cinvlem2.5 @e |- J = ( id_ ` T ) @.
    cinvlem2.6 @e |- T e. CatOLD @.
    @( The set of the inverses of the morphism ` F ` .  (Contributed by FL,
       22-Dec-2008.) @)
    cinvlem2 @p |- ( F e. M -> ( ( cinvOLD ` T ) ` F ) = { g e. M |
      ( ( F R g ) = ( J ` ( C ` F ) ) /\ ( g R F ) = ( J ` ( D ` F ) ) ) } ) @=
      ( vf cv co cfv wceq wa ccinv oveq1 fveq2d eqeq12d anbi12d rabbidv ccatOLD
      crab fveq2 oveq2 wcel cmpt cinvlem1 ax-mp cdom_ cdm cvv fvex dmex eqeltri
      rabex fvmpt ) OFOPZEPZCQZVCARZGRZSZVDVCCQZVCBRZGRZSZTZEHUHZFVDCQZFARZGRZS
      ZVDFCQZFBRZGRZSZTZEHUHHDUARZVCFSZVMWCEHWEVHVRVLWBWEVEVOVGVQVCFVDCUBWEVFVP
      GVCFAUIUCUDWEVIVSVKWAVCFVDCUJWEVJVTGVCFBUIUCUDUEUFDUGUKWDOHVNULSNABCDOEGH
      IJKLMUMUNWCEHHDUORZUPUQIWFDUOURUSUTVAVB @.
  @}

  @{
    @d C g @.  @d D g @.  @d F g @.  @d G g @.  @d J g @.  @d M g @.  @d R g @.
    @d T g @.
    cinvlem3.1 @e |- M = dom ( dom_ ` T ) @.
    cinvlem3.2 @e |- D = ( dom_ ` T ) @.
    cinvlem3.3 @e |- C = ( cod_ ` T ) @.
    cinvlem3.4 @e |- R = ( o_ ` T ) @.
    cinvlem3.5 @e |- J = ( id_ ` T ) @.
    cinvlem3.6 @e |- T e. CatOLD @.
    cinvlem3.7 @e |- F e. M @.
    @( The set of the inverses of the morphism ` F ` .  (Contributed by FL,
       22-Dec-2008.) @)
    cinvlem3 @p |- ( G e. ( ( cinvOLD ` T ) ` F ) <-> ( G e. M /\
      ( F R G ) = ( J ` ( C ` F ) ) /\ ( G R F ) = ( J ` ( D ` F ) ) ) ) @=
      ( vg co cfv wceq wcel cv wa ccinv w3a oveq2 eqeq1d oveq1 anbi12d cinvlem2
      crab elrab ax-mp eleq2i 3anass 3bitr4i ) FEPUAZCQZEARGRZSZUPECQZEBRGRZSZU
      BZPHUJZTFHTZEFCQZURSZFECQZVASZUBZUBFEDUCRRZTVEVGVIUDVCVJPFHUPFSZUSVGVBVIV
      LUQVFURUPFECUEUFVLUTVHVAUPFECUGUFUHUKVKVDFEHTVKVDSOABCDPEGHIJKLMNUIULUMVE
      VGVIUNUO @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Functors
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( The class of all functors. @)
  @c FuncOLD @.

  @( The class of all isomorphisms. @)
  @c Isofunc @.

  @( Extend class notation with the class of all functors. @)
  cfuncOLD @a class FuncOLD @.

  @( Extend class notation with the class of all isomorphisms. @)
  cifunc @a class Isofunc @.

  @{
    @d t u v f o p m n @.
    @( Function returning all the functors from a category ` t ` to a category
       ` u ` .  Intuitively a functor associates any morphism of ` t ` to a
       morphism of ` u ` , any object of ` t ` to an object of ` u ` , and
       respects the identity, the composition, the domain and the codomain.
       Here to capture the idea that a functor associates any object of ` t `
       to an object of ` u ` we write it associates any identity of ` t ` to an
       identity of ` u ` which simplifies the definition.  (Contributed by FL,
       10-Feb-2008.) @)
    df-funcOLD @a |- FuncOLD = ( t e. CatOLD , u e. CatOLD |->
      { f e. ( dom ( dom_ ` u ) ^m dom ( dom_ ` t ) ) |
      ( A. o e. dom ( id_ ` t )
      E. p e. dom ( id_ ` u ) ( f ` ( ( id_ ` t ) ` o ) ) =
           ( ( id_ ` u ) ` p ) /\
      ( A. m e. dom ( dom_ ` t )
        ( f ` ( ( id_ ` t ) ` ( ( dom_ ` t ) ` m ) ) ) =
           ( ( id_ ` u ) ` ( ( dom_ ` u ) ` ( f ` m ) ) ) /\
       A. m e. dom ( dom_ ` t )
        ( f ` ( ( id_ ` t ) ` ( ( cod_ ` t ) ` m ) ) ) =
           ( ( id_ ` u ) ` ( ( cod_ ` u ) ` ( f ` m ) ) ) ) /\
       A. m e. dom ( dom_ ` t ) A. n e. dom ( dom_ ` t )
        ( ( ( cod_ ` t ) ` n ) = ( ( dom_ ` t ) ` m ) ->
          ( f ` ( m ( o_ ` t ) n ) ) =
           ( ( f ` m ) ( o_ ` u ) ( f ` n ) ) ) ) } ) @.
  @}

  @{
    @d t u C1 @.  @d t u C2 @.  @d t u D1 @.  @d f m n t u M1 @.  @d t u Ro1 @.
    @d t u D2 @.  @d f t u M2 @.  @d o t u O1 @.  @d p t u O2 @.  @d t u Ro2 @.
    @d t u I1 @.  @d t u I2 @.  @d f m n o p t u T @.  @d f m n o p t u U @.
    isfuna.1 @e |- O1 = dom ( id_ ` T ) @.
    isfuna.2 @e |- M1 = dom ( dom_ ` T ) @.
    isfuna.3 @e |- D1 = ( dom_ ` T ) @.
    isfuna.4 @e |- C1 = ( cod_ ` T ) @.
    isfuna.5 @e |- I1 = ( id_ ` T ) @.
    isfuna.6 @e |- Ro1 = ( o_ ` T ) @.
    isfuna.7 @e |- O2 = dom ( id_ ` U ) @.
    isfuna.8 @e |- M2 = dom ( dom_ ` U ) @.
    isfuna.9 @e |- D2 = ( dom_ ` U ) @.
    isfuna.10 @e |- C2 = ( cod_ ` U ) @.
    isfuna.11 @e |- I2 = ( id_ ` U ) @.
    isfuna.12 @e |- Ro2 = ( o_ ` U ) @.
    @( The class of functors between the categories ` T ` and ` U ` .
       (Contributed by FL, 10-Feb-2008.) @)
    isfuna @p |- ( ( T e. CatOLD /\ U e. CatOLD )
   -> ( FuncOLD ` <. T , U >. ) =
      { f e. ( M2 ^m M1 ) |
       ( A. o e. O1 E. p e. O2 ( f ` ( I1 ` o ) ) = ( I2 ` p ) /\
        ( A. m e. M1 ( f ` ( I1 ` ( D1 ` m ) ) ) =
            ( I2 ` ( D2 ` ( f ` m ) ) ) /\
          A. m e. M1 ( f ` ( I1 ` ( C1 ` m ) ) ) =
            ( I2 ` ( C2 ` ( f ` m ) ) ) ) /\
          A. m e. M1 A. n e. M1 ( ( C1 ` n ) = ( D1 ` m ) ->
            ( f ` ( m Ro1 n ) ) = ( ( f ` m ) Ro2 ( f ` n ) ) ) ) } ) @=
      ( vt vu ccatOLD wcel wa cop cfuncOLD cfv co cv wceq wrex wral wi w3a cmap
      crab df-ov cid_ cdm cdom_ ccod_ co_ fveq2 dmeqd syl6eqr oveqan12rd eqcomd
      sylan9eq adantl fveq1d fveq2d eqeq1d eqeq12d sylan9bb rexeqbidv raleqbidv
      adantr fveq12d 3eqtrd eqeqan12d eleq2d bicomd imbi12d ralbidv2 anbi12d wb
      a1i oveqd 3anbi123d rabeqbidv df-funcOLD ovex rabex ovmpt2a syl5eqr ) AUN
      UOBUNUOUPABUQURUSABURUTFVAZLUSZCVAZUSZGVAZPUSZVBZGJVCZFHVDZDVAZMUSZLUSZXJ
      USZXQXJUSZQUSZPUSZVBZDIVDZXQNUSZLUSZXJUSZYARUSZPUSZVBZDIVDZUPZEVAZNUSZXRV
      BZXQYNOUTZXJUSZYAYNXJUSZSUTZVBZVEZEIVDZDIVDZVFZCKIVGUTZVHZABURVIULUMABUNU
      NXHULVAZVJUSZUSZXJUSZXLUMVAZVJUSZUSZVBZGUUMVKZVCZFUUIVKZVDZXQUUHVLUSZUSZU
      UIUSZXJUSZYAUULVLUSZUSZUUMUSZVBZDUUTVKZVDZXQUUHVMUSZUSZUUIUSZXJUSZYAUULVM
      USZUSZUUMUSZVBZDUVHVDZUPZYNUVJUSZUVAVBZXQYNUUHVNUSZUTZXJUSZYAYSUULVNUSZUT
      ZVBZVEZEUVHVDZDUVHVDZVFZCUVDVKZUVHVGUTZVHUUGURUUHAVBZUULBVBZUPZUWKUUECUWM
      UUFUWOUWNUWLKUVHIVGUWOUWLBVLUSZVKKUWOUVDUWQUULBVLVOZVPUGVQUWNUVHAVLUSZVKZ
      IUWNUUTUWSUUHAVLVOZVPZUAVQZVRUWPUUSXPUVSYMUWJUUDUWPUUQXOFUURHUWNUWOUURAVJ
      USZVKZHUWNUUIUXDUUHAVJVOZVPUWOHUXEHUXEVBUWOTWSVSVTUWPUUOXNGUUPJUWOUUPJVBU
      WNUWOUUPBVJUSZVKJUWOUUMUXGUULBVJVOZVPUFVQWAUWNUUOXHUXDUSZXJUSZUUNVBUWOXNU
      WNUUKUXJUUNUWNUUJUXIXJUWNXHUUIUXDUXFWBWCWDUWOUXJXKUUNXMUWOUXIXIXJUWOXHUXD
      LUWOLUXDLUXDVBUWOUDWSVSZWBWCUWOXLUUMPUWOUUMUXGPUXHUJVQZWBWEWFWGWHUWPUVIYE
      UVRYLUWPUVGYDDUVHIUWNUVHIVBUWOUXCWIZUWNUWOUVCXTUVFYCUWNUVBXSXJUWNUVAXRUUI
      LUWNUUIUXDLUXFUDVQUWNXQUUTMUWNUUTUWSMUXAUBVQWBZWJWCUWOUVFUVEUXGUSYAUWQUSZ
      UXGUSYCUWOUVEUUMUXGUXHWBUWOUVEUXOUXGUWOYAUVDUWQUWRWBWCUWOUXOYBUXGPUWOPUXG
      PUXGVBUWOUJWSVSUWOYAUWQQUWOQUWQQUWQVBUWOUHWSVSWBWJWKWLWHUWNUVRXQAVMUSZUSZ
      UXDUSZXJUSZUVPVBZDUWTVDUWOYLUWNUVQUXTDUVHUWTUXBUWNUVMUXSUVPUWNUVLUXRXJUWN
      UVKUXQUUIUXDUXFUWNXQUVJUXPUUHAVMVOZWBWJWCWDWHUWOUXTYKDUWTIUWOXQUWTUOZXQIU
      OZUXTYKUWOUYCUYBUWOIUWTXQIUWTVBUWOUAWSWMWNUWOUXSYHUVPYJUWOUXRYGXJUWOUXQYF
      UXDLUXKUWOXQUXPNUWONUXPNUXPVBUWOUCWSVSWBWJWCUWOUVOYIUUMPUXLUWOYAUVNRUWOUV
      NBVMUSRUULBVMVOUIVQWBWJWEWOWPWFWQUWPUWIUUCDUVHIUXMUWPUWHUUBEUVHIUXMUWPUWA
      YPUWGUUAUWNUWAYPWRUWOUWNUVTYOUVAXRUWNYNUVJNUWNUVJUXPNUYAUCVQWBUXNWEWIUWNU
      WOUWDYRUWFYTUWNUWCYQXJUWNUWBOXQYNUWNUWBAVNUSOUUHAVNVOUEVQWTWCUWOUWESYAYSU
      WOUWEBVNUSSUULBVNVOUKVQWTWLWOWHWHXAXBUMULCDEFGXCUUECUUFKIVGXDXEXFXG @.
  @}

  @{
    @d f C1 @.  @d f C2 @.  @d f D1 @.  @d f D2 @.  @d f m n M1 @.  @d f Ro1 @.
    @d f I1 @.  @d f I2 @.  @d f M2 @.  @d f o O1 @.  @d f p O2 @.  @d f Ro2 @.
    @d f m n o p F @.  @d f m n o p T @.  @d f m n o p U @.
    isfunb.1 @e |- O1 = dom ( id_ ` T ) @.
    isfunb.2 @e |- M1 = dom ( dom_ ` T ) @.
    isfunb.3 @e |- D1 = ( dom_ ` T ) @.
    isfunb.4 @e |- C1 = ( cod_ ` T ) @.
    isfunb.5 @e |- I1 = ( id_ ` T ) @.
    isfunb.6 @e |- Ro1 = ( o_ ` T ) @.
    isfunb.7 @e |- O2 = dom ( id_ ` U ) @.
    isfunb.8 @e |- M2 = dom ( dom_ ` U ) @.
    isfunb.9 @e |- D2 = ( dom_ ` U ) @.
    isfunb.10 @e |- C2 = ( cod_ ` U ) @.
    isfunb.11 @e |- I2 = ( id_ ` U ) @.
    isfunb.12 @e |- Ro2 = ( o_ ` U ) @.
    @( The predicate "is a functor" .  (Contributed by FL, 10-Feb-2008.) @)
    isfunb @p |- ( ( T e. CatOLD /\ U e. CatOLD ) ->
       ( F e. ( FuncOLD ` <. T , U >. ) <->
       ( F : M1 --> M2 /\ ( A. o e. O1
        E. p e. O2 ( F ` ( I1 ` o ) ) = ( I2 ` p ) /\
      ( A. m e. M1
       ( F ` ( I1 ` ( D1 ` m ) ) ) =
          ( I2 ` ( D2 ` ( F ` m ) ) ) /\
      A. m e. M1
       ( F ` ( I1 ` ( C1 ` m ) ) ) =
          ( I2 ` ( C2 ` ( F ` m ) ) ) ) /\
      A. m e. M1 A. n e. M1
       ( ( C1 ` n ) = ( D1 ` m ) ->
         ( F ` ( m Ro1 n ) ) =
          ( ( F ` m ) Ro2 ( F ` n ) ) ) ) ) ) ) @=
      ( vf ccatOLD wcel wa cop cfuncOLD cfv cv wceq wrex wral co wi w3a cmap wf
      isfuna eleq2d fveq1 eqeq1d rexbidv ralbidv fveq2d eqeq12d anbi12d oveq12d
      crab imbi2d 2ralbidv 3anbi123d elrab cdom_ cdm cvv fvex dmex elmap anbi1i
      eqeltri bitri syl6bb ) AUMUNBUMUNUOZFABUPUQURZUNFEUSLURZULUSZURZGUSPURZUT
      ZGJVAZEHVBZCUSZMURZLURZWPURZXBWPURZQURZPURZUTZCIVBZXBNURLURZWPURZXFRURZPU
      RZUTZCIVBZUOZDUSZNURXCUTZXBXROVCZWPURZXFXRWPURZSVCZUTZVDZDIVBCIVBZVEZULKI
      VFVCZVRZUNZIKFVGZWOFURZWRUTZGJVAZEHVBZXDFURZXBFURZQURZPURZUTZCIVBZXKFURZY
      QRURZPURZUTZCIVBZUOZXSXTFURZYQXRFURZSVCZUTZVDZDIVBCIVBZVEZUOZWMWNYIFABULC
      DEGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVHVIYJFYHUNZUUNUOUUOYGUUNULFYHWPFUT
      ZXAYOXQUUGYFUUMUUQWTYNEHUUQWSYMGJUUQWQYLWRWOWPFVJVKVLVMUUQXJUUAXPUUFUUQXI
      YTCIUUQXEYPXHYSXDWPFVJUUQXGYRPUUQXFYQQXBWPFVJZVNVNVOVMUUQXOUUECIUUQXLUUBX
      NUUDXKWPFVJUUQXMUUCPUUQXFYQRUURVNVNVOVMVPUUQYEUULCDIIUUQYDUUKXSUUQYAUUHYC
      UUJXTWPFVJUUQXFYQYBUUISUURXRWPFVJVQVOVSVTWAWBUUPYKUUNKIFKBWCURZWDWEUGUUSB
      WCWFWGWJIAWCURZWDWEUAUUTAWCWFWGWJWHWIWKWL @.
  @}

  @{
    @d w x y z F @.  @d x y M1 @.  @d w x y z T @.  @d w x y z U @.
    fmamo.1 @e |- M1 = dom ( dom_ ` T ) @.
    fmamo.2 @e |- M2 = dom ( dom_ ` U ) @.
    @( A functor is a mapping between morphisms.  (Contributed by FL,
       10-Feb-2008.) @)
    fmamo @p |- ( ( T e. CatOLD /\ U e. CatOLD ) ->
      ( F e. ( FuncOLD ` <. T , U >. ) -> F : M1 --> M2 ) ) @=
      ( vz vw vx vy ccatOLD wcel wa cfv cv cid_ wceq wral eqid cop cfuncOLD cdm
      wf wrex cdom_ ccod_ co_ co wi w3a isfunb simprbda ex ) ALMBLMNZCABUAUBOMZ
      DECUDZUOUPUQHPAQOZOCOIPBQOZORIUSUCZUEHURUCZSJPZAUFOZOZUROCOVBCOZBUFOZOUSO
      RJDSVBAUGOZOUROCOVEBUGOZOUSORJDSNKPZVGOVDRVBVIAUHOZUICOVEVICOBUHOZUIRUJKD
      SJDSUKABJKHCIVADUTEURVCVGVJUSVFVHVKVATFVCTVGTURTVJTUTTGVFTVHTUSTVKTULUMUN
      @.
  @}

  @{
    @d F m n o p @.  @d O1 o @.  @d O2 p @.  @d T m n o p @.  @d U m n o p @.
    vidfunid.1 @e |- O1 = dom ( id_ ` T ) @.
    vidfunid.2 @e |- I1 = ( id_ ` T ) @.
    vidfunid.3 @e |- O2 = dom ( id_ ` U ) @.
    vidfunid.4 @e |- I2 = ( id_ ` U ) @.
    @( The functor ` F ` associates every object of ` T ` to an object in
       ` U ` .  For the identification of objects with the identities see
       ~ df-funcOLD .  JFM CAT_1 th. 97.  (Contributed by FL, 10-Feb-2008.) @)
    vidfunid @p |- ( ( T e. CatOLD /\ U e. CatOLD ) ->
       ( F e. ( FuncOLD ` <. T , U >. ) ->
         A. o e. O1
        E. p e. O2 ( F ` ( I1 ` o ) ) = ( I2 ` p ) ) ) @=
      ( vm vn cfv cv wceq wral eqid ccatOLD wcel wa cop cfuncOLD wrex cdom_ cdm
      ccod_ co_ co wi wf w3a isfunb simplbda simp1d ex ) AUAUBBUAUBUCZDABUDUEPU
      BZCQHPDPEQIPREGUFCFSZUSUTUCVANQZAUGPZPZHPDPVBDPZBUGPZPIPRNVCUHZSVBAUIPZPH
      PDPVEBUIPZPIPRNVGSUCZOQZVHPVDRVBVKAUJPZUKDPVEVKDPBUJPZUKRULOVGSNVGSZUSUTV
      GVFUHZDUMVAVJVNUNABNOCDEFVGGVOHVCVHVLIVFVIVMJVGTVCTVHTKVLTLVOTVFTVITMVMTU
      OUPUQUR @.
  @}

  @{
    @d a b m n F @.  @d m n M1 @.  @d a b m n T @.  @d a b m n U @.
    iddvvidd.1 @e |- M1 = dom ( dom_ ` T ) @.
    iddvvidd.2 @e |- D1 = ( dom_ ` T ) @.
    iddvvidd.3 @e |- I1 = ( id_ ` T ) @.
    iddvvidd.4 @e |- I2 = ( id_ ` U ) @.
    iddvvidd.5 @e |- D2 = ( dom_ ` U ) @.
    @( Functors preserve domains.  JFM CAT_1 th. 98.  (Contributed by FL,
       5-May-2008.) @)
    iddvvidd @p |- ( ( T e. CatOLD /\ U e. CatOLD ) ->
      ( F e. ( FuncOLD ` <. T , U >. ) ->
         A. m e. M1 ( F ` ( I1 ` ( D1 ` m ) ) ) =
           ( I2 ` ( D2 ` ( F ` m ) ) ) ) ) @=
      ( va cfv cv wceq wral eqid vb vn ccatOLD wcel cop cfuncOLD ccod_ cid_ cdm
      wa wrex co_ co wi cdom_ wf w3a isfunb simplbda simp2d simpld ex ) AUCUDBU
      CUDUJZDABUEUFPUDZCQZGPZFPDPVEDPZIPHPRCESZVCVDUJZVHVEAUGPZPFPDPVGBUGPZPHPR
      CESZVIOQFPDPUAQHPRUABUHPUIZUKOAUHPUIZSZVHVLUJZUBQZVJPVFRVEVQAULPZUMDPVGVQ
      DPBULPZUMRUNUBESCESZVCVDEBUOPUIZDUPVOVPVTUQABCUBODUAVNEVMWAFGVJVRHIVKVSVN
      TJKVJTLVRTVMTWATNVKTMVSTURUSUTVAVB @.
  @}

  @{
    @d a b m n F @.  @d m n M1 @.  @d a b m n T @.  @d a b m n U @.
    idcvvidc.1 @e |- M1 = dom ( dom_ ` T ) @.
    idcvvidc.2 @e |- C1 = ( cod_ ` T ) @.
    idcvvidc.3 @e |- I1 = ( id_ ` T ) @.
    idcvvidc.4 @e |- I2 = ( id_ ` U ) @.
    idcvvidc.5 @e |- C2 = ( cod_ ` U ) @.
    @( Functors preserve codomains.  JFM CAT_1 th. 98.  (Contributed by FL,
       5-May-2008.) @)
    idcvvidc @p |- ( ( T e. CatOLD /\ U e. CatOLD ) ->
      ( F e. ( FuncOLD ` <. T , U >. ) ->
         A. m e. M1 ( F ` ( I1 ` ( C1 ` m ) ) ) =
           ( I2 ` ( C2 ` ( F ` m ) ) ) ) ) @=
      ( va cfv cv wceq wral eqid vb vn ccatOLD wcel cop cfuncOLD cdom_ cid_ cdm
      wa wrex co_ co wi wf w3a isfunb simplbda simp2d simprd ex ) AUCUDBUCUDUJZ
      DABUEUFPUDZCQZGPFPDPVDDPZIPHPRCESZVBVCUJZVDAUGPZPZFPDPVEBUGPZPHPRCESZVFVG
      OQFPDPUAQHPRUABUHPUIZUKOAUHPUIZSZVKVFUJZUBQZGPVIRVDVPAULPZUMDPVEVPDPBULPZ
      UMRUNUBESCESZVBVCEVJUIZDUOVNVOVSUPABCUBODUAVMEVLVTFVHGVQHVJIVRVMTJVHTKLVQ
      TVLTVTTVJTNMVRTUQURUSUTVA @.
  @}

  @{
    @d m n x y F @.  @d m n M1 @.  @d m n x y T @.  @d m n x y U @.
    fmp.1 @e |- M1 = dom ( dom_ ` T ) @.
    fmp.2 @e |- C1 = ( cod_ ` T ) @.
    fmp.3 @e |- D1 = ( dom_ ` T ) @.
    fmp.6 @e |- Ro1 = ( o_ ` T ) @.
    fmp.7 @e |- Ro2 = ( o_ ` U ) @.
    @( Functors preserve morphisms composition.  JFM CAT_1 th. 99.
       (Contributed by FL, 2-Aug-2009.) @)
    fmp @p |- ( ( T e. CatOLD /\ U e. CatOLD ) ->
      ( F e. ( FuncOLD ` <. T , U >. ) ->
         A. m e. M1 A. n e. M1 ( ( C1 ` n ) = ( D1 ` m )
            -> ( F ` ( m Ro1 n ) ) = ( ( F ` m ) Ro2 ( F ` n ) ) ) ) ) @=
      ( cfv cv wceq wral eqid vx vy ccatOLD wcel wa cop cfuncOLD co wi cid_ cdm
      wrex cdom_ ccod_ wf w3a isfunb simplbda simp3d ex ) AUCUDBUCUDUEZEABUFUGP
      UDZDQZHPCQZGPZRVDVCIUHEPVDEPZVCEPJUHRUIDFSCFSZVAVBUEUAQAUJPZPEPUBQBUJPZPR
      UBVIUKZULUAVHUKZSZVEVHPEPVFBUMPZPVIPRCFSVDHPVHPEPVFBUNPZPVIPRCFSUEZVGVAVB
      FVMUKZEUOVLVOVGUPABCDUAEUBVKFVJVPVHGHIVIVMVNJVKTKMLVHTNVJTVPTVMTVNTVITOUQ
      URUSUT @.
  @}

  @{
    @d T a b m n @.
    @( The identity functor is a functor.  (Contributed by FL, 15-Jul-2008.) @)
    idfisf @p |- ( T e. CatOLD ->
      ( _I |` dom ( dom_ ` T ) ) e. ( FuncOLD ` <. T , T >. ) ) @=
      ( va vb vm vn wcel cfv cdm cv wceq wral wa wi eqid jdmo fvresi syl adantl
      ralrimiva fveq2d ccatOLD cid cdom_ cres cop cfuncOLD wf cid_ ccod_ co_ co
      wrex w3a wf1o f1oi f1of mp1i fveq2 eqeq2d rspcev ex mpd dmo syldan eqcomd
      eqtrd jca cmpmorp com12 eqcoms oveqan12rd sylan9eqr 3adant1 3com23 3expib
      cdmo syld ralrimivv 3jca wb isfunb anidms mpbir2and ) AUAFZUBAUCGZHZUDZAA
      UEUFGFZWFWFWGUGZBIZAUHGZGZWGGZCIZWKGZJZCWKHZULZBWQKZDIZWEGZWKGZWGGZWTWGGZ
      WEGZWKGZJZDWFKZWTAUIGZGZWKGZWGGZXDXIGZWKGZJZDWFKZLZEIZXIGZXAJZWTXRAUJGZUK
      ZWGGZXDXRWGGZYAUKZJZMZEWFKDWFKZUMZWFWFWGUNWIWDWFUOWFWFWGUPUQWDWSXQYHWDWRB
      WQWDWJWQFZLZWMWLJZWRYKWLWFFYLWJAWKWFWQWFNZWQNZWKNZOWFWLPQYJYLWRMWDYJYLWRW
      PYLCWJWQWNWJJWOWLWMWNWJWKURUSUTVARVBSWDXHXPWDXGDWFWDWTWFFZLZXCXBXFYQXBWFF
      ZXCXBJWDYPXAWQFYRWEAWTWFWQYMYNWENZVCXAAWKWFWQYMYNYOOVDWFXBPQYPXBXFJWDYPXA
      XEWKYPWTXDWEYPXDWTWFWTPZVEZTTRVFSWDXODWFYQXLXKXNYQXKWFFZXLXKJWDYPXJWQFUUB
      XIAWTWFWQYMYNXINZVPXJAWKWFWQYMYNYOOVDWFXKPQYPXKXNJWDYPXJXMWKYPWTXDXIUUATT
      RVFSVGWDYGDEWFWFWDYPXRWFFZYGWDUUDYPYGWDUUDYPUMZXTYBWFFZYFXTUUEUUFUUEUUFMX
      AXSUUEXAXSJUUFXIWEYAAXRWTWFYMYSUUCYANZVHVIVJVIUUDYPUUFYFMWDUUDYPLZUUFYFUU
      FUUHYCYBYEWFYBPUUHYEYBYPUUDXDWTYDXRYAYTWFXRPVKVEVLVAVMVQVNVOVRVSWDWHWIYIL
      VTAADEBWGCWQWFWQWFWKWEXIYAWKWEXIYAYNYMYSUUCYOUUGYNYMYSUUCYOUUGWAWBWC @.
  @}

  @{
    @d u v f g @.
    @( Class of isomorphisms.  (Contributed by FL, 21-May-2012.) @)
    df-isof @a |- Isofunc = ( u e. CatOLD , v e. CatOLD |->
      { f e. ( FuncOLD ` <. u , v >. ) | E. g e. ( FuncOLD ` <. v , u >. )
      ( ( f o. g ) = ( _I |` dom ( dom_ ` v ) ) /\
        ( g o. f ) = ( _I |` dom ( dom_ ` u ) ) ) } ) @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Subcategories
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c SubCat @.
  @( Extend class notation with a function returning all the subcategories of a
     given category. @)
  csubcat @a class SubCat @.

  @( ` ( SubCat `` x ) ` is the set of all the subcategories of the category
     ` x ` .  All the objects and all the morphisms of the subcategory belong
     to the supercategory.  The identity of an object, the domain and the
     codomain of a morphism are the same in the subcategory and the
     supercategory.  The composition of the subcategory is a restriction of the
     composition of the supercategory.  (Contributed by FL, 17-Sep-2009.) @)
  df-subcat @a |- SubCat = ( x e. CatOLD |-> ( CatOLD i^i
    ( ( ~P ( dom_ ` x ) X. ~P ( cod_ ` x ) ) X.
      ( ~P ( id_ ` x ) X. ~P ( o_ ` x ) ) ) ) ) @.

  @{
    @d C a u @.  @d C a x y @.  @d D a u @.  @d D a x y @.  @d J a u @.
    @d J a x y @.  @d R a u @.  @d R a x y @.  @d T a x y @.
    issubcat.2 @e |- D = ( dom_ ` T ) @.
    issubcat.3 @e |- C = ( cod_ ` T ) @.
    issubcat.4 @e |- R = ( o_ ` T ) @.
    issubcat.5 @e |- J = ( id_ ` T ) @.
    @( The set of all the subcategories of ` T ` .  (Contributed by FL,
       17-Sep-2009.)  (Revised by Mario Carneiro, 27-Dec-2014.) @)
    issubcat @p |- ( T e. CatOLD -> ( SubCat ` T ) =
      ( CatOLD i^i ( ( ~P D X. ~P C ) X. ( ~P J X. ~P R ) ) ) ) @=
      ( ccatOLD cdom_ cfv cpw ccod_ cxp cid_ co_ fveq2 syl6eqr pweqd vx csubcat
      cin wceq xpeq12d ineq2d df-subcat cvv fvex eqeltri pwex xpex inex2 fvmpt
      cv ) UADJUAUOZKLZMZUPNLZMZOZUPPLZMZUPQLZMZOZOZUCJBMZAMZOZEMZCMZOZOZUCJUBU
      PDUDZVGVNJVOVAVJVFVMVOURVHUTVIVOUQBVOUQDKLZBUPDKRFSTVOUSAVOUSDNLZAUPDNRGS
      TUEVOVCVKVEVLVOVBEVOVBDPLZEUPDPRISTVOVDCVOVDDQLZCUPDQRHSTUEUEUFUAUGVNJVJV
      MVHVIBBVPUHFDKUIUJUKAAVQUHGDNUIUJUKULVKVLEEVRUHIDPUIUJUKCCVSUHHDQUIUJUKUL
      ULUMUN @.
  @}

  @{
    @d C a @.  @d D a @.  @d J a @.  @d R a @.  @d T a @.  @d U a @.
    issubcata.2 @e |- D = ( dom_ ` T ) @.
    issubcata.3 @e |- C = ( cod_ ` T ) @.
    issubcata.4 @e |- R = ( o_ ` T ) @.
    issubcata.5 @e |- J = ( id_ ` T ) @.
    @( The predicate "is a subcategory of" ` T ` .  (Contributed by FL,
       17-Sep-2009.)  (Revised by Mario Carneiro, 10-Sep-2015.) @)
    issubcata @p |- ( T e. CatOLD -> ( U e. ( SubCat ` T ) <-> (
    U e. CatOLD /\ ( ( id_ ` U ) C_ J /\ ( ( dom_ ` U ) C_ D
    /\ ( cod_ ` U ) C_ C ) /\ ( o_ ` U ) C_ R ) ) ) ) @=
      ( ccatOLD wcel cfv cpw cxp wss wa cvv eqid bitr3i csubcat cin cdom_ ccod_
      cid_ co_ w3a issubcat eleq2d elin c1st c2nd cop wceq strcat sseli 1st2nd2
      wb elxp6 baib 3syl xp1st syl domval eleq1i fvex elpw codval anbi12i xp2nd
      syl6bb idval cmpval anbi12d bitrd 3anass 3ancoma pm5.32i bitri ) DKLZEDUA
      MZLEKBNZANZOZFNZCNZOZOZUBZLZEKLZEUEMZFPZEUCMZBPZEUDMZAPZQZEUFMZCPZUGZQZVT
      WAWIEABCDFGHIJUHUIWJWKEWHLZQXBEKWHUJWKXCXAWKXCWRWMWTQZQZXAWKXCEUKMZWDLZEU
      LMZWGLZQZXEWKERROZXKOZLZEXFXHUMUNZXCXJURKXLEUOUPZEXKXKUQXCXNXJEWDWGUSUTVA
      WKXGWRXIXDWKXGXFUKMZWBLZXFULMZWCLZQZWRWKXFXKLZXFXPXRUMUNZXGXTURWKXMYAXOEX
      KXKVBVCXFRRUQXGYBXTXFWBWCUSUTVAXQWOXSWQXQWNWBLWOWNXPWBWNEWNSVDVEWNBEUCVFV
      GTXSWPWCLWQWPXRWCWPEWPSVHVEWPAEUDVFVGTVIVKWKXIXHUKMZWELZXHULMZWFLZQZXDWKX
      HXKLZXHYCYEUMUNZXIYGURWKXMYHXOEXKXKVJVCXHRRUQXIYIYGXHWEWFUSUTVAYDWMYFWTYD
      WLWELWMWLYCWEEWLWLSVLVEWLFEUEVFVGTYFWSWFLWTWSYEWFEWSWSSVMVEWSCEUFVFVGTVIV
      KVNVOXEWRWMWTUGXAWRWMWTVPWRWMWTVQTVKVRVSVK @.
  @}

  @{
    @d C a @.  @d D a @.  @d J a @.  @d R a @.  @d T a @.  @d U a @.
    issubcatb.2 @e |- D = ( dom_ ` T ) @.
    issubcatb.3 @e |- C = ( cod_ ` T ) @.
    issubcatb.4 @e |- R = ( o_ ` T ) @.
    issubcatb.5 @e |- J = ( id_ ` T ) @.
  @( Todo: to be removed. @)
    @( The predicate "is a subcategory of" ` T ` .  (Contributed by FL,
       17-Sep-2009.) @)
    issubcatb @p |- ( ( T e. CatOLD /\ U e. CatOLD )
       -> ( U e. ( SubCat ` T ) <-> (
    ( id_ ` U ) C_ J /\ ( ( dom_ ` U ) C_ D
    /\ ( cod_ ` U ) C_ C ) /\ ( o_ ` U ) C_ R ) ) ) @=
      ( ccatOLD wcel csubcat cfv cid_ wss cdom_ ccod_ wa co_ issubcata baibd
      w3a ) DKLEDMNLEKLEONFPEQNBPERNAPSETNCPUCABCDEFGHIJUAUB @.
  @}

  @{
    @d a x y @.
    @( Lemma to simplify some subcategories related theorems .  (Contributed by
       FL, 17-Sep-2009.) @)
    besubbeca @p |- ( U e. ( SubCat ` T ) -> T e. CatOLD ) @=
      ( vx csubcat cfv wcel cdm ccatOLD cv cdom_ cpw cxp cid_ co_ cin df-subcat
      ccod_ dmmptss elfvdm sseldi ) BADEFDGHACHHCIZJEKUAQEKLUAMEKUANEKLLODCPRBA
      DST @.
  @}

  @( A category belongs to the set of its subcategories.  (Contributed by FL,
     17-Sep-2009.) @)
  catsbc @p |- ( T e. CatOLD -> T e. ( SubCat ` T ) ) @=
    ( ccatOLD wcel csubcat cfv cid_ wss cdom_ ccod_ co_ w3a ssid pm3.2i 3pm3.2i
    wa wb eqid issubcatb anidms mpbiri ) ABCZAADECZAFEZUCGZAHEZUEGZAIEZUGGZOZAJ
    EZUJGZKZUDUIUKUCLUFUHUELUGLMUJLNUAUBULPUGUEUJAAUCUEQUGQUJQUCQRST @.

  @{
    obsubc2.1 @e |- O1 = dom ( id_ ` T ) @.
    obsubc2.2 @e |- O2 = dom ( id_ ` U ) @.
    @( The objects of a subcategory are a subset of those of the
       supercategory.  JFM CAT_2 th. 11 .  (Contributed by FL, 17-Sep-2009.) @)
    obsubc2 @p |- ( U e. ( SubCat ` T ) -> O2 C_ O1 ) @=
      ( ccatOLD wcel csubcat cfv wss besubbeca wa cid_ cdm cdom_ ccod_ co_ eqid
      w3a issubcata dmss 3ad2ant1 adantl syl6bi imp 3sstr4g mpancom ) AGHZBAIJH
      ZDCKABLUIUJMBNJZOZANJZOZDCUIUJULUNKZUIUJBGHZUKUMKZBPJAPJZKBQJAQJZKMZBRJAR
      JZKZTZMUOUSURVAABUMURSUSSVASUMSUAVCUOUPUQUTUOVBUKUMUBUCUDUEUFFEUGUH @.
  @}

  @{
    idsubc.1 @e |- I1 = ( id_ ` T ) @.
    idsubc.2 @e |- I2 = ( id_ ` U ) @.
    @( The identity function of a subcategory is a subset of the identity
       function of the supercategory.  (Contributed by FL, 17-Sep-2009.) @)
    idsubc @p |- ( U e. ( SubCat ` T ) -> I2 C_ I1 ) @=
      ( ccatOLD wcel csubcat cfv wss besubbeca wa cid_ cdom_ ccod_ co_ w3a eqid
      issubcata sseq2i biimpi 3ad2ant1 adantl syl6bi imp 3sstr4g mpancom ) AGHZ
      BAIJHZDCKABLUIUJMBNJZANJZDCUIUJUKULKZUIUJBGHZUKCKZBOJAOJZKBPJAPJZKMZBQJAQ
      JZKZRZMUMUQUPUSABCUPSUQSUSSETVAUMUNUOURUMUTUOUMCULUKEUAUBUCUDUEUFFEUGUH
      @.
  @}

  @{
    domsubc.1 @e |- D1 = ( dom_ ` T ) @.
    domsubc.2 @e |- D2 = ( dom_ ` U ) @.
    @( The domain function of a subcategory is a subset of the domain function
       of the supercategory.  (Contributed by FL, 19-Sep-2009.) @)
    domsubc @p |- ( U e. ( SubCat ` T ) -> D2 C_ D1 ) @=
      ( ccatOLD wcel csubcat cfv wss besubbeca wa cdom_ cid_ ccod_ co_ w3a eqid
      issubcata simpr2l syl6bi imp 3sstr4g mpancom ) AGHZBAIJHZDCKABLUFUGMBNJZA
      NJZDCUFUGUHUIKZUFUGBGHZBOJAOJZKZUJBPJAPJZKZMBQJAQJZKZRMUJUNUIUPABULUISUNS
      UPSULSTUJUOUMUQUKUAUBUCFEUDUE @.
  @}

  @{
    codsubc.1 @e |- C1 = ( cod_ ` T ) @.
    codsubc.2 @e |- C2 = ( cod_ ` U ) @.
    @( The codomain function of a subcategory is a subset of the codomain
       function of the supercategory.  (Contributed by FL, 19-Sep-2009.) @)
    codsubc @p |- ( U e. ( SubCat ` T ) -> C2 C_ C1 ) @=
      ( ccatOLD wcel csubcat cfv wss besubbeca wa ccod_ cid_ cdom_ co_ w3a eqid
      issubcata simpr2r syl6bi imp 3sstr4g mpancom ) AGHZBAIJHZDCKABLUFUGMBNJZA
      NJZDCUFUGUHUIKZUFUGBGHZBOJAOJZKZBPJAPJZKZUJMBQJAQJZKZRMUJUIUNUPABULUNSUIS
      UPSULSTUOUJUMUQUKUAUBUCFEUDUE @.
  @}

  @( A subcategory is a category.  (Contributed by FL, 17-Sep-2009.) @)
  subctct @p |- ( U e. ( SubCat ` T ) -> U e. CatOLD ) @=
    ( ccatOLD wcel csubcat cfv besubbeca cid_ wss cdom_ ccod_ co_ w3a issubcata
    wa eqid simpl syl6bi mpcom ) ACDZBAEFDZBCDZABGTUAUBBHFAHFZIBJFAJFZIBKFAKFZI
    OBLFALFZIMZOUBUEUDUFABUCUDPUEPUFPUCPNUBUGQRS @.

  @{
    morsubc.1 @e |- M1 = dom ( dom_ ` T ) @.
    morsubc.2 @e |- M2 = dom ( dom_ ` U ) @.
    @( The morphisms of a subcategory are a subset of those of the
       supercategory.  (Contributed by FL, 18-Sep-2009.) @)
    morsubc @p |- ( U e. ( SubCat ` T ) -> M2 C_ M1 ) @=
      ( csubcat cfv wcel wss ccatOLD cid_ cdom_ ccod_ wa co_ w3a wb eqid cdm
      besubbeca issubcata dmss 3sstr4g adantr 3ad2ant2 adantl syl6bi pm2.43i
      syl ) BAGHIZDCJZUKUKBKIZBLHALHZJZBMHZAMHZJZBNHANHZJZOZBPHAPHZJZQZOZULUKAK
      IUKVERABUAUSUQVBABUNUQSUSSVBSUNSUBUJVDULUMVAUOULVCURULUTURUPTUQTDCUPUQUCF
      EUDUEUFUGUHUI @.
  @}

  @{
    cmpsubc.1 @e |- Ro1 = ( o_ ` T ) @.
    cmpsubc.2 @e |- Ro2 = ( o_ ` U ) @.
    @( The composition law of a subcategory is a subset of the composition law
       of the supercategory.  (Contributed by FL, 20-Sep-2009.) @)
    cmpsubc @p |- ( U e. ( SubCat ` T ) -> Ro2 C_ Ro1 ) @=
      ( ccatOLD wcel csubcat cfv wss besubbeca wa co_ cid_ cdom_ ccod_ w3a eqid
      issubcata simpr3 syl6bi imp 3sstr4g mpancom ) AGHZBAIJHZDCKABLUFUGMBNJZAN
      JZDCUFUGUHUIKZUFUGBGHZBOJAOJZKZBPJAPJZKBQJAQJZKMZUJRMUJUOUNUIABULUNSUOSUI
      SULSTUKUMUPUJUAUBUCFEUDUE @.
  @}

  @{
    @d T x @.  @d U x @.
    idsubidsup.1 @e |- I1 = ( id_ ` T ) @.
    idsubidsup.2 @e |- I2 = ( id_ ` U ) @.
    idsubidsup.3 @e |- O2 = dom ( id_ ` U ) @.
    @( The identity of an object of the subcategory equals the identity of the
       object in the supercategory.  (Contributed by FL, 2-Nov-2009.) @)
    idsubidsup @p |- ( U e. ( SubCat ` T ) ->
      A. x e. O2 ( I2 ` x ) = ( I1 ` x ) ) @=
      ( csubcat cfv wcel cv wceq wa wfun cdm syl eqid adantr wss calg besubbeca
      ccatOLD cded catded dedalg cdom_ ida ffun idsubc cid_ eqcomi dmeqi eleq2i
      wf eqtri biimpi adantl w3a funssfv eqcomd syl3anc ralrimiva ) CBJKLZAMZFK
      ZVFEKZNZADVEVFDLZOEPZFEUAZVFFQZLZVIVEVKVJVEBUBLZVKVEBUDLZVOBCUCVPBUELVOBU
      FBUGRRVOEQZBUHKZQZEUPVKVRBEVSVQVSSVRSVQSGUIVQVSEUJRRTVEVLVJBCEFGHUKTVJVNV
      EVJVNDVMVFDCULKZQVMIVTFFVTHUMUNUQUOURUSVKVLVNUTVHVGVFEFVAVBVCVD @.
  @}

  @{
    @d M m n o p @.  @d T m n o p @.  @d U m n o p @.
    idsubfun.1 @e |- M = dom ( dom_ ` U ) @.
    @( The identity restricted to the morphism of a subcategory ` U ` is a
       functor from the subcategory to the supercategory.  It is called the
       inclusion functor.  JFM CAT_2 th. 19.  (Contributed by FL,
       5-Oct-2009.) @)
    idsubfun @p |- ( U e. ( SubCat ` T ) ->
      ( _I |` M ) e. ( FuncOLD ` <. U , T >. ) ) @=
      ( vm cfv wcel cid cdm wceq wa eqid cvv fvi fvres syl adantr adantl fveq2d
      syl3anc vo vp vn csubcat cres cop cfuncOLD cdom_ wf cv cid_ wrex wral co_
      ccod_ co wi w3a wss wf1o f1oi f1of ax-mp morsubc fss sylancr obsubc2 fvex
      sselda ccatOLD subctct jdmo sylan wfun besubbeca ffun 3syl idsubc funssfv
      idc simpr 3eqtr4a fveq2 eqeq2d rspcev syl2anc ralrimiva eleq2i biimpi dmo
      syl2an mp1i domc domsubc eqcomd eqtr2d 3eqtr3d 3eqtrd cdmo codsubc morcat
      codc syl5eq eleq2d biimpa jca pm3.2an3 com23 imp31 id cmpmorp sylc fvresi
      ovex adantll cmppfc1 ad2antrr cmpsubc ad2antlr opeq12d wb cmppfcd eqeltrd
      oveq12 mpbird oprssopvg eqtr4d exp31 ralrimiv 3jca isfunb mpbir2and ) BAU
      DFGZHCUEZBAUFUGFGZCAUHFZIZYNUIZUAUJZBUKFZFZYNFZUBUJZAUKFZFZJZUBUUDIZULZUA
      YTIZUMZEUJZBUHFZFZYTFZYNFZUUKYNFZYPFZUUDFZJZECUMZUUKBUOFZFZYTFZYNFZUUPAUO
      FZFZUUDFZJZECUMZKZUCUJZUVAFZUUMJZUUKUVKBUNFZUPZYNFZUUPUVKYNFZAUNFZUPZJZUQ
      ZUCCUMZECUMZURZYMCCYNUIZCYQUSYRCCYNUTUWECVACCYNVBVCABYQCYQLZDVDCCYQYNVEVF
      YMUUJUVJUWCYMUUHUAUUIYMYSUUIGZKZYSUUGGUUBYSUUDFZJZUUHYMUUIUUGYSABUUGUUIUU
      GLZUUILZVGVIUWHUUAHFZUUAUUBUWIUUAMGUWMUUAJYSYTVHUUAMNVCUWHUUACGZUUBUWMJYM
      BVJGZUWGUWNABVKZYSBYTCUUIDUWLYTLZVLVMUUACHOPUWHUUDVNZYTUUDUSZUWGUWIUUAJYM
      UWRUWGYMAVJGZUUGYQUUDUIUWRABVOZYPAUUDYQUUGUWFYPLZUWKUUDLZVTUUGYQUUDVPVQZQ
      YMUWSUWGABUUDYTUXCUWQVRZQYMUWGWAYSUUDYTVSTWBUUFUWJUBYSUUGUUCYSJUUEUWIUUBU
      UCYSUUDWCWDWEWFWGYMUUTUVIYMUUSECYMUUKCGZKZUUOUUNHFZUUNUURUXGUUNCGZUUOUXHJ
      UXGUWOUUMUUIGZUXIYMUWOUXFUWPQZYMUWOUUKUULIZGZUXJUXFUWPUXFUXMCUXLUUKDWHWIZ
      UULBUUKUXLUUIUXLLUWLUULLZWJWKZUUMBYTCUUIDUWLUWQVLWFUUNCHOPUUNMGUXHUUNJUXG
      UUMYTVHUUNMNWLUXGUUMUUDFZUUKYPFZUUDFUUNUURUXGUUMUXRUUDUXGUXRUUMUXGYPVNZUU
      LYPUSZUXMUXRUUMJYMUXSUXFYMUWTYQUUGYPUIUXSUXAYPAUUDYQUUGUWFUXBUWKUXCWMYQUU
      GYPVPVQQYMUXTUXFABYPUULUXBUXOWNQUXFUXMYMUXNRUUKYPUULVSTWOSUXGUWRUWSUXJUXQ
      UUNJYMUWRUXFUXDQZYMUWSUXFUXEQZUXPUUMUUDYTVSTUXGUXRUUQUUDUXGUUKUUPYPUXGUUP
      UUKHFZUUKUXFUUPUYCJYMUUKCHORUXFUYCUUKJYMUUKCNRWPZSSWQWRWGYMUVHECUXGUVDUVC
      HFZUVCUVGUXGUVCCGZUVDUYEJUXGUWOUVBUUIGZUYFUXKYMUWOUXFUYGUWPUVABUUKCUUIDUW
      LUVALZWSVMZUVBBYTCUUIDUWLUWQVLWFUVCCHOPUVCMGUYEUVCJUXGUVBYTVHUVCMNWLUXGUV
      CUVBUUDFZUUKUVEFZUUDFUVGUXGUWRUWSUYGUVCUYJJUYAUYBUYIUWRUWSUYGURUYJUVCUVBU
      UDYTVSWOTUXGUVBUYKUUDUXGUYKUVBUXGUVEVNZUVAUVEUSZUUKUVAIZGZUYKUVBJYMUYLUXF
      YMUWTYQUUGUVEUIUYLUXAUVEYPAUUDYQUUGUWFUXBUWKUXCUVELZXBYQUUGUVEVPVQQYMUYMU
      XFABUVEUVAUYPUYHWTQYMUXFUYOYMCUYNUUKYMUWOCUYNJUWPUWOCUXLUYNDBXAXCPXDXEUUK
      UVEUVAVSTWOSUXGUYKUVFUUDUXGUUKUUPUVEUYDSSWRWRWGXFYMUWBECUXGUWAUCCUXGUVKCG
      ZUVMUVTUXGUYQKZUVMKZUVPUVOHFZUVOUVSUYSUVOCGZUVPUYTJUYSUWOUYQUXFURZUUMUVLJ
      ZVUAUYRVUBUVMYMUXFUYQVUBYMUWOUXFUYQVUBUQUQUWPUWOUYQUXFVUBUWOUYQUXFXGXHPXI
      QZUVMVUCUYRUVMUVLUUMUVMXJWORZUVAUULUVNBUVKUUKCDUXOUYHUVNLZXKXLUVOCHOPUVOM
      GUYTUVOJUYSUUKUVKUVNXNUVOMNWLUYSUVOUUPUVQUVNUPZUVSUYSUUKUUPJZUVKUVQJZKZUV
      OVUGJUYRVUJUVMUXFUYQVUJYMUXFUYQKZVUHVUIVUKUUPUUKUXFUUPUUKJZUYQCUUKXMZQWOV
      UKUVQUVKHFZUVKUYQUVQVUNJUXFUVKCHORUYQVUNUVKJUXFUVKCNRWPXFXOQUUKUUPUVKUVQU
      VNYDPUYSUVRVNZUVNUVRUSZUUPUVQUFZUVNIZGUVSVUGJUXGVUOUYQUVMYMVUOUXFYMUWTVUO
      UXAUVRAUVRLZXPPQXQUXGVUPUYQUVMYMVUPUXFABUVRUVNVUSVUFXRQXQUYSVUQUUKUVKUFZV
      URUYSUUPUUKUVQUVKUXGVULUYQUVMUXFVULYMVUMRXQUYQUVQUVKJUXGUVMCUVKXMXSXTUYSV
      UTVURGZVUCVUEUYSVUBVVAVUCYAVUDUVAUULUVNBUVKUUKCDUXOUYHVUFYBPYEYCUUPUVQUVR
      UVNYFTYGWRYHYIWGYJYMUWOUWTYOYRUWDKYAUWPUXABAEUCUAYNUBUUICUUGYQYTUULUVAUVN
      UUDYPUVEUVRUWLDUXOUYHUWQVUFUWKUWFUXBUYPUXCVUSYKWFYL @.
  @}

  @{
    @d M1 x @.  @d M2 x @.
    infemb.1 @e |- M1 = dom ( dom_ ` T ) @.
    infemb.2 @e |- M2 = dom ( dom_ ` U ) @.
    @( The inclusion functor is an embedding.  (Contributed by FL,
       2-Nov-2009.) @)
    infemb @p |- ( U e. ( SubCat ` T ) -> ( _I |` M2 ) : M2 -1-1-> M1 ) @=
      ( vx csubcat cfv wcel cv cid cres wf1o wss wa wex wf1 cdom_ cvv f1oi fvex
      morsubc cdm dmex eqeltri f1oeq3 sseq1 anbi12d spcev sylancr resiexg ax-mp
      wceq f11o sylibr ) BAHIJZDGKZLDMZNZURCOZPZGQZDCUSRUQDDUSNZDCOZVCDUAABCDEF
      UCVBVDVEPGDDBSIZUDTFVFBSUBUEUFZURDUNUTVDVAVEURDDUSUGURDCUHUIUJUKGDCUSDTJU
      STJVGDTULUMUOUP @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Terminal and initial objects
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c InitObj @.

  @( Extend class notation with the class of all initial objects. @)
  ciobj @a class InitObj @.

  @{
    @d x z o m @.
    @( Definition of the initial objects of a category.  Experimental.
       (Contributed by FL, 27-Jun-2014.) @)
    df-inob @a |- InitObj = ( x e. CatOLD |->
      { z e. dom ( id_ ` x ) |
        A. o e. dom ( id_ ` x ) E! m e. dom ( dom_ ` x )
        ( ( ( dom_ ` x ) ` m ) = z /\ ( ( cod_ ` x ) ` m ) = o ) } ) @.
  @}

  @{
    @d m o x z T @.  @d m M @.  @d z O @.
    isinob.1 @e |- O = dom ( id_ ` T ) @.
    isinob.2 @e |- M = dom ( dom_ ` T ) @.
    isinob.3 @e |- D = ( dom_ ` T ) @.
    isinob.4 @e |- C = ( cod_ ` T ) @.
    @( The predicate "are the initial objects of a category".  (Contributed by
       FL, 27-Jun-2014.) @)
    isinob @p |- ( T e. CatOLD -> ( InitObj ` T ) = { z e. O |
        A. o e. O E! m e. M ( ( D ` m ) = z /\ ( C ` m ) = o ) } ) @=
      ( wcel cfv cv wceq cdm cid_ cvv fveq1d ccatOLD ciobj cdom_ wreu wral crab
      vx ccod_ wa fvex dmex rabexg fveq2 dmeqd eleq2d anbi12d reubidvag imbi12d
      mp1i eqeq1d ralbidv2 rabeqbidv df-inob fvmptg mpdan eqcomi a1i eqtrd ) DU
      AMZDUBNZEOZDUCNZNZAOZPZVKDUHNZNZFOZPZUIZEVLQZUDZFDRNZQZUEZAWDUFZVKCNZVNPZ
      VKBNZVRPZUIZEGUDZFHUEZAHUFVIWFSMZVJWFPWDSMWNVIWCDRUJUKWEAWDSULUSUGDVKUGOZ
      UCNZNZVNPZVKWOUHNZNZVRPZUIZEWPQZUDZFWORNZQZUEZAXFUFWFUASUBWODPZXGWEAXFWDX
      HXEWCWODRUMUNZXHXDWBFXFWDXHVRXFMVRWDMZXDWBXHXFWDVRXIUOXHXBVTEXCWAXHWRVOXA
      VSXHWQVMVNXHVKWPVLWODUCUMZTUTXHWTVQVRXHVKWSVPWODUHUMTUTUPXHWPVLXKUNUQURVA
      VBUGAEFVCVDVEVIWEWMAWDHWDHPVIHWDIVFVGZVIWBWLFWDHVIXJVRHMWBWLVIWDHVRXLUOVI
      VTWKEWAGVIVOWHVSWJVIVMWGVNVIVKVLCVLCPVICVLKVFVGTUTVIVQWIVRVIVKVPBVPBPVIBV
      PLVFVGTUTUPWAGPVIGWAJVFVGUQURVAVBVH @.
  @}

  @c TermObj @.

  @( Extend class notation with the class of all terminal objects. @)
  ctobj @a class TermObj @.

  @{
    @d x y z o m @.
    @( Definition of the terminal objects of a category.  Experimental.
       (Contributed by FL, 15-Jul-2012.) @)
    df-termob @a |- TermObj = ( x e. CatOLD |->
       { z e. dom ( id_ ` x ) |
        A. o e. dom ( id_ ` x ) E! m e. dom ( dom_ ` x )
        ( ( ( dom_ ` x ) ` m ) = o /\ ( ( cod_ ` x ) ` m ) = z ) } ) @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Sources and sinks
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Source @.

  @( Extend class notation with the class of all sources. @)
  csrce @a class Source @.

  @{
    @d c i s x y @.
    @( A source is a family ` s ` of morphims indexed by a set ` i ` which all
       have the same domain ` d ` .  Joy of Cats, def. 10.1, p. 169.
       Experimental.  (Contributed by FL, 30-May-2014.) @)
    df-source @a |- Source = ( c e. CatOLD , i e. _V |->
     { s e. ( dom ( dom_ ` c ) ^m i ) |
        A. x e. i A. y e. i ( ( dom_ ` c ) ` ( s ` x )
      ) = ( ( dom_ ` c ) ` ( s ` y ) ) } ) @.
  @}

  @{
    @d c i s x y I @.  @d c i s x y T @.  @d s x y S @.
    issrc.1 @e |- D = ( dom_ ` T ) @.
    issrc.2 @e |- M = dom ( dom_ ` T ) @.
    @( Properties of a source.  (Contributed by FL, 27-Jun-2014.) @)
    issrc @p |- ( ( T e. CatOLD /\ I e. A ) -> ( S e. ( T Source I ) <-> (
       S e. ( M ^m I ) /\
       A. x e. I A. y e. I ( D ` ( S ` x ) ) = ( D ` ( S ` y ) ) ) ) ) @=
      ( vs wcel wa co cv cfv wceq wral cmap cvv vc ccatOLD csrce cdom_ cdm crab
      vi elex wi ovex rabexg fveq2 adantr dmeqd simpr oveq12d eqeq12d raleqbidv
      fveq1d rabeqbidv df-source ovmpt2ga 3expia com12 mp2b sylan2 eleq2d fveq1
      fveq2d 2ralbidv elrab eqcomi a1i oveq1d wb fveq1i eqeq12i 2ralbii anbi12d
      syl5bb bitrd ) FUBLZGCLZMZEFGUCNZLEAOZKOZPZFUDPZPZBOZWGPZWIPZQZBGRZAGRZKW
      IUEZGSNZUFZLZEHGSNZLZWFEPZDPZWKEPZDPZQZBGRAGRZMZWDWEWSEWCWBGTLZWEWSQZGCUH
      WRTLWSTLZWBXJMZXKUIWQGSUJWPKWRTUKXMXLXKWBXJXLXKUAUGFGUBTWHUAOZUDPZPZWLXOP
      ZQZBUGOZRZAXSRZKXOUEZXSSNZUFWSUCTXNFQZXSGQZMZYAWPKYCWRYFYBWQXSGSYFXOWIYDX
      OWIQYEXNFUDULUMZUNYDYEUOZUPYFXTWOAXSGYHYFXRWNBXSGYHYFXPWJXQWMYFWHXOWIYGUS
      YFWLXOWIYGUSUQURURUTABUGKUAVAVBVCVDVEVFVGWTEWRLZXCWIPZXEWIPZQZBGRAGRZMWDX
      IWPYMKEWRWGEQZWNYLABGGYNWJYJWMYKYNWHXCWIWFWGEVHVIYNWLXEWIWKWGEVHVIUQVJVKW
      DYIXBYMXHWDWRXAEWDWQHGSWQHQWDHWQJVLVMVNVGYMXHVOWDYLXGABGGYJXDYKXFXCWIDDWI
      IVLZVPXEWIDYOVPVQVRVMVSVTWA @.
  @}

  @{
    @d c i s x y I @.  @d c i s x y T @.  @d s x y F @.
    propsrc.1 @e |- M = dom ( dom_ ` T ) @.
    propsrc.2 @e |- D = ( dom_ ` T ) @.
    propsrc.4 @e |- S = ( T Source I ) @.
    @( Properties of a source.  (Contributed by FL, 30-May-2014.) @)
    propsrc @p |- ( ( T e. CatOLD /\ I e. A /\ F e. S )
      -> ( F : I --> M /\ A. x e. I A. y e. I
     ( D ` ( F ` x ) ) = ( D ` ( F ` y ) ) ) ) @=
      ( vs wcel cfv wceq wral wa cvv wi vc vi ccatOLD wf cv csrce co elex cdom_
      eleq2i cdm cmap simpl fveq2d dmeqd simpr oveq12d fveq1d eqeq12d raleqbidv
      crab rabeqbidv df-source rabex ovmpt2a eleq2d fveq1 2ralbidv elrab eqcoms
      ovex oveq1 biimpd wb fvex dmex jctil eleq1 anbi1d syl5ibr elmapg syl syl9
      ax-mp eqcomi fveq1i eqeq12i 2ralbii biimpi a1i anim12d com12 sylbi syl6bi
      pm2.43a ex syl5 syl7bi 3imp ) FUCNZHCNZGENZHIGUDZAUEZGOZDOZBUEZGOZDOZPZBH
      QAHQZRZXBGFHUFUGZNZWTXAXLEXMGLUJXAHSNZWTXNXLTZHCUHWTXOXPXNWTXORZXLXQXNGXD
      MUEZOZFUIOZOZXGXROZXTOZPZBHQZAHQZMXTUKZHULUGZVAZNZXQXLTZXQXMYIGUAUBFHUCSX
      SUAUEZUIOZOZYBYMOZPZBUBUEZQZAYQQZMYMUKZYQULUGZVAYIUFYLFPZYQHPZRZYSYFMUUAY
      HUUDYTYGYQHULUUDYMXTUUDYLFUIUUBUUCUMUNZUOUUBUUCUPZUQUUDYRYEAYQHUUFUUDYPYD
      BYQHUUFUUDYNYAYOYCUUDXSYMXTUUEURUUDYBYMXTUUEURUSUTUTVBABUBMUAVCYFMYHYGHUL
      VKVDVEVFYJGYHNZXEXTOZXHXTOZPZBHQAHQZRZYKYFUUKMGYHXRGPZYDUUJABHHUUMYAUUHYC
      UUIUUMXSXEXTXDXRGVGUNUUMYBXHXTXGXRGVGUNUSVHVIXQUULXLXQUUGXCUUKXKIYGPZXQUU
      GXCTTJUUNUUGGIHULUGZNZXQXCUUNUUGUUPUUNYHUUOGYHUUOPYGIYGIHULVLVJVFVMXQUUPX
      CXQISNZXORZUUPXCVNUUNXQUURTJXQUURUUNYGSNZXORXQXOUUSWTXOUPXTFUIVOVPVQUUNUU
      QUUSXOIYGSVRVSVTWDIHGSSWAWBVMWCWDUUKXKTXQUUKXKUUJXJABHHUUHXFUUIXIXEXTDDXT
      KWEZWFXHXTDUUTWFWGWHWIWJWKWLWMWNWOWPWQWRWS @.
  @}

  @c Sink @.

  @( Extend class notation with the class of all sinks. @)
  csnk @a class Sink @.

  @{
    @d c i s x y @.
    @( A sink is a family of morphims indexed by a set ` i ` which all have the
       same codomain.  Joy of Cats, def. 10.62, p. 184.  Experimental.
       (Contributed by FL, 15-Jul-2012.) @)
    df-sink @a |- Sink = ( c e. CatOLD , i e. _V |-> {
      s e. ( dom ( dom_ ` c ) ^m i ) | A. x e. i A. y e. i
      ( ( cod_ ` c ) ` ( s ` x ) ) =
         ( ( cod_ ` c ) ` ( s ` y ) ) } ) @.
  @}

  @c Natural @.

  @( Extend class notation with the class of all natural sources. @)
  cntrl @a class Natural @.

  @{
    @d i t d s m @.
    @( A diagram is an indexed family of objects and morphisms in a category C.
       Maybe more than one morphism between two given objects, maybe none.  One
       might choose a simple set with no structure for the set of indices as
       usual, but we can also use a category.  Let's call I this category.
       Morphisms of I are used as indices of morphisms of C and objects of I
       are used as indices of objects of C. With this convention a diagram is
       now a functor ` e. ( FuncOLD `` <. I , C >. ) ` .

       Using a category for the indices is even a better solution than using a
       simple set because with the functions dom_ and cod_ it is easy to
       express the relationship between a morphism in C and its attached
       objects simply by naming the relationship between the morphism in I and
       its attached objects (let's recall a functor preserves the domain and
       codomain).

       So ...

       Let ` d e. ( FuncOLD `` <. i , c >. ) ` be a diagram, a source indexed
       by the objects of ` i ` is said to be natural for the diagram provided
       that each morphism ` m ` of ` d ` and the morphisms of the source
       connected to its domain and codomain commute.  Joy of Cats, def. 11.3,
       (1) p. 193.  Goldblatt calls "cone" what Adamek, Herrlich and Strecker
       call "natural source".  Experimental.  (Contributed by FL,
       27-Jun-2014.) @)
    df-natur @a |- Natural = ( i e. CatOLD , t e. CatOLD |-> ( d e. ( FuncOLD `
      <. i , t >. ) |-> { s e. ( t Source dom ( id_ ` i ) ) |
      A. m e. dom ( dom_ ` i ) (
           ( ( dom_ ` t ) ` ( d ` m ) ) =
               ( ( cod_ ` t ) ` ( s ` ( ( dom_ ` i ) ` m ) ) )
        /\ ( ( cod_ ` t ) ` ( d ` m ) ) =
               ( ( cod_ ` t ) ` ( s ` ( ( cod_ ` i ) ` m ) ) )
        /\ ( ( d ` m ) ( o_ ` t ) ( s ` ( ( dom_ ` i ) ` m ) ) ) =
          ( s ` ( ( cod_ ` i ) ` m ) ) ) } ) ) @.
  @}

  @{
    @d d i m s t I @.  @d d m s D @.  @d d i m s t T @.  @d m s S @.
    isntr.1 @e |- O1 = dom ( id_ ` I ) @.
    isntr.2 @e |- M1 = dom ( dom_ ` I ) @.
    isntr.3 @e |- D1 = ( dom_ ` I ) @.
    isntr.4 @e |- C1 = ( cod_ ` I ) @.
    isntr.5 @e |- D2 = ( dom_ ` T ) @.
    isntr.6 @e |- C2 = ( cod_ ` T ) @.
    isntr.7 @e |- Ro2 = ( o_ ` T ) @.
    @( The predicate "is a natural source".  (Contributed by FL,
       27-Jun-2014.) @)
    isntr @p |- ( ( I e. CatOLD /\ T e. CatOLD
        /\ D e. ( FuncOLD ` <. I , T >. ) ) ->
     ( S e. ( ( I Natural T ) ` D ) <-> ( S e. ( T Source O1 ) /\ A. m e. M1
       ( ( D2 ` ( D ` m ) ) = ( C2 ` ( S ` ( D1 ` m ) ) )
       /\ ( C2 ` ( D ` m ) ) = ( C2 ` ( S ` ( C1 ` m ) ) )
       /\ ( ( D ` m ) Ro2 ( S ` ( D1 ` m ) ) ) = ( S ` ( C1 ` m ) ) ) ) ) ) @=
      ( cfv vd vs vi vt ccatOLD wcel cop cfuncOLD w3a cntrl co cdom_ ccod_ wceq
      cv co_ cdm wral cid_ csrce crab cmpt wa cvv fvex mptexg mp1i opeq12 simpr
      fveq2d fveq2 adantr dmeqd oveq12d adantl fveq1d fveq12d eqeq12d 3anbi123d
      eqidd oveq123d raleqbidv rabeqbidv df-natur ovmpt2ga syld3an3 eleq2d ovex
      mpteq12dv wb simp3 rabexg fveq1 eqeq1d oveq1d ralbidv eqid fvmptg syl2anc
      eqeq2d oveq2d eqcomi oveq2i eleq2i fveq1i fveq2i fveq12i eqeq12i oveq123i
      elrab 3anbi123i imbi12i ralbii2 anbi12i bitri syl6bb bitrd ) EUEUFZCUEUFZ
      AECUGZUHTZUFZUIZBAECUJUKZTZUFBAUAYADUOZUAUOZTZCULTZTZYFEULTZTZUBUOZTZCUMT
      ZTZUNZYHYOTZYFEUMTZTZYMTZYOTZUNZYHYNCUPTZUKZUUAUNZUIZDYKUQZURZUBCEUSTZUQZ
      UTUKZVAZVBZTZUFZBCFUTUKZUFZYFATZJTZYFHTZBTZKTZUNZUUSKTZYFITZBTZKTZUNZUUSU
      VBLUKZUVGUNZUIZDGURZVCZYCYEUUOBYCAYDUUNXRXSYBUUNVDUFZYDUUNUNYAVDUFUVOYCXT
      UHVEUAYAUUMVDVFVGUCUDECUEUEUAUCUOZUDUOZUGZUHTZYHUVQULTZTZYFUVPULTZTZYMTZU
      VQUMTZTZUNZYHUWETZYFUVPUMTZTZYMTZUWETZUNZYHUWDUVQUPTZUKZUWKUNZUIZDUWBUQZU
      RZUBUVQUVPUSTZUQZUTUKZVAZVBUUNUJVDUVPEUNZUVQCUNZVCZUAUVSUXCYAUUMUXFUVRXTU
      HUVPUVQECVHVJUXFUWSUUIUBUXBUULUXFUVQCUXAUUKUTUXDUXEVIUXFUWTUUJUXDUWTUUJUN
      UXEUVPEUSVKVLVMVNUXFUWQUUGDUWRUUHUXFUWBYKUXDUWBYKUNUXEUVPEULVKVLZVMUXFUWG
      YQUWMUUCUWPUUFUXFUWAYJUWFYPUXFYHUVTYIUXEUVTYIUNUXDUVQCULVKVOVPUXFUWDYNUWE
      YOUXEUWEYOUNUXDUVQCUMVKVOZUXFUWCYLYMUXFYFUWBYKUXGVPVJZVQVRUXFUWHYRUWLUUBU
      XFYHUWEYOUXHVPUXFUWKUUAUWEYOUXHUXFUWJYTYMUXFYFUWIYSUXDUWIYSUNUXEUVPEUMVKV
      LVPVJZVQVRUXFUWOUUEUWKUUAUXFYHYHUWDYNUWNUUDUXEUWNUUDUNUXDUVQCUPVKVOUXFYHV
      TUXIWAUXJVRVSWBWCWIUDUCDUBUAWDWEWFVPWGYCUUPBUUSYITZYPUNZUUSYOTZUUBUNZUUSY
      NUUDUKZUUAUNZUIZDUUHURZUBUULVAZUFZUVNYCYBUXSVDUFZUUPUXTWJXRXSYBWKUULVDUFU
      YAYCCUUKUTWHUXRUBUULVDWLVGYBUYAVCUUOUXSBUAAUUMUXSYAVDUUNYGAUNZUUIUXRUBUUL
      UULUYBUULVTUYBUUGUXQDUUHUYBYQUXLUUCUXNUUFUXPUYBYJUXKYPUYBYHUUSYIYFYGAWMZV
      JWNUYBYRUXMUUBUYBYHUUSYOUYCVJWNUYBUUEUXOUUAUYBYHUUSYNUUDUYCWOWNVSWPWCUUNW
      QWRWGWSUXTBUULUFZUXKYLBTZYOTZUNZUXMYTBTZYOTZUNZUUSUYEUUDUKZUYHUNZUIZDUUHU
      RZVCUVNUXRUYNUBBUULYMBUNZUXQUYMDUUHUYOUXLUYGUXNUYJUXPUYLUYOYPUYFUXKUYOYNU
      YEYOYLYMBWMZVJWTUYOUUBUYIUXMUYOUUAUYHYOYTYMBWMZVJWTUYOUXOUYKUUAUYHUYOYNUY
      EUUSUUDUYPXAUYQVRVSWPXJUYDUURUYNUVMUULUUQBUUKFCUTFUUKMXBXCXDUYMUVLDUUHGYF
      UUHUFYFGUFUYMUVLUUHGYFGUUHNXBXDUYGUVDUYJUVIUYLUVKUXKUUTUYFUVCUUSYIJJYIQXB
      XEUYEUVBYOKKYORXBZYLUVABYFYKHHYKOXBXEXFZXGXHUXMUVEUYIUVHUUSYOKUYRXEUYHUVG
      YOKUYRYTUVFBYFYSIIYSPXBXEXFZXGXHUYKUVJUYHUVGUUSUYEUUSUVBUUDLUUSWQUYSLUUDS
      XBXIUYTXHXKXLXMXNXOXPXQ @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Limits and co-limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c LimCat @.

  @( Extend class notation with the class of all limits. @)
  clmct @a class LimCat @.

  @{
    @d i c t d l m f x @.
    @( A limit of a diagram ` d ` is a natural source ` l ` for the diagram
       with the universal property that every natural source for ` d ` uniquely
       factors through it.  Joy of Cats, def. 11.3 (2), p. 194.  Experimental.
       (Contributed by FL, 27-Jun-2014.) @)
    df-limcat @a |- LimCat = ( i e. CatOLD , t e. CatOLD
      |-> ( d e. ( FuncOLD ` <. i , t >. )
        |-> { l e. ( ( i Natural t ) ` d ) |
        A. f e. ( ( i Natural t ) ` d ) E! m e. dom ( dom_ ` t )
        A. x e. dom ( id_ ` i ) ( f ` x ) = ( ( l ` x ) ( o_ ` t ) m ) } ) ) @.
  @}

  @{
    @d d f i l m t x @.  @d d f l D @.  @d d f i l t x m I @.
    @d d f i l t x m T @.  @d f l x m L @.  @d l m M2 @.  @d l O1 @.
    @d l Ro2 @.
    islimcat.1 @e |- O1 = dom ( id_ ` I ) @.
    islimcat.2 @e |- M2 = dom ( dom_ ` T ) @.
    islimcat.3 @e |- Ro2 = ( o_ ` T ) @.
    @( The predicate "is a limit of a diagram."  (Contributed by FL,
       27-Jun-2014.) @)
    islimcat @p |- ( ( I e. CatOLD /\ T e. CatOLD
         /\ D e. ( FuncOLD ` <. I , T >. ) ) ->
     ( L e. ( ( I LimCat T ) ` D ) <-> ( L e. ( ( I Natural T ) ` D )
      /\ A. f e. ( ( I Natural T ) ` D ) E! m e. M2
         A. x e. O1 ( f ` x ) = ( ( L ` x ) Ro2 m ) ) ) ) @=
      ( vd vl wcel cfv cv wceq wral vi vt ccatOLD cop cfuncOLD w3a clmct co co_
      cid_ cdm cdom_ wreu cntrl crab cmpt wa cvv fvex mptexg mp1i opeq12 fveq2d
      wb oveq12 fveq1d fveq2 adantr adantl eqeq2d raleqbidv reubidvag rabeqbidv
      dmeqd oveqd mpteq12dv df-limcat ovmpt2ga eleq2d syld3an3 simp3 rabex eqid
      raleqdv fvmptg sylancl eqcomi eleq2i fveq1 eqidd oveq123d imbi12d ralbidv
      a1i ralbidv2 elrab syl6bb bitrd ) FUCPZCUCPZBFCUDZUEQZPZUFZGBFCUGUHZQZPZG
      BNXBARZDRQZXHORZQZERZCUIQZUHZSZAFUJQZUKZTZECULQZUKZUMZDNRZFCUNUHZQZTZOYDU
      OZUPZQZPZGBYCQZPXIXHGQZXLJUHZSZAHTZEIUMZDYJTZUQZWSWTXCYGURPZXGYIVDXBURPYR
      XDXAUEUSNXBYFURUTVAWSWTYRUFZXFYHGYSBXEYGUAUBFCUCUCNUARZUBRZUDZUEQZXIXKXLU
      UAUIQZUHZSZAYTUJQZUKZTZEUUAULQZUKZUMZDYBYTUUAUNUHZQZTZOUUNUOZUPYGUGURYTFS
      ZUUACSZUQZNUUCUUPXBYFUUSUUBXAUEYTUUAFCVBVCUUSUUOYEOUUNYDUUSYBUUMYCYTFUUAC
      UNVEVFZUUSUULYADUUNYDUUTUUSUUIXREUUKXTUUSUUFXOAUUHXQUUSUUGXPUUQUUGXPSUURY
      TFUJVGVHVNUUSUUEXNXIUUSUUDXMXKXLUURUUDXMSUUQUUACUIVGVIVOVJVKUUSUUJXSUURUU
      JXSSUUQUUACULVGVIVNVLVKVMVPAUBDUAENOVQVRVFVSVTXDYIGYADYJTZOYJUOZPZYQXDXCU
      VBURPZYIUVCVDWSWTXCWAUVAOYJBYCUSWBXCUVDUQYHUVBGNBYFUVBXBURYGYBBSZYEUVAOYD
      YJYBBYCVGZUVEYADYDYJUVFWDVMYGWCWEVSWFUVAYPOGYJXJGSZYAYODYJUVGXRYNEXTIUVGX
      OYMAXQHUVGXHXQPZXHHPZXOYMUVHUVIVDUVGXQHXHHXQKWGWHWNUVGXNYLXIUVGXKYKXLXLXM
      JXMJSUVGJXMMWGWNXHXJGWIUVGXLWJWKVJWLWOXTISUVGIXTLWGWNVLWMWPWQWR @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Product and sum of two objects
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c ProdObj @.

  @( Extend class notation with the class of all object products. @)
  cprodo @a class ProdObj @.

  @{
    @d c a b m n f g h @.
    @( " A product in a category ` C ` of two objects ` a ` and ` b ` is a
       ` C ` -object ` a x. b ` together with a pair ( ` m : a x. b --> a ` ,
       ` n : a x. b --> b ` ) of ` C ` -arrows such that for any pair of ` C `
       -arrows of the form ( ` f : c --> a ` , ` g : c --> b ` ) there is
       exactly one arrow ` <. f , g >. : c --> a x. b ` such that
       ` m o. <. f , g >. = f ` and ` n o. <. f , g >. = g ` ".  Goldblatt
       p. 47.  Experimental.  (Contributed by FL, 15-Jul-2012.) @)
    df-prodobj @a |- ProdObj = ( c e. CatOLD |->
      ( a e. dom ( id_ ` c ) , b e. dom ( id_ ` c ) |->
         { <. m , n >. |
          ( ( m e. dom ( dom_ ` c )
          /\ n e. dom ( dom_ ` c ) )
          /\ ( ( ( dom_ ` c ) ` m ) = ( ( dom_ ` c ) ` n )
          /\ ( ( cod_ ` c ) ` m ) = a
          /\ ( ( cod_ ` c ) ` n ) = b )
          /\ A. f e. dom ( dom_ ` c ) A. g e. dom ( dom_ ` c )
             ( ( ( ( dom_ ` c ) ` f ) = ( ( dom_ ` c ) ` g )
             /\ ( ( cod_ ` c ) ` f ) = a
             /\ ( ( cod_ ` c ) ` g ) = b )
             /\ E! h e. dom ( dom_ ` c )
                 ( ( ( dom_ ` c ) ` h ) = ( ( dom_ ` c ) ` f )
                 /\ ( ( cod_ ` c ) ` h ) = ( ( dom_ ` c ) ` m )
                 /\ ( ( m ( o_ ` c ) h ) = f
                 /\ ( n ( o_ ` c ) h ) = g ) ) ) ) } ) ) @.
  @}

  @c SumObj @.

  @( Extend class notation with the class of all object sums. @)
  csumo @a class SumObj @.

  @{
    @d c a b m n f g h @.
    @( " A co-product of C-objects ` a ` and ` b ` is a C-object ` a + b `
       together with a pair ( ` m : a --> a + b ` , ` n : b --> a + b ` ) of
       C-arrows such that for any pair of C-arrows of the form
       ( ` f : a --> c ` , ` g : b --> c ` ) there is exactly one arrow
       ` [ f , g ] : a + b --> c ` such that ` [ f , g ] o. m = f ` and
       ` [ f , g ] o. n = g ` ".  Goldblatt p. 54.  Experimental.  (Contributed
       by FL, 15-Jul-2012.) @)
    df-sumobj @a |- SumObj = ( c e. CatOLD |->
      ( a e. dom ( id_ ` c ) , b e. dom ( id_ ` c ) |->
       { <. m , n >. |
          ( ( m e. dom ( dom_ ` c )
          /\ n e. dom ( dom_ ` c ) )
          /\ ( ( ( cod_ ` c ) ` m ) = ( ( cod_ ` c ) ` n )
          /\ ( ( dom_ ` c ) ` m ) = a
          /\ ( ( dom_ ` c ) ` n ) = b )
          /\ A. f e. dom ( dom_ ` c ) A. g e. dom ( dom_ ` c )
             ( ( ( ( cod_ ` c ) ` f ) = ( ( cod_ ` c ) ` g )
             /\ ( ( dom_ ` c ) ` f ) = a
             /\ ( ( dom_ ` c ) ` g ) = b )
             /\ E! h e. dom ( dom_ ` c )
                 ( ( ( cod_ ` c ) ` h ) = ( ( cod_ ` c ) ` f )
                 /\ ( ( dom_ ` c ) ` h ) = ( ( cod_ ` c ) ` m )
                 /\ ( ( h ( o_ ` c ) m ) = f
                 /\ ( h ( o_ ` c ) n ) = g ) ) ) ) } ) ) @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Tarski's classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c tar @. @( A function to study Tarski's classes. @)

  @( Extends class notation to include function ` tar ` . @)
  ctar @a class tar @.

  @{
    @d a b c x y u v @.
    @( A function to study Tarski's classes.  See ~ valdom for its domain,
       ~ vtare for its value at ` (/) ` , ~ vtarsu for its value at a
       successor, ~ vtarl for its value at a limit ordinal.  (Contributed by
       FL, 20-Mar-2011.) @)
    df-tar @a |- tar = ( a e. _V , b e. _V |-> ( rec
         ( ( x e. _V |-> ( ( { u | E. v e. x ( u C_ v \/ u = ~P v ) } u.
            ~P x ) i^i ( tarskiMap ` a ) ) ) , { a } ) |` b ) ) @.
  @}

  @{
    @d X a b c x y @.  @d Y a b c @.  @d a b c u v x y @.
    @( The ` tar ` function as a recursive function.  (Contributed by FL,
       20-Mar-2011.)  (Revised by Mario Carneiro, 10-Sep-2015.) @)
    valtar @p |- ( ( X e. A /\ Y e. B ) -> ( tar ` <. X , Y >. ) = ( rec
       ( ( x e. _V |-> ( ( { u | E. v e. x ( u C_ v \/ u = ~P v ) } u.
          ~P x ) i^i ( tarskiMap ` X ) ) ) , { X } ) |` Y ) ) @=
      ( va vb wcel ctar cfv cvv cv cpw wceq ctskm cin crdg cres wa cop wss wrex
      co wo cab cun cmpt csn df-ov elex wfun rdgfun resfunexg mpan adantl fveq2
      ineq2d mpteq2dv rdgeq1 rdgeq2 eqtrd reseq1d reseq2 df-tar ovmpt2g mpd3an3
      syl sneq syl2an syl5eqr ) FDJZGEJZUAFGUBKLFGKUEZAMCNZBNZUCVPVQOPUFBANZUDC
      UGVROUHZFQLZRZUIZFUJZSZGTZFGKUKVMFMJZGMJZVOWEPZVNFDULGEULWFWGWEMJZWHWGWIW
      FWDUMWGWIWCWBUNWDGMUOUPUQHIFGMMAMVSHNZQLZRZUIZWJUJZSZINZTWEKWDWPTMWJFPZWO
      WDWPWQWOWBWNSZWDWQWMWBPWOWRPWQAMWLWAWQWKVTVSWJFQURUSUTWNWMWBVAVIWQWNWCPWR
      WDPWJFVJWNWCWBVBVIVCVDWPGWDVEABCHIVFVGVHVKVL @.
  @}

  @{
    @d w x y z X @.
    @( The domain of the ` tar ` function is the ordinal ` Y ` .  (Contributed
       by FL, 20-Mar-2011.) @)
    valdom @p |- ( ( X e. A /\ Y e. On )
      -> dom ( tar ` <. X , Y >. ) = Y ) @=
      ( vx vz vy wcel con0 wa cop ctar cfv cdm cvv cv wss cpw wceq wo wfn ctskm
      wrex cab cun cin cmpt crdg cres valtar dmeqd rdgfnon onss fnssres sylancr
      csn adantl fndm syl eqtrd ) BAGZCHGZIZBCJKLZMDNEOZFOZPVDVEQRSFDOZUBEUCVFQ
      UDBUALUEUFZBUOZUGZCUHZMZCVBVCVJDFEAHBCUIUJVBVJCTZVKCRVBVIHTCHPZVLVHVGUKVA
      VMUTCULUPHCVIUMUNCVJUQURUS @.

    @( Value of ` tar ` at ` (/) ` .  JFM CLASSES1 th. 10.  (Contributed by FL,
       20-Mar-2011.) @)
    vtare @p |- ( ( X e. A /\ Y e. On /\ Y =/= (/) )
     -> ( ( tar ` <. X , Y >. ) ` (/) ) = { X } ) @=
      ( vx vz vy wcel con0 c0 wne w3a cop ctar cfv cvv cv wss cpw wceq wo ctskm
      wrex cab cun cin cmpt csn crdg cres valtar 3adant3 fveq1d on0eln0 biimpar
      3adant1 fvres syl eqtrd snex rdg0 syl6eq ) BAGZCHGZCIJZKZIBCLMNZNZIDOEPZF
      PZQVHVIRSTFDPZUBEUCVJRUDBUANUEUFZBUGZUHZNZVLVEVGIVMCUIZNZVNVEIVFVOVBVCVFV
      OSVDDFEAHBCUJUKULVEICGZVPVNSVCVDVQVBVCVQVDCUMUNUOICVMUPUQURVLVKBUSUTVA @.
  @}

  @{
    @d u v x y A @.  @d u v x y X @.  @d u v x y Y @.
    @( The parts and the powersets of the elements of ` tar ( A ) ` are
       elements of ` tar ( suc A ) ` .  As well as the parts of ` tar ( A ) `
       when they are elements of the smallest Tarski's class of which ` X ` is
       an element.  JFM CLASSES1 th. 11.  (Contributed by FL, 20-Mar-2011.) @)
    vtarsu @p |- ( ( X e. B /\ Y e. On /\ suc A e. Y ) ->
      ( ( tar ` <. X , Y >. ) ` suc A ) =
      ( ( { u | E. v e. ( ( tar ` <. X , Y >. ) ` A ) ( u C_ v \/ u = ~P v ) }
        u. ~P ( ( tar ` <. X , Y >. ) ` A ) ) i^i ( tarskiMap ` X ) ) ) @=
      ( vx wcel con0 cfv cvv cv cpw wceq wrex cab cun ctskm cin fveq1d csuc w3a
      cop ctar wss wo cmpt csn crdg valtar 3adant3 onelon 3adant1 sylibr rdgsuc
      cres sucelon syl fvres 3ad2ant3 fvex rexeq abbidv pweq uneq12d eqid inex2
      ineq1d fvmpt ax-mp ordsuccl2 eqtrd fveq2d syl5eqr 3eqtr4d ) EDHZFIHZCUAZF
      HZUBZVREFUCUDJZJVRGKBLZALZUEWBWCMNUFZAGLZOZBPZWEMZQZERJZSZUGZEUHZUIZFUPZJ
      ZWDACWAJZOZBPZWQMZQZWJSZVTVRWAWOVPVQWAWONVSGABDIEFUJUKZTVTVRWNJZCWNJZWLJZ
      WPXBVTCIHZXDXFNVTVRIHZXGVQVSXHVPFVRULUMCUQUNWMCWLUOURVSVPWPXDNVQVRFWNUSUT
      VTXBWQWLJZXFWQKHXIXBNCWAVAGWQWKXBKWLWEWQNZWIXAWJXJWGWSWHWTXJWFWRBWDAWEWQV
      BVCWEWQVDVEVHWLVFWJXAERVAVGVIVJVTWQXEWLVTWQCWOJZXEVTCWAWOXCTVTCFHZXKXENVQ
      VSXLVPCFVKUMCFWNUSURVLVMVNVOVL @.
  @}

  @{
    @d u v x y z X @.
    @( The value of ` tar ` at a limit ordinal.  JFM CLASSES1 th. 12.
       (Contributed by FL, 20-Mar-2011.) @)
    vtarl @p |- ( ( X e. B /\ Y e. On /\ ( A e. Y /\ Lim A ) )
      -> ( ( tar ` <. X , Y >. ) ` A ) = U. ( ( tar ` <. X , Y >. ) " A ) ) @=
      ( vx vu vv wcel con0 wlim wa w3a cfv cv cpw wceq cima cuni 3adant3 eqtrd
      cop ctar cvv wss wo wrex cab cun ctskm cin cmpt crdg valtar fveq1d simp3l
      csn cres fvres syl rdglim 3ad2ant3 eloni 3ad2ant2 imresord syl2anc eqcomd
      word imaeq1d eqtr3d unieqd ) CBHZDIHZADHZAJZKZLZACDUAUBMZMZAEUCFNZGNZUDVS
      VTOPUEGENZUFFUGWAOUHCUIMUJUKZCUPZULZDUQZMZVQAQZRZVKVLVRWFPVOVKVLKAVQWEEGF
      BICDUMZUNSVPWFAWDMZWHVPVMWFWJPVKVLVMVNUOZADWDURUSVPWJWDAQZRZWHVOVKWJWMPVL
      WCADWBUTVAVPWLWGVPWEAQZWLWGVPDVGZVMWNWLPVLVKWOVODVBVCWKADWDVDVEVPWEVQAVPV
      QWEVKVLVQWEPVOWISVFVHVIVJTTT @.
  @}

  @{
    @d w x z @.  @d b c A @.  @d b B @.  @d b c v x y X @.  @d b c v y Y @.
    @( The sequence ` tar ` has its values in a Tarski's class.  (Contributed
       by FL, 20-Mar-2011.) @)
    tartarmap @p |- ( ( X e. A /\ Y e. On /\ suc B e. Y ) ->
      ( ( tar ` <. X , Y >. ) ` B ) C_ ( tarskiMap ` X ) ) @=
      ( vc csuc con0 wcel w3a cfv wss wi cv c0 wceq sseq1d cpw syl wral wa ctar
      vb vv vy vx vw vz ctskm onelon 3adant1 sucelon suceq eleq1d 3anbi3d fveq2
      cop imbi12d csn wne ne0i vtare syl3an3 tskmid 3ad2ant1 snssd eqsstrd wrex
      wo cab cun cin inss2 wb simp1 simp2 word eloni ordtr 3ad2ant2 simp3 trsuc
      wtr syl2anc 3jca 3ad2ant3 vtarsu mpbiri 3exp wlim cima cuni simp31 simp32
      ordsuccl2 adantl simpl 3adant2 vtarl syl3anc r19.27av ordon ordtr1 sylbir
      jca ax-mp ancoms ordsucelsuc simpl1 simpl2 exp3acom23 3imp1 expcom syl6bi
      a1i syl6 pm2.43a pm5.31 ex com3r imp impcom ralimiaa r19.26 3simpa ralimi
      wfun cdm cvv cmpt crdg cres valtar wfn rdgfnon fnfun funres funeq 3adant3
      mp2b ordsuccl3 valdom sseqtr4d funimass4 fvex elpw ralbii syl6bb syl6sseq
      uniss unipw syl6bir com23 sylbi 3syl pm2.43d 3imp tfinds mpcom ) BFZGHZCA
      HZDGHZUUSDHZIZBCDUPUAJZJZCUHJZKZUVBUVCUUTUVADUUSUIUJUUTBGHUVDUVHLZBUKUVAU
      VBUBMZFZDHZIZUVJUVEJZUVGKZLUVAUVBNFZDHZIZNUVEJZUVGKZLUVAUVBEMZFZDHZIZUWAU
      VEJZUVGKZLZUVAUVBUWBFZDHZIZUWBUVEJZUVGKZLUVIUBEBUVJNOZUVMUVRUVOUVTUWMUVLU
      VQUVAUVBUWMUVKUVPDUVJNULUMUNUWMUVNUVSUVGUVJNUVEUOPUQUVJUWAOZUVMUWDUVOUWFU
      WNUVLUWCUVAUVBUWNUVKUWBDUVJUWAULUMUNUWNUVNUWEUVGUVJUWAUVEUOPUQUVJUWBOZUVM
      UWJUVOUWLUWOUVLUWIUVAUVBUWOUVKUWHDUVJUWBULUMUNUWOUVNUWKUVGUVJUWBUVEUOPUQU
      VJBOZUVMUVDUVOUVHUWPUVLUVCUVAUVBUWPUVKUUSDUVJBULUMUNUWPUVNUVFUVGUVJBUVEUO
      PUQUVRUVSCURZUVGUVQUVAUVBDNUSUVSUWQODUVPUTACDVAVBUVRCUVGUVAUVBCUVGHUVQCAV
      CVDVEVFUWAGHZUWGUWJUWLUWRUWGUWJIZUWLUCMZUDMZKUWTUXAQOVHUDUWEVGUCVIUWEQVJZ
      UVGVKZUVGKZUXBUVGVLUWSUWDUWLUXDVMUWJUWRUWDUWGUWJUVAUVBUWCUVAUVBUWIVNUVAUV
      BUWIVOUWJDWBZUWIUWCUVBUVAUXEUWIUVBDVPZUXEDVQZDVRRVSUVAUVBUWIVTDUWBWAWCWDW
      EUWDUWKUXCUVGUDUCUWAACDWFPRWGWHUVJWIZUWGEUVJSZUVMUVOUXHUXIUVMIZUVNUVEUVJW
      JZWKZUVGUXJUVAUVBUVJDHZUXHTZUVNUXLOUXHUXIUVAUVBUVLWLUXHUXIUVAUVBUVLWMUXHU
      VMUXNUXIUXHUVMTUXMUXHUVMUXMUXHUVBUVLUXMUVAUVJDWNUJWOUXHUVMWPXDWQUVJACDWRW
      SUXHUXIUVMUXLUVGKZUXIUVMUXOLZLUXHUXIUVMUXOUXIUVMUXPUXIUVMTUWGUVMTZEUVJSUW
      FUWDTZEUVJSZUXPUWGUVMEUVJWTUXQUXREUVJUXQUWAUVJHZUXRUWGUVMUXTUXRLUVMUXTUWG
      UXRUVMUXTUWDUWGUXRLUXTUVMUWDUVMUVJVPZUXTUVMUWDLZLUVBUVLUYAUVAUVLUVBUYAUVL
      UVBTZUVKGHZUYAGVPUYCUYDLXAUVKDGXBXEUYDUVJGHUYAUVJUKUVJVQXCRXFUJUYAUXTUWBU
      VKHZUYBUWAUVJXGUVMUYEUWDUVMUYETUVAUVBUWCUVAUVBUVLUYEXHUVAUVBUVLUYEXIUVAUV
      BUVLUYEUWCUVAUVBUXFUVLUYEUWCLLUVBUXFLUVAUXGXNUXFUYEUVLUWCUWBUVKDXBXJXOXKW
      DXLXMRXPUWGUWDUXRUWDUWGUWDUXRLUWDUWFUWDXQXRXPXOXSXTYAYBUXSUWFEUVJSZUWDEUV
      JSZTUXPUWFUWDEUVJYCUYGUYFUXPUYGUVAUVBTZEUVJSZUYFUXPLUWDUYHEUVJUVAUVBUWCYD
      YEUYIUVMUYFUXOUYIUVMUVEYFZUVJUVEYGZKZTZUYFUXOLUYIUVMUYMUYIUVMTUYJUYLUVMUY
      JUYIUVAUVBUYJUVLUYHUVEUEYHUFMZUGMZKUYNUYOQOVHUGUEMZVGUFVIUYPQVJUVGVKYIZUW
      QYJZDYKZOZUYJUEUGUFAGCDYLUYTUYJUYSYFZUYRGYMUYRYFVUAUWQUYQYNGUYRYODUYRYPYS
      UVEUYSYQWGRYRWOUVMUYLUYIUVMUVJDUYKUVBUVLUVJDKUVAUVJDYTUJUVAUVBUYKDOUVLACD
      UUAYRUUBWOXDXRUYMUYFUXKUVGQZKZUXOUYMVUCUWEVUBHZEUVJSUYFEUVJVUBUVEUUCVUDUW
      FEUVJUWEUVGUWAUVEUUDUUEUUFUUGVUCUXLVUBWKUVGUXKVUBUUIUVGUUJUUHUUKXOUULRYAU
      UMUUNXRUUOXNUUPVFWHUUQXCUUR @.
  @}

  @{
    @d A t @.  @d X t @.
    @( If ` A ` belongs to the smallest Tarski's class that contains ` X ` so
       does ` ~P A ` .  CLASSES1 th. 7.  (Contributed by FL, 17-Apr-2011.)
       (Proof shortened by Mario Carneiro, 21-Sep-2014.) @)
    pwtsm @p |- ( A e. ( tarskiMap ` X ) -> ~P A e. ( tarskiMap ` X ) ) @=
      ( ctskm cfv ctsk wcel cpw tskmcl tskpw mpan ) BCDZEFAKFAGKFBHAKIJ @.
  @}

  @{
    @d A t @.  @d X t @.
    @( If ` A ` belongs to the smallest Tarski's class that contains ` X ` so
       does the subsets of ` A ` .  CLASSES1. th. 6.  (Contributed by FL,
       17-Apr-2011.)  (Proof shortened by Mario Carneiro, 21-Sep-2014.) @)
    subtsm @p |- ( A e. ( tarskiMap ` X ) -> ~P A C_ ( tarskiMap ` X ) ) @=
      ( ctskm cfv ctsk wcel cpw wss tskmcl tskpwss mpan ) BCDZEFALFAGLHBIALJK
      @.
  @}

  @( If ` A ` is a subset of the smallest Tarski's class that contains ` X `
     then it is equipotent to this class or it belongs to it.  CLASSES1 th. 8.
     (Contributed by FL, 17-Apr-2011.) @)
  subtareqbe @p |- ( A C_ ( tarskiMap ` X ) ->
      ( A ~~ ( tarskiMap ` X ) \/ A e. ( tarskiMap ` X ) ) ) @=
    ( ctskm cfv ctsk wcel wss cen wbr wo tskmcl tsken mpan ) BCDZEFANGANHIANFJB
    KANLM @.

  @c tr @.

  @( @)

  @( Extend class notation to include the function whose value is the
     transitive closure of its operand. @)
  ctr @a class tr @.

  @{
    @d x y a z w @.
    @( The transitive closure of a set.  (Contributed by FL, 17-Apr-2011.) @)
    df-trcls @a |- tr = ( x e. _V |-> U_ a e. om
      ( ( rec ( ( z e. _V |-> ( z u. U. z ) ) , x ) |` om ) ` a ) ) @.
  @}

  @{
    @d A a x y @.  @d a w x y z @.
    @( The transitive closure of a set A. (Contributed by FL, 17-Apr-2011.) @)
    trclval @p |- ( A e. B
    -> ( tr ` A ) = U_ a e. om
     ( ( rec ( ( z e. _V |-> ( z u. U. z ) ) , A ) |` om ) ` a ) ) @=
      ( vx wcel cvv ctr cfv com cuni cun cmpt crdg cres ciun wceq elex rdgeq2
      cv reseq1d fveq1d iuneq2d df-trcls omex fvex iunex fvmpt syl ) BCFBGFBHID
      JDTZAGATZUKKLMZBNZJOZIZPZQBCREBDJUJULETZNZJOZIZPUPGHUQBQZDJUTUOVAUJUSUNVA
      URUMJUQBULSUAUBUCEADUDDJUOUEUJUNUFUGUHUI @.
  @}

  @{
    @d u z A @.  @d z B @.  @d u z C @.  @d u z X @.  @d u z Y @.
    @( C belongs to the value of ` tar ` at a successor of ` A ` iff it is a
       part of ` tar ` at ` A ` , the powerset of an element or a part of an
       element of ` tar ` at ` A ` .  CLASSES1 th. 13 (Contributed by FL,
       13-Apr-2011.)  (Proof shortened by Mario Carneiro, 21-Sep-2014.) @)
    vtarsuelt @p |- ( ( X e. B /\ Y e. On /\ suc A e. Y ) -> ( C e. ( ( tar
    ` <. X , Y >. ) ` suc A ) <-> ( ( C C_ ( ( tar ` <. X , Y >. ) ` A ) /\
    C e. ( tarskiMap ` X ) ) \/ E. z e. ( ( tar ` <. X , Y >. ) ` A )
    ( C C_ z \/ C = ~P z ) ) ) ) @=
      ( vu wcel cv wss cpw wceq wo cfv wrex wa wb cvv orbi12d a1i con0 csuc w3a
      cop ctar cab cun ctskm cin elin vex ssex id pwex syl6eqel rexlimivw sseq1
      jaoi eqeq1 rexbidv elab3 fvex elpw2 orcom 3bitr4g anbi1d syl5bb vtarsu wi
      elun eleq2d tartarmap sselda ctsk tskmcl tskss mp3an1 ex pwtsm syl5ibrcom
      eleq1 jaod syl rexlimdva pm4.71d orbi2d andir syl6bbr 3bitr4d ) ECHFUAHBU
      BZFHUCZDGIZAIZJZWLWMKZLZMZABEFUDUENZNZOZGUFZWSKZUGZEUHNZUIZHZDWSJZDWMJZDW
      OLZMZAWSOZMZDXDHZPZDWJWRNZHXGXMPZXKMZXFDXCHZXMPWKXNDXCXDUJWKXRXLXMWKDXAHZ
      DXBHZMXKXGMXRXLWKXSXKXTXGXSXKQWKWTXKGDXJDRHZAWSXHYAXIDWMAUKZULXIDWORXIUMW
      MYBUNUOURUPWLDLZWQXJAWSYCWNXHWPXIWLDWMUQWLDWOUSSUTVATXTXGQWKDWSBWRVBVCTSD
      XAXBVJXGXKVDVEVFVGWKXOXEDAGBCEFVHVKWKXQXPXKXMPZMXNWKXKYDXPWKXKXMWKXJXMAWS
      WKWMWSHPWMXDHZXJXMVIWKWSXDWMCBEFVLVMYEXHXMXIYEXHXMXDVNHYEXHXMEVOWMDXDVPVQ
      VRYEXMXIWOXDHWMEVSDWOXDWAVTWBWCWDWEWFXGXKXMWGWHWI @.
  @}

  @{
    @d z A @.  @d z B @.  @d z C @.  @d z X @.  @d z Y @.  @d z Z @.
    @( If ` C ` is a part of an element of our tar function at ` A ` then ` C `
       is an element or tar at ` suc A ` .  CLASSES1 th. 14 (Contributed by FL,
       13-Apr-2011.) @)
    partarelt1 @p |- ( ( X e. B /\ Y e. On /\ suc A e. Y ) ->
       ( ( C C_ Z /\ Z e. ( ( tar ` <. X , Y >. ) ` A ) ) ->
          C e. ( ( tar ` <. X , Y >. ) ` suc A ) ) ) @=
      ( vz wss cop ctar cfv wcel wa con0 csuc w3a cpw wceq wo wi orc wrex sseq2
      cv pweq eqeq2d orbi12d rspcev ctskm olc vtarsuelt syl5ibrcom syl ex mpan9
      com12 ) CFHZFADEIJKZKZLZMDBLENLAOZELPZCVAURKLZUQUQCFQZRZSZUTVBVCTZUQVEUAU
      TVFVGUTVFMCGUDZHZCVHQZRZSZGUSUBZVGVLVFGFUSVHFRZVIUQVKVEVHFCUCVNVJVDCVHFUE
      UFUGUHVMVCVBCUSHCDUIKLMZVMSVMVOUJGABCDEUKULUMUNUOUP @.
  @}

  @{
    @d x A @.  @d x B @.  @d x X @.  @d x Y @.  @d x Z @.
    @( If ` Z ` is an element of our tar function at ` A ` then ` ~P Z ` is an
       element or tar at ` suc A ` .  CLASSES1 th. 15 (Contributed by FL,
       13-Apr-2011.) @)
    partarelt2 @p |- ( ( X e. B /\ Y e. On /\ suc A e. Y ) ->
       ( Z e. ( ( tar ` <. X , Y >. ) ` A ) ->
          ~P Z e. ( ( tar ` <. X , Y >. ) ` suc A ) ) ) @=
      ( vx wcel con0 csuc w3a cop ctar cfv cpw wss ctskm wa wceq wo olcd eqeq2d
      cv wrex eqidd sseq2 pweq orbi12d rspcev sylan2 expcom vtarsuelt sylibrd )
      CBGDHGAIZDGJZEACDKLMZMZGZENZUPOURCPMGQZURFUBZOZURUTNZRZSZFUPUCZSZURUMUOMG
      UQUNVFUQUNQVEUSUNUQUREOZURURRZSZVEUNVHVGUNURUDTVDVIFEUPUTERZVAVGVCVHUTEUR
      UEVJVBURURUTEUFUAUGUHUITUJFABURCDUKUL @.
  @}

  @{
    @d A x @.  @d B x @.  @d X x @.  @d Y x @.
    @( All the element of ` tar ` at ` A ` are elements of ` tar ` at
       ` suc A ` .  CLASSES1 th. 18 (Contributed by FL, 13-Apr-2011.) @)
    tareltsuc @p |- ( ( X e. B /\ Y e. On /\ suc A e. Y ) ->
       ( ( tar ` <. X , Y >. ) ` A ) C_
         ( ( tar ` <. X , Y >. ) ` suc A ) ) @=
      ( vx wcel con0 csuc w3a cop ctar cfv cv wss ssid partarelt1 mpani ssrdv )
      CBFDGFAHZDFIZEACDJKLZLZSUALZTEMZUDNUDUBFUDUCFUDOABUDCDUDPQR @.
  @}

  @( An element of the intersection of a Tarski's class with the class of the
     ordinal numbers is a part of the intersection.  (Contributed by FL,
     20-Apr-2011.) @)
  eltintpar @p |- ( T e. Tarski -> ( A e. ( On i^i T )
      -> A C_ ( On i^i T ) ) ) @=
    ( ctsk wcel con0 cin wss wa elin onss ad2antrr word wtr eloni ordtr tsktrss
    wi 3exp com3l ex 3syl imp31 jca sylbi impcom ssin sylib ) BCDZAEBFZDZAUIGZU
    HUJHAEGZABGZHZUKUJUHUNUJAEDZABDZHZUHUNQAEBIUQUHUNUQUHHULUMUOULUPUHAJKUOUPUH
    UMUOALAMZUPUHUMQQANAOUHURUPUMUHURUPUMABPRSUAUBUCTUDUEAEBUFUGT @.

  @{
    @d T x @.
    @( The intersection of a Tarski's class with the class of the ordinal
       numbers is an ordinal number.  (Contributed by FL, 20-Apr-2011.) @)
    inttaror @p |- ( T e. Tarski -> ( On i^i T ) e. On ) @=
      ( vx ctsk wcel con0 cin cvv cv wa wral incom inex1g syl5eqelr inss1 sseli
      wss adantl wi elin wtr onss word eloni ordtr syl w3a tsktrss ssin syl5com
      biimpi ex 3exp com14 sylc imp sylbi impcom jca ralrimiva celsor syl2anc )
      ACDZEAFZGDBHZEDZVDVCPZIZBVCJVCEDVBVCAEFGAEKAECLMVBVGBVCVBVDVCDZIVEVFVHVEV
      BVCEVDEANOQVHVBVFVHVEVDADZIVBVFRZVDEASVEVIVJVEVDEPZVDTZVIVJRVDUAVEVDUBVLV
      DUCVDUDUEVBVLVIVKVFVBVLVIVKVFRVBVLVIUFVDAPZVKVFVDAUGVKVMVFVKVMIVFVDEAUHUJ
      UKUIULUMUNUOUPUQURUSBVCGUTVA @.
  @}

  @( The intersection of a Tarski's class and the ordinal numbers is equipotent
     to the Tarski's class.  JFM CLASSES2. .  (Contributed by FL,
     20-Apr-2011.) @)
  inttarcar @p |- ( T e. Tarski -> ( On i^i T ) ~~ T ) @=
    ( ctsk wcel con0 cin wss cen wbr inss2 wo wa tsken ax-1 inttaror elin elirr
    wi pm2.21i sylbir ex syl adantr com12 jaoi mpcom mpan2 ) ABCZDAEZAFZUHAGHZD
    AIUJUHACZJUGUIKZUJUHALUJULUJQUKUJULMULUKUJUGUKUJQZUIUGUHDCZUMANUNUKUJUNUKKU
    HUHCZUJUHDAOUOUJUHPRSTUAUBUCUDUEUF @.

  @{
    @d T x @.
    @( The cardinal of the intersection of a Tarski's class with the class of
       the ordinal numbers.  (Contributed by FL, 20-Apr-2011.) @)
    carinttar @p |- ( T e. Tarski
      -> ( card ` ( On i^i T ) ) = ( On i^i T ) ) @=
      ( vx ctsk wcel con0 cin cv csdm wbr wral ccrd wa cen wn cvv imp wi expcom
      mpcom sylanbrc cfv wceq inttaror cdom wss incom inex1g syl5eqel eltintpar
      ssdomg sylsyld inttarcar elin tsksdom sdomnen entr con3d a1i com3r adantl
      syl sylbi com13 brsdom ralrimiva iscard ) ACDZEAFZEDBGZVHHIZBVHJVHKUAVHUB
      AUCVGVJBVHVGVIVHDZLVIVHUDIZVIVHMIZNZVJVGVKVLVGVHODVKVIVHUEVLVGVHAEFOEAUFA
      ECUGUHVIAUIVIVHOUJUKPVGVKVNVHAMIZVGVKVNQAULVKVGVOVNVKVIEDZVIADZLVGVOVNQZQ
      ZVIEAUMVQVSVPVGVQVRVIAHIZVGVQLZVRVIAUNVTVIAMIZNZWAVRQVIAUOWAVOWCVNVOWCVNQ
      QWAVOVMWBVMVOWBVIVHAUPRUQURUSVASRUTVBVCSPVIVHVDTVEBVHVFT @.
  @}

  @( The cardinal of a Tarski's class equals the intersection of the Tarski's
     class with the class of the ordinal numbers.  CLASSES2 th. 10.
     (Contributed by FL, 20-Apr-2011.) @)
  carinttar2 @p |- ( T e. Tarski
      -> ( card ` T ) = ( On i^i T ) ) @=
    ( ctsk wcel ccrd cfv con0 cin wceq cen wbr inttarcar syl wb inttaror carden
    ensym mpdan mpbird carinttar eqtrd ) ABCZADEZFAGZDEZUCUAUBUDHZAUCIJZUAUCAIJ
    UFAKUCAPLUAUCFCUEUFMANAUCBFOQRAST @.

  @{
    @d T x @.
    @( The cardinal of an element of a Tarski's class belongs to the Tarski's
       class. th. 12 CLASSES2 (Contributed by FL, 20-Apr-2011.) @)
    cardtar @p |- ( ( T e. Tarski /\ A e. T ) -> ( card ` A ) e. T ) @=
      ( ctsk wcel wa ccrd cfv wss con0 cin carinttar2 inss2 eqsstrd adantr csdm
      a1i wbr tsksdom wb cardsdom ancoms mpbird sseldd ) BCDZABDZEZBFGZBAFGZUDU
      GBHUEUDUGIBJZBBKUIBHUDIBLPMNUFUHUGDZABOQZABRUEUDUJUKSABBCTUAUBUC @.

    @( The cardinal of a Tarski's class is a limit ordinal.  CLASSES2 th. 21.
       (Contributed by FL, 20-Apr-2011.)  (Proof shortened by Mario Carneiro,
       21-Sep-2014.) @)
    cartarlim @p |- ( ( T e. Tarski /\ T =/= (/) ) -> Lim ( card ` T ) ) @=
      ( ctsk wcel c0 wne wa com ccrd cfv wss wlim cardom cdom wbr tskinf cvv wb
      omex simpl carddom sylancr mpbird syl5eqssr cardlim sylib ) ABCZADEZFZGAH
      IZJUIKUHGGHIZUILUHUJUIJZGAMNZAOUHGPCUFUKULQRUFUGSGAPBTUAUBUCAUDUE @.
  @}

  @{
    @( An element of the cardinal of the Tarski's class ` T ` is an element of
       ` T ` . th. 14 CLASSES2.  (Contributed by FL, 20-Nov-2011.) @)
    elcarelcl @p |- ( ( T e. Tarski /\ A e. ( card ` T ) )
    -> A e. T ) @=
      ( ctsk wcel ccrd cfv con0 cin wceq wi carinttar2 eleq2 simprbi syl6bi syl
      elin imp ) BCDZABEFZDZABDZRSGBHZIZTUAJBKUCTAUBDZUASUBALUDAGDUAAGBPMNOQ @.
  @}

  @{
    @d A f x @.  @d T f x @.
    @( Consider functions whose domain ` A ` is an element of a transitive
       Tarski's class ` T ` and whose range is ` T ` , then they are elements
       of ` T ` .  CLASSES2 th. 23.  (Contributed by FL, 26-Sep-2011.)
       (Revised by Mario Carneiro, 4-May-2015.) @)
    fnctartar @p |- ( ( T e. Tarski /\ Tr T /\ A e. T ) -> ( T ^m A ) C_ T ) @=
      ( vf vx ctsk wcel w3a cv wi wa wss csdm wbr cfv wceq com12 3adant2 imbi2d
      imp cen wtr cmap co wf elmapg simpr1 cxp fssxp ssel c1st cop elxp6 simp31
      c2nd trel exp3acom23 3adant1 adantr simp1r tskop syl3anc 3exp eleq1 sylbi
      syl5ibr syl6com com4l mpcom ssrdv wfn wfun cdm ffn fnfun fndm jca fundmen
      breq1 tsksdom sdomen1 syl5ibcom syl6bi mpan9 3syl 3jca ex tskssel pm2.43a
      vex syl6 ) BEFZBUAZABFZGZCBAUBUCZBCHZWOFZWNWPBFZWKWMWQWNWRIZIWLWKWMJZWQAB
      WPUDZWSBAWPEBUEXAWNWKWPBKZWPBLMZGZWRXAWNXDXAWNJZWKXBXCXAWKWLWMUFXEDWPBXAW
      NDHZWPFZXFBFZIZWPABUGZKZXAWNXIIABWPUHXGXKXAWNXHXKXGXFXJFZXAWNXHIZIZWPXJXF
      UIXLXFXFUJNZXFUNNZUKZOZXOAFZXPBFZJZJXNXFABULXRYAXNYAXNXRXAWNXQBFZIZIYAXAW
      NYBYAXAWNGWKXOBFZXTYBYAXAWKWLWMUMYAWNYDXAYAWNYDXSWNYDIXTWNXSYDWLWMXSYDIZW
      KWLWMYEWLXSWMYDBXOAUOUPSUQPURSQXSXTXAWNUSXOXPBUTVAVBXRXMYCXAXRXHYBWNXFXQB
      VCRRVESVDVFVGVHSVIXAWNXCXAWPAVJZWPVKZWPVLZAOZJWNXCIZABWPVMYFYGYIAWPVNAWPV
      OVPYGYHWPTMZYIYJWPCWIVQYIYKAWPTMZYJYHAWPTVRWNYLXCWKWMYLXCIWLWTABLMYLXCABV
      SAWPBVTWAQPWBWCWDSWEWFWPBWGWJWBQWHVI @.
  @}

  @{
    @d A f x @.  @d T f x @.
    @( Consider functions whose domain ` A ` is an element and a part of a
       Tarski's class ` T ` and whose range is ` T ` , then they are elements
       of ` T ` .  CLASSES2 th. 23.  (Contributed by FL, 27-Sep-2011.)
       (Revised by Mario Carneiro, 4-May-2015.) @)
    fnctartar2 @p |- ( ( T e. Tarski /\ A C_ T /\ A e. T )
        -> ( T ^m A ) C_ T ) @=
      ( vf vx ctsk wcel wss w3a cv csdm wbr wi 3adant2 wa ssel cfv wceq imp cen
      com12 cmap co wf wb elmapg simpr1 cxp fssxp c1st c2nd cop simp31 3ad2ant2
      elxp6 adantr simp1r tskop syl3anc 3exp eleq1 imbi2d syl5ibr sylbi syl6com
      com4l mpcom ssrdv wfn wfun cdm ffn jca fnfun fndm anim12i fundmen tsksdom
      vex breq1 sdomen1 syl5ibcom syl6bi mpan9 3syl 3jca pm2.43a tskssel syl6
      ex ) BEFZABGZABFZHZCBAUAUBZBWMCIZWNFZWJWOBGZWOBJKZHZWOBFWPWMWSWMWPABWOUCZ
      WMWSLWJWLWPWTUDWKBAWOEBUEMWTWMWSWTWMNZWJWQWRWTWJWKWLUFXADWOBWTWMDIZWOFZXB
      BFZLZWOABUGZGZWTWMXELABWOUHXCXGWTWMXDXGXCXBXFFZWTWMXDLZLZWOXFXBOXHXBXBUIP
      ZXBUJPZUKZQZXKAFZXLBFZNZNXJXBABUNXNXQXJXQXJXNWTWMXMBFZLZLXQWTWMXRXQWTWMHW
      JXKBFZXPXRXQWTWJWKWLULXQWMXTWTXQWMXTXOWMXTLXPWMXOXTWKWJXOXTLWLABXKOUMTUOR
      MXOXPWTWMUPXKXLBUQURUSXNXIXSWTXNXDXRWMXBXMBUTVAVAVBRVCVDVEVFRVGWTWMWRWTWO
      AVHZYANWOVIZWOVJZAQZNWMWRLZWTYAYAABWOVKZYFVLYAYBYAYDAWOVMAWOVNVOYBYCWOSKZ
      YDYEWOCVRVPYDYGAWOSKZYEYCAWOSVSWMYHWRWJWLYHWRLWKWJWLNABJKYHWRABVQAWOBVTWA
      MTWBWCWDRWEWIWBWFWOBWGWHVG @.
  @}

  @( If the cardinal of ` A ` of a part of ` T ` is less than ` T ` . a
     function from ` A ` to ` T ` is a part of ` T ` .  CLASSES2 th. 23.
     (Contributed by FL, 20-Nov-2011.) @)
  fnctartar3 @p |- ( ( T e. Tarski /\ A C_ T /\
      ( card ` A ) e. ( card ` T ) ) -> ( T ^m A ) C_ T ) @=
    ( ctsk wcel wss ccrd cfv cmap co csdm wbr wa wb ssexg ancoms simpl cardsdom
    cvv syl2anc syld3an3 biimp3a tskssel fnctartar2 ) BCDZABEZAFGBFGDZABDZBAHIB
    EUDUEUFABJKZUGUDUEUFUHUDUELARDZUDUFUHMUEUDUIABCNOUDUEPABRCQSUAABUBTABUCT @.

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Category Set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( Class variables used as operators, relations, etc. I use the singular
     form because it was Cantor's use (who invented the .e sign). "A e. B"
     in Cantor's mind meant "A is a B" . Thus, "A e. Morphism" means "A is
     a Morphism". @)

  @v .Morphism @.
  @v .Object @.
  @v .graph @.
  @v .dom @.
  @v .cod @.
  @v .id @.

  @( Let variable ` .Morphism ` be a class. @)
  cmorp @f class .Morphism @.
  @( Let variable ` .Object ` be a class. @)
  cobj @f class .Object @.
  @( Let variable ` .graph ` be a class. @)
  cgra @f class .graph @.
  @( Let variable ` .dom ` be a class. @)
  cdomc @f class .dom @.
  @( Let variable ` .cod ` be a class. @)
  ccod @f class .cod @.
  @( Let variable ` .id ` be a class. @)
  cidc @f class .id @.

  @c MorphismSetCat @.
  @( Extend class notation to include the morphisms of the category Set. @)
  ccmrcase @a class MorphismSetCat @.

  @{
    @d x a b c @.
    @( The morphisms of the category Set.  ( ` a ` is redundant and could be
       retrieved from ` c ` .)  Experimental.  (Contributed by FL,
       15-Sep-2013.) @)
    df-morcatset @a |- MorphismSetCat = ( x e. Univ |->
     { <. <. a , b >. , c >. | ( a e. x /\ b e. x /\ c e. ( b ^m a ) ) } ) @.
  @}

  @{
    @d U a b c @.
    @( Lemma for ~ prismorcset .  (Contributed by FL, 15-Sep-2013.) @)
    prismorcsetlem @p |- ( U e. Univ -> {
               <.
               <. a
               , b
               >.
               , c
               >.
               | ( a e. U /\ b e. U /\ c e. ( b ^m a ) ) }
            e. _V ) @=
      ( cgru wcel cv cmap coprab cxp cab wss cvv cdm crn wa a1i eqsstrd syl2anc
      wrex co wrel reloprab relssdmrn ax-mp wb df-3an oprabbidv dmeqd dmoprabss
      rneqd rnoprab2 syl6eq ssid xpss12 syl5ss xpexg anidms df-iun eliun rexbii
      ciun abbii eqtri wral ovex ralrimiva iunexg syldan mpdan syl5eqelr ssexg
      w3a ) AEFZBGZAFZCGZAFZDGZVQVOHUAZFZVMZBCDIZAAJZWACATZBATZDKZJZLWHMFZWCMFV
      NWCWCNZWCOZJZWHWCUBWCWLLWBBCDUCWCUDUEVNWJWDLWKWGLWLWHLVNWJVPVRPWAPZBCDIZN
      ZWDVNWCWNVNWBWMBCDWBWMUFVNVPVRWAUGQUHZUIWOWDLVNWABCDAAUJQRVNWKWGWGVNWKWNO
      WGVNWCWNWPUKWABCDAAULUMWGWGLVNWGUNQRWJWDWKWGUOSUPVNWDMFZWGMFWIVNWQAAEEUQU
      RVNWGBACAVTVBZVBZMWSVSWRFZBATZDKWGBDAWRUSXAWFDWTWEBACVSAVTUTVAVCVDVNWRMFZ
      BAVEWSMFVNXBBAVNVPVTMFZCAVEXBVNVPPZXCCAXCXDVRPVQVOHVFQVGCAVTEMVHVIVGBAWRE
      MVHVJVKWDWGMMUQSWCWHMVLS @.
  @}

  @{
    @d U a b c @.
    @( Lemma for ~ prismorcset .  First use of the property of a universe
       through ~ grumap .  (Contributed by FL, 6-Nov-2013.) @)
    prismorcsetlemb @p |- ( U e. Univ ->
      { c | E. a e. U E. b e. U c e. ( b ^m a ) } e. _V ) @=
      ( cgru wcel cvv cv cmap co cab wral wrex elex wa abid2 grumap 3exp com13
      wi imp impcom syl syl5eqel ralrimivva ab2rexex2g syl3anc ) AEFZAGFZUIDHCH
      ZBHZIJZFZDKZGFZCALBALUMCAMBAMDKGFAENZUPUHUOBCAAUHUKAFZUJAFZOZOZUNULGDULPU
      TULAFZULGFUSUHVAUQURUHVATUHURUQVAUHURUQVAUJUKAQRSUAUBULANUCUDUEUMBCDAAUFU
      G @.
  @}

  @{
    @d A a b c @.  @d B a b c @.  @d C a b c @.  @d D a b c @.  @d E a b c @.
    @d F a b c @.  @d U a b c x @.
    @( The predicate "is a morphism of the category Set".  (Contributed by FL,
       15-Sep-2013.) @)
    prismorcset @p |- ( ( ( A e. D /\ B e. E /\ C e. F ) /\
       U e. Univ )
       -> ( <. <. A , B >. , C >. e. ( MorphismSetCat ` U ) <->
         ( A e. U /\ B e. U /\ C e. ( B ^m A ) ) ) ) @=
      ( va vb vc wcel w3a cgru wa cv cmap cvv wceq wss syl2anc cop ccmrcase cfv
      vx coprab simpr cxp wrex cab cdm crn wrel reloprab relssdmrn ax-mp df-3an
      co wb oprabbidv dmeqd dmoprabss eqsstrd rneqd rnoprab2 syl6eq ssid xpss12
      a1i syl5ss xpexg anidms adantl ciun df-iun eliun rexbii abbii wral adantr
      eqtri ralrimiva iunexg syl5eqelr ssexg eleq2 biidd 3anbi123d df-morcatset
      ovex fvmptg eleq2d eleq1 oveq2 oveq1 3anbi3d eloprabg bitrd ) ADKBFKCGKLZ
      EMKZNZABUACUAZEUBUCZKXAHOZEKZIOZEKZJOZXEXCPUQZKZLZHIJUEZKZAEKZBEKZCBAPUQZ
      KZLZWTXBXKXAWTWSXKQKZXBXKRWRWSUFZWTXKEEUGZXIIEUHZHEUHZJUIZUGZSYDQKZXRWTXK
      XKUJZXKUKZUGZYDXKULXKYHSXJHIJUMXKUNUOWTYFXTSYGYCSYHYDSWTYFXDXFNXINZHIJUEZ
      UJZXTWTXKYJWTXJYIHIJXJYIURWTXDXFXIUPVHUSZUTYKXTSWTXIHIJEEVAVHVBWTYGYCYCWT
      YGYJUKYCWTXKYJYLVCXIHIJEEVDVEYCYCSWTYCVFVHVBYFXTYGYCVGTVIWTXTQKZYCQKYEWSY
      MWRWSYMEEMMVJVKVLWTYCHEIEXHVMZVMZQYOXGYNKZHEUHZJUIYCHJEYNVNYQYBJYPYAHEIXG
      EXHVOVPVQVTWTWSYNQKZHEVRYOQKXSWTYRHEWTXDNZWSXHQKZIEVRYRWTWSXDXSVSYSYTIEYT
      YSXFNXEXCPWIVHWAIEXHMQWBTWAHEYNMQWBTWCXTYCQQVJTXKYDQWDTUDEXCUDOZKZXEUUAKZ
      XILZHIJUEXKMQUBUUAERZUUDXJHIJUUEUUBXDUUCXFXIXIUUAEXCWEUUAEXEWEUUEXIWFWGUS
      UDHIJWHWJTWKWRXLXQURWSXJXMXFXGXEAPUQZKZLXMXNXGXOKZLXQHIJABCDFGXCARZXDXMXF
      XFXIUUGXCAEWLUUIXFWFUUIXHUUFXGXCAXEPWMWKWGXEBRZXMXMXFXNUUGUUHUUJXMWFXEBEW
      LUUJUUFXOXGXEBAPWNWKWGXGCRUUHXPXMXNXGCXOWLWOWPVSWQ @.
  @}

  @{
    @d x U a b c @.
    @( The morphisms of the category Set.  (Contributed by FL, 6-Nov-2013.) @)
    morcatset1 @p |- ( U e. Univ -> ( MorphismSetCat ` U ) =
     { <. <. a , b >. , c >. | ( a e. U /\ b e. U /\ c e. ( b ^m a ) ) } ) @=
      ( vx cgru wcel cv cmap co w3a coprab cvv ccmrcase cfv wceq prismorcsetlem
      wel eleq2 3anbi12d oprabbidv df-morcatset fvmptg mpdan ) AFGBHZAGZCHZAGZD
      HUGUEIJGZKZBCDLZMGANOUKPABCDQEABERZCERZUIKZBCDLUKFMNEHZAPZUNUJBCDUPULUFUM
      UHUIUOAUESUOAUGSTUAEBCDUBUCUD @.
  @}

  @{
    @d U a b c @.
    prismorcsetlemc.1 @e |- F = {
               <.
               <. a
               , b
               >.
               , c
               >.
               | ( a e. U /\ b e. U /\ c e. ( b ^m a ) ) } @.
    @( Lemma for ~ morexcmp .  (Contributed by FL, 6-Nov-2013.) @)
    prismorcsetlemc @p |- ( U e. Univ
      -> F C_ ( ( U X. U ) X. U_ a e. U U_ b e. U ( b ^m a ) ) ) @=
      ( wcel cv coprab cxp ciun cdm crn wss wi wa wrex wceq eqtr ex cgru co w3a
      cmap wrel reloprab relssdmrn cab rnoprab2 dmoprabss dfiunv2 eqcomi df-3an
      bicomi oprabbii rneqi sseq1i biimpi eqimss xpss12 sstr a1d syl5com syl2im
      dmeqi eqcoms mpsyl mpan2 mp2 mp2b syl5eqss ) AUAGZBCHZAGZDHZAGZEHVOVMUDUB
      ZGZUCZCDEIZAAJZCADAVQKKZJZFVTUEVTVTLZVTMZJZNZVLVTWCNZOZVSCDEUFVTUGVNVPPVR
      PZCDEIZMZVRDAQCAQEUHZRZWKLZWANZWGWIOZVRCDEAAUIVRCDEAAUJWNWMWBRZWPWQOZWBWM
      CDEAAVQUKULWLWERWNWRPWLWBRZWSWKVTWJVSCDEVSWJVNVPVRUMUNUOZUPWLWMWBSWTWSOWE
      WLWEWLRZWTWSXBWTPWEWBRZWPWDWANZWQWEWLWBSWPXDWOWDWAWKVTXAVEUQURXCWEWBNZXDW
      QWEWBUSXDXEWQXDXEPWFWCNZWGWIWDWAWEWBUTWGXFWIWGXFPWHVLVTWFWCVAVBTVCTVCVDTV
      FVGVHVIVJVK @.
  @}

  @{
    @d M m @.  @d U a b c m @.  @d U a b c u @.
    prismorcset2.1 @e |- A = ( ( 1st o. 1st ) ` M ) @.
    prismorcset2.2 @e |- B = ( ( 2nd o. 1st ) ` M ) @.
    prismorcset2.3 @e |- C = ( 2nd ` M ) @.
    @( The predicate "is a morphism of the category Set".  (Contributed by FL,
       15-Sep-2013.) @)
    prismorcset2 @p |-
     ( ( U e. Univ /\ M e. ( MorphismSetCat ` U ) )
      -> ( A e. U /\ B e. U /\ C e. ( B ^m A ) ) ) @=
      ( c1st cfv wceq wcel cmap co w3a wi c2nd eleq2d eleq1 cvv vm va ccom cgru
      vb vc ccmrcase wa cv fveq2 eleq1d oveq12d eleq12d 3anbi123d imbi2d coprab
      morcatset1 oveq2 3anbi13d oveq1 3anbi23d wb wfo fo1st fof ax-mp vex fvco3
      wf mp2an eqcomi eleq1i a1i oveq12i eloprabi syl6bi vtoclga impcom 3anbi3d
      id com12 syl5ibr ) AEIIUCZJZKZDUDLZEDUGJZLZUHZADLZBDLZCBAMNZLZOZPFWIWNWEW
      DDLZWKCBWDMNZLZOZBEQIUCZJZKZWIWRPGWIWRXAWOWTDLZCWTWDMNZLZOZCEQJZKZWIXEPHW
      IXEXGWOXBXFXCLZOZWHWFXIWFUAUIZWCJZDLZXJWSJZDLZXJQJZXMXKMNZLZOZPWFXIPUAEWG
      XJEKZXRXIWFXSXLWOXNXBXQXHXSXKWDDXJEWCUJZUKXSXMWTDXJEWSUJZUKXSXOXFXPXCXJEQ
      UJXSXMWTXKWDMYAXTULUMUNUOWFXJWGLZXRWFYBXJUBUIZDLZUEUIZDLZUFUIZYEYCMNZLZOZ
      UBUEUFUPZLXRWFWGYKXJDUBUEUFUQRYJXJIJZIJZDLZYFYGYEYMMNZLZOYNYLQJZDLZYGYQYM
      MNZLZOXRUBUEUFXJYCYMKZYDYNYIYPYFYCYMDSUUAYHYOYGYCYMYEMURRUSYEYQKZYFYRYPYT
      YNYEYQDSUUBYOYSYGYEYQYMMUTRVAYGXOKZYNXLYRXNYTXQYNXLVBUUCYMXKDXKYMTTIVIZXJ
      TLZXKYMKTTIVCUUDVDTTIVEVFZUAVGZTTXJIIVHVJVKZVLVMYRXNVBUUCYQXMDXMYQUUDUUEX
      MYQKUUFUUGTTXJQIVHVJVKZVLVMUUCYGXOYSXPUUCVTYSXPKUUCYQXMYMXKMUUIUUHVNVMUMU
      NVOVPWAVQVRXGXDXHWOXBCXFXCSVSWBVFXAWKXBWQXDWOBWTDSXAWPXCCBWTWDMUTRVAWBVFW
      EWJWOWMWQWKAWDDSWEWLWPCAWDBMURRUSWBVF @.
  @}

  @c domSetCat @.
  @( Extend class notation to include the domain of a morphism in the category
     Set. @)
  cdomcase @a class domSetCat @.

  @{
    @d x a @.
    @( The domain of a morphism in the category Set.  Experimental.
       (Contributed by FL, 6-Nov-2013.) @)
    df-domcatset @a |- domSetCat = ( x e. Univ |->
      ( a e. ( MorphismSetCat ` x ) |-> ( ( 1st o. 1st ) ` a ) ) ) @.
  @}

  @c graphSetCat @.
  @( Extend class notation to include the graph of a morphism in the category
     Set. @)
  cgraphcase @a class graphSetCat @.

  @{
    @d x a @.
    @( The underlying function of a morphism in the category Set.
       Experimental.  (Contributed by FL, 6-Nov-2013.) @)
    df-graphcatset @a |- graphSetCat = ( x e. Univ |->
      ( a e. ( MorphismSetCat ` x ) |-> ( 2nd ` a ) ) ) @.
  @}

  @{
    @d x U a @.  @d A a @.
    @( The graph of a morhism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    isgraphmrph @p |- ( ( U e. Univ /\ A e. ( MorphismSetCat ` U ) )
     -> ( ( graphSetCat ` U ) ` A ) = ( 2nd ` A ) ) @=
      ( va vx cgru wcel ccmrcase cfv wa cgraphcase cv c2nd cmpt cvv wceq mptexg
      fvex mp1i fveq2 fvmptg eqidd mpteq12dv df-graphcatset syldan fveq1d simpr
      eqid sylancl eqtrd ) BEFZABGHZFZIZABJHZHACUKCKZLHZMZHZALHZUMAUNUQUJULUQNF
      ZUNUQOUKNFUTUMBGQCUKUPNPRDBCDKZGHZUPMUQENJVABOZCVBUPUKUPVABGSVCUPUAUBDCUC
      TUDUEUMULUSNFURUSOUJULUFALQCAUPUSUKNUQUOALSUQUGTUHUI @.
  @}

  @{
    isgraphmrph2.1 @e |- .graph = ( graphSetCat ` U ) @.
    isgraphmrph2.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    @( The graph of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    isgraphmrph2 @p |- ( ( U e. Univ /\ A e. .Morphism )
     -> ( .graph ` A ) = ( 2nd ` A ) ) @=
      ( cgraphcase cfv wceq cgru wcel wa c2nd ccmrcase eleq2 anbi2d isgraphmrph
      wi syl6bi ax-mp fveq1 eqeq1d syl5ibr ) DBGHZIZBJKZACKZLZADHZAMHZIZREUHUKU
      EAUDHZUJIZCBNHZIZUHUMRFUOUHUFAUNKZLUMUOUGUPUFCUNAOPABQSTUEUIULUJADUDUAUBU
      CT @.
  @}

  @{
    @d U a u v w x @.  @d ph u v w @.
    @( The domain of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    domcatfun @p |- ( U e. Univ ->
      ( domSetCat ` U ) : ( MorphismSetCat ` U ) --> U ) @=
      ( va vx vu vv vw cgru wcel ccmrcase cfv wf c1st cmpt cmap w3a wceq eleq2d
      cv co cvv cdomcase wa coprab df-morcatset fveq1d biimpa wi prismorcsetlem
      ccom eleq2 3anbi12d oprabbidv eqid fvmptg mpdan biimpd adantr eleq1 oveq2
      a1i c2nd 3anbi13d oveq1 3anbi23d 3anbi3d eloprabi wfo fo1st fof ax-mp vex
      fvco3 mp2an eqcomi eleq1i biimpi 3ad2ant1 a1d syl pm2.43a mpd fmptd fveq2
      syl6 eqidd mpteq12dv df-domcatset fvex mptex fvmpt feq1d mpbird ) AGHZAIJ
      ZAAUAJZKWNABWNBRZLLUIJZMZKWMBWNWQAWRWMWPWNHZUBZWPACGDRZCRZHZERZXBHZFRZXDX
      ANSZHZOZDEFUCZMZJZHZWQAHZWMWSXMWMWNXLWPWMAIXKIXKPWMCDEFUDUTUEQUFXMWTXNWTX
      MWPXAAHZXDAHZXHOZDEFUCZHZWTXNUGZWMXMXSUGWSWMXMXSWMXLXRWPWMXRTHXLXRPADEFUH
      CAXJXRGTXKXBAPZXIXQDEFYAXCXOXEXPXHXBAXAUJXBAXDUJUKULXKUMUNUOQUPUQXSWPLJZL
      JZAHZYBVAJZAHZWPVAJZYEYCNSZHZOZXTXQYDXPXFXDYCNSZHZOYDYFXFYHHZOYJDEFWPXAYC
      PZXOYDXHYLXPXAYCAURYNXGYKXFXAYCXDNUSQVBXDYEPZXPYFYLYMYDXDYEAURYOYKYHXFXDY
      EYCNVCQVDXFYGPYMYIYDYFXFYGYHURVEVFYJXNWTYDYFXNYIYDXNYCWQAWQYCTTLKZWPTHWQY
      CPTTLVGYPVHTTLVIVJBVKTTWPLLVLVMVNVOVPVQVRVSWDVTWAWRUMWBWMWNAWOWRCABXBIJZW
      QMWRGUAYABYQWQWNWQXBAIWCYAWQWEWFCBWGBWNWQAIWHWIWJWKWL @.
  @}

  @{
    @( The domain of the function ` domSetCat ` in the category Set.
       (Contributed by FL, 6-Nov-2013.) @)
    domdomcatfun @p |- ( U e. Univ ->
       dom ( domSetCat ` U ) = ( MorphismSetCat ` U ) ) @=
      ( cgru wcel ccmrcase cfv cdomcase wf cdm wceq domcatfun fdm syl ) ABCADEZ
      AAFEZGNHMIAJMANKL @.
  @}

  @{
    domdomcatfun1.1 @e |- .dom = ( domSetCat ` U ) @.
    domdomcatfun1.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    @( The domain of the function ` domSetCat ` in the category Set.
       (Contributed by FL, 6-Nov-2013.) @)
    domdomcatfun1 @p |- ( U e. Univ ->
       dom .dom = .Morphism ) @=
      ( cgru wcel cdomcase cfv cdm ccmrcase domdomcatfun dmeqi 3eqtr4g ) AFGAHI
      ZJAKICJBALCODMEN @.
  @}

  @( The domain of a morphism in the category Set is a member of the underlying
     universe.  (Contributed by FL, 6-Nov-2013.) @)
  domcatsetval @p |- ( ( U e. Univ /\ A e. ( MorphismSetCat ` U ) ) ->
      ( ( domSetCat ` U ) ` A ) e. U ) @=
    ( cgru wcel ccmrcase cfv cdomcase wf domcatfun ffvelrn sylan ) BCDBEFZBBGFZ
    HALDAMFBDBILBAMJK @.

  @{
    domcatsetval2.1 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    domcatsetval2.2 @e |- .dom = ( domSetCat ` U ) @.
    @( The domain of a morphism in the category Set is a member of the
       underlying universe.  (Contributed by FL, 6-Nov-2013.) @)
    domcatsetval2 @p |- ( ( U e. Univ /\ F e. .Morphism ) ->
      ( .dom ` F ) e. U ) @=
      ( ccmrcase cfv wceq cgru wcel wa eleq2 anbi2d cdomcase domcatsetval fveq1
      wi eleq1d ax-mp syl5ibr syl6bi ) CAGHZIZAJKZBCKZLZBDHZAKZREUDUGUEBUCKZLZU
      IUDUFUJUECUCBMNDAOHZIZUKUIRFUKUIUMBULHZAKBAPUMUHUNABDULQSUATUBT @.
  @}

  @{
    @d A a @.  @d U a u @.
    @( The domain of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    domcatval @p |- ( ( U e. Univ /\ A e. ( MorphismSetCat ` U ) )
      -> ( ( domSetCat ` U ) ` A ) = ( ( 1st o. 1st ) ` A ) ) @=
      ( va vu cgru wcel ccmrcase cfv wa cdomcase c1st ccom cmpt wceq fvex fveq2
      cv cvv fvmptg sylancl simpl mptex eqidd mpteq12dv df-domcatset simpr eqid
      fveq1d eqtrd ) BEFZABGHZFZIZABJHZHACUKCQZKKLZHZMZHZAUPHZUMAUNURUMUJURRFUN
      URNUJULUACUKUQBGOUBDBCDQZGHZUQMURERJVABNZCVBUQUKUQVABGPVCUQUCUDDCUESTUHUM
      ULUTRFUSUTNUJULUFAUPOCAUQUTUKRURUOAUPPURUGSTUI @.
  @}

  @{
    domcatval2.1 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    domcatval2.2 @e |- .dom = ( domSetCat ` U ) @.
    @( The domain of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    domcatval2 @p |- ( ( U e. Univ /\ A e. .Morphism )
      -> ( .dom ` A ) = ( ( 1st o. 1st ) ` A ) ) @=
      ( ccmrcase wceq cgru wcel wa c1st ccom wi eleq2 anbi2d cdomcase domcatval
      cfv ax-mp fveq1 eqeq1d syl5ibr syl6bi ) CBGSZHZBIJZACJZKZADSZALLMSZHZNEUF
      UIUGAUEJZKZULUFUHUMUGCUEAOPDBQSZHZUNULNFUNULUPAUOSZUKHABRUPUJUQUKADUOUAUB
      UCTUDT @.
  @}

  @c codSetCat @.
  @( Extend class notation to include the codomain of a morphism in the
     category Set. @)
  ccodcase @a class codSetCat @.

  @{
    @d x a @.
    @( The codomain of a morphism in the category Set.  Experimental.
       (Contributed by FL, 6-Nov-2013.) @)
    df-codcatset @a |- codSetCat = ( x e. Univ |->
      ( a e. ( MorphismSetCat ` x ) |-> ( ( 2nd o. 1st ) ` a ) ) ) @.
  @}

  @{
    @d U a u v w x @.  @d ph u v w @.
    @( The codomain of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    codcatfun @p |- ( U e. Univ ->
      ( codSetCat ` U ) : ( MorphismSetCat ` U ) --> U ) @=
      ( va vx vu vv vw cgru wcel ccmrcase cfv wf c2nd c1st cmpt cmap w3a eleq2d
      cv wceq cvv ccodcase ccom co coprab wa df-morcatset fveq1d prismorcsetlem
      a1i biimpa eleq2 3anbi12d oprabbidv eqid fvmptg mpdan biimpd adantr eleq1
      wi oveq2 3anbi13d oveq1 3anbi23d 3anbi3d eloprabi wfo fo1st fof ax-mp vex
      fvco3 mp2an eqcomi eleq1i 3ad2ant2 syl5com syl6 pm2.43b mpcom fmptd fveq2
      biimpi eqidd mpteq12dv df-codcatset fvex mptex fvmpt feq1d mpbird ) AGHZA
      IJZAAUAJZKWMABWMBRZLMUBJZNZKWLBWMWPAWQWOACGDRZCRZHZERZWSHZFRZXAWROUCZHZPZ
      DEFUDZNZJZHZWLWOWMHZUEZWPAHZWLXKXJWLWMXIWOWLAIXHIXHSWLCDEFUFUIUGQUJXJXLXM
      XLXJWOWRAHZXAAHZXEPZDEFUDZHZXLXMUTWLXJXRUTXKWLXJXRWLXIXQWOWLXQTHXIXQSADEF
      UHCAXGXQGTXHWSASZXFXPDEFXSWTXNXBXOXEWSAWRUKWSAXAUKULUMXHUNUOUPQUQURXRWOMJ
      ZMJZAHZXTLJZAHZWOLJZYCYAOUCZHZPZXLXMXPYBXOXCXAYAOUCZHZPYBYDXCYFHZPYHDEFWO
      WRYASZXNYBXEYJXOWRYAAUSYLXDYIXCWRYAXAOVAQVBXAYCSZXOYDYJYKYBXAYCAUSYMYIYFX
      CXAYCYAOVCQVDXCYESYKYGYBYDXCYEYFUSVEVFYHXMUTXLYDYBXMYGYDXMYCWPAWPYCTTMKZW
      OTHWPYCSTTMVGYNVHTTMVIVJBVKTTWOLMVLVMVNVOWCVPUIVQVRVSVTWQUNWAWLWMAWNWQCAB
      WSIJZWPNWQGUAXSBYOWPWMWPWSAIWBXSWPWDWECBWFBWMWPAIWGWHWIWJWK @.
  @}

  @( The codomain of a morphism in the category Set is a member of the
     underlying universe.  (Contributed by FL, 6-Nov-2013.) @)
  codcatsetval @p |- ( ( U e. Univ /\ A e. ( MorphismSetCat ` U ) ) ->
      ( ( codSetCat ` U ) ` A ) e. U ) @=
    ( cgru wcel ccmrcase cfv ccodcase wf codcatfun ffvelrn sylan ) BCDBEFZBBGFZ
    HALDAMFBDBILBAMJK @.

  @{
    @d A a @.  @d U a u @.
    @( The codomain of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    codcatval @p |- ( ( U e. Univ /\ A e. ( MorphismSetCat ` U ) )
      -> ( ( codSetCat ` U ) ` A ) = ( ( 2nd o. 1st ) ` A ) ) @=
      ( va vu cgru wcel ccmrcase cfv wa ccodcase c2nd c1st cmpt wceq fvex fveq2
      cv cvv fvmptg sylancl ccom simpl mptex eqidd mpteq12dv df-codcatset simpr
      fveq1d eqid eqtrd ) BEFZABGHZFZIZABJHZHACULCQZKLUAZHZMZHZAUQHZUNAUOUSUNUK
      USRFUOUSNUKUMUBCULURBGOUCDBCDQZGHZURMUSERJVBBNZCVCURULURVBBGPVDURUDUEDCUF
      STUHUNUMVARFUTVANUKUMUGAUQOCAURVAULRUSUPAUQPUSUISTUJ @.
  @}

  @{
    codcatval2.1 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    codcatval2.2 @e |- .cod = ( codSetCat ` U ) @.
    @( The codomain of a morphism in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    codcatval2 @p |- ( ( U e. Univ /\ A e. .Morphism )
      -> ( .cod ` A ) = ( ( 2nd o. 1st ) ` A ) ) @=
      ( ccodcase cfv wceq cgru wcel wa c2nd c1st wi ccmrcase eleq2 anbi2d ax-mp
      ccom codcatval syl6bi fveq1 eqeq1d syl5ibr ) DBGHZIZBJKZACKZLZADHZAMNTHZI
      ZOFUJUMUGAUFHZULIZCBPHZIZUJUOOEUQUJUHAUPKZLUOUQUIURUHCUPAQRABUAUBSUGUKUNU
      LADUFUCUDUES @.
  @}

  @{
    prismorcset3.1 @e |- .dom = ( domSetCat ` U ) @.
    prismorcset3.2 @e |- .cod = ( codSetCat ` U ) @.
    prismorcset3.3 @e |- .graph = ( graphSetCat ` U ) @.
    prismorcset3.4 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    @( The predicate "is a morphism of the category Set".  (Contributed by FL,
       6-Nov-2013.) @)
    prismorcset3 @p |- ( ( U e. Univ /\ M e. .Morphism )
      -> ( .graph ` M ) e. ( ( .cod ` M ) ^m ( .dom ` M ) ) ) @=
      ( cfv wceq wcel cmap co wi c1st eqid fveq1 ax-mp ccmrcase wa eleq2 anbi2d
      cgru cdomcase ccodcase cgraphcase c2nd ccom prismorcset2 simp3d codcatval
      isgraphmrph domcatval oveq12d eleq12d mpbird eleq1d syl5ibr oveq1d eleq2d
      oveq2d syl6bi ) CAUAKZLZAUEMZBCMZUBZBDKZBFKZBEKZNOZMZPJVFVIVGBVEMZUBZVNVF
      VHVOVGCVEBUCUDEAUFKZLZVPVNPGVPVNVRVJVKBVQKZNOZMZFAUGKZLZVPWAPHVPWAWCVJBWB
      KZVSNOZMZDAUHKZLZVPWFPIVPWFWHBWGKZWEMZVPWJBUIKZBUIQUJKZBQQUJKZNOZMZVPWMAM
      WLAMWOWMWLWKABWMRWLRWKRUKULVPWIWKWEWNBAUNVPWDWLVSWMNBAUMBAUOUPUQURWHVJWIW
      EBDWGSUSUTTWCVTWEVJWCVKWDVSNBFWBSVAVBUTTVRVMVTVJVRVLVSVKNBEVQSVCVBUTTVDT
      @.
  @}

  @c IdSetCat @.
  @( Extend class notation to include the identity morphism of an object in the
     category Set. @)
  cidcase @a class IdSetCat @.

  @{
    @d x a @.
    @( The identity morphims in the category Set.  Experimental.  (Contributed
       by FL, 6-Nov-2013.) @)
    df-idcatset @a |- IdSetCat = ( x e. Univ |-> ( a e. x |->
       <. <. a , a >. , ( _I |` a ) >. ) ) @.
  @}

  @{
    @d U a x @.
    @( The identity morphims in the category Set.  (Contributed by FL,
       6-Nov-2013.) @)
    idcatfun @p |- ( U e. Univ ->
    ( IdSetCat ` U ) : U --> ( MorphismSetCat ` U ) ) @=
      ( va vx cgru wcel ccmrcase cfv cidcase wf cv cop cid cres cmpt simpr wfun
      wa cvv mp2an a1i funi vex resfunexg simpl w3a cmap co simpl1 wf1o f1oi wb
      f1of elmapg bicomd biimpi mp2b prismorcset mpbir3and syl31anc eqid mptexg
      fmptd wceq mpteq1 df-idcatset fvmptg mpdan feq1d mpbird ) ADEZAAFGZAHGZIA
      VKBABJZVMKLVMMZKZNZIVJBAVOVKVPVJVMAEZQZVQVQVNREZVJVOVKEZVJVQOZWAVSVRLPVMR
      EZVSUABUBZLVMRUCSTVJVQUDVQVQVSUEVJQZVTVQVQVNVMVMUFUGEZVQVQVSVJUHZWFWEWDVM
      VMVNUIVMVMVNIZWEVMUJVMVMVNULWGWEWBWBWGWEUKWCWCWBWBQWEWGVMVMVNRRUMUNSUOUPT
      VMVMVNAAARUQURUSVPUTVBVJAVKVLVPVJVPREVLVPVCBAVODVACABCJZVONVPDRHBWHAVOVDC
      BVEVFVGVHVI @.
  @}

  @{
    obcatset.1 @e |- .Object = dom ( IdSetCat ` U ) @.
    @( The objects of the category Set is the Universe.  (Contributed by FL,
       6-Nov-2013.) @)
    obcatset @p |- ( U e. Univ -> .Object = U ) @=
      ( cgru wcel cidcase cfv cdm ccmrcase wf wceq idcatfun fdm syl syl5eq ) AD
      EZBAFGZHZACPAAIGZQJRAKALASQMNO @.
  @}

  @( An identity morphism is a morphism.  (Contributed by FL, 6-Nov-2013.) @)
  idcatval @p |- ( ( U e. Univ /\ A e. U ) ->
      ( ( IdSetCat ` U ) ` A ) e. ( MorphismSetCat ` U ) ) @=
    ( cgru wcel ccmrcase cfv cidcase wf idcatfun ffvelrn sylan ) BCDBBEFZBGFZHA
    BDAMFLDBIBLAMJK @.

  @{
    idcatval2.1 @e |- .id = ( IdSetCat ` U ) @.
    idcatval2.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    @( An identity morphism is a morphism.  (Contributed by FL, 6-Nov-2013.) @)
    idcatval2 @p |- ( ( U e. Univ /\ A e. U ) ->
      ( .id ` A ) e. .Morphism ) @=
      ( cgru wcel wa cfv ccmrcase cidcase wceq wi idcatval fveq1 eleq1d syl5ibr
      ax-mp syl6eleqr ) BGHABHIZADJZBKJZCDBLJZMZUAUBUCHZNEUAUFUEAUDJZUCHABOUEUB
      UGUCADUDPQRSFT @.
  @}

  @( The underlying universe of an identity morphism.  (Contributed by FL,
     6-Nov-2013.) @)
  domidcat @p |- ( U e. Univ -> dom ( IdSetCat ` U ) = U ) @=
    ( cgru wcel ccmrcase cfv cidcase wf cdm wceq idcatfun fdm syl ) ABCAADEZAFE
    ZGNHAIAJAMNKL @.

  @{
    @d A a @.  @d U a u @.
    @( An identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
    idmor @p |- ( ( U e. Univ /\ A e. U )
     -> ( ( IdSetCat ` U ) ` A ) = <. <. A , A >. , ( _I |` A ) >. ) @=
      ( va vu cgru wcel wa cidcase cfv cop cid cres cmpt cvv wceq mptexg adantr
      cv mpteq1 fvmptg df-idcatset syldan fveq1d opex opeq12 anidms reseq2 eqid
      simpr opeq12d sylancl eqtrd ) BEFZABFZGZABHIZIACBCRZUQJZKUQLZJZMZIZAAJZKA
      LZJZUOAUPVAUMUNVANFZUPVAOUMVFUNCBUTEPQDBCDRZUTMVAENHCVGBUTSDCUATUBUCUOUNV
      ENFVBVEOUMUNUIVCVDUDCAUTVEBNVAUQAOZURVCUSVDVHURVCOUQUQAAUEUFUQAKUGUJVAUHT
      UKUL @.
  @}

  @( An identity morphism is a morphism.  (Contributed by FL, 6-Nov-2013.) @)
  idmorimor @p |- ( ( U e. Univ /\ A e. U )
     -> <. <. A , A >. , ( _I |` A ) >. e. ( MorphismSetCat ` U ) ) @=
    ( cgru wcel wa cidcase cfv cop cid cres ccmrcase idmor idcatval eqeltrrd )
    BCDABDEABFGGAAHIAJHBKGABLABMN @.

  @( Domain of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
  domidmor @p |- ( ( U e. Univ /\ A e. U ) ->
      ( ( domSetCat ` U ) ` ( ( IdSetCat ` U ) ` A ) ) = A ) @=
    ( cgru wcel wa cidcase cfv cdomcase cop cid cres idmor fveq2d c1st wceq cvv
    opex sylancr op1stg eqtrd ccom ccmrcase idmorimor domcatval syldan wf fo1st
    wfo fof ax-mp fvco3 mp2an wfun funi simpr resfunexg sylancom syl5eq ) BCDZA
    BDZEZABFGGZBHGZGAAIZJAKZIZVCGZAVAVBVFVCABLMVAVGVFNNUAGZAUSUTVFBUBGDVGVHOABU
    CVFBUDUEVAVHVFNGZNGZAPPNUFZVFPDVHVJOPPNUHVKUGPPNUIUJVDVEQPPVFNNUKULVAVJVDNG
    ZAVAVIVDNVAVDPDVEPDZVIVDOAAQVAJUMUTVMUNUSUTUOZJABUPRVDVEPPSRMUSUTUTVLAOVNAA
    BBSUQTURTT @.

  @{
    domidmor2.1 @e |- .dom = ( domSetCat ` U ) @.
    domidmor2.2 @e |- .id = ( IdSetCat ` U ) @.
    @( Domain of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
    domidmor2 @p |- ( ( U e. Univ /\ A e. U ) ->
      ( .dom ` ( .id ` A ) ) = A ) @=
      ( cdomcase cfv wceq cgru wcel wa wi cidcase domidmor fveq1 fveq2d syl5ibr
      eqeq1d ax-mp ) CBGHZIZBJKABKLZADHZCHZAIZMEUCUFUBUDUAHZAIZDBNHZIZUCUHMFUCU
      HUJAUIHZUAHZAIABOUJUGULAUJUDUKUAADUIPQSRTUBUEUGAUDCUAPSRT @.
  @}

  @( Domain of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
  codidmor @p |- ( ( U e. Univ /\ A e. U ) ->
      ( ( codSetCat ` U ) ` ( ( IdSetCat ` U ) ` A ) ) = A ) @=
    ( cgru wcel wa cidcase cfv ccodcase cop cid cres idmor fveq2d c2nd c1st cvv
    wceq opex sylancr eqtrd ccom ccmrcase idmorimor codcatval syldan wf wfo fof
    fo1st ax-mp fvco3 mp2an wfun funi simpr op1stg op2ndg anidms adantl syl5eq
    resfunexg ) BCDZABDZEZABFGGZBHGZGAAIZJAKZIZVFGZAVDVEVIVFABLMVDVJVINOUAGZAVB
    VCVIBUBGDVJVKQABUCVIBUDUEVDVKVIOGZNGZAPPOUFZVIPDVKVMQPPOUGVNUIPPOUHUJVGVHRP
    PVINOUKULVDVMVGNGZAVDVLVGNVDVGPDVHPDZVLVGQAARVDJUMVCVPUNVBVCUOJABVASVGVHPPU
    PSMVCVOAQZVBVCVQAABBUQURUSTUTTT @.

  @{
    codidmor2.1 @e |- .cod = ( codSetCat ` U ) @.
    codidmor2.2 @e |- .id = ( IdSetCat ` U ) @.
    @( Domain of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
    codidmor2 @p |- ( ( U e. Univ /\ A e. U ) ->
      ( .cod ` ( .id ` A ) ) = A ) @=
      ( ccodcase cfv wceq cgru wcel wa wi cidcase codidmor fveq1 fveq2d syl5ibr
      eqeq1d ax-mp ) CBGHZIZBJKABKLZADHZCHZAIZMEUCUFUBUDUAHZAIZDBNHZIZUCUHMFUCU
      HUJAUIHZUAHZAIABOUJUGULAUJUDUKUAADUIPQSRTUBUEUGAUDCUAPSRT @.
  @}

  @( Graph of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
  grphidmor @p |- ( ( U e. Univ /\ A e. U ) ->
    ( ( graphSetCat ` U ) ` ( ( IdSetCat ` U ) ` A ) ) = ( _I |` A ) ) @=
    ( cgru wcel wa cidcase cfv cgraphcase cop cid cres c2nd idmor ccmrcase wceq
    fveq2d idmorimor isgraphmrph cvv sylancr syldan opex wfun funi elex adantl
    resfunexg op2ndg 3eqtrd ) BCDZABDZEZABFGGZBHGZGAAIZJAKZIZUNGZUQLGZUPULUMUQU
    NABMPUJUKUQBNGDURUSOABQUQBRUAULUOSDUPSDZUSUPOAAUBULJUCASDZUTUDUKVAUJABUEUFJ
    ASUGTUOUPSSUHTUI @.

  @{
    grphidmor2.1 @e |- .graph = 2nd @.
    grphidmor2.2 @e |- .id = ( IdSetCat ` U ) @.
    @( Graph of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
    grphidmor2 @p |- ( ( U e. Univ /\ A e. U ) ->
      ( .graph ` ( .id ` A ) ) = ( _I |` A ) ) @=
      ( cidcase cfv wceq cgru wcel wa c2nd cop cvv fveq1 eqeq1d syl5ibr ax-mp
      wi cid cres idmor fveq2 opex resiexg adantl op2ndg sylancr expcom syl5com
      eqtr syl mpcom fveq2d ) DBGHZIZBJKZABKZLZADHZCHZUAAUBZIZTFUTVDUQAUPHZCHZV
      CIZCMIZUTVGTEUTVGVHVEMHZVCIZVEAANZVCNZIZUTVJABUCVMVIVLMHZIZUTVJVEVLMUDUTV
      NVCIZVOVJTUTVKOKVCOKZVPAAUEUSVQURABUFUGVKVCOOUHUIVOVPVJVIVNVCULUJUMUKUNVH
      VFVIVCVECMPQRSUQVBVFVCUQVAVECADUPPUOQRS @.
  @}

  @{
    grphidmor3.1 @e |- .graph = ( graphSetCat ` U ) @.
    grphidmor3.2 @e |- .id = ( IdSetCat ` U ) @.
    @( Graph of an identity morphism.  (Contributed by FL, 6-Nov-2013.) @)
    grphidmor3 @p |- ( ( U e. Univ /\ A e. U ) ->
      ( .graph ` ( .id ` A ) ) = ( _I |` A ) ) @=
      ( cgru wcel cfv c2nd cid cres ccmrcase wceq idcatval2 isgraphmrph2 syldan
      wa eqid grphidmor2 eqtrd ) BGHZABHZRADIZCIZUDJIZKALUBUCUDBMIZHUEUFNABUGDF
      UGSZOUDBUGCEUHPQABJDJSFTUA @.
  @}

  @c roSetCat @.
  @( Extend class notation to include the morphisms composition in the category
     Set. @)
  crocase @a class roSetCat @.

  @{
    @d x a b c @.
    @( Composition of two morphisms in the category Set.  Experimental.
       (Contributed by FL, 6-Nov-2013.) @)
    df-rocatset @a |- roSetCat = ( x e. Univ |-> { <. <. a , b >. , c >. |
     ( ( a e. ( MorphismSetCat ` x ) /\ b e. ( MorphismSetCat ` x ) /\
       ( ( 1st o. 1st ) ` a ) = ( ( 2nd o. 1st ) ` b ) ) /\
     c = <. <. ( ( 1st o. 1st ) ` b ) , ( ( 2nd o. 1st ) ` a ) >. ,
             ( ( 2nd ` a ) o. ( 2nd ` b ) ) >. ) } ) @.
  @}

  @{
    @d u U a b c @.
    @( Definition of the composition of two morphisms in the category Set .
       (Contributed by FL, 6-Nov-2013.)  (Revised by Mario Carneiro,
       20-Dec-2013.) @)
    isrocatset @p |- ( U e. Univ ->
     ( roSetCat ` U ) = { <. <. a , b >. , c >. |
     ( ( a e. ( MorphismSetCat ` U ) /\ b e. ( MorphismSetCat ` U ) /\
       ( ( 1st o. 1st ) ` a ) = ( ( 2nd o. 1st ) ` b ) ) /\
     c = <. <. ( ( 1st o. 1st ) ` b ) , ( ( 2nd o. 1st ) ` a ) >. ,
             ( ( 2nd ` a ) o. ( 2nd ` b ) ) >. ) } ) @=
      ( vu cv ccmrcase cfv wcel c1st ccom c2nd wceq w3a cop coprab cgru crocase
      wa eleq2d fveq2 3anbi12d anbi1d oprabbidv df-rocatset df-mpt2 fvex mpt2ex
      cmpt2 cvv eqeltrri 3simpa anim1i ssoprab2i ssexi fvmpt ) EABFZEFZGHZIZCFZ
      USIZUQJJKZHVALJKZHMZNZDFVAVCHUQVDHOUQLHVALHKOZMZSZBCDPUQAGHZIZVAVJIZVENZV
      HSZBCDPZQRURAMZVIVNBCDVPVFVMVHVPUTVKVBVLVEVPUSVJUQURAGUAZTVPUSVJVAVQTUBUC
      UDEBCDUEVOVKVLSZVHSZBCDPZBCVJVJVGUIVTUJBCDVJVJVGUFBCVJVJVGAGUGZWAUHUKVNVS
      BCDVMVRVHVKVLVEULUMUNUOUP @.
  @}

  @{
    cmp2morp.1 @e |- O = ( roSetCat ` U ) @.
    @{
      @d U a b c @.  @d A a b c @.  @d B a b c @.
      @( Composite of two morphisms.  (Contributed by FL, 6-Nov-2013.)
         (Revised by Mario Carneiro, 20-Dec-2013.) @)
      cmp2morp @p |- ( ( U e. Univ /\ ( A e. ( MorphismSetCat ` U )
                 /\ B e. ( MorphismSetCat ` U ) ) /\
                    ( ( domSetCat ` U ) ` A ) = ( ( codSetCat ` U ) ` B ) ) ->
          ( A O B ) = <. <. ( ( 1st o. 1st ) ` B ) ,
                            ( ( 2nd o. 1st ) ` A ) >. ,
             ( ( 2nd ` A ) o. ( 2nd ` B ) ) >. ) @=
        ( va vb vc wcel cfv wa wceq co c1st ccom c2nd cop cv w3a fveq2d crocase
        ccmrcase cdomcase ccodcase coprab isrocatset syl5eq oveqd adantr simprl
        cgru domcatval adantrr codcatval adantrl eqeq12d biimpd impr 3simpa cvv
        wi opex simpr opeq12d coeq12d eqeq2d biimp3ar biantrud eleq1d 3anbi123d
        simpl wb 3adant3 bitr3d moeq moani eqid ovigg mpcom 3expa syl2anc eqtrd
        mp3an3 3impb ) CUKIZACUBJZIZBWFIZKZACUCJJZBCUDJJZLZABDMZBNNOZJZAPNOZJZQ
        ZAPJZBPJZOZQZLWEWIWLKZKZWMABFRZWFIZGRZWFIZXEWNJZXGWPJZLZSZHRZXGWNJZXEWP
        JZQZXEPJZXGPJZOZQZLZKZFGHUEZMZXBWEWMYDLXCWEDYCABWEDCUAJYCECFGHUFUGUHUIX
        DWIAWNJZBWPJZLZYDXBLZWEWIWLUJWEWIWLYGWEWIKZWLYGYIWJYEWKYFWEWGWJYELWHACU
        LUMWEWHWKYFLWGBCUNUOUPUQURWGWHYGYHWIWGWHYGSZYHWGWHYGUSWGWHXBUTIYJYHVAWR
        XAVBYBYJFGHABXBYCWFWFUTXEALZXGBLZXMXBLZSZXLYBYJYNYAXLYKYLYAYMYKYLKZXTXB
        XMYOXPWRXSXAYOXNWOXOWQYOXGBWNYKYLVCZTYOXEAWPYKYLVKZTVDYOXQWSXRWTYOXEAPY
        QTYOXGBPYPTVEVDVFVGVHYKYLXLYJVLYMYOXFWGXHWHXKYGYOXEAWFYQVIYOXGBWFYPVIYO
        XIYEXJYFYOXEAWNYQTYOXGBWPYPTUPVJVMVNYAXLHHXTVOVPYCVQVRWCVSVTWAWBWD @.
    @}

    @( The composite of two morphisms in the category Set is a morphism.
       (Contributed by FL, 6-Nov-2013.) @)
    rocatval @p |- ( ( U e. Univ /\ ( A e. ( MorphismSetCat ` U ) /\
        B e. ( MorphismSetCat ` U ) ) /\
        ( ( domSetCat ` U ) ` A ) = ( ( codSetCat ` U ) ` B ) ) ->
        ( A O B ) e. ( MorphismSetCat ` U ) ) @=
      ( wcel cfv wceq w3a co c1st ccom c2nd cmap syl2anc wf eqid fvex elmap cvv
      cgru ccmrcase wa cdomcase ccodcase cop cmp2morp simp1 simp2r domcatsetval
      domcatval simp2l codcatsetval prismorcset2 simp3d adantrr adantrl eqeq12d
      eqeltrrd codcatval biimp3a eqcomd oveq2d eleqtrrd sylib fco sylibr wb a1i
      coex prismorcset syl31anc mpbir3and eqeltrd ) CUAFZACUBGZFZBVPFZUCZACUDGZ
      GZBCUEGZGZHZIZABDJBKKLZGZAMKLZGZUFAMGZBMGZLZUFZVPABCDEUGWEWMVPFZWGCFZWICF
      ZWLWIWGNJFZWEBVTGZWGCWEVOVRWRWGHVOVSWDUHZVOVQVRWDUIZBCUKOWEVOVRWRCFWSWTBC
      UJOUSWEAWBGZWICWEVOVQXAWIHWSVOVQVRWDULZACUTOWEVOVQXACFWSXBACUMOUSWEWGWIWL
      PZWQWEBWHGZWIWJPZWGXDWKPZXCWEWJWIXDNJZFXEWEWJWIAWFGZNJZXGWEXHCFZWPWJXIFZW
      EVOVQXJWPXKIWSXBXHWIWJCAXHQWIQWJQUNOUOWEXDXHWINWEXHXDVOVSWDXHXDHVOVSUCWAX
      HWCXDVOVQWAXHHVRACUKUPVOVRWCXDHVQBCUTUQURVAVBVCVDWIXDWJAWHRZBWHRZSVEWEWKX
      DWGNJFZXFWEWOXDCFZXNWEVOVRWOXOXNIWSWTWGXDWKCBWGQXDQWKQUNOUOXDWGWKXMBWFRZS
      VEWGXDWIWJWKVFOWIWGWLXLXPSVGWEWGTFZWITFZWLTFZVOWNWOWPWQIVHXQWEXPVIXRWEXLV
      IXSWEWJWKAMRBMRVJVIWSWGWIWLTCTTVKVLVMVN @.

    @{
      rocatval2.1 @e |- .Morphism = ( MorphismSetCat ` U ) @.
      rocatval2.2 @e |- .dom = ( domSetCat ` U ) @.
      rocatval2.3 @e |- .cod = ( codSetCat ` U ) @.
      @( The composite of two morphisms in the category Set is a morphism.
         (Contributed by FL, 7-Nov-2013.) @)
      rocatval2 @p |- ( ( U e. Univ /\ ( A e. .Morphism /\
        B e. .Morphism ) /\
        ( .dom ` A ) = ( .cod ` B ) ) ->
        ( A O B ) e. .Morphism ) @=
        ( cfv wceq wcel wa w3a wi fveq1 ax-mp eleq2 ccmrcase co cdomcase eqeq1d
        3anbi3d ccodcase eqeq2d rocatval syl6bi anbi12d 3anbi2d imbi12d mpbiri
        cgru ) ECUALZMZCUNNZAENZBENZOZAFLZBGLZMZPZABDUBZENZQZIUPVGUQAUONZBUONZO
        ZVCPZVEUONZQZFCUCLZMZVMJVOVKUQVJAVNLZVBMZPZVLVOVCVQUQVJVOVAVPVBAFVNRUDU
        EGCUFLZMZVRVLQKVTVRUQVJVPBVSLZMZPVLVTVQWBUQVJVTVBWAVPBGVSRUGUEABCDHUHUI
        SUISUPVDVKVFVLUPUTVJUQVCUPURVHUSVIEUOATEUOBTUJUKEUOVETULUMS @.
    @}
  @}

  @{
    @d u U a b c @.  @d A a b c @.  @d B a b c @.
    cmp2morpcats.1 @e |- O = ( roSetCat ` U ) @.
    cmp2morpcats.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    cmp2morpcats.3 @e |- .dom = ( domSetCat ` U ) @.
    cmp2morpcats.4 @e |- .cod = ( codSetCat ` U ) @.
    @( Composite of two morphisms.  (Contributed by FL, 7-Nov-2013.) @)
    cmp2morpcats @p |- ( ( U e. Univ /\ ( A e. .Morphism
                 /\ B e. .Morphism ) /\
                    ( .dom ` A ) = ( .cod ` B ) ) ->
          ( A O B ) = <. <. ( .dom ` B ) ,
                            ( .cod ` A ) >. ,
             ( ( 2nd ` A ) o. ( 2nd ` B ) ) >. ) @=
      ( wcel wa cfv wceq c1st ccom c2nd cop biimpi cgru ccmrcase cdomcase simp1
      w3a co ccodcase eleq2i adantr 3ad2ant2 adantl 3ad2ant3 cmp2morp syl121anc
      fveq1i eqeq12i wi ad2antll domcatval syldan eqcomd eqeq2d syl5ibr 3adant3
      fveq1 ax-mp anim2i codcatval syl eqeq1d opeq12d opeq1d eqtrd ) CUALZAELZB
      ELZMZAFNZBGNZOZUEZABDUFZBPPQNZARPQNZSZARNBRNQZSZBFNZAGNZSZWFSWAVNACUBNZLZ
      BWKLZACUCNZNZBCUGNZNZOZWBWGOVNVQVTUDVQVNWLVTVOWLVPVOWLEWKAIUHTUIZUJVQVNWM
      VTVPWMVOVPWMEWKBIUHTZUKUJVTVNWRVQVTWRVRWOVSWQAFWNJUOBGWPKUOUPTULABCDHUMUN
      WAWEWJWFWAWCWHWDWIVNVQWCWHOZVTFWNOZVNVQMZXAUQJXCXAXBWCBWNNZOXCXDWCVNVQWMX
      DWCOVPWMVNVOWTURBCUSUTVAXBWHXDWCBFWNVEVBVCVFVDWAWIWDGWPOZWAWIWDOZUQKWAXFX
      EAWPNZWDOZWAVNWLMZXHVNVQXIVTVQWLVNWSVGVDACVHVIXEWIXGWDAGWPVEVJVCVFVAVKVLV
      M @.
  @}

  @{
    cmp2morpcatt.1 @e |- O = ( roSetCat ` U ) @.
    cmp2morpcatt.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    cmp2morpcatt.3 @e |- .dom = ( domSetCat ` U ) @.
    cmp2morpcatt.4 @e |- .cod = ( codSetCat ` U ) @.
    @{
      cmp2morpcatt.5 @e |- .graph = ( graphSetCat ` U ) @.
      @( Composite of two morphisms.  (Contributed by FL, 7-Nov-2013.) @)
      cmp2morpcatt @p |- ( ( U e. Univ /\ ( A e. .Morphism
                 /\ B e. .Morphism ) /\
                    ( .dom ` A ) = ( .cod ` B ) ) ->
          ( A O B ) = <. <. ( .dom ` B ) ,
                            ( .cod ` A ) >. ,
             ( ( .graph ` A ) o. ( .graph ` B ) ) >. ) @=
        ( cfv c2nd wceq wa wcel cop ccom cgru co isgraphmrph2 anim12dan 3adant3
        w3a cmp2morpcats simpl simpr coeq12d opeq2d eqeq2d syl5ibr mpcom ) AFNZ
        AONZPZBFNZBONZPZQZCUARZAERZBERZQZAGNBHNPZUFZABDUBZBGNAHNSZUOURTZSZPZVBV
        EVAVFVBVCUQVDUTACEFMJUCBCEFMJUCUDUEVGVLVAVHVIUPUSTZSZPABCDEGHIJKLUGVAVK
        VNVHVAVJVMVIVAUOUPURUSUQUTUHUQUTUIUJUKULUMUN @.

      @( Graph of the composite of two morphisms.  (Contributed by FL,
         7-Nov-2013.) @)
      cmp2morpgrp @p |- ( ( U e. Univ /\ ( A e. .Morphism
                 /\ B e. .Morphism ) /\
                    ( .dom ` A ) = ( .cod ` B ) ) ->
        ( .graph ` ( A O B ) ) = ( ( .graph ` A ) o. ( .graph ` B ) ) ) @=
        ( wcel cfv wceq cop ccom fvex fveq1i cgru wa co cgraphcase cmp2morpcatt
        w3a c2nd eqid fveq2d simp1 rocatval2 eqeltrrd isgraphmrph2 syl2anc opex
        coex op2nd eqcomi coeq12i eqtri a1i 3eqtrd ) CUANZAENBENUBZAGOBHOPZUFZA
        BDUCZFOBGOZAHOZQZACUDOZOZBVKOZRZQZFOZVOUGOZAFOZBFOZRZVFVGVOFABCDEVKGHIJ
        KLVKUHUEZUIVFVCVOENVPVQPVCVDVEUJVFVGVOEWAABCDEGHIJKLUKULVOCEFMJUMUNVQVT
        PVFVQVNVTVJVNVHVIUOVLVMAVKSBVKSUPUQVLVRVMVSVRVLAFVKMTURVSVMBFVKMTURUSUT
        VAVB @.
    @}

    @( Domain of the composite of two morphisms.  (Contributed by FL,
       7-Nov-2013.)  (Revised by Mario Carneiro, 27-Dec-2014.) @)
    cmp2morpdom @p |- ( ( U e. Univ /\ ( A e. .Morphism
                 /\ B e. .Morphism ) /\ ( .dom ` A ) = ( .cod ` B ) ) ->
          ( .dom ` ( A O B ) ) = ( .dom ` B ) ) @=
      ( wcel wa cfv wceq c1st ccom c2nd cvv fvex cgru w3a cdomcase a1i ccmrcase
      co fveq1d simp1 eleq2i biimpi anim12i rocatval2 syl3an2 domcatval syl2anc
      eqid cop cmp2morpcats fveq2d wf wfo fo1st fof ax-mp opex fvco3 mp2an coex
      op1st fveq2i 3eqtri syl6eq 3eqtrd ) CUALZAELZBELZMZAFNBGNOZUBZABDUFZFNVTC
      UCNZNZVTPPQZNZBFNZVSVTFWAFWAOVSJUDUGVSVNVTCUENZLZWBWDOVNVQVRUHVQVNAWFLZBW
      FLZMVRWGVOWHVPWIVOWHEWFAIUIUJVPWIEWFBIUIUJUKABCDWFFGHWFUPJKULUMVTCUNUOVSW
      DWEAGNZUQZARNZBRNZQZUQZWCNZWEVSVTWOWCABCDEFGHIJKURUSWPWOPNZPNZWKPNWESSPUT
      ZWOSLWPWROSSPVAWSVBSSPVCVDWKWNVESSWOPPVFVGWQWKPWKWNWEWJVEWLWMARTBRTVHVIVJ
      WEWJBFTAGTVIVKVLVM @.

    @( Codomain of the composite of two morphisms.  (Contributed by FL,
       7-Nov-2013.)  (Revised by Mario Carneiro, 27-Dec-2014.) @)
    cmp2morpcod @p |- ( ( U e. Univ /\ ( A e. .Morphism
                 /\ B e. .Morphism ) /\ ( .dom ` A ) = ( .cod ` B ) ) ->
          ( .cod ` ( A O B ) ) = ( .cod ` A ) ) @=
      ( wcel cfv wceq c2nd c1st ccom cop cvv fvex cgru w3a rocatval2 codcatval2
      wa co simp1 syl2anc cmp2morpcats fveq2d wf wfo fo1st fof ax-mp opex fvco3
      mp2an coex op1st fveq2i op2nd 3eqtri syl6eq eqtrd ) CUALZAELBELUEZAFMBGMN
      ZUBZABDUFZGMZVJOPQZMZAGMZVIVFVJELVKVMNVFVGVHUGABCDEFGHIJKUCVJCEGIKUDUHVIV
      MBFMZVNRZAOMZBOMZQZRZVLMZVNVIVJVTVLABCDEFGHIJKUIUJWAVTPMZOMZVPOMVNSSPUKZV
      TSLWAWCNSSPULWDUMSSPUNUOVPVSUPSSVTOPUQURWBVPOVPVSVOVNUPVQVRAOTBOTUSUTVAVO
      VNBFTAGTVBVCVDVE @.

    @( Associativity of composition in category Set.  (Contributed by FL,
       7-Nov-2013.) @)
    cmpmorass @p |- ( ( U e. Univ /\ ( A e. .Morphism /\ B e. .Morphism
      /\ C e. .Morphism ) /\ ( ( .dom ` C ) = ( .cod ` B ) /\
         ( .dom ` B ) = ( .cod ` A ) ) ) ->
         ( C O ( B O A ) ) = ( ( C O B ) O A ) ) @=
      ( wcel w3a cfv wceq co cop ccom syl121anc cgru wa cgraphcase simp1 simp23
      simp22 simp21 simp3r rocatval2 simp3l cmp2morpcod eqtr4d eqid cmp2morpdom
      cmp2morpcatt opeq1d cmp2morpgrp coeq2d opeq12d eqcomd opeq2d coeq1d coass
      eqcomi a1i eqtrd 3eqtr4d 3eqtrd ) DUAMZAFMZBFMZCFMZNZCGOZBHOZPZBGOZAHOZPZ
      UBZNZCBAEQZEQZWBGOZCHOZRZCDUCOZOZWBWGOZSZRZAGOZWERZWHBWGOZAWGOZSZSZRZCBEQ
      ZAEQZWAVIVLWBFMZVNWBHOZPWCWKPVIVMVTUDZVIVJVKVLVTUEZWAVIVKVJVSXAXCVIVJVKVL
      VTUFZVIVJVKVLVTUGZVIVMVPVSUHZBADEFGHIJKLUITWAVNVOXBVIVMVPVSUJZWAVIVKVJVSX
      BVOPXCXEXFXGBADEFGHIJKLUKTULCWBDEFWGGHIJKLWGUMZUOTWAWFWMWJWQWAWDWLWEWAVIV
      KVJVSWDWLPXCXEXFXGBADEFGHIJKLUNTUPWAWIWPWHWAVIVKVJVSWIWPPXCXEXFXGBADEFWGG
      HIJKLXIUQTURUSWAWMWHWNSZWOSZRWLWSHOZRZWSWGOZWOSZRZWRWTWAWMXMXKXOWAWEXLWLW
      AVIVLVKVPWEXLPXCXDXEXHVIVLVKUBVPNXLWECBDEFGHIJKLUKUTTVAWAXJXNWOWAXNXJWAVI
      VLVKVPXNXJPXCXDXEXHCBDEFWGGHIJKLXIUQTUTVBUSWAWQXKWMWQXKPWAXKWQWHWNWOVCVDV
      EVAWAVIWSFMZVJWSGOZVRPWTXPPXCWAVIVLVKVPXQXCXDXEXHCBDEFGHIJKLUITXFWAXRVQVR
      WAVIVLVKVPXRVQPXCXDXEXHCBDEFGHIJKLUNTXGVFWSADEFWGGHIJKLXIUOTVGVH @.
  @}

  @{
    @d U a b c @.
    morexcmp.1 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    morexcmp.2 @e |- .dom = ( domSetCat ` U ) @.
    morexcmp.3 @e |- .cod = ( codSetCat ` U ) @.
    morexcmp.4 @e |- .graph = 2nd @.
    @( A morphism expressed thanks to its components.  (Contributed by FL,
       8-Nov-2013.)  (Proof shortened by Mario Carneiro, 27-Dec-2014.) @)
    morexcmp @p |- ( ( U e. Univ /\ F e. .Morphism ) ->
       F = <. <. ( .dom ` F ) , ( .cod ` F ) >. , ( .graph ` F ) >. ) @=
      ( va vb vc wcel c1st cfv c2nd cop cvv wceq cgru wa cxp cv cmap w3a coprab
      co ccmrcase morcatset1 syl5eq wss oprabss a1i eqsstrd sselda 1st2nd2 3syl
      syl xp1st ccom domcatval2 wf wfo fo1st fof ax-mp elex adantl fvco3 eqtr2d
      sylancr codcatval2 opeq12d eqtrd eqcomi fveq1i ) AUANZBCNZUBZBBOPZBQPZRZB
      EPZBFPZRZBDPZRVTBSSUCZSUCZNZBWCTVRCWIBVRCKUDZANLUDZANMUDWLWKUEUHNUFZKLMUG
      ZWIVRCAUIPWNGAKLMUJUKWNWIULVRWMKLMUMUNUOUPZBWHSUQUSVTWAWFWBWGVTWAWAOPZWAQ
      PZRZWFVTWJWAWHNWAWRTWOBWHSUTWASSUQURVTWPWDWQWEVTWDBOOVAPZWPBACEGHVBVTSSOV
      CZBSNZWSWPTSSOVDWTVESSOVFVGZVSXAVRBCVHVIZSSBOOVJVLVKVTWEBQOVAPZWQBACFGIVM
      VTWTXAXDWQTXBXCSSBQOVJVLVKVNVOWBWGTVTBQDDQJVPVQUNVNVO @.
  @}

  @{
    morexcmp2.1 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    morexcmp2.2 @e |- .dom = ( domSetCat ` U ) @.
    morexcmp2.3 @e |- .cod = ( codSetCat ` U ) @.
    morexcmp2.4 @e |- .graph = ( graphSetCat ` U ) @.
    @( A morphism expressed thanks to its components.  (Contributed by FL,
       8-Nov-2013.) @)
    morexcmp2 @p |- ( ( U e. Univ /\ F e. .Morphism ) ->
       F = <. <. ( .dom ` F ) , ( .cod ` F ) >. , ( .graph ` F ) >. ) @=
      ( cgru wcel wa cfv cop c2nd eqid morexcmp isgraphmrph2 eqcomd opeq2d
      eqtrd ) AKLBCLMZBBENBFNOZBPNZOUDBDNZOABCPEFGHIPQRUCUEUFUDUCUFUEBACDJGSTUA
      UB @.
  @}

  @{
    cmpidmor2.1 @e |- O = ( roSetCat ` U ) @.
    cmpidmor2.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    cmpidmor2.4 @e |- .cod = ( codSetCat ` U ) @.
    cmpidmor2.5 @e |- .id = ( IdSetCat ` U ) @.
    @( Composition with an identity.  (Contributed by FL, 8-Nov-2013.)  (Proof
       shortened by Mario Carneiro, 27-Dec-2014.) @)
    cmpidmor2 @p |- ( ( U e. Univ /\ F e. .Morphism )
        -> ( ( .id ` ( .cod ` F ) ) O F ) = F ) @=
      ( wcel wa cfv cop c2nd ccom wceq syldan syl5eq eqid cgru cdomcase cidcase
      co ccodcase fveq1i fveq12i ccmrcase eleq2i codcatsetval syl5eqel codidmor
      sylan2b opeq2d cres fveq2i grphidmor2 coeq1d cmap cgraphcase prismorcset3
      cid wf isgraphmrph eqeltrrd elmap sylib fcoi2 syl eqtrd opeq12d idcatval2
      fvex simpl simpr domidmor cmp2morpcats syl121anc morexcmp 3eqtr4d ) AUAKZ
      BDKZLZBAUBMZMZBEMZFMZEMZNZWGOMZBOMZPZNZWEWFNZWKNWGBCUDZBWCWIWNWLWKWCWHWFW
      EWCWHWFAUCMZMZAUEMZMZWFWGWQEWRIWFFWPJUFZUGWAWBWFAKZWSWFQWCWFBWRMZABEWRIUF
      WBWABAUHMZKZXBAKDXCBHUIZBAUJUMUKZWFAULRSUNWCWLVBWFUOZWKPZWKWCWJXGWKWCWJWQ
      OMZXGWGWQOWTUPWAWBXAXIXGQXFWFAOWPOTZWPTUQRSURWCWEWFWKVCZXHWKQWCWKWFWEUSUD
      ZKXKWCBAUTMZMZWKXLWBWAXDXNWKQXEBAVDUMABDXMWDEWDTZIXMTHVAVEWFWEWKBEVMBWDVM
      VFVGWEWFWKVHVIVJVKWCWAWGDKZWBWGWDMZWFQZWOWMQWAWBVNWAWBXAXPXFWFADFJHVLRWAW
      BVOWAWBXAXRXFWAXALXQWQWDMWFWGWQWDWTUPWFAVPSRWGBACDWDEGHXOIVQVRABDOWDEHXOI
      XJVSVT @.
  @}

  @{
    cmpidmor3.1 @e |- O = ( roSetCat ` U ) @.
    cmpidmor3.2 @e |- .Morphism = ( MorphismSetCat ` U ) @.
    cmpidmor3.4 @e |- .dom = ( domSetCat ` U ) @.
    cmpidmor3.5 @e |- .id = ( IdSetCat ` U ) @.
    @( Composition with an identity.  (Contributed by FL, 8-Nov-2013.) @)
    cmpidmor3 @p |- ( ( U e. Univ /\ F e. .Morphism )
        -> ( F O ( .id ` ( .dom ` F ) ) ) = F ) @=
      ( wcel wa cfv cop ccom co wceq syldan eqid cvv ccodcase cgraphcase opeq1d
      cgru domcatsetval2 domidmor2 cid cres grphidmor3 coeq2d cmap prismorcset3
      wf wb fvex pm3.2i elmapg mp1i mpbid fcoi1 syl eqtrd simpl simpr idcatval2
      opeq12d codidmor2 eqcomd cmp2morpcatt syl121anc morexcmp2 3eqtr4d ) AUDKZ
      BDKZLZBEMZFMZEMZBAUAMZMZNZBAUBMZMZVQWBMZOZNZVPVTNZWCNBVQCPZBVOWAWGWEWCVOV
      RVPVTVMVNVPAKZVRVPQABDEHIUEZVPAEFIJUFRUCVOWEWCUGVPUHZOZWCVOWDWKWCVMVNWIWD
      WKQWJVPAWBFWBSZJUIRUJVOVPVTWCUMZWLWCQVOWCVTVPUKPKZWNABDWBEVSIVSSZWMHULVTT
      KZVPTKZLWOWNUNVOWQWRBVSUOBEUOUPVTVPWCTTUQURUSVPVTWCUTVAVBVFVOVMVNVQDKZVPV
      QVSMZQWHWFQVMVNVCVMVNVDVMVNWIWSWJVPADFJHVERVOWTVPVMVNWIWTVPQWJVPAVSFWPJVG
      RVHBVQACDWBEVSGHIWPWMVIVJABDWBEVSHIWPWMVKVL @.
  @}

  @{
    @d U a b c @.
    @( Composition of morphisms is a function.  (Contributed by FL,
       8-Nov-2013.)  (Revised by Mario Carneiro, 20-Dec-2013.) @)
    cmpmorfun @p |- ( U e. Univ -> Fun ( roSetCat ` U ) ) @=
      ( va vb vc cgru wcel crocase cfv wfun cv ccmrcase c1st ccom c2nd wceq w3a
      cop wa coprab moeq moani funoprab isrocatset funeqd mpbiri ) AEFZAGHZIBJZ
      AKHZFCJZUIFUHLLMZHUJNLMZHOPZDJUJUKHUHULHQUHNHUJNHMQZOZRZBCDSZIUPBCDUOUMDD
      UNTUAUBUFUGUQABCDUCUDUE @.
  @}

  @{
    @d U a b c @.
    @( Morphisms composition is defined every time the codomain of the second
       operand matches the domain of the first one.  (Contributed by FL,
       8-Nov-2013.)  (Revised by Mario Carneiro, 20-Dec-2013.) @)
    cmppar2 @p |- ( U e. Univ
    -> dom ( roSetCat ` U ) = { <. a , b >. |
     ( a e. ( MorphismSetCat ` U ) /\ b e. ( MorphismSetCat ` U ) /\
      ( ( 1st o. 1st ) ` a ) = ( ( 2nd o. 1st ) ` b ) ) } ) @=
      ( vc cgru wcel crocase cfv cdm ccmrcase c1st ccom c2nd wceq w3a cop copab
      cv wex syl6eq coprab isrocatset dmeqd dmoprab opex isseti 19.42v mpbiran2
      wa opabbii ) AEFZAGHZIZBRZAJHZFCRZUOFUNKKLZHUPMKLZHNOZDRUPUQHUNURHPZUNMHU
      PMHLZPZNZUIZDSZBCQZUSBCQUKUMVDBCDUAZIVFUKULVGABCDUBUCVDBCDUDTVEUSBCVEUSVC
      DSDVBUTVAUEUFUSVCDUGUHUJT @.
  @}

  @{
    @d u U a b c @.
    @( Composition of morphisms is a partial operation in the set of
       morphisms.  (Contributed by FL, 8-Nov-2013.)  (Revised by Mario
       Carneiro, 20-Dec-2013.) @)
    cmppar @p |- ( U e. Univ -> dom ( roSetCat ` U ) C_
                   ( ( MorphismSetCat ` U ) X. ( MorphismSetCat ` U ) ) ) @=
      ( va vb cgru wcel crocase cfv cdm cv ccmrcase c1st ccom c2nd wceq w3a cxp
      copab cmppar2 wss wa df-3an opabbii opabssxp eqsstri a1i eqsstrd ) ADEZAF
      GHBIZAJGZEZCIZUIEZUHKKLGUKMKLGNZOZBCQZUIUIPZABCRUOUPSUGUOUJULTUMTZBCQUPUN
      UQBCUJULUMUAUBUMBCUIUIUCUDUEUF @.
  @}

  @{
    @d A a b @.  @d B a b @.  @d U a b @.
    @( Morphisms composition is defined every time the codomain of the second
       operand matches the domain of the first one.  (Contributed by FL,
       8-Nov-2013.) @)
    cmppar3 @p |- ( ( U e. Univ /\ A e. ( MorphismSetCat ` U )
                 /\ B e. ( MorphismSetCat ` U ) )
      -> ( <. A , B >. e. dom ( roSetCat ` U ) <->
       ( ( domSetCat ` U ) ` A ) = ( ( codSetCat ` U ) ` B ) ) ) @=
      ( va vb cgru wcel cfv w3a cv c1st ccom wceq wb elex eleq1 fveq2 wa eqcomd
      cvv ccmrcase cop crocase cdm c2nd copab cdomcase ccodcase 3ad2ant1 eleq2d
      cmppar2 3ad2ant2 3ad2ant3 eqeq1d 3anbi13d 3anbi23d opelopabg syl2anc ibar
      eqeq2d 3adant1 syl6rbbr domcatval 3adant3 codcatval 3adant2 eqeq12d bitrd
      df-3an 3bitrd ) CFGZACUAHZGZBVLGZIZABUBZCUCHUDZGVPDJZVLGZEJZVLGZVRKKLZHZV
      TUEKLZHZMZIZDEUFZGZVMVNAWBHZBWDHZMZIZACUGHHZBCUHHHZMZVOVQWHVPVKVMVQWHMVNC
      DEUKUIUJVOATGZBTGZWIWMNVMVKWQVNAVLOULVNVKWRVMBVLOUMWGVMWAWJWEMZIWMDEABTTV
      RAMZVSVMWFWSWAVRAVLPWTWCWJWEVRAWBQUNUOVTBMZWAVNWSWLVMVTBVLPXAWEWKWJVTBWDQ
      UTUPUQURVOWMWLWPVOWLVMVNRZWLRZWMVMVNWLXCNVKXBWLUSVAVMVNWLVIVBVOWJWNWKWOVO
      WNWJVKVMWNWJMVNACVCVDSVOWOWKVKVNWOWKMVMBCVEVFSVGVHVJ @.
  @}

  @{
    @d x U a b @.
    @( The composite of two morphisms is a morphism.  (Contributed by FL,
       8-Nov-2013.) @)
    cmpmor @p |- ( U e. Univ
    -> ran ( roSetCat ` U ) C_ ( MorphismSetCat ` U ) ) @=
      ( va vb vx cgru wcel crocase cfv cv ccmrcase c1st ccom c2nd w3a wa wex wi
      wceq eqtr 3imp copab wfn wral crn wss wfun cdm cmpmorfun cmppar2 sylanbrc
      df-fn cop elopab cdomcase ccodcase domcatval 3adant3 codcatval 3adant2 co
      df-ov eqid rocatval 3expa syl5eqelr exp42 syl5com expcom eqcoms com3l syl
      ex com24 sylc pm2.43i 3exp com4l fveq2 eleq1d imbi2d syl5ibr imp exlimivv
      sylbi com12 ralrimiv fnfvrnss syl2anc ) AEFZAGHZBIZAJHZFZCIZWLFZWKKKLHZWN
      MKLHZRZNZBCUAZUBZDIZWJHZWLFZDWTUCWJUDWLUEWIWJUFWJUGWTRXAAUHABCUIWJWTUKUJW
      IXDDWTXBWTFZWIXDXEXBWKWNULZRZWSOZCPBPWIXDQZWSBCXBUMXHXIBCXGWSXIWSXIXGWIXF
      WJHZWLFZQZWMWOWRXLWIWMWOWRXKWIWMWOWRXKQZWIWMWONZXMXNWKAUNHHZWPRZWNAUOHHZW
      QRZXNXMQWIWMXPWOWKAUPUQWIWOXRWMWNAURUSXPWRXNXRXKXPWRXNXRXKQQZXPWROXOWQRZX
      SXOWPWQSXRXTXNXKXTXNXKQZQWQXQXTWQXQRZYAXTYBOXOXQRZXNXKXOWQXQSWIWMWOYCXKQW
      IWMWOYCXKWIWMWOOZOYCOXJWKWNWJUTZWLWKWNWJVAWIYDYCYEWLFWKWNAWJWJVBVCVDVEVFT
      VGVHVIVJVKVLVMVNVOVPVQTXGXDXKWIXGXCXJWLXBXFWJVRVSVTWAWBWCWDWEWFDWTWLWJWGW
      H @.
  @}

  @c SetCatOLD @.
  @( Extend class notation to include the category Set. @)
  ccaset @a class SetCatOLD @.

  @{
    @( Definition of the category Set.  (We should say "the categories Set"
       since there is such a category per universe but for our purpose they are
       equivalent obviously.)  Experimental.  (Contributed by FL,
       8-Nov-2013.) @)
    df-catset @a |- SetCatOLD = ( x e. Univ |->
     <. <. ( domSetCat ` x ) , ( codSetCat ` x ) >. ,
        <. ( IdSetCat ` x ) , ( roSetCat ` x ) >. >. ) @.
  @}

  @{
    @d x U @.
    @( The category Set.  (Contributed by FL, 8-Nov-2013.) @)
    iscatset @p |- ( U e. Univ -> ( SetCatOLD ` U ) =
      <. <. ( domSetCat ` U ) , ( codSetCat ` U ) >. ,
         <. ( IdSetCat ` U ) , ( roSetCat ` U ) >. >. ) @=
      ( vx cv cdomcase cfv ccodcase cop cidcase crocase cgru wceq fveq2 opeq12d
      ccaset df-catset opex fvmpt ) BABCZDEZRFEZGZRHEZRIEZGZGADEZAFEZGZAHEZAIEZ
      GZGJNRAKZUAUGUDUJUKSUETUFRADLRAFLMUKUBUHUCUIRAHLRAILMMBOUGUJPQ @.
  @}

  @{
    @d f g U h a @.
    @( The category set is a category.  (Contributed by FL, 6-Nov-2013.) @)
    setiscat @p |- ( U e. Univ -> ( SetCatOLD ` U ) e. CatOLD ) @=
      ( vh vg vf va wcel cfv cop cv wceq wa co wi wral w3a wf 3jca cvv eqid syl
      cgru ccaset cdomcase ccodcase cidcase crocase iscatset cded cdm calg wfun
      ccatOLD wb cxp wss ccmrcase domcatfun domdomcatfun domidcat feq23d mpbird
      crn codcatfun idcatfun cmppar xpeq12d sseqtr4d cmpmor fvex 3pm3.2i pm3.2i
      cmpmorfun isalg mp1i mpbir2and eleq2d biimpd imdistani domidmor ralrimiva
      codidmor jca simpl simprr simprl eleq2 3anbi23d syl5ibr eqcoms ralrimivva
      anabsi5 cmppar3 cmp2morpdom 3exp ancomsd anbi12d imbi1d mpcom cmp2morpcod
      ralrimivv com12 ancoms syl6bi com23 simp1l adantrd adantr adantld 3adant3
      isded simp3 cmpmorass syl3anc ralrimiv anc2li cmpidmor2 syl6 eleq1 anbi1d
      imp fveq2 oveq1d eqeq1d imbi12d com3l cmpidmor3 ex oveq2d imbi2d iscatOLD
      eqeltrd ) AUAFZAUBGAUCGZAUDGZHAUEGZAUFGZHHZULAUGYLYQULFZYQUHFZBIZYMGCIZYN
      GZJUUAYMGDIZYNGZJZKZYTUUAUUCYPLZYPLYTUUAYPLUUCYPLJZMZBYMUIZNZCUUJNDUUJNZK
      ZUUDEIZJZUUNYOGZUUCYPLZUUCJZMZDUUJNEYOUIZNZUUCYMGZUUNJZUUCUUPYPLZUUCJZMZD
      UUJNEUUTNZKZYLYSUULYLYSYQUJFZUUPYMGUUNJZUUPYNGUUNJZKZEUUTNZUUAUUCHYPUIZFU
      UEUMZCUUJNDUUJNZOZUUEUUGYMGUVBJZMZCUUJNDUUJNZUUEUUGYNGUUBJZMZCUUJNDUUJNZK
      ZYLUVIUVMUVPYLUVIUUJUUTYMPZUUJUUTYNPZUUTUUJYOPZOZYPUKZUVNUUJUUJUNZUOZYPVB
      ZUUJUOZOZYLUWEUWFUWGYLUWEAUPGZAYMPAUQYLUUJUUTUWOAYMAURZAUSZUTVAYLUWFUWOAY
      NPAVCYLUUJUUTUWOAYNUWPUWQUTVAYLUWGAUWOYOPAVDYLUUTUUJAUWOYOUWQUWPUTVAQYLUW
      IUWKUWMAVLYLUVNUWOUWOUNUWJAVEYLUUJUWOUUJUWOUWPUWPVFVGYLUWLUWOUUJAVHUWPVGQ
      YMRFZYNRFZYORFZOZYPRFZKZUVIUWHUWNKUMYLUXAUXBUWRUWSUWTAUCVIAUDVIAUEVIVJAUF
      VIVKZRRYNYMYPRRYOUUJUUTUUJSZUUTSZVMVNVOYLUVLEUUTYLUUNUUTFZKZUVJUVKUXHYLUU
      NAFZKZUVJYLUXGUXIYLUXGUXIYLUUTAUUNUWQVPVQVRZUUNAVSTUXHUXJUVKUXKUUNAWATWBV
      TYLUVODCUUJUUJYLUUCUUJFZUUAUUJFZKZKZYLUUAUWOFZUUCUWOFZOZUVOYLUXNUXRYLUUJU
      WOJZUXOUXRMZUWPUXTUWOUUJUXOUXRUWOUUJJZYLUXMUXLOUXOYLUXMUXLYLUXNWCYLUXLUXM
      WDYLUXLUXMWEQUYAUXPUXMUXQUXLYLUWOUUJUUAWFUWOUUJUUCWFWGWHWITWKUUAUUCAWLTWJ
      QYLUVTUWCYLUVSDCUUJUUJUXSYLUXNUVSMZUWPYLUYBUXSUXQUXPKZUVSMYLUXPUXQUVSYLUX
      PUXQKZUUEUVRUUAUUCAYPUWOYMYNYPSZUWOSZYMSZYNSZWMWNWOUXSUXNUYCUVSUXSUXLUXQU
      XMUXPUUJUWOUUCWFUUJUWOUUAWFWPZWQWHWRWTYLUWBDCUUJUUJUXSYLUXNUWBMUWPUXSUXNY
      LUWBUXSUXNUYCYLUWBMZUYIUXPUXQUYJYLUYDUWBYLUYDUUEUWAUUAUUCAYPUWOYMYNUYEUYF
      UYGUYHWSWNXAXBXCXDWRWTWBUXCYSUVQUWDKUMYLUXDRRYNYMYPDCRRYOUUJUUTEUXEUXFXJV
      NVOYLUUKDCUUJUUJUXOUUIBUUJUXOYTUUJFZUUFUUHUXOUYKUUFOYLUXQUXPYTUWOFZOZUUFU
      UHYLUXNUYKUUFXEUXOUYKUYMUUFUXOUYKKUXQUXPUYLUXOUXQUYKYLUXNUXQYLUXLUXQUXMYL
      UXLUXQYLUUJUWOUUCUWPVPVQZXFXTXGUXOUXPUYKYLUXNUXPYLUXMUXPUXLYLUXMUXPYLUUJU
      WOUUAUWPVPVQXHXTXGUXOUYKUYLYLUYKUYLMUXNYLUYKUYLYLUUJUWOYTUWPVPVQXGXTQXIUX
      OUYKUUFXKUUCUUAYTAYPUWOYMYNUYEUYFUYGUYHXLXMWNXNWJWBYLUVAUVGYLUUSEDUUTUUJU
      UOYLUXGUXLKZUURYLUYOUURMZMUUNUUDYLUYPUUNUUDJZUUDUUTFZUXLKZUUDYOGZUUCYPLZU
      UCJZMYLUYSYLUXQKZVUBYLUYSUXQYLUXLUXQUYRUYNXHXOAUUCYPUWOYNYOUYEUYFUYHYOSZX
      PXQUYQUYOUYSUURVUBUYQUXGUYRUXLUUNUUDUUTXRXSUYQUUQVUAUUCUYQUUPUYTUUCYPUUNU
      UDYOYAYBYCYDWHWIYEWTYLUVFEDUUTUUJUVCYLUYOUVEYLUYOUVEMZMUUNUVBYLVUEUUNUVBJ
      ZUYOUUCUVBYOGZYPLZUUCJZMYLUYOVUIYLUYOKVUCVUIYLUYOUXQYLUXLUXQUXGUYNXHVRAUU
      CYPUWOYMYOUYEUYFUYGVUDYFTYGVUFUVEVUIUYOVUFUVDVUHUUCVUFUUPVUGUUCYPUUNUVBYO
      YAYHYCYIWHWIYEWTWBUXCYRUUMUVHKUMYLUXDRRYNYMYPDCBRRYOUUJUUTEUXEUXFYJVNVOYK
      @.
  @}

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
       Grammars, Logics, Machines and Automata
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c Kleene @.

  @( Extend class notation with the Kleene star. @)
  ckln @a class Kleene @.


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Words
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)


  @c Words @.

  @( Extend class notation with the class of words of a given size. @)
  cwrd @a class Words @.

  @{
    @d x y @.
    @( The words of size ` y ` over an alphabet ` x ` are the finite sequences
       over ` x ` of size ` y ` .  Their domains are fiercely set to
       ` ( 1 ... y ) ` so that I can concatenate them easily.  The case
       ` y = 0 ` is a bit tricky and corresponds to the unique empty word
       (often denoted by an epsilon or by ` 1 ` in textbooks.)  Experimental.
       (Contributed by FL, 14-Jan-2014.) @)
    df-words @a |- Words = ( x e. _V , y e. NN0 |-> ( x ^m ( 1 ... y ) ) ) @.
  @}

  @{
    @d x y A @.  @d x y N @.
    @( The words over a set ` A ` .  (Contributed by FL, 14-Jan-2014.) @)
    isword @p |- ( ( A e. B /\ N e. NN0 )
      -> ( A Words N ) = ( A ^m ( 1 ... N ) ) ) @=
      ( vx vy wcel cn0 wa cvv c1 cfz co cmap cwrd wceq elex adantr simpr ovex
      cv a1i oveq1 oveq2 oveq2d df-words ovmpt2g syl3anc ) ABFZCGFZHZAIFZUIAJCK
      LZMLZIFZACNLUMOUHUKUIABPQUHUIRUNUJAULMSUADEACIGDTZJETZKLZMLUMNAUQMLIUOAUQ
      MUBUPCOUQULAMUPCJKUCUDDEUEUFUG @.
  @}

  @c dWords @.


  @( Syntax for the dWords operator. @)
  cdwords @a class dWords @.

  @{
    @d a s w x y @.
    @( Words of size S over an alphabet ` A ` with all the elements different.
       (For my private use only.  Don't use.)  (Contributed by FL,
       26-May-2016.) @)
    df-dwords @a |- dWords = ( a e. _V , s e. NN0 |-> { w e. ( a Words s ) |
      A. x e. ( 1 ... s ) A. y e. ( 1 ... s )
        ( x =/= y -> ( w ` x ) =/= ( w ` y ) ) } ) @.
  @}


  @{
    @d a s w x y S @.  @d a s w A @.  @d w x y W @.
    @( The words over a set ` A ` .  (For my private use only.  Don't use.)
       (Contributed by FL, 26-May-2014.) @)
    isnword @p |- ( ( A e. B /\ S e. NN0 )
      -> ( W e. ( A dWords S ) <-> ( W e. ( A ^m ( 1 ... S ) ) /\
      A. x e. ( 1 ... S ) A. y e. ( 1 ... S )
        ( x =/= y -> ( W ` x ) =/= ( W ` y ) ) ) ) ) @=
      ( vw va vs wcel wa co cv wne cfv c1 wral cwrd cvv wceq cn0 cdwords wi cfz
      crab cmap elex adantr simpr rabex a1i oveq1 rabeq oveq2 raleqdv raleqbidv
      ovex rabeqbidv df-dwords ovmpt2g syl3anc eleq2d wb fveq1 neeq12d 2ralbidv
      syl imbi2d elrab isword anbi1d 3bitrd ) CDJZEUAJZKZFCEUBLZJFAMZBMZNZVQGMZ
      OZVRVTOZNZUCZBPEUDLZQZAWEQZGCERLZUEZJZFWHJZVSVQFOZVRFOZNZUCZBWEQAWEQZKZFC
      WEUFLZJZWPKVOVPWIFVOCSJZVNWISJZVPWITVMWTVNCDUGUHVMVNUIXAVOWGGWHCERUQUJUKH
      ICESUAWDBPIMZUDLZQZAXCQZGHMZXBRLZUEZWIUBXEGCXBRLZUEZSXFCTXGXITXHXJTXFCXBR
      ULXEGXGXIUMVGXBETZXEWGGXIWHXBECRUNXKXDWFAXCWEXBEPUDUNZXKWDBXCWEXLUOUPURAB
      GIHUSUTVAVBWJWQVCVOWGWPGFWHVTFTZWDWOABWEWEXMWCWNVSXMWAWLWBWMVQVTFVDVRVTFV
      DVEVHVFVIUKVOWKWSWPVOWHWRFCDEVJVBVKVL @.
  @}


  @{
    @d x a u @.
    @( The Kleene star of an alphabet ` x ` is the set of all the finite
       sequences of elements of this alphabet.  Experimental.  (Contributed by
       FL, 14-Jan-2014.) @)
    df-kle @a |- Kleene = ( x e. _V |->
      U_ u e. NN0 ( x ^m ( 1 ... u ) ) ) @.
  @}

  @{
    @d x u A @.
    @( The predicate is the Kleene star of a set ` A ` .  An element of
       ` ( Kleene `` A ) ` is called a word.  (Contributed by FL,
       14-Jan-2014.) @)
    isKleene @p |- ( A e. B
    -> ( Kleene ` A ) = U_ u e. NN0 ( A ^m ( 1 ... u ) ) ) @=
      ( vx wcel cvv cn0 c1 cv cfz cmap ciun ckln cfv wceq elex wral nn0ex ovex
      co rgenw a1i iunexg sylancr oveq1 iuneq2d df-kle fvmptg syl2anc ) BCEZBFE
      AGBHAIJTZKTZLZFEZBMNUMOBCPUJGFEULFEZAGQZUNRUPUJUOAGBUKKSUAUBAGULFFUCUDDBA
      GDIZUKKTZLUMFFMUQBOAGURULUQBUKKUEUFDAUGUHUI @.
  @}

  @{
    @d n A @.
    @( Symbols and variables belong to the Kleene star of ` NN ` .
       (Contributed by FL, 2-Feb-2014.) @)
    1iskle @p |- ( A e. NN -> { <. 1 , A >. } e. ( Kleene ` NN ) ) @=
      ( vn cn wcel c1 cop csn cn0 cv cfz co cmap wceq ax-mp a1i mpbird cvv nnex
      wf sylancr ciun ckln cfv wrex 1nn0 wss wf1o 1nn f1osng mpan syl snssi fss
      f1of syl2anc cz 1z fzsn feq2d wb elmapg oveq2 oveq2d eleq2d rspcev sylibr
      ovex eliun isKleene syl6eleqr ) ACDZEAFGZBHCEBIZJKZLKZUAZCUBUCZVKVLVODZBH
      UDZVLVPDVKEHDVLCEEJKZLKZDZVSUEVKWBVTCVLSZVKWCEGZCVLSZVKWDAGZVLSZWFCUFWEVK
      WDWFVLUGZWGECDVKWHUHEACCUIUJWDWFVLUNUKACULWDWFCVLUMUOVKVTWDCVLVTWDMZVKEUP
      DWIUQEURNOUSPVKCQDZVTQDZWBWCUTRWKVKEEJVGOCVTVLQQVATPVRWBBEHVMEMZVOWAVLWLV
      NVTCLVMEEJVBVCVDVETBVLHVOVHVFWJVQVPMRBCQVINVJ @.
  @}

  @{
    @d x C @.
    selsubf.1 @e |- A e. _V @.
    selsubf.2 @e |- C e. _V @.
    @( A way of selecting a subset of functions so that their values belong to
       ` B ` .  (Contributed by FL, 14-Jan-2014.) @)
    selsubf @p |- ( ( A ^m C ) i^i ~P ( C X. B ) ) = ( ( A i^i B ) ^m C ) @=
      ( vx cxp cpw cv wfn cab cin cmap co in32 xpindi pweqi pwin ineq1i mapval2
      eqtr2i eqtri inex1 3eqtr4i ) CAGZHZFICJFKZLZCBGZHZLZCABLZGZHZUGLZACMNZUJL
      ULCMNUKUFUJLZUGLUOUFUGUJOUQUNUGUNUEUILZHUQUMURCABPQUEUIRUASUBUPUHUJACFDET
      SULCFABDUCETUD @.
  @}

  @{
    @d f C @.
    selsubf3.1 @e |- A e. _V @.
    selsubf3.2 @e |- C e. _V @.
    @( A way of selecting a subset of functions so that their values belong to
       ` B ` .  (Contributed by FL, 14-Jan-2014.) @)
    selsubf3 @p |- ( ( A ^m C ) i^i ~P ( _V X. B ) ) = ( ( A i^i B ) ^m C ) @=
      ( vf cxp cpw cv wfn cab cin cvv cmap co in32 pwin eqtri ineq1i mapval2
      inxp inv1 xpeq1i pweqi eqtr3i inex1 3eqtr4i ) CAGZHZFICJFKZLZMBGZHZLZCABL
      ZGZHZUJLZACNOZUMLUOCNOUNUIUMLZUJLURUIUJUMPUTUQUJUHULLZHUTUQUHULQVAUPVACML
      ZUOGUPCAMBUAVBCUOCUBUCRUDUESRUSUKUMACFDETSUOCFABDUFETUG @.
  @}

  @{
    @( A way of selecting a subset of functions so that their values belong to
       ` B ` .  (Contributed by FL, 14-Jan-2014.) @)
    selsubf3g @p |- ( ( A e. D /\ C e. E ) ->
        ( ( A ^m C ) i^i ~P ( _V X. B ) ) = ( ( A i^i B ) ^m C ) ) @=
      ( wcel cvv cmap co cxp cin wceq elex cif ineq1d eqeq12d oveq2 0ex elimel
      c0 cpw oveq1 ineq1 oveq1d selsubf3 dedth2h syl2an ) ADFAGFZCGFZACHIZGBJUA
      ZKZABKZCHIZLZCEFADMCEMUHUIUOUHATNZCHIZUKKZUPBKZCHIZLUPUICTNZHIZUKKZUSVAHI
      ZLACTTAUPLZULURUNUTVEUJUQUKAUPCHUBOVEUMUSCHAUPBUCUDPCVALZURVCUTVDVFUQVBUK
      CVAUPHQOCVAUSHQPUPBVAATGRSCTGRSUEUFUG @.
  @}

  @c IndCls @.

  @( Extend class notation with the class of inductive closures. @)
  clincl @a class IndCls @.

@(
  %c IndClsBu %.

  %( Extend class notation with the class of inductive closures. %)
  clinclb %a class IndClsBu %.
@)

  @{
    @d x y a f j @.
    @( Definition of an inductive closure.  Top down definition.  Gallier p. 19
       (Contributed by FL, 14-Jan-2014.) @)
    df-indcls @a |- IndCls = ( x e. _V , y e. _V |-> |^| { a | ( x C_ a /\
        A. f e. y A. j e. ( dom f i^i ~P ( _V X. a ) ) ( f ` j ) e. a ) } ) @.
  @}

  @{
    @d A f n @.  @d f U n @.  @d f F @.
    @( Lemma for ~ indcls2 .  (Contributed by FL, 14-Jan-2014.) @)
    lemindclsbu @p |- ( ( U e. A /\
      A. f e. F E. n e. NN f e. ( U ^m ( U ^m ( 1 ... n ) ) ) )
       -> F e. _V ) @=
      ( wcel cv c1 co cmap cn wral cz cxp cpw wss cvv wa wi syl cfz mapsspw cuz
      wrex cfv fzssuz uzssz sstri xpss1 sspwb sstr w3a ssel a1dd a1i syl5com ex
      com5l sylbi 3imp1 mpi 3exp1 expcom ax-mp rexlimiv com12 ralimdv imp dfss3
      mp2b sylibr zex elex xpexg pwexg sylancr syl2anc ssexg mpan9 syldan ) BAF
      ZCGZBBHDGZUAIZJIZJIZFZDKUDZCELZEMBNZOZBNZOZPZEQFZWAWIRWBWMFZCELZWNWAWIWQW
      AWHWPCEWHWAWPWGWAWPSZDKWEWDBNZOZPZWCKFZWGWRSZSZBWDUBWDMPWSWJPZXAXDSZWDHUC
      UEMHWCUFHUGUHWDMBUIXEWTWKPZXFWSWJUJXAXGXDXAXGRWEWKPZXDWEWTWKUKXHXBWGWAWPX
      HXBWGULWARWFWEBNZOZPZWPBWEUBXHXBWGWAXKWPSZXHXIWLPZXBWGWAXLSSSZWEWKBUIXMXJ
      WMPZXNXIWLUJXKXOXBWGWAWPXKXOXDXKXORWFWMPZXBXCWFXJWMUKXPXCSXBXPWGWPWAWFWMW
      BUMUNUOUPUQURUSTUTVAVBTVCUSVJVDVEVFVGVHCEWMVIVKWAWMQFZWNWOWAWLQFZXQWAWKQF
      ZBQFZXRWAMQFZXTXSVLBAVMZYAXTRWJQFXSMBQQVNWJQVOTVPYBWKBQQVNVQWLQVOTWNXQWOE
      WMQVRUQVSVT @.
  @}

  @{
    @d a f j x y n F @.  @d a f j n U @.  @d a f j x y n X @.  @d f j n A @.
    @( The inductive closure of ` X ` under ` F ` .  (Contributed by FL,
       14-Jan-2014.) @)
    indcls2 @p |- ( ( U e. A /\ X C_ U /\
        A. f e. F E. n e. NN f e. ( U ^m ( U ^m ( 1 ... n ) ) ) )
      -> ( X IndCls F ) = |^| { a | ( X C_ a /\
        A. f e. F A. j e. ( dom f i^i ~P ( _V X. a ) )
          ( f ` j ) e. a ) } ) @=
      ( vx wcel cv co cmap wral cvv cin wa wceq adantr wi vy wss c1 cfz cn wrex
      w3a clincl cfv cdm cxp cpw cab cint simp1 simp2 lemindclsbu 3adant2 simp3
      ssexg ancoms 3adant3 c0 wne simpl1 simpl2 wf wb ovex elmapg sylancl jctir
      wex fdm adantl selsubf3g syl eleq2d ffvelrn ex com12 oveq1i eleq2s syl6bi
      inidm pm2.43a ralrimiv ineq1 raleqdv imbi2d syl5ibr mpcom pm2.43b ralimdv
      rexlimivw sseq2 xpeq2 pweqd ineq2d eleq2 raleqbidv ralbidv anbi12d spcegv
      imp syl12anc abn0 sylibr intex sylib sseq1 simpr abbidv df-indcls syl3anc
      inteqd ovmpt2ga syl31anc ) BAJZGBUBZCKZBBUCEKZUDLZMLZMLJZEUEUFZCFNZUGXSXT
      FOJZYGGFUHLGHKZUBZDKZYAUIZYIJZDYAUJZOYIUKZULZPZNZCFNZQZHUMZUNZRZXSXTYGUOX
      SXTYGUPXSYGYHXTABCEFUQURXSXTYGUSXSXTYHUGZYGQZGOJZYHUUBOJZUUCUUDUUFYGXSXTU
      UFYHXTXSUUFGBAUTVAVBSUUDYHYGXSXTYHUSSUUEUUAVCVDZUUGUUEYTHVMZUUHUUEXSXTYLB
      JZDYNOBUKZULZPZNZCFNZUUIXSXTYHYGVEXSXTYHYGVFUUDYGUUOUUDYFUUNCFYFUUDUUNYEU
      UDUUNTZEUEYEUUDUUNUUDYEYDBYAVGZUUPUUDXSYDOJYEUUQVHXSXTYHUOZBYCMVIBYDYAAOV
      JVKYNYDRZUUQUUPYDBYAVNUUQUUPUUSUUDUUJDYDUULPZNZTUUQUUDUVAUUQUUDQZUUJDUUTY
      KUUTJZUVBUUJUVBUVCYKBBPZYCMLZJUVBUUJTZUVBUUTUVEYKUVBXSYCOJZQZUUTUVERUUDUV
      HUUQUUDXSUVGUURUCYBUDVIVLVOBBYCAOVPVQVRUVFYKYDUVEUVBYKYDJZUUJUUQUVIUUJTUU
      DUUQUVIUUJYDBYKYAVSVTSWAUVDBYCMBWEWBWCWDWFWGVTUUSUUNUVAUUDUUSUUJDUUMUUTYN
      YDUULWHWIWJWKWLWDWMWOWAWNXEXSXTUUOQZUUIYTUVJHBAYIBRZYJXTYSUUOYIBGWPUVKYRU
      UNCFUVKYMUUJDYQUUMUVKYPUULYNUVKYOUUKYIBOWQWRWSYIBYLWTXAXBXCXDXEXFYTHXGXHU
      UAXIXJIUAGFOOIKZYIUBZYRCUAKZNZQZHUMZUNUUBUHOUVLGRZUVNFRZQZUVQUUAUVTUVPYTH
      UVTUVMYJUVOYSUVRUVMYJVHUVSUVLGYIXKSUVTYRCUVNFUVRUVSXLWIXCXMXPIUACDHXNXQXO
      XR @.
  @}

  @{
    @d f n x y F @.  @d f n y A @.  @d f n x y U @.  @d f n x y X @.
    @( X is a part of the inductive closure of ` X ` under ` F ` .
       (Contributed by FL, 15-Jan-2014.) @)
    xindcls @p |- ( ( U e. A /\ X C_ U /\
        A. f e. F E. n e. NN f e. ( U ^m ( U ^m ( 1 ... n ) ) ) )
      -> X C_ ( X IndCls F ) ) @=
      ( vx vy wcel wss cv c1 cfz co cmap cn wrex wral w3a cfv cdm cvv wa clincl
      cxp cpw cin cab cint wal simpl ax-gen a1i ssintab sylibr indcls2 sseqtr4d
      wi ) BAIFBJCKZBBLDKMNONONIDPQCERSZFFGKZJZHKUSTVAIHUSUAUBVAUEUFUGRCERZUCZG
      UHUIZFEUDNUTVDVBURZGUJZFVEJVGUTVFGVBVCUKULUMVDGFUNUOABCHDEFGUPUQ @.
  @}

  @( The definition df-indclsbu is not sound, since it defines ` IndClsBu `
     in terms of itself.  I commented out the definition and all theorems
     using it. - NM 18-May-2014 @)
@(
  %{
    %d u x y z n a l m b o f j %.
    %( Definition of an inductive closure.  Gallier p. 19.  Bottom up
       definition. %)
    df-indclsbu %a |- IndClsBu = ( u e. _V |-> ( x e. ~P u ,
      y e. ~P { z | E. n e. NN z e. ( u ^m ( u ^m ( 1 ... n ) ) ) }
        |-> ( a e. NN0 |->
           ( ( ( l e. ~P u , m e. ~P u |-> ( l u. m ) ) seq0 ( b e. NN0 |->
         if ( b = 0 , x ,
            { o | E. f e. y E. j e. ( dom f i^i
              ( _V X. ( ( x IndClsBu y ) ` ( b - 1 ) ) ) )
              o = ( f ` j ) } ) ) ) ` a ) ) ) ) %.
  %}

  %{
    %d a b f j l m n o u x y z %.  %d a b f j o x y z F %.  %d a f j o N %.
    %d a f l m n u x y z U %.  %d a b f j o x y X %.  %d f n A %.
    %( Definition of an inductive closure.  Gallier p. 19.  ( Contributed by
       FL, 14-Jan-2014.) %)
    indclsbu %p |- ( ( ( U e. A /\ X C_ U ) /\
      A. f e. F E. n e. NN f e. ( U ^m ( U ^m ( 1 ... n ) ) ) /\ N e. NN0 ) ->
        ( ( X ( IndClsBu ` U ) F ) ` N ) = ( ( ( l e. ~P U , m e. ~P U |->
      ( l u. m ) ) seq0 ( b e. NN0 |-> if ( b = 0 , X ,
        { o | E. f e. F E. j e. ( dom f i^i
          ( _V X. ( ( X IndClsBu F ) ` ( b - 1 ) ) ) )
         o = ( f ` j ) } ) ) ) ` N ) ) %=
      ( vz wcel cv co cn0 cfv wceq cvv vx vy va vu wss wa c1 cfz cmap wrex wral
      cn w3a clinclb cpw cab cun cmpt2 cc0 cdm cmin cxp cin cif cmpt cseq0 elex
      3ad2ant1 pwexg nnex a1i abid2 ovex eqeltri rgen jctir abrexex2g mpt2exga
      adantr 3syl syl2anc pweq oveq1 oveq12d eleq2d rexbidv pweqd mpt2eq123dv
      id abbidv eqidd oveq1d fveq1d mpteq2dva df-indclsbu fvmptg oveqd ancoms
      ssexg elpwg biimprd adantld mpcom eleq1d rexbidva cbvralv biimpi 3ad2ant2
      weq simpl ssabral sylibr wb lemindclsbu adantlr 3adant3 syl mpbird mptexg
      nn0ex ax-mp biidd simpll wel simplr oveq12 xpeq2d ineq2d anbi1d rexbidv2
      anbi12d ifbieq12d oveq2d eqid ovmpt2ga syl3anc simp3 fvex fveq2 sylancl
      3eqtrd ) BANZJBUEZUFZCOZBBUGFOZUHPZUIPZUIPZNZFULUJZCHUKZIQNZUMZIJHBUNRZPZ
      RIJHUAUBBUOZMOZUUINZFULUJZMUPZUOZUCQUCOZLEUUQUUQLOEOUQZURZKQKOZUSSZUAOZGO
      DOZUUERSZDUUEUTZTUVFUGVAPZUVHUBOZUNPZRZVBZVCZUJZCUVMUJZGUPZVDZVEZVFPZRZVE
      ZURZPZRIUCQUVCUVEKQUVGJUVJDUVKTUVLJHUNPZRZVBZVCZUJZCHUJZGUPZVDZVEZVFPZRZV
      EZRZIUWQRZUUNIUUPUWGUUNUUOUWFJHUUNBTNZUWFTNZUUOUWFSUUDUULUXBUUMUUBUXBUUCB
      AVGVSVHUUNUUQTNZUVBTNZUXCUUDUULUXDUUMUUBUXDUUCBAVIVSVHUUNULTNZUUSMUPZTNZF
      ULUKZUFUVATNUXEUUNUXFUXIUXFUUNVJVKUXHFULUXHUUFULNZUXGUUITMUUIVLBUUHUIVMVN
      VKVOVPUUSFMULTTVQUVATVIVTUAUBUUQUVBUWETTVRWAUDBUAUBUDOZUOZUURUXKUXKUUGUIP
      ZUIPZNZFULUJZMUPZUOZUCQUVCLEUXLUXLUVDURZUWBVFPZRZVEZURUWFTTUNUXKBSZUAUBUX
      LUXRUYBUUQUVBUWEUXKBWBZUYCUXQUVAUYCUXPUUTMUYCUXOUUSFULUYCUXNUUIUURUYCUXKB
      UXMUUHUIUYCWIUXKBUUGUIWCWDWEWFWJWGUYCUCQUYAUWDUYCUYAUWDSUVCQNZUYCUVCUXTUW
      CUYCUXSUVEUWBVFUYCLEUXLUXLUVDUUQUUQUVDUYDUYDUYCUVDWKWHWLWMVSWNWHUAUBMUDCD
      EFGUCKLWOWPWAWQWMUUNIUWGUWSUUNJUUQNZHUVBNZUWSTNZUWGUWSSUUDUULUYFUUMJTNZUU
      DUYFUUCUUBUYIJBAWSWRUYIUUCUYFUUBUYIUYFUUCJBTWTXAXBXCVHUUNUYGHUVAUEZUUNUUT
      MHUKZUYJUULUUDUYKUUMUULUYKUUKUUTCMHCMXIZUUJUUSFULUYLUXJUFUUEUURUUIUYLUXJX
      JXDXEXFXGXHUUTMHXKXLUUNHTNZUYGUYJXMUUDUULUYMUUMUUBUULUYMUUCABCFHXNXOXPHUV
      ATWTXQXRUYHUUNQTNUYHXTUCQUWRTXSYAVKUAUBJHUUQUVBUWEUWSUWFTUVHJSZUVMHSZUFZU
      CQUWDUWRUYPUWDUWRSUYEUYPUVCUWCUWQUYPUWBUWPUVEVFUYPKQUWAUWOUYPUVFQNZUFZUVG
      UVGUVHUVTJUWNUYRUVGYBUYNUYOUYQYCUYRUVSUWMGUYRUVRUWLCUVMHUYRCUBYDUUEHNUVRU
      WLUYRUVMHUUEUYNUYOUYQYEWEUYRUVJUVJDUVQUWKUYRUVIUVQNUVIUWKNUVJUYRUVQUWKUVI
      UYRUVPUWJUVKUYRUVOUWITUYRUVLUVNUWHUYPUVNUWHSUYQUVHJUVMHUNYFVSWMYGYHWEYIYJ
      YKYJWJYLWNYMWMVSWNUWFYNYOYPWMUUNUUMUXATNUWTUXASUUDUULUUMYQIUWQYRUCIUWRUXA
      QTUWSUVCIUWQYSUWSYNWPYTUUA %.
      %( [14-Jan-2014] %)
  %}

  %{
    %d b f j l m n o %.  %d b f j o F %.  %d b f j o X %.  %d f n A %.
    %d f l m n U %.
    %( Definition of an inductive closure at ` 0 ` .  ( Contributed by FL,
       14-Jan-2014.) %)
    indclsbu0 %p |- ( ( U e. A /\ X C_ U /\
      A. f e. F E. n e. NN f e. ( U ^m ( U ^m ( 1 ... n ) ) ) ) ->
        ( ( X ( IndClsBu ` U ) F ) ` 0 ) = X ) %=
      ( vl vm vb vo vj wcel cv co wrex cc0 cfv cn0 wceq cvv wss c1 cmap cn wral
      cfz w3a clinclb cpw cun cmpt2 cdm cmin cxp cin cab cif cseq0 3simpa simp3
      cmpt wa a1i indclsbu syl3anc pwexg mpt2exga syl2anc 3ad2ant1 nn0ex mptexg
      0nn0 syl seq00g ssexg ancoms 3adant3 lemindclsbu 3adant2 dmexg ab2rexexg2
      inex1g rgen sylancl ifcl oveq1 adantr fveq2d xpeq2d ineq2d eleq2d anbi1d
      eqeq1 rexbidv2 rexbidva abbidv ifbieq2d eqid fvmptg sylancr iftrue syl6eq
      ax-mp 3eqtrd ) BALZFBUAZCMZBBUBDMUFNUCNUCNLDUDOCEUEZUGZPFEBUHQNQZPGHBUIZX
      KGMHMUJZUKZIRIMZPSZFJMKMZXGQZSZKXGULZTXNUBUMNZFEUHNZQZUNZUOZOZCEOZJUPZUQZ
      VAZURNQZPYIQZFXIXEXFVBXHPRLZXJYJSXEXFXHUSXEXFXHUTYLXIVLVCABCKHDJEPFIGVDVE
      XIXMTLZYITLZYJYKSXEXFYMXHXEXKTLZYOYMBAVFZYPGHXKXKXLTTVGVHVIXIRTLZYNYQXIVJ
      VCIRYHTVKVMTTXMYIVNVHXIYKPPSZFXRKXSTPUBUMNZYAQZUNZUOZOZCEOZJUPZUQZFXIYLUU
      FTLZYKUUFSVLXIFTLZUUETLZUUGXEXFUUHXHXFXEUUHFBAVOVPVQXIETLZUUBTLZCEUEUUIXE
      XHUUJXFABCDEVRVSUUKCEXGELZXSTLUUKXGEVTXSUUATWBVMWCCKJEUUBXQTTWAWDYRFUUETW
      EVHIPYHUUFRTYIXOXOYRYGUUEFXNPPWMXOYFUUDJXOYEUUCCEXOUULVBZXRXRKYDUUBUUMXPY
      DLXPUUBLXRUUMYDUUBXPUUMYCUUAXSUUMYBYTTUUMXTYSYAXOXTYSSUULXNPUBUMWFWGWHWIW
      JWKWLWNWOWPWQYIWRWSWTYRUUFFSPWRYRFUUEXAXCXBXD %.
      %( [14-Jan-2014] %)
  %}

  %{
    %d b f g h j l m o U %.  %d b f j l m n o U %.  %d b f j n o A %.
    %d b f g h j o F %.  %d b f g h j o N %.  %d b f g h j o X %.
    %d g h l m z %.  %d n o F %.  %d n o N %.  %d n o X %.
    %( Definition of an inductive closure at a successor.  ( Contributed by FL,
       14-Jan-2014.) %)
    indclsbusuc %p |- ( ( ( U e. A /\ X C_ U ) /\
      A. f e. F E. n e. NN f e. ( U ^m ( U ^m ( 1 ... n ) ) ) /\ N e. NN0 ) ->
        ( ( X ( IndClsBu ` U ) F ) ` ( N + 1 ) ) =
        ( ( ( X ( IndClsBu ` U ) F ) ` N ) u.
        { o | E. f e. F E. j e. ( dom f i^i
          ( _V X. ( ( X IndClsBu F ) ` N ) ) ) o = ( f ` j ) } ) ) %=
      ( vl vm wcel wa c1 co cn0 wceq cvv a1i wi vb vg vh vz wss cv cmap cn wrex
      cfz wral w3a caddc clinclb cfv cpw cun cmpt2 cc0 cdm cmin cxp cin cab cif
      cmpt cseq0 peano2nn0 indclsbu syl3an3 pwexg adantr 3ad2ant1 syl2anc nn0ex
      mpt2exga mptexg ax-mp simp3 seq0p1g imp syl21anc wf ssexg biimprd adantld
      elpwg syl ancoms pm2.43i ad2antrr wn r19.29 ovex elmapg wfn sylbi syl6bi
      elin ex mpan2 3adant3 syl5ibr 3expd com12 rexlimiv wb vex rgen ab2rexexg2
      inex1 sylancl mpbird eqid sylib elpw sylibr 3ad2ant3 fveq2d xpeq2d ineq2d
      eleq2d anbi1d rexbidv2 abbidv clt wbr 1re 0lt1 syl22anc 3imp ax-17 uneq12
     cr fvex eqtrd syl3anc cc ax-1cn 3eqtrd df-f wfun fnfun fvelrn ssel syl5com
      crn com23 com3l impcom eleq1 exp3a abssdv lemindclsbu adantlr dmex ifclda
      com3r ralrimiva fmpt unss biimpi syl2anb unex rgen2a fmpt2 mpbii syl23anc
      seq0clg ifcl eqeq1 oveq1 rexbidva ifbieq2d fvmptg wne nn0re peano2re cle
      nn0ge0 addgegt0 gt0ne0 df-ne wal simpl1 ffvelrn 3exp1 com15 com24 alrimiv
      fdm biimpa abss adantl iffalse eleq1d mpancom eqeltrd pm3.2i unexg oveqd
     cbvmpt2 ovmpt2ga eqcomd readdcl addsubass subidi oveq2d rexbidv uneq12d
      nn0cn addid1 ) BALZIBUEZMZCUFZBBNEUFZUJOZUGOZUGOLZEUHUIZCGUKZHPLZULZHNUMO
      ZIGBUNUOOZUOZUYEJKBUPZUYHJUFZKUFZUQZURZUAPUAUFZUSQZIFUFZDUFZUXPUOZQZDUXPU
      TZRUYMNVAOZIGUNOZUOZVBZVCZUIZCGUIZFVDZVEZVFZVGOZUOZHVUJUOZUYEVUIUOZUYLOZH
      UYFUOZUYRDUYSRHVUAUOZVBZVCZUIZCGUIZFVDZUQZUYCUXOUYBUYEPLZUYGVUKQHVHZABCDK
      EFGUYEIUAJVIVJUYDUYLRLZVUIRLZUYCVUKVUNQZUYDUYHRLZVVHVVEUXOUYBVVHUYCUXMVVH
      UXNBAVKVLVMZVVIJKUYHUYHUYKRRVPVNZVVFUYDPRLVVFVOUAPVUHRVQVRSZUXOUYBUYCVSZV
      VEVVFMZUYCVVGRRUYLVUIHVTWAWBUYDVUNVULVUMUQZVVBUYDVULUYHLZVUMUYHLZVVNRLZVU
      NVVNQUYDVVEVVFUYCPUYHVUIWCZUYHUYHVBUYHUYLWCZVVOVVJVVKVVLUYDVUHUYHLZUAPUKV
      VRUYDVVTUAPUYDUYMPLZMZUYNIVUGUYHUYDIUYHLZVWAUYNUXOUYBVWCUYCUXOVWCUXNUXMUX
      OVWCTZUXNUXMMIRLZVWDIBAWDZVWEUXNVWCUXMVWEVWCUXNIBRWGWEWFWHWIWJVMWKVWBUYNW
      LZMZVUGUYHLZVUGBUEZVWHVUFFBUYDVUFUYOBLZTZVWAVWGUXOUYBVWLUYCUXOUYBVWLUXMUY
      BVWLTUXNUYBVUFUXMVWKUYBVUFUXMVWKTZUYBVUFMUYAVUEMZCGUIVWMUYAVUECGWMVWNVWMC
      GVWNUXPGLZVWMUYAVUEVWOVWMTZUXTVUEVWPTZEUHUXTVWQTUXQUHLZVUEUXTVWPUYRUXTVWP
      TZDVUDUYPVUDLZUYPUYSLZUYPVUCLZMUYRVWSTZUYPUYSVUCWSVXAVXCVXBUYRVXAVWSUYRVX
      AUXTVWOVWMUYRVXAUXTVWOULZUXMVWKVXDUXMMVWKUYRUYQBLZVXDUXMVXEVXAUXTUXMVXETZ
      VWOUXTVXAVXFUXMUXTVXAVXEUXMUXSRLZUXTVXAVXETZTBUXRUGWNZUXMVXGMZUXTUXSBUXPW
      CZVXHBUXSUXPARWOZVXKUXPUXSWPZUXPUUGZBUEZMVXHUXSBUXPUUAVXMVXOVXHVXMUXPUUBZ
      VXOVXHTUXSUXPUUCVXPVXAVXOVXEVXPVXAVXOVXETVXPVXAMUYQVXNLVXOVXEUYPUXPUUDVXN
      BUYQUUEUUFWTUUHWHWAWQWRXAUUIUUJXBWAUYOUYQBUUKZXCUULXDXEVLWQXFXESXFWAXEXFW
      HWTUURVLWAXBWKUUMVWHVUGRLZVWIVWJXGVWHGRLZVUDRLZCGUKVXRUYDVXSVWAVWGUXOUYBV
      XSUYCUXMUYBVXSUXNABCEGUUNUUOXBZWKVXTCGVXTVWOUYSVUCUXPCXHUUPZXKSXICDFGVUDU
      YQRRXJXLVUGBRWGWHXMUUQUUSUAPUYHVUHVUIVUIXNZUUTXOUYDUYKUYHLZKUYHUKJUYHUKZV
      VSVYDJKUYHUYIUYHLZUYJUYHLZMUYKBUEZVYDVYFUYIBUEZUYJBUEZVYHVYGUYIBJXHZXPUYJ
      BKXHZXPVYIVYJMVYHUYIUYJBUVAUVBUVCUYKBUYIUYJVYKVYLUVDXPXQUVEVYEVVSXGUYDJKU
      YHUYHUYHUYKUYLUYLXNUVFSUVGVVMUYCVVRVVSULVVORRUYHUYLVUIHUVIWAUVHUYDVUMUYEU
      SQZIUYRDUYSRUYENVAOZVUAUOZVBZVCZUIZCGUIZFVDZVEZUYHUYDVVCWUARLZVUMWUAQUYCU
      XOVVCUYBVVDXRUYDVWEVYTRLZWUBUXOUYBVWEUYCUXNUXMVWEVWFWIVMUYDVXSVYQRLZCGUKW
      UCVYAWUDCGWUDVWOUYSVYPVYBXKSXICDFGVYQUYQRRXJXLZVYMIVYTRUVJVNUAUYEVUHWUAPR
      VUIUYMUYEQZUYNVYMVUGVYTIUYMUYEUSUVKWUFVUFVYSFWUFVUEVYRCGWUFVUEVYRXGVWOWUF
      UYRUYRDVUDVYQWUFVWTUYPVYQLZUYRWUFVUDVYQUYPWUFVUCVYPUYSWUFVUBVYORWUFUYTVYN
      VUAUYMUYENVAUVLXSXTYAYBYCYDVLUVMYEUVNVYCUVOVNZVYMWLZUYDWUAUYHLZUYDUYEUSUV
      PZWUIUYDUYEYNLZUSUYEYFYGZWUKUYDHYNLZWULUYCUXOWUNUYBHUVQZXRZHUVRWHUYDWUNNY
      NLZUSHUVSYGZUSNYFYGZWUMWUPWUQUYDYHSUYCUXOWURUYBHUVTZXRWUSUYDYISHNUWAZYJUY
      EUWBZVNUYEUSUWCZXOWUIUYDMWUJVYTUYHLZUYDWVDWUIUYDWVDVYTBUEZUYDVYSVWKTZFUWD
      WVEUYDWVFFUXOUYBUYCWVFUYBUXOUYCWVFTUYBVYSUYCUXOVWKUYBVYSUYCUXOVWKTTZUYBVY
      SMUYAVYRMZCGUIWVGUYAVYRCGWMWVHWVGCGWVHVWOWVGUYAVYRVWOWVGTZUXTVYRWVITZEUHU
      XTWVJTVWRVYRUXTWVIUYRUXTWVITZDVYQUYRWUGWVKUYRWUGUXTVWOWVGUYRWUGUXTVWOULZU
      YCUXOVWKWVLUYCUXOULVWKUYRVXEWVLUYCUXOVXEWUGUXTVWOUYCUXOVXETTZWUGVXAUYPVYP
      LZMUXTVWOWVMTTZUYPUYSVYPWSVXAWVOWVNUXOUXTVWOUYCVXAVXEUXMUXTVWOUYCVXHTTZTZ
      UXNUXMVXGWVQVXIVXJUXTVXKWVPVXLVXKVWOUYCVXAVXEVXKVWOUYCULZVXAMVXKUYPUXSLZV
      XEVXKVWOUYCVXAUWEWVRVXAWVSWVRUYSUXSUYPVXKVWOUYSUXSQUYCUXSBUXPUWKVMYBUWLUX
      SBUYPUXPUWFVNUWGWRXAVLUWHVLWQYKYKVXQXCXDXDXEXFXESXFWAXEXFWHWTUWIXEYKUWJVY
      SFBUWMXQUYDWUCWVDWVEXGWUEVYTBRWGWHXMUWNWUIWUJWVDXGUYDWUIWUAVYTUYHVYMIVYTU
      WOZUWPVLXMUWQUWRUYDVULRLZVUMRLZMZVVQWWCUYDWWAWWBHVUJYOUYEVUIYOUWSSVULVUMR
      RUWTWHVVOVVPVVQULZVUNVULVUMUBUCUYHUYHUBUFZUCUFZUQZURZOVVNWWDUYLWWHVULVUMU
      YLWWHQWWDJKUBUCUDUYHUYHUYKWWGUDUFZUYKLZUBYLWWJUCYLWWIWWGLZJYLWWKKYLUYIWWE
      UYJWWFYMUXBSUXAUBUCVULVUMUYHUYHWWGVVNWWHRWWEVULWWFVUMYMWWHXNUXCYPYQUYDVUL
      VUOVUMVVAUYDVUOVULABCDKEFGHIUAJVIUXDUYDVUMWUAVYTVVAWUHUYDWUIWUAVYTQUYDWUK
      WUIUYCUXOWUKUYBUYCWULWUMWUKUYCWUNWUQWULWUOYHHNUXEXLUYCWUNWUQWURWUSWUMWUOW
      UQUYCYHSWUTWUSUYCYISWVAYJWVBVNXRWVCXOWVTWHUYCUXOVYTVVAQUYBUYCVYSVUTFUYCVY
      RVUSCGUYCUYRUYRDVYQVURUYCWUGUYPVURLUYRUYCVYQVURUYPUYCVYPVUQUYSUYCVYOVUPRU
      YCVYNHVUAUYCVYNHNNVAOZUMOZHUSUMOZHUYCHYRLZNYRLZWWPVYNWWMQHUXKZWWPUYCYSSZW
      WRHNNUXFYQUYCWWLUSHUMWWLUSQUYCNYSUXGSUXHUYCWWOWWNHQWWQHUXLWHYTXSXTYAYBYCY
      DUXIYEXRYTUXJYPYT %.
      %( [14-Jan-2014] %)
  %}
@)

  @c Grammar @.

  @( Extend class notation with the class of all grammars. @)
  cgrm @a class Grammar @.

  @{
    @d x n t p s l r a @.
    @( A grammar is a structure composed of a set of non-terminal symbols
       ` n ` , of terminal symbols ` t ` , a set of productions ` p ` and a
       distinguished element of ` n ` , the start symbol ` s ` .
       Experimental.  (Contributed by FL, 15-Jul-2012.) @)
    df-grm @a |- Grammar = { x | E. n E. t E. p E. s (
         ( x = <. <. n , t >. , <. p , s >. >. /\
           n e. Fin /\
           t e. Fin ) /\
         ( ( n i^i t ) = (/) /\
             p = { <. l , r >. | ( l e. ( Kleene ` ( n u. t ) ) /\ r e. (
        Kleene ` ( n u. t ) ) /\ E. a e. NN ( l ` a ) e. n ) } /\
             s e. n ) ) } @.
  @}

  @c sym @.

  @( Extend class notation with a function returning the symbols of a
     grammar. @)
  csym @a class sym @.

  @( The symbols of a grammar ` g ` .  Experimental.  (Contributed by FL,
     15-Jul-2012.) @)
  df-sym @a |- sym = ( g e. Grammar |-> ( ( ( 1st o. 1st ) ` g ) u. (
    ( 2nd o. 1st ) ` g ) ) ) @.

  @c prdct @.

  @( Extend class notation with a function returning the productions of a
     grammar. @)
  cgprdct @a class prdct @.

  @( The productions of a grammar.  (Contributed by FL, 15-Jul-2012.) @)
  df-prodct @a |- prdct = ( 1st o. 2nd ) @.

  @c conc @.

  @( Extend class notation with an operation concatenating two sequences of
     symbols. @)
  cconc @a class conc @.

  @{
    @d x y a b @.
    @( Concatenation of two words.  Experimental.  (Contributed by FL,
       14-Jan-2014.) @)
    df-conc @a |- conc = ( x e. _V , y e. _V |->
      if ( x = (/) , y , if ( y = (/) , x ,
      ( x u. ( a e. ( ( ( # ` x ) + 1 ) ... ( ( # ` x )
        + ( # ` y ) ) ) |-> ( y ` ( a - ( # ` x ) ) ) ) ) ) ) ) @.
  @}

  @{
    @d x y a A @.
    @( Concatenation with the empty set.  (Contributed by FL, 14-Jan-2014.) @)
    isconc1 @p |- ( A e. B -> ( (/) conc A ) = A ) @=
      ( va vx vy wcel c0 co wceq chash cfv c1 caddc cfz cmin cmpt cun cif cvv
      cv cconc 0ex a1i elex iftrue ax-mp syl5eqel eqeq1 id fveq2 oveq1d oveq12d
      eqid oveq2d fveq2d mpteq12dv uneq12d ifeq12d fveq1 uneq2d df-conc ovmpt2g
      ifbieq2d syl3anc syl6eq ) ABFZGAUAHZGGIZAAGIZGGCGJKZLMHZVJAJKZMHZNHZCTZVJ
      OHZAKZPZQZRZRZAVFGSFZASFWASFVGWAIWBVFUBUCABUDZVFWAASVHWAAIGUMVHAVTUEUFZWC
      UGDEGASSDTZGIZETZWGGIZWEWECWEJKZLMHZWIWGJKZMHZNHZVOWIOHZWGKZPZQZRZRWAUAVH
      WGWHGGCVKVJWKMHZNHZVPWGKZPZQZRZRSWFWFVHWRXDWGWEGGUHWFWHWEGWQXCWFUIZWFWEGW
      PXBXEWFCWMWOWTXAWFWJVKWLWSNWFWIVJLMWEGJUJZUKWFWIVJWKMXFUKULWFWNVPWGWFWIVJ
      VOOXFUNUOUPUQURVCWGAIZVHWGAXDVTXGUIXGWHVIXCVSGWGAGUHXGXBVRGXGCWTXAVNVQXGW
      SVMVKNXGWKVLVJMWGAJUJUNUNVPWGAUSUPUTVCURDECVAVBVDWDVE @.
  @}

  @{
    @d x y A a @.
    @( Concatenation with the empty set.  (Contributed by FL, 14-Jan-2014.) @)
    isconc2 @p |- ( A e. B -> ( A conc (/) ) = A ) @=
      ( va vx vy wcel c0 co wceq chash cfv c1 caddc cfz cmin cmpt cun cif cvv
      cv cconc elex 0ex wa wn adantr ovex mptexg mp1i unexg syldan ifclda eqeq1
      a1i fveq2 oveq1d oveq12d oveq2d fveq2d mpteq12dv uneq12d ifeq12d ifbieq2d
      id fveq1 uneq2d df-conc ovmpt2g syl3anc iftrue eqcom biimpi eqtrd iffalse
      eqid ax-mp syl6eq pm2.61i ) ABFZAGUAHZAGIZGGGIZAACAJKZLMHZWCGJKZMHZNHZCTZ
      WCOHZGKZPZQZRZRZAVSASFZGSFZWNSFVTWNIABUBZWPVSUCUNVSWAGWMSWPVSWAUDUCUNVSWM
      SFWAUEZVSWBAWLSVSWOWBWQUFVSWBUEZWKSFZWLSFWGSFWTVSWSUDWDWFNUGCWGWJSUHUIAWK
      BSUJUKULUFULDEAGSSDTZGIZETZXCGIZXAXACXAJKZLMHZXEXCJKZMHZNHZWHXEOHZXCKZPZQ
      ZRZRWNUAWAXCXDAACWDWCXGMHZNHZWIXCKZPZQZRZRSXAAIZXBWAXNXTXCXAAGUMYAXDXAAXM
      XSYAVDZYAXAAXLXRYBYACXIXKXPXQYAXFWDXHXONYAXEWCLMXAAJUOZUPYAXEWCXGMYCUPUQY
      AXJWIXCYAXEWCWHOYCURUSUTVAVBVCXDWAXCGXTWMXDVDXDXDWBXSWLAXCGGUMXDXRWKAXDCX
      PXQWGWJXDXOWFWDNXDXGWEWCMXCGJUOURURWIXCGVEUTVFVCVBDECVGVHVIWAWNAIWAWNGAWA
      GWMVJWAGAIAGVKVLVMWRWNWMAWAGWMVNWBWMAIGVOWBAWLVJVPVQVRVQ @.
  @}

  @{
    @d x y A a @.  @d x y B a @.
    @( Definition of a concatenation.  (Contributed by FL, 14-Jan-2014.) @)
    isconc3 @p |- ( ( A e. C /\ B e. C /\ ( A =/= (/) /\ B =/= (/) ) )
    -> ( A conc B ) =
     ( A u. ( a e. ( ( ( # ` A ) + 1 ) ... ( ( # ` A )
        + ( # ` B ) ) ) |-> ( B ` ( a - ( # ` A ) ) ) ) ) ) @=
      ( vx vy wcel c0 co wceq chash cfv c1 caddc cfz cv cmin cmpt cif cvv cconc
      wne wa w3a cun elex 3ad2ant1 3ad2ant2 adantr wn ifnefalse adantl 3ad2ant3
      ovex mptexg mp1i unexb sylib eqeltrd ifclda eqeq1 id fveq2 oveq1d oveq12d
      jca oveq2d fveq2d mpteq12dv uneq12d ifeq12d ifbieq2d fveq1 uneq2d df-conc
      ovmpt2g syl3anc 3eqtrd ) ACGZBCGZAHUBZBHUBZUCZUDZABUAIZAHJZBBHJZAADAKLZMN
      IZWHBKLZNIZOIZDPZWHQIZBLZRZUEZSZSZWRWQWDATGZBTGZWSTGWEWSJVSVTWTWCACUFUGZV
      TVSXAWCBCUFUHZWDWFBWRTWDXAWFXCUIWDWRTGWFUJWDWRWQTWCVSWRWQJZVTWBXDWABHAWQU
      KULUMZWDWTWPTGZUCWQTGWDWTXFXBWLTGXFWDWIWKOUNDWLWOTUOUPVFAWPUQURUSUIUTEFAB
      TTEPZHJZFPZXIHJZXGXGDXGKLZMNIZXKXIKLZNIZOIZWMXKQIZXILZRZUEZSZSWSUAWFXIXJA
      ADWIWHXMNIZOIZWNXILZRZUEZSZSTXGAJZXHWFXTYFXIXGAHVAYGXJXGAXSYEYGVBZYGXGAXR
      YDYHYGDXOXQYBYCYGXLWIXNYAOYGXKWHMNXGAKVCZVDYGXKWHXMNYIVDVEYGXPWNXIYGXKWHW
      MQYIVGVHVIVJVKVLXIBJZWFXIBYFWRYJVBYJXJWGYEWQAXIBHVAYJYDWPAYJDYBYCWLWOYJYA
      WKWIOYJXMWJWHNXIBKVCVGVGWNXIBVMVIVNVLVKEFDVOVPVQWCVSWSWRJZVTWAYKWBAHBWRUK
      UIUMXEVR @.
  @}

  @{
    @d n A @.  @d x A @.
    @( The empty set is an element of the kleene star of ` A ` .  (Contributed
       by FL, 2-Feb-2014.) @)
    empklst @p |- ( A e. B -> (/) e. ( Kleene ` A ) ) @=
      ( vn vx wcel c0 cn0 c1 cv cfz co cmap ciun cc0 eleq2d c1o cvv ax-mp oveq2
      wceq ckln cfv wrex 0nn0 wi fz10 oveq1 0lt1o map0e eleqtrri vtoclg syl5ibr
      vex oveq2d rspcev sylancr eliun sylibr isKleene eleqtrrd ) ABEZFCGAHCIZJK
      ZLKZMZAUAUBVAFVDEZCGUCZFVEEVANGEFAHNJKZLKZEZVGUDVHFTZVAVJUEUFVAVJVKFAFLKZ
      EZFDIZFLKZEVMDABVNATVOVLFVNAFLUGOFPVOUHVNQEVOPTDUMVNQUIRUJUKVKVIVLFVHFALS
      OULRVFVJCNGVBNTZVDVIFVPVCVHALVBNHJSUNOUOUPCFGVDUQURCABUSUT @.
  @}

  @{
    @d a b c d A @.  @d a b c d B @.  @d a b c d C @.
    @( Closure of concatenation.  (Contributed by FL, 2-Feb-2014.) @)
    clscnc @p |- ( ( A e. ( Kleene ` C ) /\ B e. ( Kleene ` C ) )
       -> ( A conc B ) e. ( Kleene ` C ) ) @=
      ( va vb wcel wa co wi c0 wceq c1 caddc cfz cvv cn0 cmap adantr wb imbi2d
      vc ckln cfv cconc isconc1 eleq1 biimpd eqcoms mpcom oveq1 syl5ibr adantld
      vd eleq1d wne isconc2 oveq2 adantrd a1i w3a chash cv cmin cmpt cun elfvex
      isconc3 ciun isKleene wrex weq oveq2d cbviunv eleq2i eliun bitri nn0addcl
      ancoms ad2ant2r 3adant3 wf ovex elmapg mpan2 wfn ffn fseq1hash simpl2r cz
      cin elfzel1 adantl nn0z zaddcl syl2anr ad2antrr 3ad2ant2 elfzelz anim12ci
      fzsubel syl21anc ex com13 pm2.43i impcom simpl1r ad2antrl cc ax-1cn nn0cn
      pncan2 syl oveq12d eleq2d syl6 clt wbr cr nn0re cle syl2anc nn0ge0 bicomd
      cc0 sylancr syl6bi pm2.43a mpbird 3exp1 mpteq12dv uneq2d exp3a exp3acom3r
      imp com3l 3imp1 rexlimiva sylbi eleq2 imbi12d biimpac ffvelrn fmptd ltp1d
      jca eqid fzdisj fun2 simp2l necon3bid cn simpr2l 0re ltlen mpand elnnnn0b
      0fz1 sylanbrc nnge1 3ad2ant1 addge01 elfz1 mpbir3and fzsplit feq2d simpl3
      1z sylancl fveq2d eqidd com5l com23 imp3a com25 com4l rspcev com12 sylibr
      syl5ibrcom 3imp eqeltrd 3expia pm2.61dne pm2.61ine ) ACUBUCZFZBUWEFZGZABU
      DHZUWEFZIZAJAJKZUWGUWJUWFUWGUWJUWLJBUDHZUWEFZUWMBKUWGUWNBUWEUEUWGUWNIBUWM
      BUWMKUWGUWNBUWMUWEUFUGUHUIUWLUWIUWMUWEAJBUDUJUNUKULAJUOZUWKBJBJKZUWKIUWOU
      WPUWFUWJUWGUWFUWJUWPAJUDHZUWEFZUWQAKUWFUWRAUWEUPUWFUWRIAUWQAUWQKUWFUWRAUW
      QUWEUFUGUHUIUWPUWIUWQUWEBJAUDUQUNUKURUSUWHUWOBJUOZUWJUWFUWGUWOUWSGZUWJUWF
      UWGUWTUTUWIADAVAUCZLMHZUXABVAUCZMHZNHZDVBZUXAVCHZBUCZVDZVEZUWEABUWEDVGUWF
      UWGUWTUXJUWEFZCOFZUWFUWGUWTUXKIZIZACUBVFUWEDPCLUXFNHZQHZVHZKZUXLUWFUXNIZD
      COVIUXLUXSUXRAUXQFZBUXQFZUWTUXJUXQFZIZIZIUXLUXTUYAUWTUYBUXLUXTUYAUTUWTGUX
      JCLEVBZNHZQHZFZEPVJZUYBUXLUXTUYAUWTUYIUXTUXLUYAUWTUYIIZIZUXTACLUAVBZNHZQH
      ZFZUAPVJZUXLUYKIZUXTAUAPUYNVHZFUYPUXQUYRADUAPUXPUYNDUAVKUXOUYMCQUXFUYLLNU
      QVLVMVNUAAPUYNVOVPUYOUYQUAPUYAUYLPFZUYOGZUXLUYJUYABCLUMVBZNHZQHZFZUMPVJZU
      YTUXLUYJIIZUYABUMPVUCVHZFVUEUXQVUGBDUMPUXPVUCDUMVKUXOVUBCQUXFVUALNUQVLVMV
      NUMBPVUCVOVPVUDVUFUMPVUAPFZVUDGZUYTUXLUWTUYIVUIUYTUXLUTZUWTGUYLVUAMHZPFZU
      XJCLVUKNHZQHZFZUYIVUJVULUWTVUIUYTVULUXLVUHUYSVULVUDUYOUYSVUHVULUYLVUAVQVR
      VSVTRVUIUYTUXLUWTVUOVUDVUHUYTUXLUWTVUOIZIZIUXLVUDVUHUYTVUPVUDUXLVUHUYTVUP
      IIZUXLVUDVUBCBWAZUXLVURIZUXLVUBOFVUDVUSSLVUANWBCVUBBOOWCWDBVUBWEZVUSVUTVU
      BCBWFUXLVVAVUSVURUXLVVAVUSGZVURIUXLUYTVVBVUHUXLVUPUXLUYSUYOVVBVUHVUQIZIZU
      XLUYOUYSVVDUXLUYOUYMCAWAZUYSVVDIZUXLUYMOFUYOVVESLUYLNWBCUYMAOOWCWDAUYMWEZ
      VVEVVFUYMCAWFZUYSVVGVVEVVDVVGUYSVVEVVDIZUYSVVGUYSVVIIZUYSVVGGZUXAUYLKZVVJ
      AUYLWGVVLUYSVVEVVDVVBVVLUYSVVEGZVVCVVAVUSVVLVVMVVCIIVUHVVAVUSVVLVVMVUQVVA
      VUHVUSVVLVVMVUQIZIZIZVUHVVAVUHVVPIZVUHVVAGUXCVUAKZVVQBVUAWGVVRVUHVUSVVOVU
      HVUSGZVVOVVRVVLVVMUXLUWTADUXBUXAVUAMHZNHZUXHVDZVEZVUNFZIZIZIZIVVSVWGVVLVV
      MUXLUWTADUYLLMHZVUKNHZUXFUYLVCHZBUCZVDZVEZVUNFZIZIZIVVSVVMUXLUWTVWNVVSVVM
      UXLUTZUWTGZVWNVUMCVWMWAZVWRVWSUYMVWIVEZCVWMWAZVWRVVEVWICVWLWAUYMVWIWJJKZV
      XAUYSVVEVVSUXLUWTWHVWRDVWIVWKCVWLVWJVWHUYLVCHZVUKUYLVCHZNHZFZVWRUXFVWIFZG
      ZVWKCFZVXGVWRVXFVXGVWRVXFIVWRVXGVXGVXFVWRVXGVXGVXFIVXHVXGVXFVXHVWHWIFZVUK
      WIFZUXFWIFZUYLWIFZGVXGVXFSVXGVXJVWRUXFVWHVUKWKWLVWQVXKUWTVXGVVSVVMVXKUXLV
      UHUYSVXKVUSVVEUYSVXMVUAWIFVXKVUHUYLWMZVUAWMUYLVUAWNWOVSVTZWPVWRVXMVXGVXLV
      WQVXMUWTVVMVVSVXMUXLUYSVXMVVEVXNRWQRZUXFVWHVUKWRWSUXFUYLVWHVUKWTXAUGXBXCX
      DXEVXFVXHVUSVWJVUBFZGZVXIVXFVXHVXRVXFVXHGVUSVXQVWRVUSVXFVXGVUHVUSVVMUXLUW
      TXFXGVXHVXFVXQVXHVXEVUBVWJVXHVXCLVXDVUANVXHUYLXHFZLXHFZGZVXCLKVWQVYAUWTVX
      GVVSVVMVYAUXLVUHUYSVYAVUSVVEVUHVXTUYSVXSVXTVUHXIUSUYLXJZWSVSVTWPUYLLXKXLV
      XHVXSVUAXHFZGZVXDVUAKVWQVYDUWTVXGVVSVVMVYDUXLVUHUYSVYDVUSVVEVUHVYCUYSVXSV
      UAXJVYBWSVSVTWPUYLVUAXKXLXMXNUUAUUEXBVUBCVWJBUUBXOUIVWLUUFUUCVWRUYLVWHXPX
      QVXBVWRUYLVWQUYLXRFZUWTVVMVVSVYEUXLUYSVYEVVEUYLXSZRWQRUUDLUYLVWHVUKUUGXLU
      YMVWICAVWLUUHXAVWRVUMVWTCVWMVWRUYLVUMFZVUMVWTKVWRVYGVXMLUYLXTXQZUYLVUKXTX
      QZVXPVWQUWTVYHVWQUWOVYHUWSUWOVWQVYHVWQUWOUYLYDUOZVWQVYHIVWQUYSVVGUWOVYJSV
      VSUYSVVEUXLUUIVVMVVSVVGUXLVVEVVGUYSVVHWLWQVVKAJUYLYDAUYLUUQUUJYAVYJVWQUYL
      UUKFZVYHVYJVWQVYKVYJVWQGUYSYDUYLXPXQZVYKUYSVVEVVSUXLVYJUULVWQVYJVYLVVMVVS
      VYJVYLIZUXLUYSVYMVVEUYSYDUYLXTXQZVYJVYLUYLYBUYSVYNVYJGZVYLUYSYDXRFZVYEVYO
      VYLSUUMVYFVYPVYEGVYLVYOYDUYLUUNYCYEUGUUORWQXEUYLUUPUURXBUYLUUSXOYFYGURYNV
      WRVYIYDVUAXTXQZVWQVYQUWTVVSVVMVYQUXLVUHVYQVUSVUAYBRUUTRVWRVYEVUAXRFZGZVYI
      VYQSVWQVYSUWTVVSVVMVYSUXLVUHUYSVYSVUSVVEVUHVYRUYSVYEVUAXSVYFWSVSVTRVYSVYQ
      VYIUYLVUAUVAYCXLYHVWRLWIFVXKVYGVXMVYHVYIUTSUVGVWQVXKUWTVXORUYLLVUKUVBYEUV
      CUYLLVUKUVDXLUVEYHVWRUXLVUMOFVWNVWSSVVSVVMUXLUWTUVFLVUKNWBCVUMVWMOOWCUVHY
      HYIVVLVWFVWPVVMVVLVWEVWOUXLVVLVWDVWNUWTVVLVWCVWMVUNVVLVWBVWLAVVLDVWAUXHVW
      IVWKVVLUXBVWHVVTVUKNUXAUYLLMUJUXAUYLVUAMUJXMVVLUXGVWJBUXAUYLUXFVCUQUVIYJY
      KUNTTTUVSVVRVVNVWGVVLVVRVUQVWFVVMVVRVUPVWEUXLVVRVUOVWDUWTVVRUXJVWCVUNVVRU
      XIVWBAVVRDUXEUXHVWAUXHVVRUXDVVTUXBNUXCVUAUXAMUQVLVVRUXHUVJYJYKUNTTTTUKYLX
      LXBYGUVKYNYOYLXLXBYGYOUIYFUVLUVMUVNXDYMUIYFYGUVOXEYPUYHVUOEVUKPUYEVUKKZUY
      GVUNUXJVYTUYFVUMCQUYEVUKLNUQVLXNUVPYAYIYQYRYOYQYRUVQYPUYBUXJEPUYGVHZFUYIU
      XQWUAUXJDEPUXPUYGDEVKUXOUYFCQUXFUYELNUQVLVMVNEUXJPUYGVOVPUVRYIUXRUWFUXTUX
      NUYDUWEUXQAYSUXRUWGUYAUXMUYCUWEUXQBYSUXRUXKUYBUWTUWEUXQUXJYSTYTYTUKUIUIUV
      TUWAUWBYMUWCUWD @.
  @}

  @c -.c @.

  @( Extend class notation with the symbol ` -. ` . @)
  cnots @a class -.c @.

  @( Definition of the symbol ` -. ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-nots @a |- -.c = { <. 1 , 1 >. } @.

  @c /\c @.

  @( Extend class notation with the symbol ` /\ ` . @)
  cands @a class /\c @.

  @( Definition of the symbol ` /\ ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-ands @a |- /\c = { <. 1 , 2 >. } @.

  @c \/c @.

  @( Extend class notation with the symbol ` \/ ` . @)
  clors @a class \/c @.

  @( Definition of the symbol ` \/ ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-ors @a |- \/c = { <. 1 , 3 >. } @.

  @c =>c @.

  @( Extend class notation with the symbol ` -> ` . @)
  cimps @a class =>c @.

  @( Definition of the symbol ` -> ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-imps @a |- =>c = { <. 1 , 4 >. } @.

  @c <=>c @.

  @( Extend class notation with the symbol ` <-> ` . @)
  cbis @a class <=>c @.

  @( Definition of the symbol ` <-> ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-bis @a |- <=>c = { <. 1 , 5 >. } @.

  @c _|_c @.

  @( Extend class notation with the symbol _|_ . @)
  cfals @a class _|_c @.

  @( Definition of the symbol _|_ .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-fals @a |- _|_c = { <. 1 , 6 >. } @.

  @c phc @.

  @( Extend class notation with the symbol ` ph ` . @)
  cphc @a class phc @.

  @( Definition of the symbol ` ph ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-phc @a |- phc = { <. 1 , 7 >. } @.

  @c psc @.

  @( Extend class notation with the symbol ` ps ` . @)
  clpsc @a class psc @.

  @( Definition of the symbol ` ps ` .  Experimental.  (Contributed by FL,
     2-Feb-2014.) @)
  df-psc @a |- psc = { <. 1 , 8 >. } @.

  @( The variable ` phc ` belongs to the Kleene star of ` NN ` .  (Contributed
     by FL, 2-Feb-2014.) @)
  phckle @p |- phc e. ( Kleene ` NN ) @=
    ( vn cphc cn wcel c1 c7 csn cn0 cfz co cmap wf wf1o elexi ax-mp mp2an mpbir
    wceq 7nn nnex ckln cfv cop cv ciun wrex 1nn0 wss 1ex cr f1osn wb cz 1z fzsn
    7re eqid f1oeq23 f1of snss mpbi ovex elmap oveq2 oveq2d eleq2d rspcev eliun
    fss df-phc cvv isKleene eleq12i ) BCUAUBZDEFUCGZAHCEAUDZIJZKJZUEZDZVTVOVRDZ
    AHUFZEHDVOCEEIJZKJZDZWBUGWEWCCVOLZWCFGZVOLZWGCUHZWFWCWGVOMZWHWJEGZWGVOMZEFU
    IFUJUPNUKWCWKRZWGWGRWJWLULEUMDWMUNEUOOWGUQWCWKWGWGVOURPQWCWGVOUSOFCDWISFCFC
    SNUTVAWCWGCVOVIPCWCVOTEEIVBVCQWAWEAEHVPERZVRWDVOWNVQWCCKVPEEIVDVEVFVGPAVOHV
    RVHQBVOVNVSVJCVKDVNVSRTACVKVLOVMQ @.

  @( The variable ` psc ` belongs to the Kleene star of ` NN ` .  (Contributed
     by FL, 2-Feb-2014.) @)
  psckle @p |- psc e. ( Kleene ` NN ) @=
    ( vn clpsc cn wcel c1 c8 csn cn0 cfz co cmap wf wf1o elexi wceq ax-mp mp2an
    mpbir 8nn nnex ckln cfv cop cv ciun wrex 1nn0 wss 1ex cr 8re f1osn wb cz 1z
    fzsn eqid f1oeq23 f1of snss mpbi fss elmap oveq2 oveq2d eleq2d rspcev eliun
    ovex df-psc cvv isKleene eleq12i ) BCUAUBZDEFUCGZAHCEAUDZIJZKJZUEZDZVTVOVRD
    ZAHUFZEHDVOCEEIJZKJZDZWBUGWEWCCVOLZWCFGZVOLZWGCUHZWFWCWGVOMZWHWJEGZWGVOMZEF
    UIFUJUKNULWCWKOZWGWGOWJWLUMEUNDWMUOEUPPWGUQWCWKWGWGVOURQRWCWGVOUSPFCDWISFCF
    CSNUTVAWCWGCVOVBQCWCVOTEEIVIVCRWAWEAEHVPEOZVRWDVOWNVQWCCKVPEEIVDVEVFVGQAVOH
    VRVHRBVOVNVSVJCVKDVNVSOTACVKVLPVMR @.

  @c Pc @.

  @( Extend class notation with a function that returns a propositional
     variable. @)
  cPc @a class Pc @.

  @( Function that returns a propositional variable.  Experimental.
     (Contributed by FL, 2-Feb-2014.) @)
  df-propvar @a |- Pc = ( x e. ( ZZ>= ` 7 ) |-> { <. 1 , x >. } ) @.

  @c notc @.

  @( Extend class notation with a function that returns a negated
     proposition. @)
  cnotc @a class notc @.

  @( Function that returns a negated proposition.  Experimental.  (Contributed
     by FL, 2-Feb-2014.) @)
  df-notc @a |- notc = ( x e. ( ( Kleene ` NN ) ^m { 1 } ) |->
    ( -.c conc ( x ` 1 ) ) ) @.

  @c andc @.

  @( Extend class notation with the class of function that returns two
     propositions joined with ` /\ ` . @)
  candc @a class andc @.

  @( Function that returns two propositions joined with ` /\ ` .
     Experimental.  (Contributed by FL, 2-Feb-2014.) @)
  df-andc @a |- andc = ( x e. ( ( Kleene ` NN ) ^m { 1 , 2 } )
    |-> ( ( /\c conc ( x ` 1 ) ) conc ( x ` 2 ) ) ) @.

  @c ors @.

  @( Extend class notation with the function that returns two propositions
     joined with ` \/ ` . @)
  cors @a class ors @.

  @( Function that returns two propositions joined with ` \/ ` .
     Experimental.  (Contributed by FL, 2-Feb-2014.) @)
  df-orc @a |- ors = ( x e. ( ( Kleene ` NN ) ^m { 1 , 2 } )
    |-> ( ( \/c conc ( x ` 1 ) ) conc ( x ` 2 ) ) ) @.

  @c impc @.

  @( Extend class notation with the function that returns two propositions
     joined with ` -> ` . @)
  cimpc @a class impc @.

  @( Function that returns two propositions joined with ` -> ` .
     Experimental.  (Contributed by FL, 2-Feb-2014.) @)
  df-impc @a |- impc = ( x e. ( ( Kleene ` NN ) ^m { 1 , 2 } )
    |-> ( ( =>c conc ( x ` 1 ) ) conc ( x ` 2 ) ) ) @.

  @c bic @.

  @( Extend class notation with the function that returns two propositions
     joined with ` <-> ` . @)
  cbic @a class bic @.

  @( Function that returns two propositions joined with ` <-> ` .
     Experimental.  (Contributed by FL, 2-Feb-2014.) @)
  df-bic @a |- bic = ( x e. ( ( Kleene ` NN ) ^m { 1 , 2 } )
    |-> ( ( <=>c conc ( x ` 1 ) ) conc ( x ` 2 ) ) ) @.

  @c Prop @.

  @( Extend class notation to include the set of all propositioanl formulas. @)
  cprop @a class Prop @.

  @( The set of propositional formulas.  Gallier p. 32.  (Contributed by FL,
     2-Feb-2014.) @)
  df-prop @a |- Prop =
    ( ( ( Pc " ( ZZ>= ` 7 ) ) u. { _|_c } ) IndCls
      ( { notc , andc , ors } u. { impc , bic } ) ) @.

  @{
    @d x y @.
    @( The symbols and variables of ` Prop ` belong to the Kleene star of
       ` NN ` .  (Contributed by FL, 2-Feb-2014.) @)
    smbkle @p |- ( ( Pc " ( ZZ>= ` 7 ) ) u. { _|_c } )
      C_ ( Kleene ` NN ) @=
      ( vx vy cPc c7 cfv cima cfals csn cn c1 cv cop wceq wss wcel snex eqsstri
      cvv ax-mp c6 cuz ckln df-propvar imaeq1i cdm dmmptg a1i imaeq2 eqcoms crn
      cmpt mprg imadmrn wrex cab eqid rnmpt wral 7nn uznnssnn sseli 1iskle rgen
      syl wb uniiunlem mpbi eqsstrd df-fals 6nn eqeltri snss unssi ) CDUAEZFZGH
      ZIUBEZVOAVNJAKZLZHZUKZVNFZVQCWAVNAUCUDWAUEZVNMZWBVQNVTROZWDAVNAVNVTRUFWEV
      RVNOZVSPUGZULWDWBWAWCFZVQWBWHMVNWCVNWCWAUHUIWHVQNWDWHWAUJZVQWAUMWIBKVTMAV
      NUNBUOZVQABVNVTWAWAUPUQVTVQOZAVNURZWJVQNZWKAVNWFVRIOWKVNIVRDIOVNINUSDUTSV
      AVRVBVDVCWEWLWMVEAVNABVNVTVQRVFWGULVGQQUGVHSQGVQOVPVQNGJTLZHZVQVITIOWOVQO
      VJTVBSVKGVQGWORVIWNPVKVLVGVM @.
  @}

  @( The interval ` ( 1 ... 2 ) ` in terms of its elements.  (Contributed by
     FL, 2-Feb-2014.) @)
  intset @p |- ( 1 ... 2 ) = { 1 , 2 } @=
    ( c1 c2 cfz co caddc cpr df-2 oveq2i cz wcel wceq ax-mp 1p1e2 preq2i 3eqtri
    1z fzpr ) ABCDAAAEDZCDZARFZABFBRACGHAIJSTKPAQLRBAMNO @.

  @{
    @d f n @.
    @( The functions of ` Prop ` .  (Contributed by FL, 2-Feb-2014.) @)
    fnckle @p |- A. f e. ( { notc , andc , ors } u. { impc , bic } )
      E. n e. NN
      f e. ( ( Kleene ` NN ) ^m ( ( Kleene ` NN ) ^m ( 1 ... n ) ) ) @=
      ( vx cn c1 co cmap wcel cnotc candc cors cimpc cbic cconc wf ax-mp clscnc
      wceq mpbir c2 cv ckln cfv cfz wrex ctp cpr cun wo elun w3o vex eltp cnots
      1nn csn cmpt eqid cop df-nots 1iskle eqeltri elmapi snidg ffvelrn sylancl
      sylancr fmpti fvex ovex elmap df-notc cz fzsn oveq2i eleq12i oveq2 oveq2d
      eleq2d rspcev mp2an eleq1 rexbidv mpbiri 2nn cands df-ands prid1g syl2anc
      1z prid2g df-andc intset clors df-ors 3nn df-orc 3jaoi sylbi elpr df-impc
      c3 cimps wb mpteq1 eqeq2d c4 df-imps 4nn w3a cle wbr wa 3pm3.2i 1re leidi
      2z 2re 1lt2 ltleii pm3.2i elfz4 mpan2 simpl eleq1d rexbidva df-bic df-bis
      cbis c5 5nn jaoi rgen ) AUAZDUBUCZYOEBUAZUDFZGFZGFZHZBDUEZAIJKUFZLMUGZUHZ
      YNUUDHYNUUBHZYNUUCHZUIUUAYNUUBUUCUJUUEUUAUUFUUEYNIRZYNJRZYNKRZUKUUAYNIJKA
      ULZUMUUGUUAUUHUUIUUGUUAIYSHZBDUEZEDHZIYOYOEEUDFZGFZGFZHZUULUOUUQCYOEUPZGF
      ZUNECUAZUCZNFZUQZYOUUSGFZHZUVEUUSYOUVCOCUUSYOUVBUVCUVCURUUTUUSHZUNYOHUVAY
      OHZUVBYOHUNEEUSUPZYOUTUUMUVHYOHUOEVAPVBUVFUURYOUUTOEUURHZUVGUUTYOUURVCUUM
      UVIUOEDVDPUURYOEUUTVEVFUNUVADQVGVHYOUUSUVCDUBVIZYOUURGVJVKSIUVCUUPUVDCVLU
      UOUUSYOGUUNUURYOGEVMHZUUNUURRWJEVNPVOVOVPSUUKUUQBEDYPERZYSUUPIUVLYRUUOYOG
      UVLYQUUNYOGYPEEUDVQVRVRVSVTWAUUGYTUUKBDYNIYSWBWCWDUUHUUAJYSHZBDUEZTDHZJYO
      YOETUDFZGFZGFZHZUVNWEUVSCYOETUGZGFZWFUVANFZTUUTUCZNFZUQZYOUWAGFZHZUWGUWAY
      OUWEOCUWAYOUWDUWEUWEURUUTUWAHZUWBYOHZUWCYOHZUWDYOHUWHWFYOHUVGUWIWFETUSUPZ
      YOWGUVOUWKYOHWETVAPVBUWHUVTYOUUTOZEUVTHZUVGUUTYOUVTVCZUUMUWMUOETDWHPUVTYO
      EUUTVEVFZWFUVADQVGUWHUWLTUVTHZUWJUWNUVOUWPWEETDWKPUVTYOTUUTVEVFZUWBUWCDQW
      IVHYOUWAUWEUVJYOUVTGVJZVKSJUWEUVRUWFCWLUVQUWAYOGUVPUVTYOGWMVOZVOZVPSUVMUV
      SBTDYPTRZYSUVRJUXAYRUVQYOGUXAYQUVPYOGYPTEUDVQVRVRZVSVTWAUUHYTUVMBDYNJYSWB
      WCWDUUIUUAKYSHZBDUEZUVOKUVRHZUXDWEUXECUWAWNUVANFZUWCNFZUQZUWFHZUXIUWAYOUX
      HOCUWAYOUXGUXHUXHURUWHUXFYOHZUWJUXGYOHUWHWNYOHUVGUXJWNEXBUSUPZYOWOXBDHUXK
      YOHWPXBVAPVBUWOWNUVADQVGUWQUXFUWCDQWIVHYOUWAUXHUVJUWRVKSKUXHUVRUWFCWQUWTV
      PSUXCUXEBTDUXAYSUVRKUXBVSVTWAUUIYTUXCBDYNKYSWBWCWDWRWSUUFYNLRZYNMRZUIUUAY
      NLMUUJWTUXLUUAUXMUXLUUALYSHZBDUEZUVOLUVRHZUXOWEUXPUVQYOLOCUVQYOXCUVANFZUW
      CNFZLLCUVQUXRUQZRZLCUWAUXRUQZRZCXAUVQUWARZUXTUYBXDUWSUYCUXSUYALCUVQUWAUXR
      XEXFPSUUTUVQHZUXQYOHZUWJUXRYOHUYDUVPYOUUTOZUYEYOUVPUUTUVJETUDVJVKZUYFXCYO
      HUVGUYEXCEXGUSUPZYOXHXGDHUYHYOHXIXGVAPVBUYFEUVPHZUVGUVKTVMHZUVKXJEEXKXLZE
      TXKXLZXMUYIUVKUYJUVKWJXQWJXNUYKUYLEXOXPETXOXRXSXTZYAEETYBWAZUVPYOEUUTVEZY
      CXCUVADQVGWSUYDUYFUWJUYGUYFTUVPHZUWJUVKUYJUYJXJUYLTTXKXLZXMUYPUVKUYJUYJWJ
      XQXQXNUYLUYQUYMTXRXPYATETYBWAUVPYOTUUTVEYCWSZUXQUWCDQWIVHYOUVQLUVJYOUVPGV
      JZVKSUXNUXPBTDUXAYSUVRLUXBVSVTWAUXLYTUXNBDUXLYPDHZXMYNLYSUXLUYTYDYEYFWDUX
      MUUAMYSHZBDUEZUVOMUVRHZVUBWEVUCUVQYOMOCUVQYOYIUVANFZUWCNFZMMCUVQVUEUQZRZM
      CUWAVUEUQZRZCYGUYCVUGVUIXDUWSUYCVUFVUHMCUVQUWAVUEXEXFPSUYDVUDYOHZUWJVUEYO
      HUYDYIYOHUVGVUJYIEYJUSUPZYOYHYJDHVUKYOHYKYJVAPVBUYDUYFUYIUVGUUTYOUVPVCUYN
      UYOVFYIUVADQVGUYRVUDUWCDQWIVHYOUVQMUVJUYSVKSVUAVUCBTDUXAYSUVRMUXBVSVTWAUX
      MYTVUABDUXMUYTXMYNMYSUXMUYTYDYEYFWDYLWSYLWSYM @.

    @( The functions of ` Prop ` .  (Contributed by FL, 2-Feb-2014.) @)
    fnckleb @p |- A. f e. ( { notc , andc , ors } u. { impc , bic } )
      ( Fun f /\ ran f C_ ( Kleene ` NN ) ) @=
      ( vn cv cn ckln cfv c1 cfz cmap wcel wrex cnotc candc cors ctp cimpc wral
      co wa sylbi cbic cpr cun wfun crn wss fnckle wf fvex ovex elmap wfn fnfun
      df-f anim1i rexlimivw ralimi ax-mp ) ACZDEFZUTGBCHRZIRZIRJZBDKZALMNOPUAUB
      UCZQUSUDZUSUEUTUFZSZAVEQABUGVDVHAVEVCVHBDVCVBUTUSUHZVHUTVBUSDEUIUTVAIUJUK
      VIUSVBULZVGSVHVBUTUSUNVJVFVGVBUSUMUOTTUPUQUR @.

  @}

  @{
    @d a f j n @.
    @( Propositional formulas are a subset of the Kleene star of ` NN ` .
       (Contributed by FL, 2-Feb-2014.) @)
    pfsubkl @p |- Prop C_ ( Kleene ` NN ) @=
      ( vj vf vx vy cfv cnotc candc cors cimpc cbic co wss wcel cvv cin wral wa
      wceq wo cconc va vn cprop cPc c7 cuz cima cfals csn cun ctp cpr clincl cn
      ckln df-prop cv cdm cxp cpw cab cint c1 cfz cmap wrex fvex smbkle indcls2
      fnckle mp3an sseq2 xpeq2 pweqd ineq2d eleq2 raleqbidv ralbidv anbi12d w3o
      elun eltpg elin crn wfun fnckleb cnots cmpt df-notc ovex mptex tpid1 orci
      eqeltri mpbir funeq rneq sseq1d rspccva simprd funmpt2 fvelrn mpan sseldi
      mp2an adantr sylbi rgen ineq1d fveq1 eleq1d mpbiri c2 cands df-andc tpid2
      dmeq clors df-orc tpid3 3jaoi syl6bi pm2.43i vex elpr cimps df-impc prid1
      olci cbis df-bic prid2 jaoi pm3.2i intmin3 ax-mp eqsstri ) UCUDUEUFEUGUHU
      IUJZFGHUKZIJULZUJZUMKZUNUOEZUPUUBYRUAUQZLZAUQZBUQZEZUUDMZAUUGURZNUUDUSZUT
      ZOZPZBUUAPZQZUAVAVBZUUCUUCNMZYRUUCLZUUGUUCUUCVCUBUQVDKVEKVEKMUBUNVFBUUAPU
      UBUUQRUNUOVGZVHBUBVJNUUCBAUBUUAYRUAVIVKUURUUQUUCLUUTUUPUUSUUHUUCMZAUUJNUU
      CUSZUTZOZPZBUUAPZQUAUUCNUUDUUCRZUUEUUSUUOUVFUUDUUCYRVLUVGUUNUVEBUUAUVGUUI
      UVAAUUMUVDUVGUULUVCUUJUVGUUKUVBUUDUUCNVMVNVOUUDUUCUUHVPVQVRVSUUSUVFVHUVEB
      UUAUUGUUAMUUGYSMZUUGYTMZSUVEUUGYSYTWAUVHUVEUVIUVHUVEUVHUVHUUGFRZUUGGRZUUG
      HRZVTUVEUUGFGHYSWBUVJUVEUVKUVLUVJUVEUUFFEZUUCMZAFURZUVCOZPUVNAUVPUUFUVPMU
      UFUVOMZUUFUVCMZQUVNUUFUVOUVCWCUVQUVNUVRUVQFWDZUUCUVMUUGWEZUUGWDZUUCLZQZBU
      UAPZFUUAMZUVSUUCLZBWFZUWEFYSMZFYTMZSUWHUWIFGHFCUUCVCUIZVEKZWGVCCUQZEZTKZW
      HNCWIZCUWKUWNUUCUWJVEWJWKWNWLWMFYSYTWAWOUWDUWEQFWEZUWFUWCUWPUWFQBFUUAUVJU
      VTUWPUWBUWFUUGFWPUVJUWAUVSUUCUUGFWQWRVSWSWTXEUWPUVQUVMUVSMCUWKUWNFUWOXAUU
      FFXBXCXDXFXGXHUVJUVAUVNAUVDUVPUVJUUJUVOUVCUUGFXQXIUVJUUHUVMUUCUUFUUGFXJXK
      VQXLUVKUVEUUFGEZUUCMZAGURZUVCOZPUWRAUWTUUFUWTMUUFUWSMZUVRQUWRUUFUWSUVCWCU
      XAUWRUVRUXAGWDZUUCUWQUWDGUUAMZUXBUUCLZUWGUXCGYSMZGYTMZSUXEUXFFGHGDUUCVCXM
      ULZVEKZXNVCDUQZEZTKXMUXIEZTKZWHNDXOZDUXHUXLUUCUXGVEWJZWKWNXPWMGYSYTWAWOUW
      DUXCQGWEZUXDUWCUXOUXDQBGUUAUVKUVTUXOUWBUXDUUGGWPUVKUWAUXBUUCUUGGWQWRVSWSW
      TXEUXOUXAUWQUXBMDUXHUXLGUXMXAUUFGXBXCXDXFXGXHUVKUVAUWRAUVDUWTUVKUUJUWSUVC
      UUGGXQXIUVKUUHUWQUUCUUFUUGGXJXKVQXLUVLUVEUUFHEZUUCMZAHURZUVCOZPUXQAUXSUUF
      UXSMUUFUXRMZUVRQUXQUUFUXRUVCWCUXTUXQUVRUXTHWDZUUCUXPUXIWEZUXIWDZUUCLZQZDU
      UAPZHUUAMZUYAUUCLZDWFZUYGHYSMZHYTMZSUYJUYKFGHHDUXHXRUXJTKUXKTKZWHNDXSDUXH
      UYLUXNWKWNXTWMHYSYTWAWOUYFUYGQHWEZUYHUYEUYMUYHQDHUUAUXIHRZUYBUYMUYDUYHUXI
      HWPUYNUYCUYAUUCUXIHWQWRVSWSWTXEUYMUXTUXPUYAMCUXHXRUWMTKXMUWLETKHCXSXAUUFH
      XBXCXDXFXGXHUVLUVAUXQAUVDUXSUVLUUJUXRUVCUUGHXQXIUVLUUHUXPUUCUUFUUGHXJXKVQ
      XLYAYBYCUVIUUGIRZUUGJRZSUVEUUGIJBYDYEUYOUVEUYPUYOUVEUUFIEZUUCMZAIURZUVCOZ
      PUYRAUYTUUFUYTMUUFUYSMZUVRQUYRUUFUYSUVCWCVUAUYRUVRVUAIWDZUUCUYQUYFIUUAMZV
      UBUUCLZUYIVUCIYSMZIYTMZSVUFVUEIJIDUXHYFUXJTKUXKTKZWHNDYGZDUXHVUGUXNWKWNYH
      YIIYSYTWAWOUYFVUCQIWEZVUDUYEVUIVUDQDIUUAUXIIRZUYBVUIUYDVUDUXIIWPVUJUYCVUB
      UUCUXIIWQWRVSWSWTXEVUIVUAUYQVUBMDUXHVUGIVUHXAUUFIXBXCXDXFXGXHUYOUVAUYRAUV
      DUYTUYOUUJUYSUVCUUGIXQXIUYOUUHUYQUUCUUFUUGIXJXKVQXLUYPUVEUUFJEZUUCMZAJURZ
      UVCOZPVULAVUNUUFVUNMUUFVUMMZUVRQVULUUFVUMUVCWCVUOVULUVRVUOJWDZUUCVUKUWDJU
      UAMZVUPUUCLZUWGVUQJYSMZJYTMZSVUTVUSIJJDUXHYJUXJTKUXKTKZWHNDYKZDUXHVVAUXNW
      KWNYLYIJYSYTWAWOUWDVUQQJWEZVURUWCVVCVURQBJUUAUYPUVTVVCUWBVURUUGJWPUYPUWAV
      UPUUCUUGJWQWRVSWSWTXEVVCVUOVUKVUPMDUXHVVAJVVBXAUUFJXBXCXDXFXGXHUYPUVAVULA
      UVDVUNUYPUUJVUMUVCUUGJXQXIUYPUUHVUKUUCUUFUUGJXJXKVQXLYMXGYMXGXHYNYOYPYQYQ
      @.
  @}

  @{
    @d f n @.
    @( Propositional variables are propositions .  (Contributed by FL,
       2-Feb-2014.) @)
    pvp @p |- ( Pc " ( ZZ>= ` 7 ) ) C_ Prop @=
      ( vf vn cPc c7 cuz cfv cima cprop wss cfals csn wa cun co cn ckln wcel cv
      cvv cmap cnotc candc cors ctp cimpc cbic cpr clincl c1 cfz wrex wral fvex
      smbkle fnckle xindcls mp3an df-prop sseqtr4i unss mpbir simpli ) CDEFGZHI
      ZJKZHIZVDVFLVCVEMZHIVGVGUAUBUCUDUEUFUGMZUHNZHOPFZSQVGVJIARVJVJUIBRUJNTNTN
      QBOUKAVHULVGVIIOPUMUNABUOSVJABVHVGUPUQURUSVCVEHUTVAVB @.

  @}

  @{
    @d x y N @.
    @( Condition to be a propositional variable.  (Contributed by FL,
       2-Feb-2014.) @)
    cndpv @p |- ( ( N e. ZZ /\ 7 <_ N )
      -> { <. 1 , N >. } e. ( Pc " ( ZZ>= ` 7 ) ) ) @=
      ( vx vy cPc cdm c7 cuz cfv wceq cz wcel cop csn cima snex df-propvar wrex
      c1 cv syl6eleqr cle wbr wa wi dmmpti crn cab 7nn nnzi biimpri eqidd opeq2
      eluz1i sneqd eqeq2d rspcev syl2anc eqeq1 rexbidv elab sylibr rnmpt imaeq2
      imadmrn eqcoms eleq2d syl5ibr ax-mp ) DEZFGHZIZAJKFAUAUBUCZRALZMZDVJNZKZU
      DBVJRBSZLZMDVROBPUEVLVPVKVNDVINZKVLVNDUFZVSVLVNVQRCSZLZMZIZCVJQZBUGZVTVLV
      NWCIZCVJQZVNWFKVLAVJKZVNVNIZWHWIVLFAFUHUIUMUJVLVNUKWGWJCAVJWAAIZWCVNVNWKW
      BVMWAARULUNUOUPUQWEWHBVNVMOVQVNIWDWGCVJVQVNWCURUSUTVACBVJWCDCPVBTDVDTVKVO
      VSVNVOVSIVJVIVJVIDVCVEVFVGVH @.
  @}

  @( ` phc ` is a propositional formula.  (Contributed by FL, 2-Feb-2014.) @)
  phpf @p |- phc e. Prop @=
    ( cPc c7 cuz cfv cima cprop cphc pvp c1 cop csn df-phc cz wcel cle wbr nnzi
    7nn 7re leidi cndpv mp2an eqeltri sselii ) ABCDEZFGHGIBJKZUELBMNBBOPUFUENBR
    QBSTBUAUBUCUD @.

  @( ` psc ` is a propositional formula.  (Contributed by FL, 2-Feb-2014.) @)
  pspf @p |- psc e. Prop @=
    ( cPc c7 cuz cfv cima cprop clpsc pvp c1 c8 cop csn df-psc wcel cle wbr 8nn
    cz nnzi 7re 8re 7lt8 ltleii cndpv mp2an eqeltri sselii ) ABCDEZFGHGIJKLZUHM
    JRNBJOPUIUHNJQSBJTUAUBUCJUDUEUFUG @.

  @{
    @d a f j n @.  @d n x @.  @d x y @.
    @( ` ( ph /\ ps ) ` is a propositional formula.  We use variables.
       (Contributed by FL, 2-Feb-2014.) @)
    pgapspf @p |- ( ( /\c conc phc ) conc psc )
    e. Prop @=
      ( vx vn vy cphc cconc co clpsc cPc c7 cfv csn candc wcel wss cvv c1 ax-mp
      c2 wceq c8 va vj vf vz cands cuz cima cfals cun cnotc cors ctp cimpc cbic
      cpr clincl cprop cv cdm cxp cpw cin wral wa cab cint wi ovex elintab ckln
      cop cn cmap df-pr wf c0 wf1o 1ex df-phc snex eqeltri f1osn f1of snss mpbi
      phckle fss mp2an cr 2re df-psc psckle sylancl pm3.2i wne 1ne2 disjsn2 fun
      elexi unidm mpbir elmap a1i fveq1 syl6eq df-andc sylancr cmpt dmeq eleq1d
      mp1i w3a wb sylibr xpsn ssv wrex cz cle wbr nnzi 7re mpbir2an opeq2 sneqd
      eluz1i eqeq2d rspcev eqeq1 rexbidv df-propvar rnmpt sseqtr4i eqcoms sstr2
      adantr sylbir xpss12 syl5eqssr mpgbir eqcomi feq23i fvex prex fvpr1 fvpr2
      oveq2d oveq12d fvmptg mptex ineq1d raleqbidv rspcva 3pm3.2i feq123 mpbird
      tpid2 elun1 cmpdom2 syl6eleqr unss crn 7nn leidi elab imadmrn dmmptg mprg
      snssi eqeq1d imaeq2 syl6bi mp2 ssab elsn 8nn 8re 7lt8 ltleii mpbiri sylbi
      mp2b unssd unex elpw syl5eqel elin sylanbrc fveq2 syl syl5com mpan impcom
      rspcv eqeltrrd cfz smbkle fnckle indcls2 eleq2d mp3an df-prop eleqtrri )
      UEDEFZGEFZHIUFJZUGZUHKZUIZUJLUKULZUMUNUOZUIZUPFZUQUXEUXMMZUXEUXIUAURZNZUB
      URZUCURZJZUXOMZUBUXRUSZOUXOUTZVAZVBZVCZUCUXLVCZVDZUAVEVFZMZUYIUYGUXEUXOMV
      GUAUYGUAUXEUXDGEVHZVIUYGPDVKZRGVKZUOZLJZUXEUXOUYGUYMVLVJJZPRUOZVMFZMZUXEO
      MZUYNUXESUYMUYKKZUYLKZUIZUYQUYKUYLVNZVUBUYQMUYPUYOVUBVOZVUDPKZRKZUIZUYOUY
      OUIZVUBVOZVUEUYOUYTVOZVUFUYOVUAVOZVDZVUEVUFVBVPSZVUIVUJVUKVUEDKZUYTVOZVUN
      UYONZVUJVUEVUNUYTVQVUOPDVRDPIVKZKZOVSVUQVTWAZWBVUEVUNUYTWCQDUYOMVUPWFDUYO
      VUSWDWEVUEVUNUYOUYTWGWHVUFGKZVUAVQZVUKRGRWIWJWSZGPTVKZKZOWKVVCVTWAZWBVVAV
      UFVUTVUAVOVUTUYONZVUKVUFVUTVUAWCGUYOMVVFWLGUYOVVEWDWEVUFVUTUYOVUAWGWMQWNZ
      PRWOZVUMWPPRWQQZVUEVUFUYOUYOUYTVUAWRZWHUYPUYOVUGVUHVUBPRVNZVUHUYOUYOWTUUA
      ZUUBXAUYOUYPVUBVLVJUUCZPRUUDZXBXAWAUYSUYGUYJXCAUYMUEPAURZJZEFZRVVOJZEFUXE
      UYQOLVVOUYMSZVVQUXDVVRGEVVSVVPDUEEVVSVVPPUYMJZDPVVOUYMXDVVHVVTDSWPPRDGVRV
      USUUEQXEUUGVVSVVRRUYMJZGRVVOUYMXDVVHVWAGSWPPRDGVVBVVEUUFQXEUUHAXFUUIXGUYF
      UXPUYNUXOMZLUXLMZUYFUXPVWBVGLUXJMVWCUJLUKLUDUYQUEPUDURZJEFZRVWDJZEFZXHOUD
      XFZUDUYQVWGUYOUYPVMVHUUJWAUUQLUXJUXKUURQVWCUYFVDUXQLJZUXOMZUBLUSZUYCVBZVC
      ZUXPVWBUYEVWMUCLUXLUXRLSZUXTVWJUBUYDVWLVWNUYAVWKUYCUXRLXIUUKVWNUXSVWIUXOU
      XQUXRLXDXJUULUUMUXPUYMVWLMZVWMVWBVGUXPUYMVWKMUYMUYCMVWOUXPUYMUYQVWKUXPUYP
      UYOUYMVOZUYRUXPVWPVUIVULVUMVDVUIUXPVULVUMVVGVVIWNVVJXKUYMVUBSZUYPVUGSZUYO
      VUHSZXLVWPVUIXMUXPVWQVWRVWSVUCVVKVVLUUNUYPUYOVUGVUHUYMVUBUUOXKUUPUYOUYPUY
      MVVMVVNXBXNUDUYQVWEVWFLEVWHUUSUUTUXPUYMVUBUYCVUCUXPVUBUYBNVUBUYCMUXPUYTVU
      AUYBUXPUYTVUEVUNUTZUYBPDVRVUSXOUXPVUEONVUNUXONZVWTUYBNVUEXPUXPUXGUXONZUXH
      UXONZVDZVXAUXGUXHUXOUVAZVXBVXAVXCVUNUXGNVXBVXAVGVUNHHUSZUGZUXGVUNHUVBZVXG
      VUNVVOPBURZVKZKZSZBUXFXQZAVEZVXHDVXNMZVUNVXNNVXODVXKSZBUXFXQZIUXFMZDVURSZ
      VXQVXRIXRMIIXSXTIUVCYAZIYBUVDIIVXTYFYCVSVXPVXSBIUXFVXIISZVXKVURDVYAVXJVUQ
      VXIIPYDYEYGYHWHVXMVXQADVUSVVODSVXLVXPBUXFVVODVXKYIYJUVEXADVXNUVIQBAUXFVXK
      HBYKYLYMHUVFZYMHAUXFPVVOVKZKZXHZSZVYEUSZUXFSZUXGVXGSZAYKZVYDOMZVYHAUXFAUX
      FVYDOUVGVYKVVOUXFMVYCVTXCUVHZVYFVYHVXFUXFSZVYIVYFVYGVXFUXFVYGVXFSVYEHVYEH
      XIYNUVJVYIUXFVXFUXFVXFHUVKYNZUVLUVMYMVUNUXGUXOYOQYPYQVUEOVUNUXOYRXGYSUXPV
      UAVUFVUTUTZUYBRGVVBGUYOWLWSXOUXPVUFONVUTUXONZVYOUYBNVUFXPUXPVXDVYPVXEVXBV
      YPVXCVUTUXGNVXBVYPVGVUTVXGUXGVUTVXHVXGVUTVVOPCURZVKZKZSZCUXFXQZAVEZVXHVUT
      WUBNVVOVUTMZWUAVGAWUAAVUTUVNWUCVVOGSZWUAAGUVOWUDWUAGVYSSZCUXFXQZTUXFMZGVV
      DSZWUFWUGTXRMITXSXTTUVPYAITYBUVQUVRUVSITVXTYFYCWKWUEWUHCTUXFVYQTSZVYSVVDG
      WUIVYRVVCVYQTPYDYEYGYHWHWUDVYTWUECUXFVVOGVYSYIYJUVTUWAYTCAUXFVYSHCYKYLYMV
      YBYMVYFVYMVYIVYJVYFVXFVYGUXFHVYEXIVYLXEVYNUWBYMVUTUXGUXOYOQYPYQVUFOVUTUXO
      YRXGYSUWCVUBUYBUYTVUAUYKVTUYLVTUWDUWEXNUWFUYMVWKUYCUWGUWHVWJVWBUBUYMVWLUX
      QUYMSVWIUYNUXOUXQUYMLUWIXJUWNUWJUWKUWLUWMUWOYTUYOOMZUXIUYONZUXRUYOUYOPVXI
      UWPFVMFVMFMBVLXQUCUXLVCZUXNUYIXMVVMUWQUCBUWRWUJWUKWULXLUXMUYHUXEOUYOUCUBB
      UXLUXIUAUWSUWTUXAXAUXBUXC @.
  @}

  @{
    @d a f j n @.  @d a j p q P @.  @d a f j y @.  @d a j q Q @.  @d p q x @.
    @( ` ( ph /\ ps ) ` is a propositional formula.  Here we use
       meta-variables.  (Contributed by FL, 2-Feb-2014.) @)
    pgapspf2 @p |- ( ( P e. Prop /\ Q e. Prop ) ->
      ( ( /\c conc P ) conc Q ) e. Prop ) @=
      ( va vj vf cprop wcel wa cconc co cfv candc cv cvv wi cn c1 wb c2 wceq vy
      vx vq vp vn cands cPc c7 cuz cima cfals csn cun cnotc cors ctp cimpc cbic
      cpr clincl wss cdm cxp cpw cin wral cab cint ckln cmap wrex smbkle fnckle
      wal cfz fvex indcls2 eleq2d mp3an elintabg 19.26 pm3.43 pm2.27 wo df-andc
      w3a cmpt ovex mptex eqeltri tpid2 orci elun mpbir dmeq fveq1 eleq1d eleq1
      cop wel anbi2d anbi1d 3anbi23d opeq2 fveq2d oveq2 eqeq12d imbi12d wf 1ne2
      1ex 2nn vex ax-mp pfsubkl sseli anim12i 3ad2ant3 fss pm3.2i elmapg mpbird
      syl6eq pm2.43i a1i adantl prssg mpbid syl6eleqr ex syl com3r com3l syl6bi
      mp1i sylbi df-prop eleq2s pm2.43b sylibr ineq1d rspccva preq1d oveq1d wne
      raleqbidv preq2d elexi prss sylib sylancr prex fvpr1 oveq2d fvpr2 oveq12d
      fpr fvmptg sylancl vtocl2g dmeqi dmmptg mprg eqtr 1nn fprg syl3anc pm3.22
      simpr adantr ssin mpbi2and syl2anc inex1 ineq1 imbi2d syl5ibr mp2an fveq2
      selsubf3 rspcv syl6 3imp 3exp mpan2 syld com12 alimdv expcom sylbir com23
      eqeltrrd imp elintab ) AFGZBFGZHZUFAIJZBIJZUGUHUIKUJUKULUMZUNLUOUPZUQURUS
      ZUMZUTJZFUWQUWSUWTCMZVAZDMZEMZKZUXEGZDUXHVBZNUXEVCVDZVEZVFZEUXCVFZHZCVGVH
      ZGZUWSUXDGZUWQUXPUWSUXEGZOZCVNZUXRUWOUWPUYBUWOUWPUYBOZUWOUWOUYCUWOUWOUYCO
      ZOZAUXDFAUXDGZAUXQGZUYEPVIKZNGZUWTUYHVAZUXHUYHUYHQUAMVOJVJJVJJGUAPVKEUXCV
      FZUYFUYGRPVIVPZVLEUAVMZUYIUYJUYKWFZUXDUXQANUYHEDUAUXCUWTCVQZVRVSUWOUYGUWO
      UYCUWOUYGUXPAUXEGZOZCVNZUYDUXPCAFVTUWPUYRUWOUYBUWPUYRUWOUYBOZOZUWPUWPUYTU
      WPUWPUYTOZOZBUXDFBUXDGZBUXQGZVUBUYIUYJUYKVUCVUDRUYLVLUYMUYNUXDUXQBUYOVRVS
      UWPVUDUWPUYTUWPVUDUXPBUXEGZOZCVNZVUAUXPCBFVTVUGUYRUWPUYSVUGUYRUWPUYSOZVUG
      UYRHVUFUYQHZCVNZVUHVUFUYQCWAUWPUWOVUJUYBUWOUWPVUJUYBOUWQVUIUYACVUIUWQUYAV
      UIUXPVUEUYPHZOZUWQUYAOUXPVUEUYPWBUXPVULUWQUXTUXPVULVUKUWQUXTOZUXPVUKWCUXO
      VUKVUMOZUXFUXOLUXCGZVUNVUOLUXAGZLUXBGZWDVUPVUQUNLUOLUBUYHQSUSZVJJZUFQUBMZ
      KZIJZSVUTKZIJZWGZNUBWEZUBVUSVVDUYHVURVJWHWIWJWKWLLUXAUXBWMWNUXOVUOHUXGLKZ
      UXEGZDLVBZUXLVEZVFZVUNUXNVVKELUXCUXHLTZUXJVVHDUXMVVJVVLUXKVVIUXLUXHLWOUUA
      VVLUXIVVGUXEUXGUXHLWPWQUUFUUBVVKVUKUWQUXTVVKVUKUWQWFZQAWSZSBWSZUSZLKZUWSU
      XEVVMVVQUWSTZUWQVVKVVMVVROZVUKVVKUCCWTZUDCWTZHZUDMZFGZUCMZFGZHZWFZQVWCWSZ
      SVWEWSZUSZLKZUFVWCIJZVWEIJZTZOVVKVVTUYPHZUWOVWFHZWFZVVNVWJUSZLKZUWRVWEIJZ
      TZOVVSUDUCABFFVWCATZVWHVWRVWOVXBVXCVWBVWPVWGVWQVVKVXCVWAUYPVVTVWCAUXEWRXA
      VXCVWDUWOVWFVWCAFWRXBXCVXCVWLVWTVWNVXAVXCVWKVWSLVXCVWIVVNVWJVWCAQXDUUCXEV
      XCVWMUWRVWEIVWCAUFIXFUUDXGXHVWEBTZVWRVVMVXBVVRVXDVWPVUKVWQUWQVVKVXDVVTVUE
      UYPVWEBUXEWRXBVXDVWFUWPUWOVWEBFWRXAXCVXDVWTVVQVXAUWSVXDVWSVVPLVXDVWJVVOVV
      NVWEBSXDUUGXEVWEBUWRIXFXGXHVWHVWKVUSGZVWNNGVWOVWHVXEVURUYHVWKXIZVWHVURVWC
      VWEUSZVWKXIZVXGUYHVAZVXFQSUUEZVXHXJQSVWCVWEXKSPXLUUHZUDXMZUCXMZUUQXNVWHVW
      CUYHGZVWEUYHGZHZVXIVWGVVKVXPVWBVWDVXNVWFVXOFUYHVWCXOXPFUYHVWEXOXPXQXRVWCV
      WEUYHVXLVXMUUIUUJVURVXGUYHVWKXSUUKUYIVURNGZHVXEVXFRVWHUYIVXQUYLQSUULZXTUY
      HVURVWKNNYAYOYBVWMVWEIWHUBVWKVVDVWNVUSNLVUTVWKTZVVBVWMVVCVWEIVXSVVAVWCUFI
      VXSVVAQVWKKZVWCQVUTVWKWPVXJVXTVWCTXJQSVWCVWEXKVXLUUMXNYCUUNVXSVVCSVWKKZVW
      ESVUTVWKWPVXJVYAVWETXJQSVWCVWEVXKVXMUUOXNYCUUPVVFUURUUSUUTXRYDVVKVUKUWQVV
      QUXEGZVUKUWQVVKVYBVUKUWQVVPVVJGZVVKVYBOVVIVVEVBZTZVYDVUSTZVUKUWQVYCOZOZLV
      VEVVFUVAVVDNGZVYFUBVUSUBVUSVVDNUVBVYIVUTVUSGVVBVVCIWHYEUVCVYEVYFHVVIVUSTZ
      VYHVVIVYDVUSUVDVUKVYGVYJUWQVVPVUSUXLVEZGZOVUKUWQVYLVUKUWQHZVVPUYHUXEVEZVU
      RVJJZVYKVYMVVPVYOGZVURVYNVVPXIZVYMVURABUSZVVPXIZVYRVYNVAZVYQVYMQPGZSPGZHZ
      UWQVXJVYSWUCVYMWUAWUBUVEXLXTYEVUKUWQUVIVXJVYMXJYEQSABPPFFUVFUVGVYMVYRUYHV
      AZVYRUXEVAZVYTVYMAUYHGZBUYHGZHZWUDUWQWUHVUKUWOWUFUWPWUGFUYHAXOXPFUYHBXOXP
      XQYFUWQWUHWUDRVUKABUYHFFYGYFYHVYMUYPVUEHZWUEVUKWUIUWQVUEUYPUVHUVJUWQWUIWU
      ERVUKABUXEFFYGYFYHWUDWUEHVYTRVYMVYRUYHUXEUVKYEUVLVURVYRVYNVVPXSUVMVYNNGZV
      XQHVYPVYQRVYMWUJVXQUYHUXEUYLUVNVXRXTVYNVURVVPNNYAYOYBUYHUXEVURUYLVXRUVTYI
      YJVYJVYCVYLUWQVYJVVJVYKVVPVVIVUSUXLUVOVRUVPUVQYKUVRVVHVYBDVVPVVJUXGVVPTVV
      GVVQUXEUXGVVPLUVSWQUWAUWBYLUWCUWLUWDYKUWEYFUWFYMYKUWGUWHUWIYLUWJYJUWKYNYM
      YPYQYRYSYDYMYNYMYPYQYRYSYDUWMUXPCUWSUWRBIWHUWNYTUYIUYJUXHUYHUYHQUEMVOJVJJ
      VJJGUEPVKEUXCVFZUXSUXRRUYLVLEUEVMUYIUYJWUKWFUXDUXQUWSNUYHEDUEUXCUWTCVQVRV
      SYTYQYI @.
  @}

  @c derv @.

  @( Extend class notation with the relation "derives in one step". @)
  cderv @a class derv @.

  @{
    @d g x y u v p q @.
    @( The relation ` u ` derives ` v ` in one step in the grammar ` g ` .
       Experimental.  (Contributed by FL, 15-Jul-2012.) @)
    df-derv @a |- derv = ( g e. Grammar |-> { <. x , y >. | ( x e. (
     Kleene ` g ) /\ y e. ( Kleene ` g ) /\ E. u e. ( Kleene ` g ) E. v
     e. ( Kleene ` g ) E. p e. ( Kleene ` g ) E. q e. ( Kleene ` g ) ( x =
     ( ( u ( conc ` g ) p ) ( conc ` g ) v ) /\ <. p , q >. e. (
     prdct ` g ) /\ y = ( ( u ( conc ` g ) q ) ( conc ` g ) v ) ) ) }
     ) @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Planar geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @( The points of an incidence geometry. @)
  @c PPoints @.

  @( Extend class notation with the class of all Points. @)
  cpoints @a class PPoints @.

  @( Definition of PPoints.  (Contributed by FL, 1-Apr-2016.) @)
  df-points @a |- PPoints = Base @.

  @( The lines of an incidence geometry. @)
  @c PLines @.

  @( Extend class notation with the class of all Lines. @)
  cplines @a class PLines @.

  @( Definition of PLines.  (Contributed by FL, 1-Apr-2016.) @)
  df-plines @a |- PLines = Scalar @.

  @( An incidencence geometry. @)
  @c Ig @.

  @( Extend class notation with the class of all planar incidence
     geometries. @)
  cig @a class Ig @.

  @{
    @d f g h l x y z @.
    @( Definition of a geometry that can build on the axioms of incidence.
       Definition of an Incidence-Betweenness Geometry in [AitkenIBG] p. 1-2.
       (For my private use only.  Don't use.)  (Contributed by FL,
       1-Apr-2016.) @)
    df-ig2 @a |- Ig = { f | [. ( PPoints ` f ) / g ].
     [. ( PLines ` f ) / h ].
      ( A. l e. h l C_ g /\
       ( A. x e. g A. y e. g ( x =/= y -> E! l e. h ( x e. l /\ y e. l ) ) /\
         A. l e. h E. x e. g E. y e. g ( x =/= y /\ x e. l /\ y e. l ) /\
         E. x e. g E. y e. g E. z e. g ( ( x =/= y /\ y =/= z /\ x =/= z ) /\
           A. l e. h -. ( x e. l /\ y e. l /\ z e. l ) ) ) ) } @.
  @}

  @{
    @d f g h l x y z @.  @d f g I @.  @d g h l x y z L @.  @d g h l x y z P @.
    bisig0.1 @e |- P = ( PPoints ` I ) @.
    bisig0.2 @e |- L = ( PLines ` I ) @.
    @( Definition of a geometry that can build on the axioms of incidence.
       Definition of an Incidence-Betweenness Geometry in [AitkenIBG] p. 1-2.
       (For my private use only.  Don't use.)  (Contributed by FL,
       1-Apr-2016.) @)
    bisig0 @p |- ( I e. Ig <->
      ( I e. _V /\ ( A. l e. L l C_ P /\
        A. x e. P A. y e. P ( x =/= y -> E! l e. L ( x e. l /\ y e. l ) ) /\
        A. l e. L E. x e. P E. y e. P ( x =/= y /\ x e. l /\ y e. l ) ) /\
        E. x e. P E. y e. P E. z e. P ( ( x =/= y /\ y =/= z /\ x =/= z ) /\
          A. l e. L -. ( x e. l /\ y e. l /\ z e. l ) ) ) ) @=
      ( vg vh wcel cv wral wa w3a wrex wsbc wceq wb vf cig wss wne wreu cplines
      wi wn cfv cpoints cab cvv df-ig2 eleq2i fveq2 dfsbcq sbcbidv bitrd elab4g
      eqid eqcomi ax-mp sbcbii syl6bb fvex eqeltri simpr sseq2 adantr raleqbidv
      syl simpl biidd reubidvag imbi2d rexeqdv rexeqbidv raleqdv anbi2d anbi12d
      3anbi123d sbc2ie bitri anbi2i simprl simprr1 simprr2 simprr3 simp1 simp21
      3jca simp22 simp23 simp3 jca32 impbii 3bitri ) EUBLEGMZJMZUCZGKMZNZAMZBMZ
      UDZXCWRLZXDWRLZOZGXAUEZUGZBWSNZAWSNZXEXFXGPZBWSQZAWSQZGXANZXEXDCMZUDXCXQU
      DPZXFXGXQWRLPUHZGXANZOZCWSQZBWSQZAWSQZPZOZKUAMZUFUIZRZJYGUJUIZRZUAUKZLEUL
      LZYFKEUFUIZRZJEUJUIZRZOZYMWRDUCZGFNZXEXHGFUEZUGZBDNZADNZXMBDQZADQZGFNZPZX
      RXSGFNZOZCDQZBDQZADQZPZUBYLEABCUAJKGUMUNYKYQUAEYLYGESZYKYIJYPRZYQUUOYJYPS
      YKUUPTYGEUJUOYIJYJYPUPVKUUOYHYNSZUUPYQTYGEUFUOUUQYIYOJYPYFKYHYNUPUQVKURYL
      UTUSYRYMYTUUDUUGUUMPZOZOZUUNYQUUSYMYQYFKFRZJDRZUUSYPDSZYQUVBTDYPHVAUVCYQY
      OJDRUVBYOJYPDUPYOUVAJDYNFSYOUVATFYNIVAYFKYNFUPVBVCVDVBYFUUSJKDFDYPULHEUJV
      EVFFYNULIEUFVEVFWSDSZXAFSZOZXBYTYEUURUVFWTYSGXAFUVDUVEVGZUVDWTYSTUVEWSDWR
      VHVIVJUVFXLUUDXPUUGYDUUMUVFXKUUCAWSDUVDUVEVLZUVFXJUUBBWSDUVHUVFXIUUAXEUVF
      XHXHGXAFUVFXHVMUVGVNVOVJVJUVFXOUUFGXAFUVGUVFXNUUEAWSDUVHUVFXMBWSDUVHVPVQV
      JUVFYCUULAWSDUVHUVFYBUUKBWSDUVHUVFYAUUJCWSDUVHUVFXTUUIXRUVFXSGXAFUVGVRVSV
      QVQVQWAVTWBWCWDUUTUUNUUTYMUUHUUMYMUUSVLUUTYTUUDUUGYMYTUURWEUUDUUGUUMYTYMW
      FUUDUUGUUMYTYMWGWKUUDUUGUUMYTYMWHWKUUNYMYTUURYMUUHUUMWIYMYTUUDUUGUUMWJUUN
      UUDUUGUUMYMYTUUDUUGUUMWLYMYTUUDUUGUUMWMYMUUHUUMWNWKWOWPWCWQ @.
  @}


  @{
    isig.1 @e |- P = ( PPoints ` I ) @.
    isig.2 @e |- L = ( PLines ` I ) @.

    @{
      @d l x y z L @.  @d l x y z P @.
      isig1a2.1 @e |- ( ph -> I e. Ig ) @.
      @( A line is a set of points.  This axiom is not needed.  (Let's recall
         that the incidence relation can be formalized as an abstract
         relation.  And that the belonging relationship is only an
         interpretation.)  However, Wayne Aitken adds this axiom to his system
         and I will follow him.  The definitions below will take advantage of
         it.  (For my private use only.  Don't use.)  (Contributed by FL,
         2-Apr-2016.) @)
      isig1a2 @p |- ( ph -> A. l e. L l C_ P ) @=
        ( vx vy vz cig wcel cv wral wne wel wa w3a wrex wss wi wn bisig0 simp21
        cvv wreu sylbi syl ) ACLMZENBUAEDOZHUJCUFMZUKINZJNZPZIEQZJEQZREDUGUBJBO
        IBOZUOUPUQSJBTIBTEDOZSUOUNKNZPUMUTPSUPUQKEQSUCEDORKBTJBTIBTZSUKIJKBCDEF
        GUDULUKURUSVAUEUHUI @.
    @}


    @{
      @d l A @.  @d l L @.  @d l P @.
      isig12.1 @e |- ( ph -> I e. Ig ) @.
      isig12.2 @e |- ( ph -> A e. L ) @.
      @( A line is a set of points.  (For my private use only.  Don't use.)
         (Contributed by FL, 2-Apr-2016.) @)
      isig12 @p |- ( ph -> A C_ P ) @=
        ( vl wcel cv wss wral isig1a2 sseq1 rspcva syl2anc ) ABEKJLZCMZJENBCMZI
        ACDEJFGHOTUAJBESBCPQR @.
    @}

    @{
      @d l x y z L @.  @d l x y z P @.
      isig22.1 @e |- ( ph -> I e. Ig ) @.
      @( There is only one line passing through two distinct points.  (For my
         private use only.  Don't use.)  (Contributed by FL, 2-Apr-2016.) @)
      isig22 @p |- ( ph -> A. x e. P A. y e. P
         ( x =/= y -> E! l e. L ( x e. l /\ y e. l ) ) ) @=
        ( vz cig wcel cv wne wel wa wral w3a wrex wreu wi cvv wss bisig0 simp22
        wn sylbi syl ) AELMZBNZCNZOZBGPZCGPZQGFUAUBCDRBDRZJUJEUCMZGNDUDGFRZUPUM
        UNUOSCDTBDTGFRZSUMULKNZOUKUTOSUNUOKGPSUGGFRQKDTCDTBDTZSUPBCKDEFGHIUEUQU
        RUPUSVAUFUHUI @.
    @}

    @{
      @d l x y A @.  @d l y B @.  @d l x y L @.  @d l x y P @.
      isig2a2.1 @e |- ( ph -> I e. Ig ) @.
      isig2a2.2 @e |- ( ph -> A e. P ) @.
      isig2a2.3 @e |- ( ph -> B e. P ) @.
      isig2a2.4 @e |- ( ph -> A =/= B ) @.
      @( There is only one line passing through two distinct points.  (For my
         private use only.  Don't use.)  (Contributed by FL, 2-Apr-2016.) @)
      isig2a2 @p |- ( ph -> E! l e. L ( A e. l /\ B e. l ) ) @=
        ( vx vy wne cv wcel wa wreu wral isig22 wceq neeq1 eleq1 anbi1d reubidv
        wi imbi12d neeq2 anbi2d rspc2va syl21anc mpd ) ABCPZBGQZRZCUPRZSZGFTZMA
        BDRCDRNQZOQZPZVAUPRZVBUPRZSZGFTZUHZODUANDUAUOUTUHZKLANODEFGHIJUBVHVIBVB
        PZUQVESZGFTZUHNOBCDDVABUCZVCVJVGVLVABVBUDVMVFVKGFVMVDUQVEVABUPUEUFUGUIV
        BCUCZVJUOVLUTVBCBUJVNVKUSGFVNVEURUQVBCUPUEUKUGUIULUMUN @.
    @}

    @{
      @d l x y z L @.  @d l x y z P @.
      elhaltdp.1 @e |- ( ph -> I e. Ig ) @.
      @( Every line has at least two distinct points.  (For my private use
         only.  Don't use.)  (Contributed by FL, 28-Apr-2016.) @)
      elhaltdp @p |- ( ph -> A. l e. L E. x e. P E. y e. P
        ( x =/= y /\ x e. l /\ y e. l ) ) @=
        ( vz cig wcel cv wne wel w3a wrex wral wa cvv wss wreu wi bisig0 simp23
        wn sylbi syl ) AELMZBNZCNZOZBGPZCGPZQCDRBDRGFSZJUJEUAMZGNDUBGFSZUMUNUOT
        GFUCUDCDSBDSZUPQUMULKNZOUKUTOQUNUOKGPQUGGFSTKDRCDRBDRZQUPBCKDEFGHIUEUQU
        RUSUPVAUFUHUI @.
    @}

    @{
      @d l x y A @.  @d l x y L @.  @d l x y P @.
      elhaltdp2.1 @e |- ( ph -> I e. Ig ) @.
      elhaltdp2.2 @e |- ( ph -> A e. L ) @.
      @( Every line has at least two distinct points.  (For my private use
         only.  Don't use.)  (Contributed by FL, 28-Apr-2016.) @)
      elhaltdp2 @p |- ( ph -> E. x e. P E. y e. P
        ( x =/= y /\ x e. A /\ y e. A ) ) @=
        ( vl wcel cv wne w3a wrex wral elhaltdp eleq2 wceq 3anbi23d rspcv sylc
        2rexbidv ) ADGMBNZCNZOZUFLNZMZUGUIMZPZCEQBEQZLGRUHUFDMZUGDMZPZCEQBEQZKA
        BCEFGLHIJSUMUQLDGUIDUAZULUPBCEEURUJUNUKUOUHUIDUFTUIDUGTUBUEUCUD @.
    @}

    @{
      @d x y L @.  @d x y M @.  @d x y P @.
      elhalop2.1 @e |- ( ph -> I e. Ig ) @.
      elhalop2.2 @e |- ( ph -> M e. L ) @.
      @( Every line has at least one point.  (For my private use only.  Don't
         use.)  (Contributed by FL, 10-Aug-2016.) @)
      elhalop2 @p |- ( ph -> E. x e. P x e. M ) @=
        ( vy cv wne wcel w3a wrex elhaltdp2 simp2 rexlimivw reximi syl ) ABLZKL
        ZMZUBFNZUCFNZOZKCPZBCPUEBCPABKFCDEGHIJQUHUEBCUGUEKCUDUEUFRSTUA @.
    @}

    @{
      @d l x y z L @.  @d l x y z P @.
      tethpnc.1 @e |- ( ph -> I e. Ig ) @.
      @( There exists three non colinear points.  (For my private use only.
         Don't use.)  (Contributed by FL, 28-Apr-2016.) @)
      tethpnc @p |- ( ph -> E. x e. P E. y e. P E. z e. P
        ( ( x =/= y /\ y =/= z /\ x =/= z ) /\ A. l e. L
          -. ( x e. l /\ y e. l /\ z e. l ) ) ) @=
        ( cig wcel cv wne w3a wel wral wa wrex wn cvv wss wi bisig0 simp3bi syl
        wreu ) AFLMZBNZCNZOZUKDNZOUJUMOPBHQZCHQZDHQPUAHGRSDETCETBETZKUIFUBMHNEU
        CHGRULUNUOSHGUHUDCERBERULUNUOPCETBETHGRPUPBCDEFGHIJUEUFUG @.
    @}

    @{
      @d m x y z L @.  @d m M @.  @d m x y z P @.  @d x y z ph @.
      tethpnc2.1 @e |- ( ph -> I e. Ig ) @.
      tethpnc2.2 @e |- ( ph -> M e. L ) @.
      @( There exists three non colinear points.  (For my private use only.
         Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
      tethpnc2 @p |- ( ph -> E. x e. P E. y e. P E. z e. P
        ( ( x =/= y /\ y =/= z /\ x =/= z ) /\
          -. ( x e. M /\ y e. M /\ z e. M ) ) ) @=
        ( vm cv wne w3a wcel wrex eleq2 reximdv wn wral wa tethpnc wi 3anbi123d
        wceq notbid rspcv syl anim2d mpd ) ABNZCNZOUNDNZOUMUOOPZUMMNZQZUNUQQZUO
        UQQZPZUAZMGUBZUCZDERZCERZBERUPUMHQZUNHQZUOHQZPZUAZUCZDERZCERZBERABCDEFG
        MIJKUDAVFVNBEAVEVMCEAVDVLDEAVCVKUPAHGQVCVKUELVBVKMHGUQHUGZVAVJVOURVGUSV
        HUTVIUQHUMSUQHUNSUQHUOSUFUHUIUJUKTTTUL @.
    @}

    @{
      @d a b c x M @.  @d a b c L @.  @d a b c x P @.  @d a b c ph @.
      gltpntl.1 @e |- ( ph -> I e. Ig ) @.
      gltpntl.2 @e |- ( ph -> M e. L ) @.
      @( Remove. Keep the next one. @)
      @( Given a line, there exists a point not on this line.  (For my private
         use only.  Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
      gltpntl @p |- ( ph -> E. x e. P x e/ M ) @=
        ( va vb vc cv wcel wn wrex wnel wi com12 wne w3a wa tethpnc2 w3o 3ianor
        df-nel neleq1 rspcev ex adantr sylbir adantl expcom a1dd 3jaoi rexlimiv
        a1d sylbi rexlimivv syl ) AKNZLNZUAVCMNZUAVBVDUAUBZVBFOZVCFOZVDFOZUBPZU
        CZMCQZLCQKCQBNZFRZBCQZAKLMCDEFGHIJUDVKVNKLCCVKVBCOZVCCOZUCZVNVJVQVNSZMC
        VJVDCOZVRVIVSVRSZVEVIVFPZVGPZVHPZUEVTVFVGVHUFWAVTWBWCWAVBFRZVTVBFUGWDVR
        VSVQWDVNVOWDVNSVPVOWDVNVMWDBVBCVLVBFUHUIUJUKTURULWBVCFRZVTVCFUGWEVRVSVQ
        WEVNVPWEVNSVOVPWEVNVMWEBVCCVLVCFUHUIUJUMTURULWCVDFRZVTVDFUGWFVSVNVQVSWF
        VNVMWFBVDCVLVDFUHUIUNUOULUPUSUMTUQTUTVA @.
    @}

    @{
      @d x M @.  @d x P @.
      gltpntl2.1 @e |- ( ph -> I e. Ig ) @.
      gltpntl2.2 @e |- ( ph -> M e. L ) @.
      @( Given a line, there exists a point not on this line.  (For my private
         use only.  Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
      gltpntl2 @p |- ( ph -> E. x x e. ( P \ M ) ) @=
        ( cv wnel wrex cdif wcel wex gltpntl wa df-rex wn eldif biimpri sylan2b
        df-nel eximi sylbi syl ) ABKZFLZBCMZUHCFNOZBPZABCDEFGHIJQUJUHCOZUIRZBPU
        LUIBCSUNUKBUIUMUHFOTZUKUHFUDUKUMUORUHCFUAUBUCUEUFUG @.
    @}

  @}


  @{
    @d x M @.  @d x I @.  @d x L @.
    alne.1 @e |- ( ph -> I e. Ig ) @.
    alne.2 @e |- L = ( PLines ` I ) @.
    alne.3 @e |- ( ph -> M e. L ) @.
    @( A line is not empty.  (Contributed by FL, 10-Aug-2016.) @)
    aline @p |- ( ph -> M =/= (/) ) @=
      ( vx cv wcel wex c0 wne cpoints cfv wrex eqid elhalop2 rexex syl sylibr
      n0 ) AHIDJZHKZDLMAUCHBNOZPUDAHUEBCDUEQFEGRUCHUESTHDUBUA @.
  @}

  @{
    @d x P @.  @d w x y z I @.  @d w x y z P @.
    tpne.1 @e |- P = ( PPoints ` I ) @.
    tpne.2 @e |- ( ph -> I e. Ig ) @.
    @( The plane is not empty.  Exercise 5 of [AitkenIBG] p. 4.  (For my
       private use only.  Don't use.)  (Contributed by FL, 29-Apr-2016.) @)
    tpne @p |- ( ph -> P =/= (/) ) @=
      ( vx vy vz vw cv wne w3a wel wn cplines cfv wral wa wrex c0 tethpnc rexn0
      eqid syl ) AFJZGJZKUFHJZKUEUGKLFIMGIMHIMLNICOPZQRHBSGBSZFBSBTKAFGHBCUHIDU
      HUCEUAUIFBUBUD @.
  @}

  @( Function returning the line passing through two points. @)
  @c line @.

  @( Extend class notation with the class of all lines. @)
  cline @a class line @.

  @{
    @d f x y l @.
    @( Definition of the line xy.  It also defines a degenerate line.
       Definition 4 of [AitkenIBG] p. 2.  (For my private use only.  Don't
       use.)  (Contributed by FL, 2-Apr-2016.) @)
    df-li @a |- line = ( f e. Ig |->
      ( x e. ( PPoints ` f ) , y e. ( PPoints ` f ) |-> if ( x =/= y ,
      ( iota_ l e. ( PLines ` f ) ( x e. l /\ y e. l ) ) , { x } ) ) ) @.
  @}

  @{
    lineval2.1 @e |- P = ( PPoints ` G ) @.
    lineval2.2 @e |- L = ( PLines ` G ) @.
    lineval2.3 @e |- M = ( line ` G ) @.
    lineval2.4 @e |- ( ph -> G e. Ig ) @.

    @{
      @d f l x y G @.  @d f l L @.  @d f x y P @.
      @( Definition of the line xy.  It also defines a degenerate line.  (For
         my private use only.  Don't use.)  (Contributed by FL,
         25-Feb-2016.) @)
      linevala2 @p |- ( ph ->
       M = ( x e. P , y e. P |-> if ( x =/= y ,
    ( iota_ l e. L ( x e. l /\ y e. l ) ) , { x } ) ) ) @=
        ( vf cline cfv cv wcel cvv cpoints cplines wne wel wa csn cif cmpt2 cig
        crio wceq fvex eqeltri pm3.2i mpt2exga mp1i fveq2 riotaeqdv mpt2eq123dv
        syl6eqr ifeq1d df-li fvmptg syl2anc syl5eq ) AGENOZBCDDBPZCPUAZBHUBCHUB
        UCZHFUHZVEUDZUEZUFZKAEUGQVKRQZVDVKUILDRQZVMUCVLAVMVMDESOZRIESUJUKZVOULB
        CDDVJRRUMUNMEBCMPZSOZVQVFVGHVPTOZUHZVIUEZUFVKUGRNVPEUIZBCVQVQVTDDVJWAVQ
        VNDVPESUOIURZWBWAVFVSVHVIWAVGHVRFWAVRETOFVPETUOJURUPUSUQBCMHUTVAVBVC @.
    @}

    @{
      @d l x y A @.  @d l x y B @.  @d l x y G @.  @d l x y L @.  @d l ph @.
      @d x y P @.
      lineval2.5 @e |- ( ph -> A e. P ) @.
      lineval2.6 @e |- ( ph -> B e. P ) @.
      lineval2.7 @e |- ( ph -> A =/= B ) @.
      @( The line passing through two distinct points ` A ` and ` B ` .  (For
         my private use only.  Don't use.)  (Contributed by FL,
         25-Feb-2016.) @)
      lineval222 @p |- ( ph ->
        ( A M B ) = ( iota_ l e. L ( A e. l /\ B e. l ) ) ) @=
        ( vx vy co wcel wceq cline cfv cv wne crio csn cif cmpt2 a1i oveqd eqid
        wa linevala2 cvv riotaex snex ifex simpl simpr neeq12d eleq1d riotabidv
        anbi12d sneq adantr ifbieq12d ovmpt2ga syl3anc iftrue syl eqtrd 3eqtrd
        ) ABCGRBCEUAUBZRBCPQDDPUCZQUCZUDZVNHUCZSZVOVQSZULZHFUEZVNUFZUGZUHZRZBVQ
        SZCVQSZULZHFUEZAGVMBCGVMTAKUIUJAVMWDBCAPQDEFVMHIJVMUKLUMUJAWEBCUDZWIBUF
        ZUGZWIABDSCDSWLUNSZWEWLTMNWMAWJWIWKWHHFUOBUPUQUIPQBCDDWCWLWDUNVNBTZVOCT
        ZULZVPWJWAWBWIWKWPVNBVOCWNWOURZWNWOUSZUTWPVTWHHFWPVRWFVSWGWPVNBVQWQVAWP
        VOCVQWRVAVCVBWNWBWKTWOVNBVDVEVFWDUKVGVHAWJWLWITOWJWIWKVIVJVKVL @.

    @}

    @{
      @d l x A @.  @d l x B @.  @d l G @.  @d l x L @.  @d l x N @.  @d l P @.
      @d l ph @.
      lineval42.5 @e |- ( ph -> A e. P ) @.
      lineval42.6 @e |- ( ph -> B e. P ) @.
      lineval42.7 @e |- ( ph -> A =/= B ) @.
      lineval42.8 @e |- ( ph -> A e. N ) @.
      lineval42.9 @e |- ( ph -> B e. N ) @.
      lineval42.a @e |- ( ph -> N e. L ) @.
      @( Any line to which ` A ` and ` B ` are incident is the line
         ` ( A M B ) ` .  (For my private use only.  Don't use.)  (Contributed
         by FL, 1-Apr-2016.) @)
      lineval42 @p |- ( ph -> N = ( A M B ) ) @=
        ( vl wcel co cv wa crio lineval222 wceq wb isig2a2 eleq2 anbi12d riota2
        wreu syl2anc mpbi2and eqtr2d ) ABCGUABSUBZTZCUPTZUCZSFUDZHABCDEFGSIJKLM
        NOUEABHTZCHTZUTHUFZPQAHFTUSSFULVAVBUCZVCUGRABCDEFSIJLMNOUHUSVDSFHUPHUFU
        QVAURVBUPHBUIUPHCUIUJUKUMUNUO @.

    @}

    @{
      @d x A @.  @d x B @.  @d x G @.  @d x L @.  @d x P @.  @d x ph @.
      lineval12.5 @e |- ( ph -> A e. P ) @.
      lineval12.6 @e |- ( ph -> B e. P ) @.
      lineval12.7 @e |- ( ph -> A =/= B ) @.
      @( The line passing through two distinct points ` A ` and ` B ` is a
         line.  (For my private use only.  Don't use.)  (Contributed by FL,
         25-Feb-2016.) @)
      lineval12 @p |- ( ph -> ( A M B ) e. L ) @=
        ( vx co cv wcel wa crio lineval222 wreu isig2a2 riotacl syl eqeltrd ) A
        BCGPBOQZRCUGRSZOFTZFABCDEFGOHIJKLMNUAAUHOFUBUIFRABCDEFOHIKLMNUCUHOFUDUE
        UF @.
    @}

    @{
      @d l x A @.  @d l y A @.  @d l x B @.  @d l G @.  @d l y L @.  @d l P @.
      @d l ph @.  @d y B @.
      lineval22.5 @e |- ( ph -> A e. P ) @.
      lineval22.6 @e |- ( ph -> B e. P ) @.
      lineval22.7 @e |- ( ph -> A =/= B ) @.
      @( The points ` A ` and ` B ` belong to the line passing through two
         distinct points ` A ` and ` B ` .  (For my private use only.  Don't
         use.)  (Contributed by FL, 25-Feb-2016.) @)
      lineval22 @p |- ( ph ->
        ( A e. ( A M B ) /\ B e. ( A M B ) ) ) @=
        ( vl wcel wa nfel2 eleq2 anbi12d co cv crio wreu isig2a2 nfan eqid wceq
        nfriota1 riotaprop syl simprd lineval222 eleq2d mpbird ) ABBCGUAZPZCUPP
        ZQBBOUBZPZCUSPZQZOFUCZPZCVCPZQZAVCFPZVFAVBOFUDVGVFQABCDEFOHIKLMNUEVBVFO
        FVCVDVEOOBVCVBOFUIZROCVCVHRUFVCUGUSVCUHUTVDVAVEUSVCBSUSVCCSTUJUKULAUQVD
        URVEAUPVCBABCDEFGOHIJKLMNUMZUNAUPVCCVIUNTUO @.
    @}

  @}

  @{
    @d x y z A @.  @d x y z G @.  @d x y P @.
    lineval3a.1 @e |- P = ( PPoints ` G ) @.
    lineval3a.3 @e |- M = ( line ` G ) @.
    lineval3a.4 @e |- ( ph -> G e. Ig ) @.
    lineval3a.5 @e |- ( ph -> A e. P ) @.
    @( Value of a degenerate line.  (For my private use only.  Don't use.)
       (Contributed by FL, 25-Feb-2016.) @)
    lineval3a @p |- ( ph -> ( A M A ) = { A } ) @=
      ( vx vy vz co cv wne wcel wa crio csn wceq cplines cfv cif eqid linevala2
      cmpt2 oveqd cvv riotaex snex simpl simpr neeq12d eleq1d anbi12d riotabidv
      ifex a1i sneq adantr ifbieq12d ovmpt2ga syl3anc neirr iffalse mp1i 3eqtrd
      wn ) ABBEMBBJKCCJNZKNZOZVILNZPZVJVLPZQZLDUAUBZRZVISZUCZUFZMZBBOZBVLPZWCQZ
      LVPRZBSZUCZWFAEVTBBAJKCDVPELFVPUDGHUEUGABCPZWHWGUHPZWAWGTIIWIAWBWEWFWDLVP
      UIBUJUQURJKBBCCVSWGVTUHVIBTZVJBTZQZVKWBVQVRWEWFWLVIBVJBWJWKUKZWJWKULZUMWL
      VOWDLVPWLVMWCVNWCWLVIBVLWMUNWLVJBVLWNUNUOUPWJVRWFTWKVIBUSUTVAVTUDVBVCWBVH
      WGWFTABVDWBWEWFVEVFVG @.
  @}

  @{
    lineval12a.1 @e |- P = ( PPoints ` G ) @.
    lineval12a.3 @e |- M = ( line ` G ) @.
    lineval12a.4 @e |- ( ph -> G e. Ig ) @.
    lineval12a.5 @e |- ( ph -> A e. P ) @.
    lineval12a.6 @e |- ( ph -> B e. P ) @.
    @( The line passing through two distinct points ` A ` and ` B ` is a set of
       points .  (For my private use only.  Don't use.)  (Contributed by FL,
       25-Feb-2016.) @)
    lineval12a @p |- ( ph -> ( A M B ) C_ P ) @=
      ( co wss wi wceq csn lineval3a snssd wcel adantl eqsstrd oveq1 sseq1d wne
      syl5ibr wa cplines cfv eqid cig simpl lineval12 isig12 ex pm2.61ine ) ABC
      FLZDMZNBCAUQBCOZCCFLZDMAUSCPDACDEFGHIKQACDKRUAURUPUSDBCCFUBUCUEBCUDZAUQUT
      AUFZUPDEEUGUHZGVBUIZAEUJSUTITZVABCDEVBFGVCHVDABDSUTJTACDSUTKTUTAUKULUMUNU
      O @.
  @}


  @{
    lineval2a.1 @e |- P = ( PPoints ` G ) @.
    lineval2a.3 @e |- M = ( line ` G ) @.
    lineval2a.4 @e |- ( ph -> G e. Ig ) @.
    lineval2a.5 @e |- ( ph -> A e. P ) @.
    lineval2a.6 @e |- ( ph -> B e. P ) @.
    @( The point ` A ` belongs to the line passing through it .  (For my
       private use only.  Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
    lineval2a @p |- ( ph -> A e. ( A M B ) ) @=
      ( co wcel wi wceq csn snidg syl lineval3a adantl oveq2 eqcoms syl5ibr wne
      eleqtrrd eleq2d wa cplines cfv eqid cig simpl lineval22 simpld pm2.61ine
      ex ) ABBCFLZMZNBCAURBCOZBBBFLZMABBPZUTABDMZBVAMJBDQRABDEFGHIJSUEUSUQUTBUQ
      UTOCBCBBFUAUBUFUCBCUDZAURVCAUGZURCUQMVDBCDEEUHUIZFGVEUJHAEUKMVCITAVBVCJTA
      CDMVCKTVCAULUMUNUPUO @.

    @( The point ` B ` belongs to the line passing through it .  (For my
       private use only.  Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
    lineval2b @p |- ( ph -> B e. ( A M B ) ) @=
      ( co wcel wi wceq lineval2a oveq1 eleq2d syl5ibr adantl wne cplines simpl
      wa cfv eqid cig lineval22 simprd ex pm2.61ine ) ACBCFLZMZNBCAUMBCOZCCCFLZ
      MACCDEFGHIKKPUNULUOCBCCFQRSBCUAZAUMUPAUDZBULMUMUQBCDEEUBUEZFGURUFHAEUGMUP
      ITABDMUPJTACDMUPKTUPAUCUHUIUJUK @.
  @}


  @{
    @d l A @.  @d l B @.  @d l G @.  @d l ph @.
    lineval4a.1 @e |- P = ( PPoints ` G ) @.
    lineval4a.3 @e |- M = ( line ` G ) @.
    lineval4a.4 @e |- ( ph -> G e. Ig ) @.
    lineval4a.5 @e |- ( ph -> A e. P ) @.
    lineval4a.6 @e |- ( ph -> B e. P ) @.
    @{
      @( The line AB is the line BA. (For my private use only.  Don't use.)
         (Contributed by FL, 20-May-2016.) @)
      lineval4a @p |- ( ph -> ( A M B ) = ( B M A ) ) @=
        ( vl co wceq biimpi wne wa wcel crio adantl wi oveq2d oveq1d eqtr4d a1d
        eqcom cv cplines cfv wb ancom a1i riotabidv eqid simpl lineval222 necom
        cig adantr 3eqtr4d ex pm2.61ine ) ABCFMZCBFMZNZUABCBCNZVEAVFVCBBFMVDVFC
        BBFVFCBNBCUFOZUBVFCBBFVGUCUDUEBCPZAVEVHAQZBLUGZRZCVJRZQZLEUHUIZSVLVKQZL
        VNSVCVDVIVMVOLVNVMVOUJVIVKVLUKULUMVIBCDEVNFLGVNUNZHAEURRVHITZABDRVHJTZA
        CDRVHKTZVHAUOUPVICBDEVNFLGVPHVQVSVRVHCBPZAVHVTBCUQOUSUPUTVAVB @.
    @}

    @{
      lineval5a.7 @e |- ( ph -> C e. ( A M B ) ) @.
      lineval5a.8 @e |- ( ph -> C =/= B ) @.
      @( If ` C ` is a point of AB, AB = CB. (For my private use only.  Don't
         use.)  (Contributed by FL, 20-May-2016.) @)
      lineval5a @p |- ( ph -> ( A M B ) = ( C M B ) ) @=
        ( co wne wcel wceq wi eleq2d cfv eqid lineval12a sseldd lineval2b oveq1
        cplines csn lineval3a cvv wb elex elsncg 3syl wn df-ne pm2.21 sylbi syl
        sylbid com12 syl6bi com3l mpcom idd pm2.61dne lineval12 lineval42 ) ADC
        EFFUGUAZGBCGOZHVIUBZIJAVJEDABCEFGHIJKLUCMUDLNMABCEFGHIJKLUEABCEFVIGHVKI
        JKLABCPZBCDVJQZABCRZVLSMVNVMAVLVNVMDCCGOZQZAVLSVNVJVODBCCGUFTAVPVLAVPDC
        UHZQZVLAVOVQDACEFGHIJLUITAVRDCRZVLAVMDUJQVRVSUKMDVJULDCUJUMUNADCPZVSVLS
        ZNVTVSUOWADCUPVSVLUQURUSUTUTVAVBVCVDAVLVEVFVGVH @.

    @}

    @{
      lineval6a.7 @e |- ( ph -> C e. ( A M B ) ) @.
      lineval6a.8 @e |- ( ph -> A =/= C ) @.
      @( If ` C ` is a point of AB, AB = AC (For my private use only.  Don't
         use.)  (Contributed by FL, 20-May-2016.) @)
      lineval6a @p |- ( ph -> ( A M B ) = ( A M C ) ) @=
        ( co wne wcel wceq wi eqcoms cfv eqid lineval12a sseldd lineval2a oveq2
        cplines eleq2d csn lineval3a cvv elex elsncg biimpd df-ne pm2.24 syl5bi
        3syl wn com12 sylsyld sylbid syl6bi com3l mpcom idd pm2.61dne lineval12
        lineval42 ) ABDEFFUGUAZGBCGOZHVJUBZIJKAVKEDABCEFGHIJKLUCMUDNABCEFGHIJKL
        UEMABCEFVJGHVLIJKLABCPZBCDVKQZABCRZVMSMVOVNAVMVOVNDBBGOZQZAVMSVOVKVPDVK
        VPRCBCBBGUFTUHAVQVMAVQDBUIZQZVMAVPVRDABEFGHIJKUJUHABDPZVSDBRZVMNAVNDUKQ
        ZVSWASMDVKULWBVSWADBUKUMUNURWAVTVMVTVMSBDVTBDRZUSWCVMBDUOWCVMUPUQTUTVAV
        BUTVCVDVEAVMVFVGVHVI @.
    @}

  @}

  @( The colinear relationship. @)
  @c coln @.

  @( Extend class notation with the class of all collinear points sets. @)
  ccol @a class coln @.

  @{
    @d f x l @.
    @( Definition of collinear points.  Definition 5 of [AitkenIBG] p. 3.
       (Contributed by FL, 1-Apr-2016.) @)
    df-col @a |- coln = ( f e. Ig |->
      { x | E. l e. ( PLines ` f ) x C_ l } ) @.
  @}

  @{
    iscola2.1 @e |- ( ph -> G e. Ig ) @.

    @{
      @d f l x G @.
      @( The predicate "being collinear points".  (For my private use only.
         Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
      iscola2 @p |- ( ph -> ( coln ` G ) =
      { x | E. l e. ( PLines ` G ) x C_ l } ) @=
        ( vf cig wcel cv wss cplines cfv wrex cab cvv ccol wceq ciun iunab wral
        fvex a1i wa pm4.24 abbii abssexg syl5eqel rgen iunexg sylancl syl5eqelr
        fveq2 rexeqdv abbidv df-col fvmptg syl2anc ) ACGHBIDIZJZDCKLZMZBNZOHCPL
        VBQEAVBDUTUSBNZRZOUSDBUTSAUTOHZVCOHZDUTTVDOHVEACKUAUBVFDUTURUTHVCUSUSUC
        ZBNOUSVGBUSUDUEUSBURUTUFUGUHDUTVCOOUIUJUKFCUSDFIZKLZMZBNVBGOPVHCQZVJVAB
        VKUSDVIUTVHCKULUMUNBFDUOUPUQ @.
    @}

    @{
      @d l w A @.  @d l w G @.
      iscola2.2 @e |- ( ph -> A e. B ) @.
      @( The predicate "being collinear points".  (For my private use only.
         Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
      iscol2 @p |- ( ph -> ( A e. ( coln ` G ) <->
       E. l e. ( PLines ` G ) A C_ l ) ) @=
        ( vw ccol cfv wcel cv wss cplines wrex cab iscola2 eleq2d wb wceq sseq1
        rexbidv elabg syl bitrd ) ABDIJZKBHLZELZMZEDNJZOZHPZKZBUHMZEUJOZAUFULBA
        HDEFQRABCKUMUOSGUKUOHBCUGBTUIUNEUJUGBUHUAUBUCUDUE @.
    @}

    @{
      @d l x A @.  @d l G @.  @d l x P @.  @d l ph @.
      iscola3.2 @e |- ( ph -> A e. ( coln ` G ) ) @.
      iscola3.3 @e |- P = ( PPoints ` G ) @.
      @( Collinear points are points.  (For my private use only.  Don't use.)
         (Contributed by FL, 20-May-2016.) @)
      iscol3 @p |- ( ph -> A. x e. A x e. P ) @=
        ( vl ccol cfv wcel cv wss wi wa eqid ex com3l pm2.43a wral cplines wrex
        iscol2 cpoints cig adantr simpr isig12 wceq sstr sseq2 wb dfss3 biimpcd
        a1i syl6bir mpsyl syl rexlimiv syl6bi mpd ) ACEJKZLZBMDLBCUAZGVDAVEAVDC
        IMZNZIEUBKZUCAVEOZACVCEIFGUDVGVIIVHAVFVHLZVGVEVJAVGVEOZAVJAVKOZAVJPZVFE
        UEKZNZVLVMVFVNEVHVNQVHQAEUFLVJFUGAVJUHUIVGVOAVEVGVOVIDVNUJZVGVOPCVNNZVI
        HCVFVNUKVPVQCDNZVIDVNCULAVRVEVRVEUMABCDUNUPUOUQURRSUSRTSUTVATVB @.
    @}

  @}

  @( Fonction returning the concurrent lines. @)
  @c con @.

  @( Extend class notation with the class of all concurrent lines. @)
  ccon2 @a class con @.

  @{
    @d f x @.
    @( Definition of concurrent lines.  Definition 6 of [AitkenIBG] p. 3.  (For
       my private use only.  Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
    df-con2 @a |- con = ( f e. Ig |->
      { x e. ~P ( PLines ` f ) | |^| x =/= (/) } ) @.
  @}

  @{
    isconclb @e |- ( ph -> F e. Ig ) @.
    @{
      @d f x F @.
      @( The predicate "are concurrent lines".  (For my private use only.
         Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
      isconcl1b @p |- ( ph -> ( con ` F ) =
        { x e. ~P ( PLines ` F ) | |^| x =/= (/) } ) @=
        ( vf cig wcel ccon2 cfv cv cint wne cplines crab wceq fveq2 pweqd biidd
        c0 cpw rabeqbidv df-con2 fvex pwex rabex fvmpt syl ) ACFGCHIBJKSLZBCMIZ
        TZNZODECUHBEJZMIZTZNUKFHULCOZUHUHBUNUJUOUMUIULCMPQUOUHRUABEUBUHBUJUICMU
        CUDUEUFUG @.
    @}

    @{
      @d x A @.  @d x F @.
      @( The predicate "are concurrent lines".  (For my private use only.
         Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
      isconcl2b @p |- ( ph -> ( A e. ( con ` F ) <->
        ( A e. ~P ( PLines ` F ) /\ |^| A =/= (/) ) ) ) @=
        ( vx ccon2 cfv wcel cv cint c0 wne cplines cpw crab wa isconcl1b eleq2d
        wceq inteq neeq1d elrab syl6bb ) ABCFGZHBEIZJZKLZECMGNZOZHBUHHBJZKLZPAU
        DUIBAECDQRUGUKEBUHUEBSUFUJKUEBTUAUBUC @.
    @}

    @{
      isconcl3.1 @e |- ( ph -> A e. ( con ` F ) ) @.
      @( Only lines can be concurrent.  (For my private use only.  Don't use.)
         (Contributed by FL, 25-Feb-2016.) @)
      isconcl3b @p |- ( ph -> A C_ ( PLines ` F ) ) @=
        ( cplines cfv cpw wcel wss c0 wne ccon2 wa isconcl2b mpbid simpld elpwi
        cint syl ) ABCFGZHIZBUAJAUBBSKLZABCMGIUBUCNEABCDOPQBUART @.
    @}

    @{
      isconcl4.1 @e |- ( ph -> A e. ( con ` F ) ) @.
      @( Concurrent lines have at least one point in common.  (For my private
         use only.  Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
      isconcl4b @p |- ( ph -> |^| A =/= (/) ) @=
        ( cplines cfv cpw wcel cint c0 wne ccon2 wa isconcl2b mpbid simprd ) AB
        CFGHIZBJKLZABCMGIRSNEABCDOPQ @.
    @}

  @}

@(
  %( The parallel relationship. %)
  %c ||g %.

  %( Extend class notation with the "parallel" relation. %)
  cppg %a class ||g %.
@)

  @{
    isconcl5a.1 @e |- L = ( PLines ` F ) @.
    isconcl5a.2 @e |- P = ( PPoints ` F ) @.
    isconcl5a.3 @e |- ( ph -> F e. Ig ) @.
    isconcl5a.4 @e |- ( ph -> L1 e. L ) @.
    isconcl5a.5 @e |- ( ph -> L2 e. L ) @.
    isconcl5a.6 @e |- ( ph -> L1 =/= L2 ) @.

    @{
      @d p q L1 @.  @d p q L2 @.  @d p q P @.  @d p q ph @.
      @( Two distinct lines intersect in at most one point.  Proposition 4 of
         [AitkenIBG] p. 3.  (For my private use only.  Don't use.)
         (Contributed by FL, 25-Feb-2016.) @)
      isconcl5a @p |- ( ph -> E* p ( p e. P /\ p e. L1 /\ p e. L2 ) ) @=
        ( vq wcel w3a wa wi wal adantl cv wsbc wceq wmo vex eleq1 3anbi123d idd
        sbcie a1ii com14 wne wn cline cfv co cig simpl31 simpl21 simpl1 simpl32
        eqid simpl22 lineval42 simpl33 simpl23 eqtr4d neneqd jca ex pm2.24 syl6
        imp 3exp pm2.61ine sylbi impcom com12 alrimivv wsb nfv mo3 sbsbc anbi2i
        imbi1i 2albii bitri sylibr ) AEUAZBOZWIFOZWIGOZPZWMENUAZUBZQZWIWNUCZRZN
        SESZWMEUDZAWRENWPAWQWOWMAWQRZWOWNBOZWNFOZWNGOZPZWMXARZWMXEEWNNUEWQWJXBW
        KXCWLXDWIWNBUFWIWNFUFWIWNGUFUGUIXEXFRWIWNAXEWMWQWQAXEWMWQWQRRWMWQUHUJUK
        WIWNULZXEWMXAXGXEWMPZAFGUCZXIUMZQZWQXHAXKXHAQZXIXJXLFWIWNCUNUOZUPGXLWIW
        NBCDXMFIHXMVBZACUQOXHJTZWJWKWLXGXEAURZXBXCXDXGWMAUSZXGXEWMAUTZWJWKWLXGX
        EAVAXBXCXDXGWMAVCAFDOXHKTVDXLWIWNBCDXMGIHXNXOXPXQXRWJWKWLXGXEAVEXBXCXDX
        GWMAVFAGDOXHLTVDVGAXJXHAFGMVHTVIVJXIXJWQXIWQVKVMVLVNVOVPVQVRVSWTWMWMENV
        TZQZWQRZNSESWSWMENWMNWAWBYAWRENXTWPWQXSWOWMWMENWCWDWEWFWGWH @.
    @}

    @{
      @d p q L1 @.  @d p q L2 @.  @d p q ph @.
      @( Two distinct lines intersect in at most one point.  Proposition 4 of
         [AitkenIBG] p. 3.  (For my private use only.  Don't use.)
         (Contributed by FL, 25-Feb-2016.) @)
      isconcl5ab @p |- ( ph -> E* p ( p e. L1 /\ p e. L2 ) ) @=
        ( vq wcel wa wi wal adantl com12 cv weq wmo vex eleq1 anbi12d sbcie idd
        wsbc a1ii com14 wne w3a wceq wn cline cfv co eqid isig12 sseld 3ad2ant3
        cig adantr imp 3ad2ant2 simpl1 simpl3l simpl2l lineval42 simpl3r eqtr4d
        simpl2r neneqd jca pm2.24 syl6 3exp pm2.61ine sylbi impcom alrimivv wsb
        ex nfv mo3 sbsbc anbi2i imbi1i 2albii bitri sylibr ) AEUAZFOZWMGOZPZWPE
        NUAZUIZPZENUBZQZNRERZWPEUCZAXAENWSAWTWRWPAWTQZWRWQFOZWQGOZPZWPXDQZWPXGE
        WQNUDWTWNXEWOXFWMWQFUEWMWQGUEUFUGXGXHQWMWQAXGWPWTWTAXGWPWTWTQQWPWTUHUJU
        KWMWQULZXGWPXDXIXGWPUMZAFGUNZXKUOZPZWTXJAXMXJAPZXKXLXNFWMWQCUPUQZURGXNW
        MWQBCDXOFIHXOUSZACVCOXJJSZXJAWMBOZWPXIAXRQZXGWNXSWOAWNXRAFBWMAFBCDIHJKU
        TZVATVDVBVEZXJAWQBOZXGXIAYBQZWPXEYCXFAXEYBAFBWQXTVATVDVFVEZXIXGWPAVGZWN
        WOXIXGAVHXEXFXIWPAVIAFDOXJKSVJXNWMWQBCDXOGIHXPXQYAYDYEWNWOXIXGAVKXEXFXI
        WPAVMAGDOXJLSVJVLAXLXJAFGMVNSVOWDXKXLWTXKWTVPVEVQVRVSVTWATWBXCWPWPENWCZ
        PZWTQZNRERXBWPENWPNWEWFYHXAENYGWSWTYFWRWPWPENWGWHWIWJWKWL @.
    @}

    @{
      @d p L1 @.  @d p L2 @.  @d p P @.  @d p ph @.
      isconcl6a.1 @e |- ( ph -> ( L1 i^i L2 ) =/= (/) ) @.
      @( Two distinct non-parallel lines intersect in one and only point.
         Proposition 4 of [AitkenIBG] p. 3.  (For my private use only.  Don't
         use.)  (Contributed by FL, 25-Feb-2016.) @)
      isconcl6a @p |- ( ph -> E! p ( p e. P /\ p e. L1 /\ p e. L2 ) ) @=
        ( wcel w3a wex wi sylbi com12 cv wmo weu isconcl5a df-mo cin c0 wne wss
        n0 isig12 elin ssel impcom 3adant2 simp1 simp2 3jca 3expia eximdv mpcom
        wa syl imim1i ) EUAZBOZVEFOZVEGOZPZEUBZAVIEUCZABCDEFGHIJKLMUDVJVIEQZVKR
        AVKRVIEUEAVLVKFGUFZUGUHZAVLNVNVEVMOZEQZAVLREVMUJAVPVLAFBUIZVPVLRAFBCDIH
        JKUKVQVOVIEVOVQVIVOVGVHVBVQVIRVEFGULVGVHVQVIVGVHVQPVFVGVHVGVQVFVHVQVGVF
        FBVEUMUNUOVGVHVQUPVGVHVQUQURUSSTUTVCTSVAVDSVA @.
    @}


    @{
      @d p L1 @.  @d p L2 @.  @d p ph @.
      isconcl6ab.1 @e |- ( ph -> ( L1 i^i L2 ) =/= (/) ) @.
      @( Two distinct non-parallel lines intersect in one and only point.
         Proposition 4 of [AitkenIBG] p. 3.  (For my private use only.  Don't
         use.)  (Contributed by FL, 25-Feb-2016.) @)
      isconcl6ab @p |- ( ph -> E! p ( p e. L1 /\ p e. L2 ) ) @=
        ( cv wcel wex wi sylbi mpcom wa wmo weu isconcl5ab df-mo cin c0 n0 elin
        wne biimpi eximi a1d imim1i ) EOZFPUOGPUAZEUBZAUPEUCZABCDEFGHIJKLMUDUQU
        PEQZURRAURRUPEUEAUSURFGUFZUGUJZAUSNVAUOUTPZEQZAUSREUTUHVCUSAVBUPEVBUPUO
        FGUIUKULUMSTUNST @.
    @}

  @}

  @{
    @d x L1 @.  @d x L2 @.  @d x X @.  @d x ph @.
    isconcl7a.1 @e |- L = ( PLines ` G ) @.
    isconcl7a.3 @e |- ( ph -> G e. Ig ) @.
    isconcl7a.4 @e |- ( ph -> L1 e. L ) @.
    isconcl7a.5 @e |- ( ph -> L2 e. L ) @.
    isconcl7a.6 @e |- ( ph -> L1 =/= L2 ) @.
    isconcl7a.7 @e |- ( ph -> X e. ( L1 i^i L2 ) ) @.
    @( Two distinct non-parallel lines intersect in one and only point.  (For
       my private use only.  Don't use.)  (Contributed by FL, 25-Feb-2016.) @)
    isconcl7a @p |- ( ph -> ( L1 i^i L2 ) = { X } ) @=
      ( vx wcel wb wal wi wa syl sylibr cv cin csn wceq weu wex cpoints eqid c0
      cfv wne ne0i isconcl6ab elin eubii wrex eleq1 rexsng mpbird df-rex bitr4i
      exancom eupicka syl2anc wral ralsng df-ral sylib albiim sylanbrc dfcleq )
      AMUAZEFUBZNZVLDUCZNZOMPZVMVOUDAVNVPQMPZVPVNQMPZVQAVNMUEZVNVPRMUFZVRAVLENV
      LFNRZMUEVTABUGUJZBCMEFGWCUHHIJKADVMNZVMUIUKLVMDULSUMVNWBMVLEFUNUOTAVNMVOU
      PZWAAWEWDLAWDWEWDOLVNWDMDVMVLDVMUQZURSUSWAVPVNRMUFWEVNVPMVBVNMVOUTVATVNVP
      MVCVDAVNMVOVEZVSAWGWDLAWDWGWDOLVNWDMDVMWFVFSUSVNMVOVGVHVNVPMVIVJMVMVOVKT
      @.
  @}

  @( The betweenness slot. @)
  @c btw @.

  @( The incidence betweenness geometry. @)
  @c Ibg @.

  @( Extend class notation with the betweenness relation. @)
  cbtw @a class btw @.

  @( Extend class notation with the class of all planar incidence betweenness
     geometries. @)
  cibg @a class Ibg @.

  @( Definition of btw.  (Contributed by FL, 1-Apr-2016.) @)
  df-btw @a |- btw = +g @.

  @{
    @d a b c d e f g h l p q r @.
    @( Definition of a geometry that can build on the axioms of incidence and
       betweenness.  Axioms B-1, B-2, B-3, B-4 of [AitkenIBG] p. 3-4.  (For my
       private use only.  Don't use.)  (Contributed by FL, 1-Apr-2016.) @)
    df-ibg2 @a |- Ibg = { f e. Ig | [. ( PPoints ` f ) / g ].
      [. ( PLines ` f ) / h ]. [. ( coln ` f ) / d ]. [. ( btw ` f ) / e ].
      A. p e. g A. q e. g ( ( p =/= q -> E. a e. g E. b e. g E. c e. g
          ( p e. ( a e q ) /\ b e. ( p e q ) /\ q e. ( p e c ) ) )
         /\ A. r e. g ( ( ( { p , q , r } e. d
                /\ ( p =/= q /\ p =/= r /\ q =/= r ) ) ->
                 ( ( p e. ( q e r ) /\ q e/ ( p e r ) /\ r e/ ( p e q ) )
           \/ ( p e/ ( q e r ) /\ q e. ( p e r ) /\ r e/ ( p e q ) )
           \/ ( p e/ ( q e r ) /\ q e/ ( p e r ) /\ r e. ( p e q ) ) ) )
         /\ ( q e. ( p e r ) ->
         ( q e. ( r e p ) /\ { p , q , r } e. d
           /\ ( p =/= q /\ p =/= r /\ q =/= r ) ) )
      /\ A. l e. h ( ( p e/ l /\ q e/ l /\ r e/ l ) ->
        ( ( ( ( ( p e q ) i^i l ) = (/) /\
            ( ( q e r ) i^i l ) = (/) )
              -> ( ( p e r ) i^i l ) = (/) ) /\
             ( ( ( ( p e q ) i^i l ) =/= (/) /\
                 ( ( q e r ) i^i l ) =/= (/) )
                     -> ( ( p e r ) i^i l ) = (/) ) ) ) ) ) } @.
  @}


  @{
    isibg.1 @e |- P = ( PPoints ` G ) @.
    isibg.2 @e |- L = ( PLines ` G ) @.
    isibg.3 @e |- B = ( btw ` G ) @.
    isibg.6 @e |- C = ( coln ` G ) @.
    @{
      @d a b c d e f g h l p q r B @.  @d a b c d e f g h p q r P @.
      @d d e f g h p q r C @.  @d d f g h G @.  @d d e f g h l p q r L @.
      @( The predicate "is an incidence-betweenness geometry".

         B-1 If ` q ` is between ` p ` and ` r ` then it is between ` r ` and
         ` p ` and ` p ` , ` q ` , ` r ` are collinear and distinct.

         B-2 If ` p ` and ` q ` are distinct, then there are points ` a ` ,
         ` b ` , ` c ` such that ` a ` is before ` p ` and ` q ` , ` b ` is
         between ` p ` and ` q ` , ` c ` is after ` p ` and ` q ` .

         B-3 If three points ` p ` , ` q ` , ` r ` are collinear and distinct
         then exactly one of the followings occurs: ` p ` is between ` q ` and
         ` r ` , ` q ` is between ` p ` and ` r ` , ` r ` is between ` p ` and
         ` q ` .

         B-4 "Being on the same side" is a transitive relation.  If ` p ` and
         ` q ` are not on the same side of ` l ` and ` q ` and ` r ` are not on
         the same side of ` l ` then ` p ` and ` r ` are on the same side of
         ` l ` .  (For my private use only.  Don't use.)  (Contributed by FL,
         1-Apr-2016.) @)
      isibg2 @p |- ( G e. Ibg <-> ( G e. Ig /\ A. p e. P A. q e. P
     ( ( p =/= q -> E. a e. P E. b e. P E. c e. P
          ( p e. ( a B q ) /\ b e. ( p B q ) /\ q e. ( p B c ) ) )
         /\ A. r e. P ( ( ( { p , q , r } e. C
                /\ ( p =/= q /\ p =/= r /\ q =/= r ) ) ->
                 ( ( p e. ( q B r ) /\ q e/ ( p B r ) /\ r e/ ( p B q ) )
                \/ ( p e/ ( q B r ) /\ q e. ( p B r ) /\ r e/ ( p B q ) )
                \/ ( p e/ ( q B r ) /\ q e/ ( p B r ) /\ r e. ( p B q ) ) ) )
         /\ ( ( q e. ( p B r ) ->
         ( q e. ( r B p ) /\ { p , q , r } e. C
           /\ ( p =/= q /\ p =/= r /\ q =/= r ) ) )
      /\ A. l e. L ( ( p e/ l /\ q e/ l /\ r e/ l ) ->
        ( ( ( ( ( p B q ) i^i l ) = (/) /\
            ( ( q B r ) i^i l ) = (/) )
              -> ( ( p B r ) i^i l ) = (/) ) /\
             ( ( ( ( p B q ) i^i l ) =/= (/) /\
                 ( ( q B r ) i^i l ) =/= (/) )
                     -> ( ( p B r ) i^i l ) = (/) ) ) ) ) ) ) ) ) @=
        ( wcel wa wral wsbc ve vg vd vh vf cv wne co w3a wrex wi ctp w3o cin c0
        wnel wceq cbtw cfv ccol cplines cpoints cig cibg wb dfsbcq syl sbcbidv2
        fveq2 sbcbidv bitrd eqcomi ax-mp cvv fvex eqeltri sbcbiiOLD bitri rexeq
        syl6bb rexeqbi1dv imbi2d raleq anbi12d raleqbi1dv 3anbi3d ralbidv eleq2
        anbi2d 2ralbidv anbi1d imbi1d 3anbi12d 3anass syl3an9b sbc3ie 3anbi123d
        3anbi2d oveq eleq2d rexbidv 2rexbidv neleq12d 3orbi123d 3anbi1d imbi12d
        eqidd ineq1d eqeq1d neeq1d sbcie df-ibg2 elrab2 ) HUFZGUFZUGZXNIUFZXOUA
        UFZUHZQZJUFZXNXOXRUHZQZXOXNKUFZXRUHZQZUIZKUBUFZUJZJYHUJZIYHUJZUKZXNXOFU
        FZULZUCUFZQZXPXNYMUGXOYMUGUIZRZXNXOYMXRUHZQZXOXNYMXRUHZUPZYMYBUPZUIZXNY
        SUPZXOUUAQZUUCUIZUUEUUBYMYBQZUIZUMZUKZUUFXOYMXNXRUHZQZYPYQUIZUKZXNLUFZU
        PXOUUPUPYMUUPUPUIZYBUUPUNZUOUQZYSUUPUNZUOUQZRZUUAUUPUNZUOUQZUKZUURUOUGZ
        UUTUOUGZRZUVDUKZRZUKZLUDUFZSZUIZFYHSZRZGYHSZHYHSZUAUEUFZURUSZTZUCUVSUTU
        SZTZUDUVSVAUSZTZUBUVSVBUSZTZXPXNXQXOAUHZQZYAXNXOAUHZQZXOXNYDAUHZQZUIZKC
        UJZJCUJICUJZUKZYNBQZYQRZXNXOYMAUHZQZXOXNYMAUHZUPZYMUWJUPZUIZXNUWTUPZXOU
        XBQZUXDUIZUXFUXCYMUWJQZUIZUMZUKZUXGXOYMXNAUHZQZUWRYQUIZUKZUUQUWJUUPUNZU
        OUQZUWTUUPUNZUOUQZRZUXBUUPUNZUOUQZUKZUXQUOUGZUXSUOUGZRZUYCUKZRZUKZLESZR
        ZRZFCSZRZGCSHCSZUEDVCVDUVSDUQZUWGUVRUAATZUCBTZUDETZUBCTZUYPUYQUWGUVRUAD
        URUSZTZUCDUTUSZTZUDDVAUSZTZUBDVBUSZTZVUAUYQUWGUWCUDVUFTZUBVUHTVUIUYQUWE
        VUJUBUWFVUHUVSDVBVIUYQUWDVUFUQUWEVUJVEUVSDVAVIUWCUDUWDVUFVFVGVHUYQVUJVU
        GUBVUHUYQUWCVUEUDVUFUYQUWAVUCUCUWBVUDUVSDUTVIUYQUVTVUBUQUWAVUCVEUVSDURV
        IUVRUAUVTVUBVFVGVHVJVJVKVUIVUGUBCTZVUAVUHCUQVUIVUKVECVUHMVLVUGUBVUHCVFV
        MVUKVUEUDETZUBCTZVUACVNQZVUKVUMVECVUHVNMDVBVOVPZVUGVULUBCVNVUFEUQVUGVUL
        VEEVUFNVLVUEUDVUFEVFVMVQVMVUNVUMVUAVEVUOVULUYTUBCVNEVNQVULUYTVEEVUFVNND
        VAVOVPZVUEUYSUDEVNVUEVUCUCBTZUYSVUDBUQVUEVUQVEBVUDPVLVUCUCVUDBVFVMBVNQV
        UQUYSVEBVUDVNPDUTVOVPZVUCUYRUCBVNVUBAUQVUCUYRVEAVUBOVLUVRUAVUBAVFVMVQVM
        VRVQVMVQVMVRVRVTVUAXPYGKCUJZJCUJZICUJZUKZUWSUUJUKZUUFUUMUWRYQUIZUKZUVKL
        ESZRZRZFCSZRZGCSHCSZUAATZUYPUYRVVLUBUDUCCEBVUOVUPVURYHCUQZUYRVVBUVNFCSZ
        RZGCSZHCSZUAATUVLEUQZVVBUUKUUOVVFUIZFCSZRZGCSHCSZUAATYOBUQZVVLVVMUVRVVQ
        UAAUVQVVPHYHCUVPVVOGYHCVVMYLVVBUVOVVNVVMYKVVAXPYJVUTIYHCYIVUSJYHCYGKYHC
        VSWAWAWBUVNFYHCWCWDWEWEVJVVRVVQVWBUAAVVRVVOVWAHGCCVVRVVNVVTVVBVVRUVNVVS
        FCVVRUVMVVFUUKUUOUVKLUVLEWCWFWGWIWJVJVWCVWBVVKUAAVWCVWAVVJHGCCVWCVVTVVI
        VVBVWCVVSVVHFCVWCVVSVVCVVEVVFUIVVHVWCUUKVVCUUOVVEVVFVWCYRUWSUUJVWCYPUWR
        YQYOBYNWHZWKWLVWCUUNVVDUUFVWCYPUWRUUMYQVWDWRWBWMVVCVVEVVFWNVTWGWIWJVJWO
        WPVVKUYPUAAAVUBVNODURVOVPXRAUQZVVJUYOHGCCVWEVVBUWQVVIUYNVWEVVAUWPXPVWEV
        USUWOIJCCVWEYGUWNKCVWEXTUWIYCUWKYFUWMVWEXSUWHXNXQXOXRAWSWTVWEYBUWJYAXNX
        OXRAWSZWTVWEYEUWLXOXNYDXRAWSWTWQXAXBWBVWEVVHUYMFCVWEVVCUXLVVGUYLVWEUUJU
        XKUWSVWEUUDUXEUUGUXHUUIUXJVWEYTUXAUUBUXCUUCUXDVWEYSUWTXNXOYMXRAWSZWTVWE
        XOXOUUAUXBVWEXOXGXNYMXRAWSZXCZVWEYMYMYBUWJVWEYMXGVWFXCZWQVWEUUEUXFUUFUX
        GUUCUXDVWEXNXNYSUWTVWEXNXGVWGXCZVWEUUAUXBXOVWHWTZVWJWQVWEUUEUXFUUBUXCUU
        HUXIVWKVWIVWEYBUWJYMVWFWTWQXDWBVWEVVEUXPVVFUYKVWEUUFUXGVVDUXOVWLVWEUUMU
        XNUWRYQVWEUULUXMXOYMXNXRAWSWTXEXFVWEUVKUYJLEVWEUVJUYIUUQVWEUVEUYDUVIUYH
        VWEUVBUYAUVDUYCVWEUUSUXRUVAUXTVWEUURUXQUOVWEYBUWJUUPVWFXHZXIVWEUUTUXSUO
        VWEYSUWTUUPVWGXHZXIWDVWEUVCUYBUOVWEUUAUXBUUPVWHXHXIZXFVWEUVHUYGUVDUYCVW
        EUVFUYEUVGUYFVWEUURUXQUOVWMXJVWEUUTUXSUOVWNXJWDVWOXFWDWBWGWDWDWGWDWJXKV
        RVTUAUEUBUDFGHIJKUCLXLXM @.
    @}
  @}


  @{
    @d t u v w x y z G @.
    isibg1a.1 @e |- ( ph -> G e. Ibg ) @.
    @( An incidence-betweenness geometry is an incidence geometry.  (For my
       private use only.  Don't use.)  (Contributed by FL, 2-Apr-2016.) @)
    isibg1a @p |- ( ph -> G e. Ig ) @=
      ( vz vy vw vv vu wcel cv wne cfv co w3a wi wa wnel c0 wral eqid vx vt cig
      cibg cbtw cpoints wrex ctp ccol w3o cin wceq cplines isibg2 simplbi syl )
      ABUDIZBUCIZCUQURDJZEJZKZUSFJUTBUELZMIGJUSUTVBMZIUTUSHJVBMINHBUFLZUGGVDUGF
      VDUGOUSUTUAJZUHBUILZIZVAUSVEKUTVEKNZPUSUTVEVBMZIUTUSVEVBMZQZVEVCQZNUSVIQZ
      UTVJIZVLNVMVKVEVCINUJOVNUTVEUSVBMIVGVHNOUSUBJZQUTVOQVEVOQNVCVOUKZRULVIVOU
      KZRULPVJVOUKRULZOVPRKVQRKPVROPOUBBUMLZSPPUAVDSPEVDSDVDSVBVFVDBVSUAEDFGHUB
      VDTVSTVBTVFTUNUOUP @.
  @}

  @{
    @d a b c l x y z B @.  @d a b c x y z P @.  @d a b c l x y z X @.
    @d a b c l y z Y @.  @d l x y z L @.  @d l M @.  @d l z Z @.  @d x y z C @.
    isibg2aa.1 @e |- P = ( PPoints ` G ) @.
    isibg2aa.2 @e |- L = ( PLines ` G ) @.
    isibg2aa.3 @e |- B = ( btw ` G ) @.
    isibg2aa.4 @e |- C = ( coln ` G ) @.
    isibg2aa.5 @e |- ( ph -> X e. P ) @.
    isibg2aa.6 @e |- ( ph -> Y e. P ) @.
    isibg2aa.7 @e |- ( ph -> Z e. P ) @.
    isibg2aa.8 @e |- ( ph -> M e. L ) @.
    isibg2aa.9 @e |- ( ph -> G e. Ibg ) @.
    @( Properties of an incidence-betweenness geometry.  (Contributed by FL,
       10-Aug-2016.) @)
    isibg2aa @p |- ( ph ->
     ( ( X =/= Y -> E. a e. P E. b e. P E. c e. P
          ( X e. ( a B Y ) /\ b e. ( X B Y ) /\ Y e. ( X B c ) ) )
         /\ ( ( ( { X , Y , Z } e. C
                /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) ) ->
                 ( ( X e. ( Y B Z ) /\ Y e/ ( X B Z ) /\ Z e/ ( X B Y ) )
                \/ ( X e/ ( Y B Z ) /\ Y e. ( X B Z ) /\ Z e/ ( X B Y ) )
                \/ ( X e/ ( Y B Z ) /\ Y e/ ( X B Z ) /\ Z e. ( X B Y ) ) ) )
         /\ ( ( Y e. ( X B Z ) ->
         ( Y e. ( Z B X ) /\ { X , Y , Z } e. C
           /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) ) )
              /\ ( ( X e/ M /\ Y e/ M /\ Z e/ M ) ->
                 ( ( ( ( ( X B Y ) i^i M ) = (/) /\
                    ( ( Y B Z ) i^i M ) = (/) )
                      -> ( ( X B Z ) i^i M ) = (/) ) /\
                       ( ( ( ( X B Y ) i^i M ) =/= (/) /\
                       ( ( Y B Z ) i^i M ) =/= (/) )
                         -> ( ( X B Z ) i^i M ) = (/) ) ) ) ) ) ) ) @=
      ( vx vy vz vl cibg wcel wne cv co w3a wrex wi ctp wa wnel w3o cin c0 wceq
      cig wral isibg2 neeq1 eleq1 oveq1 eleq2d 3anbi123d rexbidv 2rexbidv tpeq1
      imbi12d eleq1d 3anbi12d anbi12d eqidd neleq12d neleq1 oveq2 ineq1d eqeq1d
      3orbi123d 3anbi1d anbi1d neeq1d ralbidv neeq2 tpeq2 3anbi2d imbi1d rspc2v
      3anbi13d tpeq3 3anbi23d 3anbi3d anbi2d rspcv neleq2 ineq2 syl anim2d syl9
      mpcom syl2anc pm2.43i com12 adantl sylbi ) EUGUHZAHIUIZHKUJZIBUKZUHZLUJZH
      IBUKZUHZIHMUJZBUKZUHZULZMDUMZLDUMKDUMZUNZHIJUOZCUHZXKHJUIZIJUIZULZUPZHIJB
      UKZUHZIHJBUKZUQZJXPUQZULZHYKUQZIYMUHZYOULZYQYNJXPUHZULZURZUNZYRIJHBUKZUHZ
      YFYIULZUNZHGUQZIGUQZJGUQZULZXPGUSZUTVAZYKGUSZUTVAZUPZYMGUSZUTVAZUNZUULUTU
      IZUUNUTUIZUPZUURUNZUPZUNZUPZUPZUPZUBXJEVBUHZUCUJZUDUJZUIZUVJXLUVKBUKZUHZX
      OUVJUVKBUKZUHZUVKUVJXRBUKZUHZULZMDUMZLDUMKDUMZUNZUVJUVKUEUJZUOZCUHZUVLUVJ
      UWCUIZUVKUWCUIZULZUPZUVJUVKUWCBUKZUHZUVKUVJUWCBUKZUQZUWCUVOUQZULZUVJUWJUQ
      ZUVKUWLUHZUWNULZUWPUWMUWCUVOUHZULZURZUNZUWQUVKUWCUVJBUKZUHZUWEUWHULZUNZUV
      JUFUJZUQZUVKUXGUQZUWCUXGUQZULZUVOUXGUSZUTVAZUWJUXGUSZUTVAZUPZUWLUXGUSZUTV
      AZUNZUXLUTUIZUXNUTUIZUPZUXRUNZUPZUNZUFFVCZUPZUPZUEDVCZUPZUDDVCUCDVCZUPAUV
      HUNZBCDEFUEUDUCKLMUFNOPQVDUYKUYLUVIAUYKUVHAUYKUVHUNZAHDUHZIDUHZAUYMUNRSUY
      NUYOUPUYKYDHIUWCUOZCUHZXKHUWCUIZIUWCUIZULZUPZHIUWCBUKZUHZIHUWCBUKZUQZUWCX
      PUQZULZHVUBUQZIVUDUHZVUFULZVUHVUEUWCXPUHZULZURZUNZVUIIUWCHBUKZUHZUYQUYTUL
      ZUNZHUXGUQZIUXGUQZUXJULZXPUXGUSZUTVAZVUBUXGUSZUTVAZUPZVUDUXGUSZUTVAZUNZVV
      BUTUIZVVDUTUIZUPZVVHUNZUPZUNZUFFVCZUPZUPZUEDVCZUPZAUVHUYJVVTHUVKUIZHUVMUH
      ZXOHUVKBUKZUHZUVKXSUHZULZMDUMZLDUMKDUMZUNZHUVKUWCUOZCUHZVWAUYRUWGULZUPZHU
      WJUHZUVKVUDUQZUWCVWCUQZULZHUWJUQZUVKVUDUHZVWPULZVWRVWOUWCVWCUHZULZURZUNZV
      WSUVKVUOUHZVWKVWLULZUNZVUSUXIUXJULZVWCUXGUSZUTVAZUXOUPZVVHUNZVXIUTUIZUYAU
      PZVVHUNZUPZUNZUFFVCZUPZUPZUEDVCZUPUCUDHIDDUVJHVAZUWBVWIUYIVYAVYBUVLVWAUWA
      VWHUVJHUVKVEZVYBUVTVWGKLDDVYBUVSVWFMDVYBUVNVWBUVPVWDUVRVWEUVJHUVMVFVYBUVO
      VWCXOUVJHUVKBVGZVHVYBUVQXSUVKUVJHXRBVGVHVIVJVKVMVYBUYHVXTUEDVYBUXBVXDUYGV
      XSVYBUWIVWMUXAVXCVYBUWEVWKUWHVWLVYBUWDVWJCUVJHUVKUWCVLVNZVYBUVLVWAUWFUYRU
      WGVYCUVJHUWCVEVOZVPVYBUWOVWQUWRVWTUWTVXBVYBUWKVWNUWMVWOUWNVWPUVJHUWJVFVYB
      UVKUVKUWLVUDVYBUVKVQUVJHUWCBVGZVRZVYBUWCUWCUVOVWCVYBUWCVQVYDVRZVIVYBUWPVW
      RUWQVWSUWNVWPUVJHUWJVSZVYBUWLVUDUVKVYGVHZVYIVIVYBUWPVWRUWMVWOUWSVXAVYJVYH
      VYBUVOVWCUWCVYDVHVIWCVMVYBUXFVXGUYFVXRVYBUWQVWSUXEVXFVYKVYBUXDVXEUWEVWKUW
      HVWLVYBUXCVUOUVKUVJHUWCBVTVHVYEVYFVIVMVYBUYEVXQUFFVYBUXKVXHUYDVXPVYBUXHVU
      SUXIUXJUVJHUXGVSWDVYBUXSVXLUYCVXOVYBUXPVXKUXRVVHVYBUXMVXJUXOVYBUXLVXIUTVY
      BUVOVWCUXGVYDWAZWBWEVYBUXQVVGUTVYBUWLVUDUXGVYGWAWBZVMVYBUYBVXNUXRVVHVYBUX
      TVXMUYAVYBUXLVXIUTVYLWFWEVYMVMVPVMWGVPVPWGVPUVKIVAZVWIYDVYAVVSVYNVWAXKVWH
      YCUVKIHWHZVYNVWGYBKLDDVYNVWFYAMDVYNVWBXNVWDXQVWEXTVYNUVMXMHUVKIXLBVTVHVYN
      VWCXPXOUVKIHBVTZVHUVKIXSVFVIVJVKVMVYNVXTVVRUEDVYNVXDVUNVXSVVQVYNVWMVUAVXC
      VUMVYNVWKUYQVWLUYTVYNVWJUYPCUVKIHUWCWIVNZVYNVWAXKUWGUYSUYRVYOUVKIUWCVEWMZ
      VPVYNVWQVUGVWTVUJVXBVULVYNVWNVUCVWOVUEVWPVUFVYNUWJVUBHUVKIUWCBVGZVHUVKIVU
      DVSZVYNUWCUWCVWCXPVYNUWCVQVYPVRZVIVYNVWRVUHVWSVUIVWPVUFVYNHHUWJVUBVYNHVQV
      YSVRZUVKIVUDVFZWUAVIVYNVWRVUHVWOVUEVXAVUKWUBVYTVYNVWCXPUWCVYPVHVIWCVMVYNV
      XGVURVXRVVPVYNVWSVUIVXFVUQWUCVYNVXEVUPVWKUYQVWLUYTUVKIVUOVFVYQVYRVIVMVYNV
      XQVVOUFFVYNVXHVVAVXPVVNVYNUXIVUTVUSUXJUVKIUXGVSWJVYNVXLVVIVXOVVMVYNVXKVVF
      VVHVYNVXJVVCUXOVVEVYNVXIVVBUTVYNVWCXPUXGVYPWAZWBVYNUXNVVDUTVYNUWJVUBUXGVY
      SWAZWBVPWKVYNVXNVVLVVHVYNVXMVVJUYAVVKVYNVXIVVBUTWUDWFVYNUXNVVDUTWUEWFVPWK
      VPVMWGVPVPWGVPWLAVVSUVGYDJDUHZAVVSUVGUNTWUFVVSUUCUUGVUSVUTJUXGUQZULZVVCYK
      UXGUSZUTVAZUPZYMUXGUSZUTVAZUNZVVJWUIUTUIZUPZWUMUNZUPZUNZUFFVCZUPZUPZAUVGV
      VRWVBUEJDUWCJVAZVUNUUCVVQWVAWVCVUAYJVUMUUBWVCUYQYFUYTYIWVCUYPYECUWCJHIWNV
      NZWVCUYRYGUYSYHXKUWCJHWHUWCJIWHWOZVPWVCVUGYPVUJYSVULUUAWVCVUCYLVUEYNVUFYO
      WVCVUBYKHUWCJIBVTZVHWVCIIVUDYMWVCIVQUWCJHBVTZVRZUWCJXPVSZVIWVCVUHYQVUIYRV
      UFYOWVCHHVUBYKWVCHVQWVFVRZWVCVUDYMIWVGVHZWVIVIWVCVUHYQVUEYNVUKYTWVJWVHUWC
      JXPVFVIWCVMWVCVURUUGVVPWUTWVCVUIYRVUQUUFWVKWVCVUPUUEUYQYFUYTYIWVCVUOUUDIU
      WCJHBVGVHWVDWVEVIVMWVCVVOWUSUFFWVCVVAWUHVVNWURWVCUXJWUGVUSVUTUWCJUXGVSWPW
      VCVVIWUNVVMWUQWVCVVFWUKVVHWUMWVCVVEWUJVVCWVCVVDWUIUTWVCVUBYKUXGWVFWAZWBWQ
      WVCVVGWULUTWVCVUDYMUXGWVGWAWBZVMWVCVVLWUPVVHWUMWVCVVKWUOVVJWVCVVDWUIUTWVL
      WFWQWVMVMVPVMWGVPVPWRAWVAUVFUUCAWUTUVEUUGAGFUHWUTUVEUNUAWUSUVEUFGFUXGGVAZ
      WUHUUKWURUVDWVNVUSUUHVUTUUIWUGUUJUXGGHWSUXGGIWSUXGGJWSVIWVNWUNUUSWUQUVCWV
      NWUKUUPWUMUURWVNVVCUUMWUJUUOWVNVVBUULUTUXGGXPWTZWBWVNWUIUUNUTUXGGYKWTZWBV
      PWVNWULUUQUTUXGGYMWTWBZVMWVNWUPUVBWUMUURWVNVVJUUTWUOUVAWVNVVBUULUTWVOWFWV
      NWUIUUNUTWVPWFVPWVQVMVPVMWRXAXBXBXCXDXBXCXEXFXGXHXIXD @.
  @}

  @{
    @d a x y X @.  @d a y Y @.  @d b x y X @.  @d b y Y @.  @d c x y X @.
    @d c y Y @.  @d l x y X @.  @d l y Y @.  @d x y z X @.  @d x y B @.
    @d x y C @.  @d x y L @.  @d x y P @.  @d z Y @.
    isibg2aalem1.1 @e |- P = ( PPoints ` G ) @.
    isibg2aalem1.2 @e |- L = ( PLines ` G ) @.
    @( Properties of an incidence-betweenness geometry.  (Contributed by FL,
       10-Aug-2016.) @)
    isibg2aalem1 @p |- ( ( X e. P /\ Y e. P )
                      -> ( A. x
                            e. P
                               A. y
                               e. P
                                  ( ( x =/= y
                                     -> E. a
                                        e. P
                                           E. b
                                           e. P
                                              E. c
                                              e. P
                                                 ( x e. ( a B y )
                                                 /\ b e. ( x B y )
                                                 /\ y e. ( x B c ) ) )
                                  /\ A. z
                                     e. P
                                        ( ( ( { x , y , z } e. C
                                              /\ ( x =/= y
                                                 /\ x =/= z
                                                 /\ y =/= z ) )
                                           -> ( ( x e. ( y B z )
                                                 /\ y e/ ( x B z )
                                                 /\ z e/ ( x B y ) )
                                              \/ ( x e/ ( y B z )
                                                 /\ y e. ( x B z )
                                                 /\ z e/ ( x B y ) )
                                              \/ ( x e/ ( y B z )
                                                 /\ y e/ ( x B z )
                                                 /\ z e. ( x B y ) ) ) )
                                        /\ ( ( y e. ( x B z )
                                              -> ( y e. ( z B x )
                                                 /\ { x , y , z } e. C
                                                 /\ ( x =/= y
                                                    /\ x =/= z
                                                    /\ y =/= z ) ) )
                                           /\ A. l
                                              e. L
                                                 ( ( x e/ l
                                                    /\ y e/ l
                                                    /\ z e/ l )
                                                 -> ( ( ( ( ( x B y )
                                                               i^i l )
                                                             = (/)
                                                          /\ ( ( y B z )
                                                               i^i l )
                                                             = (/) )
                                                       -> ( ( x B z ) i^i l )
                                                          = (/) )
                                                    /\ ( ( ( ( x B y )
                                                                 i^i l )
                                                             =/= (/)
                                                          /\ ( ( y B z )
                                                                 i^i l )
                                                             =/= (/) )
                                                       -> ( ( x B z ) i^i l )
                                                          = (/) ) ) ) ) ) )
                         -> ( ( X =/= Y
                               -> E. a
                                  e. P
                                     E. b
                                     e. P
                                        E. c
                                        e. P
                                           ( X e. ( a B Y )
                                           /\ b e. ( X B Y )
                                           /\ Y e. ( X B c ) ) )
                            /\ A. z
                               e. P
                                  ( ( ( { X , Y , z } e. C
                                        /\ ( X =/= Y /\ X =/= z /\ Y =/= z ) )
                                     -> ( ( X e. ( Y B z )
                                           /\ Y e/ ( X B z )
                                           /\ z e/ ( X B Y ) )
                                        \/ ( X e/ ( Y B z )
                                           /\ Y e. ( X B z )
                                           /\ z e/ ( X B Y ) )
                                        \/ ( X e/ ( Y B z )
                                           /\ Y e/ ( X B z )
                                           /\ z e. ( X B Y ) ) ) )
                                  /\ ( ( Y e. ( X B z )
                                        -> ( Y e. ( z B X )
                                           /\ { X , Y , z } e. C
                                           /\ ( X =/= Y /\ X =/= z /\ Y =/= z )
                                           ) )
                                     /\ A. l
                                        e. L
                                           ( ( X e/ l /\ Y e/ l /\ z e/ l )
                                           -> ( ( ( ( ( X B Y ) i^i l )
                                                       = (/)
                                                    /\ ( ( Y B z ) i^i l )
                                                       = (/) )
                                                 -> ( ( X B z ) i^i l ) = (/) )
                                              /\ ( ( ( ( X B Y ) i^i l )
                                                       =/= (/)
                                                    /\ ( ( Y B z ) i^i l )
                                                       =/= (/) )
                                                 -> ( ( X B z ) i^i l ) = (/) )
                                              ) ) ) ) ) ) ) @=
      ( wcel w3a wa c0 cv wne co wrex wi ctp wnel w3o cin wceq wral neeq1 eleq1
      oveq1 eleq2d rexbidv 2rexbidv imbi12d tpeq1 eleq1d 3anbi12d anbi12d eqidd
      3anbi123d neleq12d neleq1 oveq2 3anbi1d ineq1d eqeq1d anbi1d neeq1d neeq2
      3orbi123d ralbidv tpeq2 3anbi13d 3anbi2d imbi1d rspc2v ) AUAZBUAZUBZWAKUA
      ZWBDUCZQZLUAZWAWBDUCZQZWBWAMUAZDUCZQZRZMFUDZLFUDKFUDZUEZWAWBCUAZUFZEQZWCW
      AWQUBZWBWQUBZRZSZWAWBWQDUCZQZWBWAWQDUCZUGZWQWHUGZRZWAXDUGZWBXFQZXHRZXJXGW
      QWHQZRZUHZUEZXKWBWQWADUCZQZWSXBRZUEZWANUAZUGZWBYAUGZWQYAUGZRZWHYAUIZTUJZX
      DYAUIZTUJZSZXFYAUIZTUJZUEZYFTUBZYHTUBZSZYLUEZSZUEZNHUKZSZSZCFUKZSIJUBZIWD
      JDUCZQZWGIJDUCZQZJIWJDUCZQZRZMFUDZLFUDKFUDZUEZIJWQUFZEQZUUDIWQUBZJWQUBZRZ
      SZIJWQDUCZQZJIWQDUCZUGZWQUUGUGZRZIUVAUGZJUVCQZUVERZUVGUVDWQUUGQZRZUHZUEZU
      VHJWQIDUCZQZUUPUUSRZUEZIYAUGZJYAUGZYDRZUUGYAUIZTUJZUVAYAUIZTUJZSZUVCYAUIZ
      TUJZUEZUWATUBZUWCTUBZSZUWGUEZSZUEZNHUKZSZSZCFUKZSIWBUBZIWEQZWGIWBDUCZQZWB
      UUIQZRZMFUDZLFUDKFUDZUEZIWBWQUFZEQZUWSUUQXARZSZIXDQZWBUVCUGZWQUXAUGZRZIXD
      UGZWBUVCQZUXNRZUXPUXMWQUXAQZRZUHZUEZUXQWBUVNQZUXIUXJRZUEZUVRYCYDRZUXAYAUI
      ZTUJZYISZUWGUEZUYGTUBZYOSZUWGUEZSZUEZNHUKZSZSZCFUKZSABIJFFWAIUJZWPUXGUUCU
      YSUYTWCUWSWOUXFWAIWBULZUYTWNUXEKLFFUYTWMUXDMFUYTWFUWTWIUXBWLUXCWAIWEUMUYT
      WHUXAWGWAIWBDUNZUOUYTWKUUIWBWAIWJDUNUOVDUPUQURUYTUUBUYRCFUYTXPUYBUUAUYQUY
      TXCUXKXOUYAUYTWSUXIXBUXJUYTWRUXHEWAIWBWQUSUTZUYTWCUWSWTUUQXAVUAWAIWQULVAZ
      VBUYTXIUXOXLUXRXNUXTUYTXEUXLXGUXMXHUXNWAIXDUMUYTWBWBXFUVCUYTWBVCWAIWQDUNZ
      VEZUYTWQWQWHUXAUYTWQVCVUBVEZVDUYTXJUXPXKUXQXHUXNWAIXDVFZUYTXFUVCWBVUEUOZV
      UGVDUYTXJUXPXGUXMXMUXSVUHVUFUYTWHUXAWQVUBUOVDVNURUYTXTUYEYTUYPUYTXKUXQXSU
      YDVUIUYTXRUYCWSUXIXBUXJUYTXQUVNWBWAIWQDVGUOVUCVUDVDURUYTYSUYONHUYTYEUYFYR
      UYNUYTYBUVRYCYDWAIYAVFVHUYTYMUYJYQUYMUYTYJUYIYLUWGUYTYGUYHYIUYTYFUYGTUYTW
      HUXAYAVUBVIZVJVKUYTYKUWFTUYTXFUVCYAVUEVIVJZURUYTYPUYLYLUWGUYTYNUYKYOUYTYF
      UYGTVUJVLVKVUKURVBURVOVBVBVOVBWBJUJZUXGUUNUYSUWRVULUWSUUDUXFUUMWBJIVMZVUL
      UXEUULKLFFVULUXDUUKMFVULUWTUUFUXBUUHUXCUUJVULWEUUEIWBJWDDVGUOVULUXAUUGWGW
      BJIDVGZUOWBJUUIUMVDUPUQURVULUYRUWQCFVULUYBUVMUYQUWPVULUXKUUTUYAUVLVULUXIU
      UPUXJUUSVULUXHUUOEWBJIWQVPUTZVULUWSUUDXAUURUUQVUMWBJWQULVQZVBVULUXOUVFUXR
      UVIUXTUVKVULUXLUVBUXMUVDUXNUVEVULXDUVAIWBJWQDUNZUOWBJUVCVFZVULWQWQUXAUUGV
      ULWQVCVUNVEZVDVULUXPUVGUXQUVHUXNUVEVULIIXDUVAVULIVCVUQVEZWBJUVCUMZVUSVDVU
      LUXPUVGUXMUVDUXSUVJVUTVURVULUXAUUGWQVUNUOVDVNURVULUYEUVQUYPUWOVULUXQUVHUY
      DUVPVVAVULUYCUVOUXIUUPUXJUUSWBJUVNUMVUOVUPVDURVULUYOUWNNHVULUYFUVTUYNUWMV
      ULYCUVSUVRYDWBJYAVFVRVULUYJUWHUYMUWLVULUYIUWEUWGVULUYHUWBYIUWDVULUYGUWATV
      ULUXAUUGYAVUNVIZVJVULYHUWCTVULXDUVAYAVUQVIZVJVBVSVULUYLUWKUWGVULUYKUWIYOU
      WJVULUYGUWATVVBVLVULYHUWCTVVCVLVBVSVBURVOVBVBVOVBVT @.
  @}

  @{
    @d l z Z @.  @d z B @.  @d z C @.  @d z L @.  @d z P @.  @d z X @.
    @d z Y @.
    @( Properties of an incidence-betweenness geometry.  (Contributed by FL,
       10-Aug-2016.) @)
    isibg2aalem2 @p |- ( Z e. P
                      -> ( A. z
                            e. P
                               ( ( ( { X , Y , z } e. C
                                     /\ ( X =/= Y /\ X =/= z /\ Y =/= z ) )
                                  -> ( ( X e. ( Y B z )
                                        /\ Y e/ ( X B z )
                                        /\ z e/ ( X B Y ) )
                                     \/ ( X e/ ( Y B z )
                                        /\ Y e. ( X B z )
                                        /\ z e/ ( X B Y ) )
                                     \/ ( X e/ ( Y B z )
                                        /\ Y e/ ( X B z )
                                        /\ z e. ( X B Y ) ) ) )
                               /\ ( ( Y e. ( X B z )
                                     -> ( Y e. ( z B X )
                                        /\ { X , Y , z } e. C
                                        /\ ( X =/= Y /\ X =/= z /\ Y =/= z ) )
                                     )
                                  /\ A. l
                                     e. L
                                        ( ( X e/ l /\ Y e/ l /\ z e/ l )
                                        -> ( ( ( ( ( X B Y ) i^i l ) = (/)
                                                 /\ ( ( Y B z ) i^i l ) = (/) )
                                              -> ( ( X B z ) i^i l ) = (/) )
                                           /\ ( ( ( ( X B Y ) i^i l ) =/= (/)
                                                 /\ ( ( Y B z ) i^i l ) =/= (/)
                                                 )
                                              -> ( ( X B z ) i^i l ) = (/) ) )
                                        ) ) )
                         -> ( ( ( { X , Y , Z } e. C
                                  /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) )
                               -> ( ( X e. ( Y B Z )
                                     /\ Y e/ ( X B Z )
                                     /\ Z e/ ( X B Y ) )
                                  \/ ( X e/ ( Y B Z )
                                     /\ Y e. ( X B Z )
                                     /\ Z e/ ( X B Y ) )
                                  \/ ( X e/ ( Y B Z )
                                     /\ Y e/ ( X B Z )
                                     /\ Z e. ( X B Y ) ) ) )
                            /\ ( ( Y e. ( X B Z )
                                  -> ( Y e. ( Z B X )
                                     /\ { X , Y , Z } e. C
                                     /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) ) )
                               /\ A. l
                                  e. L
                                     ( ( X e/ l /\ Y e/ l /\ Z e/ l )
                                     -> ( ( ( ( ( X B Y ) i^i l ) = (/)
                                              /\ ( ( Y B Z ) i^i l ) = (/) )
                                           -> ( ( X B Z ) i^i l ) = (/) )
                                        /\ ( ( ( ( X B Y ) i^i l ) =/= (/)
                                              /\ ( ( Y B Z ) i^i l ) =/= (/) )
                                           -> ( ( X B Z ) i^i l ) = (/) ) ) ) )
                            ) ) ) @=
      ( wcel wne w3a wa co wnel wi cin c0 wceq imbi12d cv ctp wral tpeq3 eleq1d
      neeq2 3anbi23d anbi12d oveq2 eleq2d eqidd neleq12d neleq1 3anbi123d eleq1
      w3o 3orbi123d oveq1 3anbi3d ineq1d eqeq1d anbi2d neeq1d ralbidv rspcv ) F
      GAUAZUBZCJZFGKZFVFKZGVFKZLZMZFGVFBNZJZGFVFBNZOZVFFGBNZOZLZFVNOZGVPJZVSLZW
      AVQVFVRJZLZUPZPZWBGVFFBNZJZVHVLLZPZFIUAZOZGWLOZVFWLOZLZVRWLQZRSZVNWLQZRSZ
      MZVPWLQZRSZPZWQRKZWSRKZMZXCPZMZPZIEUCZMZMFGHUBZCJZVIFHKZGHKZLZMZFGHBNZJZG
      FHBNZOZHVROZLZFXSOZGYAJZYCLZYEYBHVRJZLZUPZPZYFGHFBNZJZXNXQLZPZWMWNHWLOZLZ
      WRXSWLQZRSZMZYAWLQZRSZPZXEYRRKZMZUUBPZMZPZIEUCZMZMAHDVFHSZWGYKXLUUJUUKVMX
      RWFYJUUKVHXNVLXQUUKVGXMCVFHFGUDUEZUUKVJXOVKXPVIVFHFUFVFHGUFUGZUHUUKVTYDWC
      YGWEYIUUKVOXTVQYBVSYCUUKVNXSFVFHGBUIZUJUUKGGVPYAUUKGUKVFHFBUIZULZVFHVRUMZ
      UNUUKWAYEWBYFVSYCUUKFFVNXSUUKFUKUUNULZUUKVPYAGUUOUJZUUQUNUUKWAYEVQYBWDYHU
      URUUPVFHVRUOUNUQTUUKWKYOXKUUIUUKWBYFWJYNUUSUUKWIYMVHXNVLXQUUKWHYLGVFHFBUR
      UJUULUUMUNTUUKXJUUHIEUUKWPYQXIUUGUUKWOYPWMWNVFHWLUMUSUUKXDUUCXHUUFUUKXAYT
      XCUUBUUKWTYSWRUUKWSYRRUUKVNXSWLUUNUTZVAVBUUKXBUUARUUKVPYAWLUUOUTVAZTUUKXG
      UUEXCUUBUUKXFUUDXEUUKWSYRRUUTVCVBUVATUHTVDUHUHVE @.
  @}

  @{
    @d l B @.  @d l L @.  @d l M @.  @d l X @.  @d l Y @.  @d l Z @.
    @( Properties of an incidence-betweenness geometry.  (Contributed by FL,
       10-Aug-2016.) @)
    isibg2aalem3 @p |- ( M e. L
                      -> ( A. l
                            e. L
                               ( ( X e/ l /\ Y e/ l /\ Z e/ l )
                               -> ( ( ( ( ( X B Y ) i^i l ) = (/)
                                        /\ ( ( Y B Z ) i^i l ) = (/) )
                                     -> ( ( X B Z ) i^i l ) = (/) )
                                  /\ ( ( ( ( X B Y ) i^i l ) =/= (/)
                                        /\ ( ( Y B Z ) i^i l ) =/= (/) )
                                     -> ( ( X B Z ) i^i l ) = (/) ) ) )
                         -> ( ( X e/ M /\ Y e/ M /\ Z e/ M )
                            -> ( ( ( ( ( X B Y ) i^i M ) = (/)
                                     /\ ( ( Y B Z ) i^i M ) = (/) )
                                  -> ( ( X B Z ) i^i M ) = (/) )
                               /\ ( ( ( ( X B Y ) i^i M ) =/= (/)
                                     /\ ( ( Y B Z ) i^i M ) =/= (/) )
                                  -> ( ( X B Z ) i^i M ) = (/) ) ) ) ) ) @=
      ( wnel co cin c0 wceq wa wi wne neleq2 ineq2 eqeq1d anbi12d imbi12d rspcv
      cv w3a 3anbi123d neeq1d ) DGUBZHZEUFHZFUFHZUCZDEAIZUFJZKLZEFAIZUFJZKLZMZD
      FAIZUFJZKLZNZULKOZUOKOZMZUTNZMZNDCHZECHZFCHZUCZUKCJZKLZUNCJZKLZMZURCJZKLZ
      NZVKKOZVMKOZMZVQNZMZNGCBUFCLZUJVJVFWCWDUGVGUHVHUIVIUFCDPUFCEPUFCFPUDWDVAV
      RVEWBWDUQVOUTVQWDUMVLUPVNWDULVKKUFCUKQZRWDUOVMKUFCUNQZRSWDUSVPKUFCURQRZTW
      DVDWAUTVQWDVBVSVCVTWDULVKKWEUEWDUOVMKWFUESWGTSTUA @.
  @}

  @{
    isibg2a.1 @e |- P = ( PPoints ` G ) @.
    isibg2a.2 @e |- B = ( btw ` G ) @.
    isibg2a.3 @e |- ( ph -> G e. Ibg ) @.
    isibg2a.4 @e |- ( ph -> X e. P ) @.
    isibg2a.5 @e |- ( ph -> Y e. P ) @.
    @{
      @d a b c l x y z B @.  @d a b c x y z P @.  @d a b c l x y z X @.
      @d a b c l x y z Y @.  @d l x y z G @.  @d l z Z @.
      @d t u v w x y z B @.  @d t x y z G @.  @d t u v w x y z X @.
      @d t u v w x y z Y @.  @d u v w x y z P @.  @d t z Z @.
      isib2g1a1.1 @e |- ( ph -> Z e. P ) @.
      isib2g1a1.2 @e |- ( ph -> Y e. ( X B Z ) ) @.
      @( If ` Y ` is between ` X ` and ` Z ` , it is between ` Z ` and ` X `
         (For my private use only.  Don't use.)  (Contributed by FL,
         20-May-2016.) @)
      isib2g1a1 @p |- ( ph -> Y e. ( Z B X ) ) @=
        ( wcel co w3a wi wa wnel vy vx vw vv vu vz vt cibg cig cv wne wrex ccol
        ctp cfv w3o cin wceq cplines wral eqid isibg2 isibg2aalem1 isibg2aalem2
        c0 simp1 imim12i ad2antrl syl6 com23 mpcom com12 adantl syl2anc pm2.43i
        sylbi ) DUHOZAFGEBPOZJVQDUIOZUAUJZUBUJZUKZVTUCUJZWABPOUDUJZVTWABPZOWAVT
        UEUJZBPOQUECULUDCULUCCULRVTWAUFUJZUNDUMUOZOZWBVTWGUKWAWGUKQZSVTWAWGBPZO
        WAVTWGBPZTZWGWETZQVTWKTZWAWLOZWNQWOWMWGWEOQUPRWPWAWGVTBPOWIWJQRVTUGUJZT
        WAWQTWGWQTZQWEWQUQZVEURWKWQUQZVEURSWLWQUQVEURZRWSVEUKWTVEUKSXARSRUGDUSU
        OZUTSSUFCUTSUBCUTUACUTZSAVRRZBWHCDXBUFUBUAUCUDUEUGHXBVAZIWHVAVBXCXDVSAX
        CVRAXCVRRZAECOZFCOZAXFRKLXGXHSZXCAVRXIXCEFUKZEWCFBPOWDEFBPZOFEWFBPOQUEC
        ULUDCULUCCULRZEFWGUNWHOZXJEWGUKFWGUKQZSEFWGBPZOFEWGBPZTZWGXKTZQEXOTZFXP
        OZXRQXSXQWGXKOQUPRXTFWGEBPOXMXNQREWQTZFWQTZWRQXKWQUQZVEURZXOWQUQZVEURSX
        PWQUQVEURZRYCVEUKZYEVEUKSYFRSRUGXBUTSSUFCUTZSXDUAUBUFBWHCDXBEFUCUDUEUGH
        XEVCYHXDXLAYHVRGCOZAYHVRRMYIYHAVRYIYHEFGUNWHOZXJEGUKFGUKQZSEFGBPZOFEGBP
        ZTZGXKTZQEYLTZFYMOZYOQYPYNGXKOQUPRZYQVRYJYKQZRZYAYBGWQTQYDYLWQUQZVEURSY
        MWQUQVEURZRYGUUAVEUKSUUBRSRUGXBUTZSSXDUFBWHCXBEFGUGVDYTXDYRUUCAYQYSVRNV
        RYJYKVFVGVHVIVJVKVLVMVIVJVNVOVLVMVPVK @.
    @}

    @{
      @d a b c w x y z B @.  @d a b c w x y z P @.  @d a b c w x y z X @.
      @d a b c w x z Y @.  @d t u v w x y z B @.  @d t w x y z G @.
      @d t u v w x y z X @.  @d t u v w x z Y @.  @d t w z Z @.
      @d u v w x y z P @.  @d x y z C @.
      isibg1a2.2 @e |- C = ( coln ` G ) @.
      isibg1a2.4 @e |- ( ph -> Y e. ( X B Z ) ) @.
      isibg1a2.7 @e |- ( ph -> Z e. P ) @.
      @( If ` Y ` is between ` X ` and ` Z ` , then ` X ` , ` Y ` , ` Z ` are
         collinear .  (For my private use only.  Don't use.)  (Contributed by
         FL, 20-May-2016.) @)
      isibg1a2 @p |- ( ph -> { X , Y , Z } e. C ) @=
        ( wcel wi w3a wa vy vx vw vv vu vz vt ctp cibg cig cv wne wrex wnel w3o
        co cin c0 wceq cplines wral eqid isibg2 isibg2aalem1 isibg2aalem2 simp2
        cfv imim12i ad2antrl syl6 syl pm2.43b com23 syl2anc pm2.43i com12 sylbi
        adantl ) AFGHUHCQZAEUIQZAVSRZKVTEUJQZUAUKZUBUKZULZWCUCUKZWDBUPQUDUKZWCW
        DBUPZQWDWCUEUKZBUPQSUEDUMUDDUMUCDUMRWCWDUFUKZUHCQZWEWCWJULWDWJULSZTWCWD
        WJBUPZQWDWCWJBUPZUNZWJWHUNZSWCWMUNZWDWNQZWPSWQWOWJWHQSUORWRWDWJWCBUPQWK
        WLSRWCUGUKZUNWDWSUNWJWSUNZSWHWSUQZURUSWMWSUQZURUSTWNWSUQURUSZRXAURULXBU
        RULTXCRTRUGEUTVGZVATTUFDVATUBDVAUADVAZTWABCDEXDUFUBUAUCUDUEUGIXDVBZJNVC
        XEWAWBAXEVSAXEVSRZAFDQZGDQZAXGRLMXHXITZXEAVSXJXEFGULZFWFGBUPQWGFGBUPZQG
        FWIBUPQSUEDUMUDDUMUCDUMRZFGWJUHCQZXKFWJULGWJULSZTFGWJBUPZQGFWJBUPZUNZWJ
        XLUNZSFXPUNZGXQQZXSSXTXRWJXLQSUORYAGWJFBUPQXNXOSRFWSUNZGWSUNZWTSXLWSUQZ
        URUSZXPWSUQZURUSTXQWSUQURUSZRYDURULZYFURULTYGRTRUGXDVATTUFDVAZTWAUAUBUF
        BCDEXDFGUCUDUEUGIXFVDYIWAXMYIAVSAHDQZYIWARPYJYIVSXKFHULGHULSZTFGHBUPZQG
        FHBUPZUNZHXLUNZSFYLUNZGYMQZYOSYPYNHXLQSUORZYQGHFBUPQZVSYKSZRZYBYCHWSUNS
        YEYLWSUQZURUSTYMWSUQURUSZRYHUUBURULTUUCRTRUGXDVAZTTWAUFBCDXDFGHUGVEUUAW
        AYRUUDAYQYTVSOYSVSYKVFVHVIVJVKVLVRVJVMVNVOVPVRVQVKVO @.
    @}

    @{
      @d a b c p q x y B @.  @d a b c w x y z B @.  @d a b c p q x y P @.
      @d a b c p q x y X @.  @d a b c q x y Y @.  @d p q x y G @.
      @d w x y z G @.  @d w x y z X @.  @d w x y Y @.  @d z P @.
      isibg2a.6 @e |- ( ph -> X =/= Y ) @.
      @( Two distinct points have a point before, between and after them.  (For
         my private use only.  Don't use.)  (Contributed by FL, 1-Apr-2016.) @)
      isibg2a @p |- ( ph -> E. a e. P E. b e. P E. c e. P
      ( X e. ( a B Y ) /\ b e. ( X B Y ) /\ Y e. ( X B c ) ) ) @=
        ( wcel co w3a wi wa vz vy vx vw cibg wrex cig wne ctp ccol cfv wnel w3o
        cv cin c0 wceq cplines wral eqid isibg2 isibg2aalem1 imim1i adantr syl6
        com23 syl2anc pm2.43i com12 adantl sylbi mpcom ) DUEPZAEGUNZFBQPHUNZEFB
        QZPFEIUNZBQPRICUFHCUFGCUFZLVMDUGPZUAUNZUBUNZUHZVTVNWABQPVOVTWABQZPWAVTV
        QBQPRICUFHCUFGCUFSVTWAUCUNZUIDUJUKZPZWBVTWDUHWAWDUHRZTVTWAWDBQZPWAVTWDB
        QZULZWDWCULZRVTWHULZWAWIPZWKRWLWJWDWCPRUMSWMWAWDVTBQPWFWGRSVTUDUNZULWAW
        NULWDWNULZRWCWNUOZUPUQWHWNUOZUPUQTWIWNUOUPUQZSWPUPUHWQUPUHTWRSTSUDDURUK
        ZUSTTUCCUSTUBCUSUACUSZTAVRSZBWECDWSUCUBUAGHIUDJWSUTZKWEUTVAWTXAVSAWTVRA
        WTVRSZAECPZFCPZAXCSMNXDXETZWTAVRXFWTEFUHZVRSZEFWDUIWEPZXGEWDUHFWDUHRZTE
        FWDBQZPFEWDBQZULZWDVPULZREXKULZFXLPZXNRXOXMWDVPPRUMSXPFWDEBQPXIXJRSEWNU
        LFWNULWORVPWNUOZUPUQXKWNUOZUPUQTXLWNUOUPUQZSXQUPUHXRUPUHTXSSTSUDWSUSTTU
        CCUSZTXAUAUBUCBWECDWSEFGHIUDJXBVBXHXAXTAXGVROVCVDVEVFVGVHVIVJVKVL @.
    @}

    @{
      @d a b c B @.  @d a b c P @.  @d a b c X @.  @d a b c Y @.
      isibg2a1.6 @e |- ( ph -> X =/= Y ) @.
      @( Two distinct points ` X ` , ` Y ` have a point before them.  (For my
         private use only.  Don't use.)  (Contributed by FL, 10-Aug-2016.) @)
      isibg2a1 @p |- ( ph -> E. a e. P X e. ( a B Y ) ) @=
        ( vb vc cv co wcel wrex rexlimivw w3a isibg2a simp1 reximi syl ) AEGPFB
        QRZNPEFBQRZFEOPBQRZUAZOCSZNCSZGCSUFGCSABCDEFGNOHIJKLMUBUKUFGCUJUFNCUIUF
        OCUFUGUHUCTTUDUE @.
    @}

    @{
      @d a b c B @.  @d a b c P @.  @d a b c X @.  @d a b c Y @.
      isibg2a2.6 @e |- ( ph -> X =/= Y ) @.
      @( Two distinct points ` X ` , ` Y ` have a point between them.  (For my
         private use only.  Don't use.)  (Contributed by FL, 10-Aug-2016.) @)
      isibg2a2 @p |- ( ph -> E. b e. P b e. ( X B Y ) ) @=
        ( va vc cv co wcel wrex rexlimivw w3a isibg2a simp2 reximi syl ) AENPFB
        QRZGPEFBQRZFEOPBQRZUAZOCSZGCSZNCSUGGCSZABCDEFNGOHIJKLMUBUKULNCUJUGGCUIU
        GOCUFUGUHUCTUDTUE @.
    @}

    @{
      @d a b c B @.  @d a b c P @.  @d a b c X @.  @d a b c Y @.
      isibg2a3.6 @e |- ( ph -> X =/= Y ) @.
      @( Two distinct points ` X ` , ` Y ` have a point after them.  (For my
         private use only.  Don't use.)  (Contributed by FL, 10-Aug-2016.) @)
      isibg2a3 @p |- ( ph -> E. c e. P Y e. ( X B c ) ) @=
        ( va vb cv co wcel wrex rexlimivw w3a isibg2a simp3 reximi syl ) AENPFB
        QRZOPEFBQRZFEGPBQRZUAZGCSZOCSZNCSUHGCSZABCDEFNOGHIJKLMUBUKULNCUJULOCUIU
        HGCUFUGUHUCUDTTUE @.
    @}
  @}

  @{
    isibg1a3a.1 @e |- P = ( PPoints ` G ) @.
    isibg1a3a.2 @e |- B = ( btw ` G ) @.
    isibg1a3a.3 @e |- ( ph -> G e. Ibg ) @.
    isibg1a3a.4 @e |- ( ph -> X e. P ) @.
    isibg1a3a.5 @e |- ( ph -> Y e. P ) @.
    isibg1a3a.6 @e |- ( ph -> Z e. P ) @.
    isibg1a3a.7 @e |- ( ph -> Y e. ( X B Z ) ) @.
    @{
      @d a b c l p q r G @.  @d a b c p q r P @.  @d p q r X @.  @d q r Y @.
      @d r Z @.  @d t u v w x y z B @.  @d t x y z G @.  @d t u v w x y z X @.
      @d t u v w x y Y @.  @d t x Z @.  @d u v w x y z P @.
      @( If ` Y ` is between ` X ` and ` Z ` , then ` X ` and ` Y ` , are
         distinct .  (For my private use only.  Don't use.)  (Contributed by
         FL, 20-May-2016.) @)
      isibg1a3a @p |- ( ph -> X =/= Y ) @=
        ( wcel co w3a wi wa wnel vz vy vw vv vu vx vt cibg wne cig cv wrex ccol
        ctp cfv w3o cin wceq cplines wral eqid isibg2 isibg2aalem1 isibg2aalem2
        c0 simp31 imim12i ad2antrl syl6 com23 mpcom com12 syl2anc pm2.43i sylbi
        adantl ) DUHOZAEFUIZJVQDUJOZUAUKZUBUKZUIZVTUCUKZWABPOUDUKZVTWABPZOWAVTU
        EUKZBPOQUECULUDCULUCCULRVTWAUFUKZUNDUMUOZOZWBVTWGUIWAWGUIQZSVTWAWGBPZOW
        AVTWGBPZTZWGWETZQVTWKTZWAWLOZWNQWOWMWGWEOQUPRWPWAWGVTBPOWIWJQRVTUGUKZTW
        AWQTWGWQTZQWEWQUQZVEURWKWQUQZVEURSWLWQUQVEURZRWSVEUIWTVEUISXARSRUGDUSUO
        ZUTSSUFCUTSUBCUTUACUTZSAVRRZBWHCDXBUFUBUAUCUDUEUGHXBVAZIWHVAVBXCXDVSAXC
        VRAXCVRRZAECOZFCOZAXFRKLXGXHSZXCAVRXIXCVREWCFBPOWDEFBPZOFEWFBPOQUECULUD
        CULUCCULRZEFWGUNWHOZVREWGUIFWGUIQZSEFWGBPZOFEWGBPZTZWGXJTZQEXNTZFXOOZXQ
        QXRXPWGXJOQUPRXSFWGEBPOXLXMQREWQTZFWQTZWRQXJWQUQZVEURZXNWQUQZVEURSXOWQU
        QVEURZRYBVEUIZYDVEUISYERSRUGXBUTSSUFCUTZSXDUAUBUFBWHCDXBEFUCUDUEUGHXEVC
        YGXDXKAYGVRGCOZAYGVRRMYHYGAVRYHYGEFGUNWHOZVREGUIZFGUIZQZSEFGBPZOFEGBPZT
        ZGXJTZQEYMTZFYNOZYPQYQYOGXJOQUPRZYRFGEBPOZYIYLQZRZXTYAGWQTQYCYMWQUQZVEU
        RSYNWQUQVEURZRYFUUCVEUISUUDRSRUGXBUTZSSXDUFBWHCXBEFGUGVDUUBXDYSUUEAYRUU
        AVRNYTYIVRYJYKVFVGVHVIVJVKVLVPVIVJVMVNVLVPVOVK @.
    @}

    @{
      @d a b c l p q r G @.  @d a b c p q r P @.  @d p q r X @.  @d q r Y @.
      @d r Z @.  @d t u v w x y z B @.  @d t x y z G @.  @d t u v w x y z X @.
      @d t u v w x y Y @.  @d t x Z @.  @d u v w x y z P @.
      @( If ` Y ` is between ` X ` and ` Z ` , then ` X ` and ` Z ` , are
         distinct .  (For my private use only.  Don't use.)  (Contributed by
         FL, 20-May-2016.) @)
      isibg1spa @p |- ( ph -> X =/= Z ) @=
        ( wcel co w3a wi wa wnel vz vy vw vv vu vx vt cibg wne cig cv wrex ccol
        ctp cfv w3o cin wceq cplines wral eqid isibg2 isibg2aalem1 isibg2aalem2
        c0 simp32 imim12i ad2antrl syl6 com23 mpcom com12 syl2anc pm2.43i sylbi
        adantl ) DUHOZAEGUIZJVQDUJOZUAUKZUBUKZUIZVTUCUKZWABPOUDUKZVTWABPZOWAVTU
        EUKZBPOQUECULUDCULUCCULRVTWAUFUKZUNDUMUOZOZWBVTWGUIWAWGUIQZSVTWAWGBPZOW
        AVTWGBPZTZWGWETZQVTWKTZWAWLOZWNQWOWMWGWEOQUPRWPWAWGVTBPOWIWJQRVTUGUKZTW
        AWQTWGWQTZQWEWQUQZVEURWKWQUQZVEURSWLWQUQVEURZRWSVEUIWTVEUISXARSRUGDUSUO
        ZUTSSUFCUTSUBCUTUACUTZSAVRRZBWHCDXBUFUBUAUCUDUEUGHXBVAZIWHVAVBXCXDVSAXC
        VRAXCVRRZAECOZFCOZAXFRKLXGXHSZXCAVRXIXCEFUIZEWCFBPOWDEFBPZOFEWFBPOQUECU
        LUDCULUCCULRZEFWGUNWHOZXJEWGUIFWGUIQZSEFWGBPZOFEWGBPZTZWGXKTZQEXOTZFXPO
        ZXRQXSXQWGXKOQUPRXTFWGEBPOXMXNQREWQTZFWQTZWRQXKWQUQZVEURZXOWQUQZVEURSXP
        WQUQVEURZRYCVEUIZYEVEUISYFRSRUGXBUTSSUFCUTZSXDUAUBUFBWHCDXBEFUCUDUEUGHX
        EVCYHXDXLAYHVRGCOZAYHVRRMYIYHAVRYIYHEFGUNWHOZXJVRFGUIZQZSEFGBPZOFEGBPZT
        ZGXKTZQEYMTZFYNOZYPQYQYOGXKOQUPRZYRFGEBPOZYJYLQZRZYAYBGWQTQYDYMWQUQZVEU
        RSYNWQUQVEURZRYGUUCVEUISUUDRSRUGXBUTZSSXDUFBWHCXBEFGUGVDUUBXDYSUUEAYRUU
        AVRNYTYJXJVRYKVFVGVHVIVJVKVLVPVIVJVMVNVLVPVOVK @.
    @}

    @{
      @d a b c l p q r G @.  @d a b c p q r P @.  @d p q r X @.  @d q r Y @.
      @d r Z @.  @d t u v w x y z B @.  @d t x y z G @.  @d t u v w x y z X @.
      @d t u v w x y Y @.  @d t x Z @.  @d u v w x y z P @.
      @( If ` Y ` is between ` X ` and ` Z ` , then ` Y ` and ` Z ` , are
         distinct .  (For my private use only.  Don't use.)  (Contributed by
         FL, 20-May-2016.) @)
      isibg1a5a @p |- ( ph -> Y =/= Z ) @=
        ( wcel co w3a wi wa wnel vz vy vw vv vu vx vt cibg wne cig cv wrex ccol
        ctp cfv w3o cin wceq cplines wral eqid isibg2 isibg2aalem1 isibg2aalem2
        c0 simp33 imim12i ad2antrl syl6 com23 mpcom com12 syl2anc pm2.43i sylbi
        adantl ) DUHOZAFGUIZJVQDUJOZUAUKZUBUKZUIZVTUCUKZWABPOUDUKZVTWABPZOWAVTU
        EUKZBPOQUECULUDCULUCCULRVTWAUFUKZUNDUMUOZOZWBVTWGUIWAWGUIQZSVTWAWGBPZOW
        AVTWGBPZTZWGWETZQVTWKTZWAWLOZWNQWOWMWGWEOQUPRWPWAWGVTBPOWIWJQRVTUGUKZTW
        AWQTWGWQTZQWEWQUQZVEURWKWQUQZVEURSWLWQUQVEURZRWSVEUIWTVEUISXARSRUGDUSUO
        ZUTSSUFCUTSUBCUTUACUTZSAVRRZBWHCDXBUFUBUAUCUDUEUGHXBVAZIWHVAVBXCXDVSAXC
        VRAXCVRRZAECOZFCOZAXFRKLXGXHSZXCAVRXIXCEFUIZEWCFBPOWDEFBPZOFEWFBPOQUECU
        LUDCULUCCULRZEFWGUNWHOZXJEWGUIFWGUIQZSEFWGBPZOFEWGBPZTZWGXKTZQEXOTZFXPO
        ZXRQXSXQWGXKOQUPRXTFWGEBPOXMXNQREWQTZFWQTZWRQXKWQUQZVEURZXOWQUQZVEURSXP
        WQUQVEURZRYCVEUIZYEVEUISYFRSRUGXBUTSSUFCUTZSXDUAUBUFBWHCDXBEFUCUDUEUGHX
        EVCYHXDXLAYHVRGCOZAYHVRRMYIYHAVRYIYHEFGUNWHOZXJEGUIZVRQZSEFGBPZOFEGBPZT
        ZGXKTZQEYMTZFYNOZYPQYQYOGXKOQUPRZYRFGEBPOZYJYLQZRZYAYBGWQTQYDYMWQUQZVEU
        RSYNWQUQVEURZRYGUUCVEUISUUDRSRUGXBUTZSSXDUFBWHCXBEFGUGVDUUBXDYSUUEAYRUU
        AVRNYTYJXJYKVRVFVGVHVIVJVKVLVPVIVJVMVNVLVPVOVK @.
    @}

    @{
      @d l G @.  @d l M @.  @d l X @.  @d l Y @.  @d l Z @.  @d l ph @.
      isibg1a3a.8 @e |- M = ( line ` G ) @.
      @( If ` Y ` is between ` X ` and ` Z ` , it belongs to the line XZ (For
         my private use only.  Don't use.)  (Contributed by FL,
         20-May-2016.) @)
      isibg1a6 @p |- ( ph -> Y e. ( X M Z ) ) @=
        ( vl wcel wi 3ad2ant3 ctp ccol cfv co eqid isibg1a2 cv wss cplines wrex
        cvv isibg1a a1i iscol2 w3a tpssg simp12 cig wne isibg1spa simp11 simp13
        tpex simp2 lineval42 eleqtrd 3exp syl6bir com24 pm2.43i rexlimiv syl6bi
        com3l pm2.43a mpd ) AFGHUAZDUBUCZRZGFHEUDZRZABVQCDFGHIJKLMVQUEONUFVRAVT
        AVRVPQUGZUHZQDUIUCZUJAVTSZAVPUKDQADKULZVPUKRAFGHVCUMUNWBWDQWCAWAWCRZWBV
        TAWFWBVTSSAWBWFAVTAWBFWARZGWARZHWARZUOZWFWDSAFGHWACCCLMNUPWJWFAVTWJWFAU
        OZGWAVSWGWHWIWFAUQWKFHCDWCEWAIWCUEPAWJDURRWFWETAWJFCRWFLTAWJHCRWFNTAWJF
        HUSWFABCDFGHIJKLMNOUTTWGWHWIWFAVAWGWHWIWFAVBWJWFAVDVEVFVGVHVIVJVMVKVLVN
        VO @.
    @}

    @{
      isibg1a7.1 @e |- M = ( line ` G ) @.
      @( If ` Y ` is between ` X ` and ` Z ` , ` X ` belongs to the line YZ
         (For my private use only.  Don't use.)  (Contributed by FL,
         20-May-2016.) @)
      isibg1a7 @p |- ( ph -> X e. ( Y M Z ) ) @=
        ( co isibg1a lineval2a isibg1a6 isibg1a5a lineval5a eleqtrd ) AFFHEQGHE
        QAFHCDEIPADKRZLNSAFHGCDEIPUDLNABCDEFGHIJKLMNOPTABCDFGHIJKLMNOUAUBUC @.
    @}

    @{
      isibg1a8.1 @e |- M = ( line ` G ) @.
      @( If ` Y ` is between ` X ` and ` Z ` , ` Z ` belongs to the line XY
         (For my private use only.  Don't use.)  (Contributed by FL,
         20-May-2016.) @)
      isibg1a8 @p |- ( ph -> Z e. ( X M Y ) ) @=
        ( co isibg1a lineval2b isibg1a6 isibg1a3a lineval6a eleqtrd ) AHFHEQFGE
        QAFHCDEIPADKRZLNSAFHGCDEIPUDLNABCDEFGHIJKLMNOPTABCDFGHIJKLMNOUAUBUC @.
    @}

  @}


  @{
    bsstr.1 @e |- P = ( PPoints ` G ) @.
    bsstr.2 @e |- L = ( PLines ` G ) @.
    bsstr.3 @e |- B = ( btw ` G ) @.
    bsstr.4 @e |- ( ph -> G e. Ibg ) @.
    bsstr.5 @e |- ( ph -> M e. L ) @.

    @{
      @d t u v w x y z B @.  @d t x y z L @.  @d t M @.  @d t u v w x y z X @.
      @d t u v w x y Y @.  @d t x Z @.  @d u v w x y z P @.  @d x y z G @.
      bsstr.6 @e |- ( ph -> X e. ( P \ M ) ) @.
      bsstr.7 @e |- ( ph -> Y e. ( P \ M ) ) @.
      bsstr.8 @e |- ( ph -> Z e. ( P \ M ) ) @.
      bsstr.9 @e |- ( ph -> ( ( X B Y ) i^i M ) = (/) ) @.
      bsstr.10 @e |- ( ph -> ( ( Y B Z ) i^i M ) = (/) ) @.
      @( Being on the same side is a transitive relation.  (For my private use
         only.  Don't use.)  (Contributed by FL, 10-Jul-2016.) @)
      bsstr @p |- ( ph -> ( ( X B Z ) i^i M ) = (/) ) @=
        ( wi vz vy vw vv vu vx vt cibg wcel co cin c0 wceq cig wne w3a wrex ctp
        cv ccol cfv wa wnel w3o wral eqid isibg2 cdif isibg2aalem1 isibg2aalem2
        eldifi isibg2aalem3 eldifn df-nel pm2.27 syl2anc com12 adantr syl6 3exp
        wn com23 com34 com14 sylbir syl mpcom syl9 adantl ex sylbi ) DUHUIZAGIB
        UJZFUKULUMZMWLDUNUIZUAUSZUBUSZUOZWPUCUSZWQBUJUIUDUSZWPWQBUJZUIWQWPUEUSZ
        BUJUIUPUECUQUDCUQUCCUQTWPWQUFUSZURDUTVAZUIZWRWPXCUOWQXCUOUPZVBWPWQXCBUJ
        ZUIWQWPXCBUJZVCZXCXAVCZUPWPXGVCZWQXHUIZXJUPXKXIXCXAUIUPVDTXLWQXCWPBUJUI
        XEXFUPTWPUGUSZVCWQXMVCXCXMVCZUPXAXMUKZULUMXGXMUKZULUMVBXHXMUKULUMZTXOUL
        UOXPULUOVBXQTVBTUGEVEVBVBUFCVEVBUBCVEUACVEZVBAWNTZBXDCDEUFUBUAUCUDUEUGJ
        KLXDVFVGXRXSWOAXRWNHCFVHZUIZAXRWNTZPYAHCUIZAYBTZHCFVKAYCYBGXTUIZAYCYBTZ
        OYEGCUIZAYFTGCFVKYGYCAYBYGYCYDYGYCVBZXRAWNYHXRGHUOZGWSHBUJUIWTGHBUJZUIH
        GXBBUJUIUPUECUQUDCUQUCCUQTZGHXCURXDUIZYIGXCUOHXCUOUPZVBGHXCBUJZUIHGXCBU
        JZVCZXCYJVCZUPGYNVCZHYOUIZYQUPYRYPXCYJUIUPVDTYSHXCGBUJUIYLYMUPTGXMVCZHX
        MVCZXNUPYJXMUKZULUMZYNXMUKZULUMVBYOXMUKULUMZTUUBULUOZUUDULUOVBUUETVBTUG
        EVEVBVBUFCVEZVBXSUAUBUFBXDCDEGHUCUDUEUGJKVIUUGXSYKAUUGWNIXTUIZAUUGWNTZQ
        UUHICUIZAUUITICFVKUUJUUGAWNUUJUUGGHIURXDUIZYIGIUOHIUOUPZVBGHIBUJZUIHWMV
        CZIYJVCZUPGUUMVCZHWMUIZUUOUPUUPUUNIYJUIUPVDTZUUQHIGBUJUIUUKUULUPTZYTUUA
        IXMVCUPUUCUUMXMUKZULUMVBWMXMUKULUMZTUUFUUTULUOVBUVATVBTUGEVEZVBZVBXSUFB
        XDCEGHIUGVJUVCXSUURUVBXSUUSAUVBWNFEUIZAUVBWNTNUVDUVBGFVCZHFVCZIFVCZUPZY
        JFUKZULUMZUUMFUKZULUMZVBZWNTZUVIULUOUVKULUOVBWNTZVBZTZAWNBEFGHIUGVLYEAU
        VQWNTZOYEGFUIWAZAUVRTZGCFVMUVSUVEUVTGFVNAUVEUVRYAAUVEUVRTZPYAHFUIWAZAUW
        ATZHCFVMUWBUVFUWCHFVNAUVFUWAUUHAUVFUWATZQUUHIFUIWAZAUWDTZICFVMUWEUVGUWF
        IFVNUVEAUVFUVGUVRUVEUVFAUVGUVRTUVEUVFUVGAUVRUVEUVFUVGUVTUVHUVQAWNUVHUVQ
        UVPXSUVHUVPVOUVNXSUVOAUVNWNAUVJUVLUVNWNTRSUVMWNVOVPVQVRVSWBVTWCWBWDWEWF
        WGVQWEWFWGVQWEWFWGWHWGVQWIWIVSWBWFWGVQWIVSWBWJWBWFWGVQWFWGVQWIWKWG @.

    @}

    @{
      @d t u v w x y z B @.  @d t x y z L @.  @d t M @.  @d t u v w x y z X @.
      @d t u v w x y Y @.  @d t x Z @.  @d u v w x y z P @.  @d x y z G @.
      nbssntr.6 @e |- ( ph -> X e. ( P \ M ) ) @.
      nbssntr.7 @e |- ( ph -> Y e. ( P \ M ) ) @.
      nbssntr.8 @e |- ( ph -> Z e. ( P \ M ) ) @.
      nbssntr.9 @e |- ( ph -> ( ( X B Y ) i^i M ) =/= (/) ) @.
      nbssntr.10 @e |- ( ph -> ( ( Y B Z ) i^i M ) =/= (/) ) @.
      @( IF ` X ` and ` Y ` are not on the same side, and ` Y ` and ` Z ` are
         not on the same side then ` X ` and ` Z ` are on the same side.  (For
         my private use only.  Don't use.)  (Contributed by FL,
         10-Jul-2016.) @)
      nbssntr @p |- ( ph -> ( ( X B Z ) i^i M ) = (/) ) @=
        ( wi vz vy vw vv vu vx vt cibg wcel co cin c0 wceq cig wne w3a wrex ctp
        cv ccol cfv wa wnel w3o wral eqid isibg2 cdif isibg2aalem1 isibg2aalem2
        eldifi isibg2aalem3 eldifn df-nel pm2.27 syl2anc com12 adantl syl6 3exp
        wn com23 com34 com14 sylbir syl mpcom syl9 ex sylbi ) DUHUIZAGIBUJZFUKU
        LUMZMWKDUNUIZUAUSZUBUSZUOZWOUCUSZWPBUJUIUDUSZWOWPBUJZUIWPWOUEUSZBUJUIUP
        UECUQUDCUQUCCUQTWOWPUFUSZURDUTVAZUIZWQWOXBUOWPXBUOUPZVBWOWPXBBUJZUIWPWO
        XBBUJZVCZXBWTVCZUPWOXFVCZWPXGUIZXIUPXJXHXBWTUIUPVDTXKWPXBWOBUJUIXDXEUPT
        WOUGUSZVCWPXLVCXBXLVCZUPWTXLUKZULUMXFXLUKZULUMVBXGXLUKULUMZTXNULUOXOULU
        OVBXPTVBTUGEVEVBVBUFCVEVBUBCVEUACVEZVBAWMTZBXCCDEUFUBUAUCUDUEUGJKLXCVFV
        GXQXRWNAXQWMHCFVHZUIZAXQWMTZPXTHCUIZAYATZHCFVKAYBYAGXSUIZAYBYATZOYDGCUI
        ZAYETGCFVKYFYBAYAYFYBYCYFYBVBZXQAWMYGXQGHUOZGWRHBUJUIWSGHBUJZUIHGXABUJU
        IUPUECUQUDCUQUCCUQTZGHXBURXCUIZYHGXBUOHXBUOUPZVBGHXBBUJZUIHGXBBUJZVCZXB
        YIVCZUPGYMVCZHYNUIZYPUPYQYOXBYIUIUPVDTYRHXBGBUJUIYKYLUPTGXLVCZHXLVCZXMU
        PYIXLUKZULUMZYMXLUKZULUMVBYNXLUKULUMZTUUAULUOZUUCULUOVBUUDTVBTUGEVEVBVB
        UFCVEZVBXRUAUBUFBXCCDEGHUCUDUEUGJKVIUUFXRYJAUUFWMIXSUIZAUUFWMTZQUUGICUI
        ZAUUHTICFVKUUIUUFAWMUUIUUFGHIURXCUIZYHGIUOHIUOUPZVBGHIBUJZUIHWLVCZIYIVC
        ZUPGUULVCZHWLUIZUUNUPUUOUUMIYIUIUPVDTZUUPHIGBUJUIUUJUUKUPTZYSYTIXLVCUPU
        UBUULXLUKZULUMVBWLXLUKULUMZTUUEUUSULUOVBUUTTVBTUGEVEZVBZVBXRUFBXCCEGHIU
        GVJUVBXRUUQUVAXRUURAUVAWMFEUIZAUVAWMTNUVCUVAGFVCZHFVCZIFVCZUPZYIFUKZULU
        MUULFUKZULUMVBWMTZUVHULUOZUVIULUOZVBZWMTZVBZTZAWMBEFGHIUGVLYDAUVPWMTZOY
        DGFUIWAZAUVQTZGCFVMUVRUVDUVSGFVNAUVDUVQXTAUVDUVQTZPXTHFUIWAZAUVTTZHCFVM
        UWAUVEUWBHFVNAUVEUVTUUGAUVEUVTTZQUUGIFUIWAZAUWCTZICFVMUWDUVFUWEIFVNUVDA
        UVEUVFUVQUVDUVEAUVFUVQTUVDUVEUVFAUVQUVDUVEUVFUVSUVGUVPAWMUVGUVPUVOXRUVG
        UVOVOUVNXRUVJAUVNWMAUVKUVLUVNWMTRSUVMWMVOVPVQVRVSWBVTWCWBWDWEWFWGVQWEWF
        WGVQWEWFWGWHWGVQVRVRVSWBWFWGVQVRVSWBWIWBWFWGVQWFWGVQVRWJWG @.
    @}

  @}

  @( Function returning a segment. @)
  @c seg @.

  @( Extend class notation with the segment symbol. @)
  cseg @a class seg @.

  @{
    @d f x y z @.
    @( Definition of the segment xy degenerated or not.  Definition 8 of
       [AitkenIBG] p. 4.  (For my private use only.  Don't use.)  (Contributed
       by FL, 28-Feb-2016.) @)
    df-seg2 @a |- seg = ( f e. Ibg |-> ( x e. ( PPoints ` f ) ,
      y e. ( PPoints ` f ) |-> if ( x =/= y ,
         { z e. ( PPoints ` f ) |
       ( z e. ( x ( btw ` f ) y ) \/ z = x \/ z = y ) } , { x } ) ) ) @.
  @}

  @{
    @d f x y G @.  @d x y B @.  @d x y P @.  @d x y X @.  @d x y Y @.
    sgplpte.1 @e |- P = ( PPoints ` G ) @.
    sgplpte.3 @e |- S = ( seg ` G ) @.
    sgplpte.4 @e |- ( ph -> G e. Ibg ) @.
    sgplpte.5 @e |- ( ph -> X e. P ) @.

    @{
      @d f x y z G @.  @d f x y z ph @.  @d x y B @.  @d x y z P @.
      @d x y z X @.  @d x y z Y @.
      sgplpte21.2 @e |- B = ( btw ` G ) @.
      sgplpte21.6 @e |- ( ph -> Y e. P ) @.
      sgplpte21.7 @e |- ( ph -> X =/= Y ) @.
      @( The predicate "is a non-degenerated segment".  (For my private use
         only.  Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte21 @p |- ( ph -> ( X S Y ) =
        { z e. P | ( z e. ( X B Y ) \/ z = X \/ z = Y ) } ) @=
        ( vx vy co wcel wceq vf cseg cfv w3o crab a1i oveqd wne csn cif cpoints
        cv cbtw cmpt2 cibg cvv cmpt df-seg2 fveq2 adantl eleq2d biidd 3orbi123d
        wa rabeqbidv ifeq1d mpt2eq123dv fvex mpt2ex fvmptd eqcomi simprl simprr
        neeq12d wb oveq12 simpl eqeq2d simpr rabbidv ad2antrl ifbieq12d eqeltri
        sneq rabex snex ifex ovmpt2d eqtrd iftrue syl ) AGHERGHFUBUCZRZBULZGHCR
        ZSZWNGTZWNHTZUDZBDUEZAEWLGHEWLTAJUFUGAWMGHUHZWTGUIZUJZWTAWMGHPQFUKUCZXD
        PULZQULZUHZWNXEXFFUMUCZRZSZWNXETZWNXFTZUDZBXDUEZXEUIZUJZUNZRXCAWLXQGHAU
        AFPQUAULZUKUCZXSXGWNXEXFXRUMUCZRZSZXKXLUDZBXSUEZXOUJZUNZXQUOUBUPUBUAUOY
        FUQTAPQBUAURUFAXRFTZVDZPQXSXSYEXDXDXPYGXSXDTAXRFUKUSUTZYIYHXGYDXNXOYHYC
        XMBXSXDYIYHYBXJXKXKXLXLYHYAXIWNYHXTXHXEXFYGXTXHTAXRFUMUSUTUGVAYHXKVBYHX
        LVBVCVEVFVGKXQUPSAPQXDXDXPFUKVHZYJVIUFVJUGAPQGHDDXGWNXEXFCRZSZXKXLUDZBD
        UEZXOUJZXCXQUPAPQXDXDXPDDYOXDDTADXDIVKUFZYPAXGXNYNXOAXMYMBXDDYPAXJYLXKX
        KXLXLAXIYKWNAXHCXEXFXHCTACXHMVKUFUGVAAXKVBAXLVBVCVEVFVGAXEGTZXFHTZVDZVD
        ZXGXAYNXOWTXBYTXEGXFHAYQYRVLAYQYRVMVNYTYMWSBDYSYMWSVOAYSYLWPXKWQXLWRYSY
        KWOWNXEGXFHCVPVAYSXEGWNYQYRVQVRYSXFHWNYQYRVSVRVCUTVTYQXOXBTAYRXEGWDWAWB
        LNXCUPSAXAWTXBWSBDDXDUPIYJWCWEGWFWGUFWHWIAXAXCWTTOXAWTXBWJWKWIWI @.
    @}

    @{
      @d f x y G @.  @d u z P @.  @d u B @.  @d u z S @.  @d u z X @.
      @d u z Y @.  @d x y B @.  @d x y P @.  @d x y X @.  @d x y Y @.
      @d z G @.  @d z ph @.
      sgplpte21a.2 @e |- B = ( btw ` G ) @.
      sgplpte21a.6 @e |- ( ph -> Y e. P ) @.
      sgplpte21a.7 @e |- ( ph -> X =/= Y ) @.
      @( The predicate "is a non-degenerated segment".  (For my private use
         only.  Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte21a @p |- ( ph -> A. z ( z e. ( X S Y ) <->
         ( z e. P /\ ( z e. ( X B Y ) \/ z = X \/ z = Y ) ) ) ) @=
        ( co wcel wceq wb wal cv w3o crab sgplpte21 nfcv nfrab1 cleqf rabid a1i
        wa bibi2d albidv syl5bb mpbid ) AGHEPZBUAZGHCPQUPGRUPHRUBZBDUCZRZUPUOQZ
        UPDQUQUJZSZBTZABCDEFGHIJKLMNOUDUSUTUPURQZSZBTAVCBUOURBUOUEUQBDUFUGAVEVB
        BAVDVAUTVDVASAUQBDUHUIUKULUMUN @.
    @}

    @{
      @d f x y G @.  @d x y B @.  @d x y P @.  @d x y X @.  @d x y Y @.
      @d z B @.  @d z G @.  @d z P @.  @d z S @.  @d z X @.  @d z Y @.
      @d z Z @.  @d z ph @.
      sgplpte21b.2 @e |- B = ( btw ` G ) @.
      sgplpte21b.6 @e |- ( ph -> Y e. P ) @.
      sgplpte21b.7 @e |- ( ph -> X =/= Y ) @.
      sgplpte21b.8 @e |- ( ph -> Z e. _V ) @.
      @( The predicate "is a non-degenerated segment".  (For my private use
         only.  Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte21b @p |- ( ph -> ( Z e. ( X S Y ) <->
         ( Z e. P /\ ( Z e. ( X B Y ) \/ Z = X \/ Z = Y ) ) ) ) @=
        ( vz wcel wceq eleq1 cvv cv co w3o wa wb wal sgplpte21a eqeq1 3orbi123d
        anbi12d bibi12d spcgv sylc ) AHUARQUBZFGDUCZRZUOCRZUOFGBUCZRZUOFSZUOGSZ
        UDZUEZUFZQUGHUPRZHCRZHUSRZHFSZHGSZUDZUEZUFZPAQBCDEFGIJKLMNOUHVEVMQHUAUO
        HSZUQVFVDVLUOHUPTVNURVGVCVKUOHCTVNUTVHVAVIVBVJUOHUSTUOHFUIUOHGUIUJUKULU
        MUN @.
    @}

    @{
      sgplpte21c.2 @e |- B = ( btw ` G ) @.
      sgplpte21c.6 @e |- ( ph -> Y e. P ) @.
      sgplpte21c.7 @e |- ( ph -> X =/= Y ) @.
      @( The predicate "is a non-degenerated segment".  (For my private use
         only.  Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte21c @p |- ( ph -> ( Z e. ( X S Y ) ->
         ( Z e. P /\ ( Z e. ( X B Y ) \/ Z = X \/ Z = Y ) ) ) ) @=
        ( co wcel wceq wa adantl w3o cibg wne cvv elex adantr sgplpte21b biimpd
        wi ex pm2.43b ) AHFGDPZQZHCQHFGBPQHFRHGRUASZUMAUMUNUIUMASZUMUNUOBCDEFGH
        IJAEUBQUMKTAFCQUMLTMAGCQUMNTAFGUCUMOTUMHUDQAHULUEUFUGUHUJUK @.

    @}

    @{
      sgplpte21d.2 @e |- B = ( btw ` G ) @.
      sgplpte21d.6 @e |- ( ph -> Y e. P ) @.
      sgplpte21d.7 @e |- ( ph -> X =/= Y ) @.
      @( The predicate "is a non-degenerated segment".  (For my private use
         only.  Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte21d @p |- ( ph -> (
         ( Z e. P /\ ( Z e. ( X B Y ) \/ Z = X \/ Z = Y ) )
            -> Z e. ( X S Y ) ) ) @=
        ( wcel co wceq wa adantl w3o cibg wne cvv elex adantr sgplpte21b exbiri
        wi com23 anabsi5 com12 ) HCPZHFGBQPHFRHGRUAZSZAHFGDQPZUMUNAUPUIUMAUOUPU
        MAUPUOUMASBCDEFGHIJAEUBPUMKTAFCPUMLTMAGCPUMNTAFGUCUMOTUMHUDPAHCUEUFUGUH
        UJUKUL @.
    @}


    @{
      sgplpte21e.2 @e |- B = ( btw ` G ) @.
      sgplpte21e.6 @e |- ( ph -> Y e. P ) @.
      sgplpte21e.7 @e |- ( ph -> X =/= Y ) @.
      @( The predicate "is a non-degenerated segment".  (For my private use
         only.  Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte21e @p |- ( ph -> ( Z e. ( X S Y ) <->
         ( Z e. P /\ ( Z e. ( X B Y ) \/ Z = X \/ Z = Y ) ) ) ) @=
        ( co wcel wceq w3o wa sgplpte21c sgplpte21d impbid ) AHFGDPQHCQHFGBPQHF
        RHGRSTABCDEFGHIJKLMNOUAABCDEFGHIJKLMNOUBUC @.
    @}

    @{
      @d f x y z G @.  @d f x y z ph @.  @d x y B @.  @d x y z P @.
      @d x y z X @.  @d x y Y @.
      @( The predicate "is a degenerated segment".  (For my private use only.
         Don't use.)  (Contributed by FL, 20-May-2016.) @)
      sgplpte22 @p |- ( ph -> ( X S X ) = { X } ) @=
        ( vx vy vz vf co cpoints cfv wcel wceq cvv adantl wne cbtw w3o crab csn
        cv cif cmpt2 cseg cibg cmpt df-seg2 a1i wa fveq2 oveqd eleq2d 3orbi123d
        biidd rabeqbidv ifeq1d mpt2eq123dv mpt2ex fvmptd syl5eq eqcomi wb simpl
        fvex simpr neeq12d oveq12 eqeq2 ad2antrl rabbidv sneq ifbieq12d eqeltri
        rabex snex ifex ovmpt2d wn neirr iffalse mp1i 3eqtrd ) AEECNEEJKDOPZWHJ
        UFZKUFZUAZLUFZWIWJDUBPZNZQZWLWIRZWLWJRZUCZLWHUDZWIUEZUGZUHZNEEUAZWLEEWM
        NZQZWLERZXFUCZLBUDZEUEZUGZXIACXBEEACDUIPXBGAMDJKMUFZOPZXLWKWLWIWJXKUBPZ
        NZQZWPWQUCZLXLUDZWTUGZUHZXBUJUISUIMUJXSUKRAJKLMULUMAXKDRZUNZJKXLXLXRWHW
        HXAXTXLWHRAXKDOUOTZYBYAWKXQWSWTYAXPWRLXLWHYBYAXOWOWPWPWQWQYAXNWNWLYAXMW
        MWIWJXTXMWMRAXKDUBUOTUPUQYAWPUSYAWQUSURUTVAVBHXBSQAJKWHWHXADOVIZYCVCUMV
        DVEUPAJKEEBBWKWRLBUDZWTUGZXJXBSAJKWHWHXABBYEWHBRABWHFVFUMZYFAWKWSYDWTAW
        RWRLWHBYFAWRUSUTVAVBAWIERZWJERZUNZUNZWKXCYDWTXHXIYIWKXCVGAYIWIEWJEYGYHV
        HYGYHVJVKTYJWRXGLBYJWOXEWPXFWQXFYIWOXEVGAYIWNXDWLWIEWJEWMVLUQTYGWPXFVGA
        YHWIEWLVMVNYIWQXFVGZAYHYKYGWJEWLVMTTURVOYGWTXIRAYHWIEVPVNVQIIXJSQAXCXHX
        IXGLBBWHSFYCVRVSEVTWAUMWBXCWCXJXIRAEWDXCXHXIWEWFWG @.
    @}


    @{
      sgplpte21d1.6 @e |- ( ph -> Y e. P ) @.
      @( The extremities belong to a segment.  (For my private use only.  Don't
         use.)  (Contributed by FL, 29-Jul-2016.) @)
      sgplpte21d1 @p |- ( ph -> X e. ( X S Y ) ) @=
        ( co wcel wi wceq csn snidg wa adantl eqid syl sgplpte22 eleqtrrd oveq2
        eleq2d syl5ibr eqcoms wne cbtw cibg simpl sgplpte21d simpr 3mix2 adantr
        cfv w3o pm2.27 syl2anc mpan sylc ex pm2.61ine ) AEEFCLZMZNZEFVFFEAVEFEO
        ZEEECLZMAEEPZVHAEBMZEVIMJEBQUAABCDEGHIJUBUCVGVDVHEFEECUDUEUFUGEFUHZAVEV
        KARZVJVJEEFDUIUPZLMZEEOZEFOZUQZRZVENZVEAVJVKJSZVLVMBCDEFEGHADUJMVKISVTV
        MTAFBMVKKSVKAUKULVOVJVSVENZETVOVJRVJVQWAVOVJUMVOVQVJVOVNVPUNUOVRVEURUSU
        TVAVBVC @.

      @( The extremities belong to a segment.  (For my private use only.  Don't
         use.)  (Contributed by FL, 29-Jul-2016.) @)
      sgplpte21d2 @p |- ( ph -> Y e. ( X S Y ) ) @=
        ( co wcel wi wceq sgplpte21d1 oveq1 wa adantl eqid syl5ibr wne cbtw cfv
        eleq2d w3o cibg simpl sgplpte21d simpr 3mix3 adantr pm2.27 syl2anc mpan
        sylc ex pm2.61ine ) AFEFCLZMZNEFAUTEFOZFFFCLZMABCDFFGHIKKPVAUSVBFEFFCQU
        EUAEFUBZAUTVCARZFBMZVEFEFDUCUDZLMZFEOZFFOZUFZRZUTNZUTAVEVCKSZVDVFBCDEFF
        GHADUGMVCISAEBMVCJSVFTVMVCAUHUIVIVEVLUTNZFTVIVERVEVJVNVIVEUJVIVJVEVIVGV
        HUKULVKUTUMUNUOUPUQUR @.
    @}

    @{
      @d f x y G @.  @d x y B @.  @d x M @.  @d x y P @.  @d x S @.
      @d x y X @.  @d x y Y @.  @d x ph @.
      segline.1 @e |- M = ( line ` G ) @.
      segline.2 @e |- ( ph -> Y e. P ) @.
      @( A segment is a part of a line.  (For my private use only.  Don't
         use.)  (Contributed by FL, 20-May-2016.) @)
      segline @p |- ( ph -> ( X S Y ) C_ ( X M Y ) ) @=
        ( co wss wi wa wcel adantl eleq1 vx wceq ssid sgplpte22 isibg1a sseq12d
        csn lineval3a mpbiri id eqcomd oveq2d syl5ibr wne cv cbtw cfv cibg eqid
        w3o simpl sgplpte21e w3a 3ad2ant3 simp2 simp1 isibg1a6 cig lineval2a ex
        3exp imbi2d imbi12d lineval2b 3jaoi impcom com12 sylbid ssrdv pm2.61ine
        ) AFGCNZFGENZOZPFGAWCFGUBZFFCNZFFENZOZAWGFUGZWHOWHUCAWEWHWFWHABCDFHIJKU
        DAFBDEHLADJUEZKUHUFUIWDWAWEWBWFWDGFFCWDFGWDUJUKZULWDGFFEWJULUFUMFGUNZAW
        CWKAQZUAWAWBWLUAUOZWARWMBRZWMFGDUPUQZNRZWMFUBZWMGUBZUTZQZWMWBRZWLWOBCDF
        GWMHIADURRZWKJSZAFBRZWKKSZWOUSZAGBRZWKMSZWKAVAVBWTWLXAWSWNWLXAPZWPWNXIP
        ZWQWRWPWNWLXAWPWNWLVCWOBDEFWMGHXFWLWPXBWNXCVDWLWPXDWNXEVDWPWNWLVEWLWPXG
        WNXHVDWPWNWLVFLVGVKWQXJXDWLFWBRZPZPXDWLXKXDWLQFGBDEHLWLDVHRZXDAXMWKWISZ
        SXDWLVAWLXGXDXHSVIVJWQWNXDXIXLWMFBTWQXAXKWLWMFWBTVLVMUIWRXJXGWLGWBRZPZP
        XGWLXOXGWLQFGBDEHLWLXMXGXNSWLXDXGXESXGWLVAVNVJWRWNXGXIXPWMGBTWRXAXOWLWM
        GWBTVLVMUIVOVPVQVRVSVJVT @.
    @}

    @{
      @d f x y G @.  @d x y B @.  @d x y P @.  @d x y X @.  @d x y Y @.
      @d z B @.  @d z P @.  @d z S @.  @d z X @.  @d z Y @.  @d z ph @.
      pxysxy.1 @e |- B = ( btw ` G ) @.
      pxysxy.2 @e |- ( ph -> Y e. P ) @.
      pxysxy.3 @e |- ( ph -> X =/= Y ) @.
      @( Points between ` X ` and ` Y ` belong to the segment XY. (For my
         private use only.  Don't use.)  (Contributed by FL, 17-Jul-2016.) @)
      pxysxy @p |- ( ph -> ( ( X B Y ) i^i P ) C_ ( X S Y ) ) @=
        ( vz co wcel wa wceq imp cin cv elin w3a w3o simp1 simp2 3mix1 3ad2ant3
        wi sgplpte21d syl12anc 3exp com13 sylbi com12 ssrdv ) AOFGBPZCUAZFGDPZO
        UBZUSQZAVAUTQZVBVAURQZVACQZRAVCUJZVAURCUCVDVEVFAVEVDVCAVEVDVCAVEVDUDAVE
        VDVAFSZVAGSZUEZVCAVEVDUFAVEVDUGVDAVIVEVDVGVHUHUIAVEVIRVCABCDEFGVAHIJKLM
        NUKTULUMUNTUOUPUQ @.
    @}

  @}

  @{
    lppotoslem.6 @e |- ( ph -> ( M1 i^i M2 ) = { X } ) @.
    lppotoslem.8 @e |- ( ph -> Y e. M1 ) @.
    lppotoslem.9 @e |- ( ph -> X =/= Y ) @.
    @( To show that a point doesn't belong to a line ` M2 ` .  (For my private
       use only.  Don't use.)  (Contributed by FL, 14-Jul-2016.) @)
    lppotoslem @p |- ( ph -> -. Y e. M2 ) @=
      ( wcel wn wi wa cin elin csn eleq2d wceq elsni wne syl df-ne pm2.21 sylbi
      com12 eqcoms syl6bi pm2.43b sylbir ex com23 mpcom pm2.01d ) ACEIZCDIZAUMU
      MJZKGUNUMAUOUNUMAUOKZUNUMLCDEMZIZUPCDENURAUOAURCBOZIZUPAUQUSCFPUTCBQUPCBR
      UPBCABCQZUOABCSZVAUOKZHVBVAJVCBCUAVAUOUBUCTUDUETUFUGUHUIUJUKUL @.
  @}


  @{
    @d x y z M @.  @d x L @.  @d x y z P @.  @d x y z S @.  @d x y z X @.
    @d x z ph @.  @d z G @.
    lppotos.1 @e |- P = ( PPoints ` G ) @.
    lppotos.2 @e |- L = ( PLines ` G ) @.
    lppotos.3 @e |- S = ( seg ` G ) @.
    lppotos.4 @e |- ( ph -> G e. Ibg ) @.
    lppotos.5 @e |- ( ph -> X e. ( P \ M ) ) @.
    lppotos.6 @e |- ( ph -> M e. L ) @.
    @( Given a line ` M ` and a point ` X ` not on this line.  There exists a
       point on the other side of the line.  (For my private use only.  Don't
       use.)  (Contributed by FL, 10-Aug-2016.) @)
    lppotos @p |- ( ph ->
      E. y e. ( P \ M ) ( ( X S y ) i^i M ) =/= (/) ) @=
      ( vx wcel wi 3ad2ant1 adantr adantl vz cv wrex co cin c0 wne cdif isibg1a
      elhalop2 wn eldifn wceq wa nelneq df-ne cbtw cfv w3a eqid cibg eldifi syl
      necom 3ad2ant3 simp2 isibg2a3 simpl1 cline simpl3 simpl2 isibg1a6 csn cig
      simp1rr simprl3 simprl2 isibg1spa lineval12 lineval2a simp3r syl2anc elin
      nelne1 simplbi2com com12 3adant2 isconcl7a lineval2b isibg1a5a lppotoslem
      id imp mpancom 3exp 3exp1 com25 3imp com3l 3imp1 sylanbrc wex w3o simpl33
      eldif 3mix1d sgplpte21e mpbir2and simprl 19.8a sylibr oveq2 ineq1d neeq1d
      n0 rspcev rexlimiv mpcom com34 com4l sylbi sylbir ex com24 com14 ) OUBZGP
      ZOCUCAHBUBZDUDZGUEZUFUGZBCGUHZUCZAOCEFGIJAELUIZNUJYGAYMQZOCAYFCPZYGYMHYLP
      ZAYPYGYMQQZMYQHGPUKZAYRQHCGULYGAYPYSYMYGYSYPAYMYGYSYPYOQZYFHUMZUKZYGYSUNZ
      YTYFHGUOUUBYFHUGZUUCYTQZYFHUPUUDHYFUGZUUEYFHVDAUUFUUCYPYMAUUFYPUUCYMAUUFY
      PUUCYMQZYFHUAUBZEUQURZUDPZUACUCAUUFYPUSZUUGUUKUUICEHYFUAIUUIUTZAUUFEVAPZY
      PLRZAUUFHCPZYPAYQUUOMHCGVBVCZRZYPAYPUUFYPWLVEAUUFYPVFVGUUJUUKUUGQUACUUHCP
      ZUUJUUKUUCYMUURUUJUUKUSZUUCUNZUUHYLPZHUUHDUDZGUEZUFUGZYMUUTUURUUHGPUKZUVA
      UURUUJUUKUUCVHZUURUUJUUKUUCUVEUUKUURUUJUUCUVEQZAUUFYPUURUUJUVGQQAUUJYPUUR
      UUFUVGAUUJYPUURUUFUVGQZYFHUUHEVIURZUDZPZAUUJYPUSZUURUNZUVHUVMUUICEUVIHYFU
      UHIUULUVLUUMUURAUUJUUMYPLRSZUVLUUOUURAUUJUUOYPUUPRSZAUUJYPUURVJUURUURUVLU
      URWLTAUUJYPUURVKUVIUTZVLUVKUVMUNZUUFUUCUVEUVJGUEZYFVMUMZUVQUUFUUCUSZUVEUV
      TEFYFUVJGJUVQUUFEVNPZUUCUVMUWAUVKUVLUWAUURAUUJUWAYPYNRSTRZUVTHUUHCEFUVIIJ
      UVPUWBUVQUUFUUOUUCUVMUUOUVKUVOTRZUVLUURUVKUUFUUCVOZUVTUUICEHYFUUHIUULUVQU
      UFUUMUUCUVMUUMUVKUVNTRZUWCUVQUUFYPUUCAUUJYPUURUVKVPRZUWDUVQUUFUUJUUCAUUJY
      PUURUVKVQRZVRVSUVQUUFGFPZUUCUVMUWHUVKUVLUWHUURAUUJUWHYPNRSTRUVTHUVJPYSUVJ
      GUGUVTHUUHCEUVIIUVPUWBUWCUWDVTUVQUUFYGYSWAHUVJGWDWBUVQUUCYFUVRPZUUFUVQUUC
      UWIUVKUUCUWIQUVMUUCUVKUWIYGUVKUWIQYSUWIUVKYGYFUVJGWCWESWFSWMWGWHUVSUVTUNZ
      YFUUHUVJGUVSUVSUVTUVSWLSUWJHUUHCEUVIIUVPUVTUWAUVSUWBTUVTUUOUVSUWCTZUVTUUR
      UVSUWDTZWIUWJUUICEHYFUUHIUULUVTUUMUVSUWETUWKUVTYPUVSUWFTUWLUVTUUJUVSUWGTW
      JWKWNWOWNWPWQWRWSWTUUHCGXEXAUUTYFUVCPZOXBZUVDUUTUWMUWNUUTYFUVBPZYGUWMUUTU
      WOYPUUJUUAYFUUHUMZXCAUUFYPUURUUJUUCXDZUUTUUJUUAUWPUURUUJUUKUUCVKZXFUUTUUI
      CDEHUUHYFIKUUSUUMUUCUUKUURUUMUUJUUNVESZUUSUUOUUCUUKUURUUOUUJUUQVESZUULUVF
      UUTUUICEHYFUUHIUULUWSUWTUWQUVFUWRVRXGXHUUSYGYSXIYFUVBGWCXAUWMOXJVCOUVCXOX
      KYKUVDBUUHYLYHUUHUMZYJUVCUFUXAYIUVBGYHUUHHDXLXMXNXPWBWPXQXRWOXSXTYAYBXRYC
      YDYEVCXRWSXQXR @.
  @}


  @{
    xsyysx.1 @e |- P = ( PPoints ` G ) @.
    xsyysx.3 @e |- S = ( seg ` G ) @.
    xsyysx.4 @e |- ( ph -> G e. Ibg ) @.
    xsyysx.5 @e |- ( ph -> X e. P ) @.
    xsyysx.6 @e |- ( ph -> Y e. P ) @.

    @{
      @d x G @.  @d x P @.  @d x X @.  @d x Y @.  @d x ph @.
      @( The segments xy and yx are equal.  (For my private use only.  Don't
         use.)  (Contributed by FL, 17-Jul-2016.) @)
      xsyysx @p |- ( ph -> ( X S Y ) = ( Y S X ) ) @=
        ( vx wceq co wi wa wcel adantl adantr a1d eqidd id eqcoms oveq2d oveq1d
        eqeq12d syl5ibr wn cbtw cfv w3o crab eqid simpr isib2g1a1 3mix1d expcom
        cv cibg 3mix3 3mix2 3jaoi com12 simpl impbid rabbidva wne df-ne biimpri
        ex sgplpte21 necomd 3eqtr4d pm2.61i ) EFMZAEFCNZFECNZMZOAVRVOEECNZVSMAV
        SUAVOVPVSVQVSVOFEECFEMZFEVTUBUCZUDVOFEECWAUEUFUGVOUHZAVRWBAPZLURZEFDUIU
        JZNQZWDEMZWDFMZUKZLBULWDFEWENQZWHWGUKZLBULVPVQWCWIWKLBWCWDBQZPZWIWKWIWM
        WKWFWMWKOWGWHWMWFWKWMWFPZWJWHWGWNWEBDEWDFGWEUMZWMDUSQZWFWCWPWLAWPWBIRZS
        ZSWMEBQZWFWCWSWLAWSWBJRZSZSWMWLWFWCWLUNZSWMFBQZWFWCXCWLAXCWBKRZSZSWMWFU
        NUOUPUQWGWKWMWGWJWHUTTWHWKWMWHWJWGVATVBVCWKWMWIWJWMWIOWHWGWJWMWIWJWMPZW
        FWGWHXFWEBDFWDEGWOWMWPWJWRRWMXCWJXERWMWLWJXBRWMWSWJXARWJWMVDUOUPVJWHWIW
        MWHWFWGUTTWGWIWMWGWFWHVATVBVCVEVFWCLWEBCDEFGHWQWTWOXDWBEFVGZAXGWBEFVHVI
        ZSVKWCLWEBCDFEGHWQXDWOWTWBFEVGAWBEFXHVLSVKVMVJVN @.
    @}

  @}

  @{
    bsstrs.1 @e |- P = ( PPoints ` G ) @.
    bsstrs.2 @e |- L = ( PLines ` G ) @.
    bsstrs.3 @e |- S = ( seg ` G ) @.
    bsstrs.4 @e |- ( ph -> G e. Ibg ) @.
    bsstrs.5 @e |- ( ph -> M e. L ) @.

    @{
      @d x G @.  @d x M @.  @d x P @.  @d x X @.  @d x Y @.  @d x Z @.
      @d x ph @.  @d z G @.  @d z M @.  @d z P @.  @d z X @.  @d z Y @.
      @d z Z @.  @d z ph @.
      bsstrs.6 @e |- ( ph -> X e. ( P \ M ) ) @.
      bsstrs.7 @e |- ( ph -> Y e. ( P \ M ) ) @.
      bsstrs.8 @e |- ( ph -> Z e. ( P \ M ) ) @.
      bsstrs.9 @e |- ( ph -> ( ( X S Y ) i^i M ) = (/) ) @.
      bsstrs.10 @e |- ( ph -> ( ( Y S Z ) i^i M ) = (/) ) @.
      @( Being on the same side is a transitive relation.  Segment version of
         ~ bsstr .  (For my private use only.  Don't use.)  (Contributed by FL,
         14-Jul-2016.) @)
      bsstrs @p |- ( ph -> ( ( X S Z ) i^i M ) = (/) ) @=
        ( vz vx wceq co cin c0 oveq1 ineq1d eqeq1d syl5ibr csn cdif wcel eldifi
        wi wn syl sgplpte22 incom eldifn disjsn sylibr syl5eq a1i imbi2d eqcoms
        eqtrd oveq2 a1d w3a wa cbtw cfv w3o crab cibg adantl eqid df-ne biimpri
        wne 3ad2ant2 adantr sgplpte21 inrab2 wral 3ad2ant3 syl6eq rabeq0 3ioran
        cv eqtr2 ralbii r19.26-3 wss isibg1a isig12 ssid jctr ssin sylib imim1d
        sseld ralimdv2 disjr syl6 pm2.43b 3ad2ant1 sylbi pm2.43a mpid imp bsstr
        ex disj wrex risset sylnib ralnex syl3anbrc inss2 mpd wb ralbidv mpbird
        ancoms 3exp1 pm2.61i ) GHUBZAGICUCZFUDZUEUBZUNZAYKYHHICUCZFUDZUEUBZSYHY
        JYNUEYHYIYMFGHICUFUGUHUIGIUBZYHUOZYLUNZYRIGYQYLIGUBZAGGCUCZFUDZUEUBZUNZ
        UUCYQAUUAGUJZFUDZUEAYTUUDFABCDGJLMAGBFUKZULZGBULZOGBFUMUPZUQUGAUUEFUUDU
        DZUEUUDFURAGFULZUOZUUJUEUBAUUGUULOGBFUSUPZFGUTVAVBVFVCYSYKUUBAYSYJUUAUE
        YSYIYTFIGGCVGUGUHVDUIVEHIUBZYPUOZYRUNZUUPIHIHUBZYRUUOUUQYLYQAYKUUQGHCUC
        ZFUDZUEUBZRUUQYJUUSUEUUQYIUURFIHGCVGUGUHUIVHVHVEUUNUOZUUOYQAYKUVAUUOYQV
        IZAVJZYJUAWJZGIDVKVLZUCZULZUVDGUBZUVDIUBZVMZUABVNZFUDZUEUVCYIUVKFUVCUAU
        VEBCDGIJLADVOULZUVBMVPAUUHUVBUUIVPUVEVQZAIBULZUVBAIUUFULZUVOQIBFUMUPZVP
        UVBGIVTZAUUOUVAUVRYQUVRUUOGIVRVSWAWBWCUGUVCUVLUVJUABFUDZVNZUEUVJUABFWDU
        VCUVJUOZUAUVSWEZUVTUEUBAUVBUWBAUVBVJZUWBUVGUOZUVHUOZUVIUOZVIZUAUVSWEZUW
        CUWGUAFWEZUWHUWCUWDUAFWEZUWEUAFWEZUWFUAFWEZUWIUWCFUVFUDZUEUBUWJUWCUWMUV
        FFUDUEFUVFURUWCUVEBDEFGHIJKUVNAUVMUVBMWBZAFEULUVBNWBAUUGUVBOWBAHUUFULZU
        VBPWBAUVPUVBQWBAUVBGHUVEUCZFUDUEUBZAUVBUUTUWQRAUVBUUTUWQUNUUTUWCUWQUWCU
        USTWJZUWPULZUWRGUBZUWRHUBZVMZTUVSVNZUBZUUTUWCUWQUNZUNUWCUUSUXBTBVNZFUDU
        XCUWCUURUXFFUWCTUVEBCDGHJLUWNAUUHUVBUUIWBUVNAHBULZUVBAUWOUXGPHBFUMUPWBZ
        UVBGHVTZAYQUVAUXIUUOUXIYQGHVRVSWFVPWCUGUXBTBFWDWGUXDUUTUXEUXDUUTVJUXCUE
        UBZUXEUUSUXCUEWKUXJUXBUOZTUVSWEZUXEUXBTUVSWHUXLUWSUOZUWTUOZUXAUOZVIZTUV
        SWEZUXEUXKUXPTUVSUWSUWTUXAWIWLUXQUXMTUVSWEZUXNTUVSWEZUXOTUVSWEZVIUXEUXM
        UXNUXOTUVSWMUXRUXSUXEUXTUXRUWCUWQAUXRUXEUNUVBAUXRUXMTFWEZUXEAUXMUXMTUVS
        FAUWRFULZUWRUVSULZUXMAFUVSUWRAFBWNZFUVSWNZAFBDEJKADMWONWPUYDUYDFFWNZVJU
        YEUYDUYFFWQWRFBFWSWTUPXBZXAXCUYAUWQUWCUWQUYATUWPFXDVSVHXEWBXFXGXHXHXHUP
        XMUPXIXMXJXKAUVBHIUVEUCZFUDUEUBZAUVBYOUYISAUVBYOUYIUNYOUWCUYIUWCYNUWRUY
        HULZUXAUWRIUBZVMZTUVSVNZUBZYOUWCUYIUNZUNUWCYNUYLTBVNZFUDUYMUWCYMUYPFUWC
        TUVEBCDHIJLUWNUXHUVNAUVOUVBUVQWBUVBHIVTZAUVAUUOUYQYQUYQUVAHIVRVSXGVPWCU
        GUYLTBFWDWGUYNYOUYOUYNYOVJUYMUEUBZUYOYNUYMUEWKUYRUYLUOZTUVSWEZUYOUYLTUV
        SWHUYTUYJUOZUXOUYKUOZVIZTUVSWEZUYOUYSVUCTUVSUYJUXAUYKWIWLVUDVUATUVSWEZU
        XTVUBTUVSWEZVIUYOVUAUXOVUBTUVSWMVUEUXTUYOVUFVUEUWCUYIAVUEUYOUNUVBAVUEVU
        ATFWEZUYOAVUAVUATUVSFAUYBUYCVUAUYGXAXCVUGUYIUWCUYIVUGTUYHFXDVSVHXEWBXFX
        GXHXHXHUPXMUPXIXMXJXKXLVBUAFUVFXNWTUWCUVHUAFXOZUOZUWKAVUIUVBAUUKVUHUUMU
        AGFXPXQWBUVHUAFXRVAUWCUVIUAFXOZUOUWLUWCIFULZVUJAVUKUOZUVBAUVPVULQIBFUSU
        PWBUAIFXPXQUVIUAFXRVAUWDUWEUWFUAFWMXSUWCUWGUWGUAFUVSAUVDFULZUWGUNUVDUVS
        ULZUWGUNUNUVBAVUNVUMUWGAUVSFUVDUVSFWNABFXTVCXBXAWBXCYAUWCUWAUWGUAUVSUWA
        UWGYBUWCUVGUVHUVIWIVCYCYDYEUVJUAUVSWHVAVBVFYFYGYGYG @.
    @}

    @{
      @d x G @.  @d x M @.  @d x P @.  @d x X @.  @d x Y @.  @d x Z @.
      @d x ph @.  @d z G @.  @d z M @.  @d z P @.  @d z S @.  @d z X @.
      @d z Y @.  @d z Z @.  @d z ph @.
      nbssntrs.6 @e |- ( ph -> X e. ( P \ M ) ) @.
      nbssntrs.7 @e |- ( ph -> Y e. ( P \ M ) ) @.
      nbssntrs.8 @e |- ( ph -> Z e. ( P \ M ) ) @.
      nbssntrs.9 @e |- ( ph -> ( ( X S Y ) i^i M ) =/= (/) ) @.
      nbssntrs.10 @e |- ( ph -> ( ( Y S Z ) i^i M ) =/= (/) ) @.
      @( IF ` X ` and ` Y ` are not on the same side, and ` Y ` and ` Z ` are
         not on the same side then ` X ` and ` Z ` are on the same side.  (For
         my private use only.  Don't use.)  (Contributed by FL,
         14-Jul-2016.) @)
      nbssntrs @p |- ( ph -> ( ( X S Z ) i^i M ) = (/) ) @=
        ( c0 vx vz wceq co cin wi wn w3a wa cv cbtw cfv wcel w3o crab cibg cdif
        adantl eldifi syl eqid wne df-ne biimpri adantr sgplpte21 ineq1d inrab2
        3ad2ant2 wral incom 3ad2ant3 syl6eq neeq1 wrex rabn0 elin sylbir expcom
        ne0i a1d sylbi com12 eleq1 eldifn pm2.21d syl6bi 3jaoi rexlimiv pm2.43a
        mpid impcom 3ad2ant1 a1ii com3r nbssntr syl5eq disj sylib risset sylnib
        ex ralnex sylibr r19.26-3 syl3anbrc wss inss2 a1i sseld imim1d ralimdv2
        mpd 3ioran ralbidv mpbird rabeq0 eqtrd 3exp1 oveq1 neeq1d csn sgplpte22
        wb eqeq1i disjsn notnot2 sylnbi com3l mpcom ineq1 eqeq1d syl5ibr eqcoms
        syld oveq2 neeq1i bicomi necon3bbii com23 pm2.61iii ) HIUCZGIUCZGHUCZAG
        ICUDZFUEZTUCZUFZUUBUGZUUCUGZUUDUGZAUUGUUIUUJUUKUHZAUIZUUFUAUJZGIDUKULZU
        DZUMZUUNGUCZUUNIUCZUNZUABUOZFUEZTUUMUUEUVAFUUMUAUUOBCDGIJLADUPUMZUULMUR
        ZAGBUMZUULAGBFUQZUMZUVEOGBFUSUTZURUUOVAZAIBUMZUULAIUVFUMZUVJQIBFUSUTZUR
        UULGIVBZAUUJUUIUVMUUKUVMUUJGIVCVDVIVEVFVGUUMUVBUUTUABFUEZUOZTUUTUABFVHU
        UMUUTUGZUAUVNVJZUVOTUCUUMUVQUUQUGZUURUGZUUSUGZUHZUAUVNVJZUUMUWAUAFVJZUW
        BUUMUVRUAFVJZUVSUAFVJZUVTUAFVJZUWCUUMFUUPUEZTUCUWDUUMUWGUUPFUETFUUPVKUU
        MUUOBDEFGHIJKUVIUVDAFEUMUULNURAUVGUULOURAHUVFUMZUULPURAUVKUULQURAUULGHU
        UOUDZFUEZTVBZAUULGHCUDZFUEZTVBZUWKRAUULUWNUWKUFUWNAUULUIZUWKUWOUWMUBUJZ
        UWIUMZUWPGUCZUWPHUCZUNZUBUVNUOZUCZUWNUWOUWKUFZUFUWOUWMUWTUBBUOZFUEUXAUW
        OUWLUXDFUWOUBUUOBCDGHJLAUVCUULMVEZAUVEUULUVHVEUVIAHBUMZUULAUWHUXFPHBFUS
        UTZVEZUULGHVBZAUUKUUIUXIUUJUXIUUKGHVCVDVLURVFVGUWTUBBFVHVMUXBUWNUXATVBZ
        UXCUWMUXATVNUXJUWTUBUVNVOUXCUWTUBUVNVPUWTUXCUBUVNUWTUWPUVNUMZUXCUWQUXKU
        XCUFUWRUWSUXKUWQUXCUXKUWPBUMZUWPFUMZUIZUWQUXCUFZUWPBFVQZUXMUXOUXLUWQUXM
        UXCUWQUXMUIUWPUWJUMZUXCUWPUWIFVQUXQUWKUWOUWJUWPVTWAVRVSURWBWCUWRUXKGUVN
        UMZUXCUWPGUVNWDUXRUVEGFUMZUIUXCGBFVQUXSUXCUVEUWOUXSUWKAUXSUWKUFUULAUXSU
        WKAUVGUXSUGZOGBFWEUTZWFVEWCURWBWGUWSUXKHUVNUMZUXCUWPHUVNWDZUYBUXFHFUMZU
        IZUXCHBFVQZUYDUXCUXFUWOUYDUWKAUYDUWKUFUULAUYDUWKAUWHUYDUGZPHBFWEUTZWFVE
        WCURWBWGWHWCWIWBWGUTWJXBWKWLAUULHIUUOUDZFUEZTVBZAUULHICUDZFUEZTVBZUYKSA
        UULUYNUYNUYKUFZSAUULUYNUYOUFUYNUWOUYOUWOUYMUWPUYIUMZUWSUWPIUCZUNZUBUVNU
        OZUCZUYNUWOUYOUFZUFUWOUYMUYRUBBUOZFUEUYSUWOUYLVUBFUWOUBUUOBCDHIJLUXEUXH
        UVIAUVJUULUVLVEUULHIVBZAUUIUUJVUCUUKVUCUUIHIVCVDWMURVFVGUYRUBBFVHVMUYTU
        YNUYSTVBZVUAUYMUYSTVNVUDUYRUBUVNVOVUAUYRUBUVNVPUYRVUAUBUVNUYRUXKVUAUYPU
        XKVUAUFUWSUYQUXKUYPVUAUXKUXNUYPVUAUFZUXPUXMVUEUXLUYPUXMVUAUYPUXMUIUWPUY
        JUMZVUAUWPUYIFVQUWOUYNVUFUYKUWOUYNVUFUYKUFUYJUWPVTWNWOVRVSURWBWCUWSUXKU
        YBVUAUYCUYBUYEVUAUYFUYDVUAUXFUWOUYDUYOAUYDUYOUFUULAUYDUYOUYHWFVEWCURWBW
        GUYQUXKIUVNUMZVUAUWPIUVNWDVUGUVJIFUMZUIVUAIBFVQVUHVUAUVJUWOVUHUYOAVUHUY
        OUFUULAVUHUYOAUVKVUHUGZQIBFWEUTZWFVEWCURWBWGWHWCWIWBWGUTWJXBWKWKWLWPWQU
        AFUUPWRWSUUMUURUAFVOZUGZUWEAVULUULAUXSVUKUYAUAGFWTXAURUURUAFXCXDUUMUUSU
        AFVOZUGUWFUUMVUHVUMAVUIUULVUJURUAIFWTXAUUSUAFXCXDUVRUVSUVTUAFXEXFUUMUWA
        UWAUAFUVNAUUNFUMZUWAUFUUNUVNUMZUWAUFUFUULAVUOVUNUWAAUVNFUUNUVNFXGABFXHX
        IXJXKURXLXMUUMUVPUWAUAUVNUVPUWAYDUUMUUQUURUUSXNXIXOXPUUTUAUVNXQXDWQXRXS
        AUUBUUGUYNAUUBUUGUFSUUBUYNAUUGUUBUYNIICUDZFUEZTVBZUUHUUBUYMVUQTUUBUYLVU
        PFHIICXTVGYAAVURUUGAVURVUHUUGAVURIYBZFUEZTVBZVUHAVUQVUTTAVUPVUSFABCDIJL
        MUVLYCVGYAVVAVUTTUCZUGVUHVUTTVCVVBFVUSUEZTUCZVUHVUTVVCTVUSFVKYEVVDVUIVU
        HFIYFVUHYGYHYHWBWGAVUHUUGVUJWFYOWCWGYIYJWCAUUGUUCGGCUDZFUEZTUCZVVEGYBZU
        CZAVVGABCDGJLMUVHYCAVVGVVIVVHFUEZTUCAVVJFVVHUEZTVVHFVKAUXTVVKTUCUYAFGYF
        XDWQVVIVVFVVJTVVEVVHFYKYLYMYJUUCUUFVVFTUUCUUEVVEFUUEVVEUCIGIGGCYPYNVGYL
        YMAUUDUUGUWNAUUDUUGUFRUUDUWNAUUGUUDUWNHHCUDZFUEZTVBZUUHUUDUWMVVMTUUDUWL
        VVLFGHHCXTVGYAAVVNUUGVVLHYBZUCZAVVNUUGUFABCDHJLMUXGYCVVPVVNAUUGVVPVVNVV
        OFUEZTVBZUUHVVPVVMVVQTVVLVVOFYKYAVVRFVVOUEZTVBZUUHVVQVVSTVVOFVKYQVVTUYG
        UGZUUHUYGVVSTVVSTUCUYGFHYFYRYSVWAUYDUUHUYDYGAUYDUUGAUYDUUGUYHWFWCUTVRWB
        WGYTYJWCWGYIYJWCUUA @.
    @}
  @}


  @( The non degenerated segments. @)
  @c Segments @.

  @( Extend class notation with the non-degenerated segment symbol. @)
  cSeg @a class Segments @.

  @( The non-degenerated segments.  (For my private use only.  Don't use.)
     (Contributed by FL, 7-Mar-2016.) @)
  df-Seg @a |- Segments = ( f e. Ibg |->
    ( ( seg ` f ) " ( ( ( PPoints ` f ) X. ( PPoints ` f ) ) \ _I ) ) ) @.

  @{
    @d f G @.
    nds.1 @e |- P = ( PPoints ` G ) @.
    nds.2 @e |- S = ( seg ` G ) @.
    @( The non-degenerated segments.  (For my private use only.  Don't use.)
       (Contributed by FL, 7-Mar-2016.) @)
    nds @p |- ( G e. Ibg ->
       ( Segments ` G ) = ( S " ( ( P X. P ) \ _I ) ) ) @=
      ( cibg wcel cSeg cfv cseg cpoints cxp cid cdif cima cvv wceq fveq2 eqcomi
      vf fvex imaexg mp1i cv imaeq1d xpeq12d difeq1d imaeq2d eqtrd df-Seg mpdan
      fvmptg imaeq1i xpeq12i difeq1i imaeq2i eqtri syl6eq ) CFGZCHIZCJIZCKIZVBL
      ZMNZOZBAALZMNZOZUSVEPGZUTVEQVAPGVIUSCJUAVAVDPUBUCTCTUDZJIZVJKIZVLLZMNZOZV
      EFPHVJCQZVOVAVNOVEVPVKVAVNVJCJRUEVPVNVDVAVPVMVCMVPVLVBVLVBVJCKRZVQUFUGUHU
      ITUJULUKVEBVDOVHVABVDBVAESUMVDVGBVCVFMVBAVBAAVBDSZVRUNUOUPUQUR @.
  @}

  @c ray @.

  @( Extend class notation with the ray symbol. @)
  cray2 @a class ray @.

  @{
    @d f x y z @.
    @( Definition of the ray xy degenerated or not.  Definition 11 of
       [AitkenIBG] p. 4.  (For my private use only.  Don't use.)  (Contributed
       by FL, 5-Mar-2016.) @)
    df-ray2 @a |- ray = ( f e. Ibg |-> ( x e. ( PPoints ` f ) ,
      y e. ( PPoints ` f ) |-> if ( x =/= y , ( ( x ( seg ` f ) y ) u.
      { z e. ( PPoints ` f ) | y e. ( x ( btw ` f ) z ) } ) , { x } ) ) ) @.
  @}


  @{
    @d f x y z G @.  @d f x y P @.  @d f x y ph @.  @d x y z X @.
    isray2.1 @e |- P = ( PPoints ` G ) @.
    isray2.3 @e |- R = ( ray ` G ) @.
    isray2.5 @e |- ( ph -> G e. Ibg ) @.
    isray2.6 @e |- ( ph -> X e. P ) @.
    @( A degenerated ray.  (For my private use only.  Don't use.)  (Contributed
       by FL, 13-Apr-2016.) @)
    isray2 @p |- ( ph -> ( X R X ) = { X } ) @=
      ( vz vx vy vf co cfv cv wcel cpoints cvv wceq wne cseg cbtw cun csn cray2
      crab cif cmpt2 cibg cmpt df-ray2 a1i wa fveq2 syl6eqr adantl oveqd eleq2d
      rabeqbidv uneq12d ifeq1d mpt2eq123dv eqeltri mpt2ex fvmptd syl5eq neeq12d
      fvex simpl simpr oveq12 oveq1 adantr eleq12d rabbidv sneq ifbieq12d rabex
      ovex unex snex ifex ovmpt2d wn neirr iffalse mp1i eqtrd ) AEECNEEUAZEEDUB
      OZNZEEJPZDUCOZNZQZJDROZUGZUDZEUEZUHZWTAKLEEBBKPZLPZUAZXBXCWKNZXCXBWMWNNZQ
      ZJWQUGZUDZXBUEZUHZXACSACDUFOKLBBXKUIZGAMDKLMPZROZXNXDXBXCXMUBOZNZXCXBWMXM
      UCOZNZQZJXNUGZUDZXJUHZUIZXLUJUFSUFMUJYCUKTAKLJMULUMAXMDTZUNKLXNXNYBBBXKYD
      XNBTAYDXNWQBXMDRUOZFUPUQZYFYDYBXKTAYDXDYAXIXJYDXPXEXTXHYDXOWKXBXCXMDUBUOU
      RYDXSXGJXNWQYEYDXRXFXCYDXQWNXBWMXMDUCUOURUSUTVAVBUQVCHXLSQAKLBBXKBWQSFDRV
      IZVDZYHVEUMVFVGXBETZXCETZUNZXKXATAYKXDWJXIXJWSWTYKXBEXCEYIYJVJYIYJVKZVHYK
      XEWLXHWRXBEXCEWKVLYKXGWPJWQYKXCEXFWOYLYIXFWOTYJXBEWMWNVMVNVOVPVAYIXJWTTYJ
      XBEVQVNVRUQIIXASQAWJWSWTWLWREEWKVTWPJWQYGVSWAEWBWCUMWDWJWEXAWTTAEWFWJWSWT
      WGWHWI @.
  @}

  @{
    @d f x y z G @.  @d f x y ph @.  @d x y B @.  @d x y z P @.  @d x y S @.
    @d x y z X @.  @d x y z Y @.
    isray.1 @e |- P = ( PPoints ` G ) @.
    isray.2 @e |- S = ( seg ` G ) @.
    isray.3 @e |- R = ( ray ` G ) @.
    isray.5 @e |- ( ph -> G e. Ibg ) @.
    isray.6a @e |- ( ph -> X e. P ) @.
    isray.6b @e |- ( ph -> Y e. P ) @.

    @{
      isray.4 @e |- B = ( btw ` G ) @.
      isray.7 @e |- ( ph -> X =/= Y ) @.
      @( A non-degenerated ray.  (For my private use only.  Don't use.)
         (Contributed by FL, 20-May-2016.) @)
      isray @p |- ( ph -> ( X R Y ) = ( ( X S Y ) u.
         { z e. P | Y e. ( X B z ) } ) ) @=
        ( vx vy wceq vf co wne cv wcel crab cun csn cif cpoints cseg cbtw cray2
        cfv cvv cmpt2 cibg cmpt df-ray2 a1i fveq2 adantl oveqd eleq2d rabeqbidv
        uneq12d ifeq1d mpt2eq123dv fvex mpt2ex fvmptd syl5eq simpl simpr eqcomi
        wa neeq12d oveq123d eleq12d sneq adantr ifbieq12d syl6eleq ovex eqeltri
        eqidd rabex unex snex ifex ovmpt2d iftrue syl eqtrd ) AHIEUBHIUCZHIFUBZ
        IHBUDZCUBZUEZBDUFZUGZHUHZUIZXAARSHIGUJUNZXDRUDZSUDZUCZXEXFGUKUNZUBZXFXE
        WQGULUNZUBZUEZBXDUFZUGZXEUHZUIZXCEUOAEGUMUNRSXDXDXPUPZLAUAGRSUAUDZUJUNZ
        XSXGXEXFXRUKUNZUBZXFXEWQXRULUNZUBZUEZBXSUFZUGZXOUIZUPZXQUQUMUOUMUAUQYHU
        RTARSBUAUSUTAXRGTZVPRSXSXSYGXDXDXPYIXSXDTAXRGUJVAZVBZYKYIYGXPTAYIXGYFXN
        XOYIYAXIYEXMYIXTXHXEXFXRGUKVAVCYIYDXLBXSXDYJYIYCXKXFYIYBXJXEWQXRGULVAVC
        VDVEVFVGVBVHMXQUOUEARSXDXDXPGUJVIZYLVJUTVKVLXEHTZXFITZVPZXPXCTAYOXGWOXN
        XOXAXBYOXEHXFIYMYNVMZYMYNVNZVQYOXIWPXMWTYOXEHXFIXHFXHFTYOFXHKVOUTYPYQVR
        YOXLWSBXDDXDDTYODXDJVOUTYOXFIXKWRYQYOXEHWQWQXJCXJCTYOCXJPVOUTYPYOWQWFVR
        VSVEVFYMXOXBTYNXEHVTWAWBVBAHDXDNJWCAIDXDOJWCXCUOUEAWOXAXBWPWTHIFWDWSBDD
        XDUOJYLWEWGWHHWIWJUTWKAWOXCXATQWOXAXBWLWMWN @.
    @}

    @( A segment is a part of a ray.  (For my private use only.  Don't use.)
       (Contributed by FL, 20-May-2016.) @)
    segray @p |- ( ph -> ( X S Y ) C_ ( X R Y ) ) @=
      ( vx co wss sseq12d oveq1 wcel adantl wi wceq csn sgplpte22 isray2 mpbiri
      ssid syl5ibr wne wa cv cbtw cfv crab cun ssun1 cibg simpl isray syl5sseqr
      eqid ex pm2.61ine ) AFGDOZFGCOZPZUAFGAVFFGUBZGGDOZGGCOZPZAVJGUCZVKPVKUGAV
      HVKVIVKABDEGHIKMUDABCEGHJKMUEQUFVGVDVHVEVIFGGDRFGGCRQUHFGUIZAVFVLAUJZVDGF
      NUKEULUMZOSNBUNZUOVDVEVDVOUPVMNVNBCDEFGHIJAEUQSVLKTAFBSVLLTAGBSVLMTVNVAVL
      AURUSUTVBVC @.
  @}

  @{
    @d p G @.  @d p L @.  @d p P @.  @d p X @.  @d p Y @.  @d p ph @.
    rayline.1 @e |- P = ( PPoints ` G ) @.
    rayline.2 @e |- L = ( line ` G ) @.
    rayline.3 @e |- R = ( ray ` G ) @.
    rayline.4 @e |- ( ph -> G e. Ibg ) @.
    rayline.5 @e |- ( ph -> X e. P ) @.
    rayline.6 @e |- ( ph -> Y e. P ) @.
    @( A ray is a part of a line.  (For my private use only.  Don't use.)
       (Contributed by FL, 20-May-2016.) @)
    rayline @p |- ( ph -> ( X R Y ) C_ ( X L Y ) ) @=
      ( vp co wss sseq12d wcel adantl 3ad2ant1 wi wceq isray2 isibg1a lineval3a
      csn ssid mpbiri oveq1 syl5ibr wne wa cseg cfv cv cbtw crab cun eqid simpl
      isray segline w3a simp2 simp3 isibg1a8 rabssdv unssd eqsstrd ex pm2.61ine
      cibg ) AFGCOZFGEOZPZUAFGAVOFGUBZGGCOZGGEOZPZAVSGUFZVTPVTUGAVQVTVRVTABCDGH
      JKMUCAGBDEHIADKUDMUEQUHVPVMVQVNVRFGGCUIFGGEUIQUJFGUKZAVOWAAULZVMFGDUMUNZO
      ZGFNUOZDUPUNZORZNBUQZURVNWBNWFBCWCDFGHWCUSZJADVLRZWAKSZAFBRZWALSZAGBRZWAM
      SZWFUSZWAAUTVAWBWDWHVNAWDVNPWAABWCDEFGHWIKLIMVBSWBWGNBVNWBWEBRZWGVCWFBDEF
      GWEHWPWBWQWJWGWKTWBWQWLWGWMTWBWQWNWGWOTWBWQWGVDWBWQWGVEIVFVGVHVIVJVK @.
  @}

  @( Function returning angles. @)
  @c angle @.

  @( Extend class notation with the angle symbol. @)
  cangle @a class angle @.

  @{
    @d g w @.
    @( Definition of an angle.  Definition 17 of [AitkenIBG] p. 10.  The angles
       can't be degenerated.  Contrary to the concept of degenerated line or
       segment, the concept of degenerated angle no longer simplifies the
       wording.  (For my private use only.  Don't use.)  (Contributed by FL,
       7-Apr-2016.) @)
    df-angle @a |- angle = ( g e. Ibg |-> ( w e. ( ( PPoints ` g ) dWords 3 )
      |-> ( ( ( w ` 2 ) ( ray ` g ) ( w ` 1 ) ) u.
             ( ( w ` 2 ) ( ray ` g ) ( w ` 3 ) ) ) ) ) @.
  @}

  @( Function returning triangles. @)
  @c triangle @.

  @( Extend class notation with the triangle symbol. @)
  ctriangle @a class triangle @.

  @{
    @d g w @.
    @( Definition of a triangle, degenerated or not.  Definition 23 of
       [AitkenIBG] p. 15.  (For my private use only.  Don't use.)  (Contributed
       by FL, 7-Apr-2016.) @)
    df-triangle @a |- triangle = ( g e. Ibg |->
      ( w e. ( ( PPoints ` g ) dWords 3 )
         |-> ( ( ( ( w ` 1 ) ( seg ` g ) ( w ` 2 ) ) u.
                ( ( w ` 2 ) ( seg ` g ) ( w ` 3 ) ) ) u.
                ( ( w ` 3 ) ( seg ` g ) ( w ` 1 ) ) ) ) ) @.
  @}

  @( Triangle congruence. @)
  @c trcng @.

  @( Extend class notation with triangle congruence. @)
  ctrcng @a class trcng @.

  @( The same side relation. @)
  @c ss @.

  @( Extend class notation with the same side relation. @)
  csas @a class ss @.

  @{
    @d g l x y @.
    @( Two points not on ` l ` are on the same side of ` l ` if the segment xy
       doesn't intersect ` l ` .  Definition 10 of [AitkenIBG] p. 4 (For my
       private use only.  Don't use.)  (Contributed by FL, 26-May-2016.) @)
    df-sside @a |- ss = ( g e. Ibg |-> ( l e. ( PLines ` g ) |->
      { <. x , y >. | ( x e. ( ( PPoints ` g ) \ l ) /\
       y e. ( ( PPoints ` g ) \ l )
        /\ ( ( x ( seg ` g ) y ) i^i l ) = (/) ) } ) ) @.
  @}

  @{
    isside.1 @e |- P = ( PPoints ` G ) @.
    isside.2 @e |- L = ( PLines ` G ) @.
    isside.3 @e |- .~ = ( ( ss ` G ) ` M ) @.
    isside.4 @e |- ( ph -> G e. Ibg ) @.
    isside.5 @e |- ( ph -> M e. L ) @.

    @{
      isside.7 @e |- S = ( seg ` G ) @.
      @{
        @d g l x y G @.  @d l x y M @.  @d x y ph @.
        @( The predicate "Being on the same side of ` L ` " (For my private use
           only.  Don't use.)  (Contributed by FL, 19-Jun-2016.) @)
        isside0 @p |- ( ph -> .~ = { <. x , y >. | ( x e. ( P \ M ) /\
        y e. ( P \ M )
         /\ ( ( x S y ) i^i M ) = (/) ) } ) @=
          ( vl cfv wcel wceq cvv vg csas cv co cin c0 w3a copab cplines cpoints
          cdif cseg cmpt cibg mptex fveq2 difeq1d eleq2d oveqd ineq1d 3anbi123d
          fvex eqeq1d opabbidv mpteq12dv df-sside fvmptg fveq1d syl6eleq difeq2
          sylancl ineq2 eqid wa 3anass opabbii a1i difexg ax-mp zfausab opabex3
          cab syl6eqel fvmpt3 syl eqcomi difeq1i 3eqtrd syl5eq ) AEIGUBQZQZBUCZ
          DIUKZRZCUCZWMRZWLWOFUDZIUEZUFSZUGZBCUHZLAWKIPGUIQZWLGUJQZPUCZUKZRZWOX
          ERZWLWOGULQZUDZXDUEZUFSZUGZBCUHZUMZQZWLXCIUKZRZWOXPRZXIIUEZUFSZUGZBCU
          HZXAAIWJXNAGUNRXNTRWJXNSMPXBXMGUIVBUOUAGPUAUCZUIQZWLYCUJQZXDUKZRZWOYF
          RZWLWOYCULQZUDZXDUEZUFSZUGZBCUHZUMXNUNTUBYCGSZPYDYNXBXMYCGUIUPYOYMXLB
          CYOYGXFYHXGYLXKYOYFXEWLYOYEXCXDYCGUJUPUQZURYOYFXEWOYPURYOYKXJUFYOYJXI
          XDYOYIXHWLWOYCGULUPUSUTVCVAVDVEBCUAPVFVGVKVHAIXBRXOYBSAIHXBNKVIPIXMYB
          XBXNTXDISZXLYABCYQXFXQXGXRXKXTYQXEXPWLXDIXCVJZURYQXEXPWOYRURYQXJXSUFX
          DIXIVLVCVAVDXNVMXDXBRZXMXFXGXKVNZVNZBCUHZTXMUUBSYSXLUUABCXFXGXKVOVPVQ
          YTBCXEXCTRXETRGUJVBXCXDTVRVSZYTCWBTRXFXKCXEUUCVTVQWAWCWDWEAYAWTBCAXQW
          NXRWPXTWSAXPWMWLXPWMSAXCDIDXCJWFWGVQZURAXPWMWOUUDURAXSWRUFAXIWQIAXHFW
          LWOXHFSAFXHOWFVQUSUTVCVAVDWHWI @.
      @}

      @{
        @d x y G @.  @d x y M @.  @d x y P @.  @d x y S @.  @d x y X @.
        @d x y Y @.  @d x y ph @.
        isside1.8 @e |- ( ph -> X e. A ) @.
        isside1.9 @e |- ( ph -> Y e. B ) @.
        @( The predicate "Being on the same side of ` L ` " (For my private use
           only.  Don't use.)  (Contributed by FL, 19-Jun-2016.) @)
        isside1 @p |- ( ph -> ( X .~ Y <-> ( X e. ( P \ M ) /\
         Y e. ( P \ M ) /\ ( ( X S Y ) i^i M ) = (/) ) ) ) @=
          ( wcel vx vy wbr cv cdif co cin c0 wceq w3a copab isside0 breqd wb wa
          simpl eleq1d simpr oveq12 ineq1d eqeq1d 3anbi123d eqid brabga syl2anc
          bitrd ) AJKEUCJKUAUDZDIUEZTZUBUDZVHTZVGVJFUFZIUGZUHUIZUJZUAUBUKZUCZJV
          HTZKVHTZJKFUFZIUGZUHUIZUJZAEVPJKAUAUBDEFGHILMNOPQULUMAJBTKCTVQWCUNRSV
          OWCUAUBJKVPBCVGJUIZVJKUIZUOZVIVRVKVSVNWBWFVGJVHWDWEUPUQWFVJKVHWDWEURU
          QWFVMWAUHWFVLVTIVGJVJKFUSUTVAVBVPVCVDVEVF @.
      @}

      @{
        @d x y G @.  @d x y M @.  @d x y P @.  @d x y S @.  @d x y X @.
        @d x y Y @.  @d x y ph @.
        isside.8 @e |- ( ph -> X e. ( P \ M ) ) @.
        isside.9 @e |- ( ph -> Y e. ( P \ M ) ) @.
        @( The predicate "Being on the same side of ` L ` " (For my private use
           only.  Don't use.)  (Contributed by FL, 19-Jun-2016.) @)
        isside @p |- ( ph -> ( X .~ Y <-> ( ( X S Y ) i^i M ) = (/) ) ) @=
          ( wbr wcel adantr cdif co cin c0 wceq w3a isside1 simp3 wa simpr 3jca
          ex impbid2 bitrd ) AHICRHBGUAZSZIUOSZHIDUBGUCUDUEZUFZURAUOUOBCDEFGHIJ
          KLMNOPQUGAUSURUPUQURUHAURUSAURUIUPUQURAUPURPTAUQURQTAURUJUKULUMUN @.
      @}
    @}

    @{
      @d a b x y z @.  @d a b x y G @.  @d a b x y M @.  @d a b x y P @.
      @d x y z .~ @.  @d x y z ph @.
      @( "Being on the same side of ` M ` " is an equivalence relation among
         points that are not on ` M ` .  (Contributed by FL, 10-Aug-2016.) @)
      bosser @p |- ( ph -> .~ Er ( P \ M ) ) @=
        ( vx vy va wceq wbr wa wcel cin c0 vz vb wrel cdm cdif wal wer cseg cfv
        cv wi co w3a copab relopab a1i eqid isside0 releqd mpbird dmeqd opabbii
        3anass wex wral simpr csn cibg adantr eldifi adantl sgplpte22 ineq1d wn
        incom eldifn disjsn sylibr 3eqtrd wrex oveq2 eqeq1d rspcev df-rex sylib
        syl2anc ralrimiva dmopab3 simpr2 simpr1 3ad2ant3 3ad2ant1 xsyysx biimpd
        weq 3ad2ant2 3exp com34 3imp impcom 3jca ex wb df-br opabid bitri eleq1
        cop vex oveq1 3anbi13d 3anbi23d oveq12 3anbi123d cbvopabv 3imtr4d breqd
        brab simprl1 simprr2 simprl2 simprl3 simprr3 bsstrs anbi12d jca alrimiv
        syl6bb alrimivv dfer2 syl3anbrc ) ACUCZCUDZBFUEZOLUJZMUJZCPZYPYOCPZUKZY
        QYPUAUJZCPZQZYOYTCPZUKZQZUAUFZMUFLUFYNCUGAYLYOYNRZYPYNRZYOYPDUHUIZULZFS
        ZTOZUMZLMUNZUCZUUOAUUMLMUOUPACUUNALMBCUUIDEFGHIJKUUIUQZURZUSUTAYMUUNUDU
        UGUUHUULQZQZLMUNZUDZYNACUUNUUQVAAUUNUUTUUNUUTOAUUMUUSLMUUGUUHUULVCVBUPV
        AAUURMVDZLYNVEUVAYNOAUVBLYNAUUGQZUUGYOYOUUIULZFSZTOZUVBAUUGVFUVCUVEYOVG
        ZFSZFUVGSZTUVCUVDUVGFUVCBUUIDYOGUUPADVHRZUUGJVIUUGYOBRZAYOBFVJZVKVLVMUV
        HUVIOUVCUVGFVOUPUVCYOFRVNZUVITOUUGUVMAYOBFVPVKFYOVQVRVSUUGUVFQUULMYNVTU
        VBUULUVFMYOYNMLWOZUUKUVETUVNUUJUVDFYPYOYOUUIWAVMWBWCUULMYNWDWEWFWGUURLM
        YNWHWEVSAUUFLMAUUEUAAYSUUDAYOYPUUNPZYPYOUUNPZYQYRAUUMUUHUUGYPYOUUIULZFS
        ZTOZUMZUVOUVPAUUMUVTAUUMQUUHUUGUVSAUUGUUHUULWIAUUGUUHUULWJUUMAUVSUUGUUH
        UULAUVSUKUUGUUHAUULUVSUUGUUHAUULUVSUKUUGUUHAUMZUULUVSUWAUUKUVRTUWAUUJUV
        QFUWABUUIDYOYPGUUPAUUGUVJUUHJWKUUGUUHUVKAUVLWLUUHUUGYPBRAYPBFVJWPWMVMWB
        WNWQWRWSWTXAXBUVOUUMXCAUVOYOYPXHUUNRUUMYOYPUUNXDUUMLMXEXFUPZUVPUVTXCANU
        JZYNRZUBUJZYNRZUWCUWEUUIULZFSZTOZUMZUUHUWFYPUWEUUIULZFSZTOZUMZUVTNUBYPY
        OUUNMXIZLXIZNMWOZUWDUUHUWIUWMUWFUWCYPYNXGUWQUWHUWLTUWQUWGUWKFUWCYPUWEUU
        IXJVMWBXKZUBLWOZUWFUUGUWMUVSUUHUWEYOYNXGUWSUWLUVRTUWSUWKUVQFUWEYOYPUUIW
        AVMWBXLUUMUWJLMNUBLNWOZMUBWOZQZUUGUWDUUHUWFUULUWIUWTUUGUWDXCUXAYOUWCYNX
        GVIUXAUUHUWFXCUWTYPUWEYNXGVKUXBUUKUWHTUXBUUJUWGFYOUWCYPUWEUUIXMVMWBXNXO
        ZXRUPXPACUUNYOYPUUQXQZACUUNYPYOUUQXQXPAUVOYPYTUUNPZQZYOYTUUNPZUUBUUCAUU
        MUUHYTYNRZYPYTUUIULZFSZTOZUMZQZUUGUXHYOYTUUIULZFSZTOZUMZUXFUXGAUXMUXQAU
        XMQZUUGUXHUXPUUGUUHUULUXLAXSZUUHUXHUXKUUMAXTZUXRBUUIDEFYOYPYTGHUUPAUVJU
        XMJVIAFERUXMKVIUXSUUGUUHUULUXLAYAUXTUUGUUHUULUXLAYBUUHUXHUXKUUMAYCYDXAX
        BAUVOUUMUXEUXLUWBAUXEYPYTUWJNUBUNZPUXLAUUNUYAYPYTUUNUYAOAUXCUPZXQUWJUWN
        UXLNUBYPYTUYAUWOUAXIZUWRUBUAWOZUWFUXHUWMUXKUUHUWEYTYNXGZUYDUWLUXJTUYDUW
        KUXIFUWEYTYPUUIWAVMWBXLUYAUQZXRYHYEAUXGYOYTUYAPUXQAUUNUYAYOYTUYBXQUWJUU
        GUWFYOUWEUUIULZFSZTOZUMUXQNUBYOYTUYAUWPUYCNLWOZUWDUUGUWIUYIUWFUWCYOYNXG
        UYJUWHUYHTUYJUWGUYGFUWCYOUWEUUIXJVMWBXKUYDUWFUXHUYIUXPUUGUYEUYDUYHUXOTU
        YDUYGUXNFUWEYTYOUUIWAVMWBXLUYFXRYHXPAYQUVOUUAUXEUXDACUUNYPYTUUQXQYEACUU
        NYOYTUUQXQXPYFYGYILMUAYNCYJYK @.
    @}

    @{
      @d a .~ @.  @d a A @.  @d a M @.  @d a P @.  @d b x .~ @.  @d b x A @.
      @d b x G @.  @d b x M @.  @d b x P @.  @d b x ph @.  @d x y .~ @.
      @d x B @.  @d y A @.  @d y G @.  @d y M @.  @d y P @.  @d y ph @.
      pdiveql.1 @e |- ( ph -> A e. ( P \ M ) ) @.
      @( The plane is divided into two equivalence classes by a line ` M ` .
         (For my private use only.  Don't use.)  (Contributed by FL,
         14-Jul-2016.) @)
      pdiveql @p |- ( ph -> ( B e. ( ( P \ M ) /. .~ )
         <-> ( B = [ A ] .~ \/ B = ( ( P \ M ) \ [ A ] .~ ) ) ) ) @=
        ( wcel wceq wi c0 adantr cvv vx vy va vb cdif cqs wo cv wrex elqsg cseg
        cec cfv co cin wn exmid w3a cibg 3ad2ant1 bosser wbr wa eqid eldifi syl
        adantl xsyysx ineq1d eqeq1d simp2 isside mpbird erthi 3exp eqeq1 imbi2d
        biimp3a syl5ibr com3l 3imp wb vex pm3.2i mp1i a1i isside1 simpr2 simp32
        elecg simpl2 biimpa 3ad2ant2 3ad2ant3 biimpd 3imp2 3adant2 bsstrs con3d
        com34 3imp1 jca simprl simpl notbid ad2antll wne df-ne biimpri nbssntrs
        sylibr syl6bi pm2.43a impancom impcom 3jca impbida bitrd sylancr bicomd
        ex anbi2d 3bitrd eldif syl6bbr eqrdv orim12d com14 ax-mp rexlimiv com12
        fvex eqeltri eleq1 pm2.24 ad2antlr eqtrd sylbi cpoints difexg eceq1 w3o
        pm2.43i eqeq2d rspcev sylancl csas eceq2 ecexg lppotos 3ianor csn oveq2
        simpllr equcoms sgplpte22 eldifn disjsn syl5eq simprlr neeq1d pm2.61ian
        incom 3jaoi simplrr simpr com13 imp mtbird 3bitr4d reximdva mp2b impbid
        mpd jaoi ) ACDHUEZEUFZOZCBEULZPZCUVPUVSUEZPZUGZUVRAUWCUVRAUWCQZUVRUVRCU
        AUHZEULZPZUAUVPUIUWDUAUVPCEUVQUJUWGUWDUAUVPBUWEFUKUMZUNZHUOZRPZUWKUPZUG
        ZUWEUVPOZUWGUWDQQUWKUQAUWNUWGUWMUWCAUWNUWGUWMUWCQAUWNUWGURUWKUVTUWLUWBA
        UWNUWGUWKUVTQZUWGAUWNUWOAUWNUWOQUWGUWNUWKUWFUVSPZQZQAUWNUWKUWPAUWNUWKUR
        ZUWEBEUVPUWRDEFGHIJKAUWNFUSOZUWKLUTZAUWNHGOZUWKMUTZVAUWRUWEBEVBUWEBUWHU
        NZHUOZRPZAUWNUWKUXEAUWNVCZUWJUXDRUXFUWIUXCHUXFDUWHFBUWEIUWHVDZAUWSUWNLS
        ABDOZUWNABUVPOZUXHNBDHVEVFZSUWNUWEDOZAUWEDHVEZVGVHVIVJZVRUWRDEUWHFGHUWE
        BIJKUWTUXBUXGAUWNUWKVKAUWNUXIUWKNUTVLVMVNVOUWGUWOUWQUWNUWGUVTUWPUWKCUWF
        UVSVPVQVQVSVTWAAUWNUWGUWLUWBQZUWGAUWNUXNAUWNUXNQUWGUWNUWLUWFUWAPZQZQAUW
        NUWLUXOAUWNUWLURZUBUWFUWAUXQUBUHZUWFOZUXRUVPOZUXRUVSOZUPZVCZUXRUWAOUXQU
        XSUWEUXREVBZUXTBUXREVBZUPZVCZUYCUXRTOZUWETOZVCUXSUYDWBUXQUYHUYIUBWCZUAW
        CZWDUXRUWEETTWJWEUXQUYDUWNUXTUWEUXRUWHUNZHUOZRPZURZUYGUXQTTDEUWHFGHUWEU
        XRIJKAUWNUWSUWLLUTZAUWNUXAUWLMUTZUXGUYIUXQUYKWFUYHUXQUYJWFWGUXQUYOUYGUX
        QUYOVCUXTUYFUXQUWNUXTUYNWHAUWNUWLUYOUYFAUWNUYOUWLUYFAUWNUYOUWLUYFQAUWNU
        YOURZUYEUWKUYRUYEUWKUYRUYEVCDUWHFGHBUXRUWEIJUXGUYRUWSUYEAUWNUWSUYOLUTZS
        UYRUXAUYEAUWNUXAUYOMUTZSUYRUXIUYEAUWNUXIUYONUTZSUYRUXTUYEAUWNUWNUXTUYNW
        IZSAUWNUYOUYEWKUYRUYEBUXRUWHUNHUOZRPZUYRDEUWHFGHBUXRIJKUYSUYTUXGVUAVUBV
        LWLUYRUXRUWEUWHUNZHUOZRPZUYEAUYOVUGUWNAUWNUXTUYNVUGAUWNUXTUYNVUGQAUWNUX
        TURZUYNVUGVUHUYMVUFRVUHUYLVUEHVUHDUWHFUWEUXRIUXGAUWNUWSUXTLUTUWNAUXKUXT
        UXLWMUXTAUXRDOUWNUXRDHVEWNVHVIVJWOVOWPWQSWRYAWSVOWTXAXBUXQUYGVCUWNUXTUY
        NAUWNUWLUYGWKUXQUXTUYFXCUYGUXQUYNUXTUXQUYFUYNUYFUXTUXQVCZUYNVUIUYFVUDUP
        ZVUIUYNQVUIUYEVUDVUIDEUWHFGHBUXRIJKUXQUWSUXTUYPVGUXQUXAUXTUYQVGUXGUXQUX
        IUXTAUWNUXIUWLNUTZVGUXTUXQXDVLXEVUJVUIUYNVUJVUIVCDUWHFGHUWEBUXRIJUXGUXQ
        UWSVUJUXTUYPXFUXQUXAVUJUXTUYQXFUXQUWNVUJUXTAUWNUWLVKXFUXQUXIVUJUXTVUKXF
        VUJUXTUXQXCUXQUXDRXGZVUJUXTUXQUXEUPZVULAUWNUWLVUMUXFUWKUXEUXMXEVRUXDRXH
        XKXFVUJVUCRXGZVUIVUNVUJVUCRXHXISXJYAXLXMXNXOXPXQXRUXQUYFUYBUXTUXQUYEUYA
        UXQUYAUYEUXQUYHUXIUYAUYEWBUYJVUKUXRBETUVPWJXSXTXEYBYCUXRUVPUVSYDYEYFVOU
        WGUXNUXPUWNUWGUWBUXOUWLCUWFUWAVPVQVQVSVTWAYGVOYHYIYJXLUUCYKUWCAUVRUVTAU
        VRQUWBAUVRUVTUVSUVQOZAVUOUVSUCUHZEULZPZUCUVPUIZAUXIUVSUVSPZVUSNUVSVDVUR
        VUTUCBUVPVUPBPVUQUVSUVSVUPBEUUAUUDUUEUUFUVSTOVUOVUSWBAUVSBHFUUGUMZUMZUL
        ZTEVVBPUVSVVCPKEVVBBUUHYIVVBTOVVCTOHVVAYLBTVVBUUIYIYMUCUVPUVSETUJWEVMCU
        VSUVQYNVSAUVRUWBUWAUVQOZAUWAUDUHZEULZPZUDUVPUIZVVDABVVEUWHUNZHUOZRXGZUD
        UVPUIVVHAUDDUWHFGHBIJUXGLNMUUJAVVKVVGUDUVPAVVEUVPOZVCZVVKVVGVVMVVKVCZUA
        UWAVVFVVNUWEUWAOZUWNUWEUVSOZUPZVCZVVEUWEEVBZUWEVVFOZVVOVVRWBVVNUWEUVPUV
        SYDWFVVNUWNBUWEEVBZUPZVCZVVLUWNVVEUWEUWHUNZHUOZRPZURZVVRVVSVVNVWCVWGVVN
        VWCVCVVLUWNVWFAVVLVVKVWCUUNVVNUWNVWBXCVWCVVNVWFUWNVVNVWBVWFVWBUWNVVNVCZ
        VWFVWHVWBUXIUWNUWKURZUPZVWHVWFQZVWHVWAVWIVWHUVPUVPDEUWHFGHBUWEIJKVVNUWS
        UWNVVMUWSVVKAUWSVVLLSZSZVGZVVNUXAUWNVVMUXAVVKAUXAVVLMSZSZVGZUXGVVNUXIUW
        NVVMUXIVVKAUXIVVLNSZSZVGZUWNVVNXDWGXEVWJUXIUPZUWNUPZUWLUUBVWKUXIUWNUWKU
        UKVXAVWKVXBUWLVWHVXAVWFVVNVXAVWFQZUWNVVMVXCVVKAVXCVVLAUXIVXCNUXIVWFYOVF
        SSVGYKVWHVXBVWFUWNVXBVWFQVVNUWNVWFYOSYKUWLVWHVWFVVEUWEPZUWLVWHVCZVWFVXD
        VXEVCZVWEVVEUULZHUOZRVXFVWDVXGHVXFVWDVVEVVEUWHUNZVXGVXDVWDVXIPZVXEVXJUA
        UDUWEVVEVVEUWHUUMUUOSVXFDUWHFVVEIUXGVWHUWSVXDUWLVWNXFVWHVVEDOZVXDUWLVVN
        VXKUWNVVLVXKAVVKVVEDHVEZYPVGXFUUPYQVIVXFVXHHVXGUOZRVXGHUVCVXFVVEHOUPZVX
        MRPVWHVXNVXDUWLVVNVXNUWNVVLVXNAVVKVVEDHUUQYPVGXFHVVEUURXKUUSYQVXDUPZVXE
        VCZDUWHFGHVVEBUWEIJUXGVWHUWSVXOUWLVWNXFVWHUXAVXOUWLVWQXFVWHVVLVXOUWLUWN
        AVVLVVKUUTXFVWHUXIVXOUWLVWTXFVXEUWNVXOUWLUWNVVNXCVGVWHVVEBUWHUNZHUOZRXG
        ZVXOUWLVVNVXSUWNVVMVVKVXSVVMVVJVXRRVVMVVIVXQHVVMDUWHFBVVEIUXGVWLAUXHVVL
        UXJSVVLVXKAVXLVGVHVIUVAWLVGXFVXPUWLUWJRXGVXOUWLVWHXCUWJRXHXKXJUVBYAUVDY
        RXLXMXNXOXPVVNVWGVCZUWNVWBVVNVVLUWNVWFWHZVXTVWAUWKVVNVWGUWLVVKVVMVWGUWL
        QZVVKVVJRPZUPZVVMVYBQVVJRXHVWGVVMVYDUWLVWGVVMVYDUWLQVWGVVMVCZUWKVYCVYEU
        WKVYCVYEUWKVCDUWHFGHBUWEVVEIJUXGVVMUWSVWGUWKVWLYPVVMUXAVWGUWKVWOYPVVMUX
        IVWGUWKVWRYPVYEUWNUWKVVLUWNVWFVVMWKSVWGAVVLUWKUVEVYEUWKUVFVYEUWEVVEUWHU
        NZHUOZRPZUWKVVLUWNVWFVVMVYHVVLUWNVVMVWFVYHVVLUWNVVMVWFVYHQVVLUWNVVMURZV
        WFVYHVYIVWEVYGRVYIVWDVYFHVYIDUWHFVVEUWEIUXGVVMVVLUWSUWNVWLWNVVLUWNVXKVV
        MVXLUTUWNVVLUXKVVMUXLWMVHVIVJWOVOWTXASWRYAWSYAUVGYRXOUVHVXTDEUWHFGHBUWE
        IJKVVNUWSVWGVWMSVVNUXAVWGVWPSUXGVVNUXIVWGVWSSVYAVLUVIXBXQVVNVVQVWBUWNVV
        NVVPVWAVVNUYIUXIVVPVWAWBUYKVWSUWEBETUVPWJXSXEYBVVMVVSVWGWBZVVKAVYJVVLAT
        TDEUWHFGHVVEUWEIJKLMUXGVVETOZAUDWCZWFUYIAUYKWFWGSSUVJUYIVYKVCZVVSVVTWBV
        VNUYIVYKUYKVYLWDVYMVVTVVSUWEVVEETTWJXTWEYCYFYAUVKUVNUVPTOZUWATOVVDVVHWB
        DTOVYNDFYSUMTIFYSYLYMDHTYTYIUVPUVSTYTUDUVPUWAETUJUVLXKCUWAUVQYNVSUVOYKU
        VM @.
    @}

    @{
      @d x M @.  @d x P @.
      hpd.1.1 @e |- ( ph -> A e. ( P \ M ) ) @.
      @( Check Ibg is the right context? @)
      @( Halfplanes are distinct.  (For my private use only.  Don't use.)
         (Contributed by FL, 16-Sep-2016.) @)
      hpd @p |- ( ph -> [ A ] .~ =/= ( ( P \ M ) \ [ A ] .~ ) )
         @=
        ( vx cec cdif wceq wn c0 sylibr wne wa cv wcel isibg1a gltpntl2 intnand
        wex neq0 eqcom sssu bitri sylnibr df-ne ) ABDOZCGPZUOPZQZRUOUQUAAUOSQZU
        PSQZUBZURAUTUSANUCUPUDNUHUTRANCEFGHIAEKUELUFNUPUITUGURUQUOQVAUOUQUJUOUP
        UKULUMUOUQUNT @.
    @}

  @}

  @( The two half planes. @)
  @c Halfplane @.

  @( Extend class notation with the Halfplane symbol. @)
  chalfp @a class Halfplane @.

  @{
    @d g l @.
    @( Returns the halplanes delimited by ` l ` .  (For my private use only.
       Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
    df-halfplane @a |- Halfplane = ( g e. Ibg |-> ( l e. ( PLines ` g ) |->
      ( ( ( PPoints ` g ) \ l )
                 /. ( ( ss ` g ) ` l ) ) ) ) @.
  @}

  @{
    abhp.1 @e |- ( ph -> G e. Ibg ) @.
    abhp.2 @e |- ( ph -> M e. L ) @.
    abhp.3 @e |- P = ( PPoints ` G ) @.
    abhp.4 @e |- .~ = ( ( ss ` G ) ` M ) @.
    abhp.5 @e |- L = ( PLines ` G ) @.
    @{
      @d g l G @.  @d g l ph @.  @d l M @.
      @( The half planes delimited by ` M ` .  (For my private use only.  Don't
         use.)  (Contributed by FL, 16-Sep-2016.) @)
      aishp @p |- ( ph -> ( ( Halfplane ` G ) ` M ) = ( ( P \ M ) /. .~ ) )
       @=
        ( vl vg cfv cpoints cdif cqs cvv wceq wcel csas cv cplines df-halfplane
        chalfp cmpt a1i fveq2 difeq1d qseq1 fveq1d qseq2 eqtrd mpteq12dv adantl
        cibg syl fvex mptexg fvmptd difeq2 syl6eleq difexg ax-mp eqcomi difeq1i
        mp1i qsex 3eqtrd ) AFDUENZNDONZFPZFDUANZNZQZBFPZVNQZVPCQZALFVKLUBZPZVSV
        MNZQZVODUCNZVJRAMDLMUBZUCNZWDONZVSPZVSWDUANZNZQZUFZLWCWBUFZUPUERUEMUPWK
        UFSAMLUDUGWDDSZWKWLSAWMLWEWJWCWBWDDUCUHWMWJVTWIQZWBWMWGVTSWJWNSWMWFVKVS
        WDDOUHUIWGVTWIUJUQWMWIWASWNWBSWMVSWHVMWDDUAUHUKWIWAVTULUQUMUNUOGWCRTWLR
        TADUCURLWCWBRUSVGUTVSFSZWBVOSAWOWBVLWAQZVOWOVTVLSWBWPSVSFVKVAVTVLWAUJUQ
        WOWAVNSWPVOSVSFVMUHWAVNVLULUQUMUOAFEWCHKVBVORTAVLVNVKRTVLRTDOURVKFRVCVD
        VHUGUTVLVPSVOVQSAVKBFBVKIVEVFVLVPVNUJVGVNCSVQVRSACVNJVEVNCVPULVGVI @.
    @}

    @{
      @d x .~ @.  @d x H @.  @d x M @.  @d x P @.  @d x ph @.
     @( reximdai rexlimd pdiveql @)
      @( The half planes delimited by ` M ` .  (For my private use only.  Don't
         use.)  (Contributed by FL, 16-Sep-2016.) @)
      abhp @p |- ( ph -> ( H e. ( ( Halfplane ` G ) ` M )
       <-> E. x e. ( P \ M ) ( H = [ x ] .~ \/ H =
        ( ( P \ M ) \ [ x ] .~ ) ) ) ) @=
        ( cfv wcel cdif wceq wrex wa adantr chalfp cqs cv cec aishp eleq2d wnel
        wo wi isibg1a gltpntl wn df-nel biimpi anim2i eldif sylibr adantl simpl
        ex reximdv2 com12 cibg simpr pdiveql biimpd reximdva syl9 mpcom biimprd
        jca rexlimdva impbid bitrd ) AFHEUANNZOFCHPZDUBZOZFBUCZDUDZQFVPVTPQUHZB
        VPRZAVOVQFACDEGHIJKLMUEUFAVRWBVSHUGZBCRZAVRWBUIABCEGHKMAEIUJJUKWDVRVRBV
        PRZAWBVRWDWEVRWCVRBCVPVRVSCOZWCSZVSVPOZVRSVRWGSWHVRWGWHVRWGWFVSHOULZSWH
        WCWIWFWCWIVSHUMUNUOVSCHUPUQURVRWGUSVKUTVAVBAVRWABVPAWHSZVRWAWJVSFCDEGHK
        MLAEVCOWHITAHGOWHJTAWHVDVEZVFVGVHVIAWAVRBVPWJVRWAWKVJVLVMVN @.
    @}

    @{
      abhp1.1 @e |- ( ph -> A e. ( P \ M ) ) @.
     @( pdiveql @)
      @( The half planes delimited by ` M ` .  (For my private use only.  Don't
         use.)  (Contributed by FL, 16-Sep-2016.) @)
      abhp1 @p |- ( ph -> ( H e. ( ( Halfplane ` G ) ` M )
       <-> ( H = [ A ] .~ \/ H =
        ( ( P \ M ) \ [ A ] .~ ) ) ) ) @=
        ( chalfp cfv wcel cdif cqs wceq cec wo aishp eleq2d pdiveql bitrd ) AFH
        EOPPZQFCHRZDSZQFBDUAZTFUHUJRTUBAUGUIFACDEGHIJKLMUCUDABFCDEGHKMLIJNUEUF
        @.
    @}

    @{
      @d x .~ @.  @d x A @.  @d x G @.  @d x M @.  @d x P @.  @d x ph @.
     @( abhp1 and dfcleq elprg @)
      abhp2.1 @e |- ( ph -> A e. ( P \ M ) ) @.
      @( The half planes delimited by ` M ` .  (For my private use only.  Don't
         use.)  (Contributed by FL, 16-Sep-2016.)  NEW @)
      abhp2 @p |- ( ph -> ( ( Halfplane ` G ) ` M )
       = { [ A ] .~ , ( ( P \ M ) \ [ A ] .~ ) } ) @=
        ( vx chalfp cfv cec cdif wcel wceq cpr cv abhp1 vex elpr syl6bbr eqrdv
        wo ) ANGEOPPZBDQZCGRUJRZUAZANUBZUISUMUJTUMUKTUHUMULSABCDEUMFGHIJKLMUCUM
        UJUKNUDUEUFUG @.
    @}

    @{
      @d h x z .~ @.  @d h x z M @.  @d h x z P @.  @d x z ph @.  @d z G @.
     @( abhp elabf @)
      @( The half planes delimited by ` M ` .  (For my private use only.  Don't
         use.)  (Contributed by FL, 16-Sep-2016.) @)
      bhp2a @p |- ( ph -> ( ( Halfplane ` G ) ` M )
       = { h | E. x e. ( P \ M ) ( h = [ x ] .~ \/ h
       = ( ( P \ M ) \ [ x ] .~ ) ) } ) @=
        ( vz cfv cv wceq cdif wo wcel chalfp cec wrex cab abhp vex wa wb adantr
        eqeq1 orbi12d rexbidva elab syl6bbr eqrdv ) ANHFUAOOZEPZBPZDUBZQZUQCHRZ
        USRZQZSZBVAUCZEUDZANPZUPTVGUSQZVGVBQZSZBVAUCZVGVFTABCDFVGGHIJKLMUEVEVKE
        VGNUFUQVGQZVDVJBVAVLURVATZUGUTVHVCVIVLUTVHUHVMUQVGUSUJUIVLVCVIUHVMUQVGV
        BUJUIUKULUMUNUO @.
    @}

    @{
      @d x G @.  @d x M @.  @d x P @.  @d x ph @.
     @( hashprg abhp2 hpd @)
      @( Every line divides the plane into exactly two half planes .  (For my
         private use only.  Don't use.)  (Contributed by FL, 16-Sep-2016.) @)
      bhp3 @p |- ( ph -> ( # ` ( ( Halfplane ` G ) ` M ) ) = 2 ) @=
        ( vx cfv chash c2 wceq cdif wcel cvv ax-mp chalfp wral cec cpr wne cibg
        cv wa adantr simpr hpd wb csas fvex eqeltri ecexg cpoints hashprg mp2an
        difexg sylib ralrimiva eqcomd fveq2d eqeq1d biimpd ralimdva mpd isibg1a
        abhp2 c0 wex gltpntl2 n0 sylibr r19.3rzv syl mpbird ) AFDUAMMZNMZOPZWAL
        BFQZUBZALUGZCUCZWBWEQZUDZNMZOPZLWBUBWCAWILWBAWDWBRZUHZWEWFUEZWIWKWDBCDE
        FIKJADUFRWJGUIZAFERWJHUIZAWJUJZUKWESRZWFSRZWLWIULCSRWPCFDUMMZMSJFWRUNUO
        WDSCUPTWBSRZWQBSRWSBDUQMSIDUQUNUOBFSUTTWBWESUTTWEWFSURUSVAVBAWIWALWBWKW
        IWAWKWHVTOWKWGVSNWKVSWGWKWDBCDEFWMWNIJKWOVJVCVDVEVFVGVHAWBVKUEZWAWCULAW
        JLVLWTALBDEFIKADGVIHVMLWBVNVOWALWBVPVQVR @.
    @}

  @}

  @( Function returning convex subsets of points. @)
  @c convex @.

  @( Extend class notation with the convex symbol. @)
  cconvex @a class convex @.

  @{
    @d f x p q @.
    @( Definition of the convex subsets of points.  Definition 24 of
       [AitkenIBG] p. 15.  (For my private use only.  Don't use.)  (Contributed
       by FL, 5-Mar-2016.) @)
    df-cnvx @a |- convex = ( f e. Ibg |-> { x e. ~P ( PPoints ` f ) |
      A. p e. x A. q e. x ( p ( seg ` f ) q ) C_ x } ) @.
  @}

  @( The segment congruence slot. @)
  @c segc @.

  @( An incidence betweenness geometry with congruence relationships. @)
  @c Ibcg @.

  @( Extend class notation with the segment congruence selector. @)
  csegc @a class segc @.

  @( Extend class notation with the class of all planar, incidence,
     betweenness, congruence geometries. @)
  cibcg @a class Ibcg @.

  @( Segment congruence selector.  (Contributed by FL, 1-Apr-2016.) @)
  df-segc @a |- segc = .r @.

  @( The angle congruence slot. @)
  @c angc @.

  @( Extend class notation with the angle congruence selector. @)
  cangc @a class angc @.

  @( Angle congruence selector.  (Contributed by FL, 1-Apr-2016.) @)
  df-angc @a |- angc = *r @.


  @( An angle in a  triangle. @)
  @c angtrg @.

  @( Extend class notation a function returning an angle in a triangle. @)
  cangtrg @a class angtrg @.

  @{
    @d g u x @.
    @( Select an angle in a triangle.  Definition 2 of [AitkenIBCG] p. 3.
       (Contributed by FL, 2-Sep-2016.) @)
    df-angtrg @a |- angtrg = ( g e. Ig |->
     ( u e. ( ( PPoints ` g ) dWords 3 ) , x e. ( 1 ... 3 )
       |-> ( ( angle ` g ) ` if ( x = 2 ,
          <" ( u ` 1 ) ( u ` 2 ) ( u ` 3 ) "> ,
       if ( x = 3 ,
          <" ( u ` 2 ) ( u ` 3 ) ( u ` 1 ) "> ,
          <" ( u ` 3 ) ( u ` 1 ) ( u ` 2 ) "> ) ) ) ) ) @.
  @}

  @( A segment in a  triangle. @)
  @c segtrg @.

  @( Extend class notation a function returning a segment in a triangle. @)
  csegtrg @a class segtrg @.

  @{
    @d g u x @.
    @( Select a segment in a triangle.  (Contributed by FL, 2-Sep-2016.) @)
    df-segtrg @a |- segtrg = ( g e. Ig |->
      ( u e. ( ( PPoints ` g ) dWords 3 ) , x e. ( 1 ... 3 )
        |-> ( ( angle ` g ) ` if ( x = 1 ,
          ( ( u ` 1 ) ( seg ` g ) ( u ` 2 ) ) ,
          if ( x = 2 ,
            ( ( u ` 2 ) ( seg ` g ) ( u ` 3 ) ) ,
            ( ( u ` 3 ) ( seg ` g ) ( u ` 1 ) ) ) ) ) ) ) @.
  @}

  @{
    @d g u v @.
    @( g e. _V because otherwise there is a soundness issue. @)
    @( Congruence of two triangles.  Triangles are congruent if their sides and
       angles are congruent.  "Technically, congruence is not a property of
       triangles themselves, but of triangles with a given ordering of their
       vertices.  Triangles that are congruent under one ordering, might not be
       under other orderings."  Definition 2 of [AitkenIBCG] p. 3.
       (Contributed by FL, 2-Sep-2016.) @)
    df-trcng @a |- trcng = ( g e. _V |->
    { <. u , v >. | ( ( u e. ( ( PPoints ` g ) dWords 3 ) /\
       v e. ( ( PPoints ` g ) dWords 3 ) )
      /\
        ( ( u ( segtrg ` g ) 1 ) ( segc ` g ) ( v ( segtrg ` g ) 1 )
        /\ ( u ( segtrg ` g ) 2 ) ( segc ` g ) ( v ( segtrg ` g ) 2 )
        /\ ( u ( segtrg ` g ) 3 ) ( segc ` g ) ( v ( segtrg ` g ) 3 ) )
      /\ ( ( u ( angtrg ` g ) 2 ) ( angc ` g ) ( v ( angtrg ` g ) 2 )
              /\ ( u ( angtrg ` g ) 3 ) ( angc ` g ) ( v ( angtrg ` g ) 3 )
              /\ ( u ( angtrg ` g ) 1 ) ( angc ` g ) ( v ( angtrg ` g ) 1 )
       ) ) } ) @.
  @}


  @{
    @d a b c d e f g l o p q r s t u v w x y z @.
    @( Incidence-Betweenness Geometry plus congruence axioms.  (Here is an
       excerpt of Aitken's handout.)

       Axiom (C-1).  Segment congruence is an equivalence relation for line
       segments.

       Axiom (C-2).  Suppose that ` A B ` is a line segment and ` C D ` is a
       ray.  Then there is a unique point ` E ` on ` C D ` , distinct from
       ` C ` , such that ` A B .~s C E ` .  The next axiom concerns copying
       dividing or intermediate points on a segment.

       Axiom (C-3).  Suppose that ` A C ` and ` A' C' ` are congruent line
       segments.  If B is a point such that ` A * B * C ` , then there is a
       point ` B' ` such that ` A' * B' * C' ` , ` A B .~s A' B' ` , and
       ` B C .~s B' C' ` .

       Axiom (C-4).  Angle congruence is an equivalence relation for angles.

       Axiom (C-5).  (Copying an angle) Suppose ` B A C ` is an angle, and
       ` D E ` is a ray.  Then on any given side of ` D E ` , there is a unique
       ray ` D F ` such that ` B A C .~a E D F ` .

       Axiom (C-6).  (Copying a triangle) Suppose ` A B C ` is a triangle, and
       ` A' B' ` is a segment such that ` A B .~s A' B' ` .  Then on any given
       side of ` A' B' ` , there is a point ` C' ` such that
       ` A B C .~a A' B' C' ` .

       (For my private use only.  Don't use.)  Axiom C-1 C-2, C-3, C-4, C-5,
       C-6 of [AitkenIBCG] p. 2 .  (Contributed by FL, 1-Apr-2016.) @)
    df-ibcg @a |- Ibcg = { g e. Ibg | [. ( angc ` g ) / o ].
       [. ( PPoints ` g ) / p ]. [. ( btw ` g ) / q ]. [. ( ray ` g ) / r ].
       [. ( segc ` g ) / s ]. [. ( seg ` g ) / t ]. [. ( line ` g ) / l ].
    [. ( angle ` g ) / u ]. [. ( triangle ` g ) / v ]. [. ( p dWords 3 ) / w ].
 [. ( Halfplane ` g ) / x ]. [. ( Segments ` g ) / y ]. [. ( trcng ` g ) / z ].
       ( s Er y /\ o Er ( u " w ) /\
         A. d e. p A. e e. p ( d =/= e ->
           ( A. a e. p A. b e. p
                ( ( a =/= b -> E! f e. ( d r e )
                    ( f =/= d /\ ( a t b ) s ( d t f ) ) )
              /\ A. c e. p ( ( c e. ( a q b ) /\ ( a t b ) s ( d t e ) )
                    -> E. f e. p ( f e. ( d q e ) /\ ( a t c ) s ( d t f )
                         /\ ( c t b ) s ( f t e ) ) ) )
           /\
              A. a e. w (
                 A. b e. ( x ` ( d l e ) )
                   E! f e. b
                   ( u ` a ) o
                   ( u ` <" e d f "> )
               /\
                 ( ( ( a ` 1 ) t ( a ` 2 ) ) s ( d t e )
                  -> A. b e. ( x ` ( d l e ) )
                     E. f e. b
                      a z ( v ` <" d e f "> ) ) ) ) ) ) } @.
  @}

  @v .~a @.
  @v .~s @.
  @v .~t @.

  @( Define a connective symbol for use as a class variable. @)
  c.sma @f class .~a @.

  @( Define a connective symbol for use as a class variable. @)
  c.sms @f class .~s @.

  @( Define a connective symbol for use as a class variable. @)
  c.smt @f class .~t @.

  @{
    @d a b c d e f g l o p q r s t u v w x y z @.
    @d a b d e f l o p q r s t u v w x y z .~a @.
    @d a b c d e f l q r s t u v w x y z .~s @.
    @d a b d e f l q r s t u v w x y z .~t @.
    @d a b c d e f l q r s t u v w x y z A @.
    @d a b c d e f l q r s t u v w x y z B @.
    @d a b d e f l q r s t u v w x y z H @.
    @d a b c d e f l q r s t u v w x y z L @.
    @d a b c d e f l p q r s t u v w x y z P @.
    @d a b c d e f l q r s t u v w x y z R @.
    @d a b c d e f l q r s t u v w x y z S @.
    @d a b d e f l q r s t u v w x y z T @.
    @d a b d e f l q r s t u v w x y z U @.
    @d a b d e f l q r s t u v w x y z W @.
    @d g l o p q r s t u v w x y z G @.
    isibcg.1 @e |- .~a = ( angc ` G ) @.
    isibcg.2 @e |- P = ( PPoints ` G ) @.
    isibcg.3 @e |- U = ( Segments ` G ) @.
    isibcg.4 @e |- B = ( btw ` G ) @.
    isibcg.5 @e |- R = ( ray ` G ) @.
    isibcg.6 @e |- .~s = ( segc ` G ) @.
    isibcg.7 @e |- S = ( seg ` G ) @.
    isibcg.8 @e |- L = ( line ` G ) @.
    isibcg.9 @e |- H = ( Halfplane ` G ) @.
    isibcg.10 @e |- T = ( triangle ` G ) @.
    isibcg.11 @e |- A = ( angle ` G ) @.
    isibcg.12 @e |- .~t = ( trcng ` G ) @.
    isibcg.13 @e |- W = ( P dWords 3 ) @.
    @( The predicate "is an incidence betwenness geometry with congruences".
       (For my private use only.  Don't use.)  (Contributed by FL,
       16-Sep-2016.) @)
    isibcg @p |- ( G e. Ibcg <-> ( G e. Ibg /\
       ( .~s Er U /\ .~a Er ( A " W ) ) /\
         A. d e. P A. e e. P ( d =/= e ->
           ( A. a e. P A. b e. P
                ( ( a =/= b -> E! f e. ( d R e )
                    ( f =/= d /\ ( a S b ) .~s ( d S f ) ) )
              /\ A. c e. P ( ( c e. ( a B b ) /\ ( a S b ) .~s ( d S e ) )
                    -> E. f e. P ( f e. ( d B e ) /\ ( a S c ) .~s ( d S f )
                         /\ ( c S b ) .~s ( f S e ) ) ) )
           /\
              A. a e. W (
                 A. b e. ( H ` ( d L e ) )
                   E! f e. b
                   ( A ` a ) .~a
                   ( A ` <" e d f "> )
               /\
                 ( ( ( a ` 1 ) S ( a ` 2 ) ) .~s ( d S e )
                  -> A. b e. ( H ` ( d L e ) )
                     E. f e. b
                      a .~t ( T ` <" d e f "> ) ) ) ) ) ) ) @=
      ( vy vs vu vw vo vt vr vq vp vl vx vv vz vg cibcg wcel cv wer cima wne co
      wbr wa wreu wi w3a wrex wral cfv cs3 ctrcng wsbc cSeg chalfp c3 ctriangle
      cdwords cangle cline cseg csegc cray2 cbtw cpoints cangc cibg fveq2 biidd
      wceq sbcbidv2 sbcbidv fvex eqtr breq reubidv ralbidv anbi1d anbi2d imbi2d
      wb ereq1 2ralbidv 3anbi23d syl expcom eqcoms ax-mp raleqbi1dv wtru eqcomi
      sbcie a1i eqeltri 3ad2ant3 oveq 3ad2ant2 3ad2ant1 anbi12d rexbidv imbi12d
      cvv eleq2d sbc3ie ereq2 breq12d fveq1 3bitri c1 crab df-ibcg eleq2i elrab
      c2 oveq1 rexeq 3anbi3d trud reubidvag 3anbi123d imbi1d 3anbi13d raleqbidv
      imaeq1 fveq2d raleqdv ovex imaeq2 eleq2 simp1 fveq1d breq2d df-3an adantr
      ralbidv2 adantl syl5bb sbc2ie anbi2i 3anass bitr4i ) JVHVIJUNVJZUOVJZVKZU
      PVJZUQVJZVLZURVJZVKZQVJZHVJZVMZNVJZOVJZVMZIVJZUWBVMZUWEUWFUSVJZVNZUWBUWHU
      WJVNZUVOVOZVPZIUWBUWCUTVJZVNZVQZVRZPVJZUWEUWFVAVJZVNZVIZUWKUWBUWCUWJVNZUV
      OVOZVPZUWHUWBUWCUWTVNZVIZUWEUWSUWJVNZUWLUVOVOZUWSUWFUWJVNZUWHUWCUWJVNZUVO
      VOZVSZIVBVJZVTZVRZPUXNWAZVPZOUXNWAZNUXNWAZUWEUVQWBZUWCUWBUWHWCZUVQWBZUVTV
      OZIUWFVQZOUWBUWCVCVJZVNZVDVJZWBZWAZUUAUWEWBZUUFUWEWBZUWJVNZUXCUVOVOZUWEUW
      BUWCUWHWCZVEVJZWBZVFVJZVOZIUWFVTZOUYIWAZVRZVPZNUVRWAZVPZVRZHUXNWAQUXNWAZV
      SZVFVGVJZWDWBZWEZUNVUIWFWBZWEZVDVUIWGWBZWEZUQUXNWHWJVNZWEZVEVUIWIWBZWEZUP
      VUIWKWBZWEZVCVUIWLWBZWEZUSVUIWMWBZWEZUOVUIWNWBZWEZUTVUIWOWBZWEZVAVUIWPWBZ
      WEZVBVUIWQWBZWEZURVUIWRWBZWEZVGWSUUBZVIJWSVIZVUHVFJWDWBZWEZUNJWFWBZWEZVDJ
      WGWBZWEZUQVUPWEZVEJWIWBZWEZUPJWKWBZWEZVCJWLWBZWEZUSJWMWBZWEZUOJWNWBZWEZUT
      JWOWBZWEZVAJWPWBZWEZVBJWQWBZWEZURJWRWBZWEZVPZVVQGSVKZAMVLZRVKZVPZUWDUWGUW
      IUWEUWFEVNZUWBUWHEVNZSVOZVPZIUWBUWCDVNZVQZVRZUWSUWEUWFBVNZVIZVXHUWBUWCEVN
      ZSVOZVPZUWHUWBUWCBVNZVIZUWEUWSEVNZVXISVOZUWSUWFEVNZUWHUWCEVNZSVOZVSZICVTZ
      VRZPCWAZVPZOCWANCWAZUWEAWBZUYBAWBZRVOZIUWFVQZOUWBUWCLVNZKWBZWAZUYKUYLEVNZ
      VXQSVOZUWEUYOFWBZTVOZIUWFVTZOVYRWAZVRZVPZNMWAZVPZVRZHCWAQCWAZVSZVHVVPJVDU
      NVFUQVEUPUSHIVGURUOUTVAVBNOPQVCUUCUUDVVOVXBVGJWSVUIJXBZVVMVWTURVVNVXAVUIJ
      WRWTWUMVVKVWRVBVVLVWSVUIJWQWTWUMVVIVWPVAVVJVWQVUIJWPWTWUMVVGVWNUTVVHVWOVU
      IJWOWTWUMVVEVWLUOVVFVWMVUIJWNWTWUMVVCVWJUSVVDVWKVUIJWMWTWUMVVAVWHVCVVBVWI
      VUIJWLWTWUMVUSVWFUPVUTVWGVUIJWKWTWUMVUQVWDVEVURVWEVUIJWIWTWUMVUOVWCUQVUPW
      UMVUMVWAVDVUNVWBVUIJWGWTWUMVUKVVSUNVULVVTVUIJWFWTWUMVUHVUHVFVUJVVRVUIJWDW
      TWUMVUHXAXCXCXCXDXCXCXCXCXCXCXCXCXCUUEVXCVVQVXGWUKVPZVPWULVXBWUNVVQVXBUVP
      UVSRVKZUWDUXTUYAUYCRVOZIUWFVQZOUYIWAZVUBVPZNUVRWAZVPZVRZHUXNWAZQUXNWAZVSZ
      VFVVRWEZUNVVTWEZVDVWBWEZUQVUPWEZVEVWEWEZUPVWGWEZVCVWIWEZUSVWKWEZUOVWMWEZU
      TVWOWEZVAVWQWEZVBVWSWEZUVPWUOUWDUWRUXEUXMICVTZVRZPCWAZVPZOCWAZNCWAZWUTVPZ
      VRZHCWAZQCWAZVSZVFVVRWEZUNVVTWEZVDVWBWEZUQCWHWJVNZWEZVEVWEWEZUPVWGWEZVCVW
      IWEZUSVWKWEZUOVWMWEZUTVWOWEZVAVWQWEZWUNVWTWVQURVXAJWRXERVXAXBUVTVXAXBZVWT
      WVQXMZVRZUAWXCVXARWXAVXARXBZWXBWXAWXDVPUVTRXBZWXBUVTVXARXFWXEVWRWVPVBVWSW
      XEVWPWVOVAVWQWXEVWNWVNUTVWOWXEVWLWVMUOVWMWXEVWJWVLUSVWKWXEVWHWVKVCVWIWXEV
      WFWVJUPVWGWXEVWDWVIVEVWEWXEVWCWVHUQVUPWXEVWAWVGVDVWBWXEVVSWVFUNVVTWXEVUHW
      VEVFVVRWXEUWAWUOVUGWVDUVPUVSUVTRXNWXEVUFWVBQHUXNUXNWXEVUEWVAUWDWXEVUDWUTU
      XTWXEVUCWUSNUVRWXEUYJWURVUBWXEUYEWUQOUYIWXEUYDWUPIUWFUYAUYCUVTRXGXHXIXJXI
      XKXLXOXPXDXDXDXDXDXDXDXDXDXDXDXDXQXRXSXTYDWVPWWTVBVWSJWQXECVWSXBUXNVWSXBZ
      WVPWWTXMZVRZUBWXHVWSCWXFVWSCXBZWXGWXFWXIVPUXNCXBZWXGUXNVWSCXFWXJWVOWWSVAV
      WQWXJWVNWWRUTVWOWXJWVMWWQUOVWMWXJWVLWWPUSVWKWXJWVKWWOVCVWIWXJWVJWWNUPVWGW
      XJWVIWWMVEVWEWXJWVHWWKUQVUPWWLUXNCWHWJUUGWXJWVGWWJVDVWBWXJWVFWWIUNVVTWXJW
      VEWWHVFVVRWXJWVDWWGUVPWUOWVCWWFQUXNCWVBWWEHUXNCWXJWVAWWDUWDWXJUXTWWCWUTUX
      SWWBNUXNCUXRWWAOUXNCWXJUXQWVTUWRUXPWVSPUXNCWXJUXOWVRUXEUXMIUXNCUUHXLYAXKY
      AYAXJXLYAYAUUIXDXDXDXCXDXDXDXDXDXDXDXQXRXSXTYDWWTWWHVFTWEZUNGWEZVDKWEZUQM
      WEZVEFWEZUPAWEZVCLWEZUSEWEZUOSWEZUTDWEZVABWEZUVNSVKZWUOUWDUWGUWIUWKUWLSVO
      ZVPZIVXLVQZVRZVXPUWKUXCSVOZVPZVYAUXHUWLSVOZUXJUXKSVOZVSZICVTZVRZPCWAZVPZO
      CWANCWAZWURUYMUXCSVOZVUAVRZVPZNUVRWAZVPZVRZHCWAQCWAZVSZVFTWEZUNGWEZVDKWEZ
      UQMWEZVEFWEZUPAWEZVCLWEZUSEWEZWUNWWTWYAXMYBWWSWXTVAVWQBVWQBXBYBBVWQUDYCYE
      YBWWRWXSUTVWODVWODXBYBDVWOUEYCYEYBWWQWXRUOVWMSVWMSXBYBSVWMUFYCYEYBWWPWXQU
      SVWKEVWKEXBYBEVWKUGYCYEYBWWOWXPVCVWILVWILXBYBLVWIUHYCYEYBWWNWXOUPVWGAVWGA
      XBYBAVWGUKYCYEYBWWMWXNVEVWEFVWEFXBYBFVWEUJYCYEYBWWKWXMUQWWLMWWLMXBYBMWWLU
      MYCYEYBWWJWXLVDVWBKVWBKXBYBKVWBUIYCYEYBWWIWXKUNVVTGVVTGXBYBGVVTUCYCYEYBWW
      HWWHVFVVRTVVRTXBYBTVVRULYCYEYBWWHXAXCXCXCXCXCXCXCXCXCXCXCUUJWXRXULVAUTUOB
      DSBVWQYNUDJWPXEYFDVWOYNUEJWOXEYFSVWMYNUFJWNXEYFUWTBXBZUWODXBZUVOSXBZVSZWX
      QXUKUSEXUPWXPXUJVCLXUPWXOXUIUPAXUPWXNXUHVEFXUPWXMXUGUQMXUPWXLXUFVDKXUPWXK
      XUEUNGXUPWWHXUDVFTXUPUVPWYBWWGXUCWUOXUOXUMUVPWYBXMXUNUVNUVOSXNYGXUPWWEXUB
      QHCCXUPWWDXUAUWDXUPWWCWYPWUTWYTXUPWWAWYONOCCXUPUWRWYFWVTWYNXUPUWQWYEUWGXU
      PUWNWYDIUWPVXLXUPUWMWYCUWIXUOXUMUWMWYCXMXUNUWKUWLUVOSXGYGXKXUNXUMUWPVXLXB
      XUOUWBUWCUWODYHYIUUKXLXUPWVSWYMPCXUPUXEWYHWVRWYLXUPUXBVXPUXDWYGXUMXUNUXBV
      XPXMXUOXUMUXAVXOUWSUWEUWFUWTBYHYOYJXUOXUMUXDWYGXMXUNUWKUXCUVOSXGYGYKXUPUX
      MWYKICXUPUXGVYAUXIWYIUXLWYJXUMXUNUXGVYAXMXUOXUMUXFVXTUWHUWBUWCUWTBYHYOYJX
      UOXUMUXIWYIXMXUNUXHUWLUVOSXGYGXUOXUMUXLWYJXMXUNUXJUXKUVOSXGYGUULYLYMXIYKX
      OXUPWUSWYSNUVRXUPVUBWYRWURXUPUYNWYQVUAXUOXUMUYNWYQXMXUNUYMUXCUVOSXGYGUUMX
      KXIYKXLXOUUNXDXDXDXDXDXDXDXDYPXULWYBAUVRVLZRVKZUWDVYLVYPOVYQUYHWBZWAZWUAU
      YTOXUSWAZVRZVPZNUVRWAZVPZVRZHCWAQCWAZVSZVFTWEZUNGWEZVDKWEZUQMWEZVEFWEZWYB
      VXFUWDVYLVYSWUAUWEWUBUYRVOZIUWFVTZOVYRWAZVRZVPZNMWAZVPZVRZHCWAQCWAZVSZVFT
      WEZUNGWEZWUNXUIXVMUSVCUPELAEVWKYNUGJWMXEYFLVWIYNUHJWLXEYFAVWGYNUKJWKXEYFU
      WJEXBZUYFLXBZUVQAXBZVSZXUHXVLVEFXWIXUGXVKUQMXWIXUFXVJVDKXWIXUEXVIUNGXWIXU
      DXVHVFTXWIWUOXURXUCXVGWYBXWHXWFWUOXURXMZXWGXWHUVSXUQXBXWJUVQAUVRUUPUVSXUQ
      RYQXQYGXWIXUBXVFQHCCXWIXUAXVEUWDXWIWYPVYLWYTXVDXWIWYOVYKNOCCXWIWYFVXNWYNV
      YJXWIWYEVXMUWGXWIWYDVXKIVXLXWIWYCVXJUWIXWIUWKVXHUWLVXISXWFXWGUWKVXHXBXWHU
      WEUWFUWJEYHZYJXWFXWGUWLVXIXBXWHUWBUWHUWJEYHYJZYRXKXHXLXWIWYMVYIPCXWIWYHVX
      SWYLVYHXWIWYGVXRVXPXWFXWGWYGVXRXMXWHXWFUWKVXHUXCVXQSXWKUWBUWCUWJEYHZYRYJX
      KXWIWYKVYGICXWIWYIVYCWYJVYFVYAXWIUXHVYBUWLVXISXWFXWGUXHVYBXBXWHUWEUWSUWJE
      YHYJXWLYRXWFXWGWYJVYFXMXWHXWFUXJVYDUXKVYESUWSUWFUWJEYHUWHUWCUWJEYHYRYJXPY
      LYMXIYKXOXWIWYSXVCNUVRXWIWURXUTWYRXVBXWIWUQVYPOUYIXUSXWIUYGVYQUYHXWGXWFUY
      GVYQXBXWHUWBUWCUYFLYHYIUUQZXWIWUPVYOIUWFXWHXWFWUPVYOXMXWGXWHUYAVYMUYCVYNR
      UWEUVQAYSUYBUVQAYSYRYGXHUUOXWIWYQWUAVUAXVAXWFXWGWYQWUAXMXWHXWFUYMVYTUXCVX
      QSUYKUYLUWJEYHXWMYRYJXWIUYTOUYIXUSXWNUURYMYKXIYKXLXOXPXDXDXDXDXDYPXVJXWEV
      EUQVDFMKFVWEYNUJJWIXEYFMWWLYNUMCWHWJUUSYFKVWBYNUIJWGXEYFUYPFXBZUVRMXBZUYH
      KXBZVSZXVIXWDUNGXWRXVHXWCVFTXWRXURVXFXVGXWBWYBXWPXWOXURVXFXMZXWQXWPXUQVXE
      XBXWSUVRMAUUTXUQVXERYQXQYIXWRXVFXWAQHCCXWRXVEXVTUWDXWRXVDXVSVYLXWRXVCXVRN
      UVRMXWRUWEUVRVIZUWEMVIZXVCXVRXWPXWOXWTXXAXMXWQUVRMUWEUVAYIXWRXUTVYSXVBXVQ
      XWRVYPOXUSVYRXWQXWOXUSVYRXBXWPVYQUYHKYSYGZUURXWRXVAXVPWUAXWRUYTXVOOXUSVYR
      XXBXWRUYSXVNIUWFXWRUYQWUBUWEUYRXWRUYOUYPFXWOXWPXWQUVBUVCUVDYLUUOXLYKYMUVG
      XKXLXOXPXDXDYPXWCWUNUNVFGTGVVTYNUCJWFXEYFTVVRYNULJWDXEYFXWCWYBVXFVPZXWBVP
      UVNGXBZUYRTXBZVPZWUNWYBVXFXWBUVEXXFXXCVXGXWBWUKXXFWYBVXDVXFXXDWYBVXDXMXXE
      UVNGSYQUVFXJXXFXWAWUJQHCCXXFXVTWUIUWDXXFXVSWUHVYLXXFXVRWUGNMXXFXVQWUFVYSX
      XFXVPWUEWUAXXFXVOWUDOVYRXXFXVNWUCIUWFXXEXVNWUCXMXXDUWEWUBUYRTXGUVHYLXIXLX
      KXIXKXLXOYKUVIUVJYTYTYTUVKVVQVXGWUKUVLUVMYT @.
  @}

  @( Function returning the slices of a set of points. @)
  @c slices @.

  @( Extend class notation with the slices symbol. @)
  cslices @a class slices @.

  @{
    @d f x a b @.
    @( Return the slices generated by the Dedekind cut of a set of points.
       Definition 1 of [AitkenNG] p. 2.  (For my private use only.  Don't
       use.)  (Contributed by FL, 5-Mar-2016.) @)
    df-slices @a |- slices = ( f e. Ibg |-> ( x e. ~P ( PPoints ` f ) |->
      { <. a , b >. | ( ( ( a u. b ) = x /\ ( a i^i b ) = (/) ) /\
                        ( a =/= (/) /\ b =/= (/) ) /\
                   ( a e. ( convex ` f ) /\ b e. ( convex ` f ) ) ) } ) ) @.
  @}

  @( Function returning the cut point of a set of points. @)
  @c Cut @.

  @( Extend class notation with the cutpoint symbol. @)
  ccut @a class Cut @.

  @{
    @d f x y c u v @.
    @( Return the cutpoints of a set of points ` ( x u. y ) ` where ` x ` and
       ` y ` are the slices of a Dedekind cut of ` ( x u. y ) ` .  Definition 2
       of [AitkenNG] p. 2.  (For my private use only.  Don't use.)
       (Contributed by FL, 5-Mar-2016.) @)
    df-Cut @a |- Cut = ( f e. Ibg |-> ( x e. ~P ( PPoints ` f )
      , y e. ~P ( PPoints ` f ) |->
      { c e. ( x u. y ) | A. u e. ( x u. y ) A. v e. ( x u. y )
        ( u e. ( c ( btw ` f ) v ) ->
            ( ( u e. x /\ v e. x ) \/ ( u e. y /\ v e. y ) ) ) } ) ) @.
  @}

  @( A neutral geometry. @)
  @c Neug @.

  @( Extend class notation with the neutral geometry symbol. @)
  cneug @a class Neug @.

  @{
    @d g l u @.
    @( Definition of a neutral geometry.  Every Dedekind cut of a line has a
       cut point.  (Axiom of Dedekind in [AitkenNG] p. 3.)  (For my private use
       only.  Don't use.)  (Contributed by FL, 1-Apr-2016.) @)
    df-neug @a |- Neug = { g e. Ibcg | A. l e. ( PLines ` g )
     A. u e. ( ( slices ` g ) ` l )
       ( ( 1st ` u ) ( Cut ` g ) ( 2nd ` u ) ) =/= (/) } @.
  @}

  @( Function returning a circle. @)
  @c Circle @.

  @( Extend class notation with the Circle symbol. @)
  ccircle @a class Circle @.

  @{
    @d g x y u @.
    @( Definition of a circle (degenerated or not).  Definition 5 of [AitkenNG]
       p. 4.  (For my private use only.  Don't use.)  (Contributed by FL,
       5-Mar-2016.) @)
    df-crcl @a |- Circle = ( g e. Ibcg |-> ( x e. ( PPoints ` g ) ,
      y e. ( PPoints ` g ) |-> { u e. ( PPoints ` g ) |
      ( x ( seg ` g ) u ) ( segc ` g ) ( x ( seg ` g ) y ) } ) ) @.
  @}

@( (End of FL's mathbox.) @)
********* end of commenting out FL's mathbox $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Jeff Hankins
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                              Miscellany
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    a1i13.1 $e |- ( ps -> th ) $.
    $( Add two antecedents to a wff.  (Contributed by Jeff Hankins,
       4-Aug-2009.) $)
    a1i13 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( wi a1d a1i ) BCDFFABDCEGH $.
  $}

  ${
    a1i4.1 $e |- ( ph -> ( ps -> ( ch -> ta ) ) ) $.
    $( Add an antecedent to a wff.  (Contributed by Jeff Hankins,
       4-Aug-2009.) $)
    a1i4 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi ax-1 syl8 ) ABCEDEGFEDHI $.
  $}

  ${
    a1i14.1 $e |- ( ps -> ( ch -> ta ) ) $.
    $( Add two antecedents to a wff.  (Contributed by Jeff Hankins,
       4-Aug-2009.) $)
    a1i14 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi a1dd a1i ) BCDEGGGABCEDFHI $.
  $}

  ${
    a1i24.1 $e |- ( ph -> ( ch -> ta ) ) $.
    $( Add two antecedents to a wff.  (Contributed by Jeff Hankins,
       5-Aug-2009.) $)
    a1i24 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi a1dd a1d ) ACDEGGBACEDFHI $.
  $}

  ${
    a1i34.1 $e |- ( ph -> ( ps -> ta ) ) $.
    $( Add two antecedents to a wff.  (Contributed by Jeff Hankins,
       5-Aug-2009.) $)
    a1i34 $p |- ( ph -> ( ps -> ( ch -> ( th -> ta ) ) ) ) $=
      ( wi a1dd ) ABDEGCABEDFHH $.
  $}

  ${
    exp5d.1 $e |- ( ( ( ph /\ ps ) /\ ch ) -> ( ( th /\ ta ) -> et ) ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp5d $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi wa exp3a exp31 ) ABCDEFHHABICIDEFGJK $.
  $}

  ${
    exp5g.1 $e |- ( ( ph /\ ps ) -> ( ( ( ch /\ th ) /\ ta ) -> et ) ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp5g $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi wa exp4c ex ) ABCDEFHHHABICDEFGJK $.
  $}

  ${
    exp5j.1 $e |- ( ph -> ( ( ( ( ps /\ ch ) /\ th ) /\ ta ) -> et ) ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp5j $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi wa exp3a exp4c ) ABCDEFHABCIDIEFGJK $.
  $}

  ${
    exp5k.1 $e |- ( ph -> ( ( ( ps /\ ( ch /\ th ) ) /\ ta ) -> et ) ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp5k $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wi wa exp3a exp4d ) ABCDEFHABCDIIEFGJK $.
  $}

  ${
    exp5l.1 $e |- ( ph -> ( ( ( ps /\ ch ) /\ ( th /\ ta ) ) -> et ) ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp5l $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wa exp3a exp5c ) ABCDEFABCHDEHFGIJ $.
  $}

  ${
    exp56.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ ( th /\ ta ) ) -> et ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp56 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wa ex exp5d ) ABCDEFABHCHDEHFGIJ $.
  $}

  ${
    exp58.1 $e |- ( ( ( ph /\ ps ) /\ ( ( ch /\ th ) /\ ta ) ) -> et ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp58 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wa ex exp5g ) ABCDEFABHCDHEHFGIJ $.
  $}

  ${
    exp510.1 $e |- ( ( ph /\ ( ( ( ps /\ ch ) /\ th ) /\ ta ) ) -> et ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp510 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wa ex exp5j ) ABCDEFABCHDHEHFGIJ $.
  $}

  ${
    exp511.1 $e |- ( ( ph /\ ( ( ps /\ ( ch /\ th ) ) /\ ta ) ) -> et ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp511 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wa ex exp5k ) ABCDEFABCDHHEHFGIJ $.
  $}

  ${
    exp512.1 $e |- ( ( ph /\ ( ( ps /\ ch ) /\ ( th /\ ta ) ) ) -> et ) $.
    $( An exportation inference.  (Contributed by Jeff Hankins, 7-Jul-2009.) $)
    exp512 $p |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $=
      ( wa ex exp5l ) ABCDEFABCHDEHHFGIJ $.
  $}

  ${
    3com12d.1 $e |- ( ph -> ( ps /\ ch /\ th ) ) $.
    $( Commutation in consequent.  Swap 1st and 2nd.  (Contributed by Jeff
       Hankins, 17-Nov-2009.) $)
    3com12d $p |- ( ph -> ( ch /\ ps /\ th ) ) $=
      ( w3a id 3com12 syl ) ABCDFCBDFZECBDJJGHI $.
  $}

  ${
    3imp5.1 $e |- ( ph -> ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) ) $.
    $( A triple importation inference.  (Contributed by Jeff Hankins,
       8-Jul-2009.) $)
    imp5p $p |- ( ph -> ( ps -> ( ( ch /\ th /\ ta ) -> et ) ) ) $=
      ( w3a wi com52l 3imp com3l ) CDEHABFCDEABFIIABCDEFGJKL $.

    $( A triple importation inference.  (Contributed by Jeff Hankins,
       8-Jul-2009.) $)
    imp5q $p |- ( ( ph /\ ps ) -> ( ( ch /\ th /\ ta ) -> et ) ) $=
      ( wa wi imp 3impd ) ABHCDEFABCDEFIIIGJK $.
  $}

  ${
    ecase13d.1 $e |- ( ph -> -. ch ) $.
    ecase13d.2 $e |- ( ph -> -. th ) $.
    ecase13d.3 $e |- ( ph -> ( ch \/ ps \/ th ) ) $.
    $( Deduction for elimination by cases.  (Contributed by Jeff Hankins,
       18-Aug-2009.) $)
    ecase13d $p |- ( ph -> ps ) $=
      ( wn wo wi w3o 3orass df-or bitri sylib mpd orcom ) ADHZBFABDIZRBJZACHZSE
      ACBDKZUASJZGUBCSIUCCBDLCSMNOPSDBITBDQDBMNOP $.
  $}

  ${
    $d z w ph $.  $d z w ps $.  $d z w ch $.  $d y z w A $.  $d y z w B $.
    $d y z w X $.  $d y z w Y $.  $d y z w Z $.  $d x y z w $.
    subtr.1 $e |- F/_ x A $.
    subtr.2 $e |- F/_ x B $.
    ${
      subtr.3 $e |- F/_ x Y $.
      subtr.4 $e |- F/_ x Z $.
      subtr.5 $e |- ( x = A -> X = Y ) $.
      subtr.6 $e |- ( x = B -> X = Z ) $.
      $( Transitivity of implicit substitution.  (Contributed by Jeff Hankins,
         13-Sep-2009.)  (Proof shortened by Mario Carneiro, 11-Dec-2016.) $)
      subtr $p |- ( ( A e. C /\ B e. D ) -> ( A = B -> Y = Z ) ) $=
        ( wcel wceq wi cv nfeq nfim eqeq1 eqeq1d imbi12d vtoclgf adantr ) BDOBC
        PZGHPZQZCEOARZCPZFHPZQUHABDIUFUGAABCIJSAGHKLSTUIBPZUJUFUKUGUIBCUAULFGHM
        UBUCNUDUE $.
    $}

    ${
      subtr2.3 $e |- F/ x ps $.
      subtr2.4 $e |- F/ x ch $.
      subtr2.5 $e |- ( x = A -> ( ph <-> ps ) ) $.
      subtr2.6 $e |- ( x = B -> ( ph <-> ch ) ) $.
      $( Transitivity of implicit substitution into a wff.  (Contributed by
         Jeff Hankins, 19-Sep-2009.)  (Proof shortened by Mario Carneiro,
         11-Dec-2016.) $)
      subtr2 $p |- ( ( A e. C /\ B e. D ) -> ( A = B -> ( ps <-> ch ) ) ) $=
        ( wcel wceq wb wi cv nfeq nfbi nfim eqeq1 bibi1d imbi12d vtoclgf adantr
        ) EGOEFPZBCQZRZFHODSZFPZACQZRUJDEGIUHUIDDEFIJTBCDKLUAUBUKEPZULUHUMUIUKE
        FUCUNABCMUDUENUFUG $.
    $}
  $}

  ${
    $d a b c r s t .<_ $.
    $( A relation intersected with its converse is an equivalence relation if
       the relation is transitive.  (Contributed by Jeff Hankins, 6-Oct-2009.)
       (Revised by Mario Carneiro, 12-Aug-2015.) $)
    trer $p |- ( A. a A. b A. c ( ( a .<_ b /\ b .<_ c ) -> a .<_ c ) ->
      ( .<_ i^i `' .<_ ) Er dom ( .<_ i^i `' .<_ ) ) $=
      ( vr vs vt cv wbr wa wi wal brin vex brcnv weq breq1 imbi12d spv breq2
      ccnv cin wrel cdm wer wss inss2 relcnv relss mp2 a1i eqidd anbi2i anbi12i
      wceq bitri anbi1d 2albidv anbi12d imbi1d albidv pm3.3 com23 adantrd imp3a
      anbi2d 4syl adantld jcad bitr2i syl6ib syl5bi bicomi 3bitr4i biimpi jctil
      anbi12ci alrimiv alrimivv dfer2 syl3anbrc ) BHZCHZAIZWCDHZAIZJZWBWEAIZKZD
      LCLZBLZAAUAZUBZUCZWMUDZWOUOEHZFHZWMIZWQWPWMIZKZWRWQGHZWMIZJZWPXAWMIZKZJZG
      LZFLELWOWMUEWNWKWMWLUFWLUCWNAWLUGAUHWMWLUIUJUKWKWOULWKXGEFWKXFGWKXEWTXCWP
      WQAIZWQWPAIZJZWQXAAIZXAWQAIZJZJZWKXDWRXJXBXMWRXHWPWQWLIZJZXJWPWQAWLMZXOXI
      XHWPWQAENZFNZOZUMUPXBXKWQXAWLIZJXMWQXAAWLMYAXLXKWQXAAXSGNZOUMUPUNWKXNWPXA
      AIZXAWPAIZJZXDWKXNYCYDWKWPWCAIZWFJZWPWEAIZKZDLZCLZXHWQWEAIZJZYHKZDLZXHXKJ
      ZYCKZXNYCKWJYKBEBEPZWIYICDYRWGYGWHYHYRWDYFWFWBWPWCAQUQWBWPWEAQRURSYJYOCFC
      FPZYIYNDYSYGYMYHYSYFXHWFYLWCWQWPATWCWQWEAQZUSUTVASYNYQDGDGPZYMYPYHYCUUAYL
      XKXHWEXAWQATVFWEXAWPATRSYQXJXMYCYQXHXMYCKXIYQXMXHYCYQXKXHYCKXLYQXHXKYCXHX
      KYCVBVCVDVCVDVEVGWKXAWCAIZWFJZXAWEAIZKZDLZCLZXLYLJZUUDKZDLZXLXIJZYDKZXNYD
      KWJUUGBGBGPZWIUUECDUUMWGUUCWHUUDUUMWDUUBWFWBXAWCAQUQWBXAWEAQRURSUUFUUJCFY
      SUUEUUIDYSUUCUUHUUDYSUUBXLWFYLWCWQXAATYTUSUTVASUUIUULDEDEPZUUHUUKUUDYDUUN
      YLXIXLWEWPWQATVFWEWPXAATRSUULXJXMYDUULXIXMYDKXHUULXMXIYDUULXLXIYDKXKXLXIY
      DVBVHVCVHVEVGVIXDYCWPXAWLIZJYEWPXAAWLMUUOYDYCWPXAAXRYBOUMVJVKVLWRWSXPXIWQ
      WPWLIZJWRWSXHUUPXOXIUUPXHWQWPAXSXROVMXTVQXQWQWPAWLMVNVOVPVRVSEFGWOWMVTWA
      $.
  $}

  $( An equivalent membership condition for closed intervals.  (Contributed by
     Jeff Hankins, 14-Jul-2009.) $)
  elicc3 $p |- ( ( A e. RR* /\ B e. RR* ) -> ( C e. ( A [,] B ) <-> ( C e. RR*
  /\ A <_ B /\ ( C = A \/ ( A < C /\ C < B ) \/ C = B ) ) ) ) $=
    ( cxr wcel wa cle wbr w3a wceq clt wi simp1 a1i xrleltne biimprd syl5ibrcom
    wn wne wo cicc co w3o elicc1 xrletr exp5o com23 imp5q df-ne syl5bir adantlr
    3adant3r3 eqcom necon3bbii syl5bi 3exp com12 imp32 3adantr2 adantll anim12d
    ex df-or 3orass pm5.6 orcom imbi2i bitri 3bitr4ri syl6ib 3jcad xrleid breq2
    xrltle adantr adantllr adantrd simpr 3jaod exp31 3impd breq1 ancoms adantld
    ad3antrrr ad3antlr impbid bitrd ) ADEZBDEZFZCABUAUBECDEZACGHZCBGHZIZWLABGHZ
    CAJZACKHZCBKHZFZCBJZUCZIZABCUDWKWOXCWKWOWLWPXBWOWLLWKWLWMWNMNWIWJWLWMWNWPWI
    WLWJWMWNWPLLWIWLWJWMWNWPACBUEUFUGUHWKWOWQRZXARZFWTLZXBWKWOXFWKWOFXDWRXEWSWI
    WOXDWRLZWJWIWLWMXGWNXDCASZWIWLWMIZWRCAUIXIWRXHACOPUJULUKWJWOXEWSLZWIWJWLWNX
    JWMWJWLWNXJWLWJWNXJLWLWJWNXJXEBCSZWLWJWNIZWSXABCCBUMUNXLWSXKCBOPUOUPUQURUSU
    TVAVBWQWTXATZTXDXMLZXBXFWQXMVCWQWTXAVDXFXDXAWTTZLXNXDXAWTVEXOXMXDXAWTVFVGVH
    VIVJVKWKXCWLWMWNXCWLLWKWLWPXBMNWKWLWPXBWMWKWLWPXBWMLWKWLFZWPFZWQWMWTXAXQWMW
    QAAGHZWIXRWJWLWPAVLWECAAGVMQXQWRWMWSWIWLWPWRWMLZWJWIWLFXSWPACVNVOVPVQXQWMXA
    WPXPWPVRZCBAGVMQVSVTWAWKWLWPXBWNWKWLWPXBWNLXQWQWNWTXAXQWNWQWPXTCABGWBQXPWTW
    NLZWPWJWLYAWIWJWLFWSWNWRWLWJWSWNLCBVNWCWDUTVOXQWNXABBGHZWJYBWIWLWPBVLWFCBBG
    WBQVSVTWAVKWGWH $.

  ${
    $d a k m n y ph $.  $d a k m n x ps $.  $d x y $.
    finminlem.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful lemma about finite sets.  If a property holds for a finite set,
       it holds for a minimal set.  (Contributed by Jeff Hankins,
       4-Dec-2009.) $)
    finminlem $p |- ( E. x e. Fin ph -> E. x ( ph /\ A. y ( ( y C_ x /\ ps ) ->
    x = y ) ) ) $=
      ( vn vm vk cfn wrex cv cen wbr wa wex com c0 wi wcel ex crab wne cin wceq
      wss weq wal nfe1 nfcv nfrab nfne isfi w3a 19.8a anim2i 3impb breq2 anbi1d
      exbidv elrab sylibr ne0i syl 3exp rexlimiv rexlimi con0 cep epweon ssrab2
      sylbi wwe omsson sstri wefrc mp3an12 nfin nfeq1 nfan simprr wpss wo sspss
      nfv wn rspe pssss sylan2 sylbir adantrr simprll simprlr simplrr vex breq1
      ssfi anbi12d spcev syl2anc csdm adantr php3 cdom cvv ssdomg ax-mp endomtr
      ad2antrr ad2antlr ensym domentr expcom syld syl5 domnsym con2i nsyli impr
      ad2antll word wb nnord ad2antrl ordtri1 con2bid mpbird jca31 anbi1i bitri
      elin exp44 rexlimdv syl5bi com23 mpdd necon2bd imp31 pm2.21d equcomi a1i
      jaod expr imp3a alrimiv jca eximd impancom 3syl ) ACIJCKZFKZLMZANZCOZFPUA
      ZQUBZUUNGKZUCZQUDZGUUNJZADKZUUIUEZBNCDUFZRZDUGZNZCOZAUUOCICUUNQUUMCFPUULC
      UHCPUIUJZCQUIUKUUIISZUUIUUPLMZGPJZAUUORZGUUIULZUVIUVKGPUUPPSZUVIAUUOUVMUV
      IAUMZUUPUUNSZUUOUVNUVMUVIANZCOZNZUVOUVMUVIAUVRUVPUVQUVMUVPCUNUOUPUUMUVQFU
      UPPFGUFZUULUVPCUVSUUKUVIAUUJUUPUUILUQURUSUTZVAUUNUUPVBVCVDVEVKVFVGVHVLUUN
      VGUEUUOUUSVIUUNPVGUUMFPVJVMVNGVGUUNVOVPUURUVFGUUNUVOUVRUURUVFRUVTUVMUURUV
      QUVFUVMUURNZUVPUVECUVMUURCUVMCWDCUUQQCUUNUUPUVGCUUPUIVQVRVSUWAUVPUVEUWAUV
      PNZAUVDUWAUVIAVTUWBUVCDUWBUVABUVBUWBBUVAUVBUWAUVPBUVAUVBRUVAUUTUUIWAZDCUF
      ZWBUWAUVPBNZNZUVBUUTUUIWCUWFUWCUVBUWDUWFUWCUVBUVMUURUWEUWCWEZUVMUWEUURUWG
      UVMUWEUURUWGRUVMUWENZUWCUUQQUWHUWCUUTISZUUQQUBZUVMUVPUWCUWIRZBUVMUVIUWKAU
      VMUVINZUVJUWKUVIGPWFZUVJUVHUWKUVLUVHUWCUWIUWCUVHUVAUWIUUTUUIWGUUIUUTWPWHT
      WIVCWJWJUWHUWIUWCUWJUWIUUTHKZLMZHPJUWHUWCUWJRZHUUTULUWHUWOUWPHPUWHUWNPSZU
      WOUWCUWJUWHUWQUWONZUWCNZNZUWNUUQSZUWJUWTUWQUUIUWNLMZANZCOZNZUWNUUPSZNZUXA
      UWTUWQUXDUXFUWHUWQUWOUWCWKUWTUWOBUXDUWHUWQUWOUWCWLUVMUVPBUWSWMUXCUWOBNCUU
      TDWNUVBUXBUWOABUUIUUTUWNLWOEWQWRWSUWTUXFUUPUWNUEZWEZUWHUWRUWCUXIUWHUWRNZU
      WCUUTUUIWTMZUXIUXJUVHUWCUXKRUWHUVHUWRUVMUVPUVHBUVMUVIUVHAUWLUVJUVHUWMUVLV
      AWJWJXAUVHUWCUXKUUIUUTXBTVCUXJUXHUUIUUTXCMZUXKUXHUUPUWNXCMZUXJUXLUWNXDSUX
      HUXMRHWNUUPUWNXDXEXFUXJUXMUUIUWNXCMZUXLUWEUXMUXNRZUVMUWRUVIUXOABUVIUXMUXN
      UUIUUPUWNXGTXHXIUWOUXNUXLRUWHUWQUXNUWOUXLUWOUXNUWNUUTLMUXLUUTUWNXJUUIUWNU
      UTXKWHXLXSXMXNUXLUXKUUIUUTXOXPXQXMXRUWTUUPXTZUWNXTZUXFUXIYAUVMUXPUWEUWSUU
      PYBXHUWRUXQUWHUWCUWQUXQUWOUWNYBXAYCUXPUXQNUXHUXFUUPUWNYDYEWSYFYGUXAUWNUUN
      SZUXFNUXGUWNUUNUUPYJUXRUXEUXFUUMUXDFUWNPFHUFZUULUXCCUXSUUKUXBAUUJUWNUUILU
      QURUSUTYHYIVAUUQUWNVBVCYKYLYMYNYOYPTYNYQYRUWDUVBRUWFDCYSYTUUAYMUUBYNUUCUU
      DUUETUUFUUGVKVEUUH $.
  $}

  ${
    $d z A $.  $d x y z S $.
    $( Any number greater than an infimum is greater than some element of the
       set.  (Contributed by Jeff Hankins, 29-Sep-2013.) $)
    gtinf $p |- ( ( ( S C_ RR /\ S =/= (/) /\ E. x e. RR A. y e. S x <_ y ) /\
    ( A e. RR /\ sup ( S , RR , `' < ) < A ) ) -> E. z e. S z < A ) $=
      ( cr cv wbr wral wrex wcel clt wa cvv wb wor brcnvg mpan2 vex brcnv cnvso
      wss c0 wne cle w3a ccnv csup simprl ltso mpbi supex biimpar adantl a1i wn
      wi infm3 notbii ralbii rexbii imbi12i anbi12i sylibr adantr suplub mp2and
      rexbidv ad2antrl mpbid ) EFUBEUCUDAGZBGZUEHBEIAFJUFZDFKZEFLUGZUHZDLHZMZMZ
      DCGZVOHZCEJZVTDLHZCEJZVSVNDVPVOHZWBVMVNVQUIVRWEVMVNWEVQVNVPNKWEVQOFEVOFLP
      FVOPZUJFLUAUKZULDVPFNLQRUMUNVSABCFEDVOWFVSWGUOVMVKVLVOHZUPZBEIZVLVKVOHZVL
      VTVOHZCEJZUQZBFIZMZAFJZVRVMVLVKLHZUPZBEIZVKVLLHZVTVLLHZCEJZUQZBFIZMZAFJWQ
      ABCEURWPXFAFWJWTWOXEWIWSBEWHWRVKVLLASZBSZTUSUTWNXDBFWKXAWMXCVLVKLXHXGTWLX
      BCEVLVTLXHCSZTVAVBUTVCVAVDVEVFVGVNWBWDOVMVQVNWAWCCEVNVTNKWAWCOXIDVTFNLQRV
      HVIVJ $.
  $}

  ${
    $d x y A $.
    $( A set is open in the standard topology of the reals precisely when every
       point can be enclosed in an open ball.  (Contributed by Jeff Hankins,
       23-Sep-2013.)  (Proof shortened by Mario Carneiro, 30-Jan-2014.) $)
    opnrebl $p |- ( A e. ( topGen ` ran (,) ) <-> ( A C_ RR /\ A. x e. A E. y
    e. RR+ ( ( x - y ) (,) ( x + y ) ) C_ A ) ) $=
      ( cioo crn ctg cfv wcel cr wss cv cabs cmin co crp wrex wral wa wb eqid
      ccom cxp cres caddc cxmt rexmet cmopn tgioo elmopn2 ax-mp ssel2 wceq rpre
      cbl bl2ioo sylan2 sseq1d rexbidva syl ralbidva pm5.32i bitri ) CDEFGZHZCI
      JZAKZBKZLMUAIIUBUCZUNGNZCJZBOPZACQZRZVEVFVGMNVFVGUDNDNZCJZBOPZACQZRVHIUEG
      HVDVMSVHVHTZUFABCVHVCIVHVHUGGZVRVSTUHUIUJVEVLVQVEVKVPACVEVFCHRVFIHZVKVPSC
      IVFUKVTVJVOBOVTVGOHZRVIVNCWAVTVGIHVIVNULVGUMVFVGVHVRUOUPUQURUSUTVAVB $.
  $}

  ${
    $d t w x y z A $.
    $( A set is open in the standard topology of the reals precisely when every
       point can be enclosed in an arbitrarily small ball.  (Contributed by
       Jeff Hankins, 22-Sep-2013.)  (Proof shortened by Mario Carneiro,
       30-Jan-2014.) $)
    opnrebl2 $p |- ( A e. ( topGen ` ran (,) ) <-> ( A C_ RR /\ A. x e. A A. y
    e. RR+ E. z e. RR+ ( z <_ y /\ ( ( x - z ) (,) ( x + z ) ) C_ A ) ) ) $=
      ( cioo cfv wcel cr wss cv wbr cmin co wa crp wrex wral eqid wi c1 crn ctg
      cle caddc cabs ccom cxp cres cxmt rexmet cmopn mopnss mpan clt cbl mopni3
      tgioo w3a ex mp3an1 sselda wceq rpre bl2ioo sylan2 sseq1d anbi2d rexbidva
      biimpd ltle syl2anr anim1d reximdva syl9 syl mpdd expimpd ralrimivv ssel2
      jca 1rp simpr reximi biidd rspcv mpsyl syl5ibr ralimdva imdistani elmopn2
      ralimi wb ax-mp sylibr impbii ) DEUAUBFZGZDHIZCJZBJZUCKZAJZWSLMXBWSUDMEMZ
      DIZNZCOPZBOQZADQZNZWQWRXHUELUFHHUGUHZHUIFGZWQWRXJXJRZUJZDXJWPHXJXJUKFZXLX
      NRUQZULUMZWQXFABDOWQXBDGZWTOGZXFWQXQNZXRWSWTUNKZXBWSXJUOFMZDIZNZCOPZXFXKW
      QXQXRYDSXMXKWQXQURXRYDCDXJXBWTWPHXOUPUSUTXSXBHGZXRYDXFSSWQDHXBXPVAYEYDXTX
      DNZCOPZXRXFYEYDYGYEYCYFCOYEWSOGZNZYBXDXTYIYAXCDYHYEWSHGZYAXCVBWSVCZXBWSXJ
      XLVDVEVFZVGVHVIXRYFXECOXRYHNXTXAXDYHYJWTHGXTXASXRYKWTVCWSWTVJVKVLVMVNVOVP
      VQVRVTXIWRYBCOPZADQZNZWQWRXHYNWRXGYMADWRXQNYEXGYMSDHXBVSXGYMYEXDCOPZTOGXG
      YPBOQYPWAXFYPBOXEXDCOXAXDWBWCWKYPYPBTOWTTVBYPWDWEWFYEYBXDCOYLVHWGVOWHWIXK
      WQYOWLXMACDXJWPHXOWJWMWNWO $.
  $}

  ${
    $d k m n p q r t x y A $.  $d k m n p q r t x y B $.
    $( Lemma for ~ nn0prpw .  Use strong induction to show that every natural
       number has unique prime power divisors.  (Contributed by Jeff Hankins,
       28-Sep-2013.) $)
    nn0prpwlem $p |- ( A e. NN -> A. k e. NN ( k < A -> E. p e. Prime E. n e.
    NN -. ( ( p ^ n ) || k <-> ( p ^ n ) || A ) ) ) $=
      ( clt wbr cexp co cdivides wb wn cn wrex cprime wi notbid c1 wcel breq1d
      wa vx vy vq vt vr vm cv wral breq2 bibi2d 2rexbidv imbi12d ralbidv nnnlt1
      wceq weq pm2.21d c2 w3a cdiv cz cc0 prmz adantr nnz adantl syl3anc biimpd
      dvdsval2 3ad2antl2 adantrl simprr cr nngt0 jca syl divgt0 syl2anr adantrr
      nnre elnnz expr cle eluz1i zre 2re ltletr mp3an12 mpani sylbi breq1 rspcv
      2z imp 3ad2ant1 ad2antrr 1re ad2antlr a1i syl112anc mpbid bibi1d 3ad2ant2
      cmul 3ad2ant3 biimpa ad2antrl ad4antlr zexpcl ad3antlr dvdsmulcr divcan1d
      syl2anc cc breq12d bitr3d ad4antr bibi12d impr oveq2 rspcev oveq1 rexbidv
      anbi2d dvdsmultr2 cgcd simp-4r syl6bb mpan2d impbid divcan2d breq2d bitrd
      coprmdvds ex com23 pm2.61d embantd syld biimpar rgen cuz cfv exprmfct wne
      prmnn nnne0d sylanbrc eluzelz eluzelre 2pos 0re a1d syl6ibr sylbid ancoms
      ancld recnd mulid2d prmuz2 ltmul1 eqbrtrrd ltdivmul mpbird ltdiv1 simprll
      1lt2 nnred caddc peano2nn nnnn0 ad2antll nncnd expp1d eqcomd mpbiri com12
      simplr gcdcom simprl prmdvdsexpb equcom con3d coprm eqtrd exp32 rexlimdvv
      cn0 nncn 3exp2 3impia com24 imp32 3syld simpl2 1nn exp1d 3adant1 idd mpid
      mtod bi2 rspc2ev exp3a ralrimiv cbvrex2v cbvralv sylib 3exp1 rexlimdv mpd
      nsyl indstr2 vtoclga ) BUGZUAUGZEFZDUGZCUGZGHZUXOIFZUXTUXPIFZJZKZCLMDNMZO
      ZBLUHZUXOAEFZUYAUXTAIFZJZKZCLMDNMZOZBLUHUAALUXPAUOZUYFUYMBLUYNUXQUYHUYEUY
      LUXPAUXOEUIUYNUYDUYKDCNLUYNUYCUYJUYNUYBUYIUYAUXPAUXTIUIUJPUKULUMUYGUXOUBU
      GZEFZUYAUXTUYOIFZJZKZCLMDNMZOZBLUHZUXOQEFZUYAUXTQIFZJZKZCLMDNMZOZBLUHUAUB
      UXPQUOZUYFVUHBLVUIUXQVUCUYEVUGUXPQUXOEUIVUIUYDVUFDCNLVUIUYCVUEVUIUYBVUDUY
      AUXPQUXTIUIUJPUKULUMUAUBUPZUYFVUABLVUJUXQUYPUYEUYTUXPUYOUXOEUIVUJUYDUYSDC
      NLVUJUYCUYRVUJUYBUYQUYAUXPUYOUXTIUIUJPUKULUMVUHBLUXOLRVUCVUGUXOUNUQUUAUXP
      URUUBUUCZRZUCUGZUXPIFZUCNMUYOUXPEFZVUBOZUBLUHZUYGOZUXPUCUUDVULVUNVURUCNVU
      LVUMNRZVUNVUQUYGVULVUSVUNUSZVUQTZUDUGZUXPEFZUEUGZUFUGZGHZVVBIFZVVFUXPIFZJ
      ZKZUFLMZUENMZOZUDLUHUYGVVAVVMUDLVUTVUQVVBLRZVVMVUTVUQVVNTTZVUMVVBIFZVVMVV
      OVVPVVBVUMUTHZVARZVVQLRZVVMVUTVVNVVPVVROZVUQVUSVULVVNVVTVUNVUSVVNTZVVPVVR
      VWAVUMVARZVUMVBUUEZVVBVARZVVPVVRJVUSVWBVVNVUMVCZVDVUSVWCVVNVUSVUMVUMUUFZU
      UGZVDVVNVWDVUSVVBVEVFVUMVVBVIVGVHVJVKVUTVVNVVRVVSOVUQVUTVVNVVRVVSVUTVVNVV
      RTTVVRVBVVQEFZVVSVUTVVNVVRVLVUTVVNVWHVVRVUSVULVVNVWHVUNVVNVVBVMRZVBVVBEFZ
      TVUMVMRZVBVUMEFZTZVWHVUSVVNVWIVWJVVBVTZVVBVNVOVUSVUMLRZVWMVWFVWOVWKVWLVUM
      VTVUMVNZVOVPZVVBVUMVQVRVJVSVVQWAUUHWBVKVUTVUQVVNVVSVVMOVUTVVSVVNVUQVVMVUL
      VUSVUNVVSVVNVUQVVMOZOOZVULVUSTZVUNUXPVUMUTHZLRZVWSVUSVULVUNVXBOVUSVULTZVU
      NVXAVARZVXBVXCVWBVWCUXPVARZVUNVXDJVUSVWBVULVWEVDVUSVWCVULVWGVDVULVXEVUSUR
      UXPUUIVFVUMUXPVIVGVXCVXDVXDVBVXAEFZTVXBVXCVXDVXFVXCVXFVXDVULUXPVMRZVBUXPE
      FZTVWMVXFVUSVULVXGVXHURUXPUUJZVULVXEURUXPWCFZTVXHURUXPWMWDVXEVXJVXHVXEVBU
      REFZVXJVXHUUKVXEVXGVXKVXJTVXHOZUXPWEVBVMRURVMRZVXGVXLUULWFVBURUXPWGWHVPWI
      WNWJZVOVWQUXPVUMVQVRUUMUUQVXAWAUUNUUOUUPVWTVXBVVSVVNVWRVWTVXBVVSVVNUSZTZV
      UQVXAUXPEFZUXOVXAEFZUYAUXTVXAIFZJZKZCLMDNMZOZBLUHZOZVVMVXOVUQVYEOZVWTVXBV
      VSVYFVVNVUPVYEUBVXALUYOVXAUOZVUOVXQVUBVYDUYOVXAUXPEWKVYGVUAVYCBLVYGUYPVXR
      UYTVYBUYOVXAUXOEUIVYGUYSVYADCNLVYGUYRVXTVYGUYQVXSUYAUYOVXAUXTIUIUJPUKULUM
      ULWLWOVFVXPVXQVYDVVMVXPVXQUXPVUMUXPXDHZEFZVXPQUXPXDHZUXPVYHEVULVYJUXPUOVU
      SVXOVULUXPVULUXPVXIUURZUUSWPVXPQVUMEFZVYJVYHEFZVUSVYLVULVXOVUSVUMVUKRZVYL
      VUMUUTVYNVWBURVUMWCFZTVYLURVUMWMWDVWBVYOVYLVWBQUREFZVYOVYLUVGVWBVWKVYPVYO
      TVYLOZVUMWEQVMRZVXMVWKVYQWQWFQURVUMWGWHVPWIWNWJVPWRVXPVYRVWKVXGVXHVYLVYMJ
      VYRVXPWQWSVUSVWKVULVXOVUSVUMVWFUVHWRZVULVXGVUSVXOVXIWPZVULVXHVUSVXOVXNWPQ
      VUMUXPUVAWTXAUVBVXPVXGVXGVWKVWLVXQVYIJVYTVYTVYSVUSVWLVULVXOVUSVWOVWLVWFVW
      PVPWRZUXPUXPVUMUVCWTUVDVXPVYDVVQVXAEFZUXTVVQIFZVXSJZKZCLMDNMZOZVVMVXOVYDW
      UGOZVWTVVSVXBWUHVVNVYCWUGBVVQLUXOVVQUOZVXRWUBVYBWUFUXOVVQVXAEWKWUIVYAWUED
      CNLWUIVXTWUDWUIUYAWUCVXSUXOVVQUXTIUIXBPUKULWLXCVFVXPVVCWUGVVLVXPVVCWUGVVL
      OVXPVVCTZWUBWUFVVLVXPVVCWUBVXPVWIVXGVWKVWLVVCWUBJVXOVWIVWTVVNVXBVWIVVSVWN
      XEVFVYTVYSWUAVVBUXPVUMUVEWTXFWUJWUEVVLDCNLWUJUXRNRZUXSLRZTZWUEVVLWUJWUMWU
      ETZTZWUKUXRVVEGHZVVBIFZWUPUXPIFZJZKZUFLMZVVLWUJWUKWULWUEUVFWUODUCUPZWVAWV
      BWUOWVAWVBWUOWVAOWUJWUMVUMUXSGHZVVQIFZWVCVXAIFZJZKZTZTZVUMVVEGHZVVBIFZWVJ
      UXPIFZJZKZUFLMZOWVIUXSQUVIHZLRZVUMWVPGHZVVBIFZWVRUXPIFZJZKZWVOWUMWVQWUJWV
      GWULWVQWUKUXSUVJVFXGWUJWUMWVGWWBWUJWUMTZWVGWWBWWCWVFWWAWWCWVDWVSWVEWVTWWC
      WVCVUMXDHZVVQVUMXDHZIFZWVDWVSWWCWVCVARZVVRVWBVWCWWFWVDJWWCVWBUXSUWHRZWWGV
      USVWBVULVXOVVCWUMVWEXHZWULWWHWUJWUKUXSUVKZUVLZVUMUXSXIXMZVXOVVRVWTVVCWUMV
      VSVXBVVRVVNVVQVEXCZXJWWIVUSVWCVULVXOVVCWUMVWGXHZVUMWVCVVQXKWTWWCWWDWVRWWE
      VVBIWWCWVRWWDWWCVUMUXSVUSVUMXNRZVULVXOVVCWUMVUSVUMVWFUVMZXHZWWKUVNUVOZWWC
      VVBVUMVXOVVBXNRZVWTVVCWUMVVNVXBWWSVVSVVBUWIXEZXJWWQWWNXLXOXPWWCWWDVXAVUMX
      DHZIFZWVEWVTWWCWWGVXDVWBVWCWXBWVEJWWLVXOVXDVWTVVCWUMVXBVVSVXDVVNVXAVEWOZX
      JWWIWWNVUMWVCVXAXKWTWWCWWDWVRWXAUXPIWWRWWCUXPVUMVULUXPXNRZVUSVXOVVCWUMVYK
      XQWWQWWNXLXOXPXRPVHXSWVNWWBUFWVPLVVEWVPUOZWVMWWAWXEWVKWVSWVLWVTWXEWVJWVRV
      VBIVVEWVPVUMGXTZSWXEWVJWVRUXPIWXFSXRPYAXMWVBWUOWVIWVAWVOWVBWUNWVHWUJWVBWU
      EWVGWUMWVBWUDWVFWVBWUCWVDVXSWVEWVBUXTWVCVVQIUXRVUMUXSGYBZSWVBUXTWVCVXAIWX
      GSXRPYDYDWVBWUTWVNUFLWVBWUSWVMWVBWUQWVKWURWVLWVBWUPWVJVVBIUXRVUMVVEGYBZSW
      VBWUPWVJUXPIWXHSXRPYCULUVPUVQWUJWUMWUEWVBKZWVAOWWCWXIWUEWVAWUJWUMWXIWUEWV
      AOWUJWUMWXITZTZWUEWVAWXKWUETWULUXTVVBIFZUYBJZKZWVAWXJWULWUJWUEWUKWULWXIUV
      RWRWXKWUEWXNWXKWUDWXMWXKWUCWXLVXSUYBWXKWUCUXTVUMVVQXDHZIFZWXLWXKWUCWXPWXK
      UXTVARZVWBVVRWUCWXPOWXKUXRVARZWWHWXQWUMWXRWUJWXIWUKWXRWULUXRVCVDXGWUMWWHW
      UJWXIWULWWHWUKWWJVFXGUXRUXSXIXMZVUSVWBVULVXOVVCWXJVWEXHZVXOVVRVWTVVCWXJWW
      MXJZUXTVUMVVQYEVGWXKWXPUXTVUMYFHZQUOZWUCWXKWYBVUMUXTYFHZQWXKWXQVWBWYBWYDU
      OWXSWXTUXTVUMUVSXMWXKVUMUXTIFZKZWYDQUOZWUJWUMWXIWYFWWCWYEWVBWWCVUSWUKWULW
      YEWVBOVULVUSVXOVVCWUMYGWUJWUKWULUVTWUJWUKWULVLVUSWUKWULUSZWYEWVBWYHWYEUCD
      UPWVBVUMUXRUXSUWAUCDUWBYHVHVGUWCXSWXKVUSWXQWYFWYGJVULVUSVXOVVCWXJYGWXSVUM
      UXTUWDXMXAUWEZWXKWXQVWBVVRWXPWYCTWUCOWXSWXTWYAUXTVUMVVQYNVGYIYJWXKWXOVVBU
      XTIWXKVVBVUMVXOWWSVWTVVCWXJWWTXJVUSWWOVULVXOVVCWXJWWPXHZVUSVWCVULVXOVVCWX
      JVWGXHZYKYLYMWXKVXSUXTVUMVXAXDHZIFZUYBWXKVXSWYMWXKWXQVWBVXDVXSWYMOWXSWXTV
      XOVXDVWTVVCWXJWXCXJZUXTVUMVXAYEVGWXKWYMWYCVXSWYIWXKWXQVWBVXDWYMWYCTVXSOWX
      SWXTWYNUXTVUMVXAYNVGYIYJWXKWYLUXPUXTIWXKUXPVUMVULWXDVUSVXOVVCWXJVYKXQWYJW
      YKYKYLYMXRPXFWUTWXNUFUXSLUFCUPZWUSWXMWYOWUQWXLWURUYBWYOWUPUXTVVBIVVEUXSUX
      RGXTZSWYOWUPUXTUXPIWYPSZXRPYAXMYOWBYPXSYQVVKWVAUEUXRNUEDUPZVVJWUTUFLWYRVV
      IWUSWYRVVGWUQVVHWURWYRVVFWUPVVBIVVDUXRVVEGYBZSWYRVVFWUPUXPIWYSSZXRPYCYAXM
      UWFUWGYRYOYPYSYRYSUWJYSUWKUWLUWMUWNVUTVVNVVPKZVVMOVUQVUTVVNTXUAVVCVVLVUTV
      VNXUAVVCTZVVLVUTVVNXUBTZTZVUSQLRZVUMQGHZVVBIFZXUFUXPIFZJZKZVVLVULVUSVUNXU
      CUWOXUEXUDUWPWSXUDXUHXUGOZXUIXUDXUKXUGVUTXUBXUGKZVVNVUTXUAXULVVCVUSVULXUA
      XULVUNVUSXULXUAVUSXUGVVPVUSXUFVUMVVBIVUSVUMWWPUWQZSPYTVJVSVKVUTXUKXUGOXUC
      VUTXUKXUHXUGVUSVUNXUHVULVUSXUHVUNVUSXUFVUMUXPIXUMSYTUWRVUTXUKUWSUWTVDUXAX
      UGXUHUXBUXLVVJXUJWVNUEUFVUMQNLUEUCUPZVVIWVMXUNVVGWVKVVHWVLXUNVVFWVJVVBIVV
      DVUMVVEGYBZSXUNVVFWVJUXPIXUOSXRPVVEQUOZWVMXUIXUPWVKXUGWVLXUHXUPWVJXUFVVBI
      VVEQVUMGXTZSXUPWVJXUFUXPIXUQSXRPUXCVGWBUXDVKYQWBUXEVVMUYFUDBLUDBUPZVVCUXQ
      VVLUYEVVBUXOUXPEWKXURVVLVVFUXOIFZVVHJZKZUFLMUENMUYEXURVVJXVAUEUFNLXURVVIX
      UTXURVVGXUSVVHVVBUXOVVFIUIXBPUKXVAUYDWUPUXOIFZWURJZKUEUFDCNLWYRXUTXVCWYRX
      USXVBVVHWURWYRVVFWUPUXOIWYSSWYTXRPWYOXVCUYCWYOXVBUYAWURUYBWYOWUPUXTUXOIWY
      PSWYQXRPUXFYHULUXGUXHUXIUXJUXKUXMUXN $.

    $( Two nonnegative integers are the same if and only if they are divisible
       by the same prime powers.  (Contributed by Jeff Hankins,
       29-Sep-2013.) $)
    nn0prpw $p |- ( ( A e. NN0 /\ B e. NN0 ) -> ( A = B <-> A. p e. Prime A. n
    e. NN ( ( p ^ n ) || A <-> ( p ^ n ) || B ) ) ) $=
      ( vk wcel wa wceq cdivides wbr wb cn wral cprime cc0 wi wn wrex clt c1 cv
      cn0 cexp co breq2 a1d ralrimivv wo elnn0 wne cr nnre lttri2 syl2an ancoms
      nn0prpwlem breq1 bibi1d notbid 2rexbidv imbi12d rspcv mpan9 bicom syl5com
      syl6bb impcom jaod sylbid df-ne rexnal rexbii bitri 3imtr3g ex prmunb w3a
      con4d 1nn cle cz prmz zexpcl sylancl dvdsle sylan prmnn syl reexpcl lenlt
      1nn0 nncnd exp1d adantr breq2d bitrd sylibd con2d dvds0 3ad2ant2 idd mpid
      3impia mtod bi2 oveq2 breq1d bibi12d rspcev sylancr 3expia reximdva sylib
      nsyl mpd pm2.21d bibi2d 2ralbidv eqeq2 syl5ibr jaoi sylbi com12 orcom bi1
      df-or imim2i eqcom syl6ib eqeq1 imp sylanb impbid2 ) AUBFZBUBFZGABHZDUAZC
      UAZUCUDZAIJZYSBIJZKZCLMZDNMZYPUUBDCNLYPUUBYQNFZYRLFGABYSIUEUFUGYNALFZAOHZ
      UHZYOUUDYPPZAUIUUHYOUUIUUFYOUUIPUUGYOUUFUUIYOBLFZBOHZUHZUUFUUIPZBUIZUUJUU
      MUUKUUJUUFUUIUUJUUFGZYPUUDUUOABUJZUUBQZCLRZDNRZYPQUUDQZUUOUUPABSJZBASJZUH
      ZUUSUUFUUJUUPUVCKZUUFAUKFZBUKFZUVDUUJAULZBULZABUMUNUOUUOUVAUUSUVBUUJEUAZB
      SJZYSUVIIJZUUAKZQZCLRDNRZPZELMUUFUVAUUSPZBECDUPUVOUVPEALUVIAHZUVJUVAUVNUU
      SUVIABSUQUVQUVMUUQDCNLUVQUVLUUBUVQUVKYTUUAUVIAYSIUEURUSUTVAVBVCUUFUUJUVBU
      USPZUUFUVIASJZUVKYTKZQZCLRDNRZPZELMUUJUVRAECDUPUWCUVREBLUVIBHZUVSUVBUWBUU
      SUVIBASUQUWDUWAUUQDCNLUWDUVTUUBUWDUVTUUAYTKUUBUWDUVKUUAYTUVIBYSIUEURUUAYT
      VDVFUSUTVAVBVEVGVHVIABVJUUSUUCQZDNRUUTUURUWEDNUUBCLVKVLUUCDNVKVMVNVRVOUUF
      UUIUUKYTYSOIJZKZCLMZDNMZUUGPUUFUWIUUGUUFUWGQZCLRZDNRZUWIQZUUFAYQSJZDNRUWL
      ADVPUUFUWNUWKDNUUFUUEUWNUWKUUFUUEUWNVQZTLFZYQTUCUDZAIJZUWQOIJZKZQZUWKVSUW
      OUWSUWRPZUWTUWOUXBUWRUUFUUEUWNUWRQUUFUUEGUWRUWNUUEUUFUWRUWNQZPUUEUUFGZUWR
      UWQAVTJZUXCUUEUWQWAFZUUFUWRUXEPUUEYQWAFTUBFZUXFYQWBWKYQTWCWDZUWQAWEWFUXDU
      XEAUWQSJZQZUXCUUEUWQUKFZUVEUXEUXJKUUFUUEYQUKFZUXGUXKUUEYQLFUXLYQWGZYQULWH
      WKYQTWIWDZUVGUWQAWJUNUXDUXIUWNUXDUWQYQASUUEUWQYQHZUUFUUEYQUUEYQUXMWLWMZWN
      WOUSWPWQUOWRXCUWOUXBUWSUWRUUEUUFUWSUWNUUEUXFUWSUXHUWQWSWHZWTUWOUXBXAXBXDU
      WRUWSXEXNUWJUXACTLYRTHZUWGUWTUXRYTUWRUWFUWSUXRYSUWQAIYRTYQUCXFZXGUXRYSUWQ
      OIUXSXGZXHUSXIXJXKXLXOUWLUWHQZDNRUWMUWKUYADNUWGCLVKVLUWHDNVKVMXMXPUUKUUDU
      WIYPUUGUUKUUBUWGDCNLUUKUUAUWFYTBOYSIUEXQXRBOAXSVAXTYAYBYCYOUUIUUGUWFUUAKZ
      CLMZDNMZOBHZPYOUYDUUKUYEYOUUKUYDYOUUKQZUUJPZUYFUYDQZPYOUULUYGUUNUULUUKUUJ
      UHUYGUUJUUKYDUUKUUJYFVMVMUUJUYHUYFUUJUYBQZCLRZDNRZUYHUUJBYQSJZDNRUYKBDVPU
      UJUYLUYJDNUUJUUEUYLUYJUUJUUEUYLVQZUWPUWSUWQBIJZKZQZUYJVSUYMUWSUYNPZUYOUYM
      UYQUYNUUJUUEUYLUYNQUUJUUEGUYNUYLUUEUUJUYNUYLQZPUUEUUJGZUYNUWQBVTJZUYRUUEU
      XFUUJUYNUYTPUXHUWQBWEWFUYSUYTBUWQSJZQZUYRUUEUXKUVFUYTVUBKUUJUXNUVHUWQBWJU
      NUYSVUAUYLUYSUWQYQBSUUEUXOUUJUXPWNWOUSWPWQUOWRXCUYMUYQUWSUYNUUEUUJUWSUYLU
      XQWTUYMUYQXAXBXDUWSUYNYEXNUYIUYPCTLUXRUYBUYOUXRUWFUWSUUAUYNUXTUXRYSUWQBIU
      XSXGXHUSXIXJXKXLXOUYKUYCQZDNRUYHUYJVUCDNUYBCLVKVLUYCDNVKVMXMYGYBVRBOYHYIU
      UGUUDUYDYPUYEUUGUUBUYBDCNLUUGYTUWFUUAAOYSIUEURXRAOBYJVAXTYAYKYLYM $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Basic topological facts
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    topbnd.1 $e |- X = U. J $.
    $( Two equivalent expressions for the boundary of a topology.  (Contributed
       by Jeff Hankins, 23-Sep-2009.) $)
    topbnd $p |- ( ( J e. Top /\ A C_ X ) -> ( ( ( cls ` J ) ` A ) i^i ( ( cls
    ` J ) ` ( X \ A ) ) ) = ( ( ( cls ` J ) ` A ) \ ( ( int ` J ) ` A ) ) ) $=
      ( ctop wcel wss wa ccl cfv cdif cin cnt clsdif ineq2d indif2 syl6eq df-ss
      wceq clsss3 sylib difeq1d eqtrd ) BEFACGHZABIJZJZCAKUEJZLZUFCLZABMJJZKZUF
      UJKUDUHUFCUJKZLUKUDUGULUFABCDNOUFCUJPQUDUIUFUJUDUFCGUIUFSABCDTUFCRUAUBUC
      $.
  $}

  ${
    opnbnd.1 $e |- X = U. J $.
    $( A set is open iff it is disjoint from its boundary.  (Contributed by
       Jeff Hankins, 23-Sep-2009.) $)
    opnbnd $p |- ( ( J e. Top /\ A C_ X ) -> ( A e. J <-> ( A i^i ( ( ( cls ` J
    ) ` A ) i^i ( ( cls ` J ) ` ( X \ A ) ) ) ) = (/) ) ) $=
      ( ctop wcel wss wa cnt cfv wceq ccl cdif cin disjdif a1i eqeq1d syl5ibcom
      c0 ineq1 ntrss2 adantr inssdif0 sscls df-ss sylib eqcomd eqimss syl sylan
      sstr sylan2br eqssd ex impbid isopn3 topbnd ineq2d 3bitr4d ) BEFACGHZABIJ
      JZAKZAABLJZJZVAMZNZSKZABFAVDCAMVCJNZNZSKUTVBVGUTVAVENZSKZVBVGVKUTVAVDOPVB
      VJVFSVAAVETQRUTVGVBUTVGHVAAUTVAAGVGABCDUAUBVGUTAVDNZVAGZAVAGZAVDVAUCUTAVL
      GZVMVNUTAVLKVOUTVLAUTAVDGVLAKABCDUDAVDUEUFUGAVLUHUIAVLVAUKUJULUMUNUOABCDU
      PUTVIVFSUTVHVEAABCDUQURQUS $.

    $( A set is closed iff it contains its boundary.  (Contributed by Jeff
       Hankins, 1-Oct-2009.) $)
    cldbnd $p |- ( ( J e. Top /\ A C_ X ) -> ( A e. ( Clsd ` J ) <-> ( ( ( cls
    ` J ) ` A ) i^i ( ( cls ` J ) ` ( X \ A ) ) ) C_ A ) ) $=
      ( ctop wcel wss wa cfv cdif cin c0 adantl incom ex sylbi ineq2d wb adantr
      wceq ccld ccl iscld3 eqimss syl6bi ssinss1 syl6 sslin disjdif eqtri sseq0
      sylancl dfss4 fveq2 eqcomd syl5eq eqeq1d difss opnbnd mpan2 bitr4d opncld
      wi eleq1 sylibd sylbid syld impbid ) BEFZACGZHZABUAIZFZABUBIZIZCAJZVNIZKZ
      AGZVKVMVOAGZVSVKVMVOATVTABCDUCVOAUDUEVOVQAUFUGVKVSVPVRKZLTZVMVKVSWBVKVSHW
      AVPAKZGZWCLTWBVSWDVKVRAVPUHMWCAVPKLVPANACUIUJWAWCUKULOVKWBVPBFZVMVKWBVPVQ
      CVPJZVNIZKZKZLTZWEVKWAWILVKVRWHVPVKVRVQVOKWHVOVQNVKVOWGVQVJVOWGTZVIVJWFAT
      ZWKACUMZWLWGVOWFAVNUNUOPMQUPQUQVIWEWJRZVJVIVPCGWNCAURVPBCDUSUTSVAVKWEWFVL
      FZVMVIWEWOVCVJVIWEWOVPBCDVBOSVJWOVMRZVIVJWLWPWMWFAVLVDPMVEVFVGVH $.
  $}

  ${
    $d o J $.  $d o O $.  $d o X $.
    ntruni.1 $e |- X = U. J $.
    $( A union of interiors is a subset of the interior of the union.  The
       reverse inclusion may not hold.  (Contributed by Jeff Hankins,
       31-Aug-2009.) $)
    ntruni $p |- ( ( J e. Top /\ O C_ ~P X ) -> U_ o e. O ( ( int ` J ) ` o
    ) C_ ( ( int ` J ) ` U. O ) ) $=
      ( ctop wcel cpw wss wa cv cnt cfv cuni wral ciun elssuni wi sspwuni ntrss
      3expia sylan2b syl5 ralrimiv iunss sylibr ) BFGZCDHIZJZAKZBLMZMZCNZUKMZIZ
      ACOACULPUNIUIUOACUJCGUJUMIZUIUOUJCQUHUGUMDIZUPUORCDSUGUQUPUOUMUJBDETUAUBU
      CUDACULUNUEUF $.
  $}

  ${
    clsun.1 $e |- X = U. J $.
    $( A pairwise union of closures is the closure of the union.  (Contributed
       by Jeff Hankins, 31-Aug-2009.) $)
    clsun $p |- ( ( J e. Top /\ A C_ X /\ B C_ X ) -> ( ( cls ` J ) ` ( A u. B
    ) ) = ( ( ( cls ` J ) ` A ) u. ( ( cls ` J ) ` B ) ) ) $=
      ( wcel wss cun cfv cdif difundi wceq difss wa unss ntrdif syl2anc 3adant3
      cin 3adant2 w3a ccl cnt fveq2i ntrin mp3an23 3ad2ant1 syl5eq simp1 biimpi
      ctop 3adant1 ineq12d syl6eqr 3eqtr3d difeq2d clscld cldss syl dfss4 sylib
      ccld clsss3 jca bitri ) CUKFZADGZBDGZUAZDDABHZCUBIZIZJZJZDDAVKIZBVKIZHZJZ
      JZVLVQVIVMVRDVIDVJJZCUCIZIZDAJZWAIZDBJZWAIZSZVMVRVIWBWCWESZWAIZWGVTWHWADA
      BKUDVFVGWIWGLZVHVFWCDGWEDGWJDAMDBMWCWECDEUEUFUGUHVIVFVJDGZWBVMLVFVGVHUIZV
      GVHWKVFVGVHNWKABDOUJULZVJCDEPQVIWGDVOJZDVPJZSVRVIWDWNWFWOVFVGWDWNLVHACDEP
      RVFVHWFWOLVGBCDEPTUMDVOVPKUNUOUPVIVLDGZVNVLLVIVLCVBIFZWPVIVFWKWQWLWMVJCDE
      UQQVLCDEURUSVLDUTVAVIVODGZVPDGZNZVSVQLZVIWRWSVFVGWRVHACDEVCRVFVHWSVGBCDEV
      CTVDWTVQDGXAVOVPDOVQDUTVEVAUO $.
  $}

  ${
    $d c C $.  $d c J $.  $d c X $.
    clsint2.1 $e |- X = U. J $.
    $( The closure of an intersection is a subset of the intersection of the
       closures.  (Contributed by Jeff Hankins, 31-Aug-2009.) $)
    clsint2 $p |- ( ( J e. Top /\ C C_ ~P X ) -> ( ( cls ` J ) ` |^| C ) C_
    |^|_ c e. C ( ( cls ` J ) ` c ) ) $=
      ( ctop wcel cpw wss wa cint ccl cfv cv wral ciin cuni wi sspwuni elssuni
      sstr2 syl adantl intss1 clsss syl3an3 3com23 3expia syld impancom sylan2b
      ralrimiv ssiin sylibr ) BFGZACHIZJZAKZBLMZMZDNZUSMZIZDAOUTDAVBPIUQVCDAUPU
      OAQZCIZVAAGZVCRACSUOVFVEVCUOVFJVEVACIZVCVFVEVGRZUOVFVAVDIVHVAATVAVDCUAUBU
      CUOVFVGVCUOVGVFVCVFUOVGURVAIVCVAAUDVAURBCEUEUFUGUHUIUJUKULDAVBUTUMUN $.
  $}

  ${
    $d c o A $.  $d c o J $.  $d c o X $.
    opnregcld.1 $e |- X = U. J $.
    $( A set is regularly closed iff it is the closure of some open set.
       (Contributed by Jeff Hankins, 27-Sep-2009.) $)
    opnregcld $p |- ( ( J e. Top /\ A C_ X ) -> ( ( ( cls ` J ) ` ( ( int ` J )
    ` A ) ) = A <-> E. o e. J A = ( ( cls ` J ) ` o ) ) ) $=
      ( ctop wcel wss wa cnt cfv wceq cv wrex ntropn fveq2 syldan clsss syl3anc
      ccl eqcom biimpi eqeq2d rspcev syl2an simpl eltopss clsss3 ntrss2 sseqtrd
      clsidm ntrss3 simpr sscls ssntr syl22anc eqssd adantlr eqeq12d syl5ibrcom
      ex fveq2d id rexlimdva impbid ) CFGZADHZIZACJKZKZCTKZKZALZABMZVKKZLZBCNZV
      HVMVQVHVJCGAVLLZVQVMACDEOVMVRVLAUAUBVPVRBVJCVNVJLVOVLAVNVJVKPUCUDUEVAVHVP
      VMBCVHVNCGZIVMVPVOVIKZVKKZVOLZVFVSWBVGVFVSIZWAVOWCWAVOVKKZVOWCVFVODHZVTVO
      HZWAWDHVFVSUFZVFVSVNDHZWEVNCDEUGZVNCDEUHQZVFVSWEWFWJVOCDEUIQVOVTCDERSVFVS
      WHWDVOLWIVNCDEUKQUJWCVFVTDHZVNVTHZVOWAHWGVFVSWEWKWJVOCDEULQWCVFWEVSVNVOHZ
      WLWGWJVFVSUMVFVSWHWMWIVNCDEUNQVOCVNDEUOUPVTVNCDERSUQURVPVLWAAVOVPVJVTVKAV
      OVIPVBVPVCUSUTVDVE $.

    $( A set if regularly open iff it is the interior of some closed set.
       (Contributed by Jeff Hankins, 27-Sep-2009.) $)
    cldregopn $p |- ( ( J e. Top /\ A C_ X ) -> ( ( ( int ` J ) ` ( ( cls ` J )
    ` A ) ) = A <-> E. c e. ( Clsd ` J ) A = ( ( int ` J ) ` c ) ) ) $=
      ( ctop wcel wss wa ccl cfv cnt wceq ccld wrex fveq2 syl2anc ntrss syl3anc
      cv clscld eqcom biimpi eqeq2d rspcev syl2an ex cldrcl cldss ntrss2 clsss2
      mpdan ntridm ntrss3 clsss3 sscls eqsstr3d eqssd adantl eqeq12d syl5ibrcom
      fveq2d id rexlimdva impbid ) BFGZACHIZABJKZKZBLKZKZAMZADTZVJKZMZDBNKZOZVG
      VLVQVGVIVPGAVKMZVQVLABCEUAVLVRVKAUBUCVOVRDVIVPVMVIMVNVKAVMVIVJPUDUEUFUGVG
      VOVLDVPVGVMVPGZIVLVOVNVHKZVJKZVNMZVSWBVGVSWAVNVSVFVMCHZVTVMHZWAVNHVMBUHZV
      MBCEUIZVSVNVMHZWDVSVFWCWGWEWFVMBCEUJQVMVNBCEUKULVMVTBCERSVSVNVNVJKZWAVSVF
      WCWHVNMWEWFVMBCEUMQVSVFVTCHZVNVTHZWHWAHWEVSVFVNCHZWIWEVSVFWCWKWEWFVMBCEUN
      QZVNBCEUOQVSVFWKWJWEWLVNBCEUPQVTVNBCERSUQURUSVOVKWAAVNVOVIVTVJAVNVHPVBVOV
      CUTVAVDVE $.
  $}

  $( Two neighborhoods intersect to form a neighborhood of the intersection.
     (Contributed by Jeff Hankins, 31-Aug-2009.) $)
  neiin $p |- ( ( J e. Top /\ M e. ( ( nei ` J ) ` A ) /\ N e. ( ( nei ` J ) `
  B ) ) -> ( M i^i N ) e. ( ( nei ` J ) ` ( A i^i B ) ) ) $=
    ( cfv cin wss wa simpr wb simpl neiss2 neii1 neiint syl3anc ssinss1 3adant3
    wcel syl ctop cnei w3a cnt cuni eqid mpbid inss2 3adant2 syl5ss ssind simp1
    wceq ntrin sseqtr4d mpbird ) CUASZDACUBFZFSZEBURFSZUCZDEGZABGZURFSZVCVBCUDF
    ZFZHZVAVCDVEFZEVEFZGZVFVAVCVHVIUQUSVCVHHZUTUQUSIZAVHHZVKVLUSVMUQUSJVLUQACUE
    ZHZDVNHZUSVMKUQUSLZACDVNVNUFZMZACDVNVRNZACDVNVROPUGABVHQTRVAVCBVIABUHUQUTBV
    IHZUSUQUTIZUTWAUQUTJWBUQBVNHEVNHZUTWAKUQUTLBCEVNVRMBCEVNVRNZBCEVNVROPUGUIUJ
    UKVAUQVPWCVFVJUMUQUSUTULUQUSVPUTVTRUQUTWCUSWDUIDECVNVRUNPUOUQUSVDVGKZUTVLUQ
    VCVNHZVBVNHZWEVQVLVOWFVSABVNQTVLVPWGVTDEVNQTVCCVBVNVROPRUP $.

  $( Homeomorphisms preserve closedness.  (Contributed by Jeff Hankins,
     3-Jul-2009.)  (Revised by Mario Carneiro, 3-Jun-2014.) $)
  hmeoclda $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Homeo K ) ) /\ S e. (
  Clsd ` J ) ) -> ( F " S ) e. ( Clsd ` K ) ) $=
    ( ctop wcel chmeo co w3a ccnv ccn ccld cima hmeocnvcn 3ad2ant3 wa imacnvcnv
    cfv cnclima syl5eqelr sylan ) CEFZDEFZBCDGHFZIBJZDCKHFZACLRFZBAMZDLRZFUDUBU
    FUCBCDNOUFUGPUHUEJAMUIBAQAUEDCSTUA $.

  $( Homeomorphisms preserve closedness.  (Contributed by Jeff Hankins,
     3-Jul-2009.) $)
  hmeocldb $p |- ( ( ( J e. Top /\ K e. Top /\ F e. ( J Homeo K ) ) /\ S e. (
  Clsd ` K ) ) -> ( `' F " S ) e. ( Clsd ` J ) ) $=
    ( ctop wcel chmeo w3a ccn ccld cfv ccnv cima hmeocn 3ad2ant3 cnclima sylan
    co ) CEFZDEFZBCDGRFZHBCDIRFZADJKFBLAMCJKFUASUBTBCDNOABCDPQ $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Topology of the real numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y B $.  $d x y D $.  $d x y F $.  $d x y U $.
    $( An alternate proof of the Intermediate Value Theorem ~ ivth using
       topology.  (Contributed by Jeff Hankins, 17-Aug-2009.)  (Revised by
       Mario Carneiro, 15-Dec-2013.) $)
    ivthALT $p |- ( ( ( A e. RR /\ B e. RR /\ U e. RR ) /\ A < B /\ ( ( A [,] B
    ) C_ D /\ D C_ CC /\ ( F e. ( D -cn-> CC ) /\ ( F " ( A [,] B ) ) C_ RR /\
    U e. ( ( F ` A ) (,) ( F ` B ) ) ) ) ) -> E. x e. ( A (,) B ) ( F ` x ) = U
    ) $=
      ( cr wcel w3a wbr co wss cc cfv wceq syl 3ad2ant3 crest ccn wa cicc ccncf
      vy clt cima cioo cv wrex wfun wf simp31 cncff ffun wral crn ctg ccon cuni
      cres wfo iccconn 3adant3 3ad2ant1 cdm simpr1 anim2i 3impb adantl biimparc
      fdm sseq2d jca fores wb ctop retop simp332 uniretop restuni sylancr foeq3
      mpbid ccnfld ctopn simp331 ssid eqid cnfldtop cnfldtopon toponunii restid
      ax-mp eqcomi cncfcn mpan2 3ad2ant2 eleqtrd ctopon simp32 toponuni sseqtrd
      resttopon cnrest syl2anc cvv ssexg sylancl restabs syl3anc iccssre rerest
      a1i cnex eqtrd oveq1d df-ima eqimss2i syl6ss cnrest2 oveq2d cnconn reconn
      ax-resscn wi cxr rexrd funfvima2 sylc sseq1d mpd sseldd wne adantr neneqd
      eqnetrd fveq2 nsyl jcad rexr syl2an cle simp11 simp12 imp 3adantl3 lbicc2
      ltle ubicc2 oveq1 oveq2 rspc2v ioossicc fvelima w3o simpl1 simprr simp333
      sseli elioo2 simp2d gtned simp13 simp3d ltned simprl3 ecase13d ex syl6ibr
      3anass elicc3 anbi1d elioo1 3imtr4d simpr reximdv2 ) BGHZCGHZEGHZIZBCUDJZ
      BCUAKZDLZDMLZFDMUBKZHZFUWAUEZGLZEBFNZCFNZUFKZHZIZIZIZAUGZFNZEOZAUWAUHZUWQ
      ABCUFKZUHUWNFUIZEUWFHUWRUWMUVSUWTUVTUWMDMFUJZUWTUWMUWEUXAUWBUWCUWEUWGUWKU
      KDMFULZPDMFUMZPQUWNUWHUWIUAKZUWFEUWNUWOUCUGZUAKZUWFLZUCUWFUNAUWFUNZUXDUWF
      LZUWNUFUOUPNZUWFRKZUQHZUXHUWNUXJUWARKZUQHZUWAUXKURZFUWAUSZUTZUXPUXMUXKSKZ
      HUXLUVSUVTUXNUWMUVPUVQUXNUVRBCVAVBVCUWNUWAUWFUXPUTZUXQUWNUWTUWAFVDZLZTZUX
      SUWNUWBUXATZUYBUWMUVSUYCUVTUWBUWCUWLUYCUWCUWLTZUXAUWBUYDUWEUXAUWCUWEUWGUW
      KVEUXBPVFVGQUYCUWTUYAUXAUWTUWBUXCVHUXAUYAUWBUXAUXTDUWADMFVJVKVIVLPZUWAFVM
      PUWNUWFUXOOZUXSUXQVNUWNUXJVOHUWGUYFVPUWEUWGUWKUWBUWCUVSUVTVQZUWFUXJGVRVSV
      TUWFUXOUWAUXPWAPWBUWNUXPUXMWCWDNZUWFRKZSKZUXRUWNUXPUXMUYHSKZHZUXPUYJHZUWN
      UXPUYHDRKZUWARKZUYHSKZUYKUWNFUYNUYHSKZHUWAUYNURZLUXPUYPHUWNFUWDUYQUWEUWGU
      WKUWBUWCUVSUVTWEUWMUVSUWDUYQOZUVTUWCUWBUYSUWLUWCMMLUYSMWFDMUYHUYNUYHUYHWG
      ZUYNWGUYHMRKZUYHUYHVOHZVUAUYHOUYHUYTWHZUYHVOMMUYHUYHUYTWIZWJWKWLWMWNWOWPQ
      WQUWNUWADUYRUVSUVTUWBUWCUWLUKZUWNUYNDWRNHZDUYROUWNUYHMWRNHZUWCVUFVUDUVSUV
      TUWBUWCUWLWSZDUYHMXBVTDUYNWTPXAUWAFUYNUYHUYRUYRWGXCXDUWNUYOUXMUYHSUWNUYOU
      YHUWARKZUXMUWNVUBUWBDXEHZUYOVUIOVUBUWNVUCXLVUEUWNUWCMXEHVUJVUHXMDMXEXFXGU
      WADUYHVOXEXHXIUWNUWAGLZVUIUXMOUVSUVTVUKUWMUVPUVQVUKUVRBCXJVBVCUWAUXJUYHUY
      TUXJWGZXKPXNXOWQUWNVUGUXPUOZUWFLZUWFMLUYLUYMVNVUGUWNVUDXLVUNUWNUWFVUMFUWA
      XPXQXLUWNUWFGMUYGYCXRUWFUXPUXMUYHMXSXIWBUWNUYIUXKUXMSUWNUWGUYIUXKOUYGUWFU
      XJUYHUYTVULXKPXTWQUXPUXMUXKUWAUXOUXOWGYAXIUWMUVSUXLUXHVNZUVTUWLUWBVUOUWCU
      WGUWEVUOUWKAUCUWFYBWPQQWBUWNUWHUWFHZUWIUWFHZUXHUXIYDUWNUYBBUWAHZVUPUYEUWN
      BYEHZCYEHZBCUUAJZVURUWNBUVPUVQUVRUVTUWMUUBYFZUWNCUVPUVQUVRUVTUWMUUCYFZUVS
      UVTVVAUWMUVPUVQUVTVVAUVRUVPUVQTUVTVVABCUUGUUDUUEVBZBCUUFXIUWABFYGYHZUWNUY
      BCUWAHZVUQUYEUWNVUSVUTVVAVVFVVBVVCVVDBCUUHXIUWACFYGYHZUXGUXIUWHUXEUAKZUWF
      LAUCUWHUWIUWFUWFUWOUWHOUXFVVHUWFUWOUWHUXEUAUUIYIUXEUWIOVVHUXDUWFUXEUWIUWH
      UAUUJYIUUKXDYJUWMUVSEUXDHZUVTUWLUWBVVIUWCUWKUWEVVIUWGUWJUXDEUWHUWIUULUURQ
      QQYKAEUWAFUUMXDUWNUWQUWQAUWAUWSUWNUWOUWAHZUWQTZUWOUWSHZUWQUWNUWOYEHZVVAUW
      OBOZBUWOUDJZUWOCUDJZTZUWOCOZUUNZIZUWQTZVVMVVOVVPIZVVKVVLUWNVWAVVMVVQTVWBU
      WNVWAVVMVVQVWAVVMYDUWNVVMVVAVVSUWQUUOXLUWNVWAVVQUWNVWATZVVQVVNVVRVWCUWPUW
      HOVVNVWCUWPUWHVWCUWPEUWHUWNVVTUWQUUPZUWNEUWHYLVWAUWNUWHEUWNUWFGUWHUYGVVEY
      KZUWNUVRUWHEUDJZEUWIUDJZUWNUWKUVRVWFVWGIZUWEUWGUWKUWBUWCUVSUVTUUQUWNUWHYE
      HUWIYEHUWKVWHVNUWNUWHVWEYFUWNUWIUWNUWFGUWIUYGVVGYKYFUWHUWIEUUSXDWBZUUTUVA
      YMYOYNUWOBFYPYQVWCUWPUWIOVVRVWCUWPUWIVWCUWPEUWIVWDUWNEUWIYLVWAUWNEUWIUVPU
      VQUVRUVTUWMUVBUWNUVRVWFVWGVWIUVCUVDYMYOYNUWOCFYPYQVVMVVAVVSUWQUWNUVEUVFUV
      GYRVVMVVOVVPUVIUVHUWNVVJVVTUWQUVSUVTVVJVVTVNZUWMUVPUVQVWJUVRUVPVUSVUTVWJU
      VQBYSZCYSZBCUWOUVJYTVBVCUVKUVSUVTVVLVWBVNZUWMUVPUVQVWMUVRUVPVUSVUTVWMUVQV
      WKVWLBCUWOUVLYTVBVCUVMVVKUWQYDUWNVVJUWQUVNXLYRUVOYJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                  Refinements
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Fne $.
  $( Extend class definition to include the "finer than" relation. $)
  cfne $a class Fne $.

  $c Ref $.
  $( Extend class definition to include the refinement relation. $)
  cref $a class Ref $.

  $c PtFin $.
  $( Extend class definition to include the class of point-finite covers. $)
  cptfin $a class PtFin $.

  $c LocFin $.
  $( Extend class definition to include the class of locally finite covers. $)
  clocfin $a class LocFin $.

  ${
    $d x y z $.
    $( Define the fineness relation for covers.  (Contributed by Jeff Hankins,
       28-Sep-2009.) $)
    df-fne $a |- Fne = { <. x , y >. | ( U. x = U. y /\ A. z e. x z C_ U. ( y
    i^i ~P z ) ) } $.
  $}

  ${
    $d w x y z $.
    $( Define the refinement relation.  (Contributed by Jeff Hankins,
       18-Jan-2010.) $)
    df-ref $a |- Ref = { <. x , y >. | ( U. x = U. y /\ A. z e. y E. w e. x z
    C_ w ) } $.
  $}

  ${
    $d x y z $.
    $( Define "point-finite."  (Contributed by Jeff Hankins, 21-Jan-2010.) $)
    df-ptfin $a |- PtFin = { x | A. y e. U. x { z e. x | y e. z } e. Fin } $.
  $}

  ${
    $d n p s x y $.
    $( Define "locally finite."  (Contributed by Jeff Hankins, 21-Jan-2010.) $)
    df-locfin $a |- LocFin = ( x e. Top |-> { y | ( U. x = U. y /\ A. p e. U. x
      E. n e. x ( p e. n /\ { s e. y | ( s i^i n ) =/= (/) } e. Fin ) ) } ) $.
  $}

  ${
    $d x y z $.
    $( Fineness is a relation.  (Contributed by Jeff Hankins, 28-Sep-2009.) $)
    fnerel $p |- Rel Fne $=
      ( vx vy vz cv cuni wceq cpw cin wss wral wa cfne df-fne relopabi ) ADZEBD
      ZEFCDZPQGHEICOJKABLABCMN $.
  $}

  ${
    $d r s t u w x y z A $.  $d r s t u w x y z B $.  $d t u w x y z C $.
    $d r s t u w X $.  $d r s t u w Y $.
    isfne.1 $e |- X = U. A $.
    isfne.2 $e |- Y = U. B $.
    $( The predicate " ` B ` is finer than ` A ` ."  This property is, in a
       sense, the opposite of refinement, as refinement requires every element
       to be a subset of an element of the original and fineness requires that
       every element of the original have a subset in the finer cover
       containing every point.  I do not know of a literature reference for
       this.  (Contributed by Jeff Hankins, 28-Sep-2009.) $)
    isfne $p |- ( B e. C -> ( A Fne B <-> ( X = Y /\ A. x e. A x C_ U. ( B i^i
    ~P x ) ) ) ) $=
      ( vr vs wcel cfne wceq cv cin cuni wss wral wa cvv fnerel brrelexi anim1i
      wbr ancoms simpr 3eqtr3g uniexg adantr eqeltrd uniexb sylibr simpl syldan
      cpw adantrr unieq syl6eqr eqeq1d raleq anbi12d eqeq2d ineq1 unieqd sseq2d
      jca ralbidv df-fne brabg pm5.21nd ) CDKZBCLUDZEFMZANZCVNUOZOZPZQZABRZSZBT
      KZVKSZVLVKWBVLWAVKBCLUAUBUCUEVKVMWBVSVKVMBPZCPZMZWBVKVMSEFWCWDVKVMUFGHUGV
      KWESZWAVKWFWCTKWAWFWCWDTVKWEUFVKWDTKWECDUHUIUJBUKULVKWEUMVFUNUPINZPZJNZPZ
      MZVNWIVOOZPZQZAWGRZSEWJMZWNABRZSVTIJBCTDLWGBMZWKWPWOWQWRWHEWJWRWHWCEWGBUQ
      GURUSWNAWGBUTVAWICMZWPVMWQVSWSWJFEWSWJWDFWICUQHURVBWSWNVRABWSWMVQVNWSWLVP
      WICVOVCVDVEVGVAIJAVHVIVJ $.

    $( The predicate " ` B ` is finer than ` A ` " in terms of the topology
       generation function.  (Contributed by Mario Carneiro, 11-Sep-2015.) $)
    isfne4 $p |- ( A Fne B <-> ( X = Y /\ A C_ ( topGen ` B ) ) ) $=
      ( vx cfne wbr cvv wcel wceq ctg cfv wss wa fnerel cuni uniexb wral adantl
      brrelex2i simpl 3eqtr3g fvex sylib eqeltrrd sylibr cv cpw cin isfne dfss3
      ssex eltg ralbidv syl5bb anbi2d bitr4d pm5.21nii ) ABHIZBJKZCDLZABMNZOZPZ
      ABHQUBVFBRZJKVBVFARZVGJVFCDVHVGVCVEUCEFUDVFAJKZVHJKVEVIVCAVDBMUEUNUAASUFU
      GBSUHVBVAVCGUIZBVJUJUKROZGATZPVFGABJCDEFULVBVEVLVCVEVJVDKZGATVBVLGAVDUMVB
      VMVKGAVJBJUOUPUQURUSUT $.

    $( A condition for a topology to be finer than another.  (Contributed by
       Jeff Hankins, 28-Sep-2009.)  (Revised by Mario Carneiro,
       11-Sep-2015.) $)
    isfne4b $p |- ( B e. V -> ( A Fne B <-> ( X = Y /\
        ( topGen ` A ) C_ ( topGen ` B ) ) ) ) $=
      ( wcel wceq ctg cfv wss wa cfne wbr cvv wb cuni simpr 3eqtr3g simpl tgss3
      uniexg adantr eqeltrd uniexb sylibr syl2anc pm5.32da isfne4 syl6rbbr ) BC
      HZDEIZAJKBJKZLZMUMAUNLZMABNOULUMUOUPULUMMZAPHZULUOUPQUQARZPHURUQUSBRZPUQD
      EUSUTULUMSFGTULUTPHUMBCUCUDUEAUFUGULUMUAABPCUBUHUIABDEFGUJUK $.

    $( The predicate " ` B ` is finer than ` A ` ."  (Contributed by Jeff
       Hankins, 28-Sep-2009.)  (Proof shortened by Mario Carneiro,
       11-Sep-2015.) $)
    isfne2 $p |- ( B e. C -> ( A Fne B <-> ( X = Y /\ A. x e. A A. y e. x E. z
    e. B ( y e. z /\ z C_ x ) ) ) ) $=
      ( cfne wbr wceq ctg wss wa wcel cv wral syl5bb wrex isfne4 eltg2b ralbidv
      cfv dfss3 anbi2d ) DEKLGHMZDENUEZOZPEFQZUHBRCRZQULARZOPCEUABUMSZADSZPDEGH
      IJUBUKUJUOUHUJUMUIQZADSUKUOADUIUFUKUPUNADBCUMEFUCUDTUGT $.

    $( The predicate " ` B ` is finer than ` A ` ."  (Contributed by Jeff
       Hankins, 11-Oct-2009.)  (Proof shortened by Mario Carneiro,
       11-Sep-2015.) $)
    isfne3 $p |- ( B e. C -> ( A Fne B <-> ( X = Y /\ A. x e. A E. y ( y C_ B
    /\ x = U. y ) ) ) ) $=
      ( cfne wbr wceq ctg cfv wss wa wcel cv wral syl5bb wex isfne4 dfss3 eltg3
      cuni ralbidv anbi2d ) CDJKFGLZCDMNZOZPDEQZUHBRZDOARZULUELPBUAZACSZPCDFGHI
      UBUKUJUOUHUJUMUIQZACSUKUOACUIUCUKUPUNACBUMDEUDUFTUGT $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x X $.  $d x Y $.
    fnebas.1 $e |- X = U. A $.
    fnebas.2 $e |- Y = U. B $.
    $( A finer cover covers the same set as the original.  (Contributed by Jeff
       Hankins, 28-Sep-2009.) $)
    fnebas $p |- ( A Fne B -> X = Y ) $=
      ( cfne wbr wceq ctg cfv wss isfne4 simplbi ) ABGHCDIABJKLABCDEFMN $.
  $}

  $( A finer cover generates a topology finer than the original set.
     (Contributed by Mario Carneiro, 11-Sep-2015.) $)
  fnetg $p |- ( A Fne B -> A C_ ( topGen ` B ) ) $=
    ( cfne wbr cuni wceq ctg cfv wss eqid isfne4 simprbi ) ABCDAEZBEZFABGHIABMN
    MJNJKL $.

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z P $.  $d x y z S $.
    $( If ` B ` is finer than ` A ` and ` S ` is an element of ` A ` , every
       point in ` S ` is an element of a subset of ` S ` which is in ` B ` .
       (Contributed by Jeff Hankins, 28-Sep-2009.) $)
    fnessex $p |- ( ( A Fne B /\ S e. A /\ P e. S ) -> E. x e. B
        ( P e. x /\ x C_ S ) ) $=
      ( cfne wbr wcel cv wss wa wrex ctg cfv fnetg sselda tg2 sylan 3impa ) BCF
      GZEBHZDEHZDAIZHUCEJKACLZTUAKECMNZHUBUDTBUEEBCOPAECDQRS $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y S $.
    $( If ` B ` is finer than ` A ` , every element of ` A ` is a union of
       elements of ` B ` .  (Contributed by Jeff Hankins, 11-Oct-2009.) $)
    fneuni $p |- ( ( A Fne B /\ S e. A ) -> E. x ( x C_ B /\ S = U. x ) ) $=
      ( cfne wbr wcel wa ctg cfv cv wss cuni wceq wex fnetg sselda cdm wb syl
      elfvdm eltg3 ibi ) BCEFZDBGHDCIJZGZAKZCLDUGMNHAOZUDBUEDBCPQUFUHUFCIRZGUFU
      HSDCIUAADCUIUBTUCT $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d y z C $.  $d x y z P $.
    $( If a cover is finer than another, every point can be approached more
       closely by intersections.  (Contributed by Jeff Hankins,
       11-Oct-2009.) $)
    fneint $p |- ( A Fne B -> |^| { x e. B | P e. x }
    C_ |^| { x e. A | P e. x } ) $=
      ( vy vz cfne wbr cv wcel crab cint wral wa eleq2 elrab wrex fnessex 3expb
      wss intminss sstr sylan expl rexlimiv syl ex syl5bi ralrimiv ssint sylibr
      ) BCGHZDAIZJZACKLZEIZTZEUNABKZMUOURLTULUQEURUPURJUPBJZDUPJZNZULUQUNUTAUPB
      UMUPDOPULVAUQULVANDFIZJZVBUPTZNZFCQZUQULUSUTVFFBCDUPRSVEUQFCVBCJZVCVDUQVG
      VCNUOVBTVDUQUNVCAVBCUMVBDOUAUOVBUPUBUCUDUEUFUGUHUIEUOURUJUK $.
  $}

  ${
    $d w x y z $.
    $( Refinement is a relation.  (Contributed by Jeff Hankins,
       18-Jan-2010.) $)
    refrel $p |- Rel Ref $=
      ( vx vy vz vw cv cuni wceq wss wrex wral wa cref df-ref relopabi ) AEZFBE
      ZFGCEDEHDOICPJKABLABCDMN $.
  $}

  ${
    $d a b x y A $.  $d a b x B $.  $d a b C $.  $d a b X $.  $d a b Y $.
    isref.1 $e |- X = U. A $.
    isref.2 $e |- Y = U. B $.
    $( The property of being a refinement of a cover.  Dr.  Nyikos once
       commented in class that the term "refinement" is actually misleading and
       that people are inclined to confuse it with the notion defined in
       ~ isfne .  On the other hand, the two concepts do seem to have a dual
       relationship.  (Contributed by Jeff Hankins, 18-Jan-2010.) $)
    isref $p |- ( B e. C -> ( A Ref B <-> ( X = Y /\ A. x e. B E. y e. A x C_ y
    ) ) ) $=
      ( va vb wcel cref wceq cv wrex wral wa cvv cuni wbr refrel brrelexi simpl
      wss adantl jca simpr 3eqtr3g uniexg adantr eqeltrd uniexb adantrr syl6eqr
      sylibr unieq eqeq1d rexeq ralbidv anbi12d eqeq2d raleq df-ref pm5.21nd
      brabg ) DELZCDMUAZFGNZAOBOUEZBCPZADQZRZCSLZVGRVGVHRVNVGVHVNVGCDMUBUCUFVGV
      HUDUGVGVMRVNVGVGVIVNVLVGVIRZCTZSLVNVOVPDTZSVOFGVPVQVGVIUHHIUIVGVQSLVIDEUJ
      UKULCUMUPUNVGVMUDUGJOZTZKOZTZNZVJBVRPZAVTQZRFWANZVKAVTQZRVMJKCDSEMVRCNZWB
      WEWDWFWGVSFWAWGVSVPFVRCUQHUOURWGWCVKAVTVJBVRCUSUTVAVTDNZWEVIWFVLWHWAGFWHW
      AVQGVTDUQIUOVBVKAVTDVCVAJKABVDVFVE $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y X $.  $d x y Y $.
    refbas.1 $e |- X = U. A $.
    refbas.2 $e |- Y = U. B $.
    $( A refinement covers the same set.  (Contributed by Jeff Hankins,
       18-Jan-2010.) $)
    refbas $p |- ( A Ref B -> X = Y ) $=
      ( vx vy cvv wcel cref wbr wceq refrel brrelex2i cv wss wrex wral isref
      simprbda mpancom ) BIJZABKLZCDMZABKNOUCUDUEGPHPQHARGBSGHABICDEFTUAUB $.
  $}

  ${
    $d x y A $.  $d y B $.  $d y C $.  $d x y S $.
    $( Every set in a refinement has a superset in the original cover.
       (Contributed by Jeff Hankins, 18-Jan-2010.) $)
    refssex $p |- ( ( A Ref B /\ S e. B ) -> E. x e. A S C_ x ) $=
      ( vy cref wbr wcel cv wss wrex wral wi cvv brrelex2i cuni wceq eqid isref
      refrel simplbda mpancom sseq1 rexbidv rspccv syl imp ) BCFGZDCHZDAIZJZABK
      ZUHEIZUJJZABKZECLZUIULMCNHZUHUPBCFTOUQUHBPZCPZQUPEABCNURUSURRUSRSUAUBUOUL
      EDCUMDQUNUKABUMDUJUCUDUEUFUG $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.
    fness.1 $e |- X = U. A $.
    fness.2 $e |- Y = U. B $.
    $( A cover is finer than its subcovers.  (Contributed by Jeff Hankins,
       11-Oct-2009.) $)
    fness $p |- ( ( B e. C /\ A C_ B /\ X = Y ) -> A Fne B ) $=
      ( vy vz vx wcel wss wceq w3a cfne wel cv wa wral simp3 wrex ssel2 3adant3
      wbr ssid jctir elequ2 anbi12d rspcev syl2anc 3expib ralrimivv 3ad2ant2 wb
      sseq1 isfne2 3ad2ant1 mpbir2and ) BCKZABLZDEMZNABOUDZVAHIPZIQZJQZLZRZIBUA
      ZHVESJASZUSUTVATUTUSVIVAUTVHJHAVEUTVEAKZHJPZVHUTVJVKNZVEBKZVKVEVELZRZVHUT
      VJVMVKABVEUBUCVLVKVNUTVJVKTVEUEUFVGVOIVEBVDVEMVCVKVFVNIJHUGVDVEVEUOUHUIUJ
      UKULUMUSUTVBVAVIRUNVAJHIABCDEFGUPUQUR $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y X $.  $d x y Y $.
    ssref.1 $e |- X = U. A $.
    ssref.2 $e |- Y = U. B $.
    $( A subcover is a refinement of the original cover.  (Contributed by Jeff
       Hankins, 18-Jan-2010.) $)
    ssref $p |- ( ( A e. C /\ A C_ B /\ X = Y ) -> B Ref A ) $=
      ( vx vy wcel wss wceq w3a cref wbr cv wrex wral eqcom wa biimpi 3ad2antl2
      3ad2ant3 ssel2 sseq2 rspcev sylancl ralrimiva wb isref 3ad2ant1 mpbir2and
      ssid ) ACJZABKZDELZMZBANOZEDLZHPZIPZKZIBQZHARZUPUNUSUOUPUSDESUAUCUQVCHAUQ
      UTAJZTUTBJZUTUTKZVCUOUNVEVFUPABUTUDUBUTUMVBVGIUTBVAUTUTUEUFUGUHUNUOURUSVD
      TUIUPHIBACEDGFUJUKUL $.
  $}

  ${
    $d x y z A $.  $d x y z V $.
    $( Reflexivity of the fineness relation.  (Contributed by Jeff Hankins,
       12-Oct-2009.) $)
    fneref $p |- ( A e. V -> A Fne A ) $=
      ( vy vz vx wcel cfne wbr cuni wceq wel cv wss wrex wral eqid elequ2 sseq1
      wa ssid anbi12d rspcev mpanr2 rgen2 pm3.2i isfne2 mpbiri ) ABFAAGHAIZUHJZ
      CDKZDLZELZMZSZDANZCULOEAOZSUIUPUHPZUOECAULULAFCEKZULULMZUOULTUNURUSSDULAU
      KULJUJURUMUSDECQUKULULRUAUBUCUDUEECDAABUHUHUQUQUFUG $.
  $}

  ${
    $d x y A $.  $d x y V $.
    $( Reflexivity of refinement.  (Contributed by Jeff Hankins,
       18-Jan-2010.) $)
    refref $p |- ( A e. V -> A Ref A ) $=
      ( vx vy wcel cref wbr cuni wceq cv wss wrex wral wa eqid ssid sseq2 mpan2
      rspcev rgen pm3.2i isref mpbiri ) ABEAAFGAHZUDIZCJZDJZKZDALZCAMZNUEUJUDOZ
      UICAUFAEUFUFKZUIUFPUHULDUFAUGUFUFQSRTUACDAABUDUDUKUKUBUC $.
  $}

  ${
    $d u v w x A $.  $d u v w x B $.  $d u v w x C $.  $d u v w x V $.
    $( Transitivity of the fineness relation.  (Contributed by Jeff Hankins,
       5-Oct-2009.)  (Proof shortened by Mario Carneiro, 11-Sep-2015.) $)
    fnetr $p |- ( ( A Fne B /\ B Fne C ) -> A Fne C ) $=
      ( cfne wbr wa cuni wceq ctg cfv wss eqid fnebas cvv wcel fnerel brrelex2i
      isfne4b simplbda mpancom sylan9eq sylan9ss wb adantl syl mpbir2and ) ABDE
      ZBCDEZFZACDEZAGZCGZHZAIJZCIJZKZUGUHUKBGZULABUKUQUKLZUQLZMBCUQULUSULLZMUAU
      GUHUNBIJZUOBNOZUGUNVAKZABDPQVBUGUKUQHVCABNUKUQURUSRSTCNOZUHVAUOKZBCDPQZVD
      UHUQULHVEBCNUQULUSUTRSTUBUIVDUJUMUPFUCUHVDUGVFUDACNUKULURUTRUEUF $.
  $}

  ${
    fneval.1 $e |- .~ = ( Fne i^i `' Fne ) $.
    $( Two covers are finer than each other iff they are both bases for the
       same topology.  (Contributed by Mario Carneiro, 11-Sep-2015.) $)
    fneval $p |- ( ( A e. V /\ B e. W ) ->
      ( A .~ B <-> ( topGen ` A ) = ( topGen ` B ) ) ) $=
      ( wbr cfne wa wcel ctg cfv wceq anbi2i bitri cuni wss eqid isfne4b unitg
      ccnv breqi brin fnerel relbrcnv eqcom anbi1i syl6bb bi2anan9r eqss anandi
      cin syl6bbr unieq eqeqan12d syl5ib pm4.71rd bitr4d syl5bb ) ABCGZABHGZBAH
      GZIZADJZBEJZIZAKLZBKLZMZUTABHHUAZULZGZVCABCVKFUBVLVAABVJGZIVCABHVJUCVMVBV
      AABHUDUENOOVFVCAPZBPZMZVIIZVIVFVCVPVGVHQZIZVPVHVGQZIZIZVQVEVAVSVDVBWAABEV
      NVOVNRZVORZSVDVBVOVNMZVTIWABADVOVNWDWCSWEVPVTVOVNUFUGUHUIVQVPVRVTIZIWBVIW
      FVPVGVHUJNVPVRVTUKOUMVFVIVPVIVGPZVHPZMVFVPVGVHUNVDVEWGVNWHVOADTBETUOUPUQU
      RUS $.

    $d x y .~ $.
    $( Fineness intersected with its converse is an equivalence relation.
       (Contributed by Jeff Hankins, 6-Oct-2009.)  (Revised by Mario Carneiro,
       11-Sep-2015.) $)
    fneer $p |- .~ Er _V $=
      ( vx vy cv ctg cfv fveq2 wbr copab wceq wrel cfne wss ccnv cin inss1 wcel
      cvv vex eqsstri fnerel relss mp2 dfrel4v mpbi wb mp2an opabbii eqtri eqer
      fneval ) CDCEZFGZDEZFGZAUMUOFHAUMUOAIZCDJZUNUPKZCDJALZAURKAMNMLUTAMMOZPMB
      MVAQUAUBAMUCUDCDAUEUFUQUSCDUMSRUOSRUQUSUGCTDTUMUOASSBULUHUIUJUK $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z C $.  $d x y z V $.
    $( Refinement is transitive.  (Contributed by Jeff Hankins,
       18-Jan-2010.) $)
    reftr $p |- ( ( A Ref B /\ B Ref C ) -> A Ref C ) $=
      ( vx vz vy cref wbr wa cuni cv wss wrex eqid refbas wi refssex adantl cvv
      wcel wceq wral sylan9eq ex ad2ant2r sstr2 reximdv ad2antll mpd rexlimdvaa
      syld ralrimiv wb refrel brrelex2i isref syl mpbir2and ) ABGHZBCGHZIZACGHZ
      AJZCJZUAZDKZEKZLZEAMZDCUBZUSUTVCBJZVDABVCVKVCNZVKNZOBCVKVDVMVDNZOUCVAVIDC
      VAVFCTZVFFKZLZFBMZVIUTVOVRPUSUTVOVRFBCVFQUDRVAVQVIFBVAVPBTZVQIIVPVGLZEAMZ
      VIUSVSWAUTVQEABVPQUEVQWAVIPVAVSVQVTVHEAVFVPVGUFUGUHUIUJUKULVACSTZVBVEVJIU
      MUTWBUSBCGUNUORDEACSVCVDVLVNUPUQUR $.
  $}

  ${
    topfne.1 $e |- X = U. J $.
    topfne.2 $e |- Y = U. K $.
    $( Fineness for covers corresponds precisely with fineness for topologies.
       (Contributed by Jeff Hankins, 29-Sep-2009.) $)
    topfne $p |- ( ( K e. Top /\ X = Y ) -> ( J C_ K <-> J Fne K ) ) $=
      ( ctop wcel wss ctg cfv wceq cfne wbr tgtop sseq2d bicomd isfne4 sylan9bb
      baibr ) BGHZABIZABJKZIZCDLZABMNZUAUDUBUAUCBABOPQUFUEUDABCDEFRTS $.
  $}

  ${
    $d c j o s x A $.  $d c j o s x J $.  $d c j o s x .~ $.
    topfneec.1 $e |- .~ = ( Fne i^i `' Fne ) $.
    $( A cover is equivalent to a topology iff it is a base for that topology.
       (Contributed by Jeff Hankins, 8-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 11-Sep-2015.) $)
    topfneec $p |- ( J e. Top -> ( A e. [ J ] .~ <-> ( topGen ` A ) = J ) ) $=
      ( cec wcel wbr ctop ctg cfv wceq wrel wb cvv wer fneer ax-mp wa ctb ex wi
      errel relelec brrelex2i a1i eleq1 biimparc tgclb sylibr elex fneval tgtop
      syl eqeq1d eqcom syl6bb adantr bitrd pm5.21ndd syl5bb ) ACBEFZCABGZCHFZAI
      JZCKZBLZVAVBMNBOVFBDPNBUBQZACBUCQVCANFZVBVEVBVHUAVCCABVGUDUEVCVEVHVCVERZA
      SFZVHVIVDHFZVJVEVKVCVDCHUFUGAUHUIASUJUMTVCVHVBVEMVCVHRVBCIJZVDKZVECABHNDU
      KVCVMVEMVHVCVMCVDKVEVCVLCVDCULUNCVDUOUPUQURTUSUT $.
  $}

  ${
    topfneec2.1 $e |- .~ = ( Fne i^i `' Fne ) $.
    $( A topology is precisely identified with its equivalence class.
       (Contributed by Jeff Hankins, 12-Oct-2009.) $)
    topfneec2 $p |- ( ( J e. Top /\ K e. Top ) ->
      ( [ J ] .~ = [ K ] .~ <-> J = K ) ) $=
      ( ctop wcel wa wbr ctg cfv wceq cec fneval cvv wer fneer a1i adantr tgtop
      elex erth eqeqan12d 3bitr3d ) BEFZCEFZGZBCAHBIJZCIJZKBALCALKBCKBCAEEDMUFB
      CANNAOUFADPQUDBNFUEBETRUAUDUEUGBUHCBSCSUBUC $.
  $}

  ${
    $d c t w x y z A $.  $d c t w x y z B $.  $d c t w x y z C $.
    $d c t w x y z X $.  $d c t w x y z Y $.
    fnessref.1 $e |- X = U. A $.
    fnessref.2 $e |- Y = U. B $.
    $( A cover is finer iff it has a subcover which is both finer and a
       refinement.  (Contributed by Jeff Hankins, 18-Jan-2010.) $)
    fnessref $p |- ( X = Y ->
      ( A Fne B <-> E. c ( c C_ B /\ A ( Fne i^i Ref ) c ) ) ) $=
      ( vx vy vt vw vz wceq cfne wss wa wrex cvv wcel wi wbr cv cref cin fnerel
      wex crab brrelex2i adantl rabexg syl cuni wral eleq2i eluni bitri fnessex
      wel 3expia adantll sseq2 rspcev ex anim2d reximdv syld com23 imp3a syl5bi
      exlimdv elunirab syl6ibr ssrdv ssrab2 unissi simpl syl6req syl5sseq eqssd
      3expb a1i ad2antll com12 ad2antrl jcad sseq1 rexbidv elrab simpr reximdv2
      expcom mpd ralrimivva wb eqid isfne2 3syl mpbir2and biimpi ralrimiv isref
      cbvrexv brin sylanbrc jctil breq2 anbi12d spcegv sylc inss1 fnebas eqtr3d
      ssbri syl6eq vex uniex syl6eqelr uniexb sylibr simprl fness syl3anc fnetr
      syl2anc impbid ) CDMZABNUAZEUBZBOZAYHNUCUDZUAZPZEUFZYFYGYMYFYGPZHUBZIUBZO
      ZIAQZHBUGZRSZYSBOZAYSYJUAZPZYMYNBRSZYTYGUUDYFABNUEUHUIZYRHBRUJZUKYNUUBUUA
      YNAYSNUAZAYSUCUAZUUBYNUUGCYSULZMZJKURZKUBZLUBZOZPZKYSQZJUUMUMLAUMZYNCUUIY
      NJCUUIYNJUBZCSZJHURZYRPZHBQZUURUUISUUSJLURZUUMASZPZLUFZYNUVBUUSUURAULZSUV
      FCUVGUURFUNLUURAUOUPYNUVEUVBLYNUVCUVDUVBYNUVDUVCUVBYNUVDUVCUVBTYNUVDPZUVC
      UUTYOUUMOZPZHBQZUVBYGUVDUVCUVKTYFYGUVDUVCUVKHABUURUUMUQUSUTUVHUVJUVAHBUVH
      UVIYRUUTUVDUVIYRTYNUVDUVIYRYQUVIIUUMAYPUUMYOVAVBVCUIVDVEVFVCVGVHVJVIYRHUU
      RBVKVLVMYNBULZUUICYSBYRHBVNZVOYNCDUVLYFYGVPGVQVRVSZYNUUPLJAUUMYNUVDUVCPZP
      ZUUOKBQZUUPYGUVOUVQYFYGUVDUVCUVQKABUURUUMUQVTUTUVPUUOUUOKBYSUVPUULBSZUUOP
      ZUULYSSZUUOUVPUVSUVRUULYPOZIAQZPUVTUVPUVSUVRUWBUVSUVRTUVPUVRUUOVPWAUVDUVS
      UWBTYNUVCUVSUVDUWBUUNUVDUWBTUVRUUKUVDUUNUWBUWAUUNIUUMAYPUUMUULVAVBWKWBWCW
      DWEYRUWBHUULBYOUULMYQUWAIAYOUULYPWFWGWHVLUVSUUOTUVPUVRUUOWIWAWEWJWLWMYNUU
      DYTUUGUUJUUQPWNUUEUUFLJKAYSRCUUIFUUIWOZWPWQWRYNUUHUUJUUMUULOZKAQZLYSUMZUV
      NYNUWELYSUUMYSSUUMBSZUUMYPOZIAQZPZYNUWEYRUWIHUUMBYOUUMMYQUWHIAYOUUMYPWFWG
      WHUWJUWETYNUWIUWEUWGUWIUWEUWHUWDIKAYPUULUUMVAXBWSUIWAVIWTYNUUDYTUUHUUJUWF
      PWNUUEUUFLKAYSRCUUIFUWCXAWQWRAYSNUCXCXDUVMXEYLUUCEYSRYHYSMYIUUAYKUUBYHYSB
      WFYHYSAYJXFXGXHXIVCYFYLYGEYFYLYGYFYLPZAYHNUAZYHBNUAZYGYKUWLYFYIYJNAYHNUCX
      JXMZWBUWKUUDYIYHULZDMUWMUWKUVLRSUUDUWKUVLUWORUWKUWODUVLUWKCUWODYKCUWOMZYF
      YIYKUWLUWPUWNAYHCUWOFUWOWOZXKUKWBYFYLVPXLZGXNYHEXOXPXQBXRXSYFYIYKXTUWRYHB
      RUWODUWQGYAYBAYHBYCYDVCVJYE $.
  $}

  ${
    $d c x y A $.  $d c x y B $.  $d c x y C $.  $d c x y X $.  $d c x y Y $.
    refssfne.1 $e |- X = U. A $.
    refssfne.2 $e |- Y = U. B $.
    $( A cover is a refinement iff it is a subcover of something which is both
       finer and a refinement.  (Contributed by Jeff Hankins, 18-Jan-2010.) $)
    refssfne $p |- ( X = Y -> ( A Ref B <->
      E. c ( B C_ c /\ A ( Fne i^i Ref ) c ) ) ) $=
      ( vx vy wceq cref wbr cv wss cfne wa cun cvv wcel cuni brrelexi brrelex2i
      cin wex refrel adantl unexg syl2anc ssun1 a1i eqimss2 adantr sylib eqcomd
      ssequn2 uneq12i uniun eqtr4i fness syl3anc wrex wral wo elun sseq2 rspcev
      wi ssid mpan2 refssex ex jaod syl5bi ralrimiv wb isref syl mpbir2and brin
      sylanbrc ssun2 jctil breq2 anbi12d spcegv sylc ad2antll vex ssex ad2antrl
      simprbi simprl simpl eqid refbas eqtr3d ssref reftr exlimdv impbid ) CDJZ
      ABKLZBEMZNZAXCOKUCZLZPZEUDZXAXBXHXAXBPZABQZRSZBXJNZAXJXELZPZXHXIARSZBRSZX
      KXBXOXAABKUEUAUFXBXPXAABKUEUBUFABRRUGUHZXIXMXLXIAXJOLZAXJKLZXMXIXKAXJNZCC
      DQZJZXRXQXTXIABUIUJXIYACXIDCNZYACJXAYCXBDCUKULDCUOUMUNZAXJRCYAFYAATZBTZQX
      JTCYEDYFFGUPABUQURZUSUTXIXSYBHMZIMZNZIAVAZHXJVBZYDXIYKHXJYHXJSYHASZYHBSZV
      CXIYKYHABVDXIYMYKYNYMYKVGXIYMYHYHNZYKYHVHYJYOIYHAYIYHYHVEVFVIUJXBYNYKVGXA
      XBYNYKIABYHVJVKUFVLVMVNXIXKXSYBYLPVOXQHIAXJRCYAFYGVPVQVRAXJOKVSVTBAWAWBXG
      XNEXJRXCXJJXDXLXFXMXCXJBVEXCXJAXEWCWDWEWFVKXAXGXBEXAXGXBXAXGPZAXCKLZXCBKL
      ZXBXFYQXAXDXFAXCOLYQAXCOKVSWKZWGYPXPXDDXCTZJYRXDXPXAXFBXCEWHWIWJXAXDXFWLY
      PCDYTXAXGWMXFCYTJZXAXDXFYQUUAYSAXCCYTFYTWNZWOVQWGWPBXCRDYTGUUBWQUTAXCBWRU
      HVKWSWT $.
  $}

  ${
    $d a x y A $.  $d a B $.  $d a x X $.
    isptfin.1 $e |- X = U. A $.
    $( The statement "is a point-finite cover."  (Contributed by Jeff Hankins,
       21-Jan-2010.) $)
    isptfin $p |- ( A e. B -> ( A e. PtFin <-> A. x e. X { y e. A | x e. y }
    e. Fin ) ) $=
      ( va cv wcel crab cfn cuni wral cptfin wceq unieq syl6eqr rabeq raleqbidv
      eleq1d df-ptfin elab2g ) AHBHIZBGHZJZKIZAUDLZMUCBCJZKIZAEMGCNDUDCOZUFUIAU
      GEUJUGCLEUDCPFQUJUEUHKUCBUDCRTSGABUAUB $.
  $}

  ${
    $d j n s x y A $.  $d j n x y J $.  $d j x y X $.  $d y Y $.
    islocfin.1 $e |- X = U. J $.
    islocfin.2 $e |- Y = U. A $.
    $( The statement "is a locally finite cover."  (Contributed by Jeff
       Hankins, 21-Jan-2010.) $)
    islocfin $p |- ( A e. ( LocFin ` J ) <-> ( J e. Top /\ X = Y /\ A. x e. X
      E. n e. J ( x e. n /\ { s e. A | ( s i^i n ) =/= (/) } e. Fin ) ) ) $=
      ( vj vy clocfin wcel ctop wceq cv cfn wa cuni cvv cfv cin c0 wne crab w3a
      wrex wral cdm cab df-locfin dmmptss elfvdm sseldi cpw wss eqimss2 sspwuni
      sylibr vex elpw adantr abssi topopn pwexg 3syl ssexg sylancr unieq eqeq1d
      syl6eqr rexeq anbi12d abbidv fvmptg mpdan eleq2d elex adantl simpr syl6eq
      raleqbidv eqeltrrd syl uniexb adantrr eqeq2d rabeq eleq1d rexbidv ralbidv
      anbi2d elabg pm5.21nd bitrd biadan2 3anass bitr4i ) BDLUAZMZDNMZEFOZAPCPZ
      MZGPXCUBUCUDZGBUEZQMZRZCDUGZAEUHZRZRXAXBXJUFWTXAXKWTLUINDJNJPZSZKPZSZOZXD
      XEGXNUEZQMZRZCXLUGZAXMUHZRZKUJZLJKCGAUKZULBDLUMUNXAWTBEXOOZXSCDUGZAEUHZRZ
      KUJZMZXKXAWSYIBXAYITMZWSYIOXAYIEUOZUOZUPYMTMZYKYHKYMYEXNYMMZYGYEXNYLUPZYO
      YEXOEUPYPXOEUQXNEURUSXNYLKUTVAUSVBVCXAEDMZYLTMYNDEHVDZEDVEYLTVEVFYIYMTVGV
      HJDYCYINTLXLDOZYBYHKYSXPYEYAYGYSXMEXOYSXMDSEXLDVIHVKZVJYSXTYFAXMEYTXSCXLD
      VLWBVMVNYDVOVPVQXAYJXKBTMZYJUUAXABYIVRVSXAXBUUAXJXAXBRZBSZTMZUUAUUBUUCDMU
      UDUUBEUUCDUUBEFUUCXAXBVTIWAXAYQXBYRVBWCUUCDVRWDBWEUSWFYHXKKBTXNBOZYEXBYGX
      JUUEXOFEUUEXOUUCFXNBVIIVKWGUUEYFXIAEUUEXSXHCDUUEXRXGXDUUEXQXFQXEGXNBWHWIW
      LWJWKVMWMWNWOWPXAXBXJWQWR $.
  $}

  ${
    $d x y A $.
    $( A finite cover is a point-finite cover.  (Contributed by Jeff Hankins,
       21-Jan-2010.) $)
    finptfin $p |- ( A e. Fin -> A e. PtFin ) $=
      ( vx vy cfn wcel cptfin wel crab cuni wral rabfi ralrimivw isptfin mpbird
      eqid ) ADEZAFEBCGZCAHDEZBAIZJPRBSQCAKLBCADSSOMN $.
  $}

  ${
    $d p x A $.  $d p x P $.  $d p x X $.
    ptfinfin.1 $e |- X = U. A $.
    $( A point covered by a point-finite cover is only covered by finitely many
       elements.  (Contributed by Jeff Hankins, 21-Jan-2010.) $)
    ptfinfin $p |- ( ( A e. PtFin /\ P e. X )
        -> { x e. A | P e. x } e. Fin ) $=
      ( vp cptfin wcel cv crab cfn wral wi isptfin ibi wceq eleq1 eleq1d rspccv
      rabbidv syl imp ) BGHZCDHZCAIZHZABJZKHZUCFIZUEHZABJZKHZFDLZUDUHMUCUMFABGD
      ENOULUHFCDUICPZUKUGKUNUJUFABUICUEQTRSUAUB $.
  $}

  ${
    $d n s x A $.  $d n s x J $.  $d n s x X $.  $d n s x Y $.
    finlocfin.1 $e |- X = U. J $.
    finlocfin.2 $e |- Y = U. A $.
    $( A finite cover of a topological space is a locally finite cover.
       (Contributed by Jeff Hankins, 21-Jan-2010.) $)
    finlocfin $p |- ( ( J e. Top /\ A e. Fin /\ X = Y ) ->
      A e. ( LocFin ` J ) ) $=
      ( vx vn vs ctop wcel cfn wceq w3a cv cin c0 wne crab wa wrex wral clocfin
      cfv simp1 simp3 simpl1 topopn syl simpr simpl2 ssrab2 sylancl eleq2 ineq2
      wss ssfi neeq1d rabbidv eleq1d anbi12d rspcev syl12anc ralrimiva islocfin
      syl3anbrc ) BJKZALKZCDMZNZVGVIGOZHOZKZIOZVLPZQRZIASZLKZTZHBUAZGCUBABUCUDK
      VGVHVIUEVGVHVIUFVJVTGCVJVKCKZTZCBKZWAVNCPZQRZIASZLKZVTWBVGWCVGVHVIWAUGBCE
      UHUIVJWAUJWBVHWFAUPWGVGVHVIWAUKWEIAULAWFUQUMVSWAWGTHCBVLCMZVMWAVRWGVLCVKU
      NWHVQWFLWHVPWEIAWHVOWDQVLCVNUOURUSUTVAVBVCVDGAHBCDIEFVEVF $.
  $}

  ${
    $d n s x A $.  $d n s x B $.  $d n s x J $.  $d n s x X $.  $d n s x Y $.
    $( A locally finite cover covers a topological space.  (Contributed by Jeff
       Hankins, 21-Jan-2010.) $)
    locfintop $p |- ( A e. ( LocFin ` J ) -> J e. Top ) $=
      ( vs vn vx clocfin cfv wcel ctop cuni wceq cv cin c0 wne crab cfn wa wrex
      eqid wral islocfin simp1bi ) ABFGHBIHBJZAJZKCLDLZHELUFMNOEAPQHRDBSCUDUACA
      DBUDUEEUDTUETUBUC $.

    locfinbas.1 $e |- X = U. J $.
    locfinbas.2 $e |- Y = U. A $.
    $( A locally finite cover must cover the base set of its corresponding
       topological space.  (Contributed by Jeff Hankins, 21-Jan-2010.) $)
    locfinbas $p |- ( A e. ( LocFin ` J ) -> X = Y ) $=
      ( vs vn vx clocfin cfv wcel ctop wceq cv cin c0 wne crab cfn wa wrex wral
      islocfin simp2bi ) ABJKLBMLCDNGOHOZLIOUFPQRIASTLUAHBUBGCUCGAHBCDIEFUDUE
      $.
  $}

  ${
    $d n s x A $.  $d n x J $.  $d n x P $.  $d x X $.
    locfinnei.1 $e |- X = U. J $.
    $( A point covered by a locally finite cover has a neighborhood which
       intersects only finitely many elements of the cover.  (Contributed by
       Jeff Hankins, 21-Jan-2010.) $)
    locfinnei $p |- ( ( A e. ( LocFin ` J ) /\ P e. X ) ->
      E. n e. J ( P e. n /\ { s e. A | ( s i^i n ) =/= (/) } e. Fin ) ) $=
      ( vx clocfin cfv wcel cv cin c0 wne crab cfn wa wrex wceq wral ctop eleq1
      cuni eqid islocfin simp3bi anbi1d rexbidv rspccva sylan ) ADIJKZHLZCLZKZF
      LUNMNOFAPQKZRZCDSZHEUAZBEKBUNKZUPRZCDSZULDUBKEAUDZTUSHACDEVCFGVCUEUFUGURV
      BHBEUMBTZUQVACDVDUOUTUPUMBUNUCUHUIUJUK $.
  $}

  ${
    $d n s x A $.  $d n s x B $.  $d n s x J $.
    $( A locally finite cover is point-finite.  (Contributed by Jeff Hankins,
       21-Jan-2010.)  (Proof shortened by Mario Carneiro, 11-Sep-2015.) $)
    lfinpfin $p |- ( A e. ( LocFin ` J ) -> A e. PtFin ) $=
      ( vx vs vn clocfin cfv wcel cptfin cv crab cfn cuni wral wa cin c0 expcom
      eqid wi wne locfinbas eleq2d biimpar locfinnei syldan wss inelcm ad2antlr
      wrex ss2rabdv ssfi syl expimpd rexlimdvw mpd ralrimiva isptfin mpbird ) A
      BFGZHZAIHCJZDJZHZDAKZLHZCAMZNVAVFCVGVAVBVGHZOZVBEJZHZVCVJPQUAZDAKZLHZOZEB
      UJZVFVAVHVBBMZHZVPVAVRVHVAVQVGVBABVQVGVQSZVGSZUBUCUDAVBEBVQDVSUEUFVIVOVFE
      BVIVKVNVFVIVKOZVEVMUGZVNVFTWAVDVLDAVKVDVLTVIVCAHVDVKVLVBVCVJUHRUIUKVNWBVF
      VMVEULRUMUNUOUPUQCDAUTVGVTURUS $.
  $}

  ${
    $d c o s x y C $.  $d c o s x y J $.  $d o s x y X $.
    locfincmp.1 $e |- X = U. J $.
    locfincmp.2 $e |- Y = U. C $.
    $( For a compact space, the locally finite covers are precisely the finite
       covers.  Sadly, this property does not properly characterize all compact
       spaces.  (Contributed by Jeff Hankins, 22-Jan-2010.)  (Proof shortened
       by Mario Carneiro, 11-Sep-2015.) $)
    locfincmp $p |- ( J e. Comp ->
        ( C e. ( LocFin ` J ) <-> ( C e. Fin /\ X = Y ) ) ) $=
      ( vc vs vo vx vy wcel cfn wceq wa c0 wss cv wrex wel ccmp clocfin cfv csn
      cdif cun cuni cin wne crab wral cpw locfinnei ralrimiva cmpcov2 sylan2 wi
      elfpw ciun simplrr wex elunii syl6eleqr ancoms adantl locfinbas ad3antrrr
      eldifsn eleqtrrd simplr eleqtrd eluni2 sylib simplrl simprr syl2anc ineq1
      inelcm neeq1d elrab sylanbrc expr reximdva mpd exlimdv n0 3imtr4g expimpd
      eliun syl5bi ssrdv ssfi expcom sylan9 sylan2b rexlimdva snfi unfi sylancl
      iunfi ssun1 undif1 sseqtr4i jca ctop cmptop finlocfin 3expib syl impbid
      ex ) BUALZABUBUCLZAMLZCDNZOZXLXMXPXLXMOZXNXOXQAPUDZUEZXRUFZMLZAXTQXNXQXSM
      LZXRMLYAXQCGRZUGZNZHRZIRZUHZPUIZHAUJZMLZIYCUKZOZGBULMUHZSZYBXMXLJITYKOIBS
      ZJCUKYOXMYPJCAJRZIBCHEUMUNYKJIBCGEUOUPXQYMYBGYNYCYNLXQYCBQZYCMLZOZYMYBUQY
      CBURXQYTOZYEYLYBUUAYEOZYSXSIYCYJUSZQZYLYBUQXQYRYSYEUTUUBJXSUUCYQXSLYQALZY
      QPUIZOUUBYQUUCLZYQAPVHUUBUUEUUFUUGUUBUUEOZKJTZKVAYQYJLZIYCSZUUFUUGUUHUUIU
      UKKUUBUUEUUIUUKUUBUUEUUIOZOZKITZIYCSZUUKUUMKRZYDLUUOUUMUUPCYDUUMUUPDCUULU
      UPDLZUUBUUIUUEUUQUUIUUEOUUPAUGDUUPYQAVBFVCVDVEXQXOYTYEUULXMXOXLABCDEFVFVE
      ZVGVIUUAYEUULVJVKIUUPYCVLVMUUMUUNUUJIYCUUMIGTZUUNUUJUUMUUSUUNOZOZUUEYQYGU
      HZPUIZUUJUUBUUEUUIUUTVNUVAUUIUUNUVCUUBUUEUUIUUTUTUUMUUSUUNVOUUPYQYGVRVPYI
      UVCHYQAYFYQNYHUVBPYFYQYGVQVSVTWAWBWCWDWBWEKYQWFIYQYCYJWIWGWHWJWKYSYLUUCML
      ZUUDYBYSYLUVDIYCYJWTXKUVDUUDYBUUCXSWLWMWNVPWHWOWPWDPWQXSXRWRWSAAXRUFXTAXR
      XAAXRXBXCXTAWLWSUURXDXKXLBXELZXPXMUQBXFUVEXNXOXMABCDEFXGXHXIXJ $.
  $}

  ${
    $d s x y C $.  $d x y X $.  $d s x Y $.
    locfindis.1 $e |- Y = U. C $.
    $( The locally finite covers of a discrete space are precisely the
       point-finite covers.  (Contributed by Jeff Hankins, 22-Jan-2010.)
       (Proof shortened by Mario Carneiro, 11-Sep-2015.) $)
    locfindis $p |- ( C e. ( LocFin ` ~P X ) <-> ( C e. PtFin /\ X = Y ) ) $=
      ( vx vy vs wcel cptfin wceq wa cuni cv cin c0 wne crab cfn cvv adantl cpw
      clocfin cfv lfinpfin unipw eqcomi locfinbas ctop wrex wral simpr syl5eqel
      jca uniexg adantr eqeltrd distop syl snelpwi snidg simpll eleq2d ptfinfin
      csn biimpa syl2anc eleq2 neeq1d disjsn necon2abii syl6bbr rabbidv anbi12d
      ineq2 eleq1d rspcev syl12anc ralrimiva islocfin syl3anbrc impbii ) ABUAZU
      BUCHZAIHZBCJZKZWCWDWEAWBUDAWBBCWBLBBUEUFZDUGUMWFWBUHHZWEEMZFMZHZGMZWJNZOP
      ZGAQZRHZKZFWBUIZEBUJWCWFBSHWHWFBCSWDWEUKZWDCSHWEWDCALSDAIUNULUOUPBSUQURWS
      WFWREBWFWIBHZKZWIVDZWBHZWIXBHZWIWLHZGAQZRHZWRWTXCWFWIBUSTWTXDWFWIBUTTXAWD
      WICHZXGWDWEWTVAWFWTXHWFBCWIWSVBVEGAWICDVCVFWQXDXGKFXBWBWJXBJZWKXDWPXGWJXB
      WIVGXIWOXFRXIWNXEGAXIWNWLXBNZOPXEXIWMXJOWJXBWLVNVHXEXJOWLWIVIVJVKVLVOVMVP
      VQVREAFWBBCGWGDVSVTWA $.
  $}

  ${
    $d n s x y J $.  $d n x y K $.  $d n s x y X $.
    locfincf.1 $e |- X = U. J $.
    $( A locally finite cover in a coarser topology is locally finite in a
       finer topology.  (Contributed by Jeff Hankins, 22-Jan-2010.)  (Proof
       shortened by Mario Carneiro, 11-Sep-2015.) $)
    locfincf $p |- ( ( K e. ( TopOn ` X ) /\ J C_ K ) ->
      ( LocFin ` J ) C_ ( LocFin ` K ) ) $=
      ( vx vy vn vs cfv wcel wa clocfin cv cuni wceq wrex ad2antrr eqid adantl
      ex ctopon wss ctop cin c0 wne crab cfn topontop toponuni locfinbas eqtr3d
      wral eleq2d locfinnei wi ssrexv sylan9r ralrimiv islocfin syl3anbrc ssrdv
      sylbird ) BCUAIJZABUBZKZEALIZBLIZVFEMZVGJZVIVHJZVFVJKZBUCJZBNZVINZOFMZGMZ
      JHMVQUDUEUFHVIUGUHJKZGBPZFVNUMVKVDVMVEVJCBUIQVLCVNVOVDCVNOVEVJCBUJQZVJCVO
      OVFVIACVODVORZUKSULVLVSFVNVLVPVNJVPCJZVSVLCVNVPVTUNVJWBVRGAPZVFVSVJWBWCVI
      VPGACHDUOTVEWCVSUPVDVRGABUQSURVCUSFVIGBVNVOHVNRWAUTVATVB $.
  $}

  ${
    $d a b c d f p q s t x y z J $.  $d a b c d f p q s t x y z X $.
    comppfsc.1 $e |- X = U. J $.
    $( A space where every open cover has a point-finite subcover is compact.
       This is significant in part because it shows half of the proposition
       that if only half the generalization in the definition of
       metacompactness (and consequently paracompactness) is performed, one
       does not obtain any more spaces.  (Contributed by Jeff Hankins,
       21-Jan-2010.)  (Proof shortened by Mario Carneiro, 11-Sep-2015.) $)
    comppfsc $p |- ( J e. Top -> ( J e. Comp <->
      A. c e. ~P J ( X = U. c -> E. d e. PtFin ( d C_ c /\ X = U. d ) ) ) ) $=
      ( vs vp vz vq wcel cv cuni wceq wss wa wi wral cfn syl c0 va vb ctop ccmp
      vx vf cptfin wrex cpw elpwi w3a cin cmpcov elfpw finptfin anassrs ancom1s
      anim1i sylanb reximi2 3exp syl5 ralrimiv 0elpw 0fin mpbir2an unieq syl6eq
      elin uni0 eqeq2d rspcev mpan a1i13 wne wex wel simp2 eleq2d biimpd eluni2
      syl6ib cun cmpt crn ciun simpl3 simprl sseldd elssuni syl6sseqr ralrimivw
      n0 iunss sylibr ssequn1 sylib simpl2 uniiun uneq2d eqtr3d vex unex dfiun3
      iunun eqtr3i wf simpll1 adantr sselda unopn syl3anc eqid fmptd frn elpw2g
      3ad2ant1 mpbird sseq2 anbi1d rexbidv imbi12d rspcv mpid crab simprr ssel2
      syl2anc expcom ad2antll cvv rgenw ax-mp ad2antrr snssd unssd exlimdv syld
      wb ex 3ad2antl3 adantrr elunii syl6eleqr eleqtrd ptfinfin ralrnmpt ssralv
      elun1 eleq2 sylc rabid2 eleq1d biimprd cfv cab rnmpt ssabral uneq2 ac6sfi
      syl6sseq csn wfo wfn simprrl ffn dffn4 fofi snfi sylancl sylanbrc simplrr
      unfi simprrr iuneq2 syl5eq eqtrd ssun2 snid sselii fvssunirn ssun1 unissi
      sstri unssi mpbir syl6eqss sstrd uniss eqssd expr mpdd 3syld com23 syl5bi
      rexlimdv rexlimdvaa pm2.61dne syl3an3 com24 ralrimdv iscmp sylibd impbid2
      baibr ) AUCJZAUDJZBCKZLZMZDKZUXHNZBUXKLZMZOZDUGUHZPZCAUIZQZUXGUXQCUXRUXHU
      XRJUXHANZUXGUXQUXHAUJUXGUXTUXJUXPUXGUXTUXJUKUXNDUXHUIRULZUHUXPUXHABDEUMUX
      NUXODUYAUGUXKUYAJUXLUXKRJZOUXNUXKUGJZUXOOZUXKUXHUNUYBUXLUXNUYDUYBUXLUXNUY
      DUYBUYCUXOUXKUOURUPUQUSUTSVAVBVCUXFUXSBUAKZLZMZBUBKZLZMZUBUYEUIZRULZUHZPZ
      UAUXRQZUXGUXFUXSUYNUAUXRUXFUYGUYEUXRJZUXSUYMUXFUYGUYPUXSUYMPZUYPUXFUYGUYE
      ANZUYQUYEAUJUXFUYGUYRUKZUYQBTUYSBTMZUXSUYMTUYLJZUYTUYMVUATUYKJTRJUYEVDVET
      UYKRVIVFUYJUYTUBTUYLUYHTMZUYITBVUBUYITLTUYHTVGVJVHVKVLVMVNBTVOUEKZBJZUEVP
      UYSUYQUEBWMUYSVUDUYQUEUYSVUDUEFVQZFUYEUHZUYQUYSVUDVUCUYFJZVUFUYSVUDVUGUYS
      BUYFVUCUXFUYGUYRVRVSVTFVUCUYEWAWBUYSVUEUYQFUYEUYSFUAVQZVUEOZOZUXSUXKGUYEF
      KZGKZWCZWDZWEZNZUXNOZDUGUHZUYMVUJUXSBVUOLZMZVURVUJBGUYEVUKWFZGUYEVULWFZWC
      ZVUSVUJVVABWCZBVVCVUJVVABNZVVDBMVUJVUKBNZGUYEQVVEVUJVVFGUYEVUJVUKAJZVVFVU
      JUYEAVUKUXFUYGUYRVUIWGZUYSVUHVUEWHZWIZVVGVUKALZBVUKAWJEWKSWLGUYEVUKBWNWOV
      VABWPWQVUJBVVBVVAVUJBUYFVVBUXFUYGUYRVUIWRGUYEWSVHWTXAGUYEVUMWFVVCVUSGUYEV
      UKVULXEGUYEVUMVUKVULFXBZGXBXCZXDXFVHVUJVUOUXRJZUXSVUTVURPZPVUJVVNVUOANZVU
      JUYEAVUNXGVVPVUJGUYEVUMAVUNVUJGUAVQZOUXFVVGVULAJVUMAJUXFUYGUYRVUIVVQXHVUJ
      VVGVVQVVJXIVUJUYEAVULVVHXJVUKVULAXKXLVUNXMZXNUYEAVUNXOSUYSVVNVVPYSZVUIUXF
      UYGVVSUYRVUOAUCXPXQXIXRUXQVVOCVUOUXRUXHVUOMZUXJVUTUXPVURVVTUXIVUSBUXHVUOV
      GVKVVTUXOVUQDUGVVTUXLVUPUXNUXHVUOUXKXSXTYAYBYCSYDVUJVUQUYMDUGVUJVUQUYCUYM
      VUJVUQUYCUYMPVUJVUQOZUYCUEHVQZHUXKYEZRJZUYBUYMVWAVUCUXMJZUYCVWDPVWAVUCBUX
      MVUJVUDVUQVUJVUCVVKBVUJVUEVVGVUCVVKJUYSVUHVUEYFUYSVUHVVGVUEUYRUXFVUHVVGUY
      GUYEAVUKYGUUAUUBVUCVUKAUUCYHEUUDXIVUJVUPUXNYFUUEUYCVWEVWDHUXKVUCUXMUXMXMU
      UFYISVWAUYBVWDVWAUXKVWCRVWAVWBHUXKQZUXKVWCMVWAVUPVWBHVUOQZVWFVUJVUPUXNWHZ
      VUJVWGVUQVUJVUCVUMJZGUYEQZVWGVUJVWIGUYEVUEVWIUYSVUHVUCVUKVULUUIYJWLVUMYKJ
      ZGUYEQVWGVWJYSVWKGUYEVVMYLVWBVWIGHUYEVUMVUNYKVVRHKVUMVUCUUJUUGYMWOXIVWBHU
      XKVUOUUHUUKVWBHUXKUULWOUUMUUNVWAUYBUXKUYEUFKZXGZIKZVUKVWNVWLUUOZWCZMZIUXK
      QZOZUFVPZUYMVWAVWNVUMMZGUYEUHZIUXKQZUYBVWTPVWAUXKVXBIUUPZNVXCVWAUXKVUOVXD
      VWHGIUYEVUMVUNVVRUUQUVAVXBIUXKUURWQUYBVXCVWTVXAVWQIGUXKUYEUFVULVWOMVUMVWP
      VWNVULVWOVUKUUSVKUUTYISVWAUYBVWTUYMPVWAUYBOVWSUYMUFVWAUYBVWSUYMVWAUYBVWSO
      ZOZVWLWEZVUKUVBZWCZUYLJZBVXILZMZUYMVXFVXIUYENVXIRJZVXJVXFVXGVXHUYEVWSVXGU
      YENZVWAUYBVWMVXNVWRUXKUYEVWLXOXIYJZVXFVUKUYEVUJVUHVUQVXEVVIYNYOYPVXFVXGRJ
      ZVXHRJVXMVXFUYBUXKVXGVWLUVCZVXPVWAUYBVWSWHVXFVWLUXKUVDZVXQVXFVWMVXRVWAUYB
      VWMVWRUVEUXKUYEVWLUVFSUXKVWLUVGWQUXKVXGVWLUVHYHVUKUVIVXGVXHUVMUVJVXIUYEUN
      UVKVXFBVXKVXFBIUXKVWPWFZVXKVXFBUXMVXSVUJVUPUXNVXEUVLVXFUXMIUXKVWNWFZVXSIU
      XKWSVXFVWRVXTVXSMVWAUYBVWMVWRUVNIUXKVWNVWPUVOSUVPUVQVXSVXKNVWPVXKNZIUXKQV
      YAIUXKVUKVWOVXKVUKVXIJVUKVXKNVXHVXIVUKVXHVXGUVRVUKVVLUVSUVTVUKVXIWJYMVWOV
      XGLVXKVWLVWNUWAVXGVXIVXGVXHUWBUWCUWDUWEYLIUXKVWPVXKWNUWFUWGVXFVXIANZVXKBN
      VXFVXGVXHAVXFVXGUYEAVXOVUJUYRVUQVXEVVHYNUWHVXFVUKAVUJVVGVUQVXEVVJYNYOYPVY
      BVXKVVKBVXIAUWIEWKSUWJUYJVXLUBVXIUYLUYHVXIMUYIVXKBUYHVXIVGVKVLYHUWKYQYTUW
      LUWMYTUWNUWPYRUWQYRYQUWOUWRUWSVAUWTUXAUXGUXFUYOUAUBABEUXBUXEUXCUXD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Neighborhood bases determine topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f k n t v y z G $.  $d j n s u v x y z J $.  $d f o s t u v w x y z P $.
    $d f k o s t u v w x y z N $.  $d f k o t u v x y S $.  $d f k n x y z U $.
    $d a b f g j k n o s t u v w x y z F $.  $d f j k n o s t v w x y z ph $.
    $d a b f g j k n o s t u v w x y z X $.
    neibastop1.1 $e |- ( ph -> X e. V ) $.
    neibastop1.2 $e |- ( ph -> F : X --> ( ~P ~P X \ { (/) } ) ) $.
    neibastop1.3 $e |- ( ( ph /\ ( x e. X /\ v e. ( F ` x ) /\
      w e. ( F ` x ) ) ) -> ( ( F ` x ) i^i ~P ( v i^i w ) ) =/= (/) ) $.
    neibastop1.4 $e |- J = { o e. ~P X |
      A. x e. o ( ( F ` x ) i^i ~P o ) =/= (/) } $.
    $( A collection of neighborhood bases determines a topology.  Part of
       Theorem 4.5 of Stephen Willard's _General Topology_.  (Contributed by
       Jeff Hankins, 8-Sep-2009.)  (Proof shortened by Mario Carneiro,
       11-Sep-2015.) $)
    neibastop1 $p |- ( ph -> J e. ( TopOn ` X ) ) $=
      ( vy wcel wss cin wral wa c0 vz ctop cuni wceq ctopon cfv cv wi wal simpr
      cpw wne crab ssrab2 eqsstri syl6ss sspwuni sylib uniex elpw sylibr eluni2
      vex wrex elssuni ad2antrl sspwb syl sselda adantrr weq pweq ineq2d neeq1d
      sslin raleqbi1dv elrab2 simprbi simprr rsp sylc syl2anc rexlimdvaa syl5bi
      ssn0 ralrimiv sylanbrc alrimiv anbi12i an4 bitri inss1 elpwi syl5ss inex1
      ex ssralv ax-mp inss2 anim12i r19.26 wex eeanv simprl sseldi elpwid ss2in
      n0 simplll ad2antrr simplr sseldd syl13anc exlimdvv syl5bir ralimdva syl5
      impr sylan2b ralrimivva cvv wb mpbi a1i ssexd uniexb istopg mpbir2and csn
      pwidg cdif ffvelrnda eldifi 3syl df-ss eldifsni eqnetrd ralrimiva istopon
      eqssd ) AGUBOZIGUCZUDGIUEUFOAUUANUGZGPZUUCUCZGOZUHZNUIZUUCUAUGZQZGOZUAGRN
      GRZAUUGNAUUDUUFAUUDSZUUEIUKZOZBUGZFUFZUUEUKZQZTULZBUUERZUUFUUMUUEIPZUUOUU
      MUUCUUNPUVBUUMUUCGUUNAUUDUJZGUUQEUGZUKZQZTULZBUVDRZEUUNUMUUNMUVHEUUNUNUOZ
      UPUUCIUQURUUEIUUCNVCZUSUTVAUUMUUTBUUEUUPUUEOUUPUUIOZUAUUCVDUUMUUTUAUUPUUC
      VBUUMUVKUUTUAUUCUUMUUIUUCOZUVKSSZUUQUUIUKZQZUUSPZUVOTULZUUTUVMUVNUURPZUVP
      UVMUUIUUEPZUVRUVLUVSUUMUVKUUIUUCVEVFUUIUUEVGURUVNUURUUQVOVHUVMUVQBUUIRZUV
      KUVQUVMUUIGOZUVTUUMUVLUWAUVKUUMUUCGUUIUVCVIVJUWAUUIUUNOZUVTUVHUVTEUUIUUNG
      UVGUVQBUVDUUIEUAVKZUVFUVOTUWCUVEUVNUUQUVDUUIVLVMVNVPMVQZVRVHUUMUVLUVKVSUV
      QBUUIVTWAUVOUUSWEWBWCWDWFUVHUVAEUUEUUNGUVGUUTBUVDUUEUVDUUEUDZUVFUUSTUWEUV
      EUURUUQUVDUUEVLVMVNVPMVQWGWPWHAUUKNUAGGUUCGOZUWASZAUUCUUNOZUWBSZUUQUUCUKZ
      QZTULZBUUCRZUVTSZSZUUKUWGUWHUWMSZUWBUVTSZSUWOUWFUWPUWAUWQUVHUWMEUUCUUNGUV
      GUWLBUVDUUCENVKZUVFUWKTUWRUVEUWJUUQUVDUUCVLVMVNVPMVQUWDWIUWHUWMUWBUVTWJWK
      AUWOSZUUJUUNOZUUQUUJUKZQZTULZBUUJRZUUKUWSUUJIPZUWTAUWIUXEUWNUWHUXEAUWBUWH
      UUJUUCIUUCUUIWLZUUCIWMWNVFZVJUUJIUUCUUIUVJWOUTVAAUWIUWNUXDUWNUWLUVQSZBUUJ
      RZAUWISZUXDUWNUWLBUUJRZUVQBUUJRZSUXIUWMUXKUVTUXLUUJUUCPUWMUXKUHUXFUWLBUUJ
      UUCWQWRUUJUUIPUVTUXLUHUUCUUIWSUVQBUUJUUIWQWRWTUWLUVQBUUJXAVAUXJUXHUXCBUUJ
      UXHDUGZUWKOZDXBZCUGZUVOOZCXBZSZUXJUUPUUJOZSZUXCUWLUXOUVQUXRDUWKXHCUVOXHWI
      UXSUXNUXQSZCXBDXBUYAUXCUXNUXQDCXCUYAUYBUXCDCUYAUYBUXCUYAUYBSZUUQUXMUXPQZU
      KZQZUXBPZUYFTULZUXCUYCUYEUXAPZUYGUYCUYDUUJPZUYIUYCUXMUUCPUXPUUIPUYJUYCUXM
      UUCUYCUWKUWJUXMUUQUWJWSUYAUXNUXQXDZXEXFUYCUXPUUIUYCUVOUVNUXPUUQUVNWSUYAUX
      NUXQVSZXEXFUXMUUCUXPUUIXGWBUYDUUJVGURUYEUXAUUQVOVHUYCAUUPIOZUXMUUQOUXPUUQ
      OUYHAUWIUXTUYBXIUYCUUJIUUPUXJUXEUXTUYBUXGXJUXJUXTUYBXKXLUYCUWKUUQUXMUUQUW
      JWLUYKXEUYCUVOUUQUXPUUQUVNWLUYLXELXMUYFUXBWEWBWPXNXOWDXPXQXRUVHUXDEUUJUUN
      GUVGUXCBUVDUUJUVDUUJUDZUVFUXBTUYNUVEUXAUUQUVDUUJVLVMVNVPMVQWGXSXTAGYAOZUU
      AUUHUULSYBAUUBYAOUYOAUUBIHJUUBIPZAGUUNPUYPUVIGIUQYCYDZYEGYFVANUAYAGYGVHYH
      AIUUBAIGOZIUUBPAIUUNOZUUQUUNQZTULZBIRZUYRAIHOUYSJIHYJVHAVUABIAUYMSZUYTUUQ
      TVUCUUQUUNPZUYTUUQUDVUCUUQUUNUKZTYIZYKZOZUUQVUEOVUDAIVUGUUPFKYLZUUQVUEVUF
      YMUUQUUNWMYNUUQUUNYOURVUCVUHUUQTULVUIUUQVUETYPVHYQYRUVHVUBEIUUNGUVGVUABUV
      DIUVDIUDZUVFUYTTVUJUVEUUNUUQUVDIVLVMVNVPMVQWGIGVEVHUYQYTIGYSWG $.

    neibastop1.5 $e |- ( ( ph /\ ( x e. X /\ v e. ( F ` x ) ) ) -> x e. v ) $.
    neibastop1.6 $e |- ( ( ph /\ ( x e. X /\ v e. ( F ` x ) ) ) ->
      E. t e. ( F ` x ) A. y e. t ( ( F ` y ) i^i ~P v ) =/= (/) ) $.
    ${
      neibastop2.p $e |- ( ph -> P e. X ) $.
      neibastop2.n $e |- ( ph -> N C_ X ) $.
      neibastop2.f $e |- ( ph -> U e. ( F ` P ) ) $.
      neibastop2.u $e |- ( ph -> U C_ N ) $.
      neibastop2.g $e |- G = ( rec ( ( a e. _V |-> U_ z e. a U_ x e. X
        ( ( F ` x ) i^i ~P z ) ) , { U } ) |` om ) $.
      neibastop2.s $e |- S = { y e. X |
        E. f e. U. ran G ( ( F ` y ) i^i ~P f ) =/= (/) } $.
      $( Lemma for ~ neibastop2 .  (Contributed by Jeff Hankins,
         12-Sep-2009.) $)
      neibastop2lem $p |- ( ph -> E. u e. J ( P e. u /\ u C_ N ) ) $=
        ( vk vn wcel wss cv wa wrex cpw cfv cin c0 wne wral cuni ssrab2 eqsstri
        crn crab wb elpw2g syl mpbiri weq fveq2 ineq1d neeq1d rexbidv elrab2 wi
        com wfn cvv ciun cmpt csn crdg frfnom fneq1i mpbir fnunirn ax-mp wex n0
        cres inss1 sseli anassrs simprl wel fvssunirn wf sspwuni sylib ad2antrr
        frn syl5ss sselda elpwid adantrr eliun pweq ineq2d eleq2d rspcev sylibr
        wceq sseq1d adantr adantl iunss ralrimiva iuneq1 expr ralrimiv syl12anc
        syl2anc elpw fnfvelrn elunii sylanbrc impr inelcm syl5bi rexlimdv eleq2
        exlimdv ad3antrrr sseldd sylan2 adantrl cdif difss2d csuc rspe ad2ant2l
        simprlr syl5bb simpll simprll fveq1i snex fr0g eqtri syl6eq pwidg snssd
        pwexg inss2 elpwi sspwb ralrimivw ssralv mpan9 frsucmpt2 eqsstrd expcom
        ssexd finds2 syl6ibr com12 ffnfv mpbiran eleqtrrd peano2 sylancr simprr
        fvex rabeq2i ralimdva dfss3 vex rexlimddv rexlimdvaa expimpd raleqbi1dv
        snidg peano1 mp2an eqeltrri sylancl eluni2 rexrn ffvelrnda elin simprrr
        sstrd simpllr simprrl elequ1 imbi12d rspcv syl3c exp32 rexlimdva 3impia
        rabssdv syl5eqss sseq1 anbi12d ) AJPUOZIJUOZJQUPZIGUQZUOZUXOQUPZURZGPUS
        AJSUTZUOZBUQZNVAZJUTZVBZVCVDZBJVEZUXLAUXTJSUPZJCUQZNVAZLUQZUTZVBZVCVDZL
        OVIZVFZUSZCSVJZSULUYPCSVGVHASRUOUXTUYGVKUAJSRVLVMVNAUYEBJUYAJUOUYASUOZU
        YBUYKVBZVCVDZLUYOUSZURAUYEUYPVUACUYASJCBVOZUYMUYTLUYOVUBUYLUYSVCVUBUYIU
        YBUYKUYHUYANVPVQVRVSULVTAUYRVUAUYEAUYRURZUYTUYELUYOUYJUYOUOZUYJUMUQZOVA
        ZUOZUMWBUSZVUCUYTUYEWAZOWBWCZVUDVUHVKVUJTWDDTUQZBSUYBDUQZUTZVBZWEZWEZWF
        ZKWGZWHWBWPZWBWCVURVUQWIWBOVUSUKWJWKZUMUYJOWBWLWMVUCVUGVUIUMWBUYTFUQZUY
        SUOZFWNVUCVUEWBUOZVUGURZURZUYEFUYSWOVVEVVBUYEFVUCVVDVVBUYEVUCVVDVVBURZU
        RZUYIVVAUTZVBZVCVDZCHUQZVEZUYEHUYBVUCVVBVVLHUYBUSZVVDVVBVUCVVAUYBUOZVVM
        UYSUYBVVAUYBUYKWQWRAUYRVVNVVMUFWSUUAUUBVVGVVKUYBUOZVVLURURZVVOVVKUYCUOZ
        UYEVVGVVOVVLWTVVPVVKJUPZVVQVVPUYHJUOZCVVKVEZVVRVVGVVOVVLVVTVVGVVOURZVVJ
        VVSCVVKVWACHXAZVVJVVSVWAVWBVVJURZURZUYHSUOZUYPVVSVWAVWBVWEVVJVWAVVKSUYH
        VWAVVKSVVGUYBUXSVVKVVGUYBNVIZVFZUXSNUYAXBAVWGUXSUPZUYRVVFAVWFUXSUTZUPVW
        HAVWFVWIVCWGZASVWIVWJUUCZNXCVWFVWKUPUBSVWKNXGVMUUDVWFUXSXDXEXFXHXIXJXIX
        KVWDVVAUYOUOZVVJUYPVVGVWLVVOVWCVVGVVAVUEUUEZOVAZUOVWNUYNUOZVWLVVGVVADVU
        FVUOWEZVWNVVGVVAVUOUOZDVUFUSZVVAVWPUOVVGVUGVVBBSUSZVWRVUCVVCVUGVVBUUHUY
        RVVBVWSAVVDVVBBSUUFUUGVWQVWSDUYJVUFVWQVVAVUNUOZBSUSDLVOZVWSBVVASVUNXLVX
        AVWTVVBBSVXAVUNUYSVVAVXAVUMUYKUYBVULUYJXMXNXOVSUUIXPYHDVVAVUFVUOXLXQVVG
        AVVCVUFKUTZUPZVWNVWPXRZAUYRVVFUUJVUCVVCVUGVVBUUKZVVGVUFUYOVXBOVUEXBAUYO
        VXBUPZUYRVVFAUYNVXBUTZUPZVXFAWBVXGOXCZVXHAUNUQZOVAZVXGUOZUNWBVEZVXIAVXL
        UNWBVXJWBUOZAVXLVXNAVXKVXBUPZVXLVXOVURVXBUPVXCVWNVXBUPZAUNUMVXJVCXRZVXK
        VURVXBVXQVXKVCOVAZVURVXJVCOVPVXRVCVUSVAZVURVCOVUSUKUULVURWDUOVXSVURXRKU
        UMVURWDVUQUUNWMUUOZUUPXSUNUMVOVXKVUFVXBVXJVUEOVPXSVXJVWMXRVXKVWNVXBVXJV
        WMOVPXSAKVXBAKINVAZUOZKVXBUOZUIKVYAUUQVMZUURAVVCVXCVXPWAAVVCVXCVXPAVVCV
        XCURZURZVWNVWPVXBVYFVVCVWPWDUOVXDAVVCVXCWTVYFVWPVXBWDVYFVYBVXBWDUOAVYBV
        YEUIXTKVYAUUSVMVYFVUOVXBUPZDVUFVEZVWPVXBUPAVYGDVXBVEZVYEVYHAVYGDVXBAVUL
        VXBUOZURZVUNVXBUPZBSVEVYGVYKVYLBSVYKVUNVUMVXBUYBVUMUUTVYKVULKUPZVUMVXBU
        PVYJVYMAVULKUVAYAVULKUVBXEXHUVCBSVUNVXBYBXQYCVXCVYIVYHWAVVCVYGDVUFVXBUV
        DYAUVEDVUFVUOVXBYBXQZUVITCVURVUEVUPVWPDUYHVUOWEOWDUKDUYHVUKVUOYDDUYHVUF
        VUOYDUVFYHZVYNUVGYEUVHUVJVXKVXBVXJOUVSYIUVKUVLYFVXIVUJVXMVUTUNWBVXGOUVM
        UVNXQZWBVXGOXGVMUYNVXBXDXEXFXHVYOYGUVOVVGVUJVWMWBUOZVWOVUTVVGVVCVYQVXEV
        UEUVPVMWBVWMOYJUVQVVAVWNUYNYKYHXFVWAVWBVVJUVRUYMVVJLVVAUYOLFVOZUYLVVIVC
        VYRUYKVVHUYIUYJVVAXMXNVRXPYHUYPCJSULUVTYLYEUWAYMCVVKJUWBXQVVKJHUWCYIXQV
        VKUYBUYCYNYHUWDYEYRYOUWEYOYPUWFYOYFUYBMUQZUTZVBZVCVDZBVYSVEUYFMJUXSPWUB
        UYEBVYSJVYSJXRZWUAUYDVCWUCVYTUYCUYBVYSJXMXNVRUWGUDVTYLAISUOVYAUYKVBZVCV
        DZLUYOUSZUXMUGAKUYOUOZVYAVXBVBZVCVDZWUFAKVURUOZVURUYNUOWUGAVYBWUJUIKVYA
        UWHVMVXRVURUYNVXTVUJVCWBUOVXRUYNUOVUTUWIWBVCOYJUWJUWKKVURUYNYKUWLAVYBVY
        CWUIUIVYDKVYAVXBYNYHWUEWUILKUYOUYJKXRZWUDWUHVCWUKUYKVXBVYAUYJKXMXNVRXPY
        HUYPWUFCISJUYHIXRZUYMWUELUYOWULUYLWUDVCWULUYIVYAUYKUYHINVPVQVRVSULVTYLA
        JUYQQULAUYPCSQAVWEUYPUYHQUOZAVWEURZUYMWUMLUYOVUDLDXAZDUYNUSZWUNUYMWUMWA
        ZDUYJUYNUWMWUPVUHWUNWUQVUJWUPVUHVKVUTWUOVUGDUMWBOVULVUFUYJYQUWNWMWUNVUG
        WUQUMWBWUNVVCURZVUGUYMWUMWURVUGUYMURZURZUYJQUYHWUTUYJKQWUTUYJKWURVUGUYJ
        VXBUOUYMWURVUFVXBUYJWURVUFVXBWUNWBVXGVUEOAVXIVWEVYPXTUWOXJXIXKXJAKQUPVW
        EVVCWUSUJYSUWRWURVUGUYMCLXAZUYMVVAUYLUOZFWNWURVUGURZWVAFUYLWOWVCWVBWVAF
        WVBVVAUYIUOZVVAUYKUOZURZWVCWVAVVAUYIUYKUWPWURVUGWVFWVAWURVUGWVFURZURZVV
        AUYJUYHWVHVVAUYJWURVUGWVDWVEUWQXJWVHVWEVVNBFXAZWAZBSVEZWVDCFXAZAVWEVVCW
        VGUWSAWVKVWEVVCWVGAWVJBSAUYRVVNWVIUEYEYCYSWURVUGWVDWVEUWTWVJWVDWVLWABUY
        HSBCVOZVVNWVDWVIWVLWVMUYBUYIVVAUYAUYHNVPXOBCFUXAUXBUXCUXDYTYEYOYRYOYMYT
        UXEUXFYOYOYPUXGUXHUXIUXRUXMUXNURGJPUXOJXRUXPUXMUXQUXNUXOJIYQUXOJQUXJUXK
        XPYG $.
    $}

    $( In the topology generated by a neighborhood base, a set is a
       neighborhood of a point iff it contains a subset in the base.
       (Contributed by Jeff Hankins, 9-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 11-Sep-2015.) $)
    neibastop2 $p |- ( ( ph /\ P e. X ) -> ( N e. ( ( nei ` J ) ` { P } ) <->
        ( N C_ X /\ ( ( F ` P ) i^i ~P N ) =/= (/) ) ) ) $=
      ( wcel vs vu vz vg va vb vn vf wa csn cnei cfv wss cpw cin c0 cuni ctopon
      wne ctop neibastop1 topontop syl adantr eqid neii1 wceq toponuni ad2antrr
      sylan sseqtr4d cv wrex neii2 wral wi pweq ineq2d neeq1d raleqbi1dv elrab2
      weq simprrr sspwb sylib sslin wb snssg ad3antlr mpbird fveq2 ineq1d rspcv
      simprrl ssn0 ee12an expr com23 expimpd syl5bi rexlimdv mpd jca ex n0 elin
      wex simprl sseqtrd cvv ciun cmpt crdg com cres crab cdif wf simpll simplr
      crn w3a elpwid cbviunv iuneq2d syl5eq mpteq2i rdgeq1 ax-mp reseq1i syl5bb
      cbvrexv rexbidv cbvrabv neibastop2lem eleqtrd syl2anc mpbir2and exlimdv
      isneip impbid ) AGMTZUIZKGUJZJUKULULTZKMUMZGIULZKUNZUOZUPUSZUIZUUCUUEUUKU
      UCUUEUIZUUFUUJUULKJUQZMUUCJUTTZUUEKUUMUMZAUUNUUBAJMURULTZUUNABDEHIJLMNOPQ
      VAZMJVBVCZVDZUUDJKUUMUUMVEZVFVJAMUUMVGZUUBUUEAUUPUVAUUQMJVHVCZVIVKUULUUDC
      VLZUMZUVCKUMZUIZCJVMZUUJUUCUUNUUEUVGUUSUUDCJKVNVJUULUVFUUJCJUVCJTUVCMUNZT
      ZBVLZIULZUVCUNZUOZUPUSZBUVCVOZUIUULUVFUUJVPZUVKHVLZUNZUOZUPUSZBUVQVOUVOHU
      VCUVHJUVTUVNBUVQUVCHCWBZUVSUVMUPUWAUVRUVLUVKUVQUVCVQVRVSVTQWAUULUVIUVOUVP
      UULUVIUIUVFUVOUUJUULUVIUVFUVOUUJVPUULUVIUVFUIZUIZUUGUVLUOZUUIUMZUVOUWDUPU
      SZUUJUWCUVLUUHUMZUWEUWCUVEUWGUULUVIUVDUVEWCUVCKWDWEUVLUUHUUGWFVCUWCGUVCTZ
      UVOUWFVPUWCUWHUVDUULUVIUVDUVEWNUUBUWHUVDWGAUUEUWBGUVCMWHWIWJUVNUWFBGUVCUV
      JGVGZUVMUWDUPUWIUVKUUGUVLUVJGIWKWLVSWMVCUWDUUIWOWPWQWRWSWTXAXBXCXDUUCUUFU
      UJUUEUUJUAVLZUUITZUAXGUUCUUFUIZUUEUAUUIXEUWLUWKUUEUAUWKUWJUUGTZUWJUUHTZUI
      ZUWLUUEUWJUUGUUHXFUUCUUFUWOUUEUUCUUFUWOUIZUIZUUEUUOGUBVLZTUWRKUMUIUBJVMZU
      WQKMUUMUUCUUFUWOXHZAUVAUUBUWPUVBVIZXIUWQBCUCDEUBFGDVLZIULZUDVLZUNZUOZUPUS
      ZUDUEXJUFUEVLZUGMUGVLZIULZUFVLZUNZUOZXKZXKZXLZUWJUJZXMZXNXOZYAUQZVMZDMXPU
      WJUHHIUXSJKLMUEAMLTUUBUWPNVIAMUVHUNUPUJXQIXRUUBUWPOVIUWQAUVJMTZEVLZUVKTZU
      XBUVKTYBUVKUYCUXBUOUNUOUPUSAUUBUWPXSZPVJQUWQAUYBUYDUIZUVJUYCTUYERVJUWQAUY
      FUVCIULZUYCUNUOUPUSCFVLVOFUVKVMUYESVJAUUBUWPXTZUWTUUCUUFUWMUWNWNUWQUWJKUU
      CUUFUWMUWNWCYCUXRUEXJUCUXHBMUVKUCVLZUNZUOZXKZXKZXLZUXQXMZXNUXPUYNVGUXRUYO
      VGUEXJUXOUYMUFUCUXHUXNUYLUFUCWBZUXNBMUVKUXLUOZXKUYLUGBMUXMUYQUGBWBUXJUVKU
      XLUXIUVJIWKWLYDUYPBMUYQUYKUYPUXLUYJUVKUXKUYIVQVRYEYFYDYGUXQUXPUYNYHYIYJUY
      AUYGUHVLZUNZUOZUPUSZUHUXTVMZDCMUYAUXCUYSUOZUPUSZUHUXTVMDCWBZVUBUXGVUDUDUH
      UXTUDUHWBZUXFVUCUPVUFUXEUYSUXCUXDUYRVQVRVSYLVUEVUDVUAUHUXTVUEVUCUYTUPVUEU
      XCUYGUYSUXBUVCIWKWLVSYMYKYNYOUWQUUNGUUMTUUEUUOUWSUIWGAUUNUUBUWPUURVIUWQGM
      UUMUYHUXAYPGUBJKUUMUUTYTYQYRWQWTYSWTWSUUA $.

    $( The topology generated by a neighborhood base is unique.  (Contributed
       by Jeff Hankins, 16-Sep-2009.)  (Proof shortened by Mario Carneiro,
       11-Sep-2015.) $)
    neibastop3 $p |- ( ph -> E! j e. ( TopOn ` X )
      A. x e. X ( ( nei ` j ) ` { x } ) =
        { n e. ~P X | ( ( F ` x ) i^i ~P n ) =/= (/) } ) $=
      ( wcel vz cv ctopon cfv csn cnei cpw cin c0 wne crab wceq wral wa wreu wi
      weu wal neibastop1 cab wss neibastop2 elpw anbi1i syl6bbr abbi2dv syl6eqr
      df-rab ralrimiva sneq fveq2d ineq1d neeq1d rabbidv eqeq12d cbvralv sylibr
      vex fveq2 cuni toponuni eqimss2 sspwuni ad2antlr dfss1 sylib wrex ctop wb
      topontop ad3antlr eltop2 ssralv adantl simprr eleq2d sseq2d biimpa sylan2
      elpwi sselda adantrr adantr eqid isneip baibd syl21anc pweq ineq2d elrab3
      syl 3bitr3d expr ralimdva syld an32s ralbi bitrd rabbi2dva eqtr3d alrimiv
      imp expl eleq1 fveq1d eqeq1d ralbidv anbi12d eqeu syl121anc df-reu ) AGUB
      ZMUCUDZTZBUBZUEZYLUFUDZUDZYOJUDZHUBZUGZUHZUIUJZHMUGZUKZULZBMUMZUNZGUQZUUG
      GYMUOAKYMTZUUJYPKUFUDZUDZUUEULZBMUMZUUHYLKULZUPZGURUUIABDEIJKLMNOPQUSZUUQ
      AUAUBZUEZUUKUDZUURJUDZUUAUHZUIUJZHUUDUKZULZUAMUMUUNAUVEUAMAUURMTUNZUUTYTU
      UDTZUVCUNZHUTUVDUVFUVHHUUTUVFYTUUTTYTMVAZUVCUNUVHABCDEFUURIJKYTLMNOPQRSVB
      UVGUVIUVCYTMHVRVCVDVEVFUVCHUUDVHVGVIUUMUVEBUAMYOUURULZUULUUTUUEUVDUVJYPUU
      SUUKYOUURVJVKUVJUUCUVCHUUDUVJUUBUVBUIUVJYSUVAUUAYOUURJVSVLVMVNVOVPVQAUUPG
      AYNUUGUUOAYNUNZUUGUNZUUDYLUHZYLKUVLYLUUDVAZUVMYLULYNUVNAUUGYNYLVTZMVAZUVN
      YNMUVOULZUVPMYLWAZUVOMWBXKYLMWCVQWDYLUUDWEWFUVLUVMYSIUBZUGZUHZUIUJZBUVSUM
      ZIUUDUKKUVLUWCIUUDYLUVLUVSUUDTZUNZUVSYLTZYOUURTUURUVSVAUNUAYLWGZBUVSUMZUW
      CUWEYLWHTZUWFUWHWIYNUWIAUUGUWDMYLWJZWKBUAUVSYLWLXKUWEUWGUWBWIZBUVSUMZUWHU
      WCWIUVKUWDUUGUWLUVKUWDUNZUUGUWLUWMUUGUUFBUVSUMZUWLUWDUUGUWNUPZUVKUWDUVSMV
      AZUWOUVSMWTZUUFBUVSMWMXKWNUWMUUFUWKBUVSUWMYOUVSTZUUFUWKUWMUWRUUFUNZUNZUVS
      YRTZUVSUUETZUWGUWBUWTYRUUEUVSUWMUWRUUFWOWPUWTUWIYOUVOTZUVSUVOVAZUXAUWGWIY
      NUWIAUWDUWSUWJWKUWMUWRUXCUUFUWMUVSUVOYOUWDUVKUWPUXDUWQUVKUWPUXDUVKMUVOUVS
      YNUVQAUVRWNWQWRWSZXAXBUWMUXDUWSUXEXCUWIUXCUNUXAUXDUWGYOUAYLUVSUVOUVOXDXEX
      FXGUWDUXBUWBWIUVKUWSUUCUWBHUVSUUDYTUVSULZUUBUWAUIUXFUUAUVTYSYTUVSXHXIVMXJ
      WDXLXMXNXOYBXPUWGUWBBUVSXQXKXRXSQVGXTYCYAUUHUUJUUNUNGKYMUUOYNUUJUUGUUNYLK
      YMYDUUOUUFUUMBMUUOYRUULUUEUUOYPYQUUKYLKUFVSYEYFYGYHYIYJUUGGYMYKVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Lattice structure of topologies
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t y A $.  $d j k t x y S $.  $d j k t x V $.  $d j k t x y X $.
    $d t x T $.
    $( The meet of a collection of topologies on ` X ` is again a topology on
       ` X ` .  (Contributed by Jeff Hankins, 5-Oct-2009.)  (Proof shortened by
       Mario Carneiro, 12-Sep-2015.) $)
    topmtcl $p |- ( ( X e. V /\ S C_ ( TopOn ` X ) ) ->
      ( ~P X i^i |^| S ) e. ( TopOn ` X ) ) $=
      ( wcel ctopon cfv cpw cmre wss cint cin toponmre mrerintcl sylan ) CBDCEF
      ZCGZHFDAOIPAJKODCBLOAPMN $.

    $( Two equivalent formulations of the meet of a collection of topologies.
       (Contributed by Jeff Hankins, 4-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    topmeet $p |- ( ( X e. V /\ S C_ ( TopOn ` X ) ) ->
      ( ~P X i^i |^| S ) = U. { k e. ( TopOn ` X ) | A. j e. S k C_ j } ) $=
      ( wcel ctopon cfv wss wa cpw cint cin wral cuni wceq sylibr syl sspwuni
      cv crab topmtcl inss2 intss1 syl5ss rgen sseq1 ralbidv elrab mpbiran2 w3a
      elssuni toponuni eqimss2 3ad2ant2 simp3 ssint ssind vex elpw sylib eqssd
      rabssdv ) EDFAEGHZIJZEKZALZMZCTZBTZIZBANZCVDUAZOZVEVHVMFZVHVNIVEVHVDFZVOA
      DEUBVOVPVHVJIZBANZVQBAVJAFVHVGVJVFVGUCVJAUDUEUFVLVRCVHVDVIVHPVKVQBAVIVHVJ
      UGUHUIUJQVHVMULRVEVMVHKZIVNVHIVEVLCVDVSVEVIVDFZVLUKZVIVHIVIVSFWAVIVFVGVTV
      EVIVFIZVLVTVIOZEIZWBVTEWCPWDEVIUMWCEUNRVIESQUOWAVLVIVGIVEVTVLUPBVIAUQQURV
      IVHCUSUTQVCVMVHSVAVB $.

    $( Two equivalent formulations of the join of a collection of topologies.
       (Contributed by Jeff Hankins, 6-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    topjoin $p |- ( ( X e. V /\ S C_ ( TopOn ` X ) ) ->
      ( topGen ` ( fi ` ( { X } u. U. S ) ) ) =
        |^| { k e. ( TopOn ` X ) | A. j e. S j C_ k } ) $=
      ( wcel ctopon cfv wss wa cuni cun wral sylibr wceq syl sspwuni syl6ss cvv
      sylib csn cfi ctg cv crab cint wi topontop ad2antrl toponmax snssd simprr
      ctop unissb unssd syl2anc expr ralrimiva ssintrab ctb fibas tgtopon ax-mp
      tgfiss uniun unisng adantr uneq1d syl5req cpw simpr toponuni eqimss2 elpw
      vex ssriv ssequn2 snex fvex ssex adantl uniexg unexg sylancr fiuni fveq2d
      3eqtr3d syl5eleqr elssuni ssun2 ssfii sylan9ssr bastg sseq2 ralbidv elrab
      sylanbrc intss1 eqssd ) EDFZAEGHZIZJZEUAZAKZLZUBHZUCHZBUDZCUDZIZBAMZCXAUE
      ZUFZXCXLXHXJIZUGZCXAMXHXNIXCXPCXAXCXJXAFZXLXOXCXQXLJJZXJUMFZXFXJIXOXQXSXC
      XLEXJUHUIXRXDXEXJXREXJXQEXJFXCXLEXJUJUIUKXRXLXEXJIXCXQXLULBAXJUNNUOXFXJVD
      UPUQURXLCXHXAUSNXCXHXMFZXNXHIXCXHXAFXIXHIZBAMZXTXCXHXGKZGHZXAXGUTFZXHYDFX
      FVAZXGVBVCXCEYCGXCEXEKZLZXFKZEYCXCYIXDKZYGLYHXDXEVEXCYJEYGWTYJEOXBEDVFVGV
      HVIXCYGEIZYHEOXCXEEVJZIZYKXCAYLVJZIYMXCAXAYNWTXBVKCXAYNXQXJYLIZXJYNFXQXJK
      ZEIZYOXQEYPOYQEXJVLYPEVMPXJEQNXJYLCVOVNNVPRAYLQTXEEQTYGEVQTXCXFSFZYIYCOXC
      XDSFXESFZYREVRXCASFZYSXBYTWTAXAEGVSVTWAASWBPXDXESSWCWDZXFSWEPWGWFWHXCYABA
      XCXIAFZJXIXGXHUUBXCXIXFXGUUBXIXEXFXIAWIXEXDWJRXCYRXFXGIUUAXFSWKPWLYEXGXHI
      YFXGUTWMVCRURXLYBCXHXAXJXHOXKYABAXJXHXIWNWOWPWQXHXMWRPWS $.

    $( The meet of a collection of equivalence classes of covers with respect
       to fineness.  (Contributed by Jeff Hankins, 5-Oct-2009.)  (Proof
       shortened by Mario Carneiro, 12-Sep-2015.) $)
    fnemeet1 $p |- ( ( X e. V /\ A. y e. S X = U. y /\ A e. S ) ->
      ( ~P X i^i |^|_ t e. S ( topGen ` t ) ) Fne A ) $=
      ( wcel cv cuni wceq wral ctg cfv cfne wss unitg unieq eqeq2d syl 3ad2ant3
      w3a cpw ciin cin c0 wne wa adantl rspccva 3ad2antl2 eqtr4d eqimss sspwuni
      sylibr ralrimiva ne0i riinn0 syl2anc wrex simp3 ssid fveq2 sseq1d sylancl
      rspcev iinss unissd sseqtrd 3adant1 adantr eqtr3d simpr eltg3i eqeltrd wb
      wbr cvv uniexg eliin mpbird elssuni eqssd eqid isfne4 sylanbrc eqbrtrd )
      FEGZFAHZIZJZADKZCDGZUAZFUBZBDBHZLMZUCZUDZWQCNWMWPWNOZBDKDUEUFZWRWQJWMWSBD
      WMWODGZUGZWPIZFOZWSXBXCFJXDXBXCWOIZFXAXCXEJWMWODPUHWKWGXAFXEJZWLWJXFAWODW
      HWOJWIXEFWHWOQRUIUJZUKXCFULSWPFUMUNUOWLWGWTWKDCUPTBWNWPDUQURWMWQIZCIZJWQC
      LMZOZWQCNVPWMXHXIWMXHXJIZXIWMWQXJWMWPXJOZBDUSZXKWMWLXJXJOZXNWGWKWLUTXJVAX
      MXOBCDWOCJWPXJXJWOCLVBVCVEVDBDWPXJVFSZVGWLWGXLXIJWKCDPTVHWMXIWQGZXIXHOWMX
      QXIWPGZBDKZWMXRBDXBXIXEWPXBFXIXEWMFXIJZXAWKWLXTWGWJXTACDWHCJWIXIFWHCQRUIV
      IVJXGVKXBXAWOWOOXEWPGWMXAVLWOVAWOWODVMVDVNUOWMXIVQGZXQXSVOWLWGYAWKCDVRTBX
      IDWPVQVSSVTXIWQWASWBXPWQCXHXIXHWCXIWCWDWEWF $.

    $( The meet of equivalence classes under the fineness relation-part two.
       (Contributed by Jeff Hankins, 6-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    fnemeet2 $p |- ( ( X e. V /\ A. y e. S X = U. y ) ->
      ( T Fne ( ~P X i^i |^|_ t e. S ( topGen ` t ) ) <->
        ( X = U. T /\ A. x e. S T Fne x ) ) ) $=
      ( wcel cv cuni wceq wral wa cfne wbr c0 eqid syl wss cvv cpw ctg cfv ciin
      cin wi riin0 unieqd unipw syl6req a1i wne wex n0 w3a unieq eqeq2d rspccva
      3adant1 fnebas eqtr4d 3expia exlimdv syl5bi pm2.61dne adantr adantl fnetr
      fnemeet1 ex expcom 3expa ralrimdva simprl eqtr3d eqimss2 ad2antrl sspwuni
      sylibr breq2 cbvralv fnetg ralimi sylbi ad2antll ssiin ssind pwexg inex1g
      jcad ad2antrr bastg sstrd isfne4 sylanbrc impbid ) GFHZGBIZJZKZBDLZMZEGUA
      ZCDCIZUBUCZUDZUEZNOZGEJZKZEAIZNOZADLZMZXBXHXJXMXBXHXJXBXHMGXGJZXIXBGXOKZX
      HXBXPDPDPKZXPUFXBXQXOXCJGXQXGXCCXCXEDUGUHGUIUJUKDPULXKDHZAUMXBXPADUNXBXRX
      PAWQXAXRXPWQXAXRUOZGXKJZXOXAXRGXTKZWQWTYABXKDWRXKKWSXTGWRXKUPUQURUSXSXGXK
      NOZXOXTKBCXKDFGVIZXGXKXOXTXOQZXTQUTRVAVBVCVDVEZVFXHXIXOKZXBEXGXIXOXIQZYDU
      TVGVAVJXBXHXLADWQXAXRXHXLUFZXSYBYHYCXHYBXLEXGXKVHVKRVLVMWJXBXNXHXBXNMZYFE
      XGUBUCZSXHYIGXIXOXBXJXMVNXBXPXNYEVFVOYIEXGYJYIEXCXFYIXIGSZEXCSXJYKXBXMXIG
      VPVQEGVRVSYIEXESZCDLZEXFSXMYMXBXJXMEXDNOZCDLYMXLYNACDXKXDENVTWAYNYLCDEXDW
      BWCWDWECDXEEWFVSWGYIXGTHZXGYJSWQYOXAXNWQXCTHYOGFWHXCXFTWIRWKXGTWLRWMEXGXI
      XOYGYDWNWOVJWP $.

    $( Join of equivalence classes under the fineness relation-part one.
       (Contributed by Jeff Hankins, 8-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    fnejoin1 $p |- ( ( X e. V /\ A. y e. S X = U. y /\ A e. S ) ->
      A Fne if ( S = (/) , { X } , U. S ) ) $=
      ( wcel cv cuni wceq wral w3a c0 cfne wss 3ad2ant3 sspwuni sylibr cvv eqid
      syl csn cif ctg cfv wbr elssuni unissd cpw eqimss2 ralimi 3ad2ant2 unissb
      sylib unieq eqeq2d rspccva 3adant1 eqssd pwexg 3ad2ant1 ssexd bastg sstrd
      sseqtrd isfne4 sylanbrc wne ne0i ifnefalse breqtrrd ) EDFZEAGZHZIZACJZBCF
      ZKZBCHZCLIEUAZVRUBZMVQBHZVRHZIBVRUCUDZNBVRMUEVQWAWBVQBVRVPVKBVRNVOBCUFOZU
      GVQWBEWAVQVREUHZNZWBENVQVLWENZACJZWFVOVKWHVPVNWGACVNVMENWGVMEUIVLEPQUJUKA
      CWEULQZVREPUMVOVPEWAIZVKVNWJABCVLBIVMWAEVLBUNUOUPUQVDURVQBVRWCWDVQVRRFVRW
      CNVQVRWERVKVOWERFVPEDUSUTWIVAVRRVBTVCBVRWAWBWASWBSVEVFVQCLVGZVTVRIVPVKWKV
      OCBVHOCLVSVRVITVJ $.

    $( Join of equivalence classes under the fineness relation-part two.
       (Contributed by Jeff Hankins, 8-Oct-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    fnejoin2 $p |- ( ( X e. V /\ A. y e. S X = U. y ) ->
      ( if ( S = (/) , { X } , U. S ) Fne T <->
        ( X = U. T /\ A. x e. S x Fne T ) ) ) $=
      ( wcel cuni wceq wral wa c0 cfne wbr adantr eqid syl ex wss cvv cv unisng
      csn cif eqcomd iftrue unieqd eqeq2d syl5ibrcom wne wex n0 rspccva 3adant1
      w3a unieq fnejoin1 fnebas eqtrd 3expia syl5bi pm2.61dne sylan9eq wi fnetr
      exlimdv 3expa ralrimdva jcad ctg cfv simprl eqtr3d elex ad2antrr eqeltrrd
      sseq1 uniexb sylibr eltg3i sylancl eqeltrd snssd wn simplrr ralimi unissb
      ssid fnetg ifbothda isfne4 sylanbrc impbid ) FEGZFBUAZHZIZBCJZKZCLIZFUCZC
      HZUDZDMNZFDHZIZAUAZDMNZACJZKZWSXDXFXIWSXDXFWSXDFXCHZXEWSFXKIZCLWSXLWTFXAH
      ZIZWNXNWRWNXMFFEUBUEOWTXKXMFWTXCXAWTXAXBUFUGUHUICLUJXGCGZAUKWSXLACULWSXOX
      LAWNWRXOXLWNWRXOUOZFXGHZXKWRXOFXQIZWNWQXRBXGCWOXGIWPXQFWOXGUPUHUMUNXPXGXC
      MNZXQXKIBXGCEFUQZXGXCXQXKXQPXKPZURQUSUTVFVAVBZXCDXKXEYAXEPZURVCRWSXDXHACW
      NWRXOXDXHVDZXPXSYDXTXSXDXHXGXCDVERQVGVHVIWSXJXDWSXJKZXKXEIXCDVJVKZSZXDYEF
      XKXEWSXLXJYBOWSXFXIVLZVMWTXAYFSZXBYFSZYGYEXAXBXAXCYFVQXBXCYFVQYEYIWTYEFYF
      YEFXEYFYHYEDTGZDDSXEYFGYEXETGYKYEFXETYHWNFTGWRXJFEVNVOVPDVRVSDWHDDTVTWAWB
      WCOYEWTWDZKZXGYFSZACJZYJYMXIYOWSXFXIYLWEXHYNACXGDWIWFQACYFWGVSWJXCDXKXEYA
      YCWKWLRWM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Filter bases
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d t x B $.  $d t x F $.  $d t x X $.  $d t x Y $.
    $( Minimality property of a generated filter: every filter that contains
       ` B ` contains its generated filter.  (Contributed by Jeff Hankins,
       5-Sep-2009.)  (Revised by Mario Carneiro, 7-Aug-2015.) $)
    fgmin $p |- ( ( B e. ( fBas ` X ) /\ F e. ( Fil ` X ) ) ->
        ( B C_ F <-> ( X filGen B ) C_ F ) ) $=
      ( vt vx cfbas cfv wcel cfil wa wss cfg co cv wrex wb elfg adantr ssrexv
      wi adantl filss 3exp2 com34 rexlimdv ad2antlr com23 imp3a sylbid ssrdv ex
      syld ssfg sstr2 syl impbid ) ACFGHZBCIGHZJZABKZCALMZBKZUSUTVBUSUTJZDVABVC
      DNZVAHZVDCKZENZVDKZEAOZJZVDBHZUSVEVJPZUTUQVLUREVDACQRRVCVFVIVKVCVIVFVKVCV
      IVHEBOZVFVKTZUTVIVMTUSVHEABSUAURVMVNTUQUTURVHVNEBURVGBHZVFVHVKURVOVFVHVKV
      GVDBCUBUCUDUEUFULUGUHUIUJUKUQVBUTTZURUQAVAKVPACUMAVABUNUORUP $.
  $}

  ${
    $d t u x y z J $.  $d t u x y z S $.  $d t u x y z X $.
    neifg.1 $e |- X = U. J $.
    $( The neighborhood filter of a nonempty set is generated by its open
       supersets.  See comments for ~ opnfbas .  (Contributed by Jeff Hankins,
       3-Sep-2009.) $)
    neifg $p |- ( ( J e. Top /\ S C_ X /\ S =/= (/) ) ->
        ( X filGen { x e. J | S C_ x } ) = ( ( nei ` J ) ` S ) ) $=
      ( vt vu vz wcel wss c0 wne cv crab cpw cin cfv wa wex wb ctop w3a co cnei
      cfg cfbas wceq opnfbas fgval syl pweq ineq2d neeq1d elrab vex elpw a1i n0
      elin sseq2 anbi12i bitri exbii anbi12d isnei 3adant3 df-rex bitr4i anbi2i
      wrex anass syl6rbbr bitrd syl5bb eqrdv eqtrd ) CUAIZBDJZBKLZUBZDBAMZJZACN
      ZUEUCZWCFMZOZPZKLZFDOZNZBCUDQQZVTWCDUFQIWDWJUGABCDEUHFWCDUIUJVTGWJWKGMZWJ
      IWLWIIZWCWLOZPZKLZRZVTWLWKIZWHWPFWLWIWEWLUGZWGWOKWSWFWNWCWEWLUKULUMUNVTWQ
      WLDJZHMZCIZBXAJZRZXAWLJZRZHSZRZWRVTWMWTWPXGWMWTTVTWLDGUOUPUQWPXGTVTWPXAWO
      IZHSXGHWOURXIXFHXIXAWCIZXAWNIZRXFXAWCWNUSXJXDXKXEWBXCAXACWAXABUTUNXAWLHUO
      UPVAVBVCVBUQVDVTWRWTXCXERZHCVJZRZXHVQVRWRXNTVSBHCWLDEVEVFXGXMWTXGXBXLRZHS
      XMXFXOHXBXCXEVKVCXLHCVGVHVIVLVMVNVOVP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Directed sets, nets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d d x D $.  $d x X $.  $d x A $.
    tailfval.1 $e |- X = dom D $.
    $( The tail function for a directed set.  (Contributed by Jeff Hankins,
       25-Nov-2009.)  (Revised by Mario Carneiro, 24-Nov-2013.) $)
    tailfval $p |- ( D e. DirRel -> ( tail ` D ) =
                     ( x e. X |-> ( D " { x } ) ) ) $=
      ( vd cdir wcel ctail cfv cuni cv csn cima cmpt cvv wceq uniexg 3syl unieq
      mptexg unieqd imaeq1 mpteq12dv df-tail fvmptg mpdan dirdm syl5req mpteq1d
      cdm eqtrd ) BFGZBHIZABJZJZBAKLZMZNZACUQNULUROGZUMURPULUNOGUOOGUSBFQUNOQAU
      OUQOTREBAEKZJZJZUTUPMZNURFOHUTBPZAVBVCUOUQVDVAUNUTBSUAUTBUPUBUCAEUDUEUFUL
      AUOCUQULCBUJUODBUGUHUIUK $.

    $( The tail of an element in a directed set.  (Contributed by Jeff Hankins,
       25-Nov-2009.)  (Revised by Mario Carneiro, 24-Nov-2013.) $)
    tailval $p |- ( ( D e. DirRel /\ A e. X ) ->
                   ( ( tail ` D ) ` A ) = ( D " { A } ) ) $=
      ( vx cdir wcel wa ctail cfv csn cima cmpt wceq tailfval fveq1d adantr cvv
      cv id imaexg sneq imaeq2d eqid fvmptg syl2anr eqtrd ) BFGZACGZHABIJZJZAEC
      BESZKZLZMZJZBAKZLZUHUKUPNUIUHAUJUOEBCDOPQUIUIURRGUPURNUHUITBUQFUAEAUNURCR
      UOULANUMUQBULAUBUCUOUDUEUFUG $.

    $( An element of a tail.  (Contributed by Jeff Hankins, 25-Nov-2009.)
       (Revised by Mario Carneiro, 24-Nov-2013.) $)
    eltail $p |- ( ( D e. DirRel /\ A e. X /\ B e. C ) ->
                   ( B e. ( ( tail ` D ) ` A ) <-> A D B ) ) $=
      ( cdir wcel w3a ctail cfv csn cima wbr wb wa tailval eleq2d 3adant3 cop
      elimasng df-br syl6bbr 3adant1 bitrd ) DGHZAEHZBCHZIBADJKKZHZBDALMZHZABDN
      ZUFUGUJULOUHUFUGPUIUKBADEFQRSUGUHULUMOUFUGUHPULABTDHUMDABECUAABDUBUCUDUE
      $.
  $}

  ${
    $d s x y z D $.  $d s x y z X $.
    tailf.1 $e |- X = dom D $.
    $( The tail function of a directed set sends its elements to its subsets.
       (Contributed by Jeff Hankins, 25-Nov-2009.)  (Revised by Mario Carneiro,
       24-Nov-2013.) $)
    tailf $p |- ( D e. DirRel -> ( tail ` D ) : X --> ~P X ) $=
      ( vx cdir wcel cpw ctail cfv wf cv csn cima cmpt wral wss cuni cvv mpbird
      sstri crn imassrn cdm cun ssun2 dmrnssfld dirdm syl5req syl5sseq wb dmexg
      syl5eqel elpw2g syl ralrimivw eqid fmpt sylib tailfval feq1d ) AEFZBBGZAH
      IZJBVBDBADKLZMZNZJZVAVEVBFZDBOVGVAVHDBVAVHVEBPZVAAQQZVEBVEAUAZVJAVDUBVKAU
      CZVKUDVJVKVLUEAUFTTVABVLVJCAUGUHUIVABRFVHVIUJVABVLRCAEUKULVEBRUMUNSUODBVB
      VEVFVFUPUQURVABVBVCVFDABCUSUTS $.
  $}

  ${
    tailini.1 $e |- X = dom D $.
    $( A tail contains its initial element.  (Contributed by Jeff Hankins,
       25-Nov-2009.) $)
    tailini $p |- ( ( D e. DirRel /\ A e. X ) -> A e. ( ( tail ` D ) ` A ) ) $=
      ( cdir wcel wa ctail cfv wbr dirref wb eltail 3anidm23 mpbird ) BEFZACFZG
      AABHIIFZAABJZABCDKPQRSLAACBCDMNO $.
  $}

  ${
    $d u v w x y z D $.  $d u v w x y z X $.
    tailfb.1 $e |- X = dom D $.
    $( The collection of tails of a directed set is a filter base.
       (Contributed by Jeff Hankins, 25-Nov-2009.)  (Revised by Mario Carneiro,
       8-Aug-2015.) $)
    tailfb $p |- ( ( D e. DirRel /\ X =/= (/) )
          -> ran ( tail ` D ) e. ( fBas ` X ) ) $=
      ( vz vx vy vu vv wcel c0 wa cfv wss cv wrex adantr wi wb wbr cvv cdir wne
      vw ctail crn cfbas cpw wnel cin wral w3a wf tailf frn syl wex n0 fnfvelrn
      wfn ffn 3syl ne0i syl6 exlimdv syl5bi imp wceq tailini n0i nrexdv fvelrnb
      ex wn mtbird df-nel sylibr anbi12d dirge 3expb sylan ad2ant2r dirtr exp32
      reeanv vex mpan2 com23 ad2ant2rl anim12d expr impr eltail adantrr adantrl
      mp3an3 3imtr4d syl6ibr ssrdv sseq1 rspcev syl2anc rexlimddv ineq1 rexbidv
      elin sseq2d ineq2 sylan9bb syl5ibcom rexlimdvva sylbid ralrimivv 3jca cdm
      syl5bir dmexg syl5eqel isfbas2 mpbir2and ) AUAIZBJUBZKZAUDLZUEZBUFLIZYDBU
      GZMZYDJUBZJYDUHZDNZENZFNZUIZMZDYDOZFYDUJEYDUJZUKZXTYGYAXTBYFYCULZYGABCUMZ
      BYFYCUNUOPYBYHYIYPXTYAYHYAYKBIZEUPXTYHEBUQXTYTYHEXTYTYKYCLZYDIZYHXTYRYCBU
      SZYTUUBQYSBYFYCUTZUUCYTUUBBYKYCURVLVAYDUUAVBVCVDVEVFYBJYDIZVMYIYBUUEUUAJV
      GZEBOZXTUUGVMYAXTUUFEBXTYTKYKUUAIUUFVMYKABCVHUUAYKVIUOVJPXTUUEUUGRZYAXTYR
      UUCUUHYSUUDEBJYCVKVAPVNJYDVOVPYBYOEFYDYDXTYKYDIZYLYDIZKZYOQYAXTUUKGNZYCLZ
      YKVGZGBOZHNZYCLZYLVGZHBOZKZYOXTYRUUCUUKUUTRYSUUDUUCUUIUUOUUJUUSGBYKYCVKHB
      YLYCVKVQVAUUTUUNUURKZHBOGBOXTYOUUNUURGHBBWDXTUVAYOGHBBXTUULBIZUUPBIZKZKZY
      JUUMUUQUIZMZDYDOZUVAYOUVEUULUCNZASZUUPUVIASZKZUVHUCBXTUVBUVCUVLUCBOUCUULU
      UPABCVRVSUVEUVIBIZUVLKZKZUVIYCLZYDIZUVPUVFMZUVHXTUVMUVQUVDUVLXTUUCUVMUVQX
      TYRUUCYSUUDUOBUVIYCURVTWAUVOEUVPUVFUVOYKUVPIZYKUUMIZYKUUQIZKZYKUVFIUVOUVI
      YKASZUULYKASZUUPYKASZKZUVSUWBUVEUVMUVLUWCUWFQUVEUVMKUWCUVLUWFUVEUVMUWCUVL
      UWFQUVEUVMUWCKKUVJUWDUVKUWEXTUWCUVJUWDQZUVDUVMXTUWCUWGXTUVJUWCUWDXTYKTIZU
      VJUWCUWDQQEWEZXTUWHKZUVJUWCUWDUULUVIYKATWBWCWFWGVFWHXTUWCUVKUWEQZUVDUVMXT
      UWCUWKXTUVKUWCUWEXTUWHUVKUWCUWEQQUWIUWJUVKUWCUWEUUPUVIYKATWBWCWFWGVFWHWIW
      JWGWKXTUVMUVSUWCRZUVDUVLXTUVMUWHUWLUWIUVIYKTABCWLWOWAUVEUWBUWFRUVNUVEUVTU
      WDUWAUWEXTUVBUVTUWDRZUVCXTUVBUWHUWMUWIUULYKTABCWLWOWMXTUVCUWAUWERZUVBXTUV
      CUWHUWNUWIUUPYKTABCWLWOWNVQPWPYKUUMUUQXEWQWRUVGUVRDUVPYDYJUVPUVFWSWTXAXBU
      UNUVHYJYKUUQUIZMZDYDOUURYOUUNUVGUWPDYDUUNUVFUWOYJUUMYKUUQXCXFXDUURUWPYNDY
      DUURUWOYMYJUUQYLYKXGXFXDXHXIXJXOXKPXLXMYBBTIZYEYGYQKRXTUWQYAXTBAXNTCAUAXP
      XQPEFDTBYDXRUOXS $.
  $}

  ${
    $d x y A $.  $d d f k m n t u v w x y z F $.  $d d f m t u v w x y z H $.
    $d x y B $.  $d d f t u v w z D $.  $d d f n t u v z X $.
    ${
      filnet.h $e |- H = U_ n e. F ( { n } X. n ) $.
      filnet.d $e |- D = { <. x , y >. |
          ( ( x e. H /\ y e. H ) /\ ( 1st ` y ) C_ ( 1st ` x ) ) } $.
      ${
        filnetlem1.a $e |- A e. _V $.
        filnetlem1.b $e |- B e. _V $.
        $( Lemma for ~ filnet .  Change variables.  (Contributed by Jeff
           Hankins, 13-Dec-2009.)  (Revised by Mario Carneiro, 8-Aug-2015.) $)
        filnetlem1 $p |- ( A D B <-> ( ( A e. H /\ B e. H ) /\
            ( 1st ` B ) C_ ( 1st ` A ) ) ) $=
          ( cv c1st cfv wss wceq fveq2 sseq2d sseq1d sylan9bb brab2ga ) BMZNOZA
          MZNOZPZDNOZCNOZPZABCDHHEUECQZUGUDUIPUCDQZUJUKUFUIUDUECNRSULUDUHUIUCDN
          RTUAJUB $.
      $}

      $( Lemma for ~ filnet .  The field of the direction.  (Contributed by
         Jeff Hankins, 13-Dec-2009.)  (Revised by Mario Carneiro,
         8-Aug-2015.) $)
      filnetlem2 $p |- ( ( _I |` H ) C_ D /\ D C_ ( H X. H ) ) $=
        ( vz cid cres wss cxp cv wbr idref wcel wa c1st cfv ssid vex filnetlem1
        mpbiran2 biimpri anidms mprgbir copab opabssxp eqsstri pm3.2i ) JFKCLZC
        FFMZLULINZUNCOZIFIFCPUNFQZUOUOUPUPRZUOUQUNSTZURLURUAABUNUNCDEFGHIUBZUSU
        CUDUEUFUGCANZFQBNZFQRVASTUTSTLZRABUHUMHVBABFFUIUJUK $.

      $( Lemma for ~ filnet .  (Contributed by Jeff Hankins, 13-Dec-2009.)
         (Revised by Mario Carneiro, 8-Aug-2015.) $)
      filnetlem3 $p |- ( H = U. U. D /\
        ( F e. ( Fil ` X ) -> ( H C_ ( F X. X ) /\ D e. DirRel ) ) ) $=
        ( vv vw vz cfv wcel wss wa cv c1st wbr cvv vu cuni wceq cfil cxp wi cdm
        cdir crn cun cid cres dmresi filnetlem2 dmss ax-mp eqsstr3i ssun1 sstri
        simpli dmrnssfld simpri uniss mp2b unixpss unidm sseqtri eqssi csn ciun
        wral filelss xpss2 syl ralrimiva iunxpconst syl6sseq syl5eqss wrel ccom
        ss2iun ccnv a1i relopabi jctil wex cin c0 wne simpl adantr simprl xp1st
        sseldd simprr filinn0 syl3anc sylib cop filin simpr opeliunxp2 sylanbrc
        n0 id syl6eleqr fvex inex1 op1st inss1 eqsstri opex filnetlem1 mpbiran2
        vex inss2 breq2 anbi12d spcev syl2anc exlimddv ralrimivva codir simplbi
        sylibr wal simpld simprd anim12i simprbi sylan9ssr ax-gen gen2 mpbir wb
        cotr filtop xpexg mpdan ssexd ssexg sylancr isdir mpbir2and jca pm3.2i
        ) FCUBZUBZUCEGUDMZNZFEGUEZOZCUHNZPUFFUUHFCUGZCUIZUJZUUHFUUNUUPFUKFULZUG
        ZUUNFUMUUQCOZUURUUNOUUSCFFUEZOZABCDEFHIUNZUTZUUQCUOUPUQUUNUUOURUSCVAUSU
        UHUUTUBZUBZFUVAUUGUVDOUUHUVEOUUSUVAUVBVBZCUUTVCUUGUVDVCVDUVEFFUJFFFVEFV
        FVGUSVHZUUJUULUUMUUJFDEDQZVIZUVHUEZVJZUUKHUUJUVKDEUVIGUEZVJZUUKUUJUVJUV
        LOZDEVKUVKUVMOUUJUVNDEUUJUVHENPUVHGOUVNUVHEGVLUVHGUVIVMVNVODEUVJUVLWAVN
        DEGVPVQVRZUUJUUMCVSZUUSPZCCVTCOZUUTCWBCVTOZPZUUJUUSUVPUUSUUJUVCWCAQZFNB
        QZFNPUWBRMUWARMOPABCIWDWEUUJUVSUVRUUJJQZKQZCSZLQZUWDCSZPZKWFZLFVKJFVKUV
        SUUJUWIJLFFUUJUWCFNZUWFFNZPZPZUAQZUWCRMZUWFRMZWGZNZUWIUAUWMUWQWHWIZUWRU
        AWFUWMUUJUWOENZUWPENZUWSUUJUWLWJZUWMUWCUUKNUWTUWMFUUKUWCUUJUULUWLUVOWKZ
        UUJUWJUWKWLZWNUWCEGWMVNZUWMUWFUUKNUXAUWMFUUKUWFUXCUUJUWJUWKWOZWNUWFEGWM
        VNZUWOUWPEGWPWQUAUWQXDWRUWMUWRPZUWCUWQUWNWSZCSZUWFUXICSZUWIUXHUWJUXIFNZ
        UXJUWMUWJUWRUXDWKUXHUXIUVKFUXHUWQENZUWRUXIUVKNUWMUXMUWRUWMUUJUWTUXAUXMU
        XBUXEUXGUWOUWPEGWTWQWKUWMUWRXADEUVHUWQUWNUWQUVHUWQUCXEXBXCHXFZUXJUWJUXL
        PUXIRMZUWOOUXOUWQUWOUWQUWNUWOUWPUWCRXGXHUAXOXIZUWOUWPXJXKABUWCUXICDEFHI
        JXOZUWQUWNXLZXMXNXCUXHUWKUXLUXKUWMUWKUWRUXFWKUXNUXKUWKUXLPUXOUWPOUXOUWQ
        UWPUXPUWOUWPXPXKABUWFUXICDEFHILXOZUXRXMXNXCUWHUXJUXKPKUXIUXRUWDUXIUCUWE
        UXJUWGUXKUWDUXIUWCCXQUWDUXIUWFCXQXRXSXTYAYBJLKFFCYCYEUVRUWEUWDUWFCSZPZU
        WCUWFCSZUFZLYFZKYFJYFUYDJKUYCLUYAUWLUWPUWOOUYBUWEUWJUXTUWKUWEUWJUWDFNZU
        WEUWJUYEPZUWDRMZUWOOZABUWCUWDCDEFHIUXQKXOZXMZYDYGUXTUYEUWKUXTUYEUWKPZUW
        PUYGOZABUWDUWFCDEFHIUYIUXSXMZYDYHYIUXTUWEUWPUYGUWOUXTUYKUYLUYMYJUWEUYFU
        YHUYJYJYKABUWCUWFCDEFHIUXQUXSXMXCYLYMJKLCYPYNWEUUJCTNZUUMUVQUVTPYOUUJUV
        AUUTTNZUYNUVFUUJFTNZUYPUYOUUJFUUKTUUJGENUUKTNEGYQEGUUIEYRYSUVOYTZUYQFFT
        TYRXTCUUTTUUAUUBFCTUVGUUCVNUUDUUEUUF $.

      $( Lemma for ~ filnet .  (Contributed by Jeff Hankins, 15-Dec-2009.)
         (Revised by Mario Carneiro, 8-Aug-2015.) $)
      filnetlem4 $p |- ( F e. ( Fil ` X ) -> E. d e. DirRel E. f ( f : dom d
          --> X
       /\ F = ( ( X FilMap f ) ` ran ( tail ` d ) ) ) ) $=
        ( vk cfv wcel wceq wa wss wi cvv c0 vt vm vv cfil cdir cdm cv ctail crn
        cfm wex wrex cxp cuni filnetlem3 simpri simprd c2nd cres f2ndres simpld
        wf co fssres2 sylancr filtop xpexg mpdan ssexd fex syl2anc dirdm simpli
        syl syl6reqr feq2d mpbid cfg cima c1st wral cpw wfn tailf mpbird adantr
        eqid ffn imaeq2 sseq1d rexrn 3syl wfun wfo fo2nd fofn ax-mp ssv fnssres
        mp2an fnfun ffvelrnda elpwid ad2antrr sseqtr4d fndm syl6sseqr funimass4
        wb wbr simpr eleqtrd vex a1i eltail syl3anc biantrurd anbi1d filnetlem1
        syl6bbr bitr4d imbi1d eleq1d bitri rexbidva csn ciun cop op1std imbi12d
        weq wne sseq1 cfbas wn sylib ss0b dmss eqeq2d anbi12d ralbidv2 raliunxp
        fvres pm5.74i impexp syl6bb bitrd op2ndd sneq id xpeq12d cbviunv raleqi
        eqtri imbi2i r19.21v bitr4i ralbii 3bitr4i rexbii rexeqi sseq2d ralbidv
        dfss3 rexiunxp 3bitri fileln0 adantlr r19.9rzv rspcv adantl sstr2 com12
        ssid mpii ralrimivw impbid1 bitr3d syl5bb 3bitrd pm5.32da filn0 wo snnz
        jctil neanior sylnibr ralrimiva r19.2z rexnal sseq1i 3bitr3i necon3abii
        xpeq0 iunss sylibr cid dmresi filnetlem2 eqsstr3i dmxpid sseqtri tailfb
        eqssi elfm filfbas elfg eqrdv fgfil eqtr2d jca feq1 oveq2 fveq1d spcegv
        3bitr4d sylc dmeq fveq2 rneqd fveq2d exbidv rspcev ) FHUDMZNZCUENZCUFZH
        DUGZVBZFCUHMZUIZHUYHUJVCZMZOZPZDUKZIUGZUFZHUYHVBZFUYQUHMZUIZUYLMZOZPZDU
        KZIUEULUYEGFHUMZQZUYFGCUNUNZOZUYEVUGUYFPRZABCEFGHJKUOZUPZUQZUYEURGUSZSN
        ZUYGHVUNVBZFUYKHVUNUJVCZMZOZPZUYPUYEGHVUNVBZGSNVUOUYEVUFHURVUFUSVBVUGVV
        AFHUTUYEVUGUYFVULVAZVUFHGURVDVEZUYEGVUFSUYEHFNZVUFSNFHVFZFHUYDFVGVHVVBV
        IGHSVUNVJVKUYEVUPVUSUYEVVAVUPVVCUYEGUYGHVUNUYEUYGVUHGUYEUYFUYGVUHOVUMCV
        LVNVUIVUJVUKVMVOZVPVQUYEVURHFVRVCZFUYEUAVURVVGUYEUAUGZHQZVUNUYQVSZVVHQZ
        IUYKULZPZVVIEUGZVVHQZEFULZPZVVHVURNZVVHVVGNZUYEVVIVVLVVPUYEVVIPZVVLVUNU
        YHUYJMZVSZVVHQZDGULZUYQVTMZUYHVTMZQZUYQURMZVVHNZRZIGWAZDGULZVVPVVTGUYGW
        BZUYJVBZUYJGWCVVLVWDXIUYEVWNVVIUYEVWNUYGVWMUYJVBZUYEUYFVWOVUMCUYGUYGWGZ
        WDVNUYEGUYGVWMUYJVVFVPWEWFZGVWMUYJWHVVKVWCIDGUYJUYQVWAOVVJVWBVVHUYQVWAV
        UNWIWJWKWLVVTVWCVWKDGVVTUYHGNZPZVWCUYQVUNMZVVHNZIVWAWAZVWKVWSVUNWMZVWAV
        UNUFZQVWCVXBXIVUNGWCZVXCURSWCZGSQVXESSURWNVXFWOSSURWPWQGWRSGURWSWTZGVUN
        XAWQVWSVWAGVXDVWSVWAUYGGVWSVWAUYGVVTGVWMUYHUYJVWQXBXCUYEGUYGOVVIVWRVVFX
        DZXEVXEVXDGOVXGGVUNXFWQXGIVWAVVHVUNXHVEVWSVXAVWJIVWAGVWSUYQVWANZVXARUYQ
        GNZVWGPZVXARZVXJVWJRZVWSVXIVXKVXAVWSVXIUYHUYQCXJZVXKVWSUYFUYHUYGNUYQSNZ
        VXIVXNXIUYEUYFVVIVWRVUMXDVWSUYHGUYGVVTVWRXKZVXHXLVXOVWSIXMZXNUYHUYQSCUY
        GVWPXOXPVWSVXKVWRVXJPZVWGPVXNVWSVXJVXRVWGVWSVWRVXJVXPXQXRABUYHUYQCEFGJK
        DXMVXQXSXTYAYBVXLVXKVWIRVXMVXKVXAVWIVXJVXAVWIXIVWGVXJVWTVWHVVHUYQGURUUC
        YCWFUUDVXJVWGVWIUUEYDUUFUUAUUGYEVWLLUGZVVNQZVXSVVHQZRZLFWAZUBVVNULZEFUL
        ZVVTVVPVWLVXSVWFQZVYARZLFWAZDGULVYHDEFVVNYFZVVNUMZYGZULVYEVWKVYHDGVWJIL
        FVXSYFZVXSUMZYGZWAVYFUCUGZVVHNZRZUCVXSWAZLFWAVWKVYHVWJVYQILUCFVXSUYQVXS
        VYOYHOZVWGVYFVWIVYPVYSVWEVXSVWFVXSVYOUYQLXMZUCXMZYIWJVYSVWHVYOVVHVXSVYO
        UYQVYTWUAUUHYCYJUUBVWJIGVYNGVYKVYNJELFVYJVYMELYKZVYIVYLVVNVXSVVNVXSUUIW
        UBUUJUUKUULUUNUUMVYGVYRLFVYGVYFVYPUCVXSWAZRVYRVYAWUCVYFUCVXSVVHUVDUUOVY
        FVYPUCVXSUUPUUQUURUUSUUTVYHDGVYKJUVAVYHVYCDEUBFVVNUYHVVNUBUGZYHOZVYGVYB
        LFWUEVYFVXTVYAWUEVWFVVNVXSVVNWUDUYHEXMZUBXMYIUVBYBUVCUVEUVFVVTVYDVVOEFV
        VTVVNFNZPZVYCVYDVVOWUHVVNTYLZVYCVYDXIUYEWUGWUIVVIVVNFHUVGZUVHVYCUBVVNUV
        IVNWUHVYCVVOWUGVYCVVORVVTWUGVYCVVNVVNQZVVOVVNUVNVYBWUKVVORLVVNFLEYKVXTW
        UKVYAVVOVXSVVNVVNYMVXSVVNVVHYMYJUVJUVOUVKVVOVYBLFVXTVVOVYAVXSVVNVVHUVLU
        VMUVPUVQUVRYEUVSUVTUWAUYEVVDUYKGYNMNZVVAVVRVVMXIVVEUYEUYFGTYLZWULVUMUYE
        VYJTQZEFWAZYOZWUMUYEWUNYOZEFULZWUPUYEFTYLWUQEFWAWURFHUWBUYEWUQEFUYEWUGP
        ZVYITOVVNTOUWCZWUNWUSVYITYLZWUIPWUTYOWUSWUIWVAWUJVVNWUFUWDUWEVYITVVNTUW
        FYPWUNVYJTOWUTVYJYQVYIVVNUWNYDUWGUWHWUQEFUWIVKWUNEFUWJYPWUOGTGTQVYKTQGT
        OWUOGVYKTJUWKGYQEFVYJTUWOUWLUWMUWPCGGUYGGUWQGUSZUFZUYGGUWRWVBCQZWVCUYGQ
        WVDCGGUMZQZABCEFGJKUWSZVMWVBCYRWQUWTUYGWVEUFZGWVFUYGWVHQWVDWVFWVGUPCWVE
        YRWQGUXAUXBUXDUXCVKVVCIVVHUYKFVUNHGUXEXPUYEFHYNMNVVSVVQXIFHUXFEVVHFHUXG
        VNUXPUXHFHUXIUXJUXKUYOVUTDVUNSUYHVUNOZUYIVUPUYNVUSUYGHUYHVUNUXLWVIUYMVU
        RFWVIUYKUYLVUQUYHVUNHUJUXMUXNYSYTUXOUXQVUEUYPICUEUYQCOZVUDUYODWVJUYSUYI
        VUCUYNWVJUYRUYGHUYHUYQCUXRVPWVJVUBUYMFWVJVUAUYKUYLWVJUYTUYJUYQCUHUXSUXT
        UYAYSYTUYBUYCVK $.
    $}

    $( A filter has the same convergence and clustering properties as some
       net.  (Contributed by Jeff Hankins, 12-Dec-2009.)  (Revised by Mario
       Carneiro, 8-Aug-2015.) $)
    filnet $p |- ( F e. ( Fil ` X ) -> E. d e. DirRel E. f ( f : dom d --> X
       /\ F = ( ( X FilMap f ) ` ran ( tail ` d ) ) ) ) $=
      ( vx vy vn cv csn cxp ciun wcel wa c1st cfv wss copab eqid filnetlem4 ) E
      FEHZGBGHZIUAJKZLFHZUBLMUCNOTNOPMEFQZAGBUBCDUBRUDRS $.
  $}

$( (End of Jeffrey Hankins' mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                          Mathbox for Jeff Madsen
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Logic and set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    anim12da.1 $e |- ( ( ph /\ ps ) -> th ) $.
    anim12da.2 $e |- ( ( ph /\ ch ) -> ta ) $.
    $( Conjoin antecedents and consequents in a deduction.  (Contributed by
       Jeff Madsen, 16-Jun-2011.) $)
    anim12da $p |- ( ( ph /\ ( ps /\ ch ) ) -> ( th /\ ta ) ) $=
      ( anim12dan ) ABDCEFGH $.
  $}

  ${
    syldanl.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    syldanl.2 $e |- ( ( ( ph /\ ch ) /\ th ) -> ta ) $.
    $( A syllogism deduction with conjoined antecedents.  (Contributed by Jeff
       Madsen, 20-Jun-2011.) $)
    syldanl $p |- ( ( ( ph /\ ps ) /\ th ) -> ta ) $=
      ( wa ex imdistani sylan ) ABHACHDEABCABCFIJGK $.
  $}

  ${
    $d A w x y z $.  $d B w x z $.  $d C w x y $.  $d D w x y $.  $d F w x y $.
    $d ph w x z $.  $d ps w x y $.  $d ch w x y $.
    unirep.1 $e |- ( y = D -> ( ph <-> ps ) ) $.
    unirep.2 $e |- ( y = D -> B = C ) $.
    unirep.3 $e |- ( y = z -> ( ph <-> ch ) ) $.
    unirep.4 $e |- ( y = z -> B = F ) $.
    unirep.5 $e |- B e. _V $.
    $( Define a quantity whose definition involves a choice of representative,
       but which is uniquely determined regardless of the choice.  (Contributed
       by Jeff Madsen, 1-Jun-2011.) $)
    unirep $p |- ( ( A. y e. A A. z e. A ( ( ph /\ ch ) -> B = F ) /\
            ( D e. A /\ ps ) ) -> ( iota x E. y e. A ( ph /\ x = B ) ) = C ) $=
      ( wa wceq wi wrex vw wral cv cio eqidd ancli eqeq2d anbi12d rspcev sylan2
      wcel adantl cvv weu wb csb nfcvd csbiegf csbex syl6eqelr ad2antrl wex wal
      eqeq1 anbi2d rexbidv spcegv adantr r19.29 pm3.35 eqeq12 syl5ibrcom ancoms
      syl mpd an4 expimpd syl5bi ancomsd expdimp rexlimivw sylan an32s alrimivv
      imp ex cbvrexv syl6bb eu4 sylanbrc iota2 syl2anc mpbid ) ACQZHKRZSZFGUBZE
      GUBZJGUKZBQZQZAIHRZQZEGTZADUCZHRZQZEGTZDUDIRZWTXDWRBWSBIIRZQZXDBXJBIUEUFX
      CXKEJGEUCZJRZABXBXJLXMHIIMUGUHUIUJZULXAIUMUKZXHDUNZXDXIUOWSXOWRBWSIEJHUPU
      MEJHIGWSEIUQMUREJHPUSUTZVAXAXHDVBZXHCUAUCZKRZQZFGTZQXEXSRZSZUAVCDVCXPWTXR
      WRWTXDXRXNWSXDXRSZBWSXOYEXQXHXDDIUMXEIRZXGXCEGYFXFXBAXEIHVDVEVFZVGVNVHVOU
      LXAYDDUAWRYDWTWRXHYBYCWRXHQWQXGQZEGTYBYCSZWQXGEGVIYHYIEGYHYBYCWQYBXGYCWQY
      BQWPYAQZFGTZXGYCWPYAFGVIYKXGYCYJXGYCSFGWPYAXGYCWPXGYAYCXGYAQWNXFXTQZQWPYC
      AXFCXTVPWPWNYLYCWNWPYLYCSWNWPQYCYLWOWNWOVJXEHXSKVKVLVMVQVRVSVTWAWEWBWCWFW
      AVNVQVHWDXHYBDUAYCXHAXSHRZQZEGTYBYCXGYNEGYCXFYMAXEXSHVDVEVFYNYAEFGXLFUCRZ
      ACYMXTNYOHKXSOUGUHWGWHWIWJXHXDDIUMYGWKWLWM $.
  $}

  ${
    $d ph x z $.  $d B x y z $.  $d A x z $.
    cover2.1 $e |- B e. _V $.
    cover2.2 $e |- A = U. B $.
    $( Two ways of expressing the statement "there is a cover of ` A ` by
       elements of ` B ` such that for each set in the cover, ` ph ` ."  Note
       that ` ph ` and ` x ` must be distinct.  (Contributed by Jeff Madsen,
       20-Jun-2010.) $)
    cover2 $p |- ( A. x e. A E. y e. B ( x e. y /\ ph )
                        <-> E. z e. ~P B ( U. z = A /\ A. y e. z ph ) ) $=
      ( cv wcel wa wrex wral cuni wceq cpw crab wss ssrab2 eleq2 elpw2 mpbir wb
      wal nfra1 unissi sseli syl6eleqr rsp syl6ibr impbid2 alrimi dfcleq sylibr
      elunirab unieq eqeq1d anbi1d nfrab1 nfeq2 simprbi syl6bi ralrimi biantrud
      rabid bitr4d rspcev sylancr biimpar eluni2 sylib wi r19.29r expcom ssrexv
      elpwi sylan9r sylan imp sylan2 anassrs ralrimiva anasss ancom2s rexlimiva
      impbii ) BIZCIZJZAKZCFLZBEMZDIZNZEOZACWMMZKZDFPZLZWLACFQZWRJZWTNZEOZWSXAW
      TFRACFSZWTFGUAUBWLWGXBJZWGEJZUCZBUDXCWLXGBWKBEUEWLXEXFXEWGFNZEXBXHWGWTFXD
      UFUGHUHWLXFWKXEWKBEUIACWGFUOUJUKULBXBEUMUNWQXCDWTWRWMWTOZWQXCWPKXCXIWOXCW
      PXIWNXBEWMWTUPUQURXIWPXCXIACWMCWMWTACFUSUTXIWHWMJWHWTJZAWMWTWHTXJWHFJAACF
      VEVAVBVCVDVFVGVHWQWLDWRWMWRJZWPWOWLXKWPWOWLXKWPKZWOKWKBEXLWOXFWKWOXFKZXLW
      ICWMLZWKXMWGWNJZXNWOXOXFWNEWGTVICWGWMVJVKXLXNWKXKWMFRZWPXNWKVLWMFVPWPXNWJ
      CWMLZXPWKXNWPXQWIACWMVMVNWJCWMFVOVQVRVSVTWAWBWCWDWEWF $.
  $}

  ${
    $d ph b x z $.  $d B b x y z $.  $d A b x z $.
    cover2g.1 $e |- A = U. B $.
    $( Two ways of expressing the statement "there is a cover of ` A ` by
       elements of ` B ` such that for each set in the cover, ` ph ` ."  Note
       that ` ph ` and ` x ` must be distinct.  (Contributed by Jeff Madsen,
       21-Jun-2010.) $)
    cover2g $p |- ( B e. C -> ( A. x e. A E. y e. B ( x e. y /\ ph )
                        <-> E. z e. ~P B ( U. z = A /\ A. y e. z ph ) ) ) $=
      ( vb wel wa cv wrex cuni wral wceq cpw unieq syl6eqr rexeq raleqbidv pweq
      eqeq2d anbi1d rexeqbidv vex eqid cover2 vtoclbg ) BCJAKZCILZMZBUKNZODLZNZ
      UMPZACUNOZKZDUKQZMUJCFMZBEOUOEPZUQKZDFQZMIFGUKFPZULUTBUMEVDUMFNEUKFRHSZUJ
      CUKFTUAVDURVBDUSVCUKFUBVDUPVAUQVDUMEUOVEUCUDUEABCDUMUKIUFUMUGUHUI $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d ch x y $.
    brabg2.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    brabg2.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    brabg2.3 $e |- R = { <. x , y >. | ph } $.
    brabg2.4 $e |- ( ch -> A e. C ) $.
    $( Relation by a binary relation abstraction.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    brabg2 $p |- ( B e. D -> ( A R B <-> ch ) ) $=
      ( wcel wbr cvv brabg com3l mpdi relopabi brrelexi wi biimpd exbiri impbid
      wa ex ) GIOZFGJPZCUIUJFQOZCFGJADEJMUAUBUKUIUJCUKUIUJCUCUKUIUGUJCABCDEFGQI
      JKLMRUDUHSTUICFHOZUJNULUICUJULUIUJCABCDEFGHIJKLMRUESTUF $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d ch x y $.
    opelopab3.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopab3.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    opelopab3.3 $e |- ( ch -> A e. C ) $.
    $( Ordered pair membership in an ordered pair class abstraction, with a
       reduced hypothesis.  (Contributed by Jeff Madsen, 29-May-2011.) $)
    opelopab3 $p |- ( B e. D -> ( <. A , B >. e.
                            { <. x , y >. | ph } <-> ch ) ) $=
      ( wcel cop copab cvv wa syl anim1i ancoms cxp wrel wss relopab mpbi sseli
      df-rel opelxp1 elex opelopabg pm5.21nd ) GIMZFGNZADEOZMZCFPMZULQZUOULUQUO
      UPULUOUMPPUAZMUPUNURUMUNUBUNURUCADEUDUNUGUEUFFGPPUHRSTCULUQCUPULCFHMUPLFH
      UIRSTABCDEFGPIJKUJUK $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d F x y $.  $d G x y $.  $d H x y $.
    $( Cancellation of a surjective function from the right side of a
       composition.  (Contributed by Jeff Madsen, 1-Jun-2011.)  (Proof
       shortened by Mario Carneiro, 27-Dec-2014.) $)
    cocanfo $p |- ( ( ( F : A -onto-> B /\ G Fn B /\ H Fn B )
                                    /\ ( G o. F ) = ( H o. F ) ) -> G = H ) $=
      ( vx vy wfo wfn ccom wceq wa cv cfv wral syl fvco3 sylan wb fveq2 wcel wf
      w3a simplr fveq1d simpl1 fof 3eqtr3d ralrimiva eqeq12d cbvfo mpbid eqfnfv
      3adant1 adantr mpbird ) ABCHZDBIZEBIZUCZDCJZECJZKZLZDEKZFMZDNZVFENZKZFBOZ
      VDGMZCNZDNZVLENZKZGAOZVJVDVOGAVDVKAUAZLZVKVANZVKVBNZVMVNVRVKVAVBUTVCVQUDU
      EVDABCUBZVQVSVMKVDUQWAUQURUSVCUFZABCUGPZABVKDCQRVDWAVQVTVNKWCABVKECQRUHUI
      VDUQVPVJSWBVOVIGFABCVLVFKVMVGVNVHVLVFDTVLVFETUJUKPULUTVEVJSZVCURUSWDUQFBD
      EUMUNUOUP $.
  $}

  ${
    brresi.1 $e |- B e. _V $.
    $( Restriction of a binary relation.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    brresi $p |- ( A ( R |` C ) B -> A R B ) $=
      ( cres resss ssbri ) DCFDABDCGH $.
  $}

  ${
    $d ph x $.  $d ph y $.
    fnopabeqd.1 $e |- ( ph -> B = C ) $.
    $( Equality deduction for function abstractions.  (Contributed by Jeff
       Madsen, 19-Jun-2011.) $)
    fnopabeqd $p |- ( ph -> { <. x , y >. | ( x e. A /\ y = B ) }
                          = { <. x , y >. | ( x e. A /\ y = C ) } ) $=
      ( cv wcel wceq wa eqeq2d anbi2d opabbidv ) ABHDIZCHZEJZKOPFJZKBCAQROAEFPG
      LMN $.
  $}

  ${
    $d A d r x y $.  $d B d r y $.  $d C d r x y $.  $d D d r x y $.
    $d R r x y $.  $d d x y $.  $d r x y $.
    fvopabf4g.1 $e |- C e. _V $.
    fvopabf4g.2 $e |- ( x = A -> B = C ) $.
    fvopabf4g.3 $e |- F = ( x e. ( R ^m D ) |-> B ) $.
    $( Function value of an operator abstraction whose domain is a set of
       functions with given domain and range.  (Contributed by Jeff Madsen,
       1-Dec-2009.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
    fvopabf4g $p |- ( ( D e. X /\ R e. Y /\ A : D --> R ) -> ( F ` A ) = C ) $=
      ( wcel wf w3a cmap co cfv wceq wb elmapg ancoms biimp3ar fvmpt syl ) EHMZ
      FIMZEFBNZOBFEPQZMZBGRDSUFUGUJUHUGUFUJUHTFEBIHUAUBUCABCDUIGKLJUDUE $.
  $}

  ${
    $d F x $.  $d G x $.  $d A x $.  $d B x $.
    $( Two functions on ` A u. B ` are equal if and only if they have equal
       restrictions to both ` A ` and ` B ` .  (Contributed by Jeff Madsen,
       19-Jun-2011.) $)
    eqfnun $p |- ( ( F Fn ( A u. B ) /\ G Fn ( A u. B ) ) -> ( F = G <->
                ( ( F |` A ) = ( G |` A ) /\ ( F |` B ) = ( G |` B ) ) ) ) $=
      ( vx cun wfn wa wceq cres reseq1 jca cv wcel fveq1 fvres sylan9req adantl
      cfv eqtr3d wral wo elun adantlr adantll sylan2b ralrimiva syl5ibr impbid2
      jaodan eqfnfv ) CABFZGDULGHZCDIZCAJZDAJZIZCBJZDBJZIZHZUNUQUTCDAKCDBKLVAUN
      UMEMZCSZVBDSZIZEULUAVAVEEULVBULNVAVBANZVBBNZUBVEVBABUCVAVFVEVGUQVFVEUTUQV
      FHVBUPSZVCVDUQVFVHVBUOSVCVBUOUPOVBACPQVFVHVDIUQVBADPRTUDUTVGVEUQUTVGHVBUS
      SZVCVDUTVGVIVBURSVCVBURUSOVBBCPQVGVIVDIUTVBBDPRTUEUJUFUGEULCDUKUHUI $.
  $}

  ${
    $d C x y z $.  $d B y z $.  $d H x y z $.  $d A x y z $.  $d B z $.
    $d F z $.  $d G z $.
    fnopabco.1 $e |- ( x e. A -> B e. C ) $.
    fnopabco.2 $e |- F = { <. x , y >. | ( x e. A /\ y = B ) } $.
    fnopabco.3 $e |- G = { <. x , y >. | ( x e. A /\ y = ( H ` B ) ) } $.
    $( Composition of a function with a function abstraction.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 27-Dec-2014.) $)
    fnopabco $p |- ( H Fn C -> G = ( H o. F ) ) $=
      ( cfv cmpt cv wcel wceq wa copab df-mpt eqtr4i wfn ccom adantl a1i biimpi
      dffn5 fveq2 fmptco syl6reqr ) HEUAZHFUBACDHLZMZGUJABCEDBNZHLZUKFHANCOZDEO
      UJIUCFACDMZPUJFUOUMDPQABRUPJABCDSTUDUJHBEUNMPBEHUFUEUMDHUGUHGUOUMUKPQABRU
      LKABCUKSTUI $.
  $}

  ${
    $d A x y $.  $d B y $.  $d C y $.  $d M x y $.  $d R x y $.  $d S x y $.
    opropabco.1 $e |- ( x e. A -> B e. R ) $.
    opropabco.2 $e |- ( x e. A -> C e. S ) $.
    opropabco.3 $e |- F = { <. x , y >. | ( x e. A /\ y = <. B , C >. ) } $.
    opropabco.4 $e |- G = { <. x , y >. | ( x e. A /\ y = ( B M C ) ) } $.
    $( Composition of an operator with a function abstraction.  (Contributed by
       Jeff Madsen, 11-Jun-2010.) $)
    opropabco $p |- ( M Fn ( R X. S ) -> G = ( M o. F ) ) $=
      ( cop cv wcel wceq wa copab cxp opelxpi syl2anc cfv eqeq2i anbi2i opabbii
      co df-ov eqtri fnopabco ) ABCDEOZFGUAZHIJAPCQZDFQEGQULUMQKLDEFGUBUCMIUNBP
      ZDEJUHZRZSZABTUNUOULJUDZRZSZABTNURVAABUQUTUNUPUSUODEJUIUEUFUGUJUK $.
  $}

  ${
    $d A r s t u v w $.  $d B r s t u v w $.  $d F r s t u v w $.
    $( Condition for an operation to be one-to-one.  (Contributed by Jeff
       Madsen, 17-Jun-2010.) $)
    f1opr $p |- ( F : ( A X. B ) -1-1-> C <-> ( F : ( A X. B ) --> C /\
                          A. r e. A A. s e. B A. t e. A A. u e. B
                    ( ( r F s ) = ( t F u ) -> ( r = t /\ s = u ) ) ) ) $=
      ( vv vw cv cfv wceq weq wi wral wa co cop fveq2 cxp wf dff13 df-ov eqeq1d
      wf1 syl6eqr eqeq1 imbi12d ralbidv ralxp eqeq2d eqeq2 syl6bb 2ralbii bitri
      vex opth anbi2i ) CDUAZEFUFUTEFUBZIKZFLZJKZFLZMZIJNZOZJUTPZIUTPZQVAHKZGKZ
      FRZBKZAKZFRZMZHBNGANQZOZADPBCPZGDPHCPZQIJUTEFUCVJWAVAVJVMVEMZVKVLSZVDMZOZ
      JUTPZGDPHCPWAVIWFIHGCDVBWCMZVHWEJUTWGVFWBVGWDWGVCVMVEWGVCWCFLVMVBWCFTVKVL
      FUDUGUEVBWCVDUHUIUJUKWFVTHGCDWEVSJBACDVDVNVOSZMZWBVQWDVRWIVEVPVMWIVEWHFLV
      PVDWHFTVNVOFUDUGULWIWDWCWHMVRVDWHWCUMVKVLVNVOHUQGUQURUNUIUKUOUPUSUP $.
  $}

  $( Composition with a function and then with the converse.  (Contributed by
     Jeff Madsen, 2-Sep-2009.) $)
  cocnv $p |- ( ( Fun F /\ Fun G ) ->
                              ( ( F o. G ) o. `' G ) = ( F |` ran G ) ) $=
    ( wfun ccom ccnv crn cres coass cid wceq funcocnv2 adantl coeq2d resco wrel
    wa funrel coi1 syl reseq1d adantr syl5eqr eqtrd syl5eq ) ACZBCZPZABDBEZDABU
    HDZDZABFZGZABUHHUGUJAIUKGZDZULUGUIUMAUFUIUMJUEBKLMUGUNAIDZUKGZULAIUKNUEUPUL
    JUFUEUOAUKUEAOUOAJAQARSTUAUBUCUD $.

  $( Cancel a composition by a bijection by preapplying the converse.
     (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
     Carneiro, 27-Dec-2014.) $)
  f1ocan1fv $p |- ( ( Fun F /\ G : A -1-1-onto-> B /\ X e. B ) ->
                            ( ( F o. G ) ` ( `' G ` X ) ) = ( F ` X ) ) $=
    ( wfun wf1o wcel w3a ccnv cfv ccom wceq f1of 3ad2ant2 f1ocnv simp3 ffvelrnd
    wf syl fvco3 syl2anc f1ocnvfv2 3adant1 fveq2d eqtrd ) CFZABDGZEBHZIZEDJZKZC
    DLKZULDKZCKZECKUJABDSZULAHUMUOMUHUGUPUIABDNOUJBAEUKUHUGBAUKSZUIUHBAUKGUQABD
    PBAUKNTOUGUHUIQRABULCDUAUBUJUNECUHUIUNEMUGABEDUCUDUEUF $.

  $( Cancel a composition by the converse of a bijection by preapplying the
     bijection.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
  f1ocan2fv $p |- ( ( Fun F /\ G : A -1-1-onto-> B /\ X e. A ) ->
                            ( ( F o. `' G ) ` ( G ` X ) ) = ( F ` X ) ) $=
    ( wfun wf1o wcel w3a ccnv cfv ccom wceq f1orel dfrel2 sylib 3ad2ant2 fveq1d
    wrel fveq2d f1ocnv f1ocan1fv syl3an2 eqtr3d ) CFZABDGZEAHZIZEDJZJZKZCUILZKZ
    EDKZULKECKZUHUKUNULUHEUJDUFUEUJDMZUGUFDSUPABDNDOPQRTUFUEBAUIGUGUMUOMABDUABA
    CUIEUBUCUD $.

  ${
    $d x f A $.  $d B f $.  $d C f $.
    $( Intersection of Cartesian products over the same base set.  (Contributed
       by Jeff Madsen, 2-Sep-2009.) $)
    inixp $p |- ( X_ x e. A B i^i X_ x e. A C ) = X_ x e. A ( B i^i C ) $=
      ( vf cixp cin cv wfn cfv wcel wral wa an4 anidm r19.26 elin anbi12i elixp
      bicomi ralbii bitr3i bitri vex 3bitr4i ineqri ) EABCFZABDFZABCDGZFZEHZBIZ
      AHUKJZCKZABLZMZULUMDKZABLZMZMZULUMUIKZABLZMZUKUGKZUKUHKZMUKUJKUTULULMZUOU
      RMZMVCULUOULURNVFULVGVBULOVGUNUQMZABLVBUNUQABPVHVAABVAVHUMCDQTUAUBRUCVDUP
      VEUSABCUKEUDZSABDUKVISRABUIUKVISUEUF $.
  $}

  ${
    $d A a b c d h s t u v w x y z $.  $d R a b c d h s t u v w x y z $.
    $d S a b c d h s t u v w x y z $.  $d F a b c d h s t u v w x y z $.
    $d B a b c d h s t u v w x y z $.  $d C a b c d h s t u v w x y z $.
    $d X a c d h s t u v w x y z $.  $d P a c d h s t u v $.
    upixp.1 $e |- X = X_ b e. A ( C ` b ) $.
    upixp.2 $e |- P = ( w e. A |-> ( x e. X |-> ( x ` w ) ) ) $.
    $( Universal property of the indexed Cartesian product.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       12-Sep-2015.) $)
    upixp $p |- ( ( A e. R /\ B e. S /\ A. a e. A
                  ( F ` a ) : B --> ( C ` a ) ) -> E! h ( h : B --> X
                        /\ A. a e. A ( F ` a ) = ( ( P ` a ) o. h ) ) ) $=
      ( vu vs wcel cfv wceq cv wf wral w3a cmpt cvv ccom wa wi wal weu 3ad2ant2
      mptexg cixp ffvelrn expcom ralimdv impcom 3ad2antl3 fveq2 eleq12d cbvralv
      fveq1d sylib wb simpl1 mptelixpg syl mpbird cbvixpv eqtri syl6eleqr fmptd
      eqid nfv nfra1 nf3an fvex fvmpt3i adantl adantlr eqidd rgenw ixpexg ax-mp
      mpteq2dv eqeltri mptex fveq1 fmptco rsp 3ad2ant3 feqmptd 3eqtr4rd ralrimi
      imp simprl simplrr coeq1d eqeq12d rspccva sylan fvco3 adantr eqtrd 3eqtrd
      ex mpteq2dva wfn syl6eleq ixpfn dffn5 eqtr4d alrimiv coeq2 eqeq2d ralbidv
      feq1 anbi12d eqeu syl121anc ) CGRZDHRZDLUAZESZYDJSZUBZLCUCZUDZPDQCPUAZQUA
      ZJSZSZUEZUEZUFRZDKYOUBZYFYDFSZYOUGZTZLCUCZDKIUAZUBZYFYRUUBUGZTZLCUCZUHZUU
      BYOTZUIZIUJUUGIUKYCYBYPYHPDYNHUMULYIPDYNKYOYIYJDRZUHZYNQCYKESZUNZKUUKYNUU
      MRZYMUULRZQCUCZUUKYJYFSZYERZLCUCZUUPYHYBUUJUUSYCUUJYHUUSUUJYGUURLCYGUUJUU
      RDYEYJYFUOUPUQURUSUURUUOLQCYDYKTZUUQYMYEUULUUTYJYFYLYDYKJUTZVCYDYKEUTVAVB
      VDUUKYBUUNUUPVEYBYCYHUUJVFQCYMUULGVGVHVIKMCMUAZESZUNZUUMNMQCUVCUULUVBYKEU
      TVJVKVLZYOVNVMYIYTLCYBYCYHLYBLVOYCLVOYGLCVPVQYIYDCRZYTYIUVFUHZPDYDYNSZUEP
      DUUQUEYSYFUVGPDUVHUUQUVFUVHUUQTYIQYDYMUUQCYNYKYDTYJYLYFYKYDJUTVCYNVNYJYLV
      RVSVTWFUVGPADKYNYDAUAZSZUVHYOYRYIUUJYNKRUVFUVEWAUVGYOWBUVFYRAKUVJUEZTYIBY
      DAKBUAZUVISZUEZUVKCFUVLYDTAKUVMUVJUVLYDUVIUTWFOAKUVMKUVDUFNUVCUFRZMCUCUVD
      UFRUVOMCUVBEVRWCMCUVCUFWDWEWGWHZVSVTYDUVIYNWIWJUVGPDYEYFYIUVFYGYHYBUVFYGU
      IYCYGLCWKWLWPWMWNXGWOYIUUIIYIUUGUUHYIUUGUHZUUBPDYJUUBSZUEYOUVQPDKUUBYIUUC
      UUFWQZWMUVQPDYNUVRUVQUUJUHZYNQCYKUVRSZUEZUVRUVTQCYMUWAUVTYKCRZUHZYMYJYKFS
      ZUUBUGZSZUVRUWESZUWAUWDYJYLUWFUVTUUFUWCYLUWFTZYIUUCUUFUUJWRUUEUWILYKCUUTY
      FYLUUDUWFUVAUUTYRUWEUUBYDYKFUTWSWTXAXBVCUVTUWGUWHTZUWCUVQUUCUUJUWJUVSDKYJ
      UWEUUBXCXBXDUWDUWHUVRAKYKUVISZUEZSZUWAUWDUVRUWEUWLUWCUWEUWLTUVTBYKUVNUWLC
      FUVLYKTAKUVMUWKUVLYKUVIUTWFOUVPVSVTVCUVTUWMUWATZUWCUVTUVRKRZUWNUVQUUCUUJU
      WOUVSDKYJUUBUOXBZAUVRUWKUWAKUWLYKUVIUVRWIUWLVNYKUVIVRVSVHXDXEXFXHUVTUVRCX
      IZUVRUWBTUVTUVRUVDRUWQUVTUVRKUVDUWPNXJMCUVCUVRXKVHQCUVRXLVDXMXHXMXGXNUUGY
      QUUAUHIYOUFUUHUUCYQUUFUUADKUUBYOXRUUHUUEYTLCUUHUUDYSYFUUBYOYRXOXPXQXSXTYA
      $.
  $}

  ${
    $d A x y $.
    abrexdom.1 $e |- ( y e. A -> E* x ph ) $.
    $( An indexed set is dominated by the indexing set.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    abrexdom $p |- ( A e. V -> { x | E. y e. A ph } ~<_ A ) $=
      ( wcel wrex cab cv wa copab crn cdom wex df-rex abbii wbr cvv wmo cdm wfn
      rnopab eqtr4i wss dmopabss ssexg mpan funopab wi moanimv mpbir mpgbir a1i
      wfun funfn sylib fnrndomg sylc ssdomg mpi domtr syl2anc syl5eqbr ) DEGZAC
      DHZBIZCJDGZAKZCBLZMZDNVGVICOZBIVKVFVLBACDPQVICBUCUDVEVKVJUAZNRZVMDNRZVKDN
      RVEVMSGZVJVMUBZVNVMDUEZVEVPACBDUFZVMDEUGUHVEVJUOZVQVTVEVTVIBTZCVICBUIWAVH
      ABTUJFVHABUKULUMUNVJUPUQVMSVJURUSVEVRVOVSVMDEUTVAVKVMDVBVCVD $.
  $}

  ${
    $d A x y $.  $d B x $.
    $( An indexed set is dominated by the indexing set.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    abrexdom2 $p |- ( A e. V -> { x | E. y e. A x = B } ~<_ A ) $=
      ( cv wceq wmo wcel moeq a1i abrexdom ) AFDGZABCEMAHBFCIADJKL $.
  $}

  ${
    $d A x y z f $.  $d B x y z f $.  $d ph z f $.  $d ps z $.
    ac6gf.1 $e |- F/ y ps $.
    ac6gf.2 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Axiom of Choice.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    ac6gf $p |- ( ( A e. C /\ A. x e. A E. y e. B ph ) ->
                                E. f ( f : A --> B /\ A. x e. A ps ) ) $=
      ( vz wrex wral wcel wsb cv wf wa wex cbvrexsv ralbii cfv sbhypf ac6sg imp
      sylan2b ) ADFLZCEMEGNZADKOZKFLZCEMZEFHPZQBCEMRHSZUGUJCEADKFTUAUHUKUMUIBCK
      EFHGABDKCPULUBIJUCUDUEUF $.
  $}

  ${
    $d A x y c z w v q $.  $d B x y c z w v q $.  $d ph c z w v q $.
    $( If for every element of an indexing set ` A ` there exists a
       corresponding element of another set ` B ` , then there exists a subset
       of ` B ` consisting only of those elements which are indexed by ` A ` .
       Used to avoid the Axiom of Choice in situations where only the range of
       the choice function is needed.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    indexa $p |- ( ( B e. M /\ A. x e. A E. y e. B ph ) -> E. c
          ( c C_ B /\ A. x e. A E. y e. c ph /\ A. y e. c E. x e. A ph ) ) $=
      ( vz vw vv wcel cv wsbc wrex wral nfv wa sbceq2a nfcv nfsbc1v cvv wss w3a
      crab wex rabexg ssrab2 a1i nfre1 rspcev ancoms anim2i anasss wceq sbcbidv
      rexbidv elrab sylibr nfsbc nfrex nfrab cbvrexf sylib exp31 rexlimd cbvrex
      sylancom ralimia syl6bb simprbi rgen sseq1 rexeqf ralbid raleqf 3anbi123d
      3jca nfeq2 spcegv imp syl2an ) EFKACHLZMZBILZMZIDNZHEUDZUAKZWGEUBZACWGNZB
      DOZABDNZCWGOZUCZGLZEUBZACWONZBDOZWLCWOOZUCZGUEZACENZBDOZWFHEFUFXCWIWKWMWI
      XCWFHEUGUHXBWJBDBLZDKZAWJCEXECPACWGUIXECLZEKZAWJXEXGQZAQZACJLZMZJWGNZWJXH
      AXFWGKZXLXIXGABWDMZIDNZQZXMAXHXPAXEXGXPXGAXEQZXPXQXOXGXEAXOXNAIXDDABWDRZU
      JUKULUKUMUKWFXOHXFEWBXFUNZWEXNIDXSWCABWDACWBRUOUPZUQURXKAJXFWGACXJRZUJVGX
      KAJCWGJWGSWFCHEWECIDCDSWCCBWDCWDSACWBTUSUTCESVAZACXJTAJPYAVBVCVDVEVHWMXCW
      LCWGXMXGWLWFWLHXFEXSWFXOWLXTXNAIBDABWDTAIPXRVFVIUQVJVKUHVQWHWNXAWTWNGWGUA
      WOWGUNZWPWIWRWKWSWMWOWGEVLYCWQWJBDBWOWGWFBHEWEBIDBDSWCBWDTUTBESVAVRACWOWG
      CWOSZYBVMVNWLCWOWGYDYBVOVPVSVTWA $.
  $}

  ${
    $d A c f x y $.  $d B c f x y $.  $d ph f c $.
    $( If for every element of an indexing set ` A ` there exists a
       corresponding element of another set ` B ` , then there exists a subset
       of ` B ` consisting only of those elements which are indexed by ` A ` ,
       and which is dominated by the set ` A ` .  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    indexdom $p |- ( ( A e. M /\ A. x e. A E. y e. B ph ) ->
            E. c ( ( c ~<_ A /\ c C_ B ) /\ ( A. x e. A E. y e. c ph
                                        /\ A. y e. c E. x e. A ph ) ) ) $=
      ( vf wcel wrex wral wa cv wex cdom wbr wss cvv adantr anbi12d wf cfv wsbc
      nfsbc1v sbceq1a ac6gf crn wfn cdm fdm vex dmex syl6eqelr ffn fnrndomg frn
      sylc nfv nfan wfun ffun eleq2d biimpar fvelrn syl2anc adantlr rsp adantll
      nfra1 imp rspesbca ex ralrimi nfcv nfral wceq wb fvelrnb wi adantl eqcoms
      syl biimprcd syl6 reximdai sylbid rnex breq1 sseq1 rexeq ralbidv syl22anc
      raleq spcev exlimiv ) DFIACEJBDKLDEHMZUAZACBMZWPUBZUCZBDKZLZHNGMZDOPZXCEQ
      ZLZACXCJZBDKZABDJZCXCKZLZLZGNZAWTBCDEFHACWSUDZACWSUEZUFXBXMHXBWPUGZDOPZXP
      EQZACXPJZBDKZXICXPKZXMWQXQXAWQDRIWPDUHZXQWQDWPUIZRDEWPUJZWPHUKZULUMDEWPUN
      ZDRWPUOUQSWQXRXADEWPUPSXBXSBDWQXABWQBURWTBDVIUSZXBWRDIZXSXBYHLWSXPIZWTXSW
      QYHYIXAWQYHLWPUTZWRYCIZYIWQYJYHDEWPVASWQYKYHWQYCDWRYDVBVCWRWPVDVEVFXAYHWT
      WQXAYHWTWTBDVGZVJVHACWSXPVKVEVLVMXBXICXPWQXACWQCURWTCBDCDVNXNVOUSXBCMZXPI
      ZWSYMVPZBDJZXIWQYNYPVQZXAWQYBYQYFBDYMWPVRWBSXBYOABDYGXBYHWTYOAVSXAYHWTVSW
      QYLVTYOAWTAWTVQYMWSXOWAWCWDWEWFVMXLXQXRLZXTYALZLGXPWPYEWGXCXPVPZXFYRXKYSY
      TXDXQXEXRXCXPDOWHXCXPEWITYTXHXTXJYAYTXGXSBDACXCXPWJWKXICXCXPWMTTWNWLWOWB
      $.
  $}

  ${
    $d R x y z $.  $d A x y z $.  $d B x y z $.
    $( A subset of a well-founded set has an infimum.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    frinfm $p |- ( ( R Fr A /\ ( B e. C /\ B C_ A /\ B =/= (/) ) ) ->
                    E. x e. A ( A. y e. B -. x `' R y /\
                    A. y e. A ( y `' R x -> E. z e. B y `' R z ) ) ) $=
      ( wfr wcel wss c0 wa cv wbr wn wral wrex wi vex ex wne w3a ccnv fri exp43
      ancom1s 3imp2 ssel2 adantrr brcnv biimpi ralimi ad2antll rspcev ralrimivw
      con3i breq2 ad2antrl jca32 reximdv2 adantl 3ad2antr2 mpd ) DGHZEFIZEDJZEK
      UAZUBLBMZAMZGNZOZBEPZAEQZVIVHGUCZNZOZBEPZVHVIVNNZVHCMZVNNZCEQZRZBDPZLZADQ
      ZVDVEVFVGVMVDVEVFVGVMVEVDVFVGLVMABDEFGUDUFUEUGVDVEVFVMWERZVGVFWFVDVFVLWDA
      EDVFVIEIZVLLZVIDIZWDLVFWHLWIVQWCVFWGWIVLEDVIUHUIVLVQVFWGVKVPBEVOVJVOVJVIV
      HGASBSUJUKUPULUMWGWCVFVLWGWBBDWGVRWAVTVRCVIEVSVIVHVNUQUNTUOURUSTUTVAVBVC
      $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d R x y z $.
    $( A non-empty subset of a well-ordered set has a lower bound.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    welb $p |- ( ( R We A /\ ( B e. C /\ B C_ A /\ B =/= (/) ) ) ->
              ( `' R Or B /\ E. x e. B ( A. y e. B -. x `' R y /\
                        A. y e. B ( y `' R x -> E. z e. B y `' R z ) ) ) ) $=
      ( wwe wcel wss w3a wa wor cv wbr wral wrex syl 3ad2antr2 id c0 ccnv wn wi
      wne wess impcom weso cnvso sylib wfr wefr 3anim123i adantl frinfm syl2anc
      ssid a1i jca ) DGHZEFIZEDJZEUAUEZKZLZEGUBZMZANZBNZVFOUCBEPVIVHVFOVICNVFOC
      EQUDBEPLAEQZUTVAVBVGVCUTVBLZEGMZVGVKEGHZVLVBUTVMEDGUFUGZEGUHREGUIUJSVEEGU
      KZVAEEJZVCKZVJUTVAVBVOVCVKVMVOVNEGULRSVDVQUTVAVAVBVPVCVCVATVPVBEUQURVCTUM
      UNABCEEFGUOUPUS $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d R x y z $.
    $( Existence of supremum.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    supex2g $p |- ( A e. C -> sup ( B , A , R ) e. _V ) $=
      ( vx vy vz wcel csup cv wbr wn wral wrex wi wa crab cuni cvv df-sup syl
      rabexg uniexg syl5eqel ) ACHZBADIEJZFJZDKLFBMUGUFDKUGGJDKGBNOFAMPZEAQZRZS
      EFGBADTUEUISHUJSHUHEACUBUISUCUAUD $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d R x y z $.
    $( Closure of supremum.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    supclt $p |- ( ( R Or A /\ E. x e. A ( A. y e. B -. x R y /\ A. y e. A
            ( y R x -> E. z e. B y R z ) ) ) -> sup ( B , A , R ) e. A ) $=
      ( wor cv wbr wn wral wrex wi wa simpl simpr supcl ) DFGZAHZBHZFIJBEKTSFIT
      CHFICELMBDKNADLZNABCDEFRUAORUAPQ $.
  $}

  ${
    $d A x y z $.  $d B x y z $.  $d C x y z $.  $d R x y z $.
    $( Upper bound property of supremum.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    supubt $p |- ( ( R Or A /\ E. x e. A ( A. y e. B -. x R y /\
                        A. y e. A ( y R x -> E. z e. B y R z ) ) ) ->
                                ( C e. B -> -. sup ( B , A , R ) R C ) ) $=
      ( wor cv wbr wn wral wrex wi wa simpl simpr supub ) DGHZAIZBIZGJKBELUATGJ
      UACIGJCEMNBDLOADMZOABCDEFGSUBPSUBQR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Real and complex numbers; integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A u v w x y z $.  $d B u v w x y z $.  $d ph u v w y $.
    $( Combine a finite set of lower bounds.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    filbcmb $p |- ( ( A e. Fin /\ A =/= (/) /\ B C_ RR ) ->
                      ( A. x e. A E. y e. B A. z e. B ( y <_ z -> ph )
                    -> E. y e. B A. z e. B ( y <_ z -> A. x e. A ph ) ) ) $=
      ( vw vu vv cfn wcel cr cv cle wi wral wrex wa ssel2 adantlr wne reex ssex
      c0 wss w3a wbr cvv indexfi 3expia sylan2 3adant2 rexn0 rexlimivw 3ad2ant2
      r19.2z syl ex ad2antrr sstr ancoms fimaxre sylan anasss ancom2s 3ad2antl3
      anassrs syld a1dd 3impd nfv nfcv nfre1 nfral nfra1 nfrex weq breq1 imbi1d
      ralbidv cbvrexv rsp adantrr ad2ant2r adantr rspccva adantll simplrr letrd
      nfan pm2.27 ad2antlr mpid syl5 rexlimdva ralimdva imp an32s exp32 ralrimi
      syl5bi reximdai ssrexv exp43 3ad2ant3 mpdd ) EJKZEUDUAZFLUEZUFZCMZDMZNUGZ
      AOZDFPZCFQBEPZGMZFUEZXOCXQQZBEPZXOBEQCXQPZUFZGJQZXMABEPZOZDFPZCFQZXGXIXPY
      COZXHXIXGFUHKZYHFLUBUCXGYIXPYCXOBCEFUHGUIUJUKULXJYBYGGJXJXQJKZRZYBHMZXKNU
      GZHXQPZCXQQZYGYKXRXTYAYOYKXRXTYAYOOOYKXRRZXTYOYAYPXTXQUDUAZYOXJXTYQOZYJXR
      XHXGYRXIXHXTYQXHXTRXSBEQYQXSBEUPXSYQBEXOCXQUMUNUQURUOUSXJYJXRYQYOOZXIXGYJ
      XRRYSXHXIXRYJYSXIXRYJYSXIXRRZXQLUEZYJYSXRXIUUAXQFLUTVAUUAYJYQYOCHXQVBUJVC
      VDVEVFVGVHVIURVJXJYBYOYGOZOZYJXIXGUUCXHXIXRXTYAUUBXIXRXTYAUUBYTXTYARZRYOY
      FCXQQZYGYTXTYOUUEOYAYTXTRZYNYFCXQYTXTCYTCVKXSCBECEVLXOCXQVMVNWJUUFXKXQKZY
      NYFUUFUUGYNRZRYEDFUUFUUHDYTXTDYTDVKXSDBEDEVLXODCXQDXQVLXNDFVOVPVNWJUUHDVK
      WJYTUUHXTXLFKZYEOYTUUHRZXTRUUIXMYDUUJUUIXMRZXTYDUUJUUKRZXTYDUULXSABEXSIMZ
      XLNUGZAOZDFPZIXQQUULBMEKZRZAXOUUPCIXQCIVQZXNUUODFUUSXMUUNAXKUUMXLNVRVSVTW
      AUURUUPAIXQUULUUMXQKZUUPAOUUQUUPUUIUUOOZUULUUTRZAUUODFWBUVBUVAUUNAUVBUUMX
      KXLUUJUUTUUMLKZUUKYTUUTUVCUUHXIXRUUTUVCXRUUTRXIUUMFKUVCXQFUUMSFLUUMSUKVGT
      TUUJXKLKZUUKUUTYTUUGUVDYNXIXRUUGUVDXRUUGRXIXKFKUVDXQFXKSFLXKSUKVGWCUSUULX
      LLKZUUTYTUUIUVEUUHXMXIUUIUVEXRFLXLSTWDWEUUJUUTUUMXKNUGZUUKUUHUUTUVFYTYNUU
      TUVFUUGYMUVFHUUMXQYLUUMXKNVRWFWGWGTUUJUUIXMUUTWHWIUUKUVAUUOOZUUJUUTUUIUVG
      XMUUIUUOWKWEWLWMWNTWOXAWPWQWRWSWRWTWSXBWCXRUUEYGOXIUUDYFCXQFXCWLVHXDVJXEW
      EXFWOVH $.
  $}

  $( Two ways of expressing the remainder when ` A ` is divided by ` B ` .
     (Contributed by Jeff Madsen, 17-Jun-2010.) $)
  rdr $p |- ( ( A e. RR /\ B e. RR+ ) ->
                      ( ( A - ( A mod B ) ) / B ) = ( |_ ` ( A / B ) ) ) $=
    ( moddiffl ) ABC $.

  $( Membership of a product in a finite interval of integers.  (Contributed by
     Jeff Madsen, 17-Jun-2010.) $)
  fzmul $p |- ( ( M e. ZZ /\ N e. ZZ /\ K e. NN ) -> ( J e. ( M ... N ) ->
                        ( K x. J ) e. ( ( K x. M ) ... ( K x. N ) ) ) ) $=
    ( cz wcel w3a cfz co cle wbr cmul wb wi wa cr zre 3expa zmulcl ex elfz1 cc0
    cn 3adant3 clt nnre nngt0 jca lemul2 syl3an biimpd adantllr ancom1s anim12d
    adantlll nnz 3anim123d elfz 3coml syl com12 sylibrd an32s exp4b 3impd 3impa
    syl6 imp sylbid ) CEFZDEFZBUCFZGACDHIFZAEFZCAJKZADJKZGZBALIZBCLIZBDLIZHIFZV
    JVKVMVQMVLACDUAUDVJVKVLVQWANVJVKOZVLOZVNVOVPWAWCVNVOVPWAWBVNVLVOVPOZWANWBVN
    OZVLOZWDVSVRJKZVRVTJKZOZWAWFVOWGVPWHVJVNVLVOWGNVKVJVNOVLOVOWGVJVNVLVOWGMZVJ
    CPFVNAPFZVLBPFZUBBUEKZOZWJCQAQZVLWLWMBUFBUGUHZCABUIUJRUKULVKVNVLVPWHNVJVKVN
    OVLOVPWHVNVKVLVPWHMZVNVKVLWQVNWKVKDPFVLWNWQWODQWPADBUIUJRUMUKUOUNWEVLWAWIMZ
    VJVKVNVLWRNVLVJVKVNGZWRVLBEFZWSWRNBUPWTWSVSEFZVTEFZVREFZGWRWTVJXAVKXBVNXCWT
    VJXABCSTWTVKXBBDSTWTVNXCBASTUQXCXAXBWRVRVSVTURUSVGUTVARVHVBVCVDVEVFVI $.

  $( Membership of a sum in a finite interval of integers.  (Contributed by
     Jeff Madsen, 17-Jun-2010.) $)
  fzadd2 $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( O e. ZZ /\ P e. ZZ ) ) ->
                    ( ( J e. ( M ... N ) /\ K e. ( O ... P ) ) ->
                        ( J + K ) e. ( ( M + O ) ... ( N + P ) ) ) ) $=
    ( cz wcel wa cfz co cle wbr w3a caddc wi cr zre anim12i zaddcl bi2anan9 an6
    le2add syl2an impr 3adantr3 adantlr syl2anr 3adantr2 adantll wb elfz syl3an
    elfz1 3expb ancoms 3ad2antr1 mpbir2and ex an4s syl5bi sylbid ) DGHZEGHZIZFG
    HZAGHZIZIZBDEJKHZCFAJKHZIBGHZDBLMZBELMZNZCGHZFCLMZCALMZNZIZBCOKZDFOKZEAOKZJ
    KHZVEVJVOVHVKVSBDEUNCFAUNUAVTVLVPIZVMVQIZVNVRIZNZVIWDVLVMVNVPVQVRUBVCVFVDVG
    WHWDPVCVFIZVDVGIZIZWHWDWKWHIWDWBWALMZWAWCLMZWIWHWLWJWIWEWFWLWGWIWEWFWLWIDQH
    ZFQHZIBQHZCQHZIZWFWLPWEVCWNVFWODRFRSVLWPVPWQBRCRSZDFBCUCUDUEUFUGWJWHWMWIWJW
    EWGWMWFWJWEWGWMWEWREQHZAQHZIWGWMPWJWSVDWTVGXAERARSBCEAUCUHUEUIUJWKWFWEWDWLW
    MIUKZWGWEWKXBWEWIWJXBWEWAGHWIWBGHWJWCGHXBBCTDFTEATWAWBWCULUMUOUPUQURUSUTVAV
    B $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Sequences and sums
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d f g h j k n w x y A $.  $d h j k m w x J $.  $d f g h j k m n w x y M $.
    $d g j ch $.  $d j m n w x F $.  $d f h j k x y ps $.  $d f g j n x y si $.
    $d f g h j k m n w x G $.  $d j n w x y ph $.  $d n w x y th $.  $d h V $.
    $d h j k n w x y ta $.  $d f g h j k m n w x y Z $.
    sdc.1 $e |- Z = ( ZZ>= ` M ) $.
    sdc.2 $e |- ( g = ( f |` ( M ... n ) ) -> ( ps <-> ch ) ) $.
    sdc.3 $e |- ( n = M -> ( ps <-> ta ) ) $.
    sdc.4 $e |- ( n = k -> ( ps <-> th ) ) $.
    sdc.5 $e |- ( ( g = h /\ n = ( k + 1 ) ) -> ( ps <-> si ) ) $.
    sdc.6 $e |- ( ph -> A e. V ) $.
    sdc.7 $e |- ( ph -> M e. ZZ ) $.
    sdc.8 $e |- ( ph -> E. g ( g : { M } --> A /\ ta ) ) $.
    sdc.9 $e |- ( ( ph /\ k e. Z ) -> ( ( g : ( M ... k ) --> A /\ th ) ->
                  E. h ( h : ( M ... ( k + 1 ) ) --> A /\
                         g = ( h |` ( M ... k ) ) /\ si ) ) ) $.
    ${
      sdc.10 $e |- J = { g | E. n e. Z ( g : ( M ... n ) --> A /\ ps ) } $.
      sdc.11 $e |- F = ( w e. Z , x e. J |-> { h | E. k e. Z
     ( h : ( M ... ( k + 1 ) ) --> A /\ x = ( h |` ( M ... k ) ) /\ si ) } ) $.
      ${
        sdc.12 $e |- F/ k ph $.
        sdc.13 $e |- ( ph -> G : Z --> J ) $.
        sdc.14 $e |- ( ph -> ( G ` M ) : ( M ... M ) --> A ) $.
        sdc.15 $e |- ( ( ph /\ w e. Z ) ->
                       ( G ` ( w + 1 ) ) e. ( w F ( G ` w ) ) ) $.
        $( Lemma for ~ sdc .  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
        sdclem2 $p |- ( ph -> E. f ( f : Z --> A /\ A. n e. Z ch ) ) $=
          ( vm cv cfv cmpt wf cfz co wsbc wral wa wex wcel ffvelrnda cab eleq2i
          wrex nfcv nfv nfsbc1v nfan nfrex fvex wceq feq1 sbceq1a anbi12d elabf
          rexbidv sylib weq cdm fdm adantr wi caddc fveq2 oveq2 mpteq1d eqeq12d
          cuz c1 imbi2d id fveq12d eqid fvmpt adantl fveq1d ralrimi wfn ffn syl
          ex wb fnmpti sylancl a1i cres w3a cvv simpr wss cmap ovex ssexg eqeq1
          sylancr reseq1 eqeq2d fzssp1 syl6eleq fzopth mpbid simprd ax-mp fvres
          resmpt eluzfz2 syl5ibrcom sylbid mpd syl6eq bitrd sbcbidv dfsbcq 3exp
          bitri elfz1eq fveq2d eqtr2d eqfnfv mpbird 3simpa reximi eqeltri simpl
          cz ss2abi elmapg mpan2 syl5ibr abssdv abrexex2g 3anbi2d abbidv eleq1d
          a1d imbi12d ovmpt4g 3com12 vtoclga syl6eqss sseldd elab simprl fssres
          syl3c simprr fneq1d mpbiri fndm eqtr3d simplr oveq1d oveq2d wo elfzp1
          reseq2d syl6req syl5ibcom eqeltrrd peano2uz 4syl eqcomd jaod ralrimiv
          eqtrd ad2antrl eqfnfv2 mpbir2and imbi1d expimpd rexlimd expcom sylbir
          expr a2d uzind4 eleq2s impcom dmeqd dmmptg mprg eqeq1d syl6bi equcoms
          syl5 feq2d biimpcd sylcom rexlimdvw simpld ffvelrnd cbvmptv fmpt 3syl
          mpteq1 cbvralv sylibr mptex vex resex fzssuz sseqtr4i syl5bbr ralbidv
          sbcie spcev syl2anc ) ATIUPTUPUQZUYOPURZURZUSZUTZBKUPRNUQZVAVBZUYQUSZ
          VCZNTVDZTIJUQZUTZCNTVDZVEZJVFAMUQZVUIPURZURZIVGZMTVDUYSAVULMTULAVUITV
          GZVULAVUMVEZRVUIVAVBZIVUIVUJVUNVUOIVUJUTZDKVUJVCZVUNVUAIVUJUTZBKVUJVC
          ZVEZNTVKZVUPVUQVEZVUNVUJQVGZVVAATQVUIPUMVHVVCVUJVUAIKUQZUTZBVEZNTVKZK
          VIZVGVVAQVVHVUJUJVJVVGVVAKVUJVUTKNTKTVLVURVUSKVURKVMBKVUJVNVOVPVUIPVQ
          VVDVUJVRZVVFVUTNTVVIVVEVURBVUSVUAIVVDVUJVSBKVUJVTWAWCWBUUBWDVUNVUTVVB
          NTVUNVUTMNWEZVVBVUTVUJWFZVUAVRZVUNVVJVURVVLVUSVUAIVUJWGWHVUNVVLRRVRZV
          VJVEZVVJVUNVVLVUOVUAVRZVVNVUNVVKVUOVUAVUNVVKUPVUOUYQUSZWFZVUOVUNVUJVV
          PVUMAVUJVVPVRZAVVRWIZVUIRWOURZTAGUQZPURZUPRVWAVAVBZUYQUSZVRZWIARPURZU
          PRRVAVBZUYQUSZVRZWIZAHUQZPURZUPRVWKVAVBZUYQUSZVRZWIAVWKWPWJVBZPURZUPR
          VWPVAVBZUYQUSZVRZWIVVSGHRVUIVWARVRZVWEVWIAVXAVWBVWFVWDVWHVWARPWKVXAUP
          VWCVWGUYQVWARRVAWLWMWNWQGHWEZVWEVWOAVXBVWBVWLVWDVWNVWAVWKPWKVXBUPVWCV
          WMUYQVWAVWKRVAWLWMWNWQVWAVWPVRZVWEVWTAVXCVWBVWQVWDVWSVWAVWPPWKVXCUPVW
          CVWRUYQVWAVWPRVAWLWMWNWQGMWEZVWEVVRAVXDVWBVUJVWDVVPVWAVUIPWKVXDUPVWCV
          UOUYQVWAVUIRVAWLWMWNWQVWJRUULVGAVWIVUIVWFURZVUIVWHURZVRZMVWGVDZAVXGMV
          WGULAVUIVWGVGZVXGAVXIVEZVXFVUKVXEVXIVXFVUKVRAUPVUIUYQVUKVWGVWHUPMWEZU
          YOVUIUYPVUJUYOVUIPWKVXKWRWSZVWHWTZVUIVUJVQXAXBVXJVUIVUJVWFVXJVUIRPVXI
          VUIRVRAVUIRUUCXBUUDXCUUEXHXDAVWFVWGXEZVWHVWGXEVWIVXHXIAVWGIVWFUTVXNUN
          VWGIVWFXFXGUPVWGUYQVWHUYOUYPVQZVXMXJMVWGVWFVWHUUFXKUUGXLVWKVVTVGZAVWO
          VWTVXPVWKTVGZAVWOVWTWIZWITVVTVWKUAVJAVXQVXRAVXQVEZRVUIWPWJVBZVAVBZIVW
          QUTZVWLVWQVUOXMZVRZVEZMTVKZVXRVXSVWQVYAILUQZUTZVWLVYGVUOXMZVRZVEZMTVK
          ZLVIZVGVYFVXSVWKVWLOVBZVYMVWQVXSVYNVYHVYJFXNZMTVKZLVIZVYMVXSVWLQVGVXQ
          VYQXOVGZVYNVYQVRZATQVWKPUMVHAVXQXPVXSVYQVYMXQVYMXOVGZVYRVYPVYLLVYOVYK
          MTVYHVYJFUUHUUIUUMZVXSTXOVGVYKLVIZXOVGZMTVDVYTTVVTXOUARWOVQUUJZVXSWUC
          MTAVXQMULVXQMVMVOZVXSWUCVUMVXSWUBIVYAXRVBZXQZWUFXOVGWUCVXSISVGZWUGAWU
          HVXQUFWHWUHVYKLWUFVYKVYGWUFVGZWUHVYHVYHVYJUUKWUHVYAXOVGWUIVYHXIRVXTVA
          XSIVYAVYGSXOUUNUUOUUPUUQXGIVYAXRXSWUBWUFXOXTXKUVBXDVYKMLTXOXOUURYBVYQ
          VYMXOXTYBVXQVYHVWAVYIVRZFXNZMTVKZLVIZXOVGZVWKVWAOVBZWUMVRZWIZWIVXQVYR
          VYSWIZWIGVWLQVWAVWLVRZWUQWURVXQWUSWUNVYRWUPVYSWUSWUMVYQXOWUSWULVYPLWU
          SWUKVYOMTWUSWUJVYJVYHFVWAVWLVYIYAUUSWCUUTZUVAWUSWUOVYNWUMVYQVWAVWLVWK
          OWLWUTWNUVCWQVWAQVGZVXQWUNWUPVXQWVAWUNWUPHGTQWUMOXOUKUVDUVEUUAUVFUVLW
          UAUVGUOUVHVYLVYFLVWQVWPPVQVYGVWQVRZVYKVYEMTWVBVYHVYBVYJVYDVYAIVYGVWQV
          SWVBVYIVYCVWLVYGVWQVUOYCYDWAWCUVIWDVXSVYEVXRMTWUEVXRMVMVXSVUMVYEVXRWI
          VXSVUMVEZVYBVYDVXRWVCVYBVEVXRVYDVYCVWNVRZVWTWIWVCVYBWVDVWTWVCVYBWVDVE
          ZVEZVWTVYAVWRVRZVWAVWQURZVWAVWSURZVRZGVYAVDZWVFVXTVWPRVAWVFVUIVWKWPWJ
          WVFVVMMHWEZWVFVUOVWMVRZVVMWVLVEZWVFVYCWFZVUOVWMWVFVUOIVYCUTZWVOVUOVRW
          VFVYBVUOVYAXQWVPWVCVYBWVDUVJRVUIYEVYAIVUOVWQUVKXKVUOIVYCWGXGWVFVYCVWM
          XEZWVOVWMVRWVFWVQVWNVWMXEUPVWMUYQVWNVXOVWNWTXJWVFVWMVYCVWNWVCVYBWVDUV
          MZUVNUVOVWMVYCUVPXGUVQZWVFVUIVVTVGZWVMWVNXIWVFVUITVVTVXSVUMWVEUVRUAYF
          ZRVWKRVUIYGXGYHYIZUVSZUVTWVFWVJGVYAWVFVWAVYAVGZVWAVUOVGZVWAVXTVRZUWAZ
          WVJWVFWVTWWDWWGXIWWAVWARVUIUWBXGWVFWWEWVJWWFWVFVWAVYCURZVWAVWSVUOXMZU
          RZVRWWEWVJWVFVWAVYCWWIWVFVYCVWNWWIWVRWVFWWIVWSVWMXMZVWNWVFVUOVWMVWSWV
          SUWCVWMVWRXQWWKVWNVRRVWKYEUPVWRVWMUYQYLYJUWDUWLXCWWEWWHWVHWWJWVIVWAVU
          OVWQYKVWAVUOVWSYKWNUWEWVFWWFVXCWVJWVFVXTVWPVWAWWCYDWVFWVJVXCVWPVWQURZ
          VWPVWSURZVRWVFWWMWWLWVFVXPVWPVVTVGVWPVWRVGWWMWWLVRWVFVUIVWKVVTWWBWWAU
          WFRVWKUWGRVWPYMUPVWPUYQWWLVWRVWSUYOVWPVRZUYOVWPUYPVWQUYOVWPPWKWWNWRWS
          VWSWTZVWPVWQVQXAUWHUWIVXCWVHWWLWVIWWMVWAVWPVWQWKVWAVWPVWSWKWNYNYOUWJY
          OUWKWVFVWQVYAXEZVWSVWRXEVWTWVGWVKVEXIVYBWWPWVCWVDVYAIVWQXFUWMUPVWRUYQ
          VWSVXOWWOXJGVYAVWRVWQVWSUWNXKUWOUXAVYDVWOWVDVWTVWLVYCVWNYAUWPYNUWQXHU
          WRYPUWSUWTUXBUXCUAUXDUXEZUXFUYQXOVGZVVQVUOVRUPVUOUPVUOUYQXOUXGWWRUYOV
          UOVGVXOXLUXHYQUXIVUNWVTVVOVVNXIVUNVUITVVTAVUMXPUAYFZRUYTRVUIYGXGYRVVM
          VVJXPUXJUXLVVJVUTVVBVUTVVBXINMNMWEZVURVUPVUSVUQWWTVUAVUOIVUJUYTVUIRVA
          WLZUXMWWTBDKVUJUDYSWAUXKUXNUXOUXPYPZUXQVUNWVTVUIVUOVGWWSRVUIYMXGUXRXH
          XDMTIVUKUYRUPMTUYQVUKVXLUXSUXTWDADKVVPVCZMTVDVUDAWXCMTULAVUMWXCVUNVUQ
          WXCVUNVUPVUQWXBYIVUNVVRVUQWXCXIWWQDKVUJVVPYTXGYHXHXDVUCWXCNMTWWTVUCBK
          VVPVCZWXCWWTVUAVUOVRVUBVVPVRVUCWXDXIWXAUPVUAVUOUYQUYBBKVUBVVPYTUYAWWT
          BDKVVPUDYSYRUYCUYDVUHUYSVUDVEJUYRUPTUYQWUDUYEVUEUYRVRZVUFUYSVUGVUDTIV
          UEUYRVSWXECVUCNTCBKVUEVUAXMZVCZWXEVUCBCKWXFVUEVUAJUYFUYGUBUYLWXEWXFVU
          BVRWXGVUCXIWXEWXFUYRVUAXMZVUBVUEUYRVUAYCVUATXQWXHVUBVRVUAVVTTRUYTUYHU
          AUYIUPTVUAUYQYLYJYQBKWXFVUBYTXGUYJUYKWAUYMUYN $.
      $}

      $d g h k ph $.
      $( Lemma for ~ sdc .  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
      sdclem1 $p |- ( ph -> E. f ( f : Z --> A /\ A. n e. Z ch ) ) $=
        ( vj vm csn cv wf wa wral wex cz wcel cc0 cif cuz cfv wceq c1 caddc w3a
        co cvv cxp cpw c0 cdif cfz wrex cab fvex eqeltri cmap wss simpl wb ovex
        elmapg sylancl syl5ibr abssdv ssexg ralrimivw abrexex2g syl5eqel adantr
        sylancr uzid syl syl6eleqr simprl fzsn feq2d mpbird simprr oveq2 rspcev
        anbi12d syl12anc abeq2i sylibr cres wne wsbc ad2antlr simpr1 simpr3 vex
        peano2uzs weq a1i sbc2iedv ad2antrr nfv nfcv nfsbc1v nfsbc nfan sbceq1a
        wi sbcbidv rspce eleq2i nfrex rexbidv ex sylib syl6eqr sylan nfre1 nfab
        fveq2d nfcxfr feq1 elabf bitri rexlimdva elpw2g cbvrexv reximdva syl6ib
        rexcom4 syl5bi ss2abdv syl5eqss sselda 3anbi2d exbidv elab abn0 adantlr
        eqeq1 eldifsn sylanbrc adantrl ralrimivva fmpt2 iftrue xpeq1d syldan 0z
        biimpar elimel eqid axdc4uz syl3anc abbii eqtri syl6bb eqeq1d 3anbi123d
        feq3 ax-mp simpll nff cmpt2 nfmpt2 nfov nfel2 nfral nf3an simpr2 feq12d
        raleqdv oveq1 id fveq2 oveq12d eleq12d rspccva sdclem2 exlimdv exlimddv
        sylbid mpd ) AQUMZIKUNZUOZEUPZSIJUNUOCNSUQUPJURZKUGAUXFUPZQUSUTZQVAVBZV
        CVDZPUKUNZUOZUXJUXLVDZUXDVEZULUNZVFVGVIZUXLVDZUXPUXPUXLVDZOVIZUTZULUXKU
        QZVHZUKURZUXGUXHPVJUTZUXDPUTZUXKPVKZPVLZVMUMVNZOUOZUYDAUYEUXFAPQNUNZVOV
        IZIUXDUOZBUPZNSVPZKVQZVJUIASVJUTUYNKVQZVJUTZNSUQUYPVJUTSQVCVDZVJTQVCVRV
        SAUYRNSAUYQIUYLVTVIZWAUYTVJUTUYRAUYNKUYTUYNUXDUYTUTZAUYMUYMBWBAIRUTZUYL
        VJUTVUAUYMWCUEQUYKVOWDIUYLUXDRVJWEWFWGWHIUYLVTWDUYQUYTVJWIWFWJUYNNKSVJV
        JWKWNWLZWMUXHUYOUYFUXHQSUTQQVOVIZIUXDUOZEUYOUXHQUYSSUXHUXIQUYSUTAUXIUXF
        UFWMZQWOWPTWQUXHVUEUXEAUXEEWRZUXHVUDUXCIUXDUXHUXIVUDUXCVEZVUFQWSZWPWTXA
        AUXEEXBUYNVUEEUPNQSUYKQVEZUYMVUEBEVUJUYLVUDIUXDUYKQQVOXCWTUBXEXDXFUYOKP
        UIXGXHAUXFSPVKZUYIOUOZUYJUXHQMUNZVFVGVIZVOVIZILUNZUOZGUNZVUPQVUMVOVIZXI
        ZVEZFVHZMSVPZLVQZUYIUTZGPUQHSUQVULUXHVVEHGSPUXHVURPUTZVVEHUNZSUTZUXHVVF
        UPZVVDUYHUTZVVDVMXJZVVEVVIVVJVVDPWAZAVVLUXFVVFAVVCLPAVVBVUPPUTZMSAVUMSU
        TZUPZVVBVVMVVOVVBUPZUYLIVUPUOZBKVUPXKZUPZNSVPZVVMVVPVUNSUTZVUQBNVUNXKZK
        VUPXKZVVTVVNVWAAVVBQVUMSTXPXLVVOVUQVVAFXMVVPVWCFVVOVUQVVAFXNAVWCFWCVVNV
        VBABFKNVUPVUNLXOZVUMVFVGWDKLXQZUYKVUNVEZUPBFWCYGAUDXRXSXTXAVVSVUQVWCUPN
        VUNSVUQVWCNVUQNYAVWBNKVUPNVUPYBBNVUNYCYDYEVWFVVQVUQVVRVWCVWFUYLVUOIVUPU
        YKVUNQVOXCWTVWFBVWBKVUPBNVUNYFYHXEYIXFVVMVUPUYPUTVVTPUYPVUPUIYJUYOVVTKV
        UPVVSKNSKSYBVVQVVRKVVQKYABKVUPYCYEYKVWDVWEUYNVVSNSVWEUYMVVQBVVRUYLIUXDV
        UPUUABKVUPYFXEYLUUBUUCXHYMUUDWHXTVVIUYEVVJVVLWCAUYEUXFVVFVUCXTVVDPVJUUE
        WPXAAVVFVVKUXFAVVFUPZVVCLURZVVKVWGVURVUQUXDVUTVEZFVHZMSVPZLURZKVQZUTVWH
        APVWMVURAPUYPVWMUIAUYOVWLKUYOVUSIUXDUOZDUPZMSVPZAVWLUYNVWONMSNMXQZUYMVW
        NBDVWQUYLVUSIUXDUYKVUMQVOXCWTUCXEUUFZAVWPVWJLURZMSVPVWLAVWOVWSMSUHUUGVW
        JMLSUUIUUHUUJUUKUULUUMVWLVWHKVURGXOKGXQZVWKVVCLVWTVWJVVBMSVWTVWIVVAVUQF
        UXDVURVUTUUSUUNYLUUOUUPYNVVCLUUQXHUURVVDUYHVMUUTUVAUVBUVCHGSPVVDUYIOUJU
        VDYNAUYJVULAUYGVUKUYIOAUXKSPAUXKUYSSAUXJQVCAUXIUXJQVEZUFUXIQVAUVEZWPYST
        YOUVFWTUVIUVGPUXDUKULOUXJVJUXKQVAUSUVHUVJUXKUVKUVLUVMUXHUYCUXGUKUXHUYCS
        VWPKVQZUXLUOZQUXLVDZUXDVEZUYAULSUQZVHZUXGUXHUXMVXDUXOVXFUYBVXGUXHUXMSPU
        XLUOZVXDUXHUXKSPUXLUXHUXKUYSSUXHUXJQVCUXHUXIVXAVUFVXBWPZYSTYOZWTPVXCVEV
        XIVXDWCPUYPVXCUIUYOVWPKVWRUVNUVOZPVXCSUXLUVSUVTZUVPUXHUXNVXEUXDUXHUXJQU
        XLVXJYSUVQUXHUYAULUXKSVXKUWKUVRUXHVXHUXGUXHVXHUPZBCDEFGHIJKLMNOUXLPQRST
        UAUBUCUDAVUBUXFVXHUEXTAUXIUXFVXHUFXTZAUXFKURUXFVXHUGXTVXNAVVNVWOVWSYGAU
        XFVXHUWAUHYPUIUJUXHVXHMUXHMYAVXDVXFVXGMMSVXCUXLMUXLYBMSYBZVWPMKVWOMSYQY
        RZUWBVXFMYAUYAMULSVXPMUXRUXTMUXPUXSOMUXPYBMOHGSPVVDUWCUJHGMSPVVDVXPMPVX
        CVXLVXQYTVVCMLVVBMSYQYRUWDYTMUXSYBUWEUWFUWGUWHYEVXNVXDVXIUXHVXDVXFVXGXM
        VXMXHVXNVUDIVXEUOUXEUXHUXEVXHVUGWMVXNVUDUXCIVXEUXDUXHVXDVXFVXGUWIVXNUXI
        VUHVXOVUIWPUWJXAVXNVXGVVHVVGVFVGVIZUXLVDZVVGVVGUXLVDZOVIZUTZUXHVXDVXFVX
        GXNUYAVYBULVVGSULHXQZUXRVXSUXTVYAVYCUXQVXRUXLUXPVVGVFVGUWLYSVYCUXPVVGUX
        SVXTOVYCUWMUXPVVGUXLUWNUWOUWPUWQYPUWRYMUXAUWSUXBUWT $.
    $}

    $d g h k ph $.
    $( Strong dependent choice.  Suppose we may choose an element of ` A ` such
       that property ` ps ` holds, and suppose that if we have already chosen
       the first ` k ` elements (represented here by a function from
       ` 1 ... k ` to ` A ` ), we may choose another element so that all
       ` k + 1 ` elements taken together have property ` ps ` .  Then there
       exists an infinite sequence of elements of ` A ` such that the first
       ` n ` terms of this sequence satisfy ` ps ` for all ` n ` .  This
       theorem allows us to construct infinite seqeunces where each term
       depends on all the previous terms in the sequence.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       3-Jun-2014.) $)
    sdc $p |- ( ph -> E. f ( f : Z --> A /\ A. n e. Z ch ) ) $=
      ( vx vy vj cv cfz co wf wa wrex cab c1 caddc cres wceq w3a cmpt2 eqid weq
      oveq2 feq2d anbi12d cbvrexv abbii mpt2eq123i eqidd 3anbi2d rexbidv abbidv
      eqeq1 cbvmpt2v eqtr3i sdclem1 ) ABCDEFUEUFGHIJKLUGHOMKUHZUIUJZGIUHZUKZDUL
      ZKOUMZIUNZMVQUOUPUJUIUJGJUHZUKZHUHZWDVRUQZURZFUSZKOUMZJUNZUTZMLUHZUIUJZGV
      SUKZBULZLOUMZIUNZMNOPQRSTUAUBUCUDWRVAUGHOWRWKUTWLUFUEOWRWEUEUHZWGURZFUSZK
      OUMZJUNZUTUGHOWRWKOWCWKOVAWQWBIWPWALKOLKVBZWOVTBDXDWNVRGVSWMVQMUIVCVDSVEV
      FVGWKVAVHUGHUFUEOWRWKXCWKUGUFVBWKVIHUEVBZWJXBJXEWIXAKOXEWHWTWEFWFWSWGVMVJ
      VKVLVNVOVP $.
  $}

  ${
    $d C c f n $.  $d A a b c d f g m n x y $.  $d M a b c d f g j k m n x y $.
    $d Z a b c d g j m n x $.  $d N a b c d f g j k m n $.  $d R a b d $.
    $d ph c d f g j k m $.  $d ps a $.  $d ch a b c d g m n $.
    $d th c d f g n $.  $d ta a b c d g m $.  $d et a b g m $.
    fdc.1 $e |- A e. _V $.
    fdc.2 $e |- M e. ZZ $.
    fdc.3 $e |- Z = ( ZZ>= ` M ) $.
    fdc.4 $e |- N = ( M + 1 ) $.
    fdc.5 $e |- ( a = ( f ` ( k - 1 ) ) -> ( ph <-> ps ) ) $.
    fdc.6 $e |- ( b = ( f ` k ) -> ( ps <-> ch ) ) $.
    fdc.7 $e |- ( a = ( f ` n ) -> ( th <-> ta ) ) $.
    fdc.8 $e |- ( et -> C e. A ) $.
    fdc.9 $e |- ( et -> R Fr A ) $.
    fdc.10 $e |- ( ( et /\ a e. A ) -> ( th \/ E. b e. A ph ) ) $.
    fdc.11 $e |- ( ( ( et /\ ph ) /\ ( a e. A /\ b e. A ) ) -> b R a ) $.
    $( Finite version of dependent choice.  Construct a function whose value
       depends on the previous function value, except at a final point at which
       no new value can be chosen.  The final hypothesis ensures that the
       process will terminate.  The proof does not use the Axiom of Choice.
       (Contributed by Jeff Madsen, 18-Jun-2010.) $)
    fdc $p |- ( et -> E. n e. Z E. f ( f : ( M ... n ) --> A /\
              ( ( f ` M ) = C /\ ta ) /\ A. k e. ( N ... n ) ch ) ) $=
      ( vc vd vm vg vx vj wcel cv cfz co wf cfv wceq wa wral w3a wex c0 wss wbr
      wrex wn wi wsbc cuz ax-mp csn sylancr adantr a1i feq1 fveq1 eqeq1d syl6eq
      cz sbceq2a syl anbi12d oveq2 feq2d fvex sbcie fveq2 dfsbcq syl5bbr anbi2d
      wb c1 caddc oveq1i clt ltp1i mpbi raleqdv 3anbi123d exbidv rspcev adantll
      mp2an weq eqeq2 anbi1d 3anbi2d rexbidv ad2antll cmin bitri bitrd ad2antlr
      sbcbidv eleq1 cif eleq2s ltnlei elfzle1 syl6bi com12 adantl iffalse ex cc
      cle imp ax-1cn fvmpt eqeq1 oveq1 fveq2d ifbieq2d ifex sseldi cvv eleqtrri
      crab cdif uzid cop eqid elexi vex fsn mpbir snssi fzsn feq2i sylibr simpr
      fss fvsn snex spcev syl12anc zrei peano2z fzn ral0 df-3an mpbiran2 syl6bb
      eqtri breq1 expcom dfrex2 syl6ib con2d eldif simplbi2 ssrab2 dfss4 eleq2i
      elrab3 syl5bb sylibd cbvrexv ralbidv cbvexv rexbii peano2uzs imbi12d cmpt
      a1d imbi1d imbi2d wo peano2uz elfzp12 iftrue eleq1d biimprcd ad2antrr 1re
      readdcli mtoi elfzelz eluzelz peano2zd fzsubel biimpd mpanr2 mpanl1 com23
      1z mpd recni pncan sylancl oveq12d eleqtrd ffvelrn sylan2 anassrs ancom1s
      zcnd eqeltrd jaod sylbid ralrimiv fmpt adantlll 3ad2antr1 eluzfz1 eluzfz2
      sylib cr wne eluzle zleltp1 ltne neneqd 3eqtrd biimpar ad2ant2l 3ad2antr2
      mpbid eluzp1p1 fveq2i syl6eleqr biimpa eqtrd eqeq2i sylbi ltleii mpbir3an
      adantlr fzaddel mpanr12 gtneii ifnefalse simprl biimparc adantlrr eqeltri
      eluz2 fzss1 rspcva sylan fzssp1 breqtrri subadd mp3an23 eqcom syl5bi mp2b
      addcomi lttri syldan adantlrl jaodan ralrimiva adantllr adantrlr 3adantr1
      an32s cbvralv ovex mptex syl121anc chvarv syl2anc exlimdv rexlimdva 3syld
      an42s rexlimdvaa mpjaodan sylibrd notbii iman bitr4i syl6ibr nrexdv df-ne
      wfr difss difexg fri expr syl5bir mt3d ssdif0 eqssd rabid2 ) FHGUOMLUPZUQ
      URZGJUPZUSZMVXMUTZUIUPZVAZEVBZCKNVXKUQURZVCZVDZJVEZLOVIZUIGVCZVXNVXOHVAZE
      VBZVXTVDZJVEZLOVIZUEFGVYCUIGUUBZVAVYDFGVYJFGVYJUUCZVFVAZGVYJVGFVYLUJUPZPU
      PZIVHZVJUJVYKVCZPVYKVIZFVYPPVYKFVYNVYKUOZVYPVJZFVYPVYRFVYPVYNGUOZVYNVYJUO
      ZVKZVYRVJZFVYTVYPWUAFVYTVYPWUAVKFVYTVBZVYPVXNVXOVYNVAZEVBZVXTVDZJVEZLOVIZ
      WUAWUDDVYPWUIVKZAQGVIZWUDDVBWUIVYPVYTDWUIFVYTDVBZMOUOMMUQURZGVXMUSZWUEDPV
      XOVLZVBZVBZJVEZWUIMMVMUTZOMWCUOZMWUSUOSMUUDVNTUUAWULWUMGMVYNUUEZVOZUSZMWV
      BUTZVYNVAZDWURVYTWVCDVYTMVOZGWVBUSZWVCVYTWVFVYNVOZWVBUSZWVHGVGWVGWVIWVBWV
      BVAWVBUUFMVYNWVBMWCSUUGZPUUHZUUIUUJVYNGUUKWVFWVHGWVBUUPVPWUMWVFGWVBWUTWUM
      WVFVASMUULVNUUMUUNVQWVEWULMVYNWVJWVKUUQZVRVYTDUUOWUQWVCWVEDVBZVBJWVBWVAUU
      RVXMWVBVAZWUNWVCWUPWVMWUMGVXMWVBVSWVNWUEWVEWUODWVNVXOWVDVYNMVXMWVBVTZWAWV
      NWUEWUODWOWVNVXOWVDVYNWVOWVLWBDPVXOWDWEWFWFUUSUUTWUHWURLMOVXKMVAZWUGWUQJW
      VPWUGWUNWUPCKVFVCZVDZWUQWVPVXNWUNWUFWUPVXTWVQWVPVXLWUMGVXMVXKMMUQWGWHWVPE
      WUOWUEEDPVXKVXMUTZVLZWVPWUODEPWVSVXKVXMWIUDWJZWVPWVSVXOVAWVTWUOWOVXKMVXMW
      KDPWVSVXOWLWEWMWNWVPCKVXSVFWVPVXSNMUQURZVFVXKMNUQWGWWBMWPWQURZMUQURZVFNWW
      CMUQUAWRMWWCWSVHZWWDVFVAZMMSUVAZWTZWWCWCUOZWUTWWEWWFWOWUTWWISMUVBVNZSWWCM
      UVCXGXAUVHWBXBXCWVRWUQWVQCKUVDWUNWUPWVQUVEUVFUVGXDXEVPXFUWIWUDWUKWUJWUDAW
      UJQGFAVYTQUPZGUOZWUJFAVBZVYTWWLVBZVBZVYPWWKVYKUOZVJZVXNVXOWWKVAZEVBZVXTVD
      ZJVEZLOVIZWUIWWOWWPVYPWWOWWPVYOUJVYKVIZVYSWWOWWKVYNIVHZWWPWXCVKUHWWPWXDWX
      CVYOWXDUJWWKVYKVYMWWKVYNIUVIXEUVJWEVYOUJVYKUVKUVLUVMWWLWWQWXBVKWWMVYTWWLW
      WQWWKGVYKUUCZUOZWXBWXFWWLWWQWWKGVYKUVNUVOWXFWWKVYJUOWWLWXBWXEVYJWWKVYJGVG
      ZWXEVYJVAVYCUIGUVPZVYJGUVQXAUVRVYCWXBUIWWKGUIQXHZVYBWXALOWXIVYAWWTJWXIVXR
      WWSVXNVXTWXIVXQWWREVXPWWKVXOXIXJXKXDXLUVSUVTUWAXMWXBMUKUPZUQURZGULUPZUSZM
      WXLUTZWWKVAZDPWXJWXLUTZVLZVBZAQKUPZWXLUTZVLZPWXSWPXNURZWXLUTZVLZKNWXJUQUR
      ZVCZVDZULVEZUKOVIZWWOWUIWXBWXKGVXMUSZWWRDPWXJVXMUTZVLZVBZCKWYEVCZVDZJVEZU
      KOVIWYIWXAWYPLUKOLUKXHZWWTWYOJWYQVXNWYJWWSWYMVXTWYNWYQVXLWXKGVXMVXKWXJMUQ
      WGWHWYQEWYLWWREWVTWYQWYLWWAWYQWVSWYKVAWVTWYLWOVXKWXJVXMWKDPWVSWYKWLWEWMWN
      WYQCKVXSWYEVXKWXJNUQWGXBXCXDUWBWYPWYHUKOWYOWYGJULJULXHZWYJWXMWYMWXRWYNWYF
      WXKGVXMWXLVSWYRWWRWXOWYLWXQWYRVXOWXNWWKMVXMWXLVTWAWYRWYKWXPVAWYLWXQWOWXJV
      XMWXLVTDPWYKWXPWLWEWFWYRCWYDKWYECAQWXSVXMUTZVLZPWYBVXMUTZVLZWYRWYDXUBBQWY
      SVLZCWYTXUCPXUAWYBVXMWIVYNXUAVAABQWYSUBXRWJBCQWYSWXSVXMWIUCWJXOZWYRXUBWYT
      PWYCVLZWYDWYRXUAWYCVAXUBXUEWOWYBVXMWXLVTWYTPXUAWYCWLWEWYRWYTWYAPWYCWYRWYS
      WXTVAWYTWYAWOWXSVXMWXLVTAQWYSWXTWLWEXRXPWMUWCXCUWDUWEXOWWOWYHWUIUKOWWOWXJ
      OUOZVBZWYGWUIULXUGWYGWUIXUGWYGVBWXJWPWQURZOUOZMXUHUQURZGVXMUSZWUEDPXUHVXM
      UTZVLZVBZCKNXUHUQURZVCZVDZJVEZWUIXUFXUIWWOWYGMWXJOTUWFXQXUGWYGXURAWWNXUFW
      YGXURVKZFAVYTXUFXUSWWLAQVYMVLZVYTVBZXUFVBZWXMWXNVYMVAZWXQVBZWYFVDZXURVKZV
      KZAVYTVBZXUFVBZXUSVKUJQUJQXHZXVBXVIXVFXUSXVJXVAXVHXUFXVJXUTAVYTAQVYMWDXJX
      JXVJXVEWYGXURXVJXVDWXRWXMWYFXVJXVCWXOWXQVYMWWKWXNXIXJXKUWJUWGXUTPVXPVLZVX
      PGUOZVBZXUFVBZXVEXUKVXQXUMVBZXUPVDZJVEZVKZVKXVGUIPUIPXHZXVNXVBXVRXVFXVSXV
      MXVAXUFXVSXVKXUTXVLVYTXUTPVXPWDVXPVYNGXSWFXJXVSXVQXURXVEXVSXVPXUQJXVSXVOX
      UNXUKXUPXVSVXQWUEXUMVXPVYNVXOXIZXJXKXDUWKUWGXVNXVEXVQXVNXVEVBXUJGUMXUJUMU
      PZMVAZVXPXWAWPXNURZWXLUTZXTZUWHZUSZMXWFUTZVXPVAZDPXUHXWFUTZVLZAQWXSXWFUTZ
      VLZPWYBXWFUTZVLZKXUOVCZXVQXVNXVDWXMXWGWYFXVLXUFWXMXWGXVKXVLXUFVBWXMVBZXWE
      GUOZUMXUJVCXWGXWQXWRUMXUJXWQXWAXUJUOZXWBXWAWWCXUHUQURZUOZUWLZXWRXUFXWSXXB
      WOZXVLWXMXUFXUHWUSUOZXXCXXDWXJWUSOMWXJUWMZTYAXWAMXUHUWNWEXQXWQXWBXWRXXAXV
      LXWBXWRVKXUFWXMXWBXWRXVLXWBXWEVXPGXWBVXPXWDUWOZUWPUWQUWRXUFWXMXXAXWRVKXVL
      XUFWXMVBZXXAXWRXXGXXAVBZXWEXWDGXXHXWBVJZXWEXWDVAXXAXXIXXGXXAXWBWWCMYJVHZW
      WEXXJVJWWHMWWCWWGMWPWWGUWSUWTZYBXAXWBXXAXXJXWBXXAMXWTUOXXJXWAMXWTXSMWWCXU
      HYCYDYEUXAYFXWBVXPXWDYGWEWXMXUFXXAXWDGUOZWXMXUFXXAXXLXUFXXAVBZWXMXWCWXKUO
      XXLXXMXWCWWCWPXNURZXUHWPXNURZUQURZWXKXXMXWAWCUOZXWCXXPUOZXXAXXQXUFXWAWWCX
      UHUXBYFXUFXXAXXQXXRVKXUFXXQXXAXXRXUFXUHWCUOZXXQXXAXXRVKZVKXUFWXJWXJWCUOZW
      XJWUSOMWXJUXCTYAZUXDZXXSXXQXXTWWIXXSXXQXXTWWJWWIXXSVBZXXQWPWCUOZXXTUXJXYD
      XXQXYEVBVBXXAXXRXWAWPWWCXUHUXEUXFUXGUXHYHWEUXIYKUXKXUFXXPWXKVAXXAXUFXXNMX
      XOWXJUQXXNMVAZXUFMYIUOZWPYIUOZXYFMWWGUXLZYLMWPUXMXGZVRXUFWXJYIUOXYHXXOWXJ
      VAXUFWXJXYBUYAYLWXJWPUXMUXNZUXOVQUXPWXKGXWCWXLUXQUXRUXSUXTUYBYHXFUYCUYDUY
      EUMXUJGXWEXWFXWFUUFZUYFUYKUYGUYHXUFXWIXVMXVEXUFMXUJUOZXWIXYMWXJWUSOWXJWUS
      UOZXXDXYMXXEMXUHUYIWETYAUMMXWEVXPXUJXWFXXFXYLUIUUHZYMWEZXQXVNWXMXVDXWKWYF
      XUFWXQXWKXVMXVCXUFXWKWXQXUFXWJWXPVAXWKWXQWOXUFXWJXUHMVAZVXPXXOWXLUTZXTZXY
      RWXPXUFXUHXUJUOZXWJXYSVAXYTWXJWUSOXYNXXDXYTXXEMXUHUYJWETYAUMXUHXWEXYSXUJX
      WFXWAXUHVAZXWBXYQXWDXYRVXPXWAXUHMYNYUAXWCXXOWXLXWAXUHWPXNYOYPYQXYLXYQVXPX
      YRXYOXXOWXLWIYRYMWEXUFXYQVJXYSXYRVAXUFXUHMXUFMUYLUOMXUHWSVHZXUHMUYMWWGXUF
      MWXJYJVHZYUBYUCWXJWUSOMWXJUYNTYAXUFWUTXYAYUCYUBWOSXYBMWXJUYOVPVUBMXUHUYPV
      PUYQXYQVXPXYRYGWEXUFXXOWXJWXLXYKYPUYRDPXWJWXPWLWEUYSUYTVUAXVNXVDWYFXWPWXM
      XVNXVCWYFXWPWXQXVKXUFXVCWYFVBZXWPXVLXVKXUFVBZYUDVBZAQUNUPZXWFUTZVLZPYUGWP
      XNURZXWFUTZVLZUNXUOVCXWPYUFYULUNXUOYUFYUGXUOUOZYUGNVAZYUGNWPWQURZXUHUQURZ
      UOZUWLZYULYUEYUMYURYUDXUFYUMYURXVKXUFYUMYURXUFXUHNVMUTZUOYUMYURWOXUFXUHWW
      CVMUTZYUSXUHYUTUOWXJWUSOMWXJVUCTYANWWCVMUAVUDVUEYUGNXUHUWNWEVUFXFVULYUFYU
      NYULYUQYUEXVCYUNYULWYFYUEXVCYUNYULXVKXUFXVCYUNVBZYULXUFYVAVBZYULXVKYVBYUL
      YUIPVXPVLZXVKYVBYUKVXPVAYULYVCWOYVBYUKXWHVXPYUNYUKXWHVAXUFXVCYUNYUJMXWFYU
      NYUJNWPXNURZMYUGNWPXNYOYVDXXNMNWWCWPXNUAWRXYJUVHWBYPXMXUFXWIYVAXYPVQVUGYU
      IPYUKVXPWLWEYVBYUIXUTPVXPYVBYUHVYMVAYUIXUTWOYVBYUHWWCXWFUTZWXNVYMYUNYUHYV
      EVAZXUFXVCYUNYUGWWCVAZYVFNWWCYUGUAVUHYUGWWCXWFWKVUIXMXUFYVEWXNVAYVAXUFYVE
      WWCMVAZVXPWXNXTZWXNXUFWWCXUJUOYVEYVIVAXUFXWTXUJWWCWWCWUSUOZXWTXUJVGYVJWUT
      WWIMWWCYJVHSWWJMWWCWWGXXKWWHVUJMWWCVVAVUKZWWCMXUHVVBVNXUFMWXKUOZWWCXWTUOZ
      YVLWXJWUSOMWXJUYITYAXUFWUTXYAYVLYVMWOZSXYBWUTXYAVBWUTXYEYVNSUXJMWPMWXJVUM
      VUNVPVUBYSUMWWCXWEYVIXUJXWFXWAWWCVAZXWBYVHXWDWXNVXPXWAWWCMYNYVOXWCMWXLYVO
      XWCXXNMXWAWWCWPXNYOXYJWBYPYQXYLYVHVXPWXNXYOMWXLWIYRYMWEWWCMUYMYVIWXNVAMWW
      CWWGWWHVUOWWCMVXPWXNVUPVNWBVQXUFXVCYUNVUQUYRAQYUHVYMWLWEXRXPVURUXSUXSVUSX
      UFYUDYUQYULXVKXUFWYFYUQYULXVCXUFYUQWYFYULXUFYUQVBZWYFAQYUJWXLUTZVLZPYUJWP
      XNURZWXLUTZVLZYULYVPYUJWYEUOWYFYWAYVPYUJYUOWPXNURZXXOUQURZWYEYVPYUGWCUOZY
      UJYWCUOZYUQYWDXUFYUGYUOXUHUXBZYFXUFYUQYWDYWEVKXUFYWDYUQYWEXUFYUOWCUOZXXSY
      WDYUQYWEVKZVKNWCUOYWGNWWCWCUAWWJVUTZNUVBVNXYCYWGXXSVBZYWDYWHYWJYWDXYEYWHU
      XJYWJYWDXYEVBVBYUQYWEYUGWPYUOXUHUXEUXFUXGYHVPUXIYKUXKXUFYWCWYEVAYUQXUFYWB
      NXXOWXJUQYWBNVAZXUFNYIUOXYHYWKNNYWIUVAZUXLYLNWPUXMXGVRXYKUXOVQUXPZWYDYWAK
      YUJWYEWXSYUJVAZWYDWYAPYVTVLZYWAYWNWYCYVTVAWYDYWOWOYWNWYBYVSWXLWXSYUJWPXNY
      OYPWYAPWYCYVTWLWEYWNWYAYVRPYVTYWNWXTYVQVAWYAYVRWOWXSYUJWXLWKAQWXTYVQWLWEX
      RXPVVCVVDYVPYULYWAYVPYULYUIPYVTVLZYWAYVPYUKYVTVAYULYWPWOYVPYUKYUJMVAZVXPY
      VTXTZYVTYVPYUJXUJUOYUKYWRVAYVPXUOXUJYUJNWUSUOZXUOXUJVGNWWCWUSUAYVKVUTZNMX
      UHVVBVNYVPWYEXUOYUJNWXJVVEYWMYSYSUMYUJXWEYWRXUJXWFXWAYUJVAZXWBYWQXWDYVTVX
      PXWAYUJMYNYXAXWCYVSWXLXWAYUJWPXNYOYPYQXYLYWQVXPYVTXYOYVSWXLWIYRYMWEYVPYWQ
      VJZYWRYVTVAYUQYXBXUFYUQYWQYUOWWCYJVHZWWCYUOWSVHYXCVJWWCWWCWPWQURYUOWSWWCX
      XKWTNWWCWPWQUAWRVVFWWCYUOXXKNWPYWLUWSUWTZYBXAYUQYWQWPMWQURZYUGVAZYXCYUQYU
      GYIUOZYWQYXFWOZYUQYUGYWFUYAYXGXYHXYGYXHYLXYIYUGWPMVVGVVHWEYXFYVGYUQYXCYXF
      YUGYXEVAYVGYXEYUGVVIYXEWWCYUGWPMYLXYIVVLVUHXOYVGYUQYXCYVGYUQWWCYUPUOYXCYU
      GWWCYUPXSWWCYUOXUHYCYDYEVVJUYDUXAYFYWQVXPYVTYGWEVUGYUIPYUKYVTWLWEYVPYUIYV
      RPYVTYVPYUHYVQVAYUIYVRWOYVPYUHYUGMVAZVXPYVQXTZYVQYVPYUGXUJUOYUHYXJVAYVPYU
      PXUJYUGYWSYUOWUSUOYUPXUJVGYWTMNUWMYUOMXUHVVBVVKXUFYUQUUOYSUMYUGXWEYXJXUJX
      WFUMUNXHZXWBYXIXWDYVQVXPXWAYUGMYNYXKXWCYUJWXLXWAYUGWPXNYOYPYQXYLYXIVXPYVQ
      XYOYUJWXLWIYRYMWEYVPYXIVJZYXJYVQVAYUQYXLXUFYUQYXIYUOMYJVHZMYUOWSVHZYXMVJM
      NWSVHNYUOWSVHYXNMWWCNWSWWHUAVVFNYWLWTMNYUOWWGYWLYXDVVMXGMYUOWWGYXDYBXAYXI
      YUQYXMYXIYUQMYUPUOYXMYUGMYUPXSMYUOXUHYCYDYEUXAYFYXIVXPYVQYGWEVUGAQYUHYVQW
      LWEXRXPUYSVVNVWAVVOUYGVVPVVNVVQYULXWOUNKXUOUNKXHZYULYUIPXWNVLZXWOYXOYUKXW
      NVAYULYXPWOYXOYUJWYBXWFYUGWXSWPXNYOYPYUIPYUKXWNWLWEYXOYUIXWMPXWNYXOYUHXWL
      VAYUIXWMWOYUGWXSXWFWKAQYUHXWLWLWEXRXPVWBUYKVVRVVSVVTXVPXWGXWIXWKVBZXWPVDJ
      XWFUMXUJXWEMXUHUQVWCVWDVXMXWFVAZXUKXWGXVOYXQXUPXWPXUJGVXMXWFVSYXRVXQXWIXU
      MXWKYXRVXOXWHVXPMVXMXWFVTWAYXRXULXWJVAXUMXWKWOXUHVXMXWFVTDPXULXWJWLWEWFYX
      RCXWOKXUOCXUBYXRXWOXUDYXRXUBWYTPXWNVLZXWOYXRXUAXWNVAXUBYXSWOWYBVXMXWFVTWY
      TPXUAXWNWLWEYXRWYTXWMPXWNYXRWYSXWLVAWYTXWMWOWXSVXMXWFVTAQWYSXWLWLWEXRXPWM
      UWCXCUUSVWEYHVWFVWFVUSUYGYKWUHXURLXUHOVXKXUHVAZWUGXUQJYXTVXNXUKWUFXUNVXTX
      UPYXTVXLXUJGVXMVXKXUHMUQWGWHYXTEXUMWUEEWVTYXTXUMWWAYXTWVSXULVAWVTXUMWOVXK
      XUHVXMWKDPWVSXULWLWEWMWNYXTCKVXSXUOVXKXUHNUQWGXBXCXDXEVWGYHVWHVWIVVJVWJVW
      KVWLYKUGVWMVYTWUAWUIWOFVYCWUIUIVYNGXVSVYBWUHLOXVSVYAWUGJXVSVXRWUFVXNVXTXV
      SVXQWUEEXVTXJXKXDXLUVSYFVWNYHUXIWUCVYTWUAVJVBZVJWUBVYRYYAVYNGVYJUVNVWOVYT
      WUAVWPVWQVWRUVMYKVWSVYLVJVYKVFUYMZFVYQVYKVFVWTFGIVXAZVYKGVGZYYBVYQVKUFGVY
      JVXBYYCYYDYYBVYQVYKYTUOZYYCYYDYYBVBVYQGYTUOYYERGVYJYTVXCVNPUJGVYKYTIVXDUX
      HVXEUXNVXFVXGGVYJVXHUUNWXGFWXHVRVXIVYCUIGVXJUYKVYCVYIUIHGVXPHVAZVYBVYHLOY
      YFVYAVYGJYYFVXRVYFVXNVXTYYFVXQVYEEVXPHVXOXIXJXKXDXLVVCVWG $.
  $}

  ${
    $d A a b c d f n $.  $d R a b d $.  $d M a b c d f k n $.
    $d Z a b c d n $.  $d N a b c d f k n $.  $d ph d f k $.  $d ps a d $.
    $d ch a b c d n $.  $d th d f n $.  $d ta a b c d $.  $d et a b c d f n $.
    $d ze b c d f n $.  $d si a c $.
    fdc1.1 $e |- A e. _V $.
    fdc1.2 $e |- M e. ZZ $.
    fdc1.3 $e |- Z = ( ZZ>= ` M ) $.
    fdc1.4 $e |- N = ( M + 1 ) $.
    fdc1.5 $e |- ( a = ( f ` M ) -> ( ze <-> si ) ) $.
    fdc1.6 $e |- ( a = ( f ` ( k - 1 ) ) -> ( ph <-> ps ) ) $.
    fdc1.7 $e |- ( b = ( f ` k ) -> ( ps <-> ch ) ) $.
    fdc1.8 $e |- ( a = ( f ` n ) -> ( th <-> ta ) ) $.
    fdc1.9 $e |- ( et -> E. a e. A ze ) $.
    fdc1.10 $e |- ( et -> R Fr A ) $.
    fdc1.11 $e |- ( ( et /\ a e. A ) -> ( th \/ E. b e. A ph ) ) $.
    fdc1.12 $e |- ( ( ( et /\ ph ) /\ ( a e. A /\ b e. A ) ) -> b R a ) $.
    $( Variant of ~ fdc with no specified base value.  (Contributed by Jeff
       Madsen, 18-Jun-2010.) $)
    fdc1 $p |- ( et -> E. n e. Z E. f ( f : ( M ... n ) --> A /\
                          ( si /\ ta ) /\ A. k e. ( N ... n ) ch ) ) $=
      ( vc vd wrex cv cfz co wf wa wral w3a wex wcel wsbc wi wceq eleq1 sbceq2a
      anbi2d anbi12d imbi1d cfv wsb c1 cmin sbsbc nfv sbhypf syl5bbr simprl wfr
      adantr nfsbc1v nfcv nfrex nfor nfim sbceq1a rexbidv orbi12d imbi12d chvar
      wo adantlr wbr nfan anbi1d breq2 adantllr fdc anassrs fvex sbcie syl5rbbr
      dfsbcq biimpcd adantl anim1d 3anim123d eximdv reximdv chvarv ex rexlimdva
      idd mpd ) FGQIUMNMUNZUOUPIKUNZUQZHEURZCLOXPUOUPUSZUTZKVAZMPUMZUGFGYCQIFQU
      NZIVBZURZGYCFUKUNZIVBZURZGQYGVCZURZYCVDYFGURZYCVDUKQYGYDVEZYKYLYCYMYIYFYJ
      GYMYHYEFYGYDIVFVHGQYGVGVIVJYKXRNXQVKZYGVEZEURZXTUTZKVAZMPUMZYCFYHYJYSAQUL
      UNZVCZBCDQYTVCZEFYHYJURZURIYGJKLMNOPULRSTUAUBUUAAQULVLYTLUNVMVNUPXQVKZVEB
      AQULVOABQULUUDBQVPUDVQVRUEUUBDQULVLYTXPXQVKZVEEDQULVODEQULUUEEQVPUFVQVRFY
      HYJVSFIJVTUUCUHWAFYTIVBZUUBUUARIUMZWLZUUCYFDARIUMZWLZVDFUUFURZUUHVDQULUUK
      UUHQUUKQVPUUBUUGQDQYTWBUUAQRIQIWCAQYTWBZWDWEWFYDYTVEZYFUUKUUJUUHUUMYEUUFF
      YDYTIVFZVHUUMDUUBUUIUUGDQYTWGUUMAUUARIAQYTWGZWHWIWJUIWKWMFUUAUUFRUNZIVBZU
      RZUUPYTJWNZUUCFAURZYEUUQURZURZUUPYDJWNZVDFUUAURZUURURZUUSVDQULUVEUUSQUVDU
      URQFUUAQFQVPUULWOUURQVPWOUUSQVPWFUUMUVBUVEUVCUUSUUMUUTUVDUVAUURUUMAUUAFUU
      OVHUUMYEUUFUUQUUNWPVIYDYTUUPJWQWJUJWKWRWSWTYKYRYBMPYKYQYAKYKXRXRYPXSXTXTY
      KXRXNYKYOHEYJYOHVDYIYOYJHHGQYNVCYOYJGHQYNNXQXAUCXBGQYNYGXDXCXEXFXGYKXTXNX
      HXIXJXOXKXLXMXO $.
  $}

  ${
    $d F m n p q s x y z $.  $d A m n p q s x y z $.  $d R m n p q s x y z $.
    $( Two ways to say that a sequence respects a partial order.  (Contributed
       by Jeff Madsen, 2-Sep-2009.) $)
    seqpo $p |- ( ( R Po A /\ F : NN --> A ) ->
                  ( A. s e. NN ( F ` s ) R ( F ` ( s + 1 ) ) <-> A. m e. NN
                    A. n e. ( ZZ>= ` ( m + 1 ) ) ( F ` m ) R ( F ` n ) ) ) $=
      ( cn wa cv cfv c1 caddc wbr wral cuz wcel wi wceq fveq2 breq2d wpo imbi2d
      vp vq wf co oveq1 fveq2d breq12d rspccva adantl a1i peano2nn elnnuz sylib
      cz uztrn sylibr expcom syl imdistani ad2ant2l w3a ffvelrn adantrr adantrl
      ex sylan2 3jca potr exp3acom23 syl5 expdimp adantr mpdd anasss a2d uzind4
      com12 ralrimiv anassrs ralrimiva breq1d raleqbidv imdistanri nnzd impbid1
      rspcv uzid ) ABUAZGAEUEZHZFIZEJZWMKLUFZEJZBMZFGNZCIZEJZDIZEJZBMZDWSKLUFZO
      JZNZCGNZWLWRXGWLWRHZXFCGWLWRWSGPZXFWLWRXIHZHZXCDXEXAXEPXKXCXKWTUCIZEJZBMZ
      QXKWTXDEJZBMZQZXKWTUDIZEJZBMZQXKWTXRKLUFZEJZBMZQXKXCQUCUDXDXAXLXDRZXNXPXK
      YDXMXOWTBXLXDESTUBXLXRRZXNXTXKYEXMXSWTBXLXRESTUBXLYARZXNYCXKYFXMYBWTBXLYA
      ESTUBXLXARZXNXCXKYGXMXBWTBXLXAESTUBXQXDUPPXJXPWLWQXPFWSGWMWSRZWNWTWPXOBWM
      WSESYHWOXDEWMWSKLUGUHUIUJUKULXRXEPZXKXTYCXKYIXTYCQZWLWRXIYIYJQXHXIYIYJXIY
      IHXIXRGPZHZXHYJXIYIYKXIXDKOJZPZYIYKQXIXDGPYNWSUMXDUNUOYIYNYKYIYNHXRYMPYKX
      DXRKUQXRUNURUSUTVAXHYLXSYBBMZYJXHYLYOWRYKYOWLXIWQYOFXRGWMXRRZWNXSWPYBBWMX
      RESYPWOYAEWMXRKLUGUHUIUJVBVGWLYLYOYJQZQWRWJWKYLYQWKYLHZWTAPZXSAPZYBAPZVCZ
      WJYQYRYSYTUUAWKXIYSYKGAWSEVDVEWKYKYTXIGAXREVDVFWKYKUUAXIYKWKYAGPUUAXRUMGA
      YAEVDVHVFVIWJUUBYQWJUUBHXTYOYCAWTXSYBBVJVKVGVLVMVNVOVLVMVPVSVQVRVSVTWAWBV
      GXGWQFGXGWMGPZHWNXBBMZDWOOJZNZUUCHWQUUCXGUUFXFUUFCWMGWSWMRZXCUUDDXEUUEUUG
      XDWOOWSWMKLUGUHUUGWTWNXBBWSWMESWCWDWHWEUUCUUFWOUUEPZWQUUCWOUPPUUHUUCWOWMU
      MWFWOWIUTUUDWQDWOUUEXAWORXBWPWNBXAWOESTUJVHUTWBWG $.
  $}

  ${
    $d F k m n p q $.  $d A k m n p q $.
    $( An increasing sequence of natural numbers takes on indefinitely large
       values.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    incsequz $p |- ( ( F : NN --> NN /\ A. m e. NN
                    ( F ` m ) < ( F ` ( m + 1 ) ) /\ A e. NN ) ->
                                  E. n e. NN ( F ` n ) e. ( ZZ>= ` A ) ) $=
      ( vk cn cv cfv c1 caddc co wbr wcel cuz wrex wa wi wceq fveq2 cr vp vq wf
      clt wral eleq2d rexbidv imbi2d c0 wne 1nn ne0i ax-mp ffvelrn elnnuz sylib
      ralrimiva r19.2z sylancr adantr peano2nn adantl cle nnre ad2antrr adantlr
      nnred adantll 1re a1i leadd1d oveq1 fveq2d breq12d rspcv imdistani sylan2
      wb nnltp1le syl2anc biimpa anasss anass1rs peano2re letr syl3anc adantlrr
      syl mpan2d sylbid cz nnz nnzd eluz syl2an adantrlr anassrs 3imtr4d eleq1d
      peano2zd rspcev ee12an rexlimdva cbvrexv syl6ib ex a2d nnind com12 3impia
      ) FFDUCZBGZDHZXLIJKZDHZUDLZBFUEZAFMZCGZDHZANHZMZCFOZXRXKXQPZYCYDXTUAGZNHZ
      MZCFOZQYDXTINHZMZCFOZQYDXTUBGZNHZMZCFOZQYDXTYLIJKZNHZMZCFOZQYDYCQUAUBAYEI
      RZYHYKYDYTYGYJCFYTYFYIXTYEINSUFUGUHYEYLRZYHYOYDUUAYGYNCFUUAYFYMXTYEYLNSUF
      UGUHYEYPRZYHYSYDUUBYGYRCFUUBYFYQXTYEYPNSUFUGUHYEARZYHYCYDUUCYGYBCFUUCYFYA
      XTYEANSUFUGUHXKYKXQXKFUIUJZYJCFUEYKIFMUUDUKFIULUMXKYJCFXKXSFMZPZXTFMZYJFF
      XSDUNZXTUOUPUQYJCFURUSUTYLFMZYDYOYSUUIYDYOYSQUUIYDPZYOEGZDHZYQMZEFOZYSUUJ
      YNUUNCFUUJUUEPZXSIJKZFMZYNUUPDHZYQMZUUNUUEUUQUUJXSVAZVBUUOYLXTVCLZYPUURVC
      LZYNUUSUUOUVAYPXTIJKZVCLZUVBUUOYLXTIUUIYLTMZYDUUEYLVDZVEYDUUEXTTMZUUIXKUU
      EUVGXQUUFXTUUHVGVFVHITMUUOVIVJVKUUOUVDUVCUURVCLZUVBYDUUEUVHUUIXKUUEXQUVHU
      UEXQPXKUUEXTUURUDLZPUVHUUEXQUVIXPUVIBXSFXLXSRZXMXTXOUURUDXLXSDSUVJXNUUPDX
      LXSIJVLVMVNVOVPXKUUEUVIUVHUUFUVIUVHUUFUUGUURFMZUVIUVHVRUUHUUEXKUUQUVKUUTF
      FUUPDUNZVQXTUURVSVTWAWBVQWCVHUUIXKUUEUVDUVHPUVBQZXQUUIXKPUUEPYPTMZUVCTMZU
      URTMZUVMUUIUVNXKUUEUUIUVEUVNUVFYLWDWHVEXKUUEUVOUUIUUFUVCUUFUUGUVCFMUUHXTV
      AWHVGVHXKUUEUVPUUIUUEXKUUQUVPUUTXKUUQPZUURUVLVGVQVHYPUVCUURWEWFWGWIWJUUIY
      DUUEYNUVAVRZUUIXKUUEUVRXQUUIYLWKMXTWKMUVRUUFYLWLZUUFXTUUHWMYLXTWNWOWPWQUU
      IYDUUEUUSUVBVRZUUIXKUUEUVTXQUUIYPWKMUURWKMZUVTUUFUUIYLUVSWTUUEXKUUQUWAUUT
      UVQUURUVLWMVQYPUURWNWOWPWQWRUUMUUSEUUPFUUKUUPRUULUURYQUUKUUPDSWSXAXBXCUUM
      YRECFUUKXSRUULXTYQUUKXSDSWSXDXEXFXGXHXIXJ $.

    $( An increasing sequence of natural numbers takes on indefinitely large
       values.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    incsequz2 $p |- ( ( F : NN --> NN /\ A. m e. NN
            ( F ` m ) < ( F ` ( m + 1 ) ) /\ A e. NN ) ->
              E. n e. NN A. k e. ( ZZ>= ` n ) ( F ` k ) e. ( ZZ>= ` A ) ) $=
      ( vp vq cn cv cfv c1 caddc clt wbr wral wcel cuz wi wa cr wf w3a incsequz
      co wrex wpo wb wss nnssre wor ltso sopo ax-mp poss seqpo biimpd imdistani
      mp2 mpan wceq wo uzp1 fveq2 adantl ffvelrn nnzd uzid syl eqeltrd adantllr
      adantr oveq1 fveq2d breq1d raleqbidv rspccva breq2d sylan adantlll elnnuz
      cz peano2nn sylib uztrn ancoms sylibr sylan2 anassrs cle ltle syl2an eluz
      zre sylibrd syl2anc mpd jaodan ex ralrimdva 3impa reximdvai ) HHEUAZCIZEJ
      XCKLUDEJMNCHOZAHPZUBZDIZEJZAQJZPZDHUEBIZEJZXIPZBXGQJZOZDHUEACDEUCXFXJXODH
      XBXDXEXGHPZXJXORZRZXBXDSXBFIZEJZGIZEJZMNZGXSKLUDZQJZOZFHOZSZXEXRXBXDYGXBX
      DYGHMUFZXBXDYGUGHTUHTMUFZYIUITMUJYJUKTMULUMHTMUNURHMFGECUOUSUPUQYHXESZXPX
      QYKXPSXJXMBXNYHXPXKXNPZXJXMRZXEYHXPSZYLSXLXHQJZPZYMYLYNXKXGUTZXKXGKLUDZQJ
      ZPZVAYPXGXKVBYNYQYPYTXBXPYQYPYGXBXPSZYQSXLXHYOYQXLXHUTUUAXKXGEVCVDUUAXHYO
      PZYQUUAXHWAPZUUBUUAXHHHXGEVEVFZXHVGVHVKVIVJYNYTSXHXLMNZYPYGXPYTUUEXBYGXPS
      XHYBMNZGYSOZYTUUEYFUUGFXGHXSXGUTZYCUUFGYEYSUUHYDYRQXSXGKLVLVMUUHXTXHYBMXS
      XGEVCVNVOVPUUFUUEGXKYSYAXKUTYBXLXHMYAXKEVCVQVPVRVSXBXPYTUUEYPRZYGUUAYTSUU
      CXLWAPZUUIUUAUUCYTUUDVKXBXPYTUUJXPYTSXBXKHPZUUJXPYRKQJZPZYTUUKXPYRHPUUMXG
      WBYRVTWCUUMYTSXKUULPZUUKYTUUMUUNYRXKKWDWEXKVTWFVRXBUUKSXLHHXKEVEVFWGWHUUC
      UUJSUUEXHXLWINZYPUUCXHTPXLTPUUEUUORUUJXHWMXLWMXHXLWJWKXHXLWLWNWOVJWPWQWGY
      PXJXMXHXLAWDWRVHVJWSWRVRWTXAWP $.
  $}

  ${
    $d A x $.  $d B x $.
    $( A bounded above set of natural numbers is finite.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 28-Feb-2014.) $)
    nnubfi $p |- ( ( A C_ NN /\ B e. NN ) -> { x e. A | x < B } e. Fin ) $=
      ( cn wss wcel wa cc0 cfz co cfn cv wbr wi cn0 nnnn0 syl adantlr cr nnre
      clt crab fzfi wral cle adantr ad3antlr ad2antlr ltle syl2anc imp elfz2nn0
      ssel2 syl3anbrc ex ralrimiva rabss sylibr ssfi sylancr ) BDEZCDFZGZHCIJZK
      FALZCUAMZABUBZVDEZVGKFHCUCVCVFVEVDFZNZABUDVHVCVJABVCVEBFZGZVFVIVLVFGVEOFZ
      COFZVECUEMZVIVLVMVFVAVKVMVBVAVKGZVEDFZVMBDVEUMZVEPQRUFVBVNVAVKVFCPUGVLVFV
      OVLVESFZCSFZVFVONVAVKVSVBVPVQVSVRVETQRVBVTVAVKCTUHVECUIUJUKVECULUNUOUPVFA
      BVDUQURVDVGUSUT $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( An infinite set of natural numbers is unbounded above.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 28-Feb-2014.) $)
    nninfnub $p |- ( ( A C_ NN /\ -. A e. Fin /\ B e. NN )
                                  -> { x e. A | B < x } =/= (/) ) $=
      ( vy cn wss cfn wcel wn cv clt wbr c0 wa wal wral wi sylibr cr adantlr co
      crab wne wceq eq0 breq2 elrab notbii imnan bitr4i biimpi alimi df-ral cle
      ssel2 nnred nnre ad2antlr lenlt biimprd syl2anc ralimdva cc0 cfz fzfi cn0
      w3a nnnn0d adantr nnnn0 ad3antlr simpr 3jca ex elfz2nn0 syl6ibr imp dfss3
      ssfi sylancr syld syl5 syl5bi necon3bd an32s 3impa ) BEFZBGHZIZCEHZCAJZKL
      ZABUBZMUCZWGWJWIWNWGWJNZWIWNWOWHWMMWMMUDDJZWMHZIZDOZWOWHDWMUEWSCWPKLZIZDB
      PZWOWHWSWPBHZXAQZDOXBWRXDDWRXDWRXCWTNZIXDWQXEWLWTAWPBWKWPCKUFUGUHXCWTUIUJ
      UKULXADBUMRWOXBWPCUNLZDBPZWHWOXAXFDBWOXCNZWPSHZCSHZXAXFQWGXCXIWJWGXCNZWPB
      EWPUOZUPTWJXJWGXCCUQURXIXJNXFXAWPCUSUTVAVBWOXGWHWOXGNZVCCVDUAZGHBXNFZWHVC
      CVEXMWPXNHZDBPZXOWOXGXQWOXFXPDBXHXFWPVFHZCVFHZXFVGZXPXHXFXTXHXFNXRXSXFXHX
      RXFWGXCXRWJXKWPXLVHTVIWJXSWGXCXFCVJVKXHXFVLVMVNWPCVOVPVBVQDBXNVRRXNBVSVTV
      NWAWBWCWDVQWEWF $.
  $}

  ${
    $d k x A $.  $d x B $.  $d x C $.  $d k x ph $.
    csbrn.1 $e |- ( ph -> A e. Fin ) $.
    csbrn.2 $e |- ( ( ph /\ k e. A ) -> B e. RR ) $.
    csbrn.3 $e |- ( ( ph /\ k e. A ) -> C e. RR ) $.
    $( Cauchy-Schwarz-Bunjakovsky inequality for R^n.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 4-Jun-2014.) $)
    csbren $p |- ( ph -> ( sum_ k e. A ( B x. C ) ^ 2 ) <_
                        ( sum_ k e. A ( B ^ 2 ) x. sum_ k e. A ( C ^ 2 ) ) ) $=
      ( cmul co csu c2 cexp cle c4 wcel recnd cr caddc adantlr vx wbr cc 2cn cv
      wceq wa remulcld fsumrecl sqmul sylancr sq2 oveq1i syl6eq cc0 resqcld 2re
      cmin remulcl cfn adantr simplr sqge0d binom2 syl2anc sqmuld mul32d oveq2d
      readdcld a1i mulassd eqtr4d oveq12d oveq1d breqtrd fsumge0 addcld fsumadd
      eqtrd simpr sqcld fsummulc1 fsummulc2 discr 4re suble0d mpbid eqbrtrrd wb
      clt 4pos lemul2 syl112anc mpbird ) ABCDIJZEKZLMJZBCLMJZEKZBDLMJZEKZIJZNUB
      ZOWQIJZOXBIJZNUBZALWPIJZLMJZXDXENAXHLLMJZWQIJZXDALUCPZWPUCPXHXJUFUDAWPABW
      OEFAEUEBPZUGZCDGHUHZUIZQLWPUJUKXIOWQIULUMUNAXHXEURJUONUBXHXENUBAUAWSXGXAA
      BWREFXMCGUPZUIZALRPZWPRPXGRPUQXOLWPUSUKZABWTEFXMDHUPZUIZAUAUEZRPZUGZUOBWR
      YBLMJZIJZLWOIJZYBIJZSJZWTSJZEKZWSYEIJZXGYBIJZSJZXASJZNYDBYJEABUTPYCFVAZYD
      XLUGZYIWTYQYFYHYQWRYEAXLWRRPYCXPTZYQYBAYCXLVBZUPUHZYQYGYBAXLYGRPZYCXMXRWO
      RPZUUAUQXNLWOUSUKZTYSUHZVIAXLWTRPYCXTTZVIYQUOCYBIJZDSJZLMJZYJNYQUUGYQUUFD
      YQCYBAXLCRPYCGTZYSUHZAXLDRPYCHTZVIVCYQUUHUUFLMJZLUUFDIJZIJZSJZWTSJZYJYQUU
      FUCPDUCPUUHUUPUFYQUUFUUJQYQDUUKQZUUFDVDVEYQUUOYIWTSYQUULYFUUNYHSYQCYBYQCU
      UIQZYQYBYSQZVFYQUUNLWOYBIJZIJYHYQUUMUUTLIYQCYBDUURUUSUUQVGVHYQLWOYBXKYQUD
      VJYQWOAXLUUBYCXNTQZUUSVKVLVMVNVSVOVPYDYKBYIEKZXASJYOYDBYIWTEYPYQYFYHYQYFY
      TQZYQYHUUDQZVQYQWTUUEQVRYDUVBYNXASYDUVBBYFEKZBYHEKZSJYNYDBYFYHEYPUVCUVDVR
      YDYLUVEYMUVFSYDBWRYEEYPYDYBYDYBAYCVTQZWAYQWRYRQWBYDYMBYGEKZYBIJUVFYDXGUVH
      YBIYDBWOLEYPXKYDUDVJUVAWCVNYDBYGYBEYPUVGAXLYGUCPYCXMYGUUCQTWBVSVMVLVNVSVO
      WDAXHXEAXGXSUPAORPZXBRPZXERPWEAWSXAXQYAUHZOXBUSUKWFWGWHAWQRPUVJUVIUOOWJUB
      ZXCXFWIAWPXOUPUVKUVIAWEVJUVLAWKVJWQXBOWLWMWN $.

    $( Triangle inequality in R^n.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Revised by Mario Carneiro, 4-Jun-2014.) $)
    trirn $p |- ( ph -> ( sqr ` sum_ k e. A ( ( B + C ) ^ 2 ) ) <_
     ( ( sqr ` sum_ k e. A ( B ^ 2 ) ) + ( sqr ` sum_ k e. A ( C ^ 2 ) ) ) ) $=
      ( caddc co c2 cexp csu cle wbr cmul wcel cr recnd wceq csqr cv wa resqcld
      cfv 2re remulcld remulcl sylancr readdcld fsumrecl sqge0d fsumge0 mulge0d
      resqrcld fsumadd 2cn a1i fsummulc2 cabs abscld leabsd absresq syl resqrth
      cc csbren cc0 syl2anc 3brtr4d absge0d sqrge0d le2sqd mpbird letrd wb 2pos
      lemul2 syl112anc mpbid eqbrtrrd leadd2dd eqbrtrd leadd1dd binom2 sumeq2dv
      clt eqtrd sqrmuld eqcomd oveq2d oveq12d addge0d ) ABCDIJZKLJZEMZUAUEZBCKL
      JZEMZUAUEZBDKLJZEMZUAUEZIJZNOWQKLJZXDKLJZNOABWRKCDPJZPJZIJZEMZXBIJZWSKWSX
      BPJZUAUEZPJZIJZXBIJZXEXFNAXJXOXBABXIEFAEUBBQUCZWRXHXQCGUDZXQKRQZXGRQXHRQU
      FXQCDGHUGZKXGUHUIZUJZUKAWSXNABWREFXRUKZAXSXMRQZXNRQUFAXLAWSXBYCABXAEFXQDH
      UDZUKZUGZAWSXBYCYFABWREFXRXQCGULUMZABXAEFYEXQDHULUMZUNZUOZKXMUHUIZUJYFAXJ
      WSBXHEMZIJXONABWRXHEFXQWRXRSXQXHYASUPAYMXNWSABXHEFYAUKYLYCAKBXGEMZPJZYMXN
      NABXGKEFKVFQAUQURXQXGXTSUSAYNXMNOZYOXNNOZAYNYNUTUEZXMABXGEFXTUKZAYNAYNYSS
      ZVAZYKAYNYSVBAYRXMNOYRKLJZXMKLJZNOAYNKLJZXLUUBUUCNABCDEFGHVGAYNRQZUUBUUDT
      YSYNVCVDAXLRQVHXLNOUUCXLTYGYJXLVEVIVJAYRXMUUAYKAYNYTVKAXLYGYJVLVMVNVOAUUE
      YDXSVHKWGOZYPYQVPYSYKXSAUFURUUFAVQURYNXMKVRVSVTWAWBWCWDAXEWPXKAWPRQVHWPNO
      XEWPTABWOEFXQWNXQCDGHUJZUDZUKZABWOEFUUHXQWNUUGULUMZWPVEVIAWPBXIXAIJZEMXKA
      BWOUUKEXQCVFQDVFQWOUUKTXQCGSXQDHSCDWEVIWFABXIXAEFXQXIYBSXQXAYESUPWHWHAXFW
      TKLJZKWTXCPJZPJZIJZXCKLJZIJZXPAWTVFQXCVFQXFUUQTAWTAWSYCYHUOZSAXCAXBYFYIUO
      ZSWTXCWEVIAUUOXOUUPXBIAUULWSUUNXNIAWSRQVHWSNOUULWSTYCYHWSVEVIAUUMXMKPAXMU
      UMAWSXBYCYHYFYIWIWJWKWLAXBRQVHXBNOUUPXBTYFYIXBVEVIWLWHVJAWQXDAWPUUIUUJUOA
      WTXCUURUUSUJAWPUUIUUJVLAWTXCUURUUSAWSYCYHVLAXBYFYIVLWMVMVN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d J v $.  $d X v $.  $d A v $.  $d B v $.
    $( An open set is open in the subspace topology.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 15-Dec-2013.) $)
    subspopn $p |- ( ( ( J e. Top /\ A e. V ) /\ ( B e. J /\ B C_ A ) )
                                      -> B e. ( J |`t A ) ) $=
      ( ctop wcel wa wss crest co wi w3a cin elrestr wceq df-ss eleq1 syl5ibcom
      wb sylbi 3expa impr ) CEFZADFZGBCFZBAHZBCAIJZFZUCUDUEUFUHKUCUDUELBAMZUGFZ
      UFUHBACEDNUFUIBOUJUHSBAPUIBUGQTRUAUB $.
  $}

  ${
    $d J x y $.  $d N x $.  $d S x y $.
    $( Neighborhoods are closed under finite intersection.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 25-Nov-2013.) $)
    neificl $p |- ( ( ( J e. Top /\ N C_ ( ( nei ` J ) ` S ) ) /\
              ( N e. Fin /\ N =/= (/) ) ) -> |^| N e. ( ( nei ` J ) ` S ) ) $=
      ( vx vy ctop wcel cnei cfv wss cfn c0 wne wa cint simprl cv w3a wi wral
      wal cin innei 3expib ralrimivv fiint sylib wceq sseq1 neeq1 eleq1 3ancomb
      3anbi123d 3anass bitri syl6bb inteq eleq1d imbi12d spcgv syl5 com3l mpdi
      impl ) BFGZCABHIIZJZCKGZCLMZNZCOZVFGZVEVGVJNZVHVLVGVHVIPVHVEVMVLVEDQZVFJZ
      VNLMZVNKGZRZVNOZVFGZSZDUAZVHVMVLSZVEVNEQZUBVFGZEVFTDVFTWBVEWEDEVFVFVEVNVF
      GWDVFGWEABWDVNUCUDUEDEVFUFUGWAWCDCKVNCUHZVRVMVTVLWFVRVGVIVHRZVMWFVOVGVPVI
      VQVHVNCVFUIVNCLUJVNCKUKUMWGVGVHVIRVMVGVIVHULVGVHVIUNUOUPWFVSVKVFVNCUQURUS
      UTVAVBVCVD $.
  $}

  ${
    $d J x $.  $d X x $.  $d A x $.  $d B x $.
    lpss2.1 $e |- X = U. J $.
    $( Limit points of a subset are limit points of the larger set.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    lpss2 $p |- ( ( J e. Top /\ A C_ X /\ B C_ A ) ->
                          ( ( limPt ` J ) ` B ) C_ ( ( limPt ` J ) ` A ) ) $=
      ( lpss3 ) ABCDEF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Metric spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d M u v w x y z $.  $d X u v w x y z $.  $d Y u v w x y z $.
    $d F u v w x y z $.  $d A u v w x y z $.  $d N u v w $.
    metf1o.2 $e |- N = ( x e. Y , y e. Y |-> ( ( F ` x ) M ( F ` y ) ) ) $.
    $( Use a bijection with a metric space to construct a metric on a set.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    metf1o $p |- ( ( Y e. A /\ M e. ( Met ` X ) /\
                                F : Y -1-1-onto-> X ) -> N e. ( Met ` Y ) ) $=
      ( wcel cfv cv co wceq wb wral wa wi ffvelrn ex vu vv vw cme w3a cxp cr wf
      wf1o cc0 caddc cle wbr anim12d syl metcl 3expib sylan9r 3adant1 ralrimivv
      f1of fmpt2 sylib fveq2 oveq1d oveq2d ovex ovmpt2 eqeq1d adantl imp meteq0
      adantll 3expb adantlr syldan wf1 f1of1 f1fveq sylan 3bitrd mettri2 expcom
      ancoms impcom anassrs adantr oveq12d breq12d ralrimiva jca 3adantl1 ismet
      mpbird 3ad2ant1 mpbir2and ) HCJZEGUDKJZHGDUIZUEZFHUDKJZHHUFUGFUHZUALZUBLZ
      FMZUJNZXCXDNZOZXEUCLZXCFMZXIXDFMZUKMZULUMZUCHPZQZUBHPUAHPZWTALZDKZBLZDKZE
      MZUGJZBHPAHPXBWTYBABHHWRWSXQHJZXSHJZQZYBRWQWSYEXRGJZXTGJZQZWRYBWSHGDUHZYE
      YHRHGDVAZYIYCYFYDYGYIYCYFHGXQDSTYIYDYGHGXSDSTUNUOWRYFYGYBXRXTEGUPUQURUSUT
      ABHHYAUGFIVBVCWTXOUAUBHHWTXCHJZXDHJZQZXOWRWSYMXOWQWRWSQZYMQZXHXNYOXFXCDKZ
      XDDKZEMZUJNZYPYQNZXGYMXFYSOYNYMXEYRUJABXCXDHHYAYRFYPXTEMXQXCNXRYPXTEXQXCD
      VDVEXSXDNZXTYQYPEXSXDDVDZVFIYPYQEVGVHZVIVJYNYMYPGJZYQGJZQZYSYTOZWSYMUUFWR
      WSYMUUFWSYIYMUUFRYJYIYKUUDYLUUEYIYKUUDHGXCDSTYIYLUUEHGXDDSTUNZUOVKVMWRUUF
      UUGWSWRUUDUUEUUGYPYQEGVLVNVOVPWSYMYTXGOZWRWSHGDVQYMUUIHGDVRHGXCXDDVSVTVMW
      AYOXMUCHYOXIHJZQXMYRXIDKZYPEMZUUKYQEMZUKMZULUMZYNYMUUJUUOYNYMUUJQZUUFUUKG
      JZQZUUOWSUUPUURWRWSUUPUURWSYIUUPUURRYJYIYMUUFUUJUUQUUHYIUUJUUQHGXIDSTUNUO
      VKVMWRUURUUOWSUURWRUUOUUQUUFWRUUORZUUQUUDUUEUUSWRUUQUUDUUEUEUUOYPYQUUKEGW
      BWCVNWDWEVOVPWFYMUUJXMUUOOYNUUPXEYRXLUUNULYMXEYRNUUJUUCWGUUPXJUULXKUUMUKY
      KUUJXJUULNZYLUUJYKUUTABXIXCHHYAUULFUUKXTEMZXQXINXRUUKXTEXQXIDVDVEZXSXCNXT
      YPUUKEXSXCDVDVFIUUKYPEVGVHWDVOYLUUJXKUUMNZYKUUJYLUVCABXIXDHHYAUUMFUVAUVBU
      UAXTYQUUKEUUBVFIUUKYQEVGVHWDVMWHWIVMWNWJWKWLTUTWQWRXAXBXPQOWSUAUBUCCFHWMW
      OWP $.
  $}

  ${
    $d M x $.  $d S x $.  $d R x $.  $d N x $.  $d X x $.  $d Y x $.
    blssp.2 $e |- N = ( M |` ( S X. S ) ) $.
    $( A ball in the subspace metric.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 5-Jan-2014.) $)
    blssp $p |- ( ( ( M e. ( Met ` X ) /\ S C_ X ) /\
        ( Y e. S /\ R e. RR+ ) ) ->
      ( Y ( ball ` N ) R ) = ( ( Y ( ball ` M ) R ) i^i S ) ) $=
      ( cme cfv wcel wss wa crp cxmt cin cxr cbl co wceq metxmet simprl sseqin2
      ad2antrr simplr sylib eleqtrrd rpxr ad2antll blres syl3anc ) CEHIJZBEKZLZ
      FBJZAMJZLZLZCENIJZFEBOZJAPJZFADQIRFACQIRBOSUKURULUPCETUCUQFBUSUMUNUOUAUQU
      LUSBSUKULUPUDBEUBUEUFUOUTUMUNAUGUHDCFAEBGUIUJ $.
  $}

  ${
    $d k n x D $.  $d k n x F $.  $d k n x M $.  $d k n x N $.  $d k n x ph $.
    $d k n X $.
    mettrifi.2 $e |- ( ph -> D e. ( Met ` X ) ) $.
    mettrifi.3 $e |- ( ph -> N e. ( ZZ>= ` M ) ) $.
    mettrifi.4 $e |- ( ( ph /\ k e. ( M ... N ) ) -> ( F ` k ) e. X ) $.
    $( Generalized triangle inequality for arbitrary finite sums.  (Contributed
       by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       4-Jun-2014.) $)
    mettrifi $p |- ( ph -> ( ( F ` M ) D ( F ` N ) ) <_
           sum_ k e. ( M ... ( N - 1 ) ) ( ( F ` k ) D ( F ` ( k + 1 ) ) ) ) $=
      ( cfz co wcel cfv c1 cle wbr wi wceq oveq2d vx vn cmin cv csu cuz eluzfz2
      caddc syl eleq1 fveq2 oveq1 sumeq1d breq12d imbi12d imbi2d cz cc0 a1i cme
      0le0 wral eluzfz1 ralrimiva eleq1d rspcv sylc met0 syl2anc c0 clt eluzel2
      zred ltm1d wb peano2zm fzn mpbid sum0 syl6eq 3brtr4d a1d peano2fzr adantl
      wa ex imim1d 3ad2ant1 simp3 cbvralv sylib 3impia mettri syl13anc cr metcl
      w3a rsp syl3anc readdcld fzfid adantr wss elfzuz3 sselda 3ad2antl1 syldan
      fzss2 elfzuz peano2uz eluzp1p1 uztrn elfzuzb sylanbrc sylan fsumrecl letr
      rspccva mpand fzssp1 eluzelz 3ad2ant2 zcnd npcan sylancl syl5sseq leadd1d
      ax-1cn simp2 recnd fveq2d oveq12d fsumm1 breq2d bitr4d 3imtr4d 3expia a2d
      cc pncan syld expcom uzind4 mpcom mpd ) AFEFKLZMZEDNZFDNZBLZEFOUCLZKLZCUD
      ZDNZUUMOUHLZDNZBLZCUEZPQZAFEUFNZMZUUGIEFUGUIUVAAUUGUUSRZIAUAUDZUUFMZUUHUV
      CDNZBLZEUVCOUCLZKLZUUQCUEZPQZRZRAEUUFMZUUHUUHBLZEEOUCLZKLZUUQCUEZPQZRZRZA
      UBUDZUUFMZUUHUVTDNZBLZEUVTOUCLZKLZUUQCUEZPQZRZRAUVTOUHLZUUFMZUUHUWIDNZBLZ
      EUWIOUCLZKLZUUQCUEZPQZRZRAUVBRUAUBEFUVCESZUVKUVRAUWRUVDUVLUVJUVQUVCEUUFUJ
      UWRUVFUVMUVIUVPPUWRUVEUUHUUHBUVCEDUKTUWRUVHUVOUUQCUWRUVGUVNEKUVCEOUCULTUM
      UNUOUPUVCUVTSZUVKUWHAUWSUVDUWAUVJUWGUVCUVTUUFUJUWSUVFUWCUVIUWFPUWSUVEUWBU
      UHBUVCUVTDUKTUWSUVHUWEUUQCUWSUVGUWDEKUVCUVTOUCULTUMUNUOUPUVCUWISZUVKUWQAU
      WTUVDUWJUVJUWPUVCUWIUUFUJUWTUVFUWLUVIUWOPUWTUVEUWKUUHBUVCUWIDUKTUWTUVHUWN
      UUQCUWTUVGUWMEKUVCUWIOUCULTUMUNUOUPUVCFSZUVKUVBAUXAUVDUUGUVJUUSUVCFUUFUJU
      XAUVFUUJUVIUURPUXAUVEUUIUUHBUVCFDUKTUXAUVHUULUUQCUXAUVGUUKEKUVCFOUCULTUMU
      NUOUPUVSEUQMZAUVQUVLAURURUVMUVPPURURPQAVAUSABGUTNMZUUHGMZUVMURSHAUVLUUNGM
      ZCUUFVBZUXDAUVAUVLIEFVCUIAUXECUUFJVDZUXEUXDCEUUFUUMESUUNUUHGUUMEDUKVEVFVG
      ZUUHBGVHVIAUVPVJUUQCUEURAUVOVJUUQCAUVNEVKQZUVOVJSZAEAEAUVAUXBIEFVLUIZVMVN
      AUXBUVNUQMZUXIUXJVOUXKAUXBUXLUXKEVPUIEUVNVQVIVRUMUUQCVSVTWAWBUSUVTUUTMZAU
      WHUWQAUXMUWHUWQRAUXMWEZUWHUWJUWGRUWQUXNUWJUWAUWGUXMUWJUWARAUXMUWJUWAUVTEF
      WCWFWDZWGUXNUWJUWGUWPAUXMUWJUWGUWPRAUXMUWJWQZUWCUWBUWKBLZUHLZEUVTKLZUUQCU
      EZPQZUWLUXTPQZUWGUWPUXPUWLUXRPQZUYAUYBUXPUXCUXDUWKGMZUWBGMZUYCAUXMUXCUWJH
      WHZAUXMUXDUWJUXHWHZUXPUWJUXFUYDAUXMUWJWIZAUXMUXFUWJUXGWHZUXEUYDCUWIUUFUUM
      UWISUUNUWKGUUMUWIDUKVEVFVGZUXPUYEUBUUFVBZUWAUYEUXPUXFUYKUYIUXEUYECUBUUFUU
      MUVTSZUUNUWBGUUMUVTDUKZVEWJWKZAUXMUWJUWAUXOWLZUYEUBUUFWRVGZUUHUWKUWBBGWMW
      NUXPUWLWOMZUXRWOMUXTWOMUYCUYAWEUYBRUXPUXCUXDUYDUYQUYFUYGUYJUUHUWKBGWPWSUX
      PUWCUXQUXPUXCUXDUYEUWCWOMUYFUYGUYPUUHUWBBGWPWSZUXPUXCUYEUYDUXQWOMUYFUYPUY
      JUWBUWKBGWPWSZWTUXPUXSUUQCUXPEUVTXAUXPUUMUXSMZWEZUXCUXEUUPGMZUUQWOMZUXPUX
      CUYTUYFXBUXPUYTUUMUUFMZUXEUXPUXSUUFUUMUXPFUVTUFNMZUXSUUFXCUXPUWAVUEUYOUVT
      EFXDUIUVTEFXHUIXEAUXMVUDUXEUWJJXFXGUXPUYTUUOUUFMZVUBVUAUUOUUTMZFUUOUFNZMZ
      VUFVUAUUMUUTMZVUGUYTVUJUXPUUMEUVTXIWDEUUMXJUIVUAFUWIUFNMZUWIVUHMZVUIUXPVU
      KUYTUXPUWJVUKUYHUWIEFXDUIXBVUAUVTUUMUFNMZVULUYTVUMUXPUUMEUVTXDWDUUMUVTXKU
      IUWIFUUOXLVIUUOEFXMXNUXPUYKVUFVUBUYNUYEVUBUBUUOUUFUVTUUOSUWBUUPGUVTUUODUK
      VEXRXOXGUUNUUPBGWPWSZXPUWLUXRUXTXQWSXSUXPUWGUXRUWFUXQUHLZPQUYAUXPUWCUWFUX
      QUYRUXPUWEUUQCUXPEUWDXAUXPUUMUWEMUYTVUCUXPUWEUXSUUMUXPEUWDOUHLZKLUWEUXSEU
      WDXTUXPVUPUVTEKUXPUVTYSMZOYSMZVUPUVTSUXPUVTUXMAUVTUQMUWJEUVTYAYBYCZYHUVTO
      YDYETYFXEVUNXGXPUYSYGUXPUXTVUOUXRPUXPUUQUXQCEUVTAUXMUWJYIVUAUUQVUNYJUYLUU
      NUWBUUPUWKBUYMUYLUUOUWIDUUMUVTOUHULYKYLYMYNYOUXPUWOUXTUWLPUXPUWNUXSUUQCUX
      PUWMUVTEKUXPVUQVURUWMUVTSVUSYHUVTOYTYETUMYNYPYQYRUUAUUBYRUUCUUDUUE $.
  $}

  ${
    $d j k n x D $.  $d j k n x F $.  $d j k x G $.  $d x J $.  $d j k n x X $.
    $d j k m n x A $.  $d j k m n x B $.  $d j k n x ph $.  $d j k x Y $.
    lmclim2.2 $e |- ( ph -> D e. ( Met ` X ) ) $.
    lmclim2.3 $e |- ( ph -> F : NN --> X ) $.
    ${
      lmclim2.4 $e |- J = ( MetOpen ` D ) $.
      lmclim2.5 $e |- G = ( x e. NN |-> ( ( F ` x ) D Y ) ) $.
      lmclim2.6 $e |- ( ph -> Y e. X ) $.
      $( A sequence in a metric space converges to a point iff the distance
         between the point and the elements of the sequence converges to 0.
         (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
         Carneiro, 5-Jun-2014.) $)
      lmclim2 $p |- ( ph -> ( F ( ~~>t ` J ) Y <-> G ~~> 0 ) ) $=
        ( vk vj cfv wbr wcel wral cn clm cv co clt cuz wrex crp wa cc0 cli cxmt
        c1 cme metxmet syl nnuz cz 1z a1i eqidd lmmbrf cabs cvv cmpt nnex mptex
        eqeltri wceq fveq2 oveq1d ovex fvmpt adantl cr adantr ffvelrnda syl3anc
        metcl clim0c wb uztrn2 cle metge0 absidd breq1d sylan2 anassrs ralbidva
        recnd rexbidva ralbidv biantrurd 3bitrrd bitrd ) ADHFUAPQHGRZNUBZDPZHCU
        CZBUBZUDQZNOUBZUEPZSZOTUFZBUGSZUHZEUIUJQZABWQCHONDFULGTKACGUMPRZCGUKPRI
        CGUNUOUPULUQRAURUSZAWPTRZUHZWQUTJVAAXGWRVBPZWSUDQZNXBSZOTUFZBUGSXEXFABW
        RONEULVCTUPXIEVCRAEBTWSDPZHCUCZVDVCLBTXQVEVFVGUSXJWPEPWRVHABWPXQWRTEWSW
        PVHXPWQHCWSWPDVIVJLWQHCVKVLVMXKWRXKXHWQGRZWOWRVNRAXHXJIVOZATGWPDJVPZAWO
        XJMVOZWQHCGVRVQZWIVSAXOXDBUGAXNXCOTAXATRZUHXMWTNXBAYCWPXBRZXMWTVTZYCYDU
        HAXJYEULWPXATUPWAXKXLWRWSUDXKWRYBXKXHXRWOUIWRWBQXSXTYAWQHCGWCVQWDWEWFWG
        WHWJWKAWOXEMWLWMWN $.
    $}

    geomcau.4 $e |- ( ph -> A e. RR ) $.
    geomcau.5 $e |- ( ph -> B e. RR+ ) $.
    geomcau.6 $e |- ( ph -> B < 1 ) $.
    geomcau.7 $e |- ( ( ph /\ k e. NN ) ->
      ( ( F ` k ) D ( F ` ( k + 1 ) ) ) <_ ( A x. ( B ^ k ) ) ) $.
    $( If the distance between consecutive points in a sequence is bounded by a
       geometric sequence, then the sequence is Cauchy.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       5-Jun-2014.) $)
    geomcau $p |- ( ph -> F e. ( Cau ` D ) ) $=
      ( vm cfv wcel co cn c1 cmul vj vn cca clt wbr cuz wral wrex crp cexp cmin
      vx cv cdiv cabs cmpt cc0 cli cn0 cvv nnuz cz 1z rpcnd rpred rpge0d absidd
      a1i eqbrtrd expcnv cr 1re resubcl sylancr posdif sylancl mpbid rerpdivcld
      wb elrpd recnd nnex mptex wa cc wceq nnnn0 adantl oveq2 eqid ovex syl nnz
      rpexpcl syl2an eqeltrd adantr mulcomd weq oveq1d oveq2d 3eqtr4d climmulc2
      fvmpt mul01d breqtrd remulcld clim0c wi uzid fveq2d breq1d rspcv 3syl cle
      cme wf simpl ffvelrn uztrn2 metcl syl3anc ad2antrl nn0zd ad2antrr eluznn0
      csu sylan reexpcld caddc cfz simpll elfzuz sylan2 syl2anc fsumrecl mpbird
      letrd adantlr eqidd geolim2 eqtr4d isermulc2 rpexpcld wne rpne0d isumclim
      div12d cdm seqex breldm isumrecl eqeltrrd abscld fzfid ffvelrnda peano2nn
      cseq simprl simprr mettrifi fsumle wss fzssuz 0re metge0 divge0d isumless
      ledivmul2d mulge0d leabsd rpre ad2antlr lelttr anassrs ralrimdva reximdva
      mpand syld ralimdva mpd cxmt metxmet iscauf ) AFDUCOPUAUMZFOZUBUMZFOZDQZU
      LUMZUDUEZUBUWEUFOZUGZUARUHZULUIUGZACUWGUJQZBSCUKQZUNQZTQZUOOZUWJUDUEZUBUW
      LUGZUARUHZULUIUGZUWOANRCNUMZUJQZUWRTQZUPZUQURUEUXDAUXHUWRUQTQUQURAUQUWRUB
      NUSUXFUPZUXHSUTRVASVBPAVCVHZACNACKVDZACUOOZCSUDACACKVEZACKVFVGLVIZVJAUWRA
      BUWQJAUWQASVKPZCVKPZUWQVKPVLUXMSCVMVNZACSUDUEZUQUWQUDUEZLAUXPUXOUXRUXSVSU
      XMVLCSVOVPVQVTZVRZWAZUXHUTPANRUXGWBWCVHZAUWGRPZWDZUWGUXIOZUWPWEUYEUWGUSPZ
      UYFUWPWFUYDUYGAUWGWGWHNUWGUXFUWPUSUXIUXEUWGCUJWIZUXIWJCUWGUJWKXDWLZUYEUWP
      ACUIPZUWGVBPUWPUIPUYDKUWGWMCUWGWNWOZVDZWPUYEUWSUWRUWPTQUWGUXHOZUWRUYFTQUY
      EUWPUWRUYLAUWRWEPUYDUYBWQWRUYDUYMUWSWFANUWGUXGUWSRUXHNUBWSUXFUWPUWRTUYHWT
      UXHWJUWPUWRTWKXDWHZUYEUYFUWPUWRTUYIXAXBXCAUWRUYBXEXFAULUWSUAUBUXHSUTRVAUX
      JUYCUYNUYEUWSUYEUWPUWRUYEUWPUYKVEAUWRVKPUYDUYAWQXGWAXHVQAUXCUWNULUIAUWJUI
      PZWDZUXBUWMUARUYPUWERPZWDZUXBCUWEUJQZUWRTQZUOOZUWJUDUEZUWMUYRUWEVBPZUWEUW
      LPUXBVUBXIUYQVUCUYPUWEWMWHUWEXJUXAVUBUBUWEUWLUBUAWSZUWTVUAUWJUDVUDUWSUYTU
      OVUDUWPUYSUWRTUWGUWECUJWIWTXKXLXMXNUYRVUBUWKUBUWLUYPUYQUWGUWLPZVUBUWKXIUY
      PUYQVUEWDZWDZUWIVUAXOUEZVUBUWKAVUFVUHUYOAVUFWDZUWIUYTVUAVUIDGXPOPZUWFGPZU
      WHGPZUWIVKPZAVUJVUFHWQZARGFXQZUYQVUKVUFIUYQVUEXRRGUWEFXSWOAVUOUYDVULVUFIS
      UWGUWERVAXTRGUWGFXSWOUWFUWHDGYAYBZVUIUWLBCEUMZUJQZTQZEYGZUYTVKVUIVUSUYTEN
      UWLBUXFTQZUPZUWEUWLUWLWJZVUIUWEUYQUWEUSPZAVUEUWEWGYCZYDZVUQUWLPZVUQVVBOZV
      USWFVUINVUQVVAVUSUWLVVBNEWSUXFVURBTUXEVUQCUJWIZXAVVBWJBVURTWKXDWHZVUIVVGW
      DZVUSVVKBVURABVKPZVUFVVGJYEZVVKCVUQAUXPVUFVVGUXMYEVUIVVDVVGVUQUSPVVEVUQUW
      EYFYHYIZXGZWAVUIYJVVBUWEUURZBUYSUWQUNQZTQZUYTURVUIVVQBENUWLUXFUPZVVBUWEUW
      LVVCVVFABWEPVUFABJWAWQZVUICEVVSUWEACWEPVUFUXKWQAUXLSUDUEVUFUXNWQVVEVVGVUQ
      VVSOZVURWFVUINVUQUXFVURUWLVVSVVIVVSWJCVUQUJWKXDWHZUUAVVKVWAVURWEVWBVVKVUR
      VVNWAWPVVKVVHVUSBVWATQVVJVVKVWAVURBTVWBXAUUBUUCZVUIBUYSUWQVVTVUIUYSVUICUW
      EAUYJVUFKWQVVFUUDVDAUWQWEPVUFAUWQUXQWAWQAUWQUQUUEVUFAUWQUXTUUFWQUUHXFUUGZ
      VUIVUSEVVBUWEUWLVVCVVFVVJVVOVUIVVPVVRURUEVVPURUUIPVWCVVPVVRURYJVVBUWEUUJB
      VVQTWKUUKWLZUULZUUMZVUIUYTVUIUYTVWGWAUUNZVUIUWIVUTUYTXOVUIUWIUWEUWGSUKQZY
      KQZVUQFOZVUQSYJQZFOZDQZEYGZVUTVUPVUIVWJVWNEVUIUWEVWIUUOZVUIVUQVWJPZWDZAVU
      QRPZVWNVKPZAVUFVWQYLZVWQVUIVVGVWSVUQUWEVWIYMZVUIUYQVVGVWSAUYQVUEUUSSVUQUW
      ERVAXTYHZYNZAVWSWDZVUJVWKGPZVWMGPZVWTAVUJVWSHWQZARGVUQFIUUPZAVUOVWLRPVXGV
      WSIVUQUUQRGVWLFXSWOZVWKVWMDGYAYBZYOZYPZVWFVUIDEFUWEUWGGVUNAUYQVUEUUTVUQUW
      EUWGYKQPVUIVVGVXFVUQUWEUWGYMVVKAVWSVXFAVUFVVGYLZVXCVXIYOYNUVAVUIVWOVWJVUS
      EYGVUTVXMVUIVWJVUSEVWPVWQVUIVVGVUSVKPVXBVVOYNZYPVWFVUIVWJVWNVUSEVWPVXLVXO
      VWRAVWSVWNVUSXOUEZVXAVXDMYOUVBVUIVWJVUSEVVBUWEUWLVVCVVFVWPVWJUWLUVCVUIUWE
      VWIUVDVHVVJVVOVVKBVURVVMVVNVVKAVWSUQBXOUEVXNVXCVXEUQVWNVURUNQZBUQVKPVXEUV
      EVHVXEVWNVURVXKAUYJVUQVBPVURUIPZVWSKVUQWMCVUQWNWOZVRAVVLVWSJWQZVXEVWNVURV
      XKVXSVXEVUJVXFVXGUQVWNXOUEVXHVXIVXJVWKVWMDGUVFYBUVGVXEVXQBXOUEVXPMVXEVWNB
      VURVXKVXTVXSUVIYQYRYOVVKVURVVKAVWSVXRVXNVXCVXSYOVFUVJVWEUVHYRYRVWDXFVUIUY
      TVWGUVKYRYSVUGVUMVUAVKPZUWJVKPZVUHVUBWDUWKXIAVUFVUMUYOVUPYSAVUFVYAUYOVWHY
      SUYOVYBAVUFUWJUVLUVMUWIVUAUWJUVNYBUVRUVOUVPUVSUVQUVTUWAAULUWHUWFDUAUBFSGR
      VAAVUJDGUWBOPHDGUWCWLUXJUYEUWHYTAUYQWDUWFYTIUWDYQ $.
  $}

  ${
    $d j k m n x D $.  $d j k m n x G $.  $d j k m n x ph $.  $d j k m n x X $.
    $d j k m x F $.  $d k m n N $.  $d j m n x W $.  $d j k m x Z $.
    $d j n M $.
    caures.1 $e |- Z = ( ZZ>= ` M ) $.
    caures.3 $e |- ( ph -> M e. ZZ ) $.
    caures.4 $e |- ( ph -> D e. ( Met ` X ) ) $.
    ${
      caures.5 $e |- ( ph -> F e. ( X ^pm CC ) ) $.
      $( The restriction of a Cauchy sequence to a set of upper integers is
         Cauchy.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario
         Carneiro, 5-Jun-2014.) $)
      caures $p |- ( ph ->
                     ( F e. ( Cau ` D ) <-> ( F |` Z ) e. ( Cau ` D ) ) ) $=
        ( vk vj vx cc co wcel cfv wral wa cvv cpm cdm clt wbr w3a cuz wrex cres
        cv crp uztrn2 adantll biantrurd dmres syl6bbr 3anbi1d ralbidva rexbidva
        cca elin2 ralbidv cme wss elfvdm cnex ssid cz uzssz zsscn sstri eqsstri
        pmss12g mpanl12 sylancl fvex eqeltri pmresg sylancr sseldd 3bitr3d cxmt
        syl metxmet eqidd iscau4 wceq fvres adantl 3bitr4d ) ACENUAOZPZKUIZCUBZ
        PZWLCQZEPZWOLUIZCQZBOMUIUCUDZUEZKWQUFQZRZLFUGZMUJRZSZCFUHZWJPZWLXFUBZPZ
        WPWSUEZKXARZLFUGZMUJRZSZCBUSQZPXFXOPAXDXMXEXNAXCXLMUJAXBXKLFAWQFPZSZWTX
        JKXAXQWLXAPZSZWNXIWPWSXSWNWLFPZWNSXIXSXTWNXPXRXTADWLWQFGUKULUMWLFWMXHCF
        UNUTUOUPUQURVAAWKXDJUMAXGXMAEFUAOZWJXFAEVBUBZPZNTPZYAWJVCZABEVBQPZYCIBE
        VBVDWBVEEEVCFNVCYCYDSYEEVFFDUFQZNGYGVGNDVHVIVJVKEFENYBTVLVMVNAFTPWKXFYA
        PFYGTGDUFVOVPJEFNCTVQVRVSUMVTAMWOWRBLKCDEFGAYFBEWAQPIBEWCWBZHAXTSWOWDXQ
        WRWDWEAMWOWRBLKXFDEFGYHHXTWLXFQWOWFAWLFCWGWHXPWQXFQWRWFAWQFCWGWHWEWI $.
    $}

    caushft.4 $e |- W = ( ZZ>= ` ( M + N ) ) $.
    caushft.5 $e |- ( ph -> N e. ZZ ) $.
    caushft.7 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = ( G ` ( k + N ) ) ) $.
    caushft.8 $e |- ( ph -> F e. ( Cau ` D ) ) $.
    caushft.9 $e |- ( ph -> G : W --> X ) $.
    $( A shifted Cauchy sequence is Cauchy.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 5-Jun-2014.) $)
    caushft $p |- ( ph -> G e. ( Cau ` D ) ) $=
      ( cfv wcel vn vm vx vj cca cv clt wbr cuz wral wrex crp cdm caddc w3a cpm
      co cc wa cme cxmt metxmet syl wceq ralrimiva fveq2 fveq2d eqeq12d rspccva
      oveq1 sylan iscau4 simprd cz eleq2i biimpi eluzadd syl2anr syl6eleqr cmin
      mpbid simplr syl6eleq eluzelz ad2antrr simpr eluzsub syl3anc simp3 ralimi
      oveq1d breq1d rspcv syl2im adantl npcand wf uztrn2 ffvelrnd adantr metsym
      zcnd eqtrd sylibd ralrimdva raleqbidv rspcev ee12an rexlimdva ralimdv mpd
      zaddcld eqidd iscauf mpbird ) AEBUESZTUAUFZESZUBUFZESZBUQZUCUFZUGUHZUBXQU
      ISZUJZUAHUKZUCULUJZACUFZDUMTZYHGUNUQZESZITZYKUDUFZGUNUQZESZBUQZYBUGUHZUOZ
      CYMUISZUJZUDJUKZUCULUJZYGADIURUPUQTZUUBADXPTUUCUUBUSQAUCYKYOBUDCDFIJKABIU
      TSTZBIVASTMBIVBVCZLPAYHDSZYKVDZCJUJYMJTZYMDSZYOVDZAUUGCJPVEUUGUUJCYMJYHYM
      VDZUUFUUIYKYOYHYMDVFUUKYJYNEYHYMGUNVJVGVHVIVKVLWAVMAUUAYFUCULAYTYFUDJAUUH
      USZYNHTZYTYOXTBUQZYBUGUHZUBYNUISZUJZYFUULYNFGUNUQZUISZHUUHYMFUISZTZGVNTZY
      NUUSTAUUHUVAJUUTYMKVOVPOGFYMVQVRNVSZUULYTUUOUBUUPUULXSUUPTZUSZYTXSGVTUQZG
      UNUQZESZYOBUQZYBUGUHZUUOUVEUVFYSTZYTYQCYSUJUVJUVEYMVNTZUVBUVDUVKUVEUVAUVL
      UVEYMJUUTAUUHUVDWBKWCFYMWDVCAUVBUUHUVDOWEUULUVDWFGYMXSWGWHYRYQCYSYIYLYQWI
      WJYQUVJCUVFYSYHUVFVDZYPUVIYBUGUVMYKUVHYOBUVMYJUVGEYHUVFGUNVJVGWKWLWMWNUVE
      UVIUUNYBUGUVEUVIXTYOBUQZUUNUVEUVHXTYOBUVEUVGXSEUVEXSGUVEXSUVDXSVNTUULYNXS
      WDWOXBAGURTUUHUVDAGOXBWEWPVGWKUVEUUDXTITYOITZUVNUUNVDAUUDUUHUVDMWEUVEHIXS
      EAHIEWQZUUHUVDRWEUULUUMUVDXSHTZUVCUURXSYNHNWRVKWSUULUVOUVDUULHIYNEAUVPUUH
      RWTUVCWSWTXTYOBIXAWHXCWLXDXEYEUUQUAYNHXQYNVDZYCUUOUBYDUUPXQYNUIVFUVRYAUUN
      YBUGUVRXRYOXTBXQYNEVFWKWLXFXGXHXIXJXKAUCXTXRBUAUBEUURIHNUUEAFGLOXLAUVQUSX
      TXMAXQHTUSXRXMRXNXO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Continuous maps and homeomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.
    constcncf.1 $e |- F = ( x e. CC |-> A ) $.
    $( A constant function is a continuous function on ` CC ` .  (Contributed
       by Jeff Madsen, 2-Sep-2009.)  (Moved into main set.mm as ~ cncfmptc and
       may be deleted by mathbox owner, JM. --MC 12-Sep-2015.)  (Revised by
       Mario Carneiro, 12-Sep-2015.) $)
    constcncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      ( cc wcel cmpt ccncf co wss ssid cncfmptc mp3an23 syl5eqel ) BEFZCAEBGZEE
      HIZDOEEJZRPQFEKZSABEELMN $.
  $}

  ${
    $d x y $.
    idcncf.1 $e |- F = ( x e. CC |-> x ) $.
    $( The identity function is a continuous function on ` CC ` .  (Contributed
       by Jeff Madsen, 11-Jun-2010.)  (Moved into main set.mm as ~ cncfmptid
       and may be deleted by mathbox owner, JM. --MC 12-Sep-2015.)  (Revised by
       Mario Carneiro, 12-Sep-2015.) $)
    idcncf $p |- F e. ( CC -cn-> CC ) $=
      ( cc cv cmpt ccncf co wss wcel ssid cncfmptid mp2an eqeltri ) BADAEFZDDGH
      ZCDDIZQOPJDKZRADDLMN $.
  $}

  ${
    $d A u v w x y $.  $d F u v w $.
    sub1cncf.1 $e |- F = ( x e. CC |-> ( x - A ) ) $.
    $( Subtracting a constant is a continuous function.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       12-Sep-2015.) $)
    sub1cncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      ( cc wcel cv cmin co cmpt ccncf ccnfld ctopn cfv ctx ccn subcn a1i idcncf
      eqid wss ssid cncfmptc mp3an23 cncfmpt2f syl5eqel ) BEFZCAEAGZBHIJEEKIZDU
      GAUHBHLMNZEUJTZHUJUJOIUJPIFUGUJUKQRAEUHJZUIFUGAULULTSRUGEEUAZUMAEBJUIFEUB
      ZUNABEEUCUDUEUF $.
  $}

  ${
    $d A u v w x y $.  $d F u v w $.
    sub2cncf.1 $e |- F = ( x e. CC |-> ( A - x ) ) $.
    $( Subtraction from a constant is a continuous function.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario Carneiro,
       12-Sep-2015.) $)
    sub2cncf $p |- ( A e. CC -> F e. ( CC -cn-> CC ) ) $=
      ( cc wcel cv cmin cmpt ccncf ccnfld ctopn cfv eqid ctx ccn subcn a1i wss
      co ssid cncfmptc mp3an23 idcncf cncfmpt2f syl5eqel ) BEFZCAEBAGZHTIEEJTZD
      UGABUHHKLMZEUJNZHUJUJOTUJPTFUGUJUKQRUGEESZULAEBIUIFEUAZUMABEEUBUCAEUHIZUI
      FUGAUNUNNUDRUEUF $.
  $}

  ${
    $d J x y z $.  $d K x y z $.  $d F x y z $.  $d X x y z $.  $d Y x y z $.
    $d A x y z $.  $d B x y z $.
    cnres2.1 $e |- X = U. J $.
    cnres2.2 $e |- Y = U. K $.
    $( The restriction of a continuous function to a subset is continuous.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       15-Dec-2013.) $)
    cnres2 $p |- ( ( ( J e. Top /\ K e. Top ) /\ ( A C_ X /\ B C_ Y ) /\
                ( F e. ( J Cn K ) /\ A. x e. A ( F ` x ) e. B ) ) -> ( F |` A )
                  e. ( ( J |`t A ) Cn ( K |`t B ) ) ) $=
      ( ctop wcel wa wss ccn co cfv crest syl2anc wb cv wral cres simp3l simp2l
      w3a cnrest ctopon crn simp1r toptopon sylib cima df-ima simp3r cdm wf cnf
      wfun ffun 3syl wceq fdm funimass4 mpbird syl5eqssr simp2r cnrest2 syl3anc
      sseqtr4d mpbid ) EKLZFKLZMZBGNZCHNZMZDEFOPLZAUADQCLABUBZMZUFZDBUCZEBRPZFO
      PLZWBWCFCRPOPLZWAVRVOWDVNVQVRVSUDZVNVOVPVTUEZBDEFGIUGSWAFHUHQLZWBUIZCNVPW
      DWETWAVMWHVLVMVQVTUJFHJUKULWAWIDBUMZCDBUNWAWJCNZVSVNVQVRVSUOWADUSZBDUPZNW
      KVSTWAVRGHDUQZWLWFDEFGHIJURZGHDUTVAWABGWMWGWAVRWNWMGVBWFWOGHDVCVAVJABCDVD
      SVEVFVNVOVPVTVGCWBWCFHVHVIVK $.
  $}

  ${
    $d J x y z $.  $d K x y z $.  $d F x y z $.
    $( A continuous function is continuous onto its image.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 15-Dec-2013.) $)
    cnresima $p |- ( ( J e. Top /\ K e. Top /\ F e. ( J Cn K ) )
                              -> F e. ( J Cn ( K |`t ran F ) ) ) $=
      ( ctop wcel ccn co w3a crn crest simp3 cuni ctopon cfv wss simp2 toptopon
      wb eqid sylib ssid a1i wf cnf frn syl 3ad2ant3 cnrest2 syl3anc mpbid ) BD
      EZCDEZABCFGEZHZUMABCAIZJGFGEZUKULUMKUNCCLZMNEZUOUOOZUOUQOZUMUPRUNULURUKUL
      UMPCUQUQSZQTUSUNUOUAUBUMUKUTULUMBLZUQAUCUTABCVBUQVBSVAUDVBUQAUEUFUGUOABCU
      QUHUIUJ $.
  $}

  ${
    $d A w x y z $.  $d B w x y z $.  $d C w y z $.  $d J x y $.  $d K x y $.
    $d G z $.
    cncfres.1 $e |- A C_ CC $.
    cncfres.2 $e |- B C_ CC $.
    cncfres.3 $e |- F = ( x e. CC |-> C ) $.
    cncfres.4 $e |- G = ( x e. A |-> C ) $.
    cncfres.5 $e |- ( x e. A -> C e. B ) $.
    cncfres.6 $e |- F e. ( CC -cn-> CC ) $.
    cncfres.7 $e |- J = ( MetOpen ` ( ( abs o. - ) |` ( A X. A ) ) ) $.
    cncfres.8 $e |- K = ( MetOpen ` ( ( abs o. - ) |` ( B X. B ) ) ) $.
    $( A continuous function on complex numbers restricted to a subset.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       12-Sep-2015.) $)
    cncfres $p |- G e. ( J Cn K ) $=
      ( ccncf co wcel cc ccn wf fmpti wss wb cmpt cres wceq resmpt ax-mp eqtr4i
      eqeltrri rescncf mp2 eqeltri cncffvrn mp2an mpbir cabs cmin ccom cxp eqid
      cncfmet eleqtri ) FBCQRZGHUARZFVFSZBCFUBZABCDFLMUCCTUDZFBTQRZSVHVIUEJFATD
      UFZBUGZVKFABDUFZVMLBTUDZVMVNUHIATBDUIUJUKVOVLTTQRZSVMVKSIEVLVPKNULTTBVLUM
      UNUOBTCFUPUQURVOVJVFVGUHIJBCUSUTVAZBBVBUGZVQCCVBUGZGHVRVCVSVCOPVDUQVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Boundedness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c TotBnd $.
  $c Bnd $.
  $( Extend class notation with the class of totally bounded metric spaces. $)
  ctotbnd $a class TotBnd $.
  $( Extend class notation with the class of bounded metric spaces. $)
  cbnd $a class Bnd $.

  ${
    $d b d m v x y $.
    $( Define the class of totally bounded metrics.  A metric space is totally
       bounded iff it can be covered by a finite number of balls of any given
       radius.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    df-totbnd $a |- TotBnd = ( x e. _V |-> { m e. ( Met ` x ) |
      A. d e. RR+ E. v e. Fin ( U. v = x /\
        A. b e. v E. y e. x b = ( y ( ball ` m ) d ) ) } ) $.
  $}

  ${
    $d b d m v x M $.  $d b d m v x y X $.
    $( The predicate "is a totally bounded metric space".  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    istotbnd $p |- ( M e. ( TotBnd ` X ) <-> ( M e. ( Met ` X ) /\
      A. d e. RR+ E. v e. Fin ( U. v = X /\
        A. b e. v E. x e. X b = ( x ( ball ` M ) d ) ) ) ) $=
      ( vm vy ctotbnd cfv wcel cme cv wceq wrex wral wa cfn crp ralbidv cvv cbl
      cuni co elfvex crab fveq2 eqeq2 rexeq anbi12d rexbidv rabeqbidv df-totbnd
      adantr fvex rabex fvmpt eleq2d oveqd eqeq2d anbi2d elrab syl6bb pm5.21nii
      ) CDIJZKZDUAKZCDLJZKZBMZUCZDNZEMZAMZFMZCUBJZUDZNZADOZEVJPZQZBROZFSPZQZCDI
      UEVIVGWCCDLUEUNVGVFCVLVMVNVOGMZUBJZUDZNZADOZEVJPZQZBROZFSPZGVHUFZKWDVGVEW
      NCHDVKHMZNZWHAWOOZEVJPZQZBROZFSPZGWOLJZUFWNUAIWODNZXAWMGXBVHWODLUGXCWTWLF
      SXCWSWKBRXCWPVLWRWJWODVKUHXCWQWIEVJWHAWODUITUJUKTULHABGEFUMWMGVHDLUOUPUQU
      RWMWCGCVHWECNZWLWBFSXDWKWABRXDWJVTVLXDWIVSEVJXDWHVRADXDWGVQVMXDWFVPVNVOWE
      CUBUGUSUTUKTVAUKTVBVCVD $.
  $}

  ${
    $d M d v b x $.  $d X d v b x $.
    $( The predicate "is a totally bounded metric space."  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    istotbnd2 $p |- ( M e. ( Met ` X ) -> ( M e. ( TotBnd ` X ) <->
       A. d e. RR+ E. v e. Fin ( U. v = X /\
         A. b e. v E. x e. X b = ( x ( ball ` M ) d ) ) ) ) $=
      ( ctotbnd cfv wcel cme cv cuni wceq cbl co wrex wral wa cfn crp istotbnd
      baib ) CDGHICDJHIBKZLDMEKAKFKCNHOMADPEUCQRBSPFTQABCDEFUAUB $.
  $}

  ${
    $d b d f v w x M $.  $d b d f v w x X $.
    $( A metric space is totally bounded iff there is a finite &epsilon;-net
       for every positive &epsilon;.  This differs from the definition in
       providing a finite set of ball centers rather than a finite set of
       balls.  (Contributed by Mario Carneiro, 12-Sep-2015.) $)
    istotbnd3 $p |- ( M e. ( TotBnd ` X ) <-> ( M e. ( Met ` X ) /\ A. d e. RR+
      E. v e. ( ~P X i^i Fin ) U_ x e. v ( x ( ball ` M ) d ) = X ) ) $=
      ( vw vb vf cfv wcel cv wceq wrex wral wa cfn crp ciun wss syl ctotbnd cme
      cbl co cpw cin istotbnd wf wex wi oveq1 eqeq2d ac6sfi ex ad2antlr simprrl
      cuni crn frn wfo simplr wfn ffn dffn4 sylib syl2anc elfpw sylanbrc eleq2d
      wb rexrn eliun 3bitr4g eqrdv simprrr iuneq2 uniiun simprl syl5eqr 3eqtr2d
      fofi iuneq1 eqeq1d rspcev expr exlimdv syld expimpd rexlimdva cab simprbi
      cmpt mptfi rnfi 3syl ovex dfiun3 simprr eqid rnmpt simplbi ssrexv ss2abdv
      ad2antrl syl5eqss ssabral syl5bbr anbi12d syl12anc impbid ralbidv pm5.32i
      unieq sseq1 bitri ) CDUAIJCDUBIJZFKZUQZDLZGKZAKZEKZCUCIZUDZLZADMZGXQNZOZF
      PMZEQNZOXPABKZYDRZDLZBDUEPUFZMZEQNZOAFCDGEUGXPYJYPXPYIYOEQXPYIYOXPYHYOFPX
      PXQPJZOZXSYGYOYRXSOZYGXQDHKZUHZXTXTYTIZYBYCUDZLZGXQNZOZHUIZYOYQYGUUGUJXPX
      SYQYGUUGYEUUDGAXQDHYAUUBLZYDUUCXTYAUUBYBYCUKZULUMUNUOYSUUFYOHYRXSUUFYOYRX
      SUUFOZOZYTURZYNJZAUULYDRZDLZYOUUKUULDSZUULPJZUUMUUKUUAUUPYRXSUUAUUEUPZXQD
      YTUSTUUKYQXQUULYTUTZUUQXPYQUUJVAUUKYTXQVBZUUSUUKUUAUUTUURXQDYTVCTZXQYTVDV
      EXQUULYTWAVFUULDVGVHUUKUUNGXQUUCRZGXQXTRZDUUKBUUNUVBUUKYKYDJZAUULMZYKUUCJ
      ZGXQMZYKUUNJYKUVBJUUKUUTUVEUVGVJUVAUVDUVFAGXQYTUUHYDUUCYKUUIVIVKTAYKUULYD
      VLGYKXQUUCVLVMVNUUKUUEUVCUVBLYRXSUUAUUEVOGXQXTUUCVPTUUKUVCXRDGXQVQYRXSUUF
      VRVSVTYMUUOBUULYNYKUULLYLUUNDAYKUULYDWBWCWDVFWEWFWGWHWIXPYMYIBYNXPYKYNJZY
      MYIXPUVHYMOOZAYKYDWLZURZPJZUVKUQZDLZUVKYFGWJZSZYIUVIYKPJZUVJPJUVLUVHUVQXP
      YMUVHYKDSZUVQYKDVGZWKXDAYKYDWMUVJWNWOUVIUVMYLDAYKYDYAYBYCWPWQXPUVHYMWRVSU
      VIUVKYEAYKMZGWJUVOAGYKYDUVJUVJWSWTUVIUVTYFGUVIUVRUVTYFUJUVHUVRXPYMUVHUVRU
      VQUVSXAXDYEAYKDXBTXCXEYHUVNUVPOFUVKPXQUVKLZXSUVNYGUVPUWAXRUVMDXQUVKXMWCYG
      XQUVOSUWAUVPYFGXQXFXQUVKUVOXNXGXHWDXIWEWIXJXKXLXO $.
  $}

  ${
    $d b d v x M $.  $d b d v x X $.
    $( The predicate "totally bounded" implies ` M ` is a metric space.
       (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    totbndmet $p |- ( M e. ( TotBnd ` X ) -> M e. ( Met ` X ) ) $=
      ( vv vb vx vd ctotbnd cfv wcel cme cv cuni wceq cbl co wrex wral cfn crp
      wa istotbnd simplbi ) ABGHIABJHICKZLBMDKEKFKANHOMEBPDUCQTCRPFSQECABDFUAUB
      $.
  $}

  ${
    $d r v x M $.
    $( The metric (there is only one) on the empty set is totally bounded.
       (Contributed by Mario Carneiro, 16-Sep-2015.) $)
    0totbnd $p |- ( X = (/) ->
      ( M e. ( TotBnd ` X ) <-> M e. ( Met ` X ) ) ) $=
      ( vx vv vr c0 wceq ctotbnd cfv wcel cme fveq2 eleq2d cbl ciun cpw cfn crp
      cv co wrex wral 0elpw 0fin elin mpbir2an iuneq1 eqeq1d rspcev mp2an rgenw
      cin 0iun istotbnd3 mpbiran2 syl6rbbr bitrd ) BFGZABHIZJAFHIZJZABKIZJZURUS
      UTABFHLMURVCAFKIZJZVAURVBVDABFKLMVAVECDSZCSESANITZOZFGZDFPZQULZUAZERUBVLE
      RFVKJZCFVGOZFGZVLVMFVJJFQJFUCUDFVJQUEUFCVGUMVIVODFVKVFFGVHVNFCVFFVGUGUHUI
      UJUKCDAFEUNUOUPUQ $.
  $}

  ${
    $d b c d f u v w x y z M $.  $d b c d f u v w x y z X $.
    $d c d f u v w x y z N $.  $d b c d f u v w x y z Y $.
    sstotbnd.2 $e |- N = ( M |` ( Y X. Y ) ) $.
    $( Condition for a subset of a metric space to be totally bounded.
       (Contributed by Mario Carneiro, 12-Sep-2015.) $)
    sstotbnd2 $p |- ( ( M e. ( Met ` X ) /\ Y C_ X ) ->
      ( N e. ( TotBnd ` Y ) <-> A. d e. RR+ E. v e. ( ~P X i^i Fin )
        Y C_ U_ x e. v ( x ( ball ` M ) d ) ) ) $=
      ( vy vz wcel wss wa co cin crp wral wceq syl c0 vw vc cme cfv ctotbnd cbl
      vf cv ciun cpw cfn wrex wb cxp cres metres2 syl5eqel istotbnd3 baib sspwb
      simpllr sylib ssrin simprl sseldd simprr wel cxmt metxmet ad4antr simplbi
      cxr elfpw adantl sselda simp-4r dfss1 eleqtrrd rpxrd blres inss1 syl6eqss
      syl3anc ralrimiva ss2iun adantrr eqsstr3d jca ex reximdv2 ralimdva sylbid
      c2 cdiv wi simpr rphalfcld oveq2 iuneq2d sseq2d rexbidv rspcv wne crab wf
      wex simprbi ad2antrl ssrab2 ssfi sylancl oveq1 ineq1d incom syl6eq neeq1d
      weq dfin5 rabn0 syl6bb elrab cima mpbird wfn ffn elpreima imaeq2d eleq12d
      id adantr syl2anc cbviunv ad4antlr iunss sylibr syl5eq sylan sstrd syl2an
      syld rgen eleq1 ac6sfi cdm ccnv w3a fdm feq2d baibd ralbidva ralrab2 3jca
      crn simpr2 frn simpr1 fnfi rnfi sylanbrc rpxr iunin1 simplrr syl6sseq 0ss
      blssm sseq1 mpbiri a1i simpr3 imbi12d rspccva ad2antrr ad3antrrr cnvimass
      cr syl5ss rpred simplbda syl22anc sseli ffvelrn simp-5r sseqtr4d fnfvelrn
      blhalf ssiun2s adantlr pm2.61dne eqssd iuneq1 eqeq1d rspcev mpd ralrimdva
      exlimdv rexlimdvaa sylibrd impbid ) CEUCUDKZFELZMZDFUEUDKZFABUHZAUHZGUHZC
      UFUDZNZUIZLZBEUJZUKOZULZGPQZUXAUXBAUXCUXDUXEDUFUDZNZUIZFRZBFUJZUKOZULZGPQ
      ZUXMUXADFUCUDZKZUXBUYAUMUXADCFFUNUOUYBHCFEUPUQZUXBUYCUYAABDFGURUSSUXAUXTU
      XLGPUXAUXEPKZMZUXQUXIBUXSUXKUYFUXCUXSKZUXQMZUXCUXKKZUXIMUYFUYHMZUYIUXIUYJ
      UXSUXKUXCUYJUXRUXJLZUXSUXKLUYJUWTUYKUWSUWTUYEUYHVAFEUTVBUXRUXJUKVCSUYFUYG
      UXQVDVEUYJFUXPUXHUYFUYGUXQVFUYFUYGUXPUXHLZUXQUYFUYGMZUXOUXGLZAUXCQUYLUYMU
      YNAUXCUYMABVGZMZUXOUXGFOZUXGUYPCEVHUDKZUXDEFOZKUXEVLKUXOUYQRUWSUYRUWTUYEU
      YGUYOCEVIZVJUYPUXDFUYSUYMUXCFUXDUYGUXCFLZUYFUYGVUAUXCUKKZUXCFVMVKVNVOUYPU
      WTUYSFRZUWSUWTUYEUYGUYOVPFEVQZVBVRUYPUXEUXAUYEUYGUYOVAVSDCUXDUXEEFHVTWCUX
      GFWAWBWDAUXCUXOUXGWESWFWGWHWIWJWKWLUXAUXMAUAUHZUXDUBUHZUXNNZUIZFRZUAUXSUL
      ZUBPQZUXBUXAUXMVUJUBPUXAVUFPKZMZUXMFAUXCUXDVUFWMWNNZUXFNZUIZLZBUXKULZVUJV
      UMVUNPKUXMVURWOVUMVUFUXAVULWPWQUXLVURGVUNPUXEVUNRZUXIVUQBUXKVUSUXHVUPFVUS
      AUXCUXGVUOUXEVUNUXDUXFWRWSWTXAXBSVUMVUQVUJBUXKVUMUYIVUQMZMZVUOFOZTXCZAUXC
      XDZFUGUHZXEZIUHZVVEUDZVVGVUNUXFNZKZIVVDQZMZUGXFZVUJVVAVVDUKKZJUHZVVIKZJFU
      LZIVVDQVVMVVAVUBVVDUXCLVVNUYIVUBVUMVUQUYIUXCELZVUBUXCEVMZXGXHZVVCAUXCXIZU
      XCVVDXJXKVVQIVVDVVGVVDKZIBVGZVVQVVCVVQAVVGUXCAIXQZVVCVVPJFXDZTXCVVQVWDVVB
      VWETVWDVVBFVVIOZVWEVWDVVBVVIFOZVWFVWDVUOVVIFUXDVVGVUNUXFXLZXMZVVIFXNXOJFV
      VIXRXOXPVVPJFXSXTYAXGUUAVVPVVJIJVVDFUGVVOVVHVVIUUBUUCXKVVAVVLVUJUGVVAVVLV
      VEUUDZUXCLZVWJFVVEXEZVVCUXDVVEUUEZVUOYBZKZWOZAUXCQZUUFZVUJVVAVUBVVLVWRWOV
      VTVUBVVLVWRVUBVVLMZVWKVWLVWQVWSVWJVVDUXCVVFVWJVVDRVUBVVKVVDFVVEUUGXHZVWAW
      BVWSVWLVVFVUBVVFVVKVDVWSVWJVVDFVVEVWTUUHYCVWSVVGVWMVVIYBZKZIVVDQZVWQVWSVX
      CVVKVUBVVFVVKVFVVFVXCVVKUMVUBVVKVVFVXBVVJIVVDVVFVXBVWBVVJVVFVVEVVDYDVXBVW
      BVVJMUMVVDFVVEYEVVDVVGVVIVVEYFSUUIUUJXHYCVVCVXBVWOIAUXCIAXQZVVGUXDVXAVWNV
      XDYIVXDVVIVUOVWMVVGUXDVUNUXFXLYGYHUUKVBUULWISVVAVWRVUJVVAVWRMZVVEUUMZUXSK
      ZAVXFVUGUIZFRZVUJVXEVXFFLZVXFUKKZVXGVXEVWLVXJVVAVWKVWLVWQUUNZVWJFVVEUUOSZ
      VXEVVEUKKZVXKVXEVVEVWJYDZVWJUKKZVXNVXEVWLVXOVXLVWJFVVEYESZVXEVUBVWKVXPVVA
      VUBVWRVVTYJVVAVWKVWLVWQUUPZUXCVWJXJYKVWJVVEUUQYKVVEUURSVXFFVMUUSVXEVXHJVX
      FVVOVUFUXNNZUIZFAJVXFVUGVXSUXDVVOVUFUXNXLYLVXEVXTFVXEVXSFLZJVXFQVXTFLVXEV
      YAJVXFVXEVVOVXFKZMZDFVHUDKZVVOFKVUFVLKZVYAVYCUYCVYDUXAUYCVULVUTVWRVYBUYDV
      JDFVISVXEVXFFVVOVXMVOVULVYEUXAVUTVWRVYBVUFUUTZYMDVVOVUFFUVEWCWDJVXFVXSFYN
      YOVXEFIUXCVWGUIZVXTVXEVYGIUXCVVIUIZFOZFIUXCFVVIUVAVXEFVYHLVYIFRVXEFVUPVYH
      VUMUYIVUQVWRUVBAIUXCVUOVVIVWHYLUVCFVYHVQVBYPVXEVWGVXTLZIUXCQVYGVXTLVXEVYJ
      IUXCVXEVWCMZVYJVWGTVWGTRZVYJWOVYKVYLVYJTVXTLVXTUVDVWGTVXTUVFUVGUVHVYKVWGT
      XCZVXBVYJVXEVWQVWCVYMVXBWOZVVAVWKVWLVWQUVIVWPVYNAVVGUXCVWDVVCVYMVWOVXBVWD
      VVBVWGTVWIXPVWDUXDVVGVWNVXAVWDYIVWDVUOVVIVWMVWHYGYHUVJUVKYQVYKVXBVYJVXEVX
      BVYJVWCVXEVXBMZVWGVVHVUFUXNNZVXTVYOVWGVVHVUFUXFNZFOZVYPVYOVVIVYQLZVWGVYRL
      VYOUYRVVGEKVUFUVOKVVJVYSVUMUYRVUTVWRVXBUWSUYRUWTVULUYTUVLUVMZVXEVXAEVVGVX
      EVXAVWJEVVEVVIUVNZVXEVWJUXCEVXRVVAVVRVWRUYIVVRVUMVUQUYIVVRVUBVVSVKXHYJYRU
      VPVOVYOVUFUXAVULVUTVWRVXBVPUVQVXEVXOVXBVVJVXQVXOVXBVVGVWJKZVVJVWJVVGVVIVV
      EYFUVRYQVUFCEVVGVVHUWEUVSVVIVYQFVCSVYOUYRVVHUYSKVYEVYPVYRRVYTVYOVVHFUYSVX
      EVWLWUBVVHFKVXBVXLVXAVWJVVGWUAUVTZVWJFVVGVVEUWAYSVYOUWTVUCUWSUWTVULVUTVWR
      VXBUWBVUDVBVRVULVYEUXAVUTVWRVXBVYFYMDCVVHVUFEFHVTWCUWCVYOVVHVXFKZVYPVXTLV
      XEVXOWUBWUDVXBVXQWUCVWJVVGVVEUWDYSJVXFVXSVVHVYPVVOVVHVUFUXNXLUWFSYRUWGWIY
      TUWHWDIUXCVWGVXTYNYOWGUWIYPVUIVXIUAVXFUXSVUEVXFRVUHVXHFAVUEVXFVUGUWJUWKUW
      LYKWIYTUWOUWMUWPYTUWNUXAUYCUXBVUKUMUYDUXBUYCVUKAUADFUBURUSSUWQUWR $.

    $( Condition for a subset of a metric space to be totally bounded.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof shortened by Mario
       Carneiro, 12-Sep-2015.) $)
    sstotbnd $p |- ( ( M e. ( Met ` X ) /\ Y C_ X ) ->
      ( N e. ( TotBnd ` Y ) <-> A. d e. RR+ E. v e. Fin ( Y C_ U. v /\
        A. b e. v E. x e. X b = ( x ( ball ` M ) d ) ) ) ) $=
      ( vu vf cfv wcel wss wa cv ciun cfn wrex wceq cme ctotbnd cbl cpw cin crp
      vy co wral cuni sstotbnd2 cmpt crn elfpw simprbi mptfi rnfi 3syl ad2antrl
      cab simprr eqid rnmpt wi simplbi ssrexv syl ss2abdv syl5eqss unieq dfiun3
      ovex syl6eqr sseq2d ssabral syl5bbr anbi12d rspcev syl12anc rexlimdvaa wf
      sseq1 wex oveq1 eqeq2d ac6sfi adantrl frn wfo simplrl wfn ffn dffn4 sylib
      adantl fofi syl2anc sylanbrc simprrl adantr uniiun iuneq2 syl5eq ad2antll
      sseqtrd eleq2d rexrn eliun 3bitr4g eqrdv sseqtr4d iuneq1 exlimddv ralbidv
      impbid bitrd ) CEUALMFENOZDFUBLMFAJPZAPZHPZCUCLZUHZQZNZJEUDRUEZSZHUFUIFBP
      ZUJZNZGPZYBTZAESZGYGUIZOZBRSZHUFUIAJCDEFHIUKXQYFYOHUFXQYFYOXQYDYOJYEXQXRY
      EMZYDOOZAXRYBULZUMZRMZYDYSYLGUTZNZYOYPYTXQYDYPXRRMZYRRMYTYPXRENZUUCXREUNZ
      UOAXRYBUPYRUQURUSXQYPYDVAYQYSYKAXRSZGUTUUAAGXRYBYRYRVBVCYQUUFYLGYPUUFYLVD
      ZXQYDYPUUDUUGYPUUDUUCUUEVEYKAXREVFVGUSVHVIYNYDUUBOBYSRYGYSTZYIYDYMUUBUUHY
      HYCFUUHYHYSUJYCYGYSVJAXRYBXSXTYAVLVKVMVNYMYGUUANUUHUUBYLGYGVOYGYSUUAWBVPV
      QVRVSVTXQYNYFBRXQYGRMZYNOZOZYGEKPZWAZYJYJUULLZXTYAUHZTZGYGUIZOZYFKUUJUURK
      WCZXQUUIYMUUSYIYKUUPGAYGEKXSUUNTZYBUUOYJXSUUNXTYAWDZWEWFWGWOUUKUUROZUULUM
      ZYEMZFAUVCYBQZNZYFUVBUVCENZUVCRMZUVDUUMUVGUUKUUQYGEUULWHUSUVBUUIYGUVCUULW
      IZUVHXQUUIYNUURWJUVBUULYGWKZUVIUUMUVJUUKUUQYGEUULWLUSZYGUULWMWNYGUVCUULWP
      WQUVCEUNWRUVBFGYGUUOQZUVEUVBFYHUVLUUKYIUURXQUUIYIYMWSWTUUQYHUVLTUUKUUMUUQ
      YHGYGYJQUVLGYGXAGYGYJUUOXBXCXDXEUVBUVJUVEUVLTUVKUVJUGUVEUVLUVJUGPZYBMZAUV
      CSUVMUUOMZGYGSUVMUVEMUVMUVLMUVNUVOAGYGUULUUTYBUUOUVMUVAXFXGAUVMUVCYBXHGUV
      MYGUUOXHXIXJVGXKYDUVFJUVCYEXRUVCTYCUVEFAXRUVCYBXLVNVRWQXMVTXOXNXP $.

    $( Use a net that is not necessarily finite, but for which only finitely
       many balls meet the subset.  (Contributed by Mario Carneiro,
       14-Sep-2015.) $)
    sstotbnd3 $p |- ( ( M e. ( Met ` X ) /\ Y C_ X ) ->
      ( N e. ( TotBnd ` Y ) <-> A. d e. RR+ E. v e. ~P X
        ( Y C_ U_ x e. v ( x ( ball ` M ) d ) /\
          { x e. v | ( ( x ( ball ` M ) d ) i^i Y ) =/= (/) } e. Fin ) ) ) $=
      ( vy vw cfv wcel wss wa cv ciun cfn wrex crp wral cme ctotbnd cbl cin wne
      vz co c0 crab sstotbnd2 elin rabfi anim2i sylbi ancoms an12 sylib reximi2
      cpw ralimi syl6bi ssrab2 elpwi ad2antlr syl5ss elfpw sylanbrc ssel2 eliun
      simprr inelcm expcom ancrd reximdv impcom wceq oveq1 eleq2d rexrab2 bitri
      sylancom sylibr ex ssrdv ad2antrl iuneq1 sseq2d syl2anc rexlimdva ralimdv
      rspcev sylibrd impbid ) CEUAKLFEMNZDFUBKLZFABOZAOZGOZCUCKZUGZPZMZWTFUDUHU
      EZAWPUIZQLZNZBEUSZRZGSTZWNWOXBBXGQUDZRZGSTXIABCDEFGHUJXKXHGSXBXFBXJXGWPXJ
      LZXBNXBWPXGLZXENZNZXMXFNXBXLXOXLXNXBXLXMWPQLZNXNWPXGQUKXPXEXMXCAWPULUMUNU
      MUOXBXMXEUPUQURUTVAWNXIFIJOZIOZWRWSUGZPZMZJXJRZGSTWOWNXHYBGSWNXFYBBXGWNXM
      NZXFYBYCXFNZXDXJLZFIXDXSPZMZYBYDXDEMXEYEYDXDWPEXCAWPVBXMWPEMWNXFWPEVCVDVE
      YCXBXEVJXDEVFVGXBYGYCXEXBUFFYFXBUFOZFLZYHYFLZXBYINZXCYHWTLZNZAWPRZYJXBYIY
      LAWPRZYNYKYHXALYOFXAYHVHAYHWPWTVIUQYIYOYNYIYLYMAWPYIYLXCYLYIXCYHWTFVKVLVM
      VNVOWAYJYHXSLZIXDRYNIYHXDXSVIXCYPYLIAWPXRWQVPXSWTYHXRWQWRWSVQVRVSVTWBWCWD
      WEYAYGJXDXJXQXDVPXTYFFIXQXDXSWFWGWKWHWCWIWJIJCDEFGHUJWLWM $.
  $}

  ${
    $d b d v x M $.  $d b d v x S $.  $d b d v x X $.
    $( A subset of a totally bounded metric space is totally bounded.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       12-Sep-2015.) $)
    totbndss $p |- ( ( M e. ( TotBnd ` X ) /\ S C_ X ) ->
        ( M |` ( S X. S ) ) e. ( TotBnd ` S ) ) $=
      ( vv vb vx vd ctotbnd cfv wcel wss wa cxp cres cv wceq wrex wral cfn crp
      cuni cbl cme istotbnd simprbi sseq2 biimprcd anim1d reximdv ralimdv mpan9
      co wb totbndmet eqid sstotbnd sylan mpbird ) BCHIJZACKZLBAAMNZAHIJZADOZUA
      ZKZEOFOGOBUBIULPFCQEVCRZLZDSQZGTRZUSVDCPZVFLZDSQZGTRZUTVIUSBCUCIJZVMFDBCE
      GUDUEUTVLVHGTUTVKVGDSUTVJVEVFVJVEUTVDCAUFUGUHUIUJUKUSVNUTVBVIUMBCUNFDBVAC
      AEGVAUOUPUQUR $.
  $}

  ${
    $d s v x y M $.  $d r v x y N $.  $d r v x y ph $.  $d r s v x y X $.
    $d s v x y R $.
    equivtotbnd.1 $e |- ( ph -> M e. ( TotBnd ` X ) ) $.
    equivtotbnd.2 $e |- ( ph -> N e. ( Met ` X ) ) $.
    equivtotbnd.3 $e |- ( ph -> R e. RR+ ) $.
    equivtotbnd.4 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x N y ) <_ ( R x. ( x M y ) ) ) $.
    $( If the metric ` M ` is "strongly finer" than ` N ` (meaning that there
       is a positive real constant ` R ` such that
       ` N ( x , y ) <_ R x. M ( x , y ) ` ), then total boundedness of ` M `
       implies total boundedness of ` N ` .  (Using this theorem twice in each
       direction states that if two metrics are strongly equivalent, then one
       is totally bounded iff the other is.)  (Contributed by Mario Carneiro,
       14-Sep-2015.) $)
    equivtotbnd $p |- ( ph -> N e. ( TotBnd ` X ) ) $=
      ( vv vr vs cfv wcel cv co crp wss cme cbl ciun wceq cpw cfn cin wrex wral
      ctotbnd wa cdiv simpr adantr rpdivcld istotbnd3 simprbi syl oveq2 iuneq2d
      eqeq1d rexbidv rspcv sylc elfpw simplbi adantl sselda cmopn eqid anass1rs
      metss2lem adantlr syldan ralrimiva sseq1 syl5ibcom cxmt ad3antrrr metxmet
      ss2iun cxr simpllr rpxrd blssm syl3anc iunss sylibr eqss syl6ibr reximdva
      jctild mpd sylanbrc ) AFGUAOZPZBLQZBQZMQZFUBORZUCZGUDZLGUEUFUGZUHZMSUIFGU
      JOZPIAXDMSAWSSPZUKZBWQWRWSDULRZEUBOZRZUCZGUDZLXCUHZXDXGXHSPBWQWRNQZXIRZUC
      ZGUDZLXCUHZNSUIZXMXGWSDAXFUMADSPXFJUNUOXGEXEPZXSAXTXFHUNXTEWOPZXSBLEGNUPZ
      UQURXRXMNXHSXNXHUDZXQXLLXCYCXPXKGYCBWQXOXJXNXHWRXIUSUTVAVBVCVDXGXLXBLXCXG
      WQXCPZUKZXLXAGTZGXATZUKXBYEXLYGYFYEXKXATZXLYGYEXJWTTZBWQUIYHYEYIBWQYEWRWQ
      PZWRGPZYIYEWQGWRYDWQGTZXGYDYLWQUFPWQGVEVFVGVHZXGYKYIYDAYKXFYIABCFEDWSFVIO
      ZEVIOZGYNVJYOVJIAXTYAHXTYAXSYBVFURJKVLVKVMVNVOBWQXJWTWAURXKGXAVPVQYEWTGTZ
      BWQUIYFYEYPBWQYEYJUKZFGVROPZYKWSWBPYPYQWPYRAWPXFYDYJIVSFGVTURYMYQWSAXFYDY
      JWCWDFWRWSGWEWFVOBWQWTGWGWHWLXAGWIWJWKWMVOBLFGMUPWN $.
  $}

  ${
    $d m r x y $.
    $( Define the class of bounded metrics.  A metric space is bounded iff it
       can be covered by a single ball.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    df-bnd $a |- Bnd = ( x e. _V |-> { m e. ( Met ` x ) |
      A. y e. x E. r e. RR+ x = ( y ( ball ` m ) r ) } ) $.
  $}

  ${
    $d d m r s x y z M $.  $d d r y N $.  $d d r y P $.  $d d m r s x y z X $.
    $d r x R $.  $d r x S $.  $d d r x y Y $.
    $( The predicate "is a bounded metric space".  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
    isbnd $p |- ( M e. ( Bnd ` X ) <-> ( M e. ( Met ` X ) /\
        A. x e. X E. r e. RR+ X = ( x ( ball ` M ) r ) ) ) $=
      ( vm vy cbnd cfv wcel cvv cme cv cbl co wceq crp wrex wral elfvex crab wa
      adantr fveq2 eqeq1 rexbidv raleqbi1dv rabeqbidv df-bnd rabex fvmpt eleq2d
      fvex oveqd eqeq2d ralbidv elrab syl6bb pm5.21nii ) BCGHZIZCJIZBCKHZIZCALZ
      DLZBMHZNZOZDPQZACRZUAZBCGSVCVAVJBCKSUBVAUTBCVDVEELZMHZNZOZDPQZACRZEVBTZIV
      KVAUSVRBFCFLZVNOZDPQZAVSRZEVSKHZTVRJGVSCOZWBVQEWCVBVSCKUCWAVPAVSCWDVTVODP
      VSCVNUDUEUFUGFAEDUHVQEVBCKULUIUJUKVQVJEBVBVLBOZVPVIACWEVOVHDPWEVNVGCWEVMV
      FVDVEVLBMUCUMUNUEUOUPUQUR $.

    $( A bounded metric space is a metric space.  (Contributed by Mario
       Carneiro, 16-Sep-2015.) $)
    bndmet $p |- ( M e. ( Bnd ` X ) -> M e. ( Met ` X ) ) $=
      ( vx vy cbnd cfv wcel cme cv cbl co wceq crp wrex wral isbnd simplbi ) AB
      EFGABHFGBCIDIAJFKLDMNCBOCABDPQ $.

    $( A "bounded extended metric" (meaning that it satisfies the same
       condition as a bounded metric, but with "metric" replaced with "extended
       metric") is a metric and thus is bounded in the conventional sense.
       (Contributed by Mario Carneiro, 12-Sep-2015.) $)
    isbndx $p |- ( M e. ( Bnd ` X ) <-> ( M e. ( *Met ` X ) /\
        A. x e. X E. r e. RR+ X = ( x ( ball ` M ) r ) ) ) $=
      ( vy cbnd cfv wcel cme cv cbl co crp wral wa cr wf cxr vex sylanbrc isbnd
      wceq wrex cxmt metxmet cxp simpr wfn xmetf ffn 3syl ccnv cima wbr w3a cec
      simprr rpxr eqid blssec 3expa sylan2 adantrr eqsstrd sselda elec sylib wb
      wss xmeterval ad3antrrr mpbid simp3d ralrimiva rexlimdvaa ralimdva impcom
      ffnov ismet2 ex impbid2 pm5.32ri bitri ) BCFGHBCIGHZCAJZDJZBKGLZUBZDMUCZA
      CNZOBCUDGHZWJOABCDUAWJWDWKWJWDWKBCUEWJWKWDWJWKOZWKCCUFZPBQZWDWJWKUGZWLBWM
      UHZWEEJZBLPHZECNZACNZWNWLWKWMRBQWPWOBCUIWMRBUJUKWKWJWTWKWIWSACWKWECHZOZWH
      WSDMXBWFMHZWHOZOZWRECXEWQCHZOZXAXFWRXGWEWQBULPUMZUNZXAXFWRUOZXGWQWEXHUPZH
      XIXECXKWQXECWGXKXBXCWHUQXBXCWGXKVIZWHXCXBWFRHZXLWFURWKXAXMXLBWEXHWFCXHUSZ
      UTVAVBVCVDVEWQWEXHESASVFVGWKXIXJVHXAXDXFWEWQBXHCXNVJVKVLVMVNVOVPVQAECCPBV
      RTBCVSTVTWAWBWC $.

    $( The predicate "is a bounded metric space".  Uses a single point instead
       of an arbitrary point in the space.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    isbnd2 $p |- ( ( M e. ( Bnd ` X ) /\ X =/= (/) ) <-> ( M e. ( *Met ` X ) /\
                E. x e. X E. r e. RR+ X = ( x ( ball ` M ) r ) ) ) $=
      ( vy vs cfv wcel wa cv co wceq crp wrex eqeq2d c2 wss wi a1i cr cbnd cxmt
      c0 wne cbl wral isbndx anbi1i anass r19.2z ancoms oveq1 cbvrex2v cmul 2rp
      oveq2 rpmulcl mpan ad2antll ad2antrr cdiv cc cc0 rpcn 2cn 2ne0 w3a eqcomd
      divcan3 syl3anc oveq2d biimpd adantr imp simpr eleq2 biimpac rpre remulcl
      2re sylancr blhalf expr sylan2 anasss anassrs eqsstrd syldan adantl blssm
      cxr rpxr syl3an3 3expa an32s eqssd rspcev syl2anc ex ralrimdva rexlimdvva
      syl5bi rexn0 jcad impbid2 pm5.32i 3bitri ) BCUAGHZCUCUDZIBCUBGHZCAJZDJZBU
      EGZKZLZDMNZACUFZIZXIIXJXQXIIZIXJXPACNZIXHXRXIABCDUGUHXJXQXIUIXJXSXTXJXSXT
      XIXQXTXPACUJUKXJXTXQXIXTCEJZFJZXMKZLZFMNECNXJXQXOYDCYAXLXMKZLADEFCMXKYALX
      NYECXKYAXLXMULOXLYBLYEYCCXLYBYAXMUPOUMXJYDXQEFCMXJYACHZYBMHZIZIZYDXPACYIX
      KCHZIZYDXPYKYDIZPYBUNKZMHZCXKYMXMKZLZXPYIYNYJYDYGYNXJYFPMHYGYNUOPYBUQURZU
      SUTYLCYOYKYDCYAYMPVAKZXMKZLZCYOQYKYDYTYIYDYTRZYJYGUUAXJYFYGYDYTYGYCYSCYGY
      BYRYAXMYGYBVBHZPVBHZPVCUDZYBYRLYBVDUUCYGVESUUDYGVFSUUBUUCUUDVGYRYBYBPVIVH
      VJVKOVLUSVMVNYKYTICYSYOYKYTVOYIYJYTYSYOQZYJYTIYIXKYSHZUUEYTYJUUFCYSXKVPVQ
      YIUUFUUEXJYFYGUUFUUERZYGXJYFIZYMTHZUUGYGPTHYBTHUUIVTYBVRPYBVSWAUUHUUIUUFU
      UEYMBCYAXKWBWCWDWEVNWDWFWGWHYKYOCQZYDXJYJYHUUJYHXJYJIYNUUJYGYNYFYQWIXJYJY
      NUUJYNXJYJYMWKHUUJYMWLBXKYMCWJWMWNWDWOVMWPXOYPDYMMXLYMLXNYOCXLYMXKXMUPOWQ
      WRWSWTXAXBXTXIRXJXPACXCSXDXEXFXG $.

    $( A metric space is bounded iff the metric function maps to some bounded
       real interval.  (Contributed by Mario Carneiro, 13-Sep-2015.) $)
    isbnd3 $p |- ( M e. ( Bnd ` X ) <-> ( M e. ( Met ` X ) /\
        E. x e. RR M : ( X X. X ) --> ( 0 [,] x ) ) ) $=
      ( vy vr vz wcel cc0 co cr wa c0 wceq wral syl adantr sylancr cle wbr wb
      cbnd cfv cme cxp cv cicc wf wrex bndmet wne 0re ne0i wfn crn wss metf ffn
      ax-mp ad2antrr cdm fdm xpeq2 xp0 syl6eq sylan9eq dm0rn0 0ss syl6eqss df-f
      sylib sylanbrc ralrimiva r19.2z cbl crp cxmt isbnd2 simprbi wi c2 simprlr
      2re rpred remulcl simpll simprl simprr metcl syl3anc metge0 caddc simprll
      cmul readdcld mettri2 syl13anc clt simplrr eleqtrd cxr metxmet rpxr elbl2
      ad2antlr syl22anc mpbid lt2addd recnd 2timesd breqtrrd lelttrd w3a elicc2
      ltled mpbir3and ralrimivva ffnov oveq2 feq3 rspcev syl2anc rexlimdvva mpd
      expr pm2.61dane jca c1 simpllr simpr met0 simplr fovrnd eqbrtrrd ge0p1rpd
      simp3d crab fovrn 3expa adantlll simp1d peano2re ltp1d rabid2 rexrd blval
      sylibr eqtr4d eqeq2d isbnd ex rexlimdva imp impbii ) BCUAUBGZBCUCUBGZCCUD
      ZHAUEZUFIZBUGZAJUHZKUUNUUOUUTBCUIZUUNUUTCLUUNCLMZKZJLUJZUUSAJNUUTHJGZUVDU
      KJHULURUVCUUSAJUVCUUQJGZKZBUUPUMZBUNZUURUOUUSUUNUVHUVBUVFUUNUUOUVHUVAUUOU
      UPJBUGZUVHBCUPZUUPJBUQOZOUSUVGUVILUURUVGBUTZLMZUVILMUVCUVNUVFUUNUVBUVMUUP
      LUUNUVJUVMUUPMUUNUUOUVJUVAUVKOUUPJBVAOUVBUUPCLUDLCLCVBCVCVDVEPBVFVJUURVGV
      HUUPUURBVIVKVLUUSAJVMQUUNCLUJZKZCDUEZEUEZBVNUBZIZMZEVOUHZDCUHZUUTUVPBCVPU
      BGZUWCDBCEVQVRUUNUWCUUTVSZUVOUUNUUOUWEUVAUUOUWAUUTDECVOUUOUVQCGZUVRVOGZKZ
      UWAUUTUUOUWHUWAKZKZVTUVRWMIZJGZUUPHUWKUFIZBUGZUUTUWJVTJGUVRJGZUWLWBUWJUVR
      UUOUWFUWGUWAWAWCZVTUVRWDQZUWJUVHUUQFUEZBIZUWMGZFCNACNUWNUUOUVHUWIUVLPUWJU
      WTAFCCUWJUUQCGZUWRCGZKZKZUWTUWSJGZHUWSRSZUWSUWKRSZUXDUUOUXAUXBUXEUUOUWIUX
      CWEZUWJUXAUXBWFZUWJUXAUXBWGZUUQUWRBCWHWIZUXDUUOUXAUXBUXFUXHUXIUXJUUQUWRBC
      WJWIUXDUWSUWKUXKUWJUWLUXCUWQPZUXDUWSUVQUUQBIZUVQUWRBIZWKIZUWKUXKUXDUXMUXN
      UXDUUOUWFUXAUXMJGUXHUWJUWFUXCUUOUWFUWGUWAWLPZUXIUVQUUQBCWHWIZUXDUUOUWFUXB
      UXNJGZUXHUXPUXJUVQUWRBCWHWIZWNUXLUXDUUOUWFUXAUXBUWSUXORSUXHUXPUXIUXJUUQUW
      RUVQBCWOWPUXDUXOUVRUVRWKIUWKWQUXDUXMUXNUVRUVRUXQUXSUWJUWOUXCUWPPZUXTUXDUU
      QUVTGZUXMUVRWQSZUXDUUQCUVTUXIUUOUWHUWAUXCWRZWSUXDUWDUVRWTGZUWFUXAUYAUYBTU
      XDUUOUWDUXHBCXAZOZUWIUYDUUOUXCUWGUYDUWFUWAUVRXBXDXDZUXPUXIUUQBUVQUVRCXCXE
      XFUXDUWRUVTGZUXNUVRWQSZUXDUWRCUVTUXJUYCWSUXDUWDUYDUWFUXBUYHUYITUYFUYGUXPU
      XJUWRBUVQUVRCXCXEXFXGUXDUVRUXDUVRUXTXHXIXJXKXNUXDUVEUWLUWTUXEUXFUXGXLTUKU
      XLHUWKUWSXMQXOXPAFCCUWMBXQVKUUSUWNAUWKJUUQUWKMUURUWMMUUSUWNTUUQUWKHUFXRUU
      RUWMUUPBXSOXTYAYDYBOPYCYEYFUUOUUTUUNUUOUUSUUNAJUUOUVFKZUUSUUNUYJUUSKZUUOU
      WBDCNUUNUUOUVFUUSWEZUYKUWBDCUYKUWFKZUUQYGWKIZVOGCUVQUYNUVSIZMZUWBUYMUUQUU
      OUVFUUSUWFYHZUYMUVQUVQBIZHUUQRUYMUUOUWFUYRHMUYKUUOUWFUYLPZUYKUWFYIZUVQBCY
      JYAUYMUYRJGZHUYRRSZUYRUUQRSZUYMUYRUURGZVUAVUBVUCXLZUYMUVQUVQUURCCBUYJUUSU
      WFYKUYTUYTYLUYMUVEUVFVUDVUETUKUYQHUUQUYRXMQXFYOYMYNUYMCUXNUYNWQSZFCYPZUYO
      UYMVUFFCNCVUGMUYMVUFFCUYMUXBKZUXNUUQUYNVUHUXRHUXNRSZUXNUUQRSZVUHUXNUURGZU
      XRVUIVUJXLZUUSUWFUXBVUKUYJUUSUWFUXBVUKUVQUWRUURCCBYQYRYSUYMVUKVULTZUXBUYM
      UVEUVFVUMUKUYQHUUQUXNXMQPXFZYTUYMUVFUXBUYQPZUYMUYNJGZUXBUYMUVFVUPUYQUUQUU
      AOZPVUHUXRVUIVUJVUNYOVUHUUQVUOUUBXKVLVUFFCUUCUUFUYMUWDUWFUYNWTGUYOVUGMUYM
      UUOUWDUYSUYEOUYTUYMUYNVUQUUDFBUVQUYNCUUEWIUUGUWAUYPEUYNVOUVRUYNMUVTUYOCUV
      RUYNUVQUVSXRUUHXTYAVLDBCEUUIVKUUJUUKUULUUM $.

    $( A metric space is bounded iff the metric function maps to some bounded
       real interval.  (Contributed by Mario Carneiro, 22-Sep-2015.) $)
    isbnd3b $p |- ( M e. ( Bnd ` X ) <-> ( M e. ( Met ` X ) /\
        E. x e. RR A. y e. X A. z e. X ( y M z ) <_ x ) ) $=
      ( cfv wcel cc0 cv co wf cr wrex wa cle wbr wral wb 3expb adantlr cbnd cme
      cxp cicc isbnd3 wfn metf adantr ffn ffnov baib 3syl 0re a1i simplr metge0
      metcl elicc2 df-3an baibd syl22anc 2ralbidva bitrd rexbidva pm5.32i bitri
      w3a syl6bb ) DEUAFGDEUBFGZEEUCZHAIZUDJZDKZALMZNVIBIZCIZDJZVKOPZCEQBEQZALM
      ZNADEUEVIVNVTVIVMVSALVIVKLGZNZVMVQVLGZCEQBEQZVSWBVJLDKZDVJUFZVMWDRVIWEWAD
      EUGUHVJLDUIVMWFWDBCEEVLDUJUKULWBWCVRBCEEWBVOEGZVPEGZNZNZHLGZWAVQLGZHVQOPZ
      WCVRRWKWJUMUNVIWAWIUOVIWIWLWAVIWGWHWLVOVPDEUQSTVIWIWMWAVIWGWHWMVOVPDEUPST
      WKWANZWCWLWMNZVRWNWCWLWMVRVGWOVRNHVKVQURWLWMVRUSVHUTVAVBVCVDVEVF $.

    $( A subset of a bounded metric space is bounded.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    bndss $p |- ( ( M e. ( Bnd ` X ) /\ S C_ X ) ->
        ( M |` ( S X. S ) ) e. ( Bnd ` S ) ) $=
      ( vy vr vx cme cfv wcel cv cbl co wceq crp wrex wral wa cbnd cin an32s wi
      wss cxp metres2 adantlr ssel2 ancoms oveq1 eqeq2d rexbidv rspcva adantlll
      cres sylan dfss biimpi incom syl6eq ineq1 adantll eqid blssp an4s anassrs
      sylan9eq adantr eqtr4d ex reximdva imp syldan ralrimiva jca isbnd 3imtr4i
      anbi1i ) BCGHIZCDJZEJZBKHZLZMZENOZDCPZQZACUBZQZBAAUCUMZAGHIZAFJZVSWHKHLZM
      ZENOZFAPZQBCRHIZWFQWHARHIWGWIWNVQWFWIWDBACUDUEWGWMFAWEWJAIZWFWMWEWPQWFWMV
      QWPWDWFWMUAVQWPQZWDQWFWMWQWFWDWMWQWFQZWDCWJVSVTLZMZENOZWMWPWFWDXAVQWPWFQW
      JCIZWDXAWFWPXBACWJUFUGWCXADWJCVRWJMZWBWTENXCWAWSCVRWJVSVTUHUIUJUKUNULWRXA
      WMWRWTWLENWRVSNIZQZWTWLXEWTQAWSASZWKWRWTAXFMZXDWFWTXGWQWFWTACASZXFWFAACSZ
      XHWFAXIMACUOUPACUQURCWSAUSVEUTUEXEWKXFMZWTWQWFXDXJVQWFWPXDXJVSABWHCWJWHVA
      VBVCVDVFVGVHVIVJVKTVHTVJTVLVMWOWEWFDBCEVNVPFWHAEVNVO $.

    $( A ball is bounded.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Proof
       shortened by Mario Carneiro, 15-Jan-2014.) $)
    blbnd $p |- ( ( M e. ( *Met ` X ) /\ Y e. X /\ R e. RR ) ->
          ( M |` ( ( Y ( ball ` M ) R ) X. ( Y ( ball ` M ) R ) ) ) e.
            ( Bnd ` ( Y ( ball ` M ) R ) ) ) $=
      ( vx vr cxmt cfv wcel cbl co c0 wceq wa crp wrex adantr sylanbrc syl3anc
      cv cr w3a cxp cres cbnd wral wss simp1 cxr blssm syl3an3 xmetres2 syl2anc
      rexr rzal adantl isbndx wne simpl2 simpl3 cc0 clt wbr xbln0 biimpa blcntr
      wb elrpd cin elin rexrd eqid blres inidm syl6req isbnd2 simpld pm2.61dane
      rspceov ) BCGHIZDCIZAUAIZUBZBDABJHKZWDUCUDZWDUEHIZWDLWCWDLMZNWEWDGHIZWDET
      FTWEJHZKMFOPZEWDUFZWFWCWHWGWCVTWDCUGZWHVTWAWBUHZWBVTWAAUIIZWLAUNZBDACUJUK
      BWDCULUMZQWGWKWCWJEWDUOUPEWEWDFUQRWCWDLURZNZWFWQWRWHWJEWDPZWFWQNWCWHWQWPQ
      WRDWDIZAOIZWDDAWIKZMWSWRVTWAXAWTWCVTWQWMQZVTWAWBWQUSZWRAVTWAWBWQUTZWCWQVA
      AVBVCZWBVTWAWNWQXFVGWOBDACVDUKVEVHZBDACVFSZXGWRXBWDWDVIZWDWRVTDCWDVIIZWNX
      BXIMXCWRWAWTXJXDXHDCWDVJRWRAXEVKWEBDACWDWEVLVMSWDVNVOEFWDODAWDWIVSSEWEWDF
      VPRVQVR $.

    ssbnd.2 $e |- N = ( M |` ( Y X. Y ) ) $.
    $( A subset of a metric space is bounded iff it is contained in a ball
       around ` P ` , for any ` P ` in the larger space.  (Contributed by Mario
       Carneiro, 14-Sep-2015.) $)
    ssbnd $p |- ( ( M e. ( Met ` X ) /\ P e. X ) ->
      ( N e. ( Bnd ` Y ) <-> E. d e. RR Y C_ ( P ( ball ` M ) d ) ) ) $=
      ( vy vr cfv wcel wa co wss cr wrex c0 wceq cdm syl cme cbnd cv cbl wi wne
      wral cc0 0re ne0i ax-mp 0ss sseq1 mpbiri ralrimivw r19.2z sylancr a1i crp
      cxmt isbnd2 caddc simplll cxp cin cres dmeqi dmres eqtri cxr wf xmetf fdm
      syl5eqr sylibr ad2antlr metf ad3antrrr sseqtrd dmss dmxpid 3sstr3g simprl
      df-ss sseldd simpllr syl3anc rpre ad2antll readdcld metxmet elin sylanbrc
      metcl rpxr blres inss1 cle wbr leidd recnd pncand breqtrrd blss2 syl33anc
      syl5ss eqsstrd oveq2 sseq2d syl2anc rexbidv syl5ibrcom rexlimdvva expimpd
      cmin rspcev syl5bi expdimp pm2.61dne simprr resabs1 syl6eqr blbnd syl3an1
      ex xpss12 3expa adantrr bndss eqeltrrd rexlimdvaa impbid ) BDUAJKZADKZLZC
      EUBJZKZEAFUCZBUDJZMZNZFOPZYOYQUUBYOYQLZUUBEQEQRZUUBUEUUCUUDOQUFZUUAFOUGUU
      BUHOKUUEUIOUHUJUKUUDUUAFOUUDUUAQYTNYTULEQYTUMUNUOUUAFOUPUQURYOYQEQUFZUUBY
      QUUFLCEUTJKZEHUCZIUCZCUDJMZRZIUSPHEPZLYOUUBHCEIVAYOUUGUULUUBYOUUGLZUUKUUB
      HIEUSUUMUUHEKZUUIUSKZLZLZUUBUUKUUJYTNZFOPZUUQUUHABMZUUIVBMZOKZUUJAUVAYSMZ
      NZUUSUUQUUTUUIUUQYMUUHDKZYNUUTOKYMYNUUGUUPVCZUUQEDUUHUUQEEVDZSZDDVDZSZEDU
      UQUVGUVINUVHUVJNUUQUVGBSZUVIUUGUVGUVKNZYOUUPUUGUVGUVKVEZUVGRUVLUUGUVMCSZU
      VGUVNBUVGVFZSUVMCUVOGVGBUVGVHVIUUGUVGVJCVKUVNUVGRCEVLUVGVJCVMTVNUVGUVKWDV
      OVPYMUVKUVIRZYNUUGUUPYMUVIOBVKUVPBDVQUVIOBVMTVRVSUVGUVIVTTEWADWAWBUUMUUNU
      UOWCZWEZYMYNUUGUUPWFZUUHABDWNWGZUUOUUIOKZUUMUUNUUIWHWIZWJZUUQUUJUUHUUIYSM
      ZEVEZUVCUUQBDUTJKZUUHDEVEKZUUIVJKZUUJUWERUUQYMUWFUVFBDWKZTZUUQUVEUUNUWGUV
      RUVQUUHDEWLWMUUOUWHUUMUUNUUIWOWICBUUHUUIDEGWPWGUUQUWEUWDUVCUWDEWQUUQUWFUV
      EYNUWAUVBUUTUVAUUIXOMZWRWSUWDUVCNUWJUVRUVSUWBUWCUUQUUTUUTUWKWRUUQUUTUVTWT
      UUQUUTUUIUUQUUTUVTXAUUQUUIUWBXAXBXCBUUHAUUIUVADXDXEXFXGUURUVDFUVAOYRUVARY
      TUVCUUJYRUVAAYSXHXIXPXJUUKUUAUURFOEUUJYTUMXKXLXMXNXQXRXSYEYOUUAYQFOYOYROK
      ZUUALLZBYTYTVDZVFZUVGVFZCYPUWMUWPUVOCUWMUVGUWNNZUWPUVORUWMUUAUUAUWQYOUWLU
      UAXTZUWREYTEYTYFXJBUVGUWNYATGYBUWMUWOYTUBJKZUUAUWPYPKYOUWLUWSUUAYMYNUWLUW
      SYMUWFYNUWLUWSUWIYRBDAYCYDYGYHUWREUWOYTYIXJYJYKYL $.
  $}

  ${
    $d d v w x y z M $.  $d d v x y z X $.
    $( A totally bounded metric space is bounded.  This theorem fails for
       extended metrics - a bounded extended metric is a metric, but there are
       totally bounded extended metrics that are not metrics (if we were to
       weaken ~ istotbnd to only require that ` M ` be an extended metric).  A
       counterexample is the discrete extended metric (assigning distinct
       points distance ` +oo ` ) on a finite set.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 12-Sep-2015.) $)
    totbndbnd $p |- ( M e. ( TotBnd ` X ) -> M e. ( Bnd ` X ) ) $=
      ( vx vv vd vz cfv wcel cv c1 co wceq crp wral cr clt wss syl3anc adantr
      c0 vy vw ctotbnd cme cbl ciun cpw cfn cin wrex cbnd totbndmet 1rp simprbi
      istotbnd3 oveq2 iuneq2d eqeq1d rexbidv rspcv mpsyl wa caddc cmpt crn csup
      wf simplll elfpw simplbi ad2antrl sselda simpllr metcl cc0 cle wbr metge0
      ge0p1rpd eqid fmptd frn syl wne rnfi 3syl simplr simprr eleqtrrd ne0i cdm
      mptfi dm0rn0 ovex dmmpti eqeq1i iuneq1 sylbi syl6eq sylbir necon3i rpssre
      0iun syl6ss wor w3a ltso fisupcl mpan cxmt cmin metxmet ad2antrr fimaxre2
      sseldd 1re a1i syl2anc cvv elrnmpt1 mpan2 adantl suprub syl31anc leaddsub
      mpbid blss2 syl33anc ralrimiva nfcv nfmpt1 nfrn nfsup nfov nfss nfv oveq1
      wb sseq1d sylibr cbvral iunss eqsstr3d cxr rpxrd eqeq2d rspcev rexlimdvaa
      blssm eqssd ralrimdva isbnd baib sylibrd sylc ) ABUCGHZABUDGHZCDIZCIZJAUE
      GZKZUFZBLZDBUGUHUIZUJZABUKGHZABULJMHUUPCUURUUSEIZUUTKZUFZBLZDUVDUJZEMNZUV
      EUMUUPUUQUVLCDABEUOUNUVKUVEEJMUVGJLZUVJUVCDUVDUVMUVIUVBBUVMCUURUVHUVAUVGJ
      UUSUUTUPUQURUSUTVAUUQUVEBUAIZUVGUUTKZLZEMUJZUABNZUVFUUQUVEUVQUABUUQUVNBHZ
      VBZUVCUVQDUVDUVTUURUVDHZUVCVBZVBZFUURFIZUVNAKZJVCKZVDZVEZOPVFZMHBUVNUWIUU
      TKZLZUVQUWCUWHMUWIUWCUURMUWGVGUWHMQUWCFUURUWFMUWGUWCUWDUURHZVBZUWEUWMUUQU
      WDBHZUVSUWEOHZUUQUVSUWBUWLVHZUWCUURBUWDUWAUURBQZUVTUVCUWAUWQUURUHHZUURBVI
      ZVJVKVLZUUQUVSUWBUWLVMZUWDUVNABVNRZUWMUUQUWNUVSVOUWEVPVQUWPUWTUXAUWDUVNAB
      VRRVSUWGVTZWAUURMUWGWBWCZUWCUWHUHHZUWHTWDZUWHOQZUWIUWHHZUWAUXEUVTUVCUWAUW
      RUWGUHHUXEUWAUWQUWRUWSUNFUURUWFWLUWGWEWFVKZUWCUVNUVBHUVBTWDUXFUWCUVNBUVBU
      UQUVSUWBWGZUVTUWAUVCWHZWIUVBUVNWJUWHTUVBTUWHTLUWGWKZTLZUVBTLUWGWMUXMUVBCT
      UVAUFZTUXMUURTLUVBUXNLUXLUURTFUURUWFUWGUWEJVCWNZUXCWOWPCUURTUVAWQWRCUVAXC
      WSWTXAWFZUWCUWHMOUXDXBXDZOPXEUXEUXFUXGXFUXHXGOUWHPXHXIRZXOZUWCBUWJUWCBUVB
      UWJUXKUWCUVAUWJQZCUURNZUVBUWJQUWCUWDJUUTKZUWJQZFUURNUYAUWCUYCFUURUWMABXJG
      HZUWNUVSJOHZUWIOHZUWEUWIJXKKVPVQZUYCUWCUYDUWLUUQUYDUVSUWBABXLXMZSUWTUXAUY
      EUWMXPXQZUWCUYFUWLUWCUWHOUWIUXQUXRXOSZUWMUWFUWIVPVQZUYGUWMUXGUXFUBIUVGVPV
      QUBUWHNEOUJZUWFUWHHZUYKUWCUXGUWLUXQSZUWCUXFUWLUXPSUWMUXGUXEUYLUYNUWCUXEUW
      LUXISEUBUWHXNXRUWLUYMUWCUWLUWFXSHUYMUXOFUURUWFUWGXSUXCXTYAYBEUBUWHUWFYCYD
      UWMUWOUYEUYFUYKUYGYRUXBUYIUYJUWEJUWIYERYFAUWDUVNJUWIBYGYHYIUXTUYCCFUURFUV
      AUWJFUVAYJFUVNUWIUUTFUVNYJFUUTYJFUWHOPFUWGFUURUWFYKYLFOYJFPYJYMYNYOUYCCYP
      UUSUWDLUVAUYBUWJUUSUWDJUUTYQYSUUAYTCUURUVAUWJUUBYTUUCUWCUYDUVSUWIUUDHUWJB
      QUYHUXJUWCUWIUXSUUEAUVNUWIBUUIRUUJUVPUWKEUWIMUVGUWILUVOUWJBUVGUWIUVNUUTUP
      UUFUUGXRUUHUUKUVFUUQUVRUAABEUULUUMUUNUUO $.
  $}

  ${
    $d r x y M $.  $d r s x y N $.  $d r x y ph $.  $d r s x y X $.
    $d s x y R $.
    equivbnd.1 $e |- ( ph -> M e. ( Bnd ` X ) ) $.
    equivbnd.2 $e |- ( ph -> N e. ( Met ` X ) ) $.
    equivbnd.3 $e |- ( ph -> R e. RR+ ) $.
    equivbnd.4 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x N y ) <_ ( R x. ( x M y ) ) ) $.
    $( If the metric ` M ` is "strongly finer" than ` N ` (meaning that there
       is a positive real constant ` R ` such that
       ` N ( x , y ) <_ R x. M ( x , y ) ` ), then boundedness of ` M ` implies
       boundedness of ` N ` .  (Using this theorem twice in each direction
       states that if two metrics are strongly equivalent, then one is bounded
       iff the other is.)  (Contributed by Mario Carneiro, 14-Sep-2015.) $)
    equivbnd $p |- ( ph -> N e. ( Bnd ` X ) ) $=
      ( vs vr wcel cv cle wbr wral cr wa cme cfv wrex cbnd isbnd3b simprbi cmul
      co syl rpred remulcl sylan wi bndmet adantr metcl simplr ad2antrr lemul2d
      3expb crp adantlr remulcld letr syl3anc mpand anassrs ralimdva wceq breq2
      sylbid 2ralbidv rspcev ee12an rexlimdva mpd sylanbrc ) AFGUAUBZNZBOZCOZFU
      HZLOZPQZCGRBGRZLSUCZFGUDUBZNIAVTWAEUHZMOZPQZCGRZBGRZMSUCZWFAEWGNZWMHWNEVR
      NZWMMBCEGUEUFUIAWLWFMSAWISNZTZDWIUGUHZSNZWLWBWRPQZCGRZBGRZWFADSNZWPWSADJU
      JZDWIUKULZWQWKXABGWQVTGNZTWJWTCGWQXFWAGNZWJWTUMWQXFXGTZTZWJDWHUGUHZWRPQZW
      TXIWHWIDWQWOXHWHSNZAWOWPAWNWOHEGUNUIUOWOXFXGXLVTWAEGUPUTULZAWPXHUQADVANWP
      XHJURUSXIWBXJPQZXKWTAXHXNWPKVBXIWBSNZXJSNWSXNXKTWTUMWQVSXHXOAVSWPIUOVSXFX
      GXOVTWAFGUPUTULXIDWHAXCWPXHXDURXMVCWQWSXHXEUOWBXJWRVDVEVFVKVGVHVHWEXBLWRS
      WCWRVIWDWTBCGGWCWRWBPVJVLVMVNVOVPLBCFGUEVQ $.
  $}

  ${
    bnd2lem.1 $e |- D = ( M |` ( Y X. Y ) ) $.
    $( Lemma for ~ equivbnd2 and similar theorems.  (Contributed by Jeff
       Madsen, 16-Sep-2015.) $)
    bnd2lem $p |- ( ( M e. ( Met ` X ) /\ D e. ( Bnd ` Y ) ) -> Y C_ X ) $=
      ( cme cfv wcel cbnd cxp cdm wss dmss wceq cr wf metf fdm syl dmxpid resss
      wa cres eqsstri mp1i bndmet 3syl adantl adantr 3sstr3d 3sstr3g ) BCFGHZAD
      IGHZUBZDDJZKZCCJZKZDCUNUOUQLUPURLUNAKZBKZUOUQABLUSUTLUNABUOUCBEBUOUAUDABM
      UEUMUSUONZULUMADFGHUOOAPVAADUFADQUOOARUGUHULUTUQNZUMULUQOBPVBBCQUQOBRSUIU
      JUOUQMSDTCTUK $.
  $}

  ${
    $d x y C $.  $d x y D $.  $d x y ph $.  $d x y R $.  $d x y S $.
    $d x y Y $.
    equivbnd2.1 $e |- ( ph -> M e. ( Met ` X ) ) $.
    equivbnd2.2 $e |- ( ph -> N e. ( Met ` X ) ) $.
    equivbnd2.3 $e |- ( ph -> R e. RR+ ) $.
    equivbnd2.4 $e |- ( ph -> S e. RR+ ) $.
    equivbnd2.5 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x N y ) <_ ( R x. ( x M y ) ) ) $.
    equivbnd2.6 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
      ( x M y ) <_ ( S x. ( x N y ) ) ) $.
    equivbnd2.7 $e |- C = ( M |` ( Y X. Y ) ) $.
    equivbnd2.8 $e |- D = ( N |` ( Y X. Y ) ) $.
    equivbnd2.9 $e |- ( ph -> ( C e. ( TotBnd ` Y ) <-> C e. ( Bnd ` Y ) ) ) $.
    $( If balls are totally bounded in the metric ` M ` , then balls are
       totally bounded in the equivalent metric ` N ` .  (Contributed by Mario
       Carneiro, 15-Sep-2015.) $)
    equivbnd2 $p |- ( ph -> ( D e. ( TotBnd ` Y ) <-> D e. ( Bnd ` Y ) ) ) $=
      ( ctotbnd cfv wcel cbnd totbndbnd wa simpr cxp cres cme wss bnd2lem sylan
      adantr metres2 syl2anc syl5eqel crp cmul cle wbr sselda anim12dan adantlr
      cv co syldan wceq oveqi ovres syl5eq adantl oveq2d 3brtr4d biimpar bndmet
      equivbnd equivtotbnd ex impbid2 ) AEKUAUBZUCZEKUDUBZUCZEKUEAWDWBAWDUFZBCF
      DEKAWDDWCUCZDWAUCZWEBCGEDKAWDUGWEDHKKUHZUIZKUJUBZRWEHJUJUBZUCZKJUKZWIWJUC
      AWLWDLUNAIWKUCWDWMMEIJKSULUMZHKJUOUPUQAGURUCWDOUNWEBVEZKUCZCVEZKUCZUFZUFZ
      WOWQHVFZGWOWQIVFZUSVFZWOWQDVFZGWOWQEVFZUSVFUTWEWSWOJUCZWQJUCZUFZXAXCUTVAZ
      WEWPXFWRXGWEKJWOWNVBWEKJWQWNVBVCZAXHXIWDQVDVGWSXDXAVHWEWSXDWOWQWIVFXADWIW
      OWQRVIWOWQKKHVJVKVLZWTXEXBGUSWSXEXBVHWEWSXEWOWQIWHUIZVFXBEXLWOWQSVIWOWQKK
      IVJVKVLZVMVNVQAWGWFTVOVGWDEWJUCAEKVPVLAFURUCWDNUNWTXBFXAUSVFZXEFXDUSVFUTW
      EWSXHXBXNUTVAZXJAXHXOWDPVDVGXMWTXDXAFUSXKVMVNVRVSVT $.
  $}

  ${
    $d x z $.  $d a r z A $.  $d a r z C $.  $d f g k m r v y D $.  $d x y R $.
    $d f g k m r v w x y B $.  $d f g k r w y z E $.  $d a f g k r w x y ph $.
    $d f g k v w x y I $.  $d x S $.  $d f g k r w y z V $.  $d x Y $.
    prdsbnd.y $e |- Y = ( S Xs_ R ) $.
    prdsbnd.b $e |- B = ( Base ` Y ) $.
    prdsbnd.v $e |- V = ( Base ` ( R ` x ) ) $.
    prdsbnd.e $e |- E = ( ( dist ` ( R ` x ) ) |` ( V X. V ) ) $.
    prdsbnd.d $e |- D = ( dist ` Y ) $.
    prdsbnd.s $e |- ( ph -> S e. W ) $.
    prdsbnd.i $e |- ( ph -> I e. Fin ) $.
    prdsbnd.r $e |- ( ph -> R Fn I ) $.
    ${
      prdsbnd.m $e |- ( ( ph /\ x e. I ) -> E e. ( Bnd ` V ) ) $.
      $( The product metric over finite index set is bounded if all the factors
         are bounded.  (Contributed by Mario Carneiro, 13-Sep-2015.) $)
      prdsbnd $p |- ( ph -> D e. ( Bnd ` B ) ) $=
        ( vm vk vw vf vg vz cme cfv wcel cxp cv cicc co wf wrex cbnd cmpt cprds
        cc0 cr cds cbs cvv eqid wa fvex a1i bndmet syl prdsmet wceq dffn5 sylib
        wfn oveq2d syl5eq fveq2d 3eltr4d cfn wex isbnd3 simprbi ralrimiva oveq2
        wral feq3 ac6sfi syl2anc crn csn cun clt csup wss frn adantl 0re adantr
        wb snssd unssd c0 wne wfo ffn dffn4 fofi syl2an snfi unfi sylancl ssun2
        c0ex snid sselii ne0i mp1i wor w3a ltso fisupcl mpan syl3anc sseldd cle
        wbr simprl simprr metcl cxr eleqtrd adantlr prdsbascl r19.21bi ad2ant2r
        elicc2 sylancr suprub syl31anc sylanbrc metf ad2antrr metge0 prdsdsval3
        adantrr 3syl proplem3 eqtrd ffvelrn ad2ant2lr fovrnd mpbid simp3d ssun1
        fimaxre2 ad2antlr fnfvelrn letrd expr ralimdva impr ovex rgenw ralrnmpt
        sseldi breq1 ax-mp sylibr elsni breq1d syl5ibrcom ralrimiv ralunb fmptd
        ressxr syl6ss rexrd supxrleub mpbird eqbrtrd mpbir3and an32s ralrimivva
        ffnov rspcev exlimddv ) ADCUGUHZUIZCCUJZUSUAUKZULUMZDUNZUAUTUOZDCUPUHUI
        AFBHBUKZEUHZUQZURUMZVAUHZUWQVBUHZUGUHDUWGABUWSUWRUWOFGHIJUWQVCUWQVDZUWS
        VDZNOUWRVDZQRUWOVCUIZAUWNHUIZVEZUWNEVFZVGUXEGIUPUHUIZGIUGUHUIZTGIVHVIZV
        JADKVAUHUWRPAKUWQVAAKFEURUMUWQLAEUWPFURAEHVNEUWPVKSBHEVLVMVOVPZVQVPZACU
        WSUGACKVBUHUWSMAKUWQVBUXJVQVPZVQVRZAHUTUBUKZUNZIIUJZUSUWNUXNUHZULUMZGUN
        ZBHWEZVEZUWMUBAHVSUIZUXPUSUCUKZULUMZGUNZUCUTUOZBHWEUYAUBVTRAUYFBHUXEUXG
        UYFTUXGUXHUYFUCGIWAWBVIWCUYEUXSBUCHUTUBUYCUXQVKUYDUXRVKUYEUXSWSUYCUXQUS
        ULWDUYDUXRUXPGWFVIWGWHAUYAVEZUXNWIZUSWJZWKZUTWLWMZUTUIZUWIUSUYKULUMZDUN
        ZUWMAUXOUYLUXTAUXOVEZUYJUTUYKUYOUYHUYIUTUXOUYHUTWNAHUTUXNWOWPAUYIUTWNUX
        OAUSUTUSUTUIZAWQVGWTWRXAZUYOUYJVSUIZUYJXBXCZUYJUTWNZUYKUYJUIZUYOUYHVSUI
        ZUYIVSUIUYRAUYBHUYHUXNXDZVUBUXORUXOUXNHVNZVUCHUTUXNXEZHUXNXFVMHUYHUXNXG
        XHUSXIUYHUYIXJXKZUSUYJUIZUYSUYOUYIUYJUSUYIUYHXLUSXMXNXOZUYJUSXPZXQUYQUT
        WLXRUYRUYSUYTXSVUAXTUTUYJWLYAYBYCYDZUUEZUYGDUWIVNZUDUKZUEUKZDUMZUYMUIZU
        ECWEUDCWEUYNAVULUYAAUWHUWIUTDUNVULUXMDCUUAUWIUTDXEUUFWRUYGVUPUDUECCAVUM
        CUIZVUNCUIZVEZUYAVUPAVUSVEZUYAVEZVUPVUOUTUIZUSVUOYEYFZVUOUYKYEYFZVVAUWH
        VUQVURVVBAUWHVUSUYAUXMUUBZVUTVUQUYAAVUQVURYGZWRZVUTVURUYAAVUQVURYHZWRZV
        UMVUNDCYIYCVVAUWHVUQVURVVCVVEVVGVVIVUMVUNDCUUCYCVVAVUOBHUWNVUMUHZUWNVUN
        UHZGUMZUQZWIZUYIWKZYJWLWMZUYKYEVUTVUOVVPVKUYAVUTVUOVUMVUNUWRUMVVPAVUSUD
        UEDUWRUXKUUGVUTBUWSUWRUWOFGVUMVUNHIJVSVCUWQUWTUXAAFJUIVUSQWRZAUYBVUSRWR
        ZVUTUXCBHUXCVUTUXDVEZUXFVGWCZVUTVUMCUWSVVFACUWSVKVUSUXLWRZYKZVUTVUNCUWS
        VVHVWAYKZNOUXBUUDUUHWRVVAVVPUYKYEYFZUYCUYKYEYFZUCVVOWEZVVAVWEUCVVNWEZVW
        EUCUYIWEVWFVVAVVLUYKYEYFZBHWEZVWGVUTUXOUXTVWIVUTUXOVEZUXSVWHBHVWJUXDUXS
        VWHVWJUXDUXSVEZVEZVVLUXQUYKVUTUXDVVLUTUIZUXOUXSVVSUXHVVJIUIZVVKIUIZVWMA
        UXDUXHVUSUXIYLVUTVWNBHVUTBUWSUWOFVUMHIJVSVCUWQUWTUXAVVQVVRVVTNVWBYMYNZV
        UTVWOBHVUTBUWSUWOFVUNHIJVSVCUWQUWTUXAVVQVVRVVTNVWCYMYNZVVJVVKGIYIYCZYOU
        XOUXDUXQUTUIZVUTUXSHUTUWNUXNUUIUUJZVWJUYLVWKAUXOUYLVUSVUJYLWRVWLVWMUSVV
        LYEYFZVVLUXQYEYFZVWLVVLUXRUIZVWMVXAVXBXSZVWLVVJVVKUXRIIGVWJUXDUXSYHVUTU
        XDVWNUXOUXSVWPYOVUTUXDVWOUXOUXSVWQYOUUKVWLUYPVWSVXCVXDWSWQVWTUSUXQVVLYP
        YQUULUUMVWLUYTUYSUYCUFUKYEYFUCUYJWEUFUTUOZUXQUYJUIUXQUYKYEYFVWJUYTVWKAU
        XOUYTVUSUYQYLWRVUGUYSVWLVUHVUIXQVWJVXEVWKAUXOVXEVUSUYOUYTUYRVXEUYQVUFUF
        UCUYJUUOWHZYLWRVWLUYHUYJUXQUYHUYIUUNVWLVUDUXDUXQUYHUIUXOVUDVUTVWKVUEUUP
        VWJUXDUXSYGHUWNUXNUUQWHUVEUFUCUYJUXQYRYSUURUUSUUTUVAVVLVCUIZBHWEVWGVWIW
        SVXGBHVVJVVKGUVBUVCVWEVWHBUCHVVLVVMVCVVMVDZUYCVVLUYKYEUVFUVDUVGUVHVVAVW
        EUCUYIVVAVWEUYCUYIUIZUSUYKYEYFZVVAUYTUYSVXEVUGVXJAUXOUYTVUSUXTUYQYOVUGU
        YSVVAVUHVUIXQAUXOVXEVUSUXTVXFYOVUGVVAVUHVGUFUCUYJUSYRYSVXIUYCUSUYKYEUYC
        USUVIUVJUVKUVLVWEUCVVNUYIUVMYTVVAVVOYJWNZUYKYJUIVWDVWFWSVUTVXKUYAVUTVVO
        UTYJVUTVVNUYIUTVUTHUTVVMUNVVNUTWNVUTBHVVLUTVVMVWRVXHUVNHUTVVMWOVIVUTUSU
        TUYPVUTWQVGWTXAUVOUVPWRVVAUYKAUYAUYLVUSVUKYLZUVQUCVVOUYKUVRWHUVSUVTVVAU
        YPUYLVUPVVBVVCVVDXSWSWQVXLUSUYKVUOYPYQUWAUWBUWCUDUECCUYMDUWDYTUWLUYNUAU
        YKUTUWJUYKVKUWKUYMVKUWLUYNWSUWJUYKUSULWDUWKUYMUWIDWFVIUWEWHUWFUADCWAYT
        $.
    $}

    ${
      prdstotbnd.m $e |- ( ( ph /\ x e. I ) -> E e. ( TotBnd ` V ) ) $.
      $( The product metric over finite index set is totally bounded if all the
         factors are totally bounded.  (Contributed by Mario Carneiro,
         20-Sep-2015.) $)
      prdstotbnd $p |- ( ph -> D e. ( TotBnd ` B ) ) $=
        ( vy vv vr vf vz vw vg cme cfv wcel cv cbl co ciun wceq cpw cfn cin crp
        wrex wral ctotbnd cmpt cprds cds cbs cvv eqid wa fvex a1i totbndmet syl
        prdsmet wfn dffn5 sylib oveq2d syl5eq fveq2d 3eltr4d wex adantr simprbi
        wf istotbnd3 r19.21bi df-rex bitr4i an32s ralrimiva eleq1 iuneq1 eqeq1d
        rexv anbi12d ac6sfi syl2anc cixp wss elfpw simplbi ralimi ad2antll fnfi
        ss2ixp cdm fndm prdsbas rgenw ixpeq2 syl6eqr ad2antrr sseqtr4d sylanbrc
        ax-mp ixpfi cxmt cxr metxmet rpxr blssm 3expa syl2an ssralv sylc sylibr
        iunss eleq2d vex elixp wi eliun 3bitr4i syl5bbr adantl eleqtrrd syl6ibr
        eleq2 ex biimprd ral2imi syl5 sylbid imp oveq1 ffn simpl anim12i biimpa
        ixpfn simpr simp-4l sseldd simp-4r fveq2 cbvmptv oveq2i proplem3 simprl
        adantlr eleqtrd cc0 clt wbr rpgt0 prdsbl eqtrd syl12anc jca ssrdv eqssd
        eximdv mpd rspcev exlimddv ) ADCUHUIZUJZUAUBUKZUAUKZUCUKZDULUIZUMZUNZCU
        OZUBCUPUQURZUTZUCUSVADCVBUIUJAFBHBUKZEUIZVCZVDUMZVEUIZUWKVFUIZUHUIDUVQA
        BUWMUWLUWIFGHIJUWKVGUWKVHUWMVHNOUWLVHQRUWIVGUJZAUWHHUJZVIZUWHEVJZVKUWPG
        IVBUIUJZGIUHUIUJZTGIVLVMZVNADKVEUIZUWLPAKUWKVEAKFEVDUMUWKLAEUWJFVDAEHVO
        ZEUWJUOSBHEVPVQVRVSZVTVSACUWMUHACKVFUIZUWMMAKUWKVFUXCVTVSVTWAZAUWGUCUSA
        UWAUSUJZVIZHVGUDUKZWEZUWHUXHUIZIUPUQURZUJZUEUXJUEUKZUWAGULUIZUMZUNZIUOZ
        VIZBHVAZVIZUWGUDUXGHUQUJZUFUKZUXKUJZUEUYBUXOUNZIUOZVIZUFVGUTZBHVAUXTUDW
        BAUYAUXFRWCZUXGUYGBHAUWOUXFUYGUWPUXFVIUYEUFUXKUTZUYGUWPUYIUCUSUWPUWRUYI
        UCUSVAZTUWRUWSUYJUEUFGIUCWFWDVMWGUYIUYFUFWBUYGUYEUFUXKWHUYFUFWOWIVQWJWK
        UYFUXRBUFHVGUDUYBUXJUOZUYCUXLUYEUXQUYBUXJUXKWLUYKUYDUXPIUEUYBUXJUXOWMWN
        WPWQWRUXGUXTVIZBHUXJWSZUWFUJZUAUYMUWCUNZCUOZUWGUYLUYMCWTZUYMUQUJZUYNUYL
        UYMBHIWSZCUYLUXJIWTZBHVAZUYMUYSWTZUXSVUAUXGUXIUXRUYTBHUXLUYTUXQUXLUYTUX
        JUQUJZUXJIXAZXBWCXCXDBHUXJIXFVMZACUYSUOZUXFUXTACBHUWIVFUIZWSZUYSABCKEFH
        JUQLQAUXBUYAEUQUJSRHEXEWRMAUXBEXGHUOSHEXHVMXIIVUGUOZBHVAUYSVUHUOVUIBHNX
        JBHIVUGXKXPXLZXMZXNZUYLUYAVUCBHVAZUYRUXGUYAUXTUYHWCZUXSVUMUXGUXIUXRVUCB
        HUXLVUCUXQUXLUYTVUCVUDWDWCXCXDBHUXJXQWRUYMCXAXOUYLUYOCUYLUWCCWTZUAUYMVA
        ZUYOCWTUYLUYQVUOUACVAZVUPVULUXGVUQUXTADCXRUIUJZUWAXSUJZVUQUXFAUVRVURUXE
        DCXTVMUWAYAZVURVUSVIVUOUACVURUVTCUJZVUSVUOVURVVAVUSVUODUVTUWACYBYCWJWKY
        DWCVUOUAUYMCYEYFUAUYMUWCCYHYGUYLUGCUYOUYLUGUKZCUJZVVBUWCUJZUAUYMUTZVVBU
        YOUJUYLVVCVVEUYLVVCVIZHVGUVTWEZUWHUVTUIZUXJUJZUWHVVBUIZVVHUWAUXNUMZUJZV
        IZBHVAZVIZUAWBZVVEVVFUYAUXMUXJUJZVVJUXOUJZVIZUEVGUTZBHVAZVVPUYLUYAVVCVU
        NWCUYLVVCVWAUYLVVCVVBUYSUJZVWAUYLCUYSVVBVUKYIZVWBVVJIUJZBHVAZUYLVWAVWBV
        VBHVOZVWEBHIVVBUGYJZYKWDUXSVWEVWAYLUXGUXIUXRVWDVVTBHUXQVWDVVTYLUXLUXQVV
        TVWDVVTVVJUXPUJZUXQVWDVVRUEUXJUTVVSUEWBVWHVVTVVRUEUXJWHUEVVJUXJUXOYMVVS
        UEWOYNUXPIVVJYSYOUUAYPUUBXDUUCUUDUUEVVSVVMBUEHVGUAUXMVVHUOZVVQVVIVVRVVL
        UXMVVHUXJWLVWIUXOVVKVVJUXMVVHUWAUXNUUFYIWPWQWRVVFVVPUVTUYMUJZVVDVIZUAWB
        VVEVVFVVOVWKUAVVFVVOVWKVVFVVOVIZVWJVVDVVOVWJVVFVVOUVTHVOZVVIBHVAZVIVWJV
        VGVWMVVNVWNHVGUVTUUGVVMVVIBHVVIVVLUUHXCUUIBHUXJUVTUAYJYKYGYPZVWLVVBBHVV
        KWSZUWCVWLVWFVVLBHVAZVVBVWPUJVVFVWFVVOVVFVWBVWFUYLVVCVWBVWCUUJBHIVVBUUK
        VMWCVVNVWQVVFVVGVVMVVLBHVVIVVLUULXCXDBHVVKVVBVWGYKXOVWLAVVAUXFUWCVWPUOA
        UXFUXTVVCVVOUUMZVWLUVTUYSCVWLUYMUYSUVTUYLVUBVVCVVOVUEXMVWOUUNVWLAVUFVWR
        VUJVMYQAUXFUXTVVCVVOUUOAVVAUXFVIZVIZUWCUVTUWAFUAHUVTEUIZVCZVDUMZVEUIZUL
        UIZUMVWPAVWSUAUCUWBVXEADVXDULADUXAVXDPAKVXCVEAKUWKVXCUXCVXBUWJFVDUABHVX
        AUWIUVTUWHEUUPUUQUURZXLZVTVSVTUUSVWTBUWAVXCVFUIZVXDUVTUWIFGHIJVXCVGVXFV
        XHVHNOVXDVHAFJUJVWSQWCAUYAVWSRWCUWNVWTUWOVIUWQVKAUWOGIXRUIUJZVWSUWPUWSV
        XIUWTGIXTVMUVAVWTUVTCVXHAVVAUXFUUTACVXHUOVWSACUXDVXHMAKVXCVFVXGVTVSWCUV
        BUXFVUSAVVAVUTXDUXFUVCUWAUVDUVEAVVAUWAUVFXDUVGUVHUVIYQUVJYTUVMVVDUAUYMW
        HYRUVNYTUAVVBUYMUWCYMYRUVKUVLUWEUYPUBUYMUWFUVSUYMUOUWDUYOCUAUVSUYMUWCWM
        WNUVOWRUVPWKUAUBDCUCWFXO $.
    $}

    prdsbnd2.c $e |- C = ( D |` ( A X. A ) ) $.
    prdsbnd2.e $e |- ( ( ph /\ x e. I ) -> E e. ( Met ` V ) ) $.
    prdsbnd2.m $e |- ( ( ph /\ x e. I ) ->
      ( ( E |` ( y X. y ) ) e. ( TotBnd ` y ) <->
        ( E |` ( y X. y ) ) e. ( Bnd ` y ) ) ) $.
    $( If balls are totally bounded in each factor, then balls are bounded in a
       metric product.  (Contributed by Mario Carneiro, 16-Sep-2015.) $)
    prdsbnd2 $p |- ( ph -> ( C e. ( TotBnd ` A ) <-> C e. ( Bnd ` A ) ) ) $=
      ( va vr ctotbnd cfv wcel cbnd totbndbnd wi c0 wceq bndmet 0totbnd syl5ibr
      cme a1i wne cv wex n0 wa cbl co wss cr wrex simprr cmpt cprds cds cbs cvv
      wb eqid prdsmet wfn dffn5 sylib oveq2d syl5eq fveq2d 3eltr4d adantr simpr
      fvex bnd2lem syl2an simprl sseldd ssbnd syl2anc mpbid cres xpss12 resabs1
      cxp syl syl6eqr crp simpll cc0 clt wbr ne0i cxmt cxr ad2antrr rexrd xbln0
      metxmet syl3anc elrpd cress cfn ovex fveq2 xpeq12d reseq12d eqidd oveq12d
      oveq123d cbvmptv adantlr wral ralrimiva eleqtrd prdsbascl reseq2d eleq12d
      fnmpti ad2antll eqtr4d oveq2i fveq2i cixp eqtrd rpred blbnd xpeq12 anidms
      r19.21bi simplrr imbi2d vtocl mpbird fvmpt adantl ressds ax-mp rpxr blssm
      bibi12d ressbas2 prdstotbnd ressprdsds ixpeq2dva proplem3 prdsbl prdsbas3
      reseq1i rpgt0 3eqtr4rd 3eltr3d syl12anc totbndss eqeltrrd rexlimddv exp32
      exlimdv syl5bi pm2.61dne impbid2 ) AFDUHUIZUJZFDUKUIUJZFDULAUVSUVRUMZDUND
      UNUOZUVTUMAUVSUVRUWAFDUSUIUJFDUPFDUQURUTDUNVAUFVBZDUJZUFVCAUVTUFDVDAUWCUV
      TUFAUWCUVSUVRAUWCUVSVEZVEZDUWBUGVBZGVFUIZVGZVHZUVRUGVIUWEUVSUWIUGVIVJZAUW
      CUVSVKUWEGEUSUIZUJZUWBEUJZUVSUWJVQAUWLUWDAIBKBVBZHUIZVLZVMVGZVNUIZUWQVOUI
      ZUSUIGUWKABUWSUWRUWOIJKLMUWQVPUWQVRZUWSVRZQRUWRVRTUAUWOVPUJZAUWNKUJZVEZUW
      NHWIZUTZUDVSAGNVNUIZUWRSANUWQVNANIHVMVGUWQOAHUWPIVMAHKVTHUWPUOUBBKHWAWBWC
      WDZWEWDAEUWSUSAENVOUIZUWSPANUWQVOUXHWEWDZWEWFZWGUWEDEUWBAUWLUVSDEVHUWDUXK
      UWCUVSWHFGEDUCWJWKAUWCUVSWLZWMZUWBGFEDUGUCWNWOWPUWEUWFVIUJZUWIVEZVEZGUWHU
      WHWTZWQZDDWTZWQZFUVQUXPUXTGUXSWQZFUXPUXSUXQVHZUXTUYAUOUXPUWIUWIUYBUWEUXNU
      WIVKZUYCDUWHDUWHWRWOGUXSUXQWSXAUCXBUXPUXRUWHUHUIZUJZUWIUXTUVQUJUXPAUWMUWF
      XCUJZUYEAUWDUXOXDUWEUWMUXOUXMWGZUXPUWFUWEUXNUWIWLZUXPUWHUNVAZXEUWFXFXGZUX
      PUWBUWHUJUYIUXPDUWHUWBUYCUWEUWCUXOUXLWGWMUWHUWBXHXAUXPGEXIUIUJZUWMUWFXJUJ
      ZUYIUYJVQUXPUWLUYKAUWLUWDUXOUXKXKGEXNXAUYGUXPUWFUYHXLGUWBUWFEXMXOWPXPAUWM
      UYFVEZVEZICKCVBZHUIZUYOUWBUIZUWFUYPVNUIZUYPVOUIZUYSWTZWQZVFUIZVGZXQVGZVLZ
      VMVGZVNUIZVUFVOUIZUHUIUXRUYDUYNBVUHVUGVUEIUWNVUEUIZVNUIZVUIVOUIZVUKWTZWQZ
      KVUKMVUFVUFVRVUHVRVUKVRVUMVRVUGVRAIMUJUYMTWGZAKXRUJUYMUAWGZVUEKVTUYNBKUWO
      UWNUWBUIZUWFJVFUIZVGZXQVGZVUEUWOVURXQXSZCBKVUDVUSUYOUWNUOZUYPUWOVUCVURXQU
      YOUWNHXTZVVAUYQVUPUWFUWFVUBVUQVVAVUAJVFVVAVUAUWOVNUIZLLWTZWQZJVVAUYRVVCUY
      TVVDVVAUYPUWOVNVVBWEVVAUYSLUYSLVVAUYSUWOVOUILVVAUYPUWOVOVVBWEQXBZVVFYAYBR
      XBWEUYOUWNUWBXTVVAUWFYCYEYDZYFZYNUTUYNUXCVEZJVURVURWTZWQZVURUHUIZVUMVUKUH
      UIVVIVVKVVLUJZVVKVURUKUIZUJZVVIJLXIUIUJZVUPLUJZUXNVVOVVIJLUSUIUJZVVPAUXCV
      VRUYMUDYGJLXNXAZUYNVVQBKUYNBUWSUWOIUWBKLMXRVPUWQUWTUXAVUNVUOAUXBBKYHUYMAU
      XBBKUXFYIWGQUYNUWBEUWSAUWMUYFWLZAEUWSUOUYMUXJWGYJYKUUEZVVIUWFAUWMUYFUXCUU
      FUUAUWFJLVUPUUBXOAUXCVVMVVOVQZUYMUXDJUYOUYOWTZWQZUYOUHUIZUJZVWDUYOUKUIZUJ
      ZVQZUMUXDVWBUMCVURVUPUWFVUQXSZUYOVURUOZVWIVWBUXDVWKVWFVVMVWHVVOVWKVWDVVKV
      WEVVLVWKVWCVVJJVWKVWCVVJUOUYOVURUYOVURUUCUUDYLZUYOVURUHXTYMVWKVWDVVKVWGVV
      NVWLUYOVURUKXTYMUUPUUGUEUUHYGUUIVVIVUMVVCVVJWQZVVKVVIVUJVVCVULVVJVVIVUJVU
      SVNUIZVVCVVIVUIVUSVNUXCVUIVUSUOUYNCUWNVUDVUSKVUEVVGVUEVRVUTUUJUUKZWEVURVP
      UJZVVCVWNUOVWJVURVVCUWOVUSVPVUSVRZVVCVRUULUUMXBVVIVUKVURVUKVURVVIVUKVUSVO
      UIZVURVVIVUIVUSVOVWOWEVVIVURLVHZVURVWRUOVVIVVPVVQUYLVWSVVSVWAUYNUYLUXCUYF
      UYLAUWMUWFUUNYOZWGJVUPUWFLUUOXOZVURLVUSUWOVWQQUUQXAZYPZVXCYAYBVVIVVKVVEVV
      JWQZVWMJVVEVVJRUVDVVIVVJVVDVHZVXDVWMUOVVIVWSVWSVXEVXAVXAVURLVURLWRWOVVCVV
      JVVDWSXAWDYPVVIVUKVURUHVXCWEWFUURUYNVUGGIBKVUSVLZVMVGZVOUIZVXHWTZWQUXRUYN
      BVURVXHGUWOIIMVUGVXGKMXRVPNVPANUWQUOUYMUXHWGUYNVXGYCVXHVRZSVUFVXGVNVUEVXF
      IVMVVHYQZYRVUNVUNVUOUXBVVIUXEUTZVWPVVIVWJUTUUSUYNVXIUXQGUYNVXHUWHVXHUWHUY
      NBKVURYSZBKVWRYSUWHVXHUYNBKVURVWRVXBUUTUYNUWHUWBUWFICKUYPVLZVMVGZVNUIZVFU
      IZVGVXMAUYMUFUGUWGVXQAGVXPVFAGUXGVXPSANVXOVNANUWQVXOUXHVXNUWPIVMCBKUYPUWO
      VVBYFYQZXBZWEWDWEUVAUYNBUWFVXOVOUIZVXPUWBUWOIJKLMVXOVPVXRVXTVRQRVXPVRVUNV
      UOVXLVVSUYNUWBEVXTVVTAEVXTUOUYMAEUXIVXTPANVXOVOVXSWEWDWGYJVWTUYFUYJAUWMUW
      FUVEYOUVBYTUYNBVXHVUSIKVWRMXRVPVXGVXGVRVXJVUNVUOUYNVUSVPUJZBKVYAVVIVUTUTY
      IVWRVRUVCUVFZVYBYAYLYTUYNVUHUWHUHUYNVUHVXHUWHVUFVXGVOVXKYRVYBWDWEUVGUVHUY
      CDUXRUWHUVIWOUVJUVKUVLUVMUVNUVOUVP $.
  $}

  ${
    $d a b d r x y z D $.  $d d r x y z X $.
    cntotbnd.d $e |- D = ( ( abs o. - ) |` ( X X. X ) ) $.
    $( A subset of the complexes is totally bounded iff it is bounded.
       (Contributed by Mario Carneiro, 14-Sep-2015.) $)
    cntotbnd $p |- ( D e. ( TotBnd ` X ) <-> D e. ( Bnd ` X ) ) $=
      ( vx vz cfv wcel cabs co cc cgz cmul c1 caddc ci cr clt wbr wceq cle cbnd
      vy vr vd va vb ctotbnd totbndbnd cv cmin ccom cbl ciun wss cin c0 wne cfn
      crab wa cpw wrex crp wral cmpt crn wf rpcn adantl gzcn mulcl eqid syl cre
      cdiv c2 cfl cim cnmet rerpdivcld 1re readdcl sylancl flcld syl2anc abscld
      cz rpcnd cexp zcnd ax-icn sylancr recnd replimd rpred oveq2d eqtrd subdid
      a1i fveq2d oveq1d zred resubcld resqcld absresq rddif absge0d cc0 halfgt0
      le2sqd mpbid eqbrtrrd mpbi lelttrd mpbird cnmetdval absmuld rpge0d absidd
      cxr wb cnxmet oveq2 eleq2d rspcev cvv oveq1 syl6ibr 0cn mp2an wi ad2antlr
      ovex adantr wn letrd absled elfz syl3anc eqeq2d syl2an fmptd elpw2 sylibr
      frn cnex bnd2lem mpan sselda adantrl recld simprl rehalfcli gzreim rpne0d
      cme imcld divcld subcld addsub4d redivd oveq12d 3eqtr4d absreimsq resqcli
      imdivd elrpii rpge0 recni sqvali halflt1 ltmul1ii mulid2i breqtri eqbrtri
      mp1i lt2halvesd sq1 syl6breqr 0le1 lt2sqd ltmul2dd mulcld divcan2d eqtr3d
      eqbrtrd 3eqtrrd mulid1d 3brtr3d cxmt rpxr ad2antrl elbl2 expr eliun rgenw
      syl22anc rexrnmpt ax-mp bitri ssrdv simpl ssbnd sylib cneg cfz cmpt2 fzfi
      cxp wfo xpfi wfn fnmpt2i dffn4 fofi elrnmpti elgz simp2bi simpllr simplrl
      readdcld peano2zd absrele cxad simplrr sslin rpxrd rexrd w3a bldisj 3exp2
      adantlr imp32 syl32anc sseq0 ee12an necon3ad rexadd subid1d breq12d mtbid
      imp ltnled ltmuldiv2d flltp1 lttrd ltled znegcld simp3bi absimle elrnmpt2
      rspc2ev ex ineq1d neeq1d imbi12d syl5ibrcom rexlimdva syl5bi 3imp rabssdv
      eleq1 rexlimddv iuneq1 sseq2d eleq1d anbi12d syl12anc ralrimiva sstotbnd3
      ssfi rabeq impbii ) ABUGFGZABUAFGZABUHVVOVVNBDUBUIZDUIZUCUIZHUJUKZULFZIZU
      MZUNZVWABUOZUPUQZDVVPUSZURGZUTZUBJVAZVBZUCVCVDZVVOVWJUCVCVVOVVRVCGZUTZEKV
      VREUIZLIZVEZVFZVWIGZBDVWQVWAUMZUNZVWEDVWQUSZURGZVWJVWMVWQJUNZVWRVWMKJVWPV
      GVXCVWMEKVWOJVWPVWMVVRJGZVWNJGZVWOJGZVWNKGZVWLVXDVVOVVRVHVIVWNVJZVVRVWNVK
      UUAZVWPVLZUUBKJVWPUUEVMVWQJUUFUUCUUDVWMUBBVWSVWMVVPBGZVVPVWOVVRVVTIZGZEKV
      BZVVPVWSGZVVOVWLVXKVXNVVOVWLVXKUTUTZVVPVNFZVVRVOIZMVPVOIZNIZVQFZOVVPVRFZV
      VRVOIZVXSNIZVQFZLIZNIZKGZVVPVVRVYGLIZVVRVVTIZGZVXNVXPVYAWGGVYEWGGVYHVXPVX
      TVXPVXRPGZVXSPGZVXTPGVXPVXQVVRVXPVVPVVOVXKVVPJGZVWLVVOBJVVPVVSJUUPFGZVVOB
      JUNZVSAVVSJBCUUGUUHZUUIUUJZUUKVVOVWLVXKUULZVTZMWAUUMZVXRVXSWBWCWDZVXPVYDV
      XPVYCPGZVYMVYDPGVXPVYBVVRVXPVVPVYRUUQVYSVTZWUAVYCVXSWBWCWDZVYAVYEUUNWEZVX
      PVYKVYIVVPVVSIZVVRQRZVXPVVRVYGVVPVVRVOIZUJIZHFZLIZVVRMLIWUGVVRQVXPWUKMVVR
      VXPWUJVXPVYGWUIVXPVYHVYGJGWUFVYGVJVMZVXPVVPVVRVYRVXPVVRVYSWHZVXPVVRVYSUUO
      ZUURZUUSZWFZMPGVXPWAWSZVYSVXPWUKMQRWUKVPWIIZMVPWIIZQRVXPWUTMWVAQVXPWUTVYA
      VXRUJIZVPWIIZVYEVYCUJIZVPWIIZNIZMQVXPWUTWVBOWVDLIZNIZHFZVPWIIZWVFVXPWUKWV
      IVPWIVXPWUJWVHHVXPVYGVXROVYCLIZNIZUJIWVBVYFWVKUJIZNIWUJWVHVXPVYAVYFVXRWVK
      VXPVYAWUBWJVXPOJGZVYEJGVYFJGWKVXPVYEWUEWJZOVYEVKWLVXPVXRVYTWMVXPWVNVYCJGW
      VKJGWKVXPVYCWUDWMZOVYCVKWLUUTVXPWUIWVLVYGUJVXPWUIWUIVNFZOWUIVRFZLIZNIWVLV
      XPWUIWUPWNVXPWVQVXRWVSWVKNVXPVVRVVPVXPVVRVYSWOZVYRWUOUVAVXPWVRVYCOLVXPVVR
      VVPWVTVYRWUOUVFWPUVBWQWPVXPWVGWVMWVBNVXPOVYEVYCWVNVXPWKWSWVOWVPWRWPUVCWTX
      AVXPWVBPGZWVDPGZWVJWVFSVXPVYAVXRVXPVYAWUBXBVYTXCZVXPVYEVYCVXPVYEWUEXBWUDX
      CZWVBWVDUVDWEWQVXPWVCWVEMVXPWVBWWCXDZVXPWVDWWDXDZWUSVXPWVCVXSVPWIIZVXSWWE
      WWGPGVXPVXSWUAUVEWSZVYMVXPWUAWSZVXPWVBHFZVPWIIZWVCWWGTVXPWWAWWKWVCSWWCWVB
      XEVMVXPWWJVXSTRZWWKWWGTRVXPVYLWWLVYTVXRXFVMVXPWWJVXSVXPWVBVXPWVBWWCWMZWFW
      WIVXPWVBWWMXGVXSVCGXHVXSTRVXPVXSWUAXIUVGVXSUVHUVPZXJXKXLWWGVXSQRVXPWWGVXS
      VXSLIZVXSQVXSVXSWUAUVIZUVJWWOMVXSLIZVXSQVXSMQRWWOWWQQRUVKVXSMVXSWUAWAWUAX
      IUVLXMVXSWWPUVMUVNUVOWSZXNVXPWVEWWGVXSWWFWWHWWIVXPWVDHFZVPWIIZWVEWWGTVXPW
      WBWWTWVESWWDWVDXEVMVXPWWSVXSTRZWWTWWGTRVXPWUCWXAWUDVYCXFVMVXPWWSVXSVXPWVD
      VXPWVDWWDWMZWFWWIVXPWVDWXBXGWWNXJXKXLWWRXNUVQUWFUVRUVSVXPWUKMWURWUSVXPWUJ
      WUQXGXHMTRVXPUVTWSUWAXOUWBVXPWUGVYIVVPUJIZHFZVVRHFZWUKLIZWULVXPVYIJGZVYNW
      UGWXDSVXPVVRVYGWUNWUMUWCZVYRVYIVVPVVSVVSVLZXPWEVXPVVRWUJLIZHFWXDWXFVXPWXJ
      WXCHVXPWXJVYIVVRWUILIZUJIWXCVXPVVRVYGWUIWUNWUMWUPWRVXPWXKVVPVYIUJVXPVVPVV
      RVYRWUNWUOUWDWPWQWTVXPVVRWUJWUNWUQXQUWEVXPWXEVVRWUKLVXPVVRWVTVXPVVRVYSXRX
      SXAUWGVXPVVRWUNUWHUWIVXPVVSJUWJFGZVVRXTGZWXGVYNVYKWUHYAWXLVXPYBWSVWLWXMVV
      OVXKVVRUWKUWLWXHVYRVVPVVSVYIVVRJUWMUWQXOVXMVYKEVYGKVWNVYGSZVXLVYJVVPWXNVW
      OVYIVVRVVTVWNVYGVVRLYCXAYDYEWEUWNVXOVVPVWAGZDVWQVBZVXNDVVPVWQVWAUWOVWOYFG
      ZEKVDWXPVXNYAWXQEKVVRVWNLYMZUWPWXOVXMEDKVWOVWPYFVXJVVQVWOSZVWAVXLVVPVVQVW
      OVVRVVTYGZYDUWRUWSUWTYHUXAVWMBXHUDUIZVVTIZUNZVXBUDPVWMVVOWYCUDPVBZVVOVWLU
      XBVYOXHJGZVVOWYDYAVSYIXHVVSAJBUDCUXCYJUXDVWMWYAPGZWYCUTZUTZUEUFVVRWYANIZV
      VRVOIZVQFZMNIZUXEZWYLUXFIZWYNVVRUEUIZOUFUIZLIZNIZLIZUXGZVFZURGZVXAXUAUNVX
      BWYNWYNUXIZURGZXUCXUAWYTUXJZXUBWYNURGZXUFXUDWYMWYLUXHZXUGWYNWYNUXKYJWYTXU
      CUXLXUEUEUFWYNWYNWYSWYTWYTVLZVVRWYRLYMZUXMXUCWYTUXNXMXUCXUAWYTUXOYJWYHVWE
      DVWQXUAWYHVVQVWQGZVWEVVQXUAGZXUJWXSEKVBWYHVWEXUKYKZEKVWOVVQVWPVXJWXRUXPWY
      HWXSXULEKWYHVXGUTZXULWXSVXLBUOZUPUQZVWOXUAGZYKXUMXUOVWOWYSSZUFWYNVBUEWYNV
      BZXUPXUMXUOXURXUMXUOUTZVWNVNFZWYNGZVWNVRFZWYNGZVWOVVRXUTOXVBLIZNIZLIZSZXU
      RXUSXVAWYMXUTTRXUTWYLTRUTZXUSXUTHFZWYLTRXVHXUSXVIVWNHFZWYLXUSXUTXUSXUTVXG
      XUTWGGZWYHXUOVXGVXEXVKXVBWGGZVWNUXQZUXRYLZWJWFXUSVWNVXGVXEWYHXUOVXHYLZWFZ
      XUSWYLXUSWYKXUSWYJXUSWYIVVRXUSVVRWYAXUSVVRXUMVWLXUOVVOVWLWYGVXGUXSZYNZWOZ
      XUMWYFXUOVWMWYFWYCVXGUXTZYNZUYAZXVRVTZWDUYBZXBZXUSVXEXVIXVJTRXVOVWNUYCVMX
      USXVJWYLXVPXWEXUSXVJWYJWYLXVPXWCXWEXUSVVRXVJLIZWYIQRXVJWYJQRXUSVWOHFZXWFW
      YIQXUSXWGWXEXVJLIXWFXUSVVRVWNXUSVVRXVRWHXVOXQXUSWXEVVRXVJLXUSVVRXVSXUSVVR
      XVRXRXSXAWQXUSXWGWYIQRWYIXWGTRZYOXUSVVRWYAUYDIZVWOXHVVSIZTRZXWHXUMXUOXWKY
      OXUMXWKXUNUPXUMXUNVXLWYBUOZUNZXWKXWLUPSZXUNUPSXUMWYCXWMVWMWYFWYCVXGUYEBWY
      BVXLUYFVMXUMWXLVXFWYEWXMWYAXTGZXWKXWNYKZWXLXUMYBWSVWMVXGVXFWYGVXIUYLZWYEX
      UMYIWSXUMVVRXVQUYGXUMWYAXVTUYHWXLVXFWYEUYIZWXMXWOXWPXWRWXMXWOXWKXWNVVSVWO
      XHVVRWYAJUYJUYKUYMUYNXUNXWLUYOUYPUYQVUBXUSXWIWYIXWJXWGTXUSVVRPGWYFXWIWYIS
      XVSXWAVVRWYAUYRWEXUSXWJVWOXHUJIZHFZXWGXUSVXFWYEXWJXWTSXUMVXFXUOXWQYNZYIVW
      OXHVVSWXIXPWCXUSXWSVWOHXUSVWOXXAUYSWTWQUYTVUAXUSXWGWYIXUSVWOXXAWFXWBVUCXO
      XLXUSXVJWYIVVRXVPXWBXVRVUDXKXUSWYJPGWYJWYLQRXWCWYJVUEVMVUFVUGZYPXUSXUTWYL
      XUSXUTXVNXBXWEYQXKXUSXVKWYMWGGZWYLWGGZXVAXVHYAXVNXUSWYLXWDVUHZXWDXUTWYMWY
      LYRYSXOXUSXVCWYMXVBTRXVBWYLTRUTZXUSXVBHFZWYLTRXXFXUSXXGXVJWYLXUSXVBXUSXVB
      VXGXVLWYHXUOVXGVXEXVKXVLXVMVUIYLZWJWFXVPXWEXUSVXEXXGXVJTRXVOVWNVUJVMXXBYP
      XUSXVBWYLXUSXVBXXHXBXWEYQXKXUSXVLXXCXXDXVCXXFYAXXHXXEXWDXVBWYMWYLYRYSXOXU
      SVWNXVEVVRLXUSVWNXVOWNWPXUQXVGVWOVVRXUTWYQNIZLIZSUEUFXUTXVBWYNWYNWYOXUTSZ
      WYSXXJVWOXXKWYRXXIVVRLWYOXUTWYQNYGWPYTWYPXVBSZXXJXVFVWOXXLXXIXVEVVRLXXLWY
      QXVDXUTNWYPXVBOLYCWPWPYTVULYSVUMUEUFWYNWYNWYSVWOWYTXUHXUIVUKYHWXSVWEXUOXU
      KXUPWXSVWDXUNUPWXSVWAVXLBWXTVUNVUOVVQVWOXUAVVBVUPVUQVURVUSVUTVVAXUAVXAVVK
      WLVVCVWHVWTVXBUTUBVWQVWIVVPVWQSZVWCVWTVWGVXBXXMVWBVWSBDVVPVWQVWAVVDVVEXXM
      VWFVXAURVWEDVVPVWQVVLVVFVVGYEVVHVVIVVOVYOVYPVVNVWKYAVSVYQDUBVVSAJBUCCVVJW
      LXOVVM $.
  $}

  ${
    $d x y A $.  $d x y I $.
    cnpwstotbnd.y $e |- Y = ( ( CCfld |`s A ) ^s I ) $.
    cnpwstotbnd.d $e |- D = ( ( dist ` Y ) |` ( X X. X ) ) $.
    $( A subset of ` A ^ I ` , where ` A C_ CC ` , is totally bounded iff it is
       bounded.  (Contributed by Mario Carneiro, 14-Sep-2015.) $)
    cnpwstotbnd $p |- ( ( A C_ CC /\ I e. Fin ) ->
        ( D e. ( TotBnd ` X ) <-> D e. ( Bnd ` X ) ) ) $=
      ( wss wcel ccnfld cfv cxp cds cres cvv eqid cme wceq fveq2d eleq1d vx cfn
      vy cc wa cress co csca csn cprds ctotbnd cbnd cbs fvex a1i simpr wfn ovex
      cv fnconstg mp1i cnfldms cnex ssex ad2antrr ressms sylancr msmet fvconst2
      cmt xpeq12d reseq12d 3eltr4d totbndbnd cnfldbas ressbas2 eleqtrrd bnd2lem
      adantl wi ex syl5 wb cabs cmin ccom cntotbnd sseq2d biimpa xpss12 syl2anc
      syl resabs1 adantr cnfldds ressds reseq1d eqtr4d 3bitr4d pm5.21ndd pwsval
      prdsbnd2 syl5eq ) AUDHZCUBIZUEZJAUFUGZUHKZCXGUILZUJUGZMKZDDLZNZDUKKZIXMDU
      LKZIBXNIBXOIXFUAUCDXJUMKZXMXKXIXHUAUSZXIKZMKZXRUMKZXTLZNZCXTOXJXJPXPPXTPY
      BPXKPXHOIXFXGUHUNUOXDXEUPZXGOIZXICUQXFJAUFURZCXGOUTVAXMPXFXQCIZUEZXGMKZXG
      UMKZYILZNZYIQKZYBXTQKYGXGVJIZYKYLIYGJVJIAOIZYMVBXDYNXEYFAUDVCVDVEZAJOVFVG
      YKXGYIYIPYKPVHWLZYGXSYHYAYJYGXRXGMYFXRXGRXFCXGXQYEVIVSZSYGXTYIXTYIYGXRXGU
      MYQSZYRVKVLZYGXTYIQYRSVMYGYKUCUSZYTLZNZYTUKKZIZUUBYTULKZIZYBUUANZUUCIUUGU
      UEIYGYTAHZUUDUUFUUDUUFYGUUHUUBYTVNYGYKAQKZIZUUFUUHVTYGYKYLUUIYPYGAYIQXDAY
      IRXEYFAUDXGJXGPZVOVPVEZSVQUUJUUFUUHUUBYKAYTUUBPVRWAWLZWBUUMYGUUHUUDUUFWCY
      GUUHUEZWDWEWFZUUANZUUCIZUUPUUEIZUUDUUFUUQUURWCUUNUUPYTUUPPWGUOUUNUUBUUPUU
      CUUNUUBYHUUANZUUPUUNUUAYJHZUUBUUSRUUNYTYIHZUVAUUTYGUUHUVAYGAYIYTUULWHWIZU
      VBYTYIYTYIWJWKYHUUAYJWMWLUUNUUOYHUUAUUNYNUUOYHRYGYNUUHYOWNAUUOJXGOUUKWOWP
      WLWQWRZTUUNUUBUUPUUEUVCTWSWAWTYGUUGUUBUUCYGYBYKUUAYSWQZTYGUUGUUBUUEUVDTWS
      XBXFBXMXNXFBEMKZXLNXMGXFUVEXKXLXFEXJMXFYDXEEXJRYEYCXGXHCOUBEFXHPXAVGSWQXC
      ZTXFBXMXOUVFTWS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Isometries
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Ismty $.
  $( Extend class notation with the class of metric space isometries. $)
  cismty $a class Ismty $.

  ${
    $d m n z f x y $.
    $( Define a function which takes two metric spaces and returns the set of
       isometries between the spaces.  An isometry is a bijection which
       preserves distance.  (Contributed by Jeff Madsen, 2-Sep-2009.) $)
    df-ismty $a |- Ismty = ( m e. U. ran *Met , n e. U. ran *Met |->
        { f | ( f : dom dom m -1-1-onto-> dom dom n /\ A. x e. dom dom m
            A. y e. dom dom m ( x m y ) = ( ( f ` x ) n ( f ` y ) ) ) } ) $.
  $}

  ${
    $d M m n z f x y $.  $d N m n z f x y $.  $d X m n z f x y $.
    $d Y m n z f x y $.
    $( The set of isometries between two metric spaces.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    ismtyval $p |- ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) ) ->
      ( M Ismty N ) = { f | ( f : X -1-1-onto-> Y /\ A. x e. X A. y e. X
                            ( x M y ) = ( ( f ` x ) N ( f ` y ) ) ) } ) $=
      ( vm vn cxmt cfv wcel wa cv cdm co wceq wral wb syl crn cuni wf1o cab cvv
      cismty cmpt2 df-ismty a1i cxp dmeq cxr xmetf fdm sylan9eqr ad2ant2r dmeqd
      wf dmxpid syl6eq f1oeq2 ad2ant2l f1oeq3 bitrd eqeqan12d raleqbidv anbi12d
      oveq adantl abbidv fvssunirn simpl sseldi simpr cmap adantr elfvdm elmapg
      wss f1of syl2anr syl5ibr abssdv ovex ssex ovmpt2d ) DFJKZLZEGJKZLZMZHIDEJ
      UAUBZWLHNZOZOZINZOZOZCNZUCZANZBNZWMPZXAWSKZXBWSKZWPPZQZBWORZAWORZMZCUDZFG
      WSUCZXAXBDPZXDXEEPZQZBFRZAFRZMZCUDZUFUEUFHIWLWLXKUGQWKABCHIUHUIWKWMDQZWPE
      QZMZMZXJXRCYCWTXLXIXQYCWTFWRWSUCZXLYCWOFQWTYDSYCWOFFUJZOFYCWNYEWHXTWNYEQW
      JYAXTWHWNDOZYEWMDUKWHYEULDURYFYEQDFUMYEULDUNTUOUPUQFUSUTZWOFWRWSVATYCWRGQ
      YDXLSYCWRGGUJZOGYCWQYHWJYAWQYHQWHXTYAWJWQEOZYHWPEUKWJYHULEURYIYHQEGUMYHUL
      EUNTUOVBUQGUSUTWRGFWSVCTVDYCXHXPAWOFYGYCXGXOBWOFYGYBXGXOSWKXTYAXCXMXFXNXA
      XBWMDVHXDXEWPEVHVEVIVFVFVGVJWKWGWLDJFVKWHWJVLVMWKWIWLEJGVKWHWJVNVMWKXSGFV
      OPZVSXSUELWKXRCYJXRWSYJLZWKFGWSURZXLYLXQFGWSVTVPWJGJOZLFYMLYKYLSWHEGJVQDF
      JVQGFWSYMYMVRWAWBWCXSYJGFVOWDWETWF $.
  $}

  ${
    $d M f x y $.  $d N f x y $.  $d X f x y $.  $d Y f x y $.  $d F f x y $.
    $( The condition "is an isometry".  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    isismty $p |- ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) ) ->
      ( F e. ( M Ismty N ) <-> ( F : X -1-1-onto-> Y /\ A. x e. X A. y e. X
                              ( x M y ) = ( ( F ` x ) N ( F ` y ) ) ) ) ) $=
      ( vf cxmt cfv wcel wa co cv wf1o wceq wral cvv elfvdm fveq1 cismty eleq2d
      cab ismtyval wi wb wf f1of adantr fex2 syl3an 3expib com12 f1oeq1 oveq12d
      cdm eqeq2d 2ralbidv anbi12d elab3g syl bitrd ) DFIJKZEGIJKZLZCDEUAMZKCFGH
      NZOZANZBNZDMZVIVGJZVJVGJZEMZPZBFQAFQZLZHUCZKZFGCOZVKVICJZVJCJZEMZPZBFQAFQ
      ZLZVEVFVRCABHDEFGUDUBVEWFCRKZUEVSWFUFWFVEWGWFVCVDWGWFFGCUGZVCFIUPZKVDGWIK
      WGVTWHWEFGCUHUIDFISEGISFGCWIWIUJUKULUMVQWFHCRVGCPZVHVTVPWEFGVGCUNWJVOWDAB
      FFWJVNWCVKWJVLWAVMWBEVIVGCTVJVGCTUOUQURUSUTVAVB $.
  $}

  ${
    $d u v x y F $.  $d u v x y M $.  $d u v x y N $.  $d u v x y X $.
    $d u v x y Y $.
    $( The inverse of an isometry is an isometry.  (Contributed by Jeff Madsen,
       2-Sep-2009.) $)
    ismtycnv $p |- ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) ) ->
                      ( F e. ( M Ismty N ) -> `' F e. ( N Ismty M ) ) ) $=
      ( vx vy vu vv cxmt cfv wcel wa wf1o cv co wceq wral cismty wi ccnv f1ocnv
      adantr f1ocnvdm anim12d imdistani oveq1 fveq2 oveq1d eqeq12d oveq2 oveq2d
      ex rspc2v impcom adantll f1ocnvfv2 adantrr adantrl oveq12d adantlr eqtr2d
      syl ralrimivva jca a1i isismty wb ancoms 3imtr4d ) BDJKLZCEJKLZMZDEANZFOZ
      GOZBPZVOAKZVPAKZCPZQZGDRFDRZMZEDAUAZNZHOZIOZCPZWFWDKZWGWDKZBPZQZIERHERZMZ
      ABCSPLWDCBSPLZWCWNTVMWCWEWMVNWEWBDEAUBUCWCWLHIEEWCWFELZWGELZMZMZWKWIAKZWJ
      AKZCPZWHWSWCWIDLZWJDLZMZMWKXBQZWCWRXEVNWRXETWBVNWPXCWQXDVNWPXCDEWFAUDUMVN
      WQXDDEWGAUDUMUEUCUFWBXEXFVNXEWBXFWAXFWIVPBPZWTVSCPZQFGWIWJDDVOWIQZVQXGVTX
      HVOWIVPBUGXIVRWTVSCVOWIAUHUIUJVPWJQZXGWKXHXBVPWJWIBUKXJVSXAWTCVPWJAUHULUJ
      UNUOUPVCVNWRXBWHQWBVNWRMWTWFXAWGCVNWPWTWFQWQDEWFAUQURVNWQXAWGQWPDEWGAUQUS
      UTVAVBVDVEVFFGABCDEVGVLVKWOWNVHHIWDCBEDVGVIVJ $.
  $}

  ${
    $d x y F $.  $d x y M $.  $d x y N $.  $d x y P $.  $d x R $.  $d x y X $.
    $d x y Y $.
    $( The image of a ball under an isometry is another ball.  (Contributed by
       Jeff Madsen, 31-Jan-2014.) $)
    ismtyima $p |- ( ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) /\
       F e. ( M Ismty N ) ) /\ ( P e. X /\ R e. RR* ) ) ->
               ( F " ( P ( ball ` M ) R ) ) = ( ( F ` P ) ( ball ` N ) R ) ) $=
      ( vx vy cfv wcel co wa wss wceq adantr syl syl3anc wb clt cxmt cismty w3a
      cxr cbl cima crn imassrn wf1o wral isismty biimp3a simpld f1of frn syl5ss
      cv wf sseld simpl2 simprl ffvelrn syl2anc simprr blssm wbr simpl1 simplrr
      ccnv simplrl f1ocnv 3syl sylan elbl2 syl22anc simprd oveq1 oveq1d eqeq12d
      wi fveq2 oveq2 oveq2d rspc2v impancom imp syldan breq1d bitrd wf1 f1elima
      f1of1 f1ocnvfv2 simpr eqeltrd 3bitr4d eleq1d 3bitr3d ex pm5.21ndd eqrdv )
      DFUAJKZEGUAJKZCDEUBLKZUCZAFKZBUDKZMZMZHCABDUEJLZUFZACJZBEUEJLZXIHUQZGKZXN
      XKKZXNXMKZXIXKGXNXIXKCUGZGCXJUHXIFGCURZXRGNXIFGCUIZXSXIXTXNIUQZDLZXNCJZYA
      CJZELZOZIFUJHFUJZXEXTYGMZXHXBXCXDYHHICDEFGUKULPZUMZFGCUNQZFGCUOQUPUSXIXMG
      XNXIXCXLGKZXGXMGNXBXCXDXHUTZXIXSXFYLYKXEXFXGVAZFGACVBVCZXEXFXGVDZEXLBGVER
      USXIXOXPXQSXIXOMZXNCVIZJZCJZXKKZYTXMKZXPXQYQYSXJKZXLYTELZBTVFZUUAUUBYQUUC
      AYSDLZBTVFZUUEYQXBXGXFYSFKZUUCUUGSXIXBXOXBXCXDXHVGZPXEXFXGXOVHZXEXFXGXOVJ
      XIGFYRURZXOUUHXIXTGFYRUIUUKYJFGCVKGFYRUNVLGFXNYRVBVMZYSDABFVNVOYQUUFUUDBT
      XIXOUUHUUFUUDOZUULXIUUHUUMXIXFYGUUHUUMVTYNXIXTYGYIVPXFUUHYGUUMYFUUMAYADLZ
      XLYDELZOHIAYSFFXNAOZYBUUNYEUUOXNAYADVQUUPYCXLYDEXNACWAVRVSYAYSOZUUNUUFUUO
      UUDYAYSADWBUUQYDYTXLEYAYSCWAWCVSWDWEVCWFWGWHWIYQFGCWJZUUHXJFNZUUAUUCSXIUU
      RXOXIXTUURYJFGCWLQPUULXIUUSXOXIXBXFXGUUSUUIYNYPDABFVERPFGCYSXJWKRYQXCXGYL
      YTGKUUBUUESXIXCXOYMPUUJXIYLXOYOPYQYTXNGXIXTXOYTXNOYJFGXNCWMVMZXIXOWNWOYTE
      XLBGVNVOWPYQYTXNXKUUTWQYQYTXNXMUUTWQWRWSWTXA $.
  $}

  ${
    $d r u w x y z F $.  $d f r u w z J $.  $d f r u w x y z N $.  $d r w ph $.
    $d f u K $.  $d f x y M $.  $d f u x y X $.  $d f r u w x y z Y $.
    ismtyhmeo.1 $e |- J = ( MetOpen ` M ) $.
    ismtyhmeo.2 $e |- K = ( MetOpen ` N ) $.
    ${
      ismtyhmeolem.3 $e |- ( ph -> M e. ( *Met ` X ) ) $.
      ismtyhmeolem.4 $e |- ( ph -> N e. ( *Met ` Y ) ) $.
      ismtyhmeolem.5 $e |- ( ph -> F e. ( M Ismty N ) ) $.
      $( Lemma for ~ ismtyhmeo .  (Contributed by Jeff Madsen, 2-Sep-2009.)
         (Revised by Mario Carneiro, 12-Sep-2015.) $)
      ismtyhmeolem $p |- ( ph -> F e. ( J Cn K ) ) $=
        ( co wcel cv cfv wral wceq cxr vu vx vy vz vw vr ccn ccnv cima cbl wf1o
        wf crn cismty wa cxmt wb isismty syl2anc mpbid simpld syl cxp adantr wi
        f1of ismtycnv simprl simprr ismtyima syl32anc f1ocnv 3syl simpl ffvelrn
        mpd syl2an blopn syl3anc eqeltrd ralrimivva fveq2 df-ov syl6eqr imaeq2d
        cop eleq1d ralxp sylibr cpw wfn blf ffn imaeq2 ralrn 4syl mpbird ctopon
        mopntopon ctg mopnval tgcn mpbir2and ) ABCDUGNOGHBULZBUHZUAPZUIZCOZUAFU
        JQZUMZRZAGHBUKZXDAXLUBPZUCPZENXMBQXNBQFNSUCGRUBGRZABEFUNNOZXLXOUOZMAEGU
        PQOZFHUPQOZXPXQUQKLUBUCBEFGHURUSUTVAZGHBVFVBAXKXEUDPZXIQZUIZCOZUDHTVCZR
        ZAXEUEPZUFPZXINZUIZCOZUFTRUEHRYFAYKUEUFHTAYGHOZYHTOZUOZUOZYJYGXEQZYHEUJ
        QNZCYOXSXRXEFEUNNOZYLYMYJYQSAXSYNLVDAXRYNKVDZAYRYNAXPYRMAXRXSXPYRVEKLBE
        FGHVGUSVPVDAYLYMVHAYLYMVIZYGYHXEFEHGVJVKYOXRYPGOZYMYQCOYSAHGXEULZYLUUAY
        NAXLHGXEUKUUBXTGHBVLHGXEVFVMYLYMVNHGYGXEVOVQYTEYPYHCGIVRVSVTWAYDYKUDUEU
        FHTYAYGYHWFZSZYCYJCUUDYBYIXEUUDYBUUCXIQYIYAUUCXIWBYGYHXIWCWDWEWGWHWIAXS
        YEHWJZXIULXIYEWKXKYFUQLFHWLYEUUEXIWMXHYDUAUDYEXIXFYBSXGYCCXFYBXEWNWGWOW
        PWQAUAXJBCDGHAXRCGWRQOKECGIWSVBAXSDXJWTQSLFDHJXAVBAXSDHWRQOLFDHJWSVBXBX
        C $.
    $}

    $( An isometry is a homeomorphism on the induced topology.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
    ismtyhmeo $p |- ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) ) ->
                      ( M Ismty N ) C_ ( J Homeo K ) ) $=
      ( vf cxmt cfv wcel wa cismty co chmeo cv ccn ccnv ismtyhmeolem simpll imp
      simplr simpr ismtycnv ishmeo sylanbrc ex ssrdv ) CEJKLZDFJKLZMZICDNOZABPO
      ZULIQZUMLZUOUNLZULUPMZUOABROLUOSZBAROLUQURUOABCDEFGHUJUKUPUAZUJUKUPUCZULU
      PUDTURUSBADCFEHGVAUTULUPUSDCNOLUOCDEFUEUBTUOABUFUGUHUI $.
  $}

  ${
    $d r w x y z F $.  $d r w x y z M $.  $d r w y z N $.  $d r w x y z X $.
    $d r w y z Y $.
    $( Lemma for ~ ismtybnd .  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Proof shortened by Mario Carneiro, 19-Jan-2014.) $)
    ismtybndlem $p |- ( ( N e. ( *Met ` Y ) /\ F e. ( M Ismty N ) ) ->
        ( M e. ( Bnd ` X ) -> N e. ( Bnd ` Y ) ) ) $=
      ( vx vr vy vz vw cfv wcel co wa cv wceq crp wrex wral wi cxmt cismty cbnd
      cbl w3a ccnv wf1o isismty biimp3a simpld f1ocnv f1of 3syl ffvelrnda oveq1
      wf eqeq2d rexbidv rspcv syl cima imaeq2 wfo f1ofo foima adantr cxr adantl
      rpxr anim12dan ismtyima syldan simpl f1ocnvfv2 syl2an oveq1d eqtrd syl5ib
      eqeq12d anassrs reximdva ralrimdva simp2 jctild 3expib com12 imp3a isbndx
      syld 3imtr4g ) CEUAKLZABCUBMLZNZBDUAKLZDFOZGOZBUDKZMZPZGQRZFDSZNWKEHOZWPC
      UDKZMZPZGQRZHESZNZBDUCKLCEUCKLWMWNXAXHWNWMXAXHTZWNWKWLXIWNWKWLUEZXAXGWKXJ
      XAXFHEXJXBELZNZXADXBAUFZKZWPWQMZPZGQRZXFXLXNDLZXAXQTXJEDXBXMXJDEAUGZEDXMU
      GEDXMUPXJXSIOZJOZBMXTAKYAAKCMPJDSIDSZWNWKWLXSYBNIJABCDEUHUIUJZDEAUKEDXMUL
      UMUNZWTXQFXNDWOXNPZWSXPGQYEWRXODWOXNWPWQUOUQURUSUTXLXPXEGQXJXKWPQLZXPXETX
      PADVAZAXOVAZPXJXKYFNZNZXEDXOAVBYJYGEYHXDXJYGEPZYIXJXSDEAVCYKYCDEAVDDEAVEU
      MVFYJYHXNAKZWPXCMZXDXJYIXRWPVGLZNYHYMPXJXKXRYFYNYDYFYNXJWPVIVHVJXNWPABCDE
      VKVLYJYLXBWPXCXJXSXKYLXBPYIYCXKYFVMDEXBAVNVOVPVQVSVRVTWAWIWBWNWKWLWCWDWEW
      FWGFBDGWHHCEGWHWJ $.

    $( Isometries preserve boundedness.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 19-Jan-2014.) $)
    ismtybnd $p |- ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) /\
      F e. ( M Ismty N ) ) -> ( M e. ( Bnd ` X ) <-> N e. ( Bnd ` Y ) ) ) $=
      ( cxmt cfv wcel cismty co w3a cbnd wi ismtybndlem 3adant1 ismtycnv 3impia
      ccnv 3adant2 syld3an3 impbid ) BDFGHZCEFGHZABCIJHZKBDLGHZCELGHZUCUDUEUFMU
      BABCDENOUBUCUDARZCBIJHZUFUEMZUBUCUDUHABCDEPQUBUHUIUCUGCBEDNSTUA $.
  $}

  ${
    $d u v A $.  $d u v x y F $.  $d u v x y M $.  $d u v x y N $.  $d u v S $.
    $d u v T $.  $d u v x y X $.  $d u v x y Y $.
    ismtyres.2 $e |- B = ( F " A ) $.
    ismtyres.3 $e |- S = ( M |` ( A X. A ) ) $.
    ismtyres.4 $e |- T = ( N |` ( B X. B ) ) $.
    $( A restriction of an isometry is an isometry.  The condition ` A C_ X `
       is not necessary but makes the proof easier.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 12-Sep-2015.) $)
    ismtyres $p |- ( ( ( M e. ( *Met ` X ) /\ N e. ( *Met ` Y ) ) /\
      ( F e. ( M Ismty N ) /\ A C_ X ) ) -> ( F |` A ) e. ( S Ismty T ) ) $=
      ( vu cxmt cfv wcel wa co wceq syl2anc vv vx vy cismty cres cima wf1o wral
      wss cv wf1 isismty simprbda adantrr f1of1 simprr f1ores biimpa wi anim12d
      syl ssel oveq1 fveq2 oveq1d eqeq12d oveq2 oveq2d rspc2v adantlrl adantlll
      imp an32s cxp oveqi ovres syl5eq fvres ad2antrl ad2antll oveq12d wfun cdm
      adantl f1ofun sseq2d biimparc funfvima2 syl6eleqr adantrl ovresd adantlrr
      f1odm eqtrd 3eqtr4d ralrimivva mpdan wb xmetres2 ad2ant2rl simplr imassrn
      syl5eqel crn eqsstri f1ofo forn 3syl syl5sseq fveq2i syl6eleq mpbir2and
      wfo ) FHNOPZGINOPZQZEFGUDRPZAHUIZQZQZEAUEZCDUDRPZAEAUFZYAUGZMUJZUAUJZCRZY
      EYAOZYFYAOZDRZSZUAAUHMAUHZXTHIEUKZXRYDXTHIEUGZYMXPXQYNXRXPXQYNUBUJZUCUJZF
      RZYOEOZYPEOZGRZSZUCHUHUBHUHZUBUCEFGHIULZUMUNZHIEUOVAXPXQXRUPHIAEUQTXTYNUU
      BQZYLXPXQUUEXRXPXQUUEUUCURUNXPXRUUEYLXQXPXRQUUEQZYKMUAAAUUFYEAPZYFAPZQZQY
      EYFFRZYEEOZYFEOZGRZYGYJXRUUEUUIUUJUUMSZXPXRUUBUUIUUNYNXRUUIUUBUUNXRUUIQZU
      UBUUNUUOYEHPZYFHPZQZUUBUUNUSXRUUIUURXRUUGUUPUUHUUQAHYEVBAHYFVBUTVLUUAUUNY
      EYPFRZUUKYSGRZSUBUCYEYFHHYOYESZYQUUSYTUUTYOYEYPFVCUVAYRUUKYSGYOYEEVDVEVFY
      PYFSZUUSUUJUUTUUMYPYFYEFVGUVBYSUULUUKGYPYFEVDVHVFVIVAVLVMVJVKUUIYGUUJSUUF
      UUIYGYEYFFAAVNUEZRUUJCUVCYEYFKVOYEYFAAFVPVQWDXRUUEUUIYJUUMSZXPXRYNUUIUVDU
      UBXRYNQZUUIQZYJUUKUULDRZUUMUVFYHUUKYIUULDUUGYHUUKSUVEUUHYEAEVRVSUUHYIUULS
      UVEUUGYFAEVRVTWAUVFUVGUUKUULGBBVNUEZRUUMDUVHUUKUULLVOUVFUUKUULGBUVEUUGUUK
      BPUUHUVEUUGQUUKYCBUVEUUGUUKYCPZUVEEWBZAEWCZUIZUUGUVIUSYNUVJXRHIEWEWDZYNUV
      LXRYNUVKHAHIEWMWFWGZAYEEWHTVLJWIUNUVEUUHUULBPUUGUVEUUHQUULYCBUVEUUHUULYCP
      ZUVEUVJUVLUUHUVOUSUVMUVNAYFEWHTVLJWIWJWKVQWNWLVKWOWPVJWQXTCANOZPZDYCNOZPY
      BYDYLQWRXNXRUVQXOXQXNXRQCUVCUVPKFAHWSXCWTXTDBNOZUVRXTDUVHUVSLXTXOBIUIUVHU
      VSPXNXOXSXAXTEXDZBIBYCUVTJEAXBXEXTYNHIEXMUVTISUUDHIEXFHIEXGXHXIGBIWSTXCBY
      CNJXJXKMUAYACDAYCULTXL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Heine-Borel Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d n t x y A $.  $d k n r t u x y F $.  $d g k t x G $.  $d g k r t x ph $.
    $d g k m n r t u v x y z D $.  $d g k m r t u x y z M $.  $d m n x y z T $.
    $d g n t u v y B $.  $d g k m n r t u v x y z J $.  $d g n t u v x y z U $.
    $d g t y z ps $.  $d k m n t u v x y z S $.  $d g k m n r t u v x y z X $.
    $d m n t u v y C $.  $d g n t x y z K $.  $d k t x Y $.  $d k v x Z $.
    heibor.1 $e |- J = ( MetOpen ` D ) $.
    ${
      $d m F $.  $d m n u y ph $.
      heibor1.3 $e |- ( ph -> D e. ( Met ` X ) ) $.
      heibor1.4 $e |- ( ph -> J e. Comp ) $.
      heibor1.5 $e |- ( ph -> F e. ( Cau ` D ) ) $.
      heibor1.6 $e |- ( ph -> F : NN --> X ) $.
      $( Lemma for ~ heibor1 .  A compact metric space is complete.  This proof
         works by considering the collection ` cls ( F " ( ZZ>= `` n ) ) ` for
         each ` n e. NN ` , which has the finite intersection property because
         any finite intersection of upper integer sets is another upper integer
         set, so any finite intersection of the image closures will contain
         ` ( F " ( ZZ>= `` m ) ) ` for some ` m ` .  Thus, by compactness, the
         intersection contains a point ` y ` , which must then be the
         convergent point of ` F ` .  (Contributed by Jeff Madsen,
         17-Jan-2014.)  (Revised by Mario Carneiro, 5-Jun-2014.) $)
      heibor1lem $p |- ( ph -> F e. dom ( ~~>t ` J ) ) $=
        ( vk vu cfv wrex wcel c0 wss wi cn wa vy vr vm vn cv cima wceq cuz cint
        crn cdm ccld cpw cfi wn wex syl imassrn frn sseqtrd syl5ss eqid syl2anc
        wf eleq1a fvex cfn cin wral vex bitri raleq anbi2d inteq sseq2d rexbidv
        wne imbi12d weq cc0 wfn uzf ffn ax-mp fnfvelrn cvv imaeq2 sseq1d rspcev
        mp2an a1i ssralv eqeq1 sylib uzin2 inss2 inss1 imass2 expcom syl6 imp3a
        cz com23 syl5 imp c1 nnuz exlimdv ssn0 sylancr rexlimdva adantr sylan2b
        1z n0 mpd wb eleq2d wbr wal clt crp fveq2d mpbid ad2antrr ad2antll sylc
        co ralimi rpxrd syl3anc sseli caddc ad3antrrr uztrn2 ad2ant2lr ffvelrnd
        syl22anc cr metcl ccl cab clm ccmp ctop cuni cme metxmet mopntop clscld
        cxmt mopnuni rexlimdvw abssdv elpw2 sylibr elin elpw ssabral anbi1i csn
        cun ssv sseqtr4i ssun1 anim2i imim1i ssun2 ralsn sscls sseq2 syl5ibrcom
        0z int0 anim12i ssin intunsn syl6sseqr rexlimdvv reeanv cbvrexv 3imtr3g
        ss2in exp3a sylcom findcard2 com12 impr mpan2 uzn0 wfun fnfun syl5sseqr
        eqeltri fndm funfvima2 ne0i necomd neneqd nrexdv 0ex pwex ssexi abrexex
        zex elfi sylnibr cmptop cmpfi ibi fveq2 notbid neeq1d syl6bb syl3c wrel
        rspccv lmrel r19.23v albii eleq2 ceqsalv ralbii ralcom4 elintab 3bitr4i
        bitr3i eqeq2d elab mpbir intss1 clsss3 sseqtr4d sselda cdiv w3a cpm cca
        c2 cc iscau3 simprd simp3 reximi rphalfcl breq2 2ralbidv rspccva syl2an
        cbl ffun nnz simplr rspcv cxr ad2antrl blcntr clsndisj syl32anc fvelima
        sylan2 adantl reximdv ex syl5bi r19.29 uznnssnn simprlr simplrl simpllr
        blopn elbl3 simprr rpred lt2add mpan2d rpcnd 2halvesd breq2d sylibd cle
        mettri2 syl13anc readdcld lelttr mpand anassrs ralimdva reximdva ssrexv
        syld sylsyld syldanl ralrimiva eqidd lmmbrf mpbir2and sylan2br exlimddv
        expr releldm ) AUAUEZKUEZCLUEZUFZDUUAMZMZUGZLUHUJZNZKUUBZUIZOZCDUUCMZUK
        OZUAADUUDOZVXKDULMZUMZOZPVXKUNMZOZUOZVXMUAUPZHAVXKVXQQVXSAVXJKVXQAVXHVX
        CVXQOZLVXIAVXGVXQOZVXHVYDRADUUEOZVXEDUUFZQZVYEABEUUKMOZVYFABEUUGMOZVYIG
        BEUUHUQZBDEFUUIUQZAVXECUJZVYGCVXDURZAVYMEVYGASECVDZVYMEQJSECUSUQZAVYIEV
        YGUGVYKBDEFUULUQZUTZVAVXEDVYGVYGVBZUUJVCVXGVXQVXCVEUQUUMUUNVXKVXQDULVFU
        UOUUPAPUBUEZUIZUGZUBVXKUMZVGVHZNZVYAAWUBUBWUDVYTWUDOZAVXJKVYTVIZVYTVGOZ
        TZWUBUOWUFVYTWUCOZWUHTWUIVYTWUCVGUUQWUJWUGWUHWUJVYTVXKQWUGVYTVXKUBVJUUR
        VXJKVYTUUSVKUUTVKAWUITZPWUAWUKWUAPWUKCVXCUFZWUAQZKVXINZWUAPVQZAWUGWUHWU
        NWUHAWUGTZWUNAVXJKUCUEZVIZTZWULWUQUIZQZKVXINZRAVXJKPVIZTZWULPUIZQZKVXIN
        ZRAVXJKVXBVIZTZWULVXBUIZQZKVXINZRZAVXJKVXBUDUEZUVAZUVBZVIZTZWULWVPUIZQZ
        KVXINZRZWUPWUNRUCUAUDVYTWUQPUGZWUSWVDWVBWVGWWCWURWVCAVXJKWUQPVLVMWWCWVA
        WVFKVXIWWCWUTWVEWULWUQPVNVOVPVRUCUAVSZWUSWVIWVBWVLWWDWURWVHAVXJKWUQVXBV
        LVMWWDWVAWVKKVXIWWDWUTWVJWULWUQVXBVNVOVPVRWUQWVPUGZWUSWVRWVBWWAWWEWURWV
        QAVXJKWUQWVPVLVMWWEWVAWVTKVXIWWEWUTWVSWULWUQWVPVNVOVPVRUCUBVSZWUSWUPWVB
        WUNWWFWURWUGAVXJKWUQVYTVLVMWWFWVAWUMKVXIWWFWUTWUAWULWUQVYTVNVOVPVRWVGWV
        DVTUHMZVXIOZCWWGUFZWVEQZWVGUHXBWAZVTXBOWWHXBXBUMZUHVDZWWKWBXBWWLUHWCWDZ
        UVMXBVTUHWEWJWWIWFWVEWWIUVCUVNUVDWVFWWJKWWGVXIVXCWWGUGWULWWIWVEVXCWWGCW
        GWHWIWJWKWVMWWBRVXBVGOWVMWVRWVLWWAWVRWVIWVLWVQWVHAVXBWVPQWVQWVHRVXBWVOU
        VEVXJKVXBWVPWLWDUVFUVGAWVQWVLWWARZWVQWVNVXGUGZLVXINZAWWOWVQVXJKWVOVIZWW
        QWVOWVPQWVQWWRRWVOVXBUVHVXJKWVOWVPWLWDVXJWWQKWVNUDVJZKUDVSVXHWWPLVXIVXC
        WVNVXGWMVPUVIWNAWWQWVLWWAAWWPWVKTZKVXINLVXINCWUQUFZWVSQZUCVXINZWWQWVLTW
        WAAWWTWXCLKVXIVXIVXDVXIOVXCVXIOZTVXDVXCVHZVXIOZAWWTWXCRVXDVXCWOAWWTWXFW
        XCAWWTCWXEUFZWVSQZWXFWXCRAWWPWVKWXHAWWPVXEWVNQZWVKWXHRAWXIWWPVXEVXGQZAV
        YFVYHWXJVYLAVXEEVYGAVXEVYMEVYNVYPVAVYQUTVXEDVYGVYSUVJVCWVNVXGVXEUVKUVLW
        VKWXIWXHWVKWXITZWXGWVJWVNVHZWVSWXKWXGWULVXEVHZWXLWXEVXCQZWXEVXDQZWXGWXM
        QZVXDVXCWPVXDVXCWQWXNWXOTWXGWULQZWXGVXEQZTWXPWXNWXQWXOWXRWXEVXCCWRWXEVX
        DCWRUVOWXGWULVXEUVPWNWJWULWVJVXEWVNUWCVAVXBWVNWWSUVQUVRWSWTXAWXFWXHWXCW
        XBWXHUCWXEVXIWUQWXEUGWXAWXGWVSWUQWXECWGWHWIWSWTXCXDUVSWWPWVKLKVXIVXIUVT
        WXBWVTUCKVXIUCKVSWXAWULWVSWUQVXCCWGWHUWAUWBUWDXDXEUWEWKUWFUWGUWHAWUNWUO
        RZWUIACSWAZWXSAVYOWXTJSECWCUQWXTWUMWUOKVXIWXTWXDTZWULPVQZWUMWUORWYACVXC
        SVHZUFZWULQZWYDPVQZWYBWYCVXCQWYEVXCSWQWYCVXCCWRWDWXTWXDWYFWXDVXBWYCOZUA
        UPZWXTWYFWXDWYCPVQZWYHWXDWYCVXIOZWYIWXDSVXIOZWYJSXFUHMZVXIXGWWKXFXBOZWY
        LVXIOWWNXNXBXFUHWEWJUWNZVXCSWOUWIWYCUWJUQUAWYCXOWNWXTWYGWYFUAWXTWYGVXBC
        MZWYDOZWYFWXTCUWKZWYCCUKZQWYGWYPRSCUWLWXTSWYCWYRVXCSWPSCUWOUWMWYCVXBCUW
        PVCWYDWYOUWQWTXHXDXEWYDWULXIXJWUMWYBWUOWULWUAXIWSUQXKUQXLXPUWRUWSXMUWTP
        WFOVXKWFOVYAWUEXQUXALKVXIVXGVXIWWLXBUXEUXBWWMVXIWWLQWBXBWWLUHUSWDUXCUXD
        UBPVXKWFWFUXFWJUXGVXPPWUQUNMZOZUOZWUTPVQZRZUCVXRVIZVXSVYBVYCRZRVXPXUDVX
        PVYFVXPXUDXQDUXHUCDUXIUQUXJXUCXUEUCVXKVXRWUQVXKUGZXUAVYBXUBVYCXUFWYTVYA
        XUFWYSVXTPWUQVXKUNUXKXRUXLXUFXUBVXLPVQVYCXUFWUTVXLPWUQVXKVNUXMUAVXLXOUX
        NVRUXQUQUXOAVXMTVXNUXPCVXBVXNXSZVXODUXRVXMAVXBVXGOZLVXIVIZXUGVXHVXBVXCO
        ZRZLVXIVIZKXTZVXJXUJRZKXTXUIVXMXULXUNKVXHXUJLVXIUXSUXTXUIXUKKXTZLVXIVIX
        UMXUOXUHLVXIXUJXUHKVXGVXEVXFVFVXCVXGVXBUYAUYBUYCXUKLKVXIUYDUYGVXJKVXBUA
        VJUYEUYFZAXUITZXUGVXBEOZWVNCMZVXBBYHZVYTYAXSZUDVXCUHMZVIZKSNZUBYBVIZXUI
        AVXMXURXUPAVXLEVXBAVXLCSUFZVXFMZEXVGVXKOZVXLXVGQXVHXVGVXGUGZLVXINZWYKXV
        GXVGUGZXVJWYNXVGVBXVIXVKLSVXIVXDSUGZVXGXVGXVGXVLVXEXVFVXFVXDSCWGYCUYHWI
        WJVXJXVJKXVGXVFVXFVFVXCXVGUGVXHXVILVXIVXCXVGVXGWMVPUYIUYJXVGVXKUYKWDAXV
        GVYGEAVYFXVFVYGQXVGVYGQVYLAXVFVYMVYGCSURVYRVAXVFDVYGVYSUYLVCVYQUYMVAUYN
        XMZXUQXVDUBYBXUQVYTYBOZTZVXCCMZXUSBYHZVYTUYSUYOYHZYAXSZUDXVBVIZKWUQUHMZ
        VIZUCSNZXVDXUQXVQVXBYAXSZUDXVBVIZKXWAVIZUCSNZUAYBVIZXVRYBOZXWCXVNAXWHXU
        IAVXCWYROZXVPEOZXWEUYPZKXWAVIZUCSNZUAYBVIZXWHACEUYTUYQYHOZXWOACBUYRMOXW
        PXWOTIAUABUCKUDCXFESXGVYKWYMAXNWKZVUAYDVUBXWNXWGUAYBXWMXWFUCSXWLXWEKXWA
        XWJXWKXWEVUCYIVUDYIUQXLVYTVUEZXWGXWCUAXVRYBVXBXVRUGZXWFXWBUCSXWSXWDXVSK
        UDXWAXVBVXBXVRXVQYAVUFVUGVPVUHVUIXVOXWBXVDUCSXUQXVNWUQSOZXWBXVDRXUQXVNX
        WTTZTZXWBXVPVXBXVRBVUJMYHZOZKXWANZXVDXXBWYQXXCCXWAUFZVHZPVQZXXEAWYQXUIX
        XAAVYOWYQJSECVUKUQYEXXBVYFXXFVYGQZVXBXXFVXFMZOZXXCDOZVXBXXCOZXXHAVYFXUI
        XXAVYLYEAXXIXUIXXAAXXFVYMVYGCXWAURVYRVAYEXXBXWAVXIOZXUIXXKXWTXXNXUQXVNX
        WTWWKWUQXBOXXNWWNWUQVULXBWUQUHWEXJYFAXUIXXAVUMXUHXXKLXWAVXIVXDXWAUGZVXG
        XXJVXBXXOVXEXXFVXFVXDXWACWGYCXRVUNYGXXBVYIXURXVRVUOOZXXLAVYIXUIXXAVYKYE
        ZXUQXURXXAXVMXLZXXBXVRXVNXWIXUQXWTXWRVUPZYJBVXBXVRDEFVVKYKXXBVYIXURXWIX
        XMXXQXXRXXSBVXBXVREVUQYKVXBXXFXXCDVYGVYSVURVUSXXHWVNXXGOZUDUPWYQXXEUDXX
        GXOWYQXXTXXEUDWYQXXTXXEWYQXXTTZXVPWVNUGZKXWANZXXEXXTWYQWVNXXFOXYCXXGXXF
        WVNXXCXXFWPYLKWVNXWACVUTVVAXYAXYBXXDKXWAXYAWVNXXCOZXYBXXDRXXTXYDWYQXXGX
        XCWVNXXCXXFWQYLVVBWVNXXCXVPVEUQVVCXPVVDXHVVEYGXWBXXETXVTXXDTZKXWANZXXBX
        VDXVTXXDKXWAVVFAXUIXURXXAXYFXVDRXVMAXURTZXXATZXWASQZXYFXVCKXWANXVDXWTXY
        IXYGXVNWUQVVGYFXYHXYEXVCKXWAXYHVXCXWAOZTZXVTXXDXVCXYKXXDXVTXVCXYHXYJXXD
        XVTXVCRXYHXYJXXDTZTXVSXVAUDXVBXYHXYLWVNXVBOZXVSXVARXYHXYLXYMTZTZXVSXVQX
        VPVXBBYHZYMYHZVYTYAXSZXVAXYOXVSXYQXVRXVRYMYHZYAXSZXYRXYOXVSXYPXVRYAXSZX
        YTXYOXXDYUAXYHXYJXXDXYMVVHXYOVYIXXPXURXWKXXDYUAXQAVYIXURXXAXYNVYKYNXYOX
        VRXYOXVNXWIXYGXVNXWTXYNVVIZXWRUQZYJAXURXXAXYNVVJZXYOSEVXCCAVYOXURXXAXYN
        JYNZXXAXYLVXCSOZXYGXYMXWTXYJYUFXVNXXDXFVXCWUQSXGYOYPYPZYQZXVPBVXBXVREVV
        LYRYDXYOXVQYSOZXYPYSOZXVRYSOZYUKXVSYUATXYTRXYOVYJXWKXUSEOZYUIAVYJXURXXA
        XYNGYNZYUHXYOSEWVNCYUEXYOYUFXYMWVNSOZYUGXYHXYLXYMVVMXFWVNVXCSXGYOVCYQZX
        VPXUSBEYTYKZXYOVYJXWKXURYUJYUMYUHYUDXVPVXBBEYTYKZXYOXVRYUCVVNZYURXVQXYP
        XVRXVRVVOYRVVPXYOXYSVYTXYQYAXYOVYTXYOVYTYUBVVQVVRVVSVVTXYOXUTXYQVWAXSZX
        YRXVAXYOVYJXWKYULXURYUSYUMYUHYUOYUDXUSVXBXVPBEVWBVWCXYOXUTYSOZXYQYSOVYT
        YSOYUSXYRTXVARXYOVYJYULXURYUTYUMYUOYUDXUSVXBBEYTYKXYOXVQXYPYUPYUQVWDXYO
        VYTYUBVVNXUTXYQVYTVWEYKVWFVWKVWGVWHVWTXCXAVWIXVCKXWASVWJVWLVWMXDVVPVWGX
        KXPVWNAXUGXURXVETXQXUIAUBXUSBVXBKUDCDXFESFVYKXGXWQAYUNTXUSVWOJVWPXLVWQV
        WRCVXBVXNVXAXJVWS $.
    $}

    $( One half of ~ heibor , that does not require any Choice.  A compact
       metric space is complete and totally bounded.  We prove completeness in
       ~ cmpcmet and total boundedness here, which follows trivially from the
       fact that the set of all ` r ` -balls is an open cover of ` X ` , so
       finitely many cover ` X ` .  (Contributed by Jeff Madsen,
       16-Jan-2014.) $)
    heibor1 $p |- ( ( D e. ( Met ` X ) /\ J e. Comp ) ->
                    ( D e. ( CMet ` X ) /\ D e. ( TotBnd ` X ) ) ) $=
      ( vx vy vz vr cfv wcel wa cv wi wral ralrimiva cuni wceq wrex cfn crp cme
      ccmp cms ctotbnd cn wf clm cdm cca simpll simplr simprl simprr heibor1lem
      expr c1 nnuz cz a1i simpl iscmet3 mpbird cbl cab cpw cin wss cxmt metxmet
      1z co cxr id rpxr blopn syl3an 3com23 eleq1a syl rexlimdva adantlr abssdv
      3expa ad2antrr mopnuni blcntr syl3an1 elabrex adantl elunii syl2anc nfre1
      ovex nfcv nfab nfuni dfss3f sylibr eqsstr3d unissd eqssd eqid cmpcov elin
      syl3anc ancom bitri anbi1i anass rexbii2 sylib eqcom eqeq1d anbi1d syl5bb
      syl5rbb elpwi ssabral anim2i syl6bi reximdv mpd istotbnd sylanbrc jca ) A
      CUAIJZBUBJZKZACUCIJZACUDIJZYHYIUECELZUFZYKBUGIUHJZMZEAUIIZNYHYNEYOYHYKYOJ
      ZYLYMYHYPYLKZKAYKBCDYFYGYQUJYFYGYQUKYHYPYLULYHYPYLUMUNUOOYHAEBUPCUEUQDUPU
      RJYHVJUSYFYGUTZVAVBYHYFYKPZCQZFLZGLZHLZAVCIZVKZQZGCRZFYKNZKZESRZHTNYJYRYH
      UUJHTYHUUCTJZKZYKUUGFVDZVEZJZBPZYSQZKZESRZUUJUULUUQEUUNSVFZRZUUSUULYGUUMB
      VGUUPUUMPZQUVAYFYGUUKUKUULUUGFBYFUUKUUGUUABJZMYGYFUUKKZUUFUVCGCUVDUUBCJZK
      ZUUEBJZUUFUVCMYFUUKUVEUVGYFUVEUUKUVGYFACVHIJZUVEUVEUUKUUCVLJUVGACVIZUVEVM
      UUCVNAUUBUUCBCDVOVPVQWCUUEBUUAVRVSVTWAWBZUULUUPUVBUULUUPCUVBUULUVHCUUPQYF
      UVHYGUUKUVIWDABCDWEVSZUULUUBUVBJZGCNZCUVBVGYFUUKUVMYGUVDUVLGCUVFUUBUUEJZU
      UEUUMJZUVLYFUUKUVEUVNYFUVEUUKUVNYFUVHUVEUUKUVNUVIAUUBUUCCWFWGVQWCUVEUVOUV
      DGFCUUEUUBUUCUUDWMWHWIUUBUUEUUMWJWKOWAGCUVBGCWNGUUMUUGGFUUFGCWLWOWPWQWRWS
      UULUUMBUVJWTXAUUMBUUPEUUPXBXCXEUUQUUREUUTSYKUUTJZUUQKYKSJZUUOKZUUQKUVQUUR
      KUVPUVRUUQUVPUUOUVQKUVRYKUUNSXDUUOUVQXFXGXHUVQUUOUUQXIXGXJXKUULUURUUIESUU
      LUURYTUUOKZUUIUURUUQUUOKUULUVSUUOUUQXFUULUUQYTUUOYTCYSQUULUUQYSCXLUULCUUP
      YSUVKXMXPXNXOUUOUUHYTUUOYKUUMVGUUHYKUUMXQUUGFYKXRXKXSXTYAYBOGEACFHYCYDYE
      $.

    ${
      heibor.3 $e |- K = { u | -. E. v e. ( ~P U i^i Fin ) u C_ U. v } $.
      ${
        heiborlem1.4 $e |- B e. _V $.
        $( Lemma for ~ heibor .  We work with a fixed open cover ` U `
           throughout.  The set ` K ` is the set of all subsets of ` X ` that
           admit no finite subcover of ` U ` .  (We wish to prove that ` K ` is
           empty.)  If a set ` C ` has no finite subcover, then any finite
           cover of ` C ` must contain a set that also has no finite subcover.
           (Contributed by Jeff Madsen, 23-Jan-2014.) $)
        heiborlem1 $p |- ( ( A e. Fin /\ C C_ U_ x e. A B /\ C e. K ) ->
                            E. x e. A B e. K ) $=
          ( vt cfn wcel wss wrex wa wn ciun cv cuni cpw wral wceq sseq1 rexbidv
          cin notbid elab2 con2bii ralbii ralnex bitr2i wf cfv wex unieq sseq2d
          wi ac6sfi adantr elab2g ibi crn frn ad2antrl inss1 syl6ss sspwuni vex
          ex sylib rnex uniex elpw sylibr wfo wfn dffn4 fofi syldan inss2 unifi
          ffn syl2anc elin sylanbrc adantlr simplr fnfvelrn sylan adantll uniss
          elssuni 3syl sstr2 syl5com impr iunss sstrd rspcev nsyl3 exlimdv syld
          ralimdva syl5bi con4d 3impia ) DOPZFADEUAZQZFJPZEJPZADRZXKXMSZXPXNXPT
          ZEBUBZUCZQZBHUDZOUIZRZADUEZXQXNTZYEXOTZADUEXRYDYGADXOYDCUBZXTQZBYCRZT
          ZYDTCEJMYHEUFZYJYDYLYIYABYCYHEXTUGUHUJLUKULUMXOADUNUOXQYEDYCNUBZUPZEA
          UBZYMUQZUCZQZADUEZSZNURZYFXKYEUUAVAXMXKYEUUAYAYRABDYCNXSYPUFXTYQEXSYP
          USUTVBVMVCXQYTYFNXQYTYFXNFXTQZBYCRZXQYTSZXNUUCTZYKUUECFJJYHFUFZYJUUCU
          UFYIUUBBYCYHFXTUGUHUJLVDVEUUDYMVFZUCZYCPZFUUHUCZQZUUCXKYTUUIXMXKYTSZU
          UHYBPZUUHOPZUUIUULUUHHQZUUMUULUUGYBQUUOUULUUGYCYBYNUUGYCQXKYSDYCYMVGV
          HZYBOVIVJUUGHVKVNUUHHUUGYMNVLVOVPVQVRUULUUGOPZUUGOQUUNXKYTDUUGYMVSZUU
          QUULYMDVTZUURYNUUSXKYSDYCYMWFZVHDYMWAVNDUUGYMWBWCUULUUGYCOUUPYBOWDVJU
          UGWEWGUUHYBOWHWIWJUUDFXLUUJXKXMYTWKXKYTXLUUJQZXMUULEUUJQZADUEZUVAXKYN
          YSUVCXKYNSZYRUVBADUVDYODPZSZYQUUJQZYRUVBUVFYPUUGPZYPUUHQUVGYNUVEUVHXK
          YNUUSUVEUVHUUTDYOYMWLWMWNYPUUGWPYPUUHWOWQEYQUUJWRWSXGWTADEUUJXAVRWJXB
          UUBUUKBUUHYCXSUUHUFXTUUJFXSUUHUSUTXCWGXDVMXEXFXHXIXJ $.
      $}

      heibor.4 $e |- G = { <. y , n >. |
                          ( n e. NN0 /\ y e. ( F ` n ) /\ ( y B n ) e. K ) } $.
      ${
        heiborlem2.5 $e |- A e. _V $.
        heiborlem2.6 $e |- C e. _V $.
        $( Lemma for ~ heibor .  Substitutions for the set ` G ` .
           (Contributed by Jeff Madsen, 23-Jan-2014.) $)
        heiborlem2 $p |- ( A G C <-> ( C e. NN0 /\
                            A e. ( F ` C ) /\ ( A B C ) e. K ) ) $=
          ( cn0 wcel cv cfv co w3a wceq eleq1 oveq1 eleq1d 3anbi23d fveq2 oveq2
          eleq2d 3anbi123d brab ) IUAZSTZAUAZUOJUBZTZUQUOEUCZMTZUDUPDURTZDUOEUC
          ZMTZUDFSTZDFJUBZTZDFEUCZMTZUDAIDFKQRUQDUEZUSVBVAVDUPUQDURUFVJUTVCMUQD
          UOEUGUHUIUOFUEZUPVEVBVGVDVIUOFSUFVKURVFDUOFJUJULVKVCVHMUOFDEUKUHUMPUN
          $.
      $}

      $d x B $.
      heibor.5 $e |- B = ( z e. X , m e. NN0 |->
                            ( z ( ball ` D ) ( 1 / ( 2 ^ m ) ) ) ) $.
      heibor.6 $e |- ( ph -> D e. ( CMet ` X ) ) $.
      heibor.7 $e |- ( ph -> F : NN0 --> ( ~P X i^i Fin ) ) $.
      heibor.8 $e |- ( ph -> A. n e. NN0 X = U_ y e. ( F ` n ) ( y B n ) ) $.
      $( Lemma for ~ heibor .  Using countable choice ~ ax-cc , we have fixed
         in advance a collection of finite ` 2 ^ -u n ` nets ` ( F `` n ) ` for
         ` X ` (note that an ` r ` -net is a set of points in ` X ` whose ` r `
         -balls cover ` X ` ).  The set ` G ` is the subset of these points
         whose corresponding balls have no finite subcover (i.e. in the set
         ` K ` ).  If the theorem was false, then ` X ` would be in ` K ` , and
         so some ball at each level would also be in ` K ` .  But we can say
         more than this; given a ball ` ( y B n ) ` on level ` n ` , since
         level ` n + 1 ` covers the space and thus also ` ( y B n ) ` , using
         ~ heiborlem1 there is a ball on the next level whose intersection with
         ` ( y B n ) ` also has no finite subcover.  Now since the set ` G ` is
         a countable union of finite sets, it is countable (which needs ~ ax-cc
         via ~ iunctb ), and so we can apply ~ ax-cc to ` G ` directly to get a
         function from ` G ` to itself, which points from each ball in ` K ` to
         a ball on the next level in ` K ` , and such that the intersection
         between these balls is also in ` K ` .  (Contributed by Jeff Madsen,
         18-Jan-2014.) $)
      heiborlem3 $p |- ( ph -> E. g A. x e. G
          ( ( g ` x ) G ( ( 2nd ` x ) + 1 ) /\
            ( ( B ` x ) i^i ( ( g ` x ) B ( ( 2nd ` x ) + 1 ) ) ) e. K ) ) $=
        ( vt cuni cv wf cfv c2nd c1 caddc co wbr cin wcel wa wral wex cdom wrex
        com cn0 csn cxp ciun nn0ex fvex snex xpex iunex c1st wrel wceq relopabi
        cvv wss cop w3a 1st2nd mpan eleq1d df-br syl6bbr heiborlem2 syl6bb snid
        opelxp mpbiran2 fveq2 sneq xpeq12d eleq2d rspcev sylan2br eliun 3adant3
        ibi sylibr syl eqeltrd ssriv ssdomg mp2 cen cn nnenom entri endom ax-mp
        nn0ennn vex xpsnen cfn inss2 ffvelrnda sseldi sylancr ralrimiva ffvelrn
        cpw syl2an oveq1 syl5eq oveq2 eqtrd ineq2d c2 cexp adantl elpwid oveq2d
        cdiv ovex syl2anc adantr syl3anc sylib heiborlem1 cmopn sdomdom endomtr
        csdm sylbi iunctb domtr simp1d peano2nn0 iunin2 cbviunv iuneq1d iuneq2d
        isfinite eqeq2d rspccva fveq2d df-ov syl6eqr inss1 simp2d sseldd ovmpt2
        cbl cxmt cxr cme cms cmetmet metxmet nnexpcl nnrpd rpreccld rpxrd blssm
        2nn eqsstrd df-ss eqtr3d eqimss2 simp3d inex1 mopnuni sseqtrd sselda id
        adantrr unisn uniiun eqtr3i sseqtri mp3an12 eleq1 biimpri syl3an simprr
        snfi rexsn 3expb jca32 ex reximdv2 eqeltri uniex breq1 anbi12d axcc4dom
        mpd simpr eximi ) ANOUFZJUGZUHZBUGZUXKUIZUXMUJUIZUKULUMZNUNZUXMGUIZUXNU
        XPGUMZUOZPUPZUQZBNURZUQZJUSZUYCJUSANVBUTUNZUEUGZUXPNUNZUXRUYGUXPGUMZUOZ
        PUPZUQZUEUXJVAZBNURUYEANUEVCUYGMUIZUYGVDZVEZVFZUTUNZUYQVBUTUNZUYFUYQVPU
        PNUYQVQUYRUEVCUYPVGUYNUYOUYGMVHZUYGVIVJVKBNUYQUXMNUPZUXMUXMVLUIZUXOVRZU
        YQNVMVUAUXMVUCVNLUGZVCUPCUGZVUDMUIZUPVUEVUDGUMZPUPVSCLNTVOUXMNVTWAZVUAU
        XOVCUPZVUBUXOMUIZUPZVUBUXOGUMZPUPZVSZVUCUYQUPZVUAVUNVUAVUAVUBUXONUNZVUN
        VUAVUAVUCNUPVUPVUAUXMVUCNVUHWBVUBUXONWCWDCEFVUBGUXOHILMNOPRSTUXMVLVHUXM
        UJVHZWEWFWRZVUIVUKVUOVUMVUIVUKUQVUCUYPUPZUEVCVAZVUOVUKVUIVUCVUJUXOVDZVE
        ZUPZVUTVVCVUKUXOVVAUPUXOVUQWGVUBUXOVUJVVAWHWIVUSVVCUEUXOVCUYGUXOVNZUYPV
        VBVUCVVDUYNVUJUYOVVAUYGUXOMWJUYGUXOWKWLWMWNWOUEVUCVCUYPWPWSWQWTXAXBNUYQ
        VPXCXDAVCVBUTUNZUYPVBUTUNZUEVCURUYSVCVBXEUNVVEVCXFVBXKXGXHVCVBXIXJAVVFU
        EVCAUYGVCUPUQZUYPUYNXEUNUYNVBUTUNZVVFUYNUYGUYTUEXLZXMVVGUYNXNUPZVVHVVGQ
        YAZXNUOZXNUYNVVKXNXOZAVCVVLUYGMUCXPXQVVJUYNVBUUCUNVVHUYNUUMUYNVBUUAUUDW
        TUYPUYNVBUUBXRXSUEVCUYPUUEXRNUYQVBUUFXRAUYMBNAVUAUQZUYKUEUXPMUIZVAZUYMV
        VNVVOXNUPUXRUEVVOUYJVFZVQZUXRPUPZVVPVVNVVLXNVVOVVMAVCVVLMUHZUXPVCUPZVVO
        VVLUPVUAUCVUAVUIVWAVUAVUIVUKVUMVURUUGZUXOUUHWTZVCVVLUXPMXTYBZXQVVNVVQUX
        RVNVVRVVNVVQUXRUEVVOUYIVFZUOZUXRUEVVOUXRUYIUUIVVNUXRQUOZVWFUXRVVNQVWEUX
        RAQCVUFVUGVFZVNZLVCURVWAQVWEVNZVUAUDVWCVWIVWJLUXPVCVUDUXPVNZVWHVWEQVWKV
        WHUEVVOUYGVUDGUMZVFZVWEVWKVWHUEVUFVWLVFVWMCUEVUFVUGVWLVUEUYGVUDGYCUUJVW
        KUEVUFVVOVWLVUDUXPMWJUUKYDVWKUEVVOVWLUYIVUDUXPUYGGYEUULYFUUNUUOYBYGVVNU
        XRQVQVWGUXRVNVVNUXRVUBUKYHUXOYIUMZYMUMZHUVCUIZUMZQVVNUXRVULVWQVUAUXRVUL
        VNAVUAUXRVUCGUIVULVUAUXMVUCGVUHUUPVUBUXOGUUQUURZYJVVNVUBQUPZVUIVULVWQVN
        VVNVUJQVUBVVNVUJQVVNVVLVVKVUJVVKXNUUSZAVVTVUIVUJVVLUPVUAUCVWBVCVVLUXOMX
        TYBXQYKVUAVUKAVUAVUIVUKVUMVURUUTYJUVAZVUAVUIAVWBYJZDKVUBUXOQVCDUGZUKYHK
        UGZYIUMZYMUMZVWPUMVWQGVUBVXFVWPUMVXCVUBVXFVWPYCVXDUXOVNZVXFVWOVUBVWPVXG
        VXEVWNUKYMVXDUXOYHYIYEYLYLUAVUBVWOVWPYNUVBYOYFVVNHQUVDUIUPZVWSVWOUVEUPV
        WQQVQAVXHVUAAHQUVFUIUPZVXHAHQUVGUIUPVXIUBHQUVHWTHQUVIWTZYPVXAVVNVWOVVNV
        WNVVNVWNVVNYHXFUPVUIVWNXFUPUVOVXBYHUXOUVJXRUVKUVLUVMHVUBVWOQUVNYQUVPUXR
        QUVQYRUVRYDUXRVVQUVSWTVUAVVSAVUAUXRVULPVWRVUAVUIVUKVUMVURUVTXAYJUEEFVVO
        UYJUXRHIOPRSUXRUYIUXMGVHUWAYSYQVVNUYKUYLUEVVOUXJVVNUYGVVOUPZUYKUQZUYGUX
        JUPZUYLUQVVNVXLUQVXMUYHUYKVVNVXKVXMUYKVVNVVOUXJUYGVVNVVOQUXJVVNVVOQVVNV
        VLVVKVVOVWTVWDXQYKAQUXJVNZVUAAVXHVXNVXJHOQRUWBWTYPUWCUWDUWFVVNVXKUYKUYH
        VVNVWAVXKVXKUYKUYIPUPZUYHVUAVWAAVWCYJVXKUWEUYKUXKPUPZJUYIVDZVAZVXOVXQXN
        UPUYJJVXQUXKVFZVQUYKVXRUYIUWPUYJUYIVXSUXRUYIXOVXQUFUYIVXSUYIUYGUXPGYNZU
        WGJVXQUWHUWIUWJJEFVXQUXKUYJHIOPRSJXLYSUWKVXPVXOJUYIVXTUXKUYIPUWLUWQYRUY
        HVWAVXKVXOVSCEFUYGGUXPHILMNOPRSTVVIUXOUKULYNWEUWMUWNUWRVVNVXKUYKUWOUWSU
        WTUXAUXGXSUYLUYBUEUXJJBNOOHYTUIVPRHYTVHUXBUXCUYGUXNVNZUYHUXQUYKUYAUYGUX
        NUXPNUXDVYAUYJUXTPVYAUYIUXSUXRUYGUXNUXPGYCYGWBUXEUXFYOUYDUYCJUXLUYCUXHU
        XIWT $.

      ${
        heibor.9 $e |- ( ph -> A. x e. G
             ( ( T ` x ) G ( ( 2nd ` x ) + 1 ) /\
               ( ( B ` x ) i^i ( ( T ` x ) B ( ( 2nd ` x ) + 1 ) ) ) e. K ) )
            $.
        heibor.10 $e |- ( ph -> C G 0 ) $.
        heibor.11 $e |- S = seq 0 ( T ,
                           ( m e. NN0 |-> if ( m = 0 , C , ( m - 1 ) ) ) ) $.
        $( Lemma for ~ heibor .  Using the function ` T ` constructed in
           ~ heiborlem3 , construct an infinite path in ` G ` .  (Contributed
           by Jeff Madsen, 23-Jan-2014.) $)
        heiborlem4 $p |- ( ( ph /\ A e. NN0 ) -> ( S ` A ) G A ) $=
          ( vk cn0 wcel cfv wbr cv wi cc0 c1 caddc co wceq fveq2 breq12d imbi2d
          id cmin cif cmpt cseq fveq1i cz 0z seq1 ax-mp eqtri cvv 0nn0 relopabi
          w3a brrelexi syl iftrue eqid fvmptg sylancr syl5eq eqbrtrd cin wa cop
          df-br c2nd wral syl6eqr fvex vex op2ndd oveq1d oveq12d ineq12d eleq1d
          df-ov anbi12d rspccv syl5bi cuz seqp1 eleq2s oveq1i 3eqtr4g peano2nn0
          nn0uz cn wn nn0p1nn nnne0 neneqd iffalse 3syl syl6eqel eqeq1 ifbieq2d
          ovex oveq1 syl2anc cc nn0cn ax-1cn pncan sylancl 3eqtrd oveq2d breq1d
          eqtrd biimprd adantrd syl9r a2d nn0ind impcom ) GULUMAGKUNZGQUOZABUPZ
          KUNZUUDQUOZUQAURKUNZURQUOZUQAUKUPZKUNZUUIQUOZUQAUUIUSUTVAZKUNZUULQUOZ
          UQAUUCUQBUKGUUDURVBZUUFUUHAUUOUUEUUGUUDURQUUDURKVCUUOVFVDVEUUDUUIVBZU
          UFUUKAUUPUUEUUJUUDUUIQUUDUUIKVCUUPVFVDVEUUDUULVBZUUFUUNAUUQUUEUUMUUDU
          ULQUUDUULKVCUUQVFVDVEUUDGVBZUUFUUCAUURUUEUUBUUDGQUUDGKVCUURVFVDVEAUUG
          IURQAUUGURNULNUPZURVBZIUUSUSVGVAZVHZVIZUNZIUUGURLUVCURVJZUNZUVDURKUVE
          UJVKURVLUMUVFUVDVBVMLUVCURVNVOVPAURULUMIVQUMZUVDIVBVRAIURQUOUVGUIIURQ
          OUPZULUMCUPZUVHPUNUMUVIUVHHVASUMVTCOQUCVSWAWBNURUVBIULVQUVCUUTIUVAWCU
          VCWDZWEWFWGUIWHUUIULUMZAUUKUUNAUUKUUJUUILVAZUULQUOZUUJUUIHVAZUVLUULHV
          AZWIZSUMZWJZUVKUUNUUKUUJUUIWKZQUMZAUVRUUJUUIQWLAUUDLUNZUUDWMUNZUSUTVA
          ZQUOZUUDHUNZUWAUWCHVAZWIZSUMZWJZBQWNUVTUVRUQUHUWIUVRBUVSQUUDUVSVBZUWD
          UVMUWHUVQUWJUWAUVLUWCUULQUWJUWAUVSLUNUVLUUDUVSLVCUUJUUILXCWOZUWJUWBUU
          IUSUTUUJUUIUUDUUIKWPUKWQWRWSZVDUWJUWGUVPSUWJUWEUVNUWFUVOUWJUWEUVSHUNU
          VNUUDUVSHVCUUJUUIHXCWOUWJUWAUVLUWCUULHUWKUWLWTXAXBXDXEWBXFUVKUVMUUNUV
          QUVKUUNUVMUVKUUMUVLUULQUVKUUMUUJUULUVCUNZLVAZUVLUVKUULUVEUNZUUIUVEUNZ
          UWMLVAZUUMUWNUWOUWQVBUUIURXGUNULLUVCURUUIXHXMXIUULKUVEUJVKUUJUWPUWMLU
          UIKUVEUJVKXJXKUVKUWMUUIUUJLUVKUWMUULURVBZIUULUSVGVAZVHZUWSUUIUVKUULUL
          UMUWTVQUMUWMUWTVBUUIXLUVKUWTUWSVQUVKUULXNUMZUWRXOUWTUWSVBUUIXPUXAUULU
          RUULXQXRUWRIUWSXSXTZUULUSVGYDYANUULUVBUWTULVQUVCUUSUULVBUUTUWRUVAUWSI
          UUSUULURYBUUSUULUSVGYEYCUVJWEYFUXBUVKUUIYGUMUSYGUMUWSUUIVBUUIYHYIUUIU
          SYJYKYLYMYOYNYPYQYRYSYTUUA $.

        heibor.12 $e |- M = ( n e. NN |->
                            <. ( S ` n ) , ( 3 / ( 2 ^ n ) ) >. ) $.
        $( Lemma for ~ heibor .  The function ` M ` is a set of
           point-and-radius pairs suitable for application to ~ caubl .
           (Contributed by Jeff Madsen, 23-Jan-2014.) $)
        heiborlem5 $p |- ( ph -> M : NN --> ( X X. RR+ ) ) $=
          ( vk cv cfv c3 c2 cexp co cdiv cop crp cxp wcel cn wral cn0 nnnn0 cpw
          wf wa cfn cin inss1 ffvelrnda sseldi elpwid wbr heiborlem4 heiborlem2
          fvex vex simp2bi syl sseldd sylan2 ralrimiva weq fveq2 eleq1d cbvralv
          sylib wi 3re 3pos elrpii nnexpcl sylancr nnrpd rpdivcl opelxpi expcom
          2nn ralimia fmpt ) ANUMZJUNZUOUPXEUQURZUSURZUTZTVAVBZVCZNVDVEZVDXJSVI
          AXFTVCZNVDVEZXLAULUMZJUNZTVCZULVDVEXNAXQULVDXOVDVCAXOVFVCZXQXOVGAXRVJ
          ZXOOUNZTXPXSXTTXSTVHZVKVLZYAXTYAVKVMAVFYBXOOUFVNVOVPXSXPXOPVQZXPXTVCZ
          ABCDEFXOGHIJKLMNOPQRTUAUBUCUDUEUFUGUHUIUJVRYCXRYDXPXOGURRVCCEFXPGXOIL
          NOPQRUAUBUCXOJVTULWAVSWBWCWDWEWFXQXMULNVDULNWGXPXFTXOXEJWHWIWJWKXMXKN
          VDXEVDVCZXHVAVCZXMXKWLYEUOVAVCXGVAVCYFUOWMWNWOYEXGYEUPVDVCXEVFVCXGVDV
          CXBXEVGUPXEWPWQWRUOXGWSWQXMYFXKXFXHTVAWTXAWCXCWCNVDXJXISUKXDWK $.

        $( Lemma for ~ heibor .  Since the sequence of balls connected by the
           function ` T ` ensures that each ball nontrivially intersects with
           the next (since the empty set has a finite subcover, the
           intersection of any two successive balls in the sequence is
           nonempty), and each ball is half the size of the previous one, the
           distance between the centers is at most ` 3 / 2 ` times the size of
           the larger, and so if we expand each ball by a factor of ` 3 ` we
           get a nested sequence of balls.  (Contributed by Jeff Madsen,
           23-Jan-2014.) $)
        heiborlem6 $p |- ( ph -> A. k e. NN
      ( ( ball ` D ) ` ( M ` ( k + 1 ) ) ) C_ ( ( ball ` D ) ` ( M ` k ) ) ) $=
          ( cv c1 caddc co cfv wss cn wcel wa c3 cexp cdiv cn0 cmin cle wbr syl
          c2 cr adantr cpw wf cfn cin sylancl elpwid heiborlem4 fvex heiborlem2
          sylan2 ovex simp2bi sseldd crp 3re 2nn nnexpcl nnrpd adantl rerpdivcl
          sylancr mpan wn c0 wne wceq oveq1 weq oveq2 oveq2d ovmpt2 fveq2 df-ov
          wi cop syl6eqr oveq1d oveq12d ineq12d mpd syl2anc cuni mp2an rpreccld
          wrex rpred cxr rpxrd syl3anc cc0 cif fveq1i oveq1i cvv cc pncan eqtrd
          ax-1cn cmul 3cn rpcn rpne0 2cn mp3an12 divcan5 mp3an13 eqtr3d opeq12d
          cbl nnnn0 cxmt cme cms cmetmet metxmet inss1 peano2nn0 ffvelrn syl2an
          fss ffvelrnda vex sylancom df-br op2ndd breq12d eleq1d anbi12d rspccv
          c2nd wral syl5bi simpld simprd 0elpw 0fin elin mpbir2an sseq2d rspcev
          0ss unieq 0ex sseq1 rexbidv notbid elab2 con2bii mpbi nelne2 eqnetrrd
          cxad rexadd breq1d w3a 3exp2 imp32 syl32anc sylbird necon3ad rpaddcld
          bldisj metcl letrid ord cmpt seqp1 nn0uz eleq2s 3eqtr4g nn0p1nn nnne0
          cseq neneqd iffalse syl6eqel eqeq1 ifbieq2d eqid fvmptg 3eqtrd metsym
          nn0cn 2timesi df-3 3eqtri mulcli divsubdir divdir 3eqtr3a 2ne0 pm3.2i
          cuz mulcom expp1 eqtr4d mulid1i a1i 3eqtr4d 3brtr4d syl33anc peano2nn
          blss2 opex fvmpt fveq2d 3sstr4d ralrimiva ) AMUMZUNUOUPZTUQZIUUAUQZUQ
          ZVUATUQZVUDUQZURMUSAVUAUSUTZVAZVUBJUQZVBVJVUBVCUPZVDUPZVUDUPZVUAJUQZV
          BVJVUAVCUPZVDUPZVUDUPZVUEVUGVUHAVUAVEUTZVUMVUQURZVUAUUBAVURVAZIUAUUCU
          QUTZVUJUAUTVUNUAUTZVULVKUTZVUPVKUTZVUJVUNIUPZVUPVULVFUPZVGVHVUSAVVAVU
          RAIUAUUDUQUTZVVAAIUAUUEUQUTVVGUFIUAUUFVIZIUAUUGVIVLZVUTVUBPUQZUAVUJVU
          TVVJUAAVEUAVMZPVNZVUBVEUTZVVJVVKUTVURAVEVVKVOVPZPVNVVNVVKURVVLUGVVKVO
          UUHVEVVNVVKPUULVQZVUAUUIZVEVVKVUBPUUJUUKVRZVUTVUJVUBQVHZVUJVVJUTZVURA
          VVMVVRVVPABCDEFVUBGHIJKLNOPQRSUAUBUCUDUEUFUGUHUIUJUKVSWBVVRVVMVVSVUJV
          UBGUPSUTCEFVUJGVUBILOPQRSUBUCUDVUBJVTVUAUNUOWCZWAWDVIWEVUTVUAPUQZUAVU
          NVUTVWAUAAVEVVKVUAPVVOUUMVRVUTVUNVUAQVHZVUNVWAUTZABCDEFVUAGHIJKLNOPQR
          SUAUBUCUDUEUFUGUHUIUJUKVSZVWBVURVWCVUNVUAGUPZSUTCEFVUNGVUAILOPQRSUBUC
          UDVUAJVTZMUUNZWAWDVIWEZVUTVBVKUTZVUKWFUTZVVCWGVURVWJAVURVUKVURVJUSUTZ
          VVMVUKUSUTWHVVPVJVUBWIWMWJZWKVBVUKWLWMVUTVWIVUOWFUTZVVDWGVURVWMAVURVU
          OVWKVURVUOUSUTWHVJVUAWIWNWJZWKVBVUOWLWMVUTVUNVUNVUAKUPZIUPZUNVUOVDUPZ
          UNVUKVDUPZUOUPZVVEVVFVGVUTVWSVWPVGVHZWOZVWPVWSVGVHZVUTVUNVWQVUDUPZVWO
          VWRVUDUPZVPZWPWQVXAVUTVWEVWOVUBGUPZVPZVXEWPVUTVWEVXCVXFVXDAVURVVBVWEV
          XCWRVWHDNVUNVUAUAVEDUMZUNVJNUMZVCUPZVDUPZVUDUPZVXCGVUNVXKVUDUPVXHVUNV
          XKVUDWSNMWTZVXKVWQVUNVUDVXMVXJVUOUNVDVXIVUAVJVCXAXBXBUEVUNVWQVUDWCXCU
          UOVUTVWOUAUTZVVMVXFVXDWRVUTVVJUAVWOVVQVUTVWOVUBQVHZVWOVVJUTZVUTVXOVXG
          SUTZVUTVWBVXOVXQVAZVWDAVWBVXRXFVURVWBVUNVUAXGZQUTZAVXRVUNVUAQUUPABUMZ
          KUQZVYAUVBUQZUNUOUPZQVHZVYAGUQZVYBVYDGUPZVPZSUTZVAZBQUVCVXTVXRXFUIVYJ
          VXRBVXSQVYAVXSWRZVYEVXOVYIVXQVYKVYBVWOVYDVUBQVYKVYBVXSKUQVWOVYAVXSKXD
          VUNVUAKXEXHZVYKVYCVUAUNUOVUNVUAVYAVWFVWGUUQXIZUURVYKVYHVXGSVYKVYFVWEV
          YGVXFVYKVYFVXSGUQVWEVYAVXSGXDVUNVUAGXEXHVYKVYBVWOVYDVUBGVYLVYMXJXKUUS
          UUTUVAVIUVDVLXLZUVEVXOVVMVXPVXFSUTCEFVWOGVUBILOPQRSUBUCUDVUNVUAKWCVVT
          WAWDVIWEZVURVVMAVVPWKDNVWOVUBUAVEVXLVXDGVWOVXKVUDUPVXHVWOVXKVUDWSVXIV
          UBWRZVXKVWRVWOVUDVYPVXJVUKUNVDVXIVUBVJVCXAXBXBUEVWOVWRVUDWCXCXMXKVUTV
          XQWPSUTZWOZVXGWPWQVUTVXOVXQVYNUVFWPEUMZXNZURZELVMZVOVPZXQZVYRWPWUCUTZ
          WPWPXNZURZWUDWUEWPWUBUTWPVOUTLUVGUVHWPWUBVOUVIUVJWUFUVMWUAWUGEWPWUCVY
          SWPWRVYTWUFWPVYSWPUVNUVKUVLXOVYQWUDFUMZVYTURZEWUCXQZWOWUDWOFWPSUVOWUH
          WPWRZWUJWUDWUKWUIWUAEWUCWUHWPVYTUVPUVQUVRUCUVSUVTUWAVXGWPSUWBVQUWCVUT
          VWTVXEWPVUTVWTVWQVWRUWDUPZVWPVGVHZVXEWPWRZVUTWULVWSVWPVGVUTVWQVKUTVWR
          VKUTWULVWSWRVUTVWQVURVWQWFUTAVURVUOVWNXPWKZXRVUTVWRVURVWRWFUTAVURVUKV
          WLXPWKZXRVWQVWRUWEXMUWFVUTVVAVVBVXNVWQXSUTZVWRXSUTZWUMWUNXFZVVIVWHVYO
          VUTVWQWUOXTVUTVWRWUPXTVVAVVBVXNUWGZWUQWURWUSWUTWUQWURWUMWUNIVUNVWOVWQ
          VWRUAUWNUWHUWIUWJUWKUWLXLVUTVWTVXBVUTVWSVWPVUTVWSVUTVWQVWRWUOWUPUWMXR
          VUTVVGVVBVXNVWPVKUTAVVGVURVVHVLZVWHVYOVUNVWOIUAUWOYAUWPUWQXLVUTVVEVWO
          VUNIUPZVWPVUTVUJVWOVUNIVURVUJVWOWRAVURVUJVUNVUBNVEVXIYBWRZHVXIUNVFUPZ
          YCZUWRZUQZKUPZVWOVURVUBKWVFYBUXEZUQZVUAWVIUQZWVGKUPZVUJWVHWVJWVLWRVUA
          YBUYEUQVEKWVFYBVUAUWSUWTUXAVUBJWVIUKYDVUNWVKWVGKVUAJWVIUKYDYEUXBVURWV
          GVUAVUNKVURWVGVUBYBWRZHVUBUNVFUPZYCZWVNVUAVURVVMWVOYFUTWVGWVOWRVVPVUR
          WVOWVNYFVURWVMWOZWVOWVNWRVURVUBUSUTZWVPVUAUXCWVQVUBYBVUBUXDUXFVIWVMHW
          VNUXGVIZVUBUNVFWCUXHNVUBWVEWVOVEYFWVFVYPWVCWVMWVDWVNHVXIVUBYBUXIVXIVU
          BUNVFWSUXJWVFUXKUXLXMWVRVURVUAYGUTUNYGUTZWVNVUAWRVUAUXOYJVUAUNYHVQUXM
          XBYIWKXIVUTVVGVXNVVBWVBVWPWRWVAVYOVWHVWOVUNIUAUXNYAYIVURVVFVWSWRAVURV
          JVBYKUPZVUKVDUPZVULVFUPZVJVUKVDUPZVWRUOUPZVVFVWSVURWVTVBVFUPZVUKVDUPZ
          VJUNUOUPZVUKVDUPZWWBWWDWWEWWGVUKVDWWEVBVBUOUPZVBVFUPZVBWWGWVTWWIVBVFV
          BYLUXPYEVBYGUTZWWKWWJVBWRYLYLVBVBYHXOUXQUXRYEVURVWJWWFWWBWRZVWLVWJVUK
          YGUTZVUKYBWQZWWLVUKYMZVUKYNZWVTYGUTWWKWWMWWNVAZWWLVJVBYOYLUXSYLWVTVBV
          UKUXTYPXMVIVURVWJWWHWWDWRZVWLVWJWWMWWNWWRWWOWWPVJYGUTZWVSWWQWWRYOYJVJ
          UNVUKUYAYPXMVIUYBVURVUPWWAVULVFVURWVTVJVUOYKUPZVDUPZVUPWWAVURVWMWXAVU
          PWRZVWNVWMVUOYGUTZVUOYBWQZWXBVUOYMZVUOYNZWWKWXCWXDVAZWWSVJYBWQZVAZWXB
          YLWWSWXHYOUYCUYDZVBVUOVJYQYRXMVIVURWWTVUKWVTVDVURWWTVUOVJYKUPZVUKVURW
          WSWXCWWTWXKWRYOVURVWMWXCVWNWXEVIVJVUOUYFWMWWSVURVUKWXKWRYOVJVUAUYGWNU
          YHZXBYSXIVURVWQWWCVWRUOVURVJUNYKUPZWWTVDUPZVWQWWCVURVWMWXNVWQWRZVWNVW
          MWXCWXDWXOWXEWXFWVSWXGWXIWXOYJWXJUNVUOVJYQYRXMVIVURWXMVJWWTVUKVDWXMVJ
          WRVURVJYOUYIUYJWXLXJYSXIUYKWKUYLIVUJVUNVULVUPUAUYOUYMWBVUIVUEVUJVULXG
          ZVUDUQVUMVUIVUCWXPVUDVUHVUCWXPWRZAVUHWVQWXQVUAUYNOVUBOUMZJUQZVBVJWXRV
          CUPZVDUPZXGZWXPUSTWXRVUBWRZWXSVUJWYAVULWXRVUBJXDWYCWXTVUKVBVDWXRVUBVJ
          VCXAXBYTULVUJVULUYPUYQVIWKUYRVUJVULVUDXEXHVUHVUGVUQWRAVUHVUGVUNVUPXGZ
          VUDUQVUQVUHVUFWYDVUDOVUAWYBWYDUSTOMWTZWXSVUNWYAVUPWXRVUAJXDWYEWXTVUOV
          BVDWXRVUAVJVCXAXBYTULVUNVUPUYPUYQUYRVUNVUPVUDXEXHWKUYSUYT $.

        $( Lemma for ~ heibor .  Since the sizes of the balls decrease
           exponentially, the sequence converges to zero.  (Contributed by Jeff
           Madsen, 23-Jan-2014.) $)
        heiborlem7 $p |- A. r e. RR+ E. k e. NN ( 2nd ` ( M ` k ) ) < r $=
          ( cv cfv c2nd clt wbr cn wrex crp wcel c3 c2 cexp co cdiv c1 3re 3pos
          elrpii rpdivcl mpan2 cr 2re 1lt2 expnlbnd mp3an23 syl wa cmul cn0 2nn
          wceq nnnn0 nnexpcl sylancr nnrpd cc0 wne rpcn rpne0 3cn divrec mp3an1
          cc syl2anc adantl breq1d nnrecred rpre pm3.2i ltmuldiv2 syl2anr bitrd
          wb mp3an3 rexbidva mpbird cop fveq2 oveq2 oveq2d opeq12d fvmpt fveq2d
          opex fvex ovex op2nd syl6eq rexbiia sylibr rgen ) MUNZTUOZUPUOZUBUNZU
          QURZMUSUTZUBVAYHVAVBZVCVDYEVEVFZVGVFZYHUQURZMUSUTZYJYKYOVHYLVGVFZYHVC
          VGVFZUQURZMUSUTZYKYQVAVBZYSYKVCVAVBYTVCVIVJVKYHVCVLVMYTVDVNVBVHVDUQUR
          YSVOVPYQVDMVQVRVSYKYNYRMUSYKYEUSVBZVTZYNVCYPWAVFZYHUQURZYRUUBYMUUCYHU
          QUUAYMUUCWDZYKUUAYLVAVBZUUEUUAYLUUAVDUSVBYEWBVBYLUSVBWCYEWEVDYEWFWGZW
          HUUFYLWPVBZYLWIWJZUUEYLWKYLWLVCWPVBUUHUUIUUEWMVCYLWNWOWQVSWRWSUUAYPVN
          VBZYHVNVBZUUDYRXFZYKUUAYLUUGWTYHXAUUJUUKVCVNVBZWIVCUQURZVTUULUUMUUNVI
          VJXBYPYHVCXCXGXDXEXHXIYIYNMUSUUAYGYMYHUQUUAYGYEJUOZYMXJZUPUOYMUUAYFUU
          PUPOYEOUNZJUOZVCVDUUQVEVFZVGVFZXJUUPUSTUUQYEWDZUURUUOUUTYMUUQYEJXKUVA
          UUSYLVCVGUUQYEVDVEXLXMXNUMUUOYMXQXOXPUUOYMYEJXRVCYLVGXSXTYAWSYBYCYD
          $.

        heibor.13 $e |- ( ph -> U C_ J ) $.
        ${
          heibor.14 $e |- Y e. _V $.
          heibor.15 $e |- ( ph -> Y e. Z ) $.
          heibor.16 $e |- ( ph -> Z e. U ) $.
          heibor.17 $e |- ( ph -> ( 1st o. M ) ( ~~>t ` J ) Y ) $.
          $( Lemma for ~ heibor .  The previous lemmas establish that the
             sequence ` M ` is Cauchy, so using completeness we now consider
             the convergent point ` Y ` .  By assumption, ` U ` is an open
             cover, so ` Y ` is an element of some ` Z e. U ` , and some ball
             centered at ` Y ` is contained in ` Z ` .  But the sequence
             contains arbitrarily small balls close to ` Y ` , so some element
             ` ball ( M `` n ) ` of the sequence is contained in ` Z ` .  And
             finally we arrive at a contradiction, because ` { Z } ` is a
             finite subcover of ` U ` that covers ` ball ( M `` n ) ` , yet
             ` ball ( M `` n ) e. K ` .  For convenience, we write this
             contradiction as ` ph -> ps ` where ` ph ` is all the accumulated
             hypotheses and ` ps ` is anything at all.  (Contributed by Jeff
             Madsen, 22-Jan-2014.) $)
          heiborlem8 $p |- ( ph -> ps ) $=
            ( vk vr vt cv cbl cfv co wss crp wrex cxmt wcel cms cmetmet metxmet
            cme 3syl sseldd mopni2 syl3anc wa c2nd c2 cdiv clt wn rphalfcl wceq
            wbr cn breq2 rexbidv heiborlem7 vtoclri syl adantl nnnn0 heiborlem4
            cn0 fvex vex heiborlem2 simp3bi sylan2 ad2ant2r wi c1st c1 cexp cxr
            cle ad2antrr cxp ffvelrnda xp1st 2nn nnexpcl sylancr nnrpd rpreccld
            heiborlem5 ad2antrl rpxrd c3 1re 3re cr cop weq oveq2 oveq2d fveq2d
            ovex syl6eq syl2anc 3sstr3d cuni ad2antlr sstrd cfn sseq2d 1lt3 cc0
            xp2nd ltleii wb elrp lediv1 mp3an12 sylbi mpbii fveq2 opeq12d fvmpt
            opex op2nd breqtrrd ssbl syl221anc oveq1 ovmpt2 op1st oveq1d eqtr3d
            1st2nd2 df-ov syl6reqr ctop mopntop blssm mopnuni eqid sscls simprr
            ccl blsscls syl23anc eqsstr3d rpre ccom clm heiborlem6 3expia mpdan
            caublcls imp blhalf syl22anc sstr2 cpw cin csn unisng biimpar snssd
            snex elpw sylibr snfi elin sylanbrc unieq rspcev sylan syldan sseq1
            a1i notbid elab2 con2bii sylib syld mt2d rexlimddv nrexdv pm2.21dd
            ex ) AUBCVCZJVDVEZVFZUCVGZCVHVIZBAJUAVJVEVKZUCRVKUBUCVKUYAAJUAVLVEV
            KJUAVOVEVKUYBUHJUAVMJUAVNVPZAMRUCUOURVQUQCUCJUBRUAUDVRVSAUXTCVHAUXQ
            VHVKZVTZUTVCZTVEZWAVEZUXQWBWCVFZWDWHZUXTWEUTWIUYDUYJUTWIVIZAUYDUYIV
            HVKZUYKUXQWFZUYHVAVCZWDWHZUTWIVIUYKVAUYIVHUYNUYIWGUYOUYJUTWIUYNUYIU
            YHWDWJWKACDEFGHIJKLMUTNOPQRSTUAVAUDUEUFUGUHUIUJUKULUMUNWLWMWNWOUYEU
            YFWIVKZUYJVTZVTZUXTUYFKVEZUYFHVFZSVKZAUYPVUAUYDUYJUYPAUYFWRVKZVUAUY
            FWPZAVUBVTUYSUYFQWHZVUAACDEFGUYFHIJKLMNOPQRSUAUDUEUFUGUHUIUJUKULUMW
            QVUDVUBUYSUYFPVEVKVUADFGUYSHUYFJMOPQRSUDUEUFUYFKWSZUTWTXAXBWNXCXDUY
            RUXTUYTUCVGZVUAWEZUYRUYTUXSVGUXTVUFXEUYRUYTUYGUXRVEZUXSUYRUYGXFVEZX
            GWBUYFXHVFZWCVFZUXRVFZVUIUYHUXRVFZUYTVUHUYRUYBVUIUAVKZVUKXIVKUYHXIV
            KZVUKUYHXJWHVULVUMVGAUYBUYDUYQUYCXKZUYRUYGUAVHXLZVKZVUNAUYPVURUYDUY
            JAWIVUQUYFTACDEFGHIJKLMNOPQRSTUAUDUEUFUGUHUIUJUKULUMUNXTZXMXDZUYGUA
            VHXNWNZUYRVUKUYPVUKVHVKUYEUYJUYPVUJUYPVUJUYPWBWIVKVUBVUJWIVKXOVUCWB
            UYFXPXQXRZXSYAYBUYRUYHUYRVURUYHVHVKVUTUYGUAVHUUCWNYBZUYRVUKYCVUJWCV
            FZUYHXJUYPVUKVVDXJWHZUYEUYJUYPVUJVHVKZVVEVVBVVFXGYCXJWHZVVEXGYCYDYE
            UUAUUDVVFVUJYFVKUUBVUJWDWHVTZVVGVVEUUEZVUJUUFXGYFVKYCYFVKVVHVVIYDYE
            XGYCVUJUUGUUHUUIUUJWNYAUYPUYHVVDWGUYEUYJUYPUYHUYSVVDYGZWAVEVVDUYPUY
            GVVJWAOUYFOVCZKVEZYCWBVVKXHVFZWCVFZYGVVJWITOUTYHZVVLUYSVVNVVDVVKUYF
            KUUKVVOVVMVUJYCWCVVKUYFWBXHYIYJUULUNUYSVVDUUNUUMZYKUYSVVDVUEYCVUJWC
            YLZUUOYMYAUUPJVUIVUKUYHUAUUQUURUYRVUIUYFHVFZVULUYTUYRVUNVUBVVRVULWG
            VVAUYPVUBUYEUYJVUCYAENVUIUYFUAWREVCZXGWBNVCZXHVFZWCVFZUXRVFVULHVUIV
            WBUXRVFVVSVUIVWBUXRUUSNUTYHZVWBVUKVUIUXRVWCVWAVUJXGWCVVTUYFWBXHYIYJ
            YJUGVUIVUKUXRYLUUTYNUYRVUIUYSUYFHUYPVUIUYSWGUYEUYJUYPVUIVVJXFVEUYSU
            YPUYGVVJXFVVPYKUYSVVDVUEVVQUVAYMYAUVBUVCUYRVUHVUIUYHYGZUXRVEVUMUYRU
            YGVWDUXRUYRVURUYGVWDWGVUTUYGUAVHUVDWNYKVUIUYHUXRUVEUVFZYOUYRVUHVUHR
            UVNVEZVEZUXSUYRRUVGVKZVUHRYPZVGVUHVWGVGUYRUYBVWHVUPJRUAUDUVHWNUYRVU
            MUAVUHVWIUYRUYBVUNVUOVUMUAVGVUPVVAVVCJVUIUYHUAUVIVSVWEUYRUYBUAVWIWG
            VUPJRUAUDUVJWNYOVUHRVWIVWIUVKUVLYNUYRVWGVUIUYIUXRVFZUXSUYRVWGVUMVWF
            VEZVWJUYRVUMVUHVWFVWEYKUYRUYBVUNVUOUYIXIVKUYJVWKVWJVGVUPVVAVVCUYRUY
            IUYDUYLAUYQUYMYQYBUYEUYPUYJUVMJVUIUYHUYIRUAUDUVOUVPUVQZUYRUYBVUNUXQ
            YFVKZUBVWJVKVWJUXSVGVUPVVAUYDVWMAUYQUXQUVRYQUYRVWGVWJUBVWLAUYPUBVWG
            VKZUYDUYJAUYPVWNAXFTUVSUBRUVTVEWHZUYPVWNXEUSAVWOUYPVWNAUYFJUBVBTRUA
            UYCVUSACDEFGHIJKLMVBNOPQRSTUAUDUEUFUGUHUIUJUKULUMUNUWAUDUWDUWBUWCUW
            EXDVQUXQJUAVUIUBUWFUWGYRYRYRUYTUXSUCUWHWNAVUFVUGXEUYDUYQAVUFVUGAVUF
            VTUYTFVCZYPZVGZFMUWIZYSUWJZVIZVUGAVUFUYTUCUWKZYPZVGZVXAAVXDVUFAVXCU
            CUYTAUCMVKVXCUCWGURUCMUWLWNYTUWMAVXBVWTVKZVXDVXAAVXBVWSVKZVXBYSVKZV
            XEAVXBMVGVXFAUCMURUWNVXBMUCUWOUWPUWQVXGAUCUWRUXFVXBVWSYSUWSUWTVWRVX
            DFVXBVWTVWPVXBWGVWQVXCUYTVWPVXBUXAYTUXBUXCUXDVUAVXAGVCZVWQVGZFVWTVI
            ZWEVXAWEGUYTSUYSUYFHYLVXHUYTWGZVXJVXAVXKVXIVWRFVWTVXHUYTVWQUXEWKUXG
            UEUXHUXIUXJUXPXKUXKUXLUXMUXNUXO $.
        $}

        heiborlem9.14 $e |- ( ph -> U. U = X ) $.
        $( Lemma for ~ heibor .  Discharge the hypotheses of ~ heiborlem8 by
           applying ~ caubl to get a convergent point and adding the open cover
           assumption.  (Contributed by Jeff Madsen, 20-Jan-2014.) $)
        heiborlem9 $p |- ( ph -> ps ) $=
          ( vt vk vr c1st ccom clm cfv cv wcel cuni wrex ctopon wbr cms cmetmet
          cxmt cme metxmet 3syl mopntopon syl cdm cca heiborlem5 heiborlem6 clt
          c2nd cn crp wral heiborlem7 a1i caubl cmetcau syl2anc wfun wb methaus
          cha lmfun funfvbrb mpbid lmcl eleqtrrd eluni2 sylib wa adantr cn0 cpw
          cfn cin wf co ciun wceq c1 caddc cc0 wss fvex simprr simprl rexlimddv
          heiborlem8 ) AURTUSZRUTVAZVAZUOVBZVCZBUOMAYBMVDZVCYDUOMVEAYBUAYEARUAV
          FVAVCZXTYBYAVGZYBUAVCAJUAVJVAVCZYFAJUAVHVAVCZJUAVKVAVCYHUFJUAVIJUAVLV
          MZJRUAUBVNVOAXTYAVPVCZYGAYIXTJVQVAVCYKUFAJUPTUAUQYJACDEFGHIJKLMNOPQRS
          TUAUBUCUDUEUFUGUHUIUJUKULVRACDEFGHIJKLMUPNOPQRSTUAUBUCUDUEUFUGUHUIUJU
          KULVSUPVBTVAWAVAUQVBVTVGUPWBVEUQWCWDAACDEFGHIJKLMUPNOPQRSTUAUQUBUCUDU
          EUFUGUHUIUJUKULWEWFWGJXTRUAUBWHWIARWMVCZYAWJYKYGWKAYHYLYJJRUAUBWLVORW
          NXTYAWOVMWPZYBXTRUAWQWIUNWRUOYBMWSWTAYCMVCZYDXAZXABCDEFGHIJKLMNOPQRST
          UAYBYCUBUCUDUEAYIYOUFXBAXCUAXDXEXFPXGYOUGXBAUADOVBZPVADVBYPHXHXIXJOXC
          WDYOUHXBACVBZLVAZYQWAVAXKXLXHZQVGYQHVAYRYSHXHXFSVCXACQWDYOUIXBAIXMQVG
          YOUJXBUKULAMRXNYOUMXBXTYAXOAYNYDXPAYNYDXQAYGYOYMXBXSXR $.
      $}

      $d v ph $.
      $( Lemma for ~ heibor .  The last remaining piece of the proof is to find
         an element ` C ` such that ` C G 0 ` , i.e. ` C ` is an element of
         ` ( F `` 0 ) ` that has no finite subcover, which is true by
         ~ heiborlem1 , since ` ( F `` 0 ) ` is a finite cover of ` X ` , which
         has no finite subcover.  Thus, the rest of the proof follows to a
         contradiction, and thus there must be a finite subcover of ` U ` that
         covers ` X ` , i.e. ` X ` is compact.  (Contributed by Jeff Madsen,
         22-Jan-2014.) $)
      heiborlem10 $p |- ( ( ph /\ ( U C_ J /\ U. J = U. U ) ) ->
                          E. v e. ( ~P U i^i Fin ) U. J = U. v ) $=
        ( vx vg vt wss cuni wceq wa cv cpw cfn cin wrex wcel wn cc0 co cfv ciun
        wi cn0 wf 0nn0 inss2 ffvelrn sseldi sylancl fveq2 oveq2 iuneq12d eqeq2d
        wral rspccva eqimss syl w3a ovex heiborlem1 oveq1 eleq1d cbvrexv 3expia
        weq sylib syl2anc adantr wbr vex c0ex heiborlem2 c2nd c1 wex heiborlem3
        caddc ad2antrr cmin cif cmpt cseq cn c3 cexp cdiv cop cms simprr oveq1d
        c2 breq12d oveq12d ineq12d anbi12d cbvralv simprl eqeq1 ifbieq2d seqeq3
        cbvmptv ax-mp eqid simplrl cme cxmt cmetmet metxmet mopnuni 4syl eqtr2d
        heiborlem9 expr exlimdv mpd sylan2br 3exp2 mpi rexlimdv syld pm2.01d wb
        cdm elfvdm sseq1 rexbidv notbid elab2g 3syl con2bid mpbird sseq1d inss1
        sseli elpwid sstr unissd syl2anr biantrud syl6bbr bitrd rexbidva mpbid
        eqss ) AHMUFZMUGZHUGZUHZUIZUIZODUJZUGZUFZDHUKZULUMZUNZUVEUVKUHZDUVNUNUV
        IUVOONUOZUPZUVIUVQUVIUVQUCUJZUQFURZNUOZUCUQKUSZUNZUVRAUVQUWCVAZUVHAUWBU
        LUOZOBUWBBUJZUQFURZUTZUFZUWDAVBOUKZULUMZKVCZUQVBUOZUWEUAVDUWLUWMUIUWKUL
        UWBUWJULVEVBUWKUQKVFVGVHAOUWHUHZUWIAOBJUJZKUSZUWFUWOFURZUTZUHZJVBVMZUWM
        UWNUBVDUWSUWNJUQVBUWOUQUHZUWRUWHOUXABUWPUWBUWQUWGUWOUQKVIUWOUQUWFFVJVKV
        LVNVHOUWHVOVPUWEUWIUVQUWCUWEUWIUVQVQUWGNUOZBUWBUNUWCBDEUWBUWGOGHMNPQUWF
        UQFVRVSUXBUWABUCUWBBUCWDUWGUVTNUWFUVSUQFVTWAWBWEWCWFWGUVIUWAUVRUCUWBUVI
        UWMUVSUWBUOZUWAUVRVAVAVDUVIUWMUXCUWAUVRUWMUXCUWAVQUVIUVSUQLWHZUVRBDEUVS
        FUQGHJKLMNPQRUCWIWJWKUVIUXDUIZUVSUDUJZUSZUVSWLUSZWMWPURZLWHZUVSFUSZUXGU
        XIFURZUMZNUOZUIZUCLVMZUDWNZUVRAUXQUVHUXDAUCBCDEFGHUDIJKLMNOPQRSTUAUBWOW
        QUXEUXPUVRUDUVIUXDUXPUVRUVIUXDUXPUIZUIZUVRUEBCDEFUVSGUXFUDVBUXFUQUHZUVS
        UXFWMWRURZWSZWTZUQXAZUXFHIJKLMNJXBUWOUYDUSXCXJUWOXDURXEURXFWTZOPQRSAGOX
        GUSUOZUVHUXRTWQAUWLUVHUXRUAWQAUWTUVHUXRUBWQUXSUXPUEUJZUXFUSZUYGWLUSZWMW
        PURZLWHZUYGFUSZUYHUYJFURZUMZNUOZUIZUELVMUVIUXDUXPXHUXOUYPUCUELUCUEWDZUX
        JUYKUXNUYOUYQUXGUYHUXIUYJLUVSUYGUXFVIZUYQUXHUYIWMWPUVSUYGWLVIXIZXKUYQUX
        MUYNNUYQUXKUYLUXLUYMUVSUYGFVIUYQUXGUYHUXIUYJFUYRUYSXLXMWAXNXOWEUVIUXDUX
        PXPUYCIVBIUJZUQUHZUVSUYTWMWRURZWSZWTZUHUYDUXFVUDUQXAUHUDIVBUYBVUCUDIWDU
        XTVUAUYAVUBUVSUXFUYTUQXQUXFUYTWMWRVTXRXTUXFUYCVUDUQXSYAUYEYBAUVDUVGUXRY
        CUVIUVFOUHUXRUVIOUVEUVFAOUVEUHZUVHAUYFGOYDUSUOGOYEUSUOVUETGOYFGOYGGMOPY
        HYIZWGAUVDUVGXHYJWGYKYLYMYNYOYPYQYRYSYTUVIUVQUVOAUVQUVOUPZUUAZUVHAUYFOX
        GUUBZUOVUHTGOXGUUCEUJZUVKUFZDUVNUNZUPVUGEONVUIVUJOUHZVULUVOVUMVUKUVLDUV
        NVUJOUVKUUDUUEUUFQUUGUUHWGUUIUUJUVIUVLUVPDUVNUVIUVJUVNUOZUIZUVLUVEUVKUF
        ZUVPVUOOUVEUVKAVUEUVHVUNVUFWQUUKVUOVUPVUPUVKUVEUFZUIUVPVUOVUQVUPVUNUVJH
        UFZUVDVUQUVIVUNUVJHUVNUVMUVJUVMULUULUUMUUNAUVDUVGXPVURUVDUIUVJMUVJHMUUO
        UUPUUQUURUVEUVKUVCUUSUUTUVAUVB $.
    $}

    $( Generalized Heine-Borel Theorem.  A metric space is compact iff it is
       complete and totally bounded.  See ~ heibor1 and ~ heiborlem1 for a
       description of the proof.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Revised by Mario Carneiro, 28-Jan-2014.) $)
    heibor $p |- ( ( D e. ( Met ` X ) /\ J e. Comp ) <->
                   ( D e. ( CMet ` X ) /\ D e. ( TotBnd ` X ) ) ) $=
      ( vv vm vy vn vt cfv wcel wa cv wceq cfn wrex wral cn0 co ciun vr vu ccmp
      vz vk cme cms ctotbnd heibor1 cmetmet adantr ctop cuni cpw cin wi metxmet
      cxmt mopntop 3syl wf c1 c2 cexp cdiv cbl wex crp istotbnd simprbi nnexpcl
      cn mpan nnrpd rpreccld oveq2 eqeq2d rexbidv ralbidv anbi2d rspccva syl2an
      2nn expcom adantl oveq1 ac6sfi adantrl w3a crn wss simp3l frn syl mopnuni
      3ad2ant1 sseqtrd cmopn cvv fvex eqeltri uniex elpw2 sylibr simp2l wfo wfn
      ffn dffn4 sylib fofi sylan2 syl2anc elin eleq2d rexrn eliun 3bitr4g eqrdv
      sylanbrc simp3r uniiun iuneq2 syl5eq simp2r 3eqtr2rd iuneq1 rspcev 3expia
      adantrrr exlimdv mpd rexlimdvaa syld ralrimdva eqid simpl oveq2d iuneq2dv
      weq pwex inex1 com nn0ennn nnenom entri axcc4 elpwi cmpt2 wn cab copab wb
      syl6 pweqd ineq1d feq3 biimpar adantrr cbviunv id inss1 syl5sseqr syl2anr
      ffvelrnda elpwid sselda simplr ovex ovmpt2 biimprd ralimdva fveq2 iuneq1d
      fss impr eqtrd cbvralv heiborlem10 exp32 ralrimiv ex imp iscmp jca impbii
      syl5 ) ACUFJKZBUCKZLACUGJKZACUHJKZLZABCDUIUWLUWHUWIUWJUWHUWKACUJZUKUWLBUL
      KZBUMZUAMZUMNZUWOEMZUMZNEUWPUNOUOZPZUPZUABUNZQZUWIUWJUWNUWKUWJUWHACURJKZU
      WNUWMACUQZABCDUSUTUKUWJUWKUXDUWJUWKRUWOUNZOUOZFMZVAZCGHMZUXIJZGMZVBVCUXKV
      DSZVESZAVFJZSZTZNZHRQZLZFVGZUXDUWJUWKCGIMZUXQTZNZIUXHPZHRQUYBUWJUWKUYFHRU
      WJUXKRKZLZUWKUBMZUMZCNZUWRUXQNZGCPZEUYIQZLZUBOPZUYFUYGUWKUYPUPUWJUWKUYGUY
      PUWKUYKUWRUXMUWPUXPSZNZGCPZEUYIQZLZUBOPZUAVHQZUXOVHKUYPUYGUWKUWHVUCGUBACE
      UAVIVJUYGUXNUYGUXNVCVLKUYGUXNVLKWCVCUXKVKVMVNVOVUBUYPUAUXOVHUWPUXONZVUAUY
      OUBOVUDUYTUYNUYKVUDUYSUYMEUYIVUDUYRUYLGCVUDUYQUXQUWRUWPUXOUXMUXPVPVQVRVSV
      TVRWAWBWDWEUYHUYOUYFUBOUYHUYIOKZUYOLZLZUYICUXIVAZUWRUWRUXIJZUXOUXPSZNZEUY
      IQZLZFVGZUYFVUFVUNUYHVUEUYNVUNUYKUYLVUKEGUYICFUXMVUINZUXQVUJUWRUXMVUIUXOU
      XPWFZVQWGWHWEVUGVUMUYFFUYHVUEUYKVUMUYFUPUYNUYHVUEUYKLZVUMUYFUYHVUQVUMWIZU
      XIWJZUXHKZCGVUSUXQTZNZUYFVURVUSUXGKZVUSOKZVUTVURVUSUWOWKVVCVURVUSCUWOVURV
      UHVUSCWKUYHVUQVUHVULWLZUYICUXIWMWNUYHVUQCUWONZVUMUWJVVFUYGUWJUWHUXEVVFUWM
      UXFABCDWOUTZUKWPWQVUSUWOBBAWRJWSDAWRWTXAXBZXCXDVURVUEVUHVVDUYHVUEUYKVUMXE
      VVEVUHVUEUYIVUSUXIXFZVVDVUHUXIUYIXGZVVIUYICUXIXHZUYIUXIXIXJUYIVUSUXIXKXLX
      MVUSUXGOXNXTVURVVAEUYIVUJTZUYJCVURVUHVVJVVAVVLNVVEVVKVVJUAVVAVVLVVJUWPUXQ
      KZGVUSPUWPVUJKZEUYIPUWPVVAKUWPVVLKVVMVVNGEUYIUXIVUOUXQVUJUWPVUPXOXPGUWPVU
      SUXQXQEUWPUYIVUJXQXRXSUTVURVULUYJVVLNUYHVUQVUHVULYAVULUYJEUYIUWRTVVLEUYIY
      BEUYIUWRVUJYCYDWNUYHVUEUYKVUMYEYFUYEVVBIVUSUXHUYCVUSNUYDVVACGUYCVUSUXQYGV
      QYHXMYIYJYKYLYMYNYOUYEUXSIUXHFHRUXGOUWOVVHUUAUUBRVLUUCUUDUUEUUFUYCUXLNUYD
      UXRCGUYCUXLUXQYGVQUUGUUNUWJUYAUXDFUWJUYAUXDUWJUYALZUXBUAUXCUWPUXCKUWPBWKZ
      VVOUXBUWPBUUHVVOVVPUWQUXAVVOIUDEUBUDFCRUDMZVBVCUXIVDSZVESZUXPSZUUIZAUWPFU
      EUXIUEMZRKUYCVWBUXIJZKZUYCVWBVWASZUYIUWSWKEUWTPUUJUBUUKZKWIIUEUULZBVWFCDV
      WFYPVWGYPVWAYPZUWJUYAYQUWJUXJRCUNZOUOZUXIVAZUXTUWJVWKUXJUWJVWJUXHNVWKUXJU
      UMUWJVWIUXGOUWJCUWOVVGUUOZUUPVWJUXHRUXIUUQWNUURUUSVVOCIUXLUYCUXKVWASZTZNZ
      HRQZCIVWCVWETZNZUERQUWJUXJUXTVWPUWJUXJLZUXSVWOHRVWSUYGLZVWOUXSVWTVWNUXRCV
      WTVWNGUXLUXMUXKVWASZTUXRIGUXLVWMVXAUYCUXMUXKVWAWFUUTVWTGUXLVXAUXQVWTUXMUX
      LKZLUXMCKUYGVXAUXQNVWTUXLCUXMVWTUXLCVWSRVWIUXKUXIUXJUXJUXHVWIWKRVWIUXIVAU
      WJUXJUVAUWJUXGUXHVWIUXGOUVBVWLUVCRUXHVWIUXIUVOUVDUVEUVFUVGVWSUYGVXBUVHUDF
      UXMUXKCRVVTUXQVWAUXMVVSUXPSVVQUXMVVSUXPWFFHYTZVVSUXOUXMUXPVXCVVRUXNVBVEUX
      IUXKVCVDVPYRYRVWHUXMUXOUXPUVIUVJXMYSYDVQUVKUVLUVPVWOVWRHUERHUEYTZVWNVWQCV
      XDVWNIVWCVWMTVWQVXDIUXLVWCVWMUXKVWBUXIUVMUVNVXDIVWCVWMVWEVXDVWDLUXKVWBUYC
      VWAVXDVWDYQYRYSUVQVQUVRXJUVSUVTUWGUWAUWBYKYNUWCUAEBUWOUWOYPUWDXTUWEUWF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Banach Fixed Point Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d j k x y z D $.  $d j k x y z G $.  $d j k x y z J $.  $d j k w x y ph $.
    $d j k A $.  $d j k w x y z F $.  $d j k x y K $.  $d j k w x y z X $.
    bfp.2 $e |- ( ph -> D e. ( CMet ` X ) ) $.
    bfp.3 $e |- ( ph -> X =/= (/) ) $.
    bfp.4 $e |- ( ph -> K e. RR+ ) $.
    bfp.5 $e |- ( ph -> K < 1 ) $.
    bfp.6 $e |- ( ph -> F : X --> X ) $.
    bfp.7 $e |- ( ( ph /\ ( x e. X /\ y e. X ) ) ->
                  ( ( F ` x ) D ( F ` y ) ) <_ ( K x. ( x D y ) ) ) $.
    ${
      bfp.8 $e |- J = ( MetOpen ` D ) $.
      bfp.9 $e |- ( ph -> A e. X ) $.
      bfp.10 $e |- G = seq 1 ( ( F o. 1st ) , ( NN X. { A } ) ) $.
      $( Lemma for ~ bfp .  The sequence ` G ` , which simply starts from any
         point in the space and iterates ` F ` , satisfies the property that
         the distance from ` G ( n ) ` to ` G ( n + 1 ) ` decreases by at least
         ` K ` after each step.  Thus, the total distance from any ` G ( i ) `
         to ` G ( j ) ` is bounded by a geometric series, and the sequence is
         Cauchy.  Therefore, it converges to a point ` ( ( ~~>t `` J ) `` G ) `
         since the space is complete.  (Contributed by Jeff Madsen,
         17-Jun-2014.) $)
      bfplem1 $p |- ( ph -> G ( ~~>t ` J ) ( ( ~~>t ` J ) ` G ) ) $=
        ( co vk vj clm cfv cdm wcel wbr cms cca cdiv cme cmetmet syl c1 cn nnuz
        cz 1z a1i algrf cr ffvelrnd metcl syl3anc rerpdivcld cv caddc cexp cmul
        cle wi wceq fveq2 oveq1 fveq2d oveq12d oveq2 oveq2d breq12d leidd algr0
        imbi2d 1nn algrp1 mpan2 eqtrd rpred recnd exp1d rpne0d divcan1d 3brtr4d
        wa ffvelrnda wf peano2nn ffvelrn syl2an ralrimivva adantr oveq1d rspc2v
        wral jca sylc remulcld adantl nnnn0d reexpcld letr mpand cc0 clt wb cn0
        nnnn0 reexpcl rpgt0d lemul1 syl112anc mulcomd expp1 eqtr4d bitrd sylan2
        cc mulassd breq1d 3imtr4d expcom a2d impcom geomcau cmetcau syl2anc cha
        nnind wfun cxmt 3syl metxmet methaus lmfun funfvbrb mpbid ) AGHUCUDZUEU
        FZGGUUFUDUUFUGZAEJUHUDUFZGEUIUDUFUUGKADDFUDZETZIUJTZIEUAGJAUUIEJUKUDUFZ
        KEJULUMZADGJFUNUOUPSUNUQUFAURUSZROUTZAUUKIAUUMDJUFUUJJUFUUKVAUFUUNRAJJD
        FORVBDUUJEJVCVDZMVEZMNUAVFZUOUFZAUUSGUDZUUSUNVGTZGUDZETZUULIUUSVHTZVITZ
        VJUGZAUBVFZGUDZUVHUNVGTZGUDZETZUULIUVHVHTZVITZVJUGZVKAUNGUDZUNUNVGTZGUD
        ZETZUULIUNVHTZVITZVJUGZVKAUVGVKZAUVCUVBUNVGTZGUDZETZUULIUVBVHTZVITZVJUG
        ZVKUWCUBUAUUSUVHUNVLZUVOUWBAUWJUVLUVSUVNUWAVJUWJUVIUVPUVKUVREUVHUNGVMUW
        JUVJUVQGUVHUNUNVGVNVOVPUWJUVMUVTUULVIUVHUNIVHVQVRVSWBUVHUUSVLZUVOUVGAUW
        KUVLUVDUVNUVFVJUWKUVIUVAUVKUVCEUVHUUSGVMUWKUVJUVBGUVHUUSUNVGVNVOVPUWKUV
        MUVEUULVIUVHUUSIVHVQVRVSWBZUVHUVBVLZUVOUWIAUWMUVLUWFUVNUWHVJUWMUVIUVCUV
        KUWEEUVHUVBGVMUWMUVJUWDGUVHUVBUNVGVNVOVPUWMUVMUWGUULVIUVHUVBIVHVQVRVSWB
        UWLAUUKUUKUVSUWAVJAUUKUUQVTAUVPDUVRUUJEADGJFUNUOUPSUUORWAZAUVRUVPFUDZUU
        JAUNUOUFUVRUWOVLWCADGJFUNUNUOUPSUUOROWDWEAUVPDFUWNVOWFVPAUWAUULIVITUUKA
        UVTIUULVIAIAIAIMWGZWHZWIVRAUUKIAUUKUUQWHUWQAIMWJWKWFWLUUTAUVGUWIAUUTUVG
        UWIVKAUUTWMZIUVDVITZUWHVJUGZUVAFUDZUVCFUDZETZUWHVJUGZUVGUWIUWRUXCUWSVJU
        GZUWTUXDUWRUVAJUFZUVCJUFZWMBVFZFUDZCVFZFUDZETZIUXHUXJETZVITZVJUGZCJXCBJ
        XCZUXEUWRUXFUXGAUOJUUSGUUPWNZAUOJGWOUVBUOUFZUXGUUTUUPUUSWPZUOJUVBGWQWRZ
        XDAUXPUUTAUXOBCJJPWSWTUXOUXEUXAUXKETZIUVAUXJETZVITZVJUGBCUVAUVCJJUXHUVA
        VLZUXLUYAUXNUYCVJUYDUXIUXAUXKEUXHUVAFVMXAUYDUXMUYBIVIUXHUVAUXJEVNVRVSUX
        JUVCVLZUYAUXCUYCUWSVJUYEUXKUXBUXAEUXJUVCFVMVRUYEUYBUVDIVIUXJUVCUVAEVQVR
        VSXBXEUWRUXCVAUFZUWSVAUFUWHVAUFUXEUWTWMUXDVKUWRUUMUXAJUFUXBJUFUYFAUUMUU
        TUUNWTZUWRJJUVAFAJJFWOUUTOWTZUXQVBUWRJJUVCFUYHUXTVBUXAUXBEJVCVDUWRIUVDA
        IVAUFZUUTUWPWTZUWRUUMUXFUXGUVDVAUFZUYGUXQUXTUVAUVCEJVCVDZXFUWRUULUWGAUU
        LVAUFUUTUURWTZUWRIUVBUYJUWRUVBUUTUXRAUXSXGXHXIXFUXCUWSUWHXJVDXKUWRUVGUV
        DIVITZUVFIVITZVJUGZUWTUWRUYKUVFVAUFUYIXLIXMUGZUVGUYPXNUYLUWRUULUVEUYMAU
        YIUUSXOUFZUVEVAUFUUTUWPUUSXPZIUUSXQWRZXFUYJAUYQUUTAIMXRWTUVDUVFIXSXTUWR
        UYNUWSUYOUWHVJUWRUVDIUWRUVDUYLWHAIYFUFZUUTUWQWTZYAUWRUYOUULUVEIVITZVITU
        WHUWRUULUVEIUWRUULUYMWHUWRUVEUYTWHVUBYGUWRUWGVUCUULVIAVUAUYRUWGVUCVLUUT
        UWQUYSIUUSYBWRVRYCVSYDUWRUWFUXCUWHVJUWRUVCUXAUWEUXBEADGJFUUSUNUOUPSUUOR
        OWDUUTAUXRUWEUXBVLUXSADGJFUVBUNUOUPSUUOROWDYEVPYHYIYJYKYQYLYMEGHJQYNYOA
        HYPUFZUUFYRUUGUUHXNAUUMEJYSUDUFVUDUUNEJUUAEHJQUUBYTHUUCGUUFUUDYTUUE $.

      $( Lemma for ~ bfp .  Using the point found in ~ bfplem1 , we show that
         this convergent point is a fixed point of ` F ` .  Since for any
         positive ` x ` , the sequence ` G ` is in ` B ( x / 2 , P ) ` for all
         ` k e. ( ZZ>= `` j ) ` (where ` P = ( ( ~~>t `` J ) `` G ) ` ), we
         have ` D ( G ( j + 1 ) , F ( P ) ) <_ D ( G ( j ) , P ) < x / 2 ` and
         ` D ( G ( j + 1 ) , P ) < x / 2 ` , so ` F ( P ) ` is in every
         neighborhood of ` P ` and ` P ` is a fixed point of ` F ` .
         (Contributed by Jeff Madsen, 5-Jun-2014.) $)
      bfplem2 $p |- ( ph -> E. z e. X ( F ` z ) = z ) $=
        ( vk clm cfv wcel wceq wrex ctopon wbr cme cxmt cms cmetmet syl metxmet
        vj cv mopntopon 3syl bfplem1 lmcl syl2anc co cc0 cle caddc crp wral clt
        wa c2 cdiv cuz cn c1 adantr nnuz cz 1z a1i eqidd rphalfcl adantl lmmcvg
        simpr ralimi nnz uzid fveq2 oveq1d breq1d rspcv peano2uz algrp1 adantlr
        wi sylibd jcad cr ad2antrr wf algrf ffvelrnda syl3anc ffvelrnd ad2antlr
        metcl rpre lt2halves readdcld mettri2 syl13anc cmul remulcld ralrimivva
        rpred jca oveq1 oveq2d breq12d oveq2 rspc2v sylc 1re metge0 sylancl mpd
        ltle lemul1ad recnd mulid2d letrd leadd1dd lelttr mpand 3syld rexlimdva
        breqtrd syl5 wb 0re syl2an addid2d breqtrrd alrple mpbird letri3 meteq0
        ralrimiva mpbir2and mpbid id eqeq12d rspcev ) AHIUBUCZUCZKUDZUUOGUCZUUO
        UEZDUPZGUCZUUSUEZDKUFAIKUGUCUDZHUUOUUNUHZUUPAFKUIUCUDZFKUJUCUDZUVBAFKUK
        UCUDUVDLFKULUMZFKUNZFIKRUQURABCEFGHIJKLMNOPQRSTUSZUUOHIKUTVAZAUUQUUOFVB
        ZVCUEZUURAUVKUVJVCVDUHZVCUVJVDUHZAUVLUVJVCBUPZVEVBZVDUHZBVFVGZAUVPBVFAU
        VNVFUDZVIZUVJUVNUVOVDUVSUVJUVNVHUHZUVJUVNVDUHZUVSUAUPZHUCZKUDZUWCUUOFVB
        ZUVNVJVKVBZVHUHZVIZUAUOUPZVLUCZVGZUOVMUFUVTUVSUWCFUUOUWFUOUAHIVNKVMRUVS
        UVDUVEAUVDUVRUVFVOUVGUMVPVNVQUDZUVSVRVSUVSUWBVMUDVIUWCVTAUVCUVRUVHVOUVR
        UWFVFUDAUVNWAWBWCUVSUWKUVTUOVMUWKUWGUAUWJVGZUVSUWIVMUDZVIZUVTUWHUWGUAUW
        JUWDUWGWDWEUWOUWMUWIHUCZUUOFVBZUWFVHUHZUWPGUCZUUOFVBZUWFVHUHZVIZUWQUWTV
        EVBZUVNVHUHZUVTUWOUWMUWRUXAUWOUWIVQUDZUWIUWJUDZUWMUWRWOUWNUXEUVSUWIWFWB
        ZUWIWGZUWGUWRUAUWIUWJUWBUWIUEZUWEUWQUWFVHUXIUWCUWPUUOFUWBUWIHWHWIWJWKUR
        UWOUWMUWIVNVEVBZHUCZUUOFVBZUWFVHUHZUXAUWOUXFUXJUWJUDUWMUXMWOUWOUXEUXFUX
        GUXHUMUWIUWIWLUWGUXMUAUXJUWJUWBUXJUEZUWEUXLUWFVHUXNUWCUXKUUOFUWBUXJHWHW
        IWJWKURUWOUXLUWTUWFVHUWOUXKUWSUUOFAUWNUXKUWSUEUVRAEHKGUWIVNVMVPTUWLAVRV
        SZSPWMWNWIWJWPWQUWOUWQWRUDZUWTWRUDZUVNWRUDZUXBUXDWOUWOUVDUWPKUDZUUPUXPA
        UVDUVRUWNUVFWSZUVSVMKUWIHAVMKHWTUVRAEHKGVNVMVPTUXOSPXAVOXBZAUUPUVRUWNUV
        IWSZUWPUUOFKXFXCZUWOUVDUWSKUDZUUPUXQUXTUWOKKUWPGAKKGWTUVRUWNPWSZUYAXDZU
        YBUWSUUOFKXFXCZUVRUXRAUWNUVNXGZXEZUWQUWTUVNXHXCUWOUVJUXCVDUHZUXDUVTUWOU
        VJUWSUUQFVBZUWTVEVBZUXCAUVJWRUDZUVRUWNAUVDUUQKUDZUUPUYMUVFAKKUUOGPUVIXD
        ZUVIUUQUUOFKXFXCZWSZUWOUYKUWTUWOUVDUYDUYNUYKWRUDUXTUYFUWOKKUUOGUYEUYBXD
        ZUWSUUQFKXFXCZUYGXIUWOUWQUWTUYCUYGXIZUWOUVDUYDUYNUUPUVJUYLVDUHUXTUYFUYR
        UYBUUQUUOUWSFKXJXKUWOUYKUWQUWTUYSUYCUYGUWOUYKJUWQXLVBZUWQUYSUWOJUWQAJWR
        UDZUVRUWNAJNXOZWSZUYCXMUYCUWOUXSUUPVIUVNGUCZCUPZGUCZFVBZJUVNVUFFVBZXLVB
        ZVDUHZCKVGBKVGZUYKVUAVDUHZUWOUXSUUPUYAUYBXPAVULUVRUWNAVUKBCKKQXNWSVUKVU
        MUWSVUGFVBZJUWPVUFFVBZXLVBZVDUHBCUWPUUOKKUVNUWPUEZVUHVUNVUJVUPVDVUQVUEU
        WSVUGFUVNUWPGWHWIVUQVUIVUOJXLUVNUWPVUFFXQXRXSVUFUUOUEZVUNUYKVUPVUAVDVUR
        VUGUUQUWSFVUFUUOGWHXRVURVUOUWQJXLVUFUUOUWPFXTXRXSYAYBUWOVUAVNUWQXLVBUWQ
        VDUWOJVNUWQVUDVNWRUDZUWOYCVSUYCUWOUVDUXSUUPVCUWQVDUHUXTUYAUYBUWPUUOFKYD
        XCAJVNVDUHZUVRUWNAJVNVHUHZVUTOAVUBVUSVVAVUTWOVUCYCJVNYGYEYFWSYHUWOUWQUW
        OUWQUYCYIYJYQYKYLYKUWOUYMUXCWRUDUXRUYJUXDVIUVTWOUYQUYTUYIUVJUXCUVNYMXCY
        NYOYRYPYFAUYMUXRUVTUWAWOUVRUYPUYHUVJUVNYGUUAYFUVSUVNUVSUVNUVRUXRAUYHWBY
        IUUBUUCUUHAUYMVCWRUDZUVLUVQYSUYPYTBUVJVCUUDYEUUEAUVDUYNUUPUVMUVFUYOUVIU
        UQUUOFKYDXCAUYMVVBUVKUVLUVMVIYSUYPYTUVJVCUUFYEUUIAUVDUYNUUPUVKUURYSUVFU
        YOUVIUUQUUOFKUUGXCUUJUVAUURDUUOKUUSUUOUEZUUTUUQUUSUUOUUSUUOGWHVVCUUKUUL
        UUMVA $.
    $}

    $( Banach fixed point theorem, also known as contraction mapping theorem.
       A contraction on a complete metric space has a unique fixed point.  We
       show existence in the lemmas, and uniqueness here - if ` F ` has two
       fixed points, then the distance between them is less than ` K ` times
       itself, a contradiction.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Proof shortened by Mario Carneiro, 5-Jun-2014.) $)
    bfp $p |- ( ph -> E! z e. X ( F ` z ) = z ) $=
      ( wcel c1 wbr co cle cc0 vw cv cfv wceq wrex wa weq wi wral c0 wne wex n0
      wreu sylib c1st ccom cn csn cxp cseq cmopn cms adantr crp wf cmul adantlr
      clt eqid simpr bfplem2 exlimddv oveq12 adantl eqbrtrrd cme cr cmetmet syl
      cmin ad2antrr simplrl simplrr metcl syl3anc rpred remulcld suble0d mpbird
      ax-1cn a1i recnd subdird mulid2d oveq1d eqtrd 1re resubcl sylancr 3brtr4d
      mul01d 0re posdif sylancl lemul2 syl112anc metge0 letri3 mpbir2and meteq0
      cc wb mpbid ex ralrimivva fveq2 id eqeq12d anbi1d equequ1 imbi12d ralbidv
      cbvralv reu4 sylanbrc ) ADUBZFUCZYGUDZDHUEZYICUBZFUCZYKUDZUFZDCUGZUHZCHUI
      ZDHUIZYIDHUNAUAUBZHOZYJUAAHUJUKZYTUAULJUAHUMUOAYTUFBCDYSEFFUPUQURYSUSUTPV
      AZEVBUCZGHAEHVCUCOZYTIVDAUUAYTJVDAGVEOYTKVDAGPVIQZYTLVDAHHFVFYTMVDABUBZHO
      ZYKHOZUFZUUFFUCZYLERZGUUFYKERZVGRZSQZYTNVHUUCVJAYTVKUUBVJVLVMAUUJUUFUDZYM
      UFZBCUGZUHZCHUIZBHUIYRAUURBCHHAUUIUFZUUPUUQUUTUUPUFZUULTUDZUUQUVAUVBUULTS
      QZTUULSQZUVAUVCPGWARZUULVGRZUVETVGRZSQZUVAUULUUMWARZTUVFUVGSUVAUVITSQUULU
      UMSQUVAUUKUULUUMSUUPUUKUULUDUUTUUJUUFYLYKEVNVOUUTUUNUUPNVDVPUVAUULUUMUVAE
      HVQUCOZUUGUUHUULVROZAUVJUUIUUPAUUDUVJIEHVSVTWBZAUUGUUHUUPWCZAUUGUUHUUPWDZ
      UUFYKEHWEWFZUVAGUULAGVROZUUIUUPAGKWGZWBZUVOWHWIWJUVAUVFPUULVGRZUUMWARUVIU
      VAPGUULPXLOUVAWKWLUVAGUVRWMUVAUULUVOWMZWNUVAUVSUULUUMWAUVAUULUVTWOWPWQUVA
      UVEUVAUVEAUVEVROZUUIUUPAPVROZUVPUWAWRUVQPGWSWTWBZWMXBXAUVAUVKTVROZUWATUVE
      VIQZUVCUVHXMUVOUWDUVAXCWLUWCAUWEUUIUUPAUUEUWELAUVPUWBUUEUWEXMUVQWRGPXDXEX
      NWBUULTUVEXFXGWJUVAUVJUUGUUHUVDUVLUVMUVNUUFYKEHXHWFUVAUVKUWDUVBUVCUVDUFXM
      UVOXCUULTXIXEXJUVAUVJUUGUUHUVBUUQXMUVLUVMUVNUUFYKEHXKWFXNXOXPUUSYQBDHBDUG
      ZUURYPCHUWFUUPYNUUQYOUWFUUOYIYMUWFUUJYHUUFYGUUFYGFXQUWFXRXSXTBDCYAYBYCYDU
      OYIYMDCHYOYHYLYGYKYGYKFXQYOXRXSYEYF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Euclidean space
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Rn $.
  $( Extend class notation with the n-dimensional Euclidean space. $)
  crrn $a class Rn $.

  ${
    $d i x y k $.
    $( Define n-dimensional Euclidean space as a metric space with the standard
       Euclidean norm given by the quadratic mean.  (Contributed by Jeff
       Madsen, 2-Sep-2009.) $)
    df-rrn $a |- Rn = ( i e. Fin |->
       ( x e. ( RR ^m i ) , y e. ( RR ^m i ) |-> ( sqr `
         sum_ k e. i ( ( ( x ` k ) - ( y ` k ) ) ^ 2 ) ) ) ) $.
  $}

  ${
    $d k n x y G $.  $d f i j k m n x y z I $.  $d j k n M $.  $d j k n x ph $.
    $d k A $.  $d x J $.  $d j k n x y P $.  $d k n R $.  $d f i j k x y z X $.
    $d f j k m n t x y F $.
    rrnval.1 $e |- X = ( RR ^m I ) $.
    $( The n-dimensional Euclidean space.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 13-Sep-2015.) $)
    rrnval $p |- ( I e. Fin -> ( Rn ` I ) = ( x e. X , y e. X |-> ( sqr `
          sum_ k e. I ( ( ( x ` k ) - ( y ` k ) ) ^ 2 ) ) ) ) $=
      ( vi cr cv cmap co cfv csu csqr cmpt2 wf cvv wcel wral cc cmin cexp oveq2
      c2 cfn crrn wceq syl6eqr sumeq1 fveq2d mpt2eq123dv df-rrn cxp crn csn cun
      c0 fvrn0 rgen2w eqid fmpt2 mpbi ovex eqeltri xpex cnex wss sqrf frn ax-mp
      ssexi p0ex unex fex2 mp3an fvmpt ) GDABHGIZJKZVRVQCIZAILVSBILUAKUDUBKZCMZ
      NLZOABEEDVTCMZNLZOZUEUFVQDUGZABVRVRWBEEWDWFVRHDJKZEVQDHJUCFUHZWHWFWAWCNVQ
      DVTCUIUJUKABGCULEEUMZNUNZUQUOZUPZWEPZWIQRWLQRWEQRWDWLRZBESAESWMWNABEENWCU
      RUSABEEWDWLWEWEUTVAVBEEEWGQFHDJVCVDZWOVEWJWKWJTVFTTNPWJTVGVHTTNVIVJVKVLVM
      WIWLWEQQVNVOVP $.

    $( The value of the Euclidean metric.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 13-Sep-2015.) $)
    rrnmval $p |- ( ( I e. Fin /\ F e. X /\ G e. X ) -> ( F ( Rn ` I ) G ) =
        ( sqr ` sum_ k e. I ( ( ( F ` k ) - ( G ` k ) ) ^ 2 ) ) ) $=
      ( vx vy wcel cv cfv cmin co c2 cexp csu csqr cvv wceq fveq1 cfn w3a cmpt2
      crrn rrnval 3ad2ant1 oveqan12d oveq1d sumeq2sdv fveq2d adantl simp2 simp3
      wa fvex a1i ovmpt2d ) DUAIZBEIZCEIZUBZGHBCEEDAJZGJZKZVBHJZKZLMZNOMZAPZQKZ
      DVBBKZVBCKZLMZNOMZAPZQKZDUDKZRURUSVQGHEEVJUCSUTGHADEFUEUFVCBSZVECSZUNZVJV
      PSVAVTVIVOQVTDVHVNAVTVGVMNOVRVSVDVKVFVLLVBVCBTVBVECTUGUHUIUJUKURUSUTULURU
      SUTUMVPRIVAVOQUOUPUQ $.

    $( Euclidean space is a metric space.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 5-Jun-2014.) $)
    rrnmet $p |- ( I e. Fin -> ( Rn ` I ) e. ( Met ` X ) ) $=
      ( vx vy vk wcel cr cfv wf co cc0 wceq caddc wral wa c2 cexp csqr syl crrn
      vz cfn cxp cv wb cle wbr cme cmin cmpt2 simpl cmap simprl syl6eleq elmapi
      csu ffvelrnda simprr resubcld resqcld fsumrecl sqge0d resqrcld ralrimivva
      fsumge0 eqid fmpt2 sylib rrnval feq1d mpbird sqr00 syl2anc bitrd cc recnd
      fsum00 sqeq0 subeq0ad ralbidva rrnmval 3expb eqeq1d wfn ffn eqfnfv simpll
      3bitr4d adantlr simpr trirn npncand oveq1d sumeq2dv fveq2d 3brtr3d adantr
      sqsubswap w3a 3adant3r 3adant3l oveq12d 3expa an32s 3brtr4d ralrimiva jca
      cvv ovex eqeltri ismet ax-mp sylanbrc ) AUCGZBBUDZHAUAIZJZDUEZEUEZXQKZLMZ
      XSXTMZUFZYAUBUEZXSXQKZYEXTXQKZNKZUGUHZUBBOZPZEBODBOZXQBUIIGZXOXRXPHDEBBAF
      UEZXSIZYNXTIZUJKZQRKZFUQZSIZUKZJZXOYTHGZEBODBOUUBXOUUCDEBBXOXSBGZXTBGZPZP
      ZYSUUGAYRFXOUUFULZUUGYNAGZPZYQUUJYOYPUUGAHYNXSUUGXSHAUMKZGAHXSJZUUGXSBUUK
      XOUUDUUEUNCUOXSHAUPTZURZUUGAHYNXTUUGXTUUKGAHXTJZUUGXTBUUKXOUUDUUEUSCUOXTH
      AUPTZURZUTZVAZVBZUUGAYRFUUHUUSUUJYQUURVCZVFZVDVEDEBBYTHUUAUUAVGVHVIXOXPHX
      QUUADEFABCVJVKVLXOYKDEBBUUGYDYJUUGYTLMZYOYPMZFAOZYBYCUUGUVCYRLMZFAOZUVEUU
      GUVCYSLMZUVGUUGYSHGLYSUGUHUVCUVHUFUUTUVBYSVMVNUUGAYRFUUHUUSUVAVRVOUUGUVFU
      VDFAUUJUVFYQLMZUVDUUJYQVPGUVFUVIUFUUJYQUURVQYQVSTUUJYOYPUUJYOUUNVQZUUJYPU
      UQVQZVTVOWAVOUUGYAYTLXOUUDUUEYAYTMZFXSXTABCWBWCZWDUUGXSAWEZXTAWEZYCUVEUFU
      UGUULUVNUUMAHXSWFTUUGUUOUVOUUPAHXTWFTFAXSXTWGVNWIUUGYIUBBUUGYEBGZPZYTAYNY
      EIZYOUJKQRKZFUQZSIZAUVRYPUJKZQRKFUQSIZNKZYAYHUGUVQAYOUVRUJKZUWBNKZQRKZFUQ
      ZSIAUWEQRKZFUQZSIZUWCNKYTUWDUGUVQAUWEUWBFXOUUFUVPWHUVQUUIPZYOUVRUUGUUIYOH
      GUVPUUNWJUVQAHYNYEUVQYEUUKGAHYEJUVQYEBUUKUUGUVPWKCUOYEHAUPTURZUTUWLUVRYPU
      WMUUGUUIYPHGUVPUUQWJUTWLUVQUWHYSSUVQAUWGYRFUWLUWFYQQRUWLYOUVRYPUUGUUIYOVP
      GZUVPUVJWJZUWLUVRUWMVQZUUGUUIYPVPGUVPUVKWJWMWNWOWPUVQUWKUWAUWCNUVQUWJUVTS
      UVQAUWIUVSFUWLUWNUVRVPGUWIUVSMUWOUWPYOUVRWSVNWOWPWNWQUUGUVLUVPUVMWRXOUVPU
      UFYHUWDMZXOUVPUUFUWQXOUVPUUFWTYFUWAYGUWCNXOUVPUUDYFUWAMUUEFYEXSABCWBXAXOU
      VPUUEYGUWCMUUDFYEXTABCWBXBXCXDXEXFXGXHVEBXIGYMXRYLPUFBUUKXICHAUMXJXKDEUBX
      IXQBXLXMXN $.

    rrndstprj1.1 $e |- M = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    $( The distance between two points in Euclidean space is greater than the
       distance between the projections onto one coordinate.  (Contributed by
       Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 13-Sep-2015.) $)
    rrndstprj1 $p |- ( ( ( I e. Fin /\ A e. I ) /\ ( F e. X /\ G e. X
                    ) ) -> ( ( F ` A ) M ( G ` A ) ) <_ ( F ( Rn ` I ) G ) ) $=
      ( vk wcel wa cfv cmin co c2 cexp cle wbr cr wceq cfn cabs csu csqr simpll
      cv crrn cmap simprl syl6eleq elmapi syl ffvelrnda simprr resubcld resqcld
      wf sqge0d oveq12d oveq1d simplr fsumge1 ffvelrnd absresq fsumrecl fsumge0
      fveq2 resqrth syl2anc 3brtr4d recnd abscld resqrcld absge0d le2sqd mpbird
      cc0 sqrge0d remetdval rrnmval 3expb adantlr ) DUAJZADJZKZBFJZCFJZKZKZABLZ
      ACLZMNZUBLZDIUFZBLZWNCLZMNZOPNZIUCZUDLZWJWKENZBCDUGLNZQWIWMWTQRWMOPNZWTOP
      NZQRWIWLOPNZWSXCXDQWIDWRXEIAWCWDWHUEZWIWNDJKZWQXGWOWPWIDSWNBWIBSDUHNZJDSB
      UQWIBFXHWEWFWGUIGUJBSDUKULZUMWIDSWNCWICXHJDSCUQWICFXHWEWFWGUNGUJCSDUKULZU
      MUOZUPZXGWQXKURZWNATZWQWLOPXNWOWJWPWKMWNABVGWNACVGUSUTWCWDWHVAZVBWIWLSJXC
      XETWIWJWKWIDSABXIXOVCZWIDSACXJXOVCZUOZWLVDULWIWSSJVQWSQRXDWSTWIDWRIXFXLVE
      ZWIDWRIXFXLXMVFZWSVHVIVJWIWMWTWIWLWIWLXRVKZVLWIWSXSXTVMWIWLYAVNWIWSXSXTVR
      VOVPWIWJSJWKSJXAWMTXPXQWJWKEHVSVIWCWHXBWTTZWDWCWFWGYBIBCDFGVTWAWBVJ $.

    $( Bound on the distance between two points in Euclidean space given bounds
       on the distances in each coordinate.  This theorem and ~ rrndstprj1 can
       be used to show that the supremum norm and Euclidean norm are
       equivalent.  (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by
       Mario Carneiro, 13-Sep-2015.) $)
    rrndstprj2 $p |- ( ( ( I e. ( Fin \ { (/) } ) /\ F e. X /\ G e. X ) /\
      ( R e. RR+ /\ A. n e. I ( ( F ` n ) M ( G ` n ) ) < R ) ) ->
        ( F ( Rn ` I ) G ) < ( R x. ( sqr ` ( # ` I ) ) ) ) $=
      ( vk wcel cfv co clt wbr c2 cexp cmul wceq cr cfn c0 csn cdif w3a cv wral
      crp crrn cmin csu csqr chash simpl1 eldifad simpl2 simpl3 rrnmval syl3anc
      wa wne eldifsni cmap wf syl6eleq elmapi ffvelrnda resubcld resqcld simprl
      rpred adantr cabs absresq remetdval syl2anc simprr oveq12d breq1d rspccva
      syl fveq2 sylan eqbrtrrd recnd abscld absge0d cc0 cle rpge0d lt2sqd mpbid
      fsumlt fsumrecl sqge0d fsumge0 resqrth cn wb hashnncl mpbird nnrpd oveq2d
      rpcnd mulcomd eqtrd rpsqrcld sqmuld cc fsumconst 3eqtr4d 3brtr4d resqrcld
      rpmulcld sqrge0d eqbrtrd ) EUAUBUCZUDKZCGKZDGKZUEZAUHKZBUFZCLZYCDLZFMZANO
      ZBEUGZUTZUTZCDEUILMZEJUFZCLZYLDLZUJMZPQMZJUKZULLZAEUMLZULLZRMZNYJEUAKZXSX
      TYKYRSYJEUAXQXRXSXTYIUNZUOZXRXSXTYIUPZXRXSXTYIUQZJCDEGHURUSYJYRUUANOYRPQM
      ZUUAPQMZNOYJYQEAPQMZJUKZUUGUUHNYJEYPUUIJUUDYJXREUBVAZUUCEUAUBVBWAZYJYLEKZ
      UTZYOUUNYMYNYJETYLCYJCTEVCMZKETCVDYJCGUUOUUEHVECTEVFWAVGZYJETYLDYJDUUOKET
      DVDYJDGUUOUUFHVEDTEVFWAVGZVHZVIZYJUUITKUUMYJAYJAYAYBYHVJZVKZVIZVLUUNYOVML
      ZPQMZYPUUINUUNYOTKUVDYPSUURYOVNWAUUNUVCANOUVDUUINOUUNYMYNFMZUVCANUUNYMTKY
      NTKUVEUVCSUUPUUQYMYNFIVOVPYJYHUUMUVEANOZYAYBYHVQYGUVFBYLEYCYLSZYFUVEANUVG
      YDYMYEYNFYCYLCWBYCYLDWBVRVSVTWCWDUUNUVCAUUNYOUUNYOUURWEZWFYJATKUUMUVAVLUU
      NYOUVHWGYJWHAWIOUUMYJAUUTWJVLWKWLWDWMYJYQTKWHYQWIOUUGYQSYJEYPJUUDUUSWNZYJ
      EYPJUUDUUSUUNYOUURWOWPZYQWQVPYJUUIYTPQMZRMZYSUUIRMZUUHUUJYJUVLUUIYSRMUVMY
      JUVKYSUUIRYJYSTKWHYSWIOUVKYSSYJYSYJYSYJYSWRKZUUKUULYJUUBUVNUUKWSUUDEWTWAX
      AXBZVKYJYSUVOWJYSWQVPXCYJUUIYSYJUUIUVBWEZYJYSUVOXDXEXFYJAYTYJAUUTXDYJYTYJ
      YSUVOXGZXDXHYJUUBUUIXIKUUJUVMSUUDUVPEUUIJXJVPXKXLYJYRUUAYJYQUVIUVJXMYJUUA
      YJAYTUUTUVQXNZVKYJYQUVIUVJXOYJUUAUVRWJWKXAXP $.

    rrncms.3 $e |- J = ( MetOpen ` ( Rn ` I ) ) $.
    rrncms.4 $e |- ( ph -> I e. Fin ) $.
    rrncms.5 $e |- ( ph -> F e. ( Cau ` ( Rn ` I ) ) ) $.
    rrncms.6 $e |- ( ph -> F : NN --> X ) $.
    rrncms.7 $e |- P = ( m e. I |->
                         ( ~~> ` ( t e. NN |-> ( ( F ` t ) ` m ) ) ) ) $.
    $( Lemma for ~ rrncms .  (Contributed by Jeff Madsen, 6-Jun-2014.)
       (Revised by Mario Carneiro, 13-Sep-2015.) $)
    rrncmslem $p |- ( ph -> F e. dom ( ~~>t ` J ) ) $=
      ( vk cfv wcel cn vx vj vn vy clm wrel wbr cdm lmrel cv crrn clt wral wrex
      co cuz crp cr cmap wf wfn cmpt cli fvex fnmpti a1i wa c1 nnuz cz cvv wceq
      1z weq fveq2 fveq1d eqid fvmpt adantl ffvelrnda syl6eleq elmapi syl an32s
      eqeltrd recnd cmin cabs cca cme cxmt cfn rrnmet eqidd iscauf mpbid adantr
      metxmet cle ad3antrrr simpllr uztrn2 adantll ffvelrnd rrndstprj1 adantllr
      simplr syl3anc wi syl2anc metcl ad2antrr ralimdva remetdval fveq2d breq1d
      reximdva ralbidva rexbidva sylibd ralrimiva sylanbrc wb sylancr mpbird c0
      mpd cc0 csqr csu adantlr simplrr syl6eq simplrl expr rexuz3 ax-mp anassrs
      sylan2 rpcnd syl22anc metsym breqtrd remet simpll lelttr ad2antlr oveq12d
      mpand eqtr4d ralbidv mptex caucvg climdm sylib mpteq2dv breqtrrd climrecl
      rpre nnex ffnfv reex elmapg syl6eleqr 1nn cexp rrnmval sumeq1d sum0 eqtrd
      sqr0 rpgt0d eqbrtrd syl6eqr raleqdv rspcev wne chash cdiv simprl hashnncl
      c2 simprr nnrpd rpsqrcld rpdivcld climi2 syl5bbr rexfiuz syl5bb cmul cdif
      csn rrndstprj2 syl31anc rpne0d divcan1d breq2d pm2.61dne lmmbrf mpbir2and
      eldifsn w3a releldm ) AGUERZUFECUXEUGZEUXEUHSGUIAUXFCISZQUJZERZCFUKRZUOZU
      AUJZULUGZQUBUJZUPRZUMZUBTUNZUAUQUMACURFUSUOZIACUXRSZFURCUTZACFVAZUCUJZCRZ
      URSZUCFUMUXTUYAADFBTDUJZBUJZERZRZVBZVCRZCUYIVCVDPVEVFAUYDUCFAUYBFSZVGZUYC
      QBTUYBUYGRZVBZVHTVIVHVJSZUYLVMVFUYLUYNUYNVCRZUYCVCUYLUYNVCUHSUYNUYPVCUGUY
      LUAUBQUYNVHVKTVIUYLUXHTSZVGZUXHUYNRZUYRUYSUYBUXIRZURUYQUYSUYTVLZUYLBUXHUY
      MUYTTUYNBQVNUYBUYGUXIUYFUXHEVOVPUYNVQZUYBUXIVDVRZVSAUYQUYKUYTURSZAUYQVGZF
      URUYBUXIVUEUXIUXRSFURUXIUTVUEUXIIUXRATIUXHEOVTZJWAUXIURFWBWCVTWDZWEZWFUYL
      UXNERZUXIUXJUOZUXLULUGZQUXOUMZUBTUNZUAUQUMZUYSUXNUYNRZWGUOZWHRZUXLULUGZQU
      XOUMZUBTUNZUAUQUMZAVUNUYKAEUXJWIRSVUNNAUAUXIVUIUXJUBQEVHITVIAUXJIWJRSZUXJ
      IWKRSAFWLSZVVBMFIJWMWCZUXJIWRWCZUYOAVMVFZVUEUXIWNZAUXNTSZVGZVUIWNOWOWPWQU
      YLVUNUYTUYBVUIRZHUOZUXLULUGZQUXOUMZUBTUNZUAUQUMVVAUYLVUMVVNUAUQUYLUXLUQSZ
      VGZVULVVMUBTVVPVVHVGZVUKVVLQUXOVVQUXHUXOSZVGZVVKVUJWSUGZVUKVVLUYLVVHVVRVV
      TVVOUYLVVHVGZVVRVGZVVKUXIVUIUXJUOZVUJWSVWBVVCUYKUXIISZVUIISZVVKVWCWSUGAVV
      CUYKVVHVVRMWTAUYKVVHVVRXAVWBTIUXHEATIEUTZUYKVVHVVROWTZVVHVVRUYQUYLVHUXHUX
      NTVIXBZXCZXDZVWBTIUXNEVWGUYLVVHVVRXGXDZUYBUXIVUIFHIJKXEUUAVWBVVBVWDVWEVWC
      VUJVLAVVBUYKVVHVVRVVDWTZVWJVWKUXIVUIUXJIUUBXHUUCXFVVSVVKURSZVUJURSZUXLURS
      ZVVTVUKVGVVLXIUYLVVHVVRVWMVVOVWBHURWJRSZVUDVVJURSZVWMVWPVWBHKUUDVFVWBUYLU
      YQVUDUYLVVHVVRUUEVWIVUGXJZVWAVWQVVRAVVHUYKVWQVVIFURUYBVUIVVIVUIUXRSFURVUI
      UTVVIVUIIUXRATIUXNEOVTJWAVUIURFWBWCVTWDWQZUYTVVJHURXKXHXFUYLVVHVVRVWNVVOV
      WBVVBVWEVWDVWNVWLVWKVWJVUIUXIUXJIXKXHXFVVPVWOVVHVVRVVOVWOUYLUXLUUSVSXLVVK
      VUJUXLUUFXHUUIXMXQXMUYLVVNVUTUAUQUYLVVMVUSUBTVWAVVLVURQUXOVWBVVKVUQUXLULV
      WBVVKUYTVVJWGUOZWHRZVUQVWBVUDVWQVVKVXAVLVWRVWSUYTVVJHKXNXJVWBVUPVWTWHVWBU
      YSUYTVUOVVJWGVWBUYQVUAVWIVUCWCVVHVUOVVJVLUYLVVRBUXNUYMVVJTUYNBUBVNUYBUYGV
      UIUYFUXNEVOVPVUBUYBVUIVDVRUUGUUHXOUUJXPXRXSUUKXTYGUYNVKSUYLBTUYMUUTUULVFU
      UMUYNUUNUUOUYKUYCUYPVLADUYBUYJUYPFCDUCVNZUYIUYNVCVXBBTUYHUYMUYEUYBUYGVOUU
      PXOPUYNVCVDVRVSUUQZVUHUURZYAUCFURCUVAYBAURVKSVVCUXSUXTYCUVBMURFCVKWLUVCYD
      YEJUVDZAUXQUAUQAVVOVGUXQFYFAVVOFYFVLZUXQAVVOVXFVGZVGZVHTSUXMQTUMZUXQUVEVX
      HUXMQTVXHUYQVGZUXKYHUXLULVXJUXKYHYIRZYHVXJUXKFUDUJZUXIRVXLCRWGUOUWBUVFUOZ
      UDYJZYIRZVXKVXJVVCVWDUXGUXKVXOVLAVVCVXGUYQMXLAUYQVWDVXGVUFYKAUXGVXGUYQVXE
      XLUDUXICFIJUVGXHVXJVXNYHYIVXJVXNYFVXMUDYJYHVXJFYFVXMUDAVVOVXFUYQYLUVHVXMU
      DUVIYMXOUVJUVKYMVXJUXLAVVOVXFUYQYNUVLUVMYAUXPVXIUBVHTUXNVHVLZUXMQUXOTVXPU
      XOVHUPRTUXNVHUPVOVIUVNUVOUVPYDYOAVVOFYFUVQZUXQAVVOVXQVGZVGZUYTUYCHUOZUXLF
      UVRRZYIRZUVSUOZULUGZUCFUMZQUXOUMZUBTUNZUXQVXSVYGVYDQUXOUMZUBVJUNZUCFUMZVX
      SVYIUCFVXSUYKVGZVYIUYTUYCWGUOWHRZVYCULUGZQUXOUMZUBTUNZVYKUYCUYTVYCUBQUYNV
      HTVIUYOVYKVMVFVXSVYCUQSZUYKVXSUXLVYBAVVOVXQUVTVXSVYAVXSVYAVXSVYATSZVXQAVV
      OVXQUWCVXSVVCVYQVXQYCAVVCVXRMWQZFUWAWCYEUWDUWEZUWFZWQUYQVUAVYKVUCVSAUYKUY
      NUYCVCUGVXRVXCYKUWGVYIVYHUBTUNZVYKVYOUYOWUAVYIYCVMVYDUBQVHTVIYPYQVYKVYHVY
      NUBTVYKVVHVGVYDVYMQUXOVYKVVHVVRVYDVYMYCZVVHVVRVGZVYKUYQWUBVWHVYKUYQVGZVXT
      VYLVYCULWUDVUDUYDVXTVYLVLAUYKUYQVUDVXRVUGXFVYKUYDUYQAUYKUYDVXRVXDYKWQUYTU
      YCHKXNXJXPYSYRXRXSUWHYEYAVYGVYFUBVJUNZVXSVYJUYOVYGWUEYCVMVYEUBQVHTVIYPYQV
      XSVVCWUEVYJYCVYRVYDFUBQUCUWIWCUWJYEVXSVYFUXPUBTVXSVVHVGVYEUXMQUXOVXSVVHVV
      RVYEUXMXIZWUCVXSUYQWUFVWHVXSUYQVGZVYEUXKVYCVYBUWKUOZULUGZUXMWUGFWLYFUWMUW
      LSZVWDUXGVYPVYEWUIXIWUGVVCVXQWUJAVVCVXRUYQMXLAVVOVXQUYQYLFWLYFUXBYBVXSTIU
      XHEAVWFVXROWQVTAUXGVXRUYQVXEXLVXSVYPUYQVYTWQWUJVWDUXGUXCVYPVYEWUIVYCUCUXI
      CFHIJKUWNYOUWOWUGWUHUXLUXKULWUGUXLVYBWUGUXLAVVOVXQUYQYNYTWUGVYBVXSVYBUQSU
      YQVYSWQZYTWUGVYBWUKUWPUWQUWRXTYSYRXMXQYGYOUWSYAAUAUXIUXJCUBQEGVHITLVVEVIV
      VFVVGOUWTUXAECUXEUXDYD $.
  $}

  ${
    $d f m t I $.  $d f X $.
    rrncms.1 $e |- X = ( RR ^m I ) $.
    $( Euclidean space is complete.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Revised by Mario Carneiro, 13-Sep-2015.) $)
    rrncms $p |- ( I e. Fin -> ( Rn ` I ) e. ( CMet ` X ) ) $=
      ( vf vt vm cfn wcel crrn cfv cms cn cv wf cmopn wa cmpt cr eqid c1 clm wi
      cdm cca wral cli cabs cmin ccom cxp cres simpll simplr simpr rrncmslem ex
      ralrimiva nnuz cz 1z a1i rrnmet iscmet3 mpbird ) AGHZAIJZBKJHLBDMZNZVGVFO
      JZUAJUCHZUBZDVFUDJZUEVEVKDVLVEVGVLHZPZVHVJVNVHPEFAELFMEMVGJJQUFJQZFVGAVIU
      GUHUIRRUJUKZBCVPSVISZVEVMVHULVEVMVHUMVNVHUNVOSUOUPUQVEVFDVITBLURVQTUSHVEU
      TVAABCVBVCVD $.
  $}

  ${
    $d k r z F $.  $d k r z G $.  $d k r z I $.  $d k r z ph $.  $d k r z X $.
    $d k r D $.
    rrnequiv.y $e |- Y = ( ( CCfld |`s RR ) ^s I ) $.
    rrnequiv.d $e |- D = ( dist ` Y ) $.
    rrnequiv.1 $e |- X = ( RR ^m I ) $.
    $( The supremum metric on ` RR ^ I ` is a metric.  (Contributed by Jeff
       Madsen, 15-Sep-2015.) $)
    repwsmet $p |- ( I e. Fin -> D e. ( Met ` X ) ) $=
      ( vk cfn wcel ccnfld csca cfv cr cds cbs cme cvv eqid wceq cress co cprds
      csn cabs cmin ccom cres cmpt fconstmpt oveq2i ax-resscn cnfldbas ressbas2
      cxp cc wss ax-mp reex cnfldds ressds reseq1i fvex a1i id cv wa ovex remet
      prdsmet resssca pwsval mpan fveq2d syl5eq cmap pwsbas eqtrd 3eltr4d ) BIJ
      ZKLMZBKNUAUBZUDUOZUCUBZOMZWDPMZQMACQMVTHWFWEWBWAUEUFUGZNNUOZUHZBNRWDRWCHB
      WBUIWAUCHBWBUJUKWFSNUPUQNWBPMTULNUPWBKWBSZUMUNURZWGWBOMZWHNRJZWGWLTUSNWGK
      WBRWJUTVAURVBWESWARJVTKLVCVDVTVEWBRJZVTHVFBJVGZKNUAVHZVDWINQMJWOWIWISVIVD
      VJVTADOMWEFVTDWDOWNVTDWDTWPWBWABRIDEWMWAWBLMTUSNWAKWBRWJWASVKURVLVMZVNVOV
      TCWFQVTCNBVPUBZWFGVTWRDPMZWFWNVTWRWSTWPNWBBRIDEWKVQVMVTDWDPWQVNVRVOVNVS
      $.

    rrnequiv.i $e |- ( ph -> I e. Fin ) $.
    $( The supremum metric on ` RR ^ I ` is equivalent to the ` Rn ` metric.
       (Contributed by Jeff Madsen, 15-Sep-2015.) $)
    rrnequiv $p |- ( ( ph /\ ( F e. X /\ G e. X ) ) ->
      ( ( F D G ) <_ ( F ( Rn ` I ) G ) /\
        ( F ( Rn ` I ) G ) <_ ( ( sqr ` ( # ` I ) ) x. ( F D G ) ) ) ) $=
      ( vk wcel co cfv cle wbr cr cvv adantr vz vr wa crrn chash csqr cmul cabs
      cv cmin ccom cxp cres cmpt crn cc0 csn cun cxr clt csup ccnfld csca cress
      cprds cds wceq ovex reex resssca ax-mp pwsval sylancr fveq2d syl5eq oveqd
      cfn eqid cbs fconstmpt oveq2i fvex a1i ralrimiva simprl cmap cc ax-resscn
      cnfldbas ressbas2 pwsbas eleqtrd simprr cnfldds ressds reseq1i prdsdsval3
      eqtrd wral rrndstprj1 an32s sylanl1 wb rgenw breq1 ralrnmpt sylibr rrnmet
      wss cme metge0 elsni breq1d syl5ibrcom ralrimiv ralunb sylanbrc prdsbascl
      syl syl3anc wf r19.21bi metcl syl2anc ressxr sseldi mpbird eqbrtrd c0 wfn
      syl6eleq elmapi ffn 3syl caddc crp readdcld lelttrd ad2antrr recnd mp3an1
      remet fmptd frn syl6ss 0xr snssd supxrleub rzal eqfnfv syl5ibr imp oveq1d
      met0 cn0 hashcl nn0red nn0ge0d resqrcld repwsmet sqrge0d mulge0d remulcld
      unssd rpre ad2antll cdiv cdif eldifsn cn hashnncl nnrpd rpsqrcld rpdivcld
      wne rpred 0re ltaddrpd elrpd adantlr ssun1 simpr elrnmpt1 sylancl supxrub
      breqtrrd rrndstprj2 syl32anc adddird mulcomd rpne0d oveq12d breqtrd ltled
      divcan1d anassrs alrple pm2.61dane jca ) ACFMZDFMZUCZUCZCDBNZCDEUDOZNZPQU
      XFEUEOZUFOZUXDUGNZPQZUXCUXDLELUIZCOZUXKDOZUHUJUKZRRULZUMZNZUNZUOZUPUQZURZ
      USUTVAZUXFPUXCUXDCDVBVCOZEVBRVDNZUQULZVENZVFOZNUYBUXCBUYGCDUXCBGVFOUYGIUX
      CGUYFVFUXCUYDSMZEVQMZGUYFVGVBRVDVHZAUYIUXBKTZUYDUYCESVQGHRSMZUYCUYDVCOVGV
      IRUYCVBUYDSUYDVRZUYCVRVJVKVLVMZVNVOVPUXCLUYFVSOZUYGUYDUYCUXPCDERSVQSUYFUY
      ELEUYDUNUYCVELEUYDVTWAZUYOVRZUYCSMUXCVBVCWBWCZUYKUXCUYHLEUYHUXCUXKEMZUCZU
      YJWCWDZUXCCFUYOAUWTUXAWEZUXCFREWFNZUYOJUXCVUCGVSOZUYOUXCUYHUYIVUCVUDVGUYJ
      UYKRUYDESVQGHRWGXIRUYDVSOVGWHRWGUYDVBUYMWIWJVKZWKVMUXCGUYFVSUYNVNWRVOZWLZ
      UXCDFUYOAUWTUXAWMZVUFWLZVUEUXNUYDVFOZUXOUYLUXNVUJVGVIRUXNVBUYDSUYMWNWOVKW
      PUYGVRWQWRZUXCUYBUXFPQZUAUIZUXFPQZUAUYAWSZUXCVUNUAUXSWSZVUNUAUXTWSVUOUXCU
      XQUXFPQZLEWSZVUPUXCVUQLEAUYIUXBUYSVUQKUYIUYSUXBVUQUXKCDEUXPFJUXPVRZWTXAXB
      WDUXQSMZLEWSVUPVURXCVUTLEUXLUXMUXPVHZXDVUNVUQLUAEUXQUXRSUXRVRZVUMUXQUXFPX
      EXFVKXGUXCVUNUAUXTUXCVUNVUMUXTMZUPUXFPQZUXCUXEFXJOZMZUWTUXAVVDUXCUYIVVFUY
      KEFJXHXSZVUBVUHCDUXEFXKXTVVCVUMUPUXFPVUMUPXLXMXNXOVUNUAUXSUXTXPXQUXCUYAUS
      XIZUXFUSMVULVUOXCUXCUXSUXTUSUXCUXSRUSUXCERUXRYAUXSRXIUXCLEUXQRUXRUYTUXLRM
      ZUXMRMZUXQRMZUXCVVILEUXCLUYOUYDUYCCERSVQSUYFUYPUYQUYRUYKVUAVUEVUGXRYBUXCV
      VJLEUXCLUYOUYDUYCDERSVQSUYFUYPUYQUYRUYKVUAVUEVUIXRYBUXPRXJOMVVIVVJVVKUXPV
      USUUBUXLUXMUXPRYCUUAYDZVVBUUCERUXRUUDXSYEUUEUXCUPUSUPUSMUXCUUFWCUUGUVDZUX
      CRUSUXFYEUXCVVFUWTUXAUXFRMZVVGVUBVUHCDUXEFYCXTZYFUAUYAUXFUUHYDYGYHUXCUXJE
      YIUXCEYIVGZUCZUXFDDUXENZUXIPVVQCDDUXEUXCVVPCDVGZVVPVVSUXCUXLUXMVGZLEWSZVV
      TLEUUIUXCCEYJZDEYJZVVSVWAXCUXCCVUCMERCYAVWBUXCCFVUCVUBJYKCREYLERCYMYNUXCD
      VUCMERDYAVWCUXCDFVUCVUHJYKDREYLERDYMYNLECDUUJYDUUKUULUUMUXCVVRUXIPQVVPUXC
      VVRUPUXIPUXCVVFUXAVVRUPVGVVGVUHDUXEFUUNYDUXCUXHUXDUXCUXGUXCUXGUXCUYIUXGUU
      OMUYKEUUPXSZUUQZUXCUXGVWDUURZUUSZUXCBVVEMZUWTUXAUXDRMZUXCUYIVWHUYKBEFGHIJ
      UUTXSZVUBVUHCDBFYCXTZUXCUXGVWEVWFUVAUXCVWHUWTUXAUPUXDPQZVWJVUBVUHCDBFXKXT
      ZUVBYHTYHUXCEYIUVOZUCZUXJUXFUXIUBUIZYONZPQZUBYPWSZVWOVWRUBYPUXCVWNVWPYPMZ
      VWRUXCVWNVWTUCZUCZUXFVWQUXCVVNVXAVVOTVXBUXIVWPUXCUXIRMZVXAUXCUXHUXDVWGVWK
      UVCZTVWTVWPRMUXCVWNVWPUVEUVFZYQVXBUXFUXDVWPUXHUVGNZYONZUXHUGNZVWQUTVXBEVQ
      YIUQUVHMZUWTUXAVXGYPMUXQVXGUTQZLEWSUXFVXHUTQVXBUYIVWNVXIUXCUYIVXAUYKTZUXC
      VWNVWTWEZEVQYIUVIXQUXCUWTVXAVUBTUXCUXAVXAVUHTVXBVXGVXBUXDVXFUXCVWIVXAVWKT
      ZVXBVXFVXBVWPUXHUXCVWNVWTWMVXBUXGVXBUXGVXBUXGUVJMZVWNVXLVXBUYIVXNVWNXCVXK
      EUVKXSYGUVLUVMZUVNZUVPZYQZVXBUPUXDVXGUPRMVXBUVQWCVXMVXRUXCVWLVXAVWMTVXBUX
      DVXFVXMVXPUVRZYRUVSVXBVXJLEVXBUYSUCZUXQUXDVXGUXCUYSVVKVXAVVLUVTVXBVWIUYSV
      XMTVXBVXGRMUYSVXRTVXTUXQUYBUXDPVXTVVHUXQUYAMUXQUYBPQUXCVVHVXAUYSVVMYSVXTU
      XSUYAUXQUXSUXTUWAVXTUYSVUTUXQUXSMVXBUYSUWBVVALEUXQUXRSVVBUWCUWDYFUYAUXQUW
      EYDUXCUXDUYBVGVXAUYSVUKYSUWFVXBUXDVXGUTQUYSVXSTYRWDVXGLCDEUXPFJVUSUWGUWHV
      XBVXHUXDUXHUGNZVXFUXHUGNZYONVWQVXBUXDVXFUXHVXBUXDVXMYTZVXBVXFVXQYTVXBUXHU
      XCUXHRMVXAVWGTYTZUWIVXBVYAUXIVYBVWPYOVXBUXDUXHVYCVYDUWJVXBVWPUXHVXBVWPVXE
      YTVYDVXBUXHVXOUWKUWOUWLWRUWMUWNUWPWDUXCUXJVWSXCZVWNUXCVVNVXCVYEVVOVXDUBUX
      FUXIUWQYDTYGUWRUWS $.
  $}

  ${
    $d x y I $.  $d x y M $.  $d x y Y $.
    rrntotbnd.1 $e |- X = ( RR ^m I ) $.
    rrntotbnd.2 $e |- M = ( ( Rn ` I ) |` ( Y X. Y ) ) $.
    $( A set in Euclidean space is totally bounded iff its is bounded.
       (Contributed by Jeff Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro,
       16-Sep-2015.) $)
    rrntotbnd $p |- ( I e. Fin ->
                      ( M e. ( TotBnd ` Y ) <-> M e. ( Bnd ` Y ) ) ) $=
      ( vx vy wcel cr co cfv c1 eqid syl cle wbr wa cmul adantr cfn ccnfld cpws
      cress cds cxp cres chash csqr caddc crrn repwsmet rrnmet cn0 hashcl nn0re
      nn0ge0 resqrcld cc0 sqrge0d ge0p1rpd crp 1rp a1i cv cme metcl 3expb sylan
      simprl simprr w3a metge0 jca syl3anc simpld remulcld peano2re id rrnequiv
      simprd lep1d lemul1a syl31anc letrd recnd mulid2d breqtrrd cc wss ctotbnd
      cbnd wb ax-resscn cnpwstotbnd mpan equivbnd2 ) AUAIZGHUBJUDKAUCKZUELZDDUF
      UGZBAUHLZUILZMUJKZMWTAUKLZCDWTACWSWSNZWTNZEULZACEUMZWRXCWRXBUNIZXCJIZAUOZ
      XJXBXBUPZXBUQZUROZWRXJUSXCPQXLXJXBXMXNUTOVAMVBIWRVCVDWRGVEZCIZHVEZCIZRZRZ
      XPXRXEKZXCXPXRWTKZSKZXDYCSKZWRXECVFLZIZXTYBJIZXIYGXQXSYHXPXRXECVGVHVIZYAX
      CYCWRXKXTXOTZYAYCJIZUSYCPQZYAWTYFIZXQXSYKYLRZWRYMXTXHTWRXQXSVJWRXQXSVKYMX
      QXSVLYKYLXPXRWTCVGXPXRWTCVMVNVOZVPZVQYAXDYCWRXDJIZXTWRXKYQXOXCVROTZYPVQYA
      YCYBPQZYBYDPQZWRWTXPXRACWSXFXGEWRVSVTZWAYAXKYQYNXCXDPQYDYEPQYJYRYOYAXCYJW
      BXCXDYCWCWDWEYAYCYBMYBSKPYAYSYTUUAVPYAYBYAYBYIWFWGWHXANZFJWIWJWRXADWKLIXA
      DWLLIWMWNJXAADWSXFUUBWOWPWQ $.
  $}

  ${
    rrnheibor.1 $e |- X = ( RR ^m I ) $.
    rrnheibor.2 $e |- M = ( ( Rn ` I ) |` ( Y X. Y ) ) $.
    rrnheibor.3 $e |- T = ( MetOpen ` M ) $.
    rrnheibor.4 $e |- U = ( MetOpen ` ( Rn ` I ) ) $.
    $( Heine-Borel theorem for Euclidean space.  A subset of Euclidean space is
       compact iff it is closed and bounded.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Revised by Mario Carneiro, 22-Sep-2015.) $)
    rrnheibor $p |- ( ( I e. Fin /\ Y C_ X ) ->
               ( T e. Comp <-> ( Y e. ( Clsd ` U ) /\ M e. ( Bnd ` Y ) ) ) ) $=
      ( cfn wcel wss wa ccmp cms cfv cme wb adantr ctotbnd ccld cbnd rrnmet cxp
      crrn cres syl5eqel sylan biantrurd heibor syl6bb eleq1i rrncms cmetss syl
      metres2 syl5bb rrntotbnd anbi12d bitrd ) CKLZFEMZNZAOLZDFPQZLZDFUAQLZNZFB
      UBQLZDFUCQLZNVDVEDFRQZLZVENVIVDVMVEVBCUFQZERQLZVCVMCEGUDVOVCNDVNFFUEUGZVL
      HVNFEUQUHUIUJDAFIUKULVDVGVJVHVKVGVPVFLZVDVJDVPVFHUMVDVNEPQLZVQVJSVBVRVCCE
      GUNTVNBEFJUOUPURVBVHVKSVCCDEFGHUSTUTVA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Intervals (continued)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k x y z A $.  $d k y z F $.  $d y z R $.  $d k y z V $.
    ismrer1.1 $e |- R = ( ( abs o. - ) |` ( RR X. RR ) ) $.
    ismrer1.2 $e |- F = ( x e. RR |-> ( { A } X. { x } ) ) $.
    $( An isometry between ` RR ` and ` RR ^ 1 ` .  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Mario Carneiro, 22-Sep-2015.) $)
    ismrer1 $p |- ( A e. V -> F e. ( R Ismty ( Rn ` { A } ) ) ) $=
      ( vy vz vk wcel cr csn co cfv wceq syl cmin c2 cexp cmap wf1o crrn cismty
      cv wral cxp cmpt wb sneq xpeq1d mpteq2dv syl6eqr f1oeq1 oveq2d bitrd eqid
      f1oeq3 reex vex mapsnf1o3 vtoclg wa csqr cabs cc xpeq2d snex xpex fvmpt3i
      csu fveq1d adantr snidg fvconst2g sylancr sylan9eqr adantl oveq12d oveq1d
      cvv resubcl absresq eqtr4d recnd abscld sqcld eqeltrd fveq2 syldan fveq2d
      sumsn eqtrd absge0d sqrsqd wf f1of ffvelrnda anim12dan cfn rrnmval mp3an1
      snfi remetdval 3eqtr4rd ralrimivva cxmt rexmet cme rrnmet metxmet isismty
      mp2b mp2an sylanbrc ) BEKZLLBMZUANZDUBZHUEZIUEZCNZXTDOZYADOZXQUCOZNZPZILU
      FHLUFZDCYEUDNKZLLXTMZUANZALYJAUEZMZUGZUHZUBZXSHBEXTBPZYPLYKDUBZXSYQYODPYP
      YRUIYQYOALXQYMUGZUHDYQALYNYSYQYJXQYMXTBUJZUKULGUMLYKYODUNQYQYKXRPYRXSUIYQ
      YJXQLUAYTUOYKXRLDURQUPALYJYOXTYJUQUSHUTZYOUQVAVBZXPYGHILLXPXTLKZYALKZVCZV
      CZXQJUEZYCOZUUGYDOZRNZSTNZJVKZVDOZXTYARNZVEOZYFYBUUFUUMUUOSTNZVDOUUOUUFUU
      LUUPVDUUFUULBYCOZBYDOZRNZSTNZUUPXPUUEUUTVFKUULUUTPUUFUUTUUPVFUUFUUTUUNSTN
      ZUUPUUFUUSUUNSTUUFUUQXTUURYARUUEXPUUQBXQYJUGZOZXTUUCUUQUVCPUUDUUCBYCUVBAX
      TYSUVBLDYLXTPYMYJXQYLXTUJVGGXQYMBVHYLVHVIZVJVLVMXPXTWAKBXQKZUVCXTPUUABEVN
      ZXQXTBWAVOVPVQUUEXPUURBXQYAMZUGZOZYAUUDUURUVIPUUCUUDBYDUVHAYAYSUVHLDYLYAP
      YMUVGXQYLYAUJVGGUVDVJVLVRXPYAWAKUVEUVIYAPIUTUVFXQYABWAVOVPVQVSVTUUFUUNLKZ
      UUPUVAPUUEUVJXPXTYAWBVRZUUNWCQWDZUUFUUOUUFUUOUUFUUNUUFUUNUVKWEZWFZWEWGWHU
      UKUUTJBEUUGBPZUUJUUSSTUVOUUHUUQUUIUURRUUGBYCWIUUGBYDWIVSVTWLWJUVLWMWKUUFU
      UOUVNUUFUUNUVMWNWOWMUUFYCXRKZYDXRKZVCYFUUMPZXPUUCUVPUUDUVQXPLXRXTDXPXSLXR
      DWPUUBLXRDWQQZWRXPLXRYADUVSWRWSXQWTKZUVPUVQUVRBXCZJYCYDXQXRXRUQZXAXBQUUEY
      BUUOPXPXTYACFXDVRXEXFCLXGOKYEXRXGOKZYIXSYHVCUICFXHUVTYEXRXIOKUWCUWAXQXRUW
      BXJYEXRXKXMHIDCYELXRXLXNXO $.
  $}

  ${
    $d R x y z $.
    reheibor.2 $e |- M = ( ( abs o. - ) |` ( Y X. Y ) ) $.
    reheibor.3 $e |- T = ( MetOpen ` M ) $.
    reheibor.4 $e |- U = ( topGen ` ran (,) ) $.
    $( Heine-Borel theorem for real numbers.  A subset of ` RR ` is compact iff
       it is closed and bounded.  (Contributed by Jeff Madsen, 2-Sep-2009.)
       (Revised by Mario Carneiro, 22-Sep-2015.) $)
    reheibor $p |- ( Y C_ RR -> ( T e. Comp <->
                               ( Y e. ( Clsd ` U ) /\ M e. ( Bnd ` Y ) ) ) ) $=
      ( cr wss c1o cfv c0 cxp cres wcel co wb cismty eqid cxmt vx vy vz crrn cv
      csn cmpt cima cmopn ccmp ccld cbnd wa cfn cmap df1o2 snfi eqeltri imassrn
      crn wf1o wf cabs cmin ccom wceq wral cvv 0ex ax-mp fveq2i oveq2i eleqtrri
      ismrer1 rexmet cme rrnmet metxmet mp2b isismty mp2an mpbi simpli f1of frn
      sstri a1i rrnheibor sylancr chmph wbr chmeo cc cnxmet id ax-resscn syl6ss
      xmetres2 syl5eqel syl2anc ismtyres syl22anc xpss12 anidms resabs1 syl6eqr
      ismtyhmeo syl oveq1d eleqtrd sseldd hmphi cmphmph hmphsym impbid cioo ctg
      wi tgioo sselii ctopon retopon toponunii hmeocld ismtybnd syl3anc anbi12d
      eqtri 3bitr4d ) DHIZJUDKZUAHLUFZUAUEUFMUGZDUHZYNMNZUIKZUJOZYNYKUIKZUKKOZY
      OYNULKOZUMZAUJOZDBUKKOZCDULKOZUMYJJUNOZYNHJUOPZIZYQUUAQJYLUNUPLUQURZUUGYJ
      YNYMUTZUUFYMDUSHUUFYMVAZHUUFYMVBUUIUUFIUUJUBUEZUCUEZVCVDVEZHHMZNZPUUKYMKU
      ULYMKYKPVFUCHVGUBHVGZYMUUOYKRPZOZUUJUUPUMZYMUUOYLUDKZRPZUUQLVHOYMUVAOVIUA
      LUUOYMVHUUOSZYMSVNVJYKUUTUUORJYLUDUPVKVLVMZUUOHTKOZYKUUFTKOZUURUUSQUUOUVB
      VOZUUEYKUUFVPKOUVEUUHJUUFUUFSZVQYKUUFVRVSZUBUCYMUUOYKHUUFVTWAWBWCHUUFYMWD
      HUUFYMWEVSWFWGZYPYRJYOUUFYNUVGYOSZYPSZYRSZWHWIYJAYPWJWKZUUBYQQYJYMDNZAYPW
      LPZOUVMYJCYORPZUVOUVNYJCDTKZOZYOYNTKOZUVPUVOIYJCUUMDDMZNZUVQEYJUUMWMTKODW
      MIUWAUVQOWNYJDHWMYJWOZWPWQUUMDWMWRWIWSZYJUVEUUGUVSUVHUVIYKYNUUFWRWIZAYPCY
      ODYNFUVKXGWTYJUVNUUOUVTNZYORPZUVPYJUVDUVEUURYJUVNUWFOUVDYJUVFWGUVEYJUVHWG
      UURYJUVCWGUWBDYNUWEYOYMUUOYKHUUFYNSUWESUVJXAXBYJUWECYORYJUWEUWACYJUVTUUNI
      ZUWEUWAVFYJUWGDHDHXCXDUUMUVTUUNXEXHEXFXIXJZXKUVNAYPXLXHUVMUUBYQAYPXMUVMYP
      AWJWKYQUUBXRAYPXNYPAXMXHXOXHYJUUCYSUUDYTYJYMBYRWLPZOYJUUCYSQUUQUWIYMUVDUV
      EUUQUWIIUVFUVHBYRUUOYKHUUFBXPUTXQKZUUOUIKZGUUOUWKUVBUWKSXSYHUVLXGWAUVCXTU
      WBDYMBYRHHBBUWJHYAKGYBURYCYDWIYJUVRUVSUVNUVPOUUDYTQUWCUWDUWHUVNCYODYNYEYF
      YGYI $.
  $}

  ${
    $d r x y A $.  $d r x y B $.  $d r x y J $.  $d r x y M $.
    iccbnd.1 $e |- J = ( A [,] B ) $.
    iccbnd.2 $e |- M = ( ( abs o. - ) |` ( J X. J ) ) $.
    $( A closed interval in ` RR ` is bounded.  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 22-Sep-2015.) $)
    iccbnd $p |- ( ( A e. RR /\ B e. RR ) -> M e. ( Bnd ` J ) ) $=
      ( vx vy vr cr wcel wa cfv cv co cle wbr wral cmin cc wrex cbnd cabs cnmet
      cme ccom cxp cres cicc iccssre syl5eqss ax-resscn syl6ss metres2 syl5eqel
      wss sylancr resubcl ancoms oveqi wceq adantl syl5eq sselda anim12dan eqid
      ovres cnmetdval eqtrd caddc simprr syl6eleq wb elicc2 adantr mpbid simp1d
      syl w3a simpll simprl simplr simp3d lesub1dd subled simp2d letrd readdcld
      syl2anc lesub2dd lesubadd2d absdifled mpbir2and ralrimivva breq2 2ralbidv
      eqbrtrd rspcev isbnd3b sylanbrc ) AJKZBJKZLZDCUEMZKGNZHNZDOZINZPQZHCRGCRZ
      IJUAZDCUBMKXCDUCSUFZCCUGUHZXDFXCXLTUEMKCTUPXMXDKUDXCCJTXCCABUIOZJEABUJUKU
      LUMZXLCTUNUQUOXCBASOZJKZXGXPPQZHCRGCRZXKXBXAXQBAURUSZXCXRGHCCXCXECKZXFCKZ
      LZLZXGXEXFSOUCMZXPPYDXGXEXFXLOZYEYDXGXEXFXMOZYFDXMXEXFFUTYCYGYFVAXCXEXFCC
      XLVGVBVCYDXETKZXFTKZLYFYEVAXCYAYHYBYIXCCTXEXOVDXCCTXFXOVDVEXEXFXLXLVFVHVR
      VIYDYEXPPQXFXPSOZXEPQXEXFXPVJOZPQYDYJAXEYDXFJKZXQYJJKYDYLAXFPQZXFBPQZYDXF
      XNKZYLYMYNVSZYDXFCXNXCYAYBVKEVLXCYOYPVMYCABXFVNVOVPZVQZXCXQYCXTVOZXFXPURW
      IXAXBYCVTZYDXEJKZAXEPQZXEBPQZYDXEXNKZUUAUUBUUCVSZYDXECXNXCYAYBWAEVLXCUUDU
      UEVMYCABXEVNVOVPZVQZYDXFAXPYRYTYSYDXFBAYRXAXBYCWBZYTYDYLYMYNYQWCWDWEYDUUA
      UUBUUCUUFWFWGYDXEBYKUUGUUHYDXFXPYRYSWHYDUUAUUBUUCUUFWCYDBXFSOXPPQBYKPQYDA
      XFBYTYRUUHYDYLYMYNYQWFWJYDBXFXPUUHYRYSWKVPWGYDXEXFXPUUGYRYSWLWMWQWNXJXSIX
      PJXHXPVAXIXRGHCCXHXPXGPWOWPWRWIIGHDCWSWT $.
  $}

  ${
    icccmpALT.1 $e |- J = ( A [,] B ) $.
    icccmpALT.2 $e |- M = ( ( abs o. - ) |` ( J X. J ) ) $.
    icccmpALT.3 $e |- T = ( MetOpen ` M ) $.
    $( A closed interval in ` RR ` is compact.  Alternate proof of ~ icccmp
       using the Heine-Borel theorem ~ heibor .  (Contributed by Jeff Madsen,
       2-Sep-2009.)  (Proof shortened by Mario Carneiro, 14-Aug-2014.) $)
    icccmpALT $p |- ( ( A e. RR /\ B e. RR ) -> T e. Comp ) $=
      ( cr wcel wa ccmp cioo crn ctg cfv ccld cbnd cicc co icccld iccbnd wss wb
      syl5eqel iccssre syl5eqss eqid reheibor syl mpbir2and ) AIJBIJKZCLJZDMNOP
      ZQPZJZEDRPJZULDABSTZUOFABUAUEABDEFGUBULDIUCUMUPUQKUDULDURIFABUFUGCUNEDGHU
      NUHUIUJUK $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Groups and related structures
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    exidcl.1 $e |- X = ran G $.
    $( Closure of the binary operation of a magma with identity.  (Contributed
       by Jeff Madsen, 16-Jun-2011.) $)
    exidcl $p |- ( ( G e. ( Magma i^i ExId ) /\ A e. X /\ B e. X )
                                            -> ( A G B ) e. X ) $=
      ( cmagm cexid cin w3a co cdm wa crn rngopid syl5eq eleq2d anbi12d pm5.32i
      wcel inss1 sseli eqid clmgm syl3an1 3expb sylbi 3impb 3ad2ant1 eleqtrrd
      wceq ) CFGHZSZADSZBDSZIABCJZCKKZDULUMUNUOUPSZULUMUNLZLULAUPSZBUPSZLZLUQUL
      URVAULUMUSUNUTULDUPAULDCMUPECNOZPULDUPBVBPQRULUSUTUQULCFSUSUTUQUKFCFGTUAA
      BCUPUPUBUCUDUEUFUGULUMDUPUJUNVBUHUI $.
  $}

  ${
    $d G x $.  $d Y x $.  $d X x $.  $d U u x y $.  $d H u x y $.
    exidres.1 $e |- X = ran G $.
    exidres.2 $e |- U = ( GId ` G ) $.
    exidres.3 $e |- H = ( G |` ( Y X. Y ) ) $.
    $( Lemma for ~ exidres and ~ exidresid .  (Contributed by Jeff Madsen,
       8-Jun-2010.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    exidreslem $p |- ( ( G e. ( Magma i^i ExId ) /\ Y C_ X /\ U e. Y ) ->
                              ( U e. dom dom H /\ A. x e. dom dom H
                            ( ( U H x ) = x /\ ( x H U ) = x ) ) ) $=
      ( wcel wss cdm co wceq wa wral cxp sylib syl5eq dmeqd cmagm cexid cin w3a
      cv cres dmeqi xpss12 anidms wfo wf opidon2 fof fdm sseq2d syl5ibr ssdmres
      3syl imp dmxpid syl6eq eleq2d biimp3ar cmpidelt sylan2 anassrs adantrl wb
      ssel2 oveqi eqeq1d ancoms anbi12d adantl mpbird ralrimiva 3adant3 raleqdv
      ovres 3impa jca ) CUAUBUCJZFEKZBFJZUDZBDLZLZJZBAUEZDMZWINZWIBDMZWINZOZAWG
      PZWBWCWHWDWBWCOZWGFBWPWGFFQZLZFWPWFWQWPWFCWQUFZLZWQDWSIUGZWPWQCLZKZWTWQNZ
      WBWCXCWCXCWBWQEEQZKZWCXFFEFEUHUIWBXBXEWQWBXEECUJXEECUKXBXENCEGULXEECUMXEE
      CUNURUOUPUSZWQCUQZRSTFUTZVAVBVCWEWOWNAFPZWBWCWDXJWPWDOWNAFWPWDWIFJZWNWPWD
      XKOZOWNBWICMZWINZWIBCMZWINZOZWPXKXQWDWBWCXKXQWCXKOWBWIEJXQFEWIVIWIBCEGHVD
      VEVFVGXLWNXQVHWPXLWKXNWMXPXLWJXMWIXLWJBWIWSMXMDWSBWIIVJBWIFFCVSSVKXLWLXOW
      IXKWDWLXONXKWDOWLWIBWSMXODWSWIBIVJWIBFFCVSSVLVKVMVNVOVFVPVTWEWNAWGFWEWGWR
      FWEWFWQWEWFWTWQXAWEXCXDWBWCXCWDXGVQXHRSTXIVAVRVOWA $.

    $( The restriction of a binary operation with identity to a subset
       containing the identity has an identity element.  (Contributed by Jeff
       Madsen, 8-Jun-2010.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    exidres $p |- ( ( G e. ( Magma i^i ExId ) /\ Y C_ X /\ U e. Y )
                                                      -> H e. ExId ) $=
      ( vu vx cexid wcel cv co wceq wa cdm wral eqeq1d cvv cmagm cin exidreslem
      wss w3a wrex oveq1 anbi12d ralbidv rspcev syl wb cxp cres resexg syl5eqel
      oveq2 eqid isexid 3ad2ant1 mpbird ) BUAKUBZLZEDUDZAELZUEZCKLZIMZJMZCNZVIO
      ZVIVHCNZVIOZPZJCQQZRZIVOUFZVFAVOLAVICNZVIOZVIACNZVIOZPZJVORZPVQJABCDEFGHU
      CVPWCIAVOVHAOZVNWBJVOWDVKVSVMWAWDVJVRVIVHAVICUGSWDVLVTVIVHAVICUQSUHUIUJUK
      VCVDVGVQULZVEVCCTLWEVCCBEEUMZUNTHBWFVBUOUPIJTCVOVOURUSUKUTVA $.

    $( The restriction of a binary operation with identity to a subset
       containing the identity has the same identity element.  (Contributed by
       Jeff Madsen, 8-Jun-2010.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    exidresid $p |- ( ( ( G e. ( Magma i^i ExId ) /\ Y C_ X /\ U e. Y ) /\
                                        H e. Magma ) -> ( GId ` H ) = U ) $=
      ( vu vx cmagm cexid wcel wa cv co wceq wral cvv adantr cin wss w3a resexg
      cgi cfv crn crio cxp cres syl5eqel eqid gidval 3ad2ant1 exidreslem simprd
      syl cdm exidres elin rngopid sylbir ancoms sylan raleqdv mpbird wb simpld
      wreu exidu1 oveq1 eqeq1d oveq2 anbi12d ralbidv riota2 syl2anc mpbid eqtrd
      eleqtrrd ) BKLUAZMZEDUBZAEMZUCZCKMZNZCUEUFZIOZJOZCPZWJQZWJWICPZWJQZNZJCUG
      ZRZIWPUHZAWEWHWRQZWFWBWCWSWDWBCSMWSWBCBEEUIZUJSHBWTWAUDUKJICSWPWPULZUMUQU
      NTWGAWJCPZWJQZWJACPZWJQZNZJWPRZWRAQZWGXGXFJCURURZRZWEXJWFWEAXIMZXJJABCDEF
      GHUOZUPTWGXFJWPXIWECLMZWFWPXIQZABCDEFGHUSZWFXMXNWFXMNZCWAMZXNCKLUTZCVAVBV
      CVDZVEVFWGAWPMWQIWPVIZXGXHVGWGAXIWPWEXKWFWEXKXJXLVHTXSVTWEXMWFXTXOWFXMXTX
      PXQXTXRJICWPXAVJVBVCVDWQXGIWPAWIAQZWOXFJWPYAWLXCWNXEYAWKXBWJWIAWJCVKVLYAW
      MXDWJWIAWJCVMVLVNVOVPVQVRVS $.
  $}

  ${
    abl4pnp.1 $e |- X = ran G $.
    abl4pnp.2 $e |- D = ( /g ` G ) $.
    $( A commutative/associative law for Abelian groups.  (Contributed by Jeff
       Madsen, 11-Jun-2010.) $)
    ablo4pnp $p |- ( ( G e. AbelOp /\ ( ( A e. X /\ B e. X ) /\
                  ( C e. X /\ F e. X ) ) ) -> ( ( A G B ) D ( C G F ) ) =
                                            ( ( A D C ) G ( B D F ) ) ) $=
      ( cablo wcel wa co wceq w3a 3expib anim1d 3anass imp syldan df-3an oveq1d
      ablomuldiv sylan2br adantrrr cgr wi ablogrpo grpocl syl syl6ibr grpodivcl
      ablodivdiv4 an4 3imtr4g grpomuldivass sylan 3eqtr3d ) FJKZAGKZBGKZLZCGKZE
      GKZLZLZLZABFMZCDMZEDMZACDMZBFMZEDMZVHCEFMDMZVKBEDMFMZVGVIVLEDUSVBVCVIVLNZ
      VDVBVCLUSUTVAVCOVPUTVAVCUAABCDFGHIUCUDUEUBUSVFVHGKZVCVDOZVJVNNUSVFVRUSVFV
      QVELVRUSVBVQVEUSFUFKZVBVQUGFUHZVSUTVAVQABFGHUIPUJQVQVCVDRUKSVHCEDFGHIUMTU
      SVSVFVMVONZVTVSVFVKGKZVAVDOZWAVSVFWCVSUTVCLZVAVDLZLWBWELVFWCVSWDWBWEVSUTV
      CWBACDFGHIULPQUTVAVCVDUNWBVAVDRUOSVKBEDFGHIUPTUQUR $.
  $}

  ${
    grpeqdivid.1 $e |- X = ran G $.
    grpeqdivid.2 $e |- U = ( GId ` G ) $.
    grpeqdivid.3 $e |- D = ( /g ` G ) $.
    $( Two group elements are equal iff their quotient is the identity.
       (Contributed by Jeff Madsen, 6-Jan-2011.) $)
    grpoeqdivid $p |- ( ( G e. GrpOp /\ A e. X /\ B e. X ) ->
                                              ( A = B <-> ( A D B ) = U ) ) $=
      ( cgr wcel w3a wceq grpodivid 3adant2 oveq1 eqeq1d syl5ibrcom grponpcan
      co grpolid eqeq12d syl5ib impbid ) EJKZAFKZBFKZLZABMZABCTZDMZUHUKUIBBCTZD
      MZUEUGUMUFBCDEFGIHNOUIUJULDABBCPQRUKUJBETZDBETZMUHUIUJDBEPUHUNAUOBABCEFGI
      SUEUGUOBMUFBDEFGHUAOUBUCUD $.
  $}

  ${
    $d F x y $.  $d G x y $.  $d H x y $.  $d X x y $.
    ghomf.1 $e |- X = ran G $.
    ghomf.2 $e |- W = ran H $.
    $( Mapping property of a group homomorphism.  (Contributed by Jeff Madsen,
       1-Dec-2009.) $)
    ghomf $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) )
                                                  -> F : X --> W ) $=
      ( vx vy cgr wcel cghom co wf wa cv cfv wceq wral elghom simprbda 3impa )
      BJKZCJKZABCLMKZEDANZUCUDOUEUFHPZAQIPZAQCMUGUHBMAQRIESHESHIABCDEFGTUAUB $.
  $}

  ${
    $d S u v x y $.  $d T u v x y $.  $d G u v x y $.  $d H u v x y $.
    $d K u v x y $.
    $( The composition of two group homomorphisms is a group homomorphism.
       (Contributed by Jeff Madsen, 1-Dec-2009.)  (Revised by Mario Carneiro,
       27-Dec-2014.) $)
    ghomco $p |- ( ( ( G e. GrpOp /\ H e. GrpOp /\ K e. GrpOp ) /\
                    ( S e. ( G GrpOpHom H ) /\ T e. ( H GrpOpHom K ) ) ) ->
                                      ( T o. S ) e. ( G GrpOpHom K ) ) $=
      ( vx vy vu vv cgr wcel cghom co wa cv cfv wceq wral wi ad2ant2r wf ancoms
      w3a crn fco a1i ffvelrn anim12da fveq2 oveq1d oveq1 fveq2d eqeq12d oveq2d
      ccom oveq2 rspc2va sylan an32s adantllr sylan9eq anasss ad2ant2rl oveq12d
      fvco3 adantlr eqid grpocl 3expb sylan2 anassrs 3eqtr4d ralimdva com23 imp
      expr ex com12 3ad2ant1 wb elghom 3adant3 3adant1 anbi12d 3adant2 3imtr4d
      jcad ) CJKZDJKZEJKZUCZACDLMKZBDELMKZNZBAUOZCELMKZWKCUDZDUDZAUAZFOZAPZGOZA
      PZDMZWTXBCMZAPZQZGWQRZFWQRZNZWREUDZBUAZHOZBPZIOZBPZEMZXMXODMZBPZQZIWRRHWR
      RZNZNZWQXKWOUAZWTWOPZXBWOPZEMZXEWOPZQZGWQRZFWQRZNZWNWPWKYCYDYKYCYDSWKWSXL
      YDXIYAXLWSYDWQWRXKBAUEUBTUFWHWIYCYKSWJYCWHYKWSYBXIWHYKSZWSYBNXIYMWSXLYAXI
      YMSWSXLNZYANZWHXIYKYOWHXIYKSZYNWHYAYPYNWHNZYANZXHYJFWQYRWTWQKZNXGYIGWQYRY
      SXBWQKZXGYISYRYSYTNZXGYIYRUUAXGNNXABPZXCBPZEMZXFBPZYGYHYRUUAXGUUDUUEQYRUU
      ANXGUUDXDBPZUUEYNYAUUAUUDUUFQZWHWSYAUUAUUGXLWSUUAYAUUGWSUUANXAWRKZXCWRKZN
      YAUUGWSYSYTUUHUUIWQWRWTAUGWQWRXBAUGUHXTUUGUUBXPEMZXAXODMZBPZQHIXAXCWRWRXM
      XAQZXQUUJXSUULUUMXNUUBXPEXMXABUIUJUUMXRUUKBXMXAXODUKULUMXOXCQZUUJUUDUULUU
      FUUNXPUUCUUBEXOXCBUIUNUUNUUKXDBXOXCXADUPULUMUQURUSUTUTXDXFBUIVAVBYQUUAYGU
      UDQZYAXGYNUUAUUOWHYNUUANYEUUBYFUUCEWSYSYEUUBQXLYTWQWRWTBAVETWSYTYFUUCQXLY
      SWQWRXBBAVEVCVDVFTYQUUAYHUUEQZYAXGYNWHUUAUUPWHUUANYNXEWQKZUUPWHYSYTUUQWTX
      BCWQWQVGZVHVIWSUUQUUPXLWQWRXEBAVEVFVJVKTVLVPVKVMVMUSVQVNVBVOUSVRVSWGWKWLX
      JWMYBWHWIWLXJVTWJFGACDWRWQUURWRVGZWAWBWIWJWMYBVTWHHIBDEXKWRUUSXKVGZWAWCWD
      WHWJWPYLVTWIFGWOCEXKWQUURUUTWAWEWFVO $.
  $}

  ${
    ghomdiv.1 $e |- X = ran G $.
    ghomdiv.2 $e |- D = ( /g ` G ) $.
    ghomdiv.3 $e |- C = ( /g ` H ) $.
    $( Group homomorphisms preserve division.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    ghomdiv $p |- ( ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) /\
                                ( A e. X /\ B e. X ) ) ->
                      ( F ` ( A D B ) ) = ( ( F ` A ) C ( F ` B ) ) ) $=
      ( cgr wcel co wa cfv wceq ffvelrnda grponpcan 3ad2antl1 cghom simpl2 eqid
      w3a crn ghomf adantrr adantrl syl3anc fveq2d grpodivcl simprr jca ghomlin
      3expb eqcomd syldan 3eqtr2rd wb grporcan syl13anc mpbid ) FLMZGLMZEFGUANM
      ZUDZAHMZBHMZOZOZABDNZEPZBEPZGNZAEPZVMCNZVMGNZQZVLVPQZVJVQVOVKBFNZEPZVNVJV
      DVOGUEZMZVMWBMZVQVOQVCVDVEVIUBZVFVGWCVHVFHWBAEEFGWBHIWBUCZUFZRUGZVFVHWDVG
      VFHWBBEWGRUHZVOVMCGWBWFKSUIVJVTAEVCVDVIVTAQZVEVCVGVHWJABDFHIJSUOTUJVFVIVK
      HMZVHOZWAVNQVCVDVIWLVEVCVIOWKVHVCVGVHWKABDFHIJUKUOZVCVGVHULUMTVFWLOVNWAVK
      BEFGHIUNUPUQURVJVDVLWBMZVPWBMZWDVRVSUSWEVFVIWKWNVCVDVIWKVEWMTVFHWBVKEWGRU
      QVJVDWCWDWOWEWHWIVOVMCGWBWFKUKUIWIVLVPVMGWBWFUTVAVB $.
  $}

  ${
    $d G x y $.  $d H x y $.  $d F x y $.  $d U x y $.  $d W x y $.
    $d X x y $.
    grpkerinj.1 $e |- X = ran G $.
    grpkerinj.2 $e |- W = ( GId ` G ) $.
    grpkerinj.3 $e |- Y = ran H $.
    grpkerinj.4 $e |- U = ( GId ` H ) $.
    $( A group homomorphism is injective if and only if its kernel is zero.
       (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    grpokerinj $p |- ( ( G e. GrpOp /\ H e. GrpOp /\ F e. ( G GrpOpHom H ) ) ->
                      ( F : X -1-1-> Y <-> ( `' F " { U } ) = { W } ) ) $=
      ( vx vy wcel co csn cima wceq wa cfv cgr cghom w3a wf1 ccnv ghomid wfn wf
      sneqd ghomf ffn syl grpoidcl 3ad2ant1 fnsnfv syl2anc eqtr3d imaeq2d snssd
      adantl wss f1imacnv sylan2 eqtrd expcom cv wi adantr cgs simpl2 ffvelrnda
      wral adantrr adantrl eqid grpoeqdivid syl3anc adantlr ghomdiv eqeq1d fvex
      cgi cvv eqeltri snid eleq1 mpbiri wfun cdm ffun grpodivcl 3expb 3ad2antl1
      wb fdm eleqtrrd fvimacnv eleq2 sylan9bb an32s biimprd syl5 sylbid sylbird
      elsni ralrimivva dff13 sylanbrc ex impbid ) CUANZDUANZBCDUBONZUCZFGBUDZBU
      EZAPZQZEPZRZXOXNXTXOXNSXRXPBXSQZQZXSXNXRYBRXOXNXQYAXPXNEBTZPZXQYAXNYCAAEB
      CDIKUFUIXNBFUGZEFNZYDYARXNFGBUHZYEBCDGFHJUJZFGBUKULXKXLYFXMECFHIUMZUNFEBU
      OUPUQURUTXNXOXSFVAZYBXSRXKXLYJXMXKEFYIUSUNFGXSBVBVCVDVEXNXTXOXNXTSZYGLVFZ
      BTZMVFZBTZRZYLYNRZVGZMFVLLFVLXOXNYGXTYHVHYKYRLMFFYKYLFNZYNFNZSZSZYPYMYODV
      ITZOZARZYQXNUUAYPUUEWNZXTXNUUASZXLYMGNZYOGNZUUFXKXLXMUUAVJXNYSUUHYTXNFGYL
      BYHVKVMXNYTUUIYSXNFGYNBYHVKVNYMYOUUCADGJKUUCVOZVPVQVRUUBUUEYLYNCVITZOZBTZ
      ARZYQUUBUUMUUDAXNUUAUUMUUDRXTYLYNUUCUUKBCDFHUUKVOZUUJVSVRVTUUNUUMXQNZUUBY
      QUUNUUPAXQNAADWBTWCKDWBWAWDWEUUMAXQWFWGUUBUUPUULXSNZYQXNUUAXTUUPUUQWNUUGU
      UPUULXRNZXTUUQUUGBWHZUULBWIZNUUPUURWNXNUUSUUAXNYGUUSYHFGBWJULVHUUGUULFUUT
      XKXLUUAUULFNZXMXKYSYTUVAYLYNUUKCFHUUOWKWLWMXNUUTFRZUUAXNYGUVBYHFGBWOULVHW
      PUULXQBWQUPXRXSUULWRWSWTXNUUAUUQYQVGXTUUQUULERZUUGYQUULEXEXKXLUUAUVCYQVGZ
      XMXKYSYTUVDXKYSYTUCYQUVCYLYNUUKECFHIUUOVPXAWLWMXBVRXCXBXDXCXFLMFGBXGXHXIX
      J $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    ringnegcl.1 $e |- G = ( 1st ` R ) $.
    ringnegcl.2 $e |- X = ran G $.
    ringnegcl.3 $e |- N = ( inv ` G ) $.
    $( A ring is closed under negation.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    rngonegcl $p |- ( ( R e. RingOps /\ A e. X ) -> ( N ` A ) e. X ) $=
      ( crngo wcel cgr cfv rngogrpo grpoinvcl sylan ) BIJCKJAEJADLEJBCFMACDEGHN
      O $.

    ${
      ringaddneg.4 $e |- Z = ( GId ` G ) $.
      $( Adding the negative in a ring gives zero.  (Contributed by Jeff
         Madsen, 10-Jun-2010.) $)
      rngoaddneg1 $p |- ( ( R e. RingOps /\ A e. X )
            -> ( A G ( N ` A ) ) = Z ) $=
        ( crngo wcel cgr cfv co wceq rngogrpo grporinv sylan ) BKLCMLAELAADNCOF
        PBCGQAFCDEHJIRS $.

      $( Adding the negative in a ring gives zero.  (Contributed by Jeff
         Madsen, 10-Jun-2010.) $)
      rngoaddneg2 $p |- ( ( R e. RingOps /\ A e. X )
             -> ( ( N ` A ) G A ) = Z ) $=
        ( crngo wcel cgr cfv co wceq rngogrpo grpolinv sylan ) BKLCMLAELADNACOF
        PBCGQAFCDEHJIRS $.
    $}

    ringsub.4 $e |- D = ( /g ` G ) $.
    $( Subtraction in a ring, in terms of addition and negation.  (Contributed
       by Jeff Madsen, 19-Jun-2010.) $)
    rngosub $p |- ( ( R e. RingOps /\ A e. X /\ B e. X )
                                        -> ( A D B ) = ( A G ( N ` B ) ) ) $=
      ( crngo wcel cgr co cfv wceq rngogrpo grpodivval syl3an1 ) DLMENMAGMBGMAB
      COABFPEOQDEHRABCEFGIJKST $.
  $}

  ${
    ringneg.1 $e |- G = ( 1st ` R ) $.
    ringneg.2 $e |- H = ( 2nd ` R ) $.
    ringneg.3 $e |- X = ran G $.
    ringneg.4 $e |- N = ( inv ` G ) $.
    ringneg.5 $e |- U = ( GId ` H ) $.
    $( Negation in a ring is the same as left multiplication by ` -u 1 ` .
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    rngonegmn1l $p |- ( ( R e. RingOps /\ A e. X ) ->
                                            ( N ` A ) = ( ( N ` U ) H A ) ) $=
      ( wcel wa cfv co wceq crn mpdan adantr crngo cgi c1st rneqi eqtri rngo1cl
      rngonegcl jca rngodir 3exp2 imp42 eqid rngoaddneg1 oveq1d rngolz rngolidm
      an32s eqtrd 3eqtr3rd rngocl 3expa cgr rngogrpo grpoinvid1 syl3an1 mpd3an3
      wb mpbird ) BUAMZAGMZNZAFOCFOZAEPZQZAVMDPZDUBOZQZVKCVLDPZAEPZCAEPZVMDPZVP
      VOVKCGMZVLGMZNZVSWAQZVIWDVJVIWBWCBCEGGDRBUCOZRJDWFHUDUEZILUFZVIWBWCWHCBDF
      GHJKUGSZUHTVIWDVJWEVIWBWCVJWEVIWBWCVJWECVLABDEGHIJUIUJUKUQSVKVSVPAEPVPVKV
      RVPAEVIVRVPQZVJVIWBWJWHCBDFGVPHJKVPULZUMSTUNABDEGVPWKJHIUOURVKVTAVMDABCEG
      IWGLUPUNUSVIVJVMGMZVNVQVGZVKWCWLVIWCVJWITVIWCVJWLVIWCVJWLVLABDEGHIJUTVAUQ
      SVIDVBMVJWLWMBDHVCAVMVPDFGJWKKVDVEVFVH $.

    $( Negation in a ring is the same as right multiplication by ` -u 1 ` .
       (Contributed by Jeff Madsen, 19-Jun-2010.) $)
    rngonegmn1r $p |- ( ( R e. RingOps /\ A e. X ) ->
                                            ( N ` A ) = ( A H ( N ` U ) ) ) $=
      ( wcel wa cfv co wceq crn mpdan adantr crngo cgi c1st rneqi eqtri rngo1cl
      rngonegcl jca rngodi 3exp2 imp43 rngoaddneg2 oveq2d rngorz eqtrd rngoridm
      eqid 3eqtr3rd wb rngocl mpd3an3 cgr rngogrpo grpoinvid2 syl3an1 mpbird )
      BUAMZAGMZNZAFOACFOZEPZQZVKADPZDUBOZQZVIAVJCDPZEPZVKACEPZDPZVNVMVIVJGMZCGM
      ZNVQVSQZVIVTWAVGVTVHVGWAVTBCEGGDRBUCOZRJDWCHUDUEZILUFZCBDFGHJKUGSTZVGWAVH
      WETUHVGVHVTWAWBVGVHVTWAWBAVJCBDEGHIJUIUJUKSVIVQAVNEPVNVIVPVNAEVGVPVNQZVHV
      GWAWGWECBDFGVNHJKVNUQZULSTUMABDEGVNWHJHIUNUOVIVRAVKDABCEGIWDLUPUMURVGVHVK
      GMZVLVOUSZVGVHVTWIWFAVJBDEGHIJUTVAVGDVBMVHWIWJBDHVCAVKVNDFGJWHKVDVEVAVF
      $.
  $}

  ${
    ringnegmul.1 $e |- G = ( 1st ` R ) $.
    ringnegmul.2 $e |- H = ( 2nd ` R ) $.
    ringnegmul.3 $e |- X = ran G $.
    ringnegmul.4 $e |- N = ( inv ` G ) $.
    $( Negation of a product in a ring.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    rngoneglmul $p |- ( ( R e. RingOps /\ A e. X /\ B e. X )
                                -> ( N ` ( A H B ) ) = ( ( N ` A ) H B ) ) $=
      ( crngo wcel w3a cfv co wceq wi crn rngonegmn1l cgi c1st rneqi eqtri eqid
      rngo1cl rngonegcl mpdan rngoass 3exp2 3imp 3adant3 oveq1d wa rngocl 3expb
      mpd syldan 3impb 3eqtr4rd ) CLMZAGMZBGMZNZEUAOZFOZAEPZBEPZVFABEPZEPZAFOZB
      EPVIFOZVAVBVCVHVJQZVAVFGMZVBVCVMRRVAVEGMVNCVEEGGDSCUBOZSJDVOHUCUDIVEUEZUF
      VECDFGHJKUGUHVAVNVBVCVMVFABCDEGHIJUIUJUQUKVDVKVGBEVAVBVKVGQVCACVEDEFGHIJK
      VPTULUMVAVBVCVLVJQZVAVBVCUNVIGMZVQVAVBVCVRABCDEGHIJUOUPVICVEDEFGHIJKVPTUR
      USUT $.

    $( Negation of a product in a ring.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    rngonegrmul $p |- ( ( R e. RingOps /\ A e. X /\ B e. X )
                                -> ( N ` ( A H B ) ) = ( A H ( N ` B ) ) ) $=
      ( crngo wcel w3a co cfv wceq wi crn rngonegmn1r cgi c1st rneqi eqtri eqid
      rngo1cl rngonegcl mpdan rngoass 3exp2 com24 com34 mpd rngocl 3expb syldan
      3imp wa 3impb 3adant2 oveq2d 3eqtr4d ) CLMZAGMZBGMZNZABEOZEUAPZFPZEOZABVI
      EOZEOZVGFPZABFPZEOVCVDVEVJVLQZVCVIGMZVDVEVORRVCVHGMVPCVHEGGDSCUBPZSJDVQHU
      CUDIVHUEZUFVHCDFGHJKUGUHVCVPVEVDVOVCVDVEVPVOVCVDVEVPVOABVICDEGHIJUIUJUKUL
      UMUQVCVDVEVMVJQZVCVDVEURVGGMZVSVCVDVEVTABCDEGHIJUNUOVGCVHDEFGHIJKVRTUPUSV
      FVNVKAEVCVEVNVKQVDBCVHDEFGHIJKVRTUTVAVB $.
  $}

  ${
    ringsubdi.1 $e |- G = ( 1st ` R ) $.
    ringsubdi.2 $e |- H = ( 2nd ` R ) $.
    ringsubdi.3 $e |- X = ran G $.
    ringsubdi.4 $e |- D = ( /g ` G ) $.
    $( Ring multiplication distributes over subtraction.  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    rngosubdi $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) )
                          -> ( A H ( B D C ) ) = ( ( A H B ) D ( A H C ) ) ) $=
      ( wcel w3a wa co cfv wceq rngosub eqtr4d cgn eqid 3adant3r1 oveq2d rngocl
      crngo 3adant3r3 3adant3r2 jca 3expb syldan idd rngonegcl ex 3anim123d imp
      rngodi rngonegrmul ) EUFMZAHMZBHMZCHMZNZOZABCDPZGPABCFUAQZQZFPZGPZABGPZAC
      GPZDPZVDVEVHAGUSVAVBVEVHRUTBCDEFVFHIKVFUBZLSUCUDVDVLVJVKVFQZFPZVIUSVCVJHM
      ZVKHMZOVLVORZVDVPVQUSUTVAVPVBABEFGHIJKUEUGUSUTVBVQVAACEFGHIJKUEUHUIUSVPVQ
      VRVJVKDEFVFHIKVMLSUJUKVDVIVJAVGGPZFPZVOUSVCUTVAVGHMZNZVIVTRUSVCWBUSUTUTVA
      VAVBWAUSUTULUSVAULUSVBWACEFVFHIKVMUMUNUOUPABVGEFGHIJKUQUKVDVNVSVJFUSUTVBV
      NVSRVAACEFGVFHIJKVMURUHUDTTT $.

    $( Ring multiplication distributes over subtraction.  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    rngosubdir $p |- ( ( R e. RingOps /\ ( A e. X /\ B e. X /\ C e. X ) )
                          -> ( ( A D B ) H C ) = ( ( A H C ) D ( B H C ) ) ) $=
      ( wcel w3a wa co cfv wceq rngosub eqtr4d cgn eqid 3adant3r3 oveq1d rngocl
      crngo 3adant3r2 3adant3r1 jca 3expb syldan idd rngonegcl ex 3anim123d imp
      rngodir rngoneglmul oveq2d ) EUFMZAHMZBHMZCHMZNZOZABDPZCGPABFUAQZQZFPZCGP
      ZACGPZBCGPZDPZVEVFVICGUTVAVBVFVIRVCABDEFVGHIKVGUBZLSUCUDVEVMVKVLVGQZFPZVJ
      UTVDVKHMZVLHMZOVMVPRZVEVQVRUTVAVCVQVBACEFGHIJKUEUGUTVBVCVRVABCEFGHIJKUEUH
      UIUTVQVRVSVKVLDEFVGHIKVNLSUJUKVEVJVKVHCGPZFPZVPUTVDVAVHHMZVCNZVJWARUTVDWC
      UTVAVAVBWBVCVCUTVAULUTVBWBBEFVGHIKVNUMUNUTVCULUOUPAVHCEFGHIJKUQUKVEVOVTVK
      FUTVBVCVOVTRVABCEFGVGHIJKVNURUHUSTTT $.
  $}

  ${
    zerdivempx.1 $e |- G = ( 1st ` R ) $.
    zerdivempx.2 $e |- H = ( 2nd ` R ) $.
    zerdivempx.3 $e |- Z = ( GId ` G ) $.
    zerdivempx.4 $e |- X = ran G $.
    zerdivempx.5 $e |- U = ( GId ` H ) $.
    $d A a $.  $d B a $.  $d H a $.  $d R a $.  $d X a $.  $d Z a $.
    $( In a unitary ring a left invertible element is not a zero divisor.
       Generalization of ~ zerdivemp1 by Frederic Line.  (Contributed by Jeff
       Madsen, 18-Apr-2010.) $)
    zerdivemp1x $p |- ( ( R e. RingOps /\ A e. X /\ E. a e. X ( a H A ) = U )
       -> ( B e. X -> ( ( A H B ) = Z -> B = Z ) ) ) $=
      ( wcel co wceq wi w3a 3exp crngo cv oveq2 wa simpl1 simpr1 simpr3 rngoass
      wrex simpl3 syl13anc eqtr ex oveq1 rngorz 3adant3 crn c1st rneqi rngolidm
      cfv eqtri 3adant2 simp1 simp2 simp3 3eqtr3d com14 com13 sylc com15 eqcoms
      a1d com24 syl com25 com12 3imp syl6 3imp1 mpd 3exp1 syl5com rexlimiv ) CU
      AOZAGOZIUBZAFPZDQZIGUIZBGOZABFPZHQZBHQZRRZWJWFWEWOWIWFWEWORZRIGWGGOZWIWFW
      PWMWEWKWQWIWFSZWNWMWGWLFPZWGHFPZQZWEWKWRWNRRWLHWGFUCWEXAWKWRWNWEXAWKSZWRU
      DZWHBFPZWSQZWNXCWEWQWFWKXEWEXAWKWRUEXBWQWIWFUFXBWQWIWFUGWEXAWKWRUJWGABCEF
      GJKMUHUKWEXAWKWRXEWNRXEXAWKWRWEWNXEXAXDWTQZWKWRWEWNRZRRXEXAXFXDWSWTULUMWR
      WKXFXGWQWIWFWKXFXGRRZWIWQWFXHRZWIXDDBFPZQZWQXIRWHDBFUNXKXFWFWKWQXGXFWFWKW
      QXGRRRZRXJXDXJXDQZXFXLXMXFUDXJWTQZXLXJXDWTULXNWQWKWFXGWEWQWKWFXNWNWEWQWKW
      FXNWNRZRZWEWQWKSWTHQZXJBQZXPWEWQXQWKWGCEFGHLMJKUOUPWEWKXRWQBCDFGKGEUQCURV
      AZUQMEXSJUSVBNUTVCWFXRXQXOXNXRXQWFWNXNXRXQWFWNRXNXRXQSZWNWFXTXJWTBHXNXRXQ
      VDXNXRXQVEXNXRXQVFVGVMTVHVIVJTVKVNVOUMVLVPVOVQVRVIVSVKVTWAWBWCVHTWDVIVR
      $.
  $}

  ${
    $d g h $.
    isdivrng1.1 $e |- G = ( 1st ` R ) $.
    isdivrng1.2 $e |- H = ( 2nd ` R ) $.
    isdivrng1.3 $e |- Z = ( GId ` G ) $.
    isdivrng1.4 $e |- X = ran G $.
    $( The predicate "is a division ring".  (Contributed by Jeff Madsen,
       8-Jun-2010.) $)
    isdrngo1 $p |- ( R e. DivRingOps <-> ( R e. RingOps /\
             ( H |` ( ( X \ { Z } ) X. ( X \ { Z } ) ) ) e. GrpOp ) ) $=
      ( vg vh cdrng wcel cfv cop crngo csn cdif cgr wa c1st c2nd wceq cres wrel
      cxp cv crn df-drngo relopabi 1st2nd mpan relrngo adantr wb opeq12i eqeq2i
      cgi cvv fvex eqeltri isdivrngo ax-mp sneqi difeq12i xpeq12i eleq1i anbi2i
      reseq2i bitr4i eleq1 anbi1d bibi12d mpbiri sylbir pm5.21nii ) ALMZAAUANZA
      UBNZOZUCZAPMZCDEQZRZWDUFZUDZSMZTZLUEVQWAJUGZKUGZOPMWJWIUHWIURNQRZWKUFUDSM
      TJKLJKUIUJALUKULWBWAWGPUEWBWAUMAPUKULUNWAABCOZUCZVQWHUOZWLVTABVRCVSFGUPUQ
      WMWNWLLMZWLPMZWGTZUOWOWPCBUHZBURNZQZRZXAUFZUDZSMZTZWQCUSMWOXEUOCVSUSGAUBU
      TVAUSBCVBVCWGXDWPWFXCSWEXBCWDXAWDXADWRWCWTIEWSHVDVEZXFVFVIVGVHVJWMVQWOWHW
      QAWLLVKWMWBWPWGAWLPVKVLVMVNVOVP $.

    $( The product of two nonzero elements of a division ring is nonzero.
       (Contributed by Jeff Madsen, 9-Jun-2010.) $)
    divrngcl $p |- ( ( R e. DivRingOps /\ A e. ( X \ { Z } )
                    /\ B e. ( X \ { Z } ) ) -> ( A H B ) e. ( X \ { Z } ) ) $=
      ( wcel cxp wa co wceq adantl cdm wss eleq2d cdrng crngo csn cdif cres cgr
      isdrngo1 ovres crn wi grpocl 3expib grporndm difss xpss12 mp2an wf rngosm
      eqid fdm syl5sseqr ssdmres sylib adantr dmeqd dmxpid syl6eq eqtrd anbi12d
      syl 3imtr3d imp eqeltrrd 3impb syl3an1b ) CUALCUBLZEFGUCZUDZVRMZUEZUFLZNZ
      AVRLZBVRLZABEOZVRLZCDEFGHIJKUGWBWCWDWFWBWCWDNZNABVTOZWEVRWGWHWEPWBABVRVRE
      UHQWBWGWHVRLZWBAVTUIZLZBWJLZNZWHWJLZWGWIWAWMWNUJVPWAWKWLWNABVTWJWJUSUKULQ
      WBWKWCWLWDWBWJVRAWBWJVTRZRZVRWAWJWPPVPVTUMQWBWPVSRVRWBWOVSVPWOVSPZWAVPVSE
      RZSWQVPFFMZVSWRVRFSZWTVSWSSFVQUNZXAVRFVRFUOUPVPWSFEUQWRWSPCDEFHIKURWSFEUT
      VJVAVSEVBVCVDVEVRVFVGVHZTWBWJVRBXBTVIWBWJVRWHXBTVKVLVMVNVO $.

    $d H x y u v w z $.  $d X x y u v w z $.  $d Z x y u v w z $.
    $d R x y u v w z $.  $d U x y u v w z $.
    isdivrng2.5 $e |- U = ( GId ` H ) $.
    $( A division ring is a ring in which ` 1 =/= 0 ` and every nonzero element
       is invertible.  (Contributed by Jeff Madsen, 8-Jun-2010.) $)
    isdrngo2 $p |- ( R e. DivRingOps <-> ( R e. RingOps /\ ( U =/= Z /\
             A. x e. ( X \ { Z } ) E. y e. ( X \ { Z } ) ( y H x ) = U ) ) ) $=
      ( vz wcel wa co wceq wrex adantr vu vv vw cdrng csn cdif cxp cres cgr wne
      crngo cv wral isdrngo1 dvrunz sylbir crn cdm grporndm adantl difss xpss12
      wss mp2an wf rngosm fdm syl5sseqr ssdmres sylib dmeqd dmxpid syl6eq eqtrd
      syl eleq2d biimpar cgn cfv grpoinvcl adantll cgi grpolinv cmagm cexid cin
      eqid cmndo rngomndo mndomgmid sseqtri rngorn1eq syl5sseq c1st rneqi eqtri
      rngo1cl eldifsn sylanbrc grpomndo mndoismgm exidresid oveq1 eqeq1d rspcev
      syl31anc syl2anc syldan rexeqdv ovres ancoms rexbidva bitrd ralrimiva jca
      wb mpbid cvv fvex eqeltri rnex difexg mp1i wfn ffn fnssres sylancl eldifi
      anim12i 3expb sylan2 adantlr weq wi sylan2b adantlrl ovresd sylan 3eqtr4d
      w3a rngocl oveq2 rexbidv rspcv imdistanri zerdivemp1x syl3an3 syl3an2 imp
      ssrexv ax-mp necon3d impr an32s ancom2s an42s eqeltrd ralrimivva 3adantr3
      ffnov simpr3 3adant3 oveq1d 3adant1 oveq2d simpr1 fovrn 3adant3r1 rngoass
      3anim123i anim1i sylibr adantrr rngolidm adantlrr cbvrexv isgrpda impbida
      rspcva pm5.32i bitri ) CUDOZCUKOZFGHUEZUFZUWEUGZUHZUIOZPZUWCDHUJZBULZAULZ
      FQZDRZBUWESZAUWEUMZPZPZCEFGHIJKLUNZUWCUWHUWQUWCUWHUWQUWIUWJUWPUWIUWBUWJUW
      SCDEFGHIJLKMUOUPZUWIUWOAUWEUWIUWLUWEOZPZUWKUWLUWGQZDRZBUWGUQZSZUWOUWIUXAU
      WLUXEOZUXFUWIUXGUXAUWIUXEUWEUWLUWIUXEUWGURZURZUWEUWHUXEUXIRUWCUWGUSUTUWIU
      XIUWFURUWEUWIUXHUWFUWIUWFFURZVCZUXHUWFRUWCUXKUWHUWCGGUGZUWFUXJUWEGVCZUXMU
      WFUXLVCZGUWDVAZUXOUWEGUWEGVBVDZUWCUXLGFVEZUXJUXLRCEFGIJLVFZUXLGFVGVOVHTUW
      FFVIVJVKUWEVLVMVNZVPVQUWIUXGPZUWLUWGVRVSZVSZUXEOZUYBUWLUWGQZDRZUXFUWHUXGU
      YCUWCUWLUWGUYAUXEUXEWGZUYAWGZVTWAUXTUYDUWGWBVSZDUWHUXGUYDUYHRUWCUWLUYHUWG
      UYAUXEUYFUYHWGUYGWCWAUWIUYHDRZUXGUWIFWDWEWFOZUWEFUQZVCZDUWEOZUWGWDOZUYIUW
      CUYJUWHUWCFWHOUYJCFJWIFWJVOTUWCUYLUWHUWCEUQZUWEUYKUWEGUYOUXOLWKCEFJIWLWMT
      UWIDGOZUWJUYMUWCUYPUWHCDFGGUYOCWNVSZUQLEUYQIWOWPZJMWQZTUWTDGHWRZWSUWHUYNU
      WCUWHUWGWHOUYNUWGWTUWGXAVOUTDFUWGUYKUWEUYKWGMUWGWGXBXFTVNUXDUYEBUYBUXEUWK
      UYBRUXCUYDDUWKUYBUWLUWGXCXDXEXGXHUXBUXFUXDBUWESZUWOUXBUXDBUXEUWEUWIUXEUWE
      RUXAUXSTXIUXAVUAUWOXPUWIUXAUXDUWNBUWEUXAUWKUWEOZPUXCUWMDVUBUXAUXCUWMRUWKU
      WLUWEUWEFXJXKXDXLUTXMXQXNXOUWRUAUBUCDNUWGUWEGXROUWEXROUWRGUYOXRLEEUYQXRIC
      WNXSXTYAXTGUWDXRYBYCUWRUWGUWFYDZUAULZUBULZUWGQZUWEOZUBUWEUMUAUWEUMUWFUWEU
      WGVEZUWRFUXLYDZUXNVUCUWCVUIUWQUWCUXQVUIUXRUXLGFYEVOTUXPUXLUWFFYFYGUWRVUGU
      AUBUWEUWEUWRVUDUWEOZVUEUWEOZPZPZVUFVUDVUEFQZUWEVULVUFVUNRZUWRVUDVUEUWEUWE
      FXJZUTVUMVUNGOZVUNHUJZVUNUWEOZUWCVULVUQUWQVULUWCVUDGOZVUEGOZPVUQVUJVUTVUK
      VVAVUDGUWDYHZVUEGUWDYHZYIUWCVUTVVAVUQVUDVUECEFGIJLUUAYJYKYLUWCUWPVULVURUW
      JUWCVUKUWPVUJVURUWPVUJPUWCVUKPZUWKVUDFQZDRZBUWESZVUJPVURVUJUWPVVGUWOVVGAV
      UDUWEAUAYMZUWNVVFBUWEVVHUWMVVEDUWLVUDUWKFUUBXDUUCZUUDUUEVVDVUJVVGVURUWCVU
      JVVGPZVUKVURVUKUWCVVJPZVVAVUEHUJZPVURVUEGHWRVVKVVAVVLVURVVKVVAPVUNHVUEHVV
      KVVAVUNHRVUEHRYNZUWCVUJVVGVVAVVMYNZVUJUWCVUTVVGVVNVVBVVGUWCVUTVVFBGSZVVNU
      XMVVGVVOYNUXOVVFBUWEGUUJUUKVUDVUECDEFGHBIJKLMUUFUUGUUHYJUUIUULUUMYOUUNUUO
      YKUUPYPVUNGHWRWSZUUQUURUAUBUWEUWEUWEUWGUUTWSZUWRVUJVUKUCULZUWEOZYTZPZVUNV
      VRUWGQVUNVVRFQZVUFVVRUWGQVUDVUEVVRUWGQZUWGQZVWAVUNVVRFUWEUWRVUJVUKVUSVVSV
      VPUUSUWRVUJVUKVVSUVAYQVWAVUFVUNVVRUWGVVTVUOUWRVUJVUKVUOVVSVUPUVBUTUVCVWAV
      UDVWCFQVUDVUEVVRFQZFQZVWDVWBVWAVWCVWEVUDFVVTVWCVWERZUWRVUKVVSVWGVUJVUEVVR
      UWEUWEFXJUVDUTUVEVWAVUDVWCFUWEUWRVUJVUKVVSUVFUWRVUHVVTVWCUWEOZVVQVUHVUKVV
      SVWHVUJVUEVVRUWEUWEUWEUWGUVGUVHYRYQUWCVVTVWBVWFRZUWQVVTUWCVUTVVAVVRGOZYTV
      WIVUJVUTVUKVVAVVSVWJVVBVVCVVRGUWDYHUVJVUDVUEVVRCEFGIJLUVIYKYLYSYSUWCUWJUY
      MUWPUWCUWJPZUYPUWJPUYMUWCUYPUWJUYSUVKUYTUVLZUVMUWCUWJVUJDVUDUWGQZVUDRUWPV
      WKVUJPVWMDVUDFQZVUDVWKUYMVUJVWMVWNRVWLDVUDUWEUWEFXJYRUWCVUJVWNVUDRZUWJVUJ
      UWCVUTVWOVVBVUDCDFGJUYRMUVNYKYLVNUVOUWCUWPVUJNULZVUDUWGQZDRZNUWESZUWJUWPV
      UJVWSUWCVUJUWPVWSVUJUWPVVGVWSUWOVVGAVUDUWEVVIUVSVVGVUJVWPVUDFQZDRZNUWESZV
      WSVVFVXABNUWEBNYMVVEVWTDUWKVWPVUDFXCXDUVPVUJVWSVXBVUJVWRVXANUWEVWPUWEOZVU
      JVWRVXAXPVXCVUJPVWQVWTDVWPVUDUWEUWEFXJXDXKXLVQYOXHXKWAYPUVQUVRUVTUWA $.

    $( A division ring is a ring in which ` 1 =/= 0 ` and every nonzero element
       is invertible.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    isdrngo3 $p |- ( R e. DivRingOps <-> ( R e. RingOps /\ ( U =/= Z /\
                        A. x e. ( X \ { Z } ) E. y e. X ( y H x ) = U ) ) ) $=
      ( wcel wne cv co wceq wrex wa cdrng crngo csn cdif isdrngo2 wb eldifi wss
      wral wi difss ssrexv ax-mp neeq1 biimparc rngolz oveq1 syl5ibrcom necon3d
      eqeq1d sylan2 an4s anassrs pm3.2 syl5com eldifsn syl6ibr imdistanda ancom
      imp 3imtr4g reximdv2 impbid2 ralbidva pm5.32da pm5.32i bitri ) CUANCUBNZD
      HOZBPZAPZFQZDRZBGHUCZUDZSZAWEUIZTZTVRVSWCBGSZAWEUIZTZTABCDEFGHIJKLMUEVRWH
      WKVRVSWGWJVRVSTZWFWIAWEWAWENWLWAGNZWFWIUFWAGWDUGWLWMTZWFWIWEGUHWFWIUJGWDU
      KWCBWEGULUMWNWCWCBGWEWNWCVTGNZTWCVTWENZTWOWCTWPWCTWNWCWOWPWNWCTZWOWOVTHOZ
      TZWPWQWRWOWSWLWMWCWRVRWMVSWCWRVSWCTVRWMTZWBHOZWRWCXAVSWBDHUNUOWTXAWRWTVTH
      WBHWTWBHRVTHRZHWAFQZHRWACEFGHKLIJUPXBWBXCHVTHWAFUQUTURUSVJVAVBVCWOWRVDVEV
      TGHVFVGVHWOWCVIWPWCVIVKVLVMVAVNVOVPVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ring homomorphisms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c RngHom $.
  $c RngIso $.
  $c ~=r $.

  $( Extend class notation with the class of ring homomorphisms. $)
  crnghom $a class RngHom $.

  $( Extend class notation with the class of ring isomorphisms. $)
  crngiso $a class RngIso $.

  $( Extend class notation with the ring isomorphism relation. $)
  crisc $a class ~=r $.

  ${
    $d r s t f x y $.
    $( Define the function which gives the set of ring homomorphisms between
       two given rings.  (Contributed by Jeff Madsen, 19-Jun-2010.) $)
    df-rngohom $a |- RngHom = ( r e. RingOps , s e. RingOps |->
      { f e. ( ran ( 1st ` s ) ^m ran ( 1st ` r ) ) |
        ( ( f ` ( GId ` ( 2nd ` r ) ) ) = ( GId ` ( 2nd ` s ) ) /\
          A. x e. ran ( 1st ` r ) A. y e. ran ( 1st ` r )
 ( ( f ` ( x ( 1st ` r ) y ) ) = ( ( f ` x ) ( 1st ` s ) ( f ` y ) ) /\
   ( f ` ( x ( 2nd ` r ) y ) ) = ( ( f ` x ) ( 2nd ` s ) ( f ` y ) ) ) ) } ) $.
  $}

  ${
    $d f x y F $.  $d f r s G $.  $d f r s H $.  $d f r s J $.  $d f r s y Y $.
    $d f r s K $.  $d f r s x y R $.  $d f r s x y S $.  $d f r s x y X $.
    $d f r s U $.  $d f r s V $.
    rnghomval.1 $e |- G = ( 1st ` R ) $.
    rnghomval.2 $e |- H = ( 2nd ` R ) $.
    rnghomval.3 $e |- X = ran G $.
    rnghomval.4 $e |- U = ( GId ` H ) $.
    rnghomval.5 $e |- J = ( 1st ` S ) $.
    rnghomval.6 $e |- K = ( 2nd ` S ) $.
    rnghomval.7 $e |- Y = ran J $.
    rnghomval.8 $e |- V = ( GId ` K ) $.
    $( The set of ring homomorphisms.  (Contributed by Jeff Madsen,
       19-Jun-2010.)  (Revised by Mario Carneiro, 22-Sep-2015.) $)
    rngohomval $p |- ( ( R e. RingOps /\ S e. RingOps ) -> ( R RngHom S ) =
            { f e. ( Y ^m X ) | ( ( f ` U ) = V /\ A. x e. X A. y e. X
              ( ( f ` ( x G y ) ) = ( ( f ` x ) J ( f ` y ) ) /\
            ( f ` ( x H y ) ) = ( ( f ` x ) K ( f ` y ) ) ) ) } ) $=
      ( vr vs crngo cv c2nd cfv cgi wceq c1st co wa crn wral cmap crnghom simpr
      crab fveq2d syl6eqr rneqd simpl oveq12d eqeq12d oveqd raleqbidv rabeqbidv
      anbi12d df-rngohom ovex rabex ovmpt2a ) UBUCCDUDUDUBUEZUFUGZUHUGZFUEZUGZU
      CUEZUFUGZUHUGZUIZAUEZBUEZVMUJUGZUKZVPUGZWBVPUGZWCVPUGZVRUJUGZUKZUIZWBWCVN
      UKZVPUGZWGWHVSUKZUIZULZBWDUMZUNZAWQUNZULZFWIUMZWQUOUKZUREVPUGZKUIZWBWCGUK
      ZVPUGZWGWHIUKZUIZWBWCHUKZVPUGZWGWHJUKZUIZULZBLUNZALUNZULZFMLUOUKZURUPVMCU
      IZVRDUIZULZWTXPFXBXQXTXAMWQLUOXTXAIUMMXTWIIXTWIDUJUGIXTVRDUJXRXSUQZUSRUTZ
      VATUTXTWQGUMLXTWDGXTWDCUJUGGXTVMCUJXRXSVBZUSNUTZVAPUTZVCXTWAXDWSXOXTVQXCV
      TKXTVOEVPXTVOHUHUGEXTVNHUHXTVNCUFUGHXTVMCUFYCUSOUTZUSQUTUSXTVTJUHUGKXTVSJ
      UHXTVSDUFUGJXTVRDUFYAUSSUTZUSUAUTVDXTWRXNAWQLYEXTWPXMBWQLYEXTWKXHWOXLXTWF
      XFWJXGXTWEXEVPXTWDGWBWCYDVEUSXTWIIWGWHYBVEVDXTWMXJWNXKXTWLXIVPXTVNHWBWCYF
      VEUSXTVSJWGWHYGVEVDVHVFVFVHVGABFUCUBVIXPFXQMLUOVJVKVL $.

    $( The predicate "is a ring homomorphism from ` R ` to ` S ` ."
       (Contributed by Jeff Madsen, 19-Jun-2010.) $)
    isrngohom $p |- ( ( R e. RingOps /\ S e. RingOps )
       -> ( F e. ( R RngHom S ) <->
                ( F : X --> Y /\ ( F ` U ) = V /\ A. x e. X A. y e. X
              ( ( F ` ( x G y ) ) = ( ( F ` x ) J ( F ` y ) ) /\
            ( F ` ( x H y ) ) = ( ( F ` x ) K ( F ` y ) ) ) ) ) ) $=
      ( vf crngo wcel wa crnghom co cv wceq wral cmap crab wf rngohomval eleq2d
      cfv w3a crn cvv c1st fvex eqeltri rnex elmap anbi1i fveq1 oveq12d eqeq12d
      eqeq1d anbi12d 2ralbidv elrab 3anass 3bitr4i syl6bb ) CUCUDDUCUDUEZFCDUFU
      GZUDFEUBUHZUPZKUIZAUHZBUHZGUGZVRUPZWAVRUPZWBVRUPZIUGZUIZWAWBHUGZVRUPZWEWF
      JUGZUIZUEZBLUJALUJZUEZUBMLUKUGZULZUDZLMFUMZEFUPZKUIZWCFUPZWAFUPZWBFUPZIUG
      ZUIZWIFUPZXCXDJUGZUIZUEZBLUJALUJZUQZVPVQWQFABCDEUBGHIJKLMNOPQRSTUAUNUOFWP
      UDZXAXKUEZUEWSXNUEWRXLXMWSXNMLFMIURUSTIIDUTUPUSRDUTVAVBVCVBLGURUSPGGCUTUP
      USNCUTVAVBVCVBVDVEWOXNUBFWPVRFUIZVTXAWNXKXOVSWTKEVRFVFVIXOWMXJABLLXOWHXFW
      LXIXOWDXBWGXEWCVRFVFXOWEXCWFXDIWAVRFVFZWBVRFVFZVGVHXOWJXGWKXHWIVRFVFXOWEX
      CWFXDJXPXQVGVHVJVKVJVLWSXAXKVMVNVO $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d X x y $.  $d Y y $.  $d F x y $.
    rnghomf.1 $e |- G = ( 1st ` R ) $.
    rnghomf.2 $e |- X = ran G $.
    rnghomf.3 $e |- J = ( 1st ` S ) $.
    rnghomf.4 $e |- Y = ran J $.
    $( A ring homomorphism is a function.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    rngohomf $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
                                                          -> F : X --> Y ) $=
      ( vx vy crngo wcel co wa cfv wceq eqid crnghom wf c2nd cgi wral isrngohom
      cv w3a biimpa simp1d 3impa ) ANOZBNOZCABUAPOZFGCUBZULUMQZUNQUOAUCRZUDRZCR
      BUCRZUDRZSZLUGZMUGZDPCRVBCRZVCCRZEPSVBVCUQPCRVDVEUSPSQMFUELFUEZUPUNUOVAVF
      UHLMABURCDUQEUSUTFGHUQTIURTJUSTKUTTUFUIUJUK $.

    $( Closure law for a ring homomorphism.  (Contributed by Jeff Madsen,
       3-Jan-2011.) $)
    rngohomcl $p |- ( ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
                                          /\ A e. X ) -> ( F ` A ) e. Y ) $=
      ( crngo wcel crnghom co w3a rngohomf ffvelrnda ) BMNCMNDBCOPNQGHADBCDEFGH
      IJKLRS $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d F x y $.
    rnghom1.1 $e |- H = ( 2nd ` R ) $.
    rnghom1.2 $e |- U = ( GId ` H ) $.
    rnghom1.3 $e |- K = ( 2nd ` S ) $.
    rnghom1.4 $e |- V = ( GId ` K ) $.
    $( A ring homomorphism preserves ` 1 ` .  (Contributed by Jeff Madsen,
       24-Jun-2011.) $)
    rngohom1 $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
                                                  -> ( F ` U ) = V ) $=
      ( vx vy crngo wcel co cfv wceq wa eqid crnghom c1st crn wf wral isrngohom
      cv w3a biimpa simp2d 3impa ) ANOZBNOZDABUAPOZCDQGRZULUMSZUNSAUBQZUCZBUBQZ
      UCZDUDZUOLUGZMUGZUQPDQVBDQZVCDQZUSPRVBVCEPDQVDVEFPRSMURUELURUEZUPUNVAUOVF
      UHLMABCDUQEUSFGURUTUQTHURTIUSTJUTTKUFUIUJUK $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d F x y $.  $d G x y $.  $d J x y $.
    $d X x y $.  $d A x y $.  $d B y $.
    rnghomadd.1 $e |- G = ( 1st ` R ) $.
    rnghomadd.2 $e |- X = ran G $.
    rnghomadd.3 $e |- J = ( 1st ` S ) $.
    $( Ring homomorphisms preserve addition.  (Contributed by Jeff Madsen,
       3-Jan-2011.) $)
    rngohomadd $p |- ( ( ( R e. RingOps /\ S e. RingOps
        /\ F e. ( R RngHom S ) ) /\ ( A e. X /\ B e. X ) )
                    -> ( F ` ( A G B ) ) = ( ( F ` A ) J ( F ` B ) ) ) $=
      ( vx vy wcel co cfv wceq wral wa eqid crngo crnghom w3a cv c2nd isrngohom
      crn wf cgi biimpa simp3d 3impa simpl ralimi syl oveq1 fveq2d fveq2 oveq1d
      eqeq12d oveq2 oveq2d rspc2v mpan9 ) CUANZDUANZECDUBONZUCZLUDZMUDZFOZEPZVI
      EPZVJEPZGOZQZMHRZLHRZAHNBHNSABFOZEPZAEPZBEPZGOZQZVHVPVIVJCUEPZOEPVMVNDUEP
      ZOQZSZMHRZLHRZVRVEVFVGWJVEVFSZVGSHGUGZEUHZWEUIPZEPWFUIPZQZWJWKVGWMWPWJUCL
      MCDWNEFWEGWFWOHWLIWETJWNTKWFTWLTWOTUFUJUKULWIVQLHWHVPMHVPWGUMUNUNUOVPWDAV
      JFOZEPZWAVNGOZQLMABHHVIAQZVLWRVOWSWTVKWQEVIAVJFUPUQWTVMWAVNGVIAEURUSUTVJB
      QZWRVTWSWCXAWQVSEVJBAFVAUQXAVNWBWAGVJBEURVBUTVCVD $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d F x y $.  $d H x y $.  $d K x y $.
    $d X x y $.  $d A x y $.  $d B y $.
    rnghommul.1 $e |- G = ( 1st ` R ) $.
    rnghommul.2 $e |- X = ran G $.
    rnghommul.3 $e |- H = ( 2nd ` R ) $.
    rnghommul.4 $e |- K = ( 2nd ` S ) $.
    $( Ring homomorphisms preserve multiplication.  (Contributed by Jeff
       Madsen, 3-Jan-2011.) $)
    rngohommul $p |- ( ( ( R e. RingOps /\ S e. RingOps
      /\ F e. ( R RngHom S ) ) /\ ( A e. X /\ B e. X ) )
                   -> ( F ` ( A H B ) ) = ( ( F ` A ) K ( F ` B ) ) ) $=
      ( vx vy wcel co cfv wceq wral crngo crnghom w3a cv c1st crn cgi isrngohom
      wa wf eqid biimpa simp3d 3impa simpr ralimi syl oveq1 fveq2d fveq2 oveq1d
      eqeq12d oveq2 oveq2d rspc2v mpan9 ) CUAPZDUAPZECDUBQPZUCZNUDZOUDZGQZERZVK
      ERZVLERZHQZSZOITZNITZAIPBIPUIABGQZERZAERZBERZHQZSZVJVKVLFQERVOVPDUERZQSZV
      RUIZOITZNITZVTVGVHVIWKVGVHUIZVIUIIWGUFZEUJZGUGRZERHUGRZSZWKWLVIWNWQWKUCNO
      CDWOEFGWGHWPIWMJLKWOUKWGUKMWMUKWPUKUHULUMUNWJVSNIWIVROIWHVRUOUPUPUQVRWFAV
      LGQZERZWCVPHQZSNOABIIVKASZVNWSVQWTXAVMWREVKAVLGURUSXAVOWCVPHVKAEUTVAVBVLB
      SZWSWBWTWEXBWRWAEVLBAGVCUSXBVPWDWCHVLBEUTVDVBVEVF $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d G x y $.  $d J x y $.  $d F x y $.
    rnggrphom.1 $e |- G = ( 1st ` R ) $.
    rnggrphom.2 $e |- J = ( 1st ` S ) $.
    $( A ring homomorphism is a group homomorphism.  (Contributed by Jeff
       Madsen, 2-Jan-2011.) $)
    rngogrphom $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
                                                  -> F e. ( G GrpOpHom J ) ) $=
      ( vx vy crngo wcel co crn cv cfv wral eqid wa cgr rngogrpo crnghom w3a wf
      cghom wceq rngohomf rngohomadd eqcomd ralrimivva wb elghom syl2an 3adant3
      mpbir2and ) AJKZBJKZCABUALKZUBZCDEUDLKZDMZEMZCUCZHNZCOINZCOELZVCVDDLCOZUE
      ZIUTPHUTPZABCDEUTVAFUTQZGVAQZUFURVGHIUTUTURVCUTKVDUTKRRVFVEVCVDABCDEUTFVI
      GUGUHUIUOUPUSVBVHRUJZUQUODSKESKVKUPADFTBEGTHICDEVAUTVIVJUKULUMUN $.
  $}

  ${
    rnghom0.1 $e |- G = ( 1st ` R ) $.
    rnghom0.2 $e |- Z = ( GId ` G ) $.
    rnghom0.3 $e |- J = ( 1st ` S ) $.
    rnghom0.4 $e |- W = ( GId ` J ) $.
    $( A ring homomorphism preserves ` 0 ` .  (Contributed by Jeff Madsen,
       2-Jan-2011.) $)
    rngohom0 $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
                                                      -> ( F ` Z ) = W ) $=
      ( crngo wcel crnghom co w3a cgr cghom cfv rngogrpo wceq 3ad2ant1 3ad2ant2
      rngogrphom ghomid syl3anc ) ALMZBLMZCABNOMZPDQMZEQMZCDEROMGCSFUAUGUHUJUIA
      DHTUBUHUGUKUIBEJTUCABCDEHJUDFGCDEIKUEUF $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d F x y $.  $d H x y $.  $d K x y $.
    $d X x y $.  $d A x y $.  $d B y $.
    rnghomsub.1 $e |- G = ( 1st ` R ) $.
    rnghomsub.2 $e |- X = ran G $.
    rnghomsub.3 $e |- H = ( /g ` G ) $.
    rnghomsub.4 $e |- J = ( 1st ` S ) $.
    rnghomsub.5 $e |- K = ( /g ` J ) $.
    $( Ring homomorphisms preserve subtraction.  (Contributed by Jeff Madsen,
       15-Jun-2011.) $)
    rngohomsub $p |- ( ( ( R e. RingOps /\ S e. RingOps
       /\ F e. ( R RngHom S ) ) /\ ( A e. X /\ B e. X ) )
                   -> ( F ` ( A H B ) ) = ( ( F ` A ) K ( F ` B ) ) ) $=
      ( crngo wcel co w3a cfv crnghom cgr cghom wceq rngogrpo 3ad2ant1 3ad2ant2
      wa rngogrphom 3jca ghomdiv sylan ) CPQZDPQZECDUARQZSZFUBQZHUBQZEFHUCRQZSA
      JQBJQUHABGRETAETBETIRUDUPUQURUSUMUNUQUOCFKUEUFUNUMURUODHNUEUGCDEFHKNUIUJA
      BIGEFHJLMOUKUL $.
  $}

  ${
    $d R x y $.  $d S x y $.  $d T x y $.  $d F x y $.  $d G x y $.
    $( The composition of two ring homomorphisms is a ring homomorphism.
       (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    rngohomco $p |- ( ( ( R e. RingOps /\ S e. RingOps /\ T e. RingOps ) /\
                          ( F e. ( R RngHom S ) /\ G e. ( S RngHom T ) ) )
                                      -> ( G o. F ) e. ( R RngHom T ) ) $=
      ( vx vy wcel w3a co wa cfv wceq eqid 3expa 3adantl3 fvco3 wi ex imp crngo
      crnghom ccom c1st crn c2nd cgi wral rngohomf 3adantl1 adantrl adantrr fco
      wf cv syl2anc rngo1cl 3ad2ant1 adantr rngohom1 fveq2d rngohomadd adantlrr
      eqtrd rngohomcl anim12da adantlrl syldan rngogcl 3ad2antl1 adantlr oveq12
      3expb sylan syl 3eqtr4d rngohommul rngocl ralrimivva wb isrngohom 3adant2
      jca mpbir3and ) AUAHZBUAHZCUAHZIZDABUBJHZEBCUBJHZKZKZEDUCZACUBJHZAUDLZUEZ
      CUDLZUEZWMUNZAUFLZUGLZWMLZCUFLZUGLZMZFUOZGUOZWOJZWMLZXFWMLZXGWMLZWQJZMZXF
      XGWTJZWMLZXJXKXCJZMZKZGWPUHFWPUHZWLBUDLZUEZWREUNZWPYADUNZWSWHWJYBWIWFWGWJ
      YBWEWFWGWJYBBCEXTWQYAWRXTNZYANZWQNZWRNZUIOUJUKWHWIYCWJWEWFWIYCWGWEWFWIYCA
      BDWOXTWPYAWONZWPNZYDYEUIOPULZWPYAWREDUMUPWLXBXADLZELZXDWLYCXAWPHZXBYLMYJW
      HYMWKWEWFYMWGAXAWTWPYIWTNZXANZUQURUSWPYAXAEDQUPWLYLBUFLZUGLZELZXDWLYKYQEW
      HWIYKYQMZWJWEWFWIYSWGWEWFWIYSABXADWTYPYQYNYOYPNZYQNZUTOPULVAWHWJYRXDMZWIW
      FWGWJUUBWEWFWGWJUUBBCYQEYPXCXDYTUUAXCNZXDNZUTOUJUKVDVDWLXRFGWPWPWLXFWPHZX
      GWPHZKZKZXMXQUUHXHDLZELZXFDLZELZXGDLZELZWQJZXIXLUUHUUJUUKUUMXTJZELZUUOUUH
      UUIUUPEWHWIUUGUUIUUPMZWJWHWIKZUUGUURWEWFWIUUGUURRZWGWEWFWIUUTWEWFWIIZUUGU
      URXFXGABDWOXTWPYHYIYDVBSOPTVCVAWLUUGUUKYAHZUUMYAHZKZUUQUUOMZWHWIUUGUVDWJU
      USUUGUVDWEWFWIUUGUVDRZWGWEWFWIUVFUVAUUGUVDUVAUUEUUFUVBUVCXFABDWOXTWPYAYHY
      IYDYEVEXGABDWOXTWPYAYHYIYDYEVEVFSOPTVCZWHWJUVDUVEWIWHWJKZUVDUVEWFWGWJUVDU
      VERZWEWFWGWJUVIWFWGWJIZUVDUVEUUKUUMBCEXTWQYAYDYEYFVBSOUJTVGVHVDWLUUGXHWPH
      ZXIUUJMZWHUUGUVKWKWEWFUUGUVKWGWEUUEUUFUVKXFXGAWOWPYHYIVIVMVJVKWLYCUVKUVLY
      JWPYAXHEDQVNVHUUHXJUULMZXKUUNMZKZXLUUOMWLUUEUUFUVMUVNWLYCUUEUVMYJWPYAXFED
      QVNWLYCUUFUVNYJWPYAXGEDQVNVFZXJUULXKUUNWQVLVOVPUUHXNDLZELZUULUUNXCJZXOXPU
      UHUVRUUKUUMYPJZELZUVSUUHUVQUVTEWHWIUUGUVQUVTMZWJUUSUUGUWBWEWFWIUUGUWBRZWG
      WEWFWIUWCUVAUUGUWBXFXGABDWOWTYPWPYHYIYNYTVQSOPTVCVAWLUUGUVDUWAUVSMZUVGWHW
      JUVDUWDWIUVHUVDUWDWFWGWJUVDUWDRZWEWFWGWJUWEUVJUVDUWDUUKUUMBCEXTYPXCYAYDYE
      YTUUCVQSOUJTVGVHVDWLUUGXNWPHZXOUVRMZWHUUGUWFWKWEWFUUGUWFWGWEUUEUUFUWFXFXG
      AWOWTWPYHYNYIVRVMVJVKWLYCUWFUWGYJWPYAXNEDQVNVHUUHUVOXPUVSMUVPXJUULXKUUNXC
      VLVOVPWCVSWHWNWSXEXSIVTZWKWEWGUWHWFFGACXAWMWOWTWQXCXDWPWRYHYNYIYOYFUUCYGU
      UDWAWBUSWD $.
  $}

  ${
    rngkerinj.1 $e |- G = ( 1st ` R ) $.
    rngkerinj.2 $e |- X = ran G $.
    rngkerinj.3 $e |- W = ( GId ` G ) $.
    rngkerinj.4 $e |- J = ( 1st ` S ) $.
    rngkerinj.5 $e |- Y = ran J $.
    rngkerinj.6 $e |- Z = ( GId ` J ) $.
    $( A ring homomorphism is injective if and only if its kernel is zero.
       (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    rngokerinj $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
        -> ( F : X -1-1-> Y <-> ( `' F " { Z } ) = { W } ) ) $=
      ( wcel cfv crn eqtri cgi crngo crnghom co w3a c1st cgr cghom wf1 ccnv csn
      cima wceq wb eqid rngogrpo 3ad2ant1 3ad2ant2 rngogrphom fveq2i grpokerinj
      rneqi syl3anc ) AUAPZBUAPZCABUBUCPZUDAUEQZUFPZBUEQZUFPZCVFVHUGUCPGHCUHCUI
      IUJUKFUJULUMVCVDVGVEAVFVFUNZUOUPVDVCVIVEBVHVHUNZUOUQABCVFVHVJVKURICVFVHFG
      HGDRVFRKDVFJVASFDTQVFTQLDVFTJUSSHERVHRNEVHMVASIETQVHTQOEVHTMUSSUTVB $.
  $}

  ${
    $d r s t f $.
    $( Define the function which gives the set of ring isomorphisms between two
       given rings.  (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    df-rngoiso $a |- RngIso = ( r e. RingOps , s e. RingOps |->
      { f e. ( r RngHom s ) |
        f : ran ( 1st ` r ) -1-1-onto-> ran ( 1st ` s ) } ) $.
  $}

  ${
    $d f F $.  $d f r s R $.  $d f r s S $.  $d f r s X $.  $d f r s Y $.
    rngisoval.1 $e |- G = ( 1st ` R ) $.
    rngisoval.2 $e |- X = ran G $.
    rngisoval.3 $e |- J = ( 1st ` S ) $.
    rngisoval.4 $e |- Y = ran J $.
    $( The set of ring isomorphisms.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    rngoisoval $p |- ( ( R e. RingOps /\ S e. RingOps ) -> ( R RngIso S ) =
                          { f e. ( R RngHom S ) | f : X -1-1-onto-> Y } ) $=
      ( vr vs cv c1st cfv crn crnghom wceq syl6eqr crngo wf1o co crngiso oveq12
      crab wa fveq2 rneqd f1oeq2 syl f1oeq3 sylan9bb rabeqbidv df-rngoiso rabex
      wb ovex ovmpt2a ) LMABUAUALNZOPZQZMNZOPZQZCNZUBZCUTVCRUCZUFFGVFUBZCABRUCZ
      UFUDUTASZVCBSZUGVGVICVHVJUTAVCBRUEVKVGFVEVFUBZVLVIVKVBFSVGVMUQVKVBDQFVKVA
      DVKVAAOPDUTAOUHHTUIITVBFVEVFUJUKVLVEGSVMVIUQVLVEEQGVLVDEVLVDBOPEVCBOUHJTU
      IKTVEGFVFULUKUMUNCMLUOVICVJABRURUPUS $.

    $( The predicate "is a ring isomorphism between ` R ` and ` S ` ."
       (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    isrngoiso $p |- ( ( R e. RingOps /\ S e. RingOps ) -> ( F e. ( R RngIso S )
      <-> ( F e. ( R RngHom S ) /\ F : X -1-1-onto-> Y ) ) ) $=
      ( vf crngo wcel wa crngiso co cv wf1o crnghom eleq2d f1oeq1 elrab syl6bb
      crab rngoisoval ) AMNBMNOZCABPQZNCFGLRZSZLABTQZUEZNCUKNFGCSZOUGUHULCABLDE
      FGHIJKUFUAUJUMLCUKFGUICUBUCUD $.

    $( A ring isomorphism is a bijection.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    rngoiso1o $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngIso S ) )
                                          -> F : X -1-1-onto-> Y ) $=
      ( crngo wcel crngiso co wf1o wa crnghom isrngoiso simplbda 3impa ) ALMZBL
      MZCABNOMZFGCPZUBUCQUDCABROMUEABCDEFGHIJKSTUA $.
  $}

  $( A ring isomorphism is a ring homomorphism.  (Contributed by Jeff Madsen,
     16-Jun-2011.) $)
  rngoisohom $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngIso S ) )
                                          -> F e. ( R RngHom S ) ) $=
    ( crngo wcel crngiso co crnghom c1st cfv wf1o eqid isrngoiso simprbda 3impa
    wa crn ) ADEZBDEZCABFGEZCABHGEZRSPTUAAIJZQZBIJZQZCKABCUBUDUCUEUBLUCLUDLUELM
    NO $.

  ${
    $d R x y $.  $d S x y $.  $d F x y $.
    $( The inverse of a ring isomorphism is a ring isomorphism.  (Contributed
       by Jeff Madsen, 16-Jun-2011.) $)
    rngoisocnv $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngIso S ) )
                                          -> `' F e. ( S RngIso R ) ) $=
      ( vx vy wcel co wa cfv wceq eqid sylan2 ancoms f1ocnvfv2 adantll f1ocnvdm
      wi 3expb sylan an32s crngo crngiso ccnv crnghom c1st crn wf1o wf c2nd cgi
      cv wral f1ocnv f1of syl ad2antll rngohom1 3expa adantrr rngo1cl ad2ant2rl
      f1ocnvfv mpd anim12da w3a rngohomadd exp32 impr rngogcl adantlll adantlrl
      oveq12 imp 3eqtr4rd wb wf1 f1of1 ad2antlr anassrs adantllr syl12anc mpbid
      f1fveq rngohommul rngocl ralrimivva isrngohom adantr mpbir3and ex 3imtr4d
      jca isrngoiso 3impia ) AUAFZBUAFZCABUBGFZCUCZBAUBGFZWOWPHZCABUDGFZAUEIZUF
      ZBUEIZUFZCUGZHZWRBAUDGFZXEXCWRUGZHZWQWSWTXGXJWTXGHZXHXIXKXHXEXCWRUHZBUIIZ
      UJIZWRIAUIIZUJIZJZDUKZEUKZXDGZWRIZXRWRIZXSWRIZXBGZJZXRXSXMGZWRIZYBYCXOGZJ
      ZHZEXEULDXEULZXFXLWTXAXFXIXLXCXECUMZXEXCWRUNUOUPXKXPCIXNJZXQWTXAYMXFWOWPX
      AYMABXPCXOXMXNXOKZXPKZXMKZXNKZUQURUSWOXFYMXQQZWPXAXFWOYRWOXFXPXCFYRAXPXOX
      CXCKZYNYOUTXCXEXPXNCVBLMVAVCXKYJDEXEXEXKXRXEFZXSXEFZHZHZYEYIUUCYACIZYDCIZ
      JZYEUUCYBCIZYCCIZXDGZXTUUEUUDXGUUBUUIXTJZWTXFUUBUUJXAXFUUBHZUUGXRJZUUHXSJ
      ZHZUUJXFYTUUAUULUUMXCXEXRCNXCXEXSCNVDZUUGXRUUHXSXDVLUOOOXKUUBUUEUUIJZWTXA
      XFUUBUUPQZWOWPXAXFUUQQWOWPXAVEZXFUUBUUPUUKUURYBXCFZYCXCFZHZUUPXFYTUUAUUSU
      UTXCXEXRCPXCXEXSCPVDZYBYCABCXBXDXCXBKZYSXDKZVFLVGURVHVMWTXFUUBUUDXTJZXAWP
      XFUUBUVEWOWPUUBXFUVEWPUUBHZXTXEFZXFUVEWPYTUUAUVGXRXSBXDXEUVDXEKZVIRZXFUVG
      UVEXCXEXTCNMSTVJVKVNWTXFUUBUUFYEVOZXAWTXFHUUBHZXCXECVPZYAXCFZYDXCFZUVJXFU
      VLWTUUBXCXECVQVRZWPXFUUBUVMWOWPUUBXFUVMUVFUVGXFUVMUVIXFUVGUVMXCXEXTCPMSTV
      JWOXFUUBUVNWPWOXFUUBUVNUUKWOUVAUVNUVBWOUUSUUTUVNYBYCAXBXCUVCYSVIRLVSVTXCX
      EYAYDCWCWAVKWBUUCYGCIZYHCIZJZYIUUCUUGUUHXMGZYFUVQUVPXGUUBUVSYFJZWTXFUUBUV
      TXAUUKUUNUVTUUOUUGXRUUHXSXMVLUOOOXKUUBUVQUVSJZWTXAXFUUBUWAQZWOWPXAXFUWBQU
      URXFUUBUWAUUKUURUVAUWAUVBYBYCABCXBXOXMXCUVCYSYNYPWDLVGURVHVMWTXFUUBUVPYFJ
      ZXAWPXFUUBUWCWOWPUUBXFUWCUVFYFXEFZXFUWCWPYTUUAUWDXRXSBXDXMXEUVDYPUVHWERZX
      FUWDUWCXCXEYFCNMSTVJVKVNWTXFUUBUVRYIVOZXAUVKUVLYGXCFZYHXCFZUWFUVOWPXFUUBU
      WGWOWPUUBXFUWGUVFUWDXFUWGUWEXFUWDUWGXCXEYFCPMSTVJWOXFUUBUWHWPWOXFUUBUWHUU
      KWOUVAUWHUVBWOUUSUUTUWHYBYCAXBXOXCUVCYNYSWERLVSVTXCXEYGYHCWCWAVKWBWLWFWTX
      HXLXQYKVEVOZXGWPWOUWIDEBAXNWRXDXMXBXOXPXEXCUVDYPUVHYQUVCYNYSYOWGMWHWIXFXI
      WTXAYLUPWLWJABCXBXDXCXEUVCYSUVDUVHWMWPWOWSXJVOBAWRXDXBXEXCUVDUVHUVCYSWMMW
      KWN $.
  $}

  ${
    $( The composition of two ring isomorphisms is a ring isomorphism.
       (Contributed by Jeff Madsen, 16-Jun-2011.) $)
    rngoisoco $p |- ( ( ( R e. RingOps /\ S e. RingOps /\ T e. RingOps ) /\
                      ( F e. ( R RngIso S ) /\ G e. ( S RngIso T ) ) )
                                    -> ( G o. F ) e. ( R RngIso T ) ) $=
      ( crngo wcel crngiso co wa crnghom c1st cfv crn rngoisohom 3expa 3adantl3
      wf1o 3adantl1 eqid ccom anim12da rngohomco syldan rngoiso1o adantrl f1oco
      w3a adantrr syl2anc wb isrngoiso 3adant2 adantr mpbir2and ) AFGZBFGZCFGZU
      HZDABHIGZEBCHIGZJZJZEDUAZACHIGZVDACKIGZALMZNZCLMZNZVDRZUSVBDABKIGZEBCKIGZ
      JVFUSUTVAVLVMUPUQUTVLURUPUQUTVLABDOPQUQURVAVMUPUQURVAVMBCEOPSUBABCDEUCUDV
      CBLMZNZVJERZVHVODRZVKUSVAVPUTUQURVAVPUPUQURVAVPBCEVNVIVOVJVNTZVOTZVITZVJT
      ZUEPSUFUSUTVQVAUPUQUTVQURUPUQUTVQABDVGVNVHVOVGTZVHTZVRVSUEPQUIVHVOVJEDUGU
      JUSVEVFVKJUKZVBUPURWDUQACVDVGVIVHVJWBWCVTWAULUMUNUO $.
  $}

  ${
    $d r s f $.
    $( Define the ring isomorphism relation.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    df-risc $a |- ~=r = { <. r , s >. | ( ( r e. RingOps /\ s e. RingOps )
                                  /\ E. f f e. ( r RngIso s ) ) } $.
  $}

  ${
    $d R r s f $.  $d S r s f $.
    $( The ring isomorphism relation.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    isriscg $p |- ( ( R e. A /\ S e. B ) -> ( R ~=r S <->
        ( ( R e. RingOps /\ S e. RingOps ) /\ E. f f e. ( R RngIso S ) ) ) ) $=
      ( vr vs cv crngo wcel wa crngiso co wex crisc eleq1 eleq2d exbidv anbi12d
      wceq anbi1d oveq1 anbi2d oveq2 df-risc brabg ) FHZIJZGHZIJZKZEHZUGUILMZJZ
      ENZKCIJZUJKZULCUILMZJZENZKUPDIJZKZULCDLMZJZENZKFGCDABOUGCTZUKUQUOUTVFUHUP
      UJUGCIPUAVFUNUSEVFUMURULUGCUILUBQRSUIDTZUQVBUTVEVGUJVAUPUIDIPUCVGUSVDEVGU
      RVCULUIDCLUDQRSEGFUEUF $.
  $}

  ${
    $d R f $.  $d S f $.
    isrisc.1 $e |- R e. _V $.
    isrisc.2 $e |- S e. _V $.
    $( The ring isomorphism relation.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    isrisc $p |- ( R ~=r S <-> ( ( R e. RingOps /\ S e. RingOps )
                              /\ E. f f e. ( R RngIso S ) ) ) $=
      ( cvv wcel crisc wbr crngo wa cv crngiso co wex wb isriscg mp2an ) AFGBFG
      ABHIAJGBJGKCLABMNGCOKPDEFFABCQR $.
  $}

  ${
    $d R f $.  $d S f $.
    $( The ring isomorphism relation.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    risc $p |- ( ( R e. RingOps /\ S e. RingOps ) ->
                      ( R ~=r S <-> E. f f e. ( R RngIso S ) ) ) $=
      ( crngo wcel wa crisc wbr cv crngiso co wex isriscg bianabs ) ADEBDEFABGH
      CIABJKECLDDABCMN $.
  $}

  ${
    $d R f $.  $d S f $.  $d F f $.
    $( Determine that two rings are isomorphic.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    risci $p |- ( ( R e. RingOps /\ S e. RingOps /\
                                F e. ( R RngIso S ) ) -> R ~=r S ) $=
      ( vf crngo wcel crngiso co crisc wbr wa cv wex elex2 risc syl5ibr 3impia
      ) AEFZBEFZCABGHZFZABIJZUAUBRSKDLTFDMDCTNABDOPQ $.
  $}

  ${
    $d f g r s t $.
    $( Ring isomorphism is an equivalence relation.  (Contributed by Jeff
       Madsen, 16-Jun-2011.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    riscer $p |- ~=r Er dom ~=r $=
      ( vr vs vt vf vg crisc cv wbr wi wa wal crngo wcel crngiso wex vex isrisc
      co 3expia risci cdm wer wrel wceq df-risc relopabi eqid rngoisocnv ancoms
      ccnv syld exlimdv imp sylbi eeanv ccom rngoisoco 3adant2 exlimdvv syl5bir
      w3a ex 3expb adantlr an4s syl2anb pm3.2i ax-gen gen2 dfer2 mpbir3an ) FUA
      ZFUBFUCVLVLUDAGZBGZFHZVNVMFHZIZVOVNCGZFHZJVMVRFHZIZJZCKZBKAKVMLMZVNLMZJZD
      GZVMVNNRMZDOZJZABFDBAUEUFVLUGWCABWBCVQWAVOWJVPVMVNDAPBPZQZWFWIVPWFWHVPDWF
      WHWGUJZVNVMNRMZVPWDWEWHWNVMVNWGUHSWEWDWNVPIWEWDWNVPVNVMWMTSUIUKULUMUNVOWJ
      WEVRLMZJZEGZVNVRNRMZEOZJVTVSWLVNVREWKCPQWFWPWIWSVTWFWPJWIWSJZVTWDWPWTVTIZ
      WEWDWEWOXAWTWHWRJZEODOWDWEWOVAZVTWHWRDEUOXCXBVTDEXCXBWQWGUPZVMVRNRMZVTXCX
      BXEVMVNVRWGWQUQVBWDWOXEVTIWEWDWOXEVTVMVRXDTSURUKUSUTVCVDUMVEVFVGVHVIABCVL
      FVJVK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Commutative rings
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CRingOps $.

  $( Extend class notation with the class of commutative rings. $)
  ccring $a class CRingOps $.

  $( Define the class of commutative rings.  (Contributed by Jeff Madsen,
     8-Jun-2010.) $)
  df-crngo $a |- CRingOps = ( RingOps i^i Com2 ) $.

  $( The predicate "is a commutative ring".  (Contributed by Jeff Madsen,
     8-Jun-2010.) $)
  iscrngo $p |- ( R e. CRingOps <-> ( R e. RingOps /\ R e. Com2 ) ) $=
    ( crngo ccm2 ccring df-crngo elin2 ) ABCDEF $.

  ${
    $d R x y $.  $d X x y $.
    iscring2.1 $e |- G = ( 1st ` R ) $.
    iscring2.2 $e |- H = ( 2nd ` R ) $.
    iscring2.3 $e |- X = ran G $.
    $( The predicate "is a commutative ring".  (Contributed by Jeff Madsen,
       8-Jun-2010.) $)
    iscrngo2 $p |- ( R e. CRingOps <-> ( R e. RingOps /\
                          A. x e. X A. y e. X ( x H y ) = ( y H x ) ) ) $=
      ( wcel crngo ccm2 wa cv co wceq wral c1st cfv cvv ccring iscrngo c2nd cop
      wb wrel relrngo 1st2nd mpan eleq1 crn rneqi eqtri raleqi eqeq12i raleqbii
      oveqi ralbii fvex iscom2 mp2an 3bitr4ri syl6bb syl pm5.32i bitri ) CUAJCK
      JZCLJZMVGANZBNZEOZVJVIEOZPZBFQZAFQZMCUBVGVHVOVGCCRSZCUCSZUDZPZVHVOUEKUFVG
      VSUGCKUHUIVSVHVRLJZVOCVRLUJVIVJVQOZVJVIVQOZPZBVPUKZQZAFQWEAWDQZVOVTWEAFWD
      FDUKWDIDVPGULUMZUNVNWEAFVMWCBFWDWGVKWAVLWBEVQVIVJHUQEVQVJVIHUQUOUPURVPTJV
      QTJVTWFUECRUSCUCUSTTVPVQABUTVAVBVCVDVEVF $.
  $}

  ${
    $d ph w x y z $.  $d G w x y z $.  $d H w x y z $.  $d X w x y z $.
    $d U x y $.
    iscringd.1 $e |- ( ph -> G e. AbelOp ) $.
    iscringd.2 $e |- ( ph -> X = ran G ) $.
    iscringd.3 $e |- ( ph -> H : ( X X. X ) --> X ) $.
    iscringd.4 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) )
                                  -> ( ( x H y ) H z ) = ( x H ( y H z ) ) ) $.
    iscringd.5 $e |- ( ( ph /\ ( x e. X /\ y e. X /\ z e. X ) )
                          -> ( x H ( y G z ) ) = ( ( x H y ) G ( x H z ) ) ) $.
    iscringd.6 $e |- ( ph -> U e. X ) $.
    iscringd.7 $e |- ( ( ph /\ y e. X ) -> ( y H U ) = y ) $.
    iscringd.8 $e |- ( ( ph /\ ( x e. X /\ y e. X ) )
                                              -> ( x H y ) = ( y H x ) ) $.
    $( Conditions that determine a commutative ring.  (Contributed by Jeff
       Madsen, 20-Jun-2011.)  (Revised by Mario Carneiro, 23-Dec-2013.) $)
    iscringd $p |- ( ph -> <. G , H >. e. CRingOps ) $=
      ( wcel co wceq wa vw cop crngo ccm2 ccring cv w3a id 3com13 eleq1 3anbi1d
      wi anbi2d oveq2 oveq12d eqeq12d imbi12d 3anbi3d oveq1 oveq1d cablo adantr
      crn simpr3 eleqtrd simpr2 eqid ablocom syl3anc simpr1 cgr ablogrpo grpocl
      syl eleqtrrd jca ovex chvarv vtocl syldan 3adantr3 3adantr2 cxp wf fovrnd
      3eqtrd 3eqtr2d sylan2 imbi2d an12s ex vtoclga mpcom eqtrd isrngod anbi12d
      wral eleq2d biimpar ralrimivva cvv rnexg eqeltrd xpexg syl2anc fex iscom2
      wb mpbird iscrngo sylanbrc ) AFGUBZUCQXLUDQZXLUEQABCDEFGHIJKLMBUFZHQZCUFZ
      HQZDUFZHQZUGZAXSXQXOUGZXNXPFRZXRGRZXNXRGRZXPXRGRZFRZSZXSXQXOYAYAUHUIAUAUF
      ZHQZXQXOUGZTZYBYHGRZXNYHGRZXPYHGRZFRZSZULZAYATZYGULUADYHXRSZYKYRYPYGYSYJY
      AAYSYIXSXQXOYHXRHUJUKUMYSYLYCYOYFYHXRYBGUNYSYMYDYNYEFYHXRXNGUNYHXRXPGUNUO
      UPUQAYIXQXSUGZTZXRXPFRZYHGRZXRYHGRZYNFRZSZULZYQDBXRXNSZUUAYKUUFYPUUHYTYJA
      UUHXSXOYIXQXRXNHUJURUMUUHUUCYLUUEYOUUHUUBYBYHGXRXNXPFUSUTUUHUUDYMYNFXRXNY
      HGUSUTUPUQAXTTZUUBXNGRZXRXNGRZXPXNGRZFRZSZULUUGBUAXNYHSZUUIUUAUUNUUFUUOXT
      YTAUUOXOYIXQXSXNYHHUJUKUMUUOUUJUUCUUMUUEXNYHUUBGUNUUOUUKUUDUULYNFXNYHXRGU
      NXNYHXPGUNUOUPUQUUIUUJXPXRFRZXNGRZXNUUPGRZUUMUUIUUBUUPXNGUUIFVAQZXRFVCZQZ
      XPUUTQZUUBUUPSAUUSXTIVBZUUIXRHUUTAXOXQXSVDZAHUUTSXTJVBZVEZUUIXPHUUTAXOXQX
      SVFZUVEVEZXRXPFUUTUUTVGZVHVIUTAXTXOUUPHQZTZUURUUQSZUUIXOUVJAXOXQXSVJZUUIU
      UPUUTHUUIFVKQZUVBUVAUUPUUTQUUIUUSUVNUVCFVLVNUVHUVFXPXRFUUTUVIVMVIUVEVOVPA
      XOYITZTZYMYHXNGRZSZULZAUVKTZUVLULUAUUPXPXRFVQYHUUPSZUVPUVTUVRUVLUWAUVOUVK
      AUWAYIUVJXOYHUUPHUJUMUMUWAYMUURUVQUUQYHUUPXNGUNYHUUPXNGUSUPUQAXOXQTZTZXNX
      PGRZUULSZULZUVSCUAXPYHSZUWCUVPUWEUVRUWGUWBUVOAUWGXQYIXOXPYHHUJUMUMUWGUWDY
      MUULUVQXPYHXNGUNXPYHXNGUSUPUQPVRVSVTUUIUURUWDYDFRUULUUKFRZUUMMUUIUWDUULYD
      UUKFAXOXQUWEXSPWAAXOXSYDUUKSZXQUWFAXOXSTZTZUWIULCDXPXRSZUWCUWKUWEUWIUWLUW
      BUWJAUWLXQXSXOXPXRHUJUMUMUWLUWDYDUULUUKXPXRXNGUNXPXRXNGUSUPUQPVRWBUOUUIUU
      SUULUUTQUUKUUTQUWHUUMSUVCUUIUULHUUTUUIXPXNHHHGAHHWCZHGWDZXTKVBZUVGUVMWEUV
      EVEUUIUUKHUUTUUIXRXNHHHGUWOUVDUVMWEUVEVEUULUUKFUUTUVIVHVIWFWGVRVRVRWHNAXQ
      TZEXPGRZXPEGRZXPEHQZUWPUWQUWRSZAUWSXQNVBUWPUWEULUWPUWTULBEHXNESZUWEUWTUWP
      UXAUWDUWQUULUWRXNEXPGUSXNEXPGUNUPWIXOUWPUWEAXOXQUWEPWJWKWLWMOWNOWOAXMUWEC
      UUTWQBUUTWQZAUWEBCUUTUUTAXNUUTQZUVBTZUWBUWEAUWBUXDAXOUXCXQUVBAHUUTXNJWRAH
      UUTXPJWRWPWSPVTWTAUUSGXAQZXMUXBXHIAUWNUWMXAQZUXEKAHXAQZUXGUXFAHUUTXAJAUUS
      UUTXAQIFVAXBVNXCZUXHHHXAXAXDXEUWMHXAGXFXEVAXAFGBCXGXEXIXLXJXK $.
  $}

  $( A commutative ring is a ring.  (Contributed by Jeff Madsen,
     10-Jun-2010.) $)
  crngorngo $p |- ( R e. CRingOps -> R e. RingOps ) $=
    ( ccring wcel crngo ccm2 iscrngo simplbi ) ABCADCAECAFG $.

  ${
    $d X x y $.  $d A x y $.  $d B y $.  $d H x y $.  $d R x y $.
    crngocom.1 $e |- G = ( 1st ` R ) $.
    crngocom.2 $e |- H = ( 2nd ` R ) $.
    crngocom.3 $e |- X = ran G $.
    $( The multiplication operation of a commutative ring is commutative.
       (Contributed by Jeff Madsen, 8-Jun-2010.) $)
    crngocom $p |- ( ( R e. CRingOps /\ A e. X /\ B e. X )
                                        -> ( A H B ) = ( B H A ) ) $=
      ( vx vy ccring wcel co wceq cv wral oveq1 oveq2 eqeq12d wa crngo iscrngo2
      simprbi rspc2v mpan9 3impb ) CLMZAFMZBFMZABENZBAENZOZUHJPZKPZENZUOUNENZOZ
      KFQJFQZUIUJUAUMUHCUBMUSJKCDEFGHIUCUDURUMAUOENZUOAENZOJKABFFUNAOUPUTUQVAUN
      AUOERUNAUOESTUOBOUTUKVAULUOBAESUOBAERTUEUFUG $.
  $}

  ${
    crngm.1 $e |- G = ( 1st ` R ) $.
    crngm.2 $e |- H = ( 2nd ` R ) $.
    crngm.3 $e |- X = ran G $.
    $( Commutative/associative law for commutative rings.  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    crngm23 $p |- ( ( R e. CRingOps /\ ( A e. X /\ B e. X /\ C e. X ) )
                                -> ( ( A H B ) H C ) = ( ( A H C ) H B ) ) $=
      ( ccring wcel w3a wa co wceq crngocom 3adant3r1 rngoass sylan crngo 3exp2
      oveq2d crngorngo com34 3imp2 3eqtr4d ) DKLZAGLZBGLZCGLZMZNZABCFOZFOZACBFO
      ZFOZABFOCFOZACFOBFOZUMUNUPAFUHUJUKUNUPPUIBCDEFGHIJQRUCUHDUALZULURUOPDUDZA
      BCDEFGHIJSTUHUTULUSUQPZVAUTUIUJUKVBUTUIUKUJVBUTUIUKUJVBACBDEFGHIJSUBUEUFT
      UG $.

    $( Commutative/associative law for commutative rings.  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    crngm4 $p |- ( ( R e. CRingOps /\ ( A e. X /\ B e. X )
                                  /\ ( C e. X /\ D e. X ) ) ->
                  ( ( A H B ) H ( C H D ) ) = ( ( A H C ) H ( B H D ) ) ) $=
      ( wcel wa co wceq w3a adantrrr rngocl 3expb 3jca ccring crngm23 crngorngo
      df-3an sylan2br oveq1d crngo adantrr simprrl simprrr rngoass syldan sylan
      adantrlr simprlr 3eqtr3d 3impb ) EUALZAHLZBHLZMZCHLZDHLZMZABGNZCDGNGNZACG
      NZBDGNGNZOURVAVDMZMZVECGNZDGNZVGBGNZDGNZVFVHVJVKVMDGURVAVBVKVMOZVCVAVBMUR
      USUTVBPVOUSUTVBUDABCEFGHIJKUBUEQUFUREUGLZVIVLVFOZEUCZVPVIVEHLZVBVCPVQVPVI
      MZVSVBVCVPVAVSVDVPUSUTVSABEFGHIJKRSUHVPVAVBVCUIVPVAVBVCUJZTVECDEFGHIJKUKU
      LUMURVPVIVNVHOZVRVPVIVGHLZUTVCPWBVTWCUTVCVPVAVBWCVCVPUSVBWCUTVPUSVBWCACEF
      GHIJKRSUNQVPUSUTVDUOWATVGBDEFGHIJKUKULUMUPUQ $.
  $}

  $( A field is a commutative ring.  (Contributed by Jeff Madsen,
     8-Jun-2010.) $)
  fldcrng $p |- ( K e. Fld -> K e. CRingOps ) $=
    ( cdrng wcel ccm2 crngo cfld ccring c2nd cfv c1st crn cgi csn cdif cxp cres
    wa cgr eqid drngoi simpld anim1i df-fld elin2 iscrngo 3imtr4i ) ABCZADCZQAE
    CZUHQAFCAGCUGUIUHUGUIAHIZAJIZKZUKLIZMNZUNOPRCAUKUJULUMUKSUJSULSUMSTUAUBABDF
    UCUDAUEUF $.

  $( The predicate "is a field".  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
  isfld2 $p |- ( K e. Fld <-> ( K e. DivRingOps /\ K e. CRingOps ) ) $=
    ( cfld wcel cdrng ccring wa flddivrng fldcrng jca crngo iscrngo simprbi cin
    ccm2 elin biimpri df-fld syl6eleqr sylan2 impbii ) ABCZADCZAECZFUAUBUCAGAHI
    UCUBANCZUAUCAJCUDAKLUBUDFZADNMZBAUFCUEADNOPQRST $.

  ${
    $d R w x y z $.  $d S w x y z $.  $d X w x y z $.  $d Y w x y z $.
    $d F w x y z $.
    crnghomfo.1 $e |- G = ( 1st ` R ) $.
    crnghomfo.2 $e |- X = ran G $.
    crnghomfo.3 $e |- J = ( 1st ` S ) $.
    crnghomfo.4 $e |- Y = ran J $.
    $( The image of a homomorphism from a commutative ring is commutative.
       (Contributed by Jeff Madsen, 4-Jan-2011.) $)
    crngohomfo $p |- ( ( ( R e. CRingOps /\ S e. RingOps )
        /\ ( F e. ( R RngHom S ) /\ F : X -onto-> Y ) ) -> S e. CRingOps ) $=
      ( vy vz vw vx wcel wa co cfv wceq ccring crngo crnghom wfo cv c2nd simplr
      wral wrex wi foelrn ex anim12d reeanv syl6ibr ad2antll w3a crngocom 3expb
      eqid 3ad2antl1 fveq2d crngorngo rngohommul syl3anl1 ancom2s oveq12 ancoms
      3eqtr3d eqeq12d syl5ibrcom 3expa adantrr rexlimdvv syld iscrngo2 sylanbrc
      ralrimivv ) AUAPZBUBPZQZCABUCRPZFGCUDZQZQZVTLUEZMUEZBUFSZRZWGWFWHRZTZMGUH
      LGUHBUAPVSVTWDUGWEWKLMGGWEWFGPZWGGPZQZWFNUEZCSZTZWGOUEZCSZTZQZOFUINFUIZWK
      WCWNXBUJWAWBWCWNWQNFUIZWTOFUIZQXBWCWLXCWMXDWCWLXCNFGWFCUKULWCWMXDOFGWGCUK
      ULUMWQWTNOFFUNUOUPWEXAWKNOFFWAWBWOFPZWRFPZQZXAWKUJZUJZWCVSVTWBXIVSVTWBUQZ
      XGXHXJXGQZWKXAWPWSWHRZWSWPWHRZTXKWOWRAUFSZRZCSZWRWOXNRZCSZXLXMXKXOXQCVSVT
      XGXOXQTZWBVSXEXFXSWOWRADXNFHXNUTZIURUSVAVBVSAUBPZVTWBXGXPXLTAVCZWOWRABCDX
      NWHFHIXTWHUTZVDVEVSYAVTWBXGXRXMTZYBYAVTWBUQXFXEYDWRWOABCDXNWHFHIXTYCVDVFV
      EVIXAWIXLWJXMWFWPWGWSWHVGWTWQWJXMTWGWSWFWPWHVGVHVJVKULVLVMVNVOVRLMBEWHGJY
      CKVPVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ideals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Idl $.
  $c PrIdl $.
  $c MaxIdl $.

  $( Extend class notation with the class of ideals. $)
  cidl $a class Idl $.

  $( Extend class notation with the class of prime ideals. $)
  cpridl $a class PrIdl $.

  $( Extend class notation with the class of maximal ideals. $)
  cmaxidl $a class MaxIdl $.

  ${
    $d r s i x y z $.
    $( Define the class of (two-sided) ideals of a ring ` R ` .  A subset of
       ` R ` is an ideal if it contains ` 0 ` , is closed under addition, and
       is closed under multiplication on either side by any element of ` R ` .
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    df-idl $a |- Idl = ( r e. RingOps |->
                { i e. ~P ran ( 1st ` r ) | ( ( GId ` ( 1st ` r ) ) e. i /\
                      A. x e. i ( A. y e. i ( x ( 1st ` r ) y ) e. i /\
                    A. z e. ran ( 1st ` r ) ( ( z ( 2nd ` r ) x ) e. i /\
                            ( x ( 2nd ` r ) z ) e. i ) ) ) } ) $.
  $}

  ${
    $d r s i a b x y $.
    $( Define the class of prime ideals of a ring ` R ` .  A proper ideal ` I `
       of ` R ` is prime if whenever ` A B C_ I ` for ideals ` A ` and ` B ` ,
       either ` A C_ I ` or ` B C_ I ` .  The more familiar definition using
       elements rather than ideals is equivalent provided ` R ` is commutative;
       see ~ ispridl2 and ~ ispridlc .  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    df-pridl $a |- PrIdl = ( r e. RingOps |->
        { i e. ( Idl ` r ) | ( i =/= ran ( 1st ` r ) /\ A. a e. ( Idl ` r )
          A. b e. ( Idl ` r ) ( A. x e. a A. y e. b ( x ( 2nd ` r ) y ) e. i ->
                                      ( a C_ i \/ b C_ i ) ) ) } ) $.
  $}

  ${
    $d r s i j $.
    $( Define the class of maximal ideals of a ring ` R ` .  A proper ideal is
       called maximal if it is maximal with respect to inclusion among proper
       ideals.  (Contributed by Jeff Madsen, 5-Jan-2011.) $)
    df-maxidl $a |- MaxIdl = ( r e. RingOps |->
            { i e. ( Idl ` r ) | ( i =/= ran ( 1st ` r ) /\ A. j e. ( Idl ` r )
                      ( i C_ j -> ( j = i \/ j = ran ( 1st ` r ) ) ) ) } ) $.
  $}

  ${
    $d R r s x y z i $.  $d X r s z i $.  $d I x y z i $.  $d Z r s i $.
    $d G r s i $.  $d H r s i $.
    idlval.1 $e |- G = ( 1st ` R ) $.
    idlval.2 $e |- H = ( 2nd ` R ) $.
    idlval.3 $e |- X = ran G $.
    idlval.4 $e |- Z = ( GId ` G ) $.
    $( The class of ideals of a ring.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    idlval $p |- ( R e. RingOps -> ( Idl ` R ) = { i e. ~P X | ( Z e. i /\
                                A. x e. i ( A. y e. i ( x G y ) e. i /\
                      A. z e. X ( ( z H x ) e. i /\ ( x H z ) e. i ) ) ) } ) $=
      ( cv c1st cfv wcel co wral wa cgi c2nd crn cpw crab crngo cidl wceq fveq2
      vr syl6eqr rneqd fveq2d eleq1d ralbidv anbi12d raleqbidv rabeqbidv df-idl
      pweqd oveqd cvv fvex eqeltri rnex pwex rabex fvmpt ) UJDUJNZOPZUAPZENZQZA
      NZBNZVJRZVLQZBVLSZCNZVNVIUBPZRZVLQZVNVSVTRZVLQZTZCVJUCZSZTZAVLSZTZEWFUDZU
      EIVLQZVNVOFRZVLQZBVLSZVSVNGRZVLQZVNVSGRZVLQZTZCHSZTZAVLSZTZEHUDZUEUFUGVID
      UHZWJXDEWKXEXFWFHXFWFFUCZHXFVJFXFVJDOPZFVIDOUIJUKZULLUKZUTXFVMWLWIXCXFVKI
      VLXFVKFUAPIXFVJFUAXIUMMUKUNXFWHXBAVLXFVRWOWGXAXFVQWNBVLXFVPWMVLXFVJFVNVOX
      IVAUNUOXFWEWTCWFHXJXFWBWQWDWSXFWAWPVLXFVTGVSVNXFVTDUBPGVIDUBUIKUKZVAUNXFW
      CWRVLXFVTGVNVSXKVAUNUPUQUPUOUPURABCEUJUSXDEXEHHXGVBLFFXHVBJDOVCVDVEVDVFVG
      VH $.

    $( The predicate "is an ideal of the ring ` R ` ."  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    isidl $p |- ( R e. RingOps -> ( I e. ( Idl ` R ) <-> ( I C_ X /\ Z e. I /\
                                A. x e. I ( A. y e. I ( x G y ) e. I /\
                      A. z e. X ( ( z H x ) e. I /\ ( x H z ) e. I ) ) ) ) ) $=
      ( vi wcel cv co wral wa eleq2 cidl cfv cpw crab wss w3a idlval eleq2d crn
      crngo c1st fvex eqeltri rnex elpw2 anbi1i wceq raleqbi1dv anbi12d ralbidv
      cvv elrab 3anass 3bitr4i syl6bb ) DUJOZGDUAUBZOGINPZOZAPZBPEQZVHOZBVHRZCP
      ZVJFQZVHOZVJVNFQZVHOZSZCHRZSZAVHRZSZNHUCZUDZOZGHUEZIGOZVKGOZBGRZVOGOZVQGO
      ZSZCHRZSZAGRZUFZVFVGWEGABCDNEFHIJKLMUGUHGWDOZWHWPSZSWGWSSWFWQWRWGWSGHHEUI
      VALEEDUKUBVAJDUKULUMUNUMUOUPWCWSNGWDVHGUQZVIWHWBWPVHGITWAWOAVHGWTVMWJVTWN
      VLWIBVHGVHGVKTURWTVSWMCHWTVPWKVRWLVHGVOTVHGVQTUSUTUSURUSVBWGWHWPVCVDVE $.

    $d X x $.
    $( The predicate "is an ideal of the commutative ring ` R ` ."
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    isidlc $p |- ( R e. CRingOps -> ( I e. ( Idl ` R ) <-> ( I C_ X /\ Z e. I
        /\
                                A. x e. I ( A. y e. I ( x G y ) e. I /\
                                    A. z e. X ( z H x ) e. I ) ) ) ) $=
      ( wcel cv co wral wa w3a wb ccring cidl cfv wss crngo crngorngo isidl syl
      ssel2 crngocom eleq1d biimprd 3expa pm4.71d bicomd ralbidva anbi2d sylan2
      wi anassrs adantrr pm5.32da df-3an 3bitr4g bitrd ) DUANZGDUBUCNZGHUDZIGNZ
      AOZBOEPGNBGQZCOZVJFPZGNZVJVLFPZGNZRZCHQZRZAGQZSZVHVIVKVNCHQZRZAGQZSZVFDUE
      NVGWATDUFABCDEFGHIJKLMUGUHVFVHVIRZVTRWFWDRWAWEVFWFVTWDVFVHVTWDTVIVFVHRVSW
      CAGVFVHVJGNZVSWCTZVHWGRVFVJHNZWHGHVJUIVFWIRZVRWBVKWJVQVNCHWJVLHNZRZVNVQWL
      VNVPVFWIWKVNVPUSVFWIWKSZVPVNWMVOVMGVJVLDEFHJKLUJUKULUMUNUOUPUQURUTUPVAVBV
      HVIVTVCVHVIWDVCVDVE $.
  $}

  ${
    $d R x y z $.  $d I x y z $.  $d X z $.
    idlss.1 $e |- G = ( 1st ` R ) $.
    idlss.2 $e |- X = ran G $.
    $( An ideal of ` R ` is a subset of ` R ` .  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    idlss $p |- ( ( R e. RingOps /\ I e. ( Idl ` R ) ) -> I C_ X ) $=
      ( vx vy vz crngo wcel cidl cfv wa wss cgi cv co wral eqid c2nd w3a biimpa
      isidl simp1d ) AJKZCALMKZNCDOZBPMZCKZGQZHQBRCKHCSIQZUKAUAMZRCKUKULUMRCKNI
      DSNGCSZUFUGUHUJUNUBGHIABUMCDUIEUMTFUITUDUCUE $.

    $( An element of an ideal is an element of the ring.  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    idlcl $p |- ( ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                                      /\ A e. I ) -> A e. X ) $=
      ( crngo wcel cidl cfv wa idlss sselda ) BHIDBJKILDEABCDEFGMN $.
  $}

  ${
    $d R x y z $.  $d I x y z $.  $d G z $.
    idl0cl.1 $e |- G = ( 1st ` R ) $.
    idl0cl.2 $e |- Z = ( GId ` G ) $.
    $( An ideal contains ` 0 ` .  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    idl0cl $p |- ( ( R e. RingOps /\ I e. ( Idl ` R ) ) -> Z e. I ) $=
      ( vx vy vz crngo wcel cidl cfv wa crn wss cv co wral eqid c2nd w3a biimpa
      isidl simp2d ) AJKZCALMKZNCBOZPZDCKZGQZHQBRCKHCSIQZUKAUAMZRCKUKULUMRCKNIU
      HSNGCSZUFUGUIUJUNUBGHIABUMCUHDEUMTUHTFUDUCUE $.
  $}

  ${
    $d R x y z $.  $d I x y z $.  $d G x y z $.  $d A x y $.  $d B y $.
    idladdcl.1 $e |- G = ( 1st ` R ) $.
    $( An ideal is closed under addition.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    idladdcl $p |- ( ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                              /\ ( A e. I /\ B e. I ) ) -> ( A G B ) e. I ) $=
      ( vx vy vz crngo wcel cidl cfv wa cv co wral eqid wceq eleq1d crn wss cgi
      c2nd w3a isidl biimpa simp3d simpl ralimi syl oveq1 oveq2 rspc2v mpan9 )
      CJKZECLMKZNZGOZHOZDPZEKZHEQZGEQZAEKBEKNABDPZEKZURVCIOZUSCUDMZPEKUSVGVHPEK
      NIDUAZQZNZGEQZVDUREVIUBZDUCMZEKZVLUPUQVMVOVLUEGHICDVHEVIVNFVHRVIRVNRUFUGU
      HVKVCGEVCVJUIUJUKVBVFAUTDPZEKGHABEEUSASVAVPEUSAUTDULTUTBSVPVEEUTBADUMTUNU
      O $.
  $}

  ${
    $d R x y z $.  $d I x y z $.  $d X x z $.  $d H x z $.  $d A x z $.
    $d B z $.
    idllmulcl.1 $e |- G = ( 1st ` R ) $.
    idllmulcl.2 $e |- H = ( 2nd ` R ) $.
    idllmulcl.3 $e |- X = ran G $.
    $( An ideal is closed under multiplication on the left.  (Contributed by
       Jeff Madsen, 10-Jun-2010.) $)
    idllmulcl $p |- ( ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                              /\ ( A e. I /\ B e. X ) ) -> ( B H A ) e. I ) $=
      ( vz vx vy wcel cfv wa cv co wral ralimi crngo cidl wss eqid isidl biimpa
      cgi w3a simp3d simpl adantl syl wceq oveq2 eleq1d oveq1 rspc2v mpan9 ) CU
      ANZFCUBONZPZKQZLQZERZFNZKGSZLFSZAFNBGNPBAERZFNZVAVCMQDRFNMFSZVEVCVBERFNZP
      ZKGSZPZLFSZVGVAFGUCZDUGOZFNZVOUSUTVPVRVOUHLMKCDEFGVQHIJVQUDUEUFUIVNVFLFVM
      VFVJVLVEKGVEVKUJTUKTULVEVIVBAERZFNLKABFGVCAUMVDVSFVCAVBEUNUOVBBUMVSVHFVBB
      AEUPUOUQUR $.

    $( An ideal is closed under multiplication on the right.  (Contributed by
       Jeff Madsen, 10-Jun-2010.) $)
    idlrmulcl $p |- ( ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                              /\ ( A e. I /\ B e. X ) ) -> ( A H B ) e. I ) $=
      ( vx vz vy wcel cfv wa cv co wral ralimi crngo cidl wss eqid isidl biimpa
      cgi w3a simp3d simpr adantl syl wceq oveq1 eleq1d oveq2 rspc2v mpan9 ) CU
      ANZFCUBONZPZKQZLQZERZFNZLGSZKFSZAFNBGNPABERZFNZVAVBMQDRFNMFSZVCVBERFNZVEP
      ZLGSZPZKFSZVGVAFGUCZDUGOZFNZVOUSUTVPVRVOUHKMLCDEFGVQHIJVQUDUEUFUIVNVFKFVM
      VFVJVLVELGVKVEUJTUKTULVEVIAVCERZFNKLABFGVBAUMVDVSFVBAVCEUNUOVCBUMVSVHFVCB
      AEUPUOUQUR $.
  $}

  ${
    idlnegcl.1 $e |- G = ( 1st ` R ) $.
    idlnegcl.2 $e |- N = ( inv ` G ) $.
    $( An ideal is closed under negation.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    idlnegcl $p |- ( ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                                          /\ A e. I ) -> ( N ` A ) e. I ) $=
      ( crngo wcel cidl cfv wa c2nd cgi co crn wss eqid anassrs mpdan wceq c1st
      idlss ssel2 rngonegmn1l sylan2 syldanl rneqi rngonegcl ad2antrr idllmulcl
      rngo1cl eqeltrd ) BHIZDBJKIZLZADIZLZAEKZBMKZNKZEKZAUTOZDUNUODCPZQZUQUSVCU
      AZBCDVDFVDRZUCUNVEUQVFVEUQLUNAVDIVFDVDAUDABVACUTEVDFUTRZVGGVARZUEUFSUGURV
      BVDIZVCDIZUNVJUOUQUNVAVDIVJBVAUTVDCBUBKFUHVHVIULVABCEVDFVGGUITUJUPUQVJVKA
      VBBCUTDVDFVHVGUKSTUM $.
  $}

  ${
    idlsubcl.1 $e |- G = ( 1st ` R ) $.
    idlsubcl.2 $e |- D = ( /g ` G ) $.
    $( An ideal is closed under subtraction.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    idlsubcl $p |- ( ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                              /\ ( A e. I /\ B e. I ) ) -> ( A D B ) e. I ) $=
      ( crngo wcel cidl cfv wa co cgn crn wceq eqid idlcl syldan anim12da 3expb
      rngosub adantlr simprl idlnegcl adantrl jca idladdcl eqeltrd ) DIJZFDKLJZ
      MZAFJZBFJZMZMZABCNZABEOLZLZENZFUMUPAEPZJZBVBJZMZURVAQZUMUNUOVCVDADEFVBGVB
      RZSBDEFVBGVGSUAUKVEVFULUKVCVDVFABCDEUSVBGVGUSRZHUCUBUDTUMUPUNUTFJZMVAFJUQ
      UNVIUMUNUOUEUMUOVIUNBDEFUSGVHUFUGUHAUTDEFGUITUJ $.
  $}

  ${
    $d R x y z $.  $d X x y z $.
    rngidl.1 $e |- G = ( 1st ` R ) $.
    rngidl.2 $e |- X = ran G $.
    $( A ring ` R ` is an ` R ` ideal.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    rngoidl $p |- ( R e. RingOps -> X e. ( Idl ` R ) ) $=
      ( vx vy vz crngo wcel cfv cv co wral wa eqid 3expa ralrimiva rngocl jca
      cidl wss cgi c2nd ssid a1i rngo0cl rngogcl w3a 3com23 isidl mpbir3and ) A
      IJZCAUAKJCCUBZBUCKZCJFLZGLZBMCJZGCNZHLZUPAUDKZMCJZUPUTVAMCJZOZHCNZOZFCNUN
      UMCUEUFABCUODEUOPZUGUMVFFCUMUPCJZOZUSVEVIURGCUMVHUQCJURUPUQABCDEUHQRVIVDH
      CUMVHUTCJZVDUMVHVJUIVBVCUMVJVHVBUTUPABVACDVAPZESUJUPUTABVACDVKESTQRTRFGHA
      BVACCUODVKEVGUKUL $.
  $}

  ${
    $d R x y z $.  $d Z x y z $.  $d G z $.
    0idl.1 $e |- G = ( 1st ` R ) $.
    0idl.2 $e |- Z = ( GId ` G ) $.
    $( The set containing only ` 0 ` is an ideal.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    0idl $p |- ( R e. RingOps -> { Z } e. ( Idl ` R ) ) $=
      ( vx vy vz wcel cfv cv co wral wa eqid wceq ovex elsnc sylibr eleq1d cidl
      crngo csn crn wss c2nd rngo0cl snssd cgi cvv fvex eqeltri snid elsn mpdan
      a1i rngo0rid oveq2 syl5ibrcom syl5bi ralrimiv rngorz rngolz jca ralrimiva
      oveq1 ralbidv anbi12d isidl mpbir3and ) AUBIZCUCZAUAJIVLBUDZUECVLIZFKZGKZ
      BLZVLIZGVLMZHKZVOAUFJZLZVLIZVOVTWALZVLIZNZHVMMZNZFVLMVKCVMABVMCDVMOZEUGZU
      HVNVKCCBUIJUJEBUIUKULUMUPVKWHFVLVOVLIVOCPZVKWHFCUNVKWHWKCVPBLZVLIZGVLMZVT
      CWALZVLIZCVTWALZVLIZNZHVMMZNVKWNWTVKWMGVLVPVLIVPCPZVKWMGCUNVKWMXACCBLZVLI
      ZVKXBCPZXCVKCVMIXDWJCABVMCDWIEUQUOXBCCCBQRSXAWLXBVLVPCCBURTUSUTVAVKWSHVMV
      KVTVMINZWPWRXEWOCPWPVTABWAVMCEWIDWAOZVBWOCVTCWAQRSXEWQCPWRVTABWAVMCEWIDXF
      VCWQCCVTWAQRSVDVEVDWKVSWNWGWTWKVRWMGVLWKVQWLVLVOCVPBVFTVGWKWFWSHVMWKWCWPW
      EWRWKWBWOVLVOCVTWAURTWKWDWQVLVOCVTWAVFTVHVGVHUSUTVAFGHABWAVLVMCDXFWIEVIVJ
      $.
  $}

  ${
    $d R x $.  $d X x $.  $d I x $.  $d U x $.
    1idl.1 $e |- G = ( 1st ` R ) $.
    1idl.2 $e |- H = ( 2nd ` R ) $.
    1idl.3 $e |- X = ran G $.
    1idl.4 $e |- U = ( GId ` H ) $.
    $( Two ways of expressing the unit ideal.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    1idl $p |- ( ( R e. RingOps /\ I e. ( Idl ` R ) )
           -> ( U e. I <-> I = X ) ) $=
      ( vx crngo wcel cidl cfv wa wceq wss adantr crn idlss cv c1st rneqi eqtri
      rngolidm ad2ant2rl idlrmulcl eqeltrrd expr ssrdv eqssd rngo1cl syl5ibrcom
      co ex eleq2 impbid ) ALMZEANOMZPZBEMZEFQZVAVBVCVAVBPZEFVAEFRVBACEFGIUASVD
      KFEVAVBKUBZFMZVEEMVAVBVFPPBVEDUOZVEEUSVFVGVEQUTVBVEABDFHFCTAUCOZTICVHGUDU
      EZJUFUGBVEACDEFGHIUHUIUJUKULUPVAVBVCBFMZUSVJUTABDFVIHJUMSEFBUQUNUR $.
  $}

  ${
    0ring.1 $e |- G = ( 1st ` R ) $.
    0ring.2 $e |- H = ( 2nd ` R ) $.
    0ring.3 $e |- X = ran G $.
    0ring.4 $e |- Z = ( GId ` G ) $.
    0ring.5 $e |- U = ( GId ` H ) $.
    $( In a ring, ` 0 = 1 ` iff the ring contains only ` 0 ` .  (Contributed by
       Jeff Madsen, 6-Jan-2011.) $)
    0rngo $p |- ( R e. RingOps -> ( Z = U <-> X = { Z } ) ) $=
      ( crngo wcel wceq csn cgi cfv cvv fvex crn eqeltri snid cidl wb 0idl 1idl
      eleq1 mpbii mpdan syl5ib eqcom syl6ib c1st rneqi eqtri eleq2 elsni eqcomd
      rngo1cl syl6bi syl5com impbid ) ALMZFBNZEFOZNZVCVDVEENZVFVDBVEMZVCVGVDFVE
      MVHFFCPQRJCPSUAUBFBVEUGUHVCVEAUCQMVHVGUDACFGJUEABCDVEEGHIKUFUIUJVEEUKULVC
      BEMZVFVDABDEECTAUMQZTICVJGUNUOHKUSVFVIVHVDEVEBUPVHBFBFUQURUTVAVB $.
  $}

  ${
    $d R i x y z $.  $d H i x y z $.  $d X i x y z $.  $d U i x y z $.
    $d Z i x y z $.
    divrngidl.1 $e |- G = ( 1st ` R ) $.
    divrngidl.2 $e |- H = ( 2nd ` R ) $.
    divrngidl.3 $e |- X = ran G $.
    divrngidl.4 $e |- Z = ( GId ` G ) $.
    $( The only ideals in a division ring are the zero ideal and the unit
       ideal.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    divrngidl $p |- ( R e. DivRingOps -> ( Idl ` R ) = { { Z } , X } ) $=
      ( vy vx vi vz wcel cgi wne cv wceq wa wi cdrng crngo cfv co csn cdif wrex
      wral cidl cpr eqid isdrngo2 idl0cl adantr wex wss fvex eqeltri snss necom
      wo cvv c0 pssdifn0 n0 sylib syl2anb idlss ssdif sselda sylan oveq2 eqeq1d
      rexbidv rspcva eldifi anim12i idllmulcl 1idl biimpd eleq1 syl5ibrcom mpid
      imbi1d sylan2 anassrs rexlimdva syldan an32s ex exlimdv syl5 mpand sylibr
      imp neor 0idl rngoidl jaod impbid vex elpr syl6bbr eqrdv adantrl sylbi )
      AUANAUBNZCOUCZEPZJQZKQZCUDZXHRZJDEUEZUFZUGZKXOUHZSSAUIUCZXNDUJZRZKJAXHBCD
      EFGIHXHUKZULXGXQXTXIXGXQSZLXRXSYBLQZXRNZYCXNRZYCDRZVAZYCXSNYBYDYGYBYDYGYB
      YDSYCXNPZYFTZYGXGYDXQYIXGYDSZXQSZEYCNZYHYFYJYLXQABYCEFIUMUNYLYHSMQZYCXNUF
      ZNZMUOZYKYFYLXNYCUPZXNYCPZYPYHEYCEBOUCVBIBOUQURUSYCXNUTYQYRSYNVCPYPXNYCVD
      MYNVEVFVGYKYOYFMYKYOYFYJYOXQYFYJYOSZXQXJYMCUDZXHRZJXOUGZYFYSYMXONZXQUUBYJ
      YCDUPZYOUUCABYCDFHVHUUDYNXOYMYCDXNVIVJVKXPUUBKYMXOXKYMRZXMUUAJXOUUEXLYTXH
      XKYMXJCVLVMVNVOVKYSUUBYFYSUUAYFJXOYJYOXJXONZUUAYFTZYOUUFSYJYMYCNZXJDNZSZU
      UGYOUUHUUFUUIYMYCXNVPXJDXNVPVQYJUUJSZUUAYTYCNZYFYMXJABCYCDFGHVRUUKUULYFTU
      UAXHYCNZYFTZYJUUNUUJYJUUMYFAXHBCYCDFGHYAVSVTUNUUAUULUUMYFYTXHYCWAWDWBWCWE
      WFWGWOWHWIWJWKWLWMWIYFYCXNWPWNWJXGYGYDTXQXGYEYDYFXGYDYEXNXRNABEFIWQYCXNXR
      WAWBXGYDYFDXRNABDFHWRYCDXRWAWBWSUNWTYCXNDLXAXBXCXDXEXF $.
  $}

  ${
    $d R i x y z $.  $d C i x y z $.
    $( The intersection of a nonempty collection of ideals is an ideal.
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    intidl $p |- ( ( R e. RingOps /\ C =/= (/) /\ C C_ ( Idl ` R ) )
                                                  -> |^| C e. ( Idl ` R ) ) $=
      ( vx vy vz vi wcel cfv cv co wral wa eqid sylan2 anassrs ralrimiva sylibr
      wss elint2 ex crngo wne cidl w3a cint c1st crn cgi c2nd intssuni 3ad2ant2
      cuni ssel2 idlss 3adant2 unissb sstrd idl0cl vex r19.26 idladdcl ralimdva
      c0 fvex wi ovex syl6ibr syl5bir expdimp ralrimiv idllmulcl anass1rs an32s
      syl5bi an4s imp idlrmulcl jca wb isidl 3ad2ant1 mpbir3and ) BUAGZAVCUBZAB
      UCHZRZUDZAUEZWEGZWHBUFHZUGZRZWJUHHZWHGZCIZDIZWJJZWHGZDWHKZEIZWOBUIHZJZWHG
      ZWOWTXAJZWHGZLZEWKKZLZCWHKZWGWHAULZWKWDWCWHXJRWFAUJUKWGFIZWKRZFAKZXJWKRWC
      WFXMWDWCWFLZXLFAWCWFXKAGZXLWFXOLZWCXKWEGZXLAWEXKUMZBWJXKWKWJMZWKMZUNNOPUO
      FAWKUPQUQWCWFWNWDXNWMXKGZFAKWNXNYAFAWCWFXOYAXPWCXQYAXRBWJXKWMXSWMMZURNOPF
      WMAWJUHVDSQUOWCWFXIWDXNXHCWHWOWHGWOXKGZFAKZXNXHFWOACUSSXNYDXHXNYDLZWSXGYE
      WRDWHWPWHGWPXKGZFAKZYEWRFWPADUSSXNYDYGWRYDYGLYCYFLZFAKZXNWRYCYFFAUTXNYIWQ
      XKGZFAKWRXNYHYJFAWCWFXOYHYJVEZXPWCXQYKXRWCXQLZYHYJWOWPBWJXKXSVATNOVBFWQAW
      OWPWJVFSVGVHVIVNVJYEXFEWKXNWTWKGZYDXFXNYMLZYDLZXCXEYOXBXKGZFAKZXCYNYDYQYN
      YCYPFAXNYMXOYCYPVEZWCYMWFXOYRXPWCYMLZXQYRXRWCXQYMYRYLYMLZYCYPYLYCYMYPWOWT
      BWJXAXKWKXSXAMZXTVKVLTVMNVOOVBVPFXBAWTWOXAVFSQYOXDXKGZFAKZXEYNYDUUCYNYCUU
      BFAXNYMXOYCUUBVEZWCYMWFXOUUDXPYSXQUUDXRWCXQYMUUDYTYCUUBYLYCYMUUBWOWTBWJXA
      XKWKXSUUAXTVQVLTVMNVOOVBVPFXDAWOWTXAVFSQVRVMPVRTVNVJUOWCWDWIWLWNXIUDVSWFC
      DEBWJXAWHWKWMXSUUAXTYBVTWAWB $.
  $}

  ${
    $d I i $.  $d J i $.
    $( The intersection of two ideals is an ideal.  (Contributed by Jeff
       Madsen, 16-Jun-2011.) $)
    inidl $p |- ( ( R e. RingOps /\ I e. ( Idl ` R ) /\ J e. ( Idl ` R ) )
                                          -> ( I i^i J ) e. ( Idl ` R ) ) $=
      ( crngo wcel cidl cfv w3a cpr cint cin intprg 3adant1 wa c0 wne wss prnzg
      wceq adantr prssi jca intidl 3expb sylan2 3impb eqeltrrd ) ADEZBAFGZEZCUI
      EZHBCIZJZBCKZUIUJUKUMUNSUHBCUIUILMUHUJUKUMUIEZUJUKNZUHULOPZULUIQZNUOUPUQU
      RUJUQUKBCUIRTBCUIUAUBUHUQURUOULAUCUDUEUFUG $.
  $}

  ${
    $d R i k x y z $.  $d C i j k x y z $.
    $( The union of a nonempty chain of ideals is an ideal.  (Contributed by
       Jeff Madsen, 5-Jan-2011.) $)
    unichnidl $p |- ( ( R e. RingOps /\ ( C =/= (/) /\ C C_ ( Idl ` R ) /\
                              A. i e. C A. j e. C ( i C_ j \/ j C_ i ) ) )
                                          -> U. C e. ( Idl ` R ) ) $=
      ( vx vy vz vk wcel cfv wss cv wral wa eqid imp sylan2 wel wi an32s c0 wne
      crngo cidl wo w3a cuni c1st crn cgi co c2nd dfss3 idlss ex ralimdv unissb
      sylibr 3ad2antr2 wrex idl0cl r19.2z an12s eluni2 3adantr3 weq sseq1 sseq2
      sylan2b orbi12d ralbidv adantr ad2antlr ad2antrl adantll idladdcl ancom2s
      rspcv ssel2 ancoms expr an42s anasss simprl elunii syl2anc anassrs jaodan
      ad2antrr syldan rexlimdvaa syl5bi ralrimiv 3adantr1 idllmulcl exp43 com23
      imp41 sylanl2 simplrr idlrmulcl jca ralrimiva wb isidl mpbir3and ) BUCIZA
      UAUBZABUDJZKZCLZDLZKZXLXKKZUEZDAMZCAMZUFZNZAUGZXIIZXTBUHJZUIZKZYBUJJZXTIZ
      ELZFLZYBUKZXTIZFXTMZGLZYGBULJZUKZXTIZYGYLYMUKZXTIZNZGYCMZNZEXTMZXGXHXJYDX
      QXGXJNZXKYCKZCAMZYDXJXGXKXIIZCAMZUUDCAXIUMZXGUUFUUDXGUUEUUCCAXGUUEUUCBYBX
      KYCYBOZYCOZUNUOUPPVICAYCUQURUSXGXHXJYFXQXGXHXJNNYEXKIZCAUTZYFXHXGXJUUKUUB
      XHUUJCAMZUUKXJXGUUFUULUUGXGUUFUULXGUUEUUJCAXGUUEUUJBYBXKYEUUHYEOZVAUOUPPV
      IUUJCAVBQVCCYEAVDURVEXSYTEXTYGXTIEHRZHAUTXSYTHYGAVDXSUUNYTHAXSHLZAIZUUNNZ
      NYKYSXGUUQXRYKXGUUQNZXJXQYKXHUURXJXQYKUURXJNZXQUUOXLKZXLUUOKZUEZDAMZYKUUS
      XQUVCUUQXQUVCSZXGXJUUPUVDUUNXPUVCCUUOACHVFZXOUVBDAUVEXMUUTXNUVAXKUUOXLVGX
      KUUOXLVHVJVKVRVLVMPUUSUVCNZYJFXTYHXTIFCRZCAUTUVFYJCYHAVDUVFUVGYJCAUUSXKAI
      ZUVGNZUVCYJUUSUVINZUVCUUOXKKZXKUUOKZUEZYJUVJUVCUVMUVHUVCUVMSUUSUVGUVBUVMD
      XKADCVFUUTUVKUVAUVLXLXKUUOVHXLXKUUOVGVJVRVNPUVJUVKYJUVLUVJUVKYJUURXJUVIUV
      KYJSZXGXJUVINZUUQUVNXGUVONZUUQUVKYJUUQUVKNUVPECRZYJUUNUVKUVQUUPUVKUUNUVQU
      UOXKYGVSVTVOUVPUVQNYIXKIZUVHYJUVPUVQUVRXGXJUVIUVQUVRSZXGUVGXJUVHUVSXJUVHN
      XGUVGNUUEUVSAXIXKVSXGUUEUVGUVSXGUUENZUVGUVQUVRUVTUVQUVGUVRYGYHBYBXKUUHVPV
      QWATQWBWCPUVOUVHXGUVQXJUVHUVGWDVMYIXKAWEWFQWATWGPUUSUVIUVLYJUVIUVLNUUSFHR
      ZYJUVGUVLUWAUVHUVLUVGUWAXKUUOYHVSVTVOUUSUWANYIUUOIZUUPYJUUSUWAUWBXGXJUUQU
      WAUWBSZXGUUNXJUUPUWCXJUUPNZXGUUNNZUUOXIIZUWCAXIUUOVSZXGUWFUUNUWCXGUWFNUUN
      UWAUWBYGYHBYBUUOUUHVPWATQWBTPUURUUPXJUWAXGUUPUUNWDWIYIUUOAWEWFQWGWHWJTWKW
      LWMWJWCWNTXGUUQXRYSUURXHXJYSXQXGXJUUQYSXGUUNXJUUPYSUWEUWDNZYRGYCUWHYLYCIZ
      NZYOYQUWJYNUUOIZUUPYOUWDUWEUWFUWIUWKUWGXGUUNUWFUWIUWKXGUWFUUNUWIUWKSXGUWF
      UUNUWIUWKYGYLBYBYMUUOYCUUHYMOZUUIWOWPWQWRWSUWEXJUUPUWIWTZYNUUOAWEWFUWJYPU
      UOIZUUPYQUWDUWEUWFUWIUWNUWGXGUUNUWFUWIUWNXGUWFUUNUWIUWNSXGUWFUUNUWIUWNYGY
      LBYBYMUUOYCUUHUWLUUIXAWPWQWRWSUWMYPUUOAWEWFXBXCWBTUSTXBWKWLWMXGYAYDYFUUAU
      FXDXREFGBYBYMXTYCYEUUHUWLUUIUUMXEVLXF $.
  $}

  ${
    $d R x y z $.  $d S x y z $.  $d F x y z $.  $d Z x y z $.
    keridl.1 $e |- G = ( 1st ` S ) $.
    keridl.2 $e |- Z = ( GId ` G ) $.
    $( The kernel of a ring homomorphism is an ideal.  (Contributed by Jeff
       Madsen, 3-Jan-2011.) $)
    keridl $p |- ( ( R e. RingOps /\ S e. RingOps /\ F e. ( R RngHom S ) )
                                      -> ( `' F " { Z } ) e. ( Idl ` R ) ) $=
      ( vx vy wcel co cfv wa eqid wceq fvex elsnc wb elpreima 3syl vz crngo w3a
      crnghom ccnv csn cima cidl c1st crn wss cv wral c2nd wf rngohomf cnvimass
      cgi cdm fdm syl5sseq syl rngo0cl 3ad2ant1 sylibr wfn mpbir2and rngohomadd
      rngohom0 ffn an4 adantr oveq12 adantl cgr rngogrpo grpoidcl grpolid mpdan
      3ad2ant2 ad2antrr 3eqtrd anbi12i 3imtr4g imdistanda rngogcl 3expib anim1d
      ex wi syld syl5bi anbi12d 3imtr4d ralrimiva anbi2i rngocl 3expb 3ad2antl1
      impl anass1rs adantlrr rngohommul oveq2 rngohomcl rngorz 3ad2antl2 syldan
      ad2antlr adantlr anassrs oveq1 rngolz jca sylbid imp isidl mpbir3and ) AU
      BJZBUBJZCABUDKJZUCZCUEEUFZUGZAUHLJZYDAUILZUJZUKZYFURLZYDJZHULZIULZYFKZYDJ
      ZIYDUMZUAULZYKAUNLZKZYDJZYKYPYQKZYDJZMZUAYGUMZMZHYDUMZYBYGDUJZCUOZYHABCYF
      DYGUUFYFNZYGNZFUUFNZUPZUUGCUSYDYGCYCUQYGUUFCUTVAVBYBYJYIYGJZYICLZYCJZXSXT
      UULYAAYFYGYIUUHUUIYINZVCVDYBUUMEOUUNABCYFDEYIUUHUUOFGVIUUMEYICPQVEYBUUGCY
      GVFZYJUULUUNMRUUKYGUUFCVJZYGYIYCCSTVGYBUUDHYDYBYKYDJZMZYOUUCUUSYNIYDYBUUR
      YLYDJZYNYBYKYGJZYKCLZYCJZMZYLYGJZYLCLZYCJZMZMZYMYGJZYMCLZYCJZMZUURUUTMYNU
      VIUVAUVEMZUVCUVGMZMZYBUVMUVAUVCUVEUVGVKYBUVPUVNUVLMUVMYBUVNUVOUVLYBUVNMZU
      VBEOZUVFEOZMZUVKEOZUVOUVLUVQUVTUWAUVQUVTMUVKUVBUVFDKZEEDKZEUVQUVKUWBOUVTY
      KYLABCYFDYGUUHUUIFVHVLUVTUWBUWCOUVQUVBEUVFEDVMVNYBUWCEOZUVNUVTXTXSUWDYAXT
      DVOJZUWDBDFVPUWEEUUFJUWDEDUUFUUJGVQEEDUUFUUJGVRVSVBVTWAWBWIUVCUVRUVGUVSUV
      BEYKCPQZUVFEYLCPQWCUVKEYMCPQWDWEYBUVNUVJUVLXSXTUVNUVJWJYAXSUVAUVEUVJYKYLA
      YFYGUUHUUIWFWGVDWHWKWLYBUURUVDUUTUVHYBUUGUUPUURUVDRUUKUUQYGYKYCCSTZYBUUGU
      UPUUTUVHRUUKUUQYGYLYCCSTWMYBUUGUUPYNUVMRUUKUUQYGYMYCCSTWNWTWOYBUURUUCYBUU
      RUVDUUCUWGUVDUVAUVRMZYBUUCUVCUVRUVAUWFWPYBUWHUUCYBUWHMZUUBUAYGUWIYPYGJZMZ
      YSUUAUWKYSYRYGJZYRCLZYCJZYBUVAUWJUWLUVRYBUWJUVAUWLXSXTUWJUVAMUWLYAXSUWJUV
      AUWLYPYKAYFYQYGUUHYQNZUUIWQWRWSXAXBUWKUWMEOUWNUWKUWMYPCLZUVBBUNLZKZUWPEUW
      QKZEYBUVAUWJUWMUWROZUVRYBUWJUVAUWTYPYKABCYFYQUWQYGUUHUUIUWOUWQNZXCXAXBUWH
      UWRUWSOZYBUWJUVRUXBUVAUVBEUWPUWQXDVNXIYBUWJUWSEOZUWHYBUWJUWPUUFJZUXCYPABC
      YFDYGUUFUUHUUIFUUJXEZXTXSUXDUXCYAUWPBDUWQUUFEGUUJFUXAXFXGXHXJWBUWMEYRCPQV
      EYBYSUWLUWNMRZUWHUWJYBUUGUUPUXFUUKUUQYGYRYCCSTWAVGUWKUUAYTYGJZYTCLZYCJZYB
      UVAUWJUXGUVRYBUVAUWJUXGXSXTUVAUWJMUXGYAXSUVAUWJUXGYKYPAYFYQYGUUHUWOUUIWQW
      RWSXKXBUWKUXHEOUXIUWKUXHUVBUWPUWQKZEUWPUWQKZEYBUVAUWJUXHUXJOZUVRYBUVAUWJU
      XLYKYPABCYFYQUWQYGUUHUUIUWOUXAXCXKXBUWHUXJUXKOZYBUWJUVRUXMUVAUVBEUWPUWQXL
      VNXIYBUWJUXKEOZUWHYBUWJUXDUXNUXEXTXSUXDUXNYAUWPBDUWQUUFEGUUJFUXAXMXGXHXJW
      BUXHEYTCPQVEYBUUAUXGUXIMRZUWHUWJYBUUGUUPUXOUUKUUQYGYTYCCSTWAVGXNWOWIWLXOX
      PXNWOXSXTYEYHYJUUEUCRYAHIUAAYFYQYDYGYIUUHUWOUUIUUOXQVDXR $.
  $}

  ${
    $d R r s i x y a b $.  $d X i r s $.  $d H i r s $.
    pridlval.1 $e |- G = ( 1st ` R ) $.
    pridlval.2 $e |- H = ( 2nd ` R ) $.
    pridlval.3 $e |- X = ran G $.
    $( The class of prime ideals of a ring ` R ` .  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    pridlval $p |- ( R e. RingOps -> ( PrIdl ` R ) = { i e. ( Idl ` R ) |
                ( i =/= X /\ A. a e. ( Idl ` R ) A. b e. ( Idl ` R ) (
          A. x e. a A. y e. b ( x H y ) e. i -> ( a C_ i \/ b C_ i ) ) ) } ) $=
      ( vr cv c1st cfv c2nd wral cidl fveq2 crn wne co wcel wo wi wa crab crngo
      wss cpridl wceq syl6eqr rneqd neeq2d oveqd eleq1d 2ralbidv imbi1d anbi12d
      raleqbidv rabeqbidv df-pridl fvex rabex fvmpt ) MCDNZMNZOPZUAZUBZANZBNZVH
      QPZUCZVGUDZBINZRAHNZRZVRVGUJVQVGUJUEZUFZIVHSPZRZHWBRZUGZDWBUHVGGUBZVLVMFU
      CZVGUDZBVQRAVRRZVTUFZICSPZRZHWKRZUGZDWKUHUIUKVHCULZWEWNDWBWKVHCSTZWOVKWFW
      DWMWOVJGVGWOVJEUAGWOVIEWOVICOPEVHCOTJUMUNLUMUOWOWCWLHWBWKWPWOWAWJIWBWKWPW
      OVSWIVTWOVPWHABVRVQWOVOWGVGWOVNFVLVMWOVNCQPFVHCQTKUMUPUQURUSVAVAUTVBABDMH
      IVCWNDWKCSVDVEVF $.

    $d P i x y a b $.
    $( The predicate "is a prime ideal".  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    ispridl $p |- ( R e. RingOps -> ( P e. ( PrIdl ` R ) <-> ( P e. ( Idl ` R )
                /\ P =/= X /\ A. a e. ( Idl ` R ) A. b e. ( Idl ` R )
        ( A. x e. a A. y e. b ( x H y ) e. P -> ( a C_ P \/ b C_ P ) ) ) ) ) $=
      ( vi wcel cfv cv wne wral wss wa crngo cpridl co wo wi cidl crab pridlval
      w3a eleq2d wceq neeq1 eleq2 2ralbidv sseq2 orbi12d imbi12d anbi12d 3anass
      elrab bitr4i syl6bb ) DUANZCDUBOZNCMPZGQZAPBPFUCZVENZBIPZRAHPZRZVJVESZVIV
      ESZUDZUEZIDUFOZRHVPRZTZMVPUGZNZCVPNZCGQZVGCNZBVIRAVJRZVJCSZVICSZUDZUEZIVP
      RHVPRZUIZVCVDVSCABDMEFGHIJKLUHUJVTWAWBWITZTWJVRWKMCVPVECUKZVFWBVQWIVECGUL
      WLVOWHHIVPVPWLVKWDVNWGWLVHWCABVJVIVECVGUMUNWLVLWEVMWFVECVJUOVECVIUOUPUQUN
      URUTWAWBWIUSVAVB $.
  $}

  ${
    $d R x y a b $.  $d P x y a b $.
    $( A prime ideal is an ideal.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    pridlidl $p |- ( ( R e. RingOps /\ P e. ( PrIdl ` R ) )
                                            -> P e. ( Idl ` R ) ) $=
      ( vx vy vb va crngo wcel cpridl cfv cidl c1st crn wne cv c2nd wral wss wa
      eqid co wo wi w3a ispridl 3anass syl6bb simprbda ) BGHZABIJHZABKJZHZABLJZ
      MZNZCODOBPJZUAAHDEOZQCFOZQURARUQARUBUCEUKQFUKQZSZUIUJULUOUSUDULUTSCDABUMU
      PUNFEUMTUPTUNTUEULUOUSUFUGUH $.
  $}

  ${
    $d R x y a b $.  $d P x y a b $.
    pridlnr.1 $e |- G = ( 1st ` R ) $.
    prdilnr.2 $e |- X = ran G $.
    $( A prime ideal is a proper ideal.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    pridlnr $p |- ( ( R e. RingOps /\ P e. ( PrIdl ` R ) ) -> P =/= X ) $=
      ( vx vy vb va crngo wcel cpridl cfv wne cidl cv wral wss wa c2nd co wo wi
      w3a eqid ispridl 3anan12 syl6bb simprbda ) BKLZABMNLZADOZABPNZLZGQHQBUANZ
      UBALHIQZRGJQZRURASUQASUCUDIUNRJUNRZTZUKULUOUMUSUEUMUTTGHABCUPDJIEUPUFFUGU
      OUMUSUHUIUJ $.
  $}

  ${
    $d R x y a b $.  $d P x y a b $.  $d A x a b $.  $d B x y a b $.
    $d H a b $.
    pridl.1 $e |- H = ( 2nd ` R ) $.
    $( The main property of a prime ideal.  (Contributed by Jeff Madsen,
       19-Jun-2010.) $)
    pridl $p |- ( ( ( R e. RingOps /\ P e. ( PrIdl ` R ) ) /\
                        ( A e. ( Idl ` R ) /\ B e. ( Idl ` R ) /\
            A. x e. A A. y e. B ( x H y ) e. P ) ) -> ( A C_ P \/ B C_ P ) ) $=
      ( vb va wcel cfv wa cv wral wss wo wi eqid wceq crngo cpridl cidl co c1st
      crn wne ispridl df-3an syl6bb simplbda raleq sseq1 orbi1d imbi12d ralbidv
      w3a orbi2d rspc2v syl5com exp3a 3imp2 ) FUAKZEFUBLKZMZCFUCLZKZDVFKZANBNGU
      DEKZBDOZACOZCEPZDEPZQZVEVGVHVKVNRZVEVIBINZOZAJNZOZVREPZVPEPZQZRZIVFOJVFOZ
      VGVHMVOVCVDEVFKZEFUELZUFZUGZMZWDVCVDWEWHWDUQWIWDMABEFWFGWGJIWFSHWGSUHWEWH
      WDUIUJUKWCVOVQACOZVLWAQZRJICDVFVFVRCTZVSWJWBWKVQAVRCULWLVTVLWAVRCEUMUNUOV
      PDTZWJVKWKVNWMVQVJACVIBVPDULUPWMWAVMVLVPDEUMURUOUSUTVAVB $.
  $}

  ${
    $d R a b r s $.  $d P a b r s $.  $d X a b r s $.  $d H r s $.
    ispridl2.1 $e |- G = ( 1st ` R ) $.
    ispridl2.2 $e |- H = ( 2nd ` R ) $.
    ispridl2.3 $e |- X = ran G $.
    $( A condition that shows an ideal is prime.  For commutative rings, this
       is often taken to be the definition.  See ~ ispridlc for the equivalence
       in the commutative case.  (Contributed by Jeff Madsen, 19-Jun-2010.) $)
    ispridl2 $p |- ( ( R e. RingOps /\ ( P e. ( Idl ` R ) /\ P =/= X /\
          A. a e. X A. b e. X ( ( a H b ) e. P -> ( a e. P \/ b e. P ) ) ) )
                              -> P e. ( PrIdl ` R ) ) $=
      ( vs vr wcel cv wo wi wral wss wa syl crngo cidl cfv wne w3a cpridl idlss
      ssralv adantrr ralimdv adantrl syld adantlr r19.26-2 pm3.35 ralimi 2ralor
      co biimpi dfss3 orbi12i sylibr sylbir expcom syl6 ralrimdvva ex imdistand
      adantrd df-3an 3imtr4g ispridl sylibrd imp ) BUAMZABUBUCZMZAEUDZFNZGNZDUR
      AMZVSAMZVTAMZOZPZGEQZFEQZUEZABUFUCMZVOWHVQVRWAGKNZQFLNZQZWKARZWJARZOZPZKV
      PQLVPQZUEZWIVOVQVRSZWGSWSWQSWHWRVOWSWGWQVOVQWGWQPZVRVOVQWTVOVQSZWGWPLKVPV
      PXAWKVPMZWJVPMZSZSWGWEGWJQZFWKQZWPVOXDWGXFPVQVOXDSWGWFFWKQZXFVOXBWGXGPZXC
      VOXBSWKERXHBCWKEHJUGWFFWKEUHTUIVOXCXGXFPZXBVOXCSWJERZXIBCWJEHJUGXJWFXEFWK
      WEGWJEUHUJTUKULUMWLXFWOWLXFSWAWESZGWJQZFWKQZWOWAWEFGWKWJUNXMWDGWJQZFWKQZW
      OXLXNFWKXKWDGWJWAWDUOUPUPXOWBFWKQZWCGWJQZOZWOXOXRWBWCFGWKWJUQUSWMXPWNXQFW
      KAUTGWJAUTVAVBTVCVDVEVFVGVIVHVQVRWGVJVQVRWQVJVKFGABCDELKHIJVLVMVN $.
  $}

  ${
    $d R i j r s $.  $d X r s $.
    maxidlval.1 $e |- G = ( 1st ` R ) $.
    maxidlval.2 $e |- X = ran G $.
    $( The set of maximal ideals of a ring.  (Contributed by Jeff Madsen,
       5-Jan-2011.) $)
    maxidlval $p |- ( R e. RingOps -> ( MaxIdl ` R ) =
                              { i e. ( Idl ` R ) | ( i =/= X /\
                A. j e. ( Idl ` R ) ( i C_ j -> ( j = i \/ j = X ) ) ) } ) $=
      ( vr cv c1st cfv crn wne wceq wo wi cidl wral wa crab crngo cmaxidl fveq2
      wss syl6eqr rneqd neeq2d eqeq2d orbi2d imbi2d raleqbidv anbi12d rabeqbidv
      df-maxidl fvex rabex fvmpt ) HABIZHIZJKZLZMZURCIZUDZVCURNZVCVANZOZPZCUSQK
      ZRZSZBVITUREMZVDVEVCENZOZPZCAQKZRZSZBVPTUAUBUSANZVKVRBVIVPUSAQUCZVSVBVLVJ
      VQVSVAEURVSVADLEVSUTDVSUTAJKDUSAJUCFUEUFGUEZUGVSVHVOCVIVPVTVSVGVNVDVSVFVM
      VEVSVAEVCWAUHUIUJUKULUMBCHUNVRBVPAQUOUPUQ $.
  $}

  ${
    $d R i j $.  $d M i j $.  $d X i $.
    ismaxidl.1 $e |- G = ( 1st ` R ) $.
    ismaxidl.2 $e |- X = ran G $.
    $( The predicate "is a maximal ideal".  (Contributed by Jeff Madsen,
       5-Jan-2011.) $)
    ismaxidl $p |- ( R e. RingOps -> ( M e. ( MaxIdl ` R ) <->
                              ( M e. ( Idl ` R ) /\ M =/= X /\
                A. j e. ( Idl ` R ) ( M C_ j -> ( j = M \/ j = X ) ) ) ) ) $=
      ( vi crngo wcel cmaxidl cfv cv wne wss wceq wo wi wral wa cidl w3a eleq2d
      crab neeq1 sseq1 eqeq2 orbi1d imbi12d ralbidv anbi12d elrab 3anass bitr4i
      maxidlval syl6bb ) AIJZDAKLZJDHMZENZUSBMZOZVAUSPZVAEPZQZRZBAUALZSZTZHVGUD
      ZJZDVGJZDENZDVAOZVADPZVDQZRZBVGSZUBZUQURVJDAHBCEFGUOUCVKVLVMVRTZTVSVIVTHD
      VGUSDPZUTVMVHVRUSDEUEWAVFVQBVGWAVBVNVEVPUSDVAUFWAVCVOVDUSDVAUGUHUIUJUKULV
      LVMVRUMUNUP $.
  $}

  ${
    $d R j $.  $d M j $.
    $( A maximal ideal is an ideal.  (Contributed by Jeff Madsen,
       5-Jan-2011.) $)
    maxidlidl $p |- ( ( R e. RingOps /\ M e. ( MaxIdl ` R ) )
                                                -> M e. ( Idl ` R ) ) $=
      ( vj crngo wcel cmaxidl cfv cidl c1st crn wne cv wss wceq wo wi wral eqid
      wa w3a ismaxidl 3anass syl6bb simprbda ) ADEZBAFGEZBAHGZEZBAIGZJZKZBCLZMU
      LBNULUJNOPCUGQZSZUEUFUHUKUMTUHUNSACUIBUJUIRUJRUAUHUKUMUBUCUD $.

    $d R j $.  $d M j $.
    maxidlnr.1 $e |- G = ( 1st ` R ) $.
    maxidlnr.2 $e |- X = ran G $.
    $( A maximal ideal is proper.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    maxidlnr $p |- ( ( R e. RingOps /\ M e. ( MaxIdl ` R ) ) -> M =/= X ) $=
      ( vj crngo wcel cmaxidl cfv wa cidl wne cv wss wceq wo wi wral w3a biimpa
      ismaxidl simp2d ) AHIZCAJKIZLCAMKZIZCDNZCGOZPUJCQUJDQRSGUGTZUEUFUHUIUKUAA
      GBCDEFUCUBUD $.

    $d I j $.  $d X j $.
    $( A maximal ideal is a maximal proper ideal.  (Contributed by Jeff Madsen,
       16-Jun-2011.) $)
    maxidlmax $p |- ( ( ( R e. RingOps /\ M e. ( MaxIdl ` R ) ) /\
                ( I e. ( Idl ` R ) /\ M C_ I ) ) -> ( I = M \/ I = X ) ) $=
      ( vj crngo wcel cmaxidl cfv wa cidl wss wceq wo wi cv eqeq1 wral ismaxidl
      wne w3a biimpa simp3d sseq2 orbi12d imbi12d rspcva sylan2 ancoms impr ) A
      IJZDAKLJZMZCANLZJZDCOZCDPZCEPZQZURUPUSVBRZUPURDHSZOZVDDPZVDEPZQZRZHUQUAZV
      CUPDUQJZDEUCZVJUNUOVKVLVJUDAHBDEFGUBUEUFVIVCHCUQVDCPZVEUSVHVBVDCDUGVMVFUT
      VGVAVDCDTVDCETUHUIUJUKULUM $.
  $}

  ${
    maxidln1.1 $e |- H = ( 2nd ` R ) $.
    maxidln1.2 $e |- U = ( GId ` H ) $.
    $( One is not contained in any maximal ideal.  (Contributed by Jeff Madsen,
       17-Jun-2011.) $)
    maxidln1 $p |- ( ( R e. RingOps /\ M e. ( MaxIdl ` R ) ) -> -. U e. M ) $=
      ( crngo wcel cmaxidl cfv wa wn c1st crn wne eqid maxidlnr cidl maxidlidl
      wb 1idl necon3bbid syldan mpbird ) AGHZDAIJHZKBDHZLZDAMJZNZOZAUIDUJUIPZUJ
      PZQUEUFDARJHZUHUKTADSUEUNKUGDUJABUICDUJULEUMFUAUBUCUD $.
  $}

  ${
    maxidln0.1 $e |- G = ( 1st ` R ) $.
    maxidln0.2 $e |- H = ( 2nd ` R ) $.
    maxidln0.3 $e |- Z = ( GId ` G ) $.
    maxidln0.4 $e |- U = ( GId ` H ) $.
    $( A ring with a maximal ideal is not the zero ring.  (Contributed by Jeff
       Madsen, 17-Jun-2011.) $)
    maxidln0 $p |- ( ( R e. RingOps /\ M e. ( MaxIdl ` R ) ) -> U =/= Z ) $=
      ( crngo wcel cmaxidl cfv wa wn wceq cidl maxidlidl idl0cl syldan maxidln1
      nelneq syl2anc neneqad necomd ) AKLZEAMNLZOZFBUIFBUIFELZBELPFBQPUGUHEARNL
      UJAESACEFGITUAABDEHJUBFBEUCUDUEUF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Prime rings and integral domains
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c PrRing $.
  $c Dmn $.

  $( Extend class notation with the class of prime rings. $)
  cprrng $a class PrRing $.

  $( Extend class notation with the class of domains. $)
  cdmn $a class Dmn $.

  $( Define the class of prime rings.  A ring is prime if the zero ideal is a
     prime ideal.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
  df-prrngo $a |- PrRing = { r e. RingOps |
                              { ( GId ` ( 1st ` r ) ) } e. ( PrIdl ` r ) } $.

  $( Define the class of (integral) domains.  A domain is a commutative prime
     ring.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
  df-dmn $a |- Dmn = ( PrRing i^i Com2 ) $.

  ${
    $d R r $.  $d Z r $.  $d U r $.
    isprrng.1 $e |- G = ( 1st ` R ) $.
    isprrng.2 $e |- Z = ( GId ` G ) $.
    $( The predicate "is a prime ring".  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    isprrngo $p |- ( R e. PrRing <-> ( R e. RingOps
                                        /\ { Z } e. ( PrIdl ` R ) ) ) $=
      ( vr cv c1st cfv cgi csn cpridl wcel crngo cprrng wceq fveq2 fveq2d sneqd
      syl6eqr eleq12d df-prrngo elrab2 ) FGZHIZJIZKZUDLIZMCKZALIZMFANOUDAPZUGUI
      UHUJUKUFCUKUFBJICUKUEBJUKUEAHIBUDAHQDTRETSUDALQUAFUBUC $.
  $}

  $( A prime ring is a ring.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
  prrngorngo $p |- ( R e. PrRing -> R e. RingOps ) $=
    ( cprrng wcel crngo c1st cfv cgi csn cpridl eqid isprrngo simplbi ) ABCADCA
    EFZGFZHAIFCAMNMJNJKL $.

  ${
    $d R i j x y $.  $d H x y $.  $d X i j x y $.  $d Z i j x y $.
    $d U i j x y $.
    smprngpr.1 $e |- G = ( 1st ` R ) $.
    smprngpr.2 $e |- H = ( 2nd ` R ) $.
    smprngpr.3 $e |- X = ran G $.
    smprngpr.4 $e |- Z = ( GId ` G ) $.
    smprngpr.5 $e |- U = ( GId ` H ) $.
    $( A simple ring (one whose only ideals are ` 0 ` and ` R ` ) is a prime
       ring.  (Contributed by Jeff Madsen, 6-Jan-2011.) $)
    smprngopr $p |- ( ( R e. RingOps /\ U =/= Z
          /\ ( Idl ` R ) = { { Z } , X } ) -> R e. PrRing ) $=
      ( vx vy vj vi wcel wceq wral wi wa wne cidl cfv csn cpr w3a cpridl cprrng
      crngo simp1 cv co wss 0idl 3ad2ant1 0rngo eqcom 3bitr4g necon3bid 3adant3
      wo biimpa cun df-pr eqeq2i eleq2 anbi12d elun elsn orbi12i anbi12i syl6bb
      bitri sylbi 3ad2ant3 eqimss orcd adantr a1d a1i olcd adantl wrex crn c1st
      wb wn rneqi eqtri rngo1cl rngolidm eleq1d cgi cvv fvex eqeltri necon3bbid
      mpdan elsnc biimpar oveq1 notbid oveq2 rspc2ev syl3anc rexnal sylib raleq
      rexbii pm2.21d ralbidv sylan9bb imbi1d syl5ibrcom ccased sylbid ralrimivv
      ispridl mpbir3and isprrngo sylanbrc ) AUIPZBFUAZAUBUCZFUDZEUEZQZUFZYBYEAU
      GUCPZAUHPYBYCYGUJYHYIYEYDPZYEEUAZLUKZMUKZDULZYEPZMNUKZRZLOUKZRZYRYEUMZYPY
      EUMZVAZSZNYDROYDRZYBYCYJYGACFGJUNUOYBYCYKYGYBYCYKYBBFYEEYBFBQEYEQBFQZYEEQ
      ABCDEFGHIJKUPBFUQYEEUQURUSVBUTYHUUCONYDYDYHYRYDPZYPYDPZTZYRYEQZYREQZVAZYP
      YEQZYPEQZVAZTZUUCYGYBUUHUUOWFZYCYGYDYEUDZEUDZVCZQZUUPYFUUSYDYEEVDVEUUTUUH
      YRUUSPZYPUUSPZTUUOUUTUUFUVAUUGUVBYDUUSYRVFYDUUSYPVFVGUVAUUKUVBUUNUVAYRUUQ
      PZYRUURPZVAUUKYRUUQUURVHUVCUUIUVDUUJOYEVIOEVIVJVMUVBYPUUQPZYPUURPZVAUUNYP
      UUQUURVHUVEUULUVFUUMNYEVINEVIVJVMVKVLVNVOYBYCUUOUUCSYGYBYCTZUUIUULUUJUUMU
      UCUUIUULTZUUCSUVGUVHUUBYSUUIUUBUULUUIYTUUAYRYEVPVQZVRVSVTUUJUULTZUUCSUVGU
      VJUUBYSUULUUBUUJUULUUAYTYPYEVPWAWBVSVTUUIUUMTZUUCSUVGUVKUUBYSUUIUUBUUMUVI
      VRVSVTUVGUUCUUJUUMTZYOMERZLERZUUBSUVGUVNUUBUVGYOWGZMEWCZLEWCZUVNWGZUVGBEP
      ZUVSBBDULZYEPZWGZUVQYBUVSYCABDEECWDAWEUCZWDICUWCGWHWIZHKWJZVRZUWFYBUWBYCY
      BUWABFYBUWABYEPUUEYBUVTBYEYBUVSUVTBQUWEBABDEHUWDKWKWRWLBFBDWMUCWNKDWMWOWP
      WSVLWQWTUVOUWBBYMDULZYEPZWGLMBBEEYLBQZYOUWHUWIYNUWGYEYLBYMDXAWLXBYMBQZUWH
      UWAUWJUWGUVTYEYMBBDXCWLXBXDXEUVQUVMWGZLEWCUVRUVPUWKLEYOMEXFXIUVMLEXFVMXGX
      JUVLYSUVNUUBUUJYSYQLERUUMUVNYQLYREXHUUMYQUVMLEYOMYPEXHXKXLXMXNXOUTXPXQYBY
      CYIYJYKUUDUFWFYGLMYEACDEONGHIXRUOXSACFGJXTYA $.
  $}

  $( A division ring is a prime ring.  (Contributed by Jeff Madsen,
     6-Jan-2011.) $)
  divrngpr $p |- ( R e. DivRingOps -> R e. PrRing ) $=
    ( cdrng wcel crngo c2nd cfv cgi c1st wne cidl csn crn wceq cprrng cdif cres
    cpr cxp cgr eqid isdrngo1 simplbi dvrunz divrngidl smprngopr syl3anc ) ABCZ
    ADCZAEFZGFZAHFZGFZIAJFULKZUKLZQMANCUGUHUIUNUMOZUORPSCAUKUIUNULUKTZUITZULTZU
    NTZUAUBAUJUKUIUNULUPUQUSURUJTZUCAUKUIUNULUPUQUSURUDAUJUKUIUNULUPUQUSURUTUEU
    F $.

  $( The predicate "is a domain".  (Contributed by Jeff Madsen,
     10-Jun-2010.) $)
  isdmn $p |- ( R e. Dmn <-> ( R e. PrRing /\ R e. Com2 ) ) $=
    ( cprrng ccm2 cdmn df-dmn elin2 ) ABCDEF $.

  $( The predicate "is a domain".  (Contributed by Jeff Madsen,
     10-Jun-2010.) $)
  isdmn2 $p |- ( R e. Dmn <-> ( R e. PrRing /\ R e. CRingOps ) ) $=
    ( cdmn wcel cprrng ccm2 wa ccring isdmn crngo wb prrngorngo iscrngo pm5.32i
    baibr syl bitri ) ABCADCZAECZFQAGCZFAHQRSQAICZRSJAKSTRALNOMP $.

  $( A domain is a commutative ring.  (Contributed by Jeff Madsen,
     6-Jan-2011.) $)
  dmncrng $p |- ( R e. Dmn -> R e. CRingOps ) $=
    ( cdmn wcel cprrng ccring isdmn2 simprbi ) ABCADCAECAFG $.

  $( A domain is a ring.  (Contributed by Jeff Madsen, 6-Jan-2011.) $)
  dmnrngo $p |- ( R e. Dmn -> R e. RingOps ) $=
    ( cdmn wcel ccring crngo dmncrng crngorngo syl ) ABCADCAECAFAGH $.

  $( A field is a domain.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
  flddmn $p |- ( K e. Fld -> K e. Dmn ) $=
    ( cdrng wcel ccring cprrng cfld cdmn divrngpr anim1i isfld2 isdmn2 3imtr4i
    wa ) ABCZADCZMAECZOMAFCAGCNPOAHIAJAKL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ideal generators
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c IdlGen $.

  $( Extend class notation with the ideal generation function. $)
  cigen $a class IdlGen $.

  ${
    $d r s i j $.
    $( Define the ideal generated by a subset of a ring.  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    df-igen $a |- IdlGen = ( r e. RingOps , s e. ~P ran ( 1st ` r ) |->
                      |^| { j e. ( Idl ` r ) | s C_ j } ) $.
  $}

  ${
    $d R r s i j $.  $d S r s i j $.  $d X r s i j $.  $d I j $.
    igenval.1 $e |- G = ( 1st ` R ) $.
    igenval.2 $e |- X = ran G $.
    $( The ideal generated by a subset of a ring.  (Contributed by Jeff Madsen,
       10-Jun-2010.)  (Proof shortened by Mario Carneiro, 20-Dec-2013.) $)
    igenval $p |- ( ( R e. RingOps /\ S C_ X ) -> ( R IdlGen S ) =
                                        |^| { j e. ( Idl ` R ) | S C_ j } ) $=
      ( vr vs crngo wcel wss cv cidl cfv crab cint cvv wceq c1st cigen co wa c0
      wne wrex rngoidl sseq2 rspcev sylan rabn0 sylibr intex sylib cpw crn fvex
      eqeltri elpw2 simpl fveq2d wb sseq1 adantl rabeqbidv inteqd fveq2 syl6eqr
      rnex rneqd pweqd df-igen ovmpt2x syl3an2br mpd3an3 ) AJKZBELZBCMZLZCANOZP
      ZQZRKZABUAUBWBSZVPVQUCZWAUDUEZWCWEVSCVTUFZWFVPEVTKVQWGADEFGUGVSVQCEVTVREB
      UHUIUJVSCVTUKULWAUMUNVQVPBEUOZKWCWDBEEDUPZRGDDATOZRFATUQURVIURUSHIABJHMZT
      OZUPZUOIMZVRLZCWKNOZPZQWBUARWHWKASZWNBSZUCZWQWAWTWOVSCWPVTWTWKANWRWSUTVAW
      SWOVSVBWRWNBVRVCVDVEVFWRWMEWRWMWIEWRWLDWRWLWJDWKATVGFVHVJGVHVKCIHVLVMVNVO
      $.

    $( A set is a subset of the ideal it generates.  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    igenss $p |- ( ( R e. RingOps /\ S C_ X ) -> S C_ ( R IdlGen S ) ) $=
      ( vj crngo wcel wss wa cv cidl cfv crab cint cigen co ssintub igenval
      syl5sseqr ) AHIBDJKBGLJGAMNZOPBABQRGBUBSABGCDEFTUA $.

    $( The ideal generated by a set is an ideal.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    igenidl $p |- ( ( R e. RingOps /\ S C_ X ) ->
                              ( R IdlGen S ) e. ( Idl ` R ) ) $=
      ( vj crngo wcel wss wa cigen co cv cidl cfv crab cint igenval c0 wne wrex
      rngoidl sseq2 rspcev sylan sylibr ssrab2 intidl mp3an3 syldan eqeltrd
      rabn0 ) AHIZBDJZKZABLMBGNZJZGAOPZQZRZUSABGCDEFSUNUOUTTUAZVAUSIZUPURGUSUBZ
      VBUNDUSIUOVDACDEFUCURUOGDUSUQDBUDUEUFURGUSUMUGUNVBUTUSJVCURGUSUHUTAUIUJUK
      UL $.
  $}

  ${
    $d R j $.  $d S j $.  $d I j $.
    $( The ideal generated by a set is the minimal ideal containing that set.
       (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    igenmin $p |- ( ( R e. RingOps /\ I e. ( Idl ` R ) /\ S C_ I )
                                              -> ( R IdlGen S ) C_ I ) $=
      ( vj crngo wcel cidl cfv wss w3a cigen co cv crab cint wceq c1st crn eqid
      idlss wa sstr ancoms igenval anassrs syldanl 3impa sseq2 intminss 3adant1
      sylan2 eqsstrd ) AEFZCAGHZFZBCIZJABKLZBDMZIZDUNNOZCUMUOUPUQUTPZUMUOCAQHZR
      ZIZUPVAAVBCVCVBSZVCSZTUMVDUPVAVDUPUAUMBVCIZVAUPVDVGBCVCUBUCABDVBVCVEVFUDU
      KUEUFUGUOUPUTCIUMUSUPDCUNURCBUHUIUJUL $.

    $( The ideal generated by an ideal is that ideal.  (Contributed by Jeff
       Madsen, 10-Jun-2010.) $)
    igenidl2 $p |- ( ( R e. RingOps /\ I e. ( Idl ` R ) )
                                          -> ( R IdlGen I ) = I ) $=
      ( vj crngo wcel cidl cfv wa cigen co cv wss crab cint c1st crn wceq idlss
      eqid igenval syldan intmin adantl eqtrd ) ADEZBAFGZEZHABIJZBCKLCUFMNZBUEU
      GBAOGZPZLUHUIQAUJBUKUJSZUKSZRABCUJUKULUMTUAUGUIBQUECBUFUBUCUD $.
  $}

  ${
    $d R i j $.  $d S i j $.  $d I j $.  $d X i $.
    igenval2.1 $e |- G = ( 1st ` R ) $.
    igenval2.2 $e |- X = ran G $.
    $( The ideal generated by a subset of a ring.  (Contributed by Jeff Madsen,
       10-Jun-2010.) $)
    igenval2 $p |- ( ( R e. RingOps /\ S C_ X ) -> ( ( R IdlGen S ) = I <->
                                  ( I e. ( Idl ` R ) /\ S C_ I /\
                          A. j e. ( Idl ` R ) ( S C_ j -> I C_ j ) ) ) ) $=
      ( vi wcel wss wa wceq cv wi wral w3a igenmin adantr sseq2 crngo cigen cfv
      co cidl igenidl igenss 3expia ralrimiva 3jca eleq1 sseq1 imbi2d 3anbi123d
      ralbidv syl5ibcom 3adant3r3 adantlr crab cint ralrab biimpri ssint sylibr
      3ad2ant3 adantl igenval sseqtr4d eqssd ex impbid ) AUAJZBFKZLZABUBUDZEMZE
      AUEUCZJZBEKZBCNZKZEVTKZOZCVQPZQZVNVOVQJZBVOKZWAVOVTKZOZCVQPZQVPWEVNWFWGWJ
      ABDFGHUFABDFGHUGVLWJVMVLWICVQVLVTVQJWAWHABVTRUHUISUJVPWFVRWGVSWJWDVOEVQUK
      VOEBTVPWIWCCVQVPWHWBWAVOEVTULUMUOUNUPVNWEVPVNWELZVOEVLWEVOEKZVMVLVRVSWLWD
      ABERUQURWKEBINZKZIVQUSZUTZVOWEEWPKZVNWDVRWQVSWDWBCWOPZWQWRWDWNWAWBCIVQWMV
      TBTVAVBCEWOVCVDVEVFVNVOWPMWEABIDFGHVGSVHVIVJVK $.
  $}

  ${
    $d R j x y u v w r s $.  $d X j x y u v w r s $.  $d G x y r s $.
    $d H j x y u v w r s $.  $d A j x y u v w r s $.
    prnc.1 $e |- G = ( 1st ` R ) $.
    prnc.2 $e |- H = ( 2nd ` R ) $.
    prnc.3 $e |- X = ran G $.
    $( A principal ideal (an ideal generated by one element) in a commutative
       ring.  (Contributed by Jeff Madsen, 10-Jun-2010.) $)
    prnc $p |- ( ( R e. CRingOps /\ A e. X ) -> ( R IdlGen { A } ) =
                                  { x e. X | E. y e. X x = ( y H A ) } ) $=
      ( vv vw wcel wa co cv wceq wrex wral oveq1 vj vu vr ccring csn cigen crab
      vs cidl cfv wss wi w3a cgi crngo crngorngo ssrab2 a1i eqid rngo0cl adantr
      rngolz eqcomd eqeq2d rspcev syl2anc eqeq1 rexbidv sylanbrc cbvrexv syl6bb
      elrab rngodir 3exp2 imp42 3expib imdistani rngocl 3expa ad2antlr eqeltrrd
      rngogcl mpan2 sylan an32s anassrs oveq2 eleq1d rexlimdva adantld ralrimiv
      syl5ibrcom syl5bi rngoass anass1rs jca ralbidv anbi12d 3jca isidlc mpbird
      ralrimiva simpr crn c1st rneqi eqtri rngo1cl rngolidm snssd snssg biimpar
      wb idllmulcl eleq1 rabss sylibr ex syl5 expdimp snssi igenval2 syl2an ) D
      UDMZCGMZNZDCUEZUFOAPZBPZCFOZQZBGRZAGUGZQZYMDUIUJZMZYGYMUKZYGUAPZUKZYMYRUK
      ZULZUAYOSZUMZYFYPYQUUBYFYPYMGUKZEUNUJZYMMZUBPZKPZEOZYMMZKYMSZLPZUUGFOZYMM
      ZLGSZNZUBYMSZUMZYDDUOMZYEUURDUPZUUSYENZUUDUUFUUQUUDUVAYLAGUQURUVAUUEGMZUU
      EYJQZBGRZUUFUUSUVBYEDEGUUEHJUUEUSZUTVAZUVAUVBUUEUUECFOZQZUVDUVFUVAUVGUUEC
      DEFGUUEUVEJHIVBVCUVCUVHBUUEGYIUUEQYJUVGUUEYIUUECFTVDVEVFYLUVDAUUEGYHUUEQY
      KUVCBGYHUUEYJVGVHVLVIUVAUUPUBYMUUGYMMUUGGMZUUGUCPZCFOZQZUCGRZNUVAUUPYLUVM
      AUUGGYHUUGQZYLUUGYJQZBGRUVMUVNYKUVOBGYHUUGYJVGVHUVOUVLBUCGYIUVJQYJUVKUUGY
      IUVJCFTVDVJVKVLUVAUVMUUPUVIUVAUVLUUPUCGUVAUVJGMZNZUUPUVLUVKUUHEOZYMMZKYMS
      ZUULUVKFOZYMMZLGSZNUVQUVTUWCUVQUVSKYMUUHYMMUUHGMZUUHUHPZCFOZQZUHGRZNUVQUV
      SYLUWHAUUHGYHUUHQZYLUUHYJQZBGRUWHUWIYKUWJBGYHUUHYJVGVHUWJUWGBUHGYIUWEQYJU
      WFUUHYIUWECFTVDVJVKVLUVQUWHUVSUWDUVQUWGUVSUHGUVQUWEGMZNUVSUWGUVKUWFEOZYMM
      ZUVAUVPUWKUWMUUSUVPUWKNZYEUWMUUSUWNNZYENUVJUWEEOZCFOZUWLYMUUSUVPUWKYEUWQU
      WLQZUUSUVPUWKYEUWRUVJUWECDEFGHIJVMVNVOUWOUUSUWPGMZNZYEUWQYMMZUUSUWNUWSUUS
      UVPUWKUWSUVJUWEDEGHJWBVPVQUWTYENUWQGMZUWQYJQZBGRZUXAUUSUWSYEUXBUWPCDEFGHI
      JVRVSUWSUXDUUSYEUWSUWQUWQQZUXDUWQUSUXCUXEBUWPGYIUWPQYJUWQUWQYIUWPCFTVDVEW
      CVTYLUXDAUWQGYHUWQQYKUXCBGYHUWQYJVGVHVLVIWDWAWEWFUWGUVRUWLYMUUHUWFUVKEWGW
      HWLWIWJWMWKUVQUWBLGUVAUULGMZUVPUWBUVAUXFUVPNZNUULUVJFOZCFOZUWAYMUUSUXGYEU
      XIUWAQZUUSUXFUVPYEUXJUUSUXFUVPYEUXJUULUVJCDEFGHIJWNVNVOWEUUSUXGYEUXIYMMZU
      USUXGNUUSUXHGMZNZYEUXKUUSUXGUXLUUSUXFUVPUXLUULUVJDEFGHIJVRVPVQUXMYENUXIGM
      ZUXIYJQZBGRZUXKUUSUXLYEUXNUXHCDEFGHIJVRVSUXLUXPUUSYEUXLUXIUXIQZUXPUXIUSUX
      OUXQBUXHGYIUXHQYJUXIUXIYIUXHCFTVDVEWCVTYLUXPAUXIGYHUXIQYKUXOBGYHUXIYJVGVH
      VLVIWDWEWAWOXBWPUVLUUKUVTUUOUWCUVLUUJUVSKYMUVLUUIUVRYMUUGUVKUUHETWHWQUVLU
      UNUWBLGUVLUUMUWAYMUUGUVKUULFWGWHWQWRWLWIWJWMWKWSWDYDYPUURXMYEUBKLDEFYMGUU
      EHIJUVEWTVAXAYFCYMYFYECYJQZBGRZCYMMYDYEXCYDUUSYEUXSUUTUVAFUNUJZGMZCUXTCFO
      ZQZUXSUUSUYAYEDUXTFGGEXDDXEUJZXDJEUYDHXFXGZIUXTUSZXHVAUVAUYBCCDUXTFGIUYEU
      YFXIVCUXRUYCBUXTGYIUXTQYJUYBCYIUXTCFTVDVEVFWDYLUXSACGYHCQYKUXRBGYHCYJVGVH
      VLVIXJYDUUSYEUUBUUTUVAUUAUAYOUUSYRYOMZYEUUAUUSUYGNZYEYSYTYEYSNCYRMZUYHYTY
      EUYIYSCYRGXKXLUYHUYIYTUYHUYINZYLYHYRMZULZAGSYTUYJUYLAGUYJUYLYHGMUYJYKUYKB
      GUYJYIGMZNUYKYKYJYRMZUYHUYIUYMUYNCYIDEFYRGHIJXNWFYHYJYRXOWLWIVAXBYLAGYRXP
      XQXRXSXTWEXBWDWSYDUUSYGGUKYNUUCXMYEUUTCGYADYGUAEYMGHJYBYCXA $.
  $}

  ${
    $d K x y z $.  $d X x y z $.  $d G y z $.  $d H x y z $.  $d U x y z $.
    $d Z x y $.
    isfldidl.1 $e |- G = ( 1st ` K ) $.
    isfldidl.2 $e |- H = ( 2nd ` K ) $.
    isfldidl.3 $e |- X = ran G $.
    isfldidl.4 $e |- Z = ( GId ` G ) $.
    isfldidl.5 $e |- U = ( GId ` H ) $.
    $( Determine if a ring is a field based on its ideals.  (Contributed by
       Jeff Madsen, 10-Jun-2010.) $)
    isfldidl $p |- ( K e. Fld <-> ( K e. CRingOps /\
                                U =/= Z /\ ( Idl ` K ) = { { Z } , X } ) ) $=
      ( vy vx vz wcel wceq syl cv wrex wa cfld wne cidl cfv csn cpr w3a fldcrng
      ccring cdrng flddivrng dvrunz divrngidl 3jca crngo co cdif wral crngorngo
      3ad2ant1 simp2 crab crn c1st rneqi eqtri rngo1cl ad2antrr cigen eldif wss
      snssi igenss sylan2 vex snss biimpri eleq2 syl5ibcom con3and sylan anasss
      wn sylan2b adantlr eldifi snssd igenidl imp an32s ovex elpr sylib ord mpd
      wo sylanl1 prnc eqtr3d eleqtrd eqeq1 rexbidv elrab simprd eqcom ralrimiva
      rexbii sylibr 3adant2 jca32 isdrngo3 simp1 isfld2 sylanbrc impbii ) DUAOZ
      DUIOZAFUBZDUCUDZFUEZEUFZPZUGZXPXQXRYBDUHXPDUJOZXRDUKZDABCEFGHIJKULQXPYDYB
      YEDBCEFGHIJUMQUNYCYDXQXPYCDUOOZXRLRMRZCUPZAPZLESZMEXTUQZURZTTYDYCYFXRYLXQ
      XRYFYBDUSZUTXQXRYBVAXQYBYLXRXQYBTZYJMYKYNYGYKOZTZAYHPZLESZYJYPAEOZYRYPANR
      ZYHPZLESZNEVBZOYSYRTYPAEUUCXQYSYBYOXQYFYSYMDACEEBVCDVDUDZVCIBUUDGVEVFHKVG
      QVHYPDYGUEZVIUPZEUUCXQYFYBYOUUFEPZYMYFYBTYOTZUUFXTPZWCZUUGYFYOUUJYBYOYFYG
      EOZYGXTOZWCZTUUJYGEXTVJYFUUKUUMUUJYFUUKTUUEUUFVKZUUMUUJUUKYFUUEEVKZUUNYGE
      VLDUUEBEGIVMVNUUNUUIUULUUNYGUUFOZUUIUULUUPUUNYGUUFMVOVPVQUUFXTYGVRVSVTWAW
      BWDWEUUHUUIUUGUUHUUFYAOZUUIUUGWPYFYOYBUUQYFYOTZYBUUQUURUUFXSOZYBUUQYOYFUU
      OUUSYOYGEYGEXTWFZWGDUUEBEGIWHVNXSYAUUFVRVSWIWJUUFXTEDUUEVIWKWLWMWNWOWQXQY
      OUUFUUCPZYBYOXQUUKUVAUUTNLYGDBCEGHIWRVNWEWSWTUUBYRNAEYTAPUUAYQLEYTAYHXAXB
      XCWMXDYIYQLEYHAXEXGXHXFXIXJMLDABCEFGHJIKXKXHXQXRYBXLDXMXNXO $.
  $}

  ${
    isfldidl2.1 $e |- G = ( 1st ` K ) $.
    isfldidl2.2 $e |- H = ( 2nd ` K ) $.
    isfldidl2.3 $e |- X = ran G $.
    isfldidl2.4 $e |- Z = ( GId ` G ) $.
    $( Determine if a ring is a field based on its ideals.  (Contributed by
       Jeff Madsen, 6-Jan-2011.) $)
    isfldidl2 $p |- ( K e. Fld <-> ( K e. CRingOps /\
                              X =/= { Z } /\ ( Idl ` K ) = { { Z } , X } ) ) $=
      ( cfld wcel ccring cgi cfv wne cidl wceq w3a wa 3anass csn cpr eqid crngo
      isfldidl wb crngorngo eqcom 0rngo syl5bb necon3bid anbi1d pm5.32i 3bitr4i
      syl bitri ) CJKCLKZBMNZEOZCPNEUAZDUBQZRZUQDUTOZVARZURABCDEFGHIURUCZUEUQUS
      VASZSUQVCVASZSVBVDUQVFVGUQUSVCVAUQUREDUTUQCUDKZUREQZDUTQZUFCUGVIEURQVHVJU
      REUHCURABDEFGHIVEUIUJUOUKULUMUQUSVATUQVCVATUNUP $.
  $}

  ${
    $d R a b x y r s $.  $d P a b x y r s $.  $d X a b x y r s $.
    $d G x y r s $.  $d H a b x y r s $.
    ispridlc.1 $e |- G = ( 1st ` R ) $.
    ispridlc.2 $e |- H = ( 2nd ` R ) $.
    ispridlc.3 $e |- X = ran G $.
    $( The predicate "is a prime ideal".  Alternate definition for commutative
       rings.  (Contributed by Jeff Madsen, 19-Jun-2010.) $)
    ispridlc $p |- ( R e. CRingOps -> ( P e. ( PrIdl ` R ) <-> ( P e. ( Idl ` R
        )
                              /\ P =/= X /\ A. a e. X A. b e. X
                      ( ( a H b ) e. P -> ( a e. P \/ b e. P ) ) ) ) ) $=
      ( vx vy vs vr wcel co wi wral wss wa ccring cpridl cfv cidl wne cv wo w3a
      crngo wb crngorngo ispridl syl cigen snssi igenidl syl2an adantrr adantrl
      csn wceq raleq sseq1 orbi1d imbi12d ralbidv orbi2d rspc2v syl2anc adantlr
      wrex crab cab df-rab syl6eq abeq2d anbi12d adantr reeanv anbi2i an4 bitri
      prnc crngm4 3com23 3expa adantllr syl3an1 3expb idllmulcl sylanl1 anassrs
      rngocl syldan eqeltrrd oveq12 eleq1d syl5ibrcom rexlimdvva adantld sylbid
      syl5bir ralrimivv ex igenss snss sylibr ssel syl5com orim12d imim12d syld
      vex ralrimdvva adantrd imdistand df-3an 3imtr4g ispridl2 impbid ) BUAOZAB
      UBUCOZABUDUCZOZAEUEZFUFZGUFZDPZAOZYFAOZYGAOZUGZQZGERFERZUHZYAYBYDYEKUFZLU
      FZDPZAOZLMUFZRZKNUFZRZUUBASZYTASZUGZQZMYCRNYCRZUHZYOYABUIOZYBUUIUJBUKZKLA
      BCDENMHIJULUMYAYDYETZUUHTUULYNTUUIYOYAUULUUHYNYAYDUUHYNQZYEYAYDUUMYAYDTZU
      UHYMFGEEUUNYFEOZYGEOZTZTZUUHYSLBYGUTZUNPZRZKBYFUTZUNPZRZUVCASZUUTASZUGZQZ
      YMYAUUQUUHUVHQZYDYAUUQTZUVCYCOZUUTYCOZUVIYAUUOUVKUUPYAUUJUVBESZUVKUUOUUKY
      FEUOZBUVBCEHJUPUQURYAUUPUVLUUOYAUUJUUSESZUVLUUPUUKYGEUOZBUUSCEHJUPUQUSUUG
      UVHUUAKUVCRZUVEUUEUGZQNMUVCUUTYCYCUUBUVCVAZUUCUVQUUFUVRUUAKUUBUVCVBUVSUUD
      UVEUUEUUBUVCAVCVDVEYTUUTVAZUVQUVDUVRUVGUVTUUAUVAKUVCYSLYTUUTVBVFUVTUUEUVF
      UVEYTUUTAVCVGVEVHVIVJUURYIUVDUVGYLUURYIUVDUURYITZYSKLUVCUUTUWAYPUVCOZYQUU
      TOZTZYPEOZYPUUBYFDPZVAZNEVKZTZYQEOZYQYTYGDPZVAZMEVKZTZTZYSUURUWDUWOUJZYIY
      AUUQUWPYDUVJUWBUWIUWCUWNYAUUOUWBUWIUJUUPYAUUOTZUWIKUVCUWQUVCUWHKEVLUWIKVM
      KNYFBCDEHIJWCUWHKEVNVOVPURYAUUPUWCUWNUJUUOYAUUPTZUWNLUUTUWRUUTUWMLEVLUWNL
      VMLMYGBCDEHIJWCUWMLEVNVOVPUSVQVJVRUWOUWEUWJTZUWGUWLTZMEVKNEVKZTZUWAYSUXBU
      WSUWHUWMTZTUWOUXAUXCUWSUWGUWLNMEEVSVTUWEUWJUWHUWMWAWBUWAUXAYSUWSUWAUWTYSN
      MEEUWAUUBEOZYTEOZTZTZYSUWTUWFUWKDPZAOUXGUUBYTDPZYHDPZUXHAUURUXFUXJUXHVAZY
      IYAUUQUXFUXKYDYAUUQUXFUXKYAUXFUUQUXKUUBYTYFYGBCDEHIJWDWEWFWGVJUUNYIUXFUXJ
      AOZUUQUUNYITUXFUXIEOZUXLUUNUXFUXMYIYAUXFUXMYDYAUXDUXEUXMYAUUJUXDUXEUXMUUK
      UUBYTBCDEHIJWMWHWIVJVJUUNYIUXMUXLYAUUJYDYIUXMTUXLUUKYHUXIBCDAEHIJWJWKWLWN
      WGWOUWTYRUXHAYPUWFYQUWKDWPWQWRWSWTXBXAXCXDYAUUQUVGYLQYDUVJUVEYJUVFYKUVJYF
      UVCOZUVEYJYAUUOUXNUUPUWQUVBUVCSZUXNYAUUJUVMUXOUUOUUKUVNBUVBCEHJXEUQYFUVCF
      XMXFXGURUVCAYFXHXIUVJYGUUTOZUVFYKYAUUPUXPUUOUWRUUSUUTSZUXPYAUUJUVOUXQUUPU
      UKUVPBUUSCEHJXEUQYGUUTGXMXFXGUSUUTAYGXHXIXJVJXKXLXNXDXOXPYDYEUUHXQYDYEYNX
      QXRXAYAUUJYOYBQUUKUUJYOYBABCDEFGHIJXSXDUMXT $.

    $d A a b $.  $d B b $.
    $( Property of a prime ideal in a commutative ring.  (Contributed by Jeff
       Madsen, 17-Jun-2011.) $)
    pridlc $p |- ( ( ( R e. CRingOps /\ P e. ( PrIdl ` R ) ) /\
          ( A e. X /\ B e. X /\ ( A H B ) e. P ) ) -> ( A e. P \/ B e. P ) ) $=
      ( va vb wcel cfv wa cv co wo wi wral ccring cpridl w3a cidl biimpa simp3d
      ispridlc wceq oveq1 eleq1d eleq1 orbi1d imbi12d oveq2 orbi2d rspc2v com12
      wne exp3a 3imp2 sylan ) DUAMZCDUBNMZOZKPZLPZFQZCMZVECMZVFCMZRZSZLGTKGTZAG
      MZBGMZABFQZCMZUCACMZBCMZRZVDCDUDNMZCGURZVMVBVCWAWBVMUCCDEFGKLHIJUGUEUFVMV
      NVOVQVTVMVNVOVQVTSZVNVOOVMWCVLWCAVFFQZCMZVRVJRZSKLABGGVEAUHZVHWEVKWFWGVGW
      DCVEAVFFUIUJWGVIVRVJVEACUKULUMVFBUHZWEVQWFVTWHWDVPCVFBAFUNUJWHVJVSVRVFBCU
      KUOUMUPUQUSUTVA $.

    $( Property of a prime ideal in a commutative ring.  (Contributed by Jeff
       Madsen, 17-Jun-2011.) $)
    pridlc2 $p |- ( ( ( R e. CRingOps /\ P e. ( PrIdl ` R ) ) /\
            ( A e. ( X \ P ) /\ B e. X /\ ( A H B ) e. P ) ) -> B e. P ) $=
      ( ccring wcel cpridl cfv wa cdif co w3a wn eldifn adantl wi eldifi pridlc
      3ad2ant1 ord syl3anr1 mpd ) DKLCDMNLOZAGCPLZBGLZABFQCLZRZOACLZSZBCLZUMUOU
      IUJUKUOULAGCTUEUAUJAGLZUIUKULUOUPUBAGCUCUIUQUKULROUNUPABCDEFGHIJUDUFUGUH
      $.

    $( Property of a prime ideal in a commutative ring.  (Contributed by Jeff
       Madsen, 17-Jun-2011.) $)
    pridlc3 $p |- ( ( ( R e. CRingOps /\ P e. ( PrIdl ` R ) ) /\
          ( A e. ( X \ P ) /\ B e. ( X \ P ) ) ) -> ( A H B ) e. ( X \ P ) ) $=
      ( ccring wcel cpridl cfv wa cdif co eldifi wn wi crngorngo anim12i rngocl
      crngo 3expb syl2an adantlr ad2antll pridlc2 3exp2 imp32 con3d sylanr2 mpd
      eldifn eldifd ) DKLZCDMNLZOZAGCPZLZBUTLZOZOZABFQZGCUQVCVEGLZURUQDUDLZAGLZ
      BGLZOVFVCDUAVAVHVBVIAGCRBGCRZUBVGVHVIVFABDEFGHIJUCUEUFUGVDBCLZSZVECLZSZVB
      VLUSVABGCUOUHVBUSVAVIVLVNTVJUSVAVIOOVMVKUSVAVIVMVKTUSVAVIVMVKABCDEFGHIJUI
      UJUKULUMUNUP $.
  $}

  ${
    $d R a b $.  $d Z a b $.  $d H a b $.  $d X a b $.
    isdmn3.1 $e |- G = ( 1st ` R ) $.
    isdmn3.2 $e |- H = ( 2nd ` R ) $.
    isdmn3.3 $e |- X = ran G $.
    isdmn3.4 $e |- Z = ( GId ` G ) $.
    isdmn3.5 $e |- U = ( GId ` H ) $.
    $( The predicate "is a domain", alternate expression.  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    isdmn3 $p |- ( R e. Dmn <-> ( R e. CRingOps /\ U =/= Z /\ A. a e. X A. b e.
        X
                                ( ( a H b ) = Z -> ( a = Z \/ b = Z ) ) ) ) $=
      ( wcel wa wceq wi wral cfv syl cdmn cprrng ccring wne cv co wo w3a isdmn2
      crngo csn cpridl isprrngo cidl ispridlc crngorngo biantrurd 3anass wb crn
      0idl rneqi eqtri rngo1cl eleq2 elsni syl6bir syl5com c1o cen wbr rngoueqz
      c1st rngo0cl en1eqsn eqcomd ex sylbird impbid necon3bid ovex elsn orbi12i
      elsnc imbi12i 2ralbidv anbi12d bitr3d 3bitr3d pm5.32i ancom 3bitr4i bitri
      a1i syl5bb ) AUANAUBNZAUCNZOZWQBFUDZGUEZHUEZDUFZFPZWTFPZXAFPZUGZQZHERGERZ
      UHZAUIWQWPOWQWSXHOZOWRXIWQWPXJWPAUJNZFUKZAULSNZOZWQXJACFILUMWQXMXLAUNSNZX
      LEUDZXBXLNZWTXLNZXAXLNZUGZQZHERGERZUHZXNXJXLACDEGHIJKUOWQXKXMAUPZUQYCXOXP
      YBOZOZWQXJXOXPYBURWQYEYFXJWQXOYEWQXKXOYDACFILVATUQWQXPWSYBXHWQXLEBFWQXKXL
      EPZBFPZUSYDXKYGYHXKBENZYGYHABDEECUTAVMSZUTKCYJIVBVCJMVDYGYIBXLNYHXLEBVEBF
      VFVGVHXKYHEVIVJVKZYGABCDEFIJLMKVLXKFENZYKYGQACEFIKLVNYLYKYGYLYKOEXLFEVOVP
      VQTVRVSTVTWQYAXGGHEEYAXGUSWQXQXCXTXFXBFWTXADWAWDXRXDXSXEGFWBHFWBWCWEWNWFW
      GWHWOWIWOWJWPWQWKWQWSXHURWLWM $.
  $}

  ${
    $d R a b $.  $d H a b $.  $d X a b $.  $d Z a b $.  $d A a b $.  $d B b $.
    dmnnzd.1 $e |- G = ( 1st ` R ) $.
    dmnnzd.2 $e |- H = ( 2nd ` R ) $.
    dmnnzd.3 $e |- X = ran G $.
    dmnnzd.4 $e |- Z = ( GId ` G ) $.
    $( A domain has no zero-divisors (besides zero).  (Contributed by Jeff
       Madsen, 19-Jun-2010.) $)
    dmnnzd $p |- ( ( R e. Dmn /\ ( A e. X /\ B e. X /\ ( A H B ) = Z ) )
                                                  -> ( A = Z \/ B = Z ) ) $=
      ( va vb wcel co wceq wo wi cv wral cdmn wa ccring cgi cfv wne eqid isdmn3
      simp3bi oveq1 eqeq1d eqeq1 orbi1d imbi12d oveq2 orbi2d rspc2v exp3a 3imp2
      syl5com ) CUANZAFNZBFNZABEOZGPZAGPZBGPZQZVAVBVCVEVHRZVALSZMSZEOZGPZVJGPZV
      KGPZQZRZMFTLFTZVBVCUBVIVACUCNEUDUEZGUFVRCVSDEFGLMHIJKVSUGUHUIVQVIAVKEOZGP
      ZVFVOQZRLMABFFVJAPZVMWAVPWBWCVLVTGVJAVKEUJUKWCVNVFVOVJAGULUMUNVKBPZWAVEWB
      VHWDVTVDGVKBAEUOUKWDVOVGVFVKBGULUPUNUQUTURUS $.
  $}

  ${
    dmncan.1 $e |- G = ( 1st ` R ) $.
    dmncan.2 $e |- H = ( 2nd ` R ) $.
    dmncan.3 $e |- X = ran G $.
    dmncan.4 $e |- Z = ( GId ` G ) $.
    $( Cancellation law for domains.  (Contributed by Jeff Madsen,
       6-Jan-2011.) $)
    dmncan1 $p |- ( ( ( R e. Dmn /\ ( A e. X /\ B e. X /\ C e. X ) )
                      /\ A =/= Z ) -> ( ( A H B ) = ( A H C ) -> B = C ) ) $=
      ( wcel wa co wceq sylan adantr wi 3expb cdmn w3a wne cgs cfv dmnrngo eqid
      crngo rngosubdi eqeq1d wo cgr rngogrpo syl grpodivcl adantlr dmnnzd 3exp2
      imp31 syldan exp43 3imp2 neor syl6ib com23 sylbird wb 3adant3r3 3adant3r2
      imp rngocl grpoeqdivid syl3anc 3adantr1 3imtr4d ) DUAMZAGMZBGMZCGMZUBZNZA
      HUCZNZABFOZACFOZEUDUEZOZHPZBCWFOZHPZWDWEPZBCPZWCWHAWIFOZHPZWJWCWMWGHWAWMW
      GPZWBVPDUHMZVTWODUFZABCWFDEFGIJKWFUGZUIQRUJWAWBWNWJSWAWNWBWJWAWNAHPWJUKZW
      BWJSVPVQVRVSWNWSSZVPVQVRVSWTVPVQNVRVSNZWIGMZWTVPXAXBVQVPEULMZXAXBVPWPXCWQ
      DEIUMUNZXCVRVSXBBCWFEGKWRUOTQUPVPVQXBWTVPVQXBWNWSAWIDEFGHIJKLUQURUSUTVAVB
      WJAHVCVDVEVJVFWAWKWHVGZWBWAXCWDGMZWEGMZXEVPXCVTXDRVPWPVTXFWQWPVQVRXFVSABD
      EFGIJKVKVHQVPWPVTXGWQWPVQVSXGVRACDEFGIJKVKVIQWDWEWFHEGKLWRVLVMRWAWLWJVGZW
      BVPVRVSXHVQVPXCXAXHXDXCVRVSXHBCWFHEGKLWRVLTQVNRVO $.

    $( Cancellation law for domains.  (Contributed by Jeff Madsen,
       6-Jan-2011.) $)
    dmncan2 $p |- ( ( ( R e. Dmn /\ ( A e. X /\ B e. X /\ C e. X ) )
                      /\ C =/= Z ) -> ( ( A H C ) = ( B H C ) -> A = B ) ) $=
      ( cdmn wcel w3a wa wne co wceq crngocom wb ccring dmncrng 3adant3r2 sylan
      3adant3r1 eqeq12d adantr wi 3anrot biimpri dmncan1 sylanl2 sylbid ) DMNZA
      GNZBGNZCGNZOZPZCHQZPACFRZBCFRZSZCAFRZCBFRZSZABSZUTVDVGUAZVAUODUBNZUSVIDUC
      VJUSPVBVEVCVFVJUPURVBVESUQACDEFGIJKTUDVJUQURVCVFSUPBCDEFGIJKTUFUGUEUHUSUO
      URUPUQOZVAVGVHUIVKUSURUPUQUJUKCABDEFGHIJKLULUMUN $.
  $}
$( (End of Jeff Madsen's mathbox.) $)

$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                    Mathbox for Giovanni Mascellani
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Tools for automatic proof building
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  The results in this section are mostly meant for begin used by
  automatic proof building programs. As a result, they might appear
  less useful or meaningful than others to human beings.

$)

  ${
    efald2.1 $e |- ( -. ph -> F. ) $.
    $( A proof by contradiction.  (Contributed by Giovanni Mascellani,
       15-Sep-2017.) $)
    efald2 $p |- ph
    $=
      ( wtru wn wfal adantl efald trud ) ACAADECBFGH $.
  $}

  ${
    $( Simplification rule of negation across a biimplication.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    notbinot1 $p |- ( -. ( -. ph <-> ps ) <-> ( ph <-> ps ) )
    $=
      ( wb wn nbbn bicomi con1bii ) ABCZADBCZIHDABEFG $.
  $}

  ${
    $( Biimplication of its own negation is a contradiction.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    bicontr $p |- ( ( -. ph <-> ph ) <-> F. )
    $=
      ( wn wb biid notbinot1 mpbir bifal ) ABACZHBAACADAAEFG $.
  $}

  ${
    $( An equivalent formula for implying a disjunction.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    impor $p |- ( ( ph -> ( ps \/ ch ) ) <-> ( ( -. ph \/ ps ) \/ ch ) )
    $=
      ( wo wi wn wb imor orass bicomi bibi2i mpbi ) ABCDZEZAFZMDZGNOBDCDZGAMHPQ
      NQPOBCIJKL $.
  $}

  ${
    $( The falsum ` F. ` can be removed from a disjunction.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    orfa $p |- ( ( ph \/ F. ) <-> ph )
    $=
      ( wfal wo wn wi orcom df-or bitri fal pm2.27 ax-mp sylbi orc impbii ) ABC
      ZAOBDZAEZAOBACQABFBAGHPQAEIPAJKLABMN $.
  $}

  ${
    $( Commutation rule between negation and biimplication.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    notbinot2 $p |- ( -. ( ph <-> ps ) <-> ( -. ph <-> ps ) )
    $=
      ( wn wb nbbn bicomi ) ACBDABDCABEF $.
  $}

  ${
    $( An rewriting rule for biimplication.  (Contributed by Giovanni
       Mascellani, 15-Sep-2017.) $)
    biimpor $p |- ( ( ( ph <-> ps ) -> ch ) <-> ( ( -. ph <-> ps ) \/ ch ) )
    $=
      ( wb wi wn wo imor notbinot2 orbi1i bitri ) ABDZCELFZCGAFBDZCGLCHMNCABIJK
      $.
  $}

  ${
    unitresl.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    unitresl.2 $e |- ( ph -> -. ch ) $.
    $( A lemma for Conjunctive Normal Form unit propagation, in deduction
       form.  (Contributed by Giovanni Mascellani, 15-Sep-2017.) $)
    unitresl $p |- ( ph -> ps )
    $=
      ( wo wn wa jca wi orcom df-or bitri biimpi imp syl ) ABCFZCGZHBAQRDEIQRBQ
      RBJZQCBFSBCKCBLMNOP $.
  $}

  ${
    unitresr.1 $e |- ( ph -> ( ps \/ ch ) ) $.
    unitresr.2 $e |- ( ph -> -. ps ) $.
    $( A lemma for Conjunctive Normal Form unit propagation, in deduction
       form.  (Contributed by Giovanni Mascellani, 15-Sep-2017.) $)
    unitresr $p |- ( ph -> ch )
    $=
      ( orcomd unitresl ) ACBABCDFEG $.
  $}

  ${
    orfa1.1 $e |- ( ph -> ps ) $.
    $( Add a contradicting disjunct to an antecedent.  (Contributed by Giovanni
       Mascellani, 15-Sep-2017.) $)
    orfa1 $p |- ( ( ph \/ F. ) -> ps )
    $=
      ( wfal falim jaoi ) ABDCBEF $.
  $}

  ${
    orfa2.1 $e |- ( ph -> F. ) $.
    $( Remove a contradicting disjunct from an antecedent.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    orfa2 $p |- ( ( ph \/ ps ) -> ps )
    $=
      ( wo wfal orim1i falim id jaoi syl ) ABDEBDBAEBCFEBBBGBHIJ $.
  $}

  ${
    bifald.1 $e |- ( ph -> -. ps ) $.
    $( Infer the equivalence to a contradiction from a negation, in deduction
       form.  (Contributed by Giovanni Mascellani, 15-Sep-2017.) $)
    bifald $p |- ( ph -> ( ps <-> F. ) )
    $=
      ( wn wfal wb id falim pm5.21ni syl ) ABDBEFCBBEBGBHIJ $.
  $}

  ${
    orsild.1 $e |- ( ph -> -. ( ps \/ ch ) ) $.
    $( A lemma for not-or-not elimination, in deduction form.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    orsild $p |- ( ph -> -. ps )
    $=
      ( wn wo wa ioran sylib simpld ) ABEZCEZABCFEKLGDBCHIJ $.
  $}

  ${
    orsird.1 $e |- ( ph -> -. ( ps \/ ch ) ) $.
    $( A lemma for not-or-not elimination, in deduction form.  (Contributed by
       Giovanni Mascellani, 15-Sep-2017.) $)
    orsird $p |- ( ph -> -. ch )
    $=
      ( wn wo wa ioran sylib simprd ) ABEZCEZABCFEKLGDBCHIJ $.
  $}

  ${
    orcomdd.1 $e |- ( ph -> ( ps -> ( ch \/ th ) ) ) $.
    $( Commutativity of logic disjunction, in double deduction form.
       (Contributed by Giovanni Mascellani, 19-Mar-2018.) $)
    orcomdd $p |- ( ph -> ( ps -> ( th \/ ch ) ) ) $=
      ( wo wi pm1.4 imim2i ax-mp ) ABCDFZGZGABDCFZGZGELNAKMBCDHIIJ $.
  $}

  ${
    cnf1dd.1 $e |- ( ph -> ( ps -> -. ch ) ) $.
    cnf1dd.2 $e |- ( ph -> ( ps -> ( ch \/ th ) ) ) $.
    $( A lemma for Conjunctive Normal Form unit propagation, in double
       deduction form.  (Contributed by Giovanni Mascellani, 19-Mar-2018.) $)
    cnf1dd $p |- ( ph -> ( ps -> th ) ) $=
      ( wn wo wa wi jcad df-or anbi2i pm3.35 sylbi imim2i ax-mp ) ABCGZCDHZIZJZ
      JABDJZJABRSEFKUAUBATDBTRRDJZIDSUCRCDLMRDNOPPQ $.
  $}

  ${
    cnf2dd.1 $e |- ( ph -> ( ps -> -. th ) ) $.
    cnf2dd.2 $e |- ( ph -> ( ps -> ( ch \/ th ) ) ) $.
    $( A lemma for Conjunctive Normal Form unit propagation, in double
       deduction form.  (Contributed by Giovanni Mascellani, 19-Mar-2018.) $)
    cnf2dd $p |- ( ph -> ( ps -> ch ) ) $=
      ( orcomdd cnf1dd ) ABDCEABCDFGH $.
  $}

  ${
    cnfn1dd.1 $e |- ( ph -> ( ps -> ch ) ) $.
    cnfn1dd.2 $e |- ( ph -> ( ps -> ( -. ch \/ th ) ) ) $.
    $( A lemma for Conjunctive Normal Form unit propagation, in double
       deduction form.  (Contributed by Giovanni Mascellani, 19-Mar-2018.) $)
    cnfn1dd $p |- ( ph -> ( ps -> th ) ) $=
      ( wn notnot1 syl6 cnf1dd ) ABCGZDABCKGECHIFJ $.
  $}

  ${
    cnfn2dd.1 $e |- ( ph -> ( ps -> th ) ) $.
    cnfn2dd.2 $e |- ( ph -> ( ps -> ( ch \/ -. th ) ) ) $.
    $( A lemma for Conjunctive Normal Form unit propagation, in double
       deduction form.  (Contributed by Giovanni Mascellani, 19-Mar-2018.) $)
    cnfn2dd $p |- ( ph -> ( ps -> ch ) ) $=
      ( wn notnot1 syl6 cnf2dd ) ABCDGZABDKGEDHIFJ $.
  $}

  ${
    or32dd.1 $e |- ( ph -> ( ps -> ( ( ch \/ th ) \/ ta ) ) ) $.
    $( A rearrangement of disjuncts, in double deduction form.  (Contributed by
       Giovanni Mascellani, 19-Mar-2018.) $)
    or32dd $p |- ( ph -> ( ps -> ( ( ch \/ ta ) \/ th ) ) ) $=
      ( wo or32 syl6ibr ) ABCDGEGCEGDGFCEDHI $.
  $}

  ${
    notornotel1.1 $e |- ( ph -> -. ( -. ps \/ ch ) ) $.
    $( A lemma for not-or-not elimination, in deduction form.  (Contributed by
       Giovanni Mascellani, 19-Mar-2018.) $)
    notornotel1 $p |- ( ph -> ps ) $=
      ( wn wo wi wa ioran biimpi simpl notnot2 3syl imim2i ax-mp ) ABEZCFEZGABG
      DQBAQPEZCEZHZRBQTPCIJRSKBLMNO $.
  $}

  ${
    notornotel2.1 $e |- ( ph -> -. ( ps \/ -. ch ) ) $.
    $( A lemma for not-or-not elimination, in deduction form.  (Contributed by
       Giovanni Mascellani, 19-Mar-2018.) $)
    notornotel2 $p |- ( ph -> ch ) $=
      ( wn wo orcom notbii sylibr notornotel1 ) ACBABCEZFZEKBFZEDMLKBGHIJ $.
  $}

  ${
    contrd.1 $e |- ( ph -> ( -. ps -> ch ) ) $.
    contrd.2 $e |- ( ph -> ( -. ps -> -. ch ) ) $.
    $( A proof by contradiction, in deduction form.  (Contributed by Giovanni
       Mascellani, 19-Mar-2018.) $)
    contrd $p |- ( ph -> ps ) $=
      ( wn wa wi jcad pm2.24 imp imim2i pm2.18 syl ) ABFZCCFZGZHZBAOCPDEIROBHBQ
      BOCPBCBJKLBMNN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Tseitin axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  A collection of Tseitin axioms used to convert a wff to Conjunctive
  Normal Form.

$)

  $( Refutation of falsity, in deduction form.  (Contributed by Giovanni
     Mascellani, 24-Mar-2018.) $)
  fald $p |- ( th -> -. F. ) $=
    ( wfal wn fal a1i ) BCADE $.

  $( A Tseitin axiom for logical implication, in deduction form.  (Contributed
     by Giovanni Mascellani, 24-Mar-2018.) $)
  tsim1 $p |- ( th -> ( ( -. ph \/ ps ) \/ -. ( ph -> ps ) ) ) $=
    ( wn wo wi exmid df-or notnot bicomi imbi1i bitri orbi1i mpbir a1i ) ADZBEZ
    ABFZDZEZCTRSERGQRSQPDZBFRPBHUAABAUAAIJKLMNO $.

  $( A Tseitin axiom for logical implication, in deduction form.  (Contributed
     by Giovanni Mascellani, 24-Mar-2018.) $)
  tsim2 $p |- ( th -> ( ph \/ ( ph -> ps ) ) ) $=
    ( wi wo orc wn pm2.21 olcd pm2.61i a1i ) AABDZEZCAMALFAGLAABHIJK $.

  $( A Tseitin axiom for logical implication, in deduction form.  (Contributed
     by Giovanni Mascellani, 24-Mar-2018.) $)
  tsim3 $p |- ( th -> ( -. ps \/ ( ph -> ps ) ) ) $=
    ( wn wi wo ax-1 olcd orc pm2.61i a1i ) BDZABEZFZCBNBMLBAGHLMIJK $.

  $( A Tseitin axiom for logical biimplication, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsbi1 $p |- ( th -> ( ( -. ph \/ -. ps ) \/ ( ph <-> ps ) ) ) $=
    ( wn wo wb wa pm5.1 olcd pm3.13 orcd pm2.61i a1i ) ADBDEZABFZEZCABGZPQONABH
    IQDNOABJKLM $.

  $( A Tseitin axiom for logical biimplication, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsbi2 $p |- ( th -> ( ( ph \/ ps ) \/ ( ph <-> ps ) ) ) $=
    ( wo wb wn wa pm5.21 olcd pm4.57 biimpi orcd pm2.61i a1i ) ABDZABEZDZCAFBFG
    ZQRPOABHIRFZOPSOABJKLMN $.

  $( A Tseitin axiom for logical biimplication, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsbi3 $p |- ( th -> ( ( ph \/ -. ps ) \/ -. ( ph <-> ps ) ) ) $=
    ( wn wo wb orc wi bi2 con34b df-or biimpri sylbi syl con3i olcd pm2.61i a1i
    ) ABDZEZABFZDZEZCTUCTUBGTDUBTUATUABAHZTABIUDADSHZTBAJTUEASKLMNOPQR $.

  $( A Tseitin axiom for logical biimplication, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsbi4 $p |- ( th -> ( ( -. ph \/ ps ) \/ -. ( ph <-> ps ) ) ) $=
    ( wn wo wb tsbi3 orcom orbi1i bicom notbii orbi2i bitri sylib ) CBADZEZBAFZ
    DZEZOBEZABFZDZEZBACGSTREUCPTRBOHIRUBTQUABAJKLMN $.

  $( A Tseitin axiom for logical exclusive disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsxo1 $p |- ( th -> ( ( -. ph \/ -. ps ) \/ -. ( ph \/_ ps ) ) ) $=
    ( wn wo wb wxo tsbi1 xnor orbi2i sylib ) CADBDEZABFZELABGDZEABCHMNLABIJK $.

  $( A Tseitin axiom for logical exclusive disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsxo2 $p |- ( th -> ( ( ph \/ ps ) \/ -. ( ph \/_ ps ) ) ) $=
    ( wo wb wxo wn tsbi2 xnor orbi2i sylib ) CABDZABEZDLABFGZDABCHMNLABIJK $.

  $( A Tseitin axiom for logical exclusive disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsxo3 $p |- ( th -> ( ( ph \/ -. ps ) \/ ( ph \/_ ps ) ) ) $=
    ( wn wo wb wxo tsbi3 df-xor bicomi orbi2i sylib ) CABDEZABFDZEMABGZEABCHNOM
    ONABIJKL $.

  $( A Tseitin axiom for logical exclusive disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsxo4 $p |- ( th -> ( ( -. ph \/ ps ) \/ ( ph \/_ ps ) ) ) $=
    ( wn wo wb wxo tsbi4 df-xor bicomi orbi2i sylib ) CADBEZABFDZEMABGZEABCHNOM
    ONABIJKL $.

  $( A Tseitin axiom for logical conjunction, in deduction form.  (Contributed
     by Giovanni Mascellani, 24-Mar-2018.) $)
  tsan1 $p |- ( th -> ( ( -. ph \/ -. ps ) \/ ( ph /\ ps ) ) ) $=
    ( wn wo wa pm3.12 a1i ) ADBDEABFECABGH $.

  $( A Tseitin axiom for logical conjunction, in deduction form.  (Contributed
     by Giovanni Mascellani, 24-Mar-2018.) $)
  tsan2 $p |- ( th -> ( ph \/ -. ( ph /\ ps ) ) ) $=
    ( wa wn wo orc pm3.14 syl olcd pm2.61i a1i ) AABDEZFZCANAMGAEZMAOOBEZFMOPGA
    BHIJKL $.

  $( A Tseitin axiom for logical conjunction, in deduction form.  (Contributed
     by Giovanni Mascellani, 24-Mar-2018.) $)
  tsan3 $p |- ( th -> ( ps \/ -. ( ph /\ ps ) ) ) $=
    ( wa wn wo orc olc pm3.14 syl olcd pm2.61i a1i ) BABDEZFZCBOBNGBEZNBPAEZPFN
    PQHABIJKLM $.

  $( A Tseitin axiom for logical incompatibility, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsna1 $p |- ( th -> ( ( -. ph \/ -. ps ) \/ -. ( ph -/\ ps ) ) ) $=
    ( wn wo wa wnan tsan1 notnot df-nan bitr3i con4bii orbi2i sylibr ) CADBDEZA
    BFZEOABGZDZEABCHRPORPRDQPDQIABJKLMN $.

  $( A Tseitin axiom for logical incompatibility, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsna2 $p |- ( th -> ( ph \/ ( ph -/\ ps ) ) ) $=
    ( wa wn wo wnan tsan2 df-nan orbi2i sylibr ) CAABDEZFAABGZFABCHMLAABIJK $.

  $( A Tseitin axiom for logical incompatibility, in deduction form.
     (Contributed by Giovanni Mascellani, 24-Mar-2018.) $)
  tsna3 $p |- ( th -> ( ps \/ ( ph -/\ ps ) ) ) $=
    ( wa wn wo wnan tsan3 df-nan orbi2i sylibr ) CBABDEZFBABGZFABCHMLBABIJK $.

  $( A Tseitin axiom for logical disjunction, in deduction form.  (Contributed
     by Giovanni Mascellani, 25-Mar-2018.) $)
  tsor1 $p |- ( th -> ( ( ph \/ ps ) \/ -. ( ph \/ ps ) ) ) $=
    ( wo exmidd ) CABDE $.

  $( A Tseitin axiom for logical disjunction, in deduction form.  (Contributed
     by Giovanni Mascellani, 25-Mar-2018.) $)
  tsor2 $p |- ( th -> ( -. ph \/ ( ph \/ ps ) ) ) $=
    ( wn wo orc olcd pm2.61i a1i ) ADZABEZEZCALAKJABFGJKFHI $.

  $( A Tseitin axiom for logical disjunction, in deduction form.  (Contributed
     by Giovanni Mascellani, 25-Mar-2018.) $)
  tsor3 $p |- ( th -> ( -. ps \/ ( ph \/ ps ) ) ) $=
    ( wn wo olc olcd orc pm2.61i a1i ) BDZABEZEZCBMBLKBAFGKLHIJ $.

  $( A Tseitin axiom for triple logical conjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 25-Mar-2018.) $)
  ts3an1 $p |- ( th ->
       ( ( -. ( ph /\ ps ) \/ -. ch ) \/ ( ph /\ ps /\ ch ) ) ) $=
    ( wa wn wo w3a tsan1 df-3an orbi2i sylibr ) DABEZFCFGZMCEZGNABCHZGMCDIPONAB
    CJKL $.

  $( A Tseitin axiom for triple logical conjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 25-Mar-2018.) $)
  ts3an2 $p |- ( th -> ( ( ph /\ ps ) \/ -. ( ph /\ ps /\ ch ) ) ) $=
    ( wa wn wo w3a tsan2 df-3an notbii orbi2i sylibr ) DABEZNCEZFZGNABCHZFZGNCD
    IRPNQOABCJKLM $.

  $( A Tseitin axiom for triple logical conjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 25-Mar-2018.) $)
  ts3an3 $p |- ( th -> ( ch \/ -. ( ph /\ ps /\ ch ) ) ) $=
    ( wa wn wo w3a tsan3 df-3an notbii orbi2i sylibr ) DCABEZCEZFZGCABCHZFZGNCD
    IRPCQOABCJKLM $.

  $( A Tseitin axiom for triple logical disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 25-Mar-2018.) $)
  ts3or1 $p |- ( th -> ( ( ( ph \/ ps ) \/ ch ) \/ -. ( ph \/ ps \/ ch ) ) ) $=
    ( wo wn w3o exmidd df-3or notbii orbi2i sylibr ) DABECEZMFZEMABCGZFZEDMHPNM
    OMABCIJKL $.

  $( A Tseitin axiom for triple logical disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 25-Mar-2018.) $)
  ts3or2 $p |- ( th -> ( -. ( ph \/ ps ) \/ ( ph \/ ps \/ ch ) ) ) $=
    ( wo wn w3o tsor2 df-3or orbi2i sylibr ) DABEZFZLCEZEMABCGZELCDHONMABCIJK
    $.

  $( A Tseitin axiom for triple logical disjunction, in deduction form.
     (Contributed by Giovanni Mascellani, 25-Mar-2018.) $)
  ts3or3 $p |- ( th -> ( -. ch \/ ( ph \/ ps \/ ch ) ) ) $=
    ( wn wo w3o tsor3 df-3or orbi2i sylibr ) DCEZABFZCFZFLABCGZFMCDHONLABCIJK
    $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Equality deductions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  A collection of theorems for commuting equalities (or
  biimplications) with other constructs.

$)

  $( Substituting into equivalent wff's gives equivalent results.  (Contributed
     by Giovanni Mascellani, 9-Apr-2018.) $)
  sbcbi2 $p |- ( A. x ( ph <-> ps ) ->
       ( [. A / x ]. ph <-> [. A / x ]. ps ) ) $=
    ( wb wal cab wcel wsbc wceq abbi eleq2 sylbi df-sbc bibi12i sylibr ) ABECFZ
    DACGZHZDBCGZHZEZACDIZBCDIZEQRTJUBABCKRTDLMUCSUDUAACDNBCDNOP $.

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.
    $( Substituting into equivalent classes gives equivalent results.
       (Contributed by Giovanni Mascellani, 9-Apr-2018.) $)
    csbeq $p |- ( A. x B = C -> [_ A / x ]_ B = [_ A / x ]_ C ) $=
      ( vy wceq wal cv wcel cab csb wb eleq2 alimi sbcbi2 abbidv df-csb eqeq12i
      wsbc syl sylibr ) CDFZAGZEHZCIZABSZEJZUDDIZABSZEJZFABCKZABDKZFUCUFUIEUCUE
      UHLZAGUFUILUBUMACDUDMNUEUHABOTPUKUGULUJAEBCQAEBDQRUA $.
  $}

  ${
    $d A y $.  $d B y $.
    iuneq2f.1 $e |- F/_ x A $.
    iuneq2f.2 $e |- F/_ x B $.
    $( Equality deduction for indexed union.  (Contributed by Giovanni
       Mascellani, 9-Apr-2018.) $)
    iuneq2f $p |- ( A = B -> U_ x e. A C = U_ x e. B C ) $=
      ( vy wceq nfeq cv eleq2 eqrdv eqidd iuneq12df ) BCHZABCDDABCEFIEFOGBCBCGJ
      KLODMN $.
  $}

  $( Equality deduction for class abstraction.  (Contributed by Giovanni
     Mascellani, 10-Apr-2018.) $)
  abeq12 $p |- ( A. x ( ph <-> ps ) -> { x | ph } = { x | ps } ) $=
    ( wb wal cab wceq abbi biimpi ) ABDCEACFBCFGABCHI $.

  ${
    rabeq12f.1 $e |- F/_ x A $.
    rabeq12f.2 $e |- F/_ x B $.
    $( Equality deduction for restricted class abstraction.  (Contributed by
       Giovanni Mascellani, 10-Apr-2018.) $)
    rabeq12f $p |- ( ( A = B /\ A. x e. A ( ph <-> ps ) ) ->
         { x e. A | ph } = { x e. B | ps } ) $=
      ( wb wral wceq crab rabbi biimpi rabeqf sylan9eqr ) ABHCDIZDEJACDKZBCDKZB
      CEKPQRJABCDLMBCDEFGNO $.
  $}

  $( Equality deduction for substitution in class.  (Contributed by Giovanni
     Mascellani, 10-Apr-2018.) $)
  csbeq12 $p |- ( ( A = B /\ A. x C = D ) ->
       [_ A / x ]_ C = [_ B / x ]_ D ) $=
    ( wceq wal csb csbeq csbeq1 sylan9eqr ) DEFAGBCFABDHABEHACEHABDEIABCEJK $.

  $( Equality deduction for not-freeness.  (Contributed by Giovanni Mascellani,
     10-Apr-2018.) $)
  nfbii2 $p |- ( A. x ( ph <-> ps ) -> ( F/ x ph <-> F/ x ps ) ) $=
    ( wb wal nfa1 sp nfbidf ) ABDZCEABCICFICGH $.

  $( Equality deduction for substitution.  (Contributed by Giovanni Mascellani,
     10-Apr-2018.) $)
  sbeqi $p |- ( ( x = y /\ A. z ( ph <-> ps ) ) ->
       ( [ x / z ] ph <-> [ y / z ] ps ) ) $=
    ( wb wal wsb cv wceq spsbbi sbequ sylan9bbr ) ABFEGAECHBECHCIDIJBEDHABECKBC
    DELM $.

  ${
    ralbi12f.1 $e |- F/_ x A $.
    ralbi12f.2 $e |- F/_ x B $.
    $( Equality deduction for restricted universal quantification.
       (Contributed by Giovanni Mascellani, 10-Apr-2018.) $)
    ralbi12f $p |- ( ( A = B /\ A. x e. A ( ph <-> ps ) ) ->
         ( A. x e. A ph <-> A. x e. B ps ) ) $=
      ( wb wral wceq ralbi raleqf sylan9bbr ) ABHCDIACDIBCDIDEJBCEIABCDKBCDEFGL
      M $.
  $}

  $( Equality deduction for class abstraction of nested ordered pairs.
     (Contributed by Giovanni Mascellani, 10-Apr-2018.) $)
  oprabbi $p |- ( A. x A. y A. z ( ph <-> ps ) ->
       { <. <. x , y >. , z >. | ph } = { <. <. x , y >. , z >. | ps } ) $=
    ( coprab wceq wb wal eqoprab2b biimpri ) ACDEFBCDEFGABHEIDICIABCDEJK $.

  ${
    $d x y $.  $d x z $.  $d y z $.  $d z A $.  $d z B $.  $d z C $.  $d z D $.
    $d z E $.  $d z F $.
    mpt2bi123f.1 $e |- F/_ x A $.
    mpt2bi123f.2 $e |- F/_ x B $.
    mpt2bi123f.3 $e |- F/_ y A $.
    mpt2bi123f.4 $e |- F/_ y B $.
    mpt2bi123f.5 $e |- F/_ y C $.
    mpt2bi123f.6 $e |- F/_ y D $.
    mpt2bi123f.7 $e |- F/_ x C $.
    mpt2bi123f.8 $e |- F/_ x D $.
    $( Equality deduction for maps-to notations with two arguments.
       (Contributed by Giovanni Mascellani, 10-Apr-2018.) $)
    mpt2bi123f $p |- ( ( ( A = B /\ C = D ) /\ A. x e. A A. y e. C E = F )
         -> ( x e. A , y e. C |-> E ) = ( x e. B , y e. D |-> F ) ) $=
      ( a1d wo cnfn2dd cnf2dd vz wceq wa wral cv wcel coprab cmpt2 wb wal eleq2
      nfeq alrimi ax-17 nfel2 nfbi nfa1 a17d cbv3 syl alimi wnfc nfal nfri wfal
      wi wn exmidd tsim3 tsim2 tsim1 or32dd orcomdd contrd efald2 ax-mp anim12i
      id idd imdistanri alanimi eqeq2 alrimiv ralimi hbra1 alrimih 19.21v albii
      rsp biimpri 19.21 2albii 3syl a1i tsan2 orsild tsbi2 tsbi3 tsan3 notnotrd
      orsird tsan1 tsbi1 tsbi4 2alimi oprabbi df-mpt2 eqeq12i sylibr ) CDUBZEFU
      BZUCZGHUBZBEUDZACUDZUCZAUEZCUFZBUEZEUFZUCZUAUEZGUBZUCZABUAUGZXQDUFZXSFUFZ
      UCZYBHUBZUCZABUAUGZUBZABCEGUHZABDFHUHZUBXPYDYJUIZUAUJZBUJAUJZYLXPXRYFUIZX
      TYGUIZUCZXRXTYCYIUIZVFZVFZUCZUAUJZBUJZAUJZYQXPYTUAUJZBUJZAUJZUUCUAUJZBUJZ
      AUJZUCUUGXLUUJXOUUMXLYRUAUJZBUJZAUJZYSUAUJZBUJZAUJZUCUUJXJUUPXKUUSXJYRAUJ
      UUPXJYRAACDIJULCDXQUKUMYRUUOAYRUUNUUOYRUAUNYRUUNUABXRYFBBXQCKUOZBXQDLUOUP
      YRUAUQYBXSUBYRUAURUSUTVAUTXKYSBUJZUUSXKYSBBEFMNULEFXSUKUMAEVBZUVAUUSVFZOA
      FVBZUVBUVCVFZPUVAUURVFZUVDUVEVFZYSUUQBYSUAUNVAUURUUSVFZUVFUVGVFZUURAUUQAB
      YSAUAXTYGAAXSEOUOAXSFPUOUPVCVCVDUVHUVIVFZUVJVGZVEUVFUVKVEVGZUVFUVIUVKUVLU
      VIVGZUVJUVKUVLUVKUVKUVKUVKUVLUVKVRQZUVKUVKUVKVGRUVLUVKUVKVHQSUVKUVMUVJRUV
      LUVHUVIUVKVIQTZUVKUVFUVIRUVLUVFUVGUVKVJQTUVKUVLUVFVGZUVAUVKUVLUVAUVCUVKUV
      LUVCVGZUVEUVKUVLUVEVGZUVGUVKUVLUVGVGZUVIUVOUVKUVSUVIRUVLUVFUVGUVKVIQTUVKU
      VRUVGRUVLUVDUVEUVKVIQTUVKUVQUVERUVLUVBUVCUVKVIQTZUVKUVAUVCRUVLUVAUUSUVKVJ
      QTUVKUVLUVAVGZUVPUVKUVLUWAUVPRUURUVKUVLUURVGZUUSUVKUVLUUSVGZUVCUVTUVKUWCU
      VCRUVLUVAUUSUVKVIQTUVKUVLUWBUUSRZUVHUVKUVLUVHUVJUVNUVKUVHUVJRUVLUVHUVIUVK
      VJQTUVKUWDUVHVGRUVLUURUUSUVKVKQSTUVKUVLUWAUURUVPUVKUWAUURRUVPRUVLUVAUURUV
      KVKQVLTVMSVNVOVPVPVPVPUTVQUUOUURUUIAUUNUUQUUHBYRYSYTUAYSYRYRYSYRVSVTWAWAW
      AUTXOUUAUAUJZBEUDZACUDZUUMXNUWFACXMUWEBEXMUUAUAGHYBWBWCWDWDUWGUUBUAUJZBUJ
      ZACUDZXRUWIVFZAUJZUUMUWFUWIACUWFXTUWEVFZBUJZUWIUWFUWMBUWEBEWEUWEBEWIWFUWI
      UWNUWHUWMBXTUUAUAWGWHWJUTWDUWJUWKAUWIACWEUWIACWIWFUWLXRUWHVFZBUJZAUJZUUMU
      WQUWLUWPUWKAXRUWHBUUTWKWHWJUUMUWQUUKUWOABXRUUBUAWGWLWJUTWMUTVQUUIUULUUFAU
      UHUUKUUEBYTUUCUUDUAUUCYTYTUUCYTVSVTWAWAWAUTUUEYPABUUDYOUAUUDYOVFZUWRVGZVE
      UUBUWSUVLUUBXRUWSXRUVLUWSXRYJUWSXRVGZYJYDUWSUWTYDVGZYAUWSUWTYAVGZXRUWTUWT
      VFUWSUWTVRWNZUWSUWTXRUXBUWSXRUXBRUWTXRXTUWSWOQVMTUWSUWTYAUXAUWSYAUXARZUWT
      YAYCUWSWOZQVMTUWSUWTYDYJUWSYDYJRZUWTUWSUXFUWRUWSUXFVGZUWRYOUWSUXGYOYDUXGU
      XAVFUWSUXGYDYJUXGVRZWPWNUWSUXGYDYOUWSUXGYDYORYJUXGYJVGZVFUWSUXGYDYJUXHXAW
      NUWSUXGYDYJYOUWSUXFYORZUXGYDYJUWSWQZQVLTVMTUWSUXGYOVGZUWRUWSUXLUWRRZUXGUU
      DYOUWSVIZQVMSUWSUXGUWSUWSUWSUWSUXGUWSVRZQUWSUWSUWSVGRZUXGUWSUWSVHZQSVNQVM
      TUWSUWTUXIYHUWSUWTYHVGZYFUWSUWTYFVGZXRUXCUWSUWTXRUXSUWSUWTXRUXSRZYRUWSYRU
      WTUWSYRUWRUWSYRVGZUWRUUDUWSUYAUUDVGZYTUWSUYAYTVGZYRUYAUYAVFUWSUYAVRWNUWSU
      YAYRUYCUWSYRUYCRUYAYRYSUWSWOQVMTUWSUYAYTUYBUWSYTUYBRZUYAYTUUCUWSWOZQVMTUW
      SUYAUUDUWRUWSUUDUWRRZUYAUUDYOUWSVJZQVMTUWSUYAUWSUWSUWSUWSUYAUXOQUWSUXPUYA
      UXQQSVNZQUWSUXTUYARUWTXRYFUWSWRQSVMTUWSUWTYFUXRUWSYFUXRRUWTYFYGUWSWOQVMTU
      WSUWTYHUXIUWSYHUXIRZUWTYHYIUWSWOZQVMTVNZQZUWSUVLUWTUUBUWSUVLUWTUUBRZUUCUW
      SUVLUUCUUDUWSUVLUUDUWRUWSUVLUWSUWSUWSUWSUVLUXOQZUWSUXPUVLUXQQSUWSUYFUVLUY
      GQTUWSUUCUYBRZUVLYTUUCUWSWSZQSUWSUYMUUCVGRZUVLXRUUBUWSVKZQSVMSUWSUVLUUBVG
      ZXTUWSUVLXTYAUWSUVLYAYDUWSUVLYDYJUWSUXIUVLUWSUXIUUAUWSUXIVGZUUAXTUWSUYTXT
      YGUWSUYTYGYHUWSUYTYHYJUYTYJVFUWSUYTYJUYTVRWTWNZUWSUYIUYTUYJQSUWSYGUXRRUYT
      YFYGUWSWSQSUWSUYTXTYGVGZRZYSUWSYSUYTUWSYSUWRUWSYSVGZUWRUUDUWSVUDUYBYTUWSV
      UDUYCYSVUDVUDVFUWSVUDVRWNUWSVUDYSUYCUWSYSUYCRVUDYRYSUWSWSQVMTUWSVUDYTUYBU
      WSUYDVUDUYEQVMTUWSVUDUUDUWRUWSUYFVUDUYGQVMTUWSVUDUWSUWSUWSUWSVUDUXOQUWSUX
      PVUDUXQQSVNZQUWSVUCVUDRUYTXTYGUWSWRQSSZUWSUYTXTVGZUUAUWSUYTVUGUUARZUUBUWS
      UYTUUBXRUWSXRUYTUYKQZUWSUYTUWTUUBUWSUYTUYMUUCUWSUYTUUCUUDUWSUYTUUDUWRUWSU
      YTUWSUWSUWSUWSUYTUXOQZUWSUXPUYTUXQQSUWSUYFUYTUYGQTUWSUYOUYTUYPQSUWSUYQUYT
      UYRQSVMSUWSVUHUYSRZUYTXTUUAUWSVKZQSVMSUWSUYTUUAVGZYCUWSUYTYCVGZYAUWSUYTYA
      XRVUIUWSUYTUWTYAUWSUYTUWTYARXTVUFUWSUYTUWTVUGYAUWSUWTVUGRYARUYTXRXTUWSXBQ
      VLSVMSUWSUYTUXBVUNUWSUYTUXBVUNRZYDUWSUYTUXAYJVUAUWSUYTUXAUXIRZYOUWSUYTUXL
      UWRVUJUWSUXMUYTUXNQTUWSVUPYORUYTYDYJUWSXCQTSUWSVUOYDRUYTYAYCUWSXBQTVMSUWS
      UYTYCVUMUWSUYTYCVUMRYIUWSUYTYIYJVUAUWSYIUXIRUYTYHYIUWSWSQSUWSUYTYCYIVGZVU
      MUWSYCVUQRVUMRUYTYCYIUWSWRQVLSVMTVNQZUWSUVLUXFYOUWSUVLUXLUWRUYNUWSUXMUVLU
      XNQTUWSUXJUVLUXKQTTZUWSUXDUVLUXEQSUWSXTUXBRUVLXRXTUWSWSQSZUWSUVLVUGUYSUWS
      UVLVUGUYSRUUAUWSUVLVUMYCUWSUVLYCYDVUSUWSYCUXARUVLYAYCUWSWSQSUWSUVLVUNVUMU
      WSUVLVUNVUMRYIUWSUVLVUQYHUWSUVLYHYFUWSUVLYFXRUYLUWSUVLUWTYFUWSUVLUWTYFRZY
      RUWSYRUVLUYHQUWSVVAUYARUVLXRYFUWSXDQSVMSUWSUVLUXSYHUWSUVLUXSYHRYGUWSUVLYG
      XTVUTUWSUVLVUGYGUWSUVLVUGYGRZYSUWSYSUVLVUEQUWSVVBVUDRUVLXTYGUWSXDQSVMSUWS
      UVLUXSVUBYHUWSUXSVUBRYHRUVLYFYGUWSXBQVLSVMSUWSUVLUXRVUQUWSUVLUXRVUQRZYJVU
      RUWSVVCYJRUVLYHYIUWSXBQTVMSUWSUVLVUNYIVUMUWSVUNYIRVUMRUVLYCYIUWSXDQVLTVMS
      UWSUVLVUGUUAUYSUWSVUKUVLVULQVLTVMSVNVOVAXEUTYDYJABUAXFUTYMYEYNYKABUACEGXG
      ABUADFHXGXHXI $.
  $}

  ${
    iuneq12f.1 $e |- F/_ x A $.
    iuneq12f.2 $e |- F/_ x B $.
    $( Equality deduction for indexed unions.  (Contributed by Giovanni
       Mascellani, 10-Apr-2018.) $)
    iuneq12f $p |- ( ( A = B /\ A. x e. A C = D )
         -> U_ x e. A C = U_ x e. B D ) $=
      ( wceq wral wa ciun iuneq2 necon3ai intnand necon4ai iuneq2f adantr eqtrd
      wne ) BCHZDEHABIZJZABDKZABEKZACEKZUBUCUDUCUDSUATUAUCUDABDELMNOTUDUEHUAABC
      EFGPQR $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y D $.
    iineq12f.1 $e |- F/_ x A $.
    iineq12f.2 $e |- F/_ x B $.
    $( Equality deduction for indexed intersections.  (Contributed by Giovanni
       Mascellani, 10-Apr-2018.) $)
    iineq12f $p |- ( ( A = B /\ A. x e. A C = D ) ->
         |^|_ x e. A C = |^|_ x e. B D ) $=
      ( vy wceq wral wa cv wcel cab ciin wb eleq2 ralimi ralbi df-iin syl bitrd
      adantl raleqf adantr abbidv 3eqtr4g ) BCIZDEIZABJZKZHLZDMZABJZHNULEMZACJZ
      HNABDOACEOUKUNUPHUKUNUOABJZUPUJUNUQPZUHUJUMUOPZABJURUIUSABDEULQRUMUOABSUA
      UCUHUQUPPUJUOABCFGUDUEUBUFAHBDTAHCETUG $.
  $}

  $( Equality deduction for class abstraction of ordered pairs.  (Contributed
     by Giovanni Mascellani, 10-Apr-2018.) $)
  opabbi $p |- ( A. x A. y ( ph <-> ps ) ->
       { <. x , y >. | ph } = { <. x , y >. | ps } ) $=
    ( copab wceq wb wal eqopab2b biimpri ) ACDEBCDEFABGDHCHABCDIJ $.

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y D $.  $d y E $.
    mptbi12f.1 $e |- F/_ x A $.
    mptbi12f.2 $e |- F/_ x B $.
    $( Equality deduction for maps-to notations.  (Contributed by Giovanni
       Mascellani, 10-Apr-2018.) $)
    mptbi12f $p |- ( ( A = B /\ A. x e. A D = E ) ->
         ( x e. A |-> D ) = ( x e. B |-> E ) ) $=
      ( vy wceq wal wi wn id a1i wo a1d orcomdd cnf2dd cnfn2dd contrd wral wcel
      wa cv copab cmpt wb nfeq eleq2 alrimi ax-17 alimi syl eqeq2 ralimi df-ral
      alrimiv sylib 19.21v albii biimpri anim12i imdistanri alanimi wfal orsild
      idd tsan2 orsird tsbi2 tsim3 tsim2 notornotel2 tsbi3 tsan3 tsim1 notnotrd
      or32dd exmidd tsan1 tsbi1 efald2 2alimi eqopab2b df-mpt eqeq12i sylibr
      tsbi4 ) BCIZDEIZABUAZUCZAUDZBUBZHUDZDIZUCZAHUEZWMCUBZWOEIZUCZAHUEZIZABDUF
      ZACEUFZIWLWQXAUGZHJAJZXCWLWNWSUGZWNWPWTUGZKZUCZHJZAJZXGWLXHHJZAJZXJHJZAJZ
      UCXMWIXOWKXQWIXHAJXOWIXHAABCFGUHBCWMUIUJXHXNAXHHUKULUMWKWNXIHJZKZAJZXQWKX
      RABUAXTWJXRABWJXIHDEWOUNUQUOXRABUPURXQXTXPXSAWNXIHUSUTVAUMVBXNXPXLAXHXJXK
      HXJXHXHXJXHVGVCVDVDUMXKXFAHXKXFKZYALZVEXIYBVELZXIWNYBWNYCYBWNXAYBWNLZXAWQ
      YBYDWQLZWNYDYDKYBYDMNZYBYDWNYEYBWNYEOYDWNWPYBVHPQRYBYDWQXAYBWQXAOZYDYBYGY
      BYBYBYGLZYBMZPYBYHYBLZYAYBYHYAXFYBYHXFWQYHYEKYBYHWQXAYHMZVFNYBYHWQXFYBYHW
      QXFOXAYHXALZKYBYHWQXAYKVINYBYHWQXAXFYBYGXFOYHWQXAYBVJPVRRQRYBYHXFLZYAYBYM
      YAOZYHXKXFYBVKZPQSYBYHYBYJYBYBYJOZYHYBYBVSZPQSTZPQRYBYDYLWSYBYDWSLZWNYFYB
      YDWNYSYBWNYSOZYDYBYTXKYBXKYTLZYBXKYBYBYBXKLZYIPYBUUBYJYAYBUUBYAXKUUBUUBKY
      BUUBMNYBUUBXKYAYBXKYAOUUBXKXFYBVLPQRYBUUBYBYJYBYPUUBYQPQSTZPYBUUAUUBXHYBU
      UAXHLZWNUUAYDKYBUUAWNYSUUAMZVFNYBUUAWNUUDYBUUAWNUUDOWSUUAWSKYBUUAWNWSUUEV
      MNYBUUAWNYSUUDYBYTUUDOUUAWNWSYBVNPVRSQRYBUUAXHUUBYBXHUUBOZUUAXHXJYBVHZPQR
      TZPQRYBYDWSYLYBWSYLOZYDWSWTYBVHZPQRTPZYBYCYDXIYBYCYDXIOZXJYBYCXJXKYBXKYCU
      UCPZYBXJUUBOZYCXHXJYBVOZPSYBUULXJLOZYCWNXIYBVPZPSQSYBYCXILZWPYBYCWPWQYBYC
      WQXAYBYLYCYBYLWQYBYLLZWQWNYBUUSWNWSYBUUSWSXAUUSXAKYBUUSXAUUSMVQNZYBUUIUUS
      UUJPSYBYTUUSUUHPSZYBUUSYDWQYBUUSYDWQOWPYBUUSWPWTYBUUSWTXAUUTYBWTYLOUUSWSW
      TYBVOPSYBUUSWPWTLZOZXIYBUUSXIWNUVAYBUUSYDXIYBUUSUULXJYBUUSXJXKYBXKUUSUUCP
      YBUUNUUSUUOPSYBUUPUUSUUQPSQSYBUVCUUROUUSWPWTYBVNPSSYBUUSYDWPLZWQYBYDUVDOW
      QOUUSWNWPYBVTPVRSQSYBUUSYEXAUUTYBUUSYEYLOZXFYBUUSYMYAYBUUSYBYBYBYBUUSYIPY
      BYPUUSYQPSYBYNUUSYOPRYBUVEXFOUUSWQXAYBWAPRSTPZYBYGYCYRPRYBWPYEOYCWNWPYBVO
      PSYBYCUVDUURYBYCUVDUUROWTYBYCUVBWSYBYCWSWNUUKYBYCYDWSYBYCYDWSOZXHYBYCXHXK
      UUMYBUUFYCUUGPSYBUVGUUDOYCWNWSYBWHPSQSYBYCYSUVBYBYCYSUVBOZXAUVFYBUVHXAOYC
      WSWTYBVTPRQSYBYCUVDWTUURYBUVDWTOUUROYCWPWTYBWHPVRRQSTWBWCUMXCXGWQXAAHWDVA
      UMXDWRXEXBAHBDWEAHCEWEWFWG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Work in progress or things that do not belong anywhere else.

$)

  ${
    $d x y $.  $d x z $.
    $( Substituting ` y ` for ` x ` and then ` z ` for ` y ` is equivalent to
       substituting ` z ` for both ` x ` and ` y ` .  (Contributed by Giovanni
       Mascellani, 8-Apr-2018.) $)
    sbcom3 $p |- ( [ z / y ] [ y / x ] ph <-> [ z / x ] [ z / y ] ph ) $=
      ( wi wa wn id a1i wo a1d orcomdd cnf2dd or32dd tsim3 cnfn2dd contrd tsan3
      tsan1 tsim2 wsb cv wceq wex wb equtr impcom equtr2 eqcomd imbi2d pm5.74rd
      eqeq2 pm5.32rd exbidv pm5.74i imbi1d pm5.32i wfal tsan2 tsbi2 tsbi3 tsbi4
      exmidd tsbi1 efald2 ax-mp exbii orsild orsird notnotrd tsim1 df-sb imbi2i
      anbi2i anbi12i bitri bicomi bitr4i 3bitr4i sbcom ) ABCUAZCDUAZABDUAZCDUAZ
      ACDUABDUACUBZDUBZUCZBUBZWEUCZAEZWIAFZBUDZFZEZWGWMFZCUDZFZWGWHWFUCZAEZWRAF
      ZBUDZFZEZWGXBFZCUDZFZWBWDWGWIFZWREZWQXFUEZWIWGWRBCDUFUGWGWRFZWIEZXHXIEZXJ
      WEWHCBDUHUIWGWLEZWGXAEZUEZXKXLEZWGWLXAWGWKWTBWGAWIWRWGAWIWRWGWIWRAWEWFWHU
      LZUJUKUMUNZUOWPXEUEZXOXPEZWOXDCWGWJFZWGWSFZUEZWOXDUEZWGWJWSWGWIWRAXQUPUQW
      GWLFZWGXAFZUEZYCYDEZWGWLXAXRUQYGYHEZYIGZURXBYJURGZXBWSYJYKWSYBYJYKYBYAYJY
      KYAWGYJWGYKYJWGYHYJWGGZYHYDYJYLYDWOYJYLWOGZWGYLYLEYJYLHIZYJYLWGYMYJWGYMJY
      LWGWMYJUSKLMYJYLWOYDYJYLWOYDJXDYJYLXDGZWGYNYJYLWGYOYJWGYOJYLWGXBYJUSKLMYJ
      YLWOXDYDYJWOXDJZYDJZYLWOXDYJUTZKNMLMYJYLYDGZYHYJYSYHJZYLYCYDYJOZKLPYJYLYH
      GZYIYJYLYJYJYJYJYLYJHZKYJYJYJGJZYLYJYJVCZKPYJUUBYIJZYLYGYHYJOZKMQZKZYJYKY
      LYAYJYKYLYAJWJYJYKWJWMYJYKWMWOYJWOYKYJWOWMYJYMWMWJYJYMWJYAYJYMYAYBYJYMYBW
      GYJWGYMUUHKZYJYMYLYBYJYMYLYBJWSYJYMWSXBYJYMXBXDYJYMXDWOYMYMEYJYMHIZYJYMWO
      XDYJYMYPYDYJYMYSYHYJYMUUBYIYJYMYJYJYJYJYMUUCKZYJUUDYMUUEKPYJUUFYMUUGKMZYJ
      YTYMUUAKMYJYQYMYRKMLMYJXBYOJYMWGXBYJRKPZYJWSXBGZJZYMWSXAYJUSKPYJYMYLWSGZY
      BYJYLUUQJYBJYMWGWSYJSKNPLPYJYMYAYBGZJZYCYJYMYCYHUUMYJYCYHJZYMYCYDYJTZKMYJ
      UUSYCGZJYMYAYBYJVAKPPYJWJYAGZJYMWGWJYJRKPYJYMWJGZWMYJYMUVDWMJWLYJYMWLYEYJ
      YMYEYFYJYMYFWGUUJYJYMYLYFYJYMYLYFJXAYJYMXAXBUUNYJXAUUOJZYMWSXAYJRKPYJYMYL
      XAGZYFYJYLUVFJYFJYMWGXAYJSKNPLPYJYMYEYFGZJZYGYJYMYGYIUULYJYGYIJZYMYGYHYJT
      ZKMYJUVHYGGZJYMYEYFYJVAKPPYJWLYEGZJYMWGWLYJRKPYJYMUVDWLGZWMYJUVDUVMJZWMJZ
      YMWJWLYJSKNPLPYJYMWMGZWGUUJYJYMYLUVPYJYMYLUVPJZWOUUKYJUVQWOJYMWGWMYJSKMLP
      QKZYJWMYMJYKWGWMYJRKPZYJWJUVPJZYKWJWLYJUSKPYJYKYLUVDYAYJYLUVDJYAJYKWGWJYJ
      SKNPLPYJYKUVCYBYJYKUVCYBJZYCYJYKYCYHYJYKUUBYIYJYKYJYJYJYJYKUUCKZYJUUDYKUU
      EKPYJUUFYKUUGKMZYJUUTYKUVAKMYJUWAUVBJYKYAYBYJVBKPLPYJWSUURJYKWGWSYJRKPYJY
      KUUQXBYJYKUUQXBJXAYJYKXAYFYJYKYFYEYJYKYEWGUUIYJYKYLYEYJYKYLYEJWLYJYKWLWMU
      VSYJWLUVPJZYKWJWLYJRKPYJYKYLUVMYEYJYLUVMJYEJYKWGWLYJSKNPLPYJYKUVLYFYJYKUV
      LYFJZYGYJYKYGYIUWBYJUVIYKUVJKMYJUWEUVKJYKYEYFYJVBKPLPYJXAUVGJYKWGXAYJRKPY
      JYKUUQUVFXBYJUUQUVFJZXBJZYKWSXAYJSKNPLPYJYKUUOWGUUIYJYKYLUUOYJYKYLUUOJZXD
      YJYKYOWOUVRYJYKYMYOYJYKYMYOJZYDYJYKYSYHUWCYJYTYKUUAKMYJUWIYDJYKWOXDYJVDKM
      LPYJUWHXDJYKWGXBYJSKMLPQVEVFVFVGXSXTEZUWJGZURXHUWKXHYKUWKXHXTUWKXHGZXTXPU
      WKUWLXPXLUWKUWLXLXHUWLUWLEUWKUWLHIUWKUWLXHXLUWKXHXLJUWLXHXIUWKTKLMUWKUWLX
      LGZXPUWKUWMXPJZUWLXKXLUWKOZKLPUWKUWLXPGZXTUWKUWPXTJZUWLXOXPUWKOZKLPUWKUWL
      XTGZUWJUWKUWLUWKUWKUWKUWKUWLUWKHZKUWKUWKUWKGZJZUWLUWKUWKVCZKPUWKUWSUWJJZU
      WLXSXTUWKOZKMQKUWKYKUWLXGUWKYKXGWGUWKYKWGWNUWKYKWNGZWPUWKYKWPXEUWKXEYKUWK
      XEWQUWKXEGZWQXFUWKUXGXFGZXEUXGUXGEUWKUXGHIZUWKUXGXEUXHUWKXEUXHJUXGXCXEUWK
      RKLMUWKWQXFJZUXGUWKUXJXTUWKUXJGZXTXPUWKUXKXPXLUWKUXKXLXIUWKUXKXIWQUXKWQGZ
      EUWKUXKWQXFUXKHZVHIUWKUXKWQXIUWKUXKWQXIJXFUXKUXHEUWKUXKWQXFUXMVIIUWKUXKWQ
      XFXIUWKUXJXIJUXKWQXFUWKUTKNMLMUWKUXKXIGZXLUWKUXNXLJZUXKXHXIUWKOZKLPUWKUXK
      UWMXPUWKUWNUXKUWOKLPUWKUXKUWPXTUWKUWQUXKUWRKLPUWKUXKUWSUWJUWKUXKUWKUWKUWK
      UWKUXKUWTKUWKUXBUXKUXCKPUWKUXDUXKUXEKMQZKMUWKUXGUXLWPUWKUXGWPGZXEUXIUWKUX
      GUXRXEJZXSUWKXSUXGUWKXSUWKUWKUWKXSGZUWTKUWKUXTUXAUWJUWKUXTUWJXSUXTUXTEUWK
      UXTHIUWKUXTXSUWJUWKXSUWJJUXTXSXTUWKTKLMUWKUXTUWKUXAUWKUXBUXTUXCKLPQZKUWKU
      XSUXTJUXGWPXEUWKVBKPMUWKUXGWPUXLUWKWPUXLJUXGWNWPUWKRKLMQZKUWKYKWPUXGJZXSU
      WKXSYKUYAKUWKUYCUXTJYKWPXEUWKVAKPPUWKYKUXFUXRJZWQUWKUXLYKUWKUXLWJUWKUXLGZ
      WJWMUWKUYEWMWGUWKUYEWGXCUWKUYEXCGZXEUWKXEUYEUYBKUWKUYEUYFUXGJZXFUWKUYEUXH
      WQUYEWQEUWKUYEWQUYEHVJIZUWKUYEUXLUXHUWKUYEUXLUXHJZXIUWKUYEUXNXLUWKUYEUWMX
      PUWKUYEUWPXTUWKUYEUWSUWJUWKUYEUWKUWKUWKUWKUYEUWTKUWKUXBUYEUXCKPUWKUXDUYEU
      XEKMUWKUWQUYEUWRKMUWKUWNUYEUWOKMUWKUXOUYEUXPKMUWKUYIXIJUYEWQXFUWKVDKMLPUW
      KUYGXFJUYEXCXEUWKSKMPZUWKWGXCJUYEWGXBUWKTKMZUWKUYEYLWMUWKUYEYLWMJZWNUWKUY
      EWNWQUYHUWKWNUXLJUYEWNWPUWKUSKPUWKUYLUXFJUYEWGWMUWKVKKPLPZUWKUVTUYEWJWLUW
      KUSKPUWKUYEUVDWIUWKUYEWIXJUWKUYEXJWGUYKUWKUYEYLXJUWKUYEYLXJJWRUWKUYEWRWSU
      WKUYEUUQXAUWKUYEXAWGUYKUWKUYEYLXAUWKUYEYLXAJZXNUWKUYEXNXMUWKUYEXMWLUWKUYE
      WLWMUYMUWKUWDUYEWJWLUWKRKPUWKUYEUVMXMUWKUVMXMJUYEWGWLUWKOKLPUWKUYEXMGZXNU
      WKUYEUYOXNJZXOUWKXOUYEUWKXOUWJUWKXOGZUWJXTUWKUYQXTXOUYQUYQEUWKUYQHIUWKUYQ
      XOXTUWKXOXTJUYQXOXPUWKTKLMUWKUYQUWSUWJUWKUXDUYQUXEKLPUWKUYQUWKUWKUWKUWKUY
      QUWTKUWKUXBUYQUXCKPQZKUWKUYPUYQJUYEXMXNUWKVBKPLPUWKUYNXNGZJUYEWGXAUWKVKKP
      LPUWKUYEUWFXBUWKUYEUUOXCUYJUWKUUOXCJUYEWGXBUWKOKMUWKUWGUYEWSXAUWKSKMPZUWK
      WRWSJUYEWRAUWKTKMUWKUYEYLWRGZXJUWKYLVUAJXJJUYEWGWRUWKSKNPLPUWKUYEXJGZWIUW
      KUYEVUBWIJZXKUWKXKUYEUWKXKUWJUWKXKGZUWJXTUWKVUDXTXPUWKVUDXPXKVUDVUDEUWKVU
      DHIUWKVUDXKXPUWKXKXPJVUDXKXLUWKTKLMUWKVUDUWPXTUWKUWQVUDUWRKLPUWKVUDUWSUWJ
      UWKUXDVUDUXEKLPUWKVUDUWKUWKUWKUWKVUDUWTKUWKUXBVUDUXCKPQKUWKVUCVUDJUYEXJWI
      UWKVKKPLPUWKUYEWIGZUVDUWKUYEVUEUVDJAUWKUYEAGZWSUYTUWKVUFWSJUYEWRAUWKOKMUW
      KUYEVUEAUVDUWKVUEAJUVDJUYEWIAUWKVKKNMLPQKZUWKUYDWQJYKWNWPUWKSKMPZUWKWGWNJ
      YKWGWMUWKTKMZUWKYKYLXGUWKYKYLXGJWIUWKYKWIWJUWKYKUVDWLUWKYKWLWGVUIUWKYKYLW
      LUWKYKYLWLJZXMUWKYKXMXNUWKYKXNXAUWKYKXAXBUWKYKXBWGVUIUWKYKYLXBUWKYKYLXBJZ
      XCUWKYKXCXFUWKYKXFWQVUGUWKYKWQXFUWKUXJYKUXQKLMUWKXCUXHJYKXCXEUWKUSKPUWKVU
      KUYFJYKWGXBUWKVKKPLPZUWKUVEYKWSXAUWKRKPUWKYKUVFXNUWKUVFXNJYKWGXAUWKOKLPUW
      KYKXMUYSJZXOUWKXOYKUYRKUWKVUMUYQJYKXMXNUWKVAKPPUWKVUJUYOJYKWGWLUWKVKKPLPU
      WKYKUVNWMUWKYKUVPWNVUHUWKUVPWNJYKWGWMUWKOKMUWKUVOYKWJWLUWKSKMPZUWKWIWJJYK
      WIAUWKTKMUWKYKYLVUEXGUWKYLVUEJXGJYKWGWIUWKSKNPLPUWKYKXGGZUWLUWKYKVUOUWLJW
      RUWKYKVUAAUWKYKVUFWJVUNUWKVUFWJJYKWIAUWKOKMUWKYKVUAAJZWSUWKYKWSXBVULUWKUU
      PYKWSXAUWKUSKPUWKVUPUUQJYKWRAUWKVKKPMUWKYKVUOWRUWLUWKVUOWRJUWLJYKXGWRUWKV
      KKNMLPQVEVFVFVFVFWBWGWAEZWGWAFZCUDZFWQWACDVLVUQWNVUSWPWAWMWGABCVLZVMVURWO
      CWAWMWGVUTVNVGVOVPWDWGWCEZWGWCFZCUDZFXFWCCDVLXCVVAXEVVCXBWCWGWCXBABDVLZVQ
      VMVVCXEVVBXDCWCXBWGVVDVNVGVQVOVRVSACDBVTVR $.
  $}

  ${
    $d x y $.  $d x z $.  $d x w $.  $d y z $.  $d z w $.  $d z A $.  $d w A $.
    scottexf.1 $e |- F/_ y A $.
    scottexf.2 $e |- F/_ x A $.
    $( A version of ~ scottex with non-free variables instead of distinct
       variables.  (Contributed by Giovanni Mascellani, 19-Aug-2018.) $)
    scottexf $p |- { x e. A | A. y e. A ( rank ` x ) C_ ( rank ` y ) } e. _V $=
      ( vw vz cv crnk cfv wss wral crab cvv wcel nfcv nfv wceq fveq2 sseq2d
      cbvralf imbi2i rabbiia nfral sseq1d ralbidv cbvrab eqtr4i scottex eqeltri
      pm5.74ri ) AHZIJZBHZIJZKZBCLZACMZFHZIJZGHZIJZKZGCLZFCMZNURUMVBKZGCLZACMVE
      UQVGACULCOZUQVGUQVGVHUPVFBGCDGCPUPGQVFBQUNVARUOVBUMUNVAISTUAUBUKUCVDVGFAC
      FCPEVCAGCEVCAQUDVGFQUSULRZVCVFGCVIUTUMVBUSULISUEUFUGUHFGCUIUJ $.
  $}

  ${
    $d x y $.  $d x z $.  $d x w $.  $d y z $.  $d z w $.  $d z A $.  $d w A $.
    scott0f.1 $e |- F/_ y A $.
    scott0f.2 $e |- F/_ x A $.
    $( A version of ~ scott0 with non-free variables instead of distinct
       variables.  (Contributed by Giovanni Mascellani, 19-Aug-2018.) $)
    scott0f $p |- ( A = (/) <-> { x e. A | A. y e. A ( rank ` x )
         C_ ( rank ` y ) } = (/) ) $=
      ( vw vz c0 wceq cv crnk cfv wss wral crab scott0 wcel nfcv nfv fveq2
      sseq2d cbvralf imbi2i pm5.74ri rabbiia nfral sseq1d ralbidv cbvrab eqtr4i
      eqeq1i bitr4i ) CHIFJZKLZGJZKLZMZGCNZFCOZHIAJZKLZBJZKLZMZBCNZACOZHIFGCPVF
      USHVFVAUPMZGCNZACOUSVEVHACUTCQZVEVHVEVHVIVDVGBGCDGCRVDGSVGBSVBUOIVCUPVAVB
      UOKTUAUBUCUDUEURVHFACFCREUQAGCEUQASUFVHFSUMUTIZUQVGGCVJUNVAUPUMUTKTUGUHUI
      UJUKUL $.
  $}

  ${
    $d x y $.
    scottn0f.1 $e |- F/_ y A $.
    scottn0f.2 $e |- F/_ x A $.
    $( A version of ~ scott0f with inequalities instead of equalities.
       (Contributed by Giovanni Mascellani, 19-Aug-2018.) $)
    scottn0f $p |- ( A =/= (/) <-> { x e. A | A. y e. A ( rank ` x )
         C_ ( rank ` y ) } =/= (/) ) $=
      ( c0 cv crnk cfv wss wral crab scott0f necon3bii ) CFAGHIBGHIJBCKACLFABCD
      EMN $.
  $}

  ${
    $d ph f $.  $d x y $.  $d x A $.  $d x f $.  $d y f $.  $d A f $.
    ac6s3f.1 $e |- F/ y ps $.
    ac6s3f.2 $e |- A e. _V $.
    ac6s3f.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Generalization of the Axiom of Choice to classes, with bound-variable
       hypothesis.  (Contributed by Giovanni Mascellani, 19-Aug-2018.) $)
    ac6s3f $p |- ( A. x e. A E. y ph -> E. f A. x e. A ps ) $=
      ( wex wral cvv wrex cv wf wa rexv ralbii biimpri ac6sf exsimpr 3syl ) ADJ
      ZCEKZADLMZCEKZELFNOZBCEKZPFJUHFJUFUDUEUCCEADQRSABCDELFGHITUGUHFUAUB $.
  $}

  ${
    $d ph f $.  $d x y $.  $d x A $.  $d x f $.  $d y f $.  $d A f $.
    ac6s6.1 $e |- F/ y ps $.
    ac6s6.2 $e |- A e. _V $.
    ac6s6.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    $( Generalization of the Axiom of Choice to classes, moving the existence
       condition in the consequent.  (Contributed by Giovanni Mascellani,
       19-Aug-2018.) $)
    ac6s6 $p |- E. f A. x e. A ( E. y ph -> ps ) $=
      ( wi wn id a1d wo cnfn2dd tsim2 cnf2dd tsim3 orcomdd contrd wex wcel wral
      cv cab cvv cif hbe1 iftrue abeq2d exbidh ibir vex exiftru wceq iffalse wb
      hbn eleq2d wfal exmidd tsbi3 or32dd tsim1 efald2 ax-mp pm2.61i rgenw nfe1
      nfim cfv a1i tsbi4 tsbi2 tsbi1 wtru notornotel2 notornotel1 a1tru ac6s3f
      ) DUDZADUAZADUEZUFUGZUBZDUAZCEUCWBBJZCEUCFUAWFCEWBWFWBWFWBWEADADUHZWBADWD
      WBWCUFUIUJZUKULWAUFUBZDUAZWBKZWFJZWJDDUMZUNWLWDUFUOJZWKWMJZWBWCUFUPZWLWFW
      KUQZJZWOWPJZWLWEWJDWBDWHURWLWDUFWAWQUSZUKWSWTJZXBKZUTWSXCUTKZWSXBXCXDXCXC
      XCXCXDXCLMZXCXCXCKNXDXCXCVAMOXCWSXBNXDWSWTXCPMQXCXDWSKZWLXCXDWLWMXCXDWMKZ
      WPXCXDWPKZWTXCXDWTKZXBXEXCXIXBNXDWSWTXCRMQXCXHWTNXDWOWPXCRMQZXCXGWPNXDWKW
      MXCRMQZXCWLWMNXDWLWFXCPMQXCXDWLKZXFXCXDXLXFNWRXCXDWRKZWFXCXDWFKZWMXKXCXNW
      MNXDWLWFXCRMQXCXDWFXMXCXDWFXMNWKXCXDWKWPXJXCWKWPNXDWKWMXCPMQXCXDWFWKKZXMX
      CWFXONXMNXDWFWKXCVBMVCOSQXCXDXLWRXFXCXLWRNXFNXDWLWRXCVDMVCQSOTVEVFVFVFVGV
      HWEWGCDEFWBBDADVIGVJHWBWACUDFUDVKUOZWEWGUQZJZWBWEAUQZJZWBXRJZWIXPABUQZJZX
      TYAJZIYCYDJZYEKZUTXQYFXDXQWEYFXDWEAYFAXDYFAWGYFAKZWGWEYFYGWEKZAYGYGJYFYGL
      VLZYFYGYHANZXSYFYGXSWBYFYGWBYAYFYGYAKZYDYFYGYDKZYEYFYGYFYFYFYFYGYFLZMYFYF
      YFKZNZYGYFYFVAZMOYFYLYENZYGYCYDYFRZMQZYFYKYDNZYGXTYAYFRZMQZYFWBYANZYGWBXR
      YFPZMQZYFYGWLXSYFYGWLXSNZXTYFYGXTYDYSYFXTYDNZYGXTYAYFPZMQYFUUFXTKNZYGWBXS
      YFVDZMOSOYFYJXSKZNYGWEAYFVMMOQYFYGWEWGYFYGWEWGNZXQYFYGXQKZXRYFYGXRKZYAUUB
      YFUUNYANZYGWBXRYFRZMQZYFUUMXRNZYGXPXQYFRZMQYFUULXQNYGWEWGYFVNMQSQYFYGWGKZ
      WBUUEYFYGWLUUTYFYGWLUUTNBYFYGBKZAYIYFYGAUVAYFYGAUVANZYBYFYGYBXPYFYGXPXRUU
      QYFXPXRNZYGXPXQYFPZMQYFYGXPKZYBYFYGUVEYBNZYCYFYCYGYFYCYFYFYFYCKZYMMYFUVGY
      NYEYFUVGYEYCUVGUVGJYFUVGLVLYFUVGYCYEYFYCYENUVGYCYDYFPMSQYFUVGYFYNYFYOUVGY
      PMSOTZMYFUVFUVGNZYGXPYBYFVDZMOSOYFUVBYBKZNYGABYFVBMOSQYFYGWLBUUTYFWLBNUUT
      NYGWBBYFVDMVCQSOTMZYFXDWEYGNZXSYFXDXSWBYFXDWBYAYFXDYKYDYFXDYLYEYFXDYFYFYF
      YFXDYMMYFYOXDYPMOYFYQXDYRMQZYFYTXDUUAMQZYFUUCXDUUDMQYFXDWLXSYFXDUUFXTYFXD
      XTYDUVNYFUUGXDUUHMQYFUUIXDUUJMOSOYFUVMUUKNXDWEAYFVBMOOYFXDYHXQYFXDYHXQNWG
      YFXDWGBYFXDBAUVLYFXDYGBYFXDYGBNZYBYFXDYBXPYFXDXPXRYFXDUUNYAUVOYFUUOXDUUPM
      QZYFUVCXDUVDMQYFXDUVEYBYFXDUVFYCYFYCXDUVHMYFUVIXDUVJMOSOYFUVPUVKNXDABYFVM
      MOSOYFXDUVAWGYFUVAWGNXDWBBYFRMSOYFXDYHUUTXQYFYHUUTNZXQNZXDWEWGYFVOMVCOSOY
      FXDUUMXRUVQYFUURXDUUSMQTVEVFVFWLWEVPUQZJZWLXRJZWLWEWJUQZJZUWAXAWLWJJZUWDU
      WAJZWJWLWNVLUWEUWFJZUWGKZUTWJUWHXDWJWLUWHWLXDUWHWLUWGUWHXLUWGUWFUWHXLUWFU
      WAUWHXLUWAWLXLXLJUWHXLLVLUWHXLWLUWAUWHWLUWANXLWLUVTUWHPMSQUWHXLUWAKZUWFUW
      HUWIUWFNZXLUWDUWAUWHRZMSOUWHXLUWFKZUWGUWHUWLUWGNZXLUWEUWFUWHRZMSOUWHXLUWH
      UWHUWHUWHXLUWHLZMUWHUWHUWHKZNZXLUWHUWHVAZMOTMZUWHXDXLWJUWHXDXLWJNZUWEUWHU
      WEXDUWHUWEUWHUWHUWHUWEKZUWOMUWHUXAUWPUWGUWHUXAUWGUWEUXAUXAJUWHUXALVLUWHUX
      AUWEUWGUWHUWEUWGNUXAUWEUWFUWHPMSQUWHUXAUWHUWPUWHUWQUXAUWRMSOTMUWHUWTUXANX
      DWLWJUWHVDMOSOUWHXDWJKZUWCUWHXDUWCWLUWSUWHXDXLUWCUWHXDXLUWCNZUWDUWHUWDXDU
      WHUWDUWHUWHUWHUWDKZUWOMUWHUXDUWPUWGUWHUXDUWGUWFUWHUXDUWFUWDUXDUXDJUWHUXDL
      VLUWHUXDUWDUWFUWHUWDUWFNUXDUWDUWAUWHPMSQUWHUXDUWLUWGUWHUWMUXDUWNMSOUWHUXD
      UWHUWPUWHUWQUXDUWRMSOTMUWHUXCUXDNXDWLUWCUWHVDMOSOUWHXDUWCKZUXBUWHUXEUXBNZ
      XDUWHUXFUWFUWHUXFKZUWFUWAUWHUXGUWAUVTUWHUXGUVTWEUWHUXGWEWJUXGWJJUWHUXGUXE
      WJUXGLZVQVLUWHUXGWEUXBNZUWCUXGUWCJUWHUXGUWCUXBUXHVRVLUWHUXIUXENUXGWEWJUWH
      VBMOOUWHUXGYHUVTUWHUXGYHUVTNVPUWHVPUXGUWHVSMUWHUXGYHVPKZUVTUWHYHUXJNUVTNU
      XGWEVPUWHVOMVCOSOUWHUXGUVTKZUWAUWHUXKUWANUXGWLUVTUWHRMSOUWHUXGUWIUWFUWHUW
      JUXGUWKMSOUWHUXGUWLUWGUWHUXGUWHUWHUWHUWHUXGUWOMUWHUWQUXGUWRMOUWHUWMUXGUWN
      MQTMSOTVEVFVFUWAUWBJZUXLKZUTUVTUXMXDUVTWLUXMXDWLUWBUXMXDUWBKZUXLUXMXDUXMU
      XMUXMUXMXDUXMLZMZUXMUXMUXMKNZXDUXMUXMVAZMOUXMUXNUXLNZXDUWAUWBUXMRZMQZUXMW
      LUWBNZXDWLXRUXMPZMQUXMXDXLUVTUXMXDXLUVTNZUWAUXMXDUWAUXLUXPUXMUWAUXLNXDUWA
      UWBUXMPMQUXMUYDUWINXDWLUVTUXMVDMOSOUXMXDUXKWEUXMXDYHWGUXMWGXDUXMWGUXLUXMU
      UTUXLUWBUXMUUTUWBWLUXMUUTXLWBUXMUUTWBWGUUTUUTJUXMUUTLVLUXMWBWGNUUTWBBUXMP
      MQUXMUUTWLXLUXMWLXLNUUTUXMWLVAMSOUXMUUTWLUWBUXMUYBUUTUYCMSQUXMUUTUXNUXLUX
      MUXSUUTUXTMSOUXMUUTUXMUXMUXMUXMUUTUXOMUXMUXQUUTUXRMOTMUXMXDUVRXQUXMXDUUMX
      RUXMXDUUNUWBUYAUXMUUNUWBNXDWLXRUXMRMQUXMUURXDXPXQUXMRMQUXMUVSXDWEWGUXMVOM
      QOUXMXDWEUXKUXMXDWEUXKNVPUXMVPXDUXMVSMUXMXDWEUXJUXKUXMWEUXJNUXKNXDWEVPUXM
      VBMVCOSQTVEVFVGVTVF $.
  $}

  ${
    $d ph z $.  $d ph f $.  $d ps z $.  $d x y $.  $d x z $.  $d x f $.
    $d y z $.  $d y f $.  $d z A $.  $d z f $.  $d A f $.
    ac6s6f.1 $e |- A e. _V $.
    ac6s6f.2 $e |- F/ y ps $.
    ac6s6f.3 $e |- ( y = ( f ` x ) -> ( ph <-> ps ) ) $.
    ac6s6f.4 $e |- F/_ x A $.
    $( Generalization of the Axiom of Choice to classes, moving the existence
       condition in the consequent.  (Contributed by Giovanni Mascellani,
       20-Aug-2018.) $)
    ac6s6f $p |- E. f A. x e. A ( E. y ph -> ps ) $=
      ( vz wex wi wral cv wceq wa isseti vex ax-mp ac6s6 pm3.2i exdistr biimpri
      exan nfcv raleqf biimpa 2eximi ax17e ) ADLBMZCENZFLZKLZUMKOZEPZUKCUONZQZF
      LKLZUNUPUQFLZQKLZUSUPUTKUPKLUTKEGRABCDUOFHKSIUAUBUEUSVAUPUQKFUCUDTURULKFU
      PUQULUKCUOECUOUFJUGUHUITUMKUJT $.
  $}

$( (End of Giovanni Mascellani's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                            Mathbox for Rodolfo Medina
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                  Partitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    prtlem60.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    prtlem60.2 $e |- ( ps -> ( th -> ta ) ) $.
    $( Lemma for ~ prter3 .  (Contributed by Rodolfo Medina, 9-Oct-2010.) $)
    prtlem60 $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      ( wi a1i syldd ) ABCDEFBDEHHAGIJ $.
  $}

  ${
    bicomdd.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( Commute two sides of a biconditional in a deduction.  (Contributed by
       Rodolfo Medina, 19-Oct-2010.)  (Proof shortened by Andrew Salmon,
       29-Jun-2011.) $)
    bicomdd $p |- ( ph -> ( ps -> ( th <-> ch ) ) ) $=
      ( wb bicom syl6ib ) ABCDFDCFECDGH $.
  $}

  ${
    prtlem1.1 $e |- ( ps -> ( ch -> ph ) ) $.
    $( Add a disjunct in the antecedent.  (Contributed by Rodolfo Medina,
       24-Sep-2010.) $)
    prtlem1 $p |- ( ( ph \/ ps ) -> ( ch -> ph ) ) $=
      ( wi ax-1 jaoi ) ACAEBACFDG $.
  $}

  ${
    jca2.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jca2.2 $e |- ( ps -> th ) $.
    $( Inference conjoining the consequents of two implications.  (Contributed
       by Rodolfo Medina, 12-Oct-2010.) $)
    jca2 $p |- ( ph -> ( ps -> ( ch /\ th ) ) ) $=
      ( wi a1i jcad ) ABCDEBDGAFHI $.
  $}

  ${
    jca2r.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jca2r.2 $e |- ( ps -> th ) $.
    $( Inference conjoining the consequents of two implications.  (Contributed
       by Rodolfo Medina, 17-Oct-2010.) $)
    jca2r $p |- ( ph -> ( ps -> ( th /\ ch ) ) ) $=
      ( wi a1i jcad ) ABDCBDGAFHEI $.
  $}

  ${
    jca3.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jca3.2 $e |- ( th -> ta ) $.
    $( Inference conjoining the consequents of two implications.  (Contributed
       by Rodolfo Medina, 14-Oct-2010.) $)
    jca3 $p |- ( ph -> ( ps -> ( th -> ( ch /\ ta ) ) ) ) $=
      ( wa wi imp a1d jca2 ex ) ABDCEHIABHZDCENCDABCFJKGLM $.
  $}

  ${
    prtlem50.1 $e |- ( ph -> ( ps -> ch ) ) $.
    prtlem50.2 $e |- ( th -> ta ) $.
    $( Lemma for ~ prter3 .  (Contributed by Rodolfo Medina, 12-Oct-2010.) $)
    prtlem50 $p |- ( ph -> ( ( ps /\ th ) -> ( ch /\ ta ) ) ) $=
      ( wi a1i anim12d ) ABCDEFDEHAGIJ $.
  $}

  $( Rearrangement of 4 conjuncts.  (Contributed by Rodolfo Medina,
     24-Sep-2010.)  (Proof shortened by Andrew Salmon, 29-Jun-2011.) $)
  an43 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
               ( ( ph /\ th ) /\ ( ps /\ ch ) ) ) $=
    ( wa an42 bicomi ) ADEBCEEABECDEEADBCFG $.

  $( Rearrangement of 4 conjuncts.  (Contributed by Rodolfo Medina,
     24-Sep-2010.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  an43OLD $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) <->
               ( ( ph /\ th ) /\ ( ps /\ ch ) ) ) $=
    ( wa ancom anbi2i an4 bitri ) ABEZCDEZEJDCEZEADEBCEEKLJCDFGABDCHI $.

  $( A rearrangement of conjuncts.  (Contributed by Rodolfo Medina,
     25-Sep-2010.) $)
  an3 $p |- ( ( ( ph /\ ps ) /\ ( ch /\ th ) ) -> ( ph /\ th ) ) $=
    ( wa an43 simplbi ) ABECDEEADEBCEABCDFG $.

  $( Lemma for ~ prter3 : a rearrangement of conjuncts.  (Contributed by
     Rodolfo Medina, 20-Oct-2010.) $)
  prtlem70 $p |- ( ( ( ( ps /\ et ) /\ ( ( ph /\ th ) /\ ( ch /\ ta ) ) )
                        /\ ph ) <-> ( ( ph /\ ( ps /\ ( ch /\ ( th /\ ta ) ) )
    ) /\ et ) ) $=
    ( wa anass anbi1i anandi ancom 3bitr4ri bitri 3bitri an4 anbi2i ) BFGZADGZC
    EGZGZGZAGZABDGZGZSGZFGZAUCSGZGZFGABCDEGZGGZGZFGABGZRGZSGZFGULTGZFGZUFUBUNUO
    FULRSHIUEUNFUDUMSABDJIIUBULFGZTGZFULGZTGZUPAQGZTGAUAGURUBAQTHUQVATABFHIUAAK
    LUQUSTULFKIUTFUOGUPFULTHFUOKMNLUEUHFAUCSHIUHUKFUGUJAUGBCGUIGUJBDCEOBCUIHMPI
    N $.

  ${
    ibdr.1 $e |- ( ph -> ( ch -> ( ps <-> ch ) ) ) $.
    $( Reverse of ibd.  (Contributed by Rodolfo Medina, 30-Sep-2010.) $)
    ibdr $p |- ( ph -> ( ch -> ps ) ) $=
      ( bicomdd ibd ) ACBACBCDEF $.
  $}

  $( Variant of ~ pm5.31 .  (Contributed by Rodolfo Medina, 15-Oct-2010.) $)
  pm5.31r $p |- ( ( ch /\ ( ph -> ps ) ) -> ( ph -> ( ch /\ ps ) ) ) $=
    ( wi wa pm3.2 imim2d imp ) CABDACBEZDCBIACBFGH $.

  $( Double the quantifiers of theorem r19.29.  (Contributed by Rodolfo Medina,
     25-Sep-2010.) $)
  2r19.29 $p |- ( ( A. x e. A A. y e. B ph /\ E. x e. A E. y e. B ps )
                        -> E. x e. A E. y e. B ( ph /\ ps ) ) $=
    ( wral wrex wa r19.29 reximi syl ) ADFGZCEGBDFHZCEHIMNIZCEHABIDFHZCEHMNCEJO
    PCEABDFJKL $.

  $( Lemma for ~ prter3 .  (Contributed by Rodolfo Medina, 19-Oct-2010.) $)
  prtlem100 $p |- ( E. x e. A ( B e. x /\ ph ) <->
                        E. x e. ( A \ { (/) } ) ( B e. x /\ ph ) ) $=
    ( cv wcel wa csn cdif wne anass eldifsn anbi1i ne0i pm4.71ri bitri 3bitr4ri
    c0 anbi2i rexbii2 ) DBEZFZAGZUCBCCRHIZUACFZUARJZGZUCGUEUFUCGZGUAUDFZUCGUEUC
    GUEUFUCKUIUGUCUACRLMUCUHUEUCUFUBGZAGUHUBUJAUBUFUADNOMUFUBAKPSQT $.

  ${
    $d u v x r $.  $d u v x s $.  $d u v x A $.
    $( Lemma for ~ prter1 , ~ prter2 , ~ prter3 and ~ prtex .  (Contributed by
       Rodolfo Medina, 25-Sep-2010.)  (Proof shortened by Mario Carneiro,
       11-Dec-2016.) $)
    prtlem5 $p |- ( [ s / v ] [ r / u ] E. x e. A ( u e. x /\ v e. x )
                        <-> E. x e. A ( r e. x /\ s e. x ) ) $=
      ( wel wa wrex wsb nfv weq elequ1 bi2anan9r rexbidv sbiedv sbie ) CAGZBAGZ
      HZADIZCFJFAGZEAGZHZADIZBEUEBKBELZUAUECFUFCFLZHTUDADUGRUBUFSUCCFAMBEAMNOPQ
      $.
  $}

  $( Lemma for ~ prter2 .  (Contributed by Rodolfo Medina, 17-Oct-2010.) $)
  prtlem90 $p |- ( -. A e. B -> ( C e. B -> C =/= A ) ) $=
    ( wcel wn wne wceq wa wb wo olc ancom orbi2i sylib xor sylibr eleq1 nsyl ex
    df-ne syl6ibr necom syl6ib ) ABDZEZCBDZACFZCAFUEUFACGZEZUGUEUFUIUEUFHZUDUFI
    ZUHUJUDUFEHZUFUEHZJZUKEUJULUJJUNUJULKUJUMULUEUFLMNUDUFOPACBQRSACTUAACUBUC
    $.

  $( Lemma for ~ prter2 .  (Contributed by Rodolfo Medina, 17-Oct-2010.) $)
  prtlem80 $p |- ( A e. B -> -. A e. ( C \ { A } ) ) $=
    ( wcel neldifsnd ) ABDACE $.

  ${
    $d x A $.  $d x u $.
    $( Negated membership of the empty set in another class.  (Contributed by
       Rodolfo Medina, 25-Sep-2010.) $)
    n0el $p |- ( -. (/) e. A <-> A. x e. A E. u u e. x ) $=
      ( cv wcel wn wal wral wi c0 df-ral df-ex ralbii wa alnex imnan albii wrex
      wex 3bitr4ri 0el df-rex bitri notbii ) BDADZEZFBGZFZACHUECEZUHIZAGZUFBSZA
      CHJCEZFZUHACKULUHACUFBLMUIUGNZFZAGUOASZFUKUNUOAOUJUPAUIUGPQUMUQUMUGACRUQA
      BCUAUGACUBUCUDTT $.
  $}

  ${
    $d x A $.
    ceqsex3.1OLD $e |- ( ps -> A. x ps ) $.
    ceqsex3.2OLD $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Version of ~ ceqsex with an antecedent instead of a hypothesis.  (Use
       ~ ceqsexg instead of this one. --NM 13-Aug-11) (Contributed by Rodolfo
       Medina, 19-Oct-2010.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ceqsex3OLD $p |- ( A e. _V -> ( E. x ( x = A /\ ph ) <-> ps ) ) $=
      ( cvv wcel cv wceq wa wex biimpa exlimih isset wi biimprcd alrimih exintr
      wal syl syl5bi com12 impbid2 ) DGHZCIDJZAKZCLZBUGBCEUFABFMNBUEUHUEUFCLZBU
      HCDOBUFAPZCTUIUHPBUJCEUFABFQRUFACSUAUBUCUD $.
  $}

  ${
    $d x A $.  $d x ps $.
    ceqsex3v.1OLD $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Version of ~ ceqsexv with an antecedent instead of a hypothesis.  (Use
       ~ ceqsexgv instead of this one. --NM 13-Aug-11) (Contributed by Rodolfo
       Medina, 19-Oct-2010.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ceqsex3vOLD $p |- ( A e. _V -> ( E. x ( x = A /\ ph ) <-> ps ) ) $=
      ( cvv ceqsexgv ) ABCDFEG $.
  $}

  ${
    $d x y z $.  $d x y w $.
    $( Closed form of ~ brabsbOLD .  (Contributed by Rodolfo Medina,
       13-Oct-2010.) $)
    brabsb2 $p |- ( R = { <. x , y >. | ph }
                        -> ( z R w <-> [ w / y ] [ z / x ] ph ) ) $=
      ( copab wceq cv wbr cop wcel wsb breq df-br syl6bb opelopabsbOLD ) FABCGZ
      HZDIZEIZFJZTUAKRLZABDMCEMSUBTUARJUCTUAFRNTUAROPABCDEQP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d ph x $.  $d ph y $.
    eqbrrdv2.1 $e |- ( ( ( Rel A /\ Rel B ) /\ ph )
                        -> ( x A y <-> x B y ) ) $.
    $( Other version of ~ eqbrrdiv .  (Contributed by Rodolfo Medina,
       30-Sep-2010.) $)
    eqbrrdv2 $p |- ( ( ( Rel A /\ Rel B ) /\ ph ) -> A = B ) $=
      ( wrel wa wceq cv wbr cop wcel df-br 3bitr3g eqrelrdv2 anabss5 ) DGEGHZAD
      EIRAHZBCDESBJZCJZDKTUAEKTUALZDMUBEMFTUADNTUAENOPQ $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Lemma for ~ prter3 .  (Contributed by Rodolfo Medina, 25-Sep-2010.) $)
    prtlem9 $p |- ( A e. B -> E. x e. B [ x ] .~ = [ A ] .~ ) $=
      ( wcel cv wceq wrex cec risset eceq1 reximi sylbi ) BCEAFZBGZACHNDIBDIGZA
      CHABCJOPACNBDKLM $.
  $}

  ${
    $d v w $.  $d v z $.  $d v A $.  $d v .~ $.
    $( Lemma for ~ prter3 .  (Contributed by Rodolfo Medina, 14-Oct-2010.)
       (Revised by Mario Carneiro, 12-Aug-2015.) $)
    prtlem10 $p |- ( .~ Er A -> ( z e. A -> ( z .~ w <->
        E. v e. A ( z e. [ v ] .~ /\ w e. [ v ] .~ ) ) ) ) $=
      ( wer cv wcel wbr cec wa wrex wb wi simpr simpl breq1 ex vex elec anbi12d
      erref weq rspcev expr syl2anc simplll simprl simprr ertr3d impbid anbi12i
      rexlimdva rexbii syl6bbr ) DEFZAGZDHZUQBGZEIZUQCGZEJZHZUSVBHZKZCDLZMUPURK
      ZUTVAUQEIZVAUSEIZKZCDLZVFVGUTVKVGURUQUQEIZUTVKNUPUROZVGUQEDUPURPVMUBURVLU
      TVKVJVLUTKCUQDCAUCVHVLVIUTVAUQUQEQVAUQUSEQUAUDUEUFVGVJUTCDVGVADHZKZVJUTVO
      VJKUQVAUSEDUPURVNVJUGVOVHVIUHVOVHVIUIUJRUMUKVEVJCDVCVHVDVIUQVAEASCSZTUSVA
      EBSVPTULUNUOR $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x .~ $.
    $( Lemma for ~ prter2 .  (Contributed by Rodolfo Medina, 12-Oct-2010.) $)
    prtlem11 $p |- ( B e. D ->
                        ( C e. A -> ( B = [ C ] .~ -> B e. ( A /. .~ ) ) ) ) $=
      ( vx wcel cec wceq cqs wa cv wrex risset r19.41v eceq1 eqtr3 eqcomd sylan
      reximi sylbir sylanb elqsg syl5ibr exp3a ) BDGZCAGZBCEHZIZBAEJGZUGUIKUJUF
      BFLZEHZIZFAMZUGUKCIZFAMZUIUNFCANUPUIKUOUIKZFAMUNUOUIFAOUQUMFAUOULUHIZUIUM
      UKCEPURUIKULBULBUHQRSTUAUBFABEDUCUDUE $.
  $}

  ${
    $d x y $.
    $( Lemma for ~ prtex and ~ prter3 .  (Contributed by Rodolfo Medina,
       13-Oct-2010.) $)
    prtlem12 $p |- ( .~ = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) }
                        -> Rel .~ ) $=
      ( wel wa wrex copab wceq wrel relopab releq mpbiri ) EACFBCFGCDHZABIZJEKP
      KOABLEPMN $.
  $}

  ${
    $d u v x y A $.  $d v w x y $.  $d v x y z $.
    prtlem13.1 $e |- .~ = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } $.
    $( Lemma for ~ prter1 , ~ prter2 , ~ prter3 and ~ prtex .  (Contributed by
       Rodolfo Medina, 13-Oct-2010.)  (Revised by Mario Carneiro,
       12-Aug-2015.) $)
    prtlem13 $p |- ( z .~ w <-> E. v e. A ( z e. v /\ w e. v ) ) $=
      ( wel wa wrex cv vex weq elequ2 anbi12d cbvrexv eleq1 bi2anan9 rexbidv
      syl5bb braba ) AFJZBFJZKZFGLZCEJZDEJZKZEGLZABCMZDMZHCNDNUGAEJZBEJZKZEGLAC
      OZBDOZKZUKUFUPFEGFEOUDUNUEUOFEAPFEBPQRUSUPUJEGUQUNUHURUOUIAMULEMZSBMUMUTS
      TUAUBIUC $.

    $d u v w x y z A $.  $d w z .~ $.
    $( Lemma for ~ prtex , ~ prter2 and ~ prter3 .  (Contributed by Rodolfo
       Medina, 14-Oct-2010.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    prtlem16 $p |- dom .~ = U. A $=
      ( vz vw vv cdm cuni cv wcel wbr wex wa wrex vex eldm prtlem13 adantrr weq
      exbii elunii ancoms rexlimiva exlimiv eluni2 eleq1 anbi2d syl6bbr rexbidv
      pm4.24 spcev sylbi impbii 3bitri eqriv ) GEJZDKZGLZUSMVAHLZENZHOVAILZMZVB
      VDMZPZIDQZHOZVAUTMZHVAEGRZSVCVHHABGHICDEFTUCVIVJVHVJHVGVJIDVDDMZVEVJVFVEV
      LVJVAVDDUDUEUAUFUGVJVEIDQZVIIVADUHVHVMHVAVKHGUBZVGVEIDVNVGVEVEPVEVNVFVEVE
      VBVAVDUIUJVEUMUKULUNUOUPUQUR $.

    $( Lemma for ~ prter2 and also a property of partitions .  (Contributed by
       Rodolfo Medina, 15-Oct-2010.)  (Revised by Mario Carneiro,
       12-Aug-2015.) $)
    prtlem400 $p |- -. (/) e. ( U. A /. .~ ) $=
      ( c0 cuni cqs wcel wne neirr cdm wceq prtlem16 elqsn0 mpan mto ) GDHZEIJZ
      GGKZGLEMSNTUAABCDEFOSGEPQR $.
  $}

  $( Introduce the partition predicate. $)
  $c Prt $.

  $( Extend the definition of a wff to include the partition predicate. $)
  wprt $a wff Prt A $.

  ${
    $d x y A $.
    $( Define the partition predicate.  (Contributed by Rodolfo Medina,
       13-Oct-2010.) $)
    df-prt $a |- ( Prt A <-> A. x e. A A. y e. A ( x = y \/
                                                ( x i^i y ) = (/) ) ) $.
  $}

  ${
    $d x y A $.  $d x y .~ $.  $d x y X $.
    $( The quotient set of an equivalence relation is a partition.
       (Contributed by Rodolfo Medina, 13-Oct-2010.) $)
    erprt $p |- ( .~ Er X -> Prt ( A /. .~ ) ) $=
      ( vx vy wer cv wceq cin c0 wo cqs wral wprt wa simpl simprl simprr qsdisj
      wcel ralrimivva df-prt sylibr ) CBFZDGZEGZHUEUFIJHKZEABLZMDUHMUHNUDUGDEUH
      UHUDUEUHTZUFUHTZOZOAUEUFBCUDUKPUDUIUJQUDUIUJRSUADEUHUBUC $.
  $}

  ${
    $d u v w x y z $.  $d x y z A $.
    $( Lemma for ~ prter1 , ~ prter2 and ~ prtex .  (Contributed by Rodolfo
       Medina, 13-Oct-2010.) $)
    prtlem14 $p |- ( Prt A -> ( ( x e. A /\ y e. A )
                                -> ( ( w e. x /\ w e. y ) -> x = y ) ) ) $=
      ( wprt cv wcel wa wceq cin c0 wo wi wral df-prt rsp2 sylbi elin wn wal sp
      eq0 pm2.21d syl5bir prtlem1 syl6 ) DEZAFZDGBFZDGHZUHUIIZUHUIJZKIZLZCFZUHG
      UOUIGHZUKMUGUNBDNADNUJUNMABDOUNABDDPQUKUMUPUPUOULGZUMUKUOUHUIRUMUQUKUMUQS
      ZCTURCULUBURCUAQUCUDUEUF $.

    $( Lemma for ~ prter1 and ~ prtex .  (Contributed by Rodolfo Medina,
       13-Oct-2010.) $)
    prtlem15 $p |- ( Prt A -> ( E. x e. A E. y e. A ( ( u e. x /\ w e. x )
                        /\ ( w e. y /\ v e. y ) )
                        -> E. z e. A ( u e. z /\ v e. z ) ) ) $=
      ( wprt wel wa wrex cv wcel wi anabs7 an43 anbi2i 3bitr4ri weq elequ2 syl8
      prtlem14 an3 anbi2d syl5ibr imp4a syl7bi expdimp rexlimdv anbi12d cbvrexv
      reximdva syl6ib ) GHZFAIZDAIZJDBIZEBIZJJZBGKZAGKUOEAIZJZAGKFCIZECIZJZCGKU
      NUTVBAGUNALGMZJUSVBBGUNVFBLGMZUSVBNZUSUPUQJZUSJZUNVFVGJZVBVIUOURJZVIJZJVM
      VJUSVLVIOUSVMVIUOUPUQURPZQVNRUNVKVIUSVBUNVKVIABSZVHABDGUBUSVBVOVLUOUPUQUR
      UCVOVAURUOABETUDUEUAUFUGUHUIULVBVEACGACSUOVCVAVDACFTACETUJUKUM $.
  $}

  ${
    $d x y A $.  $d z x $.  $d z y $.  $d y w $.
    $( Lemma for ~ prter2 .  (Contributed by Rodolfo Medina, 15-Oct-2010.) $)
    prtlem17 $p |- ( Prt A -> ( ( x e. A /\ z e. x )
                                        -> ( E. y e. A ( z e. y /\ w e. y )
                                                -> w e. x ) ) ) $=
      ( wprt cv wcel wel wa wrex wi wex df-rex an32 weq prtlem14 elequ2 biimprd
      syl8 exp4a imp3a syl5bir exp3a imp5a imp4b exlimdv syl5bi ex ) EFZAGEHZCA
      IZJZCBIZDBIZJZBEKZDAIZLUQBGEHZUPJZBMUJUMJZURUPBENVAUTURBUJUMUSUPURUJUMUSU
      NUOURUJUMUSUNUOURLZLZUMUSJUKUSJZULJUJVCUKUSULOUJVDULVCUJVDULUNVBUJVDULUNJ
      ABPZVBABCEQVEURUOABDRSTUAUBUCUDUEUFUGUHUI $.
  $}

  ${
    $d p q r u v w x y z A $.  $d p v w z .~ $.  $d v w z S $.
    prtlem18.1 $e |- .~ = { <. x , y >. | E. u e. A ( x e. u /\ y e. u ) } $.
    $( Lemma for ~ prter2 .  (Contributed by Rodolfo Medina, 15-Oct-2010.)
       (Revised by Mario Carneiro, 12-Aug-2015.) $)
    prtlem18 $p |- ( Prt A ->
      ( ( v e. A /\ z e. v ) -> ( w e. v <-> z .~ w ) ) ) $=
      ( vp wprt cv wcel wel wa wbr wi wrex rspe prtlem13 syl6ibr syl7bi impbidd
      expr a1i prtlem17 ) GKZELGMZCENZOZDENZCLDLHPZUJUKULQQUGUJUKUIUKOZEGRZULUH
      UIUKUNUMEGSUDABCDEFGHITUAUEULCJNDJNOJGRUGUJUKABCDJFGHITEJCDGUFUBUC $.

    $( Lemma for ~ prter2 .  (Contributed by Rodolfo Medina, 15-Oct-2010.)
       (Revised by Mario Carneiro, 12-Aug-2015.) $)
    prtlem19 $p |- ( Prt A -> ( ( v e. A /\ z e. v ) -> v = [ z ] .~ ) ) $=
      ( vw wprt cv wcel wa cec wceq wbr wb prtlem18 imp vex elec syl6bbr eqrdv
      ex ) FJZDKZFLCKZUFLMZUFUGGNZOUEUHMZIUFUIUJIKZUFLZUGUKGPZUKUILUEUHULUMQABC
      IDEFGHRSUKUGGITCTUAUBUCUD $.

    $( Every partition generates an equivalence relation.  (Contributed by
       Rodolfo Medina, 13-Oct-2010.)  (Revised by Mario Carneiro,
       12-Aug-2015.) $)
    prter1 $p |- ( Prt A -> .~ Er U. A ) $=
      ( vz vw vp vv vq vr cv wbr wi wa wal wel wrex prtlem13 wprt wrel cdm cuni
      wceq wer relopabi prtlem16 prtlem15 anbi12i reeanv bitr4i 3imtr4g 3imtr4i
      a1i pm3.22 reximi jctil alrimivv alrimiv dfer2 syl3anbrc ) DUAZEUBZEUCDUD
      ZUEZGMZHMZENZVHVGENZOZVIVHIMZENZPZVGVLENZOZPZIQHQZGQVEEUFVDVCACRBCRPCDSAB
      EFUGUOVFVCABCDEFUHUOVCVRGVCVQHIVCVPVKVCGJRZHJRZPZHKRIKRPZPKDSJDSZGLRILRPL
      DSVNVOJKLHIGDUIVNWAJDSZWBKDSZPWCVIWDVMWEABGHJCDEFTZABHIKCDEFTUJWAWBJKDDUK
      ULABGILCDEFTUMWDVTVSPZJDSVIVJWAWGJDVSVTUPUQWFABHGJCDEFTUNURUSUTGHIVEEVAVB
      $.

    $( The equivalence relation generated by a partition is a set if and only
       if the partition itself is a set.  (Contributed by Rodolfo Medina,
       15-Oct-2010.)  (Revised by Mario Carneiro, 12-Aug-2015.) $)
    prtex $p |- ( Prt A -> ( .~ e. _V <-> A e. _V ) ) $=
      ( wprt cvv wcel cuni wer wb prter1 erexb syl uniexb syl6bbr ) DGZEHIZDJZH
      IZDHIRTEKSUALABCDEFMTENODPQ $.

    $( The quotient set of the equivalence relation generated by a partition
       equals the partition itself.  (Contributed by Rodolfo Medina,
       17-Oct-2010.) $)
    prter2 $p |- ( Prt A -> ( U. A /. .~ ) = ( A \ { (/) } ) ) $=
      ( vp vv vz c0 cv wcel wa wceq wrex wex bitri df-rex wral wi wprt cuni cqs
      csn cdif wne cec rexcom4 r19.41v exbii rexbii elqs eluni2 anbi1i 3bitr4ri
      vex prtlem19 ralrimivv 2r19.29 ex syl5bi eqtr3 reximi syl6 19.41v simprbi
      risset syl6ibr wn prtlem400 prtlem90 mp1i jcad eldifsn neldifsn n0el mpbi
      syl rspec eldifi jca ancomsd elunii jca2r cvv prtlem11 ax-mp eximdv 19.9v
      imp 3imtr3g syl5 impbid eqrdv ) DUAZGDUBZEUCZDJUDZUEZWOGKZWQLZWTWSLZWOXAW
      TDLZWTJUFZMXBWOXAXCXDWOXAHKZWTNZHDOZXCWOXAXFIXEOZHDOZXGWOXAXEIKZEUGZNZWTX
      KNZMZIXEOZHDOZXIXAXMIXEOZHDOZWOXPXJXELZXMMZIPZHDOZXSHDOZXMMZIPZXRXAYBXTHD
      OZIPYEXTHIDUHYFYDIXSXMHDUIUJQXQYAHDXMIXERUKXAXMIWPOZYEIWPWTEGUPZULYGXJWPL
      ZXMMZIPYEXMIWPRYJYDIYIYCXMHXJDUMUNUJQQUOWOXLIXESHDSZXRXPTWOXLHIDXEABIHCDE
      FUQURYKXRXPXLXMHIDXEUSUTVRVAXOXHHDXNXFIXEXEWTXKVBVCVCVDXHXFHDXHXSIPZXFXHX
      SXFMIPYLXFMXFIXERXSXFIVEQVFVCVDHWTDVGVHJWQLVIXAXDTWOABCDEFVJJWQWTVKVLVMWT
      DJVNVHXBXJWTLZIPZXCMZWOXAXBYNXCYNGWSJWSLVIYNGWSSJDVOGIWSVPVQVSWTDWRVTWAWO
      YMXCMZIPXAIPYOXAWOYPXAIWOYPYJXAWOYPXMYIWOXCYMXMABIGCDEFUQWBXJWTDWCWDYIXMX
      AWTWELYIXMXATTYHWPWTXJWEEWFWGWJVDWHYMXCIVEXAIWIWKWLWMWN $.

    $( For every partition there exists a unique equivalence relation whose
       quotient set equals the partition.  (Contributed by Rodolfo Medina,
       19-Oct-2010.)  (Proof shortened by Mario Carneiro, 12-Aug-2015.) $)
    prter3 $p |- ( ( S Er U. A /\ ( U. A /. S ) = ( A \ { (/) } ) ) ->
        .~ = S ) $=
      ( vz vw vv wrel c0 wceq wa wel wrex cv wbr wb wcel cuni wer cqs csn errel
      cdif adantr relopabi prtlem13 cec simpll wne simprl ne0i ad2antll eldifsn
      sylanbrc simplr eleqtrrd simprr qsel syl3anc eleq2d elec anassrs pm5.32da
      vex syl6bb rexbidva simpr eluni2 sylib ex pm4.71rd r19.41v syl6bbr bitr4d
      ercl syl5bb adantl eqbrrdv2 mpanl1 mpancom ) FKZDUAZFUBZWEFUCZDLUDUFZMZNZ
      EFMZWFWDWIWEFUEUGEKZWDWJWKACOBCONCDPABEGUHWJHIEFWJHQZIQZERZWMWNFRZSWLWDNW
      OHJOZIJOZNZJDPZWJWPABHIJCDEGUIWJWTWQWPNZJDPZWPWJWSXAJDWJJQZDTZNWQWRWPWJXD
      WQWRWPSWJXDWQNZNZWRWNWMFUJZTWPXFXCXGWNXFWFXCWGTWQXCXGMWFWIXEUKXFXCWHWGXFX
      DXCLULZXCWHTWJXDWQUMWQXHWJXDXCWMUNUOXCDLUPUQWFWIXEURUSWJXDWQUTWEXCWMFWEVA
      VBVCWNWMFIVGHVGVDVHVEVFVIWJWPWQJDPZWPNXBWJWPXIWJWPXIWJWPNZWMWETXIXJWMWNFW
      EWFWIWPUKWJWPVJVRJWMDVKVLVMVNWQWPJDVOVPVQVSVTWAWBWC $.
  $}

$( (End of Rodolfo Medina's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Stefan O'Rear
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Additional elementary logic and set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Demonstrate by witnesses that two classes lack a subclass relation.
     (Contributed by Stefan O'Rear, 5-Feb-2015.) $)
  nelss $p |- ( ( A e. B /\ -. A e. C ) -> -. B C_ C ) $=
    ( wcel wss ssel com12 con3and ) ABDZBCEZACDZJIKBCAFGH $.

  ${
    $d ps x $.  $d ph y $.  $d x A $.  $d x y $.
    moxfr.a $e |- A e. _V $.
    moxfr.b $e |- E! y x = A $.
    moxfr.c $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Transfer at-most-one between related expressions.  (Contributed by
       Stefan O'Rear, 12-Feb-2015.) $)
    moxfr $p |- ( E* x ph <-> E* y ps ) $=
      ( wex weu wi wmo cvv wrex wcel cv a1i wceq rexv df-mo ax-mp mpbir 3bitr3i
      euex rexxfr euxfr imbi12i 3bitr4i ) ACIZACJZKBDIZBDJZKACLBDLUIUKUJULACMNB
      DMNUIUKABCDEMMEMODPMOFQCPZERZDMNZUMMOUOUNDIZUNDJUPGUNDUDUAUNDSUBQHUEACSBD
      SUCABCDEFGHUFUGACTBDTUH $.
  $}

  $( Rearrangement of a property of a singleton difference.  (Contributed by
     Stefan O'Rear, 27-Feb-2015.) $)
  raldifsni $p |- ( A. x e. ( A \ { B } ) -. ph <->
      A. x e. A ( ph -> x = B ) ) $=
    ( wn cv wceq wi csn cdif wcel wne eldifsn imbi1i impexp df-ne con34b bitr4i
    wa imbi2i 3bitri ralbii2 ) AEZABFZDGZHZBCDIJZCUDUGKZUCHUDCKZUDDLZSZUCHUIUJU
    CHZHUIUFHUHUKUCUDCDMNUIUJUCOULUFUIULUEEZUCHUFUJUMUCUDDPNAUEQRTUAUB $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Additional theory of functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F x y $.  $d A x y $.  $d X x y $.
    $( Express the class of fixed points of a function.  (Contributed by Stefan
       O'Rear, 1-Feb-2015.) $)
    fninfp $p |- ( F Fn A -> dom ( F i^i _I ) = { x e. A | ( F ` x ) = x } ) $=
      ( wfn cid cin cdm cres cv cfv wceq crab inres incom reseq1i eqtri 3eqtr4i
      fnresdm ineq1d syl5reqr dmeqd fnresi fndmin mpan2 wcel fvresi rabbiia a1i
      eqeq2d 3eqtrd ) CBDZCEFZGCEBHZFZGZAIZCJZUPUMJZKZABLZUQUPKZABLZUKULUNUKUNC
      BHZEFZULEVCFZULBHZVDUNVEECFZBHVFECBMVGULBECNOPVCENCEBMQUKVCCEBCRSTUAUKUMB
      DUOUTKBUBABCUMUCUDUTVBKUKUSVAABUPBUEURUPUQBUPUFUIUGUHUJ $.

    $( Property of a fixed point of a function.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    fnelfp $p |- ( ( F Fn A /\ X e. A ) -> ( X e. dom ( F i^i _I ) <->
          ( F ` X ) = X ) ) $=
      ( vx wfn cid cin cdm wcel cv cfv wceq crab fninfp eleq2d fveq2 id eqeq12d
      elrab3 sylan9bb ) BAEZCBFGHZICDJZBKZUCLZDAMZICAICBKZCLZUAUBUFCDABNOUEUHDC
      AUCCLZUDUGUCCUCCBPUIQRST $.

    $( Express the class of non-fixed points of a function.  (Contributed by
       Stefan O'Rear, 14-Aug-2015.) $)
    fndifnfp $p |- ( F Fn A -> dom ( F \ _I ) =
          { x e. A | ( F ` x ) =/= x } ) $=
      ( wfn cid cdif cdm cres cv cfv wne crab cvv cxp cun c0 wss wceq wf dffn2
      fssxp sylbi ssdif0 sylib uneq2d un0 syl6req difeq2i difindi eqtri syl6eqr
      cin df-res dmeqd fnresi fndmdif mpan2 wcel fvresi neeq2d rabbiia 3eqtrd
      a1i ) CBDZCEFZGCEBHZFZGZAIZCJZVIVFJZKZABLZVJVIKZABLZVDVEVGVDVEVECBMNZFZOZ
      VGVDVRVEPOVEVDVQPVEVDCVPQZVQPRVDBMCSVSBCTBMCUAUBCVPUCUDUEVEUFUGVGCEVPULZF
      VRVFVTCEBUMUHCEVPUIUJUKUNVDVFBDVHVMRBUOABCVFUPUQVMVORVDVLVNABVIBURVKVIVJB
      VIUSUTVAVCVB $.

    $( Property of a non-fixed point of a function.  (Contributed by Stefan
       O'Rear, 15-Aug-2015.) $)
    fnelnfp $p |- ( ( F Fn A /\ X e. A ) -> ( X e. dom ( F \ _I ) <->
          ( F ` X ) =/= X ) ) $=
      ( vx wfn cid cdif cdm wcel cv cfv crab fndifnfp eleq2d wceq fveq2 neeq12d
      wne id elrab3 sylan9bb ) BAEZCBFGHZICDJZBKZUDRZDALZICAICBKZCRZUBUCUGCDABM
      NUFUIDCAUDCOZUEUHUDCUDCBPUJSQTUA $.

    $( A function is the identity iff it moves no points.  (Contributed by
       Stefan O'Rear, 25-Aug-2015.) $)
    fnnfpeq0 $p |- ( F Fn A -> ( dom ( F \ _I ) = (/) <->
          F = ( _I |` A ) ) ) $=
      ( vx wfn cv cfv wne crab c0 wceq cid cres wral cdif cdm wn rabeq0 wcel wa
      wb fvresi eqeq2d adantl nne syl6rbbr ralbidva syl5bb eqeq1d fnresi eqfnfv
      fndifnfp mpan2 3bitr4d ) BADZCEZBFZUOGZCAHZIJZUPUOKALZFZJZCAMZBKNOZIJBUTJ
      ZUSUQPZCAMUNVCUQCAQUNVFVBCAUNUOARZSVBUPUOJZVFVGVBVHTUNVGVAUOUPAUOUAUBUCUP
      UOUDUEUFUGUNVDURICABUKUHUNUTADVEVCTAUICABUTUJULUM $.
  $}

  ${
    $d B x $.  $d F x $.
    $( Indexed intersection of an image.  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    imaiinfv $p |- ( ( F Fn A /\ B C_ A ) ->
        |^|_ x e. B ( F ` x ) = |^| ( F " B ) ) $=
      ( wfn wss wa cres cfv ciin crn cint cima wceq fnssres fniinfv syl iineq2i
      cv fvres eqcomi df-ima inteqi 3eqtr4g ) DBECBFGZACASZDCHZIZJZUGKZLZACUFDI
      ZJZDCMZLUEUGCEUIUKNBCDOACUGPQUIUMACUHULUFCDTRUAUNUJDCUBUCUD $.
  $}

  ${
    $d ph x z $.  $d ph x y $.  $d ps y $.  $d ps z $.  $d A x $.  $d C x $.
    $d D x $.  $d ch x $.
    ralxpxfr2d.a $e |- A e. _V $.
    ralxpxfr2d.b $e |- ( ph -> ( x e. B <-> E. y e. C E. z e. D x = A ) ) $.
    ralxpxfr2d.c $e |- ( ( ph /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer a universal quantifier between one variable with pair-like
       semantics and two.  (Contributed by Stefan O'Rear, 27-Feb-2015.) $)
    ralxpxfr2d $p |- ( ph -> ( A. x e. B ps <-> A. y e. C A. z e. D ch ) ) $=
      ( wral wi wal wrex albidv ralcom4 ralbii wceq df-ral imbi1d syl5bb bitr2i
      wcel r19.23v albii 3bitr4ri syl6bb pm5.74da biidd ceqsalv 2ralbidv bitrd
      cv ) ABDHNZDUPZGUAZBOZDPZFJNZEINZCFJNEINAUQUSFJQZEIQZBOZDPZVCUQURHUFZBOZD
      PAVGBDHUBAVIVFDAVHVEBLUCRUDUTFJNZDPZEINVJEINZDPVCVGVJEDISVBVKEIUTFDJSTVFV
      LDVLVDBOZEINVFVJVMEIUSBFJUGTVDBEIUGUEUHUIUJAVACEFIJAVAUSCOZDPCAUTVNDAUSBC
      MUKRCCDGKUSCULUMUJUNUO $.
  $}

  ${
    $d ph g y $.  $d ps f $.  $d J f g y $.  $d S f g y $.  $d T f g y $.
    $d V f g y $.
    ralxpmap.j $e |- ( f = ( g u. { <. J , y >. } ) -> ( ph <-> ps ) ) $.
    $( Quantification over functions in terms of quantification over values and
       punctured functions.  (Contributed by Stefan O'Rear, 27-Feb-2015.)
       (Revised by Stefan O'Rear, 5-May-2015.) $)
    ralxpmap $p |- ( J e. T -> ( A. f e. ( S ^m T ) ph <->
          A. y e. S A. g e. ( S ^m ( T \ { J } ) ) ps ) ) $=
      ( wcel csn cun wceq wa wf cvv wb syl wss syl2anc cv cop cmap co cdif snex
      vex unex wrex cres simpr elmapex adantl elmapg mpbid simpl ffvelrnd difss
      cfv fssres sylancl simpld simprd difexg mpbird wfn fnsnsplit opeq2 uneq2d
      ffn sneqd eqeq2d uneq1 rspc2ev syl3anc ex cin elmapi ad2antll wf1o f1osng
      c0 f1of mpan2 adantr incom disjdif eqtri syl21anc uncom snssd undif sylib
      a1i fun syl5eq feq2d ssid snssi ad2antrl unssd fss ssun1 undif1 syl5eqelr
      unexg ssexg sylancr eleq1 syl5ibrcom rexlimdvva impbid ralxpxfr2d ) HEJZA
      BFCGGUAZHCUAZUBZKZLZDEUCUDZDDEHKZUEZUCUDZXOXRGUGXQUFUHXNFUAZXTJZYDXSMZGYC
      UICDUIZXNYEYGXNYENZHYDUSZDJYDYBUJZYCJZYDYJHYIUBZKZLZMZYGYHEDHYDYHYEEDYDOZ
      XNYEUKYHDPJZEPJZNZYEYPQYEYSXNYDDEULZUMZDEYDPPUNRUOZXNYEUPZUQYHYKYBDYJOZYH
      YPYBESUUDUUBEYAUREDYBYDUTVAYHYQYBPJZYKUUDQYEYQXNYEYQYRYTVBUMYHYRUUEYHYQYR
      UUAVCEYAPVDRDYBYJPPUNTVEYHYDEVFZXNYOYHYPUUFUUBEDYDVJRUUCEYDHVGTYFYOYDXOYM
      LZMCGYIYJDYCXPYIMZXSUUGYDUUHXRYMXOUUHXQYLXPYIHVHVKVIVLXOYJMUUGYNYDXOYJYMV
      MVLVNVOVPXNYFYECGDYCXNXPDJZXOYCJZNZNZYEYFXSXTJZUULUUMEDXSOZUULEDXPKZLZXSO
      ZUUPDSUUNUULYBYALZUUPXSOZUUQUULYBDXOOZYAUUOXROZYBYAVQZWBMZUUSUUJUUTXNUUIX
      ODYBVRVSXNUVAUUKXNXPPJZUVACUGXNUVDNYAUUOXRVTUVAHXPEPWAYAUUOXRWCRWDWEUVCUU
      LUVBYAYBVQWBYBYAWFYAEWGWHWNYBYADUUOXOXRWOWIUULUUREUUPXSUULUURYAYBLZEYBYAW
      JUULYAESUVEEMUULHEXNUUKUPWKYAEWLWMWPWQUOUULDUUODDDSUULDWRWNUUIUUODSXNUUJX
      PDWSWTXAEUUPDXSXBTUULYQYRUUMUUNQUULYQUUEUUJYQUUENXNUUIXODYBULVSZVBUULEEYA
      LZSUVGPJYREYAXCUULUVGUURPEYAXDUULUUEYAPJUURPJUULYQUUEUVFVCHUFYBYAPPXFVAXE
      EUVGPXGXHDEXSPPUNTVEYDXSXTXIXJXKXLYFABQXNIUMXM $.
  $}

  $( Finite support for a function extended by a singleton.  (Contributed by
     Stefan O'Rear, 27-Feb-2015.) $)
  funsnfsup $p |- ( ( `' ( F u. { <. X , Y >. } ) " Z ) e. Fin <->
      ( `' F " Z ) e. Fin ) $=
    ( cop csn cun ccnv cima cfn wcel cnvun imaeq1i imaundir eleq1i crn wss ssfi
    eqtri mp2an cdm dfdm4 snfi dmsnopss eqeltrri imassrn wa unfir unfi mpbiran2
    impbii bitri ) ABCEFZGHZDIZJKAHZDIZUMHZDIZGZJKZUQJKZUOUTJUOUPURGZDIUTUNVCDA
    UMLMUPURDNSOVAVBUSJKZURPZJKUSVEQVDUMUAZVEJUMUBBFZJKVFVGQVFJKBUCBCUDVGVFRTUE
    URDUFVEUSRTVAVBVDUGUQUSUHUQUSUIUKUJUL $.

  ${
    $d B x $.  $d V x $.  $d X x $.
    fvtresfn.f $e |- F = ( x e. B |-> ( x |` V ) ) $.
    $( Functionality of a tuple-restriction function.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    fvtresfn $p |- ( X e. B -> ( F ` X ) = ( X |` V ) ) $=
      ( wcel cres cvv cfv wceq resexg cv reseq1 fvmptg mpdan ) EBGEDHZIGECJQKED
      BLAEAMZDHQBICREDNFOP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Extensions beyond function theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A k x y z $.  $d B k x y z $.  $d ph k x y z $.  $d .x. k x y z $.
    $d Y x y z $.  $d P k x y z $.  $d S k x y z $.  $d K k x y z $.
    $d X k x y z $.  $d .0. k x z y $.  $d R y $.
    gsumvsmul.b $e |- B = ( Base ` R ) $.
    gsumvsmul.s $e |- S = ( Scalar ` R ) $.
    gsumvsmul.k $e |- K = ( Base ` S ) $.
    gsumvsmul.z $e |- .0. = ( 0g ` R ) $.
    gsumvsmul.p $e |- .+ = ( +g ` R ) $.
    gsumvsmul.t $e |- .x. = ( .s ` R ) $.
    gsumvsmul.r $e |- ( ph -> R e. LMod ) $.
    gsumvsmul.a $e |- ( ph -> A e. V ) $.
    gsumvsmul.x $e |- ( ph -> X e. K ) $.
    gsumvsmul.y $e |- ( ( ph /\ k e. A ) -> Y e. B ) $.
    gsumvsmul.n $e |- ( ph -> ( `' ( k e. A |-> Y ) "
            ( _V \ { .0. } ) ) e. Fin ) $.
    $( Pull a scalar multiplication out of a sum of vectors. _EDITORIAL_:
       properly generalizes ~ gsummulc2 , since every ring is a left module
       over itself.  (Contributed by Stefan O'Rear, 6-Feb-2015.)  (Revised by
       Mario Carneiro, 5-May-2015.) $)
    gsumvsmul $p |- ( ph -> ( R gsum ( k e. A |-> ( X .x. Y ) ) ) =
          ( X .x. ( R gsum ( k e. A |-> Y ) ) ) ) $=
      ( vy cv co cmpt cgsu clmod wcel ccmn lmodcmn syl cmnd cghm cmhm lmodvsghm
      cmnmnd syl2anc ghmmhm oveq2 gsummhm2 ) AUEBCKUEUFZGUGZKLGUGHKEHBLUHUIUGZG
      UGEEJLMNQAEUJUKZEULUKZTEUMUNZAVHEUOUKVIEUSUNUAAUECVEUHZEEUPUGUKZVJEEUQUGU
      KAVGKIUKVKTUBUEKGFICENOSPURUTEEVJVAUNUCUDVDLKGVBVDVFKGVBVC $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y K $.  $d x y ph $.  $d x y .x. $.
    $d y H $.
    lcomf.f $e |- F = ( Scalar ` W ) $.
    lcomf.k $e |- K = ( Base ` F ) $.
    lcomf.s $e |- .x. = ( .s ` W ) $.
    lcomf.b $e |- B = ( Base ` W ) $.
    lcomf.w $e |- ( ph -> W e. LMod ) $.
    lcomf.g $e |- ( ph -> G : I --> K ) $.
    lcomf.h $e |- ( ph -> H : I --> B ) $.
    lcomf.i $e |- ( ph -> I e. V ) $.
    $( A linear-combination sum is a function.  (Contributed by Stefan O'Rear,
       28-Feb-2015.) $)
    lcomf $p |- ( ph -> ( G oF .x. H ) : I --> B ) $=
      ( vx wcel vy clmod cv wa co lmodvscl 3expb sylan inidm off ) ASUAGGGCHBBE
      FIIAJUBTZSUCZHTZUAUCZBTZUDULUNCUEBTZOUKUMUOUPULCDHBJUNNKMLUFUGUHPQRRGUIUJ
      $.

    $d H x $.  $d Y x $.  $d .0. x $.
    lcomfsup.z $e |- .0. = ( 0g ` W ) $.
    lcomfsup.y $e |- Y = ( 0g ` F ) $.
    lcomfsup.j $e |- ( ph -> ( `' G " ( _V \ { Y } ) ) e. Fin ) $.
    $( A linear-combination sum is finitely supported if the coefficients are.
       (Contributed by Stefan O'Rear, 28-Feb-2015.) $)
    lcomfsup $p |- ( ph -> ( `' ( G oF .x. H ) " ( _V \ { .0. } ) ) e. Fin ) $=
      ( vx ccnv cvv csn cdif cima cfn wcel cof co wss lcomf cfv wceq eldifi wfn
      cv wa ffn syl adantr simpr fnfvof syl22anc sylan2 ssid a1i suppssr oveq1d
      wf clmod ffvelrnda lmod0vs syl2anc 3eqtrd suppss ssfi ) AEUEUFKUGUHUIZUJU
      KEFCULUMZUEUFLUGUHUIZWAUNWCUJUKUCAGBUDWBWALABCDEFGHIJMNOPQRSTUOAUDUTZGWAU
      HUKZVAZWDWBUPZWDEUPZWDFUPZCUMZKWICUMZLWEAWDGUKZWGWJUQZWDGWAURZAWLVAZEGUSZ
      FGUSZGIUKZWLWMAWPWLAGHEVMWPRGHEVBVCVDAWQWLAGBFVMWQSGBFVBVCVDAWRWLTVDAWLVE
      GCEFIWDVFVGVHWFWHKWICAGHEWAWDKRWAWAUNAWAVIVJVKVLWEAWLWKLUQZWNWOJVNUKZWIBU
      KWSAWTWLQVDAGBWDFSVOCDKBJWILPMOUBUAVPVQVHVRVSWAWCVTVQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Additional topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A v w $.  $d B v w $.  $d C v w $.  $d V v w $.
    $( Elementhood in a set of relative finite intersections.  (Contributed by
       Stefan O'Rear, 22-Feb-2015.) $)
    elrfi $p |- ( ( B e. V /\ C C_ ~P B ) -> ( A e. ( fi ` ( { B } u. C ) ) <->
          E. v e. ( ~P C i^i Fin ) A = ( B i^i |^| v ) ) ) $=
      ( vw wcel cpw wss wa cvv cun cint cin wceq cfn wrex syl2anc sseli sylib
      csn cfi cfv cv wi elex a1i inex1g eleq1 syl5ibrcom rexlimdvw adantr simpr
      wb snex pwexg ad2antrr simplr ssexd unexg sylancr elfi cdif inss1 sseqtri
      uncom pweqi elpwun ad2antrl inss2 diffi syl elin sylanbrc incom simprr c0
      cuni eqeltrrd intex sylibr intssuni elpwi pwidg snssd unssd sstrd sspwuni
      wne eqsstrd df-ss syl5req ineq2 ad2antll eqtrd intun intsng ineq1d undif2
      ad3antrrr inteqi syl5eq inteq ineq2d eqeq2d rspcev rexlimdvaa ssun1 ssun4
      syl6eqr 3syl adantl vex unex elpw snfi unfi eqcomd eqeq1 rexlimdva impbid
      rexbidv bitrd ex pm5.21ndd ) CEGZDCHZIZJZBKGZBCUAZDLZUBUCZGZBCAUDZMZNZOZA
      DHZPNZQZYNYJUEYIBYMUFUGYFUUAYJUEYHYFYRYJAYTYFYJYRYQKGCYPEUHBYQKUIUJUKULYI
      YJYNUUAUNYIYJJZYNBFUDZMZOZFYLHZPNZQZUUAUUBYJYLKGZYNUUHUNYIYJUMUUBYKKGDKGU
      UICUOZUUBDYGKYFYGKGYHYJCEUPUQYFYHYJURUSYKDKKUTVAFBYLKKVBRUUBUUHUUAUUBUUEU
      UAFUUGUUBUUCUUGGZUUEJZJZUUCYKVCZYTGZBCUUNMZNZOZUUAUUMUUNYSGZUUNPGZUUOUUKU
      USUUBUUEUUKUUCDYKLZHZGUUSUUGUVBUUCUUGUUFUVBUUFPVDZYLUVAYKDVFVGVESUUCDYKUU
      JVHTVIUUKUUTUUBUUEUUKUUCPGUUTUUGPUUCUUFPVJSUUCYKVKVLVIUUNYSPVMVNUUMBYKUUN
      LZMZUUQUUMBYKUUCLZMZUVEUUMBCUUDNZUVGUUMBCBNZUVHUUMUVIBCNZBCBVOUUMBCIUVJBO
      UUMBUUDCUUBUUKUUEVPZUUMUUDUUCVRZCUUMUUCVQWIZUUDUVLIUUMUUDKGUVMUUMBUUDKUVK
      YIYJUULURVSUUCVTWAUUCWBVLUUMUUCYGIUVLCIUUMUUCYLYGUUKUUCYLIZUUBUUEUUKUUCUU
      FGUVNUUGUUFUUCUVCSUUCYLWCVLVIYIYLYGIYJUULYIYKDYGYFYKYGIYHYFCYGCEWDWEULYFY
      HUMWFUQWGUUCCWHTWGWJBCWKTWLUUEUVIUVHOUUBUUKBUUDCWMWNWOYFUVHUVGOYHYJUULYFU
      VGYKMZUUDNUVHYKUUCWPYFUVOCUUDCEWQZWRWLWTWOUVDUVFYKUUCWSXAXJYFUVEUUQOYHYJU
      ULYFUVEUVOUUPNUUQYKUUNWPYFUVOCUUPUVPWRXBWTWOYRUURAUUNYTYOUUNOZYQUUQBUVQYP
      UUPCYOUUNXCXDXEXFRXGUUBYRUUHAYTUUBYOYTGZJZUUHYRYQUUDOZFUUGQZUVSYKYOLZUUGG
      ZYQUWBMZOZUWAUVSUWBUUFGZUWBPGZUWCUVSUWBYLIUWFUVSYKYOYLYKYLIUVSYKDXHUGUVRY
      OYLIZUUBUVRYOYSGYODIUWHYTYSYOYSPVDSYODWCYODYKXIXKXLWFUWBYLYKYOUUJAXMXNXOW
      AUVSYKPGYOPGZUWGCXPUVRUWIUUBYTPYOYSPVJSXLYKYOXQVAUWBUUFPVMVNYFUWEYHYJUVRY
      FYQUVOYPNUWDYFCUVOYPYFUVOCUVPXRWRYKYOWPXJWTUVTUWEFUWBUUGUUCUWBOUUDUWDYQUU
      CUWBXCXEXFRYRUUEUVTFUUGBYQUUDXSYBUJXTYAYCYDYE $.
  $}

  ${
    $d A v w $.  $d B v w $.  $d F v w $.  $d F y $.  $d I v w $.  $d V v w $.
    $d v y $.
    $( Elementhood in a set of relative finite intersections of an indexed
       family of sets.  (Contributed by Stefan O'Rear, 22-Feb-2015.) $)
    elrfirn $p |- ( ( B e. V /\ F : I --> ~P B ) ->
        ( A e. ( fi ` ( { B } u. ran F ) ) <->
          E. v e. ( ~P I i^i Fin ) A = ( B i^i |^|_ y e. v ( F ` y ) ) ) ) $=
      ( vw wcel cpw wa cv cin wceq cfn wrex wss cvv sseli adantl wf csn crn cun
      cfi cfv cint cima ciin wb elrfi sylan2 imassrn pwexg ssexg syl2anr elpw2g
      frn syl mpbiri adantr wfun ffun ad2antlr inss2 imafi syl2anc sylanbrc wfn
      elin inss1 elpwid fipreima syl3anc eqcom rexbii sylib inteq ineq2d eqeq2d
      ffn rexxfrd imaiinfv eqcomd rexbidva 3bitrd ) DGIZFDJZEUAZKZCDUBEUCZUDUEU
      FIZCDHLZUGZMZNZHWKJZOMZPZCDEBLZUHZUGZMZNZBFJZOMZPCDAWTALEUFUIZMZNZBXFPWIW
      GWKWHQZWLWSUJFWHEURZHCDWKGUKULWJWPXDHBXAWRXFWJWTXFIZKZXAWQIZXAOIZXAWRIWJX
      NXLWJXNXAWKQZEWTUMWJWKRIZXNXPUJWIXJWHRIXQWGXKDGUNWKWHRUOUPXAWKRUQUSUTVAXM
      EVBZWTOIZXOWIXRWGXLFWHEVCVDXLXSWJXFOWTXEOVESTEWTVFVGXAWQOVJVHWJWMWRIZKZXA
      WMNZBXFPZWMXANZBXFPYAEFVIZWMWKQZWMOIZYCWIYEWGXTFWHEWAZVDXTYFWJXTWMWKWRWQW
      MWQOVKSVLTXTYGWJWROWMWQOVESTWMFEBVMVNYBYDBXFXAWMVOVPVQYDWPXDUJWJYDWOXCCYD
      WNXBDWMXAVRVSVTTWBWJXDXIBXFXMXCXHCXMXBXGDXMXGXBXMYEWTFQZXGXBNWIYEWGXLYHVD
      XLYIWJXLWTFXFXEWTXEOVKSVLTAFWTEWCVGWDVSVTWEWF $.
  $}

  ${
    $d A v $.  $d B v y $.  $d C v z $.  $d C x $.  $d I v y z $.  $d I x $.
    $d V v y $.  $d x y z $.

    $( Elementhood in a set of relative finite intersections of an indexed
       family of sets (implicit).  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    elrfirn2 $p |- ( ( B e. V /\ A. y e. I C C_ B ) ->
        ( A e. ( fi ` ( { B } u. ran ( y e. I |-> C ) ) ) <->
          E. v e. ( ~P I i^i Fin ) A = ( B i^i |^|_ y e. v C ) ) ) $=
      ( vz wcel wss wral wa cfv cv ciin cin wceq cpw cfn wrex csn crn cun wf wb
      cmpt cfi elpw2g biimprd ralimdv imp eqid sylib elrfirn syldan inss1 sseli
      fmpt elpwid nffvmpt1 nfcv fveq2 cbviin simplr simpll simpr fvmpt2 syl2anc
      cvv ssexd ex ralimdva ssralv mpan9 iineq2 syl syl5eq ineq2d eqeq2d sylan2
      rexbidva bitrd ) DGIZEDJZAFKZLZCDUAAFEUFZUBUCUGMIZCDHBNZHNZWGMZOZPZQZBFRZ
      SPZTZCDAWIEOZPZQZBWPTWCWEFDRZWGUDZWHWQUEWFEXAIZAFKZXBWCWEXDWCWDXCAFWCXCWD
      EDGUHUIUJUKAFXAEWGWGULZURUMHBCDWGFGUNUOWFWNWTBWPWIWPIZWFWIFJZWNWTUEXFWIFW
      PWOWIWOSUPUQUSWFXGLZWMWSCXHWLWRDXHWLAWIANZWGMZOZWRHAWIWKXJAFEWJUTHXJVAWJX
      IWGVBVCXHXJEQZAWIKZXKWRQWFXLAFKZXGXMWCWEXNWCWDXLAFWCXIFIZLZWDXLXPWDLZXOEV
      IIXLWCXOWDVDXQEDGWCXOWDVEXPWDVFVJAFEVIWGXEVGVHVKVLUKXLAWIFVMVNAWIXJEVOVPV
      QVRVSVTWAWB $.
  $}

  ${
    $d ph k l $.  $d I k l $.  $d J k l $.  $d S l $.  $d X k l $.
    cmpfiiin.x $e |- X = U. J $.
    cmpfiiin.j $e |- ( ph -> J e. Comp ) $.
    cmpfiiin.s $e |- ( ( ph /\ k e. I ) -> S e. ( Clsd ` J ) ) $.
    cmpfiiin.z $e |- ( ( ph /\ ( l C_ I /\ l e. Fin ) ) ->
        ( X i^i |^|_ k e. l S ) =/= (/) ) $.
    $( In a compact topology, a system of closed sets with nonempty finite
       intersections has a nonempty intersection.  (Contributed by Stefan
       O'Rear, 22-Feb-2015.) $)
    cmpfiiin $p |- ( ph -> ( X i^i |^|_ k e. I S ) =/= (/) ) $=
      ( ciin cin c0 wcel wss syl wa wne cfn csn cmpt crn cun cint ccld cfv wral
      wceq ctop ccmp cmptop topcld cv cldss ralrimiva riinint syl2anc cfi snssd
      wn wf eqid fmptd frn unssd wrex elin elpwi anim1i sylbi necom df-ne bitri
      cpw sylib sylan2 nrexdv wb elrfirn2 mtbird cmpfii syl3anc eqnetrd ) AFCDB
      LMZFUAZCDBUBZUCZUDZUEZNAFEUFUGZOZBFPZCDUHZWEWJUIAEUJOZWLAEUKOZWOIEULQEFHU
      MQZAWMCDACUNDORBWKOWMJBEFHUOQUPZBCDWKFUQURAWPWIWKPNWIUSUGOZVAWJNSIAWFWHWK
      AFWKWQUTADWKWGVBWHWKPACDBWKWGJWGVCVDDWKWGVEQVFAWSNFCGUNZBLMZUIZGDVOZTMZVG
      ZAXBGXDWTXDOZAWTDPZWTTOZRZXBVAZXFWTXCOZXHRXIWTXCTVHXKXGXHWTDVIVJVKAXIRXAN
      SZXJKXLNXASXJXANVLNXAVMVNVPVQVRAWLWNWSXEVSWQWRCGNFBDWKVTURWAEWIWBWCWD $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Characterization of closure operators.  Kuratowski closure axioms
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d ph x y z $.  $d B x y z $.  $d F x y z $.  $d V x y z $.
    ismrcd.b $e |- ( ph -> B e. V ) $.
    ismrcd.f $e |- ( ph -> F : ~P B --> ~P B ) $.
    ismrcd.e $e |- ( ( ph /\ x C_ B ) -> x C_ ( F ` x ) ) $.
    ismrcd.m $e |- ( ( ph /\ x C_ B /\ y C_ x ) -> ( F ` y ) C_ ( F ` x ) ) $.
    ismrcd.i $e |- ( ( ph /\ x C_ B ) -> ( F ` ( F ` x ) ) = ( F ` x ) ) $.
    $( Any function from the subsets of a set to itself, which is extensive
       (satisfies ~ mrcssid ), isotone (satisfies ~ mrcss ), and idempotent
       (satisfies ~ mrcidm ) has a collection of fixed points which is a Moore
       collection, and itself is the closure operator for that collection.
       This can be taken as an alternate definition for the closure operators.
       This is the first half, ~ ismrcd2 is the second.  (Contributed by Stefan
       O'Rear, 1-Feb-2015.) $)
    ismrcd1 $p |- ( ph -> dom ( F i^i _I ) e. ( Moore ` B ) ) $=
      ( vz wss wceq syl wcel cfv wb syl2anc 3ad2ant1 cid cin cdm cpw inss1 dmss
      ax-mp wf fdm syl5sseq ssid elpwg mpbiri ffvelrnd elpwid wral elpw sylan2b
      cv vex ralrimiva fveq2 sseq12d rspcva eqssd wfn ffn fnelfp mpbird wne w3a
      id c0 cint wel wa wal cuni simp2 sstrd simp3 intssuni2 unipw syl6sseq cvv
      intex sylbi 3ad2ant3 adantr 3expib alrimiv sselda intss1 adantl jca sseq1
      wi anbi2d sseq1d imbi12d spcgv syl3c mpbid sseqtrd ssint sylibr ismred )
      AEUAUBZUCZDLAEUCZXIDUDZXHEMXIXJMEUAUEXHEUFUGAXKXKEUHZXJXKNHXKXKEUIOUJZADX
      IPZDEQZDNZAXODAXODAXKXKDEHADXKPZDDMZDUKADFPXQXRRGDDFULOUMZUNUOAXQBUSZXTEQ
      ZMZBXKUPZDXOMZXSAYBBXKXTXKPZAXTDMZYBXTDBUTUQIURVAZYBYDBDXKXTDNZXTDYAXOYHV
      LXTDEVBVCVDSVEAEXKVFZXQXNXPRAXLYIHXKXKEVGOZXSXKEDVHSVIALUSZXIMZYKVMVJZVKZ
      YKVNZXIPZYOEQZYONZYNYQYOYNYQXTMZBYKUPYQYOMYNYSBYKYNBLVOZVPZYQYAXTUUAYOXKP
      ZYFCUSZXTMZVPZUUCEQZYAMZWQZCVQZYFYOXTMZVPZYQYAMZYNUUBYTYNUUBYODMZYNYOXKVR
      ZDYNYKXKMYMYOUUNMYNYKXIXKAYLYMVSZAYLXIXKMYMXMTVTZAYLYMWAYKXKWBSDWCWDYMAUU
      BUUMRZYLYMYOWEPUUQYKWFYODWEULWGWHVIZWIYNUUIYTAYLUUIYMAUUHCAYFUUDUUGJWJWKT
      WIUUAYFUUJUUAXTDYNYKXKXTUUPWLZUOYTUUJYNXTYKWMWNWOUUHUUKUULWQCYOXKUUCYONZU
      UEUUKUUGUULUUTUUDUUJYFUUCYOXTWPWRUUTUUFYQYAUUCYOEVBWSWTXAXBUUAXTXIPZYAXTN
      ZYNYKXIXTUUOWLUUAYIYEUVAUVBRYNYIYTAYLYIYMYJTZWIUUSXKEXTVHSXCXDVABYQYKXEXF
      YNUUBYCYOYQMZUURAYLYCYMYGTYBUVDBYOXKXTYONZXTYOYAYQUVEVLXTYOEVBVCVDSVEYNYI
      UUBYPYRRUVCUURXKEYOVHSVIXG $.

    $( Second half of ~ ismrcd1 .  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    ismrcd2 $p |- ( ph -> F = ( mrCls ` dom ( F i^i _I ) ) ) $=
      ( vz cfv wcel wa wss adantr wi cvv wceq cpw cid cin cdm cmrc wfn ffn cmre
      wf ismrcd1 eqid mrcf 3syl cv mrcssvd elpwi mrcssid syl2an 3expib alrimivv
      syl wal vex weq wb sseq1 adantl sseq12 anbi12d fveq2 imbi12d spc2gv mp2an
      fvex mp2and mrccl elpw sylibr fnelfp syl2anc mpbid sseqtrd anbi2d sseq12d
      id chvarv sylan2 fveq2d eqeq12d ffvelrnda mpbird mrcsscl syl3anc eqfnfvd
      eqssd ) ALDUAZEEUBUCUDZUEMZAWPWPEUIEWPUFZHWPWPEUGVAZAWQDUHMNZWPWQWRUIWRWP
      UFABCDEFGHIJKUJZWQWRDWRUKZULWPWQWRUGUMALUNZWPNZOZXDEMZXDWRMZXFXGXHEMZXHXF
      XHDPZXDXHPZXGXIPZAXJXEAWQXDWRDXBXCUOZQAXAXDDPZXKXEXBXDDUPZWQXDWRDXCUQURAX
      JXKOZXLRZXEABUNZDPZCUNZXRPZOZXTEMZXREMZPZRZBVBCVBZXQAYFCBAXSYAYEJUSUTXDSN
      XHSNYGXQRLVCXDWRVNZYFXQCBXDXHSSCLVDZXRXHTZOZYBXPYEXLYKXSXJYAXKYJXSXJVEYIX
      RXHDVFVGXTXDXRXHVHVIYIYCXGTYDXITYEXLVEYJXTXDEVJXRXHEVJYCXGYDXIVHURVKVLVMV
      AQVOXFXHWQNZXIXHTZAXAXNYLXEXBXOWQXDWRDXCVPURXFWSXHWPNZYLYMVEAWSXEWTQZAYNX
      EAXJYNXMXHDYHVQVRQWPEXHVSVTWAWBXFXAXDXGPZXGWQNZXHXGPAXAXEXBQXEAXNYPXOAXSO
      ZXRYDPZRAXNOZYPRBLBLVDZYRYTYSYPUUAXSXNAXRXDDVFWCZUUAXRXDYDXGUUAWEXRXDEVJZ
      WDVKIWFWGXFYQXGEMZXGTZXEAXNUUEXOYRYDEMZYDTZRYTUUERBLUUAYRYTUUGUUEUUBUUAUU
      FUUDYDXGUUAYDXGEUUCWHUUCWIVKKWFWGXFWSXGWPNYQUUEVEYOAWPWPXDEHWJWPEXGVSVTWK
      WQXDWRXGDXCWLWMWOWN $.
  $}

  ${
    $d B x y z $.  $d ph x y z $.  $d F x y z $.  $d J x y $.  $d V x y z $.
    istopclsd.b $e |- ( ph -> B e. V ) $.
    istopclsd.f $e |- ( ph -> F : ~P B --> ~P B ) $.
    istopclsd.e $e |- ( ( ph /\ x C_ B ) -> x C_ ( F ` x ) ) $.
    istopclsd.i $e |- ( ( ph /\ x C_ B ) -> ( F ` ( F ` x ) ) = ( F ` x ) ) $.
    istopclsd.z $e |- ( ph -> ( F ` (/) ) = (/) ) $.
    istopclsd.u $e |- ( ( ph /\ x C_ B /\ y C_ B ) -> ( F ` ( x u. y ) ) =
          ( ( F ` x ) u. ( F ` y ) ) ) $.
    istopclsd.j $e |- J = { z e. ~P B | ( F ` ( B \ z ) ) = ( B \ z ) } $.
    $( A closure function which satisfies ~ sscls , ~ clsidm , ~ cls0 , and
       ~ clsun defines a (unique) topology which it is the closure function
       on.  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    istopclsd $p |- ( ph -> ( J e. ( TopOn ` B ) /\ ( cls ` J ) = F ) ) $=
      ( cfv wcel wceq wb wss ctopon ccl cv cdif cid cin cdm cpw crab wa wfn ffn
      syl adantr difss elpw2g mpbiri fnelfp syl2anc bicomd rabbidva syl5eq ccld
      wf w3a cun simp1 simp2 simp3 sstrd syl3anc ssequn2 biimpi 3ad2ant3 fveq2d
      eqtr3d sylibr ismrcd1 c0 0elpw sylancl inss1 dmss ax-mp syl5sseq 3ad2ant1
      mpbird fdm sseldd elpwid mpbid uneq12d eqtrd unssd unex elpw eqid mretopd
      vex simpld eqeltrd cmrc ctop topontop mrccls simprd eqtr4d ismrcd2 jca )
      AGEUAPZQZGUBPZFRAGEDUCZUDZFUEUFZUGZQZDEUHZUIZXJAGXNFPXNRZDXRUIXSOAXTXQDXR
      AXMXRQZUJZXQXTYBFXRUKZXNXRQZXQXTSAYCYAAXRXRFVDZYCJXRXRFULUMZUNAYDYAAYDXNE
      TZEXMUOAEHQYDYGSIXNEHUPUMUQUNXRFXNURUSUTVAVBZAXSXJQZXPXSVCPZRZABCDEXSXPAB
      CEFHIJKABUCZETZCUCZYLTZVEZYLFPZYNFPZVFZYQRYRYQTYPYLYNVFZFPZYSYQYPAYMYNETZ
      UUAYSRZAYMYOVGAYMYOVHZYPYNYLEAYMYOVIUUDVJNVKYPYTYLFYOAYTYLRZYMYOUUEYNYLVL
      VMVNVOVPYRYQVLVQZLVRAVSXPQZVSFPVSRZMAYCVSXRQUUGUUHSYFEVTXRFVSURWAWGAYLXPQ
      ZYNXPQZVEZYTXPQZUUAYTRZUUKUUAYSYTUUKAYMUUBUUCAUUIUUJVGUUKYLEUUKXPXRYLAUUI
      XPXRTUUJAFUGZXPXRXOFTXPUUNTFUEWBXOFWCWDAYEUUNXRRJXRXRFWHUMWEWFZAUUIUUJVHZ
      WIZWJZUUKYNEUUKXPXRYNUUOAUUIUUJVIZWIZWJZNVKUUKYQYLYRYNUUKUUIYQYLRZUUPUUKY
      CYLXRQUUIUVBSAUUIYCUUJYFWFZUUQXRFYLURUSWKUUKUUJYRYNRZUUSUUKYCYNXRQUUJUVDS
      UVCUUTXRFYNURUSWKWLWMUUKYCYTXRQZUULUUMSUVCUUKYTETUVEUUKYLYNEUURUVAWNYTEYL
      YNBWSCWSWOWPVQXRFYTURUSWGXSWQWRZWTXAZAXLXPXBPZFAXLGVCPZXBPZUVHAGXCQZXLUVJ
      RAXKUVKUVGEGXDUMUVJGUVJWQXEUMAXPUVIXBAXPYJUVIAYIYKUVFXFAGXSVCYHVOXGVOXGAB
      CEFHIJKUUFLXHXGXI $.
  $}

  ${
    $d F x y z w $.  $d B x y z w $.
    $( A function is a Moore closure operator iff it satisfies ~ mrcssid ,
       ~ mrcss , and ~ mrcidm .  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    ismrc $p |- ( F e. ( mrCls " ( Moore ` B ) ) <-> ( B e. _V /\
          F : ~P B --> ~P B /\ A. x A. y ( ( x C_ B /\ y C_ x ) ->
              ( x C_ ( F ` x ) /\ ( F ` y ) C_ ( F ` x ) /\
                ( F ` ( F ` x ) ) = ( F ` x ) ) ) ) ) $=
      ( vz vw cmrc cmre cfv wcel cvv cv wss wa wceq w3a wi wal syl wb cima wrex
      cpw wf wfun crn cuni wfn fnmrc fnfun ax-mp fvelima mpan eqid mrcf mresspw
      elfvex fss syl2anc mrcssid adantrr mrcss 3expb ancom2s mrcidm ex alrimivv
      3jca feq1 fveq1 sseq2d sseq12d fveq12d eqeq12d 3anbi123d 2albidv 3anbi23d
      id imbi2d syl5ibcom rexlimiv cid cin cdm simp1 simp2 3simpb imim2i 2alimi
      ssid vex weq sseq1 adantr sseq12 ancoms anbi12d fveq2 fveq2d spc2gv mp2an
      imbi12d mpan2i imp simpld syl2anr 3impib simprd ismrcd2 ismrcd1 fvssunirn
      3ad2ant3 fndm sseqtr4i funfvima2 eqeltrd impbii ) DGCHIZUAZJZCKJZCUCZYBDU
      DZALZCMZBLZYDMZNZYDYDDIZMZYFDIZYIMZYIDIZYIOZPZQZBRARZPZXTELZGIZDOZEXRUBZY
      RGUEZXTUUBGHUFUGZUHZUUCUIUUDGUJUKZEDXRGULUMUUAYREXRYSXRJZYAYBYBYTUDZYHYDY
      DYTIZMZYFYTIZUUIMZUUIYTIZUUIOZPZQZBRARZPUUAYRUUGYAUUHUUQYSCHUQUUGYBYSYTUD
      YSYBMUUHYSYTCYTUNZUOYSCUPYBYSYBYTURUSUUGUUPABUUGYHUUOUUGYHNUUJUULUUNUUGYE
      UUJYGYSYDYTCUURUTVAUUGYGYEUULUUGYGYEUULYSYFYTYDCUURVBVCVDUUGYEUUNYGYSYDYT
      CUURVEVAVHVFVGVHUUAUUHYCUUQYQYAYBYBYTDVIUUAUUPYPABUUAUUOYOYHUUAUUJYJUULYL
      UUNYNUUAUUIYIYDYDYTDVJZVKUUAUUKYKUUIYIYFYTDVJUUSVLUUAUUMYMUUIYIUUAUUIYIYT
      DUUAVRUUSVMUUSVNVOVSVPVQVTWASYRDDWBWCWDZGIZXSYREFCDKYAYCYQWEZYAYCYQWFZYRY
      SCMZNZYSYSDIZMZUVFDIZUVFOZYRUVDUVGUVINZYRUVDYSYSMZUVJYSWJYQYAUVDUVKNZUVJQ
      ZYCYQYHYJYNNZQZBRARZUVMYPUVOABYOUVNYHYJYLYNWGWHWIYSKJZUVQUVPUVMQEWKZUVRUV
      OUVMABYSYSKKAEWLZBEWLZNZYHUVLUVNUVJUWAYEUVDYGUVKUVSYEUVDTZUVTYDYSCWMZWNUV
      TUVSYGUVKTYFYSYDYSWOWPWQUWAYJUVGYNUVIUVSYJUVGTUVTUVSYDYSYIUVFUVSVRYDYSDWR
      ZVLWNUVSYNUVITUVTUVSYMUVHYIUVFUVSYIUVFDUWDWSUWDVNWNWQXBWTXASXLXCXDZXEZYRU
      VDFLZYSMZUWGDIZUVFMZYRYHYLQZBRARZUVDUWHNZUWJQZYQYAUWLYCYPUWKABYOYLYHYJYLY
      NWFWHWIXLUVQUWGKJUWLUWNQUVRFWKUWKUWNABYSUWGKKUVSBFWLZNZYHUWMYLUWJUWPYEUVD
      YGUWHUVSUWBUWOUWCWNUWOUVSYGUWHTYFUWGYDYSWOWPWQUWOYKUWIOYIUVFOYLUWJTUVSYFU
      WGDWRUWDYKUWIYIUVFWOXFXBWTXASXGZUVEUVGUVIUWEXHZXIYRUUTXRJZUVAXSJZYREFCDKU
      VBUVCUWFUWQUWRXJUUCXRGWDZMUWSUWTQUUFXRUUDUXAHCXKUUEUXAUUDOUIUUDGXMUKXNXRU
      UTGXOXASXPXQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Algebraic closure systems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c NoeACS $.

  $( Class of Noetherian closure systems. $)
  cnacs $a class NoeACS $.

  ${
    $d x c s g $.
    $( Define a closure system of _Noetherian type_ (not standard terminology)
       as an algebraic system where all closed sets are finitely generated.
       (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    df-nacs $a |- NoeACS = ( x e. _V |-> { c e. ( ACS ` x ) | A. s e. c
              E. g e. ( ~P x i^i Fin ) s = ( ( mrCls ` c ) ` g ) } ) $.
  $}

  ${
    $d C c g s $.  $d F c g s $.  $d S g s $.  $d X c g s x $.
    isnacs.f $e |- F = ( mrCls ` C ) $.
    $( Expand definition of Noetherian-type closure system.  (Contributed by
       Stefan O'Rear, 4-Apr-2015.) $)
    isnacs $p |- ( C e. ( NoeACS ` X ) <-> ( C e. ( ACS ` X ) /\
          A. s e. C E. g e. ( ~P X i^i Fin ) s = ( F ` g ) ) ) $=
      ( vc vx cnacs cfv wcel cvv cacs cv wceq cpw cfn wrex wral cmrc cin elfvex
      wa adantr crab fveq2 ineq1d rexeqdv ralbidv rabeqbidv df-nacs rabex fvmpt
      pweq fvex eleq2d syl6eqr fveq1d eqeq2d rexbidv raleqbi1dv elrab pm5.21nii
      syl6bb ) ADIJZKZDLKZADMJZKZENZBNZCJZOZBDPZQUAZRZEASZUCZADIUBVIVGVQADMUBUD
      VGVFAVJVKGNZTJZJZOZBVORZEVSSZGVHUEZKVRVGVEWEAHDWBBHNZPZQUAZRZEVSSZGWFMJZU
      EWELIWFDOZWJWDGWKVHWFDMUFWLWIWCEVSWLWBBWHVOWLWGVNQWFDUNUGUHUIUJHBEGUKWDGV
      HDMUOULUMUPWDVQGAVHWCVPEVSAVSAOZWBVMBVOWMWAVLVJWMVKVTCWMVTATJCVSATUFFUQUR
      USUTVAVBVDVC $.

    $( In a Noetherian-type closure system, all closed sets are finitely
       generated.  (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    nacsfg $p |- ( ( C e. ( NoeACS ` X ) /\ S e. C ) ->
        E. g e. ( ~P X i^i Fin ) S = ( F ` g ) ) $=
      ( vs wcel cnacs cfv cv wceq cpw cfn cin wrex wral cacs isnacs simprbi
      eqeq1 rexbidv rspcva sylan2 ancoms ) BAHZAEIJHZBCKDJZLZCEMNOZPZUGUFGKZUHL
      ZCUJPZGAQZUKUGAERJHUOACDEGFSTUNUKGBAULBLUMUICUJULBUHUAUBUCUDUE $.

    $( Express Noetherian-type closure system with fewer quantifiers.
       (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    isnacs2 $p |- ( C e. ( NoeACS ` X ) <-> ( C e. ( ACS ` X ) /\
          ( F " ( ~P X i^i Fin ) ) = C ) ) $=
      ( vs vg cnacs cfv wcel cacs cv wceq cpw cfn wrex wral wa wss 3syl syl6bbr
      cin cima isnacs wfn wb cmre acsmre mrcf ffn inss1 fvelimab sylancl rexbii
      wf eqcom syl6rbbr ralbidv dfss3 crn imassrn syl5ss biantrurd eqss pm5.32i
      frn bitrd bitri ) ACGHIACJHIZEKZFKBHZLZFCMZNUAZOZEAPZQVHBVMUBZALZQAFBCEDU
      CVHVOVQVHVOAVPRZVQVHVOVIVPIZEAPVRVHVNVSEAVHVSVJVILZFVMOZVNVHBVLUDZVMVLRVS
      WAUEVHACUFHIZVLABUNZWBACUGZABCDUHZVLABUISVLNUJFVLVMVIBUKULVKVTFVMVIVJUOUM
      UPUQEAVPURTVHVRVPARZVRQVQVHWGVRVHVPBUSZABVMUTVHWCWDWHARWEWFVLABVESVAVBVPA
      VCTVFVDVG $.

    $( Slight variation on finite genration for closure systems.  (Contributed
       by Stefan O'Rear, 4-Apr-2015.) $)
    mrefg2 $p |- ( C e. ( Moore ` X ) ->
        ( E. g e. ( ~P X i^i Fin ) S = ( F ` g ) <->
          E. g e. ( ~P S i^i Fin ) S = ( F ` g ) ) ) $=
      ( cmre cfv wcel cv wceq cpw cfn cin wb wa wss elpw 3bitr4g elin simpr vex
      mrcssid mrcssv adantr impbida anbi1d pweq ineq1d eleq2d bibi2d syl5ibrcom
      sstrd pm5.32rd rexbidv2 ) AEGHIZBCJZDHZKZUSCELZMNZBLZMNZUPUSUQVAIZUQVCIZU
      PVDVEOUSVDUQURLZMNZIZOUPUQUTIZUQMIZPUQVFIZVJPVDVHUPVIVKVJUPUQEQZUQURQZVIV
      KUPVLVMAUQDEFUCUPVMPUQUREUPVMUAUPUREQVMAUQDEFUDUEUMUFUQECUBZRUQURVNRSUGUQ
      UTMTUQVFMTSUSVEVHVDUSVCVGUQUSVBVFMBURUHUIUJUKULUNUO $.

    $( Slight variation on finite genration for closure systems.  (Contributed
       by Stefan O'Rear, 4-Apr-2015.) $)
    mrefg3 $p |- ( ( C e. ( Moore ` X ) /\ S e. C ) ->
        ( E. g e. ( ~P X i^i Fin ) S = ( F ` g ) <->
          E. g e. ( ~P S i^i Fin ) S C_ ( F ` g ) ) ) $=
      ( cmre cfv wcel wa cv wceq cpw cfn cin wrex wss wb mrefg2 adantr biantrud
      simpll inss1 sseli elpwid adantl simplr mrcsscl syl3anc syl6rbbr rexbidva
      eqss bitrd ) AEGHIZBAIZJZBCKZDHZLZCEMNOPZUSCBMZNOZPZBURQZCVBPUNUTVCRUOABC
      DEFSTUPUSVDCVBUPUQVBIZJZVDVDURBQZJUSVFVGVDVFUNUQBQZUOVGUNUOVEUBVEVHUPVEUQ
      BVBVAUQVANUCUDUEUFUNUOVEUGAUQDBEFUHUIUABURULUJUKUM $.
  $}

  ${
    $d C g h i s $.  $d C t $.  $d X g h i s $.  $d X t $.  $d g t $.
    $d h t $.  $d s t $.
    $( A closure system of Noetherian type is algebraic.  (Contributed by
       Stefan O'Rear, 4-Apr-2015.) $)
    nacsacs $p |- ( C e. ( NoeACS ` X ) -> C e. ( ACS ` X ) ) $=
      ( cnacs cfv wcel cacs cmrc cpw cfn cin cima wceq eqid isnacs2 simplbi ) A
      BCDEABFDEAGDZBHIJKALAPBPMNO $.

    $( A choice-free order equivalent to the Noetherian condition on a closure
       system.  (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    isnacs3 $p |- ( C e. ( NoeACS ` X ) <-> ( C e. ( Moore ` X ) /\
          A. s e. ~P C ( ( toInc ` s ) e. Dirset -> U. s e. s ) ) ) $=
      ( vg vh vi vt cfv wcel cv cipo wi cpw wa wceq cfn wrex wss adantlr cvv wb
      cnacs cmre cdrs cuni wral nacsacs acsmred cmrc simpll cacs ad2antrr elpwi
      cin ad2antlr simpr acsdrsel syl3anc nacsfg syl2anc mrefg2 syl mpbid elfpw
      eqid fissuni sylbi 3expb sylan2b sstr ancoms simprr simprl sseldd mrcsscl
      ipodrsfi adantr eqsstrd simplrl elssuni eqssd eqeltrd expr syl5 rexlimdva
      ex exp3a expdimp rexlimdv mpd ralrimiva jca simpl adantl sseld imim2d imp
      ralimdva isacs3 sylanbrc cima mrcid mress acsficld eqtr3d wfn wf mrcf ffn
      mrcss fpwipodrs mp1i inss1 sspwb sylib syl5ss fvex imaexg ax-mp ipodrsima
      vex a1i crn imassrn elpw sylibr simplr fveq2 eleq1d unieq eleq12d imbi12d
      frn id rspcva fvelimab eqcom rexbii mpbird isnacs impbii ) ABUBHIZABUCHIZ
      CJZKHZUDIZUUDUEZUUDIZLZCAMZUFZNZUUBUUCUUKUUBABABUGZUHZUUBUUICUUJUUBUUDUUJ
      IZNZUUFUUHUUPUUFNZUUGDJZAUIHZHZOZDUUGMPUNZQZUUHUUQUVADBMZPUNZQZUVCUUQUUBU
      UGAIZUVFUUBUUOUUFUJUUQABUKHIZUUDARZUUFUVGUUBUVHUUOUUFUUMULUUOUVIUUBUUFUUD
      AUMZUOUUPUUFUPABUUDUQURAUUGDUUSBUUSVEZUSUTUUBUVFUVCUAZUUOUUFUUBUUCUVLUUNA
      UUGDUUSBUVKVAVBULVCUUQUVAUUHDUVBUURUVBIZUUREJZUEZRZEUUDMPUNZQZUUQUVAUUHLZ
      UVMUURUUGRUURPINUVRUURUUGVDUURUUDEVFVGUUQUVPUVSEUVQUUPUUFUVNUVQIZUVPUVSLZ
      UUFUVTNUVOFJZRZFUUDQZUUPUWAUVTUUFUVNUUDRZUVNPIZNUWDUVNUUDVDUUFUWEUWFUWDFU
      UDUVNVPVHVIUUPUWCUWAFUUDUUPUWBUUDIZNZUWCUVPUVSUWCUVPNUURUWBRZUWHUVSUVPUWC
      UWIUURUVOUWBVJVKUUPUWGUWIUVSUUPUWGUWINZNZUVAUUHUWKUVANZUUGUWBUUDUWLUUGUWB
      UWLUUGUUTUWBUWKUVAUPUWKUUTUWBRZUVAUWKUUCUWIUWBAIUWMUUBUUCUUOUWJUUNULUUPUW
      GUWIVLUWKUUDAUWBUUOUVIUUBUWJUVJUOUUPUWGUWIVMVNAUURUUSUWBBUVKVOURVQVRUWLUW
      GUWBUUGRUUPUWGUWIUVAVSZUWBUUDVTVBWAUWNWBWFWCWDWGWEWDWHWIWDWIWJWFWKWLUULUV
      HGJZUUTOZDUVEQZGAUFUUBUULUUCUUFUVGLZCUUJUFZUVHUUCUUKWMUUCUUKUWSUUCUUIUWRC
      UUJUUCUUONZUUHUVGUUFUWTUUDAUUGUUOUVIUUCUVJWNWOWPWRWQABCWSWTZUULUWQGAUULUW
      OAIZNZUWQUWPDUWOMZPUNZQZUXCUUTUWOOZDUXEQZUXFUXCUWOUUSUXEXAZIZUXHUXCUWOUXI
      UEZUXIUXCUWOUUSHZUWOUXKUUCUXBUXLUWOOUUKAUWOUUSBUVKXBSUXCAUWOUUSBUULUVHUXB
      UXAVQUVKUUCUXBUWOBRZUUKAUWOBXCZSXDXEUXCUXIKHZUDIZUXKUXIIZUUCUXBUXPUUKUUCU
      XBNZEDBUXEUUSTUUCUUSUVDXFZUXBUUCUVDAUUSXGZUXSAUUSBUVKXHZUVDAUUSXIVBVQZUUC
      UURUVNRZUVNBRZNUUTUVNUUSHRZUXBUUCUYCUYDUYEAUURUUSUVNBUVKXJVHSUWOTIUXEKHUD
      IUXRGYAUWOTXKXLUXRUXEUXDUVDUXDPXMUXRUXMUXDUVDRUXNUWOBXNXOXPZUXITIZUXRUUST
      IUYGAUIXQUUSUXETXRXSZYBXTSUXCUXIUUJIZUUKUXPUXQLZUUCUXBUYIUUKUXRUXIARZUYIU
      UCUYKUXBUUCUXIUUSYCZAUUSUXEYDUUCUXTUYLARUYAUVDAUUSYMVBXPVQUXIAUYHYEYFSUUC
      UUKUXBYGUUIUYJCUXIUUJUUDUXIOZUUFUXPUUHUXQUYMUUEUXOUDUUDUXIKYHYIUYMUUGUXKU
      UDUXIUUDUXIYJUYMYNYKYLYOUTWJWBUUCUXBUXJUXHUAZUUKUXRUXSUXEUVDRUYNUYBUYFDUV
      DUXEUWOUUSYPUTSVCUWPUXGDUXEUWOUUTYQYRYFUUCUWQUXFUAUUKUXBAUWODUUSBUVKVAULY
      SWKADUUSBGUVKYTWTUUA $.
  $}

  ${
    $d A a b $.  $d B a $.  $d F a b x $.
    $( Transitivity induction of subsets, lemma for ~ nacsfix .  (Contributed
       by Stefan O'Rear, 4-Apr-2015.) $)
    incssnn0 $p |- ( ( A. x e. NN0 ( F ` x ) C_ ( F ` ( x + 1 ) ) /\
        A e. NN0 /\ B e. ( ZZ>= ` A ) ) -> ( F ` A ) C_ ( F ` B ) ) $=
      ( va vb cv cfv c1 caddc co wss cn0 wcel wa wi wceq fveq2 sseq2d imbi2d cz
      wral cuz weq ssid a1ii eluznn0 ancoms oveq1 sseq12d rspcv expimpd ancomsd
      fveq2d syl sstr2 com12 syl6 a2d uzind4 3impia ) AGZDHZVBIJKZDHZLZAMUBZBMN
      ZCBUCHZNZBDHZCDHZLZVJVGVHOZVMVNVKEGZDHZLZPVNVKVKLZPVNVKFGZDHZLZPVNVKVSIJK
      ZDHZLZPVNVMPEFBCVOBQZVQVRVNWEVPVKVKVOBDRSTEFUDZVQWAVNWFVPVTVKVOVSDRSTVOWB
      QZVQWDVNWGVPWCVKVOWBDRSTVOCQZVQVMVNWHVPVLVKVOCDRSTBUANVNVRVKUEUFVSVINZVNW
      AWDWIVNVTWCLZWAWDPWIVHVGWJWIVHVGWJWIVHOVSMNZVGWJPVHWIWKVSBUGUHVFWJAVSMAFU
      DZVCVTVEWCVBVSDRWLVDWBDVBVSIJUIUNUJUKUOULUMWAWJWDVKVTWCUPUQURUSUTUQVA $.
  $}

  ${
    $d C a b z $.  $d C y $.  $d F a b c w $.  $d F y z $.  $d X a b z $.
    $d X y $.  $d a x y $.  $d b x $.  $d w y z $.  $d x z $.  $d F x $.
    $( An increasing sequence of closed sets in a Noetherian-type closure
       system eventually fixates.  (Contributed by Stefan O'Rear,
       4-Apr-2015.) $)
    nacsfix $p |- ( ( C e. ( NoeACS ` X ) /\ F : NN0 --> C /\
          A. x e. NN0 ( F ` x ) C_ ( F ` ( x + 1 ) ) ) ->
        E. y e. NN0 A. z e. ( ZZ>= ` y ) ( F ` z ) = ( F ` y ) ) $=
      ( vw va vb vc cfv wcel cn0 cv wss wral wceq wrex syl wa cnacs wf c1 caddc
      co w3a crn cuni cuz cipo cdrs cvv c0 wne cun cpw frn 3ad2ant2 wb 3ad2ant1
      elpw2g mpbird elex cc0 wfn ffn 0nn0 fnfvelrn sylancl cr ad2antrl ad2antll
      ne0i nn0re cle wbr simplrr simpll3 simplrl cz nn0z syl2an biimpar adantll
      incssnn0 syl3anc ssequn1 sylib eqimss fveq2 sseq2d rspcev syl2anc syl2anr
      ssequn2 lecasei ralrimivva uneq1 sseq1d rexbidv ralbidv ralrn uneq2 sseq2
      eluz weq rexrn bitrd isipodrs syl3anbrc cmre isnacs3 simprbi eleq1d unieq
      wi eleq12d imbi12d rspcva mpd fvelrnb mpbid fvssunirn syl5sseqr ralrimiva
      id simpr eqssd expr reximdva ) DFUAKZLZMDEUBZANZEKYNUCUDUEEKOAMPZUFZBNZEK
      ZEUGZUHZQZBMRZCNZEKZYRQZCYQUIKZPZBMRYPYTYSLZUUBYPYSUJKZUKLZUUHYPYSULLZYSU
      MUNZYQUUCUOZGNZOZGYSRZCYSPZBYSPZUUJYPYSDUPZLZUUKYPUUTYSDOZYMYLUVAYOMDEUQU
      RYLYMUUTUVAUSYOYSDYKVAUTVBZYSUUSVCSYPVDEKZYSLZUULYPEMVEZVDMLUVDYMYLUVEYOM
      DEVFURZVGMVDEVHVIYSUVCVMSYPUURHNZEKZINZEKZUOZJNZEKZOZJMRZIMPZHMPZYPUVOHIM
      MYPUVGMLZUVIMLZTZTZUVOUVGUVIUVRUVGVJLYPUVSUVGVNVKUVSUVIVJLYPUVRUVIVNVLUWA
      UVGUVIVOVPZTZUVSUVKUVJOZUVOYPUVRUVSUWBVQUWCUVKUVJQZUWDUWCUVHUVJOZUWEUWCYO
      UVRUVIUVGUIKLZUWFYLYMYOUVTUWBVRYPUVRUVSUWBVSUVTUWBUWGYPUVTUWGUWBUVRUVGVTL
      ZUVIVTLZUWGUWBUSUVSUVGWAZUVIWAZUVGUVIXEWBWCWDAUVGUVIEWEWFUVHUVJWGWHUVKUVJ
      WISUVNUWDJUVIMJIXFUVMUVJUVKUVLUVIEWJWKWLWMUWAUVIUVGVOVPZTZUVRUVKUVHOZUVOY
      PUVRUVSUWLVSUWMUVKUVHQZUWNUWMUVJUVHOZUWOUWMYOUVSUVGUVIUIKLZUWPYLYMYOUVTUW
      LVRYPUVRUVSUWLVQUVTUWLUWQYPUVTUWQUWLUVSUWIUWHUWQUWLUSUVRUWKUWJUVIUVGXEWNW
      CWDAUVIUVGEWEWFUVJUVHWOWHUVKUVHWISUVNUWNJUVGMJHXFUVMUVHUVKUVLUVGEWJWKWLWM
      WPWQYPUVEUURUVQUSUVFUVEUURUVHUUCUOZUUNOZGYSRZCYSPZHMPUVQUUQUXABHMEYQUVHQZ
      UUPUWTCYSUXBUUOUWSGYSUXBUUMUWRUUNYQUVHUUCWRWSWTXAXBUVEUXAUVPHMUVEUXAUVKUU
      NOZGYSRZIMPUVPUWTUXDCIMEUUCUVJQZUWSUXCGYSUXEUWRUVKUUNUUCUVJUVHXCWSWTXBUVE
      UXDUVOIMUXCUVNGJMEUUNUVMUVKXDXGXAXHXAXHSVBBCGYSXIXJYPUUTYQUJKZUKLZYQUHZYQ
      LZXPZBUUSPZUUJUUHXPZUVBYLYMUXKYOYLDFXKKLUXKDFBXLXMUTUXJUXLBYSUUSYQYSQZUXG
      UUJUXIUUHUXMUXFUUIUKYQYSUJWJXNUXMUXHYTYQYSYQYSXOUXMYFXQXRXSWMXTYPUVEUUHUU
      BUSUVFBMYTEYASYBYPUUAUUGBMYPYQMLZUUAUUGYPUXNUUATZTZUUECUUFUXPUUCUUFLZTZUU
      DYRUXRYTUUDYREUUCYCYPUXNUUAUXQVQYDUXRYOUXNUXQYRUUDOYLYMYOUXOUXQVRYPUXNUUA
      UXQVSUXPUXQYGAYQUUCEWEWFYHYEYIYJXT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Miscellanea 1. Map utilities
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    constmap.1 $e |- A e. _V $.
    constmap.3 $e |- C e. _V $.
    $( A constant (represented without dummy variables) is an element of a
       function set.

       _Note:  In the following development, we will be quite often quantifying
       over functions and points in N-dimensional space (which are equivalent
       to functions from an "index set").  Many of the following theorems exist
       to transfer standard facts about functions to elements of function
       sets._ (Contributed by Stefan O'Rear, 30-Aug-2014.)  (Revised by Stefan
       O'Rear, 5-May-2015.) $)
    constmap $p |- ( B e. C -> ( A X. { B } ) e. ( C ^m A ) ) $=
      ( wcel csn cxp wf cmap co fconst6g elmap sylibr ) BCFACABGHZIOCAJKFABCLCA
      OEDMN $.
  $}

  ${
    $d A c $.  $d B c $.  $d C c $.
    $( A mapping is always a function.  (Contributed by Stefan O'Rear,
       9-Oct-2014.)  (Revised by Stefan O'Rear, 5-May-2015.) $)
    elmapfun $p |- ( A e. ( B ^m C ) -> Fun A ) $=
      ( cmap co wcel wf wfun elmapi ffun syl ) ABCDEFCBAGAHABCICBAJK $.
  $}

  ${
    $d A a b c $.  $d B a b c $.  $d C a b c $.  $d D a b c $.  $d E a b c $.
    $( Renaming indexes in a tuple, with sethood as antecedents.  (Contributed
       by Stefan O'Rear, 9-Oct-2014.)  (Revised by Mario Carneiro,
       5-May-2015.) $)
    mapco2g $p |- ( ( E e. _V /\ A e. ( B ^m C ) /\ D : E --> C ) ->
      ( A o. D ) e. ( B ^m E ) ) $=
      ( cvv wcel cmap co wf w3a ccom elmapi fco sylan 3adant1 wb c0 wceq n0i
      reldmmap ovprc1 nsyl2 3ad2ant2 simp1 elmapg syl2anc mpbird ) EFGZABCHIZGZ
      ECDJZKZADLZBEHIGZEBUNJZUKULUPUIUKCBAJULUPABCMECBADNOPUMBFGZUIUOUPQUKUIUQU
      LUKUJRSUQUJATBCHUAUBUCUDUIUKULUEBEUNFFUFUGUH $.
  $}

  ${
    mapco2.3 $e |- E e. _V $.
    $( Post-composition (renaming indexes) of a mapping viewed as a point.
       (Contributed by Stefan O'Rear, 5-Oct-2014.)  (Revised by Stefan O'Rear,
       5-May-2015.) $)
    mapco2 $p |- ( ( A e. ( B ^m C ) /\ D : E --> C ) ->
        ( A o. D ) e. ( B ^m E ) ) $=
      ( cvv wcel cmap co wf ccom mapco2g mp3an1 ) EGHABCIJHECDKADLBEIJHFABCDEMN
      $.
  $}

  $( A restricted mapping is a mapping.  (Contributed by Stefan O'Rear,
     9-Oct-2014.)  (Revised by Mario Carneiro, 5-May-2015.) $)
  elmapssres $p |- ( ( A e. ( B ^m C ) /\ D C_ C ) ->
      ( A |` D ) e. ( B ^m D ) ) $=
    ( cmap co wcel wss wa cres wf elmapi fssres sylan cvv elmapex simpld adantr
    wb simprd ssexg ancoms elmapg syl2anc mpbird ) ABCEFGZDCHZIZADJZBDEFGZDBUIK
    ZUFCBAKUGUKABCLCBDAMNUHBOGZDOGZUJUKSUFULUGUFULCOGZABCPZQRUFUNUGUMUFULUNUOTU
    GUNUMDCOUAUBNBDUIOOUCUDUE $.

  ${
    $d N a b c x $.  $d A a b c x $.  $d B a b c x $.  $d C a b c x $.
    $d D a b c x $.  $d M a b c x $.
    mapfzcons.1 $e |- M = ( N + 1 ) $.
    $( Extending a one-based mapping by adding a tuple at the end results in
       another mapping.  (Contributed by Stefan O'Rear, 10-Oct-2014.)  (Revised
       by Stefan O'Rear, 5-May-2015.) $)
    mapfzcons $p |- ( ( N e. NN0 /\ A e. ( B ^m ( 1 ... N ) ) /\ C e. B ) -> (
        A u. { <. M , C >. } ) e. ( B ^m ( 1 ... M ) ) ) $=
      ( cn0 wcel c1 cfz co cmap caddc csn cun wf wceq cvv ovex cuz w3a c0 simp2
      cop cin wb elmapex simpld 3ad2ant2 elmapg sylancl mpbid wf1o simp3 f1osng
      wss sylancr f1of syl snssi 3ad2ant3 fss syl2anc fzp1disj a1i fun syl21anc
      cz cmin cfv 1z simp1 cc0 nn0uz 1m1e0 fveq2i eqtr4i syl6eleq fzsuc2 eqcomd
      unidm feq23d mpbird opeq1i sneqi uneq2i oveq2i 3eltr4g ) EGHZABIEJKZLKHZC
      BHZUAZAEIMKZCUDZNZOZBIWNJKZLKZADCUDZNZOBIDJKZLKWMWQWSHZWRBWQPZWMWJWNNZOZB
      BOZWQPZXDWMWJBAPZXEBWPPZWJXEUEUBQZXHWMWKXIWIWKWLUCWMBRHZWJRHZWKXIUFWKWIXL
      WLWKXLXMABWJUGUHUIZIEJSBWJARRUJUKULWMXECNZWPPZXOBUPZXJWMXEXOWPUMZXPWMWNRH
      WLXREIMSWIWKWLUNWNCRBUOUQXEXOWPURUSWLWIXQWKCBUTVAXEXOBWPVBVCXKWMIEVDVEWJX
      EBBAWPVFVGWMXFXGWRBWQWMWRXFWMIVHHEIIVIKZTVJZHWRXFQVKWMEGXTWIWKWLVLGVMTVJX
      TVNXSVMTVOVPVQVRIEVSUQVTXGBQWMBWAVEWBULWMXLWRRHXCXDUFXNIWNJSBWRWQRRUJUKWC
      XAWPAWTWODWNCFWDWEWFXBWRBLDWNIJFWGWGWH $.

    $( Recover prefix mapping from an extended mapping.  (Contributed by Stefan
       O'Rear, 10-Oct-2014.)  (Revised by Stefan O'Rear, 5-May-2015.) $)
    mapfzcons1 $p |- ( A e. ( B ^m ( 1 ... N ) ) ->
      ( ( A u. { <. M , C >. } ) |` ( 1 ... N ) ) = A ) $=
      ( c1 cfz co cmap wcel cres csn cun wceq c0 cdm cin wss ax-mp cop wfn 3syl
      wf elmapi ffn fnresdm uneq1d resundir dmres caddc dmsnopss sneqi fzp1disj
      sseqtri sslin sseq0 mp2an eqtri wrel wb relres reldm0 mpbir uneq2i eqtr2i
      un0 3eqtr4g ) ABGEHIZJIKZAVILZDCUAMZVILZNAVMNZAVLNVILAVJVKAVMVJVIBAUDAVIU
      BVKAOABVIUEVIBAUFVIAUGUCUHAVLVIUIVNAPNAVMPAVMPOZVMQZPOZVPVIVLQZRZPVLVIUJV
      SVIEGUKIZMZRZSZWBPOVSPOVRWASWCVRDMWADCULDVTFUMUOVRWAVIUPTGEUNVSWBUQURUSVM
      UTVOVQVAVLVIVBVMVCTVDVEAVGVFVH $.

    $( A nonempty mapping has a prefix.  (Contributed by Stefan O'Rear,
       10-Oct-2014.)  (Revised by Stefan O'Rear, 5-May-2015.) $)
    mapfzcons1cl $p |- ( A e. ( B ^m ( 1 ... M ) ) ->
        ( A |` ( 1 ... N ) ) e. ( B ^m ( 1 ... N ) ) ) $=
      ( c1 cfz cmap wcel wss cres caddc fzssp1 oveq2i sseqtr4i elmapssres mpan2
      co ) ABFCGRZHRIFDGRZSJATKBTHRITFDFLRZGRSFDMCUAFGENOABSTPQ $.

    $( Recover added element from an extended mapping.  (Contributed by Stefan
       O'Rear, 10-Oct-2014.)  (Revised by Stefan O'Rear, 5-May-2015.) $)
    mapfzcons2 $p |- ( ( A e. ( B ^m ( 1 ... N ) ) /\ C e. B ) ->
        ( ( A u. { <. M , C >. } ) ` M ) = C ) $=
      ( c1 cfz co cmap wcel wa cvv cdm wn csn wceq caddc cin c0 cop cun eqeltri
      cfv ovex a1i adantl wf elmapi fdm syl adantr ineq1d sneqi ineq2i fzp1disj
      elex eqtri syl6eq disjsn sylib fsnunfv syl3anc ) ABGEHIZJIKZCBKZLZDMKZCMK
      ZDANZKOZDADCUAPUBUDCQVHVGDEGRIZMFEGRUEUCUFVFVIVECBUQUGVGVJDPZSZTQVKVGVNVD
      VMSZTVGVJVDVMVEVJVDQZVFVEVDBAUHVPABVDUIVDBAUJUKULUMVOVDVLPZSTVMVQVDDVLFUN
      UOGEUPURUSVJDUTVAAMMDCVBVC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Miscellanea for polynomials
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x a b $.  $d V a b $.  $d B a b $.  $d C a b $.  $d R a b x $.
    $( Value of a pointwise operation on two functions defined using maps-to
       notation.  (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    ofmpteq $p |- ( ( A e. V /\ ( x e. A |-> B ) Fn A
        /\ ( x e. A |-> C ) Fn A )
  -> ( ( x e. A |-> B ) oF R ( x e. A |-> C ) ) = ( x e. A |-> ( B R C ) ) ) $=
      ( va wcel cmpt wfn co cv csb cvv wral eqid mptfng wceq nfcv cbvmpt w3a wa
      cof simp1 simpr simpl2 sylibr nfcsb1v csbeq1a eleq1d rspc sylc simpl3 a1i
      nfel1 offval2 nfov oveq12d syl6eqr ) BFHZABCIZBJZABDIZBJZUAZVAVCEUCKGBAGL
      ZCMZAVFDMZEKZIABCDEKZIVEGBVGVHEVAVCFNNUTVBVDUDVEVFBHZUBZVKCNHZABOZVGNHZVE
      VKUEZVLVBVNUTVBVDVKUFABCVAVAPQUGVMVOAVFBAVGNAVFCUHZUOALVFRZCVGNAVFCUIZUJU
      KULVLVKDNHZABOZVHNHZVPVLVDWAUTVBVDVKUMABDVCVCPQUGVTWBAVFBAVHNAVFDUHZUOVRD
      VHNAVFDUIZUJUKULVAGBVGIRVEAGBCVGGCSVQVSTUNVCGBVHIRVEAGBDVHGDSWCWDTUNUPAGB
      VJVIGVJSAVGVHEVQAESWCUQVRCVGDVHEVSWDURTUS $.
  $}

  ${
    $d A t $.  $d C t $.
    $( Interpret range of a maps-to notation as a constraint on the
       definition.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    mptfcl $p |- ( ( t e. A |-> B ) : A --> C -> ( t e. A -> B e. C ) ) $=
      ( cmpt wf wcel wral cv wi eqid fmpt rsp sylbir ) BDABCEZFCDGZABHAIBGPJABD
      COOKLPABMN $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Multivariate polynomials over the integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c mzPolyCld $.
  $c mzPoly $.
  $( Extend class notation to include pre-polynomial rings. $)
  cmzpcl $a class mzPolyCld $.
  $( Extend class notation to include polynomial rings. $)
  cmzp $a class mzPoly $.

  ${
    $d f g i j p v x $.
    $( Define the polynomially closed function rings over an arbitrary index
       set ` v ` .  The set ` ( mzPolyCld `` v ) ` contains all sets of
       functions from ` ( ZZ ^m v ) ` to ` ZZ ` which include all constants and
       projections and are closed under addition and multiplication.  This is a
       "temporary" set used to define the polynomial function ring itself
       ` ( mzPoly `` v ) ` ; see ~ df-mzp .  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    df-mzpcl $a |- mzPolyCld = ( v e. _V |-> { p e. ~P ( ZZ ^m ( ZZ ^m v ) ) |
        ( ( A. i e. ZZ ( ( ZZ ^m v ) X. { i } ) e. p
           /\ A. j e. v ( x e. ( ZZ ^m v ) |-> ( x ` j ) ) e. p )
    /\ A. f e. p A. g e. p ( ( f oF + g ) e. p /\ ( f oF x. g ) e. p ) ) } ) $.

    $( Polynomials over ` ZZ ` with an arbitrary index set, that is, the
       smallest ring of functions containing all constant functions and all
       projections.  This is almost the most general reasonable definition; to
       reach full generality, we would need to be able to replace ZZ with an
       arbitrary (semi-)ring (and a coordinate subring), but rings have not
       been defined yet.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
    df-mzp $a |- mzPoly = ( v e. _V |-> |^| ( mzPolyCld ` v ) ) $.
  $}

  ${
    $d V v p f g a b c $.  $d V v p i a b c $.  $d V v p j x a b c $.
    $( Substitution lemma for ` mzPolyCld ` .  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    mzpclval $p |- ( V e. _V -> ( mzPolyCld ` V ) =
      { p e. ~P ( ZZ ^m ( ZZ ^m V ) ) |
        ( ( A. i e. ZZ ( ( ZZ ^m V ) X. { i } ) e. p
           /\ A. j e. V ( x e. ( ZZ ^m V ) |-> ( x ` j ) ) e. p )
    /\ A. f e. p A. g e. p ( ( f oF + g ) e. p /\ ( f oF x. g ) e. p ) ) } ) $=
      ( vv va vc vb cz cv cmap co wcel wral cmpt wa eleq1d csn cxp cfv cof cmul
      caddc cpw crab cvv cmzpcl wceq oveq2 oveq2d pweqd xpeq1d ralbidv weq sneq
      xpeq2d cbvralv syl6bb mpteq1d fveq2 mpteq2dv fveq1 cbvmptv eleq1i anbi12d
      raleqbi1dv anbi1d rabeqbidv df-mzpcl ovex pwex rabex fvmpt ) HFLHMZNOZIMZ
      UAZUBZGMZPZILQZJVRKMZJMZUCZRZWBPZKVQQZSZBMZCMZUFUDOWBPWLWMUEUDOWBPSCWBQBW
      BQZSZGLVRNOZUGZUHLFNOZDMZUAZUBZWBPZDLQZAWREMZAMZUCZRZWBPZEFQZSZWNSZGLWRNO
      ZUGZUHUIUJVQFUKZWOXKGWQXMXNWPXLXNVRWRLNVQFLNULZUMUNXNWKXJWNXNWDXCWJXIXNWD
      WRVTUBZWBPZILQXCXNWCXQILXNWAXPWBXNVRWRVTXOUOTUPXQXBIDLIDUQZXPXAWBXRVTWTWR
      VSWSURUSTUTVAXNWJJWRWGRZWBPZKFQXIWIXTKVQFXNWHXSWBXNJVRWRWGXOVBTVIXTXHKEFK
      EUQZXTJWRXDWFUCZRZWBPXHYAXSYCWBYAJWRWGYBWEXDWFVCVDTYCXGWBJAWRYBXFXDWFXEVE
      VFVGVAUTVAVHVJVKJHBCIKGVLXKGXMXLLWRNVMVNVOVP $.
  $}

  ${
    $d V v p f g $.  $d V v p i $.  $d V v p j x $.  $d P v p f g $.
    $d P v p i $.  $d P v p j x $.
    $( Double substitution lemma for ` mzPolyCld ` .  (Contributed by Stefan
       O'Rear, 4-Oct-2014.) $)
    elmzpcl $p |- ( V e. _V -> ( P e. ( mzPolyCld ` V ) <->
        ( P C_ ( ZZ ^m ( ZZ ^m V ) )
       /\ ( ( A. i e. ZZ ( ( ZZ ^m V ) X. { i } ) e. P
           /\ A. j e. V ( x e. ( ZZ ^m V ) |-> ( x ` j ) ) e. P )
        /\ A. f e. P A. g e. P ( ( f oF + g ) e. P /\ ( f oF x. g ) e. P ) ) )
        ) ) $=
      ( vp wcel cfv cz cmap co cv wral wa cof eleq2 ralbidv anbi12d cvv csn cxp
      cmzpcl cmpt caddc cmul cpw crab wss mzpclval eleq2d wceq raleqbi1dv elrab
      ovex elpw2 anbi1i bitri syl6bb ) GUAIZBGUDJZIBKGLMZENUBUCZHNZIZEKOZAVCFNA
      NJUEZVEIZFGOZPZCNZDNZUFQMZVEIZVLVMUGQMZVEIZPZDVEOZCVEOZPZHKVCLMZUHZUIZIZB
      WBUJZVDBIZEKOZVHBIZFGOZPZVNBIZVPBIZPZDBOZCBOZPZPZVAVBWDBACDEFGHUKULWEBWCI
      ZWQPWRWAWQHBWCVEBUMZVKWKVTWPWTVGWHVJWJWTVFWGEKVEBVDRSWTVIWIFGVEBVHRSTVSWO
      CVEBVRWNDVEBWTVOWLVQWMVEBVNRVEBVPRTUNUNTUOWSWFWQBWBKVCLUPUQURUSUT $.
  $}

  ${
    $d V v p f g a b $.  $d P v p f g a b $.  $d F v p f g a b $.
    $d G v p f g a b $.
    $( The set of all functions with the signature of a polynomial is a
       polynomially closed set.  This is a lemma to show that the intersection
       in ~ df-mzp is well-defined.  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    mzpclall $p |- ( V e. _V -> ( ZZ ^m ( ZZ ^m V ) ) e. ( mzPolyCld ` V ) ) $=
      ( vv vf vg va vb cz cv cmap co cmzpcl cfv wcel cvv wral wa caddc wf elmap
      zex wceq oveq2 fveq2 eleq12d wss csn cxp cmpt cof cmul ssid ovex constmap
      oveq2d rgen ffvelrn sylanb ancoms fmptd sylibr pm3.2i zaddcl adantl simpl
      vex eqid simpr a1i inidm off zmulcl jca anbi12i 3imtr4i rgen2a wb elmzpcl
      ax-mp mpbir2an vtoclg ) GGBHZIJZIJZWAKLZMZGGAIJZIJZAKLZMBANWAAUAZWCWGWDWH
      WIWBWFGIWAAGIUBUNWAAKUCUDWEWCWCUEZWBCHZUFUGWCMZCGOZDWBWKDHZLZUHZWCMZCWAOZ
      PZWKWNQUIJZWCMZWKWNUJUIJZWCMZPZDWCOCWCOZPZWCUKWSXEWMWRWLCGWBWKGGWAIULZTUM
      UOWQCWAWKWAMZWBGWPRWQXHDWBWOGWPWNWBMZXHWOGMZXIWAGWNRXHXJGWAWNTBVEZSWAGWKW
      NUPUQURWPVFUSGWBWPTXGSUTUOVAXDCDWCWBGWKRZWBGWNRZPZWBGWTRZWBGXBRZPWKWCMZWN
      WCMZPXDXNXOXPXNEFWBWBWBQGGGWKWNNNEHZGMFHZGMPZXSXTQJGMXNXSXTVBVCXLXMVDZXLX
      MVGZWBNMXNXGVHZYDWBVIZVJXNEFWBWBWBUJGGGWKWNNNYAXSXTUJJGMXNXSXTVKVCYBYCYDY
      DYEVJVLXQXLXRXMGWBWKTXGSGWBWNTXGSVMXAXOXCXPGWBWTTXGSGWBXBTXGSVMVNVOVAWANM
      WEWJXFPVPXKDWCCDCCWAVQVRVSVT $.

    $( Corrolary of ~ mzpclall :  Polynomially closed function sets are not
       empty.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
    mzpcln0 $p |- ( V e. _V -> ( mzPolyCld ` V ) =/= (/) ) $=
      ( cvv wcel cz cmap co cmzpcl cfv c0 wne mzpclall ne0i syl ) ABCDDAEFEFZAG
      HZCOIJAKONLM $.

    $( Defining property 1 of a polynomially closed function set ` P ` : it
       contains all constant functions.  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    mzpcl1 $p |- ( ( P e. ( mzPolyCld ` V ) /\ F e. ZZ ) ->
      ( ( ZZ ^m V ) X. { F } ) e. P ) $=
      ( vf vg cmzpcl cfv wcel cz wa cmap co cv csn cxp wral simpr wss cof syl
      cmpt caddc cmul simpl cvv elfvex adantr elmzpcl mpbid simprll wceq xpeq2d
      wb sneq eleq1d rspcva syl2anc ) ACFGHZBIHZJZUSICKLZDMZNZOZAHZDIPZVABNZOZA
      HZURUSQUTAIVAKLRZVFEVAVBEMZGUAAHDCPZJVBVKUBSLAHVBVKUCSLAHJEAPDAPZJJZVFUTU
      RVNURUSUDUTCUEHZURVNUMURVOUSACFUFUGEADEDDCUHTUIVJVFVLVMUJTVEVIDBIVBBUKZVD
      VHAVPVCVGVAVBBUNULUOUPUQ $.

    $( Defining property 2 of a polynomially closed function set ` P ` : it
       contains all projections.  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    mzpcl2 $p |- ( ( P e. ( mzPolyCld ` V ) /\ F e. V ) ->
      ( g e. ( ZZ ^m V ) |-> ( g ` F ) ) e. P ) $=
      ( vf cmzpcl cfv wcel wa cz cmap co cv cmpt wral simpr wss csn cof syl cxp
      caddc cmul simpl cvv wb elfvex adantr elmzpcl mpbid simprlr wceq mpteq2dv
      fveq2 eleq1d rspcva syl2anc ) ADFGHZCDHZIZUSBJDKLZEMZBMZGZNZAHZEDOZBVACVC
      GZNZAHZURUSPUTAJVAKLQZVAVBRUAAHEJOZVGIVBVCUBSLAHVBVCUCSLAHIBAOEAOZIIZVGUT
      URVNURUSUDUTDUEHZURVNUFURVOUSADFUGUHBAEBEEDUITUJVKVLVGVMUKTVFVJECDVBCULZV
      EVIAVPBVAVDVHVBCVCUNUMUOUPUQ $.

    $( Defining properties 3 and 4 of a polynomially closed function set
       ` P ` : it is closed under pointwise addition and multiplication.
       (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
    mzpcl34 $p |- ( ( P e. ( mzPolyCld ` V ) /\ F e. P /\ G e. P ) ->
      ( ( F oF + G ) e. P /\ ( F oF x. G ) e. P ) ) $=
      ( vf vg cmzpcl cfv wcel cv cof co wa wral cz cmap syl wceq oveq1 eleq1d
      w3a caddc cmul simp2 simp3 wss csn cxp simp1 cvv wb elfvexd elmzpcl mpbid
      cmpt simprr anbi12d oveq2 rspc2va syl21anc ) ADGHIZBAIZCAIZUAZVBVCEJZFJZU
      BKZLZAIZVEVFUCKZLZAIZMZFANEANZBCVGLZAIZBCVJLZAIZMZVAVBVCUDVAVBVCUEVDAOODP
      LZPLUFZVTVEUGUHAIEONFVTVEVFHUOAIEDNMZVNMMZVNVDVAWCVAVBVCUIZVDDUJIVAWCUKVD
      AGDWDULFAEFEEDUMQUNWAWBVNUPQVMVSBVFVGLZAIZBVFVJLZAIZMEFBCAAVEBRZVIWFVLWHW
      IVHWEAVEBVFVGSTWIVKWGAVEBVFVJSTUQVFCRZWFVPWHVRWJWEVOAVFCBVGURTWJWGVQAVFCB
      VJURTUQUSUT $.
  $}

  ${
    $d V v p f g a b $.
    $( Value of the ` mzPoly ` function.  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    mzpval $p |- ( V e. _V -> ( mzPoly ` V ) = |^| ( mzPolyCld ` V ) ) $=
      ( vv cvv wcel cmzpcl cfv cint cmzp wceq c0 wne mzpcln0 intex sylib inteqd
      cv fveq2 df-mzp fvmptg mpdan ) ACDZAEFZGZCDZAHFUCIUAUBJKUDALUBMNBABPZEFZG
      UCCCHUEAIUFUBUEAEQOBRST $.

    $( ` mzPoly ` is defined for all index sets which are sets.  This is used
       with ~ elfvdm to eliminate sethood antecedents.  (Contributed by Stefan
       O'Rear, 4-Oct-2014.) $)
    dmmzp $p |- dom mzPoly = _V $=
      ( vv cmzp cdm cvv cv cmzpcl cfv cint cmpt df-mzp dmeqi wcel dmmptg c0 wne
      wceq mzpcln0 intex sylib mprg eqtri ) BCADAEZFGZHZIZCZDBUEAJKUDDLZUFDPADA
      DUDDMUBDLUCNOUGUBQUCRSTUA $.

    $( Polynomial closedness is a universal first-order property and passes to
       intersections.  This is where the closure properties of the polynomial
       ring itself are proved.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
    mzpincl $p |- ( V e. _V -> ( mzPoly ` V ) e. ( mzPolyCld ` V ) ) $=
      ( vf vg va wcel cfv cz cmap co cv wral cof simpr simplr syl2anc ralrimiva
      wa ovex elint2 sylibr cvv cmzp cmzpcl cint mzpval wss csn cmpt caddc cmul
      cxp mzpclall intss1 syl mzpcl1 snex xpex mzpcl2 jca wi vex mzpcl34 3expib
      mptex ralimia r19.26 3imtr3i syl2anb anbi12i a1i ralrimivv elmzpcl mpbird
      jca32 eqeltrd ) AUAEZAUBFAUCFZUDZVQAUEVPVRVQEVRGGAHIZHIZUFZVSBJZUGZUKZVRE
      ZBGKZCVSWBCJZFZUHZVREZBAKZQZWBWGUILZIZVREZWBWGUJLZIZVREZQZCVRKBVRKZQQVPWA
      WLWTVPVTVQEWAAULVTVQUMUNVPWFWKVPWEBGVPWBGEZQZWDDJZEZDVQKWEXBXDDVQXBXCVQEZ
      QXEXAXDXBXEMVPXAXENXCWBAUOOPDWDVQVSWCGAHRZWBUPUQSTPVPWJBAVPWBAEZQZWIXCEZD
      VQKWJXHXIDVQXHXEQXEXGXIXHXEMVPXGXENXCCWBAUROPDWIVQCVSWHXFVDSTPUSVPWSBCVRV
      RWBVREZWGVREZQZWSUTVPXLWNXCEZDVQKZWQXCEZDVQKZQZWSXJWBXCEZDVQKZWGXCEZDVQKZ
      XQXKDWBVQBVASDWGVQCVASXRXTQZDVQKXMXOQZDVQKXSYAQXQYBYCDVQXEXRXTYCXCWBWGAVB
      VCVEXRXTDVQVFXMXODVQVFVGVHWOXNWRXPDWNVQWBWGWMRSDWQVQWBWGWPRSVITVJVKVNCVRB
      CBBAVLVMVO $.
  $}

  $( Constant functions are polynomial.  See also ~ mzpconstmpt .  (Contributed
     by Stefan O'Rear, 4-Oct-2014.) $)
  mzpconst $p |- ( ( V e. _V /\ C e. ZZ ) ->
    ( ( ZZ ^m V ) X. { C } ) e. ( mzPoly ` V ) ) $=
    ( cvv wcel cmzp cfv cmzpcl cz cmap co csn cxp mzpincl mzpcl1 sylan ) BCDBEF
    ZBGFDAHDHBIJAKLPDBMPABNO $.

  $( A polynomial function is a function from the coordinate space to the
     integers.  (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
  mzpf $p |- ( F e. ( mzPoly ` V ) -> F : ( ZZ ^m V ) --> ZZ ) $=
    ( cmzp cfv wcel cz cmap co wf cvv elfvex cmzpcl cint mzpval mzpclall intss1
    wss syl eqsstrd sselda anidms zex ovex elmap sylib ) ABCDZEZAFFBGHZGHZEZUHF
    AIUGUJUGUFUIAUGBJEZUFUIQABCKUKUFBLDZMZUIBNUKUIULEUMUIQBOUIULPRSRTUAFUHAUBFB
    GUCUDUE $.

  ${
    $d X g $.  $d V g $.
    $( A projection function is polynomial.  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    mzpproj $p |- ( ( V e. _V /\ X e. V ) -> ( g e. ( ZZ ^m V ) |-> ( g ` X ) )
        e. ( mzPoly ` V ) ) $=
      ( cvv wcel cmzp cfv cmzpcl cz cmap co cv cmpt mzpincl mzpcl2 sylan ) BDEB
      FGZBHGECBEAIBJKCALGMQEBNQACBOP $.
  $}

  $( The pointwise sum of two polynomial functions is a polynomial function.
     See also ~ mzpaddmpt .  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
  mzpadd $p |- ( ( A e. ( mzPoly ` V ) /\ B e. ( mzPoly ` V ) ) ->
    ( A oF + B ) e. ( mzPoly ` V ) ) $=
    ( cmzp cfv wcel caddc cof cmul cmzpcl cvv elfvex adantr mzpincl syl mzpcl34
    wa co 3expib mpcom simpld ) ACDEZFZBUBFZQZABGHRUBFZABIHRUBFZUBCJEFZUEUFUGQZ
    UECKFZUHUCUJUDACDLMCNOUHUCUDUIUBABCPSTUA $.

  $( The pointwise product of two polynomial functions is a polynomial
     function.  See also ~ mzpmulmpt .  (Contributed by Stefan O'Rear,
     4-Oct-2014.) $)
  mzpmul $p |- ( ( A e. ( mzPoly ` V ) /\ B e. ( mzPoly ` V ) ) ->
    ( A oF x. B ) e. ( mzPoly ` V ) ) $=
    ( cmzp cfv wcel caddc cof cmul cmzpcl cvv elfvex adantr mzpincl syl mzpcl34
    wa co 3expib mpcom simprd ) ACDEZFZBUBFZQZABGHRUBFZABIHRUBFZUBCJEFZUEUFUGQZ
    UECKFZUHUCUJUDACDLMCNOUHUCUDUIUBABCPSTUA $.

  ${
    $d V x a b $.  $d C x $.  $d D x a b $.  $d A a b $.

    $( A constant function expressed in maps-to notation is polynomial.  This
       theorem and the several that follow ( ~ mzpaddmpt , ~ mzpmulmpt ,
       ~ mzpnegmpt , ~ mzpsubmpt , ~ mzpexpmpt ) can be used to build proofs
       that functions which are "manifestly polynomial", in the sense of being
       a maps-to containing constants, projections, and simple arithmetic
       operations, are actually polynomial functions.  There is no mzpprojmpt
       because ~ mzpproj is already expressed using maps-to notation.
       (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    mzpconstmpt $p |- ( ( V e. _V /\ C e. ZZ ) ->
      ( x e. ( ZZ ^m V ) |-> C ) e. ( mzPoly ` V ) ) $=
      ( cvv wcel cz wa cmap cmpt csn cxp cmzp cfv fconstmpt mzpconst syl5eqelr
      co ) CDEBFEGAFCHQZBIRBJKCLMARBNBCOP $.

    $( Sum of polynomial functions is polynomial.  Maps-to version of
       ~ mzpadd .  (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    mzpaddmpt $p |- ( ( ( x e. ( ZZ ^m V ) |-> A ) e. ( mzPoly ` V ) /\ ( x e.
        ( ZZ ^m V ) |-> B ) e. ( mzPoly ` V ) ) ->
        ( x e. ( ZZ ^m V ) |-> ( A + B ) ) e. ( mzPoly ` V ) ) $=
      ( cz cmap co cmpt cmzp cfv wcel wa caddc cof wfn wf mzpf ffn syl cvv wceq
      ovex ofmpteq mp3an1 syl2an mzpadd eqeltrrd ) AEDFGZBHZDIJZKZAUHCHZUJKZLUI
      ULMNGZAUHBCMGHZUJUKUIUHOZULUHOZUNUOUAZUMUKUHEUIPUPUIDQUHEUIRSUMUHEULPUQUL
      DQUHEULRSUHTKUPUQUREDFUBAUHBCMTUCUDUEUIULDUFUG $.

    $( Product of polynomial functions is polynomial.  Maps-to version of
       ~ mzpmulmpt .  (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    mzpmulmpt $p |- ( ( ( x e. ( ZZ ^m V ) |-> A ) e. ( mzPoly ` V ) /\
      ( x e. ( ZZ ^m V ) |-> B ) e. ( mzPoly ` V ) ) ->
        ( x e. ( ZZ ^m V ) |-> ( A x. B ) ) e. ( mzPoly ` V ) ) $=
      ( cz cmap co cmpt cmzp cfv wcel wa cmul cof wfn wf mzpf ffn syl cvv wceq
      ovex ofmpteq mp3an1 syl2an mzpmul eqeltrrd ) AEDFGZBHZDIJZKZAUHCHZUJKZLUI
      ULMNGZAUHBCMGHZUJUKUIUHOZULUHOZUNUOUAZUMUKUHEUIPUPUIDQUHEUIRSUMUHEULPUQUL
      DQUHEULRSUHTKUPUQUREDFUBAUHBCMTUCUDUEUIULDUFUG $.

    ${
      $d B a $.
      $( The difference of two polynomial functions is polynomial.
         (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
      mzpsubmpt $p |- ( ( ( x e. ( ZZ ^m V ) |-> A ) e. ( mzPoly ` V ) /\
        ( x e. ( ZZ ^m V ) |-> B ) e. ( mzPoly ` V ) ) ->
          ( x e. ( ZZ ^m V ) |-> ( A - B ) ) e. ( mzPoly ` V ) ) $=
        ( cz co cmpt cmzp wcel wa cneg caddc nfmpt1 nfel1 mzpf mptfcl sylc zcnd
        c1 wf cmap cfv cmin cmul nfan cv ad2antlr simpr mulm1d ad2antrr negsubd
        oveq2d eqtr2d mpteq2da elfvex 1nn0 nn0negzi mzpconstmpt sylancl mpancom
        cvv mzpmulmpt mzpaddmpt sylan2 eqeltrd ) AEDUAFZBGZDHUBZIZAVFCGZVHIZJZA
        VFBCUCFZGAVFBSKZCUDFZLFZGZVHVLAVFVMVPVIVKAAVGVHAVFBMNAVJVHAVFCMNUEVLAUF
        VFIZJZVPBCKZLFVMVSVOVTBLVSCVSCVSVFEVJTZVRCEIVKWAVIVRVJDOUGVLVRUHZAVFCEP
        QRZUIULVSBCVSBVSVFEVGTZVRBEIVIWDVKVRVGDOUJWBAVFBEPQRWCUKUMUNVKVIAVFVOGV
        HIZVQVHIAVFVNGVHIZVKWEVKDVAIVNEIWFVJDHUOSUPUQAVNDURUSAVNCDVBUTABVODVCVD
        VE $.
    $}

    $( Negation of a polynomial function.  (Contributed by Stefan O'Rear,
       11-Oct-2014.) $)
    mzpnegmpt $p |- ( ( x e. ( ZZ ^m V ) |-> A ) e. ( mzPoly ` V ) ->
        ( x e. ( ZZ ^m V ) |-> -u A ) e. ( mzPoly ` V ) ) $=
      ( cz cmap cmpt cmzp cfv wcel cneg cc0 cmin df-neg mpteq2i cvv mzpconstmpt
      co elfvex 0z sylancl mzpsubmpt mpancom syl5eqel ) ADCEQZBFZCGHZIZAUDBJZFA
      UDKBLQZFZUFAUDUHUIBMNAUDKFUFIZUGUJUFIUGCOIKDIUKUECGRSAKCPTAKBCUAUBUC $.

    $( Raise a polynomial function to a (fixed) exponent.  (Contributed by
       Stefan O'Rear, 5-Oct-2014.) $)
    mzpexpmpt $p |- ( ( ( x e. ( ZZ ^m V ) |-> A ) e. ( mzPoly ` V ) /\
        D e. NN0 ) -> ( x e. ( ZZ ^m V ) |-> ( A ^ D ) ) e. ( mzPoly ` V ) ) $=
      ( wcel cz co cmpt cexp cv wi cc0 c1 wceq oveq2 mpteq2dv eleq1d imbi2d cc
      wa va vb cn0 cmap cmzp cfv caddc wral wf wss mzpf zsscn sylancl eqid fmpt
      fss sylibr nfra1 rsp imp exp0d mpteq2da syl elfvex 1z mzpconstmpt eqeltrd
      cvv w3a cmul 3ad2ant2 simp1 nfv adantlr simplr expp1d syl2anc simp3 simp2
      nfan mzpmulmpt 3exp a2d nn0ind impcom ) CUCEAFDUDGZBHZDUEUFZEZAWFBCIGZHZW
      HEZWIAWFBUAJZIGZHZWHEZKWIAWFBLIGZHZWHEZKWIAWFBUBJZIGZHZWHEZKWIAWFBWTMUGGZ
      IGZHZWHEZKWIWLKUAUBCWMLNZWPWSWIXHWOWRWHXHAWFWNWQWMLBIOPQRWMWTNZWPXCWIXIWO
      XBWHXIAWFWNXAWMWTBIOPQRWMXDNZWPXGWIXJWOXFWHXJAWFWNXEWMXDBIOPQRWMCNZWPWLWI
      XKWOWKWHXKAWFWNWJWMCBIOPQRWIWRAWFMHZWHWIBSEZAWFUHZWRXLNWIWFSWGUIZXNWIWFFW
      GUIFSUJXOWGDUKULWFFSWGUPUMAWFSBWGWGUNUOUQZXNAWFWQMXMAWFURZXNAJWFEZTBXNXRX
      MXMAWFUSUTZVAVBVCWIDVHEMFEXLWHEWGDUEVDVEAMDVFUMVGWTUCEZWIXCXGXTWIXCXGXTWI
      XCVIZXFAWFXABVJGZHZWHYAXNXTXFYCNWIXTXNXCXPVKXTWIXCVLXNXTTZAWFXEYBXNXTAXQX
      TAVMVTYDXRTBWTXNXRXMXTXSVNXNXTXRVOVPVBVQYAXCWIYCWHEXTWIXCVRXTWIXCVSAXABDW
      AVQVGWBWCWDWE $.

  $}

  ${
    $d ph x f g $.  $d ps f g $.  $d ch x $.  $d th x $.  $d ta x $.
    $d et x $.  $d ze x $.  $d si x $.  $d rh x $.  $d V x f g a b $.
    $d A x $.
    mzpindd.co $e |- ( ( ph /\ f e. ZZ ) -> ch ) $.
    mzpindd.pr $e |- ( ( ph /\ f e. V ) -> th ) $.
    mzpindd.ad $e |- ( ( ph /\ ( f : ( ZZ ^m V ) --> ZZ /\ ta ) /\ ( g : ( ZZ
        ^m V ) --> ZZ /\ et ) ) -> ze ) $.
    mzpindd.mu $e |- ( ( ph /\ ( f : ( ZZ ^m V ) --> ZZ /\ ta ) /\ ( g : ( ZZ
        ^m V ) --> ZZ /\ et ) ) -> si ) $.
    mzpindd.1 $e |- ( x = ( ( ZZ ^m V ) X. { f } ) -> ( ps <-> ch ) ) $.
    mzpindd.2 $e |- ( x = ( g e. ( ZZ ^m V ) |-> ( g ` f ) ) -> ( ps <-> th ) )
        $.
    mzpindd.3 $e |- ( x = f -> ( ps <-> ta ) ) $.
    mzpindd.4 $e |- ( x = g -> ( ps <-> et ) ) $.
    mzpindd.5 $e |- ( x = ( f oF + g ) -> ( ps <-> ze ) ) $.
    mzpindd.6 $e |- ( x = ( f oF x. g ) -> ( ps <-> si ) ) $.
    mzpindd.7 $e |- ( x = A -> ( ps <-> rh ) ) $.
    $( "Structural" induction to prove properties of all polynomial functions.
       (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
    mzpindd $p |- ( ( ph /\ A e. ( mzPoly ` V ) ) -> rh ) $=
      ( va vb cmzp cfv wcel wa cz cmap co crab elfvex adantl cmzpcl cint mzpval
      cvv wceq wss cv csn cxp wral cmpt caddc cof cmul ssrab2 a1i ovex constmap
      zex elrab sylanbrc ralrimiva adantr wf simpllr simpr elmapg biimpa simplr
      syl21anc ffvelrnd eqid fmptd elmap sylibr jca zaddcl simpl inidm ad2ant2r
      adantlr 3expb zmulcl jca32 ex anbi1i anbi12i 3imtr4g ralrimivv wb elmzpcl
      off mpbird intss1 syl eqsstrd sselda an32s mpdan simprbi ) AKNUHUIZUJZUKZ
      KBJULULNUMUNZUMUNZUOZUJZIXTNVAUJZYDXSYEAKNUHUPUQAYEXSYDAYEUKZXRYCKYFXRNUR
      UIZUSZYCYEXRYHVBANUTUQYFYCYGUJZYHYCVCYFYIYCYBVCZYALVDZVEVFZYCUJZLULVGZMYA
      YKMVDZUIZVHZYCUJZLNVGZUKZYKYOVIVJUNZYCUJZYKYOVKVJUNZYCUJZUKZMYCVGLYCVGZUK
      UKZYFYJYTUUFYJYFBJYBVLVMYFYNYSAYNYEAYMLULAYKULUJZUKYLYBUJZCYMUUHUUIAYAYKU
      LULNUMVNZVPVOUQOBCJYLYBSVQVRVSVTYFYRLNYFYKNUJZUKZYQYBUJZDYRUULYAULYQWAUUM
      UULMYAYPULYQUULYOYAUJZUKZNULYKYOUUOULVAUJZYEUUNNULYOWAZUUPUUOVPVMAYEUUKUU
      NWBUULUUNWCUUPYEUKUUNUUQULNYOVAVAWDWEWGYFUUKUUNWFWHYQWIWJULYAYQVPUUJWKWLA
      UUKDYEPWRBDJYQYBTVQVRVSWMAUUFYEAUUELMYCYCAYKYBUJZEUKZYOYBUJZFUKZUKZUUAYBU
      JZGUKZUUCYBUJZHUKZUKZYKYCUJZYOYCUJZUKUUEAYAULYKWAZEUKZYAULYOWAZFUKZUKZYAU
      LUUAWAZGUKZYAULUUCWAZHUKZUKZUVBUVGAUVNUVSAUVNUKZUVPUVQHUVTUVOGUVNUVOAUVJU
      VLUVOEFUVJUVLUKZUFUGYAYAYAVIULULULYKYOVAVAUFVDZULUJUGVDZULUJUKZUWBUWCVIUN
      ULUJUWAUWBUWCWNUQUVJUVLWOZUVJUVLWCZYAVAUJUWAUUJVMZUWGYAWPZXIWQUQAUVKUVMGQ
      WSWMUVNUVQAUVJUVLUVQEFUWAUFUGYAYAYAVKULULULYKYOVAVAUWDUWBUWCVKUNULUJUWAUW
      BUWCWTUQUWEUWFUWGUWGUWHXIWQUQAUVKUVMHRWSXAXBUUSUVKUVAUVMUURUVJEULYAYKVPUU
      JWKXCUUTUVLFULYAYOVPUUJWKXCXDUVDUVPUVFUVRUVCUVOGULYAUUAVPUUJWKXCUVEUVQHUL
      YAUUCVPUUJWKXCXDXEUVHUUSUVIUVABEJYKYBUAVQBFJYOYBUBVQXDUUBUVDUUDUVFBGJUUAY
      BUCVQBHJUUCYBUDVQXDXEXFVTXAYEYIUUGXGAMYCLMLLNXHUQXJYCYGXKXLXMXNXOXPYDKYBU
      JIBIJKYBUEVQXQXL $.
  $}

  ${
    $d I a b x y $.  $d I f g $.  $d b f g $.
    $( Relationship between multivariate Z-polynomials and general multivariate
       polynomial functions.  (Contributed by Stefan O'Rear, 20-Mar-2015.) $)
    mzpmfp $p |- ( mzPoly ` I ) = ran ( I eval ( CCfld |`s ZZ ) ) $=
      ( va vb vg vy cvv wcel cfv ccnfld cz co wceq cv caddc cmul wa a1i syl2anc
      ax-mp eleq1 vf vx cmzp cress cevl crn cmap csn cxp cmpt cof wss cbs zsscn
      cc eqid cnfldbas ressbas2 evlval rneqi simpl ccrg csubrg cncrng subrgcrng
      ces zsubrg mp2an subrgrng subrgid simpr mpfconst mpfproj wf simp2r simp3r
      crg w3a cplusg zex cnfldadd ressplusg mpfaddcl cnfldmul ressmulr mpfmulcl
      cmulr mzpindd simprlr simprrr mzpadd mzpmul mzpconst adantlr mpfind eqrdv
      mzpproj impbida wn fvprc df-evl reldmmpt2 ovprc1 rneqd rn0 syl6eq pm2.61i
      c0 eqtr4d ) AFGZAUCHZAIJUDKZUEKZUFZLXJBXKXNXJBMZXKGZXOXNGZXJCMZXNGJAUGKZU
      AMZUHUIZXNGDXSXTDMZHUJZXNGXTXNGZYBXNGZXTYBNUKZKZXNGZXTYBOUKZKZXNGZXQCXOUA
      DAXJXTJGZPZJXNJXLAFXTJUOULJXLUMHLUNJUOXLIXLUPZUQURSZXMJAXLVFKHJXMXLAXMUPY
      OUSUTZXJYLVAXLVBGZYMIVBGJIVCHGZYQVDVGJIXLYNVEVHZQJXLVCHGZYMXLVQGZYTYRUUAV
      GJIXLYNVISJXLYOVJSZQXJYLVKVLXJXTAGZPZJXNJXLDAXTFYOYPXJUUCVAYQUUDYSQYTUUDU
      UBQXJUUCVKVMXJXSJXTVNZYDPZXSJYBVNZYEPZVRZYDYEYHXJUUEYDUUHVOZXJUUFUUGYEVPZ
      NXNJXLXTYBAYPJFGZNXLVSHLVTJNIXLFYNWAWBSZWCRUUIYDYEYKUUJUUKXNJXLOXTYBAYPUU
      LOXLWGHLVTJIXLOFYNWDWESZWFRXRYAXNTXRYCXNTXRXTXNTXRYBXNTXRYGXNTXRYJXNTXRXO
      XNTWHXJXQPZXRXKGXSUBMZUHUIZXKGZEXSUUPEMZHUJZXKGZUUPXKGZUUSXKGZUUPUUSYFKZX
      KGZUUPUUSYIKZXKGZXPCXOJNXNJXLOUBEAYOUUMUUNYPUUOUUPXNGZUVBPZUUSXNGZUVCPZPP
      ZUVBUVCUVEUUOUVHUVBUVKWIZUUOUVIUVJUVCWJZUUPUUSAWKRUVLUVBUVCUVGUVMUVNUUPUU
      SAWLRXRUUQXKTXRUUTXKTXRUUPXKTXRUUSXKTXRUVDXKTXRUVFXKTXRXOXKTXJUUPJGUURXQU
      UPAWMWNXJUUPAGUVAXQEAUUPWQWNXJXQVKWOWRWPXJWSZXKXHXNAUCWTUVOXNXHUFXHUVOXMX
      HAXLUEBCFFXRUMHXOXRVFKHUEBCXAXBXCXDXEXFXIXG $.
  $}

  ${
    $d W a b c x y $.  $d F a b c x $.  $d V a b c x y $.  $d G a b c x $.

    $( Substituting polynomials for the variables of a polynomial results in a
       polynomial. ` G ` is expected to depend on ` y ` and provide the
       polynomials which are being substituted.  (Contributed by Stefan O'Rear,
       5-Oct-2014.) $)
    mzpsubst $p |- ( ( W e. _V /\ F e. ( mzPoly ` V ) /\ A. y e. V G e. (
        mzPoly ` W ) ) ->
        ( x e. ( ZZ ^m W ) |-> ( F ` ( y e. V |-> ( G ` x ) ) ) ) e. ( mzPoly `
        W ) ) $=
      ( va cvv wcel cfv cz co cv cmpt wa wceq simpr fveq1 eleq1d mpteq2dv vb vc
      cmzp wral w3a simp1 elfvex 3ad2ant2 simp3 simp2 csn cxp caddc cof simpll3
      cmap cmul simpll2 wf mzpf ffvelrnda expcom ralimdv eqid fmpt sylib adantr
      imp zex elmapg sylancr mpbird syl21anc vex fvconst2 mpteq2dva mzpconstmpt
      wb syl 3ad2antl1 eqeltrd csb fvex fvmpt simplr csbeq1 fveq1d nfcv nfcsb1v
      nffv csbeq1a cbvmpt fvmptg sylancl eqtrd simpl3 nfel1 rspc feqmptd eqtr4d
      sylc wfn simp2l ffn simp3l simp13 simp12 simplll simpllr ovex a1i simplrl
      simplrr fnfvof syl22anc simp2r simp3r mzpaddmpt syl2anc mzpmulmpt mzpindd
      syl31anc ) FHIZCEUCJIZDFUCJZIZBEUDZUEYCEHIZYGYDAKFUPLZBEAMZDJZNZCJZNZYEIZ
      YCYDYGUFYDYCYHYGCEUCUGUHYCYDYGUIYCYDYGUJYCYHYGUEZAYIYLGMZJZNZYEIAYIYLKEUP
      LZUAMZUKULZJZNZYEIAYIYLUBYTUUAUBMZJZNZJZNZYEIAYIYLUUAJZNZYEIZAYIYLUUEJZNZ
      YEIZAYIYLUUAUUEUMUNLZJZNZYEIAYIYLUUAUUEUQUNLZJZNZYEIYOGCUAUBEYPUUAKIZOZUU
      DAYIUUANZYEUVCAYIUUCUUAUVCYJYIIZOZYLYTIZUUCUUAPUVFUVEYGYHUVGUVCUVEQYCYHYG
      UVBUVEUOYCYHYGUVBUVEURUVEYGOZYHOZUVGEKYLUSZUVHUVJYHUVHYKKIZBEUDZUVJUVEYGU
      VLUVEYFUVKBEYFUVEUVKYFYIKYJDDFUTVAVBVCZVHBEKYKYLYLVDVEZVFVGUVIKHIZYHUVGUV
      JVRZVIUVHYHQKEYLHHVJZVKVLZVMYTUUAYLUAVNVOVSVPYCYHUVBUVDYEIYGAUUAFVQVTWAYP
      UUAEIZOZUUIBUUADWBZYEUVTUUIAYIYJUWAJZNUWAUVTAYIUUHUWBUVTUVEOZUUHUUAYLJZUW
      BUWCUVGUUHUWDPUWCUVEYGYHUVGUVTUVEQYCYHYGUVSUVEUOYCYHYGUVSUVEURUVRVMUBYLUU
      FUWDYTUUGUUAUUEYLRUUGVDUUAYLWCWDVSUWCUVSUWBHIUWDUWBPYPUVSUVEWEYJUWAWCGUUA
      YJBYQDWBZJZUWBEHYLYQUUAPZYJUWEUWABYQUUADWFWGBGEYKUWFGYKWHBYJUWEBYQDWIBYJW
      HWJBMZYQPYJDUWEBYQDWKWGWLWMWNWOVPUVTAYIKUWAUVTUWAYEIZYIKUWAUSUVTUVSYGUWIY
      PUVSQYCYHYGUVSWPYFUWIBUUAEBUWAYEBUUADWIWQUWHUUAPDUWAYEBUUADWKSWRXAZUWAFUT
      VSWSWTUWJWAYPYTKUUAUSZUULOZYTKUUEUSZUUOOZUEZUURAYIUUJUUMUMLZNZYEUWOUUAYTX
      BZUUEYTXBZYGYHUURUWQPUWOUWKUWRYPUWKUULUWNXCYTKUUAXDVSZUWOUWMUWSYPUWLUWMUU
      OXEYTKUUEXDVSZYCYHYGUWLUWNXFZYCYHYGUWLUWNXGZUWRUWSOZYGYHOZOZAYIUUQUWPUXFU
      VEOZUWRUWSYTHIZUVGUUQUWPPUWRUWSUXEUVEXHZUWRUWSUXEUVEXIZUXHUXGKEUPXJXKZUXG
      UVGUVJUXGUVLUVJUXGUVEYGUVLUXFUVEQUXDYGYHUVEXLUVMXAUVNVFUXGUVOYHUVPVIUXDYG
      YHUVEXMUVQVKVLZYTUMUUAUUEHYLXNXOVPXOUWOUULUUOUWQYEIYPUWKUULUWNXPZYPUWLUWM
      UUOXQZAUUJUUMFXRXSWAUWOUVAAYIUUJUUMUQLZNZYEUWOUWRUWSYGYHUVAUXPPUWTUXAUXBU
      XCUXFAYIUUTUXOUXGUWRUWSUXHUVGUUTUXOPUXIUXJUXKUXLYTUQUUAUUEHYLXNXOVPXOUWOU
      ULUUOUXPYEIUXMUXNAUUJUUMFXTXSWAYQUUBPZYSUUDYEUXQAYIYRUUCYLYQUUBRTSYQUUGPZ
      YSUUIYEUXRAYIYRUUHYLYQUUGRTSUWGYSUUKYEUWGAYIYRUUJYLYQUUARTSYQUUEPZYSUUNYE
      UXSAYIYRUUMYLYQUUERTSYQUUPPZYSUURYEUXTAYIYRUUQYLYQUUPRTSYQUUSPZYSUVAYEUYA
      AYIYRUUTYLYQUUSRTSYQCPZYSYNYEUYBAYIYRYMYLYQCRTSYAYB $.
  $}

  ${
    $d W x a b $.  $d F x a b $.  $d R x a b $.  $d V a x $.
    $( Simplified version of ~ mzpsubst to simply relabel variables in a
       polynomial.  (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    mzprename $p |- ( ( W e. _V /\ F e. ( mzPoly ` V ) /\ R : V --> W ) ->
        ( x e. ( ZZ ^m W ) |-> ( F ` ( x o. R ) ) ) e. ( mzPoly ` W ) ) $=
      ( va vb cvv wcel cmzp cfv wf w3a cz cv cmpt wceq wa syl2anc mpteq2dva zex
      cmap co ccom simpr wb simpll elmapg sylancr mpbid simplr fcompt eqid fvex
      fveq1 fvmpt ad2antlr eqcomd eqtrd fveq2d 3adant2 simpl1 ffvelrn 3ad2antl3
      wral mzpproj ralrimiva mzpsubst syld3an3 eqeltrd ) EHIZCDJKIZDEBLZMZANEUB
      UCZAOZBUDZCKZPZAVOFDVPGVOFOZBKZGOZKZPZKZPZCKZPZEJKZVKVMVSWHQVLVKVMRZAVOVR
      WGWJVPVOIZRZVQWFCWLVQFDWAVPKZPZWFWLENVPLZVMVQWNQWLWKWOWJWKUEWLNHIVKWKWOUF
      UAVKVMWKUGNEVPHHUHUIUJVKVMWKUKFVPBDENULSWLFDWMWEWLVTDIZRWEWMWKWEWMQWJWPGV
      PWCWMVOWDWAWBVPUOWDUMWAVPUNUPUQURTUSUTTVAVKVLVMWDWIIZFDVEWHWIIVNWQFDVNWPR
      VKWAEIZWQVKVLVMWPVBVMVKWPWRVLDEVTBVCVDGEWAVFSVGAFCWDDEVHVIVJ $.
  $}

  ${
    $d W x $.  $d F x $.  $d V x $.
    $( A polynomial is a polynomial over all larger index sets.  (Contributed
       by Stefan O'Rear, 5-Oct-2014.)  (Revised by Stefan O'Rear,
       5-Jun-2015.) $)
    mzpresrename $p |- ( ( W e. _V /\ V C_ W /\ F e. ( mzPoly ` V ) ) -> ( x e.
        ( ZZ ^m W ) |-> ( F ` ( x |` V ) ) ) e. ( mzPoly ` W ) ) $=
      ( cvv wcel wss cmzp cfv w3a cz cmap co cv cres cmpt cid ccom coires1 wf
      fveq2i mpteq2i simp1 simp3 wf1o f1oi f1of ax-mp fss mpan 3ad2ant2 syl3anc
      mzprename syl5eqelr ) DEFZCDGZBCHIFZJZAKDLMZANZCOZBIZPAUSUTQCOZRZBIZPZDHI
      ZAUSVEVBVDVABUTCSUAUBURUOUQCDVCTZVFVGFUOUPUQUCUOUPUQUDUPUOVHUQCCVCTZUPVHC
      CVCUEVICUFCCVCUGUHCCDVCUIUJUKAVCBCDUMULUN $.
  $}

  ${
    $d A a b d e f g h i j k l $.  $d B a b c d e f g h i j k l $.
    mzpcompact2lem.i $e |- B e. _V $.
    $( Lemma for ~ mzpcompact2 .  (Contributed by Stefan O'Rear,
       9-Oct-2014.) $)
    mzpcompact2lem $p |- ( A e. ( mzPoly ` B )
        -> E. a e. Fin E. b e. ( mzPoly ` a ) ( a C_ B
          /\ A = ( c e. ( ZZ ^m B ) |-> ( b ` ( c |` a ) ) ) ) ) $=
      ( vd cmzp cfv wcel cv cz co cmpt wceq wa wrex cfn c0 anbi2d ve vf vg cmap
      vh vi vj vk vl wss cres wtru tru csn cxp caddc cof cmul 0fin cvv mzpconst
      0ex 0ss a1i simpr elmapssres sylancl vex fvconst2 syl mpteq2dva fconstmpt
      syl6reqr fveq1 mpteq2dv eqeq2d rspcev syl12anc fveq2 sseq1 reseq2 anbi12d
      mpan fveq2d rexeqbidv sylancr adantl snfi snex snid mzpproj mp2an cbvmptv
      snssi simpl snssd syl2anc eqid fvmpt fvres ax-mp syl6req syl5eq wf w3a wi
      fvex simplll simprll unfi unex ssun1 simpllr mzpresrename syl3anc simprlr
      cun mzpaddmpt simplr simprr wfn ovex mzpf ffn 3syl ofmpteq reseq1 oveq12d
      ssun2 resabs1 fveq2i oveq12i eqtrd eqeq1d rexbidv 2rexbidv cbvrexv syl6bb
      eqeq1 weq unssd elmapi fssres syl2anr zex elmap sylibr mzpmulmpt adantlrr
      adantrrr simplrr simprrr mpbird r19.40 exp32 rexlimdvv rexlimivv ad2ant2l
      ex imp 3adant1 simpld simprd mzpindd eqeq2i anbi2i 2rexbii sylib ) ABHIZJ
      ZCKZBUJZAGLBUDMZGKZUVKUKZDKZIZNZOZPZDUVKHIZQCRQZUVLAEUVMEKZUVKUKZUVPIZNZO
      ZPZDUWAQCRQULUVJUWBUMULUVLUAKZUVROZPZDUWAQCRQZUVLUVMUBKZUNZUOZUVROZPZDUWA
      QZCRQZUVLUCUVMUWMUCKZIZNZUVROZPZDUWAQZCRQZUEKZBUJZUWMGUVMUVNUXGUKZUFKZIZN
      ZOZPZUFUXGHIZQZUERQZUGKZBUJZUWTGUVMUVNUXRUKZUHKZIZNZOZPZUHUXRHIZQZUGRQZUV
      LUWMUWTUPUQZMZUVROZPZDUWAQZCRQZUVLUWMUWTURUQZMZUVROZPZDUWAQZCRQZUWBUAAUBU
      CBUWMLJZUWSULVUASRJSBUJZUWOGUVMUVNSUKZUVPIZNZOZPZDSHIZQZUWSUSVUALSUDMZUWN
      UOZVUHJZVUBUWOGUVMVUCVUKIZNZOZVUISUTJVUAVULVBUWMSVAWCVUBVUABVCZVDVUAVUNGU
      VMUWMNUWOVUAGUVMVUMUWMVUAUVNUVMJZPZVUCVUJJZVUMUWMOVURVUQVUBVUSVUAVUQVEVUP
      UVNLBSVFVGVUJUWMVUCUBVHZVIVJVKGUVMUWMVLVMVUGVUBVUOPDVUKVUHUVPVUKOZVUFVUOV
      UBVVAVUEVUNUWOVVAGUVMVUDVUMVUCUVPVUKVNVOVPTVQVRUWRVUICSRUVKSOZUWQVUGDUWAV
      UHUVKSHVSVVBUVLVUBUWPVUFUVKSBVTVVBUVRVUEUWOVVBGUVMUVQVUDVVBUVOVUCUVPUVKSU
      VNWAWDVOVPWBWEVQWFWGUWMBJZUXFULVVCUWNRJUWNBUJZUXBGUVMUVNUWNUKZUVPIZNZOZPZ
      DUWNHIZQZUXFUWMWHVVCUCLUWNUDMZUXANZVVJJZVVDUXBGUVMVVEVVMIZNZOZVVKVVNVVCUW
      NUTJUWMUWNJZVVNUWMWIUWMVUTWJZUCUWNUWMWKWLVDUWMBWNVVCUXBGUVMUWMUVNIZNVVPUC
      GUVMUXAVVTUWMUWTUVNVNWMVVCGUVMVVTVVOVVCVUQPZVVOUWMVVEIZVVTVWAVVEVVLJZVVOV
      WBOVWAVUQVVDVWCVVCVUQVEVWAUWMBVVCVUQWOWPUVNLBUWNVFWQUCVVEUXAVWBVVLVVMUWMU
      WTVVEVNVVMWRUWMVVEXGWSVJVVRVWBVVTOVVSUWMUWNUVNWTXAXBVKXCVVIVVDVVQPDVVMVVJ
      UVPVVMOZVVHVVQVVDVWDVVGVVPUXBVWDGUVMVVFVVOVVEUVPVVMVNVOVPTVQVRUXEVVKCUWNR
      UVKUWNOZUXDVVIDUWAVVJUVKUWNHVSVWEUVLVVDUXCVVHUVKUWNBVTVWEUVRVVGUXBVWEGUVM
      UVQVVFVWEUVOVVEUVPUVKUWNUVNWAWDVOVPWBWEVQWFWGULUVMLUWMXDZUXQPZUVMLUWTXDZU
      YHPZXEZUYNUYTVWGVWIUYNUYTPZULUXQUYHVWKVWFVWHUXQUYHVWKUXNUYHVWKXFZUEUFRUXO
      UXGRJZUXJUXOJZPZUXNVWLVWOUXNPZUYEVWKUGUHRUYFVWPUXRRJZUYAUYFJZPZUYEVWKVWPV
      WSUYEPZPZUYMUYSPZCRQZVWKVXAVXCUVLUXLUYCUYIMZUVROZPZDUWAQZUVLUXLUYCUYOMZUV
      ROZPZDUWAQZPZCRQZVWPVWSUXSVXMUYDVWOUXHVWSUXSPZVXMUXMVWOUXHPZVXNPZUXGUXRXQ
      ZRJZVXQBUJZVXDGUVMUVNVXQUKZUVPIZNZOZPZDVXQHIZQZVXSVXHVYBOZPZDVYEQZVXMVXPV
      WMVWQVXRVWMVWNUXHVXNXHVXOVWQVWRUXSXIUXGUXRXJWQVXPUILVXQUDMZUIKZUXGUKZUXJI
      ZVYKUXRUKZUYAIZUPMZNZVYEJZVXSVXDGUVMVXTVYQIZNZOZVYFVXPUIVYJVYMNVYEJZUIVYJ
      VYONVYEJZVYRVXPVXQUTJZUXGVXQUJZVWNWUBWUDVXPUXGUXRUEVHUGVHXKZVDZWUEVXPUXGU
      XRXLZVDVWMVWNUXHVXNXMZUIUXJUXGVXQXNXOZVXPWUDUXRVXQUJZVWRWUCWUGWUKVXPUXRUX
      GYIZVDVXOVWQVWRUXSXPZUIUYAUXRVXQXNXOZUIVYMVYOVXQXRWQVXPUXGUXRBVWOUXHVXNXS
      ZVXOVWSUXSXTZUUAZVXPVXDGUVMUXKUYBUPMZNZVYTVXPUVMUTJZUXLUVMYAZUYCUVMYAZVXD
      WUSOWUTVXPLBUDYBVDZVXPUXLUVIJZUVMLUXLXDWVAVXPBUTJZUXHVWNWVDWVEVXPFVDZWUOW
      UIGUXJUXGBXNXOUXLBYCUVMLUXLYDYEZVXPUYCUVIJZUVMLUYCXDWVBVXPWVEUXSVWRWVHWVF
      WUPWUMGUYAUXRBXNXOUYCBYCUVMLUYCYDYEZGUVMUXKUYBUPUTYFXOVXPGUVMWURVYSVXPVUQ
      PZVYSVXTUXGUKZUXJIZVXTUXRUKZUYAIZUPMZWURWVJVXTVYJJZVYSWVOOWVJVXQLVXTXDZWV
      PVUQBLUVNXDVXSWVQVXPUVNLBUUBWUQBLVXQUVNUUCUUDLVXQVXTUUEWUFUUFUUGZUIVXTVYP
      WVOVYJVYQVYKVXTOZVYMWVLVYOWVNUPWVSVYLWVKUXJVYKVXTUXGYGWDZWVSVYNWVMUYAVYKV
      XTUXRYGWDZYHVYQWRWVLWVNUPYBWSVJWVLUXKWVNUYBUPWVKUXIUXJWUEWVKUXIOWUHUVNUXG
      VXQYJXAYKZWVMUXTUYAWUKWVMUXTOWULUVNUXRVXQYJXAYKZYLXBVKYMVYDVXSWUAPDVYQVYE
      UVPVYQOZVYCWUAVXSWWDVYBVYTVXDWWDGUVMVYAVYSVXTUVPVYQVNVOVPTVQVRVXPUIVYJVYM
      VYOURMZNZVYEJZVXSVXHGUVMVXTWWFIZNZOZVYIVXPWUBWUCWWGWUJWUNUIVYMVYOVXQUUHWQ
      WUQVXPVXHGUVMUXKUYBURMZNZWWIVXPWUTWVAWVBVXHWWLOWVCWVGWVIGUVMUXKUYBURUTYFX
      OVXPGUVMWWKWWHWVJWWHWVLWVNURMZWWKWVJWVPWWHWWMOWVRUIVXTWWEWWMVYJWWFWVSVYMW
      VLVYOWVNURWVTWWAYHWWFWRWVLWVNURYBWSVJWVLUXKWVNUYBURWWBWWCYLXBVKYMVYHVXSWW
      JPDWWFVYEUVPWWFOZVYGWWJVXSWWNVYBWWIVXHWWNGUVMVYAWWHVXTUVPWWFVNVOVPTVQVRVX
      LVYFVYIPCVXQRUVKVXQOZVXGVYFVXKVYIWWOVXFVYDDUWAVYEUVKVXQHVSZWWOUVLVXSVXEVY
      CUVKVXQBVTZWWOUVRVYBVXDWWOGUVMUVQVYAWWOUVOVXTUVPUVKVXQUVNWAWDVOZVPWBWEWWO
      VXJVYHDUWAVYEWWPWWOUVLVXSVXIVYGWWQWWOUVRVYBVXHWWRVPWBWEWBVQVRUUIUUJVXAVXB
      VXLCRVXAUYMVXGUYSVXKVXAUYLVXFDUWAVXAUYKVXEUVLVXAUYJVXDUVRVXAUWMUXLUWTUYCU
      YIVWOUXHUXMVWTUUKZVWPVWSUXSUYDUULZYHYNTYOVXAUYRVXJDUWAVXAUYQVXIUVLVXAUYPV
      XHUVRVXAUWMUXLUWTUYCUYOWWSWWTYHYNTYOWBYOUUMUYMUYSCRUUNVJUUOUUPUUSUUQUUTUU
      RUVAZUVBVWJUYNUYTWXAUVCUWIUWOOZUWKUWQCDRUWAWXBUWJUWPUVLUWIUWOUVRYSTYPUWIU
      XBOZUWKUXDCDRUWAWXCUWJUXCUVLUWIUXBUVRYSTYPUAUBYTZUWLUVLUWMUVROZPZDUWAQZCR
      QUXQWXDUWKWXFCDRUWAWXDUWJWXEUVLUWIUWMUVRYSTYPWXGUXPCUERCUEYTZWXGUXHUWMGUV
      MUXIUVPIZNZOZPZDUXOQUXPWXHWXFWXLDUWAUXOUVKUXGHVSWXHUVLUXHWXEWXKUVKUXGBVTW
      XHUVRWXJUWMWXHGUVMUVQWXIWXHUVOUXIUVPUVKUXGUVNWAWDVOVPWBWEWXLUXNDUFUXODUFY
      TZWXKUXMUXHWXMWXJUXLUWMWXMGUVMWXIUXKUXIUVPUXJVNVOVPTYQYRYQYRUAUCYTZUWLUVL
      UWTUVROZPZDUWAQZCRQUYHWXNUWKWXPCDRUWAWXNUWJWXOUVLUWIUWTUVRYSTYPWXQUYGCUGR
      CUGYTZWXQUXSUWTGUVMUXTUVPIZNZOZPZDUYFQUYGWXRWXPWYBDUWAUYFUVKUXRHVSWXRUVLU
      XSWXOWYAUVKUXRBVTWXRUVRWXTUWTWXRGUVMUVQWXSWXRUVOUXTUVPUVKUXRUVNWAWDVOVPWB
      WEWYBUYEDUHUYFDUHYTZWYAUYDUXSWYCWXTUYCUWTWYCGUVMWXSUYBUXTUVPUYAVNVOVPTYQY
      RYQYRUWIUYJOZUWKUYLCDRUWAWYDUWJUYKUVLUWIUYJUVRYSTYPUWIUYPOZUWKUYRCDRUWAWY
      EUWJUYQUVLUWIUYPUVRYSTYPUWIAOZUWKUVTCDRUWAWYFUWJUVSUVLUWIAUVRYSTYPUVDWCUV
      TUWHCDRUWAUVSUWGUVLUVRUWFAGEUVMUVQUWEGEYTUVOUWDUVPUVNUWCUVKYGWDWMUVEUVFUV
      GUVH $.
  $}

  ${
    $d A a b d $.  $d B a b c d $.
    $( Polynomials are finitary objects and can only reference a finite number
       of variables, even if the index set is infinite.  Thus, every polynomial
       can be expressed as a (uniquely minimal, although we do not prove that)
       polynomial on a finite number of variables, which is then extended by
       adding an arbitrary set of ignored variables.  (Contributed by Stefan
       O'Rear, 9-Oct-2014.) $)
    mzpcompact2 $p |- ( A e. ( mzPoly ` B ) -> E. a e. Fin E. b e. ( mzPoly ` a
        ) ( a C_ B /\ A = ( c e. ( ZZ ^m B ) |-> ( b ` ( c |` a ) ) ) ) ) $=
      ( vd cvv wcel cmzp cfv cv wss cz cmap co cmpt wceq wa wrex cfn cres fveq2
      elfvex eleq2d sseq2 oveq2 mpteq1d anbi12d 2rexbidv imbi12d mzpcompact2lem
      wi eqeq2d vex vtoclg mpcom ) BGHABIJZHZCKZBLZAEMBNOZEKUSUADKJZPZQZRZDUSIJ
      ZSCTSZABIUCAFKZIJZHZUSVHLZAEMVHNOZVBPZQZRZDVFSCTSZULURVGULFBGVHBQZVJURVPV
      GVQVIUQAVHBIUBUDVQVOVECDTVFVQVKUTVNVDVHBUSUEVQVMVCAVQEVLVAVBVHBMNUFUGUMUH
      UIUJAVHCDEFUNUKUOUP $.
  $}
$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Miscellanea for Diophantine sets 1
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A composition of two relations is empty iff there is no overlap betwen the
     range of the second and the domain of the first.  Useful in combination
     with ~ coundi and ~ coundir to prune meaningless terms in the result.
     (Contributed by Stefan O'Rear, 8-Oct-2014.) $)
  coeq0 $p |- ( ( A o. B ) = (/) <-> ( dom A i^i ran B ) = (/) ) $=
    ( ccom c0 wceq crn cres cdm wrel wb relco relrn0 ax-mp eqeq1i relres reldm0
    cin rnco dmres incom eqtri 3bitr3i 3bitri ) ABCZDEZUDFZDEZABFZGZFZDEZAHZUHQ
    ZDEZUDIUEUGJABKUDLMUFUJDABRNUIDEZUIHZDEZUKUNUIIZUOUQJAUHOZUIPMURUOUKJUSUILM
    UPUMDUPUHULQUMAUHSUHULTUANUBUC $.

  $( ~ coeq0 but without explicitly introducing domain and range symbols.
     (Contributed by Stefan O'Rear, 16-Oct-2014.) $)
  coeq0i $p |- ( ( A : C --> D /\ B : E --> F /\ ( C i^i F ) = (/) ) ->
      ( A o. B ) = (/) ) $=
    ( wf cin c0 wceq w3a cdm crn ccom wss frn 3ad2ant2 sslin syl fdm ineq1d ss0
    3ad2ant1 simp3 eqtrd sseqtrd coeq0 sylibr ) CDAGZEFBGZCFHZIJZKZALZBMZHZIJZA
    BNIJUMUPIOUQUMUPUNFHZIUMUOFOZUPUROUJUIUSULEFBPQUOFUNRSUMURUKIUMUNCFUIUJUNCJ
    ULCDATUCUAUIUJULUDUEUFUPUBSABUGUH $.

  $( Split a finite 1-based set of integers in the middle, allowing either end
     to be empty ( ` ( 1 ... 0 ) ` ).  (Contributed by Stefan O'Rear,
     8-Oct-2014.) $)
  fzsplit1nn0 $p |- ( ( A e. NN0 /\ B e. NN0 /\ A <_ B ) -> ( 1 ... B ) = ( ( 1
      ... A ) u. ( ( A + 1 ) ... B ) ) ) $=
    ( cn0 wcel cle wbr c1 cfz co caddc cun wceq cn cc0 wo wa adantr cz syl6eq
    c0 wi elnn0 nnge1 simprr wb nnz 1z a1i nn0z ad2antrl elfz syl3anc mpbir2and
    fzsplit syl uncom oveq1 0p1e1 oveq1d oveq2 uneq12d un0 syl5req jaoian sylbi
    fz10 ex 3impib ) ACDZBCDZABEFZGBHIZGAHIZAGJIZBHIZKZLZVIAMDZANLZOZVJVKPZVQUA
    AUBVTWAVQVRWAVQVSVRWAPZAVLDZVQWBWCGAEFZVKVRWDWAAUCQVRVJVKUDWBARDZGRDZBRDZWC
    WDVKPUEVRWEWAAUFQWFWBUGUHVJWGVRVKBUIUJAGBUKULUMAGBUNUOVSWAPZVPVOVMKZVLVMVOU
    PWHWIVLTKVLWHVOVLVMTWHVNGBHWHVNNGJIZGVSVNWJLWAANGJUQQURSUSWHVMGNHIZTVSVMWKL
    WAANGHUTQVFSVAVLVBSVCVDVGVEVH $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 1: definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Dioph $.
  $( Extend class notation to include the family of Diophantine sets. $)
  cdioph $a class Dioph $.

  ${
    $d n d k p t u $.
    $( A Diophantine set is a set of natural numbers which is a projection of
       the zero set of some polynomial.  This definition somewhat awkwardly
       mixes ` ZZ ` (via ` mzPoly ` ) and ` NN0 ` (to define the zero sets);
       the former could be avoided by considering coincidence sets of ` NN0 `
       polynomials at the cost of requiring two, and the second is driven by
       consistency with our mu-recursive functions and the requirements of the
       Davis-Putnam-Robinson-Matiyasevich proof.  Both are avoidable at a
       complexity cost.  In particular, it is a consequence of ~ 4sq that
       implicitly restricting variables to ` NN0 ` adds no expressive power
       over allowing them to range over ` ZZ ` .  While this definition
       stipulates a specific index set for the polynomials, there is actually
       flexibility here, see ~ eldioph2b .  (Contributed by Stefan O'Rear,
       5-Oct-2014.) $)
    df-dioph $a |- Dioph = ( n e. NN0 |-> ran ( k e. ( ZZ>= ` n ) , p e. (
        mzPoly ` ( 1 ... k ) ) |-> { t | E. u e. ( NN0 ^m ( 1 ... k ) ) ( t =
        ( u |` ( 1 ... n ) ) /\ ( p ` u ) = 0 ) } ) ) $.
  $}

  ${
    $d D n d k p $.  $d N n d k p t u $.
    $( Initial expression of Diophantine property of a set.  (Contributed by
       Stefan O'Rear, 5-Oct-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.) $)
    eldiophb $p |- ( D e. ( Dioph ` N ) <-> ( N e. NN0 /\ E. k e. ( ZZ>= ` N )
        E. p e. (
        mzPoly ` ( 1 ... k ) ) D = { t | E. u e. ( NN0 ^m ( 1 ... k ) ) ( t =
        ( u |` ( 1 ... N ) ) /\ ( p ` u ) = 0 ) } ) ) $=
      ( vn vd cdioph cfv wcel cn0 cv c1 cfz co wceq cmap wrex cab cres cc0 cmzp
      wa cuz cdm cmpt2 df-dioph dmmptss elfvdm sseldi fveq2 eqidd oveq2 reseq2d
      crn eqeq2d anbi1d rexbidv abbidv mpt2eq123dv rneqd cpw ovex pwex eqid wss
      rnmpt2 wf elmapi fzss2 fssres syl2anr nn0ex elmap sylibr eleq1 syl5ibrcom
      adantr rexlimdva abssdv elpw2 rexlimdvw rexlimiv abssi ssexi fvmpt eleq2d
      wb eqsstri abrexex simpl reximi ss2abi elrnmpt2 syl6bb biadan2 ) CEIJZKZE
      LKZCBMZAMZNEOPZUAZQZXBFMJUBQZUDZALNDMZOPZRPZSZBTZQFXIUCJZSDEUEJZSZWSIUFLE
      GLDFGMZUEJZXMXAXBNXPOPZUAZQZXFUDZAXJSZBTZUGZUPZIABDGFUHZUICEIUJUKWTWSCDFX
      NXMXLUGZUPZKXOWTWRYHCGEYEYHLIXPEQZYDYGYIDFXQXMYCXNXMXLXPEUEULYIXMUMYIYBXK
      BYIYAXGAXJYIXTXEXFYIXSXDXAYIXRXCXBXPENOUNUOUQURUSUTVAVBYFYHLXCRPZVCZYJLXC
      RVDZVEYHHMZXLQZFXMSZDXNSZHTYKDFHXNXMXLYGYGVFZVHYPHYKYOYMYKKZDXNXHXNKZYNYR
      FXMYSYRYNXLYKKZYSXLYJVGYTYSXKBYJYSXGXAYJKZAXJYSXBXJKZUDZUUAXGXDYJKZUUCXCL
      XDVIZUUDUUBXILXBVIXCXIVGUUEYSXBLXIVJENXHVKXILXCXBVLVMLXCXDVNNEOVDVOVPXEUU
      AUUDWIXFXAXDYJVQVSVRVTWAXLYJYLWBVPYMXLYKVQVRWCWDWEWJWFWGWHDFXNXMXLCYGYQXL
      XEAXJSZBTABXJXDLXIRVDWKXKUUFBXGXEAXJXEXFWLWMWNWFWOWPWQ $.
  $}

  ${
    $d N k p t u $.  $d K k p t u $.  $d P k p t u $.
    $( Condition for a set to be Diophantine (unpacking existential quantifier)
       (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    eldioph $p |- ( ( N e. NN0 /\ K e. ( ZZ>= ` N ) /\ P e. ( mzPoly ` ( 1 ...
        K ) ) ) ->
        { t | E. u e. ( NN0 ^m ( 1 ... K ) ) ( t = ( u |` ( 1 ... N ) ) /\ ( P
        ` u ) = 0 ) } e. ( Dioph ` N ) ) $=
      ( vp vk cn0 wcel cfv c1 cfz co cmzp cv wceq cc0 cmap wrex cab cuz cres wa
      cdioph simp1 simp2 simp3 eqidd eqeq1d anbi2d rexbidv abbidv eqeq2d rspcev
      w3a fveq1 syl2anc oveq2 fveq2d oveq2d rexeqdv rexeqbidv eldiophb sylanbrc
      ) EHIZDEUAJZIZCKDLMZNJZIZUOZVEBOAOZKELMUBPZVLCJZQPZUCZAHVHRMZSZBTZVMVLFOZ
      JZQPZUCZAHKGOZLMZRMZSZBTZPZFWENJZSZGVFSZVSEUDJIVEVGVJUEVKVGVSWCAVQSZBTZPZ
      FVISZWLVEVGVJUFVKVJVSVSPZWPVEVGVJUGVKVSUHWOWQFCVIVTCPZWNVSVSWRWMVRBWRWCVP
      AVQWRWBVOVMWRWAVNQVLVTCUPUIUJUKULUMUNUQWKWPGDVFWDDPZWIWOFWJVIWSWEVHNWDDKL
      URZUSWSWHWNVSWSWGWMBWSWCAWFVQWSWEVHHRWTUTVAULUMVBUNUQABVSGEFVCVD $.
  $}

  ${
    $d S a b c d $.  $d T a b c d $.  $d M a b c d $.  $d O a b c d $.
    $d P b c d $.
    $( Renaming and adding unused witness variables does not change the
       Diophantine set coded by a polynomial.  (Contributed by Stefan O'Rear,
       7-Oct-2014.) $)
    diophrw $p |- ( ( S e. _V /\ M : T -1-1-> S /\ ( M |` O ) = ( _I |` O ) )
        -> { a | E. b e. ( NN0 ^m S ) ( a = ( b |` O ) /\ ( ( d e. ( ZZ ^m S )
        |-> ( P ` ( d o. M ) ) ) ` b ) = 0 ) } = { a | E. c e. ( NN0 ^m T ) ( a
        = ( c |` O ) /\ ( P ` c ) = 0 ) } ) $=
      ( cvv wcel cres wceq cz ccom cc0 cn0 wf syl5eq c0 wf1 cid w3a cv cmap cfv
      co cmpt wa simpr wb nn0ex simp1 adantr elmapg sylancr mpbid simp2 f1f syl
      ad2antrr syl2anc f1dmex mpbird simprl resco simpll3 coeq2d coires1 syl6eq
      fco eqtr4d wss simpll1 oveq2 sseq12d zex nn0ssz mapss mp2an vtoclg simplr
      wrex sseldd coeq1 fveq2d fvmpt simprr eqtr3d reseq1 eqeq2d eqeq1d anbi12d
      eqid fvex rspcev syl12anc ex rexlimdva ccnv crn cdif csn cxp cun cin wf1o
      fveq2 f1cnv f1of 3syl c0ex fconst a1i disjdif fun syl21anc frn undif 0nn0
      sylib snssi ax-mp ssequn2 mpbi feq23d resundir cnvresid cima simpl2 df-f1
      wfun simprbi funcnvres simpl3 cdm syl6req uneq12d un0 eqtrd cnveqd df-ima
      rneqd rnresi reseq2d syl5reqr dmres wne snnz dmxp ineq2i inss1 resss rnss
      3eqtr3d mp1i eqsstrd syl5ss inssdif0 wrel relres reldm0 sylibr sylancl 0z
      fss coundir coass f1cocnv1 ineq1i incom 3eqtri coeq0 3eqtrd impbid abbidv
      mpbir fcoi1 ) BJKZCBDUAZDELZUBELZMZUCZFUDZGUDZELZMZUWFINBUEUGZIUDZDOZAUFZ
      UHZUFZPMZUIZGQBUEUGZWCZUWEHUDZELZMZUWSAUFZPMZUIZHQCUEUGZWCZFUWDUWRUXFUWDU
      WPUXFGUWQUWDUWFUWQKZUIZUWPUXFUXHUWPUIZUWFDOZUXEKZUWEUXJELZMZUXJAUFZPMZUXF
      UXIUXKCQUXJRZUXIBQUWFRZCBDRZUXPUXHUXQUWPUXHUXGUXQUWDUXGUJUXHQJKZUVSUXGUXQ
      UKULUWDUVSUXGUVSUVTUWCUMZUNQBUWFJJUOUPUQUNUWDUXRUXGUWPUWDUVTUXRUVSUVTUWCU
      RZCBDUSZUTVACBQUWFDVKVBUXIUXSCJKZUXKUXPUKULUWDUYCUXGUWPUWDUVTUVSUYCUYAUXT
      CBJDVCVBZVAQCUXJJJUOUPVDUXIUWEUWGUXLUXHUWHUWOVEUXIUXLUWFUWAOZUWGUWFDEVFUX
      IUYEUWFUWBOUWGUXIUWAUWBUWFUVSUVTUWCUXGUWPVGVHUWFEVIVJSVLUXIUWNUXNPUXIUWFU
      WIKUWNUXNMUXIUWQUWIUWFUXIUVSUWQUWIVMZUVSUVTUWCUXGUWPVNQUWEUEUGZNUWEUEUGZV
      MZUYFFBJUWEBMUYGUWQUYHUWIUWEBQUEVOUWEBNUEVOVPNJKZQNVMZUYIVQVRQNUWEJVSVTWA
      UTUWDUXGUWPWBWDIUWFUWLUXNUWIUWMUWJUWFMUWKUXJAUWJUWFDWEWFUWMWNZUXJAWOWGUTU
      XHUWHUWOWHWIUXDUXMUXOUIHUXJUXEUWSUXJMZUXAUXMUXCUXOUYMUWTUXLUWEUWSUXJEWJWK
      UYMUXBUXNPUWSUXJAXHWLWMWPWQWRWSUWDUXDUWRHUXEUWDUWSUXEKZUIZUXDUWRUYOUXDUIZ
      UWSDWTZOZBDXAZXBZPXCZXDZXEZUWQKZUWEVUCELZMZVUCUWMUFZPMZUWRUYPVUDBQVUCRZUY
      PUYSUYTXEZQVUAXEZVUCRZVUIUYPUYSQUYRRZUYTVUAVUBRZUYSUYTXFZTMZVULUYPCQUWSRZ
      UYSCUYQRZVUMUYOVUQUXDUYOUYNVUQUWDUYNUJUYOUXSUYCUYNVUQUKULUWDUYCUYNUYDUNQC
      UWSJJUOUPUQZUNZUYPUVTUYSCUYQXGVURUWDUVTUYNUXDUYAVAZCBDXIUYSCUYQXJXKZUYSCQ
      UWSUYQVKVBVUNUYPUYTPXLXMXNZVUPUYPUYSBXOZXNZUYSUYTQVUAUYRVUBXPXQUYPVUJVUKB
      QVUCUYPUYSBVMZVUJBMUWDVVFUYNUXDUWDUVTUXRVVFUYAUYBCBDXRXKVAUYSBXSYAZVUKQMZ
      UYPVUAQVMZVVHPQKVVIXTPQYBYCVUAQYDYEXNYFUQUWDVUDVUIUKZUYNUXDUWDUXSUVSVVJUL
      UXTQBVUCJJUOUPVAVDUYPUWEUWTVUEUYOUXAUXCVEUYOUWTVUEMUXDUYOVUEUWTTXEZUWTUYO
      VUEUYRELZVUBELZXEVVKUYRVUBEYGUYOVVLUWTVVMTUYOVVLUWSUYQELZOZUWTUWSUYQEVFUY
      OVVOUWSUWBOUWTUYOVVNUWBUWSUYOUWBUWBWTZVVNEYHUYOUWAWTZUYQDEYIZLZVVPVVNUYOU
      VTUYQYLZVVQVVSMUVSUVTUWCUYNYJUVTUXRVVTCBDYKYMEDYNXKUYOUWAUWBUVSUVTUWCUYNY
      OZUUAUYOVVREUYQUYOVVRUWAXAZEDEUUBUYOVWBUWBXAZEUYOUWAUWBVWAUUCZEUUDZVJSUUE
      UUOUUFVHUWSEVIVJSUYOVVMYPZTMZVVMTMZUYOVWFEVUBYPZXFZTVUBEUUGUYOVWJEUYTXFZT
      VWIUYTEVUATUUHVWIUYTMPXLUUIUYTVUAUUJYCZUUKUYOEBXFZUYSVMVWKTMUYOVWMEUYSEBU
      ULUYOEVWBUYSUYOVWBVWCEVWDVWEYQUWADVMVWBUYSVMUYODEUUMUWADUUNUUPUUQUUREBUYS
      UUSYASSVVMUUTVWHVWGUKVUBEUVAVVMUVBYCUVCYRSUWTYSYQUNYTUYPVUGVUCDOZAUFZUXBP
      UYPVUCUWIKZVUGVWOMUYPVWPBNVUCRZUYPVUJNVUAXEZVUCRZVWQUYPUYSNUYRRZVUNVUPVWS
      UYPCNUWSRZVURVWTUYOVXAUXDUYOVUQUYKVXAVUSVRCQNUWSUVFUVDUNVVBUYSCNUWSUYQVKV
      BVVCVVEUYSUYTNVUAUYRVUBXPXQUYPVUJVWRBNVUCVVGVWRNMZUYPVUANVMZVXBPNKVXCUVEP
      NYBYCVUANYDYEXNYFUQUWDVWPVWQUKZUYNUXDUWDUYJUVSVXDVQUXTNBVUCJJUOUPVAVDIVUC
      UWLVWOUWIUWMUWJVUCMUWKVWNAUWJVUCDWEWFUYLVWNAWOWGUTUYPVWNUWSAUYPVWNUYRDOZV
      UBDOZXEZUWSUYRVUBDUVGUYPVXGUWSUBCLZOZTXEZUWSUYPVXEVXIVXFTUYPVXEUWSUYQDOZO
      ZVXIUWSUYQDUVHUYPUVTVXLVXIMVVAUVTVXKVXHUWSCBDUVIVHUTSVXFTMZUYPVXMVWIUYSXF
      ZTMVXNUYTUYSXFVUOTVWIUYTUYSVWLUVJUYTUYSUVKVVDUVLVUBDUVMUVQXNYRUYPVXJVXIUW
      SVXIYSUYPVUQVXIUWSMVUTCQUWSUVRUTSYTSWFUYOUXAUXCWHUVNUWPVUFVUHUIGVUCUWQUWF
      VUCMZUWHVUFUWOVUHVXOUWGVUEUWEUWFVUCEWJWKVXOUWNVUGPUWFVUCUWMXHWLWMWPWQWRWS
      UVOUVP $.
  $}

  ${
    $d A a d e $.  $d N a d e $.  $d a b c d e $.
    $( Lemma for ~ eldioph2 .  Construct necessary renaming function for one
       direction.  (Contributed by Stefan O'Rear, 8-Oct-2014.) $)
    eldioph2lem1 $p |- ( ( N e. NN0 /\ A e. Fin /\ ( 1 ... N ) C_ A ) -> E. d
        e. ( ZZ>= ` N ) E. e e. _V ( e : ( 1 ... d ) -1-1-onto-> A /\ ( e |` (
        1 ... N ) ) = ( _I |` ( 1 ... N ) ) ) ) $=
      ( va wcel cfn c1 cfz co caddc chash cfv wf1o wceq cvv wbr cun c0 a1i cdif
      cn0 wss w3a cv cres cid wa wrex cuz cen cc cr nn0re 3ad2ant1 recnd ax-1cn
      wex addcom sylancl diffi 3ad2ant2 fzfid incom disjdif eqtri syl3anc uncom
      cin hashun simp3 undif sylib syl5eq fveq2d hashfz1 oveq2d 3eqtr3d oveq12d
      cz 1z hashcl syl nn0zd nn0z fzen ensymd fzfi hashen sylibr 3eqtrd sylancr
      wb mp2an mpbid bren simpl1 simpl2 nn0addge2 syl2anc breqtrrd adantr eluz2
      cle syl3anbrc vex ovex resiexg ax-mp unex simpr nn0red ltp1d fzdisj f1oun
      clt syl22anc fzsplit1nn0 syl6reqr simpl3 f1oeq23 resundir cdm dmres f1odm
      f1oi adantl ineq2d eqtrd relres reldm0 residm uneq12d syl6eq oveq2 f1oeq2
      wrel un0 anbi1d f1oeq1 reseq1 eqeq1d anbi12d rspc2ev syl112anc exlimddv )
      CUBFZAGFZHCIJZAUCZUDZCHKJZALMZIJZAUUIUAZEUEZNZHDUEZIJZABUEZNZUUTUUIUFZUGU
      UIUFZOZUHZBPUIDCUJMZUIZEUUKUUNUUOUKQZUUQEURUUKUUNLMZUUOLMZOZUVHUUKUVIHCKJ
      ZUVJCKJZIJZLMZHUVJIJZLMZUVJUUKUUNUVNLUUKUULUVLUUMUVMIUUKCULFHULFUULUVLOUU
      KCUUGUUHCUMFZUUJCUNUOZUPUQCHUSUTUUKUUOUUIRZLMZUVJUUILMZKJZUUMUVMUUKUUOGFZ
      UUIGFUUOUUIVIZSOZUWAUWCOUUHUUGUWDUUJAUUIVAVBZUUKHCVCUWFUUKUWEUUIUUOVISUUO
      UUIVDUUIAVEVFZTUUOUUIVJVGUUKUVTALUUKUVTUUIUUORZAUUOUUIVHZUUKUUJUWIAOZUUGU
      UHUUJVKUUIAVLZVMVNVOUUKUWBCUVJKUUGUUHUWBCOUUJCVPUOVQVRZVSVOUUKUVNUVPUKQZU
      VOUVQOZUUKUVPUVNUUKHVTFZUVJVTFCVTFZUVPUVNUKQUWPUUKWATUUKUVJUUKUWDUVJUBFZU
      WGUUOWBWCZWDUUGUUHUWQUUJCWEUOCHUVJWFVGWGUVNGFUVPGFUWOUWNWMUVLUVMWHHUVJWHU
      VNUVPWIWNWJUUKUWRUVQUVJOUWSUVJVPWCWKUUKUUNGFUWDUVKUVHWMUULUUMWHUWGUUNUUOW
      IWLWOUUNUUOEWPVMUUKUUQUHZUUMUVFFZUUPUVCRZPFZHUUMIJZAUXBNZUXBUUIUFZUVCOZUV
      GUWTUWQUUMVTFCUUMXDQZUXAUWTCUUGUUHUUJUUQWQZWDUWTUUMUWTUUHUUMUBFZUUGUUHUUJ
      UUQWRAWBWCZWDUUKUXHUUQUUKCUVMUUMXDUUKUVRUWRCUVMXDQUVSUWSCUVJWSWTUWMXAXBZC
      UUMXCXEUXCUWTUUPUVCEXFUUIPFUVCPFHCIXGUUIPXHXIXJTUWTUUNUUIRZUVTUXBNZUXEUWT
      UUQUUIUUIUVCNZUUNUUIVIZSOUWFUXNUUKUUQXKUXOUWTUUIYFTUWTUXPUUIUUNVIZSUUNUUI
      VDUWTCUULXPQUXQSOUWTCUWTCUXIXLXMHCUULUUMXNWCZVNUWFUWTUWHTUUNUUOUUIUUIUUPU
      VCXOXQUWTUXMUXDOUVTAOUXNUXEWMUWTUXDUUIUUNRZUXMUWTUUGUXJUXHUXDUXSOUXIUXKUX
      LCUUMXRVGUUNUUIVHXSUWTUVTUWIAUWJUWTUUJUWKUUGUUHUUJUUQXTUWLVMVNUXMUXDUVTAU
      XBYAWTWOUWTUXFUUPUUIUFZUVCUUIUFZRZUVCUUPUVCUUIYBUWTUYBSUVCRZUVCUWTUXTSUYA
      UVCUWTUXTYCZSOZUXTSOZUWTUYDUUIUUPYCZVIZSUUPUUIYDUWTUYHUXQSUWTUYGUUNUUIUUQ
      UYGUUNOUUKUUNUUOUUPYEYGYHUXRYIVNUXTYQUYFUYEWMUUPUUIYJUXTYKXIWJUYAUVCOUWTU
      GUUIYLTYMUYCUVCSRUVCSUVCVHUVCYRVFYNVNUVEUXEUXGUHUXDAUUTNZUVDUHDBUUMUXBUVF
      PUURUUMOZUVAUYIUVDUYJUUSUXDOUVAUYIWMUURUUMHIYOUUSUXDAUUTYPWCYSUUTUXBOZUYI
      UXEUVDUXGUXDAUUTUXBYTUYKUVBUXFUVCUUTUXBUUIUUAUUBUUCUUDUUEUUF $.
  $}

  ${
    $d N a b c $.  $d S a b c $.  $d A a b c $.
    $( Lemma for ~ eldioph2 .  Construct necessary renaming function for one
       direction.  (Contributed by Stefan O'Rear, 8-Oct-2014.) $)
    eldioph2lem2 $p |- ( ( ( N e. NN0 /\ -. S e. Fin ) /\ ( ( 1 ... N ) C_ S /\
        A e. ( ZZ>= ` N ) ) ) -> E. c ( c : ( 1 ... A ) -1-1-> S /\ ( c |` ( 1
        ... N ) ) = ( _I |` ( 1 ... N ) ) ) ) $=
      ( va wcel cfn wa c1 cfz wss wf1 cres wceq cun cin c0 adantl syl syl5eq wn
      cn0 co cuz cfv cdif cv cid simplr fzfi difinf sylancl diffi ax-mp isinffi
      wex crn wf1o f1f1orn f1oi a1i incom disjdif eqtri wf f1f frn syl6sseq ss0
      ssrin f1oun syl22anc f1of1 wb uncom simplrr fzss2 undif sylib f1eq2 mpbid
      difss2d simplrl unssd f1ss syl2anc resundir dmres f1dm ineq1d syl6eq wrel
      cdm relres reldm0 sylibr residm uneq12d un0 vex ovex resiexg f1eq1 reseq1
      cvv unex eqeq1d anbi12d spcev exlimddv ) CUBFZBGFUAZHZICJUCZBKZACUDUEFZHZ
      HZIAJUCZXNUFZBXNUFZEUGZLZXSBDUGZLZYDXNMZUHXNMZNZHZDUPZEXRYAGFUAZXTGFZYCEU
      PXRXLXNGFYKXKXLXQUIICUJBXNUKULXSGFYLIAUJXSXNUMUNYAXTEUOULXRYCHZXSBYBYGOZL
      ZYNXNMZYGNZYJYMXSYBUQZXNOZYNLZYSBKYOYMXTXNOZYSYNLZYTYMUUAYSYNURZUUBYMXTYR
      YBURZXNXNYGURZXTXNPZQNZYRXNPZQNZUUCYCUUDXRXTYAYBUSRUUEYMXNUTVAUUGYMUUFXNX
      TPQXTXNVBXNXSVCVDZVAYMUUHQKUUIYMUUHYAXNPZQYMYRYAKZUUHUUKKYCUULXRYCXTYAYBV
      EUULXTYAYBVFXTYAYBVGSZRYRYAXNVJSUUKXNYAPQYAXNVBXNBVCVDVHUUHVISXTYRXNXNYBY
      GVKVLUUAYSYNVMSYMUUAXSNUUBYTVNYMUUAXNXTOZXSXTXNVOYMXNXSKZUUNXSNYMXPUUOXMX
      OXPYCVPCIAVQSXNXSVRVSTUUAXSYSYNVTSWAYMYRXNBYCYRBKXRYCYRBXNUUMWBRXMXOXPYCW
      CWDXSYSBYNWEWFYMYPYBXNMZYGXNMZOZYGYBYGXNWGYMUURQYGOZYGYMUUPQUUQYGYMUUPWMZ
      QNZUUPQNZYMUUTXNYBWMZPZQYBXNWHYMUVDUVCXNPZQXNUVCVBYMUVEUUFQYMUVCXTXNYCUVC
      XTNXRXTYAYBWIRWJUUJWKTTUUPWLUVBUVAVNYBXNWNUUPWOUNWPUUQYGNYMUHXNWQVAWRUUSY
      GQOYGQYGVOYGWSVDWKTYIYOYQHDYNYBYGEWTXNXEFYGXEFICJXAXNXEXBUNXFYDYNNZYEYOYH
      YQXSBYDYNXCUVFYFYPYGYDYNXNXDXGXHXIWFXJ $.
  $}

  ${
    $d P a b c e t u g h $.  $d S a b c d e t u g h $.
    $d N a b c d e f t u g h $.
    $( Construct a Diophantine set from a polynomial with witness variables
       drawn from any set whatsoever, via ~ mzpcompact2 .  (Contributed by
       Stefan O'Rear, 8-Oct-2014.)  (Revised by Stefan O'Rear, 5-Jun-2015.) $)
    eldioph2 $p |- ( ( N e. NN0 /\ ( S e. _V /\ ( 1 ... N ) C_ S ) /\ P e. (
        mzPoly ` S ) ) ->
        { t | E. u e. ( NN0 ^m S ) ( t = ( u |` ( 1 ... N ) ) /\ ( P ` u ) = 0
        ) } e. ( Dioph ` N ) ) $=
      ( ve wcel cvv co wss wa cfv cv cres wceq wrex cfn cc0 syl3anc ccom va cn0
      vb vc vd vg vh c1 cfz cmzp cz cmap cmpt cdioph mzpcompact2 3ad2ant3 fveq1
      w3a cab eqeq1d anbi2d rexbidv abbidv ad2antll wi cun wf1o cid cuz simplll
      simplrl fzfi unfi sylancl ssun2 a1i eldioph2lem1 f1ococnv2 ad2antrl ssun1
      reseq1d resabs1 ax-mp syl6req syl6eq adantr coeq2d coires1 eqcomi 3eqtr3g
      ccnv resco coass fveq2d wf ovex simpr f1of1 simprr ad2antrr unssd syl2anc
      wf1 f1ss f1f syl mapco2g coeq1 eqid fvex fvmpt eqtr4d mpteq2dva ad3antrrr
      fveq1d diophrw eqtrd simp-5l simplrr f1ocnv f1of fssres mzprename eldioph
      eqeltrd ex rexlimdvva mpd exp31 3adant3 imp31 adantrr ) EUBGZDHGZUHEUIIZD
      JZKZCDUJLGZURZUAMZDJZCFUKDULIZFMZYTNZUCMZLZUMZOZKZUCYTUJLZPUAQPZBMZAMZYON
      OZUUMCLZROZKZAUBDULIZPZBUSZEUNLZGZYRYMUUKYQCDUAUCFUOUPYSUUIUVBUAUCQUUJYSY
      TQGZUUEUUJGZKZKZUUIUVBUVFUUIKUUTUUNUUMUUGLZROZKZAUURPZBUSZUVAUUHUUTUVKOUV
      FUUAUUHUUSUVJBUUHUUQUVIAUURUUHUUPUVHUUNUUHUUOUVGRUUMCUUGUQUTVAVBVCVDUVFUU
      AUVKUVAGZUUHYSUVEUUAUVLYMYQUVEUUAUVLVEVEYRYMYQKZUVEUUAUVLUVMUVEKZUUAKZUHU
      DMZUIIZYTYOVFZUEMZVGZUVSYONVHYONOZKZUEHPUDEVILZPZUVLUVOYMUVRQGZYOUVRJZUWD
      YMYQUVEUUAVJUVOUVCYOQGUWEUVMUVCUVDUUAVKUHEVLYTYOVMVNUWFUVOYOYTVOVPUVRUEEU
      DVQSUVOUWBUVLUDUEUWCHUVOUVPUWCGZUVSHGZKZKZUWBUVLUWJUWBKZUVKUULUFMZYONOUWL
      UGUKUVQULIZUGMZUVSWKZYTNZTZUUELZUMZLROKUFUBUVQULIPBUSZUVAUWKUVKUUNUUMFUUB
      UUCUVSTZUWSLZUMZLZROZKZAUURPZBUSZUWTUWKUVJUXGBUWKUVIUXFAUURUWKUVHUXEUUNUW
      KUVGUXDRUWKUUMUUGUXCUWKFUUBUUFUXBUWKUUCUUBGZKZUUFUXAUWPTZUUELZUXBUXJUUDUX
      KUUEUXJUUCVHYTNZTUUCUVSUWPTZTZUUDUXKUXJUXMUXNUUCUWKUXMUXNOUXIUWKUXMUVSUWO
      TZYTNZUXNUWKUXQVHUVRNZYTNZUXMUWKUXPUXRYTUVTUXPUXROUWJUWAUVQUVRUVSVRVSWAYT
      UVRJZUXSUXMOYTYOVTZVHYTUVRWBWCWDUVSUWOYTWLWEWFWGUUCYTWHUXKUXOUUCUVSUWPWMW
      IWJWNUXJUXAUWMGZUXBUXLOUXJUVQHGZUXIUVQDUVSWOZUYBUYCUXJUHUVPUIWPZVPUWKUXIW
      QUWKUYDUXIUWKUVQDUVSXCZUYDUWKUVQUVRUVSXCZUVRDJZUYFUVTUYGUWJUWAUVQUVRUVSWR
      VSUVOUYHUWIUWBUVOYTYODUVNUUAWQUVMYPUVEUUAYMYNYPWSWTXAWTUVQUVRDUVSXDXBZUVQ
      DUVSXEXFWFUUCUKDUVSUVQXGSUGUXAUWRUXLUWMUWSUWNUXAOUWQUXKUUEUWNUXAUWPXHWNUW
      SXIUXKUUEXJXKXFXLXMXOUTVAVBVCUWKYNUYFUWAUXHUWTOUVNYNUUAUWIUWBYMYNYPUVEVKX
      NUYIUWJUVTUWAWSUWSDUVQUVSYOBAUFFXPSXQUWKYMUWGUWSUVQUJLGZUWTUVAGYMYQUVEUUA
      UWIUWBXRUVOUWGUWHUWBVKUWKUYCUVDYTUVQUWPWOZUYJUYCUWKUYEVPUVOUVDUWIUWBUVMUV
      CUVDUUAXSWTUVTUYKUWJUWAUVTUVRUVQUWOWOZUXTUYKUVTUVRUVQUWOVGUYLUVQUVRUVSXTU
      VRUVQUWOYAXFUYAUVRUVQYTUWOYBVNVSUGUWPUUEYTUVQYCSUFBUWSUVPEYDSYEYFYGYHYIYJ
      YKYLYEYFYGYH $.
  $}

  ${
    $d A a b p $.  $d N a b c d e u t p $.  $d S a b c d e u t p $.
    $( While Diophantine sets were defined to have a finite number of witness
       variables consequtively following the observable variables, this is not
       necessary; they can equivalently be taken to use any witness set
       ` ( S \ ( 1 ... N ) ) ` .  For instance, in ~ diophin we use this to
       take the two input sets to have disjoint witness sets.  (Contributed by
       Stefan O'Rear, 8-Oct-2014.) $)
    eldioph2b $p |- ( ( ( N e. NN0 /\ S e. _V ) /\ ( -. S e. Fin /\ ( 1 ... N )
        C_ S ) ) -> ( A e. ( Dioph ` N ) <->
        E. p e. ( mzPoly ` S ) A = { t | E. u e. ( NN0 ^m S ) ( t = ( u |` ( 1
        ... N ) ) /\ ( p ` u ) = 0 ) } ) ) $=
      ( vd vb va vc ve wcel cvv wa co cfv cv cres wceq wrex cn0 cfn cfz wss cc0
      wn c1 cdioph cmap cab cuz eldiophb wf1 cid simplll simplrl simplrr simprl
      cmzp wex eldioph2lem2 syl22anc rexv sylibr cz ccom cmpt wf simp-5r simprr
      ad2antrr f1f syl mzprename syl3anc w3a diophrw eqcomd fveq1 eqeq1d anbi2d
      rexbidv abbidv eqeq2d rspcev ex rexlimdva mpd eqeq1 syl5ibrcom rexlimdvva
      syl2anc adantld syl5bi simpllr eldioph2 syl121anc adantr eqeltrd impbid
      simpr ) EUALZDMLZNZDUBLUFZUGEUCOZDUDZNZNZCEUHPZLZCBQZAQZXFRSZXMFQZPZUESZN
      ZAUADUIOZTZBUJZSZFDUSPZTZXKXBCXLGQZXFRSYEHQZPUESNGUAUGIQZUCOZUIOTBUJZSZHY
      HUSPZTIEUKPZTZNXIYDGBCIEHULXIYMYDXBXIYJYDIHYLYKXIYGYLLZYFYKLZNZNZYDYJYIYA
      SZFYCTZYQYHDJQZUMZYTXFRUNXFRSZNZJMTZYSYQUUCJUTZUUDYQXBXEXGYNUUEXBXCXHYPUO
      XDXEXGYPUPXDXEXGYPUQXIYNYOURYGDEJVAVBUUCJVCVDYQUUCYSJMYQYTMLZNZUUCYSUUGUU
      CNZKVEDUIOKQYTVFYFPVGZYCLZYIXNXMUUIPZUESZNZAXSTZBUJZSZYSUUHXCYOYHDYTVHZUU
      JXBXCXHYPUUFUUCVIZYQYOUUFUUCXIYNYOVJVKUUHUUAUUQUUGUUAUUBURZYHDYTVLVMKYTYF
      YHDVNVOUUHXCUUAUUBUUPUURUUSUUGUUAUUBVJXCUUAUUBVPUUOYIYFDYHYTXFBAGKVQVRVOY
      RUUPFUUIYCXOUUISZYAUUOYIUUTXTUUNBUUTXRUUMAXSUUTXQUULXNUUTXPUUKUEXMXOUUIVS
      VTWAWBWCWDWEWLWFWGWHYJYBYRFYCCYIYAWIWBWJWKWMWNXIYBXKFYCXIXOYCLZNZYBXKUVBY
      BNCYAXJUVBYBXAUVBYAXJLZYBUVBXBXCXGUVAUVCXBXCXHUVAUOXBXCXHUVAWOXDXEXGUVAUQ
      XIUVAXAABXODEWPWQWRWSWFWGWT $.
  $}

  ${
    $d A a b c d $.  $d B a b c d $.
    $( Remove antecedent on ` B ` from Diophantine set constructors.
       (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    eldiophelnn0 $p |- ( A e. ( Dioph ` B ) -> B e. NN0 ) $=
      ( vc vd va vb cdioph cfv wcel cn0 cv c1 cfz co cres wceq cc0 wa cmap wrex
      cab cmzp cuz eldiophb simplbi ) ABGHIBJIACKDKZLBMNOPUFEKHQPRDJLFKMNZSNTCU
      APEUGUBHTFBUCHTDCAFBEUDUE $.
  $}

  ${
    $d A p t u $.  $d N p t u $.
    $( Define Diophantine sets in terms of polynomials with variables indexed
       by ` NN ` .  This avoids a quantifier over the number of witness
       variables and will be easier to use than ~ eldiophb in most cases.
       (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    eldioph3b $p |- ( A e. ( Dioph ` N ) <-> ( N e. NN0 /\
        E. p e. ( mzPoly ` NN ) A = { t | E. u e. ( NN0 ^m NN ) ( t = ( u |` (
        1 ... N ) ) /\ ( p ` u ) = 0 ) } ) ) $=
      ( cdioph cfv wcel cn0 cv c1 cfz co cres wceq cc0 wa cn cmap wrex cab cmzp
      eldiophelnn0 cvv wb nnex cfn wn wss cz uzinf ax-mp elfznn ssriv eldioph2b
      1z nnuz mpanr12 mpan2 biadan2 ) CDFGHZDIHZCBJAJZKDLMZNOVCEJZGPOQAIRSMTBUA
      OERUBGTZCDUCVBRUDHZVAVFUEZUFVBVGQRUGHUHZVDRUIVHKUJHVIUPKRUQUKULEVDRVEDUMU
      NABCRDEUOURUSUT $.
  $}

  $( could maybe shorten a LOT of these with a canned substitution huh? $)
  ${
    $d A a b p t u $.  $d N a b p t u $.  $d P a b p t u $.
    $( Inference version of ~ eldioph3b with quantifier expanded.  (Contributed
       by Stefan O'Rear, 10-Oct-2014.) $)
    eldioph3 $p |- ( ( N e. NN0 /\ P e. ( mzPoly ` NN ) ) -> { t | E. u e. (
        NN0 ^m NN ) ( t = ( u |` ( 1 ... N ) ) /\ ( P ` u ) = 0 ) } e. ( Dioph
        ` N ) ) $=
      ( va vb vp cn0 wcel cn cfv wa cv co cres wceq cc0 wrex cab eqeq1d cmzp c1
      cfz cdioph simpl simpr eqidd fveq1 anbi2d rexbidv abbidv weq eqeq1 anbi1d
      reseq1 eqeq2d fveq2 anbi12d cbvrexv syl6bb cbvabv syl6eq rspcev eldioph3b
      cmap syl2anc sylanbrc ) DHIZCJUAKZIZLZVHBMZAMZUBDUCNZOZPZVMCKZQPZLZAHJVEN
      ZRZBSZEMZFMZVNOZPZWDGMZKZQPZLZFVTRZESZPZGVIRZWBDUDKIVHVJUEVKVJWBWBPZWNVHV
      JUFVKWBUGWMWOGCVIWGCPZWLWBWBWPWLWFWDCKZQPZLZFVTRZESWBWPWKWTEWPWJWSFVTWPWI
      WRWFWPWHWQQWDWGCUHTUIUJUKWTWAEBEBULZWTVLWEPZWRLZFVTRWAXAWSXCFVTXAWFXBWRWC
      VLWEUMUNUJXCVSFAVTFAULZXBVPWRVRXDWEVOVLWDVMVNUOUPXDWQVQQWDVMCUQTURUSUTVAV
      BUPVCVFFEWBDGVDVG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 2 miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d N a $.  $d A a $.  $d B a $.
    $( Membership in a set of lower integers.  (Contributed by Stefan O'Rear,
       9-Oct-2014.) $)
    ellz1 $p |- ( B e. ZZ -> ( A e. ( ZZ \ ( ZZ>= ` ( B + 1 ) ) ) <-> ( A e. ZZ
        /\ A <_ B ) ) ) $=
      ( cz c1 caddc co cuz cfv cdif wcel wn wa cle wbr eldif clt notbid cr zre
      wb zltp1le lenlt syl2anr peano2z eluz sylan 3bitr4rd pm5.32da syl5bb ) AC
      BDEFZGHZIJACJZAUKJZKZLBCJZULABMNZLACUKOUOULUNUPUOULLZBAPNZKZUJAMNZKUPUNUQ
      URUTBAUAQULARJBRJUPUSTUOASBSABUBUCUQUMUTUOUJCJULUMUTTBUDUJAUEUFQUGUHUI $.

    $( A set of lower integers and upper integers which abut or overlap is all
       of the integers.  (Contributed by Stefan O'Rear, 9-Oct-2014.) $)
    lzunuz $p |- ( ( A e. ZZ /\ B e. ZZ /\ B <_ ( A + 1 ) ) -> ( ( ZZ \ ( ZZ>=
        ` ( A + 1 ) ) ) u. ( ZZ>= ` B ) ) = ZZ ) $=
      ( va cz wcel c1 caddc co cle wbr w3a cuz cfv cdif wo wa wb cr zred ex cun
      elun ellz1 3ad2ant1 eluz1 3ad2ant2 orbi12d clt zre adantl simpl1 lelttric
      syl2anc simpll2 simpll1 peano2zd ad2antlr simpll3 zltp1le 3ad2antl1 letrd
      cv biimpa orim2d mpd pm4.71d andi syl6rbb bitrd syl5bb eqrdv ) ADEZBDEZBA
      FGHZIJZKZCDVNLMNZBLMZUAZDCVBZVSEVTVQEZVTVREZOZVPVTDEZVTVQVRUBVPWCWDVTAIJZ
      PZWDBVTIJZPZOZWDVPWAWFWBWHVLVMWAWFQVOVTAUCUDVMVLWBWHQVOBVTUEUFUGVPWDWDWEW
      GOZPWIVPWDWJVPWDWJVPWDPZWEAVTUHJZOZWJWKVTREZAREWMWDWNVPVTUIZUJWKAVLVMVOWD
      UKSVTAULUMWKWLWGWEWKWLWGWKWLPZBVNVTWPBVLVMVOWDWLUNSWPVNWPAVLVMVOWDWLUOUPS
      WDWNVPWLWOUQVLVMVOWDWLURWKWLVNVTIJZVLVMWDWLWQQVOAVTUSUTVCVATVDVETVFWDWEWG
      VGVHVIVJVK $.

    $( Express a one-based finite range as the intersection of lower integers
       with ` NN ` .  (Contributed by Stefan O'Rear, 9-Oct-2014.) $)
    fz1eqin $p |- ( N e. NN0 -> ( 1 ... N ) = ( ( ZZ \ ( ZZ>= ` ( N + 1 ) ) )
        i^i NN ) ) $=
      ( va cn0 wcel c1 cfz co cz caddc cuz cfv cdif cn cin cv cle wbr wa w3a wb
      1z nn0z elfz1 sylancr 3anass ancom anbi2i anandi 3bitri syl6bb elin ellz1
      syl elnnz1 a1i anbi12d syl5bb bitr4d eqrdv ) ACDZBEAFGZHAEIGJKLZMNZUTBOZV
      ADZVDHDZVDAPQZRZVFEVDPQZRZRZVDVCDZUTVEVFVIVGSZVKUTEHDAHDZVEVMTUAAUBZVDEAU
      CUDVMVFVIVGRZRVFVGVIRZRVKVFVIVGUEVPVQVFVIVGUFUGVFVGVIUHUIUJVLVDVBDZVDMDZR
      UTVKVDVBMUKUTVRVHVSVJUTVNVRVHTVOVDAULUMVSVJTUTVDUNUOUPUQURUS $.
  $}

  ${
    $d N a b c $.
    $( Lower integers are countably infinite.  (Contributed by Stefan O'Rear,
       10-Oct-2014.) $)
    lzenom $p |- ( N e. ZZ -> ( ZZ \ ( ZZ>= ` ( N + 1 ) ) ) ~~ om ) $=
      ( cz wcel c1 co cn cen wbr com cmin cvv a1i cle wceq zre ad2antrl anbi12d
      wa cr cc va vb caddc cuz cfv cdif cv zex difexg mp1i nnex ovex a1ii simpl
      peano2zd simprl zsubcld zred 1re simprr zcn adantr pncan sylancl breqtrrd
      ax-1cn lesubd zcnd nncand eqcomd jca31 adantrr eleq1 breq2 oveq2 ad2antll
      wb eqeq2d mpbird recnd pncan2 eqbrtrd subled breq1 impbida anbi1d 3bitr4d
      ellz1 elnnz1 en2d nnenom entr ) ABCZBADUCEZUDUEZUFZFGHFIGHWPIGHWMUAUBWPFW
      NUAUGZJEZWNUBUGZJEZBKCWPKCWMUHBWOKUIUJFKCWMUKLWMWQWPCZWRKCWNWQJULUMWMWSFC
      ZWTKCWNWSJULUMWMWQBCZWQAMHZRZWSWRNZRZWSBCZDWSMHZRZWQWTNZRZXAXFRXBXKRWMXGX
      LWMXGRXLWRBCZDWRMHZRZWQWNWRJEZNZRZWMXEXRXFWMXERZXMXNXQXSWNWQXSAWMXEUNUOZW
      MXCXDUPUQXSWQWNDXCWQSCWMXDWQOPXSWNXTURDSCXSUSLXSWQAWNDJEZMWMXCXDUTXSATCZD
      TCZYAANWMYBXEAVAVBVFADVCVDVEVGXSXPWQXSWNWQXSWNXTVHXCWQTCWMXDWQVAPVIVJVKVL
      XFXLXRVQWMXEXFXJXOXKXQXFXHXMXIXNWSWRBVMWSWRDMVNQXFWTXPWQWSWRWNJVOVRQVPVSW
      MXLRXGWTBCZWTAMHZRZWSWNWTJEZNZRZWMXJYIXKWMXJRZYDYEYHYJWNWSYJAWMXJUNUOZWMX
      HXIUPUQYJWNAWSYJWNYKURWMASCXJAOVBZXHWSSCWMXIWSOPYJWNAJEZDWSMYJYBYCYMDNYJA
      YLVTVFADWAVDWMXHXIUTWBWCYJYGWSYJWNWSYJWNYKVHXHWSTCWMXIWSVAPVIVJVKVLXKXGYI
      VQWMXJXKXEYFXFYHXKXCYDXDYEWQWTBVMWQWTAMWDQXKWRYGWSWQWTWNJVOVRQVPVSWEWMXAX
      EXFWQAWHWFWMXBXJXKXBXJVQWMWSWILWFWGWJWKWPFIWLVD $.
  $}

  $( ~ fresaun transposed to mappings.  (Contributed by Stefan O'Rear,
     9-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
  elmapresaun $p |- ( ( F e. ( C ^m A ) /\ G e. ( C ^m B ) /\
    ( F |` ( A i^i B ) ) = ( G |` ( A i^i B ) ) ) ->
      ( F u. G ) e. ( C ^m ( A u. B ) ) ) $=
    ( cmap co wcel cin cres wceq w3a cun wf elmapi fresaun cvv elmapex simprd
    id syl3an wb simpld 3ad2ant1 unexg syl2an 3adant3 elmapg syl2anc mpbird ) D
    CAFGHZECBFGHZDABIZJEUMJKZLZDEMZCABMZFGHZUQCUPNZUKACDNULBCENUNUNUSDCAOECBOUN
    TABCDEPUAUOCQHZUQQHZURUSUBUKULUTUNUKUTAQHZDCARZUCUDUKULVAUNUKVBBQHZVAULUKUT
    VBVCSULUTVDECBRSABQQUEUFUGCUQUPQQUHUIUJ $.

  $( ~ fresaunres2 transposed to mappings.  (Contributed by Stefan O'Rear,
     9-Oct-2014.) $)
  elmapresaunres2 $p |- ( ( F e. ( C ^m A ) /\ G e. ( C ^m B ) /\
  ( F |` ( A i^i B ) ) = ( G |` ( A i^i B ) ) ) -> ( ( F u. G ) |` B ) = G ) $=
    ( cmap co wcel wf cin cres wceq cun elmapi id fresaunres2 syl3an ) DCAFGHAC
    DIECBFGHBCEIDABJZKERKLZSDEMBKELDCANECBNSOABCDEPQ $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 2: union and intersection.  Monotone Boolean algebra
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a b c d e f g h i j k l $.  $d B a b c d e f g h i j k l $.
    $d N a b c d e f g h i j k l $.
    $( If two sets are Diophantine, so is their intersection.  (Contributed by
       Stefan O'Rear, 9-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    diophin $p |- ( ( A e. ( Dioph ` N ) /\ B e. ( Dioph ` N ) ) -> ( A i^i B )
        e. ( Dioph ` N ) ) $=
      ( vc vg cfv wcel cn0 wa c1 co cres wceq cc0 cz cmap wrex cn c2 syl3anc vd
      va ve vb vf cdioph cin wi eldiophelnn0 cv cfz caddc cuz cdif cab cmzp cvv
      cfn wn wss wb id zex difexg mp1i com cen wbr nn0z lzenom enfi 3syl mtbiri
      ominf fz1eqin inss1 syl6eqss eldioph2b syl22anc nnex 1z nnuz uzinf elfznn
      a1i ssriv anbi12d reeanv cexp cmpt inab simplrl simplrr reseq2d ad3antrrr
      cun eqcomd simprrl simprll eqtr4d elmapresaun uneq2i nnge1d lzunuz syl5eq
      3eqtr2d nn0p1nn oveq2d eleqtrd elmapresaunres2 fveq2d eqtrd simprrr jca32
      reseq1 eqeq2d eqeq1d syl2anc ex rexlimdvva elmapssres adantr nnssz simprl
      cle sylancl resabs1 syl fveq2 anbi2d cr mzpf adantl ffvelrnd mzpresrename
      wf zred oveq1d 2nn0 mzpexpmpt unidm uneq12d syl5eqr syl6eqr uncom reseq1i
      resundir incom simprlr rspcev simpr difss anbi1d rspc2ev rexlimdva impbid
      nn0ssz mapss mp2an sseli sumsqeq0 oveq12d eqid ovex fvmpt bitr4d rexbidva
      jca bitrd syl5bbr abbidv simpl fzssuz uzssz sstri pm3.2i simprr mzpaddmpt
      eldioph2 eqeltrd ineq12 eleq1d syl5ibrcom syl5bir sylbid anabsi5 ) ACUFFZ
      GZBUWGGZABUGZUWGGZUWHCHGZUWHUWIIZUWKUHACUIUWLUWMADUJZUAUJZJCUKKZLZMZUWOUB
      UJZFZNMZIZUAHOCJULKZUMFZUNZPKZQZDUOZMZUBUXEUPFZQZBUWNUCUJZUWPLZMZUXLUDUJZ
      FZNMZIZUCHRPKZQZDUOZMZUDRUPFZQZIZUWKUWLUWHUXKUWIUYDUWLUWLUXEUQGZUXEURGZUS
      UWPUXEUTZUWHUXKVAUWLVBZOUQGZUYFUWLVCOUXDUQVDVEUWLUYGVFURGZVNUWLCOGZUXEVFV
      GVHUYGUYKVACVIZCVJUXEVFVKVLVMUWLUWPUXERUGZUXECVOZUXERVPVQZUADAUXECUBVRVSU
      WLUWLRUQGZRURGUSZUWPRUTZUWIUYDVAUYIUYQUWLVTWEJOGZUYRUWLWAJRWBWCVEUYSUWLUB
      UWPRUWSCWDWFZWEUCDBRCUDVRVSWGUYEUXIUYBIZUDUYCQUBUXJQUWLUWKUXIUYBUBUDUXJUY
      CWHUWLVUBUWKUBUDUXJUYCUWLUWSUXJGZUXOUYCGZIZIZUWKVUBUXHUYAUGZUWGGVUFVUGUWN
      UEUJZUWPLZMZVUHEOOPKZEUJZUXELZUWSFZSWIKZVULRLZUXOFZSWIKZULKZWJZFZNMZIZUEH
      OPKZQZDUOZUWGVUFVUGUXGUXTIZDUOVVFUXGUXTDWKVUFVVGVVEDVVGUXBUXRIZUCUXSQUAUX
      FQZVUFVVEUXBUXRUAUCUXFUXSWHVUFVVIVUJVUHUXELZUWSFZNMZVUHRLZUXOFZNMZIZIZUEV
      VDQZVVEVUFVVIVVRVUFVVHVVRUAUCUXFUXSVUFUWOUXFGZUXLUXSGZIZIZVVHVVRVWBVVHIZU
      WOUXLWPZVVDGUWNVWDUWPLZMZVWDUXELZUWSFZNMZVWDRLZUXOFZNMZIZIZVVRVWCVWDHUXER
      WPZPKZVVDVWCVVSVVTUWOUYNLZUXLUYNLZMZVWDVWPGVUFVVSVVTVVHWLZVUFVVSVVTVVHWMZ
      VWCVWQUWQVWRUWLVWQUWQMVUEVWAVVHUWLUYNUWPUWOUWLUWPUYNUYOWQZWNWOVWCVWRUXMUW
      NUWQUWLVWRUXMMVUEVWAVVHUWLUYNUWPUXLVXBWNWOVWBUXBUXNUXQWRZVWBUWRUXAUXRWSZX
      FWTZUXERHUWOUXLXATUWLVWPVVDMVUEVWAVVHUWLVWOOHPUWLVWOUXEJUMFZWPZORVXFUXEWB
      XBUWLUYLUYTJUXCYEVHVXGOMUYMUYTUWLWAWEUWLUXCCXGXCCJXDTXEXHWOXIVWCVWFVWIVWL
      VWCUWNUWQUXMWPZVWEVWCUWNUWNUWNWPVXHUWNUUAVWCUWNUWQUWNUXMVXDVXCUUBUUCUWOUX
      LUWPUUGUUDVWCVWHUWTNVWCVWGUWOUWSVWCVWGUXLUWOWPZUXELZUWOVWDVXIUXEUWOUXLUUE
      UUFVWCVVTVVSUXLRUXEUGZLZUWOVXKLZMVXJUWOMVXAVWTVWCVXLUXMVXMUWLVXLUXMMVUEVW
      AVVHUWLVXKUWPUXLUWLVXKUYNUWPRUXEUUHVXBXEZWNWOVWCVXMUWQUWNUXMUWLVXMUWQMVUE
      VWAVVHUWLVXKUWPUWOVXNWNWOVXDVXCXFWTRUXEHUXLUWOXJTXEXKVWBUWRUXAUXRUUIXLVWC
      VWKUXPNVWCVWJUXLUXOVWCVVSVVTVWSVWJUXLMVWTVXAVXEUXERHUWOUXLXJTXKVWBUXBUXNU
      XQXMXLXNVVQVWNUEVWDVVDVUHVWDMZVUJVWFVVPVWMVXOVUIVWEUWNVUHVWDUWPXOXPVXOVVL
      VWIVVOVWLVXOVVKVWHNVXOVVJVWGUWSVUHVWDUXEXOXKXQVXOVVNVWKNVXOVVMVWJUXOVUHVW
      DRXOXKXQWGWGUUJXRXSXTVUFVVQVVIUEVVDVUFVUHVVDGZIZVVQVVIVXQVVQIZVVJUXFGZVVM
      UXSGZUWNVVJUWPLZMZVVLIZUWNVVMUWPLZMZVVOIZIZVVIVXQVXSVVQVXQVXPUXEOUTZVXSVU
      FVXPUUKZOUXDUULZVUHHOUXEYAYFYBVXQVXTVVQVXQVXPROUTZVXTVYIYCVUHHORYAYFYBVXR
      VYCVYEVVOVXRVYBVVLVXRUWNVUIVYAVXQVUJVVPYDZVXRUYHVYAVUIMUWLUYHVUEVXPVVQUYP
      WOVUHUWPUXEYGYHWTVXQVUJVVLVVOWRUVHVXRUWNVUIVYDVYLUYSVYDVUIMVXRVUAVUHUWPRY
      GVEWTVXQVUJVVLVVOXMXNVVHVYGVYCUXRIUAUCVVJVVMUXFUXSUWOVVJMZUXBVYCUXRVYMUWR
      VYBUXAVVLVYMUWQVYAUWNUWOVVJUWPXOXPVYMUWTVVKNUWOVVJUWSYIXQWGUUMUXLVVMMZUXR
      VYFVYCVYNUXNVYEUXQVVOVYNUXMVYDUWNUXLVVMUWPXOXPVYNUXPVVNNUXLVVMUXOYIXQWGYJ
      UUNTXSUUOUUPVUFVVQVVCUEVVDVXQVVPVVBVUJVXQVVPVVKSWIKZVVNSWIKZULKZNMZVVBVXQ
      VVKYKGVVNYKGVVPVYRVAVXQVVKVXQOUXEPKZOVVJUWSVXQVUCVYSOUWSYPUWLVUCVUDVXPWLU
      WSUXEYLYHVXPVVJVYSGZVUFVXPVUHVUKGZVYHVYTVVDVUKVUHUYJHOUTVVDVUKUTVCUUQHOOU
      QUURUUSUUTZVYJVUHOOUXEYAYFYMYNYQVXQVVNVXQORPKZOVVMUXOVXQVUDWUCOUXOYPUWLVU
      CVUDVXPWMUXORYLYHVXPVVMWUCGZVUFVXPWUAVYKWUDWUBYCVUHOORYAYFYMYNYQVVKVVNUVA
      XRVXQVVAVYQNVXQWUAVVAVYQMVXPWUAVUFWUBYMEVUHVUSVYQVUKVUTVULVUHMZVUOVYOVURV
      YPULWUEVUNVVKSWIWUEVUMVVJUWSVULVUHUXEXOXKYRWUEVUQVVNSWIWUEVUPVVMUXOVULVUH
      RXOXKYRUVBVUTUVCVYOVYPULUVDUVEYHXQUVFYJUVGUVIUVJUVKXEVUFUWLUYJUWPOUTZIZVU
      TOUPFZGZVVFUWGGUWLVUEUVLWUGVUFUYJWUFVCUWPVXFOJCUVMJUVNUVOUVPWEVUFEVUKVUOW
      JWUHGZEVUKVURWJWUHGZWUIVUFEVUKVUNWJWUHGZSHGZWUJVUFUYJVYHVUCWULUYJVUFVCWEZ
      VYHVUFVYJWEUWLVUCVUDYDEUWSUXEOYOTYSEVUNSOYTYFVUFEVUKVUQWJWUHGZWUMWUKVUFUY
      JVYKVUDWUOWUNVYKVUFYCWEUWLVUCVUDUVQEUXOROYOTYSEVUQSOYTYFEVUOVUROUVRXRUEDV
      UTOCUVSTUVTVUBUWJVUGUWGAUXHBUYAUWAUWBUWCXTUWDUWEYHUWF $.
  $}

  ${
    $d A a b c d e $.  $d B a b c d e $.  $d N a b c d e $.

    $( If two sets are Diophantine, so is their union.  (Contributed by Stefan
       O'Rear, 9-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    diophun $p |- ( ( A e. ( Dioph ` N ) /\ B e. ( Dioph ` N ) ) -> ( A u. B )
        e. ( Dioph ` N ) ) $=
      ( vb vd va vc ve cfv wcel cn0 wa cv co wceq cc0 cn wrex cz syl cdioph cun
      wi eldiophelnn0 c1 cfz cres cmap cab cmzp cvv cfn wn wb nnex jctr 1z nnuz
      wss uzinf ax-mp elfznn ssriv pm3.2i eldioph2b anbi12d sylancl reeanv cmul
      cmpt wo unab r19.43 andi zex nn0ssz mapss mp2an sseli adantl oveq12d eqid
      fveq2 ovex fvmpt eqeq1d simplrl mzpf ffvelrnd zcnd simplrr mul0ord bitr2d
      wf anbi2d syl5bbr rexbidva abbidv syl5eq simpl a1i simprl eqeltrrd simprr
      feqmptd syl2anc eldioph2 syl3anc eqeltrd uneq12 eleq1d syl5ibrcom syl5bir
      mzpmulmpt rexlimdvva sylbid anabsi5 ) ACUAIZJZBXRJZABUBZXRJZXSCKJZXSXTLZY
      BUCACUDYCYDADMEMZUECUFNZUGOZYEFMZIZPOZLZEKQUHNZRZDUIZOZFQUJIZRZBYGYEGMZIZ
      POZLZEYLRZDUIZOZGYPRZLZYBYCYCQUKJZLZQULJUMZYFQUSZLZYDUUFUNYCUUGUOUPUUIUUJ
      UESJUUIUQUEQURUTVAFYFQYHCVBVCZVDUUHUUKLXSYQXTUUEEDAQCFVEEDBQCGVEVFVGUUFYO
      UUDLZGYPRFYPRYCYBYOUUDFGYPYPVHYCUUMYBFGYPYPYCYHYPJZYRYPJZLZLZYBUUMYNUUCUB
      ZXRJUUQUURYGYEHSQUHNZHMZYHIZUUTYRIZVINZVJZIZPOZLZEYLRZDUIZXRUUQUURYMUUBVK
      ZDUIUVIYMUUBDVLUUQUVJUVHDUVJYKUUAVKZEYLRUUQUVHYKUUAEYLVMUUQUVKUVGEYLUVKYG
      YJYTVKZLUUQYEYLJZLZUVGYGYJYTVNUVNUVLUVFYGUVNUVFYIYSVINZPOUVLUVNUVEUVOPUVN
      YEUUSJZUVEUVOOUVMUVPUUQYLUUSYESUKJKSUSYLUUSUSVOVPKSQUKVQVRVSVTZHYEUVCUVOU
      USUVDUUTYEOUVAYIUVBYSVIUUTYEYHWCUUTYEYRWCWAUVDWBYIYSVIWDWETWFUVNYIYSUVNYI
      UVNUUSSYEYHUVNUUNUUSSYHWNZYCUUNUUOUVMWGYHQWHZTUVQWIWJUVNYSUVNUUSSYEYRUVNU
      UOUUSSYRWNZYCUUNUUOUVMWKYRQWHZTUVQWIWJWLWMWOWPWQWPWRWSUUQYCUUGUUJLZUVDYPJ
      ZUVIXRJYCUUPWTUWBUUQUUGUUJUOUULVDXAUUQHUUSUVAVJZYPJHUUSUVBVJZYPJUWCUUQYHU
      WDYPUUQHUUSSYHUUQUUNUVRYCUUNUUOXBZUVSTXEUWFXCUUQYRUWEYPUUQHUUSSYRUUQUUOUV
      TYCUUNUUOXDZUWATXEUWGXCHUVAUVBQXNXFEDUVDQCXGXHXIUUMYAUURXRAYNBUUCXJXKXLXO
      XMXPTXQ $.
  $}

  ${
    $d A a b c d $.  $d B a b c d $.
    $( Diophantine sets are sets of tuples of natural numbers.  (Contributed by
       Stefan O'Rear, 10-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    eldiophss $p |- ( A e. ( Dioph ` B ) -> A C_ ( NN0 ^m ( 1 ... B ) ) ) $=
      ( vb vc va vd cfv wcel cn0 cv co wceq wa cn cmap wrex wss simpr rexlimdva
      ex cdioph cfz cres cc0 cab cmzp eldioph3b vex eqeq1 anbi1d rexbidv elfznn
      elab ssriv elmapssres mpan2 ad2antlr eqeltrd adantrd syl5bi ssrdv eqsstrd
      c1 adantr imp sylbi ) ABUAGHBIHZACJZDJZVCBUBKZUCZLZVIEJZGUDLZMZDINOKZPZCU
      EZLZENUFGZPZMAIVJOKZQZDCABEUGVGWAWCVGVSWCEVTVGVMVTHMZVSWCWDVSMAVRWBWDVSRW
      DVRWBQVSWDFVRWBFJZVRHWEVKLZVNMZDVPPZWDWEWBHZVQWHCWEFUHVHWELZVOWGDVPWJVLWF
      VNVHWEVKUIUJUKUMWDWGWIDVPWDVIVPHZMZWFWIVNWLWFWIWLWFMWEVKWBWLWFRWKVKWBHZWD
      WFWKVJNQWMEVJNVMBULUNVIINVJUOUPUQURTUSSUTVAVDVBTSVEVF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 3: construction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d N t u a b c d e f g h $.  $d M a b c d e f g h $.
    $d S t u a b c d e f g h $.
    $( Projecting a Diophantine set by removing a coordinate results in a
       Diophantine set.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    diophrex $p |- ( ( N e. NN0 /\ M e. ( ZZ>= ` N ) /\ S e. ( Dioph ` M ) ) ->
        { t | E. u e. S t = ( u |` ( 1 ... N ) ) } e. ( Dioph ` N ) ) $=
      ( va vb vd ve vc cn0 wcel cfv cv cres wceq wrex cab wa wex cuz cdioph w3a
      c1 cfz co eqeq1 rexbidv reseq1 eqeq2d cbvrexv syl6bb cbvabv cc0 cmap cmzp
      eldioph3b simprbi 3ad2ant3 rexeq abbidv adantl anbi1d rexab r19.41v exbii
      cn rexcom4 anass vex resex anbi2d ceqsexv bitri ancom simpl2 resabs1 3syl
      wss fzss2 syl5bb syl5bbr eldioph3 3ad2antl1 adantr ex rexlimdva syl5eqelr
      eqeltrd mpd ) EKLZDEUAMLZCDUBMLZUCZBNZANZUDEUEUFZOZPZACQZBRFNZGNZWQOZPZGC
      QZFRZEUBMZXEWTFBXAWOPZXEWOXCPZGCQWTXHXDXIGCXAWOXCUGUHXIWSGACXBWPPXCWRWOXB
      WPWQUIUJUKULUMWNCHNZINZUDDUEUFZOZPZXKJNZMUNPZSZIKVGUOUFZQZHRZPZJVGUPMZQZX
      FXGLZWMWKYCWLWMDKLYCIHCDJUQURUSWNYAYDJYBWNXOYBLZSZYAYDYFYASXFXDGXTQZFRZXG
      YAXFYHPYFYAXEYGFXDGCXTUTVAVBYFYHXGLYAYFYHXAXKWQOZPZXPSZIXRQZFRZXGYFYGYLFY
      GXBXMPZXPSZIXRQZXDSZGTZYFYLXSYPXDGHXJXBPZXQYOIXRYSXNYNXPXJXBXMUGVCUHVDYRY
      OXDSZIXRQZGTZYFYLUUAYQGYOXDIXRVEVFUUBYTGTZIXRQYFYLYTIGXRVHYFUUCYKIXRUUCXP
      XAXMWQOZPZSZYFYKUUCYNXPXDSZSZGTUUFYTUUHGYNXPXDVIVFUUGUUFGXMXKXLIVJVKYNXDU
      UEXPYNXCUUDXAXBXMWQUIUJVLVMVNUUFUUEXPSYFYKXPUUEVOYFUUEYJXPYFUUDYIXAYFWLWQ
      XLVSUUDYIPWKWLWMYEVPEUDDVTXKWQXLVQVRUJVCWAWAUHWBWBWAVAWKWLYEYMXGLWMIFXOEW
      CWDWIWEWIWFWGWJWH $.
  $}

  ${
    $d N t a b c d e $.  $d A a b c d e $.  $d B a b $.

    $( This is the first of a number of theorems which allow sets to be proven
       Diophantine by syntactic induction, and models the correspondence
       between Diophantine sets and monotone existential first order logic.
       This first theorem shows that the zero set of an implicit polynomial is
       Diophantine.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    eq0rabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e. (
        mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A = 0 } e.
        ( Dioph ` N ) ) $=
      ( va vb cn0 wcel cz co cmap cfv wa cc0 wceq crab wrex cab eqeq1d syl6eq
      cv c1 cfz cmpt cmzp cres cdioph wb wral nfv nfmpt1 nfel1 nfan cvv wss zex
      nn0ssz mapss mp2an sseli adantl wf mzpf mptfcl syl2an adantll eqid fvmpt2
      imp syl2anc eqcomd ralrimi rabbi sylib nffvmpt1 nfeq1 fveq2 cbvrab df-rab
      ex nfcv wfn elmapi ffn fnresdm 3syl eqeq2d equcom syl6bb anbi1d ceqsrexbv
      rexbiia bitr2i abbii cuz simpl nn0z uzid syl adantr simpr eldioph syl3anc
      eqeltrd ) CFGZAHUACUBIZJIZBUCZXEUDKZGZLZBMNZAFXEJIZOZDTZETZXEUEZNZXOXGKZM
      NZLZEXLPZDQZCUFKZXJXMXNXLGXNXGKZMNZLZDQZYBXJXMYEDXLOZYGXJXMATZXGKZMNZAXLO
      ZYHXJXKYKUGZAXLUHXMYLNXJYMAXLXDXIAXDAUIAXGXHAXFBUJUKULXJYIXLGZYMXJYNLZBYJ
      MYOYJBYOYIXFGZBHGZYJBNYNYPXJXLXFYIHUMGFHUNXLXFUNUOUPFHXEUMUQURUSZUTXIYNYQ
      XDXIXFHXGVAZYPYQYNXGXEVBYRYSYPYQAXFBHVCVHVDVEAXFBHXGXGVFVGVIVJRVSVKXKYKAX
      LVLVMYKYEADXLAXLVTDXLVTYKDUIAYDMAXFBXNVNVOYIXNNYJYDMYIXNXGVPRVQSYEDXLVRSY
      FYADYAXOXNNZXSLZEXLPYFXTUUAEXLXOXLGZXQYTXSUUBXQXNXONYTUUBXPXOXNUUBXEFXOVA
      XOXEWAXPXONXOFXEWBXEFXOWCXEXOWDWEWFDEWGWHWIWKXSYEEXNXLYTXRYDMXOXNXGVPRWJW
      LWMSXJXDCCWNKGZXIYBYCGXDXIWOXDUUCXIXDCHGUUCCWPCWQWRWSXDXIWTEDXGCCXAXBXC
      $.

    $( Diophantine set builder for equality of polynomial expressions.  Note
       that the two expressions need not be non-negative; only variables are so
       constrained.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    eqrabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e. (
        mzPoly ` ( 1 ... N ) ) /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> B ) e. (
        mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A = B } e.
        ( Dioph ` N ) ) $=
      ( cn0 wcel cz co cmap cmpt cfv wceq crab wa nfmpt1 nfel1 wf mzpf cvv wss
      c1 cfz cmzp w3a cmin cc0 cdioph wb wral nfan cv ad2antrr zex nn0ssz mapss
      mp2an sseli adantl mptfcl sylc zcnd ad2antlr subeq0ad ralrimi rabbi sylib
      bicomd ex 3adant1 simp1 mzpsubmpt eq0rabdioph syl2anc eqeltrd ) DEFZAGUAD
      UBHZIHZBJZVPUCKZFZAVQCJZVSFZUDZBCLZAEVPIHZMZBCUEHZUFLZAWEMZDUGKZVTWBWFWIL
      ZVOVTWBNZWDWHUHZAWEUIWKWLWMAWEVTWBAAVRVSAVQBOPAWAVSAVQCOPUJWLAUKZWEFZWMWL
      WONZWHWDWPBCWPBWPVQGVRQZWNVQFZBGFVTWQWBWOVRVPRULWOWRWLWEVQWNGSFEGTWEVQTUM
      UNEGVPSUOUPUQURZAVQBGUSUTVAWPCWPVQGWAQZWRCGFWBWTVTWOWAVPRVBWSAVQCGUSUTVAV
      CVGVHVDWDWHAWEVEVFVIWCVOAVQWGJVSFZWIWJFVOVTWBVJVTWBXAVOABCVPVKVIAWGDVLVMV
      N $.

    $( The null set is Diophantine.  (Contributed by Stefan O'Rear,
       10-Oct-2014.) $)
    0dioph $p |- ( A e. NN0 -> (/) e. ( Dioph ` A ) ) $=
      ( va cn0 wcel c0 c1 cc0 wceq cfz co cmap crab cdioph cfv wral wne ax-1ne0
      wn df-ne cz mpbi rgenw rabeq0 mpbir cmpt cmzp cvv mzpconstmpt eq0rabdioph
      ovex 1z mp2an mpan2 syl5eqelr ) ACDZEFGHZBCFAIJZKJZLZAMNZUSEHUPRZBUROVABU
      RFGPVAQFGSUAUBUPBURUCUDUOBTUQKJFUEUQUFNDZUSUTDUQUGDFTDVBFAIUJUKBFUQUHULBF
      AUIUMUN $.

    $( The "universal" set (as large as possible given ~ eldiophss ) is
       Diophantine.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    vdioph $p |- ( A e. NN0 -> ( NN0 ^m ( 1 ... A ) ) e. ( Dioph ` A ) ) $=
      ( va cn0 wcel c1 cfz cmap cc0 wceq crab cdioph cfv wral eqid rgenw rabid2
      co mpbir cz cmpt cmzp cvv 0z mzpconstmpt mp2an eq0rabdioph mpan2 syl5eqel
      ovex ) ACDZCEAFQZGQZHHIZBULJZAKLZULUNIUMBULMUMBULHNOUMBULPRUJBSUKGQHTUKUA
      LDZUNUODUKUBDHSDUPEAFUIUCBHUKUDUEBHAUFUGUH $.

    $( Diophantine set builder for conjunctions.  (Contributed by Stefan
       O'Rear, 10-Oct-2014.) $)
    anrabdioph $p |- ( ( { t e. ( NN0 ^m ( 1 ... N ) ) | ph } e. ( Dioph ` N )
        /\ { t e. ( NN0 ^m ( 1 ... N ) ) | ps } e. ( Dioph ` N ) ) -> { t e. (
        NN0 ^m ( 1 ... N ) ) | ( ph /\ ps ) } e. ( Dioph ` N ) ) $=
      ( cn0 c1 cfz co cmap crab cdioph cfv wcel wa cin inrab diophin syl5eqelr
      ) ACEFDGHIHZJZDKLZMBCSJZUAMNABNCSJTUBOUAABCSPTUBDQR $.

    $( Diophantine set builder for disjunctions.  (Contributed by Stefan
       O'Rear, 10-Oct-2014.) $)
    orrabdioph $p |- ( ( { t e. ( NN0 ^m ( 1 ... N ) ) | ph } e. ( Dioph ` N )
        /\ { t e. ( NN0 ^m ( 1 ... N ) ) | ps } e. ( Dioph ` N ) ) -> { t e. (
        NN0 ^m ( 1 ... N ) ) | ( ph \/ ps ) } e. ( Dioph ` N ) ) $=
      ( cn0 c1 cfz co cmap crab cdioph cfv wcel wa cun unrab diophun syl5eqelr
      wo ) ACEFDGHIHZJZDKLZMBCTJZUBMNABSCTJUAUCOUBABCTPUAUCDQR $.

    $( Diophantine set builder for ternary conjunctions.  (Contributed by
       Stefan O'Rear, 10-Oct-2014.) $)
    3anrabdioph $p |- ( ( { t e. ( NN0 ^m ( 1 ... N ) ) | ph } e. ( Dioph ` N )
        /\ { t e. ( NN0 ^m ( 1 ... N ) ) | ps } e. ( Dioph ` N ) /\ { t e. (
        NN0 ^m ( 1 ... N ) ) | ch } e. ( Dioph ` N ) ) -> { t e. ( NN0 ^m ( 1
        ... N ) ) | ( ph /\ ps /\ ch ) } e. ( Dioph ` N ) ) $=
      ( cn0 c1 cfz co cmap crab cdioph cfv wcel w3a wa wb cv df-3an anrabdioph
      a1i rabbiia sylan syl5eqel 3impa ) ADFGEHIJIZKELMZNZBDUFKUGNZCDUFKUGNZABC
      OZDUFKZUGNUHUIPZUJPULABPZCPZDUFKZUGUKUODUFUKUOQDRUFNABCSUAUBUMUNDUFKUGNUJ
      UPUGNABDETUNCDETUCUDUE $.

    $( Diophantine set builder for ternary disjunctions.  (Contributed by
       Stefan O'Rear, 10-Oct-2014.) $)
    3orrabdioph $p |- ( ( { t e. ( NN0 ^m ( 1 ... N ) ) | ph } e. ( Dioph ` N )
        /\ { t e. ( NN0 ^m ( 1 ... N ) ) | ps } e. ( Dioph ` N ) /\ { t e. (
        NN0 ^m ( 1 ... N ) ) | ch } e. ( Dioph ` N ) ) -> { t e. ( NN0 ^m ( 1
        ... N ) ) | ( ph \/ ps \/ ch ) } e. ( Dioph ` N ) ) $=
      ( cn0 c1 cfz co cmap crab cdioph cfv wcel w3o wa wo wb cv orrabdioph a1i
      df-3or rabbiia sylan syl5eqel 3impa ) ADFGEHIJIZKELMZNZBDUGKUHNZCDUGKUHNZ
      ABCOZDUGKZUHNUIUJPZUKPUMABQZCQZDUGKZUHULUPDUGULUPRDSUGNABCUBUAUCUNUODUGKU
      HNUKUQUHNABDETUOCDETUDUEUF $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 4 miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A c $.  $d B c $.  $d C b $.  $d a c $.  $d b c $.  $d C a $.
    $( Exchange an existential quantifier with two substitutions.  (Contributed
       by Stefan O'Rear, 11-Oct-2014.)  (Revised by NM, 24-Aug-2018.) $)
    2sbcrex $p |- ( [. A / a ]. [. B / b ]. E. c e. C ph
       <-> E. c e. C [. A / a ]. [. B / b ]. ph ) $=
      ( wrex wsbc sbcrex sbcbii bitri ) AGDHFCIZEBIAFCIZGDHZEBINEBIGDHMOEBAFGCD
      JKNEGBDJL $.
  $}

  ${
    $d A c $.  $d B c $.  $d C b $.  $d a c $.  $d b c $.  $d C a $.
    2sbcrex.1 $e |- A e. _V $.
    2sbcrex.2 $e |- B e. _V $.
    $( Exchange an existential quantifier with two substitutions.  (Contributed
       by Stefan O'Rear, 11-Oct-2014.)  Obsolete as of 24-Aug-2018.  Use
       ~ csbov123 instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    2sbcrexOLD $p |- ( [. A / a ]. [. B / b ]. E. c e. C ph
       <-> E. c e. C [. A / a ]. [. B / b ]. ph ) $=
      ( wrex wsbc cvv wcel wb sbcrexgOLD ax-mp sbcbii bitri ) AGDJFCKZEBKAFCKZG
      DJZEBKZTEBKGDJZSUAEBCLMSUANIAFGCDLOPQBLMUBUCNHTEGBDLOPR $.
  $}

  ${
    $d A b $.  $d A c $.  $d B a $.  $d C a $.  $d a b $.  $d a c $.
    $( Exchange a substitution with two existentials.  (Contributed by Stefan
       O'Rear, 11-Oct-2014.)  (Revised by NM, 24-Aug-2018.) $)
    sbc2rex $p |- ( [. A / a ]. E. b e. B E. c e. C ph
       <-> E. b e. B E. c e. C [. A / a ]. ph ) $=
      ( wrex wsbc sbcrex rexbii bitri ) AGDHZFCHEBIMEBIZFCHAEBIGDHZFCHMEFBCJNOF
      CAEGBDJKL $.

    $( Exchange a substitution with two existentials.  (Contributed by Stefan
       O'Rear, 11-Oct-2014.)  Obsolete as of 24-Aug-2018.  Use ~ csbov123
       instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbc2rexgOLD $p |- ( A e. V -> ( [. A / a ]. E. b e. B E. c e. C ph
       <-> E. b e. B E. c e. C [. A / a ]. ph ) ) $=
      ( wcel cvv wrex wsbc wb elex sbcrexgOLD rexbidv bitrd syl ) BEIBJIZAHDKZG
      CKFBLZAFBLHDKZGCKZMBENSUATFBLZGCKUCTFGBCJOSUDUBGCAFHBDJOPQR $.

    $d A d $.  $d A e $.  $d D a $.  $d E a $.  $d a d $.  $d a e $.
    $( Exchange a substitution with 4 existentials.  (Contributed by Stefan
       O'Rear, 11-Oct-2014.)  (Revised by NM, 24-Aug-2018.) $)
    sbc4rex $p |- ( [. A / a ]. E. b e. B E. c e. C E. d e. D E. e e. E ph
           <-> E. b e. B E. c e. C E. d e. D E. e e. E [. A / a ]. ph ) $=
      ( wrex wsbc sbc2rex 2rexbii bitri ) AFGLKELZJDLICLHBMQHBMZJDLICLAHBMFGLKE
      LZJDLICLQBCDHIJNRSIJCDABEGHKFNOP $.

    $( Exchange a substitution with 4 existentials.  (Contributed by Stefan
       O'Rear, 11-Oct-2014.)  Obsolete as of 24-Aug-2018.  Use ~ csbov123
       instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    sbc4rexgOLD $p |- ( A e. V
      -> ( [. A / a ]. E. b e. B E. c e. C E. d e. D E. e e. E ph
           <-> E. b e. B E. c e. C E. d e. D E. e e. E [. A / a ]. ph ) ) $=
      ( wcel cvv wrex wsbc wb elex sbc2rexgOLD 2rexbidv bitrd syl ) BHMBNMZAFGO
      LEOZKDOJCOIBPZAIBPFGOLEOZKDOJCOZQBHRUCUEUDIBPZKDOJCOUGUDBCDNIJKSUCUHUFJKC
      DABEGNILFSTUAUB $.
  $}

  ${
    $d A b $.  $d A c $.  $d B a $.  $d C a $.  $d a c $.  $d a b $.
    $( also my first direct use of sp $)
    $( Rotate a sequence of three explicit substitutions.  (Contributed by
       Stefan O'Rear, 11-Oct-2014.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    sbcrot3 $p |- ( [. A / a ]. [. B / b ]. [. C / c ]. ph <->
      [. B / b ]. [. C / c ]. [. A / a ]. ph ) $=
      ( wsbc sbccom sbcbii bitri ) AGDHZFCHEBHLEBHZFCHAEBHGDHZFCHLEFBCIMNFCAEGB
      DIJK $.

    $d A d $.  $d A e $.  $d D a $.  $d E a $.  $d a e $.  $d a d $.
    $( Rotate a sequence of five explicit substitutions.  (Contributed by
       Stefan O'Rear, 11-Oct-2014.)  (Revised by Mario Carneiro,
       11-Dec-2016.) $)
    sbcrot5 $p |- ( [. A / a ]. [. B / b ]. [. C / c ]. [. D / d ].
        [. E / e ]. ph
      <-> [. B / b ]. [. C / c ]. [. D / d ]. [. E / e ]. [. A / a ]. ph ) $=
      ( wsbc sbcrot3 sbcbii bitri ) AFGLKELZJDLICLHBLPHBLZJDLZICLAHBLFGLKELZJDL
      ZICLPBCDHIJMRTICQSJDABEGHKFMNNO $.
  $}

  ${
    $d A a c $.  $d A a b $.  $d C a c $.
    sbccomieg.1 $e |- ( a = A -> B = C ) $.
    $( Commute two explicit substitutions, using an implicit substitution to
       rewrite the exiting substitution.  (Contributed by Stefan O'Rear,
       11-Oct-2014.)  (Revised by Mario Carneiro, 11-Dec-2016.) $)
    sbccomieg $p |- ( [. A / a ]. [. B / b ]. ph
         <-> [. C / b ]. [. A / a ]. ph ) $=
      ( wsbc cvv wcel sbcex wex spesbc exlimiv syl nfcv nfsbc1v nfsbc cv wceq
      wb dfsbcq sbceq1a sbcbidv bitrd sbciegf pm5.21nii ) AFCHZEBHBIJZAEBHZFDHZ
      UHEBKUKUJFLUIUJFDMUJUIFAEBKNOUHUKEBIUJEFDEDPAEBQRESBTZUHAFDHZUKULCDTUHUMU
      AGAFCDUBOULAUJFDAEBUCUDUEUFUG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 4: Quantification
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d N t u v a b c d e $.  $d M t u v a b c d e $.  $d ph u v a b c d e $.
    $d ps t a b c d e $.  $d ch v a b c d e $.
    rexrabdioph.1 $e |- M = ( N + 1 ) $.
    rexrabdioph.2 $e |- ( v = ( t ` M ) -> ( ps <-> ch ) ) $.
    rexrabdioph.3 $e |- ( u = ( t |` ( 1 ... N ) ) -> ( ch <-> ph ) ) $.
    $( Diophantine set builder for existential quantification.  (Contributed by
       Stefan O'Rear, 10-Oct-2014.) $)
    rexrabdioph $p |- ( ( N e. NN0 /\ { t e. ( NN0 ^m ( 1 ... M ) ) | ph } e. (
        Dioph ` M ) ) -> { u e. ( NN0 ^m ( 1 ... N ) ) | E. v e. NN0 ps } e. (
        Dioph ` N ) ) $=
      ( va vb cn0 wcel wa wrex wceq wsbc dfsbcq vc c1 cfz co cmap cdioph cfv cv
      crab cab df-rab cbvrexv anbi2i r19.42v bitr4i cop csn simpll simpr simplr
      cun mapfzcons syl3anc adantrr wb mapfzcons2 syl2anc eqcomd syl mapfzcons1
      cres sbcbidv bitrd biimpd reseq1 eqeq2d anbi12d rspcev syl12anc rexlimdva
      impr fveq1 ex wf cn caddc nn0p1nn syl5eqel elfz1end sylib ffvelrn syl2anr
      elmapi adantr simprr mapfzcons1cl ad2antlr eqeltrd simprl ad2antll mpbird
      anbi2d impbid syl5bb abbidv syl5eq nfcv nfv nfsbc1v nfsbc sbceq1a rexbidv
      nfrex weq cbvrex syl6bb cbvrab rexrab abbii 3eqtr4g fvex vex resex sbc2ie
      sylan9bb a1i rabbiia rexeqi syl6eq simpl nn0z uzid peano2uz 3syl diophrex
      cuz cz ) HNOZAFNUBGUCUDZUEUDZUIZGUFUGOZPZBDNQZENUBHUCUDZUEUDZUIZLUHZMUHZU
      UEVKZRZMUUAQZLUJZHUFUGZYRUUGUUMRUUBYRUUGUUKMBEFUHZUUEVKZSZDGUUOUGZSZFYTUI
      ZQZLUJZUUMYRBEUUHSZDUUISZMNQZLUUFUIZBEUUJSZDGUUIUGZSZUUKPZMYTQZLUJZUUGUVB
      YRUVFUUHUUFOZUVEPZLUJUVLUVELUUFUKYRUVNUVKLUVNUVMUVCDUAUHZSZPZUANQZYRUVKUV
      NUVMUVPUANQZPUVRUVEUVSUVMUVDUVPMUANUVCDUUIUVOTULUMUVMUVPUANUNUOYRUVRUVKYR
      UVQUVKUANYRUVONOZPZUVQUVKUWAUVQPUUHGUVOUPUQVAZYTOZBEUWBUUEVKZSZDGUWBUGZSZ
      UUHUWDRZUVKUWAUVMUWCUVPUWAUVMPZYRUVMUVTUWCYRUVTUVMURUWAUVMUSZYRUVTUVMUTZU
      UHNUVOGHIVBVCVDUWAUVMUVPUWGUWIUVPUWGUWIUVPUVCDUWFSZUWGUWIUVOUWFRUVPUWLVEU
      WIUWFUVOUWIUVMUVTUWFUVORUWJUWKUUHNUVOGHIVFVGVHUVCDUVOUWFTVIUWIUVCUWEDUWFU
      WIUWHUVCUWEVEUWIUWDUUHUWIUVMUWDUUHRUWJUUHNUVOGHIVJVIVHZBEUUHUWDTVIVLVMVNW
      AUWAUVMUWHUVPUWMVDUVJUWGUWHPMUWBYTUUIUWBRZUVIUWGUUKUWHUWNUVIUVGDUWFSZUWGU
      WNUVHUWFRUVIUWOVEGUUIUWBWBUVGDUVHUWFTVIUWNUVGUWEDUWFUWNUUJUWDRUVGUWEVEUUI
      UWBUUEVOZBEUUJUWDTVIVLVMUWNUUJUWDUUHUWPVPVQVRVSWCVTYRUVJUVRMYTYRUUIYTOZPZ
      UVJUVRUWRUVJPZUVHNOZUVMUVCDUVHSZUVRUWRUWTUVJUWQYSNUUIWDGYSOZUWTYRUUINYSWM
      YRGWEOUXBYRGHUBWFUDZWEIHWGWHGWIWJYSNGUUIWKWLWNUWSUUHUUJUUFUWRUVIUUKWOUWQU
      UJUUFOYRUVJUUINGHIWPWQWRUWSUXAUVIUWRUVIUUKWSUUKUXAUVIVEUWRUVIUUKUVCUVGDUV
      HBEUUHUUJTVLWTXAUVQUVMUXAPUAUVHNUVOUVHRUVPUXAUVMUVCDUVOUVHTXBVRVSWCVTXCXD
      XEXFUUDUVEELUUFEUUFXGLUUFXGUUDLXHUVDEMNENXGUVCEDUUIEUUIXGBEUUHXIXJXMELXNZ
      UUDUVCDNQUVEUXDBUVCDNBEUUHXKXLUVCUVDDMNUVCMXHUVCDUUIXIUVCDUUIXKXOXPXQUVAU
      VKLUUSUVIUUKMFYTFMXNZUUSUUQDUVHSZUVIUXEUURUVHRUUSUXFVEGUUOUUIWBUUQDUURUVH
      TVIUXEUUQUVGDUVHUXEUUPUUJRUUQUVGVEUUOUUIUUEVOBEUUPUUJTVIVLVMXRXSXTUVAUULL
      UUKMUUTUUAUUSAFYTUUSAVEUUOYTOBADEUURUUPGUUOYAUUOUUEFYBYCDUHUURRBCEUHUUPRA
      JKYEYDYFYGYHXSYIWNUUCYRGHYPUGZOZUUBUUMUUNOYRUUBYJYRUXHUUBYRGUXCUXGIYRHYQO
      HUXGOUXCUXGOHYKHYLHHYMYNWHWNYRUUBUSMLUUAGHYOVCWR $.
  $}

  ${
    $d G a b c d e f t u v w x y z p q $.
    $d H a b c d e f t u v w x y z p q $.
    $d I a b c d e f t u v w x y z p q $.
    $d J a b c d e f t u v w x y z p q $.
    $d K a b c d e f t u v w x y z p q $.
    $d L a b c d e f t u v w x y z p q $.
    $d M a b c d e f t u v w x y z p q $.
    $d N a b c d e f t u v w x y z p q $.  $d ph a b c d e f t $.
    rexfrabdioph.1 $e |- M = ( N + 1 ) $.
    $( Diophantine set builder for existential quantifier, explicit
       substitution.  (Contributed by Stefan O'Rear, 11-Oct-2014.)  (Revised by
       Stefan O'Rear, 6-May-2015.) $)
    rexfrabdioph $p |- ( ( N e. NN0 /\ { t e. ( NN0 ^m ( 1 ... M ) )
   | [. ( t |` ( 1 ... N ) ) / u ]. [. ( t ` M ) / v ]. ph } e. ( Dioph ` M ) )
      -> { u e. ( NN0 ^m ( 1 ... N ) ) | E. v e. NN0 ph } e. ( Dioph ` N ) ) $=
      ( vb va cn0 wcel cv cfv wsbc c1 cfz co crab wrex nfcv cres cmap cdioph wa
      nfv nfsbc1v nfrex sbceq1a cbvrex rexbidv syl5bb cbvrab dfsbcq rexrabdioph
      wceq sbcbidv syl5eqel ) FJKABEDLZMZNZCUROFPQZUAZNZDJOEPQUBQREUCMKUDABJSZC
      JVAUBQZRABHLZNZCILZNZHJSZIVERFUCMVDVJCIVECVETIVETVDIUEVICHJCJTVGCVHUFUGVD
      VGHJSCLVHUOZVJAVGBHJAHUEABVFUFABVFUHUIVKVGVIHJVGCVHUHUJUKULVCVIUTCVHNHIDE
      FGVFUSUOVGUTCVHABVFUSUMUPUTCVHVBUMUNUQ $.

    rexfrabdioph.2 $e |- L = ( M + 1 ) $.
    $( Diophantine set builder for existential quantifier, explicit
       substitution, two variables.  (Contributed by Stefan O'Rear,
       11-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    2rexfrabdioph $p |- ( ( N e. NN0 /\ { t e. ( NN0 ^m ( 1 ... L ) )
 | [. ( t |` ( 1 ... N ) ) / u ]. [. ( t ` M ) / v ]. [. ( t ` L ) / w ]. ph }
  e. ( Dioph ` L ) ) -> { u e. ( NN0 ^m ( 1 ... N ) ) | E. v e. NN0 E. w e.
        NN0 ph } e. ( Dioph ` N ) ) $=
      ( va cn0 wcel cfv wsbc c1 cfz co cres crab cv cmap cdioph wrex wa 2sbcrex
      wb a1i rabbiia caddc peano2nn0 adantr sbcrot3 sbcbii reseq1 sbccomieg wss
      syl5eqel wceq fzssp1 oveq2i sseqtr4i resabs1 dfsbcq cvv vex resex sbcco3g
      mp2b fveq1 ax-mp nn0p1nn elfz1end sylib fvres 3syl syl5bb sbcbidv syl5rbb
      cn rabbidv eleq1d biimpa rexfrabdioph syl2anc syldan ) HLMZABFEUAZNZOZCGW
      HNZOZDWHPHQRZSZOZELPFQRUBRZTZFUCNZMZABLUDZCGKUAZNZODXAWMSZOZKLPGQRZUBRZTZ
      GUCNZMWTCLUDDLWMUBRTHUCNMWGWSUEZXGACXBODXCOZBLUDZKXFTZXHXDXKKXFXDXKUGXAXF
      MAXCXBLDCBUFUHUIXIGLMZXJBWIOZKWHXESZOZEWPTZWRMZXLXHMWGXMWSWGGHPUJRZLIHUKU
      RULWGWSXRWGWQXQWRWGWOXPEWPXPWJCXBOZDXCOZKXOOZWGWOXNYAKXOAWIXCXBBDCUMUNYBX
      TKXOOZDXOWMSZOZWGWOXTXOXCYDKDXAXOWMUOUPYEYCDWNOZWGWOWMXEUQYDWNUSYEYFUGWMP
      XSQRXEPHUTGXSPQIVAVBWHWMXEVCYCDYDWNVDVIWGYCWLDWNYCWJCGXONZOZWGWLXOVEMYCYH
      UGWHXEEVFVGWJKCXOXBYGVEGXAXOVJVHVKWGGXEMZYGWKUSYHWLUGWGGVTMYIWGGXSVTIHVLU
      RGVMVNGXEWHVOWJCYGWKVDVPVQVRVQVQVSWAWBWCXJBKEFGJWDWEURWTCDKGHIWDWF $.

    rexfrabdioph.3 $e |- K = ( L + 1 ) $.
    $( Diophantine set builder for existential quantifier, explicit
       substitution, two variables.  (Contributed by Stefan O'Rear,
       17-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    3rexfrabdioph $p |- ( ( N e. NN0
          /\ { t e. ( NN0 ^m ( 1 ... K ) )
      | [. ( t |` ( 1 ... N ) ) / u ]. [. ( t ` M ) / v ]. [. ( t ` L ) / w ].
      [. ( t ` K ) / x ]. ph } e. ( Dioph ` K ) )
   -> { u e. ( NN0 ^m ( 1 ... N ) )
        | E. v e. NN0 E. w e. NN0 E. x e. NN0 ph } e. ( Dioph ` N ) ) $=
      ( va cn0 wcel cfv wsbc c1 co cv cfz cres cmap crab cdioph wrex wa sbc2rex
      wb sbcbii bitri a1i rabbiia caddc cn nn0p1nn nnnn0d adantr sbcrot3 reseq1
      syl5eqel sbccomieg wss wceq fzssp1 oveq2i sseqtr4i resabs1 dfsbcq cvv vex
      mp2b resex fveq1 sbcco3g ax-mp elfz1end sylib 3syl syl5bb sbcbidv syl5bbr
      fvres rabbidv eleq1d biimpar 2rexfrabdioph syl2anc rexfrabdioph syldan )
      JOPZABGFUAZQZRCHWMQZRZDIWMQZRZEWMSJUBTZUCZRZFOSGUBTUDTZUEZGUFQZPZABOUGCOU
      GZDINUAZQZRZEXGWSUCZRZNOSIUBTZUDTZUEZIUFQZPXFDOUGEOWSUDTUEJUFQPWLXEUHZXNA
      DXHRZEXJRZBOUGCOUGZNXMUEZXOXKXSNXMXKXSUJXGXMPXKXQBOUGCOUGZEXJRXSXIYAEXJAX
      HOODCBUIUKXQXJOOECBUIULUMUNXPIOPZXRBWNRCWORZNWMXLUCZRZFXBUEZXDPZXTXOPWLYB
      XEWLIWLIJSUOTZUPKJUQVBZURUSWLYGXEWLYFXCXDWLYEXAFXBYEWPDXHRZEXJRZNYDRZWLXA
      YKYCNYDYKXQBWNRCWORZEXJRYCYJYMEXJAXHWOWNDCBUTUKXQXJWOWNECBUTULUKYLYJNYDRZ
      EYDWSUCZRZWLXAYJYDXJYONEXGYDWSVAVCYPYNEWTRZWLXAWSXLVDYOWTVEYPYQUJWSSYHUBT
      XLSJVFIYHSUBKVGVHWMWSXLVIYNEYOWTVJVMWLYNWREWTYNWPDIYDQZRZWLWRYDVKPYNYSUJW
      MXLFVLVNWPNDYDXHYRVKIXGYDVOVPVQWLIXLPZYRWQVEYSWRUJWLIUPPYTYIIVRVSIXLWMWDW
      PDYRWQVJVTWAWBWAWAWCWEWFWGXRBCNFGHILMWHWIVBXFDENIJKWJWK $.

    rexfrabdioph.4 $e |- J = ( K + 1 ) $.
    $( Diophantine set builder for existential quantifier, explicit
       substitution, four variables.  (Contributed by Stefan O'Rear,
       11-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    4rexfrabdioph $p |- ( ( N e. NN0 /\ { t e. ( NN0 ^m ( 1 ... J ) )
       | [. ( t |` ( 1 ... N ) ) / u ]. [. ( t ` M ) / v ]. [. ( t ` L ) / w ].
       [. ( t ` K ) / x ]. [. ( t ` J ) / y ]. ph } e. ( Dioph ` J ) )
   -> { u e. ( NN0 ^m ( 1 ... N ) ) | E. v e. NN0 E. w e. NN0 E. x e. NN0
        E. y e. NN0 ph } e. ( Dioph ` N ) ) $=
      ( va cn0 wcel wsbc cv cfv c1 cfz co cres cmap crab cdioph wrex wa 2sbcrex
      wb rexbii bitri sbcbii sbcrex rabbiia caddc cn nn0p1nn syl5eqel peano2nnd
      nnnn0d adantr sbcrot3 bitr3i reseq1 sbccomieg wceq fzssp1 oveq2i sseqtr4i
      a1i wss sstri resabs1 dfsbcq mp2b fveq1 elfz1end sylib fvres 3syl cvv vex
      sseldi resex sbcco3g syl5bb sbcbidv rabbidv biimpar 2rexfrabdioph syl2anc
      ax-mp bitrd eleq1d syldan ) LRSZACHGUAZUBZTZBIXAUBZTZDJXAUBZTZEKXAUBZTZFX
      AUCLUDUEZUFZTZGRUCHUDUEUGUEZUHZHUIUBZSZACRUJZBRUJZDJQUAZUBZTEKXSUBZTZFXSX
      JUFZTZQRUCJUDUEZUGUEZUHZJUIUBZSXRDRUJERUJFRXJUGUEUHLUIUBSWTXPUKZYGADXTTEY
      ATZFYCTZCRUJZBRUJZQYFUHZYHYDYMQYFYDYMUMXSYFSYDYJCRUJZBRUJZFYCTZYMYBYPFYCY
      BXQDXTTEYATZBRUJYPXQYAXTREDBULYRYOBRAYAXTREDCULUNUOUPYQYOFYCTZBRUJYMYOFBY
      CRUQYSYLBRYJFCYCRUQUNUOUOVNURYIJRSZYKCXBTBXDTZQXAYEUFZTZGXMUHZXOSZYNYHSWT
      YTXPWTJWTJKUCUSUEZUTNWTKWTKLUCUSUEZUTMLVAVBZVCVBZVDVEWTUUEXPWTUUDXNXOWTUU
      CXLGXMUUCXEDXTTZEYATZFYCTZQUUBTZWTXLUUAUULQUUBUUAYJCXBTZBXDTZFYCTUULYJYCX
      DXBFBCVFUUOUUKFYCUUOXCDXTTEYATZBXDTUUKUUNUUPBXDAXBYAXTCEDVFUPXCXDYAXTBEDV
      FUOUPVGUPUUMUUKQUUBTZFUUBXJUFZTZWTXLUUKUUBYCUURQFXSUUBXJVHVIUUSUUQFXKTZWT
      XLXJYEVOUURXKVJUUSUUTUMXJUCKUDUEZYEXJUCUUGUDUEUVAUCLVKKUUGUCUDMVLVMUVAUCU
      UFUDUEYEUCKVKJUUFUCUDNVLVMZVPXAXJYEVQUUQFUURXKVRVSWTUUQXIFXKUUQUUJQUUBTZE
      KUUBUBZTZWTXIUUJUUBYAUVDQEKXSUUBVTVIWTUVEUVCEXHTZXIWTKYESUVDXHVJUVEUVFUMW
      TUVAYEKUVBWTKUTSKUVASUUHKWAWBWGKYEXAWCUVCEUVDXHVRWDWTUVCXGEXHUVCXEDJUUBUB
      ZTZWTXGUUBWESUVCUVHUMXAYEGWFWHXEQDUUBXTUVGWEJXSUUBVTWIWPWTJYESZUVGXFVJUVH
      XGUMWTJUTSUVIUUIJWAWBJYEXAWCXEDUVGXFVRWDWJWKWQWJWKWJWJWJWLWRWMYKCBQGHIJOP
      WNWOVBXRDEFQJKLMNWNWS $.

    rexfrabdioph.5 $e |- I = ( J + 1 ) $.
    rexfrabdioph.6 $e |- H = ( I + 1 ) $.
    $( Diophantine set builder for existential quantifier, explicit
       substitution, six variables.  (Contributed by Stefan O'Rear,
       11-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    6rexfrabdioph $p |- ( ( N e. NN0 /\ { t e. ( NN0 ^m ( 1 ... H ) )
       | [. ( t |` ( 1 ... N ) ) / u ]. [. ( t ` M ) / v ]. [. ( t ` L ) / w ].
       [. ( t ` K ) / x ]. [. ( t ` J ) / y ]. [. ( t ` I ) / z ].
       [. ( t ` H ) / p ]. ph } e. ( Dioph ` H ) )
  -> { u e. ( NN0 ^m ( 1 ... N ) ) | E. v e. NN0 E. w e. NN0 E. x e. NN0
       E. y e. NN0 E. z e. NN0 E. p e. NN0 ph } e. ( Dioph ` N ) ) $=
      ( va cn0 wcel cv cfv wsbc c1 cfz co cres cmap crab cdioph wrex wa sbc4rex
      wb sbcbii bitri rabbiia caddc cn nn0p1nn syl5eqel peano2nnd nnnn0d adantr
      a1i sbcrot5 reseq1 sbccomieg wss wceq fzssp1 oveq2i sseqtr4i sstri dfsbcq
      resabs1 mp2b fveq1 elfz1end sylib sseldi fvres 3syl cvv vex resex sbcco3g
      ax-mp syl5bb sbcbidv syl5bbr rabbidv eleq1d biimpar 4rexfrabdioph syl2anc
      bitrd 2rexfrabdioph syldan ) OUDUEZAPIHUFZUGZUHDJXFUGZUHCKXFUGZUHBLXFUGZU
      HZEMXFUGZUHZFNXFUGZUHZGXFUIOUJUKZULZUHZHUDUIIUJUKUMUKZUNZIUOUGZUEZAPUDUPD
      UDUPCUDUPBUDUPZEMUCUFZUGZUHZFNYDUGZUHZGYDXPULZUHZUCUDUIMUJUKZUMUKZUNZMUOU
      GZUEYCEUDUPFUDUPGUDXPUMUKUNOUOUGUEXEYBUQZYMAEYEUHZFYGUHZGYIUHZPUDUPDUDUPC
      UDUPBUDUPZUCYLUNZYNYJYSUCYLYJYSUSYDYLUEYJYQPUDUPDUDUPCUDUPBUDUPZGYIUHYSYH
      UUAGYIYHYPPUDUPDUDUPCUDUPBUDUPZFYGUHUUAYFUUBFYGAYEUDUDUDPUDEBCDURUTYPYGUD
      UDUDPUDFBCDURVAUTYQYIUDUDUDPUDGBCDURVAVJVBYOMUDUEZYRPXGUHDXHUHCXIUHBXJUHZ
      UCXFYKULZUHZHXSUNZYAUEZYTYNUEXEUUCYBXEMXEMNUIVCUKZVDRXENXENOUIVCUKZVDQOVE
      VFZVGVFZVHVIXEUUHYBXEUUGXTYAXEUUFXRHXSUUFXKEYEUHZFYGUHZGYIUHZUCUUEUHZXEXR
      UUOUUDUCUUEUUOYQPXGUHDXHUHCXIUHBXJUHZGYIUHUUDUUNUUQGYIUUNYPPXGUHDXHUHCXIU
      HBXJUHZFYGUHUUQUUMUURFYGAYEXJXIXHPXGEBCDVKUTYPYGXJXIXHPXGFBCDVKVAUTYQYIXJ
      XIXHPXGGBCDVKVAUTUUPUUNUCUUEUHZGUUEXPULZUHZXEXRUUNUUEYIUUTUCGYDUUEXPVLVMU
      VAUUSGXQUHZXEXRXPYKVNUUTXQVOUVAUVBUSXPUINUJUKZYKXPUIUUJUJUKUVCUIOVPNUUJUI
      UJQVQVRUVCUIUUIUJUKYKUINVPMUUIUIUJRVQVRZVSXFXPYKWAUUSGUUTXQVTWBXEUUSXOGXQ
      UUSUUMUCUUEUHZFNUUEUGZUHZXEXOUUMUUEYGUVFUCFNYDUUEWCVMXEUVGUVEFXNUHZXOXENY
      KUEUVFXNVOUVGUVHUSXEUVCYKNUVDXENVDUENUVCUEUUKNWDWEWFNYKXFWGUVEFUVFXNVTWHX
      EUVEXMFXNUVEXKEMUUEUGZUHZXEXMUUEWIUEUVEUVJUSXFYKHWJWKXKUCEUUEYEUVIWIMYDUU
      EWCWLWMXEMYKUEZUVIXLVOUVJXMUSXEMVDUEUVKUULMWDWEMYKXFWGXKEUVIXLVTWHWNWOXBW
      NWOWNWNWPWQWRWSYRDPCBUCHIJKLMSTUAUBWTXAVFYCEFGUCMNOQRXCXD $.

    rexfrabdioph.7 $e |- G = ( H + 1 ) $.
    $( Diophantine set builder for existential quantifier, explicit
       substitution, seven variables.  (Contributed by Stefan O'Rear,
       11-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    7rexfrabdioph $p |- ( ( N e. NN0 /\ { t e. ( NN0 ^m ( 1 ... G ) )
       | [. ( t |` ( 1 ... N ) ) / u ]. [. ( t ` M ) / v ]. [. ( t ` L ) / w ].
       [. ( t ` K ) / x ]. [. ( t ` J ) / y ]. [. ( t ` I ) / z ].
       [. ( t ` H ) / p ]. [. ( t ` G ) / q ]. ph } e. ( Dioph ` G ) )
  -> { u e. ( NN0 ^m ( 1 ... N ) ) | E. v e. NN0 E. w e. NN0 E. x e. NN0
     E. y e. NN0 E. z e. NN0 E. p e. NN0 E. q e. NN0 ph } e. ( Dioph ` N ) ) $=
      ( va cn0 wcel cv cfv wsbc c1 cfz co cres cmap crab cdioph wrex wa sbc2rex
      wb sbc4rex 2rexbii bitri sbcbii 3bitri a1i rabbiia caddc nn0p1nn syl5eqel
      nnnn0d adantr sbcrot3 sbcrot5 reseq1 sbccomieg wss fzssp1 oveq2i sseqtr4i
      wceq resabs1 dfsbcq mp2b cvv vex resex fveq1 sbcco3g ax-mp elfz1end sylib
      cn fvres 3syl syl5bb sbcbidv syl5bbr rabbidv eleq1d biimpar 6rexfrabdioph
      syl2anc rexfrabdioph syldan ) PUGUHZAQIHUIZUJZUKRJXIUJZUKDKXIUJZUKCLXIUJZ
      UKZBMXIUJZUKENXIUJZUKZFOXIUJZUKZGXIULPUMUNZUOZUKZHUGULIUMUNUPUNZUQZIURUJZ
      UHZAQUGUSRUGUSDUGUSCUGUSZBUGUSEUGUSZFOUFUIZUJZUKZGYIXTUOZUKZUFUGULOUMUNZU
      PUNZUQZOURUJZUHYHFUGUSGUGXTUPUNUQPURUJUHXHYFUTZYPAFYJUKZGYLUKZQUGUSRUGUSD
      UGUSCUGUSZBUGUSEUGUSZUFYOUQZYQYMUUBUFYOYMUUBVBYIYOUHYMYSQUGUSRUGUSDUGUSCU
      GUSZBUGUSEUGUSZGYLUKUUDGYLUKZBUGUSEUGUSUUBYKUUEGYLYKYGFYJUKZBUGUSEUGUSUUE
      YGYJUGUGFEBVAUUGUUDEBUGUGAYJUGUGUGQUGFCDRVCVDVEVFUUDYLUGUGGEBVAUUFUUAEBUG
      UGYSYLUGUGUGQUGGCDRVCVDVGVHVIYROUGUHZYTQXJUKRXKUKDXLUKCXMUKZBXOUKZEXPUKZU
      FXIYNUOZUKZHYCUQZYEUHZUUCYQUHXHUUHYFXHOXHOPULVJUNZWOSPVKVLZVMVNXHUUOYFXHU
      UNYDYEXHUUMYBHYCUUMXQFYJUKZGYLUKZUFUULUKZXHYBUUSUUKUFUULUUSXNFYJUKZBXOUKE
      XPUKZGYLUKUVAGYLUKZBXOUKZEXPUKUUKUURUVBGYLXNYJXPXOFEBVOVFUVAYLXPXOGEBVOUV
      DUUJEXPUVCUUIBXOUVCYSQXJUKRXKUKDXLUKCXMUKZGYLUKUUIUVAUVEGYLAYJXMXLXKQXJFC
      DRVPVFYSYLXMXLXKQXJGCDRVPVEVFVFVGVFUUTUURUFUULUKZGUULXTUOZUKZXHYBUURUULYL
      UVGUFGYIUULXTVQVRUVHUVFGYAUKZXHYBXTYNVSUVGYAWCUVHUVIVBXTULUUPUMUNYNULPVTO
      UUPULUMSWAWBXIXTYNWDUVFGUVGYAWEWFXHUVFXSGYAUVFXQFOUULUJZUKZXHXSUULWGUHUVF
      UVKVBXIYNHWHWIXQUFFUULYJUVJWGOYIUULWJWKWLXHOYNUHZUVJXRWCUVKXSVBXHOWOUHUVL
      UUQOWMWNOYNXIWPXQFUVJXRWEWQWRWSWRWRWTXAXBXCYTCDRBEUFHIJKLMNOQTUAUBUCUDUEX
      DXEVLYHFGUFOPSXFXG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 5: Arithmetic sets
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d N t $.
    $( Lemma for arithmetic diophantine sets.  Convert polynomial-ness of an
       expression into a constraint suitable for ~ ralimi .  (Contributed by
       Stefan O'Rear, 10-Oct-2014.) $)
    rabdiophlem1 $p |- ( ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e. ( mzPoly ` ( 1
        ... N ) ) -> A. t e. ( NN0 ^m ( 1 ... N ) ) A e. ZZ ) $=
      ( cn0 c1 cfz co cmap cz wss cmpt cmzp cfv wcel cvv zex nn0ssz mapss mp2an
      wral wf mzpf eqid fmpt sylibr ssralv mpsyl ) DECFGZHGZIUHHGZJZAUJBKZUHLMN
      ZBINZAUJTZUNAUITIONDIJUKPQDIUHORSUMUJIULUAUOULUHUBAUJIBULULUCUDUEUNAUIUJU
      FUG $.
  $}

  ${
    $d N a b c u t $.  $d M a b c u t $.  $d A a b c t $.
    rabdiophlem2.1 $e |- M = ( N + 1 ) $.
    $( Lemma for arithmetic diophantine sets.  Reuse a polynomial expression
       under a new quantifier.  (Contributed by Stefan O'Rear, 10-Oct-2014.) $)
    rabdiophlem2 $p |- ( ( N e. NN0 /\ ( u e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e.
        ( mzPoly ` ( 1 ... N ) ) ) -> ( t e. ( ZZ ^m ( 1 ... M ) ) |-> [_ ( t
        |` ( 1 ... N ) ) / u ]_ A ) e. ( mzPoly ` ( 1 ... M ) ) ) $=
      ( va wcel cz c1 cfz co cmap cmpt cmzp cfv wa cv csb nfcsb1v cn0 cres nfcv
      csbeq1a cbvmpt fveq1i wceq mapfzcons1cl adantl wral mzpf eqid fmpt sylibr
      wf ad2antlr nfel1 eleq1d rspc csbeq1 fvmptg syl2anc syl5req mpteq2dva cvv
      sylc wss ovex a1i caddc fzssp1 oveq2i sseqtr4i simpr mzpresrename syl3anc
      eqeltrd ) EUAHZAIJEKLZMLZCNZVSOPHZQZBIJDKLZMLZABRZVSUBZCSZNBWEWGWAPZNZWDO
      PZWCBWEWHWIWCWFWEHZQZWIWGGVTAGRZCSZNZPZWHWGWAWPAGVTCWOGCUCAWNCTAWNCUDUEUF
      WMWGVTHZWHIHZWQWHUGWLWRWCWFIDEFUHUIZWMWRCIHZAVTUJZWSWTWBXBVRWLWBVTIWAUOXB
      WAVSUKAVTICWAWAULUMUNUPXAWSAWGVTAWHIAWGCTUQARWGUGCWHIAWGCUDURUSVFGWGWOWHV
      TIWPAWNWGCUTWPULVAVBVCVDWCWDVEHZVSWDVGZWBWJWKHXCWCJDKVHVIXDWCVSJEJVJLZKLW
      DJEVKDXEJKFVLVMVIVRWBVNBWAVSWDVOVPVQ $.
  $}

  ${
    $d A a b c $.  $d N a b c t $.
    $( Diophantine set builder for nonnegativity constraints.  The first
       builder which uses a witness variable internally; an expression is
       nonnegative if there is a nonnegative integer equal to it.  (Contributed
       by Stefan O'Rear, 11-Oct-2014.) $)
    elnn0rabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e.
        ( mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A e. NN0
        } e. ( Dioph ` N ) ) $=
      ( vb va vc cn0 wcel cz c1 cfz co cmap cmpt cmzp cfv crab cv wceq nfcv csb
      wa wrex cdioph risset a1i rabbiia nfv nfcsb1v nfeq2 nfrex csbeq1a rexbidv
      wb eqeq2d cbvrab syl6eq caddc cres peano2nn0 adantr ovex nn0p1nn elfz1end
      cvv cn sylib mzpproj sylancr rabdiophlem2 eqrabdioph syl3anc eqeq1 csbeq1
      eqid rexrabdioph syldan eqeltrd ) CGHZAIJCKLZMLBNVTOPHZUBZBGHZAGVTMLZQZDR
      ZAERZBUAZSZDGUCZEWDQZCUDPZWBWEWFBSZDGUCZAWDQZWKWEWOSWBWCWNAWDWCWNUNARZWDH
      DBGUEUFUGUFWNWJAEWDAWDTEWDTWNEUHWIADGAGTAWFWHAWGBUIUJUKWPWGSZWMWIDGWQBWHW
      FAWGBULUOUMUPUQVSWACJURLZFRZPZAWSVTUSZBUAZSZFGJWRKLZMLQWRUDPHZWKWLHWBWRGH
      ZFIXDMLZWTNXDOPZHZFXGXBNXHHXEVSXFWACUTVAWBXDVEHWRXDHZXIJWRKVBVSXJWAVSWRVF
      HXJCVCWRVDVGVAFXDWRVHVIAFBWRCWRVOZVJFWTXBWRVKVLXCWIWTWHSDEFWRCXKWFWTWHVMW
      GXASWHXBWTAWGXABVNUOVPVQVR $.
  $}

  ${
    $d ph y a b c $.  $d ps x a b c $.  $d ch x a b c $.  $d x y $.
    rexzrexnn0.1 $e |- ( x = y -> ( ph <-> ps ) ) $.
    rexzrexnn0.2 $e |- ( x = -u y -> ( ph <-> ch ) ) $.
    $( Rewrite a quantification over integers into a quantification over
       naturals.  (Contributed by Stefan O'Rear, 11-Oct-2014.) $)
    rexzrexnn0 $p |- ( E. x e. ZZ ph <-> E. y e. NN0 ( ps \/ ch ) ) $=
      ( cz wrex wo cn0 cv wcel wa cneg simpr wceq wb bicomd rspcev cr elznn0 ex
      simprbi adantr simplr equcoms syl2anc zcn negnegd eqcomd negeq syl5ibrcom
      eqeq2d imp syl adantlr rspcedv impancom orim12d mpd r19.43 rexlimiva nn0z
      sylibr sylan nn0negz jaodan impbii ) ADHIZBCJZEKIZAVLDHDLZHMZANZBEKIZCEKI
      ZJZVLVOVMKMZVMOZKMZJZVRVNWBAVNVMUAMWBVMUBUDUEVOVSVPWAVQVOVSVPVOVSNVSAVPVO
      VSPVNAVSUFBAEVMKELZVMQABABRDEFUGSTUHUCVNWAAVQVNWANCAEVTKVNWAPVNWCVTQZCARW
      AVNWDNZACWEVMWCOZQZACRVNWDWGVNWGWDVMVTOZQVNWHVMVNVMVMUIUJUKWDWFWHVMWCVTUL
      UNUMUOGUPSUQURUSUTVABCEKVBVEVCVKVJEKWCKMZBVJCWIWCHMBVJWCVDABDWCHFTVFWIWFH
      MCVJWCVGACDWFHGTVFVHVCVI $.
  $}

  ${
    $d N t $.  $d M t $.
    $( Diophantine set builder for the less or equals relation.  (Contributed
       by Stefan O'Rear, 11-Oct-2014.) $)
    lerabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e. (
        mzPoly ` ( 1 ... N ) ) /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> B ) e. (
        mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A <_ B } e.
        ( Dioph ` N ) ) $=
      ( cn0 wcel cz c1 cfz co cmap cmpt cmzp cfv crab wral rabdiophlem1 3adant1
      w3a wa cle cmin cdioph wceq wb znn0sub ralimi r19.26 rabbi 3imtr3i syl2an
      wbr simp1 mzpsubmpt ancoms elnn0rabdioph syl2anc eqeltrd ) DEFZAGHDIJZKJZ
      BLUTMNZFZAVACLVBFZSZBCUAULZAEUTKJZOZCBUBJZEFZAVGOZDUCNZVCVDVHVKUDZUSVCBGF
      ZAVGPZCGFZAVGPZVMVDABDQACDQVNVPTZAVGPVFVJUEZAVGPVOVQTVMVRVSAVGBCUFUGVNVPA
      VGUHVFVJAVGUIUJUKRVEUSAVAVILVBFZVKVLFUSVCVDUMVCVDVTUSVDVCVTACBUTUNUORAVID
      UPUQUR $.

    $( Diophantine set builder for membership in a fixed set of upper
       integers.  (Contributed by Stefan O'Rear, 11-Oct-2014.) $)
    eluzrabdioph $p |- ( ( N e. NN0 /\ M e. ZZ /\ ( t e. ( ZZ ^m ( 1 ... N ) )
        |-> A ) e. ( mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) )
        | A e. ( ZZ>= ` M ) } e. ( Dioph ` N ) ) $=
      ( cn0 wcel cz c1 cfz co cmap cmpt cmzp cfv w3a cuz crab cle wbr wral wceq
      cdioph wa wb rabdiophlem1 eluz ralimdv imp sylan2 rabbi sylib 3adant1 cvv
      ex ovex mzpconstmpt mpan lerabdioph syl3an2 eqeltrd ) DEFZCGFZAGHDIJZKJZB
      LVCMNZFZOBCPNFZAEVCKJZQZCBRSZAVHQZDUBNZVBVFVIVKUAZVAVBVFUCVGVJUDZAVHTZVMV
      FVBBGFZAVHTZVOABDUEVBVQVOVBVPVNAVHVBVPVNCBUFUNUGUHUIVGVJAVHUJUKULVBVAAVDC
      LVEFZVFVKVLFVCUMFVBVRHDIUOACVCUPUQACBDURUSUT $.

    $( Diophantine set builder for positivity.  (Contributed by Stefan O'Rear,
       11-Oct-2014.) $)
    elnnrabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e.
        ( mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A e. NN }
        e. ( Dioph ` N ) ) $=
      ( cn0 wcel cz c1 cfz co cmap cmpt cmzp cfv wa cn crab cuz cdioph wb cv 1z
      elnnuz a1i rabbiia eluzrabdioph mp3an2 syl5eqel ) CDEZAFGCHIZJIBKUILMEZNB
      OEZADUIJIZPBGQMEZAULPZCRMZUKUMAULUKUMSATULEBUBUCUDUHGFEUJUNUOEUAABGCUEUFU
      G $.

    $( Diophantine set builder for the strict less than relation.  (Contributed
       by Stefan O'Rear, 11-Oct-2014.) $)
    ltrabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e. (
        mzPoly ` ( 1 ... N ) ) /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> B ) e. (
        mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A < B } e.
        ( Dioph ` N ) ) $=
      ( cn0 wcel cz c1 cfz co cmap cmpt cmzp cfv crab wral rabdiophlem1 3adant1
      w3a wa clt wbr cmin cn cdioph wceq wb znnsub ralimi r19.26 3imtr3i syl2an
      rabbi simp1 mzpsubmpt ancoms elnnrabdioph syl2anc eqeltrd ) DEFZAGHDIJZKJ
      ZBLVAMNZFZAVBCLVCFZSZBCUAUBZAEVAKJZOZCBUCJZUDFZAVHOZDUENZVDVEVIVLUFZUTVDB
      GFZAVHPZCGFZAVHPZVNVEABDQACDQVOVQTZAVHPVGVKUGZAVHPVPVRTVNVSVTAVHBCUHUIVOV
      QAVHUJVGVKAVHUMUKULRVFUTAVBVJLVCFZVLVMFUTVDVEUNVDVEWAUTVEVDWAACBVAUOUPRAV
      JDUQURUS $.

    $( Diophantine set builder for inequality.  This not quite trivial theorem
       touches on something important; Diophantine sets are not closed under
       negation, but they contain an important subclass that is, namely the
       recursive sets.  With this theorem and De Morgan's laws, all
       quantifier-free formulae can be negated.  (Contributed by Stefan O'Rear,
       11-Oct-2014.) $)
    nerabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e. (
        mzPoly ` ( 1 ... N ) ) /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> B ) e. (
        mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A =/= B }
        e. ( Dioph ` N ) ) $=
      ( cn0 wcel cz co cmap cmpt cfv crab clt wbr rabdiophlem1 wa cr zre syl2an
      wral c1 cfz cmzp w3a wo cdioph wceq wb lttri2 ralimi r19.26 rabbi 3imtr3i
      wne 3adant1 ltrabdioph 3com23 orrabdioph syl2anc eqeltrd ) DEFZAGUADUBHZI
      HZBJVBUCKZFZAVCCJVDFZUDZBCUNZAEVBIHZLZBCMNZCBMNZUEZAVILZDUFKZVEVFVJVNUGZV
      AVEBGFZAVITZCGFZAVITZVPVFABDOACDOVQVSPZAVITVHVMUHZAVITVRVTPVPWAWBAVIVQBQF
      CQFWBVSBRCRBCUISUJVQVSAVIUKVHVMAVIULUMSUOVGVKAVILVOFVLAVILVOFZVNVOFABCDUP
      VAVFVEWCACBDUPUQVKVLADURUSUT $.
  $}

  ${
    $d N a b c d t $.  $d A a b c d $.  $d B a b c d $.

    $( Divisibility is a Diophantine relation.  (Contributed by Stefan O'Rear,
       11-Oct-2014.) $)
    dvdsrabdioph $p |- ( ( N e. NN0 /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> A ) e.
        ( mzPoly ` ( 1 ... N ) ) /\ ( t e. ( ZZ ^m ( 1 ... N ) ) |-> B ) e. (
        mzPoly ` ( 1 ... N ) ) ) -> { t e. ( NN0 ^m ( 1 ... N ) ) | A || B } e.
        ( Dioph ` N ) ) $=
      ( vb va vc cn0 wcel cz c1 co cmap cmpt cfv crab cv cmul wceq nfcv cfz w3a
      cmzp cdivides wbr cneg wo wrex cdioph wral rabdiophlem1 wa divides eqeq1d
      wb oveq1 rexzrexnn0 syl6bb ralimi r19.26 rabbi 3imtr3i syl2an 3adant1 csb
      nfv nfcsb1v nfov nfeq nfrex csbeq1a oveq2d eqeq12d orbi12d rexbidv cbvrab
      nfor caddc cres simp1 peano2nn0 3ad2ant1 ovex cn nn0p1nn elfz1end mzpproj
      cvv sylancr adantr eqid rabdiophlem2 mzpmulmpt syl2anc 3adant3 eqrabdioph
      sylib 3adant2 syl3anc mzpnegmpt syl orrabdioph negeq rexrabdioph syl5eqel
      oveq1d csbeq1 eqeltrd ) DHIZAJKDUALZMLZBNXJUCOZIZAXKCNXLIZUBZBCUDUEZAHXJM
      LZPZEQZBRLZCSZXSUFZBRLZCSZUGZEHUHZAXQPZDUIOZXMXNXRYGSZXIXMBJIZAXQUJZCJIZA
      XQUJZYIXNABDUKACDUKYJYLULZAXQUJXPYFUOZAXQUJYKYMULYIYNYOAXQYNXPFQZBRLZCSZF
      JUHYFFBCUMYRYAYDFEYPXSSYQXTCYPXSBRUPUNYPYBSYQYCCYPYBBRUPUNUQURUSYJYLAXQUT
      XPYFAXQVAVBVCVDXOYGXSAYPBVEZRLZAYPCVEZSZYBYSRLZUUASZUGZEHUHZFXQPZYHYFUUFA
      FXQAXQTFXQTYFFVFUUEAEHAHTUUBUUDAAYTUUAAXSYSRAXSTARTZAYPBVGZVHAYPCVGZVIAUU
      CUUAAYBYSRAYBTUUHUUIVHUUJVIVQVJAQYPSZYEUUEEHUUKYAUUBYDUUDUUKXTYTCUUAUUKBY
      SXSRAYPBVKZVLAYPCVKZVMUUKYCUUCCUUAUUKBYSYBRUULVLUUMVMVNVOVPXOXIDKVRLZGQZO
      ZAUUOXJVSZBVEZRLZAUUQCVEZSZUUPUFZUURRLZUUTSZUGZGHKUUNUALZMLZPUUNUIOZIZUUG
      YHIXIXMXNVTXOUVAGUVGPUVHIZUVDGUVGPUVHIZUVIXOUUNHIZGJUVFMLZUUSNUVFUCOZIZGU
      VMUUTNUVNIZUVJXIXMUVLXNDWAWBZXIXMUVOXNXIXMULZGUVMUUPNUVNIZGUVMUURNUVNIZUV
      OXIUVSXMXIUVFWHIUUNUVFIZUVSKUUNUAWCXIUUNWDIUWADWEUUNWFWQGUVFUUNWGWIWJZAGB
      UUNDUUNWKZWLZGUUPUURUVFWMWNWOXIXNUVPXMAGCUUNDUWCWLWRZGUUSUUTUUNWPWSXOUVLG
      UVMUVCNUVNIZUVPUVKUVQXIXMUWFXNUVRGUVMUVBNUVNIZUVTUWFUVRUVSUWGUWBGUUPUVFWT
      XAUWDGUVBUURUVFWMWNWOUWEGUVCUUTUUNWPWSUVAUVDGUUNXBWNUVEUUEUUPYSRLZUUASZUV
      BYSRLZUUASZUGEFGUUNDUWCXSUUPSZUUBUWIUUDUWKUWLYTUWHUUAXSUUPYSRUPUNUWLUUCUW
      JUUAUWLYBUVBYSRXSUUPXCXFUNVNYPUUQSZUWIUVAUWKUVDUWMUWHUUSUUAUUTUWMYSUURUUP
      RAYPUUQBXGZVLAYPUUQCXGZVMUWMUWJUVCUUAUUTUWMYSUURUVBRUWNVLUWOVMVNXDWNXEXH
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 6 miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a $.

    $( A finite set of positive integers is a set of positive integers.
       (Contributed by Stefan O'Rear, 16-Oct-2014.) $)
    fz1ssnn $p |- ( 1 ... A ) C_ NN $=
      ( va c1 cfz co cn cv elfznn ssriv ) BCADEFBGAHI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Diophantine sets 6: reusability.  renumbering of variables
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d W a b c p u t w $.  $d S a b c p u t w $.  $d N a b c p u t w $.
    $d P a b c p u t w $.
    eldioph4b.a $e |- W e. _V $.
    eldioph4b.b $e |- -. W e. Fin $.
    eldioph4b.c $e |- ( W i^i NN ) = (/) $.
    $( Membership in ` Dioph ` expressed using a quantified union to add
       witness variables instead of a restriction to remove them.  (Contributed
       by Stefan O'Rear, 16-Oct-2014.) $)
    eldioph4b $p |- ( S e. ( Dioph ` N ) <-> ( N e. NN0 /\ E. p e. ( mzPoly ` (
        W u. ( 1 ... N ) ) ) S = { t e. ( NN0 ^m ( 1 ... N ) ) | E. w e. ( NN0
        ^m W ) ( p ` ( t u. w ) ) = 0 } ) ) $=
      ( vu cfv wcel cn0 cun cc0 wceq wrex cres wa c0 cdioph cv cmap co cfz crab
      c1 cmzp eldiophelnn0 cab cvv cfn wn wb ovex unex jctr intnanr unfir ssun2
      wss pm3.2i eldioph2b sylancl elmapssres mpan2 adantr ssun1 resundi eqtr4i
      mto uncom wfn elmapi ffn fnresdm 3syl syl5eq fveq2d eqeq1d biimpar rspcev
      uneq2 syl2anc jca eleq1 uneq1 rexbidv anbi12d syl5ibrcom expimpd rexlimiv
      wf ancomsd cin fz1ssnn sslin ax-mp sseqtri reseq2i res0 eqtri elmapresaun
      cn ss0 mp3an3 ancoms syl5eqel reseq1i elmapresaunres2 simpr reseq1 eqeq2d
      syl5req fveq2 syl12anc ex rexlimdva imp impbii abbii df-rab eqeq2i rexbii
      syl6bb biadan2 ) CDUAKLZDMLZCBUBZAUBZNZFUBZKZOPZAMEUCUDZQZBMUGDUEUDZUCUDZ
      UFZPZFEYQNZUHKZQZCDUIYHYGCYIJUBZYQRZPZUUDYLKZOPZSZJMUUAUCUDZQZBUJZPZFUUBQ
      ZUUCYHYHUUAUKLZSUUAULLZUMZYQUUAVAZSYGUUNUNYHUUOEYQGUGDUEUOUPUQUUQUURUUPEU
      LLZYQULLZSUUSUUTHUREYQUSVKYQEUTZVBJBCUUADFVCVDUUMYTFUUBUULYSCUULYIYRLZYPS
      ZBUJYSUUKUVCBUUKUVCUUIUVCJUUJUUDUUJLZUUHUUFUVCUVDUUHUUFUVCUVDUUHSZUVCUUFU
      UEYRLZUUEYJNZYLKZOPZAYOQZSUVEUVFUVJUVDUVFUUHUVDUURUVFUVAUUDMUUAYQVEVFVGUV
      EUUDERZYOLZUUEUVKNZYLKZOPZUVJUVDUVLUUHUVDEUUAVAUVLEYQVHUUDMUUAEVEVFVGUVDU
      VOUUHUVDUVNUUGOUVDUVMUUDYLUVDUVMUUDUUARZUUDUVMUVKUUENUVPUUEUVKVLUUDEYQVIV
      JUVDUUAMUUDWMUUDUUAVMUVPUUDPUUDMUUAVNUUAMUUDVOUUAUUDVPVQVRVSVTWAUVIUVOAUV
      KYOYJUVKPZUVHUVNOUVQUVGUVMYLYJUVKUUEWCVSVTWBWDWEUUFUVBUVFYPUVJYIUUEYRWFUU
      FYNUVIAYOUUFYMUVHOUUFYKUVGYLYIUUEYJWGVSVTWHWIWJWKWNWLUVBYPUUKUVBYNUUKAYOU
      VBYJYOLZSZYNUUKUVSYNSYKUUJLZYIYKYQRZPZYNUUKUVSUVTYNUVSYKYJYINZUUJYIYJVLZU
      VRUVBUWCUUJLZUVRUVBYJEYQWOZRZYIUWFRZPZUWEUWGTUWHUWGYJTRTUWFTYJUWFTVAUWFTP
      UWFEXDWOZTYQXDVAUWFUWJVADWPYQXDEWQWRIWSUWFXEWRZWTYJXAXBUWHYITRTUWFTYIUWKW
      TYIXAXBVJZEYQMYJYIXCXFXGXHVGUVSUWBYNUVSUWAUWCYQRZYIYKUWCYQUWDXIUVRUVBUWMY
      IPZUVRUVBUWIUWNUWLEYQMYJYIXJXFXGXNVGUVSYNXKUUIUWBYNSJYKUUJUUDYKPZUUFUWBUU
      HYNUWOUUEUWAYIUUDYKYQXLXMUWOUUGYMOUUDYKYLXOVTWIWBXPXQXRXSXTYAYPBYRYBVJYCY
      DYEYF $.

    $( Forward-only version of ~ eldioph4b .  (Contributed by Stefan O'Rear,
       16-Oct-2014.) $)
    eldioph4i $p |- ( ( N e. NN0 /\ P e. ( mzPoly ` ( W u. ( 1 ... N ) ) ) ) ->
        { t e. ( NN0 ^m ( 1 ... N ) ) | E. w e. ( NN0 ^m W ) ( P ` ( t u. w ) )
        = 0 } e. ( Dioph ` N ) ) $=
      ( va vb vp cn0 wcel co cun cfv cv cc0 wceq wrex cfz cmzp cmap crab cdioph
      c1 wa weq uneq1 fveq2d eqeq1d rexbidv uneq2 cbvrexv cbvrabv fveq1 rabbidv
      syl6bb eqeq2d rspcev mpan2 anim2i eldioph4b sylibr ) DLMZCEUFDUANZOUBPZMZ
      UGVEBQZAQZOZCPZRSZALEUCNZTZBLVFUCNZUDZIQZJQZOZKQZPZRSZJVNTZIVPUDZSZKVGTZU
      GVQDUEPMVHWGVEVHVQVTCPZRSZJVNTZIVPUDZSZWGVOWJBIVPBIUHZVOVRVJOZCPZRSZAVNTW
      JWMVMWPAVNWMVLWORWMVKWNCVIVRVJUIUJUKULWPWIAJVNAJUHZWOWHRWQWNVTCVJVSVRUMUJ
      UKUNURUOWFWLKCVGWACSZWEWKVQWRWDWJIVPWRWCWIJVNWRWBWHRVTWACUPUKULUQUSUTVAVB
      JIVQDEKFGHVCVD $.
  $}

  ${
    $d S a b c d e f g h i $.  $d M a b c d e f g h i $.
    $d N a b c d e f g h i $.  $d F a b c d e f g h i $.
    $( Change variables in a Diophantine set, using class notation.  This
       allows already proved Diophantine sets to be reused in contexts with
       more variables.  (Contributed by Stefan O'Rear, 16-Oct-2014.)  (Revised
       by Stefan O'Rear, 5-Jun-2015.) $)
    diophren $p |- ( ( S e. ( Dioph ` N ) /\ M e. NN0 /\
          F : ( 1 ... N ) --> ( 1 ... M ) ) ->
        { a e. ( NN0 ^m ( 1 ... M ) ) | ( a o. F ) e. S } e. ( Dioph ` M ) ) $=
      ( vd cfv wcel cn0 c1 co ccom cmap wa cun cc0 wceq cz cn c0 vc vb ve wf cv
      cdioph cfz crab cdif wrex cmzp cvv zex difexg ax-mp cfn com ominf cen wbr
      wb caddc cuz nnuz 0p1e1 fveq2i eqtr4i difeq2i 0z lzenom eqbrtri mtbir cin
      enfi incom disjdif eqtri eldioph4b cres cmpt simpr simp-4r mapco2 syl2anc
      cid ovex uneq1 fveq2d eqeq1d rexbidv elrab3 syl simp-5r simplr w3a coundi
      coundir elmapi 3ad2ant3 simp1 wss fz1ssnn ssdisj mp2an a1i coeq0i syl3anc
      uneq2d syl5eq un0 3ad2ant2 wf1o f1oi f1of mp3an23 coires1 wfn ffn fnresdm
      syl6eq 3syl uneq12d uncom syl5req nn0ssz mapss reseq2i elmapresaun oveq2i
      res0 syl6eleq mp3an3 sseldi adantll coeq1 eqid fvex fvmpt eqtr4d rexbidva
      bitrd rabbidva simplll id fun syl21anc feq1i ad3antlr mzprename eldioph4i
      unex sylib eqeltrd eleq2 rabbidv eleq1d syl5ibrcom rexlimdva syl5bi 3impb
      expimpd impcom ) ADUFGHZCIHZJDUGKZJCUGKZBUDZEUEZBLZAHZEIUVFMKZUHZCUFGZHZU
      VDUVGNZUVCUVNUVCDIHZAUAUEZFUEZOZUBUEZGZPQZFIRSUIZMKZUJZUAIUVEMKZUHZQZUBUW
      CUVEOZUKGZUJZNUVOUVNFUAADUWCUBRULHZUWCULHUMRSULUNUOZUWCUPHZUQUPHZURUWCUQU
      SUTUWNUWOVAUWCRPJVBKZVCGZUIZUQUSSUWQRSJVCGUWQVDUWPJVCVEVFVGVHPRHUWRUQUSUT
      VIPVJUOVKUWCUQVNUOVLZUWCSVMSUWCVMZTUWCSVOSRVPZVQZVRUVOUVPUWKUVNUVOUVPNZUW
      HUVNUBUWJUXCUVTUWJHZNZUVNUWHUVIUWGHZEUVKUHZUVMHUXEUXGUVHUVROZUCRUWCUVFOZM
      KZUCUEZBWEUWCVSZOZLZUVTGZVTZGZPQZFUWDUJZEUVKUHZUVMUXEUXFUXSEUVKUXEUVHUVKH
      ZNZUXFUVIUVROZUVTGZPQZFUWDUJZUXSUYBUVIUWFHZUXFUYFVAUYBUYAUVGUYGUXEUYAWAUV
      DUVGUVPUXDUYAWBUVHIUVFBUVEJDUGWFWCWDUWEUYFUAUVIUWFUVQUVIQZUWBUYEFUWDUYHUW
      AUYDPUYHUVSUYCUVTUVQUVIUVRWGWHWIWJWKWLUYBUYEUXRFUWDUYBUVRUWDHZNZUYDUXQPUY
      JUYDUXHUXMLZUVTGZUXQUYJUYCUYKUVTUYJUVGUYAUYIUYCUYKQUVDUVGUVPUXDUYAUYIWMUX
      EUYAUYIWNUYBUYIWAUVGUYAUYIWOZUYKUXHBLZUXHUXLLZOUYCUXHBUXLWPUYMUYNUVIUYOUV
      RUYMUYNUVITOZUVIUYMUYNUVIUVRBLZOUYPUVHUVRBWQUYMUYQTUVIUYMUWCIUVRUDZUVGUWC
      UVFVMZTQZUYQTQUYIUVGUYRUYAUVRIUWCWRZWSUVGUYAUYIWTUYTUYMUYSUVFUWCVMZTUWCUV
      FVOUVFSXAUWTTQZVUBTQZCXBUXAUVFSUWCXCXDZVQXEUVRBUWCIUVEUVFXFXGXHXIUVIXJXTU
      YMUYOTUVROZUVRUYMUYOUVHUXLLZUVRUXLLZOVUFUVHUVRUXLWQUYMVUGTVUHUVRUYMUVFIUV
      HUDZVUGTQZUYAUVGVUIUYIUVHIUVFWRXKVUIUWCUWCUXLUDZVUDVUJUWCUWCUXLXLVUKUWCXM
      UWCUWCUXLXNUOZVUEUVHUXLUVFIUWCUWCXFXOWLUYIUVGVUHUVRQUYAUYIVUHUVRUWCVSZUVR
      UVRUWCXPUYIUYRUVRUWCXQVUMUVRQVUAUWCIUVRXRUWCUVRXSYAXIWSYBXIVUFUVRTOUVRTUV
      RYCUVRXJVQXTYBYDXGWHUYJUXHUXJHZUXQUYLQUYAUYIVUNUXEUYAUYINIUXIMKZUXJUXHUWL
      IRXAVUOUXJXAUMYEIRUXIULYFXDUYAUYIUVHVUBVSZUVRVUBVSZQZUXHVUOHVUPTVUQVUPUVH
      TVSTVUBTUVHVUEYGUVHYJVQVUQUVRTVSTVUBTUVRVUEYGUVRYJVQVGUYAUYIVURWOUXHIUVFU
      WCOZMKVUOUVFUWCIUVHUVRYHVUSUXIIMUVFUWCYCYIYKYLYMYNUCUXHUXOUYLUXJUXPUXKUXH
      QUXNUYKUVTUXKUXHUXMYOWHUXPYPUYKUVTYQYRWLYSWIYTUUAUUBUXEUVDUXPUXIUKGHZUXTU
      VMHUVDUVGUVPUXDUUCUXEUXIULHZUXDUWIUXIUXMUDZVUTVVAUXEUWCUVFUWMJCUGWFUUKXEU
      XCUXDWAUVGVVBUVDUVPUXDUVGUWIUXIUXLBOZUDZVVBUVGVUKUVGUWCUVEVMZTQZVVDVUKUVG
      VULXEUVGUUDVVFUVGVVEUVEUWCVMZTUWCUVEVOUVESXAVUCVVGTQDXBUXAUVESUWCXCXDVQXE
      UWCUVEUWCUVFUXLBUUEUUFUWIUXIVVCUXMUXLBYCUUGUULUUHUCUXMUVTUWIUXIUUIXGFEUXP
      CUWCUWMUWSUXBUUJWDUUMUWHUVLUXGUVMUWHUVJUXFEUVKAUWGUVIUUNUUOUUPUUQUURUVAUU
      SUVBUUT $.
  $}

  ${
    $d ph b $.  $d A a b $.  $d B a b $.  $d F a b $.
    $( Change variable numbers in a Diophantine class abstraction using
       explicit substitution.  (Contributed by Stefan O'Rear, 17-Oct-2014.) $)
    rabrenfdioph $p |- ( ( B e. NN0 /\ F : ( 1 ... A ) --> ( 1 ... B ) /\
          { a e. ( NN0 ^m ( 1 ... A ) ) | ph } e. ( Dioph ` A ) ) ->
        { b e. ( NN0 ^m ( 1 ... B ) ) | [. ( b o. F ) / a ]. ph } e.
          ( Dioph ` B ) ) $=
      ( cn0 wcel c1 cfz co wf cmap crab cdioph cfv w3a cv ccom wa simplr mapco2
      wsbc wceq simpr ovex syl2anc biantrurd nfcv elrabsf syl6bbr 3adant3 3coml
      rabbidva diophren eqeltrd ) CGHZIBJKZICJKZDLZAEGURMKZNZBOPHZQAEFRZDSZUCZF
      GUSMKZNZVEVBHZFVGNZCOPZUQUTVHVJUDVCUQUTTZVFVIFVGVLVDVGHZTZVFVEVAHZVFTVIVN
      VOVFVNVMUTVOVLVMUEUQUTVMUAVDGUSDURIBJUFUBUGUHAEVEVAEVAUIUJUKUNULVCUQUTVJV
      KHVBDCBFUOUMUP $.
  $}

  ${
    $d ps a $.  $d ph b $.  $d X a b $.  $d Y a b $.  $d Z a b $.  $d N a b $.
    rabren3dioph.a $e |- ( ( ( a ` 1 ) = ( b ` X ) /\ ( a ` 2 ) = ( b ` Y ) /\
      ( a ` 3 ) = ( b ` Z ) ) -> ( ph <-> ps ) ) $.
    rabren3dioph.b $e |- X e. ( 1 ... N ) $.
    rabren3dioph.c $e |- Y e. ( 1 ... N ) $.
    rabren3dioph.d $e |- Z e. ( 1 ... N ) $.
    $( Change variable numbers in a 3-variable Diophantine class abstraction.
       (Contributed by Stefan O'Rear, 17-Oct-2014.) $)
    rabren3dioph $p |- ( ( N e. NN0 /\ { a e. ( NN0 ^m ( 1 ... 3 ) ) | ph } e.
        ( Dioph ` 3 ) ) -> { b e. ( NN0 ^m ( 1 ... N ) ) | ps } e.
        ( Dioph ` N ) ) $=
      ( wcel c1 c3 co cfv c2 wceq mp2an cn0 cfz cmap crab cdioph wa cv cop ccom
      ctp wsbc wb vex tpex coex w3a wfn wne 1ne2 1re 1lt3 ltneii 2re 1ex cn 2nn
      2lt3 elexi 3nn fntp mp3an tpid1 fvco2 fvtp1 eqtri tpid2 fvtp2 tpid3 fvtp3
      fveq2i 3pm3.2i fveq1 eqeq1d 3anbi123d mpbiri syl sbcie a1i rabbiia wf wss
      ftp caddc cz fztp ax-mp ax-1cn 2cn addcomi df-3 eqtr4i oveq2i eqidd 1p1e2
      tpeq123d 3eqtr3i feq2i mpbir tpss mpbi fss rabrenfdioph mp3an2 syl5eqelr
      1z ) CUAMZAGUANOUBPZUCPUDOUEQMZUFBHUANCUBPZUCPZUDAGHUGZNDUHZREUHZOFUHZUJZ
      UIZUKZHXTUDZCUEQZYGBHXTYGBULYAXTMABGYFYAYEHUMYBYCYDUNUOGUGZYFSZNYJQZDYAQZ
      SZRYJQZEYAQZSZOYJQZFYAQZSZUPZABULYKUUANYFQZYMSZRYFQZYPSZOYFQZYSSZUPUUCUUE
      UUGUUBNYEQZYAQZYMYENROUJZUQZNUUJMUUBUUISNRURZNOURZROURZUUKUSNOUTVAVBZROVC
      VGVBZNRODEFVDRVEVFVHZOVEVIVHZDXSJVHZEXSKVHZFXSLVHZVJVKZNROVDVLUUJYAYENVMT
      UUHDYAUULUUMUUHDSUSUUONRODEFVDUUSVNTVTVOUUDRYEQZYAQZYPUUKRUUJMUUDUVDSUVBN
      ROUUQVPUUJYAYERVMTUVCEYAUULUUNUVCESUSUUPNRODEFUUQUUTVQTVTVOUUFOYEQZYAQZYS
      UUKOUUJMUUFUVFSUVBNROUURVRUUJYAYEOVMTUVEFYAUUMUUNUVEFSUUOUUPNRODEFUURUVAV
      STVTVOWAYKYNUUCYQUUEYTUUGYKYLUUBYMNYJYFWBWCYKYOUUDYPRYJYFWBWCYKYRUUFYSOYJ
      YFWBWCWDWEIWFWGWHWIXPXQXSYEWJZXRYHYIMXQDEFUJZYEWJZUVHXSWKZUVGUVIUUJUVHYEW
      JNRODEFVDUUQUURUUSUUTUVAUSUUOUUPWLXQUUJUVHYENNRWMPZUBPZNNNWMPZUVKUJZXQUUJ
      NWNMZUVLUVNSXONWOWPUVKONUBUVKRNWMPONRWQWRWSWTXAZXBUVOUVNUUJSXOUVONNUVMRUV
      KOUVONXCUVMRSUVOXDWHUVKOSUVOUVPWHXEWPXFXGXHDXSMZEXSMZFXSMZUPUVJUVQUVRUVSJ
      KLWADEFXSUUSUUTUVAXIXJXQUVHXSYEXKTAOCYEGHXLXMXN $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Pigeonhole Principle and cardinality helpers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y a b c d $.  $d B x y a b c d $.  $d C y a b c d $.
    $d D x a b c d $.  $d ph x y a b c d $.
    fphpd.a $e |- ( ph -> B ~< A ) $.
    fphpd.b $e |- ( ( ph /\ x e. A ) -> C e. B ) $.
    fphpd.c $e |- ( x = y -> C = D ) $.
    $( Pigeonhole principle expressed with implicit substitution.  If the range
       is smaller than the domain, two inputs must be mapped to the same
       output.  (Contributed by Stefan O'Rear, 19-Oct-2014.)  (Revised by
       Stefan O'Rear, 6-May-2015.) $)
    fphpd $p |- ( ph -> E. x e. A E. y e. A ( x =/= y /\ C = D ) ) $=
      ( va wceq cv wi wral wn wa wrex wcel csb vb wne cdom wbr csdm domnsym cvv
      nsyl3 relsdom brrelexi syl adantr nfcsb1v nfel1 nfim eleq1 anbi2d csbeq1a
      nfv eleq1d imbi12d chvar ex wb csbid vex nfcv csbief eqeq12i 2ralbii nfeq
      imbi1i csbeq1 eqeq1d equequ1 eqeq2d equequ2 rspc2 com12 sylbir id impbid1
      syl6 adantl dom2d mpd mtand ancom df-ne anbi1i pm4.61 rexbii rexnal bitri
      3bitr4i sylibr ) AFGLZBMZCMZLZNZCDOZBDOZPZWRWSUBZWQQZCDRZBDRZAXCDEUCUDZXI
      EDUEUDZADEUFHUHAXCQZEUGSZXIAXLXCAXJXLHEDUEUIUJUKULXKKUADEBKMZFTZBUAMZFTZU
      GAXMDSZXNESZNXCAXQXRAWRDSZQZFESZNAXQQZXRNBKYBXRBYBBUSBXNEBXMFUMZUNUOWRXML
      ZXTYBYAXRYDXSXQAWRXMDUPUQYDFXNEBXMFURUTVAIVBVCULXCXQXODSQZXNXPLZXMXOLZVDZ
      NAXCYEYFYGNZYHXCBWRFTZBWSFTZLZWTNZCDOBDOZYEYINYMXABCDDYLWQWTYJFYKGBFVEBWS
      FGCVFBGVGJVHVIVLVJYEYNYIYMYIXNYKLZXMWSLZNBCXMXODDYOYPBBXNYKYCBWSFUMVKYPBU
      SUOYICUSYDYLYOWTYPYDYJXNYKBWRXMFVMVNBKCVOVAWSXOLZYOYFYPYGYQYKXPXNBWSXOFVM
      VPCUAKVQVAVRVSVTYIYFYGYIWABXMXOFVMWBWCWDWEWFWGXHXBPZBDRXDXGYRBDXGXAPZCDRY
      RXFYSCDWTPZWQQWQYTQXFYSYTWQWHXEYTWQWRWSWIWJWQWTWKWOWLXACDWMWNWLXBBDWMWNWP
      $.
  $}

  ${
    $d ph x y z a b c $.  $d A x y z a b c $.  $d B z a b c $.
    $d C x y a b c $.  $d D y z a b c $.  $d E x z a b c $.
    fphpdo.1 $e |- ( ph -> A C_ RR ) $.
    fphpdo.2 $e |- ( ph -> B e. _V ) $.
    fphpdo.3 $e |- ( ph -> B ~< A ) $.
    fphpdo.4 $e |- ( ( ph /\ z e. A ) -> C e. B ) $.
    fphpdo.5 $e |- ( z = x -> C = D ) $.
    fphpdo.6 $e |- ( z = y -> C = E ) $.
    $( Pigeonhole principle for sets of real numbers with implicit output
       reordering.  (Contributed by Stefan O'Rear, 12-Sep-2014.) $)
    fphpdo $p |- ( ph -> E. x e. A E. y e. A ( x < y /\ D = E ) ) $=
      ( vb wceq wa clt wcel vc wne cmpt cfv wrex wbr eqid fmptd ffvelrnda fveq2
      cv fphpd wo cr sselda adantrr adantr adantrl simprl ad2antrr simprr simpr
      lttri2d simplr weq breq1 eqeq1d anbi12d breq2 eqeq2d rspc2ev syl112anc ex
      eqcomd jaod wi eleq1 anbi2d eleq1d imbi12d chvarv syl2anc adantlr eqeq12d
      fvmptg biimpd anim2d reximdva syld sylbid expimpd ancomsd rexlimdvva mpd
      ) APUKZUAUKZUBZWODEGUCZUDZWPWRUDZQZRZUAEUEPEUEBUKZCUKZSUFZHIQZRZCEUEZBEUE
      ZAPUAEFWSWTLAEFWOWRADEGFWRMWRUGZUHUIWOWPWRUJULAXBXIPUAEEAWOETZWPETZRZRZXA
      WQXIXNXAWQXIXNXARZWQWOWPSUFZWPWOSUFZUMZXIXOWOWPXNWOUNTZXAAXKXSXLAEUNWOJUO
      UPUQXNWPUNTZXAAXLXTXKAEUNWPJUOURUQVCXOXRXEXCWRUDZXDWRUDZQZRZCEUEZBEUEZXIX
      OXPYFXQXOXPYFXOXPRXKXLXPXAYFXNXKXAXPAXKXLUSZUTXNXLXAXPAXKXLVAZUTXOXPVBXNX
      AXPVDYDXPXARWOXDSUFZWSYBQZRBCWOWPEEBPVEZXEYIYCYJXCWOXDSVFYKYAWSYBXCWOWRUJ
      VGVHCUAVEZYIXPYJXAXDWPWOSVIYLYBWTWSXDWPWRUJVJVHVKVLVMXOXQYFXOXQRZXLXKXQWT
      WSQZYFXNXLXAXQYHUTXNXKXAXQYGUTXOXQVBYMWSWTXNXAXQVDVNYDXQYNRWPXDSUFZWTYBQZ
      RBCWPWOEEBUAVEZXEYOYCYPXCWPXDSVFYQYAWTYBXCWPWRUJVGVHCPVEZYOXQYPYNXDWOWPSV
      IYRYBWSWTXDWOWRUJVJVHVKVLVMVOAYFXIVPXMXAAYEXHBEAXCETZRZYDXGCEYTXDETZRZYCX
      FXEUUBYCXFUUBYAHYBIUUBYSHFTZYAHQAYSUUAVDYTUUCUUAADUKZETZRZGFTZVPZYTUUCVPD
      BDBVEZUUFYTUUGUUCUUIUUEYSAUUDXCEVQVRUUIGHFNVSVTMWAUQDXCGHEFWRNXJWEWBUUBUU
      AIFTZYBIQYTUUAVBAUUAUUJYSUUHAUUARZUUJVPDCDCVEZUUFUUKUUGUUJUULUUEUUAAUUDXD
      EVQVRUULGIFOVSVTMWAWCDXDGIEFWROXJWEWBWDWFWGWHWHUTWIWJWKWLWMWN $.
  $}

  $( An infinite subset of a countable set is countable, without using choice.
     (Contributed by Stefan O'Rear, 19-Oct-2014.)  (Revised by Stefan O'Rear,
     6-May-2015.) $)
  ctbnfien $p |- ( ( ( X ~~ om /\ Y ~~ om ) /\
        ( A C_ X /\ -. A e. Fin ) ) -> A ~~ Y ) $=
    ( com cen wbr wa wss cfn wcel wn csdm isfinite notbii wo cvv relen brrelexi
    cdom wi ssdomg syl domen2 sylibd imp brdom2 sylib adantlr syl5bi impr enen2
    ord wb ad2antlr mpbird ) BDEFZCDEFZGZABHZAIJZKZGZGACEFZADEFZURUSVAVDVAADLFZ
    KURUSGZVDUTVEAMNVFVEVDUPUSVEVDOZUQUPUSGADSFZVGUPUSVHUPUSABSFZVHUPBPJUSVITBD
    EQRABPUAUBBDAUCUDUEADUFUGUHULUIUJUQVCVDUMUPVBCDAUKUNUO $.

  ${
    $d A x y z $.  $d ph x y z $.  $d B x y z $.  $d D y z $.  $d E x $.
    fiphp3d.a $e |- ( ph -> A ~~ NN ) $.
    fiphp3d.b $e |- ( ph -> B e. Fin ) $.
    fiphp3d.c $e |- ( ( ph /\ x e. A ) -> D e. B ) $.
    $( Infinite pigeonhole principle for partitioning an infinite set between
       finitely many buckets.  (Contributed by Stefan O'Rear, 18-Oct-2014.) $)
    fiphp3d $p |- ( ph -> E. y e. B { x e. A | D = y } ~~ NN ) $=
      ( cv wceq crab cfn wcel wrex cn cen wbr com wa wn wral ominf risset eqcom
      ciun rexbii bitri sylib ralrimiva rabid2 sylibr iunrab syl6reqr eleq1d wb
      nnenom entr sylancl enfi syl bitrd mtbiri iunfi sylan mtand rexnal ssrab2
      wss jctir jctl ctbnfien syl2an ex reximdv mpd ) AFCJZKZBDLZMNZUAZCEOZVSPQ
      RZCEOAVTCEUBZUAWBAWDCEVSUFZMNZAWFSMNZUCAWFDMNZWGAWEDMADVRCEOZBDLZWEAWIBDU
      BDWJKAWIBDABJDNTFENZWIIWKVQFKZCEOWICFEUDWLVRCEVQFUEUGUHUIUJWIBDUKULVRCBED
      UMUNUOADSQRZWHWGUPADPQRPSQRZWMGUQDPSURUSZDSUTVAVBVCAEMNWDWFHCEVSVDVEVFVTC
      EVGULAWAWCCEAWAWCAWMWNTVSDVIZWATWCWAAWMWNWOUQVJWAWPVRBDVHVKVSDPVLVMVNVOVP
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    A non-closed set of reals is infinite
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a b c d x y $.  $d B a b c d x y $.
    $( Lemma for ~ rencldnfi .  (Contributed by Stefan O'Rear, 18-Oct-2014.) $)
    rencldnfilem $p |- ( ( ( A C_ RR /\ B e. RR /\ ( A =/= (/) /\ -. B e. A ) )
        /\ A. x e. RR+ E. y e. A ( abs ` ( y - B ) ) < x ) -> -. A e. Fin ) $=
      ( va vb vc vd cr wss wcel wn wa cv clt wbr wrex crp wral wceq c0 wne cmin
      w3a co cabs cfv cfn crab ccnv csup weq eqeq1 rexbidv elrab simp-4l sseldd
      wi simpr recnd simp-4r subcld simprr ad2antrr nelneq syl2anc cc wb subeq0
      cc0 necon3abid mpbird absrpcld syl5ibrcom rexlimdva expimpd syl5bi adantr
      eleq1 ssrdv cab abrexfi rabssab ssfi sylancl adantl wex simplrl n0 abscld
      sylib eqid oveq1 fveq2d eqeq2d rspcev mpan2 sylanbrc ne0i exlimddv ssrab2
      syl a1i wor ltso mpbi fisupcl mpan syl3anc cle soss mp2 fisupg elrabi vex
      cnvso brcnv notbii lenlt biimprd adantll sylan2 ralimdva adantrd reximdva
      lbinfmle sseldi lenltd mpbid ralrimiva breq2 notbid ralbidv ralnex rexbii
      mpd rexnal bitri ex 3impa con2d imp ) CIJZDIKZCUAUBZDCKLZMZUDZBNZDUCUEZUF
      UGZANZOPZBCQZARSZCUHKZLUUHUUPUUOUUCUUDUUGUUPUUOLZURUUCUUDMZUUGMZUUPUUQUUS
      UUPMZUUMLZBCSZARQZUUQUUTENZFNZDUCUEZUFUGZTZFCQZEIUIZIOUJZUKZRKUUKUVLOPZLZ
      BCSZUVCUUTUVJRUVLUUSUVJRJUUPUUSGUVJRGNZUVJKZUVPIKZUVPUVGTZFCQZMUUSUVPRKZU
      VIUVTEUVPIEGULUVHUVSFCUVDUVPUVGUMUNUOUUSUVRUVTUWAUUSUVRMZUVSUWAFCUWBUVECK
      ZMZUWAUVSUVGRKUWDUVFUWDUVEDUWDUVEUWDCIUVEUUCUUDUUGUVRUWCUPUWBUWCUSZUQUTZU
      WDDUUCUUDUUGUVRUWCVAUTZVBUWDUVFVJUBZUVEDTZLZUWDUWCUUFUWJUWEUUSUUFUVRUWCUU
      RUUEUUFVCVDUVEDCVEVFUWDUVEVGKZDVGKZUWHUWJVHUWFUWGUWKUWLMUWIUVFVJUVEDVIVKV
      FVLVMUVPUVGRVSVNVOVPVQVTVRUUTUVJUHKZUVJUAUBZUVJIJZUVLUVJKZUUPUWMUUSUUPUVI
      EWAZUHKUVJUWQJUWMFECUVGWBUVIEIWCUWQUVJWDWEWFZUUTUUICKZUWNBUUTUUEUWSBWGUUR
      UUEUUFUUPWHBCWIWKUUTUWSMZUUKUVJKZUWNUWTUUKIKUUKUVGTZFCQZUXAUWTUUJUWTUUIDU
      WTUUIUWTCIUUIUUCUUDUUGUUPUWSUPUUTUWSUSUQUTUWTDUUCUUDUUGUUPUWSVAUTVBWJZUWS
      UXCUUTUWSUUKUUKTZUXCUUKWLUXBUXEFUUICFBULZUVGUUKUUKUXFUVFUUJUFUVEUUIDUCWMW
      NWOWPWQWFUVIUXCEUUKIUVDUUKTUVHUXBFCUVDUUKUVGUMUNUOWRZUVJUUKWSXBWTZUWOUUTU
      VIEIXAZXCIUVKXDZUWMUWNUWOUDUWPIOXDUXJXEIOXPXFZIUVJUVKXGXHXIZUQUUTUVNBCUWT
      UVLUUKXJPZUVNUWTUWOUVPHNZXJPZHUVJSZGUVJQZUXAUXMUWOUWTUXIXCUUTUXQUWSUUTUVP
      UXNUVKPZLZHUVJSZUXNUVPUVKPUXNUULUVKPAUVJQURHUVJSZMZGUVJQZUXQUUTUVJUVKXDZU
      WMUWNUYCUYDUUTUWOUXJUYDUXIUXKUVJIUVKXKXLXCUWRUXHGHAUVJUVKXMXIUUTUYBUXPGUV
      JUVQUUTUVRUYBUXPURUVIEUVPIXNUUTUVRMZUXTUXPUYAUYEUXSUXOHUVJUXNUVJKUYEUXNIK
      ZUXSUXOURZUVIEUXNIXNUVRUYFUYGUUTUXSUXNUVPOPZLZUVRUYFMZUXOUXRUYHUVPUXNOGXO
      HXOXQXRUYJUXOUYIUVPUXNXSXTVQYAYBYCYDYBYEYPVRUXGGHUUKUVJYFXIUWTUVLUUKUUTUV
      LIKUWSUUTUVJIUVLUXIUXLYGVRUXDYHYIYJUVBUVOAUVLRUULUVLTZUVAUVNBCUYKUUMUVMUU
      LUVLUUKOYKYLYMWPVFUVCUUNLZARQUUQUVBUYLARUUMBCYNYOUUNARYQYRWKYSYTUUAUUB $.

    $( A set of real numbers which comes arbitrarily close to some target yet
       excludes it is infinite.  The work is done in ~ rencldnfilem using
       infima; this theorem removes the requirement that A be non-empty.
       (Contributed by Stefan O'Rear, 19-Oct-2014.) $)
    rencldnfi $p |- ( ( ( A C_ RR /\ B e. RR /\ -. B e. A ) /\ A. x e. RR+ E. y
        e. A ( abs ` ( y - B ) ) < x ) -> -. A e. Fin ) $=
      ( cr wss wcel wn w3a cv cmin co cabs cfv crp wral wa c0 wne c1 clt simpl1
      wbr wrex cfn simpl2 ralimi wb 1rp ne0i r19.3rzv mp2b sylibr adantl simpl3
      rexn0 jca simpr rencldnfilem syl31anc ) CEFZDEGZDCGHZIZBJDKLMNAJUAUCZBCUD
      ZAOPZQZVAVBCRSZVCQVGCUEGHVAVBVCVGUBVAVBVCVGUFVHVIVCVGVIVDVGVIAOPZVIVFVIAO
      VEBCUPUGTOGORSVIVJUHUIOTUJVIAOUKULUMUNVAVBVCVGUOUQVDVGURABCDUSUT $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Miscellanea for Lagrange's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Two elements in a half-open interval have separation _strictly_ less
       than the difference between the endpoints.  (Contributed by Stefan
       O'Rear, 12-Sep-2014.) $)
    icodiamlt $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( C e. ( A [,) B ) /\ D e. (
        A [,) B ) ) ) -> ( abs ` ( C - D ) ) < ( B - A ) ) $=
      ( cr wcel wa cico cmin cabs cfv clt wbr cle w3a cxr elico2 recnd resubcld
      co wi rexr anbi12d biimpd sylan2 simplr simpll negsubdi2d simprl1 simprr1
      simprl2 lesub1dd simprr3 ltsub2dd lelttrd eqbrtrd simprl3 simprr2 ltletrd
      cneg ltsub1dd lesub2dd absltd mpbir2and ex syld imp ) AEFZBEFZGZCABHTZFZD
      VKFZGZCDITZJKBAITZLMZVJVNCEFZACNMZCBLMZOZDEFZADNMZDBLMZOZGZVQVIVHBPFZVNWF
      UABUBVHWGGZVNWFWHVLWAVMWEABCQABDQUCUDUEVJWFVQVJWFGZVQVPUTZVOLMVOVPLMWIWJA
      BITZVOLWIBAWIBVHVIWFUFZRWIAVHVIWFUGZRUHWIWKCBITVOWIABWMWLSWICBVRVSVTWEVJU
      IZWLSWICDWNWBWCWDWAVJUJZSZWIACBWMWNWLVRVSVTWEVJUKULWIDBCWOWLWNWBWCWDWAVJU
      MUNUOUPWIVOBDITVPWPWIBDWLWOSWIBAWLWMSZWICBDWNWLWOVRVSVTWEVJUQVAWIADBWMWOW
      LWBWCWDWAVJURVBUSWIVOVPWPWQVCVDVEVFVG $.

    $( Modular reduction produces a half-open interval.  (Contributed by Stefan
       O'Rear, 12-Sep-2014.) $)
    modelico $p |- ( ( A e. RR /\ B e. RR+ ) -> ( A mod B ) e. ( 0 [,) B ) ) $=
      ( cr wcel crp wa cmo co cc0 cle wbr clt modcl modge0 modlt cxr w3a wb 0re
      cico rpxr adantl elico2 sylancr mpbir3and ) ACDZBEDZFZABGHZIBTHDZUICDZIUI
      JKZUIBLKZABMABNABOUHICDBPDZUJUKULUMQRSUGUNUFBUAUBIBUIUCUDUE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Lagrange's rational approximation theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x a b c $.  $d A a b c d x y z w $.  $d B a b c d x y z w $.
    $( Lemma for ~ irrapx1 .  Divides the unit interval into ` B ` half-open
       sections and using the pigeonhole principle ~ fphpdo finds two multiples
       of ` A ` in the same section mod 1.  (Contributed by Stefan O'Rear,
       12-Sep-2014.) $)
    irrapxlem1 $p |- ( ( A e. RR+ /\ B e. NN ) -> E. x e. ( 0 ... B ) E. y e. (
        0 ... B ) ( x < y /\ ( |_ ` ( B x. ( ( A x. x ) mod 1 ) ) ) = ( |_ ` (
        B x. ( ( A x. y ) mod 1 ) ) ) ) ) $=
      ( wcel cc0 co c1 cmul cmo cfl cfv cr cz a1i clt wbr cle ad2antlr sylancl
      va crp cn wa cfz cmin cv wss cuz fzssuz uzssz zssre cvv ovex csdm nnm1nn0
      sstri cn0 adantl nn0uz syl6eleq nnre ltm1d fzsdom2 syl21anc rpre ad2antrr
      nnz elfzelz zred remulcld 1rp modcl flcld wn recnd mul01d modge0 wb nngt0
      0re lemul2 syl112anc mpbid eqbrtrrd lenltd 0z fllt mpbird elnn0z sylanbrc
      mtbid caddc flle syl modlt 1re ltmul2 mulid1d breqtrd lelttrd wceq ax-1cn
      cc nncn npcan breqtrrd 1z zsubcl zleltp1 syl2anc elfz2nn0 syl3anbrc oveq2
      oveq1d oveq2d fveq2d fphpdo ) CUBEZDUCEZUDZABUAFDUEGZFDHUFGZUEGZDCUAUGZIG
      ZHJGZIGZKLZDCAUGZIGZHJGZIGZKLDCBUGZIGZHJGZIGZKLYBMUHYAYBFUILZMFDUJYRNMFUK
      ULUQUQOYDUMEYAFYCUEUNOYAYCYREDNEZYCDPQYDYBUOQYAYCURYRXTYCUREZXSDUPZUSUTVA
      XTYSXSDVHZUSYADXTDMEZXSDVBZUSVCFYCDVDVEYAYEYBEZUDZYIUREZYTYIYCRQZYIYDEUUF
      YINEZFYIRQZUUGUUFYHUUFDYGXTUUCXSUUEUUDSZUUFYFMEZHUBEZYGMEZUUFCYEXSCMEXTUU
      ECVFVGUUEYEMEYAUUEYEYEFDVIVJUSVKZVLYFHVMTZVKZVNZUUFUUJYIFPQZVOUUFYHFPQZUU
      SUUFFYHRQUUTVOUUFDFIGZFYHRUUFDUUFDUUKVPZVQUUFFYGRQZUVAYHRQZUUFUULUUMUVCUU
      OVLYFHVRTUUFFMEZUUNUUCFDPQZUVCUVDVSUVEUUFWAOZUUPUUKXTUVFXSUUEDVTSZFYGDWBW
      CWDWEUUFFYHUVGUUQWFWDUUFYHMEZFNEUUTUUSVSUUQWGYHFWHTWLUUFFYIUVGUUFYIUURVJZ
      WFWIYIWJWKXTYTXSUUEUUASUUFUUHYIYCHWMGZPQZUUFYIDUVKPUUFYIYHDUVJUUQUUKUUFUV
      IYIYHRQUUQYHWNWOUUFYHDHIGZDPUUFYGHPQZYHUVMPQZUUFUULUUMUVNUUOVLYFHWPTUUFUU
      NHMEZUUCUVFUVNUVOVSUUPUVPUUFWQOUUKUVHYGHDWRWCWDUUFDUVBWSWTXAXTUVKDXBZXSUU
      EXTDXDEHXDEUVQDXEXCDHXFTSXGUUFUUIYCNEZUUHUVLVSUURUUFYSHNEUVRXTYSXSUUEUUBS
      XHDHXITYIYCXJXKWIYIYCXLXMYEYJXBZYHYMKUVSYGYLDIUVSYFYKHJYEYJCIXNXOXPXQYEYN
      XBZYHYQKUVTYGYPDIUVTYFYOHJYEYNCIXNXOXPXQXR $.

    $( Lemma for ~ irrapx1 .  Two multiples in the same bucket means they are
       very close mod 1.  (Contributed by Stefan O'Rear, 12-Sep-2014.) $)
    irrapxlem2 $p |- ( ( A e. RR+ /\ B e. NN ) -> E. x e. ( 0 ... B ) E. y e. (
        0 ... B ) ( x < y /\ ( abs ` ( ( ( A x. x ) mod 1 ) - ( ( A x. y ) mod
        1 ) ) ) < ( 1 / B ) ) ) $=
      ( wcel wa clt wbr cmul co c1 cmo cfv wceq cc0 wrex cmin cabs cr recnd crp
      cn cv cfl cdiv irrapxlem1 caddc nnre ad3antlr rpre ad3antrrr elfzelz zred
      cfz ad2antlr remulcld 1rp a1i modcld intfrac adantl oveq12d fveq2d adantr
      syl simpr flcld zcnd pnpcand cico 0re modelico sylancl icodiamlt syl22anc
      oveq1d 1re ax-1cn subid1i syl6breq eqbrtrd ex wb resubcld abscld rereccld
      nngt0 gt0ne0d ltmul2 syl112anc nnnn0 nn0ge0d absidd eqcomd absmuld subdid
      cle 3eqtr2d recidd breq12d bitrd sylibrd anim2d reximdva mpd ) CUAEZDUBEZ
      FZAUCZBUCZGHZDCXIIJZKLJZIJZUDMZDCXJIJZKLJZIJZUDMZNZFZBODUNJZPZAYBPXKXMXQQ
      JZRMZKDUEJZGHZFZBYBPZAYBPABCDUFXHYCYIAYBXHXIYBEZFZYAYHBYBYKXJYBEZFZXTYGXK
      YMXTXNXRQJZRMZKGHZYGYMXTYPYMXTFZYOXOXNKLJZUGJZXSXRKLJZUGJZQJZRMZKGYMYOUUC
      NXTYMYNUUBRYMXNYSXRUUAQYMXNSEZXNYSNYMDXMXGDSEZXFYJYLDUHUIZYMXLKYMCXIXFCSE
      XGYJYLCUJUKZYJXISEXHYLYJXIXIODULUMUOUPKUAEZYMUQURZUSZUPZXNUTVEYMXRSEZXRUU
      ANYMDXQUUFYMXPKYMCXJUUGYLXJSEYKYLXJXJODULUMVAUPUUIUSZUPZXRUTVEVBVCVDYQUUC
      XSYRUGJZUUAQJZRMZKGYQUUBUUPRYQYSUUOUUAQYQXOXSYRUGYMXTVFVPVPVCYMUUQKGHXTYM
      UUQYRYTQJZRMZKGYMUUPUURRYMXSYRYTYMXSYMXRUUNVGVHYMYRYMXNKUUKUUIUSTYMYTYMXR
      KUUNUUIUSTVIVCYMUUSKOQJZKGYMOSEZKSEZYROKVJJZEZYTUVCEZUUSUUTGHUVAYMVKURUVB
      YMVQURYMUUDUUHUVDUUKUQXNKVLVMYMUULUUHUVEUUNUQXRKVLVMOKYRYTVNVOKVRVSVTWAVD
      WAWAWBYMYGDYEIJZDYFIJZGHZYPYMYESEYFSEUUEODGHZYGUVHWCYMYDYMYDYMXMXQUUJUUMW
      DTZWEYMDUUFYMDXGUVIXFYJYLDWGUIZWHZWFUUFUVKYEYFDWIWJYMUVFYOUVGKGYMUVFDRMZY
      EIJDYDIJZRMYOYMDUVMYEIYMUVMDYMDUUFXGODWQHXFYJYLXGDDWKWLUIWMWNVPYMDYDYMDUU
      FTZUVJWOYMUVNYNRYMDXMXQUVOYMXMUUJTYMXQUUMTWPVCWRYMDUVOUVLWSWTXAXBXCXDXDXE
      $.

    $( Lemma for ~ irrapx1 .  By subtraction, there is a multiple very close to
       an integer.  (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    irrapxlem3 $p |- ( ( A e. RR+ /\ B e. NN ) -> E. x e. ( 1 ... B ) E. y e.
        NN0 ( abs ` ( ( A x. x ) - y ) ) < ( 1 / B ) ) $=
      ( wcel wa clt wbr cmul co c1 cmin cabs cfv cc0 cle cz syl cr recnd va crp
      vb cn cv cmo cdiv cfz wrex cn0 irrapxlem2 cfl 1m1e0 elfzelz ad2antrl zred
      ad2antll posdifd biimpa wb simplrr simplrl zsubcld zlem1lt sylancr mpbird
      syl5eqbr 1z resubcld 0re simpllr elfzle1 lesub2dd subid1d elfzle2 eqbrtrd
      a1i nnred nnzd elfz syl3anc mpbir2and adantrr cuz rpre ad3antrrr remulcld
      letrd simpr ltled rpgt0 lemul2 mpbid flword2 uznn0sub subdid oveq1d flcld
      syl112anc zcnd sub4d wceq modfrac eqcomd oveq12d 3eqtrd fveq2d 1rp modcld
      abssubd eqtr2d breq1d biimpd impr oveq2 rspc2ev ex rexlimdvva mpd ) CUBEZ
      DUDEZFZUAUEZUCUEZGHZCYCIJZKUFJZCYDIJZKUFJZLJMNZKDUGJZGHZFZUCODUHJZUIUAYNU
      ICAUEZIJZBUEZLJZMNZYKGHZBUJUIAKDUHJZUIZUAUCCDUKYBYMUUBUAUCYNYNYBYCYNEZYDY
      NEZFZFZYMUUBUUFYMFYDYCLJZUUAEZYHULNZYFULNZLJZUJEZCUUGIJZUUKLJZMNZYKGHZUUB
      UUFYEUUHYLUUFYEFZUUHKUUGPHZUUGDPHZUUQUURKKLJZUUGGHZUUQUUTOUUGGUMUUFYEOUUG
      GHUUFYCYDUUFYCUUCYCQEZYBUUDYCODUNZUOUPUUFYDUUDYDQEZYBUUCYDODUNZUQUPURUSVG
      UUQKQEZUUGQEZUURUVAUTVHUUQYDYCUUQUUDUVDYBUUCUUDYEVAZUVERZUUQUUCUVBYBUUCUU
      DYEVBZUVCRZVCZKUUGVDVEVFUUQUUGYDOLJZDUUQYDYCUUQYDUVIUPZUUQYCUVKUPZVIUUQYD
      OUVNOSEUUQVJVQZVIUUQDXTYAUUEYEVKZVRUUQOYCYDUVPUVOUVNUUQUUCOYCPHUVJYCODVLR
      VMUUQUVMYDDPUUQYDUUQYDUVNTZVNUUQUUDYDDPHUVHYDODVORVPWHUUQUVGUVFDQEUUHUURU
      USFUTUVLUVFUUQVHVQUUQDUVQVSUUGKDVTWAWBWCUUFYEUULYLUUQUUIUUJWDNEZUULUUQYFS
      EZYHSEZYFYHPHZUVSUUQCYCXTCSEZYAUUEYECWEWFZUVOWGZUUQCYDUWDUVNWGZUUQYCYDPHZ
      UWBUUQYCYDUVOUVNUUFYEWIWJUUQYCSEYDSEUWCOCGHZUWGUWBUTUVOUVNUWDXTUWHYAUUEYE
      CWKWFYCYDCWLWSWMYFYHWNWAUUJUUIWORWCUUFYEYLUUPUUQYLUUPUUQYJUUOYKGUUQUUOYIY
      GLJZMNYJUUQUUNUWIMUUQUUNYHYFLJZUUKLJYHUUILJZYFUUJLJZLJUWIUUQUUMUWJUUKLUUQ
      CYDYCUUQCUWDTUVRUUQYCUVOTWPWQUUQYHYFUUIUUJUUQYHUWFTUUQYFUWETUUQUUIUUQYHUW
      FWRWTUUQUUJUUQYFUWEWRWTXAUUQUWKYIUWLYGLUUQYIUWKUUQUWAYIUWKXBUWFYHXCRXDUUQ
      YGUWLUUQUVTYGUWLXBUWEYFXCRXDXEXFXGUUQYIYGUUQYIUUQYHKUWFKUBEUUQXHVQZXITUUQ
      YGUUQYFKUWEUWMXITXJXKXLXMXNYTUUPUUMYQLJZMNZYKGHABUUGUUKUUAUJYOUUGXBZYSUWO
      YKGUWPYRUWNMUWPYPUUMYQLYOUUGCIXOWQXGXLYQUUKXBZUWOUUOYKGUWQUWNUUNMYQUUKUUM
      LXOXGXLXPWAXQXRXS $.

    $( Lemma for ~ irrapx1 .  Eliminate ranges, use positivity of the input to
       force positivity of the output by increasing ` B ` as needed.
       (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    irrapxlem4 $p |- ( ( A e. RR+ /\ B e. NN ) -> E. x e. NN E. y e. NN ( abs `
        ( ( A x. x ) - y ) ) < ( 1 / if ( x <_ B , B , x ) ) ) $=
      ( va vb wcel cn wa co cmin cabs c1 cdiv cle wbr clt cr cc0 syl2anc crp cv
      cmul cfv cfl caddc cif cn0 cfz simpl rpreccld rprege0d flge0nn0 syl simpr
      wrex nn0p1nn ifcl irrapxlem3 elfznn ad3antlr nn0z ad2antlr cneg ad3antrrr
      cz rpred nnred remulcld nn0re resubcld recnd abscld nnrecred 0re rprecred
      a1i flcld zred peano2re max2 wb nngt0d lerec syl22anc mpbid fllep1 nnne0d
      nncnd recrecd breqtrrd recgt0d rpgt0d mpbird letrd mulid1d nnge1d lemul2d
      1re eqbrtrrd subid1d ltletrd absltd simprd ltsub2d elnnz sylanbrc elfzle2
      max1 maxle syl3anc mpbir2and oveq2 oveq1d fveq2d breq1 id ifbieq2d oveq2d
      weq breq12d breq1d rspc2ev ex rexlimdva mpd ) CUAGZDHGZIZCEUBZUCJZFUBZKJZ
      LUDZMDMCNJZUEUDZMUFJZOPZYQDUGZNJZQPZFUHUPZEMYSUIJZUPZCAUBZUCJZBUBZKJZLUDZ
      MUUEDOPZDUUEUGZNJZQPZBHUPAHUPZYIYGYSHGZUUDYGYHUJZYIYQHGZYHUUOYIYPUHGZUUQY
      IYORGZSYOOPIUURYIYOYICUUPUKULYOUMUNYPUQUNZYGYHUOZYRYQDHURZTEFCYSUSTYIUUBU
      UNEUUCYIYJUUCGZIZUUAUUNFUHUVDYLUHGZIZUUAUUNUVFUUAIZYJHGZYLHGZYNMYJDOPZDYJ
      UGZNJZQPZUUNUVCUVHYIUVEUUAYJYSUTVAZUVGYLVFGZSYLQPZUVIUVEUVOUVDUUAYLVBVCUV
      GUVPYMYKSKJZQPZUVGUVQVDYMQPZUVRUVGYNUVQQPUVSUVRIUVGYNYTUVQUVGYMUVGYMUVGYK
      YLUVGCYJUVGCYIYGUVCUVEUUAUUPVEZVGZUVGYJUVNVHZVIZUVEYLRGUVDUUAYLVJVCZVKZVL
      VMZUVGYSUVGUUQYHUUOYIUUQUVCUVEUUAUUTVEZYIYHUVCUVEUUAUVAVEZUVBTZVNZUVGYKSU
      WCSRGUVGVOVQZVKZUVFUUAUOZUVGYTCUVQUWJUWAUWLUVGYTMYQNJZCUWJUVGYQUWGVNZUWAU
      VGYQYSOPZYTUWNOPZUVGDRGZYQRGZUWPUVGDUWHVHZUVGYPRGUWSUVGYPUVGYOUVGCUVTVPZV
      RVSYPVTUNZDYQWATUVGUWSSYQQPYSRGZSYSQPZUWPUWQWBUXBUVGYQUWGWCZUVGYSUWIVHZUV
      GYSUWIWCZYQYSWDWEWFUVGUWNCOPZYOMUWNNJZOPZUVGYOYQUXIOUVGUUSYOYQOPUXAYOWGUN
      UVGYQUVGYQUWGWIUVGYQUWGWHWJWKUVGUWNRGSUWNQPCRGSCQPUXHUXJWBUWOUVGYQUXBUXEW
      LUWAUVGCUVTWMUWNCWDWEWNWOUVGCYKUVQOUVGCMUCJZCYKOUVGCUVGCUWAVLWPUVGMYJOPUX
      KYKOPUVGYJUVNWQUVGMYJCMRGUVGWSVQUWBUVTWRWFWTUVGYKUVGYKUWCVLXAWKWOXBUVGYMU
      VQUWEUWLXCWFXDUVGSYLYKUWKUWDUWCXEWNYLXFXGUVGYNYTUVLUWFUWJUVGUVKUVGYHUVHUV
      KHGUWHUVNUVJDYJHURTVNUWMUVGUVKYSOPZYTUVLOPZUVGUXLYJYSOPZDYSOPZUVCUXNYIUVE
      UUAYJMYSXHVAUVGUWRUWSUXOUWTUXBDYQXITUVGYJRGZUWRUXCUXLUXNUXOIWBUWBUWTUXFYJ
      DYSXJXKXLUVGUVKRGZSUVKQPUXCUXDUXLUXMWBUVGUWRUXPUXQUWTUWBUVJDYJRURTZUVGSDU
      VKUWKUWTUXRUVGDUWHWCUVGUXPUWRDUVKOPUWBUWTYJDWATXBUXFUXGUVKYSWDWEWFXBUUMUV
      MYKUUGKJZLUDZUVLQPABYJYLHHAEXTZUUIUXTUULUVLQUYAUUHUXSLUYAUUFYKUUGKUUEYJCU
      CXMXNXOUYAUUKUVKMNUYAUUJUVJUUEYJDUUEYJDOXPUYAXQXRXSYABFXTZUXTYNUVLQUYBUXS
      YMLUUGYLYKKXMXOYBYCXKYDYEYEYF $.

    $( Lemma for ~ irrapx1 .  Switching to real intervals and fraction syntax.
       (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    irrapxlem5 $p |- ( ( A e. RR+ /\ B e. RR+ )
        -> E. x e. QQ ( 0 < x /\ ( abs ` ( x - A ) ) < B
          /\ ( abs ` ( x - A ) ) < ( ( denom ` x ) ^ -u 2 ) ) ) $=
      ( crp wcel cmul co cmin cabs cfv c1 cdiv cle wbr clt cn cc0 syl syl2anc
      cr va vb wa cv cfl caddc cif wrex cdenom c2 cneg cexp w3a cq cn0 rpreccld
      simpr rprege0d flge0nn0 nn0p1nn irrapxlem4 syldan wne simplrr nnq simplrl
      3syl nnne0d qdivcl syl3anc nnrpd rpgt0d nnred nnnn0d absidd eqcomd oveq1d
      rpdivcld nn0ge0d nncnd qre ad3antrrr resubcld recnd absmuld eqtr4d cc qcn
      rpre subdid divcan2d mulcomd oveq12d eqtrd fveq2d remulcld abssubd 3eqtrd
      rpcn abscld simpllr rprecred rpge0d ifcl rpred fllep1 letrd lerecd rpne0d
      max2 recrecd mulid2d nnge1d 1re a1i lemul1d eqbrtrd ltletrd nngt0d ltmul2
      mpbid wb syl112anc mpbird msqgt0d gt0ne0d rereccld qdencl divdiv1d dividd
      max1 divrecd 3eqtr3rd 3brtr4d cz nnzd divdenle le2msq syl22anc wceq lerec
      expneg sqvald oveq2d breqtrrd breq2 oveq1 breq1d breq12d 3anbi123d rspcev
      2nn0 fveq2 syl13anc ex rexlimdvva mpd ) BDEZCDEZUCZBUAUDZFGZUBUDZHGZIJZKU
      VAKCLGZUEJZKUFGZMNZUVHUVAUGZLGZONZUBPUHUAPUHZQAUDZONZUVNBHGZIJZCONZUVQUVN
      UIJZUJUKZULGZONZUMZAUNUHZUURUUSUVHPEZUVMUUTUVFTEZQUVFMNZUCUVGUOEZUWEUUTUV
      FUUTCUURUUSUQUPURUVFUSZUVGUTZVGUAUBBUVHVAVBUUTUVLUWDUAUBPPUUTUVAPEZUVCPEZ
      UCZUCZUVLUWDUWNUVLUCZUVCUVALGZUNEZQUWPONZUWPBHGZIJZCONZUWTUWPUIJZUVTULGZO
      NZUWDUWOUVCUNEZUVAUNEZUVAQVCUWQUWOUWLUXEUUTUWKUWLUVLVDZUVCVERUWOUWKUXFUUT
      UWKUWLUVLVFZUVAVERUWOUVAUXHVHZUVCUVAVIVJZUWOUWPUWOUVCUVAUWOUVCUXGVKUWOUVA
      UXHVKZVRVLUWOUXAUVAUWTFGZUVACFGZONZUWOUXLUVEUXMOUWOUXLUVAUWSFGZIJZUVCUVBH
      GZIJUVEUWOUXLUVAIJZUWTFGUXPUWOUVAUXRUWTFUWOUXRUVAUWOUVAUWOUVAUXHVMZUWOUVA
      UWOUVAUXHVNVSZVOVPVQUWOUVAUWSUWOUVAUXHVTZUWOUWSUWOUWPBUWOUWQUWPTEUXJUWPWA
      RUURBTEUUSUWMUVLBWIWBZWCWDZWEWFUWOUXOUXQIUWOUXOUVAUWPFGZUVABFGZHGUXQUWOUV
      AUWPBUYAUWOUWQUWPWGEUXJUWPWHRUURBWGEUUSUWMUVLBWSWBZWJUWOUYDUVCUYEUVBHUWOU
      VCUVAUWOUVCUXGVTZUYAUXIWKUWOUVABUYAUYFWLWMWNWOUWOUVCUVBUYGUWOUVBUWOBUVAUY
      BUXSWPZWDWQWRZUWOUVEUVKUXMUWOUVDUWOUVDUWOUVBUVCUYHUWOUVCUXGVMWCWDWTZUWOUV
      JUWOUVHDEUVADEUVJDEUWOUVHUWOUWHUWEUWOUWFUWGUWHUWOCUURUUSUWMUVLXAZXBZUWOUV
      FUWOCUYKUPZXCUWISUWJRZVKUXKUVIUVHUVADXDSZXBZUWOUVACUXSUWOCUYKXEZWPZUWNUVL
      UQZUWOUVKKUVFLGZUXMUYPUWOUVFUYMXBUYRUWOUVFUVJMNUVKUYTMNUWOUVFUVHUVJUYLUWO
      UVHUYNVMZUWOUVHTEZUVATEZUVJTEVUAUXSUVIUVHUVATXDSUWOUWFUVFUVHMNUYLUVFXFRUW
      OVUCVUBUVHUVJMNUXSVUAUVAUVHXJSXGUWOUVFUVJUYMUYOXHYAUWOUYTKCFGZUXMMUWOUYTC
      VUDUWOCUWOCUYQWDZUWOCUYKXIXKUWOCVUEXLWFUWOKUVAMNVUDUXMMNUWOUVAUXHXMUWOKUV
      ACKTEUWOXNXOUXSUYKXPYAXQXGXRXQUWOUWTTEZCTEVUCQUVAONZUXAUXNYBUWOUWSUYCWTZU
      YQUXSUWOUVAUXHXSZUWTCUVAXTYCYDUWOUWTKUXBUXBFGZLGZUXCOUWOUWTKUVAUVAFGZLGZV
      UKVUHUWOVULUWOUVAUVAUXSUXSWPZUWOVULUWOUVAUXSUXIYEZYFZYGZUWOVUJUWOUXBUXBUW
      OUXBUWOUWQUXBPEUXJUWPYHRZVMZVUSWPZUWOVUJUWOUXBVUSUWOUXBVURVHYEZYFYGUWOUWT
      VUMONZUXLUVAVUMFGZONZUWOUVEKUVALGZUXLVVCOUWOUVEUVKVVEUYJUYPUWOUVAUXSUXIYG
      UYSUWOUVAUVJMNZUVKVVEMNUWOVUCVUBVVFUXSVUAUVAUVHYKSUWOUVAUVJUXKUYOXHYAXRUY
      IUWOUVAUVALGZUVALGUVAVULLGVVEVVCUWOUVAUVAUVAUYAUYAUYAUXIUXIYIUWOVVGKUVALU
      WOUVAUYAUXIYJVQUWOUVAVULUYAUWOVULVUNWDVUPYLYMYNUWOVUFVUMTEVUCVUGVVBVVDYBV
      UHVUQUXSVUIUWTVUMUVAXTYCYDUWOVUJVULMNZVUMVUKMNZUWOUXBUVAMNZVVHUWOUVCYOEUW
      KVVJUWOUVCUXGYPUXHUVCUVAYQSUWOUXBTEQUXBMNVUCQUVAMNVVJVVHYBVUSUWOUXBUWOUXB
      VURVNVSUXSUXTUXBUVAYRYSYAUWOVUJTEQVUJONVULTEQVULONVVHVVIYBVUTVVAVUNVUOVUJ
      VULUUAYSYAXRUWOUXCKUXBUJULGZLGZVUKUWOUXBWGEUJUOEZUXCVVLYTUWOUXBVURVTZVVMU
      WOUULXOUXBUJUUBSUWOVVKVUJKLUWOUXBVVNUUCUUDWNUUEUWCUWRUXAUXDUMAUWPUNUVNUWP
      YTZUVOUWRUVRUXAUWBUXDUVNUWPQOUUFVVOUVQUWTCOVVOUVPUWSIUVNUWPBHUUGWOZUUHVVO
      UVQUWTUWAUXCOVVPVVOUVSUXBUVTULUVNUWPUIUUMVQUUIUUJUUKUUNUUOUUPUUQ $.

    $( Lemma for ~ irrapx1 .  Explicit description of a non-closed set.
       (Contributed by Stefan O'Rear, 13-Sep-2014.) $)
    irrapxlem6 $p |- ( ( A e. RR+ /\ B e. RR+ ) -> E. x e. { y e. QQ | ( 0 < y
        /\ ( abs ` ( y - A ) ) < ( ( denom ` y ) ^ -u 2 ) ) } ( abs ` ( x - A )
        ) < B ) $=
      ( va crp wcel wa cc0 cv clt wbr cmin co cabs cfv cdenom cexp cq wrex cneg
      w3a crab irrapxlem5 simplr simpr1 simpr3 jca weq breq2 oveq1 fveq2d fveq2
      c2 oveq1d breq12d anbi12d sylanbrc simpr2 breq1d rspcev syl2anc rexlimdva
      elrab ex mpd ) CFGDFGHZIEJZKLZVHCMNZOPZDKLZVKVHQPZUNUAZRNZKLZUBZESTAJZCMN
      ZOPZDKLZAIBJZKLZWBCMNZOPZWBQPZVNRNZKLZHZBSUCZTZECDUDVGVQWKESVGVHSGZHZVQWK
      WMVQHZVHWJGZVLWKWNWLVIVPHZWOVGWLVQUEWNVIVPWMVIVLVPUFWMVIVLVPUGUHWIWPBVHSB
      EUIZWCVIWHVPWBVHIKUJWQWEVKWGVOKWQWDVJOWBVHCMUKULWQWFVMVNRWBVHQUMUOUPUQVDU
      RWMVIVLVPUSWAVLAVHWJAEUIZVTVKDKWRVSVJOVRVHCMUKULUTVAVBVEVCVF $.

    $( Dirichlet's approximation theorem.  Every positive irrational number has
       infinitely many rational approximations which are closer than the
       inverse squares of their reduced denominators.  Lemma 61 in
       [vandenDries] p. 42.  (Contributed by Stefan O'Rear, 14-Sep-2014.) $)
    irrapx1 $p |- ( A e. ( RR+ \ QQ ) -> { y e. QQ | ( 0 < y /\ ( abs ` ( y - A
        ) ) < ( ( denom ` y ) ^ -u 2 ) ) } ~~ NN ) $=
      ( vb va crp cq wcel com cen wbr cn wa cv clt cmin co cabs cfv wss cr cdif
      cc0 cdenom c2 cneg cexp crab cfn wn qnnen nnenom entri pm3.2i wrex ssrab2
      wral qssre sstri a1i eldifi rpred eldifn elrabi nsyl irrapxlem6 ralrimiva
      sylan rencldnfi syl31anc jctil ctbnfien sylancr ) BEFUAGZFHIJZKHIJZLUBAMZ
      NJVPBOPQRVPUCRUDUEUFPNJLZAFUGZFSZVRUHGUIZLVRKIJVNVOFKHUJUKULUKUMVMVTVSVMV
      RTSZBTGBVRGZUICMBOPQRDMZNJCVRUNZDEUPVTWAVMVRFTVQAFUOZUQURUSVMBBEFUTZVAVMB
      FGWBBEFVBVQABFVCVDVMWDDEVMBEGWCEGWDWFCABWCVEVGVFDCVRBVHVIWEVJVRFKVKVL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Pell equations 1: A nontrivial solution always exists
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d e f g A $.  $d a b c d e f g B $.  $d a b c d e f g C $.
    $d a b c d e f g D $.  $d a b c d e f g E $.  $d a b c d e f g F $.
    $d a b c d e f g u $.  $d a b c d e f g v $.  $d a b c d e f g w $.
    $d a b c d e f g x $.  $d a b c d e f g y $.  $d a b c d e f g z $.
    $d a b c d e f g ph $.

    $( a bit of terminology - Pell field = Q[sqr d], Pell ring = Z[sqr d]
       (algebraic integers in Pell field), Pell group = right branch of the
       group of units in Pell ring - isomorphic to ZZ, Pell semigroup = Pell
       group elements >= 1, resembles NN0 $)

    $( Lemma for ~ pellex .  Arithmetical core of pellexlem3, norm lower
       bound.  This begins Dirichlet's proof of the Pell equation solution
       existence; the proof here follows theorem 62 of [vandenDries] p. 43.
       (Contributed by Stefan O'Rear, 14-Sep-2014.) $)
    pellexlem1 $p |- ( ( ( D e. NN /\ A e. NN /\ B e. NN ) /\ -. ( sqr ` D ) e.
        QQ ) -> ( ( A ^ 2 ) - ( D x. ( B ^ 2 ) ) ) =/= 0 ) $=
      ( cn wcel w3a csqr cfv cq c2 cexp cc0 wne wceq nncn 3ad2ant2 3ad2ant3 wbr
      co cc wn cmul cmin sqcld 3ad2ant1 mulcld subeq0ad cdiv nnne0 wb sqne0 syl
      mpbird divmul3d sqdiv fveq2d syl3anc cr nnre redivcld cle clt nnnn0 nngt0
      nn0ge0d divge0 syl22anc sqrsqd eqtr3d nnq qdivcl eqeltrd eleq1d syl5ibcom
      fveq2 sylbird sylbid necon3bd imp ) CDEZADEZBDEZFZCGHZIEZUAAJKSZCBJKSZUBS
      ZUCSZLMWCWEWILWCWILNWFWHNZWEWCWFWHWCAWAVTATEZWBAOPZUDZWCCWGVTWACTEWBCOUEZ
      WCBWBVTBTEZWABOQZUDZUFUGWCWJWFWGUHSZCNZWEWCWFCWGWMWNWQWCWGLMZBLMZWBVTXAWA
      BUIQZWCWOWTXAUJWPBUKULUMUNWCWRGHZIEWSWEWCXCABUHSZIWCXDJKSZGHZXCXDWCWKWOXA
      XFXCNWLWPXBWKWOXAFXEWRGABUOUPUQWCXDWCABWAVTAUREZWBAUSPZWBVTBUREZWABUSQZXB
      UTWCXGLAVARZXILBVBRZLXDVARXHWAVTXKWBWAAAVCVEPXJWBVTXLWABVDQABVFVGVHVIWCAI
      EZBIEZXAXDIEWAVTXMWBAVJPWBVTXNWABVJQXBABVKUQVLWSXCWDIWRCGVOVMVNVPVQVRVS
      $.

    $( Lemma for ~ pellex .  Arithmetical core of pellexlem3, norm upper
       bound.  (Contributed by Stefan O'Rear, 14-Sep-2014.) $)
    pellexlem2 $p |- ( ( ( D e. NN /\ A e. NN /\ B e. NN ) /\ ( abs ` ( ( A / B
        ) - ( sqr ` D ) ) ) < ( B ^ -u 2 ) ) -> ( abs ` ( ( A ^ 2 ) - ( D x. (
        B ^ 2 ) ) ) ) < ( 1 + ( 2 x. ( sqr ` D ) ) ) ) $=
      ( wcel cdiv co cfv cabs c2 clt wbr cmul caddc c1 oveq2d cc cc0 recnd cle
      cr cn w3a csqr cmin cneg cexp wa simpl3 nnred sqge0d absidd eqcomd simpl2
      resqcld nncnd sqcld simpl1 mulcld subcld wne nnne0d sqne0 biimpar syl2anc
      absdivd eqtr4d abscld divcan2d divsubdird sqdivd nnnn0d remsqsqr resqrcld
      wceq nn0ge0d sqvald divcan4d 3eqtr4rd oveq12d divcld subsq addcld mulcomd
      nndivred resubcld 3eqtrd fveq2d 3eqtr3d absmuld remulcld cz 2nn0 nn0negzi
      eqtrd a1i reexpclzd 1re 2re readdcld simpr nngt0d divgt0d addgt0d gt0ne0d
      sqrgt0 absgt0 biimpa ltmul1 syl112anc mpbid sqgt0d ltmul2 expclzd syl3anc
      mulass cn0 expneg sylancl recidd oveq1d mulid2d addcomd ppncan 2times syl
      abstrid nn0ge0i sqrge0d mulge0d nnsqcld nnge1d 0lt1 lerec syl22anc ax-1cn
      wb div1i syl6breq eqbrtrd ltletrd ltled leadd1dd letrd ) CUADZAUADZBUADZU
      BZABEFZCUCGZUDFZHGZBIUEZUFFZJKZUGZAIUFFZCBIUFFZLFZUDFZHGZUUQUUJUUHUUIMFZL
      FZHGZLFZNIUUILFZMFZJUUOUUQUUTUUQEFZLFUUQUUSUUQEFZHGZLFUUTUVDUUOUVGUVIUUQL
      UUOUVGUUTUUQHGZEFUVIUUOUUQUVJUUTEUUOUVJUUQUUOUUQUUOBUUOBUUDUUEUUFUUNUHZUI
      ZUNZUUOBUVLUJUKULOUUOUUSUUQUUOUUPUURUUOAUUOAUUDUUEUUFUUNUMZUOZUPZUUOCUUQU
      UOCUUDUUEUUFUUNUQZUOZUUOBUUOBUVKUOZUPZURZUSZUVTUUOBPDZBQUTZUUQQUTZUVSUUOB
      UVKVAZUWCUWEUWDBVBVCVDZVEVFOUUOUUTUUQUUOUUTUUOUUSUWBVGRUVTUWGVHUUOUVIUVCU
      UQLUUOUVHUVBHUUOUVHUUPUUQEFZUURUUQEFZUDFUUHIUFFZUUIIUFFZUDFZUVBUUOUUPUURU
      UQUVPUWAUVTUWGVIUUOUWHUWJUWIUWKUDUUOUWJUWHUUOABUVOUVSUWFVJULUUOUUIUUILFZC
      UWKUWIUUOCTDZQCSKUWMCVNUUOCUVQUIZUUOCUUOCUVQVKVOZCVLVDUUOUUIUUOUUIUUOCUWO
      UWPVMZRZVPUUOCUUQUVRUVTUWGVQVRVSUUOUWLUVAUUJLFZUVBUUOUUHPDZUUIPDZUWLUWSVN
      UUOABUVOUVSUWFVTZUWRUUHUUIWAVDUUOUVAUUJUUOUUHUUIUXBUWRWBZUUOUUJUUOUUHUUIU
      UOABUUOAUVNUIZUVKWDZUWQWEZRZWCWNWFWGOWHUUOUVDUUQUUKUVAHGZLFZLFZUVFJUUOUVC
      UXIUUQLUUOUUJUVAUXGUXCWIOUUOUXJUUQUUMUXHLFZLFZUVFUUOUUQUXIUVMUUOUUKUXHUUO
      UUJUXGVGZUUOUVAUXCVGZWJZWJUUOUUQUXKUVMUUOUUMUXHUUOBUULUVLUWFUULWKDUUOIWLW
      MWOZWPZUXNWJZWJUUONUVENTDZUUOWQWOZUUOIUUIITDUUOWRWOZUWQWJZWSZUUOUXIUXKJKZ
      UXJUXLJKZUUOUUNUYDUUGUUNWTZUUOUUKTDUUMTDUXHTDQUXHJKZUUNUYDYPUXMUXQUXNUUOU
      VAPDZUVAQUTZUYGUXCUUOUVAUUOUUHUUIUXEUWQUUOABUXDUVLUUOAUVNXAUUOBUVKXAXBUUO
      UWNQCJKQUUIJKUWOUUOCUVQXACXEVDXCXDUYHUYIUYGUVAXFXGVDUUKUUMUXHXHXIXJUUOUXI
      TDUXKTDUUQTDZQUUQJKZUYDUYEYPUXOUXRUVMUUOBUVLUWFXKZUXIUXKUUQXLXIXJUUOUXLUX
      HUVFSUUOUXLUUQUUMLFZUXHLFZNUXHLFUXHUUOUUQPDZUUMPDZUXHPDZUXLUYNVNUVTUUOBUU
      LUVSUWFUXPXMUUOUXHUXNRZUYOUYPUYQUBUYNUXLUUQUUMUXHXOULXNUUOUYMNUXHLUUOUYMU
      UQNUUQEFZLFNUUOUUMUYSUUQLUUOUWCIXPDUUMUYSVNUVSWLBIXQXRZOUUOUUQUVTUWGXSWNX
      TUUOUXHUYRYAWFUUOUXHUUJUVEMFZHGZUVFSUUOUVAVUAHUUOUVAUUIUUHMFZUUIUUIMFZUUJ
      MFZVUAUUOUUHUUIUXBUWRYBUUOUXAUXAUWTVUCVUEVNUWRUWRUXBUXAUXAUWTUBVUEVUCUUIU
      UIUUHYCULXNUUOVUEUUJVUDMFVUAUUOVUDUUJUUOUUIUUIUWRUWRWBUXGYBUUOVUDUVEUUJMU
      UOUXAVUDUVEVNUWRUXAUVEVUDUUIYDULYEOWNWFWGUUOVUBUUKUVEHGZMFZUVFUUOVUAUUOVU
      AUUOUUJUVEUXFUYBWSRVGUUOUUKVUFUXMUUOUVEUUOUVEUYBRZVGWSUYCUUOUUJUVEUXGVUHY
      FUUOVUGUUKUVEMFUVFSUUOVUFUVEUUKMUUOUVEUYBUUOIUUIUYAUWQQISKUUOIWLYGWOUUOCU
      WOUWPYHYIUKOUUOUUKNUVEUXMUXTUYBUUOUUKNUXMUXTUUOUUKUUMNUXMUXQUXTUYFUUOUUMU
      YSNSUYTUUOUYSNNEFZNSUUONUUQSKZUYSVUISKZUUOUUQUUOBUVKYJYKUUOUXSQNJKZUYJUYK
      VUJVUKYPUXTVULUUOYLWOUVMUYLNUUQYMYNXJNYOYQYRYSYTUUAUUBYSUUCYSYSYTYSYS $.

    ${
      $d D x y z $.
      $( Lemma for ~ pellex .  To each good rational approximation of
         ` ( sqr `` D ) ` , there exists a near-solution.  (Contributed by
         Stefan O'Rear, 14-Sep-2014.) $)
      pellexlem3 $p |- ( ( D e. NN /\ -. ( sqr ` D ) e. QQ ) -> { x e. QQ | ( 0
          < x /\ ( abs ` ( x - ( sqr ` D ) ) ) < ( ( denom ` x ) ^ -u 2 ) ) }
          ~<_ { <. y , z >. | ( ( y e. NN /\ z e. NN ) /\ ( ( ( y ^ 2 ) - ( D
          x. ( z ^ 2 ) ) ) =/= 0 /\ ( abs ` ( ( y ^ 2 ) - ( D x. ( z ^ 2 ) ) )
          ) < ( 1 + ( 2 x. ( sqr ` D ) ) ) ) ) } ) $=
        ( cn wcel cfv cq wa cv c2 cexp co cmin cc0 cabs clt wbr cdenom wceq wne
        va vb csqr wn cmul c1 caddc copab cvv cneg crab cdom nnex xpex opabssxp
        cxp ssexi cnumer cop simprl simprrl qgt0numnn syl2anc qdencl syl simpll
        simplr pellexlem1 syl31anc simprrr wb qeqnumdivden oveq1d fveq2d breq1d
        jca cdiv mpbid pellexlem2 jca32 breq2 oveq1 fveq2 breq12d anbi12d elrab
        ex fvex eleq1 anbi1d neeq1d anbi2d oveq2d opelopab ssrab2 sseldi simprr
        3imtr4g opth oveq12d 3eqtr4d syl5bi opeq12d impbid1 dom2d mpi ) DEFZDUD
        GZHFUEZIZBJZEFZCJZEFZIZXLKLMZDXNKLMZUFMZNMZOUAZXTPGZUGKXIUFMUHMZQRZIZIZ
        BCUIZUJFOAJZQRZYHXINMZPGZYHSGZKUKZLMZQRZIZAHULZYGUMRYGEEUQEEUNUNUOYEBCE
        EUPURXKUBUCYQYGUBJZUSGZYRSGZUTZUCJZUSGZUUBSGZUTZUJXKYRHFZOYRQRZYRXINMZP
        GZYTYMLMZQRZIZIZYSEFZYTEFZIZYSKLMZDYTKLMZUFMZNMZOUAZUUTPGZYCQRZIZIZYRYQ
        FZUUAYGFXKUUMUVEXKUUMIZUUPUVAUVCUVGUUNUUOUVGUUFUUGUUNXKUUFUULVAZXKUUFUU
        GUUKVBYRVCVDZUVGUUFUUOUVHYRVEVFZVQUVGXHUUNUUOXJUVAXHXJUUMVGZUVIUVJXHXJU
        UMVHYSYTDVIVJUVGXHUUNUUOYSYTVRMZXINMZPGZUUJQRZUVCUVKUVIUVJUVGUUKUVOXKUU
        FUUGUUKVKUVGUUFUUKUVOVLUVHUUFUUIUVNUUJQUUFUUHUVMPUUFYRUVLXINYRVMZVNVOVP
        VFVSYSYTDVTVJWAWHYPUULAYRHYHYRTZYIUUGYOUUKYHYROQWBUVQYKUUIYNUUJQUVQYJUU
        HPYHYRXINWCVOUVQYLYTYMLYHYRSWDVNWEWFWGYFUUNXOIZUUQXSNMZOUAZUVSPGZYCQRZI
        ZIUVEBCYSYTYRUSWIZYRSWIZXLYSTZXPUVRYEUWCUWFXMUUNXOXLYSEWJWKUWFYAUVTYDUW
        BUWFXTUVSOUWFXQUUQXSNXLYSKLWCVNZWLUWFYBUWAYCQUWFXTUVSPUWGVOVPWFWFXNYTTZ
        UVRUUPUWCUVDUWHXOUUOUUNXNYTEWJWMUWHUVTUVAUWBUVCUWHUVSUUTOUWHXSUUSUUQNUW
        HXRUURDUFXNYTKLWCWNWNZWLUWHUWAUVBYCQUWHUVSUUTPUWIVOVPWFWFWOWSXKUVFUUBYQ
        FZIZUUAUUETZYRUUBTZVLZXKUWKIZUUFUUBHFZUWNUWOYQHYRYPAHWPZXKUVFUWJVAWQUWO
        YQHUUBUWQXKUVFUWJWRWQUUFUWPIZUWLUWMUWLYSUUCTZYTUUDTZIZUWRUWMYSYTUUCUUDU
        WDUWEWTUWRUXAUWMUWRUXAIZUVLUUCUUDVRMZYRUUBUXBYSUUCYTUUDVRUWRUWSUWTVAUWR
        UWSUWTWRXAUXBUUFYRUVLTUUFUWPUXAVGUVPVFUXBUWPUUBUXCTUUFUWPUXAVHUUBVMVFXB
        WHXCUWMYSUUCYTUUDYRUUBUSWDYRUUBSWDXDXEVDWHXFXG $.
    $}

    ${
      $d D y z $.
      $( Lemma for ~ pellex .  Invoking ~ irrapx1 , we have infinitely many
         near-solutions.  (Contributed by Stefan O'Rear, 14-Sep-2014.) $)
      pellexlem4 $p |- ( ( D e. NN /\ -. ( sqr ` D ) e. QQ ) -> { <. y , z >. |
          ( ( y e. NN /\ z e. NN ) /\ ( ( ( y ^ 2 ) - ( D x. ( z ^ 2 ) ) ) =/=
          0 /\ ( abs ` ( ( y ^ 2 ) - ( D x. ( z ^ 2 ) ) ) ) < ( 1 + ( 2 x. (
          sqr ` D ) ) ) ) ) } ~~ NN ) $=
        ( vb cn wcel cfv cq wa cv c2 cexp co cmul cmin clt wbr cdom cen crp cc0
        csqr wn wne cabs c1 caddc copab cxp cvv wss nnex opabssxp ssdomg xpnnen
        xpex mp2 domentr mp2an cdenom cneg crab cdif nnrp rpsqrcld anim1i eldif
        sylibr irrapx1 ensym 3syl pellexlem3 endomtr syl2anc sbth sylancr ) CEF
        ZCUBGZHFUCZIZAJZEFBJZEFIWAKLMCWBKLMNMOMZUAUDWCUEGUFKVRNMUGMPQIZIABUHZER
        QZEWERQZWEESQWEEEUIZRQZWHESQWFWHUJFWEWHUKWIEEULULUPWDABEEUMWEWHUJUNUQUO
        WEWHEURUSVTEUADJZPQWJVROMUEGWJUTGKVALMPQIDHVBZSQZWKWERQWGVTVRTHVCFZWKES
        QWLVTVRTFZVSIWMVQWNVSVQCCVDVEVFVRTHVGVHDVRVIWKEVJVKDABCVLEWKWEVMVNWEEVO
        VP $.
    $}

    ${
      $d D x y z $.
      $( Lemma for ~ pellex .  Invoking ~ fiphp3d , we have infinitely many
         near-solutions for some specific norm.  (Contributed by Stefan O'Rear,
         19-Oct-2014.) $)
      pellexlem5 $p |- ( ( D e. NN /\ -. ( sqr ` D ) e. QQ ) -> E. x e. ZZ ( x
          =/= 0 /\ { <. y , z >. | ( ( y e. NN /\ z e. NN ) /\ ( ( y ^ 2 ) - (
          D x. ( z ^ 2 ) ) ) = x ) } ~~ NN ) ) $=
        ( cn wcel cfv wa c1st c2 cexp co c2nd cmul cmin wceq cc0 wbr cz cr csqr
        va vb cq wn cv wne cabs caddc clt copab crab cen cfl cneg cfz cdif wrex
        csn pellexlem4 cfn fzfi diffi mp1i cop wex elopab oveq1d oveq2d oveq12d
        c1 fveq2 vex op1st oveq1i oveq2i oveq12i syl6eq ad2antrl simprrl simprr
        op2nd simpl ad2antll cle nnz ad2antrr zsqcl simplr nnzd zmulcld zsubcld
        syl 1re 2re nnre nnnn0 nn0ge0d resqrcld remulcl sylancr readdcl znegcld
        cn0 flcld zred nn0abscl nn0zd peano2re flltp1 wb zleltp1 syl2anc mpbird
        lttrd biimpa syl21anc w3a elfz biimpar syl31anc syl12anc adantlr simprl
        absle eldifsn sylanbrc eqeltrd ex syl5bi wi 3ad2ant3 3exp imp3a cvv wss
        cdom nnex ssdomg jca32 exlimdvv imp fiphp3d eldif elfzelz simp2 biimpri
        elsn necon3bi jca syl5 simp2l simp2r cxp xpex opabssxp mp2 xpnnen mp2an
        domentr ensym ssexi elrab syl6req eqtrd 2eximdv 3imtr4g expimpd ancomsd
        eqeq1d ssrdv 3adant3 mpsyl endomtr sbth syld reximdv2 mpd ) DEFZDUAGZUD
        FUEZHZUBUFZIGZJKLZDUWCMGZJKLZNLZOLZAUFZPZUBBUFZEFZCUFZEFZHZUWLJKLZDUWNJ
        KLZNLZOLZQUGZUWTUHGZVKJUVTNLZUILZUJRZHZHZBCUKZULZEUMRZAUXDUNGZUOZUXKUPL
        ZQUSZUQZURUWJQUGZUWPUWTUWJPZHZBCUKZEUMRZHZASURUWBUBAUXHUXOUWIBCDUTUXMVA
        FUXOVAFUWBUXLUXKVBUXMUXNVCVDUWBUWCUXHFZUWIUXOFZUYBUWCUWLUWNVEZPZUXGHZCV
        FBVFUWBUYCUXGBCUWCVGUWBUYFUYCBCUWBUYFUYCUWBUYFHZUWIUWTUXOUYEUWIUWTPUWBU
        XGUYEUWIUYDIGZJKLZDUYDMGZJKLZNLZOLZUWTUYEUWEUYIUWHUYLOUYEUWDUYHJKUWCUYD
        IVLVHUYEUWGUYKDNUYEUWFUYJJKUWCUYDMVLVHVIVJUYIUWQUYLUWSOUYHUWLJKUWLUWNBV
        MZCVMZVNVOUYKUWRDNUYJUWNJKUWLUWNUYNUYOWBVOVPVQZVRVSUYGUWTUXMFZUXAUWTUXO
        FUVSUYFUYQUWAUVSUYFHUWPUVSUXEUYQUVSUYEUWPUXFVTUVSUYFWCUXGUXEUVSUYEUWPUX
        AUXEWAWDUWPUVSUXEHZHZUWTSFZUXLSFZUXKSFZUXLUWTWERUWTUXKWERHZUYQUYSUWQUWS
        UYSUWLSFZUWQSFUWMVUDUWOUYRUWLWFWGUWLWHWMUYSDUWRUVSDSFUWPUXEDWFVSUYSUWNS
        FUWRSFUYSUWNUWMUWOUYRWIWJUWNWHWMWKWLZUYSUXKUYSUXDUYSVKTFUXCTFZUXDTFZWNU
        YSJTFUVTTFVUFWOUYSDUVSDTFUWPUXEDWPVSUYSDUVSDXDFUWPUXEDWQVSWRWSJUVTWTXAV
        KUXCXBXAZXEZXCVUIUYSUWTTFZUXKTFZUXBUXKWERZVUCUYSUWTVUEXFUYSUXKVUIXFZUYS
        VULUXBUXKVKUILZUJRZUYSUXBUXDVUNUYSUXBUYSUXBUYSUYTUXBXDFVUEUWTXGWMXHZXFV
        UHUYSVUKVUNTFVUMUXKXIWMUWPUVSUXEWAUYSVUGUXDVUNUJRVUHUXDXJWMXOUYSUXBSFVU
        BVULVUOXKVUPVUIUXBUXKXLXMXNVUJVUKHVULVUCUWTUXKYEXPXQUYTVUAVUBXRUYQVUCUW
        TUXLUXKXSXTYAYBYCUXGUXAUWBUYEUWPUXAUXEYDWDUWTUXMQYFYGYHYIUUAYJUUBUUCUWB
        UXJUYAAUXOSUWBUWJUXOFZUXJUWJSFZUYAHZUWBVUQVURUXPHZUXJVUSYKVUQUWJUXMFZUW
        JUXNFZUEZHUWBVUTUWJUXMUXNUUDUWBVVAVVCVUTVVAVURUWBVVCVUTYKUWJUXLUXKUUEUW
        BVURVVCVUTUWBVURVVCXRVURUXPUWBVURVVCUUFVVCUWBUXPVURVVBUWJQVVBUWJQPAQUUH
        UUGUUIYLUUJYMUUKYNYJUWBVUTUXJVUSUWBVUTUXJXRZVURUXPUXTUWBVURUXPUXJUULUWB
        VURUXPUXJUUMVVDUXSEYQRZEUXSYQRZUXTUXSEEUUNZYQRZVVGEUMRVVEVVGYOFUXSVVGYP
        VVHEEYRYRUUOZUXQBCEEUUPZUXSVVGYOYSUUQUURUXSVVGEUUTUUSVVDEUXIUMRZUXIUXSY
        QRZVVFUXJUWBVVKVUTUXIEUVAYLUXSYOFVVDUXIUXSYPZVVLUXSVVGVVIVVJUVBUWBVUTVV
        MUXJUWBVUTHZUCUXIUXSUCUFZUXIFVVOUXHFZVVOIGZJKLZDVVOMGZJKLZNLZOLZUWJPZHV
        VNVVOUXSFZUWKVWCUBVVOUXHUWCVVOPZUWIVWBUWJVWEUWEVVRUWHVWAOVWEUWDVVQJKUWC
        VVOIVLVHVWEUWGVVTDNVWEUWFVVSJKUWCVVOMVLVHVIVJUVJUVCVVNVWCVVPVWDVVNVWCVV
        PVWDVVNVWCHZVVOUYDPZUXGHZCVFBVFVWGUXRHZCVFBVFVVPVWDVWFVWHVWIBCVWFVWHVWI
        VWFVWHHZVWGUWPUXQVWFVWGUXGYDVWFVWGUWPUXFVTVWJUWTVWBUWJVWGUWTVWBPVWFUXGV
        WGVWBUYMUWTVWGVVRUYIVWAUYLOVWGVVQUYHJKVVOUYDIVLVHVWGVVTUYKDNVWGVVSUYJJK
        VVOUYDMVLVHVIVJUYPUVDVSVVNVWCVWHWIUVEYTYIUVFUXGBCVVOVGUXRBCVVOVGUVGUVHU
        VIYJUVKUVLUXIUXSYOYSUVMEUXIUXSUVNXMUXSEUVOXAYTYMUVPYNUVQUVR $.
    $}

    ${
      pellex.ann $e |- ( ph -> A e. NN ) $. $( A,B first pigeon $)
      pellex.bnn $e |- ( ph -> B e. NN ) $.
      pellex.cz $e |- ( ph -> C e. ZZ ) $. $( common norm $)
      pellex.dnn $e |- ( ph -> D e. NN ) $. $( discriminant $)
      pellex.irr $e |- ( ph -> -. ( sqr ` D ) e. QQ ) $.
      pellex.enn $e |- ( ph -> E e. NN ) $. $( E,F second pigeon $)
      pellex.fnn $e |- ( ph -> F e. NN ) $.
      pellex.neq $e |- ( ph -> -. ( A = E /\ B = F ) ) $.
      pellex.cn0 $e |- ( ph -> C =/= 0 ) $.
      pellex.no1 $e |- ( ph -> ( ( A ^ 2 ) - ( D x. ( B ^ 2 ) ) ) = C ) $.
      pellex.no2 $e |- ( ph -> ( ( E ^ 2 ) - ( D x. ( F ^ 2 ) ) ) = C ) $.
      pellex.xcg $e |- ( ph -> ( A mod ( abs ` C ) ) = ( E mod ( abs ` C ) ) )
          $.
      pellex.ycg $e |- ( ph -> ( B mod ( abs ` C ) ) = ( F mod ( abs ` C ) ) )
          $.

      $(
        math form:

        |(A+dB)/(E+dF)| = |(A+dB)(E-dF) / (E+dF)(E-dF)| =
          |(AE-DBF)+d(BE-AF)| / |EE+DFF=C| is the soln
        norm: (AE-DBF)(AE-DBF)-D(BE-AF)(BE-AF) / CC;
        AAEE-2AEDBF+DDBBFF-DBBEE+2DBEAF-DAAFF / CC
        AAEE+DDBBFF-DBBEE-DAAFF / CC
        (AA-DBB)EE-DFF(AA-DBB) / CC
        EE-DFF / C
        1
        divisibility: AE-DBF ~~ AA-DBB ~ C ~ 0 mod C; BE-AF ~~ FE-FE ~ 0
        nontriviality: via the norm, AE-DBF=0 implies d = AF-BE / CC
        contradicting irrationality.  BE-AF=0 means B/A = F/E = r; common norm
        then implies B=A and F=E
      $)

      $( Lemma for ~ pellex .  Doing a field division between near solutions
         get us to norm 1, and the modularity constraint ensures we still have
         an integer.  Returning NN guarantees that we are not returning the
         trivial solution (1,0).  We are not explicitly defining the
         Pell-field, Pell-ring, and Pell-norm explicitly because after this
         construction is done we will never use them.  This is mostly basic
         algebraic number theory and could be simplified if a generic framework
         for that were in place.  (Contributed by Stefan O'Rear,
         19-Oct-2014.) $)
      pellexlem6 $p |- ( ph -> E. a e. NN E. b e. NN ( ( a ^ 2 ) - ( D x. ( b ^
          2 ) ) ) = 1 ) $=
        ( cmul co cmin cdiv cabs cfv cn wcel c2 cexp c1 wceq cv wrex cz cc0 wne
        nncnd mulcld subcld absdivd cmo caddc negsubd eqcomd oveq1d cr remulcld
        cneg nnred renegcld modmul1 syl221anc sqcld sqvald resqcld resubcld 0re
        nnzd a1i abscld dividd eqeltrd mod0 syl2anc absmod0 syl 3eqtr4d modadd1
        wb mpbird oveq2d mul12d 3eqtrd eqtrd negidd mpbid redivcld absz cle wbr
        divcld nnnn0d nn0ge0d wa absresq sqdivd cc sqne0 3eqtr2d oveq12d addcld
        clt mulsubd subdid adddid mulcomd mulassd sqmuld eqtr4d subdird syl3anc
        eqtr3d subdi negeqd 3eqtr3d adantr simpr neneqad divne0d nnabscl nnne0d
        w3a oveq1 divcan1d csqr ad2antrr ex zcnd absrpcld npcand eqtr2d absne0d
        crp recnd zred 0mod addid2d zmulcld 0lt1 1re ltnlei mpbi sqge0d mulge0d
        1z wn suble0d breq1 syl5ibrcom mtoi divsubdird mul4d nnncan2d negsubdi2
        divassd addsub4d mulneg2d mulneg1d fveq2d div0d abs00bd sq0id divmuleqd
        mtand negsub adantl divcan4d nngt0d divge0 syl22anc sqrsqd fveq2 simplr
        sqr1 mulid2d jca syld mpd sylbird mtod subne0d eqeq1d rspc2ev ) ABFUCUD
        ZECGUCUDZUCUDZUEUDZDUFUDZUGUHZUIUJZCFUCUDZBGUCUDZUEUDZDUFUDZUGUHZUIUJZU
        XBUKULUDZEUXHUKULUDZUCUDZUEUDZUMUNZHUOZUKULUDZEIUOZUKULUDZUCUDZUEUDZUMU
        NZIUIUPHUIUPAUXAUQUJZUXAURUSUXCAUYBUXBUQUJZAUXBUWTUGUHZDUGUHZUFUDZUQAUW
        TDAUWQUWSABFABJUTZAFOUTZVAZAEUWRAEMUTZACGACKUTZAGPUTZVAZVAZVBZADLUUAZRV
        CAUYDUYEVDUDURUNZUYFUQUJZAUWTUYEVDUDZURUNZUYQAUYSURUYEVDUDZURAUYSUWQUWS
        VKZVEUDZUYEVDUDZUWSVUBVEUDZUYEVDUDZVUAAUWTVUCUYEVDAVUCUWTAUWQUWSUYIUYNV
        FVGVHAUWQVIUJUWSVIUJVUBVIUJUYEUUFUJZUWQUYEVDUDZUWSUYEVDUDZUNVUDVUFUNABF
        ABJVLZAFOVLZVJZAEUWRAEMVLZACGACKVLZAGPVLZVJVJZAUWSVUPVMADUYPRUUBZAVUHFF
        UCUDZUYEVDUDZGEGUCUDZUCUDZUYEVDUDZVUIABVIUJZFVIUJZFUQUJZVUGBUYEVDUDFUYE
        VDUDUNZVUHVUSUNVUJVUKAFOWAZVUQUABFFUYEVNVOAVUSFUKULUDZEGUKULUDZUCUDZUEU
        DZVVJVEUDZUYEVDUDZURVVJVEUDZUYEVDUDZVVBAVURVVLUYEVDAVVLVVHVURAVVHVVJAFU
        YHVPZAEVVIUYJAGUYLVPZVAZUUCAFUYHVQUUDVHAVVKVIUJURVIUJZVVJVIUJVUGVVKUYEV
        DUDZVUAUNVVMVVOUNAVVHVVJAFVUKVRAEVVIVUMAGVUOVRVJZVSVVSAVTWBZVWAVUQADUYE
        VDUDZURVVTVUAAVWCURUNZUYEUYEVDUDURUNZAVWEUYEUYEUFUDZUQUJZAVWFUMUQAUYEAU
        YEADUYPWCZUUGADUYPRUUEWDUMUQUJAUURWBWEAUYEVIUJVUGVWEVWGWLVWHVUQUYEUYEWF
        WGWMADVIUJVUGVWDVWEWLADLUUHZVUQDUYEWHWGWMAVVKDUYEVDTVHAVUGVUAURUNVUQUYE
        UUIWIZWJVVKURVVJUYEWKVOAVVNVVAUYEVDAVVNVVJEGGUCUDZUCUDVVAAVVJVVRUUJAVVI
        VWKEUCAGUYLVQWNAEGGUYJUYLUYLWOWPVHWPAVVBCVUTUCUDZUYEVDUDZVUIAGVIUJZCVIU
        JZVUTUQUJVUGGUYEVDUDZCUYEVDUDZUNVVBVWMUNVUOVUNAEGAEMWAAGPWAZUUKVUQAVWQV
        WPUBVGGCVUTUYEVNVOAVWLUWSUYEVDACEGUYKUYJUYLWOVHWQWPUWQUWSVUBUYEWKVOAVUE
        URUYEVDAUWSUYNWRVHWPVWJWQAUWTVIUJVUGUYTUYQWLAUWQUWSVULVUPVSZVUQUWTUYEWH
        WGWSAUYDVIUJVUGUYQUYRWLAUWTUYOWCVUQUYDUYEWFWGWSWEAUXAVIUJZUYBUYCWLAUWTD
        VWSVWIRWTZUXAXAWIWMAUWTDUYOUYPAUWTURAUWTURUNZUMURUXLUEUDZUNZAVXDUMURXBX
        CZURUMXOXCVXEUUSUULURUMVTUUMUUNUUOAVXEVXDVXCURXBXCZAVXFURUXLXBXCAEUXKVU
        MAUXHAUXGAUXFDAUXDUXEACFUYKUYHVAZABGUYGUYLVAZVBZUYPRXDWCZVRZAEAEMXEXFAU
        XHVXJUUPUUQAURUXLVWBAEUXKVUMVXKVJUUTWMUMVXCURXBUVAUVBUVCAVXBXGZUXMUMVXC
        AUXNVXBAUXMUWTUWTUCUDZDUKULUDZUFUDZEUXFUXFUCUDZUCUDZVXNUFUDZUEUDVXMVXQU
        EUDZVXNUFUDZUMAUXJVXOUXLVXRUEAUXJUXAUKULUDZUWTUKULUDZVXNUFUDVXOAVWTUXJV
        YAUNVXAUXAXHWIAUWTDUYOUYPRXIAVYBVXMVXNUFAUWTUYOVQVHWPAUXLEUXFUKULUDZVXN
        UFUDZUCUDEVYCUCUDZVXNUFUDVXRAUXKVYDEUCAUXKUXGUKULUDZVYDAUXGVIUJZUXKVYFU
        NAUXFDAUXDUXEACFVUNVUKVJZABGVUJVUOVJZVSZVWIRWTZUXGXHWIAUXFDVXIUYPRXIWQW
        NAEVYCVXNUYJAUXFVXIVPADUYPVPZAVXNURUSZDURUSZRADXJUJZVYMVYNWLUYPDXKWIWMZ
        UVHAVYEVXQVXNUFAVYCVXPEUCAUXFVXIVQWNVHXLXMAVXMVXQVXNAUWTUWTUYOUYOVAAEVX
        PUYJAUXFUXFVXIVXIVAVAVYLVYPUVDAVXTUWQUWQUCUDZUWSUWSUCUDZVEUDZUWQUWSUCUD
        ZVYTVEUDZUEUDZEUXDUXDUCUDZUCUDZEUXEUXEUCUDZUCUDZVEUDZEUXDUXEUCUDZUCUDZW
        UIVEUDZUEUDZUEUDZVXNUFUDVXNVXNUFUDUMAVXSWULVXNUFAVXMWUBVXQWUKUEAUWQUWSU
        WQUWSUYIUYNUYIUYNXPAVXQEWUCWUEVEUDZWUHWUHVEUDZUEUDZUCUDEWUMUCUDZEWUNUCU
        DZUEUDWUKAVXPWUOEUCAUXDUXEUXDUXEVXGVXHVXGVXHXPWNAEWUMWUNUYJAWUCWUEAUXDU
        XDVXGVXGVAZAUXEUXEVXHVXHVAZXNAWUHWUHAUXDUXEVXGVXHVAZWUTXNXQAWUPWUGWUQWU
        JUEAEWUCWUEUYJWURWUSXRAEWUHWUHUYJWUTWUTXRXMWPXMVHAWULVXNVXNUFAWULVYSWUJ
        UEUDZWUKUEUDVYSWUGUEUDZVXNAWUBWVAWUKUEAWUAWUJVYSUEAVYTWUIVYTWUIVEAVYTUW
        SUWQUCUDEUWRUWQUCUDZUCUDWUIAUWQUWSUYIUYNXSAEUWRUWQUYJUYMUYIXTAWVCWUHEUC
        AWVCUWRFBUCUDZUCUDUXDGBUCUDZUCUDWUHAUWQWVDUWRUCABFUYGUYHXSWNACGFBUYKUYL
        UYHUYGUVEAWVEUXEUXDUCAGBUYLUYGXSWNWPWNWPZWVFXMWNVHAVYSWUGWUJAVYQVYRAUWQ
        UWQUYIUYIVAZAUWSUWSUYNUYNVAZXNAWUDWUFAEWUCUYJWURVAZAEWUEUYJWUSVAZXNAWUI
        WUIAEWUHUYJWUTVAZWVKXNUVFAWVBVYQWUDUEUDZVYRWUFUEUDZVEUDUWQUKULUDZEUXDUK
        ULUDZUCUDZUEUDZUWSUKULUDZEUXEUKULUDZUCUDZUEUDZVEUDZVXNAVYQVYRWUDWUFWVGW
        VHWVIWVJUVIAWVQWVLWWAWVMVEAWVNVYQWVPWUDUEAUWQUYIVQAWVOWUCEUCAUXDVXGVQWN
        XMAWVRVYRWVTWUFUEAUWSUYNVQAWVSWUEEUCAUXEVXHVQWNXMXMAWWBBUKULUDZVVHUCUDZ
        ECUKULUDZUCUDZVVHUCUDZUEUDZEEUCUDZWWEUCUDZVVIUCUDZEWWCUCUDZVVIUCUDZUEUD
        ZVEUDDVVHUCUDZEDUCUDZVKZVVIUCUDZVEUDZVXNAWVQWWHWWAWWNVEAWVNWWDWVPWWGUEA
        BFUYGUYHYAAWVPEWWEVVHUCUDZUCUDWWGAWVOWWTEUCACFUYKUYHYAWNAEWWEVVHUYJACUY
        KVPZVVPXTYBXMAWVRWWKWVTWWMUEAEUKULUDZUWRUKULUDZUCUDWWIWWEVVIUCUDZUCUDWV
        RWWKAWXBWWIWXCWXDUCAEUYJVQACGUYKUYLYAXMAEUWRUYJUYMYAAWWIWWEVVIAEEUYJUYJ
        VAZWXAVVQXTWJAWVTEWWCVVIUCUDZUCUDWWMAWVSWXFEUCABGUYGUYLYAWNAEWWCVVIUYJA
        BUYGVPZVVQXTYBXMXMAWWHWWOWWNWWRVEAWWCWWFUEUDZVVHUCUDWWHWWOAWWCWWFVVHWXG
        AEWWEUYJWXAVAZVVPYCAWXHDVVHUCSVHYEAWWJWWLUEUDZVVIUCUDEWWFUCUDZWWLUEUDZV
        VIUCUDWWNWWRAWXJWXLVVIUCAWWJWXKWWLUEAEEWWEUYJUYJWXAXTVHVHAWWJWWLVVIAWWI
        WWEWXEWXAVAAEWWCUYJWXGVAVVQYCAWXLWWQVVIUCAWXLEWWFWWCUEUDZUCUDZEDVKZUCUD
        WWQAEXJUJZWWFXJUJZWWCXJUJZWXLWXNUNUYJWXIWXGWXPWXQWXRYOWXNWXLEWWFWWCYFVG
        YDAWXMWXOEUCAWXMWXHVKZWXOAWXRWXQWXMWXSUNWXGWXIWXRWXQXGWXSWXMWWCWWFUVGVG
        WGAWXHDSYGWQWNAEDUYJUYPUVJWPVHYHXMAWWSWWODVVJUCUDZVKZVEUDWWOWXTUEUDZVXN
        AWWRWYAWWOVEAWWRWWPVVIUCUDZVKWYAAWWPVVIAEDUYJUYPVAVVQUVKAWYCWXTAWYCDEUC
        UDZVVIUCUDWXTAWWPWYDVVIUCAEDUYJUYPXSVHADEVVIUYPUYJVVQXTWQYGWQWNAWWOWXTA
        DVVHUYPVVPVAADVVJUYPVVRVAVFADVVKUCUDZDDUCUDWYBVXNAVVKDDUCTWNAVYOVVHXJUJ
        ZVVJXJUJZWYBWYEUNUYPVVPVVRVYOWYFWYGYOWYEWYBDVVHVVJYFVGYDADUYPVQWJWPWPXL
        WPVHAVXNVYLVYPWDWPXLZYIVXLUXJURUXLUEVXLUXBVXLUXBURDUFUDZUGUHZURVXLUXAWY
        IUGVXLUWTURDUFAVXBYJVHUVLAWYJURUNVXBAWYIADUYPRUVMUVNYIWQUVOVHYEUVQYKRYL
        UXAYMWGAUXGUQUJZUXGURUSUXIAWYKUXHUQUJZAUXHUXFUGUHZUYEUFUDZUQAUXFDVXIUYP
        RVCAWYMUYEVDUDURUNZWYNUQUJZAUXFUYEVDUDZURUNZWYOAWYQVUAURAWYQUXDUXEVKZVE
        UDZUYEVDUDZUXEWYSVEUDZUYEVDUDZVUAAUXFWYTUYEVDAUXDXJUJZUXEXJUJZUXFWYTUNV
        XGVXHXUDXUEXGWYTUXFUXDUXEUVRVGWGVHAUXDVIUJUXEVIUJWYSVIUJVUGUXDUYEVDUDZU
        XEUYEVDUDZUNXUAXUCUNVYHVYIAUXEVYIVMVUQAGFUCUDZUYEVDUDZFGUCUDZUYEVDUDZXU
        FXUGAXUHXUJUYEVDAGFUYLUYHXSVHAVWOVWNVVEVUGVWQVWPUNXUFXUIUNVUNVUOVVGVUQU
        BCGFUYEVNVOAVVCVVDGUQUJVUGVVFXUGXUKUNVUJVUKVWRVUQUABFGUYEVNVOWJUXDUXEWY
        SUYEWKVOAXUBURUYEVDAUXEVXHWRVHWPVWJWQAUXFVIUJVUGWYRWYOWLVYJVUQUXFUYEWHW
        GWSAWYMVIUJVUGWYOWYPWLAUXFVXIWCVUQWYMUYEWFWGWSWEAVYGWYKWYLWLVYKUXGXAWIW
        MAUXFDVXIUYPAUXDUXEVXGVXHAUXDUXEAUXDUXEUNZBFUNZCGUNZXGZQAXULCGUFUDZBFUF
        UDZUNZXUOACGBFUYKUYLUYGUYHAGPYNZAFOYNZUVPAXURXUOAXURXGZXUPUKULUDZUMUNZX
        UOXVAXVBDUCUDZDUFUDWXHWXHUFUDZXVBUMXVAXVDWXHDWXHUFXVAXVDXVBVVKUCUDXVBVV
        HUCUDZXVBVVJUCUDZUEUDWXHXVADVVKXVBUCXVAVVKDAVVKDUNXURTYIVGWNXVAXVBVVHVV
        JAXVBXJUJXURAXUPACGUYKUYLXUSXDVPYIZAWYFXURVVPYIZAWYGXURVVRYIXQXVAXVFWWC
        XVGWWFUEXVAXVFXUQUKULUDZVVHUCUDZWWCVVHUFUDZVVHUCUDWWCXURXVFXVKUNAXURXVB
        XVJVVHUCXUPXUQUKULYPVHUVSXVAXVJXVLVVHUCXVABFABXJUJXURUYGYIAFXJUJZXURUYH
        YIAFURUSZXURXUTYIXIVHXVAWWCVVHAWXRXURWXGYIXVIAVVHURUSZXURAXVOXVNXUTAXVM
        XVOXVNWLUYHFXKWIWMYIYQWPXVAXVGEXVBVVIUCUDZUCUDEWWEVVIUFUDZVVIUCUDZUCUDW
        WFXVAXVBEVVIXVHAWXPXURUYJYIAVVIXJUJXURVVQYIZWOXVAXVPXVREUCXVAXVBXVQVVIU
        CXVACGACXJUJXURUYKYIAGXJUJZXURUYLYIAGURUSZXURXUSYIXIVHWNXVAXVRWWEEUCXVA
        WWEVVIAWWEXJUJXURWXAYIXVSAVVIURUSZXURAXWBXWAXUSAXVTXWBXWAWLUYLGXKWIWMYI
        YQWNWPXMWPADWXHUNXURAWXHDSVGYIXMXVAXVBDXVHAVYOXURUYPYIAVYNXURRYIUVTAXVE
        UMUNXURAXVEDDUFUDUMAWXHDWXHDUFSSXMADUYPRWDWQYIYHXVAXVCXUPUMUNZXUOXVAXVC
        XWCXVAXVCXGZXUPXVBYRUHZUMYRUHZUMAXUPXWEUNXURXVCAXWEXUPAXUPACGVUNVUOXUSW
        TAVWOURCXBXCVWNURGXOXCURXUPXBXCVUNACACKXEXFVUOAGPUWACGUWBUWCUWDVGYSXVCX
        WEXWFUNXVAXVBUMYRUWEUVSXWFUMUNXWDUWGWBWPYTXVAXWCXUOXVAXWCXGZXUMXUNXWGXU
        QFUCUDZUMFUCUDZBFXWGXUQUMFUCXWGXUPXUQUMAXURXWCUWFXVAXWCYJZYEVHAXWHBUNXU
        RXWCABFUYGUYHXUTYQYSAXWIFUNXURXWCAFUYHUWHYSYHXWGXUPGUCUDZUMGUCUDZCGXWGX
        UPUMGUCXWJVHAXWKCUNXURXWCACGUYKUYLXUSYQYSAXWLGUNXURXWCAGUYLUWHYSYHUWIYT
        UWJUWKYTUWLUWMYKUWNRYLUXGYMWGWYHUYAUXNUXJUXSUEUDZUMUNHIUXBUXHUIUIUXOUXB
        UNZUXTXWMUMXWNUXPUXJUXSUEUXOUXBUKULYPVHUWOUXQUXHUNZXWMUXMUMXWOUXSUXLUXJ
        UEXWOUXRUXKEUCUXQUXHUKULYPWNWNUWOUWPYD $.
    $}

    ${
      $d D x y $.
      $( Every Pell equation has a nontrivial solution.  Theorem 62 in
         [vandenDries] p. 43.  (Contributed by Stefan O'Rear, 19-Oct-2014.) $)
      pellex $p |- ( ( D e. NN /\ -. ( sqr ` D ) e. QQ ) -> E. x e. NN E. y e.
          NN ( ( x ^ 2 ) - ( D x. ( y ^ 2 ) ) ) = 1 ) $=
        ( vb vc vf vg cn wcel cfv wa cv c2 cexp co wceq wbr c1st cmo c2nd va vd
        ve csqr cq wn cc0 wne cmul cmin copab cen cz wrex c1 pellexlem5 cop cfz
        cabs cxp csdm com cfn fzfi xpfi mp2an isfinite mpbi nnenom ensymi ensym
        sdomentr ad2antll sylancr opabssxp sseli simprrl simpllr simplr nnabscl
        cvv nnzd syl2anc zmodfz simprrr jca ex opelxp 3imtr4g syl5 imp adantlrr
        elxp7 weq fveq2 oveq1d opeq12d fphpd wi eleq1 bi2anan9 oveq2d oveqan12d
        oveq1 eqeq1d anbi12d cbvopabv eleq2i biimpi wex elopab simp3ll 3ad2ant1
        3expb simp3lr simp1lr 3adant1r simp-4l simp-4r simp2ll 3adant2l simp2lr
        w3a simp2l simp1rl simp3l simp3 vex opth sylib ovex fveq2d op1st syl6eq
        syl3anc 3eqtr3d op2nd mpd exlimdvv syl5bi simp2 3netr3d simp1rr simp2rr
        simp1 necon3abii 3adant1l simp3r simprl simpll simprr simpld pellexlem6
        3adant3 simprd 3exp imp3a sylan2i rexlimdvv mpdan rexlimdva ) CHIZCUDJU
        EIUFZKZUALZUGUHZDLZHIZELZHIZKZUVGMNOZCUVIMNOZUIOZUJOZUVEPZKZDEUKZHULQZK
        ZUAUMUNALMNOCBLMNOUIOUJOUOPBHUNAHUNZUADECUPUVDUVTUWAUAUMUVDUVEUMIZKZUVT
        UWAUWCUVTKZUBLZUCLZUHZUWERJZUVEUSJZSOZUWETJZUWISOZUQZUWFRJZUWISOZUWFTJZ
        UWISOZUQZPZKZUCUVRUNUBUVRUNZUWAUWDUBUCUVRUGUWIUOUJOZUROZUXCUTZUWMUWRUWD
        UXDHVAQZHUVRULQZUXDUVRVAQUXDVBVAQZVBHULQUXEUXDVCIZUXGUXCVCIZUXIUXHUGUXB
        VDZUXJUXCUXCVEVFUXDVGVHHVBVIVJUXDVBHVLVFUVSUXFUWCUVFUVRHVKVMUXDHUVRVLVN
        UWCUVFUWEUVRIZUWMUXDIZUVSUWCUVFKZUXKUXLUXKUWEHHUTZIZUXMUXLUVRUXNUWEUVPD
        EHHVOVPUXMUWEWAWAUTIZUWHHIZUWKHIZKKZUWJUXCIZUWLUXCIZKZUXOUXLUXMUXSUYBUX
        MUXSKZUXTUYAUYCUWHUMIUWIHIZUXTUYCUWHUXMUXPUXQUXRVQWBUYCUWBUVFUYDUVDUWBU
        VFUXSVRUWCUVFUXSVSUVEVTWCZUWHUWIWDWCUYCUWKUMIUYDUYAUYCUWKUXMUXPUXQUXRWE
        WBUYEUWKUWIWDWCWFWGUWEHHWMUWJUWLUXCUXCWHWIWJWKWLUBUCWNZUWJUWOUWLUWQUYFU
        WHUWNUWISUWEUWFRWOWPUYFUWKUWPUWISUWEUWFTWOWPWQWRUWCUVFUXAUWAUVSUXMUXAUW
        AUXMUWTUWAUBUCUVRUVRUWFUVRIZUXMUXKUWFFLZHIZGLZHIZKZUYHMNOZCUYJMNOZUIOZU
        JOZUVEPZKZFGUKZIZUWTUWAWSZUYGUYTUVRUYSUWFUVQUYRDEFGDFWNZEGWNZKZUVKUYLUV
        PUYQVUBUVHUYIVUCUVJUYKUVGUYHHWTUVIUYJHWTXAVUDUVOUYPUVEVUBVUCUVLUYMUVNUY
        OUJUVGUYHMNXDVUCUVMUYNCUIUVIUYJMNXDXBXCXEXFXGXHXIUXMUXKUYTVUAUXKUWEUVGU
        VIUQZPZUVQKZEXJDXJUXMUYTVUAWSZUVQDEUWEXKUXMVUGVUHDEUXMVUGVUHUYTUWFUYHUY
        JUQZPZUYRKZGXJFXJUXMVUGKZVUAUYRFGUWFXKVULVUKVUAFGVULVUKUWTUWAVULVUKUWTY
        CZUVGUVIUVECUYHUYJABVULVUKUVHUWTUXMVUFUVQUVHUVHUVJUVPUXMVUFXLXNXMVULVUK
        UVJUWTUXMVUFUVQUVJUVHUVJUVPUXMVUFXOXNXMUXMVUKUWTUWBVUGUVDUWBUVFVUKUWTXP
        XQVULVUKUVBUWTUVBUVCUWBUVFVUGXRXMVULVUKUVCUWTUVBUVCUWBUVFVUGXSXMVULUYRU
        WTUYIVUJUYIUYKUYQVULUWTXTYAVULUYRUWTUYKVUJUYIUYKUYQVULUWTYBYAVUMVUJVUFU
        WGVUDUFZVULVUJUYRUWTYDZVUFUVQUXMVUKUWTYEZVULVUKUWGUWSYFVUJVUFUWGYCZVUEV
        UIUHVUNVUQUWEUWFVUEVUIVUJVUFUWGYGVUJVUFUWGUUAVUJVUFUWGUUEUUBVUDVUEVUIUV
        GUVIUYHUYJDYHZEYHZYIUUFYJYOUWCUVFVUGVUKUWTXPVUGVUKUWTUVPUXMUVKUVPVUFVUK
        UWTUUCUUGUYLUYQVUJVULUWTUUDVUMUVGUWISOZUYHUWISOZPZUVIUWISOZUYJUWISOZPZV
        UMVUFVUJUWSVVBVVEKZVUPVUOVULVUKUWGUWSUUHVUFVUJUWSYCZUWJUWOPZUWLUWQPZKZV
        VFVVGUWSVVJVUFVUJUWSYGUWJUWLUWOUWQUWHUWISYKUWKUWISYKYIYJVUFVUJVVJVVFWSU
        WSVUFVUJKZVVJVVFVVKVVJKZVVBVVEVVLUWJUWOVUTVVAVVKVVHVVIUUIVVLUWHUVGUWISV
        VLUWHVUERJUVGVVLUWEVUERVUFVUJVVJUUJZYLUVGUVIVURVUSYMYNWPVVLUWNUYHUWISVV
        LUWNVUIRJUYHVVLUWFVUIRVUFVUJVVJVSZYLUYHUYJFYHZGYHZYMYNWPYPVVLUWLUWQVVCV
        VDVVKVVHVVIUUKVVLUWKUVIUWISVVLUWKVUETJUVIVVLUWEVUETVVMYLUVGUVIVURVUSYQY
        NWPVVLUWPUYJUWISVVLUWPVUITJUYJVVLUWFVUITVVNYLUYHUYJVVOVVPYQYNWPYPWFWGUU
        NYRYOZUULVUMVVBVVEVVQUUOUUMUUPYSYTWGYSYTUUQUURUUSWKWLUUTWGUVAYR $.
    $}
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Pell equations 2: Algebraic number theory of the solution set
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Pell1QR Pell14QR Pell1234QR PellFund []NN $.

  ${
    $d a b c d e f g A $.  $d a b c d e f g B $.  $d a b c d e f g C $.
    $d a b c d e f g D $.  $d a b c d e f g E $.  $d a b c d e f g F $.
    $d a b c d e f g u $.  $d a b c d e f g v $.  $d a b c d e f g w $.
    $d a b c d e f g x $.  $d a b c d e f g y $.  $d a b c d e f g z $.
    $d a b c d e f g ph $.

    $( define image of ZZ or NN $)
    $( prove non-denseness $)
    $( use logarithms to show all elements are powers of a base $)
    $( value of PellFund ` a*a-1 $)
    $( define Ak, Bk $)
    $( Lucas sequence $)

    $( Extend class notation to include the set of square natural numbers. $)
    csquarenn $a class []NN $.
    $( Extend class notation to include the class of quadrant-1 Pell
       solutions. $)
    cpell1qr $a class Pell1QR $.
    $( Extend class notation to include the class of any-quadrant Pell
       solutions. $)
    cpell1234qr $a class Pell1234QR $.
    $( Extend class notation to include the class of positive Pell
       solutions. $)
    cpell14qr $a class Pell14QR $.
    $( Extend class notation to include the Pell-equation fundamental solution
       function. $)
    cpellfund $a class PellFund $.

    $( Define the set of square natural numbers.  (Contributed by Stefan
       O'Rear, 18-Sep-2014.) $)
    df-squarenn $a |- []NN = { x e. NN | ( sqr ` x ) e. QQ } $.

    ${
      $d x y z w $.
      $( Define the solutions of a Pell equation in the first quadrant.  To
         avoid pair pain, we represent this via the canonical embedding into
         the reals.  (Contributed by Stefan O'Rear, 17-Sep-2014.) $)
      df-pell1qr $a |- Pell1QR = ( x e. ( NN \ []NN ) |-> { y e. RR | E. z e.
          NN0 E. w e. NN0 ( y = ( z + ( ( sqr ` x ) x. w ) ) /\ ( ( z ^ 2 ) - (
          x x. ( w ^ 2 ) ) ) = 1 ) } ) $.
      $( Define the positive solutions of a Pell equation.  (Contributed by
         Stefan O'Rear, 17-Sep-2014.) $)
      df-pell14qr $a |- Pell14QR = ( x e. ( NN \ []NN ) |-> { y e. RR | E. z e.
          NN0 E. w e. ZZ ( y = ( z + ( ( sqr ` x ) x. w ) ) /\ ( ( z ^ 2 ) - (
          x x. ( w ^ 2 ) ) ) = 1 ) } ) $.
      $( Define the general solutions of a Pell equation.  (Contributed by
         Stefan O'Rear, 17-Sep-2014.) $)
      df-pell1234qr $a |- Pell1234QR = ( x e. ( NN \ []NN ) |-> { y e. RR | E.
          z e. ZZ E. w e. ZZ ( y = ( z + ( ( sqr ` x ) x. w ) ) /\ ( ( z ^ 2 )
          - ( x x. ( w ^ 2 ) ) ) = 1 ) } ) $.
      $( A function mapping Pell discriminants to the corresponding fundamental
         solution.  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
      df-pellfund $a |- PellFund = ( x e. ( NN \ []NN ) |-> sup ( { z e. (
          Pell14QR ` x ) | 1 < z } , RR , `' < ) ) $.
    $}

    ${
      $d y z w D $.  $d y z w A $.
      $( Value of the set of first-quadrant Pell solutions.  (Contributed by
         Stefan O'Rear, 17-Sep-2014.) $)
      pell1qrval $p |- ( D e. ( NN \ []NN ) -> ( Pell1QR ` D ) = { y e. RR | E.
          z e. NN0 E. w e. NN0 ( y = ( z + ( ( sqr ` D ) x. w ) ) /\ ( ( z ^ 2
          ) - ( D x. ( w ^ 2 ) ) ) = 1 ) } ) $=
        ( va cv csqr cfv cmul co caddc wceq c2 cexp cmin c1 wa cn0 wrex cr crab
        csquarenn cdif cpell1qr fveq2 oveq1d oveq2d eqeq2d oveq1 eqeq1d anbi12d
        cn 2rexbidv rabbidv df-pell1qr reex rabex fvmpt ) EDAFZBFZEFZGHZCFZIJZK
        JZLZUTMNJZVAVCMNJZIJZOJZPLZQZCRSBRSZATUAUSUTDGHZVCIJZKJZLZVGDVHIJZOJZPL
        ZQZCRSBRSZATUAULUBUCUDVADLZVMWBATWCVLWABCRRWCVFVQVKVTWCVEVPUSWCVDVOUTKW
        CVBVNVCIVADGUEUFUGUHWCVJVSPWCVIVRVGOVADVHIUIUGUJUKUMUNEABCUOWBATUPUQUR
        $.

      $( Membership in a first-quadrant Pell solution set.  (Contributed by
         Stefan O'Rear, 17-Sep-2014.) $)
      elpell1qr $p |- ( D e. ( NN \ []NN ) -> ( A e. ( Pell1QR ` D ) <-> ( A e.
          RR /\ E. z e. NN0 E. w e. NN0 ( A = ( z + ( ( sqr ` D ) x. w ) ) /\ (
          ( z ^ 2 ) - ( D x. ( w ^ 2 ) ) ) = 1 ) ) ) ) $=
        ( va cn csquarenn cdif wcel cfv cv cmul co wceq c2 cexp wa cn0 wrex cr
        cpell1qr csqr caddc cmin c1 crab pell1qrval eleq2d eqeq1 2rexbidv elrab
        anbi1d syl6bb ) DFGHIZCDUAJZICEKZAKZDUBJBKZLMUCMZNZUQOPMDUROPMLMUDMUENZ
        QZBRSARSZETUFZICTICUSNZVAQZBRSARSZQUNUOVDCEABDUGUHVCVGECTUPCNZVBVFABRRV
        HUTVEVAUPCUSUIULUJUKUM $.

      $( Value of the set of positive Pell solutions.  (Contributed by Stefan
         O'Rear, 17-Sep-2014.) $)
      pell14qrval $p |- ( D e. ( NN \ []NN ) -> ( Pell14QR ` D ) = { y e. RR |
          E. z e. NN0 E. w e. ZZ ( y = ( z + ( ( sqr ` D ) x. w ) ) /\ ( ( z ^
          2 ) - ( D x. ( w ^ 2 ) ) ) = 1 ) } ) $=
        ( va cv csqr cfv cmul co caddc wceq c2 cexp cmin c1 cz wrex cn0 cr crab
        wa cn csquarenn cdif cpell14qr fveq2 oveq1d oveq2d eqeq2d oveq1 anbi12d
        eqeq1d 2rexbidv rabbidv df-pell14qr reex rabex fvmpt ) EDAFZBFZEFZGHZCF
        ZIJZKJZLZVAMNJZVBVDMNJZIJZOJZPLZUBZCQRBSRZATUAUTVADGHZVDIJZKJZLZVHDVIIJ
        ZOJZPLZUBZCQRBSRZATUAUCUDUEUFVBDLZVNWCATWDVMWBBCSQWDVGVRVLWAWDVFVQUTWDV
        EVPVAKWDVCVOVDIVBDGUGUHUIUJWDVKVTPWDVJVSVHOVBDVIIUKUIUMULUNUOEABCUPWCAT
        UQURUS $.

      $( Membership in the set of positive Pell solutions.  (Contributed by
         Stefan O'Rear, 17-Sep-2014.) $)
      elpell14qr $p |- ( D e. ( NN \ []NN ) -> ( A e. ( Pell14QR ` D ) <-> ( A
          e. RR /\ E. z e. NN0 E. w e. ZZ ( A = ( z + ( ( sqr ` D ) x. w ) ) /\
          ( ( z ^ 2 ) - ( D x. ( w ^ 2 ) ) ) = 1 ) ) ) ) $=
        ( va cn csquarenn wcel cfv cv cmul co wceq c2 cexp wa cz wrex cn0 cr c1
        cdif cpell14qr csqr caddc cmin pell14qrval eleq2d eqeq1 anbi1d 2rexbidv
        crab elrab syl6bb ) DFGUBHZCDUCIZHCEJZAJZDUDIBJZKLUELZMZURNOLDUSNOLKLUF
        LUAMZPZBQRASRZETULZHCTHCUTMZVBPZBQRASRZPUOUPVECEABDUGUHVDVHECTUQCMZVCVG
        ABSQVIVAVFVBUQCUTUIUJUKUMUN $.

      $( Value of the set of general Pell solutions.  (Contributed by Stefan
         O'Rear, 17-Sep-2014.) $)
      pell1234qrval $p |- ( D e. ( NN \ []NN ) -> ( Pell1234QR ` D ) = { y e.
          RR | E. z e. ZZ E. w e. ZZ ( y = ( z + ( ( sqr ` D ) x. w ) ) /\ ( (
          z ^ 2 ) - ( D x. ( w ^ 2 ) ) ) = 1 ) } ) $=
        ( vd cv csqr cfv cmul co caddc wceq c2 cexp cmin c1 wa cz wrex cr fveq2
        crab cn csquarenn cpell1234qr oveq1d oveq2d eqeq2d oveq1 eqeq1d anbi12d
        cdif 2rexbidv rabbidv df-pell1234qr reex rabex fvmpt ) EDAFZBFZEFZGHZCF
        ZIJZKJZLZUTMNJZVAVCMNJZIJZOJZPLZQZCRSBRSZATUBUSUTDGHZVCIJZKJZLZVGDVHIJZ
        OJZPLZQZCRSBRSZATUBUCUDULUEVADLZVMWBATWCVLWABCRRWCVFVQVKVTWCVEVPUSWCVDV
        OUTKWCVBVNVCIVADGUAUFUGUHWCVJVSPWCVIVRVGOVADVHIUIUGUJUKUMUNEABCUOWBATUP
        UQUR $.

      $( Membership in the set of general Pell solutions.  (Contributed by
         Stefan O'Rear, 17-Sep-2014.) $)
      elpell1234qr $p |- ( D e. ( NN \ []NN ) -> ( A e. ( Pell1234QR ` D ) <->
          ( A e. RR /\ E. z e. ZZ E. w e. ZZ ( A = ( z + ( ( sqr ` D ) x. w ) )
          /\ ( ( z ^ 2 ) - ( D x. ( w ^ 2 ) ) ) = 1 ) ) ) ) $=
        ( va cn csquarenn cdif wcel cfv cv cmul co wceq c2 cexp wa cz wrex cr
        cpell1234qr csqr caddc cmin c1 crab pell1234qrval eleq2d eqeq1 2rexbidv
        anbi1d elrab syl6bb ) DFGHIZCDUAJZICEKZAKZDUBJBKZLMUCMZNZUQOPMDUROPMLMU
        DMUENZQZBRSARSZETUFZICTICUSNZVAQZBRSARSZQUNUOVDCEABDUGUHVCVGECTUPCNZVBV
        FABRRVHUTVEVAUPCUSUIUKUJULUM $.

    $}

    $( General Pell solutions are (coded as) real numbers.  (Contributed by
       Stefan O'Rear, 17-Sep-2014.) $)
    pell1234qrre $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1234QR ` D ) ) -> A
        e. RR ) $=
      ( va vb cn csquarenn cdif wcel cpell1234qr cfv cr cv csqr cmul co wceq c2
      cexp cz wrex caddc cmin c1 wa elpell1234qr simprbda ) BEFGHABIJHAKHACLZBM
      JDLZNOUAOPUGQROBUHQRONOUBOUCPUDDSTCSTCDABUEUF $.

    $( No solution to a Pell equation is zero.  (Contributed by Stefan O'Rear,
       17-Sep-2014.) $)
    pell1234qrne0 $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1234QR ` D ) ) ->
        A =/= 0 ) $=
      ( va vb cn csquarenn wcel cfv cc0 wne cmul co wceq c2 cexp cmin c1 wa cz
      cc cdif cpell1234qr cr csqr caddc wrex elpell1234qr simprl ax-1ne0 eldifi
      cv adantr nncnd ad3antrrr sqrcld zcn ad2antll sqmuld sqsqrd oveq1d eqtr2d
      ad2antrr oveq2d ad2antrl mulcld subsq syl2anc eqtrd simplr subcld 3eqtr3d
      simpr mul02d ex necon3d mpi adantrl eqnetrd rexlimdvva expimpd sylbid imp
      ) BEFUAGZABUBHGZAIJZWCWDAUCGZACUKZBUDHZDUKZKLZUELZMZWGNOLZBWINOLZKLZPLZQM
      ZRZDSUFCSUFZRWECDABUGWCWFWSWEWCWFRZWRWECDSSWTWGSGZWISGZRZRZWRWEXDWRRAWKIX
      DWLWQUHXDWQWKIJZWLXDWQRZQIJXEUIXFWKIQIXFWKIMZQIMXFXGRZWPWKWGWJPLZKLZQIXHW
      PWMWJNOLZPLZXJXHWOXKWMPXHXKWHNOLZWNKLWOXHWHWIXHBWTBTGXCWQXGWTBWCBEGWFBEFU
      JULUMUNZUOZXDWITGZWQXGXBXPWTXAWIUPUQVBZURXHXMBWNKXHBXNUSUTVAVCXHWGTGZWJTG
      XLXJMXDXRWQXGXAXRWTXBWGUPVDVBZXHWHWIXOXQVEZWGWJVFVGVHXDWQXGVIXHXJIXIKLIXH
      WKIXIKXFXGVLUTXHXIXHWGWJXSXTVJVMVHVKVNVOVPVQVRVNVSVTWAWB $.

    $( General solutions of the Pell equation are closed under reciprocals.
       (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell1234qrreccl $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1234QR ` D ) )
        -> ( 1 / A ) e. ( Pell1234QR ` D ) ) $=
      ( vc vd va vb wcel wa c1 co cv cmul caddc wceq c2 cexp cmin cz cc oveq2d
      cn csquarenn cdif cpell1234qr cdiv cr csqr wrex elpell1234qr pell1234qrre
      biimpa pell1234qrne0 rereccld ad2antrr cneg simplrl simplrr znegcld recnd
      cfv zcn adantr ad2antlr eldifi ad3antrrr sqrcld zcnd negcld mulcld addcld
      nncnd cc0 sqmuld sqsqrd oveq1d eqtr2d simprr subsq syl2anc 3eqtr3d recidd
      wne simprl mulneg2d negsubd eqtrd oveq12d 3eqtr4d mulcanad syl weq eqeq2d
      sqneg oveq1 eqeq1d anbi12d oveq2 rspc2ev syl112anc jca rexlimdvva adantld
      ex mpd wb mpbird ) BUAUBUCGZABUDUTZGZHZIAUEJZXHGZXKUFGZXKCKZBUGUTZDKZLJZM
      JZNZXNOPJZBXPOPJZLJZQJZINZHZDRUHCRUHZHZXJAUFGZAEKZXOFKZLJZMJZNZYIOPJZBYJO
      PJZLJZQJZINZHZFRUHERUHZHZYGXGXIUUAEFABUIUKXJYTYGYHXJYSYGEFRRXJYIRGZYJRGZH
      ZHZYSYGUUEYSHZXMYFXJXMUUDYSXJAABUJZABULZUMZUNUUFUUBYJUOZRGXKYIXOUUJLJZMJZ
      NZYNBUUJOPJZLJZQJZINZYFXJUUBUUCYSUPUUFYJXJUUBUUCYSUQZURUUFXKUULAXJXKSGUUD
      YSXJXKUUIUSUNUUFYIUUKUUDYISGZXJYSUUBUUSUUCYIVAVBVCZUUFXOUUJUUFBXGBSGXIUUD
      YSXGBBUAUBVDVKVEZVFZUUFYJUUFYJUURVGZVHVIVJXJASGUUDYSXJAUUGUSUNZXJAVLWBUUD
      YSUUHUNZUUFIYLYIYKQJZLJZAXKLJAUULLJUUFYQYNYKOPJZQJZIUVGUUFYPUVHYNQUUFUVHX
      OOPJZYOLJYPUUFXOYJUVBUVCVMUUFUVJBYOLUUFBUVAVNVOVPTUUEYMYRVQZUUFUUSYKSGUVI
      UVGNUUTUUFXOYJUVBUVCVIZYIYKVRVSVTUUFAUVDUVEWAUUFAYLUULUVFLUUEYMYRWCUUFUUL
      YIYKUOZMJUVFUUFUUKUVMYIMUUFXOYJUVBUVCWDTUUFYIYKUUTUVLWEWFWGWHWIUUFUUPYQIU
      UFUUOYPYNQUUFUUNYOBLUUFYJSGUUNYONUVCYJWMWJTTUVKWFYEUUMUUQHXKYIXQMJZNZYNYB
      QJZINZHCDYIUUJRRCEWKZXSUVOYDUVQUVRXRUVNXKXNYIXQMWNWLUVRYCUVPIUVRXTYNYBQXN
      YIOPWNVOWOWPXPUUJNZUVOUUMUVQUUQUVSUVNUULXKUVSXQUUKYIMXPUUJXOLWQTWLUVSUVPU
      UPIUVSYBUUOYNQUVSYAUUNBLXPUUJOPWNTTWOWPWRWSWTXCXAXBXDXGXLYGXEXICDXKBUIVBX
      F $.

    $( General solutions of the Pell equation are closed under multiplication.
       (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell1234qrmulcl $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1234QR ` D ) /\
        B e. ( Pell1234QR ` D ) ) -> ( A x. B ) e. ( Pell1234QR ` D ) ) $=
      ( wcel cmul co wa cv caddc wceq c2 cexp cmin c1 cz wrex oveq12d cc mulcld
      oveq2d va vb vc vd ve vf cn csquarenn cdif cpell1234qr cr csqr wi remulcl
      cfv ad5antlr simprl ad3antrrr simplrl zmulcld eldifi ad2antrr nnzd simprr
      simplrr zaddcld zcn ad2antrl nncnd sqrcld ad2antll adantr ad2antlr adantl
      mul4d oveq1d eqtrd mul12d adddid eqtr4d 3eqtrd addcld sqmuld sqsqrd subsq
      muladdd msqsqrd eqtr2d syl2anc mulsubd subcld 3eqtr2d 1t1e1 eqeq2d eqeq1d
      a1i oveq1 anbi12d oveq2 rspc2ev syl112anc jca ex rexlimdvva imp3a expimpd
      elpell1234qr an4 syl6bb 3imtr4d 3impib ) CUGUHUIDZACUJUOZDZBXMDZABEFZXMDZ
      XLAUKDZBUKDZGZAUAHZCULUOZUBHZEFZIFZJZYAKLFZCYCKLFZEFZMFZNJZGZUBOPUAOPZBUC
      HZYBUDHZEFZIFZJZYNKLFZCYOKLFZEFZMFZNJZGZUDOPUCOPZGZGZXPUKDZXPUEHZYBUFHZEF
      ZIFZJZUUIKLFZCUUJKLFZEFZMFZNJZGZUFOPUEOPZGZXNXOGZXQXLXTUUFUVAXLXTGZYMUUEU
      VAUVCYLUUEUVAUMZUAUBOOUVCYAODZYCODZGZGZYLUVDUVHYLGZUUDUVAUCUDOOUVIYNODZYO
      ODZGZGZUUDUVAUVMUUDGZUUHUUTXTUUHXLUVGYLUVLUUDABUNUPUVNYAYNEFZCYOYCEFZEFZI
      FZODYAYOEFZYNYCEFZIFZODXPUVRYBUWAEFZIFZJZUVRKLFZCUWAKLFZEFZMFZNJZUUTUVNUV
      OUVQUVNYAYNUVHUVEYLUVLUUDUVCUVEUVFUQURZUVIUVJUVKUUDUSZUTUVNCUVPUVHCODYLUV
      LUUDUVHCXLCUGDXTUVGCUGUHVAVBZVCURUVNYOYCUVIUVJUVKUUDVEZUVHUVFYLUVLUUDUVCU
      VEUVFVDURZUTUTVFUVNUVSUVTUVNYAYOUWJUWMUTUVNYNYCUWKUWNUTVFUVNXPYEYQEFZUVOY
      PYDEFZIFZYAYPEFZYNYDEFZIFZIFZUWCUVNAYEBYQEUVIYFUVLUUDUVHYFYKUQVBUVMYRUUCU
      QQUVNYAYDYNYPUVHYARDZYLUVLUUDUVEUXBUVCUVFYAVGVHURZUVNYBYCUVNCUVHCRDYLUVLU
      UDUVHCUWLVIURZVJZUVHYCRDZYLUVLUUDUVFUXFUVCUVEYCVGVKURZSZUVLYNRDZUVIUUDUVJ
      UXIUVKYNVGVLVMZUVNYBYOUXEUVLYORDZUVIUUDUVKUXKUVJYOVGVNVMZSZWFZUVNUWQUVRUW
      TUWBIUVNUWPUVQUVOIUVNUWPYBYBEFZUVPEFUVQUVNYBYOYBYCUXEUXLUXEUXGVOUVNUXOCUV
      PEUVNCUXDWGVPVQTZUVNUWTYBUVSEFZYBUVTEFZIFUWBUVNUWRUXQUWSUXRIUVNYAYBYOUXCU
      XEUXLVRUVNYNYBYCUXJUXEUXGVRQUVNYBUVSUVTUXEUVNYAYOUXCUXLSZUVNYNYCUXJUXGSZV
      SVTZQZWAUVNUWHUWOYAYDMFZYNYPMFZEFZEFZYGYBKLFZYHEFZMFZYSUYGYTEFZMFZEFZNUVN
      UWHUWEUWBKLFZMFZUWCUVRUWBMFZEFZUYFUVNUWGUYMUWEMUVNUYMUYGUWFEFUWGUVNYBUWAU
      XEUVNUVSUVTUXSUXTWBZWCUVNUYGCUWFEUVNCUXDWDZVPWHTUVNUVRRDUWBRDUYNUYPJUVNUV
      OUVQUVNYAYNUXCUXJSUVNCUVPUXDUVNYOYCUXLUXGSSWBUVNYBUWAUXEUYQSUVRUWBWEWIUVN
      UWCUWOUYOUYEEUVNUWOUXAUWCUXNUYBWHUVNUYEUWQUWTMFUYOUVNYAYDYNYPUXCUXHUXJUXM
      WJUVNUWQUVRUWTUWBMUXPUYAQWHQWAUVNUYFYEUYCEFZYQUYDEFZEFYGYDKLFZMFZYSYPKLFZ
      MFZEFUYLUVNYEYQUYCUYDUVNYAYDUXCUXHWBUVNYNYPUXJUXMWBUVNYAYDUXCUXHWKUVNYNYP
      UXJUXMWKVOUVNVUBUYSVUDUYTEUVNUXBYDRDVUBUYSJUXCUXHYAYDWEWIUVNUXIYPRDVUDUYT
      JUXJUXMYNYPWEWIQUVNVUBUYIVUDUYKEUVNVUAUYHYGMUVNYBYCUXEUXGWCTUVNVUCUYJYSMU
      VNYBYOUXEUXLWCTQWLUVNUYLYJUUBEFNNEFZNUVNUYIYJUYKUUBEUVNUYHYIYGMUVNUYGCYHE
      UYRVPTUVNUYJUUAYSMUVNUYGCYTEUYRVPTQUVNYJNUUBNEUVIYKUVLUUDUVHYFYKVDVBUVMYR
      UUCVDQVUENJUVNWMWPWAWAUUSUWDUWIGXPUVRUUKIFZJZUWEUUPMFZNJZGUEUFUVRUWAOOUUI
      UVRJZUUMVUGUURVUIVUJUULVUFXPUUIUVRUUKIWQWNVUJUUQVUHNVUJUUNUWEUUPMUUIUVRKL
      WQVPWOWRUUJUWAJZVUGUWDVUIUWIVUKVUFUWCXPVUKUUKUWBUVRIUUJUWAYBEWSTWNVUKVUHU
      WHNVUKUUPUWGUWEMVUKUUOUWFCEUUJUWAKLWQTTWOWRWTXAXBXCXDXCXDXEXFXLUVBXRYMGZX
      SUUEGZGUUGXLXNVULXOVUMUAUBACXGUCUDBCXGWRXRYMXSUUEXHXIUEUFXPCXGXJXK $.

    $( ( Characterize the right branch Pell14 as the positive elements ) $)

    $( A positive Pell solution is a general Pell solution.  (Contributed by
       Stefan O'Rear, 18-Sep-2014.) $)
    pell14qrss1234 $p |- ( D e. ( NN \ []NN ) -> ( Pell14QR ` D ) C_ (
        Pell1234QR ` D ) ) $=
      ( va vb vc cn csquarenn cdif wcel cpell14qr cv cmul co wceq c2 cexp wa cz
      cfv wrex cn0 cpell1234qr cr csqr caddc cmin c1 a1i anim1d reximdv2 anim2d
      wi nn0z elpell14qr elpell1234qr 3imtr4d ssrdv ) AEFGHZBAIRZAUARZUQBJZUBHZ
      UTCJZAUCRDJZKLUDLMVBNOLAVCNOLKLUELUFMPDQSZCTSZPVAVDCQSZPUTURHUTUSHUQVEVFV
      AUQVDVDCTQUQVBTHZVBQHZVDVGVHUKUQVBULUGUHUIUJCDUTAUMCDUTAUNUOUP $.

    $( A positive Pell solution is a real number.  (Contributed by Stefan
       O'Rear, 18-Sep-2014.) $)
    pell14qrre $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> A e.
        RR ) $=
      ( cn csquarenn cdif cpell14qr cfv cpell1234qr pell14qrss1234 pell1234qrre
      wcel cr sselda syldan ) BCDEKZABFGZKABHGZKALKOPQABIMABJN $.

    $( A positive Pell solution is a nonzero number.  (Contributed by Stefan
       O'Rear, 17-Sep-2014.) $)
    pell14qrne0 $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> A
        =/= 0 ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv cpell1234qr cc0 wne pell14qrss1234
      sselda pell1234qrne0 syldan ) BCDEFZABGHZFABIHZFAJKPQRABLMABNO $.

    $( A positive Pell solution is a positive number.  (Contributed by Stefan
       O'Rear, 18-Sep-2014.) $)
    pell14qrgt0 $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> 0 <
        A ) $=
      ( va vb cn wcel cfv cc0 clt cr cmul co wceq c2 cexp cmin wa cabs ad2antlr
      wbr csquarenn cdif cpell14qr cv csqr caddc c1 wrex cn0 elpell14qr 0cn a1i
      cz cc eldifi ad3antrrr nnred nnnn0d nn0ge0d resqrcld zre remulcld abssubd
      adantl recnd subid1d fveq2d eqtrd absresq syl sqrcld sqmuld sqsqrd oveq1d
      3eqtrd simpr breqtrrd resqcld nn0re adantr posdifd mpbird eqbrtrd absge0d
      abscld cle nn0ge0 lt2sqd 0re absdifltd mpbid simprd nn0cn addcomd adantrl
      0lt1 simprl ex rexlimdvva expimpd sylbid imp ) BEUAUBFZABUCGFZHAITZXCXDAJ
      FZACUDZBUEGZDUDZKLZUFLZMZXGNOLZBXINOLZKLZPLZUGMZQZDUMUHCUIUHZQXECDABUJXCX
      FXSXEXCXFQZXRXECDUIUMXTXGUIFZXIUMFZQZQZXRXEYDXRQHXKAIYDXQHXKITXLYDXQQZHXJ
      XGUFLZXKIYEXJXGPLHITZHYFITZYEHXJPLRGZXGITYGYHQYEYIXJRGZXGIYEYIXJHPLZRGYJY
      EHXJHUNFYEUKULYEXJYEXHXIYEBYEBXCBEFXFYCXQBEUAUOUPZUQZYEBYEBYLURUSUTYCXIJF
      ZXTXQYBYNYAXIVAVDZSZVBZVEZVCYEYKXJRYEXJYRVFVGVHYEYJXGITYJNOLZXMITYEYSXOXM
      IYEYSXJNOLZXHNOLZXNKLXOYEXJJFYSYTMYQXJVIVJYEXHXIYEBYEBYMVEZVKYCXIUNFXTXQY
      CXIYOVESVLYEUUABXNKYEBUUBVMVNVOYEXOXMITHXPITYEHUGXPIHUGITYEWPULYDXQVPVQYE
      XOXMYEBXNYMYEXIYPVRVBYEXGYCXGJFZXTXQYAUUCYBXGVSVTSZVRWAWBWCYEYJXGYEXJYRWE
      UUDYEXJYRWDYCHXGWFTZXTXQYAUUEYBXGWGVTSWHWBWCYEHXJXGHJFYEWIULYQUUDWJWKWLYE
      XGXJYCXGUNFZXTXQYAUUFYBXGWMVTSYRWNVQWOYDXLXQWQVQWRWSWTXAXB $.

    $( A positive Pell solution is a positive real.  (Contributed by Stefan
       O'Rear, 19-Sep-2014.) $)
    pell14qrrp $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> A e.
        RR+ ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv wa pell14qrre pell14qrgt0 elrpd )
      BCDEFABGHFIAABJABKL $.

    $( A general Pell solution is either a positive solution, or its negation
       is.  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell1234qrdich $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1234QR ` D ) ) ->
        ( A e. ( Pell14QR ` D ) \/ -u A e. ( Pell14QR ` D ) ) ) $=
      ( va vb vc wcel cneg cmul co caddc wceq c2 cexp cmin c1 wa wrex cn0 oveq1
      cz vd cn csquarenn cdif cpell1234qr cfv cpell14qr wo cr csqr elpell1234qr
      cv wi simp-4r weq eqeq2d oveq1d eqeq1d anbi12d rexbidv adantll elpell14qr
      rspcev wb ad4antr mpbir2and orcd simp-5r renegcld simpllr znegcl ad2antlr
      exp31 simprl negeqd cc adantl ad3antrrr eldifi nncnd sqrcld mulcld negdid
      zcn ad5antr mulneg2 eqcomd syl2anc oveq2d 3eqtrd sqneg syl oveq12d simprr
      eqtrd oveq2 rspc2ev syl112anc olcd rexlimdva elznn0 simprbi mpjaod sylbid
      ex expimpd imp ) BUBUCUDFZABUEUFFZABUGUFZFZAGZXJFZUHZXHXIAUIFZACULZBUJUFZ
      DULZHIZJIZKZXPLMIZBXRLMIZHIZNIZOKZPZDTQZCTQZPXNCDABUKXHXOYIXNXHXOPZYHXNCT
      YJXPTFZPZXPRFZYHXNUMZXPGZRFZYLYMYHXNYLYMPYHPZXKXMYQXKXOAEULZXSJIZKZYRLMIZ
      YDNIZOKZPZDTQZERQZXHXOYKYMYHUNYMYHUUFYLUUEYHEXPRECUOZUUDYGDTUUGYTYAUUCYFU
      UGYSXTAYRXPXSJSUPUUGUUBYEOUUGUUAYBYDNYRXPLMSUQURUSUTVCVAXHXKXOUUFPVDXOYKY
      MYHEDABVBVEVFVGVMYLYPYNYLYPPZYGXNDTUUHXRTFZPZYGXNUUJYGPZXMXKUUKXMXLUIFZXL
      YRXQUAULZHIZJIZKZUUABUUMLMIZHIZNIZOKZPZUATQERQZUUKAXHXOYKYPUUIYGVHVIUUKYP
      XRGZTFZXLYOXQUVCHIZJIZKZYOLMIZBUVCLMIZHIZNIZOKZUVBYLYPUUIYGVJUUIUVDUUHYGX
      RVKVLUUKXLXTGYOXSGZJIUVFUUKAXTUUJYAYFVNVOUUKXPXSYLXPVPFZYPUUIYGYKUVNYJXPW
      DVQVRZUUKXQXRUUKBXHBVPFXOYKYPUUIYGXHBBUBUCVSVTWEWAZUUIXRVPFZUUHYGXRWDVLZW
      BWCUUKUVMUVEYOJUUKXQVPFZUVQUVMUVEKUVPUVRUVSUVQPUVEUVMXQXRWFWGWHWIWJUUKUVK
      YEOUUKUVHYBUVJYDNUUKUVNUVHYBKUVOXPWKWLUUKUVIYCBHUUKUVQUVIYCKUVRXRWKWLWIWM
      UUJYAYFWNWOUVAUVGUVLPXLYOUUNJIZKZUVHUURNIZOKZPEUAYOUVCRTYRYOKZUUPUWAUUTUW
      CUWDUUOUVTXLYRYOUUNJSUPUWDUUSUWBOUWDUUAUVHUURNYRYOLMSUQURUSUUMUVCKZUWAUVG
      UWCUVLUWEUVTUVFXLUWEUUNUVEYOJUUMUVCXQHWPWIUPUWEUWBUVKOUWEUURUVJUVHNUWEUUQ
      UVIBHUUMUVCLMSWIWIURUSWQWRXHXMUULUVBPVDXOYKYPUUIYGEUAXLBVBWEVFWSXEWTXEYKY
      MYPUHZYJYKXPUIFUWFXPXAXBVQXCWTXFXDXG $.

    $( A number is a positive Pell solution iff it is positive and a Pell
       solution, justifying our name choice.  (Contributed by Stefan O'Rear,
       19-Oct-2014.) $)
    elpell14qr2 $p |- ( D e. ( NN \ []NN ) -> ( A e. ( Pell14QR ` D ) <-> ( A
        e. ( Pell1234QR ` D ) /\ 0 < A ) ) ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv cpell1234qr cc0 clt pell14qrss1234
      wbr wa sselda pell14qrgt0 wn cr wi adantrr jca wo 0re pell1234qrre ltnsym
      cneg sylancr impr lt0neg1d mtbid ex adantr mtod pell1234qrdich orel2 sylc
      impbida ) BCDEFZABGHZFZABIHZFZJAKMZNZURUTNVBVCURUSVAABLOABPUAURVDNZAUFZUS
      FZQUTVGUBZUTVEVGJVFKMZVEAJKMZVIURVBVCVJQZURVBNJRFARFZVCVKSUCABUDZJAUEUGUH
      VEAURVBVLVCVMTUIUJURVGVISVDURVGVIVFBPUKULUMURVBVHVCABUNTVGUTUOUPUQ $.

    $( Positive Pell solutions are closed under multiplication.  (Contributed
       by Stefan O'Rear, 17-Sep-2014.) $)
    pell14qrmulcl $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ B e.
        ( Pell14QR ` D ) ) -> ( A x. B ) e. ( Pell14QR ` D ) ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv cmul co cpell1234qr cc0 clt wbr wa
      cr pell1234qrre syldan elpell14qr2 simprll simprrl pell1234qrmulcl jca ex
      simpl syl3anc simprlr simprrr mulgt0d anbi12d 3imtr4d 3impib ) CDEFGZACHI
      ZGZBUOGZABJKZUOGZUNACLIZGZMANOZPZBUTGZMBNOZPZPZURUTGZMURNOZPZUPUQPUSUNVGV
      JUNVGPZVHVIVKUNVAVDVHUNVGUFUNVAVBVFUAZUNVCVDVEUBZABCUCUGVKABUNVGVAAQGVLAC
      RSUNVGVDBQGVMBCRSUNVAVBVFUHUNVCVDVEUIUJUDUEUNUPVCUQVFACTBCTUKURCTULUM $.

    $( Positive Pell solutions are closed under reciprocal.  (Contributed by
       Stefan O'Rear, 18-Sep-2014.) $)
    pell14qrreccl $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> (
        1 / A ) e. ( Pell14QR ` D ) ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv c1 cdiv co cpell1234qr cc0 clt wbr
      wa pell1234qrreccl adantrr cr elpell14qr2 pell1234qrre simprr recgt0d jca
      ex 3imtr4d imp ) BCDEFZABGHZFZIAJKZUIFZUHABLHZFZMANOZPZUKUMFZMUKNOZPZUJUL
      UHUPUSUHUPPZUQURUHUNUQUOABQRUTAUHUNASFUOABUARUHUNUOUBUCUDUEABTUKBTUFUG $.

    $( Positive Pell solutions are closed under division.  (Contributed by
       Stefan O'Rear, 18-Sep-2014.) $)
    pell14qrdivcl $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ B e.
        ( Pell14QR ` D ) ) -> ( A / B ) e. ( Pell14QR ` D ) ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv w3a cdiv co c1 cc pell14qrre recnd
      cmul wa 3adant3 3adant2 cc0 wne pell14qrne0 divrecd pell14qrreccl eqeltrd
      pell14qrmulcl syld3an3 ) CDEFGZACHIZGZBUJGZJZABKLAMBKLZQLZUJUMABUIUKANGUL
      UIUKRAACOPSUIULBNGUKUIULRBBCOPTUIULBUAUBUKBCUCTUDUIUKULUNUJGZUOUJGUIULUPU
      KBCUETAUNCUGUHUF $.

    $( Lemma for ~ pell14qrexpcl .  (Contributed by Stefan O'Rear,
       18-Sep-2014.) $)
    pell14qrexpclnn0 $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ B
        e. NN0 ) -> ( A ^ B ) e. ( Pell14QR ` D ) ) $=
      ( va vb cn csquarenn wcel cn0 cexp co cv wi cc0 wceq oveq2 eleq1d eqeltrd
      c1 imbi2d cdif cpell14qr cfv caddc weq pell14qrre recnd exp0d pell14qrne0
      wa cdiv dividd eqtr4d pell14qrdivcl 3anidm23 w3a cc 3ad2ant2 simp1 expp1d
      cmul simp2l simp3 simp2r pell14qrmulcl syl3anc 3exp a2d nn0ind exp3acom3r
      3imp ) CFGUAHZACUBUCZHZBIHZABJKZVMHZVOVLVNVQVLVNUJZADLZJKZVMHZMVRANJKZVMH
      ZMVRAELZJKZVMHZMVRAWDSUDKZJKZVMHZMVRVQMDEBVSNOZWAWCVRWJVTWBVMVSNAJPQTDEUE
      ZWAWFVRWKVTWEVMVSWDAJPQTVSWGOZWAWIVRWLVTWHVMVSWGAJPQTVSBOZWAVQVRWMVTVPVMV
      SBAJPQTVRWBAAUKKZVMVRWBSWNVRAVRAACUFUGZUHVRAWOACUIULUMVLVNWNVMHAACUNUORWD
      IHZVRWFWIWPVRWFWIWPVRWFUPZWHWEAVAKZVMWQAWDVRWPAUQHWFWOURWPVRWFUSUTWQVLWFV
      NWRVMHWPVLVNWFVBWPVRWFVCWPVLVNWFVDWEACVEVFRVGVHVIVJVK $.

    $( Positive Pell solutions are closed under integer powers.  (Contributed
       by Stefan O'Rear, 18-Sep-2014.) $)
    pell14qrexpcl $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ B e.
        ZZ ) -> ( A ^ B ) e. ( Pell14QR ` D ) ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv co cn0 wa simplll pell14qrexpclnn0
      cexp simpllr simpr syl3anc cc recnd cz cr cneg wo c1 cdiv wceq pell14qrre
      elznn0 ad2antrr simplr expneg2 pell14qrreccl syl2anc jaodan syl5bi 3impia
      eqeltrd expl ) CDEFGZACHIZGZBUAGZABOJZVAGZVCBUBGZBKGZBUCZKGZUDZLUTVBLZVEB
      UIVKVFVJVEVKVFLZVGVEVIVLVGLUTVBVGVEUTVBVFVGMUTVBVFVGPVLVGQABCNRVLVILZVDUE
      AVHOJZUFJZVAVMASGZBSGVIVDVOUGVKVPVFVIVKAACUHTUJVMBVKVFVIUKTVLVIQZABULRVMU
      TVNVAGZVOVAGUTVBVFVIMZVMUTVBVIVRVSUTVBVFVIPVQAVHCNRVNCUMUNURUOUSUPUQ $.

    $( First-quadrant Pell solutions are a subset of the positive solutions.
       (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell1qrss14 $p |- ( D e. ( NN \ []NN ) -> ( Pell1QR ` D ) C_ ( Pell14QR ` D
        ) ) $=
      ( va vc vb cn csquarenn cdif wcel cpell1qr cfv cv cmul co wceq c2 cexp wa
      cn0 wrex cz cpell14qr cr csqr caddc cmin nn0z a1i anim1d reximdv2 reximdv
      c1 wi anim2d elpell1qr elpell14qr 3imtr4d ssrdv ) AEFGHZBAIJZAUAJZURBKZUB
      HZVACKZAUCJDKZLMUDMNVCOPMAVDOPMLMUEMUKNQZDRSZCRSZQVBVEDTSZCRSZQVAUSHVAUTH
      URVGVIVBURVFVHCRURVEVEDRTURVDRHZVDTHZVEVJVKULURVDUFUGUHUIUJUMCDVAAUNCDVAA
      UOUPUQ $.

    $( A positive Pell solution is either in the first quadrant, or its
       reciprocal is.  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell14qrdich $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> ( A
        e. ( Pell1QR ` D ) \/ ( 1 / A ) e. ( Pell1QR ` D ) ) ) $=
      ( va vb wcel wa cmul co caddc wceq c2 cexp cmin c1 cn0 ad2antrr cc adantr
      wrex oveq2d vc cn csquarenn cdif cpell14qr cr cv csqr cz cpell1qr cdiv wo
      cfv elpell14qr biimpa cneg simplrr elznn0 sylib simprd simplr simpr rsp2e
      simprl syl3anc jca elpell1qr ad4antr sylibrd cc0 wne pell14qrne0 rereccld
      ex pell14qrre recnd reccld ad3antrrr nn0cn ad2antrl eldifi nncnd ad2antll
      sqrcld zcn negcld mulcld addcld recidd simprr eqtr4d subsq syl2anc sqmuld
      sqsqrd oveq1d eqtr2d mulneg2d negsub eqcomd oveq12d 3eqtr4d adantrr eqtrd
      wb mulcanad sqneg syl oveq2 eqeq2d eqeq1d anbi12d rspcev rspe orim12d mpd
      oveq1 rexlimdvva expimpd ) BUBUCUDEZABUEUMEZFZAUFEZACUGZBUHUMZDUGZGHZIHZJ
      ZYDKLHZBYFKLHZGHZMHZNJZFZDUISCOSZFZABUJUMZEZNAUKHZYREZULZXTYAYQCDABUNUOYB
      YCYPUUBYBYCFZYOUUBCDOUIUUCYDOEZYFUIEZFZFZYOUUBUUGYOFZYFOEZYFUPZOEZULZUUBU
      UHYFUFEZUULUUHUUEUUMUULFUUCUUDUUEYOUQYFURUSUTUUHUUIYSUUKUUAUUHUUIYCYODOSC
      OSZFZYSUUHUUIUUOUUHUUIFZYCUUNUUGYCYOUUIYBYCUUFVAZPUUPUUDUUIYOUUNUUGUUDYOU
      UIUUCUUDUUEVDZPUUHUUIVBUUGYOUUIVAYOCDOOVCVEVFVNXTYSUUOXEYAYCUUFYOCDABVGVH
      VIUUHUUKYTUFEZYTYDYEUAUGZGHZIHZJZYJBUUTKLHZGHZMHZNJZFZUAOSZCOSZFZUUAUUHUU
      KUVKUUHUUKFZUUSUVJUVLAUUGYCYOUUKUUQPYBAVJVKZYCUUFYOUUKABVLZVHVMUVLUUDUVIU
      VJUUGUUDYOUUKUURPUVLUUKYTYDYEUUJGHZIHZJZYJBUUJKLHZGHZMHZNJZFZUVIUUHUUKVBU
      VLUVQUWAUUHUVQUUKUUHYTUVPAYBYTQEYCUUFYOYBAYBAABVOVPZUVNVQVRUUGUVPQEYOUUGY
      DUVOUUDYDQEZUUCUUEYDVSVTZUUGYEUUJUUGBXTBQEYAYCUUFXTBBUBUCWAWBVRZWDZUUGYFU
      UEYFQEZUUCUUDYFWEWCZWFWGWHRYBAQEYCUUFYOUWCVRYBUVMYCUUFYOUVNVRUUHAYTGHZYMA
      UVPGHZUUHUWJNYMYBUWJNJYCUUFYOYBAUWCUVNWIVRUUGYIYNWJWKUUGYIYMUWKJYNUUGYIFZ
      YJYGKLHZMHZYHYDYGMHZGHZYMUWKUWLUWDYGQEZUWNUWPJUUGUWDYIUWERUUGUWQYIUUGYEYF
      UWGUWIWGZRYDYGWLWMUUGYMUWNJYIUUGYLUWMYJMUUGUWMYEKLHZYKGHYLUUGYEYFUWGUWIWN
      UUGUWSBYKGUUGBUWFWOWPWQTRUWLAYHUVPUWOGUUGYIVBUUGUVPUWOJYIUUGUVPYDYGUPZIHZ
      UWOUUGUVOUWTYDIUUGYEYFUWGUWIWRTUUGUWDUWQUWOUXAJUWEUWRUWDUWQFUXAUWOYDYGWSW
      TWMWKRXAXBXCXDXFRUVLUVTYMNUVLUVSYLYJMUVLUVRYKBGUVLUWHUVRYKJUUGUWHYOUUKUWI
      PYFXGXHTTUUGYIYNUUKUQXDVFUVHUWBUAUUJOUUTUUJJZUVCUVQUVGUWAUXBUVBUVPYTUXBUV
      AUVOYDIUUTUUJYEGXITXJUXBUVFUVTNUXBUVEUVSYJMUXBUVDUVRBGUUTUUJKLXQTTXKXLXMW
      MUVICOXNWMVFVNXTUUAUVKXEYAYCUUFYOCUAYTBVGVHVIXOXPVNXRXSXP $.

    $( A Pell solution in the first quadrant is at least 1.  (Contributed by
       Stefan O'Rear, 17-Sep-2014.) $)
    pell1qrge1 $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1QR ` D ) ) -> 1 <_ A
        ) $=
      ( va vb cn wcel c1 cle wbr co wceq c2 cexp wa cn0 a1i nn0red nn0ge0d cc0
      cc csquarenn cdif cpell1qr cfv cr csqr cmul caddc cmin wrex elpell1qr 1re
      simplrl eldifi ad3antrrr nnnn0d resqrcld remulcld readdcld 2nn0 nn0expcld
      nn0mulcld addge02d mpbid sq1 nn0cn ad2antrl sqcld ad2antrr nncnd ad2antll
      cv simplrr mulcld ax-1cn subaddd biimpa eqcomd 3brtr4d 0le1 le2sqd mpbird
      sqrge0d mulge0d addge01d letrd adantrl simprl breqtrrd rexlimdvva expimpd
      ex sylbid imp ) BEUAUBFZABUCUDFZGAHIZWOWPAUEFZACVLZBUFUDZDVLZUGJZUHJZKZWS
      LMJZBXALMJZUGJZUIJGKZNZDOUJCOUJZNWQCDABUKWOWRXJWQWOWRNZXIWQCDOOXKWSOFZXAO
      FZNZNZXIWQXOXINGXCAHXOXHGXCHIXDXOXHNZGWSXCGUEFXPULPZXPWSXKXLXMXHUMZQZXPWS
      XBXSXPWTXAXPBXPBXPBWOBEFZWRXNXHBEUAUNZUOUPZQZXPBYBRZUQZXPXAXKXLXMXHVMZQZU
      RZUSXPGWSHIGLMJZXEHIXPGXGGUHJZYIXEHXPSXGHIGYJHIXPXGXPBXFYBXPXALYFLOFXPUTP
      VAVBZRXPGXGXQXPXGYKQVCVDYIGKXPVEPXPYJXEXOXHYJXEKXOXEXGGXOWSXLWSTFXKXMWSVF
      VGVHXOBXFXOBWOXTWRXNYAVIVJXOXAXMXATFXKXLXAVFVKVHVNGTFXOVOPVPVQVRVSXPGWSXQ
      XSSGHIXPVTPXPWSXRRWAWBXPSXBHIWSXCHIXPWTXAYEYGXPBYCYDWCXPXAYFRWDXPWSXBXSYH
      WEVDWFWGXOXDXHWHWIWLWJWKWMWN $.

    $( 1 is a Pell solution and in the first quadrant as one.  (Contributed by
       Stefan O'Rear, 17-Sep-2014.) $)
    pell1qr1 $p |- ( D e. ( NN \ []NN ) -> 1 e. ( Pell1QR ` D ) ) $=
      ( va vb cn csquarenn wcel c1 cmul co caddc wceq c2 cexp wa cn0 a1i oveq2d
      cmin cc0 oveq1 cdif cpell1qr cfv cr csqr wrex 1re 1nn0 0nn0 eldifi sqrcld
      nncnd mul01d ax-1cn addid1i syl6req sq1 sq0 oveq2i syl5eq oveq12d subid1i
      syl6eq eqeq2d oveq1d eqeq1d anbi12d rspc2ev syl112anc elpell1qr mpbir2and
      cv oveq2 ) ADEUAFZGAUBUCFGUDFZGBVLZAUEUCZCVLZHIZJIZKZVPLMIZAVRLMIZHIZRIZG
      KZNZCOUFBOUFZVOVNUGPVNGOFZSOFZGGVQSHIZJIZKZGLMIZASLMIZHIZRIZGKZWHWIVNUHPW
      JVNUIPVNWLGSJIGVNWKSGJVNVQVNAVNAADEUJULZUKUMQGUNUOUPVNWQGSRIGVNWNGWPSRWNG
      KVNUQPVNWPASHISWOSAHURUSVNAWSUMUTVAGUNVBVCWGWMWRNGGVSJIZKZWNWDRIZGKZNBCGS
      OOVPGKZWAXAWFXCXDVTWTGVPGVSJTVDXDWEXBGXDWBWNWDRVPGLMTVEVFVGVRSKZXAWMXCWRX
      EWTWLGXEVSWKGJVRSVQHVMQVDXEXBWQGXEWDWPWNRXEWCWOAHVRSLMTQQVFVGVHVIBCGAVJVK
      $.

    $( The first quadrant solutions are precisely the positive Pell solutions
       which are at least one.  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    elpell1qr2 $p |- ( D e. ( NN \ []NN ) -> ( A e. ( Pell1QR ` D ) <-> ( A e.
        ( Pell14QR ` D ) /\ 1 <_ A ) ) ) $=
      ( wcel cfv c1 cle wbr wa pell1qrge1 clt wceq wo cr 1re a1i cdiv co wn cc0
      adantr cn csquarenn cdif cpell1qr cpell14qr pell1qrss14 sselda pell14qrre
      jca leloed ltnled biimpa ax-1cn div1i eqcomi breq2d wb pell14qrgt0 lerec2
      0lt1 syl22anc bitrd mtbid simplll sylancom mtand pell14qrdich orel2 simpr
      sylc pell1qr1 ad2antrr eqeltrrd jaodan ex sylbid impr impbida ) BUAUBUCCZ
      ABUDDZCZABUEDZCZEAFGZHVSWAHWCWDVSVTWBABUFUGABIUIVSWCWDWAVSWCHZWDEAJGZEAKZ
      LZWAWEEAEMCZWENOZABUHZUJWEWHWAWEWFWAWGWEWFHZEAPQZVTCZRWAWNLZWAWLWNEWMFGZW
      LAEFGZWPWEWFWQRWEEAWJWKUKULWLWQAEEPQZFGZWPWLEWRAFEWRKWLWREEUMUNUOOUPWLAMC
      ZSAJGZWISEJGZWSWPUQWEWTWFWKTWEXAWFABURTWIWLNOXBWLUTOAEUSVAVBVCWLWNVSWPVSW
      CWFWNVDWMBIVEVFWEWOWFABVGTWNWAVHVJWEWGHEAVTWEWGVIVSEVTCWCWGBVKVLVMVNVOVPV
      QVR $.

    $( Lemma for ~ pell1qrgap .  (Contributed by Stefan O'Rear,
       18-Sep-2014.) $)
    pell1qrgaplem $p |- ( ( ( D e. NN /\ ( A e. NN0 /\ B e. NN0 ) ) /\ ( 1 < (
        A + ( ( sqr ` D ) x. B ) ) /\ ( ( A ^ 2 ) - ( D x. ( B ^ 2 ) ) ) = 1 )
        ) -> ( ( sqr ` ( D + 1 ) ) + ( sqr ` D ) ) <_ ( A + ( ( sqr ` D ) x. B
        ) ) ) $=
      ( wcel wa c1 cmul co caddc wbr c2 cexp cmin wceq a1i adantr cle cc0 eqtrd
      oveq2d cn cn0 csqr cfv clt crp ad2antrr 1rp rpaddcld rpsqrcld rpred nn0re
      cr ad2antlr adantl remulcld 1re resqcld resubcld 0re sq1 nnge1 wn simplrl
      nnrp oveq1 sq0 syl6eq cc rpcnd mul01d simplrr recnd sqcld subid1d 3eqtr3d
      syl5req wb nn0ge0 0le1 sq11 syl22anc mpbid oveq12d ax-1cn addid1i breqtrd
      simpr ltnri pm2.24 wo elnn0 sylib mpjaodan le2sqd eqbrtrrd suble0d mpbird
      ee10 lemul2d leadd2dd sqsqrd simprr eqcomd mulcld addsub12d subdid oveq1d
      mulid1d eqtr2d addid1d 3brtr4d rpge0d le2addd ) CUADZAUBDZBUBDZEZEZFACUCU
      DZBGHZIHZUEJZAKLHZCBKLHZGHZMHZFNZEZEZCFIHZUCUDZXTAYAYJYLYJYKYJCFXOCUFDXRY
      ICVEUGZFUFDYJUHOUIZUJZUKZYJXTYJCYMUJZUKZXRAUMDZXOYIXPYSXQAULPUNZYJXTBYRXR
      BUMDZXOYIXQUUAXPBULUOUNZUPYJYLAQJYLKLHZYDQJYJYDCFYEMHZGHZIHZYDCRGHZIHZUUC
      YDQYJUUEUUGYDYJCUUDYJCYMUKZYJFYEFUMDZYJUQOZYJBUUBURZUSZUPYJCRUUIRUMDYJUTO
      ZUPYJAYTURYJUUDRQJZUUEUUGQJYJUUOFYEQJYJFKLHZFYEQUUPFNYJVAOYJFBQJZUUPYEQJY
      JBUADZUUQBRNZUURUUQYJBVBUOYJUUSEZFFUEJZUVAVCUUQUUTFYBFUEXSYCYHUUSVDUUTYBF
      RIHFUUTAFYARIUUTYDUUPNZAFNZUUTUUPFYDVAUUTYGYDRMHFYDUUTYFRYDMUUTYFUUGRUUTY
      ERCGUUTYERKLHZRUUSYEUVDNYJBRKLVFUOVGVHTUUTCYJCVIDUUSYJCYMVJZPVKSTXSYCYHUU
      SVLUUTYDYJYDVIDUUSYJAYJAYTVMVNZPVOVPVQYJUVBUVCVRZUUSYJYSRAQJZUUJRFQJZUVGY
      TXRUVHXOYIXPUVHXQAVSPUNZUUKUVIYJVTOZAFWAWBPWCUUTYAXTRGHRUUTBRXTGYJUUSWHTU
      UTXTYJXTVIDUUSYJXTYQVJZPVKSWDFWEWFVHWGFUQWIUVAUUQWJWSYJXQUURUUSWKXOXPXQYI
      VLBWLWMWNZYJFBUUKUUBUVKXRRBQJZXOYIXQUVNXPBVSUOUNWOWCWPYJFYEUUKUULWQWRYJUU
      DRCUUMUUNYMWTWCXAYJUUCYKUUFYJYKYJYKYNVJXBYJYKCYGIHZUUFYJFYGCIYJYGFXSYCYHX
      CXDTYJUVOYDCYFMHZIHUUFYJCYDYFUVEUVFYJCYEUVEYJBYJBUUBVMVNZXEXFYJUVPUUEYDIY
      JUUECFGHZYFMHUVPYJCFYEUVEYJFUUKVMUVQXGYJUVRCYFMYJCUVEXIXHXJTSSSYJUUHYDRIH
      YDYJUUGRYDIYJCUVEVKTYJYDUVFXKXJXLYJYLAYPYTYJYLYOXMUVJWOWRYJXTFGHZXTYAQYJX
      TUVLXIYJUUQUVSYAQJUVMYJFBXTUUKUUBYQWTWCWPXN $.

    $( First-quadrant Pell solutions are bounded away from 1.  (This particular
       bound allows us to prove exact values for the fundamental solution
       later.)  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell1qrgap $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell1QR ` D ) /\ 1 < A )
        -> ( ( sqr ` ( D + 1 ) ) + ( sqr ` D ) ) <_ A ) $=
      ( va vb cn csquarenn wcel cfv c1 clt wbr caddc co csqr cle wa cv cmul cn0
      wceq cdif cpell1qr wi cr c2 cexp cmin wrex elpell1qr adantr eldifi simplr
      ad4antr simp-4r simprl breqtrd pell1qrgaplem syl22anc breqtrrd rexlimdvva
      wb simprr ex expimpd sylbid com23 3imp ) BEFUAGZABUBHGZIAJKZBILMNHBNHZLMZ
      AOKZVHVJVIVMVHVJVIVMUCVHVJPZVIAUDGZACQZVKDQZRMLMZTZVPUEUFMBVQUEUFMRMUGMIT
      ZPZDSUHCSUHZPZVMVHVIWCVAVJCDABUIUJVNVOWBVMVNVOPZWAVMCDSSWDVPSGVQSGPZPZWAV
      MWFWAPZVLVRAOWGBEGZWEIVRJKVTVLVROKVHWHVJVOWEWABEFUKUMWDWEWAULWGIAVRJVHVJV
      OWEWAUNWFVSVTUOZUPWFVSVTVBVPVQBUQURWIUSVCUTVDVEVCVFVG $.

    $( Positive Pell solutions are bounded away from 1.  (Contributed by Stefan
       O'Rear, 18-Sep-2014.) $)
    pell14qrgap $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ 1 < A
        ) -> ( ( sqr ` ( D + 1 ) ) + ( sqr ` D ) ) <_ A ) $=
      ( cn csquarenn cdif wcel cpell1qr cfv cpell14qr c1 clt wbr caddc csqr cle
      co w3a simp2 wa cr 1re pell14qrre ltle sylancr 3impia elpell1qr2 3ad2ant1
      wi wb mpbir2and pell1qrgap syld3an2 ) BCDEFZABGHFZABIHFZJAKLZBJMPNHBNHMPA
      OLUMUOUPQUNUOJAOLZUMUOUPRUMUOUPUQUMUOSJTFATFUPUQUHUAABUBJAUCUDUEUMUOUNUOU
      QSUIUPABUFUGUJABUKUL $.

    $( Positive Pell solutions are bounded away from 1, with a friendlier
       bound.  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pell14qrgapw $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ 1 < A
        ) -> 2 < A ) $=
      ( cn csquarenn wcel cfv c1 clt wbr c2 caddc co csqr cr a1i rpsqrcld rpred
      cexp syl cle cdif cpell14qr w3a 2re eldifi 3ad2ant1 crp rpaddcld readdcld
      nnrpd 1rp pell14qrre 3adant3 df-2 1re nnred peano2re nnge1d ltp1d lelttrd
      wceq sq1 cc nncnd peano2cn sqsqrd 3brtr4d cc0 rpge0d lt2sqd mpbird le2sqd
      0le1 ltleaddd syl5eqbr pell14qrgap ltletrd ) BCDUAEZABUBFEZGAHIZUCZJBGKLZ
      MFZBMFZKLZAJNEWAUDOWAWCWDWAWCWAWBWABGWABVRVSBCEVTBCDUEUFZUJZGUGEWAUKOUHPZ
      QZWAWDWABWGPZQZUIVRVSANEVTABULUMWAJGGKLWEHUNWAGGWCWDGNEWAUOOZWLWIWKWAGWCH
      IGJRLZWCJRLZHIWAGWBWMWNHWAGBWBWLWABWFUPZWABNEWBNEWOBUQSWABWFURZWABWOUSUTW
      MGVAWAVBOZWAWBWABVCEWBVCEWABWFVDZBVESVFVGWAGWCWLWIVHGTIWAVMOZWAWCWHVIVJVK
      WAGWDTIWMWDJRLZTIWAGBWMWTTWPWQWABWRVFVGWAGWDWLWKWSWAWDWJVIVLVKVNVOABVPVQ
      $.

    $( Condition for a calculated real to be a Pell solution.  (Contributed by
       Stefan O'Rear, 19-Sep-2014.) $)
    pellqrexplicit $p |- ( ( ( D e. ( NN \ []NN ) /\ A e. NN0 /\ B e. NN0 ) /\
        ( ( A ^ 2 ) - ( D x. ( B ^ 2 ) ) ) = 1 ) -> ( A + ( ( sqr ` D ) x. B )
        ) e. ( Pell1QR ` D ) ) $=
      ( va vb cn wcel cn0 c2 cexp co cmul cmin c1 wceq wa caddc cr oveq1 oveq2d
      csquarenn cdif w3a csqr cfv cpell1qr nn0re 3ad2ant2 eldifi 3ad2ant1 nnrpd
      wrex rpsqrcld rpred 3ad2ant3 remulcld readdcld adantr simpl2 simpl3 eqidd
      cv simpr eqeq2d oveq1d eqeq1d anbi12d oveq2 syl112anc elpell1qr mpbir2and
      rspc2ev wb ) CFUAUBGZAHGZBHGZUCZAIJKZCBIJKZLKZMKZNOZPZACUDUEZBLKZQKZCUFUE
      GZWFRGZWFDVBZWDEVBZLKZQKZOZWIIJKZCWJIJKZLKZMKZNOZPZEHULDHULZVQWHWBVQAWEVO
      VNARGVPAUGUHVQWDBVQWDVQCVQCVNVOCFGVPCFUAUIUJUKUMUNVPVNBRGVOBUGUOUPUQURWCV
      OVPWFWFOZWBWTVNVOVPWBUSVNVOVPWBUTWCWFVAVQWBVCWSXAWBPWFAWKQKZOZVRWPMKZNOZP
      DEABHHWIAOZWMXCWRXEXFWLXBWFWIAWKQSVDXFWQXDNXFWNVRWPMWIAIJSVEVFVGWJBOZXCXA
      XEWBXGXBWFWFXGWKWEAQWJBWDLVHTVDXGXDWANXGWPVTVRMXGWOVSCLWJBIJSTTVFVGVLVIVQ
      WGWHWTPVMZWBVNVOXHVPDEWFCVJUJURVK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Pell equations 3: characterizing fundamental solution
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y z A $.  $d x y z B $.
    $( Any lower bound of a nonempty set of real numbers is less than or equal
       to its infimum, one-direction version.  (Contributed by Stefan O'Rear,
       1-Sep-2013.) $)
    infmrgelbi $p |- ( ( ( A C_ RR /\ A =/= (/) /\ B e. RR ) /\
                      A. x e. A B <_ x ) -> B <_ sup ( A , RR , `' < ) ) $=
      ( vz cr wss c0 wne wcel w3a cv cle wbr wral wa clt ccnv csup simpr wrex
      wb simpl1 simpl2 breq1 ralbidv rspcev 3ad2antl3 simpl3 infmrgelb syl31anc
      wceq mpbird ) BEFZBGHZCEIZJZCAKZLMZABNZOZCBEPQRLMZUSUPUSSUTUMUNDKZUQLMZAB
      NZDETZUOVAUSUAUMUNUOUSUBUMUNUOUSUCUOUMUSVEUNVDUSDCEVBCUKVCURABVBCUQLUDUEU
      FUGUMUNUOUSUHDAABCUIUJUL $.
  $}

  ${
    $d a b c d e f g A $.  $d a b c d e f g B $.  $d a b c d e f g C $.
    $d a b c d e f g D $.  $d a b c d e f g E $.  $d a b c d e f g F $.
    $d a b c d e f g u $.  $d a b c d e f g v $.  $d a b c d e f g w $.
    $d a b c d e f g x $.  $d a b c d e f g y $.  $d a b c d e f g z $.
    $d a b c d e f g ph $.

    $( the only place we directly use D's non-squareness $)
    ${
      $d D x $.
      $( There is a nontrivial solution of a Pell equation in the first
         quadrant.  (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
      pellqrex $p |- ( D e. ( NN \ []NN ) -> E. x e. ( Pell1QR ` D ) 1 < x ) $=
        ( vc vd va cn csquarenn wcel cv c2 cexp co c1 clt wbr wa cr 1re a1i cle
        cdif cmul cmin wceq wrex cpell1qr csqr cq wn eldifi eldifn anim1i fveq2
        cfv eleq1d df-squarenn elrab2 sylibr mtand pellex syl2anc simpll adantr
        caddc nnnn0 ad2antlr adantl simpr pellqrexplicit syl31anc readdcli nnre
        cn0 ad2antrl nnrpd rpsqrcld rpred ad2antll remulcld readdcld ltp1i nncn
        nnge1 1t1e1 sq1 sqsqrd 3brtr4d nnrp cc0 0le1 rpge0d le2sqd mpbird jctir
        syl lemul12a syl22anc mp2and syl5eqbrr le2addd ltletrd breq2 rexlimdvva
        wi rspcev ex mpd ) BFGUAHZCIZJKLBDIZJKLUBLUCLMUDZDFUECFUEZMAIZNOZABUFUN
        ZUEZXHBFHZBUGUNZUHHZUIXLBFGUJZXHXSBGHZBFGUKXHXSPXQXSPYAXHXQXSXTULEIZUGU
        NZUHHXSEBFGYBBUDYCXRUHYBBUGUMUOEUPUQURUSCDBUTVAXHXKXPCDFFXHXIFHZXJFHZPZ
        PZXKXPYGXKPZXIXRXJUBLZVDLZXOHZMYJNOZXPYHXHXIVMHZXJVMHZXKYKXHYFXKVBYFYMX
        HXKYDYMYEXIVEVCVFYFYNXHXKYEYNYDXJVEVGVFYGXKVHXIXJBVIVJYGYLXKYGMMMVDLZYJ
        MQHZYGRSZYOQHYGMMRRVKSYGXIYIYDXIQHXHYEXIVLVNZYGXRXJYGXRYGBYGBXHXQYFXTVC
        ZVOVPVQZYEXJQHZXHYDXJVLVRZVSZVTMYONOYGMRWASYGMMXIYIYQYQYRUUCYDMXITOXHYE
        XIWCVNYGMMMUBLZYITWDYGMXRTOZMXJTOZUUDYITOZYGXQUUEYSXQUUEMJKLZXRJKLZTOXQ
        MBUUHUUITBWCUUHMUDXQWESXQBBWBWFWGXQMXRYPXQRSXQXRXQBBWHVPZVQWIMTOZXQWJSX
        QXRUUJWKWLWMWOYEUUFXHYDXJWCVRYGYPUUKPZXRQHUULUUAUUEUUFPUUGXDYGYPUUKYQWJ
        WNZYTUUMUUBMXRMXJWPWQWRWSWTXAVCXNYLAYJXOXMYJMNXBXEVAXFXCXG $.
    $}

    ${
      $d D x $.
      $( Value of the fundamental solution of a Pell equation.  (Contributed by
         Stefan O'Rear, 18-Sep-2014.) $)
      pellfundval $p |- ( D e. ( NN \ []NN ) -> ( PellFund ` D ) = sup ( { x e.
          ( Pell14QR ` D ) | 1 < x } , RR , `' < ) ) $=
        ( va c1 cv clt wbr cpell14qr crab cr ccnv csup csquarenn cdif cpellfund
        cfv cn wceq fveq2 wor rabeq syl df-pellfund ltso cnvso mpbi supex fvmpt
        supeq1d ) CBDAEFGZACEZHPZIZJFKZLUJABHPZIZJUNLQMNOUKBRZJUMUPUNUQULUORUMU
        PRUKBHSUJAULUOUAUBUICAUCJUPUNJFTJUNTUDJFUEUFUGUH $.
    $}

    $( The fundamental solution of a Pell equation exists as a real number.
       (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pellfundre $p |- ( D e. ( NN \ []NN ) -> ( PellFund ` D ) e. RR ) $=
      ( va vb vc cn wcel cfv c1 cv clt wbr wss cle wral wrex pell14qrre sylancr
      cr 1re wa csquarenn cdif cpellfund cpell14qr crab ccnv pellfundval c0 wne
      csup ssrab2 ssrdv syl5ss cpell1qr pell1qrss14 pellqrex ssrexv sylc sylibr
      ex rabn0 breq2 elrab wi ltle expimpd syl5bi ralrimiv breq1 ralbidv rspcev
      wceq infmrcl syl3anc eqeltrd ) AEUAUBFZAUCGHBIZJKZBAUDGZUEZRJUFUJZRBAUGVP
      VTRLVTUHUIZCIZDIZMKZDVTNZCROZWARFVPVTVSRVRBVSUKVPBVSRVPVQVSFVQRFVQAPUTULU
      MVPVRBVSOZWBVPAUNGZVSLVRBWIOWHAUOBAUPVRBWIVSUQURVRBVSVAUSVPHRFZHWDMKZDVTN
      ZWGSVPWKDVTWDVTFWDVSFZHWDJKZTVPWKVRWNBWDVSVQWDHJVBVCVPWMWNWKVPWMTWJWDRFWN
      WKVDSWDAPHWDVEQVFVGVHWFWLCHRWCHVLWEWKDVTWCHWDMVIVJVKQCDVTVMVNVO $.

    $( Lower bound on the fundamental solution of a Pell equation.
       (Contributed by Stefan O'Rear, 19-Sep-2014.) $)
    pellfundge $p |- ( D e. ( NN \ []NN ) -> ( ( sqr ` ( D + 1 ) ) + ( sqr ` D
        ) ) <_ ( PellFund ` D ) ) $=
      ( va vb cn csquarenn wcel c1 caddc co csqr cfv cv clt wbr cr cle wss wrex
      nnrpd rpsqrcld cdif cpell14qr crab ccnv csup cpellfund c0 wne wral ssrab2
      pell14qrre ssrdv syl5ss cpell1qr pell1qrss14 pellqrex ssrexv rabn0 sylibr
      ex sylc eldifi peano2nnd rpred readdcld wa breq2 elrab pell14qrgap 3expib
      syl5bi ralrimiv infmrgelbi syl31anc pellfundval breqtrrd ) ADEUAFZAGHIZJK
      ZAJKZHIZGBLZMNZBAUBKZUCZOMUDUEZAUFKPVQWEOQWEUGUHZWAOFWACLZPNZCWEUIWAWFPNV
      QWEWDOWCBWDUJVQBWDOVQWBWDFWBOFWBAUKUTULUMVQWCBWDRZWGVQAUNKZWDQWCBWKRWJAUO
      BAUPWCBWKWDUQVAWCBWDURUSVQVSVTVQVSVQVRVQVRVQAADEVBZVCSTVDVQVTVQAVQAWLSTVD
      VEVQWICWEWHWEFWHWDFZGWHMNZVFVQWIWCWNBWHWDWBWHGMVGVHVQWMWNWIWHAVIVJVKVLCWE
      WAVMVNBAVOVP $.

    $( Weak lower bound on the Pell fundamental solution.  (Contributed by
       Stefan O'Rear, 19-Sep-2014.) $)
    pellfundgt1 $p |- ( D e. ( NN \ []NN ) -> 1 < ( PellFund ` D ) ) $=
      ( cn csquarenn wcel c1 caddc co csqr cfv cr nnrpd rpsqrcld rpred readdcld
      a1i sqr1 clt wbr c2 cle cdif cpellfund 1re eldifi peano2nnd syl5eqel 1lt2
      pellfundre oveq12i 1p1e2apr1 eqtri breqtrri nnge1d cc0 nnred peano2re syl
      0le1 nnnn0d nn0ge0d sqrled mpbid le2addd ltletrd pellfundge ) ABCUADZEAEF
      GZHIZAHIZFGZAUBIEJDVFUCOZVFVHVIVFVHVFVGVFVGVFAABCUDZUEZKLMZVFVIVFAVFAVLKL
      MZNZAUHVFEEHIZVQFGZVJVKVFVQVQVFVQEJPVKUFZVSNVPEVRQRVFESVRQUGVREEFGSVQEVQE
      FPPUIUJUKULOVFVQVQVHVIVSVSVNVOVFEVGTRVQVHTRVFVGVMUMVFEVGVKUNETRVFUROZVFAJ
      DVGJDVFAVLUOZAUPUQVFVGVFVGVMUSUTVAVBVFEATRVQVITRVFAVLUMVFEAVKVTWAVFAVFAVL
      USUTVAVBVCVDAVEVD $.

    $( A nontrivial first quadrant solution is at least as large as the
       fundamental solution.  (Contributed by Stefan O'Rear, 19-Sep-2014.) $)
    pellfundlb $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ 1 < A )
        -> ( PellFund ` D ) <_ A ) $=
      ( va vb vc vd wcel cfv c1 clt wbr cv cr cle wceq 3ad2ant1 wral pell14qrre
      1re wa csquarenn cdif cpell14qr cpellfund crab ccnv csup pellfundval wrex
      cn w3a wss ssrab2 ex ssrdv syl5ss breq2 elrab ltle sylancr expimpd syl5bi
      wi ralrimiv breq1 ralbidv rspcev simp2 sylanbrc infmrlb syl3anc eqbrtrd
      simp3 ) BUJUAUBGZABUCHZGZIAJKZUKZBUDHZICLZJKZCVOUEZMJUFUGZANVNVPVSWCOVQCB
      UHPVRWBMULZDLZELZNKZEWBQZDMUIZAWBGZWCANKVNVPWDVQVNWBVOMWACVOUMVNFVOMVNFLZ
      VOGWKMGWKBRUNUOUPPVRIMGZIWFNKZEWBQZWISVNVPWNVQVNWMEWBWFWBGWFVOGZIWFJKZTVN
      WMWAWPCWFVOVTWFIJUQURVNWOWPWMVNWOTWLWFMGWPWMVCSWFBRIWFUSUTVAVBVDPWHWNDIMW
      EIOWGWMEWBWEIWFNVEVFVGUTVRVPVQWJVNVPVQVHVNVPVQVMWAVQCAVOVTAIJUQURVIDEAWBV
      JVKVL $.

    ${
      $d x D $.  $d x A $.
      $( If a real is larger than the fundamental solution, there is a
         nontrivial solution less than it.  (Contributed by Stefan O'Rear,
         18-Sep-2014.) $)
      pellfundglb $p |- ( ( D e. ( NN \ []NN ) /\ A e. RR
            /\ ( PellFund ` D ) < A )
          -> E. x e. ( Pell1QR ` D ) ( ( PellFund ` D ) <_ x /\ x < A ) ) $=
        ( va wcel cr cfv clt wbr w3a cv cle wn c1 wrex wa 3ad2ant1 wss ex jca
        cn csquarenn cdif cpellfund cpell14qr crab cpell1qr wral ccnv csup wceq
        pellfundval simp3 eqbrtrrd pellfundre eqeltrrd simp2 ltnled mpbid c0 wi
        ssrab2 pell14qrre ssrdv syl5ss pell1qrss14 pellqrex ssrexv rabn0 sylibr
        wne sylc infmrgelbi syl3anc mtod rexnal breq2 simprl 1re simpl1 syl2anc
        elrab a1i simprr wb elpell1qr2 syl mpbird sylan2b adantrr sseldi syl5bi
        ltled simpr imp pellfundlb adantr sseldd simpl2 reximdv2 mpd ) CUAUBUCE
        ZBFEZCUDGZBHIZJZBAKZLIZMZANDKZHIZDCUEGZUFZOZXDXGLIZXGBHIZPZACUGGZOXFXHA
        XMUHZMXNXFXSBXMFHUIUJZLIZXFXTBHIYAMXFXDXTBHXBXCXDXTUKXEDCULQZXBXCXEUMUN
        XFXTBXFXDXTFYBXBXCXDFEXECUOQUPXBXCXEUQZURUSXFXMFRZXMUTVKZXCXSYAVAXFXMXL
        FXKDXLVBZXBXCXLFRZXEXBDXLFXBXJXLEXJFEXJCVCSVDQZVEXFXKDXLOZYEXFXRXLRZXKD
        XROZYIXBXCYJXECVFQXBXCYKXEDCVGQXKDXRXLVHVLXKDXLVIVJYCYDYEXCJXSYAAXMBVMS
        VNVOXHAXMVPVJXFXIXQAXMXRXFXGXMEZXIPZXGXREZXQPXFYMPZYNXQXFYLYNXIYLXFXGXL
        EZNXGHIZPZYNXKYQDXGXLXJXGNHVQWBZXFYRPZYNYPNXGLIZPZYTYPUUAXFYPYQVRZYTNXG
        NFEYTVSWCYTXBYPXGFEXBXCXEYRVTZUUCXGCVCWAXFYPYQWDWMTYTXBYNUUBWEUUDXGCWFW
        GWHWIWJYOXOXPYOXBYPYQXOXBXCXEYMVTYOXMXLXGYFXFYLXIVRWKZXFYLYQXIXFYLYQYLY
        RXFYQYSYRYQVAXFYPYQWNWCWLWOWJXGCWPVNYOXPXIXFYLXIWDYOXGBYOXLFXGXFYGYMYHW
        QUUEWRXBXCXEYMWSURWHTTSWTXA $.
    $}

    $( The fundamental solution as an infimum is itself a solution, showing
       that the solution set is discrete.

       Since the fundamental solution is an infimum, there must be an element
       ge to Fund and lt 2*Fund.  If this element is equal to the fundamental
       solution we're done, otherwise use the infimum again to find another
       element which must be ge Fund and lt the first element; their ratio is a
       group element in (1,2), contradicting ~ pell14qrgapw .  (Contributed by
       Stefan O'Rear, 18-Sep-2014.) $)
    pellfundex $p |- ( D e. ( NN \ []NN ) -> ( PellFund ` D ) e. ( Pell1QR ` D
        ) ) $=
      ( va vb wcel cfv cle wbr c2 cmul co clt wa cr 2re cc0 c1 adantr ad3antrrr
      a1i syl2anc cn csquarenn cpellfund cv cpell1qr pellfundre remulcl sylancr
      cdif wrex caddc 0re 1re pellfundgt1 lttrd elrpd ltaddrpd 2timesd breqtrrd
      0lt1 pellfundglb mpd3an23 wceq wo cpell14qr pell1qrss14 sselda pell14qrre
      recnd wi syldan leloed simpll simprl syl3anc simp-4l simplr simprr sseldd
      simp-4r wss ad2antrr wb 2pos lemul2 syl112anc mpbid ltletrd cdiv 3ad2ant1
      w3a simp1 simp2l simp2r pell14qrdivcl mulid2d simp3l pell14qrgt0 ltmuldiv
      eqbrtrd simp3r ltdivmul2 mpbird pell14qrgapw ltnsym mpd pm2.21dd syl22anc
      wn syl122anc rexlimdva exp32 simp2 simp1r eqeltrd 3exp jaod sylbid imp3a
      ex ) AUAUBUIDZAUCEZBUDZFGZYCHYBIJZKGZLZBAUEEZUJZYBYHDZYAYEMDZYBYEKGYIYAHM
      DZYBMDZYKNAUFZHYBUGUHZYAYBYBYBUKJYEKYAYBYBYNYAYBYNYAOPYBOMDYAULSPMDZYAUMS
      YNOPKGYAUTSAUNUOUPUQYAYBYAYBYNVIURUSBYEAVAVBYAYGYJBYHYAYCYHDZLZYDYFYJYRYD
      YBYCKGZYBYCVCZVDYFYJVJZYRYBYCYAYMYQYNQZYAYQYCAVEEZDZYCMDZYAYHUUCYCAVFZVGY
      CAVHZVKZVLYRYSUUAYTYRYSYFYJYRYSYFLZLZYBCUDZFGZUUKYCKGZLZCYHUJZYJUUJYAUUEY
      SUUOYAYQUUIVMYRUUEUUIUUHQYRYSYFVNCYCAVAVOUUJUUNYJCYHUUJUUKYHDZLZUUNYJUUQU
      UNLZYAYQUUPUUMYCHUUKIJZKGZYJYAYQUUIUUPUUNVPZYAYQUUIUUPUUNVTUUJUUPUUNVQZUU
      QUULUUMVRUURYCYEUUSYRUUEUUIUUPUUNUUHRYRYKUUIUUPUUNYAYKYQYOQRUURYLUUKMDZUU
      SMDNUURYAUUKUUCDZUVCUVAUURYHUUCUUKYRYHUUCWAZUUIUUPUUNYAUVEYQUUFQRUVBVSUUK
      AVHZTZHUUKUGUHUUJYFUUPUUNYRYSYFVRWBUURUULYEUUSFGZUUQUULUUMVNUURYMUVCYLOHK
      GZUULUVHWCYRYMUUIUUPUUNUUBRUVGYLUURNSUVIUURWDSYBUUKHWEWFWGWHYAYQUUPLZUUMU
      UTLZWKZYAYCUUKWIJZUUCDZPUVMKGZUVMHKGZYJYAUVJUVKWLZUVLYAUUDUVDUVNUVQUVLYHU
      UCYCYAUVJUVEUVKUUFWJZYAYQUUPUVKWMVSZUVLYHUUCUUKUVRYAYQUUPUVKWNVSZYCUUKAWO
      VOUVLPUUKIJZYCKGZUVOUVLUWAUUKYCKUVLUUKUVLUUKUVLYAUVDUVCUVQUVTUVFTZVIWPYAU
      VJUUMUUTWQWTUVLYPUUEUVCOUUKKGZUWBUVOWCYPUVLUMSUVLYAUUDUUEUVQUVSUUGTZUWCUV
      LYAUVDUWDUVQUVTUUKAWRTZPYCUUKWSWFWGUVLUVPUUTYAUVJUUMUUTXAUVLUUEYLUVCUWDUV
      PUUTWCUWEYLUVLNSUWCUWFYCHUUKXBWFXCYAUVNLZUVOUVPLZLZUVPYJUWGUVOUVPVRUWIHUV
      MKGZUVPXIZUWIYAUVNUVOUWJYAUVNUWHVMYAUVNUWHVQUWGUVOUVPVNUVMAXDVOUWIYLUVMMD
      ZUWJUWKVJNUWGUWLUWHUVMAVHQHUVMXEUHXFXGXHXJXTXKXFXLYRYTYFYJYRYTYFWKYBYCYHY
      RYTYFXMYAYQYTYFXNXOXPXQXRXSXKXF $.

    $( There are no solutions between 1 and the fundamental solution.
       (Contributed by Stefan O'Rear, 18-Sep-2014.) $)
    pellfund14gap $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) /\ ( 1
        <_ A /\ A < ( PellFund ` D ) ) ) -> A = 1 ) $=
      ( cn csquarenn cdif wcel cpell14qr cfv c1 cle wbr cpellfund clt wa w3a wn
      wceq wo cr mpbid simp3r pell14qrre 3adant3 pellfundre ltnled simpl1 simpr
      3ad2ant1 simpl2 pellfundlb syl3anc mtand simp3l wb 1re leloe sylancr sylc
      orel1 eqcomd ) BCDEFZABGHFZIAJKZABLHZMKZNZOZIAVGIAMKZPVHIAQZRZVIVGVHVDAJK
      ZVGVEVKPVAVBVCVEUAVGAVDVAVBASFZVFABUBUCZVAVBVDSFVFBUDUHUETVGVHNVAVBVHVKVA
      VBVFVHUFVAVBVFVHUIVGVHUGABUJUKULVGVCVJVAVBVCVEUMVGISFVLVCVJUNUOVMIAUPUQTV
      HVIUSURUT $.

    $( The fundamental Pell solution is a positive real.  (Contributed by
       Stefan O'Rear, 19-Sep-2014.) $)
    pellfundrp $p |- ( D e. ( NN \ []NN ) -> ( PellFund ` D ) e. RR+ ) $=
      ( cn csquarenn cdif wcel cpellfund cfv pellfundre cc0 0re a1i 1re clt wbr
      c1 cr 0lt1 pellfundgt1 lttrd elrpd ) ABCDEZAFGZAHZUAIOUBIPEUAJKOPEUALKUCI
      OMNUAQKARST $.

    $( The fundamental Pell solution is never 1.  (Contributed by Stefan
       O'Rear, 19-Sep-2014.) $)
    pellfundne1 $p |- ( D e. ( NN \ []NN ) -> ( PellFund ` D ) =/= 1 ) $=
      ( cn csquarenn cdif wcel c1 cpellfund cfv cr 1re a1i pellfundgt1 gtned )
      ABCDEZFAGHFIENJKALM $.

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Logarithm laws generalized to an arbitrary base
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d e f g A $.  $d a b c d e f g B $.  $d a b c d e f g C $.
    $d a b c d e f g D $.  $d a b c d e f g E $.  $d a b c d e f g F $.
    $d a b c d e f g u $.  $d a b c d e f g v $.  $d a b c d e f g w $.
    $d a b c d e f g x $.  $d a b c d e f g y $.  $d a b c d e f g z $.
    $d a b c d e f g ph $.

    $( General logarithm is a real number.  (Contributed by Stefan O'Rear,
       19-Sep-2014.) $)
    reglogcl $p |- ( ( A e. RR+ /\ B e. RR+ /\ B =/= 1 ) -> ( ( log ` A ) / (
        log ` B ) ) e. RR ) $=
      ( crp wcel c1 wne w3a cfv cr relogcl 3ad2ant1 3ad2ant2 cc0 logne0 3adant1
      clog redivcld ) ACDZBCDZBEFZGAPHZBPHZRSUAIDTAJKSRUBIDTBJLSTUBMFRBNOQ $.

    $( General logarithm preserves "less than".  (Contributed by Stefan O'Rear,
       19-Sep-2014.) $)
    reglogltb $p |- ( ( ( A e. RR+ /\ B e. RR+ ) /\ ( C e. RR+ /\ 1 < C ) ) ->
        ( A < B <-> ( ( log ` A ) / ( log ` C ) ) < ( ( log ` B ) / ( log ` C )
        ) ) ) $=
      ( crp wcel wa c1 clt wbr clog cfv cdiv co wb logltb adantr cr cc0 relogcl
      ad2antrr ad2antlr ad2antrl log1 mpan biimpa syl5eqbrr adantl ltdiv1 bitrd
      1rp syl112anc ) ADEZBDEZFZCDEZGCHIZFZFZABHIZAJKZBJKZHIZUTCJKZLMVAVCLMHIZU
      NUSVBNUQABOPURUTQEZVAQEZVCQEZRVCHIZVBVDNULVEUMUQASTUMVFULUQBSUAUOVGUNUPCS
      UBUQVHUNUQRGJKZVCHUCUOUPVIVCHIZGDEUOUPVJNUJGCOUDUEUFUGUTVAVCUHUKUI $.

    $( General logarithm preserves ` <_ ` .  (Contributed by Stefan O'Rear,
       19-Oct-2014.) $)
    reglogleb $p |- ( ( ( A e. RR+ /\ B e. RR+ ) /\ ( C e. RR+ /\ 1 < C ) ) ->
        ( A <_ B <-> ( ( log ` A ) / ( log ` C ) ) <_ ( ( log ` B ) / ( log ` C
        ) ) ) ) $=
      ( crp wcel wa c1 clt wbr cle clog cfv cdiv co wb logleb adantr cr relogcl
      cc0 ad2antrr ad2antlr ad2antrl log1 logltb biimpa syl5eqbrr adantl lediv1
      1rp mpan syl112anc bitrd ) ADEZBDEZFZCDEZGCHIZFZFZABJIZAKLZBKLZJIZVBCKLZM
      NVCVEMNJIZUPVAVDOUSABPQUTVBREZVCREZVEREZTVEHIZVDVFOUNVGUOUSASUAUOVHUNUSBS
      UBUQVIUPURCSUCUSVJUPUSTGKLZVEHUDUQURVKVEHIZGDEUQURVLOUJGCUEUKUFUGUHVBVCVE
      UIULUM $.

    $( Multiplication law for general log.  (Contributed by Stefan O'Rear,
       19-Sep-2014.) $)
    reglogmul $p |- ( ( A e. RR+ /\ B e. RR+ /\ ( C e. RR+ /\ C =/= 1 ) ) -> (
        ( log ` ( A x. B ) ) / ( log ` C ) ) = ( ( ( log ` A ) / ( log ` C ) )
        + ( ( log ` B ) / ( log ` C ) ) ) ) $=
      ( crp wcel c1 wne wa w3a cmul co clog cdiv caddc wceq cc relogcl 3ad2ant3
      cfv recnd relogmul 3adant3 oveq1d 3ad2ant1 3ad2ant2 adantr logne0 divdird
      cc0 eqtrd ) ADEZBDEZCDEZCFGZHZIZABJKLSZCLSZMKALSZBLSZNKZURMKUSURMKUTURMKN
      KUPUQVAURMUKULUQVAOUOABUAUBUCUPUSUTURUKULUSPEUOUKUSAQTUDULUKUTPEUOULUTBQT
      UEUOUKURPEZULUMVBUNUMURCQTUFRUOUKURUIGULCUGRUHUJ $.

    $( Power law for general log.  (Contributed by Stefan O'Rear,
       19-Sep-2014.) $)
    reglogexp $p |- ( ( A e. RR+ /\ N e. ZZ /\ ( C e. RR+ /\ C =/= 1 ) ) -> ( (
        log ` ( A ^ N ) ) / ( log ` C ) ) = ( N x. ( ( log ` A ) / ( log ` C )
        ) ) ) $=
      ( crp wcel cz c1 wne wa w3a cexp co clog cdiv cmul relogcl recnd 3ad2ant3
      cfv cc wceq relogexp 3adant3 oveq1d 3ad2ant2 3ad2ant1 adantr logne0 eqtrd
      zcn cc0 divassd ) ADEZCFEZBDEZBGHZIZJZACKLMSZBMSZNLCAMSZOLZUTNLCVAUTNLOLU
      RUSVBUTNUMUNUSVBUAUQACUBUCUDURCVAUTUNUMCTEUQCUJUEUMUNVATEUQUMVAAPQUFUQUMU
      TTEZUNUOVCUPUOUTBPQUGRUQUMUTUKHUNBUHRULUI $.

    $( General log of the base is 1.  (Contributed by Stefan O'Rear,
       19-Sep-2014.) $)
    reglogbas $p |- ( ( C e. RR+ /\ C =/= 1 ) -> ( ( log ` C ) / ( log ` C ) )
        = 1 ) $=
      ( crp wcel c1 wne wa clog cfv cc relogcl recnd adantr logne0 dividd ) ABC
      ZADEZFAGHZOQICPOQAJKLAMN $.

    $( General log of 1 is 0.  (Contributed by Stefan O'Rear, 19-Sep-2014.) $)
    reglog1 $p |- ( ( C e. RR+ /\ C =/= 1 ) -> ( ( log ` 1 ) / ( log ` C ) ) =
        0 ) $=
      ( crp wcel c1 wne wa clog cfv cdiv co log1 oveq1i cc relogcl recnd adantr
      cc0 logne0 div0d syl5eq ) ABCZADEZFZDGHZAGHZIJQUEIJQUDQUEIKLUCUEUAUEMCUBU
      AUEANOPARST $.

    $( General log of a power of the base is the exponent.  (Contributed by
       Stefan O'Rear, 19-Sep-2014.) $)
    reglogexpbas $p |- ( ( N e. ZZ /\ ( C e. RR+ /\ C =/= 1 ) ) -> ( ( log ` (
        C ^ N ) ) / ( log ` C ) ) = N ) $=
      ( cz wcel crp c1 wne wa cexp co clog cfv cdiv cmul simprl simpl reglogexp
      wceq simpr syl3anc reglogbas adantl oveq2d cc zcn adantr mulid1d 3eqtrd )
      BCDZAEDZAFGZHZHZABIJKLAKLZMJZBUNUNMJZNJZBFNJBUMUJUIULUOUQRUIUJUKOUIULPUIU
      LSAABQTUMUPFBNULUPFRUIAUAUBUCUMBUIBUDDULBUEUFUGUH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Pell equations 4: the positive solution group is infinite cyclic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d e f g A $.  $d a b c d e f g B $.  $d a b c d e f g C $.
    $d a b c d e f g D $.  $d a b c d e f g E $.  $d a b c d e f g F $.
    $d a b c d e f g u $.  $d a b c d e f g v $.  $d a b c d e f g w $.
    $d a b c d e f g x $.  $d a b c d e f g y $.  $d a b c d e f g z $.
    $d a b c d e f g ph $.
    ${
      $d x D $.  $d x A $.
      $( Every positive Pell solution is a power of the fundamental solution.
         (Contributed by Stefan O'Rear, 19-Sep-2014.) $)
      pellfund14 $p |- ( ( D e. ( NN \ []NN ) /\ A e. ( Pell14QR ` D ) ) -> E.
          x e. ZZ A = ( ( PellFund ` D ) ^ x ) ) $=
        ( wcel cfv clog cdiv co cz cexp wceq crp adantr cle wbr clt cc0 syl2anc
        c1 caddc cn csquarenn cdif cpell14qr wa cpellfund cfl cv wne pell14qrrp
        wrex cr pellfundrp pellfundne1 reglogcl flcld pell14qrre recnd rpexpcld
        syl3anc cneg rpcnd znegcld rpne0d simpl cpell1qr pell1qrss14 pellfundex
        cmul sseldd pell14qrexpcl pell14qrmulcl mpd3an3 cmo 1rp a1i modge0 cmin
        zcnd negsubd modfrac syl eqtr4d breqtrrd reglog1 reglogmul reglogexpbas
        syl112anc syl12anc oveq2d eqtrd rpmulcld pellfundgt1 reglogleb syl22anc
        3brtr4d mpbird eqbrtrd reglogbas reglogltb pellfund14gap negidd expaddz
        wb modlt cc exp0d 3eqtr3rd mulcan2ad oveq2 eqeq2d rspcev ) CUAUBUCDZBCU
        DEZDZUEZBFECUFEZFEZGHZUGEZIDZBXQXTJHZKZBXQAUHZJHZKZAIUKXPXSXPBLDZXQLDZX
        QSUIZXSULDZBCUJZXMYHXOCUMMZXMYIXOCUNMZBXQUOUTZUPZXPBYBXQXTVAZJHZXPBBCUQ
        URXPYBXPXQXTYLYOUSVBXPYQXPXQYPYLXPXTYOVCZUSZVBXPYQYSVDXPBYQVIHZSYBYQVIH
        ZXPXMYTXNDZSYTNOZYTXQPOZYTSKXMXOVEZXMXOYQXNDZUUBXPXMXQXNDZYPIDZUUFUUEXM
        UUGXOXMCVFEXNXQCVGCVHVJMYRXQYPCVKUTBYQCVLVMXPUUCSFEXRGHZYTFEXRGHZNOZXPQ
        XSYPTHZUUIUUJNXPQXSSVNHZUULNXPYJSLDZQUUMNOYNUUNXPVOVPZXSSVQRXPUULXSXTVR
        HZUUMXPXSXTXPXSYNURXPXTYOVSZVTXPYJUUMUUPKYNXSWAWBWCZWDXPYHYIUUIQKYLYMXQ
        WERXPUUJXSYQFEXRGHZTHZUULXPYGYQLDYHYIUUJUUTKYKYSYLYMBYQXQWFWHXPUUSYPXST
        XPUUHYHYIUUSYPKYRYLYMXQYPWGWIWJWKZWPXPUUNYTLDZYHSXQPOZUUCUUKXDUUOXPBYQY
        KYSWLZYLXMUVCXOCWMMZSYTXQWNWOWQXPUUDUUJXRXRGHZPOZXPUULSUUJUVFPXPUULUUMS
        PUURXPYJUUNUUMSPOYNUUOXSSXERWRUVAXPYHYIUVFSKYLYMXQWSRWPXPUVBYHYHUVCUUDU
        VGXDUVDYLYLUVEYTXQXQWTWOWQYTCXAWHXPXQXTYPTHZJHZXQQJHUUASXPUVHQXQJXPXTUU
        QXBWJXPXQXFDXQQUIYAUUHUVIUUAKXPXQYLVBZXPXQYLVDYOYRXQXTYPXCWOXPXQUVJXGXH
        WKXIYFYCAXTIYDXTKYEYBBYDXTXQJXJXKXLR $.

      $( The positive Pell solutions are precisely the integer powers of the
         fundamental solution.  To get the general solution set (which we will
         not be using), throw in a copy of Z/2Z. (Contributed by Stefan O'Rear,
         19-Sep-2014.) $)
      pellfund14b $p |- ( D e. ( NN \ []NN ) -> ( A e. ( Pell14QR ` D ) <-> E.
          x e. ZZ A = ( ( PellFund ` D ) ^ x ) ) ) $=
        ( cn csquarenn cdif wcel cpell14qr cpellfund cv cexp co wceq pellfund14
        cfv cz wrex wa simpll cpell1qr pellfundex sseldd ad2antrr pell14qrexpcl
        pell1qrss14 simplr syl3anc wb eleq1 adantl mpbird rexlimdva imp impbida
        ex ) CDEFGZBCHOZGZBCIOZAJZKLZMZAPQZABCNUPVCURUPVBURAPUPUTPGZRZVBURVEVBR
        ZURVAUQGZVFUPUSUQGZVDVGUPVDVBSUPVHVDVBUPCTOUQUSCUECUAUBUCUPVDVBUFUSUTCU
        DUGVBURVGUHVEBVAUQUIUJUKUOULUMUN $.
    $}

  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    X and Y sequences 1: Definition and recurrence laws
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c rmX rmY $.

  $( Extend class notation to include the Robertson-Matiyasevich X sequence. $)
  crmx $a class rmX $.
  $( Extend class notation to include the Robertson-Matiyasevich Y sequence. $)
  crmy $a class rmY $.

  ${
    $d a n b c $.
    $( Define the X sequence as the rational part of some solution of a special
       Pell equation.  See ~ frmx and ~ rmxyval for a more useful but
       non-eliminable definition.  (Contributed by Stefan O'Rear,
       21-Sep-2014.) $)
    df-rmx $a |- rmX = ( a e. ( ZZ>= ` 2 ) , n e. ZZ |-> ( 1st ` ( `' ( b e. (
        NN0 X. ZZ ) |-> ( ( 1st ` b ) + ( ( sqr ` ( ( a ^ 2 ) - 1 ) ) x. ( 2nd
        ` b ) ) ) ) ` ( ( a + ( sqr ` ( ( a ^ 2 ) - 1 ) ) ) ^ n ) ) ) ) $.
    $( Define the X sequence as the irrational part of some solution of a
       special Pell equation.  See ~ frmy and ~ rmxyval for a more useful but
       non-eliminable definition.  (Contributed by Stefan O'Rear,
       21-Sep-2014.) $)
    df-rmy $a |- rmY = ( a e. ( ZZ>= ` 2 ) , n e. ZZ |-> ( 2nd ` ( `' ( b e. (
        NN0 X. ZZ ) |-> ( ( 1st ` b ) + ( ( sqr ` ( ( a ^ 2 ) - 1 ) ) x. ( 2nd
        ` b ) ) ) ) ` ( ( a + ( sqr ` ( ( a ^ 2 ) - 1 ) ) ) ^ n ) ) ) ) $.
  $}

  ${
    $d a n b A $.  $d a n b N $.
    $( Value of the X sequence.  Not used after ~ rmxyval is proved.
       (Contributed by Stefan O'Rear, 21-Sep-2014.) $)
    rmxfval $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmX N ) = ( 1st ` (
        `' ( b e. ( NN0 X. ZZ ) |-> ( ( 1st ` b ) + ( ( sqr ` ( ( A ^ 2 ) - 1 )
        ) x. ( 2nd ` b ) ) ) ) ` ( ( A + ( sqr ` ( ( A ^ 2 ) - 1 ) ) ) ^ N ) )
        ) ) $=
      ( va vn c2 cfv cz cv cexp co c1 cmin csqr caddc c1st cmul cmpt ccnv wceq
      cuz cn0 c2nd crmx wa oveq1 oveq1d fveq2d oveq2d mpteq2dv cnveqd adantr id
      cxp oveq12d oveqan12d fveq12d df-rmx fvex ovmpt2a ) DEABFUAGHDIZVAFJKZLMK
      ZNGZOKZEIZJKZCUBHUNZCIZPGZVDVIUCGZQKZOKZRZSZGZPGAAFJKZLMKZNGZOKZBJKZCVHVJ
      VSVKQKZOKZRZSZGZPGUDVAATZVFBTZUEZVPWFPWIVGWAVOWEWGVOWETWHWGVNWDWGCVHVMWCW
      GVLWBVJOWGVDVSVKQWGVCVRNWGVBVQLMVAAFJUFUGUHZUGUIUJUKULWGWHVEVTVFBJWGVAAVD
      VSOWGUMWJUOWHUMUPUQUHEDCURWFPUSUT $.

    $( Value of the Y sequence.  Not used after ~ rmxyval is proved.
       (Contributed by Stefan O'Rear, 21-Sep-2014.) $)
    rmyfval $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmY N ) = ( 2nd ` (
        `' ( b e. ( NN0 X. ZZ ) |-> ( ( 1st ` b ) + ( ( sqr ` ( ( A ^ 2 ) - 1 )
        ) x. ( 2nd ` b ) ) ) ) ` ( ( A + ( sqr ` ( ( A ^ 2 ) - 1 ) ) ) ^ N ) )
        ) ) $=
      ( va vn c2 cfv cz cv cexp co c1 cmin csqr caddc c2nd cmul cmpt ccnv wceq
      cuz cn0 c1st crmy wa oveq1 oveq1d fveq2d oveq2d mpteq2dv cnveqd adantr id
      cxp oveq12d oveqan12d fveq12d df-rmy fvex ovmpt2a ) DEABFUAGHDIZVAFJKZLMK
      ZNGZOKZEIZJKZCUBHUNZCIZUCGZVDVIPGZQKZOKZRZSZGZPGAAFJKZLMKZNGZOKZBJKZCVHVJ
      VSVKQKZOKZRZSZGZPGUDVAATZVFBTZUEZVPWFPWIVGWAVOWEWGVOWETWHWGVNWDWGCVHVMWCW
      GVLWBVJOWGVDVSVKQWGVCVRNWGVBVQLMVAAFJUFUGUHZUGUIUJUKULWGWHVEVTVFBJWGVAAVD
      VSOWGUMWJUOWHUMUPUQUHEDCURWFPUSUT $.
  $}

  $( The discriminant used to define the X and Y sequences has an irrational
     square root.  (Contributed by Stefan O'Rear, 21-Sep-2014.) $)
  rmspecsqrnq $p |- ( A e. ( ZZ>= ` 2 ) -> ( sqr ` ( ( A ^ 2 ) - 1 ) ) e. ( CC
      \ QQ ) ) $=
    ( c2 wcel cexp co c1 cmin cc ax-1cn sylancl clt wbr caddc cmul wceq 2re 1re
    cr remulcl a1i cuz cfv csqr cq eluzelz zcnd sqcld subcl sqrcld cn0 wn cn wa
    eluz2b2 biimpi nnsqcld nnm1nn0 syl eluzelre recnd binom2sub sylancr resqcli
    simpld recni subsubd eqtr4d resubcl nnred 2timesi simprd cc0 wb 2pos ltmul2
    syl112anc mpbid syl5eqbrr ltaddsubd mulid1d oveq2d oveq12d breqtrrd eqbrtrd
    sq1 ltsub2dd ltm1d npcan oveq1d nonsq syl22anc eldifd ) ABUAUBCZABDEZFGEZUC
    UBZHUDWMWOWMWNHCFHCZWOHCWMAWMABAUEUFUGZIWNFUHJUIWMWOUJCZAFGEZUJCZWTBDEZWOKL
    WOWTFMEZBDEZKLWPUDCUKWMWNULCWSWMAWMAULCZFAKLZWMXEXFUMAUNUOZVDZUPZWNUQURWMXE
    XAXHAUQURWMXBWNBAFNEZNEZFBDEZGEZGEZWOKWMXBWNXKGEXLMEZXNWMAHCZWQXBXOOWMABAUS
    ZUTZIAFVAJWMWNXKXLWRWMXKWMBRCZXJRCZXKRCZPWMARCZFRCZXTXQQAFSJBXJSVBZUTXLHCWM
    XLFQVCZVETVFVGWMFXMWNYCWMQTZWMYAXLRCXMRCYDYEXKXLVHJWMWNXIVIZWMFBANEZFGEZXMK
    WMFFMEZYHKLFYIKLWMYJBFNEZYHKFIVJWMXFYKYHKLZWMXEXFXGVKWMYCYBXSVLBKLZXFYLVMYF
    XQXSWMPTYMWMVNTFABVOVPVQVRWMFFYHYFYFWMXSYBYHRCPXQBASVBVSVQWMXKYHXLFGWMXJABN
    WMAXRVTWAXLFOWMWETWBWCWFWDWMWOWNXDKWMWNYGWGWMXCABDWMXPWQXCAOXRIAFWHJWIWCWOW
    TWJWKWL $.

  ${
    $d a A $.
    $( The discriminant used to define the X and Y sequences is a nonsquare
       positive integer and thus a valid Pell equation discriminant.
       (Contributed by Stefan O'Rear, 21-Sep-2014.) $)
    rmspecnonsq $p |- ( A e. ( ZZ>= ` 2 ) -> ( ( A ^ 2 ) - 1 ) e. ( NN \ []NN )
        ) $=
      ( va c2 cuz cfv wcel cexp co c1 cn csquarenn cz cc0 clt wbr a1i cn0 mpbid
      csqr cq cmin eluzelz zsqcl syl 1z zsubcld sq1 eluz2b2 simprbi cr eluzelre
      1re 0le1 2nn0 eluznn0 mpan nn0ge0d lt2sqd syl5eqbrr resqcld posdifd elnnz
      cle sylanbrc wa cc rmspecsqrnq eldifbd intnand cv crab df-squarenn eleq2i
      wceq fveq2 eleq1d elrab bitr2i sylnib eldifd ) ACDEFZACGHZIUAHZJKWAWCLFMW
      CNOZWCJFZWAWBIWAALFWBLFCAUBAUCUDILFWAUEPUFWAIWBNOWDWAIICGHZWBNUGWAIANOZWF
      WBNOWAAJFWGAUHUIWAIAIUJFWAULPZCAUKZMIVCOWAUMPWAACQFWAAQFUNACUOUPUQURRUSWA
      IWBWHWAAWIUTVARWCVBVDWAWEWCSEZTFZVEZWCKFZWAWKWEWAWJVFTAVGVHVIWMWCBVJZSEZT
      FZBJVKZFWLKWQWCBVLVMWPWKBWCJWNWCVNWOWJTWNWCSVOVPVQVRVSVT $.
  $}

  $( This lemma implements the concept of "equate rational and irrational
     parts", used to prove many arithmetical properties of the X and Y
     sequences.  (Contributed by Stefan O'Rear, 21-Sep-2014.) $)
  qirropth $p |- ( ( A e. ( CC \ QQ ) /\ ( B e. QQ /\ C e. QQ ) /\ ( D e. QQ /\
      E e. QQ ) ) -> ( ( B + ( A x. C ) ) = ( D + ( A x. E ) ) <-> ( B = D /\ C
      = E ) ) ) $=
    ( cc cq wcel wa cmul caddc wceq adantr cmin ad2antrr qcn syl syl2anc mulcld
    co cdif wn eldifn 3ad2ant1 cdiv simpll1 eldifad simp2r simp3r subdid qsubcl
    w3a mulcomd simplr simp2l simp3l addsubeq4d mpbid 3eqtr4d cc0 wne wb subeq0
    simpr necon3abid mpbird divmuld qdivcl syl3anc eqeltrrd mt3d simpl2l simpl1
    simpl3l simpl3r eqcomd oveq2d eqtrd addcan2ad jcai ancomd oveqan12d impbid1
    ex id oveq2 ) AFGUAHZBGHZCGHZIZDGHZEGHZIZULZBACJTZKTZDAEJTZKTZLZBDLZCELZIZW
    NWSXBWNWSIZXAWTXCXAWTXCXAAGHZWNXDUBZWSWGWJXEWMAFGUCUDMXCXAUBZXDXCXFIZDBNTZC
    ENTZUETZAGXGXJALXIAJTZXHLXGAXIJTWOWQNTZXKXHXGACEXGAFGWGWJWMWSXFUFUGZXGWICFH
    ZWNWIWSXFWGWHWIWMUHOZCPQZXGWLEFHZWNWLWSXFWGWJWKWLUIOZEPZQZUJXGXIAXGXIGHZXIF
    HXGWIWLYAXOXRCEUKRZXIPQZXMUMXGWSXHXLLWNWSXFUNXGBWODWQXGWHBFHZWNWHWSXFWGWHWI
    WMUOOZBPZQXGACXMXPSXGWKDFHZWNWKWSXFWGWJWKWLUPOZDPZQXGAEXMXTSUQURUSXGXHXIAXG
    XHGHZXHFHXGWKWHYJYHYEDBUKRZXHPQYCXMXGXIUTVAZXFXCXFVDXGXNXQYLXFVBXPXTXNXQIXA
    XIUTCEVCVERVFZVGVFXGYJYAYLXJGHYKYBYMXHXIVHVIVJWDVKXCXAWTXCXAIZBDWQXCYDXAXCW
    HYDWHWIWGWMWSVLYFQMXCYGXAXCWKYGWKWLWGWJWSVNYIQMXCWQFHXAXCAEXCAFGWGWJWMWSVMU
    GXCWLXQWKWLWGWJWSVOXSQSMYNBWQKTWPWRYNWQWOBKYNECAJYNCEXCXAVDVPVQVQWNWSXAUNVR
    VSWDVTWAWDWTXABDWOWQKWTWECEAJWFWBWC $.

  $( The base of exponent used to define the X and Y sequences is the
     fundamental solution of the corresponding Pell equation.  (Contributed by
     Stefan O'Rear, 21-Sep-2014.) $)
  rmspecfund $p |- ( A e. ( ZZ>= ` 2 ) -> ( PellFund ` ( ( A ^ 2 ) - 1 ) ) = (
      A + ( sqr ` ( ( A ^ 2 ) - 1 ) ) ) ) $=
    ( c2 cfv wcel cexp co c1 cmin csqr caddc wceq cle wbr cn clt cmul syl recnd
    a1i cn0 cuz cpellfund csquarenn cdif cpell14qr rmspecnonsq cz eluzelz zsqcl
    zred cr 1re resubcld cc0 eluz2b2 simprbi eluzelre 0le1 2nn0 eluznn0 nn0ge0d
    sq1 mpan lt2sqd mpbid eqbrtrrd posdifd elrpd rpsqrcld rpred oveq2d cpell1qr
    mulid1d wss pell1qrss14 oveq2i syl5eq cc ax-1cn nncand eqtrd pellqrexplicit
    1nn0 syl31anc sseldd eqeltrrd readdcld ltaddrpd ltadd1dd pellfundlb syl3anc
    lttrd npcand fveq2d sqrsqd oveq1d pellfundge pellfundre letri3d mpbir2and )
    ABUACDZABEFZGHFZUBCZAXCICZJFZKXDXFLMZXFXDLMXAXCNUCUDDZXFXCUECZDGXFOMXGAUFZX
    AAXEGPFZJFZXFXIXAXKXEAJXAXEXAXEXAXEXAXCXAXCXAXBGXAXBXAAUGDXBUGDBAUHAUIQUJZG
    UKDXAULSZUMZXAGXBOMUNXCOMXAGBEFZGXBOXPGKXAVBSXAGAOMZXPXBOMXAANDXQAUOUPZXAGA
    XNBAUQZUNGLMXAURSXAABTDXAATDZUSABUTVCZVAZVDVEVFXAGXBXNXMVGVEVHVIZVJZRVMVKXA
    XCVLCZXIXLXAXHYEXIVNXJXCVOQXAXHXTGTDZXBXCXPPFZHFZGKXLYEDXJYAYFXAWCSXAYHXBXC
    HFGXAYGXCXBHXAYGXCGPFXCXPGXCPVBVPXAXCXAXCXORVMVQVKXAXBGXAXBXMRZGVRDXAVSSZVT
    WAAGXCWBWDWEWFXAGGXEJFXFXNXAGXEXNYDWGXAAXEXSYDWGZXAGXEXNYCWHXAGAXEXNXSYDXRW
    IWLXFXCWJWKXAXCGJFZICZXEJFZXFXDLXAYMAXEJXAYMXBICAXAYLXBIXAXBGYIYJWMWNXAAXSY
    BWOWAWPXAXHYNXDLMXJXCWQQVFXAXDXFXAXHXDUKDXJXCWRQYKWSWT $.

  ${
    $d A a c d $.  $d N a $.
    $( The solutions used to construct the X and Y sequences are quadratic
       irrationals.  (Contributed by Stefan O'Rear, 21-Sep-2014.) $)
    rmxyelqirr $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( ( A + ( sqr ` ( (
        A ^ 2 ) - 1 ) ) ) ^ N ) e. { a | E. c e. NN0 E. d e. ZZ a = ( c + ( (
        sqr ` ( ( A ^ 2 ) - 1 ) ) x. d ) ) } ) $=
      ( c2 cfv wcel cz wa cexp co cv wceq wrex cn0 cr crab cvv wss c1 cpell14qr
      cuz cmin csqr cmul caddc cn csquarenn cdif rmspecnonsq adantr pell14qrval
      cab syl wral simpl reximi rgenw a1i ss2rab sylibr ssv rabss2 ax-mp syl6ss
      wi rabab syl6sseq eqsstrd cpellfund simpr rmspecfund eqcomd oveq1d eqeq2d
      oveq2 rspcev syl2anc wb pellfund14b mpbird sseldd ) AFUCGHZBIHZJZAFKLUAUD
      LZUBGZCMZDMZWGUEGZEMZUFLUGLNZEIOZDPOZCUNZAWKUGLZBKLZWFWHWMWJFKLWGWLFKLUFL
      UDLUANZJZEIOZDPOZCQRZWPWFWGUHUIUJHZWHXCNWDXDWEAUKULZCDEWGUMUOWFXCWOCSRZWP
      WFXCWOCQRZXFWFXBWOVGZCQUPZXCXGTXIWFXHCQXAWNDPWTWMEIWMWSUQURURUSUTXBWOCQVA
      VBQSTXGXFTQVCWOCQSVDVEVFWOCVHVIVJWFWRWHHZWRWGVKGZWIKLZNZCIOZWFWEWRXKBKLZN
      ZXNWDWEVLWFWQXKBKWFXKWQWDXKWQNWEAVMULVNVOXMXPCBIWIBNXLXOWRWIBXKKVQVPVRVSW
      FXDXJXNVTXECWRWGWAUOWBWC $.
  $}

  ${
    $d b c d a A $.
    $( The function used to extract rational and irrational parts in ~ df-rmx
       and ~ df-rmy in fact achieves a one-to-one mapping from the quadratic
       irrationals to pairs of integers.  (Contributed by Stefan O'Rear,
       21-Sep-2014.) $)
    rmxypairf1o $p |- ( A e. ( ZZ>= ` 2 ) -> ( b e. ( NN0 X. ZZ ) |-> ( ( 1st `
        b ) + ( ( sqr ` ( ( A ^ 2 ) - 1 ) ) x. ( 2nd ` b ) ) ) ) : ( NN0 X. ZZ
        ) -1-1-onto-> { a | E. c e. NN0 E. d e. ZZ a = ( c + ( ( sqr ` ( ( A ^
        2 ) - 1 ) ) x. d ) ) } ) $=
      ( cfv wcel cn0 cz cv c1st co c2nd cmul caddc wceq wrex ovex fveq2 cq cexp
      c2 cuz cxp c1 cmin csqr cmpt wfn crn cab wi wral wf1o eqid fnmpti a1i cop
      wb op1std op2ndd oveq2d oveq12d eqeq2d rexxp bicomi abbidv rnmpt syl6reqr
      vex wa fvmpt ad2antrl ad2antll eqeq12d cc rmspecsqrnq adantr nn0ssq xp1st
      sseldi xp2nd zq syl qirropth syl122anc biimpd xpopth adantl sylibd sylbid
      cdif ralrimivva dff1o6 syl3anbrc ) AUBUCFGZCHIUDZCJZKFZAUBUALUEUFLUGFZWRM
      FZNLZOLZUHZWQUIZXDUJZBJZDJZWTEJZNLZOLZPZEIQDHQZBUKZPXHXDFZXIXDFZPZXHXIPZU
      LZEWQUMDWQUMWQXNXDUNXEWPCWQXCXDWSXBORXDUOZUPUQWPXNXGXCPZCWQQZBUKXFWPXMYBB
      XMYBUSWPYBXMYAXLCDEHIWRXHXIURPZXCXKXGYCWSXHXBXJOXHXIWRDVJZEVJZUTYCXAXIWTN
      XHXIWRYDYEVAVBVCVDVEVFUQVGCBWQXCXDXTVHVIWPXSDEWQWQWPXHWQGZXIWQGZVKZVKZXQX
      HKFZWTXHMFZNLZOLZXIKFZWTXIMFZNLZOLZPZXRYIXOYMXPYQYFXOYMPWPYGCXHXCYMWQXDWR
      XHPZWSYJXBYLOWRXHKSYSXAYKWTNWRXHMSVBVCXTYJYLORVLVMYGXPYQPWPYFCXIXCYQWQXDW
      RXIPZWSYNXBYPOWRXIKSYTXAYOWTNWRXIMSVBVCXTYNYPORVLVNVOYIYRYJYNPYKYOPVKZXRY
      IYRUUAYIWTVPTWLGZYJTGYKTGZYNTGYOTGZYRUUAUSWPUUBYHAVQVRYIHTYJVSYFYJHGWPYGX
      HHIVTVMWAYIYKIGZUUCYFUUEWPYGXHHIWBVMYKWCWDYIHTYNVSYGYNHGWPYFXIHIVTVNWAYIY
      OIGZUUDYGUUFWPYFXIHIWBVNYOWCWDWTYJYKYNYOWEWFWGYHUUAXRUSWPXHXIHIHIWHWIWJWK
      WMDEWQXNXDWNWO $.
  $}

  ${
    $d a b c d A $.  $d a N $.
    $( Lemma for ~ frmx and ~ frmy .  (Contributed by Stefan O'Rear,
       22-Sep-2014.) $)
    rmxyelxp $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ )
        -> ( `' ( b e. ( NN0 X. ZZ ) |-> ( ( 1st ` b )
          + ( ( sqr ` ( ( A ^ 2 ) - 1 ) ) x. ( 2nd ` b ) ) ) ) ` ( ( A
          + ( sqr ` ( ( A ^ 2 ) - 1 ) ) ) ^ N ) ) e. ( NN0 X. ZZ ) ) $=
      ( va vc vd c2 cuz cfv wcel cz wa cn0 cxp cv cexp co cmul caddc wrex cmin
      c1 csqr wceq cab c1st c2nd cmpt wf1o ccnv rmxypairf1o rmxyelqirr f1ocnvdm
      adantr syl2anc ) AGHIJZBKJZLMKNZDOEOAGPQUBUAQUCIZFORQSQUDFKTEMTDUEZCURCOZ
      UFIUSVAUGIRQSQUHZUIZAUSSQBPQZUTJVDVBUJIURJUPVCUQADCEFUKUNABDEFULURUTVDVBU
      MUO $.
  $}

  ${
    $d a b c $.
    $( The X sequence is a nonnegative integer.  See ~ rmxnn for a
       strengthening.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
    frmx $p |- rmX : ( ( ZZ>= ` 2 ) X. ZZ ) --> NN0 $=
      ( va vb vc cv c2 cexp co c1 cmin csqr cfv caddc cn0 cz cxp c1st c2nd wcel
      wral crmx cmul cmpt ccnv cuz wf wa rmxyelxp xp1st rgen2 df-rmx fmpt2 mpbi
      syl ) ADZUNEFGHIGJKZLGBDZFGCMNOZCDZPKUOURQKUAGLGUBUCKZPKZMRZBNSAEUDKZSVBN
      OMTUEVAABVBNUNVBRUPNRUFUSUQRVAUNUPCUGUSMNUHUMUIABVBNUTMTBACUJUKUL $.

    $( The Y sequence is an integer.  (Contributed by Stefan O'Rear,
       22-Sep-2014.) $)
    frmy $p |- rmY : ( ( ZZ>= ` 2 ) X. ZZ ) --> ZZ $=
      ( va vb vc cv c2 cexp co c1 cmin csqr cfv caddc cn0 cz cxp c1st c2nd wcel
      wral crmy cmul cmpt ccnv cuz wf wa rmxyelxp xp2nd rgen2 df-rmy fmpt2 mpbi
      syl ) ADZUNEFGHIGJKZLGBDZFGCMNOZCDZPKUOURQKUAGLGUBUCKZQKZNRZBNSAEUDKZSVBN
      ONTUEVAABVBNUNVBRUPNRUFUSUQRVAUNUPCUGUSMNUHUMUIABVBNUTNTBACUJUKUL $.
  $}

  ${
    $d a b c d A $.  $d a b c N $.
    $( Main definition of the X and Y sequences.  Compare definition 2.3 of
       [JonesMatijasevic] p. 694.  (Contributed by Stefan O'Rear,
       19-Oct-2014.) $)
    rmxyval $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( ( A rmX N ) + ( ( sqr
        ` ( ( A ^ 2 ) - 1 ) ) x. ( A rmY N ) ) ) = ( ( A + ( sqr ` ( ( A ^ 2 )
        - 1 ) ) ) ^ N ) ) $=
      ( vb va vc vd c2 cfv wcel cz co cmul caddc c1st c2nd oveq2d oveq12d fveq2
      cv wceq cuz wa crmx cexp cmin csqr crmy cn0 cxp cmpt ccnv rmxfval rmyfval
      c1 rmxyelxp weq cbvmptv ovex fvmpt syl wrex rmxypairf1o adantr rmxyelqirr
      cab wf1o f1ocnvfv2 syl2anc 3eqtr2d ) AGUAHIZBJIZUBZABUCKZAGUDKUNUEKUFHZAB
      UGKZLKZMKAVNMKBUDKZCUHJUIZCSZNHZVNVSOHZLKZMKZUJZUKHZNHZVNWEOHZLKZMKZWEWDH
      ZVQVLVMWFVPWHMABCULVLVOWGVNLABCUMPQVLWEVRIWJWITABCUODWEDSZNHZVNWKOHZLKZMK
      ZWIVRWDWKWETZWLWFWNWHMWKWENRWPWMWGVNLWKWEORPQCDVRWCWOCDUPZVTWLWBWNMVSWKNR
      WQWAWMVNLVSWKORPQUQWFWHMURUSUTVLVRWKESVNFSLKMKTFJVAEUHVADVEZWDVFZVQWRIWJV
      QTVJWSVKADCEFVBVCABDEFVDVRWRVQWDVGVHVI $.
  $}

  $( The discriminant used to define the X and Y sequences is a positive real.
     (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmspecpos $p |- ( A e. ( ZZ>= ` 2 ) -> ( ( A ^ 2 ) - 1 ) e. RR+ ) $=
    ( c2 cuz cfv wcel cexp co c1 cmin eluzelre resqcld 1re a1i resubcld clt wbr
    cr cc0 cn0 mpbid sq1 cz eluz2b1 simprbi 0le1 2nn0 eluznn0 nn0ge0d syl5eqbrr
    cle mpan lt2sqd posdifd elrpd ) ABCDEZABFGZHIGZUOUPHUOABAJZKZHQEUOLMZNUOHUP
    OPRUQOPUOHHBFGZUPOUAUOHAOPZVAUPOPUOAUBEVBAUCUDUOHAUTURRHUJPUOUEMUOABSEUOASE
    UFABUGUKUHULTUIUOHUPUTUSUMTUN $.

  ${
    $d A n $.  $d X n $.  $d Y n $.  $d X x y $.  $d Y x y $.  $d A x y $.
    $( The X and Y sequences taken together enumerate all solutions to the
       corresponding Pell equation in the right half-plane.  (Contributed by
       Stefan O'Rear, 22-Sep-2014.) $)
    rmxycomplete $p |- ( ( A e. ( ZZ>= ` 2 ) /\ X e. NN0 /\ Y e. ZZ ) -> ( ( (
        X ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( Y ^ 2 ) ) ) = 1 <-> E. n e. ZZ ( X =
        ( A rmX n ) /\ Y = ( A rmY n ) ) ) ) $=
      ( vx vy c2 wcel cn0 cz cexp co c1 cmin cmul caddc wceq wa cq adantr cv cn
      cuz cfv w3a csqr cpell14qr cpellfund wrex crmx crmy csquarenn rmspecnonsq
      cdif wb 3ad2ant1 pellfund14b syl cr nn0re 3ad2ant2 rmspecpos rpsqrcld zre
      rpred 3ad2ant3 remulcld biantrurd simpl2 simpl3 eqidd simpr eqeq2d oveq1d
      readdcld oveq1 eqeq1d anbi12d oveq2 oveq2d rspc2ev syl112anc ex cc nn0ssq
      rmspecsqrnq simp2 zq sseli ad2antrl ad2antll qirropth syl122anc oveqan12d
      sseldi biimpd anim1d eqcomd biimpa syl6 rexlimdvva elpell14qr 3bitr4d cxp
      impbid wf frmx a1i simpl1 fovrnd zssq rmxyval 3ad2antl1 rmspecfund eqtr4d
      frmy bitr3d rexbidva ) AGUCUDZHZCIHZDJHZUEZCAGKLMNLZUFUDZDOLZPLZYDUGUDHZY
      GYDUHUDZBUAZKLZQZBJUIZCGKLZYDDGKLZOLZNLZMQZCAYJUJLZQDAYJUKLZQRZBJUIYCYDUB
      ULUNHZYHYMUOXTYAUUBYBAUMUPZBYGYDUQURYCYGEUAZYEFUAZOLZPLZQZUUDGKLZYDUUEGKL
      ZOLZNLZMQZRZFJUIEIUIZYGUSHZUUORZYRYHYCUUPUUOYCCYFYAXTCUSHYBCUTVAYCYEDXTYA
      YEUSHYBXTYEXTYDAVBVCVEUPYBXTDUSHYADVDVFVGVOVHYCYRUUOYCYRUUOYCYRRZYAYBYGYG
      QZYRUUOXTYAYBYRVIXTYAYBYRVJUURYGVKYCYRVLUUNUUSYRRYGCUUFPLZQZYNUUKNLZMQZRE
      FCDIJUUDCQZUUHUVAUUMUVCUVDUUGUUTYGUUDCUUFPVPVMUVDUULUVBMUVDUUIYNUUKNUUDCG
      KVPVNVQVRUUEDQZUVAUUSUVCYRUVEUUTYGYGUVEUUFYFCPUUEDYEOVSVTVMUVEUVBYQMUVEUU
      KYPYNNUVEUUJYOYDOUUEDGKVPVTVTVQVRWAWBWCYCUUNYREFIJYCUUDIHZUUEJHZRZRZUUNCU
      UDQZDUUEQZRZUUMRYRUVIUUHUVLUUMUVIUUHUVLUVIYEWDSUNHZCSHZDSHZUUDSHZUUESHZUU
      HUVLUOYCUVMUVHXTYAUVMYBAWFUPZTYCUVNUVHYCISCWEXTYAYBWGWOZTYCUVOUVHYBXTUVOY
      ADWHVFZTUVFUVPYCUVGISUUDWEWIWJUVGUVQYCUVFUUEWHWKYECDUUDUUEWLWMWPWQUVLUUMY
      RUVLUULYQMUVLYQUULUVJUVKYNUUIYPUUKNCUUDGKVPUVKYOUUJYDODUUEGKVPVTWNWRVQWSW
      TXAXEYCUUBYHUUQUOUUCEFYGYDXBURXCYCUUAYLBJYCYJJHZRZYGYSYEYTOLPLZQZUUAYLUWB
      UVMUVNUVOYSSHYTSHUWDUUAUOYCUVMUWAUVRTYCUVNUWAUVSTYCUVOUWAUVTTUWBISYSWEUWB
      AYJIXSJUJXSJXDZIUJXFUWBXGXHXTYAYBUWAXIZYCUWAVLZXJWOUWBJSYTXKUWBAYJJXSJUKU
      WEJUKXFUWBXPXHUWFUWGXJWOYECDYSYTWLWMUWBUWCYKYGUWBUWCAYEPLZYJKLZYKXTYAUWAU
      WCUWIQYBAYJXLXMUWBYIUWHYJKYCYIUWHQZUWAXTYAUWJYBAXNUPTVNXOVMXQXRXC $.
  $}

  ${
    $d A a $.  $d N a $.
    $( The X and Y sequences define a solution to the corresponding Pell
       equation.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
    rmxynorm $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( ( ( A rmX N ) ^ 2 )
        - ( ( ( A ^ 2 ) - 1 ) x. ( ( A rmY N ) ^ 2 ) ) ) = 1 ) $=
      ( va c2 cuz wcel cz wa crmx co cexp cmin crmy wceq eqidd oveq2 eqeq2d cn0
      c1 fovcl cfv cmul cv wrex simpr anim12i anbi12d rspcev syl2anc simpl frmx
      wb frmy rmxycomplete syl3anc mpbird ) ADEUAZFZBGFZHZABIJZDKJADKJSLJABMJZD
      KJUBJLJSNZVAACUCZIJZNZVBAVDMJZNZHZCGUDZUTUSVAVANZVBVBNZHZVJURUSUEURVKUSVL
      URVAOUSVBOUFVIVMCBGVDBNZVFVKVHVLVNVEVAVAVDBAIPQVNVGVBVBVDBAMPQUGUHUIUTURV
      ARFVBGFVCVJULURUSUJABRUQGIUKTABGUQGMUMTACVAVBUNUOUP $.
  $}

  $( The base of exponentiation for the X and Y sequences is a positive real.
     (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmbaserp $p |- ( A e. ( ZZ>= ` 2 ) -> ( A + ( sqr ` ( ( A ^ 2 ) - 1 ) ) ) e.
      RR+ ) $=
    ( c2 cuz cfv wcel cexp co c1 cmin cpellfund csqr caddc rmspecfund csquarenn
    crp cn cdif rmspecnonsq pellfundrp syl eqeltrrd ) ABCDEZABFGHIGZJDZAUCKDLGO
    AMUBUCPNQEUDOEARUCSTUA $.

  $( Negation law for X and Y sequences.  JonesMatijasevic is inconsistent on
     whether the X and Y sequences have domain ` NN0 ` or ` ZZ ` ; we use
     ` ZZ ` consistently to avoid the need for a separate subtraction law.
     (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmxyneg $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( ( A rmX -u N ) = ( A
      rmX N ) /\ ( A rmY -u N ) = -u ( A rmY N ) ) ) $=
    ( c2 wcel cz crmx co cexp c1 cmin crmy cmul caddc oveq2d cn0 fovcl cc eqtrd
    wceq cq cuz cfv wa cneg csqr znegcl rmxyval sylan2 cdiv nn0cnd cn csquarenn
    frmx rmspecnonsq eldifad nncnd adantr sqrcld frmy zcnd negcld mulcld addcld
    rmbaserp rpcnd cc0 wne rpne0d simpr expclzd eqeltrd expne0d reccld mulneg2d
    eqnetrd negsubd subsq syl2anc eqtr4d sqmuld sqsqrd oveq1d rmxynorm mulcanad
    recidd expnegd 3eqtr4rd cdif rmspecsqrnq nn0ssq sseldi zssq qnegcl qirropth
    wb syl syl122anc mpbid ) ACUAUBZDZBEDZUCZABUDZFGZACHGIJGZUEUBZAXCKGZLGMGZAB
    FGZXFABKGZUDZLGZMGZSZXDXISXGXKSUCZXBXHAXFMGZXCHGZXMXAWTXCEDZXHXQSBUFZAXCUGU
    HXBIXIXFXJLGZMGZUIGZIXPBHGZUIGXMXQXBYAYCIUIABUGZNXBXMYBYAXBXIXLXBXIABOWSEFU
    MPZUJZXBXFXKXBXEWTXEQDXAWTXEWTXEUKULAUNUOUPUQZURZXBXJXBXJABEWSEKUSPZUTZVAVB
    VCXBYAXBYAYCQYDXBXPBWTXPQDXAWTXPAVDZVEUQZWTXPVFVGXAWTXPYKVHUQZWTXAVIZVJVKZX
    BYAYCVFYDXBXPBYLYMYNVLVOZVMYOYPXBYAXMLGZIYAYBLGXBYQXICHGZXTCHGZJGZIXBYQYAXI
    XTJGZLGZYTXBXMUUAYALXBXMXIXTUDZMGUUAXBXLUUCXIMXBXFXJYHYJVNNXBXIXTYFXBXFXJYH
    YJVBZVPRNXBXIQDXTQDYTUUBSYFUUDXIXTVQVRVSXBYTYRXEXJCHGZLGZJGIXBYSUUFYRJXBYSX
    FCHGZUUELGUUFXBXFXJYHYJVTXBUUGXEUUELXBXEYGWAWBRNABWCRRXBYAYOYPWEVSWDXBXPBYL
    YMYNWFWGRXBXFQTWHDZXDTDXGTDXITDXKTDZXNXOWOWTUUHXAAWIUQXBOTXDWJXAWTXRXDODXSA
    XCOWSEFUMPUHWKXBETXGWLXAWTXRXGEDXSAXCEWSEKUSPUHWKXBOTXIWJYEWKXBXJTDUUIXBETX
    JWLYIWKXJWMWPXFXDXGXIXKWNWQWR $.

  $( Addition formula for X and Y sequences.  See ~ rmxadd and ~ rmyadd for
     most uses.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmxyadd $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) -> (
        ( A rmX ( M + N ) ) = ( ( ( A rmX M ) x. ( A rmX N ) ) + ( ( ( A ^ 2 )
      - 1 ) x. ( ( A rmY M ) x. ( A rmY N ) ) ) ) /\
        ( A rmY ( M + N ) ) = ( ( ( A rmY M ) x. ( A rmX N ) ) + ( ( A rmX M )
      x. ( A rmY N ) ) ) ) ) $=
    ( wcel cz caddc co crmx cexp c1 crmy cmul wceq syl2anc cq cn0 fovrnd sseldi
    zssq qmulcl c2 cuz cfv w3a cmin csqr wa simp1 zaddcl 3adant1 rmxyval cc cc0
    wne eluzelz 3ad2ant1 zcnd zq qsqcl 3syl 1z sselii a1i qsubcl qcn syl sqrcld
    addcld rmbaserp rpne0d simp2 simp3 expaddz syl22anc cxp wf frmx nn0cnd frmy
    mulcld muladdd oveq12d eqtr3d msqsqrd mulcomd oveq2d mul12d addcomd 3eqtr2d
    mul4d eqtrd adddid oveq1d cdif rmspecsqrnq nn0ssq qaddcl qirropth syl122anc
    wb mpbid ) AUAUBUCZDZBEDZCEDZUDZABCFGZHGZAUAIGZJUEGZUFUCZAXGKGZLGFGZABHGZAC
    HGZLGZXJABKGZACKGZLGZLGZFGZXKXQXOLGZXNXRLGZFGZLGZFGZMZXHYAMXLYDMUGZXFXMAXKF
    GZXGIGZYFXFXCXGEDZXMYJMXCXDXEUHZXDXEYKXCBCUIUJZAXGUKNXFYJYIBIGZYICIGZLGZXPX
    KXRLGZXKXQLGZLGZFGZXNYQLGZXOYRLGZFGZFGZYFXFYIULDYIUMUNZXDXEYJYPMXFAXKXFAXCX
    DAEDZXEUAAUOUPZUQXFXJXFXJODZXJULDXFXIODZJODZUUHXFUUFAODUUIUUGAURAUSUTUUJXFE
    OJSVAVBVCXIJVDNZXJVEVFZVGZVHXCXDUUEXEXCYIAVIVJUPXCXDXEVKZXCXDXEVLZYIBCVMVNX
    FXNYRFGZXOYQFGZLGUUDYPXFXNYRXOYQXFXNXFABPXBEHXBEVOZPHVPXFVQVCZYLUUNQZVRZXFX
    KXQUUMXFXQXFABEXBEKUUREKVPXFVSVCZYLUUNQZUQZVTXFXOXFACPXBEHUUSYLUUOQZVRZXFXK
    XRUUMXFXRXFACEXBEKUVBYLUUOQZUQZVTWAXFUUPYNUUQYOLXFXCXDUUPYNMYLUUNABUKNXFXCX
    EUUQYOMYLUUOACUKNWBWCXFYTYAUUCYEFXFYSXTXPFXFYSXKXKLGZXRXQLGZLGXTXFXKXRXKXQU
    UMUVHUUMUVDWJXFUVIXJUVJXSLXFXJUULWDXFXRXQUVHUVDWEWBWKWFXFUUCXKYCLGZXKXOXQLG
    ZLGZFGXKYCUVLFGZLGYEXFUUAUVKUUBUVMFXFXNXKXRUVAUUMUVHWGXFXOXKXQUVFUUMUVDWGWB
    XFXKYCUVLUUMXFXNXRUVAUVHVTZXFXOXQUVFUVDVTZWLXFUVNYDXKLXFUVNUVLYCFGYDXFYCUVL
    UVOUVPWHXFUVLYBYCFXFXOXQUVFUVDWEWMWKWFWIWBWIWKXFXKULOWNDZXHODXLODYAODZYDODZ
    YGYHWTXCXDUVQXEAWOUPXFPOXHWPXFAXGPXBEHUUSYLYMQRXFEOXLSXFAXGEXBEKUVBYLYMQRXF
    XPODZXTODZUVRXFXNODZXOODZUVTXFPOXNWPUUTRZXFPOXOWPUVERZXNXOTNXFUUHXSODZUWAUU
    KXFXQODZXRODZUWFXFEOXQSUVCRZXFEOXRSUVGRZXQXRTNXJXSTNXPXTWQNXFYBODZYCODZUVSX
    FUWGUWCUWKUWIUWEXQXOTNXFUWBUWHUWLUWDUWJXNXRTNYBYCWQNXKXHXLYAYDWRWSXA $.

  $( Value of the X and Y sequences at 1.  (Contributed by Stefan O'Rear,
     22-Sep-2014.) $)
  rmxy1 $p |- ( A e. ( ZZ>= ` 2 )
      -> ( ( A rmX 1 ) = A /\ ( A rmY 1 ) = 1 ) ) $=
    ( c2 cfv wcel c1 crmx co cexp crmy cmul caddc wceq cz 1z mpan2 rpcnd cq cn0
    fovcl sseldi cuz cmin csqr rmxyval rmbaserp rmspecpos sqrcld mulid1d eqcomd
    wa exp1d oveq2d 3eqtrd cc cdif wb rmspecsqrnq nn0ssq frmx zssq frmy eluzelz
    zq syl sselii a1i qirropth syl122anc mpbid ) ABUACZDZAEFGZABHGEUBGZUCCZAEIG
    ZJGKGZAVNEJGZKGZLZVLALVOELUJZVKVPAVNKGZEHGZWAVRVKEMDZVPWBLNAEUDOVKWAVKWAAUE
    PUKVKVNVQAKVKVQVNVKVNVKVMVKVMAUFPUGUHUIULUMVKVNUNQUODVLQDVOQDAQDZEQDZVSVTUP
    AUQVKRQVLURVKWCVLRDNAERVJMFUSSOTVKMQVOUTVKWCVOMDNAEMVJMIVASOTVKAMDWDBAVBAVC
    VDWEVKMQEUTNVEVFVNVLVOAEVGVHVI $.

  $( Value of the X and Y sequences at 0.  (Contributed by Stefan O'Rear,
     22-Sep-2014.) $)
  rmxy0 $p |- ( A e. ( ZZ>= ` 2 )
      -> ( ( A rmX 0 ) = 1 /\ ( A rmY 0 ) = 0 ) ) $=
    ( c2 cfv wcel cc0 crmx co cexp c1 crmy cmul caddc wceq cz 0z mpan2 rpcnd cq
    cn0 zssq cmin csqr wa rmxyval rmbaserp exp0d rmspecpos sqrcld mul01d oveq2d
    cuz ax-1cn addid1i syl6req 3eqtrd cc cdif wb rmspecsqrnq nn0ssq frmx sseldi
    fovcl frmy 1z sselii a1i qirropth syl122anc mpbid ) ABUKCZDZAEFGZABHGIUAGZU
    BCZAEJGZKGLGZIVOEKGZLGZMZVMIMVPEMUCZVLVQAVOLGZEHGZIVSVLENDZVQWCMOAEUDPVLWBV
    LWBAUEQUFVLVSIELGIVLVREILVLVOVLVNVLVNAUGQUHUIUJIULUMUNUOVLVOUPRUQDVMRDVPRDI
    RDZERDZVTWAURAUSVLSRVMUTVLWDVMSDOAESVKNFVAVCPVBVLNRVPTVLWDVPNDOAENVKNJVDVCP
    VBWEVLNRITVEVFVGWFVLNRETOVFVGVOVMVPIEVHVIVJ $.

  $( Negation law (even function) for the X sequence.  The method of proof used
     for the previous four theorems ~ rmxyneg , ~ rmxyadd , ~ rmxy0 , and
     ~ rmxy1 via ~ qirropth results in two theorems at once, but typical use
     requires only one, so this group of theorems serves to separate the
     cases.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmxneg $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmX -u N ) = ( A rmX N
      ) ) $=
    ( c2 cuz cfv wcel cz wa cneg crmx co wceq crmy rmxyneg simpld ) ACDEFBGFHAB
    IZJKABJKLAPMKABMKILABNO $.

  $( Value of X sequence at 0.  Part 1 of equation 2.11 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmx0 $p |- ( A e. ( ZZ>= ` 2 ) -> ( A rmX 0 ) = 1 ) $=
    ( c2 cuz cfv wcel cc0 crmx co c1 wceq crmy rmxy0 simpld ) ABCDEAFGHIJAFKHFJ
    ALM $.

  $( Value of X sequence at 1.  Part 2 of equation 2.11 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmx1 $p |- ( A e. ( ZZ>= ` 2 ) -> ( A rmX 1 ) = A ) $=
    ( c2 cuz cfv wcel c1 crmx co wceq crmy rmxy1 simpld ) ABCDEAFGHAIAFJHFIAKL
    $.

  $( Addition formula for X sequence.  Equation 2.7 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmxadd $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) ->
        ( A rmX ( M + N ) ) = ( ( ( A rmX M ) x. ( A rmX N ) ) + ( ( ( A ^ 2 )
      - 1 ) x. ( ( A rmY M ) x. ( A rmY N ) ) ) ) ) $=
    ( c2 cuz cfv wcel cz w3a caddc crmx cmul cexp cmin crmy wceq rmxyadd simpld
    co c1 ) ADEFGBHGCHGIABCJSZKSABKSZACKSZLSADMSTNSABOSZACOSZLSLSJSPAUAOSUDUCLS
    UBUELSJSPABCQR $.

  $( Negation formula for Y sequence (odd function).  (Contributed by Stefan
     O'Rear, 22-Sep-2014.) $)
  rmyneg $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmY -u N ) = -u ( A
      rmY N ) ) $=
    ( c2 cuz cfv wcel cz wa cneg crmx co wceq crmy rmxyneg simprd ) ACDEFBGFHAB
    IZJKABJKLAPMKABMKILABNO $.

  $( Value of Y sequence at 0.  Part 1 of equation 2.12 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmy0 $p |- ( A e. ( ZZ>= ` 2 ) -> ( A rmY 0 ) = 0 ) $=
    ( c2 cuz cfv wcel cc0 crmx co c1 wceq crmy rmxy0 simprd ) ABCDEAFGHIJAFKHFJ
    ALM $.

  $( Value of Y sequence at 1.  Part 2 of equation 2.12 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmy1 $p |- ( A e. ( ZZ>= ` 2 ) -> ( A rmY 1 ) = 1 ) $=
    ( c2 cuz cfv wcel c1 crmx co wceq crmy rmxy1 simprd ) ABCDEAFGHAIAFJHFIAKL
    $.

  $( Addition formula for Y sequence.  Equation 2.8 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 22-Sep-2014.) $)
  rmyadd $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) ->
        ( A rmY ( M + N ) ) = ( ( ( A rmY M ) x. ( A rmX N ) ) + ( ( A rmX M )
      x. ( A rmY N ) ) ) ) $=
    ( c2 cuz cfv wcel cz w3a caddc crmx cmul cexp cmin crmy wceq rmxyadd simprd
    co c1 ) ADEFGBHGCHGIABCJSZKSABKSZACKSZLSADMSTNSABOSZACOSZLSLSJSPAUAOSUDUCLS
    UBUELSJSPABCQR $.

  $( Special addition-of-1 formula for X sequence.  Part 1 of equation 2.9 of
     [JonesMatijasevic] p. 695.  (Contributed by Stefan O'Rear,
     19-Oct-2014.) $)
  rmxp1 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) ->
        ( A rmX ( N + 1 ) ) = ( ( ( A rmX N ) x. A ) + ( ( ( A ^ 2 ) - 1 ) x. (
      A rmY N ) ) ) ) $=
    ( c2 cuz wcel cz wa c1 caddc co crmx cmul cexp cmin crmy wceq adantr oveq2d
    cfv eqtrd 1z rmxadd mp3an3 rmx1 rmy1 frmy fovcl zcnd mulid1d oveq12d ) ACDS
    ZEZBFEZGZABHIJKJZABKJZAHKJZLJZACMJHNJZABOJZAHOJZLJZLJZIJZUPALJZUSUTLJZIJULU
    MHFEUOVDPUAABHUBUCUNURVEVCVFIUNUQAUPLULUQAPUMAUDQRUNVBUTUSLUNVBUTHLJZUTULVB
    VGPUMULVAHUTLAUERQUNUTUNUTABFUKFOUFUGUHUITRUJT $.

  $( Special addition of 1 formula for Y sequence.  Part 2 of equation 2.9 of
     [JonesMatijasevic] p. 695.  (Contributed by Stefan O'Rear,
     24-Sep-2014.) $)
  rmyp1 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) ->
        ( A rmY ( N + 1 ) ) = ( ( ( A rmY N ) x. A ) + ( A rmX N ) ) ) $=
    ( c2 cuz wcel cz wa c1 caddc co crmy crmx cmul wceq 1z rmyadd oveq2d adantr
    cfv eqtrd mp3an3 rmx1 rmy1 cn0 frmx fovcl nn0cnd mulid1d oveq12d ) ACDSZEZB
    FEZGZABHIJKJZABKJZAHLJZMJZABLJZAHKJZMJZIJZUOAMJZURIJUKULHFEUNVANOABHPUAUMUQ
    VBUTURIUKUQVBNULUKUPAUOMAUBQRUMUTURHMJZURUKUTVCNULUKUSHURMAUCQRUMURUMURABUD
    UJFLUEUFUGUHTUIT $.

  $( Subtraction of 1 formula for X sequence.  Part 1 of equation 2.10 of
     [JonesMatijasevic] p. 695.  (Contributed by Stefan O'Rear,
     14-Oct-2014.) $)
  rmxm1 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) ->
        ( A rmX ( N - 1 ) ) = ( ( A x. ( A rmX N ) ) -
        ( ( ( A ^ 2 ) - 1 ) x. ( A rmY N ) ) ) ) $=
    ( c2 wcel cz c1 cneg caddc co crmx cmul cmin crmy mpan2 eqtrd adantr oveq2d
    wceq 1z cc cuz cfv wa cexp 1nn0 nn0negzi rmxadd mp3an3 rmxneg rmx1 cn0 frmx
    fovcl nn0cnd eluzelz zcnd mulcomd rmyneg rmy1 negeqd ax-1cn mulneg2 sylancl
    frmy mulid1d cn csquarenn rmspecnonsq eldifad nncnd mulneg2d oveq12d adantl
    zcn negsub mulcld negsubd 3eqtr3d ) ACUAUBZDZBEDZUCZABFGZHIZJIZAABJIZKIZACU
    DIFLIZABMIZKIZGZHIZABFLIZJIWGWJLIWBWEWFAWCJIZKIZWHWIAWCMIZKIZKIZHIZWLVTWAWC
    EDWEWSRFUEUFABWCUGUHWBWOWGWRWKHWBWOWFAKIWGWBWNAWFKVTWNARWAVTWNAFJIZAVTFEDZW
    NWTRSAFUINAUJOPQWBWFAWBWFABUKVSEJULUMUNZVTATDWAVTACAUOUPPZUQOWBWRWHWIGZKIWK
    WBWQXDWHKWBWQWIWCKIZXDVTWQXERWAVTWPWCWIKVTWPAFMIZGZWCVTXAWPXGRSAFURNVTXFFAU
    SUTOQPWBXEWIFKIZGZXDWBWITDFTDZXEXIRWBWIABEVSEMVDUMUPZVAWIFVBVCWBXHWIWBWIXKV
    EUTOOQWBWHWIVTWHTDWAVTWHVTWHVFVGAVHVIVJPZXKVKOVLOWBWDWMAJWBBTDZXJWDWMRWAXMV
    TBVNVMVABFVOVCQWBWGWJWBAWFXCXBVPWBWHWIXLXKVPVQVR $.

  $( Subtraction of 1 formula for Y sequence.  Part 2 of equation 2.10 of
     [JonesMatijasevic] p. 695.  (Contributed by Stefan O'Rear,
     19-Oct-2014.) $)
  rmym1 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) ->
        ( A rmY ( N - 1 ) ) = ( ( ( A rmY N ) x. A ) - ( A rmX N ) ) ) $=
    ( c2 wcel cz c1 cmin co crmy cneg caddc crmx cmul cc wceq sylancl oveq2d 1z
    eqtrd adantr cuz cfv zcn adantl ax-1cn negsub eqcomd nn0negzi rmyadd mp3an3
    wa 1nn0 rmxneg mpan2 rmx1 rmyneg rmy1 negeqd cn0 fovcl nn0cnd neg1cn mulcom
    frmx mulm1d 3eqtrd oveq12d frmy zcnd eluzelre recnd mulcld negsubd ) ACUAUB
    ZDZBEDZUKZABFGHZIHABFJZKHZIHZABIHZAVSLHZMHZABLHZAVSIHZMHZKHZWBAMHZWEGHZVQVR
    VTAIVQVTVRVQBNDZFNDVTVROVPWKVOBUCUDUEBFUFPUGQVOVPVSEDWAWHOFULUHABVSUIUJVQWH
    WIWEJZKHWJVQWDWIWGWLKVQWCAWBMVOWCAOVPVOWCAFLHZAVOFEDZWCWMORAFUMUNAUOSTQVQWG
    WEVSMHZVSWEMHZWLVQWFVSWEMVOWFVSOVPVOWFAFIHZJZVSVOWNWFWRORAFUPUNVOWQFAUQURST
    QVQWENDVSNDWOWPOVQWEABUSVNELVDUTVAZVBWEVSVCPVQWEWSVEVFVGVQWIWEVQWBAVQWBABEV
    NEIVHUTVIVOANDVPVOACAVJVKTVLWSVMSVF $.

  $( The X sequence is a Lucas (second-order integer recurrence) sequence.
     Part 3 of equation 2.11 of [JonesMatijasevic] p. 695.  (Contributed by
     Stefan O'Rear, 14-Oct-2014.) $)
  rmxluc $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmX ( N + 1 ) ) =
      ( ( ( 2 x. A ) x. ( A rmX N ) ) - ( A rmX ( N - 1 ) ) ) ) $=
    ( c2 wcel cz wa cmul co crmx c1 cmin caddc wceq crmy cn0 frmx nn0cnd mulcld
    cc fovcl cuz cfv cexp peano2zm sylan2 peano2z addcomd rmxp1 oveq12d eluzelz
    rmxm1 zcnd adantr csquarenn rmspecnonsq eldifad frmy ppncand mulcomd oveq1d
    cn nncnd 2cn a1i mulassd 2timesd eqtr2d 3eqtrd mulcl sylancr subaddd mpbird
    eqcomd ) ACUAUBZDZBEDZFZCAGHZABIHZGHZABJKHZIHZKHZABJLHZIHZVQWCWEMWBWELHZVTM
    VQWFWEWBLHVSAGHZACUCHJKHZABNHZGHZLHZAVSGHZWJKHZLHZVTVQWBWEVPVOWAEDZWBSDBUDV
    OWOFWBAWAOVNEIPTQUEZVPVOWDEDZWESDBUFVOWQFWEAWDOVNEIPTQUEZUGVQWEWKWBWMLABUHA
    BUKUIVQWNWGWLLHWLWLLHZVTVQWGWJWLVQVSAVQVSABOVNEIPTQZVOASDZVPVOACAUJULUMZRVQ
    WHWIVOWHSDVPVOWHVOWHVAUNAUOUPVBUMVQWIABEVNENUQTULRVQAVSXBWTRZURVQWGWLWLLVQV
    SAWTXBUSUTVQVTCWLGHWSVQCAVSCSDZVQVCVDXBWTVEVQWLXCVFVGVHVHVQVTWBWEVQVRVSVQXD
    XAVRSDVCXBCAVIVJWTRWPWRVKVLVM $.

  $( The Y sequence is a Lucas sequence, definable via this second-order
     recurrence with ~ rmy0 and ~ rmy1 .  Part 3 of equation 2.12 of
     [JonesMatijasevic] p. 695.  JonesMatijasevic uses this theorem to redefine
     the X and Y sequences to have domain ` ( ZZ X. ZZ ) ` , which simplifies
     some later theorems.  It may shorten the derivation to use this as our
     initial definition.  Incidentally, the X sequence satisfies the exact same
     recurrence.  (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
  rmyluc $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmY ( N + 1 ) ) = ( (
      2 x. ( ( A rmY N ) x. A ) ) - ( A rmY ( N - 1 ) ) ) ) $=
    ( c2 cuz cfv wcel cz wa c1 caddc crmy cmul cmin frmy fovcl sylan2 zcnd crmx
    co cc peano2z 2cn eluzelre recnd adantr mulcld mulcl sylancr peano2zm rmyp1
    subcld rmym1 oveq12d cn0 frmx nn0cnd ppncand npcand eqtr2d 3eqtrd addcan2ad
    2timesd ) ACDEZFZBGFZHZABIJSZKSZCABKSZALSZLSZABIMSZKSZMSZVMVFVHVEVDVGGFVHGF
    BUAAVGGVCGKNOPQVFVKVMVFCTFVJTFVKTFUBVFVIAVFVIABGVCGKNOQVDATFVEVDACAUCUDUEUF
    ZCVJUGUHZVFVMVEVDVLGFVMGFBUIAVLGVCGKNOPQZUKVQVFVHVMJSVJABRSZJSZVJVRMSZJSVJV
    JJSZVNVMJSZVFVHVSVMVTJABUJABULUMVFVJVRVJVOVFVRABUNVCGRUOOUPVOUQVFWBVKWAVFVK
    VMVPVQURVFVJVOVBUSUTVA $.

  $( Lucas sequence property of Y with better output ordering.  (Contributed by
     Stefan O'Rear, 16-Oct-2014.) $)
  rmyluc2 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmY ( N + 1 ) ) =
        ( ( ( 2 x. A ) x. ( A rmY N ) ) - ( A rmY ( N - 1 ) ) ) ) $=
    ( c2 cuz cfv wcel cz wa c1 caddc co crmy cmul cmin rmyluc frmy zcnd eluzelz
    fovcl cc adantr mulcomd oveq2d 2cn a1i mulassd eqtr4d oveq1d eqtrd ) ACDEZF
    ZBGFZHZABIJKLKCABLKZAMKZMKZABINKLKZNKCAMKUNMKZUQNKABOUMUPURUQNUMUPCAUNMKZMK
    URUMUOUSCMUMUNAUMUNABGUJGLPSQZUKATFULUKACARQUAZUBUCUMCAUNCTFUMUDUEVAUTUFUGU
    HUI $.

  $( "Double-angle formula" for X-values.  Equation 2.13 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
  rmxdbl $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmX ( 2 x. N ) ) = ( (
      2 x. ( ( A rmX N ) ^ 2 ) ) - 1 ) ) $=
    ( c2 wcel cz cmul co crmx caddc cexp c1 cmin crmy cc 2timesd oveq2d oveq12d
    fovcl sqcld sqvald cuz cfv wa zcn adantl wceq rmxadd 3anidm23 cn0 nn0cnd cn
    frmx csquarenn rmspecnonsq eldifad adantr frmy zcnd mulcld pnncand rmxynorm
    nncnd eqcomd 3eqtr3rd 3eqtrd ) ACUAUBZDZBEDZUCZACBFGZHGABBIGZHGZABHGZVMFGZA
    CJGKLGZABMGZVPFGZFGZIGZCVMCJGZFGZKLGZVIVJVKAHVIBVHBNDVGBUDUEOPVGVHVLVSUFABB
    UGUHVIVTVTIGZVTVOVPCJGZFGZLGZLGVTWEIGWBVSVIVTVTWEVIVMVIVMABUIVFEHULRUJZSZWH
    VIVOWDVGVONDVHVGVOVGVOUKUMAUNUOVBUPVIVPVIVPABEVFEMUQRURZSUSUTVIWCWAWFKLVIWA
    WCVIVTWHOVCABVAQVIVTVNWEVRIVIVMWGTVIWDVQVOFVIVPWITPQVDVE $.

  $( "Double-angle formula" for Y-values.  Equation 2.14 of [JonesMatijasevic]
     p. 695.  (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
  rmydbl $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmY ( 2 x. N ) ) = ( (
      2 x. ( A rmX N ) ) x. ( A rmY N ) ) ) $=
    ( c2 cuz cfv wcel cz wa cmul crmy caddc crmx zcn adantl 2timesd oveq2d wceq
    co cc fovcl rmyadd 3anidm23 2cn a1i frmx nn0cnd frmy mulassd mulcld mulcomd
    cn0 zcnd oveq1d 3eqtrrd 3eqtrd ) ACDEZFZBGFZHZACBIRZJRABBKRZJRZABJRZABLRZIR
    ZVDVCIRZKRZCVDIRVCIRZUSUTVAAJUSBURBSFUQBMNOPUQURVBVGQABBUAUBUSVHCVFIRVFVFKR
    VGUSCVDVCCSFUSUCUDUSVDABUKUPGLUETUFZUSVCABGUPGJUGTULZUHUSVFUSVDVCVIVJUIOUSV
    FVEVFKUSVDVCVIVJUJUMUNUO $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Ordering and induction lemmas for the integers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a b x y $.  $d B a b x y $.  $d C a b c d y $.  $d D a x y $.
    $d E a x y $.  $d F b x $.  $d G b x $.  $d H a b c d x y $.
    $d ph a b c d x y $.
    monotuz.1 $e |- ( ( ph /\ y e. H ) -> F < G ) $.
    monotuz.2 $e |- ( ( ph /\ x e. H ) -> C e. RR ) $.
    monotuz.3 $e |- H = ( ZZ>= ` I ) $.
    monotuz.4 $e |- ( x = ( y + 1 ) -> C = G ) $.
    monotuz.5 $e |- ( x = y -> C = F ) $.
    monotuz.6 $e |- ( x = A -> C = D ) $.
    monotuz.7 $e |- ( x = B -> C = E ) $.
    $( A function defined on a set of upper integers which increases at every
       adjacent pair is globally strictly monotonic by induction.  (Contributed
       by Stefan O'Rear, 24-Sep-2014.) $)
    monotuz $p |- ( ( ph /\ ( A e. H /\ B e. H ) ) -> ( A < B <-> D < E ) ) $=
      ( wcel va vb vc vd wa clt wbr csb cv csbeq1 cuz cr cz uzssz zssre eqsstri
      cfv sstri wi nfv nfcsb1v nfel1 nfim weq eleq1 anbi2d csbeq1a eleq1d chvar
      imbi12d simpl adantlrr simplrl sseldi simplrr simpr c1 wceq breq2d imbi2d
      caddc co vex nfcv csbief syl5eqr ovex csbeq1d breq12d vtoclg w3a 3ad2ant2
      oveq1 simp2l cle zre 3ad2ant1 simp3 ltled wb simp11 simp12 syl2anc mpbird
      eluz simp2r syl6eleq uztrn syl6eleqr peano2uz syl vtoclf lttrd a2d uzind2
      3exp syl3anc mpd ex ltord1 nfcvd csbiegf breqan12d adantl bitrd ) ADKTZEK
      TZUEZUEDEUFUGBDFUHZBEFUHZUFUGZGHUFUGZAUAUBBUAUIZFUHZBUBUIZFUHZDEKYIYJBYMY
      OFUJBYMDFUJBYMEFUJKLUKUQZULOYQUMULLUNZUOURUPABUIZKTZUEZFULTZUSZAYMKTZUEZY
      NULTZUSBUAUUEUUFBUUEBUTBYNULBYMFVAVBVCBUAVDZUUAUUEUUBUUFUUGYTUUDAYSYMKVEV
      FUUGFYNULBYMFVGVHVJNVIZAUUDYOKTZUEUEZYMYOUFUGZYNYPUFUGZUUJUUKUEZUUEUULAUU
      DUUKUUEUUIUUEUUKVKVLUUMYMUMTZYOUMTUUKUUEUULUSZUUMKUMYMKYQUMOYRUPZAUUDUUIU
      UKVMVNUUMKUMYOUUPAUUDUUIUUKVOVNUUJUUKVPUUEYNBUCUIZFUHZUFUGZUSUUEYNBYMVQWA
      WBZFUHZUFUGZUSZUUEYNBUDUIZFUHZUFUGZUSUUEYNBUVDVQWAWBZFUHZUFUGZUSUUOUCUDYM
      YOUUQUUTVRZUUSUVBUUEUVJUURUVAYNUFBUUQUUTFUJVSVTUCUDVDZUUSUVFUUEUVKUURUVEY
      NUFBUUQUVDFUJVSVTUUQUVGVRZUUSUVIUUEUVLUURUVHYNUFBUUQUVGFUJVSVTUCUBVDZUUSU
      ULUUEUVMUURYPYNUFBUUQYOFUJVSVTACUIZKTZUEZIJUFUGZUSZUVCCYMUMCUAVDZUVPUUEUV
      QUVBUVSUVOUUDAUVNYMKVEVFUVSIYNJUVAUFUVSIBUVNFUHZYNBUVNFICWCBIWDQWEZBUVNYM
      FUJWFUVSJBUVNVQWAWBZFUHZUVABUWBFJUVNVQWAWGBJWDPWEZUVSBUWBUUTFUVNYMVQWAWMW
      HWFWIVJMWJUUNUVDUMTZYMUVDUFUGZWKZUUEUVFUVIUWGUUEUVFUVIUWGUUEUVFWKZYNUVEUV
      HUUEUWGUUFUVFUUHWLUWHAUVDKTZUVEULTZUWGAUUDUVFWNZUWHUVDYQKUWHUVDYMUKUQTZYM
      YQTUVDYQTZUWHUWLYMUVDWOUGZUWGUUEUWNUVFUWGYMUVDUUNUWEYMULTUWFYMWPWQUWEUUNU
      VDULTUWFUVDWPWLUUNUWEUWFWRWSWQUWHUUNUWEUWLUWNWTUUNUWEUWFUUEUVFXAUUNUWEUWF
      UUEUVFXBYMUVDXEXCXDUWHYMKYQUWGAUUDUVFXFOXGYMUVDLXHXCZOXIZUUCAUWIUEZUWJUSB
      UDUWQUWJBUWQBUTBUVEULBUVDFVAVBVCBUDVDZUUAUWQUUBUWJUWRYTUWIAYSUVDKVEVFUWRF
      UVEULBUVDFVGVHVJNVIXCUWHAUVGKTZUVHULTZUWKUWHUVGYQKUWHUWMUVGYQTUWOLUVDXJXK
      OXIUUCAUWSUEZUWTUSBUVGUXAUWTBUXABUTBUVHULBUVGFVAVBVCUVDVQWAWGYSUVGVRZUUAU
      XAUUBUWTUXBYTUWSAYSUVGKVEVFUXBFUVHULBUVGFVGVHVJNXLXCUWGUUEUVFWRUWHAUWIUVE
      UVHUFUGZUWKUWPUVRUWQUXCUSZCUDUXDCUTCUDVDZUVPUWQUVQUXCUXEUVOUWIAUVNUVDKVEV
      FUXEIUVEJUVHUFUXEIUVTUVEUWABUVNUVDFUJWFUXEJUWCUVHUWDUXEBUWBUVGFUVNUVDVQWA
      WMWHWFWIVJMVIXCXMXPXNXOXQXRXSXTYHYKYLWTAYFYGYIGYJHUFBDFGKYFBGYARYBBEFHKYG
      BHYASYBYCYDYE $.
  $}

  ${
    $d ph a b x y $.  $d A a b x y $.  $d B a b x y $.  $d F a b x y $.
    monotoddzzfi.1 $e |- ( ( ph /\ x e. ZZ ) -> ( F ` x ) e. RR ) $.
    monotoddzzfi.2 $e |- ( ( ph /\ x e. ZZ ) -> ( F ` -u x ) = -u ( F ` x ) )
        $.
    monotoddzzfi.3 $e |- ( ( ph /\ x e. NN0 /\ y e. NN0 ) -> ( x < y -> ( F ` x
        ) < ( F ` y ) ) ) $.
    $( A function which is odd and monotonic on ` NN0 ` is monotonic on
       ` ZZ ` .  This proof is far too long.  (Contributed by Stefan O'Rear,
       25-Sep-2014.) $)
    monotoddzzfi $p |- ( ( ph /\ A e. ZZ /\ B e. ZZ ) -> ( A < B <-> ( F ` A )
        < ( F ` B ) ) ) $=
      ( cz wcel clt wbr wa cr wi eleq1d imbi12d cn0 cc0 va vb wb cv fveq2 zssre
      cfv weq eleq1 anbi2d chvarv cn cneg wo elznn simprbi anim12i adantl nnnn0
      simpll ad2antrl ad2antll w3a simpl simpr 3anbi23d breq12 breqan12d vtocl2
      vex syl3anc ex adantrr adantr 0re a1i adantrl cle wceq znegcl negex vtocl
      syldan ad2antrr c0ex mpan2 recnd neg0 fveq2i negeq fveq2d eqeq12d syl5eqr
      negeqd eqnegad nngt0 simplll 0nn0 simplrl breq12d mpd eqbrtrrd ltled 0le0
      0z syl5breqr breq2d mpbird elnn0 biimpi mpjaodan breqtrd le0neg1d lelttrd
      a1d simp3 wn zre ad2antlr 1re nnre nn0ge0 0le1 letrd nnge1 lenltd 3adant3
      c1 mpbid pm2.21dd 3exp 3com23 adantlr sylibd ltnegd 3imtr4d ccased ltord1
      3expb 3impb ) ADJKEJKDELMDFUGZEFUGZLMUCAUAUBUAUDZFUGZUBUDZFUGZDEJUUAUUBUU
      CUUEFUEUUCDFUEUUCEFUEUFABUDZJKZNZUUGFUGZOKZPZAUUCJKZNZUUDOKZPBUABUAUHZUUI
      UUNUUKUUOUUPUUHUUMAUUGUUCJUIUJZUUPUUJUUDOUUGUUCFUEZQRGUKZAUUMUUEJKZNZNZUU
      CULKZUUCUMZSKZUNZUUEULKZUUEUMZSKZUNZNZUUCUUELMZUUDUUFLMZPZUVAUVKAUUMUVFUU
      TUVJUUMUUCOKZUVFUUCUOUPUUTUUEOKZUVJUUEUOUPUQURUVBUVCUVGUVEUVIUVNUVBUVCUVG
      NZUVNUVBUVQNAUUCSKZUUESKZUVNAUVAUVQUTUVCUVRUVBUVGUUCUSVAUVGUVSUVBUVCUUEUS
      ZVBAUUGSKZCUDZSKZVCZUUGUWBLMZUUJUWBFUGZLMZPZPZAUVRUVSVCZUVNPBCUUCUUEUAVJU
      BVJZUUPCUBUHZNZUWDUWJUWHUVNUWMUWAUVRUWCUVSAUWMUUGUUCSUUPUWLVDQUWMUWBUUESU
      UPUWLVEQVFUWMUWEUVLUWGUVMUUGUUCUWBUUELVGUUPUWLUUJUUDUWFUUFLUURUWBUUEFUEZV
      HRRIVIVKVLUVBUVEUVGNZUVNUVBUWONZUVMUVLUWPUUDTUUFUVBUUOUWOAUUMUUOUUTUUSVMZ
      VNZTOKZUWPVOVPUVBUUFOKZUWOAUUTUWTUUMUULAUUTNZUWTPBUBBUBUHZUUIUXAUUKUWTUXB
      UUHUUTAUUGUUEJUIUJZUXBUUJUUFOUUGUUEFUEZQRGUKVQZVNUWPUUDTVRMTUUDUMZVRMUWPT
      UVDFUGZUXFVRUWPUVDULKZTUXGVRMZUVDTVSZUWPUXHNZTUXGUWSUXKVOVPUVBUXGOKZUWOUX
      HAUVAUVDJKZUXLUUMUXMAUUTUUCVTVAUULAUXMNZUXLPBUVDUUCWAZUUGUVDVSZUUIUXNUUKU
      XLUXPUUHUXMAUUGUVDJUIUJUXPUUJUXGOUUGUVDFUEQRGWBWCWDUXKTFUGZTUXGLUVBUXQTVS
      ZUWOUXHAUXRUVAAUXQAUXQATJKZUXQOKZXEUULAUXSNZUXTPBTWEUUGTVSZUUIUYAUUKUXTUY
      BUUHUXSAUUGTJUIUJZUYBUUJUXQOUUGTFUEZQRGWBWFWGAUXQTUMZFUGZUXQUMZUYETFWHWIA
      UXSUYFUYGVSZXEUUIUUGUMZFUGZUUJUMZVSZPZUYAUYHPBTWEUYBUUIUYAUYLUYHUYCUYBUYJ
      UYFUYKUYGUYBUYIUYEFUUGTWJWKUYBUUJUXQUYDWNWLRHWBWFWMWOVNZWDUXKTUVDLMZUXQUX
      GLMZUXHUYOUWPUVDWPURUXKATSKZUVEUYOUYPPZAUVAUWOUXHWQUYQUXKWRVPUVBUVEUVGUXH
      WSUWIAUYQUVEVCZUYRPBCTUVDWEUXOUYBUWBUVDVSZNZUWDUYSUWHUYRVUAUWAUYQUWCUVEAV
      UAUUGTSUYBUYTVDZQVUAUWBUVDSUYBUYTVEZQVFVUAUWEUYOUWGUYPUUGTUWBUVDLVGVUAUUJ
      UXQUWFUXGLVUAUUGTFVUBWKVUAUWBUVDFVUCWKWTRRIVIVKXAXBXCUWPUXJNZUXITUXQVRMZV
      UDTTUXQVRXDUVBUXRUWOUXJUYNWDXFUXJUXIVUEUCUWPUXJUXGUXQTVRUVDTFUEXGURXHUVEU
      XHUXJUNZUVBUVGUVEVUFUVDXIXJVAXKUVBUXGUXFVSZUWOAUUMVUGUUTUYMUUNVUGPBUAUUPU
      UIUUNUYLVUGUUQUUPUYJUXGUYKUXFUUPUYIUVDFUUGUUCWJWKUUPUUJUUDUURWNWLRHUKVMZV
      NXLUWPUUDUWRXMXHUWPUXQTUUFLUVBUXRUWOUYNVNUWPTUUELMZUXQUUFLMZUVGVUIUVBUVEU
      UEWPVBUWPAUYQUVSVUIVUJPZAUVAUWOUTUYQUWPWRVPUVGUVSUVBUVEUVTVBUWIAUYQUVSVCZ
      VUKPBCTUUEWEUWKUYBUWLNZUWDVULUWHVUKVUMUWAUYQUWCUVSAVUMUUGTSUYBUWLVDQVUMUW
      BUUESUYBUWLVEQVFVUMUWEVUIUWGVUJUUGTUWBUUELVGUYBUWLUUJUXQUWFUUFLUYDUWNVHRR
      IVIVKXAXBXNXOVLUVBUVCUVINZUVLUVMUVBVUNUVLVCUVLUVMUVBVUNUVLXPUVBVUNUVLXQZU
      VLUVBVUNNZUUEUUCVRMVUOVUPUUEYHUUCUVAUVPAVUNUUTUVPUUMUUEXRURZXSZYHOKVUPXTV
      PZUVCUVOUVBUVIUUCYAVAZVUPUUETYHVURUWSVUPVOVPVUSVUPUUETVRMTUVHVRMZUVIVVAUV
      BUVCUVHYBVBVUPUUEVURXMXHTYHVRMVUPYCVPYDUVCYHUUCVRMUVBUVIUUCYEVAYDVUPUUEUU
      CVURVUTYFYIYGYJYKUVBUVEUVINZUVNUVBVVBNZUVHUVDLMZUUFUMZUXFLMZUVLUVMVVCVVDU
      VHFUGZUXGLMZVVFAVVBVVDVVHPZUVAAUVEUVIVVIAUVIUVEVVIUWIAUVIUVEVCZVVIPBCUVHU
      VDUUEWAUXOUUGUVHVSZUYTNZUWDVVJUWHVVIVVLUWAUVIUWCUVEAVVLUUGUVHSVVKUYTVDQVV
      LUWBUVDSVVKUYTVEQVFVVLUWEVVDUWGVVHUUGUVHUWBUVDLVGVVKUYTUUJVVGUWFUXGLUUGUV
      HFUEUWBUVDFUEVHRRIVIYLYSYMVVCVVGVVEUXGUXFLUVBVVGVVEVSZVVBAUUTVVMUUMUYMUXA
      VVMPBUBUXBUUIUXAUYLVVMUXCUXBUYJVVGUYKVVEUXBUYIUVHFUUGUUEWJWKUXBUUJUUFUXDW
      NWLRHUKVQVNUVBVUGVVBVUHVNWTYNVVCUUCUUEUVBUVOVVBUUMUVOAUUTUUCXRVAVNUVAUVPA
      VVBVUQXSYOVVCUUDUUFUVBUUOVVBUWQVNUVBUWTVVBUXEVNYOYPVLYQXAYRYT $.
  $}

  ${
    $d ph a b x y $.  $d A a b x y $.  $d B a b x y $.  $d E a b y $.
    $d C a b x y $.  $d D a b x y $.  $d F a b x $.  $d G a b x $.
    monotoddzz.1 $e |- ( ( ph /\ x e. NN0 /\ y e. NN0 ) -> ( x < y -> E < F ) )
        $.
    monotoddzz.2 $e |- ( ( ph /\ x e. ZZ ) -> E e. RR ) $.
    monotoddzz.3 $e |- ( ( ph /\ y e. ZZ ) -> G = -u F ) $.
    monotoddzz.4 $e |- ( x = A -> E = C ) $.
    monotoddzz.5 $e |- ( x = B -> E = D ) $.
    monotoddzz.6 $e |- ( x = y -> E = F ) $.
    monotoddzz.7 $e |- ( x = -u y -> E = G ) $.
    $( A function (given implicitly) which is odd and monotonic on ` NN0 ` is
       monotonic on ` ZZ ` .  This proof is far too long.  (Contributed by
       Stefan O'Rear, 25-Sep-2014.) $)
    monotoddzz $p |- ( ( ph /\ A e. ZZ /\ B e. ZZ ) -> ( A < B <-> C < D ) ) $=
      ( cz clt cr va vb wcel w3a wbr cmpt cfv cv wa wi nffvmpt1 nfel1 nfim wceq
      eleq1 anbi2d fveq2 eleq1d imbi12d simpr eqid fvmpt2 syl2anc eqeltrd chvar
      cneg negeq fveq2d negeqd eqeq12d znegcl adantl negex sylan2 fvmptg chvarv
      nfv vtocl 3eqtr4d cn0 nfcv nfbr 3anbi2d breq1 breq1d 3anbi3d breq2 breq2d
      nn0z 3adant3 nfeq1 3adant2 breq12d sylibrd monotoddzzfi simp2 simp3 bitrd
      vtoclg anabsi7 ) ADRUCZERUCZUDZDESUEDBRHUFZUGZEXDUGZSUEFGSUEAUAUBDEXDABUH
      ZRUCZUIZXGXDUGZTUCZUJAUAUHZRUCZUIZXLXDUGZTUCZUJBUAXNXPBXNBVQBXOTBRHXLUKZU
      LUMXGXLUNZXIXNXKXPXRXHXMAXGXLRUOUPXRXJXOTXGXLXDUQZURUSXIXJHTXIXHHTUCZXJHU
      NZAXHUTLBRHTXDXDVAZVBVCZLVDVEACUHZRUCZUIZYDVFZXDUGZYDXDUGZVFZUNZUJXNXLVFZ
      XDUGZXOVFZUNZUJCUAYDXLUNZYFXNYKYOYPYEXMAYDXLRUOUPYPYHYMYJYNYPYGYLXDYDXLVG
      VHYPYIXOYDXLXDUQVIVJUSYFJIVFYHYJMYFYGRUCZJTUCZYHJUNYEYQAYDVKZVLYEAYQYRYSX
      IXTUJZAYQUIZYRUJBYGYDVMXGYGUNZXIUUAXTYRUUBXHYQAXGYGRUOUPUUBHJTQURUSLVRVNB
      YGHJRTXDQYBVOVCYFYIIYFYEITUCZYIIUNZAYEUTYTYFUUCUJBCXGYDUNZXIYFXTUUCUUEXHY
      EAXGYDRUOUPUUEHITPURUSLVPBYDHIRTXDPYBVOVCVIVSVPAXGVTUCZUBUHZVTUCZUDZXGUUG
      SUEZXJUUGXDUGZSUEZUJZUJZAXLVTUCZUUHUDZXLUUGSUEZXOUUKSUEZUJZUJBUAUUPUUSBUU
      PBVQUUQUURBUUQBVQBXOUUKSXQBSWABRHUUGUKWBUMUMXRUUIUUPUUMUUSXRUUFUUOAUUHXGX
      LVTUOWCXRUUJUUQUULUURXGXLUUGSWDXRXJXOUUKSXSWEUSUSAUUFYDVTUCZUDZXGYDSUEZXJ
      YISUEZUJZUJUUNCUBYDUUGUNZUVAUUIUVDUUMUVEUUTUUHAUUFYDUUGVTUOWFUVEUVBUUJUVC
      UULYDUUGXGSWGUVEYIUUKXJSYDUUGXDUQWHUSUSUVAUVBHISUEUVCKUVAXJHYIISAUUFYAUUT
      UUFAXHYAXGWIYCVNZWJAUUTUUDUUFAUUFUIZYAUJAUUTUIZUUDUJBCUVHUUDBUVHBVQBYIIBR
      HYDUKWKUMUUEUVGUVHYAUUDUUEUUFUUTAXGYDVTUOUPUUEXJYIHIXGYDXDUQPVJUSUVFVEWLW
      MWNVPVEWOXCXEFXFGSXCXAFTUCZXEFUNAXAXBWPAXAUVIXBAXAUVIYTAXAUIZUVIUJBDRXGDU
      NZXIUVJXTUVIUVKXHXAAXGDRUOUPUVKHFTNURUSLWSWTWJBDHFRTXDNYBVOVCXCXBGTUCZXFG
      UNAXAXBWQAXBUVLXAAXBUVLYTAXBUIZUVLUJBERXGEUNZXIUVMXTUVLUVNXHXBAXGERUOUPUV
      NHGTOURUSLWSWTWLBEHGRTXDOYBVOVCWMWR $.
  $}

  ${
    $d B a b x $.  $d C a b x $.  $d D a b x y $.  $d E a b x $.  $d F a b x $.
    $d A a b y $.  $d ph a b x y $.
    oddcomabszz.1 $e |- ( ( ph /\ x e. ZZ ) -> A e. RR ) $.
    oddcomabszz.2 $e |- ( ( ph /\ x e. ZZ /\ 0 <_ x ) -> 0 <_ A ) $.
    oddcomabszz.3 $e |- ( ( ph /\ y e. ZZ ) -> C = -u B ) $.
    oddcomabszz.4 $e |- ( x = y -> A = B ) $.
    oddcomabszz.5 $e |- ( x = -u y -> A = C ) $.
    oddcomabszz.6 $e |- ( x = D -> A = E ) $.
    oddcomabszz.7 $e |- ( x = ( abs ` D ) -> A = F ) $.
    $( An odd function which takes nonnegative values on nonnegative arguments
       commutes with ` abs ` .  (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
    oddcomabszz $p |- ( ( ph /\ D e. ZZ ) -> ( abs ` E ) = F ) $=
      ( cz wceq cc0 cle va wcel wa csb cabs cfv cv wi eleq1 anbi2d csbeq1 fveq2
      fveq2d csbeq1d eqeq12d imbi12d wbr cr nfv nfcsb1v nfel1 nfim eleq1d chvar
      csbeq1a adantr w3a nfcv nfbr breq2 3anbi23d breq2d 3expa absidd zre absid
      ad2antlr sylancom eqtr4d cneg negex csbief negeq vex negeqd absnid znegcl
      syl5eqr vtoclf 3expia sylan2 sylibd le0neg1d 3imtr4d imp absnidd 3eqtr4rd
      adantl wo 0re letric sylancr mpjaodan vtoclg anabsi7 csbiegf fvex 3eqtr3d
      nfcvd a1i ) AGQUBZUCZBGDUDZUEUFZBGUEUFZDUDZHUEUFZIAXKXNXPRZAUAUGZQUBZUCZB
      XSDUDZUEUFZBXSUEUFZDUDZRZUHXLXRUHUAGQXSGRZYAXLYFXRYGXTXKAXSGQUIUJYGYCXNYE
      XPYGYBXMUEBXSGDUKUMYGBYDXODXSGUEULUNUOUPYASXSTUQZYFXSSTUQZYAYHUCZYCYBYEYJ
      YBYAYBURUBZYHABUGZQUBZUCZDURUBZUHYAYKUHBUAYAYKBYABUSBYBURBXSDUTZVAVBYLXSR
      ZYNYAYOYKYQYMXTAYLXSQUIZUJYQDYBURBXSDVEZVCUPJVDZVFAXTYHSYBTUQZAYMSYLTUQZV
      GZSDTUQZUHZAXTYHVGZUUAUHBUAUUFUUABUUFBUSBSYBTBSVHZBTVHZYPVIVBYQUUCUUFUUDU
      UAYQYMXTUUBYHAYRYLXSSTVJVKYQDYBSTYSVLUPKVDVMVNYJBYDXSDYAYHXSURUBZYDXSRXTU
      UIAYHXSVOZVQXSVPVRUNVSYAYIUCZBXSVTZDUDZYBVTZYEYCYAUUMUUNRZYIACUGZQUBZUCZF
      EVTZRZUHYAUUOUHZCUAUVACUSUUPXSRZUURYAUUTUUOUVBUUQXTAUUPXSQUIUJUVBFUUMUUSU
      UNUVBFBUUPVTZDUDUUMBUVCDFUUPWABFVHNWBUVBBUVCUULDUUPXSWCUNWHUVBEYBUVBEBUUP
      DUDYBBUUPDECWDBEVHMWBBUUPXSDUKWHWEUOUPLVDZVFUUKBYDUULDYAYIUUIYDUULRXTUUIA
      YIUUJVQXSWFVRUNUUKYBYAYKYIYTVFYAYIYBSTUQZYASUULTUQZSUUNTUQZYIUVEYAUVFSUUM
      TUQZUVGXTAUULQUBZUVFUVHUHXSWGAUVIUVFUVHUUEAUVIUVFVGZUVHUHBUULUVJUVHBUVJBU
      SBSUUMTUUGUUHBUULDUTVIVBXSWAYLUULRZUUCUVJUUDUVHUVKYMUVIUUBUVFAYLUULQUIYLU
      ULSTVJVKUVKDUUMSTBUULDVEVLUPKWIWJWKYAUUMUUNSTUVDVLWLYAXSXTUUIAUUJWRWMYAYB
      YTWMWNWOWPWQXTYHYIWSZAXTSURUBUUIUVLWTUUJSXSXAXBWRXCXDXEXKXNXQRAXKXMHUEBGD
      HQXKBHXIOXFUMWRXPIRXLBXODIGUEXGBIVHPWBXJXH $.
  $}

  ${
    $d a b c x y $.  $d a b c x A $.  $d ps a b c x $.  $d ch a b c x $.
    $d th a b c x $.  $d ta a b c x $.  $d et a b c x $.  $d rh a b c x $.
    $d ph a b c y $.
    2nn0ind.1 $e |- ps $.
    2nn0ind.2 $e |- ch $.
    2nn0ind.3 $e |- ( y e. NN -> ( ( th /\ ta ) -> et ) ) $.
    2nn0ind.4 $e |- ( x = 0 -> ( ph <-> ps ) ) $.
    2nn0ind.5 $e |- ( x = 1 -> ( ph <-> ch ) ) $.
    2nn0ind.6 $e |- ( x = ( y - 1 ) -> ( ph <-> th ) ) $.
    2nn0ind.7 $e |- ( x = y -> ( ph <-> ta ) ) $.
    2nn0ind.8 $e |- ( x = ( y + 1 ) -> ( ph <-> et ) ) $.
    2nn0ind.9 $e |- ( x = A -> ( ph <-> rh ) ) $.
    $( Induction on natural numbers with two base cases, for use with
       Lucas-type sequences.  (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
    2nn0ind $p |- ( A e. NN0 -> rh ) $=
      ( c1 va cn0 wcel wsbc caddc co cmin wa cn nn0p1nn cv wceq wb oveq1 dfsbcq
      syl anbi12d weq ovex cc0 1m1e0 eqeq2i sylbi sbcie mpbir 1ex pm3.2i simprr
      cc nncn ax-1cn pncan sylancl adantr mpbird vex anbi12i 3imtr4g imp jca ex
      nnind nn0cn biimpa adantrr mpdan sbcieg mpbid ) JUBUCZAHJUDZGWIAHJTUEUFZT
      UGUFZUDZAHWKUDZUHZWJWIWKUIUCWOJUJAHUAUKZTUGUFZUDZAHWPUDZUHAHTTUGUFZUDZAHT
      UDZUHAHIUKZTUGUFZUDZAHXCUDZUHZAHXCTUEUFZTUGUFZUDZAHXHUDZUHZWOUAIWKWPTULZW
      RXAWSXBXMWQWTULWRXAUMWPTTUGUNAHWQWTUOUPAHWPTUOUQUAIURZWRXEWSXFXNWQXDULWRX
      EUMWPXCTUGUNAHWQXDUOUPAHWPXCUOUQWPXHULZWRXJWSXKXOWQXIULWRXJUMWPXHTUGUNAHW
      QXIUOUPAHWPXHUOUQWPWKULZWRWMWSWNXPWQWLULWRWMUMWPWKTUGUNAHWQWLUOUPAHWPWKUO
      UQXAXBXABKABHWTTTUGUSHUKZWTULXQUTULABUMWTUTXQVAVBNVCVDVEXBCLACHTVFOVDVEVG
      XCUIUCZXGXLXRXGUHZXJXKXSXJXFXRXEXFVHXSXIXCULZXJXFUMXRXTXGXRXCVIUCTVIUCZXT
      XCVJVKXCTVLVMVNAHXIXCUOUPVOXRXGXKXRDEUHFXGXKMXEDXFEADHXDXCTUGUSPVDAEHXCIV
      PQVDVQAFHXHXCTUEUSRVDVRVSVTWAWBUPWIWMWJWNWIWMWJWIWLJULZWMWJUMWIJVIUCYAYBJ
      WCVKJTVLVMAHWLJUOUPWDWEWFAGHJUBSWGWH $.
  $}

  ${
    $d ph a b y $.  $d A a b x y $.  $d ps a b x $.  $d ch a b x $.
    $d th a b x $.  $d ta a b x $.
    zindbi.1 $e |- ( y e. ZZ -> ( ps <-> ch ) ) $.
    zindbi.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    zindbi.3 $e |- ( x = ( y + 1 ) -> ( ph <-> ch ) ) $.
    zindbi.4 $e |- ( x = 0 -> ( ph <-> th ) ) $.
    zindbi.5 $e |- ( x = A -> ( ph <-> ta ) ) $.
    $( Inductively transfer a property to the integers if it holds for zero and
       passes between adjacent integers in either direction.  (Contributed by
       Stefan O'Rear, 1-Oct-2014.) $)
    zindbi $p |- ( A e. ZZ -> ( th <-> ta ) ) $=
      ( vb cz wsbc cc0 cle wb dfsbcq va wcel c0ex sbcie wbr 0z wi cv wceq eleq1
      w3a breq1 3anbi13d bibi1d imbi12d breq2 3anbi23d bibi2d c1 caddc co biidd
      weq vex syl5bbr oveq1 syl bibi12d vtoclga 3ad2ant2 biimpd vtocl2g 3adant3
      ovex uzind pm2.43i mp3an1 wa mp3an2 bicomd cr wo 0re zre sylancr mpjaodan
      letric sbcieg bitrd ) HOUBZDAFHPZEDAFQPZWJWKADFQUCLUDWJQHRUEZWLWKSZHQRUEZ
      QOUBZWJWMWNUFWPWJWMUKZWNWPWJWQWNUGZWMGUHZOUBZNUHZOUBZWSXARUEZUKZAFWSPZAFX
      APZSZUGZWPXBQXARUEZUKZWLXFSZUGWRGNQHOOWSQUIZXDXJXGXKXLWTWPXCXIXBWSQOUJWSQ
      XARULUMXLXEWLXFAFWSQTUNUOXAHUIZXJWQXKWNXMXBWJXIWMWPXAHOUJXAHQRUPUQXMXFWKW
      LAFXAHTURUOXEAFUAUHZPZSXEXESXGXEAFXAUSUTVAZPZSZXGUANWSXAUAGVCXOXEXEAFXNWS
      TURUANVCXOXFXEAFXNXATURZXNXPUIXOXQXEAFXNXPTURXSWTXEVBXDXGXRXDXFXQXEXBWTXF
      XQSZXCBCSXTGXAOGNVCZBXFCXQBXEYAXFABFWSGVDJUDAFWSXATVECAFWSUSUTVAZPZYAXQAC
      FYBWSUSUTVNKUDYAYBXPUIYCXQSWSXAUSUTVFAFYBXPTVGVEVHIVIVJURVKVOZVLVMVPVQWJW
      OVRWKWLWJWPWOWKWLSZUFWJWPWOUKZYEWJWPYFYEUGZWOXHWJXBHXARUEZUKZWKXFSZUGYGGN
      HQOOWSHUIZXDYIXGYJYKWTWJXCYHXBWSHOUJWSHXARULUMYKXEWKXFAFWSHTUNUOXAQUIZYIY
      FYJYEYLXBWPYHWOWJXAQOUJXAQHRUPUQYLXFWLWKAFXAQTURUOYDVLVMVPVSVTWJQWAUBHWAU
      BWMWOWBWCHWDQHWGWEWFVEAEFHOMWHWI $.
  $}

  ${
    $d A a b $.  $d B a b $.  $d N a b $.

    $( Mantissa ordering relationship for exponentiation.  (Contributed by
       Stefan O'Rear, 16-Oct-2014.) $)
    expmordi $p |- ( ( ( A e. RR /\ B e. RR ) /\ ( 0 <_ A /\ A < B ) /\
        N e. NN ) -> ( A ^ N ) < ( B ^ N ) ) $=
      ( va vb cr wcel wa cc0 cle wbr clt cexp co wi wceq oveq2 breq12d imbi2d
      c1 cn cv caddc weq cc recn exp1 breqan12d syl2an biimpar adantrl w3a cmul
      wb simp2ll cn0 nnnn0 3ad2ant1 reexpcld simp2lr jca simp2rl expge0d simp2l
      simp3 simp2r ltmul12a syl22anc recnd expp1d 3brtr4d 3exp a2d nnind impcom
      3impa ) AFGZBFGZHZIAJKZABLKZHZCUAGZACMNZBCMNZLKZWCVSWBHZWFWGADUBZMNZBWHMN
      ZLKZOWGATMNZBTMNZLKZOWGAEUBZMNZBWOMNZLKZOWGAWOTUCNZMNZBWSMNZLKZOWGWFODECW
      HTPZWKWNWGXCWIWLWJWMLWHTAMQWHTBMQRSDEUDZWKWRWGXDWIWPWJWQLWHWOAMQWHWOBMQRS
      WHWSPZWKXBWGXEWIWTWJXALWHWSAMQWHWSBMQRSWHCPZWKWFWGXFWIWDWJWELWHCAMQWHCBMQ
      RSVSWAWNVTVSWNWAVQAUEGZBUEGZWNWAUNVRAUFBUFXGXHWLAWMBLAUGBUGUHUIUJUKWOUAGZ
      WGWRXBXIWGWRXBXIWGWRULZWPAUMNZWQBUMNZWTXALXJWPFGZWQFGZHIWPJKZWRHVSWBXKXLL
      KXJXMXNXJAWOVQVRWBXIWRUOZXIWGWOUPGWRWOUQURZUSXJBWOVQVRWBXIWRUTZXQUSVAXJXO
      WRXJAWOXPXQVTWAVSXIWRVBVCXIWGWRVEVAXIVSWBWRVDXIVSWBWRVFWPWQABVGVHXJAWOXJA
      XPVIXQVJXJBWOXJBXRVIXQVJVKVLVMVNVOVP $.

    $( Mantissa ordering relationship for exponentiation of positive reals.
       (Contributed by Stefan O'Rear, 16-Oct-2014.) $)
    rpexpmord $p |- ( ( N e. NN /\ A e. RR+ /\ B e. RR+ ) -> ( A < B <->
        ( A ^ N ) < ( B ^ N ) ) ) $=
      ( va vb cn wcel crp clt wbr cexp co wb cv oveq1 rpssre cr cn0 wa rpred ex
      rpre nnnn0 reexpcl syl2anr cc0 cle simplrl simplrr rpge0d simpll expmordi
      simpr syl221anc ltord1 3impb ) CFGZAHGBHGABIJACKLZBCKLZIJMUQDEDNZCKLZENZC
      KLZABHURUSUTVBCKOUTACKOUTBCKOPUTHGZUTQGZCRGVAQGUQUTUBCUCUTCUDUEUQVDVBHGZS
      ZSZUTVBIJZVAVCIJZVHVISZVEVBQGUFUTUGJVIUQVJVKUTUQVDVFVIUHZTVKVBUQVDVFVIUIT
      VKUTVLUJVHVIUMUQVGVIUKUTVBCULUNUAUOUP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    X and Y sequences 2: Order properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b A $.  $d a b N $.
    $( For all nonnegative indices, X is positive and Y is nonnegative.
       (Contributed by Stefan O'Rear, 24-Sep-2014.) $)
    rmxypos $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 ) -> ( 0 < ( A rmX N ) /\ 0
        <_ ( A rmY N ) ) ) $=
      ( cn0 wcel c2 cc0 crmx co clt wbr crmy wa wi wceq oveq2 breq2d anbi12d cz
      cle 3ad2ant2 va vb cuz cfv cv c1 imbi2d weq 0lt1 rmx0 syl5breqr 0le0 rmy0
      caddc jca cmul cexp cmin cr simp2 nn0z 3ad2ant1 frmx fovcl syl2anc nn0red
      w3a eluzelre remulcld rmspecpos rpred frmy zred simp3l wss uznnssnn ax-mp
      cn 2nn sseli nngt0d mulgt0d rpge0d simp3r mulge0d addgtge0 syl22anc rmxp1
      breqtrrd 2nn0 eluznn0 mpan nn0ge0d addge0d rmyp1 3exp a2d nn0ind impcom )
      BCDAEUCUDZDZFABGHZIJZFABKHZSJZLZXAFAUAUEZGHZIJZFAXGKHZSJZLZMXAFAFGHZIJZFA
      FKHZSJZLZMXAFAUBUEZGHZIJZFAXRKHZSJZLZMXAFAXRUFUNHZGHZIJZFAYDKHZSJZLZMXAXF
      MUAUBBXGFNZXLXQXAYJXIXNXKXPYJXHXMFIXGFAGOPYJXJXOFSXGFAKOPQUGUAUBUHZXLYCXA
      YKXIXTXKYBYKXHXSFIXGXRAGOPYKXJYAFSXGXRAKOPQUGXGYDNZXLYIXAYLXIYFXKYHYLXHYE
      FIXGYDAGOPYLXJYGFSXGYDAKOPQUGXGBNZXLXFXAYMXIXCXKXEYMXHXBFIXGBAGOPYMXJXDFS
      XGBAKOPQUGXAXNXPXAFUFXMIUIAUJUKXAFFXOSULAUMUKUOXRCDZXAYCYIYNXAYCYIYNXAYCV
      GZYFYHYOFXSAUPHZAEUQHUFURHZYAUPHZUNHZYEIYOYPUSDYRUSDFYPIJFYRSJFYSIJYOXSAY
      OXSYOXAXRRDZXSCDYNXAYCUTZYNXAYTYCXRVAVBZAXRCWTRGVCVDVEZVFZXAYNAUSDYCEAVHT
      ZVIYOYQYAXAYNYQUSDYCXAYQAVJZVKTZYOYAYOXAYTYARDUUAUUBAXRRWTRKVLVDVEVMZVIYO
      XSAUUDUUEYNXAXTYBVNXAYNFAIJYCXAAWTVRAEVRDWTVRVOVSEVPVQVTWATWBYOYQYAUUGUUH
      XAYNFYQSJYCXAYQUUFWCTYNXAXTYBWDZWEYPYRWFWGYOXAYTYEYSNUUAUUBAXRWHVEWIYOFYA
      AUPHZXSUNHZYGSYOUUJXSYOYAAUUHUUEVIUUDYOYAAUUHUUEUUIXAYNFASJYCXAAECDXAACDW
      JAEWKWLWMTWEYOXSUUCWMWNYOXAYTYGUUKNUUAUUBAXRWOVEWIUOWPWQWRWS $.
  $}

  ${
    $d N a b $.  $d M a b $.  $d A a b $.
    $( The Y-sequence is strictly monotonic on ` NN0 ` .  Strengthened by
       ~ ltrmy .  (Contributed by Stefan O'Rear, 24-Sep-2014.) $)
    ltrmynn0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. NN0 /\ N e. NN0 ) -> ( M < N
        <-> ( A rmY M ) < ( A rmY N ) ) ) $=
      ( va vb c2 wcel cn0 clt wbr crmy co cv c1 cc0 cz fovcl sylan2 cn oveq2 wb
      cuz cfv caddc wa cmul crmx nn0z frmy zred eluzelre adantr remulcld nn0red
      frmx readdcld cle rmxypos simprd wss 2nn uznnssnn ax-mp nnge1d lemulge11d
      cr sseli simpld ltaddposd mpbid lelttrd wceq rmyp1 breqtrrd nn0uz monotuz
      3impb ) AFUBUCZGZBHGCHGBCIJABKLZACKLZIJUAVSDEBCADMZKLZVTWAAEMZKLZAWDNUDLZ
      KLZHOVSWDHGZUEZWEWEAUFLZAWDUGLZUDLZWGIWIWEWJWLWIWEWHVSWDPGZWEPGWDUHZAWDPV
      RPKUIQRUJZWIWEAWOVSAVFGWHFAUKULZUMZWIWJWKWQWIWKWHVSWMWKHGWNAWDHVRPUGUOQRU
      NZUPWIWEAWOWPWIOWKIJZOWEUQJZAWDURZUSVSNAUQJWHVSAVRSAFSGVRSUTVAFVBVCVGVDUL
      VEWIWSWJWLIJWIWSWTXAVHWIWKWJWRWQVIVJVKWHVSWMWGWLVLWNAWDVMRVNVSWBHGZUEWCXB
      VSWBPGWCPGWBUHAWBPVRPKUIQRUJVOWBWFAKTWBWDAKTWBBAKTWBCAKTVPVQ $.
  $}

  ${
    $d A a b $.  $d M a b $.  $d N a b $.
    $( The X-sequence is strictly monotonic on ` NN0 ` .  (Contributed by
       Stefan O'Rear, 4-Oct-2014.) $)
    ltrmxnn0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. NN0 /\ N e. NN0 ) -> ( M < N
        <-> ( A rmX M ) < ( A rmX N ) ) ) $=
      ( c2 wcel cn0 clt wbr crmx co c1 cz frmx fovcl sylan2 nn0red adantr oveq2
      cc0 cle va vb cuz cfv wb cv caddc wa cmul nn0z eluzelre remulcld peano2zd
      cr cn eluz2b2 simprbi crmy rmxypos ltmulgt11 syl3anc mpbid cexp csquarenn
      simpld cmin rmspecnonsq eldifad nnred frmy nnnn0d nn0ge0d simprd addge01d
      zred mulge0d wceq rmxp1 breqtrrd ltletrd nn0uz monotuz 3impb ) ADUCUDZEZB
      FECFEBCGHABIJZACIJZGHUEWEUAUBBCAUAUFZIJZWFWGAUBUFZIJZAWJKUGJZIJZFSWEWJFEZ
      UHZWKWKAUIJZWMWOWKWNWEWJLEZWKFEWJUJZAWJFWDLIMNOPZWOWKAWSWEAUNEZWNDAUKQZUL
      ZWOWMWNWEWLLEWMFEWNWJWRUMAWLFWDLIMNOPWOKAGHZWKWPGHZWEXCWNWEAUOEXCAUPUQQWO
      WKUNEWTSWKGHZXCXDUEWSXAWOXESAWJURJZTHZAWJUSZVEWKAUTVAVBWOWPWPADVCJKVFJZXF
      UIJZUGJZWMTWOSXJTHWPXKTHWOXIXFWOXIWEXIUOEWNWEXIUOVDAVGVHQZVIZWOXFWNWEWQXF
      LEWRAWJLWDLURVJNOVOZWOXIWOXIXLVKVLWOXEXGXHVMVPWOWPXJXBWOXIXFXMXNULVNVBWNW
      EWQWMXKVQWRAWJVROVSVTWEWHFEZUHWIXOWEWHLEWIFEWHUJAWHFWDLIMNOPWAWHWLAIRWHWJ
      AIRWHBAIRWHCAIRWBWC $.

    $( The X-sequence is monotonic on ` NN0 ` .  (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    lermxnn0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. NN0 /\ N e. NN0 ) -> ( M <_ N
        <-> ( A rmX M ) <_ ( A rmX N ) ) ) $=
      ( va vb c2 cuz cfv wcel cn0 cle wbr crmx co wb cv oveq2 nn0ssre cz clt wa
      nn0z frmx fovcl sylan2 nn0red wi w3a ltrmxnn0 biimpd 3expb leord1 3impb )
      AFGHZIZBJICJIBCKLABMNZACMNZKLOUODEADPZMNZAEPZMNZBCJUPUQURUTAMQURBAMQURCAM
      QRUOURJIZUAUSVBUOURSIUSJIURUBAURJUNSMUCUDUEUFUOVBUTJIZURUTTLZUSVATLZUGUOV
      BVCUHVDVEAURUTUIUJUKULUM $.

    $( The X-sequence is defined to range over ` NN0 ` but never actually takes
       the value 0.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
    rmxnn $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( A rmX N ) e. NN ) $=
      ( wcel cz wa cn0 crmx co cn cc0 clt wbr nn0z frmx sylan2 crmy cle rmxypos
      fovcl simpld c2 cuz cfv cneg elnnnn0b sylanbrc adantlr wceq rmxneg adantr
      eqeltrrd wo cr elznn0 simprbi adantl mpjaodan ) AUAUBUCZCZBDCZEZBFCZABGHZ
      ICZBUDZFCZUSVBVDUTUSVBEZVCFCZJVCKLZVDVBUSUTVHBMABFURDGNSOVGVIJABPHQLABRTV
      CUEUFUGVAVFEAVEGHZVCIVAVJVCUHVFABUIUJUSVFVJICZUTUSVFEZVJFCZJVJKLZVKVFUSVE
      DCVMVEMAVEFURDGNSOVLVNJAVEPHQLAVERTVJUEUFUGUKUTVBVFULZUSUTBUMCVOBUNUOUPUQ
      $.
  $}

  ${
    $d M a b $.  $d N a b $.  $d A a b $.
    $( The Y-sequence is strictly monotonic over ` ZZ ` .  (Contributed by
       Stefan O'Rear, 25-Sep-2014.) $)
    ltrmy $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) -> ( M < N <-> (
        A rmY M ) < ( A rmY N ) ) ) $=
      ( va vb c2 cuz cfv wcel crmy co cv cneg cn0 w3a clt wbr ltrmynn0 cz oveq2
      biimpd wa frmy fovcl zred rmyneg monotoddzz ) AFGHZIZDEBCABJKACJKADLZJKZA
      ELZJKZAULMZJKUIUJNIULNIOUJULPQUKUMPQAUJULRUAUIUJSIUBUKAUJSUHSJUCUDUEAULUF
      UJBAJTUJCAJTUJULAJTUJUNAJTUG $.
  $}

  ${
    $d A a b $.  $d N a b $.
    $( Y is zero only at zero.  (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
    rmyeq0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( N = 0 <-> ( A rmY N )
        = 0 ) ) $=
      ( va vb c2 cuz cfv wcel cz wa cc0 wceq crmy co wb 0z cv oveq2 clt wbr w3a
      zssre frmy fovcl zred ltrmy biimpd 3expb eqord1 mpanr2 rmy0 adantr eqeq2d
      wi bitrd ) AEFGZHZBIHZJZBKLZABMNZAKMNZLZVAKLUQURKIHUTVCOPUQCDACQZMNZADQZM
      NZBKIVAVBVDVFAMRVDBAMRVDKAMRUBUQVDIHZJVEAVDIUPIMUCUDUEUQVHVFIHZVDVFSTZVEV
      GSTZUNUQVHVIUAVJVKAVDVFUFUGUHUIUJUSVBKVAUQVBKLURAUKULUMUO $.
  $}

  ${
    $d A a b $.  $d N a b $.  $d M a b $.
    $( Y is one-to-one.  (Contributed by Stefan O'Rear, 3-Oct-2014.) $)
    rmyeq $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) -> ( M = N <-> (
        A rmY M ) = ( A rmY N ) ) ) $=
      ( va vb c2 cuz cfv wcel cz wceq crmy co wb cv oveq2 zssre wa clt wbr frmy
      fovcl zred wi w3a ltrmy biimpd 3expb eqord1 3impb ) AFGHZIZBJICJIBCKABLMZ
      ACLMZKNULDEADOZLMZAEOZLMZBCJUMUNUOUQALPUOBALPUOCALPQULUOJIZRUPAUOJUKJLUAU
      BUCULUSUQJIZUOUQSTZUPURSTZUDULUSUTUEVAVBAUOUQUFUGUHUIUJ $.
  $}

  ${
    $d A a b $.  $d N a b $.  $d M a b $.
    $( Y is monotonic (non-strict).  (Contributed by Stefan O'Rear,
       3-Oct-2014.) $)
    lermy $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) -> ( M <_ N <-> (
        A rmY M ) <_ ( A rmY N ) ) ) $=
      ( va vb c2 cuz cfv wcel cz cle wbr crmy co wb cv oveq2 zssre wa clt fovcl
      frmy zred wi w3a ltrmy biimpd 3expb leord1 3impb ) AFGHZIZBJICJIBCKLABMNZ
      ACMNZKLOULDEADPZMNZAEPZMNZBCJUMUNUOUQAMQUOBAMQUOCAMQRULUOJIZSUPAUOJUKJMUB
      UAUCULUSUQJIZUOUQTLZUPURTLZUDULUSUTUEVAVBAUOUQUFUGUHUIUJ $.
  $}
  $( ` rmY ` is positive for positive arguments.  (Contributed by Stefan
     O'Rear, 16-Oct-2014.) $)
  rmynn $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN ) -> ( A rmY N ) e. NN ) $=
    ( c2 cuz cfv wcel cn wa crmy co cz cc0 clt wbr nnz frmy fovcl sylan2 adantl
    wceq rmy0 adantr nngt0 wb simpl ltrmy syl3anc mpbid eqbrtrrd elnnz sylanbrc
    0z a1i ) ACDEZFZBGFZHZABIJZKFZLURMNURGFUPUOBKFZUSBOZABKUNKIPQRUQALIJZLURMUO
    VBLTUPAUAUBUQLBMNZVBURMNZUPVCUOBUCSUQUOLKFZUTVCVDUDUOUPUEVEUQULUMUPUTUOVASA
    LBUFUGUHUIURUJUK $.

  $( ` rmY ` is nonnegative for nonnegative arguments.  (Contributed by Stefan
     O'Rear, 16-Oct-2014.) $)
  rmynn0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 ) -> ( A rmY N ) e. NN0 ) $=
    ( c2 cuz cfv wcel cn0 wa crmy co cz cc0 cle wbr nn0z frmy fovcl sylan2 crmx
    clt rmxypos simprd elnn0z sylanbrc ) ACDEZFZBGFZHZABIJZKFZLUIMNZUIGFUGUFBKF
    UJBOABKUEKIPQRUHLABSJTNUKABUAUBUIUCUD $.

  ${
    $d A a b $.  $d B a b $.
    $( ` rmY ` commutes with ` abs ` .  (Contributed by Stefan O'Rear,
       26-Sep-2014.) $)
    rmyabs $p |- ( ( A e. ( ZZ>= ` 2 ) /\ B e. ZZ ) -> ( abs ` ( A rmY B ) ) =
        ( A rmY ( abs ` B ) ) ) $=
      ( va vb c2 cuz cfv wcel cv crmy co cneg cabs cz wa frmy cc0 cle wbr oveq2
      fovcl zred w3a crmx clt cn0 elnn0z biimpri 3adant1 rmxypos syl2anc simprd
      simp1 rmyneg oddcomabszz ) AEFGZHZCDACIZJKZADIZJKAUTLZJKBABJKABMGZJKUQURN
      HZOUSAURNUPNJPUAUBUQVCQURRSZUCZQAURUDKUESZQUSRSZVEUQURUFHZVFVGOUQVCVDUMVC
      VDVHUQVHVCVDOURUGUHUIAURUJUKULAUTUNURUTAJTURVAAJTURBAJTURVBAJTUO $.
  $}

  $( X(n) is strictly greater than Y(n) + Y(n-1).  Lemma 2.24 of
     [JonesMatijasevic] p. 697 restricted to ` NN ` .  (Contributed by Stefan
     O'Rear, 3-Oct-2014.) $)
  jm2.24nn $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN ) -> ( ( A rmY ( N - 1 ) ) +
      ( A rmY N ) ) < ( A rmX N ) ) $=
    ( c2 wcel c1 cmin co crmy caddc cmul cz sylan2 cn0 clt wbr recnd mpbid wceq
    cr cc0 cuz cfv cn wa crmx nnz 1z zsubcl sylancl frmy fovcl readdcld remulcl
    zred 2re sylancr resubcld frmx nn0red eluzelre remulcld a1i nnm1nn0 rmxypos
    adantr cle simprd eluzle lemul1ad mulcomd ltaddposd eqbrtrd lelttrd 2timesd
    simpld rmyp1 cc nnre adantl ax-1cn oveq2d eqtr3d 3brtr3d ltaddsubd ltadd1dd
    npcan oveq1d addsubd eqtrd breqtrrd wb rmy0 nngt0 simpl 0z syl3anc eqbrtrrd
    ltrmy lemul1 syl112anc lesub1dd rmym1 eqtr2d subsub23 breqtrd ltletrd ) ACU
    AUBZDZBUCDZUDZABEFGZHGZABHGZIGZCXMJGZXLFGZABUEGZXJXLXMXJXLXIXHXKKDZXLKDXIBK
    DZEKDXRBUFZUGBEUHUIZAXKKXGKHUJUKLUNZXJXMXIXHXSXMKDXTABKXGKHUJUKLUNZULXJXOXL
    XJCSDZXMSDZXOSDUOYCCXMUMUPZYBUQXJXQXIXHXSXQMDXTABMXGKUEURUKLUSZXJXNXMXLFGZX
    MIGZXPNXJXLYHXMYBXJXMXLYCYBUQYCXJXLXLIGZXMNOXLYHNOXJCXLJGZXLAJGZAXKUEGZIGZY
    JXMNXJYKAXLJGZYNXJYDXLSDYKSDUOYBCXLUMUPXJAXLXHASDZXICAUTVEZYBVAXJYLYMXJXLAY
    BYQVAZXJYMXIXHXRYMMDYAAXKMXGKUEURUKLUSZULXJCAXLYDXJUOVBZYQYBXIXHXKMDZTXLVFO
    ZBVCZXHUUAUDZTYMNOZUUBAXKVDZVGLXHCAVFOZXICAVHVEZVIXJYOYLYNNXJAXLXJAYQPZXJXL
    YBPZVJXJUUEYLYNNOXIXHUUAUUEUUCUUDUUEUUBUUFVOLXJYMYLYSYRVKQVLVMXJXLUUJVNXJAX
    KEIGZHGZYNXMXIXHXRUULYNRYAAXKVPLXJUUKBAHXJBVQDEVQDUUKBRXJBXIBSDXHBVRVSPVTBE
    WFUIWAWBWCXJXLXLXMYBYBYCWDQWEXJXPXMXMIGZXLFGYIXJXOUUMXLFXJXMXJXMYCPZVNWGXJX
    MXMXLUUNUUNUUJWHWIWJXJXPAXMJGZXLFGZXQVFXJXOUUOXLYFXJAXMYQYCVAZYBXJUUGXOUUOV
    FOZUUHXJYDYPYETXMNOUUGUURWKYTYQYCXJATHGZTXMNXHUUSTRXIAWLVEXJTBNOZUUSXMNOZXI
    UUTXHBWMVSXJXHTKDZXSUUTUVAWKXHXIWNUVBXJWOVBXIXSXHXTVSATBWRWPQWQCAXMWSWTQXAX
    JUUOXQFGZXLRZUUPXQRZXJXLXMAJGZXQFGZUVCXIXHXSXLUVGRXTABXBLXJUVFUUOXQFXJXMAUU
    NUUIVJWGXCXJUUOVQDXQVQDXLVQDUVDUVEWKXJUUOUUQPXJXQYGPUUJUUOXQXLXDWPQXEXF $.

  ${
    $d A a b $.  $d N a b $.
    $( First half of lemma 2.17 of [JonesMatijasevic] p. 696.  (Contributed by
       Stefan O'Rear, 14-Oct-2014.) $)
    jm2.17a $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 ) -> ( ( ( 2 x. A ) - 1 ) ^
        N ) <_ ( A rmY ( N + 1 ) ) ) $=
      ( wcel c2 cmul co c1 cmin cexp caddc crmy cle wbr wi wceq oveq2d cc cr cz
      cc0 va vb cn0 cuz cfv oveq2 oveq1 breq12d imbi2d weq 1le1 a1i 2cn eluzelz
      cv zcnd mulcl sylancr ax-1cn subcl sylancl exp0d 0p1e1 oveq2i rmy1 syl5eq
      3brtr4d w3a wa 2re eluzelre adantl remulcl 1re resubcl peano2nn0 reexpcld
      adantr 3adant3 simpr nn0z peano2zd frmy fovcl zred syl2anc remulcld simp1
      3ad2ant2 expp1d simpl 2nn clt eluz2b2 simplbi nnmulcl nnm1nn0 nn0ge0 3syl
      cn jca 3jca simp3 lemul1a eqbrtrd nn0cn pncan eqeltrd nn0re lep1d syl3anc
      wb lermy mpbid recnd mulid1d lesub2dd subdid mulcomd oveq1d eqtrd rmyluc2
      letrd 3exp a2d nn0ind impcom ) BUCCADUDUEZCZDAEFZGHFZBIFZABGJFZKFZLMZYIYK
      UAUOZIFZAYPGJFZKFZLMZNYIYKTIFZATGJFZKFZLMZNYIYKUBUOZIFZAUUEGJFZKFZLMZNYIY
      KUUGIFZAUUGGJFZKFZLMZNYIYONUAUBBYPTOZYTUUDYIUUNYQUUAYSUUCLYPTYKIUFUUNYRUU
      BAKYPTGJUGPUHUIUAUBUJZYTUUIYIUUOYQUUFYSUUHLYPUUEYKIUFUUOYRUUGAKYPUUEGJUGP
      UHUIYPUUGOZYTUUMYIUUPYQUUJYSUULLYPUUGYKIUFUUPYRUUKAKYPUUGGJUGPUHUIYPBOZYT
      YOYIUUQYQYLYSYNLYPBYKIUFUUQYRYMAKYPBGJUGPUHUIYIGGUUAUUCLGGLMYIUKULYIYKYIY
      JQCZGQCZYKQCZYIDQCAQCUURUMYIADAUNUPDAUQURUSYJGUTVAZVBYIUUCAGKFGUUBGAKVCVD
      AVEVFVGUUEUCCZYIUUIUUMUVBYIUUIUUMUVBYIUUIVHZUUJUUHYKEFZUULUVBYIUUJRCUUIUV
      BYIVIZYKUUGUVEYJRCZGRCZYKRCZUVEDRCARCZUVFVJYIUVIUVBDAVKVLDAVMURZVNYJGVOVA
      ZUVBUUGUCCYIUUEVPVRVQVSUVBYIUVDRCUUIUVEUUHYKUVEYIUUGSCZUUHRCZUVBYIVTZUVEU
      UEUVBUUESCZYIUUEWAVRZWBZYIUVLVIUUHAUUGSYHSKWCWDWEWFZUVKWGVSUVBYIUULRCZUUI
      UVEYIUUKSCZUVSUVNUVEUUGUVQWBYIUVTVIUULAUUKSYHSKWCWDWEWFVSUVCUUJUUFYKEFZUV
      DLUVCYKUUEYIUVBUUTUUIUVAWIUVBYIUUIWHWJUVCUUFRCZUVMUVHTYKLMZVIZVHZUUIUWAUV
      DLMUVBYIUWEUUIUVEUWBUVMUWDUVEYKUUEUVKUVBYIWKVQUVRUVEUVHUWCUVKUVEYJWTCZYKU
      CCUWCUVEDWTCAWTCZUWFWLYIUWGUVBYIUWGGAWMMAWNWOVLDAWPURYJWQYKWRWSXAXBVSUVBY
      IUUIXCUUFUUHYKXDWFXEUVBYIUVDUULLMUUIUVEYJUUHEFZUUHGEFZHFZUWHAUUGGHFZKFZHF
      ZUVDUULLUVEUWLUWIUWHUVEUWLAUUEKFZRUVEUWKUUEAKUVEUUEQCZUUSUWKUUEOUVBUWOYIU
      UEXFVRUSUUEGXGVAPZUVEYIUVOUWNRCUVNUVPYIUVOVIUWNAUUESYHSKWCWDWEWFXHUVEUVMU
      VGUWIRCUVRVNUUHGVMVAUVEYJUUHUVJUVRWGUVEUWNUUHUWLUWILUVEUUEUUGLMZUWNUUHLMZ
      UVEUUEUVBUUERCYIUUEXIVRXJUVEYIUVOUVLUWQUWRXLUVNUVPUVQAUUEUUGXMXKXNUWPUVEU
      UHUVEUUHUVRXOZXPVGXQUVEUVDUUHYJEFZUWIHFUWJUVEUUHYJGUWSUVEYJUVJXOZUUSUVEUS
      ULXRUVEUWTUWHUWIHUVEUUHYJUWSUXAXSXTYAUVEYIUVLUULUWMOUVNUVQAUUGYBWFVGVSYCY
      DYEYFYG $.

    $( Weak form of the second half of lemma 2.17 of [JonesMatijasevic] p. 696,
       allowing induction to start lower.  (Contributed by Stefan O'Rear,
       15-Oct-2014.) $)
    jm2.17b $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 ) -> ( A rmY ( N + 1 ) )
        <_ ( ( 2 x. A ) ^ N ) ) $=
      ( wcel c2 c1 caddc co crmy cmul cexp cle wbr wi wceq oveq2d breq12d cr wa
      cc0 cz va vb cn0 cuz cfv cv oveq1 oveq2 imbi2d weq 1le1 0p1e1 oveq2i rmy1
      syl5eq eluzelre remulcl sylancr recnd exp0d mpbiri cmin simpr nn0z adantr
      2re w3a peano2zd rmyluc2 syl2anc crmx clt rmxypos simprd ancoms cc ax-1cn
      nn0re pncan sylancl breqtrrd adantl fovcl remulcld eqeltrd subge02d mpbid
      frmy zred eqbrtrd 3adant3 wb simpl reexpcld cn 2nn eluz2b2 simplbi nngt0d
      nnmulcl lemul2 syl112anc biimp3a expp1d mulcomd eqtrd letr syl3anc mp2and
      peano2nn0 3exp a2d nn0ind impcom ) BUCCADUDUEZCZABEFGZHGZDAIGZBJGZKLZXPAU
      AUFZEFGZHGZXSYBJGZKLZMXPASEFGZHGZXSSJGZKLZMXPAUBUFZEFGZHGZXSYKJGZKLZMXPAY
      LEFGZHGZXSYLJGZKLZMXPYAMUAUBBYBSNZYFYJXPYTYDYHYEYIKYTYCYGAHYBSEFUGOYBSXSJ
      UHPUIUAUBUJZYFYOXPUUAYDYMYEYNKUUAYCYLAHYBYKEFUGOYBYKXSJUHPUIYBYLNZYFYSXPU
      UBYDYQYEYRKUUBYCYPAHYBYLEFUGOYBYLXSJUHPUIYBBNZYFYAXPUUCYDXRYEXTKUUCYCXQAH
      YBBEFUGOYBBXSJUHPUIXPYJEEKLUKXPYHEYIEKXPYHAEHGEYGEAHULUMAUNUOXPXSXPXSXPDQ
      CZAQCZXSQCZVFDAUPZDAUQZURUSUTPVAYKUCCZXPYOYSUUIXPYOYSUUIXPYOVGZYQXSYMIGZK
      LZUUKYRKLZYSUUIXPUULYOUUIXPRZYQUUKAYLEVBGZHGZVBGZUUKKUUNXPYLTCZYQUUQNUUIX
      PVCZUUNYKUUIYKTCZXPYKVDVEZVHZAYLVIVJUUNSUUPKLUUQUUKKLUUNSAYKHGZUUPKXPUUIS
      UVCKLZXPUUIRSAYKVKGVLLUVDAYKVMVNVOUUNUUOYKAHUUNYKVPCEVPCUUOYKNUUNYKUUIYKQ
      CXPYKVRVEUSVQYKEVSVTOZWAUUNUUKUUPUUNXSYMUUNUUDUUEUUFVFXPUUEUUIUUGWBUUHURZ
      UUNXPUURYMQCZUUSUVBXPUURRYMAYLTXOTHWHWCWIVJZWDZUUNUUPUVCQUVEUUNXPUUTUVCQC
      UUSUVAXPUUTRUVCAYKTXOTHWHWCWIVJWEWFWGWJWKUUJUUKXSYNIGZYRKUUIXPYOUUKUVJKLZ
      UUNUVGYNQCUUFSXSVLLZYOUVKWLUVHUUNXSYKUVFUUIXPWMZWNZUVFXPUVLUUIXPXSXPDWOCA
      WOCZXSWOCWPXPUVOEAVLLAWQWRDAWTURWSWBYMYNXSXAXBXCUUIXPYRUVJNYOUUNYRYNXSIGU
      VJUUNXSYKUUNXSUVFUSZUVMXDUUNYNXSUUNYNUVNUSUVPXEXFWKWAUUIXPUULUUMRYSMZYOUU
      NYQQCZUUKQCYRQCUVQUUNXPYPTCZUVRUUSUUNYLUVBVHXPUVSRYQAYPTXOTHWHWCWIVJUVIUU
      NXSYLUVFUUIYLUCCXPYKXJVEWNYQUUKYRXGXHWKXIXKXLXMXN $.

  $}

  $( Second half of lemma 2.17 of [JonesMatijasevic] p. 696.  (Contributed by
     Stefan O'Rear, 15-Oct-2014.) $)
  jm2.17c $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN ) ->
      ( A rmY ( ( N + 1 ) + 1 ) ) < ( ( 2 x. A ) ^ ( N + 1 ) ) ) $=
    ( c2 wcel cn wa cmul co c1 caddc crmy clt cr adantr cz adantl cc0 wbr mpbid
    wceq cuz cfv cmin cexp 2re eluzelre remulcl sylancr nnz peano2zd frmy fovcl
    zred syldan remulcld cc ax-1cn pncan sylancl oveq2d sylan2 eqeltrd resubcld
    nncn cn0 nnnn0 reexpcld rmy0 nngt0 wb simpl ltrmy syl3anc eqbrtrrd breqtrrd
    a1i ltsubposd cle jm2.17b 2nn eluz2b2 simplbi nnmulcl nngt0d lemul2 ltletrd
    0z syl112anc rmyluc2 recnd expp1d mulcomd eqtrd 3brtr4d ) ACUAUBZDZBEDZFZCA
    GHZABIJHZKHZGHZAWTIUCHZKHZUCHZWSWSBUDHZGHZAWTIJHKHZWSWTUDHZLWRXEXBXGWRXBXDW
    RWSXAWRCMDAMDZWSMDZUEWPXJWQCAUFNCAUGUHZWPWQWTODZXAMDZWRBWQBODZWPBUIZPZUJZWP
    XMFXAAWTOWOOKUKULUMUNZUOZWRXDABKHZMWRXCBAKWRBUPDZIUPDXCBTWQYBWPBVDPUQBIURUS
    UTZWQWPXOYAMDXPWPXOFYAABOWOOKUKULUMVAVBZVCXTWRWSXFXLWRWSBXLWQBVEDZWPBVFZPZV
    GZUOWRQXDLRXEXBLRWRQYAXDLWRAQKHZQYALWPYIQTWQAVHNWRQBLRZYIYALRZWQYJWPBVIPWRW
    PQODZXOYJYKVJWPWQVKYLWRWGVPXQAQBVLVMSVNYCVOWRXDXBYDXTVQSWRXAXFVRRZXBXGVRRZW
    QWPYEYMYFABVSVAWRXNXFMDXKQWSLRZYMYNVJXSYHXLWPYOWQWPWSWPCEDAEDZWSEDVTWPYPIAL
    RAWAWBCAWCUHWDNXAXFWSWEWHSWFWPWQXMXHXETXRAWTWIUNWRXIXFWSGHXGWRWSBWRWSXLWJZY
    GWKWRXFWSWRXFYHWJYQWLWMWN $.

  $( Lemma 2.24 of [JonesMatijasevic] p. 697 extended to ` ZZ ` .  Could be
     eliminated with a more careful proof of ~ jm2.26lem3 .  (Contributed by
     Stefan O'Rear, 3-Oct-2014.) $)
  jm2.24 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) -> ( ( A rmY ( N - 1 ) ) + (
      A rmY N ) ) < ( A rmX N ) ) $=
    ( wcel cz wa cc0 cle wbr c1 crmy caddc clt ad2antlr frmy fovcl syl2anc zred
    co cr cneg c2 cuz cfv cmin crmx simpll peano2zm adantr readdcld 0re a1i cn0
    frmx nn0red znegcl peano2zd wceq rmy0 ad2antrr simpr le0neg1d mpbid zleltp1
    zre wb ltrmy syl3anc eqbrtrrd lermy addgtge0 syl22anc negdid rmyneg oveq12d
    0z recnd cc ax-1cn negsubdi sylancl oveq2d oveq1d 3eqtr2d breqtrrd lt0neg1d
    mpbird nn0ge0d ltletrd cn elnnz biimpri adantll jm2.24nn wo adantl lelttric
    zcn mpjaodan ) AUAUBUCZCZBDCZEZBFGHZABIUDRZJRZABJRZKRZABUERZLHZFBLHZXBXCEZX
    GFXHXKXEXFXKXEXKWTXDDCZXEDCWTXAXCUFZXAXLWTXCBUGMZAXDDWSDJNOPQZXBXFSCXCXBXFA
    BDWSDJNOQUHZUIZFSCZXKUJUKXKXHXBXHULCXCABULWSDUEUMOUHZUNXKXGFLHFXGTZLHXKFABT
    ZIKRZJRZAYAJRZKRZXTLXKYCSCYDSCFYCLHFYDGHFYELHXKYCXKWTYBDCZYCDCXMXKYAXAYADCZ
    WTXCBUOMZUPZAYBDWSDJNOPQXKYDXKWTYGYDDCXMYHAYADWSDJNOPQXKAFJRZFYCLWTYJFUQXAX
    CAURUSZXKFYBLHZYJYCLHZXKFYAGHZYLXKXCYNXBXCUTXKBXABSCZWTXCBVDZMVAVBZXKFDCZYG
    YNYLVEYRXKVOUKZYHFYAVCPVBXKWTYRYFYLYMVEXMYSYIAFYBVFVGVBVHXKYJFYDGYKXKYNYJYD
    GHZYQXKWTYRYGYNYTVEXMYSYHAFYAVIVGVBVHYCYDVJVKXKXTXETZXFTZKRAXDTZJRZYDKRYEXK
    XEXFXKXEXOVPXKXFXPVPVLXKUUDUUAYDUUBKXKWTXLUUDUUAUQXMXNAXDVMPXBYDUUBUQXCABVM
    UHVNXKUUDYCYDKXKUUCYBAJXKBVQCZIVQCUUCYBUQXAUUEWTXCBWQMVRBIVSVTWAWBWCWDXKXGX
    QWEWFXKXHXSWGWHXBXJEWTBWICZXIWTXAXJUFXAXJUUFWTUUFXAXJEBWJWKWLABWMPXBYOXRXCX
    JWNXAYOWTYPWOUJBFWPVTWR $.

  ${
    $d A a b $.  $d N a b $.
    $( Y(n) increases faster than n.  Used implicitly without proof or comment
       in lemma 2.27 of [JonesMatijasevic] p. 697.  (Contributed by Stefan
       O'Rear, 4-Oct-2014.) $)
    rmygeid $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 ) -> N <_ ( A rmY N ) ) $=
      ( va vb wcel crmy co cle wbr wi cc0 c1 id oveq2 breq12d imbi2d cz syl2anc
      wceq zred cn0 c2 cuz cfv cv weq 0le0 rmy0 syl5breqr w3a 3ad2ant1 peano2zd
      caddc nn0z simp2 fovcl cr nn0re 1re a1i simp3 leadd1dd clt ltp1d wb ltrmy
      frmy syl3anc mpbid zltp1le letrd 3exp a2d nn0ind impcom ) BUAEAUBUCUDZEZB
      ABFGZHIZVQCUEZAVTFGZHIZJVQKAKFGZHIZJVQDUEZAWEFGZHIZJVQWELUMGZAWHFGZHIZJVQ
      VSJCDBVTKSZWBWDVQWKVTKWAWCHWKMVTKAFNOPCDUFZWBWGVQWLVTWEWAWFHWLMVTWEAFNOPV
      TWHSZWBWJVQWMVTWHWAWIHWMMVTWHAFNOPVTBSZWBVSVQWNVTBWAVRHWNMVTBAFNOPVQKKWCH
      UGAUHUIWEUAEZVQWGWJWOVQWGWJWOVQWGUJZWHWFLUMGZWIWPWHWPWEWOVQWEQEZWGWEUNUKZ
      ULZTWPWQWPWFWPVQWRWFQEZWOVQWGUOZWSAWEQVPQFVGUPRZULTWPWIWPVQWHQEZWIQEZXBWT
      AWHQVPQFVGUPRZTWPWEWFLWOVQWEUQEWGWEURUKZWPWFXCTLUQEWPUSUTWOVQWGVAVBWPWFWI
      VCIZWQWIHIZWPWEWHVCIZXHWPWEXGVDWPVQWRXDXJXHVEXBWSWTAWEWHVFVHVIWPXAXEXHXIV
      EXCXFWFWIVJRVIVKVLVMVNVO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Congruential equations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A wff of the form ` A || ( B - C ) ` is interpreted as a congruential
     equation.  This is similar to ` ( B mod A ) = ( C mod A ) ` , but is
     defined such that behavior is regular for zero and negative values of
     ` A ` .  To use this concept effectively, we need to show that
     congruential equations behave similarly to normal equations; first a
     transitivity law.  Idea for the future:  If there was a congruential
     equation symbol, it could incorporate type constraints, so that most of
     these would not need them.  (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
  congtr $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ D e. ZZ ) /\ ( A || (
      B - C ) /\ A || ( C - D ) ) ) -> A || ( B - D ) ) $=
    ( cz wcel wa co cdivides wbr w3a caddc simp1l simp1r simp2l 3ad2ant2 cc zcn
    cmin adantl zsubcld zsubcl simp3 dvds2add syl31anc 3ad2ant1 npncand breqtrd
    imp adantr ) AEFZBEFZGZCEFZDEFZGZABCSHZIJACDSHZIJGZKZAUQURLHZBDSHIUTUKUQEFZ
    UREFZUSAVAIJZUKULUPUSMUTBCUKULUPUSNUMUNUOUSOUAUPUMVCUSCDUBPUMUPUSUCUKVBVCKU
    SVDAUQURUDUIUEUTBCDUMUPBQFZUSULVEUKBRTUFUPUMCQFZUSUNVFUOCRUJPUPUMDQFZUSUOVG
    UNDRTPUGUH $.

  $( If two pairs of numbers are componentwise congruent, so are their sums.
     (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
  congadd $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) /\ ( D e. ZZ /\ E e. ZZ )
      /\ ( A || ( B - C ) /\ A || ( D - E ) ) ) -> A || ( ( B + D ) - ( C + E )
      ) ) $=
    ( cz wcel w3a wa cmin co cdivides wbr caddc wi simpl1 zsubcl zcnd cc zcn
    3adant1 adantr adantl dvds2add syl3anc 3impia wceq simpl2 ad2antrl ad2antll
    simpl3 addsub4d 3adant3 breqtrrd ) AFGZBFGZCFGZHZDFGZEFGZIZABCJKZLMADEJKZLM
    IZHAVBVCNKZBDNKCENKJKZLURVAVDAVELMZURVAIZUOVBFGZVCFGZVDVGOUOUPUQVAPURVIVAUP
    UQVIUOBCQUAUBVAVJURDEQUCAVBVCUDUEUFURVAVFVEUGVDVHBDCEVHBUOUPUQVAUHRUSDSGURU
    TDTUIVHCUOUPUQVAUKRUTESGURUSETUJULUMUN $.

  $( If two pairs of numbers are componentwise congruent, so are their
     products.  (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
  congmul $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) /\ ( D e. ZZ /\ E e. ZZ )
      /\ ( A || ( B - C ) /\ A || ( D - E ) ) ) -> A || ( ( B x. D ) - ( C x. E
      ) ) ) $=
    ( cz wcel w3a wa cmin co cdivides wbr cmul zmulcld wi 3ad2ant2 syl3anc zcn
    cc simp11 simp12 simp2l simp2r simp13 simp3r zsubcl dvdsmultr2 mpd 3ad2ant1
    adantr adantl subdid breqtrd zsubcld dvdsmultr1 3ad2ant3 subdird syl222anc
    simp3l congtr ) AFGZBFGZCFGZHZDFGZEFGZIZABCJKZLMZADEJKZLMZIZHZVBBDNKZFGBENK
    ZFGCENKZFGAVOVPJKZLMAVPVQJKZLMAVOVQJKLMVBVCVDVHVMUAZVNBDVBVCVDVHVMUBZVEVFVG
    VMUCOVNBEWAVEVFVGVMUDZOVNCEVBVCVDVHVMUEZWBOVNABVKNKZVRLVNVLAWDLMZVEVHVJVLUF
    VNVBVCVKFGZVLWEPVTWAVHVEWFVMDEUGQABVKUHRUIVNBDEVEVHBTGZVMVCVBWGVDBSQUJZVHVE
    DTGZVMVFWIVGDSUKQVHVEETGZVMVGWJVFESULQZUMUNVNAVIENKZVSLVNVJAWLLMZVEVHVJVLUT
    VNVBVIFGVGVJWMPVTVNBCWAWCUOWBAVIEUPRUIVNBCEWHVEVHCTGZVMVDVBWNVCCSUQUJWKURUN
    AVOVPVQVAUS $.

  $( Congruence mod ` A ` is a symmetric/commutative relation.  (Contributed by
     Stefan O'Rear, 1-Oct-2014.) $)
  congsym $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ A || ( B - C ) ) )
      -> A || ( C - B ) ) $=
    ( cz wcel wa cmin cdivides wbr cneg simprr zcn ad2antrl ad2antlr negsubdi2d
    co cc breqtrrd wb simpll simprl simplr zsubcld dvdsnegb syl2anc mpbird ) AD
    EZBDEZFZCDEZABCGPZHIZFZFZACBGPZHIZAUOJZHIZUNAUKUQHUIUJULKUNCBUJCQEUIULCLMUH
    BQEUGUMBLNORUNUGUODEUPURSUGUHUMTUNCBUIUJULUAUGUHUMUBUCAUOUDUEUF $.

  $( If two integers are congruent mod ` A ` , so are their negatives.
     (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
  congneg $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ A || ( B - C ) ) )
      -> A || ( -u B - -u C ) ) $=
    ( cz wcel wa cmin co cdivides wbr cneg congsym wceq cc zcn syl2an ad2ant2lr
    neg2sub breqtrrd ) ADEZBDEZFCDEZABCGHIJZFFACBGHZBKCKGHZIABCLUAUBUEUDMZTUCUA
    BNECNEUFUBBOCOBCRPQS $.

  $( If two pairs of numbers are componentwise congruent, so are their
     differences.  (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
  congsub $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) /\ ( D e. ZZ /\ E e. ZZ )
      /\ ( A || ( B - C ) /\ A || ( D - E ) ) ) -> A || ( ( B - D ) - ( C - E )
      ) ) $=
    ( cz wcel w3a wa cmin co cdivides wbr cneg caddc simp11 simp12 znegcld zcnd
    negsubd simp13 simp2l simp2r simp3l simp3r congneg syl22anc congadd oveq12d
    syl322anc breqtrd ) AFGZBFGZCFGZHZDFGZEFGZIZABCJKLMZADEJKLMZIZHZABDNZOKZCEN
    ZOKZJKZBDJKZCEJKZJKLVBULUMUNVCFGVEFGUSAVCVEJKLMZAVGLMULUMUNURVAPZULUMUNURVA
    QZULUMUNURVAUAZVBDUOUPUQVAUBZRVBEUOUPUQVAUCZRUOURUSUTUDVBULUPUQUTVJVKVNVOUO
    URUSUTUEADEUFUGABCVCVEUHUJVBVDVHVFVIJVBBDVBBVLSVBDVNSTVBCEVBCVMSVBEVOSTUIUK
    $.

  $( Every integer is congruent to itself mod every base.  (Contributed by
     Stefan O'Rear, 1-Oct-2014.) $)
  congid $p |- ( ( A e. ZZ /\ B e. ZZ ) -> A || ( B - B ) ) $=
    ( cz wcel wa cc0 co cdivides wbr dvds0 adantr cc zcn adantl subidd breqtrrd
    cmin ) ACDZBCDZEZAFBBQGHRAFHISAJKTBSBLDRBMNOP $.

  ${
    $d F a b c $.  $d X a b c k $.  $d V a b c k $.  $d Y a b c k $.
    $d N a b c k $.

    $( Polynomials commute with congruences.  (Does this characterize them?)
       (Contributed by Stefan O'Rear, 5-Oct-2014.) $)
    mzpcong $p |- ( ( F e. ( mzPoly ` V ) /\ ( X e. ( ZZ ^m V ) /\ Y e. ( ZZ ^m
        V ) ) /\ ( N e. ZZ /\ A. k e. V N || ( ( X ` k ) - ( Y ` k ) ) ) ) -> N
        || ( ( F ` X ) - ( F ` Y ) ) ) $=
      ( vc cfv wcel cz co wa cmin cdivides wbr cvv wceq oveq12d breq2d fveq1 va
      vb cmzp cmap cv wral w3a elfvex 3anim1i simp1 csn cxp cmpt caddc cof cmul
      simpl3l simpr congid syl2anc simpl2l vex fvconst2 syl simpl2r simpl3r weq
      breqtrrd fveq2 rspcva eqid fvex fvmpt wf simp13l simp12l ffvelrnd simp12r
      simp2l simp3l simp2r simp3r congadd syl322anc wfn ffn a1i fnfvof syl22anc
      ovex congmul mzpindd ) BDUCHIZEJDUDKZIZFWNIZLZCJIZCAUEZEHZWSFHZMKZNOZADUF
      ZLZUGDPIZWQXEUGZWMCEBHZFBHZMKZNOZWMXFWQXEBDUCUHUIWMWQXEUJXGCEUAUEZHZFXLHZ
      MKZNOCEWNUBUEZUKULZHZFXQHZMKZNOCEGWNXPGUEZHZUMZHZFYCHZMKZNOCEXPHZFXPHZMKZ
      NOZCEYAHZFYAHZMKZNOZCEXPYAUNUOKZHZFYOHZMKZNOCEXPYAUPUOKZHZFYSHZMKZNOXKUAB
      UBGDXGXPJIZLZCXPXPMKZXTNUUDWRUUCCUUENOWRXDXFWQUUCUQXGUUCURCXPUSUTUUDXRXPX
      SXPMUUDWOXRXPQWOWPXFXEUUCVAWNXPEUBVBZVCVDUUDWPXSXPQWOWPXFXEUUCVEWNXPFUUFV
      CVDRVHXGXPDIZLZCXPEHZXPFHZMKZYFNUUHUUGXDCUUKNOZXGUUGURWRXDXFWQUUGVFXCUULA
      XPDAUBVGZXBUUKCNUUMWTUUIXAUUJMWSXPEVIWSXPFVIRSVJUTUUHYDUUIYEUUJMUUHWOYDUU
      IQWOWPXFXEUUGVAGEYBUUIWNYCXPYAETYCVKZXPEVLVMVDUUHWPYEUUJQWOWPXFXEUUGVEGFY
      BUUJWNYCXPYAFTUUNXPFVLVMVDRVHXGWNJXPVNZYJLZWNJYAVNZYNLZUGZCYGYKUNKZYHYLUN
      KZMKZYRNUUSWRYGJIZYHJIZYKJIZYLJIZYJYNCUVBNOWRXDXFWQUUPUURVOZUUSWNJEXPXGUU
      OYJUURVSZWOWPXFXEUUPUURVPZVQZUUSWNJFXPUVHWOWPXFXEUUPUURVRZVQZUUSWNJEYAXGU
      UPUUQYNVTZUVIVQZUUSWNJFYAUVMUVKVQZXGUUOYJUURWAZXGUUPUUQYNWBZCYGYHYKYLWCWD
      UUSYPUUTYQUVAMUUSXPWNWEZYAWNWEZWNPIZWOYPUUTQUUSUUOUVRUVHWNJXPWFVDZUUSUUQU
      VSUVMWNJYAWFVDZUVTUUSJDUDWJWGZUVIWNUNXPYAPEWHWIUUSUVRUVSUVTWPYQUVAQUWAUWB
      UWCUVKWNUNXPYAPFWHWIRVHUUSCYGYKUPKZYHYLUPKZMKZUUBNUUSWRUVCUVDUVEUVFYJYNCU
      WFNOUVGUVJUVLUVNUVOUVPUVQCYGYHYKYLWKWDUUSYTUWDUUAUWEMUUSUVRUVSUVTWOYTUWDQ
      UWAUWBUWCUVIWNUPXPYAPEWHWIUUSUVRUVSUVTWPUUAUWEQUWAUWBUWCUVKWNUPXPYAPFWHWI
      RVHXLXQQZXOXTCNUWGXMXRXNXSMEXLXQTFXLXQTRSXLYCQZXOYFCNUWHXMYDXNYEMEXLYCTFX
      LYCTRSUAUBVGZXOYICNUWIXMYGXNYHMEXLXPTFXLXPTRSUAGVGZXOYMCNUWJXMYKXNYLMEXLY
      ATFXLYATRSXLYOQZXOYRCNUWKXMYPXNYQMEXLYOTFXLYOTRSXLYSQZXOUUBCNUWLXMYTXNUUA
      MEXLYSTFXLYSTRSXLBQZXOXJCNUWMXMXHXNXIMEXLBTFXLBTRSWLUT $.
  $}

  ${
    $d A a $.  $d N a $.
    $( Every integer is congruent to some number in the fundamental domain.
       (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
    congrep $p |- ( ( A e. NN /\ N e. ZZ ) -> E. a e. ( 0 ... ( A - 1 ) ) A ||
        ( a - N ) ) $=
      ( cn wcel cz wa cmo co cc0 c1 cmin cfz cdivides wbr cv wrex zmodfz ancoms
      adantr nnz simpr cn0 zmodcl nn0zd cdiv cr crp zre nnrp moddifz syl2anr wb
      nnne0 zsubcld dvdsval2 syl3anc mpbird congsym syl22anc wceq breq2d rspcev
      wne oveq1 syl2anc ) ADEZBFEZGZBAHIZJAKLIMIZEZAVJBLIZNOZACPZBLIZNOZCVKQVHV
      GVLBARSVIAFEZVHVJFEABVJLIZNOZVNVGVRVHAUATZVGVHUBZVIVJVHVGVJUCEBAUDSUEZVIV
      TVSAUFIFEZVHBUGEAUHEWDVGBUIAUJBAUKULVIVRAJVDZVSFEVTWDUMWAVGWEVHAUNTVIBVJW
      BWCUOAVSUPUQURABVJUSUTVQVNCVJVKVOVJVAVPVMANVOVJBLVEVBVCVF $.
  $}

  $( If two integers are congruent, they are either equal or separated by at
     least the congruence base.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
  congabseq $p |- ( ( ( A e. NN /\ B e. ZZ /\ C e. ZZ ) /\ A || ( B - C ) ) ->
      ( ( abs ` ( B - C ) ) < A <-> B = C ) ) $=
    ( wcel cz w3a cmin co wbr wa clt wceq cc zcn ad2antrr cr 3ad2ant1 ad3antrrr
    cc0 adantr cn cdivides cabs cfv 3ad2ant2 3ad2ant3 cle zsubcl 3adant1 abscld
    wn zcnd nnre ltnled biimpa wne nnz simpr 3jca simpllr dvdsleabs ex necon1bd
    sylc mpd subeq0d oveq1 adantl subidd eqtrd abs00bd nngt0 eqbrtrd impbida )
    AUADZBEDZCEDZFZABCGHZUBIZJZVSUCUDZAKIZBCLZWAWCJZBCVRBMDZVTWCVPVOWFVQBNUEOVR
    CMDZVTWCVQVOWGVPCNUFZOWEAWBUGIZUKZVSSLWAWCWJWAWBAVRWBPDVTVRVSVRVSVPVQVSEDZV
    OBCUHUIZULUJTVRAPDZVTVOVPWMVQAUMQTUNUOWEWIVSSWEVSSUPZWIWEWNJZAEDZWKWNFVTWIW
    OWPWKWNVRWPVTWCWNVOVPWPVQAUQQRVRWKVTWCWNWLRWEWNURUSVRVTWCWNUTAVSVAVDVBVCVEV
    FWAWDJZWBSAKWQVSWQVSCCGHZSWDVSWRLWABCCGVGVHWQCVRWGVTWDWHOVIVJVKVRSAKIZVTWDV
    OVPWSVQAVLQOVMVN $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Alternating congruential equations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A wff like that in this theorem will be known as an "alternating
     congruence".  A special symbol might be considered if more uses come up.
     They have many of the same properties as normal congruences, starting with
     reflexivity.

     JonesMatijasevic uses "a &#8801; &#xB1; b (mod c)" for this construction.
     The disjunction of divisibility constraints seems to adequately capture
     the concept, but it's rather verbose and somewhat inelegant.  Use of an
     explicit equivalence relation might also work.  (Contributed by Stefan
     O'Rear, 2-Oct-2014.) $)
  acongid $p |- ( ( A e. ZZ /\ B e. ZZ ) -> ( A || ( B - B ) \/ A || ( B - -u B
      ) ) ) $=
    ( cz wcel wa cmin co cdivides wbr cneg congid orcd ) ACDBCDEABBFGHIABBJFGHI
    ABKL $.

  $( Symmetry of alternating congruence.  (Contributed by Stefan O'Rear,
     2-Oct-2014.) $)
  acongsym $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) /\
          ( A || ( B - C ) \/ A || ( B - -u C ) ) ) -> ( A || ( C - B ) \/ A ||
      ( C - -u B ) ) ) $=
    ( cz wcel w3a cmin co cdivides wbr cneg wo wi congsym exp32 3impia 3ad2ant2
    wa cc zcn negnegd oveq1d negcld 3ad2ant3 neg2subd eqtr3d breq2d orim12d imp
    biimpd ) ADEZBDEZCDEZFZABCGHIJZABCKZGHZIJZLACBGHIJZACBKZGHZIJZLUNUOUSURVBUK
    ULUMUOUSMUKULRUMUOUSABCNOPUNURVBUNUQVAAIUNUTKZUPGHUQVAUNVCBUPGUNBULUKBSEUMB
    TZQUAUBUNUTCULUKUTSEUMULBVDUCQUMUKCSEULCTUDUEUFUGUJUHUI $.

  $( Negate right side of alternating congruence.  Makes essential use of the
     "alternating" part.  (Contributed by Stefan O'Rear, 3-Oct-2014.) $)
  acongneg2 $p |- ( ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) /\
          ( A || ( B - -u C ) \/ A || ( B - -u -u C ) ) ) -> ( A || ( B - C )
      \/ A || ( B - -u C ) ) ) $=
    ( cz wcel w3a cneg cmin co cdivides wbr wo wa cc zcn 3ad2ant3 oveq2d breq2d
    negnegd biimpd orim2d imp orcomd ) ADEZBDEZCDEZFZABCGZHIJKZABUHGZHIZJKZLZMU
    IABCHIZJKZUGUMUIUOLUGULUOUIUGULUOUGUKUNAJUGUJCBHUGCUFUDCNEUECOPSQRTUAUBUC
    $.

  $( Transitivity of alternating congruence.  (Contributed by Stefan O'Rear,
     2-Oct-2014.) $)
  acongtr $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ D e. ZZ ) /\
          ( ( A || ( B - C ) \/ A || ( B - -u C ) ) /\ ( A || ( C - D ) \/ A ||
      ( C - -u D ) ) ) ) -> ( A || ( B - D ) \/ A || ( B - -u D ) ) ) $=
    ( cz wcel wa cmin co cdivides wbr wo congtr ex simpll ad2antlr simpr adantl
    cneg cc 3expa orcd znegcl anim12i simplll simplrl simplrr syl22anc wceq zcn
    congsym adantr neg2subd eqcomd breq2d sylibd anim2d imp syl3anc olcd anim2i
    anim1i simpl an42s syl12anc negnegd oveq2d syl eqtr3d ccased 3impia ) AEFZB
    EFZGZCEFZDEFZGZABCHIJKZABCSZHIJKZLACDHIJKZACDSZHIJKZLGABDHIJKZABWBHIJKZLZVN
    VQGZVRWAVTWCWFWGVRWAGZWFWGWHGWDWEVNVQWHWDABCDMUAUBNWGVTWAGZWFWGWIGZWEWDWJVN
    VSEFZWBEFZGZVTAVSWBHIZJKZGZWEVNVQWIOVQWMVNWIVOWKVPWLCUCZDUCZUDZPWGWIWPWGWAW
    OVTWGWAADCHIZJKZWOWGWAXAWGWAGVLVOVPWAXAVLVMVQWAUEVNVOVPWAUFVNVOVPWAUGWGWAQA
    CDUKUHNWGWTWNAJWGWNWTVQWNWTUIVNVQCDVOCTFVPCUJULZVPDTFVODUJRZUMRUNUOUPUQURAB
    VSWBMUSUTNWGVRWCGZWFWGXDGZWEWDXEVNVOWLGZXDWEVNVQXDOVQXFVNXDVPWLVOWRVAPWGXDQ
    ABCWBMUSUTNWGVTWCGZWFWGXGGZWDWEXHVNWKVPGZVTAVSDHIZJKZGZWDVNVQXGOVQXIVNXGVOW
    KVPWQVBPWGXGXLWGWCXKVTWGWCAWBCHIZJKZXKWGWCXNWGWCGVLVOGZWLWCXNWGXOWCVLVPVMVO
    XOVLVPGVLVMVOGVOVLVPVCVMVOQUDVDULVQWLVNWCVPWLVOWRRPWGWCQACWBUKVENWGXMXJAJVQ
    XMXJUIVNVQWBVSSZHIXMXJVQXPCWBHVQCXBVFVGVQDVSXCVQWMVSTFZWSWKXQWLVSUJULVHUMVI
    RUOUPUQURABVSDMUSUBNVJVK $.

  ${
    acongeq12d.1 $e |- ( ph -> B = C ) $.
    acongeq12d.2 $e |- ( ph -> D = E ) $.
    $( Substitution deduction for alternating congruence.  (Contributed by
       Stefan O'Rear, 3-Oct-2014.) $)
    acongeq12d $p |- ( ph -> ( ( A || ( B - D ) \/ A || ( B - -u D ) ) <-> ( A
        || ( C - E ) \/ A || ( C - -u E ) ) ) ) $=
      ( cmin co cdivides wbr cneg oveq12d breq2d negeqd orbi12d ) ABCEIJZKLBDFI
      JZKLBCEMZIJZKLBDFMZIJZKLARSBKACDEFIGHNOAUAUCBKACDTUBIGAEFHPNOQ $.
  $}

  ${
    $d A a b $.  $d N a b $.
    $( Every integer is alternating-congruent to some number in the first half
       of the fundamental domain.  (Contributed by Stefan O'Rear,
       2-Oct-2014.) $)
    acongrep $p |- ( ( A e. NN /\ N e. ZZ ) -> E. a e. ( 0 ... A ) ( ( 2 x. A )
        || ( a - N ) \/ ( 2 x. A ) || ( a - -u N ) ) ) $=
      ( vb cn wcel cz wa c2 co cmin cdivides wbr wo sylancr syl2anc cr 3ad2ant1
      cc0 cle cmul cv cneg cfz wrex c1 simpl nnmulcl simpr congrep elfzelz zred
      2nn ad2antrl nnre ad2antrr elfzle1 anim1i wb 0z a1i syl3anc adantr mpbird
      nnz elfz simplrr orcd id eqidd acongeq12d rspcev simplll simplrl 3ad2ant2
      weq w3a 2re remulcl elfzel1 2z zmulcl simp2 elfzm11 biimpa syl21anc ltled
      simp3d subge0d wceq cc nncn caddc 2times oveq1d pncan2 anidms eqtrd simp3
      clt syl eqbrtrd subled jca zsubcld simplr simprr congsym syl22anc dvdsadd
      mpbid zcnd zcn ad2antlr subnegd subadd23d breqtrrd olcd lecasei rexlimddv
      recnd ) AEFZBGFZHZIAUAJZDUBZBKJLMZYECUBZBKJLMYEYHBUCZKJLMNZCSAUDJZUEZDSYE
      UFKJZUDJZYDYEEFZYCYGDYNUEYDIEFYBYOUMYBYCUGIAUHOYBYCUIYEBDUJPYDYFYNFZYGHZH
      ZYLYFAYPYFQFZYDYGYPYFYFSYMUKZULZUNZYBAQFZYCYQAUOZUPYRYFATMZHZYFYKFZYGYEYF
      YIKJLMZNZYLUUFUUGSYFTMZUUEHZYRUUJUUEYPUUJYDYGYFSYMUQUNURYRUUGUUKUSZUUEYRY
      FGFZSGFZAGFZUULYPUUMYDYGYTUNZUUNYRUTVAZYBUUOYCYQAVEZUPZYFSAVFVBVCVDUUFYGU
      UHYDYPYGUUEVGVHYJUUICYFYKCDVPZYEYHYFBBUUTVIUUTBVJVKVLPYRAYFTMZHZYEYFKJZYK
      FZYEUVCBKJLMZYEUVCYIKJZLMZNZYLUVBUVDSUVCTMZUVCATMZHZUVBYBYPUVAUVKYBYCYQUV
      AVMYDYPYGUVAVNYRUVAUIYBYPUVAVQZUVIUVJUVLUVIYFYETMUVLYFYEYPYBYSUVAUUAVOZYB
      YPYEQFZUVAYBIQFUUCUVNVRUUDIAVSORZUVLUUMUUJYFYEWTMZUVLUUNYEGFZYPUUMUUJUVPV
      QZYPYBUUNUVAYFSYMVTVOYBYPUVQUVAYBIGFZUUOUVQWAUURIAWBZORYBYPUVAWCUUNUVQHYP
      UVRYFSYEWDWEWFWHWGUVLYEYFUVOUVMWIVDUVLYEAYFUVOYBYPUUCUVAUUDRUVMUVLYEAKJZA
      YFTYBYPUWAAWJZUVAYBAWKFZUWBAWLUWCUWAAAWMJZAKJZAUWCYEUWDAKAWNWOUWCUWEAWJAA
      WPWQWRXARYBYPUVAWSXBXCXDVBYRUVDUVKUSZUVAYRUVCGFUUNUUOUWFYRYEYFYRUVSUUOUVQ
      WAUUSUVTOZUUPXEZUUQUUSUVCSAVFVBVCVDUVBUVGUVEYRUVGUVAYRYEYEBYFKJZWMJZUVFLY
      RYEUWILMZYEUWJLMZYRUVQUUMYCYGUWKUWGUUPYBYCYQXFZYDYPYGXGYEYFBXHXIYRUVQUWIG
      FUWKUWLUSUWGYRBYFUWMUUPXEYEUWIXJPXKYRUVFUVCBWMJUWJYRUVCBYRUVCUWHXLYCBWKFY
      BYQBXMXNZXOYRYEYFBYRYEUWGXLYRYFUUBYAUWNXPWRXQVCXRYJUVHCUVCYKYHUVCWJZYEYHU
      VCBBUWOVIUWOBVJVKVLPXSXT $.
  $}

  $( Bound on the difference between two integers constrained to two possibly
     overlapping finite ranges.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
  fzmaxdif $p |- ( ( ( C e. ZZ /\ A e. ( B ... C ) ) /\ ( F e. ZZ /\ D e. ( E
      ... F ) ) /\ ( C - E ) <_ ( F - B ) ) -> ( abs ` ( A - D ) ) <_ ( F - B )
      ) $=
    ( cz wcel cfz co wa cmin cle wbr caddc syl zred resubcld recnd letrd simp2r
    w3a cabs cfv elfzelz simp2l simp1r elfzel1 elfzle2 lesub1dd breqtrd elfzle1
    nncand simp1l readdcld lesub2dd simp3 lesubaddd addcomd absdifled mpbir2and
    mpbid ) CGHZABCIJHZKZFGHZDEFIJHZKZCELJZFBLJZMNZUBZADLJUCUDVJMNDVJLJZAMNADVJ
    OJZMNVLVMBAVLDVJVLDVLVGDGHVEVFVGVKUAZDEFUEPQZVLFBVLFVEVFVGVKUFQZVLBVLVDBGHV
    CVDVHVKUGZABCUHPQZRZRVSVLAVLVDAGHVRABCUEPQZVLVMFVJLJBMVLDFVJVPVQVTVLVGDFMNV
    ODEFUIPUJVLFBVLFVQSVLBVSSUMUKVLVDBAMNVRABCULPTVLACVNWAVLCVCVDVHVKUNQZVLDVJV
    PVTUOVLVDACMNVRABCUIPVLCVJDOJZVNMVLCDLJZVJMNCWCMNVLWDVIVJVLCDWBVPRVLCEWBVLE
    VLVGEGHVODEFUHPQZRVTVLEDCWEVPWBVLVGEDMNVODEFULPUPVEVHVKUQTVLCDVJWBVPVTURVBV
    LVJDVLVJVTSVLDVPSUSUKTVLADVJWAVPVTUTVA $.

  $( Reflection of a finite range of integers about 0.  (Contributed by Stefan
     O'Rear, 4-Oct-2014.) $)
  fzneg $p |- ( ( A e. ZZ /\ B e. ZZ /\ C e. ZZ ) -> ( A e. ( B ... C ) <-> -u
      A e. ( -u C ... -u B ) ) ) $=
    ( cz wcel w3a cle wbr wa cneg cfz co ancom cr 3ad2ant1 3ad2ant3 lenegd elfz
    zre znegcl 3ad2ant2 anbi12d syl5bb wb syl3an 3com23 3bitr4d ) ADEZBDEZCDEZF
    ZBAGHZACGHZIZCJZAJZGHZUPBJZGHZIZABCKLEUPUOURKLEZUNUMULIUKUTULUMMUKUMUQULUSU
    KACUHUIANEUJASOZUJUHCNEUICSPQUKBAUIUHBNEUJBSUAVBQUBUCABCRUHUJUIVAUTUDZUHUPD
    EUJUODEUIURDEVCATCTBTUPUOURRUEUFUG $.

  $( Two numbers in the fundamental domain are alternating-congruent iff they
     are equal.  TODO: could be used to shorten ~ jm2.26 (Contributed by Stefan
     O'Rear, 4-Oct-2014.) $)
  acongeq $p |- ( ( A e. NN /\ B e. ( 0 ... A ) /\ C e. ( 0 ... A ) ) -> ( B =
      C <-> ( ( 2 x. A ) || ( B - C ) \/ ( 2 x. A ) || ( B - -u C ) ) ) ) $=
    ( wcel cc0 co wceq c2 cmin cdivides wbr wa cz adantl clt cle caddc ad2antrr
    cr c1 cn cfz w3a cmul cneg wo 2z nnz 3ad2ant1 zmulcl sylancr elfzelz congid
    3ad2ant2 syl2anc adantr oveq2 breqtrd orcd cabs cfv 3ad2ant3 zsubcld abscld
    zcnd nnre 0re resubcl sylancl 2re simp2 simp3 leidd fzmaxdif syl221anc nnrp
    remulcl crp ltaddrpd recnd subid1d 2timesd 3brtr4d lelttrd wb simpl1 simpl2
    2nn nnmulcl syl simpl3 simpr congabseq syl31anc mpbid simpll2 zred renegcld
    elfzle1 resubcld 1re znegcld abssubd elfzel1 0z a1i 1z zsubcl fzneg syl3anc
    neg0 oveq2d eleqtrd cn0 simp1 nnm1nn0 nn0ge0d 0cn subid1i ax-1cn addsubassd
    oveq1d subcl subnegd 3eqtr4rd ltm1d simplr le0neg1d mpbird letri3 mpbir2and
    cc eqbrtrd negeqd eqtrd 3eqtr4d fveq2d eqbrtrrd ppncand eqtr4d breqtrrd cuz
    addcomd dvdsadd nnnn0 nn0uz syl6eleq fzm1 biimpa mpjaodan jaodan impbida )
    AUADZBEAUBFZDZCUUNDZUCZBCGZHAUDFZBCIFZJKZUUSBCUEZIFZJKZUFUUQUURLZUVAUVDUVEU
    USBBIFZUUTJUUQUUSUVFJKZUURUUQUUSMDZBMDZUVGUUQHMDAMDZUVHUGUUMUUOUVJUUPAUHUIZ
    HAUJUKZUUOUUMUVIUUPBEAULZUNZUUSBUMUOUPUURUVFUUTGUUQBCBIUQNURUSUUQUVAUURUVDU
    UQUVALZUUTUTVAZUUSOKZUURUUQUVQUVAUUQUVPAEIFZUUSUUQUUTUUQUUTUUQBCUVNUUPUUMCM
    DZUUOCEAULZVBZVCVEVDUUQASDZESDZUVRSDUUMUUOUWBUUPAVFUIZVGAEVHVIZUUQHSDUWBUUS
    SDZVJUWDHAVQUKZUUQUVJUUOUVJUUPUVRUVRPKUVPUVRPKUVKUUMUUOUUPVKUVKUUMUUOUUPVLZ
    UUQUVRUWEVMBEACEAVNVOUUQAAAQFZUVRUUSOUUQAAUWDUUMUUOAVRDUUPAVPUIVSUUQAUUQAUW
    DVTZWAUUQAUWJWBZWCWDZUPUVOUUSUADZUVIUVSUVAUVQUURWEUVOHUADZUUMUWMWHUUMUUOUUP
    UVAWFHAWIZUKUVOUUOUVIUUMUUOUUPUVAWGUVMWJUVOUUPUVSUUMUUOUUPUVAWKUVTWJUUQUVAW
    LUUSBCWMWNWOUUQUVDLZCEATIFZUBFDZUURCAGZUWPUWRLZUVBEBCUWTUVBEUEZEUWTCEUWTCEG
    ZCEPKZECPKZUWTUXCEUVBPKUWTEBUVBPUWTUUOEBPKUUMUUOUUPUVDUWRWPZBEAWSWJUWTUVCUT
    VAZUUSOKZBUVBGZUWTUXFAUWQUEZIFZUUSUUQUXFSDUVDUWRUUQUVCUUQUVCUUQBUVBUUQBUVNW
    QUUQCUUQCUWAWQWRWTVTVDRUUQUXJSDUVDUWRUUQAUXIUWDUUQUWQUUQUWBTSDUWQSDUWDXAATV
    HVIWRWTRUUQUWFUVDUWRUWGRUWTUXFUVBBIFUTVAZUXJPUWTBUVBUWTBUUQUVIUVDUWRUVNRZVE
    UWTUVBUUQUVBMDZUVDUWRUUQCUWAXBRZVEXCUWTEMDZUVBUXIEUBFZDUVJUUOEEIFZUXJPKZUXK
    UXJPKUWRUXOUWPCEUWQXDNUWTUVBUXIUXAUBFZUXPUWTUWRUVBUXSDZUWPUWRWLUUQUWRUXTWEZ
    UVDUWRUUQUVSUXOUWQMDZUYAUWAUXOUUQXEXFUUQUVJTMDUYBUVKXGATXHVICEUWQXIXJRWOUWT
    UXAEUXIUBUXAEGUWTXKXFZXLXMUUQUVJUVDUWRUVKRUXEUUQUXRUVDUWRUUQEUUSTIFZUXQUXJP
    UUQUYDUUQUWMUYDXNDUUQUWNUUMUWMWHUUMUUOUUPXOUWOUKZUUSXPWJXQUXQEGUUQEXRXSXFUU
    QUWITIFAUWQQFUYDUXJUUQAATUWJUWJTYLDZUUQXTXFYAUUQUUSUWITIUWKYBUUQAUWQUWJUUQA
    YLDUYFUWQYLDUWJXTATYCVIYDYEZWCRUVBUXIEBEAVNVOYMUUQUXJUUSOKUVDUWRUUQUXJUYDUU
    SOUYGUUQUUSUWGYFYMRWDUWTUWMUVIUXMUVDUXGUXHWEUUQUWMUVDUWRUYERUXLUXNUUQUVDUWR
    YGUUSBUVBWMWNWOZURUWTCUWRCSDZUWPUWRCCEUWQULWQNZYHYIUWRUXDUWPCEUWQWSNUWTUYIU
    WCUXBUXCUXDLWEUYJVGCEYJVIYKZYNUYCYOUYHUYKYPUWPUWSLZBACUYLBAIFZUTVAZUUSOKZBA
    GZUYLUVPUYNUUSOUYLUUTUYMUTUWSUUTUYMGUWPCABIUQNYQUUQUVQUVDUWSUWLRYRUYLUWMUVI
    UVJUUSUYMJKZUYOUYPWEUUQUWMUVDUWSUYERUUQUVIUVDUWSUVNRUUQUVJUVDUWSUVKRUYLUYQU
    USUUSUYMQFZJKZUYLUUSUVCUYRJUUQUVDUWSYGUYLUWIUYMQFZBCQFZUYRUVCUYLUYTBAQFZVUA
    UUQUYTVUBGUVDUWSUUQUYTABQFVUBUUQAABUWJUWJUUQBUVNVEZYSUUQABUWJVUCUUCYORUWSVU
    AVUBGUWPCABQUQNYTUUQUYRUYTGUVDUWSUUQUUSUWIUYMQUWKYBRUUQUVCVUAGUVDUWSUUQBCVU
    CUUQCUWAVEYDRYPUUAUYLUVHUYMMDZUYQUYSWEUUQUVHUVDUWSUVLRUUQVUDUVDUWSUUQBAUVNU
    VKVCRUUSUYMUUDUOYIUUSBAWMWNWOUWPUWSWLYTUUQUWRUWSUFZUVDUUQAEUUBVAZDZUUPVUEUU
    QAXNVUFUUMUUOAXNDUUPAUUEUIUUFUUGUWHVUGUUPVUECEAUUHUUIUOUPUUJUUKUUL $.

  $( Alternating congruence passes from a base to a dividing base.
     (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
  dvdsacongtr $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ D e. ZZ ) /\ ( D
      || A /\ ( A || ( B - C ) \/ A || ( B - -u C ) ) ) ) -> ( D || ( B - C )
      \/ D || ( B - -u C ) ) ) $=
    ( cz wcel wa cdivides wbr cmin co wo simplr simpr wi simp-4l zsubcld dvdstr
    ad2antrr syl3anc cneg simprr simprl mp2and znegcld orim12d expimpd 3impia
    ex ) AEFZBEFZGZCEFZDEFZGZDAHIZABCJKZHIZABCUAZJKZHIZLZGDUQHIZDUTHIZLZULUOGZU
    PVBVEVFUPGZURVCVAVDVGURVCVGURGZUPURVCVFUPURMVGURNVHUNUJUQEFUPURGVCOVFUNUPUR
    ULUMUNUBZSUJUKUOUPURPVHBCVFUKUPURUJUKUOMZSVFUMUPURULUMUNUCZSQDAUQRTUDUIVGVA
    VDVGVAGZUPVAVDVFUPVAMVGVANVLUNUJUTEFUPVAGVDOVFUNUPVAVISUJUKUOUPVAPVLBUSVFUK
    UPVAVJSVLCVFUMUPVAVKSUEQDAUTRTUDUIUFUGUH $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Additional theorems on integer divisibility
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Partial converse to ~ bezout .  Existence of a linear combination does not
     set the GCD, but it does upper bound it.  (Contributed by Stefan O'Rear,
     23-Sep-2014.) $)
  bezoutr $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( X e. ZZ /\ Y e. ZZ ) ) -> ( A
      gcd B ) || ( ( A x. X ) + ( B x. Y ) ) ) $=
    ( cz wcel wa cgcd co cdivides wbr caddc gcdcl adantr zmulcld w3a dvdsmultr1
    cmul imp syl31anc nn0zd simpll simprl simplr simprr gcddvds simpld dvds2add
    simprd syl32anc ) AEFZBEFZGZCEFZDEFZGZGZABHIZEFZACRIZEFZBDRIZEFZURUTJKZURVB
    JKZURUTVBLIJKZUMUSUPUMURABMUANZUQACUKULUPUBZUMUNUOUCZOUQBDUKULUPUDZUMUNUOUE
    ZOUQUSUKUNURAJKZVDVGVHVIUQVLURBJKZUMVLVMGUPABUFNZUGUSUKUNPVLVDURACQSTUQUSUL
    UOVMVEVGVJVKUQVLVMVNUIUSULUOPVMVEURBDQSTUSVAVCPVDVEGVFURUTVBUHSUJ $.

  $( Converse of ~ bezout for the gcd = 1 case, sufficient condition for
     relative primality.  (Contributed by Stefan O'Rear, 23-Sep-2014.) $)
  bezoutr1 $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( X e. ZZ /\ Y e. ZZ ) ) -> ( (
      ( A x. X ) + ( B x. Y ) ) = 1 -> ( A gcd B ) = 1 ) ) $=
    ( cz wcel wa cmul co caddc c1 wceq wbr cdivides a1i syl2anc cc0 wne oveq1
    cn cgcd cle bezoutr adantr simpr breqtrd wi gcdcl nn0zd ad2antrr 1nn dvdsle
    mpd wb wn simpll oveqan12d zcn mul02d sylan9eqr 00id syl6eq adantll ax-1ne0
    necomi eqnetrd ex necon2bd imp gcdn0cl nnle1eq1 syl mpbid ) AEFBEFGZCEFZDEF
    ZGZGZACHIZBDHIZJIZKLZABUAIZKLZVRWBGZWCKUBMZWDWEWCKNMZWFWEWCWAKNVRWCWANMWBAB
    CDUCUDVRWBUEUFWEWCEFZKTFZWGWFUGVNWHVQWBVNWCABUHUIUJWIWEUKOWCKULPUMWEWCTFZWF
    WDUNWEVNAQLZBQLZGZUOZWJVNVQWBUPVRWBWNVRWMWAKVRWMWAKRVRWMGZWAQKVQWMWAQLVNVQW
    MGWAQQJIZQWMVQWAQCHIZQDHIZJIWPWKWLVSWQVTWRJAQCHSBQDHSUQVOVPWQQWRQJVOCCURUSV
    PDDURUSUQUTVAVBVCQKRWOKQVDVEOVFVGVHVIABVJPWCVKVLVMVG $.

  $( Multiplication by a coprime number does not affect divisibility.
     (Contributed by Stefan O'Rear, 23-Sep-2014.) $)
  coprmdvdsb $p |- ( ( K e. ZZ /\ N e. ZZ /\ ( M e. ZZ /\ ( K gcd M ) = 1 ) )
      -> ( K || N <-> K || ( M x. N ) ) ) $=
    ( cz wcel cgcd co c1 wceq wa w3a cdivides wbr simp1 simp3l simp2 dvdsmultr2
    cmul wi syl3anc simp3r coprmdvds mpan2d impbid ) ADEZCDEZBDEZABFGHIZJZKZACL
    MZABCRGLMZUJUEUGUFUKULSUEUFUINZUEUFUGUHOZUEUFUIPZABCQTUJULUHUKUEUFUGUHUAUJU
    EUGUFULUHJUKSUMUNUOABCUBTUCUD $.

  $( The absolute value of an integer is an integer.  (Contributed by Stefan
     O'Rear, 24-Sep-2014.) $)
  zabscl $p |- ( A e. ZZ -> ( abs ` A ) e. ZZ ) $=
    ( cz wcel cabs cfv nn0abscl nn0zd ) ABCADEAFG $.

  $( The square of a natural number is a natural number.  (Contributed by
     Stefan O'Rear, 16-Oct-2014.) $)
  nn0sqcl $p |- ( A e. NN0 -> ( A ^ 2 ) e. NN0 ) $=
    ( cn0 wcel c2 cexp co 2nn0 nn0expcl mpan2 ) ABCDBCADEFBCGADHI $.

  $( Transfer divisibility to an order constraint on absolute values.
     (Contributed by Stefan O'Rear, 24-Sep-2014.) $)
  dvdsleabs2 $p |- ( ( M e. ZZ /\ N e. ZZ /\ N =/= 0 ) -> ( M || N -> ( abs ` M
      ) <_ ( abs ` N ) ) ) $=
    ( cz wcel cc0 wne w3a cdivides wbr cabs cfv cle wa zabscl 3anim1i adantr wb
    absdvdsb 3adant3 biimpa dvdsleabs sylc ex ) ACDZBCDZBEFZGZABHIZAJKZBJKLIZUG
    UHMUICDZUEUFGZUIBHIZUJUGULUHUDUKUEUFANOPUGUHUMUDUEUHUMQUFABRSTUIBUAUBUC $.

  $( Divisibility in terms of modular reduction by the absolute value of the
     base.  (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
  modabsdifz $p |- ( ( N e. RR /\ M e. RR /\ M =/= 0 ) -> ( ( N - ( N mod ( abs
      ` M ) ) ) / M ) e. ZZ ) $=
    ( cr wcel cc0 wne w3a cabs cfv cmo co cmin cz recnd syl absdivd wb redivcld
    cdiv absz crp simp1 simp2 simp3 absrpcld moddifz syl2anc wceq absidm oveq2d
    cc modcld resubcld abscld rpne0d 3eqtr4d eleq1d 3bitr4d mpbid ) BCDZACDZAEF
    ZGZBBAHIZJKZLKZVDSKZMDZVFASKZMDZVCUTVDUADVHUTVAVBUBZVCAVCAUTVAVBUCZNZUTVAVB
    UDZUEZBVDUFUGVCVGHIZMDZVIHIZMDZVHVJVCVPVRMVCVFHIZVDHIZSKVTVDSKVPVRVCWAVDVTS
    VCAUKDWAVDUHVMAUIOUJVCVFVDVCVFVCBVEVKVCBVDVKVOULUMZNZVCVDVCAVMUNZNVCVDVOUOZ
    PVCVFAWCVMVNPUPUQVCVGCDVHVQQVCVFVDWBWDWERVGTOVCVICDVJVSQVCVFAWBVLVNRVITOURU
    S $.

  $( Divisibility in terms of modular reduction by the absolute value of the
     base.  (Contributed by Stefan O'Rear, 24-Sep-2014.) $)
  dvdsabsmod0 $p |- ( ( M e. ZZ /\ N e. ZZ /\ M =/= 0 ) -> ( M || N <-> ( N mod
      ( abs ` M ) ) = 0 ) ) $=
    ( cz wcel cc0 wne w3a cdivides wbr cabs cfv cmin co cmo wb absdvdsb 3adant3
    wceq cc zcn 3ad2ant2 subid1d breq2d bitr4d cn nnabscl 3adant2 simp2 moddvds
    0z a1i syl3anc crp nnrp 0mod 3syl eqeq2d 3bitr2d ) ACDZBCDZAEFZGZABHIZAJKZB
    ELMZHIZBVDNMZEVDNMZRZVGERVBVCVDBHIZVFUSUTVCVJOVAABPQVBVEBVDHVBBUTUSBSDVABTU
    AUBUCUDVBVDUEDZUTECDZVIVFOUSVAVKUTAUFUGZUSUTVAUHVLVBUJUKBEVDUIULVBVHEVGVBVK
    VDUMDVHERVMVDUNVDUOUPUQUR $.

  ${
    $d N a $.  $d D a $.  $d R a $.
    $( ~ divalgmod using a class variable.  (Contributed by Stefan O'Rear,
       17-Oct-2014.) $)
    divalgmodcl $p |- ( ( N e. ZZ /\ D e. NN /\ R e. NN0 ) ->
        ( R = ( N mod D ) <-> ( R < D /\ D || ( N - R ) ) ) ) $=
      ( va cz wcel cn cn0 cmo co wceq clt wbr cmin cdivides wa wb cv wi anbi12d
      eqeq1 eleq1 breq1 oveq2 breq2d imbi2d divalgmod vtoclg impcom ibar adantl
      bibi12d bitr4d 3impa ) CEFZAGFZBHFZBCAIJZKZBALMZACBNJZOMZPZQUOUPPZUQPUSUQ
      VCPZVCUQVDUSVEQZVDDRZURKZVGHFZVGALMZACVGNJZOMZPZPZQZSVDVFSDBHVGBKZVOVFVDV
      PVHUSVNVEVGBURUAVPVIUQVMVCVGBHUBVPVJUTVLVBVGBALUCVPVKVAAOVGBCNUDUETTULUFA
      CDUGUHUIUQVCVEQVDUQVCUJUKUMUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    X and Y sequences 3: Divisibility properties
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A a b $.  $d K a b $.  $d N a b $.
    $( Theorem 2.18 of [JonesMatijasevic] p. 696.  Direct relationship of the
       exponential function to X and Y sequences.  (Contributed by Stefan
       O'Rear, 14-Oct-2014.) $)
    jm2.18 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ K e. NN0 /\ N e. NN0 ) ->
        ( ( ( ( 2 x. A ) x. K ) - ( K ^ 2 ) ) - 1 ) ||
        ( ( ( A rmX N ) - ( ( A - K ) x. ( A rmY N ) ) ) - ( K ^ N ) ) ) $=
      ( wcel cmul co cexp cmin c1 crmx crmy cdivides wbr cz adantr wceq oveq12d
      cc0 syl2anc oveq2 va vb c2 cuz cfv cn0 wa cv caddc eluzelz zmulcl sylancr
      wi 2z nn0z adantl zmulcld zsqcl syl zsubcld peano2zm dvds0 rmx0 rmy0 zcnd
      oveq2d mul01d eqtrd ax-1cn subid1i syl6eq nn0cn exp0d 1m1e0 breqtrrd rmx1
      cc rmy1 mulid1d nncand exp1d subidd cn pm3.43 simpll nnz frmx fovcl nn0zd
      frmy jca nnnn0 zexpcl nnm1nn0 0z zaddcl w3a ad2antrr congid simpr congmul
      syl112anc adantrl simprl congsub zaddcld iddvds subid1d congadd syl322anc
      3jca a1i sqcld addsubd npcand oveq1d eqtr3d ad2antlr expcld subdid mul12d
      expm1t eqtr4d 3eqtrrd congtr rmxluc rmyluc subcld 2cn mulcld mulcl 3eqtrd
      mulcomd nn0cnd sub4d eqcomd expp1d nncn breq2d imbi2d npcan sqvald eqtr2d
      sylancl mulassd addid2d ex expcom a2d syl5 weq 2nn0ind impcom 3impa ) AUC
      UDUEZDZBUFDZCUFDZUCAEFZBEFZBUCGFZHFZIHFZACJFZABHFZACKFZEFZHFZBCGFZHFZLMZU
      URUUPUUQUGZUVKUVLUVCAUAUHZJFZUVEAUVMKFZEFZHFZBUVMGFZHFZLMZUMUVLUVCARJFZUV
      EARKFZEFZHFZBRGFZHFZLMZUMUVLUVCAIJFZUVEAIKFZEFZHFZBIGFZHFZLMZUMUVLUVCAUBU
      HZIHFZJFZUVEAUWPKFZEFZHFZBUWPGFZHFZLMZUMZUVLUVCAUWOJFZUVEAUWOKFZEFZHFZBUW
      OGFZHFZLMZUMZUVLUVCAUWOIUIFZJFZUVEAUXMKFZEFZHFZBUXMGFZHFZLMZUMZUVLUVKUMUA
      UBCUVLUVCRUWFLUVLUVCNDZUVCRLMUVLUVBNDUYBUVLUUTUVAUVLUUSBUVLUCNDANDZUUSNDZ
      UNUUPUYCUUQUCAUJZOZUCAUKULZUUQBNDZUUPBUOUPZUQZUVLUYHUVANDZUYIBURUSZUTZUVB
      VAUSZUVCVBUSZUVLUWFIIHFRUVLUWDIUWEIHUVLUWDIRHFIUVLUWAIUWCRHUUPUWAIPUUQAVC
      OUVLUWCUVEREFRUVLUWBRUVEEUUPUWBRPUUQAVDOVFUVLUVEUVLUVEUVLABUYFUYIUTZVEZVG
      VHQIVIVJVKUVLBUUQBVQDZUUPBVLZUPZVMQVNVKVOUVLUVCRUWMLUYOUVLUWMBBHFRUVLUWKB
      UWLBHUVLUWKAUVEHFBUVLUWHAUWJUVEHUUPUWHAPUUQAVPOUVLUWJUVEIEFUVEUVLUWIIUVEE
      UUPUWIIPUUQAVROVFUVLUVEUYQVSVHQUVLABUVLAUYFVEUYTVTVHUVLBUYTWAQUVLBUYTWBVH
      VOUXDUXLUGUVLUXCUXKUGZUMUWOWCDZUYAUVLUXCUXKWDVUBUVLVUAUXTUVLVUBVUAUXTUMUV
      LVUBUGZVUAUXTVUCVUAUGZUVCUUSUXHEFZUWTHFZUXARUVAUIFZEFZHFZUXSLVUDUYBVUFNDZ
      UGZUUSUXIEFZUXAHFZNDZVUHNDZUGZUVCVUFVUMHFLMZUVCVUMVUHHFZLMZUVCVUILMVUCVUK
      VUAVUCUYBVUJUVLUYBVUBUYNOZVUCVUEUWTVUCUUSUXHUVLUYDVUBUYGOZVUCUXEUXGVUCUXE
      VUCUUPUWONDZUXEUFDUUPUUQVUBWEZVUBVVBUVLUWOWFUPZAUWOUFUUONJWGWHZSWIVUCUVEU
      XFUVLUVENDVUBUYPOZVUCUUPVVBUXFNDVVCVVDAUWONUUONKWJWHZSUQUTZUQZVUCUWQUWSVU
      CUWQVUCUUPUWPNDZUWQUFDVVCVUCVVBVVJVVDUWOVAUSZAUWPUFUUONJWGWHZSWIVUCUVEUWR
      VVFVUCUUPVVJUWRNDVVCVVKAUWPNUUONKWJWHZSUQUTZUTWKOVUCVUPVUAVUCVUNVUOVUCVUL
      UXAVUCUUSUXIVVAVUCUYHUWOUFDZUXINDZUVLUYHVUBUYIOZVUBVVOUVLUWOWLUPZBUWOWMSZ
      UQZVUCUYHUWPUFDZUXANDZVVQVUBVWAUVLUWOWNUPZBUWPWMSZUTVUCUXAVUGVWDUVLVUGNDZ
      VUBUVLRNDZUYKVWEWOUYLRUVAWPULOZUQWKOVUDUYBVUENDZVULNDZWQZUWTNDZVWBUGZUVCV
      UEVULHFLMZUXCVUQVUCVWJVUAVUCUYBVWHVWIVUTVVIVVTXKOVUCVWLVUAVUCVWKVWBVVNVWD
      WKOVUCUXKVWMUXCVUCUXKUGUYBUYDUYDWQZUXHNDZVVPUGZUVCUUSUUSHFLMZUXKVWMUVLVWN
      VUBUXKUVLUYBUYDUYDUYNUYGUYGXKWRVUCVWPUXKVUCVWOVVPVVHVVSWKOUVLVWQVUBUXKUVL
      UYBUYDVWQUYNUYGUVCUUSWSSWRVUCUXKWTUVCUUSUUSUXHUXIXAXBXCVUCUXCUXKXDUVCVUEV
      ULUWTUXAXEXBVUCVUSVUAVUCUVCUXAUVCUVAUIFZEFZVUHHFZVURLVUCUYBVWBVWBVWRNDZVW
      EUVCUXAUXAHFLMZUVCVWRVUGHFLMZUVCVWTLMVUTVWDVWDUVLVXAVUBUVLUVCUVAUYNUYLXFO
      VWGVUCUYBVWBVXBVUTVWDUVCUXAWSSUVLVXCVUBUVLUYBUYBVWFUYKUYKUVCUVCRHFZLMUVCU
      VAUVAHFLMZVXCUYNUYNVWFUVLWOXLUYLUYLUVLUVCUVCVXDLUVLUYBUVCUVCLMUYNUVCXGUSU
      VLUVCUVLUVCUYNVEXHVOUVLUYBUYKVXEUYNUYLUVCUVAWSSUVCUVCRUVAUVAXIXJOUVCUXAUX
      AVWRVUGXAXJVUCVUMVWSVUHHVUCVWSUXAUUTIHFZEFUXAUUTEFZUXAIEFZHFVUMVUCVWRVXFU
      XAEUVLVWRVXFPVUBUVLUVBUVAUIFZIHFVWRVXFUVLUVBUVAIUVLUVBUYMVEUVLBUYTXMZIVQD
      ZUVLVIXLXNUVLVXIUUTIHUVLUUTUVAUVLUUTUYJVEZVXJXOXPXQOVFVUCUXAUUTIVUCBUWPUU
      QUYRUUPVUBUYSXRZVWCXSZUVLUUTVQDVUBVXLOVXKVUCVIXLXTVUCVXGVULVXHUXAHVUCVXGU
      USUXABEFZEFVULVUCUXAUUSBVXNUVLUUSVQDVUBUVLUUSUYGVEOZVXMYAVUCUXIVXOUUSEVUC
      UYRVUBUXIVXOPVXMUVLVUBWTBUWOYBSVFYCVUCUXAVXNVSQYDXPVOOUVCVUFVUMVUHYEXBVUC
      UXSVUIPVUAVUCUXQVUFUXRVUHHVUCUXQUUSUXEEFZUWQHFZUUSUXGEFZUWSHFZHFVXQVXSHFZ
      UWTHFVUFVUCUXNVXRUXPVXTHVUCUUPVVBUXNVXRPVVCVVDAUWOYFSVUCUXPUVEUCUXFAEFZEF
      ZUWRHFZEFUVEVYCEFZUWSHFVXTVUCUXOVYDUVEEVUCUUPVVBUXOVYDPVVCVVDAUWOYGSVFVUC
      UVEVYCUWRVUCABUUPAVQDUUQVUBUUPAUYEVEWRZVXMYHZVUCUCVQDZVYBVQDVYCVQDYIVUCUX
      FAVUCUUPVVBUXFVQDVVCVVDUUPVVBUGZUXFVVGVESZVYFYJUCVYBYKULVUCUUPVVJUWRVQDVV
      CVVKUUPVVJUGZUWRVVMVESZXTVUCVYEVXSUWSHVUCVYEUVEUUSUXFEFZEFVXSVUCVYCVYMUVE
      EVUCVYCUXFUUSEFVYMVUCUCUXFAVYHVUCYIXLVYJVYFYAVUCUXFUUSVYJVXPYMVHVFVUCUVEU
      USUXFVYGVXPVYJYAVHXPYLQVUCVXQUWQVXSUWSVUCUUSUXEVXPVUCUUPVVBUXEVQDVVCVVDVY
      IUXEVVEYNSZYJVUCUUPVVJUWQVQDVVCVVKVYKUWQVVLYNSVUCUUSUXGVXPVUCUVEUXFVYGVYJ
      YJZYJVUCUVEUWRVYGVYLYJYOVUCVYAVUEUWTHVUCVUEVYAVUCUUSUXEUXGVXPVYNVYOXTYPXP
      YLVUCUXRUXIBEFVXOBEFZVUHVUCBUWOVXMVVRYQVUCUXIVXOBEVUCBUWPIUIFZGFUXIVXOVUC
      VYQUWOBGVUCUWOVQDZVXKVYQUWOPVUBVYRUVLUWOYRUPVIUWOIUUAUUDVFVUCBUWPVXMVWCYQ
      XQXPVUCVYPUXABBEFZEFVUHVUCUXABBVXNVXMVXMUUEVUCVYSVUGUXAEUVLVYSVUGPVUBUVLV
      UGUVAVYSUVLUVAVXJUUFUVLBUYTUUBUUCOVFVHYLQOVOUUGUUHUUIUUJUVMRPZUVTUWGUVLVY
      TUVSUWFUVCLVYTUVQUWDUVRUWEHVYTUVNUWAUVPUWCHUVMRAJTVYTUVOUWBUVEEUVMRAKTVFQ
      UVMRBGTQYSYTUVMIPZUVTUWNUVLWUAUVSUWMUVCLWUAUVQUWKUVRUWLHWUAUVNUWHUVPUWJHU
      VMIAJTWUAUVOUWIUVEEUVMIAKTVFQUVMIBGTQYSYTUVMUWPPZUVTUXCUVLWUBUVSUXBUVCLWU
      BUVQUWTUVRUXAHWUBUVNUWQUVPUWSHUVMUWPAJTWUBUVOUWRUVEEUVMUWPAKTVFQUVMUWPBGT
      QYSYTUAUBUUKZUVTUXKUVLWUCUVSUXJUVCLWUCUVQUXHUVRUXIHWUCUVNUXEUVPUXGHUVMUWO
      AJTWUCUVOUXFUVEEUVMUWOAKTVFQUVMUWOBGTQYSYTUVMUXMPZUVTUXTUVLWUDUVSUXSUVCLW
      UDUVQUXQUVRUXRHWUDUVNUXNUVPUXPHUVMUXMAJTWUDUVOUXOUVEEUVMUXMAKTVFQUVMUXMBG
      TQYSYTUVMCPZUVTUVKUVLWUEUVSUVJUVCLWUEUVQUVHUVRUVIHWUEUVNUVDUVPUVGHUVMCAJT
      WUEUVOUVFUVEEUVMCAKTVFQUVMCBGTQYSYTUULUUMUUN $.
  $}

  $( Lemma for ~ jm2.19 .  X and Y values are coprime.  (Contributed by Stefan
     O'Rear, 23-Sep-2014.) $)
  jm2.19lem1 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ ) -> ( ( A rmX M ) gcd ( A
      rmY M ) ) = 1 ) $=
    ( c2 wcel cz crmx co cmul crmy cexp cmin cneg caddc wceq fovcl sqcld sqvald
    c1 cn zcnd cuz cfv wa cgcd frmx nn0cnd csquarenn rmspecnonsq eldifad adantr
    cn0 nncnd frmy mulcld negsubd oveq2d mulneg1d nnnegz mul12d 3eqtr3d oveq12d
    syl rmxynorm wi nn0zd zmulcld bezoutr1 syl22anc mpd ) ACUAUBZDZBEDZUCZABFGZ
    VNHGZABIGZACJGRKGZLZVPHGZHGZMGZRNZVNVPUDGRNZVMVNCJGZVQVPCJGZHGZLZMGWDWFKGWA
    RVMWDWFVMVNVMVNABUKVJEFUEOZUFZPVMVQWEVMVQVKVQSDZVLVKVQSUGAUHUIUJZULZVMVPVMV
    PABEVJEIUMOZTZPZUNUOVMWDVOWGVTMVMVNWIQVMVRWEHGVRVPVPHGZHGWGVTVMWEWPVRHVMVPW
    NQUPVMVQWEWLWOUQVMVRVPVPVMVRVMWJVREDWKVQURVBZTWNWNUSUTVAABVCUTVMVNEDZVPEDWR
    VSEDWBWCVDVMVNWHVEZWMWSVMVRVPWQWMVFVNVPVNVSVGVHVI $.

  $( Lemma for ~ jm2.19 .  (Contributed by Stefan O'Rear, 23-Sep-2014.) $)
  jm2.19lem2 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) -> ( ( A rmY M
      ) || ( A rmY N ) <-> ( A rmY M ) || ( A rmY ( N + M ) ) ) ) $=
    ( wcel cz crmy co cdivides wbr crmx cmul caddc cgcd c1 wceq wb frmy 3adant3
    fovcl cn0 c2 cuz cfv w3a 3adant2 frmx nn0zd gcdcom syl2anc jm2.19lem1 eqtrd
    coprmdvdsb syl112anc nn0cnd mulcomd breq2d bitrd zmulcld dvdsmul2 dvdsadd2b
    zcnd rmyadd 3com23 mulcld addcomd eqtr2d 3bitrd ) AUAUBUCZDZBEDZCEDZUDZABFG
    ZACFGZHIZVMVNABJGZKGZHIZVMACJGZVMKGZVQLGZHIZVMACBLGFGZHIVLVOVMVPVNKGZHIZVRV
    LVMEDZVNEDZVPEDZVMVPMGZNOVOWEPVIVJWFVKABEVHEFQSRZVIVKWGVJACEVHEFQSUEZVLVPVI
    VJVPTDVKABTVHEJUFSRZUGZVLWIVPVMMGZNVLWFWHWIWNOWJWMVMVPUHUIVIVJWNNOVKABUJRUK
    VMVPVNULUMVLWDVQVMHVLVPVNVLVPWLUNZVLVNWKVAZUOUPUQVLWFVQEDVTEDVMVTHIZVRWBPWJ
    VLVNVPWKWMURVLVSVMVLVSVIVKVSTDVJACTVHEJUFSUEZUGZWJURVLVSEDWFWQWSWJVSVMUSUIV
    MVQVTUTUMVLWAWCVMHVLWCVQVTLGZWAVIVKVJWCWTOACBVBVCVLVQVTVLVNVPWPWOVDVLVSVMVL
    VSWRUNVLVMWJVAVDVEVFUPVG $.

  ${
    $d A a b $.  $d M a b $.  $d N a b $.  $d I a b $.
    $( Lemma for ~ jm2.19 .  (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
    jm2.19lem3 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ ( M e. ZZ /\ N e. ZZ ) /\ I e.
        NN0 ) -> ( ( A rmY M ) || ( A rmY N ) <-> ( A rmY M ) || ( A rmY ( N +
        ( I x. M ) ) ) ) ) $=
      ( wcel cz crmy co cdivides wbr caddc wb wi cc0 oveq1 oveq2d breq2d bibi2d
      cmul c1 va vb c2 cuz cfv wa cn0 cv wceq imbi2d weq cc zcn ad2antrl mul02d
      ad2antll addid1d eqtr2d simp3 simprl simprrl simprrr nn0z zmulcld zaddcld
      w3a adantr jm2.19lem2 syl3anc zcnd addassd nn0cn ax-1cn a1i adddird eqtrd
      mulid2d bitrd 3adant3 3exp a2d nn0ind com12 3impia ) AUCUDUEEZCFEZDFEZUFZ
      BUGEZACGHZADGHZIJZWJADBCSHZKHZGHZIJZLZWIWEWHUFZWQWRWLWJADUAUHZCSHZKHZGHZI
      JZLZMWRWLWJADNCSHZKHZGHZIJZLZMWRWLWJADUBUHZCSHZKHZGHZIJZLZMWRWLWJADXJTKHZ
      CSHZKHZGHZIJZLZMWRWQMUAUBBWSNUIZXDXIWRYBXCXHWLYBXBXGWJIYBXAXFAGYBWTXEDKWS
      NCSOPPQRUJUAUBUKZXDXOWRYCXCXNWLYCXBXMWJIYCXAXLAGYCWTXKDKWSXJCSOPPQRUJWSXP
      UIZXDYAWRYDXCXTWLYDXBXSWJIYDXAXRAGYDWTXQDKWSXPCSOPPQRUJWSBUIZXDWQWRYEXCWP
      WLYEXBWOWJIYEXAWNAGYEWTWMDKWSBCSOPPQRUJWRWKXGWJIWRDXFAGWRXFDNKHDWRXENDKWR
      CWFCULEWEWGCUMUNUOPWRDWGDULEWEWFDUMUPUQURPQXJUGEZWRXOYAYFWRXOYAYFWRXOVFWL
      XNXTYFWRXOUSYFWRXNXTLXOYFWRUFZXNWJAXLCKHZGHZIJZXTYGWEWFXLFEXNYJLYFWEWHUTY
      FWEWFWGVAZYGDXKYFWEWFWGVBZYGXJCYFXJFEWRXJVCVGYKVDZVEACXLVHVIYGYIXSWJIYGYH
      XRAGYGYHDXKCKHZKHXRYGDXKCYGDYLVJYGXKYMVJYGCYKVJZVKYGYNXQDKYGXQXKTCSHZKHYN
      YGXJTCYFXJULEWRXJVLVGTULEYGVMVNYOVOYGYPCXKKYGCYOVQPURPVPPQVRVSVRVTWAWBWCW
      D $.
  $}

  $( Lemma for ~ jm2.19 .  Extend to ZZ by symmetry.  TODO: use ~ zindbi .
     (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
  jm2.19lem4 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ ( M e. ZZ /\ N e. ZZ ) /\ I e. ZZ )
      -> ( ( A rmY M ) || ( A rmY N ) <-> ( A rmY M ) || ( A rmY ( N + ( I x. M
      ) ) ) ) ) $=
    ( wcel cz wa crmy co cdivides wbr cmul caddc wb cneg jm2.19lem3 ad2antrr cc
    cn0 zcn c2 cuz cfv cr wo elznn0 wi 3expia adantr simplll simprl simprr nn0z
    adantl simplr recnd znegclb syl mpbird zmulcld zaddcld simpr syl121anc cmin
    ad2antrl mulneg1d oveq2d ad2antll mulcld addcld pncand 3eqtrd breq2d bitr2d
    negsubd ex jaod expimpd syl5bi 3impia ) AUAUBUCEZCFEZDFEZGZBFEZACHIZADHIZJK
    ZWFADBCLIZMIZHIJKZNZWEBUDEZBSEZBOZSEZUEZGWAWDGZWLBUFWRWMWQWLWRWMGZWNWLWPWRW
    NWLUGWMWAWDWNWLABCDPUHUIWSWPWLWSWPGZWKWFAWJWOCLIZMIZHIZJKZWHWTWAWBWJFEWPWKX
    DNWAWDWMWPUJWRWBWMWPWAWBWCUKQZWTDWIWRWCWMWPWAWBWCULQWTBCWTWEWOFEZWPXFWSWOUM
    UNWTBREWEXFNWTBWRWMWPUOUPZBUQURUSXEUTVAWSWPVBAWOCWJPVCWTXCWGWFJWTXBDAHWTXBW
    JWIOZMIWJWIVDIDWTXAXHWJMWTBCXGWRCREZWMWPWBXIWAWCCTVEQZVFVGWTWJWIWTDWIWRDREZ
    WMWPWCXKWAWBDTVHQZWTBCXGXJVIZVJXMVOWTDWIXLXMVKVLVGVMVNVPVQVRVSVT $.

  $( Lemma 2.19 of [JonesMatijasevic] p. 696.  Transfer divisibility
     constraints between Y-values and their indices.  (Contributed by Stefan
     O'Rear, 24-Sep-2014.) $)
  jm2.19 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. ZZ /\ N e. ZZ ) -> ( M || N <-> (
      A rmY M ) || ( A rmY N ) ) ) $=
    ( cfv wcel cz cdivides wbr crmy co cc0 wceq syl adantr oveq2d cabs ad2antrr
    wb clt syl2anc c2 cuz w3a wa rmyeq0 3adant2 0dvds 3ad2ant3 frmy fovcl simpr
    3bitr4d breq1d simpl1 rmy0 eqtrd wne cmo wi 3adant3 dvds0 3ad2ant1 breqtrrd
    oveq2 breq2d syl5ibrcom wn cle cr crp zre cc 3ad2ant2 simplr absrpcld modlt
    zcn simpll1 simpll3 simpll2 nnabscl zmodcld nn0abscl ltrmynn0 syl3anc mpbid
    cn0 cn nn0zd rmyabs modcld modge0 absidd nn0red ltnled necon3bid dvdsleabs2
    3brtr4d mtod necon4ad impbid simpl2 simpl3 dvdsabsmod0 cmin cdiv cneg caddc
    ex cmul modabsdifz jm2.19lem4 syl121anc recnd subcld divcld mulneg1d mulcld
    znegcld negsubd divcan1d nncand 3eqtrrd bitr4d pm2.61dane ) AUAUBDZEZBFEZCF
    EZUCZBCGHZABIJZACIJZGHZRBKYJBKLZUDZKCGHZKYMGHZYKYNYJYQYRRYOYJCKLZYMKLZYQYRY
    GYIYSYTRYHACUEUFYIYGYQYSRYHCUGUHYJYMFEZYRYTRYGYIUUAYHACFYFFIUIUJUFYMUGMULNY
    PBKCGYJYOUKZUMYPYLKYMGYPYLAKIJZKYPBKAIUUBOYPYGUUCKLZYGYHYIYOUNAUOZMUPUMULYJ
    BKUQZUDZCBPDZURJZKLZYLAUUIIJZGHZYKYNUUGUUJUULYJUUJUULUSUUFYJUULUUJYLUUCGHYJ
    YLKUUCGYJYLFEZYLKGHYGYHUUMYIABFYFFIUIUJUTZYLVAMYGYHUUDYIUUEVBVCUUJUUKUUCYLG
    UUIKAIVDVEVFNUUGUULUUIKUUGUUIKUQZUULVGUUGUUOUDZUULYLPDZUUKPDZVHHZUUPUURUUQS
    HUUSVGUUPUUKAUUHIJZUURUUQSUUPUUIUUHSHZUUKUUTSHZUUPCVIEZUUHVJEZUVAYJUVCUUFUU
    OYIYGUVCYHCVKUHZQZUUPBYJBVLEZUUFUUOYHYGUVGYIBVQVMZQYJUUFUUOVNZVOZCUUHVPTUUP
    YGUUIWGEUUHWGEZUVAUVBRYGYHYIUUFUUOVRZUUPCUUHYGYHYIUUFUUOVSUUPYHUUFUUHWHEYGY
    HYIUUFUUOVTZUVIBWATWBZYJUVKUUFUUOYHYGUVKYIBWCVMQAUUIUUHWDWEWFUUPUURAUUIPDZI
    JZUUKUUPYGUUIFEZUURUVPLUVLUUPUUIUVNWIZAUUIWJTUUPUVOUUIAIUUPUUIUUPCUUHUVFUVJ
    WKUUPUVCUVDKUUIVHHUVFUVJCUUHWLTWMOUPUUPYGYHUUQUUTLUVLUVMABWJTWRUUPUURUUQUUP
    UURUUPUUKFEZUURWGEUUPYGUVQUVSUVLUVRAUUIFYFFIUIUJTZUUKWCMWNUUPUUQUUPUUMUUQWG
    EYJUUMUUFUUOUUNQZYLWCMWNWOWFUUPUUMUVSUUKKUQZUULUUSUSUWAUVTUUPUUOUWBUUGUUOUK
    UUPUUIKUUKKUUPYGUVQUUJUUKKLRUVLUVRAUUIUETWPWFYLUUKWQWEWSXIWTXAUUGYHYIUUFYKU
    UJRYGYHYIUUFXBZYGYHYIUUFXCZYJUUFUKZBCXDWEUUGYNYLACCUUIXEJZBXFJZXGZBXJJZXHJZ
    IJZGHZUULUUGYGYHYIUWHFEYNUWLRYGYHYIUUFUNUWCUWDUUGUWGUUGUVCBVIEZUUFUWGFEYJUV
    CUUFUVENZYJUWMUUFYHYGUWMYIBVKVMNUWEBCXKWEXSAUWHBCXLXMUUGUUKUWKYLGUUGUUIUWJA
    IUUGUWJCUWGBXJJZXGZXHJCUWOXEJZUUIUUGUWIUWPCXHUUGUWGBUUGUWFBUUGCUUIYJCVLEUUF
    YJCUVEXNNZUUGUUIUUGCUUHUWNUUGBYJUVGUUFUVHNZUWEVOWKXNZXOZUWSUWEXPZUWSXQOUUGC
    UWOUWRUUGUWGBUXBUWSXRXTUUGUWQCUWFXEJUUIUUGUWOUWFCXEUUGUWFBUXAUWSUWEYAOUUGCU
    UIUWRUWTYBUPYCOVEYDULYE $.

  $( Lemma for ~ jm2.20nn .  Express X and Y values as a binomial.
     (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
  jm2.21 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ /\ J e. ZZ ) ->
      ( ( A rmX ( N x. J ) ) + ( ( sqr ` ( ( A ^ 2 ) - 1 ) ) x. ( A rmY ( N x.
      J ) ) ) ) =
      ( ( ( A rmX N ) + ( ( sqr ` ( ( A ^ 2 ) - 1 ) ) x. ( A rmY N ) ) ) ^ J )
      ) $=
    ( c2 cuz cfv wcel cz cmul co crmx cexp c1 cmin csqr crmy caddc wceq rmxyval
    wa cc cc0 wne rmbaserp rpcnne0d expmulz sylan zmulcl sylan2 adantrr 3eqtr4d
    oveq1d 3impb ) ADEFGZCHGZBHGZACBIJZKJADLJMNJOFZAUQPJIJQJZACKJURACPJIJQJZBLJ
    ZRUNUOUPTZTZAURQJZUQLJZVDCLJZBLJZUSVAUNVDUAGVDUBUCTVBVEVGRUNVDAUDUEVDCBUFUG
    VBUNUQHGUSVERCBUHAUQSUIVCUTVFBLUNUOUTVFRUPACSUJULUKUM $.

  $( what lemmas can be pulled out of these two to shrink them? $)

  ${
    $d A i x $.  $d N i x $.  $d J i x $.
    $( Lemma for ~ jm2.20nn .  Applying binomial theorem and taking irrational
       part.  (Contributed by Stefan O'Rear, 26-Sep-2014.)  (Revised by Stefan
       O'Rear, 6-May-2015.) $)
    jm2.22 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ /\ J e. NN0 ) ->
        ( A rmY ( N x. J ) ) = sum_ i e. { x e. ( 0 ... J ) | -. 2 || x }
            ( ( J _C i ) x. ( ( ( A rmX N ) ^ ( J - i ) ) x.
            ( ( ( A rmY N ) ^ i ) x. ( ( ( A ^ 2 ) - 1 ) ^ ( ( i - 1 ) / 2 ) )
        ) ) ) ) $=
      ( c2 wcel cz cn0 cmul co wbr cc0 cexp wceq cc zcnd a1i adantr adantrr cuz
      cfv w3a crmx cv cdivides cfz crab cbc cmin c1 csqr crmy csu wn cdiv caddc
      nn0z jm2.21 syl3an3 frmx fovcl 3adant3 nn0cnd eluzelz zsqcl peano2zm 3syl
      wa 3ad2ant1 sqrcld frmy mulcld simp3 binom syl3anc cin c0 rabnc cun rabxm
      fzfid simpl3 elfzelz adantl bccl nn0zd syl2anc fznn0sub elfznn0 fsumsplit
      expcld cfn wss fzfi ssrab2 ssfi mp2an breq2 notbid elrab zexpcl cle simpr
      syl2an 1z ax-mp syl22anc wb 2z 2ne0 syl dvdsval2 mpbid cr 2re 2pos divge0
      elnn0z sylanbrc sylan2b mul12d mulcomd 2nn0 expmuld ad2antrl 2cn divcan2d
      oveq2d sqsqrd oveq1d 3eqtr4d eqtrd mulexpd 3eqtrd cq zmulcld zssq fsumzcl
      sseldi cprime 2prm nprmdvds1 omoe wne zred cn wo dvds0 mpbiri con3i elnn0
      clt sylib orel2 nnm1nn0 nn0ge0d fsummulc2 3eqtr3rd expm1t sumeq2dv eqtr2d
      sylc cdif rmspecsqrnq nn0ssq simp1 simp2 eqcomd biimpa nn0re nn0ge0 sylan
      3ad2ant3 eqeltrd qirropth syl122anc simprd ) BFUAUBZGZEHGZDIGZUCZBEDJKZUD
      KZFAUEZUFLZAMDUGKZUHZDCUEZUIKZBEUDKZDUWJUJKZNKZBFNKZUKUJKZULUBZBEUMKZJKZU
      WJNKZJKZJKZCUNZOZBUWDUMKZUWGUOZAUWHUHZUWKUWNUWRUWJNKZUWPUWJUKUJKZFUPKZNKZ
      JKZJKZJKZCUNZOZUWCUWEUWQUXEJKUQKZUXCUWQUXOJKZUQKZOZUXDUXPVIZUWCUXQUWLUWSU
      QKDNKZUWHUXBCUNZUXSUWBUVTUWADHGZUXQUYBODURZBDEUSUTUWCUWLPGUWSPGUWBUYBUYCO
      UWCUWLUVTUWAUWLIGUWBBEIUVSHUDVAVBVCZVDUWCUWQUWRUWCUWPUWCUWPUVTUWAUWPHGZUW
      BUVTBHGUWOHGUYGFBVEBVFUWOVGVHVJZQVKZUWCUWRUVTUWAUWRHGZUWBBEHUVSHUMVLVBVCZ
      QVMUVTUWAUWBVNUWLUWSCDVOVPUWCUYCUXCUXGUXBCUNZUQKUXSUWCUWIUXGUXBUWHCUWIUXG
      VQVROUWCUWGAUWHVSRUWHUWIUXGVTOUWCUWGAUWHWARUWCMDWBUWCUWJUWHGZVIZUWKUXAUYN
      UWKUYNUWBUWJHGZUWKHGZUVTUWAUWBUYMWCUYMUYOUWCUWJMDWDZWEUWBUYOVIUWKUWJDWFWG
      WHZQZUYNUWNUWTUYNUWLUWMUYNUWLUWCUWLHGZUYMUWCUWLUYFWGSZQUYMUWMIGZUWCUWJMDW
      IWEZWLZUYNUWSUWJUYNUWQUWRUYNUWPUYNUWPUWCUYGUYMUYHSQZVKZUYNUWRUWCUYJUYMUYK
      SQZVMUYMUWJIGZUWCUWJDWJZWEZWLVMVMWKUWCUYLUXRUXCUQUWCUXRUXGUWQUXNJKZCUNUYL
      UWCUXGUXNUWQCUXGWMGZUWCUWHWMGZUXGUWHWNVULMDWOZUXFAUWHWPUWHUXGWQWRRZUYIUWJ
      UXGGZUWCUYMFUWJUFLZUOZVIZUXNPGUXFVURAUWJUWHUWFUWJOUWGVUQUWFUWJFUFWSZWTXAZ
      UWCVUSVIZUWKUXMUWCUYMUWKPGVURUYSTZVVBUWNUXLUWCUYMUWNPGVURVUDTZVVBUXHUXKUW
      CUYMUXHPGVURUYNUXHUWCUYJVUHUXHHGZUYMUYKVUIUWRUWJXBXEZQTZVVBUWPUXJUWCUYMUW
      PPGZVURVUETZVUSUXJIGZUWCVUSUXJHGZMUXJXCLZVVJVUSFUXIUFLZVVKVUSUYOVURUKHGZF
      UKUFLUOZVVMUYMUYOVURUYQSUYMVURXDVVNVUSXFRVVOVUSFUUAGVVOUUBFUUCXGRUWJUKUUD
      XHVUSFHGZFMUUEZUXIHGZVVMVVKXIVVPVUSXJRVVQVUSXKRUYMVVRVURUYMUYOVVRUYQUWJVG
      XLZSFUXIXMVPXNVUSUXIXOGZMUXIXCLFXOGZMFUUMLZVVLUYMVVTVURUYMUXIVVSUUFSVUSUX
      IVUSUWJUUGGZUXIIGVUSUWJMOZUOZVWCVWDUUHZVWCVURVWEUYMVWDVUQVWDVUQFMUFLZVVPV
      WGXJFUUIXGUWJMFUFWSUUJUUKWEVUSVUHVWFUYMVUHVURVUISUWJUULUUNVWDVWCUUOUVCZUW
      JUUPXLUUQVWAVUSXPRVWBVUSXQRUXIFXRXHUXJXSXTZWEZWLZVMZVMZVMYAUURUWCUXGVUKUX
      BCVUPUWCVUSVUKUXBOVVAVVBVUKUWKUWQUXMJKZJKUXBVVBUWQUWKUXMUWCUYMUWQPGZVURVU
      FTZVVCVWMYBVVBVWNUXAUWKJVVBVWNUWNUWQUXLJKZJKUXAVVBUWQUWNUXLVWPVVDVWLYBVVB
      VWQUWTUWNJVVBUXHUWQUWJNKZJKZVWRUXHJKZVWQUWTVVBUXHVWRVVGUWCUYMVWRPGVURUYNU
      WQUWJVUFVUJWLTYCVVBVWQUXHUWQUXKJKZJKVWSVVBUWQUXHUXKVWPVVGVWKYBVVBVXAVWRUX
      HJVVBUXKUWQJKUWQUXINKZUWQJKZVXAVWRVVBUXKVXBUWQJVVBUWQFUXJJKZNKUWQFNKZUXJN
      KVXBUXKVVBUWQFUXJVWPVWJFIGZVVBYDRYEVVBVXDUXIUWQNVVBUXIFUYMUXIPGUWCVURUYMU
      XIVVSQYFFPGZVVBYGRVVQVVBXKRYHYIVVBVXEUWPUXJNVVBUWPVVIYJYKUUSYKVVBUWQUXKVW
      PVWKYCVVBVWOVWCVWRVXCOVWPVUSVWCUWCVWHWEUWQUWJUUTWHYLYIYMUWCUYMUWTVWTOVURU
      YNUWQUWRUWJVUFVUGVUJYNTYLYIYMYIYMYAUVAUVBYIYMYOUWCUWQPYPUVDGZUWEYPGUXEYPG
      UXCYPGUXOYPGUXTUYAXIUVTUWAVXHUWBBUVEVJUWCIYPUWEUVFUWCUVTUWDHGZUWEIGUVTUWA
      UWBUVGZUWCEDUVTUWAUWBUVHUWBUVTUYDUWAUYEUVNYQZBUWDIUVSHUDVAVBWHYTUWCHYPUXE
      YRUWCUVTVXIUXEHGVXJVXKBUWDHUVSHUMVLVBWHYTUWCHYPUXCYRUWCUWIUXBCUWIWMGZUWCV
      UMUWIUWHWNVXLVUNUWGAUWHWPUWHUWIWQWRRUWJUWIGUWCUYMVUQVIZUXBHGUWGVUQAUWJUWH
      VUTXAUWCVXMVIZUWKUXAUWCUYMUYPVUQUYRTVXNUWNUWTUWCUYMUWNHGZVUQUYNUYTVUBVXOV
      UAVUCUWLUWMXBWHZTVXNUWTUWPUWJFUPKZNKZUXHJKZHVXNUWTVWTVXSVXNUWQUWRUWJUWCUY
      MVWOVUQVUFTZUWCUYMUWRPGVUQVUGTUYMVUHUWCVUQVUIYFYNVXNVWRVXRUXHJVXNVWRUWQFV
      XQJKZNKVXEVXQNKVXRVXNUWJVYAUWQNUWCUYMUWJVYAOVUQUYNVYAUWJUYNUWJFUYMUWJPGUW
      CUYMUWJUYQQWEVXGUYNYGRVVQUYNXKRYHUVITYIVXNUWQFVXQVXTVXMVXQIGZUWCUYMVUHVUQ
      VYBVUIVUHVUQVIZVXQHGZMVXQXCLZVYBVUHVUQVYDVUHVVPVVQUYOVUQVYDXIVVPVUHXJRVVQ
      VUHXKRUWJURFUWJXMVPUVJVYCUWJXOGZMUWJXCLZVWAVWBVYEVUHVYFVUQUWJUVKSVUHVYGVU
      QUWJUVLSVWAVYCXPRVWBVYCXQRUWJFXRXHVXQXSXTUVMZWEVXFVXNYDRYEVXNVXEUWPVXQNVX
      NUWPUWCUYMVVHVUQVUETYJYKYOYKYMVXNVXRUXHUWCUYGVYBVXRHGVXMUYHVYHUWPVXQXBXEU
      WCUYMVVEVUQVVFTYQUVOYQYQYAYSYTUWCHYPUXOYRUWCUXGUXNCVUOVUPUWCVUSUXNHGVVAVV
      BUWKUXMUWCUYMUYPVURUYRTVVBUWNUXLUWCUYMVXOVURVXPTVVBUXHUXKUWCUYMVVEVURVVFT
      UWCUYGVVJUXKHGVUSUYHVWIUWPUXJXBXEYQYQYQYAYSYTUWQUWEUXEUXCUXOUVPUVQXNUVR
      $.
  $}

  ${
    $d A a b $.  $d N a b $.  $d J a b $.
    $( Lemma for ~ jm2.20nn .  Truncate binomial expansion p-adicly.
       (Contributed by Stefan O'Rear, 26-Sep-2014.) $)
    jm2.23 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ /\ J e. NN ) -> ( ( A rmY N )
        ^ 3 ) || ( ( A rmY ( N x. J ) ) - ( J x. ( ( ( A rmX N ) ^ ( J - 1 ) )
        x. ( A rmY N ) ) ) ) ) $=
      ( va c2 wcel cz co c3 cexp cdivides wbr c1 cmul a1i wa cn0 syl cc0 cc cuz
      vb cfv cn w3a crmy cv cfz crab cbc crmx cmin cdiv csu cfn wss fzfi ssrab2
      wn ssfi mp2an nnnn0 3ad2ant3 sseli elfzelz bccl syl2an simpl1 simpl2 frmx
      nn0zd fovcl syl2anc adantl fznn0sub zexpcl csquarenn rmspecnonsq 3ad2ant1
      eldifad nnzd cle wceq breq2 notbid elrab simprbi 1z caddc clt 0z 2nn 1lt2
      3pm3.2i 2z ax-mp syl22anc wne wb 2ne0 syl3anc mpbid zred elfzle1 sylanbrc
      cr 3re nnm1nn0 nn0ge0d 2re 2pos elnn0z sylancl zmulcld 3adant3 3nn0 simpr
      adantr ad2antlr biimpi 2cn mpbiri pm2.21dd jaodan mpbir2and nn0cnd expcld
      wo elfz zcnd expcl mulcld mulassd oveq2d oveq1d 3eqtrd eqtrd eqtr2d oveq2
      oveq12d dvds0 ndvdsp1 mp2 0p1e1 breq2i mtbi peano2zm dvdsval2 0re ltletrd
      omoe 3pos elnnz divge0 elfzel1 zsubcld subge0 mpbird fsumzcl dvdsmul2 csn
      frmy jm2.22 syl3an3 cin c0 1lt3 1re ltnlei mpbi mto sylnibr disjsn sylibr
      intnanrd cun olcd elfznn0 simplrr elnn1uz2 df-ne pm2.21d imp uzp1 mulid1i
      dvdsmul1 breqtri eluzle 2p1e3 fveq2i eleq2s sylan2 sylan2b elnn0 mpjaodan
      elfzle2 nn0zi nnz ad2antrr jca orcd pm2.61dane nn0uz eleqtri fzss1 anim1i
      0le1 nnge1 eleq1 anbi12d impbida elun orbi12i bitri eqrdv rmspecpos rpcnd
      elsn 3bitr4g con3and sylbi orel2 sylc fsumsplit fsummulc1 mulcomd expaddd
      wi 3cn npcan eqtr3d sumeq2dv 1nn 1nn0 1m1e0 oveq1i div0i eqtri 0nn0 oveq1
      eqeltri sumsn sylancr eqcomd exp1d exp0d mulid1d fsumcl pncand breqtrrd
      bcn1 ) AEUAUCZFZCGFZBUDFZUEZACUFHZIJHZEUBUGZKLZUSZUBIBUHHZUIZBDUGZUJHZACU
      KHZBVVDULHZJHZAEJHMULHZVVDMULHZEUMHZJHZVUQVVDIULHZJHZNHZNHZNHZDUNZVURNHZA
      CBNHUFHZBVVFBMULHZJHZVUQNHZNHZULHZKVUPVVRGFVURGFZVURVVSKLVUPVVCVVQDVVCUOF
      ZVUPVVBUOFVVCVVBUPVWGIBUQVVAUBVVBURZVVBVVCUTVAOZVUPVVDVVCFZPZVVEVVPVWKVVE
      VUPBQFZVVDGFZVVEQFZVWJVUOVUMVWLVUNBVBZVCZVWJVVDVVBFZVWMVVCVVBVVDVWHVDZVVD
      IBVEZRZVVDBVFZVGZVKVWKVVHVVOVWKVVFGFVVGQFZVVHGFVWKVVFVWKVUMVUNVVFQFZVUMVU
      NVUOVWJVHZVUMVUNVUOVWJVIZACQVULGUKVJVLZVMVKVWKVWQVXCVWJVWQVUPVWRVNVVDIBVO
      RZVVFVVGVPVMVWKVVLVVNVUPVVIGFZVVKQFZVVLGFVWJVUMVUNVXIVUOVUMVVIVUMVVIUDVQA
      VRVTWAVSVWJVVKGFZSVVKWBLZVXJVWJEVVJKLZVXKVWJVWMEVVDKLZUSZMGFZEMKLZUSZVXMV
      WTVWJVWQVXOVVAVXOUBVVDVVBVUSVVDWCVUTVXNVUSVVDEKWDWEZWFZWGVXPVWJWHOVXRVWJE
      SMWIHZKLZVXQSGFZEUDFZMEWJLZUEESKLZVYBUSVYCVYDVYEWKWLWMWNEGFZVYFWOEUUAWPZE
      SUUBUUCVYAMEKUUDUUEUUFZOVVDMUUKZWQVWJVYGESWRZVVJGFZVXMVXKWSZVYGVWJWOOVYKV
      WJWTOVWJVWMVYLVWTVVDUUGZRZEVVJUUHZXAXBVWJVVJXFFZSVVJWBLZEXFFZSEWJLZVXLVWJ
      VVJVYOXCVWJVWQVYRVWRVWQVVJVWQVVDUDFZVVJQFZVWQVWMSVVDWJLWUAVWSVWQSIVVDSXFF
      VWQUUIOIXFFZVWQXGOVWQVVDVWSXCZSIWJLVWQUULOVVDIBXDZUUJVVDUUMXEVVDXHZRXIRVY
      SVWJXJOVYTVWJXKOVVJEUUNZWQVVKXLZXEZVVIVVKVPVGVWKVUQGFZVVMQFZVVNGFVWKVUMVU
      NWUJVXEVXFACGVULGUFUVBVLZVMVWJWUKVUPVWJVWQWUKVWRVWQVVMGFSVVMWBLZWUKVWQVVD
      IVWSVVDIBUUOUUPVWQWUMIVVDWBLZWUEVWQVVDXFFWUCWUMWUNWSWUDXGVVDIUUQXMUURVVMX
      LXERZVNZVUQVVMVPVMXNXNXNZUUSVUPWUJIQFZVWFVUMVUNWUJVUOWULXOZXPVUQIVPXMVVRV
      URUUTVMVUPVWEVVSBMUJHZVWBVUQMJHZVVIMMULHZEUMHZJHZNHZNHZNHZWIHZWVGULHVVSVU
      PVVTWVHVWDWVGULVUPVVTVVAUBSBUHHZUIZVVEVVHVUQVVDJHZVVLNHZNHZNHZDUNZVVCWVND
      UNZMUVAZWVNDUNZWIHWVHVUOVUMVUNVWLVVTWVOWCVWOUBADBCUVCUVDVUPVVCWVQWVNWVJDV
      UPMVVCFZUSVVCWVQUVEUVFWCVUPMVVBFZVXRPWVSVUPWVTVXRWVTUSVUPWVTIMWBLZMIWJLWW
      AUSUVGMIUVHXGUVIUVJMIBXDUVKOUVOVVAVXRUBMVVBVUSMWCVUTVXQVUSMEKWDWEWFUVLVVC
      MUVMUVNVUPDWVJVVCWVQUVPZVUPVVDWVIFZVXOPZVWQVXOPZVVDMWCZYHZVVDWVJFZVVDWWBF
      ZVUPWWDWWGVUPWWDPZWWGVVDMWWJWWFPWWFWWEWWJWWFXQUVQWWJVVDMWRZPZWWEWWFWWLVWQ
      VXOWWLVWQWUNVVDBWBLZWWLVVDQFZVXOWWKWUNWWDWWNVUPWWKWWCWWNVXOVVDBUVRZXRXSVU
      PWWCVXOWWKUVSZWWJWWKXQWWNVXOWWKUEZWUAWUNVVDSWCZWUAWWQWWFVVDVULFZYHWUNVVDU
      VTWWQWWFWUNWWSWWQWWFWUNWWQWWFWUNWWKWWNWWFUSZVXOWWKWWTVVDMUWAXTVCUWBUWCWWS
      WWQVVDEWCZVVDEMWIHZUAUCZFZYHWUNEVVDUWDWWQWXAWUNWXDWWQWXAPZVXNWUNWXEVXNEEK
      LZEEMNHZEKVYGVXPEWXGKLWOWHEMUWFVAEYAUWEUWGWXAVXNWXFWSWWQVVDEEKWDVNYBWWNVX
      OWWKWXAVIYCWXDWUNWWQWUNVVDIUAUCWXCIVVDUWHWXBIUAUWIUWJUWKVNYDUWLYDUWMWWQWW
      RPVXNWUNWWRVXNWWQWWRVXNVYFVYHVVDSEKWDYBZVNWWNVXOWWKWWRVIYCWWNVXOWUAWWRYHZ
      WWKWWNWXIVVDUWNXTZVSUWOXAWWDWWMVUPWWKWWCWWMVXOVVDSBUWPXRXSWWLVWMIGFZBGFZV
      WQWUNWWMPWSWWDVWMVUPWWKWWCVWMVXOVVDSBVEZXRXSWXKWWLIXPUWQOVUPWXLWWDWWKVUOV
      UMWXLVUNBUWRVCZUWSVVDIBYIXAYEWWPUWTUXAUXBVUPWWEWWDWWFWWEWWDVUPVWQWWCVXOVV
      BWVIVVDISUAUCZFVVBWVIUPIQWXOXPUXCUXDISBUXEWPVDUXFVNVUPWWFPZWWDMWVIFZVXRWX
      PWXQSMWBLZMBWBLZWXRWXPUXGOVUPWXSWWFVUOVUMWXSVUNBUXHVCXRWXPVXPVYCWXLWXQWXR
      WXSPWSVXPWXPWHOVYCWXPWKOVUPWXLWWFWXNXRMSBYIXAYEVXRWXPVYIOWWFWWDWXQVXRPWSV
      UPWWFWWCWXQVXOVXRVVDMWVIUXIWWFVXNVXQVVDMEKWDWEUXJVNYEYDUXKVVAVXOUBVVDWVIV
      XSWFZWWIVWJVVDWVQFZYHWWGVVDVVCWVQUXLVWJWWEWYAWWFVXTDMUXRUXMUXNUXSUXOWVJUO
      FZVUPWVIUOFWVJWVIUPWYBSBUQVVAUBWVIURZWVIWVJUTVAOVUPWWHPZVVEWVMWYDVVEVUPVW
      LVWMVWNWWHVWPWWHWWCVWMWVJWVIVVDWYCVDZWXMRZVXAVGYFWYDVVHWVLWYDVVFVVGVUPVVF
      TFZWWHVUPVVFVUMVUNVXDVUOVXGXOYFZXRWYDWWCVXCWWHWWCVUPWYEVNVVDSBVORYGWYDWVK
      VVLVUPVUQTFZWWNWVKTFWWHVUPVUQWUSYJZWWHWWCWWNWYEWWORZVUQVVDYKVGVUPVVITFZVX
      JVVLTFZWWHVUMVUNWYLVUOVUMVVIAUXPUXQVSZWWHVXKVXLVXJWWHVXMVXKWWHVWMVXOVXPVX
      RVXMWYFWWHWWCVXOWXTWGVXPWWHWHOVXRWWHVYIOVYJWQWWHVYGVYKVYLVYMVYGWWHWOOVYKW
      WHWTOWWHVWMVYLWYFVYNRZVYPXAXBWWHVYQVYRVYSVYTVXLWWHVVJWYOXCWWHVVJWWHWUAWUB
      WWHWWRUSZWXIWUAWWHWWDWYPWXTWWCWWRVXNWWRVXNUYHWWCWXHOUXTUYAWWHWWNWXIWYKWXJ
      RWWRWUAUYBUYCWUFRXIVYSWWHXJOVYTWWHXKOWUGWQWUHXEVVIVVKYKZVGYLYLYLUYDVUPWVP
      VVSWVRWVGWIVUPVVSVVCVVQVURNHZDUNWVPVUPVVCVVQVURDVWIVUPWYIWURVURTFZWYJXPVU
      QIYKXMZVWKVVQWUQYJZUYEVUPVVCWYRWVNDVWKWYRVVEVVPVURNHZNHWVNVWKVVEVVPVURVWK
      VVEVXBYFVWKVVHVVOVWKVVFVVGVUPWYGVWJWYHXRVXHYGZVWKVVLVVNVUPWYLVXJWYMVWJWYN
      WUIWYQVGZVUPWYIWUKVVNTFVWJWYJWUOVUQVVMYKVGZYLZYLVUPWYSVWJWYTXRZYMVWKXUBWV
      MVVENVWKXUBVVHVVOVURNHZNHWVMVWKVVHVVOVURXUCXUFXUGYMVWKXUHWVLVVHNVWKXUHVVL
      VVNVURNHZNHXUIVVLNHWVLVWKVVLVVNVURXUDXUEXUGYMVWKVVLXUIXUDVWKVVNVURXUEXUGY
      LUYFVWKXUIWVKVVLNVWKVUQVVMIWIHZJHXUIWVKVWKVUQVVMIVUPWYIVWJWYJXRWURVWKXPOW
      UPUYGVWKXUJVVDVUQJVWKVVDTFITFXUJVVDWCVWKVVDVWJVWMVUPVWTVNYJUYIVVDIUYJXMYN
      UYKYOYPYNYQYNYQUYLYRVUPMUDFWVGTFWVRWVGWCUYMVUPWUTWVFVUOVUMWUTTFVUNVUOWUTV
      UOVWLVXPWUTQFVWOWHMBVFXMYFVCVUPVWBWVEVUPVVFVWAWYHVUOVUMVWAQFVUNBXHVCYGVUP
      WVAWVDVUPWYIMQFWVATFWYJUYNVUQMYKXMVUPWYLWVCQFWVDTFWYNWVCSQWVCSEUMHSWVBSEU
      MUYOUYPEYAWTUYQUYRZUYSVUAVVIWVCYKXMYLYLYLZWVNWVGDMUDWWFVVEWUTWVMWVFNVVDMB
      UJYSWWFVVHVWBWVLWVENWWFVVGVWAVVFJVVDMBULYSYNWWFWVKWVAVVLWVDNVVDMVUQJYSWWF
      VVKWVCVVIJWWFVVJWVBEUMVVDMMULUYTYOYNYTYTYTVUBVUCYTYPVUPBWUTVWCWVFNVUPWUTB
      VUPVWLWUTBWCVWPBVUKRVUDVUPVUQWVEVWBNVUPWVEVUQMNHVUQVUPWVAVUQWVDMNVUPVUQWY
      JVUEVUPWVDVVISJHMVUPWVCSVVIJWVCSWCVUPXUKOYNVUPVVIWYNVUFYQYTVUPVUQWYJVUGYR
      YNYTYTVUPVVSWVGVUPVVRVURVUPVVCVVQDVWIXUAVUHWYTYLXULVUIYQVUJ $.
  $}

  $( Lemma 2.20 of [JonesMatijasevic] p. 696, the "first step down lemma".
     (Contributed by Stefan O'Rear, 27-Sep-2014.) $)
  jm2.20nn $p |- ( ( A e. ( ZZ>= ` 2 ) /\ M e. NN /\ N e. NN ) -> ( ( ( A rmY N
      ) ^ 2 ) || ( A rmY M ) <-> ( N x. ( A rmY N ) ) || M ) ) $=
    ( c2 wcel crmy co cdivides wbr cmul wa syl2anc adantr cmin wceq syl3anc cc0
    cz wb c3 cuz cfv cn w3a cexp cdiv simp1 nnz 3ad2ant3 frmy fovcl zcnd sqvald
    cc crmx c1 cgcd zsqcl syl cn0 nn0zd simpr eqbrtrrd wi 3ad2ant2 muldvds1 mpd
    frmx simpl1 jm2.19 mpbird simpl2 simpl3 nndivdvds mpbid nnm1nn0 zexpcl nnzd
    zmulcld nncn wne nnne0 divcan2d eqeltrd zsubcld 3nn0 a1i 2nn0 cle nn0zi 2re
    oveq2d 3re 2lt3 ltleii eluz1i mpbir2an dvdsexp jm2.23 imp syl32anc dvds2sub
    2z dvdstr oveq1d nncand mul12d breqtrd gcdcom jm2.19lem1 rpexp12i syl112anc
    eqtrd coprmdvds clt 3ad2ant1 nngt0 ltrmy elnnz sylanbrc dvdsmulcr dvdscmulr
    rmy0 0z dvdsmul2 dvdssub2 syl31anc impbida ) ADUAUBZEZBUCEZCUCEZUDZACFGZDUE
    GZABFGZHIZCYNJGZBHIZYMYQKZYRCBCUFGZJGZBHYTYRUUBHIZYNUUAHIZYTYNYNJGZUUAYNJGZ
    HIZUUDYTYOUUEUUFHYTYNYMYNUNEYQYMYNYMYJCREZYNREZYJYKYLUGZYLYJUUHYKCUHUIZACRY
    IRFUJUKLZULZMZUMYTYOREZACUOGZUUAUPNGZUEGZREZUUFREZYOUURUUFJGZHIZYOUURUQGUPO
    ZYOUUFHIZYMUUOYQYMUUIUUOUULYNURUSZMZYTUUPREZUUQUTEZUUSYMUVGYQYMUUPYMYJUUHUU
    PUTEUUJUUKACUTYIRUOVHUKLVAZMZYTUUAUCEZUVHYTCBHIZUVKYTUVLYNYPHIZYTUUEYPHIZUV
    MYTYOUUEYPHYMYOUUEOYQYMYNUUMUMZMYMYQVBZVCYMUVNUVMVDZYQYMUUIUUIYPREZUVQUULUU
    LYMYJBREZUVRUUJYKYJUVSYLBUHVEZABRYIRFUJUKLZYNYNYPVFPMVGYTYJUUHUVSUVLUVMSYJY
    KYLYQVIZYMUUHYQUUKMZYMUVSYQUVTMACBVJPVKYTYKYLUVLUVKSYJYKYLYQVLYJYKYLYQVMBCV
    NLVOZUUAVPUSZUUPUUQVQLZYTUUAYNYTUUAUWDVRZYMUUIYQUULMZVSYTYOYPAUUBFGZUUAUURY
    NJGZJGZNGZNGZUVAHYTUUOUVRUWLREZYQYOUWLHIZYOUWMHIZUVFYMUVRYQUWAMYTUWIUWKYMUW
    IREYQYMUWIYPRYMUUBBAFYMBCYKYJBUNEYLBVTVEYLYJCUNEYKCVTUIYLYJCQWAZYKCWBUIZWCZ
    WLUWAWDMYTUUAUWJUWGYTUURYNUWFUWHVSVSZWEZUVPYTUUOYNTUEGZREZUWNYOUXBHIZUXBUWL
    HIZUWOUVFYMUXCYQYMUUITUTEZUXCUULUXFYMWFWGYNTVQLZMUXAYMUXDYQYMUUIDUTEZTYIEZU
    XDUULUXHYMWHWGUXIYMUXITREDTWIITWFWJDTWKWMWNWODTXCWPWQWGYNDTWRPZMYTYJUUHUVKU
    XEUWBUWCUWDAUUACWSPUUOUXCUWNUDUXDUXEKUWOYOUXBUWLXDWTXAUUOUVRUWNUDYQUWOKUWPY
    OYPUWLXBWTXAYTUWMYPYPUWKNGZNGZUVAYTUWLUXKYPNYTUWIYPUWKNYTUUBBAFYMUUBBOYQUWS
    MZWLXEWLYTUXLUWKUVAYTYPUWKYMYPUNEYQYMYPUWAULMYTUWKUWTULXFYTUUAUURYNYTUUAUWG
    ULYTUURUWFULUUNXGXMXMXHYTYNUUPUQGZUPOZUVCYMUXOYQYMUXNUUPYNUQGZUPYMUUIUVGUXN
    UXPOUULUVIYNUUPXILYMYJUUHUXPUPOUUJUUKACXJLXMMYTUUIUVGUXHUVHUXOUVCVDUWHUVJUX
    HYTWHWGUWEYNUUPDUUQXKXLVGUUOUUSUUTUDUVBUVCKUVDYOUURUUFXNWTXAVCYTUUIUUAREZUU
    IYNQWAZUUGUUDSUWHUWGUWHYMUXRYQYMYNUCEZUXRYMUUIQYNXOIUXSUULYMAQFGZQYNXOYJYKU
    XTQOYLAYCXPYMQCXOIZUXTYNXOIZYLYJUYAYKCXQUIYMYJQREZUUHUYAUYBSUUJUYCYMYDWGUUK
    AQCXRPVOVCYNXSXTZYNWBUSMYNYNUUAYAXLVOYTUUIUXQUUHUWQUUCUUDSUWHUWGUWCYMUWQYQU
    WRMCYNUUAYBXLVKUXMXHYMYSKZUUOAYRFGZREZUVRYOUYFHIZUYFYPHIZYQYMUUOYSUVEMYMUYG
    YSYMYJYRREZUYGUUJYMCYNUUKUULVSZAYRRYIRFUJUKLZMYMUVRYSUWAMYMUYHYSYMUYHYOYNUU
    PYNUPNGZUEGZYNJGZJGZHIZYMYOUYNYOJGZUYPHYMUYNREZUUOYOUYRHIYMUVGUYMUTEZUYSUVI
    YMUXSUYTUYDYNVPUSUUPUYMVQLZUVEUYNYOYELYMUYRUYNUUEJGUYPYMYOUUEUYNJUVOWLYMUYN
    YNYNYMUYNVUAULUUMUUMXGXMXHYMUUOUYGUYPREYOUYFUYPNGZHIZUYHUYQSUVEUYLYMYNUYOUU
    LYMUYNYNVUAUULVSVSZYMUUOUXCVUBREZUXDUXBVUBHIZVUCUVEUXGYMUYFUYPUYLVUDWEUXJYM
    YJUUHUXSVUFUUJUUKUYDAYNCWSPUUOUXCVUEUDUXDVUFKVUCYOUXBVUBXDWTXAYOUYFUYPYFYGV
    KMUYEYSUYIYMYSVBUYEYJUYJUVSYSUYISYJYKYLYSVIYMUYJYSUYKMYMUVSYSUVTMAYRBVJPVOU
    UOUYGUVRUDUYHUYIKYQYOUYFYPXDWTXAYH $.

  $( Lemma for ~ jm2.26 .  (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
  jm2.25lem1 $p |- ( ( ( A e. ZZ /\ B e. ZZ ) /\ ( C e. ZZ /\ D e. ZZ ) /\ ( A
      || ( C - D ) \/ A || ( C - -u D ) ) ) ->
          ( ( A || ( D - B ) \/ A || ( D - -u B ) ) <-> ( A || ( C - B ) \/ A
      || ( C - -u B ) ) ) ) $=
    ( cz wcel wa cmin co cdivides wbr wo simpl1l simpl2l simpl2r simpl1r simpl3
    cneg simpr acongtr w3a syl222anc acongsym syl31anc impbida ) AEFZBEFZGZCEFZ
    DEFZGZACDHIJKACDRHIJKLZUAZADBHIJKADBRZHIJKLZACBHIJKACUNHIJKLZUMUOGUFUIUJUGU
    LUOUPUFUGUKULUOMUIUJUHULUONUIUJUHULUOOUFUGUKULUOPUHUKULUOQUMUOSACDBTUBUMUPG
    ZUFUJUIUGADCHIJKADCRHIJKLZUPUOUFUGUKULUPMZUIUJUHULUPOZUIUJUHULUPNZUFUGUKULU
    PPUQUFUIUJULURUSVAUTUHUKULUPQACDUCUDUMUPSADCBTUBUE $.

  ${
    $d A a b $.  $d M a b $.  $d N a b $.  $d I a b $.
    $( Lemma for ~ jm2.26 .  Remainders mod X(2n) are negaperiodic mod 2n.
       (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
    jm2.25 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ ( M e. ZZ /\ N e. ZZ ) /\ I e. ZZ )
        -> ( ( A rmX N ) || ( ( A rmY ( M + ( I x. ( 2 x. N ) ) ) ) - ( A rmY M
        ) ) \/ ( A rmX N ) || ( ( A rmY ( M + ( I x. ( 2 x. N ) ) ) ) - -u ( A
        rmY M ) ) ) ) $=
      ( c2 wcel cz cmul caddc crmy cmin cdivides wbr syl2anc wceq oveq2d oveq1d
      co c1 zcnd va vb cuz cfv wa crmx cneg wo cc0 wi simprl simprrr frmx fovcl
      cn0 nn0zd simprrl frmy congid cc 2cn a1i zcn mulcld mul02d adantl addid1d
      adantr eqtrd ad2antll breqtrrd orcd ex cv simpl peano2zd eluzel2 ad2antrl
      zmulcld zaddcld znegcld zsubcld dvdsmul2 cexp rmxdbl nn0cnd ax-1cn npcand
      wb sqvald w3a mulass eqcomd syl3anc 3eqtrd dvdsmultr2 mpd mulid1d subnegd
      sqcld adddid 3eqtr4d breqtrd rmydbl dvds2add imp syl32anc adddird addassd
      mul32d mulid2d 3eqtr2d rmyadd addsubd jm2.25lem1 syl221anc pm5.74da oveq1
      1z olcd weq breq2d orbi12d imbi2d zindbi mpbid impcom 3impa ) AEUCUDZFZCG
      FZDGFZUEZBGFZADUFRZACBEDHRZHRZIRZJRZACJRZKRZLMZYOYSYTUGZKRZLMZUHZYNYJYMUE
      ZUUFYNUUGYOACUIYPHRZIRZJRZYTKRZLMZYOUUJUUCKRZLMZUHZUJZUUGUUFUJZYNUUGUUOYN
      UUGUEZUULUUNUURYOYTYTKRZUUKLUURYOGFZYTGFZYOUUSLMUURYJYLUUTYNYJYMUKZYNYJYK
      YLULYJYLUEYOADUOYIGUFUMUNZUPZNUURYJYKUVAUVBYNYJYKYLUQACGYIGJURUNZNYOYTUSN
      UURUUJYTYTKUURUUICAJYMUUICOYNYJYMUUICUIIRZCYMUUHUICIYLUUHUIOYKYLYPYLEDEUT
      FZYLVAVBDVCVDVEVFPYKUVFCOYLYKCCVCVGVHVIVJPQVKVLVMUUGYOACUAVNZYPHRZIRZJRZY
      TKRZLMZYOUVKUUCKRZLMZUHZUJUUGYOACUBVNZYPHRZIRZJRZYTKRZLMZYOUVTUUCKRZLMZUH
      ZUJUUGYOACUVQSIRZYPHRZIRZJRZYTKRZLMZYOUWIUUCKRZLMZUHZUJUUPUUQUAUBBUVQGFZU
      UGUWEUWNUWOUUGUEZUUTUVAUWIGFZUVTGFZYOUWIUVTKRLMZYOUWIUVTUGZKRZLMZUHUWEUWN
      WIUWPYJYLUUTUWOYJYMUKZUWOYJYKYLULZUVDNZUWPYJYKUVAUXCUWOYJYKYLUQZUVENUWPYJ
      UWHGFUWQUXCUWPCUWGUXFUWPUWFYPUWPUVQUWOUUGVOZVPUWPEDYJEGFUWOYMEAVQVRZUXDVS
      ZVSVTAUWHGYIGJURUNNUWPYJUVSGFZUWRUXCUWPCUVRUXFUWPUVQYPUXGUXIVSZVTZAUVSGYI
      GJURUNNZUWPUXBUWSUWPYOUVTAYPUFRZHRZUWTKRZAUVSUFRZAYPJRZHRZIRZUXALUWPUUTUX
      PGFZUXSGFZYOUXPLMZYOUXSLMZYOUXTLMZUXEUWPUXOUWTUWPUVTUXNUXMUWPYJYPGFZUXNGF
      UXCUXIYJUYFUEUXNAYPUOYIGUFUMUNUPNZVSZUWPUVTUXMWAZWBUWPUXQUXRUWPYJUXJUXQGF
      ZUXCUXLYJUXJUEUXQAUVSUOYIGUFUMUNUPNZUWPYJUYFUXRGFZUXCUXIAYPGYIGJURUNNZVSZ
      UWPYOUVTUXNSIRZHRZUXPLUWPYOUYOLMZYOUYPLMZUWPYOEYOHRZYOHRZUYOLUWPUYSGFUUTY
      OUYTLMUWPEYOUXHUXEVSUXEUYSYOWCNUWPUYOEYOEWDRZHRZSKRZSIRVUBUYTUWPUXNVUCSIU
      WPYJYLUXNVUCOUXCUXDADWENQUWPVUBSUWPEVUAUVGUWPVAVBZUWPYOUWPYOUWPYJYLYOUOFU
      XCUXDUVCNWFZWTVDSUTFUWPWGVBZWHUWPVUBEYOYOHRZHRZUYTUWPVUAVUGEHUWPYOVUEWJPU
      WPUVGYOUTFZVUIVUHUYTOVUDVUEVUEUVGVUIVUIWKUYTVUHEYOYOWLWMWNVIWOVKUWPUUTUWR
      UYOGFUYQUYRUJUXEUXMUWPUXNUYGVPYOUVTUYOWPWNWQUWPUXOUVTSHRZIRUXOUVTIRUYPUXP
      UWPVUJUVTUXOIUWPUVTUWPUVTUXMTZWRPUWPUVTUXNSVUKUWPUXNUYGTVUFXAUWPUXOUVTUWP
      UXOUYHTZVUKWSXBXCUWPYOUXRLMZUYDUWPYOEADJRZHRZYOHRZUXRLUWPVUOGFUUTYOVUPLMU
      WPEVUNUXHUWPYJYLVUNGFUXCUXDADGYIGJURUNNZVSUXEVUOYOWCNUWPUXRUYSVUNHRZVUPUW
      PYJYLUXRVUROUXCUXDADXDNUWPEYOVUNVUDVUEUWPVUNVUQTXJVIVKUWPUUTUYJUYLVUMUYDU
      JUXEUYKUYMYOUXQUXRWPWNWQUUTUYAUYBWKUYCUYDUEUYEYOUXPUXSXEXFXGUWPUXAUXOUXSI
      RZUWTKRUXTUWPUWIVUSUWTKUWPUWIAUVSYPIRZJRZVUSUWPUWHVUTAJUWPUWHCUVRSYPHRZIR
      ZIRUVSVVBIRVUTUWPUWGVVCCIUWPUVQSYPUWPUVQUXGTVUFUWPYPUXITZXHPUWPCUVRVVBUWP
      CUXFTUWPUVRUXKTUWPVVBUWPSYPSGFUWPXSVBUXIVSTXIUWPVVBYPUVSIUWPYPVVDXKPXLPUW
      PYJUXJUYFVVAVUSOUXCUXLUXIAUVSYPXMWNVIQUWPUXOUXSUWTVULUWPUXSUYNTUWPUWTUYIT
      XNVIVKXTYOYTUWIUVTXOXPXQUAUBYAZUVPUWEUUGVVEUVMUWBUVOUWDVVEUVLUWAYOLVVEUVK
      UVTYTKVVEUVJUVSAJVVEUVIUVRCIUVHUVQYPHXRPPZQYBVVEUVNUWCYOLVVEUVKUVTUUCKVVF
      QYBYCYDUVHUWFOZUVPUWNUUGVVGUVMUWKUVOUWMVVGUVLUWJYOLVVGUVKUWIYTKVVGUVJUWHA
      JVVGUVIUWGCIUVHUWFYPHXRPPZQYBVVGUVNUWLYOLVVGUVKUWIUUCKVVHQYBYCYDUVHUIOZUV
      PUUOUUGVVIUVMUULUVOUUNVVIUVLUUKYOLVVIUVKUUJYTKVVIUVJUUIAJVVIUVIUUHCIUVHUI
      YPHXRPPZQYBVVIUVNUUMYOLVVIUVKUUJUUCKVVJQYBYCYDUVHBOZUVPUUFUUGVVKUVMUUBUVO
      UUEVVKUVLUUAYOLVVKUVKYSYTKVVKUVJYRAJVVKUVIYQCIUVHBYPHXRPPZQYBVVKUVNUUDYOL
      VVKUVKYSUUCKVVLQYBYCYDYEYFYGYH $.
  $}

  ${
    $d A a $.  $d N a $.  $d K a $.  $d M a $.
    $( Lemma for ~ jm2.26 .  Reverse direction is required to prove forward
       direction, so do it separatly.  Induction on difference between K and M,
       together with the addition formula fact that adding 2N only inverts
       sign.  (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
    jm2.26a $p |- ( ( ( A e. ( ZZ>= ` 2 ) /\ N e. ZZ ) /\ ( K e. ZZ /\ M e. ZZ
        ) ) -> ( ( ( 2 x. N ) || ( K - M ) \/ ( 2 x. N ) || ( K - -u M ) ) -> (
        ( A rmX N ) || ( ( A rmY K ) - ( A rmY M ) ) \/ ( A rmX N ) || ( ( A
        rmY K ) - -u ( A rmY M ) ) ) ) ) $=
      ( va c2 wcel cz wa co cmin cdivides wbr crmy cneg wo syl2anc caddc adantr
      wceq cuz cfv cmul crmx cv wrex wb 2z simplr zmulcl sylancr zsubcl divides
      adantl simplll simplrr simpllr simpr jm2.25 syl121anc oveq2 oveq2d cc zcn
      pncan3 syl2anr ad2antlr sylan9eqr eqidd acongeq12d mpbid rexlimdva sylbid
      simprl znegcl ad2antll zsubcld w3a cn0 frmx fovcl nn0zd simplrl frmy 3jca
      ex negcld rmyneg acongneg2 jaod ) AFUAUBZGZDHGZIZBHGZCHGZIZIZFDUCJZBCKJZL
      MZADUDJZABNJZACNJZKJLMXBXCXDOZKJLMZPZWSBCOZKJZLMZWRXAEUEZWSUCJZWTTZEHUFZX
      GWRWSHGZWTHGZXAXNUGWRFHGWMXOUHWLWMWQUIFDUJUKZWQXPWNBCULUNEWSWTUMQWRXMXGEH
      WRXKHGZIZXMXGXSXMIZXBACXLRJZNJZXDKJLMXBYBXEKJLMPZXGXSYCXMXSWLWPWMXRYCWLWM
      WQXRUOZWNWOWPXRUPZWLWMWQXRUQZWRXRURZAXKCDUSUTSXTXBYBXCXDXDXMXSYBACWTRJZNJ
      XCXMYAYHANXLWTCRVAVBXSYHBANWQYHBTZWNXRWPCVCGBVCGZYIWOCVDZBVDZCBVEVFVGVBVH
      XTXDVIVJVKWFVLVMWRXJXLXITZEHUFZXGWRXOXIHGXJYNUGXQWRBXHWNWOWPVNWPXHHGZWNWO
      CVOVPZVQEWSXIUMQWRYMXGEHXSYMXGXSYMIZXBHGZXCHGZXDHGZVRZXFXBXCXEOKJLMPZXGXS
      UUAYMXSYRYSYTXSWLWMYRYDYFWNXBADVSWKHUDVTWAWBQXSWLWOYSYDWNWOWPXRWCABHWKHNW
      DWAQXSWLWPYTYDYEACHWKHNWDWAQWESYQXBAXHXLRJZNJZAXHNJZKJLMXBUUDUUEOKJLMPZUU
      BXSUUFYMXSWLYOWMXRUUFYDWRYOXRYPSYFYGAXKXHDUSUTSYQXBUUDXCUUEXEYMXSUUDAXHXI
      RJZNJXCYMUUCUUGANXLXIXHRVAVBXSUUGBANWQUUGBTZWNXRWPXHVCGYJUUHWOWPCYKWGYLXH
      BVEVFVGVBVHXSUUEXETZYMXSWLWPUUIYDYEACWHQSVJVKXBXCXDWIQWFVLVMWJ $.
  $}

  $( Lemma for ~ jm2.26 .  Use ~ acongrep to find K', M' ~~ K, M in [ 0,N ].
     Thus Y(K') ~~ Y(M') and both are small; K' = M' on pain of contradicting
     2.24, so K ~~ M (Contributed by Stefan O'Rear, 3-Oct-2014.) $)
  jm2.26lem3 $p |- ( ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN ) /\ ( K e. ( 0 ... N )
      /\ M e. ( 0 ... N ) ) /\ ( ( A rmX N ) || ( ( A rmY K ) - ( A rmY M ) )
      \/ ( A rmX N ) || ( ( A rmY K ) - -u ( A rmY M ) ) ) ) -> K = M ) $=
    ( cfv wcel wa cc0 co crmy wbr wceq wne cz adantr ad2antlr syl2anc cle mpbid
    cabs c2 cuz cn cfz crmx cmin cdivides cneg wo caddc clt w3a simplll elfzelz
    wn rmyabs cr zred elfzle1 absidd oveq2d eqtrd adantl oveq12d fovcl readdcld
    c1 frmy simpllr nnzd peano2zm syl frmx nn0red elfzle2 lermy syl3anc simplrr
    cn0 wb wi le2add syl22anc mp2and zcnd addcomd necomd neeqtrd neneqd adantll
    id simpr nnnn0 nn0uz syl6eleq ad4antlr simprr ad2antrr biimpa orel2 simplrl
    fzm1 sylc eqbrtrd nnnn0d mpjaodan jm2.24 lelttrd necon3bid 0re a1i ad2antll
    rmyeq le0neg2d letri3 biimpar simplr eqtr3d cc recnd mpbird eqtr4d mpdan ex
    negeq0d necon3d znegcld rmyneg negsubd fveq2d addcld abscld abstrid zsubcld
    imp 3jca ltnled subne0d dvdsleabs mtod negcld absneg eqcomd breqtrrd simpr1
    nnz nn0zd eqbrtrrd simpr2 subnegd simpr3 pm4.56 sylib syld necon4ad 3impia
    jca ) AUAUBEZFZDUCFZGZBHDUDIZFZCUVBFZGZADUEIZABJIZACJIZUFIZUGKZUVFUVGUVHUHZ
    UFIZUGKZUIZBCLZUVAUVEGZUVNBCUVPBCMZUVGTEZUVHTEZUJIZUVFUKKZUVGUVHMZUVGUVKMZU
    LZUVNUOZUVPUVQUWDUVPUVQGZUWAUWBUWCUWFUVTUVGUVHUJIZUVFUKUWFUVRUVGUVSUVHUJUWF
    UVRABTEZJIZUVGUWFUUSBNFZUVRUWILUUSUUTUVEUVQUMZUVEUWJUVAUVQUVCUWJUVDBHDUNOZP
    ZABUPQUWFUWHBAJUWFBUVEBUQFZUVAUVQUVEBUWLURZPUVEHBRKZUVAUVQUVCUWPUVDBHDUSOZP
    UTVAVBUWFUVSACTEZJIZUVHUWFUUSCNFZUVSUWSLUWKUVEUWTUVAUVQUVDUWTUVCCHDUNZVCZPZ
    ACUPQUWFUWRCAJUWFCUVECUQFZUVAUVQUVECUXBURZPUVEHCRKZUVAUVQUVDUXFUVCCHDUSZVCP
    UTVAVBVDUWFUWGADVGUFIZJIZADJIZUJIZUVFUWFUVGUVHUWFUVGUWFUUSUWJUVGNFZUWKUWMAB
    NUURNJVHVEZQZURZUWFUVHUWFUUSUWTUVHNFZUWKUXCACNUURNJVHVEZQZURZVFUWFUXIUXJUWF
    UXIUWFUUSUXHNFZUXINFUWKUWFDNFZUXTUWFDUUSUUTUVEUVQVIZVJZDVKVLZAUXHNUURNJVHVE
    QURZUWFUXJUWFUUSUYAUXJNFUWKUYCADNUURNJVHVEQURZVFUWFUVFUWFUUSUYAUVFVSFUWKUYC
    ADVSUURNUEVMVEZQVNUWFBHUXHUDIZFZUWGUXKRKZBDLZUWFUYIGZUVGUXIRKZUVHUXJRKZUYJU
    YLBUXHRKZUYMUYIUYOUWFBHUXHVOVCUWFUYOUYMVTZUYIUWFUUSUWJUXTUYPUWKUWMUYDABUXHV
    PVQOSUWFUYNUYIUWFCDRKZUYNUWFUVDUYQUVAUVCUVDUVQVRZCHDVOVLUWFUUSUWTUYAUYQUYNV
    TUWKUXCUYCACDVPVQSOUWFUYMUYNGUYJWAZUYIUWFUVGUQFZUVHUQFZUXIUQFZUXJUQFZUYSUXO
    UXSUYEUYFUVGUVHUXIUXJWBWCOWDUWFUYKGZUWGUVHUVGUJIZUXKRUWFUWGVUELUYKUWFUVGUVH
    UWFUVGUXNWEUWFUVHUXRWEWFOVUDUVHUXIRKZUVGUXJRKZVUEUXKRKZVUDCUXHRKZVUFVUDCUYH
    FZVUIVUDCDLZUOZVUJVUKUIZVUJUVQUYKVULUVPUVQUYKGZCDVUNCBDUVQCBMUYKUVQBCUVQWKW
    GOUVQUYKWLWHWIWJVUDDHUBEZFZUVDVUMUUTVUPUUSUVEUVQUYKUUTDVSVUODWMWNWOWPUVPUVD
    UVQUYKUVAUVCUVDWQWRVUPUVDVUMCHDXBWSQVUKVUJWTXCCHUXHVOVLUWFVUIVUFVTZUYKUWFUU
    SUWTUXTVUQUWKUXCUYDACUXHVPVQOSUWFVUGUYKUWFBDRKZVUGUWFUVCVURUVAUVCUVDUVQXAZB
    HDVOVLUWFUUSUWJUYAVURVUGVTUWKUWMUYCABDVPVQSOUWFVUFVUGGVUHWAZUYKUWFVUAUYTVUB
    VUCVUTUXSUXOUYEUYFUVHUVGUXIUXJWBWCOWDXDUWFVUPUVCUYIUYKUIZUWFDVSVUOUWFDUYBXE
    WNWOVUSVUPUVCVVABHDXBWSQXFUWFUUSUYAUXKUVFUKKUWKUYCADXGQXHXDUWFUVQUWBUVPUVQW
    LUWFUUSUWJUWTUVQUWBVTUWKUWMUXCUUSUWJUWTULBCUVGUVHABCXMXIVQSUWFUVGACUHZJIZUV
    KUWFBVVBMZUVGVVCMZUVPUVQVVDUVPBVVBBCUVPBVVBLZUVOUVPVVFGZBHLZUVOVVGUWNHUQFZB
    HRKZUWPVVHUVEUWNUVAVVFUWOPVVIVVGXJXKVVGBVVBHRUVPVVFWLUVPVVBHRKZVVFUVPUXFVVK
    UVDUXFUVAUVCUXGXLUVPCUVEUXDUVAUXEVCZXNSOXDUVEUWPUVAVVFUWQPUWNVVIGVVHVVJUWPG
    BHXOXPWCVVGVVHGZBHCVVGVVHWLZVVMCHLVVBHLVVMBVVBHUVPVVFVVHXQVVNXRVVMCUVPCXSFV
    VFVVHUVPCVVLXTWRYEYAYBYCYDYFYOUWFUUSUWJVVBNFZVVDVVEVTUWKUWMUWFCUWFUVDUWTUYR
    UXAVLYGUUSUWJVVOULBVVBUVGVVCABVVBXMXIVQSUWFUUSUWTVVCUVKLUWKUXCACYHQWHYPYDUV
    PUWDUWEUVPUWDGZUVJUOZUVMUOZGUWEVVPVVQVVRVVPUVJUVFUVITEZRKZVVPVVSUVFUKKVVTUO
    VVPUVGUVKUJIZTEZVVSUVFUKVVPVWAUVITVVPUVGUVHVVPUVGVVPUUSUWJUXLUUSUUTUVEUWDUM
    ZUVEUWJUVAUWDUWLPUXMQZWEZVVPUVHVVPUUSUWTUXPVWCUVEUWTUVAUWDUXBPUXQQZWEZYIYJV
    VPVWBUVTUVFVVPVWAVVPUVGUVKVWEVVPUVHVWGUUAZYKYLVVPUVRUVSVVPUVGVWEYLVVPUVHVWG
    YLVFZVVPUVFVVPUUSUYAUVFNFZVWCUVAUYAUVEUWDUUTUYAUUSDUUFVCWRUUSUYAGUVFUYGUUGQ
    ZURZVVPVWBUVRUVKTEZUJIUVTRVVPUVGUVKVWEVWHYMVVPUVSVWMUVRUJVVPUVHXSFZUVSVWMLV
    WGVWNVWMUVSUVHUUBUUCVLVAUUDUVPUWAUWBUWCUUEZXHUUHVVPVVSUVFVVPUVIVVPUVIVVPUVG
    UVHVWDVWFYNZWEYLVWLYQSVVPVWJUVINFUVIHMUVJVVTWAVWKVWPVVPUVGUVHVWEVWGUVPUWAUW
    BUWCUUIYRUVFUVIYSVQYTVVPUVMUVFUVLTEZRKZVVPVWQUVFUKKVWRUOVVPVWQUWGTEZUVFUKVV
    PUVLUWGTVVPUVGUVHVWEVWGUUJYJVVPVWSUVTUVFVVPUWGVVPUVGUVHVWEVWGYKYLVWIVWLVVPU
    VGUVHVWEVWGYMVWOXHXDVVPVWQUVFVVPUVLVVPUVLVVPUVGUVKVWDVVPUVHVWFYGYNZWEYLVWLY
    QSVVPVWJUVLNFUVLHMUVMVWRWAVWKVWTVVPUVGUVKVWEVWHUVPUWAUWBUWCUUKYRUVFUVLYSVQY
    TUUQUVJUVMUULUUMYDUUNUUOUUP $.

  ${
    $d A k m $.  $d N k m $.  $d K k m $.  $d M k m $.
    $( Lemma 2.26 of [JonesMatijasevic] p. 697, the "second step down lemma".
       (Contributed by Stefan O'Rear, 2-Oct-2014.) $)
    jm2.26 $p |- ( ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN ) /\ ( K e. ZZ /\ M e. ZZ )
        ) -> ( ( ( A rmX N ) || ( ( A rmY K ) - ( A rmY M ) ) \/ ( A rmX N ) ||
        ( ( A rmY K ) - -u ( A rmY M ) ) ) <-> ( ( 2 x. N ) || ( K - M ) \/ ( 2
        x. N ) || ( K - -u M ) ) ) ) $=
      ( vm vk c2 wcel wa cz co crmy cmin cdivides wbr cneg wo wi fovcl syl2anc
      cuz cfv cn crmx cmul cc0 cfz wrex acongrep ad2ant2l ad2ant2lr w3a simpl1l
      cv 2z nnz adantl zmulcl sylancr simplrl 3ad2antl1 simpl3l elfzelz simplrr
      syl simpl2r weq wb simpl2l simplll frmx nn0zd frmy jm2.26a syl22anc simpr
      cn0 mpd acongtr syl222anc acongsym syl31anc jm2.26lem3 syl121anc id eqidd
      simpl3r acongeq12d mpbid 3exp1 exp3a rexlimdv sylanl2 impbid ) AGUAUBZHZD
      UCHZIZBJHZCJHZIZIZADUDKZABLKZACLKZMKNOXCXDXEPZMKNOQZGDUEKZBCMKNOXHBCPZMKN
      OQZXBXHEUNZCMKNOXHXKXIMKNOQZEUFDUGKZUHZXGXJRZWQWTXNWPWSDCEUIUJXBXLXOEXMXB
      XKXMHZXLXOXBXHFUNZBMKNOXHXQBPZMKNOQZFXMUHZXPXLIZXORZWQWSXTWPWTDBFUIUKXBXS
      YBFXMXBXQXMHZXSYBXBYCXSIZYAXGXJXBYDYAULZXGIZXHJHZWSXKJHZWTXHBXKMKNOXHBXKP
      ZMKNOQZXLXJYFGJHDJHZYGUOYFWRYKWRXAYDYAXGUMZWQYKWPDUPZUQVEZGDURUSZXBYDXGWS
      YAWRWSWTXGUTVAZYFXPYHXPXLXBYDXGVBZXKUFDVCVEZXBYDXGWTYAWRWSWTXGVDVAZYFYGYH
      WSXHXKBMKNOXHXKXRMKNOQZYJYOYRYPYFXSYTYCXSXBYAXGVFZYFFEVGZXSYTVHYFWRYCXPXC
      AXQLKZAXKLKZMKNOXCUUCUUDPZMKNOQZUUBYLYCXSXBYAXGVIZYQYFXCJHZUUCJHZXEJHZUUD
      JHZXCUUCXEMKNOXCUUCXFMKNOQZXCXEUUDMKNOXCXEUUEMKNOQZUUFYFWPYKUUHXBYDXGWPYA
      WPWQXAXGVJVAZYNWPYKIXCADVQWOJUDVKSVLTZYFWPXQJHZUUIUUNYFYCUUPUUGXQUFDVCVEZ
      AXQJWOJLVMSTZYFWPWTUUJUUNYSACJWOJLVMSTZYFWPYHUUKUUNYRAXKJWOJLVMSTYFUUHUUI
      XDJHZUUJXCUUCXDMKNOXCUUCXDPMKNOQZXGUULUUOUURYFWPWSUUTUUNYPABJWOJLVMSTUUSY
      FXSUVAUUAYFWPYKUUPWSXSUVARUUNYNUUQYPAXQBDVNVOVRYEXGVPXCUUCXDXEVSVTYFXHCXK
      MKNOXHCYIMKNOQZUUMYFYGYHWTXLUVBYOYRYSXPXLXBYDXGWGZXHXKCWAWBYFWPYKWTYHUVBU
      UMRUUNYNYSYRACXKDVNVOVRXCUUCXEUUDVSVTAXQXKDWCWDUUBXHXQXKBBUUBWEUUBBWFWHVE
      WIXHXKBWAWBUVCXHBXKCVSVTWJWKWLVRWKWLVRWQWPYKXAXJXGRYMABCDVNWMWN $.
  $}

  ${
    $d a b A $.  $d a b B $.  $d a b N $.
    $( Lemma 2.15 of [JonesMatijasevic] p. 695. ` rmY ` is a polynomial for
       fixed N, so has the expected congruence property.  (Contributed by
       Stefan O'Rear, 1-Oct-2014.) $)
    jm2.15nn0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ B e. ( ZZ>= ` 2 ) /\ N e. NN0 ) ->
        ( A - B ) || ( ( A rmY N ) - ( B rmY N ) ) ) $=
      ( c2 wcel cmin co crmy cdivides wbr wi cc0 c1 syl2anc wceq oveq12d breq2d
      cz oveq2 imbi2d va vb cuz cfv wa cv caddc eluzelz zsubcl syl2an 0z congid
      cn0 sylancl rmy0 oveqan12d breqtrrd 1z rmy1 cn pm3.43 w3a 3ad2ant2 2z a1i
      cmul simp2l nnz 3ad2ant1 frmy fovcl adantr zmulcld simp2r adantl peano2zm
      syl simp3r iddvds congmul syl322anc simp3l congsub rmyluc a2d weq 2nn0ind
      3exp syl5 impcom 3impa ) ADUCUDZEZBWLEZCUMEZABFGZACHGZBCHGZFGZIJZWOWMWNUE
      ZWTXAWPAUAUFZHGZBXBHGZFGZIJZKXAWPALHGZBLHGZFGZIJZKXAWPAMHGZBMHGZFGZIJZKXA
      WPAUBUFZMFGZHGZBXPHGZFGZIJZKZXAWPAXOHGZBXOHGZFGZIJZKZXAWPAXOMUGGZHGZBYGHG
      ZFGZIJZKZXAWTKUAUBCXAWPLLFGZXIIXAWPREZLREWPYMIJWMAREZBREZYNWNDAUHZDBUHZAB
      UIUJZUKWPLULUNWMWNXGLXHLFAUOBUOUPUQXAWPMMFGZXMIXAYNMREWPYTIJYSURWPMULUNWM
      WNXKMXLMFAUSBUSUPUQYAYFUEXAXTYEUEZKXOUTEZYLXAXTYEVAUUBXAUUAYKUUBXAUUAYKUU
      BXAUUAVBZWPDYBAVFGZVFGZXQFGZDYCBVFGZVFGZXRFGZFGZYJIUUCYNUUEREUUHREXQREZXR
      REZWPUUEUUHFGIJZXTWPUUJIJXAUUBYNUUAYSVCZUUCDUUDDREZUUCVDVEZUUCYBAUUCWMXOR
      EZYBREZUUBWMWNUUAVGZUUBXAUUQUUAXOVHZVIZAXORWLRHVJVKNZXAUUBYOUUAWMYOWNYQVL
      VCZVMZVMUUCDUUGUUPUUCYCBUUCWNUUQYCREZUUBWMWNUUAVNZUVABXORWLRHVJVKNZXAUUBY
      PUUAWNYPWMYRVOVCZVMZVMUUCWMXPREZUUKUUSUUBXAUVJUUAUUBUUQUVJUUTXOVPVQVIZAXP
      RWLRHVJVKNUUCWNUVJUULUVFUVKBXPRWLRHVJVKNUUCYNUUOUUOUUDREUUGREWPDDFGIJZWPU
      UDUUGFGIJZUUMUUNUUPUUPUVDUVIUUCYNUUOUVLUUNVDWPDULUNUUCYNUURUVEYOYPYEWPWPI
      JZUVMUUNUVBUVGUVCUVHUUBXAXTYEVRUUCYNUVNUUNWPVSVQWPYBYCABVTWAWPDDUUDUUGVTW
      AUUBXAXTYEWBWPUUEUUHXQXRWCWAUUCYHUUFYIUUIFUUCWMUUQYHUUFOUUSUVAAXOWDNUUCWN
      UUQYIUUIOUVFUVABXOWDNPUQWHWEWIXBLOZXFXJXAUVOXEXIWPIUVOXCXGXDXHFXBLAHSXBLB
      HSPQTXBMOZXFXNXAUVPXEXMWPIUVPXCXKXDXLFXBMAHSXBMBHSPQTXBXPOZXFXTXAUVQXEXSW
      PIUVQXCXQXDXRFXBXPAHSXBXPBHSPQTUAUBWFZXFYEXAUVRXEYDWPIUVRXCYBXDYCFXBXOAHS
      XBXOBHSPQTXBYGOZXFYKXAUVSXEYJWPIUVSXCYHXDYIFXBYGAHSXBYGBHSPQTXBCOZXFWTXAU
      VTXEWSWPIUVTXCWQXDWRFXBCAHSXBCBHSPQTWGWJWK $.
  $}

  ${
    $d a b A $.  $d a b N $.
    $( Lemma 2.16 of [JonesMatijasevic] p. 695.  This may be regarded as a
       special case of ~ jm2.15nn0 if ` rmY ` is redefined as described in
       ~ rmyluc .  (Contributed by Stefan O'Rear, 1-Oct-2014.) $)
    jm2.16nn0 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 ) -> ( A - 1 ) || ( ( A
        rmY N ) - N ) ) $=
      ( wcel c2 c1 cmin co crmy cdivides wbr wi cz wa cmul 3adant3 wceq oveq12d
      cc0 oveq2 id va vb cn0 cuz cfv cv caddc eluzelz peano2zm syl sylancl rmy0
      0z congid oveq1d breqtrrd 1z rmy1 cn pm3.43 w3a adantl eluzel2 nnz adantr
      simpr frmy fovcl syl2anc zmulcld zmulcl 3jca jca simp3r congmul syl112anc
      a1i iddvds simp3l congsub rmyluc nncn mulid1d oveq2d 2timesd eqtrd ax-1cn
      cc pnncand eqtr2d 3exp a2d syl5 breq2d imbi2d weq 2nn0ind impcom ) BUCCAD
      UDUEZCZAEFGZABHGZBFGZIJZWTXAAUAUFZHGZXEFGZIJZKWTXAARHGZRFGZIJZKWTXAAEHGZE
      FGZIJZKWTXAAUBUFZEFGZHGZXPFGZIJZKZWTXAAXOHGZXOFGZIJZKZWTXAAXOEUGGZHGZYEFG
      ZIJZKZWTXDKUAUBBWTXARRFGZXJIWTXALCZRLCXAYJIJWTALCZYKDAUHZAUIZUJZUMXARUNUK
      WTXIRRFAULUOUPWTXAEEFGZXMIWTYKELCZXAYPIJYOUQXAEUNUKWTXLEEFAURUOUPXTYDMWTX
      SYCMZKXOUSCZYIWTXSYCUTYSWTYRYHYSWTYRYHYSWTYRVAZXADYAANGZNGZXQFGZDXOENGZNG
      ZXPFGZFGZYGIYTYKUUBLCZUUELCZVAZXQLCZXPLCZMZXAUUBUUEFGIJZXSXAUUGIJYSWTUUJY
      RYSWTMZYKUUHUUIUUOYLYKWTYLYSYMVBZYNUJZUUODUUAWTDLCZYSDAVCVBZUUOYAAUUOWTXO
      LCZYALCZYSWTVFZYSUUTWTXOVDVEZAXOLWSLHVGVHVIZUUPVJZVJUUODUUDUUSUUOUUTYQUUD
      LCZUVCUQXOEVKUKZVJVLOYSWTUUMYRUUOUUKUULUUOWTUULUUKUVBUUOUUTUULUVCXOUIUJZA
      XPLWSLHVGVHVIUVHVMOYTYKUURUURVAZUUALCZUVFMZXADDFGIJZXAUUAUUDFGIJZUUNYSWTU
      VIYRUUOYKUURUURUUQUUSUUSVLOYSWTUVKYRUUOUVJUVFUVEUVGVMOYSWTUVLYRUUOYKUURUV
      LUUQUUSXADUNVIOYTYKUVAUUTVAZYLYQMZYCXAXAIJZUVMYSWTUVNYRUUOYKUVAUUTUUQUVDU
      VCVLOYSWTUVOYRUUOYLYQUUPYQUUOUQVQVMOYSWTXSYCVNYSWTUVPYRUUOYKUVPUUQXAVRUJO
      XAYAXOAEVOVPXADDUUAUUDVOVPYSWTXSYCVSXAUUBUUEXQXPVTVPYSWTYGUUGPYRUUOYFUUCY
      EUUFFUUOWTUUTYFUUCPUVBUVCAXOWAVIYSYEUUFPWTYSUUFXOXOUGGZXPFGYEYSUUEUVQXPFY
      SUUEDXONGUVQYSUUDXODNYSXOXOWBZWCWDYSXOUVRWEWFUOYSXOXOEUVRUVREWHCYSWGVQWIW
      JVEQOUPWKWLWMXERPZXHXKWTUVSXGXJXAIUVSXFXIXERFXERAHSUVSTQWNWOXEEPZXHXNWTUV
      TXGXMXAIUVTXFXLXEEFXEEAHSUVTTQWNWOXEXPPZXHXSWTUWAXGXRXAIUWAXFXQXEXPFXEXPA
      HSUWATQWNWOUAUBWPZXHYCWTUWBXGYBXAIUWBXFYAXEXOFXEXOAHSUWBTQWNWOXEYEPZXHYHW
      TUWCXGYGXAIUWCXFYFXEYEFXEYEAHSUWCTQWNWOXEBPZXHXDWTUWDXGXCXAIUWDXFXBXEBFXE
      BAHSUWDTQWNWOWQWR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    X and Y sequences 4: Diophantine representability of Y
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    jm2.27a1 $e |- ( ph -> A e. ( ZZ>= ` 2 ) ) $.
    jm2.27a2 $e |- ( ph -> B e. NN ) $.
    jm2.27a3 $e |- ( ph -> C e. NN ) $.
    ${
      jm2.27a4 $e |- ( ph -> D e. NN0 ) $.
      jm2.27a5 $e |- ( ph -> E e. NN0 ) $.
      jm2.27a6 $e |- ( ph -> F e. NN0 ) $.
      jm2.27a7 $e |- ( ph -> G e. NN0 ) $.
      jm2.27a8 $e |- ( ph -> H e. NN0 ) $.
      jm2.27a9 $e |- ( ph -> I e. NN0 ) $.
      jm2.27a10 $e |- ( ph -> J e. NN0 ) $.
      jm2.27a11 $e |- ( ph -> ( ( D ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( C ^ 2 ) )
          ) = 1 ) $.
      jm2.27a12 $e |- ( ph -> ( ( F ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( E ^ 2 ) )
          ) = 1 ) $.
      jm2.27a13 $e |- ( ph -> G e. ( ZZ>= ` 2 ) ) $.
      jm2.27a14 $e |- ( ph -> ( ( I ^ 2 ) - ( ( ( G ^ 2 ) - 1 ) x. ( H ^ 2 ) )
          ) = 1 ) $.
      jm2.27a15 $e |- ( ph -> E = ( ( J + 1 ) x. ( 2 x. ( C ^ 2 ) ) ) ) $.
      jm2.27a16 $e |- ( ph -> F || ( G - A ) ) $.
      jm2.27a17 $e |- ( ph -> ( 2 x. C ) || ( G - 1 ) ) $.
      jm2.27a18 $e |- ( ph -> F || ( H - C ) ) $.
      jm2.27a19 $e |- ( ph -> ( 2 x. C ) || ( H - B ) ) $.
      jm2.27a20 $e |- ( ph -> B <_ C ) $.

      ${
        jm2.27a21 $e |- ( ph -> P e. ZZ ) $.
        jm2.27a22 $e |- ( ph -> D = ( A rmX P ) ) $.
        jm2.27a23 $e |- ( ph -> C = ( A rmY P ) ) $.
        jm2.27a24 $e |- ( ph -> Q e. ZZ ) $.
        jm2.27a25 $e |- ( ph -> F = ( A rmX Q ) ) $.
        jm2.27a26 $e |- ( ph -> E = ( A rmY Q ) ) $.
        jm2.27a27 $e |- ( ph -> R e. ZZ ) $.
        jm2.27a28 $e |- ( ph -> I = ( G rmX R ) ) $.
        jm2.27a29 $e |- ( ph -> H = ( G rmY R ) ) $.
        $( Lemma for ~ jm2.27 .  Reverse direction after existential
           quantifiers are expanded.  (Contributed by Stefan O'Rear,
           4-Oct-2014.) $)
        jm2.27a $p |- ( ph -> C = ( A rmY B ) ) $=
          ( crmy co wceq c2 cmul cmin cdivides wbr cneg wo cz wcel nnzd sylancr
          2z zmulcl nn0zd congsym syl22anc cuz cfv cn0 cc0 cle nn0ge0d rmy0 syl
          c1 eqcomd 3brtr4d wb a1i lermy syl3anc mpbird elnn0z sylanbrc syl2anc
          0z jm2.16nn0 oveq1d breqtrrd wa peano2zm zsubcld dvdstr mp2and congtr
          wi syl222anc orcd caddc zsqcl dvdsmul2 peano2zd dvdsmultr2 mpd eqtr3d
          cexp 3brtr3d cn clt zred nn0p1nn nngt0d nnsqcld nnmulcl mulgt0d ltrmy
          2nn elnnz jm2.20nn mpbid eqeltrrd nnnn0d elfz2nn0 syl3anbrc crmx frmy
          muldvds2 eqbrtrd dvdscmul fovcl eluzelz jm2.15nn0 oveq12d dvdsacongtr
          eqbrtrrd jm2.26 acongtr cfz rmygeid acongeq oveq2d eqtr4d ) ADBFVDVEZ
          BCVDVEUQACFBVDACFVFZVGDVHVEZCFVIVEVJVKUVACFVLZVIVEVJVKVMZAUVAVNVOZCVN
          VOZHVNVOZFVNVOZUVACHVIVEVJVKZUVACHVLVIVEVJVKZVMUVAHFVIVEZVJVKUVAHUVBV
          IVEZVJVKVMZUVCAVGVNVOZDVNVOZUVDVRADQVPZVGDVSVQZACPVPZVAUOAUVHUVIAUVDU
          VELVNVOZUVFUVACLVIVEVJVKZUVALHVIVEZVJVKZUVHUVPUVQALUBVTZVAAUVDUVRUVEU
          VALCVIVEVJVKUVSUVPUWBUVQUMUVALCWAWBAUVAKWKVIVEZVJVKZUWCUVTVJVKZUWAUKA
          UWCKHVDVEZHVIVEZUVTVJAKVGWCWDZVOZHWEVOZUWCUWGVJVKUGAUVFWFHWGVKZUWJVAA
          UWKKWFVDVEZUWFWGVKZAWFLUWLUWFWGALUBWHAUWIUWLWFVFUGKWIWJALUWFVCWLWMAUW
          IWFVNVOZUVFUWKUWMWNUGUWNAXBWOZVAKWFHWPWQWRHWSWTZKHXCXAALUWFHVIVCXDXEA
          UVDUWCVNVOZUVTVNVOUWDUWEXFUWAXLUVPAKVNVOZUWQAKUAVTZKXGWJALHUWBVAXHUVA
          UWCUVTXIWQXJUVACLHXKXMXNAVGGVHVEZVNVOZUVFUVGUVDUVAUWTVJVKZUWTUVJVJVKU
          WTUVKVJVKVMZUVLAUVMGVNVOZUXAVRURVGGVSVQVAUOUVPADGVJVKZUXBADUUSGVJUQAF
          UUSVHVEGVJVKZUUSGVJVKZAUUSVGYBVEZBGVDVEZVJVKZUXFADVGYBVEZNWKXOVEZVGUX
          KVHVEZVHVEZUXHUXIVJAUXKUXMVJVKZUXKUXNVJVKZAUVMUXKVNVOZUXOVRAUVNUXQUVO
          DXPWJZVGUXKXQVQAUXQUXLVNVOUXMVNVOZUXOUXPXLUXRANANUDVTXRZAUVMUXQUXSVRU
          XRVGUXKVSVQZUXKUXLUXMXSWQXTADUUSVGYBUQXDAIUXNUXIUIUTYAYCABUWHVOZGYDVO
          ZFYDVOZUXJUXFWNOAUXDWFGYEVKZUYCURAUYEBWFVDVEZUXIYEVKZAWFIUYFUXIYEAWFU
          XNIYEAUXLUXMAUXLUXTYFAUXMUYAYFAUXLANWEVOUXLYDVOUDNYGWJYHAUXMAVGYDVOUX
          KYDVOUXMYDVOYMADQYIVGUXKYJVQYHYKUIXEAUYBUYFWFVFOBWIWJZAIUXIUTWLWMAUYB
          UWNUXDUYEUYGWNOUWOURBWFGYLWQWRGYNWTZAUVGWFFYEVKZUYDUOAUYJUYFUUSYEVKZA
          WFDUYFUUSYEADQYHUYHADUUSUQWLWMAUYBUWNUVGUYJUYKWNOUWOUOBWFFYLWQWRFYNWT
          ZBGFYOWQYPAUVGUUSVNVOZUXDUXFUXGXLUOADUUSVNUQUVOYQZURFUUSGUUCWQXTUUDAU
          VNUXDUVMUXEUXBXLUVOURUVMAVRWOVGDGUUEWQXTABGUUAVEZBHVDVEZUUSVIVEVJVKZU
          YOUYPUUSVLVIVEVJVKZVMZUXCAUYQUYRAUYOVNVOZUYPVNVOZUWFVNVOUYMUYOUYPUWFV
          IVEZVJVKZUYOUWFUUSVIVEZVJVKUYQAJUYOVNUSAJTVTZYQZAUYBUVFVUAOVABHVNUWHV
          NVDUUBUUFXAZALUWFVNVCUWBYQZUYNAUYOBKVIVEZVJVKZVUIVUBVJVKZVUCAJUYOVUIV
          JUSAJVNVOUWRBVNVOZJKBVIVEVJVKJVUIVJVKVUEUWSAUYBVULOVGBUUGWJZUJJKBWAWB
          UUKAUYBUWIUWJVUKOUGUWPBKHUUHWQAUYTVUIVNVOVUBVNVOVUJVUKXFVUCXLVUFABKVU
          MUWSXHAUYPUWFVUGVUHXHUYOVUIVUBXIWQXJAJLDVIVEUYOVUDVJULUSALUWFDUUSVIVC
          UQUUIYCUYOUYPUWFUUSXKXMXNAUYBUYCUVFUVGUYSUXCWNOUYIVAUOBHFGUULWBYPUWTH
          FUVAUUJXMUVACHFUUMXMADYDVOCWFDUUNVEZVOZFVUNVOZUUTUVCWNQACWEVODWEVOZCD
          WGVKVUOACPYRADQYRZUNCDYSYTAFWEVOZVUQFDWGVKVUPAFUYLYRZVURAFUUSDWGAUYBV
          USFUUSWGVKOVUTBFUUOXAUQXEFDYSYTDCFUUPWQWRUUQUUR $.
      $}

      ${
        $d ph p q r $.  $d A p q r $.  $d B p q r $.  $d C p q r $.
        $d D p q r $.  $d E q r $.  $d F q r $.  $d G r $.  $d H r $.
        $d I r $.
        $( Lemma for ~ jm2.27 .  Expand existential quantifiers for reverse
           direction.  (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
        jm2.27b $p |- ( ph -> C = ( A rmY B ) ) $=
          ( vp vq vr cv crmx co wceq crmy wa cz c2 cexp cmin cmul wrex cuz wcel
          c1 cfv cn0 wb nnzd rmxycomplete mpbid adantr nn0zd ad2antrr ad3antrrr
          syl3anc cn caddc cdivides wbr simprl simprrl simprrr simplrl ad2antlr
          cle simprr jm2.27a rexlimddv ) AEBULUOZUPUQURZDBWNUSUQURZUTZDBCUSUQUR
          ZULVAAEVBVCUQBVBVCUQVIVDUQZDVBVCUQZVEUQVDUQVIURZWQULVAVFZUBABVBVGVJZV
          HZEVKVHZDVAVHXAXBVLLOADNVMBULEDVNVTVOAWNVAVHZWQUTZUTZGBUMUOZUPUQURZFB
          XIUSUQURZUTZWRUMVAXHGVBVCUQWSFVBVCUQVEUQVDUQVIURZXLUMVAVFZAXMXGUCVPXH
          XDGVKVHZFVAVHZXMXNVLAXDXGLVPAXOXGQVPAXPXGAFPVQVPBUMGFVNVTVOXHXIVAVHZX
          LUTZUTZJHUNUOZUPUQURZIHXTUSUQURZUTZWRUNVAXSJVBVCUQHVBVCUQVIVDUQIVBVCU
          QVEUQVDUQVIURZYCUNVAVFZAYDXGXRUEVRXSHXCVHZJVKVHZIVAVHZYDYEVLAYFXGXRUD
          VRAYGXGXRTVRAYHXGXRAISVQVRHUNJIVNVTVOXSXTVAVHZYCUTZUTBCDEWNXIXTFGHIJK
          AXDXGXRYJLVSACWAVHXGXRYJMVSADWAVHXGXRYJNVSAXEXGXRYJOVSAFVKVHXGXRYJPVS
          AXOXGXRYJQVSAHVKVHXGXRYJRVSAIVKVHXGXRYJSVSAYGXGXRYJTVSAKVKVHXGXRYJUAV
          SAXAXGXRYJUBVSAXMXGXRYJUCVSAYFXGXRYJUDVSAYDXGXRYJUEVSAFKVIWBUQVBWTVEU
          QVEUQURXGXRYJUFVSAGHBVDUQWCWDXGXRYJUGVSAVBDVEUQZHVIVDUQWCWDXGXRYJUHVS
          AGIDVDUQWCWDXGXRYJUIVSAYKICVDUQWCWDXGXRYJUJVSACDWJWDXGXRYJUKVSXHXFXRY
          JAXFWQWEVRXHWOXRYJAXFWOWPWFVRXHWPXRYJAXFWOWPWGVRXHXQXLYJWHXRXJXHYJXQX
          JXKWEWIXRXKXHYJXQXJXKWKWIXSYIYCWEXSYIYAYBWFXSYIYAYBWGWLWMWMWM $.
      $}
    $}

    ${
      jm2.27c4 $e |- ( ph -> C = ( A rmY B ) ) $.
      jm2.27c5 $e |- D = ( A rmX B ) $.
      jm2.27c6 $e |- Q = ( B x. ( A rmY B ) ) $.
      jm2.27c7 $e |- E = ( A rmY ( 2 x. Q ) ) $.
      jm2.27c8 $e |- F = ( A rmX ( 2 x. Q ) ) $.
      jm2.27c9 $e |- G = ( A + ( ( F ^ 2 ) x. ( ( F ^ 2 ) - A ) ) ) $.
      jm2.27c10 $e |- H = ( G rmY B ) $.
      jm2.27c11 $e |- I = ( G rmX B ) $.
      jm2.27c12 $e |- J = ( ( E / ( 2 x. ( C ^ 2 ) ) ) - 1 ) $.
      $( Lemma for ~ jm2.27 .  Forward direction with substitutions.
         (Contributed by Stefan O'Rear, 4-Oct-2014.) $)
      jm2.27c $p |- ( ph ->
      ( ( ( D e. NN0
            /\ E e. NN0
            /\ F e. NN0 )
         /\ ( G e. NN0
            /\ H e. NN0
            /\ I e. NN0 ) )
      /\ ( J e. NN0
         /\ ( ( ( ( ( D ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( C ^ 2 ) ) ) = 1
                  /\ ( ( F ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( E ^ 2 ) ) ) = 1
                  /\ G e. ( ZZ>= ` 2 ) )
               /\ ( ( ( I ^ 2 ) - ( ( ( G ^ 2 ) - 1 ) x. ( H ^ 2 ) ) ) = 1
                  /\ E = ( ( J + 1 ) x. ( 2 x. ( C ^ 2 ) ) )
                  /\ F || ( G - A ) ) )
            /\ ( ( ( 2 x. C ) || ( G - 1 )
                  /\ F || ( H - C ) )
               /\ ( ( 2 x. C ) || ( H - B )
                  /\ B <_ C ) ) ) ) ) ) $=
        ( cn0 wcel w3a c2 cexp co cmin cmul wceq cuz cfv caddc cdivides wbr cle
        c1 wa crmx cz nnzd frmx fovcl syl2anc syl5eqel crmy 2z eqeltrrd zmulcld
        cc0 zmulcl sylancr frmy rmy0 syl cn 2nn nnmulcld nnmulcl nnnn0d nn0ge0d
        wb 0z a1i lermy syl3anc mpbid eqbrtrrd elnn0z sylanbrc 3jca 2nn0 nn0cnd
        sqvald nn0mulcld eqeltrd clt eluz2b2 nn0red remulcld syl6breqr breqtrrd
        simplbi nnge1d wi zsqcl mpd nn0zd dvdsmul1 cc zcnd dvdstr mp2and oveq1d
        eqtrd oveq2d 3brtr4d oveq1i oveq12d rmxynorm oveq2i syl5eq nncnd ax-1cn
        oveq12i sylancl eqtr2d mulassd eluzelz 1z eqtr4d peano2zm sqcld zsubcld
        syl322anc jca jca31 rmx1 lermxnn0 rmxnn lemulge12d letrd nn0sub uzaddcl
        1nn0 eluznn0 iddvds jm2.20nn mpbird dvdscmul rmydbl mul32d nngt0d ltrmy
        2cn eqcomd elnnz nnsqcld nndivdvds nnm1nn0 nnne0d divcld npcan divcan1d
        pncan2d 3eqtrd zsubcl congid eqbrtrd muldvds1 dvdsmultr2 subcl subsub23
        cdiv mulcld congsub congmul congadd mulid2d jm2.15nn0 jm2.16nn0 rmygeid
        pncan3 ) AEUEUFZGUEUFZHUEUFZUGIUEUFZJUEUFZKUEUFZUGLUEUFZEUHUIUJZBUHUIUJ
        ZUTUKUJZDUHUIUJZULUJZUKUJZUTUMZHUHUIUJZUWPGUHUIUJZULUJZUKUJZUTUMZIUHUNU
        OZUFZUGZKUHUIUJZIUHUIUJUTUKUJZJUHUIUJZULUJZUKUJZUTUMZGLUTUPUJZUHUWQULUJ
        ZULUJZUMZHIBUKUJZUQURZUGZVAUHDULUJZIUTUKUJZUQURZHJDUKUJZUQURZVAUYBJCUKU
        JZUQURZCDUSURZVAZVAZVAZVAAUWGUWHUWIAEBCVBUJZUEQABUXFUFZCVCUFZUYMUEUFMAC
        NVDZBCUEUXFVCVBVEVFVGVHAGBUHFULUJZVIUJZUESAUYRVCUFZVMUYRUSURUYRUEUFAUYN
        UYQVCUFZUYSMAUHVCUFZFVCUFZUYTVJAFCBCVIUJZULUJZVCRACVUCUYPADVUCVCPADOVDZ
        VKZVLZVHZUHFVNVOZBUYQVCUXFVCVIVPVFVGZABVMVIUJZVMUYRUSAUYNVUKVMUMMBVQVRZ
        AVMUYQUSURZVUKUYRUSURZAUYQAUYQAUHVSUFZFVSUFZUYQVSUFVTAFVUDVSRACVUCNADVU
        CVSPOVKWAVHZUHFWBVOZWCZWDAUYNVMVCUFZUYTVUMVUNWEMVUTAWFWGZVUIBVMUYQWHWIW
        JWKUYRWLWMVHAHBUYQVBUJZUETAUYNUYTVVBUEUFMVUIBUYQUEUXFVCVBVEVFVGVHZWNAUW
        JUWKUWLAUHUEUFUXGUWJWOAIBUXAUXABUKUJZULUJZUPUJZUXFUAAUYNVVEUEUFVVFUXFUF
        MAUXAVVDAUXAHHULUJZUEAHAHVVCWPZWQZAHHVVCVVCWRWSZABUXAUSURZVVDUEUFZABVVG
        UXAUSABHVVGABABAUYNBVSUFZMUYNVVMUTBWTURBXAXFVRWCZXBAHVVCXBZAHHVVOVVOXCA
        BVVBHUSABUTVBUJZBVVBUSAUYNVVPBUMMBUUAVRAUTUYQUSURZVVPVVBUSURZAUYQVURXGA
        UYNUTUEUFZUYQUEUFVVQVVRWEMVVSAUUHWGVUSBUTUYQUUBWIWJWKTXDAHHVVOVVOAHVVCW
        DAHAHVVBVSTAUYNUYTVVBVSUFMVUIBUYQUUCVGVHXGUUDUUEVVIXEABUEUFUXAUEUFVVKVV
        LWEVVNVVJBUXAUUFVGWJZWRZVVEUHBUUGVGVHZIUHUUIVOAJICVIUJZUEUBAVWCVCUFZVMV
        WCUSURVWCUEUFAUXGUYOVWDVWBUYPICVCUXFVCVIVPVFVGZAIVMVIUJZVMVWCUSAUXGVWFV
        MUMVWBIVQVRAVMCUSURZVWFVWCUSURZACACNWCZWDAUXGVUTUYOVWGVWHWEVWBVVAUYPIVM
        CWHWIWJWKVWCWLWMVHAKICVBUJZUEUCAUXGUYOVWJUEUFVWBUYPICUEUXFVCVBVEVFVGVHW
        NAUWMUYLALGUXPUVQUJZUTUKUJZUEUDAVWKVSUFZVWLUEUFAUXPGUQURZVWMAUHVUCUHUIU
        JZULUJZUYRUXPGUQAVWPUHBFVIUJZULUJZUQURZVWRUYRUQURZVWPUYRUQURZAVWOVWQUQU
        RZVWSAVXBVUDFUQURZAVUDVUDFUQAVUDVCUFVUDVUDUQURVUGVUDUUJVRRXDAUYNVUPCVSU
        FVXBVXCWEMVUQNBFCUUKWIUULAVWOVCUFZVWQVCUFZVUAVXBVWSXHAVUCVCUFVXDVUFVUCX
        IVRZAUYNVUBVXEMVUHBFVCUXFVCVIVPVFVGZVUAAVJWGUHVWOVWQUUMWIXJAVWRVWRBFVBU
        JZULUJZUYRUQAVWRVCUFZVXHVCUFVWRVXIUQURAVUAVXEVXJVJVXGUHVWQVNVOZAVXHAUYN
        VUBVXHUEUFMVUHBFUEUXFVCVBVEVFVGZXKVWRVXHXLVGAUYRUHVXHULUJVWQULUJZVXIAUY
        NVUBUYRVXMUMMVUHBFUUNVGAUHVXHVWQUHXMUFAUURWGZAVXHVXLWPAVWQVXGXNUUOXRXEA
        VWPVCUFZVXJUYSVWSVWTVAVXAXHAVUAVXDVXOVJVXFUHVWOVNVOVXKVUJVWPVWRUYRXOWIX
        PAUWQVWOUHULADVUCUHUIPXQZXSGUYRUMASWGZXTZAGVSUFZUXPVSUFZVWNVWMWEAGVCUFZ
        VMGWTURVXSAGUYRVCSVUJVHZAVUKUYRVMGWTAVMUYQWTURZVUKUYRWTURZAUYQVURUUPAUY
        NVUTUYTVYCVYDWEMVVAVUIBVMUYQUUQWIWJAVUKVMVULUUSVXQXTGUUTWMAVUOUWQVSUFVX
        TVTADOUVAUHUWQWBVOZGUXPUVBVGWJVWKUVCVRVHAUXHUYAUYKAUWTUXEUXGAUWSUYMUHUI
        UJZUWPVWOULUJZUKUJZUTAUWNVYFUWRVYGUKUWNVYFUMAEUYMUHUIQYAWGAUWQVWOUWPULV
        XPXSYBAUYNUYOVYHUTUMMUYPBCYCVGXRAUXDVVBUHUIUJZUWPUYRUHUIUJZULUJZUKUJZUT
        UXAVYIUXCVYKUKHVVBUHUITYAUXBVYJUWPULGUYRUHUISYAYDYHAUYNUYTVYLUTUMMVUIBU
        YQYCVGYEZVWBWNAUXNUXRUXTAUXMVWJUHUIUJZUXJVWCUHUIUJZULUJZUKUJZUTUXIVYNUX
        LVYPUKKVWJUHUIUCYAUXKVYOUXJULJVWCUHUIUBYAYDYHAUXGUYOVYQUTUMVWBUYPICYCVG
        YEAUXQVWKUXPULUJGAUXOVWKUXPULAUXOVWLUTUPUJZVWKALVWLUTUPLVWLUMAUDWGXQAVW
        KXMUFUTXMUFZVYRVWKUMAGUXPAGVYBXNZAUXPVYEYFZAUXPVYEUVDZUVEYGVWKUTUVFYIXR
        XQAGUXPVYTWUAWUBUVGYJAHHHVVDULUJZULUJZUXSUQAHVCUFZWUCVCUFHWUDUQURAHVVCX
        KZAHVVDWUFAVVDVVTXKZVLHWUCXLVGAUXSVVFBUKUJZWUDIVVFBUKUAYAAWUHVVEVVGVVDU
        LUJWUDABVVEABVVNWPZAVVEVWAWPUVHAUXAVVGVVDULVVIXQAHHVVDVVHVVHAVVDVVTWPYK
        UVIYEXEZWNAUYDUYFUYJAUYBVVFBUTUTBUKUJZULUJZUPUJZUKUJZUYCUQAUYBVCUFZBVCU
        FZWUPVVEVCUFWULVCUFZUYBBBUKUJUQURZUYBVVEWULUKUJUQURZUYBWUNUQURAVUADVCUF
        ZWUOVJVUEUHDVNVOZAUYNWUPMUHBYLVRZWVBAVVEVWAXKAUTVCUFZWUKVCUFZWUQYMAWVCW
        UPWVDYMWVBUTBUVJVOZUTWUKVNVOAWUOWUPWURWVAWVBUYBBUVKVGZAWUOUXAVCUFZWVCVV
        DVCUFWVDUYBUXAUTUKUJZUQURZUYBVVDWUKUKUJUQURZWUSWVAAUXAVVJXKZWVCAYMWGZWU
        GWVEAUYBUXCWVHUQAUYBUWPGULUJZGULUJZUXCUQAUYBGUQURZUYBWVNUQURZAUYBDULUJZ
        GUQURZWVOAWVQUXPGUQAWVQUHDDULUJZULUJUXPAUHDDVXNADOYFZWVTYKAUWQWVSUHULAD
        WVTWQXSYNVXRUVLAWUOWUTVYAWVRWVOXHWVAVUEVYBUYBDGUVMWIXJAWUOWVMVCUFVYAWVO
        WVPXHWVAAUWPGAUWOVCUFZUWPVCUFAWUPWWAWVBBXIVRUWOYOVRVYBVLVYBUYBWVMGUVNWI
        XJAUXCUWPGGULUJZULUJWVNAUXBWWBUWPULAGVYTWQXSAUWPGGAUWOXMUFVYSUWPXMUFABW
        UIYPYGUWOUTUVOYIZVYTVYTYKYNXEAUXEWVHUXCUMZVYMAUXAXMUFUXCXMUFVYSUXEWWDWE
        AHVVHYPAUWPUXBWWCAGVYTYPUVRVYSAYGWGUXAUXCUTUVPWIWJXEZAWUOWVGWVCWUPWUPWV
        IWURWVJWVAWVKWVLWVBWVBWWEWVFUYBUXAUTBBUVSYRUYBUXAUTVVDWUKUVTYRUYBBBVVEW
        ULUWAYRAIVVFUTWUMUKIVVFUMAUAWGAWUMBWUKUPUJZUTAWULWUKBUPAWUKAWUKWVEXNUWB
        XSABXMUFVYSWWFUTUMWUIYGBUTUWFYIYJYBXEZAUXTUXSUYEUQURZUYFWUJAUXSVWCVUCUK
        UJZUYEUQAUXGUYNCUEUFZUXSWWIUQURVWBMVWIIBCUWCWIAJVWCDVUCUKJVWCUMAUBWGPYB
        XEAWUEUXSVCUFUYEVCUFUXTWWHVAUYFXHWUFAIBAUXGIVCUFZVWBUHIYLVRZWVBYQAJDAJV
        WCVCUBVWEVHZVUEYQHUXSUYEXOWIXPAUYHUYIAUYDUYCUYGUQURZUYHWWGAUYCVWCCUKUJZ
        UYGUQAUXGWWJUYCWWOUQURVWBVWIICUWDVGJVWCCUKUBYAXDAWUOUYCVCUFZUYGVCUFUYDW
        WNVAUYHXHWVAAWWKWWPWWLIYOVRAJCWWMUYPYQUYBUYCUYGXOWIXPACVUCDUSAUYNWWJCVU
        CUSURMVWIBCUWEVGPXEYSYTYTYSYT $.
    $}
  $}

  ${
    $d A d e f g h i j $.  $d B d e f g h i j $.  $d C d e f g h i j $.

    $( Lemma 2.27 of [JonesMatijasevic] p. 697; rmY is a diophantine relation.
       0 was excluded from the range of B and the lower limit of G was imposed
       because the source proof does not seem to work otherwise; quite possible
       I'm just missing something.  The source proof uses both i and I; i has
       been changed to j to avoid collision.  This theorem is basically nothing
       but substitution instances, all the work is done in ~ jm2.27a and
       ~ jm2.27c .  Once Diophantine relations have been defined, the content
       of the theorem is "rmY is Diophantine" (Contributed by Stefan O'Rear,
       4-Oct-2014.) $)
    jm2.27 $p |- ( ( A e. ( ZZ>= ` 2 ) /\ B e. NN /\ C e. NN ) -> ( C = ( A rmY
        B ) <->
        E. d e. NN0 E. e e. NN0 E. f e. NN0 E. g e. NN0 E. h e. NN0 E. i e. NN0
        E. j e. NN0
          ( ( ( ( ( d ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( C ^ 2 ) ) ) = 1
                /\ ( ( f ^ 2 ) - ( ( ( A ^ 2 ) - 1 ) x. ( e ^ 2 ) ) ) = 1
                /\ g e. ( ZZ>= ` 2 ) )
             /\ ( ( ( i ^ 2 ) - ( ( ( g ^ 2 ) - 1 ) x. ( h ^ 2 ) ) ) = 1
                /\ e = ( ( j + 1 ) x. ( 2 x. ( C ^ 2 ) ) )
                /\ f || ( g - A ) ) )
          /\ ( ( ( 2 x. C ) || ( g - 1 )
                /\ f || ( h - C ) )
             /\ ( ( 2 x. C ) || ( h - B )
                /\ B <_ C ) ) ) ) ) $=
      ( c2 wcel co wceq cexp c1 cmin wa cn0 wrex cuz cfv cn w3a crmy cmul caddc
      cdivides wbr cle crmx cdiv simpl1 simpl2 simpl3 simpr eqid jm2.27c simpld
      simprd oveq1 oveq1d eqeq2d 3anbi2d anbi2d anbi1d rspcev syl eleq1 3anbi3d
      cv oveq2d eqeq1d breq2d 3anbi13d anbi12d rexbidv 3anbi1d rspc3ev 2rexbidv
      syl2anc eqeq1 ex simpll1 ad3antrrr simpll2 simpll3 simplrl simplrr simprl
      breq1 simprr simplr simp2l1 3expb simp2l2 simp2l3 simp2r1 simp2r2 simp2r3
      ad2antrr simp3ll simp3lr simp3rl simp3rr jm2.27b rexlimdva rexlimdvva
      impbid ) AKUAUBZLZBUCLZCUCLZUDZCABUEMZNZJVKZKOMZAKOMPQMZCKOMZUFMZQMZPNZEV
      KZKOMZXSDVKZKOMZUFMZQMZPNZFVKZXJLZUDZHVKZKOMZYKKOMZPQMZGVKZKOMZUFMZQMZPNZ
      YFIVKZPUGMZKXTUFMZUFMZNZYDYKAQMZUHUIZUDZRZKCUFMZYKPQMZUHUIZYDYRCQMZUHUIZR
      ZUULYRBQMZUHUIZBCUJUIZRZRZRZISTZHSTZGSTZFSTZESTZDSTJSTZXNXPUVIXNXPRZABUKM
      ZSLAKBXOUFMZUFMZUEMZSLAUVMUKMZSLUDZUVKKOMZYAQMZPNZUVOKOMZXSUVNKOMZUFMZQMZ
      PNZYLUDZUUBUVNUUFNZUVOUUHUHUIZUDZRZUUNUVOUUOUHUIZRZUVARZRZISTZHSTZGSTFSTZ
      UVIUVJUVPAUVTUVTAQMUFMUGMZSLUWQBUEMZSLUWQBUKMZSLUDZUVJUVPUWTRZUVNUUEULMPQ
      MZSLUVSUWDUWQXJLZUDZUWSKOMZUWQKOMZPQMZUWRKOMZUFMZQMZPNZUVNUXBPUGMZUUEUFMZ
      NZUVOUWQAQMZUHUIZUDZRZUULUWQPQMZUHUIZUVOUWRCQMZUHUIZRZUULUWRBQMZUHUIZUUTR
      ZRZRZRZUVJABCUVKUVLUVNUVOUWQUWRUWSUXBXKXLXMXPUMXKXLXMXPUNXKXLXMXPUOXNXPUP
      UVKUQUVLUQUVNUQUVOUQUWQUQUWRUQUWSUQUXBUQURZUSZUSUVJUWTUXDUXKUWFUXPUDZRZUY
      GRZISTZUWPUVJUVPUWTUYKUTUVJUYIUYOUVJUXAUYIUYJUTUYNUYHIUXBSUUCUXBNZUYMUXRU
      YGUYPUYLUXQUXDUYPUWFUXNUXKUXPUYPUUFUXMUVNUYPUUDUXLUUEUFUUCUXBPUGVAVBVCVDV
      EVFVGVHUWNUYOUXDYOUXGYSUFMZQMZPNZUWFUXPUDZRZUXTUWJRZUVARZRZISTUXDYOUXIQMZ
      PNZUWFUXPUDZRZUYGRZISTFGHUWQUWRUWSSSSYKUWQNZUWMVUDISVUJUWIVUAUWLVUCVUJUWE
      UXDUWHUYTVUJYLUXCUVSUWDYKUWQXJVIVJVUJUUBUYSUWGUXPUWFVUJUUAUYRPVUJYTUYQYOQ
      VUJYQUXGYSUFVUJYPUXFPQYKUWQKOVAVBVBVLVMVUJUUHUXOUVOUHYKUWQAQVAVNVOVPVUJUW
      KVUBUVAVUJUUNUXTUWJVUJUUMUXSUULUHYKUWQPQVAVNVFVFVPVQYRUWRNZVUDVUIISVUKVUA
      VUHVUCUYGVUKUYTVUGUXDVUKUYSVUFUWFUXPVUKUYRVUEPVUKUYQUXIYOQVUKYSUXHUXGUFYR
      UWRKOVAVLVLVMVRVEVUKVUBUYCUVAUYFVUKUWJUYBUXTVUKUUOUYAUVOUHYRUWRCQVAVNVEVU
      KUUSUYEUUTVUKUURUYDUULUHYRUWRBQVAVNVFVPVPVQYNUWSNZVUIUYNISVULVUHUYMUYGVUL
      VUGUYLUXDVULVUFUXKUWFUXPVULVUEUXJPVULYOUXEUXIQYNUWSKOVAVBVMVRVEVFVQVSWAUV
      GUWPUVSYJYLUDZUUJRZUVBRZISTHSTZGSTFSTUVSYEUWBQMZPNZYLUDZUUBUWFUUIUDZRZUVB
      RZISTHSTZGSTFSTJDEUVKUVNUVOSSSXQUVKNZUVEVUPFGSSVVDUVCVUOHISSVVDUUKVUNUVBV
      VDYMVUMUUJVVDYCUVSYJYLVVDYBUVRPVVDXRUVQYAQXQUVKKOVAVBVMVRVFVFVTVTYFUVNNZV
      UPVVCFGSSVVEVUOVVBHISSVVEVUNVVAUVBVVEVUMVUSUUJVUTVVEYJVURUVSYLVVEYIVUQPVV
      EYHUWBYEQVVEYGUWAXSUFYFUVNKOVAVLVLVMVDVVEUUGUWFUUBUUIYFUVNUUFWBVDVPVFVTVT
      YDUVONZVVCUWOFGSSVVFVVBUWMHISSVVFVVAUWIUVBUWLVVFVUSUWEVUTUWHVVFVURUWDUVSY
      LVVFVUQUWCPVVFYEUVTUWBQYDUVOKOVAVBVMVDVVFUUIUWGUUBUWFYDUVOUUHUHWKVJVPVVFU
      UQUWKUVAVVFUUPUWJUUNYDUVOUUOUHWKVEVFVPVTVTVSWAWCXNUVHXPJDSSXNXQSLZYFSLZRZ
      RZUVFXPEFSSVVJYDSLZYKSLZRZRZUVDXPGHSSVVNYRSLZYNSLZRZRZUVCXPISVVRUUCSLZRZU
      VCXPVVTUVCRABCXQYFYDYKYRYNUUCVVNXKVVQVVSUVCXKXLXMVVIVVMWDWEVVNXLVVQVVSUVC
      XKXLXMVVIVVMWFWEVVNXMVVQVVSUVCXKXLXMVVIVVMWGWEVVNVVGVVQVVSUVCXNVVGVVHVVMW
      HWEVVNVVHVVQVVSUVCXNVVGVVHVVMWIWEVVNVVKVVQVVSUVCVVJVVKVVLWJWEVVNVVLVVQVVS
      UVCVVJVVKVVLWLWEVVRVVOVVSUVCVVNVVOVVPWJXAVVRVVPVVSUVCVVNVVOVVPWLXAVVRVVSU
      VCWMVVTUUKUVBYCYCYJYLUUJVVTUVBWNWOVVTUUKUVBYJYCYJYLUUJVVTUVBWPWOVVTUUKUVB
      YLYCYJYLUUJVVTUVBWQWOVVTUUKUVBUUBUUBUUGUUIYMVVTUVBWRWOVVTUUKUVBUUGUUBUUGU
      UIYMVVTUVBWSWOVVTUUKUVBUUIUUBUUGUUIYMVVTUVBWTWOVVTUUKUVBUUNUUNUUPUVAVVTUU
      KXBWOVVTUUKUVBUUPUUNUUPUVAVVTUUKXCWOVVTUUKUVBUUSUUSUUTUUQVVTUUKXDWOVVTUUK
      UVBUUTUUSUUTUUQVVTUUKXEWOXFWCXGXHXHXHXI $.
  $}

  ${
    $d A a b $.  $d B a b $.
    jm2.27dlem1.1 $e |- A e. ( 1 ... B ) $.
    $( Lemma for ~ rmydioph .  Subsitution of a tuple restriction into a
       projection that doesn't care.  (Contributed by Stefan O'Rear,
       11-Oct-2014.) $)
    jm2.27dlem1 $p |- ( a = ( b |` ( 1 ... B ) ) -> ( a ` A ) = ( b ` A ) ) $=
      ( cv c1 cfz co cres wceq cfv fveq1 wcel fvres ax-mp syl6eq ) CFZDFZGBHIZJ
      ZKARLAUALZASLZARUAMATNUBUCKEATSOPQ $.
  $}

  ${
    jm2.27dlem2.1 $e |- A e. ( 1 ... B ) $.
    jm2.27dlem2.2 $e |- C = ( B + 1 ) $.
    jm2.27dlem2.3 $e |- B e. NN $.
    $( Lemma for ~ rmydioph .  This theorem is used along with the next three
       to efficiently infer steps like ` 7 e. ( 1 ... 10 ) ` .  (Contributed by
       Stefan O'Rear, 11-Oct-2014.) $)
    jm2.27dlem2 $p |- A e. ( 1 ... C ) $=
      ( c1 cfz co wcel cz cle wbr elfzelz ax-mp elfzle1 caddc cr zrei nnrei w3a
      elfzle2 letrp1 mp3an breqtrri wb 1z cn nnz peano2z eqeltri elfz1 mpbir3an
      mp2b mp2an ) AGCHIJZAKJZGALMZACLMZAGBHIJZUQDAGBNOZUTURDAGBPOABGQIZCLARJBR
      JABLMZAVBLMAVASBFTUTVCDAGBUBOABUCUDEUEGKJCKJUPUQURUSUAUFUGCVBKEBUHJBKJVBK
      JFBUIBUJUNUKAGCULUOUM $.
  $}

  ${
    jm2.27dlem3.1 $e |- A e. NN $.
    $( Lemma for ~ rmydioph .  Infer membership of the endpoint of a range.
       (Contributed by Stefan O'Rear, 11-Oct-2014.) $)
    jm2.27dlem3 $p |- A e. ( 1 ... A ) $=
      ( cn wcel c1 cfz co elfz1end mpbi ) ACDAEAFGDBAHI $.

    jm2.27dlem4.2 $e |- B = ( A + 1 ) $.
    $( Lemma for ~ rmydioph .  Infer ` NN ` -hood of large numbers.
       (Contributed by Stefan O'Rear, 11-Oct-2014.) $)
    jm2.27dlem4 $p |- B e. NN $=
      ( c1 caddc co cn wcel peano2nn ax-mp eqeltri ) BAEFGZHDAHIMHICAJKL $.
  $}

  ${
    jm2.27dlem5.2 $e |- B = ( A + 1 ) $.
    jm2.27dlem5.3 $e |- ( 1 ... B ) C_ ( 1 ... C ) $.
    $( Lemma for ~ rmydioph .  Used with ~ sselii to infer membership of
       midpoints of range; ~ jm2.27dlem2 is deprecated.  (Contributed by Stefan
       O'Rear, 11-Oct-2014.) $)
    jm2.27dlem5 $p |- ( 1 ... A ) C_ ( 1 ... C ) $=
      ( c1 cfz co caddc fzssp1 oveq2i sseqtr4i sstri ) FAGHZFBGHZFCGHNFAFIHZGHO
      FAJBPFGDKLEM $.
  $}

  ${
    $d a b c d e f g h i j k l $.

    $( ~ jm2.27 restated in terms of Diophantine sets.  (Contributed by Stefan
       O'Rear, 11-Oct-2014.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    rmydioph $p |- { a e. ( NN0 ^m ( 1 ... 3 ) ) | ( ( a ` 1 ) e. ( ZZ>= ` 2 )
        /\ ( a ` 3 ) = ( ( a ` 1 ) rmY ( a ` 2 ) ) ) } e. ( Dioph ` 3 ) $=
      ( vi c1 cfv c2 wcel c3 co wceq cn0 crab cexp cmin cmul cdivides wbr mp2an
      wa cmpt c10 vb vd vc ve vg vf vh cv cuz crmy cfz cmap cn w3a cle wrex cc0
      caddc wo cdioph wb wf 2nn jm2.27dlem3 jm2.27dlem2 anbi2d cz simplr adantl
      df-3 clt ad2antlr syl3anc eleq1 pm5.32da bitrd ex pm5.32rd eqeq2d rabbiia
      a1i cmzp 3nn0 2z cvv ovex 1nn df-2 mzpproj eluzrabdioph elnnrabdioph wsbc
      mp3an c9 c8 c7 c6 c5 c4 fvex oveq1 oveq2d eqeq1d oveq1d 3ad2ant3 3anbi12d
      oveqan12rd breq2d anbi1d anbi12d 3ad2ant1 sbc3ie oveq12d 3anbi23d breq12d
      sbcbii jm2.27dlem1 adantr 10nn0 df-5 df-6 df-7 df-8 df-9 jm2.27dlem5 2nn0
      mzpexpmpt df-4 mzpconstmpt mzpsubmpt mzpmulmpt eqrabdioph 3anrabdioph 9nn
      df-10 sselii dvdsrabdioph anrabdioph eqeltri eq0rabdioph elmapi elnn0 iba
      ffvelrn sylancl sylib andi syl6bb syl frmy fovcl syl2anc rmy0 nngt0 ltrmy
      0z mpbid eqbrtrrd elnnz sylanbrc syl5ibrcom pm4.71rd simpllr simpr jm2.27
      nnz oveq2 eqtrd orbi12d cres 3adant3 3ad2ant2 eqeq1 simp2 3anbi123d breq1
      3nn bi2anan9r 3adant1 vex resex breq1d sbc2ie 3bitri ssid 4nn 6nn 5nn 7nn
      1z 8nn 10nn mzpaddmpt lerabdioph 7rexfrabdioph orrabdioph ) CAUHZDZEUIDZF
      ZGUWQDZUWREUWQDZUJHZIZRZAJCGUKHZULHZKUWTUXAUMFZUAUHZELHZUWRELHZCMHZUXAELH
      ZNHZMHZCIZUBUHZELHZUXLUCUHZELHZNHZMHZCIZUDUHZUWSFZUNZUEUHZELHZUYDELHZCMHZ
      UFUHZELHZNHZMHZCIZUXSUGUHZCURHZEUXMNHZNHZIZUXQUYDUWRMHZOPZUNZRZEUXANHZUYD
      CMHZOPZUXQUYKUXAMHZOPZRZVUEUYKUXBMHZOPZUXBUXAUOPZRZRZRZUGJUPUEJUPUFJUPUDJ
      UPUBJUPUCJUPUAJUPZRZUXBUMFZRZUXAUQIZUXBUQIZRZUSZRZAUXGKZGUTDZUXEVVEAUXGUW
      QUXGFZUXEUWTUXDVUSRZUXDVVBRZUSZRZVVEVVHVUSVVBUSZUXEVVLVAVVHUXBJFZVVMVVHUX
      FJUWQVBEUXFFZVVNUWQJUXFUUAEEGEVCVDZVJVCVEZUXFJEUWQUUDUUEUXBUUBUUFVVMUXDVV
      KUWTVVMUXDUXDVVMRVVKVVMUXDUUCUXDVUSVVBUUGUUHVFUUIVVHUWTVVKVVDVVHUWTRZVVIV
      UTVVJVVCVVRVUSUXDVURVVRVUSUXDVURVAVVRVUSRZUXDUXHUXDRVURVVSUXDUXHVVSUXHUXD
      UXCUMFZVVSUXCVGFZUQUXCVKPVVTVVSUWTUXBVGFZVWAVVHUWTVUSVHZVUSVWBVVRUXBUVFVI
      ZUWRUXBVGUWSVGUJUUJUUKUULVVSUWRUQUJHZUQUXCVKUWTVWEUQIZVVHVUSUWRUUMZVLVVSU
      QUXBVKPZVWEUXCVKPZVUSVWHVVRUXBUUNVIVVSUWTUQVGFZVWBVWHVWIVAVWCVWJVVSUUPWAV
      WDUWRUQUXBUUOVMUUQUURUXCUUSUUTUXAUXCUMVNUVAUVBVVSUXHUXDVUQVVSUXHRUWTVUSUX
      HUXDVUQVAVVHUWTVUSUXHUVCVVRVUSUXHVHVVSUXHUVDUWRUXBUXAUCUBUDUFUEUGUAUVEVMV
      OVPVQVRVVRVVBUXDVVAVVRVVBUXDVVAVAVVRVVBRZUXCUQUXAVWKUXCVWEUQVVBUXCVWEIVVR
      UXBUQUWRUJUVGVIUWTVWFVVHVVBVWGVLUVHVSVQVRUVIVOVPVTUWTAUXGKVVGFZVVDAUXGKVV
      GFZVVFVVGFGJFZEVGFZAVGUXFULHZUWRSUXFWBDZFZVWLWCWDUXFWEFZCUXFFVWRCGUKWFZCE
      GCCECWGVDZWHWGVEVJVCVEZAUXFCWIQAUWREGWJWMVUTAUXGKVVGFZVVCAUXGKVVGFZVWMVUR
      AUXGKVVGFZVUSAUXGKVVGFZVXCUXHAUXGKVVGFZVUQAUXGKVVGFZVXEVWNAVWPUXASVWQFZVX
      GWCVWSGUXFFVXIVWTGUVQVDZAUXFGWIQZAUXAGWKQVWNVUPUGTBUHZDZWLUEWNVXLDZWLUFWO
      VXLDZWLZUDWPVXLDZWLZUBWQVXLDZWLZUCWRVXLDZWLZUAWSVXLDZWLZAVXLUXFUVJZWLZBJC
      TUKHZULHZKZTUTDZFVXHWCVYIVYCELHZCVXLDZELHZCMHZGVXLDZELHZNHZMHZCIZVXSELHZV
      YNVYAELHZNHZMHZCIZVXQUWSFZUNZVXNELHZVXQELHZCMHZVXOELHZNHZMHZCIZVYAVXMCURH
      ZEVYPNHZNHZIZVXSVXQVYLMHZOPZUNZRZEVYONHZVXQCMHZOPZVXSVXOVYOMHZOPZRZWVBVXO
      EVXLDZMHZOPZWVHVYOUOPZRZRZRZBVYHKZVYJVYFWVNBVYHVYFWVNVAVXLVYHFVYFUYFWUGUY
      JWUJNHZMHZCIZUXSWUNUYRNHZIZVUBUNZRZVUGUXQVXOUXAMHZOPZRZVUEVXOUXBMHZOPZVUM
      RZRZRZUDVXQWLZUBVXSWLZUCVYAWLZUAVYCWLZAVYEWLUXPVYTUXLWUANHZMHZCIZWUEUNZWU
      MVYAWVSIZVXSVXQUWRMHZOPZUNZRZVUEWVCOPZVXSWWCOPZRZWWHRZRZUAVYCWLZAVYEWLWVN
      VYDWWNAVYEVYBWWMUAVYCVXTWWLUCVYAVXRWWKUBVXSVXPWWJUDVXQVUPWWJUFUEUGVXOVXNV
      XMWOVXLWTWNVXLWTTVXLWTUYKVXOIZUYGVXNIZUYPVXMIZUNZVUDWWBVUOWWIWXMVUCWWAUYF
      WXMUYOWVRUYTWVTVUBWXJWXKUYOWVRVAWXLWXJWXKRUYNWVQCWXKWXJUYHWUGUYMWVPMUYGVX
      NELXAWXJUYLWUJUYJNUYKVXOELXAXBXGXCUVKWXLWXJUYTWVTVAWXKWXLUYSWVSUXSWXLUYQW
      UNUYRNUYPVXMCURXAXDVSXEXFVFWXJWXKVUOWWIVAWXLWXJVUJWWEVUNWWHWXJVUIWWDVUGWX
      JVUHWWCUXQOUYKVXOUXAMXAXHVFWXJVULWWGVUMWXJVUKWWFVUEOUYKVXOUXBMXAXHXIXJXKX
      JXLXPXPXPXPXPWWNWXIAVYEWWMWXHUAVYCWWJWXHUCUBUDVYAVXSVXQWRVXLWTWQVXLWTWPVX
      LWTUXSVYAIZUXQVXSIZUYDVXQIZUNZWWBWXCWWIWXGWXQUYFWWRWWAWXBWXQUYCWWQUYEWUEU
      XPWXQUYBWWPCWXQUXRVYTUYAWWOMWXOWXNUXRVYTIWXPUXQVXSELXAUVLWXNWXOUYAWWOIWXP
      WXNUXTWUAUXLNUXSVYAELXAXBXKXMXCWXPWXNUYEWUEVAWXOUYDVXQUWSVNXEXNWXQWVRWUMW
      VTWWSVUBWXAWXPWXNWVRWUMVAWXOWXPWVQWULCWXPWVPWUKWUGMWXPUYJWUIWUJNWXPUYIWUH
      CMUYDVXQELXAXDXDXBXCXEWXNWXOWVTWWSVAWXPUXSVYAWVSUVMXKWXQUXQVXSVUAWWTOWXNW
      XOWXPUVNWXPWXNVUAWWTIWXOUYDVXQUWRMXAXEXOUVOXJWXOWXPWWIWXGVAWXNWXOWXPRWWEW
      XFWWHWXPVUGWXDWXOWWDWXEWXPVUFWVCVUEOUYDVXQCMXAXHUXQVXSWWCOUVPUVRXIUVSXJXL
      XPXPWXHWVNAUAVYEVYCVXLUXFBUVTUWAWSVXLWTUWQVYEIZUXIVYCIZRZWXCWVAWXGWVMWXTW
      WRWUFWXBWUTWXTUXPVYSWWQWUDWUEWXTUXOVYRCWXSWXRUXJVYKUXNVYQMUXIVYCELXAWXRUX
      LVYNUXMVYPNWXRUXKVYMCMWXRUWRVYLELCGABVXBXQZXDXDZWXRUXAVYOELGGABVXJXQZXDZX
      MXGXCWXRWWQWUDVAWXSWXRWWPWUCCWXRWWOWUBVYTMWXRUXLVYNWUANWYBXDXBXCXRXFWXRWX
      BWUTVAWXSWXRWWSWUQWXAWUSWUMWXRWVSWUPVYAWXRUYRWUOWUNNWXRUXMVYPENWYDXBXBVSW
      XRWWTWURVXSOWXRUWRVYLVXQMWYAXBXHXNXRXJWXRWXGWVMVAWXSWXRWXFWVGWWHWVLWXRWXD
      WVDWXEWVFWXRVUEWVBWVCOWXRUXAVYOENWYCXBZUWBWXRWWCWVEVXSOWXRUXAVYOVXOMWYCXB
      XHXJWXRWWGWVJVUMWVKWXRVUEWVBWWFWVIOWYEWXRUXBWVHVXOMEGABVVQXQZXBXOWXRUXBWV
      HUXAVYOUOWYFWYCXOXJXJXRXJUWCUWDWAVTWVABVYHKVYJFZWVMBVYHKVYJFZWVOVYJFWUFBV
      YHKVYJFZWUTBVYHKVYJFZWYGVYSBVYHKVYJFZWUDBVYHKVYJFZWUEBVYHKVYJFZWYITJFZBVG
      VYGULHZVYRSVYGWBDZFZBWYOCSWYPFZWYKXSBWYOVYKSWYPFZBWYOVYQSWYPFZWYQBWYOVYCS
      WYPFZEJFZWYSVYGWEFZWSVYGFXUACTUKWFZCWSUKHVYGWSWSWRTXTWRWQTYAWQWPTYBWPWOTY
      CWOWNTYDWNTTYOVYGUWEYEYEZYEZYEZYEZYEZWSUWFVDYPBVYGWSWIQYFBVYCEVYGYGQBWYOV
      YNSWYPFZBWYOVYPSWYPFZWYTBWYOVYMSWYPFZWYRXUJBWYOVYLSWYPFZXUBXULXUCCVYGFXUM
      XUDCCUKHVYGCCETWHEGTVJGWSTYHXUIYEZYEZYEVXAYPBVYGCWIQZYFBVYLEVYGYGQXUCCVGF
      WYRXUDUWJBCVYGYIQZBVYMCVYGYJQZBWYOVYOSWYPFZXUBXUKXUCGVYGFXUSXUDUXFVYGGXUN
      VXJYPBVYGGWIQZYFBVYOEVYGYGQZBVYNVYPVYGYKQBVYKVYQVYGYJQXUQBVYRCTYLWMWYNBWY
      OWUCSWYPFZWYRWYLXSBWYOVYTSWYPFZBWYOWUBSWYPFZXVBBWYOVXSSWYPFZXUBXVCXUCWQVY
      GFXVEXUDCWQUKHVYGWQXUGWQUWGVDYPBVYGWQWIQZYFBVXSEVYGYGQXUJBWYOWUASWYPFZXVD
      XURBWYOVYASWYPFZXUBXVGXUCWRVYGFXVHXUDCWRUKHVYGWRXUHWRUWHVDYPBVYGWRWIQZYFB
      VYAEVYGYGQBVYNWUAVYGYKQBVYTWUBVYGYJQXUQBWUCCTYLWMWYNVWOBWYOVXQSWYPFZWYMXS
      WDXUCWPVYGFXVJXUDCWPUKHVYGWPXUFWPUWIVDYPBVYGWPWIQZBVXQETWJWMVYSWUDWUEBTYM
      WMWUMBVYHKVYJFZWUQBVYHKVYJFZWUSBVYHKVYJFZWYJWYNBWYOWULSWYPFZWYRXVLXSBWYOW
      UGSWYPFZBWYOWUKSWYPFZXVOBWYOVXNSWYPFZXUBXVPXUCWNVYGFXVRXUDWNWNTWNYNVDYOYN
      VEBVYGWNWIQYFBVXNEVYGYGQBWYOWUISWYPFZBWYOWUJSWYPFZXVQBWYOWUHSWYPFZWYRXVSX
      VJXUBXWAXVKYFBVXQEVYGYGQXUQBWUHCVYGYJQBWYOVXOSWYPFZXUBXVTXUCWOVYGFXWBXUDC
      WOUKHVYGWOXUEWOUWKVDYPBVYGWOWIQZYFBVXOEVYGYGQBWUIWUJVYGYKQBWUGWUKVYGYJQXU
      QBWULCTYLWMWYNXVHBWYOWUPSWYPFZXVMXSXVIBWYOWUNSWYPFZBWYOWUOSWYPFZXWDBWYOVX
      MSWYPFZWYRXWEXUCTVYGFXWGXUDTUWLVDBVYGTWIQXUQBVXMCVYGUWMQBWYOESWYPFZXUKXWF
      XUCVWOXWHXUDWDBEVYGYIQZXVABEVYPVYGYKQBWUNWUOVYGYKQBVYAWUPTYLWMWYNXVEBWYOW
      URSWYPFZXVNXSXVFXVJXUMXWJXVKXUPBVXQVYLVYGYJQBVXSWURTYQWMWUMWUQWUSBTYMWMWU
      FWUTBTYRQWVGBVYHKVYJFZWVLBVYHKVYJFZWYHWVDBVYHKVYJFZWVFBVYHKVYJFZXWKWYNBWY
      OWVBSWYPFZBWYOWVCSWYPFZXWMXSXWHXUSXWOXWIXUTBEVYOVYGYKQZXVJWYRXWPXVKXUQBVX
      QCVYGYJQBWVBWVCTYQWMWYNXVEBWYOWVESWYPFZXWNXSXVFXWBXUSXWRXWCXUTBVXOVYOVYGY
      JQBVXSWVETYQWMWVDWVFBTYRQWVJBVYHKVYJFZWVKBVYHKVYJFZXWLWYNXWOBWYOWVISWYPFZ
      XWSXSXWQXWBBWYOWVHSWYPFZXXAXWCXUCEVYGFXXBXUDCEUKHVYGEXUOVVPYPBVYGEWIQZBVX
      OWVHVYGYJQBWVBWVITYQWMWYNXXBXUSXWTXSXXCXUTBWVHVYOTUWNWMWVJWVKBTYRQWVGWVLB
      TYRQWVAWVMBTYRQYSVUPUBUDUFUCUAABTWNWOWPWQWRWSGUGUEYHXTYAYBYCYDYOUWOQUXHVU
      QAGYRQVWNAVWPUXBSVWQFZVXFWCVWSVVOXXDVWTVVQAUXFEWIQZAUXBGWKQVURVUSAGYRQVVA
      AUXGKVVGFZVVBAUXGKVVGFZVXDVWNVXIXXFWCVXKAUXAGYTQVWNXXDXXGWCXXEAUXBGYTQVVA
      VVBAGYRQVUTVVCAGUWPQUWTVVDAGYRQYS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    X and Y sequences 5: Diophantine representability of X, ^, _C
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A y $.  $d N y $.  $d X y $.
    $( X can be expressed in terms of Y, so it is also Diophantine.
       (Contributed by Stefan O'Rear, 15-Oct-2014.) $)
    rmxdiophlem $p |- ( ( A e. ( ZZ>= ` 2 ) /\ N e. NN0 /\ X e. NN0 ) -> ( X =
      ( A rmX N ) <-> E. y e. NN0 ( y = ( A rmY N ) /\ ( ( X ^ 2 ) - ( (
        ( A ^ 2 ) - 1 ) x. ( y ^ 2 ) ) ) = 1 ) ) ) $=
      ( c2 wcel cn0 crmx co wceq cexp cmin cmul nn0sqcl 3ad2ant3 nn0cnd syl2anc
      c1 wa syl cuz cfv w3a crmy cv wrex cz simp1 nn0z 3ad2ant2 fovcl csquarenn
      cn rmspecnonsq eldifad nnnn0d 3ad2ant1 rmynn0 3adant3 nn0mulcld subcan2ad
      frmx rmxynorm eqeq2d cr cc0 cle wbr nn0re nn0ge0 jca sq11 3bitr3rd oveq2d
      wb oveq1 eqeq1d ceqsrexv bitr4d ) BEUAUBZFZCGFZDGFZUCZDBCHIZJZDEKIZBEKIRL
      IZBCUDIZEKIZMIZLIZRJZAUEZWIJZWGWHWNEKIZMIZLIZRJZSAGUFZWDWLWEEKIZWKLIZJWGX
      AJZWMWFWDWGXAWKWDWGWCWAWGGFWBDNOPWDXAWDWEGFZXAGFWDWACUGFZXDWAWBWCUHZWBWAX
      EWCCUIUJZBCGVTUGHVBUKQZWENTPWDWKWDWHWJWAWBWHGFWCWAWHWAWHUMULBUNUOUPUQWDWI
      GFZWJGFWAWBXIWCBCURUSZWINTUTPVAWDXBRWLWDWAXEXBRJXFXGBCVCQVDWDDVEFZVFDVGVH
      ZSZWEVEFZVFWEVGVHZSZXCWFVOWCWAXMWBWCXKXLDVIDVJVKOWDXDXPXHXDXNXOWEVIWEVJVK
      TDWEVLQVMWDXIWTWMVOXJWSWMAWIGWOWRWLRWOWQWKWGLWOWPWJWHMWNWIEKVPVNVNVQVRTVS
      $.
  $}

  ${
    $d a b c d $.
    $( X is a Diophantine function.  (Contributed by Stefan O'Rear,
       17-Oct-2014.) $)
    rmxdioph $p |- { a e. ( NN0 ^m ( 1 ... 3 ) ) | ( ( a ` 1 ) e. ( ZZ>= ` 2 )
        /\ ( a ` 3 ) = ( ( a ` 1 ) rmX ( a ` 2 ) ) ) } e. ( Dioph ` 3 ) $=
      ( vb vc c1 cfv c2 wcel c3 co wceq wa cn0 cfz crab crmy cexp cmin c4 mp2an
      cmpt cv cuz crmx cmap cmul wrex cdioph simpr elmapi df-3 ssid jm2.27dlem5
      wb 2nn jm2.27dlem3 sselii ffvelrn sylancl adantr 3nn rmxdiophlem pm5.32da
      wf syl3anc anass rexbii r19.42v bitr2i syl6bb rabbiia wsbc cres vex resex
      3nn0 fvex 1nn jm2.27dlem1 eleq1d oveq12d eqeq12d anbi12d oveq1d oveqan12d
      df-2 oveq1 eqeq1d sbc2ie a1i 4nn0 rmydioph w3a simp1 simp3 simp2 df-4 4nn
      rabren3dioph cz cmzp ovex mzpproj 2nn0 mzpexpmpt 1z mzpconstmpt mzpsubmpt
      cvv mzpmulmpt eqrabdioph mp3an anrabdioph eqeltri rexfrabdioph ) DAUAZEZF
      UBEZGZHXOEZXPFXOEZUCIJZKZALDHMIZUDIZNXRBUAZXPXTOIZJZKZXSFPIZXPFPIZDQIZYEF
      PIZUEIZQIZDJZKZBLUFZAYDNZHUGEZYBYQAYDXOYDGZYBXRYGYOKZBLUFZKZYQYTXRYAUUBYT
      XRKXRXTLGZXSLGZYAUUBUMYTXRUHYTUUDXRYTYCLXOVCZFYCGUUDXOLYCUIZDFMIZYCFFHHUJ
      YCUKULZFUNUOZUPZYCLFXOUQURUSYTUUEXRYTUUFHYCGUUEUUGHUTUOZYCLHXOUQURUSBXPXT
      XSVAVDVBYQXRUUAKZBLUFUUCYPUUMBLXRYGYOVEVFXRUUABLVGVHVIVJHLGYPBRCUAZEZVKAU
      UNYCVLZVKZCLDRMIZUDIZNZRUGEZGYRYSGVOUUTDUUNEZXQGZUUOUVBFUUNEZOIZJZKZHUUNE
      ZFPIZUVBFPIZDQIZUUOFPIZUEIZQIZDJZKZCUUSNZUVAUUQUVPCUUSUUQUVPUMUUNUUSGYPUV
      PABUUPUUOUUNYCCVMVNRUUNVPXOUUPJZYEUUOJZKZYHUVGYOUVOUVTXRUVCYGUVFUVRXRUVCU
      MUVSUVRXPUVBXQDHACDDMIZYCDDFHWEUUIULDVQUOZUPVRZVSUSUVTYEUUOYFUVEUVRUVSUHU
      VRYFUVEJUVSUVRXPUVBXTUVDOUWCFHACUUKVRVTUSWAWBUVTYNUVNDUVTYIUVIYMUVMQUVRYI
      UVIJUVSUVRXSUVHFPHHACUULVRWCUSUVRUVSYKUVKYLUVLUEUVRYJUVJDQUVRXPUVBFPUWCWC
      WCYEUUOFPWFWDVTWGWBWHWIVJUVGCUUSNUVAGZUVOCUUSNUVAGZUVQUVAGRLGZDYEEZXQGZHY
      EEZUWGFYEEZOIZJZKZBYDNYSGUWDWJBWKUWMUVGRDFRBCUWGUVBJZUWJUVDJZUWIUUOJZWLZU
      WHUVCUWLUVFUWQUWGUVBXQUWNUWOUWPWMZVSUWQUWIUUOUWKUVEUWNUWOUWPWNUWQUWGUVBUW
      JUVDOUWRUWNUWOUWPWOVTWAWBUWAUURDDFRWEFHRUJHRRWPUURUKULZULZULUWBUPZUUHUURF
      UWTUUJUPRWQUOZWRSUWFCWSUURUDIZUVNTUURWTEZGZCUXCDTUXDGZUWEWJCUXCUVITUXDGZC
      UXCUVMTUXDGZUXECUXCUVHTUXDGZFLGZUXGUURXHGZHUURGUXIDRMXAZYCUURHUWSUULUPCUU
      RHXBSXCCUVHFUURXDSCUXCUVKTUXDGZCUXCUVLTUXDGZUXHCUXCUVJTUXDGZUXFUXMCUXCUVB
      TUXDGZUXJUXOUXKDUURGUXPUXLUXACUURDXBSXCCUVBFUURXDSUXKDWSGUXFUXLXECDUURXFS
      ZCUVJDUURXGSCUXCUUOTUXDGZUXJUXNUXKRUURGUXRUXLUXBCUURRXBSXCCUUOFUURXDSCUVK
      UVLUURXISCUVIUVMUURXGSUXQCUVNDRXJXKUVGUVOCRXLSXMYPBACRHWPXNSXM $.
  $}

  ${
    jm3.1.a $e |- ( ph -> A e. ( ZZ>= ` 2 ) ) $.
    jm3.1.b $e |- ( ph -> K e. ( ZZ>= ` 2 ) ) $.
    jm3.1.c $e |- ( ph -> N e. NN ) $.
    jm3.1.d $e |- ( ph -> ( K rmY ( N + 1 ) ) <_ A ) $.
    $( Lemma for ~ jm3.1 .  (Contributed by Stefan O'Rear, 16-Oct-2014.) $)
    jm3.1lem1 $p |- ( ph -> ( K ^ N ) < A ) $=
      ( cexp co c2 c1 cmin wcel syl cn cz clt wbr cc cuz cfv cr eluzelre nnnn0d
      cmul reexpcld 2z uzid ax-mp uz2mulcl sylancr uz2m1nn nnred cc0 nngt0d 2cn
      recnd mulcl ax-1cn a1i sub32d caddc 2timesd oveq1d eqtrd breqtrrd posdifd
      pncand mpbird crp eluz2b2 simplbi nnrpd rpexpmord syl3anc mpbid crmy nnzd
      wb peano2zd frmy fovcl syl2anc zred cn0 cle jm2.17a letrd ltletrd ) ACDIJ
      ZKCUFJZLMJZDIJZBACDACKUAUBZNZCUCNFKCUDOZADGUEZUGAWMDAWMAWLWONZWMPNAKWONZW
      PWSKQNWTUHKUIUJFKCUKULWLUMOZUNZWRUGZABWONBUCNEKBUDOZACWMRSZWKWNRSZAXEUOWM
      CMJZRSAUOCLMJZXGRAXHAWPXHPNFCUMOUPAXGWLCMJZLMJXHAWLLCAKTNCTNWLTNUQACWQURZ
      KCUSULLTNAUTVAXJVBAXICLMAXICCVCJZCMJCAWLXKCMACXJVDVEACCXJXJVIVFVEVFVGACWM
      WQXBVHVJADPNCVKNWMVKNXEXFVTGACAWPCPNZFWPXLLCRSCVLVMOVNAWMXAVNCWMDVOVPVQAW
      NCDLVCJZVRJZBXCAXNAWPXMQNXNQNFADADGVSWACXMQWOQVRWBWCWDWEXDAWPDWFNWNXNWGSF
      WRCDWHWDHWIWJ $.

    $( Lemma for ~ jm3.1 .  (Contributed by Stefan O'Rear, 16-Oct-2014.) $)
    jm3.1lem2 $p |- ( ph -> ( K ^ N ) < ( ( ( ( 2 x. A ) x. K ) - ( K ^ 2 ) ) -
        1 ) ) $=
      ( co c2 cmul cmin c1 wcel cr syl caddc clt wbr recnd cexp eluzelre nnnn0d
      cuz cfv reexpcld 2re remulcl sylancr remulcld resqcld 1re resubcl sylancl
      resubcld jm3.1lem1 readdcld cz eluz2b1 simprbi cc0 eluz2b2 simplbi nngt0d
      wb cn ltmulgt11 syl3anc mpbid uz2m1nn nnrpd ltaddrpd lttrd peano2re exp1d
      cle nnge1d nnuz syl6eleq leexp2ad eqbrtrrd lelttrd eluzelz zltp1le lemul1
      syl2anc syl112anc leadd1dd cc ax-1cn a1i addsub12d adddird sqvald oveq12d
      mulcld pncan2d mulid2d 3eqtrd oveq1d oveq2d subadd23d 3eqtr3d 2cn mulassd
      mulcl 2timesd eqtrd sub32d addsubassd 3brtr4d ltletrd ) ACDUAIZBJBKIZCKIZ
      CJUAIZLIZMLIZACDACJUDUEZNZCONZFJCUBPZADGUCUFZABXSNZBONZEJBUBPZAXQONMONZXR
      ONAXOXPAXNCAJONYEXNONUGYFJBUHUIYBUJACYBUKZUOULXQMUMUNZABCDEFGHUPZABBCKIZC
      MLIZQIZXRYFAYKYLABCYFYBUJZAYAYGYLONYBULCMUMUNUQZYIABYKYMYFYNYOAMCRSZBYKRS
      ZAXTYPFXTCURNZYPCUSUTPAYEYAVABRSYPYQVEYFYBABAYDBVFNZEYDYSMBRSBVBVCPVDBCVG
      VHVIAYKYLYNAYLAXTYLVFNFCVJPVKVLVMACMQIZCKIZYKMLIZXPLIZQIZYKUUCQIZYMXRVPAU
      UAYKUUCAYTCAYAYTONZYBCVNPZYBUJZYNAUUBXPAYKONYGUUBONYNULYKMUMUNZYHUOAYTBVP
      SZUUAYKVPSZACBRSZUUJACXMBYBYCYFACMUAICXMVPACACYBTZVOACMDYBACAXTCVFNZFXTUU
      NYPCVBVCPZVQADVFMUDUEGVRVSVTWAYJWBAYRBURNZUULUUJVEAXTYRFJCWCPAYDUUPEJBWCP
      CBWDWFVIAUUFYEYAVACRSUUJUUKVEUUGYFYBACUUOVDYTBCWEWGVIWHAYKUUAXPLIZMLIZQIU
      UQUUBQIYMUUDAYKUUQMAYKYNTZAUUQAUUAXPUUHYHUOTMWINZAWJWKZWLAUURYLYKQAUUQCML
      AUUQCCKIZMCKIZQIZUVBLIUVCCAUUAUVDXPUVBLACMCUUMUVAUUMWMACUUMWNWOAUVBUVCACC
      UUMUUMWPAUUTCWINUVCWINWJUUMMCXFUIWQACUUMWRWSWTXAAUUAXPUUBAUUAUUHTAXPYHTZA
      UUBUUITZXBXCAXRYKYKQIZXPLIZMLIUVGMLIZXPLIZUUEAXQUVHMLAXOUVGXPLAXOJYKKIUVG
      AJBCJWINAXDWKABYFTUUMXEAYKUUSXGXHWTWTAUVGXPMAUVGAYKYKYNYNUQTUVEUVAXIAUVJY
      KUUBQIZXPLIUUEAUVIUVKXPLAYKYKMUUSUUSUVAXJWTAYKUUBXPUUSUVFUVEXJXHWSXKXLVM
      $.

    $( Lemma for ~ jm3.1 .  (Contributed by Stefan O'Rear, 17-Oct-2014.) $)
    jm3.1lem3 $p |- ( ph -> ( ( ( ( 2 x. A ) x. K ) -
        ( K ^ 2 ) ) - 1 ) e. NN ) $=
      ( c2 cmul co cexp cmin c1 cz wcel cc0 clt wbr syl cuz cfv eluzelz sylancr
      cn 2z zmulcl eluz2b2 simplbi zmulcld zsqcl zsubcld peano2zm cr 0re nnnn0d
      nnzd a1i nnexpcld nnred zred nngt0d jm3.1lem2 lttrd elnnz sylanbrc ) AIBJ
      KZCJKZCILKZMKZNMKZOPZQVKRSVKUEPAVJOPVLAVHVIAVGCAIOPBOPZVGOPUFABIUAUBZPVME
      IBUCTIBUGUDACACVNPZCUEPZFVOVPNCRSCUHUITZUQZUJACOPVIOPVRCUKTULVJUMTZAQCDLK
      ZVKQUNPAUOURAVTACDVQADGUPUSZUTAVKVSVAAVTWAVBABCDEFGHVCVDVKVEVF $.
  $}

  ${
    $d A a $.  $d K a $.  $d N a $.
    $( Diophantine expression for exponentiation.  Lemma 3.1 of
       [JonesMatijasevic] p. 698.  (Contributed by Stefan O'Rear,
       16-Oct-2014.) $)
    jm3.1 $p |- ( ( ( A e. ( ZZ>= ` 2 ) /\ K e. ( ZZ>= ` 2 ) /\ N e. NN ) /\
        ( K rmY ( N + 1 ) ) <_ A ) -> ( K ^ N ) = ( ( ( A rmX N ) - ( ( A - K )
          x. ( A rmY N ) ) ) mod ( ( ( ( 2 x. A ) x. K ) - ( K ^ 2 ) ) -
          1 ) ) ) $=
      ( c2 wcel cn c1 co crmy wbr wa cexp crmx cmin cn0 adantr syl3anc 3ad2ant3
      cmul cz cuz cfv w3a caddc cle cmo clt cdivides simpl1 simpl2 simpl3 simpr
      wceq jm3.1lem2 2nn0 eluznn0 mpan 3ad2ant2 nnnn0d jm2.18 wb simp1 nnz frmx
      fovcl syl2anc nn0zd eluzelz zsubcl 3adant3 frmy zmulcld zsubcld jm3.1lem3
      syl2an nnnn0 nn0expcld divalgmodcl mpbir2and ) ADUAUBZEZBVTEZCFEZUCZBCGUD
      HIHAUEJZKZBCLHZACMHZABNHZACIHZSHZNHZDASHBSHBDLHNHGNHZUFHUMZWGWMUGJZWMWLWG
      NHUHJZWFABCWAWBWCWEUIZWAWBWCWEUJZWAWBWCWEUKZWDWEULZUNWFWABOEZCOEZWPWQWDXA
      WEWBWAXAWCDOEWBXAUOBDUPUQURZPWFCWSUSABCUTQWFWLTEZWMFEWGOEZWNWOWPKVAWDXDWE
      WDWHWKWDWHWDWACTEZWHOEWAWBWCVBZWCWAXFWBCVCRZACOVTTMVDVEVFVGWDWIWJWAWBWITE
      ZWCWAATEBTEXIWBDAVHDBVHABVIVOVJWDWAXFWJTEXGXHACTVTTIVKVEVFVLVMPWFABCWQWRW
      SWTVNWDXEWEWDBCXCWCWAXBWBCVPRVQPWMWGWLVRQVS $.
  $}

  ${
    $d A d e f $.  $d B d e f $.  $d C d e f $.
    $( Lemma for ~ expdioph .  Fully expanded expression for exponential.
       (Contributed by Stefan O'Rear, 17-Oct-2014.) $)
    expdiophlem1 $p |- ( C e. NN0 -> ( ( ( A e. ( ZZ>= ` 2 ) /\ B e. NN ) /\ C
        = ( A ^ B ) ) <-> E. d e. NN0 E. e e. NN0 E. f e. NN0 ( ( A e. ( ZZ>= `
        2 ) /\ B e. NN ) /\ ( ( A e. ( ZZ>= ` 2 ) /\ d = ( A rmY ( B + 1 ) ) )
        /\ ( ( d e. ( ZZ>= ` 2 ) /\ e = ( d rmY B ) ) /\ ( ( d e. ( ZZ>= ` 2 )
        /\ f = ( d rmX B ) ) /\ ( C < ( ( ( ( 2 x. d ) x. A ) - ( A ^ 2 ) ) - 1
        ) /\ ( ( ( ( 2 x. d ) x. A ) - ( A ^ 2 ) ) - 1 ) || ( ( f - ( ( d - A )
        x. e ) ) - C ) ) ) ) ) ) ) ) $=
      ( cn0 wcel c2 wa co wceq c1 cmul cmin wbr cdivides wrex syl cz cuz cfv cn
      cexp cv caddc crmy crmx clt cmo cle 2re a1i nnre peano2re adantl peano2zd
      cr nnz frmy fovcl sylan2 zred elnnuz eluzp1p1 df-2 fveq2i syl6eleqr sylbi
      eluzle nnnn0 peano2nn0 rmygeid letrd wb eluz sylancr mpbird simprl simprr
      2z leidd jm3.1 syl31anc eqeq2d frmx syl2anc nn0zd eluzelz zsubcld zmulcld
      adantr jm3.1lem3 simpl divalgmodcl bitrd rmynn0 oveq1 oveq2 oveq1d breq2d
      syl3anc oveq2d breq12d anbi12d rexbidv anbi2d 3bitrrd anbi2i bitri rexbii
      ceqsrexv ad2antll r19.42v syl6bbr eleq1 syl5ibrcom ibar pm5.32da ad2antrl
      imp anbi1d 2rexbidv 2rexbii ) CGHZAIUAUBZHZBUCHZJZCABUDKZLZJYIYGFUEZABMUF
      KZUGKZLZJZYLYFHZDUEZYLBUGKZLZJZYQEUEZYLBUHKZLZJZCIYLNKZANKZAIUDKZOKZMOKZU
      IPZUUJUUBYLAOKZYRNKZOKZCOKZQPZJZJZJZJZEGRZDGRZFGRZJZYIUUTJEGRZDGRFGRZYEYI
      YKUVCYEYIJZYKCIYNNKZANKZUUHOKZMOKZUIPZUVKYNBUHKZYNAOKZYNBUGKZNKZOKZCOKZQP
      ZJZUVCUVGYKCUVQUVKUJKZLZUVTUVGYJUWACUVGYNYFHZYGYHYNYNUKPZYJUWALYIUWCYEYIU
      WCIYNUKPZYIIYMYNIURHYIULUMYHYMURHZYGYHBURHUWFBUNBUOSUPYIYNYHYGYMTHYNTHZYH
      BBUSZUQAYMTYFTUGUTVAVBZVCZYHIYMUKPZYGYHYMYFHZUWKYHBMUAUBHZUWLBVDUWMYMMMUF
      KZUAUBYFMBVEIUWNUAVFVGVHVIIYMVJSUPYHYGYMGHZYMYNUKPYHBGHZUWOBVKZBVLSZAYMVM
      VBVNYIITHUWGUWCUWEVOWAUWIIYNVPVQVRZUPZYEYGYHVSZYEYGYHVTZYIUWDYEYIYNUWJWBU
      PZYNABWCWDWEUVGUVQTHZUVKUCHYEUWBUVTVOYIUXDYEYIUVMUVPYIUVMYIUWCBTHZUVMGHZU
      WSYHUXEYGUWHUPZYNBGYFTUHWFVAZWGWHYIUVNUVOYIYNAUWIYGATHYHIAWIWLWJYIUWCUXEU
      VOTHUWSUXGYNBTYFTUGUTVAWGWKWJUPUVGYNABUWTUXAUXBUXCWMYEYIWNUVKCUVQWOXBWPUV
      GUVTYOYTUUDUUQJZJZJZEGRZDGRZFGRZUVCUVGUVTYOYTUXIEGRZJZDGRZJZFGRZUXNUVGUXS
      YRUVOLZUUBUVMLZUVLUVKUUBUVNYRNKZOKZCOKZQPZJZJZEGRZJZDGRZUYAUVLUVKUUBUVPOK
      ZCOKZQPZJZJZEGRZUVTUVGYNGHZUXSUYJVOYIUYQYEYHYGUWOUYQUWRAYMWQVBUPUXQUYJFYN
      GYOUXPUYIDGYOYTUXTUXOUYHYOYSUVOYRYLYNBUGWRWEYOUXIUYGEGYOUUDUYAUUQUYFYOUUC
      UVMUUBYLYNBUHWRWEYOUUKUVLUUPUYEYOUUJUVKCUIYOUUIUVJMOYOUUGUVIUUHOYOUUFUVHA
      NYLYNINWSWTWTWTZXAYOUUJUVKUUOUYDQUYRYOUUNUYCCOYOUUMUYBUUBOYOUULUVNYRNYLYN
      AOWRWTXCWTXDXEXEXFXEXFXLSUVGUVOGHZUYJUYPVOUVGUWCUWPUYSUWTYHUWPYEYGUWQXMYN
      BWQWGUYHUYPDUVOGUXTUYGUYOEGUXTUYFUYNUYAUXTUYEUYMUVLUXTUYDUYLUVKQUXTUYCUYK
      COUXTUYBUVPUUBOYRUVOUVNNWSXCWTXAXGXGXFXLSUVGUXFUYPUVTVOUVGUWCUXEUXFUWTYHU
      XEYEYGUWHXMUXHWGUYNUVTEUVMGUYAUYMUVSUVLUYAUYLUVRUVKQUYAUYKUVQCOUUBUVMUVPO
      WRWTXAXGXLSXHUXMUXRFGUXMYOUXPJZDGRUXRUXLUYTDGUXLYOUXJEGRZJUYTYOUXJEGXNVUA
      UXPYOYTUXIEGXNXIXJXKYOUXPDGXNXJXKXOUVGUXLUVAFDGGUVGUXKUUTEGUVGUXKYOUUSJUU
      TUVGYOUXJUUSUVGYOJYQUXJUUSVOUVGYOYQUVGYQYOUWCUWTYLYNYFXPXQYAYQYTUUAUXIUUR
      YQYTXRYQUUDUUEUUQYQUUDXRYBXESXSUVGYOYPUUSYGYOYPVOYEYHYGYOXRXTYBWPXFYCWPWP
      XSUVFYIUVAJZDGRZFGRZUVDUVEVUBFDGGYIUUTEGXNYDVUDYIUVBJZFGRUVDVUCVUEFGYIUVA
      DGXNXKYIUVBFGXNXJXJXO $.
  $}

  ${
    $d a b c d e f $.

    $( Lemma for ~ expdioph .  Exponentiation on a restricted domain is
       Diophantine.  (Contributed by Stefan O'Rear, 17-Oct-2014.) $)
    expdiophlem2 $p |- { a e. ( NN0 ^m ( 1 ... 3 ) ) | ( ( ( a ` 1 ) e. ( ZZ>=
        ` 2 ) /\ ( a ` 2 ) e. NN ) /\ ( a ` 3 ) = ( ( a ` 1 ) ^ ( a ` 2 ) ) ) }
        e. ( Dioph ` 3 ) $=
      ( vb ve c1 cfv c2 wcel wa c3 co wceq cn0 crab cmin c6 c4 anbi12d mp2an c7
      cmpt vc vd cv cuz cn cexp cfz cmap caddc crmy crmx cmul clt cdivides wrex
      wbr cdioph wb elmapi 3nn jm2.27dlem3 ffvelrn sylancl expdiophlem1 rabbiia
      wf syl wsbc cres 3nn0 fvex eqeq1 anbi2d adantr adantl simpr oveq2 oveq12d
      c5 oveq1d breq2d sbc2ie sbcbii vex resex df-2 df-3 jm2.27dlem5 1nn sselii
      ssid jm2.27dlem1 eleq1d jm2.27dlem2 id eqeqan12rd eleq1 oveqan12rd eqeq2d
      2nn breq12d oveq2d bitri a1i cz cmzp 6nn0 cvv ovex df-4 df-5 df-6 mzpproj
      eluzrabdioph mp3an elnnrabdioph anrabdioph peano2nn0 ceqsrexv 3syl bicomd
      2z 4nn oveqan12d eqeq12d 7nn0 6nn 1z mzpconstmpt rmydioph w3a simp1 simp3
      df-7 simp2 rabren3dioph eqeltri 5nn mzpmulmpt mzpsubmpt rexfrabdioph 2nn0
      7nn mzpaddmpt eqrabdioph mzpexpmpt ltrabdioph dvdsrabdioph 3rexfrabdioph
      rmxdioph ) DAUCZEZFUDEZGZFUUKEZUEGZHZIUUKEZUULUUOUFJKHZALDIUGJZUHJZMUUQUU
      NBUCZUULUUODUIJZUJJZKZHZUVBUUMGZUAUCZUVBUUOUJJZKZHZUVGUBUCZUVBUUOUKJZKZHZ
      UURFUVBULJZUULULJZUULFUFJZNJZDNJZUMUPZUVTUVLUVBUULNJZUVHULJZNJZUURNJZUNUP
      ZHZHZHZHZHZUBLUOUALUOBLUOZAUVAMZIUQEZUUSUWLAUVAUUKUVAGZUURLGZUUSUWLURUWOU
      UTLUUKVFIUUTGUWPUUKLUUTUSIUTVAZUUTLIUUKVBVCUULUUOUURUAUBBVDVGVEILGUWKUBOC
      UCZEZVHUAVSUWREZVHZBPUWREZVHZAUWRUUTVIZVHZCLDOUGJZUHJZMZOUQEZGUWMUWNGVJUX
      HDUWREZUUMGZFUWREZUEGZHZUXKUXBUXJUXLDUIJZUJJZKZHZUXBUUMGZUWTUXBUXLUJJZKZH
      ZUXSUWSUXBUXLUKJZKZHZIUWREZFUXBULJZUXJULJZUXJFUFJZNJZDNJZUMUPZUYKUWSUXBUX
      JNJZUWTULJZNJZUYFNJZUNUPZHZHZHZHZHZCUXGMZUXIUXEVUBCUXGUXEVUBURUWRUXGGZUXE
      UUQUVFUVGUWTUVIKZHZUVGUWSUVMKZHZUWAUVTUWSUWBUWTULJZNJZUURNJZUNUPZHZHZHZHZ
      HZBUXBVHZAUXDVHVUBUXCVURAUXDUXAVUQBUXBUWKVUQUAUBUWTUWSVSUWRVKOUWRVKUVHUWT
      KZUVLUWSKZHZUWJVUPUUQVVAUWIVUOUVFVVAUVKVUFUWHVUNVUSUVKVUFURVUTVUSUVJVUEUV
      GUVHUWTUVIVLVMVNVVAUVOVUHUWGVUMVUTUVOVUHURVUSVUTUVNVUGUVGUVLUWSUVMVLVMVOV
      VAUWFVULUWAVVAUWEVUKUVTUNVVAUWDVUJUURNVVAUVLUWSUWCVUINVUSVUTVPVUSUWCVUIKV
      UTUVHUWTUWBULVQVNVRVTWAVMQQVMVMWBWCWCVUQVUBABUXDUXBUWRUUTCWDWEPUWRVKUUKUX
      DKZUVBUXBKZHZUUQUXNVUPVUAVVBUUQUXNURVVCVVBUUNUXKUUPUXMVVBUULUXJUUMDIACDDU
      GJZUUTDDFIWFFIIWGUUTWKWHWHDWIVAZWJWLZWMZVVBUUOUXLUEFIACFFIFWTVAZWGWTWNWLZ
      WMQVNVVDUVFUXRVUOUYTVVDUUNUXKUVEUXQVVBUUNUXKURVVCVVHVNVVCVVBUVBUXBUVDUXPV
      VCWOZVVBUULUXJUVCUXOUJVVGVVBUUOUXLDUIVVJVTVRWPQVVDVUFUYBVUNUYSVVDUVGUXSVU
      EUYAVVCUVGUXSURVVBUVBUXBUUMWQVOZVVDUVIUXTUWTVVCVVBUVBUXBUUOUXLUJVVKVVJWRW
      SQVVDVUHUYEVUMUYRVVDUVGUXSVUGUYDVVLVVDUVMUYCUWSVVCVVBUVBUXBUUOUXLUKVVKVVJ
      WRWSQVVDUWAUYLVULUYQVVDUURUYFUVTUYKUMVVBUURUYFKVVCIIACUWQWLVNZVVDUVSUYJDN
      VVDUVQUYHUVRUYINVVCVVBUVPUYGUULUXJULUVBUXBFULVQVVGWRVVBUVRUYIKVVCVVBUULUX
      JFUFVVGVTVNVRVTZXAVVDUVTUYKVUKUYPUNVVNVVDVUJUYOUURUYFNVVDVUIUYNUWSNVVDUWB
      UYMUWTULVVDUVBUXBUULUXJNVVBVVCVPVVBUULUXJKVVCVVGVNVRVTXBVVMVRXAQQQQQWBXCX
      DVEUXNCUXGMUXIGZVUACUXGMUXIGZVUCUXIGUXKCUXGMUXIGZUXMCUXGMUXIGZVVOOLGZFXEG
      ZCXEUXFUHJZUXJTUXFXFEZGZVVQXGYBUXFXHGZDUXFGVWCDOUGXIZVVEUXFDDFOWFFIOWGIPO
      XJPVSOXKVSOOXLUXFWKWHWHZWHZWHZWHVVFWJZCUXFDXMRZCUXJFOXNXOVVSCVWAUXLTVWBGZ
      VVRXGVWDFUXFGZVWKVWEDFUGJUXFFVWHVVIWJZCUXFFXMRCUXLOXPRUXKUXMCOXQRUXRCUXGM
      ZUXIGUYTCUXGMUXIGZVVPVWNUVBUXOKZUXKUXBUXJUVBUJJZKZHZHZBLUOZCUXGMZUXIUXRVX
      ACUXGVUDVXAUXRVUDUXLLGZUXOLGVXAUXRURVUDUXFLUWRVFVWLVXCUWRLUXFUSVWMUXFLFUW
      RVBVCUXLXRVWSUXRBUXOLVWPVWRUXQUXKVWPVWQUXPUXBUVBUXOUXJUJVQWSVMXSXTYAVEVVS
      VWTBSUUKEZVHCUUKUXFVIZVHZALDSUGJZUHJZMZSUQEZGVXBUXIGXGVXIVXDUVCKZUUNPUUKE
      ZUULVXDUJJZKZHZHZAVXHMZVXJVXFVXPAVXHVXFVXPURUUKVXHGVWTVXPCBVXEVXDUUKUXFAW
      DWESUUKVKUWRVXEKZUVBVXDKZHZVWPVXKVWSVXOVXSVXRUVBVXDUXOUVCVXSWOZVXRUXLUUOD
      UIFOCAVWMWLVTWPVXTUXKUUNVWRVXNVXTUXJUULUUMVXRUXJUULKVXSDOCAVWIWLZVNWMVXTU
      XBVXLVWQVXMVXRUXBVXLKVXSPOCADPUGJUXFPVWFPYCVAWJZWLVNVXRVXSUXJUULUVBVXDUJV
      YBVYAYDYEQQWBXDVEVXKAVXHMVXJGZVXOAVXHMVXJGZVXQVXJGSLGZAXEVXGUHJZVXDTVXGXF
      EZGZAVYGUVCTVYHGZVYDYFVXGXHGZSVXGGVYIDSUGXIZSUUCVAZAVXGSXMRAVYGUUOTVYHGZA
      VYGDTVYHGZVYJVYKFVXGGVYNVYLFOSVWMYNYGWNAVXGFXMRVYKDXEGZVYOVYLYHADVXGYIRAU
      UODVXGUUDRAVXDUVCSUUEXOVYFDUVBEZUUMGZIUVBEZVYQFUVBEZUJJZKZHZBUVAMUWNGVYEY
      FBYJWUCVXOSDSPBAVYQUULKZVYTVXDKZVYSVXLKZYKZVYRUUNWUBVXNWUGVYQUULUUMWUDWUE
      WUFYLZWMWUGVYSVXLWUAVXMWUDWUEWUFYMWUGVYQUULVYTVXDUJWUHWUDWUEWUFYOVRYEQDOS
      VWIYNYGWNVYMPOSVYCYNYGWNYPRVXKVXOASXQRYQVWTBCASOYNUUARYQUYBCUXGMUXIGZUYSC
      UXGMUXIGZVWOVVSUUNUURUULUUOUJJZKZHZAUVAMUWNGWUIXGAYJWUMUYBOPFVSACUULUXBKZ
      UUOUXLKZUURUWTKZYKZUUNUXSWULUYAWUQUULUXBUUMWUNWUOWUPYLZWMWUQUURUWTWUKUXTW
      UNWUOWUPYMWUQUULUXBUUOUXLUJWURWUNWUOWUPYOVRYEQVYCVWMVSVSOVSYRVAXLYRWNZYPR
      UYECUXGMUXIGZUYRCUXGMUXIGZWUJVVSUUNUURUULUUOUKJZKZHZAUVAMUWNGWUTXGAUUJWVD
      UYEOPFOACWUNWUOUURUWSKZYKZUUNUXSWVCUYDWVFUULUXBUUMWUNWUOWVEYLZWMWVFUURUWS
      WVBUYCWUNWUOWVEYMWVFUULUXBUUOUXLUKWVGWUNWUOWVEYOVRYEQVYCVWMOYGVAZYPRUYLCU
      XGMUXIGZUYQCUXGMUXIGZWVAVVSCVWAUYFTVWBGZCVWAUYKTVWBGZWVIXGVWDIUXFGWVKVWEU
      UTUXFIVWGUWQWJCUXFIXMRZCVWAUYJTVWBGZCVWADTVWBGZWVLCVWAUYHTVWBGZCVWAUYITVW
      BGZWVNCVWAUYGTVWBGZVWCWVPCVWAFTVWBGZCVWAUXBTVWBGZWVRVWDVVTWVSVWEYBCFUXFYI
      RVWDPUXFGWVTVWEVYCCUXFPXMRZCFUXBUXFYSRVWJCUYGUXJUXFYSRVWCFLGWVQVWJUUBCUXJ
      FUXFUUFRCUYHUYIUXFYTRVWDVYPWVOVWEYHCDUXFYIRCUYJDUXFYTRZCUYFUYKOUUGXOVVSWV
      LCVWAUYPTVWBGZWVJXGWWBCVWAUYOTVWBGZWVKWWCCVWAUWSTVWBGZCVWAUYNTVWBGZWWDVWD
      OUXFGWWEVWEWVHCUXFOXMRCVWAUYMTVWBGZCVWAUWTTVWBGZWWFWVTVWCWWGWWAVWJCUXBUXJ
      UXFYTRVWDVSUXFGWWHVWEWUSCUXFVSXMRCUYMUWTUXFYSRCUWSUYNUXFYTRWVMCUYOUYFUXFY
      TRCUYKUYPOUUHXOUYLUYQCOXQRUYEUYRCOXQRUYBUYSCOXQRUXRUYTCOXQRUXNVUACOXQRYQU
      WKUBUABACOVSPIXJXKXLUUIRYQ $.

    $( The exponential function is Diophantine.  This result completes and
       encapsulates our development using Pell equation solution sequences and
       is sometimes regarded as Matiyasevich's theorem properly.  (Contributed
       by Stefan O'Rear, 17-Oct-2014.) $)
    expdioph $p |- { a e. ( NN0 ^m ( 1 ... 3 ) ) | ( a ` 3 ) = ( ( a ` 1 ) ^ (
        a ` 2 ) ) } e. ( Dioph ` 3 ) $=
      ( c3 cfv c1 c2 cexp co wceq cn0 cfz crab cn wcel wa wo cc0 wb eqeq2d 3nn0
      mp2an cv cmap cdioph wn pm4.42 ancom wf elmapi df-2 df-3 ssid jm2.27dlem5
      cuz jm2.27dlem3 sselii ffvelrn sylancl adantr elnn0 sylib elnn1uz2 biimpi
      1nn orim1i syl biantrurd andir orbi1i bitri cz nnz 1exp adantl syl5ibrcom
      oveq1 bibi1d pm5.32d iba anbi1d orbi12d 0exp syl5bb bitrd pm5.32da 2nn wi
      pm2.53 sylbi 0nnn eleq1 mtbiri impbid1 nn0cnd exp0d rabbiia cmpt cmzp cvv
      oveq2 mzpproj elnnrabdioph 1z mzpconstmpt eqrabdioph mp3an 3nn anrabdioph
      ovex expdiophlem2 orrabdioph eq0rabdioph eqeltri ) BAUAZCZDXMCZEXMCZFGZHZ
      AIDBJGZUBGZKXPLMZXODHZXNDHZNZXOEUMCMZYANZXRNZOZXOPHZXNPHZNZOZNZXPPHZYCNZO
      ZAXTKZBUCCZXRYPAXTXRXRYANZXRYAUDZNZOXMXTMZYPXRYAUEUUBYSYMUUAYOYSYAXRNUUBY
      MXRYAUFUUBYAXRYLUUBYANZXRYBYEOZYIOZXRNZYLUUCUUEXRUUCXOLMZYIOZUUEUUCXOIMZU
      UHUUBUUIYAUUBXSIXMUGZDXSMZUUIXMIXSUHZDDJGXSDDEBUIEBBUJXSUKULZULDVCUNUOZXS
      IDXMUPUQZURXOUSUTUUGUUDYIUUGUUDXOVAVBVDVEVFUUFYBXRNZYEXRNZOZYIXRNZOZUUCYL
      UUFUUDXRNZUUSOUUTUUDYIXRVGUVAUURUUSYBYEXRVGVHVIUUCUURYHUUSYKUUCUUPYDUUQYG
      UUCYBXRYCUUCXRYCQZYBXNDXPFGZHZYCQUUCUVCDXNYAUVCDHZUUBYAXPVJMUVEXPVKXPVLVE
      VMRYBXRUVDYCYBXQUVCXNXODXPFVORVPVNVQUUCYEYFXRYAYEYFQUUBYAYEVRVMVSVTUUCYIX
      RYJUUCXRYJQYIXNPXPFGZHZYJQUUCUVFPXNYAUVFPHUUBXPWAVMRYIXRUVGYJYIXQUVFXNXOP
      XPFVORVPVNVQVTWBWCWDWBUUAYTXRNZUUBYOXRYTUFUUBUVHYNXRNYOUUBYTYNXRUUBXPIMZY
      TYNQUUBUUJEXSMZUVIUULDEJGXSEUUMEWEUNUOZXSIEXMUPUQUVIYTYNUVIYAYNOYTYNWFXPU
      SYAYNWGWHYNYAPLMWIXPPLWJWKWLVEVSUUBYNXRYCUUBUVBYNXNXOPFGZHZYCQUUBUVLDXNUU
      BXOUUBXOUUOWMWNRYNXRUVMYCYNXQUVLXNXPPXOFWSRVPVNVQWCWBVTWBWOYMAXTKYRMZYOAX
      TKYRMZYQYRMYAAXTKYRMZYLAXTKYRMZUVNBIMZAVJXSUBGZXPWPXSWQCZMZUVPSXSWRMZUVJU
      WADBJXHZUVKAXSEWTTZAXPBXATYHAXTKYRMZYKAXTKYRMZUVQYDAXTKYRMZYGAXTKYRMUWEYB
      AXTKYRMZYCAXTKYRMZUWGUVRAUVSXOWPUVTMZAUVSDWPUVTMZUWHSUWBUUKUWJUWCUUNAXSDW
      TTZUWBDVJMUWKUWCXBADXSXCTZAXODBXDXEUVRAUVSXNWPUVTMZUWKUWISUWBBXSMUWNUWCBX
      FUNAXSBWTTZUWMAXNDBXDXEZYBYCABXGTAXIYDYGABXJTYIAXTKYRMZYJAXTKYRMZUWFUVRUW
      JUWQSUWLAXOBXKTUVRUWNUWRSUWOAXNBXKTYIYJABXGTYHYKABXJTYAYLABXGTYNAXTKYRMZU
      WIUVOUVRUWAUWSSUWDAXPBXKTUWPYNYCABXGTYMYOABXJTXL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Uncategorized stuff not associated with a major project
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y B $.
    $( Epsilon induction for sets contained in a transitive set.  If we are
       allowed to assume Infinity, then all sets have a transitive closure and
       this reduces to ~ setind ; however, this version is useful without
       Infinity.  (Contributed by Stefan O'Rear, 28-Oct-2014.) $)
    setindtr $p |- ( A. x ( x C_ A -> x e. A ) -> ( E. y ( Tr y /\ B e. y ) ->
        B e. A ) ) $=
      ( cv wtr wcel wa wex wss wi wal cdif c0 wceq cin wn sylib adantlr ex wrex
      wral nfv nfa1 nfan eldifn adantl eldifi trss imp df-ss sseq1d sp ad2antlr
      syl5 sylbid inssdif0 sylnib ralrimi ralnex vex difss ssexi zfreg necon1bi
      mtod syl ssdif0 sylibr simplr sseldd exlimiv com12 ) BEZFZDVNGZHZBIAEZCJZ
      VRCGZKZALZDCGZVQWBWCKBVQWBWCVQWBHVNCDVOWBVNCJZVPVOWBHZVNCMZNOZWDWEVRWFPNO
      ZAWFUAZQZWGWEWHQZAWFUBWJWEWKAWFVOWBAVOAUCWAAUDUEWEVRWFGZWKWEWLHZVRVNPZCJZ
      WHWMWOVTWLVTQWEVRVNCUFUGWMWOVSVTWMWNVRCVOWLWNVROZWBVOWLHVRVNJZWPVOWLWQWLV
      RVNGVOWQVRVNCUHVNVRUIUOUJVRVNUKRSULWBWAVOWLWAAUMUNUPVFVRVNCUQURTUSWHAWFUT
      RWIWFNAWFWFVNBVAVNCVBVCVDVEVGVNCVHVISVOVPWBVJVKTVLVM $.
  $}

  ${
    $d B a x z $.  $d ph y $.  $d ps x $.  $d ch x $.  $d ph a z $.
    $d a x y $.
    setindtrs.a $e |- ( A. y e. x ps -> ph ) $.
    setindtrs.b $e |- ( x = y -> ( ph <-> ps ) ) $.
    setindtrs.c $e |- ( x = B -> ( ph <-> ch ) ) $.
    $( Epsilon induction scheme without Infinity.  See comments at
       ~ setindtr .  (Contributed by Stefan O'Rear, 28-Oct-2014.) $)
    setindtrs $p |- ( E. z ( Tr z /\ B e. z ) -> ch ) $=
      ( va cv wtr wcel wa wex wi wral nfsab1 cvv setindtr dfss3 nfcv nfral nfim
      cab wss weq raleq eleq1 imbi12d vex elab ralbii abid 3imtr4i chvar mpg wb
      sylbi elex adantl exlimiv elabg syl mpbid ) FLZMZGVGNZOZFPZGADUFZNZCKLZVL
      UGZVNVLNZQVKVMQKKFVLGUAVOELZVLNZEVNRZVPEVNVLUBVREDLZRZVTVLNZQVSVPQDKVSVPD
      VRDEVNDVNUCADESUDADKSUEDKUHWAVSWBVPVREVTVNUIVTVNVLUJUKBEVTRAWAWBHVRBEVTAB
      DVQEULIUMUNADUOUPUQUTURVKGTNZVMCUSVJWCFVIWCVHGVGVAVBVCACDGTJVDVEVF $.
  $}

  ${
    $d a b c x y $.  $d N a b c x y $.

    $( Lemma for ~ dford3 .  (Contributed by Stefan O'Rear, 28-Oct-2014.) $)
    dford3lem1 $p |- ( ( Tr N /\ A. y e. N Tr y ) ->
        A. b e. N ( Tr b /\ A. y e. b Tr y ) ) $=
      ( wtr cv wral wa treq cbvralv biimpi adantl wcel wi wss trss ssralv com23
      syl6 imp ralrimiv r19.26 sylanbrc ) BDZAEZDZABFZGZCEZDZCBFZUEAUHFZCBFUIUK
      GCBFUFUJUCUFUJUEUIACBUDUHHIJKUGUKCBUCUFUHBLZUKMUCULUFUKUCULUHBNUFUKMBUHOU
      EAUHBPRQSTUIUKCBUAUB $.

    $( Lemma for ~ dford3 .  (Contributed by Stefan O'Rear, 28-Oct-2014.) $)
    dford3lem2 $p |- ( ( Tr x /\ A. y e. x Tr y ) -> x e. On ) $=
      ( vc va vb cv wtr wa wral con0 wcel vex treq anbi12d wi word sylibr raleq
      weq eleq1 wel wex csuc suctr sucid sucex wceq eleq2 sylancl adantr simprl
      spcev wss dford3lem1 ralim imp dfss3 ordon a1i trssord syl3anc ex imbi12d
      syl5 elon setindtrs mpcom ) CFZGZACUAZHZCUBZAFZGZBFGZBVMIZHZVMJKZVNVLVPVN
      VMUCZGZVMVSKZVLVMUDVMALZUEVKVTWAHCVSVMWBUFVHVSUGVIVTVJWAVHVSMVHVSVMUHNULU
      IUJDFZGZVOBWCIZHZWCJKZOEFZGZVOBWHIZHZWHJKZOZVQVRODECVMWMEWCIZWFWGWNWFHZWC
      PZWGWOWDWCJUMZJPZWPWNWDWEUKWOWLEWCIZWQWNWFWSWFWKEWCIWNWSBWCEUNWKWLEWCUOVD
      UPEWCJUQQWRWOURUSWCJUTVAWCDLVEQVBDESZWFWKWGWLWTWDWIWEWJWCWHMVOBWCWHRNWCWH
      JTVCDASZWFVQWGVRXAWDVNWEVPWCVMMVOBWCVMRNWCVMJTVCVFVG $.

    $( Ordinals are precisely the hereditarily transitive classes.
       (Contributed by Stefan O'Rear, 28-Oct-2014.) $)
    dford3 $p |- ( Ord N <-> ( Tr N /\ A. x e. N Tr x ) ) $=
      ( va word wtr cv wral wa ordtr wcel ordelord syl ralrimiva jca con0 simpl
      wss dford3lem1 dford3lem2 ralimi dfss3 sylibr a1i trssord syl3anc impbii
      ordon ) BDZBEZAFZEZABGZHZUHUIULBIUHUKABUHUJBJHUJDUKBUJKUJILMNUMUIBOQZODZU
      HUIULPUMCFZOJZCBGZUNUMUPEUKAUPGHZCBGURABCRUSUQCBCASTLCBOUAUBUOUMUGUCBOUDU
      EUF $.

    $( ~ dford3 expressed in primitives to demonstrate shortness.  (Contributed
       by Stefan O'Rear, 28-Oct-2014.) $)
    dford4 $p |- ( Ord N <-> A. a A. b A. c ( ( a e. N /\ b e. a ) ->
        ( b e. N /\ ( c e. b -> c e. a ) ) ) ) $=
      ( wtr cv wa wcel wel wal dftr2 ancom imbi1i bitri 2albii alcom bitr4i nfv
      wi impexp word wral dford3 19.3v df-ral imbi2i anbi2i anass bitr3i 3bitri
      19.21-2 albii anbi12i 19.26 19.26-2 pm4.76 ) AUAAEZBFZEZBAUBZGZURAHZCBIZG
      ZCFAHZSZDJZCJZVDDCIZDBIZSZSZDJCJZGZBJZVDVEVKGSZDJCJZBJBAUCVAVHBJZVMBJZGVO
      UQVRUTVSUQVCVBGZVESZBJCJZVRCBAKVRWACJBJWBVGWABCVGVFWAVFDUDVDVTVEVBVCLMNOW
      ABCPNQUTVBUSSZBJVSUSBAUEWCVMBWCVBVIVCGZVJSZSZCJDJZVLCJDJVMWCVBWECJDJZSWGU
      SWHVBDCURKUFVBWEDCVBDRVBCRUKQWFVLDCWFVDVIGZVJSZVLWFVBWDGZVJSWJVBWDVJTWKWI
      VJWKVBVCVIGZGWIWDWLVBVIVCLUGVBVCVIUHQMUIVDVIVJTNOVLDCPUJULNUMVHVMBUNQVNVQ
      BVNVFVLGZDJCJVQVFVLCDUOWMVPCDVDVEVKUPOUIULUJ $.
  $}

  $( Unrelated:  Wiener pairs treat proper classes symmetrically.  (Contributed
     by Stefan O'Rear, 19-Sep-2014.) $)
  wopprc $p |- ( ( A e. _V /\ B e. _V ) <-> -. 1o e. { { { A } , (/) } , { { B
      } } } ) $=
    ( cvv wcel wa c0 csn cpr c1o wceq wn dfsn2 syl5reqr snex 0ex impbii con2bii
    id snprc xchbinxr preqr1 syl sylibr biimpi preq1d syl6reqr eqcom sneqr sneq
    bitr2i anbi12i wo pm4.56 elpr bitri df1o2 eleq1i ) ACDZBCDZEZFGZAGZFHZBGZGZ
    HZDZIVFDUTVAVCJZKZVAVEJZKZEZVGKURVIUSVKVHURVHURKZVHVBFJZVMVHVCFFHZJVNVHVOVA
    VCFLZVHRMVBFFANOUAUBASZUCVMVCVOVAVMVBFFVMVNVQUDUEVPUFPQUSFVDJZVJVRUSUSKVDFJ
    VRBSVDFUGUJQVJVRFVDOUHFVDUIPTUKVLVHVJULVGVHVJUMVAVCVEFNUNTUOIVAVFUPUQT $.

  ${
    $d a b c d e $.
    $( Lemma for ~ rpnnen3 .  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    rpnnen3lem $p |- ( ( ( a e. RR /\ b e. RR ) /\ a < b ) ->
        { c e. QQ | c < a } =/= { c e. QQ | c < b } ) $=
      ( vd cv cr wcel clt wbr cq crab wne w3a wa wrex qbtwnre simp2 breq1 elrab
      wn simp3r sylanbrc simp11 3ad2ant2 simp3l ltnsymd intnand sylnibr syl2anc
      qre nelne1 necomd rexlimdv3a mpd 3expa ) AEZFGZBEZFGZUPURHIZCEZUPHIZCJKZV
      AURHIZCJKZLZUQUSUTMZUPDEZHIZVHURHIZNZDJOVFDUPURPVGVKVFDJVGVHJGZVKMZVEVCVM
      VHVEGZVHVCGZTVEVCLVMVLVJVNVGVLVKQVGVLVIVJUAVDVJCVHJVAVHURHRSUBVMVLVHUPHIZ
      NVOVMVPVLVMUPVHUQUSUTVLVKUCVLVGVHFGVKVHUJUDVGVLVIVJUEUFUGVBVPCVHJVAVHUPHR
      SUHVHVEVCUKUIULUMUNUO $.

    $( Dedekind cut injection of ` RR ` into ` ~P QQ ` .  (Contributed by
       Stefan O'Rear, 18-Jan-2015.) $)
    rpnnen3 $p |- RR ~<_ ~P QQ $=
      ( va vb vc cq cpw cvv wcel cr cdom wbr qex pwex cv clt crab wa rpnnen3lem
      wss wceq wne ssrab2 elpw2 mpbir wo lttri2 ancom1s necomd jaodan ex sylbid
      a1i necon4d breq2 rabbidv impbid1 dom2 ax-mp ) DEZFGHURIJDKLABHURCMZAMZNJ
      ZCDOZUSBMZNJZCDOZFVBURGZUTHGZVFVBDRVACDUAVBDKUBUCUKVGVCHGZPZVBVESUTVCSZVI
      UTVCVBVEVIUTVCTUTVCNJZVCUTNJZUDZVBVETZUTVCUEVIVMVNVIVKVNVLABCQVIVLPVEVBVH
      VGVLVEVBTBACQUFUGUHUIUJULVJVAVDCDUTVCUSNUMUNUOUPUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    More equivalents of the Axiom of Choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Characterization of choice similar to ~ dffin1-5 .  (Contributed by Stefan
     O'Rear, 6-Jan-2015.) $)
  axac10 $p |- ( ~~ " On ) = _V $=
    ( wac cen con0 cima cvv wceq axac3 dfac10b mpbi ) ABCDEFGHI $.

  ${
    $d x S $.  $d x V $.
    $( The Hartogs number of an infinite set is at least ` om ` . _MOVABLE_
       (Contributed by Stefan O'Rear, 10-Jul-2015.) $)
    harinf $p |- ( ( S e. V /\ -. S e. Fin ) -> om C_ ( har ` S ) ) $=
      ( vx wcel cfn wn wa com char cfv cv con0 cdom wbr nnon adantl csdm simplr
      nnfi ex sdomdom domfi syl2im mtod simpll fidomtri syl2anc mpbird elharval
      wb sylanbrc ssrdv ) ABDZAEDZFZGZCHAIJZUPCKZHDZURUQDZUPUSGZURLDZURAMNZUTUS
      VBUPUROPVAVCAURQNZFZVAVDUNUMUOUSRVAUREDZVDAURMNZUNUSVFUPURSPZAURUAVFVGUNU
      RAUBTUCUDVAVFUMVCVEUJVHUMUOUSUEURABUFUGUHAURUIUKTUL $.
  $}

  ${
    $d v w x y z $.  $d v w x X $.  $d w x A $.  $d w x y B $.  $d w x y z C $.
    $d w x ph $.
    wdom2d2.a $e |- ( ph -> A e. V ) $.
    wdom2d2.b $e |- ( ph -> B e. W ) $.
    wdom2d2.c $e |- ( ph -> C e. X ) $.
    wdom2d2.o $e |- ( ( ph /\ x e. A ) -> E. y e. B E. z e. C x = X ) $.
    $( Deduction for weak dominance by a cross product. _MOVABLE_ (Contributed
       by Stefan O'Rear, 10-Jul-2015.) $)
    wdom2d2 $p |- ( ph -> A ~<_* ( B X. C ) ) $=
      ( vw cvv cv wcel wceq wrex cxp c1st cfv c2nd csb xpexg syl2anc wa nfcsb1v
      nfeq2 nfcv nfcsb nfv cop csbopeq1a eqeq2d rexxpf sylibr wdom2d ) ABOEFGUA
      ZHPCOQZUBUCZDVAUDUCZJUEZUEZKAFIRGJRUTPRLMFGIJUFUGABQZERUHVFJSZDGTCFTVFVES
      ZOUTTNVHVGOCDFGCVFVECVBVDUIUJDVFVEDCVBVDDVBUKDVCJUIULUJVGOUMVACQDQUNSVEJV
      FCDVAJUOUPUQURUS $.
  $}

  ${
    $d a b c d e f g h i j k l m $.  $d A a b c $.  $d B a b c $.
    $d C a b c $.

    $( Tarski's theorem about choice: ~ infxpidm is equivalent to ~ ax-ac .
       (Contributed by Stefan O'Rear, 4-Nov-2014.)  (Proof shortened by Stefan
       O'Rear, 10-Jul-2015.) $)
    ttac $p |- ( CHOICE <-> A. c ( om ~<_ c -> ( c X. c ) ~~ c ) ) $=
      ( va cvv wceq com cv cdom wbr cxp cen wi wal wcel vex syl alrimiv wn char
      wss ax-mp wac ccrd cdm dfac10 eleq2 mpbiri infxpidm2 ex cfn finnum adantl
      cfv cun con0 harcl onenon cwdom fvex unex harinf mpan ssun1 syl6ss ssdomg
      wa mpsyl breq2 xpeq12 anidms id breq12d imbi12d spcv syl5 imp harndom mp2
      wo domtr mto unxpwdom2 orel2 wb wdomnumr sylib numdom sylancr ssun2 ssnum
      sylancl pm2.61dan eqv sylibr impbii bitri ) UAUBUCZCDZEAFZGHZWRWRIZWRJHZK
      ZALZUDWQXCWQXBAWQWRWPMZXBWQXDWRCMANWPCWRUEUFXDWSXAWRUGUHOPXCBFZWPMZBLWQXC
      XFBXCXEUIMZXFXGXFXCXEUJUKXCXGQZVEZXERULZXEUMZWPMZXEXKSXFXIXJWPMZXKXJGHZXL
      XJUNMXMXEUOXJUPTZXIXKXJUQHZXNXIXKXKIZXKJHZXPXCXHXRXHEXKGHZXCXRXKCMZXHEXKS
      XSXJXEXERURBNZUSZXHEXJXKXECMXHEXJSYAXECUTVAXJXEVBZVCEXKCVDVFXBXSXRKAXKYBW
      RXKDZWSXSXAXRWRXKEGVGYDWTXQWRXKJYDWTXQDWRXKWRXKVHVIYDVJVKVLVMVNVOXKXEGHZQ
      XRXPYEVRXPYEXJXEGHZXEVPXJXKGHZYEYFXTXJXKSYGYBYCXJXKCVDVQXJXKXEVSVAVTXKXJX
      EWAYEXPWBVFOXMXPXNWCXOXKXJWDTWEXJXKWFWGXEXJWHXKXEWIWJWKPBWPWLWMWNWO $.
  $}

  ${
    $d A x y z w a $.  $d X x y $.  $d Y x y $.  $d V x y $.
    pw2f1o2.f $e |- F = ( x e. ( 2o ^m A ) |-> ( `' x " { 1o } ) ) $.
    $( Define a bijection between characteristic functions and subsets.
       _EDITORIAL_: extracted from ~ pw2en , which can be easily reproved in
       terms of this.  (Contributed by Stefan O'Rear, 18-Jan-2015.)  (Revised
       by Stefan O'Rear, 9-Jul-2015.) $)
    pw2f1ocnv $p |- ( A e. V -> ( F : ( 2o ^m A ) -1-1-onto-> ~P A /\ `' F =
          ( y e. ~P A |-> ( z e. A |-> if ( z e. y , 1o , (/) ) ) ) ) ) $=
      ( vw wcel c2o cv c1o c0 cvv wa adantr wceq con0 wb syl6bbr cmap ccnv cima
      co cpw csn wel cif cmpt vex cnvex imaexg mp1i mptexg wss wf elmapg anbi1d
      2on mpan wral 1on elexi sucid df-2o eleqtrri cpr prid1 df2o2 keepel rgenw
      csuc eqid fmpt mpbi simpr feq1d mpbiri fveq1d elequ1 ifbid fvmpt sylan9eq
      0ex cfv eqeq1d iftrue noel iffalse 0lt1o eleq2 syl6bi mtoi con4i syl6rbbr
      wn impbii fvex elsnc pm5.32da ssel pm4.71rd wfn ffn elpreima 3syl 3bitr4d
      wi eqrdv jca cdm cnvimass fdm syl5sseq eqsstrd simplr eleq2d wbr eliniseg
      fnbrfvb sylan ax-mp bitr4d biimpa adantl eqtr4d wo ffvelrn df2o3 syl6eleq
      adantlr elpr sylib ord sylibrd con1d imp pm2.61dan ralrimiva eqfnfv elpw
      sylancl mpbird anbi1i f1ocnvd ) DFIZABJDUAUDZDUEZAKZUBZLUFZUCZCDCBUGZLMUH
      ZUIZENNGUUJNIUULNIUUFUUIUUGIZOUUIAUJUKUUJUUKNULUMUUFUUONIBKZUUHIZCDUUNFUN
      PUUFUUPUUQUULQZOZUUQDUOZUUIUUOQZOZUURUVBOUUFUUTDJUUIUPZUUSOZUVCUUFUUPUVDU
      USJRIUUFUUPUVDSUSJDUUIRFUQUTURUVCUVEUVCUVDUUSUVCUVDDJUUOUPZUUNJIZCDVAUVFU
      VGCDUUMLMJLLVLJLLRVBVCZVDVEVFMMMUFZVGJMUVIWDVHVIVFVJVKCDJUUNUUOUUOVMZVNVO
      ZUVCDJUUIUUOUVAUVBVPZVQVRZUVCHUUQUULUVCHKZDIZHBUGZOUVOUVNUUIWEZUUKIZOZUVP
      UVNUULIZUVCUVOUVPUVRUVCUVOOZUVPUVQLQZUVRUWAUWBUVPLMUHZLQZUVPUWAUVQUWCLUVC
      UVOUVQUVNUUOWEZUWCUVCUVNUUIUUOUVLVSCUVNUUNUWCDUUOCKUVNQUUMUVPLMCHBVTWAUVJ
      UVPLMNUVHWDVJWBZWCWFUVPUWDUVPLMWGZUVPUWDUVPWPZUWDMMIZMWHUWHUWDMLQZUWIUWHU
      WCMLUVPLMWIZWFUWJUWIMLIWJMLMWKVRWLWMWNWQWOUVQLUVNUUIWRZWSTWTUVCUVPUVOUVAU
      VPUVOXHUVBUUQDUVNXAPXBUVCUVDUUIDXCZUVTUVSSUVMDJUUIXDZDUVNUUKUUIXEXFXGXIXJ
      UVEUVAUVBUVEUUQUULDUVDUUSVPUVEUUIXKZUULDUUIUUKXLUVDUWODQUUSDJUUIXMPXNXOUV
      EUVBUVQUWEQZHDVAZUVEUWPHDUVEUVOOZUVQUWCUWEUWRUVPUVQUWCQUWRUVPOUVQLUWCUWRU
      VPUWBUWRUVPUVTUWBUWRUUQUULUVNUVDUUSUVOXPXQUWRUWBUVNLUUIXRZUVTUVEUWMUVOUWB
      UWSSUVDUWMUUSUWNPZDUVNLUUIXTYALRIUVTUWSSVBUUILUVNRHUJXSYBTYCZYDUVPUWDUWRU
      WGYEYFUWRUWHOUVQMUWCUWRUWHUVQMQZUWRUXBUVPUWRUXBWPUWBUVPUWRUXBUWBUWRUVQMLV
      GZIUXBUWBYGUWRUVQJUXCUVDUVOUVQJIUUSDJUVNUUIYHYKYIYJUVQMLUWLYLYMYNUXAYOYPY
      QUWHUWCMQUWRUWKYEYFYRUVOUWEUWCQUVEUWFYEYFYSUVEUWMUUODXCZUVBUWQSUWTUVFUXDU
      VKDJUUOXDYBHDUUIUUOYTUUBUUCXJWQTUURUVAUVBUUQDBUJUUAUUDTUUE $.

    $( Define a bijection between characteristic functions and subsets.
       _EDITORIAL_: extracted from ~ pw2en , which can be easily reproved in
       terms of this.  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    pw2f1o2 $p |- ( A e. V -> F : ( 2o ^m A ) -1-1-onto-> ~P A ) $=
      ( vy vz wcel c2o cmap co cpw wf1o ccnv wel c1o c0 cif cmpt wceq pw2f1ocnv
      simpld ) BDHIBJKBLZCMCNFUCGBGFOPQRSSTAFGBCDEUAUB $.

    $( Function value of the ~ pw2f1o2 bijection.  (Contributed by Stefan
       O'Rear, 18-Jan-2015.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    pw2f1o2val $p |- ( X e. ( 2o ^m A ) ->
        ( F ` X ) = ( `' X " { 1o } ) ) $=
      ( c2o cmap co wcel ccnv c1o csn cima cvv cfv wceq cnvexg imaexg syl cv
      cnveq imaeq1d fvmptg mpdan ) DFBGHZIZDJZKLZMZNIZDCOUIPUFUGNIUJDUEQUGUHNRS
      ADATZJZUHMUIUENCUKDPULUGUHUKDUAUBEUCUD $.

    $( Membership in a mapped set under the ~ pw2f1o2 bijection.  (Contributed
       by Stefan O'Rear, 18-Jan-2015.)  (Revised by Stefan O'Rear,
       6-May-2015.) $)
    pw2f1o2val2 $p |- ( ( X e. ( 2o ^m A ) /\ Y e. A ) ->
        ( Y e. ( F ` X ) <-> ( X ` Y ) = 1o ) ) $=
      ( c2o cmap co wcel wa cfv ccnv c1o csn cima wceq wb pw2f1o2val eleq2d wfn
      adantr wf elmapi ffn fniniseg 3syl baibd bitrd ) DGBHIJZEBJZKEDCLZJZEDMNO
      PZJZEDLNQZUJUMUORUKUJULUNEABCDFSTUBUJUOUKUPUJBGDUCDBUAUOUKUPKRDGBUDBGDUEB
      NEDUFUGUHUI $.
  $}

  ${
    weeq12d.l $e |- ( ph -> R = S ) $.
    weeq12d.r $e |- ( ph -> A = B ) $.
    $( Equality deduction for total orderings.  (Contributed by Stefan O'Rear,
       19-Jan-2015.) $)
    soeq12d $p |- ( ph -> ( R Or A <-> S Or B ) ) $=
      ( wor wceq wb soeq1 syl soeq2 bitrd ) ABDHZBEHZCEHZADEIOPJFBDEKLABCIPQJGB
      CEMLN $.

    $( Equality deduction for founded relations.  (Contributed by Stefan
       O'Rear, 19-Jan-2015.) $)
    freq12d $p |- ( ph -> ( R Fr A <-> S Fr B ) ) $=
      ( wfr wceq wb freq1 syl freq2 bitrd ) ABDHZBEHZCEHZADEIOPJFBDEKLABCIPQJGB
      CEMLN $.

    $( Equality deduction for well-orders.  (Contributed by Stefan O'Rear,
       19-Jan-2015.) $)
    weeq12d $p |- ( ph -> ( R We A <-> S We B ) ) $=
      ( wwe wceq wb weeq1 syl weeq2 bitrd ) ABDHZBEHZCEHZADEIOPJFBDEKLABCIPQJGB
      CEMLN $.
  $}

  ${
    $d A x $.  $d B x $.

    $( Limit ordinals in the sense inclusive of zero contain all successors of
       their members.  (Contributed by Stefan O'Rear, 20-Jan-2015.) $)
    limsuc2 $p |- ( ( Ord A /\ A = U. A ) -> ( B e. A <-> suc B e. A ) ) $=
      ( vx word cuni wceq wa wcel csuc cv wral ordunisuc2 biimpa eleq1d rspccva
      suceq sylan ex wi wtr ordtr trsuc syl adantr impbid ) ADZAAEFZGZBAHZBIZAH
      ZUHUIUKUHCJZIZAHZCAKZUIUKUFUGUOCALMUNUKCBAULBFUMUJAULBPNOQRUFUKUISZUGUFAT
      ZUPAUAUQUKUIABUBRUCUDUE $.
  $}

  ${
    $d R x y z w a b c $.  $d A x y z w a b c $.  $d F x y z w b c $.
    $d T a b c $.  $d U a b c $.
    wepwso.t $e |- T = { <. x , y >. | E. z e. A ( ( z e. y /\ -. z e. x ) /\
        A. w e. A ( w R z -> ( w e. x <-> w e. y ) ) ) } $.

    ${
      wepwso.u $e |- U = { <. x , y >. | E. z e. A ( ( x ` z ) _E ( y ` z ) /\
          A. w e. A ( w R z -> ( x ` w ) = ( y ` w ) ) ) } $.
      wepwso.f $e |- F = ( a e. ( 2o ^m A ) |-> ( `' a " { 1o } ) ) $.
      $( Transfer an ordering on characteristic functions by isomorphism to the
         power set.  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
      wepwsolem $p |- ( A e. _V -> F Isom U , T ( ( 2o ^m A ) , ~P A ) ) $=
        ( wcel c2o wb wa wceq c1o c0 vb vc cvv cmap co cpw wf1o cv wbr cfv wral
        wiso pw2f1o2 cep wi wrex wn epelc wf elmapi ad2antrl ffvelrnda ad2antll
        fvex wo n0i adantl elpri df2o3 eleq2s ad2antlr orel1 sylc onirri eleq12
        cpr 1on biimpd expcom com3r imp adantll mtoi mpdan adantr orel2 adantrl
        jca mpan9 syl6eqel simprl eleqtrrd impbida syl2anc pw2f1o2val2 sylancom
        0lt1o simplrr simplrl notbid anbi12d bitr4d syl5bb eqeq1 simplr wne 1n0
        necomi df-ne mpbi mtbiri simpr mtbid ad3antlr ex mpbid mpjaodan impbid2
        eqtr4d bibi12d imbi2d ralbidva rexbidva vex breqan12d eqeqan12d ralbidv
        fveq1 rexbidv braba eleq2 bi2anan9r bi2bian9 3bitr4g ralrimivva df-isom
        wel sylanbrc ) EUCNZOEUDUEZEUFZIUGUAUHZUBUHZHUIZUUBIUJZUUCIUJZGUIZPZUBY
        TUKUAYTUKYTUUAHGIULJEIUCMUMYSUUHUAUBYTYTYSUUBYTNZUUCYTNZQQZCUHZUUBUJZUU
        LUUCUJZUNUIZDUHZUULFUIZUUPUUBUJZUUPUUCUJZRZUOZDEUKZQZCEUPZUULUUFNZUULUU
        ENZUQZQZUUQUUPUUENZUUPUUFNZPZUOZDEUKZQZCEUPZUUDUUGUUKUVCUVNCEUUKUULENZQ
        ZUUOUVHUVBUVMUUOUUMUUNNZUVQUVHUUMUUNUULUUCVDURUVQUVRUUNSRZUUMSRZUQZQZUV
        HUVQUUMONZUUNONZUVRUWBPUUKEOUULUUBUUIEOUUBUSYSUUJUUBOEUTVAZVBUUKEOUULUU
        CUUJEOUUCUSYSUUIUUCOEUTVCZVBUWCUWDQZUVRUWBUWGUVRQZUVSUWAUWHUUNTRZUQZUWI
        UVSVEZUVSUVRUWJUWGUUNUUMVFVGUWDUWKUWCUVRUWKUUNTSVPZOUUNTSVHVIVJVKUWIUVS
        VLVMZUWHUVSUWAUWMUWHUVSQUVTSSNZSVQVNUVRUVSUVTUWNUOZUWGUVRUVSUWOUVSUVTUV
        RUWNUVTUVSUVRUWNUOUVTUVSQUVRUWNUUMSUUNSVOVRVSVTWAWBWCWDWHUWGUWBQZUUMSUU
        NUWPUUMTSUWGUWAUUMTRZUVSUWGUWQUVTVEZUWAUWQUWCUWRUWDUWRUUMUWLOUUMTSVHVIV
        JWEUVTUWQWFWIWGWQWJUWGUVSUWAWKWLWMWNUVQUVEUVSUVGUWAUUKUVPUUJUVEUVSPYSUU
        IUUJUVPWRJEIUUCUULMWOWPUVQUVFUVTUUKUVPUUIUVFUVTPYSUUIUUJUVPWSJEIUUBUULM
        WOWPWTXAXBXCUUKUVBUVMPUVPUUKUVAUVLDEUUKUUPENZQZUUTUVKUUQUWTUUTUURSRZUUS
        SRZPZUVKUWTUURONZUUSONZUUTUXCPUUKEOUUPUUBUWEVBUUKEOUUPUUCUWFVBUXDUXEQZU
        UTUXCUURUUSSXDUXFUURTRZUXCUUTUOUXAUXFUXGQZUXCUUTUXHUXCQZUURTUUSUXFUXGUX
        CXEUXIUXBUQUUSTRZUXBVEZUXJUXIUXAUXBUXGUXAUQUXFUXCUXGUXATSRZTSXFUXLUQSTX
        GXHTSXIXJUURTSXDXKVKUXHUXCXLXMUXEUXKUXDUXGUXCUXKUUSUWLOUUSTSVHVIVJXNUXB
        UXJWFVMXSXOUXFUXAQZUXCUUTUXMUXCQZUURSUUSUXFUXAUXCXEZUXNUXAUXBUXOUXMUXCX
        LXPXSXOUXDUXGUXAVEZUXEUXPUURUWLOUURTSVHVIVJWEXQXRWNUWTUVIUXAUVJUXBUUKUW
        SUUIUVIUXAPYSUUIUUJUWSWSJEIUUBUUPMWOWPUUKUWSUUJUVJUXBPYSUUIUUJUWSWRJEIU
        UCUUPMWOWPXTXBYAYBWEXAYCUULAUHZUJZUULBUHZUJZUNUIZUUQUUPUXQUJZUUPUXSUJZR
        ZUOZDEUKZQZCEUPUVDABUUBUUCHUAYDUBYDUXQUUBRZUXSUUCRZQZUYGUVCCEUYJUYAUUOU
        YFUVBUYHUYIUXRUUMUXTUUNUNUULUXQUUBYHUULUXSUUCYHYEUYJUYEUVADEUYJUYDUUTUU
        QUYHUYIUYBUURUYCUUSUUPUXQUUBYHUUPUXSUUCYHYFYAYGXAYILYJCBYQZCAYQZUQZQZUU
        QDAYQZDBYQZPZUOZDEUKZQZCEUPUVOABUUEUUFGUUBIVDUUCIVDUXQUUERZUXSUUFRZQZUY
        TUVNCEVUCUYNUVHUYSUVMVUBUYKUVEVUAUYMUVGUXSUUFUULYKVUAUYLUVFUXQUUEUULYKW
        TYLVUCUYRUVLDEVUCUYQUVKUUQVUAUYOUVIVUBUYPUVJUXQUUEUUPYKUXSUUFUUPYKYMYAY
        GXAYIKYJYNYOUAUBYTUUAHGIYPYR $.
    $}

    $( A well-ordering induces a strict ordering on the power set. _EDITORIAL_:
       when well-orderings are set like, this can be strengthened to remove
       ` A e. V ` (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    wepwso $p |- ( ( A e. V /\ R We A ) -> T Or ~P A ) $=
      ( va wcel wwe wa c2o cv cfv cep wbr wor eqid cmap co wceq wral wrex copab
      cpw word com 2onn nnord ax-mp ordwe weso mp2b wemapso mp3an3 cvv ccnv c1o
      wi wb csn cima cmpt wiso elex wepwsolem isoso 3syl adantr mpbid ) EHKZEFL
      ZMNEUAUBZCOZAOZPVPBOZPQRDOZVPFRVSVQPVSVRPUCVADEUDMCEUEABUFZSZEUGZGSZVMVNN
      QSZWANUHZNQLWDNUIKWEUJNUKULNUMNQUNUOABCDENFQVTHVTTZUPUQVMWAWCVBZVNVMEURKV
      OWBVTGJVOJOUSUTVCVDVEZVFWGEHVGABCDEFGVTWHJIWFWHTVHVOWBVTGWHVIVJVKVL $.
  $}

  ${
    $d F a b $.  $d A a b $.
    $( Non-emptyness of an initial segment in terms of range.  (Contributed by
       Stefan O'Rear, 18-Jan-2015.) $)
    inisegn0 $p |- ( A e. ran F <-> ( `' F " { A } ) =/= (/) ) $=
      ( va vb crn wcel cvv ccnv csn cima c0 wne elex wn wceq snprc imaeq2d ima0
      biimpi cv syl6eq necon1ai eleq1 sneq neeq1d wbr cab wex abn0 iniseg ax-mp
      vex neeq1i elrn 3bitr4ri vtoclbg pm5.21nii ) ABEZFZAGFZBHZAIZJZKLZAURMUTV
      CKUTNZVCVAKJKVEVBKVAVEVBKOAPSQVARUAUBCTZURFZVAVFIZJZKLZUSVDCAGVFAURUCVFAO
      ZVIVCKVKVHVBVAVFAUDQUEDTVFBUFZDUGZKLVLDUHVJVGVLDUIVIVMKVFGFVIVMOCULZDBVFG
      UJUKUMDVFBVNUNUOUPUQ $.
  $}

  ${
    $d F v w x y $.  $d G v w x y z $.  $d A v w x y z $.  $d ph v x w $.
    dnnumch.f $e |- F = recs ( ( z e. _V |-> ( G ` ( A \ ran z ) ) ) ) $.
    dnnumch.a $e |- ( ph -> A e. V ) $.
    dnnumch.g $e |- ( ph -> A. y e. ~P A ( y =/= (/) -> ( G ` y ) e. y ) ) $.
    $( Define an enumeration of a set from a choice function; second part, it
       restricts to a bijection. _EDITORIAL_: overlaps ~ dfac8a (Contributed by
       Stefan O'Rear, 18-Jan-2015.) $)
    dnnumch1 $p |- ( ph -> E. x e. On ( F |` x ) : x -1-1-onto-> A ) $=
      ( vw wcel cv cdif c0 cfv con0 wceq cvv cima wne wi wral cres wf1o wrex wa
      crn cmpt crecs recsval wfun wfn tfr1 fnfun ax-mp vex resfunexg mp2an rneq
      fveq1i df-ima syl6eqr difeq2d fveq2d weq cbvmptv fvex fvmpt fveq2i eqtr3i
      reseq1i 3eqtr4g ad2antlr cpw wss difss wb elpw2g syl mpbiri neeq1 eleq12d
      fveq2 id imbi12d rspcva syl2anc adantr imp eqeltrd ex ralrimiva tz7.49c )
      AEHMZEFBNZUAZOZPUBZWQFQZWSMZUCZBRUDWQEFWQUEZUFBRUGJAXCBRAWQRMZUHZWTXBXFWT
      UHXAWSGQZWSXEXAXGSAWTXEWQDTEDNZUIZOZGQZUJZUKZQXMWQUEZXLQZXAXGWQXLULWQFXMI
      VBXDXLQZXGXOXDTMZXPXGSFUMZWQTMXQFRUNXRFXLIUOZRFUPUQBURFWQTUSUTLXDELNZUIZO
      ZGQZXGTXLXTXDSZYBWSGYDYAWREYDYAXDUIWRXTXDVAFWQVCVDVEVFDLTXKYCDLVGZXJYBGYE
      XIYAEXHXTVAVEVFVHWSGVIVJUQXDXNXLFXMWQIVMVKVLVNVOXFWTXGWSMZAWTYFUCZXEAWSEV
      PZMZCNZPUBZYJGQZYJMZUCZCYHUDYGAYIWSEVQZEWRVRAWPYIYOVSJWSEHVTWAWBKYNYGCWSY
      HYJWSSZYKWTYMYFYJWSPWCYPYLXGYJWSYJWSGWEYPWFWDWGWHWIWJWKWLWMWNBEHFXSWOWI
      $.

    $( Define an enumeration (weak dominance version) of a set from a choice
       function.  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    dnnumch2 $p |- ( ph -> A C_ ran F ) $=
      ( vx cv cres wf1o con0 wrex crn wss dnnumch1 wi wfo wceq f1ofo forn resss
      syl rnss mp1i eqsstr3d a1i rexlimdvw mpd ) AKLZDEUMMZNZKOPDEQZRZAKBCDEFGH
      IJSAUOUQKOUOUQTAUODUNQZUPUOUMDUNUAURDUBUMDUNUCUMDUNUDUFUNERURUPRUOEUMUEUN
      EUGUHUIUJUKUL $.

    $( Value of the ordinal injection function.  (Contributed by Stefan O'Rear,
       18-Jan-2015.) $)
    dnnumch3lem $p |- ( ( ph /\ w e. A ) ->
        ( ( x e. A |-> |^| ( `' F " { x } ) ) ` w ) = |^| ( `' F " { w } ) ) $=
      ( cv wcel csn cima cint con0 cmpt cfv wa ccnv wceq simpr wss wne cnvimass
      c0 cdm wfn cvv crn cdif tfr1 ax-mp sseqtri dnnumch2 sselda inisegn0 sylib
      fndm oninton sylancr weq sneq imaeq2d inteqd eqid fvmptg syl2anc ) AEMZFN
      ZUAZVLGUBZVKOZPZQZRNZVKBFVNBMZOZPZQZSZTVQUCAVLUDVMVPRUEVPUHUFZVRVPGUIZRGV
      OUGGRUJWERUCGDUKFDMULUMHTSJUNRGVAUOUPVMVKGULZNWDAFWFVKACDFGHIJKLUQURVKGUS
      UTVPVBVCBVKWBVQFRWCBEVDZWAVPWGVTVOVNVSVKVEVFVGWCVHVIVJ $.

    $( Define an injection from a set into the ordinals using a choice
       function.  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    dnnumch3 $p |- ( ph -> ( x e. A |-> |^| ( `' F " { x } ) )
            : A -1-1-> On ) $=
      ( vv vw con0 cv csn cfv wceq wcel wa ccnv cima cint cmpt wf wi wf1 wss c0
      wral wne cdm cnvimass wfn cvv crn cdif tfr1 ax-mp sseqtri dnnumch2 sselda
      fndm sylib oninton sylancr eqid fmptd dnnumch3lem adantrr adantrl eqeq12d
      inisegn0 fveq2 adantl onint wb fniniseg simprbi syl adantr 3eqtr3d sylbid
      ex ralrimivva dff13 sylanbrc ) AENBEFUAZBOZPZUBZUCZUDZUELOZWMQZMOZWMQZRZW
      NWPRZUFZMEUJLEUJENWMUGABEWLNWMAWIESTZWKNUHWKUIUKZWLNSWKFULZNFWJUMFNUNZXCN
      RFDUOEDOUPUQGQUDIURZNFVCUSZUTXAWIFUPZSXBAEXGWIACDEFGHIJKVAZVBWIFVMVDWKVEV
      FWMVGVHAWTLMEEAWNESZWPESZTTZWRWHWNPZUBZUCZWHWPPZUBZUCZRZWSXKWOXNWQXQAXIWO
      XNRXJABCDLEFGHIJKVIVJAXJWQXQRXIABCDMEFGHIJKVIVKVLXKXRWSXKXRTXNFQZXQFQZWNW
      PXRXSXTRXKXNXQFVNVOXKXSWNRZXRAXIYAXJAXITZXNXMSZYAYBXMNUHXMUIUKZYCXMXCNFXL
      UMXFUTYBWNXGSYDAEXGWNXHVBWNFVMVDXMVPVFYCXNNSZYAXDYCYEYATVQXENWNXNFVRUSVSV
      TVJWAXKXTWPRZXRAXJYFXIAXJTZXQXPSZYFYGXPNUHXPUIUKZYHXPXCNFXOUMXFUTYGWPXGSY
      IAEXGWPXHVBWPFVMVDXPVPVFYHXQNSZYFXDYHYJYFTVQXENWPXQFVRUSVSVTVKWAWBWDWCWEL
      MENWMWFWG $.

    dnwech.h $e |- H = { <. v , w >. | |^| ( `' F " { v } ) e.
        |^| ( `' F " { w } ) } $.
    $( Define a well-ordering from a choice function.  (Contributed by Stefan
       O'Rear, 18-Jan-2015.) $)
    dnwech $p |- ( ph -> H We A ) $=
      ( vx wwe cep copab con0 cin ccnv csn cima cint cmpt cfv wbr wf1o dnnumch3
      cv crn wf1 f1f1orn syl wss wf f1f frn 3syl epweon wess ee10 eqid sylc cxp
      f1owe wceq wb wcel fvex epelc dnnumch3lem adantrr adantrl eleq12d syl5rbb
      pm5.32da opabbidv incom df-xp ineq12i inopab 3eqtri ineq1i 3eqtr4g weinxp
      wa weeq1 3bitr4g mpbird ) AFIPZFEUJZOFGUAZOUJUBUCUDUEZUFZDUJZWNUFZQUGZEDR
      ZPZAFWNUKZWNUHZXAQPZWTAFSWNULZXBAOBCFGHJKLMUIZFSWNUMUNAXASUOZSQPXCAXDFSWN
      UPXFXEFSWNUQFSWNURUSUTXASQVAVBEDFXAWSQWNWSVCVFVDAFIFFVEZTZPZFWSXGTZPZWKWT
      AXHXJVGXIXKVHAWLFVIZWPFVIZWGZWMWLUBUCUDZWMWPUBUCUDZVIZWGZEDRZXNWRWGZEDRZX
      HXJAXRXTEDAXNXQWRWRWOWQVIAXNWGZXQWOWQWPWNVJVKYBWOXOWQXPAXLWOXOVGXMAOBCEFG
      HJKLMVLVMAXMWQXPVGXLAOBCDFGHJKLMVLVNVOVPVQVRXHXGITXNEDRZXQEDRZTXSIXGVSXGY
      CIYDEDFFVTZNWAXNXQEDWBWCXJXGWSTYCWSTYAWSXGVSXGYCWSYEWDXNWREDWBWCWEFXHXJWH
      UNFIWFFWSWFWIWJ $.
  $}

  ${
    $d U y z a b c d e f $.  $d S x y a b c d e f g $.  $d R x y a b c d e f $.
    $d ph x y z c d e f g $.  $d A x y z a b c d e f g $.
    $d F x y z a b c d e f g $.  $d T a b c d e f $.  $d B a b c d e f $.
    fnwe2.su $e |- ( z = ( F ` x ) -> S = U ) $.
    fnwe2.t $e |- T = { <. x , y >. | ( ( F ` x ) R ( F ` y ) \/
        ( ( F ` x ) = ( F ` y ) /\ x U y ) ) } $.
    $( Lemma for ~ fnwe2 .  Substitute variables.  (Contributed by Stefan
       O'Rear, 19-Jan-2015.) $)
    fnwe2val $p |- ( a T b <-> ( ( F ` a ) R ( F ` b ) \/
        ( ( F ` a ) = ( F ` b ) /\ a [_ ( F ` a ) / z ]_ S b ) ) ) $=
      ( cv cfv wbr wceq wa wo csb vex fveq2 breqan12d eqeqan12d simpl fvex nfcv
      csbief csbeq1d syl5eqr adantr simpr breq123d anbi12d orbi12d braba ) AMZH
      NZBMZHNZDOZUQUSPZUPURGOZQZRIMZHNZJMZHNZDOZVEVGPZVDVFCVEESZOZQZRABVDVFFITJ
      TUPVDPZURVFPZQZUTVHVCVLVMVNUQVEUSVGDUPVDHUAZURVFHUAZUBVOVAVIVBVKVMVNUQVEU
      SVGVPVQUCVOUPVDURVFGVJVMVNUDVMGVJPVNVMGCUQESVJCUQEGUPHUECGUFKUGVMCUQVEEVP
      UHUIUJVMVNUKULUMUNLUO $.

    fnwe2.s $e |- ( ( ph /\ x e. A ) ->
        U We { y e. A | ( F ` y ) = ( F ` x ) } ) $.
    $( Lemma for ~ fnwe2 .  Substitution in well-ordering hypothesis.
       (Contributed by Stefan O'Rear, 19-Jan-2015.) $)
    fnwe2lem1 $p |- ( ( ph /\ a e. A ) ->
        [_ ( F ` a ) / z ]_ S We { y e. A | ( F ` y ) = ( F ` a ) } ) $=
      ( cv cfv wceq crab csb wwe wral ralrimiva csbeq1d fvex nfcv csbief syl6eq
      fveq2 eqeq2d rabbidv weeq12d cbvralv sylibr r19.21bi ) ACOJPZKOZJPZQZCERZ
      DUQGSZTZKEAUOBOZJPZQZCERZITZBEUAVAKEUAAVFBENUBVAVFKBEUPVBQZUSVEUTIVGUTDVC
      GSIVGDUQVCGUPVBJUHZUCDVCGIVBJUDDIUELUFUGVGURVDCEVGUQVCUOVHUIUJUKULUMUN $.

    fnwe2.f $e |- ( ph -> ( F |` A ) : A --> B ) $.
    fnwe2.r $e |- ( ph -> R We B ) $.

    ${
      $d ph b $.
      fnwe2lem2.a $e |- ( ph -> a C_ A ) $.
      fnwe2lem2.n0 $e |- ( ph -> a =/= (/) ) $.
      $( Lemma for ~ fnwe2 .  An element which is in a minimal fiber and
         minimal within its fiber is minimal globally; thus ` T ` is
         well-founded.  (Contributed by Stefan O'Rear, 19-Jan-2015.) $)
      fnwe2lem2 $p |- ( ph -> E. b e. a A. c e. a -. c T b ) $=
        ( ve vd vf vg cv wbr wn cres cima wral wrex cvv wcel wfr wss c0 wf wfun
        wne ffun vex funimaex 3syl wwe syl crn imassrn frn syl5ss cdm cin incom
        wefr wceq fdm sseqtr4d df-ss sylib syl5eq eqnetrd imadisj necon3bii fri
        sylibr syl22anc cfv df-ima rexeqi wfn ffn fnssres syl2anc breq2 ralbidv
        wb notbid rexrn syl5bb wel wa raleqi breq1 ralrn adantr ad2antrr fveq1d
        resabs1 fvres adantl eqtrd ad2antlr breq12d ralbidva bitrd rexbidva csb
        crab inex1 a1i sselda fnwe2lem1 syldan adantrr inss2 simprl eqidd fveq2
        weq eqeq1d elrab sylanbrc elin wi anbi2i bitri rspcva ex syl5bi mpd wo
        ne0i imbi1i impexp ralbii2 simplrl simplrr breq1d simprrr breq2d mtbird
        simpr ad3antrrr simprr simplr eleq1 anbi12d imbi12d mp2and eqtr2d breqd
        csbeq1d mtbid expr imnan fnwe2val sylnibr ralrimiva rexlimdv rexlimdvaa
        ioran rspcev sylbid ) AUBUFZUCUFZGUGZUHZUBKEUIZLUFZUJZUKZUCUVTULZNUFZMU
        FZIUGZUHZNUVSUKZMUVSULZAUVTUMUNZFGUOZUVTFUPUVTUQUTZUWBAEFUVRURZUVRUSUWI
        REFUVRVAUVRUVSLVBZVCVDAFGVEUWJSFGVNVFAUVTUVRVGZFUVRUVSVHAUWLUWNFUPREFUV
        RVIVFVJAUVRVKZUVSVLZUQUTUWKAUWPUVSUQAUWPUVSUWOVLZUVSUWOUVSVMAUVSUWOUPUW
        QUVSVOAUVSEUWOTAUWLUWOEVOREFUVRVPVFVQUVSUWOVRVSVTUAWAUVTUQUWPUQUVRUVSWB
        WCWEUCUBFUVTUMGWDWFAUWBUVOKWGZUDUFZKWGZGUGZUHZUCUVSUKZUDUVSULZUWHAUWBUV
        NUWSUVRUVSUIZWGZGUGZUHZUBUVTUKZUDUVSULZUXDUWBUWAUCUXEVGZULZAUXJUWAUCUVT
        UXKUVRUVSWHZWIAUXEUVSWJZUXLUXJWPAUVREWJZUVSEUPZUXNAUWLUXOREFUVRWKVFTEUV
        SUVRWLWMZUWAUXIUCUDUVSUXEUVOUXFVOZUVQUXHUBUVTUXRUVPUXGUVOUXFUVNGWNWQWOW
        RVFWSAUXIUXCUDUVSAUDLWTZXAZUXIUVOUXEWGZUXFGUGZUHZUCUVSUKZUXCAUXIUYDWPUX
        SUXIUXHUBUXKUKZAUYDUXHUBUVTUXKUXMXBAUXNUYEUYDWPUXQUXHUYCUBUCUVSUXEUVNUY
        AVOUXGUYBUVNUYAUXFGXCWQXDVFWSXEUXTUYCUXBUCUVSUXTUCLWTZXAZUYBUXAUYGUYAUW
        RUXFUWTGUYGUYAUVOKUVSUIZWGZUWRUYGUVOUXEUYHAUXEUYHVOZUXSUYFAUXPUYJTKUVSE
        XHVFXFZXGUYFUYIUWRVOUXTUVOUVSKXIXJXKUYGUXFUWSUYHWGZUWTUYGUWSUXEUYHUYKXG
        UXSUYLUWTVOAUYFUWSUVSKXIXLXKXMWQXNXOXPXOAUXCUWHUDUVSAUXSUXCXAZXAZUEUFZU
        VNDUWTHXQZUGZUHZUEUVSCUFZKWGZUWTVOZCEXRZVLZUKZUBVUCULZUWHUYNVUCUMUNZVUB
        UYPUOZVUCVUBUPZVUCUQUTZVUEVUFUYNUVSVUBUWMXSXTAUXSVUGUXCAUXSUWSEUNZVUGAU
        VSEUWSTYAZAVUJXAVUBUYPVEVUGABCDEGHIJKUDOPQYBVUBUYPVNVFYCYDVUHUYNUVSVUBY
        EXTUYNUWSVUCUNZVUIUYNUXSUWSVUBUNZVULAUXSUXCYFUYNVUJUWTUWTVOZVUMAUXSVUJU
        XCVUKYDUYNUWTYGVUAVUNCUWSECUDYIUYTUWTUWTUYSUWSKYHYJYKYLUWSUVSVUBYMYLVUC
        UWSUUBVFUBUEVUBVUCUMUYPWDWFUYNVUDUWHUBVUCUVNVUCUNZUBLWTZUVNEUNZUVNKWGZU
        WTVOZXAZXAZUYNVUDUWHYNZVUOVUPUVNVUBUNZXAVVAUVNUVSVUBYMVVCVUTVUPVUAVUSCU
        VNECUBYIUYTVURUWTUYSUVNKYHYJYKYOYPUYNVVAVVBVUDUYOEUNZUYOKWGZUWTVOZXAZUY
        RYNZUEUVSUKZUYNVVAXAZUWHUYRVVHUEVUCUVSUYOVUCUNZUYRYNUELWTZVVGXAZUYRYNVV
        LVVHYNVVKVVMUYRVVKVVLUYOVUBUNZXAVVMUYOUVSVUBYMVVNVVGVVLVUAVVFCUYOECUEYI
        UYTVVEUWTUYSUYOKYHYJYKYOYPUUCVVLVVGUYRUUDYPUUEVVJVVIUWHVVJVVIXAZVUPUWCU
        VNIUGZUHZNUVSUKZUWHUYNVUPVUTVVIUUFVVOVVQNUVSVVONLWTZXAZUWCKWGZVURGUGZVW
        AVURVOZUWCUVNDVWAHXQZUGZXAZUUAZVVPVVTVWBUHVWFUHZVWGUHVVTVWBVWAUWTGUGZVV
        TVVSUXCVWIUHZVVOVVSUULVVJUXCVVIVVSAUXSUXCVVAUUGXFUXBVWJUCUWCUVSUCNYIZUX
        AVWIVWKUWRVWAUWTGUVOUWCKYHUUHWQYQWMVVTVURUWTVWAGVVJVUSVVIVVSUYNVUPVUQVU
        SUUIZXFUUJUUKVVTVWCVWEUHZYNVWHVVOVVSVWCVWMVVOVVSVWCXAZXAZUWCUVNUYPUGZVW
        EVWOUWCEUNZVWAUWTVOZVWPUHZVVOVVSVWQVWCVVOUVSEUWCAUXPUYMVVAVVITUUMYAYDVW
        OVWAVURUWTVVOVVSVWCUUNZVVJVUSVVIVWNVWLXFZXKVWOVVSVVIVWQVWRXAZVWSYNZVVOV
        VSVWCYFVVJVVIVWNUUOVVHVXCUEUWCUVSUENYIZVVGVXBUYRVWSVXDVVDVWQVVFVWRUYOUW
        CEUUPVXDVVEVWAUWTUYOUWCKYHYJUUQVXDUYQVWPUYOUWCUVNUYPXCWQUURYQWMUUSVWOUY
        PVWDUWCUVNVWODUWTVWAHVWOVWAVURUWTVWTVXAUUTUVBUVAUVCUVDVWCVWEUVEVSVWBVWF
        UVKYLBCDGHIJKNUBOPUVFUVGUVHUWGVVRMUVNUVSMUBYIZUWFVVQNUVSVXEUWEVVPUWDUVN
        UWCIWNWQWOUVLWMYRYSYRYSUVIYTUVJUVMYT $.
    $}

    ${
      fnwe2lem3.a $e |- ( ph -> a e. A ) $.
      fnwe2lem3.b $e |- ( ph -> b e. A ) $.
      $( Lemma for ~ fnwe2 .  Trichotomy.  (Contributed by Stefan O'Rear,
         19-Jan-2015.) $)
      fnwe2lem3 $p |- ( ph -> ( a T b \/ a = b \/ b T a ) ) $=
        ( cv cfv wbr wceq w3o weq wor wcel wwe weso syl fvres ffvelrnd eqeltrrd
        cres solin syl12anc wa csb wo orc adantl fnwe2val sylibr crab fnwe2lem1
        3mix1 mpdan adantr eqidd fveq2 eqeq1d elrab sylanbrc eqcomd simplr olcd
        simpr jca 3mix2 csbeq1 breqd biimpa 3mix3 3jaodan ) ALUAZKUBZMUAZKUBZGU
        CZWGWIUDZWIWGGUCZUEZWFWHIUCZLMUFZWHWFIUCZUEZAFGUGZWGFUHWIFUHWMAFGUIWRRF
        GUJUKAWFKEUOZUBZWGFAWFEUHZWTWGUDSWFEKULUKAEFWFWSQSUMUNAWHWSUBZWIFAWHEUH
        ZXBWIUDTWHEKULUKAEFWHWSQTUMUNFWGWIGUPUQAWJWQWKWLAWJURZWNWQXDWJWKWFWHDWG
        HUSZUCZURZUTZWNWJXHAWJXGVAVBBCDGHIJKLMNOVCZVDWNWOWPVGZUKAWKURZXFWOWHWFX
        EUCZUEZWQXKCUAZKUBZWGUDZCEVEZXEUGZWFXQUHZWHXQUHZXMAXRWKAXQXEUIZXRAXAYAS
        ABCDEGHIJKLNOPVFVHXQXEUJUKVIXKXAWGWGUDZXSAXAWKSVIXKWGVJXPYBCWFECLUFXOWG
        WGXNWFKVKVLVMVNXKXCWIWGUDZXTAXCWKTVIXKWGWIAWKVRVOXPYCCWHECMUFXOWIWGXNWH
        KVKVLVMVNXQWFWHXEUPUQXKXFWQWOXLXKXFURZWNWQYDXHWNYDXGWJYDWKXFAWKXFVPXKXF
        VRVSVQXIVDXJUKWOWQXKWOWNWPVTVBXKXLURZWPWQYEWLYCWHWFDWIHUSZUCZURZUTZWPYE
        YHWLYEYCYGYEWGWIAWKXLVPVOXKXLYGXKXEYFWHWFWKXEYFUDADWGWIHWAVBWBWCVSVQBCD
        GHIJKMLNOVCZVDWPWNWOWDZUKWEVHAWLURZWPWQYLYIWPWLYIAWLYHVAVBYJVDYKUKWEVH
        $.
    $}

    $d ph a b $.
    $( A well-ordering can be constructed on a partitioned set by patching
       together well-orderings on each partition using a well-ordering on the
       partitions themselves.  Similar to ~ fnwe but does not require the
       within-partition ordering to be globally well.  (Contributed by Stefan
       O'Rear, 19-Jan-2015.) $)
    fnwe2 $p |- ( ph -> T We A ) $=
      ( va vb vd cv vc wfr wbr weq w3o wral wwe wss c0 wne wa wrex wal wcel cfv
      wn wi wceq crab adantlr cres wf adantr simprl simprr fnwe2lem2 ex alrimiv
      df-fr sylibr fnwe2lem3 ralrimivva dfwe2 sylanbrc ) AEIUBZQTZRTZIUCQRUDVQV
      PIUCUEZREUFQEUFEIUGAVPEUHZVPUIUJZUKZSTUATIUCUPSVPUFUAVPULZUQZQUMVOAWCQAWA
      WBAWAUKBCDEFGHIJKQUASLMABTZEUNZCTKUOWDKUOURCEUSJUGZWANUTAEFKEVAVBZWAOVCAF
      GUGZWAPVCAVSVTVDAVSVTVEVFVGVHQUASEIVIVJAVRQREEAVPEUNZVQEUNZUKZUKBCDEFGHIJ
      KQRLMAWEWFWKNUTAWGWKOVCAWHWKPVCAWIWJVDAWIWJVEVKVLQREIVMVN $.
  $}

  ${
    $d z y a b c d $.
    aomclem1.b $e |- B = { <. a , b >. | E. c e. ( R1 ` U. dom z )
        ( ( c e. b /\ -. c e. a ) /\ A. d e. ( R1 ` U. dom z )
          ( d ( z ` U. dom z ) c -> ( d e. a <-> d e. b ) ) ) } $.
    aomclem1.on $e |- ( ph -> dom z e. On ) $.
    aomclem1.su $e |- ( ph -> dom z = suc U. dom z ) $.
    aomclem1.we $e |- ( ph -> A. a e. dom z ( z ` a ) We ( R1 ` a ) ) $.
    $( Lemma for ~ dfac11 .  This is the beginning of the proof that multiple
       choice is equivalent to choice.  Our goal is to construct, by
       transfinite recursion, a well-ordering of ` ( R1 `` A ) ` .  In what
       follows, ` A ` is the index of the rank we wish to well-order, ` z ` is
       the collection of well-orderings constructed so far, ` dom z ` is the
       set of ordinal indexes of constructed ranks i.e. the next rank to
       construct, and ` y ` is a postulated multiple-choice function.

       Successor case 1, define a simple ordering from the well-ordered
       predecessor.  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    aomclem1 $p |- ( ph -> B Or ( R1 ` dom z ) ) $=
      ( cv cr1 cfv wor cvv wcel wwe wceq fveq2 cdm cuni cpw fvex wral csuc dmex
      vex uniex sucid syl5eleqr weeq12d rspcva syl2anc wepwso sylancr wb fveq2d
      con0 onuni r1suc 3syl eqtrd soeq2 syl mpbird ) ABLZUAZMNZCOZVHUBZMNZUCZCO
      ZAVLPQVLVKVGNZRZVNVKMUDAVKVHQDLZMNZVQVGNZRZDVHUEVPAVKVKUFZVHVKVHVGBUHUGUI
      UJJUKKVTVPDVKVHVQVKSVRVLVSVOVQVKVGTVQVKMTULUMUNDEFGVLVOCPHUOUPAVIVMSVJVNU
      QAVIWAMNZVMAVHWAMJURAVHUSQVKUSQWBVMSIVHUTVKVAVBVCVIVMCVDVEVF $.
  $}

  ${
    $d z y a b c d $.  $d ph a $.
    aomclem2.b $e |- B = { <. a , b >. | E. c e. ( R1 ` U. dom z )
        ( ( c e. b /\ -. c e. a ) /\ A. d e. ( R1 ` U. dom z )
          ( d ( z ` U. dom z ) c -> ( d e. a <-> d e. b ) ) ) } $.
    aomclem2.c $e |- C = ( a e. _V |->
        sup ( ( y ` a ) , ( R1 ` dom z ) , B ) ) $.
    aomclem2.on $e |- ( ph -> dom z e. On ) $.
    aomclem2.su $e |- ( ph -> dom z = suc U. dom z ) $.
    aomclem2.we $e |- ( ph -> A. a e. dom z ( z ` a ) We ( R1 ` a ) ) $.
    aomclem2.a $e |- ( ph -> A e. On ) $.
    aomclem2.za $e |- ( ph -> dom z C_ A ) $.
    aomclem2.y $e |- ( ph -> A. a e. ~P ( R1 ` A ) ( a =/= (/) ->
        ( y ` a ) e. ( ( ~P a i^i Fin ) \ { (/) } ) ) ) $.
    $( Lemma for ~ dfac11 .  Successor case 2, a choice function for subsets of
       ` ( R1 `` dom z ) ` .  (Contributed by Stefan O'Rear, 18-Jan-2015.) $)
    aomclem2 $p |- ( ph -> A. a e. ~P ( R1 ` dom z ) ( a =/= (/) ->
          ( C ` a ) e. a ) ) $=
      ( wcel wss cv c0 wne cfv wi cdm cr1 cpw w3a csup cvv wceq vex cfn cin csn
      cdif wral con0 jca r1ord3 sylc sspwb sylib sseld rsp sylsyld 3imp eldifad
      wa inss1 sseli elpwid syl aomclem1 3ad2ant1 inss2 eldifsni elpwi 3ad2ant2
      sseldi sstrd fisupcl syl13anc sseldd fvmpt2 sylancr eqeltrd 3exp ralrimiv
      wor ) AGUAZUBUCZWLFUDZWLSZUEGCUAUFZUGUDZUHZAWLWRSZWMWOAWSWMUIZWNWLBUAUDZW
      QEUJZWLWTWLUKSXBWLSWNXBULGUMWTXAWLXBWTXAWLUHZUNUOZSZXAWLTWTXAXDUBUPZAWSWM
      XAXDXFUQSZAWMXGUEZGDUGUDZUHZURWSWLXJSXHRAWRXJWLAWQXITZWRXJTAWPUSSZDUSSZVJ
      WPDTXKAXLXMMPUTQWPDVAVBWQXIVCVDVEXHGXJVFVGVHZVIZXEXAWLXDXCXAXCUNVKVLVMVNZ
      WTWQEWKZXAUNSXAUBUCZXAWQTXBXASAWSXQWMACEGHIJKMNOVOVPWTXDUNXAXCUNVQXOWAWTX
      GXRXNXAXDUBVRVNWTXAWLWQXPWSAWLWQTWMWLWQVSVTWBWQXAEWCWDWEZGUKXBWLFLWFWGXSW
      HWIWJ $.
  $}

  ${
    $d z y a b c d $.  $d ph a b $.  $d C a b c d $.  $d D a b c d $.
    aomclem3.b $e |- B = { <. a , b >. | E. c e. ( R1 ` U. dom z )
        ( ( c e. b /\ -. c e. a ) /\ A. d e. ( R1 ` U. dom z )
          ( d ( z ` U. dom z ) c -> ( d e. a <-> d e. b ) ) ) } $.
    aomclem3.c $e |- C = ( a e. _V |->
        sup ( ( y ` a ) , ( R1 ` dom z ) , B ) ) $.
    aomclem3.d $e |- D = recs ( ( a e. _V |->
        ( C ` ( ( R1 ` dom z ) \ ran a ) ) ) ) $.
    aomclem3.e $e |- E = { <. a , b >. | |^| ( `' D " { a } ) e.
        |^| ( `' D " { b } ) } $.
    aomclem3.on $e |- ( ph -> dom z e. On ) $.
    aomclem3.su $e |- ( ph -> dom z = suc U. dom z ) $.
    aomclem3.we $e |- ( ph -> A. a e. dom z ( z ` a ) We ( R1 ` a ) ) $.
    aomclem3.a $e |- ( ph -> A e. On ) $.
    aomclem3.za $e |- ( ph -> dom z C_ A ) $.
    aomclem3.y $e |- ( ph -> A. a e. ~P ( R1 ` A ) ( a =/= (/) ->
        ( y ` a ) e. ( ( ~P a i^i Fin ) \ { (/) } ) ) ) $.
    $( Lemma for ~ dfac11 .  Successor case 3, our required well-ordering.
       (Contributed by Stefan O'Rear, 19-Jan-2015.) $)
    aomclem3 $p |- ( ph -> E We ( R1 ` dom z ) ) $=
      ( cv cdm cr1 cfv cvv crn cdif cmpt crecs wceq rneq difeq2d fveq2d cbvmptv
      weq recseq ax-mp eqtri wcel fvex a1i c0 wne cpw wral aomclem2 neeq1 fveq2
      wi id eleq12d imbi12d cbvralv sylib dnwech ) ALKJICUCUDZUEUFZGFHUGGIUGVSI
      UCZUHZUIZFUFZUJZUKZKUGVSKUCZUHZUIZFUFZUJZUKZOWDWJULWEWKULIKUGWCWIIKUQZWBW
      HFWLWAWGVSVTWFUMUNUOUPWDWJURUSUTVSUGVAAVRUEVBVCAVTVDVEZVTFUFZVTVAZVKZIVSV
      FZVGLUCZVDVEZWRFUFZWRVAZVKZLWQVGABCDEFIJKLMNQRSTUAUBVHWPXBILWQILUQZWMWSWO
      XAVTWRVDVIXCWNWTVTWRVTWRFVJXCVLVMVNVOVPPVQ $.
  $}

  ${
    $d z y a b c d $.  $d ph a b c $.
    aomclem4.f $e |- F = { <. a , b >. | ( ( rank ` a ) _E ( rank ` b ) \/
        ( ( rank ` a ) = ( rank ` b ) /\ a ( z ` suc ( rank ` a ) ) b ) ) } $.
    aomclem4.on $e |- ( ph -> dom z e. On ) $.
    aomclem4.su $e |- ( ph -> dom z = U. dom z ) $.
    aomclem4.we $e |- ( ph -> A. a e. dom z ( z ` a ) We ( R1 ` a ) ) $.
    $( Lemma for ~ dfac11 .  Limit case.  Patch together well-orderings
       constructed so far using ~ fnwe2 to cover the limit rank.  (Contributed
       by Stefan O'Rear, 20-Jan-2015.) $)
    aomclem4 $p |- ( ph -> F We ( R1 ` dom z ) ) $=
      ( cv cr1 cfv con0 csuc crnk wceq wcel wa wwe fveq2 vc cdm cep fveq2d crab
      suceq wss cab cima cuni wfun wfn r1fnon fnfun ax-mp fndm pm3.2i funfvima2
      eqimss2i mpsyl elssuni syl sselda rankidb eleq2d syl5ibcom expimpd df-rab
      ss2abdv abid2 eqcomi 3sstr4g adantr wral rankr1ai adantl wb eloni limsuc2
      word syl2anc mpbid weq weeq12d cbvralv sylib rspcva wess sylc wf cres a1i
      rankf fssres epweon fnwe2 ) ADEUABJZUBZKLZMUCUAJZNZWQLCDJZOLZNZWQLZOWTXCP
      XAXDWQWTXCUFUDFAXBWSQZRZEJZOLZXCPZEWSUEZXDKLZUGZXLXESZXKXESAXMXFAXHWSQZXJ
      RZEUHXHXLQZEUHZXKXLAXPXQEAXOXJXQAXORZXHXINZKLZQZXJXQXSXHKMUIZUJZQYBAWSYDX
      HAWSYCQZWSYDUGZKUKZMKUBZUGZRAWRMQZYEYGYIKMULZYGUMMKUNUOYHMYKYHMPUMMKUPUOU
      SUQGMWRKURUTWSYCVAVBZVCXHVDVBXJYAXLXHXJXTXDKXIXCUFUDVEVFVGVIXJEWSVHXRXLEX
      LVJVKVLVMXGXDWRQZXHKLZXHWQLZSZEWRVNZXNXGXCWRQZYMXFYRAXBWRVOVPAYRYMVQZXFAW
      RVTZWRWRUJPYSAYJYTGWRVRVBHWRXCVSWAVMWBAYQXFAXBKLZXBWQLZSZDWRVNYQIUUCYPDEW
      RDEWCUUAYNUUBYOXBXHWQTXBXHKTWDWEWFVMYPXNEXDWRXHXDPYNXLYOXEXHXDWQTXHXDKTWD
      WGWAXKXLXEWHWIAYDMOWJZYFWSMOWSWKWJUUDAWMWLYLYDMWSOWNWAMUCSAWOWLWP $.
  $}

  ${
    $d z y a b c d $.  $d ph a b $.  $d C a b c d $.  $d D a b c d $.
    aomclem5.b $e |- B = { <. a , b >. | E. c e. ( R1 ` U. dom z )
        ( ( c e. b /\ -. c e. a ) /\ A. d e. ( R1 ` U. dom z )
          ( d ( z ` U. dom z ) c -> ( d e. a <-> d e. b ) ) ) } $.
    aomclem5.c $e |- C = ( a e. _V |->
        sup ( ( y ` a ) , ( R1 ` dom z ) , B ) ) $.
    aomclem5.d $e |- D = recs ( ( a e. _V |->
        ( C ` ( ( R1 ` dom z ) \ ran a ) ) ) ) $.
    aomclem5.e $e |- E = { <. a , b >. | |^| ( `' D " { a } ) e.
        |^| ( `' D " { b } ) } $.
    aomclem5.f $e |- F = { <. a , b >. | ( ( rank ` a ) _E ( rank ` b ) \/
        ( ( rank ` a ) = ( rank ` b ) /\ a ( z ` suc ( rank ` a ) ) b ) ) } $.
    aomclem5.g $e |- G = ( if ( dom z = U. dom z , F , E ) i^i
        ( ( R1 ` dom z ) X. ( R1 ` dom z ) ) ) $.
    aomclem5.on $e |- ( ph -> dom z e. On ) $.
    aomclem5.we $e |- ( ph -> A. a e. dom z ( z ` a ) We ( R1 ` a ) ) $.
    aomclem5.a $e |- ( ph -> A e. On ) $.
    aomclem5.za $e |- ( ph -> dom z C_ A ) $.
    aomclem5.y $e |- ( ph -> A. a e. ~P ( R1 ` A ) ( a =/= (/) ->
        ( y ` a ) e. ( ( ~P a i^i Fin ) \ { (/) } ) ) ) $.
    $( Lemma for ~ dfac11 .  Combine the successor case with the limit case.
       (Contributed by Stefan O'Rear, 20-Jan-2015.) $)
    aomclem5 $p |- ( ph -> G We ( R1 ` dom z ) ) $=
      ( cv cdm cr1 cfv cuni wceq cif cxp cin wwe wa con0 wcel adantr simpr wral
      aomclem4 iftrue adantl eqidd weeq12d mpbird wn csuc word orduniorsuc 3syl
      wo eloni orcanai wss c0 wne cpw cfn csn cdif wi aomclem3 pm2.61dan weinxp
      iffalse sylib wb weeq1 ax-mp sylibr ) ACUFZUGZUHUIZWNWNUJZUKZIHULZWOWOUMU
      NZUOZWOJUOZAWOWRUOZWTAWQXBAWQUPZXBWOIUOXCCIKLSAWNUQURZWQUAUSAWQUTAKUFZUHU
      IXEWMUIUOKWNVAZWQUBUSVBXCWOWOWRIWQWRIUKAWQIHVCVDXCWOVEVFVGAWQVHZUPZXBWOHU
      OXHBCDEFGHKLMNOPQRAXDXGUAUSAWQWNWPVIUKZAXDWNVJWQXIVMUAWNVNWNVKVLVOAXFXGUB
      USADUQURXGUCUSAWNDVPXGUDUSAXEVQVRXEBUFUIXEVSVTUNVQWAWBURWCKDUHUIVSVAXGUEU
      SWDXHWOWOWRHXGWRHUKAWQIHWGVDXHWOVEVFVGWEWOWRWFWHJWSUKXAWTWITWOJWSWJWKWL
      $.
  $}

  ${
    $d z y a b c d $.  $d ph a b c d z $.  $d C a b c d $.  $d D a b c d $.
    $d A a b c d z $.  $d H a b c d z $.  $d G d $.
    aomclem6.b $e |- B = { <. a , b >. | E. c e. ( R1 ` U. dom z )
        ( ( c e. b /\ -. c e. a ) /\ A. d e. ( R1 ` U. dom z )
          ( d ( z ` U. dom z ) c -> ( d e. a <-> d e. b ) ) ) } $.
    aomclem6.c $e |- C = ( a e. _V |->
        sup ( ( y ` a ) , ( R1 ` dom z ) , B ) ) $.
    aomclem6.d $e |- D = recs ( ( a e. _V |->
        ( C ` ( ( R1 ` dom z ) \ ran a ) ) ) ) $.
    aomclem6.e $e |- E = { <. a , b >. | |^| ( `' D " { a } ) e.
        |^| ( `' D " { b } ) } $.
    aomclem6.f $e |- F = { <. a , b >. | ( ( rank ` a ) _E ( rank ` b ) \/
        ( ( rank ` a ) = ( rank ` b ) /\ a ( z ` suc ( rank ` a ) ) b ) ) } $.
    aomclem6.g $e |- G = ( if ( dom z = U. dom z , F , E ) i^i
        ( ( R1 ` dom z ) X. ( R1 ` dom z ) ) ) $.
    aomclem6.h $e |- H = recs ( ( z e. _V |-> G ) ) $.
    aomclem6.a $e |- ( ph -> A e. On ) $.
    aomclem6.y $e |- ( ph -> A. a e. ~P ( R1 ` A ) ( a =/= (/) ->
        ( y ` a ) e. ( ( ~P a i^i Fin ) \ { (/) } ) ) ) $.
    $( Lemma for ~ dfac11 .  Transfinite induction, close over ` z ` .
       (Contributed by Stefan O'Rear, 20-Jan-2015.) $)
    aomclem6 $p |- ( ph -> ( H ` A ) We ( R1 ` A ) ) $=
      ( wss cr1 cfv wwe ssid con0 wcel wa adantr cv wi weq sseq1 anbi2d weeq12d
      fveq2 imbi12d wceq wral w3a cres csb wsbc wal cdm dmeq adantl simpl1 onss
      wfn cmpt tfr1 fnssres mpan fndm 4syl eqtrd eqeltrd eleq2d simpll2 simpl3l
      cvv biimpa onelss syl imp simpl3r sstrd rspcva syl22anc wb fveq1 ad2antlr
      eqsstrd fvres weeq1 mpbird ralrimiva c0 wne cpw cfn cin csn cdif aomclem5
      fveq2d weeq2 mpbid ex alrimiv nfsbc1v nfim eqeq1 sbceq1a cbval sylib wfun
      nfv fnfun ax-mp resfunexg mp2an ceqsal sbcco nfcsb1v nfcv csbeq1a sbciegf
      vex nfwe crecs recsval fveq1i cuni cif fvex xpex inex2 eqeltri csbex eqid
      cxp fvmpts reseq1i fveq2i eqtr3i 3eqtr4g 3ad2ant1 3exp tfis3 mpcom mpan2
      ) ADDUEZDUFUGZDKUGZUHZDUIDUJUKZAUURULZUVAAUVBUURUCUMANUNZDUEZULZUVDUFUGZU
      VDKUGZUHZUOAOUNZDUEZULZUVJUFUGZUVJKUGZUHZUOZUVCUVAUONODNOUPZUVFUVLUVIUVOU
      VQUVEUVKAUVDUVJDUQURUVQUVGUVMUVHUVNUVDUVJKUTUVDUVJUFUTUSVAUVDDVBZUVFUVCUV
      IUVAUVRUVEUURAUVDDDUQURUVRUVGUUSUVHUUTUVDDKUTUVDDUFUTUSVAUVDUJUKZUVPOUVDV
      CZUVFUVIUVSUVTUVFVDZUVIUVGCKUVDVEZJVFZUHZUWAUVGJUHZCUWBVGZUWDUWAUWECUVJVG
      ZOUWBVGZUWFUWAUVJUWBVBZUWGUOZOVHZUWHUWACUNZUWBVBZUWEUOZCVHUWKUWAUWNCUWAUW
      MUWEUWAUWMULZUWLVIZUFUGZJUHZUWEUWOBCDEFGHIJLMNOPQRSTUAUWOUWPUVDUJUWOUWPUW
      BVIZUVDUWMUWPUWSVBUWAUWLUWBVJVKUWOUVSUVDUJUEZUWBUVDVNZUWSUVDVBUVSUVTUVFUW
      MVLZUVDVMKUJVNZUWTUXAKCWFJVOZUBVPZUJUVDKVQVRUVDUWBVSVTWAZUXBWBZUWOLUNZUFU
      GZUXHUWLUGZUHZLUWPUWOUXHUWPUKZULZUXKUXIUXHKUGZUHZUXMUXHUVDUKZUVTAUXHDUEZU
      XOUWOUXLUXPUWOUWPUVDUXHUXFWCWGZUVSUVTUVFUWMUXLWDUWOAUXLAUVEUVSUVTUWMWEZUM
      UXMUXHUWPDUWOUXLUXHUWPUEZUWOUWPUJUKUXLUXTUOUXGUWPUXHWHWIWJUWOUWPDUEUXLUWO
      UWPUVDDUXFAUVEUVSUVTUWMWKWRZUMWLUXPUVTULAUXQULZUXOUVPUYBUXOUOOUXHUVDOLUPZ
      UVLUYBUVOUXOUYCUVKUXQAUVJUXHDUQURUYCUVMUXIUVNUXNUVJUXHKUTUVJUXHUFUTUSVAWM
      WJWNUXMUXJUXNVBUXKUXOWOUXMUXJUXHUWBUGZUXNUWMUXJUYDVBUWAUXLUXHUWLUWBWPWQUX
      MUXPUYDUXNVBUXRUXHUVDKWSWIWAUXIUXJUXNWTWIXAXBUWOAUVBUXSUCWIUYAUWOAUXHXCXD
      UXHBUNUGUXHXEXFXGXCXHXIUKUOLUUSXEVCUXSUDWIXJUWOUWQUVGVBUWRUWEWOUWOUWPUVDU
      FUXFXKUWQUVGJXLWIXMXNXOUWNUWJCOUWNOYCUWIUWGCUWICYCUWECUVJXPXQCOUPUWMUWIUW
      EUWGUWLUVJUWBXRUWECUVJXSVAXTYAUWGUWHOUWBUWGOUWBXPKYBZUVDWFUKUWBWFUKZUXCUY
      EUXEUJKYDYENYNKUVDWFYFYGZUWGOUWBXSYHYAUWECOUWBYIYAUYFUWFUWDWOUYGUWEUWDCUW
      BWFCUVGUWCCUWBJYJCUVGYKYOUWMJUWCVBUWEUWDWOCUWBJYLUVGJUWCWTWIYMYEYAUVSUVTU
      VIUWDWOZUVFUVSUVHUWCVBUYHUVSUVDUXDYPZUGUYIUVDVEZUXDUGZUVHUWCUVDUXDYQUVDKU
      YIUBYRUWBUXDUGZUWCUYKUYFUWCWFUKUYLUWCVBUYGCUWBJJUWPUWPYSVBIHYTZUWQUWQUUGZ
      XGWFUAUYNUYMUWQUWQUWPUFUUAZUYOUUBUUCUUDUUECUWBJWFUXDWFUXDUUFUUHYGUWBUYJUX
      DKUYIUVDUBUUIUUJUUKUULUVGUVHUWCWTWIUUMXAUUNUUOUUPUUQ $.

    $( Lemma for ~ dfac11 . ` ( R1 `` A ) ` is well-orderable.  (Contributed by
       Stefan O'Rear, 20-Jan-2015.) $)
    aomclem7 $p |- ( ph -> E. b b We ( R1 ` A ) ) $=
      ( cr1 cfv wwe cv wex aomclem6 fvex weeq1 spcev syl ) ADUEUFZDKUFZUGZUOMUH
      ZUGZMUIABCDEFGHIJKLMNOPQRSTUAUBUCUDUJUSUQMUPDKUKUOURUPULUMUN $.
  $}

  ${
    $d ph c d e f g h i j k l b $.  $d A a b c d e f g h i j k l $.
    $d y a c d e f g h i j k l b $.
    aomclem8.a $e |- ( ph -> A e. On ) $.
    aomclem8.y $e |- ( ph -> A. a e. ~P ( R1 ` A ) ( a =/= (/) ->
        ( y ` a ) e. ( ( ~P a i^i Fin ) \ { (/) } ) ) ) $.
    $( Lemma for ~ dfac11 .  Perform variable substitutions.  This is the most
       we can say without invoking regularity.  (Contributed by Stefan O'Rear,
       20-Jan-2015.) $)
    aomclem8 $p |- ( ph -> E. b b We ( R1 ` A ) ) $=
      ( vi vh vg vj vc vd wel wa cv cfv cvv wceq nfcv ve vl vf wn cdm wbr wb wi
      cuni cr1 wral wrex copab csup cmpt crn cdif crecs ccnv csn cima cint wcel
      crnk cep csuc wo cif cxp cin weq elequ2 notbid bi2anan9r bi2bian9 ralbidv
      imbi2d anbi12d rexbidv elequ1 breq2 imbi1d bibi12d imbi12d cbvralv syl6bb
      breq1 cbvrexv cbvopabv nfopab1 nfsup supeq1d cbvmpt nffvmpt1 rneq difeq2d
      fveq2 fveq2d recseq ax-mp nfv nfmpt1 nfcnv nfima nfint nfel nfopab2 nfmpt
      nfrecs nffv sneq imaeq2d inteqd eleq12 syl2an cbvopab breqan12d eqeqan12d
      simpl suceq adantr simpr breq123d orbi12d eqid dmeq unieqd breqd opabbidv
      syl anbi2d fveq12d mpteq2dv difeq1d imaeq1d eleq12d c0 wne cpw cfn orbi2d
      eqeq12d id raleqbidv rexeqbidv supeq123d cnveqd ifbieq12d xpeq12d ineq12d
      fveq1 eqidd cbvmptv neeq1 pweq ineq1d sylib aomclem7 ) ABUACHINZHJNZUDZOZ
      KPZHPZUAPZUEZUIZUVEQZUFZKJNZKINZUGZUHZKUVGUJQZUKZOZHUVNULZJIUMZJRJPZBPZQZ
      UVFUJQZUVRUNZUOZJRUWBUVSUPZUQZUWDQZUOZURZUWIUSZUVSUTZVAZVBZUWJIPZUTZVAZVB
      ZVCZJIUMZUVSVDQZUWNVDQZVEUFZUWTUXASZUVSUWNUWTVFZUVEQZUFZOZVGZJIUMZUVFUVGS
      ZUXIUWSVHZUWBUWBVIZVJZUBRUBPZUEZUXOUIZSZUXBUXCUVSUWNUXDUXNQZUFZOZVGZJIUMZ
      JRUXOUJQZUWEUQZJRUWAUYCUVBUVCUVDUXPUXNQZUFZUVLUHZKUXPUJQZUKZOZHUYHULZJIUM
      ZUNZUOZQZUOZURZUSZUWKVAZVBZUYRUWOVAZVBZVCZJIUMZVHZUYCUYCVIZVJZUOZURZLEMUC
      UVQMENZMLNZUDZOZUCPZMPZUVHUFZUCLNZUCENZUGZUHZUCUVNUKZOZMUVNULZJILEJLVKZIE
      VKZOZUVQHENZHLNZUDZOZUVIKLNZKENZUGZUHZKUVNUKZOZHUVNULVVCVVFUVPVVPHUVNVVFU
      VBVVJUVOVVOVVEUUSVVGVVDUVAVVIIEHVLVVDUUTVVHJLHVLVMVNVVFUVMVVNKUVNVVFUVLVV
      MUVIVVDUVJVVKVVEUVKVVLJLKVLIEKVLVOVQVPVRVSVVPVVBHMUVNHMVKZVVJVUMVVOVVAVVQ
      VVGVUJVVIVULHMEVTVVQVVHVUKHMLVTVMVRVVQVVOUVCVUOUVHUFZVVMUHZKUVNUKVVAVVQVV
      NVVSKUVNVVQUVIVVRVVMUVDVUOUVCUVHWAWBVPVVSVUTKUCUVNKUCVKZVVRVUPVVMVUSUVCVU
      NVUOUVHWGVVTVVKVUQVVLVURKUCLVTKUCEVTWCWDWEWFVRWHWFWIJLRUWCLPZUVTQZUWBUVRU
      NLUWCTJVWBUWBUVRJVWBTJUWBTUVQJIWJWKVVDUWBUWAVWBUVRUVSVWAUVTWQWLWMUWHLRUWB
      VWAUPZUQZUWDQZUOZSUWIVWFURSJLRUWGVWELUWGTJRUWCVWDWNVVDUWFVWDUWDVVDUWEVWCU
      WBUVSVWAWOWPWRWMUWHVWFWSWTUWRUWJVWAUTZVAZVBZUWJEPZUTZVAZVBZVCZJILEUWRLXAU
      WREXAJVWIVWMJVWHJUWJVWGJUWIJUWHJRUWGXBXIXCZJVWGTXDXEJVWLJUWJVWKVWOJVWKTXD
      XEXFIVWIVWMIVWHIUWJVWGIUWIIUWHIJRUWGIRTZIUWFUWDIJRUWCVWPIUWAUWBUVRIUWATIU
      WBTUVQJIXGWKXHIUWFTXJXHXIXCZIVWGTXDXEIVWLIUWJVWKVWQIVWKTXDXEXFVVDUWMVWISU
      WQVWMSUWRVWNUGVVEVVDUWLVWHVVDUWKVWGUWJUVSVWAXKXLXMVVEUWPVWLVVEUWOVWKUWJUW
      NVWJXKXLXMUWMVWIUWQVWMXNXOXPUXHVWAVDQZVWJVDQZVEUFZVWRVWSSZVWAVWJVWRVFZUVE
      QZUFZOZVGJILEVVFUXBVWTUXGVXEVVDVVEUWTVWRUXAVWSVEUVSVWAVDWQZUWNVWJVDWQZXQV
      VFUXCVXAUXFVXDVVDVVEUWTVWRUXAVWSVXFVXGXRVVFUVSVWAUWNVWJUXEVXCVVDVVEXSVVFU
      XDVXBUVEVVDUXDVXBSZVVEVVDUWTVWRSVXHVXFUWTVWRXTYJYAWRVVDVVEYBYCVRYDWIUXMYE
      VUHUARUXMUOZSVUIVXIURSUBUARVUGUXMUBUAVKZVUEUXKVUFUXLVXJUXQUXJUYBVUDUXIUWS
      VXJUXOUVFUXPUVGUXNUVEYFZVXJUXOUVFVXKYGZUUBVXJUYAUXHJIVXJUXTUXGUXBVXJUXSUX
      FUXCVXJUXRUXEUVSUWNUXDUXNUVEUUKYHYKUUAYIVXJVUCUWRJIVXJUYTUWMVUBUWQVXJUYSU
      WLVXJUYRUWJUWKVXJUYQUWIVXJUYPUWHSUYQUWISVXJJRUYOUWGVXJUYDUWFUYNUWDVXJJRUY
      MUWCVXJUWAUYCUYLUWAUWBUVRVXJUWAUULVXJUXOUVFUJVXKWRZVXJUYKUVQJIVXJUYJUVPHU
      YHUVNVXJUXPUVGUJVXLWRZVXJUYIUVOUVBVXJUYGUVMKUYHUVNVXNVXJUYFUVIUVLVXJUYEUV
      HUVCUVDVXJUXPUVGUXNUVEVXJUUCVXLYLYHWBUUDYKUUEYIUUFYMVXJUYCUWBUWEVXMYNYLYM
      UYPUWHWSYJUUGZYOXMVXJVUAUWPVXJUYRUWJUWOVXOYOXMYPYIUUHVXJUYCUWBUYCUWBVXMVX
      MUUIUUJUUMVUHVXIWSWTFADPZYQYRZVXPUVTQZVXPYSZYTVJZYQUTZUQZVCZUHZDCUJQYSZUK
      VWAYQYRZVWBVWAYSZYTVJZVYAUQZVCZUHZLVYEUKGVYDVYKDLVYEDLVKZVXQVYFVYCVYJVXPV
      WAYQUUNVYLVXRVWBVYBVYIVXPVWAUVTWQVYLVXTVYHVYAVYLVXSVYGYTVXPVWAUUOUUPYNYPW
      DWEUUQUUR $.
  $}

  ${
    $d x z f a b c d $.
    $( The right-hand side of this theorem (compare with ~ ac4 ), sometimes
       known as the "axiom of multiple choice", is a choice equivalent.
       Curiously, this statement cannot be proved without ~ ax-reg , despite
       not mentioning the cumulative hierarchy in any way as most consequences
       of regularity do.

       This is definition (MC) of [Schechter] p. 141. _EDITORIAL_: the proof is
       not original with me of course but I lost my reference sometime after
       writing it.

       A multiple choice function allows any total order to be extended to a
       choice function, which in turn defines a well-ordering.  Since a well
       ordering on a set defines a simple ordering of the power set, this
       allows the trivial well-ordering of the empty set to be transfinitely
       bootstrapped up the cumulative hierarchy to any desired level.
       (Contributed by Stefan O'Rear, 20-Jan-2015.)  (Revised by Stefan O'Rear,
       1-Jun-2015.) $)
    dfac11 $p |- ( CHOICE <-> A. x E. f A. z e. x ( z =/= (/) ->
        ( f ` z ) e. ( ( ~P z i^i Fin ) \ { (/) } ) ) ) $=
      ( vd vc va vb wac cv c0 wne cfv cfn csn wcel wi wral wex wal wceq cpw cin
      cdif dfac3 raleq exbidv cbvalv neeq1 fveq2 id eleq12d imbi12d cbvralv w3a
      cmpt sneqd eqid snex fvmpt 3ad2ant1 wss simp3 snssd elpw sylibr snfi elin
      a1i sylanbrc fvex snnz eldifsn eqeltrd 3exp a2d ralimia sylbi mptex fveq1
      vex eleq1d imbi2d ralbidv spcev syl exlimiv alimi wwe crnk pwex spcv con0
      cr1 rankon aomclem8 r1rankid wess eximdv mp2b 3syl alrimiv dfac8 impbii
      cvv ) HBIZJKZXECIZLZXEUAZMUBZJNUCZOZPZBAIZQZCRZASZHDIZJKZXREIZLZXROZPZDFI
      ZQZERZFSZXQFDEUDYGYCDXNQZERZASXQYFYIFAYDXNTYEYHEYCDYDXNUEUFUGYIXPAYHXPEYH
      XFXEGXNGIZXTLZNZUOZLZXKOZPZBXNQZXPYHXFXEXTLZXEOZPZBXNQYQYCYTDBXNXRXETZXSX
      FYBYSXRXEJUHUUAYAYRXRXEXRXEXTUIUUAUJUKULUMYTYPBXNXEXNOZXFYSYOUUBXFYSYOUUB
      XFYSUNZYNYRNZXKUUBXFYNUUDTYSGXEYLUUDXNYMYJXETYKYRYJXEXTUIUPYMUQYRURZUSUTU
      UCUUDXJOZUUDJKZUUDXKOUUCUUDXIOZUUDMOZUUFUUCUUDXEVAUUHUUCYRXEUUBXFYSVBVCUU
      DXEUUEVDVEUUIUUCYRVFVHUUDXIMVGVIUUGUUCYRXEXTVJVKVHUUDXJJVLVIVMVNVOVPVQXOY
      QCYMGXNYLAVTVRXGYMTZXMYPBXNUUJXLYOXFUUJXHYNXKXEXGYMVSWAWBWCWDWEWFWGVQVQXQ
      YDYJWHZGRZFSHXQUULFXQXMBYDWILZWMLZUAZQZCRZUUNYJWHZGRZUULXPUUQAUUOUUNUUMWM
      VJWJXNUUOTXOUUPCXMBXNUUOUEUFWKUUPUUSCUUPCUUMBGUUMWLOUUPYDWNVHUUPUJWOWFYDX
      DOYDUUNVAZUUSUULPFVTYDXDWPUUTUURUUKGYDUUNYJWQWRWSWTXAFGXBVEXC $.
  $}

  ${
    $d ph f x y z $.  $d C f w $.  $d C y z $.  $d I f x y z $.  $d J f y z $.
    $d S y $.  $d U y $.  $d w x $.
    kelac1.z $e |- ( ( ph /\ x e. I ) -> S =/= (/) ) $.
    kelac1.j $e |- ( ( ph /\ x e. I ) -> J e. Top ) $.
    kelac1.c $e |- ( ( ph /\ x e. I ) -> C e. ( Clsd ` J ) ) $.
    kelac1.b $e |- ( ( ph /\ x e. I ) -> B : S -1-1-onto-> C ) $.
    kelac1.u $e |- ( ( ph /\ x e. I ) -> U e. U. J ) $.
    kelac1.k $e |- ( ph -> ( Xt_ ` ( x e. I |-> J ) ) e. Comp ) $.
    $( Kelley's choice, basic form: if a collection of sets can be cast as
       closed sets in the factors of a topology, and there is a definable
       element in each topology (which need not be in the closed set - if it
       were this would be trivial), then compactness (via finite intersection)
       guarantees that the final product is nonempty.  (Contributed by Stefan
       O'Rear, 22-Feb-2015.) $)
    kelac1 $p |- ( ph -> X_ x e. I S =/= (/) ) $=
      ( vy wcel c0 wral wa cvv vz vf vw cixp wne wex cuni weq cif ciin cin wceq
      cv wss ccld cfv eqid cldss syl ralrimiva boxriin cmpt ctop wf ccmp cmptop
      cpt wn 0ntop fvprc eleq1d mtbiri con4i 3syl fmptd syl2anc ptunimpt ineq1d
      dmfex topcld ifcl ptcldmpt adantr cfn wrex simprr cima f1ofo foima eqcomd
      wf1o wfo wb f1ofn ssid fnimaeq0 sylancl necon3bid mpbird eqnetrd n0 sylib
      wfn rexv sylibr wi ssralv mpan9 eleq1 ac6sfi ad2antrr wel cdif cun iftrue
      ad2antrl simpll simprl sselda sseld impr eqeltrd expr ralimdva imp eldifn
      iffalse adantl eldifi sylan2 ralun undif biimpi raleqdv mptelixpg adantlr
      mpbid eleq2 ne0i exlimddv simplrr ifbothda incom disjdif eqtri a1i simplr
      simpr disjne syl3anc neneqd 3eltr4d ad3antrrr eliin elin sylanbrc adantrl
      mptexg cmpfiiin ccnv elixp2 simp3bi f1ocnv f1of ffvelrn ex 4syl ) AOUMZBG
      DUDZPZBGEUDZQUEZOAUVIQUEUVJOUFAUVIBGHUGZUDZOGBGBOUHZDUVMUIZUDZUJZUKZQADUV
      MUNZBGRUVIUVSULAUVTBGABUMZGPZSZDHUOUPZPZUVTKDHUVMUVMUQZURUSZUTBODUVMGVAUS
      AUVSBGHVBZVGUPZUGZUVRUKQAUVNUWJUVRAGTPZHVCPZBGRUVNUWJULAUWHTPZGVCUWHVDUWK
      AUWIVEPUWIVCPZUWMNUWIVFUWMUWNUWMVHZUWNQVCPVIUWOUWIQVCUWHVGVJVKVLVMVNABGHV
      CUWHJUWHUQVOGVCTUWHVSVPZAUWLBGJUTBGUWIHTUWIUQVQVPZVRAUVQOGUWIUWJUAUWJUQNA
      UVQUWIUOUPPUVHGPAGUVPBHTUWPJUWCUWEUVMUWDPZUVPUWDPKUWCUWLUWRJHUVMUWFVTUSUV
      ODUVMUWDWAVPWBWCAUAUMZGUNZUWSWDPZSZSZUWSTUBUMZVDZUWAUXDUPZDPZBUWSRZSZUWJO
      UWSUVQUJZUKZQUEZUBUXCUXAUCUMZDPZUCTWEZBUWSRZUXIUBUFAUWTUXAWFAUXOBGRZUXBUX
      PAUXOBGUWCUXNUCUFZUXOUWCDQUEUXRUWCDCEWGZQUWCUXSDUWCEDCWKZEDCWLUXSDULLEDCW
      HEDCWIVNWJUWCUXSQUEEQUEIUWCUXSQEQUWCCEXCZEEUNUXSQULEQULWMUWCUXTUYALEDCWNU
      SEWOEECWPWQWRWSWTUCDXAXBUXNUCXDXEUTUWTUXQUXPXFUXAUXOBUWSGXGWCXHUXNUXGBUCU
      WSTUBUXMUXFDXIXJVPUXCUXHUXLUXEUXCUXHSZUXKUVNUXJUKZQAUXKUYCULUXBUXHAUWJUVN
      UXJAUVNUWJUWQWJVRXKUYBBGBUAXLZUXFFUIZVBZUYCPZUYCQUEUYBUYFUVNPZUYFUXJPZUYG
      UYBUYHUYEUVMPZBGRZUYBUYJBUWSGUWSXMZXNZRZUYKUYBUYJBUWSRZUYJBUYLRZUYNUXCUXH
      UYOUXCUXGUYJBUWSUXCUYDUXGUYJUXCUYDUXGSSZUYEUXFUVMUYDUYEUXFULUXCUXGUYDUXFF
      XOXPZUXCUYDUXGUXFUVMPZUXCUYDSZDUVMUXFUYTAUWBUVTAUXBUYDXQUXCUWSGUWAAUWTUXA
      XRXSUWGVPXTYAZYBYCYDYEAUYPUXBUXHAUYJBUYLAUWAUYLPZSUYEFUVMVUBUYEFULZAVUBUY
      DVHVUCUWAGUWSYFUYDUXFFYGUSZYHVUBAUWBFUVMPZUWAGUWSYIMYJZYBUTXKUYJBUWSUYLYK
      VPUXCUYNUYKWMUXHUXCUYJBUYMGUWTUYMGULZAUXAUWTVUGUWSGYLYMXPZYNWCYQUYBUWKUYH
      UYKWMAUWKUXBUXHUWPXKBGUYEUVMTYOUSWSUYBUYIUYFUVQPZOUWSRZUYBVUIOUWSUYBOUAXL
      ZSZVUIUYEUVPPZBGRZVULVUMBUYMRZVUNVULVUMBUWSRZVUMBUYLRZVUOUYBVUPVUKUXCUXHV
      UPUXCUXGVUMBUWSUXCUYDUXGVUMUYQUYEUXFUVPUYRUVOUXGUYSUXFUVPPUYQDUVMDUVPUXFY
      RUVMUVPUXFYRUXCUYDUXGUVOUUAUYQUYSUVOVHZVUAWCUUBYBYCYDYEWCUXCVUKVUQUXHAVUK
      VUQUXBAVUKSZVUMBUYLVUSVUBSZFUVMUYEUVPAVUBVUEVUKVUFYPVUBVUCVUSVUDYHVUTVURU
      VPUVMULVUTUWAUVHVUTUYLUWSUKZQULZVUBVUKUWAUVHUEVVBVUTVVAUWSUYLUKQUYLUWSUUC
      UWSGUUDUUEUUFVUSVUBUUHAVUKVUBUUGUYLUWSUWAUVHUUIUUJUUKUVODUVMYGUSUULUTYPYP
      VUMBUWSUYLYKVPUXCVUOVUNWMUXHVUKUXCVUMBUYMGVUHYNXKYQVULUWKVUIVUNWMAUWKUXBU
      XHVUKUWPUUMBGUYEUVPTYOUSWSUTUYBUYFTPZUYIVUJWMAVVCUXBUXHAUWKVVCUWPBGUYETUU
      RUSXKOUYFUWSUVQTUUNUSWSUYFUVNUXJUUOUUPUYCUYFYSUSWTUUQYTUUSWTWTOUVIXAXBAUV
      JSZBGUWAUVHUPZCUUTZUPZVBZUVKPZUVLVVDVVIVVGEPZBGRZUVJAVVEDPZBGRZVVKUVJUVHT
      PUVHGXCVVMBGDUVHUVAUVBAVVMVVKAVVLVVJBGUWCUXTDEVVFWKDEVVFVDZVVLVVJXFLEDCUV
      CDEVVFUVDVVNVVLVVJDEVVEVVFUVEUVFUVGYDYEYJAVVIVVKWMZUVJAUWKVVOUWPBGVVGETYO
      USWCWSUVKVVHYSUSYT $.
  $}

  ${
    $d S x y $.
    $( Lemma for ~ kelac2 and ~ dfac21 : knob topologies are compact.
       (Contributed by Stefan O'Rear, 22-Feb-2015.) $)
    kelac2lem $p |- ( S e. V -> ( topGen ` { S , { ~P U. S } } ) e. Comp ) $=
      ( vx vy wcel cpw ctop cfn cin cvv cv c0 wceq wo wral vex elpr eqtr3 orcd
      wa cuni csn cpr ctg cfv ccmp ctb weq prex ineq12 incom wn pwuninel disjsn
      mpbir eqtri syl6eq olcd ccase syl2anb rgen2a baspartn mp2an tgcl mp1i wbr
      cdom prfi pwfi mpbi tgdom ax-mp domfi a1i elin sylanbrc fincmp syl ) ABEZ
      AAUAFZUBZUCZUDUEZGHIEZWCUFEVSWCGEZWCHEZWDWBUGEZWEVSWBJEZCDUHZCKZDKZIZLMZN
      ZDWBOCWBOWGAWAUIZWNCDWBWJWBEWJAMZWJWAMZNWKAMZWKWAMZNWNWKWBEWJAWACPQWKAWAD
      PQWPWRWQWSWNWPWRTWIWMWJWKARSWQWRTZWMWIWTWLWAAIZLWJWAWKAUJXAAWAIZLWAAUKXBL
      MVTAEULAUMAVTUNUOZUPUQURWPWSTZWMWIXDWLXBLWJAWKWAUJXCUQURWQWSTWIWMWJWKWARS
      USUTVACDWBJVBVCWBVDVEWFVSWBFZHEZWCXEVGVFZWFWBHEXFAWAVHWBVIVJWHXGWOWBJVKVL
      XEWCVMVCVNWCGHVOVPWCVQVR $.
  $}

  ${
    $d ph x $.  $d I x $.
    kelac2.s $e |- ( ( ph /\ x e. I ) -> S e. V ) $.
    kelac2.z $e |- ( ( ph /\ x e. I ) -> S =/= (/) ) $.
    kelac2.k $e |- ( ph -> ( Xt_ `
          ( x e. I |-> ( topGen ` { S , { ~P U. S } } ) ) ) e. Comp ) $.
    $( Kelley's choice, most common form: compactness of a product of knob
       topologies recovers choice.  (Contributed by Stefan O'Rear,
       22-Feb-2015.) $)
    kelac2 $p |- ( ph -> X_ x e. I S =/= (/) ) $=
      ( cuni cfv wcel 3syl cdif cun cvv wceq cin c0 a1i wss cid cpw csn cpr ctg
      cres cv ccmp ctop kelac2lem cmptop ccld uncom difeq1i difun2 eqtri uniprg
      wa snex sylancl difeq1d incom pwuninel disjsn sylibr syl5eq disj3 3eqtr4a
      wn sylib prex bastg mp1i prid2 sseldd eqeltrd prid1g elssuni unitg eqcomi
      ax-mp iscld2 syl2anc mpbird wf1o f1oi uniexg pwexg snidg syl6eleqr kelac1
      wb 4syl ) ABUACUFZCCCIZUBZDCWPUCZUDZUEJZGABUGDKURZCEKZWSUHKWSUIKZFCEUJWSU
      KLZWTCWSULJKZWRIZCMZWSKZWTXFWQWSWTCWQNZCMZWQCMZXFWQXIWQCNZCMXJXHXKCCWQUMU
      NWQCUOUPWTXEXHCWTXAWQOKXEXHPFWPUSZCWQEOUQUTVAWTWQCQZRPWQXJPWTXMCWQQZRWQCV
      BWTWPCKVIZXNRPXOWTCVCSCWPVDVEVFWQCVGVJVHWTWRWSWQWROKZWRWSTWTCWQVKZWROVLVM
      WQWRKZWTCWQXLVNZSVOVPWTXBCXETZXDXGWLXCWTXACWRKXTFCWQEVQCWRVRLCWSXEWSIZXEX
      PYAXEPXQWROVSWAZVTWBWCWDCCWNWEWTCWFSWTWPXEYAWTWQXEWPXRWQXETWTXSWQWRVRVMWT
      XAWOOKWPOKWPWQKFCEWGWOOWHWPOWIWMVOYBWJHWK $.
  $}

  ${
    $d f g y $.  $d g x $.  $d x y $.
    $( Tychonoff's theorem is a choice equivalent.  Definition AC21 of
       Schechter p. 461.  (Contributed by Stefan O'Rear, 22-Feb-2015.)
       (Revised by Mario Carneiro, 27-Aug-2015.) $)
    dfac21 $p |- ( CHOICE <-> A. f ( f : dom f --> Comp ->
            ( Xt_ ` f ) e. Comp ) ) $=
      ( vg vx vy wac cv cdm ccmp wf cpt cfv wcel wi wa cvv cuni cufl fvex wceq
      c0 wal ccrd cin vex simpr uniex acufl adantr syl5eleqr simpl dfac10 sylib
      dmex a1i elin sylanbrc eqid ptcmpg syl3anc alrimiv wfun crn wnel cixp wne
      ex cpw csn cpr ctg cmpt wss kelac2lem mp1i fmptd ffdm syl simpld mptex id
      dmeq feq12d fveq2 eleq1d imbi12d syl5com wn df-nel biimpi ad2antlr fvelrn
      spcv adantlr eleq1 syl5ibcom necon3bd unieqd pweqd preq12d fveq2d cbvmptv
      mpd sneqd fveq2i eleq1i adantl kelac2 syld com12 dfac9 sylibr impbii ) EA
      FZGZHXMIZXMJKZHLZMZAUAZEXRAEXOXQEXONZXNOLZXOXPPZQUBGZUCLZXQYAXTXMAUDUMUNE
      XOUEXTYBQLYBYCLYDXTYBOQXPXMJRUFZEQOSXOUGUHUIXTYBOYCYEXTEYCOSEXOUJUKULUIYB
      QYCUOUPXNXMXPOYBXPUQYBUQURUSVFUTXSBFZVAZTYFVBZVCZNZCYFGZCFZYFKZVDTVEZMZBU
      AEXSYOBYJXSYNYJXSDYKDFZYFKZYQPZVGZVHZVIZVJKZVKZJKZHLZYNYJUUCGZHUUCIZXSUUE
      YJUUGUUFYKVLZYJYKHUUCIUUGUUHNYJDYKUUBHUUCYQOLUUBHLYJYPYKLNYPYFRYQOVMVNUUC
      UQVOYKHUUCVPVQVRXRUUGUUEMAUUCDYKUUBYFBUDUMVSXMUUCSZXOUUGXQUUEUUIXNUUFHXMU
      UCUUIVTXMUUCWAWBUUIXPUUDHXMUUCJWCWDWEWLWFYJUUEYNYJUUENZCYMYKOYMOLUUJYLYKL
      ZNYLYFRUNYJUUKYMTVEZUUEYJUUKNZTYHLZWGZUULYIUUOYGUUKYIUUOTYHWHWIWJUUMUUNYM
      TUUMYMYHLZYMTSUUNYGUUKUUPYIYLYFWKWMYMTYHWNWOWPXBWMUUECYKYMYMPZVGZVHZVIZVJ
      KZVKZJKZHLZYJUUEUVDUUDUVCHUUCUVBJDCYKUUBUVAYPYLSZUUAUUTVJUVEYQYMYTUUSYPYL
      YFWCZUVEYSUURUVEYRUUQUVEYQYMUVFWQWRXCWSWTXAXDXEWIXFXGVFXHXIUTCBXJXKXL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Finitely generated left modules
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LFinGen $.

  $( Extend class notation with the class of finitely generated left
     modules. $)
  clfig $a class LFinGen $.

  $( Define the class of finitely generated left modules.  Finite generation of
     subspaces can be intepreted using ` |``s ` .  (Contributed by Stefan
     O'Rear, 1-Jan-2015.) $)
  df-lfig $a |- LFinGen = { w e. LMod | ( Base ` w ) e. ( ( LSpan ` w ) "
      ( ~P ( Base ` w ) i^i Fin ) ) } $.

  ${
    $d ph a b $.  $d W a b $.  $d B a b $.  $d N a b $.
    islmodfg.b $e |- B = ( Base ` W ) $.
    islmodfg.n $e |- N = ( LSpan ` W ) $.
    $( Property of a finitely generated left module.  (Contributed by Stefan
       O'Rear, 1-Jan-2015.) $)
    islmodfg $p |- ( W e. LMod -> ( W e. LFinGen <-> E. b e. ~P B ( b e. Fin /\
          ( N ` b ) = B ) ) ) $=
      ( va clmod wcel clfig cbs cfv cpw cfn cin cima cv wceq wa clspn wrex crab
      df-lfig eleq2i fveq2 syl6eqr pweqd ineq1d imaeq12d eleq12d elrab3 wfn wss
      syl5bb wb clss eqid lspf ffn syl inss1 fvelimab sylancl elin eqcomi pweqi
      wf anbi1i bitri eqeq2i anbi12i anass rexbii2 syl6bb bitrd ) CHIZCJIZCKLZB
      VRMZNOZPZIZDQZNIZWCBLZARZSZDAMZUAZVQCGQZKLZWJTLZWKMZNOZPZIZGHUBZIVPWBJWQC
      GUCUDWPWBGCHWJCRZWKVRWOWAWJCKUEZWRWLBWNVTWRWLCTLBWJCTUEFUFWRWMVSNWRWKVRWS
      UGUHUIUJUKUNVPWBWEVRRZDVTUAZWIVPBVSULZVTVSUMWBXAUOVPVSCUPLZBVGXBXCBVRCVRU
      QXCUQFURVSXCBUSUTVSNVADVSVTVRBVBVCWTWGDVTWHWCVTIZWTSWCWHIZWDSZWFSXEWGSXDX
      FWTWFXDWCVSIZWDSXFWCVSNVDXGXEWDVSWHWCVRAAVREVEZVFUDVHVIVRAWEXHVJVKXEWDWFV
      LVIVMVNVO $.
  $}

  ${
    $d ph a b $.  $d W a b $.  $d X a b $.  $d S a b $.  $d U a b $.
    $d N a b $.  $d B a $.
    islssfg.x $e |- X = ( W |`s U ) $.
    islssfg.s $e |- S = ( LSubSp ` W ) $.
    islssfg.n $e |- N = ( LSpan ` W ) $.
    $( Property of a finitely generated left (sub-)module.  (Contributed by
       Stefan O'Rear, 1-Jan-2015.) $)
    islssfg $p |- ( ( W e. LMod /\ U e. S ) -> ( X e. LFinGen <->
          E. b e. ~P U ( b e. Fin /\ ( N ` b ) = U ) ) ) $=
      ( clmod wcel wa cfv cbs wceq cpw wrex wb wss eqid cv clspn clfig ressbas2
      cfn lssss pweqd rexeqdv adantl elpwi lsslsp 3expa sylan2 ad2antlr eqeq12d
      syl anbi2d rexbidva lsslmod islmodfg 3bitr4rd ) DJKZBAKZLZFUAZUEKZVEEUBMZ
      MZENMZOZLZFBPZQZVKFVIPZQZVFVECMZBOZLZFVLQEUCKZVCVMVORVBVCVKFVLVNVCBVIVCBD
      NMZSBVIOZABVTDVTTZHUFBVTEDGWBUDUPZUGUHUIVDVRVKFVLVDVEVLKZLZVQVJVFWEVPVHBV
      IWDVDVEBSZVPVHOZVEBUJVBVCWFWGBVEACVGDEGIVGTZHUKULUMVCWAVBWDWCUNUOUQURVDEJ
      KVSVORABDEGHUSVIVGEFVITWHUTUPVA $.

    islssfg2.b $e |- B = ( Base ` W ) $.
    $( Property of a finitely generated left (sub-)module, with a relaxed
       constraint on the spanning vectors.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    islssfg2 $p |- ( ( W e. LMod /\ U e. S ) -> ( X e. LFinGen <->
          E. b e. ( ~P B i^i Fin ) ( N ` b ) = U ) ) $=
      ( wcel wa cfn cpw wrex wb wi wss elpw clmod clfig cv cfv wceq cin islssfg
      lssss adantl sstr2 mpan9 lspssid adantlr impbida vex 3bitr4g eleq1 anbi2d
      pweq eleq2d bibi1d imbi12d mpbii com12 adantld pm5.32rd elin anbi1i anass
      bitr2i syl6bb rexbidv2 bitrd ) EUALZCBLZMZFUBLGUCZNLZVQDUDZCUEZMZGCOZPVTG
      AOZNUFZPBCDEFGHIJUGVPWAVTGWBWDVPVQWBLZWAMVQWCLZWAMZVQWDLZVTMZVPWAWEWFVPVT
      WEWFQZVRVTVPWJVTVNVSBLZMZVQVSOZLZWFQZRVPWJRWLVQVSSZVQASZWNWFWLWPWQWLVSASZ
      WPWQWKWRVNBVSAEKIUHUIVQVSAUJUKVNWQWPWKVQDAEKJULUMUNVQVSGUOZTVQAWSTUPVTWLV
      PWOWJVTWKVOVNVSCBUQURVTWNWEWFVTWMWBVQVSCUSUTVAVBVCVDVEVFWIWFVRMZVTMWGWHWT
      VTVQWCNVGVHWFVRVTVIVJVKVLVM $.
  $}

  ${
    $d W a $.  $d N a $.  $d W a $.  $d V a $.  $d X a $.  $d B a $.
    islssfgi.n $e |- N = ( LSpan ` W ) $.
    islssfgi.v $e |- V = ( Base ` W ) $.
    islssfgi.x $e |- X = ( W |`s ( N ` B ) ) $.
    $( Finitely spanned subspaces are finitely generated.  (Contributed by
       Stefan O'Rear, 24-Jan-2015.) $)
    islssfgi $p |- ( ( W e. LMod /\ B C_ V /\ B e. Fin ) -> X e. LFinGen ) $=
      ( va clmod wcel wss cfn w3a clfig cv cfv wceq cbs eqid cpw cin wrex elpw2
      cvv fvex eqeltri biimpri 3ad2ant2 simp3 elin sylanbrc fveq2 eqeq1d rspcev
      sylancl clss wb simp1 lspcl 3adant3 islssfg2 syl2anc mpbird ) DJKZACLZAMK
      ZNZEOKZIPZBQZABQZRZICUAZMUBZUCZVHAVOKZVLVLRZVPVHAVNKZVGVQVFVEVSVGVSVFACCD
      SQUEGDSUFUGUDUHUIVEVFVGUJAVNMUKULVLTVMVRIAVOVJARVKVLVLVJABUMUNUOUPVHVEVLD
      UQQZKZVIVPURVEVFVGUSVEVFWAVGVTABCDGVTTZFUTVACVTVLBDEIHWBFGVBVCVD $.
  $}

  $( Finitely generated left modules are left modules.  (Contributed by Stefan
     O'Rear, 1-Jan-2015.) $)
  fglmod $p |- ( M e. LFinGen -> M e. LMod ) $=
    ( va clfig clmod cv cbs cfv clspn cpw cfn cin cima wcel crab df-lfig ssrab2
    eqsstri sseli ) CDACBEZFGZSHGTIJKLMZBDNDBOUABDPQR $.

  ${
    $d ph a b $.  $d D a b $.  $d E a b $.  $d F a b $.  $d A a b $.
    $d B a b $.  $d W a b $.  $d .(+) a b $.  $d U a b $.
    lsmfgcl.u $e |- U = ( LSubSp ` W ) $.
    lsmfgcl.p $e |- .(+) = ( LSSum ` W ) $.
    lsmfgcl.d $e |- D = ( W |`s A ) $.
    lsmfgcl.e $e |- E = ( W |`s B ) $.
    lsmfgcl.f $e |- F = ( W |`s ( A .(+) B ) ) $.
    lsmfgcl.w $e |- ( ph -> W e. LMod ) $.
    lsmfgcl.a $e |- ( ph -> A e. U ) $.
    lsmfgcl.b $e |- ( ph -> B e. U ) $.
    lsmfgcl.df $e |- ( ph -> D e. LFinGen ) $.
    lsmfgcl.ef $e |- ( ph -> E e. LFinGen ) $.
    $( The sum of two finitely generated submodules is finitely generated.
       (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    lsmfgcl $p |- ( ph -> F e. LFinGen ) $=
      ( wcel va vb co cress clfig cv clspn cfv wceq cbs cpw cfn wrex clmod eqid
      cin wb islssfg2 syl2anc mpbid wa adantr cun wss inss1 sseli elpwid lsmsp2
      syl3an 3expb oveq2d unss biimpi syl2an adantl inss2 unfi islssfgi syl3anc
      eqeltrd anassrs oveq2 eleq1d syl5ibcom rexlimdva mpd oveq1 syl5eqel ) AHI
      BCEUCZUDUCZUENAUAUFZIUGUHZUHZBUIZUAIUJUHZUKZULUPZUMZWJUETZADUETZWRRAIUNTZ
      BFTWTWRUQOPWOFBWLIDUALJWLUOZWOUOZURUSUTAWNWSUAWQAWKWQTZVAZIWMCEUCZUDUCZUE
      TZWNWSXEUBUFZWLUHZCUIZUBWQUMZXHAXLXDAGUETZXLSAXACFTXMXLUQOQWOFCWLIGUBMJXB
      XCURUSUTVBXEXKXHUBWQXEXIWQTZVAIWMXJEUCZUDUCZUETZXKXHAXDXNXQAXDXNVAZVAZXPI
      WKXIVCZWLUHZUDUCZUEXSXOYAIUDAXDXNXOYAUIZAXAXDWKWOVDZXNXIWOVDZYCOXDWKWOWQW
      PWKWPULVEZVFVGZXNXIWOWQWPXIYFVFVGZEWKXIWLWOIXCXBKVHVIVJVKXSXAXTWOVDZXTULT
      ZYBUETAXAXROVBXRYIAXDYDYEYIXNYGYHYDYEVAYIWKXIWOVLVMVNVOXRYJAXDWKULTXIULTY
      JXNWQULWKWPULVPZVFWQULXIYKVFWKXIVQVNVOXTWLWOIYBXBXCYBUOVRVSVTWAXKXPXGUEXK
      XOXFIUDXJCWMEWBVKWCWDWEWFWNXGWJUEWNXFWIIUDWMBCEWGVKWCWDWEWFWH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Noetherian left modules I
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LNoeM $.

  $( Extend class notation with the class of Noetherian left modules. $)
  clnm $a class LNoeM $.

  ${
    $d i w $.

    $( A left-module is _Noetherian_ iff it is hereditarily finitely
       generated.  (Contributed by Stefan O'Rear, 12-Dec-2014.) $)
    df-lnm $a |- LNoeM = { w e. LMod | A. i e. ( LSubSp ` w )
        ( w |`s i ) e. LFinGen } $.
  $}

  ${
    $d w i M $.  $d w i S $.
    islnm.s $e |- S = ( LSubSp ` M ) $.
    $( Property of being a Noetherian left module.  (Contributed by Stefan
       O'Rear, 12-Dec-2014.) $)
    islnm $p |- ( M e. LNoeM <-> ( M e. LMod /\
        A. i e. S ( M |`s i ) e. LFinGen ) ) $=
      ( vw cv cress co clfig wcel clss wral clmod clnm wceq fveq2 syl6eqr oveq1
      cfv eleq1d raleqbidv df-lnm elrab2 ) EFZBFZGHZIJZBUDKSZLCUEGHZIJZBALECMNU
      DCOZUGUJBUHAUKUHCKSAUDCKPDQUKUFUIIUDCUEGRTUAEBUBUC $.
  $}

  ${
    $d i g M $.  $d i g N $.  $d i g S $.  $d i g B $.
    islnm2.b $e |- B = ( Base ` M ) $.
    islnm2.s $e |- S = ( LSubSp ` M ) $.
    islnm2.n $e |- N = ( LSpan ` M ) $.
    $( Property of being a Noetherian left module with finite generation
       expanded in terms of spans.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    islnm2 $p |- ( M e. LNoeM <-> ( M e. LMod /\
        A. i e. S E. g e. ( ~P B i^i Fin ) i = ( N ` g ) ) ) $=
      ( clnm wcel clmod cv cress co clfig wral wa wceq wrex islnm eqid islssfg2
      cfv cpw cfn cin eqcom rexbii syl6bb ralbidva pm5.32i bitri ) EJKELKZEDMZN
      OZPKZDBQZRUNUOCMFUDZSZCAUEUFUGZTZDBQZRBDEHUAUNURVCUNUQVBDBUNUOBKRUQUSUOSZ
      CVATVBABUOFEUPCUPUBHIGUCVDUTCVAUSUOUHUIUJUKULUM $.
  $}

  ${
    $d M a $.  $d U a $.  $d S a $.  $d R a $.
    $( A Noetherian left module is a left module.  (Contributed by Stefan
       O'Rear, 12-Dec-2014.) $)
    lnmlmod $p |- ( M e. LNoeM -> M e. LMod ) $=
      ( va clnm wcel clmod cv cress co clfig clss cfv wral eqid islnm simplbi )
      ACDAEDABFGHIDBAJKZLPBAPMNO $.

    ${
      lnmlssfg.s $e |- S = ( LSubSp ` M ) $.
      lnmlssfg.r $e |- R = ( M |`s U ) $.
      $( A submodule of Noetherian module is finitely generated.  (Contributed
         by Stefan O'Rear, 1-Jan-2015.) $)
      lnmlssfg $p |- ( ( M e. LNoeM /\ U e. S ) -> R e. LFinGen ) $=
        ( va clnm wcel cv cress co clfig wral clmod islnm simprbi oveq2 syl6eqr
        wceq eleq1d rspcv mpan9 ) DHIZDGJZKLZMIZGBNZCBIAMIZUDDOIUHBGDEPQUGUIGCB
        UECTZUFAMUJUFDCKLAUECDKRFSUAUBUC $.

      $( All submodules of a Noetherian module are Noetherian.  (Contributed by
         Stefan O'Rear, 1-Jan-2015.) $)
      lnmlsslnm $p |- ( ( M e. LNoeM /\ U e. S ) -> R e. LNoeM ) $=
        ( va clnm wcel wa clmod cress co clfig cfv sylan wss wceq cbs eqid clss
        cv wral lnmlmod lsslmod oveq1i simplr adantl ressbas2 ad2antlr sseqtr4d
        lssss ressabs syl2anc syl5eq simpll wb lsslss simprbda lnmlssfg eqeltrd
        syl ralrimiva islnm sylanbrc ) DHIZCBIZJZAKIZAGUBZLMZNIZGAUAOZUCAHIVFDK
        IZVGVIDUDZBCDAFEUEPVHVLGVMVHVJVMIZJZVKDVJLMZNVQVKDCLMZVJLMZVRAVSVJLFUFV
        QVGVJCQZVTVRRVFVGVPUGVQVJASOZCVPVJWBQVHVMVJWBAWBTVMTZULUHVGCWBRZVFVPVGC
        DSOZQWDBCWEDWETZEULCWEADFWFUIVBUJUKCVJDBUMUNUOVQVFVJBIZVRNIVFVGVPUPVHVP
        WGWAVFVNVGVPWGWAJUQVOBVMCVJDAFEWCURPUSVRBVJDEVRTUTUNVAVCVMGAWCVDVE $.
    $}

    $( A Noetherian left module is finitely generated.  (Contributed by Stefan
       O'Rear, 12-Dec-2014.) $)
    lnmfg $p |- ( M e. LNoeM -> M e. LFinGen ) $=
      ( clnm wcel cbs cfv cress co clfig eqid ressid clss lnmlmod lss1 lnmlssfg
      clmod syl mpdan eqeltrrd ) ABCZAADEZFGZAHTABTIZJSTAKEZCZUAHCSAOCUDALUCTAU
      BUCIZMPUAUCTAUEUAINQR $.
  $}

  ${
    $d a b c .0. $.  $d a b c B $.  $d a b c D $.  $d a b c F $.  $d a b c K $.
    $d a b c ph $.  $d a b c S $.  $d a b c T $.  $d a b c U $.  $d a b c V $.
    $d a b c .(+) $.
    kercvrlsm.u $e |- U = ( LSubSp ` S ) $.
    kercvrlsm.p $e |- .(+) = ( LSSum ` S ) $.
    kercvrlsm.z $e |- .0. = ( 0g ` T ) $.
    kercvrlsm.k $e |- K = ( `' F " { .0. } ) $.
    kercvrlsm.b $e |- B = ( Base ` S ) $.
    kercvrlsm.f $e |- ( ph -> F e. ( S LMHom T ) ) $.
    kercvrlsm.d $e |- ( ph -> D e. U ) $.
    kercvrlsm.cv $e |- ( ph -> ( F " D ) = ran F ) $.
    $( The domain of a linear function is the subspace sum of the kernel and
       any subspace which covers the range.  (Contributed by Stefan O'Rear,
       24-Jan-2015.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    kercvrlsm $p |- ( ph -> ( K .(+) D ) = B ) $=
      ( wcel syl va vb wss clmod clmhm lmhmlmod1 lmhmkerlss lsmcl syl3anc lssss
      co cv wa cfv wceq wrex cima crn wfn cbs wf eqid lmhmf ffn fnfvelrn adantr
      sylan eleqtrrd wb fvelimab syl2anc mpbid wi csg cplusg cgrp simprl sselda
      lmodgrp adantrl grpnpcan ad2antrr eqcom cghm lmghm ghmeqker syl5bb biimpa
      simplrr lsmelvalix syl32anc eqeltrrd ex anassrs rexlimdva mpd ssrdv eqssd
      ) AICDUKZBAWSGSZWSBUCAEUDSZIGSZCGSZWTAHEFUEUKSZXAPEFHUFTZAXDXBPEFGHIJNMKU
      GTZQDGICEKLUHUIGWSBEOKUJTAUABWSAUAULZBSZXGWSSZAXHUMZUBULZHUNZXGHUNZUOZUBC
      UPZXIXJXMHCUQZSZXOXJXMHURZXPAHBUSZXHXMXRSABFUTUNZHVAZXSAXDYAPBXTEFHOXTVBV
      CTBXTHVDTZBXGHVEVGAXPXRUOXHRVFVHXJXSCBUCZXQXOVIAXSXHYBVFAYCXHAXCYCQGCBEOK
      UJTZVFUBBCXMHVJVKVLXJXNXIUBCAXHXKCSZXNXIVMAXHYEUMZUMZXNXIYGXNUMZXGXKEVNUN
      ZUKZXKEVOUNZUKZXGWSYGYLXGUOZXNYGEVPSZXHXKBSZYMAYNYFAXAYNXEEVSTVFAXHYEVQZA
      YEYOXHACBXKYDVRVTZBYKEYIXGXKOYKVBZYIVBZWAUIVFYHXAIBUCZYCYJISZYEYLWSSAXAYF
      XNXEWBAYTYFXNAXBYTXFGIBEOKUJTWBAYCYFXNYDWBYGXNUUAXNXMXLUOZYGUUAXLXMWCYGHE
      FWDUKSZXHYOUUBUUAVIAUUCYFAXDUUCPEFHWETVFYPYQBEFXGHIYIXKJOMNYSWFUIWGWHAXHY
      EXNWIBYKDICEUDYJXKOYRLWJWKWLWMWNWOWPWMWQWR $.
  $}

  ${
    $d ph x $.  $d X x $.  $d S x $.  $d A x $.  $d U x $.  $d Y x $.
    $d T x $.  $d F x $.
    lmhmfgima.y $e |- Y = ( T |`s ( F " A ) ) $.
    lmhmfgima.x $e |- X = ( S |`s A ) $.
    lmhmfgima.u $e |- U = ( LSubSp ` S ) $.
    lmhmfgima.xf $e |- ( ph -> X e. LFinGen ) $.
    lmhmfgima.a $e |- ( ph -> A e. U ) $.
    lmhmfgima.f $e |- ( ph -> F e. ( S LMHom T ) ) $.
    $( A homomorphism maps finitely generated submodules to finitely generated
       submodules.  (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    lmhmfgima $p |- ( ph -> Y e. LFinGen ) $=
      ( cress clfig cfv cfn wcel syl vx cima co cv clspn wceq cbs cpw cin clmod
      wrex wb clmhm lmhmlmod1 eqid islssfg2 syl2anc mpbid wa inss1 sseli elpwid
      wss lmhmlsp syl2an oveq2d lmhmlmod2 adantr crn imassrn wf frn syl5ss cres
      lmhmf wfo inss2 adantl wfun cdm ffun sseqtr4d fores fofi islssfgi syl3anc
      fdm eqeltrd imaeq2 eleq1d syl5ibcom rexlimdva mpd syl5eqel ) AHDFBUBZOUCZ
      PIAUAUDZCUEQZQZBUFZUACUGQZUHZRUIZUKZWPPSZAGPSZXDLACUJSZBESXFXDULAFCDUMUCS
      ZXGNCDFUNTMXAEBWRCGUAJKWRUOZXAUOZUPUQURAWTXEUAXCAWQXCSZUSZDFWSUBZOUCZPSWT
      XEXLXNDFWQUBZDUEQZQZOUCZPXLXMXQDOAXHWQXAVCZXMXQUFXKNXKWQXAXCXBWQXBRUTVAVB
      ZCDWQFWRXPXAXJXIXPUOZVDVEVFXLDUJSZXODUGQZVCZXORSZXRPSAYBXKAXHYBNCDFVGTVHA
      YDXKAXOFVIZYCFWQVJAXAYCFVKZYFYCVCAXHYGNXAYCCDFXJYCUOZVOTZXAYCFVLTVMVHXLWQ
      RSZWQXOFWQVNZVPZYEXKYJAXCRWQXBRVQVAVRXLFVSZWQFVTZVCYLAYMXKAYGYMYIXAYCFWAT
      VHXLWQXAYNXKXSAXTVRAYNXAUFZXKAYGYOYIXAYCFWGTVHWBWQFWCUQWQXOYKWDUQXOXPYCDX
      RYAYHXRUOWEWFWHWTXNWPPWTXMWODOWSBFWIVFWJWKWLWMWN $.
  $}

  ${
    $d V a $.  $d T a $.  $d S a $.  $d F a $.  $d B a $.
    lnmepi.b $e |- B = ( Base ` T ) $.
    $( Epimorphic images of Noetherian modules are Noetherian.  (Contributed by
       Stefan O'Rear, 24-Jan-2015.) $)
    lnmepi $p |- ( ( F e. ( S LMHom T ) /\ S e. LNoeM /\ ran F = B ) ->
        T e. LNoeM ) $=
      ( va clmhm wcel clnm crn wceq cress clfig clss cfv 3ad2ant1 cima sylanbrc
      co eqid w3a clmod cv wral lmhmlmod2 wa ccnv cbs wfo wss lmhmf simp3 dffo2
      lssss foimacnv syl2an oveq2d simpl2 lmhmpreima 3ad2antl1 lnmlssfg syl2anc
      wf simpl1 lmhmfgima eqeltrrd ralrimiva islnm ) DBCGSHZBIHZDJAKZUAZCUBHZCF
      UCZLSZMHZFCNOZUDCIHVIVJVMVKBCDUEPVLVPFVQVLVNVQHZUFZCDDUGVNQZQZLSZVOMVSWAV
      NCLVLBUHOZADUIZVNAUJWAVNKVRVLWCADVCZVKWDVIVJWEVKWCABCDWCTEUKPVIVJVKULWCAD
      UMRVQVNACEVQTZUNWCAVNDUOUPUQVSVTBCBNOZDBVTLSZWBWBTWHTZWGTZVSVJVTWGHZWHMHV
      IVJVKVRURVIVJVRWKVKBCVNDWGVQWJWFUSUTZWHWGVTBWJWIVAVBWLVIVJVKVRVDVEVFVGVQF
      CWFVHR $.
  $}

  ${
    $d F a b $.  $d S a b $.  $d T a b $.  $d K a b $.  $d U a b $.
    $d V a b $.
    lmhmfgsplit.z $e |- .0. = ( 0g ` T ) $.
    lmhmfgsplit.k $e |- K = ( `' F " { .0. } ) $.
    lmhmfgsplit.u $e |- U = ( S |`s K ) $.
    lmhmfgsplit.v $e |- V = ( T |`s ran F ) $.
    $( If the kernel and range of a homomorphism of left modules are finitely
       generated, then so is the domain.  (Contributed by Stefan O'Rear,
       1-Jan-2015.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    lmhmfgsplit $p |- ( ( F e. ( S LMHom T ) /\ U e. LFinGen /\
          V e. LFinGen ) -> S e. LFinGen ) $=
      ( va co wcel clfig cfn cfv wceq wa eqid vb clmhm w3a clspn crn wrex simp3
      cv cpw clmod clss lmhmlmod2 3ad2ant1 lmhmrnlss islssfg syl2anc mpbid cima
      wb cbs cin wfn wss wf simpl1 lmhmf 3syl ad2antrl simprrl fipreima syl3anc
      ffn elpwi clsm cress simpll1 lmhmlmod1 ad2antrr inss1 sseli lspcl lmhmlsp
      syl fveq2 ad2antll 3expa 3eqtrd kercvrlsm oveq2d ressid eqtr2d lmhmkerlss
      simp2rr simpll2 inss2 islssfgi lsmfgcl eqeltrd rexlimddv ) DABUBMNZCONZFO
      NZUCZLUHZPNZXDBUDQZQZDUEZRZSZAONZLXHUIZXCXBXJLXLUFZWTXAXBUGXCBUJNZXHBUKQZ
      NZXBXMUSWTXAXNXBABDULUMWTXAXPXBABDUNUMXOXHXFBFLKXOTXFTZUOUPUQXCXDXLNZXJSZ
      SZDUAUHZURZXDRZXKUAAUTQZUIZPVAZXTDYDVBZXDXHVCZXEYCUAYFUFXTWTYDBUTQZDVDYGW
      TXAXBXSVEYDYIABDYDTZYITVFYDYIDVLVGXRYHXCXJXDXHVMVHXCXRXEXIVIXDYDDUAVJVKXT
      YAYFNZYCSZSZAAEYAAUDQZQZAVNQZMZVOMZOYMYRAYDVOMZAYMYQYDAVOYMYDYOYPABAUKQZD
      EGYTTZYPTZHIYJWTXAXBXSYLVPZYMAUJNZYAYDVCZYOYTNXCUUDXSYLWTXAUUDXBABDVQUMZV
      RZYKUUEXTYCYKYAYENUUEYFYEYAYEPVSVTYAYDVMWCVHZYTYAYNYDAYJUUAYNTZWAUPZYMDYO
      URZYBXFQZXGXHYMWTUUEUUKUULRUUCUUHABYADYNXFYDYJUUIXQWBUPYCUULXGRXTYKYBXDXF
      WDWEXCXSYLXIXEXIXRXCYLWMWFWGWHWIXCYSARZXSYLXCUUDUUMUUFYDAUJYJWJWCVRWKYMEY
      OCYPYTAYOVOMZYRAUUAUUBJUUNTZYRTUUGXCEYTNZXSYLWTXAUUPXBABYTDEGIHUUAWLUMVRU
      UJWTXAXBXSYLWNYMUUDUUEYAPNZUUNONUUGUUHYKUUQXTYCYFPYAYEPWOVTVHYAYNYDAUUNUU
      IYJUUOWPVKWQWRWSWS $.

    $( If the kernel and range of a homomorphism of left modules are
       Noetherian, then so is the domain.  (Contributed by Stefan O'Rear,
       1-Jan-2015.)  (Revised by Stefan O'Rear, 12-Jun-2015.) $)
    lmhmlnmsplit $p |- ( ( F e. ( S LMHom T ) /\ U e. LNoeM /\ V e. LNoeM ) ->
        S e. LNoeM ) $=
      ( va co wcel cress clfig eqid cin cvv syl clmhm clnm w3a cv clss cfv wral
      clmod lmhmlmod1 3ad2ant1 wa cres ccnv csn crn reslmhm 3ad2antl1 cnvresima
      cima eqcomi ineq1i incom 3eqtri oveq2i oveq1i wceq simpl1 cnvexg syl5eqel
      wss imaexg inss2 ressabs sylancl syl5eq inss1 mp2an syl6reqr simpl2 simpr
      vex adantr lmhmkerlss lssincl syl3anc wb lsslss syl2anc mpbir2and eqeltrd
      a1i lnmlssfg rnexg resexg ressress resss rnss ax-mp mpbi eqtr2i lmhmrnlss
      df-ss simpl3 lmhmlmod2 lmhmfgsplit ralrimiva islnm sylanbrc ) DABUAMZNZCU
      BNZFUBNZUCZAUHNZALUDZOMZPNZLAUEUFZUGAUBNXJXKXNXLABDUIUJZXMXQLXRXMXOXRNZUK
      ZDXOULZXPBUAMNZXPYBUMGUNZUSZOMZPNBYBUOZOMZPNXQXJXKXTYCXLXPABXRDXOXRQZXPQU
      PUQZYAYFCXOERZOMZPYAYFXPYKOMZYLYEYKXPOYEDUMZYDUSZXOREXORYKXOYDDURYOEXOEYO
      IUTVAEXOVBVCVDYAYLAYKOMZYMYAYLAEOMZYKOMZYPCYQYKOJVEYAESNZYKEVJZYRYPVFYAXJ
      YSXJXKXLXTVGZXJEYOSIXJYNSNYOSNDXIVHYNYDSVKTVITXOEVLZEYKASVMVNVOXOSNYKXOVJ
      YMYPVFLWAXOEVPXOYKASVMVQVRVOYAXKYKCUEUFZNZYLPNXJXKXLXTVSYAUUDYKXRNZYTYAXN
      XTEXRNZUUEXMXNXTXSWBZXMXTVTYAXJUUFUUAABXRDEGIHYIWCTZXRXOEAYIWDWEYTYAUUBWK
      YAXNUUFUUDUUEYTUKWFUUGUUHXRUUCEYKACJYIUUCQZWGWHWIYLUUCYKCUUIYLQWLWHWJYAYH
      FYGOMZPYAXJYHUUJVFUUAXJUUJBDUOZYGRZOMZYHXJUUJBUUKOMZYGOMZUUMFUUNYGOKVEXJU
      UKSNYGSNZUUOUUMVFDXIWMXJYBSNUUPDXOXIWNYBSWMTUUKYGBSSWOWHVOYGUULBOUULYGUUK
      RZYGUUKYGVBYGUUKVJZUUQYGVFYBDVJUURDXOWPYBDWQWRZYGUUKXBWSWTVDVRTYAXLYGFUEU
      FZNZUUJPNXJXKXLXTXCYAUVAYGBUEUFZNZUURYAYCUVCYJXPBYBXATUURYAUUSWKYABUHNZUU
      KUVBNZUVAUVCUURUKWFYAXJUVDUUAABDXDTYAXJUVEUUAABDXATUVBUUTUUKYGBFKUVBQUUTQ
      ZWGWHWIUUJUUTYGFUVFUUJQWLWHWJXPBYFYBYEYHGHYEQYFQYHQXEWEXFXRLAYIXGXH $.
  $}

  ${
    $d R a $.  $d S a $.  $d V a $.
    $( Noetherian is an invariant property of modules.  (Contributed by Stefan
       O'Rear, 25-Jan-2015.) $)
    lnmlmic $p |- ( R ~=m S -> ( R e. LNoeM <-> S e. LNoeM ) ) $=
      ( va clmic wbr cv co wcel clnm clmhm crn cbs cfv wceq adantr simpr lnmepi
      wa eqid syl3anc clmim wex wb c0 wne brlmic n0 bitri lmimlmhm wf1o lmimf1o
      wfo f1ofo forn 3syl islmim2 simprbi cdm dfdm4 syl syl5eqr impbida exlimiv
      ccnv f1odm sylbi ) ABDEZCFZABUAGZHZCUBZAIHZBIHZUCZVGVIUDUEVKABUFCVIUGUHVJ
      VNCVJVLVMVJVLRVHABJGHZVLVHKBLMZNZVMVJVOVLABVHUIOVJVLPVJVQVLVJALMZVPVHUJZV
      RVPVHULVQVRVPABVHVRSZVPSZUKZVRVPVHUMVRVPVHUNUOOVPABVHWAQTVJVMRZVHVDZBAJGH
      ZVMWDKZVRNVLVJWEVMVJVOWEABVHUPUQOVJVMPWCWFVHURZVRVHUSVJWGVRNZVMVJVSWHWBVR
      VPVHVEUTOVAVRBAWDVTQTVBVCVF $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Addenda for structure powers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d Y a b x $.  $d W a b x $.  $d U a b x $.  $d Z a b x $.  $d V a b x $.
    $d B a b x $.  $d C a b x $.  $d F a b $.  $d X a b x $.  $d T x $.
    pwssplit1.y $e |- Y = ( W ^s U ) $.
    pwssplit1.z $e |- Z = ( W ^s V ) $.
    pwssplit1.b $e |- B = ( Base ` Y ) $.
    pwssplit1.c $e |- C = ( Base ` Z ) $.
    pwssplit1.f $e |- F = ( x e. B |-> ( x |` V ) ) $.
    $( Splitting for structure powers, part 0: restriction is a function.
       (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    pwssplit0 $p |- ( ( W e. T /\ U e. X /\ V C_ U ) -> F : B --> C ) $=
      ( wcel wf wb pwselbasb wss w3a cv cres cbs cfv eqid 3adant3 biimpa simpl3
      wa fssres syl2anc cvv simp1 simp2 simp3 ssexd adantr mpbird fmptd ) HDQZE
      IQZGEUAZUBZABAUCZGUDZCFVEVFBQZUKZVGCQZGHUEUFZVGRZVIEVKVFRZVDVLVEVHVMVBVCV
      HVMSVDVKHEBDVFJILVKUGZNTUHUIVBVCVDVHUJEVKGVFULUMVEVJVLSZVHVEVBGUNQVOVBVCV
      DUOVEGEIVBVCVDUPVBVCVDUQURVKHGCDVGKUNMVNOTUMUSUTPVA $.

    $( Splitting for structure powers, part 1: restriction is an onto
       function.  The only actual monoid law we need here is that the base set
       is nonempty.  (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    pwssplit1 $p |- ( ( W e. Mnd /\ U e. X /\ V C_ U ) -> F : B -onto-> C ) $=
      ( wcel wf wceq cun c0 va vb cmnd wss w3a cfv wrex wral wfo pwssplit0 cdif
      cv wa c0g csn cxp cbs cin cvv wb simp1 simp2 simp3 eqid pwselbasb syl2anc
      ssexd biimpa fconst a1i simpl1 mndidcl syl snssd fss disjdif fun syl21anc
      fvex simpl3 undif sylib unidm feq23d simpl2 mpbird cres fvtresfn resundir
      mpbid wfn fnresdm 3syl incom eqtri fnconstg ax-mp fnresdisj mpbii uneq12d
      ffn syl5eq un0 syl6eq eqtr2d fveq2 eqeq2d rspcev ralrimiva dffo3 sylanbrc
      mp1i ) GUCPZDHPZFDUDZUEZBCEQUAULZUBULZEUFZRZUBBUGZUACUHBCEUIABCUCDEFGHIJK
      LMNOUJXPYAUACXPXQCPZUMZXQDFUKZGUNUFZUOZUPZSZBPZXQYHEUFZRZYAYCYIDGUQUFZYHQ
      ZYCFYDSZYLYLSZYHQZYMYCFYLXQQZYDYLYGQZFYDURZTRZYPXPYBYQXPXMFUSPYBYQUTXMXNX
      OVAXPFDHXMXNXOVBXMXNXOVCVGYLGFCUCXQJUSLYLVDZNVEVFVHZYCYDYFYGQZYFYLUDYRUUC
      YCYDYEGUNVSZVIVJYCYEYLYCXMYEYLPXMXNXOYBVKZYLGYEUUAYEVDVLVMVNYDYFYLYGVOVFY
      TYCFDVPZVJFYDYLYLXQYGVQVRYCYNYODYLYHYCXOYNDRXMXNXOYBVTFDWAWBYOYLRYCYLWCVJ
      WDWJYCXMXNYIYMUTUUEXMXNXOYBWEYLGDBUCYHIHKUUAMVEVFWFZYCYJYHFWGZXQYCYIYJUUH
      RUUGABEFYHOWHVMYCUUHXQTSZXQYCUUHXQFWGZYGFWGZSUUIXQYGFWIYCUUJXQUUKTYCYQXQF
      WKUUJXQRUUBFYLXQXAFXQWLWMYCYDFURZTRZUUKTRZUULYSTYDFWNUUFWOYGYDWKZUUMUUNUT
      YCYEUSPUUOUUDYDYEUSWPWQYDFYGWRXLWSWTXBXQXCXDXEXTYKUBYHBXRYHRXSYJXQXRYHEXF
      XGXHVFXIUBUABCEXJXK $.

    $( Splitting for structure powers, part 2: restriction is a group
       homomorphism.  (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    pwssplit2 $p |- ( ( W e. Grp /\ U e. X /\ V C_ U ) ->
        F e. ( Y GrpHom Z ) ) $=
      ( cgrp wcel cfv co cres va wss w3a cplusg eqid simp1 simp2 pwsgrp syl2anc
      vb cvv simp3 ssexd pwssplit0 cv wa cof offres adantl adantr simpl2 simprl
      wceq pwsplusgval reseq1d fvtresfn oveqan12d 3eqtr4d grpcl 3expb sylan syl
      simprr ffvelrnda adantrr adantrl isghmd ) GPQZDHQZFDUBZUCZUAUJIUDRZJUDRZI
      JEBCMNWBUEZWCUEZWAVRVSIPQZVRVSVTUFZVRVSVTUGZGDHIKUHUIZWAVRFUKQZJPQWGWAFDH
      WHVRVSVTULUMZGFUKJLUHUIABCPDEFGHIJKLMNOUNZWAUAUOZBQZUJUOZBQZUPZUPZWMWOWBS
      ZFTZWMERZWOERZGUDRZUQZSZWSERZXAXBWCSWRWMWOXDSZFTZWMFTZWOFTZXDSZWTXEWQXHXK
      VCWAFXCWMWOBBURUSWRWSXGFWRBXCWBGWMWODPHIKMWAVRWQWGUTZVRVSVTWQVAWAWNWPVBWA
      WNWPVMXCUEZWDVDVEWQXEXKVCWAWNWPXAXIXBXJXDABEFWMOVFABEFWOOVFVGUSVHWRWSBQZX
      FWTVCWAWFWQXNWIWFWNWPXNBWBIWMWOMWDVIVJVKABEFWSOVFVLWRCXCWCGXAXBFPUKJLNXLW
      AWJWQWKUTWAWNXACQWPWABCWMEWLVNVOWAWPXBCQWNWABCWOEWLVNVPXMWEVDVHVQ $.

    $( Splitting for structure powers, part 3: restriction is a module
       homomorphism.  (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
    pwssplit3 $p |- ( ( W e. LMod /\ U e. X /\ V C_ U ) ->
        F e. ( Y LMHom Z ) ) $=
      ( clmod wcel cfv eqid cvv va wss w3a cvsca csca cbs simp1 pwslmod syl2anc
      vb simp2 simp3 ssexd wceq pwssca eqtr3d cgrp co lmodgrp pwssplit2 syl3an1
      cghm cv wa cres csn cxp cof snex xpexg sylancl vex offres adantr 3ad2ant3
      xpssres oveq1d simpl1 simpl2 fveq2d eleq2d biimpar adantrr simprr reseq1d
      eqtrd pwsvscafval fvtresfn ad2antll oveq2d lmodvscl 3expb sylan pwssplit0
      3eqtr4d syl ffvelrnda adantrl islmhmd ) GPQZDHQZFDUBZUCZUAUJIJIUDRZJUDRZE
      JUERZIUERZXGUFRZBMXDSZXESZXGSZXFSXHSZXCWTXAIPQZWTXAXBUGZWTXAXBUKZGDHIKUHU
      IZXCWTFTQZJPQXNXCFDHXOWTXAXBULUMZGFTJLUHUIXCGUERZXFXGXCWTXQXSXFUNXNXRGXSF
      PTJLXSSZUOUIXCWTXAXSXGUNXNXOGXSDPHIKXTUOUIZUPWTGUQQXAXBEIJVBURQGUSABCDEFG
      HIJKLMNOUTVAXCUAVCZXHQZUJVCZBQZVDZVDZYBYDXDURZFVEZFYBVFZVGZYDERZGUDRZVHZU
      RZYHERZYBYLXEURYGDYJVGZYDYNURZFVEZYKYDFVEZYNURZYIYOYGYSYQFVEZYTYNURZUUAXC
      YSUUCUNZYFXCYQTQZYDTQUUDXCXAYJTQUUEXOYBVIDYJHTVJVKUJVLFYMYQYDTTVMVKVNYGUU
      BYKYTYNXCUUBYKUNZYFXBWTUUFXADYJFVPVOVNVQWFYGYHYRFYGYBBGXDYMXSDXSUFRZPHYDI
      KMYMSZXIXTUUGSZWTXAXBYFVRZWTXAXBYFVSXCYCYBUUGQZYEXCUUKYCXCUUGXHYBXCXSXGUF
      YAVTWAWBWCZXCYCYEWDWGWEYGYLYTYKYNYEYLYTUNXCYCABEFYDOWHWIWJWOYGYHBQZYPYIUN
      XCXMYFUUMXPXMYCYEUUMYBXDXGXHBIYDMXKXIXLWKWLWMABEFYHOWHWPYGYBCGXEYMXSFUUGP
      TYLJLNUUHXJXTUUIUUJXCXQYFXRVNUULXCYEYLCQYCXCBCYDEABCPDEFGHIJKLMNOWNWQWRWG
      WOWS $.
  $}

  ${
    $d A a x y $.  $d B a x y $.  $d C x y $.  $d D a x y $.  $d E x y $.
    $d F a $.  $d G x y $.  $d K a x $.  $d L a x $.  $d R a x y $.
    $d V a x y $.  $d .0. x y $.
    pwssplit4.e $e |- E = ( R ^s ( A u. B ) ) $.
    pwssplit4.g $e |- G = ( Base ` E ) $.
    pwssplit4.z $e |- .0. = ( 0g ` R ) $.
    pwssplit4.k $e |- K = { y e. G | ( y |` A ) = ( A X. { .0. } ) } $.
    pwssplit4.f $e |- F = ( x e. K |-> ( x |` B ) ) $.
    pwssplit4.c $e |- C = ( R ^s A ) $.
    pwssplit4.d $e |- D = ( R ^s B ) $.
    pwssplit4.l $e |- L = ( E |`s K ) $.
    $( Splitting for structure powers 4: maps isomorphically onto the other
       half.  (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    pwssplit4 $p |- ( ( R e. LMod /\ ( A u. B ) e. V /\ ( A i^i B ) = (/) ) ->
          F e. ( L LMIso D ) ) $=
      ( va clmod wcel cun cin c0 wceq w3a clmhm co cbs cfv wf1o clmim cres cmpt
      cv wss csn cxp crab ssrab2 eqsstri resmpt ax-mp eqtr4i clss a1i pwssplit3
      ssun2 eqid syld3an3 c0g cmnd cvv cgrp simp1 lmodgrp 3syl ssun1 ssexg mpan
      grpmnd 3ad2ant2 pws0g syl2anc eqeq2d rabbidv syl5eq ccnv cima fvex eqcomi
      mptiniseg lmhmkerlss syl eqeltrd reslmhm syl5eqel wf1 wi wral wa fvtresfn
      crn eqcomd eqeqan12rd reseq1 eqeq1d elrab2 uneq12 resundi xpundir 3eqtr4g
      adantll adantl wfn simpl1 simp2 adantr simprll pwselbas ffn fnresdm eqtrd
      wf 3adant3 wb mpbird lmhmf pwselbasb uncom fnresdisj uneq12d resundir un0
      mp2b sylanbrc csubg pwslmod lsssubg subg0 3eqtr3d exp32 syl5bi imp sylbid
      ralrimiva cghm lmghm ressbas2 ghmf1 frn biimpa eqeltri fconst mndidcl fss
      snssd incom simp3 fun syl21anc unidm feq23i simpl3 fnconstg eqtr2i resexg
      sylib mpbid fvmptg biimpi 3ad2ant3 syl6eq fnfvelrn eqeltrrd dff1o5 islmim
      ex ssrdv eqssd ) GUDUEZCDUFZMUEZCDUGZUHUIZUJZILFUKULZUEZKFUMUNZIUOZILFUPU
      LUEUWJIAJAUSZDUQZURZKUQZUWKIAKUWPURZUWRSKJUTZUWRUWSUIKBUSZCUQZCNVAZVBZUIZ
      BJVCZJRUXEBJVDVEZAJKUWPVFVGVHUWJUWQHFUKULUEZKHVIUNZUEZUWRUWKUEUWEUWGUWIDU
      WFUTZUXHUXKUWJDCVLZVJAJUWMUWFUWQDGMHFOUAPUWMVMZUWQVMVKVNUWJKUXBEVOUNZUIZB
      JVCZUXIUWJKUXFUXPRUWJUXEUXOBJUWJUXDUXNUXBUWJGVPUEZCVQUEZUXDUXNUIUWJUWEGVR
      UEUXQUWEUWGUWIVSZGVTGWEWAZUWGUWEUXRUWICUWFUTZUWGUXRCDWBZCUWFMWCWDWFGCVQEN
      TQWGWHWIWJWKUWJBJUXBURZHEUKULUEZUXPUXIUEUWEUWGUWIUYAUYDUYAUWJUYBVJBJEUMUN
      ZUWFUYCCGMHEOTPUYEVMUYCVMZVKVNHEUXIUYCUXPUXNUYCWLUXNVAWMZUXPUXNVQUEUYGUXP
      UIEVOWNBJUXBUXNUYCVQUYFWPVGWOUXNVMUXIVMZWQWRWSZLHFUXIUWQKUYHUBWTWHXAZUWJK
      UWMIXBZIXGZUWMUIUWNUWJUYKUCUSZIUNZFVOUNZUIZUYMLVOUNZUIZXCZUCKXDZUWJUYSUCK
      UWJUYMKUEZXEUYPUYMDUQZDUXCVBZUIZUYRVUAUWJUYNVUBUYOVUCAKIDUYMSXFUWJVUCUYOU
      WJUXQDVQUEZVUCUYOUIUXTUWGUWEVUEUWIUXKUWGVUEUXLDUWFMWCWDWFZGDVQFNUAQWGWHXH
      XIUWJVUAVUDUYRXCZVUAUYMJUEZUYMCUQZUXDUIZXEZUWJVUGUXEVUJBUYMJKUXAUYMUIUXBV
      UIUXDUXAUYMCXJXKRXLUWJVUKVUDUYRUWJVUKVUDXEZXEZUYMUWFUQZUWFUXCVBZUYMUYQVUL
      VUNVUOUIZUWJVUJVUDVUPVUHVUJVUDXEVUIVUBUFUXDVUCUFVUNVUOVUIUXDVUBVUCXMUYMCD
      XNCDUXCXOXPXQXRVUMUWFGUMUNZUYMYHUYMUWFXSVUNUYMUIVUMVUQGUWFJUDUYMHMOVUQVMZ
      PUWEUWGUWIVULXTUWJUWGVULUWEUWGUWIYAZYBUWJVUHVUJVUDYCYDUWFVUQUYMYEUWFUYMYF
      WAUWJVUOUYQUIVULUWJVUOHVOUNZUYQUWJUXQUWGVUOVUTUIUXTVUSGUWFMHNOQWGWHUWJKHU
      UAUNUEZVUTUYQUIUWJHUDUEZUXJVVAUWEUWGVVBUWIGUWFMHOUUBYIUYIUXIKHUYHUUCWHKHL
      VUTUBVUTVMUUDWRYGYBUUEUUFUUGUUHUUIUUJUWJUWLILFUUKULUEUYKUYTYJUYJLFIUULUCL
      FUYOIKUWMUYQUWTKLUMUNZUIUXGKJLHUBPUUMVGZUXMUYQVMUYOVMUUNWAYKUWJUYLUWMUWJU
      WLVVCUWMIYHUYLUWMUTUYJVVCUWMLFIVVCVMUXMYLVVCUWMIUUOWAUWJUCUWMUYLUWJUYMUWM
      UEZUYMUYLUEUWJVVEXEZUYMUXDUFZIUNZUYMUYLVVFVVHVVGDUQZUYMVVFVVGKUEZVVIVQUEZ
      VVHVVIUIVVFVVGJUEZVVGCUQZUXDUIZVVJVVFVVLUWFVUQVVGYHZVVFDCUFZVUQVUQUFZVVGY
      HZVVOVVFDVUQUYMYHZCVUQUXDYHZDCUGZUHUIZVVRUWJVVEVVSUWJUWEVUEVVEVVSYJUXSVUF
      VUQGDUWMUDUYMFVQUAVURUXMYMWHUUPZVVFCUXCUXDYHZUXCVUQUTVVTVWDVVFCNNGVOUNVQQ
      GVOWNUUQZUURZVJVVFNVUQVVFUXQNVUQUEUWJUXQVVEUXTYBVUQGNVURQUUSWRUVACUXCVUQU
      XDUUTWHUWJVWBVVEUWJVWAUWHUHDCUVBZUWEUWGUWIUVCWKYBDCVUQVUQUYMUXDUVDUVEVVPV
      VQUWFVUQVVGDCYNVUQUVFUVGUVLUWJVVLVVOYJZVVEUWEUWGVWHUWIVUQGUWFJUDVVGHMOVUR
      PYMYIYBYKVVFVUIUXDCUQZUFUHUXDUFZVVMUXDVVFVUIUHVWIUXDVVFVWBVUIUHUIZVVFVWAU
      WHUHVWGUWEUWGUWIVVEUVHWKVVFVVSUYMDXSZVWBVWKYJVWCDVUQUYMYEZDCUYMYOWAUVMVWI
      UXDUIZVVFNVQUEUXDCXSZVWNVWECNVQUVICUXDYFYSVJYPUYMUXDCYQVWJUXDUHUFUXDUHUXD
      YNUXDYRUVJXPUXEVVNBVVGJKUXAVVGUIUXBVVMUXDUXAVVGCXJXKRXLYTZVVFVVJVVKVWPVVG
      DKUVKWRAVVGUWPVVIKVQIUWOVVGDXJSUVNWHVVFVVIVUBUXDDUQZUFZUYMUYMUXDDYQVVFVWR
      UYMUHUFUYMVVFVUBUYMVWQUHVVFVVSVWLVUBUYMUIVWCVWMDUYMYFWAUWJVWQUHUIZVVEUWIU
      WEVWSUWGUWIVWSVWDVWOUWIVWSYJVWFCUXCUXDYECDUXDYOYSUVOUVPYBYPUYMYRUVQWKYGVV
      FIKXSZVVJVVHUYLUEUWJVWTVVEUWJUWLKUWMIYHVWTUYJKUWMLFIVVDUXMYLKUWMIYEWAYBVW
      PKVVGIUVRWHUVSUWBUWCUWDKUWMIUVTYTKUWMLFIVVDUXMUWAYT $.
  $}

  ${
    $d B a b $.  $d W a b $.
    filnm.b $e |- B = ( Base ` W ) $.
    $( Finite left modules are Noetherian.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    filnm $p |- ( ( W e. LMod /\ B e. Fin ) -> W e. LNoeM ) $=
      ( va vb clmod wcel cfn wa cv clspn cfv wceq cpw cin wrex syl2anc sylanbrc
      clss eqid wral clnm simpl lssss adantl elpw sylibr simplr ssfi elin lspid
      wss vex adantlr eqcomd weq fveq2 eqeq2d rspcev ralrimiva islnm2 ) BFGZAHG
      ZIZVBDJZEJZBKLZLZMZEANZHOZPZDBSLZUABUBGVBVCUCVDVLDVMVDVEVMGZIZVEVKGZVEVEV
      GLZMZVLVOVEVJGZVEHGZVPVOVEAULZVSVNWAVDVMVEABCVMTZUDUEZVEADUMUFUGVOVCWAVTV
      BVCVNUHWCAVEUIQVEVJHUJRVOVQVEVBVNVQVEMVCVMVEVGBWBVGTZUKUNUOVIVREVEVKEDUPV
      HVQVEVFVEVGUQURUSQUTAVMEDBVGCWBWDVAR $.
  $}

  ${
    pwslnmlem0.y $e |- Y = ( W ^s (/) ) $.
    $( Zeroeth powers are Noetherian.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    pwslnmlem0 $p |- ( W e. LMod -> Y e. LNoeM ) $=
      ( clmod wcel cbs cfv cfn clnm cvv 0ex pwslmod mpan2 cmap wceq eqid pwsbas
      c0 co c1o csn fvex map0e ax-mp df1o2 eqtri snfi eqeltri syl6eqelr syl2anc
      filnm ) ADEZBDEZBFGZHEBIEULRJEZUMKARJBCLMULUNAFGZRNSZHULUOUQUNOKUPARDJBCU
      PPQMUQRUAZHUQTURUPJEUQTOAFUBUPJUCUDUEUFRUGUHUIUNBUNPUKUJ $.
  $}

  ${
    $d Y x $.  $d W i x $.
    pwslnmlem1.y $e |- Y = ( W ^s { i } ) $.
    $( First powers are Noetherian.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    pwslnmlem1 $p |- ( W e. LNoeM -> Y e. LNoeM ) $=
      ( vx clnm wcel cbs cfv cv csn cxp cmpt clmhm co crn wceq clmod cvv eqid
      lnmlmod snex pwsdiaglmhm sylancl id wf1o wfo vex pwssnf1o mpan2 forn 3syl
      f1ofo lnmepi syl3anc ) BFGZEBHIZAJZKZEJKLMZBCNOGZUPUTPCHIZQZCFGUPBRGUSSGV
      ABUAURUBEUQBUTUSSCDUQTZUTTZUCUDUPUEUPUQVBUTUFZUQVBUTUGVCUPURSGVFAUHEUQVBB
      UTURFSCDVDVEVBTZUIUJUQVBUTUMUQVBUTUKULVBBCUTVGUNUO $.
  $}

  ${
    $d X x y $.  $d A x y $.  $d W x y $.  $d Z x y $.  $d B x y $.
    $d Y x y $.  $d ph x y $.
    pwslnmlem2.a $e |- A e. _V $.
    pwslnmlem2.b $e |- B e. _V $.
    pwslnmlem2.x $e |- X = ( W ^s A ) $.
    pwslnmlem2.y $e |- Y = ( W ^s B ) $.
    pwslnmlem2.z $e |- Z = ( W ^s ( A u. B ) ) $.
    pwslnmlem2.w $e |- ( ph -> W e. LMod ) $.
    pwslnmlem2.dj $e |- ( ph -> ( A i^i B ) = (/) ) $.
    pwslnmlem2.xn $e |- ( ph -> X e. LNoeM ) $.
    pwslnmlem2.yn $e |- ( ph -> Y e. LNoeM ) $.
    $( A sum of powers is Noetherian.  (Contributed by Stefan O'Rear,
       25-Jan-2015.) $)
    pwslnmlem2 $p |- ( ph -> Z e. LNoeM ) $=
      ( vx wcel clnm eqid vy cbs cfv cv cres cmpt clmhm ccnv c0g csn cima cress
      crn clmod cun cvv wss unex a1i ssun1 pwssplit3 syl3anc cxp wceq crab fvex
      mptiniseg ax-mp cmnd cgrp lmodgrp grpmnd 3syl pws0g sylancl eqcomd eqeq2d
      co rabbidv syl5eq oveq2d clmim clmic wbr wb cin pwssplit4 brlmici lnmlmic
      c0 mpbird eqeltrd wfo pwssplit1 forn syl ressid eqtrd lmhmlnmsplit ) AQGU
      BUCZQUDBUEZUFZGEUGVRRZGXBUHEUIUCZUJUKZULVRZSREXBUMZULVRZSRGSRADUNRZBCUOZU
      PRZBXJUQZXCMXKABCHIURUSZXLABCUTUSZQWTEUBUCZXJXBBDUPGELJWTTZXOTZXBTZVAVBAX
      FGXABDUIUCZUJVCZVDZQWTVEZULVRZSAXEYBGULAXEXAXDVDZQWTVEZYBXDUPRXEYEVDEUIVF
      QWTXAXDXBUPXRVGVHAYDYAQWTAXDXTXAAXTXDADVIRZBUPRXTXDVDAXIDVJRYFMDVKDVLVMZH
      DBUPEXSJXSTZVNVOVPVQVSVTWAAYCSRZFSRZPAUAYBUAUDCUEUFZYCFWBVRRZYCFWCWDYIYJW
      EAXIXKBCWFWJVDYLMXMNUAQBCEFDGYKWTYBYCUPXSLXPYHYBTYKTJKYCTWGVBYCFYKWHYCFWI
      VMWKWLAXHESAXHEXOULVRZEAXGXOEULAWTXOXBWMZXGXOVDAYFXKXLYNYGXMXNQWTXOXJXBBD
      UPGELJXPXQXRWNVBWTXOXBWOWPWAAESRYMEVDOXOESXQWQWPWROWLGEXFXBXEXHXDXDTXETXF
      TXHTWSVB $.
  $}

  ${
    $d W a b c $.  $d I a b c $.
    pwslnm.y $e |- Y = ( W ^s I ) $.
    $( Finite powers of Noetherian modules are Noetherian.  (Contributed by
       Stefan O'Rear, 24-Jan-2015.) $)
    pwslnm $p |- ( ( W e. LNoeM /\ I e. Fin ) -> Y e. LNoeM ) $=
      ( va vb vc clnm wcel wa cpws co cv wi c0 wceq oveq2 eleq1d imbi2d eqid wn
      cfn csn cun weq clmod lnmlmod pwslnmlem0 syl wel vex snex ad2antrl disjsn
      cin biimpri ad2antlr simprr pwslnmlem1 pwslnmlem2 exp32 findcard2s impcom
      a2d syl5eqel ) BHIZAUBIZJCBAKLZHDVGVFVHHIZVFBEMZKLZHIZNVFBOKLZHIZNVFBFMZK
      LZHIZNVFBVOGMZUCZUDZKLZHIZNVFVINEFGAVJOPZVLVNVFWCVKVMHVJOBKQRSEFUEZVLVQVF
      WDVKVPHVJVOBKQRSVJVTPZVLWBVFWEVKWAHVJVTBKQRSVJAPZVLVIVFWFVKVHHVJABKQRSVFB
      UFIZVNBUGZBVMVMTUHUIVOUBIZGFUJUAZJZVFVQWBWKVFVQWBWKVFVQJZJVOVSBVPBVSKLZWA
      FUKVRULVPTWMTZWATVFWGWKVQWHUMWJVOVSUOOPZWIWLWOWJVOVRUNUPUQWKVFVQURVFWMHIW
      KVQGBWMWNUSUMUTVAVDVBVCVE $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Direct sum of left modules
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c (+)m $.

  $( Class of module direct sum generator. $)
  cdsmm $a class (+)m $.

  ${
    $d s r f x $.
    $( The direct sum of a family of Abelian groups or left modules is the
       induced group structure on finite linear combinations of elements, here
       represented as functions with finite support.  (Contributed by Stefan
       O'Rear, 7-Jan-2015.) $)
    df-dsmm $a |- (+)m = ( s e. _V , r e. _V |-> ( ( s Xs_ r ) |`s
        { f e. X_ x e. dom r ( Base ` ( r ` x ) ) |
          { x e. dom r | ( f ` x ) =/= ( 0g ` ( r ` x ) ) } e. Fin } ) ) $.
  $}

  ${
    $d S s r f x $.  $d R s r f x $.  $d B s r $.
    $( The direct sum is a well-behaved binary operator.  (Contributed by
       Stefan O'Rear, 7-Jan-2015.) $)
    reldmdsmm $p |- Rel dom (+)m $=
      ( vs vr vx vf cvv cv cprds cfv c0g wne cdm crab cfn wcel cixp cress cdsmm
      co cbs df-dsmm reldmmpt2 ) ABEEAFBFZGRCFZDFHUCUBHZIHJCUBKZLMNDCUEUDSHOLPR
      QCDABTUA $.

    dsmmval.b $e |- B = { f e. ( Base ` ( S Xs_ R ) ) |
        { x e. dom R | ( f ` x ) =/= ( 0g ` ( R ` x ) ) } e. Fin } $.
    $( Value of the module direct sum.  (Contributed by Stefan O'Rear,
       7-Jan-2015.) $)
    dsmmval $p |- ( R e. V -> ( S (+)m R ) = ( ( S Xs_ R ) |`s B ) ) $=
      ( vs vr wcel cvv cdsmm co cprds cress wceq cv cfv crab cbs c0g wne cdm wa
      elex cfn cixp oveq12 eqid vex a1i eqidd prdsbas fveq2d eqtr3d simpr dmeqd
      fveq1d neeq2d rabeqbidv eleq1d syl6eqr oveq12d df-dsmm ovex ovmpt2a wn c0
      reldmdsmm ovprc1 ress0 reldmprds oveq1d eqtr4d adantr pm2.61ian syl ) CFJ
      CKJZDCLMZDCNMZBOMZPZCFUEDKJZVRWBHIDCKKHQZIQZNMZAQZEQRZWGWERZUARZUBZAWEUCZ
      SZUFJZEAWLWITRUGZSZOMWALWDDPZWECPZUDZWFVTWPBOWDDWECNUHZWSWPWHWGCRZUARZUBZ
      ACUCZSZUFJZEVTTRZSBWSWNXFEWOXGWSWFTRZWOXGWSAXHWFWEWDWLKKWFUIWDKJWSHUJUKWE
      KJWSIUJUKXHUIWSWLULUMWSWFVTTWTUNUOWSWMXEUFWSWKXCAWLXDWSWECWQWRUPZUQWSWJXB
      WHWSWIXAUAWSWGWECXIURUNUSUTVAUTGVBVCAEHIVDVTBOVEVFWCVGZWBVRXJVSVHBOMZWAXJ
      VSVHXKDCLVIVJBVKVBXJVTVHBODCNVLVJVMVNVOVPVQ $.

    $( Base set of the module direct sum.  (Contributed by Stefan O'Rear,
       7-Jan-2015.) $)
    dsmmbase $p |- ( R e. V -> B = ( Base ` ( S (+)m R ) ) ) $=
      ( wcel cvv cdsmm co cbs cfv wceq elex cprds cress cv crab eqid fveq2d wss
      dsmmval c0g wne cdm cfn ssrab2 eqsstri ressbas2 ax-mp syl6reqr syl ) CFHC
      IHZBDCJKZLMZNCFOUNUPDCPKZBQKZLMZBUNUOURLABCDEIGUCUABUQLMZUBBUSNBARZERMVAC
      MUDMUEACUFSUGHZEUTSUTGVBEUTUHUIBUTURUQURTUTTUJUKULUM $.
  $}

  ${
    $d S s r f x $.  $d R s r f x $.  $d B s r $.
    dsmmval2.b $e |- B = ( Base ` ( S (+)m R ) ) $.
    $( Self-referential definition of the module direct sum.  (Contributed by
       Stefan O'Rear, 7-Jan-2015.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    dsmmval2 $p |- ( S (+)m R ) = ( ( S Xs_ R ) |`s B ) $=
      ( vx vf cdsmm co cprds cbs cfv cress cvv wcel wceq cv crab eqid oveq2i c0
      c0g wne cdm cfn ssrab2 ressbas2 ax-mp dsmmval fveq2d oveq2d 3eqtr4a ress0
      wss wn eqcomi reldmdsmm ovprc2 reldmprds oveq1d pm2.61i eqtr4i ) CBGHZCBI
      HZVBJKZLHZVCALHBMNZVBVEOVFVCEPZFPKVGBKUAKUBEBUCQUDNZFVCJKZQZLHZVCVKJKZLHV
      BVEVJVLVCLVJVIUMVJVLOVHFVIUEVJVIVKVCVKRVIRUFUGSEVJBCFMVJRUHZVFVDVLVCLVFVB
      VKJVMUIUJUKVFUNZTTVDLHZVBVEVOTVDULUOCBGUPUQVNVCTVDLCBIURUQUSUKUTAVDVCLDSV
      A $.
  $}

  ${
    $d S f x $.  $d R f x $.  $d P f x $.  $d I f x $.  $d V f x $.
    dsmmbas2.p $e |- P = ( S Xs_ R ) $.
    dsmmbas2.b $e |- B = { f e. ( Base ` P ) |
        dom ( f \ ( 0g o. R ) ) e. Fin } $.
    $( Base set of the direct sum module using the ~ fndmin abbreviation.
       (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    dsmmbas2 $p |- ( ( R Fn I /\ I e. V ) -> B = ( Base ` ( S (+)m R ) ) ) $=
      ( vx wfn wcel wa c0g cbs cfv crab wceq cvv c0 ccom cdif cdm cfn cdsmm wne
      cv co cprds fveq2i rabeq ax-mp simpll fvco2 sylan neeq2d rabbidva eqid wn
      noel reldmprds ovprc1 fveq2d base0 syl6eqr eleq2d mtbiri adantl prdsbasfn
      con4i simplr simpr wf fn0g dffn2 mpbi biimpi fco sylancr ffn syl ad2antrr
      fndmdif syl2anc fndm 3eqtr4d eleq1d syl5eq fnex dsmmbase eqtrd ) CFKZFGLZ
      MZAEUGZNCUAZUBUCZUDLZEBOPZQZDCUEUHOPZIWNWTJUGZWOPZXBCPNPZUFZJCUCZQZUDLZED
      CUIUHZOPZQZXAWNWTWREXJQZXKWSXJRWTXLRBXIOHUJWREWSXJUKULWNWRXHEXJWNWOXJLZMZ
      WQXGUDXNXCXBWPPZUFZJFQZXEJFQZWQXGXNXPXEJFXNXBFLZMXOXDXCXNWLXSXOXDRWLWMXMU
      MZFNCXBUNUOUPUQXNWOFKWPFKZWQXQRXNXJCDWOFSGXIXIURXJURXMDSLZWNYBXMYBUSZXMWO
      TLWOUTYCXJTWOYCXJTOPTYCXITODCUIVAVBVCVDVEVFVGVJVHWLWMXMVKXTWNXMVLVIWLYAWM
      XMWLFSWPVMZYAWLSSNVMZFSCVMZYDNSKYEVNSNVOVPWLYFFCVOVQFSSNCVRVSFSWPVTWAWBJF
      WOWPWCWDWLXGXRRZWMXMWLXFFRYGFCWEXEJXFFUKWAWBWFWGUQWHWNCSLXKXARFGCWIJXKCDE
      SXKURWJWAWKWH $.
  $}

  ${
    $d S f x $.  $d R f x $.  $d P f x $.  $d I f x $.  $d V f x $.

    $( For finite products, the direct sum is just the module product.
       (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    dsmmfi $p |- ( ( R Fn I /\ I e. Fin ) -> ( S (+)m R ) = ( S Xs_ R ) ) $=
      ( vf wfn cfn wcel wa co cprds cbs cfv cress eqid cdm wceq wss cvv ax-mp
      c0 cdsmm dsmmval2 cv c0g ccom cdif crab wral noel reldmprds ovprc1 fveq2d
      wn base0 syl6eqr eleq2d mtbiri con4i adantl simplr simpll simpr prdsbasfn
      fndm syl eqeltrd difss dmss ssfi sylancl ralrimiva rabid2 sylibr dsmmbas2
      eqtr2d oveq2d ovex ressid syl6eq syl5eq ) ACEZCFGZHZBAUAIZBAJIZWDKLZMIZWE
      WFABWFNUBWCWGWEWEKLZMIZWEWCWFWHWEMWCWHDUCZUDAUEZUFZOZFGZDWHUGZWFWCWNDWHUH
      WHWOPWCWNDWHWCWJWHGZHZWJOZFGWMWRQZWNWQWRCFWQWJCEWRCPWQWHABWJCRFWEWENZWHNZ
      WPBRGZWCXBWPXBUMZWPWJTGWJUIXCWHTWJXCWHTKLTXCWETKBAJUJUKULUNUOUPUQURUSWAWB
      WPUTZWAWBWPVAWCWPVBVCCWJVDVEXDVFWLWJQWSWJWKVGWLWJVHSWRWMVIVJVKWNDWHVLVMWO
      WEABDCFWTWONVNVOVPWERGWIWEPBAJVQWHWERXAVRSVSVT $.
  $}

  ${
    $d S a b $.  $d R a b $.  $d X a b $.  $d I a b $.
    dsmmelbas.p $e |- P = ( S Xs_ R ) $.
    dsmmelbas.c $e |- C = ( S (+)m R ) $.
    dsmmelbas.b $e |- B = ( Base ` P ) $.
    dsmmelbas.h $e |- H = ( Base ` C ) $.
    dsmmelbas.i $e |- ( ph -> I e. V ) $.
    dsmmelbas.r $e |- ( ph -> R Fn I ) $.
    $( Membership in the finitely supported hull of a structure product in
       terms of the index set.  (Contributed by Stefan O'Rear, 11-Jan-2015.) $)
    dsmmelbas $p |- ( ph -> ( X e. H <-> ( X e. B /\ { a e. I |
          ( X ` a ) =/= ( 0g ` ( R ` a ) ) } e. Fin ) ) ) $=
      ( wcel cfv cbs vb cv c0g wne cdm crab cfn cprds co wa cdsmm cvv wceq fnex
      wfn syl2anc eqid dsmmbase syl fveq2i eqtri syl6reqr eleq2d neeq1d rabbidv
      fveq1 eleq1d elrab eqtr2i eleq2i a1i fndm rabeq 3syl anbi12d syl5bb bitrd
      wb ) AJGRJKUBZUAUBZSZVSESUCSZUDZKEUEZUFZUGRZUAFEUHUIZTSZUFZRZJBRZVSJSZWBU
      DZKHUFZUGRZUJZAGWIJAWIFEUKUIZTSZGAEULRZWIWRUMAEHUOZHIRWSQPHIEUNUPKWIEFUAU
      LWIUQURUSGCTSWROCWQTMUTVAVBVCWJJWHRZWMKWDUFZUGRZUJAWPWFXCUAJWHVTJUMZWEXBU
      GXDWCWMKWDXDWAWLWBVSVTJVFVDVEVGVHAXAWKXCWOXAWKVRAWHBJBDTSWHNDWGTLUTVIVJVK
      AXBWNUGAWTWDHUMXBWNUMQHEVLWMKWDHVMVNVGVOVPVQ $.
  $}

  ${
    $d ph a b $.  $d P a b $.  $d S a b $.  $d R a b $.  $d .0. a b $.
    $d .+ a b $.  $d J a b $.  $d K a b $.  $d I a $.
    dsmmcl.p $e |- P = ( S Xs_ R ) $.
    dsmmcl.h $e |- H = ( Base ` ( S (+)m R ) ) $.
    dsmmcl.i $e |- ( ph -> I e. W ) $.
    dsmmcl.s $e |- ( ph -> S e. V ) $.
    dsmmcl.r $e |- ( ph -> R : I --> Mnd ) $.
    ${
      dsmm0cl.z $e |- .0. = ( 0g ` P ) $.
      $( The all-zero vector is contained in the finite hull, since its support
         is empty and therefore finite.  This theorem along with the next one
         effectively proves that the finite hull is a "submonoid", although
         that does not exist as a defined concept yet.  (Contributed by Stefan
         O'Rear, 11-Jan-2015.) $)
      dsmm0cl $p |- ( ph -> .0. e. H ) $=
        ( va wcel cfv c0g wceq cbs cv wne crab cfn cmnd prdsmndd mndidcl syl c0
        eqid wn wral wa ccom prds0g syl6eqr adantr fveq1d wf fvco2 sylan eqtr3d
        wfn ffn sylibr ralrimiva rabeq0 0fin syl6eqel cdsmm dsmmelbas mpbir2and
        nne co ) AIEQIBUARZQZPUBZIRZVRCRSRZUCZPFUDZUEQABUFQVQACDFGHBJLMNUGVPBIV
        PUKZOUHUIAWBUJUEAWAULZPFUMWBUJTAWDPFAVRFQZUNZVSVTTWDWFVRSCUOZRZVSVTWFVR
        WGIAWGITWEAWGBSRIACDFGHBJLMNUPOUQURUSACFVDZWEWHVTTAFUFCUTWINFUFCVEUIZFS
        CVRVAVBVCVSVTVNVFVGWAPFVHVFVIVJAVPDCVKVOZBCDEFHIPJWKUKWCKLWJVLVM $.
    $}

    ${
      dsmmacl.j $e |- ( ph -> J e. H ) $.
      dsmmacl.k $e |- ( ph -> K e. H ) $.
      dsmmacl.a $e |- .+ = ( +g ` P ) $.
      $( The finite hull is closed under addition.  (Contributed by Stefan
         O'Rear, 11-Jan-2015.) $)
      dsmmacl $p |- ( ph -> ( J .+ K ) e. H ) $=
        ( wcel va co cbs cfv cv c0g wne crab cfn eqid wa cdsmm cmnd wfn ffn syl
        wf dsmmelbas mpbid simpld prdsplusgcl cplusg adantr simpr prdsplusgfval
        neeq1d rabbidva cun wss simprd unfi syl2anc wceq neorian bicomi con1bii
        wo wn ffvelrnda mndidcl mndlid oveq12 eqeq1d syl5ibrcom syl5bi necon1ad
        ss2rabdv unrab syl6sseqr ssfi eqeltrd mpbir2and ) AHICUBZFTWMBUCUDZTUAU
        EZWMUDZWODUDZUFUDZUGZUAGUHZUITAWNCDEHIGJKBLWNUJZSONPAHWNTZWOHUDZWRUGZUA
        GUHZUITZAHFTXBXFUKQAWNEDULUBZBDEFGKHUALXGUJZXAMNAGUMDUQDGUNZPGUMDUOUPZU
        RUSZUTZAIWNTZWOIUDZWRUGZUAGUHZUITZAIFTXMXQUKRAWNXGBDEFGKIUALXHXAMNXJURU
        SZUTZVAAWTXCXNWQVBUDZUBZWRUGZUAGUHZUIAWSYBUAGAWOGTZUKZWPYAWRYEWNCDEHIGW
        OJKBLXAAEJTYDOVCAGKTYDNVCAXIYDXJVCAXBYDXLVCAXMYDXSVCSAYDVDVEVFVGAXEXPVH
        ZUITZYCYFVIYCUITAXFXQYGAXBXFXKVJAXMXQXRVJXEXPVKVLAYCXDXOVQZUAGUHYFAYBYH
        UAGYEYHYAWRYHVRXCWRVMXNWRVMUKZYEYAWRVMZYIYHYHYIVRXCWRXNWRVNVOVPYEYJYIWR
        WRXTUBZWRVMZYEWQUMTZWRWQUCUDZTZYLAGUMWODPVSZYEYMYOYPYNWQWRYNUJZWRUJZVTU
        PYNXTWQWRWRYQXTUJYRWAVLYIYAYKWRXCWRXNWRXTWBWCWDWEWFWGXDXOUAGWHWIYFYCWJV
        LWKAWNXGBDEFGKWMUALXHXAMNXJURWL $.
    $}
  $}

  ${
    $d x S $.  $d x R $.  $d x X $.  $d x Y $.  $d x I $.  $d x B $.
    $d ph x $.  $d J x $.
    prdsinvgd2.y $e |- Y = ( S Xs_ R ) $.
    prdsinvgd2.i $e |- ( ph -> I e. W ) $.
    prdsinvgd2.s $e |- ( ph -> S e. V ) $.
    prdsinvgd2.r $e |- ( ph -> R : I --> Grp ) $.
    prdsinvgd2.b $e |- B = ( Base ` Y ) $.
    prdsinvgd2.n $e |- N = ( invg ` Y ) $.
    prdsinvgd2.x $e |- ( ph -> X e. B ) $.
    prdsinvgd2.j $e |- ( ph -> J e. I ) $.
    $( Negation of a single coordinate in a structure product.  (Contributed by
       Stefan O'Rear, 11-Jan-2015.) $)
    prdsinvgd2 $p |- ( ph -> ( ( N ` X ) ` J ) =
        ( ( invg ` ( R ` J ) ) ` ( X ` J ) ) ) $=
      ( cfv vx cminusg cmpt prdsinvgd fveq1d wcel wceq fveq2d fveq12d eqid fvex
      cv fveq2 fvmpt syl eqtrd ) AFJGTZTFUAEUAULZJTZURCTZUBTZTZUCZTZFJTZFCTZUBT
      ZTZAFUQVCAUABCDEGHIJKLMNOPQRUDUEAFEUFVDVHUGSUAFVBVHEVCURFUGZUSVEVAVGVIUTV
      FUBURFCUMUHURFJUMUIVCUJVEVGUKUNUOUP $.
  $}

  ${
    $d H a b $.  $d P a b $.  $d S a b $.  $d R a b $.  $d I b $.  $d ph a b $.
    dsmmsubg.p $e |- P = ( S Xs_ R ) $.
    dsmmsubg.h $e |- H = ( Base ` ( S (+)m R ) ) $.
    dsmmsubg.i $e |- ( ph -> I e. W ) $.
    dsmmsubg.s $e |- ( ph -> S e. V ) $.
    dsmmsubg.r $e |- ( ph -> R : I --> Grp ) $.
    $( The finite hull of a product of groups is additionally closed under
       negation and thus is a subgroup of the product.  (Contributed by Stefan
       O'Rear, 11-Jan-2015.) $)
    dsmmsubg $p |- ( ph -> H e. ( SubGrp ` P ) ) $=
      ( va vb cfv wcel wceq cgrp eqid cplusg cress co c0g eqidd cdsmm cbs cprds
      cv wne cdm crab cfn cvv fex syl2anc dsmmbase syl ssrab2 syl6eqssr 3sstr4g
      fveq2i cmnd wss grpmnd ssriv fss sylancl dsmm0cl w3a 3ad2ant1 simp2 simp3
      wf dsmmacl wa cminusg prdsgrpd adantr sselda grpinvcl simpr wfn dsmmelbas
      mpbid simprd ad2antrr prdsinvgd2 adantrr fveq2 ad2antll ffvelrnda adantlr
      ffn grpinvid 3eqtrd expr necon3d ss2rabdv ssfi mpbir2and issubgrpd2 ) ANO
      EBUAPZBEUBUCZBBUDPZAXDUEAXEUEAXCUEADCUFUCZUGPZDCUHUCZUGPZEBUGPZAXGOUIZNUI
      ZPZXKCPZUDPZUJZOCUKULUMQZNXIULZXIACUNQZXRXGRAFSCVNZFHQZXSMKFSHCUOUPOXRCDN
      UNXRTUQURXQNXIUSUTJBXHUGIVBVAZABCDEFGHXEIJKLAXTSVCVDFVCCVNZMNSVCXLVEVFFSV
      CCVGVHZXETVIAXLEQZXKEQZVJBXCCDEFXLXKGHIJAYEYAYFKVKAYEDGQZYFLVKAYEYCYFYDVK
      AYEYFVLAYEYFVMXCTVOAYEVPZXLBVQPZPZEQYJXJQZXKYJPZXOUJZOFULZUMQZYHBSQZXLXJQ
      ZYKAYPYEACDFGHBIKLMVRZVSAEXJXLYBVTZXJBYIXLXJTZYITZWAUPYHXPOFULZUMQZYNUUBV
      DYOYHYQUUCYHYEYQUUCVPAYEWBYHXJXFBCDEFHXLOIXFTZYTJAYAYEKVSZACFWCZYEAXTUUFM
      FSCWNURVSZWDWEWFYHYMXPOFYHXKFQZVPZXMXOYLXOYHUUHXMXORZYLXORYHUUHUUJVPVPYLX
      MXNVQPZPZXOUUKPZXOYHUUHYLUULRUUJUUIXJCDFXKYIGHXLBIAYAYEUUHKWGAYGYEUUHLWGA
      XTYEUUHMWGYTUUAYHYQUUHYSVSYHUUHWBWHWIUUJUULUUMRYHUUHXMXOUUKWJWKYHUUHUUMXO
      RZUUJUUIXNSQZUUNAUUHUUOYEAFSXKCMWLWMXNUUKXOXOTUUKTWOURWIWPWQWRWSUUBYNWTUP
      YHXJXFBCDEFHYJOIUUDYTJUUEUUGWDXAYRXB $.
  $}

  ${
    $d ph a b x $.  $d S a b x $.  $d R a b x $.  $d I a b x $.  $d P a b x $.
    $d U a b $.  $d H a b x $.
    dsmmlss.i $e |- ( ph -> I e. W ) $.
    dsmmlss.s $e |- ( ph -> S e. Ring ) $.
    dsmmlss.r $e |- ( ph -> R : I --> LMod ) $.
    dsmmlss.k $e |- ( ( ph /\ x e. I ) -> ( Scalar ` ( R ` x ) ) = S ) $.

    ${
      dsmmlss.p $e |- P = ( S Xs_ R ) $.
      dsmmlss.u $e |- U = ( LSubSp ` P ) $.
      dsmmlss.h $e |- H = ( Base ` ( S (+)m R ) ) $.
      $( The finite hull of a product of modules is additionally closed under
         scalar multiplication and thus is a linear subspace of the product.
         (Contributed by Stefan O'Rear, 11-Jan-2015.) $)
      dsmmlss $p |- ( ph -> H e. U ) $=
        ( wcel cfv clmod eqid va vb csubg cv cvsca co wral csca cbs crg wf cgrp
        wss lmodgrp ssriv fss sylancl dsmmsubg wa c0g wne crab prdslmodd adantr
        cfn simprl simprr wb cdsmm wfn ffn syl dsmmelbas mpbid lmodvscl syl3anc
        simpld simprd wceq ad2antrr cvv fex syl2anc prdssca fveq2d eleq2d simpr
        biimpar adantrr prdsvscafval ffvelrnda adantlr simplrl eleqtrrd lmodvs0
        eqtrd oveq2 eqeq1d syl5ibrcom impr expr necon3d ss2rabdv ssfi mpbir2and
        ralrimivva islss4 ) AGFQZGCUCRQZUAUDZUBUDZCUERZUFZGQZUBGUGUACUHRZUIRZUG
        ZACDEGHUJINPJKAHSDUKZSULUMHULDUKLUASULXJUNUOHSULDUPUQURAXNUAUBXPGAXJXPQ
        ZXKGQZUSZUSZXNXMCUIRZQZBUDZXMRZYEDRZUTRZVAZBHVBZVEQZYBCSQZXSXKYCQZYDAYL
        YAABDEHICNKJLMVCZVDAXSXTVFYBYMYEXKRZYHVAZBHVBZVEQZYBXTYMYRUSZAXSXTVGAXT
        YSVHYAAYCEDVIUFZCDEGHIXKBNYTTZYCTZPJAXRDHVJZLHSDVKVLZVMVDVNZVQZXJXLXOXP
        YCCXKUUBXOTZXLTZXPTZVOVPYBYRYJYQUMYKYBYMYRUUEVRYBYIYPBHYBYEHQZUSZYOYHYF
        YHYBUUJYOYHVSZYFYHVSYBUUJUULUSUSYFXJYOYGUERZUFZYHYBUUJYFUUNVSUULUUKYCDE
        XLXJXKHYEEUIRZUJICNUUBUUHUUOTAEUJQYAUUJKVTAHIQZYAUUJJVTAUUCYAUUJUUDVTYB
        XJUUOQZUUJAXSUUQXTAUUQXSAUUOXPXJAEXOUIACDEUJWANKAXRUUPDWAQLJHSIDWBWCWDZ
        WEWFWHWIVDYBYMUUJUUFVDYBUUJWGWJWIYBUUJUULUUNYHVSZUUKUUSUULXJYHUUMUFZYHV
        SZUUKYGSQZXJYGUHRZUIRZQUVAAUUJUVBYAAHSYEDLWKWLUUKXJXPUVDAXSXTUUJWMAUUJU
        VDXPVSYAAUUJUSZUVCXOUIUVEUVCEXOMAEXOVSUUJUURVDWPWEWLWNUUMUVCUVDYGXJYHUV
        CTUUMTUVDTYHTWOWCUULUUNUUTYHYOYHXJUUMWQWRWSWTWPXAXBXCYQYJXDWCAXNYDYKUSV
        HYAAYCYTCDEGHIXMBNUUAUUBPJUUDVMVDXEXFAYLXHXIXQUSVHYNXPFXLGXOYCCUAUBUUGU
        UIUUBUUHOXGVLXE $.
    $}

    ${
      dsmmlmod.c $e |- C = ( S (+)m R ) $.
      $( The direct sum of a family of modules is a module.  (Contributed by
         Stefan O'Rear, 11-Jan-2015.) $)
      dsmmlmod $p |- ( ph -> C e. LMod ) $=
        ( cprds co clmod wcel cdsmm cbs cfv eqid prdslmodd cress dsmmval2 eqtri
        clss dsmmlss lsslmod syl2anc ) AEDMNZOPEDQNZRSZUIUESZPCOPABDEFGUIUITZIH
        JKUAABUIDEULUKFGHIJKUMULTZUKTZUFULUKUICCUJUIUKUBNLUKDEUOUCUDUNUGUH $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Free modules
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c freeLMod unitVec $.

  $( Class of free module generator. $)
  cfrlm $a class freeLMod $.

  $( Class of basic unit vectors for an explicit free module. $)
  cuvc $a class unitVec $.

  ${
    $d r i j k $.

    $( The ` i ` -dimensional free module over a ring ` r ` is the product of
       ` i ` -many copies of the ring with componentwise addition and
       multiplication.  If ` i ` is infinite, the allowed vectors are
       restricted to those with finitely many nonzero coordinates; this ensures
       that the resulting module is actually spanned by its unit vectors.
       (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    df-frlm $a |- freeLMod = ( r e. _V , i e. _V |->
        ( r (+)m ( i X. { ( ringLMod ` r ) } ) ) ) $.

    $( ` ( ( R unitVec I ) `` i ) ` is the unit vector in ` ( R freeLMod I ) `
       along the ` i ` axis.  (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
    df-uvc $a |- unitVec = ( r e. _V , i e. _V |-> ( j e. i |->
        ( k e. i |-> if ( k = j , ( 1r ` r ) , ( 0g ` r ) ) ) ) ) $.
  $}

  ${
    $d R r i $.  $d I r i $.  $d W r i $.
    frlmval.f $e |- F = ( R freeLMod I ) $.
    $( Value of the free module.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    frlmval $p |- ( ( R e. V /\ I e. W ) -> F =
        ( R (+)m ( I X. { ( ringLMod ` R ) } ) ) ) $=
      ( vr vi wcel cfrlm co crglmod cfv csn cxp cdsmm cvv wceq elex cv wa fveq2
      id sneqd xpeq2d oveq12d xpeq1 oveq2d df-frlm ovex ovmpt2 syl2an syl5eq )
      ADIZCEIZUABACJKZACALMZNZOZPKZFUNAQICQIUPUTRUOADSCESGHACQQGTZHTZVALMZNZOZP
      KUTJAVBUROZPKVAARZVAAVEVFPVGUCVGVDURVBVGVCUQVAALUBUDUEUFVBCRVFUSAPVBCURUG
      UHHGUIAUSPUJUKULUM $.

    $( The free module is a module.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    frlmlmod $p |- ( ( R e. Ring /\ I e. W ) -> F e. LMod ) $=
      ( vi crg wcel wa crglmod cfv csn cxp cdsmm clmod frlmval simpr csca wceq
      co simpl wf rlmlmod adantr fconst6g cv fvex fvconst2 adantl fveq2d rlmsca
      syl ad2antrr eqtr4d eqid dsmmlmod eqeltrd ) AGHZCDHZIZBACAJKZLMZNTZOABCGD
      EPUTFVCVBACDURUSQURUSUAUTVAOHZCOVBUBURVDUSAUCUDCVAOUEULUTFUFZCHZIZVEVBKZR
      KVARKZAVGVHVARVFVHVASUTCVAVEAJUGUHUIUJURAVISUSVFAGUKUMUNVCUOUPUQ $.

    ${
      frlmpws.b $e |- B = ( Base ` F ) $.
      $( The free module as a restriction of the power module.  (Contributed by
         Stefan O'Rear, 1-Feb-2015.) $)
      frlmpws $p |- ( ( R e. V /\ I e. W ) ->
          F = ( ( ( ringLMod ` R ) ^s I ) |`s B ) ) $=
        ( wcel wa crglmod cfv co cprds cress cbs eqid wceq oveq1d cvv csn cdsmm
        cxp dsmmval2 rlmsca adantr frlmval eqcomd fveq2d syl6eqr oveq12d syl5eq
        csca cpws fvex pwsval mpan adantl 3eqtr4d ) BEIZDFIZJZBDBKLZUAUCZUBMZVC
        UMLZVDNMZAOMZCVCDUNMZAOMVBVEBVDNMZVEPLZOMVHVKVDBVKQUDVBVJVGVKAOVBBVFVDN
        UTBVFRVABEUEUFSVBVKCPLAVBVECPVBCVEBCDEFGUGZUHUIHUJUKULVLVBVIVGAOVAVIVGR
        ZUTVCTIVAVMBKUOVCVFDTFVIVIQVFQUPUQURSUS $.

      frlmlss.u $e |- U = ( LSubSp ` ( ( ringLMod ` R ) ^s I ) ) $.
      $( The base set of the free module is a subspace of the power module.
         (Contributed by Stefan O'Rear, 1-Feb-2015.) $)
      frlmlss $p |- ( ( R e. Ring /\ I e. W ) -> B e. U ) $=
        ( crg wcel cfv co cbs fveq2d cprds clss clmod wceq eqid crglmod csn cxp
        vi wa cdsmm frlmval syl5eq simpr simpl rlmlmod adantr fconst6g syl csca
        wf cv fvex fvconst2 adantl rlmsca ad2antrr eqtr4d dsmmlss cpws cvv mpan
        pwsval eqcomd oveq1d eqtr2d syl6eqr eleqtrd eqeltrd ) BJKZEFKZUEZABEBUA
        LZUBUCZUFMZNLZCVQADNLWAHVQDVTNBDEJFGUGOUHVQWABVSPMZQLZCVQUDWBVSBWCWAEFV
        OVPUIVOVPUJVQVRRKZERVSUPVOWDVPBUKULEVRRUMUNVQUDUQZEKZUEZWEVSLZUOLVRUOLZ
        BWGWHVRUOWFWHVRSVQEVRWEBUAURZUSUTOVOBWISVPWFBJVAZVBVCWBTWCTWATVDVQWCVRE
        VEMZQLCVQWBWLQVQWLWIVSPMZWBVPWLWMSZVOVRVFKVPWNWJVRWIEVFFWLWLTWITVHVGUTV
        QWIBVSPVOWIBSVPVOBWIWKVIULVJVKOIVLVMVN $.
    $}

    $( The finite free module is a power of the ring module.  (Contributed by
       Stefan O'Rear, 1-Feb-2015.) $)
    frlmpwsfi $p |- ( ( R e. V /\ I e. Fin ) ->
        F = ( ( ringLMod ` R ) ^s I ) ) $=
      ( wcel cfn wa crglmod cfv csn cxp cdsmm cprds wceq cvv mpan adantl eqid
      co csca cpws wfn fnconstg ax-mp dsmmfi rlmsca adantr oveq1d eqtrd frlmval
      fvex pwsval 3eqtr4d ) ADFZCGFZHZACAIJZKLZMTZURUAJZUSNTZBURCUBTZUQUTAUSNTZ
      VBUPUTVDOZUOUSCUCZUPVEURPFZVFAIULZCURPUDUEUSACUFQRUQAVAUSNUOAVAOUPADUGUHU
      IUJABCDGEUKUPVCVBOZUOVGUPVIVHURVACPGVCVCSVASUMQRUN $.

    $( The ring of scalars of a free module.  (Contributed by Stefan O'Rear,
       1-Feb-2015.) $)
    frlmsca $p |- ( ( R e. V /\ I e. W ) -> R = ( Scalar ` F ) ) $=
      ( wcel wa crglmod cfv csca cpws co cbs cress wceq cvv fvex eqid pwssca
      mpan adantl resssca ax-mp syl6eq rlmsca adantr frlmpws fveq2d 3eqtr4d ) A
      DGZCEGZHZAIJZKJZUNCLMZBNJZOMZKJZABKJUMUOUPKJZUSULUOUTPZUKUNQGULVAAIRUNUOC
      QEUPUPSUOSTUAUBUQQGUTUSPBNRUQUTUPURQURSUTSUCUDUEUKAUOPULADUFUGUMBURKUQABC
      DEFUQSUHUIUJ $.

    ${
      frlm0.z $e |- .0. = ( 0g ` R ) $.
      $( Zero in a free module (ring constraint is stronger than necessary, but
         allows use of ~ frlmlss ).  (Contributed by Stefan O'Rear,
         4-Feb-2015.) $)
      frlm0 $p |- ( ( R e. Ring /\ I e. W ) ->
        ( I X. { .0. } ) = ( 0g ` F ) ) $=
        ( crg wcel wa crglmod cfv cpws co c0g cbs wceq clmod eqid sylan csn cxp
        cress csubg clss rlmlmod pwslmod frlmlss lsssubg syl2anc subg0 syl cmnd
        cgrp lmodgrp grpmnd 3syl rlm0 eqtri pws0g frlmpws fveq2d 3eqtr4d ) AHIZ
        CDIZJZAKLZCMNZOLZVHBPLZUCNZOLZCEUAUBZBOLVFVJVHUDLIZVIVLQVFVHRIZVJVHUELZ
        IVNVDVGRIZVEVOAUFZVGCDVHVHSZUGTVJAVPBCDFVJSZVPSZUHVPVJVHWAUIUJVJVHVKVIV
        KSVISUKULVDVGUMIZVEVMVIQVDVQVGUNIWBVRVGUOVGUPUQVGCDVHEVSEAOLVGOLGAURUSU
        TTVFBVKOVJABCHDFVTVAVBVC $.
    $}

    ${
      $d N k x $.  $d R k x $.  $d B x $.  $d I k x $.  $d W k x $.
      $d V k x $.  $d .0. k x $.
      frlmbas.n $e |- N = ( Base ` R ) $.
      frlmbas.z $e |- .0. = ( 0g ` R ) $.
      frlmbas.b $e |- B = { k e. ( N ^m I ) |
          ( `' k " ( _V \ { .0. } ) ) e. Fin } $.
      $( Base set of the free module.  (Contributed by Stefan O'Rear,
         1-Feb-2015.) $)
      frlmbas $p |- ( ( R e. V /\ I e. W ) -> B = ( Base ` F ) ) $=
        ( vx wcel c0g cfv cbs wceq cvv wa cv crglmod csn cxp ccom cdm cfn cprds
        cdif co crab cdsmm wfn fvex fnconstg ax-mp eqid dsmmbas2 mpan ccnv cima
        adantl cmap wne fvco2 fvconst2 fveq2d rlm0 eqtri syl6eqr eqtrd rabbidva
        neeq2d wf eqeltri elmapg biimpa ffn syl crn wss fn0g fnco mp3an fndmdif
        wb ssv sylancl fnniniseg2 3eqtr4d eleq1d cpws rlmbas pwsbas csca pwsval
        rlmsca adantr oveq1d eqtr4d rabeq eqtr3d syl5eq frlmval ) BGOZEHOZUAZCU
        BZPEBUCQZUDUEZUFZUJUGZUHOZCBXKUIUKZRQZULZBXKUMUKZRQZADRQXGXQXSSZXFXKEUN
        ZXGXTXJTOZYABUCUOZEXJTUPUQZXQXOXKBCEHXOURXQURUSUTVCXHAXIVATIUDUJVBZUHOZ
        CFEVDUKZULZXQMXHXNCYGULZYHXQXHXNYFCYGXHXIYGOZUAZXMYEUHYKNUBZXIQZYLXLQZV
        EZNEULZYMIVEZNEULZXMYEYKYOYQNEYKYLEOZUAZYNIYMYTYNYLXKQZPQZIYSYNUUBSZYKY
        AYSUUCYDEPXKYLVFUTVCYTUUBXJPQZIYTUUAXJPYSUUAXJSYKEXJYLYCVGVCVHIBPQUUDLB
        VIVJVKVLVNVMYKXIEUNZXLEUNZXMYPSYKEFXIVOZUUEXHYJUUGXGYJUUGWGZXFFTOXGUUHF
        BRQZTKBRUOVPFEXITHVQUTVCVREFXIVSVTZPTUNYAXKWAZTWBUUFWCYDUUKWHTEPXKWDWEN
        EXIXLWFWIYKUUEYEYRSUUJNEIXIWJVTWKWLVMXHYGXPSYIXQSXHYGXJEWMUKZRQZXPXGYGU
        UMSZXFYBXGUUNYCFXJETHUULUULURZFUUIXJRQKBWNVJWOUTVCXHUULXORXHUULXJWPQZXK
        UIUKZXOXGUULUUQSZXFYBXGUURYCXJUUPETHUULUUOUUPURWQUTVCXHBUUPXKUIXFBUUPSX
        GBGWRWSWTXAVHVLXNCYGXPXBVTXCXDXHDXRRBDEGHJXEVHWK $.
    $}

    ${
      $d X k $.  $d R k $.  $d I k $.  $d V k $.  $d W k $.  $d F k $.
      $d N k $.  $d .0. k $.
      frlmelbas.n $e |- N = ( Base ` R ) $.
      frlmelbas.z $e |- .0. = ( 0g ` R ) $.
      frlmelbas.b $e |- B = ( Base ` F ) $.
      $( Membership in the base set of the free module.  (Contributed by Stefan
         O'Rear, 1-Feb-2015.) $)
      frlmelbas $p |- ( ( R e. V /\ I e. W ) -> ( X e. B <->
            ( X e. ( N ^m I ) /\ ( `' X " ( _V \ { .0. } ) ) e. Fin ) ) ) $=
        ( vk wcel wa cv ccnv cima cfn cvv csn cdif cmap co crab cbs cfv frlmbas
        eqid syl6reqr eleq2d wceq cnveq imaeq1d eleq1d elrab syl6bb ) BFODGOPZH
        AOHNQZRZUAIUBUCZSZTOZNEDUDUEZUFZOHVEOHRZVBSZTOZPUSAVFHUSVFCUGUHAVFBNCDE
        FGIJKLVFUJUIMUKULVDVINHVEUTHUMZVCVHTVJVAVGVBUTHUNUOUPUQUR $.
    $}

    ${
      frlmrcl.b $e |- B = ( Base ` F ) $.
      $( If a free module is inhabited, this is sufficient to conclude that the
         ring expression defines a set.  (Contributed by Stefan O'Rear,
         3-Feb-2015.) $)
      frlmrcl $p |- ( X e. B -> R e. _V ) $=
        ( vr vi cfrlm cvv cv crglmod cfv csn cxp cdsmm co df-frlm reldmmpt2
        strov2rcl ) ADCJBEFGHIKKHLZILUBMNOPQRJIHSTUA $.
    $}

    ${
      frlmbassup.z $e |- .0. = ( 0g ` R ) $.
      frlmbassup.b $e |- B = ( Base ` F ) $.
      $( Elements of the free module are finitely supported.  (Contributed by
         Stefan O'Rear, 3-Feb-2015.) $)
      frlmbassup $p |- ( ( I e. W /\ X e. B ) ->
          ( `' X " ( _V \ { .0. } ) ) e. Fin ) $=
        ( wcel wa cbs cfv cmap co ccnv cvv csn cdif cfn simpr wb frlmrcl adantl
        cima simpl eqid frlmelbas syl2anc mpbid simprd ) DEKZFAKZLZFBMNZDOPKZFQ
        RGSTUFUAKZUOUNUQURLZUMUNUBUOBRKZUMUNUSUCUNUTUMABCDFHJUDUEUMUNUGABCDUPRE
        FGHUPUHIJUIUJUKUL $.
    $}

    ${
      frlmbasmap.n $e |- N = ( Base ` R ) $.
      frlmbasmap.b $e |- B = ( Base ` F ) $.
      $( Elements of the free module are set functions.  (Contributed by Stefan
         O'Rear, 3-Feb-2015.) $)
      frlmbasmap $p |- ( ( I e. W /\ X e. B ) -> X e. ( N ^m I ) ) $=
        ( wcel wa cmap co ccnv cvv c0g cfv csn cdif cfn simpr wb frlmrcl adantl
        cima simpl eqid frlmelbas syl2anc mpbid simpld ) DFKZGAKZLZGEDMNKZGOPBQ
        RZSTUFUAKZUOUNUPURLZUMUNUBUOBPKZUMUNUSUCUNUTUMABCDGHJUDUEUMUNUGABCDEPFG
        UQHIUQUHJUIUJUKUL $.

      $( Elements of the free module are functions.  (Contributed by Stefan
         O'Rear, 3-Feb-2015.) $)
      frlmbasf $p |- ( ( I e. W /\ X e. B ) -> X : I --> N ) $=
        ( wcel wa cmap co wf frlmbasmap wb cvv cbs cfv fvex eqeltri elmapg mpan
        adantr mpbid ) DFKZGAKZLGEDMNKZDEGOZABCDEFGHIJPUGUIUJQZUHERKUGUKEBSTRIB
        SUAUBEDGRFUCUDUEUF $.
    $}
  $}

  ${
    frlmplusgval.y $e |- Y = ( R freeLMod I ) $.
    frlmplusgval.b $e |- B = ( Base ` Y ) $.
    frlmplusgval.r $e |- ( ph -> R e. V ) $.
    frlmplusgval.i $e |- ( ph -> I e. W ) $.
    frlmplusgval.f $e |- ( ph -> F e. B ) $.
    frlmplusgval.g $e |- ( ph -> G e. B ) $.
    frlmplusgval.a $e |- .+ = ( +g ` R ) $.
    frlmplusgval.p $e |- .+b = ( +g ` Y ) $.
    $( Addition in a free module.  (Contributed by Stefan O'Rear, 1-Feb-2015.)
       (Revised by Stefan O'Rear, 6-May-2015.) $)
    frlmplusgval $p |- ( ph -> ( F .+b G ) = ( F oF .+ G ) ) $=
      ( cfv co crglmod cpws cplusg cof cbs cress wcel wceq eqid frlmpws syl2anc
      fveq2d cvv fvex ressplusg ax-mp 3eqtr4g oveqd a1i syl5eq ressbasss sseldd
      syl6eqss rlmplusg eqtri pwsplusgval eqtrd ) AFGDUAFGEUBTZHUCUAZUDTZUAFGCU
      EUAADVKFGAKUDTVJKUFTZUGUAZUDTZDVKAKVMUDAEIUHZHJUHZKVMUINOVLEKHIJLVLUJUKUL
      UMSVLUNUHVKVNUIKUFUOVLVKVJVMUNVMUJVKUJZUPUQURUSAVJUFTZCVKVIFGHUNJVJVJUJVR
      UJZVIUNUHAEUBUOUTOABVRFABVJBUGUAZUFTZVRABVLWAMAKVTUFAVOVPKVTUINOBEKHIJLMU
      KULUMVABVRVTVJVTUJVSVBVDZPVCABVRGWBQVCCEUDTVIUDTREVEVFVQVGVH $.
  $}

  ${
    frlmvscafval.y $e |- Y = ( R freeLMod I ) $.
    frlmvscafval.b $e |- B = ( Base ` Y ) $.
    frlmvscafval.k $e |- K = ( Base ` R ) $.
    frlmvscafval.i $e |- ( ph -> I e. W ) $.
    frlmvscafval.a $e |- ( ph -> A e. K ) $.
    frlmvscafval.x $e |- ( ph -> X e. B ) $.
    frlmvscafval.v $e |- .xb = ( .s ` Y ) $.
    frlmvscafval.t $e |- .x. = ( .r ` R ) $.
    $( Scalar multiplication in a free module.  (Contributed by Stefan O'Rear,
       1-Feb-2015.)  (Revised by Stefan O'Rear, 6-May-2015.) $)
    frlmvscafval $p |- ( ph -> ( A .xb X ) = ( ( I X. { A } ) oF .x. X ) ) $=
      ( cfv co crglmod cpws cvsca csn cxp cof cvv wcel wceq frlmrcl syl frlmpws
      cress syl2anc fveq2d fvex eqeltri eqid ressvsca ax-mp 3eqtr4g oveqd cmulr
      cbs csca rlmvsca a1i rlmsca syl5eq eleqtrd ressbasss syl6eqss pwsvscafval
      eqtri sseldd eqtrd ) ABJEUABJDUBTZGUCUAZUDTZUAGBUEUFJFUGUAAEVTBJAKUDTVSCU
      NUAZUDTZEVTAKWAUDADUHUIZGIUIKWAUJAJCUIWCQCDKGJLMUKULZOCDKGUHILMUMUOZUPRCU
      HUIVTWBUJCKVETZUHMKVEUQURCVTVSWAUHWAUSZVTUSZUTVAVBVCABVSVETZVRVTFVRVFTZGW
      JVETZUHIJVSVSUSWIUSZFDVDTVRUDTSDVGVOWHWJUSWKUSVRUHUIADUBUQVHOABHWKPAHDVET
      WKNADWJVEAWCDWJUJWDDUHVIULUPVJVKACWIJACWAVETZWIACWFWMMAKWAVEWEUPVJCWIWAVS
      WGWLVLVMQVPVNVQ $.
  $}

  ${
    frlmvscaval.y $e |- Y = ( R freeLMod I ) $.
    frlmvscaval.b $e |- B = ( Base ` Y ) $.
    frlmvscaval.k $e |- K = ( Base ` R ) $.
    frlmvscaval.i $e |- ( ph -> I e. W ) $.
    frlmvscaval.a $e |- ( ph -> A e. K ) $.
    frlmvscaval.x $e |- ( ph -> X e. B ) $.
    frlmvscaval.j $e |- ( ph -> J e. I ) $.
    frlmvscaval.v $e |- .xb = ( .s ` Y ) $.
    frlmvscaval.t $e |- .x. = ( .r ` R ) $.
    $( Scalar multiplication in a free module at a coordinate.  (Contributed by
       Stefan O'Rear, 3-Feb-2015.) $)
    frlmvscaval $p |- ( ph -> ( ( A .xb X ) ` J ) = ( A .x. ( X ` J ) ) ) $=
      ( cfv csn cxp cof frlmvscafval fveq1d wfn wcel wceq fnconstg syl frlmbasf
      co wf syl2anc ffn fnfvof syl22anc fvconst2g oveq1d 3eqtrd ) AHBKEUNZUBHGB
      UCUDZKFUEUNZUBZHVDUBZHKUBZFUNZBVHFUNAHVCVEABCDEFGIJKLMNOPQRTUAUFUGAVDGUHZ
      KGUHZGJUIZHGUIZVFVIUJABIUIZVJQGBIUKULAGIKUOZVKAVLKCUIVOPRCDLGIJKMONUMUPGI
      KUQULPSGFVDKJHURUSAVGBVHFAVNVMVGBUJQSGBHIUTUPVAVB $.
  $}


  ${
    $d a b c x y B $.  $d a b c x y F $.  $d a b c x y I $.  $d a b c x y ph $.
    $d a b c x y .0. $.  $d a b c x y J $.  $d a b c x y R $.
    $d a b c x y Y $.
    frlmgsum.y $e |- Y = ( R freeLMod I ) $.
    frlmgsum.b $e |- B = ( Base ` Y ) $.
    frlmgsum.z $e |- .0. = ( 0g ` Y ) $.
    frlmgsum.i $e |- ( ph -> I e. V ) $.
    frlmgsum.j $e |- ( ph -> J e. W ) $.
    frlmgsum.r $e |- ( ph -> R e. Ring ) $.
    frlmgsum.f $e |- ( ( ph /\ y e. J ) -> ( x e. I |-> U ) e. B ) $.
    frlmgsum.w $e |- ( ph ->
      ( `' ( y e. J |-> ( x e. I |-> U ) ) " ( _V \ { .0. } ) ) e. Fin ) $.
    $( Finite commutative sums in a free module are taken componentwise.
       (Contributed by Stefan O'Rear, 1-Feb-2015.)  (Revised by Mario Carneiro,
       5-Jul-2015.) $)
    frlmgsum $p |- ( ph -> ( Y gsum ( y e. J |-> ( x e. I |-> U ) ) ) =
       ( x e. I |-> ( R gsum ( y e. J |-> U ) ) ) ) $=
      ( cmpt cgsu co crglmod cfv cpws cress crg wcel frlmpws syl2anc oveq1d cbs
      wceq cvv c0g eqid ovex a1i clss wss frlmlss lssss syl fmptd clmod rlmlmod
      cplusg pwslmod lss0cl cmnd cv wa ccmn lmodcmn cmnmnd pwsmnd mndlrid sylan
      gsumress rlmbas wf wral adantr frlmbasf fmpt sylibr r19.21bi an32s anasss
      ccnv csn cdif cima fveq2d csubg lsssubg subg0 eqtr4d syl5eq sneqd difeq2d
      imaeq2d eqeltrrd pwsgsum mptexg fvex rlmplusg gsumpropd mpteq2dv 3eqtr2d
      cfn ) AKCHBGFUAZUAZUBUCEUDUEZGUFUCZDUGUCZXNUBUCXPXNUBUCZBGECHFUAZUBUCZUAZ
      AKXQXNUBAEUHUIZGIUIZKXQUNRPDEKGUHIMNUJUKZULABHXPUMUEZXPVHUEZDXNXPXQUOJXPU
      PUEZYEUQZYFUQZXQUQZXPUOUIAXOGUFURUSQADXPUTUEZUIZDYEVAAYBYCYLRPDEYKKGIMNYK
      UQZVBUKZYKDYEXPYHYMVCVDACHXMDXNSXNUQVEAXPVFUIZYLYGDUIAXOVFUIZYCYOAYBYPREV
      GVDZPXOGIXPXPUQZVIUKZYNYKDXPYGYGUQZYMVJUKAXPVKUIZBVLZYEUIYGUUBYFUCUUBUNUU
      BYGYFUCUUBUNVMAXOVKUIZYCUUAAXOVNUIZUUCAYPUUDYQXOVOVDZXOVPVDPXOGIXPYRVQUKY
      EYFXPUUBYGYHYIYTVRVSVTAXRBGXOXSUBUCZUAYAABCEUMUEZXOFGHIJXPYGYREWAZYTPQUUE
      AUUBGUIZCVLHUIZFUUGUIZAUUJUUIUUKAUUJVMZUUKBGUULGUUGXMWBZUUKBGWCUULYCXMDUI
      UUMAYCUUJPWDSDEKGUUGIXMMUUGUQNWEUKBGUUGFXMXMUQWFWGWHWIWJAXNWKZUOLWLZWMZWN
      UUNUOYGWLZWMZWNXLAUUPUURUUNAUUOUUQUOALYGALKUPUEZYGOAUUSXQUPUEZYGAKXQUPYDW
      OADXPWPUEUIZYGUUTUNAYOYLUVAYSYNYKDXPYMWQUKDXPXQYGYJYTWRVDWSWTXAXBXCTXDXEA
      BGXTUUFAXSEXOUOUHUOAHJUIXSUOUIQCHFJXFVDRXOUOUIAEUDXGUSUUGXOUMUEUNAUUHUSEV
      HUEXOVHUEUNAEXHUSXIXJWSXK $.
  $}

  ${
    $d .1. i j k r $.  $d R i j k r $.  $d I i j k r $.  $d .0. i j k r $.
    uvcfval.u $e |- U = ( R unitVec I ) $.
    uvcfval.o $e |- .1. = ( 1r ` R ) $.
    uvcfval.z $e |- .0. = ( 0g ` R ) $.
    $( Value of the unit-vector generator for a free module.  (Contributed by
       Stefan O'Rear, 1-Feb-2015.) $)
    uvcfval $p |- ( ( R e. V /\ I e. W ) -> U = ( j e. I |->
            ( k e. I |-> if ( k = j , .1. , .0. ) ) ) ) $=
      ( vr vi wcel wa cmpt cvv wceq cfv cuvc co weq cif cv cur c0g cmpt2 df-uvc
      elex a1i simpr fveq2 syl6eqr ifeq12d adantr mpteq12dv adantl simpl mptexg
      ovmpt2d syl2an syl5eq ) AGOZFHOZPBAFUAUBZDFEFEDUCZCIUDZQZQZJVDAROZFROZVFV
      JSVEAGUJFHUJVKVLPZMNAFRRDNUEZEVNVGMUEZUFTZVOUGTZUDZQZQZVJUARUAMNRRVTUHSVM
      NDEMUIUKVOASZVNFSZPZVTVJSVMWCDVNVSFVIWAWBULZWCEVNVRFVHWDWAVRVHSWBWAVGVPCV
      QIWAVPAUFTCVOAUFUMKUNWAVQAUGTIVOAUGUMLUNUOUPUQUQURVKVLUSVKVLULVLVJROVKDFV
      IRUTURVAVBVC $.

    $d J j k $.
    $( Value of a single unit vector in a free module.  (Contributed by Stefan
       O'Rear, 3-Feb-2015.) $)
    uvcval $p |- ( ( R e. V /\ I e. W /\ J e. I ) ->
        ( U ` J ) = ( k e. I |-> if ( k = J , .1. , .0. ) ) ) $=
      ( vj wcel cfv cif cmpt cv wceq cvv w3a weq wa uvcfval fveq1d simp3 mptexg
      3adant3 3ad2ant2 eqeq2 ifbid mpteq2dv eqid fvmptg syl2anc eqtrd ) AGNZEHN
      ZFENZUAZFBOZFMEDEDMUBZCIPZQZQZOZDEDRZFSZCIPZQZUQURVAVFSUSUQURUCFBVEABCMDE
      GHIJKLUDUEUHUTUSVJTNZVFVJSUQURUSUFURUQVKUSDEVIHUGUIMFVDVJETVEMRZFSZDEVCVI
      VMVBVHCIVLFVGUJUKULVEUMUNUOUP $.

    $d K k $.
    $( Value of a unit vector coordinate in a free module.  (Contributed by
       Stefan O'Rear, 3-Feb-2015.) $)
    uvcvval $p |- ( ( ( R e. V /\ I e. W /\ J e. I ) /\ K e. I ) ->
        ( ( U ` J ) ` K ) = if ( K = J , .1. , .0. ) ) $=
      ( vk wcel cfv wceq cif cvv cur fvex wa cv cmpt uvcval fveq1d adantr simpr
      w3a eqeltri c0g ifex eqeq1 ifbid eqid fvmptg sylancl eqtrd ) AGNDHNEDNUHZ
      FDNZUAZFEBOZOZFMDMUBZEPZCIQZUCZOZFEPZCIQZURVBVGPUSURFVAVFABCMDEGHIJKLUDUE
      UFUTUSVIRNVGVIPURUSUGVHCICASORKASTUIIAUJORLAUJTUIUKMFVEVIDRVFVCFPVDVHCIVC
      FEULUMVFUNUOUPUQ $.

    $( A coodinate of a unit vector is either 0 or 1.  (Contributed by Stefan
       O'Rear, 3-Feb-2015.) $)
    uvcvvcl $p |- ( ( ( R e. V /\ I e. W /\ J e. I ) /\ K e. I ) ->
        ( ( U ` J ) ` K ) e. { .0. , .1. } ) $=
      ( wcel cfv cpr cvv cur fvex eqeltri c0g w3a wceq uvcvval ifpr mp2an prcom
      wa cif eleqtri syl6eqel ) AGMDHMEDMUAFDMUGFEBNNFEUBZCIUHZICOZABCDEFGHIJKL
      UCULCIOZUMCPMIPMULUNMCAQNPKAQRSIATNPLATRSUKCIPPUDUECIUFUIUJ $.
  $}

  ${
    uvcvvcl2.u $e |- U = ( R unitVec I ) $.
    uvcvvcl2.b $e |- B = ( Base ` R ) $.
    uvcvvcl2.r $e |- ( ph -> R e. Ring ) $.
    uvcvvcl2.i $e |- ( ph -> I e. W ) $.
    uvcvvcl2.j $e |- ( ph -> J e. I ) $.
    uvcvvcl2.k $e |- ( ph -> K e. I ) $.
    $( A unit vector coordinate is a ring element.  (Contributed by Stefan
       O'Rear, 3-Feb-2015.) $)
    uvcvvcl2 $p |- ( ph -> ( ( U ` J ) ` K ) e. B ) $=
      ( cfv wceq cur crg wcel eqid c0g cif uvcvval syl31anc rngidcl rng0cl ifcl
      syl2anc syl eqeltrd ) AGFDOOZGFPZCQOZCUAOZUBZBACRSZEHSFESGESUKUOPKLMNCDUM
      EFGRHUNIUMTZUNTZUCUDAUPUOBSZKUPUMBSUNBSUSBCUMJUQUEBCUNJURUFULUMUNBUGUHUIU
      J $.
  $}

  ${
    uvcvv.u $e |- U = ( R unitVec I ) $.
    uvcvv.r $e |- ( ph -> R e. V ) $.
    uvcvv.i $e |- ( ph -> I e. W ) $.
    uvcvv.j $e |- ( ph -> J e. I ) $.

    ${
      uvcvv1.o $e |- .1. = ( 1r ` R ) $.
      $( The unit vector is one at its designated coordinate.  (Contributed by
         Stefan O'Rear, 3-Feb-2015.) $)
      uvcvv1 $p |- ( ph -> ( ( U ` J ) ` J ) = .1. ) $=
        ( cfv wceq c0g cif wcel eqid uvcvval syl31anc iftrue mp1i eqtrd ) AFFCN
        NZFFOZDBPNZQZDABGREHRFERZUIUEUHOJKLLBCDEFFGHUGIMUGSTUAUFUHDOAFSUFDUGUBU
        CUD $.
    $}

    ${
      uvcvv0.k $e |- ( ph -> K e. I ) $.
      uvcvv0.jk $e |- ( ph -> J =/= K ) $.
      uvcvv0.z $e |- .0. = ( 0g ` R ) $.
      $( The unit vector is zero at its designated coordinate.  (Contributed by
         Stefan O'Rear, 3-Feb-2015.) $)
      uvcvv0 $p |- ( ph -> ( ( U ` J ) ` K ) = .0. ) $=
        ( cfv wceq wcel wne cur cif uvcvval syl31anc wn necom df-ne bitri sylib
        eqid iffalse syl eqtrd ) AFECQQZFERZBUAQZIUBZIABGSDHSEDSFDSUNUQRKLMNBCU
        PDEFGHIJUPUJPUCUDAUOUEZUQIRAEFTZUROUSFETUREFUFFEUGUHUIUOUPIUKULUM $.
    $}
  $}

  ${
    $d U i j $.  $d Y i j $.  $d W i j $.  $d I i j $.  $d R i j $.
    $d B i j $.
    uvcff.u $e |- U = ( R unitVec I ) $.
    uvcff.y $e |- Y = ( R freeLMod I ) $.
    uvcff.b $e |- B = ( Base ` Y ) $.
    $( Domain and range of the unit vector generator; ring condition required
       to be sure 1 and 0 are actually in the ring.  (Contributed by Stefan
       O'Rear, 1-Feb-2015.) $)
    uvcff $p |- ( ( R e. Ring /\ I e. W ) -> U : I --> B ) $=
      ( vi vj crg wcel wa wf cfv cmpt cvv cfn eqid weq cur c0g cif cv cmap ccnv
      cbs csn cdif cima rngidcl rng0cl ifcl syl2anc ad3antrrr fmptd fvex elmapg
      co wb mpan ad2antlr mpbird crab mptpreima wss snfi cab cin inss2 neldifsn
      wn iffalse eleq1d mtbiri con4i ss2abi sstri dfrab3 df-sn 3sstr4i ssfi a1i
      mp2an syl5eqel frlmelbas adantr mpbir2and uvcfval feq1d ) BLMZDEMZNZDACOD
      AJDKDKJUAZBUBPZBUCPZUDZQZQZOWNJDWSAWTWNJUEZDMZNZWSAMZWSBUHPZDUFUTMZWSUGRW
      QUIUJZUKZSMZXCXFDXEWSOZXCKDWRXEWSWLWRXEMZWMXBKUEDMWLWPXEMWQXEMXKXEBWPXETZ
      WPTZULXEBWQXLWQTZUMWOWPWQXEUNUOUPWSTZUQWMXFXJVAZWLXBXERMWMXPBUHURXEDWSREU
      SVBVCVDXCXHWRXGMZKDVEZSKDWRXGWSXOVFXRSMZXCXAUIZSMXRXTVGXSXAVHDXQKVIZVJZWO
      KVIZXRXTYBYAYCDYAVKXQWOKWOXQWOVMZXQWQXGMWQRVLYDWRWQXGWOWPWQVNVOVPVQVRVSXQ
      KDVTKXAWAWBXTXRWCWEWDWFWNXDXFXINVAXBABFDXELEWSWQHXLXNIWGWHWIWTTUQWNDACWTB
      CWPJKDLEWQGXMXNWJWKVD $.

    $( In a nonzero ring, each unit vector is different.  (Contributed by
       Stefan O'Rear, 7-Feb-2015.)  (Revised by Mario Carneiro,
       14-Jun-2015.) $)
    uvcf1 $p |- ( ( R e. NzRing /\ I e. W ) -> U : I -1-1-> B ) $=
      ( vi vj wcel wa cv cfv wceq wral crg wne eqid cnzr wf wi wf1 nzrrng uvcff
      sylan cur c0g nzrnz ad3antrrr simpllr simplrl uvcvv1 simplrr simpr necomd
      uvcvv0 3netr4d fveq1 necon3i syl ex necon4d ralrimivva dff13 sylanbrc ) B
      UALZDELZMZDACUBZJNZCOZKNZCOZPVLVNPUCZKDQJDQDACUDVHBRLZVIVKBUEZABCDEFGHIUF
      UGVJVPJKDDVJVLDLZVNDLZMZMZVLVNVMVOWBVLVNSZVMVOSZWBWCMZVLVMOZVLVOOZSWDWEBU
      HOZBUIOZWFWGVHWHWISVIWAWCBWHWIWHTZWITZUJUKWEBCWHDVLREGVHVQVIWAWCVRUKZVHVI
      WAWCULZVJVSVTWCUMZWJUNWEBCDVNVLREWIGWLWMVJVSVTWCUOWNWEVLVNWBWCUPUQWKURUSV
      MVOWFWGVLVMVOUTVAVBVCVDVEJKDACVFVG $.
  $}

  ${
    $d U a b $.  $d R a b $.  $d I a b $.  $d Y a b $.  $d B a b $.
    $d .x. a b $.  $d W a b $.  $d X a b $.
    uvcresum.u $e |- U = ( R unitVec I ) $.
    uvcresum.y $e |- Y = ( R freeLMod I ) $.
    uvcresum.b $e |- B = ( Base ` Y ) $.
    uvcresum.v $e |- .x. = ( .s ` Y ) $.
    $( Any element of a free module can be expressed as a finite linear
       combination of unit vectors.  (Contributed by Stefan O'Rear,
       3-Feb-2015.)  (Proof shortened by Mario Carneiro, 5-Jul-2015.) $)
    uvcresum $p |- ( ( R e. Ring /\ I e. W /\ X e. B ) ->
        X = ( Y gsum ( X oF .x. U ) ) ) $=
      ( vb va wcel cfv co cmpt eqid wceq crg w3a cv cmulr cgsu cof cbs frlmbasf
      wf 3adant1 feqmptd c0g cmnd simpl1 rngmnd syl simpl2 simpr wral ffvelrnda
      csn cxp uvcff 3adant3 frlmvscafval adantr syl2anc fconstmpt offval2 eqtrd
      wa a1i clmod csca frlmlmod frlmsca eleqtrd lmodvscl syl3anc eqeltrrd fmpt
      fveq2d sylibr r19.21bi an32s fmptd cdif simpll1 simpll2 eldifi adantl wne
      simplr eldifsni uvcvv0 oveq2d ffvelrn syl2an rngrz suppss2 gsumpt oveq12d
      fveq2 fveq1d ovex fvmpt cur uvcvv1 rngridm mpteq2dva simp2 simp1 ccnv cvv
      eqtr4d cfn frlmbassup sneqd difeq2d imaeq2d eqimss2 suppssr oveq1d sylan2
      cima wss lmod0vs 3eqtr3d ssfi frlmgsum ) BUAOZEFOZGAOZUBZGHMENEMUCZGPZNUC
      ZYODPZPZBUDPZQZRZRZUEQZHGDCUFQZUEQYNGNEBMEUUARZUEQZRZUUDYNGNEYQGPZRUUHYNN
      EBUGPZGYLYMEUUJGUIZYKABHEUUJFGJUUJSZKUHUJZUKYNNEUUGUUIYNYQEOZVKZUUGYQUUFP
      ZUUIUUOEUUJUUFBFYQBULPZUULUUQSZUUOYKBUMOYKYLYMUUNUNZBUOUPYKYLYMUUNUQZYNUU
      NURZUUOMEUUAUUJUUFYNYOEOZUUNUUAUUJOZYNUVBVKZUVCNEUVDEUUJUUBUIZUVCNEUSUVDY
      LUUBAOUVEYKYLYMUVBUQZUVDYPYRCQZUUBAUVDUVGEYPVAVBZYRYTUFQUUBUVDYPABCYTEUUJ
      FYRHJKUULUVFYNEUUJYOGUUMUTZYNEAYODYKYLEADUIYMABDEFHIJKVCVDZUTZLYTSZVEUVDN
      EYPYSYTUVHYRFUUJUUJUVFUVDYPUUJOZUUNUVIVFUVDEUUJYQYRUVDYLYRAOZEUUJYRUIUVFU
      VKABHEUUJFYRJUULKUHVGZUTUVHNEYPRTUVDNEYPVHVLUVDNEUUJYRUVOUKVIVJZUVDHVMOZY
      PHVNPZUGPZOUVNUVGAOYNUVQUVBYKYLUVQYMBHEFJVOVDZVFUVDYPUUJUVSUVIYNUUJUVSTUV
      BYNBUVRUGYKYLBUVRTYMBHEUAFJVPVDZWBVFVQUVKYPCUVRUVSAHYRKUVRSZLUVSSVRVSVTZA
      BHEUUJFUUBJUULKUHVGNEUUJUUAUUBUUBSWAWCWDWEUUFSZWFUUOEUUAMYQVAZUUQUUOYOEUW
      EWGOZVKZUUAYPUUQYTQZUUQUWGYSUUQYPYTUWGBDEYOYQUAFUUQIYKYLYMUUNUWFWHZYKYLYM
      UUNUWFWIUWFUVBUUOYOEUWEWJZWKYNUUNUWFWMUWFYOYQWLUUOYOEYQWNWKUURWOWPUWGYKUV
      MUWHUUQTUWIUUOUUKUVBUVMUWFYNUUKUUNUUMVFUWJEUUJYOGWQWRUUJBYTYPUUQUULUVLUUR
      WSVGVJWTXAUUOUUPUUIYQYQDPZPZYTQZUUIUUNUUPUWMTYNMYQUUAUWMEUUFYOYQTZYPUUIYS
      UWLYTYOYQGXCUWNYQYRUWKYOYQDXCXDXBUWDUUIUWLYTXEXFWKUUOUWMUUIBXGPZYTQZUUIUU
      OUWLUWOUUIYTUUOBDUWOEYQUAFIUUSUUTUVAUWOSZXHWPUUOYKUUIUUJOUWPUUITUUSYNEUUJ
      YQGUUMUTUUJBYTUWOUUIUULUVLUWQXIVGVJVJVJXJXOYNNMABUUAEEFFHHULPZJKUWRSZYKYL
      YMXKZUWTYKYLYMXLUWCYNGXMZXNUUQVAZWGZYEZXPOZUUCXMXNUWRVAWGYEZUXDYFUXFXPOYL
      YMUXEYKABHEFGUUQJUURKXQUJYNEUUBMUXDUWRYNYOEUXDWGOZVKZUVGUVRULPZYRCQZUUBUW
      RUXHYPUXIYRCYNEUUJGUXDYOUXIUUMYNUXDUXAXNUXIVAZWGZYEZTUXMUXDYFYNUXCUXLUXAY
      NUXBUXKXNYNUUQUXIYNBUVRULUWAWBXRXSXTUXMUXDYAUPYBYCUXGYNUVBUVGUUBTYOEUXDWJ
      ZUVPYDUXHUVQUVNUXJUWRTYNUVQUXGUVTVFUXGYNUVBUVNUXNUVKYDCUVRUXIAHYRUWRKUWBL
      UXISUWSYGVGYHWTUXDUXFYIVGYJXOYNUUEUUCHUEYNUUEMEUVGRUUCYNMEYPYRCGDFUUJAUWT
      UVIUVKYNMEUUJGUUMUKYNMEADUVJUKVIYNMEUVGUUBUVPXJVJWPXO $.
  $}

  ${
    $d Y x y $.  $d R x y $.  $d U x y $.  $d Z x y $.  $d V x y $.
    $d B x y $.  $d C x y $.  $d F y $.  $d X x y $.
    frlmsplit2.y $e |- Y = ( R freeLMod U ) $.
    frlmsplit2.z $e |- Z = ( R freeLMod V ) $.
    frlmsplit2.b $e |- B = ( Base ` Y ) $.
    frlmsplit2.c $e |- C = ( Base ` Z ) $.
    frlmsplit2.f $e |- F = ( x e. B |-> ( x |` V ) ) $.
    $( Restriction is homomoprhic on free modules.  (Contributed by Stefan
       O'Rear, 3-Feb-2015.) $)
    frlmsplit2 $p |- ( ( R e. Ring /\ U e. X /\ V C_ U ) ->
        F e. ( Y LMHom Z ) ) $=
      ( wcel co eqid syl2anc cvv crg wss w3a crglmod cfv cpws cress cbs cv cres
      clmhm cmpt clss wceq simp1 simp2 frlmlss lssss 3syl syl6eqr clmod rlmlmod
      resmpt pwssplit3 syl3an1 reslmhm wb 3ad2ant1 simp3 ssexd pwslmod rneqd wf
      crn wa cmap ccnv c0g csn cdif cima cfn frlmbasf simpl3 fssres fvex elmapg
      sylan sylancr adantr cin cnvresima frlmbassup inss1 ssfi sylancl syl5eqel
      mpbird frlmelbas mpbir2and fmptd frn syl eqsstrd reslmhm2b mpbid eqeltrrd
      syl3anc frlmpws oveq12d eleqtrrd ) DUAPZEHPZGEUBZUCZFDUDUEZEUFQZBUGQZXPGU
      FQZCUGQZUKQZIJUKQXOAXQUHUEZAUIZGUJZULZBUJZFYAXOYFABYDULZFXOBXQUMUEZPZBYBU
      BYFYGUNXOXLXMYIXLXMXNUOZXLXMXNUPZBDYHIEHKMYHRZUQSZYHBYBXQYBRZYLURAYBBYDVC
      USZOUTXOYFXRXSUKQPZYFYAPZXOYEXQXSUKQPZYIYPXLXPVAPZXMXNYRDVBZAYBXSUHUEZEYE
      GXPHXQXSXQRXSRZYNUUARYERVDVEYMXRXQXSYHYEBYLXRRVFSXOXSVAPZCXSUMUEZPZYFVNZC
      UBYPYQVGXOYSGTPZUUCXLXMYSXNYTVHXOGEHYKXLXMXNVIVJZXPGTXSUUBVKSXOXLUUGUUEYJ
      UUHCDUUDJGTLNUUDRZUQSXOUUFYGVNZCXOYFYGYOVLXOBCYGVMUUJCUBXOABYDCYGXOYCBPZV
      OZYDCPZYDDUHUEZGVPQPZYDVQTDVRUEZVSVTZWAZWBPZUULUUOGUUNYDVMZUULEUUNYCVMZXN
      UUTXOXMUUKUVAYKBDIEUUNHYCKUUNRZMWCWHXLXMXNUUKWDEUUNGYCWESXOUUOUUTVGZUUKXO
      UUNTPUUGUVCDUHWFUUHUUNGYDTTWGWIWJWRUULUURYCVQUUQWAZGWKZWBGUUQYCWLUULUVDWB
      PZUVEUVDUBUVEWBPXOXMUUKUVFYKBDIEHYCUUPKUUPRZMWMWHUVDGWNUVDUVEWOWPWQXOUUMU
      UOUUSVOVGZUUKXOXLUUGUVHYJUUHCDJGUUNUATYDUUPLUVBUVGNWSSWJWTYGRXABCYGXBXCXD
      XRXSXTYFUUDCXTRUUIXEXHXFXGXOIXRJXTUKXOXLXMIXRUNYJYKBDIEUAHKMXISXOXLUUGJXT
      UNYJUUHCDJGUATLNXISXJXK $.
  $}

  ${
    $d x y B $.  $d y C $.  $d x y I $.  $d x y J $.  $d x y R $.  $d x y U $.
    $d x y .0. $.  $d x y V $.  $d x y Y $.
    frlmsslss.y $e |- Y = ( R freeLMod I ) $.
    frlmsslss.u $e |- U = ( LSubSp ` Y ) $.
    frlmsslss.b $e |- B = ( Base ` Y ) $.
    frlmsslss.z $e |- .0. = ( 0g ` R ) $.

    ${
      frlmsslss.c $e |- C = { x e. B | ( x |` J ) = ( J X. { .0. } ) } $.
      $( A subset of a free module obtained by restricting the support set is a
         submodule. ` J ` is the set of forbidden unit vectors.  (Contributed
         by Stefan O'Rear, 4-Feb-2015.) $)
      frlmsslss $p |- ( ( R e. Ring /\ I e. V /\ J C_ I ) -> C e. U ) $=
        ( wcel co wceq cvv eqid crg wss w3a cv cres cfrlm c0g cfv csn cxp simp1
        crab simp2 simp3 ssexd frlm0 syl2anc eqeq2d rabbidv cmpt cbs frlmsplit2
        syl5eq clmhm ccnv cima fvex mptiniseg ax-mp eqcomi lmhmkerlss eqeltrd
        syl ) DUAPZFHPZGFUBZUCZCAUDGUEZDGUFQZUGUHZRZABULZEVQCVRGJUIUJZRZABULWBO
        VQWDWAABVQWCVTVRVQVNGSPWCVTRVNVOVPUKVQGFHVNVOVPUMVNVOVPUNUODVSGSJVSTZNU
        PUQURUSVCVQABVRUTZIVSVDQPWBEPABVSVAUHZDFWFGHIVSKWEMWGTWFTZVBIVSEWFWBVTW
        FVEVTUIVFZWBVTSPWIWBRVSUGVGABVRVTWFSWHVHVIVJVTTLVKVMVL $.
    $}

    ${
      frlmsslss2.c $e |- C = { x e. B | ( `' x " ( _V \ { .0. } ) ) C_ J } $.
      $( A subset of a free module obtained by restricting the support set is a
         submodule. ` J ` is the set of permitted unit vectors.  (Contributed
         by Stefan O'Rear, 5-Feb-2015.) $)
      frlmsslss2 $p |- ( ( R e. Ring /\ I e. V /\ J C_ I ) -> C e. U ) $=
        ( wcel wss cdif wceq cvv crg w3a cv cres csn cxp crab ccnv cima cun wfn
        wa cin c0 wb cbs cfv eqid frlmbasf 3ad2antl2 ffn syl simpl3 undif sylib
        wf fneq2d mpbird disjdif a1i c0g fvex eqeltri fnsuppres rabbidva syl5eq
        syl3anc difssd frlmsslss syld3an3 eqeltrd ) DUAPZFHPZGFQZUBZCAUCZFGRZUD
        WGJUEZUFSZABUGZEWECWFUHTWHRUIGQZABUGWJOWEWKWIABWEWFBPZULZWFGWGUJZUKZGWG
        UMUNSZJTPZWKWIUOWMWOWFFUKZWMFDUPUQZWFVFZWRWCWBWLWTWDBDIFWSHWFKWSURMUSUT
        FWSWFVAVBWMWNFWFWMWDWNFSWBWCWDWLVCGFVDVEVGVHWPWMGFVIVJWQWMJDVKUQTNDVKVL
        VMVJGWGWFTJVNVQVOVPWBWCWDWGFQWJEPWEFGVRABWJDEFWGHIJKLMNWJURVSVTWA $.
    $}
  $}

  ${
    $d x B $.  $d x F $.  $d x I $.  $d x J $.  $d x K $.  $d x L $.  $d x R $.
    $d x .0. $.  $d x ph $.  $d x U $.  $d x V $.  $d x .x. $.  $d x X $.
    frlmssuvc1.f $e |- F = ( R freeLMod I ) $.
    frlmssuvc1.u $e |- U = ( R unitVec I ) $.
    frlmssuvc1.b $e |- B = ( Base ` F ) $.
    frlmssuvc1.k $e |- K = ( Base ` R ) $.
    frlmssuvc1.t $e |- .x. = ( .s ` F ) $.
    frlmssuvc1.z $e |- .0. = ( 0g ` R ) $.
    frlmssuvc1.c $e |- C = { x e. B | ( `' x " ( _V \ { .0. } ) ) C_ J } $.
    frlmssuvc1.r $e |- ( ph -> R e. Ring ) $.
    frlmssuvc1.i $e |- ( ph -> I e. V ) $.
    frlmssuvc1.j $e |- ( ph -> J C_ I ) $.

    ${
      frlmssuvc1.l $e |- ( ph -> L e. J ) $.
      frlmssuvc1.x $e |- ( ph -> X e. K ) $.
      $( A scalar multiple of a unit vector included in a support-restriction
         subspace is included in the subspace.  (Contributed by Stefan O'Rear,
         5-Feb-2015.) $)
      frlmssuvc1 $p |- ( ph -> ( X .x. ( U ` L ) ) e. C ) $=
        ( clmod wcel clss cfv csca cbs crg frlmlmod syl2anc wss eqid frlmsslss2
        co syl3anc wceq frlmsca fveq2d syl5eq eleqtrd ccnv cvv csn cdif cima wf
        uvcff sseldd ffvelrnd frlmbasf adantr eldifi adantl cin wne disjdif a1i
        cv wa c0 simpr disjne uvcvv0 suppss cnveq imaeq1d sseq1d elrab2 lssvscl
        sylanbrc syl22anc ) AHUHUIZDHUJUKZUIZNHULUKZUMUKZUILGUKZDUIZNXCFUTDUIAE
        UNUIZIMUIZWRUCUDEHIMPUOUPAXEXFJIUQWTUCUDUEBCDEWSIJMHOPWSURZRUAUBUSVAANK
        XBUGAKEUMUKXBSAEXAUMAXEXFEXAVBUCUDEHIUNMPVCUPVDVEVFAXCCUIZXCVGZVHOVIVJZ
        VKZJUQZXDAICLGAXEXFICGVLUCUDCEGIMHQPRVMUPAJILUEUFVNZVOZAIKBXCJOAXFXHIKX
        CVLUDXNCEHIKMXCPSRVPUPABWDZIJVJZUIZWEZEGILXOUNMOQAXEXQUCVQAXFXQUDVQALIU
        IXQXMVQXQXOIUIAXOIJVRVSXRJXPVTWFVBZLJUIZXQLXOWAXSXRJIWBWCAXTXQUFVQAXQWG
        JXPLXOWHVAUAWIWJXOVGZXJVKZJUQXLBXCCDXOXCVBZYBXKJYCYAXIXJXOXCWKWLWMUBWNW
        PXBWSFDXAHNXCXAURTXBURXGWOWQ $.
    $}

    ${
      frlmssuvc2.l $e |- ( ph -> L e. ( I \ J ) ) $.
      frlmssuvc2.x $e |- ( ph -> X e. ( K \ { .0. } ) ) $.
      $( A nonzero scalar multiple of a unit vector not included in a
         support-restriction subspace is not included in the subspace.
         (Contributed by Stefan O'Rear, 5-Feb-2015.) $)
      frlmssuvc2 $p |- ( ph -> -. ( X .x. ( U ` L ) ) e. C ) $=
        ( cfv co wcel ccnv cvv csn cdif cima wss wa cv wne wn eldifad cmulr cur
        crab crg wf uvcff syl2anc ffvelrnd eqid frlmvscaval uvcvv1 wceq rngridm
        oveq2d 3eqtrd eldifsni syl eqnetrd fveq2 neeq1d elrab eldifbd nelss wfn
        sylanbrc clmod csca cbs frlmlmod frlmsca fveq2d syl5eq eleqtrd lmodvscl
        syl3anc frlmbasf ffn fnniniseg2 3syl sseq1d mtbird intnand cnveq elrab2
        imaeq1d sylnibr ) ANLGUHZFUIZCUJZXIUKZULOUMZUNZUOZJUPZUQXIDUJAXOXJAXOBU
        RZXIUHZOUSZBIVDZJUPZALXSUJZLJUJUTXTUTALIUJLXIUHZOUSZYAALIJUFVAZAYBNOAYB
        NLXHUHZEVBUHZUINEVCUHZYFUIZNANCEFYFILKMXHHPRSUDANKXLUGVAZAICLGAEVEUJZIM
        UJZICGVFUCUDCEGIMHQPRVGVHYDVIZYDTYFVJZVKAYEYGNYFAEGYGILVEMQUCUDYDYGVJZV
        LVOAYJNKUJYHNVMUCYIKEYFYGNSYMYNVNVHVPANKXLUNUJNOUSUGNKOVQVRVSXRYCBLIXPL
        VMXQYBOXPLXIVTWAWBWFALIJUFWCLXSJWDVHAXNXSJAIKXIVFZXIIWEXNXSVMAYKXJYOUDA
        HWGUJZNHWHUHZWIUHZUJXHCUJXJAYJYKYPUCUDEHIMPWJVHANKYRYIAKEWIUHYRSAEYQWIA
        YJYKEYQVMUCUDEHIVEMPWKVHWLWMWNYLNFYQYRCHXHRYQVJTYRVJWOWPCEHIKMXIPSRWQVH
        IKXIWRBIOXIWSWTXAXBXCXPUKZXMUOZJUPXOBXICDXPXIVMZYTXNJUUAYSXKXMXPXIXDXFX
        AUBXEXG $.
    $}
  $}

  ${
    $d Y x y z $.  $d U x y z $.  $d B x y $.  $d .0. x y $.  $d R x y z $.
    $d C y z $.  $d I x y z $.  $d V x y z $.  $d J x y z $.  $d K x y z $.
    frlmsslsp.y $e |- Y = ( R freeLMod I ) $.
    frlmsslsp.u $e |- U = ( R unitVec I ) $.
    frlmsslsp.k $e |- K = ( LSpan ` Y ) $.
    frlmsslsp.b $e |- B = ( Base ` Y ) $.
    frlmsslsp.z $e |- .0. = ( 0g ` R ) $.
    frlmsslsp.c $e |- C = { x e. B | ( `' x " ( _V \ { .0. } ) ) C_ J } $.
    $( A subset of a free module obtained by restricting the support set is
       spanned by the relevant unit vectors.  (Contributed by Stefan O'Rear,
       6-Feb-2015.) $)
    frlmsslsp $p |- ( ( R e. Ring /\ I e. V /\ J C_ I ) ->
        ( K ` ( U " J ) ) = C ) $=
      ( wcel cfv adantr vy vz crg wss w3a cima clmod clss frlmlmod 3adant3 eqid
      frlmsslss2 cv wral wa ccnv cvv cdif wf uvcff simp3 sselda ffvelrnd simpl2
      csn cbs frlmbasf syl2anc simpll1 simpll2 eldifi adantl wne cin c0 disjdif
      disjne mp3an1 adantll uvcvv0 suppss cnveq imaeq1d sseq1d elrab2 ralrimiva
      wceq sylanbrc wfun cdm wfn ffn syl fnfun sseqtr4d funimass4 mpbird lspssp
      wb fndm syl3anc cvsca cof co cgsu simpl1 crab ssrab2 eqsstri a1i uvcresum
      c0g cabel lmodabl csubg crn imassrn frn syl5ss lspcl 3ad2antl2 inidm offn
      lsssubg syldan adantrr simprr fnfvof syl22anc csca adantrl fveq2d suppssr
      sseli ad2antrr eqtrd oveq1d lmod0vs eqeltrd cfn sylan2 frlmsca eleqtrd wi
      lspssid funfvima2 imp sseldd lssvscl anassrs adantlrr wn id simplrr simpr
      eldifd simprbi syl5eq ffvelrnda lss0cl pm2.61dan expr ralrimiv frlmbassup
      weq ffnfv dffn2 sylib ssid ffvelrn syl2an 3eqtrd ssfi gsumsubgcl ex ssrdv
      eqssd ) DUCRZFIRZGFUDZUEZEGUFZHSZCUWAJUGRZCJUHSZRUWBCUDZUWCCUDUVRUVSUWDUV
      TDJFILUIUJZABCDUWEFGIJKLUWEUKZOPQULUWAUWFUAUMZESZCRZUAGUNZUWAUWKUAGUWAUWI
      GRZUOZUWJBRZUWJUPZUQKVEURZUFZGUDZUWKUWNFBUWIEUWAFBEUSZUWMUVRUVSUWTUVTBDEF
      IJMLOUTUJZTUWAGFUWIUVRUVSUVTVAZVBZVCZUWNFDVFSZAUWJGKUWNUVSUWOFUXEUWJUSUVR
      UVSUVTUWMVDUXDBDJFUXEIUWJLUXEUKZOVGVHUWNAUMZFGURZRZUODEFUWIUXGUCIKMUVRUVS
      UVTUWMUXIVIUVRUVSUVTUWMUXIVJUWNUWIFRUXIUXCTUXIUXGFRZUWNUXGFGVKVLUWMUXIUWI
      UXGVMZUWAGUXHVNVOWGUWMUXIUXKGFVPGUXHUWIUXGVQVRVSPVTWAUXGUPZUWQUFZGUDZUWSA
      UWJBCUXGUWJWGZUXMUWRGUXOUXLUWPUWQUXGUWJWBWCWDQWEWHWFUWAEWIZGEWJZUDZUWFUWL
      WSUWAEFWKZUXPUWAUWTUXSUXAFBEWLWMZFEWNWMZUWAGFUXQUXBUWAUXSUXQFWGUXTFEWTWMW
      OZUAGCEWPVHWQUWEUWBCHJUWHNWRXAUWAUACUWCUWAUWICRZUWIUWCRUWAUYCUOZUWIJUWIEJ
      XBSZXCXDZXEXDZUWCUYDUVRUVSUWIBRZUWIUYGWGUVRUVSUVTUYCXFUVRUVSUVTUYCVDZUWAC
      BUWICBUDUWACUXNABXGBQUXNABXHXIZXJVBZBDUYEEFIUWIJMLOUYEUKZXKXAUYDFUWCUYFJI
      JXLSZUYMUKZUWAJXMRZUYCUWAUWDUYOUWGJXNWMTUYIUWAUWCJXOSRZUYCUWAUWDUWCUWERZU
      YPUWGUWAUWDUWBBUDZUYQUWGUWAUWBEXPZBEGXQUWAUWTUYSBUDUXAFBEXRWMXSZUWEUWBHBJ
      OUWHNXTVHZUWEUWCJUWHYDVHTUYDUYFFWKZUBUMZUYFSZUWCRZUBFUNFUWCUYFUSUWAUYCUYH
      VUBUYKUWAUYHUOZFFUYEFUWIEIIVUFFUXEUWIUSZUWIFWKZUVSUVRUYHVUGUVTBDJFUXEIUWI
      LUXFOVGYAZFUXEUWIWLWMZUWAUXSUYHUXTTUVRUVSUVTUYHVDZVUKFYBYCZYEUYDVUEUBFUWA
      UYCVUCFRZVUEUWAUYCVUMUOZUOZVUDVUCUWISZVUCESZUYEXDZUWCVUOVUHUXSUVSVUMVUDVU
      RWGUWAUYCVUHVUMUWAUYCUYHVUHUYKVUJYEYFUWAUXSVUNUXTTUVRUVSUVTVUNVDUWAUYCVUM
      YGFUYEUWIEIVUCYHYIVUOVUCGRZVURUWCRZUWAUYCVUSVUTVUMUWAUYCVUSVUTUWAUYCVUSUO
      ZUOZUWDUYQVUPJYJSZVFSZRVUQUWCRVUTUWAUWDVVAUWGTUWAUYQVVAVUATVVBVUPUXEVVDVV
      BFUXEVUCUWIUWAUYCVUGVUSUYCUWAUYHVUGCBUWIUYJYNVUIUUAZYFUWAVUSVUMUYCUWAGFVU
      CUXBVBYKVCUWAUXEVVDWGVVAUWADVVCVFUVRUVSDVVCWGUVTDJFUCILUUBUJZYLTUUCVVBUWB
      UWCVUQUWAUWBUWCUDZVVAUWAUWDUYRVVGUWGUYTUWBHBJONUUEVHTUWAVUSVUQUWBRZUYCUWA
      VUSVVHUWAUXPUXRVUSVVHUUDUYAUYBGVUCEUUFVHUUGYKUUHVVDUWEUYEUWCVVCJVUPVUQVVC
      UKZUYLVVDUKUWHUUIYIUUJUUKVUOVUSUULZUOZVURUYMUWCVVKVURVVCXLSZVUQUYEXDZUYMV
      VKVUPVVLVUQUYEVVKVUPKVVLVVKUYDVUCUXHRVUPKWGVUOUYDVVJUWAUYCUYDVUMUYDUUMYFT
      VVKVUCFGUWAUYCVUMVVJUUNVUOVVJUUOUUPUYDFUXEUWIGVUCKVVEUYCUWIUPZUWQUFZGUDZU
      WAUYCUYHVVPUXNVVPAUWIBCAUAUVEZUXMVVOGVVQUXLVVNUWQUXGUWIWBWCWDQWEUUQVLYMVH
      UWAKVVLWGZVUNVVJUWAKDXLSVVLPUWADVVCXLVVFYLUURZYOYPYQVVKUWDVUQBRZVVMUYMWGU
      WAUWDVUNVVJUWGYOZVUOVVTVVJUWAVUMVVTUYCUWAFBVUCEUXAUUSYKTUYEVVCVVLBJVUQUYM
      OVVIUYLVVLUKZUYNYRVHYPVVKUWDUYQUYMUWCRVWAUWAUYQVUNVVJVUAYOUWEUWCJUYMUYNUW
      HUUTVHYSUVAYSUVBUVCUBFUWCUYFUVFWHUYDVVOYTRZUYFUPUQUYMVEURUFZVVOUDZVWDYTRU
      YDUVSUYHVWCUYIUYKBDJFIUWIKLPOUVDVHUWAUYCUYHVWEUYKVUFFUQAUYFVVOUYMVUFVUBFU
      QUYFUSVULFUYFUVGUVHVUFUXGFVVOURRZUOZUXGUYFSZUXGUWISZUXGESZUYEXDZVVLVWJUYE
      XDZUYMVWGVUHUXSUVSUXJVWHVWKWGVUFVUHVWFVUJTUWAUXSUYHVWFUXTYOUVRUVSUVTUYHVW
      FVJVWFUXJVUFUXGFVVOVKZVLFUYEUWIEIUXGYHYIVWGVWIVVLVWJUYEVWGVWIKVVLVUFFUXEU
      WIVVOUXGKVUIVVOVVOUDVUFVVOUVIXJYMUWAVVRUYHVWFVVSYOYPYQVWGUWDVWJBRZVWLUYMW
      GUWAUWDUYHVWFUWGYOVUFUWTUXJVWNVWFUWAUWTUYHUXATVWMFBUXGEUVJUVKUYEVVCVVLBJV
      WJUYMOVVIUYLVWBUYNYRVHUVLWAYEVVOVWDUVMVHUVNYSUVOUVPUVQ $.
  $}

  ${
    $d F a b c d $.  $d U a b c d $.  $d J a b c d $.  $d R a b c d $.
    $d I a b c d $.  $d V a b c d $.
    frlmlbs.f $e |- F = ( R freeLMod I ) $.
    frlmlbs.u $e |- U = ( R unitVec I ) $.
    frlmlbs.j $e |- J = ( LBasis ` F ) $.
    $( The unit vectors comprise a basis for a free module.  (Contributed by
       Stefan O'Rear, 6-Feb-2015.) $)
    frlmlbs $p |- ( ( R e. Ring /\ I e. V ) -> ran U e. J ) $=
      ( vb va vc wcel cfv wss wceq csn cdif wral eqid crg wa crn clspn cv cvsca
      cbs co wn csca c0g uvcff frn syl ccnv cvv cima crab cdm cnvimass frlmbasf
      wfn adantll ffn fndm 3syl syl5sseq ralrimiva rabid2 sylibr ssid frlmsslsp
      mp3an3 fnima fveq2d 3eqtr2rd simpll simplr difssd vex snid snssi ad2antrl
      wf dfss4 sylib syl5eleqr frlmsca sneqd difeq12d eleq2d biimpar frlmssuvc2
      adantrl wfun cnzr rngelnzr syl2anc uvcf1 df-f1 simprbi imadif f1fn simprl
      wf1 fnsnfv eqcomd eqtr2d syl3anc eqtrd neleqtrrd ralrimivva wb oveq2 sneq
      difeq2d eleq12d notbid ralbidv ralrn mpbird w3a cfrlm eqeltri islbs ax-mp
      ovex syl3anbrc ) AUAMZDFMZUBZBUCZCUGNZOZYLCUDNZNZYMPZJUEZKUEZCUFNZUHZYLYS
      QZRZYONZMZUIZJCUJNZUGNZUUGUKNZQZRZSZKYLSZYLEMZYKDYMBWDZYNYMABDFCHGYMTZULZ
      DYMBUMUNYKYMYSUOUPAUKNZQZRZUQZDOZKYMURZBDUQZYONZYPYKUVBKYMSYMUVCPYKUVBKYM
      YKYSYMMZUBZYSUSZUVADYSUUTUTUVGDAUGNZYSWDZYSDVBUVHDPYJUVFUVJYIYMACDUVIFYSG
      UVITZUUPVAVCDUVIYSVDDYSVEVFVGVHUVBKYMVIVJYIYJDDOUVEUVCPDVKKYMUVCABDDYOFCU
      URGHYOTZUUPUURTZUVCTVLVMYKUVDYLYOYKUUOBDVBZUVDYLPZUUQDYMBVDZDBVNZVFVOVPYK
      UUMYRLUEZBNZYTUHZYLUVSQZRZYONZMZUIZJUUKSZLDSZYKUWELJDUUKYKUVRDMZYRUUKMZUB
      ZUBZUWCUVADUVRQZRZOKYMURZUVTUWKKYMUWNAYTBCDUWMUVIUVRFYRUURGHUUPUVKYTTZUVM
      UWNTZYIYJUWJVQZYIYJUWJVRZUWKDUWLVSZUWKUVRUWLDUWMRZUVRLVTWAUWKUWLDOZUWTUWL
      PUWHUXAYKUWIUVRDWBWCUWLDWEWFWGYKUWIYRUVIUUSRZMZUWHYKUXCUWIYKUXBUUKYRYKUVI
      UUHUUSUUJYKAUUGUGACDUAFGWHZVOYKUURUUIYKAUUGUKUXDVOWIWJWKWLWNZWMUWKUWCBUWM
      UQZYONZUWNUWKUWBUXFYOUWKUXFUVDBUWLUQZRZUWBUWKDYMBXEZBUOWOZUXFUXIPUWKAWPMZ
      YJUXJUWKYIUXCUXLUWQUXEUVIAYRUURUVMUVKWQWRUWRYMABDFCHGUUPWSWRZUXJUUOUXKDYM
      BWTXADUWLBXBVFUWKUVDYLUXHUWAUWKUXJUVNUVOUXMDYMBXCZUVQVFUWKUWAUXHUWKUVNUWH
      UWAUXHPUWKUXJUVNUXMUXNUNYKUWHUWIXDDUVRBXFWRXGWJXHVOUWKYIYJUWMDOUXGUWNPUWQ
      UWRUWSKYMUWNABDUWMYOFCUURGHUVLUUPUVMUWPVLXIXJXKXLYKUUOUVNUUMUWGXMUUQUVPUU
      LUWFKLDBYSUVSPZUUFUWEJUUKUXOUUEUWDUXOUUAUVTUUDUWCYSUVSYRYTXNUXOUUCUWBYOUX
      OUUBUWAYLYSUVSXOXPVOXQXRXSXTVFYACUPMUUNYNYQUUMYBXMCADYCUHUPGADYCYGYDKJYLY
      TUUGEUUHYOYMCUPUUIUUPUUGTUWOUUHTIUVLUUITYEYFYH $.
  $}

  ${
    $d R x y z w $.  $d I x y z w $.  $d F x y z w $.  $d B x y z w $.
    $d C x y z w $.  $d .x. x y z w $.  $d E y z w $.  $d A x y z w $.
    $d X x y z w $.  $d K x y z w $.  $d ph x y z w $.  $d Y x y z w $.
    $d U x y z w $.  $d T x y z w $.
    frlmup.f $e |- F = ( R freeLMod I ) $.
    frlmup.b $e |- B = ( Base ` F ) $.
    frlmup.c $e |- C = ( Base ` T ) $.
    frlmup.v $e |- .x. = ( .s ` T ) $.
    frlmup.e $e |- E = ( x e. B |-> ( T gsum ( x oF .x. A ) ) ) $.
    frlmup.t $e |- ( ph -> T e. LMod ) $.
    frlmup.i $e |- ( ph -> I e. X ) $.
    frlmup.r $e |- ( ph -> R = ( Scalar ` T ) ) $.
    frlmup.a $e |- ( ph -> A : I --> C ) $.
    $( Any assignment of unit vectors to target vectors can be extended
       (uniquely) to a homomorphism from a free module to an arbitrary other
       module on the same base ring.  (Contributed by Stefan O'Rear,
       7-Feb-2015.) $)
    frlmup1 $p |- ( ph -> E e. ( F LMHom T ) ) $=
      ( vy vz cvsca cfv csca cbs eqid crg wcel lmodrng eqeltrd frlmlmod syl2anc
      clmod syl wceq frlmsca eqtr3d cplusg cgrp lmodgrp cv cof co cgsu wa eleq1
      wi weq anbi2d oveq1 oveq2d eleq1d imbi12d c0g ccmn adantr ad2antrr simprl
      lmodcmn fveq2d eleqtrd simprr lmodvscl syl3anc wf frlmbasf sylan off ccnv
      inidm cvv csn cdif cima cfn wss sneqd difeq2d imaeq2d frlmbassup eqeltrrd
      wfn ffn eldifi adantl fnfvof syl22anc ssid suppssr oveq1d ffvelrn lmod0vs
      a1i syl2an 3eqtrd suppss ssfi gsumcl chvarv adantrr adantrl imaeq1d fvmpt
      cnveqd ovex oveqd ffvelrnda syl13anc eqtrd simpr oveq12d 3eqtr4d ad2antll
      offn cmpt feqmptd cmulr eleqtrrd fmptd feq1d 3expb frlmplusgval lmodvsdir
      gsumadd lmodvacl eqfnfvd ad2antrl isghmd eleq2d biimpar gsumvsmul simplrl
      dffn2 adantlrl adantlr lmodvsass simplrr frlmvscaval mpteq2dva islmhmd
      sylib ) AUBUCJGJUDUEZHIGUFUEZJUFUEZUVFUGUEZDNUVDUHZPUVFUHZUVEUHZUVGUHZAFU
      IUJZKLUJZJUOUJZAFUVEUITAGUOUJZUVEUIUJRUVEGUVJUKUPULZSFJKLMUMUNZRAFUVEUVFT
      AUVLUVMFUVFUQUVPSFJKUILMURUNZUSZAUBUCJUTUEZGUTUEZJGIDENOUVTUHZUWAUHZAUVNJ
      VAUJUVQJVBUPAUVOGVAUJRGVBUPABDGBVCZCHVDZVEZVFVEZEIAUCVCZDUJZVGZGUWHCUWEVE
      ZVFVEZEUJZVIAUWDDUJZVGZUWGEUJZVIUCBUCBVJZUWJUWOUWMUWPUWQUWIUWNAUWHUWDDVHV
      KUWQUWLUWGEUWQUWKUWFGVFUWHUWDCUWEVLVMVNVOUWJKEUWKGLGVPUEZOUWRUHZAGVQUJZUW
      IAUVOUWTRGWAUPZVRAUVMUWISVRZUWJBUBKKKHFUGUEZEEUWHCLLUWJUWDUXCUJZUBVCZEUJZ
      VGZVGZUVOUWDUVEUGUEZUJUXFUWDUXEHVEEUJAUVOUWIUXGRVSUXHUWDUXCUXIUWJUXDUXFVT
      AUXCUXIUQZUWIUXGAFUVEUGTWBZVSWCUWJUXDUXFWDUWDHUVEUXIEGUXEOUVJPUXIUHZWEWFA
      UVMUWIKUXCUWHWGZSDFJKUXCLUWHMUXCUHZNWHWIZAKECWGZUWIUAVRZUXBUXBKWLZWJZUWJU
      WHWKZWMUVEVPUEZWNZWOZWPZWQUJUWKWKZWMUWRWNWOZWPZUYDWRUYGWQUJZUWJUXTWMFVPUE
      ZWNZWOZWPZUYDWQAUYLUYDUQUWIAUYKUYCUXTAUYJUYBWMAUYIUYAAFUVEVPTWBWSWTXAVRAU
      VMUWIUYLWQUJSDFJKLUWHUYIMUYIUHNXBWIXCUWJKEBUWKUYDUWRUXSUWJUWDKUYDWOUJZVGZ
      UWDUWKUEZUWDUWHUEZUWDCUEZHVEZUYAUYQHVEZUWRUYNUWHKXDZCKXDZUVMUWDKUJZUYOUYR
      UQZUWJUYTUYMUWJUXMUYTUXOKUXCUWHXEZUPZVRAVUAUWIUYMAUXPVUAUAKECXEUPZVSAUVMU
      WIUYMSVSUYMVUBUWJUWDKUYDXFZXGKHUWHCLUWDXHZXIUYNUYPUYAUYQHUWJKUXCUWHUYDUWD
      UYAUXOUYDUYDWRUWJUYDXJXOXKXLUYNUVOUYQEUJZUYSUWRUQAUVOUWIUYMRVSUWJUXPVUBVU
      IUYMUXQVUGKEUWDCXMXPHUVEUYAEGUYQUWROUVJPUYAUHUWSXNUNXQXRUYDUYGXSUNZXTYAQU
      UAAUXEDUJZUWIVGZVGZGUXECUWEVEZUWKUWAVDVEZVFVEZGVUNVFVEZUWLUWAVEUXEUWHUVTV
      EZIUEZUXEIUEZUWHIUEZUWAVEVUMKEUWAVUNGUWKLUWROUWSUWCAUWTVULUXAVRAUVMVULSVR
      ZAVUKKEVUNWGZUWIUWJKEUWKWGZVIAVUKVGZVVCVIUCUBUCUBVJZUWJVVEVVDVVCVVFUWIVUK
      AUWHUXEDVHVKZVVFKEUWKVUNUWHUXECUWEVLZUUBVOUXSYAZYBAUWIVVDVUKUXSYCAVUKVUNW
      KZUYFWPZWQUJZUWIUWJUYHVIVVEVVLVIUCUBVVFUWJVVEUYHVVLVVGVVFUYGVVKWQVVFUYEVV
      JUYFVVFUWKVUNVVHYFYDVNVOVUJYAYBAUWIUYHVUKVUJYCUUFVUMVUSGVURCUWEVEZVFVEZVU
      PVUMVURDUJZVUSVVNUQAUVNVULVVOUVQUVNVUKUWIVVOUVTDJUXEUWHNUWBUUGUUCWIBVURUW
      GVVNDIUWDVURUQUWFVVMGVFUWDVURCUWEVLVMQGVVMVFYGYEUPVUMVVMVUOGVFVUMVVMUXEUW
      HFUTUEZVDVEZCUWEVEZVUOVUMVURVVQCUWEVUMDVVPUVTFUXEUWHKUILJMNAUVLVULUVPVRVV
      BAVUKUWIVTAVUKUWIWDVVPUHUWBUUDXLVUMBKVVRVUOVUMKKHKVVQCLLVUMKKVVPKUXEUWHLL
      VUMKUXCUXEWGZUXEKXDZAVUKVVSUWIAUVMVUKVVSSDFJKUXCLUXEMUXNNWHWIYBZKUXCUXEXE
      UPZVUMUXMUYTAUWIUXMVUKUXOYCZVUDUPZVVBVVBUXRYPZAVUAVULVUFVRVVBVVBUXRYPVUMK
      KUWAKVUNUWKLLAVUKVUNKXDZUWIVVEVVCVWFVVIKEVUNXEUPYBZAUWIUWKKXDZVUKUWJVVDVW
      HUXSKEUWKXEUPYCZVVBVVBUXRYPVUMVUBVGZUWDVVQUEZUYQHVEZUWDVUNUEZUYOUWAVEZUWD
      VVRUEZUWDVUOUEZVWJUWDUXEUEZUYPVVPVEZUYQHVEZVWQUYQHVEZUYRUWAVEZVWLVWNVWJVW
      SVWQUYPUVEUTUEZVEZUYQHVEZVXAVWJVWRVXCUYQHVWJVVPVXBVWQUYPAVVPVXBUQVULVUBAF
      UVEUTTWBVSYHXLVWJUVOVWQUXIUJUYPUXIUJZVUIVXDVXAUQAUVOVULVUBRVSVWJVWQUXCUXI
      VUMKUXCUWDUXEVWAYIAUXJVULVUBUXKVSZWCVWJUYPUXCUXIVUMKUXCUWDUWHVWCYIVXFWCVU
      MKEUWDCAUXPVULUAVRYIUWAVXBVWQUYPHUVEUXIEGUYQOUWCUVJPUXLVXBUHUUEYJYKVWJVWK
      VWRUYQHVWJVVTUYTUVMVUBVWKVWRUQVUMVVTVUBVWBVRZVUMUYTVUBVWDVRZAUVMVULVUBSVS
      ZVUMVUBYLZKVVPUXEUWHLUWDXHXIXLVWJVWMVWTUYOUYRUWAVWJVVTVUAUVMVUBVWMVWTUQVX
      GAVUAVULVUBVUFVSZVXIVXJKHUXECLUWDXHXIVWJUYTVUAUVMVUBVUCVXHVXKVXIVXJVUHXIY
      MYNVWJVVQKXDZVUAUVMVUBVWOVWLUQVUMVXLVUBVWEVRVXKVXIVXJKHVVQCLUWDXHXIVWJVWF
      VWHUVMVUBVWPVWNUQVUMVWFVUBVWGVRVUMVWHVUBVWIVRVXIVXJKUWAVUNUWKLUWDXHXIYNUU
      HYKVMYKVUMVUTVUQVVAUWLUWAVUKVUTVUQUQAUWIBUXEUWGVUQDIBUBVJUWFVUNGVFUWDUXEC
      UWEVLVMQGVUNVFYGYEUUIUWIVVAUWLUQAVUKBUWHUWGUWLDIBUCVJUWFUWKGVFUWDUWHCUWEV
      LVMQGUWKVFYGYEZYOYMYNUUJAUXEUVGUJZUWIVGZVGZGUXEUWHUVDVEZCUWEVEZVFVEZUXEUW
      LHVEZVXQIUEZUXEVVAHVEZVXPGBKUXEUYOHVEZYQZVFVEUXEGBKUYOYQZVFVEZHVEVXSVXTVX
      PKEUWAGUVEHBUXILUXEUYOUWROUVJUXLUWSUWCPAUVOVXORVRAUVMVXOSVRZAVXNUXEUXIUJZ
      UWIAVYHVXNAUXIUVGUXEAUVEUVFUGUVSWBZUUKUULYBVXPKEUWDUWKAUWIVVDVXNUXSYCZYIA
      UWIVYEWKZUYFWPZWQUJVXNUWJUYGVYLWQUWJUYEVYKUYFUWJUWKVYEUWJBKEUWKUXSYRYFYDV
      UJXCYCUUMVXPVXRVYDGVFVXPVXRBKUWDVXRUEZYQVYDVXPBKWMVXRVXPVXRKXDKWMVXRWGVXP
      KKHKVXQCLLVXPKUXCVXQWGZVXQKXDZVXPUVMVXQDUJZVYNVYGVXPUVNVXNUWIVYPAUVNVXOUV
      QVRAVXNUWIVTAVXNUWIWDUXEUVDUVFUVGDJUWHNUVIUVHUVKWEWFZDFJKUXCLVXQMUXNNWHUN
      KUXCVXQXEUPZAVUAVXOVUFVRVYGVYGUXRYPKVXRUUOUVCYRVXPBKVYMVYCVXPVUBVGZUXEUYP
      FYSUEZVEZUYQHVEZUXEUYRHVEZVYMVYCVYSWUBUXEUYPUVEYSUEZVEZUYQHVEZWUCVYSWUAWU
      EUYQHVYSVYTWUDUXEUYPAVYTWUDUQVXOVUBAFUVEYSTWBVSYHXLVYSUVOVYHVXEVUIWUFWUCU
      QAUVOVXOVUBRVSVYSUXEUVGUXIAVXNUWIVUBUUNZAUXIUVGUQVXOVUBVYIVSYTAUWIVUBVXEV
      XNUWJVUBVGUYPUXCUXIUWJKUXCUWDUWHUXOYIAUXJUWIVUBUXKVSWCUUPAVUBVUIVXOAKEUWD
      CUAYIUUQUXEUYPHWUDUVEUXIEGUYQOUVJPUXLWUDUHUURYJYKVYSVYMUWDVXQUEZUYQHVEZWU
      BVYSVYOVUAUVMVUBVYMWUIUQVXPVYOVUBVYRVRAVUAVXOVUBVUFVSZAUVMVXOVUBSVSZVXPVU
      BYLZKHVXQCLUWDXHXIVYSWUHWUAUYQHVYSUXEDFUVDVYTKUWDUXCLUWHJMNUXNWUKVYSUXEUV
      GUXCWUGAUXCUVGUQVXOVUBAFUVFUGUVRWBVSYTAVXNUWIVUBUUSWULUVHVYTUHUUTXLYKVYSU
      YOUYRUXEHVYSUYTVUAUVMVUBVUCVXPUYTVUBAUWIUYTVXNVUEYCVRWUJWUKWULVUHXIVMYNUV
      AYKVMVXPUWLVYFUXEHVXPUWKVYEGVFVXPBKEUWKVYJYRVMVMYNVXPVYPVYAVXSUQVYQBVXQUW
      GVXSDIUWDVXQUQUWFVXRGVFUWDVXQCUWEVLVMQGVXRVFYGYEUPUWIVYBVXTUQAVXNUWIVVAUW
      LUXEHVXMVMYOYNUVB $.

    ${
      frlmup.y $e |- ( ph -> Y e. I ) $.
      frlmup.u $e |- U = ( R unitVec I ) $.
      $( The evaluation map has the intended behavior on the unit vectors.
         (Contributed by Stefan O'Rear, 7-Feb-2015.) $)
      frlmup2 $p |- ( ph -> ( E ` ( U ` Y ) ) = ( A ` Y ) ) $=
        ( cfv cof co cgsu wcel wceq crg wf csca clmod lmodrng syl eqeltrd uvcff
        eqid syl2anc ffvelrnd cv oveq1 oveq2d ovex c0g ccmn cmnd lmodcmn cmnmnd
        fvmpt 3syl cbs frlmbasf fveq2d feq3 mpbid lcomf csn cdif wfn ffn adantr
        wb wa eldifi adantl fnfvof syl22anc eldifsni necomd uvcvv0 eqtrd oveq1d
        wne ffvelrn syl2an lmod0vs 3eqtrd suppss gsumpt cur uvcvv1 lmodvs1 ) AN
        IUFZJUFZGXFCHUGZUHZUIUHZNXIUFZNCUFZAXFDUJZXGXJUKALDNIAFULUJZLMUJZLDIUMA
        FGUNUFZULUBAGUOUJZXPULUJTXPGXPUTZUPUQURZUADFILMKUEOPUSVAUDVBZBXFGBVCZCX
        HUHZUIUHXJDJYAXFUKYBXIGUIYAXFCXHVDVESGXIUIVFVLUQALEXIGMNGVGUFZQYCUTZAXQ
        GVHUJGVIUJTGVJGVKVMUAUDAEHXPXFCLXPVNUFZMGXRYEUTRQTALFVNUFZXFUMZLYEXFUMZ
        AXOXMYGUAXTDFKLYFMXFOYFUTPVOVAZAYFYEUKYGYHWEAFXPVNUBVPYFYELXFVQUQVRUCUA
        VSZALEBXINVTZYCYJAYALYKWAUJZWFZYAXIUFZYAXFUFZYACUFZHUHZXPVGUFZYPHUHZYCY
        MXFLWBZCLWBZXOYALUJZYNYQUKAYTYLAYGYTYILYFXFWCUQZWDAUUAYLALECUMZUUAUCLEC
        WCUQZWDAXOYLUAWDZYLUUBAYALYKWGZWHZLHXFCMYAWIWJYMYOYRYPHYMYOFVGUFZYRYMFI
        LNYAULMUUIUEAXNYLXSWDUUFANLUJZYLUDWDUUHYLNYAWPAYLYANYALNWKWLWHUUIUTWMAU
        UIYRUKYLAFXPVGUBVPWDWNWOYMXQYPEUJZYSYCUKAXQYLTWDAUUDUUBUUKYLUCUUGLEYACW
        QWRHXPYREGYPYCQXRRYRUTYDWSVAWTXAXBAXKNXFUFZXLHUHZXPXCUFZXLHUHZXLAYTUUAX
        OUUJXKUUMUKUUCUUEUAUDLHXFCMNWIWJAUULUUNXLHAUULFXCUFZUUNAFIUUPLNULMUEXSU
        AUDUUPUTXDAFXPXCUBVPWNWOAXQXLEUJUUOXLUKTALENCUCUDVBHUUNXPEGXLQXRRUUNUTX
        EVAWTWT $.
    $}

    $d ph u $.  $d Y u $.  $d G u $.  $d I u x $.  $d A u $.  $d E u $.
    $d R u $.
    frlmup.k $e |- K = ( LSpan ` T ) $.
    $( The range of such an evaluation map is the finite linear combinations of
       the target vectors and also the span of the target vectors.
       (Contributed by Stefan O'Rear, 6-Feb-2015.) $)
    frlmup3 $p |- ( ph -> ran E = ( K ` ran A ) ) $=
      ( vu cuvc co crn clspn cfv cima clmhm wcel wss wceq frlmup1 wf csca clmod
      crg eqid lmodrng syl eqeltrd uvcff syl2anc frn lmhmlsp wfn lmhmf ffn clbs
      fnima frlmlbs lbssp eqcomd imaeq2d ccom imaco fnco syl3anc cv fvco2 sylan
      eqtr3d adantr simpr frlmup2 eqtr2d eqfnfvd imaeq1d 3eqtr3a fveq2d 3eqtr4d
      wa ) AIFKUEUFZUGZJUHUIZUIZUJZIWPUJZLUIZIUGZCUGZLUIAIJGUKUFULZWPDUMZWSXAUN
      ABCDEFGHIJKMNOPQRSTUAUBUOZAKDWOUPZXEAFUSULZKMULZXGAFGUQUIZUSUAAGURULZXJUS
      ULSXJGXJUTVAVBVCZTDFWOKMJWOUTZNOVDVEZKDWOVFVBZJGWPIWQLDOWQUTZUCVGVEAIDUJZ
      XBWSAIDVHZXQXBUNADEIUPZXRAXDXSXFDEJGIOPVIVBDEIVJVBZDIVLVBADWRIAWRDAWPJVKU
      IZULZWRDUNAXHXIYBXLTFWOJKYAMNXMYAUTZVMVEWPYAWQDJOYCXPVNVBVOVPWDAXCWTLAIWO
      VQZKUJZIWOKUJZUJXCWTIWOKVRACKUJZYEXCACYDKAUDKCYDAKECUPZCKVHZUBKECVJVBZAXR
      WOKVHZXEYDKVHXTAXGYKXNKDWOVJVBZXODKIWOVSVTAUDWAZKULZWNZYMYDUIZYMWOUIIUIZY
      MCUIAYKYNYPYQUNYLKIWOYMWBWCYOBCDEFGHWOIJKMYMNOPQRAXKYNSWEAXIYNTWEAFXJUNYN
      UAWEAYHYNUBWEAYNWFXMWGWHWIWJAYIYGXCUNYJKCVLVBWDAYFWPIAYKYFWPUNYLKWOVLVBVP
      WKWLWM $.
  $}

  ${
    $d A m x $.  $d A y $.  $d C x y $.  $d F m x $.  $d F y $.  $d I x y $.
    $d R x $.  $d T m x $.  $d T y $.  $d U m x $.  $d U y $.  $d X x y $.
    frlmup4.r $e |- R = ( Scalar ` T ) $.
    frlmup4.f $e |- F = ( R freeLMod I ) $.
    frlmup4.u $e |- U = ( R unitVec I ) $.
    frlmup4.c $e |- C = ( Base ` T ) $.
    $( Universal propery of the free module by existential uniquenes.
       (Contributed by Stefan O'Rear, 7-Mar-2015.) $)
    frlmup4 $p |- ( ( T e. LMod /\ I e. X /\ A : I --> C ) ->
        E! m e. ( F LMHom T ) ( m o. U ) = A ) $=
      ( vx wcel wceq cfv eqid syl2anc syl vy clmod wf w3a cv ccom clmhm co wrex
      wrmo wreu cbs cvsca cof cgsu cmpt simp1 simp2 csca a1i simp3 frlmup1 ovex
      wfn crn wss fnmpti crg lmodrng 3ad2ant1 uvcff ffn frn syl3anc 3ad2ant3 wa
      fnco adantr simpr fvco2 simpl1 simpl2 simpl3 frlmup2 eqtrd eqfnfvd eqeq1d
      coeq1 rspcev cres ccnv wi wral wfun funcoeqres ex ralrimivw clspn frlmlbs
      ffun clbs lbssp lspextmo rmoim sylc reu5 sylanbrc ) DUBOZHIOZHBAUCZUDZFUE
      ZEUFZAPZFGDUGUHZUIZXNFXOUJZXNFXOUKXKNGULQZDNUEADUMQZUNUHZUOUHZUPZXOOYBEUF
      ZAPZXPXKNAXRBCDXSYBGHIKXRRZMXSRZYBRZXHXIXJUQXHXIXJURZCDUSQPZXKJUTXHXIXJVA
      VBXKUAHYCAXKYBXRVDZEHVDZEVEZXRVFZYCHVDYJXKNXRYAYBDXTUOVCYGVGUTXKHXREUCZYK
      XKCVHOZXIYNXHXIYOXJCDJVIVJZYHXRCEHIGLKYEVKSZHXREVLZTXKYNYMYQHXREVMTZXRHYB
      EVQVNXJXHAHVDXIHBAVLVOXKUAUEZHOZVPZYTYCQZYTEQYBQZYTAQUUBYKUUAUUCUUDPUUBYN
      YKXKYNUUAYQVRYRTXKUUAVSZHYBEYTVTSUUBNAXRBCDXSEYBGHIYTKYEMYFYGXHXIXJUUAWAX
      HXIXJUUAWBYIUUBJUTXHXIXJUUAWCUUELWDWEWFXNYDFYBXOXLYBPXMYCAXLYBEWHWGWISXKX
      NXLYLWJAEWKUFZPZWLZFXOWMZUUGFXOUJZXQXKEWNZUUIXKYNUUKYQHXREWTTUUKUUHFXOUUK
      XNUUGXLEAWOWPWQTXKYMYLGWRQZQXRPZUUJYSXKYLGXAQZOZUUMXKYOXIUUOYPYHCEGHUUNIK
      LUUNRZWSSYLUUNUULXRGYEUUPUULRZXBTXRGDFUUFUULYLYEUUQXCSXNUUGFXOXDXEXNFXOXF
      XG $.
  $}

  ${
    $d M a b c f $.  $d B a b c f $.  $d N a b c f $.  $d K a b c f $.
    $d S a b c f $.  $d .0. a b c f $.  $d .x. a b c f $.  $d F a b c f $.
    $d I a b c f $.  $d X a f $.  $d ph a f $.
    ellspd.n $e |- N = ( LSpan ` M ) $.
    ellspd.v $e |- B = ( Base ` M ) $.
    ellspd.k $e |- K = ( Base ` S ) $.
    ellspd.s $e |- S = ( Scalar ` M ) $.
    ellspd.z $e |- .0. = ( 0g ` S ) $.
    ellspd.t $e |- .x. = ( .s ` M ) $.

    ${
      ellspd.f $e |- ( ph -> F : I --> B ) $.
      ellspd.m $e |- ( ph -> M e. LMod ) $.
      ellspd.i $e |- ( ph -> I e. _V ) $.
      $( The elements of the span of an indexed collection of basic vectors are
         those vectors which can be written as finite linear combinations of
         basic vectors.  (Contributed by Stefan O'Rear, 7-Feb-2015.) $)
      ellspd $p |- ( ph -> ( X e. ( N ` ( F " I ) ) <->
          E. f e. ( K ^m I ) ( ( `' f " ( _V \ { .0. } ) ) e. Fin /\
            X = ( M gsum ( f oF .x. F ) ) ) ) ) $=
        ( va cima cfv wcel cv cof co cgsu wceq cfrlm cbs wrex cab ccnv cvv cdif
        csn cfn wa cmap crn wf wfn ffn fnima 3syl fveq2d cmpt eqid csca frlmup3
        rnmpt a1i syl5eqr eqtr4d eleq2d ovex eleq1 mpbiri rexlimivw eqeq1 elab3
        rexbidv crab fvex eqeltri frlmbas sylancr eqcomd rexeqdv imaeq1d eleq1d
        cnveq rexrab syl6bb syl5bb bitrd ) AKFGUCZJUDZUEKUBUFZIEUFZFDUGUHZUIUHZ
        UJZECGUKUHZULUDZUMZUBUNZUEZXBUOZUPLURUQZUCZUSUEZKXDUJZUTEHGVAUHZUMZAWTX
        IKAWTFVBZJUDZXIAWSXRJAGBFVCFGVDWSXRUJSGBFVEGFVFVGVHAXIEXGXDVIZVBXSEUBXG
        XDXTXTVJZVMAEFXGBCIDXTXFGJUPXFVJZXGVJNRYATUACIVKUDZUJAPVNSMVLVOVPVQXJXO
        EXGUMZAXQXHYDUBKXOKUPUEZEXGXOYEXDUPUEIXCUIVRKXDUPVSVTWAXAKUJXEXOEXGXAKX
        DWBWDWCAYDXOEXAUOZXLUCZUSUEZUBXPWEZUMXQAXOEXGYIAYIXGACUPUEGUPUEYIXGUJCY
        CUPPIVKWFWGUAYICUBXFGHUPUPLYBOQYIVJWHWIWJWKYHXNXOEUBXPXAXBUJZYGXMUSYJYF
        XKXLXAXBWNWLWMWOWPWQWR $.
    $}

    ${
      elfilspd.f $e |- ( ph -> F : I --> B ) $.
      elfilspd.m $e |- ( ph -> M e. LMod ) $.
      elfilspd.i $e |- ( ph -> I e. Fin ) $.
      $( Simplified version of ~ ellspd when the spanning set is finite: all
         linear combinations are then acceptable.  (Contributed by Stefan
         O'Rear, 7-Feb-2015.) $)
      elfilspd $p |- ( ph -> ( X e. ( N ` ( F " I ) ) <->
          E. f e. ( K ^m I ) X = ( M gsum ( f oF .x. F ) ) ) ) $=
        ( cima cfv wcel cv ccnv cvv csn cdif cfn co cgsu wceq wa cmap wrex elex
        cof syl ellspd adantr wf wb fvex eqeltri elmapg sylancr biimpa fisuppfi
        cbs biantrurd rexbidva bitr4d ) AKFGUBJUCUDEUEZUFUGLUHUIZUBUJUDZKIVNFDU
        RUKULUKUMZUNZEHGUOUKZUPVQEVSUPABCDEFGHIJKLMNOPQRSTAGUJUDZGUGUDUAGUJUQUS
        UTAVQVREVSAVNVSUDZUNZVPVQWBGHVOVNAVTWAUAVAAWAGHVNVBZAHUGUDVTWAWCVCHCVJU
        CUGOCVJVDVEUAHGVNUGUJVFVGVHVIVKVLVM $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Every set admits a group structure iff choice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d a b c d e B $.  $d a b c d e C $.  $d a b c d e D $.  $d a b c d e .+ $.
    $d a b c d ph $.  $d b c A $.  $d a c d x y B $.  $d x y C $.  $d x y D $.
    $d x y .+ $.  $d x ph $.
    unxpwdom3.av $e |- ( ph -> A e. V ) $.
    unxpwdom3.bv $e |- ( ph -> B e. W ) $.
    unxpwdom3.dv $e |- ( ph -> D e. X ) $.
    unxpwdom3.ov $e |- ( ( ph /\ a e. C /\ b e. D ) ->
        ( a .+ b ) e. ( A u. B ) ) $.
    unxpwdom3.lc $e |- ( ( ( ph /\ a e. C ) /\ ( b e. D /\ c e. D ) ) ->
        ( ( a .+ b ) = ( a .+ c ) <-> b = c ) ) $.
    unxpwdom3.rc $e |- ( ( ( ph /\ d e. D ) /\ ( a e. C /\ c e. C ) ) ->
        ( ( c .+ d ) = ( a .+ d ) <-> c = a ) ) $.
    unxpwdom3.ni $e |- ( ph -> -. D ~<_ A ) $.
    $( Weaker version of ~ unxpwdom where a function is required only to be
       cancellative, not an injection. ` D ` and ` B ` are to be thought of as
       "large" "horizonal" sets, the others as "small".  Because the operator
       is row-wise injective, but the whole row cannot inject into ` A ` , each
       row must hit an element of ` B ` ; by column injectivity, each row can
       be identified in at least one way by the ` B ` element that it hits and
       the column in which it is hit.  (Contributed by Stefan O'Rear,
       8-Jul-2015.) _MOVABLE_ $)
    unxpwdom3 $p |- ( ph -> C ~<_* ( D X. B ) ) $=
      ( vx vy cxp cvv cv c1st co c2nd wceq crio wcel xpexg syl2anc wa wrex wral
      cfv wn wbr adantr ad2antrr wi weq oveq2 eleq1d notbid rspcv adantl cun wo
      cdom 3expa elun sylib orcomd ord syld impancom wb dom2d mpd dfrex2 sylibr
      ex mtand simprr simplr an4s adantlrr riota5 eqcomd eqeq2 riotabidv eqeq2d
      anassrs rspcev expr reximdva cop op1std oveq2d op2ndd eqeq12d rexxp wdomd
      vex ) AJUADECUCZUDLUEZUAUEZUFUQZFUGZXIUHUQZUIZLDUJZAEIUKCHUKXGUDUKPOECIHU
      LUMAJUEZDUKZUNZXOXHMUEZFUGZUBUEZUIZLDUJZUIZUBCUOZMEUOZXOXNUIZUAXGUOXQXOXR
      FUGZCUKZMEUOZYEXQYHURZMEUPZURYIXQYKEBVKUSZAYLURXPTUTXQYKUNZBGUKZYLAYNXPYK
      NVAYMKLEBXOKUEZFUGZXOXHFUGZGXQYOEUKZYKYPBUKZXQYRUNZYKYPCUKZURZYSYRYKUUBVB
      XQYJUUBMYOEMKVCZYHUUAUUCYGYPCXRYOXOFVDVEVFVGVHYTUUAYSYTYSUUAYTYPBCVIUKZYS
      UUAVJAXPYRUUDQVLYPBCVMVNVOVPVQVRXQYRXHEUKUNZYPYQUIKLVCVSZVBYKXQUUEUUFRWDU
      TVTWAWEYHMEWBWCXQYHYDMEXQXREUKZYHYDXQUUGYHUNZUNZYHXOXSYGUIZLDUJZUIZYDXQUU
      GYHWFUUIUUKXOUUIUUJLDXOAXPUUHWGXQUUGXHDUKZUUJLJVCVSZYHXQUUGUUMUUNAUUGXPUU
      MUUNSWHWOWIWJWKYCUULUBYGCXTYGUIZYBUUKXOUUOYAUUJLDXTYGXSWLWMWNWPUMWQWRWAYF
      YCUAMUBECXIXRXTWSUIZXNYBXOUUPXMYALDUUPXKXSXLXTUUPXJXRXHFXRXTXIMXFZUBXFZWT
      XAXRXTXIUUQUURXBXCWMWNXDWCXE $.
  $}

  ${
    $d f g h A $.  $d f g h B $.  $d f g h X $.  $d f g h Y $.
    $( Given two equipollent sets, a bijection can always be chosen which fixes
       a single point. _MOVABLE_ (Contributed by Stefan O'Rear, 9-Jul-2015.) $)
    enfixsn $p |- ( ( A e. X /\ B e. Y /\ X ~~ Y ) ->
        E. f ( f : X -1-1-onto-> Y /\ ( f ` A ) = B ) ) $=
      ( vg vh wcel cen cv wf1o cfv wceq wa wex csn cvv cun a1i syl2anc wbr bren
      w3a simp3 sylib cdif relen brrelex2i 3ad2ant3 adantr f1of adantl ffvelrnd
      wf simpl1 simpl2 difsnen syl3anc cop ccom cin c0 fvex f1osng simprr f1oun
      disjdif syl22anc wb ad2antrl uncom difsnid syl5eq syl f1oeq23 mpbid f1oco
      simprl wfn f1ofn fvco2 ad2antll snid fvun1 syl112anc 3eqtrd snex vex unex
      fvsng coex f1oeq1 fveq1 eqeq1d anbi12d spcev expr exlimdv mpd exlimddv )
      ADHZBEHZDEIUAZUCZDEFJZKZDECJZKZAXGLZBMZNZCOZFXDXCXFFOXAXBXCUDDEFUBUEXDXFN
      ZEAXELZPZUFZEBPZUFZGJZKZGOZXLXMXPXRIUAZYAXMEQHZXNEHZXBYBXDYCXFXCXAYCXBDEI
      UGUHUIUJXMDEAXEXFDEXEUNZXDDEXEUKZULXAXBXCXFUOUMXAXBXCXFUPXNBQEUQURXPXRGUB
      UEXMXTXLGXDXFXTXLXDXFXTNZNZDEXNBUSZPZXSRZXEUTZKZAYLLZBMZXLYHEEYKKZXFYMYHX
      OXPRZXQXRRZYKKZYPYHXOXQYJKZXTXOXPVAVBMZXQXRVAVBMZYSYHXNQHZXBYTUUCYHAXEVCZ
      SZXAXBXCYGUPZXNBQEVDTZXDXFXTVEUUAYHXOEVGSZUUBYHXQEVGSXOXQXPXRYJXSVFVHYHYQ
      EMZYREMZYSYPVIYHYDUUIYHDEAXEXFYEXDXTYFVJXAXBXCYGUOZUMYDYQXPXOREXOXPVKEXNV
      LVMVNYHXBUUJUUFXBYRXRXQREXQXRVKEBVLVMVNYQEYREYKVOTVPXDXFXTVRDEEYKXEVQTYHY
      NXNYKLZXNYJLZBYHXEDVSZXAYNUULMXFUUNXDXTDEXEVTVJUUKDYKXEAWATYHYJXOVSZXSXPV
      SZUUAXNXOHZUULUUMMYHYTUUOUUGXOXQYJVTVNXTUUPXDXFXPXRXSVTWBUUHUUQYHXNUUDWCS
      XOXPYJXSXNWDWEYHUUCXBUUMBMUUEUUFXNBQEWJTWFXKYMYONCYLYKXEYJXSYIWGGWHWIFWHW
      KXGYLMZXHYMXJYODEXGYLWLUURXIYNBAXGYLWMWNWOWPTWQWRWSWT $.
  $}

  ${
    $d w x y z $.  $d w x z A $.  $d w x z y B $.  $d w x z C $.
    $d w x z y D $.  $d w y z S $.  $d w x y z .0. $.  $d w y z ph $.
    $d x z y W $.  $d y z T $.
    mapfien2.s $e |- S = { x e. ( B ^m A ) |
          ( `' x " ( _V \ { .0. } ) ) e. Fin } $.
    mapfien2.t $e |- T = { x e. ( D ^m C ) |
          ( `' x " ( _V \ { W } ) ) e. Fin } $.
    mapfien2.ac $e |- ( ph -> A ~~ C ) $.
    mapfien2.bd $e |- ( ph -> B ~~ D ) $.
    mapfien2.z $e |- ( ph -> .0. e. B ) $.
    mapfien2.w $e |- ( ph -> W e. D ) $.
    $( Equinumerousity relation for sets of finitely supported functions.
       _MOVABLE_ (Contributed by Stefan O'Rear, 9-Jul-2015.) $)
    mapfien2 $p |- ( ph -> S ~~ T ) $=
      ( cen wcel cvv syl vy vz vw cv wf1o cfv wceq wex wbr enfixsn syl3anc bren
      wa wi sylib w3a ccnv csn cdif cima cfn cmap co crab ccom cmpt eqid f1ocnv
      3ad2ant2 simp3 3ad2ant1 relen brrelexi brrelex2i mapfien ovex rabex f1oen
      eqeltri 3adant3r sneq difeq2d imaeq2d eleq1d rabbidv adantl 3ad2ant3 3exp
      syl6eqr breqtrd exlimdv mpd ) ADFUAUDZUEZJWMUFZIUGZUMZUAUHZGHQUIZAJDRZIFR
      DFQUIZWROPNJIUADFUJUKAWQWSUAACEUBUDZUEZUBUHZWQWSUNZACEQUIZXDMCEUBULUOAXCX
      EUBAXCWQWSAXCWQUPGBUDUQZSWOURZUSZUTZVARZBFEVBVCZVDZHQAXCWNGXMQUIZWPAXCWNU
      PZGXMUCGWMUCUDXBUQZVEVEVFZUEXNXOBCDEFGXMUCXPWMWOJKXMVGWOVGXCAECXPUEWNCEXB
      VHVIAXCWNVJXOXFCSRAXCXFWNMVKZCEQVLVMTXOXADSRAXCXAWNNVKZDFQVLVMTXOXFESRXRC
      EQVLVNTXOXAFSRXSDFQVLVNTAXCWTWNOVKVOGXMXQGXGSJURUSUTVARZBDCVBVCZVDSKXTBYA
      DCVBVPVQVSVRTVTWQAXMHUGZXCWPYBWNWPXMXGSIURZUSZUTZVARZBXLVDHWPXKYFBXLWPXJY
      EVAWPXIYDXGWPXHYCSWOIWAWBWCWDWELWIWFWGWJWHWKWLWKWL $.
  $}

  ${
    $( Two ways of writing the support of a function with known codomain.
       _MOVABLE_ _SHORTEN nn0supp_ (Contributed by Stefan O'Rear,
       9-Jul-2015.) $)
    fsuppeq $p |- ( F : I --> S -> ( `' F " ( _V \ { X } ) ) =
          ( `' F " ( S \ { X } ) ) ) $=
      ( wf ccnv csn cdif cima cvv cin invdif imaeq2i wfun wceq inpreima syl wss
      ffun cdm cnvimass fimacnv eqtr4d syl5sseq sseqin2 sylib eqtrd syl5reqr
      fdm ) CABEZBFZADGZHZIUKAJULHZKZIZUKUNIZUOUMUKAULLMUJUPUKAIZUQKZUQUJBNUPUS
      OCABSAUNBPQUJUQURRUSUQOUJBTZUQURBUNUAUJUTCURCABUICABUBUCUDUQURUEUFUGUH $.
  $}

  ${
    $d x y A $.  $d x S $.  $d x y V $.
    pwfi2f1o.s $e |- S = { y e. ( 2o ^m A ) |
        ( `' y " ( _V \ { (/) } ) ) e. Fin } $.
    pwfi2f1o.f $e |- F = ( x e. S |-> ( `' x " { 1o } ) ) $.
    $( The ~ pw2f1o bijection relates finitely supported indicator functions on
       a two-element set to finite subsets. _MOVABLE_ (Contributed by Stefan
       O'Rear, 10-Jul-2015.) $)
    pwfi2f1o $p |- ( A e. V -> F : S -1-1-onto-> ( ~P A i^i Fin ) ) $=
      ( wcel c2o ccnv c1o cima wf1o cfn cin syl c0 cdif wceq cmap csn cmpt cres
      co cv cpw wf1 wss eqid pw2f1o2 f1of1 cvv ssrab2 eqsstri f1ores sylancl wb
      crab wa elmapi adantl fsuppeq cun csuc df-2o df-suc equncomi eqtri eqcomi
      wf df1o2 difeq12i difun2 incom word 1on onordi orddisj ax-mp disj3 eqtr4i
      mpbi imaeq2i syl6eq eleq1d cdm cnvimass fdm biantrurd bitrd elfpw syl6bbr
      syl5sseq rabbidva cnveq imaeq1d cbvmptv mptpreima 3eqtr4g wfo f1ofo inss1
      imaeq2d foimacnv eqtrd f1oeq3 resmpt f1oeq1 mp1i mpbid ) CFIZDAJCUAUEZAUF
      ZKZLUBZMZUCZDMZXRDUDZNZDCUGZOPZENZXLXMYBXRUHZDXMUIZYAXLXMYBXRNZYEACXRFXRU
      JUKZXMYBXRULQDBUFZKZUMRUBZSMZOIZBXMUSZXMGYMBXMUNUOZXMYBDXRUPUQXLYADYCXTNZ
      YDXLXSYCTYAYPURXLXSXRXRKYCMZMZYCXLDYQXRXLYNYJXPMZYCIZBXMUSDYQXLYMYTBXMXLY
      IXMIZUTZYMYSCUIZYSOIZUTZYTUUBYMUUDUUEUUBYLYSOUUBYLYJJYKSZMZYSUUBCJYIVKZYL
      UUGTUUAUUHXLYIJCVAVBZJYICRVCQUUFXPYJUUFXPLVDZLSZXPJUUJYKLJLVEZUUJVFUULLXP
      LVGVHVILYKVLVJVMUUKXPLSZXPXPLVNXPLPZRTXPUUMTUUNLXPPZRXPLVOLVPUUORTLVQVRLV
      SVTVIXPLWAWCWBVIWDWEWFUUBUUCUUDUUBYIWGZYSCYIXPWHUUBUUHUUPCTUUICJYIWIQWNWJ
      WKYSCWLWMWOGBXMYSYCXRABXMXQYSXNYITXOYJXPXNYIWPWQWRWSWTXDXLXMYBXRXAZYCYBUI
      YRYCTXLYGUUQYHXMYBXRXBQYBOXCXMYBYCXRXEUQXFXSYCDXTXGQXTETYPYDURXLXTADXQUCZ
      EYFXTUURTYOAXMDXQXHVTHWBDYCXTEXIXJWKXK $.
  $}

  ${
    $d x y A $.  $d x S $.  $d x y V $.
    pwfi2en.s $e |- S = { y e. ( 2o ^m A ) |
        ( `' y " ( _V \ { (/) } ) ) e. Fin } $.
    $( Finitely supported indicator functions are equinumerous to finite
       subsets. _MOVABLE_ (Contributed by Stefan O'Rear, 10-Jul-2015.) $)
    pwfi2en $p |- ( A e. V -> S ~~ ( ~P A i^i Fin ) ) $=
      ( vx wcel cpw cfn cin cv ccnv c1o csn cima cmpt wf1o cvv c2o cmap cen wbr
      eqid pwfi2f1o c0 cdif co crab ovex rabex eqeltri f1oen syl ) BDGCBHIJZFCF
      KLMNOPZQCUNUAUBFABCUODEUOUCUDCUNUOCAKLRUENUFOIGZASBTUGZUHREUPAUQSBTUIUJUK
      ULUM $.
  $}

  ${
    $d x I $.  $d x R $.  $d x V $.
    frlmpwfi.r $e |- R = ( Z/nZ ` 2 ) $.
    frlmpwfi.y $e |- Y = ( R freeLMod I ) $.
    frlmpwfi.b $e |- B = ( Base ` Y ) $.
    $( Formal linear combinations over Z/2Z are equivalent to finite subsets.
       _MOVABLE_ (Contributed by Stefan O'Rear, 10-Jul-2015.) $)
    frlmpwfi $p |- ( I e. V -> B ~~ ( ~P I i^i Fin ) ) $=
      ( vx wcel cvv c0 cfn c2o cen wbr cfv c2 eqid ax-mp cv ccnv cdif cima cmap
      csn co crab cpw cin c0g cbs wceq fvex eqeltri frlmbas mpan syl6eqr enrefg
      czn chash cn 2nn znhash hash2 eqtr4i cn0 2nn0 hashclb mpbir com 2onn nnfi
      wb hashen mpbi a1i crg ccrg zncrng crngrng mp2b rng0cl mp1i wne 2on0 con0
      mp2an 2on on0eln0 mapfien2 eqbrtrrd pwfi2en entr syl2anc ) CDJZAIUAUBZKLU
      FUCUDMJINCUEUGUHZOPWRCUIMUJZOPAWSOPWPWQKBUKQZUFUCUDMJIBULQZCUEUGUHZAWROWP
      XBEULQZABKJWPXBXCUMBRUTQKFRUTUNUOXBBIECXAKDWTGXASZWTSZXBSZUPUQHURWPICXACN
      XBWRLWTXFWRSZCDUSXANOPZWPXAVAQZNVAQZUMZXHXIRXJRVBJXIRUMVCXARBFXDVDTZVEVFX
      AMJZNMJZXKXHVNXMXIVGJZXIRVGXLVHUOXAKJXMXOVNBULUNXAKVITVJNVKJXNVLNVMTXANVO
      WHVPVQBVRJZWTXAJWPRVGJBVSJXPVHRBFVTBWAWBXABWTXDXEWCWDLNJZWPXQNLWEZWFNWGJX
      QXRVNWINWJTVJVQWKWLICWRDXGWMAWRWSWNWO $.
  $}

  ${
    $d v w x y G $.  $d v x y z G $.  $d v w x y H $.  $d z H $.
    $( Being Abelian is a group invariant. _MOVABLE_ (Contributed by Stefan
       O'Rear, 8-Jul-2015.) $)
    gicabl $p |- ( G ~=g H -> ( G e. Abel <-> H e. Abel ) ) $=
      ( vx vy vz vw vv co wcel wb syl cfv wceq wral eqid adantr syl3anc eqeq12d
      cv wa cgic wbr cgim c0 wne cabel brgic wex cgrp ccmn cghm ghmgrp1 ghmgrp2
      n0 gimghm 2thd cmnd cplusg cbs grpmnd wf1 wf1o gimf1o f1of1 simprl simprr
      grpcl f1fveq syl12anc ghmlin bitr3d 2ralbidva wfo f1ofo foima raleqdv wfn
      cima f1ofn ssid oveq2 oveq1 ralima sylancl ralbidv bitr4d anbi12d 3bitr4g
      wss iscmn isabl exlimiv sylbi ) ABUAUBABUCHZUDUEZAUFIZBUFIZJZABUGWOCSZWNI
      ZCUHWRCWNUNWTWRCWTAUIIZAUJIZTBUIIZBUJIZTWPWQWTXAXCXBXDWTXAXCWTWSABUKHIZXA
      ABWSUOZABWSULKZWTXEXCXFABWSUMKZUPWTAUQIZDSZESZAURLZHZXKXJXLHZMZEAUSLZNDXP
      NZTBUQIZFSZGSZBURLZHZXTXSYAHZMZGBUSLZNZFYENZTXBXDWTXIXRXQYGWTXIXRWTXAXIXG
      AUTKWTXCXRXHBUTKUPWTXQXJWSLZXTYAHZXTYHYAHZMZGYENZDXPNZYGWTXQYHXKWSLZYAHZY
      NYHYAHZMZEXPNZDXPNYMWTXOYQDEXPXPWTXJXPIZXKXPIZTZTZXMWSLZXNWSLZMZXOYQUUBXP
      YEWSVAZXMXPIZXNXPIZUUEXOJWTUUFUUAWTXPYEWSVBZUUFXPYEABWSXPOZYEOZVCZXPYEWSV
      DKPUUBXAYSYTUUGWTXAUUAXGPZWTYSYTVEZWTYSYTVFZXPXLAXJXKUUJXLOZVGQUUBXAYTYSU
      UHUUMUUOUUNXPXLAXKXJUUJUUPVGQXPYEXMXNWSVHVIUUBUUCYOUUDYPUUBXEYSYTUUCYOMWT
      XEUUAXFPZUUNUUOXLYAABXJWSXKXPUUJUUPYAOZVJQUUBXEYTYSUUDYPMUUQUUOUUNXLYAABX
      KWSXJXPUUJUUPUURVJQRVKVLWTYLYRDXPWTYKGWSXPVRZNZYLYRWTYKGUUSYEWTUUIUUSYEMZ
      UULUUIXPYEWSVMUVAXPYEWSVNXPYEWSVOKKZVPWTWSXPVQZXPXPWIZUUTYRJWTUUIUVCUULXP
      YEWSVSKZXPVTZYKYQGEXPXPWSXTYNMYIYOYJYPXTYNYHYAWAXTYNYHYAWBRWCWDVKWEWFWTYF
      FUUSNZYGYMWTYFFUUSYEUVBVPWTUVCUVDUVGYMJUVEUVFYFYLFDXPXPWSXSYHMZYDYKGYEUVH
      YBYIYCYJXSYHXTYAWBXSYHXTYAWARWEWCWDVKWFWGDEXPXLAUUJUUPWJFGYEYABUUKUURWJWH
      WGAWKBWKWHWLWMWM $.
  $}

  ${
    $d a b c d F $.  $d a b c d R $.  $d a b c d U $.  $d a b c d V $.
    $d a b c d ph $.  $d c d B $.
    imasgim.u $e |- ( ph -> U = ( F "s R ) ) $.
    imasgim.v $e |- ( ph -> V = ( Base ` R ) ) $.
    imasgim.f $e |- ( ph -> F : V -1-1-onto-> B ) $.
    imasgim.r $e |- ( ph -> R e. Grp ) $.
    $( A relabeling of the elements of a group induces an isomorphism to the
       relabeled group. _MOVABLE_ (Contributed by Stefan O'Rear, 8-Jul-2015.)
       (Revised by Mario Carneiro, 11-Aug-2015.) $)
    imasgim $p |- ( ph -> F e. ( R GrpIso U ) ) $=
      ( va vb vd co wcel cfv eqid wceq syl cv vc cghm cbs wf1o cgim cplusg cgrp
      c0g eqidd wfo f1ofo f1ocpbl imasgrp simpld wf imasbas f1oeq3 mpbid f1oeq2
      wb f1of wa eleq2d anbi12d w3a imasaddval eqcomd 3expib sylbird imp isghmd
      isgim sylanbrc ) AECDUBNOCUCPZDUCPZEUDZECDUENOAKLCUFPZDUFPZCDEVNVOVNQZVOQ
      ZVQQZVRQZJADUGOCUHPZEPDUHPRABVQCDEFWCMUAKLGHAVQUIAFBEUDZFBEUJIFBEUKSZAKTZ
      LTZUATMTVQEFBIULZJWCQUMUNAVPVNVOEUOAFVOEUDZVPAWDWIIABVORWDWIUTABCDEFUGGHW
      EJUPBVOFEUQSURAFVNRWIVPUTHFVNVOEUSSURZVNVOEVASAWFVNOZWGVNOZVBZWFWGVQNEPZW
      FEPWGEPVRNZRZAWMWFFOZWGFOZVBWPAWQWKWRWLAFVNWFHVCAFVNWGHVCVDAWQWRWPAWQWRVE
      WOWNABCVRVQDEFWFWGUGMUAKLWEWHGHJWAWBVFVGVHVIVJVKWJVNVOCDEVSVTVLVM $.
  $}

  $( Functionality of the base set extractor. _MOVABLE_ (Contributed by Stefan
     O'Rear, 8-Jul-2015.) $)
  basfn $p |- Base Fn _V $=
    ( cbs c1 df-base slotfn ) ABCD $.

  ${
    $d f B $.  $d f C $.  $d f R $.
    isnumbasgrplem1.b $e |- B = ( Base ` R ) $.
    $( A set which is equipollent to the base set of a definable Abelian group
       is the base set of some (relabeled) Abelian group.  (Contributed by
       Stefan O'Rear, 8-Jul-2015.) $)
    isnumbasgrplem1 $p |- ( ( R e. Abel /\ C ~~ B ) ->
        C e. ( Base " Abel ) ) $=
      ( vf cen wbr cabel wcel cv wf1o wex cbs cima ensymb bren bitri co cfv cvv
      wi wa cimas eqidd wceq a1i wfo f1ofo adantr simpr imasbas cgim cgic simpl
      cgrp ablgrp adantl imasgim brgici gicabl 3syl mpbid wfn wss basfn fnfvima
      wb ssv mp3an12 syl eqeltrd ex exlimiv impcom sylan2b ) BAFGZCHIZABEJZKZEL
      ZBMHNZIZVPABFGVTBAOABEPQVTVQWBVSVQWBUAEVSVQWBVSVQUBZBVRCUCRZMSZWAWCBCWDVR
      AHWCWDUDZACMSUEWCDUFZVSABVRUGVQABVRUHUIVSVQUJZUKWCWDHIZWEWAIZWCVQWIWHWCVR
      CWDULRICWDUMGVQWIVGWCBCWDVRAWFWGVSVQUNVQCUOIVSCUPUQURCWDVRUSCWDUTVAVBMTVC
      HTVDWIWJVEHVHTHMWDVFVIVJVKVLVMVNVO $.
  $}

  $( The Hartogs number of a set is never zero. _MOVABLE_ (Contributed by
     Stefan O'Rear, 9-Jul-2015.) $)
  harn0 $p |- ( S e. V -> ( har ` S ) =/= (/) ) $=
    ( wcel c0 char cfv wne con0 cdom wbr 0elon a1i 0domg elharval sylanbrc ne0i
    syl ) ABCZDAEFZCZSDGRDHCZDAIJTUARKLABMADNOSDPQ $.

  $( A numerable infinite set contains a countable subset. _MOVABLE_
     (Contributed by Stefan O'Rear, 9-Jul-2015.) $)
  numinfctb $p |- ( ( S e. dom card /\ -. S e. Fin ) -> om ~<_ S ) $=
    ( ccrd cdm wcel com cdom wbr cfn wn csdm wb con0 omelon onenon domtri2 mpan
    ax-mp isfinite notbii syl6bbr biimpar ) ABCZDZEAFGZAHDZIZUCUDAEJGZIZUFEUBDZ
    UCUDUHKELDUIMENQEAOPUEUGARSTUA $.

  ${
    $d a b c d x S $.
    $( If the (to be thought of as disjoint, although the proof does not
       require this) union of a set and its Hartogs number supports a group
       structure (more generally, a cancellative magma), then the set must be
       numerable.  (Contributed by Stefan O'Rear, 9-Jul-2015.) $)
    isnumbasgrplem2 $p |- ( ( S u. ( har ` S ) ) e. ( Base " Grp ) ->
        S e. dom card ) $=
      ( vx va vc vd vb cfv cbs cgrp wcel cv wceq cvv wss wb wbr sseldd ad2antrr
      wa co char cun cima wrex ccrd cdm wfn basfn ssv fvelimab mp2an cdom harcl
      cxp con0 onenon ax-mp xpnum cwdom ssun1 simpr syl5sseqr fvex ssex syl a1i
      cplusg w3a simp1l 3ad2ant1 simp2 ssun2 simp3 grpcl syl3anc simp1r eleqtrd
      simplll simprl simprr simplr grplcan syl13anc grprcan wn harndom wdomnumr
      eqid unxpwdom3 sylib numdom sylancr rexlimiva sylbi ) AAUAGZUBZHIUCJZBKZH
      GZWPLZBIUDZAUEUFZJZHMUGIMNWQXAOUHIUIBMIWPHUJUKWTXCBIWRIJZWTSZWOWOUNZXBJZA
      XFULPZXCWOXBJZXIXGWOUOJXIAUMWOUPUQZXJWOWOURUKZXEAXFUSPZXHXEAWOAWOWRVGGZMX
      BXBCDEFXEAWSNZAMJXEWPAWSAWOUTXDWTVAZVBZAWSWRHVCVDVEXIXEXJVFZXQXECKZAJZDKZ
      WOJZVHZXRXTXMTZWSWPYBXDXRWSJZXTWSJZYCWSJXDWTXSYAVIYBAWSXRXEXSXNYAXPVJXEXS
      YAVKQYBWOWSXTXEXSWOWSNZYAXEWPWOWSWOAVLXOVBZVJXEXSYAVMQWSXMWRXRXTWSWHZXMWH
      ZVNVOXDWTXSYAVPVQXEXSSZYAEKZWOJZSZSZXDYEYKWSJZYDYCXRYKXMTLXTYKLOXDWTXSYMV
      RYNWOWSXTXEYFXSYMYGRZYJYAYLVSQYNWOWSYKYPYJYAYLVTQYNAWSXRXEXNXSYMXPRXEXSYM
      WAQWSXMWRXTYKXRYHYIWBWCXEFKZWOJZSZXSYKAJZSZSZXDYOYDYQWSJYKYQXMTXRYQXMTLYK
      XRLOXDWTYRUUAVRUUBAWSYKXEXNYRUUAXPRZYSXSYTVTQUUBAWSXRUUCYSXSYTVSQUUBWOWSY
      QXEYFYRUUAYGRXEYRUUAWAQWSXMWRYKXRYQYHYIWDWCWOAULPWEXEAWFVFWIXGXLXHOXKAXFW
      GUQWJXFAWKWLWMWN $.

    $( Every nonempty numerable set can be given the structure of an Abelian
       group, either a finite cyclic group or a vector space over Z/2Z.
       (Contributed by Stefan O'Rear, 10-Jul-2015.) $)
    isnumbasgrplem3 $p |- ( ( S e. dom card /\ S =/= (/) ) ->
        S e. ( Base " Abel ) ) $=
      ( wcel wa cfn cbs cabel chash cfv czn cen wbr cn0 ccrg crg zncrng crngrng
      eqid syl syl2anc c2 ccrd cdm c0 wne cima hashcl adantl 4syl wceq hashnncl
      rngabl cn biimparc znhash eqcomd simpr znfi mpbid isnumbasgrplem1 adantll
      wb hashen wn cfrlm clmod 2nn0 mp2b frlmlmod mpan lmodabl ad2antrr cpw cin
      co frlmpwfi cdom simpll numinfctb adantlr infpwfien entr ensymd pm2.61dan
      com ) AUAUBZBZAUCUDZCZADBZAEFUEBZWGWIWJWFWGWICZAGHZIHZFBZAWMEHZJKZWJWKWLL
      BZWMMBWMNBWNWIWQWGAUFUGWLWMWMQZOWMPWMUKUHWKWLWOGHZUIZWPWKWSWLWKWLULBZWSWL
      UIWIXAWGAUJUMZWOWLWMWRWOQZUNRUOWKWIWODBZWTWPVAWGWIUPWKXAXDXBWOWLWMWRXCUQR
      AWOVBSURWOAWMXCUSSUTWHWIVCZCZTIHZAVDVNZFBZAXHEHZJKWJWFXIWGXEWFXHVEBZXIXGN
      BZWFXKTLBXGMBXLVFTXGXGQZOXGPVGXGXHAWEXHQZVHVIXHVJRVKXFXJAXFXJAVLDVMZJKZXO
      AJKZXJAJKWFXPWGXEXJXGAWEXHXMXNXJQZVOVKXFWFWDAVPKZXQWFWGXEVQWFXEXSWGAVRVSA
      VTSXJXOAWASWBXJAXHXRUSSWC $.
  $}

  $( A set is numerable iff it and its Hartogs number can be jointly given the
     structure of an Abelian group.  (Contributed by Stefan O'Rear,
     9-Jul-2015.) $)
  isnumbasabl $p |- ( S e. dom card <->
      ( S u. ( har ` S ) ) e. ( Base " Abel ) ) $=
    ( vx ccrd cdm wcel char cfv cun cbs cabel cima wne harcl onenon ax-mp unnum
    c0 con0 wss cgrp mpan2 ssun2 ssn0 sylancr isnumbasgrplem3 syl2anc cv ablgrp
    harn0 ssriv imass2 sseli isnumbasgrplem2 syl impbii ) ACDZEZAAFGZHZIJKZEZUQ
    USUPEZUSQLZVAUQURUPEZVBURREVDAMURNOAURPUAUQURUSSURQLVCURAUBAUPUIURUSUCUDUSU
    EUFVAUSITKZEUQUTVEUSJTSUTVESBJTBUGUHUJJTIUKOULAUMUNUO $.

  $( A set is numerable iff it and its Hartogs number can be jointly given the
     structure of a group.  (Contributed by Stefan O'Rear, 9-Jul-2015.) $)
  isnumbasgrp $p |- ( S e. dom card <->
      ( S u. ( har ` S ) ) e. ( Base " Grp ) ) $=
    ( vx ccrd cdm wcel char cfv cun cbs cgrp cima cabel wss ablgrp ssriv imass2
    cv ax-mp isnumbasabl biimpi sseldi isnumbasgrplem2 impbii ) ACDEZAAFGHZIJKZ
    EUDILKZUFUELJMUGUFMBLJBQNOLJIPRUDUEUGEASTUAAUBUC $.

  ${
    $d x y $.
    $( A choice equivalent in abstract algebra:  All nonempty sets admit a
       group structure.  From ~ http://mathoverflow.net/a/12988 .  (Contributed
       by Stefan O'Rear, 9-Jul-2015.) $)
    dfacbasgrp $p |- ( CHOICE <-> ( Base " Grp ) = ( _V \ { (/) } ) ) $=
      ( vx vy cvv wceq cbs cgrp cima c0 cv wcel wne wa cfv mp2an cabel eleqtrrd
      wss ax-mp eldifsn eqrdv wac ccrd cdm csn cdif dfac10 wrex wfn wb fvelimab
      basfn ssv grpbn0 neeq1 syl5ibcom rexlimiv sylbi adantl jctil ablgrp ssriv
      imass2 simprl simpl simprr isnumbasgrplem3 syl2anc sseldi impbida syl6bbr
      eqid vex char cun fvex unex ssun2 ssn0 mpbir2an a1i id isnumbasgrp sylibr
      harn0 2thd impbii bitri ) UAUBUCZCDZEFGZCHUDUEZDZUFWIWLWIAWJWKWIAIZWJJZWM
      CJZWMHKZLZWMWKJWIWNWQWIWNLWPWOWNWPWIWNBIZEMZWMDZBFUGZWPECUHFCQWNXAUIUKFUL
      BCFWMEUJNWTWPBFWRFJWSHKWTWPWSWRWSVKUMWSWMHUNUOUPUQURAVLZUSWIWQLZEOGZWJWMO
      FQXDWJQAOFWMUTVAOFEVBRXCWMWHJZWPWMXDJXCWMCWHWIWOWPVCWIWQVDPWIWOWPVEWMVFVG
      VHVIWMCHSVJTWLAWHCWLXEWOWLWMWMVMMZVNZWJJXEWLXGWKWJXGWKJZWLXHXGCJXGHKZWMXF
      XBWMVMVOVPXFXGQXFHKZXIXFWMVQWOXJXBWMCWDRXFXGVRNXGCHSVSVTWLWAPWMWBWCWOWLXB
      VTWETWFWG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Independent sets and families
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LIndF LIndS $.

  $( The class relationship of independent families in a module. $)
  clindf $a class LIndF $.

  $( The class generator of independent sets in a module. $)
  clinds $a class LIndS $.

  ${
    $d f w s x k $.
    $( An independent family is a family of vectors, no nonzero multiple of
       which can be expressed as a linear combination of other elements of the
       family.  This is almost, but not quite, the same as a function into an
       independent set.

       This is a defined concept because it matters in many cases whether
       independence is taken at a set or family level.  For instance, a number
       is transcedental iff its nonzero powers are linearly independent.  Is 1
       transcedental?  It has only one nonzero power.

       We can almost define family independence as a family of unequal elements
       with independent range, as ~ islindf3 , but taking that as primitive
       would lead to unpleasant corner case behavior with the zero ring.

       This is equivalent to the common definition of having no nontrivial
       representations of zero ( ~ islindf4 ) and only one representation for
       each element of the range ( ~ islindf5 ).  (Contributed by Stefan
       O'Rear, 24-Feb-2015.) $)
    df-lindf $a |- LIndF = { <. f , w >. | ( f : dom f --> ( Base ` w ) /\
            [. ( Scalar ` w ) / s ]. A. x e. dom f
                A. k e. ( ( Base ` s ) \ { ( 0g ` s ) } )
                  -. ( k ( .s ` w ) ( f ` x ) ) e.
                      ( ( LSpan ` w ) ` ( f " ( dom f \ { x } ) ) ) ) } $.

    $( An independent set is a set which is independent as a family.  See also
       ~ islinds3 and ~ islinds4 .  (Contributed by Stefan O'Rear,
       24-Feb-2015.) $)
    df-linds $a |- LIndS = ( w e. _V |->
          { s e. ~P ( Base ` w ) | ( _I |` s ) LIndF w } ) $.
  $}

  ${
    $d f k s w x $.
    $( The independent-family predicate is a proper relation and can be used
       with ~ brrelexi .  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    rellindf $p |- Rel LIndF $=
      ( vf vw vk vx vs cv cdm cbs cfv wf cvsca co csn cdif cima clspn wcel wral
      wn c0g csca wsbc wa clindf df-lindf relopabi ) AFZGZBFZHIUGJCFDFZUGIUIKIL
      UGUHUJMNOUIPIIQSCEFZHIUKTIMNRDUHREUIUAIUBUCABUDDBACEUEUF $.
  $}

  ${
    $d W s w $.  $d X s $.
    islinds.b $e |- B = ( Base ` W ) $.
    $( Property of an independent set of vectors in terms of an independent
       family.  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    islinds $p |- ( W e. V -> ( X e. ( LIndS ` W ) <->
          ( X C_ B /\ ( _I |` X ) LIndF W ) ) ) $=
      ( vs vw wcel clinds cfv cbs cpw cid cres clindf wbr wa wss cv wceq eleq2d
      crab cvv elex fveq2 pweqd breq2 rabeqbidv df-linds fvex pwex rabex reseq2
      fvmpt syl breq1d elrab syl6bb elpw2 sseq2i bitr4i anbi1i ) CBHZDCIJZHZDCK
      JZLZHZMDNZCOPZQZDARZVJQVCVEDMFSZNZCOPZFVGUBZHVKVCVDVPDVCCUCHVDVPTCBUDGCVN
      GSZOPZFVQKJZLZUBVPUCIVQCTZVRVOFVTVGWAVSVFVQCKUEUFVQCVNOUGUHGFUIVOFVGVFCKU
      JZUKULUNUOUAVOVJFDVGVMDTVNVICOVMDMUMUPUQURVHVLVJVHDVFRVLDVFWBUSAVFDEUTVAV
      BUR $.

    $( An independent set of vectors is a set of vectors.  (Contributed by
       Stefan O'Rear, 24-Feb-2015.) $)
    linds1 $p |- ( X e. ( LIndS ` W ) -> X C_ B ) $=
      ( clinds cfv wcel wss cid cres clindf wbr wa cdm wb elfvdm islinds simpld
      syl ibi ) CBEFGZCAHZICJBKLZUAUBUCMZUABENZGUAUDOCBEPAUEBCDQSTR $.
  $}

  ${
    $( An independent set of vectors is independent as a family.  (Contributed
       by Stefan O'Rear, 24-Feb-2015.) $)
    linds2 $p |- ( X e. ( LIndS ` W ) -> ( _I |` X ) LIndF W ) $=
      ( clinds cfv wcel cbs wss cid cres clindf wbr cdm elfvdm eqid islinds syl
      wa wb ibi simprd ) BACDEZBAFDZGZHBIAJKZUAUCUDQZUAACLZEUAUERBACMUBUFABUBNO
      PST $.
  $}

  ${
    $d B f w $.  $d F f k w x $.  $d K f w $.  $d N f k w $.  $d .x. f w $.
    $d W f k w x $.  $d .0. f k w $.  $d f s $.  $d k s $.  $d s w x $.
    islindf.b $e |- B = ( Base ` W ) $.
    islindf.v $e |- .x. = ( .s ` W ) $.
    islindf.k $e |- K = ( LSpan ` W ) $.
    islindf.s $e |- S = ( Scalar ` W ) $.
    islindf.n $e |- N = ( Base ` S ) $.
    islindf.z $e |- .0. = ( 0g ` S ) $.
    $( Property of an independent family of vectors.  (Contributed by Stefan
       O'Rear, 24-Feb-2015.) $)
    islindf $p |- ( ( W e. Y /\ F e. X ) -> ( F LIndF W <->
          ( F : dom F --> B /\ A. x e. dom F A. k e. ( N \ { .0. } )
                -. ( k .x. ( F ` x ) ) e.
                    ( K ` ( F " ( dom F \ { x } ) ) ) ) ) ) $=
      ( cfv wceq vf vw vs wcel clindf wbr cdm wf cv co csn cdif cima wn wral wa
      wb cbs cvsca clspn csca wsbc feq1 adantr dmeq fveq2 syl6eqr adantl feq23d
      c0g bitrd fvex sneqd difeq12d raleqdv ralbidv sbcie fveq2d eqidd oveq123d
      fveq1 imaeq1 difeq1d imaeq2d eqtrd fveq12d eleq12d notbid syl5bb df-lindf
      raleqbidv anbi12d brabga ancoms ) FJUDIKUDFIUEUFFUGZBFUHZEUIZAUIZFSZDUJZF
      WOWRUKZULZUMZGSZUDZUNZEHLUKZULZUOZAWOUOZUPZUQUAUIZUGZUBUIZURSZXLUHZWQWRXL
      SZXNUSSZUJZXLXMXAULZUMZXNUTSZSZUDZUNZEUCUIZURSZYFVJSZUKZULZUOZAXMUOZUCXNV
      ASZVBZUPXKUAUBFIUEJKXLFTZXNITZUPZXPWPYNXJYQXPXMXOFUHZWPYOXPYRUQYPXMXOXLFV
      CVDYQXMXOWOBFYOXMWOTYPXLFVEZVDZYPXOBTYOYPXOIURSBXNIURVFMVGVHVIVKYNYEEYMUR
      SZYMVJSZUKZULZUOZAXMUOZYQXJYLUUFUCYMXNVAVLYFYMTZYKUUEAXMUUGYEEYJUUDUUGYGU
      UAYIUUCYFYMURVFUUGYHUUBYFYMVJVFVMVNVOVPVQYQUUEXIAXMWOYTYQYEXFEUUDXHYPUUDX
      HTYOYPUUAHUUCXGYPUUACURSHYPYMCURYPYMIVASCXNIVAVFPVGZVRQVGYPUUBLYPUUBCVJSL
      YPYMCVJUUHVRRVGVMVNVHYQYDXEYQXSWTYCXDYQWQWQXQWSXRDYPXRDTYOYPXRIUSSDXNIUSV
      FNVGVHYQWQVSYOXQWSTYPWRXLFWAVDVTYQYAXCYBGYPYBGTYOYPYBIUTSGXNIUTVFOVGVHYOY
      AXCTYPYOYAFXTUMXCXLFXTWBYOXTXBFYOXMWOXAYSWCWDWEVDWFWGWHWKWKWIWLAUBUAEUCWJ
      WMWN $.

    $( Expanded property of an independent set of vectors.  (Contributed by
       Stefan O'Rear, 24-Feb-2015.) $)
    islinds2 $p |- ( W e. Y -> ( F e. ( LIndS ` W ) <->
          ( F C_ B /\ A. x e. F A. k e. ( N \ { .0. } )
                -. ( k .x. x ) e. ( K ` ( F \ { x } ) ) ) ) ) $=
      ( wcel cfv wa clinds wss cid cres clindf wbr cdm wf cv csn cdif cima wral
      co wn islinds cvv cbs fvex eqeltri ssex adantl resiexg syl islindf syldan
      wb pm5.32da wf1o f1oi f1of ax-mp dmresi feq2i mpbir mpan biantrurd raleqi
      fss fvresi oveq2d wceq difeq1i imaeq2i difss resiima eqtri fveq2i eleq12d
      a1i notbid ralbidv ralbiia bitri anbi2i syl6rbbr pm5.32i 3bitrd ) IJRZFIU
      ASRFBUBZUCFUDZIUEUFZTWTXAUGZBXAUHZEUIZAUIZXASZDUNZXAXCXFUJZUKZULZGSZRZUOZ
      EHKUJUKZUMZAXCUMZTZTZWTXEXFDUNZFXIUKZGSZRZUOZEXOUMZAFUMZTZBJIFLUPWSWTXBXR
      WSWTXAUQRZXBXRVGWSWTTFUQRZYHWTYIWSFBBIURSUQLIURUSUTVAVBFUQVCVDABCDEXAGHIU
      QJKLMNOPQVEVFVHXSYGVGWSWTXRYFWTYFXDYFTXRWTXDYFXCFXAUHZWTXDYJFFXAUHZFFXAVI
      YKFVJFFXAVKVLXCFFXAFVMZVNVOXCFBXAVSVPVQXQYFXDXQXPAFUMYFXPAXCFYLVRXPYEAFXF
      FRZXNYDEXOYMXMYCYMXHXTXLYBYMXGXFXEDFXFVTWAXLYBWBYMXKYAGXKXAYAULZYAXJYAXAX
      CFXIYLWCWDYAFUBYNYAWBFXIWEFYAWFVLWGWHWJWIWKWLWMWNWOWPWQWJWR $.

    $d B k $.  $d B x $.  $d I k $.  $d I x $.  $d X k $.  $d X x $.  $d Y k $.
    $d Y x $.
    $( Property of an independent family of vectors with prior constrained
       domain and codomain.  (Contributed by Stefan O'Rear, 26-Feb-2015.) $)
    islindf2 $p |- ( ( W e. Y /\ I e. X /\ F : I --> B ) -> ( F LIndF W <->
          A. x e. I A. k e. ( N \ { .0. } ) -. ( k .x. ( F ` x ) ) e.
                  ( K ` ( F " ( I \ { x } ) ) ) ) ) $=
      ( wcel wf w3a clindf wbr cdm cv cfv co csn cdif cima wn wral wa cvv simp1
      wb simp3 simp2 fex syl2anc islindf wss ffdm simpld 3ad2ant3 biantrurd fdm
      wceq difeq1d imaeq2d fveq2d eleq2d notbid ralbidv raleqbidv 3bitr2d ) JLT
      ZGKTZGBFUAZUBZFJUCUDZFUEZBFUAZEUFAUFZFUGDUHZFWCWEUIZUJZUKZHUGZTZULZEIMUIU
      JZUMZAWCUMZUNZWOWFFGWGUJZUKZHUGZTZULZEWMUMZAGUMWAVRFUOTZWBWPUQVRVSVTUPWAV
      TVSXCVRVSVTURVRVSVTUSGBKFUTVAABCDEFHIJUOLMNOPQRSVBVAWAWDWOVTVRWDVSVTWDWCG
      VCGBFVDVEVFVGWAWNXBAWCGVTVRWCGVIVSGBFVHVFZWAWLXAEWMWAWKWTWAWJWSWFWAWIWRHW
      AWHWQFWAWCGWGXDVJVKVLVMVNVOVPVQ $.
  $}

  ${
    $d F k x $.  $d W k x $.
    lindff.b $e |- B = ( Base ` W ) $.
    $( Functional property of a linearly independent family.  (Contributed by
       Stefan O'Rear, 24-Feb-2015.) $)
    lindff $p |- ( ( F LIndF W /\ W e. Y ) -> F : dom F --> B ) $=
      ( vk vx clindf wbr wcel wa cdm wf cv cfv csn cdif wral cvv eqid cima csca
      cvsca co clspn wn cbs c0g simpl wb rellindf brrelexi islindf sylan2 mpbid
      ancoms simpld ) BCHIZCDJZKZBLZABMZFNGNZBOCUCOZUDBVAVCPQUACUEOZOJUFFCUBOZU
      GOZVFUHOZPQRGVARZUTURVBVIKZURUSUIUSURURVJUJZURUSBSJVKBCHUKULGAVFVDFBVEVGC
      SDVHEVDTVETVFTVGTVHTUMUNUPUOUQ $.
  $}

  ${
    $d a A $.  $d a e E $.  $d a e F $.  $d a e K $.  $d a e N $.  $d a e W $.
    $d a e .0. $.  $d a e .x. $.
    lindfind.s $e |- .x. = ( .s ` W ) $.
    lindfind.n $e |- N = ( LSpan ` W ) $.
    lindfind.l $e |- L = ( Scalar ` W ) $.
    lindfind.z $e |- .0. = ( 0g ` L ) $.
    lindfind.k $e |- K = ( Base ` L ) $.
    $( A linearly independent family is independent: no nonzero element
       multiple can be expressed as a linear combination of the others.
       (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    lindfind $p |- ( ( ( F LIndF W /\ E e. dom F ) /\
          ( A e. K /\ A =/= .0. ) ) -> -. ( A .x. ( F ` E ) ) e.
            ( N ` ( F " ( dom F \ { E } ) ) ) ) $=
      ( va ve wcel wa cfv cvv clindf wbr cdm wne cdif cv co cima wn wral simplr
      csn eldifsn biimpri adantl cbs wf csca elbasfv ad2antrl rellindf brrelexi
      simpll wb ad2antrr eqid islindf syl2anc mpbid simprd fveq2 oveq2d difeq2d
      wceq sneq imaeq2d fveq2d eleq12d notbid oveq1 eleq1d rspc2va syl21anc ) D
      HUAUBZCDUCZQZRZAEQZAIUDZRZRZWFAEIULUEZQZOUFZPUFZDSZBUGZDWEWOULZUEZUHZGSZQ
      ZUIZOWLUJPWEUJZACDSZBUGZDWECULZUEZUHZGSZQZUIZWDWFWJUKWJWMWGWMWJAEIUMUNUOW
      KWEHUPSZDUQZXDWKWDXNXDRZWDWFWJVCWKHTQZDTQZWDXOVDWHXPWGWIEFURAHLNUSUTWDXQW
      FWJDHUAVAVBVEPXMFBODGEHTTIXMVFJKLNMVGVHVIVJXCXLWNXEBUGZXJQZUIPOCAWEWLWOCV
      NZXBXSXTWQXRXAXJXTWPXEWNBWOCDVKVLXTWTXIGXTWSXHDXTWRXGWEWOCVOVMVPVQVRVSWNA
      VNZXSXKYAXRXFXJWNAXEBVTWAVSWBWC $.

    $( A linearly independent set is independent: no nonzero element multiple
       can be expressed as a linear combination of the others.  (Contributed by
       Stefan O'Rear, 24-Feb-2015.) $)
    lindsind $p |- ( ( ( F e. ( LIndS ` W ) /\ E e. F ) /\
      ( A e. K /\ A =/= .0. ) ) -> -. ( A .x. E ) e. ( N ` ( F \ { E } ) ) ) $=
      ( va ve clinds cfv wcel wa wne csn cdif cv co wral simplr eldifsn biimpri
      wn adantl cbs wss cdm wb elfvdm eqid islinds2 syl ibi ad2antrr wceq oveq2
      simprd sneq difeq2d fveq2d eleq12d notbid oveq1 eleq1d rspc2va syl21anc )
      DHQRSZCDSZTZAESAIUATZTVOAEIUBUCZSZOUDZPUDZBUEZDWAUBZUCZGRZSZUJZOVRUFPDUFZ
      ACBUEZDCUBZUCZGRZSZUJZVNVOVQUGVQVSVPVSVQAEIUHUIUKVNWHVOVQVNDHULRZUMZWHVNW
      PWHTZVNHQUNZSVNWQUODHQUPPWOFBODGEHWRIWOUQJKLNMURUSUTVDVAWGWNVTCBUEZWLSZUJ
      POCADVRWACVBZWFWTXAWBWSWEWLWACVTBVCXAWDWKGXAWCWJDWACVEVFVGVHVIVTAVBZWTWMX
      BWSWIWLVTACBVJVKVIVLVM $.
  $}

  ${
    lindfind2.k $e |- K = ( LSpan ` W ) $.
    lindfind2.l $e |- L = ( Scalar ` W ) $.
    $( In a linearly independent family in a module over a nonzero ring, no
       element is contained in the span of any non-containing set.
       (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    lindfind2 $p |- ( ( ( W e. LMod /\ L e. NzRing ) /\
          F LIndF W /\ E e. dom F ) -> -. ( F ` E ) e.
            ( K ` ( F " ( dom F \ { E } ) ) ) ) $=
      ( clmod wcel cnzr wa clindf wbr cdm cfv cbs eqid syl2anc adantl 3ad2ant1
      w3a cur cvsca co csn cdif cima wceq simp1l wf simp2 lindff simp3 ffvelrnd
      lmodvs1 c0g wne crg nzrrng rngidcl syl nzrnz lindfind syl22anc eqneltrrd
      wn ) EHIZDJIZKZBELMZABNZIZUAZDUBOZABOZEUCOZUDZVOBVKAUEUFUGCOZVMVGVOEPOZIV
      QVOUHVGVHVJVLUIZVMVKVSABVMVJVGVKVSBUJVIVJVLUKZVTVSBEHVSQZULRVIVJVLUMZUNVP
      VNDVSEVOWBGVPQZVNQZUORVMVJVLVNDPOZIZVNDUPOZUQZVQVRIVFWAWCVIVJWGVLVHWGVGVH
      DURIWGDUSWFDVNWFQZWEUTVASTVIVJWIVLVHWIVGDVNWHWEWHQZVBSTVNVPABWFDCEWHWDFGW
      KWJVCVDVE $.

    $( In a linearly independent set in a module over a nonzero ring, no
       element is contained in the span of any non-containing set.
       (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    lindsind2 $p |- ( ( ( W e. LMod /\ L e. NzRing ) /\
          F e. ( LIndS ` W ) /\ E e. F ) -> -. E e. ( K ` ( F \ { E } ) ) ) $=
      ( clmod wcel cnzr wa clinds cfv w3a cid cres cdif cima 3ad2ant3 wceq cdm
      csn clindf wbr wn linds2 3ad2ant2 dmresi eleq2i biimpri lindfind2 syl3anc
      simp1 fvresi difeq1i imaeq2i wss difss resiima ax-mp eqtri fveq2i eleq12d
      wb a1i mtbid ) EHIDJIKZBELMIZABIZNZAOBPZMZVKVKUAZAUBZQZRZCMZIZABVNQZCMZIZ
      VJVGVKEUCUDZAVMIZVRUEVGVHVIUMVHVGWBVIEBUFUGVIVGWCVHWCVIVMBABUHZUIUJSAVKCD
      EFGUKULVIVGVRWAVDVHVIVLAVQVTBAUNVQVTTVIVPVSCVPVKVSRZVSVOVSVKVMBVNWDUOUPVS
      BUQWEVSTBVNURBVSUSUTVAVBVEVCSVF $.
  $}

  ${
    $d F x y $.  $d L x y $.  $d W x y $.
    lindff1.b $e |- B = ( Base ` W ) $.
    lindff1.l $e |- L = ( Scalar ` W ) $.
    $( A linearly independent family over a nonzero ring has no repeated
       elements.  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    lindff1 $p |- ( ( W e. LMod /\ L e. NzRing /\ F LIndF W ) ->
        F : dom F -1-1-> B ) $=
      ( vx vy clmod wcel cnzr cv cfv wral syl2anc wa wne wss syl adantr wbr w3a
      clindf cdm wf wceq weq wi wf1 simp3 simp1 lindff csn cdif clspn wn simpl1
      cima crn imassrn frn syl5ss eqid lspssid wfun simprll jca eldifsn biimpri
      ffun adantlr adantl sylc sseldd simpl2 simpl3 simprlr lindfind2 syl211anc
      funfvima nelne2 expr necon4d ralrimivva dff13 sylanbrc ) DIJZCKJZBDUCUAZU
      BZBUDZABUEZGLZBMZHLZBMZUFGHUGUHZHWKNGWKNWKABUIWJWIWGWLWGWHWIUJWGWHWIUKABD
      IEULOZWJWQGHWKWKWJWMWKJZWOWKJZPZPWMWOWNWPWJXAWMWOQZWNWPQZWJXAXBPZPZWNBWKW
      OUMUNZURZDUOMZMZJWPXIJUPZXCXEXGXIWNXEWGXGARZXGXIRWGWHWIXDUQZWJXKXDWJXGBUS
      ZABXFUTWJWLXMARWRWKABVASVBTXGXHADEXHVCZVDOXEBVEZWSPWMXFJZWNXGJXEXOWSWJXOX
      DWJWLXOWRWKABVJSTWJWSWTXBVFVGXDXPWJWSXBXPWTXPWSXBPWMWKWOVHVIVKVLXFWMBVTVM
      VNXEWGWHWIWTXJXLWGWHWIXDVOWGWHWIXDVPWJWSWTXBVQWOBXHCDXNFVRVSWNWPXIWAOWBWC
      WDGHWKABWEWF $.
  $}

  ${
    $d F k x y $.  $d W k x y $.
    $( The range of an independent family is an independent set.  (Contributed
       by Stefan O'Rear, 24-Feb-2015.) $)
    lindfrn $p |- ( ( W e. LMod /\ F LIndF W ) -> ran F e. ( LIndS ` W ) ) $=
      ( vk vx vy clmod wcel wa cfv wss cv csn cdif wn wral eqid syl adantr wne
      wb clindf wbr crn clinds cbs cvsca co clspn csca c0g cdm wf lindff ancoms
      frn cima simpll imassrn syl5ss wfun ffun eldifsn wceq wrex wi wfn fvelrnb
      funfn sylbi difss jctr ad2antrr simpl fveq2 necon3i adantl funfvima2 sylc
      sylanbrc expr neeq1 eleq1 imbi12d syl5ibcom rexlimdva sylbid imp3a syl5bi
      ssrdv sylan lspss syl3anc simplr simprl eldifi ad2antll eldifsni lindfind
      adantrr ssneldd ralrimivva sylib oveq2 sneq difeq2d fveq2d eleq12d notbid
      syl22anc ralbidv ralrn mpbird islinds2 mpbir2and ) BFGZABUAUBZHZAUCZBUDIG
      ZXRBUEIZJZCKZDKZBUFIZUGZXRYCLZMZBUHIZIZGZNZCBUIIZUEIZYLUJIZLZMZOZDXROZXQA
      UKZXTAULZYAXPXOYTXTABFXTPZUMUNZYSXTAUOQZXQYRYBEKZAIZYDUGZXRUUELZMZYHIZGZN
      ZCYPOZEYSOZXQUUKECYSYPXQUUDYSGZYBYPGZHZHZUUIAYSUUDLZMZUPZYHIZUUFXQUUNUUIU
      VAJZUUOXQUUNHXOUUTXTJZUUHUUTJZUVBXOXPUUNUQXQUVCUUNXQUUTXRXTAUUSURUUCUSRXQ
      AUTZUUNUVDXQYTUVEUUBYSXTAVAQZUVEUUNHZDUUHUUTYCUUHGYCXRGZYCUUESZHUVGYCUUTG
      ZYCXRUUEVBUVGUVHUVIUVJUVGUVHYBAIZYCVCZCYSVDZUVIUVJVEZUVEUVHUVMTZUUNUVEAYS
      VFZUVOAVHZCYSYCAVGVIRUVGUVLUVNCYSUVGYBYSGZHUVKUUESZUVKUUTGZVEUVLUVNUVGUVR
      UVSUVTUVGUVRUVSHZHUVEUUSYSJZHZYBUUSGZUVTUVEUWCUUNUWAUVEUWBYSUURVJVKVLUWAU
      WDUVGUWAUVRYBUUDSZUWDUVRUVSVMUVSUWEUVRYBUUDUVKUUEYBUUDAVNVOVPYBYSUUDVBVSV
      PUUSYBAVQVRVTUVLUVSUVIUVTUVJUVKYCUUEWAUVKYCUUTWBWCWDWEWFWGWHWIWJUUHUUTYHX
      TBUUAYHPZWKWLWSUUQXPUUNYBYMGZYBYNSZUUFUVAGNXOXPUUPWMXQUUNUUOWNUUOUWGXQUUN
      YBYMYOWOWPUUOUWHXQUUNYBYMYNWQWPYBYDUUDAYMYLYHBYNYDPZUWFYLPZYNPZYMPZWRXIWT
      XAXQUVPYRUUMTXQUVEUVPUVFUVQXBYQUULDEYSAYCUUEVCZYKUUKCYPUWMYJUUJUWMYEUUFYI
      UUIYCUUEYBYDXCUWMYGUUHYHUWMYFUUGXRYCUUEXDXEXFXGXHXJXKQXLXOXSYAYRHTXPDXTYL
      YDCXRYHYMBFYNUUAUWIUWFUWJUWLUWKXMRXN $.
  $}

  ${
    $d F k x $.  $d G k x $.  $d K k x $.  $d W k x $.
    $( Rearranging and deleting elements from an independent family gives an
       independent family.  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    f1lindf $p |- ( ( W e. LMod /\ F LIndF W /\ G : K -1-1-> dom F ) ->
        ( F o. G ) LIndF W ) $=
      ( vk vx clmod wcel cfv wf cdif cima eqid syl2anc wss syl adantr wceq cvv
      wa clindf wbr cdm wf1 w3a ccom cbs cv cvsca co csn clspn wn csca c0g wral
      lindff ancoms 3adant3 f1f 3ad2ant3 fco ffdm simpld simpl2 eleq2d ffvelrnd
      wne fdm biimpa adantrr eldifi ad2antll eldifsni lindfind syl22anc wi f1fn
      wfn fvco2 oveq2d eleq1d simpl1 crn imassrn frn imaco difeq1d imaeq2d ccnv
      syl5ss wfun df-f1 simprbi imadif eqtrd fnsnfv sylan difeq2d ssdifd imass2
      eqsstr3d eqsstrd syl5eqss lspss syl3anc syldan sseld sylbid ralrimivva wb
      simp1 rellindf brrelexi 3ad2ant2 simp3 dmexg f1dmex fex islindf mpbir2and
      mtod coexg ) DGHZADUAUBZCAUCZBUDZUEZABUFZDUAUBZYIUCZDUGIZYIJZEUHZFUHZYIIZ
      DUIIZUJZYIYKYOUKZKZLZDULIZIZHZUMZEDUNIZUGIZUUFUOIZUKZKZUPFYKUPZYHCYLYIJZY
      MYHYFYLAJZCYFBJZUULYDYEUUMYGYEYDUUMYLADGYLMZUQURUSZYGYDUUNYECYFBUTVAZCYFY
      LABVBNZUULYMYKCOCYLYIVCVDPYHUUEFEYKUUJYHYOYKHZYNUUJHZTZTZUUDYNYOBIZAIZYQU
      JZAYFUVCUKZKZLZUUBIZHZUVBYEUVCYFHZYNUUGHZYNUUHVHZUVJUMYDYEYGUVAVEYHUUSUVK
      UUTYHUUSTZCYFYOBYHUUNUUSUUQQYHUUSYOCHZYHYKCYOYHUULYKCRUURCYLYIVIPZVFVJZVG
      VKUUTUVLYHUUSYNUUGUUIVLVMUUTUVMYHUUSYNUUGUUHVNVMYNYQUVCAUUGUUFUUBDUUHYQMZ
      UUBMZUUFMZUUHMZUUGMZVOVPYHUUSUUDUVJVQUUTUVNUUDUVEUUCHUVJUVNYRUVEUUCUVNYPU
      VDYNYQUVNBCVSZUVOYPUVDRYHUWCUUSYGYDUWCYECYFBVRVAZQUVQCABYOVTNWAWBUVNUUCUV
      IUVEYHUUSUVOUUCUVIOZUVQYHUVOTZYDUVHYLOZUUAUVHOUWEYDYEYGUVOWCYHUWGUVOYHUVH
      AWDZYLAUVGWEYHUUMUWHYLOUUPYFYLAWFPWKQUWFUUAABYTLZLZUVHABYTWGUWFUWIUVGOUWJ
      UVHOUWFUWIBCLZBYSLZKZUVGYHUWIUWMRUVOYHUWIBCYSKZLZUWMYHYTUWNBYHYKCYSUVPWHW
      IYHBWJWLZUWOUWMRYGYDUWPYEYGUUNUWPCYFBWMWNVACYSBWOPWPQUWFUWMUWKUVFKUVGUWFU
      VFUWLUWKYHUWCUVOUVFUWLRUWDCYOBWQWRWSUWFUWKYFUVFUWFUWKBWDZYFBCWEUWFUUNUWQY
      FOYHUUNUVOUUQQCYFBWFPWKWTXBXCUWIUVGAXAPXDUUAUVHUUBYLDUUOUVSXEXFXGXHXIVKYB
      XJYHYDYISHZYJYMUUKTXKYDYEYGXLYHASHZBSHZUWRYEYDUWSYGADUAXMXNXOZYHUUNCSHZUW
      TUUQYHYGYFSHZUXBYDYEYGXPYHUWSUXCUXAASXQPCYFSBXRNCYFSBXSNABSSYCNFYLUUFYQEY
      IUUBUUGDSGUUHUUOUVRUVSUVTUWBUWAXTNYA $.
  $}

  $( Any restriction of an independent family is independent.  (Contributed by
     Stefan O'Rear, 24-Feb-2015.) $)
  lindfres $p |- ( ( W e. LMod /\ F LIndF W ) -> ( F |` X ) LIndF W ) $=
    ( clmod wcel clindf wbr wa cres cid cdm ccom coires1 resdmres eqtri wf1 wss
    wf1o f1oi ax-mp f1of1 resss dmss f1ss mp2an f1lindf mp3an3 syl5eqbrr ) BDEZ
    ABFGZHACIZAJUKKZIZLZBFUNAULIUKAULMACNOUIUJULAKZUMPZUNBFGULULUMPZULUOQZUPULU
    LUMRUQULSULULUMUATUKAQURACUBUKAUCTULULUOUMUDUEAUMULBUFUGUH $.

  $( Any subset of an independent set is independent.  (Contributed by Stefan
     O'Rear, 24-Feb-2015.) $)
  lindsss $p |- ( ( W e. LMod /\ F e. ( LIndS ` W ) /\ G C_ F ) ->
      G e. ( LIndS ` W ) ) $=
    ( clmod wcel clinds cfv wss w3a cbs cid cres clindf wbr linds1 adantl sstr2
    wa eqid wb syl5com 3impia linds2 3ad2ant2 lindfres syl2anc resabs1 3ad2ant3
    simp1 breq1d mpbid islinds 3ad2ant1 mpbir2and ) CDEZACFGZEZBAHZIZBUPEZBCJGZ
    HZKBLZCMNZUOUQURVBUOUQRAVAHZURVBUQVEUOVACAVASZOPBAVAQUAUBUSKALZBLZCMNZVDUSU
    OVGCMNZVIUOUQURUIUQUOVJURCAUCUDVGCBUEUFURUOVIVDTUQURVHVCCMKBAUGUJUHUKUOUQUT
    VBVDRTURVADCBVFULUMUN $.

  $( A family constructed from non-repeated elements of an independent set is
     independent.  (Contributed by Stefan O'Rear, 26-Feb-2015.) $)
  f1linds $p |- ( ( W e. LMod /\ S e. ( LIndS ` W ) /\ F : D -1-1-> S ) ->
      F LIndF W ) $=
    ( clmod wcel clinds cfv wf1 w3a cid cres ccom clindf wceq wf fcoi2 3ad2ant3
    f1f wbr syl cdm simp1 linds2 3ad2ant2 wb dmresi f1eq3 ax-mp biimpri f1lindf
    syl3anc eqbrtrrd ) DEFZBDGHFZABCIZJZKBLZCMZCDNUPUNUSCOZUOUPABCPUTABCSABCQUA
    RUQUNURDNTZAURUBZCIZUSDNTUNUOUPUCUOUNVAUPDBUDUEUPUNVCUOVCUPVBBOVCUPUFBUGVBB
    ACUHUIUJRURCADUKULUM $.

  ${
    islindf3.l $e |- L = ( Scalar ` W ) $.
    $( In a nonzero ring, independent families can be equivalently
       characterized as renamings of independent sets.  (Contributed by Stefan
       O'Rear, 26-Feb-2015.) $)
    islindf3 $p |- ( ( W e. LMod /\ L e. NzRing ) -> ( F LIndF W <->
          ( F : dom F -1-1-> _V /\ ran F e. ( LIndS ` W ) ) ) ) $=
      ( wcel cnzr wa clindf wbr cdm cvv wf1 crn clinds cfv cbs wss eqid lindff1
      clmod 3expa ssv f1ss sylancl lindfrn adantlr jca simpll simprr wf1o f1of1
      f1f1orn syl ad2antrl f1linds syl3anc impbida ) CTEZBFEZGZACHIZAJZKALZAMZC
      NOEZGZUTVAGZVCVEVGVBCPOZALZVHKQVCURUSVAVIVHABCVHRDSUAVHUBVBVHKAUCUDURVAVE
      USACUEUFUGUTVFGURVEVBVDALZVAURUSVFUHUTVCVEUIVCVJUTVEVCVBVDAUJVJVBKAULVBVD
      AUKUMUNVBVDACUOUPUQ $.
  $}

  ${
    $d B k x $.  $d C k x $.  $d F k x $.  $d G k x $.  $d I k x $.
    $d S k x $.  $d T k x $.
    lindfmm.b $e |- B = ( Base ` S ) $.
    lindfmm.c $e |- C = ( Base ` T ) $.
    $( Linear independence of a family is unchanged by injective linear
       functions.  (Contributed by Stefan O'Rear, 26-Feb-2015.)  (Revised by
       Stefan O'Rear, 6-May-2015.) $)
    lindfmm $p |- ( ( G e. ( S LMHom T ) /\ G : B -1-1-> C /\ F : I --> B ) ->
        ( F LIndF S <-> ( G o. F ) LIndF T ) ) $=
      ( vk vx co wcel cvv wb wa cfv wral eqid syl3anc clmhm wf1 w3a clindf ccom
      wf wbr rellindf brrelexi simp3 dmfex syl2anr ex f1f fco sylan wi cv cvsca
      3adant1 csn cdif cima clspn wn cbs c0g eldifi wss simpllr clmod lmhmlmod1
      csca ad3antrrr simprr simprl simpl ffvelrn syl2an lmodvscl imassrn adantr
      crn frn syl5ss ad2antlr syl2anc f1elima wceq simplll lmhmlin wfn ad2antrl
      lspssv ffn fvco2 oveq2d eqtr4d lmhmlsp imaco fveq2i syl6eqr bitr3d notbid
      eleq12d anassrs sylan2 ralbidva lmhmsca fveq2d difeq12d ad2antrr islindf2
      sneqd raleqdv bitr4d lmhmlmod2 ad2ant2lr 3bitr4d exp32 3impia pm5.21ndd )
      FCDUALMZABFUBZGAEUFZUCZGNMZECUDUGZFEUEZDUDUGZYFYHYGYHENMYEYGYFECUDUHUIYCY
      DYEUJGANEUKULUMYFYJYGYJYINMGBYIUFZYGYFYIDUDUHUIYDYEYKYCYDABFUFYEYKABFUNGA
      BFEUOUPZUTGBNYIUKULUMYCYDYEYGYHYJOZUQYCYDPZYEYGYMYNYEYGPZPZJURZKURZEQZCUS
      QZLZEGYRVAVBZVCZCVDQZQZMZVEZJCVMQZVFQZUUHVGQZVAZVBZRZKGRZYQYRYIQZDUSQZLZY
      IUUBVCZDVDQZQZMZVEZJDVMQZVFQZUVCVGQZVAZVBZRZKGRZYHYJYPUUMUVHKGYPYRGMZPZUU
      MUVBJUULRUVHUVKUUGUVBJUULYQUULMUVKYQUUIMZUUGUVBOZYQUUIUUKVHYPUVJUVLUVMYPU
      VJUVLPZPZUUFUVAUVOUUAFQZFUUEVCZMZUUFUVAUVOYDUUAAMZUUEAVIZUVRUUFOYCYDYOUVN
      VJUVOCVKMZUVLYSAMZUVSYCUWAYDYOUVNCDFVLZVNZYPUVJUVLVOZYPYEUVJUWBUVNYNYEYGV
      PZUVJUVLVQZGAYREVRVSZYQYTUUHUUIACYSHUUHSZYTSZUUISZVTTUVOUWAUUCAVIZUVTUWDY
      OUWLYNUVNYOUUCEWCZAEUUBWAYEUWMAVIYGGAEWDWBWEWFZUUCUUDACHUUDSZWNWGABFUUAUU
      EWHTUVOUVPUUQUVQUUTUVOUVPYQYSFQZUUPLZUUQUVOYCUVLUWBUVPUWQWIYCYDYOUVNWJZUW
      EUWHUUICDYTUUPAFUUHYQYSUWIUWKHUWJUUPSZWKTUVOUUOUWPYQUUPYPEGWLZUVJUUOUWPWI
      UVNYEUWTYNYGGAEWOWMUWGGFEYRWPVSWQWRUVOUVQFUUCVCZUUSQZUUTUVOYCUWLUVQUXBWIU
      WRUWNCDUUCFUUDUUSAHUWOUUSSZWSWGUURUXAUUSFEUUBWTXAXBXEXCXDXFXGXHUVKUVBJUVG
      UULYCUVGUULWIYDYOUVJYCUVDUUIUVFUUKYCUVCUUHVFCDFUUHUVCUWIUVCSZXIZXJYCUVEUU
      JYCUVCUUHVGUXEXJXNXKVNXOXPXHYPUWAYGYEYHUUNOYCUWAYDYOUWCXLYNYEYGVOZUWFKAUU
      HYTJEGUUDUUICNVKUUJHUWJUWOUWIUWKUUJSXMTYPDVKMZYGYKYJUVIOYCUXGYDYOCDFXQXLU
      XFYDYEYKYCYGYLXRKBUVCUUPJYIGUUSUVDDNVKUVEIUWSUXCUXDUVDSUVESXMTXSXTYAYB $.

    $( Linear independence of a set is unchanged by injective linear
       functions.  (Contributed by Stefan O'Rear, 26-Feb-2015.) $)
    lindsmm $p |- ( ( G e. ( S LMHom T ) /\ G : B -1-1-> C /\ F C_ B ) ->
        ( F e. ( LIndS ` S ) <-> ( G " F ) e. ( LIndS ` T ) ) ) $=
      ( wcel wf1 cres clindf wbr wa clinds cfv wb wf wf1o clmod co wss w3a ccom
      clmhm cid cima ibar 3ad2ant3 f1oi f1of ax-mp fss sylancr lindfmm syld3an3
      simp3 bitr3d lmhmlmod1 3ad2ant1 islinds syl lmhmlmod2 adantr simpr f1ores
      f1of1 3adant1 f1linds syl3anc crn df-ima lindfrn syl5eqel impbida coires1
      sylan breq1i syl6bbr 3bitr4d ) FCDUEUAIZABFJZEAUBZUCZWCUFEKZCLMZNZFWEUDZD
      LMZECOPIZFEUGZDOPZIZWDWFWGWIWCWAWFWGQWBWCWFUHUIWAWBWCEAWERZWFWIQWDEEWERZW
      CWNEEWESWOEUJEEWEUKULWAWBWCUQEEAWEUMUNABCDWEFEGHUOUPURWDCTIZWJWGQWAWBWPWC
      CDFUSUTATCEGVAVBWDWMFEKZDLMZWIWDWMWRWDWMNDTIZWMEWKWQJZWRWDWSWMWAWBWSWCCDF
      VCUTZVDWDWMVEWDWTWMWBWCWTWAWBWCNEWKWQSWTABEFVFEWKWQVGVBVHVDEWKWQDVIVJWDWR
      NWKWQVKZWLFEVLWDWSWRXBWLIXAWQDVMVQVNVOWHWQDLFEVPVRVSVT $.

    $( The monomorphic image of an independent set is independent.
       (Contributed by Stefan O'Rear, 26-Feb-2015.) $)
    lindsmm2 $p |- ( ( G e. ( S LMHom T ) /\ G : B -1-1-> C /\
          F e. ( LIndS ` S ) ) -> ( G " F ) e. ( LIndS ` T ) ) $=
      ( clmhm co wcel wf1 clinds cfv w3a cima simp3 wss wb linds1 lindsmm mpbid
      syl3an3 ) FCDIJKZABFLZECMNKZOUFFEPDMNKZUDUEUFQUFUDUEEARUFUGSACEGTABCDEFGH
      UAUCUB $.
  $}

  ${
    $d F k x $.  $d S k x $.  $d U k x $.  $d W k x $.  $d X k x $.
    lsslindf.u $e |- U = ( LSubSp ` W ) $.
    lsslindf.x $e |- X = ( W |`s S ) $.
    $( Linear independence is unchanged by working in a subspace.  (Contributed
       by Stefan O'Rear, 24-Feb-2015.)  (Revised by Stefan O'Rear,
       6-May-2015.) $)
    lsslindf $p |- ( ( W e. LMod /\ S e. U /\ ran F C_ S ) ->
        ( F LIndF X <-> F LIndF W ) ) $=
      ( vk vx wcel wss cvv clindf wb wa cbs cfv wral eqid wceq clmod crn w3a wi
      wbr rellindf brrelexi a1i cdm wf cv cvsca co csn cdif cima clspn csca c0g
      wn simpr ressbasss fss sylancl wfn ffn adantl simp3 3ad2ant2 ressbas2 syl
      lssss sseqtrd adantr df-f sylanbrc impbida simpl2 resssca eqcomd difeq12d
      fveq2d sneqd ressvsca simpl1 imassrn simpl3 syl5ss lsslsp syl3anc eleq12d
      oveqd notbid raleqbidv ralbidv anbi12d cress ovex eqeltri sylan 3ad2antl1
      islindf 3bitr4d ex pm5.21ndd ) DUAJZABJZCUBZAKZUCZCLJZCEMUEZCDMUEZXLXKUDX
      JCEMUFUGUHXMXKUDXJCDMUFUGUHXJXKXLXMNXJXKOZCUIZEPQZCUJZHUKZIUKZCQZEULQZUMZ
      CXOXSUNUOZUPZEUQQZQZJZUTZHEURQZPQZYIUSQZUNZUOZRZIXORZOZXODPQZCUJZXRXTDULQ
      ZUMZYDDUQQZQZJZUTZHDURQZPQZUUEUSQZUNZUOZRZIXORZOZXLXMXNXQYRYOUUKXJXQYRNXK
      XJXQYRXJXQOXQXPYQKYRXJXQVAAYQEDGYQSZVBXOXPYQCVCVDXJYROCXOVEZXHXPKZXQYRUUN
      XJXOYQCVFVGXJUUOYRXJXHAXPXFXGXIVHXJAYQKZAXPTXGXFUUPXIBAYQDUUMFVLVIAYQEDGU
      UMVJVKVMVNXOXPCVOVPVQVNXNYNUUJIXOXNYHUUDHYMUUIXNYJUUFYLUUHXNYIUUEPXNXGYIU
      UETXFXGXIXKVRZXGUUEYIAUUEDEBGUUESZVSVTVKZWBXNYKUUGXNYIUUEUSUUSWBWCWAXNYGU
      UCXNYBYTYFUUBXNYAYSXRXTXNXGYAYSTUUQXGYSYAAYSDEBGYSSZWDVTVKWLXNUUBYFXNXFXG
      YDAKUUBYFTXFXGXIXKWEUUQXNYDXHACYCWFXFXGXIXKWGWHAYDBUUAYEDEGUUASZYESZFWIWJ
      VTWKWMWNWOWPXJELJZXKXLYPNUVCXJEDAWQUMLGDAWQWRWSUHIXPYIYAHCYEYJELLYKXPSYAS
      UVBYISYJSYKSXBWTXFXGXKXMUULNXIIYQUUEYSHCUUAUUFDLUAUUGUUMUUTUVAUURUUFSUUGS
      XBXAXCXDXE $.

    $( Linear independence is unchanged by working in a subspace.  (Contributed
       by Stefan O'Rear, 24-Feb-2015.) $)
    lsslinds $p |- ( ( W e. LMod /\ S e. U /\ F C_ S ) ->
        ( F e. ( LIndS ` X ) <-> F e. ( LIndS ` W ) ) ) $=
      ( clmod wcel wss cbs cfv clindf wbr wa clinds eqid 3ad2ant2 wb cvv sseq2d
      w3a cid cres wceq lssss ressbas2 sstr2 mpan9 simpl3 impbida bitr3d rnresi
      syl crn sseq1i lsslindf syl3an3br anbi12d cress ovex eqeltri islinds mp1i
      co 3ad2ant1 3bitr4d ) DHIZABIZCAJZUBZCEKLZJZUCCUDZEMNZOZCDKLZJZVNDMNZOZCE
      PLIZCDPLIZVKVMVRVOVSVKVJVMVRVKAVLCVIVHAVLUEZVJVIAVQJZWCBAVQDVQQZFUFZAVQED
      GWEUGUNRUAVKVJVRVKWDVJVRVIVHWDVJWFRCAVQUHUIVHVIVJVRUJUKULVJVHVIVNUOZAJVOV
      SSWGCACUMUPABVNDEFGUQURUSETIWAVPSVKEDAUTVETGDAUTVAVBVLTECVLQVCVDVHVIWBVTS
      VJVQHDCWEVCVFVG $.
  $}

  ${
    $d K k x $.  $d W k x $.  $d X k x $.
    islbs4.b $e |- B = ( Base ` W ) $.
    islbs4.j $e |- J = ( LBasis ` W ) $.
    islbs4.k $e |- K = ( LSpan ` W ) $.
    $( A basis is an independent spanning set.  (Contributed by Stefan O'Rear,
       24-Feb-2015.) $)
    islbs4 $p |- ( X e. J <-> ( X e. ( LIndS ` W ) /\ ( K ` X ) = B ) ) $=
      ( vk vx wcel cvv clinds cfv wa clbs elfvex cv csn eqid wceq eleq2s adantr
      wss cvsca co cdif wn csca cbs c0g wral w3a islbs islinds2 anbi1d syl6rbbr
      3anan32 bitrd pm5.21nii ) EBKZDLKZEDMNKZECNAUAZOZVBEDPNBEDPQGUBVCVBVDEDMQ
      UCVBVAEAUDZVDIRJRZDUENZUFEVGSUGCNKUHIDUINZUJNZVIUKNZSUGULJEULZUMZVEJIEVHV
      IBVJCADLVKFVITZVHTZVJTZGHVKTZUNVBVEVFVLOZVDOVMVBVCVRVDJAVIVHIECVJDLVKFVOH
      VNVPVQUOUPVFVDVLURUQUSUT $.
  $}

  ${
    $d J a $.  $d W a $.
    lbslinds.j $e |- J = ( LBasis ` W ) $.
    $( A basis is independent.  (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    lbslinds $p |- J C_ ( LIndS ` W ) $=
      ( va clinds cfv cv wcel clspn cbs wceq eqid islbs4 simplbi ssriv ) DABEFZ
      DGZAHQPHQBIFZFBJFZKSARBQSLCRLMNO $.
  $}

  ${
    islinds3.b $e |- B = ( Base ` W ) $.
    islinds3.k $e |- K = ( LSpan ` W ) $.
    islinds3.x $e |- X = ( W |`s ( K ` Y ) ) $.
    islinds3.j $e |- J = ( LBasis ` X ) $.
    $( A subset is linearly independent iff it is a basis of its span.
       (Contributed by Stefan O'Rear, 25-Feb-2015.) $)
    islinds3 $p |- ( W e. LMod -> ( Y e. ( LIndS ` W ) <-> Y e. J ) ) $=
      ( wcel clinds cfv wceq wa wss wi linds1 a1i eqid clmod clspn ressbasss wb
      cbs syl6ss adantr clss simpl lspcl lspssid lsslsp syl3anc lspssv ressbas2
      syl eqtr3d biantrud lsslinds bicomd anbi1d bitrd pm5.21ndd islbs4 syl6bbr
      ex ) DUAKZFDLMKZFELMKZFEUBMZMZEUEMZNZOZFBKVGFAPZVHVNVHVOQVGADFGRSVNVOQVGV
      IVOVMVIFVLAVLEFVLTZRFCMZAEDIGUCUFUGSVGVOVHVNUDVGVOOZVHVHVMOVNVRVMVHVRVQVK
      VLVRVGVQDUHMZKZFVQPZVQVKNVGVOUIZVSFCADGVSTZHUJZFCADGHUKZVQFVSCVJDEIHVJTZW
      CULUMVRVQAPVQVLNFCADGHUNVQAEDIGUOUPUQURVRVHVIVMVRVIVHVRVGVTWAVIVHUDWBWDWE
      VQVSFDEWCIUSUMUTVAVBVFVCVLBVJEFVPJWFVDVE $.
  $}

  ${
    $d J b $.  $d W b x $.  $d Y b x $.
    islinds4.j $e |- J = ( LBasis ` W ) $.
    $( A set is independent in a vector space iff it is a subset of some
       basis.  (AC equivalent) (Contributed by Stefan O'Rear, 24-Feb-2015.) $)
    islinds4 $p |- ( W e. LVec ->
        ( Y e. ( LIndS ` W ) <-> E. b e. J Y C_ b ) ) $=
      ( vx clvec wcel clinds cfv cv wss wrex wa cbs eqid ad2antrr simpr syl3anc
      ex csn cdif clspn wn wral simpl linds1 adantl csca cnzr lveclmod lvecdrng
      clmod cdr drngnzr syl simplr lindsind2 syl211anc ralrimiva lbslinds sseli
      lbsext ad2antlr lindsss rexlimdva impbid ) BGHZCBIJZHZCDKZLZDAMZVHVJVMVHV
      JNZVHCBOJZLZFKZCVQUAUBBUCJZJHUDZFCUEVMVHVJUFVJVPVHVOBCVOPZUGUHVNVSFCVNVQC
      HZNBUMHZBUIJZUJHZVJWAVSVHWBVJWABUKZQVHWDVJWAVHWCUNHWDWCBWCPZULWCUOUPQVHVJ
      WAUQVNWARVQCVRWCBVRPZWFURUSUTFCAVRVOBDEVTWGVCSTVHVLVJDAVHVKAHZNZVLVJWIVLN
      WBVKVIHZVLVJVHWBWHVLWEQWHWJVHVLAVIVKABEVAVBVDWIVLRVKCBVESTVFVG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Characterization of free modules
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    lmimlbs.j $e |- J = ( LBasis ` S ) $.
    lmimlbs.k $e |- K = ( LBasis ` T ) $.
    $( The isomorphic image of a basis is a basis.  (Contributed by Stefan
       O'Rear, 26-Feb-2015.) $)
    lmimlbs $p |- ( ( F e. ( S LMIso T ) /\ B e. J ) -> ( F " B ) e. K ) $=
      ( clmim co wcel cima clinds cfv clspn cbs wceq adantr eqid adantl wa wf1o
      clmhm wf1 lmimlmhm lmimf1o f1of1 syl lbslinds sseli syl3anc lbssp imaeq2d
      lindsmm2 wss lbsss lmhmlsp syl2an wfo f1ofo foima 3eqtr3d islbs4 sylanbrc
      3syl ) DBCIJKZAEKZUAZDALZCMNKZVICONZNZCPNZQVIFKVHDBCUCJKZBPNZVMDUDZABMNZK
      ZVJVFVNVGBCDUEZRVFVPVGVFVOVMDUBZVPVOVMBCDVOSZVMSZUFZVOVMDUGUHRVGVRVFEVQAE
      BGUIUJTVOVMBCADWAWBUNUKVHDABONZNZLZDVOLZVLVMVHWEVODVGWEVOQVFAEWDVOBWAGWDS
      ZULTUMVFVNAVOUOWFVLQVGVSAEVOBWAGUPBCADWDVKVOWAWHVKSZUQURVHVTVOVMDUSWGVMQV
      FVTVGWCRVOVMDUTVOVMDVAVEVBVMFVKCVIWBHWIVCVD $.

    $d J b f $.  $d K b f $.  $d S b f $.  $d T b f $.  $d V b f $.
    $( Having a basis is an isomorphism invariant.  (Contributed by Stefan
       O'Rear, 26-Feb-2015.) $)
    lmiclbs $p |- ( S ~=m T -> ( J =/= (/) -> K =/= (/) ) ) $=
      ( vf vb clmic wbr cv clmim co wcel wex c0 wne wi brlmic n0 bitri cima syl
      wa lmimlbs ne0i ex exlimdv syl5bi exlimiv sylbi ) ABIJZGKZABLMZNZGOZCPQZD
      PQZRZULUNPQUPABSGUNTUAUOUSGUQHKZCNZHOUOURHCTUOVAURHUOVAURUOVAUDUMUTUBZDNU
      RUTABUMCDEFUEDVBUFUCUGUHUIUJUK $.
  $}

  ${
    $d B j k l $.  $d B x y $.  $d F j k l $.  $d F x y $.  $d I j k l $.
    $d I x y $.  $d I z $.  $d L j x $.  $d R k l $.  $d R x y $.  $d R z $.
    $d .x. j k l $.  $d .x. x y $.  $d W j k l $.  $d W x y $.  $d X j k l $.
    $d X x y $.  $d X z $.  $d Y j k l $.  $d Y x y $.  $d Y z $.
    $d .0. j l x y $.  $d x z $.
    islindf4.b $e |- B = ( Base ` W ) $.
    islindf4.r $e |- R = ( Scalar ` W ) $.
    islindf4.t $e |- .x. = ( .s ` W ) $.
    islindf4.z $e |- .0. = ( 0g ` W ) $.
    islindf4.y $e |- Y = ( 0g ` R ) $.
    islindf4.l $e |- L = ( Base ` ( R freeLMod I ) ) $.
    $( A family is independent iff it has no nontrivial representations of
       zero.  (Contributed by Stefan O'Rear, 28-Feb-2015.) $)
    islindf4 $p |- ( ( W e. LMod /\ I e. X /\ F : I --> B ) ->
        ( F LIndF W <-> A. x e. L ( ( W gsum ( x oF .x. F ) ) = .0. ->
              x = ( I X. { Y } ) ) ) ) $=
      ( wcel wceq cvv vk vj vl vy vz clmod wf w3a cv cfv co csn cdif cima clspn
      wn cbs wral cof cgsu cxp wi clindf wbr wa cminusg raldifsni ccnv cfn cres
      cmap crab cop cun wb cplusg simpll1 simprll ffvelrn 3ad2antl3 adantr eqid
      lmodvsinv syl3anc eqeq1d cgrp lmodgrp syl lmodvscl lmodcmn simpll2 difexg
      ccmn simprlr elmapi wss simpll3 difss fssres lcomf simprr lcomfsup gsumcl
      sylancl grpinvid2 simplr fsnunf2 funsnfsup biimpri cin a1i eqcomd syl2anc
      vex wfn ffn oveq1d eqtrd oveq2d imbi12d cnveq imaeq1d eleq1d oveq1 adantl
      c0 syl6bbr wrex 3ad2ant2 syl5bb csca fvex eqeltri grpinvnzcl sylan eqeq2d
      3bitr4d c0g imbi2d ralbidva ad2antll incom disjdif difsnid gsumsplit snex
      eqtri unex simpl3 simpl2 fex offres sylancr neldifsn fsnunres cmpt fnfvof
      fnressn syl22anc cdm fndm eleq2d mtbiri fsnunfv mp3an12 3syl opeq2d sneqd
      ovex fmptsn mp2an 3eqtrd cmnd cmnmnd gsumsn oveq12d eqtr2d 3bitrd anassrs
      eqidd pm5.74da impexp imbi1i 3bitr4g 2ralbidva fveq1 bitr4d ralrab resima
      ralxpmap eqcomi fveq2i eleq2i simpl1 ellspd r19.23v ralbidv cfrlm frlmbas
      imbi1d mpan syl6reqr lmodfgrp eldifi grpinvinv syl2an fveq2 rspcev notbid
      raleqdv ralxfrd 3ad2ant1 fvconst2 islindf2 frlmbasf fnconstg ax-mp eqfnfv
      3ad2antl2 r19.21v ralbii ralcom bitr3i syl6bb ) HUFRZFIRZFBEUGZUHZUAUIZUB
      UIZEUJZDUKZEFUYJULZUMZUNZHUOUJZUJZRZUPZUACUQUJZJULZUMZURZUBFURHAUIZEDUSZU
      KZUTUKZKSZUYJVUDUJZUYJFVUAVAZUJZSZVBZAGURZUBFURZEHVCVDVUHVUDVUJSZVBZAGURZ
      UYHVUCVUNUBFUYHUYJFRZVEZUCUIZCVFUJZUJZUYKDUKZUYQRZUPZUCVUBURZVUHVUIJSZVBZ
      AGURZVUCVUNVVGVVEVVAJSZVBZUCUYTURZVUTVVJVVEUCUYTJVGVUTUDUIZVHTVUAUMZUNVIR
      ZVVDHVVNEUYNVJZVUEUKZUTUKZSZVEZVVKVBZUDUYTUYNVKUKZURZUCUYTURZVVIAUEUIZVHZ
      VVOUNZVIRZUEUYTFVKUKZVLZURZVVMVVJVUTVWEVUDVHZVVOUNZVIRZVVIVBZAVWJURZVWLVU
      TVWEVVNUYJVVAVMZULZVNZVHZVVOUNZVIRZHVWTEVUEUKZUTUKZKSZUYJVWTUJZJSZVBZVBZU
      DVWCURUCUYTURZVWQVUTVWBVXJUCUDUYTVWCVUTVVAUYTRZVVNVWCRZVEZVEZVVPVVTVVKVBZ
      VBVVPVXIVBVWBVXJVXOVVPVXPVXIVUTVXNVVPVXPVXIVOVUTVXNVVPVEZVEZVVTVXFVVKVXHV
      XRVVTVVAUYKDUKZHVFUJZUJZVVSSZVVSVXSHVPUJZUKZKSZVXFVXRVVDVYAVVSVXRUYEVXLUY
      KBRZVVDVYASUYEUYFUYGVUSVXQVQZVUTVXLVXMVVPVRZVUTVYFVXQUYGUYEVUSVYFUYFFBUYJ
      EVSVTWAZBVVADCUYTVVBVXTHUYKLMNVXTWBZVVBWBZUYTWBZWCWDWEVXRHWFRZVXSBRZVVSBR
      VYBVYEVOVXRUYEVYMVYGHWGWHVXRUYEVXLVYFVYNVYGVYHVYIVVADCUYTBHUYKLMNVYLWIWDZ
      VXRUYNBVVRHTKLOVXRUYEHWMRZVYGHWJWHZVXRUYFUYNTRZUYEUYFUYGVUSVXQWKZFUYMIWLZ
      WHZVXRBDCVVNVVQUYNUYTTHMVYLNLVYGVXRVXMUYNUYTVVNUGZVUTVXLVXMVVPWNVVNUYTUYN
      WOWHZVXRUYGUYNFWPZUYNBVVQUGZUYEUYFUYGVUSVXQWQZFUYMWRZFBUYNEWSZXDZWUAWTVXR
      BDCVVNVVQUYNUYTTHJKMVYLNLVYGWUCWUIWUAOPVUTVXNVVPXAXBXCBVYCHVXTVXSVVSKLVYC
      WBZOVYJXEWDVXRVYDVXEKVXRVXEHVXDUYNVJZUTUKZHVXDUYMVJZUTUKZVYCUKVYDVXRFBUYN
      UYMVYCVXDHIKLOWUJVYQVYSVXRBDCVWTEFUYTIHMVYLNLVYGVXRWUBVUSVXLFUYTVWTUGZWUC
      UYHVUSVXQXFZVYHFUYTVVNUYJVVAXGWDZWUFVYSWTZVXRBDCVWTEFUYTIHJKMVYLNLVYGWUQW
      UFVYSOPVVPVXCVUTVXNVXCVVPVVNUYJVVAVVOXHZXIUUAXBUYNUYMXJZYFSVXRWUTUYMUYNXJ
      YFUYNUYMUUBUYMFUUCUUGXKVXRVUSFUYNUYMVNZSWUPVUSWVAFFUYJUUDXLWHUUEVXRWULVVS
      WUNVXSVYCVXRWUKVVRHUTVXRWUKVWTUYNVJZVVQVUEUKZVVRVXRVWTTRETRZWUKWVCSVVNVWS
      UDXNVWRUUFUUHVUTWVDVXQVUTUYGUYFWVDUYEUYFUYGVUSUUIZUYEUYFUYGVUSUUJFBIEUUKX
      MWAUYNDVWTETTUULUUMVXRWVBVVNVVQVUEVXRVVNUYNXOZUYJUYNRZUPWVBVVNSVXRWUBWVFW
      UCUYNUYTVVNXPWHZUYJFUUNZUYNVVNUYJVVAUUOXDXQXRXSVXRWUNHAUYMVXSUUPZUTUKZVXS
      VXRWUMWVJHUTVXRWUMUYJUYJVXDUJZVMZULZUYJVXSVMZULZWVJVXRVXDFXOZVUSWUMWVNSVX
      RFBVXDUGWVQWURFBVXDXPWHWUPFUYJVXDUURXMVXRWVMWVOVXRWVLVXSUYJVXRWVLVXGUYKDU
      KZVXSVXRVWTFXOZEFXOZUYFVUSWVLWVRSVXRWUOWVSWUQFUYTVWTXPWHVXRUYGWVTWUFFBEXP
      WHVYSWUPFDVWTEIUYJUUQUUSVXRVXGVVAUYKDVXRWVFUYJVVNUUTZRZUPZVXGVVASZWVHWVFW
      WBWVGWVIWVFWWAUYNUYJUYNVVNUVAUVBUVCUYJTRZVVATRWWCWWDUBXNZUCXNVVNTTUYJVVAU
      VDUVEUVFZXQXRUVGUVHWVPWVJSZVXRWWEVXSTRWWHWWFVVAUYKDUVIAUYJVXSTTUVJUVKXKUV
      LXSVXRHUVMRZWWEVYNWVKVXSSVXRVYPWWIVYQHUVNWHWWEVXRWWFXKVYOVXSBVXSAHUYJTLVU
      DUYJSVXSUVTUVOWDXRUVPUVQWEUVRVXRVVAVXGJVXRVXGVVAWWGXLWEXTUVSUWAVVPVVTVVKU
      WBVXCVVPVXIWUSUWCUWDUWEVUSVWQVXKVOUYHVWPVXJUCUYTFAUDUYJVUDVWTSZVWOVXCVVIV
      XIWWJVWNVXBVIWWJVWMVXAVVOVUDVWTYAYBYCWWJVUHVXFVVHVXHWWJVUGVXEKWWJVUFVXDHU
      TVUDVWTEVUEYDXSWEWWJVUIVXGJUYJVUDVWTUWFWEXTXTUWJYEUWGVWIVWOVVIAUEVWJVWFVU
      DSZVWHVWNVIWWKVWGVWMVVOVWFVUDYAYBYCUWHYGVUTVVLVWDUCUYTVUTVVLVWAUDVWCYHZVV
      KVBVWDVUTVVEWWLVVKVVEVVDVVQUYNUNZUYPUJZRVUTWWLUYQWWNVVDUYOWWMUYPWWMUYOEUY
      NUWIUWKUWLUWMVUTBCDUDVVQUYNUYTHUYPVVDJUYPWBZLVYLMPNVUTUYGWUDWUEWVEWUGWUHX
      DUYEUYFUYGVUSUWNUYHVYRVUSUYFUYEVYRUYGVYTYIWAUWOYJUWTVWAVVKUDVWCUWPYGUWQVU
      TVVIAGVWKVUTVWKCFUWRUKZUQUJZGUYHVWKWWQSZVUSUYFUYEWWRUYGCTRUYFWWRCHYKUJTMH
      YKYLYMVWKCUEWWPFUYTTIJWWPWBZVYLPVWKWBUWSUXAYIWAQUXBUXJYQYJUYHVUCVVGVOZVUS
      UYEUYFWWTUYGUYEUYSVVFUAUCVVCVUBVUBUYECWFRZVVAVUBRVVCVUBRCHMUXCZUYTCVVBVVA
      JVYLPVYKYNYOUYEUYIVUBRZVEZUYIVVBUJZVUBRZUYIWXEVVBUJZSZUYIVVCSZUCVUBYHUYEW
      XAWXCWXFWXBUYTCVVBUYIJVYLPVYKYNYOWXDWXGUYIUYEWXAUYIUYTRWXGUYISWXCWXBUYIUY
      TVUAUXDUYTCVVBUYIVYLVYKUXEUXFXLWXIWXHUCWXEVUBVVAWXESVVCWXGUYIVVAWXEVVBUXG
      YPUXHXMWXIUYSVVFVOUYEWXIUYRVVEWXIUYLVVDUYQUYIVVCUYKDYDYCUXIYEUXKUXLWAVUTV
      UMVVIAGVUTVUDGRZVEZVULVVHVUHWXKVUKJVUIWXKVUSVUKJSUYHVUSWXJXFFJUYJJCYRUJTP
      CYRYLYMZUXMWHYPYSYTYQYTUBBCDUAEFUYPUYTHIUFJLNWWOMVYLPUXNUYHVURVUHVULUBFUR
      ZVBZAGURZVUOUYHVUQWXNAGUYHWXJVEZVUPWXMVUHWXPVUDFXOZVUJFXOZVUPWXMVOWXPFUYT
      VUDUGZWXQUYFUYEWXJWXSUYGGCWWPFUYTIVUDWWSVYLQUXOUXSFUYTVUDXPWHJTRWXRWXLFJT
      UXPUXQUBFVUDVUJUXRXDYSYTWXOVUMUBFURZAGURVUOWXTWXNAGVUHVULUBFUXTUYAVUMAUBG
      FUYBUYCUYDYQ $.
  $}

  ${
    $d ph x y $.  $d A x y $.  $d B x y $.  $d C x y $.  $d E y $.  $d F x y $.
    $d I x y $.  $d R x $.  $d T x y $.  $d .x. x y $.  $d X x y $.
    islindf5.f $e |- F = ( R freeLMod I ) $.
    islindf5.b $e |- B = ( Base ` F ) $.
    islindf5.c $e |- C = ( Base ` T ) $.
    islindf5.v $e |- .x. = ( .s ` T ) $.
    islindf5.e $e |- E = ( x e. B |-> ( T gsum ( x oF .x. A ) ) ) $.
    islindf5.t $e |- ( ph -> T e. LMod ) $.
    islindf5.i $e |- ( ph -> I e. X ) $.
    islindf5.r $e |- ( ph -> R = ( Scalar ` T ) ) $.
    islindf5.a $e |- ( ph -> A : I --> C ) $.
    $( A family is independent iff the linear combinations homomorphism is
       injective.  (Contributed by Stefan O'Rear, 28-Feb-2015.) $)
    islindf5 $p |- ( ph -> ( A LIndF T <-> E : B -1-1-> C ) ) $=
      ( vy clindf wbr cv cfv c0g wceq wi wral wf1 cof co cgsu csn cxp cfrlm cbs
      csca clmod wcel wf wb eqid islindf4 syl3anc wa oveq1 oveq2d adantl eqeq1d
      fvmpt crg lmodrng eqeltrd frlm0 syl2anc fveq2d sneqd xpeq2d eqtr3d adantr
      ovex syl eqeq2d imbi12d ralbidva eqcomd oveq1d syl6eqr raleqdv clmhm cghm
      bitr4d frlmup1 lmghm ghmf1 3syl ) ACGUCUDZUBUEZIUFZGUGUFZUHZWTJUGUFZUHZUI
      ZUBDUJZDEIUKZAWSGWTCHULZUMZUNUMZXBUHZWTKGUSUFZUGUFZUOZUPZUHZUIZUBXMKUQUMZ
      URUFZUJZXGAGUTVAZKLVAZKECVBWSYAVCRSUAUBEXMHCKXTGLXNXBOXMVDZPXBVDZXNVDXTVD
      VEVFAXGXRUBDUJYAAXFXRUBDAWTDVAZVGZXCXLXEXQYGXAXKXBYFXAXKUHABWTGBUEZCXIUMZ
      UNUMXKDIYHWTUHYIXJGUNYHWTCXIVHVIQGXJUNWCVLVJVKYGXDXPWTAXDXPUHYFAKFUGUFZUO
      ZUPZXDXPAFVMVAYCYLXDUHAFXMVMTAYBXMVMVARXMGYDVNWDVOSFJKLYJMYJVDVPVQAYKXOKA
      YJXNAFXMUGTVRVSVTWAWBWEWFWGAXRUBXTDAXTJURUFDAXSJURAXSFKUQUMJAXMFKUQAFXMTW
      HWIMWJVRNWJWKWNWNAIJGWLUMVAIJGWMUMVAXHXGVCABCDEFGHIJKLMNOPQRSTUAWOJGIWPUB
      JGXBIDEXDNOXDVDYEWQWRWN $.
  $}

  ${
    $d ph x $.  $d A x $.  $d B x $.  $d C x $.  $d F x $.  $d I x $.
    $d N x $.  $d R x $.  $d T x $.  $d .x. x $.  $d X x $.
    indlcim.f $e |- F = ( R freeLMod I ) $.
    indlcim.b $e |- B = ( Base ` F ) $.
    indlcim.c $e |- C = ( Base ` T ) $.
    indlcim.v $e |- .x. = ( .s ` T ) $.
    indlcim.n $e |- N = ( LSpan ` T ) $.
    indlcim.e $e |- E = ( x e. B |-> ( T gsum ( x oF .x. A ) ) ) $.
    indlcim.t $e |- ( ph -> T e. LMod ) $.
    indlcim.i $e |- ( ph -> I e. X ) $.
    indlcim.r $e |- ( ph -> R = ( Scalar ` T ) ) $.
    indlcim.a $e |- ( ph -> A : I -onto-> J ) $.
    indlcim.l $e |- ( ph -> A LIndF T ) $.
    indlcim.s $e |- ( ph -> ( N ` J ) = C ) $.
    $( An independent, spanning family extends to an isomorphism from a free
       module.  (Contributed by Stefan O'Rear, 26-Feb-2015.) $)
    indlcim $p |- ( ph -> E e. ( F LMIso T ) ) $=
      ( clmhm co wcel wf1o clmim wfn crn wss wfo fofn syl cdm clindf wbr lindff
      wf clmod syl2anc frn df-f sylanbrc frlmup1 wf1 islindf5 mpbid cfv frlmup3
      wceq forn fveq2d 3eqtrd dff1o5 islmim ) AIJGUGUHUIDEIUJZIJGUKUHUIABCDEFGH
      IJKNOPQRTUAUBUCACKULZCUMZEUNZKECVBAKLCUOZWAUDKLCUPUQACURZECVBZWCACGUSUTZG
      VCUIWFUEUAECGVCQVAVDWEECVEUQKECVFVGZVHADEIVIZIUMZEVNVTAWGWIUEABCDEFGHIJKN
      OPQRTUAUBUCWHVJVKAWJWBMVLLMVLEABCDEFGHIJKMNOPQRTUAUBUCWHSVMAWBLMAWDWBLVNU
      DKLCVOUQVPUFVQDEIVRVGDEJGIPQVSVG $.
  $}

  ${
    $d B e $.  $d F e $.  $d I e $.  $d J e $.  $d W e $.  $d B x $.  $d F x $.
    $d I x $.  $d J x $.  $d W x $.  $d e x $.
    lbslcic.f $e |- F = ( Scalar ` W ) $.
    lbslcic.j $e |- J = ( LBasis ` W ) $.
    $( A module with a basis is isomorphic to a free module with the same
       cardinality.  (Contributed by Stefan O'Rear, 26-Feb-2015.) $)
    lbslcic $p |- ( ( W e. LMod /\ B e. J /\ I ~~ B ) ->
        W ~=m ( F freeLMod I ) ) $=
      ( ve vx wcel cen wbr cv co cbs cfv clmim cvv eqid adantr clmod wf1o cfrlm
      w3a clmic wex simp3 bren sylib wa cvsca cgsu cmpt ccnv clspn simpl1 relen
      cof brrelexi 3ad2ant3 csca wceq a1i wfo adantl clinds wf1 clindf lbslinds
      f1ofo sseli 3ad2ant2 f1of1 f1linds syl3anc lbssp indlcim lmimcnv exlimddv
      brlmici 3syl ) EUAJZADJZCAKLZUDZCAHMZUBZEBCUCNZUELZHWEWDWGHUFWBWCWDUGCAHU
      HUIWEWGUJZIWHOPZEIMWFEUKPZURNULNUMZWHEQNJWMUNZEWHQNJWIWJIWFWKEOPZBEWLWMWH
      CAEUOPZRWHSWKSWOSZWLSWPSZWMSWBWCWDWGUPZWECRJZWGWDWBWTWCCAKUQUSUTTBEVAPVBW
      JFVCWGCAWFVDWECAWFVJVEWJWBAEVFPZJZCAWFVGZWFEVHLWSWEXBWGWCWBXBWDDXAADEGVIV
      KVLTWGXCWECAWFVMVECAWFEVNVOWEAWPPWOVBZWGWCWBXDWDADWPWOEWQGWRVPVLTVQWHEWMV
      REWHWNVTWAVS $.
  $}

  ${
    $d F j k $.  $d J j k $.  $d W j k $.
    lmisfree.j $e |- J = ( LBasis ` W ) $.
    lmisfree.f $e |- F = ( Scalar ` W ) $.
    $( A module has a basis iff it is isomorphic to a free module.  In settings
       where isomorphic objects are not distinguished, it is common to define
       "free module" as any module with a basis; thus for instance ~ lbsex
       might be described as "every vector space is free."  (Contributed by
       Stefan O'Rear, 26-Feb-2015.) $)
    lmisfree $p |- ( W e. LMod -> ( J =/= (/) <->
        E. k W ~=m ( F freeLMod k ) ) ) $=
      ( vj wcel c0 wne cv cfrlm co clmic wbr wex vex syl cvv eqid clmod lbslcic
      n0 wa cen enref mp3an3 weq oveq2 breq2d spcev exlimdv syl5bi clbs lmicsym
      ex cfv lmiclcl cuvc crn lmodrng frlmlbs sylancl ne0i lmiclbs sylc exlimiv
      crg impbid1 ) DUAHZCIJZDBAKZLMZNOZAPZVKGKZCHZGPVJVOGCUCVJVQVOGVJVQVOVJVQU
      DDBVPLMZNOZVOVJVQVPVPUEOVSVPGQZUFVPBVPCDFEUBUGVNVSAVPVTAGUHVMVRDNVLVPBLUI
      UJUKRUPULUMVNVKAVNVMDNOVMUNUQZIJZVKDVMUOVNVJWBDVMURVJBVLUSMZUTZWAHZWBVJBV
      HHVLSHWEBDFVAAQBWCVMVLWASVMTWCTWATZVBVCWAWDVDRRVMDWACWFEVEVFVGVI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Noetherian rings and left modules II
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LNoeR $.

  $( Extend class notation with the class of left Noetherian rings. $)
  clnr $a class LNoeR $.

  $( A ring is _left-Noetherian_ iff it is Noetherian as a left module over
     itself.  (Contributed by Stefan O'Rear, 24-Jan-2015.) $)
  df-lnr $a |- LNoeR = { a e. Ring | ( ringLMod ` a ) e. LNoeM } $.

  ${
    $d A a $.
    $( Property of a left-Noetherian ring.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    islnr $p |- ( A e. LNoeR <-> ( A e. Ring /\
        ( ringLMod ` A ) e. LNoeM ) ) $=
      ( va cv crglmod cfv clnm wcel crg clnr wceq fveq2 eleq1d df-lnr elrab2 )
      BCZDEZFGADEZFGBAHIOAJPQFOADKLBMN $.

    $( Left-Noetherian rings are rings.  (Contributed by Stefan O'Rear,
       24-Jan-2015.) $)
    lnrrng $p |- ( A e. LNoeR -> A e. Ring ) $=
      ( clnr wcel crg crglmod cfv clnm islnr simplbi ) ABCADCAEFGCAHI $.

    $( Left-Noetherian rings have Noetherian associated modules.  (Contributed
       by Stefan O'Rear, 24-Jan-2015.) $)
    lnrlnm $p |- ( A e. LNoeR -> ( ringLMod ` A ) e. LNoeM ) $=
      ( clnr wcel crg crglmod cfv clnm islnr simprbi ) ABCADCAEFGCAHI $.
  $}

  ${
    $d i g R $.  $d i g N $.  $d i g U $.  $d i g B $.
    islnr2.b $e |- B = ( Base ` R ) $.
    islnr2.u $e |- U = ( LIdeal ` R ) $.
    islnr2.n $e |- N = ( RSpan ` R ) $.
    $( Property of being a left-Noetherian ring in terms of finite generation
       of ideals (the usual "pure ring theory" definition).  (Contributed by
       Stefan O'Rear, 24-Jan-2015.) $)
    islnr2 $p |- ( R e. LNoeR <-> ( R e. Ring /\
        A. i e. U E. g e. ( ~P B i^i Fin ) i = ( N ` g ) ) ) $=
      ( clnr wcel crg crglmod cfv clnm wa cv wceq cbs eqtri cpw wrex wral islnr
      cfn cin clmod wb rlmlmod rlmbas clidl clss lidlval crsp clspn rspval baib
      islnm2 syl pm5.32i bitri ) BJKBLKZBMNZOKZPVBEQDQFNRDAUAUEUFUBECUCZPBUDVBV
      DVEVBVCUGKZVDVEUHBUIVDVFVEACDEVCFABSNVCSNGBUJTCBUKNVCULNHBUMTFBUNNVCUONIB
      UPTURUQUSUTVA $.
  $}

  ${
    $d B x y $.  $d R x y $.  $d U x y $.
    islnr3.b $e |- B = ( Base ` R ) $.
    islnr3.u $e |- U = ( LIdeal ` R ) $.
    $( Relate left-Noetherian rings to Noetherian-type closure property of the
       left ideal system.  (Contributed by Stefan O'Rear, 4-Apr-2015.) $)
    islnr3 $p |- ( R e. LNoeR <-> ( R e. Ring /\ U e. ( NoeACS ` B ) ) ) $=
      ( vx vy clnr wcel crg cv crsp cfv wceq cpw cfn wrex wral wa eqid cin cacs
      cnacs islnr2 mrcrsp fveq1d eqeq2d rexbidv ralbidv lidlacs biantrurd bitrd
      cmrc isnacs syl6bbr pm5.32i bitri ) BHIBJIZFKZGKZBLMZMZNZGAOPUAZQZFCRZSUR
      CAUCMIZSABCGFVADEVATZUDURVFVGURVFCAUBMIZUSUTCUMMZMZNZGVDQZFCRZSZVGURVFVNV
      OURVEVMFCURVCVLGVDURVBVKUSURUTVAVJBCVJVAEVHVJTZUEUFUGUHUIURVIVNACBDEUJUKU
      LCGVJAFVPUNUOUPUQ $.
  $}

  ${
    $d I g i $.  $d N g i $.  $d R g i $.  $d U g i $.
    lnr2i.u $e |- U = ( LIdeal ` R ) $.
    lnr2i.n $e |- N = ( RSpan ` R ) $.
    $( Given an ideal in a left-Noetherian ring, there is a finite subset which
       generates it.  (Contributed by Stefan O'Rear, 31-Mar-2015.) $)
    lnr2i $p |- ( ( R e. LNoeR /\ I e. U ) ->
        E. g e. ( ~P I i^i Fin ) I = ( N ` g ) ) $=
      ( vi wcel wa cv cfv wceq cpw cfn cin wrex wi wss 3imtr4g clnr wral islnr2
      cbs crg eqid simprbi eqeq1 rexbidv rspcva sylan2 ancoms lnrrng rspssid ex
      sylan vex elpw anim1d elin pweq ineq1d eleq2d imbi2d syl5ibrcom imdistand
      ancom reximdv2 adantr mpd ) AUAIZDBIZJDCKZELZMZCAUDLZNZOPZQZVOCDNZOPZQZVL
      VKVSVKVLHKZVNMZCVRQZHBUBZVSVKAUEIZWFVPABCHEVPUFZFGUCUGWEVSHDBWCDMWDVOCVRW
      CDVNUHUIUJUKULVKVSWBRVLVKVOVOCVRWAVKVOVMVRIZJVOVMWAIZJWIVOJWJVOJVKVOWIWJV
      KWIWJRVOWIVMVNNZOPZIZRVKVMVQIZVMOIZJVMWKIZWOJWIWMVKWNWPWOVKVMVPSZVMVNSZWN
      WPVKWQWRVKWGWQWRAUMVPAVMEGWHUNUPUOVMVPCUQZURVMVNWSURTUSVMVQOUTVMWKOUTTVOW
      JWMWIVOWAWLVMVOVTWKODVNVAVBVCVDVEVFWIVOVGWJVOVGTVHVIVJ $.
  $}

  ${
    $d a b c R $.
    $( Left principal ideal rings are left Noetherian.  (Contributed by Stefan
       O'Rear, 24-Jan-2015.) $)
    lpirlnr $p |- ( R e. LPIR -> R e. LNoeR ) $=
      ( va vb vc clpir wcel crg cv crsp cfv wceq cbs cpw cfn cin wrex wral eqid
      wa sylanbrc clidl lpirrng clpidl csn wb islpidl syl biimpa snelpwi adantl
      clnr snfi a1i elin fveq2 eqeq2d rspcev sylancl eqeq1 syl5ibrcom rexlimdva
      rexbidv mpd ralrimiva islpir simprbi raleqdv mpbird islnr2 ) AEFZAGFZBHZC
      HZAIJZJZKZCALJZMZNOZPZBAUAJZQZAUKFAUBZVJWBVTBAUCJZQVJVTBWDVJVLWDFZSZVLDHZ
      UDZVNJZKZDVQPZVTVJWEWKVJVKWEWKUEWCVQWDADVLVNWDRZVNRZVQRZUFUGUHWFWJVTDVQWF
      WGVQFZSZVTWJWIVOKZCVSPZWPWHVSFZWIWIKZWRWPWHVRFZWHNFZWSWOXAWFWGVQUIUJXBWPW
      GULUMWHVRNUNTWIRWQWTCWHVSVMWHKVOWIWIVMWHVNUOUPUQURWJVPWQCVSVLWIVOUSVBUTVA
      VCVDVJVTBWAWDVJVKWAWDKWDAWAWLWARZVEVFVGVHVQAWACBVNWNXCWMVIT $.
  $}

  ${
    lnrfrlm.y $e |- Y = ( R freeLMod I ) $.
    $( Finite-dimensional free modules over a Noetherian ring are Noetherian.
       (Contributed by Stefan O'Rear, 3-Feb-2015.) $)
    lnrfrlm $p |- ( ( R e. LNoeR /\ I e. Fin ) -> Y e. LNoeM ) $=
      ( clnr wcel cfn wa crglmod cfv cpws co clnm frlmpwsfi lnrlnm pwslnm sylan
      eqid eqeltrd ) AEFZBGFZHCAIJZBKLZMACBEDNTUBMFUAUCMFAOBUBUCUCRPQS $.
  $}

  ${
    $d S a b c d $.  $d M a b c d $.
    lnrfg.s $e |- S = ( Scalar ` M ) $.
    $( Finitely-generated modules over a Noetherian ring, being homomorphic
       images of free modules, are Noetherian.  (Contributed by Stefan O'Rear,
       7-Feb-2015.) $)
    lnrfg $p |- ( ( M e. LFinGen /\ S e. LNoeR ) -> M e. LNoeM ) $=
      ( va vb clfig wcel clnr wa cv cfv cbs wceq clnm eqid co crn cvv a1i wf wb
      cfn clspn cpw wrex clmod fglmod islmodfg syl ibi cfrlm cid cres cvsca cof
      cgsu cmpt clmhm ad3antrrr vex csca wss wf1o f1oi f1of ax-mp elpwi sylancr
      adantr fss ad2antlr frlmup1 simpllr simprl lnrfrlm syl2anc frlmup3 rnresi
      fveq2i simprr syl5eq eqtrd lnmepi syl3anc exp31 rexlimdv mpd ) BFGZAHGZIZ
      DJZUBGZWKBUCKZKZBLKZMZIZDWOUDZUEZBNGZWHWSWIWHWSWHBUFGZWHWSUABUGZWOWMBDWOO
      ZWMOZUHUIUJVIWJWQWTDWRWJWKWRGZWQWTWJXEIZWQIZEAWKUKPZLKZBEJULWKUMZBUNKZUOP
      UPPUQZXHBURPGXHNGZXLQZWOMWTXGEXJXIWOABXKXLXHWKRXHOZXIOZXCXKOZXLOZWHXAWIXE
      WQXBUSZWKRGXGDUTSZABVAKMXGCSZXEWKWOXJTZWJWQXEWKWKXJTZWKWOVBYBWKWKXJVCYCWK
      VDWKWKXJVEVFWKWOVGWKWKWOXJVJVHVKZVLXGWIWLXMWHWIXEWQVMXFWLWPVNAWKXHXOVOVPX
      GXNXJQZWMKZWOXGEXJXIWOABXKXLXHWKWMRXOXPXCXQXRXSXTYAYDXDVQXGYFWNWOYEWKWMWK
      VRVSXFWLWPVTWAWBWOXHBXLXCWCWDWEWFWG $.

    lnrfgtr.u $e |- U = ( LSubSp ` M ) $.
    lnrfgtr.n $e |- N = ( M |`s P ) $.
    $( A submodule of a finitely generated module over a Noetherian ring is
       finitely generated.  Often taken as the definition of Noetherian ring.
       (Contributed by Stefan O'Rear, 7-Feb-2015.) $)
    lnrfgtr $p |- ( ( M e. LFinGen /\ S e. LNoeR /\ P e. U ) ->
        N e. LFinGen ) $=
      ( clfig wcel clnr w3a clnm lnrfg 3adant3 simp3 lnmlssfg syl2anc ) DIJZBKJ
      ZACJZLDMJZUAEIJSTUBUABDFNOSTUAPECADGHQR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Hilbert's Basis Theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ldgIdlSeq $.

  $( The leading ideal sequence used in the Hilbert Basis Theorem. $)
  cldgis $a class ldgIdlSeq $.

  ${
    $d r i x j k $.
    $( Define a function which carries polynomial ideals to the sequence of
       coefficient ideals of leading coefficients of degree- ` x ` elements in
       the polynomial ideal.  The proof that this map is strictly monotone is
       the core of the Hilbert Basis Theorem ~ hbt .  (Contributed by Stefan
       O'Rear, 31-Mar-2015.) $)
    df-ldgis $a |- ldgIdlSeq = ( r e. _V |-> ( i e.
            ( LIdeal ` ( Poly1 ` r ) ) |-> ( x e. NN0 |->
                { j | E. k e. i ( ( ( deg1 ` r ) ` k ) <_ x /\
                      j = ( ( coe1 ` k ) ` x ) ) } ) ) ) $.
  $}

  ${
    hbtlem.p $e |- P = ( Poly1 ` R ) $.
    hbtlem.u $e |- U = ( LIdeal ` P ) $.
    hbtlem.s $e |- S = ( ldgIdlSeq ` R ) $.

    ${
      $d D i r x $.  $d I i j k x $.  $d R i j k r x $.  $d U i r $.
      $d X j k x $.
      hbtlem.d $e |- D = ( deg1 ` R ) $.
      $( Value of the leading coefficient sequence function.  (Contributed by
         Stefan O'Rear, 31-Mar-2015.) $)
      hbtlem1 $p |- ( ( R e. V /\ I e. U /\ X e. NN0 ) -> ( ( S ` I ) ` X ) =
          { j | E. k e. I ( ( D ` k ) <_ X /\ j = ( ( coe1 ` k ) ` X ) ) } ) $=
        ( vi vx cn0 cfv wceq cvv vr wcel w3a cv cle wbr cco1 wa wrex cab cldgis
        cmpt elex cpl1 clidl syl6eqr fveq2d fveq1d breq1d anbi1d rexbidv abbidv
        cdg1 fveq2 mpteq2dv mpteq12dv df-ldgis eqeltri mptex fvmpt syl 3ad2ant1
        fvex syl5eq rexeq nn0ex 3ad2ant2 simp3 wss simpr reximi ss2abi abrexexg
        eqid ssexg sylancr breq2 eqeq2d anbi12d fvmptg syl2anc 3eqtrd ) CIUBZHE
        UBZJQUBZUCZJHDRZRZJHOEPQGUDZARZPUDZUEUFZFUDZXAWSUGRZRZSZUHZGOUDZUIZFUJZ
        ULZULZRZRZJPQXGGHUIZFUJZULZRZWTJUEUFZXCJXDRZSZUHZGHUIZFUJZWMWNWRXNSWOWM
        JWQXMWMHDXLWMDCUKRZXLMWMCTUBYEXLSCIUMUACOUAUDZUNRZUORZPQWSYFVCRZRZXAUEU
        FZXFUHZGXHUIZFUJZULZULXLTUKYFCSZOYHYOEXKYPYHBUORZEYPYGBUOYPYGCUNRBYFCUN
        VDKUPUQLUPYPPQYNXJYPYMXIFYPYLXGGXHYPYKXBXFYPYJWTXAUEYPWSYIAYPYICVCRAYFC
        VCVDNUPURUSUTVAVBVEVFPOFGUAVGOEXKEYQTLBUOVMVHVIVJVKVNURURVLWNWMXNXRSWOW
        NJXMXQOHXKXQEXLXHHSZPQXJXPYRXIXOFXGGXHHVOVBVEXLWDPQXPVPVIVJURVQWPWOYDTU
        BZXRYDSWMWNWOVRWPYDYAGHUIZFUJZVSUUATUBZYSYCYTFYBYAGHXSYAVTWAWBWNWMUUBWO
        GFHXTEWCVQYDUUATWEWFPJXPYDQTXQXAJSZXOYCFUUCXGYBGHUUCXBXSXFYAXAJWTUEWGUU
        CXEXTXCXAJXDVDWHWIVAVBXQWDWJWKWL $.
    $}

    ${
      $d I a b c d e f $.  $d I g $.  $d P b $.  $d R a b c d e f $.  $d R g $.
      $d U a b c d e f $.  $d U g $.  $d X a b c d e f $.  $d X g $.  $d a g $.
      $d b g $.  $d c g $.  $d e g $.  $d f g $.
      hbtlem2.t $e |- T = ( LIdeal ` R ) $.
      $( Leading coefficient ideals are ideals.  (Contributed by Stefan O'Rear,
         1-Apr-2015.) $)
      hbtlem2 $p |- ( ( R e. Ring /\ I e. U /\ X e. NN0 ) ->
          ( ( S ` I ) ` X ) e. T ) $=
        ( vb va wcel cfv cle cco1 wceq wa eqid vc vd ve vf crg cn0 w3a cdg1 wbr
        vg cv wrex cab hbtlem1 cbs wss c0 wne cmulr co cplusg wral wi wf lidlss
        3ad2ant2 sselda syl simpl3 ffvelrnd eleq1a adantld rexlimdva abssdv c0g
        coe1f ply1rng 3ad2ant1 simp2 lidl0cl syl2anc cmnf cxr cr nn0ssre ressxr
        deg1z sstri simp3 sseldi mnfle eqbrtrd csn cxp fveq1d fvconst2 3ad2ant3
        coe1z eqtr2d fveq2 breq1d eqeq2d anbi12d rspcev syl12anc anbi2d rexbidv
        fvex eqeq1 elab sylibr ne0i cascl adantr simpl2 ply1sclf simprl simprll
        wal adantl lidlmcl syl22anc simprrl lidlacl simpl1 sseldd rngcl syl3anc
        deg1xrcl oveq1d imp oveq2 eleq1d syl5ibrcom expimpd alrimiv weq cbvrexv
        syl6bb ralab deg1mul3le simprlr xrletrd simprrr deg1addle2 coe1sclmulfv
        coe1addfv syl31anc syl121anc exp45 exp5c imp41 ralbidv ralrimiva islidl
        ovex syl3anbrc eqeltrd ) BUENZFENZGUFNZUGZGFCOOLUKZBUHOZOZGPUIZMUKZGUVC
        QOZOZRZSZLFULZMUMZDUVDABCEMLFUEGHIJUVDTZUNUVBUVMBUOOZUPUVMUQURZUAUKZUBU
        KZBUSOZUTZUCUKZBVAOZUTZUVMNZUCUVMVBZUBUVMVBZUAUVOVBUVMDNUVBUVLMUVOUVBUV
        KUVGUVONZLFUVBUVCFNZSZUVJUWGUVFUWIUVIUVONUVJUWGVCUWIUFUVOGUVHUWIUVCAUOO
        ZNUFUVOUVHVDUVBFUWJUVCUUTUUSFUWJUPZUVAUWJFEAUWJTZIVEVFZVGUVHUWJABUVCUVO
        UVHTUWLHUVOTZVPVHUUSUUTUVAUWHVIVJUVIUVOUVGVKVHVLVMVNUVBBVOOZUVMNZUVPUVB
        UVFUWOUVIRZSZLFULZUWPUVBAVOOZFNZUWTUVDOZGPUIZUWOGUWTQOZOZRZUWSUVBAUENZU
        UTUXAUUSUUTUXGUVAABHVQVRZUUSUUTUVAVSAEFUWTIUWTTZVTWAUVBUXBWBGPUUSUUTUXB
        WBRUVAUVDABUWTUVNHUXIWGVRUVBGWCNWBGPUIUVBUFWCGUFWDWCWEWFWHZUUSUUTUVAWIW
        JGWKVHWLUVBUXEGUFUWOWMWNZOZUWOUVBGUXDUXKUUSUUTUXDUXKRUVAABUWOUWTHUXIUWO
        TWRVRWOUVAUUSUXLUWORUUTUFUWOGBVOXHZWPWQWSUWRUXCUXFSLUWTFUVCUWTRZUVFUXCU
        WQUXFUXNUVEUXBGPUVCUWTUVDWTXAUXNUVIUXEUWOUXNGUVHUXDUVCUWTQWTWOXBXCXDXEU
        VLUWSMUWOUXMUVGUWORZUVKUWRLFUXOUVJUWQUVFUVGUWOUVIXIXFXGXJXKUVMUWOXLVHUV
        BUWFUAUVOUVBUVQUVONZSZUDUKZUVDOZGPUIZUVRGUXRQOZOZRZSZUDFULZUWEVCZUBXSUW
        FUXQUYFUBUXQUYDUWEUDFUXQUXRFNZSZUXTUYCUWEUYHUXTSZUWEUYCUVQUYBUVSUTZUWAU
        WBUTZUVMNZUCUVMVBZUYIUJUKZUVDOZGPUIZUWAGUYNQOZOZRZSZUJFULZUYLVCZUCXSUYM
        UYIVUBUCUYIUYTUYLUJFUYIUYNFNZSZUYPUYSUYLVUDUYPSUYLUYSUYJUYRUWBUTZUVMNZU
        YHUXTVUCUYPVUFUXQUYGUXTVUCUYPVUFVCVCVCUXQUYGUXTVUCUYPVUFUVBUXPUYGUXTSZV
        UCUYPSZVUFVCVCUVBUXPVUGVUHVUFUVBUXPVUGVUHSZSZSZUVFVUEUVIRZSZLFULZVUFVUK
        UVQAXMOZOZUXRAUSOZUTZUYNAVAOZUTZFNZVUTUVDOZGPUIZVUEGVUTQOZOZRZVUNVUKUXG
        UUTVURFNZVUCVVAUVBUXGVUJUXHXNZUUSUUTUVAVUJXOZVUKUXGUUTVUPUWJNZUYGVVGVVH
        VVIVUKUVOUWJUVQVUOUVBUVOUWJVUOVDZVUJUUSUUTVVKUVAVUOUWJABUVOHVUOTZUWNUWL
        XPVRXNUVBUXPVUIXQZVJZVUJUYGUVBUXPUYGUXTVUHXRXTZUWJAVUQEFVUPUXRIUWLVUQTZ
        YAYBVUJVUCUVBUXPVUGVUCUYPYCXTZVUSAEFVURUYNIVUSTZYDYBVUKUWJUVDVUSBVURUYN
        GAHUVNUUSUUTUVAVUJYEZUWLVVRVUKUXGVVJUXRUWJNZVURUWJNZVVHVVNVUKFUWJUXRUVB
        UWKVUJUWMXNZVVOYFZUWJAVUQVUPUXRUWLVVPYGYHZVUKFUWJUYNVWBVVQYFZVUKUFWCGUX
        JUUSUUTUVAVUJVIZWJZVUKVURUVDOZUXSGVUKVWAVWHWCNVWDUWJUVDABVURUVNHUWLYIVH
        VUKVVTUXSWCNVWCUWJUVDABUXRUVNHUWLYIVHVWGVUKUUSUXPVVTVWHUXSPUIVVSVVMVWCV
        UOUWJUVDABVUQUVQUXRUVOUVNHUWNUWLVVPVVLUUAYHVUJUXTUVBUXPUYGUXTVUHUUBXTUU
        CVUJUYPUVBUXPVUGVUCUYPUUDXTUUEVUKVVEGVURQOOZUYRUWBUTZVUEVUKUUSVWAUYNUWJ
        NUVAVVEVWJRVVSVWDVWEVWFUWJUWBVUSBVURUYNGAHUWLVVRUWBTZUUGUUHVUKVWIUYJUYR
        UWBVUKUUSUXPVVTUVAVWIUYJRVVSVVMVWCVWFVUOUWJABVUQUVSUVOUVQUXRGHUWLUWNVVL
        VVPUVSTZUUFUUIYJWSVUMVVCVVFSLVUTFUVCVUTRZUVFVVCVULVVFVWMUVEVVBGPUVCVUTU
        VDWTXAVWMUVIVVEVUEVWMGUVHVVDUVCVUTQWTWOXBXCXDXEUVLVUNMVUEUYJUYRUWBUUPUV
        GVUERZUVKVUMLFVWNUVJVULUVFUVGVUEUVIXIXFXGXJXKUUJYKUUKYKUULUYSUYKVUEUVMU
        WAUYRUYJUWBYLYMYNYOVMYPUVLVUAUYLUCMMUCYQZUVLUVFUWAUVIRZSZLFULVUAVWOUVKV
        WQLFVWOUVJVWPUVFUVGUWAUVIXIXFXGVWQUYTLUJFLUJYQZUVFUYPVWPUYSVWRUVEUYOGPU
        VCUYNUVDWTXAVWRUVIUYRUWAVWRGUVHUYQUVCUYNQWTWOXBXCYRYSYTXKUYCUWDUYLUCUVM
        UYCUWCUYKUVMUYCUVTUYJUWAUWBUVRUYBUVQUVSYLYJYMUUMYNYOVMYPUVLUYEUWEUBMMUB
        YQZUVLUVFUVRUVIRZSZLFULUYEVWSUVKVXALFVWSUVJVWTUVFUVGUVRUVIXIXFXGVXAUYDL
        UDFLUDYQZUVFUXTVWTUYCVXBUVEUXSGPUVCUXRUVDWTXAVXBUVIUYBUVRVXBGUVHUYAUVCU
        XRQWTWOXBXCYRYSYTXKUUNUAUVOUWBBUVSDUVMUBUCKUWNVWKVWLUUOUUQUUR $.
    $}

    ${
      $d I i j x y $.  $d R i j r x y $.  $d S x $.  $d T x $.  $d U i r x $.
      hbtlem7.t $e |- T = ( LIdeal ` R ) $.
      $( Functionality of leading coefficient ideal sequence.  (Contributed by
         Stefan O'Rear, 4-Apr-2015.) $)
      hbtlem7 $p |- ( ( R e. Ring /\ I e. U ) -> ( S ` I ) : NN0 --> T ) $=
        ( vx vj vy vi wcel cfv cn0 cv cmpt cvv vr crg wa wfn wral cdg1 cle cco1
        wf wbr wceq wrex cab wss simpr reximi ss2abi abrexexg sylancr ralrimivw
        ssexg adantl eqid fnmpt syl cldgis elex cpl1 clidl fveq2 syl6eqr fveq2d
        fveq1d breq1d anbi1d rexbidv abbidv mpteq2dv mpteq12dv df-ldgis eqeltri
        mptex fvmpt syl5eq rexeq nn0ex sylan9eq fneq1d mpbird hbtlem2 ralrimiva
        fvex 3expa ffnfv sylanbrc ) BUBOZFEOZUCZFCPZQUDZKRZWSPDOZKQUEQDWSUIWRWT
        KQLRZBUFPZPZXAUGUJZMRXAXCUHPPZUKZUCZLFULZMUMZSZQUDZWRXKTOZKQUEZXMWQXOWP
        WQXNKQWQXKXHLFULZMUMZUNXQTOXNXJXPMXIXHLFXFXHUOUPUQLMFXGEURXKXQTVAUSUTVB
        KQXKXLTXLVCVDVEWRQWSXLWPWQWSFNEKQXILNRZULZMUMZSZSZPXLWPFCYBWPCBVFPZYBIW
        PBTOYCYBUKBUBVGUABNUARZVHPZVIPZKQXCYDUFPZPZXAUGUJZXHUCZLXRULZMUMZSZSYBT
        VFYDBUKZNYFYMEYAYNYFAVIPZEYNYEAVIYNYEBVHPAYDBVHVJGVKVLHVKYNKQYLXTYNYKXS
        MYNYJXILXRYNYIXFXHYNYHXEXAUGYNXCYGXDYDBUFVJVMVNVOVPVQVRVSKNMLUAVTNEYAEY
        OTHAVIWLWAWBWCVEWDVMNFYAXLEYBXRFUKZKQXTXKYPXSXJMXILXRFWEVQVRYBVCKQXKWFW
        BWCWGWHWIWRXBKQWPWQXAQOXBABCDEFXAGHIJWJWMWKKQDWSWNWO $.
    $}

    ${
      $d ph a c $.  $d I a b c $.  $d P b $.  $d R a b c $.  $d X a b c $.
      $d Y a b c $.
      hbtlem4.r $e |- ( ph -> R e. Ring ) $.
      hbtlem4.i $e |- ( ph -> I e. U ) $.
      hbtlem4.x $e |- ( ph -> X e. NN0 ) $.
      hbtlem4.y $e |- ( ph -> Y e. NN0 ) $.
      hbtlem4.xy $e |- ( ph -> X <_ Y ) $.
      $( The leading ideal function goes to increasing sequences.  (Contributed
         by Stefan O'Rear, 1-Apr-2015.) $)
      hbtlem4 $p |- ( ph -> ( ( S ` I ) ` X ) C_ ( ( S ` I ) ` Y ) ) $=
        ( cfv cle wceq wcel vc va vb cv cdg1 wbr cco1 wa wrex cab cmin cv1 cmgp
        co cmg cmulr crg cbs ad2antrr ply1rng syl cmnd cn0 eqid nn0sub2 syl3anc
        rngmgp vr1cl mgpbas mulgnn0cl simplr lidlmcl syl22anc wss lidlss sseldd
        caddc deg1pwle syl2anc deg1mulle2 nn0cnd npcand breqtrd c0g coe1pwmulfv
        simpr fveq2d eqtr3d breq1d fveq1d eqeq2d anbi12d rspcev syl12anc anbi2d
        fveq2 rexbidv syl5ibrcom expimpd rexlimdva ss2abdv hbtlem1 3sstr4d
        eqeq1 ) AUAUDZCUEQZQGRUFZUBUDZGXEUGQQZSZUHZUAFUIZUBUJZUCUDZXFQZHRUFZXHH
        XNUGQZQZSZUHZUCFUIZUBUJZGFDQZQZHYCQZAXLYAUBAXKYAUAFAXEFTZUHZXGXJYAYGXGU
        HZYAXJXPXIXRSZUHZUCFUIZYHHGUKUNZCULQZBUMQZUOQZUNZXEBUPQZUNZFTZYRXFQZHRU
        FZXIHYRUGQZQZSZYKYHBUQTZFETZYPBURQZTZYFYSYHCUQTZUUEAUUIYFXGLUSZBCIUTVAZ
        AUUFYFXGMUSZYHYNVBTZYLVCTZYMUUGTZUUHYHUUEUUMUUKBYNYNVDZVGVAYHGVCTZHVCTZ
        GHRUFZUUNAUUQYFXGNUSZAUURYFXGOUSZAUUSYFXGPUSGHVEVFZYHUUIUUOUUJUUGBCYMYM
        VDZIUUGVDZVHVAUUGYOYNYLYMUUGBYNUUPUVDVIYOVDZVJVFZAYFXGVKZUUGBYQEFYPXEJU
        VDYQVDZVLVMYHYTYLGVQUNZHRYHUUGXFCYQYPXEYLGBIXFVDZUUJUVDUVHUVFYHFUUGXEYH
        UUFFUUGVNUULUUGFEBUVDJVOVAUVGVPZUVBUUTYHUUIUUNYPXFQYLRUFUUJUVBXFBCYOYLY
        NYMUVJIUVCUUPUVEVRVSYGXGWFVTYHHGYHHUVAWAYHGUUTWAWBZWCYHUVIUUBQXIUUCYHXE
        UUGYLBCYQYOYNYMGCWDQZUVMVDIUVCUUPUVEUVDUVHUUJUVKUVBUUTWEYHUVIHUUBUVLWGW
        HYJUUAUUDUHUCYRFXNYRSZXPUUAYIUUDUVNXOYTHRXNYRXFWPWIUVNXRUUCXIUVNHXQUUBX
        NYRUGWPWJWKWLWMWNXJXTYJUCFXJXSYIXPXHXIXRXDWOWQWRWSWTXAAUUIUUFUUQYDXMSLM
        NXFBCDEUBUAFUQGIJKUVJXBVFAUUIUUFUURYEYBSLMOXFBCDEUBUCFUQHIJKUVJXBVFXC
        $.
    $}

    ${
      hbtlem3.r $e |- ( ph -> R e. Ring ) $.
      hbtlem3.i $e |- ( ph -> I e. U ) $.
      hbtlem3.j $e |- ( ph -> J e. U ) $.
      hbtlem3.ij $e |- ( ph -> I C_ J ) $.
      ${
        $d ph a $.  $d I a b $.  $d J a b $.  $d R a b $.  $d X a b $.
        hbtlem3.x $e |- ( ph -> X e. NN0 ) $.
        $( The leading ideal function is monotone.  (Contributed by Stefan
           O'Rear, 31-Mar-2015.) $)
        hbtlem3 $p |- ( ph -> ( ( S ` I ) ` X ) C_ ( ( S ` J ) ` X ) ) $=
          ( vb va cfv wcel cv cdg1 cle wbr cco1 wceq wa wrex cab wss ssrexv syl
          wi ss2abdv crg cn0 eqid hbtlem1 syl3anc 3sstr4d ) AQUAZCUBSZSHUCUDRUA
          HVAUESSUFUGZQFUHZRUIZVCQGUHZRUIZHFDSSZHGDSSZAVDVFRAFGUJVDVFUMOVCQFGUK
          ULUNACUOTZFETHUPTZVHVEUFLMPVBBCDERQFUOHIJKVBUQZURUSAVJGETVKVIVGUFLNPV
          BBCDERQGUOHIJKVLURUSUT $.
      $}
      $d ph a b c d e $.  $d I a b c d e $.  $d I x $.  $d J a b c d e $.
      $d J x $.  $d P a $.  $d R a b c d e $.  $d S x $.  $d b x $.
      hbtlem5.e $e |- ( ph ->
          A. x e. NN0 ( ( S ` J ) ` x ) C_ ( ( S ` I ) ` x ) ) $.
      $( The leading ideal function is strictly monotone.  (Contributed by
         Stefan O'Rear, 1-Apr-2015.) $)
      hbtlem5 $p |- ( ph -> I = J ) $=
        ( wcel cfv clt syl va vb vc vd ve cv cdg1 wbr cn0 wrex cmnf csn cun cbs
        wa wss eqid lidlss sselda deg1cl wo elun cn nnssnn0 cr nn0re arch mpsyl
        ssrexv wceq elsni cc0 0nn0 mnflt ax-mp breq2 rspcev mp2an breq1 rexbidv
        0re mpbiri jaoi sylbi wi wral c1 caddc imbi1d ralbidv imbi2d weq breq1d
        co fveq2 eleq1 imbi12d cbvralv syl6bb c0g crg wb adantr deg1lt0 syl2anc
        ply1rng lidl0cl eleq1a sylbid ralrimiva w3a cz 3ad2ant2 nn0zd degltp1le
        cle simpl1 cco1 cab sseq12d rspcva sylan2 simpl hbtlem1 syl3anc 3sstr3d
        adantl 3adant3 simpr eqidd fveq1d eqeq2d anbi12d syl12anc fvex ad2antrr
        elab sseldd syl22anc mpd eqeq1 anbi2d sylibr cplusg cgrp simpll2 rnggrp
        csg simplrl simprl grpnpcan simpll1 simplrr simprrl deg1sublt lidlsubcl
        simprrr simpll3 lidlacl eqeltrrd rexlimdvaa syl5bi expr 3exp a2d nn0ind
        rsp syl6com com23 imp rexlimdv ex ssrdv eqssd ) AGHOAUAHGAUAUFZHQZUVOGQ
        ZAUVPUOZUVODUGRZRZUBUFZSUHZUBUIUJZUVQUVRUVTUIUKULZUMZQZUWCUVRUVOCUNRZQZ
        UWFAHUWGUVOAHFQZHUWGUPZNUWGHFCUWGUQZJURTZUSZUWGUVSCDUVOUVSUQZIUWKUTTUWF
        UVTUIQZUVTUWDQZVAUWCUVTUIUWDVBUWOUWCUWPVCUIUPUWOUWBUBVCUJZUWCVDUWOUVTVE
        QUWQUVTVFUVTUBVGTUWBUBVCUIVIVHUWPUVTUKVJZUWCUVTUKVKUWRUWCUKUWASUHZUBUIU
        JZVLUIQUKVLSUHZUWTVMVLVEQUXAWAVLVNVOUWSUXAUBVLUIUWAVLUKSVPVQVRUWRUWBUWS
        UBUIUVTUKUWASVSVTWBTWCWDTUVRUWBUVQUBUIAUVPUWAUIQZUWBUVQWEZWEAUXBUVPUXCU
        XBAUXCUAHWFZUVPUXCWEAUVTUCUFZSUHZUVQWEZUAHWFZWEAUVTVLSUHZUVQWEZUAHWFZWE
        AUXDWEZAUDUFZUVSRZUWAWGWHWNZSUHZUXMGQZWEZUDHWFZWEUXLUCUBUWAUXEVLVJZUXHU
        XKAUXTUXGUXJUAHUXTUXFUXIUVQUXEVLUVTSVPWIWJWKUCUBWLZUXHUXDAUYAUXGUXCUAHU
        YAUXFUWBUVQUXEUWAUVTSVPWIWJWKZUXEUXOVJZUXHUXSAUYCUXHUVTUXOSUHZUVQWEZUAH
        WFUXSUYCUXGUYEUAHUYCUXFUYDUVQUXEUXOUVTSVPWIWJUYEUXRUAUDHUAUDWLZUYDUXPUV
        QUXQUYFUVTUXNUXOSUVOUXMUVSWOWMUVOUXMGWPWQWRWSWKUYBAUXJUAHUVRUXIUVOCWTRZ
        VJZUVQUVRDXAQZUWHUXIUYHXBAUYIUVPLXCUWMUWGUVSCDUVOUYGUWNIUYGUQZUWKXDXEAU
        YHUVQWEZUVPAUYGGQZUYKACXAQZGFQZUYLAUYIUYMLCDIXFTZMCFGUYGJUYJXGXEUYGGUVO
        XHTXCXIXJUXBAUXDUXSUXBAUXDUXSUXBAUXDXKZUXRUDHUYPUXMHQZUOZUXPUXNUWAXPUHZ
        UXQUYRUXNUWEQZUWAXLQUXPUYSXBUYRUXMUWGQZUYTUYPHUWGUXMAUXBUWJUXDUWLXMUSUW
        GUVSCDUXMUWNIUWKUTTUYRUWAUXBAUXDUYQXQXNUXNUWAXOXEUYPUYQUYSUXQUYPUYQUYSU
        OZUOZUWAUXMXRRZRZUEUFZUVSRZUWAXPUHZUXEUWAVUFXRRZRZVJZUOZUEGUJZUCXSZQZUX
        QVUCVULUEHUJZUCXSZVUNVUEUYPVUQVUNUPZVUBUXBAVURUXDUXBAUOZUWAHERZRZUWAGER
        ZRZVUQVUNAUXBBUFZVUTRZVVDVVBRZUPZBUIWFVVAVVCUPZPVVGVVHBUWAUIBUBWLVVEVVA
        VVFVVCVVDUWAVUTWOVVDUWAVVBWOXTYAYBVUSUYIUWIUXBVVAVUQVJAUYIUXBLYGZAUWIUX
        BNYGUXBAYCZUVSCDEFUCUEHXAUWAIJKUWNYDYEVUSUYIUYNUXBVVCVUNVJVVIAUYNUXBMYG
        VVJUVSCDEFUCUEGXAUWAIJKUWNYDYEYFYHXCVUBVUEVUQQZUYPVUBVUHVUEVUJVJZUOZUEH
        UJZVVKVUBUYQUYSVUEVUEVJZVVNUYQUYSYCUYQUYSYIVUBVUEYJVVMUYSVVOUOUEUXMHUEU
        DWLZVUHUYSVVLVVOVVPVUGUXNUWAXPVUFUXMUVSWOWMVVPVUJVUEVUEVVPUWAVUIVUDVUFU
        XMXRWOYKYLYMVQYNVUPVVNUCVUEUWAVUDYOZUXEVUEVJZVULVVMUEHVVRVUKVVLVUHUXEVU
        EVUJUUAUUBZVTYQUUCYGYRVUOVVMUEGUJZVUCUXQVUMVVTUCVUEVVQVVRVULVVMUEGVVSVT
        YQVUCVVMUXQUEGVUCVUFGQZVVMUOZUOZUXMVUFCUUHRZWNZVUFCUUDRZWNZUXMGVWCCUUEQ
        ZVUAVUFUWGQVWGUXMVJVWCUYMVWHVWCAUYMUXBAUXDVUBVWBUUFZUYOTZCUUGTVWCHUWGUX
        MVWCAUWJVWIUWLTUYPUYQUYSVWBUUIZYRZVWCGUWGVUFVWCAGUWGUPZVWIAUYNVWMMUWGGF
        CUWKJURTTVUCVWAVVMUUJZYRZUWGVWFCVWDUXMVUFUWKVWFUQZVWDUQZUUKYEVWCUYMUYNV
        WEGQZVWAVWGGQVWJUYPUYNVUBVWBAUXBUYNUXDMXMYPVWCVWEUVSRZUWASUHZVWRVWCVUDU
        WGVUIUVSCDUXMVUFUWAVWDUWNIUWKVWQUXBAUXDVUBVWBUULVWCAUYIVWILTVWLUYPUYQUY
        SVWBUUMVWOVUCVWAVUHVVLUUNVUDUQVUIUQVUCVWAVUHVVLUUQUUOVWCVWEHQZUXDVWTVWR
        WEZVWCUYMUWIUYQVUFHQVXAVWJVWCAUWIVWINTVWKVWCGHVUFUYPGHUPZVUBVWBAUXBVXCU
        XDOXMYPVWNYRCFHVWDUXMVUFJVWQUUPYSUXBAUXDVUBVWBUURUXCVXBUAVWEHUVOVWEVJZU
        WBVWTUVQVWRVXDUVTVWSUWASUVOVWEUVSWOWMUVOVWEGWPWQYAXEYTVWNVWFCFGVWEVUFJV
        WPUUSYSUUTUVAUVBYTUVCXIXJUVDUVEUVFUXCUAHUVGUVHUVIUVJUVKYTUVLUVMUVN $.
    $}

    ${
      $d ph a k $.  $d I a k $.  $d I b c d $.  $d N a $.  $d N b c e $.
      $d R a k $.  $d R b c d $.  $d R e $.  $d S a k $.  $d X a k $.
      $d X b c d $.  $d X e $.  $d b k $.  $d c k $.  $d e k $.
      hbtlem6.n $e |- N = ( RSpan ` P ) $.
      hbtlem6.r $e |- ( ph -> R e. LNoeR ) $.
      hbtlem6.i $e |- ( ph -> I e. U ) $.
      hbtlem6.x $e |- ( ph -> X e. NN0 ) $.
      $( There is a finite set of polynomials matching any single stage of the
         image.  (Contributed by Stefan O'Rear, 1-Apr-2015.) $)
      hbtlem6 $p |- ( ph -> E. k e. ( ~P I i^i Fin )
            ( ( S ` I ) ` X ) C_ ( ( S ` ( N ` k ) ) ` X ) ) $=
        ( vb cfv wss wcel va vc vd ve crsp wceq cpw cfn cin wrex clnr clidl crg
        cv cn0 lnrrng syl eqid hbtlem2 syl3anc lnr2i syl2anc elfpw cdg1 cle wbr
        wa crab cco1 cmpt cima wfn crn fvex fnmpti a1i simprl cab hbtlem1 rnmpt
        fveq2 breq1d rexrab abbii syl6eqr adantr sseqtrd simprr fipreima ssrab2
        eqtri wi sstr2 mpi adantl vex elpw sylibr adantrr elin sylanbrc ply1rng
        cbs syl6ss lidlss sstrd rspcl cres df-ima wral rspssid simprbi ad2antrl
        ssrab resmpt eqtr4d resss syl6eqssr syl5eqss sseqtr4d rspssp jca sseq1d
        rnss anbi2d syl5ibcom sylan2b expimpd reximdv2 sseq1 rexbidv syl5ibrcom
        mpd rexlimdva ) AIGDRRZUAUNZCUERZRZUFZUAYOUGUHUIZUJZYOIFUNZHRZDRRZSZFGU
        GZUHUIZUJZACUKTZYOCULRZTZUUANACUMTZGETZIUOTZUUKAUUIUULNCUPUQZOPBCDUUJEG
        IJKLUUJURZUSUTCUUJUAYOYQUUPYQURZVAVBAYSUUHUAYTAYPYTTZVGUUHYSYRUUDSZFUUG
        UJZUURAYPYOSZYPUHTZVGZUUTYPYOVCAUVCVGZQUBUNZCVDRZRZIVEVFZUBGVHZIQUNZVIR
        ZRZVJZUUBVKZYPUFZFUVIUGUHUIZUJZUUTUVDUVMUVIVLZYPUVMVMZSUVBUVQUVRUVDQUVI
        UVLUVMIUVKVNUVMURZVOVPUVDYPYOUVSAUVAUVBVQAYOUVSUFUVCAYOUVJUVFRZIVEVFZUC
        UNUVLUFZVGQGUJZUCVRZUVSAUUIUUMUUNYOUWEUFNOPUVFBCDEUCQGUKIJKLUVFURZVSUTU
        VSUWCQUVIUJZUCVRUWEQUCUVIUVLUVMUVTVTUWGUWDUCUVHUWBUWCQUBGUVEUVJUFUVGUWA
        IVEUVEUVJUVFWAWBZWCWDWKWEWFWGAUVAUVBWHYPUVIUVMFWIUTUVDUVOUUSFUVPUUGAUUB
        UVPTZUVOVGUUBUUGTZUUSVGZWLUVCAUWIUVOUWKUWIAUUBUVISZUUBUHTZVGZUVOUWKWLUU
        BUVIVCAUWNVGZUWJUVNYQRZUUDSZVGUVOUWKUWOUWJUWQUWOUUBUUFTZUWMUWJAUWLUWRUW
        MAUWLVGUUBGSZUWRUWLUWSAUWLUVIGSUWSUVHUBGWJZUUBUVIGWMWNWOUUBGFWPWQWRWSAU
        WLUWMWHUUBUUFUHWTXAUWOUULUUDUUJTZUVNUUDSUWQAUULUWNUUOWFZUWOUULUUCETZUUN
        UXAUXBUWOBUMTZUUBBXCRZSZUXCAUXDUWNAUULUXDUUOBCJXBUQWFZUWOUUBGUXEUWOUUBU
        VIGAUWLUWMVQUWTXDAGUXESZUWNAUUMUXHOUXEGEBUXEURZKXEUQWFXFZUXEBEUUBHMUXIK
        XGVBZAUUNUWNPWFZBCDUUJEUUCIJKLUUPUSUTUWOUVNQUVHUBUUCVHZUVLVJZVMZUUDUWOU
        VNUVMUUBXHZVMZUXOUVMUUBXIUWOUXPUXNSUXQUXOSUWOUXPUXNUUBXHZUXNUWOUXRQUUBU
        VLVJZUXPUWOUUBUXMSZUXRUXSUFUWOUUBUUCSZUVHUBUUBXJZUXTUWOUXDUXFUYAUXGUXJU
        XEBUUBHMUXIXKVBUWLUYBAUWMUWLUWSUYBUVHUBGUUBXNXLXMUVHUBUUCUUBXNXAQUXMUUB
        UVLXOUQUWLUXPUXSUFAUWMQUVIUUBUVLXOXMXPUXNUUBXQXRUXPUXNYDUQXSUWOUUDUWBUD
        UNUVLUFZVGQUUCUJZUDVRZUXOUWOUULUXCUUNUUDUYEUFUXBUXKUXLUVFBCDEUDQUUCUMIJ
        KLUWFVSUTUXOUYCQUXMUJZUDVRUYEQUDUXMUVLUXNUXNURVTUYFUYDUDUVHUWBUYCQUBUUC
        UWHWCWDWKWEXTCUUJUVNUUDYQUUQUUPYAUTYBUVOUWQUUSUWJUVOUWPYRUUDUVNYPYQWAYC
        YEYFYGYHWFYIYMYGYSUUEUUSFUUGYOYRUUDYJYKYLYNYM $.
    $}
  $}

  ${
    $d P a b c e f $.  $d P g $.  $d R a b c d f $.  $d R e g $.  $d a g $.
    $d c g $.  $d d g $.  $d f g $.
    hbt.p $e |- P = ( Poly1 ` R ) $.
    $( The Hilbert Basis Theorem - the ring of univariate polynomials over a
       Noetherian ring is a Noetherian ring.  (Contributed by Stefan O'Rear,
       4-Apr-2015.) $)
    hbt $p |- ( R e. LNoeR -> P e. LNoeR ) $=
      ( vb ve vg wcel cv cfv wceq cfn wral wa cn0 eqid adantr ralrimiva syl2anc
      wss fveq2 va vd vc vf clnr crg crsp cbs cpw cin wrex clidl lnrrng ply1rng
      syl cldgis cuz cnacs wf c1 caddc co islnr3 simprbi hbtlem7 sylan ad2antrr
      simplr simpr peano2nn0 adantl cle wbr nn0re lep1d hbtlem4 nacsfix syl3anc
      cc0 cfz wex fzfi simpll elfznn0 hbtlem6 fveq2d fveq1d sseq2d sylancr cuni
      ac6sfi crn frn ad2antrl inss1 syl6ss unissd unipw syl6sseq simpllr lidlss
      sstrd fvex elpw2 sylibr ciun wfn simprl ffn fniunfv 3syl ffvelrnda sseldi
      inss2 iunfi eqeltrrd elin sylanbrc ad3antrrr rspssp simplrl nn0red simprr
      rspcl cr wb mpbir2and simplrr weq fveq12d sseq12d rspcva fvssunirn syl5ss
      fznn0 id anassrs cz nn0z wi rspssid hbtlem3 eluz2 eqeq1d leidd expr breq1
      syl3anbrc imbi12d eqsstrd lecasei eqcomd eqeq2d rspcev exlimddv rexlimddv
      mpd hbtlem5 islnr2 ) BUEGZAUFGZUAHZDHZAUGIZIZJZDAUHIZUIZKUJZUKZUAAULIZLAU
      EGUUTBUFGZUVABUMZABCUNZUOZUUTUVJUAUVKUUTUVBUVKGZMZUBHZUVBBUPIZIZIZUCHZUVT
      IZJZUBUWBUQIZLZUVJUCNUVQBULIZBUHIZURIGZNUWGUVTUSZUVCUVTIUVCUTVAVBZUVTISZD
      NLUWFUCNUKUUTUWIUVPUUTUVLUWIUWHBUWGUWHOUWGOZVCVDPUUTUVLUVPUWJUVMABUVSUWGU
      VKUVBCUVKOZUVSOZUWMVEVFUVQUWLDNUVQUVCNGZMABUVSUVKUVBUVCUWKCUWNUWOUUTUVLUV
      PUWPUVMVGUUTUVPUWPVHUVQUWPVIUWPUWKNGUVQUVCVJVKUWPUVCUWKVLVMUVQUWPUVCUVCVN
      VOVKVPQDUCUBUWGUVTUWHVQVRUVQUWBNGZUWFMZMZVSUWBVTVBZUVBUIZKUJZUDHZUSZEHZUV
      TIZUXEUXEUXCIZUVDIZUVSIZIZSZEUWTLZMZUVJUDUVQUXMUDWAZUWRUVQUWTKGZUXFUXEUVE
      UVSIZIZSZDUXBUKZEUWTLUXNVSUWBWBZUVQUXSEUWTUVQUXEUWTGZMABUVSUVKDUVBUVDUXEC
      UWNUWOUVDOZUUTUVPUYAWCUUTUVPUYAVHUYAUXENGUVQUXEUWBWDVKWEQUXRUXKEDUWTUXBUD
      UVCUXGJZUXQUXJUXFUYCUXEUXPUXIUYCUVEUXHUVSUVCUXGUVDTWFWGWHWKWIPUWSUXMMZUXC
      WLZWJZUVIGZUVBUYFUVDIZJZUVJUYDUYFUVHGZUYFKGUYGUYDUYFUVGSZUYJUYDUYFUVBUVGU
      YDUYFUXAWJUVBUYDUYEUXAUYDUYEUXBUXAUXDUYEUXBSUWSUXLUWTUXBUXCWMWNUXAKWOWPWQ
      UVBWRWSZUYDUVPUVBUVGSUUTUVPUWRUXMWTZUVGUVBUVKAUVGOZUWNXAUOXBZUYFUVGAUHXCX
      DXEUYDFUWTFHZUXCIZXFZUYFKUYDUXDUXCUWTXGUYRUYFJUWSUXDUXLXHZUWTUXBUXCXIFUWT
      UXCXJXKUYDUXOUYQKGZFUWTLUYRKGUXTUYDUYTFUWTUYDUYPUWTGZMUXBKUYQUXAKXNUYDUWT
      UXBUYPUXCUYSXLXMQFUWTUYQXOWIXPUYFUVHKXQXRUYDUYHUVBUYDFABUVSUVKUYHUVBCUWNU
      WOUUTUVLUVPUWRUXMUVMXSZUYDUVAUYKUYHUVKGZUUTUVAUVPUWRUXMUVOXSZUYOUVGAUVKUY
      FUVDUYBUYNUWNYDRZUYMUYDUVAUVPUYFUVBSUYHUVBSVUDUYMUYLAUVKUYFUVBUVDUYBUWNXT
      VRUYDUYPUVTIZUYPUYHUVSIZIZSZFNUYDUYPNGZMZVUIUYPUWBVUJUYPYEGUYDUYPVNVKVUKU
      WBUYDUWQVUJUVQUWQUWFUXMYAZPYBUYDVUJUYPUWBVLVMZVUIUYDVUJVUMMZMZVUFUYPUYQUV
      DIZUVSIZIZVUHVUOVUAUXLVUFVURSZVUOVUAVUJVUMUYDVUJVUMXHZUYDVUJVUMYCVUOUWQVU
      AVUNYFUYDUWQVUNVULPUYPUWBYOUOYGUWSUXDUXLVUNYHUXKVUSEUYPUWTEFYIZUXFVUFUXJV
      URUXEUYPUVTTVVAUXEUYPUXIVUQVVAUXHVUPUVSVVAUXGUYQUVDUXEUYPUXCTWFWFVVAYPYJY
      KYLRVUOABUVSUVKVUPUYHUYPCUWNUWOUYDUVLVUNVUBPUYDVUPUVKGZVUNUYDUVAUYQUVGSVV
      BVUDUYDUYQUYFUVGUXCUYPYMZUYOYNUVGAUVKUYQUVDUYBUYNUWNYDRPUYDVUCVUNVUEPZVUO
      UVAVUCUYQUYHSVUPUYHSUYDUVAVUNUYDUVLUVAVUBUVNUOPVVDVUOUYQUYFUYHVVCUYDUYFUY
      HSZVUNUYDUVAUYKVVEVUDUYOUVGAUYFUVDUYBUYNUUARPYNAUVKUYQUYHUVDUYBUWNXTVRVUT
      UUBXBZYQUYDVUJUWBUYPVLVMZVUIUYDVUJVVGMZMZVUFUWCVUHVVIUYPUWEGZUWFVUFUWCJZU
      YDUWQVVHVVJVULUWQVVHMUWBYRGZUYPYRGZVVGVVJUWQVVLVVHUWBYSPVUJVVMUWQVVGUYPYS
      WNUWQVUJVVGYCUWBUYPUUCUUHVFUWSUWFUXMVVHUVQUWQUWFYCVGUWDVVKUBUYPUWEUBFYIUW
      AVUFUWCUVRUYPUVTTUUDYLRVVIUWCUWBVUGIZVUHUYDUWCVVNSZVVHUYDUWBUWBVLVMZVVOUY
      DUWBUYDUWBVULYBUUEUYDUWQVUMVUIYTZFNLVVPVVOYTZVULUYDVVQFNUYDVUJVUMVUIVVFUU
      FQVVQVVRFUWBNFUCYIZVUMVVPVUIVVOUYPUWBUWBVLUUGVVSVUFUWCVUHVVNUYPUWBUVTTUYP
      UWBVUGTYKUUIYLRUUQPVVIABUVSUVKUYHUWBUYPCUWNUWOUYDUVLVVHVUBPUYDVUCVVHVUEPU
      YDUWQVVHVULPUYDVUJVVGXHUYDVUJVVGYCVPXBUUJYQUUKQUURUULUVFUYIDUYFUVIUVCUYFJ
      UVEUYHUVBUVCUYFUVDTUUMUUNRUUOUUPQUVGAUVKDUAUVDUYNUWNUYBUUSXR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Additional material on polynomials [DEPRECATED]
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c Monic Poly< $.

  $( Extend class notation with the class of monic polynomials. $)
  cmnc $a class Monic $.

  $( Extend class notatin with the class of limited-degree polynomials. $)
  cplylt $a class Poly< $.

  ${
    $d s p x $.

    $( Define the class of monic polynomials.  (Contributed by Stefan O'Rear,
       5-Dec-2014.) $)
    df-mnc $a |- Monic = ( s e. ~P CC |-> { p e. ( Poly ` s ) |
        ( ( coeff ` p ) ` ( deg ` p ) ) = 1 } ) $.

    $( Define the class of limited-degree polynomials.  (Contributed by Stefan
       O'Rear, 8-Dec-2014.) $)
    df-plylt $a |- Poly< = ( s e. ~P CC , x e. NN0 |-> { p e. ( Poly ` s ) |
        ( p = 0p \/ ( deg ` p ) < x ) } ) $.
  $}

  ${
    dgrsub2.a $e |- N = ( deg ` F ) $.
    $( Subtracting two polynomials with the same degree and top coefficient
       gives a polynomial of strictly lower degree.  (Contributed by Stefan
       O'Rear, 25-Nov-2014.) $)
    dgrsub2 $p |- ( ( ( F e. ( Poly ` S ) /\ G e. ( Poly ` T ) ) /\
          ( ( deg ` G ) = N /\ N e. NN /\
            ( ( coeff ` F ) ` N ) = ( ( coeff ` G ) ` N ) ) ) ->
        ( deg ` ( F oF - G ) ) < N ) $=
      ( cply cfv wcel wa cdgr wceq ccoe cmin clt wbr cle cc eqid cn0 cn w3a cof
      co c0p wi simpr2 cc0 nngt0 syl5eqbr fveq2 breq1d syl5ibrcom syl wo plyssc
      dgr0 cif sseli dgrsub syl2an adantr simpr1 eqcomi a1i ifeq12d ifid syl6eq
      breqtrd coesub fveq1d nnnn0d cvv wf wfn coef3 ad2antrr ffn ad2antlr nn0ex
      inidm simplr3 eqidd ofval mpdan ffvelrnd subidd wb plysubcl dgrlt syl2anc
      3eqtrd mpbir2and ord pm2.61d ) CAGHZIZDBGHZIZJZDKHZELZEUAIZECMHZHEDMHZHZL
      ZUBZJZCDNUCZUDZUELZXKKHZEOPZXIXCXLXNUFWTXBXCXGUGZXCXNXLUEKHZEOPXCXPUHEOUQ
      EUIUJXLXMXPEOXKUEKUKULUMUNXIXLXNXIXLXNUOZXMEQPZEXKMHZHZUHLZXIXMCKHZXAQPZX
      AYBURZEQWTXMYDQPZXHWQCRGHZIZDYFIZYEWSWPYFCAUPUSZWRYFDBUPUSZRCDYBXAYBSXASU
      TVAVBXIYDYCEEUREXIYCXAEYBEWTXBXCXGVCYBELXIEYBFVDVEVFYCEVGVHVIXIXTEXDXEXJU
      DZHZXFXFNUDZUHXIEXSYKWTXSYKLZXHWQYGYHYNWSYIYJXDXERCDXDSZXESZVJVAVBVKXIETI
      ZYLYMLXIEXOVLZXITTXFXFNTXDXEVMVMEXITRXDVNZXDTVOWQYSWSXHXDACYOVPVQTRXDVRUN
      XITRXEVNZXETVOWSYTWQXHXEBDYPVPVSZTRXEVRUNTVMIXIVTVEZUUBTWAXBXCXGWTYQWBXIY
      QJXFWCWDWEXIXFXITREXEUUAYRWFWGWLXIXKYFIZYQXQXRYAJWHWTUUCXHWQYGYHUUCWSYIYJ
      RCDWIVAVBYRXSRXKEXMXMSXSSWJWKWMWNWO $.
  $}

  ${
    $( A nonzero polynomial with a root has positive degree.  TODO: use in
       ~ aaliou2 .  (Contributed by Stefan O'Rear, 25-Nov-2014.) $)
    dgrnznn $p |- ( ( ( P e. ( Poly ` S ) /\ P =/= 0p ) /\
        ( A e. CC /\ ( P ` A ) = 0 ) ) -> ( deg ` P ) e. NN ) $=
      ( cply cfv wcel c0p wne wa cc cc0 wceq cdgr wn cn csn cxp simpr ad2antrr
      wo fveq1d simplr fvex fvconst2 3eqtr3rd sneqd xpeq2d eqtrd df-0p necon3ad
      syl6eqr ex impcom adantll 0dgrb mtbird cn0 dgrcl elnn0 sylib orel2 sylc
      wb ) BCDEFZBGHZIAJFZABEZKLZIZIZBMEZKLZNVKOFZVLTZVMVJVLBJKBEZPZQZLZVEVIVRN
      ZVDVIVEVSVIVRBGVIVRBGLVIVRIZBJKPZQZGVTBVQWBVIVRRZVTVPWAJVTVOKVTVGAVQEZKVO
      VTABVQWCUAVFVHVRUBVFWDVOLVHVRJVOAKBUCUDSUEUFUGUHUIUKULUJUMUNVDVLVRVCVEVIC
      BUOSUPVJVKUQFZVNVDWEVEVICBURSVKUSUTVLVMVAVB $.
  $}

  ${
    $d S s p $.  $d P s p $.

    $( Property of a monic polynomial.  (Contributed by Stefan O'Rear,
       5-Dec-2014.) $)
    elmnc $p |- ( P e. ( Monic ` S ) <-> ( P e. ( Poly ` S ) /\
          ( ( coeff ` P ) ` ( deg ` P ) ) = 1 ) ) $=
      ( vs vp cmnc cfv wcel cc wss cply cdgr ccoe c1 wceq wa cdm cpw crab fveq2
      cv df-mnc dmmptss elfvdm sseldi elpwid plybss adantr cnex elpw2 rabeq syl
      fvex rabex fvmpt sylbir eleq2d fveq12d eqeq1d elrab syl6bb pm5.21nii ) AB
      EFZGZBHIZABJFZGZAKFZALFZFZMNZOZVCBHVCEPHQZBCVLDTZKFZVMLFZFZMNZDCTZJFZRZEC
      DUAZUBABEUCUDUEVFVDVJBAUFUGVDVCAVQDVERZGVKVDVBWBAVDBVLGVBWBNBHUHUICBVTWBV
      LEVRBNVSVENVTWBNVRBJSVQDVSVEUJUKWAVQDVEBJULUMUNUOUPVQVJDAVEVMANZVPVIMWCVN
      VGVOVHVMALSVMAKSUQURUSUTVA $.

    $( A monic polynomial is a polynomial.  (Contributed by Stefan O'Rear,
       5-Dec-2014.) $)
    mncply $p |- ( P e. ( Monic ` S ) -> P e. ( Poly ` S ) ) $=
      ( cmnc cfv wcel cply cdgr ccoe c1 wceq elmnc simplbi ) ABCDEABFDEAGDAHDDI
      JABKL $.

    $( A monic polynomial has leading coefficient 1.  (Contributed by Stefan
       O'Rear, 5-Dec-2014.) $)
    mnccoe $p |- ( P e. ( Monic ` S )
        -> ( ( coeff ` P ) ` ( deg ` P ) ) = 1 ) $=
      ( cmnc cfv wcel cply cdgr ccoe c1 wceq elmnc simprbi ) ABCDEABFDEAGDAHDDI
      JABKL $.

    $( A monic polynomial is not zero.  (Contributed by Stefan O'Rear,
       5-Dec-2014.) $)
    mncn0 $p |- ( P e. ( Monic ` S ) -> P =/= 0p ) $=
      ( cmnc cfv wcel cdgr ccoe wceq c0p wne mnccoe cc0 cn0 csn cxp coe0 fveq1i
      c1 dgr0 fveq2 eqeltri fvconst2 ax-mp eqtri ax-1ne0 necomi eqnetri fveq12d
      0nn0 c0ex neeq1d mpbiri necon2i syl ) ABCDEAFDZAGDZDZRHAIJABKAIUQRAIHZUQR
      JIFDZIGDZDZRJVALRVAUSMLNOZDZLUSUTVBPQUSMEVCLHUSLMSUIUAMLUSUJUBUCUDRLUEUFU
      GURUQVARURUOUSUPUTAIGTAIFTUHUKULUMUN $.
  $}

  $(
  @{
    mncdiv.s @e |- ( ph -> S e. ( SubRing ` CCfld ) ) @.
    mncdiv.f @e |- ( ph -> F e. ( Poly ` S ) ) @.
    mncdiv.g @e |- ( ph -> G e. ( Monic ` S ) ) @.
    @( Monic version of polynomial division algorithm, does not require
       division over the base ring. @)
    mncdivex @p |- ( ph -> E. q e. ( Poly ` S ) ( F oF - ( G oF x. q ) ) e.
          ( S Poly< ( deg ` G ) ) ) @=
      ? @.
  @}
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Degree and minimal polynomial of algebraic numbers
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c degAA minPolyAA $.

  $( Extend class notation to include the degree function for algebraic
     numbers. $)
  cdgraa $a class degAA $.

  $( Extend class notation to include the minimal polynomial for an algebraic
     number. $)
  cmpaa $a class minPolyAA $.

  ${
    $d x d p $.

    $( Define the degree of an algebraic number as the smallest degree of any
       nonzero polynomial which has said number as a root.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    df-dgraa $a |- degAA = ( x e. AA |-> sup ( { d e. NN |
        E. p e. ( ( Poly ` QQ ) \ { 0p } ) ( ( deg ` p ) = d /\
          ( p ` x ) = 0 ) } , RR , `' < ) ) $.

    $( Define the minimal polynomial of an algebraic number as the unique monic
       polynomial which achieves the minimum of ` degAA ` .  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    df-mpaa $a |- minPolyAA = ( x e. AA |-> ( iota_ p e. ( Poly ` QQ )
        ( ( deg ` p ) = ( degAA ` x ) /\ ( p ` x ) = 0 /\
          ( ( coeff ` p ) ` ( degAA ` x ) ) = 1 ) ) ) $.
  $}

  $(
  @{
    @d x A a b @.  @d x B a b @.
    plydeg1.a @e |- F = ( x e. CC |-> ( ( A x. x ) + B ) ) @.
    @( A polynomial with 2 terms. @)
    plydeg1a @p |- ( ( A e. S /\ B e. S /\ S C_ CC ) -> F e. ( Poly ` S ) ) @=
      ? @.

    @( Degree of a polynomial with 2 terms. @)
    plydeg1b @p |- ( ( A e. CC /\ B e. CC /\ A =/= 0 ) -> ( deg ` A ) = 1 ) @=
      ? @.
  @}
  $)

  ${
    $d A x d p a b c $.  $d P x d p a b c $.

    $( Value of the degree function on an algebraic number.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    dgraaval $p |- ( A e. AA -> ( degAA ` A ) = sup ( { d e. NN |
        E. p e. ( ( Poly ` QQ ) \ { 0p } ) ( ( deg ` p ) = d /\
          ( p ` A ) = 0 ) } , RR , `' < ) ) $=
      ( va cv cdgr cfv wceq cc0 wa cq cply c0p wrex cn crab cr clt csup wor csn
      cdif ccnv caa cdgraa fveq2 eqeq1d anbi2d rexbidv rabbidv supeq1d df-dgraa
      ltso cnvso mpbi supex fvmpt ) DABEZFGCEHZDEZURGZIHZJZBKLGMUAUBZNZCOPZQRUC
      ZSUSAURGZIHZJZBVDNZCOPZQVGSUDUEUTAHZQVFVLVGVMVEVKCOVMVCVJBVDVMVBVIUSVMVAV
      HIUTAURUFUGUHUIUJUKDBCULQVLVGQRTQVGTUMQRUNUOUPUQ $.

    $( Properties of the degree of an algebraic number.  (Contributed by Stefan
       O'Rear, 25-Nov-2014.) $)
    dgraalem $p |- ( A e. AA -> ( ( degAA ` A ) e. NN /\
        E. p e. ( ( Poly ` QQ ) \ { 0p } ) ( ( deg ` p ) = ( degAA ` A ) /\
          ( p ` A ) = 0 ) ) ) $=
      ( va vb wcel cfv cv cdgr wceq cc0 wa cq c0p cn c1 wne eqeq2 anbi1d eqeq1d
      wrex caa cdgraa cply csn cdif crab cr clt ccnv dgraaval cuz wss c0 ssrab2
      csup nnuz sseqtri cc eldifsn biimpi ad2antrr simpr simplr syl12anc simpll
      wi dgrnznn jctil weq fveq2 fveq1 anbi12d rspc2ev syl3anc rexlimiva impcom
      eqid elqaa rabn0 3imtr4i infmssuzcl sylancr eqeltrd rexbidv elrab sylib
      ex ) AUAEZAUBFZBGZHFZCGZIZAWJFZJIZKZBLUCFZMUDUEZTZCNUFZEWINEWKWIIZWOKZBWR
      TZKWHWIWTUGUHUIUOZWTABCUJWHWTOUKFZULWTUMPZXDWTEWTNXEWSCNUNUPUQAUREZADGZFZ
      JIZDWRTZKWSCNTZWHXFXKXGXLXJXGXLVFDWRXHWREZXJKZXGXLXNXGKZXHHFZNEZXMXPXPIZX
      JKZXLXOXHWQEXHMPKZXGXJXQXMXTXJXGXMXTXHWQMUSUTVAXNXGVBXMXJXGVCZAXHLVGVDXMX
      JXGVEXOXJXRYAXPVQVHWPXSWKXPIZWOKCBXPXHNWRWLXPIWMYBWOWLXPWKQRBDVIZYBXRWOXJ
      YCWKXPXPWJXHHVJSYCWNXIJAWJXHVKSVLVMVNWGVOVPADVRWSCNVSVTWTOWAWBWCWSXCCWINW
      LWIIZWPXBBWRYDWMXAWOWLWIWKQRWDWEWF $.

    $( Closure of the degree function on algebraic numbers.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    dgraacl $p |- ( A e. AA -> ( degAA ` A ) e. NN ) $=
      ( va caa wcel cdgraa cfv cn cv cdgr wceq cc0 wa cq cply c0p csn cdif wrex
      dgraalem simpld ) ACDAEFZGDBHZIFUAJAUBFKJLBMNFOPQRABST $.

    $( Degree function on algebraic numbers is a function.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    dgraaf $p |- degAA : AA --> NN $=
      ( va vp vb caa cn cdgraa wf wfn cv cfv wcel wral cdgr wceq cc0 wa clt wor
      cq cr cply cdif wrex crab ccnv csup ltso cnvso mpbi supex df-dgraa fnmpti
      c0p csn dgraacl rgen ffnfv mpbir2an ) DEFGFDHAIZFJEKZADLADBIZMJCINUSVAJON
      PBSUAJUMUNUBUCCEUDZTQUEZUFFTVBVCTQRTVCRUGTQUHUIUJABCUKULUTADUSUOUPADEFUQU
      R $.

    $( Upper bound on degree of an algebraic number.  (Contributed by Stefan
       O'Rear, 25-Nov-2014.) $)
    dgraaub $p |- ( ( ( P e. ( Poly ` QQ ) /\ P =/= 0p ) /\ ( A e. CC /\
          ( P ` A ) = 0 ) ) -> ( degAA ` A ) <_ ( deg ` P ) ) $=
      ( vb va cq cfv wcel c0p wa cc0 wceq cv cdgr wrex cle fveq1 eqeq1d syl2anc
      cn rspcev cply wne cc cdgraa csn cdif crab cr clt ccnv caa simprl eldifsn
      csup biimpri adantr simprr elqaa sylanbrc dgraaval syl cuz wss wbr ssrab2
      c1 nnuz sseqtri dgrnznn eqid jctil fveq2 anbi12d eqeq2 rexbidv infmssuzle
      anbi1d elrab sylancr eqbrtrd ) BEUAFZGBHUBIZAUCGZABFZJKZIZIZAUDFZCLZMFZDL
      ZKZAWIFZJKZIZCWAHUEUFZNZDSUGZUHUIUJUNZBMFZOWGAUKGZWHWSKWGWCAWKFZJKZDWPNZX
      AWBWCWEULWGBWPGZWEXDWBXEWFXEWBBWAHUMUOUPZWBWCWEUQZXCWEDBWPWKBKXBWDJAWKBPQ
      TRADURUSACDUTVAWGWRVFVBFZVCWTWRGZWSWTOVDWRSXHWQDSVEVGVHWGWTSGWJWTKZWNIZCW
      PNZXIABEVIWGXEWTWTKZWEIZXLXFWGWEXMXGWTVJVKXKXNCBWPWIBKZXJXMWNWEXOWJWTWTWI
      BMVLQXOWMWDJAWIBPQVMTRWQXLDWTSWKWTKZWOXKCWPXPWLXJWNWKWTWJVNVQVOVRUSWTWRVF
      VPVSVT $.

    $( A rational polynomial of degree less than an algebraic number cannot be
       zero at that number unless it is the zero polynomial.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    dgraa0p $p |- ( ( A e. AA /\ P e. ( Poly ` QQ ) /\
          ( deg ` P ) < ( degAA ` A ) ) -> ( ( P ` A ) = 0 <-> P = 0p ) ) $=
      ( caa wcel cq cply cfv cdgr cdgraa clt wbr w3a cc0 wceq c0p wn simpl2 syl
      wa simpl1 wne cle simpl3 cn0 dgrcl nn0red cn nnred ltnled mpbid cc simprl
      dgraacl aacn simprr dgraaub syl22anc expr mtod ex necon4ad wi 0pval fveq1
      eqeq1d syl5ibrcom 3ad2ant1 impbid ) ACDZBEFGDZBHGZAIGZJKZLZABGZMNZBONZVNV
      PBOVNBOUAZVPPVNVRSZVPVLVKUBKZVSVMVTPVIVJVMVRUCVSVKVLVSVKVSVJVKUDDVIVJVMVR
      QEBUERUFVSVLVSVIVLUGDVIVJVMVRTAUMRUHUIUJVNVRVPVTVNVRVPSZSZVJVRAUKDZVPVTVI
      VJVMWAQVNVRVPULWBVIWCVIVJVMWATAUNZRVNVRVPUOABUPUQURUSUTVAVIVJVQVPVBVMVIVP
      VQAOGZMNZVIWCWFWDAVCRVQVOWEMABOVDVEVFVGVH $.

    $(
    @( Degree of a rational number. @)
    dgraaq @p |- ( A e. QQ -> ( degAA ` A ) = 1 ) @=
      ( va cq wcel cdgraa cfv c1 cle wbr wceq cc cneg cv cmul co caddc cmpt cc0
      oveq1d syl cdgr cply c0p wne qcn oveq2 eqid ovex fvmpt mulm1 negcl addcom
      syl2anc negid 3eqtrd eqtrd dgraaub syl22anc breqtrd cn wb caa qaa dgraacl
      nnle1eq1 mpbid ) ACDZAEFZGHIZVHGJZVGVHBKGLZBMZNOZAPOZQZUAFZGHVGVOCUBFDVOU
      CUDAKDZAVOFZRJVHVPHI??AUEZVGVRVKANOZAPOZRVGVQVRWAJVSBAVNWAKVOVLAJVMVTAPVL
      AVKNUFSVOUGVTAPUHUITVGWAALZAPOZAWBPOZRVGVTWBAPVGVQVTWBJVSAUJTSVGWBKDZVQWC
      WDJVGVQWEVSAUKTVSWBAULUMVGVQWDRJVSAUNTUOUPAVOUQUR?USVGVHUTDZVIVJVAVGAVBDW
      FAVCAVDTVHVETVF @.
      @( [25-Nov-2014] @)
    $)

    $( An algebraic number has exactly one monic polynomial of the least
       degree.  (Contributed by Stefan O'Rear, 25-Nov-2014.) $)
    mpaaeu $p |- ( A e. AA -> E! p e. ( Poly ` QQ ) ( ( deg ` p ) =
          ( degAA ` A ) /\ ( p ` A ) = 0 /\
        ( ( coeff ` p ) ` ( degAA ` A ) ) = 1 ) ) $=
      ( va wcel cdgr cfv wceq cc0 c1 cq wa c0p cc co cmul cn0 syl adantl eqeq1d
      cvv vb vc caa cv cdgraa ccoe w3a cply wrex weq wi wral wreu cdif dgraalem
      csn cn simprd cdiv cxp cof wss qsscn wf eldifi ad2antlr cz zssq 0z sselii
      wne eqid coef2 sylancl dgrcl ffvelrnd eldifsni wb dgreq0 necon3bid qreccl
      mpbid syl2anc sylancr simpl simpr caddc qaddcl qmulcl plymul coef3 reccld
      plyconst recne0d dgrmulc syl3anc simprl eqtrd aacn ad2antrr ovex fnconstg
      wfn mp1i plyf ffn 3syl cnex a1i inidm fvconst2 simplrr ofval mpdan mul01d
      coemulc fveq1d dgraacl nnnn0d nn0ex simplrl eqcomd fveq2d fveq2 3anbi123d
      recid2d 3eqtrd fveq1 rspcev syl13anc ex rexlimdva mpd cmin anim12i sylan2
      simp2 syl6eq clt wbr 0cn subid1i com12 impl simpll cneg 1z zq qnegcl mp2b
      simprr1 simprl1 eqeltrd simprl3 simprr3 3eqtr4d dgrsub2 syl23anc ofsubeq0
      plysub eqtr4d breqtrd dgraa0p df-0p mp3an1 syl2an ralrimivva sylanbrc
      reu4 ) AUCDZBUDZEFZAUEFZGZAUVKFZHGZUVMUVKUFFZFZIGZUGZBJUHFZUIZUVTCUDZEFZU
      VMGZAUWCFZHGZUVMUWCUFFZFZIGZUGZKZBCUJZUKZCUWAULBUWAULUVTBUWAUMUVJUWEUWGKZ
      CUWALUPZUNZUIZUWBUVJUVMUQDZUWRACUOURUVJUWOUWBCUWQUVJUWCUWQDZKZUWOUWBUXAUW
      OKZMIUWDUWHFZUSNZUPZUTZUWCOVAZNZUWADZUXHEFZUVMGZAUXHFZHGZUVMUXHUFFZFZIGZU
      WBUXBUXFUWADZUWCUWADZUXIUXBJMVBUXDJDZUXQVCUXBUXCJDUXCHVKZUXSUXBPJUWDUWHUX
      BUXRHJDPJUWHVDUWTUXRUVJUWOUWCUWAUWPVEVFZVGJHVHVIVJUWHJUWCUWHVLZVMVNUXBUXR
      UWDPDUYAJUWCVOQZVPUXBUWCLVKZUXTUWTUYDUVJUWOUWCUWALVQVFUXBUXRUYDUXTVRUYAUX
      RUWCLUXCHUWHJUWCUWDUWDVLUYBVSVTQWBZUXCWAWCUXDJWMWDUYAUXQUXRKZUAUBJUXFUWCU
      XQUXRWEUXQUXRWFUAUDZJDUBUDZJDKZUYGUYHWGNJDZUYFUYGUYHWHZRUYIUYGUYHONJDZUYF
      UYGUYHWIZRWJWCUXBUXJUWDUVMUXBUXDMDZUXDHVKUXRUXJUWDGUXBUXCUXBPMUWDUWHUXBUX
      RPMUWHVDZUYAUWHJUWCUYBWKQZUYCVPZUYEWLZUXBUXCUYQUYEWNUYAUXDJUWCWOWPUXAUWEU
      WGWQWRUXBUXLUXDHONZHUXBAMDZUXLUYSGUVJUYTUWTUWOAWSZWTUXBMMUXDHOMUXFUWCTTAU
      XDTDZUXFMXCUXBIUXCUSXAZMUXDTXBXDUXBUXRMMUWCVDZUWCMXCZUYAJUWCXEZMMUWCXFZXG
      MTDZUXBXHXIZVUIMXJZUYTAUXFFUXDGUXBMUXDAVUCXKRUXAUWEUWGUYTXLXMXNUXBUXDUYRX
      OWRUXBUXOUVMPUXEUTZUWHUXGNZFZUXDUXCONZIUXBUVMUXNVULUXBUYNUXRUXNVULGUYRUYA
      UXDJUWCXPWCXQUXBUVMPDZVUMVUNGUXBUVMUVJUWSUWTUWOAXRZWTXSUXBPPUXDUXCOPVUKUW
      HTTUVMVUBVUKPXCUXBVUCPUXDTXBXDUXBUYOUWHPXCUYPPMUWHXFQPTDUXBXTXIZVUQPXJVUO
      UVMVUKFUXDGUXBPUXDUVMVUCXKRUXBVUOKZUVMUWDUWHVURUWDUVMUXAUWEUWGVUOYAYBYCXM
      XNUXBUXCUYQUYEYFYGUVTUXKUXMUXPUGBUXHUWAUVKUXHGZUVNUXKUVPUXMUVSUXPVUSUVLUX
      JUVMUVKUXHEYDSVUSUVOUXLHAUVKUXHYHSVUSUVRUXOIVUSUVMUVQUXNUVKUXHUFYDXQSYEYI
      YJYKYLYMUVJUWNBCUWAUWAUVJUVKUWADZUXRKZKZUWLUWMVVBUWLKZUVKUWCYNVANZMHUPUTZ
      GZUWMVVCVVDLVVEVVCAVVDFZHGZVVDLGZUVJVVAUWLVVHVVAUWLKUVJVVHUWLVVAUVPUWGKZU
      VJVVHUKUVTUVPUWKUWGUVNUVPUVSYQUWEUWGUWJYQYOVVAVVJKZUVJVVHVVKUVJKVVGHHYNNZ
      HUVJVVKUYTVVGVVLGVUAVVKMMHHYNMUVKUWCTTAVUTUVKMXCZUXRVVJVUTMMUVKVDZVVMJUVK
      XEZMMUVKXFQWTUXRVUEVUTVVJUXRVUDVUEVUFVUGQVFVUHVVKXHXIZVVPVUJVVAUVPUWGUYTY
      AVVAUVPUWGUYTXLXMYPHUUAUUBYRYKYPUUCUUDVVCUVJVVDUWADZVVDEFZUVMYSYTVVHVVIVR
      UVJVVAUWLUUEVVAVVQUVJUWLVVAUAUBJUVKUWCVUTUXRWEVUTUXRWFUYIUYJVVAUYKRUYIUYL
      VVAUYMRIUUFJDZVVAIVGDIJDVVSUUGIUUHIUUIUUJXIUUTVFVVCVVRUVLUVMYSVVCVUTUXRUW
      DUVLGUVLUQDUVLUVQFZUVLUWHFZGVVRUVLYSYTUVJVUTUXRUWLYAUVJVUTUXRUWLXLVVCUWDU
      VMUVLUWEUWGUWJUVTVVBUUKUVNUVPUVSUWKVVBUULZUVAVVCUVLUVMUQVWBUVJUWSVVAUWLVU
      PWTUUMVVCUVRIVVTVWAUVNUVPUVSUWKVVBUUNVVCUVLUVMUVQVWBYCVVCVWAUWIIVVCUVLUVM
      UWHVWBYCUWEUWGUWJUVTVVBUUOWRUUPJJUVKUWCUVLUVLVLUUQUURVWBUVBAVVDUVCWPWBUVD
      YRVVAVVFUWMVRZUVJUWLVUTVVNVUDVWCUXRVVOVUFVUHVVNVUDVWCXHMUVKUWCTUUSUVEUVFV
      FWBYKUVGUVTUWKBCUWAUWMUVNUWEUVPUWGUVSUWJUWMUVLUWDUVMUVKUWCEYDSUWMUVOUWFHA
      UVKUWCYHSUWMUVRUWIIUWMUVMUVQUWHUVKUWCUFYDXQSYEUVIUVH $.

    $( Value of the minimal polynomial of an algebraic number.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    mpaaval $p |- ( A e. AA -> ( minPolyAA ` A ) = ( iota_ p e. ( Poly ` QQ )
        ( ( deg ` p ) = ( degAA ` A ) /\ ( p ` A ) = 0 /\
          ( ( coeff ` p ) ` ( degAA ` A ) ) = 1 ) ) ) $=
      ( va cv cdgr cfv cdgraa wceq cc0 ccoe c1 w3a cq cply crio caa cmpaa fveq2
      eqeq2d eqeq1d fveq2d 3anbi123d riotabidv df-mpaa riotaex fvmpt ) CABDZEFZ
      CDZGFZHZUIUGFZIHZUJUGJFZFZKHZLZBMNFZOUHAGFZHZAUGFZIHZUSUNFZKHZLZBUROPQUIA
      HZUQVEBURVFUKUTUMVBUPVDVFUJUSUHUIAGRZSVFULVAIUIAUGRTVFUOVCKVFUJUSUNVGUATU
      BUCCBUDVEBURUEUF $.

    $( Properties of the minimal polynomial of an algebraic number.
       (Contributed by Stefan O'Rear, 25-Nov-2014.) $)
    mpaalem $p |- ( A e. AA -> ( ( minPolyAA ` A ) e. ( Poly ` QQ ) /\
        ( ( deg ` ( minPolyAA ` A ) ) = ( degAA ` A ) /\
          ( ( minPolyAA ` A ) ` A ) = 0 /\
          ( ( coeff ` ( minPolyAA ` A ) ) ` ( degAA ` A ) ) = 1 ) ) ) $=
      ( vp caa wcel cmpaa cfv cv cdgr cdgraa wceq cc0 ccoe c1 w3a cq cply fveq2
      crab wa eqeq1d crio mpaaval wreu mpaaeu riotacl2 syl eqeltrd fveq1 fveq1d
      3anbi123d elrab sylib ) ACDZAEFZBGZHFZAIFZJZAUOFZKJZUQUOLFZFZMJZNZBOPFZRZ
      DUNVEDUNHFZUQJZAUNFZKJZUQUNLFZFZMJZNZSUMUNVDBVEUAZVFABUBUMVDBVEUCVOVFDABU
      DVDBVEUEUFUGVDVNBUNVEUOUNJZURVHUTVJVCVMVPUPVGUQUOUNHQTVPUSVIKAUOUNUHTVPVB
      VLMVPUQVAVKUOUNLQUITUJUKUL $.

    $( Minimal polynomial is a polynomial.  (Contributed by Stefan O'Rear,
       25-Nov-2014.) $)
    mpaacl $p |- ( A e. AA -> ( minPolyAA ` A ) e. ( Poly ` QQ ) ) $=
      ( caa wcel cmpaa cfv cq cply cdgr cdgraa wceq cc0 ccoe w3a mpaalem simpld
      c1 ) ABCADEZFGECQHEAIEZJAQEKJRQLEEPJMANO $.

    $( Minimal polynomial has degree the degree of the number.  (Contributed by
       Stefan O'Rear, 25-Nov-2014.) $)
    mpaadgr $p |- ( A e. AA -> ( deg ` ( minPolyAA ` A ) ) = ( degAA ` A ) ) $=
      ( caa wcel cmpaa cfv cq cply cdgr cdgraa wceq cc0 ccoe w3a mpaalem simpr1
      c1 wa syl ) ABCADEZFGECZSHEAIEZJZASEKJZUASLEEPJZMQUBANTUBUCUDOR $.

    $( The minimal polynomial of an algebraic number has the number as a root.
       (Contributed by Stefan O'Rear, 25-Nov-2014.) $)
    mpaaroot $p |- ( A e. AA -> ( ( minPolyAA ` A ) ` A ) = 0 ) $=
      ( caa wcel cmpaa cfv cq cply cdgr cdgraa wceq cc0 ccoe w3a mpaalem simpr2
      c1 wa syl ) ABCADEZFGECZSHEAIEZJZASEKJZUASLEEPJZMQUCANTUBUCUDOR $.

    $( Minimal polynomial is monic.  (Contributed by Stefan O'Rear,
       25-Nov-2014.) $)
    mpaamn $p |- ( A e. AA -> ( ( coeff ` ( minPolyAA ` A ) ) `
          ( degAA ` A ) ) = 1 ) $=
      ( caa wcel cmpaa cfv cq cply cdgr cdgraa wceq cc0 ccoe w3a mpaalem simpr3
      c1 wa syl ) ABCADEZFGECZSHEAIEZJZASEKJZUASLEEPJZMQUDANTUBUCUDOR $.

    $(
    @( The minimal polynomial of a rational number. @)
    mpaaq @p |- ( A e. QQ -> ( minPolyAA ` A ) = ( x e. CC |-> ( x - A ) ) ) @=
      ? @.
    $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Algebraic integers I
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c _ZZ IntgOver $.

  $( Extend class notation with the integral-over predicate. $)
  citgo $a class IntgOver $.

  $( Extend class notation with the class of algebraic integers. $)
  cza $a class _ZZ $.

  ${
    $d x p s $.

    $( A complex number is said to be integral over a subset if it is the root
       of a monic polynomial with coefficients from the subset.  This
       definition is typically not used for fields but it works there, see
       ~ aaitgo .  This definition could work for subsets of an arbitrary ring
       with a more general definition of polynomials.  TODO: use ` Monic `
       (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    df-itgo $a |- IntgOver = ( s e. ~P CC |-> { x e. CC | E. p e. ( Poly ` s )
        ( ( p ` x ) = 0 /\ ( ( coeff ` p ) ` ( deg ` p ) ) = 1 ) } ) $.

    $( Define an algebraic integer as a complex number which is the root of a
       monic integer polynomial.  (Contributed by Stefan O'Rear,
       30-Nov-2014.) $)
    df-za $a |- _ZZ = ( IntgOver ` ZZ ) $.
  $}

  ${
    $d X x p s a b c $.  $d S x p s a b c $.  $d T x p s a b c $.
    $d P x p s a b c $.
    $( Value of the integral-over function.  (Contributed by Stefan O'Rear,
       27-Nov-2014.) $)
    itgoval $p |- ( S C_ CC -> ( IntgOver ` S ) = { x e. CC |
        E. p e. ( Poly ` S ) ( ( p ` x ) = 0 /\
          ( ( coeff ` p ) ` ( deg ` p ) ) = 1 ) } ) $=
      ( vs cc wss cpw wcel citgo cfv cv cc0 wceq cdgr ccoe cply wrex crab cnex
      c1 wa elpw2 fveq2 rexeqdv rabbidv df-itgo rabex fvmpt sylbir ) BEFBEGZHBI
      JAKCKZJLMUKNJUKOJJTMUAZCBPJZQZAERZMBESUBDBULCDKZPJZQZAERUOUJIUPBMZURUNAEU
      SULCUQUMUPBPUCUDUEADCUFUNAESUGUHUI $.

    $( The standard algebraic numbers ` AA ` are generated by ` IntgOver ` .
       (Contributed by Stefan O'Rear, 27-Nov-2014.) $)
    aaitgo $p |- AA = ( IntgOver ` QQ ) $=
      ( va vb caa cq cfv cv cc0 wceq cdgr ccoe c1 wa wrex cc wcel ax-mp c0p wne
      fveq2 cn0 citgo cply crab rabid qsscn itgoval eleq2i aacn mpaacl mpaaroot
      wss cmpaa cdgraa mpaadgr fveq2d mpaamn eqtrd fveq1 eqeq1d fveq12d anbi12d
      rspcev syl12anc jca csn cdif simpl cxp coe0 fveq1i dgr0 0nn0 eqeltri c0ex
      fvconst2 ax-1ne0 necomi eqnetri necon2i ad2antll eldifsn sylanbrc reximi2
      eqtri neeq1d mpbiri simprl anim2i elqaa sylibr impbii 3bitr4ri eqriv ) AC
      DUAEZAFZWOBFZEZGHZWPIEZWPJEZEZKHZLZBDUBEZMZANUCZOWONOZXELZWOWNOWOCOZXEANU
      DWNXFWODNUKWNXFHUEADBUFPUGXIXHXIXGXEWOUHXIWOULEZXDOWOXJEZGHZXJIEZXJJEZEZK
      HZXEWOUIWOUJXIXOWOUMEZXNEKXIXMXQXNWOUNUOWOUPUQXCXLXPLBXJXDWPXJHZWRXLXBXPX
      RWQXKGWOWPXJURUSXRXAXOKXRWSXMWTXNWPXJJSWPXJISUTUSVAVBVCVDXHXGWRBXDQVEVFZM
      ZLXIXEXTXGXCWRBXDXSWPXDOZXCLZWPXSOZWRYBYAWPQRZYCYAXCVGXBYDYAWRWPQXAKWPQHZ
      XAKRQIEZQJEZEZKRYHGKYHYFTGVEVHZEZGYFYGYIVIVJYFTOYJGHYFGTVKVLVMTGYFVNVOPWD
      KGVPVQVRYEXAYHKYEWSYFWTYGWPQJSWPQISUTWEWFVSVTWPXDQWAWBYAWRXBWGVDWCWHWOBWI
      WJWKWLWM $.

    $( An integral element is integral over a subset.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.) $)
    itgoss $p |- ( ( S C_ T /\ T C_ CC ) ->
          ( IntgOver ` S ) C_ ( IntgOver ` T ) ) $=
      ( va vb wss cc wa cv cfv cc0 wceq cdgr ccoe c1 cply wrex crab syl itgoval
      citgo wi wral plyss ssrexv ralrimivw ss2rab sylibr sstr adantl 3sstr4d )
      ABEZBFEZGZCHDHZIJKUNLIUNMIINKGZDAOIZPZCFQZUODBOIZPZCFQZATIZBTIZUMUQUTUAZC
      FUBURVAEUMVDCFUMUPUSEVDABUCUODUPUSUDRUEUQUTCFUFUGUMAFEVBURKABFUHCADSRULVC
      VAKUKCBDSUIUJ $.

    $( All integral elements are complex numbers.  (Contributed by Stefan
       O'Rear, 27-Nov-2014.) $)
    itgocn $p |- ( IntgOver ` S ) C_ CC $=
      ( va vb vc citgo wcel cfv cc wss cv cc0 wceq cdgr ccoe cply wrex syl6eqss
      c1 wa crab cdm cpw df-itgo dmmptss sseli cnex elpw2 itgoval ssrab2 syl wn
      sylbi c0 ndmfv 0ss pm2.61i ) AEUAZFZAEGZHIZURAHUBZFZUTUQVAABVACJZDJZGKLVD
      MGVDNGGRLSDBJZOGPCHTECBDUCUDUEVBAHIZUTAHUFUGVFUSVEVCGKLVCMGVCNGGRLSCAOGPZ
      BHTHBACUHVGBHUIQULUJURUKUSUMHAEUNHUOQUP $.

  $}

  ${
    $d ph a b $.  $d X a b $.  $d Y a b $.  $d S a b $.
    cnsrexpcl.s $e |- ( ph -> S e. ( SubRing ` CCfld ) ) $.
    cnsrexpcl.x $e |- ( ph -> X e. S ) $.
    cnsrexpcl.y $e |- ( ph -> Y e. NN0 ) $.
    $( Exponentiation is closed in number rings.  (Contributed by Stefan
       O'Rear, 30-Nov-2014.) $)
    cnsrexpcl $p |- ( ph -> ( X ^ Y ) e. S ) $=
      ( wcel cexp co wi cc0 c1 wceq oveq2 eleq1d imbi2d cc ccnfld 3ad2ant2 cmul
      va vb cn0 caddc csubrg cfv wss cnfldbas subrgss syl sseldd exp0d subrg1cl
      cv cnfld1 eqeltrd w3a simp1 expp1d simp3 cnfldmul subrgmcl syl3anc nn0ind
      3exp a2d mpcom ) DUDHACDIJZBHZGACUBUOZIJZBHZKACLIJZBHZKACUCUOZIJZBHZKACVP
      MUEJZIJZBHZKAVJKUBUCDVKLNZVMVOAWBVLVNBVKLCIOPQVKVPNZVMVRAWCVLVQBVKVPCIOPQ
      VKVSNZVMWAAWDVLVTBVKVSCIOPQVKDNZVMVJAWEVLVIBVKDCIOPQAVNMBACABRCABSUFUGHZB
      RUHEBRSUIUJUKFULZUMAWFMBHEBSMUPUNUKUQVPUDHZAVRWAWHAVRWAWHAVRURZVTVQCUAJZB
      WICVPAWHCRHVRWGTWHAVRUSUTWIWFVRCBHZWJBHAWHWFVRETWHAVRVAAWHWKVRFTBSUAVQCVB
      VCVDUQVFVGVEVH $.
  $}

  ${
    $d ph k a b $.  $d A k a b $.  $d B a b $.  $d S k a b $.
    fsumcnsrcl.s $e |- ( ph -> S e. ( SubRing ` CCfld ) ) $.
    fsumcnsrcl.a $e |- ( ph -> A e. Fin ) $.
    fsumcnsrcl.b $e |- ( ( ph /\ k e. A ) -> B e. S ) $.
    $( Finite sums are closed in number rings.  (Contributed by Stefan O'Rear,
       30-Nov-2014.) $)
    fsumcnsrcl $p |- ( ph -> sum_ k e. A B e. S ) $=
      ( va vb ccnfld csubrg cfv wcel cc wss cnfldbas cv caddc cc0 subrgss wa co
      syl cnfldadd subrgacl 3expb sylan subrgsubg cnfld0 subg0cl 3syl fsumcllem
      csubg ) AIJBCDEADKLMNZDOPFDOKQUAUDAUOIRZDNZJRZDNZUBUPURSUCDNZFUOUQUSUTDSK
      UPURUEUFUGUHGHAUODKUNMNTDNFDKUIDKTUJUKULUM $.
  $}

  ${
    $d P k $.  $d ph k $.  $d X k $.  $d S k $.  $d C k $.
    cnsrplycl.s $e |- ( ph -> S e. ( SubRing ` CCfld ) ) $.
    cnsrplycl.p $e |- ( ph -> P e. ( Poly ` C ) ) $.
    cnsrplycl.x $e |- ( ph -> X e. S ) $.
    cnsrplycl.c $e |- ( ph -> C C_ S ) $.
    $( Polynomials are closed in number rings.  (Contributed by Stefan O'Rear,
       30-Nov-2014.) $)
    cnsrplycl $p |- ( ph -> ( P ` X ) e. S ) $=
      ( vk cfv cc0 co wcel cc wss ccnfld syl2anc adantr cn0 cdgr ccoe cexp cmul
      cfz cv csu cply wceq csubrg cnfldbas subrgss syl plyss sseldd eqid coeid2
      fzfid wa wf csubg subrgsubg cnfld0 subg0cl coef2 elfznn0 adantl cnsrexpcl
      3syl ffvelrnd cnfldmul subrgmcl syl3anc fsumcnsrcl eqeltrd ) AECKZLCUAKZU
      EMZJUFZCUBKZKZEVSUCMZUDMZJUGZDACDUHKZNZEONVPWDUIABUHKZWECABDPDOPZWGWEPIAD
      QUJKNZWHFDOQUKULUMZBDUNRGUOZADOEWJHUOVTDJCVQEVTUPZVQUPUQRAVRWCDJFALVQURAV
      SVRNZUSZWIWADNWBDNWCDNAWIWMFSZWNTDVSVTATDVTUTZWMAWFLDNZWPWKAWIDQVAKNWQFDQ
      VBDQLVCVDVIVTDCWLVERSWMVSTNAVSVQVFVGZVJWNDEVSWOAEDNWMHSWRVHDQUDWAWBVKVLVM
      VNVO $.
  $}

  ${
    $d ph a b t $.  $d R a b t $.  $d B a b t $.  $d A a b t $.  $d S t $.
    rgspnval.r $e |- ( ph -> R e. Ring ) $.
    rgspnval.b $e |- ( ph -> B = ( Base ` R ) ) $.
    rgspnval.ss $e |- ( ph -> A C_ B ) $.
    rgspnval.n $e |- ( ph -> N = ( RingSpan ` R ) ) $.
    rgspnval.sp $e |- ( ph -> U = ( N ` A ) ) $.
    $( Value of the ring-span of a set of elements in a ring.  (Contributed by
       Stefan O'Rear, 7-Dec-2014.) $)
    rgspnval $p |- ( ph -> U = |^| { t e. ( SubRing ` R ) | A C_ t } ) $=
      ( vb va cfv wss cbs wcel cvv wceq crgspn csubrg crab cint fveq1d cpw cmpt
      crg elex fveq2 pweqd rabeq syl inteqd mpteq12dv df-rgspn fvex mptex fvmpt
      cv pwex 3syl sseqtrd elpw2 sylibr wrex eqid subrgid eqeltrd sseq2 syl2anc
      rspcev intexrab sylib sseq1 rabbidv fvmptg eqtrd 3eqtrd ) AFCGOCEUAOZOZCB
      UTZPZBEUBOZUCZUDZLACGVTKUEAWACMEQOZUFZMUTZWBPZBWDUCZUDZUGZOZWFACVTWMAEUHR
      ZESRVTWMTHEUHUINEMNUTZQOZUFZWJBWPUBOZUCZUDZUGWMSUAWPETZMWRXAWHWLXBWQWGWPE
      QUJUKXBWTWKXBWSWDTWTWKTWPEUBUJWJBWSWDULUMUNUONBMUPMWHWLWGEQUQZVAURUSVBUEA
      CWHRZWFSRZWNWFTACWGPXDACDWGJIVCCWGXCVDVEAWCBWDVFZXEADWDRCDPZXFADWGWDIAWOW
      GWDRHWGEWGVGVHUMVIJWCXGBDWDWBDCVJVLVKWCBWDVMVNMCWLWFWHSWMWICTZWKWEXHWJWCB
      WDWICWBVOVPUNWMVGVQVKVRVS $.

    $( The ring-span of a set is a subring.  (Contributed by Stefan O'Rear,
       7-Dec-2014.) $)
    rgspncl $p |- ( ph -> U e. ( SubRing ` R ) ) $=
      ( vt cv wss csubrg cfv crab cint wcel eqeltrd rgspnval c0 wne ssrab2 wrex
      cbs crg eqid subrgid sseq2 rspcev syl2anc rabn0 sylibr subrgint sylancr
      syl ) AEBLMZNZLDOPZQZRZUTALBCDEFGHIJKUAAVAUTNVAUBUCZVBUTSUSLUTUDAUSLUTUEZ
      VCACUTSBCNZVDACDUFPZUTHADUGSVFUTSGVFDVFUHUIUQTIUSVELCUTURCBUJUKULUSLUTUMU
      NDVAUOUPT $.

    $( The ring-span of a set contains the set.  (Contributed by Stefan O'Rear,
       30-Nov-2014.) $)
    rgspnssid $p |- ( ph -> A C_ U ) $=
      ( vt cv wss csubrg cfv crab cint ssintub rgspnval syl5sseqr ) ABLMNLDOPZQ
      RBELBUBSALBCDEFGHIJKTUA $.

    rgspnmin.sr $e |- ( ph -> S e. ( SubRing ` R ) ) $.
    rgspnmin.ss $e |- ( ph -> A C_ S ) $.
    $( The ring-span is contained in all subspaces which contain all the
       generators.  (Contributed by Stefan O'Rear, 30-Nov-2014.) $)
    rgspnmin $p |- ( ph -> U C_ S ) $=
      ( vt cv wss csubrg cfv wcel crab rgspnval sseq2 elrab sylanbrc intss1 syl
      cint eqsstrd ) AFBOPZQZODRSZUAZUHZEAOBCDFGHIJKLUBAEUMTZUNEQAEULTBEQZUOMNU
      KUPOEULUJEBUCUDUEEUMUFUGUI $.
  $}

  ${
    rgspnid.r $e |- ( ph -> R e. Ring ) $.
    rgspnid.sr $e |- ( ph -> A e. ( SubRing ` R ) ) $.
    rgspnid.sp $e |- ( ph -> S = ( ( RingSpan ` R ) ` A ) ) $.
    $( The span of a subring is itself.  (Contributed by Stefan O'Rear,
       30-Nov-2014.) $)
    rgspnid $p |- ( ph -> S = A ) $=
      ( cbs cfv crgspn eqidd csubrg wcel wss eqid subrgss syl ssid a1i rgspnmin
      rgspnssid eqssd ) ADBABCHIZCBDCJIZEAUCKZABCLIMBUCNFBUCCUCOPQZAUDKZGFBBNAB
      RSTABUCCDUDEUEUFUGGUAUB $.
  $}

  ${
    $d ph a b c d e p $.  $d B a b c d e p $.  $d X a b c d e p $.
    $d V a b c d e p $.
    rngunsnply.b $e |- ( ph -> B e. ( SubRing ` CCfld ) ) $.
    rngunsnply.x $e |- ( ph -> X e. CC ) $.
    rngunsnply.s $e |- ( ph -> S = ( ( RingSpan ` CCfld ) `
        ( B u. { X } ) ) ) $.
    $( Adjoining one element to a ring results in a set of polynomial
       evaluations.  (Contributed by Stefan O'Rear, 30-Nov-2014.) $)
    rngunsnply $p |- ( ph -> ( V e. S <->
        E. p e. ( Poly ` B ) V = ( p ` X ) ) ) $=
      ( va wcel ccnfld cfv wceq wrex cc syl caddc co cmul vb vc ve vd crgspn cv
      csn cun cply eleq2d cab crg cnrng a1i cbs cnfldbas csubrg wss snssd unssd
      subrgss eqidd cress c1 cc0 cnfld0 cplusg cnfldadd wa plyf ffvelrn syl2anr
      wf eleq1 syl5ibrcom rexlimdva ss2abdv abid2 eqtri syl6sseq plyconst sylan
      c0g cxp adantr vex fvconst2 eqcomd fveq1 eqeq2d rspcev ex syl5eqssr csubg
      syl2anc subrgsubg subg0cl sseldd w3a biid weq rexbidv cbvrexv syl6bb elab
      eqeq1 cof simplr simpr subrgacl 3expb adantlr plyadd wfn cvv ffn ad2antlr
      wi adantl cnex ad2antrr fnfvof syl22anc oveq2 eqeq1d oveq1 imbi2d syl3anb
      3imp ovex sylibr cminusg cneg cnfldneg mp1i cnfld1 cnfldmul plymul fvex
      cidp ax-1cn subrg1cl eqid subginvcl eqeltrrd subrgmcl negex oveq1d mulm1d
      fnconstg 3eqtrd eqtr4d fveq2 imp sylan2b cur cmulr issubrngd2 cres df-idp
      plyid cid fveq1i fvresi syl5req wb elabg mpbird rgspnmin mpbiri rexlimivw
      sseld elab3 syl6ib rgspncl rgspnssid unssbd snidg unssad cnsrplycl impbid
      bitrd ) ADCKDBEUGZUHZLUEMZMZKZDEFUFZMZNZFBUIMZOZACUWFDIUJAUWGUWLAUWGDJUFZ
      UWINZFUWKOZJUKZKUWLAUWFUWPDAUWDPLUWPUWFUWELULKAUMUNZPLUOMZNAUPUNZABUWCPAB
      LUQMZKZBPURZGBPLUPVAQZAEPHUSUTZAUWEVBZAUWFVBZAUAUBUWPRLUWPVCSZTVDLVEAUXGV
      BVELWCMNAVFUNRLVGMNAVHUNAUWPUWMPKZJUKZUWRAUWOUXHJAUWNUXHFUWKAUWHUWKKZVIZU
      XHUWNUWIPKZUXJPPUWHVMEPKZUXLABUWHVJHPPEUWHVKVLUWMUWIPVNVOVPVQUXIPUWRJPVRU
      PVSVTABUWPVEABUWMBKZJUKUWPJBVRAUXNUWOJAUXNUWOAUXNVIZPUWMUGWDZUWKKZUWMEUXP
      MZNZUWOAUXBUXNUXQUXCUWMBWAWBUXOUXRUWMUXOUXMUXRUWMNAUXMUXNHWEPUWMEJWFWGQWH
      UWNUXSFUXPUWKUWHUXPNUWIUXRUWMEUWHUXPWIWJWKWOWLVQWMZABLWNMKZVEBKAUXAUYAGBL
      WPQZBLVEVFWQQWRAUAUFZUWPKZUBUFZUWPKZWSZUYCUYERSZUWINZFUWKOZUYHUWPKAAUYDUY
      CEUCUFZMZNZUCUWKOZUYFUYEEUDUFZMZNZUDUWKOZUYJAWTZUWOUYNJUYCUAWFJUAXAZUWOUY
      CUWINZFUWKOUYNUYTUWNVUAFUWKUWMUYCUWIXFXBVUAUYMFUCUWKFUCXAUWIUYLUYCEUWHUYK
      WIWJXCXDXEZUWOUYRJUYEUBWFJUBXAZUWOUYEUWINZFUWKOUYRVUCUWNVUDFUWKUWMUYEUWIX
      FXBVUDUYQFUDUWKFUDXAUWIUYPUYEEUWHUYOWIWJXCXDXEZAUYNUYRUYJAUYMUYRUYJXRZUCU
      WKAUYKUWKKZVIZVUFUYMUYRUYLUYERSZUWINZFUWKOZXRVUHUYQVUKUDUWKVUHUYOUWKKZVIZ
      VUKUYQUYLUYPRSZUWINZFUWKOZVUMUYKUYORXGSZUWKKVUNEVUQMZNZVUPVUMJUABUYKUYOAV
      UGVULXHZVUHVULXIZVUHUXNUYCBKZVIZUWMUYCRSBKZVULAVVCVVDVUGAUXAVVCVVDGUXAUXN
      VVBVVDBRLUWMUYCVHXJXKWBXLZXLZXMVUMVURVUNVUMUYKPXNZUYOPXNZPXOKZUXMVURVUNNV
      UGVVGAVULVUGPPUYKVMZVVGBUYKVJZPPUYKXPQZXQZVULVVHVUHVULPPUYOVMVVHBUYOVJPPU
      YOXPQXSZVVIVUMXTUNZAUXMVUGVULHYAZPRUYKUYOXOEYBYCWHVUOVUSFVUQUWKUWHVUQNUWI
      VURVUNEUWHVUQWIWJWKWOUYQVUJVUOFUWKUYQVUIVUNUWIUYEUYPUYLRYDYEXBVOVPUYMUYJV
      UKUYRUYMUYIVUJFUWKUYMUYHVUIUWIUYCUYLUYERYFYEXBYGVOVPYIYHUWOUYJJUYHUYCUYER
      YJUWMUYHNUWNUYIFUWKUWMUYHUWIXFXBXEYKAUYDVIUYCLYLMZMZUWINZFUWKOZVVRUWPKUYD
      AUYNVVTVUBAUYNVVTAUYMVVTUCUWKVUHVVTUYMUYLVVQMZUWINZFUWKOZVUHPVDYMZUGWDZUY
      KTXGZSZUWKKVWAEVWGMZNZVWCVUHJUABVWEUYKAVWEUWKKZVUGAUXBVWDBKVWJUXCAVDVVQMZ
      VWDBVDPKVWKVWDNAUUAVDYNYOAUYAVDBKZVWKBKUYBAUXAVWLGBLVDYPUUBQZBLVVQVDVVQUU
      CUUDWOUUEVWDBWAWOWEAVUGXIVVEAVVCUWMUYCTSBKZVUGAUXAVVCVWNGUXAUXNVVBVWNBLTU
      WMUYCYQUUFXKWBXLZYRVUHVWAUYLYMZVWHVUHUYLPKZVWAVWPNVUGVVJUXMVWQAVVKHPPEUYK
      VKVLZUYLYNQVUHVWHEVWEMZUYLTSZVWDUYLTSVWPVUHVWEPXNZVVGVVIUXMVWHVWTNVWDXOKV
      XAVUHVDUUGZPVWDXOUUJYOVUGVVGAVVLXSVVIVUHXTUNAUXMVUGHWEZPTVWEUYKXOEYBYCVUH
      VWSVWDUYLTVUHUXMVWSVWDNVXCPVWDEVXBWGQUUHVUHUYLVWRUUIUUKUULVWBVWIFVWGUWKUW
      HVWGNUWIVWHVWAEUWHVWGWIWJWKWOUYMVVSVWBFUWKUYMVVRVWAUWIUYCUYLVVQUUMYEXBVOV
      PUUNUUOUWOVVTJVVRUYCVVQYSUWMVVRNUWNVVSFUWKUWMVVRUWIXFXBXEYKVDLUUPMNAYPUNT
      LUUQMNAYQUNABUWPVDUXTVWMWRUYGUYCUYETSZUWINZFUWKOZVXDUWPKAAUYDUYNUYFUYRVXF
      UYSVUBVUEAUYNUYRVXFAUYMUYRVXFXRZUCUWKVUHVXGUYMUYRUYLUYETSZUWINZFUWKOZXRVU
      HUYQVXJUDUWKVUMVXJUYQUYLUYPTSZUWINZFUWKOZVUMUYKUYOVWFSZUWKKVXKEVXNMZNZVXM
      VUMJUABUYKUYOVUTVVAVVFVUHVVCVWNVULVWOXLYRVUMVXOVXKVUMVVGVVHVVIUXMVXOVXKNV
      VMVVNVVOVVPPTUYKUYOXOEYBYCWHVXLVXPFVXNUWKUWHVXNNUWIVXOVXKEUWHVXNWIWJWKWOU
      YQVXIVXLFUWKUYQVXHVXKUWIUYEUYPUYLTYDYEXBVOVPUYMVXFVXJUYRUYMVXEVXIFUWKUYMV
      XDVXHUWIUYCUYLUYETYFYEXBYGVOVPYIYHUWOVXFJVXDUYCUYETYJUWMVXDNUWNVXEFUWKUWM
      VXDUWIXFXBXEYKUWQUURABUWCUWPUXTAEUWPAEUWPKZEUWINZFUWKOZAYTUWKKZEEYTMZNZVX
      SAUXBVWLVXTUXCVWMBUVAWOAVYAEUVBPUUSZMZEEYTVYCUUTUVCAUXMVYDENHPEUVDQUVEVXR
      VYBFYTUWKUWHYTNUWIVYAEEUWHYTWIWJWKWOAUXMVXQVXSUVFHUWOVXSJEPUWMENUWNVXRFUW
      KUWMEUWIXFXBUVGQUVHUSUTUVIUVLUWOUWLJDUWJDXOKZFUWKUWJVYEUWIXOKEUWHYSDUWIXO
      VNUVJUVKUWMDNUWNUWJFUWKUWMDUWIXFXBUVMUVNAUWJUWGFUWKUXKUWGUWJUWIUWFKUXKBUW
      HUWFEAUWFUWTKUXJAUWDPLUWFUWEUWQUWSUXDUXEUXFUVOWEAUXJXIAEUWFKUXJAUWCUWFEAB
      UWCUWFAUWDPLUWFUWEUWQUWSUXDUXEUXFUVPZUVQAUXMEUWCKHEPUVRQWRWEABUWFURUXJABU
      WCUWFVYFUVSWEUVTDUWIUWFVNVOVPUWAUWB $.
  $}

  ${
    $d ph i j $.  $d F i $.  $d S i j $.  $d K i j $.  $d B j k $.  $d i j k $.
    flcidc.f $e |- ( ph -> F = ( j e. S |-> if ( j = K , 1 , 0 ) ) ) $.
    flcidc.s $e |- ( ph -> S e. Fin ) $.
    flcidc.k $e |- ( ph -> K e. S ) $.
    flcidc.b $e |- ( ( ph /\ i e. S ) -> B e. CC ) $.
    $( Finite linear combinations with an indicator function.  (Contributed by
       Stefan O'Rear, 5-Dec-2014.) $)
    flcidc $p |- ( ph -> sum_ i e. S ( ( F ` i ) x. B ) = [_ K / i ]_ B ) $=
      ( cmul wcel wa c1 wceq cc0 syl eqtrd cc csn cv cfv co csu csb cmpt fveq1d
      cif adantr snssd sselda eqeq1 ifbid eqid 1ex c0ex ifex fvmpt elsni iftrue
      adantl oveq1d syldan sumeq2dv ax-1cn 0cn keepel syl6eqel mulcld eldifi wn
      mulid2d cdif eldifn elsn sylnib iffalse mul02d fsumss eleq1 anbi2d csbeq1
      eleq1d imbi12d nfv nfcsb1v nfel1 nfim csbeq1a chvar vtoclg anabsi7 sumsns
      wi mpdan syl2anc 3eqtr3d ) AGUAZDUBZFUCZBLUDZDUEWSBDUEZCXBDUEDGBUFZAWSXBB
      DAWTWSMZNZXBOBLUDBXFXAOBLXFXAWTGPZOQUIZOXFXAWTECEUBZGPZOQUIZUGZUCZXHAXAXM
      PZXEAWTFXLHUHZUJXFWTCMZXMXHPZAWSCWTAGCJUKZULZEWTXKXHCXLXIWTPXJXGOQXIWTGUM
      UNXLUOXGOQUPUQURUSZRSZXEXHOPZAXEXGYBWTGUTXGOQVARVBSVCXFBAXEXPBTMZXSKVDZVM
      SVEAWSCXBDXRXFXABXFXAXHTYAXGOQTVFVGVHVIYDVJAWTCWSVNMZNZXBQBLUDQYFXAQBLYFX
      AXHQYFXAXMXHAXNYEXOUJYFXPXQYEXPAWTCWSVKVBZXTRSYEXHQPZAYEXGVLYHYEXEXGWTCWS
      VODGVPVQXGOQVRRVBSVCYFBAYEXPYCYGKVDVSSIVTAGCMZXDTMZXCXDPJAYIYJJAYIYJAXICM
      ZNZDXIBUFZTMZWOZAYINZYJWOEGCXJYLYPYNYJXJYKYIAXIGCWAWBXJYMXDTDXIGBWCWDWEAX
      PNZYCWOYODEYLYNDYLDWFDYMTDXIBWGWHWIWTXIPZYQYLYCYNYRXPYKAWTXICWAWBYRBYMTDX
      IBWJWDWEKWKWLWMWPBDGCWNWQWR $.
  $}

  $(
  @{
    @d ph i a b c @.  @d B i a b c @.  @d G i a b c @.  @d F i a b c @.
    cnplyspn.b @e |- ( ph -> B e. ( SubRing ` CCfld ) ) @.
    cnplyspn.a @e |- ( ph -> A = ( ( subringAlg ` CCfld ) ` B ) ) @.
    cnplyspn.s @e |- ( ph -> S = ( ( LSpan ` A ) ` ran F ) ) @.
    cnplyspn.f @e |- ( ph -> F = ( j e. ( 0 ... ( K - 1 ) ) |-> ( R ^ j ) ) )
        @.
    @( Finite spans of powers are the values of limited-degree polynomials. @)
    cnplyspn @p |- ( ph -> ( X e. S <->
        E. f e. ( B Poly< K ) X = ( f ` R ) ) ) @=
      ? @.
  @}

    @( TODO @)
    @( Finite spans in terms of limited degree polynomials. @)
    @( Patch monic definition into itgo. @)
    @( Transitivity of finite spans. @)
    @( Forward itgofg. @)
    @( Reverse using ac6sfi. @)
    @( itgofg2 and lemmas @)
    @( start on Noetherian @)

  @{
    Xitgofglem5.b @e |- ( ph -> B e. ( SubRing ` CCfld ) ) @.
    Xitgofglem5.x @e |- ( ph -> X e. CC ) @.
    Xitgofglem5.u @e |- ( ph -> U e. ( Poly ` B ) ) @.
    Xitgofglem5.d @e |- ( ph -> D e. NN0 ) @.
    Xitgofglem5.d2 @e |- ( ph -> ( deg ` U ) < D ) @.
    Xitgofglem5.a @e |- A = ( ( subringAlg ` CCfld ) ` B ) @.
    Xitgofglem5.q @e |- Q = { x | E. i e. ( 0 ... ( D - 1 ) ) x = ( X ^ i ) }
        @.
    @( Lemma for ~ itgofg .  The span of the first ` D ` powers of ` X `
       contains all evaluations of polynomials with degree at most ` D ` . @)
    Xitgofglem5 @p |- ( ph -> ( U ` X ) e. ( ( LSpan ` A ) ` Q ) ) @=
      ? @.
  @}

  @{
    Xitgofglem4.b @e |- ( ph -> B e. ( SubRing ` CCfld ) ) @.
    Xitgofglem4.p @e |- ( ph -> P e. ( Monic ` B ) ) @.
    Xitgofglem4.x @e |- ( ph -> X e. CC ) @.
    Xitgofglem4.x0 @e |- ( ph -> ( P ` X ) = 0 ) @.
    Xitgofglem4.u @e |- ( ph -> U e. ( Poly ` B ) ) @.
    Xitgofglem4.f @e |- A = ( ( subringAlg ` CCfld ) ` B ) @.
    Xitgofglem4.g @e |- Q = { x | E. i e. ( 0 ... ( ( deg ` P ) - 1 ) )
        x = ( X ^ i ) } @.
    @( Lemma for ~ itgofg .  Use the polynomial identity to inductively prove
       that the span of Q contains all polynomial evaluations. @)
    Xitgofglem4 @p |- ( ph -> ( U ` X ) e. ( ( LSpan ` A ) ` Q ) ) @=
      ? @.
  @}

  @{
    Xitgofglem3.a @e |- ( ph -> B e. ( SubRing ` CCfld ) ) @.
    Xitgofglem3.b @e |- ( ph -> P e. ( Monic ` B ) ) @.
    Xitgofglem3.c @e |- ( ph -> X e. CC ) @.
    Xitgofglem3.d @e |- ( ph -> ( P ` X ) = 0 ) @.
    Xitgofglem3.e @e |- S = ( ( RingSpan ` CCfld ) ` ( B u. { X } ) ) @.
    Xitgofglem3.f @e |- A = ( ( subringAlg ` ( CCfld |` S ) ) ` B ) @.
    Xitgofglem3.g @e |- Q = { x | E. i e. ( 0 ... ( deg ` P ) )
        x = ( X ^ i ) } @.
    @( Lemma for ~ itgofg .  Given a polynomial witnessing the integrality of
       ` X ` , demonstrate the finite generation of ` A ` . @)
    Xitgofglem3 @p |- ( ph -> ( ( LSpan ` A ) ` Q ) = S ) @=
      ? @.
  @}

  @{
    Xitgofg.s @e |- S = ( ( RingSpan ` CCfld ) ` ( B u. { X } ) ) @.
    Xitgofg.a @e |- A = ( ( subringAlg ` ( CCfld |` S ) ) ` B ) @.
    @( Lemma for ~ itgofg . @)
    Xitgofglem2 @p |- ( ( B e. ( SubRing ` CCfld ) /\ A e. LFinGen ) ->
          X e. ( IntgOver ` B ) ) @=
      ? @.

    @( Lemma for ~ itgofg . @)
    Xitgofglem1 @p |- ( ( B e. ( SubRing ` CCfld ) /\ X e. ( IntgOver ` B ) )
        ->
          A e. LFinGen ) @=
      ? @.

    @( An element is finitely generated over a ring if and only adjoining it to
       the base ring results in a finitely spanned algebra.

       Both directions:  The ring span of a ring R and a singleton is the
       R-linear span of the powers of the singleton.  It is also the set of
       values of R-polynomials evaluated at the singleton.

       Forward:  If X is algebraic, it is the root of a monic polynomial P with
       degree D. The span of the finite set of powers (X^0 ...  X^D) is
       finitely spanned, and it is equal to the span of all the powers: it is a
       subset because the ring span is a ring which contains all the powers,
       and it also a superset, because it is a linear subspace that contains
       all of the powers (by induction).

       Reverse:  Suppose the ring of polynomial values is finitely spanned,
       that is, there is a finite set of polynomials P(i) such that any linear
       subspace that contains P(i)(X) contains all polynomials of X. Let N be
       one more than the supremum of the degrees of P(i).  By assumption (X^N)
       is in the span of P(i)(X), so there is an R-linear combination of
       P(i)(X) equal to (X^N); but an R-linear combination of R-polynomials
       with degree less than N is an R-polynomial with degree less than N, so
       let Q be an R-polynomial such that Q(X) = (X^N) and deg(Q) < N. Then
       (X^N) - Q(X) is a monic R-polynomial with X as a root, i.e.  X is
       algebraic. @)
    itgofg @p |- ( B e. ( SubRing ` CCfld ) -> ( X e. ( IntgOver ` B ) <->
          A e. LFinGen ) ) @=
      ? @.
  @}

  @{
    rgspnchn.r @e |- ( ph -> R e. Ring ) @.
    rgspnchn.s @e |- ( ph -> S = ( RingSpan ` R ) ) @.
    rgspnchn.b @e |- ( ph -> B = ( Base ` R ) ) @.
    rgspnchn.x @e |- ( ph -> X C_ B ) @.
    rgspnchn.a @e |- ( ph -> A C_ B ) @.
    @( Chaining lemma for ring spans. @)
    rgspnchn @p |- ( ph -> ( R ` ( ( R ` X ) u. A ) ) = ( R ` ( X u. A ) ) ) @=
      ? @.
  @}

  @{
    itgofg2.ba @e |- ( ph -> B e. ( SubRing ` CCfld ) ) @.
    itgofg2.fi @e |- ( ph -> F e. Fin ) @.
    itgofg2.ss @e |- ( ph -> F C_ ( IntgOver ` B ) ) @.
    itgofg2.sp @e |- ( ph -> S = ( ( RingSpan ` CCfld ) ` ( B u. F ) ) ) @.
    itgofg2.al @e |- ( ph -> A = ( ( subringAlg ` ( CCfld |` S ) ) ` B ) ) @.
    @( Adjoining finitely many integral elements to a ring still gives a finite
       extension. @)
    itgofg2 @p |- ( ph -> A e. LFinGen ) @=
      ? @.
  @}

  @{
    itgocllem.a @e |- S = ( ( RingSpan ` CCfld ) ` ( R u. { X } ) ) @.
    itgocllem.b @e |- T = ( ( RingSpan ` CCfld ) ` ( S u. { Y } ) ) @.
    itgocllem.c @e |- A = ( ( subringAlg ` ( CCfld |` S ) ) ` R ) @.
    itgocllem.d @e |- B = ( ( subringAlg ` ( CCfld |` T ) ) ` S ) @.
    itgocllem.e @e |- C = ( ( subringAlg ` ( CCfld |` T ) ) ` R ) @.
    itgocllem.f @e |- Z e. { ( X + Y ) , ( X x. Y ) } @.
    @( Integrality is transitive(?). @)
    itgocllem @p |- ( ( R e. ( SubRing ` CCfld ) /\ X e. ( IntgOver ` R ) /\
          Y e. ( IntgOver ` R ) ) -> Z e. ( IntgOver ` R ) ) @=
      ? @.
  @}
  $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Finite cardinality [SO]
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( A singleton contains its sole element.  (Contributed by Stefan O'Rear,
     16-Aug-2015.) $)
  en1uniel $p |- ( S ~~ 1o -> U. S e. S ) $=
    ( c1o cen wbr cuni csn cvv wcel relen brrelexi uniexg 3syl wceq en1b biimpi
    snidg eleqtrrd ) ABCDZAEZSFZARAGHSGHSTHABCIJAGKSGPLRATMANOQ $.

  $( Express a set of pair cardinality as the unordered pair of a given element
     and the other element.  (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
  en2eleq $p |- ( ( X e. P /\ P ~~ 2o ) -> P = { X , U. ( P \ { X } ) } ) $=
    ( wcel c2o cen wbr wa csn cdif cuni cpr cfn wss wceq com adantl wne syl3anc
    c1o syl2anc 2onn nnfi ax-mp enfi mpbiri simpl csuc a1i simpr df-2o syl6breq
    dif1en en1uniel syl eldifsn sylib simpld prssi simprd necomd pr2nelem ensym
    1onn entr fisseneq eqcomd ) BACZADEFZGZBABHIZJZKZAVIALCZVLAMZVLAEFZVLANVHVM
    VGVHVMDLCZDOCVPUADUBUCADUDUEPVIVGVKACZVNVGVHUFZVIVQVKBQZVIVKVJCZVQVSGVIVJSE
    FZVTVISOCZASUGZEFVGWAWBVIVCUHVIADWCEVGVHUIUJUKVRASBULRVJUMUNVKABUOUPZUQZBVK
    AURTVIVLDEFZDAEFZVOVIVGVQBVKQWFVRWEVIVKBVIVQVSWDUSUTBVKAAVARVHWGVGADVBPVLDA
    VDTVLAVERVF $.

  $( Taking the other element twice in a pair gets back to the original
     element.  (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
  en2other2 $p |- ( ( X e. P /\ P ~~ 2o ) ->
      U. ( P \ { U. ( P \ { X } ) } ) = X ) $=
    ( wcel c2o cen wbr csn cdif cuni cpr en2eleq prcom syl6eq difeq1d difprsnss
    wa syl6eqss wne simpl c1o com csuc 1onn simpr df-2o syl6breq dif1en syl3anc
    a1i en1uniel eldifsni 3syl necomd eldifsn sylanbrc snssd unieqd wceq unisng
    eqssd adantr eqtrd ) BACZADEFZPZAABGZHZIZGZHZIVFIZBVEVJVFVEVJVFVEVJVHBJZVIH
    VFVEAVLVIVEABVHJVLABKBVHLMNVHBOQVEBVJVEVCBVHRBVJCVCVDSZVEVHBVEVGTEFZVHVGCVH
    BRVETUACZATUBZEFVCVNVOVEUCUIVEADVPEVCVDUDUEUFVMATBUGUHVGUJVHABUKULUMBAVHUNU
    OUPUTUQVCVKBURVDBAUSVAVB $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Words in monoids and ordered group sum
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  One important use of words is as formal composites in cases where order is
  significant, using the general sum operator ~ df-gsum .  If order is not
  significant, it is simpler to use families instead.

$)

  ${
    $d x y z B $.  $d x y M $.  $d x y ph $.  $d x y ps $.  $d z .+ $.
    $d z .0. $.  $d z ch $.  $d z et $.  $d z ta $.  $d z th $.
    issubmd.b $e |- B = ( Base ` M ) $.
    issubmd.p $e |- .+ = ( +g ` M ) $.
    issubmd.z $e |- .0. = ( 0g ` M ) $.
    issubmd.m $e |- ( ph -> M e. Mnd ) $.
    issubmd.cz $e |- ( ph -> ch ) $.
    issubmd.cp $e |- ( ( ph /\ ( ( x e. B /\ y e. B ) /\
          ( th /\ ta ) ) ) -> et ) $.
    issubmd.ch $e |- ( z = .0. -> ( ps <-> ch ) ) $.
    issubmd.th $e |- ( z = x -> ( ps <-> th ) ) $.
    issubmd.ta $e |- ( z = y -> ( ps <-> ta ) ) $.
    issubmd.et $e |- ( z = ( x .+ y ) -> ( ps <-> et ) ) $.
    $( Deduction for proving a submonoid.  (Contributed by Stefan O'Rear,
       23-Aug-2015.)  (Revised by Stefan O'Rear, 5-Sep-2015.) $)
    issubmd $p |- ( ph -> { z e. B | ps } e. ( SubMnd ` M ) ) $=
      ( crab csubmnd cfv wcel wss cv co wral ssrab2 cmnd mndidcl elrab sylanbrc
      a1i syl anbi12i adantr simprll simprrl syl3anc an4 sylan2b ralrimivva w3a
      wa mndcl wb issubm mpbir3and ) ABIJUDZLUEUFUGZVMJUHZMVMUGZGUIZHUIZKUJZVMU
      GZHVMUKGVMUKZVOABIJULUQAMJUGZCVPALUMUGZWBQJLMNPUNURRBCIMJTUOUPAVTGHVMVMVQ
      VMUGZVRVMUGZVHAVQJUGZDVHZVRJUGZEVHZVHZVTWDWGWEWIBDIVQJUAUOBEIVRJUBUOUSAWJ
      VHZVSJUGZFVTWKWCWFWHWLAWCWJQUTAWFDWIVAAWGWHEVBJKLVQVRNOVIVCWJAWFWHVHDEVHV
      HFWFDWHEVDSVEBFIVSJUCUOUPVEVFAWCVNVOVPWAVGVJQGHJKVMLMNPOVKURVL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Transpositions in the symmetric group
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c pmTrsp $.
  $( Syntax for the transposition generator function. $)
  cpmtr $a class pmTrsp $.

  ${
    $d d p y z $.
    $( Define a function that generates the transpositions on a set.
       (Contributed by Stefan O'Rear, 16-Aug-2015.) $)
    df-pmtr $a |- pmTrsp = ( d e. _V |->
        ( p e. { y e. ~P d | y ~~ 2o } |-> ( z e. d |->
            if ( z e. p , U. ( p \ { z } ) , z ) ) ) ) $.
  $}

  ${
    $d x y F $.  $d x y A $.  $d x y G $.
    $( A permutation of any class moves a point which is moved to a different
       point which is moved.  (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
    f1omvdmvd $p |- ( ( F : A -1-1-onto-> A /\ X e. dom ( F \ _I ) ) ->
        ( F ` X ) e. ( dom ( F \ _I ) \ { X } ) ) $=
      ( wf1o cid cdif cdm wcel wa cfv wne csn simpr adantr fnelnfp syl2anc wceq
      wb wss mpbird wfn f1ofn difss ax-mp f1odm syl5sseq sselda mpbid wf1 f1of1
      dmss wf f1of ffvelrnd f1fveq syl12anc necon3bid eldifsn sylanbrc ) AABDZC
      BEFZGZHZIZCBJZVBHZVECKZVEVBCLFHVDVFVEBJZVEKZVDVIVGVDVCVGUTVCMVDBAUAZCAHZV
      CVGRUTVJVCAABUBNZUTVBACUTBGZVBAVABSVBVMSBEUCVABUKUDAABUEUFUGZABCOPUHZVDVH
      VEVECVDAABUIZVEAHZVKVHVEQVECQRUTVPVCAABUJNVDAACBUTAABULVCAABUMNVNUNZVNAAV
      ECBUOUPUQTVDVJVQVFVIRVLVRABVEOPTVOVEVBCURUS $.

    $( A permutation and its inverse move the same points.  (Contributed by
       Stefan O'Rear, 22-Aug-2015.) $)
    f1omvdcnv $p |- ( F : A -1-1-onto-> A
        -> dom ( `' F \ _I ) = dom ( F \ _I ) ) $=
      ( vx wf1o cv ccnv cfv wne crab cid cdif cdm wcel wa wceq wb f1ocnvfvb wfn
      f1ofn fndifnfp 3anidm23 bicomd necon3bid rabbidva f1ocnv 3syl syl 3eqtr4d
      ) AABDZCEZBFZGZUJHZCAIZUJBGZUJHZCAIZUKJKLZBJKLZUIUMUPCAUIUJAMZNZULUJUOUJV
      AUOUJOZULUJOZUIUTVBVCPAAUJUJBQUAUBUCUDUIAAUKDUKARURUNOAABUEAAUKSCAUKTUFUI
      BARUSUQOAABSCABTUGUH $.

    $( Composing two permutations moves at most the union of the points.
       (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
    mvdco $p |- dom ( ( F o. G ) \ _I )
        C_ ( dom ( F \ _I ) u. dom ( G \ _I ) ) $=
      ( ccom cid cdif cdm cin cun inundif coeq2i coundi difeq1i eqtri wss ax-mp
      eqtr3i ccnv eqsstri sstri dmss dmeqi dmun inss2 coss2 cocnvcnv1 wrel wceq
      difundir relcnv coi1 cnvcnvss ssdif mp2b difss dmcoss unss12 mp2an ) ABCZ
      DEZFZABDGZCZDEZFZABDEZCZDEZFZHZADEZFZVEFZHZUTVCVGHZFVIUSVNUSVBVFHZDEVNURV
      ODAVAVEHZCURVOVPBABDIJAVAVEKPLVBVFDUHMUAVCVGUBMVDVKNZVHVLNVIVMNVBANVCVJNV
      QVBADCZAVADNVBVRNBDUCVADAUDOVRAQZQZAVTDCZVRVTADUEVTUFWAVTUGVSUIVTUJOPAUKR
      SVBADULVCVJTUMVHVFFZVLVGVFNVHWBNVFDUNVGVFTOAVEUOSVDVKVHVLUPUQR $.

    $( Conjugation of a permutation takes the image of the moved subclass.
       (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
    f1omvdconj $p |- ( ( F : A --> A /\ G : A -1-1-onto-> A )
        -> dom ( ( ( G o. F ) o. `' G ) \ _I ) = ( G " dom ( F \ _I ) ) ) $=
      ( vx wf wf1o wa ccom cid cdm wss wceq syl wcel cfv wne wfn syl2anc sylan
      wb ccnv cdif cima cv difss dmss ax-mp dmcoss sstri f1ocnv adantl syl5sseq
      f1odm sselda crn imassrn f1of frn syl5ss simpl fco fnelnfp f1ofn ad2antrr
      fvco2 ffvelrn eqtrd eqeq1d simplr simpr f1ocnvfvb syl3anc bitrd necon3bid
      ffn simpll necom wf1 f1of1 ad2antlr fdm f1elima f1ocnvfv2 eleq1d 3bitr3rd
      adantll syl5bb 3bitrd eqrdav ) AABEZAACFZGZDCBHZCUAZHZIUBZJZCBIUBZJZUCZAW
      LWQADUDZWLWNJZWQAWQWOJZXBWPWOKWQXCKWOIUEWPWOUFUGWMWNUHUIWLAAWNFZXBALWKXDW
      JAACUJUKZAAWNUMMULUNWLWTAXAWLWTCUOZACWSUPWLAACEZXFAKWKXGWJAACUQUKZAACURMU
      SUNWLXAANZGZXAWQNZXAWOOZXAPZXAWNOZXNBOZPZXAWTNZWLWOAQZXIXKXMTWLAAWOEZXRWL
      AAWMEZAAWNEZXSWLXGWJXTXHWJWKUTAAACBVARWLXDYAXEAAWNUQMZAAAWMWNVARAAWOVOMAW
      OXAVBSXJXLXAXNXOXJXLXALXOCOZXALZXNXOLZXJXLYCXAXJXLXNWMOZYCWLWNAQZXIXLYFLW
      LXDYGXEAAWNVCMAWMWNXAVESXJBAQZXNANZYFYCLWJYHWKXIAABVOVDZWLYAXIYIYBAAXAWNV
      FSZACBXNVERVGVHXJWKXOANZXIYDYETWJWKXIVIXJWJYIYLWJWKXIVPYKAAXNBVFRWLXIVJAA
      XOXACVKVLVMVNXPXOXNPZXJXQXNXOVQXJXNCOZWTNZXNWSNZXQYMXJAACVRZYIWSAKZYOYPTW
      KYQWJXIAACVSVTYKWJYRWKXIWJBJZWSAWRBKWSYSKBIUEWRBUFUGAABWAULVDAACXNWSWBVLX
      JYNXAWTWKXIYNXALWJAAXACWCWFWDXJYHYIYPYMTYJYKABXNVBRWEWGWHWI $.

    $( A transposition is characterized by the points it moves.  (Contributed
       by Stefan O'Rear, 22-Aug-2015.) $)
    f1otrspeq $p |- ( ( ( F : A -1-1-onto-> A /\ G : A -1-1-onto-> A ) /\
          ( dom ( F \ _I ) ~~ 2o /\ dom ( G \ _I ) = dom ( F \ _I ) ) ) ->
        F = G ) $=
      ( vx vy wf1o wa cid cdif cdm c2o cen wbr wceq wfn wcel c1o wb sylan cvv
      f1ofn ad2antrr ad2antlr cv cfv csn wmo com csuc a1i simplrr simplrl df-2o
      1onn syl6breq eqbrtrd simpr dif1en syl3anc weu euen1b sylbi syl f1omvdmvd
      eumo wi eleq2 ad2antll difeq1 eleq2d 3imtr4d imp simplr fvex pm3.2i eleq1
      ex moi mp3an1 syl12anc adantlr wn fnelnfp bitrd necon2bbid biimpar eqtr4d
      wne pm2.61dan eqfnfvd ) AABFZAACFZGZBHIJZKLMZCHIJZWNNZGZGZDABCWKBAOZWLWRA
      ABUAUBZWLCAOZWKWRAACUAUCZWSDUDZAPZGZXDWPPZXDBUEZXDCUEZNZWSXGXJXEWSXGGZEUD
      ZWPXDUFZIZPZEUGZXHXNPZXIXNPZXJXKXNQLMZXPXKQUHPZWPQUIZLMXGXSXTXKUNUJXKWPWN
      YALWMWOWQXGUKXKWNKYALWMWOWQXGULUMUOUPWSXGUQWPQXDURUSXSXOEUTXPEXNVAXOEVEVB
      VCWSXGXQWSXDWNPZXHWNXMIZPZXGXQWKYBYDVFWLWRWKYBYDABXDVDVQUBWQXGYBRWMWOWPWN
      XDVGVHWQXQYDRWMWOWQXNYCXHWPWNXMVIVJVHVKVLWSWLXGXRWKWLWRVMACXDVDSXHTPZXITP
      ZGXPXQXRGXJYEYFXDBVNXDCVNVOXOXQXREXHXITTXLXHXNVPXLXIXNVPVRVSVTWAXFXGWBZGX
      HXDXIXFXHXDNYGXFXGXHXDXFXGYBXHXDWHZXFWPWNXDWMWOWQXEUKVJWSWTXEYBYHRXAABXDW
      CSWDWEWFXFXIXDNYGXFXGXIXDWSXBXEXGXIXDWHRXCACXDWCSWEWFWGWIWJ $.

    $( If exactly one of two permutations is limited to a set of points, then
       the composition will not be.  (Contributed by Stefan O'Rear,
       23-Aug-2015.) $)
    f1omvdco2 $p |- ( ( F : A -1-1-onto-> A /\ G : A -1-1-onto-> A /\
          ( dom ( F \ _I ) C_ X \/_ dom ( G \ _I ) C_ X ) ) ->
        -. dom ( ( F o. G ) \ _I ) C_ X ) $=
      ( wf1o cid cdif cdm wss ccom wn wa ccnv wceq coass f1of syl difeq1d dmeqd
      wf wxo wo excxor f1ococnv1 coeq1d fcoi2 sylan9eq syl5eqr adantr cun mvdco
      cres f1omvdcnv ad2antrr simprl eqsstrd simprr unssd syl5ss eqsstr3d con3d
      expr expimpd f1ococnv2 coeq2d fcoi1 sylan9eqr syl5eq ad2antlr jaod syl5bi
      ancomsd 3impia ) AABEZAACEZBFGZHZDIZCFGZHZDIZUAZBCJZFGHZDIZKZWBVRWAKZLZVR
      KZWALZUBVNVOLZWFVRWAUCWKWHWFWJWKVRWGWFWKVRLWEWAWKVRWEWAWKVRWELZLZVTBMZWCJ
      ZFGZHZDWKWQVTNWLWKWPVSWKWOCFWKWOWNBJZCJZCWNBCOVNVOWSFAULZCJZCVNWRWTCAABUD
      UEVOAACTXACNAACPAACUFQUGUHRSUIWMWQWNFGHZWDUJDWNWCUKWMXBWDDWMXBVQDVNXBVQNV
      OWLABUMUNWKVRWEUOUPWKVRWEUQURUSUTVBVAVCWKWAWIWFWKWAWIWFWKWALWEVRWKWAWEVRW
      KWAWELZLZVQWCCMZJZFGZHZDWKXHVQNXCWKXGVPWKXFBFWKXFBCXEJZJZBBCXEOVOVNXJBWTJ
      ZBVOXIWTBAACVDVEVNAABTXKBNAABPAABVFQVGVHRSUIXDXHWDXEFGHZUJDWCXEUKXDWDXLDW
      KWAWEUQXDXLVTDVOXLVTNVNXCACUMVIWKWAWEUOUPURUSUTVBVAVCVLVJVKVM $.

    $( If a point is moved by exactly one of two permutations, then it will be
       moved by their composite.  (Contributed by Stefan O'Rear,
       23-Aug-2015.) $)
    f1omvdco3 $p |- ( ( F : A -1-1-onto-> A /\ G : A -1-1-onto-> A /\
          ( X e. dom ( F \ _I ) \/_ X e. dom ( G \ _I ) ) ) ->
        X e. dom ( ( F o. G ) \ _I ) ) $=
      ( cid cdif cdm wcel wxo wf1o wss wb wn c0 wceq disjsn disj2 bitr3i df-xor
      cin cvv csn ccom notbi bibi12i bitri notbii 3bitr4i w3a f1omvdco2 con2bii
      sylibr syl3an3b ) DBEFGZHZDCEFGZHZIZAABJZAACJZUNUADUBZFZKZUPVBKZIZDBCUCEF
      GZHZUOUQLZMVCVDLZMURVEVHVIVHUOMZUQMZLVIUOUQUDVJVCVKVDVJUNVATNOVCUNDPUNVAQ
      RVKUPVATNOVDUPDPUPVAQRUEUFUGUOUQSVCVDSUHUSUTVEUIVFVBKZMVGABCVBUJVLVGVLVFV
      ATNOVGMVFVAQVFDPRUKULUM $.
  $}

  ${
    $d d p y z D $.  $d d p y z T $.  $d p y z P $.  $d z Z $.  $d z V $.
    pmtrfval.t $e |- T = ( pmTrsp ` D ) $.
    $( The function generating transpositions on a set.  (Contributed by Stefan
       O'Rear, 16-Aug-2015.) $)
    pmtrfval $p |- ( D e. V -> T = ( p e. { y e. ~P D | y ~~ 2o } |->
            ( z e. D |-> if ( z e. p , U. ( p \ { z } ) , z ) ) ) ) $=
      ( vd wcel cpmtr cfv cv c2o cen cpw crab cmpt cvv wceq syl cdif cuni rabeq
      wbr csn cif elex pweq mpteq1 mpteq12dv df-pmtr rabex mptex fvmpt3i syl5eq
      vex pwex ) CEIZDCJKZFALMNUDZACOZPZBCBLZFLZIVDVCUEUAUBVCUFZQZQZGURCRIUSVGS
      CEUGHCFUTAHLZOZPZBVHVEQZQVGRJVHCSZFVJVKVBVFVLVIVASVJVBSVHCUHUTAVIVAUCTBVH
      CVEUIUJABFHUKFVJVKUTAVIVHHUPUQULUMUNTUO $.

    $( A generated transposition, expressed in a symmetric form.  (Contributed
       by Stefan O'Rear, 16-Aug-2015.) $)
    pmtrval $p |- ( ( D e. V /\ P C_ D /\ P ~~ 2o ) -> ( T ` P ) =
        ( z e. D |-> if ( z e. P , U. ( P \ { z } ) , z ) ) ) $=
      ( vp vy wcel c2o cen wbr cfv cv cdif cuni cif cmpt wceq 3ad2ant1 wss crab
      w3a cpw csn pmtrfval fveq1d cvv elpw2g biimpar simp3 breq1 elrab sylanbrc
      3adant3 mptexg eleq2 difeq1 unieqd ifbieq12d mpteq2dv eqid fvmptg syl2anc
      eqidd eqtrd ) BEIZCBUAZCJKLZUCZCDMZCGHNZJKLZHBUDZUBZABANZGNZIZVQVPUEZOZPZ
      VPQZRZRZMZABVPCIZCVSOZPZVPQZRZVGVHVKWESVIVGCDWDHABDEGFUFUGTVJCVOIZWJUHIZW
      EWJSVJCVNIZVIWKVGVHWMVIVGWMVHCBEUIUJUOVGVHVIUKVMVIHCVNVLCJKULUMUNVGVHWLVI
      ABWIEUPTGCWCWJVOUHWDVQCSZABWBWIWNVRWFWAVPWHVPVQCVPUQWNVTWGVQCVSURUSWNVPVE
      UTVAWDVBVCVDVF $.

    $( General value of mapping a point under a transposition.  (Contributed by
       Stefan O'Rear, 16-Aug-2015.) $)
    pmtrfv $p |- ( ( ( D e. V /\ P C_ D /\ P ~~ 2o ) /\ Z e. D ) ->
        ( ( T ` P ) ` Z ) = if ( Z e. P , U. ( P \ { Z } ) , Z ) ) $=
      ( vz wcel wss c2o cen wbr cfv csn cdif cuni cif wceq cvv syl2anc w3a cmpt
      wa cv pmtrval fveq1d adantr simpr simpl3 relen brrelexi difexg 4syl ifexg
      uniexg eleq1 sneq difeq2d unieqd id ifbieq12d eqid fvmptg eqtrd ) ADHZBAI
      ZBJKLZUAZEAHZUCZEBCMZMZEGAGUDZBHZBVMNZOZPZVMQZUBZMZEBHZBENZOZPZEQZVHVLVTR
      VIVHEVKVSGABCDFUEUFUGVJVIWESHZVTWERVHVIUHZVJWDSHZVIWFVJVGBSHWCSHWHVEVFVGV
      IUIBJKUJUKBWBSULWCSUOUMWGWAWDESAUNTGEVRWEASVSVMERZVNWAVQVMWDEVMEBUPWIVPWC
      WIVOWBBVMEUQURUSWIUTVAVSVBVCTVD $.

    $( In a transposition of two given points, each maps to the other.
       (Contributed by Stefan O'Rear, 25-Aug-2015.) $)
    pmtrprfv $p |- ( ( D e. V /\ ( X e. D /\ Y e. D /\ X =/= Y ) ) ->
        ( ( T ` { X , Y } ) ` X ) = Y ) $=
      ( wcel wne w3a wa cpr cfv csn cdif cuni cif wss wceq syl eqtrd c2o simpr1
      cen wbr simpl simpr2 prssi syl2anc pr2nelem adantl pmtrfv syl31anc prid1g
      iftrue difprsnss prid2g simpr3 necomd eldifsn sylanbrc snssd eqssd unieqd
      a1i unisng ) ACGZDAGZEAGZDEHZIZJZDDEKZBLLZDVLGZVLDMNZOZDPZEVKVFVLAQZVLUAU
      CUDZVGVMVQRVFVJUEVKVGVHVRVFVGVHVIUBZVFVGVHVIUFZDEAUGUHVJVSVFDEAAUIUJVTAVL
      BCDFUKULVKVQVPEVKVNVQVPRVKVGVNVTDEAUMSVNVPDUNSVKVPEMZOZEVKVOWBVKVOWBVOWBQ
      VKDEUOVDVKEVOVKEVLGZEDHEVOGVKVHWDWADEAUPSVKDEVFVGVHVIUQUREVLDUSUTVAVBVCVK
      VHWCERWAEAVESTTT $.

    $( Functionality of a transposition.  (Contributed by Stefan O'Rear,
       16-Aug-2015.) $)
    pmtrf $p |- ( ( D e. V /\ P C_ D /\ P ~~ 2o ) -> ( T ` P ) : D --> D ) $=
      ( vz wcel wss c2o cen wbr w3a cfv wf cv csn cdif cuni wa c1o cmpt simpll2
      cif com csuc 1onn a1i simpll3 df-2o syl6breq simpr dif1en en1uniel eldifi
      syl3anc 3syl sseldd wn simplr ifclda eqid fmptd pmtrval feq1d mpbird ) AD
      GZBAHZBIJKZLZAABCMZNAAFAFOZBGZBVKPZQZRZVKUCZUAZNVIFAVPAVQVIVKAGZSZVLVOVKA
      VSVLSZBAVOVFVGVHVRVLUBVTVNTJKZVOVNGVOBGVTTUDGZBTUEZJKVLWAWBVTUFUGVTBIWCJV
      FVGVHVRVLUHUIUJVSVLUKBTVKULUOVNUMVOBVMUNUPUQVIVRVLURUSUTVQVAVBVIAAVJVQFAB
      CDEVCVDVE $.

    $( A transposition moves precisely the transposed points.  (Contributed by
       Stefan O'Rear, 16-Aug-2015.) $)
    pmtrmvd $p |- ( ( D e. V /\ P C_ D /\ P ~~ 2o ) ->
        dom ( ( T ` P ) \ _I ) = P ) $=
      ( vz wcel wss c2o cen wbr cfv cdif wne crab cin wceq 3syl wa c1o cv pmtrf
      w3a cid cdm wf wfn ffn fndifnfp csn cif pmtrfv neeq1d wb iffalse necon1ai
      cuni iftrue adantl com csuc 1onn a1i simpl3 df-2o syl6breq dif1en syl3anc
      simpr en1uniel eldifsni eqnetrd impbid2 adantr bitrd rabbidva incom dfin5
      ex eqtri syl6eqr simp2 df-ss sylib 3eqtrd ) ADGZBAHZBIJKZUCZBCLZUDMUEZFUA
      ZWJLZWLNZFAOZBAPZBWIAAWJUFWJAUGWKWOQABCDEUBAAWJUHFAWJUIRWIWOWLBGZFAOZWPWI
      WNWQFAWIWLAGZSZWNWQBWLUJMZUQZWLUKZWLNZWQWTWMXCWLABCDWLEULUMWIXDWQUNWSWIXD
      WQWQXCWLWQXBWLUOUPWIWQXDWIWQSZXCXBWLWQXCXBQWIWQXBWLURUSXEXATJKZXBXAGXBWLN
      XETUTGZBTVAZJKWQXFXGXEVBVCXEBIXHJWFWGWHWQVDVEVFWIWQVIBTWLVGVHXAVJXBBWLVKR
      VLVSVMVNVOVPWPABPWRBAVQFABVRVTWAWIWGWPBQWFWGWHWBBAWCWDWE $.
  $}

  ${
    $d w x y z D $.  $d x y P $.  $d w x y z T $.  $d y z V $.  $d x y F $.
    $d x R $.
    pmtrrn.t $e |- T = ( pmTrsp ` D ) $.
    pmtrrn.r $e |- R = ran T $.
    $( Transposing two points gives a transposition function.  (Contributed by
       Stefan O'Rear, 22-Aug-2015.) $)
    pmtrrn $p |- ( ( D e. V /\ P C_ D /\ P ~~ 2o ) -> ( T ` P ) e. R ) $=
      ( vx vz vy wcel wss c2o cen wbr cv wfn cmpt cvv 3ad2ant1 w3a cfv crn crab
      cpw csn cdif cuni cif wral mptexg ralrimivw eqid syl wceq pmtrfval fneq1d
      fnmpt mpbird elpw2g biimpar 3adant3 simp3 breq1 sylanbrc fnfvelrn syl2anc
      elrab syl6eleqr ) AEKZBALZBMNOZUAZBDUBZDUCZCVMDHPZMNOZHAUEZUDZQZBVSKZVNVO
      KVMVTIVSJAJPZIPZKWCWBUFUGUHWBUIZRZRZVSQZVMWESKZIVSUJZWGVJVKWIVLVJWHIVSJAW
      DEUKULTIVSWEWFSWFUMURUNVMVSDWFVJVKDWFUOVLHJADEIFUPTUQUSVMBVRKZVLWAVJVKWJV
      LVJWJVKBAEUTVAVBVJVKVLVCVQVLHBVRVPBMNVDVHVEVSBDVFVGGVI $.

    ${
      pmtrfrn.p $e |- P = dom ( F \ _I ) $.
      $( A transposition (as a kind of function) is the function transposing
         the two points it moves.  (Contributed by Stefan O'Rear,
         22-Aug-2015.) $)
      pmtrfrn $p |- ( F e. R -> ( ( D e. _V /\ P C_ D /\ P ~~ 2o ) /\
            F = ( T ` P ) ) ) $=
        ( vy vx vw vz cvv wcel c2o cen wbr cfv wceq c0 wss w3a wa wn noel cpmtr
        crn fvprc syl5eq rneqd rn0 syl6eq eleq2d mtbiri con4i cpw wrex crab wfn
        cv csn cdif cuni cif cmpt wral mptexg ralrimivw eqid fnmpt syl pmtrfval
        wb fneq1d mpbird fvelrnb eleq2i breq1 rexrab bicomi 3bitr4g elpwi simp1
        wi cid cdm pmtrmvd simp2 eqsstrd simp3 eqbrtrd eqcomd fveq2d jca difeq1
        3jca dmeqd syl6eqr sseq1 3anbi23d simpl fveq2 eqeq12d anbi12d syl5ibcom
        adantl mpdan 3exp imp4a syl5 rexlimdv sylbid mpcom ) AMNZECNZXNBAUAZBOP
        QZUBZEBDRZSZUCZXNXOXNUDZXOETNEUEYBCTEYBCDUGZTGYBYCTUGTYBDTYBDAUFRTFAUFU
        HUIUJUKULUIUMUNUOXNXOIUTZOPQZYDDRZESZUCZIAUPZUQZYAXNEYCNZYGIJUTZOPQZJYI
        URZUQZXOYJXNDYNUSZYKYOVMXNYPKYNLALUTZKUTZNYRYQVAVBVCYQVDZVEZVEZYNUSZXNY
        TMNZKYNVFUUBXNUUCKYNLAYSMVGVHKYNYTUUAMUUAVIVJVKXNYNDUUAJLADMKFVLVNVOIYN
        EDVPVKCYCEGVQYOYJYMYEYGIJYIYLYDOPVRVSVTWAXNYHYAIYIYDYINYDAUAZXNYHYAWDYD
        AWBXNUUDYEYGYAXNUUDYEYGYAWDXNUUDYEUBZXNYFWEVBZWFZAUAZUUGOPQZUBZYFUUGDRZ
        SZUCZYGYAUUEUUJUULUUEXNUUHUUIXNUUDYEWCUUEUUGYDAAYDDMFWGZXNUUDYEWHWIUUEU
        UGYDOPUUNXNUUDYEWJWKWPUUEYDUUGDUUEUUGYDUUNWLWMWNYGUUGBSZUUMYAVMYGUUGEWE
        VBZWFBYGUUFUUPYFEWEWOWQHWRYGUUOUCZUUJXRUULXTUUOUUJXRVMYGUUOUUHXPUUIXQXN
        UUGBAWSUUGBOPVRWTXFUUQYFEUUKXSYGUUOXAUUOUUKXSSYGUUGBDXBXFXCXDXGXEXHXIXJ
        XKXLXM $.

      $( Mapping of a point under a transposition function.  (Contributed by
         Stefan O'Rear, 22-Aug-2015.) $)
      pmtrffv $p |- ( ( F e. R /\ Z e. D ) -> ( F ` Z ) =
          if ( Z e. P , U. ( P \ { Z } ) , Z ) ) $=
        ( wcel wa cfv csn cdif cuni cif wceq cvv wss c2o cen wbr pmtrfrn simprd
        w3a fveq1d adantr simpld pmtrfv sylan eqtrd ) ECJZFAJZKFELZFBDLZLZFBJBF
        MNOFPZULUNUPQUMULFEUOULARJBASBTUAUBUEZEUOQZABCDEGHIUCZUDUFUGULURUMUPUQQ
        ULURUSUTUHABDRFGUIUJUK $.
    $}

    $( A transposition function is an involution.  (Contributed by Stefan
       O'Rear, 22-Aug-2015.) $)
    pmtrfinv $p |- ( F e. R -> ( F o. F ) = ( _I |` D ) ) $=
      ( vx wcel wf wfn cdif cfv cen wbr wceq syl wa c1o sylan eqtrd cid cdm cvv
      ccom cres wss c2o w3a pmtrfrn simpld pmtrf simprd feq1d mpbird fco anidms
      eqid ffn 3syl fnresi a1i cv csn cif pmtrffv iftrue sylan9eq fveq2d simpll
      cuni simp2d ad2antrr csuc 1onn simp3d df-2o syl6breq simpr dif1en syl3anc
      com en1uniel eldifad sseldd syl2anc adantr en2other2 ancoms wn wb fnelnfp
      necon2bbid biimpar fveq2 id pm2.61dan fvco2 fvresi adantl 3eqtr4d eqfnfvd
      wne ) DBHZGADDUDZUAAUEZXCAADIZAAXDIZXDAJXCXFAADUAKUBZCLZIZXCAUCHZXHAUFZXH
      UGMNZUHZXJXCXNDXIOZAXHBCDEFXHUQZUIZUJZAXHCUCEUKPXCAADXIXCXNXOXQULUMUNZXFX
      GAAADDUOUPAAXDURUSXEAJXCAUTVAXCGVBZAHZQZXTDLZDLZXTXTXDLZXTXELZYBXTXHHZYDX
      TOZYBYGQZYDXHXTVCZKZVJZDLZXTYIYCYLDYBYGYCYGYLXTVDYLAXHBCDXTEFXPVEYGYLXTVF
      VGVHYIYMYLXHHZXHYLVCKVJZYLVDZXTYIXCYLAHYMYPOXCYAYGVIYIXHAYLXCXLYAYGXCXKXL
      XMXRVKVLYIYLXHYJYIYKRMNZYLYKHYIRWAHZXHRVMZMNZYGYQYRYIVNVAXCYTYAYGXCXHUGYS
      MXCXKXLXMXRVOZVPVQVLYBYGVRXHRXTVSVTYKWBPWCZWDAXHBCDYLEFXPVEWEYIYPYOXTYIYN
      YPYOOUUBYNYOYLVFPYBXMYGYOXTOZXCXMYAUUAWFYGXMUUCXHXTWGWHSTTTYBYGWIZQYCXTOZ
      YHYBUUEUUDYBYGYCXTXCDAJZYAYGYCXTXBWJXCXFUUFXSAADURPZADXTWKSWLWMUUEYDYCXTY
      CXTDWNUUEWOTPWPXCUUFYAYEYDOUUGADDXTWQSYAYFXTOXCAXTWRWSWTXA $.

    $( A transpositon moves at least one point.  (Contributed by Stefan O'Rear,
       23-Aug-2015.) $)
    pmtrfmvdn0 $p |- ( F e. R -> dom ( F \ _I ) =/= (/) ) $=
      ( wcel cid cdif cdm c0 wne c2o 2on0 cen wbr wceq wb cvv en0 simpld simp3d
      wss w3a cfv eqid pmtrfrn enen1 syl 3bitr3g necon3bid mpbiri ) DBGZDHIJZKL
      MKLNUMUNKMKUMUNKOPZMKOPZUNKQMKQUMUNMOPZUOUPRUMASGZUNAUCZUQUMURUSUQUDDUNCU
      EQAUNBCDEFUNUFUGUAUBUNMKUHUIUNTMTUJUKUL $.

    $( A transposition function is a permutation.  (Contributed by Stefan
       O'Rear, 22-Aug-2015.) $)
    pmtrff1o $p |- ( F e. R -> F : D -1-1-onto-> D ) $=
      ( wcel wf1o ccnv wceq wf ccom cid cres wa cdif cdm cfv cvv simpld wss c2o
      cen wbr w3a eqid pmtrfrn pmtrf syl simprd mpbird pmtrfinv fcof1o syl22anc
      feq1d ) DBGZAADHZDIDJZUPAADKZUSDDLMANJZUTUQUROUPUSAADMPQZCRZKZUPASGVAAUAV
      AUBUCUDUEZVCUPVDDVBJZAVABCDEFVAUFUGZTAVACSEUHUIUPAADVBUPVDVEVFUJUOUKZVGAB
      CDEFULZVHAADDUMUNT $.

    $( A transposition function is its own inverse.  (Contributed by Stefan
       O'Rear, 22-Aug-2015.) $)
    pmtrfcnv $p |- ( F e. R -> `' F = F ) $=
      ( wcel wf1o ccnv wceq wf ccom cid cres wa cdif cdm cfv cvv simprd wss c2o
      cen wbr w3a eqid pmtrfrn simpld pmtrf syl mpbird pmtrfinv fcof1o syl22anc
      feq1d ) DBGZAADHZDIDJZUPAADKZUSDDLMANJZUTUQUROUPUSAADMPQZCRZKZUPASGVAAUAV
      AUBUCUDUEZVCUPVDDVBJZAVABCDEFVAUFUGZUHAVACSEUIUJUPAADVBUPVDVEVFTUOUKZVGAB
      CDEFULZVHAADDUMUNT $.

    $( An intrinsic characterization of the transposition permutations.
       (Contributed by Stefan O'Rear, 22-Aug-2015.) $)
    pmtrfb $p |- ( F e. R <-> ( D e. _V /\ F : D -1-1-onto-> D /\
          dom ( F \ _I ) ~~ 2o ) ) $=
      ( wcel cvv wf1o cid cdif cdm c2o cen w3a wss wceq syl pmtrff1o syl3an2 wa
      wbr eqid pmtrfrn simpl1 simpl3 3jca simp2 difss dmss ax-mp f1odm syl5sseq
      cfv pmtrrn simp3 pmtrmvd f1otrspeq syl22anc eqeltrd impbii ) DBGZAHGZAADI
      ZDJKZLZMNUBZOZVBVCVDVGVBVCVFAPZVGODVFCUNZQZUAZVCAVFBCDEFVFUCUDZVCVIVGVKUE
      RABCDEFSVBVLVGVMVCVIVGVKUFRUGVHDVJBVHVDAAVJIZVGVJJKLVFQZVKVCVDVGUHVHVJBGZ
      VNVDVCVIVGVPVDDLZVFAVEDPVFVQPDJUIVEDUJUKAADULUMZAVFBCHEFUOTZABCVJEFSRVCVD
      VGUPVDVCVIVGVOVRAVFCHEUQTADVJURUSVSUTVA $.

    $( Any conjugate of a transposition is a transposition.  (Contributed by
       Stefan O'Rear, 22-Aug-2015.) $)
    pmtrfconj $p |- ( ( F e. R /\ G : D -1-1-onto-> D ) ->
        ( ( G o. F ) o. `' G ) e. R ) $=
      ( wcel wf1o cvv ccom cid cdif cdm c2o cen wbr adantr syl2anc wss wa simpr
      ccnv pmtrfb simp1bi pmtrff1o f1oco f1ocnv adantl cima wceq syl f1omvdconj
      wf f1of wf1 f1of1 difss ax-mp fdm syl5sseq ssexd f1imaeng syl3anc eqbrtrd
      dmss simp3bi entr syl3anbrc ) DBHZAAEIZUAZAJHZAAEDKZEUCZKZIZVPLMNZOPQZVPB
      HVJVMVKVJVMAADIZDLMZNZOPQZABCDFGUDZUERZVLAAVNIZAAVOIZVQVLVKVTWFVJVKUBZVJV
      TVKABCDFGUFZRAAAEDUGSVKWGVJAAEUHUIAAAVNVOUGSVLVRWBPQWCVSVLVREWBUJZWBPVLAA
      DUNZVKVRWJUKVJWKVKVJVTWKWIAADUOULRZWHADEUMSVLAAEUPZWBATZWBJHWJWBPQVKWMVJA
      AEUQUIVLWKWNWLWKDNZWBAWADTWBWOTDLURWADVFUSAADUTVAULZVLWBAJWEWPVBAAWBEJVCV
      DVEVJWCVKVJVMVTWCWDVGRVRWBOVHSABCVPFGUDVI $.
  $}

  ${
    $d x y z B $.  $d x y z G $.  $d x y z X $.  $d y z D $.  $d y z V $.
    symgsssg.g $e |- G = ( SymGrp ` D ) $.
    symgsssg.b $e |- B = ( Base ` G ) $.
    $( The symmetric group has subgroups restricting the set of non-fixed
       points.  (Contributed by Stefan O'Rear, 24-Aug-2015.) $)
    symgsssg $p |- ( D e. V ->
        { x e. B | dom ( x \ _I ) C_ X } e. ( SubGrp ` G ) ) $=
      ( wcel cid cdif cdm wss cfv dmeqd c0 wceq difeq1 sseq1d elrab crab cplusg
      vy vz cv cress c0g eqidd cbs ssrab2 sseqtri a1i cgrp symggrp eqid grpidcl
      co syl cres symgid difeq1d resss ssdif0 dmeqi dm0 eqtri eqsstri syl6eqssr
      mpbi 0ss sylanbrc wa biid w3a 3ad2ant1 simp2l simp3l grpcl syl3anc symgov
      ccom syl2anc cun mvdco simp2r simp3r unssd syl5ss eqsstrd syl3anb cminusg
      adantr grpinvcl ccnv symginv ad2antrl wf1o elsymgbas2 ibi f1omvdcnv eqtrd
      simprl simprr sylan2b issubgrpd2 ) CEIZUCUDAUEZJKZLZFMZABUAZDUBNZDXKUFUQZ
      DDUGNZXFXMUHXFXNUHXFXLUHXKDUINZMXFXKBXOXJABUJHUKULXFXNBIZXNJKZLZFMZXNXKIX
      FDUMIZXPCDEGUNZBDXNHXNUOUPURXFXRJCUSZJKZLZFXFYCXQXFYBXNJCDEGUTVAOYDPFYDPL
      PYCPYBJMYCPQJCVBYBJVCVIVDVEVFFVJVGVHXJXSAXNBXGXNQZXIXRFYEXHXQXGXNJROSTVKX
      FXFUCUEZXKIZYFBIZYFJKZLZFMZVLZUDUEZXKIYMBIZYMJKZLZFMZVLZYFYMXLUQZXKIZXFVM
      XJYKAYFBXGYFQZXIYJFUUAXHYIXGYFJROSTZXJYQAYMBXGYMQZXIYPFUUCXHYOXGYMJROSTXF
      YLYRVNZYSBIZYSJKZLZFMZYTUUDXTYHYNUUEXFYLXTYRYAVOXFYHYKYRVPZXFYLYNYQVQZBXL
      DYFYMHXLUOZVRVSUUDUUGYFYMWAZJKZLZFUUDUUFUUMUUDYSUULJUUDYHYNYSUULQUUIUUJCB
      XLDYFYMGHUUKVTWBVAOUUDUUNYJYPWCFYFYMWDUUDYJYPFXFYHYKYRWEXFYLYNYQWFWGWHWIX
      JUUHAYSBXGYSQZXIUUGFUUOXHUUFXGYSJROSTVKWJYGXFYLYFDWKNZNZXKIZUUBXFYLVLZUUQ
      BIZUUQJKZLZFMZUURUUSXTYHUUTXFXTYLYAWLXFYHYKXBBDUUPYFHUUPUOZWMWBUUSUVBYJFU
      USUVBYFWNZJKZLZYJUUSUVAUVFUUSUUQUVEJYHUUQUVEQXFYKCBYFDUUPGHUVDWOWPVAOUUSC
      CYFWQZUVGYJQYHUVHXFYKYHUVHCBYFDBGHWRWSWPCYFWTURXAXFYHYKXCWIXJUVCAUUQBXGUU
      QQZXIUVBFUVIXHUVAXGUUQJROSTVKXDYAXE $.

    $( The symmetric group has a subgroup of permutations that move finitely
       many points.  (Contributed by Stefan O'Rear, 24-Aug-2015.) $)
    symgfisg $p |- ( D e. V ->
        { x e. B | dom ( x \ _I ) e. Fin } e. ( SubGrp ` G ) ) $=
      ( wcel cv cid cdif cdm cfn cfv dmeqd c0 wceq difeq1 eleq1d elrab vy cress
      vz crab cplusg c0g eqidd cbs wss ssrab2 sseqtri cgrp symggrp eqid grpidcl
      co a1i syl cres symgid difeq1d resss ssdif0 mpbi dmeqi eqtri 0fin eqeltri
      dm0 syl6eqelr sylanbrc biid w3a 3ad2ant1 simp2l simp3l grpcl syl3anc ccom
      wa symgov syl2anc cun simp2r simp3r mvdco sylancl eqeltrd syl3anb cminusg
      unfi ssfi adantr grpinvcl ccnv symginv ad2antrl wf1o elsymgbas2 f1omvdcnv
      simprl ibi eqtrd simprr sylan2b issubgrpd2 ) CEHZUAUCAIZJKZLZMHZABUDZDUEN
      ZDXLUBUPZDDUFNZXGXNUGXGXOUGXGXMUGXLDUHNZUIXGXLBXPXKABUJGUKUQXGXOBHZXOJKZL
      ZMHZXOXLHXGDULHZXQCDEFUMZBDXOGXOUNUOURXGXSJCUSZJKZLZMXGYDXRXGYCXOJCDEFUTV
      AOYEPMYEPLPYDPYCJUIYDPQJCVBYCJVCVDVEVIVFVGVHVJXKXTAXOBXHXOQZXJXSMYFXIXRXH
      XOJROSTVKXGXGUAIZXLHZYGBHZYGJKZLZMHZVTZUCIZXLHYNBHZYNJKZLZMHZVTZYGYNXMUPZ
      XLHZXGVLXKYLAYGBXHYGQZXJYKMUUBXIYJXHYGJROSTZXKYRAYNBXHYNQZXJYQMUUDXIYPXHY
      NJROSTXGYMYSVMZYTBHZYTJKZLZMHZUUAUUEYAYIYOUUFXGYMYAYSYBVNXGYIYLYSVOZXGYMY
      OYRVPZBXMDYGYNGXMUNZVQVRUUEUUHYGYNVSZJKZLZMUUEUUGUUNUUEYTUUMJUUEYIYOYTUUM
      QUUJUUKCBXMDYGYNFGUULWAWBVAOUUEYKYQWCZMHZUUOUUPUIUUOMHUUEYLYRUUQXGYIYLYSW
      DXGYMYOYRWEYKYQWKWBYGYNWFUUPUUOWLWGWHXKUUIAYTBXHYTQZXJUUHMUURXIUUGXHYTJRO
      STVKWIYHXGYMYGDWJNZNZXLHZUUCXGYMVTZUUTBHZUUTJKZLZMHZUVAUVBYAYIUVCXGYAYMYB
      WMXGYIYLXABDUUSYGGUUSUNZWNWBUVBUVEYKMUVBUVEYGWOZJKZLZYKUVBUVDUVIUVBUUTUVH
      JYIUUTUVHQXGYLCBYGDUUSFGUVGWPWQVAOUVBCCYGWRZUVJYKQYIUVKXGYLYIUVKCBYGDBFGW
      SXBWQCYGWTURXCXGYIYLXDWHXKUVFAUUTBXHUUTQZXJUVEMUVLXIUVDXHUUTJROSTVKXEYBXF
      $.
  $}

  ${
    $d x B $.  $d x T $.
    symgtrf.t $e |- T = ran ( pmTrsp ` D ) $.
    symgtrf.g $e |- G = ( SymGrp ` D ) $.
    symgtrf.b $e |- B = ( Base ` G ) $.
    $( Transpositions are elements of the symmetric group.  (Contributed by
       Stefan O'Rear, 23-Aug-2015.) $)
    symgtrf $p |- T C_ B $=
      ( vx cv wcel wf1o cpmtr cfv eqid pmtrff1o elsymgbas2 mpbird ssriv ) HCAHI
      ZCJSAJBBSKBCBLMZSTNEOBASDCFGPQR $.

    $d u x y z B $.  $d u x y z K $.  $d u x y z T $.  $d x z D $.  $d x z G $.
    $d x V $.
    symggen.k $e |- K = ( mrCls ` ( SubMnd ` G ) ) $.
    $( The span of the transpositions is the subgroup that moves finitely many
       points.  (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    symggen $p |- ( D e. V -> ( K ` T ) =
        { x e. B | dom ( x \ _I ) e. Fin } ) $=
      ( wcel cfv cid cdif wss cvv syl wi wceq vy vz vu cv cdm crab csubmnd cmre
      cfn elex cmnd cacs cgrp symggrp grpmnd submacs acsmre 3syl symgtrf a1i wa
      c2o com 2onn nnfi ax-mp wb cen wf1o cpmtr eqid pmtrfb simp3bi enfi adantl
      wbr mpbiri ssrabdv symgfisg subgsubm mrcsscl syl3anc vex finnum cdom csdm
      csubg wal domfi cres wfn elsymgbas2 ibi f1ofn fnnfpeq0 c0g elbasfv symgid
      c0 csymg mrccl sylancl subm0cl eqeltrd eleq1a sylbid adantr wne n0 cplusg
      wex cpr ccom simpr f1omvdmvd sylan eldifad prssi syl2anc difss dmss f1odm
      csn syl5sseq sstrd sselda fnelnfp mpbid necomd fvex symgov eqeltrrd eqtrd
      co adantlr sseldd dmeqd difeq1 eleq1 imbi12d mp3an12 pmtrrn sseldi simplr
      pr2nelem oveq2d grpcl coass pmtrfinv coeq1d wf f1of fcoi2 3eqtrd ad2antrr
      syl5eqr mrcssid difeq1d wpss simpll cun mvdco pmtrmvd eqsstrd ssid syl5ss
      unssd wn fvco2 prcom fveq2i fveq1i pmtrprfv syl13anc necon2bbid ssnelpssd
      syl5eq php3 eqbrtrd ovex breq1d spcv ad2antlr submcl ex exlimdv pm2.61dne
      mp2d syl5bi exp31 com23 3impia indcardi impcom 3adant1 rabssdv eqssd ) CG
      LZDFMZAUDZNOZUEZUILZABUFZUWREUGMZBUHMLZDUXDPUXDUXELZUWSUXDPUWRCQLZUXFCGUJ
      UXHEUKLZUXEBULMLUXFUXHEUMLZUXICEQIUNZEUORBEJUPUXEBUQURZRUWRUXCABDDBPZUWRB
      CDEHIJUSZUTUWRUWTDLZVAUXCVBUILZVBVCLUXPVDVBVEVFUXOUXCUXPVGZUWRUXOUXBVBVHV
      PZUXQUXOUXHCCUWTVIUXRCDCVJMZUWTUXSVKZHVLVMUXBVBVNRVOVQVRUWRUXDEWGMLUXGABC
      EGIJVSUXDEVTRUXEDFUXDBKWAWBUWRUXCABUWSUWTBLZUXCUWTUWSLZUWRUXCUYAUYBUXCUAU
      DZBLZUYCUWSLZSZUBUDZBLZUYGUWSLZSZUYAUYBSUAUBUWTUYCNOZUEZUYGNOZUEZUXBQUWTQ
      LUXCAWCUTUXBWDUXCUYLUXBWEVPZUYNUYLWFVPZUYJSZUBWHZUYFUXCUYOVAUYLUILZUYRUYF
      SUXBUYLWIUYSUYDUYRUYEUYSUYDUYRUYEUYSUYDVAZUYRVAZUYEUYLWSUYTUYLWSTZUYESUYR
      UYTVUBUYCNCWJZTZUYEUYTCCUYCVIZUYCCWKZVUBVUDVGUYDVUEUYSUYDVUECBUYCEBIJWLWM
      VOZCCUYCWNZCUYCWOURUYTVUCUWSLVUDUYESUYTVUCEWPMZUWSUYTUXHVUCVUITUYDUXHUYSB
      EWTUYCCIJWQVOZCEQIWRRUYTUWSUXELZVUIUWSLUYTUXFUXMVUKUYTUXHUXFVUJUXLRZUXNUX
      EDFBKXAXBZUWSEVUIVUIVKXCRXDVUCUWSUYCXERXFXGUYLWSXHUCUDZUYLLZUCXKVUAUYEUCU
      YLXIVUAVUOUYEUCVUAVUOUYEVUAVUOVAZVUNVUNUYCMZXLZUXSMZVUSUYCEXJMZYNZVUTYNZU
      YCUWSUYTVUOVVBUYCTUYRUYTVUOVAZVVBVUSVUSUYCXMZVUTYNZVUSVVDXMZUYCVVCVVAVVDV
      USVUTVVCVUSBLZUYDVVAVVDTVVCDBVUSUXNVVCUXHVURCPZVURVBVHVPZVUSDLZUYTUXHVUOV
      UJXGZVVCVURUYLCVVCVUOVUQUYLLVURUYLPUYTVUOXNZVVCVUQUYLVUNYCZUYTVUEVUOVUQUY
      LVVMOLVUGCUYCVUNXOXPXQZVUNVUQUYLXRXSZUYTUYLCPVUOUYTUYCUEZUYLCUYKUYCPUYLVV
      PPUYCNXTUYKUYCYAVFUYTVUEVVPCTVUGCCUYCYBRYDZXGZYEZVVCVUNVUQXHZVVIVVCVUQVUN
      VVCVUOVUQVUNXHZVVLVVCVUFVUNCLZVUOVWAVGVVCVUEVUFUYTVUEVUOVUGXGZVUHRZUYTUYL
      CVUNVVQYFZCUYCVUNYGXSYHZYIVUNQLVUQQLVVTVVIUCWCVUNUYCYJVUNVUQQQUUEUUARZCVU
      RDUXSQUXTHUUBWBZUUCZUYSUYDVUOUUDZCBVUTEVUSUYCIJVUTVKZYKXSZUUFVVCVVGVVDBLZ
      VVEVVFTVWIVVCVVAVVDBVWLVVCUXJVVGUYDVVABLZUYTUXJVUOUYTUXHUXJVUJUXKRXGVWIVW
      JBVUTEVUSUYCJVWKUUGWBZYLZCBVUTEVUSVVDIJVWKYKXSVVCVVFVUSVUSXMZUYCXMZUYCVUS
      VUSUYCUUHVVCVWRVUCUYCXMZUYCVVCVWQVUCUYCVVCVVJVWQVUCTVWHCDUXSVUSUXTHUUIRUU
      JVVCVUECCUYCUUKVWSUYCTVWCCCUYCUULCCUYCUUMURYMUUPUUNYOVUPVUKVUSUWSLZVVAUWS
      LZVVBUWSLUYTVUKUYRVUOVUMUUOUYTVUOVWTUYRVVCDUWSVUSUYTDUWSPZVUOUYTUXFUXMVXB
      VULUXNUXEDFBKUUQXBXGVWHYPYOVUPVVANOZUEZUYLWFVPZVWNVXAUYTVUOVXEUYRVVCVXDVV
      DNOZUEZUYLWFVVCVXCVXFVVCVVAVVDNVWLUURYQVVCUYSVXGUYLUUSVXGUYLWFVPUYSUYDVUO
      UUTVVCVXGUYLVUNVVCVXGVUSNOUEZUYLUVAUYLVUSUYCUVBVVCVXHUYLUYLVVCVXHVURUYLVV
      CUXHVVHVVIVXHVURTVVKVVSVWGCVURUXSQUXTUVCWBVVOUVDUYLUYLPVVCUYLUVEUTUVGUVFV
      VLVVCVUNVVDMZVUNTZVUNVXGLZUVHZVVCVXIVUQVUSMZVUNVVCVUFVWBVXIVXMTVWDVWECVUS
      UYCVUNUVIXSVVCVXMVUQVUQVUNXLZUXSMZMZVUNVUQVUSVXOVURVXNUXSVUNVUQUVJUVKUVLV
      VCUXHVUQCLVWBVWAVXPVUNTVVKVVCUYLCVUQVVRVVNYPVWEVWFCUXSQVUQVUNUXTUVMUVNUVQ
      YMVVCVVDCWKZVWBVXJVXLVGVVCVWMCCVVDVIZVXQVWPVWMVXRCBVVDEBIJWLWMCCVVDWNURVW
      EVXQVWBVAVXKVXIVUNCVVDVUNYGUVOXSYHUVPUYLVXGUVRXSUVSYOUYTVUOVWNUYRVWOYOUYR
      VXEVWNVXASZSZUYTVUOUYQVXTUBVVAVUSUYCVUTUVTUYGVVATZUYPVXEUYJVXSVYAUYNVXDUY
      LWFVYAUYMVXCUYGVVANYRYQUWAVYAUYHVWNUYIVXAUYGVVABYSUYGVVAUWSYSYTYTUWBUWCUW
      HVUTUWSEVUSVVAVWKUWDWBYLUWEUWFUWIUWGUWJUWKRUWLUYCUYGTZUYDUYHUYEUYIUYCUYGB
      YSUYCUYGUWSYSYTUYCUWTTZUYDUYAUYEUYBUYCUWTBYSUYCUWTUWSYSYTVYBUYKUYMUYCUYGN
      YRYQVYCUYKUXAUYCUWTNYRYQUWMUWNUWOUWPUWQ $.

    $( A finite permutation group is generated by the transpositions.
       (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    symggen2 $p |- ( D e. Fin -> ( K ` T ) = B ) $=
      ( vx cfn wcel cfv cv cid cdif cdm crab wceq wss wral dmss wf1o elsymgbas2
      symggen difss ax-mp ibi f1odm syl syl5sseq sylan2 ralrimiva rabid2 sylibr
      ssfi eqtr4d ) BKLZCEMJNZOPZQZKLZJARZAJABCDEKFGHIUEURVBJAUAAVCSURVBJAUSALZ
      URVABTVBVDUSQZVABUTUSTVAVETUSOUFUTUSUBUGVDBBUSUCZVEBSVDVFBAUSDAGHUDUHBBUS
      UIUJUKBVAUPULUMVBJAUNUOUQ $.
  $}

  ${
    $d x B $.  $d x D $.  $d x I $.  $d x T $.  $d x V $.  $d x W $.
    symgtrinv.t $e |- T = ran ( pmTrsp ` D ) $.
    symgtrinv.g $e |- G = ( SymGrp ` D ) $.
    symgtrinv.i $e |- I = ( invg ` G ) $.
    $( To invert a permutation represented as a sequence of transpositions,
       reverse the sequence.  (Contributed by Stefan O'Rear, 27-Aug-2015.) $)
    symgtrinv $p |- ( ( D e. V /\ W e. Word T ) -> ( I ` ( G gsum W ) ) =
        ( G gsum ( reverse ` W ) ) ) $=
      ( vx wcel cword wa cgsu co cfv wceq eqid wf syl coppg ccom cmhm cgrp cgim
      creverse cbs cghm symggrp invoppggim gimghm ghmmhm 4syl wss symgtrf sswrd
      ax-mp sseli gsumwmhm syl2an cc0 chash cfzo wfn grpinvf adantr wrdf adantl
      fss sylancl fco syl2anc ffn cv fvco2 sylan ffvelrnda sseldi symginv cpmtr
      ccnv pmtrfcnv 3eqtrd eqfnfvd oveq2d cmnd grpmnd gsumwrev ) AEKZFBLZKZMZCF
      NODPZCUAPZDFUBZNOZWNFNOZCFUFPNOZWIDCWNUCOKZFCUGPZLZKZWMWPQWKWICUDKZDCWNUE
      OKDCWNUHOKWSACEHUIZCDWNWNRZIUJCWNDUKCWNDULUMWJXAFBWTUNZWJXAUNWTABCGHWTRZU
      OZBWTUPUQURZWTDCWNFXGUSUTWLWOFWNNWLJVAFVBPVCOZWOFWLXJWTWOSZWOXJVDWLWTWTDS
      ZXJWTFSZXKWIXLWKWIXCXLXDWTCDXGIVETVFWLXJBFSZXFXMWKXNWIBFVGVHZXHXJBWTFVIVJ
      XJWTWTDFVKVLXJWTWOVMTWLXNFXJVDZXOXJBFVMTZWLJVNZXJKZMZXRWOPZXRFPZDPZYBWAZY
      BWLXPXSYAYCQXQXJDFXRVOVPXTYBWTKYCYDQXTBWTYBXHWLXJBXRFXOVQZVRAWTYBCDHXGIVS
      TXTYBBKYDYBQYEABAVTPZYBYFRGWBTWCWDWEWICWFKZXBWQWRQWKWIXCYGXDCWGTXIWTCWNFX
      GXEWHUTWC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The sign of a permutation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c pmSgn $.
  $( Syntax for the sign of a permutation. $)
  cpsgn $a class pmSgn $.

  ${
    $d x s w d p $.
    $( Define a function which takes the value ` 1 ` for even permutations and
       ` -u 1 ` for odd.  (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    df-psgn $a |- pmSgn = ( d e. _V |->
        ( x e. { p e. ( Base ` ( SymGrp ` d ) ) | dom ( p \ _I ) e. Fin } |->
          ( iota s E. w e. Word ran ( pmTrsp ` d )
        ( x = ( ( SymGrp ` d ) gsum w ) /\ s = ( -u 1 ^ ( # ` w ) ) ) ) ) ) $.
  $}

  ${
    $d r s A $.  $d r s P $.  $d r s Q $.  $d r s T $.
    psgnunilem1.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnunilem1.d $e |- ( ph -> D e. V ) $.
    psgnunilem1.p $e |- ( ph -> P e. T ) $.
    psgnunilem1.q $e |- ( ph -> Q e. T ) $.
    psgnunilem1.a $e |- ( ph -> A e. dom ( P \ _I ) ) $.
    $( Lemma for ~ psgnuni .  Given two consequtive transpositions in a
       representation of a permutation, either they are equal and therefore
       equivalent to the identity, or they are not and it is possible to
       commute them such that a chosen point in the left transposition is
       preserved in the right.  By repeating this process, a point can be
       removed from a representation of the identity.  (Contributed by Stefan
       O'Rear, 22-Aug-2015.) $)
    psgnunilem1 $p |- ( ph -> ( ( P o. Q ) = ( _I |` D ) \/
          E. r e. T E. s e. T ( ( P o. Q ) = ( r o. s ) /\
                A e. dom ( s \ _I ) /\ -. A e. dom ( r \ _I ) ) ) ) $=
      ( cid wcel ccom wceq syl adantr cdif cdm cres cv wn w3a wrex wo wa wi cfv
      cpmtr eqid pmtrfinv coeq1 eqeq1d syl5ibrcom imp orcd ccnv pmtrfcnv eqcomd
      wne coeq2d wf1o pmtrff1o pmtrfconj syl2anc eqeltrd ad2antrr coass wf f1of
      fco fcoi1 eqtrd syl5req cima c2o cen wbr cvv pmtrfb simp3bi cfn 2onn nnfi
      wss com ax-mp wb enfi mpbiri csn cpr en2eleq simprl wfn f1ofn crn imassrn
      cuni frn syl5ss simprr fnfvima syl3anc difss dmss syl5sseq sseldd pmtrffv
      cif f1odm iftrue imaco imaeq1d resiima syl5eqr 3eltr3d prssi eqsstrd entr
      ensymd fisseneq f1otrspeq syl22anc difeq1d dmeqd f1omvdconj eleq2d eqeq2d
      difeq1 notbid 3anbi13d coeq2 3anbi12d rspc2ev syl113anc olcd mtbird fcoi2
      expr necon3ad pm2.61dane coeq1d eqtr2d syl6eq fnelnfp necon2bbid eqeltrrd
      biimpar eleqtrrd simpr pm2.61dan ) ABEOUAZUBZPZDEQZOCUCZRZUUSIUDZHUDZQZRZ
      BUVCOUAZUBZPZBUVBOUAZUBZPZUEZUFZHFUGIFUGZUHZAUURUIZUVODEUVPDERZUIUVAUVNUV
      PUVQUVAAUVQUVAUJUURAUVAUVQEEQZUUTRZAEFPZUVSMCFCULUKZEUWAUMZJUNSZUVQUUSUVR
      UUTDEEUOUPUQTURUSUVPDEVCZUIZUVNUVAUWEUUSDQZFPZDFPZUUSUWFDQZRZBDOUAZUBZPZB
      UWFOUAZUBZPZUEZUVNAUWGUURUWDAUWFUUSDUTZQZFADUWRUUSAUWRDAUWHUWRDRLCFUWADUW
      BJVASVBVDZAUVTCCDVEZUWSFPMAUWHUXALCFUWADUWBJVFSZCFUWAEDUWBJVGVHVIVJAUWHUU
      RUWDLVJAUWJUURUWDAUWIUUSDDQZQZUUSUUSDDVKAUXDUUSUUTQZUUSAUXCUUTUUSAUWHUXCU
      UTRLCFUWADUWBJUNSZVDACCUUSVLZUXEUUSRACCDVLZCCEVLZUXGAUXAUXHUXBCCDVMSZACCE
      VEZUXIAUVTUXKMCFUWAEUWBJVFSZCCEVMSZCCCDEVNVHZCCUUSVOSVPVQVJAUWMUURUWDNVJU
      WEUWPBDUUQVRZPZUVPUWDUXPUEUVPUXPDEAUURUXPUVQAUURUXPUIZUIZUXAUXKUWLVSVTWAZ
      UUQUWLRUVQAUXAUXQUXBTAUXKUXQUXLTAUXSUXQAUWHUXSLUWHCWBPZUXAUXSCFUWADUWBJWC
      WDSZTZUXRUWLUUQUXRUUQWEPZUWLUUQWHUWLUUQVTWAZUWLUUQRAUYCUXQAUYCVSWEPZVSWIP
      UYEWFVSWGWJAUUQVSVTWAZUYCUYEWKAUVTUYFMUVTUXTUXKUYFCFUWAEUWBJWCWDSZUUQVSWL
      SWMTUXRUWLBUWLBWNUAXBZWOZUUQUXRUWMUXSUWLUYIRAUWMUXQNTUYBUWLBWPVHUXRUURUYH
      UUQPUYIUUQWHAUURUXPWQUXRBDUKZDUXOVRZUYHUUQUXRDCWRZUXOCWHZUXPUYJUYKPAUYLUX
      QAUXAUYLUXBCCDWSSTAUYMUXQAUXHUYMUXJUXHUXODWTCDUUQXACCDXCXDSTAUURUXPXECUXO
      DBXFXGAUYJUYHRUXQAUYJUWMUYHBXMZUYHAUWHBCPZUYJUYNRLAUWLCBADUBZUWLCUWKDWHUW
      LUYPWHDOXHUWKDXIWJAUXAUYPCRUXBCCDXNSXJZNXKZCUWLFUWADBUWBJUWLUMXLVHAUWMUYN
      UYHRNUWMUYHBXOSVPTAUYKUUQRUXQAUYKUXCUUQVRZUUQDDUUQXPAUYSUUTUUQVRZUUQAUXCU
      UTUUQUXFXQAUUQCWHZUYTUUQRAUXKVUAUXLUXKEUBZUUQCUUPEWHUUQVUBWHEOXHUUPEXIWJC
      CEXNXJSCUUQXRSVPXSTXTBUYHUUQYAVHYBAUYDUXQAUXSVSUUQVTWAUYDUYAAUUQVSUYGYDUW
      LVSUUQYCVHTUWLUUQYEXGVBCDEYFYGUUCUUDURAUWPUXPWKUURUWDAUWOUXOBAUWOUWSOUAZU
      BZUXOAUWNVUCAUWFUWSOUWTYHYIAUXIUXAVUDUXORUXMUXBCEDYJVHVPYKVJUUAUVMUWJUWMU
      WQUFUUSUWFUVCQZRZUVHUWQUFIHUWFDFFUVBUWFRZUVEVUFUVLUWQUVHVUGUVDVUEUUSUVBUW
      FUVCUOYLVUGUVKUWPVUGUVJUWOBVUGUVIUWNUVBUWFOYMYIYKYNYOUVCDRZVUFUWJUVHUWMUW
      QVUHVUEUWIUUSUVCDUWFYPYLVUHUVGUWLBVUHUVFUWKUVCDOYMYIYKYQYRYSYTUUEAUURUEZU
      IZUVNUVAVUJUVTEUUSQZFPZUUSEVUKQZRZBVUKOUAZUBZPZVUIUVNAUVTVUIMTAVULVUIAVUK
      EDQZEUTZQZFAVUKVUREQVUTEDEVKAEVUSVURAVUSEAUVTVUSERMCFUWAEUWBJVASVBVDXSZAU
      WHUXKVUTFPLUXLCFUWADEUWBJVGVHVITAVUNVUIAUUSUVRUUSQZVUMAVVBUUTUUSQZUUSAUVR
      UUTUUSUWCUUFAUXGVVCUUSRUXNCCUUSUUBSUUGEEUUSVKUUHTVUJBEUWLVRZVUPVUJBEUKZBV
      VDAVVEBRVUIAUURVVEBAECWRZUYOUURVVEBVCWKAUXKVVFUXLCCEWSSZUYRCEBUUIVHUUJUUL
      AVVEVVDPZVUIAVVFUWLCWHUWMVVHVVGUYQNCUWLEBXFXGTUUKAVUPVVDRVUIAVUPVUTOUAZUB
      ZVVDAVUOVVIAVUKVUTOVVAYHYIAUXHUXKVVJVVDRUXJUXLCDEYJVHVPTUUMAVUIUUNUVMVUNV
      UQVUIUFUUSEUVCQZRZUVHVUIUFIHEVUKFFUVBERZUVEVVLUVLVUIUVHVVMUVDVVKUUSUVBEUV
      CUOYLVVMUVKUURVVMUVJUUQBVVMUVIUUPUVBEOYMYIYKYNYOUVCVUKRZVVLVUNUVHVUQVUIVV
      NVVKVUMUUSUVCVUKEYPYLVVNUVGVUPBVVNUVFVUOUVCVUKOYMYIYKYQYRYSYTUUO $.
  $}

  ${
    $d j k r s w A $.  $d j r s w x D $.  $d j r s ph $.  $d j k r s w x G $.
    $d j k r s w x I $.  $d j r s w x T $.  $d j k r s w x W $.
    $d r s w x L $.
    psgnunilem2.g $e |- G = ( SymGrp ` D ) $.
    psgnunilem2.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnunilem2.d $e |- ( ph -> D e. V ) $.
    psgnunilem2.w $e |- ( ph -> W e. Word T ) $.
    psgnunilem2.id $e |- ( ph -> ( G gsum W ) = ( _I |` D ) ) $.
    psgnunilem2.l $e |- ( ph -> ( # ` W ) = L ) $.
    psgnunilem2.ix $e |- ( ph -> I e. ( 0 ..^ L ) ) $.
    psgnunilem2.a $e |- ( ph -> A e. dom ( ( W ` I ) \ _I ) ) $.
    psgnunilem2.al $e |- ( ph -> A. k e. ( 0 ..^ I )
          -. A e. dom ( ( W ` k ) \ _I ) ) $.
    $( Lemma for ~ psgnuni .  It is impossible to shift a transposition off the
       end because if the active transposition is at the right end, it is the
       only transposition moving ` A ` in contradiction to this being a
       representation of the identity.  (Contributed by Stefan O'Rear,
       25-Aug-2015.)  (Revised by Mario Carneiro, 28-Feb-2016.) $)
    psgnunilem5 $p |- ( ph -> ( I + 1 ) e. ( 0 ..^ L ) ) $=
      ( wcel vj vs c1 caddc co cc0 cfzo wceq cgsu cid cdif c0 noel cres difeq1d
      cdm dmeqd wss resss ssdif0 mpbi dmeqi dm0 syl6eq eleq2d mtbiri wa csubstr
      eqtri cop cfv ccom wf1o wxo cbs cmnd cword cgrp symggrp 3syl eqid symgtrf
      grpmnd sswrd mp1i sseldd swrdcl syl gsumwcl syl2anc elsymgbas2 ibi adantr
      chash wf wrdf oveq2d eleqtrrd ffvelrnd sseldi wn wo cv cvv csn crab csubg
      csubmnd symgsssg subgsubm cuz cfz fzossfz elfzuz3 fzoss2 sselda ffvelrnda
      cmpt eqeltrd syldan fveq2 notbid cbvralv sylib r19.21bi difeq1 sseq1d cin
      wral disj2 disjsn bitr3i elrab 3eqtrd syl3anc cs1 cconcat cmin cn eqtrd
      syl6bb sylanbrc fmptd swrd0val feqmptd reseq1d resmpt feq1d mpbird iswrdi
      gsumwsubmcl simprbi jca excxor sylibr f1omvdco3 cplusg wne cn0 clt elfzo0
      olcd wbr simp2bi cfn wrdfin hashnncl mpbid wrdeqcats1 oveq1d nncnd ax-1cn
      wb cc a1i cz elfzoelz subadd2d biimpar opeq2 s1eqd oveq12d s1cld gsumccat
      zcnd gsumws1 symgov mtand fzostep1 ord mt3d ) AGUCUDUEZUFHUGUEZTZUWLHUHZA
      UWOBFJUIUEZUJUKZUPZTZAUWSBULTBUMAUWRULBAUWRUJCUNZUJUKZUPZULAUWQUXAAUWPUWT
      UJOUOUQUXBULUPULUXAULUWTUJURUXAULUHUJCUSUWTUJUTVAVBVCVIVDVEVFAUWOVGZBFJUF
      GVJZVHUEZUIUEZGJVKZVLZUJUKZUPZUWRUXCCCUXFVMZCCUXGVMZBUXFUJUKZUPZTZBUXGUJU
      KUPTZVNZBUXJTAUXKUWOAUXFFVOVKZTZUXKAFVPTZUXEUXRVQZTZUXSACITZFVRTUXTMCFIKV
      SFWCVTZAJUYATUYBADVQZUYAJDUXRURUYEUYAURAUXRCDFLKUXRWAZWBZDUXRWDWENWFUXRJU
      FGWGWHZUXRFUXEUYFWIWJZUXSUXKCUXRUXFFUXRKUYFWKWLWHWMAUXLUWOAUXGUXRTZUXLADU
      XRUXGUYGAUFJWNVKZUGUEZDGJAJUYETZUYLDJWONDJWPWHZAGUWMUYLQAUYKHUFUGPWQWRWSW
      TZUYJUXLCUXRUXGFUXRKUYFWKWLWHWMUXCUXOUXPXAVGZUXOXAZUXPVGZXBUXQUXCUYRUYPUX
      CUYQUXPUXCUXFUAXCZUJUKZUPZXDBXEZUKZURZUAUXRXFZTZUYQUXCVUEFXHVKTZUXEVUEVQT
      ZVUFAVUGUWOAUYCVUEFXGVKTVUGMUAUXRCFIVUCKUYFXIVUEFXJVTWMUXCUFGUGUEZVUEUXEW
      OZVUHAVUJUWOAVUJVUIVUEUBVUIUBXCZJVKZXRZWOAUBVUIVULVUEVUMAVUKVUITZVGVULUXR
      TZBVULUJUKZUPZTZXAZVULVUETAVUNVUKUYLTZVUOAVUIUYLVUKAUYKGXKVKZTZVUIUYLURZA
      UYKHVVAPAGUFHXLUEZTHVVATAUWMVVDGUFHXMQWTZGUFHXNWHXSZGUFUYKXOZWHXPAVUTVGDU
      XRVULUYGAUYLDVUKJUYNXQWTXTAVUSUBVUIABEXCZJVKZUJUKZUPZTZXAZEVUIYIVUSUBVUIY
      ISVVMVUSEUBVUIVVHVUKUHZVVLVURVVNVVKVUQBVVNVVJVUPVVNVVIVULUJVVHVUKJYAUOUQV
      EYBYCYDYEVUDVUSUAVULUXRUYSVULUHZVUDVUQVUCURZVUSVVOVUAVUQVUCVVOUYTVUPUYSVU
      LUJYFUQYGVVPVUQVUBYHULUHVUSVUQVUBYJVUQBYKYLUUAYMUUBVUMWAUUCAVUIVUEUXEVUMA
      UXEJVUIUNZUBUYLVULXRZVUIUNZVUMAUYMGUFUYKXLUEZTUXEVVQUHNAGVVDVVTVVEAUYKHUF
      XLPWQWRDJGUUDWJAJVVRVUIAUBUYLDJUYNUUEUUFAVVBVVCVVSVUMUHVVFVVGUBUYLVUIVULU
      UGVTYNUUHUUIWMVUEGUXEUUJWHVUEFUXEUUKWJVUFUXNVUCURZUYQVUFUXSVWAVUDVWAUAUXF
      UXRUYSUXFUHZVUAUXNVUCVWBUYTUXMUYSUXFUJYFUQYGYMUULVWAUXNVUBYHULUHUYQUXNVUB
      YJUXNBYKYLYDWHAUXPUWORWMUUMUVBUXOUXPUUNUUOCUXFUXGBUUPYOUXCUWQUXIUXCUWPUXH
      UJUXCUWPFUXEUXGYPZYQUEZUIUEZUXFFVWCUIUEZFUUQVKZUEZUXHUXCJVWDFUIUXCJJUFUYK
      UCYRUEZVJZVHUEZVWIJVKZYPZYQUEZVWDUXCUYMJULUURZJVWNUHAUYMUWONWMAVWOUWOAUYK
      YSTZVWOAUYKHYSPAGUWMTZHYSTZQVWQGUUSTVWRGHUUTUVCGHUVAUVDWHZXSAUYMJUVETVWPV
      WOUVMNDJUVFJUVGVTUVHWMDJUVIWJUXCVWIGUHZVWNVWDUHUXCVWIHUCYRUEZGAVWIVXAUHUW
      OAUYKHUCYRPUVJWMAVXAGUHUWOAHUCGAHVWSUVKUCUVNTAUVLUVOAGAVWQGUVPTQGUFHUVQWH
      UWEUVRUVSYTVWTVWKUXEVWMVWCYQVWTVWJUXDJVHVWIGUFUVTWQVWTVWLUXGVWIGJYAUWAUWB
      WHYTWQAVWEVWHUHZUWOAUXTUYBVWCUYATVXBUYDUYHAUXGUXRUYOUWCUXRVWGFUXEVWCUYFVW
      GWAZUWDYOWMAVWHUXHUHUWOAVWHUXFUXGVWGUEZUXHAVWFUXGUXFVWGAUYJVWFUXGUHUYOUXR
      UXGFUYFUWFWHWQAUXSUYJVXDUXHUHUYIUYOCUXRVWGFUXFUXGKUYFVXCUWGWJYTWMYNUOUQWR
      UWHAUWNUWOAVWQUWNUWOXBQGUFHUWIWHUWJUWK $.

    psgnunilem2.in $e |- ( ph -> -. E. x e. Word T
            ( ( # ` x ) = ( L - 2 ) /\ ( G gsum x ) = ( _I |` D ) ) ) $.
    $( Lemma for ~ psgnuni .  Induction step for moving a transposition as far
       to the right as possible.  (Contributed by Stefan O'Rear, 24-Aug-2015.)
       (Revised by Mario Carneiro, 28-Feb-2016.) $)
    psgnunilem2 $p |- ( ph -> E. w e. Word T
          ( ( ( G gsum w ) = ( _I |` D ) /\ ( # ` w ) = L ) /\
          ( ( I + 1 ) e. ( 0 ..^ L ) /\ A e. dom ( ( w ` ( I + 1 ) ) \ _I ) /\
          A. j e. ( 0 ..^ ( I + 1 ) ) -. A e. dom ( ( w ` j ) \ _I ) ) ) ) $=
      ( vr vs cfv c1 caddc co ccom cid cres wceq cv cgsu chash wa cc0 cfzo wcel
      cdif cdm wn wral w3a cword wrex c2 cmin c0 cotp csplice wrd0 splcl adantr
      sylancl cneg cn0 cle wbr cfz fzossfz sseldi elfznn0 syl 2nn0 cr nn0addge1
      nn0addcl nn0red syl3anbrc psgnunilem5 fzofzp1 cc a1i oveq2i oveq2d spllen
      elfz2nn0 oveq1i 2cn syl5eq 3eqtrd syl12anc eqid wss cs2 eleqtrrd ffvelrnd
      syl3anc gsumws2 symgov syl2anc simpr gsumspl 3eqtr3d fveq2 eqeq1d anbi12d
      wf oveq2 rspcev ex adantrr sselda eqtrd addid1d clt 2nn mpbir3an eleqtrri
      elfzo0 splfv2a difeq1d dmeqd wb eleq2d notbid ad2antrr fveq1 addassd df-2
      nn0cnd ax-1cn syl6reqr 3eltr4d hash0 df-neg eqtr4i pncan2 oveq12d elfzel2
      negeqd zcnd negsub cop csubstr splid cbs cmnd cgrp symggrp grpmnd symgtrf
      cz sswrd ax-mp swrdcl cplusg swrds2 wrdf feq2d mpbid symgid gsum0 syl6eqr
      pm2.21dd simprl simprr s2cld simprr1 adantrl 3eqtr4rd s2len subidi syl6eq
      c0g eqeltrd jca simprr2 cn 1nn0 1lt2 s2fv1 ad2antll cuz fzosplitsni nn0uz
      wo eleq2s rspccva sylan adantlr splfv1 neleqtrrd simprr3 0nn0 2pos fveq2d
      wi s2fv0 ad2antrl mtbird syl5ibrcom jaod sylbid ralrimiv ralbidv 3anbi23d
      3jca expr rexlimdvva psgnunilem1 mpjaod ) AJMUFZJUGUHUIZMUFZUJZUKEULZUMZI
      CUNZUOUIZUYIUMZUYKUPUFZKUMZUQZUYFURKUSUIZUTZDUYFUYKUFZUKVAZVBZUTZDGUNZUYK
      UFZUKVAZVBZUTZVCZGURUYFUSUIZVDZVEZUQZCFVFZVGZUYHUDUNZUEUNZUJZUMZDVUPUKVAZ
      VBZUTZDVUOUKVAZVBZUTZVCZVEZUEFVGUDFVGAUYJVUNAUYJUQZBUNZUPUFZKVHVIUIZUMZIV
      VHUOUIZUYIUMZUQZBVUMVGZVUNVVGMJJVHUHUIZVJVKVLUIZVUMUTZVVQUPUFZVVJUMZIVVQU
      OUIZUYIUMZVVOAVVRUYJAMVUMUTZVJVUMUTZVVRQFVMZFVJMVVPJVNVPVOAVVTUYJAVVSMUPU
      FZVJUPUFZVVPJVIUIZVIUIZUHUIKVHVQZUHUIZVVJAFVJMVVPJQAJVRUTZVVPVRUTZJVVPVSV
      TZJURVVPWAUIUTZAJURKWAUIZUTZVWLAUYQVWPJURKWBTWCZJKWDWEZAVWLVHVRUTZVWMVWSW
      FJVHWIVPAJWGUTVWTVWNAJVWSWJWFJVHWHVPJVVPWSWKZAUYFUGUHUIZVWPVVPURVWFWAUIZA
      UYRVXBVWPUTADEFHIJKLMNOPQRSTUAUBWLZURKUYFWMWEAVXBJUGUGUHUIZUHUIVVPAJUGUGA
      JVWSUUCZUGWNUTAUUDWOZVXGUUAVHVXEJUHUUBWPUUEAVWFKURWASWQUUFZVWDAVWEWOWRAVW
      FKVWIVWJUHSAVWIVWHVQZVWJVWIURVWHVIUIVXIVWGURVWHVIUUGWTVWHUUHUUIAVWHVHAJWN
      UTVHWNUTZVWHVHUMVXFXAJVHUUJVPZUUMXBUUKAKWNUTVXJVWKVVJUMAKAVWQKUVEUTVWRJUR
      KUULWEUUNZXAKVHUUOVPXCVOVVGIMJVVPMJVVPUUPUUQUIZVKVLUIZUOUIZIMUOUIZVWAUYIA
      VXOVXPUMZUYJAVXNMIUOAVWCVWOVVPVXCUTZVXNMUMQVXAVXHFMJVVPUURXDWQZVOVVGIUUSU
      FZMVVPJIVXMVJVXTXEZAIUUTUTZUYJAIUVAUTZVYBAELUTZVYCPEILNUVBWEIUVCWEZVOAMVX
      TVFZUTZUYJAVUMVYFMFVXTXFZVUMVYFXFVXTEFIONVYAUVDZFVXTUVFUVGZQWCZVOAVWOUYJV
      XAVOAVXRUYJVXHVOAVXMVYFUTZUYJAVYGVYLVYKVXTMJVVPUVHWEZVOVJVYFUTVVGVXTVMWOV
      VGIVXMUOUIZUYHUYIIVJUOUIZAVYNUYHUMZUYJAVYNIUYEUYGXGZUOUIZUYEUYGIUVIUFZUIZ
      UYHAVXMVYQIUOAVWCVWLUYFURVWFUSUIZUTVXMVYQUMQVWSAUYFUYQWUAVXDAVWFKURUSSWQZ
      XHFJMUVJXJWQAVYBUYEVXTUTZUYGVXTUTZVYRVYTUMVYEAFVXTUYEVYIAUYQFJMAWUAFMXTZU
      YQFMXTAVWCWUEQFMUVKWEAWUAUYQFMWUBUVLUVMZTXIZWCZAFVXTUYGVYIAUYQFUYFMWUFVXD
      XIZWCZVXTVYSUYEUYGIVYAVYSXEZXKXJAWUCWUDVYTUYHUMWUHWUJEVXTVYSIUYEUYGNVYAWU
      KXLXMXCZVOAUYJXNAUYIVYOUMUYJAUYIIUWGUFZVYOAVYDUYIWUMUMPEILNUVNWEIWUMWUMXE
      UVOUVPVOXCXOAVXPUYIUMZUYJRVOXPVVNVVTVWBUQBVVQVUMVVHVVQUMZVVKVVTVVMVWBWUOV
      VIVVSVVJVVHVVQUPXQXRWUOVVLVWAUYIVVHVVQIUOYAXRXSYBXDAVVOVCUYJUCVOUVQYCAVVF
      VUNUDUEFFAVUOFUTZVUPFUTZUQZVVFVUNAWURVVFUQZUQZMJVVPVUOVUPXGZVKVLUIZVUMUTZ
      IWVBUOUIZUYIUMZWVBUPUFZKUMZUQZUYRDUYFWVBUFZUKVAZVBZUTZDVUCWVBUFZUKVAZVBZU
      TZVCZGVUIVDZVEZVUNAWURWVCVVFAWURUQZVWCWVAVUMUTZWVCAVWCWURQVOZWVTVUOVUPFAW
      UPWUQUVRAWUPWUQUVSUVTZFWVAMVVPJVNXMYDWUTWVEWVGWUTWVDVXOVXPUYIWUTVXTMVVPJI
      WVAVXMVYAAVYBWUSVYEVOAVYGWUSVYKVOAVWOWUSVXAVOAVXRWUSVXHVOAWURWVAVYFUTVVFW
      VTVUMVYFWVAVYJWWCWCYDAVYLWUSVYMVOWUTUYHVUQVYNIWVAUOUIZVURVVAVVEWURAUWAAVY
      PWUSWULVOAWURWWDVUQUMVVFWVTWWDVUOVUPVYSUIZVUQWVTVYBVUOVXTUTZVUPVXTUTZWWDW
      WEUMAVYBWURVYEVOAWUPWWFWUQAFVXTVUOVYHAVYIWOZYEYDZAWUQWWGWUPAFVXTVUPWWHYEU
      WBZVXTVYSVUOVUPIVYAWUKXKXJWVTWWFWWGWWEVUQUMWWIWWJEVXTVYSIVUOVUPNVYAWUKXLX
      MYFYDUWCXOAVXQWUSVXSVOAWUNWUSRVOXCAWURWVGVVFWVTWVFVWFWVAUPUFZVWHVIUIZUHUI
      ZKWVTFWVAMVVPJWWBAVWOWURVXAVOZAVXRWURVXHVOZWWCWRAWWMKUMWURAWWMVWFURUHUIVW
      FKAWWLURVWFUHAWWLVHVWHVIUIZURWWKVHVWHVIVUOVUPUWDZWTAWWPVHVHVIUIURAVWHVHVH
      VIVXKWQVHXAUWEUWFXBWQAVWFAVWFKWNSVXLUWHYGSXCVOYFYDUWIWUTUYRWVLWVRAUYRWUSV
      XDVOWUTDVUTWVKVURVVAVVEWURAUWJWUTWVJVUSWUTWVIVUPUKAWURWVIVUPUMVVFWVTWVIUG
      WVAUFZVUPWVTFWVAMVVPJUGWWBWWNWWOWWCUGURWWKUSUIZUTWVTUGURVHUSUIZWWSUGWWTUT
      UGVRUTVHUWKUTZUGVHYHVTUWLYIUWMUGVHYLYJWWKVHURUSWWQWPZYKWOYMWUQWWRVUPUMAWU
      PVUOVUPFUWNUWOYFYDYNYOXHWUTWVQGVUIWUTVUCVUIUTZVUCURJUSUIZUTZVUCJUMZUWSZWV
      QAWXCWXGYPZWUSAVWLWXHVWSWXHJURUWPUFVRURJVUCUWQUWRUWTWEVOWUTWXEWVQWXFAWURW
      XEWVQUXJVVFWVTWXEWVQWVTWXEUQZWVOVUCMUFZUKVAZVBZDAWXEDWXLUTZVCZWURADHUNZMU
      FZUKVAZVBZUTZVCZHWXDVDWXEWXNUBWXTWXNHVUCWXDWXOVUCUMZWXSWXMWYAWXRWXLDWYAWX
      QWXKWYAWXPWXJUKWXOVUCMXQYNYOYQYRUXAUXBUXCWXIWVNWXKWXIWVMWXJUKWXIFWVAMVVPJ
      VUCAVWCWURWXEQYSAVWOWURWXEVXAYSAVXRWURWXEVXHYSWVTWWAWXEWWCVOWVTWXEXNUXDYN
      YOUXEYCYDWUTWVQWXFDJWVBUFZUKVAZVBZUTZVCWUTWYEVVDVURVVAVVEWURAUXFAWURWYEVV
      DYPVVFWVTWYDVVCDWVTWYCVVBWVTWYBVUOUKWVTJURUHUIZWVBUFURWVAUFZWYBVUOWVTFWVA
      MVVPJURWWBWWNWWOWWCURWWSUTWVTURWWTWWSURWWTUTURVRUTWXAURVHYHVTUXGYIUXHURVH
      YLYJWXBYKWOYMWVTWYFJWVBAWYFJUMWURAJVXFYGVOUXIWUPWYGVUOUMAWUQVUOVUPFUXKUXL
      XPYNYOYQYDUXMWXFWVPWYEWXFWVOWYDDWXFWVNWYCWXFWVMWYBUKVUCJWVBXQYNYOYQYRUXNU
      XOUXPUXQUXTVULWVHWVSUQCWVBVUMUYKWVBUMZUYPWVHVUKWVSWYHUYMWVEUYOWVGWYHUYLWV
      DUYIUYKWVBIUOYAXRWYHUYNWVFKUYKWVBUPXQXRXSWYHVUBWVLVUJWVRUYRWYHVUAWVKDWYHU
      YTWVJWYHUYSWVIUKUYFUYKWVBYTYNYOYQWYHVUHWVQGVUIWYHVUGWVPWYHVUFWVODWYHVUEWV
      NWYHVUDWVMUKVUCUYKWVBYTYNYOYQYRUXRUXSXSYBXDUYAUYBADEUYEUYGFLUEUDOPWUGWUIU
      AUYCUYD $.
  $}

  ${
    $d a b c d e w x y D $.  $d a b c d w x G $.  $d a b c e w x y L $.
    $d a b c w x y T $.  $d a b c e w x W $.  $d a b c e x ph $.
    $d b c d w x y G $.
    psgnunilem3.g $e |- G = ( SymGrp ` D ) $.
    psgnunilem3.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnunilem3.d $e |- ( ph -> D e. V ) $.
    psgnunilem3.w1 $e |- ( ph -> W e. Word T ) $.
    psgnunilem3.l $e |- ( ph -> ( # ` W ) = L ) $.
    psgnunilem3.w2 $e |- ( ph -> ( # ` W ) e. NN ) $.
    psgnunilem3.w3 $e |- ( ph -> ( G gsum W ) = ( _I |` D ) ) $.
    psgnunilem3.in $e |- ( ph -> -. E. x e. Word T
            ( ( # ` x ) = ( L - 2 ) /\ ( G gsum x ) = ( _I |` D ) ) ) $.
    $( Lemma for ~ psgnuni .  Any nonempty representation of the identity can
       be incrementally transformed into a representation two shorter.
       (Contributed by Stefan O'Rear, 25-Aug-2015.) $)
    psgnunilem3 $p |- -. ph $=
      ( vc wcel cc0 cid ve vw va vb vd vy cn0 chash cfv cn eqeltrrd nnnn0d cdif
      cv cdm wn c0 wne wex cfzo co cword wf wrdf syl clt wbr 0nn0 nngt0d elfzo0
      syl3anbrc oveq2d eleqtrrd ffvelrnd cpmtr eqid pmtrfmvdn0 n0 sylib wa cgsu
      a1i cres wceq wral w3a wrex fzonel simpr1 mto nrex wi caddc eleq1 difeq1d
      c1 fveq2 dmeqd eleq2d raleqdv 3anbi123d anbi2d rexbidv imbi2d weq anbi12d
      oveq2 eqeq1d fveq1 notbid ralbidv cbvralv syl6bb cbvrexv adantr jca simpr
      3anbi23d ral0 fzo0 raleqi rspcev syl12anc ad2antrr simprl simpll ad2antll
      mpbir 3jca simplr simpr2 simpr3 c2 cmin sylnib psgnunilem2 rexlimdvaa a2i
      nn0ind mtoi con2i exlimddv pm2.65i ) AFUGRZAFAHUHUIZFUJMNUKZULAUAUNZSHUIZ
      TUMZUOZRZUUDUPUAAUUJUQURZUUKUAUSAUUHDRUULASUUEUTVAZDSHAHDVBZRZUUMDHVCLDHV
      DVEASSFUTVAZUUMASUGRZFUJRSFVFVGSUUPRZUUQAVHWBUUFAFUUFVISFVJVKZAUUEFSUTMVL
      VMVNCDCVOUIZUUHUUTVPJVQVEUAUUJVRVSUUDAUUKVTZUUDUVAEUBUNZWAVAZTCWCZWDZUVBU
      HUIZFWDZVTZFUUPRZUUGFUVBUIZTUMZUOZRZUUGQUNZUVBUIZTUMZUOZRZUPZQUUPWEZWFZVT
      ZUBUUNWGZUWBUBUUNUWBUPUVBUUNRUWBUVISFWHUVHUVIUVMUVTWIWJWBWKUVAUVHUCUNZUUP
      RZUUGUWDUVBUIZTUMZUOZRZUVSQSUWDUTVAZWEZWFZVTZUBUUNWGZWLUVAUVHUURUUGSUVBUI
      ZTUMZUOZRZUVSQSSUTVAZWEZWFZVTZUBUUNWGZWLUVAEBUNZWAVAZUVDWDZUXDUHUIZFWDZVT
      ZUDUNZUUPRZUUGUXJUXDUIZTUMZUOZRZUUGUEUNZUXDUIZTUMZUOZRZUPZUESUXJUTVAZWEZW
      FZVTZBUUNWGZWLZUVAUVHUXJWPWMVAZUUPRZUUGUYHUVBUIZTUMZUOZRZUVSQSUYHUTVAZWEZ
      WFZVTZUBUUNWGZWLZUVAUWCWLUCUDFUWDSWDZUWNUXCUVAUYTUWMUXBUBUUNUYTUWLUXAUVHU
      YTUWEUURUWIUWRUWKUWTUWDSUUPWNUYTUWHUWQUUGUYTUWGUWPUYTUWFUWOTUWDSUVBWQWOWR
      WSUYTUVSQUWJUWSUWDSSUTXGWTXAXBXCXDUCUDXEZUWNUYFUVAVUAUWNUVHUXKUUGUXJUVBUI
      ZTUMZUOZRZUVSQUYBWEZWFZVTZUBUUNWGUYFVUAUWMVUHUBUUNVUAUWLVUGUVHVUAUWEUXKUW
      IVUEUWKVUFUWDUXJUUPWNVUAUWHVUDUUGVUAUWGVUCVUAUWFVUBTUWDUXJUVBWQWOWRWSVUAU
      VSQUWJUYBUWDUXJSUTXGWTXAXBXCVUHUYEUBBUUNUBBXEZUVHUXIVUGUYDVUIUVEUXFUVGUXH
      VUIUVCUXEUVDUVBUXDEWAXGXHVUIUVFUXGFUVBUXDUHWQXHXFVUIVUEUXOVUFUYCUXKVUIVUD
      UXNUUGVUIVUCUXMVUIVUBUXLTUXJUVBUXDXIWOWRWSVUIVUFUUGUVNUXDUIZTUMZUOZRZUPZQ
      UYBWEUYCVUIUVSVUNQUYBVUIUVRVUMVUIUVQVULUUGVUIUVPVUKVUIUVOVUJTUVNUVBUXDXIW
      OWRWSXJXKVUNUYAQUEUYBQUEXEZVUMUXTVUOVULUXSUUGVUOVUKUXRVUOVUJUXQTUVNUXPUXD
      WQWOWRWSXJXLXMXRXFXNXMXDUWDUYHWDZUWNUYRUVAVUPUWMUYQUBUUNVUPUWLUYPUVHVUPUW
      EUYIUWIUYMUWKUYOUWDUYHUUPWNVUPUWHUYLUUGVUPUWGUYKVUPUWFUYJTUWDUYHUVBWQWOWR
      WSVUPUVSQUWJUYNUWDUYHSUTXGWTXAXBXCXDUWDFWDZUWNUWCUVAVUQUWMUWBUBUUNVUQUWLU
      WAUVHVUQUWEUVIUWIUVMUWKUVTUWDFUUPWNVUQUWHUVLUUGVUQUWGUVKVUQUWFUVJTUWDFUVB
      WQWOWRWSVUQUVSQUWJUUPUWDFSUTXGWTXAXBXCXDUVAUUOEHWAVAZUVDWDZUUEFWDZVTZUURU
      UKUUGUVNHUIZTUMZUOZRZUPZQUWSWEZWFZUXCAUUOUUKLXOAVVAUUKAVUSVUTOMXPXOUVAUUR
      UUKVVGAUURUUKUUSXOAUUKXQVVGUVAVVGVVFQUQWEVVFQXSVVFQUWSUQSXTYAYHWBYIUXBVVA
      VVHVTUBHUUNUVBHWDZUVHVVAUXAVVHVVIUVEVUSUVGVUTVVIUVCVURUVDUVBHEWAXGXHVVIUV
      FUUEFUVBHUHWQXHXFVVIUWRUUKUWTVVGUURVVIUWQUUJUUGVVIUWPUUIVVIUWOUUHTSUVBHXI
      WOWRWSVVIUVSVVFQUWSVVIUVRVVEVVIUVQVVDUUGVVIUVPVVCVVIUVOVVBTUVNUVBHXIWOWRW
      SXJXKXRXFYBYCUYGUYSWLUXJUGRUVAUYFUYRUVAUYEUYRBUUNUVAUXDUUNRZUYEVTZVTUFUBU
      UGCDQUEEUXJFGUXDIJACGRUUKVVKKYDUVAVVJUYEYEUYEUXFUVAVVJUXFUXHUYDYFYGUYEUXH
      UVAVVJUXFUXHUYDYJYGUYEUXKUVAVVJUXIUXKUXOUYCWIYGUYEUXOUVAVVJUXIUXKUXOUYCYK
      YGUYEUYCUVAVVJUXIUXKUXOUYCYLYGAUFUNZUHUIZFYMYNVAZWDZEVVLWAVAZUVDWDZVTZUFU
      UNWGZUPUUKVVKAUXGVVNWDZUXFVTZBUUNWGVVSPVWAVVRBUFUUNBUFXEZVVTVVOUXFVVQVWBU
      XGVVMVVNUXDVVLUHWQXHVWBUXEVVPUVDUXDVVLEWAXGXHXFXNYOYDYPYQYRWBYSYTUUAUUBUU
      C $.
  $}

  ${
    $d w x y D $.  $d w x y G $.  $d w x y T $.  $d w x W $.  $d w x y ph $.
    psgnunilem4.g $e |- G = ( SymGrp ` D ) $.
    psgnunilem4.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnunilem4.d $e |- ( ph -> D e. V ) $.
    psgnunilem4.w1 $e |- ( ph -> W e. Word T ) $.
    psgnunilem4.w2 $e |- ( ph -> ( G gsum W ) = ( _I |` D ) ) $.
    $( Lemma for ~ psgnuni .  An odd-length representation of the identity is
       impossible, as it could be repeatedly shortened to a length of 1, but a
       length 1 permutation must be a transposition.  (Contributed by Stefan
       O'Rear, 25-Aug-2015.) $)
    psgnunilem4 $p |- ( ph -> ( -u 1 ^ ( # ` W ) ) = 1 ) $=
      ( vx wcel co wceq c1 chash cexp wa wi vw cword cgsu cid cres cneg cfv cc0
      vy cv cn0 cuz cfn wrdfin hashcl 3syl nn0uz syl6eleq cfzo wal cfz c0 fveq2
      hash0 syl6eq oveq2d cc neg1cn exp0 ax-mp a1d wne w3a cmin wex wrex simpl1
      c2 wn syl simpl3l eqidd cn simpl2 hashnncl biimpar syl2anc simpl3r eqeq1d
      oveq2 anbi12d cbvrexv notbii biimpi adantl psgnunilem3 mpbir df-rex sylib
      iman simprl simprrr jca clt wbr simp3l simp2 adantr simprrl crp nnred 2rp
      cr ltsubrp sylancl eqbrtrd elfzo0 syl3anbrc id com13 sylc cdiv a1i ax-1cn
      ax-1ne0 negne0i cz nnzd expsubd sqneg sq1 eqtri oveq2i m1expcl zcnd div1d
      2z syl5eq eleq1 imbi12d 3eqtrd sylibd ex com23 alimdv 19.23v syl6ib com34
      mpid 3exp com12 imp3a pm2.61ine 3adant2 uzindi mp2and ) AFCUBZMZDFUCNZUDB
      UEZOZPUFZFQUGZRNZPOZJKAUAUJZUUQMZDUVFUCNZUUTOZSZUVBUVFQUGZRNZPOZTZLUJZUUQ
      MZDUVOUCNZUUTOZSZUVBUVOQUGZRNZPOZTZUURUVASZUVETUALFUVKUVTUVCUHUUQJAUVCUKU
      HULUGAUURFUMMUVCUKMJCFUNFUOUPUQURAUVTUHUVKUSNMZUWCTZLUTZUVNUVKUHUVCVANMAU
      WGSZUVNTUVFVBUVFVBOZUVNUWHUWIUVMUVJUWIUVLUVBUHRNZPUWIUVKUHUVBRUWIUVKVBQUG
      UHUVFVBQVCVDVEVFUVBVGMZUWJPOVHUVBVIVJVEVKVKUVFVBVLZAUWGUVNAUWLUWGUVNTAUWL
      UVJUWGUVMAUWLUVJUWGUVMTAUWLUVJVMZUWGUVPUVTUVKVRVNNZOZUVRSZSZLVOZUVMUWMUWP
      LUUQVPZUWRUWMUWSTUWMUWSVSZSZVSUXAUIBCDUVKEUVFGHUXAABEMAUWLUVJUWTVQIVTUVGU
      VIAUWLUWTWAZUXAUVKWBUXAUVFUMMZUWLUVKWCMZUXAUVGUXCUXBCUVFUNZVTAUWLUVJUWTWD
      UXCUXDUWLUVFWEWFZWGUVGUVIAUWLUWTWHUWTUIUJZQUGZUWNOZDUXGUCNZUUTOZSZUIUUQVP
      ZVSZUWMUWTUXNUWSUXMUWPUXLLUIUUQUVOUXGOZUWOUXIUVRUXKUXOUVTUXHUWNUVOUXGQVCW
      IUXOUVQUXJUUTUVOUXGDUCWJWIWKWLWMWNWOWPUWMUWSWTWQUWPLUUQWRWSUWMUWGUWQUVMTZ
      LUTUWRUVMTUWMUWFUXPLUWMUWQUWFUVMUWMUWQUWFUVMTUWMUWQSZUWFUWBUVMUXQUVSUWEUW
      FUWBTUXQUVPUVRUWMUVPUWPXAZUWMUVPUWOUVRXBXCUXQUVTUKMZUXDUVTUVKXDXEUWEUXQUV
      PUVOUMMUXSUXRCUVOUNUVOUOUPUWMUXDUWQUWMUXCUWLUXDUWMUVGUXCAUWLUVGUVIXFUXEVT
      AUWLUVJXGUXFWGXHZUXQUVTUWNUVKXDUWMUVPUWOUVRXIZUXQUVKXMMVRXJMUWNUVKXDXEUXQ
      UVKUXTXKXLUVKVRXNXOXPUVTUVKXQXRUWFUWEUVSUWBUWFXSXTYAUXQUWAUVLPUXQUWAUVBUW
      NRNUVLUVBVRRNZYBNZUVLUXQUVTUWNUVBRUYAVFUXQUVBUVKVRUWKUXQVHYCUVBUHVLUXQPYD
      YEYFYCVRYGMUXQYQYCUXQUVKUXTYHZYIUXQUYCUVLPYBNUVLUYBPUVLYBUYBPVRRNZPPVGMUY
      BUYEOYDPYJVJYKYLYMUXQUVLUXQUVKYGMZUVLVGMUYDUYFUVLUVKYNYOVTYPYRUUAWIUUBUUC
      UUDUUEUWQUVMLUUFUUGUUIUUJUUHUUKUULUUMUUNUVFUVOOZUVJUVSUVMUWBUYGUVGUVPUVIU
      VRUVFUVOUUQYSUYGUVHUVQUUTUVFUVODUCWJWIWKUYGUVLUWAPUYGUVKUVTUVBRUVFUVOQVCZ
      VFWIYTUVFFOZUVJUWDUVMUVEUYIUVGUURUVIUVAUVFFUUQYSUYIUVHUUSUUTUVFFDUCWJWIWK
      UYIUVLUVDPUYIUVKUVCUVBRUVFFQVCZVFWIYTUYHUYJUUOUUP $.
  $}

  $( Addition and subtraction of parities are the same.  (Contributed by Stefan
     O'Rear, 27-Aug-2015.) $)
  m1expaddsub $p |- ( ( X e. ZZ /\ Y e. ZZ ) ->
      ( -u 1 ^ ( X - Y ) ) = ( -u 1 ^ ( X + Y ) ) ) $=
    ( cz wcel c1 cneg cexp co cdiv cmul cc m1expcl adantl cc0 wne neg1cn ax-1cn
    zcnd ax-1ne0 wceq wa cmin caddc adantr negne0i expne0i mp3an12 cpr m1expcl2
    divrecd wo elpri divneg2 mp3an div1i negeqi eqtr3i 3eqtr4a jaoi 3syl oveq2d
    oveq2 id eqtrd expsub mpanl12 expaddz 3eqtr4d ) ACDZBCDZUAZEFZAGHZVLBGHZIHZ
    VMVNJHZVLABUBHGHZVLABUCHGHZVKVOVMEVNIHZJHVPVKVMVNVIVMKDVJVIVMALRUDVJVNKDVIV
    JVNBLRMVJVNNOZVIVLKDZVLNOZVJVTPEQSUEZVLBUFUGMUJVKVSVNVMJVJVSVNTZVIVJVNVLEUH
    DVNVLTZVNETZUKWDBUIVNVLEULWEWDWFWEEVLIHZVLVSVNEEIHZFZWGVLEKDZWJENOWIWGTQQSE
    EUMUNWHEEQUOZUPUQVNVLEIVBWEVCURWFWHEVSVNWKVNEEIVBWFVCURUSUTMVAVDWAWBVKVQVOT
    PWCVLABVEVFWAWBVKVRVPTPWCVLABVGVFVH $.

  ${
    psgnuni.g $e |- G = ( SymGrp ` D ) $.
    psgnuni.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnuni.d $e |- ( ph -> D e. V ) $.
    psgnuni.w $e |- ( ph -> W e. Word T ) $.
    psgnuni.x $e |- ( ph -> X e. Word T ) $.
    psgnuni.e $e |- ( ph -> ( G gsum W ) = ( G gsum X ) ) $.
    $( If the same permutation can be written in more than one way as a product
       of transpositions, the parity of those products must agree; otherwise
       the product of one with the inverse of the other would be an odd
       representation of the identity.  (Contributed by Stefan O'Rear,
       27-Aug-2015.) $)
    psgnuni $p |- ( ph -> ( -u 1 ^ ( # ` W ) ) = ( -u 1 ^ ( # ` X ) ) ) $=
      ( cfv cexp co wcel syl wceq syl2anc c1 cneg chash cword cn0 lencl m1expcl
      cz nn0zd zcnd cc0 wne neg1cn ax-1cn ax-1ne0 negne0i expne0i mp3an12 caddc
      cc cdiv cmin m1expaddsub wa expsub mpanl12 creverse cconcat revcl ccatlen
      eqtr3d revlen oveq2d eqtrd ccatcl cgsu cplusg c0g cid cres cminusg fveq2d
      eqid symgtrinv eqtr2d cgrp cbs symggrp cmnd grpmnd wss sswrd ax-mp sseldi
      symgtrf gsumwcl grprinv gsumccat syl3anc 3eqtr4d psgnunilem4 diveq1d
      symgid ) AUAUBZFUCNZOPZXDGUCNZOPZAXFAXEUHQZXFUHQAXEAFCUDZQZXEUEQKCFUFRUIZ
      XEUGRUJAXHAXGUHQZXHUHQAXGAGXJQZXGUEQLCGUFRUIZXGUGRUJAXMXHUKULZXOXDUTQZXDU
      KULZXMXPUMUAUNUOUPZXDXGUQURRAXDXEXGUSPZOPZXFXHVAPZUAAXDXEXGVBPOPZYAYBAXIX
      MYCYASXLXOXEXGVCTAXIXMYCYBSZXLXOXQXRXIXMVDYDUMXSXDXEXGVEVFTVKAXDFGVGNZVHP
      ZUCNZOPYAUAAYGXTXDOAYGXEYEUCNZUSPZXTAXKYEXJQZYGYISKAXNYJLCGVIRZCFYEVJTAYH
      XGXEUSAXNYHXGSLCGVLRVMVNVMABCDEYFHIJAXKYJYFXJQKYKCFYEVOTADFVPPZDYEVPPZDVQ
      NZPZDVRNZDYFVPPZVSBVTZAYOYLYLDWANZNZYNPZYPAYMYTYLYNAYTDGVPPZYSNZYMAYLUUBY
      SMWBABEQZXNUUCYMSJLBCDYSEGIHYSWCZWDTWEVMADWFQZYLDWGNZQZUUAYPSAUUDUUFJBDEH
      WHRZADWIQZFUUGUDZQZUUHAUUFUUJUUIDWJRZAXJUUKFCUUGWKXJUUKWKUUGBCDIHUUGWCZWO
      CUUGWLWMZKWNZUUGDFUUNWPTUUGYNDYSYLYPUUNYNWCZYPWCUUEWQTVNAUUJUULYEUUKQYQYO
      SUUMUUPAXJUUKYEUUOYKWNUUGYNDFYEUUNUUQWRWSAUUDYRYPSJBDEHXCRWTXAVKVKXB $.
  $}

  ${
    $d d p s w x $.  $d d s w x D $.  $d d x F $.  $d d G $.  $d d w T $.
    $d p B $.
    psgnfval.g $e |- G = ( SymGrp ` D ) $.
    psgnfval.b $e |- B = ( Base ` G ) $.
    psgnfval.f $e |- F = { p e. B | dom ( p \ _I ) e. Fin } $.
    psgnfval.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnfval.n $e |- N = ( pmSgn ` D ) $.
    $( Function definition of the permutation sign function.  (Contributed by
       Stefan O'Rear, 28-Aug-2015.) $)
    psgnfval $p |- N = ( x e. F |-> ( iota s E. w e. Word T
        ( x = ( G gsum w ) /\ s = ( -u 1 ^ ( # ` w ) ) ) ) ) $=
      ( cfv cv wceq cbs c0 vd cpsgn cgsu co c1 cneg chash cexp wa wrex cio cmpt
      cword cvv wcel cid cdif cdm cfn csymg crab cpmtr crn fveq2 syl6eqr fveq2d
      rabeq syl rneqd oveq1d eqeq2d anbi1d rexeqbidv iotabidv mpteq12dv df-psgn
      wrdeq fvex eqeltri rabex mptex fvmpt wn fvprc syl5eq base0 syl6eq mpteq1d
      rab0 mpt0 eqtr4d pm2.61i eqtri ) HDUBPZAFAQZGBQZUCUDZRZIQUEUFWPUGPUHUDRZU
      IZBEUMZUJZIUKZULZODUNUOZWNXDRUADAJQUPUQURUSUOZJUAQZUTPZSPZVAZWOXHWPUCUDZR
      ZWSUIZBXGVBPZVCZUMZUJZIUKZULXDUNUBXGDRZAXJXRFXCXSXJXFJCVAZFXSXICRXJXTRXSX
      IGSPZCXSXHGSXSXHDUTPZGXGDUTVDKVEZVFLVEXFJXICVGVHMVEXSXQXBIXSXMWTBXPXAXSXO
      ERXPXARXSXODVBPZVCEXSXNYDXGDVBVDVINVEXOEVQVHXSXLWRWSXSXKWQWOXSXHGWPUCYCVJ
      VKVLVMVNVOABIJUAVPAFXCFXTUNMXFJCCYAUNLGSVRVSVTVSWAWBXEWCZWNTXDDUBWDYEXDAT
      XCULTYEAFTXCYEFXTTMYEXTXFJTVAZTYECTRXTYFRYECYATLYEYATSPTYEGTSYEGYBTKDUTWD
      WEVFWFVEWEXFJCTVGVHXFJWIWGWEWHAXCWJWGWKWLWM $.
  $}

  ${
    $d p s w x $.  $d p B $.  $d s w x D $.  $d x F $.
    psgnfn.g $e |- G = ( SymGrp ` D ) $.
    psgnfn.b $e |- B = ( Base ` G ) $.
    psgnfn.f $e |- F = { p e. B | dom ( p \ _I ) e. Fin } $.
    psgnfn.n $e |- N = ( pmSgn ` D ) $.
    $( Functionality and domain of the permutation sign function.  (Contributed
       by Stefan O'Rear, 28-Aug-2015.) $)
    psgnfn $p |- N Fn F $=
      ( vx vw vs cv cgsu co wceq c1 cneg cfv chash cexp wa cpmtr crn cword wrex
      cio iotaex eqid psgnfval fnmpti ) KCKNDLNZOPQMNRSUMUATUBPQUCLBUDTUEZUFUGZ
      MUHEUOMUIKLABUNCDEMFGHIUNUJJUKUL $.
  $}

  ${
    $d p B $.  $d p P $.  $d p G $.
    psgneldm.g $e |- G = ( SymGrp ` D ) $.
    psgneldm.n $e |- N = ( pmSgn ` D ) $.
    $( The finitary permutations are a subgroup.  (Contributed by Stefan
       O'Rear, 28-Aug-2015.) $)
    psgndmsubg $p |- ( D e. V -> dom N e. ( SubGrp ` G ) ) $=
      ( vp wcel cdm cv cid cdif cfn cbs cfv crab csubg wfn wceq eqid fndm ax-mp
      psgnfn symgfisg syl5eqel ) ADHCIZGJKLIMHGBNOZPZBQOCUHRUFUHSUGAUHBCGEUGTZU
      HTFUCUHCUAUBGUGABDEUIUDUE $.

    psgneldm.b $e |- B = ( Base ` G ) $.
    $( Property of being a finitary permutation.  (Contributed by Stefan
       O'Rear, 28-Aug-2015.) $)
    psgneldm $p |- ( P e. dom N <-> ( P e. B /\ dom ( P \ _I ) e. Fin ) ) $=
      ( vp cv cid cdif cdm cfn wcel wceq difeq1 dmeqd eleq1d crab wfn eqid fndm
      psgnfn ax-mp elrab2 ) IJZKLZMZNOZCKLZMZNOICAEMZUGCPZUIULNUNUHUKUGCKQRSEUJ
      IATZUAUMUOPABUODEIFHUOUBGUDUOEUCUEUF $.
  $}

  ${
    $d s t w x G $.  $d s t w x N $.  $d s t w x P $.  $d s t w x T $.
    $d s t w p D $.  $d p G $.  $d p T $.  $d s p V $.  $d s w W $.
    psgnval.g $e |- G = ( SymGrp ` D ) $.
    psgnval.t $e |- T = ran ( pmTrsp ` D ) $.
    psgnval.n $e |- N = ( pmSgn ` D ) $.
    $( The finitary permutations are the span of the transpositons.
       (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    psgneldm2 $p |- ( D e. V -> ( P e. dom N <->
          E. w e. Word T P = ( G gsum w ) ) ) $=
      ( vp wcel cdm cword cv cgsu co wceq cfv eqid cmpt crn wrex cid cfn psgnfn
      cdif cbs crab wfn fndm ax-mp csubmnd cmrc symggen cmnd wss symggrp grpmnd
      cgrp symgtrf gsumwspan sylancl eqtr3d syl5eq eleq2d ovex elrnmpti syl6bb
      syl ) BGLZCFMZLCADNZEAOZPQZUAZUBZLCVORAVMUCVKVLVQCVKVLKOUDUGMUELKEUHSZUIZ
      VQFVSUJVLVSRVRBVSEFKHVRTZVSTJUFVSFUKULVKDEUMSUNSZSZVSVQKVRBDEWAGIHVTWATZU
      OVKEUPLZDVRUQWBVQRVKEUTLWDBEGHUREUSVJVRBDEIHVTVAAVRDWAEVTWCVBVCVDVEVFAVMV
      OCVPVPTEVNPVGVHVI $.

    $( A sequence of transpositions describes a finitary permutation.
       (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    psgneldm2i $p |- ( ( D e. V /\ W e. Word T ) ->
        ( G gsum W ) e. dom N ) $=
      ( vw cword wcel cgsu co cv wceq wrex cdm eqid oveq2 eqeq2d rspcev biimpar
      mpan2 psgneldm2 sylan2 ) FBKZLZAELZCFMNZCJOZMNZPZJUGQZUJDRLZUHUJUJPZUNUJS
      UMUPJFUGUKFPULUJUJUKFCMTUAUBUDUIUOUNJAUJBCDEGHIUEUCUF $.

    $( A finitary permutation has exactly one parity.  (Contributed by Stefan
       O'Rear, 28-Aug-2015.) $)
    psgneu $p |- ( P e. dom N -> E! s E. w e. Word T
            ( P = ( G gsum w ) /\ s = ( -u 1 ^ ( # ` w ) ) ) ) $=
      ( vx vt wcel cv cgsu co wceq cexp wa wrex cdm c1 cneg chash cfv cword wex
      wi wal weu cvv cbs cid cdif eqid psgneldm simplbi csymg elbasfv psgneldm2
      wb cfn syl ibi simpr ovex eqeq1 anbi2d spcev sylancl reximdva mpd rexcom4
      ex reeanv ad2antrr simplrl simplrr simprll simprrl eqtr3d psgnuni simprlr
      sylib simprrr 3eqtr4d syl5bir alrimivv rexbidv oveq2 eqeq2d fveq2 anbi12d
      rexlimdvva oveq2d cbvrexv syl6bb eu4 sylanbrc ) CFUAMZCEANZOPZQZGNZUBUCZX
      AUDUEZRPZQZSZADUFZTZGUGZXKCEKNZOPZQZLNZXEXMUDUEZRPZQZSZKXJTZSZXDXPQZUHZLU
      IGUIXKGUJWTXIGUGZAXJTZXLWTXCAXJTZYFWTYGWTBUKMZWTYGVAWTCEULUEZMZYHWTYJCUMU
      NUAVBMYIBCEFHJYIUOZUPUQYIEURCBHYKUSVCZABCDEFUKHIJUTVCVDWTXCYEAXJWTXAXJMZS
      ZXCYEYNXCSXCXGXGQZYEYNXCVEXGUOXIXCYOSGXGXEXFRVFXHXHYOXCXDXGXGVGVHVIVJVNVK
      VLXIAGXJVMWDWTYDGLYBXIXTSZKXJTAXJTWTYCXIXTAKXJXJVOWTYPYCAKXJXJWTYMXMXJMZS
      ZSZYPYCYSYPSZXGXRXDXPYTBDEUKXAXMHIWTYHYRYPYLVPWTYMYQYPVQWTYMYQYPVRYTCXBXN
      YSXCXHXTVSYSXIXOXSVTWAWBYSXCXHXTWCYSXIXOXSWEWFVNWNWGWHXKYAGLYCXKXCXPXGQZS
      ZAXJTYAYCXIUUBAXJYCXHUUAXCXDXPXGVGVHWIUUBXTAKXJXAXMQZXCXOUUAXSUUCXBXNCXAX
      MEOWJWKUUCXGXRXPUUCXFXQXERXAXMUDWLWOWKWMWPWQWRWS $.

    $( Value of the permutation sign function.  (Contributed by Stefan O'Rear,
       28-Aug-2015.) $)
    psgnval $p |- ( P e. dom N -> ( N ` P ) = ( iota s E. w e. Word T
        ( P = ( G gsum w ) /\ s = ( -u 1 ^ ( # ` w ) ) ) ) ) $=
      ( vt vx cv co wceq cfv wa wrex cio cdm cgsu cneg chash cword eqeq1 anbi1d
      c1 cexp rexbidv iotabidv cbs eqid cid cdif cfn wcel crab wfn psgnfn ax-mp
      fndm psgnfval iotaex fvmpt ) KCKMZEAMZUANZOZGMUGUBVFUCPUHNOZQZADUDZRZGSCV
      GOZVIQZAVKRZGSFTZFVECOZVLVOGVQVJVNAVKVQVHVMVIVECVGUEUFUIUJKAEUKPZBDVPEFGL
      HVRULZFLMUMUNTUOUPLVRUQZURVPVTOVRBVTEFLHVSVTULJUSVTFVAUTIJVBVOGVCVD $.

    $( A finitary permutation has at least one representation for its parity.
       (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    psgnvali $p |- ( P e. dom N -> E. w e. Word T ( P = ( G gsum w ) /\
            ( N ` P ) = ( -u 1 ^ ( # ` w ) ) ) ) $=
      ( vs cdm wcel cfv cv cgsu co wceq c1 wa wrex cneg chash cword cab psgnval
      cexp cio weu psgneu iotacl eqeltrd fvex eqeq1 anbi2d rexbidv elab sylib
      syl ) CFKLZCFMZCEANZOPQZJNZRUAVAUBMUFPZQZSZADUCZTZJUDZLVBUTVDQZSZAVGTZUSU
      TVHJUGZVIABCDEFJGHIUEUSVHJUHVMVILABCDEFJGHIUIVHJUJURUKVHVLJUTCFULVCUTQZVF
      VKAVGVNVEVJVBVCUTVDUMUNUOUPUQ $.

    $( Any representation of a permutation is length matching the permutation
       sign.  (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    psgnvalii $p |- ( ( D e. V /\ W e. Word T ) ->
        ( N ` ( G gsum W ) ) = ( -u 1 ^ ( # ` W ) ) ) $=
      ( vw vs wcel wa cgsu co cfv cv wceq chash cexp cword c1 cneg wrex cio cdm
      psgneldm2i psgnval simpr eqidd oveq2 eqeq2d fveq2 oveq2d anbi12d syl12anc
      syl rspcev cvv a1i weu psgneu wb eqeq1 anbi2d rexbidv adantl iota2d mpbid
      ovex eqtrd ) AELZFBUAZLZMZCFNOZDPZVPCJQZNOZRZKQZUBUCZVRSPZTOZRZMZJVMUDZKU
      EZWBFSPZTOZVOVPDUFLZVQWHRABCDEFGHIUGZJAVPBCDKGHIUHUQVOVTWJWDRZMZJVMUDZWHW
      JRVOVNVPVPRZWJWJRZWOVLVNUIVOVPUJVOWJUJWNWPWQMJFVMVRFRZVTWPWMWQWRVSVPVPVRF
      CNUKULWRWDWJWJWRWCWIWBTVRFSUMUNULUOURUPVOWGWOKWJUSWJUSLVOWBWITVJUTVOWKWGK
      VAWLJAVPBCDKGHIVBUQWAWJRZWGWOVCVOWSWFWNJVMWSWEWMVTWAWJWDVDVEVFVGVHVIVK $.

    $( All transpositions are odd.  (Contributed by Stefan O'Rear,
       29-Aug-2015.) $)
    psgnpmtr $p |- ( P e. T -> ( N ` P ) = -u 1 ) $=
      ( wcel cs1 cgsu co cfv c1 cneg cbs wceq syl cexp cvv eqid symgtrf gsumws1
      sseli fveq2d chash cword csymg elbasfv s1cl psgnvalii s1len oveq2i neg1cn
      syl2anc cc exp1 ax-mp eqtri syl6eq eqtr3d ) BCIZDBJZKLZEMZBEMNOZVBVDBEVBB
      DPMZIZVDBQCVGBVGACDGFVGUAZUBUDZVGBDVIUCRUEVBVEVFVCUFMZSLZVFVBATIZVCCUGIVE
      VLQVBVHVMVJVGDUHBAFVIUIRBCUJACDETVCFGHUKUOVLVFNSLZVFVKNVFSBULUMVFUPIVNVFQ
      UNVFUQURUSUTVA $.
  $}

  ${
    $d x y M $.
    cnmsgnsubg.m $e |- M = ( ( mulGrp ` CCfld ) |`s ( CC \ { 0 } ) ) $.
    $( The signs form a multiplicative subgroup of the complex numbers.
       (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    cnmsgnsubg $p |- { 1 , -u 1 } e. ( SubGrp ` M ) $=
      ( c1 wcel wceq cc ax-1cn syl6eqel neg1cn jaoi syl cc0 wne ax-1ne0 cmul co
      wa oveq12 eqeltri cdiv vx vy cneg cpr cv wo elpri eqnetrd negne0i mulid1i
      a1i 1ex prid1 negex prid2 mulid2i mul2negi eqtri ccase syl2an oveq2 div1i
      id divneg2 mp3an negeqi eqtr3i cnmsubglem ) UAUBCCUCZUDZABUAUEZVJDZVKCEZV
      KVIEZUFZVKFDZVKCVIUGZVMVPVNVMVKCFVMVCZGHVNVKVIFVNVCZIHJKVLVOVKLMZVQVMVTVN
      VMVKCLVRCLMZVMNUKUHVNVKVILVSVILMVNCGNUIUKUHJKVLVOUBUEZCEZWBVIEZUFVKWBOPZV
      JDZWBVJDVQWBCVIUGVMWCVNWDWFVMWCQWECCOPZVJVKCWBCORWGCVJCGUJZCVIULUMZSHVNWC
      QWEVICOPZVJVKVIWBCORWJVIVJVIIUJCVICUNUOZSHVMWDQWECVIOPZVJVKCWBVIORWLVIVJV
      IIUPWKSHVNWDQWEVIVIOPZVJVKVIWBVIORWMCVJWMWGCCCGGUQWHURWISHUSUTWIVLVOCVKTP
      ZVJDZVQVMWOVNVMWNCCTPZVJVKCCTVAWPCVJCGVBZWISHVNWNCVITPZVJVKVICTVAWRVIVJWP
      UCZWRVICFDZWTWAWSWREGGNCCVDVEWPCWQVFVGWKSHJKVH $.
  $}

  ${
    cnmsgngrp.u $e |- U = ( ( mulGrp ` CCfld ) |`s { 1 , -u 1 } ) $.
    $( The base set of the sign subgroup of the complex numbers.  (Contributed
       by Stefan O'Rear, 28-Aug-2015.) $)
    cnmsgnbas $p |- { 1 , -u 1 } = ( Base ` U ) $=
      ( c1 cneg cpr wss cbs cfv wceq wcel ax-1cn neg1cn prssi mp2an ccnfld cmgp
      cc eqid cnfldbas mgpbas ressbas2 ax-mp ) CCDZEZQFZUDAGHICQJUCQJUEKLCUCQMN
      UDQAOPHZBQOUFUFRSTUAUB $.

    $( The group of signs under multiplication.  (Contributed by Stefan O'Rear,
       28-Aug-2015.) $)
    cnmsgngrp $p |- U e. Grp $=
      ( c1 cneg cpr ccnfld cmgp cfv cc cc0 cress co wcel cvv wne ax-1cn ax-1ne0
      eldifsn mpbir2an mp2an csn cdif csubg cgrp eqid cnmsgnsubg wss wceq difss
      cnex ssexi neg1cn negne0i prssi ressabs eqtr4i subggrp ax-mp ) CCDZEZFGHZ
      IJUAZUBZKLZUCHMAUDMVDVDUEUFUTVDAAVAUTKLZVDUTKLZBVCNMUTVCUGZVFVEUHVCIUJIVB
      UIUKCVCMZUSVCMZVGVHCIMCJOPQCIJRSVIUSIMUSJOULCPQUMUSIJRSCUSVCUNTVCUTVANUOT
      UPUQUR $.
  $}

  ${
    $d w x y z D $.  $d w x y z N $.  $d w x y z S $.  $d w x y z V $.
    $d x y F $.  $d x y U $.
    psgnghm.s $e |- S = ( SymGrp ` D ) $.
    psgnghm.n $e |- N = ( pmSgn ` D ) $.
    psgnghm.f $e |- F = ( S |`s dom N ) $.
    psgnghm.u $e |- U = ( ( mulGrp ` CCfld ) |`s { 1 , -u 1 } ) $.
    $( The sign is a homomorphism from the finitary permutation group to the
       numeric signs.  (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    psgnghm $p |- ( D e. V -> N e. ( F GrpHom U ) ) $=
      ( vx vz vw wcel cfv cmul wceq ax-mp co wa vy cplusg cdm c1 cpr cbs wss cv
      cneg cid cdif cfn crab eqid psgnfn fndm ssrab2 eqsstri ressbas2 cnmsgnbas
      wfn cvv fvex eqeltri ressplusg prex ccnfld cmgp cnfldmul csubg psgndmsubg
      mgpplusg cgrp subggrp syl cnmsgngrp wral wfun fnfun funfn mpbi cgsu chash
      a1i wf cexp cpmtr cword wrex psgnvali wi cz lencl nn0zd m1expcl2 syl6eleq
      crn prcom adantl eleq1a adantld rexlimdva ralrimiv ffnfv sylanbrc anim12i
      syl5 reeanv sylibr cconcat ccatcl psgnvalii sylan2 symggrp grpmnd symgtrf
      cmnd sswrd sseli gsumccat syl3an 3expb fveq2d caddc ccatlen oveq2d neg1cn
      cc ad2antll ad2antrl expaddd eqtrd 3eqtr3d wb oveq12 eqeqan12d syl5ibrcom
      cn0 an4s rexlimdvva imp isghmd ) AFNZKUABUBOZPDCEEUCZUDUDUIZUEZUUEBUFOZUG
      UUEDUFOZQUUEKUHZUJUKUCULNZKUUHUMZUUHEUULVAZUUEUULQUUHAUULBEKGUUHUNZUULUNH
      UOZUULEUPRUUKKUUHUQURUUEUUHDBIUUNUSRZCJUTUUEVBNUUDDUBOQUUEUUIVBUUPDUFVCVD
      UUEUUDBDVBIUUDUNZVERUUGVBNPCUBOQUDUUFVFUUGPVGVHOZCVBJVGPUURUURUNVIVLVERUU
      CUUEBVJONDVMNABEFGHVKUUEBDIVNVOCVMNUUCCJVPWDUUCEUUEVAZUUJEOZUUGNZKUUEVQUU
      EUUGEWEUUSUUCEVRZUUSUUMUVBUUOUULEVSREVTWAWDUUCUVAKUUEUUJUUENZUUJBLUHZWBSZ
      QZUUTUUFUVDWCOZWFSZQZTZLAWGOWQZWHZWIZUUCUVALAUUJUVKBEGUVKUNZHWJZUUCUVJUVA
      LUVLUUCUVDUVLNZTZUVIUVAUVFUVQUVHUUGNZUVIUVAWKUVPUVRUUCUVPUVGWLNZUVRUVPUVG
      UVKUVDWMZWNUVSUVHUUFUDUEUUGUVGWOUUFUDWRWPVOWSUVHUUGUUTWTVOXAXBXGXCKUUEUUG
      EXDXEUUCUVCUAUHZUUENZTZUUJUWAUUDSZEOZUUTUWAEOZPSZQZUWCUVJUWABMUHZWBSZQZUW
      FUUFUWIWCOZWFSZQZTZTZMUVLWILUVLWIZUUCUWHUWCUVMUWOMUVLWIZTUWQUVCUVMUWBUWRU
      VOMAUWAUVKBEGUVNHWJXFUVJUWOLMUVLUVLXHXIUUCUWPUWHLMUVLUVLUUCUVPUWIUVLNZTZT
      ZUWHUWPUVEUWJUUDSZEOZUVHUWMPSZQZUXABUVDUWIXJSZWBSZEOZUUFUXFWCOZWFSZUXCUXD
      UWTUUCUXFUVLNUXHUXJQUVKUVDUWIXKAUVKBEFUXFGUVNHXLXMUXAUXGUXBEUUCUVPUWSUXGU
      XBQZUUCBXQNZUVPUVDUUHWHZNUWSUWIUXMNUXKUUCBVMNUXLABFGXNBXOVOUVLUXMUVDUVKUU
      HUGUVLUXMUGUUHAUVKBUVNGUUNXPUVKUUHXRRZXSUVLUXMUWIUXNXSUUHUUDBUVDUWIUUNUUQ
      XTYAYBYCUXAUXJUUFUVGUWLYDSZWFSUXDUXAUXIUXOUUFWFUWTUXIUXOQUUCUVKUVDUWIYEWS
      YFUXAUUFUVGUWLUUFYHNUXAYGWDUWSUWLYRNUUCUVPUVKUWIWMYIUVPUVGYRNUUCUWSUVTYJY
      KYLYMUVFUWKUVIUWNUWHUXEYNUVFUWKTZUVIUWNTUWEUXCUWGUXDUXPUWDUXBEUUJUVEUWAUW
      JUUDYOYCUUTUVHUWFUWMPYOYPYSYQYTXGUUAUUB $.
  $}

  ${
    $d x D $.  $d x S $.
    psgnghm2.s $e |- S = ( SymGrp ` D ) $.
    psgnghm2.n $e |- N = ( pmSgn ` D ) $.
    psgnghm2.u $e |- U = ( ( mulGrp ` CCfld ) |`s { 1 , -u 1 } ) $.
    $( The sign is a homomorphism from the finite symmetric group to the
       numeric signs.  (Contributed by Stefan O'Rear, 28-Aug-2015.) $)
    psgnghm2 $p |- ( D e. Fin -> N e. ( S GrpHom U ) ) $=
      ( vx cfn wcel cdm co cghm eqid cfv wceq wss cid ax-mp cvv psgnghm cv cdif
      cress cbs crab wral difss dmss wf1o elsymgbas2 f1odm syl5sseq ssfi sylan2
      ibi syl ralrimiva rabid2 sylibr wfn psgnfn fndm syl6eqr eqimss csymg fvex
      eqeltri cpsgn dmex ressid2 mp3an23 3syl oveq1d eleqtrd ) AIJZDBDKZUDLZCML
      BCMLABCVRDIEFVRNZGUAVPVRBCMVPBUEOZVQPVTVQQZVRBPZVPVTHUBZRUCZKZIJZHVTUFZVQ
      VPWFHVTUGVTWGPVPWFHVTWCVTJZVPWEAQWFWHWCKZWEAWDWCQWEWIQWCRUHWDWCUISWHAAWCU
      JZWIAPWHWJAVTWCBVTEVTNZUKUPAAWCULUQUMAWEUNUOURWFHVTUSUTDWGVAVQWGPVTAWGBDH
      EWKWGNFVBWGDVCSVDVTVQVEWABTJVQTJWBBAVFOTEAVFVGVHDDAVIOTFAVIVGVHVJVQVTVRBT
      TVSWKVKVLVMVNVO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The matrix algebra
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c maMul Mat $.
  $( Syntax for the matrix multiplication operator. $)
  cmmul $a class maMul $.
  $( Syntax for the square matrix algebra. $)
  cmat $a class Mat $.

  ${
    $d i j k m n o p r x y $.
    $( The operator which multiplies an MxN matrix with an NxP matrix.  Note
       that it is not generally possible to recover the dimensions from the
       matrix, since all Nx0 and all 0xN matrices are represented by the empty
       set.  (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    df-mamu $a |- maMul = ( r e. _V , o e. _V |-> [_ ( 1st ` ( 1st ` o ) ) /
        m ]_ [_ ( 2nd ` ( 1st ` o ) ) / n ]_ [_ ( 2nd ` o ) / p ]_ ( x e. ( (
        Base ` r ) ^m ( m X. n ) ) , y e. ( ( Base ` r ) ^m ( n X. p ) ) |->
        ( i e. m , k e. p |-> ( r gsum ( j e. n |-> ( ( i x j ) ( .r ` r ) ( j
        y k ) ) ) ) ) ) ) $.

    $( The algebra of NxN matrices over a ring...  (Contributed by Stefan
       O'Rear, 31-Aug-2015.) $)
    df-mat $a |- Mat = ( n e. Fin , r e. _V |-> ( ( r freeLMod ( n X. n ) )
        sSet <. ( .r ` ndx ) , ( r maMul <. n , n , n >. ) >. ) ) $.
  $}

  ${
    $d a i j k m n o p r x y $.  $d i j k o r x y M $.  $d i j k o r x y N $.
    $d i j k o r x y P $.  $d i j k o r x y R $.  $d i j k x y X $.
    $d i j k x y Y $.  $d i j k o r x y ph $.  $d o r x y B $.
    $d o r x y i k .x. $.  $d i j k I $.  $d i j k K $.
    mamufval.f $e |- F = ( R maMul <. M , N , P >. ) $.
    mamufval.b $e |- B = ( Base ` R ) $.
    mamufval.t $e |- .x. = ( .r ` R ) $.
    mamufval.r $e |- ( ph -> R e. V ) $.
    mamufval.m $e |- ( ph -> M e. Fin ) $.
    mamufval.n $e |- ( ph -> N e. Fin ) $.
    mamufval.p $e |- ( ph -> P e. Fin ) $.
    $( Functional value of the matrix multiplication operator.  (Contributed by
       Stefan O'Rear, 2-Sep-2015.) $)
    mamufval $p |- ( ph -> F =
        ( x e. ( B ^m ( M X. N ) ) , y e. ( B ^m ( N X. P ) ) |->
            ( i e. M , k e. P |-> ( R gsum ( j e. N |->
                ( ( i x j ) .x. ( j y k ) ) ) ) ) ) ) $=
      ( vr vo vm vn vp cotp cmmul co cxp cmap cmpt cgsu cmpt2 cvv c1st cfv c2nd
      cv cbs cmulr csb wceq df-mamu wa fvex nfcv eqidd xpeq2 oveq2d mpt2eq123dv
      a1i id csbief xpeq12 xpeq1d adantr mpteq12dv syl5eq csbie2 simprl syl6eqr
      simpr fveq2d fveq2 ad2antll cfn wcel ot1stg syl3anc eqtrd xpeq12d oveq12d
      ot2ndg ot3rdg syl oveqd elex otex ovex mpt2ex ovmpt2d ) AKFLMEUGZUHUIBCDL
      MUJZUKUIZDMEUJZUKUIZHJLEFIMHUSIUSZBUSUIZXHJUSCUSUIZGUIZULZUMUIZUNZUNZOAUB
      UCFXCUOUOUDUCUSZUPUQZUPUQZUEXQURUQZUFXPURUQZBCUBUSZUTUQZUDUSZUEUSZUJZUKUI
      ZYBYDUFUSZUJZUKUIZHJYCYGYAIYDXIXJYAVAUQZUIZULZUMUIZUNZUNZVBZVBVBZXOUHUOUH
      UBUCUOUOYQUNVCABCHIJUDUEUCUBUFVDVLAYAFVCZXPXCVCZVEZVEZYQBCYBXRXSUJZUKUIZY
      BXSXTUJZUKUIZHJXRXTYAIXSYKULZUMUIZUNZUNZXOUDUEXRXSYPUUIXQUPVFXQURVFYCXRVC
      ZYDXSVCZVEZYPBCYFYBYDXTUJZUKUIZHJYCXTYMUNZUNZUUIUFXTYOUUPXPURVFUFUUPVGYGX
      TVCZBCYFYIYNYFUUNUUOUUQYFVHUUQYHUUMYBUKYGXTYDVIVJUUQHJYCYGYMYCXTYMUUQYCVH
      UUQVMUUQYMVHVKVKVNUULBCYFUUNUUOUUCUUEUUHUULYEUUBYBUKYCXRYDXSVOVJUULUUMUUD
      YBUKUULYDXSXTUUJUUKWCZVPVJUULHJYCXTYMXRXTUUGUUJUUJUUKUUJVMVQUULXTVHUULYLU
      UFYAUMUULIYDYKXSYKUURUULYKVHVRVJVKVKVSVTUUABCUUCUUEUUHXEXGXNUUAYBDUUBXDUK
      UUAYBFUTUQDUUAYAFUTAYRYSWAZWDPWBZUUAXRLXSMUUAXRXCUPUQZUPUQZLYSXRUVBVCAYRY
      SXQUVAUPXPXCUPWEZWDWFAUVBLVCZYTALWGWHZMWGWHZEWGWHZUVDSTUALMEWGWGWGWIWJVQW
      KZUUAXSUVAURUQZMYSXSUVIVCAYRYSXQUVAURUVCWDWFAUVIMVCZYTAUVEUVFUVGUVJSTUALM
      EWGWGWGWNWJVQWKZWLWMUUAYBDUUDXFUKUUTUUAXSMXTEUVKUUAXTXCURUQZEYSXTUVLVCAYR
      XPXCURWEWFAUVLEVCZYTAUVGUVMUALMEWGWOWPVQWKZWLWMUUAHJXRXTUUGLEXMUVHUVNUUAY
      AFUUFXLUMUUSUUAIXSYKMXKUVKUUAYJGXIXJUUAYJFVAUQGUUAYAFVAUUSWDQWBWQVRWMVKVK
      VSAFNWHFUOWHRFNWRWPXCUOWHALMEWSVLXOUOWHABCXEXGXNDXDUKWTDXFUKWTXAVLXBVS $.

    mamuval.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
    mamuval.y $e |- ( ph -> Y e. ( B ^m ( N X. P ) ) ) $.
    $( Multiplication of two matrices.  (Contributed by Stefan O'Rear,
       2-Sep-2015.) $)
    mamuval $p |- ( ph -> ( X F Y ) = ( i e. M ,
            k e. P |-> ( R gsum ( j e. N |->
                ( ( i X j ) .x. ( j Y k ) ) ) ) ) ) $=
      ( vx vy cxp cmap co cv cmpt cgsu cmpt2 mamufval wceq eqidd oveq oveqan12d
      cvv adantl mpteq2dv oveq2d mpt2eq123dv cfn wcel mpt2exga syl2anc ovmpt2d
      wa ) AUDUEMNBJKUFUGUHBKCUFUGUHFHJCDGKFUIZGUIZUDUIZUHZVJHUIZUEUIZUHZEUHZUJ
      ZUKUHZULFHJCDGKVIVJMUHZVJVMNUHZEUHZUJZUKUHZULZIURAUDUEBCDEFGHIJKLOPQRSTUA
      UMAVKMUNZVNNUNZVHZVHZFHJCVRJCWCWHJUOWHCUOWHVQWBDUKWHGKVPWAWGVPWAUNAWEWFVL
      VSVOVTEVIVJVKMUPVJVMVNNUPUQUSUTVAVBUBUCAJVCVDCVCVDWDURVDSUAFHJCWCVCVCVEVF
      VG $.

    mamufv.i $e |- ( ph -> I e. M ) $.
    mamufv.k $e |- ( ph -> K e. P ) $.
    $( A cell in the multiplication of two matrices.  (Contributed by Stefan
       O'Rear, 2-Sep-2015.) $)
    mamufv $p |- ( ph -> ( I ( X F Y ) K ) = ( R gsum ( j e. N |->
        ( ( I X j ) .x. ( j Y K ) ) ) ) ) $=
      ( vi vk cv co cmpt cgsu cvv mamuval oveq1 oveq2 oveqan12d adantl mpteq2dv
      wceq wa oveq2d wcel ovex a1i ovmpt2d ) AUFUGHIJCDFKUFUHZFUHZMUIZVGUGUHZNU
      IZEUIZUJZUKUIDFKHVGMUIZVGINUIZEUIZUJZUKUIZMNGUIULABCDEUFFUGGJKLMNOPQRSTUA
      UBUCUMAVFHUSZVIIUSZUTZUTZVLVPDUKWAFKVKVOVTVKVOUSAVRVSVHVMVJVNEVFHVGMUNVII
      VGNUOUPUQURVAUDUEVQULVBADVPUKVCVDVE $.
  $}

  ${
    $d x y B $.  $d x y I $.  $d x y M $.  $d x y .+ $.  $d x y X $.
    $d x y Y $.
    mndvcl.b $e |- B = ( Base ` M ) $.
    mndvcl.p $e |- .+ = ( +g ` M ) $.
    $( Tuple-wise additive closure in monoids.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    mndvcl $p |- ( ( M e. Mnd /\ X e. ( B ^m I ) /\ Y e. ( B ^m I ) ) ->
        ( X oF .+ Y ) e. ( B ^m I ) ) $=
      ( vx vy cmnd wcel cmap co wf cvv cv elmapi 3ad2ant2 cbs w3a cof 3ad2antl1
      wa mndcl 3expb 3ad2ant3 elmapex simprd inidm off cfv fvex eqeltri sylancr
      wb elmapg mpbird ) DKLZEACMNZLZFUTLZUAZEFBUBNZUTLZCAVDOZVCIJCCCBAAAEFPPUS
      VAIQZALZJQZALZUDVGVIBNALZVBUSVHVJVKABDVGVIGHUEUFUCVAUSCAEOVBEACRSVBUSCAFO
      VAFACRUGVAUSCPLZVBVAAPLZVLEACUHUISZVNCUJUKVCVMVLVEVFUPADTULPGDTUMUNVNACVD
      PPUQUOUR $.

    $d x y z B $.  $d x y z I $.  $d x y z M $.  $d x y z .+ $.  $d x y z X $.
    $d x y z Y $.  $d x y z Z $.  $d x .0. $.
    $( Tuple-wise associativity in monoids.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    mndvass $p |- ( ( M e. Mnd /\ ( X e. ( B ^m I ) /\ Y e. ( B ^m I ) /\
            Z e. ( B ^m I ) ) ) ->
        ( ( X oF .+ Y ) oF .+ Z ) = ( X oF .+ ( Y oF .+ Z ) ) ) $=
      ( vx vy vz wcel co w3a cvv adantl wf elmapi cv cmnd cmap elmapex 3ad2ant1
      wa simprd 3ad2ant2 3ad2ant3 wceq mndass adantlr caofass ) DUAMZEACUBNZMZF
      UNMZGUNMZOZUEJKLCBBABEFGBPURCPMZUMUOUPUSUQUOAPMUSEACUCUFUDQURCAERZUMUOUPU
      TUQEACSUDQURCAFRZUMUPUOVAUQFACSUGQURCAGRZUMUQUOVBUPGACSUHQUMJTZAMKTZAMLTZ
      AMOVCVDBNVEBNVCVDVEBNBNUIURABDVCVDVEHIUJUKUL $.

    mndvlid.z $e |- .0. = ( 0g ` M ) $.
    $( Tuple-wise left identity in monoids.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    mndvlid $p |- ( ( M e. Mnd /\ X e. ( B ^m I ) ) ->
        ( ( I X. { .0. } ) oF .+ X ) = X ) $=
      ( vx cmnd wcel cmap co wa cvv elmapex simprd adantl wf elmapi adantr wceq
      mndidcl cv mndlid adantlr caofid0l ) DKLZEACMNLZOJCFBAEPAUJCPLZUIUJAPLUKE
      ACQRSUJCAETUIEACUASUIFALUJADFGIUDUBUIJUEZALFULBNULUCUJABDULFGHIUFUGUH $.

    $( Tuple-wise right identity in monoids.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    mndvrid $p |- ( ( M e. Mnd /\ X e. ( B ^m I ) ) ->
        ( X oF .+ ( I X. { .0. } ) ) = X ) $=
      ( vx cmnd wcel cmap co wa cvv elmapex simprd adantl wf elmapi adantr wceq
      mndidcl cv mndrid adantlr caofid0r ) DKLZEACMNLZOJCFBAEPAUJCPLZUIUJAPLUKE
      ACQRSUJCAETUIEACUASUIFALUJADFGIUDUBUIJUEZALULFBNULUCUJABDULFGHIUFUGUH $.
  $}

  ${
    $d x y B $.  $d x y G $.  $d x y I $.  $d x y N $.  $d x y .+ $.
    $d x y X $.  $d x y .0. $.
    grpvlinv.b $e |- B = ( Base ` G ) $.
    grpvlinv.p $e |- .+ = ( +g ` G ) $.
    grpvlinv.n $e |- N = ( invg ` G ) $.
    grpvlinv.z $e |- .0. = ( 0g ` G ) $.
    $( Tuple-wise left inverse in groups.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    grpvlinv $p |- ( ( G e. Grp /\ X e. ( B ^m I ) ) ->
        ( ( N o. X ) oF .+ X ) = ( I X. { .0. } ) ) $=
      ( vy vx wcel co cvv adantl wf adantr cfv cgrp cmap wa ccom elmapex simprd
      elmapi grpidcl grpinvf cmpt wceq fcompt syl2an grplinv adantlr caofinvl
      cv ) CUANZFADUBONZUCLMDGBAFEFUDZEPAUSDPNZURUSAPNVAFADUEUFQUSDAFRZURFADUGZ
      QURGANUSACGHKUHSURAAERZUSACEHJUIZSURVDVBUTMDMUQFTETUJUKUSVEVCMEFDAAULUMUR
      LUQZANVFETVFBOGUKUSABCEVFGHIKJUNUOUP $.

    $( Tuple-wise right inverse in groups.  (Contributed by Mario Carneiro,
       22-Sep-2015.) $)
    grpvrinv $p |- ( ( G e. Grp /\ X e. ( B ^m I ) ) ->
        ( X oF .+ ( N o. X ) ) = ( I X. { .0. } ) ) $=
      ( vx wcel co wa cfv cmpt wceq wf cvv cgrp cmap cv ccom cof csn cxp simpll
      elmapi adantl ffvelrnda grprinv syl2anc mpteq2dva elmapex simprd fvex a1i
      feqmptd grpinvf fcompt syl2an offval2 fconstmpt 3eqtr4d ) CUAMZFADUBNMZOZ
      LDLUCZFPZVJEPZBNZQLDGQZFEFUDZBUENDGUFUGZVHLDVLGVHVIDMZOZVFVJAMVLGRVFVGVPU
      HVHDAVIFVGDAFSZVFFADUIZUJZUKZABCEVJGHIKJULUMUNVHLDVJVKBFVNTATVGDTMZVFVGAT
      MWBFADUOUPUJWAVKTMVQVJEUQURVHLDAFVTUSVFAAESVRVNLDVKQRVGACEHJUTVSLEFDAAVAV
      BVCVOVMRVHLDGVDURVE $.
  $}

  ${
    $d y z B $.  $d y z F $.  $d y I $.  $d y M $.  $d y N $.  $d y z .+ $.
    $d y .+^ $.  $d y z X $.  $d y z Y $.
    mhmvlin.b $e |- B = ( Base ` M ) $.
    mhmvlin.p $e |- .+ = ( +g ` M ) $.
    mhmvlin.q $e |- .+^ = ( +g ` N ) $.
    $( Tuple extension of monoid homomorphisms.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    mhmvlin $p |- ( ( F e. ( M MndHom N ) /\ X e. ( B ^m I ) /\
          Y e. ( B ^m I ) ) -> ( F o. ( X oF .+ Y ) ) =
          ( ( F o. X ) oF .+^ ( F o. Y ) ) ) $=
      ( vy vz co wcel cfv cmpt ccom cvv cmhm cmap w3a cv cof wceq simpl1 elmapi
      wa wf 3ad2ant2 ffvelrnda 3ad2ant3 mhmlin syl3anc mpteq2dva mhmrcl1 adantr
      cmnd 3ad2antl1 mndcl elmapex feqmptd offval2 cbs eqid mhmf 3ad2ant1 fveq2
      simprd fmptco fvex a1i fcompt syl2anc 3eqtr4d ) DFGUAOPZHAEUBOZPZIVRPZUCZ
      MEMUDZHQZWBIQZBOZDQZRMEWCDQZWDDQZCOZRDHIBUEOZSDHSZDISZCUEOWAMEWFWIWAWBEPZ
      UIZVQWCAPZWDAPZWFWIUFVQVSVTWMUGWAEAWBHVSVQEAHUJZVTHAEUHUKZULZWAEAWBIVTVQE
      AIUJZVSIAEUHUMZULZABCFGDWCWDJKLUNUOUPWAMNEAWENUDZDQWFWJDWNFUSPZWOWPWEAPVQ
      VSWMXDVTVQXDWMFGDUQURUTWSXBABFWCWDJKVAUOWAMEWCWDBHITAAVTVQETPZVSVTATPXEIA
      EVBVJUMZWSXBWAMEAHWRVCWAMEAIXAVCVDWANAGVEQZDVQVSAXGDUJZVTAXGFGDJXGVFVGVHZ
      VCXCWEDVIVKWAMEWGWHCWKWLTTTXFWGTPWNWCDVLVMWHTPWNWDDVLVMWAXHWQWKMEWGRUFXIW
      RMDHEAXGVNVOWAXHWTWLMEWHRUFXIXAMDIEAXGVNVOVDVP $.
  $}

  ${
    rngvcl.b $e |- B = ( Base ` R ) $.
    rngvcl.t $e |- .x. = ( .r ` R ) $.
    $( Tuple-wise multiplication closure in monoids.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    rngvcl $p |- ( ( R e. Ring /\ X e. ( B ^m I ) /\ Y e. ( B ^m I ) ) ->
        ( X oF .x. Y ) e. ( B ^m I ) ) $=
      ( crg wcel cmgp cfv cmnd cmap co cof eqid rngmgp mgpbas mgpplusg syl3an1
      mndvcl ) BIJBKLZMJEADNOZJFUDJEFCPOUDJBUCUCQZRACDUCEFABUCUEGSBCUCUEHTUBUA
      $.
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k C $.  $d j k G $.  $d j k U $.  $d j V $.
    $d j k .0. $.  $d j k ph $.  $d k W $.
    gsumcom3.b $e |- B = ( Base ` G ) $.
    gsumcom3.z $e |- .0. = ( 0g ` G ) $.
    gsumcom3.g $e |- ( ph -> G e. CMnd ) $.
    gsumcom3.a $e |- ( ph -> A e. V ) $.
    gsumcom3.r $e |- ( ph -> C e. W ) $.
    gsumcom3.f $e |- ( ( ph /\ ( j e. A /\ k e. C ) ) -> X e. B ) $.
    gsumcom3.u $e |- ( ph -> U e. Fin ) $.
    gsumcom3.n $e |- ( ( ph /\ ( ( j e. A /\ k e. C ) /\ -. j U k ) )
       -> X = .0. ) $.
    $( A commutative law for finitely supported iterated sums.  (Contributed by
       Stefan O'Rear, 2-Nov-2015.) $)
    gsumcom3 $p |- ( ph -> ( G gsum ( j e. A |-> ( G gsum ( k e. C |->
        X ) ) ) ) = ( G gsum ( k e. C |-> ( G gsum ( j e. A |-> X ) ) ) ) ) $=
      ( cmpt2 cgsu co cmpt gsumcom wcel cv adantr gsum2d2 ancom2s cfn cnvfi syl
      ccnv wa wbr wn wceq ancom vex brcnv notbii anbi12i sylan2b 3eqtr3d ) AHFG
      BDKUAUBUCHGFDBKUAUBUCHFBHGDKUDUBUCUDUBUCHGDHFBKUDUBUCUDUBUCABCDEFGHIJKLMN
      OPQRSTUEABCDEFGHIJKLMNOPADJUFFUGZBUFZQUHRSTUIADCBEUNZGFHJIKLMNOQABIUFGUGZ
      DUFZPUHAVGVJKCUFRUJAEUKUFVHUKUFSEULUMVJVGUOZVIVFVHUPZUQZUOAVGVJUOZVFVIEUP
      ZUQZUOKLURVKVNVMVPVJVGUSVLVOVIVFEGUTFUTVAVBVCTVDUIVE $.
  $}

  ${
    $d j k A $.  $d j k B $.  $d j k C $.  $d j k G $.  $d j k ph $.
    gsumcom3fi.b $e |- B = ( Base ` G ) $.
    gsumcom3fi.g $e |- ( ph -> G e. CMnd ) $.
    gsumcom3fi.a $e |- ( ph -> A e. Fin ) $.
    gsumcom3fi.r $e |- ( ph -> C e. Fin ) $.
    gsumcom3fi.f $e |- ( ( ph /\ ( j e. A /\ k e. C ) ) -> X e. B ) $.
    $( A commutative law for finite iterated sums.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    gsumcom3fi $p |- ( ph -> ( G gsum ( j e. A |-> ( G gsum ( k e. C |->
        X ) ) ) ) = ( G gsum ( k e. C |-> ( G gsum ( j e. A |-> X ) ) ) ) ) $=
      ( cxp cfn c0g cfv wcel cv wa eqid xpfi syl2anc wbr wn wceq biimpri adantl
      brxp pm2.24d impr gsumcom3 ) ABCDBDNZEFGOOHGPQZIUNUAJKLMABORDORUMORKLBDUB
      UCAESZBRFSZDRTZUOUPUMUDZUEHUNUFZAUQTURUSUQURAURUQUOUPBDUIUGUHUJUKUL $.
  $}

  ${
    mamucl.b $e |- B = ( Base ` R ) $.
    mamucl.r $e |- ( ph -> R e. Ring ) $.

    ${
      $d i j k B $.  $d i j k M $.  $d i j k N $.  $d i j k P $.  $d i j k R $.
      $d i j k X $.  $d i j k Y $.  $d i j k ph $.
      mamucl.f $e |- F = ( R maMul <. M , N , P >. ) $.
      mamucl.m $e |- ( ph -> M e. Fin ) $.
      mamucl.n $e |- ( ph -> N e. Fin ) $.
      mamucl.p $e |- ( ph -> P e. Fin ) $.
      mamucl.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
      mamucl.y $e |- ( ph -> Y e. ( B ^m ( N X. P ) ) ) $.
      $( Operation closure of matrix multiplication.  (Contributed by Stefan
         O'Rear, 2-Sep-2015.) $)
      mamucl $p |- ( ph -> ( X F Y ) e. ( B ^m ( M X. P ) ) ) $=
        ( vi co wcel vk vj cmulr cfv cmpt cgsu cmpt2 cxp cmap eqid mamuval wral
        cv crg wa cfn c0g ccmn rngcmn syl adantr ad2antrr elmapi simplrl fovrnd
        wf simpr simplrr rngcl syl3anc fmptd cvv csn fisuppfi gsumcl ralrimivva
        cdif wb fvex eqeltri xpfi syl2anc elmapg sylancr fmpt2 syl6rbbr eqeltrd
        cbs mpbid ) AHIESRUAFCDUBGRUMZUBUMZHSZWKUAUMZISZDUCUDZSZUEZUFSZUGZBFCUH
        ZUISZABCDWORUBUAEFGUNHILJWOUJZKMNOPQUKAWRBTZUACULRFULZWSXATZAXCRUAFCAWJ
        FTZWMCTZUOZUOZGBWQDUPDUQUDZJXJUJADURTZXHADUNTZXKKDUSUTVAAGUPTXHNVAZXIUB
        GWPBWQXIWKGTZUOZXLWLBTWNBTWPBTAXLXHXNKVBXOWJWKBFGHAFGUHZBHVFZXHXNAHBXPU
        ISTXQPHBXPVCUTVBAXFXGXNVDXIXNVGZVEXOWKWMBGCIAGCUHZBIVFZXHXNAIBXSUISTXTQ
        IBXSVCUTVBXRAXFXGXNVHVEBDWOWLWNJXBVIVJWQUJVKZXIGBVLXJVMVQWQXMYAVNVOVPAX
        EWTBWSVFZXDABVLTWTUPTZXEYBVRBDWHUDVLJDWHVSVTAFUPTCUPTYCMOFCWAWBBWTWSVLU
        PWCWDRUAFCWRBWSWSUJWEWFWIWG $.
    $}

    ${
      $d i j B $.  $d i j M $.  $d i j ph $.
      mamudiag.o $e |- .1. = ( 1r ` R ) $.
      mamudiag.z $e |- .0. = ( 0g ` R ) $.
      mamudiag.i $e |- I = ( i e. M , j e. M |-> if ( i = j , .1. , .0. ) ) $.
      mamudiag.m $e |- ( ph -> M e. Fin ) $.
      $( Diagonal matrices are matrices.  (Contributed by Stefan O'Rear,
         2-Sep-2015.) $)
      mamudiagcl $p |- ( ph -> I e. ( B ^m ( M X. M ) ) ) $=
        ( wcel wral cv cvv cfn cxp cmap co wf weq cif wa rngidcl rng0cl syl2anc
        crg ifcl syl adantr ralrimivva fmpt2 sylib wb cbs cfv fvex eqeltri xpfi
        elmapg sylancr mpbird ) AGBHHUAZUBUCPZVGBGUDZAEFUEZDIUFZBPZFHQEHQVIAVLE
        FHHAVLERHPFRHPUGACUKPZVLKVMDBPIBPVLBCDJLUHBCIJMUIVJDIBULUJUMUNUOEFHHVKB
        GNUPUQABSPVGTPZVHVIURBCUSUTSJCUSVAVBAHTPZVOVNOOHHVCUJBVGGSTVDVEVF $.

      mamulid.n $e |- ( ph -> N e. Fin ) $.
      ${
        $d i j l m M $.  $d i j m B $.  $d i j .1. $.  $d i j m .0. $.
        $d i j l m ph $.  $d k l m I $.  $d k l F $.  $d k l m M $.
        $d k l m N $.  $d k l m X $.  $d k l m ph $.  $d m R $.
        mamulid.f $e |- F = ( R maMul <. M , M , N >. ) $.
        mamulid.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
        $( Diagonal matrices are left identities.  (Contributed by Stefan
           O'Rear, 3-Sep-2015.) $)
        mamulid $p |- ( ph -> ( I F X ) = X ) $=
          ( vl vk vm co wceq cv wral wcel wa cmulr cfv cmpt cgsu crg adantr cfn
          eqid cxp cmap mamudiagcl simprl simprr mamufv cmnd rngmnd ad2antrr wf
          syl elmapi simplrl simpr simplrr rngcl syl3anc fmptd csn cdif weq cif
          fovrnd eldifi adantl equequ1 ifbid equequ2 cur cvv eqeltri c0g ovmpt2
          fvex ifex syl2anc wn eldifsni necomd neneqd eqtrd oveq1d rnglz sylan2
          iffalse suppss2 gsumpt oveq2 oveq1 oveq12d ovex fvmpt ad2antrl iftrue
          equid ax-mp syl6eq anidms fovrnda rnglidm 3eqtrd ralrimivva wb mamucl
          wfn ffn eqfnov2 mpbird ) AHKGUEZKUFZUBUGZUCUGZYGUEZYIYJKUEZUFZUCJUHUB
          IUHZAYMUBUCIJAYIIUIZYJJUIZUJZUJZYKCUDIYIUDUGZHUEZYSYJKUEZCUKULZUEZUMZ
          UNUEYIUUDULZYLYRBJCUUBUDGYIYJIIUOHKTMUUBURZACUOUIZYQNUPZAIUQUIYQRUPZU
          UIAJUQUIYQSUPAHBIIUSZUTUEUIZYQABCDEFHILMNOPQRVAZUPAKBIJUSZUTUEZUIZYQU
          AUPAYOYPVBZAYOYPVCVDYRIBUUDCUQYILMPYRUUGCVEUIUUHCVFVIUUIUUPYRUDIUUCBU
          UDYRYSIUIZUJZUUGYTBUIUUABUIZUUCBUIAUUGYQUUQNVGZUURYIYSBIIHAUUJBHVHZYQ
          UUQAUUKUVAUULHBUUJVJVIVGAYOYPUUQVKYRUUQVLZWAUURYSYJBIJKAUUMBKVHZYQUUQ
          AUUOUVCUAKBUUMVJVIZVGUVBAYOYPUUQVMWAZBCUUBYTUUAMUUFVNVOUUDURZVPYRIUUC
          UDYIVQZLYRYSIUVGVRUIZUJZUUCLUUAUUBUEZLUVIYTLUUAUUBUVIYTUBUDVSZDLVTZLU
          VIYOUUQYTUVLUFAYOYPUVHVKUVHUUQYRYSIUVGWBZWCEFYIYSIIEFVSZDLVTZUVLHUBFV
          SZDLVTZEUBVSUVNUVPDLEUBFWDWEZFUDVSUVPUVKDLFUDUBWFWEQUVKDLDCWGULWHOCWG
          WLWIZLCWJULWHPCWJWLWIWMWKWNUVHUVLLUFZYRUVHUVKWOUVTUVHYIYSUVHYSYIYSIYI
          WPWQWRUVKDLXCVIWCWSWTUVHYRUUQUVJLUFZUVMUURUUGUUSUWAUUTUVEBCUUBUUALMUU
          FPXAWNXBWSXDXEYRUUEYIYIHUEZYLUUBUEZDYLUUBUEZYLYOUUEUWCUFAYPUDYIUUCUWC
          IUUDUDUBVSYTUWBUUAYLUUBYSYIYIHXFYSYIYJKXGXHUVFUWBYLUUBXIXJXKYRUWBDYLU
          UBYOUWBDUFZAYPYOUWEEFYIYIIIUVODHUVQUVRFUBVSZUVQUBUBVSZDLVTZDUWFUVPUWG
          DLFUBUBWFWEUWGUWHDUFUBXMUWGDLXLXNXOQUVSWKXPXKWTYRUUGYLBUIUWDYLUFUUHAY
          IYJBIJKUVDXQBCUUBDYLMUUFOXRWNXSXSXTAYGUUMYCZKUUMYCZYHYNYAAUUMBYGVHZUW
          IAYGUUNUIUWKABJCGIIHKMNTRRSUULUAYBYGBUUMVJVIUUMBYGYDVIAUVCUWJUVDUUMBK
          YDVIUBUCIJYGKYEWNYF $.
      $}

      ${
        $d i j k m M $.  $d i j k B $.  $d i j .1. $.  $d i j k .0. $.
        $d i j k m ph $.  $d k l m I $.  $d k l m N $.  $d k R $.
        $d k l m X $.  $d l m F $.  $d l m M $.  $d l m ph $.
        mamurid.f $e |- F = ( R maMul <. N , M , M >. ) $.
        mamurid.x $e |- ( ph -> X e. ( B ^m ( N X. M ) ) ) $.
        $( Diagonal matrices are right identities.  (Contributed by Stefan
           O'Rear, 3-Sep-2015.) $)
        mamurid $p |- ( ph -> ( X F I ) = X ) $=
          ( vl vm vk co wceq cv wral wcel wa cmulr cfv cmpt cgsu crg adantr cfn
          eqid cxp cmap mamudiagcl simprl simprr mamufv cmnd rngmnd ad2antrr wf
          syl elmapi simplrl simpr simplrr rngcl syl3anc fmptd csn cdif weq cif
          fovrnd eldifi equequ1 ifbid equequ2 cur cvv fvex eqeltri ifex syl2anc
          c0g ovmpt2 sylan2 eldifsni neneqd iffalse adantl eqtrd oveq2d suppss2
          wn rngrz gsumpt oveq2 oveq1 oveq12d ovex fvmpt ad2antll iftrue syl6eq
          ax-mp anidms fovrnda rngridm 3eqtrd ralrimivva wfn mamucl ffn eqfnov2
          wb mpbird ) AKHGUEZKUFZUBUGZUCUGZYEUEZYGYHKUEZUFZUCIUHUBJUHZAYKUBUCJI
          AYGJUIZYHIUIZUJZUJZYICUDIYGUDUGZKUEZYQYHHUEZCUKULZUEZUMZUNUEYHUUBULZY
          JYPBICYTUDGYGYHJIUOKHTMYTURZACUOUIZYONUPZAJUQUIYOSUPAIUQUIYORUPZUUGAK
          BJIUSZUTUEZUIZYOUAUPAHBIIUSZUTUEUIZYOABCDEFHILMNOPQRVAZUPAYMYNVBAYMYN
          VCZVDYPIBUUBCUQYHLMPYPUUECVEUIUUFCVFVIUUGUUNYPUDIUUABUUBYPYQIUIZUJZUU
          EYRBUIZYSBUIUUABUIAUUEYOUUONVGZUUPYGYQBJIKAUUHBKVHZYOUUOAUUJUUSUAKBUU
          HVJVIZVGAYMYNUUOVKYPUUOVLZWAZUUPYQYHBIIHAUUKBHVHZYOUUOAUULUVCUUMHBUUK
          VJVIVGUVAAYMYNUUOVMZWABCYTYRYSMUUDVNVOUUBURZVPYPIUUAUDYHVQZLYPYQIUVFV
          RUIZUJZUUAYRLYTUEZLUVHYSLYRYTUVHYSUDUCVSZDLVTZLUVGYPUUOYSUVKUFZYQIUVF
          WBZUUPUUOYNUVLUVAUVDEFYQYHIIEFVSZDLVTZUVKHUDFVSZDLVTEUDVSUVNUVPDLEUDF
          WCWDFUCVSZUVPUVJDLFUCUDWEWDQUVJDLDCWFULWGOCWFWHWIZLCWLULWGPCWLWHWIWJW
          MWKWNUVGUVKLUFZYPUVGUVJXBUVSUVGYQYHYQIYHWOWPUVJDLWQVIWRWSWTUVGYPUUOUV
          ILUFZUVMUUPUUEUUQUVTUURUVBBCYTYRLMUUDPXCWKWNWSXAXDYPUUCYJYHYHHUEZYTUE
          ZYJDYTUEZYJYNUUCUWBUFAYMUDYHUUAUWBIUUBUVJYRYJYSUWAYTYQYHYGKXEYQYHYHHX
          FXGUVEYJUWAYTXHXIXJYNUWBUWCUFAYMYNUWADYJYTYNUWADUFEFYHYHIIUVODHUCFVSZ
          DLVTZEUCVSUVNUWDDLEUCFWCWDUVQUWEUCUCVSZDLVTZDUVQUWDUWFDLFUCUCWEWDUWFU
          WGDUFYHURUWFDLXKXMXLQUVRWMXNWTXJYPUUEYJBUIUWCYJUFUUFAYGYHBJIKUUTXOBCY
          TDYJMUUDOXPWKXQXQXRAYEUUHXSZKUUHXSZYFYLYCAUUHBYEVHZUWHAYEUUIUIUWJABIC
          GJIKHMNTSRRUAUUMXTYEBUUHVJVIUUHBYEYAVIAUUSUWIUUTUUHBKYAVIUBUCJIYEKYBW
          KYD $.
      $}
    $}

    ${
      $d i j k l M $.  $d i j k F $.  $d i k G $.  $d i k H $.  $d i k l I $.
      $d i j k l P $.  $d i j k l X $.  $d i j k l Y $.  $d i j k l Z $.
      $d i j k l ph $.  $d j l B $.  $d j l N $.  $d j l O $.  $d j l R $.
      mamuass.m $e |- ( ph -> M e. Fin ) $.
      mamuass.n $e |- ( ph -> N e. Fin ) $.
      mamuass.o $e |- ( ph -> O e. Fin ) $.
      mamuass.p $e |- ( ph -> P e. Fin ) $.
      mamuass.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
      mamuass.y $e |- ( ph -> Y e. ( B ^m ( N X. O ) ) ) $.
      mamuass.z $e |- ( ph -> Z e. ( B ^m ( O X. P ) ) ) $.
      mamuass.f $e |- F = ( R maMul <. M , N , O >. ) $.
      mamuass.g $e |- G = ( R maMul <. M , O , P >. ) $.
      mamuass.h $e |- H = ( R maMul <. M , N , P >. ) $.
      mamuass.i $e |- I = ( R maMul <. N , O , P >. ) $.
      $( Matrix multiplication is associative.  (Contributed by Stefan O'Rear,
         5-Sep-2015.) $)
      mamuass $p |- ( ph -> ( ( X F Y ) G Z ) = ( X H ( Y I Z ) ) ) $=
        ( vi vk vj vl co wceq cv wral wcel wa cfv cmpt cgsu ccmn crg rngcmn syl
        cmulr adantr cfn ad2antrr cxp cmap elmapi simplrl fovrnd adantrl simprr
        wf simpr simprl simplrr adantrr eqid rngcl syl3anc mamufv oveq1d cplusg
        gsumcom3fi c0g anassrs cvv csn fmptd fisuppfi gsummulc1 rngass syl13anc
        cdif mpteq2dva oveq2d 3eqtr2d anass1rs eqtr4d 3eqtr4d mamucl ralrimivva
        gsummulc2 wfn wb ffn 3syl eqfnov2 syl2anc mpbird ) ALMEULZNFULZLMNHULZG
        ULZUMZUHUNZUIUNZXOULZXSXTXQULZUMZUICUOUHIUOZAYCUHUIICAXSIUPZXTCUPZUQZUQ
        ZDUJKXSUJUNZXNULZYIXTNULZDVEURZULZUSZUTULZDUKJXSUKUNZLULZYPXTXPULZYLULZ
        USZUTULZYAYBYHDUJKDUKJYQYPYIMULZYKYLULZYLULZUSZUTULZUSZUTULDUKJDUJKUUDU
        SUTULZUSZUTULYOUUAYHKBJUJUKDUUDOADVAUPZYGADVBUPZUUJPDVCVDVFAKVGUPZYGSVF
        ZAJVGUPZYGRVFZYHYIKUPZYPJUPZUQZUQZUUKYQBUPZUUCBUPZUUDBUPAUUKYGUURPVHZYH
        UUQUUTUUPYHUUQUQZXSYPBIJLAIJVIZBLVPZYGUUQALBUVDVJULUPZUVEUALBUVDVKVDVHA
        YEYFUUQVLYHUUQVQZVMZVNZUUSUUKUUBBUPZYKBUPZUVAUVBUUSYPYIBJKMAJKVIZBMVPZY
        GUURAMBUVLVJULUPZUVMUBMBUVLVKVDVHYHUUPUUQVOYHUUPUUQVRVMZYHUUPUVKUUQYHUU
        PUQZYIXTBKCNAKCVIZBNVPZYGUUPANBUVQVJULUPZUVRUCNBUVQVKVDVHYHUUPVQZAYEYFU
        UPVSVMZVTZBDYLUUBYKOYLWAZWBWCZBDYLYQUUCOUWCWBWCWGYHYNUUGDUTYHUJKYMUUFUV
        PYMDUKJYQUUBYLULZUSZUTULZYKYLULDUKJUWEYKYLULZUSZUTULUUFUVPYJUWGYKYLUVPB
        KDYLUKEXSYIIJVBLMUDOUWCAUUKYGUUPPVHZAIVGUPZYGUUPQVHAUUNYGUUPRVHZAUULYGU
        UPSVHAUVFYGUUPUAVHAUVNYGUUPUBVHAYEYFUUPVLUVTWDWEUVPJBDWFURZDYLUKVGUWEYK
        DWHURZOUWNWAZUWMWAZUWCUWJUWLUWAYHUUPUUQUWEBUPZUUSUUKUUTUVJUWQUVBUVIUVOB
        DYLYQUUBOUWCWBWCWIZUVPJBWJUWNWKWQZUWFUWLUVPUKJUWEBUWFUWRUWFWAWLWMWNUVPU
        WIUUEDUTUVPUKJUWHUUDYHUUPUUQUWHUUDUMZUUSUUKUUTUVJUVKUWTUVBUVIUVOUWBBDYL
        YQUUBYKOUWCWOWPWIWRWSWTWRWSYHYTUUIDUTYHUKJYSUUHUVCYSYQDUJKUUCUSZUTULZYL
        ULUUHUVCYRUXBYQYLUVCBCDYLUJHYPXTJKVBMNUGOUWCAUUKYGUUQPVHZAUUNYGUUQRVHAU
        ULYGUUQSVHZACVGUPZYGUUQTVHAUVNYGUUQUBVHAUVSYGUUQUCVHUVGAYEYFUUQVSWDWSUV
        CKBUWMDYLUJVGUUCYQUWNOUWOUWPUWCUXCUXDUVHYHUUPUUQUVAUWDXAZUVCKBUWSUXAUXD
        UVCUJKUUCBUXAUXFUXAWAWLWMXFXBWRWSXCYHBCDYLUJFXSXTIKVBXNNUEOUWCAUUKYGPVF
        ZAUWKYGQVFZUUMAUXEYGTVFZAXNBIKVIVJULUPYGABKDEIJLMOPUDQRSUAUBXDZVFAUVSYG
        UCVFAYEYFVRZAYEYFVOZWDYHBCDYLUKGXSXTIJVBLXPUFOUWCUXGUXHUUOUXIAUVFYGUAVF
        AXPBJCVIVJULUPYGABCDHJKMNOPUGRSTUBUCXDZVFUXKUXLWDXCXEAXOICVIZXGZXQUXNXG
        ZXRYDXHAXOBUXNVJULZUPUXNBXOVPUXOABCDFIKXNNOPUEQSTUXJUCXDXOBUXNVKUXNBXOX
        IXJAXQUXQUPUXNBXQVPUXPABCDGIJLXPOPUFQRTUAUXMXDXQBUXNVKUXNBXQXIXJUHUIICX
        OXQXKXLXM $.
    $}

    ${
      mamudi.f $e |- F = ( R maMul <. M , N , O >. ) $.
      mamudi.m $e |- ( ph -> M e. Fin ) $.
      mamudi.n $e |- ( ph -> N e. Fin ) $.
      mamudi.o $e |- ( ph -> O e. Fin ) $.

      ${
        $d i j k .+ $.  $d j B $.  $d i j k M $.  $d i j k O $.  $d i j k ph $.
        $d i k F $.  $d j N $.  $d i j k X $.  $d i j k Y $.  $d i j k Z $.
        $d j R $.
        mamudi.p $e |- .+ = ( +g ` R ) $.
        mamudi.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
        mamudi.y $e |- ( ph -> Y e. ( B ^m ( M X. N ) ) ) $.
        mamudi.z $e |- ( ph -> Z e. ( B ^m ( N X. O ) ) ) $.
        $( Matrix multiplication distributes over addition on the left.
           (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
        mamudi $p |- ( ph -> ( ( X oF .+ Y ) F Z ) =
            ( ( X F Z ) oF .+ ( Y F Z ) ) ) $=
          ( vi vk vj cof co wceq cv wral wcel cmulr cfv cmpt cgsu cfn eqid ccmn
          wa c0g crg rngcmn syl adantr ad2antrr cxp wf cmap elmapi simpr fovrnd
          simplrl simplrr rngcl syl3anc fmptd cvv csn cdif fisuppfi gsumadd cop
          wfn 3syl xpfi syl2anc opelxpi adantlr adantll fnfvof syl22anc oveq12i
          ffn df-ov 3eqtr4g oveq1d rngdir syl13anc eqtrd mpteq2dva eqidd eqtr4d
          offval2 oveq2d simprl simprr mamufv oveq12d cmnd rngmnd mndvcl mamucl
          3eqtr4d adantl ralrimivva wb eqfnov2 mpbird ) AIJCUEZUFZKEUFZIKEUFZJK
          EUFZXRUFZUGZUBUHZUCUHZXTUFZYEYFYCUFZUGZUCHUIUBFUIZAYIUBUCFHAYEFUJZYFH
          UJZURZURZDUDGYEUDUHZXSUFZYOYFKUFZDUKULZUFZUMZUNUFZYEYFYAUFZYEYFYBUFZC
          UFZYGYHYNDUDGYEYOIUFZYQYRUFZUMZUDGYEYOJUFZYQYRUFZUMZXRUFZUNUFDUUGUNUF
          ZDUUJUNUFZCUFUUAUUDYNGBCUUGDUUJUODUSULZLUUNUPRADUQUJZYMADUTUJZUUOMDVA
          VBVCAGUOUJZYMPVCZYNUDGUUFBUUGYNYOGUJZURZUUPUUEBUJZYQBUJZUUFBUJAUUPYMU
          USMVDZUUTYEYOBFGIAFGVEZBIVFZYMUUSAIBUVDVGUFZUJZUVESIBUVDVHZVBVDAYKYLU
          USVKZYNUUSVIZVJZUUTYOYFBGHKAGHVEZBKVFZYMUUSAKBUVLVGUFUJZUVMUAKBUVLVHV
          BVDUVJAYKYLUUSVLVJZBDYRUUEYQLYRUPZVMVNZUUGUPVOZYNUDGUUIBUUJUUTUUPUUHB
          UJZUVBUUIBUJUVCUUTYEYOBFGJAUVDBJVFZYMUUSAJUVFUJZUVTTJBUVDVHZVBVDUVIUV
          JVJZUVOBDYRUUHYQLUVPVMVNZUUJUPVOZYNGBVPUUNVQVRZUUGUURUVRVSYNGBUWFUUJU
          URUWEVSVTYNYTUUKDUNYNYTUDGUUFUUICUFZUMUUKYNUDGYSUWGUUTYSUUEUUHCUFZYQY
          RUFZUWGUUTYPUWHYQYRUUTYEYOWAZXSULZUWJIULZUWJJULZCUFZYPUWHUUTIUVDWBZJU
          VDWBZUVDUOUJZUWJUVDUJZUWKUWNUGUUTUVGUVEUWOAUVGYMUUSSVDUVHUVDBIWLWCUUT
          UWAUVTUWPAUWAYMUUSTVDUWBUVDBJWLWCAUWQYMUUSAFUOUJZUUQUWQOPFGWDWEVDYMUU
          SUWRAYKUUSUWRYLYEYOFGWFWGWHUVDCIJUOUWJWIWJYEYOXSWMUUEUWLUUHUWMCYEYOIW
          MYEYOJWMWKWNWOUUTUUPUVAUVSUVBUWIUWGUGUVCUVKUWCUVOBCDYRUUEUUHYQLRUVPWP
          WQWRWSYNUDGUUFUUICUUGUUJUOBBUURUVQUWDYNUUGWTYNUUJWTXBXAXCYNUUBUULUUCU
          UMCYNBHDYRUDEYEYFFGUTIKNLUVPAUUPYMMVCZAUWSYMOVCZUURAHUOUJZYMQVCZAUVGY
          MSVCAUVNYMUAVCZAYKYLXDZAYKYLXEZXFYNBHDYRUDEYEYFFGUTJKNLUVPUWTUXAUURUX
          CAUWAYMTVCUXDUXEUXFXFXGXLYNBHDYRUDEYEYFFGUTXSKNLUVPUWTUXAUURUXCAXSUVF
          UJZYMADXHUJZUVGUWAUXGAUUPUXHMDXIVBZSTBCUVDDIJLRXJVNZVCUXDUXEUXFXFYNYE
          YFWAZYCULZUXKYAULZUXKYBULZCUFZYHUUDYNYAFHVEZWBZYBUXPWBZUXPUOUJZUXKUXP
          UJZUXLUXOUGAUXQYMAYABUXPVGUFZUJZUXPBYAVFUXQABHDEFGIKLMNOPQSUAXKZYABUX
          PVHUXPBYAWLWCVCAUXRYMAYBUYAUJZUXPBYBVFUXRABHDEFGJKLMNOPQTUAXKZYBBUXPV
          HUXPBYBWLWCVCAUXSYMAUWSUXBUXSOQFHWDWEVCYMUXTAYEYFFHWFXMUXPCYAYBUOUXKW
          IWJYEYFYCWMUUBUXMUUCUXNCYEYFYAWMYEYFYBWMWKWNXLXNAXTUXPWBZYCUXPWBZYDYJ
          XOAXTUYAUJUXPBXTVFUYFABHDEFGXSKLMNOPQUXJUAXKXTBUXPVHUXPBXTWLWCAYCUYAU
          JZUXPBYCVFUYGAUXHUYBUYDUYHUXIUYCUYEBCUXPDYAYBLRXJVNYCBUXPVHUXPBYCWLWC
          UBUCFHXTYCXPWEXQ $.
      $}

      ${
        $d i j k .+ $.  $d j B $.  $d i j k M $.  $d i j k O $.  $d i j k ph $.
        $d i k F $.  $d j N $.  $d i j k X $.  $d i j k Y $.  $d i j k Z $.
        $d j R $.
        mamudir.p $e |- .+ = ( +g ` R ) $.
        mamudir.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
        mamudir.y $e |- ( ph -> Y e. ( B ^m ( N X. O ) ) ) $.
        mamudir.z $e |- ( ph -> Z e. ( B ^m ( N X. O ) ) ) $.
        $( Matrix multiplication distributes over addition on the right.
           (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
        mamudir $p |- ( ph -> ( X F ( Y oF .+ Z ) ) =
            ( ( X F Y ) oF .+ ( X F Z ) ) ) $=
          ( vi vk vj cof co wceq cv wral wcel cmulr cfv cmpt cgsu cfn eqid ccmn
          wa c0g crg rngcmn syl adantr ad2antrr cxp wf cmap elmapi simpr fovrnd
          simplrl simplrr rngcl syl3anc fmptd cvv csn cdif fisuppfi gsumadd cop
          wfn xpfi syl2anc opelxpi ancoms adantll fnfvof syl22anc df-ov oveq12i
          ffn 3eqtr4g oveq2d rngdi syl13anc eqtrd mpteq2dva eqidd eqtr4d simprl
          offval2 simprr mamufv oveq12d 3eqtr4d rngmnd mndvcl mamucl ralrimivva
          cmnd 3syl adantl wb eqfnov2 mpbird ) AIJKCUEZUFZEUFZIJEUFZIKEUFZXQUFZ
          UGZUBUHZUCUHZXSUFZYDYEYBUFZUGZUCHUIUBFUIZAYHUBUCFHAYDFUJZYEHUJZURZURZ
          DUDGYDUDUHZIUFZYNYEXRUFZDUKULZUFZUMZUNUFZYDYEXTUFZYDYEYAUFZCUFZYFYGYM
          DUDGYOYNYEJUFZYQUFZUMZUDGYOYNYEKUFZYQUFZUMZXQUFZUNUFDUUFUNUFZDUUIUNUF
          ZCUFYTUUCYMGBCUUFDUUIUODUSULZLUUMUPRADUQUJZYLADUTUJZUUNMDVAVBVCAGUOUJ
          ZYLPVCZYMUDGUUEBUUFYMYNGUJZURZUUOYOBUJZUUDBUJZUUEBUJAUUOYLUURMVDZUUSY
          DYNBFGIAFGVEZBIVFZYLUURAIBUVCVGUFUJZUVDSIBUVCVHVBVDAYJYKUURVKYMUURVIZ
          VJZUUSYNYEBGHJAGHVEZBJVFZYLUURAJBUVHVGUFZUJZUVITJBUVHVHVBVDZUVFAYJYKU
          URVLZVJZBDYQYOUUDLYQUPZVMVNZUUFUPVOZYMUDGUUHBUUIUUSUUOUUTUUGBUJZUUHBU
          JUVBUVGUUSYNYEBGHKAUVHBKVFZYLUURAKUVJUJZUVSUAKBUVHVHVBVDZUVFUVMVJZBDY
          QYOUUGLUVOVMVNZUUIUPVOZYMGBVPUUMVQVRZUUFUUQUVQVSYMGBUWEUUIUUQUWDVSVTY
          MYSUUJDUNYMYSUDGUUEUUHCUFZUMUUJYMUDGYRUWFUUSYRYOUUDUUGCUFZYQUFZUWFUUS
          YPUWGYOYQUUSYNYEWAZXRULZUWIJULZUWIKULZCUFZYPUWGUUSJUVHWBZKUVHWBZUVHUO
          UJZUWIUVHUJZUWJUWMUGUUSUVIUWNUVLUVHBJWLVBUUSUVSUWOUWAUVHBKWLVBAUWPYLU
          URAUUPHUOUJZUWPPQGHWCWDVDYLUURUWQAYKUURUWQYJUURYKUWQYNYEGHWEWFWGWGUVH
          CJKUOUWIWHWIYNYEXRWJUUDUWKUUGUWLCYNYEJWJYNYEKWJWKWMWNUUSUUOUUTUVAUVRU
          WHUWFUGUVBUVGUVNUWBBCDYQYOUUDUUGLRUVOWOWPWQWRYMUDGUUEUUHCUUFUUIUOBBUU
          QUVPUWCYMUUFWSYMUUIWSXBWTWNYMUUAUUKUUBUULCYMBHDYQUDEYDYEFGUTIJNLUVOAU
          UOYLMVCZAFUOUJZYLOVCZUUQAUWRYLQVCZAUVEYLSVCZAUVKYLTVCAYJYKXAZAYJYKXCZ
          XDYMBHDYQUDEYDYEFGUTIKNLUVOUWSUXAUUQUXBUXCAUVTYLUAVCUXDUXEXDXEXFYMBHD
          YQUDEYDYEFGUTIXRNLUVOUWSUXAUUQUXBUXCAXRUVJUJZYLADXKUJZUVKUVTUXFAUUOUX
          GMDXGVBZTUABCUVHDJKLRXHVNZVCUXDUXEXDYMYDYEWAZYBULZUXJXTULZUXJYAULZCUF
          ZYGUUCYMXTFHVEZWBZYAUXOWBZUXOUOUJZUXJUXOUJZUXKUXNUGAUXPYLAXTBUXOVGUFZ
          UJZUXOBXTVFUXPABHDEFGIJLMNOPQSTXIZXTBUXOVHUXOBXTWLXLVCAUXQYLAYAUXTUJZ
          UXOBYAVFUXQABHDEFGIKLMNOPQSUAXIZYABUXOVHUXOBYAWLXLVCAUXRYLAUWTUWRUXRO
          QFHWCWDVCYLUXSAYDYEFHWEXMUXOCXTYAUOUXJWHWIYDYEYBWJUUAUXLUUBUXMCYDYEXT
          WJYDYEYAWJWKWMXFXJAXSUXOWBZYBUXOWBZYCYIXNAXSUXTUJUXOBXSVFUYEABHDEFGIX
          RLMNOPQSUXIXIXSBUXOVHUXOBXSWLXLAYBUXTUJZUXOBYBVFUYFAUXGUYAUYCUYGUXHUY
          BUYDBCUXODXTYALRXHVNYBBUXOVHUXOBYBWLXLUBUCFHXSYBXOWDXP $.
      $}

      ${
        $d i j k C $.  $d i k D $.  $d i k F $.  $d i j k M $.  $d i j k N $.
        $d i j k O $.  $d i j k .x. $.  $d i j k X $.  $d i j k Y $.
        $d i j k Z $.  $d i j k ph $.  $d j B $.  $d j R $.
        mamuvs1.t $e |- .x. = ( .r ` R ) $.
        mamuvs1.x $e |- ( ph -> X e. B ) $.
        mamuvs1.y $e |- ( ph -> Y e. ( B ^m ( M X. N ) ) ) $.
        mamuvs1.z $e |- ( ph -> Z e. ( B ^m ( N X. O ) ) ) $.
        $( Matrix multiplication distributes over scalar multiplication on the
           left.  (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
        mamuvs1 $p |- ( ph -> ( ( ( ( M X. N ) X. { X } ) oF .x. Y ) F Z ) =
              ( ( ( M X. O ) X. { X } ) oF .x. ( Y F Z ) ) ) $=
          ( vi vk vj cxp csn cof co wceq wral wcel cmpt cgsu cplusg cfv cfn c0g
          cv wa eqid crg adantr ad2antrr cmap elmapi syl simplrl fovrnd simplrr
          wf simpr rngcl syl3anc cvv cdif fmptd fisuppfi gsummulc2 df-ov simprl
          cop opelxpi sylan xpfi syl2anc wfn ffn 3syl eqcomi ofc1 syl5eq oveq1d
          a1i mpdan rngass syl13anc eqtrd oveq2d simprr mamufv 3eqtr4d fconst6g
          mpteq2dva cbs fvex eqeltri elmapg sylancr mpbird rngvcl adantl mamucl
          wb ralrimivva eqfnov2 ) AFGUEZIUFZUEZJDUGZUHZKEUHZFHUEZXQUEZJKEUHZXSU
          HZUIZUBURZUCURZYAUHZYGYHYEUHZUIZUCHUJUBFUJZAYKUBUCFHAYGFUKZYHHUKZUSZU
          SZCUDGYGUDURZXTUHZYQYHKUHZDUHZULZUMUHZIYGYHYDUHZDUHZYIYJYPCUDGIYGYQJU
          HZYSDUHZDUHZULZUMUHICUDGUUFULZUMUHZDUHUUBUUDYPGBCUNUOZCDUDUPUUFICUQUO
          ZLUULUTUUKUTRACVAUKZYOMVBZAGUPUKZYOPVBZAIBUKZYOSVBZYPYQGUKZUSZUUMUUEB
          UKZYSBUKZUUFBUKAUUMYOUUSMVCZUUTYGYQBFGJAXPBJVJZYOUUSAJBXPVDUHZUKZUVDT
          JBXPVEZVFVCAYMYNUUSVGYPUUSVKZVHZUUTYQYHBGHKAGHUEZBKVJZYOUUSAKBUVJVDUH
          UKZUVKUAKBUVJVEVFVCUVHAYMYNUUSVIVHZBCDUUEYSLRVLVMZYPGBVNUULUFVOUUIUUP
          YPUDGUUFBUUIUVNUUIUTVPVQVRYPUUAUUHCUMYPUDGYTUUGUUTYTIUUEDUHZYSDUHZUUG
          UUTYRUVOYSDUUTYRYGYQWAZXTUOZUVOYGYQXTVSUUTUVQXPUKZUVRUVOUIYPYMUUSUVSA
          YMYNVTZYGYQFGWBWCUUTXPIUUEDJUPBUVQAXPUPUKZYOUUSAFUPUKZUUOUWAOPFGWDWEZ
          VCAUUQYOUUSSVCZAJXPWFZYOUUSAUVFUVDUWETUVGXPBJWGWHVCUVQJUOZUUEUIUUTUVS
          USUUEUWFYGYQJVSWIWMWJWNWKWLUUTUUMUUQUVAUVBUVPUUGUIUVCUWDUVIUVMBCDIUUE
          YSLRWOWPWQXCWRYPUUCUUJIDYPBHCDUDEYGYHFGVAJKNLRUUNAUWBYOOVBZUUPAHUPUKZ
          YOQVBZAUVFYOTVBAUVLYOUAVBZUVTAYMYNWSZWTWRXAYPBHCDUDEYGYHFGVAXTKNLRUUN
          UWGUUPUWIAXTUVEUKZYOAUUMXRUVEUKZUVFUWLMAUWMXPBXRVJZAUUQUWNSXPIBXBVFAB
          VNUKZUWAUWMUWNXMBCXDUOVNLCXDXEXFZUWCBXPXRVNUPXGXHXITBCDXPXRJLRXJVMZVB
          UWJUVTUWKWTYPYJYGYHWAZYEUOZUUDYGYHYEVSYPUWRYBUKZUWSUUDUIYOUWTAYGYHFHW
          BXKYPYBIUUCDYDUPBUWRAYBUPUKZYOAUWBUWHUXAOQFHWDWEZVBUURAYDYBWFZYOAYDBY
          BVDUHZUKZYBBYDVJUXCABHCEFGJKLMNOPQTUAXLZYDBYBVEYBBYDWGWHVBUWRYDUOZUUC
          UIYPUWTUSUUCUXGYGYHYDVSWIWMWJWNWKXAXNAYAYBWFZYEYBWFZYFYLXMAYAUXDUKYBB
          YAVJUXHABHCEFGXTKLMNOPQUWQUAXLYABYBVEYBBYAWGWHAYEUXDUKZYBBYEVJUXIAUUM
          YCUXDUKZUXEUXJMAUXKYBBYCVJZAUUQUXLSYBIBXBVFAUWOUXAUXKUXLXMUWPUXBBYBYC
          VNUPXGXHXIUXFBCDYBYCYDLRXJVMYEBYBVEYBBYEWGWHUBUCFHYAYEXOWEXI $.
      $}
    $}
  $}

  ${
    $d i j k C $.  $d i k D $.  $d i k F $.  $d i j k M $.  $d i j k N $.
    $d i j k O $.  $d i j k .x. $.  $d i j k X $.  $d i j k Y $.  $d i j k Z $.
    $d i j k ph $.  $d j B $.  $d j R $.
    mamuvs2.r $e |- ( ph -> R e. CRing ) $.
    mamuvs2.b $e |- B = ( Base ` R ) $.
    mamuvs2.t $e |- .x. = ( .r ` R ) $.
    mamuvs2.f $e |- F = ( R maMul <. M , N , O >. ) $.
    mamuvs2.m $e |- ( ph -> M e. Fin ) $.
    mamuvs2.n $e |- ( ph -> N e. Fin ) $.
    mamuvs2.o $e |- ( ph -> O e. Fin ) $.
    mamuvs2.x $e |- ( ph -> X e. ( B ^m ( M X. N ) ) ) $.
    mamuvs2.y $e |- ( ph -> Y e. B ) $.
    mamuvs2.z $e |- ( ph -> Z e. ( B ^m ( N X. O ) ) ) $.
    $( Matrix multiplication distributes over scalar multiplication on the
       left.  (Contributed by Stefan O'Rear, 5-Sep-2015.) $)
    mamuvs2 $p |- ( ph -> ( X F ( ( ( N X. O ) X. { Y } ) oF .x. Z ) ) =
          ( ( ( M X. O ) X. { Y } ) oF .x. ( X F Z ) ) ) $=
      ( vi vk vj cxp csn cof co wceq cv wral wcel cmpt cgsu cop cfv df-ov simpr
      simplrr opelxpi syl2anc cfn xpfi ad2antrr wfn cmap elmapi ffn 3syl eqcomi
      wa wf a1i ofc1 mpdan syl5eq oveq2d cmgp ccmn ccrg eqid crngmgp syl fovrnd
      simplrl mgpbas mgpplusg cmn12 syl13anc eqtrd mpteq2dva cplusg c0g crngrng
      crg adantr rngcl syl3anc cvv cdif fisuppfi gsummulc2 fconst6g wb cbs fvex
      eqeltri elmapg sylancr mpbird rngvcl simprl simprr mamufv syl5eqr 3eqtr4d
      fmptd adantl mamucl ralrimivva eqfnov2 ) AIGHUEZJUFZUEZKDUGZUHZEUHZFHUEZY
      CUEZIKEUHZYEUHZUIZUBUJZUCUJZYGUHZYMYNYKUHZUIZUCHUKUBFUKZAYQUBUCFHAYMFULZY
      NHULZVKZVKZCUDGYMUDUJZIUHZUUCYNYFUHZDUHZUMZUNUHZJCUDGUUDUUCYNKUHZDUHZUMZU
      NUHZDUHZYOYPUUBUUHCUDGJUUJDUHZUMZUNUHUUMUUBUUGUUOCUNUUBUDGUUFUUNUUBUUCGUL
      ZVKZUUFUUDJUUIDUHZDUHZUUNUUQUUEUURUUDDUUQUUEUUCYNUOZYFUPZUURUUCYNYFUQUUQU
      UTYBULZUVAUURUIUUQUUPYTUVBUUBUUPURZAYSYTUUPUSZUUCYNGHUTVAUUQYBJUUIDKVBBUU
      TAYBVBULZUUAUUPAGVBULZHVBULZUVEQRGHVCVAZVDAJBULZUUAUUPTVDZAKYBVEZUUAUUPAK
      BYBVFUHZULZYBBKVLZUVKUAKBYBVGZYBBKVHVIVDUUTKUPZUUIUIUUQUVBVKUUIUVPUUCYNKU
      QVJVMVNVOVPVQUUQCVRUPZVSULZUUDBULZUVIUUIBULZUUSUUNUIAUVRUUAUUPACVTULZUVRL
      CUVQUVQWAZWBWCVDUUQYMUUCBFGIAFGUEZBIVLZUUAUUPAIBUWCVFUHULZUWDSIBUWCVGWCVD
      AYSYTUUPWEUVCWDZUVJUUQUUCYNBGHKAUVNUUAUUPAUVMUVNUAUVOWCVDUVCUVDWDZBDUVQUU
      DJUUIBCUVQUWBMWFCDUVQUWBNWGWHWIWJWKVQUUBGBCWLUPZCDUDVBUUJJCWMUPZMUWIWAUWH
      WANACWOULZUUAAUWAUWJLCWNWCZWPAUVFUUAQWPZAUVIUUATWPZUUQUWJUVSUVTUUJBULAUWJ
      UUAUUPUWKVDUWFUWGBCDUUDUUIMNWQWRZUUBGBWSUWIUFWTUUKUWLUUBUDGUUJBUUKUWNUUKW
      AXQXAXBWJUUBBHCDUDEYMYNFGVTIYFOMNAUWAUUALWPZAFVBULZUUAPWPZUWLAUVGUUARWPZA
      UWEUUASWPZAYFUVLULZUUAAUWJYDUVLULZUVMUWTUWKAUXAYBBYDVLZAUVIUXBTYBJBXCWCAB
      WSULZUVEUXAUXBXDBCXEUPWSMCXEXFXGZUVHBYBYDWSVBXHXIXJUABCDYBYDKMNXKWRZWPAYS
      YTXLZAYSYTXMZXNUUBYPYMYNUOZYKUPZUUMYMYNYKUQUUBUXHYHULZUXIUUMUIUUAUXJAYMYN
      FHUTXRUUBYHJUULDYJVBBUXHAYHVBULZUUAAUWPUVGUXKPRFHVCVAZWPUWMAYJYHVEZUUAAYJ
      BYHVFUHZULZYHBYJVLUXMABHCEFGIKMUWKOPQRSUAXSZYJBYHVGYHBYJVHVIWPUUBUXHYJUPZ
      UULUIUXJUUBUXQYMYNYJUHUULYMYNYJUQUUBBHCDUDEYMYNFGVTIKOMNUWOUWQUWLUWRUWSAU
      VMUUAUAWPUXFUXGXNXOWPVNVOVPXPXTAYGYHVEZYKYHVEZYLYRXDAYGUXNULYHBYGVLUXRABH
      CEFGIYFMUWKOPQRSUXEXSYGBYHVGYHBYGVHVIAYKUXNULZYHBYKVLUXSAUWJYIUXNULZUXOUX
      TUWKAUYAYHBYIVLZAUVIUYBTYHJBXCWCAUXCUXKUYAUYBXDUXDUXLBYHYIWSVBXHXIXJUXPBC
      DYHYIYJMNXKWRYKBYHVGYHBYKVHVIUBUCFHYGYKYAVAXJ $.
  $}

  ${
    $d n r G $.  $d n r N $.  $d n r R $.  $d n r .x. $.
    matval.a $e |- A = ( N Mat R ) $.
    matval.g $e |- G = ( R freeLMod ( N X. N ) ) $.
    matval.t $e |- .x. = ( R maMul <. N , N , N >. ) $.
    $( Value of the matrix algebra.  (Contributed by Stefan O'Rear,
       4-Sep-2015.) $)
    matval $p |- ( ( N e. Fin /\ R e. V ) ->
        A = ( G sSet <. ( .r ` ndx ) , .x. >. ) ) $=
      ( vn vr cfn wcel wa cmat co csts wceq cfrlm cmmul cnx cfv cop cvv elex cv
      cmulr cxp cotp id xpeq12d oveqan12rd syl6eqr oteq123d opeq2d oveq12d ovex
      df-mat ovmpt2a sylan2 syl5eq ) ELMZBFMZNAEBOPZDUAUGUBZCUCZQPZGVCVBBUDMVDV
      GRBFUEJKEBLUDKUFZJUFZVIUHZSPZVEVHVIVIVIUIZTPZUCZQPVGOVIERZVHBRZNZVKDVNVFQ
      VQVKBEEUHZSPDVPVOVHBVJVRSVPUJZVOVIEVIEVOUJZVTUKULHUMVQVMCVEVQVMBEEEUIZTPC
      VPVOVHBVLWATVSVOVIEVIEVIEVTVTVTUNULIUMUOUPJKURDVFQUQUSUTVA $.
  $}

  ${
    $d a b $.
    matrcl.a $e |- A = ( N Mat R ) $.
    matrcl.b $e |- B = ( Base ` A ) $.
    $( Reverse closure for the matrix algebra.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    matrcl $p |- ( X e. B -> ( N e. Fin /\ R e. _V ) ) $=
      ( va vb wcel c0 wceq cfn cvv wa cbs cfv cmat co cv n0i wn cxp cfrlm cmulr
      cnx cotp cmmul cop csts df-mat mpt2ndm0 syl5eq fveq2d base0 3eqtr4g nsyl2
      ) EBJBKLDMJCNJOZBEUAURUBZAPQKPQBKUSAKPUSADCRSKFHIITZHTZVAUCUDSUFUEQUTVAVA
      VAUGUHSUIUJSRDCMNHIUKULUMUNGUOUPUQ $.
  $}

  ${
    $d a N $.  $d a R $.  $d a .x. $.
    matmulr.a $e |- A = ( N Mat R ) $.
    matmulr.t $e |- .x. = ( R maMul <. N , N , N >. ) $.
    $( Multiplication in the matrix algebra.  (Contributed by Stefan O'Rear,
       4-Sep-2015.) $)
    matmulr $p |- ( ( N e. Fin /\ R e. V ) -> .x. = ( .r ` A ) ) $=
      ( cfn wcel wa cxp cfrlm co cnx cmulr cfv cop cvv ovex cmmul pm3.2i mulrid
      csts wceq cotp eqeltri setsid mp1i eqid matval fveq2d eqtr4d ) DHIBEIJZCB
      DDKZLMZNOPCQUCMZOPZAOPUORIZCRIZJCUQUDUMURUSBUNLSCBDDDUEZTMRGBUTTSUFUARCOR
      UOUBUGUHUMAUPOABCUODEFUOUIGUJUKUL $.
  $}

  ${
    $d a G $.  $d a N $.  $d a R $.
    matbas.a $e |- A = ( N Mat R ) $.
    matbas.g $e |- G = ( R freeLMod ( N X. N ) ) $.
    $( The matrix ring has the same base set as its underlying group.
       (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    matbas $p |- ( ( N e. Fin /\ R e. V ) -> ( Base ` G ) = ( Base ` A ) ) $=
      ( cfn wcel wa cbs cfv cnx cmulr cotp cmmul co cop c1 c3 csts eqid basendx
      matval fveq2d baseid 1re ltneii mulrndx neeqtrri eqnetri setsnid syl6reqr
      1lt3 ) DHIBEIJZAKLCMNLZBDDDOPQZRUAQZKLCKLUOAURKABUQCDEFGUQUBUDUEUQUPKCUFM
      KLSUPUCSTUPSTUGUNUHUIUJUKULUM $.

    $( The matrix ring has the same addition as its underlying group.
       (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    matplusg $p |- ( ( N e. Fin /\ R e. V ) -> ( +g ` G ) = ( +g ` A ) ) $=
      ( cfn wcel wa cplusg cfv cnx cmulr cotp cmmul co cop c2 c3 matval plusgid
      csts fveq2d plusgndx 2re ltneii mulrndx neeqtrri eqnetri setsnid syl6reqr
      eqid 2lt3 ) DHIBEIJZAKLCMNLZBDDDOPQZRUCQZKLCKLUOAURKABUQCDEFGUQUMUAUDUQUP
      KCUBMKLSUPUESTUPSTUFUNUGUHUIUJUKUL $.

    $( The matrix ring has the same scalars as its underlying linear
       structure.  (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    matsca $p |- ( ( N e. Fin /\ R e. V ) ->
        ( Scalar ` G ) = ( Scalar ` A ) ) $=
      ( cfn wcel wa csca cfv cnx cmulr cotp cmmul co wne c5 c3 csts eqid matval
      cop fveq2d scaid 3re gtneii scandx mulrndx neeq12i mpbir setsnid syl6reqr
      3lt5 ) DHIBEIJZAKLCMNLZBDDDOPQZUDUAQZKLCKLUPAUSKABURCDEFGURUBUCUEURUQKCUF
      MKLZUQRSTRTSUGUOUHUTSUQTUIUJUKULUMUN $.

    $( The matrix ring has the same scalar multiplication as its underlying
       linear structure.  (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    matvsca $p |- ( ( N e. Fin /\ R e. V ) -> ( .s ` G ) = ( .s ` A ) ) $=
      ( cfn wcel wa cvsca cfv cnx cmulr cotp cmmul co cop c6 c3 csts matval 3re
      eqid fveq2d vscaid vscandx 3lt6 mulrndx neeqtrri eqnetri setsnid syl6reqr
      gtneii ) DHIBEIJZAKLCMNLZBDDDOPQZRUAQZKLCKLUOAURKABUQCDEFGUQUDUBUEUQUPKCU
      FMKLSUPUGSTUPTSUCUHUNUIUJUKULUM $.

    $d x y A $.  $d x y G $.  $d x y N $.  $d x y R $.  $d x y V $.
    $( The matrix ring has the same zero as its underlying linear structure.
       (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    mat0 $p |- ( ( N e. Fin /\ R e. V ) -> ( 0g ` G ) = ( 0g ` A ) ) $=
      ( vx vy cfn wcel wa cbs cfv eqidd matbas cv cplusg matplusg proplem3
      grpidpropd ) DJKBEKLZHICMNZCAUBUCOABCDEFGPUBHQUCKIQUCKLHICRNARNABCDEFGSTU
      A $.

    $( The matrix ring has the same additive inverse as its underlying linear
       structure.  (Contributed by Stefan O'Rear, 4-Sep-2015.) $)
    matinvg $p |- ( ( N e. Fin /\ R e. V ) -> ( invg ` G ) = ( invg ` A ) ) $=
      ( vx vy cfn wcel wa cbs cfv eqidd matbas cv cplusg matplusg proplem3
      grpinvpropd ) DJKBEKLZHICMNZCAUBUCOABCDEFGPUBHQUCKIQUCKLHICRNARNABCDEFGST
      UA $.
  $}

  ${
    matsca2.a $e |- A = ( N Mat R ) $.
    $( The scalars of the matrix ring are the underlying ring.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    matsca2 $p |- ( ( N e. Fin /\ R e. V ) -> R = ( Scalar ` A ) ) $=
      ( cfn wcel wa cxp cfrlm co csca cfv wceq xpfi anidms frlmsca ancoms sylan
      eqid matsca eqtrd ) CFGZBDGZHBBCCIZJKZLMZALMUCUEFGZUDBUGNZUCUHCCOPUDUHUIB
      UFUEDFUFTZQRSABUFCDEUJUAUB $.
  $}

  ${
    $d a K $.  $d a N $.  $d a R $.  $d a V $.
    matbas2.a $e |- A = ( N Mat R ) $.
    matbas2.k $e |- K = ( Base ` R ) $.
    $( The base set of the matrix ring as a set exponential.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    matbas2 $p |- ( ( N e. Fin /\ R e. V ) ->
        ( K ^m ( N X. N ) ) = ( Base ` A ) ) $=
      ( va cfn wcel wa cxp cmap co cv cfv cbs wceq adantr eqid ccnv cvv c0g csn
      cdif cima crab cfrlm wral xpfi anidms wf elmapi adantl fisuppfi ralrimiva
      rabid2 sylibr frlmbas ancoms sylan matbas 3eqtrd ) DIJZBEJZKZCDDLZMNZHOZU
      AUBBUCPZUDUEZUFIJZHVHUGZBVGUHNZQPZAQPVFVLHVHUIZVHVMRVDVPVEVDVLHVHVDVIVHJZ
      KVGCVKVIVDVGIJZVQVDVRDDUJUKZSVQVGCVIULVDVICVGUMUNUOUPSVLHVHUQURVDVRVEVMVO
      RZVSVEVRVTVMBHVNVGCEIVJVNTZGVJTVMTUSUTVAABVNDEFWAVBVC $.

    matbas2i.b $e |- B = ( Base ` A ) $.
    $( A matrix is a function.  (Contributed by Stefan O'Rear, 11-Sep-2015.) $)
    matbas2i $p |- ( M e. B -> M e. ( K ^m ( N X. N ) ) ) $=
      ( wcel cbs cfv cxp cmap co id syl6eleq cfn cvv wa wceq matrcl matbas2 syl
      eleqtrrd ) EBJZEAKLZDFFMNOZUFEBUGUFPIQUFFRJCSJTUHUGUAABCFEGIUBACDFSGHUCUD
      UE $.
  $}

  ${
    matplusg2.a $e |- A = ( N Mat R ) $.
    matplusg2.b $e |- B = ( Base ` A ) $.
    matplusg2.p $e |- .+b = ( +g ` A ) $.
    matplusg2.q $e |- .+ = ( +g ` R ) $.
    $( Addition in the matrix ring is cell-wise.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    matplusg2 $p |- ( ( X e. B /\ Y e. B ) -> ( X .+b Y ) = ( X oF .+ Y ) ) $=
      ( wcel wa co cplusg cfv cfn cvv eqid cxp cfrlm cof matrcl adantr matplusg
      wceq syl6eqr syl oveqd cbs simprd simpld xpfi simpl matbas eleqtrrd simpr
      syl2anc frlmplusgval eqtr3d ) GBMZHBMZNZGHEFFUAZUBOZPQZOGHDOGHCUCOVDVGDGH
      VDFRMZESMZNZVGDUGVBVJVCABEFGIJUDUEZVJVGAPQDAEVFFSIVFTZUFKUHUIUJVDVFUKQZCV
      GEGHVESRVFVLVMTVDVHVIVKULVDVHVHVERMVDVHVIVKUMZVNFFUNUSVDGBVMVBVCUOVDVMAUK
      QZBVDVJVMVOUGVKAEVFFSIVLUPUIJUHZUQVDHBVMVBVCURVPUQLVGTUTVA $.
  $}

  ${
    matvsca2.a $e |- A = ( N Mat R ) $.
    matvsca2.b $e |- B = ( Base ` A ) $.
    matvsca2.k $e |- K = ( Base ` R ) $.
    matvsca2.v $e |- .x. = ( .s ` A ) $.
    matvsca2.t $e |- .X. = ( .r ` R ) $.
    matvsca2.c $e |- C = ( N X. N ) $.
    $( Scalar multiplication in the matrix ring is cell-wise.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    matvsca2 $p |- ( ( X e. K /\ Y e. B ) ->
        ( X .x. Y ) = ( ( C X. { X } ) oF .X. Y ) ) $=
      ( wcel cxp co cfv wa cfrlm cvsca csn cof cfn cvv wceq matrcl eqid matvsca
      adantl syl syl6eqr oveqd cbs simpld xpfi syl2anc simpl simpr frlmvscafval
      matbas eleqtrrd xpeq1i oveq1i eqtr3d ) IGQZJBQZUAZIJDHHRZUBSZUCTZSZIJESCI
      UDZRZJFUEZSZVJVMEIJVJVMAUCTZEVJHUFQZDUGQZUAZVMVSUHVIWBVHABDHJKLUIULZADVLH
      UGKVLUJZUKUMNUNUOVJVNVKVORZJVQSVRVJIVLUPTZDVMFVKGUFJVLWDWFUJMVJVTVTVKUFQV
      JVTWAWCUQZWGHHURUSVHVIUTVJJBWFVHVIVAVJWFAUPTZBVJWBWFWHUHWCADVLHUGKWDVCUML
      UNVDVMUJOVBVPWEJVQCVKVOPVEVFUNVG $.
  $}

  ${
    $d a b x N $.  $d a b x R $.  $d x y z A $.  $d y z N $.  $d y z R $.
    $d x y z A $.  $d x y z N $.  $d x y z R $.
    matassa.a $e |- A = ( N Mat R ) $.
    $( The matrix ring is a linear structure.  (Contributed by Stefan O'Rear,
       4-Sep-2015.) $)
    matlmod $p |- ( ( N e. Fin /\ R e. Ring ) -> A e. LMod ) $=
      ( vx vy cfn wcel crg wa clmod cvv eqid cbs eqidd cv cplusg proplem3 cvsca
      cfv cxp cfrlm co xpexg anidms frlmlmod ancoms csca matbas matplusg matsca
      sylan matvsca lmodpropd mpbid ) CGHZBIHZJZBCCUAZUBUCZKHZAKHUPUSLHZUQVAUPV
      BCCGGUDUEUQVBVABUTUSLUTMZUFUGULUREFUTNTZUTUHTZNTZVEUTAURVDOABUTCIDVCUIURE
      PZVDHFPVDHZJEFUTQTAQTABUTCIDVCUJRURVEOABUTCIDVCUKVFMURVGVFHVHJEFUTSTASTAB
      UTCIDVCUMRUNUO $.

    $( Existence of the matrix ring.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    matrng $p |- ( ( N e. Fin /\ R e. Ring ) -> A e. Ring ) $=
      ( vx vy va vb wcel crg wa cfv co eqid cv mamucl eleqtrd matplusg2 syl2anc
      wceq vz cfn cbs cxp cmap cplusg cmmul weq cur c0g cif cmpt2 matbas2 eqidd
      cotp matmulr clmod cgrp matlmod lmodgrp syl w3a simp1r simp1l simp2 simp3
      simplr simpll simpr1 simpr2 simpr3 mamuass cof adantr oveq2d mamudi simpr
      mamudir 3eqtr4d oveq1d simpl mamudiagcl mamulid mamurid isrngd ) CUBIZBJI
      ZKZEFUABUCLZCCUDUEMZAUFLZABCCCUOUGMZGHCCGHUHBUILZBUJLZUKULZABWICJDWINZUMZ
      WHWKUNABWLCJDWLNZUPWHAUQIAURIABCDUSAUTVAWHEOZWJIZFOZWJIZVBWICBWLCCWSXAWPW
      FWGWTXBVCWRWFWGWTXBVDZXCXCWHWTXBVEWHWTXBVFPWHWTXBUAOZWJIZVBZKZWICBWLWLWLW
      LCCCWSXAXDWPWFWGXFVGZWFWGXFVHZXIXIXIWHWTXBXEVIZWHWTXBXEVJZWHWTXBXEVKZWRWR
      WRWRVLXGWSXAXDBUFLZVMZMZWLMWSXAWLMZWSXDWLMZXNMZWSXAXDWKMZWLMXPXQWKMZXGWIX
      MBWLCCCWSXAXDWPXHWRXIXIXIXMNZXJXKXLVRXGXSXOWSWLXGXAAUCLZIZXDYBIXSXOTXGXAW
      JYBXKWHWJYBTXFWQVNZQZXGXDWJYBXLYDQAYBXMWKBCXAXDDYBNZWKNZYARSVOXGXPYBIXQYB
      IZXTXRTXGXPWJYBXGWICBWLCCWSXAWPXHWRXIXIXIXJXKPYDQXGXQWJYBXGWICBWLCCWSXDWP
      XHWRXIXIXIXJXLPYDQZAYBXMWKBCXPXQDYFYGYARSVSXGWSXAXNMZXDWLMXQXAXDWLMZXNMZW
      SXAWKMZXDWLMXQYKWKMZXGWIXMBWLCCCWSXAXDWPXHWRXIXIXIYAXJXKXLVPXGYMYJXDWLXGW
      SYBIYCYMYJTXGWSWJYBXJYDQYEAYBXMWKBCWSXADYFYGYARSVTXGYHYKYBIYNYLTYIXGYKWJY
      BXGWICBWLCCXAXDWPXHWRXIXIXIXKXLPYDQAYBXMWKBCXQYKDYFYGYARSVSWHWIBWMGHWOCWN
      WPWFWGVQWMNZWNNZWONZWFWGWAWBWHWTKZWIBWMGHWLWOCCWSWNWPWFWGWTVGZYOYPYQWFWGW
      TVHZYTWRWHWTVQZWCYRWIBWMGHWLWOCCWSWNWPYSYOYPYQYTYTWRUUAWDWE $.

    $( Existence of the matrix algebra.  (Contributed by Stefan O'Rear,
       5-Sep-2015.) $)
    matassa $p |- ( ( N e. Fin /\ R e. CRing ) -> A e. AssAlg ) $=
      ( vy vz vx wcel ccrg wa cbs cfv co cxp eqid wceq eleqtrd matvsca2 syl2anc
      cv cfn cvsca cotp cmmul matbas2 matsca2 eqidd matmulr crg crngrng matlmod
      clmod sylan2 matrng simpr w3a csn cmulr cof ad2antlr simpll simpr1 simpr2
      simpr3 mamuvs1 adantr oveq1d mamucl 3eqtr4d simplr mamuvs2 oveq2d isassad
      cmap ) CUAHZBIHZJZEFBKLZAUBLZBCCCUCUDMZBVRCCNZVNMZAGABVRCIDVROZUEZABCIDUF
      VQVRUGVQVSUGABVTCIDVTOZUHVPVOBUIHZAULHBUJZABCDUKUMVPVOWFAUIHWGABCDUNUMVOV
      PUOVQGTZVRHZETZWBHZFTZWBHZUPZJZWAWHUQNZWJBURLZUSZMZWLVTMWPWJWLVTMZWRMZWHW
      JVSMZWLVTMWHWTVSMZWOVRBWQVTCCCWHWJWLWCVPWFVOWNWGUTZWEVOVPWNVAZXEXEWQOZVQW
      IWKWMVBZVQWIWKWMVCZVQWIWKWMVDZVEWOXBWSWLVTWOWIWJAKLZHXBWSPXGWOWJWBXJXHVQW
      BXJPWNWDVFZQAXJWABVSWQVRCWHWJDXJOZWCVSOZXFWAOZRSVGWOWIWTXJHXCXAPXGWOWTWBX
      JWOVRCBVTCCWJWLWCXDWEXEXEXEXHXIVHXKQAXJWABVSWQVRCWHWTDXLWCXMXFXNRSZVIWOWJ
      WPWLWRMZVTMXAWJWHWLVSMZVTMXCWOVRBWQVTCCCWJWHWLVOVPWNVJWCXFWEXEXEXEXHXGXIV
      KWOXQXPWJVTWOWIWLXJHXQXPPXGWOWLWBXJXIXKQAXJWABVSWQVRCWHWLDXLWCXMXFXNRSVLX
      OVIVM $.
  $}

  ${
    $d i j x .0. $.  $d i j x .1. $.  $d i j x A $.  $d i j x N $.
    $d i j x R $.
    mat1.a $e |- A = ( N Mat R ) $.
    mat1.o $e |- .1. = ( 1r ` R ) $.
    mat1.z $e |- .0. = ( 0g ` R ) $.
    $( Value of an identity matrix.  (Contributed by Stefan O'Rear,
       7-Sep-2015.) $)
    mat1 $p |- ( ( N e. Fin /\ R e. Ring ) -> ( 1r ` A ) =
        ( i e. N , j e. N |-> if ( i = j , .1. , .0. ) ) ) $=
      ( vx wcel crg wa cv wceq cbs cfv co eqid cfn cif cmpt2 cmulr wral cur cxp
      simpr simpl mamudiagcl matbas2 eleqtrd cmmul matmulr adantr simplr simpll
      cmap cotp oveqd eleq2d biimpar mamulid eqtr3d mamurid ralrimiva wb matrng
      jca isrngid syl mpbi2and ) FUALZBMLZNZDEFFDOEOPCGUBUCZAQRZLZVPKOZAUDRZSZV
      SPZVSVPVTSZVSPZNZKVQUEZAUFRZVPPZVOVPBQRZFFUGURSZVQVOWIBCDEVPFGWITZVMVNUHI
      JVPTZVMVNUIUJABWIFMHWKUKZULVOWEKVQVOVSVQLZNZWBWDWOVPVSBFFFUSUMSZSWAVSWOWP
      VTVPVSVOWPVTPWNABWPFMHWPTZUNUOZUTWOWIBCDEWPVPFFVSGWKVMVNWNUPZIJWLVMVNWNUQ
      ZWTWQVOVSWJLWNVOWJVQVSWMVAVBZVCVDWOVSVPWPSWCVSWOWPVTVSVPWRUTWOWIBCDEWPVPF
      FVSGWKWSIJWLWTWTWQXAVEVDVIVFVOAMLVRWFNWHVGABFHVHKVQAVTWGVPVQTVTTWGTVJVKVL
      $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The determinant
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c maDet maAdju $.
  $( Syntax for the matrix determinant function. $)
  cmdat $a class maDet $.
  $( Syntax for the matrix adjugate function. $)
  cmadu $a class maAdju $.

  ${
    $d n r m p x i j k l $.

    $( Determinant of a square matrix...  (Contributed by Stefan O'Rear,
       9-Sep-2015.) $)
    df-mdet $a |- maDet = ( n e. _V , r e. _V |-> ( m e. ( Base ` ( n Mat r )
        ) |-> ( r gsum ( p e. ( Base ` ( SymGrp ` n ) ) |-> ( ( (
        ZRHom ` r ) ` ( ( pmSgn ` n ) ` p ) ) ( .r ` r ) ( ( mulGrp
        ` r ) gsum ( x e. n |-> ( ( p ` x ) m x ) ) ) ) ) ) ) ) $.

    $( Define the adjunct (matrix of cofactors) of a square matrix.  This
       definition gives the standard cofactors, however the internal minors are
       not the standard minors.  (Contributed by Stefan O'Rear, 7-Sep-2015.) $)
    df-madu $a |- maAdju = ( n e. _V , r e. _V |->
       ( m e. ( Base ` ( n Mat r ) ) |-> ( i e. n , j e. n |->
         ( if ( i = j , ( 1r ` r ) , ( ( invg ` r ) ` ( 1r ` r ) ) )
             ( .r ` r ) ( ( ( n \ { i } ) maDet r ) ` ( k e. ( n \ { i } ) ,
             l e. ( n \ { i } ) |-> ( if ( k = j , i , k ) m l ) ) ) ) ) ) ) $.
  $}

  ${
    $d y z $.  $d m n r B $.  $d m p x M $.  $d m n p r x N $.  $d m n r P $.
    $d m n p r x R $.  $d m n r S $.  $d m n r .x. $.  $d m n r U $.
    $d m n r Y $.
    mdetfval.d $e |- D = ( N maDet R ) $.
    mdetfval.a $e |- A = ( N Mat R ) $.
    mdetfval.b $e |- B = ( Base ` A ) $.
    mdetfval.p $e |- P = ( Base ` ( SymGrp ` N ) ) $.
    mdetfval.y $e |- Y = ( ZRHom ` R ) $.
    mdetfval.s $e |- S = ( pmSgn ` N ) $.
    mdetfval.t $e |- .x. = ( .r ` R ) $.
    mdetfval.u $e |- U = ( mulGrp ` R ) $.
    $( First substitution for the determinant definition.  (Contributed by
       Stefan O'Rear, 9-Sep-2015.) $)
    mdetfval $p |- D = ( m e. B |-> ( R gsum ( p e. P |-> ( ( Y ` ( S ` p ) )
        .x. ( U gsum ( x e. N |-> ( ( p ` x ) m x ) ) ) ) ) ) ) $=
      ( vn vr vy vz cmdat co cv cfv cmpt cgsu cvv wcel wa wceq cmat csymg cpsgn
      cbs czrh cmgp cmulr oveq12 syl6eqr fveq2d simpr simpl fveq2 adantl fveq1d
      fveq12d mpteq1d oveq12d oveq123d df-mdet fvex eqeltri mptex ovmpt2a wn c0
      mpteq12dv reldmmpt2 ovprc mpt0 cfn cxp cfrlm cnx cotp cmmul df-mat syl5eq
      cop csts base0 3eqtr4g eqtr4d pm2.61i eqtri ) DKFUFUGZJCFMEMUHZGUIZLUIZIA
      KAUHZXBUIXEJUHUGZUJZUKUGZHUGZUJZUKUGZUJZNKULUMFULUMUNZXAXLUOUBUCKFULULJUB
      UHZUCUHZUPUGZUSUIZXOMXNUQUIZUSUIZXBXNURUIZUIZXOUTUIZUIZXOVAUIZAXNXFUJZUKU
      GZXOVBUIZUGZUJZUKUGZUJZXLUFXNKUOZXOFUOZUNZJXQYJCXKYNXQBUSUIZCYNXPBUSYNXPK
      FUPUGZBXNKXOFUPVCOVDVEPVDYNXOFYIXJUKYLYMVFZYNMXSYHEXIYNXSKUQUIZUSUIEYNXRY
      RUSYNXNKUQYLYMVGZVEVEQVDYNYCXDYFXHYGHYNYGFVBUIZHYMYGYTUOYLXOFVBVHVITVDYNY
      AXCYBLYNYBFUTUILYNXOFUTYQVERVDYNXBXTGYNXTKURUIGYNXNKURYSVESVDVJVKYNYDIYEX
      GUKYNYDFVAUIIYNXOFVAYQVEUAVDYNAXNKXFYSVLVMVNWBVMWBAJUBUCMVOZJCXKCYOULPBUS
      VPVQVRVSXMVTZXAJWAXKUJZXLUUBXAWAUUCKFUFUBUCULULYKUFUUAWCWDJXKWEVDUUBJCWAX
      KUUBYOWAUSUICWAUUBBWAUSUUBBYPWAOKFUPUDUEWFULUEUHZUDUHZUUEWGWHUGWIVBUIUUDU
      UEUUEUUEWJWKUGWNWOUGUPUDUEWLWCWDWMVEPWPWQVLWRWSWT $.

    $( Full substitution of our determinant definition (also known as Leibniz'
       Formula).  (Contributed by Stefan O'Rear, 3-Oct-2015.) $)
    mdetleib $p |- ( M e. B -> ( D ` M ) = ( R gsum ( p e. P |-> ( ( Y ` ( S `
        p ) ) .x. ( U gsum ( x e. N |-> ( ( p ` x ) M x ) ) ) ) ) ) ) $=
      ( vm cv cfv co cmpt cgsu wceq oveq mpteq2dv oveq2d mdetfval ovex fvmpt )
      UBJFMEMUCZGUDLUDZIAKAUCZUOUDZUQUBUCZUEZUFZUGUEZHUEZUFZUGUEFMEUPIAKURUQJUE
      ZUFZUGUEZHUEZUFZUGUECDUSJUHZVDVIFUGVJMEVCVHVJVBVGUPHVJVAVFIUGVJAKUTVEURUQ
      USJUIUJUKUKUJUKABCDEFGHIUBKLMNOPQRSTUAULFVIUGUMUN $.
  $}

$(
  @{
    mdetcl.d @e |- D = ( N maDet R ) @.
    mdetcl.a @e |- A = ( N Mat R ) @.
    mdetcl.b @e |- B = ( Base ` A ) @.
    mdetcl.k @e |- K = ( Base ` R ) @.
    @( The determinant evaluates to an element of the base ring.  ( Contributed
       by Stefan O'Rear, 9-Sep-2015.) @)
    mdetcl @p |- ( ( R e. CRing /\ M e. B ) -> ( D ` M ) e. K ) @= ? @.

    @( Functionality of the determinant.  ( Contributed by Stefan O'Rear,
       9-Sep-2015.) @)
    mdetf @p |- ( R e. CRing -> D : B --> K ) @= ? @.
  @}

  @{
    gsumiunfi.b @e |- B = ( Base ` G ) @.
    gsumiunfi.g @e |- ( ph -> G e. CMnd ) @.
    gsumiunfi.c @e |- ( ph -> C e. Fin ) @.
    gsumiunfi.d @e |- ( ( ph /\ i e. C ) -> D e. Fin ) @.
    gsumiunfi.a @e |- ( ( ph /\ j e. A ) -> E! i e. C j e. D ) @.
    gsumiunfi.x @e |- ( ( ph /\ j e. A ) -> X e. B ) @.
    @( An iterated splitting rule for finite sums.  ( Contributed by Stefan
       O'Rear, 10-Sep-2015.) @)
    gsumiunfi @p |- ( ph -> ( G gsum ( j e. A |-> X ) ) =
        ( G gsum ( i e. C |-> ( G gsum ( j e. D |-> X ) ) ) ) ) @= ? @.
  @}

  @{
    madufval.j @e |- J = ( N maAdju R ) @.
    madufval.a @e |- A = ( N Mat R ) @.
    madufval.b @e |- B = ( Base ` A ) @.
    madufval.o @e |- .1. = ( 1r ` R ) @.
    madufval.e @e |- E = ( invg ` R ) @.
    madufval.t @e |- .x. = ( .r ` R ) @.

    @( First substitution for the adjunct (cofactor) matrix.  ( Contributed by
       Stefan O'Rear, 10-Sep-2015.) @)
    madufval @p |- J = ( m e. B |-> ( i e. N , j e. N |->
        ( if ( i = j , .1. , ( E ` .1. ) ) .x.
          ( ( ( N \ { i } ) maDet R ) `
            ( k e. ( N \ { i } ) , l e. ( N \ { i } ) |->
              ( if ( k = j , i , k  ) m l ) ) ) ) ) ) @= ? @.

    @( Second substitution for the adjunct (cofactor) matrix.  ( Contributed
       by Stefan O'Rear, 10-Sep-2015.) @)
    maduval @p |- ( M e. B -> ( J ` M ) = ( i e. N , j e. N |->
        ( if ( i = j , .1. , ( E ` .1. ) ) .x.
          ( ( ( N \ { i } ) maDet R ) `
            ( k e. ( N \ { i } ) , l e. ( N \ { i } ) |->
              ( if ( k = j , i , k  ) m l ) ) ) ) ) ) @= ? @.
  @}

  @{
    mdetlap.d @e |- D = ( N maDet R ) @.
    mdetlap.a @e |- A = ( N Mat R ) @.
    mdetlap.b @e |- B = ( Base ` A ) @.
    mdetlap.t @e |- .x. = ( .r ` R ) @.
    mdetlap.j @e |- J = ( N maAdju R ) @.

 @(
   @{
      @( Express the cofactor as a portion of the determinant sum.
         ( Contributed by Stefan O'Rear, 10-Sep-2015.) @)
      mdetlaplem @p |- ( ( R e. CRing /\ M e. B )
        -> ( J ` M ) = ( i e. N , j e. N |->  ( R gsum ( p e. { q e. P | ...
    @}
@)

    @( The Laplace formula for the determinant.  ( Contributed by Stefan
       O'Rear, 9-Sep-2015.) @)
    mdetlap @p |- ( ( R e. CRing /\ M e. B /\ X e. N ) -> ( D ` M ) =
        ( R gsum ( y e. N |-> ( ( X M y ) .x. ( y ( J ` M ) X ) ) ) ) ) @= ? @.
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Endomorphism algebra
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c MEndo $.
  $( Syntax for module endomorphism algebra. $)
  cmend $a class MEndo $.

  ${
    $d m b x y $.
    $( Define the endomorphism algebra of a module.  (Contributed by Stefan
       O'Rear, 2-Sep-2015.) $)
    df-mend $a |- MEndo = ( m e. _V |-> [_ ( m LMHom m ) / b ]_
      ( { <. ( Base ` ndx ) , b >. ,
          <. ( +g ` ndx ) , ( x e. b , y e. b |-> ( x oF ( +g ` m ) y ) ) >. ,
          <. ( .r ` ndx ) , ( x e. b , y e. b |-> ( x o. y ) ) >. } u.
        { <. ( Scalar ` ndx ) , ( Scalar ` m ) >. ,
          <. ( .s ` ndx ) , ( x e. ( Base ` ( Scalar ` m ) ) , y e. b |->
             ( ( ( Base ` m ) X. { x } ) oF ( .s ` m ) y ) ) >. } ) ) $.
  $}

  ${
    $d b m x y B $.  $d b m x y M $.  $d b m .+ $.  $d b m S $.  $d b m .X. $.
    $d b m .x. $.
    mendval.b $e |- B = ( M LMHom M ) $.
    mendval.p $e |- .+ = ( x e. B , y e. B |-> ( x oF ( +g ` M ) y ) ) $.
    mendval.t $e |- .X. = ( x e. B , y e. B |-> ( x o. y ) ) $.
    mendval.s $e |- S = ( Scalar ` M ) $.
    mendval.v $e |- .x. = ( x e. ( Base ` S ) , y e. B |->
        ( ( ( Base ` M ) X. { x } ) oF ( .s ` M ) y ) ) $.
    $( Value of the module endomorphism algebra.  (Contributed by Stefan
       O'Rear, 2-Sep-2015.) $)
    mendval $p |- ( M e. X -> ( MEndo ` M ) = ( { <. ( Base ` ndx ) , B >. ,
        <. ( +g ` ndx ) , .+ >. , <. ( .r ` ndx ) , .X. >. } u. { <. ( Scalar `
          ndx ) , S >. , <. ( .s ` ndx ) , .x. >. } ) ) $=
      ( vb cfv cbs cop wceq co vm wcel cvv cmend cnx cplusg cmulr ctp cvsca cpr
      csca cun elex cv clmhm cof ccom csn cxp csb oveq12 anidms syl6eqr csbeq1d
      cmpt2 ovex syl6eqelr wa simpr opeq2d fveq2 syl proplem3 mpt2eq123dv eqidd
      ofeq tpeq123d adantr fveq2d xpeq1d oveq123d preq12d uneq12d eqtrd df-mend
      csbied tpex prex unex fvmpt ) HIUBHUCUBHUDPUEQPZCRZUEUFPZDRZUEUGPZGRZUHZU
      EUKPZERZUEUIPZFRZUJZULZSHIUMUAHOUAUNZXDUOTZWKOUNZRZWMABXFXFAUNZBUNZXDUFPZ
      UPZTZVEZRZWOABXFXFXHXIUQZVEZRZUHZWRXDUKPZRZWTABXSQPZXFXDQPZXHURZUSZXIXDUI
      PZUPZTZVEZRZUJZULZUTZXCUCUDXDHSZYLOCYKUTXCYMOXECYKYMXEHHUOTZCYMXEYNSXDHXD
      HUOVAVBJVCZVDYMOCYKXCUCYMCXEUCYOXDXDUOVFVGYMXFCSZVHZXRWQYJXBYQXGWLXNWNXQW
      PYQXFCWKYMYPVIZVJYQXMDWMYQXMABCCXHXIHUFPZUPZTZVEDYQABXFXFXLCCUUAYRYRYMYPA
      BXKYTYMXJYSSXKYTSXDHUFVKXJYSVPVLVMVNKVCVJYQXPGWOYQXPABCCXOVEGYQABXFXFXOCC
      XOYRYRYQXOVOVNLVCVJVQYQXTWSYIXAYQXSEWRYQXSHUKPZEYMXSUUBSYPXDHUKVKVRMVCZVJ
      YQYHFWTYQYHABEQPZCHQPZYCUSZXIHUIPZUPZTZVEFYQABYAXFYGUUDCUUIYQXSEQUUCVSYRY
      QYDUUFXIXIYFUUHYQYEUUGSZYFUUHSYMUUJYPXDHUIVKVRYEUUGVPVLYQYBUUEYCYMYBUUESY
      PXDHQVKVRVTYQXIVOWAVNNVCVJWBWCWFWDABUAOWEWQXBWLWNWPWGWSXAWHWIWJVL $.
  $}

  ${
    $d x y M $.
    mendbas.a $e |- A = ( MEndo ` M ) $.
    $( Base set of the module endomorphism algebra.  (Contributed by Stefan
       O'Rear, 2-Sep-2015.) $)
    mendbas $p |- ( M LMHom M ) = ( Base ` A ) $=
      ( vx vy cvv wcel clmhm co cbs cfv wceq cnx cop cplusg cv cof cmpt2 eqid
      c0 cmulr ccom ctp csca cvsca csn cxp cpr ovex algbase mp1i mendval syl5eq
      cun cmend fveq2d eqtr4d wn base0 reldmlmhm ovprc1 fvprc 3eqtr4a pm2.61i )
      BFGZBBHIZAJKZLVEVFMJKVFNMOKDEVFVFDPZEPZBOKQIRZNMUAKDEVFVFVHVIUBRZNUCMUDKB
      UDKZNMUEKDEVLJKVFBJKVHUFUGVIBUEKQIRZNUHUNZJKZVGVFFGVFVOLVEBBHUIVNVFVJVLVM
      VKFVNSUJUKVEAVNJVEABUOKZVNCDEVFVJVLVMVKBFVFSVJSVKSVLSVMSULUMUPUQVEURZTTJK
      VFVGUSBBHUTVAVQATJVQAVPTCBUOVBUMUPVCVD $.
  $}

  ${
    $d x y B $.  $d x y M $.  $d x y .+ $.  $d x y X $.  $d x y Y $.
    mendplusgfval.a $e |- A = ( MEndo ` M ) $.
    mendplusgfval.b $e |- B = ( Base ` A ) $.
    mendplusgfval.p $e |- .+ = ( +g ` M ) $.
    $( Addition in the module endomorphism algebra.  (Contributed by Stefan
       O'Rear, 2-Sep-2015.) $)
    mendplusgfval $p |- ( +g ` A ) = ( x e. B , y e. B |-> ( x oF .+ y ) ) $=
      ( cvv wcel cplusg cfv co cmpt2 wceq cnx cbs cop c0 cv cof cmulr ccom csca
      ctp cvsca csn cxp cpr cun cmend clmhm mendbas eqtr4i ofeq ax-mp oveqi a1i
      wa mpt2eq3ia eqid mendval syl5eq fveq2d fvex eqeltri mpt2ex algaddg fvprc
      mp1i eqtr4d wn c2 df-plusg str0 syl6eqr base0 3eqtr4g mpt2eq12 anidms syl
      mpt20 syl6eq pm2.61i ) FJKZCLMZABDDAUAZBUAZEUBZNZOZPWFWGQRMDSQLMWLSQUCMAB
      DDWHWIUDOZSUFQUEMFUEMZSQUGMABWNRMDFRMWHUHUIWIFUGMUBNOZSUJUKZLMZWLWFCWPLWF
      CFULMZWPGABDWLWNWOWMFJDCRMZFFUMNHCFGUNUOABDDWKWHWIFLMZUBZNZWKXBPWHDKWIDKU
      TWJXAWHWIEWTPWJXAPIEWTUPUQURUSVAWMVBWNVBWOVBVCVDVEWLJKWLWQPWFABDDWKDWSJHC
      RVFVGZXCVHWPDWLWNWOWMJWPVBVIVKVLWFVMZWGTWLXDWGTLMTXDCTLXDCWRTGFULVJVDZVEL
      VNVOVPVQXDWLABTTWKOZTXDDTPZWLXFPZXDWSTRMDTXDCTRXEVEHVRVSXGXHABDDTTWKVTWAW
      BABTWKWCWDVLWE $.

    mendplusg.q $e |- .+b = ( +g ` A ) $.
    $( A specific addition in the module endomorphism algebra.  (Contributed by
       Stefan O'Rear, 3-Sep-2015.) $)
    mendplusg $p |- ( ( X e. B /\ Y e. B ) -> ( X .+b Y ) = ( X oF .+ Y ) ) $=
      ( vx vy cv cof co oveq12 cplusg cfv cmpt2 mendplusgfval eqtri ovmpt2a
      ovex ) LMFGBBLNZMNZCOZPZFGUGPDUEFUFGUGQDARSLMBBUHTKLMABCEHIJUAUBFGUGUDUC
      $.
  $}

  ${
    $d x y B $.  $d x y M $.  $d x y X $.  $d x y Y $.
    mendmulrfval.a $e |- A = ( MEndo ` M ) $.
    mendmulrfval.b $e |- B = ( Base ` A ) $.
    $( Multiplication in the module endomorphism algebra.  (Contributed by
       Stefan O'Rear, 2-Sep-2015.) $)
    mendmulrfval $p |- ( .r ` A ) = ( x e. B , y e. B |-> ( x o. y ) ) $=
      ( cvv cmulr cfv cmpt2 wceq cnx cbs cop co eqid syl5eq fveq2d c0 wcel ccom
      cv cplusg cof ctp csca cvsca csn cxp cpr cun cmend mendbas eqtr4i mendval
      clmhm fvex eqeltri mpt2ex algmulr mp1i eqtr4d wn fvprc c3 df-mulr syl6eqr
      str0 base0 mpt2eq12 anidms syl mpt20 syl6eq pm2.61i ) EHUAZCIJZABDDAUCZBU
      CZUBZKZLVQVRMNJDOMUDJABDDVSVTEUDJUEPKZOMIJWBOUFMUGJEUGJZOMUHJABWDNJDENJVS
      UIUJVTEUHJUEPKZOUKULZIJZWBVQCWFIVQCEUMJZWFFABDWCWDWEWBEHDCNJZEEUQPGCEFUNU
      OWCQWBQWDQWEQUPRSWBHUAWBWGLVQABDDWADWIHGCNURUSZWJUTWFDWCWDWEWBHWFQVAVBVCV
      QVDZVRTWBWKVRTIJTWKCTIWKCWHTFEUMVERZSIVFVGVIVHWKWBABTTWAKZTWKDTLZWBWMLZWK
      DTNJZTWKDWIWPGWKCTNWLSRVJVHWNWOABDDTTWAVKVLVMABTWAVNVOVCVP $.

    mendmulr.q $e |- .x. = ( .r ` A ) $.
    $( A specific multiplication in the module endormoprhism algebra.
       (Contributed by Stefan O'Rear, 3-Sep-2015.) $)
    mendmulr $p |- ( ( X e. B /\ Y e. B ) -> ( X .x. Y ) = ( X o. Y ) ) $=
      ( vx vy wcel ccom cvv co wceq coexg cv coeq1 coeq2 cmulr cfv mendmulrfval
      cmpt2 eqtri ovmpt2g mpd3an3 ) EBLFBLEFMZNLEFCOUHPEFBBQJKEFBBJRZKRZMZUHCEU
      JMNUIEUJSUJFETCAUAUBJKBBUKUDIJKABDGHUCUEUFUG $.
  $}

  ${
    $d x y M $.
    mendsca.a $e |- A = ( MEndo ` M ) $.
    mendsca.s $e |- S = ( Scalar ` M ) $.
    $( The module endomorphism algebra has the same scalars as the underlying
       module.  (Contributed by Stefan O'Rear, 2-Sep-2015.) $)
    mendsca $p |- S = ( Scalar ` A ) $=
      ( vx vy csca cfv cmend cvv wcel wceq cnx cbs co cop cmpt2 eqid c0 cv ccom
      clmhm cplusg cof cmulr ctp cvsca csn cxp cpr cun fvex algsca mp1i mendval
      fveq2d eqtr4d wn c5 df-sca str0 fvprc 3eqtr4a pm2.61i fveq2i 3eqtr4i ) CH
      IZCJIZHIZBAHICKLZVHVJMVKVHNOICCUCPZQNUDIFGVLVLFUAZGUAZCUDIUEPRZQNUFIFGVLV
      LVMVNUBRZQUGNHIVHQNUHIFGVHOIVLCOIVMUIUJVNCUHIUEPRZQUKULZHIZVJVHKLVHVSMVKC
      HUMVRVLVOVHVQVPKVRSUNUOVKVIVRHFGVLVOVHVQVPCKVLSVOSVPSVHSVQSUPUQURVKUSZTTH
      IVHVJHUTVAVBCHVCVTVITHCJVCUQVDVEEAVIHDVFVG $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y M $.
    mendvscafval.a $e |- A = ( MEndo ` M ) $.
    mendvscafval.v $e |- .x. = ( .s ` M ) $.
    mendvscafval.b $e |- B = ( Base ` A ) $.
    mendvscafval.s $e |- S = ( Scalar ` M ) $.
    mendvscafval.k $e |- K = ( Base ` S ) $.
    mendvscafval.e $e |- E = ( Base ` M ) $.
    $( Scalar multiplication in the module endomorphism algebra.  (Contributed
       by Stefan O'Rear, 2-Sep-2015.) $)
    mendvscafval $p |- ( .s ` A ) = ( x e. K , y e. B |->
          ( ( E X. { x } ) oF .x. y ) ) $=
      ( cvsca cfv wceq cbs c0 cmend cv csn cxp cof co cmpt2 fveq2i cvv wcel cnx
      cop cplusg cmulr ccom ctp csca cpr clmhm mendbas eqtr4i eqid xpeq1i ax-mp
      cun ofeq oveq123i mpt2eq123i mendval fveq2d eqeltri mpt2ex algvsca eqtr4d
      fvex mp1i wn fvprc c6 df-vsca str0 syl6eqr base0 3eqtr4g mpt2eq12 sylancl
      syl5eq mpt20 syl6eq pm2.61i eqtri ) CPQIUAQZPQZABHDGAUBZUCZUDZBUBZFUEZUFZ
      UGZCWLPJUHIUIUJZWMWTRXAWMUKSQDULUKUMQABDDWNWQIUMQUEUFUGZULUKUNQABDDWNWQUO
      UGZULUPUKUQQEULUKPQWTULURVEZPQZWTXAWLXDPABDXBEWTXCIUIDCSQZIIUSUFLCIJUTVAX
      BVBXCVBMABHDWSESQZDISQZWOUDZWQIPQZUEZUFNDVBZWPWQXIWQWRXKGXHWOOVCWQVBFXJRW
      RXKRKFXJVFVDVGVHVIVJWTUIUJWTXERXAABHDWSHXGUINESVOVKDXFUILCSVOVKVLXDDXBEWT
      XCUIXDVBVMVPVNXAVQZWMTWTXMWMTPQTXMWLTPIUAVRVJPVSVTWAWBXMWTABTDWSUGZTXMHTR
      DDRWTXNRXMXGTSQHTXMETSXMEIUQQTMIUQVRWGVJNWCWDXLABHDTDWSWEWFABDWSWHWIVNWJW
      K $.

    $d x y E $.  $d x y .x. $.  $d x y X $.  $d x y Y $.
    mendvsca.w $e |- .xb = ( .s ` A ) $.
    $( A specific scalar multiplication in the module endomorphism algebra.
       (Contributed by Stefan O'Rear, 3-Sep-2015.) $)
    mendvsca $p |- ( ( X e. K /\ Y e. B ) ->
        ( X .xb Y ) = ( ( E X. { X } ) oF .x. Y ) ) $=
      ( vx vy cv csn cxp cof co wceq xpeq2d id oveqan12d cvsca cfv mendvscafval
      sneq cmpt2 eqtri ovex ovmpt2a ) RSIJGBFRTZUAZUBZSTZEUCZUDZFIUAZUBZJVAUDDU
      QIUEZUTJUEZUSVDUTJVAVEURVCFUQIULUFVFUGUHDAUIUJRSGBVBUMQRSABCEFGHKLMNOPUKU
      NVDJVAUOUP $.
  $}

  ${
    $d x y z A $.  $d k u v w x y z M $.  $d k u v w x y z S $.
    mendassa.a $e |- A = ( MEndo ` M ) $.
    $( The module endomorphism algebra is a ring.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    mendrng $p |- ( M e. LMod -> A e. Ring ) $=
      ( vx vy wcel co cfv wceq ccom eqid mendplusg syl2anc sylibr 3eqtr4d eqtrd
      syl lmhmco mendmulr cvv clmod clmhm cplusg cmulr cid cbs cres mendbas a1i
      eqidd cminusg c0g csn cxp cof lmhmplusg eqeltrd 3adant1 w3a simpr1 simpr2
      vz cv wa simpr3 oveq1d oveq2d cmnd cmap cgrp lmodgrp grpmnd wf lmhmf fvex
      adantr elmap mndvass syl13anc csca id 0lmhm syl3anc sylan mndvlid invlmhm
      syl2an sylancom grpvlinv isgrpd coass 3eqtr4a cmhm cghm lmghm ghmmhm 3syl
      oveq12d mhmvlin wfn inidm ofco idlmhm adantl fcoi2 syl2anr fcoi1 isrngd
      ffn ) BUAFZDEVBBBUBGZAUCHZAAUDHZUEBUFHZUGZXKAUFHIXJABCUHZUIZXJXLUJZXJXMUJ
      XJDEVBXKXLABUKHZDVCZJZXNBULHZUMUNZXQXRXTXKFZEVCZXKFZXTYEXLGZXKFXJYDYFVDZY
      GXTYEBUCHZUOZGZXKAXKYIXLBXTYECXPYIKZXLKZLZYIXTYEBBYLUPZUQURXJYDYFVBVCZXKF
      ZUSZVDZYKYPXLGZYKYPYJGZYGYPXLGXTYEYPXLGZXLGZYSYKXKFZYQYTUUAIYSYDYFUUDXJYD
      YFYQUTZXJYDYFYQVAZYOMZXJYDYFYQVEZAXKYIXLBYKYPCXPYLYMLMYSYGYKYPXLYSYDYFYGY
      KIUUEUUFYNMZVFYSXTYEYPYJGZXLGZXTUUJYJGZUUCUUAYSYDUUJXKFZUUKUULIUUEYSYFYQU
      UMUUFUUHYIYEYPBBYLUPMZAXKYIXLBXTUUJCXPYLYMLMYSUUBUUJXTXLYSYFYQUUBUUJIUUFU
      UHAXKYIXLBYEYPCXPYLYMLMZVGYSBVHFZXTXNXNVIGZFZYEUUQFZYPUUQFZUUAUULIXJUUPYR
      XJBVJFZUUPBVKZBVLQZVPYSXNXNXTVMZUURYSYDUVDUUEXNXNBBXTXNKZUVEVNZQXNXNXTBUF
      VOZUVGVQZNYSXNXNYEVMZUUSYSYFUVIUUFXNXNBBYEUVEUVEVNZQXNXNYEUVGUVGVQNZYSXNX
      NYPVMZUUTYSYQUVLUUHXNXNBBYPUVEUVEVNQZXNXNYPUVGUVGVQNZXNYIXNBXTYEYPUVEYLVR
      VSOOXJXJXJBVTHZUVOIYCXKFZXJWAZUVQXJUVOUJXNUVOUVOBBYBYBKZUVEUVOKZUVSWBWCZX
      JYDVDZYCXTXLGZYCXTYJGZXTXJUVPYDUWBUWCIUVTAXKYIXLBYCXTCXPYLYMLWDXJUUPUURUW
      CXTIYDUVCYDUVDUURUVFUVHNZXNYIXNBXTYBUVEYLUVRWEWGPXJXSXKFYDYAXKFZXSBXSKZWF
      XSXTBBBRWDZUWAYAXTXLGZYAXTYJGZYCXJYDUWEUWHUWIIUWGAXKYIXLBYAXTCXPYLYMLWHXJ
      UVAUURUWIYCIYDUVBUWDXNYIBXNXSXTYBUVEYLUWFUVRWIWGPWJYDYFXTYEXMGZXKFXJYHUWJ
      XTYEJZXKAXKXMBXTYECXPXMKZSZXTYEBBBRZUQURYSUWKYPJZXTYEYPJZJZUWJYPXMGZXTYEY
      PXMGZXMGZXTYEYPWKYSUWRUWKYPXMGZUWOYSUWJUWKYPXMYSYDYFUWJUWKIUUEUUFUWMMZVFY
      SUWKXKFZYQUXAUWOIYSYDYFUXCUUEUUFUWNMZUUHAXKXMBUWKYPCXPUWLSMPYSUWTXTUWPXMG
      ZUWQYSUWSUWPXTXMYSYFYQUWSUWPIUUFUUHAXKXMBYEYPCXPUWLSMZVGYSYDUWPXKFZUXEUWQ
      IUUEYSYFYQUXGUUFUUHYEYPBBBRMZAXKXMBXTUWPCXPUWLSMPWLYSXTUUJXMGZXTUUJJZXTUU
      BXMGUWJXTYPXMGZXLGZYSYDUUMUXIUXJIUUEUUNAXKXMBXTUUJCXPUWLSMYSUUBUUJXTXMUUO
      VGYSUWKXTYPJZXLGZUWKUXMYJGZUXLUXJYSUXCUXMXKFZUXNUXOIUXDYSYDYQUXPUUEUUHXTY
      PBBBRMZAXKYIXLBUWKUXMCXPYLYMLMYSUWJUWKUXKUXMXLUXBYSYDYQUXKUXMIUUEUUHAXKXM
      BXTYPCXPUWLSMZWRYSXTBBWMGFZUUSUUTUXJUXOIYSYDXTBBWNGFUXSUUEBBXTWOBBXTWPWQU
      VKUVNXNYIYIXTXNBBYEYPUVEYLYLWSWCOOYSYKYPXMGZYKYPJZYGYPXMGUXKUWSXLGZYSUUDY
      QUXTUYAIUUGUUHAXKXMBYKYPCXPUWLSMYSYGYKYPXMUUIVFYSUXMUWPXLGZUXMUWPYJGZUYBU
      YAYSUXPUXGUYCUYDIUXQUXHAXKYIXLBUXMUWPCXPYLYMLMYSUXKUXMUWSUWPXLUXRUXFWRYSX
      NXNXNXNYIXTYEYPTTTYSYDUVDXTXNWTUUEUVFXNXNXTXIWQYSYFUVIYEXNWTUUFUVJXNXNYEX
      IWQUVMXNTFYSUVGUIZUYEUYEXNXAXBOOXNBUVEXCZUWAXOXTXMGZXOXTJZXTXJXOXKFZYDUYG
      UYHIUYFAXKXMBXOXTCXPUWLSWDUWAUVDUYHXTIYDUVDXJUVFXDZXNXNXTXEQPUWAXTXOXMGZX
      TXOJZXTYDYDUYIUYKUYLIXJYDWAUYFAXKXMBXTXOCXPUWLSXFUWAUVDUYLXTIUYJXNXNXTXGQ
      PXH $.

    mendassa.s $e |- S = ( Scalar ` M ) $.
    $( The module endomorphism algebra is a left module.  (Contributed by Mario
       Carneiro, 22-Sep-2015.) $)
    mendlmod $p |- ( ( M e. LMod /\ S e. CRing ) -> A e. LMod ) $=
      ( vk wcel cfv co wceq a1i eqidd adantr syl w3a eqid mendvsca syl2anc cvv
      cv vx vy vz vw vv vu clmod ccrg cbs cplusg cvsca cmulr clmhm mendbas csca
      wa cur mendsca crg crngrng adantl cgrp mendrng rnggrp csn cxp cof 3adant1
      lmhmvsca 3adant1l eqeltrd simpr2 simpr3 mendplusg oveq2d simpr1 3adant3r3
      grpcl syl3anc oveq12d eleq1 3anbi3d oveq2 eleq1d imbi12d chvarv 3adant3r2
      wi fvex wf fconst6g lmhmf simpll lmodvsdi sylan 3eqtr4d lmodvsdir caofdir
      caofdi rngacl ofc12 oveq1d eqtr4d 3anbi2d oveq1 3adant3r1 eqtrd cmpt ovex
      ffvelrnda fconstmpt feqmptd offval2 lmodvsass syl13anc mpteq2dva sylancom
      rngcl simplr2 rngidcl lmodvs1 caofid0l islmodd ) CUGGZBUHGZUPZUAUBUCBUIHZ
      AUJHZBUJHZAUKHZBULHZBUQHZBCCUMIZAYMAUIHJYFACDUNZKYFYHLBAUOHJYFABCDEURKYFY
      JLYFYGLYFYILYFYKLYFYLLYEBUSGZYDBUTVAZYFAUSGZAVBGZYDYQYEACDVCMAVDNZYFUATZY
      GGZUBTZYMGZOZYTUUBYJIZCUIHZYTVEVFZUUBCUKHZVGZIZYMUUAUUCUUEUUJJZYFAYMBYJUU
      HUUFYGCYTUUBDUUHPZYNEYGPZUUFPZYJPZQZVHYEUUAUUCUUJYMGYDYTUUHUUBBYGCCUUFUUN
      UULEUUMVIVJVKZYFUUAUUCUCTZYMGZOZUPZUUGUUBUURYHIZUUIIZUUGUUBUURCUJHZVGZIZU
      UIIZYTUVBYJIZUUEYTUURYJIZYHIZUVAUVBUVFUUGUUIUVAUUCUUSUVBUVFJYFUUAUUCUUSVL
      ZYFUUAUUCUUSVMZAYMUVDYHCUUBUURDYNUVDPZYHPZVNRVOUVAUUAUVBYMGZUVHUVCJYFUUAU
      UCUUSVPZUVAYRUUCUUSUVOYFYRUUTYSMUVKUVLYMYHAUUBUURYNUVNVRVSAYMBYJUUHUUFYGC
      YTUVBDUULYNEUUMUUNUUOQRUVAUUEUVIUVEIZUUJUUGUURUUIIZUVEIUVJUVGUVAUUEUUJUVI
      UVRUVEUVAUUAUUCUUKUVPUVKUUPRUVAUUAUUSUVIUVRJZUVPUVLAYMBYJUUHUUFYGCYTUURDU
      ULYNEUUMUUNUUOQZRVTUVAUUEYMGZUVIYMGZUVJUVQJYFUUAUUCUWAUUSUUQVQYFUUAUUSUWB
      UUCUUDUWAWHYFUUAUUSOZUWBWHZUBUCUUBUURJZUUDUWCUWAUWBUWEUUCUUSYFUUAUUBUURYM
      WAWBUWEUUEUVIYMUUBUURYTYJWCWDWEUUQWFZWGAYMUVDYHCUUEUVIDYNUVMUVNVNRUVAUDUE
      UFUUFUVDUUFUUHUUGUUBUURYGUVDSUUFSGZUVACUIWIZKUVAUUAUUFYGUUGWJZUVPUUFYTYGW
      KZNUVAUUCUUFUUFUUBWJUVKUUFUUFCCUUBUUNUUNWLNUVAUUSUUFUUFUURWJZUVLUUFUUFCCU
      URUUNUUNWLZNUVAYDUDTZYGGZUETZUUFGUFTZUUFGZOUWMUWOUWPUVDIUUHIUWMUWOUUHIUWM
      UWPUUHIZUVDIJYDYEUUTWMUVDUWMUUHBYGUUFCUWOUWPUUNUVMEUULUUMWNWOWSWPWPYFUUAU
      UBYGGZUUSOZUPZUUGUUFUUBVEVFZYIVGIZUURUUIIZUVRUXBUURUUIIZUVEIZYTUUBYIIZUUR
      YJIZUVIUUBUURYJIZYHIZUXAUDUEUFUUFYIYGUUHUURUUGUXBUUFUVDSUWGUXAUWHKZUXAUUS
      UWKYFUUAUWSUUSVMZUWLNZUXAUUAUWIYFUUAUWSUUSVPZUWJNUXAUWSUUFYGUXBWJYFUUAUWS
      UUSVLZUUFUUBYGWKNUXAYDUWNUWOYGGUWQOUWMUWOYIIUWPUUHIUWRUWOUWPUUHIUVDIJYDYE
      UWTWMZUVDYIUWMUWOUUHBYGUUFCUWPUUNUVMEUULUUMYIPZWQWOWRUXAUXHUUFUXGVEVFZUUR
      UUIIZUXDUXAUXGYGGZUUSUXHUXSJUXAYOUUAUWSUXTYFYOUWTYPMZUXNUXOYGYIBYTUUBUUMU
      XQWTVSUXLAYMBYJUUHUUFYGCUXGUURDUULYNEUUMUUNUUOQRUXAUXCUXRUURUUIUXAUUFYTUU
      BYISYGYGUXKUXNUXOXAXBXCUXAUXJUVIUXIUVEIZUXFUXAUWBUXIYMGZUXJUYBJYFUUAUUSUW
      BUWSUWFWGYFUWSUUSUYCUUAUWDYFUWSUUSOZUYCWHUAUBYTUUBJZUWCUYDUWBUYCUYEUUAUWS
      YFUUSYTUUBYGWAXDUYEUVIUXIYMYTUUBUURYJXEWDWEUWFWFXFZAYMUVDYHCUVIUXIDYNUVMU
      VNVNRUXAUVIUVRUXIUXEUVEUXAUUAUUSUVSUXNUXLUVTRUXAUWSUUSUXIUXEJUXOUXLAYMBYJ
      UUHUUFYGCUUBUURDUULYNEUUMUUNUUOQRZVTXGWPUXAUUFYTUUBYKIZVEVFZUURUUIIZFUUFU
      YHFTZUURHZUUHIZXHZUYHUURYJIZYTUXIYJIZUXAFUUFUYHUYLUUHUYIUURSSUUFUXKUYHSGU
      XAUYKUUFGZUPZYTUUBYKXIKUXAUUFUUFUYKUURUXMXJZUYIFUUFUYHXHJUXAFUUFUYHXKKUXA
      FUUFUUFUURUXMXLZXMUXAUYHYGGZUUSUYOUYJJUXAYOUUAUWSVUAUYAUXNUXOYGBYKYTUUBUU
      MYKPZXRVSUXLAYMBYJUUHUUFYGCUYHUURDUULYNEUUMUUNUUOQRUXAUUGUXIUUIIZFUUFYTUU
      BUYLUUHIZUUHIZXHUYPUYNUXAFUUFYTVUDUUHUUGUXISYGSUXKUXAUUAUYQUXNMZVUDSGUYRU
      UBUYLUUHXIKUUGFUUFYTXHJUXAFUUFYTXKKUXAUXIUXEFUUFVUDXHUYGUXAFUUFUUBUYLUUHU
      XBUURSYGUUFUXKUUAUWSUUSYFUYQXSZUYSUXBFUUFUUBXHJUXAFUUFUUBXKKUYTXMXGXMUXAU
      UAUYCUYPVUCJUXNUYFAYMBYJUUHUUFYGCYTUXIDUULYNEUUMUUNUUOQRUXAFUUFUYMVUEUYRY
      DUUAUWSUYLUUFGUYMVUEJUXAYDUYQUXPMVUFVUGUYSYTUUBUUHYKBYGUUFCUYLUUNEUULUUMV
      UBXNXOXPWPWPYFYTYMGZUPZYLYTYJIZUUFYLVEVFYTUUIIZYTYFVUHYLYGGZVUJVUKJVUIYOV
      ULYFYOVUHYPMYGBYLUUMYLPZXTNZAYMBYJUUHUUFYGCYLYTDUULYNEUUMUUNUUOQXQVUIUBUU
      FYLUUHUUFYTSYGUWGVUIUWHKVUHUUFUUFYTWJYFUUFUUFCCYTUUNUUNWLVAVUNVUIYDUUBUUF
      GYLUUBUUHIUUBJYDYEVUHWMUUHYLBUUFCUUBUUNEUULVUMYAWOYBXGYC $.

    $( The module endomorphism algebra is an algebra.  (Contributed by Mario
       Carneiro, 22-Sep-2015.) $)
    mendassa $p |- ( ( M e. LMod /\ S e. CRing ) -> A e. AssAlg ) $=
      ( vv vw wcel wa cbs cfv co wceq a1i cv cmpt eqid syl2anc cvv syl3anc ccrg
      vy vz clmod cvsca cmulr clmhm mendbas csca mendsca eqidd mendlmod mendrng
      vx crg adantr simpr w3a csn cxp cof wf simpr3 lmhmf syl ffvelrnda feqmptd
      ccom simpr1 simpr2 mendvsca simplr1 fconstmpt offval2 eqtrd oveq2d fmptco
      fvex fveq2 mendmulr fcompt eqtr4d rngcl 3eqtr4d simplr2 lmhmlin mpteq2dva
      lmodvscl simplll isassad ) CUDHZBUAHZIZUBUCBJKZAUEKZAUFKZBCCUGLZAUNWQAJKM
      WMACDUHZNBAUIKMWMABCDEUJZNWMWNUKWMWOUKWMWPUKABCDEULZWKAUOHZWLACDUMUPZWKWL
      UQWMUNOZWNHZUBOZWQHZUCOZWQHZURZIZXCXEWOLZXGVHZCJKZXCUSUTZXEXGWPLZCUEKZVAZ
      LZXKXGWPLZXCXOWOLZXJXLFXMXCFOZXGKZXEKZXPLZPZXRXJFGXMXMYBXCGOZXEKZXPLZYDXG
      XKXJXMXMYAXGXJXHXMXMXGVBZWMXDXFXHVCZXMXMCCXGXMQZYKVDVEZVFZXJFXMXMXGYLVGZX
      JXKXNXEXQLZGXMYHPXJXDXFXKYOMWMXDXFXHVIZWMXDXFXHVJZAWQBWOXPXMWNCXCXEDXPQZW
      REWNQZYKWOQZVKRXJGXMXCYGXPXNXESWNSXMSHXJCJVRNZXDXFXHWMYFXMHZVLYGSHXJUUBIY
      FXEVRNXNGXMXCPMXJGXMXCVMNXJGXMXMXEXJXFXMXMXEVBZYQXMXMCCXEYKYKVDVEZVGZVNVO
      YFYBMYGYCXCXPYFYBXEVSVPVQXJFXMXCYCXPXNXOSWNSUUAXDXFXHWMYAXMHZVLZYCSHXJUUF
      IZYBXEVRNXNFXMXCPMXJFXMXCVMNZXJXOXEXGVHZFXMYCPZXJXFXHXOUUJMYQYJAWQWPCXEXG
      DWRWPQZVTRXJUUCYIUUJUUKMUUDYLFXEXGXMXMXMWARVOVNZWBXJXKWQHZXHXSXLMXJAUDHZX
      DXFUUNWMUUOXIWTUPZYPYQXCWOBWNWQAXEWRWSYTYSWHTYJAWQWPCXKXGDWRUULVTRXJXDXOW
      QHZXTXRMYPXJXAXFXHUUQWMXAXIXBUPYQYJWQAWPXEXGWRUULWCTAWQBWOXPXMWNCXCXODYRW
      REYSYKYTVKRZWDXJXEXCXGWOLZVHZXRXEUUSWPLZXTXJFXMXCYBXPLZXEKZPYEUUTXRXJFXMU
      VCYDUUHXFXDYBXMHZUVCYDMXDXFXHWMUUFWEUUGYMWNCCXPXPXMXEBXCYBEYSYKYRYRWFTWGX
      JFGXMXMUVBYGUVCUUSXEUUHWKXDUVDUVBXMHWKWLXIUUFWIUUGYMXCXPBWNXMCYBYKEYRYSWH
      TXJUUSXNXGXQLZFXMUVBPXJXDXHUUSUVEMYPYJAWQBWOXPXMWNCXCXGDYRWREYSYKYTVKRXJF
      XMXCYBXPXNXGSWNSUUAUUGYBSHUUHYAXGVRNUUIYNVNVOUUEYFUVBXEVSVQUUMWDXJXFUUSWQ
      HZUVAUUTMYQXJUUOXDXHUVFUUPYPYJXCWOBWNWQAXGWRWSYTYSWHTAWQWPCXEUUSDWRUULVTR
      UURWDWJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Subfields
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c SubDRing $.
  $( Syntax for subfields (sub-division-rings). $)
  csdrg $a class SubDRing $.

  ${
    $d s w $.
    $( A sub-division-ring is a subset of a division ring's set which is a
       division ring under the induced operation.  If the overring is
       commutative this is a field; no special consideration is made of the
       fields in the center of a skew field.  (Contributed by Stefan O'Rear,
       3-Oct-2015.) $)
    df-sdrg $a |- SubDRing = ( w e. DivRing |->
        { s e. ( SubRing ` w ) | ( w |`s s ) e. DivRing } ) $.
  $}

  ${
    $d s w R $.  $d s S $.
    $( Property of a division subring.  (Contributed by Stefan O'Rear,
       3-Oct-2015.) $)
    issdrg $p |- ( S e. ( SubDRing ` R ) <-> ( R e. DivRing /\
        S e. ( SubRing ` R ) /\ ( R |`s S ) e. DivRing ) ) $=
      ( vw vs csdrg cfv wcel cdr csubrg cress co wa w3a cv crab df-sdrg dmmptss
      cdm wceq eleq1d elfvdm fveq2 oveq1 rabeqbidv fvex rabex fvmpt oveq2 elrab
      sseldi eleq2d syl6bb biadan2 3anass bitr4i ) BAEFZGZAHGZBAIFZGZABJKZHGZLZ
      LURUTVBMUQURVCUQERHACHCNZDNZJKZHGZDVDIFZOZECDPZQBAEUAUJURUQBAVEJKZHGZDUSO
      ZGVCURUPVMBCAVIVMHEVDASZVGVLDVHUSVDAIUBVNVFVKHVDAVEJUCTUDVJVLDUSAIUEUFUGU
      KVLVBDBUSVEBSVKVAHVEBAJUHTUIULUMURUTVBUNUO $.
  $}

  ${
    $d x R $.  $d x S $.  $d x .0. $.
    issdrg2.i $e |- I = ( invr ` R ) $.
    issdrg2.z $e |- .0. = ( 0g ` R ) $.
    $( Property of a division subring (closure version).  (Contributed by Mario
       Carneiro, 3-Oct-2015.) $)
    issdrg2 $p |- ( S e. ( SubDRing ` R ) <-> ( R e. DivRing /\
        S e. ( SubRing ` R ) /\ A. x e. ( S \ { .0. } ) ( I ` x ) e. S ) ) $=
      ( csdrg cfv wcel cdr csubrg cress co w3a cv csn cdif wa df-3an wral bitri
      issdrg eqid issubdrg pm5.32i 3bitr4i ) CBHIJBKJZCBLIJZBCMNZKJZOZUHUIAPDIC
      JACEQRUAZOZBCUCUHUISZUKSUOUMSULUNUOUKUMACBUJDEUJUDGFUEUFUHUIUKTUHUIUMTUGU
      B $.
  $}

  ${
    $d a b V $.  $d a E $.  $d a b X $.  $d a b Y $.
    $( Construction of a closure rule from a one-parameter _partial_
       operation.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    acsfn1p $p |- ( ( X e. V /\ A. b e. Y E e. X ) ->
        { a e. ~P X | A. b e. ( a i^i Y ) E e. a } e. ( ACS ` X ) ) $=
      ( wcel wral wa cpw cin cv csn wss wi crab ciin cfv syl sseli cacs riinrab
      wb elpwi ssrin adantl ralss inss2 biantrud vex snss bicomi 3bitr4g imbi1d
      elin ralbiia syl6rbbr rabbidva syl5eq cmre mreacs adantr ssralv ax-mp cfn
      simpll simpr inss1 ad2antlr snssd snfi a1i acsfn syl22anc ex ralimdva imp
      syl5 mreriincl syl2anc eqeltrrd ) CBGZACGZFDHZIZCJZFCDKZFLZMZELZNZAWJGZOZ
      EWFPZQKZWLFWJDKZHZEWFPZCUARZWEWOWMFWGHZEWFPWRWMFEWFWGUBWEWTWQEWFWEWJWFGZI
      ZWQWHWPGZWLOZFWGHZWTXBWPWGNZWQXEUCXAXFWEXAWJCNXFWJCUDWJCDUESUFWLFWPWGUGSW
      MXDFWGWHWGGZWKXCWLXGWHWJGZXHWHDGZIWKXCXGXIXHWGDWHCDUHZTUIXHWKWHWJFUJUKULW
      HWJDUOUMUNUPUQURUSWEWSWFUTRGZWNWSGZFWGHZWOWSGWBXKWDBCVAVBWBWDXMWDWCFWGHZW
      BXMWGDNWDXNOXJWCFWGDVCVDWBWCXLFWGWBXGIZWCXLXOWCIZWBWCWICNWIVEGZXLWBXGWCVF
      XOWCVGXPWHCXGWHCGWBWCWGCWHCDVHTVIVJXQXPWHVKVLWIABCEVMVNVOVPVRVQFWSWNWGWFV
      SVTWA $.
  $}

  ${
    $d s x y B $.  $d s x y R $.
    subrgacs.b $e |- B = ( Base ` R ) $.
    $( Closure property of subrings.  (Contributed by Stefan O'Rear,
       12-Sep-2015.) $)
    subrgacs $p |- ( R e. Ring -> ( SubRing ` R ) e. ( ACS ` B ) ) $=
      ( vx crg wcel csubrg cfv csubg cmgp csubmnd cin cacs cv eqid issubrg3 cvv
      wa cbs syl elin syl6bbr eqrdv cpw cmre fvex eqeltri mreacs rnggrp subgacs
      mp1i cgrp cmnd rngmgp mgpbas submacs mreincl syl3anc eqeltrd ) BEFZBGHZBI
      HZBJHZKHZLZAMHZUTDVAVEUTDNZVAFVGVBFVGVDFRVGVEFBVGVCVCOZPVGVBVDUAUBUCUTVFA
      UDZUEHFZVBVFFZVDVFFZVEVFFAQFVJUTABSHQCBSUFUGQAUHUKUTBULFVKBUIABCUJTUTVCUM
      FVLBVCVHUNAVCABVCVHCUOUPTVBVDVFVIUQURUS $.

    $( Closure property of division subrings.  (Contributed by Mario Carneiro,
       3-Oct-2015.) $)
    sdrgacs $p |- ( R e. DivRing -> ( SubDRing ` R ) e. ( ACS ` B ) ) $=
      ( vx vy vs wcel cfv cv wceq wral wa cdif eqid wb wi eleq1d syl cvv cbs wn
      cdr csdrg csubrg c0g cinvr cif cpw crab cin cacs csn issdrg2 3anass bitri
      w3a baib wss subrgss elpw sylibr adantl biimprd eldifsni necon2bi pm2.21d
      vex iftrue 2thd eldifsn rbaibr ifnefalse imbi12d pm2.61ine ralbii2 difeq1
      wne eleq2 raleqbidv syl5bb elrab3 pm5.32da bitr4d elin syl6bbr eqrdv cmre
      fvex eqeltri mreacs crg drngrng subrgacs simplr df-ne drnginvrcl sylan2br
      mp1i 3expa ifclda ralrimiva acsfn1 sylancr mreincl syl3anc eqeltrd ) BUBG
      ZBUCHZBUDHZDIZBUEHZJZXJXJBUFHZHZUGZEIZGZDXPKZEAUHZUIZUJZAUKHZXGFXHYAXGFIZ
      XHGZYCXIGZYCXTGZLZYCYAGXGYDYEXNYCGZDYCXKULZMZKZLZYGYDXGYLYDXGYEYKUPXGYLLD
      BYCXMXKXMNZXKNZUMXGYEYKUNUOUQXGYEYFYKXGYELYCXSGZYFYKOYEYOXGYEYCAURYOYCABC
      USYCAFVGUTVAVBXRYKEYCXSXRXNXPGZDXPYIMZKXPYCJZYKXQYPDXPYQXJXPGZXQPZXJYQGZY
      PPZOXJXKXLYTUUBXLXQYSXLXOXJXPXLXJXNVHQVCXLUUAYPUUAXJXKXJXPXKVDVEVFVIXJXKV
      QZYSUUAXQYPUUAYSUUCXJXPXKVJVKUUCXOXNXPXJXKXJXNVLQVMVNVOYRYPYHDYQYJXPYCYIV
      PXPYCXNVRVSVTWARWBWCYCXIXTWDWEWFXGYBXSWGHGZXIYBGZXTYBGZYAYBGASGZUUDXGABTH
      SCBTWHWIZSAWJWRXGBWKGUUEBWLABCWMRXGUUGXOAGZDAKUUFUUHXGUUIDAXGXJAGZLZXLXJX
      NAXGUUJXLWNXLUAUUKUUCXNAGZXJXKWOXGUUJUUCUULABXMXJXKCYNYMWPWSWQWTXAXOSAEDX
      BXCXIXTYBXSXDXEXF $.
  $}

  ${
    $d x y z B $.  $d y z M $.  $d x y z R $.  $d x y z S $.  $d x y z Z $.
    cntzsdrg.b $e |- B = ( Base ` R ) $.
    cntzsdrg.m $e |- M = ( mulGrp ` R ) $.
    cntzsdrg.z $e |- Z = ( Cntz ` M ) $.
    $( Centralizers in division rings/fields are subfields.  (Contributed by
       Mario Carneiro, 3-Oct-2015.) $)
    cntzsdrg $p |- ( ( R e. DivRing /\ S C_ B ) ->
        ( Z ` S ) e. ( SubDRing ` R ) ) $=
      ( vx vy wcel wss wa cfv co wceq cress eqid syl2anc cvv cdr csubrg c0g csn
      cv cinvr cdif wral csdrg simpl drngrng cntzsubr sylan cmulr oveq2 eqeq12d
      crg oveq1 wne eldifsn ccntz cminusg cui cmgp oveq1i isdrng simprbi oveq2d
      invrfval fveq2d syl5eq ad2antrr fveq1d csubg drngmgp ssdif ad2antlr difss
      cgrp cbs mgpbas ressbas2 ax-mp cntzsubg cin simpr cntz2ss ssdifssd sselda
      sylancl cntzssv mp1i elin sylanbrc fvex eqeltri resscntz sylancr eleqtrrd
      difexg subginvcl eqeltrd cplusg mgpplusg ressplusg cntzi sylan2br anassrs
      ad3antrrr adantr eldifi adantl sseldi eldifsni syl3anc rngrz rnglz eqtr4d
      drnginvrcl pm2.61ne ralrimiva wb simplr cntzel mpbird issdrg2 syl3anbrc )
      BUAKZCALZMZYHCENZBUBNKZIUEZBUFNZNZYKKZIYKBUCNZUDZUGZUHYKBUINKYHYIUJZYHBUQ
      KZYIYLBUKZABCDEFGHULUMYJYPIYSYJYMYSKZMZYPYOJUEZBUNNZOZUUEYOUUFOZPZJCUHZUU
      DUUIJCUUDUUECKZMZUUIYOYQUUFOZYQYOUUFOZPUUEYQUUEYQPUUGUUMUUHUUNUUEYQYOUUFU
      OUUEYQYOUUFURUPUUDUUKUUEYQUSZUUIUUKUUOMUUDUUECYRUGZKZUUIUUECYQUTUUDYOUUPD
      AYRUGZQOZVANZNZKUUQUUIUUDYOYMUUSVBNZNZUVAUUDYMYNUVBYHYNUVBPYIUUCYHYNDBVCN
      ZQOZVBNUVBBUVDUVEYNUVDRZDBVDNZUVDQGVEYNRZVIYHUVEUUSVBYHUVDUURDQYHUUAUVDUU
      RPABUVDYQFUVFYQRZVFVGVHVJVKVLVMUUDUVAUUSVNNKZYMUVAKUVCUVAKUUDUUSVSKZUUPUU
      RLZUVJYHUVKYIUUCABUUSYQFUVIDUVGUURQGVEVOVLYIUVLYHUUCCAYRVPVQZUURUUPUUSUUT
      UURALUURUUSVTNPAYRVRUURAUUSDUUSRZABDGFWAZWBWCUUTRZWDSUUDYMUUPENZUURWEZUVA
      UUDYMUVQKYMUURKYMUVRKYJYSUVQYMYJYKUVQYRYJYIUUPCLYKUVQLYHYIWFCYRVRACUUPDEU
      VOHWGWJWHWIYJYSUURYMYKALYSUURLYJACDEUVOHWKZYKAYRVPWLWIYMUVQUURWMWNUUDUURT
      KZUVLUVAUVRPATKUVTABVTNTFBVTWOWPAYRTWTWCZUVMUURUUPDUUSTUUTEUVNHUVPWQWRWSU
      VAUUSUVBYMUVBRXASXBUUFUUPUUSYOUUEUUTUVTUUFUUSXCNPUWAUURUUFDUUSTUVNBUUFDGU
      UFRZXDZXEWCUVPXFUMXGXHUULUUMYQUUNUULUUAYOAKZUUMYQPYHUUAYIUUCUUKUUBXIZUUDU
      WDUUKUUDYHYMAKYMYQUSZUWDYJYHUUCYTXJUUDYKAYMUVSUUCYMYKKYJYMYKYRXKXLXMUUCUW
      FYJYMYKYQXNXLABYNYMYQFUVIUVHXSXOZXJZABUUFYOYQFUWBUVIXPSUULUUAUWDUUNYQPUWE
      UWHABUUFYOYQFUWBUVIXQSXRXTYAUUDYIUWDYPUUJYBYHYIUUCYCUWGJAUUFCDYOEUVOUWCHY
      DSYEYAIBYKYNYQUVHUVIYFYG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    The class equation
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Cyclic groups and order
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
  @{
    isgenod.o @e |- O = ( od ` G ) @.
    isgenod.b @e |- B = ( Base ` G ) @.
    isgenod.k @e |- K = ( mrCls ` ( SubGrp ` G ) ) @.

    @( An element generates a (cyclic) group iff it has full order.
      ( Contributed by Stefan O'Rear, 11-Sep-2015.) @)
    isgenod @p |- ( ( G e Grp /\ B e. Fin /\ X e. B ) ->
        ( ( K ` { X } ) = B <-> ( O ` X ) = ( # ` B ) ) ) @= ? @.
  @}
$)

  ${
    $d y B $.  $d y N $.  $d y R $.  $d y X $.
    idomrootle.b $e |- B = ( Base ` R ) $.
    idomrootle.e $e |- .^ = ( .g ` ( mulGrp ` R ) ) $.
    $( No element of an integral domain can have more than ` N ` ` N ` -th
       roots.  (Contributed by Stefan O'Rear, 11-Sep-2015.) $)
    idomrootle $p |- ( ( R e. IDomn /\ X e. B /\ N e. NN ) ->
        ( # ` { y e. B | ( N .^ y ) = X } ) <_ N ) $=
      ( wcel cfv co chash wceq cbs eqid syl syl3anc wf cn0 cc0 cidom cn w3a cv1
      cpl1 cmgp cmg cascl csg ce1 ccnv c0g csn cima cdg1 cv crab cle simp1 cgrp
      ccrg cdomn isidom simplbi crngrng ply1rng rnggrp cmnd rngmgp simp3 mgpbas
      crg vr1cl mulgnncl ply1sclf simp2 ffvelrnd grpsubcl wne clt deg1xrcl nnre
      cxr 0xr a1i rexrd 3ad2ant3 deg1sclle syl2anc nngt0 xrlelttrd cnzr simprbi
      wbr domnnzr nnnn0 deg1pw breqtrrd deg1sub eqtrd eqeltrd deg1nn0clb mpbird
      wb fta1g wfn cpws cvv fvex eqeltri crh evl1rhm rhmf pwselbas fniniseg2 wa
      ffn adantr simpr evl1vard simpl3 evl1expd simpl2 evl1scad evl1subd simprd
      eqeq1d grpsubeq0 bitrd rabbidva fveq2d 3brtr3d ) CUAIZFBIZEUBIZUCZECUDJZC
      UEJZUFJZUGJZKZFYRUHJZJZYRUIJZKZCUJJZJZUKCULJZUMUNZLJUUECUOJZJZEAUPZDKZFMZ
      ABUQZLJEURYPYRNJZUUJYRCUUEUUFUUHYRULJZYROZUUPOZUUJOZUUFOZUUHOZUUQOZYMYNYO
      USZYPYRUTIZUUAUUPIZUUCUUPIZUUEUUPIZYPYRVLIZUVEYPCVLIZUVIYPCVAIZUVJYPYMUVK
      UVDYMUVKCVBIZCVCZVDPZCVEPZYRCUURVFPZYRVGPYPYSVHIZYOYQUUPIZUVFYPUVIUVQUVPY
      RYSYSOZVIPYMYNYOVJYPUVJUVRUVOUUPYRCYQYQOZUURUUSVMPUUPYTYSEYQUUPYRYSUVSUUS
      VKYTOZVNQZYPBUUPFUUBYPUVJBUUPUUBRUVOUUBUUPYRCBUURUUBOZGUUSVOPYMYNYOVPZVQZ
      UUPYRUUDUUAUUCUUSUUDOZVRQZYPUUEUUQVSZUUKSIZYPUUKESYPUUKUUAUUJJZEYPUUPUUJC
      UUAUUCUUDYRUURUUTUVOUUSUWFUWBUWEYPUUCUUJJZEUWJVTYPUWKTEYPUVGUWKWCIUWEUUPU
      UJYRCUUCUUTUURUUSWAPTWCIYPWDWEYOYMEWCIYNYOEEWBWFWGYPUVJYNUWKTURWNUVOUWDUU
      BUUJYRCFBUUTUURGUWCWHWIYOYMTEVTWNYNEWJWGWKYPCWLIZESIZUWJEMYPYMUWLUVDYMUVL
      UWLYMUVKUVLUVMWMCWOPPYOYMUWMYNEWPZWGZUUJYRCYTEYSYQUUTUURUVTUVSUWAWQWIZWRW
      SUWPWTZUWOXAYPUVJUVHUWHUWIXDUVOUWGUUPUUJYRCUUEUUQUUTUURUVCUUSXBWIXCXEYPUU
      IUUOLYPUUIUULUUGJZUUHMZABUQZUUOYPUUGBXFZUUIUWTMYPBBUUGRUXAYPBCBCBXGKZNJZU
      AUUGUXBXHUXBOZGUXCOZUVDBXHIYPBCNJXHGCNXIXJWEYPUUPUXCUUEUUFYPUUFYRUXBXKKIZ
      UUPUXCUUFRYPUVKUXFUVNBYRCUXBUUFUVAUURUXDGXLPUUPUXCYRUXBUUFUUSUXEXMPUWGVQX
      NBBUUGXQPABUUHUUGXOPYPUWSUUNABYPUULBIZXPZUWSUUMFCUIJZKZUUHMZUUNUXHUWRUXJU
      UHUXHUVHUWRUXJMUXHBUXIYRCUUPUUAUUDUUCUUFUUMFUULUVAUURGUUSYPUVKUXGUVNXRZYP
      UXGXSZUXHBYRCYTUUPDYQEUUFUULUULUVAUURGUUSUXLUXMUXHBYRCUUPUUFYQUULUVAUVTGU
      URUUSUXLUXMXTUWAHUXHYOUWMYMYNYOUXGYAZUWNPYBUXHUUBBYRCUUPUUFFUULUVAUURGUWC
      UUSUXLYMYNYOUXGYCZUXMYDUWFUXIOZYEYFYGUXHCUTIZUUMBIZYNUXKUUNXDYPUXQUXGYPUV
      JUXQUVOCVGPXRUXHCUFJZVHIZYOUXGUXRYPUXTUXGYPUVJUXTUVOCUXSUXSOZVIPXRUXNUXMB
      DUXSEUULBCUXSUYAGVKHVNQUXOBCUXIUUMFUUHGUVBUXPYHQYIYJWTYKUWQYL $.
  $}

  ${
    $d x B $.  $d x N $.  $d x R $.
    idomodle.g $e |- G = ( ( mulGrp ` R ) |`s ( Unit ` R ) ) $.
    idomodle.b $e |- B = ( Base ` G ) $.
    idomodle.o $e |- O = ( od ` G ) $.
    $( Limit on the number of ` N ` -th roots of unity in an integral domain.
       (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    idomodle $p |- ( ( R e. IDomn /\ N e. NN ) ->
        ( # ` { x e. B | ( O ` x ) || N } ) <_ N ) $=
      ( wcel cfv wbr crab chash wceq cbs cvv cxr syl eqid cidom cn cdivides cmg
      wa cv cmgp cur fvex eqeltri rabex hashxrcl mp1i nnre rexrd adantl cle c0g
      co cgrp cz crg ccrg cdomn isidom simplbi adantr crngrng cui unitgrp simpr
      wb nnz ad2antlr oddvds syl3anc csubmnd unitsubm nnnn0 unitgrpbas syl6eleq
      cn0 eqtr4i submmulg eqeq12d bitr4d rabbidva fveq2d cdom wss unitss rabss2
      unitgrpid ssdomg mpsyl hashdomi eqbrtrd simpl rngidcl idomrootle xrletrd
      ) CUAJZEUBJZUEZAUFZFKEUCLZABMZNKZEXECUGKZUDKZUSZCUHKZOZACPKZMZNKZEXGQJXHR
      JXDXFABBDPKZQHDPUIUJUKXGQULUMXOQJZXPRJXDXMAXNCPUIUKZXOQULUMXCERJXBXCEEUNU
      OUPXDXHXMABMZNKZXPUQXDXGXTNXDXFXMABXDXEBJZUEZXFEXEDUDKZUSZDURKZOZXMYCDUTJ
      ZYBEVAJZXFYGVLYCCVBJZYHXDYJYBXDCVCJZYJXBYKXCXBYKCVDJCVEVFVGCVHSZVGZCCVIKZ
      DYNTZGVJSXDYBVKZXCYIXBYBEVMVNXEYDDEFBYFHIYDTZYFTVOVPYCXKYEXLYFYCYNXIVQKJZ
      EWBJZXEYNJXKYEOYCYJYRYMCYNXIYOXITVRSXCYSXBYBEVSVNYCXEBYNYPBXQYNHCYNDYOGVT
      WCZWAYNXJYDXIDEXEXJTZGYQWDVPYCYJXLYFOYMCYNXLDYOGXLTZWMSWEWFWGWHXDXTXOWILZ
      YAXPUQLXRXDXTXOWJZUUCXSBXNWJUUDXDXNCBXNTZYTWKXMABXNWLUMXTXOQWNWOXTXOWPSWQ
      XDXBXLXNJZXCXPEUQLXBXCWRXDYJUUFYLXNCXLUUEUUBWSSXBXCVKAXNCXJEXLUUEUUAWTVPX
      A $.
  $}

  $( Two finite sets of equal size have a union of the same size iff they were
     equal.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
  fiuneneq $p |- ( ( A ~~ B /\ A e. Fin ) ->
      ( ( A u. B ) ~~ A <-> A = B ) ) $=
    ( cen wbr cfn wcel wa cun wceq w3a wss simp2 wb 3ad2ant1 syl2anc a1i ensymd
    enfi fisseneq syl3anc mpbid unfi ssun1 simp3 ssun2 simp1 entr eqtr4d 3expia
    enrefg adantl unidm uneq2 syl5eqr breq1d syl5ibcom impbid ) ABCDZAEFZGZABHZ
    ACDZABIZURUSVBVCURUSVBJZAVABVDVAEFZAVAKZAVACDAVAIVDUSBEFZVEURUSVBLZVDUSVGVH
    URUSUSVGMVBABRNUAABUBOZVFVDABUCPVDVAAURUSVBUDZQAVASTVDVEBVAKZBVACDBVAIVIVKV
    DBAUEPVDVABVDVBURVABCDVJURUSVBUFVAABUGOQBVASTUHUIUTAACDZVCVBUSVLURAEUJUKVCA
    VAACVCAAAHVAAULABAUMUNUOUPUQ $.

  ${
    $d x y z G $.  $d x y z N $.  $d x y z R $.
    idomsubgmo.g $e |- G = ( ( mulGrp ` R ) |`s ( Unit ` R ) ) $.
    $( The units of an integral domain have at most one subgroup of any single
       finite cardinality.  (Contributed by Stefan O'Rear, 12-Sep-2015.)
       (Revised by NM, 17-Jun-2017.) $)
    idomsubgmo $p |- ( ( R e. IDomn /\ N e. NN ) ->
        E* y e. ( SubGrp ` G ) ( # ` y ) = N ) $=
      ( vx vz wcel wa cv chash cfv wbr cdom cdivides cvv wss cn0 wb adantr wceq
      cidom cn weq wi csubg wral wrmo w3a cun cen cod cbs crab fvex simp2l eqid
      rabex subgss syl wel cfn simpl2l simp3l simp1r nnnn0d eqeltrd vex hashclb
      ax-mp sylibr simpr odsubdvds syl3anc breqtrd ssrabdv simp2r simpl2r unssd
      simp3r mpsyl cle idomodle 3ad2ant1 breqtrrd hashbnd hashdom sylancl mpbid
      ssdomg a1i domtr syl2anc unex ssun1 mp2 eqtr4d hashen fiuneneq ralrimivva
      sbth 3expia fveq2 eqeq1d rmo4 ) BUBHZDUCHZIZAJZKLZDUAZFJZKLZDUAZIZAFUDZUE
      ZFCUFLZUGAXRUGXKAXRUHXHXQAFXRXRXHXIXRHZXLXRHZIZXOXPXHYAXOUIZXIXLUJZXIUKMZ
      XPYBYCXINMZXIYCNMZYDYBYCGJZCULLZLZDOMZGCUMLZUNZNMZYLXINMZYEYLPHZYBYCYLQYM
      YJGYKCUMUOURZYBXIXLYLYBYJGYKXIYBXSXIYKQXHXSXTXOUPYKXICYKUQZUSUTYBGAVAZIZY
      IXJDOYSXSXIVBHZYRYIXJOMXSXTXHXOYRVCYBYTYRYBXJRHZYTYBXJDRXHYAXKXNVDZYBDXFX
      GYAXOVEVFZVGZXIPHZYTUUASAVHZXIPVIVJVKZTYBYRVLYGXICYHYHUQZVMVNYBXKYRUUBTVO
      VPYBYJGYKXLYBXTXLYKQXHXSXTXOVQYKXLCYQUSUTYBGFVAZIZYIXMDOUUJXTXLVBHZUUIYIX
      MOMXSXTXHXOUUIVRYBUUKUUIYBXMRHZUUKYBXMDRXHYAXKXNVTZUUCVGXLPHUUKUULSFVHZXL
      PVIVJVKZTYBUUIVLYGXLCYHUUHVMVNYBXNUUIUUMTVOVPVSYCYLPWJWAYBYLKLZXJWBMZYNYB
      UUPDXJWBXHYAUUPDWBMXOGYKBCDYHEYQUUHWCWDUUBWEZYBYLVBHZUUEUUQYNSYBYOUUAUUQU
      USYOYBYPWKUUDUURYLXJPWFVNUUFYLXIPWGWHWIYCYLXIWLWMYCPHXIYCQYFXIXLUUFUUNWNX
      IXLWOXIYCPWJWPYCXIXAWHYBXIXLUKMZYTYDXPSYBXJXMUAZUUTYBXJDXMUUBUUMWQYBYTUUK
      UVAUUTSUUGUUOXIXLWRWMWIUUGXIXLWSWMWIXBWTXKXNAFXRXPXJXMDXIXLKXCXDXEVK $.

    $d x K $.  $d x X $.  $d x Y $.
    proot1mul.o $e |- O = ( od ` G ) $.
    proot1mul.k $e |- K = ( mrCls ` ( SubGrp ` G ) ) $.
    $( Any primitive ` N ` -th root of unity is a multiple of any other.
       (Contributed by Stefan O'Rear, 2-Nov-2015.) $)
    proot1mul $p |- ( ( ( R e. IDomn /\ N e. NN ) /\
          ( X e. ( `' O " { N } ) /\ Y e. ( `' O " { N } ) ) ) ->
        X e. ( K ` { Y } ) ) $=
      ( vx wcel cn wa csn cfv wss wceq wb chash cidom ccnv cima csubg cgrp cacs
      cbs cmre cdomn crg simpll ccrg isidom simprbi domnrng cui unitgrp subgacs
      eqid 4syl acsmre 3syl simprl cn0 wf wfn odf ffn fniniseg mp2b sylib snssd
      simpld mrcssidd snssg syl mpbird cv wrmo idomsubgmo adantr syl2anc simprd
      mrccl simplr eqeltrd odhash2 syl3anc eqtrd simprr fveq2 syl122anc eleqtrd
      eqeq1d rmoi ) AUALZDMLZNZFEUBDOUCZLZGWSLZNZNZFFOZCPZGOZCPZXCFXELZXDXEQZXC
      BUDPZXDCBUGPZXCBUELZXJXKUFPLXJXKUHPLZXCWPAUILZAUJLXLWPWQXBUKWPAULLXNAUMUN
      AUOAAUPPZBXOUSHUQUTZXKBXKUSZURXJXKVAVBZJXCFXKXCFXKLZFEPZDRZXCWTXSYANZWRWT
      XAVCZXKVDEVEZEXKVFZWTYBSBEXKXQIVGZXKVDEVHZXKDFEVIVJVKZVMZVLZVNXCWTXHXISYC
      FXEWSVOVPVQXCKVRZTPZDRZKXJVSZXEXJLZXETPZDRZXGXJLZXGTPZDRZXEXGRWRYNXBKABDH
      VTWAXCXMXDXKQYOXRYJXJXDCXKJWDWBXCYPXTDXCXLXSXTMLYPXTRXPYIXCXTDMXCXSYAYHWC
      ZWPWQXBWEZWFFBCEXKXQIJWGWHUUAWIXCXMXFXKQYRXRXCGXKXCGXKLZGEPZDRZXCXAUUCUUE
      NZWRWTXAWJYDYEXAUUFSYFYGXKDGEVIVJVKZVMZVLXJXFCXKJWDWBXCYSUUDDXCXLUUCUUDML
      YSUUDRXPUUHXCUUDDMXCUUCUUEUUGWCZUUBWFGBCEXKXQIJWGWHUUIWIYMYQYTKXJXEXGYKXE
      RYLYPDYKXETWKWNYKXGRYLYSDYKXGTWKWNWOWLWM $.
  $}

  ${
    $d w x y M $.  $d w x z M $.  $d w x A $.  $d w x B $.  $d w x y N $.
    $d z N $.
    hashgcdlem.a $e |- A = { y e. ( 0 ..^ ( M / N ) ) |
        ( y gcd ( M / N ) ) = 1 } $.
    hashgcdlem.b $e |- B = { z e. ( 0 ..^ M ) | ( z gcd M ) = N } $.
    hashgcdlem.f $e |- F = ( x e. A |-> ( x x. N ) ) $.
    $( A correspondence between elements of specific GCD and relative primes in
       a smaller ring.  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    hashgcdlem $p |- ( ( M e. NN /\ N e. NN /\ N || M ) ->
        F : A -1-1-onto-> B ) $=
      ( wcel wbr co cc0 cgcd c1 wceq wa adantr vw cn cdivides cv cmul cdiv cfzo
      w3a oveq1 eqeq1d elrab2 cn0 clt cfz elfzofz elfznn0 syl ad2antrl 3ad2ant2
      nnnn0 nn0mulcld simpl1 elfzolt2 cr wb cz elfzoelz zred 3ad2ant1 nngt0 jca
      nnre ltmuldiv syl3anc mpbird elfzo0 syl3anbrc cc nncn wne divcan1d eqcomd
      nnne0 oveq2d nndivdvds biimp3a mulgcdr simprr oveq1d mulid2d eqtrd 3eqtrd
      nnzd sylanbrc sylan2b cle gcddvds syl2anc simpld eqbrtrrd nnz mpbid nn0re
      dvdsval2 nn0ge0 divge0 elnn0z ltdiv1 simpl2 simpl3 gcddiv syl32anc dividd
      3eqtr3d simplbi anim12i ad2antll eqeq2d syl5ibrcom divcan4d impbid sylan2
      3syl zcnd f1o2d ) GUBLZHUBLZHGUCMZUHZAUADEAUDZHUENZUAUDZHUFNZFKYJDLZYIYJO
      GHUFNZUGNZLZYJYOPNZQRZSZYKELZBUDZYOPNZQRZYSBYJYPDUUBYJRUUCYRQUUBYJYOPUIUJ
      IUKZYIYTSZYKOGUGNZLZYKGPNZHRZUUAUUFYKULLYFYKGUMMZUUHUUFYJHYQYJULLZYIYSYQY
      JOYOUNNLUULYJOYOUOYJYOUPUQURYIHULLZYTYGYFUUMYHHUTUSTZVAYFYGYHYTVBUUFUUKYJ
      YOUMMZYQUUOYIYSYJOYOVCURUUFYJVDLGVDLZHVDLZOHUMMZSZUUKUUOVEUUFYJYQYJVFLZYI
      YSYJOYOVGZURZVHYIUUPYTYFYGUUPYHGVLVIZTYIUUSYTYGYFUUSYHYGUUQUURHVLHVJVKUSZ
      TYJGHVMVNVOYKGVPVQUUFUUIYKYOHUENZPNZYRHUENZHUUFGUVEYKPUUFUVEGYIUVEGRYTYIG
      HYFYGGVRLYHGVSVIYGYFHVRLZYHHVSUSZYGYFHOVTZYHHWCUSZWATWBWDUUFUUTYOVFLZUUMU
      VFUVGRUVBYIUVLYTYIYOYFYGYHYOUBLZGHWEWFZWMTUUNYJYOHWGVNUUFUVGQHUENZHUUFYRQ
      HUEYIYQYSWHWIYIUVOHRYTYIHUVIWJTWKWLCUDZGPNZHRZUUJCYKUUGEUVPYKRUVQUUIHUVPY
      KGPUIUJJUKWNWOYLELZYIYLUUGLZYLGPNZHRZSZYMDLZUVRUWBCYLUUGEUVPYLRUVQUWAHUVP
      YLGPUIUJJUKZYIUWCSZYMYPLZYMYOPNZQRZUWDUWFYMULLZUVMYMYOUMMZUWGUWFYMVFLZOYM
      WPMZUWJUWFHYLUCMZUWLUWFUWAHYLUCYIUVTUWBWHZUWFUWAYLUCMZUWAGUCMZUWFYLVFLZGV
      FLZUWPUWQSUVTUWRYIUWBYLOGVGZURZUWFGYFYGYHUWCVBWMZYLGWQWRWSWTZUWFHVFLZUVJU
      WRUWNUWLVEYIUXDUWCYGYFUXDYHHXAUSTYIUVJUWCUVKTUXAHYLXDVNXBUWFYLVDLZOYLWPMZ
      SZUUSUWMUWFYLOGUNNLZYLULLZUXGUVTUXHYIUWBYLOGUOURYLGUPUXIUXEUXFYLXCYLXEVKY
      CYIUUSUWCUVDTZYLHXFWRYMXGWNYIUVMUWCUVNTUWFYLGUMMZUWKUVTUXKYIUWBYLOGVCURUW
      FUXEUUPUUSUXKUWKVEUWFYLUXAVHYIUUPUWCUVCTUXJYLGHXHVNXBYMYOVPVQUWFUWAHUFNZH
      HUFNZUWHQUWFUWAHHUFUWOWIUWFUWRUWSYGUWNYHUXLUWHRUXAUXBYFYGYHUWCXIUXCYFYGYH
      UWCXJYLGHXKXLYIUXMQRUWCYIHUVIUVKXMTXNUUDUWIBYMYPDUUBYMRUUCUWHQUUBYMYOPUIU
      JIUKWNWOYNUVSSYIYQUVTSZYJYMRZYLYKRZVEYNYQUVSUVTYNYQYSUUEXOUVSUVTUWBUWEXOX
      PYIUXNSZUXOUXPUXQUXPUXOYLYMHUENZRUXQUXRYLUXQYLHUXQYLUVTUWRYIYQUWTXQYDYIUV
      HUXNUVITZYIUVJUXNUVKTZWAWBUXOYKUXRYLYJYMHUEUIXRXSUXQUXOUXPYJYKHUFNZRUXQUY
      AYJUXQYJHUXQYJYQUUTYIUVTUVAURYDUXSUXTXTWBUXPYMUYAYJYLYKHUFUIXRXSYAYBYE $.
  $}

  ${
    $d x z M $.  $d x z N $.  $d y z M $.  $d y z N $.
    $( Number of initial natural numbers with specified divisors.  (Contributed
       by Stefan O'Rear, 12-Sep-2015.) $)
    hashgcdeq $p |- ( ( M e. NN /\ N e. NN ) -> ( # ` { x e. ( 0 ..^ M ) |
          ( x gcd M ) = N } ) = if ( N || M , ( phi ` ( M / N ) ) , 0 ) ) $=
      ( vy vz cdivides wbr cv cgcd co wceq cc0 cfzo chash cfv cn wcel wa eqid
      c0 crab cdiv cphi cif eqeq2 c1 nndivdvds biimpa dfphi2 syl cmul cmpt wf1o
      cen hashgcdlem 3expa ovex rabex f1oen hasheni 3syl eqtr2d simprr elfzoelz
      wn wral cz ad2antrl nnz ad2antrr gcddvds syl2anc simprd eqbrtrrd impancom
      expr con3d ralrimiv rabeq0 sylibr fveq2d hash0 syl6eq ifbothda ) CBFGZAHZ
      BIJZCKZALBMJZUAZNOZBCUBJZUCOZKWKLKWKWEWMLUDZKBPQZCPQZRZWMLWMWNWKUELWNWKUE
      WQWERZWMDHWLIJUFKZDLWLMJZUAZNOZWKWRWLPQZWMXBKWQWEXCBCUGUHDWLUIUJWRXAWJEXA
      EHCUKJULZUMZXAWJUNGXBWKKWOWPWEXEEDAXAWJXDBCXASWJSXDSUOUPXAWJXDWSDWTLWLMUQ
      URUSXAWJUTVAVBWQWEVEZRZWKTNOLXGWJTNXGWHVEZAWIVFWJTKXGXHAWIWQWFWIQZXFXHWQX
      IRWHWEWQXIWHWEWQXIWHRZRZWGCBFWQXIWHVCXKWGWFFGZWGBFGZXKWFVGQZBVGQZXLXMRXIX
      NWQWHWFLBVDVHWOXOWPXJBVIVJWFBVKVLVMVNVPVQVOVRWHAWIVSVTWAWBWCWD $.

    $d d w x y z N $.  $d x y z M $.
    $( The divisor sum identity of the totient function.  (Contributed by
       Stefan O'Rear, 12-Sep-2015.) $)
    phisum $p |- ( N e. NN -> sum_ d e. { x e. NN | x || N }
          ( phi ` d ) = N ) $=
      ( vy vz vw cn wcel cv cdivides wbr crab cfv co wceq cc0 chash cdiv wa cfn
      cphi csu cgcd cfzo ciun breq1 elrab cif hashgcdeq adantrr iftrue ad2antll
      eqtrd sylan2b sumeq2dv cfz wss fzfi sgmss ssfi sylancr fzofi ssrab2 mp2an
      a1i wral wdisj oveq1 eqeq1d simprbi rgen rgenw invdisj mp1i hashiun fveq2
      c1 cmpt eqid dvdsflip oveq2 ovex fvmpt adantl elrabi phicld nncnd fsumf1o
      3eqtr4rd wrex cz wn elfzoelz adantr nnne0 neneqd intnand gcdn0cl syl21anc
      gcddvds syl2anc simprd sylanbrc risset eqcom rexbii bitri sylib ralrimiva
      nnz rabid2 sylibr iunrab syl6reqr fveq2d cn0 nnnn0 hashfzo0 syl ) BGHZAIZ
      BJKZAGLZCIZUAMZCUBZDYCEIZBUCNZDIZOZEPBUDNZLZUEZQMZBXTYCYLQMZDUBYCBYIRNZUA
      MZDUBYNYFXTYCYOYQDYIYCHZXTYIGHZYIBJKZSZYOYQOYBYTAYIGYAYIBJUFUGXTUUASYOYTY
      QPUHZYQXTYSYOUUBOYTEBYIUIUJYTUUBYQOXTYSYTYQPUKULUMUNUOXTDYCYLXTVQBUPNZTHY
      CUUCUQYCTHVQBURBAUSUUCYCUTVAZYLTHZXTYRSYKTHYLYKUQUUEPBVBYJEYKVCYKYLUTVDVE
      FIZBUCNZYIOZFYLVFZDYCVFDYCYLVGXTUUIDYCUUHFYLUUFYLHUUFYKHUUHYJUUHEUUFYKYGU
      UFOYHUUGYIYGUUFBUCVHVIUGVJVKVLDFYCYLUUGVMVNVOXTYCYEYCYQCDEYCBYGRNZVRZYPYD
      YPUAVPUUDAEYCUUKBYCVSUUKVSZVTYRYIUUKMYPOXTEYIUUJYPYCUUKYGYIBRWAUULBYIRWBW
      CWDXTYDYCHZSZYEUUNYDUUMYDGHXTYBAYDGWEWDWFWGWHWIXTYNYKQMZBXTYMYKQXTYKYJDYC
      WJZEYKLZYMXTUUPEYKVFYKUUQOXTUUPEYKXTYGYKHZSZYHYCHZUUPUUSYHGHZYHBJKZUUTUUS
      YGWKHZBWKHZYGPOZBPOZSWLZUVAUURUVCXTYGPBWMWDZXTUVDUURBXJWNZXTUVGUURXTUVFUV
      EXTBPBWOWPWQWNYGBWRWSUUSYHYGJKZUVBUUSUVCUVDUVJUVBSUVHUVIYGBWTXAXBYBUVBAYH
      GYAYHBJUFUGXCUUTYIYHOZDYCWJUUPDYHYCXDUVKYJDYCYIYHXEXFXGXHXIUUPEYKXKXLYJDE
      YCYKXMXNXOXTBXPHUUOBOBXQBXRXSUMUM $.
  $}

  ${
    $d x G $.  $d x N $.  $d x O $.  $d x R $.  $d x X $.
    proot1hash.g $e |- G = ( ( mulGrp ` R ) |`s ( Unit ` R ) ) $.
    proot1hash.o $e |- O = ( od ` G ) $.
    $( If an integral domain has a primitive ` N ` -th root of unity, it has
       exactly ` ( phi `` N ) ` of them.  (Contributed by Stefan O'Rear,
       12-Sep-2015.) $)
    proot1hash $p |- ( ( R e. IDomn /\ N e. NN /\ X e. ( `' O " { N } ) ) ->
        ( # ` ( `' O " { N } ) ) = ( phi ` N ) ) $=
      ( vx wcel cn csn chash cfv wceq crab cphi cn0 eqid mp2b 3syl ccnv cima cv
      cidom w3a csubg cmrc cbs wf wfn odf ffn fniniseg2 wa simp3 fniniseg sylib
      cin wb simprd eqeq2d rabbidv cmre wss cgrp cacs cdomn ccrg isidom simprbi
      crg 3ad2ant1 domnrng unitgrp subgacs acsmre mrcssv dfrab3ss simpl1 simpl2
      cui incom simpr simpl3 proot1mul syl22anc ex ssrdv syl5eqssr df-ss syl5eq
      3eqtrrd fveq2d simpld simp2 eqeltrd odngen syl3anc 3eqtrd ) AUDIZCJIZEDUA
      CKUBZIZUEZXBLMHUCZDMZEDMZNZHEKZBUFMZUGMZMZOZLMZXGPMZCPMXDXBXMLXDXBXFCNZHB
      UHMZOZXMXQQDUIZDXQUJZXBXRNBDXQXQRZGUKZXQQDULZHXQCDUMSZXDXMXPHXLOZXLXRURZX
      RXDXHXPHXLXDXGCXFXDEXQIZXGCNZXDXCYGYHUNZWTXAXCUOXSXTXCYIUSYBYCXQCEDUPSUQZ
      UTZVAVBXDXJXQVCMIZXLXQVDYEYFNXDBVEIZXJXQVFMIYLXDAVGIZAVKIYMWTXAYNXCWTAVHI
      YNAVIVJVLAVMAAWAMZBYORFVNTZXQBYAVOXJXQVPTXJXIXKXQXKRZVQXPHXLXQVRTXDYFXRXL
      URZXRXLXRWBXDXRXLVDYRXRNXDXRXBXLYDXDHXBXLXDXEXBIZXEXLIZXDYSUNWTXAYSXCYTWT
      XAXCYSVSWTXAXCYSVTXDYSWCWTXAXCYSWDABXKCDXEEFGYQWEWFWGWHWIXRXLWJUQWKWLWKWM
      XDYMYGXGJIXNXONYPXDYGYHYJWNXDXGCJYKWTXAXCWOWPHEBXKDXQYAGYQWQWRXDXGCPYKWMW
      S $.
  $}

  ${
    $d x G $.  $d x N $.  $d x O $.
    proot1ex.g $e |- G = ( ( mulGrp ` CCfld ) |`s ( CC \ { 0 } ) ) $.
    proot1ex.o $e |- O = ( od ` G ) $.
    $( The complex field has primitive ` N ` -th roots of unity for all
       ` N ` .  (Contributed by Stefan O'Rear, 12-Sep-2015.) $)
    proot1ex $p |- ( N e. NN -> ( -u 1 ^c ( 2 / N ) ) e. ( `' O " { N } ) ) $=
      ( wcel c1 c2 cdiv co cc cc0 cfv wceq a1i cn0 cmul ci cpi ccnfld cneg ccxp
      vx ccnv csn cima cdif wne neg1cn crp 2rp nnrp rpdivcl sylancr rpcnd cxpcl
      cn ax-1cn ax-1ne0 negne0i cxpne0d eldifsn sylanbrc cv cdivides wbr cmg wb
      wral wa cz clog ce nn0cn mulcl syl2an cxpefd eqeq1d logcl mp2an efeq1 syl
      sylancl nncn adantr adantl nnne0 div13d logm1 oveq12d divcld ax-icn recni
      2cn pire mulcli mulassd mul12d oveq2d 3eqtrd oveq1d ine0 gt0ne0ii mulne0i
      2ne0 pipos divcan4d eqtrd eleq1d 3bitrd cexp cmgp simpr cxpmul2d cnfldexp
      sylan crg cnrng cnfldbas cnfld0 cndrng drngui eqid unitsubm mp1i submmulg
      csubmnd syl3anc 3eqtr2rd nn0z dvdsval2 3bitr4rd ralrimiva cgrp unitgrpbas
      nnz unitgrp nnnn0 c0g ax-mp cnfld1 unitgrpid mpbird eqcomd wfn wf odf ffn
      odeq fniniseg mpbir2and ) BUQFZGUAZHBIJZUBJZCUDBUEUFFZUUOKLUEUGZFZUUOCMZB
      NZUULUUOKFZUUOLUHUURUULUUMKFZUUNKFZUVAUIUULUUNUULHUJFBUJFUUNUJFUKBULHBUMU
      NUOZUUMUUNUPUNZUULUUMUUNUVBUULUIOUUMLUHZUULGURUSUTZOUVDVAUUOKLVBVCZUULBUU
      SUULBUUSNZBUCVDZVEVFZUVJUUOAVGMZJZGNZVHZUCPVIZUULUVOUCPUULUVJPFZVJZUUMUUN
      UVJQJZUBJZGNZUVJBIJZVKFZUVNUVKUVRUWAUVSUUMVLMZQJZVMMZGNZUWERHSQJZQJZIJZVK
      FZUWCUVRUVTUWFGUVRUUMUVSUVBUVRUIOZUVFUVRUVGOUULUVCUVJKFZUVSKFZUVQUVDUVJVN
      ZUUNUVJVOVPZVQVRUVRUWEKFZUWGUWKVHUVRUWNUWDKFZUWQUWPUVBUVFUWRUIUVGUUMVSVTU
      VSUWDVOWCUWEWAWBUVRUWJUWBVKUVRUWJUWBUWIQJZUWIIJUWBUVRUWEUWSUWIIUVRUWEUWBH
      QJZRSQJZQJUWBHUXAQJZQJUWSUVRUVSUWTUWDUXAQUVRHBUVJHKFUVRWNOZUULBKFUVQBWDWE
      ZUVQUWMUULUWOWFZUULBLUHZUVQBWGWEZWHUWDUXANUVRWIOWJUVRUWBHUXAUVRUVJBUXEUXD
      UXGWKZUXCUXAKFUVRRSWLSWOWMZWPOWQUVRUXBUWIUWBQUVRHRSUXCRKFUVRWLOSKFUVRUXIO
      WRWSWTXAUVRUWBUWIUXHUWIKFUVRRUWHWLHSWNUXIWPZWPOUWILUHUVRRUWHWLUXJXBHSWNUX
      IXESWOXFXCXDXDOXGXHXIXJUVRUVMUVTGUVRUVTUUOUVJXKJZUVJUUOTXLMZVGMZJZUVMUVRU
      UMUUNUVJUWLUULUVCUVQUVDWEUULUVQXMZXNUULUVAUVQUXNUXKNUVEUUOUVJXOXPUVRUUQUX
      LYGMFZUVQUURUXNUVMNTXQFZUXPUVRXRTUUQUXLKTLXSXTYAYBZUXLYCYDYEUXOUULUURUVQU
      VHWEUUQUXMUVLUXLAUVJUUOUXMYCDUVLYCZYFYHYIVRUVRBVKFZUXFUVJVKFZUVKUWCVHUULU
      XTUVQBYPWEUXGUVQUYAUULUVJYJWFBUVJYKYHYLYMUULAYNFZUURBPFUVIUVPVHUXQUYBUULX
      RTUUQAUXRDYQYEUVHBYRUCUUOUVLABCUUQGTUUQAUXRDYOZEUXSUXQGAYSMNXRTUUQGAUXRDU
      UAUUBYTUUIYHUUCUUDCUUQUUEZUUPUURUUTVJVHUULUUQPCUUFUYDACUUQUYCEUUGUUQPCUUH
      YTUUQBUUOCUUJYEUUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Cyclotomic polynomials
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c CytP $.
  $( Syntax for the sequence of cyclotomic polynomials. $)
  ccytp $a class CytP $.

  ${
    $d n r $.
    $( The Nth _cyclotomic polynomial_ is the polynomial which has as its zeros
       precisely the primitive Nth roots of unity.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    df-cytp $a |- CytP = ( n e. NN |-> ( ( mulGrp ` ( Poly1 ` CCfld ) ) gsum
        ( r e. ( `' ( od ` ( ( mulGrp ` CCfld ) |`s ( CC \ { 0 } ) ) ) " { n
        } ) |-> ( ( var1 ` CCfld ) ( -g ` ( Poly1 ` CCfld ) ) ( ( algSc ` (
        Poly1 ` CCfld ) ) ` r ) ) ) ) ) $.
  $}

  ${
    $d x y B $.  $d x y R $.  $d x y U $.  $d x y .0. $.
    isdomn3.b $e |- B = ( Base ` R ) $.
    isdomn3.z $e |- .0. = ( 0g ` R ) $.
    isdomn3.u $e |- U = ( mulGrp ` R ) $.
    $( Nonzero elements form a multiplicative submonoid of any domain.
       (Contributed by Stefan O'Rear, 11-Sep-2015.) $)
    isdomn3 $p |- ( R e. Domn <-> ( R e. Ring /\
          ( B \ { .0. } ) e. ( SubMnd ` U ) ) ) $=
      ( vx vy wcel cv cfv wceq wi wral wa wne bitri eldifsn wal cdomn cmulr crg
      cnzr co wo csn cdif csubmnd eqid isdomn cur isnzr anbi1i anass wb rngidcl
      baibr syl rngcl 3expb biantrurd syl6bbr imbi2d 2ralbidva wn neanior df-ne
      con34b imbi12i bitr4i 2ralbii impexp anbi12i imbi1i bitr3i 2albii 3bitr4g
      an4 r2al 3bitr4ri anbi12d cmnd rngmgp wss mgpbas rngidval mgpplusg issubm
      w3a 3anass syl6bb difss biantrur bitr4d pm5.32i ) BUAJBUDJZHKZIKZBUBLZUEZ
      DMZWRDMWSDMUFZNZIAOHAOZPZBUCJZADUGZUHZCUILJZPZHIABWTDEWTUJZFUKXFXGBULLZDQ
      ZXEPZPZXKXFXGXNPZXEPXPWQXQXEBXMDXMUJZFUMUNXGXNXEUORXGXOXJXGXOXMXIJZXAXIJZ
      IXIOHXIOZPZXJXGXNXSXEYAXGXMAJZXNXSUPABXMEXRUQXSYCXNXMADSURUSXGWRDQZWSDQZP
      ZXADQZNZIAOHAOYFXTNZIAOHAOZXEYAXGYHYIHIAAXGWRAJZWSAJZPZPZYGXTYFYNYGXAAJZY
      GPXTYNYOYGXGYKYLYOABWTWRWSEXLUTVAVBXAADSVCVDVEXDYHHIAAXDXCVFZXBVFZNYHXBXC
      VIYFYPYGYQWRDWSDVGXADVHVJVKVLYMYINZITHTWRXIJZWSXIJZPZXTNZITHTYJYAYRUUBHIY
      RYMYFPZXTNUUBYMYFXTVMUUCUUAXTUUCYKYDPZYLYEPZPUUAYKYLYDYEVSYSUUDYTUUEWRADS
      WSADSVNVKVOVPVQYIHIAAVTXTHIXIXIVTWAVRWBXGCWCJZXJYBUPBCGWDUUFXJXIAWEZYBPZY
      BUUFXJUUGXSYAWJUUHHIAWTXICXMABCGEWFBXMCGXRWGBWTCGXLWHWIUUGXSYAWKWLUUGYBAX
      HWMWNVCUSWOWPRR $.
  $}

  ${
    $d x P $.  $d x R $.
    mon1pid.p $e |- P = ( Poly1 ` R ) $.
    mon1pid.o $e |- .1. = ( 1r ` P ) $.
    mon1pid.m $e |- M = ( Monic1p ` R ) $.
    mon1pid.d $e |- D = ( deg1 ` R ) $.
    $( Monicity and degree of the unit polynomial.  (Contributed by Stefan
       O'Rear, 12-Sep-2015.) $)
    mon1pid $p |- ( R e. NzRing -> ( .1. e. M /\ ( D ` .1. ) = 0 ) ) $=
      ( vx cnzr wcel cfv cc0 wceq cbs cco1 eqid syl cn0 c0g wne cur crg rngidcl
      ply1nz nzrrng 3syl nzrnz cv cif cmpt cascl ply1scl1 fveq2d coe1scl eqtr3d
      syl2anc deg1scl syl3anc fveq12d 0nn0 iftrue fvmpt ax-mp ismon1p syl3anbrc
      fvex syl6eq jca ) CKLZDELZDAMZNOVKDBPMZLZDBUAMZUBZVMDQMZMZCUCMZOVLVKBKLZB
      UDLVOBCFUFZBUGVNBDVNRZGUEUHVKWAVQWBBDVPGVPRZUISVKVSNJTJUJNOZVTCUAMZUKZULZ
      MZVTVKVMNVRWHVKVTBUMMZMZQMZVRWHVKWKDQVKCUDLZWKDOCUGZWJBCVTDFWJRZVTRZGUNSZ
      UOVKWMVTCPMZLZWLWHOWNVKWMWSWNWRCVTWRRZWPUESZJWJBCWRVTWFFWOWTWFRZUPURUQVKW
      KAMZVMNVKWKDAWQUOVKWMWSVTWFUBXCNOWNXACVTWFWPXBUIWJABCVTWRWFIFWTWOXBUSUTUQ
      ZVANTLWIVTOVBJNWGVTTWHWEVTWFVCWHRCUCVHVDVEVIVNABCVTDEVPFWCWDIHWPVFVGXDVJ
      $.
  $}

$(
  @{
    mon1pvr.x @e |- X = ( var1 ` R ) @.
    mon1pvr.m @e |- M = ( Monic1p ` R ) @.
    mon1pvr.d @e |- D = ( deg1 ` R ) @.
    @( Monicity and degree of the polynomial generator.  ( Contributed by
       Stefan O'Rear, 12-Sep-2015.) @)
    mon1pvr @p |- ( R e. NzRing -> ( X e. M /\ ( D ` X ) = 1 ) ) @= ? @.
  @}

  @{
    mon1plin.p @e |- P = ( Poly1 ` R ) @.
    mon1plin.x @e |- X = ( var1 ` R ) @.
    mon1plin.m @e |- M = ( Monic1p ` R ) @.
    mon1plin.d @e |- D = ( deg1 ` R ) @.
    mon1plin.s @e |- .- = ( -g ` P ) @.
    mon1plin.a @e |- A = ( algSc ` P ) @.
    mon1plin.k @e |- K = ( Base ` R ) @.
    @( Monicity and degree of a linear factor.  ( Contributed by Stefan O'Rear,
       12-Sep-2015.) @)
    mon1plin @p |- ( ( R e. NzRing /\ Y e. K ) ->
        ( ( X .- ( A ` Y ) ) e. M /\ ( D ` ( X .- ( A ` Y ) ) ) = 1 ) ) @= ? @.
  @}
$)


  ${
    $d x y M $.  $d x P $.  $d x y R $.  $d x y U $.
    mon1psubm.p $e |- P = ( Poly1 ` R ) $.
    mon1psubm.m $e |- M = ( Monic1p ` R ) $.
    mon1psubm.u $e |- U = ( mulGrp ` P ) $.
    $( Monic polynomials are a multiplicative submonoid.  (Contributed by
       Stefan O'Rear, 12-Sep-2015.) $)
    mon1psubm $p |- ( R e. NzRing -> M e. ( SubMnd ` U ) ) $=
      ( vx vy wcel cfv co eqid wceq wne cco1 syl adantr ad2antrl cn0 csubmnd cv
      cnzr cbs wss cur cmulr wral mon1pcl ssriv a1i cdg1 cc0 mon1pid simpld c0g
      wa crg ply1nz nzrrng simprr sseldi rngcl syl3anc caddc crlreg mon1pn0 cui
      mon1pldg unitrrg eqeltrd ad2antll deg1mul2 deg1nn0cl nn0addcld deg1nn0clb
      1unit sseldd syl2anc mpbird fveq2d coe1mul4 oveq12d rngidcl rnglidm eqtrd
      wb ismon1p syl3anbrc ralrimivva cmnd w3a rngmgp mgpbas rngidval mpbir3and
      mgpplusg issubm ) BUCJZDCUAKJZDAUDKZUEZAUFKZDJZHUBZIUBZAUGKZLZDJZIDUHHDUH
      ZXBWSHDXAXAABXEDEXAMZFUIZUJZUKWSXDXCBULKZKUMNXNABXCDEXCMZFXNMZUNUOWSXIHID
      DWSXEDJZXFDJZUQZUQZXHXAJZXHAUPKZOZXHXNKZXHPKZKZBUFKZNXIXTAURJZXEXAJZXFXAJ
      ZYAWSYHXSWSAUCJYHABEUSAUTQZRXQYIWSXRXLSZXTDXAXFXMWSXQXRVAVBZXAAXGXEXFXKXG
      MZVCVDZXTYCYDTJZXTYDXEXNKZXFXNKZVELZTXTXAXNABXGBVFKZXEXFYBXPEYTMZXKYNYBMZ
      WSBURJZXSBUTZRZYLXQXEYBOZWSXRABXEDYBEUUBFVGSZXTYQXEPKKZYGYTXQUUHYGNWSXRXN
      BYGXEDXPYGMZFVISZWSYGYTJXSWSBVHKZYTYGWSUUCUUKYTUEUUDBUUKYTUUAUUKMZVJQWSUU
      CYGUUKJUUDBUUKYGUULUUIVQQVRRVKYMXRXFYBOZWSXQABXFDYBEUUBFVGVLZVMZXTYQYRXTU
      UCYIUUFYQTJUUEYLUUGXAXNABXEYBXPEUUBXKVNVDXTUUCYJUUMYRTJUUEYMUUNXAXNABXFYB
      XPEUUBXKVNVDVOVKXTUUCYAYCYPWGUUEYOXAXNABXHYBXPEUUBXKVPVSVTXTYFYSYEKZYGXTY
      DYSYEUUOWAXTUUPUUHYRXFPKKZBUGKZLZYGXTXAXNBXGUURXEXFAYBEYNUURMZXKXPUUBUUEY
      LUUGYMUUNWBXTUUSYGYGUURLZYGXTUUHYGUUQYGUURUUJXRUUQYGNWSXQXNBYGXFDXPUUIFVI
      VLWCWSUVAYGNZXSWSUUCYGBUDKZJZUVBUUDWSUUCUVDUUDUVCBYGUVCMZUUIWDQUVCBUURYGY
      GUVEUUTUUIWEVSRWFWFWFXAXNABYGXHDYBEXKUUBXPFUUIWHWIWJWSCWKJZWTXBXDXJWLWGWS
      YHUVFYKACGWMQHIXAXGDCXCXAACGXKWNAXCCGXOWOAXGCGYNWQWRQWP $.
  $}

  ${
    $d x y B $.  $d x y D $.  $d x y N $.  $d x y R $.  $d x y Y $.
    $d x y .0. $.
    deg1mhm.d $e |- D = ( deg1 ` R ) $.
    deg1mhm.b $e |- B = ( Base ` P ) $.
    deg1mhm.p $e |- P = ( Poly1 ` R ) $.
    deg1mhm.z $e |- .0. = ( 0g ` P ) $.
    deg1mhm.y $e |- Y = ( ( mulGrp ` P ) |`s ( B \ { .0. } ) ) $.
    deg1mhm.n $e |- N = ( CCfld |`s NN0 ) $.
    $( Homomorphic property of the polynomial degree.  (Contributed by Stefan
       O'Rear, 12-Sep-2015.) $)
    deg1mhm $p |- ( R e. Domn ->
        ( D |` ( B \ { .0. } ) ) e. ( Y MndHom N ) ) $=
      ( vx wcel cn0 cfv wceq eqid syl vy cdomn cmnd wa cdif cres wf cv cmulr co
      csn caddc wral c0g cc0 w3a cmhm cmgp csubmnd ply1domn crg isdomn3 simprbi
      submmnd ccnfld nn0subm mp1i jca wfn wss cxr deg1xrf ffn ax-mp difss mp2an
      fnssres a1i fvres adantl domnrng adantr eldifi eldifsni deg1nn0cl syl3anc
      wne eqeltrd ralrimiva ffnfv sylanbrc crlreg ad2antrl deg1ldgdomn ad2antll
      cco1 simpl rngcl domnmuln0 syl122anc eldifsn oveqan12d 3eqtr4d ralrimivva
      deg1mul2 cur rngidcl cnzr domnnzr nzrnz 3syl rngidval fveq2d cmn1 mon1pid
      subm0 simprd 3eqtr3d 3jca cbs mgpbas ressbas2 nn0sscn cnfldbas cvv cplusg
      cc fvex eqeltri difexg mgpplusg ressplusg nn0ex cnfldadd cnfld0 ismhm ) D
      UBOZFUCOZEUCOZUDAGUKZUEZPBUUAUFZUGZNUHZUAUHZCUIQZUJZUUBQZUUDUUBQZUUEUUBQZ
      ULUJZRZUAUUAUMNUUAUMZFUNQZUUBQZUORZUPUUBFEUQUJOYQYRYSYQUUACURQZUSQOZYRYQC
      UBOZUURCDJUTZUUSCVAOZUURACUUQGIKUUQSZVBVCTZUUAFUUQLVDTPVEUSQOZYSYQVFPEVEM
      VDVGVHYQUUCUUMUUPYQUUBUUAVIZUUIPOZNUUAUMUUCUVEYQBAVIZUUAAVJZUVEAVKBUGUVGA
      BCDHJIVLAVKBVMVNAYTVOZAUUABVQVPVRYQUVFNUUAYQUUDUUAOZUDZUUIUUDBQZPUVJUUIUV
      LRYQUUDUUABVSZVTUVKDVAOZUUDAOZUUDGWGZUVLPOYQUVNUVJDWAZWBUVJUVOYQUUDAYTWCZ
      VTUVJUVPYQUUDAGWDZVTABCDUUDGHJKIWEWFWHWINUUAPUUBWJWKYQUULNUAUUAUUAYQUVJUU
      EUUAOZUDZUDZUUGBQZUVLUUEBQZULUJZUUHUUKUWBABCDUUFDWLQZUUDUUEGHJUWFSZIUUFSZ
      KYQUVNUWAUVQWBUVJUVOYQUVTUVRWMZUVJUVPYQUVTUVSWMZUWBYQUVOUVPUVLUUDWPQZQUWF
      OYQUWAWQUWIUWJUWKABCDUWFUUDGHJKIUWGUWKSWNWFUVTUUEAOZYQUVJUUEAYTWCWOZUVTUU
      EGWGZYQUVJUUEAGWDWOZXEUWBUUGUUAOZUUHUWCRUWBUUGAOZUUGGWGZUWPUWBUVAUVOUWLUW
      QYQUVAUWAYQUUSUVAUUTCWATZWBUWIUWMACUUFUUDUUEIUWHWRWFUWBUUSUVOUVPUWLUWNUWR
      YQUUSUWAUUTWBUWIUWJUWMUWOACUUFUUDUUEGIUWHKWSWTUUGAGXAWKUUGUUABVSTUWAUUKUW
      ERYQUVJUVTUUIUVLUUJUWDULUVMUUEUUABVSXBVTXCXDYQCXFQZUUBQZUWTBQZUUOUOYQUWTU
      UAOZUXAUXBRYQUWTAOZUWTGWGZUXCYQUVAUXDUWSACUWTIUWTSZXGTYQUUSCXHOUXEUUTCXIC
      UWTGUXFKXJXKUWTAGXAWKUWTUUABVSTYQUWTUUNUUBYQUURUWTUUNRUVCUUAFUUQUWTLCUWTU
      UQUVBUXFXLXPTXMYQDXHOZUXBUORZDXIUXGUWTDXNQZOUXHBCDUWTUXIJUXFUXISHXOXQTXRX
      SNUAUUAPUUFULFEUUBUOUUNUVHUUAFXTQRUVIUUAAFUUQLACUUQUVBIYAYBVNPYGVJPEXTQRY
      CPYGEVEMYDYBVNUUAYEOZUUFFYFQRAYEOUXJACXTQYEICXTYHYIAYTYEYJVNUUAUUFUUQFYEL
      CUUFUUQUVBUWHYKYLVNPYEOULEYFQRYMPULVEEYEMYNYLVNUUNSUVDUOEUNQRVFPEVEUOMYOX
      PVNYPWK $.
  $}

  ${
    $d n r $.
    $( Functionality of the cyclotomic polynomial sequence.  (Contributed by
       Stefan O'Rear, 5-Sep-2015.) $)
    cytpfn $p |- CytP Fn NN $=
      ( vn vr cn ccnfld cpl1 cfv cmgp cc cc0 csn cdif cress co cod ccnv cv cima
      cv1 cascl cgsu csg cmpt ccytp ovex df-cytp fnmpti ) ACDEFZGFZBDGFHIJKLMNF
      OAPJQDRFBPUGSFFUGUAFMUBZTMUCUHUITUDABUEUF $.
  $}

  ${
    $d n r N $.  $d n A $.  $d n .- $.  $d n O $.  $d n Q $.  $d n X $.
    cytpval.t $e |- T = ( ( mulGrp ` CCfld ) |`s ( CC \ { 0 } ) ) $.
    cytpval.o $e |- O = ( od ` T ) $.
    cytpval.p $e |- P = ( Poly1 ` CCfld ) $.
    cytpval.x $e |- X = ( var1 ` CCfld ) $.
    cytpval.q $e |- Q = ( mulGrp ` P ) $.
    cytpval.m $e |- .- = ( -g ` P ) $.
    cytpval.a $e |- A = ( algSc ` P ) $.
    $( Substitutions for the Nth cyclotomic polynomial.  (Contributed by Stefan
       O'Rear, 5-Sep-2015.) $)
    cytpval $p |- ( N e. NN -> ( CytP ` N ) =
          ( Q gsum ( r e. ( `' O " { N } ) |-> ( X .- ( A ` r ) ) ) ) ) $=
      ( cfv cmgp co cgsu vn ccnfld cpl1 cc cc0 csn cdif cress cod ccnv cima cv1
      cv cascl csg cmpt cn ccytp wceq eqcomi fveq2i eqtr4i eqtri cnveqi imaeq1i
      sneq imaeq2d syl5eqr fveq1i oveq123i mpteq12dv oveq12d df-cytp ovex fvmpt
      a1i ) UAFUBUCQZRQZIUBRQUDUEUFUGUHSZUIQZUJZUAUMZUFZUKZUBULQZIUMZVQUNQZQZVQ
      UOQZSZUPZTSCIGUJZFUFZUKZHWFAQZESZUPZTSUQURWBFUSZVRCWKWQTVRCUSWRVRBRQCVQBR
      BVQLUTVANVBVPWRIWDWJWNWPWRWDWLWCUKWNWLWAWCGVTGDUIQVTKDVSUIJVAVCVDVEWRWCWM
      WLWBFVFVGVHWJWPUSWRWPWJHWOWEWHEWIMWFAWGABUNQWGPBVQUNLVAVCVIEBUOQWIOBVQUOL
      VAVCVJUTVPVKVLUAIVMCWQTVNVO $.
  $}

$(
  @{
    @d r M @.  @d r N @.
    cytpcl.m @e |- M = ( Monic1p ` CCfld ) @.
    @( The ` N ` -th cyclotomic polynomial is a monic polynomial with complex
       coefficients.  ( Contributed by Stefan O'Rear, 12-Sep-2015.) @)
    cytpcl @p |- ( N e. NN -> ( CytP ` N ) e. M ) @=
      ( vr cn wcel cfv ccnfld cmgp cc cc0 csn cdif co eqid ax-mp a1i cn0 cndrng
      cvv ccytp cpl1 cress cod ccnv cima cv1 cv cascl csg cmpt cgsu cytpval cfn
      ccmn ccrg cncrng ply1crng crngmgp chash cphi cidom c1 cneg cdiv ccxp wceq
      c0g c2 cdomn cdr drngdomn isidom mpbir2an id proot1ex cui cnfldbas cnfld0
      drngui oveq2i proot1hash syl3anc phicl nnnn0 syl eqeltrd wb cnvexg imaexg
      fvex mp2b hashclb sylibr csubmnd cnzr drngnzr mon1psubm cdg1 cdm cnvimass
      wa unitgrpbas odf fdmi sseqtri difss sstri adantl mon1plin sylancr simpld
      sseli fmptd fisuppfi gsumsubmcl ) BEFZBUAGHUBGZIGZDHIGZJKLZMZUCNZUDGZUEZB
      LZUFZHUGGZDUHZXRUIGZGXRUJGZNZUKZULNAYJXRXSYCYKBYDYHDYCOZYDOZXROZYHOZXSOZY
      KOZYJOZUMXQYGAYMXSUNXSVHGZUUAOXSUOFZXQXRUPFZUUBHUPFZUUCUQXRHYPURPXRXSYRUS
      PQXQYGUTGZRFZYGUNFZXQUUEBVAGZRXQHVBFZXQVCVDVIBVENVFNZYGFUUEUUHVGUUIXQUUIU
      UDHVJFZUQHVKFZUUKSHVLPHVMVNQXQVOYCBYDYNYOVPHYCBYDUUJYBHVQGXTUCJHKVRVSSVTZ
      WAYOWBWCXQUUHEFUUHRFBWDUUHWEWFWGYGTFZUUGUUFWHYDTFYETFUUNYCUDWKYDTWIYEYFTW
      JWLYGTWMPWNZAXSWOGFZXQHWPFZUUPUULUUQSHWQPZXRHXSAYPCYRWRPQXQDYGYLAYMXQYIYG
      FZXBZYLAFZYLHWSGZGVCVGZUUTUUQYIJFZUVAUVCXBUURUUSUVDXQYGJYIYGYBJYGYDWTYBYD
      YFXAYBRYDYCYDYBHYBYCUUMYNXCYOXDXEXFJYAXGXHXMXIYJUVBXRHYKJAYHYIYPYQCUVBOYS
      YTVRXJXKXLYMOXNZXQYGATUUALMYMUUOUVEXOXPWG @.
      @( [12-Sep-2015] @)
  @}

  @{
    cytpdeg.d @e |- D = ( deg1 ` CCfld ) @.
    @( The ` N ` -th cyclotomic polynomial has degree ` ( phi `` N ) ` .
       ( Contributed by Stefan O'Rear, 12-Sep-2015.) @)
    cytdeg @p |- ( N e. NN -> ( D ` ( CytP ` N ) ) = ( phi ` N ) ) @= ? @.
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Wedderburn's little theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Hybrid categories proposal
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Miscellaneous topology
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d F x a b $.  $d A x a b $.  $d B x a b $.
    $( Express a function as a subset of the cross product.  (Contributed by
       Stefan O'Rear, 25-Jan-2015.) $)
    fgraphopab $p |- ( F : A --> B -> F =
          { <. a , b >. | ( ( a e. A /\ b e. B ) /\ ( F ` a ) = b ) } ) $=
      ( wf cv cfv cmpt cxp cin wcel wa wceq copab wss fssxp df-ss sylib anbi2i
      wfn ffn dffn5 ineq1d eqtr3d df-mpt df-xp ineq12i inopab ancom anass eqcom
      anandi 3bitr2i bitr3i opabbii 3eqtri syl6eq ) ABCFZCDADGZCHZIZABJZKZUTALZ
      EGZBLZMZVAVFNZMZDEOZUSCVCKZCVDUSCVCPVLCNABCQCVCRSUSCVBVCUSCAUACVBNABCUBDA
      CUCSUDUEVDVEVFVANZMZDEOZVHDEOZKVNVHMZDEOVKVBVOVCVPDEAVAUFDEABUGUHVNVHDEUI
      VQVJDEVQVEVMVGMZMZVJVEVMVGUMVSVEVGVMMZMVHVMMVJVRVTVEVMVGUJTVEVGVMUKVMVIVH
      VFVAULTUNUOUPUQUR $.

    $( Express a function as a subset of the cross product.  (Contributed by
       Stefan O'Rear, 25-Jan-2015.) $)
    fgraphxp $p |- ( F : A --> B -> F =
          { x e. ( A X. B ) | ( F ` ( 1st ` x ) ) = ( 2nd ` x ) } ) $=
      ( va vb wf cv wcel cfv wceq copab c1st c2nd cxp crab fgraphopab w3a vex
      wa cop op1std fveq2d op2ndd eqeq12d rabxp df-3an opabbii eqtri syl6eqr )
      BCDGDEHZBIZFHZCIZTUKDJZUMKZTZEFLZAHZMJZDJZUSNJZKZABCOPZBCDEFQVDULUNUPRZEF
      LURVCUPAEFBCUSUKUMUAKZVAUOVBUMVFUTUKDUKUMUSESZFSZUBUCUKUMUSVGVHUDUEUFVEUQ
      EFULUNUPUGUHUIUJ $.
  $}

  ${
    $d J a $.  $d K a $.  $d F a $.
    $( The graph of a continuous function into a Hausdorff space is closed.
       (Contributed by Stefan O'Rear, 25-Jan-2015.) $)
    hausgraph $p |- ( ( K e. Haus /\ F e. ( J Cn K ) ) ->
        F e. ( Clsd ` ( J tX K ) ) ) $=
      ( va wcel ccn co wa c1st cuni cres c2nd cfv wceq crab wfn ffn adantl syl
      wf cha cxp ccom cin cdm ctx ccld cv f1stres ax-mp fvco2 mpan fvres fveq2d
      eqtrd eqeq12d rabbidva eqid cnf fco sylancl f2ndres fndmin fgraphxp simpl
      3eqtr4rd ctopon ctop cntop1 toptopon sylib haustop tx1cn syl2anc sylancom
      cnco tx2cn hauseqlcld eqeltrd ) CUAEZABCFGEZHZAAIBJZCJZUBZKZUCZLWEKZUDUEZ
      BCUFGZUGMWBDUHZWGMZWKWHMZNZDWEOZWKIMZAMZWKLMZNZDWEOZWIAWBWNWSDWEWBWKWEEZH
      ZWLWQWMWRXBWLWKWFMZAMZWQXAWLXDNZWBWFWEPZXAXEWEWCWFTZXFWCWDUIZWEWCWFQUJWEA
      WFWKUKULRXAXDWQNWBXAXCWPAWKWEIUMUNRUOXAWMWRNWBWKWELUMRUPUQWBWGWEPZWHWEPZW
      IWONWBWEWDWGTZXIWBWCWDATZXGXKWAXLVTABCWCWDWCURZWDURZUSRZXHWEWCWDAWFUTVAWE
      WDWGQSWEWDWHTXJWCWDVBWEWDWHQUJDWEWGWHVCVAWBXLAWTNXODWCWDAVDSVFWBWGWHWJCVT
      WAVEZVTWAWFWJBFGEZWGWJCFGZEWBBWCVGMEZCWDVGMEZXQWBBVHEZXSWAYAVTABCVIRBWCXM
      VJVKZWBCVHEZXTWBVTYCXPCVLSCWDXNVJVKZBCWCWDVMVNWFAWJBCVPVOWBXSXTWHXREYBYDB
      CWCWDVQVNVRVS $.
  $}

  $c TopSep TopLnd $.

  $( The class of separable toplogies. $)
  ctopsep $a class TopSep $.

  $( The class of Lindel&ouml;f toplogies. $)
  ctoplnd $a class TopLnd $.

  ${
    $d j x y z $.
    $( A topology is _separable_ iff it has a countable dense subset.
       (Contributed by Stefan O'Rear, 8-Jan-2015.) $)
    df-topsep $a |- TopSep = { j e. Top | E. x e. ~P U. j ( x ~<_ om /\
        ( ( cls ` j ) ` x ) = U. j ) } $.

    $( A topology is _Lindel&ouml;f_ iff every open cover has a countable
       subcover.  (Contributed by Stefan O'Rear, 8-Jan-2015.) $)
    df-toplnd $a |- TopLnd = { x e. Top | A. y e. ~P x ( U. x = U. y ->
        E. z e. ~P x ( z ~<_ om /\ U. x = U. z ) ) } $.
  $}

  $( Expand definitions $)
  $( RR is separable $)
  $( A set is dense iff it meets every open set $)
  $( A set is dense iff it meets every basis element $)
  $( Lindelof criterion for subspaces $)
  $( Lindelof for closed subspaces $)
  $( A countable union of Lindelof subspaces $)
  $( In a general space, open Lindelof <=> all families of open sets have
     countable subfamilies with the same union $)
  $( Both of the above are equivalent to hereditary Lindelof above $)
  $( Hereditary Lindelof => Lindelof $)
  $( 2nd countable => hered Lindelof; RR is h Lind $)
  $( 2nd countable => separable $)
  $( Expansions of first-countability $)
  $( Metric spaces are first-countable: use balls of (1/NN) or QQ+ radius $)
  $( Binary products preserve second-countability $)
  $( Binary products preserve first-countability $)

  $( The Sorgenfrey line basis is a basis $)
  $( A set is Sorgenfrey-dense iff it is RR-dense $)
  $( SorgenfreyLine is separable $)
  $( The Sorgenfrey line is a topology on RR $)
  $( The Sorgenfrey line is finer than the usual line $)
  $( A topology finer than a Hausdorff topology is Hausdorff; Sorgenfrey line
     is Hausdorff $)
  $( Hereditary Lindelof proof: there may be a simpler one $)
    $( Basis sets are Lindelof: close/open advancing argument like icccmp $)
    $( Open intervals are countable unions of half-open $)
    $( Open intervals are Lindelof in the SL $)
    $( A Lindelof open set is equal to the union of its maximal intervals $)
    $( A union of half-open intervals sharing a point is a half-open or open
       interval $)
    $( Each maximal interval is a half-open or open interval $)
    $( Each maximal interval is disjoint $)
    $( There are countably many disjoint intervals $)
    $( All open sets are Lindelof $)
  $( Sorgenfrey line is first-countable: [x,x+q) or [x,x+(1/n)) is a countable
     neighborhood base $)

  $( Natural open sets in the Sorgenfrey plane $)
  $( Antidiagonal is closed $)
  $( Antidiagonal is discrete $)
  $( Sorgenfrey plane is NOT Lindelof, despite h. Lindelof of the line $)
  $( This proves that the Sorgenfrey line is NOT 2c $)
    $( alternate direct proof: a point is "special" in an open set if the point
       is in the open set and the open set contains no interval around it.  The
       special points of a union is at most the special points of the elements.
       An element of the standard basis has at most one special point.  The
       special points of every open set are countable.  Given a countable
       collection of open sets, find a point which is not special for any
       element; [x,x+1) thus has a special point which is not in the union, and
       so cannot be a union of elements of the countable set. $)

  $( Define the general order topology and the lexicographic order $)
    $( does it make sense to first define poset infinity and intervals? $)
  $( Define ordinal spaces or at least their ordering $)
  $( Redefine CCfld with a topology and an order $)
  $( Define the closed long ray (CLR) $)
  $( A Lindelof subset of the CLR is not cofinal $)
  $( The CLR is not Lindelof $)
  $( A countable ordinal can be continuously order-embedded in QQ $)
    $( this is also the key step for Aronsjazn trees $)
    $( an ordinal is countable iff it can be embedded in RR $)
  $( A continuous embedding extends to a homomorphism of a long line initial
     segment which "fixes" 0 $)
  $( Initial segments of the CLR are homeomorph to [0,1) $)
  $( CLR is connected $)
  $( Intial segments of the OLR are homeomorph to (0,1), thus RR $)
  $( OLR is connected $)
  $( Every Lindelof subset of OLR is contained in a homeomorph of RR $)
  $( Define LL $)
  $( Every Lindelof subset of LL is contained in a homeomorph of RR $)
  $( LL contains CLR as a closed set and OLR as open $)
  $( LL is not Lindelof $)
  $( LL has a reversing homeomorphism $)
  $( A homeomorphism of interval-connected ordered spaces is monotone $)
  $( OLR has downward cofinal sequences but not upward cofinal $)
  $( All OLR homeomorphisms are monotone increasing $)

$( (End of Stefan O'Rear's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Steve Rodriguez
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y R $.  $d x y S $.
    $( The empty set is an ` R , S ` isomorphism from the empty set to the
       empty set.  (Contributed by Steve Rodriguez, 24-Oct-2015.) $)
    iso0 $p |- (/) Isom R , S ( (/) , (/) ) $=
      ( vx vy c0 wiso wf1o cv wbr cfv wb wral f1o0 ral0 df-isom mpbir2an ) EEAB
      EFEEEGCHZDHZAIQEJREJBIKDELZCELMSCNCDEEABEOP $.
  $}

  $( ` RR ` is a subset of both ` RR ` and ` CC ` .  (Contributed by Steve
     Rodriguez, 22-Nov-2015.) $)
  ssrecnpr $p |- ( S e. { RR , CC } -> RR C_ S ) $=
    ( cr cc cpr wcel wceq wo wss elpri eqimss2 ax-resscn sseq2 mpbiri jaoi syl
    ) ABCDEABFZACFZGBAHZABCIPRQBAJQRBCHKACBLMNO $.

  ${
    seff.s $e |- ( ph -> S e. { RR , CC } ) $.
    $( Let set ` S ` be the reals or complexes.  Then the exponential function
       restricted to ` S ` is a mapping from ` S ` to ` S ` .  (Contributed by
       Steve Rodriguez, 6-Nov-2015.) $)
    seff $p |- ( ph -> ( exp |` S ) : S --> S ) $=
      ( cr cc cpr wceq ce cres wf crp mp2b wb feq23 anidms mpbiri reseq2 mpbird
      feq1d eff wcel wo elpri wf1 reeff1 f1f wss rpssre fss mpan2 cdm wrel frel
      resdm fdmi reseq2i eqtr3i feq1i mpbi jaoi 3syl ) ABDEFUABDGZBEGZUBBBHBIZJ
      ZCBDEUCVBVEVCVBVEBBHDIZJZVBVGDDVFJZDKVFUDDKVFJZVHUEDKVFUFVIKDUGVHUHDKDVFU
      IUJLVBVGVHMBBDDVFNOPVBBBVDVFBDHQSRVCVEBBHEIZJZVCVKEEVJJZEEHJZVLTEEHVJHHUK
      ZIZHVJVMHULVOHGTEEHUMHUNLVNEHEEHTUOUPUQURUSVCVKVLMBBEEVJNOPVCBBVDVJBEHQSR
      UTVA $.
  $}

  ${
    sblpnf.s $e |- ( ph -> S e. { RR , CC } ) $.
    sblpnf.d $e |- D = ( ( abs o. - ) |` ( S X. S ) ) $.
    $( The infinity ball in the absolute value metric is just the whole space.
       ` S ` analog of ~ blpnf .  (Contributed by Steve Rodriguez,
       8-Nov-2015.) $)
    sblpnf $p |- ( ( ph /\ P e. S ) -> ( P ( ball ` D ) +oo ) = S ) $=
      ( cme cfv wcel wceq cr cc cabs cmin cxp cres xpeq12 anidms reseq2d wf cbl
      cpnf co cpr elpri ccom eqid remet fveq2 eleq12d mpbiri syl5eqel cdm relco
      wo wrel resdm ax-mp wss absf ax-resscn fss mp2an subf fdmi reseq2i eqtr3i
      fco cnmet eqeltrri jaoi 3syl blpnf sylan ) ABDGHZIZCDICUBBUAHUCDJADKLUDID
      KJZDLJZUOVPEDKLUEVQVPVRVQBMNUFZDDOZPZVOFVQWAVOIZVSKKOZPZKGHZIWDWDUGUHVQWA
      WDVOWEVQVTWCVSVQVTWCJDKDKQRSDKGUIUJUKULVRBWAVOFVRWBVSLLOZPZLGHZIVSWGWHVSV
      SUMZPZVSWGVSUPWJVSJMNUNVSUQURWIWFVSWFLVSLLMTZWFLNTWFLVSTLKMTKLUSWKUTVALKL
      MVBVCVDWFLLMNVHVCVEVFVGVIVJVRWAWGVOWHVRVTWFVSVRVTWFJDLDLQRSDLGUIUJUKULVKV
      LBCDVMVN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Function operations
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d w x y z F $.  $d w A $.  $d w x y z G $.  $d w x y z H $.
    $d w x y z R $.  $d w x y z ph $.  $d x y z S $.  $d x y z T $.
    caofcan.1 $e |- ( ph -> A e. V ) $.
    caofcan.2 $e |- ( ph -> F : A --> T ) $.
    caofcan.3 $e |- ( ph -> G : A --> S ) $.
    caofcan.4 $e |- ( ph -> H : A --> S ) $.
    caofcan.5 $e |- ( ( ph /\ ( x e. T /\ y e. S /\ z e. S ) ) -> ( ( x R y ) =
        ( x R z ) <-> y = z ) ) $.
    $( Transfer a cancellation law like ~ mulcan to the function operation.
       (Contributed by Steve Rodriguez, 16-Nov-2015.) $)
    caofcan $p |- ( ph -> ( ( F oF R G ) = ( F oF R H ) <-> G = H ) ) $=
      ( vw cfv wceq cv cof co wral wcel wa wf wfn ffn inidm eqidd ofval eqeq12d
      syl simpl ffvelrnda caovcang syl13anc bitrd ralbidva offn syl2anc 3bitr4d
      wb eqfnfv ) ARUAZIJFUBZUCZSZVFIKVGUCZSZTZREUDZVFJSZVFKSZTZREUDZVHVJTZJKTZ
      AVLVPREAVFEUEZUFZVLVFISZVNFUCZWBVOFUCZTZVPWAVIWCVKWDAEEWBVNFEIJLLVFAEHIUG
      IEUHNEHIUIUNZAEGJUGJEUHZOEGJUIUNZMMEUJZWAWBUKZWAVNUKULAEEWBVOFEIKLLVFWFAE
      GKUGKEUHZPEGKUIUNZMMWIWJWAVOUKULUMWAAWBHUEVNGUEVOGUEWEVPVDAVTUOAEHVFINUPA
      EGVFJOUPAEGVFKPUPABCDWBVNVOGHFQUQURUSUTAVHEUHVJEUHVRVMVDAEEFEIJLLWFWHMMWI
      VAAEEFEIKLLWFWLMMWIVAREVHVJVEVBAWGWKVSVQVDWHWLREJKVEVBVC $.
  $}

  ${
    $d x A $.  $d x F $.  $d x V $.
    $( Function analog of ~ subid .  (Contributed by Steve Rodriguez,
       5-Nov-2015.) $)
    ofsubid $p |- ( ( A e. V /\ F : A --> CC ) ->
                    ( F oF - F ) = ( A X. { 0 } ) ) $=
      ( vx wcel cc wf wa cv cfv cmin cc0 csn cxp simpl wfn ffn adantl c0ex wceq
      fconst mp1i eqidd co ffvelrn subidd adantll fvconst2 eqtr4d offveq ) ACEZ
      AFBGZHZDADIZBJZUOKBBALMZNZCUKULOULBAPUKAFBQRZURAUPUQGUQAPUMALSUAAUPUQQUBU
      MUNAEZHZUOUCZVAUTUOUOKUDZLUNUQJZULUSVBLTUKULUSHUOAFUNBUEUFUGUSVCLTUMALUNS
      UHRUIUJ $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x H $.  $d x V $.
    $( Function analog of ~ mul12 .  (Contributed by Steve Rodriguez,
       13-Nov-2015.) $)
    ofmul12 $p |- ( ( ( A e. V /\ F : A --> CC ) /\ ( G : A --> CC /\ H : A
      --> CC ) ) -> ( F oF x. ( G oF x. H ) ) = ( G oF x. ( F oF x. H ) ) ) $=
      ( vx wcel cc wf wa cfv cmul co wfn ffn syl offn eqidd ofval ffvelrnda cof
      cv simpll simplr simprl simprr inidm mul12d eqtr4d offveq ) AEGZAHBIZJZAH
      CIZAHDIZJZJZFAFUBZBKZURCKZURDKZLMZLBCDLUAZMCBDVCMZVCMZEUKULUPUCZUQULBANUK
      ULUPUDZAHBOPZUQAALACDEEUQUNCANUMUNUOUEZAHCOPZUQUODANUMUNUOUFZAHDOPZVFVFAU
      GZQUQAALACVDEEVJUQAALABDEEVHVLVFVFVMQZVFVFVMQUQURAGJZUSRZUQAAUTVALACDEEUR
      VJVLVFVFVMVOUTRZVOVARZSVOUSVBLMUTUSVALMZLMURVEKVOUSUTVAUQAHURBVGTUQAHURCV
      ITUQAHURDVKTUHUQAAUTVSLACVDEEURVJVNVFVFVMVQUQAAUSVALABDEEURVHVLVFVFVMVPVR
      SSUIUJ $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x V $.
    $( Function analog of ~ divrec , a division analog of ~ ofnegsub .
       (Contributed by Steve Rodriguez, 3-Nov-2015.) $)
    ofdivrec $p |- ( ( A e. V /\ F : A --> CC /\ G : A --> ( CC \ { 0 } ) )
      -> ( F oF x. ( ( A X. { 1 } ) oF / G ) ) = ( F oF / G ) ) $=
      ( vx wcel cc wf cc0 csn w3a cfv c1 cdiv co cmul wfn ffn syl wa cv cxp cof
      cdif simp1 simp2 ax-1cn fnconstg mp1i simp3 inidm offn eqidd a1i ofc1 wne
      wceq ffvelrn sylan eldifsn sylib divrec eqcomd 3expb syl2anc ofval eqtr4d
      offveq ) ADFZAGBHZAGIJUDZCHZKZEAEUAZBLZMVNCLZNOZPBAMJUBZCNUCZOBCVSOZDVIVJ
      VLUEZVMVJBAQVIVJVLUFZAGBRSZVMAANAVRCDDMGFZVRAQVMUGAMGUHUIVMVLCAQVIVJVLUJZ
      AVKCRSZWAWAAUKZULVMAANABCDDWCWFWAWAWGULVMVNAFZTZVOUMZVMAMVPNCDGVNWAWDVMUG
      UNWFWIVPUMZUOWIVOVQPOZVOVPNOZVNVTLWIVOGFZVPGFZVPIUPZTZWLWMUQZVMVJWHWNWBAG
      VNBURUSVMVLWHWQWEVLWHTVPVKFWQAVKVNCURVPGIUTVAUSWNWOWPWRWNWOWPKWMWLVOVPVBV
      CVDVEVMAAVOVPNABCDDVNWCWFWAWAWGWJWKVFVGVH $.

    $( Function analog of ~ divcan4 .  (Contributed by Steve Rodriguez,
       4-Nov-2015.) $)
    ofdivcan4 $p |- ( ( A e. V /\ F : A --> CC /\ G : A --> ( CC \ { 0 } ) )
      -> ( ( F oF x. G ) oF / G ) = F ) $=
      ( vx wcel cc wf cc0 cfv cmul co cdiv wfn ffn syl wa eqidd ffvelrn sylan
      csn cdif w3a cv cof simp1 simp2 simp3 inidm offn ofval wceq eldifsn sylib
      wne divcan4 3expb syl2anc offveq ) ADFZAGBHZAGIUAUBZCHZUCZEAEUDZBJZVECJZK
      LZVGMBCKUELCBDUTVAVCUFZVDAAKABCDDVDVABANUTVAVCUGZAGBOPZVDVCCANUTVAVCUHZAV
      BCOPZVIVIAUIZUJVMVKVDAAVFVGKABCDDVEVKVMVIVIVNVDVEAFZQZVFRVPVGRZUKVQVPVFGF
      ZVGGFZVGIUOZQZVHVGMLVFULZVDVAVOVRVJAGVEBSTVDVCVOWAVLVCVOQVGVBFWAAVBVECSVG
      GIUMUNTVRVSVTWBVFVGUPUQURUS $.
  $}

  ${
    $d x A $.  $d x F $.  $d x G $.  $d x H $.  $d x V $.
    $( Function analog of ~ divdiv2 .  (Contributed by Steve Rodriguez,
       23-Nov-2015.) $)
    ofdivdiv2 $p |- ( ( ( A e. V /\ F : A --> CC ) /\ ( G : A --> ( CC \ { 0 }
        ) /\ H : A --> ( CC \ { 0 } ) ) ) -> ( F oF / ( G oF / H ) ) = ( ( F oF
        x. H ) oF / G ) ) $=
      ( wcel cc wf wa cc0 cfv cdiv co cmul wfn ffn syl offn eqidd ffvelrn vx cv
      csn cdif cof simpll simplr simprl simprr inidm wceq sylan eldifsn divdiv2
      wne sylib syl3anc ofval oveq2d 3eqtr4d offveq ) AEFZAGBHZIZAGJUCUDZCHZAVE
      DHZIZIZUAAUAUBZBKZVJCDLUEZMZKZLBVMBDNUEMZCVLMZEVBVCVHUFZVIVCBAOVBVCVHUGZA
      GBPQZVIAALACDEEVIVFCAOVDVFVGUHZAVECPQZVIVGDAOVDVFVGUIZAVEDPQZVQVQAUJZRVIA
      ALAVOCEEVIAANABDEEVSWCVQVQWDRZWAVQVQWDRVIVJAFZIZVKSZWGVNSWGVKVJCKZVJDKZLM
      ZLMZVKWJNMZWILMZVKVNLMVJVPKWGVKGFZWIGFWIJUOIZWJGFWJJUOIZWLWNUKVIVCWFWOVRA
      GVJBTULVIVFWFWPVTVFWFIWIVEFWPAVEVJCTWIGJUMUPULVIVGWFWQWBVGWFIWJVEFWQAVEVJ
      DTWJGJUMUPULVKWIWJUNUQWGVNWKVKLVIAAWIWJLACDEEVJWAWCVQVQWDWGWISZWGWJSZURUS
      VIAAWMWILAVOCEEVJWEWAVQVQWDVIAAVKWJNABDEEVJVSWCVQVQWDWHWSURWRURUTVA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( Example of the Fundamental Theorem of Calculus, part two (~ ftc2 ):
       ` S. ( 1 (,) 2 ) ( ( x ^ 2 ) - 3 ) _d x = -u ( 2 / 3 ) ` .  Section 4.4
       example 1a of [LarsonHostetlerEdwards] p. 311.  (The book teaches ~ ftc2
       as simply the "Fundamental Theorem of Calculus", then ~ ftc1 as the
       "Second Fundamental Theorem of Calculus".)  (Contributed by Steve
       Rodriguez, 28-Oct-2015.)  (Revised by Steve Rodriguez, 31-Oct-2015.) $)
    lhe4.4ex1a $p |- S. ( 1 (,) 2 ) ( ( x ^ 2 ) - 3 ) _d x = -u ( 2 / 3 ) $=
      ( vy c1 c2 co cr c3 cexp cdiv cmul cmin cmpt wceq wtru wcel a1i cc cvv c6
      3cn cioo cicc cdv cfv citg cneg 1re 2re cle wbr 1lt2 ltleii ccncf crn ctg
      cv ccnfld ctopn cpr reex prid1 recn cn0 3nn0 expcl mpan2 syl cc0 wne 3ne0
      divcl mp3an23 mulcl sylancr subcld adantl wa ovex divrec2 mpteq2ia oveq2i
      cres wf wss cdm eqid fmpti ssid ax-resscn dvexp ax-mp 3m1e2 mpteq2i eqtri
      cn 3nn dmmpti sseqtr4i dvres3 resmpt 3eqtr3i ax-1cn divcli dvmptcmul trud
      mp4an 3syl 3eqtri syl6eq dvmptsub mp2an w3a 3pm3.2i dvcn rescncf eqeltrri
      mp2 cibl mp3an oveq1 oveq1d fvmpt c4 leidi elicc2i mpbir3an oveq2 oveq12d
      c8 oveq1i 3t2e6 oveq12i caddc 2cn addcomli eqtr4i 4cn subaddrii divsubdir
      eqtr3i reseq1i divcan3 eqtr3d elexi dvmptid mulid1i iccssre tgioo2 iccntr
      sqcl cnt dvmptres2 ioossicc sstri subcl cnex prid2 2nn c0ex syl6eqel cvol
      dvmptc ioombl cniccibl iblss eqeltrd ftc2 itgeq2 mprg cu2 6nn nncni 6p2e8
      divdiri divmuli mpbir subsub3 4p2e6 cz nnzi 1exp sub4 pm3.2i 2m1e1 dividi
      3p1e4 divneg negsubdi2i negeqi ) ACDUAEZAUPZFBCDUBEZBUPZGHEZGIEZGUWMJEZKE
      ZLZUCEZUDZUEZDUWRUDZCUWRUDZKEZAUWJUWKDHEZGKEZUEZDGIEZUFZUXAUXDMNACDUWRCFO
      ZNUGPDFOZNUHPCDUIUJZNCDUGUHUKULZPNUWSBUWJUWMDHEZGKEZLZUWJQUMEZNBUWQUXOFUA
      UNUOUDZUQURUDZRFUWJUWLFFQUSZOZNFQUTVAZPZUWMFOZUWQQONUYDUWOUWPUYDUWNQOZUWO
      QOZUYDUWMQOZUYEUWMVBZUYGGVCOUYEVDUWMGVEVFZVGZUYEGQOZGVHVIZUYFTVJUWNGVKVLV
      GZUYDUYKUYGUWPQOZTUYHGUWMVMVNZVOZVPUXOROZNUYDVQZUXNGKVRZPNBUWOUXNUWPGFRRF
      UYCUYDUYFNUYMVPUXNROUYRUWMDHVRPFBFUWOLZUCEZBFUXNLZMNVUAFBFCGIEZUWNJEZLZUC
      EZBFVUCGUXNJEZJEZLZVUBUYTVUEFUCBFUWOVUDUYDUYEUWOVUDMZUYJUYEUYKUYLVUJTVJUW
      NGVSVLVGVTWAVUFVUIMNBUWNVUGVUCFRFUYCUYDUYENUYJVPVUGROUYRGUXNJVRZPFBFUWNLZ
      UCEZBFVUGLZMNFBQUWNLZFWBZUCEZQVUOUCEZFWBZVUMVUNUYAQQVUOWCQQWDZFVURWEZWDVU
      QVUSMUYBBQQUWNVUOVUOWFUYIWGQWHZFQVVAWIBQVUGVURVUKVURBQGUWMGCKEZHEZJEZLZBQ
      VUGLZGWOOVURVVFMWPBGWJWKBQVVEVUGVVDUXNGJVVCDUWMHWLWAWAWMWNZWQWRQFVUOWSXFV
      UPVULFUCFQWDZVUPVULMWIBQFUWNWTWKWAVUSVVGFWBZVUNVURVVGFVVHUUAVVIVVJVUNMWIB
      QFVUGWTWKWNXAPVUCQOZNCGXBTVJXCZPXDXEBFVUHUXNUYDVUGGIEZVUHUXNUYDUYGVUGQOZV
      VMVUHMZUYHUYGUYKUXNQOZVVNTUWMUUJZGUXNVMVNVVNUYKUYLVVOTVJVUGGVSVLXGUYDUYGV
      VPVVMUXNMZUYHVVQVVPUYKUYLVVRTVJUXNGUUBVLXGUUCVTXHPUYDUYNNUYOVPGROUYRGQTUU
      DPNFBFUWPLUCEBFGCJEZLBFGLNBUWMCGFFFUYCUYDUYGNUYHVPUXJUYRUGPNBFUYCUUEUYKNT
      PZXDBFVVSGGTUUFZWMXIXJZUWLFWDZNUXJUXKVWCUGUHCDUUGXKZPUXSUXSWFZUUHVWEUWLUX
      RUUKUDUDUWJMZNUXJUXKVWFUGUHCDUUIXKPUULZBUWLUXOLZUWJWBZUXPUXQUWJUWLWDZVWIU
      XPMCDUUMZBUWLUWJUXOWTWKVWJVWHUWLQUMEZOZVWIUXQOVWKBQUXOLZUWLWBZVWHVWLUWLQW
      DZVWOVWHMUWLFQVWDWIUUNZBQUWLUXOWTWKVWPVWNQQUMEOZVWOVWLOVWQVUTQQVWNWCZVUTX
      LQVWNUCEZWEQMVWRVUTVWSVUTVVBBQQUXOVWNVWNWFUYGVVPUXOQOZVVQVVPUYKVXATUXNGUU
      OVFVGWGVVBXMBQDUWMDCKEZHEZJEZVHKEZVWTVXDVHKVRVWTBQVXELMNBUXNVXDGVHQRRQQUX
      TONFQUUPUUQPZUYGVVPNVVQVPVXDRONUYGVQZDVXCJVRPQBQUXNLUCEBQVXDLMZNDWOOVXHUU
      RBDWJWKPUYKVXGTPVHROVXGUUSPNBGQVXFVVTUVBXJXEWQQQVWNXNXKQQUWLVWNXOXQXPZUWL
      QUWJVWHXOXQXPUUTNUWSUXPXRVWGNBUWJUWLUXORVWJNVWKPUWJUVAWEONCDUVCPUYQNUWMUW
      LOVQUYSPVWHXROZNUXJUXKVWMVXJUGUHVXICDVWHUVDXSPUVEUVFUWRVWLONBFUWQLZUWLWBZ
      UWRVWLVWCVXLUWRMVWDBFUWLUWQWTWKVWCVXKFQUMEOZVXLVWLOVWDVVIFQVXKWCZFFWDZXLF
      VXKUCEZWEFMVXMVVIVXNVXOWIBFQUWQVXKVXKWFUYPWGFWHXMBFUXOVXPUYSVXPBFUXOLMVWB
      XEWQFFVXKXNXKFQUWLVXKXOXQXPPUVGXEUWTUXFMUXAUXGMAUWJAUWJUWTUXFUVHBUWKUXOUX
      FUWJUWSUWMUWKMUXNUXEGKUWMUWKDHXTYAUWSUXPMVWGXEUXEGKVRYBUVIUXDCGKEZGIEZUXI
      UXDVUCGGIEZKEZVXRUXDVUCCKEZVXTUXDUXHYCKEZVUCGKEZKEZUXHVUCKEZYCGKEZKEZVYAU
      XBVYBUXCVYCKDUWLOZUXBVYBMVYHUXKUXLDDUIUJUHUXMDUHYDCDDUGUHYEYFBDUWQVYBUWLU
      WRUWMDMZUWQDGHEZGIEZGDJEZKEZVYBVYIUWOVYKUWPVYLKVYIUWNVYJGIUWMDGHXTYAUWMDG
      JYGYHVYMYIGIEZSKEZUXHSDKEZKEZVYBVYKVYNVYLSKVYJYIGIUVJYJYKYLVYOUXHDYMEZSKE
      ZVYQVYNVYRSKDSYMEZGIEUXHSGIEZYMEVYNVYRDSGYNSUVKUVLZTVJUVNVYTYIGISDYIWUBYN
      UVMYOYJWUADUXHYMWUADMVYLSMYKSGDWUBTYNVJUVOUVPWAXAYJUXHQOZSQODQOZVYQVYSMDG
      YNTVJXCZWUBYNUXHSDUVQXSYPVYPYCUXHKSDYCWUBYNYQYCDSYQYNUVRYOYRWAXHXIUWRWFZU
      XHYCKVRYBWKCUWLOZUXCVYCMWUGUXJCCUIUJUXLUGCUGYDUXMCDCUGUHYEYFBCUWQVYCUWLUW
      RUWMCMZUWQCGHEZGIEZVVSKEVYCWUHUWOWUJUWPVVSKWUHUWNWUIGIUWMCGHXTYAUWMCGJYGY
      HWUJVUCVVSGKWUICGIGUVSOWUICMGWPUVTGUWAWKYJVWAYLXIWUFVUCGKVRYBWKYLWUCYCQOV
      VKUYKVYDVYGMWUEYQVVLTUXHYCVUCGUWBXFVYEVUCVYFCKVXBGIEZVYEVUCWUDCQOZUYKUYLV
      QZWUKVYEMYNXBUYKUYLTVJUWCZDCGYSXSVXBCGIUWDYJYTYCGCYQTXBUWFYRYLXHVXSCVUCKG
      TVJUWEWAYPWULUYKWUMVXRVXTMXBTWUNCGGYSXSYPUXIDUFZGIEZVXRWUDUYKUYLUXIWUPMYN
      TVJDGUWGXSVXQWUOGIVVCUFVXQWUOGCTXBUWHVVCDWLUWIYTYJYPYPXA $.
  $}

  $( Derivative of a constant function on the reals or complexes.  The function
     may return a complex ` A ` even if ` S ` is ` RR ` .  (Contributed by
     Steve Rodriguez, 11-Nov-2015.) $)
  dvsconst $p |- ( ( S e. { RR , CC } /\ A e. CC ) -> ( S _D ( S X. { A } ) )
    = ( S X. { 0 } ) ) $=
    ( cr cc cpr wcel wa csn cxp cres cdv co cc0 wss cdm wceq adantr xpssres syl
    wf fconst6g anim2i recnprss c0ex fconst fdmi syl6sseqr dvconst adantl dmeqd
    sseqtr4d ssid jctil dvres3 syl2anc oveq2d reseq1d eqtrd 3eqtr3d ) BCDEFZADF
    ZGZBDAHZIZBJZKLZDVDKLZBJZBBVCIZKLZBMHZIZVBUTDDVDTZGDDNZBVGOZNZGVFVHPVAVMUTD
    ADUAUBVBVPVNVBBDVKIZOZVOUTBVRNVAUTBDVRBUCZDVKVQDMUDUEUFUGQVBVGVQVAVGVQPUTAU
    HUIZUJUKDULUMDBVDUNUOUTVFVJPVAUTVEVIBKUTBDNZVEVIPVSDVCBRSUPQVBVHVQBJZVLVBVG
    VQBVTUQUTWBVLPZVAUTWAWCVSDVKBRSQURUS $.

  $( Derivative of the identity function on the reals or complexes.
     (Contributed by Steve Rodriguez, 11-Nov-2015.) $)
  dvsid $p |- ( S e. { RR , CC } -> ( S _D ( _I |` S ) ) = ( S X. { 1 } ) ) $=
    ( cr cc cpr wcel cid cres cdv co c1 csn cxp wf wa wss cdm wceq wfn dvid syl
    crn fnresi rnresi eqimssi df-f mpbir2an jctr recnprss dmeqi 1ex fconst fdmi
    eqtri syl6sseqr jctil dvres3 syl2anc resabs1 oveq2d reseq1i xpssres 3eqtr3d
    ssid syl5eq ) ABCDEZAFCGZAGZHIZCVFHIZAGZAFAGZHIAJKZLZVEVECCVFMZNCCOZAVIPZOZ
    NVHVJQVEVNVNVFCRVFUAZCOCUBVRCCUCUDCCVFUEUFUGVEVQVOVEACVPAUHZVPCVLLZPCVIVTSU
    ICVLVTCJUJUKULUMUNCVCUOCAVFUPUQVEVGVKAHVEACOZVGVKQVSFACURTUSVEWAVJVMQVSWAVJ
    VTAGVMVIVTASUTCVLAVAVDTVB $.

  $( Derivative of the exponential function on the reals or complexes.
     (Contributed by Steve Rodriguez, 12-Nov-2015.) $)
  dvsef $p |- ( S e. { RR , CC } -> ( S _D ( exp |` S ) ) = ( exp |` S ) ) $=
    ( cr cc cpr wcel ce cres cdv co wf wa wss cdm wceq jctr recnprss dvef dmeqi
    eff fdmi eqtri syl6sseqr ssid jctil dvres3 syl2anc reseq1i syl6eq ) ABCDEZA
    FAGZHIZCFHIZAGZUJUIUICCFJZKCCLZAULMZLZKUKUMNUIUNSOUIUQUOUIACUPAPUPFMCULFQRC
    CFSTUAUBCUCUDCAFUEUFULFAQUGUH $.

  ${
    $d t y z C $.  $d t y z K $.  $d t y z S $.  $d x y K $.  $d x y ph $.
    expgrowthi.s $e |- ( ph -> S e. { RR , CC } ) $.
    expgrowthi.k $e |- ( ph -> K e. CC ) $.
    expgrowthi.y0 $e |- ( ph -> C e. CC ) $.
    expgrowthi.yt $e |- Y = ( t e. S |-> ( C x. ( exp ` ( K x. t ) ) ) ) $.
    $( Exponential growth and decay model.  See ~ expgrowth for more
       information.  (Contributed by Steve Rodriguez, 4-Nov-2015.) $)
    expgrowthi $p |- ( ph -> ( S _D Y ) = ( ( S X. { K } ) oF x. Y ) ) $=
      ( vy cdv co cmul ce cmpt wceq wcel cc a1i vx cfv csn cxp cof oveq2 fveq2d
      cv oveq2d cbvmptv eqtri oveq2i cvv cr cpr wo wi elpri eleq2 syl6bi biimpd
      recn jaoi 3syl imp wa mulcl sylan efcl syl syldan ovex cnex adantr adantl
      prid2 c1 ax-1cn dvmptid dvmptcmul mulid1d mpteq2dv eqtrd dvef wfn eff ffn
      wf ax-mp dffn5 3eqtr3i fveq2 dvmptco mulcom syl2anr anabss5 mpteq2dva w3a
      mpbi 3anim123i 3anidm12 mul12 syl5eq fconstmpt offval2 eqtr4d ) ADFLMZKDE
      CEKUHZNMZOUBZNMZNMZPZDEUCUDZFNUEMAXGDKDXKPZLMZXMFXODLFBDCEBUHZNMZOUBZNMZP
      XOJBKDXTXKXQXHQZXSXJCNYAXRXIOXQXHENUFUGUIUJUKZULAXPKDCEXJNMZNMZPXMAKXJYCC
      DUMDGAXHDRZXHSRZXJSRZAYEYFADUNSUOZRDUNQZDSQZUPYEYFUQZGDUNSURYIYKYJYIYEXHU
      NRYFDUNXHUSXHVBUTYJYEYFDSXHUSVAVCVDVEZAYFVFXISRZYGAESRZYFYMHEXHVGVHZXIVIV
      JVKZYCUMRAYEVFZEXJNVLTADKDXJPLMKDXJENMZPKDYCPAKUAXIEUAUHZOUBZYTDSXJXJSSDS
      GSYHRAUNSVMVPTAYEYFYMYLYOVKAYNYEHVNZYSSRYTSRAYSVIVOZUUBADKDXIPLMKDEVQNMZP
      KDEPZAKXHVQEDSDGYLVQSRYQVRTAKDGVSHVTAKDUUCEAEHWAWBWCSUASYTPZLMZUUEQASOLMO
      UUFUUEWDOUUESLOSWEZOUUEQSSOWHUUGWFSSOWGWIUASOWJWSZULUUHWKTYSXIOWLZUUIWMAK
      DYRYCAYEYRYCQZYQYGYNUUJAYPHXJEWNWOWPWQWCIVTAKDYDXLYQCSRZYNYGWRZYDXLQAYEUU
      LAYQUULAUUKAYNYQYGIHYPWTXAWPCEXJXBVJWQWCXCAKDEXKNXNFYHSUMGUUAXKUMRYQCXJNV
      LTXNUUDQAKDEXDTFXOQAYBTXEXF $.
  $}

  ${
    $d c x S $.  $d c x Y $.  $d x y S $.  $d x y ph $.  $d y Y $.
    dvconstbi.s $e |- ( ph -> S e. { RR , CC } ) $.
    dvconstbi.y $e |- ( ph -> Y : S --> CC ) $.
    dvconstbi.dy $e |- ( ph -> dom ( S _D Y ) = S ) $.
    $( The derivative of a function on ` S ` is zero iff it is a constant
       function.  Roughly a biconditional ` S ` analog of ~ dvconst and
       ~ dveq0 .  Corresponds to integration formula " ` S. 0 _d x = C ` " in
       section 4.1 of [LarsonHostetlerEdwards] p. 278.  (Contributed by Steve
       Rodriguez, 11-Nov-2015.) $)
    dvconstbi $p |- ( ph -> ( ( S _D Y ) = ( S X. { 0 } ) <-> E. c e. CC Y =
      ( S X. { c } ) ) ) $=
      ( vx co cc0 cxp wceq cc wa cfv wcel cr syl adantr 3adant2 vy cdv csn wrex
      cv wf wo cpr elpri 0re eleq2 mpbiri 0cn jaoi ffvelrn syl2anc wfn ffn fvex
      cvv fnconstg mp1i fvconst2 w3a cmin cabs cle wbr cmul cpnf ccom cres eqid
      adantl cbl sblpnf mpdan eleq2d biimpar eleqtrrd wss ssid a1i pnfxr eqtr4d
      cxr cdm eqimss biimpa fveq1 c0ex sylan9eq syl6eqel abscld abs00bd 3adant1
      eqle syld3an3 3expa dvlip2 sylanr1 syl3an3 recnprss sseld subcl mpan syl6
      3impdi imp recnd mul02d breqtrd anim12dan sylan 3impb syl3an2 3anidm12 wb
      absge0d letri3 sylancl mpbir2and abs00ad mpbid subeq0 eqtr2d eqfnfvd sneq
      xpeq2d eqeq2d rspcev ex oveq2 3ad2ant3 dvsconst 3adant3 rexlimdv3a impbid
      eqtrd cbvrexv syl6bbr ) ABCUBIZBJUCKZLZCBHUEZUCZKZLZHMUDZCBDUEZUCZKZLZDMU
      DAUUDUUIAUUDUUIAUUDNZJCOZMPZCBUUOUCZKZLZUUIAUUPUUDABMCUFZJBPZUUPFABQLZBML
      ZUGZUVAABQMUHPZUVDEBQMUIRUVBUVAUVCUVBUVAJQPZUJBQJUKULUVCUVAJMPZUMBMJUKULU
      NRZBMJCUOZUPSUUNUABCUURACBUQZUUDAUUTUVJFBMCURRSUUOUTPUURBUQUUNJCUSZBUUOUT
      VAVBUUNUAUEZBPZNUVLUUROZUUOUVLCOZUVMUVNUUOLUUNBUUOUVLUVKVCVNAUUDUVMUUOUVO
      LZAUUDUVMVDZUUOUVOVEIZJLZUVPUVQUVRVFOZJLZUVSUVQUWAUVTJVGVHZJUVTVGVHZUVQUV
      TJJUVLVEIZVFOZVIIZJVGAUUDUVMUVTUWFVGVHZAUUDAUVMNZUWGUWHAUUDUVLJVJVFVEVKBB
      KVLZVOOIZPZUWGAUWKUVMAUWJBUVLAUVAUWJBLZUVHAUWIJBEUWIVMZVPVQZVRVSAUUDUWKUW
      GAUUNJUWJPUWKUWGAJBUWJUVHUWNVTUUNHJUWJVJBCUWIJBJUVLAUVEUUDESUWMBBWAUUNBWB
      WCAUUTUUDFSAUVAUUDUVHSVJWFPUUNWDWCUWJVMUUNUWJUUBWGZLUWJUWOWAUUNUWJBUWOAUW
      LUUDUWNSAUWOBLUUDGSWEUWJUWOWHRUVFUUNUJWCAUUDUUEUWJPZUUEUUBOZVFOZJVGVHZAUU
      DUWPUUEBPZUWSAUWPUWTUUDAUWPUWTAUWJBUUEUWNVRWITUUDUWTUWSAUUDUWTNZUWRQPUWRJ
      LUWSUXAUWQUXAUWQJMUUDUWTUWQUUEUUCOJUUEUUBUUCWJBJUUEWKVCWLZUMWMWNUXAUWQUXB
      WOUWRJWQUPWPWRWSWTXAXHXBWSXHAUVMUWFJLUUDUWHUWEUWHUWEAUVMUWEQPZAUVMUVLMPZU
      XCABMUVLAUVEBMWAEBXCRXDUVGUXDUXCUMUVGUXDNUWDJUVLXEWNXFXGXIXJXKTXLAUVMUWCU
      UDUWHUVRUWHUUPUVOMPZNZUVRMPAUVMUXFAAUVAUVMUXFUVHAUVAUVMUXFAUUTUVAUVMNUXFF
      UUTUVAUUPUVMUXEUVIBMUVLCUOXMXNXOXPXQZUUOUVOXERZXSTAUVMUWAUWBUWCNXRZUUDUWH
      UVTQPUVFUXIUWHUVRUXHWNUJUVTJXTYATYBAUVMUWAUVSXRUUDUWHUVRUXHYCTYDAUVMUVSUV
      PXRZUUDUWHUXFUXJUXGUUOUVOYERTYDWSYFYGUUHUUSHUUOMUUEUUOLZUUGUURCUXKUUFUUQB
      UUEUUOYHYIYJYKUPYLAUUHUUDHMAUUEMPZUUHVDUUBBUUGUBIZUUCUUHAUUBUXMLUXLCUUGBU
      BYMYNAUXLUXMUUCLZUUHAUVEUXLUXNEUUEBYOXNYPYSYQYRUUMUUHDHMUUJUUELZUULUUGCUX
      OUUKUUFBUUJUUEYHYIYJYTUUA $.
  $}

  ${
    $d c t u x K $.  $d c t u x S $.  $d c x Y $.  $d u x y z K $.
    $d u x y z ph $.  $d y z S $.  $d y z Y $.
    expgrowth.s $e |- ( ph -> S e. { RR , CC } ) $.
    expgrowth.k $e |- ( ph -> K e. CC ) $.
    expgrowth.y $e |- ( ph -> Y : S --> CC ) $.
    expgrowth.dy $e |- ( ph -> dom ( S _D Y ) = S ) $.
    $( Exponential growth and decay model.  The derivative of a function _y_ of
       variable _t_ equals a constant _k_ times _y_ itself, iff _y_ equals some
       constant _C_ times the exponential of _kt_.  This theorem and
       ~ expgrowthi illustrate one of the simplest and most crucial classes of
       _differential equations_, equations that relate functions to their
       derivatives.

       Section 6.3 of [Strang] p. 242 calls _y_' = _ky_ "the most important
       differential equation in applied mathematics".  In the field of
       population ecology it is known as the _Malthusian growth model_ or
       _exponential law_, and _C_, _k_, and _t_ correspond to initial
       population size, growth rate, and time respectively
       ( ~ https://en.wikipedia.org/wiki/Malthusian_growth_model ); and in
       finance, the model appears in a similar role in _continuous compounding_
       with _C_ as the initial amount of money.  In _exponential decay_ models,
       _k_ is often expressed as the negative of a positive constant &lambda;.

       Here _y_' is given as ` ( S _D Y ) ` , _C_ as ` c ` , and _ky_ as
       ` ( ( S X. { K } ) oF x. Y ) ` . ` ( S X. { K } ) ` is the constant
       function that maps any real or complex input to _k_ and ` oF x. ` is
       multiplication as a function operation.

       The leftward direction of the biconditional is as given in
       ~ http://www.saylor.org/site/wp-content/uploads/2011/06/MA221-2.1.1.pdf
       pp. 1-2, which also notes the reverse direction ("While we will not
       prove this here, it turns out that these are the only functions that
       satisfy this equation.").  The rightward direction is Theorem 5.1 of
       [LarsonHostetlerEdwards] p. 375 (which notes " _C_ is the _initial
       value_ of _y_, and _k_ is the _proportionality constant_. _Exponential
       growth_ occurs when _k_ > 0, and _exponential decay_ occurs when _k_ <
       0."); its proof here closely follows the proof of _y_' = _y_ in
       ~ https://proofwiki.org/wiki/Exponential_Growth_Equation/Special_Case .

       Statements for this and ~ expgrowthi formulated by Mario Carneiro.
       (Contributed by Steve Rodriguez, 24-Nov-2015.) $)
    expgrowth $p |- ( ph -> ( ( S _D Y ) = ( ( S X. { K } ) oF x. Y ) <-> E. c
        e. CC Y = ( t e. S |-> ( c x. ( exp ` ( K x. t ) ) ) ) ) ) $=
      ( vu vx vy co cmul wceq ce cc wcel adantr vz cdv csn cxp cof cv cmpt wrex
      cfv wa cneg cc0 caddc cr cpr cnex prid2 a1i wss recnprss syl sseld ee12an
      mulcl imp negcld efcl adantl c1 ax-1cn dvmptid dvmptcmul mulid1d mpteq2dv
      eqtrd dvmptneg dvef wfn wf eff ffn ax-mp dffn5 mpbi 3eqtr3i fveq2 dvmptco
      oveq2i oveq2d mulcld eqid fmptd feq1d mpbird mulcom eqtr3d fconst6g eqidd
      caofcom fconstmpt offval2 cdm fdm dvmulf 3eqtr4rd ofmul12 syl22anc oveq1d
      dmeqd oveq1 sylan9eq wb w3a mulass caofass eqeq2d off adddir caofdir cmin
      inidm ofnegsub syl3anc neg1cn fconst6 ofc12 mulm1d sneqd xpeq2d mpbid 0cn
      wi cdiv wne efne0 cvv mpteq2dva sylan2 oveq2 weq ofsubid syl6eq dvconstbi
      syl2anc 3eqtr3d mul02 caofid2 fdmi cdif eldifsn sylanbrc ofdivcan4 eqeq1d
      syl5ib vex ovex efneg jca ax-1ne0 pm3.2i mp3an2 div1d ancoms an32s sylibd
      divdiv2 reximdva mpd ex simprl expgrowthi 3impb eqeq12d rexlimdv3a impbid
      3ad2ant3 fveq2d cbvmptv syl5eq cbvrexv syl6bb ) ACEUBNZCDUCUDZEOUEZNZPZEK
      CLUFZDKUFZONZQUIZONZUGZPZLRUHZEBCFUFZDBUFZONZQUIZONZUGZPZFRUHAUWFUWNAUWFU
      WNAUWFUJZEKCUWIUKZQUIZUGZUWDNZCUWGUCUDZPZLRUHZUWNUXBCUXFUBNZCULUCZUDZPUXI
      UXBUXJUXLUXEUWDNZUXLUXBUXJUWECDUKZUCZUDZEUWDNZUMUEZNZUXEUWDNZPZUXJUXMPZUX
      BUYAUXJUWEUXEUWDNZUXQUXEUWDNZUXRNZPZUXBUYFUXJUYCUXPUXFUWDNZUXRNZPZAUWFUXJ
      UWBUXEUWDNZUYGUXRNZUYHAUXJUYJEUXPUXEUWDNZUWDNZUXRNZUYKAUYJEKCUXDUXNONZUGZ
      UWDNZUXRNUYJCUXEUBNZEUWDNZUXRNUYNUXJAUYQUYSUYJUXRAEUYRUWDNUYQUYSAUYRUYPEU
      WDAKMUXCUXNMUFZQUIZVUACRUXDUXDRRCRGRUNRUOZSAUNRUPUQURAUWHCSZUJZUWIAVUCUWI
      RSZADRSZVUCUWHRSZVUEHACRUWHACVUBSZCRUSGCUTVAVBZDUWHVDVCVEZVFZAUXNRSZVUCAD
      HVFZTZUYTRSZVUARSAUYTVGVHZVUPAKUWIDCRCGVUJAVUFVUCHTACKCUWIUGUBNKCDVIONZUG
      KCDUGAKUWHVIDCRCGAVUCVUGVUIVEVIRSZVUDVJURAKCGVKHVLAKCVUQDADHVMVNVOVPRMRVU
      AUGZUBNZVUSPARQUBNQVUTVUSVQQVUSRUBQRVRZQVUSPRRQVSVVAVTRRQWAWBMRQWCWDZWHVV
      BWEURUYTUXCQWFZVVCWGZWIALMCOREUYRVUBGIACRUYRVSCRUYPVSZAKCUYORUYPVUDUXDUXN
      VUDUXCRSZUXDRSZVUKUXCVGZVAZVUNWJUYPWKWLZACRUYRUYPVVDWMWNUWGRSZVUOUJZUWGUY
      TONZUYTUWGONPAUWGUYTWOVHZWSWPWIAUYMUYQUYJUXRAUYLUYPEUWDAUYLUXEUXPUWDNUYPA
      LMCORUXPUXEVUBGAVULCRUXPVSZVUMCUXNRWQVAZAKCUXDRUXEVVIUXEWKZWLZVVNWSAKCUXD
      UXNOUXEUXPVUBRRGVVIVUNAUXEWRUXPKCUXNUGPAKCUXNWTURXAVOWIWIACEUXECGIVVRJAUY
      RXBUYPXBZCAUYRUYPVVDXIAVVEVVSCPVVJCRUYPXCVAVOXDXEAUYMUYGUYJUXRAVUHCREVSZV
      VOCRUXEVSUYMUYGPGIVVPVVRCEUXPUXEVUBXFXGWIVOUWFUYJUYCUYGUXRUWBUWEUXEUWDXJX
      HXKAUYFUYIXLUWFAUYEUYHUXJAUYDUYGUYCUXRALMUACOOROUXPEUXEOVUBGVVPIVVRVVKVUO
      UAUFZRSXMZVVMVWAONUWGUYTVWAONZONPAUWGUYTVWAXNVHZXOWIXPTWNAUYAUYFXLUWFAUXT
      UYEUXJALMUACUMROUXEUWEUXQRUMVUBGVVRALMCCCORRRUWCEVUBVUBVVLVVMRSAUWGUYTVDV
      HZAVUFCRUWCVSHCDRWQVAZIGGCYAZXQZALMCCCORRRUXPEVUBVUBVWEVVPIGGVWGXQVWBUWGU
      YTUMNVWAONUWGVWAONVWCUMNPAUWGUYTVWAXRVHXSXPTWNAUYAUYBXLUWFAUXTUXMUXJAUXSU
      XLUXEUWDAUWECVIUKZUCUDZUWEUWDNZUXRNZUWEUWEXTUENZUXSUXLAVUHCRUWEVSZVWNVWLV
      WMPGVWHVWHCUWEUWEVUBYBYCAVWKUXQUWEUXRAVWJUWCUWDNZEUWDNVWKUXQALMUACOOROVWJ
      UWCEOVUBGCRVWJVSACVWIRYDYEURVWFIVWDXOAVWOUXPEUWDAVWOCVWIDONZUCZUDUXPACVWI
      DOVUBRRGVWIRSAYDURHYFAVWQUXOCAVWPUXNADHYGYHYIVOXHWPWIAVUHVWNVWMUXLPGVWHCU
      WEVUBUUAUUDUUEXHXPTYJAUXMUXLPUWFALCULULORUXEVUBRRGVVRULRSAYKURZVWRVVKULUW
      GONULPAUWGUUFVHUUGTVOZUXBCUXFLAVUHUWFGTACRUXFVSUWFALMCCCORRREUXEVUBVUBVWE
      IVVRGGVWGXQTUXBUXJXBUXLXBCUXBUXJUXLVWSXICRUXLCULRYKYEUUHUUBUUCYJAUXIUWNYL
      UWFAUXHUWMLRAVVKUJZUXHEUXGUXEYMUEZNZPZUWMAUXHVXCYLVVKUXHUXFUXEVXANZVXBPAV
      XCUXFUXGUXEVXAXJAVXDEVXBAVUHVVTCRUXKUUIZUXEVSVXDEPGIAKCUXDVXEUXEVUDVVFUXD
      VXESZVUKVVFVVGUXDULYNVXFVVHUXCYOUXDRULUUJUUKVAVVQWLCEUXEVUBUULYCUUMUUNTVW
      TVXBUWLEVWTVXBKCUWGVIUWJYMNZYMNZUGZUWLAVXBVXIPVVKAKCUWGVXGYMUXGUXEVUBYPYP
      GUWGYPSVUDLUUOURVXGYPSVUDVIUWJYMUUPURUXGKCUWGUGPAKCUWGWTURAKCUXDVXGVUDVUE
      UXDVXGPVUJUWIUUQVAYQXATVWTKCVXHUWKAVUCVVKVXHUWKPZVVKVUDVXJVVKVUDUJZVXHUWK
      VIYMNZUWKVUDVVKUWJRSZUWJULYNZUJZVXHVXLPZVUDVUEVXOVUJVUEVXMVXNUWIVGZUWIYOU
      URVAVVKVURVIULYNZUJVXOVXPVURVXRVJUUSUUTUWGVIUWJUVFUVAYRVXKUWKVUDVVKVXMUWK
      RSVUDVUEVXMVUJVXQVAUWGUWJVDYRUVBVOUVCUVDYQVOXPUVEUVGTUVHUVIAUWMUWFLRAVVKU
      WMXMUWFCUWLUBNZUWCUWLUWDNZPZAVVKUWMVYAAVVKUWMUJZUJKUWGCDUWLAVUHVYBGTAVUFV
      YBHTAVVKUWMUVJUWLWKUVKUVLUWMAUWFVYAXLVVKUWMUWBVXSUWEVXTEUWLCUBYSEUWLUWCUW
      DYSUVMUVPWNUVNUVOUWMUXALFRLFYTZUWLUWTEVYCUWLBCUWGUWRONZUGUWTKBCUWKVYDKBYT
      ZUWJUWRUWGOVYEUWIUWQQUWHUWPDOYSUVQWIUVRVYCBCVYDUWSUWGUWOUWROXJVNUVSXPUVTU
      WA $.
  $}

$( (End of Steve Rodriguez's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Andrew Salmon
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Principia Mathematica * 10
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d ph x $.
    $( Theorem *10.12 in [WhiteheadRussell] p. 146.  In *10, this is treated as
       an axiom, and the proofs in *10 are based on this theorem.  (Contributed
       by Andrew Salmon, 17-Jun-2011.) $)
    pm10.12 $p |- ( A. x ( ph \/ ps ) -> ( ph \/ A. x ps ) ) $=
      ( wo wal nfv 19.32 biimpi ) ABDCEABCEDABCACFGH $.
  $}

  $( Theorem *10.14 in [WhiteheadRussell] p. 146.  (Contributed by Andrew
     Salmon, 17-Jun-2011.) $)
  pm10.14 $p |- ( ( A. x ph /\ A. x ps ) -> ( [ y / x ] ph /\ [ y / x ] ps )
    ) $=
    ( wal wsb stdpc4 anim12i ) ACEACDFBCEBCDFACDGBCDGH $.

  $( Theorem *10.251 in [WhiteheadRussell] p. 149.  (Contributed by Andrew
     Salmon, 17-Jun-2011.) $)
  pm10.251 $p |- ( A. x -. ph -> -. A. x ph ) $=
    ( wn wal wex alnex 19.2 con3i sylbi ) ACBDABEZCABDZCABFKJABGHI $.

  $( Theorem *10.252 in [WhiteheadRussell] p. 149.  (Contributed by Andrew
     Salmon, 17-Jun-2011.) $)
  pm10.252 $p |- ( -. E. x ph <-> A. x -. ph ) $=
    ( wn wal wex df-ex bicomi con1bii ) ACBDZABEZJICABFGH $.

  $( Theorem *10.253 in [WhiteheadRussell] p. 149.  (Contributed by Andrew
     Salmon, 17-Jun-2011.) $)
  pm10.253 $p |- ( -. A. x ph <-> E. x -. ph ) $=
    ( wn wex wal alex bicomi con1bii ) ACBDZABEZJICABFGH $.

  $( Theorem *10.301 in [WhiteheadRussell] p. 151.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  albitr $p |- ( ( A. x ( ph <-> ps ) /\ A. x ( ps <-> ch ) ) ->
        A. x ( ph <-> ch ) ) $=
    ( wb bitr alanimi ) ABEBCEACEDABCFG $.

  $( Theorem *10.42 in [WhiteheadRussell] p. 155.  (Contributed by Andrew
     Salmon, 17-Jun-2011.) $)
  pm10.42 $p |- ( ( E. x ph \/ E. x ps ) <-> E. x ( ph \/ ps ) ) $=
    ( wo wex 19.43 bicomi ) ABDCEACEBCEDABCFG $.

  ${
    $d ps x $.
    $( Theorem *10.52 in [WhiteheadRussell] p. 155.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm10.52 $p |- ( E. x ph -> ( A. x ( ph -> ps ) <-> ps ) ) $=
      ( wi wal wex 19.23v pm5.5 syl5bb ) ABDCEACFZBDJBABCGJBHI $.
  $}

  $( Theorem *10.53 in [WhiteheadRussell] p. 155.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm10.53 $p |- ( -. E. x ph -> A. x ( ph -> ps ) ) $=
    ( wex wn wal wi pm2.21 19.38 syl ) ACDZEKBCFZGABGCFKLHABCIJ $.

  ${
    $d ch x $.
    $( Theorem *10.541 in [WhiteheadRussell] p. 155.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm10.541 $p |- ( A. x ( ph -> ( ch \/ ps ) ) <->
        ( ch \/ A. x ( ph -> ps ) ) ) $=
      ( wn wi wal wo bi2.04 albii 19.21v bitri df-or imbi2i 3bitr4i ) ACEZBFZFZ
      DGZPABFZDGZFZACBHZFZDGCUAHSPTFZDGUBRUEDAPBIJPTDKLUDRDUCQACBMNJCUAMO $.
  $}

  ${
    $d ch x $.
    $( Theorem *10.542 in [WhiteheadRussell] p. 156.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm10.542 $p |- ( A. x ( ph -> ( ch -> ps ) ) <->
        ( ch -> A. x ( ph -> ps ) ) ) $=
      ( wi wal bi2.04 albii 19.21v bitri ) ACBEEZDFCABEZEZDFCLDFEKMDACBGHCLDIJ
      $.
  $}

  $( Theorem *10.55 in [WhiteheadRussell] p. 156.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm10.55 $p |- ( ( E. x ( ph /\ ps ) /\ A. x ( ph -> ps ) ) <->
        ( E. x ph /\ A. x ( ph -> ps ) ) ) $=
    ( wa wex wi wal exsimpl anim1i exintr imdistanri impbii ) ABDCEZABFCGZDACEZ
    NDMONABCHINOMABCJKL $.

  $( Theorem *10.56 in [WhiteheadRussell] p. 156.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm10.56 $p |- ( ( A. x ( ph -> ps ) /\
        E. x ( ph /\ ch ) ) -> E. x ( ps /\ ch ) ) $=
    ( wi wal wa wex wn pm3.45 con3d al2imi df-ex 3imtr4g imp ) ABEZDFZACGZDHZBC
    GZDHZQRIZDFZITIZDFZISUAQUEUCPUDUBDPRTABCJKLKRDMTDMNO $.

  $( Theorem *10.57 in [WhiteheadRussell] p. 156.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm10.57 $p |- ( A. x ( ph -> ( ps \/ ch ) ) ->
        ( A. x ( ph -> ps ) \/ E. x ( ph /\ ch ) ) ) $=
    ( wo wi wal wa wex wn alnex imnan pm2.53 con1d imim3i syl5bir al2imi orrd )
    ABCEZFZDGZABFZDGZACHZDIZUAUEUCUEJUDJZDGUAUCUDDKTUFUBDUFACJZFTUBACLSUGBASBCB
    CMNOPQPNR $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Principia Mathematica * 11
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    2alanimi.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Removes two universal quantifiers from a statement.  (Contributed by
       Andrew Salmon, 24-May-2011.) $)
    2alanimi $p |- ( ( A. x A. y ph /\ A. x A. y ps ) -> A. x A. y ch ) $=
      ( wal alanimi ) AEGBEGCEGDABCEFHH $.
  $}

  ${
    2al2imi.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Removes two universal qunatifiers from a statement.  (Contributed by
       Andrew Salmon, 24-May-2011.) $)
    2al2imi $p |- ( A. x A. y ph -> ( A. x A. y ps -> A. x A. y ch ) ) $=
      ( wal al2imi ) AEGBEGCEGDABCEFHH $.
  $}

  $( Theorem *11.1 in [WhiteheadRussell] p. 159.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  stdpc4-2 $p |- ( A. x A. y ph -> [ z / x ] [ w / y ] ph ) $=
    ( wal wsb stdpc4 alimi syl ) ACFZBFACEGZBFLBDGKLBACEHILBDHJ $.

  ${
    pm11.11.1 $e |- ph $.
    $( Theorem *11.11 in [WhiteheadRussell] p. 159.  (Contributed by Andrew
       Salmon, 17-Jun-2011.) $)
    pm11.11 $p |- A. z A. w [ z / x ] [ w / y ] ph $=
      ( wsb wal stdpc4-2 ax-gen mpg gen2 ) ACEGBDGZDEACHMBABCDEIACFJKL $.
  $}

  ${
    $d ph x $.  $d ph y $.
    $( Theorem *11.12 in [WhiteheadRussell] p. 159.  (Contributed by Andrew
       Salmon, 17-Jun-2011.) $)
    pm11.12 $p |- ( A. x A. y ( ph \/ ps ) -> ( ph \/ A. x A. y ps ) ) $=
      ( wo wal pm10.12 alimi syl ) ABEDFZCFABDFZEZCFAKCFEJLCABDGHAKCGI $.
  $}

  $( Theorem *11.22 in [WhiteheadRussell] p. 160.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  2exnaln $p |- ( E. x E. y ph <-> -. A. x A. y -. ph ) $=
    ( wex wn wal df-ex alnex albii xchbinxr ) ACDZBDKEZBFAECFZBFKBGMLBACHIJ $.

  $( Theorem *11.25 in [WhiteheadRussell] p. 160.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  2nexaln $p |- ( -. E. x E. y ph <-> A. x A. y -. ph ) $=
    ( wn wal wex 2exnaln bicomi con1bii ) ADCEBEZACFBFZKJDABCGHI $.

  ${
    $d ps x $.  $d ps y $.
    $( Compare theorem *11.3 in [WhiteheadRussell] p. 161.  Special case of
       theorem 19.21 of [Margaris] p. 90 with 2 quantifiers.  (Contributed by
       Andrew Salmon, 24-May-2011.) $)
    19.21vv $p |- ( A. x A. y ( ps -> ph ) <-> ( ps -> A. x A. y ph ) ) $=
      ( wi wal 19.21v albii bitri ) BAEDFZCFBADFZEZCFBKCFEJLCBADGHBKCGI $.
  $}

  $( Theorem *11.32 in [WhiteheadRussell] p. 162.  Theorem 19.20 of [Margaris]
     p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon, 24-May-2011.) $)
  2alim $p |- ( A. x A. y ( ph -> ps ) ->
        ( A. x A. y ph -> A. x A. y ps ) ) $=
    ( wi id 2al2imi ) ABEZABCDHFG $.

  $( Theorem *11.33 in [WhiteheadRussell] p. 162.  Theorem 19.15 of [Margaris]
     p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon, 24-May-2011.) $)
  2albi $p |- ( A. x A. y ( ph <-> ps ) ->
        ( A. x A. y ph <-> A. x A. y ps ) ) $=
    ( wb wal albi alimi syl ) ABEDFZCFADFZBDFZEZCFKCFLCFEJMCABDGHKLCGI $.

  $( Theorem *11.34 in [WhiteheadRussell] p. 162.  Theorem 19.22 of [Margaris]
     p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon, 24-May-2011.) $)
  2exim $p |- ( A. x A. y ( ph -> ps ) ->
        ( E. x E. y ph -> E. x E. y ps ) ) $=
    ( wi wal wex exim alimi syl ) ABEDFZCFADGZBDGZEZCFLCGMCGEKNCABDHILMCHJ $.

  $( Theorem *11.341 in [WhiteheadRussell] p. 162.  Theorem 19.18 of [Margaris]
     p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon, 24-May-2011.) $)
  2exbi $p |- ( A. x A. y ( ph <-> ps ) ->
        ( E. x E. y ph <-> E. x E. y ps ) ) $=
    ( wb wal wex exbi alimi syl ) ABEDFZCFADGZBDGZEZCFLCGMCGEKNCABDHILMCHJ $.

  $( Theorem *11.36 in [WhiteheadRussell] p. 162.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  spsbce-2 $p |- ( [ z / x ] [ w / y ] ph -> E. x E. y ph ) $=
    ( wsb wex spsbe eximi syl ) ACEFZBDFKBGACGZBGKBDHKLBACEHIJ $.

  $( Theorem *11.421 in [WhiteheadRussell] p. 163.  Theorem 19.33 of [Margaris]
     p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon, 24-May-2011.) $)
  19.33-2 $p |- ( ( A. x A. y ph \/ A. x A. y ps ) ->
        A. x A. y ( ph \/ ps ) ) $=
    ( wal wo orc 2alimi olc jaoi ) ADECEABFZDECEBDECEAKCDABGHBKCDBAIHJ $.

  ${
    $d ps x $.  $d ps y $.
    $( Theorem *11.43 in [WhiteheadRussell] p. 163.  Theorem 19.36 of
       [Margaris] p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon,
       25-May-2011.) $)
    19.36vv $p |- ( E. x E. y ( ph -> ps ) <-> ( A. x A. y ph -> ps ) ) $=
      ( wi wex wal 19.36v exbii bitri ) ABEDFZCFADGZBEZCFLCGBEKMCABDHILBCHJ $.
  $}

  ${
    $d ps x $.  $d ps y $.
    $( Theorem *11.44 in [WhiteheadRussell] p. 163.  Theorem 19.31 of
       [Margaris] p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon,
       24-May-2011.) $)
    19.31vv $p |- ( A. x A. y ( ph \/ ps ) <-> ( A. x A. y ph \/ ps ) ) $=
      ( wo wal nfv 19.31 albii bitri ) ABEDFZCFADFZBEZCFLCFBEKMCABDBDGHILBCBCGH
      J $.
  $}

  ${
    $d ps x $.  $d ps y $.
    $( Theorem *11.46 in [WhiteheadRussell] p. 164.  Theorem 19.37 of
       [Margaris] p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon,
       24-May-2011.) $)
    19.37vv $p |- ( E. x E. y ( ps -> ph ) <-> ( ps -> E. x E. y ph ) ) $=
      ( wi wex 19.37v exbii bitri ) BAEDFZCFBADFZEZCFBKCFEJLCBADGHBKCGI $.
  $}

  ${
    $d ps x $.  $d ps y $.
    $( Theorem *11.47 in [WhiteheadRussell] p. 164.  Theorem 19.28 of
       [Margaris] p. 90 with 2 quantifiers.  (Contributed by Andrew Salmon,
       24-May-2011.) $)
    19.28vv $p |- ( A. x A. y ( ps /\ ph ) <-> ( ps /\ A. x A. y ph ) ) $=
      ( wa wal 19.28v albii bitri ) BAEDFZCFBADFZEZCFBKCFEJLCBADGHBKCGI $.
  $}

  $( Theorem *11.52 in [WhiteheadRussell] p. 164.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm11.52 $p |- ( E. x E. y ( ph /\ ps ) <->
        -. A. x A. y ( ph -> -. ps ) ) $=
    ( wa wex wn wi wal df-an 2exbii 2nalexn bitr4i ) ABEZDFCFABGHZGZDFCFODICIGN
    PCDABJKOCDLM $.

  $( Theorem *11.521 in [WhiteheadRussell] p. 164.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  2exanali $p |- ( -. E. x E. y ( ph /\ -. ps ) <->
        A. x A. y ( ph -> ps ) ) $=
    ( wi wn wex wal wa 2nalexn con1bii annim 2exbii xchnxbir ) ABEZFZDGCGZODHCH
    ZABFIZDGCGRQOCDJKSPCDABLMN $.

  ${
    $d ph y $.  $d ps x $.
    $( Theorem *11.56 in [WhiteheadRussell] p. 165.  Special case of ~ aaan .
       (Contributed by Andrew Salmon, 24-May-2011.) $)
    aaanv $p |- ( ( A. x ph /\ A. y ps ) <-> A. x A. y ( ph /\ ps ) ) $=
      ( wa wal nfv aaan bicomi ) ABEDFCFACFBDFEABCDADGBCGHI $.
  $}

  ${
    $d ph y $.
    $( Theorem *11.57 in [WhiteheadRussell] p. 165.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm11.57 $p |- ( A. x ph <-> A. x A. y ( ph /\ [ y / x ] ph ) ) $=
      ( wal wsb wa nfv nfal sp stdpc4 jca alrimi a5i simpl sps alimi impbii ) A
      BDZAABCEZFZCDZBDAUABRTCACBACGHRASABIABCJKLMUAABTACASNOPQ $.
  $}

  ${
    $d ph y $.
    $( Theorem *11.58 in [WhiteheadRussell] p. 165.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm11.58 $p |- ( E. x ph <-> E. x E. y ( ph /\ [ y / x ] ph ) ) $=
      ( wsb wa wex 19.8a nfv sb8e sylib pm4.71i 19.42v bitr4i exbii ) AAABCDZEC
      FZBAAOCFZEPAQAABFQABGABCACHIJKAOCLMN $.
  $}

  ${
    $d ph y $.  $d ps y $.
    $( Theorem *11.59 in [WhiteheadRussell] p. 165.  (Contributed by Andrew
       Salmon, 25-May-2011.) $)
    pm11.59 $p |- ( A. x ( ph -> ps ) ->
        A. y A. x ( ( ph /\ [ y / x ] ph ) -> ( ps /\ [ y / x ] ps ) ) ) $=
      ( wi wal wsb wa nfv nfal sp spsbim anim12d a5i alrimi ) ABEZCFZAACDGZHBBC
      DGZHEZCFDPDCPDIJPTCQABRSPCKABCDLMNO $.
  $}

  ${
    $d ps x $.  $d ch y $.
    $( Theorem *11.6 in [WhiteheadRussell] p. 165.  (Contributed by Andrew
       Salmon, 25-May-2011.) $)
    pm11.6 $p |- ( E. x ( E. y ( ph /\ ps ) /\ ch ) <->
        E. y ( E. x ( ph /\ ch ) /\ ps ) ) $=
      ( wa wex excom an32 2exbii bitri 19.41v exbii 3bitr3i ) ABFZCFZEGZDGZACFZ
      BFZDGZEGZOEGCFZDGSDGBFZEGRPDGEGUBPDEHPTEDABCIJKQUCDOCELMUAUDESBDLMN $.
  $}

  ${
    $d ph y $.
    $( Theorem *11.61 in [WhiteheadRussell] p. 166.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm11.61 $p |- ( E. y A. x ( ph -> ps ) -> A. x ( ph -> E. y ps ) ) $=
      ( wi wal wex 19.12 19.37v biimpi alimi syl ) ABEZCFDGMDGZCFABDGEZCFMDCHNO
      CNOABDIJKL $.
  $}

  ${
    $d ph y $.
    $( Theorem *11.62 in [WhiteheadRussell] p. 166.  Importation combined with
       the rearrangement with quantifiers.  (Contributed by Andrew Salmon,
       24-May-2011.) $)
    pm11.62 $p |- ( A. x A. y ( ( ph /\ ps ) -> ch ) <->
        A. x ( ph -> A. y ( ps -> ch ) ) ) $=
      ( wa wi wal impexp albii 19.21v bitri ) ABFCGZEHZABCGZEHGZDNAOGZEHPMQEABC
      IJAOEKLJ $.
  $}

  $( Theorem *11.63 in [WhiteheadRussell] p. 166.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm11.63 $p |- ( -. E. x E. y ph -> A. x A. y ( ph -> ps ) ) $=
    ( wex wn wal wi 2nexaln pm2.21 2alimi sylbi ) ADECEFAFZDGCGABHZDGCGACDIMNCD
    ABJKL $.

  $( Theorem *11.7 in [WhiteheadRussell] p. 166.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  pm11.7 $p |- ( E. x E. y ( ph \/ ph ) <-> E. x E. y ph ) $=
    ( wo oridm 2exbii ) AADABCAEF $.

  ${
    $d ph y $.  $d ps y $.  $d ch x $.  $d th x $.
    $( Theorem *11.71 in [WhiteheadRussell] p. 166.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm11.71 $p |- ( ( E. x ph /\ E. y ch ) ->
        ( ( A. x ( ph -> ps ) /\ A. y ( ch -> th ) ) <->
        A. x A. y ( ( ph /\ ch ) -> ( ps /\ th ) ) ) ) $=
      ( wex wa wal nfv nfex exim 19.42v 3imtr3g imim2i syl9 syl5 alimd 19.41v
      wi aaan prth 2alimi sylbir pm3.21 simpl adantl pm3.2 simpr adantr impbid2
      ax-7 jcad ) AEGZCFGZHZABTZEIZCDTZFIZHZACHZBDHZTZFIZEIZVAUQUSHZFIEIVFUQUSE
      FUQFJUSEJUAVGVDEFABCDUBUCUDUPVFURUTUOVFURTUNUOVEUQECEFCEJKVEAUOHZBDFGZHZT
      ZUOUQVEVBFGVCFGVHVJVBVCFLACFMBDFMNUOAVHVKBUOAUEVJBVHBVIUFOPQRUGUNVFUTTUOV
      FVDEIZFIUNUTVDEFULUNVLUSFAFEAFJKVLUNCHZBEGZDHZTZUNUSVLVBEGVCEGVMVOVBVCELA
      CESBDESNUNCVMVPDUNCUHVODVMVNDUIOPQRQUJUMUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Predicate Calculus
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x z $.
    $( If ` x = y ` always implies ` x = z ` , then ` y = z ` is true.
       (Contributed by Andrew Salmon, 2-Jun-2011.) $)
    sbeqal1 $p |- ( A. x ( x = y -> x = z ) -> y = z ) $=
      ( weq wi wal wsb sb2 equsb3 sylib ) ABDACDZEAFKABGBCDKABHBACIJ $.
  $}

  ${
    $d x z $.
    sbeqal1i.1 $e |- ( x = y -> x = z ) $.
    $( Suppose you know ` x = y ` implies ` x = z ` , assuming ` x ` and ` z `
       are distinct.  Then, ` y = z ` .  (Contributed by Andrew Salmon,
       3-Jun-2011.) $)
    sbeqal1i $p |- y = z $=
      ( weq wi sbeqal1 mpg ) ABEACEFBCEAABCGDH $.

    $( If ` x = y ` implies ` x = z ` , then we can infer ` z = y ` .
       (Contributed by Andrew Salmon, 3-Jun-2011.) $)
    sbeqal2i $p |- z = y $=
      ( cv sbeqal1i eqcomi ) BECEABCDFG $.
  $}

  ${
    $d y z $.  $d x z $.
    $( When both ` x ` and ` z ` and ` y ` and ` z ` are both distinct, then
       the converse of sbeqal1 holds as well.  (Contributed by Andrew Salmon,
       2-Jun-2011.) $)
    sbeqalbi $p |- ( x = y <-> A. z ( z = x -> z = y ) ) $=
      ( weq wi wal equtrr alrimiv sbeqal1 impbii ) ABDZCADCBDEZCFKLCABCGHCABIJ
      $.
  $}

  $( Proof of a theorem that can act as a sole axiom for pure predicate
     calculus with ~ ax-gen as the inference rule.  This proof extends the idea
     of ~ ax467 and related theorems.  (Contributed by Andrew Salmon,
     14-Jul-2011.) $)
  ax4567 $p |- ( ( A. x A. y -. A. x A. y ( A. y ph -> ps ) -> ( ph ->
      A. y ( A. y ph -> ps ) ) ) -> ( A. y ph -> A. y ps ) ) $=
    ( wal wi wn ax5o ax-6 ax6o con1i alrimih ax-7 syl nsyl4 pm2.21 spsd ja ) AD
    EZBFZDEZCEGZDECEZAUAFSBDEZFZUAUEUCABDHZUAGZUBCEZDEUCUGUHDTDIUHUAUACJKLUBDCM
    NOAUAUEAGAUDDAUDPQUFRR $.

  $( Re-derivation of ~ sp from ~ ax4567 .  Note that ~ ax9 is used for the
     re-derivation.  (Contributed by Andrew Salmon, 14-Jul-2011.)
     (Proof modification is discouraged.) $)
  ax4567to4 $p |- ( A. x ph -> ph ) $=
    ( vy wal wn cv wceq ax9 wi pm2.21 ax-1 ax4567 3syl mtoi con4i ) AABDZAEZPBF
    CFGEZBDZBCHQAPRIBDZIZTBDEBDBDZUAIPSIATJUAUBKARBBLMNO $.

  $( Re-derivation of ~ ax5o from ~ ax4567 .  Note that only propositional
     calculus is required for the re-derivation.  (Contributed by Andrew
     Salmon, 14-Jul-2011.)  (Proof modification is discouraged.) $)
  ax4567to5 $p |- ( A. x ( A. x ph -> ps ) -> ( A. x ph -> A. x ps ) ) $=
    ( wal wi wn ax-1 ax4567 3syl ) ACDZBECDZAKEZKCDFCDCDZLEJBCDEKAGLMGABCCHI $.

  $( Re-derivation of ~ ax6o from ~ ax4567 .  Note that neither ~ ax6o nor
     ~ ax-7 are required for the re-derivation.  (Contributed by Andrew Salmon,
     14-Jul-2011.)  (Proof modification is discouraged.) $)
  ax4567to6 $p |- ( -. A. x -. A. x ph -> ph ) $=
    ( wal wn wi ax-1 alimi a5i con3i sps pm2.21 ax4567 syl syl6 pm2.27 mpg 3syl
    sp id ) ABCZDZBCZDAAEZBCZAEZBCZBCZDZBCZBCZDZUEAUJUBUIUBBUHUABTUGAUFBAUEBAUD
    FGHIGJIUKUDTAUKUJUCUFEZEUDTEUJULKUCABBLMABRNUCUEAEBUDAOASPQ $.

  $( Re-derivation of ~ ax-7 from ~ ax4567 .  Note that ~ ax-7 is not required
     for the re-derivation.  (Contributed by Andrew Salmon, 14-Jul-2011.)
     (Proof modification is discouraged.) $)
  ax4567to7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
    ( wal wi ax-1 2alimi wn ax4567to6 con4i pm2.21 ax4567 syl6 syl alimi pm2.27
    sp nsyl4 id mpg 3syl ) ACDZBDAAEZCDZAEZCDZBDZUEBDZCDZABDCDAUEBCAUDFGUGUGHZC
    DZHZCDZUIUMUGUJCIJULUHCUKBDZHZBDUHUKUOUEBUOUNUCUFEZEZUEUNUPKUQUDUBAUCABCLAC
    QMNOUKBIRONUEACBUCUEAECUDAPASTGUA $.

  ${
    $d x z w $.
    $( This theorem shows that, given ~ axext4 , we can derive a version of
       ~ ax10 .  However, it is weaker than ~ ax10 because it has a distinct
       variable requirement.  (Contributed by Andrew Salmon, 16-Jul-2011.)
       (Proof modification is discouraged.) $)
    ax10ext $p |- ( A. x x = z -> A. z z = x ) $=
      ( vw cv wcel wb wal wceq alimi ax-14 nfv a5i wex nfa1 19.23 elequ2 cbvexv
      wi 19.8a imim12i ax-ext ax-7 bi2 stdpc5 syl9 alimdv syl5 mpcom sylib cbv3
      syl sps sylbi a7s alrimiv spimv sp impbid 3syl axext4 albii 3imtr4i ) CDZ
      ADZEZVCBDZEZFZCGZAGZVGVEFZCGZBGZVDVFHZAGZVFVDHZBGVJVEVEAGZRZCGZAGZVGVGBGZ
      RZCGZBGVMVIVSAVOVJVSVIVNAABCUAIVNVJVSRAVJVHAGZCGVNVSVHACUBVNWDVRCVNVEVGWD
      VQABCJZWDVGVERZAGVGVQRVHWFAVEVGUCIVGVEAVGAKZUDUKUEUFUGULUHLVTWCBVRWCCAVRA
      GZWBCWHVEAMZVQRWBVEVQAVEANOVGWIVQWAVGVGBMZWIVGBSZVGVEBABACPQUIVEVGABVEBKW
      GWEUJTUMIUNUOWCVLBWBVLCBWBBGZVKCWLWJWARZVKVGWABVGBNOWMVGVEVGWJWAVEWKVGVEB
      ABACJUPTVEWJWAVGVEWIWJVEASVEVGABABCPQUIVGBUQTURUMIUNLUSVNVIAABCUTVAVPVLBB
      ACUTVAVB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Principia Mathematica * 13 and * 14
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( One result of theorem *13.13 in [WhiteheadRussell] p. 178.  A note on the
     section - to make the theorems more usable, and because inequality is
     notation for set theory (it is not defined in the predicate calculus
     section), this section will use classes instead of sets.  (Contributed by
     Andrew Salmon, 3-Jun-2011.) $)
  pm13.13a $p |- ( ( ph /\ x = A ) -> [. A / x ]. ph ) $=
    ( cv wceq wsbc sbceq1a biimpac ) BDCEAABCFABCGH $.

  $( Theorem *13.13 in [WhiteheadRussell] p. 178 with different variable
     substitution.  (Contributed by Andrew Salmon, 3-Jun-2011.) $)
  pm13.13b $p |- ( ( [. A / x ]. ph /\ x = A ) -> ph ) $=
    ( cv wceq wsbc sbceq1a biimparc ) BDCEAABCFABCGH $.

  $( Theorem *13.14 in [WhiteheadRussell] p. 178.  (Contributed by Andrew
     Salmon, 3-Jun-2011.) $)
  pm13.14 $p |- ( ( [. A / x ]. ph /\ -. ph ) -> x =/= A ) $=
    ( wsbc wn cv wne wceq sbceq1a biimprcd necon3bd imp ) ABCDZAEBFZCGMANCNCHAM
    ABCIJKL $.

  ${
    $d x y z A $.  $d ph z $.
    $( Theorem *13.192 in [WhiteheadRussell] p. 179.  (Contributed by Andrew
       Salmon, 3-Jun-2011.)  (Revised by NM, 4-Jan-2017.) $)
    pm13.192 $p |- ( E. y ( A. x ( x = A <-> x = y ) /\ ph ) <->
      [. A / y ]. ph ) $=
      ( cv wceq weq wb wal wa wex wsbc bi2 alimi nfv eqeq1 equsal sylib eqeq2
      wi eqcoms alrimiv impbii anbi1i exbii sbc5 bitr4i ) BEZDFZBCGZHZBIZAJZCKC
      EZDFZAJZCKACDLUMUPCULUOAULUOULUJUITZBIUOUKUQBUIUJMNUIUOBCUOBOUHUNDPQRUOUK
      BUKDUNDUNUHSUAUBUCUDUEACDUFUG $.
  $}

  $( Theorem *13.193 in [WhiteheadRussell] p. 179.  (Contributed by Andrew
     Salmon, 3-Jun-2011.) $)
  pm13.193 $p |- ( ( ph /\ x = y ) <-> ( [ y / x ] ph /\ x = y ) ) $=
    ( weq wsb sbequ12 pm5.32ri ) BCDAABCEABCFG $.

  $( Theorem *13.194 in [WhiteheadRussell] p. 179.  (Contributed by Andrew
     Salmon, 3-Jun-2011.) $)
  pm13.194 $p |- ( ( ph /\ x = y ) <-> ( [ y / x ] ph /\ ph /\ x = y ) ) $=
    ( weq wa wsb w3a wsbc pm13.13a sbsbc sylibr simpl simpr 3jca 3simpc impbii
    cv ) ABCDZEZABCFZARGSTARSABCQZHTABUAIABCJKARLARMNTAROP $.

  ${
    $d y A $.
    $( Theorem *13.195 in [WhiteheadRussell] p. 179.  This theorem is very
       similar to ~ sbc5 .  (Contributed by Andrew Salmon, 3-Jun-2011.)
       (Revised by NM, 4-Jan-2017.) $)
    pm13.195 $p |- ( E. y ( y = A /\ ph ) <-> [. A / y ]. ph ) $=
      ( wsbc cv wceq wa wex sbc5 bicomi ) ABCDBECFAGBHABCIJ $.
  $}

  ${
    $d x y $.  $d ph y $.
    $( Theorem *13.196 in [WhiteheadRussell] p. 179.  The only difference is
       the position of the substituted variable.  (Contributed by Andrew
       Salmon, 3-Jun-2011.) $)
    pm13.196a $p |- ( -. ph <-> A. y ( [ y / x ] ph -> y =/= x ) ) $=
      ( wn weq wsb wa wex wi wal cv sbelx sb56 imbi2i con2b df-ne bicomi 3bitri
      wne sbn albii ) ADZCBEZUBBCFZGCHUCUDIZCJABCFZCKZBKZSZIZCJUBCBLUDCBMUEUJCU
      EUCUFDZIUFUCDZIUJUDUKUCABCTNUCUFOULUIUFUIULUGUHPQNRUAR $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y ph $.
    $( Theorem *13.21 in [WhiteheadRussell] p. 179.  (Contributed by Andrew
       Salmon, 3-Jun-2011.) $)
    2sbc6g $p |- ( ( A e. C /\ B e. D ) -> ( A. z A. w ( ( z = A /\
      w = B ) -> ph ) <-> [. A / z ]. [. B / w ]. ph ) ) $=
      ( vx vy wcel cv wceq wa wi wal wsbc wb weq eqeq2 imbi1d anbi2d dfsbcq vex
      2albidv sbcbidv bibi12d anbi1d 19.21v impexp albii imbi2i 3bitr4ri bitr2i
      sbc6 vtocl2g ancoms ) EGJDFJBKZDLZCKZELZMZANZCOBOZACEPZBDPZQZBHRZCIRZMZAN
      ZCOZBOZACIKZPZBHKZPZQVGUTMZANZCOBOZVDBVOPZQVFIHEDGFVMELZVLVSVPVTWAVJVRBCW
      AVIVQAWAVHUTVGVMEUSSUATUDWAVNVDBVOACVMEUBUEUFVODLZVSVCVTVEWBVRVBBCWBVQVAA
      WBVGURUTVODUQSUGTUDVDBVODUBUFVPVGVNNZBOVLVNBVOHUCUNWCVKBVGVHANZNZCOVGWDCO
      ZNVKWCVGWDCUHVJWECVGVHAUIUJVNWFVGACVMIUCUNUKULUJUMUOUP $.
  $}

  ${
    $d w x y z A $.  $d w x y z B $.  $d x y ph $.
    $( Theorem *13.22 in [WhiteheadRussell] p. 179.  (Contributed by Andrew
       Salmon, 3-Jun-2011.) $)
    2sbc5g $p |- ( ( A e. C /\ B e. D ) -> ( E. z E. w ( ( z = A /\ w = B )
      /\ ph ) <-> [. A / z ]. [. B / w ]. ph ) ) $=
      ( vx vy wcel cv wceq wa wex wsbc wb weq eqeq2 anbi1d 2exbidv sbcbidv sbc5
      anbi2d dfsbcq bibi12d 19.42v anass anbi2i 3bitr4ri bitr2i vtocl2g ancoms
      exbii ) EGJDFJBKZDLZCKZELZMZAMZCNBNZACEOZBDOZPZBHQZCIQZMZAMZCNZBNZACIKZOZ
      BHKZOZPVDUQMZAMZCNBNZVABVLOZPVCIHEDGFVJELZVIVPVMVQVRVGVOBCVRVFVNAVRVEUQVD
      VJEUPRUCSTVRVKVABVLACVJEUDUAUEVLDLZVPUTVQVBVSVOUSBCVSVNURAVSVDUOUQVLDUNRS
      STVABVLDUDUEVMVDVKMZBNVIVKBVLUBVTVHBVDVEAMZMZCNVDWACNZMVHVTVDWACUFVGWBCVD
      VEAUGUMVKWCVDACVJUBUHUIUMUJUKUL $.
  $}

  ${
    $d x y $.  $d ph y $.
    $( Equivalence between two different forms of ` iota ` .  (Contributed by
       Andrew Salmon, 15-Jul-2011.) $)
    iotain $p |- ( E! x ph -> |^| { x | ph } = ( iota x ph ) ) $=
      ( vy weu cv wceq wb wal wex cab cint cio df-eu csn intsn nfa1 abbid df-sn
      vex sp syl6eqr inteqd iotaval 3eqtr4a exlimiv sylbi ) ABDABECEZFZGZBHZCIA
      BJZKZABLZFZABCMUJUNCUJUGNZKUGULUMUGCSOUJUKUOUJUKUHBJUOUJAUHBUIBPUIBTQBUGR
      UAUBABCUCUDUEUF $.
  $}

  ${
    $d y ph $.  $d y x $.
    $( The iota class exists.  This theorem does not require ~ ax-nul for its
       proof.  (Contributed by Andrew Salmon, 11-Jul-2011.) $)
    iotaexeu $p |- ( E! x ph -> ( iota x ph ) e. _V ) $=
      ( vy cv wceq wb wal wex cio weu cvv wcel iotaval eqcomd eximi df-eu isset
      3imtr4i ) ABDCDZEFBGZCHSABIZEZCHABJUAKLTUBCTUASABCMNOABCPCUAQR $.
  $}

  ${
    $d x y $.  $d ph y $.
    $( Definition *14.01 in [WhiteheadRussell] p. 184.  In Principia
       Mathematica, Russell and Whitehead define ` iota ` in terms of a
       function of ` ( iota x ph ) ` .  Their definition differs in that a
       function of ` ( iota x ph ) ` evaluates to "false" when there isn't a
       single ` x ` that satisfies ` ph ` .  (Contributed by Andrew Salmon,
       11-Jul-2011.) $)
    iotasbc $p |- ( E! x ph -> ( [. ( iota x ph ) / y ]. ps <->
         E. y ( A. x ( ph <-> x = y ) /\ ps ) ) ) $=
      ( cio wsbc cv wceq wa wex weu wb wal sbc5 wi cvv wcel iotaexeu eueq sylib
      df-eu iotaval eqcomd ancri eupick syl2anc impbid1 anbi1d exbidv syl5bb
      eximi sylbi ) BDACEZFDGZUMHZBIZDJACKZACGUNHLCMZBIZDJBDUMNUQUPUSDUQUOURBUQ
      UOURUQUODKZUOURIZDJZUOUROUQUMPQUTACRDUMSTUQURDJVBACDUAURVADURUOURUMUNACDU
      BUCZUDUKULUOURDUEUFVCUGUHUIUJ $.
  $}

  ${
    $d x y z $.  $d ph y z $.  $d ps y z $.
    $( Theorem *14.111 in [WhiteheadRussell] p. 184.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    iotasbc2 $p |- ( ( E! x ph /\ E! x ps ) -> ( [. ( iota x ph ) / y ].
        [. ( iota x ps ) / z ]. ch <-> E. y E. z ( A. x ( ph <-> x = y ) /\
        A. x ( ps <-> x = z ) /\ ch ) ) ) $=
      ( weu cio wsbc weq wb wal wa wex w3a iotasbc anbi2d 3anass exbii 19.42v
      bitr2i syl6bb exbidv sylan9bb ) ADGCFBDHIZEADHIADEJKDLZUEMZENBDGZUFBDFJKD
      LZCOZFNZENAUEDEPUHUGUKEUHUGUFUICMZFNZMZUKUHUEUMUFBCDFPQUKUFULMZFNUNUJUOFU
      FUICRSUFULFTUAUBUCUD $.
  $}

  ${
    $d ph y $.  $d x y $.
    $( Theorem *14.12 in [WhiteheadRussell] p. 184.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    pm14.12 $p |- ( E! x ph
        -> A. x A. y ( ( ph /\ [. y / x ]. ph ) -> x = y ) ) $=
      ( weu wmo cv wsbc wa weq wi wal eumo wsb sbsbc anbi2i imbi1i 2albii bitri
      nfv mo3 sylib ) ABDABEZAABCFGZHZBCIZJZCKBKZABLUBAABCMZHZUEJZCKBKUGABCACST
      UJUFBCUIUDUEUHUCAABCNOPQRUA $.
  $}

  ${
    $d y x A $.  $d y B $.  $d ph y $.
    $( Theorem *14.122 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 9-Jun-2011.) $)
    pm14.122a $p |- ( A e. V -> ( A. x ( ph <-> x = A )
        <-> ( A. x ( ph -> x = A ) /\ [. A / x ]. ph ) ) ) $=
      ( cv wceq wb wal wi wa wcel wsbc albiim sbc6g bicomd anbi2d syl5bb ) ABEC
      FZGBHARIBHZRAIBHZJCDKZSABCLZJARBMUATUBSUAUBTABCDNOPQ $.

    $( Theorem *14.122 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 9-Jun-2011.) $)
    pm14.122b $p |- ( A e. V -> ( ( A. x ( ph -> x = A ) /\ [. A / x ]. ph )
        <-> ( A. x ( ph -> x = A ) /\ E. x ph ) ) ) $=
      ( vy wcel cv wceq wi wal wsbc wex weq imbi2d albidv dfsbcq bibi1d imbi12d
      wb eqeq2 wa sbc5 nfa1 simpr ancr sps impbid2 exbid syl5bb vtoclg pm5.32d
      ) CDFABGZCHZIZBJZABCKZABLZABEMZIZBJZABEGZKZUQSZIUOUPUQSZIECDVACHZUTUOVCVD
      VEUSUNBVEURUMAVACULTNOVEVBUPUQABVACPQRVBURAUAZBLUTUQABVAUBUTVFABUSBUCUTVF
      AURAUDUSAVFIBAURUEUFUGUHUIUJUK $.

    $( Theorem *14.122 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 9-Jun-2011.) $)
    pm14.122c $p |- ( A e. V -> ( A. x ( ph <-> x = A ) <->
                    ( A. x ( ph -> x = A ) /\ E. x ph ) ) ) $=
      ( wcel cv wceq wb wal wi wsbc wa wex pm14.122a pm14.122b bitrd ) CDEABFCG
      ZHBIAQJBIZABCKLRABMLABCDNABCDOP $.
  $}

  ${
    $d w A z $.  $d w B z $.
    $( Theorem *14.123 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 9-Jun-2011.) $)
    pm14.123a $p |- ( ( A e. V /\ B e. W ) -> ( A. z A. w ( ph <->
      ( z = A /\ w = B ) ) <-> ( A. z A. w ( ph -> ( z = A /\ w = B ) ) /\
      [. A / z ]. [. B / w ]. ph ) ) ) $=
      ( cv wceq wa wb wal wi wcel wsbc 2albiim 2sbc6g anbi2d syl5bb ) ABHDICHEI
      JZKCLBLATMCLBLZTAMCLBLZJDFNEGNJZUAACEOBDOZJATBCPUCUBUDUAABCDEFGQRS $.

    $( Theorem *14.123 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 9-Jun-2011.) $)
    pm14.123b $p |- ( ( A e. V /\ B e. W ) -> ( ( A. z A. w ( ph ->
      ( z = A /\ w = B ) ) /\ [. A / z ]. [. B / w ]. ph ) <->
      ( A. z A. w ( ph -> ( z = A /\ w = B ) ) /\ E. z E. w ph ) ) ) $=
      ( wcel wa cv wceq wi wal wsbc wex wb 2sbc5g adantr nfa1 exbid nfa2 sp sps
      simpr ancrd impbid2 adantl bitr3d pm5.32da ) DFHEGHIZABJDKCJEKIZLZCMZBMZA
      CENBDNZACOZBOZUJUNIUKAIZCOZBOZUOUQUJUTUOPUNABCDEFGQRUNUTUQPUJUNUSUPBUMBSU
      NURACULCBUAUNURAUKAUDUNAUKUMULBULCUBUCUEUFTTUGUHUI $.

    $( Theorem *14.123 in [WhiteheadRussell] p. 185.  (Contributed by Andrew
       Salmon, 9-Jun-2011.) $)
    pm14.123c $p |- ( ( A e. V /\ B e. W ) -> ( A. z A. w ( ph <->
      ( z = A /\ w = B ) ) <-> ( A. z A. w ( ph -> ( z = A /\ w = B ) ) /\
      E. z E. w ph ) ) ) $=
      ( wcel wa cv wceq wb wal wi wsbc wex pm14.123a pm14.123b bitrd ) DFHEGHIA
      BJDKCJEKIZLCMBMATNCMBMZACEOBDOIUAACPBPIABCDEFGQABCDEFGRS $.
  $}

  ${
    $( Theorem *14.18 in [WhiteheadRussell] p. 189.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    pm14.18 $p |- ( E! x ph
        -> ( A. x ps -> [. ( iota x ph ) / x ]. ps ) ) $=
      ( weu cio cvv wcel wal wsbc wi iotaexeu spsbc syl ) ACDACEZFGBCHBCNIJACKB
      CNFLM $.
  $}

  ${
    $d x y $.
    $( Theorem *14.2 in [WhiteheadRussell] p. 189.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    iotaequ $p |- ( iota x x = y ) = y $=
      ( cv wceq wb cio iotaval biid mpg ) ACBCZDZKEKAFJDAKABGKHI $.
  $}

  ${
    $d x y z $.  $d ph z $.
    $( Theorem *14.202 in [WhiteheadRussell] p. 189.  A biconditional version
       of ~ iotaval .  (Contributed by Andrew Salmon, 11-Jul-2011.) $)
    iotavalb $p |- ( E! x ph -> ( A. x ( ph <-> x = y ) <->
        ( iota x ph ) = y ) ) $=
      ( vz weu weq wb wal cio cv wceq iotaval wa wex wsbc iotasbc wcel iotaexeu
      cvv eqsbc3 bitr3d equequ2 bibi2d albidv biimpac exlimiv syl6bir impbid2
      syl ) ABEZABCFZGZBHZABIZCJZKZABCLUJUPABDFZGZBHZDCFZMZDNZUMUJUTDUNOZVBUPAU
      TBDPUJUNSQVCUPGABRDUNUOSTUIUAVAUMDUTUSUMUTURULBUTUQUKADCBUBUCUDUEUFUGUH
      $.
  $}

  ${
    $d x y $.  $d ph y $.
    $( Theorem *14.205 in [WhiteheadRussell] p. 190.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    iotasbc5 $p |- ( E! x ph -> ( [. ( iota x ph ) / y ]. ps <->
        E. y ( y = ( iota x ph ) /\ ps ) ) ) $=
      ( cio wsbc cv wceq wa wex wb weu sbc5 a1i ) BDACEZFDGOHBIDJKACLBDOMN $.
  $}

  ${
    $d z y x $.  $d z y ph $.
    $( Theorem *14.24 in [WhiteheadRussell] p. 191.  (Contributed by Andrew
       Salmon, 12-Jul-2011.) $)
    pm14.24 $p |- ( E! x ph
        -> A. y ( [. y / x ]. ph <-> y = ( iota x ph ) ) ) $=
      ( weu cv wsbc cio wb weq wal nfeu1 nfsbc1v wa wi pm14.12 19.21bbi ancomsd
      wceq ex impbid expdimp pm13.13b adantl alrimd iotaval eqcomd iota4 dfsbcq
      syl6 syl5ibrcom alrimiv ) ABDZABCEZFZUMABGZRZHCULUNUPULUNABCIZHZBJZUPULUN
      URBABKABUMLULUNURULUNMAUQULUNAUQULAUNUQULAUNMUQNBCABCOPQUAUNUQANULUNUQAAB
      UMUBSUCTSUDUSUOUMABCUEUFUIULUNUPABUOFABUGABUMUOUHUJTUK $.
  $}

  ${
    $d x y $.  $d ph y $.
    $( Theorem *14.242 in [WhiteheadRussell] p. 192.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    iotavalsb $p |- ( A. x ( ph <-> x = y ) -> ( [. y / z ]. ps <->
        [. ( iota x ph ) / z ]. ps ) ) $=
      ( cv wceq wb wal wex cio 19.8a weu wi df-eu iotavalb dfsbcq eqcoms syl6bi
      wsbc sylbir mpcom ) ACFDFZGHCIZDJZUDBEUCTBEACKZTHZUDDLUEACMZUDUGNACDOUHUD
      UFUCGUGACDPUGUCUFBEUCUFQRSUAUB $.
  $}

  ${
    $d x y $.  $d ph y $.  $d ps y $.
    $( Theorem *14.25 in [WhiteheadRussell] p. 192.  (Contributed by Andrew
       Salmon, 12-Jul-2011.) $)
    sbiota1 $p |- ( E! x ph
        -> ( A. x ( ph -> ps ) <-> [. ( iota x ph ) / x ]. ps ) ) $=
      ( vy weu wi wal cio wsbc cv wceq wb wex df-eu wsb sbsbc dfsbcq sylc cvv
      wa biimpi iota4 iotaval eqcomd spsbim 3imtr3g imbi12d syl5ib exlimiv wcel
      com23 syl iotaexeu anbi12d imbi1d sbcan spesbc sylbir vtoclg exp3a anc2li
      eupicka syl6 impbid ) ACEZABFCGZBCACHZIZVEACJDJZKLCGZDMZACVGIZVFVHFZVEVKA
      CDNUAACUBZVJVLVMFZDVJVIVGKZVOVJVGVIACDUCUDVPVFVLVHVFACVIIZBCVIIZFVPVLVHFV
      FACDOBCDOVQVRABCDUEACDPBCDPUFVPVQVLVRVHACVIVGQZBCVIVGQZUGUHUKULUIRVEVHVEA
      BTZCMZTVFVEVHWBVEVGSUJZVLVHWBFACUMVNWCVLVHWBVQVRTZWBFVLVHTZWBFDVGSVPWDWEW
      BVPVQVLVRVHVSVTUNUOWDWACVIIWBABCVIUPWACVIUQURUSUTRVAABCVBVCVD $.
  $}

  ${
    $( Theorem *14.26 in [WhiteheadRussell] p. 192.  (Contributed by Andrew
       Salmon, 12-Jul-2011.) $)
    sbaniota $p |- ( E! x ph
        -> ( E. x ( ph /\ ps ) <-> [. ( iota x ph ) / x ]. ps ) ) $=
      ( weu wa wex wi wal cio wsbc eupickbi sbiota1 bitrd ) ACDABECFABGCHBCACIJ
      ABCKABCLM $.
  $}

  ${
    $( Theorem *14.271 in [WhiteheadRussell] p. 192.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    eubi $p |- ( A. x ( ph <-> ps ) -> ( E! x ph <-> E! x ps ) ) $=
      ( wb wal nfa1 sp eubid ) ABDZCEABCICFICGH $.
  $}

  ${
    $( Theorem *14.272 in [WhiteheadRussell] p. 193.  (Contributed by Andrew
       Salmon, 11-Jul-2011.) $)
    iotasbcq $p |- ( A. x ( ph <-> ps ) -> ( [. ( iota x ph ) / y ]. ch <->
        [. ( iota x ps ) / y ]. ch ) ) $=
      ( wb wal cio wceq wsbc iotabi dfsbcq syl ) ABFDGADHZBDHZICENJCEOJFABDKCEN
      OLM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Set Theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x $.
    $( Any set that contains one element less than the universe is not equal to
       it.  (Contributed by Andrew Salmon, 16-Jun-2011.) $)
    elnev $p |- ( A e. _V <-> { x | -. x = A } =/= _V ) $=
      ( cvv wcel cv wceq wex wn cab wne isset df-v eqeq2i wal equid albii alnex
      wb tbt bitri abbi 3bitr3ri necon2abii ) BCDAEZBFZAGZUEHZAIZCJABKUFUHCUHCF
      UHUDUDFZAIZFZUFHZCUJUHALMUGANUGUIRZANULUKUGUMAUIUGAOSPUEAQUGUIAUAUBTUCT
      $.
  $}

  ${
    $( A version of Russell's paradox which is proven using proper
       substitution.  (Contributed by Andrew Salmon, 18-Jun-2011.)
       (Proof modification is discouraged.) $)
    rusbcALT $p |- { x | x e/ x } e/ _V $=
      ( cv wnel cab cvv wcel wn pm5.19 wsbc csb sbcnel12g sbc8g csbvarg eleq12d
      wb df-nel notbid syl5bb 3bitr3d mto mpbir ) ABZUBCZADZECUDEFZGUEUDUDFZUFG
      ZOUFHUEUCAUDIAUDUBJZUHCZUFUGAUDUBUBEKUCAUDELUIUHUHFZGUEUGUHUHPUEUJUFUEUHU
      DUHUDAUDEMZUKNQRSTUDEPUA $.
  $}

  $( Equivalence between two ways of saying "is a member of the complement of
     ` A ` ."  (Contributed by Andrew Salmon, 15-Jul-2011.) $)
  compel $p |- ( x e. ( _V \ A ) <-> -. x e. A ) $=
    ( cv cvv cdif wcel wn vex eldif mpbiran ) ACZDBEFKDFKBFGAHKDBIJ $.

  ${
    $d x A $.
    $( Equality between two ways of saying "the complement of ` A ` ."
       (Contributed by Andrew Salmon, 15-Jul-2011.) $)
    compeq $p |- ( _V \ A ) = { x | -. x e. A } $=
      ( cv wcel wn cvv cdif compel abbi2i ) ACBDEAFBGABHI $.
  $}

  $( The complement of ` A ` is not equal to ` A ` .  (Contributed by Andrew
     Salmon, 15-Jul-2011.) $)
  compne $p |- ( _V \ A ) =/= A $=
    ( cvv c0 wne cdif vn0 wceq cun ssun1 eqssi undif1 eqtr4i uneq1 syl5eq unidm
    ssv syl6eq difabs id eqtrd syl5req difeq1 difid necon3i ax-mp ) BCDBAEZADFU
    FABCUFAGZBACUGBAAHZAUGBUFAHZUHBBAHZUIBUJBAIUJPJBAKLUFAAMNAOQUGAAAEZCUGAUFAE
    ZUKUGULUFABARUGSUAUFAAUBTAUCQTUDUE $.

  $( Two ways of saying "the complement of a class abstraction".  (Contributed
     by Andrew Salmon, 15-Jul-2011.)  (Proof shortened by Mario Carneiro,
     11-Dec-2016.) $)
  compab $p |- ( _V \ { z | ph } ) = { z | -. ph } $=
    ( cvv cab cdif wn wceq cv wcel wb nfcv nfab1 nfdif cleqf abid notbii compel
    3bitr4i mpgbir ) CABDZEZAFZBDZGBHZUAIZUDUCIZJBBUAUCBCTBCKABLMUBBLNUDTIZFUBU
    EUFUGAABOPBTQUBBORS $.

  ${
    $d A x $.  $d B x $.
    $( Contrpositive law for subsets.  (Contributed by Andrew Salmon,
       15-Jul-2011.) $)
    conss34 $p |- ( A C_ B <-> ( _V \ B ) C_ ( _V \ A ) ) $=
      ( vx cv wcel wi wal cvv cdif wss con34b compel imbi12i bitr4i albii dfss2
      wn 3bitr4i ) CDZAEZSBEZFZCGSHBIZEZSHAIZEZFZCGABJUCUEJUBUGCUBUAQZTQZFUGTUA
      KUDUHUFUICBLCALMNOCABPCUCUEPR $.

    $( Contrapositive law for subsets.  (Contributed by Andrew Salmon,
       15-Jul-2011.) $)
    conss2 $p |- ( A C_ ( _V \ B ) <-> B C_ ( _V \ A ) ) $=
      ( cvv wss cdif wb ssv ssconb mp2an ) ACDBCDACBEDBCAEDFAGBGABCHI $.

    $( Contrapositive law for subsets.  (Contributed by Andrew Salmon,
       15-Jul-2011.) $)
    conss1 $p |- ( ( _V \ A ) C_ B <-> ( _V \ B ) C_ A ) $=
      ( cvv difcom ) CABD $.
  $}

  ${
    ralbidar.1 $e |- ( ph -> A. x e. A ph ) $.
    ralbidar.2 $e |- ( ( ph /\ x e. A ) -> ( ps <-> ch ) ) $.
    $( More general form of ~ ralbida .  (Contributed by Andrew Salmon,
       25-Jul-2011.) $)
    ralbidar $p |- ( ph -> ( A. x e. A ps <-> A. x e. A ch ) ) $=
      ( cv wcel wi wal wral wb ex ralimi syl df-ral sylib pm2.43 pm5.74d alimi
      albi 3syl 3bitr4g ) ADHEIZBJZDKZUECJZDKZBDELCDELAUEUEBCMZJZJZDKZUFUHMZDKU
      GUIMAUKDELZUMAADELUOFAUKDEAUEUJGNOPUKDEQRULUNDULUEBCUEUJSTUAUFUHDUBUCBDEQ
      CDEQUD $.

    $( More general form of ~ rexbida .  (Contributed by Andrew Salmon,
       25-Jul-2011.) $)
    rexbidar $p |- ( ph -> ( E. x e. A ps <-> E. x e. A ch ) ) $=
      ( cv wcel wa wex wrex wb wi wal wral ex ralimi syl df-rex sylib exbi 3syl
      df-ral pm2.43 pm5.32d alimi 3bitr4g ) ADHEIZBJZDKZUICJZDKZBDELCDELAUIUIBC
      MZNZNZDOZUJULMZDOUKUMMAUODEPZUQAADEPUSFAUODEAUIUNGQRSUODEUDUAUPURDUPUIBCU
      IUNUEUFUGUJULDUBUCBDETCDETUH $.
  $}

  ${
    $d ph w $.  $d w x $.  $d w y $.  $d w z $.
    $( Theorem to aid use of the distinctor reduction theorem with ordered pair
       class abstraction.  (Contributed by Andrew Salmon, 25-Jul-2011.) $)
    dropab1 $p |- ( A. x x = y -> { <. x , z >. | ph } =
        { <. y , z >. | ph } ) $=
      ( vw cv wceq wal cop wa wex cab copab opeq1 sps eqeq2d anbi1d drex2 drex1
      df-opab abbidv 3eqtr4g ) BFZCFZGZBHZEFZUCDFZIZGZAJZDKZBKZELUGUDUHIZGZAJZD
      KZCKZELABDMACDMUFUMUREULUQBCUKUPBCDUFUJUOAUFUIUNUGUEUIUNGBUCUDUHNOPQRSUAA
      BDETACDETUB $.

    $( Theorem to aid use of the distinctor reduction theorem with ordered pair
       class abstraction.  (Contributed by Andrew Salmon, 25-Jul-2011.) $)
    dropab2 $p |- ( A. x x = y -> { <. z , x >. | ph } =
        { <. z , y >. | ph } ) $=
      ( vw cv wceq wal cop wa wex cab copab opeq2 sps eqeq2d anbi1d drex1 drex2
      df-opab abbidv 3eqtr4g ) BFZCFZGZBHZEFZDFZUCIZGZAJZBKZDKZELUGUHUDIZGZAJZC
      KZDKZELADBMADCMUFUMUREULUQBCDUKUPBCUFUJUOAUFUIUNUGUEUIUNGBUCUDUHNOPQRSUAA
      DBETADCETUB $.
  $}

  ${
    $d x A $.
    $( If the identity relation partially orders any class, then that class is
       the null class.  (Contributed by Andrew Salmon, 25-Jul-2011.) $)
    ipo0 $p |- ( _I Po A <-> A = (/) ) $=
      ( vx cid wpo c0 wceq cv wcel wbr weq equid vex ideq mpbir wn poirr eq0rdv
      ex mt2i po0 poeq2 mpbiri impbii ) ACDZAEFZUDBAUDBGZAHZUFUFCIZUHBBJBKUFUFB
      LMNUDUGUHOAUFCPRSQUEUDECDCTAECUAUBUC $.

    $( A class that is founded by the identity relation is null.  (Contributed
       by Andrew Salmon, 25-Jul-2011.) $)
    ifr0 $p |- ( _I Fr A <-> A = (/) ) $=
      ( vx cid wfr c0 wceq cv wcel wbr equid ideq mpbir wn frirr ex mt2i eq0rdv
      vex fr0 freq2 mpbiri impbii ) ACDZAEFZUCBAUCBGZAHZUEUECIZUGUEUEFBJUEUEBRK
      LUCUFUGMAUECNOPQUDUCECDCSAECTUAUB $.

    $( ~ ordelpss with an antecedent removed.  (Contributed by Andrew Salmon,
       25-Jul-2011.) $)
    ordpss $p |- ( Ord B -> ( A e. B -> A C. B ) ) $=
      ( word wcel wa wpss ordelord ex ancrd ordelpss ancoms biimpd expimpd syld
      wb ) BCZABDZACZQEABFZPQRPQRBAGHIPRQSPREQSRPQSOABJKLMN $.
  $}

  ${
    $d A x y $.  $d F x y $.
    $( Explicit substitution of a value of a function into a wff.  (Contributed
       by Andrew Salmon, 1-Aug-2011.) $)
    fvsb $p |- ( E! y A F y -> ( [. ( F ` A ) / x ]. ph <->
        E. x ( A. y ( A F y <-> y = x ) /\ ph ) ) ) $=
      ( cfv wsbc cv wbr cio weu wceq wb wal wa wex df-fv dfsbcq ax-mp iotasbc
      syl5bb ) ABDEFZGZABDCHZEIZCJZGZUECKUEUDBHLMCNAOBPUBUFLUCUGMCDEQABUBUFRSUE
      ACBTUA $.

    fveqsb.2 $e |- ( x = ( F ` A ) -> ( ph <-> ps ) ) $.
    fveqsb.3 $e |- F/ x ps $.
    $( Implicit substitution of a value of a function into a wff.  (Contributed
       by Andrew Salmon, 1-Aug-2011.) $)
    fveqsb $p |- ( E! y A F y -> ( ps <->
        E. x ( A. y ( A F y <-> y = x ) /\ ph ) ) ) $=
      ( cfv wsbc cv wbr weu weq wb wal wa wex cvv wcel fvex sbciegf ax-mp fvsb
      syl5bbr ) BACEFIZJZEDKFLZDMUHDCNODPAQCRUFSTUGBOEFUAABCUFSHGUBUCACDEFUDUE
      $.
  $}

  ${
    $d x y z A $.  $d x y B $.
    $( A Cartesian product exists iff its converse does.  Corollary 6.9(1) in
       [TakeutiZaring] p. 26.  (Contributed by Andrew Salmon, 13-Nov-2011.) $)
    xpexb $p |- ( ( A X. B ) e. _V <-> ( B X. A ) e. _V ) $=
      ( cxp cvv wcel ccnv cnvxp cnvexg syl5eqelr impbii ) ABCZDEZBACZDEZLMKFDAB
      GKDHINKMFDBAGMDHIJ $.

    $( A condition where the converse of ~ xpex holds as well.  Corollary
       6.9(2) in [TakeutiZaring] p. 26.  (Contributed by Andrew Salmon,
       13-Nov-2011.) $)
    xpexcnv $p |- ( ( B =/= (/) /\ ( A X. B ) e. _V ) -> A e. _V ) $=
      ( c0 wne cxp cvv wcel cdm dmexg dmxp eleq1d syl5ib imp ) BCDZABEZFGZAFGZP
      OHZFGNQOFINRAFABJKLM $.

    $( An element of a transitive set is a proper subset of it.  Theorem 7.2 in
       [TakeutiZaring] p. 35.  Unlike ~ tz7.2 , ~ ax-reg is required for its
       proof.  (Contributed by Andrew Salmon, 13-Nov-2011.) $)
    trelpss $p |- ( ( Tr A /\ B e. A ) -> B C. A ) $=
      ( wtr wcel wa wss wne wpss cep wfr zfregfr tz7.2 mp3an2 df-pss sylibr ) A
      CZBADZEBAFBAGEZBAHPAIJQRAKABLMBANO $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                            Arithmetic
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Generalization of commutative law for addition.  Simplifies proofs dealing
     with vectors.  However, it is dependent on our particular definition of
     ordered pair.  (Contributed by Andrew Salmon, 28-Jan-2012.)  (Revised by
     Mario Carneiro, 6-May-2015.) $)
  addcomgi $p |- ( A + B ) = ( B + A ) $=
    ( cc wcel wa caddc co wceq addcom cxp ax-addf fdmi ndmovcom pm2.61i ) ACDBC
    DEABFGBAFGHABIABCFCCJCFKLMN $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Geometry
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c +r -r .v PtDf RR3 $( plane3 $) line3 $.

  $( Introduce the operation of vector addition. $)
  cplusr $a class +r $.

  $( Introduce the operation of vector subtraction. $)
  cminusr $a class -r $.

  $( Introduce the operation of scalar multiplication. $)
  ctimesr $a class .v $.

  $( ` PtDf ` is a predicate that is crucial for the definition of lines as
     well as proving a number of important theorems. $)
  cptdfc $a class PtDf ( A , B ) $.

  $( ` RR3 ` is a class. $)
  crr3c $a class RR3 $.

  $( ` plane3 ` is a class. $)
  $( cplane3 $a class plane3 $. $)

  $( ` line3 ` is a class. $)
  cline3 $a class line3 $.

  ${
    $d v w x y z A $.  $d v w x y z B $.
    $( Define the operation of vector addition.  (Contributed by Andrew Salmon,
       27-Jan-2012.) $)
    df-addr $a |- +r = ( x e. _V , y e. _V |->
        ( v e. RR |-> ( ( x ` v ) + ( y ` v ) ) ) ) $.

    $( Define the operation of vector subtraction.  (Contributed by Andrew
       Salmon, 27-Jan-2012.) $)
    df-subr $a |- -r = ( x e. _V , y e. _V |->
        ( v e. RR |-> ( ( x ` v ) - ( y ` v ) ) ) ) $.

    $( Define the operation of scalar multiplication.  (Contributed by Andrew
       Salmon, 27-Jan-2012.) $)
    df-mulv $a |- .v = ( x e. _V , y e. _V |->
        ( v e. RR |-> ( x x. ( y ` v ) ) ) ) $.

    $( Value of the operation of vector addition.  (Contributed by Andrew
       Salmon, 27-Jan-2012.) $)
    addrval $p |- ( ( A e. C /\ B e. D ) -> ( A +r B ) =
      ( v e. RR |-> ( ( A ` v ) + ( B ` v ) ) ) ) $=
      ( vx vy wcel cvv cplusr co cr cv cfv caddc cmpt wceq elex wa fveq1 syl2an
      oveqan12d mpteq2dv df-addr reex mptex ovmpt2a ) BDHBIHCIHBCJKALAMZBNZUHCN
      ZOKZPZQCEHBDRCERFGBCIIALUHFMZNZUHGMZNZOKZPULJUMBQZUOCQZSALUQUKURUSUNUIUPU
      JOUHUMBTUHUOCTUBUCFGAUDALUKUEUFUGUA $.

    $( Value of the operation of vector subtraction.  (Contributed by Andrew
       Salmon, 27-Jan-2012.) $)
    subrval $p |- ( ( A e. C /\ B e. D ) -> ( A -r B ) =
      ( v e. RR |-> ( ( A ` v ) - ( B ` v ) ) ) ) $=
      ( vx vy wcel cvv cminusr co cr cv cfv cmin cmpt wceq elex wa fveq1 syl2an
      oveqan12d mpteq2dv df-subr reex mptex ovmpt2a ) BDHBIHCIHBCJKALAMZBNZUHCN
      ZOKZPZQCEHBDRCERFGBCIIALUHFMZNZUHGMZNZOKZPULJUMBQZUOCQZSALUQUKURUSUNUIUPU
      JOUHUMBTUHUOCTUBUCFGAUDALUKUEUFUGUA $.

    $( Value of the operation of scalar multiplication.  (Contributed by Andrew
       Salmon, 27-Jan-2012.) $)
    mulvval $p |- ( ( A e. C /\ B e. D ) -> ( A .v B ) =
      ( v e. RR |-> ( A x. ( B ` v ) ) ) ) $=
      ( vx vy wcel cvv ctimesr co cr cv cfv cmul cmpt wceq elex wa fveq1 oveq12
      sylan2 mpteq2dv df-mulv reex mptex ovmpt2a syl2an ) BDHBIHCIHBCJKALBAMZCN
      ZOKZPZQCEHBDRCERFGBCIIALFMZUIGMZNZOKZPULJUMBQZUNCQZSALUPUKURUQUOUJQUPUKQU
      IUNCTUMBUOUJOUAUBUCFGAUDALUKUEUFUGUH $.
  $}

  ${
    $d v w x y z A $.  $d v w x y z B $.  $d v w x y z C $.  $d x D $.
    $( Vector addition at a value.  The operation takes each vector ` A ` and
       ` B ` and forms a new vector whose values are the sum of each of the
       values of ` A ` and ` B ` .  (Contributed by Andrew Salmon,
       27-Jan-2012.) $)
    addrfv $p |- ( ( A e. E /\ B e. D /\ C e. RR ) -> ( ( A +r B ) ` C ) =
        ( ( A ` C ) + ( B ` C ) ) ) $=
      ( vx wcel cr cplusr co caddc wceq wa cv cmpt addrval fveq1d fveq2 oveq12d
      cfv eqid ovex fvmpt sylan9eq 3impa ) AEGZBDGZCHGZCABIJZTZCATZCBTZKJZLUFUG
      MZUHUJCFHFNZATZUOBTZKJZOZTUMUNCUIUSFABEDPQFCURUMHUSUOCLUPUKUQULKUOCARUOCB
      RSUSUAUKULKUBUCUDUE $.

    $d v w x y z A $.  $d v w x y z B $.  $d v w C $.
    $( Vector subtraction at a value.  (Contributed by Andrew Salmon,
       27-Jan-2012.) $)
    subrfv $p |- ( ( A e. E /\ B e. D /\ C e. RR ) -> ( ( A -r B ) ` C ) =
        ( ( A ` C ) - ( B ` C ) ) ) $=
      ( vx wcel cr cminusr co cmin wceq wa cv cmpt subrval fveq1d fveq2 oveq12d
      cfv eqid ovex fvmpt sylan9eq 3impa ) AEGZBDGZCHGZCABIJZTZCATZCBTZKJZLUFUG
      MZUHUJCFHFNZATZUOBTZKJZOZTUMUNCUIUSFABEDPQFCURUMHUSUOCLUPUKUQULKUOCARUOCB
      RSUSUAUKULKUBUCUDUE $.

    $( Scalar multiplication at a value.  (Contributed by Andrew Salmon,
       27-Jan-2012.) $)
    mulvfv $p |- ( ( A e. E /\ B e. D /\ C e. RR ) -> ( ( A .v B ) ` C ) =
        ( A x. ( B ` C ) ) ) $=
      ( vx wcel cr ctimesr co cfv cmul wceq wa cmpt mulvval fveq1d fveq2 oveq2d
      cv eqid ovex fvmpt sylan9eq 3impa ) AEGZBDGZCHGZCABIJZKZACBKZLJZMUFUGNZUH
      UJCFHAFTZBKZLJZOZKULUMCUIUQFABEDPQFCUPULHUQUNCMUOUKALUNCBRSUQUAAUKLUBUCUD
      UE $.

    $( Vector addition produces a function.  (Contributed by Andrew Salmon,
       27-Jan-2012.) $)
    addrfn $p |- ( ( A e. C /\ B e. D ) -> ( A +r B ) Fn RR ) $=
      ( vx wcel wa cplusr co cr wfn cv cfv cmpt ovex eqid fnmpti addrval fneq1d
      caddc mpbiri ) ACFBDFGZABHIZJKEJELZAMZUDBMZTIZNZJKEJUGUHUEUFTOUHPQUBJUCUH
      EABCDRSUA $.

    $( Vector subtraction produces a function.  (Contributed by Andrew Salmon,
       27-Jan-2012.) $)
    subrfn $p |- ( ( A e. C /\ B e. D ) -> ( A -r B ) Fn RR ) $=
      ( vx wcel wa cminusr co wfn cfv cmin cmpt ovex eqid fnmpti subrval fneq1d
      cr cv mpbiri ) ACFBDFGZABHIZSJESETZAKZUDBKZLIZMZSJESUGUHUEUFLNUHOPUBSUCUH
      EABCDQRUA $.

    $( Scalar multiplication producees a function.  (Contributed by Andrew
       Salmon, 27-Jan-2012.) $)
    mulvfn $p |- ( ( A e. C /\ B e. D ) -> ( A .v B ) Fn RR ) $=
      ( vx wcel wa ctimesr co wfn cfv cmul cmpt ovex eqid fnmpti mulvval fneq1d
      cr cv mpbiri ) ACFBDFGZABHIZSJESAETBKZLIZMZSJESUEUFAUDLNUFOPUBSUCUFEABCDQ
      RUA $.

    $( Vector addition is commutative.  (Contributed by Andrew Salmon,
       28-Jan-2012.) $)
    addrcom $p |- ( ( A e. C /\ B e. D ) -> ( A +r B ) = ( B +r A ) ) $=
      ( vx wcel wa cplusr co cr wfn wceq addrfn ancoms cv cfv wral caddc addrfv
      w3a addcomgi 3com12 3eqtr4a 3expia ralrimiv eqfnfv syl5ibrcom mp2and ) AC
      FZBDFZGZABHIZJKZBAHIZJKZULUNLZABCDMUJUIUOBADCMNUKUPUMUOGEOZULPZUQUNPZLZEJ
      QUKUTEJUIUJUQJFZUTUIUJVATUQAPZUQBPZRIVCVBRIZURUSVBVCUAABUQDCSUJUIVAUSVDLB
      AUQCDSUBUCUDUEEJULUNUFUGUH $.
  $}

  ${
    $d x y z A $.  $d x B $.
    $( Define the predicate ` PtDf ` , which is a utility definition used to
       shorten definitions and simplify proofs.  (Contributed by Andrew Salmon,
       15-Jul-2012.) $)
    df-ptdf $a |- PtDf ( A , B ) = ( x e. RR |-> ( ( ( x .v ( B -r A ) )
        +v A ) " { 1 , 2 , 3 } ) ) $.

    $( Define the set of all points ` RR3 ` .  We define each point ` A ` as a
       function to allow the use of vector addition and subtraction as well as
       scalar multiplication in our proofs.  (Contributed by Andrew Salmon,
       15-Jul-2012.) $)
    df-rr3 $a |- RR3 = ( RR ^m { 1 , 2 , 3 } ) $.

    $( Define the set of all lines.  A line is an infinite subset of ` RR3 `
       that satisfies a ` PtDf ` property.  (Contributed by Andrew Salmon,
       15-Jul-2012.) $)
    df-line3 $a |- line3 = { x e. ~P RR3 | ( 2o ~<_ x /\
        A. y e. x A. z e. x ( z =/= y -> ran PtDf ( y , z ) = x ) ) } $.
  $}


$( (End of Andrew Salmon's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Glauco Siliprandi
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d z A $.  $d z B $.
    ssrexf.1 $e |- F/_ x A $.
    ssrexf.2 $e |- F/_ x B $.
    $( restricted existential quantification follows from a subclass
       relationship.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    ssrexf $p |- ( A C_ B -> ( E. x e. A ph -> E. x e. B ph ) ) $=
      ( wss cv wcel wa wex wrex nfss ssel anim1d eximd df-rex 3imtr4g ) CDGZBHZ
      CIZAJZBKTDIZAJZBKABCLABDLSUBUDBBCDEFMSUAUCACDTNOPABCQABDQR $.
  $}

  ${
    fnvinran.1 $e |- ( ph -> F : A --> B ) $.
    $( the function value belongs to its codomain.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    fnvinran $p |- ( ( ph /\ C e. A ) -> ( F ` C ) e. B ) $=
      ( ffvelrnda ) ABCDEFG $.
  $}

  ${
    $d a b x y $.  $d a b F $.  $d a b J $.  $d a b X $.  $d a b ph $.
    $d b K $.
    evth2f.1 $e |- F/_ x F $.
    evth2f.2 $e |- F/_ y F $.
    evth2f.3 $e |- F/_ x X $.
    evth2f.4 $e |- F/_ y X $.
    evth2f.5 $e |- X = U. J $.
    evth2f.6 $e |- K = ( topGen ` ran (,) ) $.
    evth2f.7 $e |- ( ph -> J e. Comp ) $.
    evth2f.8 $e |- ( ph -> F e. ( J Cn K ) ) $.
    evth2f.9 $e |- ( ph -> X =/= (/) ) $.
    $( A version of ~ evth2 using bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    evth2f $p |- ( ph -> E. x e. X A. y e. X ( F ` x ) <_ ( F ` y ) ) $=
      ( va vb cle nfcv cv cfv wbr wral wrex evth2 nffv nfbr nfral nfv weq fveq2
      breq1d ralbidv cbvrexf breq2d cbvralf rexbii bitri sylib ) AQUAZDUBZRUAZD
      UBZSUCZRGUDZQGUEZBUAZDUBZCUAZDUBZSUCZCGUDZBGUEZAQRDEFGLMNOPUFVGVIVDSUCZRG
      UDZBGUEVNVFVPQBGQGTJVEBRGJBVBVDSBVADHBVATUGBSTBVCDHBVCTUGUHUIVPQUJQBUKZVE
      VORGVQVBVIVDSVAVHDULUMUNUOVPVMBGVOVLRCGRGTKCVIVDSCVHDICVHTUGCSTCVCDICVCTU
      GUHVLRUJRCUKVDVKVISVCVJDULUPUQURUSUT $.
  $}

  ${
    $d w x y $.  $d y A B $.
    elunif.1 $e |- F/_ x A $.
    elunif.2 $e |- F/_ x B $.
    $( A version of ~ eluni using bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    elunif $p |- ( A e. U. B <-> E. x ( A e. x /\ x e. B ) ) $=
      ( vy cuni wcel cv wa wex eluni nfcv nfel nfan nfv weq eleq2 eleq1 anbi12d
      cbvex bitri ) BCGHBFIZHZUCCHZJZFKBAIZHZUGCHZJZAKFBCLUFUJFAUDUEAABUCDAUCMZ
      NAUCCUKENOUJFPFAQUDUHUEUIUCUGBRUCUGCSTUAUB $.
  $}

  ${
    rzalf.1 $e |- F/ x A = (/) $.
    $( A version of ~ rzal using bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    rzalf $p |- ( A = (/) -> A. x e. A ph ) $=
      ( c0 wceq cv wcel ne0i necon2bi pm2.21d ralrimi ) CEFZABCDMBGZCHZAOCECNIJ
      KL $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y F $.
    fvelrnbf.1 $e |- F/_ x A $.
    fvelrnbf.2 $e |- F/_ x B $.
    fvelrnbf.3 $e |- F/_ x F $.
    $( A version of ~ fvelrnb using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    fvelrnbf $p |- ( F Fn A -> ( B e. ran F <-> E. x e. A ( F ` x ) = B ) ) $=
      ( vy wfn crn wcel cv cfv wceq wrex fvelrnb nfcv nffv nfeq nfv cbvrexf
      fveq2 eqeq1d syl6bb ) DBICDJKHLZDMZCNZHBOALZDMZCNZABOHBCDPUGUJHABHBQEAUFC
      AUEDGAUEQRFSUJHTUEUHNUFUICUEUHDUBUCUAUD $.
  $}

  ${
    $d y F $.  $d y J $.  $d y K $.  $d y X $.
    rfcnpre1.1 $e |- F/_ x B $.
    rfcnpre1.2 $e |- F/_ x F $.
    rfcnpre1.3 $e |- F/ x ph $.
    rfcnpre1.4 $e |- K = ( topGen ` ran (,) ) $.
    rfcnpre1.5 $e |- X = U. J $.
    rfcnpre1.6 $e |- A = { x e. X | B < ( F ` x ) } $.
    rfcnpre1.7 $e |- ( ph -> B e. RR* ) $.
    rfcnpre1.8 $e |- ( ph -> F e. ( J Cn K ) ) $.
    $( If F is a continuous function with respect to the standard topology,
       then the preimage A of the values greater than a given extended real B
       is an open set.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    rfcnpre1 $p |- ( ph -> A e. J ) $=
      ( wcel wb wa cr vy ccnv cpnf cioo co cima cv cfv clt wbr crab wal wceq wf
      wral ccn ctopon ctop cuni cntop1 syl jctir istopon sylibr crn ctg retopon
      eqeltri iscn sylancl mpbid simpld fnvinran elioopnf baibd syldan pm5.32da
      cxr wfn ffn elpreima 3syl rabid a1i 3bitr4d alrimi nfcnv nfcv nfov nfrab1
      nfima cleqf syl6eqr iooretop eleqtrri cnima eqeltrrd ) AEUBZDUCUDUEZUFZCF
      AWTDBUGZEUHZUIUJZBHUKZCAXAWTQZXAXDQZRZBULWTXDUMAXGBKAXAHQZXBWSQZSZXHXCSZX
      EXFAXHXIXCAXHXBTQZXIXCRAHTXAEAHTEUNZWRUAUGUFFQUAGUOZAEFGUPUEQZXMXNSZPAFHU
      QUHQZGTUQUHZQXOXPRAFURQZHFUSUMZSXQAXSXTAXOXSPEFGUTVAMVBHFVCVDGUDVEVFUHZXR
      LVGVHUAEFGHTVIVJVKVLZVMAXIXLXCADVRQXIXLXCSRODXBVNVAVOVPVQAXMEHVSXEXJRYBHT
      EVTHXAWSEWAWBXFXKRAXCBHWCWDWEWFBWTXDBWRWSBEJWGBDUCUDIBUDWHBUCWHWIWKXCBHWJ
      WLVDNWMAXOWSGQWTFQPWSYAGDUCWNLWOWSEFGWPVJWQ $.
  $}

  ${
    $d x y A $.  $d x y U $.
    $( If U belongs to A and U is an upper bound, then U is the sup of A.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    ubelsupr $p |- ( ( A C_ RR /\ U e. A /\ A. x e. A x <_ U ) ->
          U = sup ( A , RR , < ) ) $=
      ( vy cr wss wcel cv cle wbr wral w3a clt csup wceq wne wrex syl syl2anc
      c0 simp1 simp2 ne0i sseldd simp3 breq2 rspcev 3jca suprub suprleub mpbird
      ralbidv wb suprcl letri3d mpbir2and ) BEFZCBGZAHZCIJZABKZLZCBEMNZOCVCIJZV
      CCIJZVBUQBTPZUSDHZIJZABKZDEQZLZURVDVBUQVFVJUQURVAUAZVBURVFUQURVAUBZBCUCRV
      BCEGZVAVJVBBECVLVMUDZUQURVAUEZVIVADCEVGCOVHUTABVGCUSIUFULUGSUHZVMDABCUISV
      BVEVAVPVBVKVNVEVAUMVQVODAABCUJSUKVBCVCVOVBVKVCEGVQDABUNRUOUP $.
  $}

  ${
    $d k x y A $.  $d k y J $.  $d k y K $.  $d k x y X $.  $d k y ph $.
    $d y B $.
    fsumcnf.1 $e |- K = ( TopOpen ` CCfld ) $.
    fsumcnf.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    fsumcnf.3 $e |- ( ph -> A e. Fin ) $.
    fsumcnf.4 $e |- ( ( ph /\ k e. A ) -> ( x e. X |-> B ) e. ( J Cn K ) ) $.
    $( A finite sum of functions to complex numbers from a common topological
       space is continuous, without disjoint var constraint x ph.  The class
       expression for B normally contains free variables k and x to index it.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fsumcnf $p |- ( ph -> ( x e. X |-> sum_ k e. A B ) e. ( J Cn K ) ) $=
      ( vy csu cmpt cv csb ccn nfcv cbvmpt nfcsb1v nfsum csbeq1a sumeq2sdv wcel
      co weq wa syl5eqelr fsumcn syl5eqel ) ABHCDENZOMHCBMPZDQZENZOFGRUFZBMHULU
      OMULSBCUNEBCSBUMDUAZUBBMUGCDUNEBUMDUCZUDTAMCUNEFGHIJKAEPCUEUHMHUNOBHDOUPB
      MHDUNMDSUQURTLUIUJUK $.
  $}

  $( The product of a negative and a positive number is negative.  (Contributed
     by Glauco Siliprandi, 20-Apr-2017.) $)
  mulltgt0 $p |- ( ( ( A e. RR /\ A < 0 ) /\ ( B e. RR /\ 0 < B ) ) ->
    ( A x. B ) < 0 ) $=
    ( cr wcel cc0 clt wbr wa cmul co cneg renegcl ad2antrr lt0neg1 biimpa simpr
    adantr mulgt0 cc recn syl21anc ad2antrl mulneg1d breqtrd ad2ant2r lt0neg1d
    remulcl mpbird ) ACDZAEFGZHZBCDZEBFGZHZHZABIJZEFGEUPKZFGUOEAKZBIJZUQFUOURCD
    ZEURFGZUNEUSFGUIUTUJUNALMUKVAUNUIUJVAANOQUKUNPURBRUAUOABUIASDUJUNATMULBSDUK
    UMBTUBUCUDUOUPUIULUPCDUJUMABUGUEUFUH $.

  ${
    $d y A $.  $d y B $.
    rspcegf.1 $e |- F/ x ps $.
    rspcegf.2 $e |- F/_ x A $.
    rspcegf.3 $e |- F/_ x B $.
    rspcegf.4 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( A version of ~ rspcev using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    rspcegf $p |- ( ( A e. B /\ ps ) -> E. x e. B ph ) $=
      ( wcel wa cv wex wrex nfel nfan wceq eleq1 anbi12d spcegf anabsi5 df-rex
      sylibr ) DEJZBKZCLZEJZAKZCMZACENUDBUIUHUECDEGUDBCCDEGHOFPUFDQUGUDABUFDERI
      STUAACEUBUC $.
  $}

  ${
    $d x y $.  $d y A $.
    rabexgf.1 $e |- F/_ x A $.
    $( A version of ~ rabexg using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    rabexgf $p |- ( A e. V -> { x e. A | ph } e. _V ) $=
      ( crab wss cvv cv wa cab df-rab simpl ss2abi abid2f sseqtri eqsstri ssexg
      wcel mpan ) ABCFZCGCDSUAHSUABICSZAJZBKZCABCLUDUBBKCUCUBBUBAMNBCEOPQUACDRT
      $.
  $}

  ${
    $d y F $.  $d y J $.  $d y K $.  $d y T $.
    fcnre.1 $e |- K = ( topGen ` ran (,) ) $.
    fcnre.3 $e |- T = U. J $.
    sfcnre.5 $e |- C = ( J Cn K ) $.
    fcnre.6 $e |- ( ph -> F e. C ) $.
    $( A function continuous with respect to the standard topology, is a real
       mapping.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fcnre $p |- ( ph -> F : T --> RR ) $=
      ( ctopon cfv wcel cr ccn co wf ctop syl6eleq cntop1 syl toptopon cioo crn
      sylib ctg retopon eqeltri a1i cnf2 syl3anc ) AECKLMZFNKLZMZDEFOPZMZCNDQAE
      RMZULAUPUQADBUOJISZDEFTUAECHUBUEUNAFUCUDUFLUMGUGUHUIURDEFCNUJUK $.
  $}

  ${
    $d k m n M $.  $d m n A $.  $d m n B $.  $d m n ph $.
    sumsnd.1 $e |- ( ph -> F/_ k B ) $.
    sumsnd.2 $e |- F/ k ph $.
    sumsnd.3 $e |- ( ( ph /\ k = M ) -> A = B ) $.
    sumsnd.4 $e |- ( ph -> M e. V ) $.
    sumsnd.5 $e |- ( ph -> B e. CC ) $.
    $( A sum of a singleton is the term.  The deduction version of ~ sumsn .
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    sumsnd $p |- ( ph -> sum_ k e. { M } A = B ) $=
      ( vm csn c1 cfv cn wcel 1nn wceq cc vn csu caddc cop cseq cv nfcv nfcsb1v
      csb csbeq1a cbvsumi csbeq1 a1i wf1o cfz co f1osng sylancr cz wb 1z f1oeq2
      fzsn sylibr wa elsni adantl csbeq1d csbiedf adantr eqeltrd elfz1eq fveq2d
      mp2b fvsng sylan9eqr 3eqtr4rd fsum syl5eq seq1i eqtrd ) AEMZBDUBZNUCNCUDM
      ZNUEOZCAWCWBDLUFZBUIZLUBWEWBBWGDLLBUGDWFBUHDWFBUJUKAWBWGDUAUFZNEUDMZOZBUI
      ZLUAWIWDNDWFWJBULNPQZARUMANMZWBWIUNZNNUOUPZWBWIUNZAWLEFQZWNRJNEPFUQURNUSQ
      WOWMSWPWNUTVANVCWOWMWBWIVBVNVDAWFWBQZVEZWGDEBUIZTWSDWFEBWRWFESAWFEVFVGVHW
      SWTCTAWTCSZWRADEBCFHGJIVIZVJACTQZWRKVJVKVKAWHWOQZVEZWTCWKWHWDOZAXAXDXBVJX
      EDWJEBXDAWJNWIOZEXDWHNWIWHNVLZVMAWLWQXGESRJNEPFVOURVPVHXDAXFNWDOZCXDWHNWD
      XHVMAWLXCXICSRKNCPTVOURZVPVQVRVSACUCWDNVAXJVTWA $.
  $}

  ${
    $d a b y $.  $d a x y $.  $d a b F $.  $d a b J $.  $d a b X $.
    $d a b ph $.  $d b K $.
    evthf.1 $e |- F/_ x F $.
    evthf.2 $e |- F/_ y F $.
    evthf.3 $e |- F/_ x X $.
    evthf.4 $e |- F/_ y X $.
    evthf.5 $e |- F/ x ph $.
    evthf.6 $e |- F/ y ph $.
    evthf.7 $e |- X = U. J $.
    evthf.8 $e |- K = ( topGen ` ran (,) ) $.
    evthf.9 $e |- ( ph -> J e. Comp ) $.
    evthf.10 $e |- ( ph -> F e. ( J Cn K ) ) $.
    evthf.11 $e |- ( ph -> X =/= (/) ) $.
    $( A version of ~ evth using bound-variable hypotheses instead of distinct
       variable conditions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    evthf $p |- ( ph -> E. x e. X A. y e. X ( F ` y ) <_ ( F ` x ) ) $=
      ( va cle vb cv cfv wbr wral wrex evth nfcv nffv nfbr nfv weq fveq2 breq1d
      cbvralf rexbii nfral breq2d ralbidv cbvrexf bitri sylib ) AUAUBZDUCZSUBZD
      UCZTUDZUAGUEZSGUFZCUBZDUCZBUBZDUCZTUDZCGUEZBGUFZASUADEFGNOPQRUGVIVKVFTUDZ
      CGUEZSGUFVPVHVRSGVGVQUACGUAGUHKCVDVFTCVCDICVCUHUICTUHCVEDICVEUHUIUJVQUAUK
      UACULVDVKVFTVCVJDUMUNUOUPVRVOSBGSGUHJVQBCGJBVKVFTBVJDHBVJUHUIBTUHBVEDHBVE
      UHUIUJUQVOSUKSBULZVQVNCGVSVFVMVKTVEVLDUMURUSUTVAVB $.
  $}

  ${
    $d f y J $.  $d f y K $.
    $( The class of continuous functions between two topologies is a set.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    cnfex $p |- ( ( J e. Top /\ K e. Top ) -> ( J Cn K ) e. _V ) $=
      ( vf vy ctop wcel wa co cuni cvv ctopon cfv wceq eqid jctr istopon sylibr
      cv syl2an uniexg ccn ccnv cima wral cmap crab cnfval wf cab mapvalg mapex
      syl2anr eqeltrd rabexg syl ) AEFZBEFZGZABUAHZCRZUBDRUCAFDBUDZCBIZAIZUEHZU
      FZJUPAVCKLFZBVBKLFZUSVEMUQUPUPVCVCMZGVFUPVHVCNOVCAPQUQUQVBVBMZGVGUQVIVBNO
      VBBPQDCABVCVBUGSURVDJFVEJFURVDVCVBUTUHCUIZJUQVBJFZVCJFZVDVJMUPBETZAETZVBV
      CJJCUJULUPVLVKVJJFUQVNVMVCVBJJCUKSUMVACVDJUNUOUM $.
  $}

  ${
    $d f g w x y z $.  $d f u x y $.  $d f w x y z A $.
    $( For a finite set, a choice function exists, without using the axiom of
       choice.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fnchoice $p |- ( A e. Fin -> E. f ( f Fn A /\ A. x e. A ( x =/= (/) ->
                                  ( f ` x ) e. x ) ) ) $=
      ( vw cv wfn c0 wcel wral wa wex wceq anbi12d cvv a1i simplr adantr jca ex
      syl vy vz vg vu wne cfv wi csn cun fneq2 raleq exbidv fn0 mpbir 0ex fneq1
      eqid spcev ax-mp ral0 pm3.2i exan cfn wn cop wf dffn2 biimpi ad2antrl vex
      simpllr fsnunf syl121anc sylibr simprr nfv nfra1 nfan simpr nelne2 necomd
      fvunsn neeq1 fveq2 eleq1d eleq2 bitrd imbi12d cbvralv rspcv syl5bir syl3c
      eqeltrd simp-4l w3a elsni 3ad2ant2 simp1 eqtrd pm2.21ddne syl3anc wo elun
      simp3 sylib mpjaodan ralrimi syl21anc eximdv snex unex fveq1 imbi2d eximi
      ralbidv syl6 ax17e imp an32s neq0 eeanv simprrl simpl simprrr simplrl cdm
      cbvexv neleqtrrd fsnunfv 3eltr4d 2eximdv exlimiv pm2.61dan findcard2s
      fndm ) CEZDEZFZAEZGUEZYSYPUFZYSHZUGZAYQIZJZCKYPGFZUUCAGIZJZCKYPUAEZFZUUCA
      UUIIZJZCKZYPUUIUBEZUHZUIZFZUUCAUUPIZJZCKZYPBFZUUCABIZJZCKDUAUBBYQGLZUUEUU
      HCUVDYRUUFUUDUUGYQGYPUJUUCAYQGUKMULYQUUILZUUEUULCUVEYRUUJUUDUUKYQUUIYPUJU
      UCAYQUUIUKMULYQUUPLZUUEUUSCUVFYRUUQUUDUURYQUUPYPUJUUCAYQUUPUKMULYQBLZUUEU
      VCCUVGYRUVAUUDUVBYQBYPUJUUCAYQBUKMULUUFUUGCUUFCKZUUGGGFZUVHUVIGGLGUQGUMUN
      UUFUVICGUOGYPGUPURUSUUCAUTVAVBUUIVCHZUUNUUIHVDZJZUUMUUTUVLUUMJZUUNGLZUUTU
      VMUVNJUCEZUUPFZYTYSUVOUFZYSHZUGZAUUPIZJZUCKZUUTUVLUVNUUMUWBUVLUVNJZUUMUWB
      UWCUUMUWBCKZUWBUWCUUMYPUUNYQVEZUHZUIZUUPFZYTYSUWGUFZYSHZUGZAUUPIZJZCKUWDU
      WCUULUWMCUWCUULUWMUWCUULJZUWHUWLUWNUUPNUWGVFZUWHUWNUUINYPVFZUUNNHZUVKYQNH
      ZUWOUUJUWPUWCUUKUUJUWPUUIYPVGZVHVIUWQUWNUBVJZOUVJUVKUVNUULVKZUWRUWNDVJZOU
      UINYPNUUNYQVLZVMUUPUWGVGZVNUWNUVNUVKUUKUWLUVLUVNUULPUXAUWCUUJUUKVOUVNUVKJ
      ZUUKJZUWKAUUPUXEUUKAUXEAVPUUCAUUIVQZVRUXFYSUUPHZUWKUXFUXHJZYTUWJUXIYTJZYS
      UUIHZUWJYSUUOHZUXJUXKJZUWIUUAYSUXMUUNYSUEZUWIUUALZUXMUXKUVKJZUXNUXMUXKUVK
      UXJUXKVSZUXJUVKUXKUXIUVKYTUVNUVKUUKUXHVKQQRUXPYSUUNYSUUNUUIVTWAZTYPUUNYQY
      SWBZTUXMUXKUUKYTUUBUXQUXJUUKUXKUXEUUKUXHYTVKQUXIYTUXKPUUKUDEZGUEZUXTYPUFZ
      UXTHZUGZUDUUIIUXKUUCUYDUUCUDAUUIUXTYSLZUYAYTUYCUUBUXTYSGWCUYEUYCUUAUXTHUU
      BUYEUYBUUAUXTUXTYSYPWDWEUXTYSUUAWFWGWHZWIUYDUUCUDYSUUIUYFWJWKZWLWMUXJUXLJ
      UVNUXLYTUWJUXJUVNUXLUVNUVKUUKUXHYTWNQUXJUXLVSUXIYTUXLPUVNUXLYTWOZUWJYSGUY
      HYSUUNGUXLUVNYSUUNLZYTYSUUNWPZWQUVNUXLYTWRWSUVNUXLYTXDWTXAUXJUXHUXKUXLXBZ
      UXFUXHYTPYSUUIUUOXCZXEXFSSXGXHRSXIUWMUWBCUWAUWMUCUWGYPUWFCVJUWEXJXKUVOUWG
      LZUVPUWHUVTUWLUUPUVOUWGUPUYMUVSUWKAUUPUYMUVRUWJYTUYMUVQUWIYSYSUVOUWGXLWEX
      MXOMURZXNXPUWBCXQZXPXRXSUUSUWACUCYPUVOLZUUQUVPUURUVTUUPYPUVOUPUYPUUCUVSAU
      UPUYPUUBUVRYTUYPUUAUVQYSYSYPUVOXLWEXMXOMYGZVNUVMUVNVDZJZUVKYQUUNHZDKZUUMJ
      ZJZUUTUYSUVKVUBUVJUVKUUMUYRVKUYSVUAUUMUYSUYRVUAUVMUYRVSDUUNXTXEUVLUUMUYRP
      RRVUCUWBUUTVUCUWDDKZUWBUVKVUBVUDVUBUYTUULJZCKDKUVKVUDUYTUULDCYAUVKVUEUWBD
      CUVKVUEUWBUVKVUEJZUWMUWBVUFUWHUWLVUFUWOUWHVUFUWPUWQUVKUWRUWOVUFUUJUWPUVKU
      YTUUJUUKYBZUWSXEUWQVUFUWTOUVKVUEYCUWRVUFUXBOUXCVMUXDVNVUFUWKAUUPUVKVUEAUV
      KAVPUYTUULAUYTAVPUUJUUKAUUJAVPUXGVRVRVRVUFUXHUWKVUFUXHJZYTUWJVUHYTJZUXKUW
      JUXLVUIUXKJZUWIUUAYSVUJUXPUXOVUJUXKUVKVUIUXKVSZUVKVUEUXHYTUXKWNRUXPUXNUXO
      UXRUXSTTVUJUXKUUKYTUUBVUKVUIUUKUXKVUHUUKYTVUFUUKUXHUVKUYTUUJUUKYDQQQVUHYT
      UXKPUYGWLWMVUIUXLJZYQUUNUWIYSVUIUYTUXLVUHUYTYTUVKUYTUULUXHYEQQVULUWIUUNUW
      GUFZYQVULUYIUWIVUMLVULUXLUYIVUIUXLVSUYJTZYSUUNUWGWDTVULUWQUWRUUNYPYFZHVDV
      UMYQLUWQVULUWTOUWRVULUXBOVULVUOUUIUUNUVKVUEUXHYTUXLWNVULUUJVUOUUILVUIUUJU
      XLVUHUUJYTVUFUUJUXHVUGQQQUUIYPYOTYHYPNNUUNYQYIXAWSVUNYJVUIUXHUYKVUFUXHYTP
      UYLXEXFSSXGRUYNTSYKWKXRUWDUWBDUYOYLTUYQVNTYMSYN $.
  $}

  ${
    $d k x y A $.  $d k x J $.  $d k x y X $.  $d k y ph $.  $d y B $.
    refsumcn.1 $e |- F/ x ph $.
    refsumcn.2 $e |- K = ( topGen ` ran (,) ) $.
    refsumcn.3 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    refsumcn.4 $e |- ( ph -> A e. Fin ) $.
    refsumcn.5 $e |- ( ( ph /\ k e. A ) -> ( x e. X |-> B ) e. ( J Cn K ) ) $.
    $( A finite sum of continuous real functions, from a common topological
       space, is continuous.  The class expression for B normally contains free
       variables k and x to index it.  See ~ fsumcn for the analogous theorem
       on continuous complex functions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    refsumcn $p |- ( ph -> ( x e. X |-> sum_ k e. A B ) e. ( J Cn K ) ) $=
      ( vy cfv cr wcel wa a1i syl csu cmpt ccnfld ctopn crest ccn eqid cioo crn
      co cv ctg tgioo2 eqtri oveq2i syl6eleq cc ctopon wss wb cnfldtopon adantr
      wf retopon eqeltri cnf2 syl3anc frn ax-resscn cnrest2 mpbird fsumcnf wceq
      wrex wfn wral cfn simpll simpr jca simplr wi fmpt sylibr sylc fsumrecl ex
      rsp ralrimi fnmpt nfcv nfmpt1 fvelrnbf biimpa nfrn nfcri nfan w3a 3adant3
      fvmpt2 simp3 eqtr3d eqeltrrd 3adant1r 3exp rexlimd ssrdv mpbid syl6eleqr
      mpd ) ABHCDEUAZUBZFUCUDOZPUEUJZUFUJZFGUFUJZAXLFXMUFUJZQZXLXOQZABCDEFXMHXM
      UGZKLAEUKCQZRZBHDUBZXQQZYCXOQZYBYCXPXOMGXNFUFGUHUIULOZXNJXMXTUMUNUOZUPYBX
      MUQUROQZYCUIPUSZPUQUSZYDYEUTYHYBXMXTVAZSYBHPYCVCZYIYBFHUROQZGPUROZQZYCXPQ
      YLAYMYAKVBYOYBGYFYNJVDVESMYCFGHPVFVGZHPYCVHTYJYBVISPYCFXMUQVJVGVKVLAYHXLU
      IZPUSYJXRXSUTYHAYKSANYQPANUKZYQQZYRPQZAYSRZBUKZXLOZYRVMZBHVNZYTAYSUUEAXLH
      VOZYSUUEUTAXKPQZBHVPUUFAUUGBHIAUUBHQZUUGAUUHRZCDEACVQQUUHLVBUUIYARZYBUUHD
      PQZUUJAYAAUUHYAVRUUIYAVSVTAUUHYAWAYBUUKBHVPZUUHUUKWBYBYLUULYPBHPDYCYCUGWC
      WDUUKBHWHTWEWFZWGWIBHXKXLPXLUGZWJTBHYRXLBHWKBYRWKBHXKWLZWMTWNUUAUUDYTBHAY
      SBIBNYQBXLUUOWOWPWQBNPBPWKWPUUAUUHUUDYTAUUHUUDYTYSAUUHUUDWRZXKYRPUUPUUCXK
      YRAUUHUUCXKVMZUUDUUIUUHUUGRUUQUUIUUHUUGAUUHVSUUMVTBHXKPXLUUNWTTWSAUUHUUDX
      AXBAUUHUUGUUDUUMWSXCXDXEXFXJWGXGYJAVISPXLFXMUQVJVGXHYGXI $.
  $}

  ${
    $d y B $.  $d y F $.  $d y X $.  $d y ph $.
    rfcnpre2.1 $e |- F/_ x B $.
    rfcnpre2.2 $e |- F/_ x F $.
    rfcnpre2.3 $e |- F/ x ph $.
    rfcnpre2.4 $e |- K = ( topGen ` ran (,) ) $.
    rfcnpre2.5 $e |- X = U. J $.
    rfcnpre2.6 $e |- A = { x e. X | ( F ` x ) < B } $.
    rfcnpre2.7 $e |- ( ph -> B e. RR* ) $.
    rfcnpre2.8 $e |- ( ph -> F e. ( J Cn K ) ) $.
    $( If ` F ` is a continuous function with respect to the standard topology,
       then the preimage A of the values smaller than a given extended real
       ` B ` , is an open set.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    rfcnpre2 $p |- ( ph -> A e. J ) $=
      ( cmnf cioo wcel wb ccnv co cima cv cfv clt wbr crab wal wceq wa ccn eqid
      cr fcnre fnvinran cxr elioomnf syl baibd syldan pm5.32da wfn ffn elpreima
      3syl rabid a1i 3bitr4d alrimi nfcnv nfcv nfov nfima nfrab1 sylibr syl6eqr
      wf cleqf crn ctg iooretop syl6eleqr cnima syl2anc eqeltrrd ) AEUAZQDRUBZU
      CZCFAWIBUDZEUEZDUFUGZBHUHZCAWJWISZWJWMSZTZBUIWIWMUJAWPBKAWJHSZWKWHSZUKZWQ
      WLUKZWNWOAWQWRWLAWQWKUNSZWRWLTAHUNWJEAFGULUBZHEFGLMXBUMPUOZUPAWRXAWLADUQS
      WRXAWLUKTODWKURUSUTVAVBAHUNEVREHVCWNWSTXCHUNEVDHWJWHEVEVFWOWTTAWLBHVGVHVI
      VJBWIWMBWGWHBEJVKBQDRBQVLBRVLIVMVNWLBHVOVSVPNVQAEXBSWHGSWIFSPAWHRVTWAUEZG
      WHXDSAQDWBVHLWCWHEFGWDWEWF $.
  $}

  ${
    $d s t x y F $.  $d s t x y T $.  $d s t x y ph $.  $d t x J $.  $d t K $.
    cncmpmax.1 $e |- T = U. J $.
    cncmpmax.2 $e |- K = ( topGen ` ran (,) ) $.
    cncmpmax.3 $e |- ( ph -> J e. Comp ) $.
    cncmpmax.4 $e |- ( ph -> F e. ( J Cn K ) ) $.
    cncmpmax.5 $e |- ( ph -> T =/= (/) ) $.
    $( When the hypothesis for the extreme value theorem hold, then the sup of
       the range of the function belongs to the range, it is real and it an
       upper bound of the range.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    cncmpmax $p |- ( ph -> ( sup ( ran F , RR , < ) e. ran F /\
          sup ( ran F , RR , < ) e. RR /\
          A. t e. T ( F ` t ) <_ sup ( ran F , RR , < ) ) ) $=
      ( vy vs cv cle wbr cr wcel wa wceq cfv wral crn clt csup w3a evth wss ccn
      vx wf co eqid fcnre frn syl adantr wfun cdm ffun simpr fdm fvelrn syl2anc
      eleqtrrd adantrr wex wrex wfn wb fvelrnb 3syl biimpa df-rex sylib adantlr
      ffn simprr simpllr simprl fveq2 breq1d rspccva eqbrtrrd ralrimiva adantrl
      exlimddv ubelsupr syl3anc eqcomd eqeltrd sseldd simplrr sylancom breqtrrd
      cbvralv sylibr 3jca rexlimddv ) ABNZDUAZUJNZDUAZOPZBCUBZDUCZQUDUEZXFRZXGQ
      RZXAXGOPZBCUBZUFUJCAUJBDEFCGHIJKUGAXBCRZXESZSZXHXIXKXNXGXCXFXNXCXGXNXFQUH
      ZXCXFRZLNZXCOPZLXFUBZXCXGTAXOXMACQDUKZXOAEFUIULZCDEFHGYAUMJUNZCQDUOUPUQZA
      XLXPXEAXLSZDURZXBDUSZRXPAYEXLAXTYEYBCQDUTUPUQYDXBCYFAXLVAYDXTYFCTAXTXLYBU
      QCQDVBUPVEXBDVCVDVFZAXEXSXLAXESZXRLXFYHXQXFRZSZMNZCRZYKDUAZXQTZSZXRMAYIYO
      MVGZXEAYISYNMCVHZYPAYIYQAXTDCVIYIYQVJYBCQDVQMCXQDVKVLVMYNMCVNVOVPYJYOSZYM
      XQXCOYJYLYNVRYRXEYLYMXCOPZAXEYIYOVSYJYLYNVTXDYSBYKCWTYKTZXAYMXCOWTYKDWAZW
      BWCZVDWDWGWEWFLXFXCWHWIWJZYGWKZXNXFQXGYCUUDWLXNYMXGOPZMCUBXKXNUUEMCXNYLSY
      MXCXGOXNYLXEYSAXLXEYLWMUUBWNXNXGXCTYLUUCUQWOWEXJUUEBMCYTXAYMXGOUUAWBWPWQW
      RWS $.
  $}

  ${
    $d s t z B $.  $d s z F $.  $d s t z T $.  $d s ph $.
    rfcnpre3.2 $e |- F/_ t F $.
    rfcnpre3.3 $e |- K = ( topGen ` ran (,) ) $.
    rfcnpre3.4 $e |- T = U. J $.
    rfcnpre3.5 $e |- A = { t e. T | B <_ ( F ` t ) } $.
    rfcnpre3.6 $e |- ( ph -> B e. RR ) $.
    rfcnpre3.8 $e |- ( ph -> F e. ( J Cn K ) ) $.
    $( If F is a continuous function with respect to the standard topology,
       then the preimage A of the values greater or equal than a given real B
       is a closed set.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    rfcnpre3 $p |- ( ph -> A e. ( Clsd ` J ) ) $=
      ( cpnf ccld cfv cle wcel cr vs ccnv cico co cima cv wbr crab wa wf wfn wb
      ccn eqid fcnre ffn elpreima cxr clt w3a rexrd adantr pnfxr elico1 sylancl
      3syl simpr2 fnvinran simpr ltpnf syl 3jca impbida pm5.32da nfcv nffv nfbr
      bitrd weq fveq2 breq2d elrabf syl6bbr eqrdv syl6eqr cioo icopnfcld fveq2i
      crn ctg syl6eleqr cnclima syl2anc eqeltrrd ) AFUBDOUCUDZUEZCGPQZAWPDBUFZF
      QZRUGZBEUHZCAUAWPXAAUAUFZWPSZXBESZDXBFQZRUGZUIZXBXASAXCXDXEWOSZUIZXGAETFU
      JFEUKXCXIULAGHUMUDZEFGHJKXJUNNUOZETFUPEXBWOFUQVFAXDXHXFAXDUIZXHXEURSZXFXE
      OUSUGZUTZXFXLDURSZOURSXHXOULAXPXDADMVAVBVCDOXEVDVEXLXOXFXLXMXFXNVGXLXFUIZ
      XMXFXNXLXMXFXLXEAETXBFXKVHZVAVBXLXFVIXQXETSZXNXLXSXFXRVBXEVJVKVLVMVRVNVRW
      TXFBXBEBXBVOZBEVOBDXERBDVOBRVOBXBFIXTVPVQBUAVSWSXEDRWRXBFVTWAWBWCWDLWEAFX
      JSWOHPQZSWPWQSNAWOWFWIWJQZPQZYAADTSWOYCSMDWGVKHYBPJWHWKWOFGHWLWMWN $.
  $}

  ${
    $d s t z B $.  $d s z F $.  $d s t z T $.  $d s ph $.
    rfcnpre4.1 $e |- F/_ t F $.
    rfcnpre4.2 $e |- K = ( topGen ` ran (,) ) $.
    rfcnpre4.3 $e |- T = U. J $.
    rfcnpre4.4 $e |- A = { t e. T | ( F ` t ) <_ B } $.
    rfcnpre4.5 $e |- ( ph -> B e. RR ) $.
    rfcnpre4.6 $e |- ( ph -> F e. ( J Cn K ) ) $.
    $( If F is a continuous function with respect to the standard topology,
       then the preimage A of the values smaller or equal than a given real B
       is a closed set.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    rfcnpre4 $p |- ( ph -> A e. ( Clsd ` J ) ) $=
      ( cmnf ccld cfv cle wcel cr vs ccnv cioc co cima cv wbr crab wa wf wfn wb
      ccn eqid fcnre ffn elpreima cxr clt w3a mnfxr rexrd adantr elioc1 sylancr
      3syl simpr3 fnvinran mnflt syl simpr 3jca impbida pm5.32da nfcv nffv nfbr
      bitrd weq fveq2 breq1d elrabf syl6bbr eqrdv syl6eqr cioo iocmnfcld fveq2i
      crn ctg syl6eleqr cnclima syl2anc eqeltrrd ) AFUBODUCUDZUEZCGPQZAWPBUFZFQ
      ZDRUGZBEUHZCAUAWPXAAUAUFZWPSZXBESZXBFQZDRUGZUIZXBXASAXCXDXEWOSZUIZXGAETFU
      JFEUKXCXIULAGHUMUDZEFGHJKXJUNNUOZETFUPEXBWOFUQVFAXDXHXFAXDUIZXHXEURSZOXEU
      SUGZXFUTZXFXLOURSDURSZXHXOULVAAXPXDADMVBVCODXEVDVEXLXOXFXLXMXNXFVGXLXFUIZ
      XMXNXFXLXMXFXLXEAETXBFXKVHZVBVCXQXETSZXNXLXSXFXRVCXEVIVJXLXFVKVLVMVRVNVRW
      TXFBXBEBXBVOZBEVOBXEDRBXBFIXTVPBRVOBDVOVQBUAVSWSXEDRWRXBFVTWAWBWCWDLWEAFX
      JSWOHPQZSWPWQSNAWOWFWIWJQZPQZYAADTSWOYCSMDWGVJHYBPJWHWKWOFGHWLWMWN $.
  $}

  ${
    $d k A $.  $d k B $.  $d k ph $.
    sumpair.1 $e |- ( ph -> F/_ k D ) $.
    sumpair.3 $e |- ( ph -> F/_ k E ) $.
    sumupair.1 $e |- ( ph -> A e. V ) $.
    sumupair.2 $e |- ( ph -> B e. W ) $.
    sumupair.3 $e |- ( ph -> D e. CC ) $.
    sumupair.4 $e |- ( ph -> E e. CC ) $.
    sumupair.5 $e |- ( ph -> A =/= B ) $.
    sumupair.8 $e |- ( ( ph /\ k = A ) -> C = D ) $.
    sumupair.9 $e |- ( ( ph /\ k = B ) -> C = E ) $.
    $( Sum of two distinct complex values.  The class expression for ` A ` and
       ` B ` normally contain free variable ` k ` to index it.  (Contributed by
       Glauco Siliprandi, 20-Apr-2017.) $)
    sumpair $p |- ( ph -> sum_ k e. { A , B } C = ( D + E ) ) $=
      ( wcel cc cpr csu csn caddc co wne cin wceq disjsn2 syl cun df-pr a1i cfn
      c0 prfi cv wo elpri wa adantr eqeltrd jaodan sylan2 fsumsplit nfv oveq12d
      sumsnd eqtrd ) ABCUAZDFUBBUCZDFUBZCUCZDFUBZUDUEEGUDUEAVKVMDVJFABCUFVKVMUG
      UOUHPBCUIUJVJVKVMUKUHABCULUMVJUNSABCUPUMFUQZVJSAVOBUHZVOCUHZURDTSZVOBCUSA
      VPVRVQAVPUTDETQAETSVPNVAVBAVQUTDGTRAGTSVQOVAVBVCVDVEAVLEVNGUDADEFBHJAFVFZ
      QLNVHADGFCIKVSRMOVHVGVI $.
  $}

  ${
    $d n s t T $.  $d n s F $.  $d s t J $.  $d s ph $.  $d t K $.
    rfcnnnub.1 $e |- F/_ t F $.
    rfcnnnub.2 $e |- F/ t ph $.
    rfcnnnub.3 $e |- K = ( topGen ` ran (,) ) $.
    rfcnnnub.4 $e |- ( ph -> J e. Comp ) $.
    rfcnnnub.5 $e |- T = U. J $.
    rfcnnnub.6 $e |- ( ph -> T =/= (/) ) $.
    rfcnnnub.7 $e |- C = ( J Cn K ) $.
    rfcnnnub.8 $e |- ( ph -> F e. C ) $.
    $( Given a real continuous function ` F ` defined on a compact topological
       space, there is always a natural number that is a strict upper bound of
       its range.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    rfcnnnub $p |- ( ph -> E. n e. NN A. t e. T ( F ` t ) < n ) $=
      ( vs wex wa nfcv cv cfv clt wbr wral cn wrex cr wcel cle w3a nfv syl6eleq
      ccn co evthf df-rex sylib fcnre ffvelrnda ex anim1d eximdv ralrimi 19.41v
      mpd sylanbrc df-3an exbii sylibr arch 3ad2ant1 nffv nfel1 nfra1 nfbr nfan
      simprl nf3an simpll3 simpr rsp sylc simpll1 simplrl nnred simpl2 r19.21bi
      simplrr lelttrd jca eximi syl 19.9v ) ABUAZFUBZEUAZUCUDZBDUEZEUFUGZQRZWTA
      QUAZFUBZUHUIZWPXCUJUDZBDUEZWPUHUIZBDUEZUKZQRZXAAXDXFSZXHSZQRZXJAXKQRZXHXM
      AXBDUIZXFSZQRZXNAXFQDUGXQAQBFGHDQFTIQDTBDTAQULJMKLAFCGHUNUOPOUMNUPXFQDUQU
      RAXPXKQAXOXDXFAXOXDADUHXBFACDFGHKMOPUSZUTVAVBVCVFAXGBDJAWODUIZXGADUHWOFXR
      UTVAVDXKXHQVEVGXIXLQXDXFXHVHVIVJXIWTQXIWQUFUIZWSSZERZWTXIXTXCWQUCUDZSZERZ
      YBXIYCEUFUGZYEXDXFYFXHXCEVKVLYCEUFUQURXIYDYAEXIYDYAXIYDSZXTWSXIXTYCVRYGWR
      BDXIYDBXDXFXHBBXCUHBXBFIBXBTVMZVNXEBDVOXGBDVOVSXTYCBXTBULBXCWQUCYHBUCTBWQ
      TVPVQVQYGXSWRYGXSSZWPXCWQYIXHXSXGXDXFXHYDXSVTYGXSWAXGBDWBWCXDXFXHYDXSWDYI
      WQXIXTYCXSWEWFYGXEBDXDXFXHYDWGWHXIXTYCXSWIWJVAVDWKVAVCVFWSEUFUQVJWLWMWTQW
      NUR $.
  $}

  ${
    $d k x J $.  $d k F $.  $d k G $.  $d k x K $.  $d k x X $.  $d k ph $.
    refsum2cnlem1.1 $e |- F/_ x A $.
    refsum2cnlem1.2 $e |- F/_ x F $.
    refsum2cnlem1.3 $e |- F/_ x G $.
    refsum2cnlem1.4 $e |- F/ x ph $.
    refsum2cnlem1.5 $e |- A = ( k e. { 1 , 2 } |-> if ( k = 1 , F , G ) ) $.
    refsum2cnlem1.6 $e |- K = ( topGen ` ran (,) ) $.
    refsum2cnlem1.7 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    refsum2cnlem1.8 $e |- ( ph -> F e. ( J Cn K ) ) $.
    refsum2cnlem1.9 $e |- ( ph -> G e. ( J Cn K ) ) $.
    $( This is the core Lemma for ~ refsum2cn : the sum of two continuous real
       functions (from a common topological space) is continuous.  (Contributed
       by Glauco Siliprandi, 20-Apr-2017.) $)
    refsum2cnlem1 $p |- ( ph -> ( x e. X |->
          ( ( F ` x ) + ( G ` x ) ) ) e. ( J Cn K ) ) $=
      ( c1 wceq c2 cpr cv cfv csu cmpt caddc co ccn wcel wnfc cif nfmpt1 nfcxfr
      wa cc nfcv nffv a1i ax-1cn 2cn 1ex prid1 eqid iftrue ax-mp syl5eqel eqeq1
      ifbid fvmptg sylancr syl6eq adantr fveq1d cr cuni cnf syl ctopon toponuni
      wf eqcomd cioo crn ctg unieqi uniretop eqtr4i feq23d mpbid anim1i ffvelrn
      recn 3syl eqeltrd elexi prid2 wn wne 1ne2 necomi df-ne mpbi iffalse fveq2
      adantl sumpair oveq12d eqtrd mpteq2da cfn prfi wal wral ax-gen nfeq fveq1
      a1d ralrimi mpteq12f wfn retopon eqeltri cnf2 syl3anc dffn5f sylib eqtr4d
      ffn adantlr simpr ifcl syl2anc fvmpt2 sylan9eq orcd neeq2 mpbiri mpjaodan
      wo necomd neneqd olcd elpri refsumcn eqeltrrd ) ABISUAUBZBUCZDUCZCUDZUDZD
      UEZUFBIUUHEUDZUUHFUDZUGUHZUFGHUIUHZABIUULUUOMAUUHIUJZUOZUULUUHSCUDZUDZUUH
      UACUDZUDZUGUHUUOUURSUAUUKUUTDUVBUPUPDUUTUKUURDUUHUUSDSCDCDUUGUUISTZEFULZU
      FNDUUGUVDUMUNZDSUQURDUUHUQZURUSDUVBUKUURDUUHUVADUACUVEDUAUQURUVFURUSSUPUJ
      UURUTUSUAUPUJUURVAUSUURUUTUUMUPUURUUHUUSEAUUSETUUQAUUSSSTZEFULZEASUUGUJUV
      HUUPUJUUSUVHTSUAVBVCAUVHEUUPUVGUVHETSVDUVGEFVEVFZQVGDSUVDUVHUUGUUPCUVCUVC
      UVGEFUUISSVHVINVJVKUVIVLVMVNZUURIVOEWAZUUQUOUUMVOUJUUMUPUJAUVKUUQAGVPZHVP
      ZEWAZUVKAEUUPUJZUVNQEGHUVLUVMUVLVDZUVMVDZVQVRAUVLUVMIVOEAIUVLAGIVSUDUJZIU
      VLTPIGVTVRWBZUVMVOTAUVMWCWDWEUDZVPVOHUVTOWFWGWHUSZWIWJWKIVOUUHEWLUUMWMWNW
      OUURUVBUUNUPUURUUHUVAFAUVAFTUUQAUVAUASTZEFULZFAUAUUGUJUWCUUPUJUVAUWCTSUAU
      AUPVAWPWQAUWCFUUPUWBWRZUWCFTUASWSUWDSUAWTXAUASXBXCUWBEFXDVFZRVGDUAUVDUWCU
      UGUUPCUUIUATZUVCUWBEFUUIUASVHVINVJVKUWEVLVMVNZUURIVOFWAZUUQUOUUNVOUJUUNUP
      UJAUWHUUQAUVLUVMFWAZUWHAFUUPUJZUWIRFGHUVLUVMUVPUVQVQVRAUVLUVMIVOFUVSUWAWI
      WJWKIVOUUHFWLUUNWMWNWOSUAWSZUURWTUSUVCUUKUUTTUURUVCUUHUUJUUSUUISCXEVNXFUW
      FUUKUVBTUURUWFUUHUUJUVAUUIUACXEVNXFXGUURUUTUUMUVBUUNUGUVJUWGXHXIXJABUUGUU
      KDGHIMOPUUGXKUJASUAXLUSAUUIUUGUJZUOZUUJETZBIUUKUFZUUPUJZUUJFTZAUWNUWPUWLA
      UWNUOZUWOEUUPUWRUWOBIUUMUFZEUWNUWOUWSTZAUWNIITZBXMZUUKUUMTZBIXNUWTUXABIVD
      XOZUWNUXCBIBUUJEBUUICJBUUIUQURZKXPUWNUXCUUQUUHUUJEXQXRXSBIUUKIUUMXTVKXFAE
      UWSTZUWNAEIYAZUXFAUVKUXGAUVRHVOVSUDZUJZUVOUVKPUXIAHUVTUXHOYBYCUSZQEGHIVOY
      DYEIVOEYIVRBIEKYFYGVMYHAUVOUWNQVMWOYJAUWQUWPUWLAUWQUOZUWOFUUPUXKUWOBIUUNU
      FZFUWQUWOUXLTZAUWQUXBUUKUUNTZBIXNUXMUXDUWQUXNBIBUUJFUXELXPUWQUXNUUQUUHUUJ
      FXQXRXSBIUUKIUUNXTVKXFAFUXLTZUWQAFIYAZUXOAUWHUXPAUVRUXIUWJUWHPUXJRFGHIVOY
      DYEIVOFYIVRBIFLYFYGVMYHAUWJUWQRVMWOYJUWMUVCUWNUWQYTUWFUWMUVCUOUWNUWQUWMUV
      CUUJUVDEUWMUWLUVDUUPUJZUUJUVDTZAUWLYKAUXQUWLAUVOUWJUXQQRUVCEFUUPYLYMVMDUU
      GUVDUUPCNYNYMZUVCEFVEYOYPUWMUWFUOZUWQUWNUXTUUJUVDFUWMUXRUWFUXSVMUXTUVCWRZ
      UVDFTUWFUYAUWMUWFUUISUWFSUUIUWFSUUIWSUWKWTUUIUASYQYRUUAUUBXFUVCEFXDVRXIUU
      CUWLUVCUWFYTAUUISUAUUDXFYSYSUUEUUF $.
  $}

  ${
    $d k x J $.  $d k F $.  $d k G $.  $d k x K $.  $d k x X $.  $d k ph $.
    refsum2cn.1 $e |- F/_ x F $.
    refsum2cn.2 $e |- F/_ x G $.
    refsum2cn.3 $e |- F/ x ph $.
    refsum2cn.4 $e |- K = ( topGen ` ran (,) ) $.
    refsum2cn.5 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    refsum2cn.6 $e |- ( ph -> F e. ( J Cn K ) ) $.
    refsum2cn.7 $e |- ( ph -> G e. ( J Cn K ) ) $.
    $( The sum of two continuus real functions (from a common topological
       space) is continuous.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    refsum2cn $p |- ( ph
        -> ( x e. X |-> ( ( F ` x ) + ( G ` x ) ) ) e. ( J Cn K ) ) $=
      ( vk c1 c2 cpr cv wceq cif cmpt nfcv nfv nfif nfmpt eqid refsum2cnlem1 )
      ABOPQRZOSPTZCDUAZUBZOCDEFGBOUIUKBUIUCUJBCDUJBUDHIUEUFHIJULUGKLMNUH $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
   Finite multiplication of numbers and finite multiplication of functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d i j k z L $.  $d i j k M $.  $d j k l A $.  $d j k l ph $.  $d k l B $.
    $d k K $.  $d l L $.  $d l M $.  $d z B $.
    fmul01.1 $e |- F/_ i B $.
    fmul01.2 $e |- F/ i ph $.
    fmul01.3 $e |- A = seq L ( x. , B ) $.
    fmul01.4 $e |- ( ph -> L e. ZZ ) $.
    fmul01.5 $e |- ( ph -> M e. ( ZZ>= ` L ) ) $.
    fmul01.6 $e |- ( ph -> K e. ( L ... M ) ) $.
    fmul01.7 $e |- ( ( ph /\ i e. ( L ... M ) ) -> ( B ` i ) e. RR ) $.
    fmul01.8 $e |- ( ( ph /\ i e. ( L ... M ) ) -> 0 <_ ( B ` i ) ) $.
    fmul01.9 $e |- ( ( ph /\ i e. ( L ... M ) ) -> ( B ` i ) <_ 1 ) $.
    $( Multiplying a finite number of values in [ 0 , 1 ] , gives the final
       product itself a number in [ 0 , 1 ].  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    fmul01 $p |- ( ph -> ( 0 <_ ( A ` K ) /\ ( A ` K ) <_ 1 ) ) $=
      ( wcel cc0 cle c1 vk vj vl cfz co cfv wbr wa cv caddc fveq2 breq2d breq1d
      wi wceq anbi12d imbi2d cuz zred leidd cz wb eluzelz syl eluz syl2anc elfz
      mpbid syl3anc mpbir2and id jca nfcv nfv nfan nffv nfbr nfim eleq1 imbi12d
      anbi2d vtoclgf sylc cmul cseq fveq1i seq1 syl5eq breqtrrd eqbrtrd a1i w3a
      cfzo elfzouz 3ad2ant1 simpl3 wss elfzouz2 fzss2 sselda nfel1 eleq1d chvar
      cr remulcl adantl seqcl simp3 fzofzp1 anabsi7 pm3.35 ancoms simpl 3adant1
      syl6breq simp1 mulge0d seqp1 syl6breqr remulcld 1re recnd mulid1d breqtrd
      lemul2ad simp2 simprd syl5eqbrr letrd syl5eqbr 3exp fzind2 mpcom ) EFGUDU
      EZQAREBUFZSUGZYOTSUGZUHZMARUAUIZBUFZSUGZYTTSUGZUHZUNARFBUFZSUGZUUDTSUGZUH
      ZUNZARUBUIZBUFZSUGZUUJTSUGZUHZUNZARUUITUJUEZBUFZSUGZUUPTSUGZUHZUNAYRUNUAU
      BEFGYSFUOZUUCUUGAUUTUUAUUEUUBUUFUUTYTUUDRSYSFBUKZULUUTYTUUDTSUVAUMUPUQYSU
      UIUOZUUCUUMAUVBUUAUUKUUBUULUVBYTUUJRSYSUUIBUKZULUVBYTUUJTSUVCUMUPUQYSUUOU
      OZUUCUUSAUVDUUAUUQUUBUURUVDYTUUPRSYSUUOBUKZULUVDYTUUPTSUVEUMUPUQYSEUOZUUC
      YRAUVFUUAYPUUBYQUVFYTYORSYSEBUKZULUVFYTYOTSUVGUMUPUQUUHGFURUFZQZAUUEUUFAR
      FCUFZUUDSAFYNQZAUVKUHZRUVJSUGZAUVKFFSUGZFGSUGZAFAFKUSUTAUVIUVOLAFVAQZGVAQ
      ZUVIUVOVBKAUVIUVQLFGVCVDZFGVEVFVHAUVPUVPUVQUVKUVNUVOUHVBKKUVRFFGVGVIVJZAA
      UVKAVKUVSVLZADUIZYNQZUHZRUWACUFZSUGZUNZUVLUVMUNDFYNDFVMZUVLUVMDAUVKDIUVKD
      VNVOZDRUVJSDRVMZDSVMZDFCHUWGVPZVQVRUWAFUOZUWCUVLUWEUVMUWLUWBUVKAUWAFYNVSW
      AZUWLUWDUVJRSUWAFCUKZULVTOWBWCAUUDFWDCFWEZUFZUVJFBUWOJWFAUVPUWPUVJUOKWDCF
      WGVDWHZWIAUUDUVJTSUWQAUVKUVLUVJTSUGZUVSUVTUWCUWDTSUGZUNZUVLUWRUNDFYNUWGUV
      LUWRDUWHDUVJTSUWKUWJDTVMZVQVRUWLUWCUVLUWSUWRUWMUWLUWDUVJTSUWNUMVTPWBWCWJV
      LWKUUIFGWMUEQZUUNAUUSUXBUUNAWLZUUQUURUXCRUUOUWOUFZUUPSUXCRUUIUWOUFZUUOCUF
      ZWDUEZUXDSUXCUXEUXFUXCUAUCWDXDCFUUIUXBUUNUUIUVHQZAUUIFGWNWOZUXCYSFUUIUDUE
      ZQZUHAYSYNQZYSCUFZXDQZUXBUUNAUXKWPUXCUXJYNYSUXBUUNUXJYNWQZAUXBGUUIURUFQUX
      OUUIFGWRUUIFGWSVDWOWTUWCUWDXDQZUNZAUXLUHZUXNUNDUAUXRUXNDAUXLDIUXLDVNVODUX
      MXDDYSCHDYSVMVPXAVRUWAYSUOZUWCUXRUXPUXNUXSUWBUXLAUWAYSYNVSWAUXSUWDUXMXDUW
      AYSCUKXBVTNXCVFYSXDQUCUIZXDQUHYSUXTWDUEXDQUXCYSUXTXEXFXGZUXCAUUOYNQZUXFXD
      QZUXBUUNAXHZUXBUUNUYBAFGUUIXIZWOZAUYBUYCUXQAUYBUHZUYCUNDUUOYNDUUOVMZUYGUY
      CDAUYBDIUYBDVNVOZDUXFXDDUUOCHUYHVPZXAVRUWAUUOUOZUWCUYGUXPUYCUYKUWBUYBAUWA
      UUOYNVSWAZUYKUWDUXFXDUWAUUOCUKZXBVTNWBXJVFZUXCRUUJUXESUUNAUUKUXBUUNAUHUUM
      UUKAUUNUUMAUUMXKZXLUUKUULXMVDXNUUIBUWOJWFZXOZUXCAUXBRUXFSUGZUYDUXBUUNAXPA
      UXBUHZUYBUYGUYRUXBUYBAUYEXFZUYSAUYBAUXBXMUYTVLUWFUYGUYRUNDUUOYNUYHUYGUYRD
      UYIDRUXFSUWIUWJUYJVQVRUYKUWCUYGUWEUYRUYLUYKUWDUXFRSUYMULVTOWBWCVFXQUXCUXH
      UXDUXGUOUXIWDCFUUIXRVDZWIUUOBUWOJWFZXSUXCUUPUXDTSVUBUXCUXDUXGTSVUAUXCUXGU
      XETUXCUXEUXFUYAUYNXTUYATXDQUXCYAWKZUXCUXGUXETWDUEUXESUXCUXFTUXEUYNVUCUYAU
      YQUXCUYBUYGUXFTSUGZUYFUXCAUYBUYDUYFVLUWTUYGVUDUNDUUOYNUYHUYGVUDDUYIDUXFTS
      UYJUWJUXAVQVRUYKUWCUYGUWSVUDUYLUYKUWDUXFTSUYMUMVTPWBWCYEUXCUXEUXCUXEUYAYB
      YCYDUXCUXEUUJTSUYPUXCAUUNUULUYDUXBUUNAYFAUUNUHUUKUULUYOYGVFYHYIWJYJVLYKYL
      YM $.
  $}

  ${
    $d f g h l t T $.  $d f g h l Y $.  $d f g h l ph $.  $d h N $.
    $d h l P $.  $d h l U $.
    fmulcl.1 $e |- P = ( f e. Y , g e. Y |-> ( t e. T |-> ( ( f ` t ) x. ( g `
                   t ) ) ) ) $.
    fmulcl.2 $e |- X = ( seq 1 ( P , U ) ` N ) $.
    fmulcl.4 $e |- ( ph -> N e. ( 1 ... M ) ) $.
    fmulcl.5 $e |- ( ph -> U : ( 1 ... M ) --> Y ) $.
    fmulcl.6 $e |- ( ( ph /\ f e. Y /\ g e. Y ) -> ( t e. T |-> ( ( f ` t ) x.
                   ( g ` t ) ) ) e. Y ) $.
    fmulcl.7 $e |- ( ph -> T e. _V ) $.
    $( If ' Y ' is closed under the multiplication of two functions, then Y is
       closed under the multiplication ( ' X ' ) of a finite number of
       functions.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fmulcl $p |- ( ph -> X e. Y ) $=
      ( c1 cfv wcel vh vl cseq cfz co cuz elfzuz syl cv wss elfzuz3 3syl sselda
      fzss2 fnvinran syldan wa cmul cmpt wceq simprl simprr adantr mptexg fveq1
      cvv oveqan12d mpteq2dv ovmpt2ga syl3anc w3a 3simpc wi eleq1 oveq1d eleq1d
      3anbi2d imbi12d 3anbi3d oveq2d vtocl2g mpcom 3expb eqeltrd seqcl syl5eqel
      ) AJICERUCSKMAUAUBCKERIAIRHUDUEZTZIRUFSTNIRHUGUHAUAUIZRIUDUEZTWIWGTWIESKT
      AWJWGWIAWHHIUFSTWJWGUJNIRHUKIRHUNULUMAWGKWIEOUOUPAWIKTZUBUIZKTZUQZUQZWIWL
      CUEZBDBUIZWISZWQWLSZURUEZUSZKWOWKWMXAVFTZWPXAUTAWKWMVAAWKWMVBWODVFTZXBAXC
      WNQVCBDWTVFVDUHFGWIWLKKBDWQFUIZSZWQGUIZSZURUEZUSZXACVFXDWIUTZXFWLUTZUQBDX
      HWTXJXKXEWRXGWSURWQXDWIVEZWQXFWLVEZVGVHLVIVJAWKWMXAKTZWNAWKWMVKZXNAWKWMVL
      AXDKTZXFKTZVKZXIKTZVMAWKXQVKZBDWRXGURUEZUSZKTZVMXOXNVMFGWIWLKKXJXRXTXSYCX
      JXPWKAXQXDWIKVNVQXJXIYBKXJBDXHYAXJXEWRXGURXLVOVHVPVRXKXTXOYCXNXKXQWMAWKXF
      WLKVNVSXKYBXAKXKBDYAWTXKXGWSWRURXMVTVHVPVRPWAWBWCWDWEWF $.
  $}

  ${
    $d f g h l t z T $.  $d f h l t z N $.  $d f h l t z U $.
    $d f g h l z Y $.  $d h l z P $.  $d h l ph $.  $d i j t z U $.
    $d i j M $.  $d j t z N $.  $d j t z T $.  $d j ph $.
    fmuldfeqlem1.1 $e |- F/ f ph $.
    fmuldfeqlem1.2 $e |- F/ g ph $.
    fmuldfeqlem1.3 $e |- F/_ t Y $.
    fmuldfeqlem1.5 $e |- P = ( f e. Y , g e. Y |-> ( t e. T |-> ( ( f ` t ) x.
                         ( g ` t ) ) ) ) $.
    fmuldfeqlem1.6 $e |- F = ( t e. T |-> ( i e. ( 1 ... M ) |-> ( ( U ` i ) `
                         t ) ) ) $.
    fmuldfeqlem1.7 $e |- ( ph -> T e. _V ) $.
    fmuldfeqlem1.8 $e |- ( ph -> U : ( 1 ... M ) --> Y ) $.
    fmuldfeqlem1.9 $e |- ( ( ph /\ f e. Y /\ g e. Y ) -> ( t e. T |-> ( ( f ` t
                         ) x. ( g ` t ) ) ) e. Y ) $.
    fmuldfeqlem1.10 $e |- ( ph -> N e. ( 1 ... M ) ) $.
    fmuldfeqlem1.11 $e |- ( ph -> ( N + 1 ) e. ( 1 ... M ) ) $.
    fmuldfeqlem1.12 $e |- ( ph -> ( ( seq 1 ( P , U ) ` N ) ` t ) = ( seq 1 (
                          x. , ( F ` t ) ) ` N ) ) $.
    fmuldfeqlem1.13 $e |- ( ( ph /\ f e. Y ) -> f : T --> RR ) $.
    $( induction step for the proof of ~ fmuldfeq .  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    fmuldfeqlem1 $p |- ( ( ph /\ t e. T ) ->
          ( ( seq 1 ( P , U ) ` ( N + 1 ) ) ` t ) =
          ( seq 1 ( x. , ( F ` t ) ) ` ( N + 1 ) ) ) $=
      ( vj vh vl cv wcel wa cmul cfv c1 cseq caddc co cfz cr cmpt wceq cvv ovex
      mptex fvmpt2 mpan2 fveq2 fveq1d syl6eq adantl adantr wf ffvelrnd ancli wi
      cbvmptv nfcv nfv nfan nfim eleq1 anbi2d feq1 imbi12d sylc fnvinran fvmptd
      vtoclgf oveq2d cuz syl seqp1 cmpt2 fveq1 oveqan12d mpteq2dv cbvmpt2 eqtri
      elfzuz nfmpt1 nfmpt2 nfcxfr nfseq nffv ad2antrr ad2antlr oveq12d mpteq2da
      a1i nfeq2 eqid 3simpc nf3an 3anbi2d oveq1d eleq1d 3anbi3d vtocl2gf fmulcl
      w3a mpcom ovmpt2d eqtrd simpr nfmpt21 nfel1 nff remulcld syl2anc 3eqtr4rd
      mptexg ) ABUHZDUIZUJZKUKYKIULZUMUNZULZKUMUOUPZYNULZUKUPZYPYKYQEULZULZUKUP
      ZYQYOULZYKYQCEUMUNZULZULZYMYRUUAYPUKYMUEYQYKUEUHZEULZULZUUAUMJUQUPZYNURYL
      YNUEUUJUUIUSZUTAYLYNHUUJYKHUHZEULZULZUSZUUKYLUUOVAUIYNUUOUTHUUJUUNUMJUQVB
      VCBDUUOVAIQVDVEHUEUUJUUNUUIUULUUGUTYKUUMUUHUULUUGEVFVGVOVHVIUUGYQUTZUUIUU
      AUTYMUUPYKUUHYTUUGYQEVFVGVIAYQUUJUIYLUBVJADURYKYTAYTLUIZAUUQUJZDURYTVKZAU
      UJLYQESUBVLZAUUQUUTVMAFUHZLUIZUJZDURUVAVKZVNZUURUUSVNFYTLFYTVPUURUUSFAUUQ
      FMUUQFVQVRUUSFVQVSUVAYTUTZUVCUURUVDUUSUVFUVBUUQAUVAYTLVTWADURUVAYTWBWCUDW
      GWDWEZWFWHAUUCYSUTZYLAKUMWIULUIZUVHAKUUJUIUVIUAKUMJWRWJZUKYNUMKWKWJVJYMUU
      FYKKUUDULZULZUUAUKUPZUUBYMUUFYKBDUVMUSZULZUVMAUUFUVOUTYLAYKUUEUVNAUUEUVKY
      TCUPZUVNAUVIUUEUVPUTUVJCEUMKWKWJAUFUGUVKYTLLBDYKUFUHZULZYKUGUHZULZUKUPZUS
      ZUVNCVACUFUGLLUWBWLZUTACFGLLBDYKUVAULZYKGUHZULZUKUPZUSZWLZUWCPFGUFUGLLUWH
      UWBUFUWHVPUGUWHVPFUWBVPGUWBVPUVAUVQUTZUWEUVSUTZUJBDUWGUWAUWJUWKUWDUVRUWFU
      VTUKYKUVAUVQWMZYKUWEUVSWMZWNWOWPWQZXHUVQUVKUTZUVSYTUTZUJZUWBUVNUTAUWQBDUW
      AUVMUWOUWPBBUVQUVKBKUUDBCEUMBUMVPBCUWIPFGBLLUWHOOBDUWGWSWTXABEVPXBBKVPXCX
      IUWPBVQVRUWQYLUJUVRUVLUVTUUAUKUWOUVRUVLUTUWPYLYKUVQUVKWMXDUWPUVTUUAUTUWOY
      LYKUVSYTWMXEXFXGVIABCDEUFUGJKUVKLUWNUVKXJUASUVQLUIZUVSLUIZUJAUWRUWSXSZUWB
      LUIZAUWRUWSXKAUVBUWELUIZXSZUWHLUIZVNAUWRUXBXSZBDUVRUWFUKUPZUSZLUIZVNUWTUX
      AVNFGUVQUVSLLFUVQVPGUVQVPGUVSVPUXEUXHFAUWRUXBFMUWRFVQUXBFVQXLUXHFVQVSUWTU
      XAGAUWRUWSGNUWRGVQUWSGVQXLUXAGVQVSUWJUXCUXEUXDUXHUWJUVBUWRAUXBUVAUVQLVTXM
      UWJUWHUXGLUWJBDUWGUXFUWJUWDUVRUWFUKUWLXNWOXOWCUWKUXEUWTUXHUXAUWKUXBUWSAUW
      RUWEUVSLVTXPUWKUXGUWBLUWKBDUXFUWAUWKUWFUVTUVRUKUWMWHWOXOWCTXQXTRXRZUUTADV
      AUIUVNVAUIRBDUVMVAYJWJYAYBVGVJYMYLUVMURUIUVOUVMUTAYLYCYMUVLUUAADURYKUVKAU
      VKLUIZAUXJUJZDURUVKVKZUXIAUXJUXIVMUVEUXKUXLVNFUVKLFKUUDFCEUMFUMVPFCUWIPFG
      LLUWHYDXAFEVPXBFKVPXCZUXKUXLFAUXJFMFUVKLUXMYEVRFDURUVKUXMFDVPFURVPYFVSUVA
      UVKUTZUVCUXKUVDUXLUXNUVBUXJAUVAUVKLVTWADURUVAUVKWBWCUDWGWDWEUVGYGBDUVMURU
      VNUVNXJVDYHYBAUVMUUBUTYLAUVLYPUUAUKUCXNVJYBYI $.
  $}

  ${
    $d b k t T $.  $d b k F $.  $d b k ph $.  $d f g n t z T $.
    $d f i t z T $.  $d f g n z F $.  $d f g n z M $.  $d f g n t z U $.
    $d f g z Y $.  $d f g n ph $.  $d i k t z T $.  $d i y z $.  $d i k z M $.
    $d i t z U $.  $d m n t T $.  $d m n F $.  $d m n M $.  $d m n P $.
    $d m n t U $.  $d m n ph $.  $d z P $.
    fmuldfeq.1 $e |- F/ i ph $.
    fmuldfeq.2 $e |- F/_ t Y $.
    fmuldfeq.3 $e |- P = ( f e. Y , g e. Y |-> ( t e. T |-> ( ( f ` t ) x. ( g
                     ` t ) ) ) ) $.
    fmuldfeq.4 $e |- X = ( seq 1 ( P , U ) ` M ) $.
    fmuldfeq.5 $e |- F = ( t e. T |-> ( i e. ( 1 ... M ) |-> ( ( U ` i ) ` t )
                     ) ) $.
    fmuldfeq.6 $e |- Z = ( t e. T |-> ( seq 1 ( x. , ( F ` t ) ) ` M ) ) $.
    fmuldfeq.7 $e |- ( ph -> T e. _V ) $.
    fmuldfeq.8 $e |- ( ph -> M e. NN ) $.
    fmuldfeq.9 $e |- ( ph -> U : ( 1 ... M ) --> Y ) $.
    fmuldfeq.10 $e |- ( ( ph /\ f e. Y ) -> f : T --> RR ) $.
    fmuldfeq.11 $e |- ( ( ph /\ f e. Y /\ g e. Y ) -> ( t e. T |-> ( ( f ` t )
                      x. ( g ` t ) ) ) e. Y ) $.
    $( X and Z are two equivalent definitions of the finite product of real
       functions.  Y is a set of real functions from a common domain T, Y is
       closed under function multiplication and U is a finite sequence of
       functions in Y. M is the number of functions multiplied together.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fmuldfeq $p |- ( ( ph /\ t e. T ) -> ( X ` t ) = ( Z ` t ) ) $=
      ( vm vn vk vb cv wcel wa c1 cseq cfv cmul cfz co cle wbr nnge1d adantr cn
      wceq cr nnre leid 3syl cz wb nnzd a1i elfz syl3anc mpbir2and w3a 3ad2ant1
      1z wi caddc eleq1 3anbi3d fveq2 fveq1d eqeq12d imbi12d weq seq1 cmpt 1le1
      ax-mp nfcv nfv nfmpt1 nfmpt nfcxfr nffv nffvmpt1 nfeq nfim cvv ovex mptex
      imbi2d fvmpt2 mpan2 vtoclgf syl imp wf ffvelrnd ancli anbi2d feq1 vtoclga
      sylc ffvelrnda fvmptg syl2anc eqtrd fveq1i syl6eqr syl5req 3adant3 simp31
      eqid cuz simp1 simp33 jca elnnuz biimpi anim1i peano2fzr nfseq nf3an nfan
      simp32 adantlr simpr eqeltrd simp2 mp3and nfmpt21 nfmpt22 3adant1r simpr1
      cmpt2 simpr2 simpr3 fmuldfeqlem1 syl21anc nnind mpcom mpd3an3 sylib nfel1
      3jca 3exp eleq1d ad2antlr simpl simplr chvar remulcl adantl seqcl 3eqtr4d
      ) ABUIZDUJZUKZUVHJCEULUMZUNZUNZJUOUVHIUNZULUMZUNZUVHKUNZUVHMUNZAUVIJULJUP
      UQZUJZUVMUVPVCZUVJUVTULJURUSZJJURUSZAUWBUVIAJUAUTZVAAUWCUVIAJVBUJZJVDUJUW
      CUAJVEJVFVGVAUVJJVHUJZULVHUJZUWFUVTUWBUWCUKVIAUWFUVIAJUAVJZVAZUWGUVJVQVKU
      WIJULJVLVMVNUWEAUVIUVTVOZUWAAUVIUWEUVTUAVPAUVIUEUIZUVSUJZVOZUVHUWKUVKUNZU
      NZUWKUVOUNZVCZVRAUVIULUVSUJZVOZUVHULUVKUNZUNZULUVOUNZVCZVRAUVIUFUIZUVSUJZ
      VOZUVHUXDUVKUNZUNZUXDUVOUNZVCZVRZAUVIUXDULVSUQZUVSUJZVOZUVHUXLUVKUNZUNZUX
      LUVOUNZVCZVRUWJUWAVRUEUFJUWKULVCZUWMUWSUWQUXCUXSUWLUWRAUVIUWKULUVSVTWAUXS
      UWOUXAUWPUXBUXSUVHUWNUWTUWKULUVKWBWCUWKULUVOWBWDWEUEUFWFZUWMUXFUWQUXJUXTU
      WLUXEAUVIUWKUXDUVSVTWAUXTUWOUXHUWPUXIUXTUVHUWNUXGUWKUXDUVKWBWCUWKUXDUVOWB
      WDWEUWKUXLVCZUWMUXNUWQUXRUYAUWLUXMAUVIUWKUXLUVSVTWAUYAUWOUXPUWPUXQUYAUVHU
      WNUXOUWKUXLUVKWBWCUWKUXLUVOWBWDWEUWKJVCZUWMUWJUWQUWAUYBUWLUVTAUVIUWKJUVSV
      TWAUYBUWOUVMUWPUVPUYBUVHUWNUVLUWKJUVKWBWCUWKJUVOWBWDWEAUVIUXCUWRUVJUXBULU
      VNUNZUXAUWGUXBUYCVCVQUOUVNULWGWJUVJUYCUVHULEUNZUNZUXAUVJUYCULHUVSUVHHUIZE
      UNZUNZWHZUNZUYEAUVIUYCUYJVCZAUWRUVIUYKVRZAUWRULULURUSZUWBUYMAWIVKUWDAUWGU
      WGUWFUWRUYMUWBUKVIUWGAVQVKZUYNUWHULULJVLVMVNZUVIUYFUVNUNZUYFUYIUNZVCZVRUY
      LHULUVSHULWKZUVIUYKHUVIHWLZHUYCUYJHULUVNHUVHIHIBDUYIWHRHBDUYIHDWKHUVSUYHW
      MWNWOHUVHWKWPZUYSWPHUVSUYHULWQWRWSUYFULVCZUYRUYKUVIVUBUYPUYCUYQUYJUYFULUV
      NWBUYFULUYIWBWDXCUVIUYFUVNUYIUVIUYIWTUJUVNUYIVCHUVSUYHULJUPXAXBBDUYIWTIRX
      DXEWCZXFXGXHUVJUWRUYEVDUJUYJUYEVCAUWRUVIUYOVAADVDUVHUYDAUYDLUJZAVUDUKZDVD
      UYDXIZAUVSLULEUBUYOXJZAVUDVUGXKAFUIZLUJZUKZDVDVUHXIZVRZVUEVUFVRFUYDLVUHUY
      DVCZVUJVUEVUKVUFVUMVUIVUDAVUHUYDLVTXLDVDVUHUYDXMWEVULVUIUCVKZXNXOXPHULUYH
      UYEUVSVDUYIVUBUVHUYGUYDUYFULEWBWCUYIYEZXQXRXSUVHUWTUYDUWGUWTUYDVCVQCEULWG
      WJXTYAYBYCUXDVBUJZUXKUXNUXRVUPUXKUXNVOZAUXEUXMUXJVOZUVIUXRVUPUXKAUVIUXMYD
      ZVUQUXEUXMUXJVUQVUPUXMUKUXDULYFUNZUJZUXMUKUXEVUQVUPUXMVUPUXKUXNYGVUPUXKAU
      VIUXMYHZYIVUPVVAUXMVUPVVAUXDYJYKYLUXDULJYMVGZVVBVUQAUVIUXEUXJVUSVUPUXKAUV
      IUXMYQZVVCVUPUXKUXNUUAUUBUUQVVDAVURUKBCDEFGHIJUXDLAVURFAFWLUXEUXMUXJFUXEF
      WLUXMFWLFUXHUXIFUVHUXGFUXDUVKFCEULFULWKFCFGLLBDUVHVUHUNUVHGUIZUNUOUQWHZUU
      GZPFGLLVVFUUCWOFEWKYNFUXDWKWPFUVHWKWPFUXIWKWRYOYPAVURGAGWLUXEUXMUXJGUXEGW
      LUXMGWLGUXHUXIGUVHUXGGUXDUVKGCEULGULWKGCVVGPFGLLVVFUUDWOGEWKYNGUXDWKWPGUV
      HWKWPGUXIWKWRYOYPOPRADWTUJVURTVAAUVSLEXIVURUBVAAVUIVVELUJVVFLUJVURUDUUEAU
      XEUXMUXJUUFAUXEUXMUXJUUHAUXEUXMUXJUUIAVUIVUKVURUCYRUUJUUKUURUULUUMUUNUVQU
      VMVCUVJUVHKUVLQXTVKUVJUVIUVPVDUJUVRUVPVCAUVIYSUVJUGUHUOVDUVNULJAJVUTUJZUV
      IAUWEVVHUAJYJUUOVAUVJUYFUVSUJZUKZUYPVDUJZVRUVJUGUIZUVSUJZUKZVVLUVNUNZVDUJ
      ZVRHUGVVNVVPHUVJVVMHAUVIHNUYTYPVVMHWLYPHVVOVDHVVLUVNVUAHVVLWKWPUUPWSHUGWF
      ZVVJVVNVVKVVPVVQVVIVVMUVJUYFVVLUVSVTXLVVQUYPVVOVDUYFVVLUVNWBUUSWEVVJUYPUY
      QVDUVIUYRAVVIVUCUUTVVJUYQUYHVDVVJVVIUYHVDUJUYQUYHVCUVJVVIYSVVJDVDUVHUYGAV
      VIDVDUYGXIZUVIAVVIUKZUYGLUJZAVVTUKZVVRAUVSLUYFEUBXPZVVSAVVTAVVIUVAVWBYIVU
      LVWAVVRVRFUYGLVUHUYGVCZVUJVWAVUKVVRVWCVUIVVTAVUHUYGLVTXLDVDVUHUYGXMWEVUNX
      NXOYRAUVIVVIUVBXJZHUVSUYHVDUYIVUOXDXRVWDYTYTUVCVVLVDUJUHUIZVDUJUKVVLVWEUO
      UQVDUJUVJVVLVWEUVDUVEUVFBDUVPVDMSXDXRUVG $.
  $}

  ${
    $d i j z L $.  $d i j M $.  $d j k l B $.  $d j k l ph $.  $d k l L $.
    $d k l M $.  $d z B $.
    fmul01lt1lem1.1 $e |- F/_ i B $.
    fmul01lt1lem1.2 $e |- F/ i ph $.
    fmul01lt1lem1.3 $e |- A = seq L ( x. , B ) $.
    fmul01lt1lem1.4 $e |- ( ph -> L e. ZZ ) $.
    fmul01lt1lem1.5 $e |- ( ph -> M e. ( ZZ>= ` L ) ) $.
    fmul01lt1lem1.6 $e |- ( ( ph /\ i e. ( L ... M ) ) -> ( B ` i ) e. RR ) $.
    fmul01lt1lem1.7 $e |- ( ( ph /\ i e. ( L ... M ) ) -> 0 <_ ( B ` i ) ) $.
    fmul01lt1lem1.8 $e |- ( ( ph /\ i e. ( L ... M ) ) -> ( B ` i ) <_ 1 ) $.
    fmul01lt1lem1.9 $e |- ( ph -> E e. RR+ ) $.
    fmul01lt1lem1.10 $e |- ( ph -> ( B ` L ) < E ) $.
    $( Given a finite multiplication of values betweeen 0 and 1, a value larger
       than its frist element is larger the whole multiplication.  (Contributed
       by Glauco Siliprandi, 20-Apr-2017.) $)
    fmul01lt1lem1 $p |- ( ph -> ( A ` M ) < E ) $=
      ( wbr wcel adantr vj vk vl wceq cfv clt cmul cseq simpr fveq2d a1i fveq1d
      wa cz seq1 syl 3eqtrd eqbrtrd wn wne df-ne sylibr cr cle w3a zred eluzelz
      wb eluzle 3jca leltne mpbird fveq1i c1 caddc co cv remulcl adantl cc recn
      cuz 3ad2ant1 3ad2ant2 3ad2ant3 mulassd wo olcd jca lttri2 neneqd uzp1 ord
      mpd uzid cfz wi nfv nfan nfcv nffv nfel1 nfim eleq1 anbi2d eleq1d imbi12d
      fveq2 chvar adantlr seqsplit eluzfz1 ancli vtoclgf eqeltrd peano2re lep1d
      sylc elfzelz elfzle1 letrd elfz2 sylanbrc syldan seqcl remulcld rpred 1re
      elfzle2 nfbr breq2d breqtrrd eqid peano2zd gtned zltp1le syl2anc ad2antrr
      cc0 orel1 mpbid leidd simpll fmul01 simprd lemul2ad recnd mulid1d breqtrd
      lelttrd syl5eqbr pm2.61dan ) AGFUDZGBUEZEUFRZAUUMUMZUUNFCUEZEUFUUPUUNFBUE
      FUGCFUHZUEZUUQUUPGFBAUUMUIUJUUPFBUURBUURUDUUPJUKULAUUSUUQUDZUUMAFUNSZUUTK
      UGCFUOUPZTUQAUUQEUFRUUMQTURAUUMUSZFGUFRZUUOAUVCUMZUVDGFUTZUVEUVCUVFAUVCUI
      GFVAVBUVEFVCSZGVCSZFGVDRZVEZUVDUVFVHAUVJUVCAUVGUVHUVIAFKVFZAGAGFWBUEZSZGU
      NSZLFGVGUPZVFZAUVMUVILFGVIUPVJTFGVKUPVLAUVDUMZUUNGUURUEZEUFGBUURJVMUVQUVR
      UUSGUGCFVNVOVPZUHZUEZUGVPZEUFUVQUAUBUCUGVCCFFGUAVQZVCSZUBVQZVCSZUMUWCUWEU
      GVPZVCSUVQUWCUWEVRVSZUWDUWFUCVQZVCSZVEZUWGUWIUGVPUWCUWEUWIUGVPUGVPUDUVQUW
      KUWCUWEUWIUWDUWFUWCVTSUWJUWCWAWCUWFUWDUWEVTSUWJUWEWAWDUWJUWDUWIVTSUWFUWIW
      AWEWFVSUVQUVCGUVSWBUESZUVQGFUVQUVFGFUFRZUVDWGZUVQUVDUWMAUVDUIZWHUVQUVHUVG
      UMZUVFUWNVHAUWPUVDAUVHUVGUVPUVKWITGFWJUPVLWKUVQUUMUWLAUUMUWLWGZUVDAUVMUWQ
      LFGWLZUPTWMWNZUVQUVAFUVLSAUVAUVDKTZFWOUPAUWCFGWPVPZSZUWCCUEZVCSZUVDADVQZU
      XASZUMZUXECUEZVCSZWQZAUXBUMZUXDWQDUAUXKUXDDAUXBDIUXBDWRWSDUXCVCDUWCCHDUWC
      WTXAXBXCUXEUWCUDZUXGUXKUXIUXDUXLUXFUXBAUXEUWCUXAXDXEUXLUXHUXCVCUXEUWCCXHX
      FXGMXIZXJXKUVQUWBUUSEUVQUUSUWAAUUSVCSUVDAUUSUUQVCUVBAFUXASZAUXNUMZUUQVCSZ
      AUVMUXNLFGXLUPZAUXNUXQXMZUXJUXOUXPWQDFUXADFWTZUXOUXPDAUXNDIUXNDWRWSZDUUQV
      CDFCHUXSXAZXBXCUXEFUDZUXGUXOUXIUXPUYBUXFUXNAUXEFUXAXDXEZUYBUXHUUQVCUXEFCX
      HZXFXGMXNXRXOZTZUVQUAUBUGVCCUVSGUWSAUWCUVSGWPVPZSZUXDUVDAUYHUXBUXDAUYHUMZ
      UVAUVNUWCUNSZVEFUWCVDRZUWCGVDRZUMUXBUYIUVAUVNUYJAUVAUYHKTAUVNUYHUVOTUYHUY
      JAUWCUVSGXSZVSVJUYIUYKUYLUYIFUVSUWCAUVGUYHUVKTAUVSVCSZUYHAUVGUYNUVKFXPZUP
      ZTUYHUWDAUYHUWCUYMVFVSAFUVSVDRZUYHAFUVKXQZTUYHUVSUWCVDRAUWCUVSGXTVSYAUYHU
      YLAUWCUVSGYIVSWIUWCFGYBYCUXMYDXJUWHYEZYFUYFAEVCSUVDAEPYGTUVQUWBUUSVNUGVPZ
      UUSVDUVQUWAVNUUSUYSVNVCSUVQYHUKUYFAYSUUSVDRUVDAYSUUQUUSVDAUXNUXOYSUUQVDRZ
      UXQUXRUXGYSUXHVDRZWQUXOVUAWQDFUXAUXSUXOVUADUXTDYSUUQVDDYSWTDVDWTUYAYJXCUY
      BUXGUXOVUBVUAUYCUYBUXHUUQYSVDUYDYKXGNXNXRUVBYLTUVQYSUWAVDRUWAVNVDRUVQUVTC
      DGUVSGHAUVDDIUVDDWRWSUVTYMAUVSUNSZUVDAFKYNTZUVQUVCUWQUWLUVQGFUVQFGAUVGUVD
      UVKTUWOYOWKUVQUVMUWQAUVMUVDLTUWRUPUUMUWLYTXRUVQVUCUVNUVNVEUVSGVDRZGGVDRZU
      MGUYGSUVQVUCUVNUVNVUDAUVNUVDUVOTZVUGVJUVQVUEVUFUVQUVDVUEUWOUVQUVAUVNUVDVU
      EVHUWTVUGFGYPYQUUAUVQGAUVHUVDUVPTUUBWIGUVSGYBYCAUXEUYGSZUXIUVDAVUHUXFUXIA
      VUHUMZUVAUVNUXEUNSZVEZFUXEVDRZUXEGVDRZUMZUXFVUIUVAUVNVUJAUVAVUHKTAUVNVUHU
      VOTVUHVUJAUXEUVSGXSZVSVJVUIVULVUMVUIFUVSUXEAUVGVUHUVKTZVUIUVGUYNVUPUYOUPV
      UHUXEVCSZAVUHUXEVUOVFZVSAUYQVUHUYRTVUHUVSUXEVDRZAUXEUVSGXTZVSYAVUHVUMAUXE
      UVSGYIZVSWIUXEFGYBZYCMYDXJUVQVUHUMZAUXFVUBAUVDVUHUUCZVVCVUKVUNUXFVVCUVAUV
      NVUJAUVAUVDVUHKYRAUVNUVDVUHUVOYRVUHVUJUVQVUOVSVJVVCVULVUMVVCFUVSUXEAUVGUV
      DVUHUVKYRAUYNUVDVUHUYPYRVUHVUQUVQVURVSAUYQUVDVUHUYRYRVUHVUSUVQVUTVSYAVUHV
      UMUVQVVAVSWIVVBYCZNYQVVCAUXFUXHVNVDRVVDVVEOYQUUDUUEUUFAUYTUUSUDUVDAUUSAUU
      SUYEUUGUUHTUUIAUUSEUFRUVDAUUSUUQEUFUVBQURTUUJURUUKYDUUL $.
  $}

  ${
    $d a b c B $.  $d a i z J $.  $d a j B $.  $d a b c L $.  $d a b c M $.
    $d a b c ph $.  $d b c J $.  $d i z L $.  $d i M $.  $d j J $.  $d j L $.
    $d j ph $.  $d z B $.
    fmul01lt1lem2.1 $e |- F/_ i B $.
    fmul01lt1lem2.2 $e |- F/ i ph $.
    fmul01lt1lem2.3 $e |- A = seq L ( x. , B ) $.
    fmul01lt1lem2.4 $e |- ( ph -> L e. ZZ ) $.
    fmul01lt1lem2.5 $e |- ( ph -> M e. ( ZZ>= ` L ) ) $.
    fmul01lt1lem2.6 $e |- ( ( ph /\ i e. ( L ... M ) ) -> ( B ` i ) e. RR ) $.
    fmul01lt1lem2.7 $e |- ( ( ph /\ i e. ( L ... M ) ) -> 0 <_ ( B ` i ) ) $.
    fmul01lt1lem2.8 $e |- ( ( ph /\ i e. ( L ... M ) ) -> ( B ` i ) <_ 1 ) $.
    fmul01lt1lem2.9 $e |- ( ph -> E e. RR+ ) $.
    fmul01lt1lem2.10 $e |- ( ph -> J e. ( L ... M ) ) $.
    fmul01lt1lem2.11 $e |- ( ph -> ( B ` J ) < E ) $.
    $( Given a finite multiplication of values betweeen 0 and 1, a value ` E `
       larger than any multiplicand, is larger than the whole multiplication.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fmul01lt1lem2 $p |- ( ph -> ( A ` M ) < E ) $=
      ( wcel va vj vb vc wceq cfv clt wbr wa nfv nfan cz adantr cuz cfz adantlr
      cv co cr cc0 cle crp simpr fveq2d eqbrtrrd fmul01lt1lem1 cmul cseq fveq1i
      c1 wn nfcv nffv nfel1 nfim eleq1 anbi2d fveq2 eleq1d imbi12d chvar adantl
      remulcl seqcl elfzuz3 syl eluzelz elfzelz 3jca zred elfzle1 letrd elfzle2
      wi w3a jca elfz2 sylanbrc syldan rpred cmin caddc simp1 recnd simp2 simp3
      mulassd zcnd cc ax-1cn a1i npcand eleqtrrd 1z zsubcld eqcom sylnib leloed
      wo mpbid orel2 wb zltlem1 syl2anc eluz2 syl3anbrc seqsplit seqeq1d fveq1d
      sylc oveq2d eqtrd 1re resubcld lem1d eqid eluzfz2 fmul01 simpld letr
      simprd lemul1ad eqbrtrd mulid2d breqtrd lelttrd syl5eqbr pm2.61dan ) AFGU
      EZHBUFZEUGUHAUUIUIZBCDEGHIAUUIDJUUIDUJUKKAGULTZUUILUMAHGUNUFZTZUUIMUMADUQ
      ZGHUOURZTZUUOCUFZUSTZUUINUPAUUQUTUURVAUHZUUIOUPAUUQUURVJVAUHZUUIPUPAEVBTU
      UIQUMUUKFCUFZGCUFEUGUUKFGCAUUIVCVDAUVBEUGUHUUISUMVEVFAUUIVKZUIZUUJHVGCGVH
      ZUFZEUGHBUVEKVIUVDUVFHVGCFVHZUFZEAUVFUSTUVCAUAUBVGUSCGHMAUUQUIZUUSWNAUAUQ
      ZUUPTZUIZUVJCUFZUSTZWNDUAUVLUVNDAUVKDJUVKDUJZUKDUVMUSDUVJCIDUVJVLVMVNZVOU
      UOUVJUEZUVIUVLUUSUVNUVQUUQUVKAUUOUVJUUPVPZVQUVQUURUVMUSUUOUVJCVRVSZVTNWAU
      VJUSTZUBUQZUSTUIZUVJUWAVGURUSTZAUVJUWAWCZWBZWDUMAUVHUSTUVCAUAUBVGUSCFHAFU
      UPTZHFUNUFZTZRFGHWEWFZAUUOFHUOURZTZUIZUUSWNAUVJUWJTZUIZUVNWNDUAUWNUVNDAUW
      MDJUWMDUJUKUVPVOUVQUWLUWNUUSUVNUVQUWKUWMAUUOUVJUWJVPVQUVSVTAUWKUUQUUSUWLU
      ULHULTZUUOULTZWOZGUUOVAUHZUUOHVAUHZUIZUUQUWLUULUWOUWPAUULUWKLUMAUWOUWKAUU
      NUWOMGHWGWFZUMUWKUWPAUUOFHWHZWBWIUWLUWRUWSUWLGFUUOAGUSTUWKAGLWJZUMAFUSTZU
      WKAFAUWFFULTZRFGHWHWFZWJZUMUWKUUOUSTZAUWKUUOUXBWJWBAGFVAUHZUWKAUWFUXIRFGH
      WKWFZUMUWKFUUOVAUHAUUOFHWKWBWLUWKUWSAUUOFHWMWBWPUUOGHWQZWRZNWSZWAUWEWDUMZ
      AEUSTUVCAEQWTUMUVDUVFVJUVHVGURZUVHVAUVDUVFFVJXAURZUVEUFZUVHVGURZUXOVAUVDU
      VFUXQHVGCUXPVJXBURZVHZUFZVGURUXRUVDUAUCUDVGUSCGUXPHUVTUCUQZUSTZUIUVJUYBVG
      URZUSTUVDUVJUYBWCWBUVTUYCUDUQZUSTZWOZUYDUYEVGURUVJUYBUYEVGURVGURUEUVDUYGU
      VJUYBUYEUYGUVJUVTUYCUYFXCXDUYGUYBUVTUYCUYFXEXDUYGUYEUVTUYCUYFXFXDXGWBAHUX
      SUNUFZTUVCAHUWGUYHUWIAUXSFUNAFVJAFUXFXHVJXITAXJXKXLZVDXMUMUVDUULUXPULTZGU
      XPVAUHZUXPUUMTAUULUVCLUMZUVDFVJAUXEUVCUXFUMZVJULTZUVDXNXKXOUVDGFUGUHZUYKU
      VDGFUEZVKUYOUYPXSZUYOUVDUUIUYPAUVCVCFGXPXQAUYQUVCAUXIUYQUXJAGFUXCUXGXRXTU
      MUYPUYOYAYJAUYOUYKYBZUVCAUULUXEUYRLUXFGFYCYDUMXTZGUXPYEYFZUVDUUQUIZUUSWNU
      VDUVKUIZUVNWNDUAVUBUVNDUVDUVKDAUVCDJUVCDUJUKZUVOUKUVPVOUVQVUAVUBUUSUVNUVQ
      UUQUVKUVDUVRVQUVSVTAUUQUUSUVCNUPZWAYGUVDUYAUVHUXQVGUVDHUXTUVGUVDUXSFVGCAU
      XSFUEUVCUYIUMYHYIYKYLUVDUXQVJUVHUVDUAUBVGUSCGUXPUYTUVDUUOGUXPUOURZTZUIZUU
      SWNUVDUVJVUETZUIZUVNWNDUAVUIUVNDUVDVUHDVUCVUHDUJUKUVPVOUVQVUGVUIUUSUVNUVQ
      VUFVUHUVDUUOUVJVUEVPVQUVSVTAVUFUUSUVCAVUFUUQUUSAVUFUIZUWQUWTUUQVUJUULUWOU
      WPAUULVUFLUMAUWOVUFUXAUMVUFUWPAUUOGUXPWHZWBWIVUJUWRUWSVUFUWRAUUOGUXPWKWBV
      UJUUOFHVUFUXHAVUFUUOVUKWJWBZAUXDVUFUXGUMZAHUSTZVUFAHUXAWJZUMVUJUUOUXPFVUL
      AUXPUSTZVUFAFVJUXGVJUSTZAYMXKYNZUMVUMVUFUUOUXPVAUHAUUOGUXPWMWBAUXPFVAUHZV
      UFAFUXGYOUMWLAFHVAUHZVUFAUWFVUTRFGHWMWFZUMWLWPUXKWRNWSUPWAUWBUWCUVDUWDWBW
      DVUQUVDYMXKUXNUVDUTUVHVAUHUVHVJVAUHUVDUVGCDHFHIVUCUVGYPZUYMAUWHUVCUWIUMAH
      UWJTZUVCAUWHVVCUWIFHYQWFUMAUWKUUSUVCUXMUPAUWKUUTUVCAUWKUUQUUTUXLOWSZUPAUW
      KUVAUVCAUWKUUQUVAUXLPWSZUPYRYSUVDUTUXQVAUHUXQVJVAUHUVDUVECDUXPGHIVUCUVEYP
      UYLAUUNUVCMUMUVDUULUWOUYJWOZUYKUXPHVAUHZUIUXPUUPTAVVFUVCAUULUWOUYJLUXAAFV
      JUXFUYNAXNXKXOWIUMUVDUYKVVGUYSUVDVUPUXDVUNWOZVUSVUTUIVVGAVVHUVCAVUPUXDVUN
      VURUXGVUOWIUMUVDVUSVUTUVDFAUXDUVCUXGUMYOAVUTUVCVVAUMWPUXPFHYTYJWPUXPGHWQW
      RVUDAUUQUUTUVCOUPAUUQUVAUVCPUPYRUUAUUBUUCUVDUVHUVDUVHUXNXDUUDUUEAUVHEUGUH
      UVCAUVGCDEFHIJVVBUXFUWIUXMVVDVVEQSVFUMUUFUUGUUH $.
  $}

  ${
    $d i j z E $.  $d i j z M $.  $d j ph $.  $d z A $.  $d z B $.
    fmul01lt1.1 $e |- F/_ i B $.
    fmul01lt1.2 $e |- F/ i ph $.
    fmul01lt1.3 $e |- F/_ j A $.
    fmul01lt1.4 $e |- A = seq 1 ( x. , B ) $.
    fmul01lt1.5 $e |- ( ph -> M e. NN ) $.
    fmul01lt1.6 $e |- ( ph -> B : ( 1 ... M ) --> RR ) $.
    fmul01lt1.7 $e |- ( ( ph /\ i e. ( 1 ... M ) ) -> 0 <_ ( B ` i ) ) $.
    fmul01lt1.8 $e |- ( ( ph /\ i e. ( 1 ... M ) ) -> ( B ` i ) <_ 1 ) $.
    fmul01lt1.9 $e |- ( ph -> E e. RR+ ) $.
    fmul01lt1.10 $e |- ( ph -> E. j e. ( 1 ... M ) ( B ` j ) < E ) $.
    $( Given a finite multiplication of values betweeen 0 and 1, a value E
       larger than any multiplicand, is larger than the whole multiplication.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    fmul01lt1 $p |- ( ph -> ( A ` M ) < E ) $=
      ( clt nfcv wcel cv cfv wbr c1 cfz co wrex nfv nffv nfbr w3a nf3an a1i cuz
      cz 1z cn elnnuz sylib 3ad2ant1 fnvinran 3ad2antl1 cc0 cle crp simp2 simp3
      cr fmul01lt1lem2 3exp rexlimd mpd ) AEUAZCUBZFRUCZEUDGUEUFZUGGBUBZFRUCZQA
      VOVREVPAEUHEVQFREGBJEGSUIERSEFSUJAVMVPTZVOVRAVSVOUKZBCDFVMUDGHAVSVODIVSDU
      HDVNFRDVMCHDVMSUIDRSDFSUJULKUDUOTVTUPUMAVSGUDUNUBTZVOAGUQTWALGURUSUTAVSDU
      AZVPTZWBCUBZVHTVOAVPVHWBCMVAVBAVSWCVCWDVDUCVONVBAVSWCWDUDVDUCVOOVBAVSFVET
      VOPUTAVSVOVFAVSVOVGVIVJVKVL $.
  $}

  ${
    $d x y C $.  $d y A $.  $d y F $.
    cncfmptss.1 $e |- F/_ x F $.
    cncfmptss.2 $e |- ( ph -> F e. ( A -cn-> B ) ) $.
    cncfmptss.3 $e |- ( ph -> C C_ A ) $.
    $( A continuous complex function restricted to a subset is continuous,
       using "map to" notation.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    cncfmptss $p |- ( ph -> ( x e. C |-> ( F ` x ) ) e. ( C -cn-> B ) ) $=
      ( vy cv cfv cmpt cres ccncf co wceq syl wcel nfcv resmpt wf cncff feqmptd
      wss reseq1d nffv fveq2 cbvmpt a1i 3eqtr4rd rescncf sylc eqeltrd ) ABEBKZF
      LZMZFENZEDOPZAJCJKZFLZMZENZJEVAMZURUQAECUEZVCVDQIJCEVAUARAFVBEAJCDFAFCDOP
      SZCDFUBHCDFUCRUDUFUQVDQABJEUPVAJUOFJFTJUOTUGBUTFGBUTTUGUOUTFUHUIUJUKAVEVF
      URUSSIHCDEFULUMUN $.
  $}

  ${
    $d A x $.  $d C x $.
    fmptdf.1 $e |- F/ x ph $.
    fmptdf.2 $e |- ( ( ph /\ x e. A ) -> B e. C ) $.
    fmptdf.3 $e |- F = ( x e. A |-> B ) $.
    $( A version of ~ fmptd using bound-variable hypothesis instead of a
       distinct variable condition for ` ph ` .  (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    fmptdf $p |- ( ph -> F : A --> C ) $=
      ( wcel wral wf cv ex ralrimi fmpt sylib ) ADEJZBCKCEFLARBCGABMCJRHNOBCEDF
      IPQ $.
  $}

  $( The positive reals are a subset of the complex numbers.  (Contributed by
     Glauco Siliprandi, 29-Jun-2017.) $)
  rrpsscn $p |- RR+ C_ CC $=
    ( vx crp cc cv rpcn ssriv ) ABCADEF $.

  ${
    $d X x $.  $d ph x $.
    mulcncf.1 $e |- ( ph -> ( x e. X |-> A ) e. ( X -cn-> CC ) ) $.
    mulcncf.2 $e |- ( ph -> ( x e. X |-> B ) e. ( X -cn-> CC ) ) $.
    $( The multiplication of two continuous complex functions is continuous.
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    mulcncf $p |- ( ph -> ( x e. X |-> ( A x. B ) ) e. ( X -cn-> CC ) ) $=
      ( cmul ccnfld ctopn cfv eqid ctx co ccn wcel mulcn a1i cncfmpt2f ) ABCDHI
      JKZETLZHTTMNTONPATUAQRFGS $.
  $}

  ${
    $d t x A $.  $d t x B $.  $d t F $.  $d t ph $.
    mulc1cncfg.1 $e |- F/_ x F $.
    mulc1cncfg.2 $e |- F/ x ph $.
    mulc1cncfg.3 $e |- ( ph -> F e. ( A -cn-> CC ) ) $.
    mulc1cncfg.4 $e |- ( ph -> B e. CC ) $.
    $( A version of ~ mulc1cncf using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by Glauco Siliprandi,
       30-Jun-2017.) $)
    mulc1cncfg $p |- ( ph -> ( x e. A |-> ( B x. ( F ` x ) ) ) e.
      ( A -cn-> CC ) )
                   $=
      ( vt cc cv cmul co cmpt cfv wceq wcel syl nfcv ccom ccncf mulc1cncf cncff
      wf eqid fcompt syl2anc fnvinran adantr mulcld nffv oveq2 fvmptf mpteq2dva
      wa nfov fveq2 oveq2d cbvmpt syl6eq eqtrd cncfco eqeltrrd ) ABKDBLZMNZOZEU
      AZBCDVEEPZMNZOZCKUBNZAVHJCJLZEPZVGPZOZVKAKKVGUEZCKEUEZVHVPQAVGKKUBNRZVQAD
      KRZVSIBDVGVGUFZUCSZKKVGUDSAEVLRVRHCKEUDSZJVGECKKUGUHAVPJCDVNMNZOVKAJCVOWD
      AVMCRZUPZVNKRWDKRVOWDQACKVMEWCUIZWFDVNAVTWEIUJWGUKBVNVFWDKVGKBVMEFBVMTULZ
      BDVNMBDTBMTWHUQZVEVNDMUMWAUNUHUOJBCWDVJWIJDVIMJDTJMTJVITUQVMVEQVNVIDMVMVE
      EURUSUTVAVBACKKEVGHWBVCVD $.
  $}

  ${
    $d x y z $.  $d A x $.  $d A y $.  $d A z $.  $d B z $.
    $( The infimum of a non-empty bounded set of reals is the greatest lower
       bound.  (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    infrglb $p |- ( ( ( A C_ RR /\ A =/= (/) /\ E. x e. RR A. y e. A x <_ y )
      /\ B e. RR ) -> ( sup ( A , RR , `' < ) < B <-> E. z e. A z < B ) )
                $=
      ( cr cv wbr wral wrex wcel wa clt wor a1i wi nfv vex brcnv wb wss wne cle
      c0 ccnv csup ltso cnvso mpbi wn infm3 nfre1 nf3an nfcv nfra1 nfrex biimpi
      w3a con3i ralimdaa biimpri reximdv imim12d adantr anim12d ex reximdai mpd
      nfan simp1 suplub2 simpr infmrcl brcnvg syl2anc cvv mpan2 rexbidv 3bitr3d
      adantl ) DFUAZDUDUBZAGZBGZUCHZBDIZAFJZURZEFKZLZEDFMUEZUFZWKHZECGZWKHZCDJZ
      WLEMHZWNEMHZCDJZWHABCFDEWKFWKNZWHFMNWTUGFMUHUIOWHWDWCMHZUJZBDIZWCWDMHZWNW
      DMHZCDJZPZBFIZLZAFJWCWDWKHZUJZBDIZWDWCWKHZWDWNWKHZCDJZPZBFIZLZAFJABCDUKWH
      XIXRAFWAWBWGAWAAQWBAQWFAFULUMWHWCFKZXIXRPWHXSLZXCXLXHXQXTXBXKBDWHXSBWAWBW
      GBWABQWBBQWFBAFBFUNWEBDUOUPUMXSBQVIZXBXKPXTWDDKLXJXAXJXAWCWDMARZBRZSUQUSO
      UTXTXGXPBFYAXTXGXPPWDFKXTXMXDXFXOXMXDPXTXMXDWDWCMYCYBSUQOXTXEXNCDXEXNPXTX
      NXEWDWNMYCCRZSVAOVBVCVDUTVEVFVGVHWAWBWGVJVKWJWIWLFKZWMWQTWHWIVLWHYEWIABDV
      MVDEWLFFMVNVOWIWPWSTWHWIWOWRCDWIWNVPKWOWRTYDEWNFVPMVNVQVRVTVS $.
  $}

  ${
    $d x N $.
    $( The power function on complex numbers, for fixed exponent N, is
       continuous.  Similar to ~ expcn .  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    expcncf $p |- ( N e. NN0 -> ( x e. CC |-> ( x ^ N ) ) e. ( CC -cn-> CC ) )
               $=
      ( cn0 wcel cc cv cexp co cmpt ccnfld ctopn cfv ccncf eqid expcn syl6eleqr
      ccn cncfcn1 ) BCDAEAFBGHIJKLZSQHEEMHASBSNZOSTRP $.
  $}

  $( A member of a set of upper integers is a complex number.  (Contributed by
     Glauco Siliprandi, 29-Jun-2017.) $)
  eluzelcn $p |- ( N e. ( ZZ>= ` M ) -> N e. CC ) $=
    ( cuz cfv wcel eluzelre recnd ) BACDEBABFG $.

  ${
    $d x y $.  $d N x $.
    $( Exponentiation of negative one to an even power.  (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    m1expeven $p |- ( N e. NN0 -> ( -u 1 ^ ( 2 x. N ) ) = 1 ) $=
      ( vx vy c1 c2 cv cmul co cexp wceq cc0 caddc oveq2 oveq2d eqeq1d 2cn wcel
      cc cn0 a1i cneg mul01i oveq2i neg1cn exp0 ax-mp eqtri nn0cn adantr ax-1cn
      wa adddid mulid1d eqtrd negcld 2nn0 simpl nn0mulcld simpr sqvald mul2negd
      expaddd 3eqtrd oveq12d ex nn0ind ) DUAZEBFZGHZIHZDJVGEKGHZIHZDJVGECFZGHZI
      HZDJZVGEVMDLHZGHZIHZDJZVGEAGHZIHZDJBCAVHKJZVJVLDWCVIVKVGIVHKEGMNOVHVMJZVJ
      VODWDVIVNVGIVHVMEGMNOVHVQJZVJVSDWEVIVRVGIVHVQEGMNOVHAJZVJWBDWFVIWAVGIVHAE
      GMNOVLVGKIHZDVKKVGIEPUBUCVGRQWGDJUDVGUEUFUGVMSQZVPVTWHVPUKZVSVGVNELHZIHVO
      VGEIHZGHZDWIVRWJVGIWIVRVNEDGHZLHWJWIEVMDERQWIPTZWHVMRQVPVMUHUIDRQWIUJTZUL
      WIWMEVNLWIEWNUMNUNNWIVGVNEWIDWOUOZESQWIUPTZWIEVMWQWHVPUQURVBWIWLDDGHZDWIV
      ODWKDGWHVPUSWIWKVGVGGHWRDWIVGWPUTWIDDWOWOVAWIDWOUMZVCVDWSUNVCVEVF $.
  $}


  ${
    $d t x $.  $d A t $.  $d A x $.  $d F t $.  $d N t $.  $d N x $.
    $d ph t $.  $d ph x $.
    expcnfg.1 $e |- F/_ x F $.
    expcnfg.2 $e |- ( ph -> F e. ( A -cn-> CC ) ) $.
    expcnfg.3 $e |- ( ph -> N e. NN0 ) $.
    $( If ` F ` is a complex continuous function and N is a fixed number, then
       F^N is continuous too.  A generalization of ~ expcncf .  (Contributed by
       Glauco Siliprandi, 29-Jun-2017.) $)
    expcnfg $p |- ( ph -> ( x e. A |-> ( ( F ` x ) ^ N ) ) e. ( A -cn-> CC ) )
                $=
      ( vt cv cfv cexp co cmpt cc ccncf nfcv wceq wcel wa ccom nffv nfov oveq1d
      fveq2 cbvmpt wf cncff syl fnvinran cn0 adantr expcld oveq1 fvmptf syl2anc
      eqcomd mpteq2dva syl5eq simpr fmptd fcompt eqtr4d expcncf cncfco eqeltrd
      eqid ) ABCBJZDKZELMZNZBOVHELMZNZDUAZCOPMZAVKICIJZDKZVMKZNZVNAVKICVQELMZNV
      SBICVJVTIVJQBVQELBVPDFBVPQUBZBLQBEQUCZVHVPRVIVQELVHVPDUEUDUFAICVTVRAVPCSZ
      TZVRVTWDVQOSVTOSVRVTRACOVPDADVOSCODUGZGCODUHUIZUJZWDVQEWGAEUKSZWCHULUMBVQ
      VLVTOVMOWAWBVHVQELUNVMVGZUOUPUQURUSAOOVMUGWEVNVSRABOVLOVMAVHOSZTVHEAWJUTA
      WHWJHULUMWIVAWFIVMDCOOVBUPVCACOODVMGAWHVMOOPMSHBEVDUIVEVF $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Limits
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d k n ph $.  $d A k $.  $d A n $.  $d B k $.  $d B n $.  $d F k $.
    clim1fr1.1 $e |- F = ( n e. NN |-> ( ( ( A x. n ) + B ) / ( A x. n ) ) )
                   $.
    clim1fr1.2 $e |- ( ph -> A e. CC ) $.
    clim1fr1.3 $e |- ( ph -> A =/= 0 ) $.
    clim1fr1.4 $e |- ( ph -> B e. CC ) $.
    $( A class of sequences of fractions that converge to 1 (Contributed by
       Glauco Siliprandi, 29-Jun-2017.) $)
    clim1fr1 $p
                   |- ( ph -> F ~~> 1 ) $=
  ( c1 cc0 caddc co cn cdiv cvv wcel a1i cc adantr vk cmpt cv cmul nnuz cz nnex
  cli 1z mptex zcnd cfv wceq eqidd wa id ax-1cn fvmptd adantl climconst eqeltri
  nncn wne nnne0 divdiv1d mpteq2dva wbr divcld divcnv syl eqbrtrrd wf ffvelrnda
  eqid fmpti mulcld mulne0d fmptd oveq2 oveq1d simpr nncnd addcld nnne0d dividd
  oveq12d divdird eqtrd eqcomd oveq2d 3eqtrd climadd addid1i syl6breq ) AEJKLMJ
  UHAJKUADNJUBZDNCBDUCZUDMZOMZUBZEJPNUEJUFQAUIRZAJUAWOJPNUEWTWOPQADNJUGUJRAJWTU
  KUAUCZNQZXAWOULZJUMAXBDXAJJNWOSXBWOUNXBWPXAUMZUOJUNXBUPJSQZXBUQRURUSZUTEPQAED
  NWQCLMZWQOMZUBZPFDNXHUGUJVARADNCBOMZWPOMZUBZWSKUHADNXKWRAWPNQZUOZCBWPACSQZXMI
  TZABSQZXMGTZXMWPSQAWPVBUSZABKVCZXMHTZXMWPKVCAWPVDUSZVEVFAXJSQXLKUHVGACBIGHVHX
  JDVIVJVKANSXAWONSWOVLADNSJWOWOVNXEXMUQRVORVMANSXAWSADNWRSWSXNCWQXPXNBWPXRXSVP
  XNBWPXRXSYAYBVQVHWSVNVRVMAXBUOZXAEULBXAUDMZCLMZYDOMZJCYDOMZLMZXCXAWSULZLMYCDX
  AXHYFNESEXIUMYCFRXDXHYFUMYCXDXGYEWQYDOXDWQYDCLWPXABUDVSZVTYJWFUSAXBWAZYCYEYDY
  CYDCYCBXAAXQXBGTZYCXAYKWBZVPZAXOXBITZWCYNYCBXAYLYMAXTXBHTYCXAYKWDVQZVHURYCYFY
  DYDOMZYGLMYHYCYDCYDYNYOYNYPWGYCYQJYGLYCYDYNYPWEVTWHYCJXCYGYILYCXCJXFWIYCYIYGY
  CDXAWRYGNWSSYCWSUNYCXDUOZWQYDCOYRWPXABUDYCXDWAWJWJYKYCCYDYOYNYPVHURWIWFWKWLJU
  QWMWN $.
  $}


  ${
    $d i j $.  $d j k n ph $.  $d B j $.  $d F k $.  $d M j $.  $d M k $.
    $d M n $.  $d Z j $.  $d Z k $.  $d Z n $.
    isumneg.1 $e |- Z = ( ZZ>= ` M ) $.
    isumneg.2 $e |- ( ph -> M e. ZZ ) $.
    isumneg.3 $e |- ( ph -> sum_ k e. Z A e. CC ) $.
    isumneg.4 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) = A ) $.
    isumneg.5 $e |- ( ( ph /\ k e. Z ) -> A e. CC ) $.
    isumneg.6 $e |- ( ph -> seq M ( + , F ) e. dom ~~> ) $.
    $( Negation of a converging sum.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    isumneg $p |- ( ph -> sum_ k e. Z -u A = -u sum_ k e. Z A ) $=
      ( cneg csu c1 cmul co cv wcel mulm1d wa eqcomd sumeq2dv ax-1cn a1i negcld
      cc isummulc2 3eqtr2d ) AFBMZCNFOMZBPQZCNUKFBCNZPQUMMAFUJULCACRFSUAZULUJUN
      BKTUBUCABUKCDEFGHJKLAOOUGSAUDUEUFUHAUMITUI $.
  $}


  ${
    $d k w x y z ph $.  $d A k $.  $d A w $.  $d A x $.  $d A y $.  $d A z $.
    $d B k $.  $d B z $.  $d F k $.  $d F z $.  $d G k $.  $d G w $.  $d G y $.
    $d G z $.  $d H k $.  $d H x $.  $d Z k $.  $d Z w $.  $d Z y $.
    climrec.1 $e |- Z = ( ZZ>= ` M ) $.
    climrec.2 $e |- ( ph -> M e. ZZ ) $.
    climrec.3 $e |- ( ph -> G ~~> A ) $.
    climrec.4 $e |- ( ph -> A =/= 0 ) $.
    climrec.5 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. ( CC \ { 0 } ) ) $.
    climrec.6 $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) = ( 1 / ( G ` k ) ) ) $.
    climrec.7 $e |- ( ph -> H e. W ) $.
    $( Limit of the reciprocal of a converging sequence.  (Contributed by
       Glauco Siliprandi, 29-Jun-2017.) $)
    climrec $p |- ( ph -> H ~~> ( 1 / A ) ) $=
      ( cc c1 cdiv co cfv vw vx vy vz cc0 csn cdif cmpt cli wbr wcel climcl syl
      cv wceq neneqd c0ex elsnc2 sylnibr eldifd wa eqidd simpr eldifad eldifsni
      oveq2d wne adantl reccld fvmptd eqeltrd crp cmin cabs clt wi wral cle cif
      wrex cmul c2 eqid reccn2 sylan id eldifi ad2antlr ad4antr oveq12d simpllr
      fveq2d mp2d eqbrtrd exp41 ralimdv2 reximdv oveq2 eqtr4d climcn1 breqtrd
      mpd ) AEBUAPUEUFZUGZQUAUNZRSZUHZTZQBRSZUIAUBUCUDBXDCXGDEFGHIJABPXCADBUIUJ
      BPUKKBDULUMZABUEUOBXCUKABUELUPBUEUQURUSUTZAUDUNZXDUKZVAZXLXGTZQXLRSZPXNUA
      XLXFXPXDXGPXNXGVBXNXEXLUOZVAXEXLQRXNXQVCVFAXMVCZXNXLXNXLPXCXRVDXMXLUEVGAX
      LPUEVEZVHVIZVJXTVKKOAUBUNZVLUKZVAZXLBVMSVNTUCUNVOUJZXPXIVMSZVNTZYAVOUJZVP
      ZUDXDVQZUCVLVTZYDXOXHVMSZVNTZYAVOUJZVPZUDXDVQZUCVLVTABXDUKYBYJXKUCUDBYAQB
      VNTZYAWASZVRUJQYQVSYPWBRSWASZYRWCWDWEYCYIYOUCVLYCYHYNUDXDXDYCXMYHVPZXMYDY
      MYCYSVAZXMVAZYDVAZYLYFYAVOUUBYKYEVNUUBXOXPXHXIVMXMXOXPUOYTYDXMUAXLXFXPXDX
      GPXMXGVBXMXQVAXEXLQRXMXQVCVFXMWFZXMXLXLPXCWGXSVIVJWHAXHXIUOYBYSXMYDAUABXF
      XIXDXGPAXGVBAXEBUOZVAXEBQRAUUDVCVFXKABXJLVIVJZWIWJWLUUBXMYDYGXMXMYTYDUUCW
      HUUAYDVCYCYSXMYDWKWMWNWOWPWQXBMACUNZHUKVAZUUFETQUUFDTZRSZUUHXGTNUUGUAUUHX
      FUUIXDXGPUUGXGVBXEUUHUOXFUUIUOUUGXEUUHQRWRVHMUUGUUHUUGUUHPXCMVDUUGUUHXDUK
      UUHUEVGMUUHPUEVEUMVIVJWSWTUUEXA $.
  $}

  ${
    $d j k $.  $d j ph $.  $d A j $.  $d B j $.  $d F j $.  $d G j $.
    $d H j $.  $d M j $.  $d Z j $.  $d Z k $.
    climmulf.1 $e |- F/ k ph $.
    climmulf.2 $e |- F/_ k F $.
    climmulf.3 $e |- F/_ k G $.
    climmulf.4 $e |- F/_ k H $.
    climmulf.5 $e |- Z = ( ZZ>= ` M ) $.
    climmulf.6 $e |- ( ph -> M e. ZZ ) $.
    climmulf.7 $e |- ( ph -> F ~~> A ) $.
    climmulf.8 $e |- ( ph -> H e. X ) $.
    climmulf.9 $e |- ( ph -> G ~~> B ) $.
    climmulf.10 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    climmulf.11 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. CC ) $.
    climmulf.12 $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) = ( ( F ` k ) x. ( G ` k
                      ) ) ) $.
    $( A version of ~ climmul using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    climmulf $p |- ( ph -> H ~~> ( A x. B ) ) $=
      ( vj cv wcel wa cfv cc nfcv nfel1 nfan nffv nfim wceq eleq1 anbi2d eleq1d
      wi fveq2 imbi12d chvar cmul co nfov nfeq oveq12d eqeq12d climmul ) ABCUCE
      FGHIJOPQRSADUDZJUEZUFZVIEUGZUHUEZURAUCUDZJUEZUFZVNEUGZUHUEZURDUCVPVRDAVOD
      KDVNJDVNUIZUJUKZDVQUHDVNELVSULZUJUMVIVNUNZVKVPVMVRWBVJVOAVIVNJUOUPZWBVLVQ
      UHVIVNEUSZUQUTTVAVKVIFUGZUHUEZURVPVNFUGZUHUEZURDUCVPWHDVTDWGUHDVNFMVSULZU
      JUMWBVKVPWFWHWCWBWEWGUHVIVNFUSZUQUTUAVAVKVIGUGZVLWEVBVCZUNZURVPVNGUGZVQWG
      VBVCZUNZURDUCVPWPDVTDWNWODVNGNVSULDVQWGVBWADVBUIWIVDVEUMWBVKVPWMWPWCWBWKW
      NWLWOVIVNGUSWBVLVQWEWGVBWDWJVFVGUTUBVAVH $.
  $}


  ${
    $d j k $.  $d j x ph $.  $d A j $.  $d A x $.  $d F j $.  $d F x $.
    $d H j $.  $d N j $.  $d N k $.  $d N x $.  $d Z j $.  $d Z k $.  $d Z x $.
    climexp.1 $e |- F/ k ph $.
    climexp.2 $e |- F/_ k F $.
    climexp.3 $e |- F/_ k H $.
    climexp.4 $e |- Z = ( ZZ>= ` M ) $.
    climexp.5 $e |- ( ph -> M e. ZZ ) $.
    climexp.6 $e |- ( ph -> F : Z --> CC ) $.
    climexp.7 $e |- ( ph -> F ~~> A ) $.
    climexp.8 $e |- ( ph -> N e. NN0 ) $.
    climexp.9 $e |- ( ph -> H e. V ) $.
    climexp.10 $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) = ( ( F ` k ) ^ N ) ) $.
    $( The limit of natural powers, is the natural power of the limit.
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    climexp $p |- ( ph -> H ~~> ( A ^ N ) ) $=
      ( cc vx vj cexp co cli wbr cmpt ccom cfv ccnfld ctopn ccn ccncf wcel eqid
      cv cn0 expcn cncfcn1 syl6eleqr climcl climcncf eqidd wceq wa simpr oveq1d
      syl expcld fvmptd breqtrd cvv cnex mptex wf cuz eqeltri fex sylancl coexg
      fvex sylancr ffvelrnda adantr fvco3 sylan wi nfv nfan nfcv nffv nfov nfeq
      nfim eleq1 anbi2d fveq2 eqeq12d imbi12d chvar 3eqtr4rd climeq mpbird ) AE
      BGUCUDZUEUFUATUAUPZGUCUDZUGZDUHZXDUEUFAXHBXGUIXDUEATTBXGDFIMNAXGUJUKUIZXI
      ULUDZTTUMUDAGUQUNZXGXJUNQUAXIGXIUOZURVHXIXLUSUTOPADBUEUFBTUNPBDVAVHZVBAUA
      BXFXDTXGTAXGVCAXEBVDZVEXEBGUCAXNVFVGXMABGXMQVIVJVKAXDUBEXHFHVLIMRAXGVLUND
      VLUNZXHVLUNUATXFVMVNAITDVOZIVLUNXOOIFVPUIVLMFVPWAVQITVLDVRVSXGDVLVLVTWBNA
      UBUPZIUNZVEZXQDUIZXGUIZXTGUCUDZXQXHUIZXQEUIZXSUAXTXFYBTXGTXSXGVCXSXEXTVDZ
      VEXEXTGUCXSYEVFVGAITXQDOWCZXSXTGYFAXKXRQWDVIVJAXPXRYCYAVDOITXQXGDWEWFACUP
      ZIUNZVEZYGEUIZYGDUIZGUCUDZVDZWGXSYDYBVDZWGCUBXSYNCAXRCJXRCWHWICYDYBCXQELC
      XQWJZWKCXTGUCCXQDKYOWKCUCWJCGWJWLWMWNYGXQVDZYIXSYMYNYPYHXRAYGXQIWOWPYPYJY
      DYLYBYGXQEWQYPYKXTGUCYGXQDWQVGWRWSSWTXAXBXC $.
  $}

  ${
    $d j k n y ph $.  $d k x y $.  $d F j $.  $d F k $.  $d F n $.  $d F x $.
    $d F y $.  $d M j $.  $d Z j $.  $d Z k $.  $d Z n $.  $d Z x $.  $d Z y $.
    climinf.3 $e |- Z = ( ZZ>= ` M ) $.
    climinf.4 $e |- ( ph -> M e. ZZ ) $.
    climinf.5 $e |- ( ph -> F : Z --> RR ) $.
    climinf.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` ( k + 1 ) ) <_ ( F ` k ) ) $.
    climinf.7 $e |- ( ph -> E. x e. RR A. k e. Z x <_ ( F ` k ) ) $.
    $( A bounded monotonic non increasing sequence converges to the infimum of
       its range.  (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    climinf $p |- ( ph -> F ~~> sup ( ran F , RR , `' < ) ) $=
      ( vy cr clt wbr cfv co wcel cle syl vj vn crn ccnv csup cli cmin cabs cuz
      cv wral wrex crp wa caddc wss c0 wne w3a wf frn wfn ffn cz uzid syl6eleqr
      fnfvelrn syl2anc ne0i wb breq2 ralrn rexbidv mpbird 3jca infmrcl ltaddrpd
      adantr simpr rpre adantl readdcld infrglb sselda adantlr ad2antlr ltsub1d
      mpbid syl3anc recnd ad2antrr pncand breq2d bitrd biimpd reximdva mpd wceq
      cc oveq1 breq1d rexrn biimpa syldan wi uztrn2 ffvelrn syl2an simpl simprr
      cfz fzssuz uzss syl6sseqr eleq2s ad2antrl syl5ss ralrimiva ssralv sylc c1
      r19.21bi fveq2d breq12d rspccva monoord2 lesub1dd resubcld lelttr ltsub23
      fveq2 sylan mpand sseldd infmrlb abssubge0d 3imtr4d anassrs ralrimdva cvv
      fvex eqeltri fex sylancl eqidd ffvelrnda clim2c ) ADDUCZMNUDUEZUFOCUJZDPZ
      UUIUGQZUHPZLUJZNOZCUAUJZUIPZUKZUAFULZLUMUKAUUSLUMAUUNUMRZUNZUUPDPZUUNUGQZ
      UUINOZUAFULZUUSAUUTUUJUUNUGQZUUINOZCUUHULZUVEUVAUUJUUIUUNUOQZNOZCUUHULZUV
      HUVAUUIUVINOZUVKUVAUUIUUNUVAUUHMUPZUUHUQURZBUJZUUNSOZLUUHUKZBMULZUSZUUIMR
      ZAUVSUUTAUVMUVNUVRAFMDUTZUVMIFMDVATZAEDPZUUHRZUVNADFVBZEFRUWDAUWAUWEIFMDV
      CTZAEEUIPZFAEVDREUWGRHEVETGVFFEDVGVHUUHUWCVITZAUVRUVOUUKSOZCFUKZBMULZKAUW
      EUVRUWKVJUWFUWEUVQUWJBMUVPUWILCFDUUNUUKUVOSVKVLVMTVNZVOVRZBLUUHVPZTZAUUTV
      SVQUVAUVSUVIMRUVLUVKVJUWMUVAUUIUUNUWOUUTUUNMRZAUUNVTZWAWBBLCUUHUVIWCVHWHU
      VAUVJUVGCUUHUVAUUJUUHRZUNZUVJUVGUWSUVJUVFUVIUUNUGQZNOUVGUWSUUJUVIUUNAUWRU
      UJMRUUTAUUHMUUJUWBWDWEUWSUUIUUNUVAUVTUWRUWOVRUUTUWPAUWRUWQWFZWBUXAWGUWSUW
      TUUIUVFNUWSUUIUUNAUUIWSRUUTUWRAUUIAUVMUVNUVRUVTUWBUWHUWLUWNWIZWJZWKUWSUUN
      UXAWJWLWMWNWOWPWQAUVHUVEAUWEUVHUVEVJUWFUVGUVDCUAFDUUJUVBWRUVFUVCUUINUUJUV
      BUUNUGWTXAXBTXCXDUVAUVDUURUAFUVAUUPFRZUNUVDUUOCUUQUVAUXDUUJUUQRZUVDUUOXEU
      VAUXDUXEUNZUNZUVBUUIUGQZUUNNOZUULUUNNOZUVDUUOUXGUULUXHSOZUXIUXJUXGUUKUVBU
      UIUVAUWAUUJFRZUUKMRUXFAUWAUUTIVRZEUUJUUPFGXFZFMUUJDXGXHZUVAUWAUXDUVBMRZUX
      FUXMUXDUXEXIFMUUPDXGXHZAUVTUUTUXFUXBWKZUXGUBDUUPUUJUVAUXDUXEXJUXGUBUJZDPZ
      MRZUBUUPUUJXKQZUXGUYBFUPUYAUBFUKZUYAUBUYBUKUXGUYBUUQFUUPUUJXLUXDUUQFUPZUV
      AUXEUYDUUPUWGFUUPUWGRUUQUWGFEUUPXMGXNGXOXPZXQAUYCUUTUXFAUWAUYCIUWAUYAUBFF
      MUXSDXGXRTWKUYAUBUYBFXSXTYBUXGUXSUUPUUJYAUGQZXKQZRUXSFRZUXSYAUOQZDPZUXTSO
      ZUXGUYGFUXSUXGUYGUUQFUUPUYFXLUYEXQWDUXGUUJYAUOQZDPZUUKSOZCFUKZUYHUYKAUYOU
      UTUXFAUYNCFJXRWKUYNUYKCUXSFUUJUXSWRZUYMUYJUUKUXTSUYPUYLUYIDUUJUXSYAUOWTYC
      UUJUXSDYKYDYEYLXDYFYGUXGUULMRUXHMRUWPUXKUXIUNUXJXEUXGUUKUUIUXOUXRYHUXGUVB
      UUIUXQUXRYHUUTUWPAUXFUWQWFZUULUXHUUNYIWIYMUXGUXPUWPUVTUVDUXIVJUXQUYQUXRUV
      BUUNUUIYJWIUXGUUMUULUUNNUXGUUIUUKUXRUXGUUHMUUKAUVMUUTUXFUWBWKZUVAUWEUXLUU
      KUUHRZUXFAUWEUUTUWFVRUXNFUUJDVGXHZYNUXGUVMUVRUYSUUIUUKSOUYRAUVRUUTUXFUWLW
      KUYTBLUUKUUHYOWIYPXAYQYRYSWPWQXRALUUIUUKUACDEYTFGHAUWAFYTRDYTRIFUWGYTGEUI
      UUAUUBFMYTDUUCUUDAUXLUNZUUKUUEUXCVUAUUKAFMUUJDIUUFWJUUGVN $.
  $}

  ${
    $d j k ph $.  $d I j $.  $d I k $.  $d K j $.  $d M j $.  $d M k $.
    $d Z j $.  $d Z k $.
    climsuselem1.1 $e |- Z = ( ZZ>= ` M ) $.
    climsuselem1.2 $e |- ( ph -> M e. ZZ ) $.
    climsuselem1.3 $e |- ( ph -> ( I ` M ) e. Z ) $.
    climsuselem1.4 $e |- ( ( ph /\ k e. Z ) -> ( I ` ( k + 1 ) ) e. ( ZZ>= ` (
                         ( I ` k ) + 1 ) ) ) $.
    $( The subsequence index ` I ` has the expected properties: it belongs to
       the same upper integers as the original index, and it is always larger
       or equal than the original index.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    climsuselem1 $p
                   |- ( ( ph /\ K e. Z ) -> ( I ` K ) e. ( ZZ>= ` K ) ) $=
  ( wcel wa cuz cfv wi c1 wceq fveq2 eleq12d imbi2d vj eleq2i simpl cv caddc co
  biimpi adantl cz syl6eleq a1i simpll simplr mpd w3a cle wbr 3ad2ant2 peano2zd
  simpr eluzelz zred cr eluzelre 3ad2ant3 1re readdcld eqimss2i sseld imdistani
  wss 3adant3 eluzle leadd1dd letrd wb eluz syl2anc mpbird syl3anc exp31 uzind4
  syl sylc ) ADFKZLDEMNZKZADCNZDMNZKZWEWGAWEWGFWFDGUBUGUHAWEUCAUAUDZCNZWKMNZKZO
  AECNZWFKZOZABUDZCNZWRMNZKZOZAWRPUEUFZCNZXCMNZKZOAWJOUABEDWKEQZWNWPAXGWLWOWMWF
  WKECRWKEMRSTWKWRQZWNXAAXHWLWSWMWTWKWRCRWKWRMRSTWKXCQZWNXFAXIWLXDWMXEWKXCCRWKX
  CMRSTWKDQZWNWJAXJWLWHWMWIWKDCRWKDMRSTWQEUIKAWOFWFIGUJUKWRWFKZXBAXFXKXBLZALZAX
  KXAXFXLAUTZXKXBAULXMAXAXNXKXBAUMUNAXKXAUOZXFXCXDUPUQZXOXCWSPUEUFZXDXOXCXOWRXK
  AWRUIKXAEWRVAURZUSZVBXOWSPXAAWSVCKXKWRWSVDVEZPVCKXOVFUKZVGXOXDXOXDXQMNKZXDUIK
  ZAXKYBXAAXKLAWRFKZLYBAXKYDAWFFWRWFFVKAFWFGVHUKVIVJJWCVLZXQXDVAWCZVBXOWRWSPXOW
  RXRVBXTYAXAAWRWSUPUQXKWRWSVMVEVNXOYBXQXDUPUQYEXQXDVMWCVOXOXCUIKYCXFXPVPXSYFXC
  XDVQVRVSVTWAWBWD $.
  $}

  ${
    $d h i j x $.  $d i k $.  $d i j l x ph $.  $d A h $.  $d A i $.  $d A j $.
    $d A l $.  $d A x $.  $d F h $.  $d F i $.  $d F j $.  $d F x $.  $d G i $.
    $d G j $.  $d G l $.  $d G x $.  $d I h $.  $d I i $.  $d M i $.  $d M l $.
    $d Z i $.  $d Z k $.
    climsuse.1 $e |- F/ k ph $.
    climsuse.3 $e |- F/_ k F $.
    climsuse.2 $e |- F/_ k G $.
    climsuse.4 $e |- F/_ k I $.
    climsuse.5 $e |- Z = ( ZZ>= ` M ) $.
    climsuse.6 $e |- ( ph -> M e. ZZ ) $.
    climsuse.7 $e |- ( ph -> F e. X ) $.
    climsuse.8 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    climsuse.9 $e |- ( ph -> F ~~> A ) $.
    climsuse.10 $e |- ( ph -> ( I ` M ) e. Z ) $.
    climsuse.11 $e |- ( ( ph /\ k e. Z ) -> ( I ` ( k + 1 ) ) e.
      ( ZZ>= ` ( ( I ` k ) + 1 ) ) ) $.
    climsuse.12 $e |- ( ph -> G e. Y ) $.
    climsuse.13 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) = ( F ` ( I ` k ) ) ) $.
    $( A subsequence ` G ` of a converging sequence ` F ` , converges to the
       same limit. ` I ` is the strictly increasing and it is used to index the
       subsequence (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    climsuse $p    |- ( ph -> G ~~> A ) $=
      ( vi vx vl vj vh cli wbr cc wcel cv cfv cmin co cabs clt wa cuz wral wrex
      cz crp climcl syl nfv eqidd clim mpbid simprd r19.21bi cle cif simpllr wn
      ad4antr ifclda nfra1 nfan simp-4l jca simpr wss anim1i adantr eluz mpbird
      wb simpll uzid 3syl uzss syl6sseqr sseld sylc wceq wi nfcv nffv nfeq nfim
      weq eleq1 anbi2d fveq2 fveq2d eqeq12d chvar eleq2i biimpi adantl c1 caddc
      imbi12d nfov oveq1 oveq1d eleq12d climsuselem1 sseldd syl6eleqr imdistani
      nfel ex nfci nfel1 eleq1d vtoclgf syl2anc breq1d anbi12d zre eluzelz zred
      cr eluzle 3ad2ant3 letrd ralrimi eqeltrd cbvralv ad2antlr w3a simp3 simp1
      3ad2ant2 simpl2 max1 eluzelre max2 syl3anc rspccva eqbrtrd raleqdv rspcev
      simp2 exp31 rexlimdv mpd mpbir2and ) AEBUIUJBUKULZUDUMZEUNZUKULZUVDBUOUPZ
      UQUNZUEUMZURUJZUSZUDUFUMZUTUNZVAZUFVCVBZUEVDVAADBUIUJZUVBSBDVEVFAUVNUEVDA
      UEVGAUVHVDULZUVNAUVPUSZUVCDUNZUKULZUVRBUOUPZUQUNZUVHURUJZUSZUDUGUMZUTUNZV
      AZUGVCVBZUVNAUWGUEVDAUVBUWGUEVDVAZAUVOUVBUWHUSSAUEBUVRUGUDDHQAUVCVCULZUSZ
      UVRVHVIVJVKVLUVQUWFUVNUGVCUVQUWDVCULZUWFUVNUVQUWKUSZUWFUSZGUWDVMUJZUWDGVN
      ZVCULUVJUDUWOUTUNZVAZUVNUWMUWNUWDGVCUVQUWKUWFUWNVOAGVCULZUVPUWKUWFUWNVPZP
      VQVRUWMUVJUDUWPUWLUWFUDUWLUDVGUWCUDUWEVSVTUWMUVCUWPULZUVJUWMUWTUSZUVEUVIU
      XAAUVCJULZUVEAUVPUWKUWFUWTWAZUXAAUWKUSZUWTUXBUXAAUWKUXCUVQUWKUWFUWTVOZWBU
      WMUWTWCZUXDUWPJUVCUXDUWPGUTUNZJUXDUWOUXGULUWPUXGWDUXDUWNUWDGUXGUXDUWNUSZU
      WDUXGULZUWNUXDUWNWCUXHUWRUWKUSZUXIUWNWIUXDUXJUWNAUWRUWKPWEWFGUWDWGVFWHUXD
      UWSUSAUWRGUXGULAUWKUWSWJPGWKWLVRGUWOWMVFOWNWOWPZAUXBUSZUVDUVCFUNZDUNZUKAC
      UMZJULZUSZUXOEUNZUXOFUNZDUNZWQZWRUXLUVDUXNWQZWRCUDUXLUYBCAUXBCKUXBCVGZVTZ
      CUVDUXNCUVCEMCUVCWSZWTCUXMDLCUVCFNUYEWTZWTZXAXBCUDXCZUXQUXLUYAUYBUYHUXPUX
      BAUXOUVCJXDXEZUYHUXRUVDUXTUXNUXOUVCEXFUYHUXSUXMDUXOUVCFXFZXGXHXOUCXIZUXLU
      XMJULZAUYLUSZUXNUKULZUXLUXMUXGJUXLUVCUTUNZUXGUXMUXLUVCUXGULZUYOUXGWDUXBUY
      PAUXBUYPJUXGUVCOXJXKXLGUVCWMVFAUDFUVCGJOPTUXQUXOXMXNUPZFUNZUXSXMXNUPZUTUN
      ZULZWRUXLUVCXMXNUPZFUNZUXMXMXNUPZUTUNZULZWRCUDUXLVUFCUYDCVUCVUECVUBFNCVUB
      WSWTCVUDUTCUTWSCUXMXMXNUYFCXNWSCXMWSXPWTYDXBUYHUXQUXLVUAVUFUYIUYHUYRVUCUY
      TVUEUYHUYQVUBFUXOUVCXMXNXQXGUYHUYSVUDUTUYHUXSUXMXMXNUYJXRXGXSXOUAXIXTZYAZ
      OYBZAUXBUYLAUXBUYLVUIYEYCUXQUXODUNZUKULZWRUYMUYNWRCUXMJUYFUYMUYNCAUYLCKCU
      XMJUYFCUDJUYCYFYDVTCUXNUKUYGYGXBUXOUXMWQZUXQUYMVUKUYNVULUXPUYLAUXOUXMJXDX
      EVULVUJUXNUKUXOUXMDXFYHXORYIWPUUAYJUXAUVGUXNBUOUPZUQUNZUVHURUXAUVFVUMUQUX
      AUVDUXNBUOUXAAUXBUYBUXCUXKUYKYJXRXGUXAUHUMZDUNZUKULZVUPBUOUPZUQUNZUVHURUJ
      ZUSZUHUWEVAZUXMUWEULZVUNUVHURUJZUWFVVBUWLUWTUWFVVBUWCVVAUDUHUWEUDUHXCZUVS
      VUQUWBVUTVVEUVRVUPUKUVCVUODXFZYHVVEUWAVUSUVHURVVEUVTVURUQVVEUVRVUPBUOVVFX
      RXGYKYLUUBXKUUCUXAAUWKUWTVVCUXCUXEUXFAUWKUWTUUDZVVCUWDUXMVMUJZVVGUWDUVCUX
      MUWKAUWDYPULZUWTUWDYMUUGZVVGUWTUWIUVCYPULAUWKUWTUUEUWOUVCYNZUVCYMWLZVVGUX
      LUXMUXGULUXMYPULVVGAUXBAUWKUWTUUFZVVGUVCUXGJVVGUYPGUVCVMUJZVVGGUWOUVCVVGA
      GYPULZVVMAGPYOVFZVVGUWNUWDGYPVVGUWNUSUWDAUWKUWTUWNUUHYOVVGVVOUWSVVPWFVRZV
      VLVVGVVOVVIGUWOVMUJVVPVVJGUWDUUIYJUWTAUWOUVCVMUJUWKUWOUVCYQYRZYSVVGUWRUWI
      UYPVVNWIVVGAUWRVVMPVFUWTAUWIUWKVVKYRGUVCWGYJWHOYBWBZVUHGUXMUUJWLVVGUWDUWO
      UVCVVJVVQVVLVVGVVOVVIUWDUWOVMUJVVPVVJGUWDUUKYJVVRYSVVGUXLUXMUYOULZUVCUXMV
      MUJVVSVUGUVCUXMYQWLYSVVGUWKUXMVCULZVVCVVHWIAUWKUWTUUQVVGUXLVVTVWAVVSVUGUV
      CUXMYNWLUWDUXMWGYJWHUULVVBVVCUSUYNVVDVVAUYNVVDUSUHUXMUWEVUOUXMWQZVUQUYNVU
      TVVDVWBVUPUXNUKVUOUXMDXFZYHVWBVUSVUNUVHURVWBVURVUMUQVWBVUPUXNBUOVWCXRXGYK
      YLUUMVKYJUUNWBYEYTUVMUWQUFUWOVCUVKUWOWQUVJUDUVLUWPUVKUWOUTXFUUOUUPYJUURUU
      SUUTYEYTAUEBUVDUFUDEIUBUWJUVDVHVIUVA $.
  $}


  ${
    $d j k $.  $d j ph $.  $d A j $.  $d G j $.  $d H j $.  $d Z j $.
    $d Z k $.
    climrecf.1 $e |- F/ k ph $.
    climrecf.2 $e |- F/_ k G $.
    climrecf.3 $e |- F/_ k H $.
    climrecf.4 $e |- Z = ( ZZ>= ` M ) $.
    climrecf.5 $e |- ( ph -> M e. ZZ ) $.
    climrecf.6 $e |- ( ph -> G ~~> A ) $.
    climrecf.7 $e |- ( ph -> A =/= 0 ) $.
    climrecf.8 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. ( CC \ { 0 } ) ) $.
    climrecf.9 $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) = ( 1 / ( G ` k ) ) ) $.
    climrecf.10 $e |- ( ph -> H e. W ) $.
    $( A version of ~ climrec using bound-variable hypotheses instead of
       distinct variable conditions.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    climrecf $p
                   |- ( ph -> H ~~> ( 1 / A ) ) $=
  ( c1 cdiv vj cv wcel wa cfv cc cc0 csn cdif wi nfan nfcv nffv nfel1 nfim wceq
  nfv eleq1 anbi2d fveq2 eleq1d imbi12d chvar nfov nfeq oveq2d eqeq12d climrec
  co ) ABUADEFGHLMNOACUBZHUCZUDZVJDUEZUFUGUHUIZUCZUJAUAUBZHUCZUDZVPDUEZVNUCZUJC
  UAVRVTCAVQCIVQCUQUKZCVSVNCVPDJCVPULZUMZUNUOVJVPUPZVLVRVOVTWDVKVQAVJVPHURUSZWD
  VMVSVNVJVPDUTZVAVBPVCVLVJEUEZSVMTVIZUPZUJVRVPEUEZSVSTVIZUPZUJCUAVRWLCWACWJWKC
  VPEKWBUMCSVSTCSULCTULWCVDVEUOWDVLVRWIWLWEWDWGWJWHWKVJVPEUTWDVMVSSTWFVFVGVBQVC
  RVH $.
  $}

  ${
    $d j k $.  $d j ph $.  $d Z j $.  $d Z k $.
    climneg.1 $e |- F/ k ph $.
    climneg.2 $e |- F/_ k F $.
    climneg.3 $e |- Z = ( ZZ>= ` M ) $.
    climneg.4 $e |- ( ph -> M e. ZZ ) $.
    climneg.5 $e |- ( ph -> F ~~> A ) $.
    climneg.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    $( Complex limit of the negative of a sequence.  (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    climneg $p |- ( ph -> ( k e. Z |-> -u ( F ` k ) ) ~~> -u A ) $=
      ( cfv c1 cmul cvv wcel a1i cc wceq vj cv cneg cmpt co cli nfmpt1 cuz fvex
      eqeltri mptex ax-1cn negcld wa fvmptd adantl climconst neg1cn eqid fvmpt2
      eqidd id mpan2 syl6eqel syl2anc mulm1d eqcomd oveq1d 3eqtr2d climmulf wbr
      simpr climcl syl breqtrd ) ACFCUBZDMZUCZUDZNUCZBOUEBUCUFAVTBCCFVTUDZDVSEP
      FGCFVTUGHCFVRUGIJAVTUAWAEPFIJWAPQACFVTFEUHMPIEUHUIUJZUKRANNSQZAULRUMUAUBZ
      FQZWDWAMVTTAWECWDVTVTFWASWEWAVAWEVPWDTUNVTVAWEVBWENWCWEULRUMUOUPUQVSPQACF
      VRWBUKRKVPFQZVPWAMZSQAWFWGVTSWFVTSQWGVTTURCFVTSWAWAUSUTVCZURVDUPLAWFUNZVP
      VSMZVRVTVQOUEWGVQOUEWIWFVRSQWJVRTAWFVLWIVQLUMCFVRSVSVSUSUTVEWIVQLVFWIVTWG
      VQOWFVTWGTAWFWGVTWHVGUPVHVIVJABADBUFVKBSQKBDVMVNVFVO $.
  $}

  ${
    $d j k x $.  $d j ph $.  $d F j $.  $d F x $.  $d Z j $.  $d Z k $.
    $d Z x $.
    climinff.1 $e |- F/ k ph $.
    climinff.2 $e |- F/_ k F $.
    climinff.3 $e |- Z = ( ZZ>= ` M ) $.
    climinff.4 $e |- ( ph -> M e. ZZ ) $.
    climinff.5 $e |- ( ph -> F : Z --> RR ) $.
    climinff.6 $e |- ( ( ph /\ k e. Z ) -> ( F ` ( k + 1 ) ) <_ ( F ` k ) ) $.
    climinff.7 $e |- ( ph -> E. x e. RR A. k e. Z x <_ ( F ` k ) ) $.
    $( A version of ~ climinf using bound-variable hypotheses instead of
       distinct variable conditions (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    climinff $p
                   |- ( ph -> F ~~> sup ( ran F , RR , `' < ) ) $=
  ( vj cfv cle wbr wi nfcv cr cv wcel wa c1 caddc nfv nfan nffv nfbr nfim eleq1
  co anbi2d oveq1 fveq2d fveq2 breq12d imbi12d chvar wral wrex nfci nfral nfrex
  weq wb breq2d cbvral a1i rexbidv imbi2d climinf ) ABNDEFIJKACUAZFUBZUCZVMUDUE
  ULZDOZVMDOZPQZRANUAZFUBZUCZVTUDUEULZDOZVTDOZPQZRCNWBWFCAWACGWACUFZUGCWDWEPCWC
  DHCWCSUHCPSZCVTDHCVTSUHZUIUJCNVEZVOWBVSWFWJVNWAAVMVTFUKUMWJVQWDVRWEPWJVPWCDVM
  VTUDUEUNUOVMVTDUPZUQURLUSABUAZVRPQZCFUTZBTVAZRAWLWEPQZNFUTZBTVAZRCNAWRCGWQCBT
  CTSWPCNFCNFWGVBCWLWEPCWLSWHWIUIZVCVDUJWJWOWRAWJWNWQBTWNWQVFWJWMWPCNFWMNUFWSWJ
  VRWEWLPWKVGVHVIVJVKMUSVL $.
  $}


  ${
    $d j k $.  $d Z k $.
    climdivf.1 $e |- F/ k ph $.
    climdivf.2 $e |- F/_ k F $.
    climdivf.3 $e |- F/_ k G $.
    climdivf.4 $e |- F/_ k H $.
    climdivf.5 $e |- Z = ( ZZ>= ` M ) $.
    climdivf.6 $e |- ( ph -> M e. ZZ ) $.
    climdivf.7 $e |- ( ph -> F ~~> A ) $.
    climdivf.8 $e |- ( ph -> H e. X ) $.
    climdivf.9 $e |- ( ph -> G ~~> B ) $.
    climdivf.10 $e |- ( ph -> B =/= 0 ) $.
    climdivf.11 $e |- ( ( ph /\ k e. Z ) -> ( F ` k ) e. CC ) $.
    climdivf.12 $e |- ( ( ph /\ k e. Z ) -> ( G ` k ) e. ( CC \ { 0 } ) ) $.
    climdivf.13 $e |- ( ( ph /\ k e. Z ) -> ( H ` k ) =
      ( ( F ` k ) / ( G ` k ) ) ) $.
    $( Limit of the ratio of two converging sequences.  (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    climdivf $p |- ( ph -> H ~~> ( A / B ) ) $=
      ( c1 cdiv co cmul cli cv cfv cmpt nfmpt1 cvv wcel wa cc simpr cc0 eldifad
      wceq csn cdif wne eldifsni syl reccld eqid syl2anc cuz fvex eqeltri mptex
      fvmpt2 a1i climrecf eqeltrd eqcomd oveq2d 3eqtrd climmulf climcl breqtrrd
      divrecd wbr ) AGBUDCUEUFZUGUFBCUEUFUHABWEDEDJUDDUIZFUJZUEUFZUKZGHIJKLDJWH
      ULZNOPQRACDFWIHUMJKMWJOPSTUBAWFJUNZUOZWKWHUPUNWFWIUJZWHUTAWKUQWLWGWLWGUPU
      RVAZUBUSZWLWGUPWNVBUNWGURVCUBWGUPURVDVEZVFZDJWHUPWIWIVGVMVHZWIUMUNADJWHJH
      VIUJUMOHVIVJVKVLVNVOUAWLWMWHUPWRWQVPWLWFGUJWFEUJZWGUEUFWSWHUGUFWSWMUGUFUC
      WLWSWGUAWOWPWCWLWHWMWSUGWLWMWHWRVQVRVSVTABCAEBUHWDBUPUNQBEWAVEAFCUHWDCUPU
      NSCFWAVETWCWB $.
  $}

  ${
    $d n ph $.  $d A n $.  $d F n $.  $d M n $.  $d Z n $.
    climreeq.1 $e |- R = ( ~~>t ` ( topGen ` ran (,) ) ) $.
    climreeq.2 $e |- Z = ( ZZ>= ` M ) $.
    climreeq.3 $e |- ( ph -> M e. ZZ ) $.
    climreeq.4 $e |- ( ph -> F : Z --> RR ) $.
    $( If ` F ` is a real function, then ` F ` converges to ` A ` with respect
       to the standard topology on the reals if and only if it converges to
       ` A ` with respect to the standard topology on complex numbers.  In the
       theorem, ` R ` is defined to be convergence w.r.t. the standard topology
       on the reals and then ` F R A ` represents the statement " ` F `
       converges to ` A ` , with respect to the standard topology on the
       reals".  Notice that there is no need for the hypothesis that ` A ` is a
       real number.  (Contributed by Glauco Siliprandi, 2-Jul-2017.) $)
    climreeq $p    |- ( ph -> ( F R A <-> F ~~> A ) ) $=
      ( wbr cfv wcel cc cr a1i syl2anc wa simpr adantr vn cli crn ctg clm ctopn
      cioo ccnfld cz wf wss ax-resscn fss eqid lmclimf cvv tgioo2 reex cnfldtop
      wb ctop lmss pm5.32da biimpa cv ffvelrnda adantlr climrecl impbid2 ctopon
      ex ancrd retopon lmcl 3bitr3d bitr3d breqi syl6rbbr ) ADBUBKZDBUGUCUDLZUE
      LZKZDBCKADBUHUFLZUELKZVSWBAEUIMZFNDUJZWDVSUTIAFODUJZONUKZWFJWHAULPFONDUMQ
      BDWCEFWCUNZHUOQZABOMZWDRZWKWBRZWDWBAWKWDWBAWKRZBDWCVTEUPOFWCWIUQHOUPMWNUR
      PWCVAMWNWCWIUSPAWKSAWEWKITAWGWKJTVBVCAWLWDWKWDSAWDWKAWDWKAWDRBUADEFHAWEWD
      ITAWDVSWJVDAUAVEZFMWODLOMWDAFOWODJVFVGVHVKVLVIAWMWBWKWBSAWBWKAWBWKAWBRZVT
      OVJLMZWBWKWQWPVMPAWBSBDVTOVNQVKVLVIVOVPDBCWAGVQVR $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Derivatives
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.  $d A x $.  $d B x $.  $d N x $.  $d N y $.  $d ph x $.
    $d ph y $.
    dvsinexp.5 $e |- ( ph -> N e. NN ) $.
    $( The derivative of sin^N .  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    dvsinexp $p |- ( ph -> ( CC _D ( x e. CC |-> ( ( sin ` x ) ^ N ) ) ) =
      ( x e. CC |-> ( ( N x. ( ( sin ` x ) ^ ( N - 1 ) ) ) x. ( cos ` x ) ) ) )
                 $=
      ( vy cv csin cfv ccos cexp co cmul cc cr wcel a1i wf adantr cdv cmpt cmin
      c1 cpr cnex prid2 sinf ffvelrnda cosf wa simpr cn0 nnnn0d expcld nncnd cn
      nnm1nn0 syl mulcld dvsin feqmptd oveq2d 3eqtr3a wceq dvexp oveq1 dvmptco
      ) ABEBFZGHZVGIHZEFZCJKZCVJCUBUAKZJKZLKZMMVHCJKCVHVLJKZLKMMMMMNMUCOANMUDUE
      PZVPAMMVGGMMGQAUFPZUGAMMVGIMMIQAUHPZUGAVJMOZUIZVJCAVSUJZACUKOVSACDULRUMVT
      CVMACMOVSACDUNRVTVJVLWAAVLUKOZVSACUOOZWBDCUPUQRUMURAMGSKIMBMVHTZSKBMVITUS
      AGWDMSABMMGVQUTVAABMMIVRUTVBAWCMEMVKTSKEMVNTVCDECVDUQVJVHCJVEVJVHVCVMVOCL
      VJVHVLJVEVAVF $.
  $}

  $( The real derivative of the cosine (Contributed by Glauco Siliprandi,
     29-Jun-2017.) $)
  dvcosre $p |- ( RR _D ( x e. RR |-> ( cos ` x ) ) ) =
    ( x e. RR |-> -u ( sin ` x ) )
              $=
    ( cr ccos cres cdv co cc cfv cmpt csin wcel wss wceq cosf reseq1i ax-resscn
    cv ax-mp resmpt eqtri cneg cpr wf cdm reex prid1 ssid crab wi nfrab1 dfss2f
    cvv nfcv recn sincld negcld elex rabid sylanbrc mpgbir dvcos dmmpt sseqtr4i
    syl dvres3 mp4an wfn ffn dffn5 mpbi oveq2i 3eqtr3i ) BCBDZEFZGCEFZBDZBABAQZ
    CHZIZEFABVQJHZUAZIZBBGUBKGGCUCZGGLBVOUDZLVNVPMBGUEUFNGUGBWAULKZAGUHZWDBWFLV
    QBKZVQWFKZUIAABWFABUMWEAGUJUKWGVQGKWEWHVQUNZWGWAGKWEWGVTWGVQWIUOUPWAGUQVDWE
    AGURUSUTAGWAVOAVAZVBVCGBCVEVFVMVSBEVMAGVRIZBDZVSCWKBCGVGZCWKMWCWMNGGCVHRAGC
    VIVJOBGLZWLVSMPAGBVRSRTVKVPAGWAIZBDZWBVOWOBWJOWNWPWBMPAGBWASRTVL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                        Integrals
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( An open real interval has finite volume.  (Contributed by Glauco
     Siliprandi, 29-Jun-2017.) $)
  ioovolcl $p |- ( ( A e. RR /\ B e. RR ) -> ( vol ` ( A (,) B ) ) e. RR )
               $=
    ( cr wcel wa cioo co cvol cfv covol cdm wceq wbr cle c0 ancoms cxr rexr cc0
    eqeltrd ioombl mblvol mp1i clt wi ltle imdistani wb ioo0 syl2an fveq2 ovol0
    biimpar syl6eq 0re syl6eqel 3syl cmin ovolioo 3expa resubcl simpr ltlecasei
    adantr simpl ) ACDZBCDZEZABFGZHIZVIJIZCVIHKDVJVKLVHABUAVIUBUCVHVKCDZBAVHBAU
    DMZEVHBANMZEVIOLZVLVHVMVNVGVFVMVNUEBAUFPUGVHVOVNVFAQDBQDVOVNUHVGARBRABUIUJU
    MVOVKSCVOVKOJISVIOJUKULUNUOUPUQVHABNMZEVKBAURGZCVFVGVPVKVQLABUSUTVHVQCDZVPV
    GVFVRBAVAPVDTVFVGVBVFVGVEVCT $.


  $( The measure of an open interval.  (Contributed by Glauco Siliprandi,
     29-Jun-2017.) $)
  volioo $p |- ( ( A e. RR /\ B e. RR /\ A <_ B ) ->
    ( vol ` ( A (,) B ) ) = ( B - A ) )
             $=
    ( cr wcel cle wbr w3a cioo cvol cfv covol cmin cdm wceq ioombl mblvol ax-mp
    co ovolioo syl5eq ) ACDBCDABEFGABHRZIJZUAKJZBALRUAIMDUBUCNABOUAPQABST $.


  ${
    $d t x $.  $d C x $.
    itgsin0pilem1.1 $e |- C = ( t e. ( 0 [,] pi ) |-> -u ( cos ` t ) ) $.
    $( Calculation of the integral for sine on the (0,&pi;) interval
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    itgsin0pilem1 $p |- S. ( 0 (,) pi ) ( sin ` x ) _d x = 2 $=
      ( cc0 cpi co cfv c1 cneg cr cdv wceq wtru wcel cmpt ccos cc wss a1i cv c2
      cioo csin citg cmin cicc fveq2 negeqd cbvmptv eqtri oveq2i crn ctg ccnfld
      ctopn ax-resscn 0re pire iccssre mp2an wa sstri coscld adantl negcld eqid
      sseli tgioo2 cnt iccntr dvmptntr trud cpr reex prid1 recn sincld dvmptneg
      dvcosre negnegd mpteq2ia syl6eq ioossre 3eqtri fveq1i fvmpt2 mpdan syl5eq
      iooretop dvmptres itgeq2dv cle wbr pipos ltleii ccncf nfcv sincn syl5eqel
      cncfmptss cibl ioossicc cvol cdm ioombl mp3an iblss syl2anc eqcomd nfmpt1
      cniccibl coscn negfcncf ax-mp eqeltri ftc2 eqtr3i cxr rexri ubicc2 ax-1cn
      0xr cospi eqtrd 1ex fvmpt lbicc2 negex negeqi oveq12i caddc subnegi 1p1e2
      cos0 ) AEFUCGZAUAZUDHZUEZFCHZECHZUFGZIIJZUFGZUBAYPYQKCLGZHZUEZYSUUBUUGYSM
      NAYPUUFYRYQYPOZUUFYRMNUUHUUFYQAYPYRPZHZYRYQUUEUUIUUEKAEFUGGZYQQHZJZPZLGZK
      AYPUUMPLGZUUICUUNKLCBUUKBUAZQHZJZPUUNDBAUUKUUSUUMUUQYQMUURUULUUQYQQUHUIUJ
      UKZULUUOUUPMNAUUMKUCUMUNHZUOUPHZUUKYPKRSNUQTUUKKSZNEKOZFKOZUVCURUSEFUTVAZ
      TNYQUUKOZVBUULUVGUULROZNUVGYQUUKRYQUUKKRUVFUQVCZVHZVDZVEVFUVBUVBVGZVIZUVL
      UUKUVAVJHHYPMZNUVDUVEUVNURUSEFVKVATVLVMUUPUUIMNAUUMYRKUVAUVBRKYPKKRVNONKR
      VOVPTZNYQKOZVBUULUVPUVHNUVPYQYQVQZVDVEZVFUVPYRROZNUVPYQUVQVRZVENKAKUUMPLG
      AKYRJZJZPAKYRPNAUULUWAKRKUVOUVRUVPUWARONUVPYRUVTVFVEKAKUULPLGAKUWAPMNAVTT
      VSAKUWBYRUVPYRUVTWAWBWCYPKSNEFWDZTUVMUVLYPUVAONEFWJTWKVMWEZWFUUHUVSUUJYRM
      UUHYQYPRYQYPKRUWCUQVCZVHVRAYPYRRUUIUUIVGWGWHWIVEWLVMUUGUUBMNAEFCUVDNURTUV
      ENUSTEFWMWNZNEFURUSWOWPZTNUUEUUIYPRWQGUWDNARRYPUDAUDWRZUDRRWQGZONWSTZYPRS
      NUWETXAWTNUUEUUIXBUWDNAYPUUKYRRYPUUKSNEFXCTYPXDXEONEFXFTUVGUVSNUVGYQUVJVR
      VEAUUKYRPZXBOZNUVDUVEUWKUUKRWQGZOZUWLURUSUWNNARRUUKUDUWHUWJUUKRSNUVITZXAV
      MEFUWKXLXGTXHWTCUWMONCUUNUWMUUTUUNAUUKYQARUUMPZHZPZUWMAUUKUUMUWQUVGUWQUUM
      UVGYQROUUMROUWQUUMMUVJUVGUULUVKVFARUUMRUWPUWPVGZWGXIXJWBUWRUWMONARRUUKUWP
      ARUUMXKUWPUWIOZNQUWIOUWTXMARQUWPUWSXNXOTUWOXAVMXPXPTXQVMXRYTIUUAUUCUFFUUK
      OZYTIMEXSOZFXSOZUWFUXAYCFUSXTZUWGEFYAXGBFUUSIUUKCUUQFMZUUSUUCJIUXEUURUUCU
      XEUURFQHUUCUUQFQUHYDWCUIUXEIIROUXEYBTWAYEDYFYGXOUUAEQHZJZUUCEUUKOZUUAUXGM
      UXBUXCUWFUXHYCUXDUWGEFYHXGBEUUSUXGUUKCUUQEMUURUXFUUQEQUHUIDUXFYIYGXOUXFIY
      OYJUKYKUUDIIYLGUBIIYBYBYMYNUKWE $.
  $}

  ${
    $d A x $.  $d B x $.  $d N x $.
    $( sin^n on a closed interval is integrable.  (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    ibliccsinexp $p |- ( ( A e. RR /\ B e. RR /\ N e. NN0 ) ->
      ( x e. ( A [,] B ) |-> ( ( sin ` x ) ^ N ) ) e. L^1 )
                     $=
      ( cr wcel cn0 cicc co cv csin cfv cexp cmpt cc ccncf cibl w3a wa wceq a1i
      iccssre ax-resscn syl6ss sselda 3adantl3 sincld simpl3 expcld eqid fvmpt2
      syl2anc eqcomd mpteq2dva nfmpt1 sincn simp3 expcnfg wss 3adant3 cncfmptss
      nfcv eqeltrd cniccibl syld3an3 ) BEFZCEFZDGFZABCHIZAJZKLZDMIZNZVIOPIZFVMQ
      FVFVGVHRZVMAVIVJAOVLNZLZNVNVOAVIVLVQVOVJVIFZSZVQVLVSVJOFZVLOFVQVLTVFVGVRV
      TVHVFVGSZVIOVJWAVIEOBCUBUCUDZUEUFZVSVKDVSVJWCUGVFVGVHVRUHUIAOVLOVPVPUJUKU
      LUMUNVOAOOVIVPAOVLUOVOAOKDAKVBKOOPIFVOUPUAVFVGVHUQURVFVGVIOUSVHWBUTVAVCBC
      VMVDVE $.
  $}

  ${
    $d t x $.
    $( Calculation of the integral for sine on the (0,&pi;) interval
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    itgsin0pi $p |- S. ( 0 (,) pi ) ( sin ` x ) _d x = 2 $=
      ( vt cc0 cpi cicc co cv ccos cfv cneg cmpt eqid itgsin0pilem1 ) ABBCDEFBG
      HIJKZNLM $.
  $}

  ${
    $d A x $.  $d B x $.  $d N x $.
    $( sin^n on an open integral is integrable (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    iblioosinexp $p |- ( ( A e. RR /\ B e. RR /\ N e. NN0 ) ->
      ( x e. ( A (,) B ) |-> ( ( sin ` x ) ^ N ) ) e. L^1 )
                     $=
      ( cr wcel cn0 w3a cioo co cicc cv csin cfv cexp cc wss ioossicc a1i wa
      cvol ioombl iccssre ax-resscn syl6ss sselda 3adantl3 sincld simpl3 expcld
      cdm ibliccsinexp iblss ) BEFZCEFZDGFZHZABCIJZBCKJZALZMNZDOJPURUSQUQBCRSUR
      UAUKFUQBCUBSUQUTUSFZTZVADVCUTUNUOVBUTPFUPUNUOTZUSPUTVDUSEPBCUCUDUEUFUGUHU
      NUOUPVBUIUJABCDULUM $.
  $}


  ${
    $d x N $.  $d x ph $.
    itgsinexplem1.1 $e |- F = ( x e. CC |-> ( ( sin ` x ) ^ N ) ) $.
    itgsinexplem1.2 $e |- G = ( x e. CC |-> -u ( cos ` x ) ) $.
    itgsinexplem1.3 $e |- H = ( x e. CC |-> ( ( N x. ( ( sin ` x ) ^
      ( N - 1 ) ) ) x. ( cos ` x ) ) ) $.
    itgsinexplem1.4 $e
      |- I = ( x e. CC |-> ( ( ( sin ` x ) ^ N ) x. ( sin ` x ) ) ) $.
    itgsinexplem1.5 $e
      |- L = ( x e. CC |-> ( ( ( N x. ( ( sin ` x ) ^ ( N - 1 ) ) ) x.
      ( cos ` x ) ) x. -u ( cos ` x ) ) ) $.
    itgsinexplem1.6 $e
     |- M = ( x e. CC |-> ( ( ( cos ` x ) ^ 2 ) x.
       ( ( sin ` x ) ^ ( N - 1 ) ) ) ) $.
    itgsinexplem1.7 $e |- ( ph -> N e. NN ) $.
    $( Integration by parts is applied to integrate sin^(N+1) (Contributed by
       Glauco Siliprandi, 29-Jun-2017.) $)
    itgsinexplem1 $p |- ( ph -> S. ( 0 (,) pi ) ( ( ( sin ` x ) ^ N ) x.
      ( sin ` x ) ) _d x = ( N x. S. ( 0 (,) pi ) ( ( ( cos ` x ) ^ 2 ) x.
      ( ( sin ` x ) ^ ( N - 1 ) ) ) _d x ) )
                      $=
      ( cc0 cr wcel cc cpi cioo co cv csin cfv cexp cmul citg cneg ccos c2 cmin
      c1 0cn subidi oveq1i 0re a1i pire cle wbr pipos ltleii cicc cmpt ccncf wa
      wceq wss pm3.2i iccssre ax-mp ax-resscn sstri adantl sincld nnnn0d adantr
      sseli cn0 expcld fvmpt2 syl2anc eqcomd mpteq2dva nfmpt1 nfcxfr nfcv sincn
      expcnfg syl5eqel cncfmptss eqeltrd coscld negcld coscn negfcncf syl nncnd
      ioossre cn nnm1nn0 mulcld ssid cncfmptc syl3anc mulcncf wf cosf syl6eqelr
      feqmptd ioossicc cdm cibl cniccibl iblss eqid oveq2i reseq1i resmpt eqtri
      cres syl6eq dvmptres2 negnegd eqtrd fveq2 oveq1d 0expd id syl6eqel mul02d
      cdv mulassd oveq2d sqcld 3eqtrd negeqd mulneg1d cvol ioombl crn ctg ctopn
      sinf ccnfld cpr reex prid1 recn sincl fmptd wi wal cvv crab elex sylanbrc
      rabid dmmpt syl6eleqr alrimiv nfdm dfss2f dvsinexp 3eqtr4g dmeqd sseqtr4d
      sylibr dvres3 syl22anc reseq1d 3eqtr3d tgioo2 cnt iccntr dvcosre dvmptneg
      ex sin0 coscl sinpi recni itgparts 3eqtr4a sqval mulcomd mulneg2d 3eqtr4d
      df-neg itgeq2dv 2nn0 itgmulc2 eqtr4d itgcl ) ABQUAUBUCZBUDZUEUFZIUGUCZUWS
      UHUCZUIZIUJZBUWQUWRUKUFZULUGUCZUWSIUNUMUCZUGUCZUHUCZUIZUHUCZUJZIUXIUHUCZU
      JZUJUXLAUXBBUWQIUXGUHUCZUXDUHUCZUXDUJZUHUCZUIZUJZUXKAQQUMUCZUXRUMUCQUXRUM
      UCZUXBUXSUXTQUXRUMQUOUPUQABUWTUXOUXPUWSQQQUAQRSZAURUSZUARSZAUTUSZQUAVAVBA
      QUAURUTVCVDUSABQUAVEUCZUWTVFBUYFUWRCUFZVFUYFTVGUCZABUYFUWTUYGAUWRUYFSZVHZ
      UYGUWTUYJUWRTSZUWTTSUYGUWTVIUYIUYKAUYFTUWRUYFRTUYBUYDVHZUYFRVJZUYBUYDURUT
      VKZQUAVLVMZVNVOZVTZVPZUYJUWSIUYIUWSTSZAUYIUWRUYQVQVPZAIWASZUYIAIPVRZVSWBZ
      BTUWTTCJWCWDWEWFABTTUYFCBCBTUWTVFZJBTUWTWGWHACVUDTTVGUCZJABTUEIBUEWIZUEVU
      ESAWJUSZVUBWKZWLUYFTVJAUYPUSZWMWNABUYFUXPVFBUYFUWRDUFZVFUYHABUYFUXPVUJUYI
      UXPVUJVIAUYIVUJUXPUYIUYKUXPTSZVUJUXPVIUYQUYIUXDUYIUWRUYQWOZWPZBTUXPTDKWCW
      DWEVPWFABTTUYFDBDBTUXPVFZKBTUXPWGWHAUKVUESZDVUESVUOAWQUSZBTUKDKWRWSVUIWMW
      NABUWQUXOVFBUWQUWREUFZVFUWQTVGUCABUWQUXOVUQAUWRUWQSZVHZVUQUXOVUSUYKUXOTSZ
      VUQUXOVIVURUYKAUWQTUWRUWQRTQUAXAVNVOZVTZVPVUSUXNUXDVUSIUXGAITSZVURAIPWTZV
      SZVUSUWSUXFVURUYSAVURUWRVVBVQVPAUXFWASZVURAIXBSZVVFPIXCWSZVSWBZXDZVURUXDT
      SZAVURUWRVVBWOZVPZXDZBTUXOTELWCWDWEWFABTTUWQEBEBTUXOVFZLBTUXOWGWHZAEVVOVU
      ELABUXNUXDTABIUXGTAVVCTTVJZVVQBTIVFVUESVVDVVQATXEUSZVVRBITTXFXGABTUEUXFVU
      FVUGVVHWKZXHABTUXDVFUKVUEABTTUKTTUKXIAXJUSXLWQXKXHZWLUWQTVJAVVAUSZWMWNABT
      TUWQUEVUFVUGVWAWMABUWQUYFUXATUWQUYFVJAQUAXMUSZUWQUUAXNSAQUAUUBUSZUYJUWTUW
      SVUCUYTXDZAUYBUYDBUYFUXAVFZUYHSVWEXOSUYCUYEAVWEBUYFUWRFUFZVFUYHABUYFUXAVW
      FUYJVWFUXAUYJUYKUXATSVWFUXAVIUYRVWDBTUXATFMWCWDWEWFABTTUYFFBFBTUXAVFZMBTU
      XAWGWHAFVWGVUEMABUWTUWSTVUHABTUWSVFUEVUEABTTUETTUEXIAUUFUSXLWJXKXHWLVUIWM
      WNQUAVWEXPXGXQABUWQUYFUXQTVWBVWCUYJUXOUXPUYJUXNUXDUYJIUXGAVVCUYIVVDVSUYJU
      WSUXFUYTAVVFUYIVVHVSWBZXDUYIVVKAVULVPXDUYIVUKAVUMVPXDZAUYBUYDBUYFUXQVFZUY
      HSVWJXOSUYCUYEAVWJBUYFUWRGUFZVFUYHABUYFUXQVWKUYJVWKUXQUYJUYKUXQTSVWKUXQVI
      UYRVWIBTUXQTGNWCWDWEWFABTTUYFGBGBTUXQVFZNBTUXQWGWHAGVWLVUENABUXOUXPTVVTAV
      UOVUNVUESVUPBTUKVUNVUNXRWRWSXHWLVUIWMWNQUAVWJXPXGXQABUWTUXORUBUUCUUDUFZUU
      GUUEUFZTRUWQUYFRRTUUHSZARTUUIUUJUSZAUWRRSZVHZUWSIVWQUYSAVWQUWRUWRUUKZVQZV
      PZAVUAVWQVUBVSWBVWRUXNUXDVWRIUXGAVVCVWQVVDVSVWRUWSUXFVXAAVVFVWQVVHVSWBXDV
      WQVVKAVWQUWRVWSWOZVPZXDZARCRYCZYNUCZTCYNUCZRYCZRBRUWTVFZYNUCZBRUXOVFZAVWO
      TTCXIVVQRVXGXNZVJVXFVXHVIVWPABTUWTTCAUYKVHUWSIUYKUYSAUWRUULVPAVUAUYKVUBVS
      WBJUUMVVRAREXNZVXLAVWQUWRVXMSZUUNZBUUORVXMVJAVXOBAVWQVXNVWRUWRUXOUUPSZBTU
      UQZVXMVWRUYKVXPUWRVXQSVWQUYKAVWSVPVWRVUTVXPVXDUXOTUURWSVXPBTUUTUUSBTUXOEL
      UVAUVBUVTUVCBRVXMBRWIBEVVPUVDUVEUVJAVXGEATVUDYNUCVVOVXGEABIPUVFCVUDTYNJXS
      LUVGZUVHUVITRCUVKUVLVXFVXJVIAVXEVXIRYNVXEVUDRYCZVXICVUDRJXTRTVJZVXSVXIVIV
      NBTRUWTYAVMYBXSUSAVXHERYCZVXKAVXGERVXRUVMVYAVVORYCZVXKEVVORLXTVXTVYBVXKVI
      VNBTRUXOYAVMYBYDUVNUYMAUYOUSZVWNVWNXRZUVOZVYDAUYLUYFVWMUVPUFUFUWQVIUYLAUY
      NUSQUAUVQWSZYEABUXPUWSRVWMVWNTRUWQUYFVWPVWQVUKAVWQUXDVXBWPVPVXAARBRUXPVFY
      NUCBRUWSUJZUJZVFBRUWSVFABUXDVYGRTRVWPVXCVWQVYGTSAVWQUWSVWTWPVPRBRUXDVFYNU
      CBRVYGVFVIABUVRUSUVSABRVYHUWSVWQVYHUWSVIAVWQUWSVWTYFVPWFYGVYCVYEVYDVYFYEA
      UWRQVIZVHZUWTUXPUHUCZQUXPUHUCZQVYJUWTQUXPUHVYJUWTQIUGUCZQVYIUWTVYMVIZAVYI
      UWSQIUGVYIUWSQUEUFQUWRQUEYHUWAYDYIVPVYJIAVVGVYIPVSYJYGYIVYJUXPVYIVUKAVYIU
      YKVUKVYIUWRQTVYIYKUOYLUYKUXDUWRUWBWPWSVPYMYGAUWRUAVIZVHZVYKVYLQVYPUWTQUXP
      UHVYPUWTVYMQVYOVYNAVYOUWSQIUGVYOUWSUAUEUFQUWRUAUEYHUWCYDYIVPVYPIAVVGVYOPV
      SYJYGYIVYPUXPVYOVUKAVYOUXDVYOUWRVYOUWRUATVYOYKUAUTUWDYLWOWPVPYMYGUWEUXSUY
      AVIAUXRUWKUSUWFAUXRUXJAUXRBUWQUXCUXHUHUCZUIUXJABUWQUXQVYQVUSUXOUXDUHUCZUJ
      IUXHUHUCZUJUXQVYQVUSVYRVYSVUSVYRUXNUXDUXDUHUCZUHUCZIUXGUXEUHUCZUHUCZVYSVU
      SUXNUXDUXDVVJVVMVVMYOVUSWUAUXNUXEUHUCWUCVUSVYTUXEUXNUHVURVYTUXEVIZAVURVVK
      WUDVVLVVKUXEVYTUXDUWGWEWSVPYPVUSIUXGUXEVVEVVIVURUXETSZAVURUXDVVLYQVPZYOYG
      VUSWUBUXHIUHVUSUXGUXEVVIWUFUWHYPYRYSVUSUXOUXDVVNVVMUWIVUSIUXHVVEVUSUXEUXG
      WUFVVIXDZYTUWJUWLABUWQUXHUXCTAIVVDWPWUGABUWQUYFUXHTVWBVWCUYJUXEUXGUYIWUEA
      UYIUXDVULYQVPVWHXDZAUYBUYDBUYFUXHVFZUYHSWUIXOSUYCUYEAWUIBUYFUWRHUFZVFUYHA
      BUYFUXHWUJUYJWUJUXHUYJUYKUXHTSWUJUXHVIUYRWUHBTUXHTHOWCWDWEWFABTTUYFHBHBTU
      XHVFZOBTUXHWGWHAHWUKVUEOABUXEUXGTABTUKULBUKWIVUPULWASAUWMUSWKVVSXHWLVUIWM
      WNQUAWUIXPXGXQZUWNUWOYSYGAUXJUXMAIUXIVVDABUWQUXHTWUGWULUWPZYTYSAUXLAIUXIV
      VDWUMXDYFYR $.
  $}

  ${
    $d n x N $.  $d n x ph $.
    itgsinexp.1 $e |- I = ( n e. NN0 |-> S. ( 0 (,) pi )
      ( ( sin ` x ) ^ n ) _d x ) $.
    itgsinexp.2 $e |- ( ph -> N e. ( ZZ>= ` 2 ) ) $.
    $( A recursive formula for the integral of sin^N on the interval (0,&pi;) .

       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    itgsinexp $p |- ( ph -> ( I ` N ) =
      ( ( ( N - 1 ) / N ) x. ( I ` ( N - 2 ) ) ) )
                  $=
      ( cmul co c1 cmin c2 wcel cc a1i cc0 cpi cexp cmpt wceq cfv cdiv caddc cz
      cuz eluzelz zcn 3syl ax-1cn npcand eqcomd oveq1d cn uz2m1nn nncnd cioo cv
      syl csin citg cn0 cvv oveq2 ad2antlr itgeq2dv npcan syl2anc uznn0sub 2nn0
      wa nn0addcld eqeltrd itgex fvmptd cr ioossre ax-resscn sstri sseli sincld
      2cn adantl adantr expcld cicc wss ioossicc cvol cdm ioombl 0re pire mp2an
      iccssre cibl eqid fvmpt2 mpteq2dva nfmpt1 nfcv expcnfg cncfmptss cniccibl
      ccncf sincn syl3anc iblss itgcl adddird mulid2d oveq2d clt eluz2b2 simpld
      eqtrd wbr sylib expm1t syl2anr ccos itgsinexplem1 subsub4d 1p1e2 sincossq
      sincl sqcld subaddd mpbird nnm1nn0 subdird expaddd pncan3d eqtr3d oveq12d
      cneg coscl itgsub 3eqtrd subdid mulcld 3eqtr2d nnne0d divcan3d 3eqtr3d
      mpbid div23d ) AEEDUAZHIZEUBIEJKIZELKIZDUAZHIZEUBIUUGUUIEUBIUUKHIAUUHUULE
      UBAUUHUUIJUCIZUUGHIZUUIUUGHIZUUGUCIZUULAEUUMUUGHAUUMEAEJAELUEUAMZEUDMENMZ
      GLEUFEUGUHZJNMZAUIOZUJUKULAUUNUUOJUUGHIZUCIUUPAUUIJUUGAUUIAUUQUUIUMMZGEUN
      URZUOZUVAAUUGBPQUPIZBUQZUSUAZERIZUTZNACEBUVFUVHCUQZRIZUTZUVJVADVBDCVAUVMS
      TAFOZAUVKETZVJBUVFUVLUVIUVOUVLUVITAUVGUVFMZUVKEUVHRVCVDVEAEUUJLUCIZVAAUUR
      LNMZEUVQTUUSUVRAWAOZUURUVRVJUVQEELVFUKVGAUUJLAUUQUUJVAMZGLEVHURLVAMZAVIOV
      KVLZUVJVBMABUVFUVIVMOVNZABUVFUVINAUVPVJZUVHEUVPUVHNMZAUVPUVGUVFNUVGUVFVON
      PQVPVQVRVSZVTZWBZAEVAMZUVPUWBWCWDZABUVFPQWEIZUVINUVFUWKWFAPQWGOZUVFWHWIMA
      PQWJOZAUVGUWKMZVJZUVHEUWNUWEAUWNUVGUWKNUVGUWKVONPVOMZQVOMZUWKVOWFWKWLPQWN
      WMVQVRZVSZVTWBZAUWIUWNUWBWCWDZAUWPUWQBUWKUVISZUWKNXDIZMUXBWOMUWPAWKOZUWQA
      WLOZAUXBBUWKUVGBNUVISZUAZSUXCABUWKUVIUXGUWOUXGUVIUWOUVGNMZUVINMUXGUVITUWN
      UXHAUWSWBZUXABNUVINUXFUXFWPWQVGUKWRABNNUWKUXFBNUVIWSABNUSEBUSWTZUSNNXDIMA
      XEOZUWBXAUWKNWFAUWROZXBVLPQUXBXCXFXGZXHVLZXIAUVBUUGUUOUCAUUGUXNXJXKXOAUUL
      UUOKIZUUGTUUPUULTAUUGUXOAUUGUUIBUVFUVHUUJRIZUTZUVJKIZHIZUUIUUKUUGKIZHIUXO
      AUUGUVJBUVFUVHUUIRIZUVHHIZUTZUXSUWCABUVFUVIUYBUVPUWEEUMMZUVIUYBTAUWGAUYDJ
      EXLXPZAUUQUYDUYEVJGEXMXQXNZUVHEXRXSVEAUYCUUIBUVFUVGXTUAZLRIZUVHUUIJKIZRIZ
      HIZUTZHIUUIBUVFUYHUXPHIZUTZHIUXSABBNUYASZBNUYGYOZSZBNUUIUYJHIUYGHIZSZBNUY
      BSZBNUYRUYPHISZBNUYKSZUUIUYOWPUYQWPUYSWPUYTWPVUAWPVUBWPUVDYAAUYLUYNUUIHAB
      UVFUYKUYMUWDUYJUXPUYHHUWDUYIUUJUVHRAUYIUUJTUVPAUYIEJJUCIZKIUUJAEJJUUSUVAU
      VAYBAVUCLEKVUCLTAYCOXKXOZWCXKXKVEXKAUYNUXRUUIHAUYNBUVFJUVHLRIZKIZUXPHIZUT
      BUVFUXPUVIKIZUTUXRABUVFUYMVUGUVPUYMVUGTAUVPUYHVUFUXPHUVPUXHUYHVUFTUWFUXHV
      UFUYHUXHVUFUYHTVUEUYHUCIJTUVGYDUXHJVUEUYHUUTUXHUIOUXHUVHUVGYEYFUXHUYGUVGY
      PYFYGYHUKURULWBVEABUVFVUGVUHUWDVUGJUXPHIZVUEUXPHIZKIVUHUWDJVUEUXPUUTUWDUI
      OUVPVUENMAUVPUVHUWGYFWBUWDUVHUUJUWHAUVTUVPAUUJUYIVAAUYIUUJVUDUKAUVCUYIVAM
      UVDUUIYIURVLZWCZWDZYJUWDVUIUXPVUJUVIKUWDUXPVUMXJUWDUVHLUUJUCIZRIZVUJUVIUW
      DUVHLUUJUWHVULUWAUWDVIOYKAVUOUVITUVPAVUNEUVHRALEUVSUUSYLXKWCYMYNXOVEABUVF
      UXPUVINVUMABUVFUWKUXPNUWLUWMUWOUVHUUJUWTAUVTUWNVUKWCWDZAUWPUWQBUWKUXPSZUX
      CMVUQWOMUXDUXEAVUQBUWKUVGBNUXPSZUAZSUXCABUWKUXPVUSUWOVUSUXPUWOUXHUXPNMVUS
      UXPTUXIVUPBNUXPNVURVURWPWQVGUKWRABNNUWKVURBNUXPWSABNUSUUJUXJUXKVUKXAUXLXB
      VLPQVUQXCXFXGZUWJUXMYQYRXKYRYRAUXTUXRUUIHAUUKUXQUUGUVJKACUUJUVMUXQVADVBUV
      NUVKUUJTZUVMUXQTAVVABUVFUVLUXPVVAUVLUXPTUVPUVKUUJUVHRVCWCVEWBVUKUXQVBMABU
      VFUXPVMOVNZUWCYNXKAUUIUUKUUGUVEAUUKUXQNVVBABUVFUXPNVUMVUTXHVLZUXNYSUUAUKA
      UULUUOUUGAUUIUUKUVEVVCYTAUUIUUGUVEUXNYTUXNYGUUEYRULAUUGEUXNUUSAEUYFUUBZUU
      CAUUIUUKEUVEVVCUUSVVDUUFUUD $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Stone Weierstrass theorem - real version
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    stoweidlem1.1 $e |- ( ph -> N e. NN ) $.
    stoweidlem1.2 $e |- ( ph -> K e. NN ) $.
    stoweidlem1.3 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem1.5 $e |- ( ph -> A e. RR+ ) $.
    stoweidlem1.6 $e |- ( ph -> 0 <_ A ) $.
    stoweidlem1.7 $e |- ( ph -> A <_ 1 ) $.
    stoweidlem1.8 $e |- ( ph -> D <_ A ) $.
    $( Lemma for ~ stoweid .  This lemma is used by Lemma 1 in
       [BrosowskiDeutsh] p. 90; the key step uses Bernoulli's inequality
       ~ bernneq .  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem1 $p |- ( ph ->
          ( ( 1 - ( A ^ N ) ) ^ ( K ^ N ) ) <_ ( 1 / ( ( K x. D ) ^ N ) ) ) $=
      ( c1 cexp co cr wcel cc0 cle wbr cmin c2 cmul cdiv 1re a1i rpred reexpcld
      nnnn0d resubcld nn0expcld cn0 nn0mulcld nnred remulcld nncnd rpcnd nnne0d
      2nn0 wne rpne0d mulne0d cc cn mulcld expne0 syl2anc mpbird redivcld caddc
      readdcld exple1 syl31anc subge0d expge0d expcld addid2d 0re 0le1 leadd1dd
      wb dividd eqbrtrrd cz nnzd nngt0d rpgt0d mulgt0d expgt0 syl3anc syl112anc
      clt lediv1 mulexpd oveq2d oveq1d breqtrd lemulge11d ax-1cn subcld divassd
      mpbid addcld breqtrrd mulcomd cneg renegcld le0neg2 ax-mp bernneq eqbrtrd
      mpbi letrd lemul2ad wceq subsq sq1 expmuld 2cn eqtr3d oveq12d 3eqtr3d jca
      wa 1m1e0 syl5eqbr subled jca32 mulge0d leexp1a syl32anc lediv12a syl12anc
      ltled ) AMBENOZUAOZDENOZNOZMBUBEUCOZNOZUAOZYQNOZDBUCOZENOZUDOZMDCUCOZENOZ
      UDOZAYPYQAMYOMPQZAUEUFZABEABIUGZAEFUIZUHZUJZADEADGUIUULUKZUHZAUUBUUDAUUAY
      QAMYTUUJABYSUUKAUBEUBULQAUSUFZUULUMZUHZUJZUUOUHZAUUCEADBADGUNZUUKUOZUULUH
      ZAUUDRUTZUUCRUTZADBADGUPZABIUQZADGURZABIVAVBAUUCVCQEVDQZUVEUVFWAADBUVGUVH
      VEZFUUCEVFVGVHZVIAMUUGUUJAUUFEADCUVBACHUGZUOZUULUHZAUUGRUTZUUFRUTZADCUVGA
      CHUQZUVIACHVAVBAUUFVCQUVJUVPUVQWAADCUVGUVRVEFUUFEVFVGVHVIAYRYRMYOVJOZYQNO
      ZUCOZUUDUDOZUUESAYRYRMYQYOUCOZVJOZUCOZUUDUDOZUWBUUPAUWEUUDAYRUWDUUPAMUWCU
      UJAYQYOADEUVBUULUHUUMUOVKZUOZUVDUVLVIAUWAUUDAYRUVTUUPAUVSYQAMYOUUJUUMVKUU
      OUHZUOZUVDUVLVIAYRYRUWDUUDUDOZUCOUWFSAYRUWKUUPAUWDUUDUWGUVDUVLVIAYPYQUUNU
      UOARYPSTYOMSTZABPQZRBSTZBMSTZEULQZUWLUUKJKUULBEVLVMAMYOUUJUUMVNVHVOZAMMUU
      DVJOZUUDUDOZUWKSAUUDUUDUDOZMUWSSAUUDAUUCEUVKUULVPZUVLWBAUUDUWRSTZUWTUWSST
      ZARUUDVJOUUDUWRSAUUDUXAVQARMUUDRPQAVRUFZUUJUVDRMSTZAVSUFVTWCAUUDPQZUWRPQU
      XFRUUDWLTZUXBUXCWAUVDAMUUDUUJUVDVKUVDAUUCPQZEWDQZRUUCWLTUXGUVCAEFWEZADBUV
      BUUKADGWFZABIWGWHUUCEWIWJZUUDUWRUUDWMWKXBWCAUWRUWDUUDUDAUUDUWCMVJADBEUVGU
      VHUULWNWOWPWQWRAYRUWDUUDAYPYQAMYOMVCQZAWSUFZABEUVHUULVPZWTZUUOVPAMUWCUXNA
      YQYOADEUVGUULVPZUXOVEXCUXAUVLXAXDAUWEUWASTZUWFUWBSTZAUWDUVTYRUWGUWIUUPUWQ
      AUWDMYOYQUCOZVJOZUVTSAUWCUXTMVJAYQYOUXQUXOXEWOAYOPQYQULQZMXFZYOSTUYAUVTST
      UUMUUOAUYCRYOAMUUJXGUXDUUMUYCRSTZAUXEUYDVSUUIUXEUYDWAUEMXHXIXLUFABEUUKUUL
      JVOXMYOYQXJWJXKXNAUWEPQUWAPQUXFUXGUXRUXSWAUWHUWJUVDUXLUWEUWAUUDWMWKXBXMAU
      WAUUBUUDUDAYPUVSUCOZYQNOUVSYPUCOZYQNOUWAUUBAUYEUYFYQNAYPUVSUXPAMYOUXNUXOX
      CZXEWPAYPUVSYQUXPUYGUUOWNAUYFUUAYQNAMUBNOZYOUBNOZUAOZUYFUUAAUXMYOVCQUYJUY
      FXOUXNUXOMYOXPVGAUYHMUYIYTUAUYHMXOAXQUFABEUBUCOZNOUYIYTABEUBUVHUUQUULXRAU
      YKYSBNAEUBAEFUPUBVCQAXSUFXEWOXTYAXTWPYBWPWQAUUBPQZUUIYDZRUUBSTZUUBMSTZYDY
      DUUGPQZUXFYDRUUGWLTZUUGUUDSTZYDUUEUUHSTAUYMUYNUYOAUYLUUIUVAUUJYCAUUAYQUUT
      UUOARUUASTZYTMSTZAUWMUWNUWOYSULQUYTUUKJKUURBYSVLVMAMYTUUJUUSVNVHZVOAUUAPQ
      UYSUUAMSTUYBUYOUUTVUAAMMYTUUJUUJUUSAMMUAORYTSYEABYSUUKUURJVOYFYGUUOUUAYQV
      LVMYHAUYPUXFUVOUVDYCAUYQUYRAUUFPQZUXIRUUFWLTUYQUVNUXJADCUVBUVMUXKACHWGZWH
      UUFEWIWJAVUBUXHUWPRUUFSTUUFUUCSTUYRUVNUVCUULADCUVBUVMARDUXDUVBUXKYNZARCUX
      DUVMVUCYNYIACBDUVMUUKUVBVUDLXNUUFUUCEYJYKYCUUBMUUGUUDYLYMXM $.
  $}

  ${
    $d f g t F $.  $d f s t E $.  $d f g A $.  $d f g t T $.  $d f g ph $.
    $d s t T $.  $d t x E $.  $d x A $.  $d x T $.  $d x ph $.
    stoweidlem2.1 $e |- F/ t ph $.
    stoweidlem2.2 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem2.3 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem2.4 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem2.5 $e |- ( ph -> E e. RR ) $.
    stoweidlem2.6 $e |- ( ph -> F e. A ) $.
    $( lemma for ~ stoweid : here we prove that the subalgebra of continuous
       functions, which contains constant functions, is closed under scaling.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem2 $p |- ( ph -> ( t e. T |-> ( E x. ( F ` t ) ) ) e. A ) $=
      ( cv cmul cmpt wcel wi vs co wa cr wceq simpr adantr eqidd cbvmptv fvmpt2
      cfv syl2anc eqcomd oveq1d mpteq2da id mpteq2dv eleq1d imbi2d expcom mpcom
      vtoclga syl5eqel fveq1 oveq2d 3comr 3expib eqeltrd ) ACEHCPZIUKZQUBZRCEVI
      UAEHRZUKZVJQUBZRZDACEVKVNJAVIESZUCZHVMVJQVQVMHVQVPHUDSZVMHUEAVPUFAVRVPNUG
      CEHUDVLUACEHHUAPVIUEHUHUIZUJULUMUNUOVLDSAVODSZAVLCEHRZDVSVRAWADSZNACEBPZR
      ZDSZTAWBTBHUDWCHUEZWEWBAWFWDWADWFCEWCHWFUPUQURUSAWCUDSWELUTVBVAVCACEVIFPZ
      UKZVJQUBZRZDSZTAVTTFVLDWGVLUEZWKVTAWLWJVODWLCEWIVNWLWHVMVJQVIWGVLVDUNUQUR
      USAWGDSZWKIDSZAWMUCZWKAWNWMOUGWOCEWHVIGPZUKZQUBZRZDSZTWOWKTGIDWPIUEZWTWKW
      OXAWSWJDXACEWRWIXAWQVJWHQVIWPIVDVEUQURUSWPDSZAWMWTAWMXBWTKVFVGVBVAUTVBVAV
      H $.
  $}

  ${
    $d a i m z $.  $d a j m M $.  $d a j F $.  $d a j m ph $.  $d i m z A $.
    $d i m M $.  $d m n A $.  $d m n X $.  $d n M $.  $d n ph $.  $d z F $.
    stoweidlem3.1 $e |- F/_ i F $.
    stoweidlem3.2 $e |- F/ i ph $.
    stoweidlem3.3 $e |- X = seq 1 ( x. , F ) $.
    stoweidlem3.4 $e |- ( ph -> M e. NN ) $.
    stoweidlem3.5 $e |- ( ph -> F : ( 1 ... M ) --> RR ) $.
    stoweidlem3.6 $e |- ( ( ph /\ i e. ( 1 ... M ) ) -> A < ( F ` i ) ) $.
    stoweidlem3.7 $e |- ( ph -> A e. RR+ ) $.
    $( Lemma for ~ stoweid : if ` A ` is positive and all ` M ` terms of a
       finite product are larger than ` A ` , then the finite product is larger
       than A^M. (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem3 $p |- ( ph -> ( A ^ M ) < ( X ` M ) ) $=
      ( c1 co wcel cfv clt wbr cr vn vm va vj cfz cexp cuz elnnuz sylib eluzfz2
      cn syl cv wi caddc wceq oveq2 fveq2 breq12d imbi2d weq wa cz w3a cle nnzd
      1z a1i 3jca 1le1 nnge1d jca32 elfz2 sylibr ancli nfcv nfan nffv nfbr nfim
      nfv eleq1 anbi2d breq2d imbi12d vtoclgf sylc rpcnd exp1d cmul cseq fveq1i
      seq1 ax-mp eqtri 3brtr4d cfzo crp 3ad2ant3 rpred cn0 elfzouz nnnn0 sylbir
      3ad2ant1 reexpcld adantr nfel1 eleq1d wf ad2antlr elfzelz adantl elfzoelz
      elfzle1 zred ad2antrr nnred elfzle2 elfzoel2 elfzolt2 ltled letrd remulcl
      ffvelrnd chvar seqcl syl5eqel 3adant2 fzofzp1 cc0 expge0d simp3 simp2 mpd
      rpge0d simpr jca ltmul12ad cc expp1d seqp1 eqcomd oveq1d 3eqtrd fzind2
      3exp mpcom ) ENEUEOZPZABEUFOZEFQZRSZAENUGQZPZUUJAEUKPUUOJEUHUINEUJULABUAU
      MZUFOZUUPFQZRSZUNABNUFOZNFQZRSZUNZABUBUMZUFOZUVDFQZRSZUNZABUVDNUOOZUFOZUV
      IFQZRSZUNAUUMUNUAUBENEUUPNUPZUUSUVBAUVMUUQUUTUURUVARUUPNBUFUQUUPNFURUSUTU
      AUBVAZUUSUVGAUVNUUQUVEUURUVFRUUPUVDBUFUQUUPUVDFURUSUTUUPUVIUPZUUSUVLAUVOU
      UQUVJUURUVKRUUPUVIBUFUQUUPUVIFURUSUTUUPEUPZUUSUUMAUVPUUQUUKUURUULRUUPEBUF
      UQUUPEFURUSUTUVCUUOABNDQZUUTUVARANUUIPZAUVRVBZBUVQRSZANVCPZEVCPZUWAVDZNNV
      ESZNEVESZVBVBUVRAUWCUWDUWEAUWAUWBUWAUWAAVGVHZAEJVFZUWFVIUWDAVJVHAEJVKVLNN
      EVMVNZAUVRUWHVOACUMZUUIPZVBZBUWIDQZRSZUNZUVSUVTUNCNUUICNVPZUVSUVTCAUVRCHU
      VRCWAVQCBUVQRCBVPZCRVPZCNDGUWOVRVSVTUWINUPZUWKUVSUWMUVTUWRUWJUVRAUWINUUIW
      BWCUWRUWLUVQBRUWINDURWDWELWFWGABABMWHZWIUVAUVQUPAUVANWJDNWKZQZUVQNFUWTIWL
      UWAUXAUVQUPVGWJDNWMWNWOVHWPVHUVDNEWQOPZUVHAUVLUXBUVHAVDZUVEBWJOUVFUVIDQZW
      JOZUVJUVKRUXCUVEUVFBUXDUXCBUVDUXCBAUXBBWRPUVHMWSWTZUXBUVHUVDXAPZAUXBUVDUU
      NPZUXGUVDNEXBZUXHUVDUKPUXGUVDUHUVDXCXDULXEZXFUXBAUVFTPUVHUXBAVBZUVFUVDUWT
      QZTUVDFUWTIWLZUXKUCUDWJTDNUVDUXBUXHAUXIXGUXKUWINUVDUEOZPZVBZUWLTPZUNUXKUC
      UMZUXNPZVBZUXRDQZTPZUNCUCUXTUYBCUXKUXSCUXBACUXBCWAHVQUXSCWAVQCUYATCUXRDGC
      UXRVPVRXHVTCUCVAZUXPUXTUXQUYBUYCUXOUXSUXKUWIUXRUXNWBWCUYCUWLUYATUWIUXRDUR
      XIWEUXPUUITUWIDAUUITDXJZUXBUXOKXKUXPUWAUWBUWIVCPZVDZNUWIVESZUWIEVESZVBVBU
      WJUXPUYFUYGUYHUXPUWAUWBUYEUWAUXPVGVHAUWBUXBUXOUWGXKUXOUYEUXKUWINUVDXLZXMV
      IUXOUYGUXKUWINUVDXOXMUXPUWIUVDEUXOUWITPUXKUXOUWIUYIXPXMUXBUVDTPAUXOUXBUVD
      UVDNEXNXPZXQAETPUXBUXOAEJXRXKUXOUWIUVDVESUXKUWINUVDXSXMUXBUVDEVESAUXOUXBU
      VDEUYJUXBEUVDNEXTXPUVDNEYAYBXQYCVLUWINEVMVNYEYFUXRTPUDUMZTPVBUXRUYKWJOTPU
      XKUXRUYKYDXMYGYHYIUXFUXCUUITUVIDAUXBUYDUVHKWSUXBUVHUVIUUIPZANEUVDYJZXEYEU
      XCBUVDUXFUXJAUXBYKBVESUVHABMYPWSZYLUXCAUVGUXBUVHAYMUXBUVHAYNYOUYNUXBABUXD
      RSZUVHUXKUYLAUYLVBZUYOUXBUYLAUYMXGZUXKAUYLUXBAYQUYQYRUWNUYPUYOUNCUVIUUICU
      VIVPZUYPUYOCAUYLCHUYLCWAVQCBUXDRUWPUWQCUVIDGUYRVRVSVTUWIUVIUPZUWKUYPUWMUY
      OUYSUWJUYLAUWIUVIUUIWBWCUYSUWLUXDBRUWIUVIDURWDWELWFWGYIYSUXCBUVDAUXBBYTPU
      VHUWSWSUXJUUAUXCUVKUVIUWTQZUXLUXDWJOZUXEUVKUYTUPUXCUVIFUWTIWLVHUXCUXHUYTV
      UAUPUXBUVHUXHAUXIXEWJDNUVDUUBULUXCUXLUVFUXDWJUXCUVFUXLUVFUXLUPUXCUXMVHUUC
      UUDUUEWPUUGUUFUUH $.
  $}

  ${
    $d t x B $.  $d x A $.  $d x T $.  $d x ph $.
    stoweidlem4.1 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    $( Lemma for ~ stoweid : a class variable replaces a set variable, for
       constant functions.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem4 $p |- ( ( ph /\ B e. RR ) -> ( t e. T |-> B ) e. A ) $=
      ( cr wcel cmpt cv wa wi wceq eleq1 anbi2d simpl mpteq2dva eleq1d imbi12d
      vtoclg anabsi7 ) AEHIZCFEJZDIZABKZHIZLZCFUFJZDIZMAUCLZUEMBEHUFENZUHUKUJUE
      ULUGUCAUFEHOPULUIUDDULCFUFEULCKFIQRSTGUAUB $.
  $}

  ${
    $d d t D $.  $d d P $.  $d d Q $.
    stoweidlem5.1 $e |- F/ t ph $.
    stoweidlem5.2 $e |- D = if ( C <_ ( 1 / 2 ) , C , ( 1 / 2 ) ) $.
    stoweidlem5.3 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem5.4 $e |- ( ph -> Q C_ T ) $.
    stoweidlem5.5 $e |- ( ph -> C e. RR+ ) $.
    stoweidlem5.6 $e |- ( ph -> A. t e. Q C <_ ( P ` t ) ) $.
    $( There exists a &delta; as in the proof of Lemma 1 in [BrosowskiDeutsh]
       p. 90: 0 < &delta; < 1 , p >= &delta; on ` T \ U ` .  Here ` D ` is used
       to represent &delta; in the paper and ` Q ` to represent ` T \ U ` in
       the paper.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem5 $p |- ( ph
       -> E. d ( d e. RR+ /\ d < 1 /\ A. t e. Q d <_ ( P ` t ) ) ) $=
      ( crp wcel c1 wbr cle cr clt cv cfv wral w3a wex c2 cdiv co cif rehalfcli
      1re halfgt0 ifcl sylancl syl5eqel rpred a1i min2 syl5eqbr halflt1 lelttrd
      elrpii wa adantr wf ffvelrnd min1 r19.21bi letrd ex ralrimi wi wceq eleq1
      sselda breq1 ralbidv 3anbi123d spcegv syl mp3and ) ADOPZDQUARZDBUBZEUCZSR
      ZBFUDZHUBZOPZWIQUARZWIWFSRZBFUDZUEZHUFZADCQUGUHUIZSRZCWPUJZOJACOPWPOPWROP
      MWPQULUKZUMVCWQCWPOUNUOZUPZADWPQADXAUQWPTPZAWSURQTPAULURADWRWPSJACTPZXBWR
      WPSRACMUQZWSCWPUSUOUTWPQUARAVAURVBAWGBFIAWEFPZWGAXEVDZDWRWFSJXFWRCWFAWRTP
      XEAWRWTUQVEAXCXEXDVEXFGTWEEAGTEVFXEKVEAFGWELVPVGAWRCSRZXEAXCXBXGXDWSCWPVH
      UOVEACWFSRBFNVIVJUTVKVLAWCWCWDWHUEZWOVMXAWNXHHDOWIDVNZWJWCWKWDWMWHWIDOVOW
      IDQUAVQXIWLWGBFWIDWFSVQVRVSVTWAWB $.
  $}

  ${
    $d f g t z $.  $d f g A $.  $d f g z F $.  $d f g T $.  $d f g ph $.
    $d g z G $.
    stoweidlem6.1 $e |- F/ t f = F $.
    stoweidlem6.2 $e |- F/ t g = G $.
    stoweidlem6.3 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    $( Lemma for ~ stoweid : two class variables replace two set variables, for
       multiplication of two functions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem6 $p |- ( ( ph /\ F e. A /\ G e. A ) ->
          ( t e. T |-> ( ( F ` t ) x. ( G ` t ) ) ) e. A ) $=
      ( wcel w3a cv cfv cmul co cmpt wi wceq simp3 eleq1 3anbi3d fveq1 mpteq2da
      oveq2d adantr eleq1d imbi12d simp2 3anbi2d oveq1d vtoclg mpcom ) HCLZAGCL
      ZUOMZBDBNZGOZURHOZPQZRZCLZAUPUOUAAUPFNZCLZMZBDUSURVDOZPQZRZCLZSZUQVCSFHCV
      DHTZVFUQVJVCVLVEUOAUPVDHCUBUCVLVIVBCVLBDVHVAJVLVHVATURDLZVLVGUTUSPURVDHUD
      UFUGUEUHUIUPVFVJAUPVEUJAENZCLZVEMZBDURVNOZVGPQZRZCLZSVKEGCVNGTZVPVFVTVJWA
      VOUPAVEVNGCUBUKWAVSVICWABDVRVHIWAVRVHTVMWAVQUSVGPURVNGUDULUGUEUHUIKUMUNUM
      UN $.
  $}

  ${
    $d i k n A $.  $d i k n B $.  $d i k n E $.  $d i k n ph $.  $d k n F $.
    $d k n G $.
    stoweidlem7.1 $e |- F = ( i e. NN0 |-> ( ( 1 / A ) ^ i ) ) $.
    stoweidlem7.2 $e |- G = ( i e. NN0 |-> ( B ^ i ) ) $.
    stoweidlem7.3 $e |- ( ph -> A e. RR ) $.
    stoweidlem7.4 $e |- ( ph -> 1 < A ) $.
    stoweidlem7.5 $e |- ( ph -> B e. RR+ ) $.
    stoweidlem7.6 $e |- ( ph -> B < 1 ) $.
    stoweidlem7.7 $e |- ( ph -> E e. RR+ ) $.
    $( This lemma is used to prove that q_n as in the proof of Lemma 1 in
       [BrosowskiDeutsh] p. 91, (at the top of page 91), is such that q_n <
       &epsilon; on ` T \ U ` , and q_n > 1 - &epsilon; on ` V ` .  Here it is
       proven that, for ` n ` large enough, 1-(k*&delta;/2)^n > 1 - &epsilon; ,
       and 1/(k*&delta;)^n < &epsilon;.  The variable ` A ` is used to
       represent (k*&delta;) in the paper, and ` B ` is used to represent
       (k*&delta;/2).  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem7 $p |- ( ph -> E. n e. NN
          ( ( 1 - E ) < ( 1 - ( B ^ n ) ) /\ ( 1 / ( A ^ n ) ) < E ) ) $=
      ( c1 clt wbr wcel cc0 vk cmin co cv cexp cdiv wa cuz wral cn wrex cc cabs
      cfv nnuz cz a1i cn0 cmpt wceq weq oveq2 adantl nnnn0 adantr expcld fvmptd
      1z rpcnd cli cneg cr 1re renegcld 0re rpred 0lt1 ltnegi mpbi neg0 breqtri
      rpgt0d lttrd absltd mpbir2and expcnv syl5eqbr climi r19.26 simprbi oveq1d
      ad2antlr fveq2d rspccva sylancom crp simplll syl simpllr eluznn0 reexpcld
      breq1d wb rpre 3syl recn subid1d abslt bitrd mpbid simprd uznnssnn sselda
      syl2anc ltsub2d ralrimiva oveq2d breq2d cbvralv sylibr reximdva mpd recnd
      ex gt0ne0d reccld rereccld recgt0d ltdiv23 syl122anc ax-1cn mpbird climi2
      div1d wi simpll wss simpr sseldd eqtrd cle expge0d absidd biimpd ralimdva
      ltled rexanuz2 sylanbrc nnz uzid anbi12d wne expdiv syl3anc 1exp anbi2d
      jca ) APFUBUCZPCUAUDZUEUCZUBUCZQRZPBUFUCZUUSUEUCZFQRZUGZUAEUDZUHUNZUIZEUJ
      UKZUURPCUVGUEUCZUBUCZQRZPBUVGUEUCZUFUCZFQRZUGZEUJUKAUVBUAUVHUIZEUJUKZUVEU
      AUVHUIZEUJUKZUVJAUUTULSZUUTTUBUCZUMUNZFQRZUGUAUVHUIZEUJUKUVSATUUTFEUAHPUJ
      UOPUPSAVHUQZOAUUSUJSZUGZDUUSCDUDZUEUCZUUTURHULHDURUWKUSZUTUWIJUQDUAVAZUWK
      UUTUTUWIUWJUUSCUEVBVCUWHUUSURSAUUSVDVCZUWICUUSACULSUWHACMVIZVEUWNVFVGAHUW
      LTVJJACDUWOACUMUNPQRPVKZCQRCPQRAUWPTCAPPVLSZAVMUQZVNZTVLSAVOUQZACMVPZUWPT
      QRAUWPTVKZTQTPQRZUWPUXBQRVQTPVOVMVRVSVTWAUQZACMWBWCNACPUXAUWRWDWEWFWGWHAU
      WFUVREUJAUVGUJSZUGZUWFUVRUXFUWFUGZUURPUWKUBUCZQRZDUVHUIUVRUXGUXIDUVHUXGUW
      JUVHSZUGZUWKFQRZUXIUXKFVKUWKQRZUXLUXKUWKTUBUCZUMUNZFQRZUXMUXLUGZUXGUXJUWE
      UAUVHUIZUXPUWFUXRUXFUXJUWFUWBUAUVHUIUXRUWBUWEUAUVHWIWJWLUWEUXPUAUWJUVHUAD
      VAZUWDUXOFQUXSUWCUXNUMUXSUUTUWKTUBUUSUWJCUEVBZWKWMXBWNWOUXKUWKVLSZFVLSZUX
      PUXQXCUXKCUWJUXKCUXKACWPSAUXEUWFUXJWQZMWRVPUXGUXJUVGURSZUWJURSZUXKUXEUYDA
      UXEUWFUXJWSZUVGVDZWRUWJUVGWTWOXAUXKAFWPSUYBUYCOFXDXEUYAUYBUGZUXPUWKUMUNZF
      QRUXQUYHUXOUYIFQUYHUXNUWKUMUYAUXNUWKUTUYBUYAUWKUWKXFXGVEWMXBUWKFXHXIXNXJX
      KUXKAUWJUJSZUXLUXIXCUYCUXGUXJUXEUYJUYFUXEUVHUJUWJUVGXLZXMWOAUYJUGZUWKFPUY
      LCUWJACVLSUYJUXAVEUYJUYEAUWJVDVCXAAUYBUYJAFOVPVEUWQUYLVMUQXOXNXJXPUVBUXIU
      ADUVHUXSUVAUXHUURQUXSUUTUWKPUBUXTXQXRXSXTYDYAYBAUVDTUBUCZUMUNZFQRZUAUVHUI
      ZEUJUKUWAATUVDFEUAGPUJUOUWGOUWIDUUSUVCUWJUEUCZUVDURGULGDURUYQUSZUTUWIIUQU
      WMUYQUVDUTUWIUWJUUSUVCUEVBVCUWNUWIUVCUUSAUVCULSUWHABABKYCZABATPBUWTUWRKUX
      CAVQUQZLWCZYEZYFZVEUWNVFZVGAGUYRTVJIAUVCDVUCAUVCUMUNPQRUWPUVCQRUVCPQRZAUW
      PTUVCUWSUWTABKVUBYGZUXDABKVUAYHZWCAVUEPBQRZLAVUEPPUFUCZBQRZVUHAUWQBVLSTBQ
      RUWQUXCVUEVUJXCUWRKVUAUWRUYTPBPYIYJAVUIPBQAPPULSZAYKUQYNXBXIYLAUVCPVUFUWR
      WDWEWFWGYMAUYPUVTEUJUXFUYOUVEUAUVHUXFUUSUVHSZUGZAUWHUYOUVEYOAUXEVULYPVUMU
      VHUJUUSUXEUVHUJYQAVULUYKWLUXFVULYRYSUWIUYOUVEUWIUYNUVDFQUWIUYNUVDUMUNUVDU
      WIUYMUVDUMUWIUVDVUDXGWMUWIUVDUWIUVCUUSAUVCVLSUWHVUFVEZUWNXAUWIUVCUUSVUNUW
      NATUVCUUARUWHATUVCUWTVUFVUGUUFVEUUBUUCYTXBUUDXNUUEYAYBUVBUVEEUAPUJUOUUGUU
      HAUVIUVQEUJUXFUVIUVQUXFUVIUGZUVMUVCUVGUEUCZFQRZUGZUVQVUOUVIUVGUVHSZVURUXF
      UVIYRUXEVUSAUVIUXEUVGUPSZVUSUVGUUIZUVGUUJWRWLUVFVURUAUVGUVHUAEVAZUVBUVMUV
      EVUQVVBUVAUVLUURQVVBUUTUVKPUBUUSUVGCUEVBXQXRVVBUVDVUPFQUUSUVGUVCUEVBXBUUK
      WNXNVUOVUQUVPUVMUXFVUQUVPXCUVIUXFVUPUVOFQUXFVUPPUVGUEUCZUVNUFUCZUVOUXFVUK
      BULSZBTUULZUGZUYDVUPVVDUTVUKUXFYKUQAVVGUXEAVVEVVFUYSVUBUUQVEUXEUYDAUYGVCP
      BUVGUUMUUNUXFVVCPUVNUFUXFVUTVVCPUTUXEVUTAVVAVCUVGUUOWRWKYTXBVEUUPXJYDYAYB
      $.
  $}

  ${
    $d f g t z $.  $d f g A $.  $d f g z F $.  $d f g T $.  $d f g ph $.
    $d g z G $.
    stoweidlem8.1 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
         ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem8.2 $e |- F/_ t F $.
    stoweidlem8.3 $e |- F/_ t G $.
    $( Lemma for ~ stoweid : two class variables replace two set variables, for
       the sum of two functions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem8 $p |- ( ( ph /\ F e. A /\ G e. A ) ->
          ( t e. T |-> ( ( F ` t ) + ( G ` t ) ) ) e. A ) $=
      ( wcel w3a cv cfv caddc co cmpt wi wceq simp3 eleq1 3anbi3d oveq2d adantr
      nfeq2 fveq1 mpteq2da eleq1d imbi12d simp2 3anbi2d oveq1d vtoclg mpcom ) H
      CLZAGCLZUPMZBDBNZGOZUSHOZPQZRZCLZAUQUPUAAUQFNZCLZMZBDUTUSVEOZPQZRZCLZSZUR
      VDSFHCVEHTZVGURVKVDVMVFUPAUQVEHCUBUCVMVJVCCVMBDVIVBBVEHKUFVMVIVBTUSDLZVMV
      HVAUTPUSVEHUGUDUEUHUIUJUQVGVKAUQVFUKAENZCLZVFMZBDUSVOOZVHPQZRZCLZSVLEGCVO
      GTZVQVGWAVKWBVPUQAVFVOGCUBULWBVTVJCWBBDVSVIBVOGJUFWBVSVITVNWBVRUTVHPUSVOG
      UGUMUEUHUIUJIUNUOUNUO $.
  $}

  ${
    $d g t J $.  $d g A $.  $d g E $.  $d g F $.  $d g t T $.
    stoweidlem9.1 $e |- ( ph -> T = (/) ) $.
    stoweidlem9.2 $e |- ( ph -> ( t e. T |-> 1 ) e. A ) $.
    $( Lemma for ~ stoweid : here the Stone Weierstrass theorem is proven for
       the trivial case, T is the empty set.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem9 $p |- ( ph ->
          E. g e. A A. t e. T ( abs ` ( ( g ` t ) - ( F ` t ) ) ) < E ) $=
      ( c0 cv cfv cmin co cabs clt wbr wral c1 wceq wcel wrex mpteq1 syl6eq syl
      cmpt mpt0 eqeltrrd rzal fveq1 oveq1d fveq2d breq1d ralbidv rspcev syl2anc
      ) AJCUABKZJLZUQGLZMNZOLZFPQZBDRZUQEKZLZUSMNZOLZFPQZBDRZECUBABDSUFZJCADJTZ
      VJJTHVKVJBJSUFJBDJSUCBSUGUDUEIUHAVKVCHVBBDUIUEVIVCEJCVDJTZVHVBBDVLVGVAFPV
      LVFUTOVLVEURUSMUQVDJUJUKULUMUNUOUP $.
  $}

  $( Lemma for ~ stoweid .  This lemma is used by Lemma 1 in [BrosowskiDeutsh]
     p. 90, this lemma is an application of Bernoulli's inequality.
     (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
  stoweidlem10 $p |- ( ( A e. RR /\ N e. NN0 /\ A <_ 1 ) ->
    ( 1 - ( N x. A ) ) <_ ( ( 1 - A ) ^ N ) ) $=
    ( cr wcel c1 cle wbr w3a cneg cmul co caddc cexp 3ad2ant1 wa a1i cc 3adant3
    cmin wceq cn0 renegcl simp2 simpr simpl lenegd 3adant2 bernneq syl3anc recn
    mpbid nn0cn 3ad2ant2 ax-1cn mulneg1 oveq2d simp3 mulcl mulcom 3eqtrd oveq1d
    1re negsubd 3brtr3d ) ACDZBUADZAEFGZHZEAIZBJKZLKZEVILKZBMKZEBAJKZSKZEASKZBM
    KZFVHVICDZVFEIVIFGZVKVMFGVEVFVRVGAUBNVEVFVGUCVEVGVSVFVEVGOZVGVSVEVGUDVTAEVE
    VGUEECDVTVBPUFUKUGVIBUHUIVHAQDZBQDZEQDZVKVOTVEVFWAVGAUJZNVFVEWBVGBULUMWCVHU
    NPWAWBWCHZVKEABJKZIZLKZEWFSKZVOWAWBVKWHTWCWAWBOZVJWGELABUOUPRWEEWFWAWBWCUQW
    AWBWFQDWCABURRVCWAWBWIVOTWCWJWFVNESABUSUPRUTUIVEVFVMVQTVGVEVLVPBMVEEAWCVEUN
    PWDVCVANVD $.

  ${
    $d i j $.  $d i r t E $.  $d i r t N $.  $d i r ph $.  $d r t T $.
    $d r t X $.
    stoweidlem11.1 $e |- ( ph -> N e. NN ) $.
    stoweidlem11.2 $e |- ( ph -> t e. T ) $.
    stoweidlem11.3 $e |- ( ph -> j e. ( 1 ... N ) ) $.
    stoweidlem11.4 $e |- ( ( ph /\ i e. ( 0 ... N ) ) ->
          ( X ` i ) : T --> RR ) $.
    stoweidlem11.5 $e |- ( ( ph /\ i e. ( 0 ... N ) ) ->
          ( ( X ` i ) ` t ) <_ 1 ) $.
    stoweidlem11.6 $e |- ( ( ph /\ i e. ( j ... N ) ) ->
          ( ( X ` i ) ` t ) < ( E / N ) ) $.
    stoweidlem11.7 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem11.8 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( This lemma is used to prove that there is a function ` g ` as in the
       proof of [BrosowskiDeutsh] p. 92 (at the top of page 92): this lemma
       proves that g(t) < ( j + 1 / 3 ) * &epsilon;.  Here ` E ` is used to
       represent &epsilon; in the paper.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem11 $p |- ( ph -> ( ( t e. T |-> sum_ i e. ( 0 ... N )
          ( E x. ( ( X ` i ) ` t ) ) ) ` t ) < ( ( j + ( 1 / 3 ) ) x. E ) ) $=
      ( cc0 co c1 wcel cv cfz cfv cmul csu cmpt c3 cdiv caddc clt cvv wceq eqid
      sumex fvmpt2 sylancl cmin fzfid wa cr rpred ffvelrnd remulcld fsumrecl cz
      adantr cle wbr cuz w3a elfzuz syl eluz2 sylib zred nnred resubcld 1re a1i
      simp2d readdcld nndivred 3re wne 3ne0 rereccld elfzelz peano2zm 3syl nnzd
      wss lem1d elfzuz3 eluzle letrd syl3anbrc fzss2 sselda syldan cin c0 ltm1d
      fzdisj cun fzssp1 nncnd cc ax-1cn npcand oveq2d syl5sseq fzsubel syl22anc
      wb 1z mpbid 1m1e0 oveq1i syl6eleq sseldd fzsplit zcnd oveq1d eqtrd mulcld
      0z syl112anc cfn fsumconst syl2anc hashfz breqtrd ltadd2dd eqbrtrd subcld
      chash 3eqtrd mulcomd leadd2dd lemul2d uneq2d rpcnd recnd fsumsplit wf 0re
      0le1 simp3d fzss1 eluzfz2 ne0i 4syl cn rpgt0d ltmul2 fsumlt nnne0d divcld
      lemul2 mulid1d fsumle 1e0p1 fveq2i eluzp1m1 sylancr subid1d addcld mul12d
      leadd1dd ltletrd div12d elfzle1 suble0d addsub12d addcomd addid1d 3brtr3d
      mpbird nngt0d lediv1 dividd eqbrtrrd adddird eqtr4d ltmul1dd lelttrd
      lttrd ) ABUAZBCQGUBRZFUWHDUAZHUCZUCZUDRZDUEZUFZUCZUWNEUAZSUGUHRZUIRZFUDRZ
      UJAUWHCTZUWNUKTUWPUWNULJUWIUWMDUNBCUWNUKUWOUWOUMUOUPAUWNFUWQUDRZGUWQUQRZS
      UIRZFFGUHRZUDRZUDRZUIRZUWTAUWIUWMDAQGURZAUWJUWITZUSZFUWLAFUTTZUXJAFOVAZVF
      UXKCUTUWHUWKLAUXAUXJJVFVBZVCVDZAUXBUXGAFUWQUXMAUWQASVETZUWQVETZSUWQVGVHZA
      UWQSVIUCZTZUXPUXQUXRVJAUWQSGUBRTZUXTKUWQSGVKVLZSUWQVMVNZVTZVOZVCZAUXDUXFA
      UXCSAGUWQAGIVPZUYEVQSUTTZAVRVSZWAZAFUXEUXMAFGUXMIWBZVCVCZWAZAUWSFAUWQUWRU
      YEAUGUGUTTAWCVSUGQWDAWEVSWFZWAZUXMVCZAUWNQUWQSUQRZUBRZUWMDUEZUXGUIRZUXHUX
      OAUYSUXGAUYRUWMDAQUYQURZAUWJUYRTZUSZFUWLAUXLVUBUXMVFZAVUBUXJUWLUTTZAUYRUW
      IUWJAGUYQVIUCTZUYRUWIWKAUYQVETZGVETZUYQGVGVHVUFAUYAUXQVUGKUWQSGWGUWQWHWIA
      GIWJZAUYQUWQGAUWQSUYEUYIVQUYEUYGAUWQUYEWLAUYAGUWQVIUCTZUWQGVGVHKUWQSGWMZU
      WQGWNWIWOUYQGVMWPUYQQGWQVLWRZUXNWSZVCZVDZUYLWAUYMAUWNUYSUWQGUBRZUWMDUEZUI
      RUYTUJAUYRVUPUWMUWIDAUYQUWQUJVHUYRVUPWTXAULAUWQUYEXBQUYQUWQGXCVLAUWIUYRUY
      QSUIRZGUBRZXDZUYRVUPXDAUYQUWITUWIVUTULAQGSUQRZUBRZUWIUYQAQVVASUIRZUBRVVBU
      WIQVVAXEAVVCGQUBAGSAGIXFZSXGTAXHVSZXIXJXKAUYQSSUQRZVVAUBRZVVBAUYAUYQVVGTZ
      KAUXPVUHUXQUXPUYAVVHXNUXPAXOVSZVUIUYDVVIUWQSSGXLXMXPVVFQVVAUBXQXRXSXTUYQQ
      GYAVLAVUSVUPUYRAVURUWQGUBAUWQSAUWQUYDYBZVVEXIZYCUUAYDUXIUXKFUWLAFXGTZUXJA
      FOUUBZVFUXKUWLUXNUUCYEUUDAVUQUXGUYSAVUPUWMDAUWQGURZAUWJVUPTZUSZFUWLAUXLVV
      OUXMVFZVVPCUTUWHUWKAVVOUXJCUTUWKUUEAVUPUWIUWJAUWQQVIUCZTZVUPUWIWKAQVETZUX
      QQUWQVGVHVVSVVTAYFVSUYDAQSUWQQUTTAUUFVSZUYIUYEQSVGVHAUUGVSAUXPUXQUXRUYCUU
      HWOQUWQVMWPUWQQGUUIVLWRLWSAUXAVVOJVFVBZVCZVDUYLVUOAVUQVUPUXFDUEZUXGUJAVUP
      UWMUXFDVVNAUYAVUJGVUPTVUPXAWDKVUKUWQGUUJVUPGUUKUULVWCVVPFUXEVVQVVPFGVVQAG
      UUMTVVOIVFWBZVCVVPUWLUXEUJVHZUWMUXFUJVHZNVVPVUEUXEUTTUXLQFUJVHZVWFVWGXNVW
      BVWEVVQAVWHVVOAFOUUNZVFUWLUXEFUUOYGXPUUPAVWDVUPYPUCZUXFUDRZUXGAVUPYHTUXFX
      GTVWDVWKULVVNAFUXEVVMAFGVVMVVDAGIUUQZUURZYEVUPUXFDYIYJAVWJUXDUXFUDAUYAVUJ
      VWJUXDULKVUKUWQGYKWIYCYDYLYMYNAUYSUXBUXGVUOUYFUYLAUYSUYRFDUEZUXBVGAUYRUWM
      FDVUAVUNVUDVUCUWMFSUDRZFVGVUCUWLSVGVHZUWMVWOVGVHZAVUBUXJVWPVULMWSVUCVUEUY
      HUXLVWHVWPVWQXNVUMUYHVUCVRVSVUDAVWHVUBVWIVFUWLSFUUSYGXPAVWOFULVUBAFVVMUUT
      ZVFYLUVAAVWNUYRYPUCZFUDRZUWQFUDRZUXBAUYRYHTVVLVWNVWTULVUAVVMUYRFDYIYJAVWS
      UWQFUDAVWSUYQQUQRZSUIRZVURUWQAUYQVVRTZVWSVXCULAVVTUWQQSUIRZVIUCZTVXDYFAUW
      QUXSVXFUYBSVXEVIUVBUVCXSQUWQUVDUVEQUYQYKVLAVXBUYQSUIAUYQAUWQSVVJVVEYOUVFY
      CVVKYQYCAUWQFVVJVVMYRYQYLUVIUVJAUXHUXBFFUDRZUIRZUWTUYMAUXBVXGUYFAFFUXMUXM
      VCZWAUYPAUXBFUXDUXEUDRZUDRZUIRUXHVXHVGAVXKUXGUXBUIAFUXDUXEVVMAUXCSAGUWQVV
      DVVJYOZVVEUVGZVWMUVHXJAVXKVXGUXBAFVXJUXMAUXDUXEUYJUYKVCZVCVXIUYFAVXJFVGVH
      VXKVXGVGVHAVXJFUXDGUHRZUDRZFVGAUXDFGVXMVVMVVDVWLUVKAVXPVWOFVGAVXOSVGVHVXP
      VWOVGVHAVXOGGUHRZSVGAUXDGVGVHZVXOVXQVGVHZAGSUWQUQRZUIRZGQUIRUXDGVGAVXTQGA
      SUWQUYIUYEVQVWAUYGAVXTQVGVHUXRAUYAUXRKUWQSGUVLVLASUWQUYIUYEUVMUVRYSAVYASU
      XCUIRUXDAGSUWQVVDVVEVVJUVNASUXCVVEVXLUVOYDAGVVDUVPUVQAUXDUTTGUTTZVYBQGUJV
      HVXRVXSXNUYJUYGUYGAGIUVSUXDGGUVTYGXPAGVVDVWLUWAYLAVXOSFAUXDGUYJIWBUYIOYTX
      PVWRYLYNAVXJFFVXNUXMOYTXPYSUWBAVXHUWQFUIRZFUDRZUWTUJAVXHVXAVXGUIRVYDAUXBV
      XAVXGUIAFUWQVVMVVJYRYCAUWQFFVVJVVMVVMUWCUWDAVYCUWSFAUWQFUYEUXMWAUYOOAFUWR
      UWQUXMUYNUYEPYMUWEYNUWFUWGYN $.
  $}

  ${
    $d t T $.
    stoweidlem12.1 $e |- Q
        = ( t e. T |-> ( ( 1 - ( ( P ` t ) ^ N ) ) ^ ( K ^ N ) ) ) $.
    stoweidlem12.2 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem12.3 $e |- ( ph -> N e. NN0 ) $.
    stoweidlem12.4 $e |- ( ph -> K e. NN0 ) $.
    $( Lemma for ~ stoweid .  This Lemma is used by other three Lemmas.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem12 $p |- ( ( ph /\ t e. T ) ->
          ( Q ` t ) = ( ( 1 - ( ( P ` t ) ^ N ) ) ^ ( K ^ N ) ) ) $=
      ( wcel wa c1 cfv cexp co cr cn0 adantr cv cmin wceq 1re fnvinran reexpcld
      simpr a1i resubcld jca nn0expcl syl fvmpt2 syl2anc ) ABUAZELZMZUPNUOCOZGP
      QZUBQZFGPQZPQZRLUODOVBUCAUPUGUQUTVAUQNUSNRLUQUDUHUQURGAERUOCIUEAGSLZUPJTU
      FUIUQFSLZVCMZVASLAVEUPAVDVCKJUJTFGUKULUFBEVBRDHUMUN $.
  $}

  ${
    stoweidlem13.1 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem13.2 $e |- ( ph -> X e. RR ) $.
    stoweidlem13.3 $e |- ( ph -> Y e. RR ) $.
    stoweidlem13.4 $e |- ( ph -> j e. RR ) $.
    stoweidlem13.5 $e |- ( ph -> ( ( j - ( 4 / 3 ) ) x. E ) < X ) $.
    stoweidlem13.6 $e |- ( ph -> X <_ ( ( j - ( 1 / 3 ) ) x. E ) ) $.
    stoweidlem13.7 $e |- ( ph -> ( ( j - ( 4 / 3 ) ) x. E ) < Y ) $.
    stoweidlem13.8 $e |- ( ph -> Y < ( ( j + ( 1 / 3 ) ) x. E ) ) $.
    $( Lemma for ~ stoweid .  This lemma is used to prove the statement abs(
       f(t) - g(t) ) < 2 epsilon, in the last step of the proof in
       [BrosowskiDeutsh] p. 92.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem13 $p |- ( ph -> ( abs ` ( Y - X ) ) < ( 2 x. E ) ) $=
      ( co cmul clt c1 c4 c3 caddc cmin cabs cfv c2 cneg resubcld cr wcel rpred
      wbr 2re remulcl sylancr recnd negsubdi2d 1re a1i remulcld cv 3re rereccli
      cdiv 3ne0 cc0 wne w3a 4re 3pm3.2i redivcl lesub1dd lelttrd subcld subdird
      ltsub2dd sub4d subsub2d eqtrd oveq1d eqtr3d breqtrd subidd 4cn 3cn divcli
      mp1i ax-1cn oveq2i ax-1ne0 divadddivi eqtr3i addcomi df-4 mulid2i oveq12i
      div1i 1t1e1 3eqtr4ri oveq1i mulid1i 3eqtri subaddrii 1e0p1 eqtr4i ltmul1d
      syl6eq 1lt2 mpbii lttrd eqbrtrd ltnegcon1d 5re redivcld renegcld readdcld
      ltnegd mpbid lt2addd negsubd adddird eqcomd negcld mulneg1d oveq2d 3eqtrd
      c5 negeqd mulcld negdid negnegd oveq12d negidd addcld addid2d wceq adddid
      add4d divcan2i df-5 3eqtr4i divmuld mpbird 3eqtr2d 3brtr3d 3t2e6 breqtrri
      c6 5lt6 wa wb 3pos pm3.2i ltdivmul mp3an mpbir ltmul1dd absltd mpbir2and
      ) AEDUANZUBUCUDCONZPUJUUSUEUURPUJUURUUSPUJAUURUUSAEDHGUFZAUDUGUHZCUGUHUUS
      UGUHUKACFUIZUDCULUMZAUURUEDEUANZUUSPAEDAEHUNZADGUNZUOAUVDQCONZUUSADEGHUFZ
      AQCQUGUHAUPUQZUVBURUVCAUVDBUSZUVJUANZRSVBNZQSVBNZUANZTNZCONZUVGPAUVDUVJUV
      MUANZCONZUVJUVLUANZCONZUANZUVPPAUVDUVREUANUWAUVHAUVREAUVQCAUVJUVMIUVMUGUH
      ASUTVCVAUQZUFUVBURZHUFAUVRUVTUWCAUVSCAUVJUVLIRUGUHZSUGUHZSVDVEZVFUVLUGUHA
      UWDUWEUWFVGUTVCVHRSVIWEZUFUVBURZUFADUVREGUWCHKVJAUVTEUVRUWHHUWCLVNVKAUVQU
      VSUANZCONUWAUVPAUVQUVSCAUVJUVMAUVJIUNZAUVMUWBUNZVLAUVJUVLUWJAUVLUWGUNZVLA
      CUVBUNZVMAUWIUVOCOAUWIUVKUVMUVLUANUANUVOAUVJUVMUVJUVLUWJUWKUWJUWLVOAUVKUV
      MUVLAUVJUVJUWJUWJVLUWKUWLVPVQVRVSVTAUVOQCOAUVOVDUVNTNZQAUVKVDUVNTAUVJUWJW
      AVRUWNVDQTNQUVNQVDTUVLUVMQRSWBWCVCWDQSWFWCVCWDWFUVMQTNZQQONZQSONZTNZSQONZ
      VBNZRUWSVBNUVLUVMQQVBNZTNUWOUWTUXAQUVMTQWFWOWGQSQQWFWCWFWFVCWHWIWJUWRRUWS
      VBSQTNQSTNRUWRSQWCWFWKWLUWPQUWQSTWPSWCWMWNWQWRUWSSRVBSWCWSWGWTXAWGXBXCXEV
      RVTAQUDPUJUVGUUSPUJXFAQUDCUVIUVAAUKUQZFXDXGXHXIXJAUURYESVBNZCONZUUSUUTAUX
      CCAYESYEUGUHZAXKUQZUWEAUTUQZUWFAVCUQZXLZUVBURUVCAEDUEZTNUVJUVMTNZCONZUVTU
      EZTNZUURUXDPAEUXJUXLUXMHADGXMAUXKCAUVJUVMIUWBXNUVBURAUVTUWHXMMAUVTDPUJUXJ
      UXMPUJJAUVTDUWHGXOXPXQAEDUVEUVFXRAUXNUVJCONZUVMCONZTNZUXOUEZUVLCONZTNZTNZ
      UXDAUXLUXQUXMUXTTAUVJUVMCUWJUWKUWMXSAUXMUXOUXSUEZTNZUEUXRUYBUEZTNUXTAUVTU
      YCAUVTUVJUVLUEZTNZCONUXOUYECONZTNUYCAUVSUYFCOAUYFUVSAUVJUVLUWJUWLXRXTVRAU
      VJUYECUWJAUVLUWLYAUWMXSAUYGUYBUXOTAUVLCUWLUWMYBYCYDYFAUXOUYBAUVJCUWJUWMYG
      ZAUXSAUVLCUWLUWMYGZYAYHAUYDUXSUXRTAUXSUYIYIYCYDYJAUYAUXPUXSTNZUVMUVLTNZCO
      NUXDAUYAUXOUXRTNZUYJTNVDUYJTNUYJAUXOUXPUXRUXSUYHAUVMCUWKUWMYGZAUXOUYHYAUY
      IYPAUYLVDUYJTAUXOUYHYKVRAUYJAUXPUXSUYMUYIYLYMYDAUVMUVLCUWKUWLUWMXSAUYKUXC
      COAUXCUYKAUXCUYKYNSUYKONZYEYNAUYNSUVMONZSUVLONZTNZYEASUVMUVLASUXGUNZUWKUW
      LYOQRTNRQTNUYQYEQRWFWBWKUYOQUYPRTQSWFWCVCYQRSWBWCVCYQWNYRYSXEAYESUYKAYEUX
      FUNUYRAUVMUVLUWKUWLYLUXHYTUUAXTVRUUBVQUUCAUXCUDCUXIUXBFUXCUDPUJZAUYSYESUD
      ONZPUJZYEUUFUYTPUUGUUDUUEUXEUVAUWEVDSPUJZUUHUYSVUAUUIXKUKUWEVUBUTUUJUUKYE
      UDSUULUUMUUNUQUUOXHAUURUUSUUTUVCUUPUUQ $.
  $}

  ${
    $d j k z $.  $d j k D $.  $d k z A $.  $d k ph $.
    stoweidlem14.1 $e |- A = { j e. NN | ( 1 / D ) < j } $.
    stoweidlem14.2 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem14.3 $e |- ( ph -> D < 1 ) $.
    $( There exists a ` k ` as in the proof of Lemma 1 in [BrosowskiDeutsh]
       p. 90: ` k ` is an integer and 1 < k * &delta; < 2. ` D ` is used to
       represent &delta; in the paper.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem14 $p |- ( ph ->
          E. k e. NN ( 1 < ( k x. D ) /\ ( ( k x. D ) / 2 ) < 1 ) ) $=
      ( vz cn wcel c1 co clt wbr c2 wa cle a1i cr cv cmul cdiv wex wrex wral c0
      wss wne crab ssrab2 syl5eqss rprecred breq2 elrab biimpri syl6eleqr simpr
      arch reximi2 rexn0 4syl nnwo syl2anc df-rex sylib elrab2 simplbi ad2antrl
      jca simpl simprl simprr nfcv nfrab1 nfcxfr nfv cbvralf simprbi wb cc0 1re
      nnre adantl rpregt0d adantr ltdivmul2 syl3anc syldan mpbid syl12anc oveq1
      wceq rpcnd mulid2d eqtrd oveq1d rpred rehalfcld rehalfcli 2re 2pos ltdiv1
      cc syl112anc halflt1 lttrd eqbrtrd adantlr wn cuz cfv cmin simpll simplrl
      syl df-ne eluz2b3 sylanbrc cz 1z w3a caddc fveq2i eleq2i eluzsub syl3an3b
      df-2 nnuz wo wi ex sylibr mpd ad2antrr 3adant3 3ad2ant1 resubcld syl6breq
      ax-1cn ltm1d ltnle notbid rspcev rexnal imnan con2i ad2antlr sylnib ianor
      peano2rem imor rpne0d rereccld lenltd eluzelre remulcld readdcld eluzelcn
      mpbird mulcld npcand simp3 3ad2ant2 lemul1 subdird oveq2d divcan1 3brtr3d
      3jca leadd1dd eqbrtrrd pm3.2i lediv1 ltadd2dd 1p1e2 2ne0 dividi pm2.61dan
      2cn lelttrd jca32 eximdv ) AEUAZJKZLUWDCUBMZNOZUWFPUCMZLNOZQZQZEUDZUWJEJU
      EAUWDBKZUWDIUAZROZIBUFZQZEUDZUWLAUWPEBUEZUWRABJUHBUGUIZUWSABLCUCMZDUAZNOZ
      DJUJZJFUXDJUHAUXCDJUKSULAUXATKZUXAUWDNOZEJUEUXFEBUEUWTACGUMZUXAEUSUXFUXFE
      JBUWEUXFQZUWMUXFUXHUWDUXDBUWDUXDKUXHUXCUXFDUWDJUXBUWDUXANUNZUOUPFUQUWEUXF
      URVJUTUXFEBVAVBEIBVCVDUWPEBVEVFAUWQUWKEAUWQUWKAUWQQZUWEUWGUWIUWMUWEAUWPUW
      MUWEUXFUXCUXFDUWDJBUXIFVGZVHZVIUXJAUWMUWDUXBROZDBUFZUWGAUWQVKAUWMUWPVLUXJ
      UWPUXNAUWMUWPVMUWOUXMIDBIBVNDBUXDFUXCDJVOVPUWODVQUXMIVQUWNUXBUWDRUNVRVFAU
      WMUXNQZQUXFUWGUWMUXFAUXNUWMUWEUXFUXKVSVIAUXOUWEUXFUWGVTZUWMUWEAUXNUXLVIAU
      WEQZLTKZUWDTKZCTKZWACNOQZUXPUXRUXQWBSUWEUXSAUWDWCZWDAUYAUWEACGWEZWFLUWDCW
      GWHWIWJWKUXJUWDLWMZUWIAUYDUWIUWQAUYDQZUWHCPUCMZLNUYEUWFCPUCUYEUWFLCUBMZCU
      YDUWFUYGWMAUWDLCUBWLWDUYECACXDKZUYDACGWNZWFWOWPWQAUYFLNOUYDAUYFLPUCMZLACA
      CGWRZWSUYJTKALWBWTSUXRAWBSZACLNOZUYFUYJNOZHAUXTUXRPTKZWAPNOZUYMUYNVTUYKUY
      LUYOAXASZUYPAXBSZCLPXCXEWJUYJLNOAXFSXGWFXHXIUXJUYDXJZQZAUWDPXKXLZKZUWDLXM
      MZUXAROZUWIAUWQUYSXNUYTUWEUWDLUIZVUBUYTUWMUWEAUWMUWPUYSXOZUXLXPUYSVUEUXJV
      UEUYSUWDLXQUPWDUWDXRXSZUYTVUDUXAVUCNOZXJZUYTVUCJKZVUIUYTLXTKZVUKVUBVUJVUK
      UYTYASZVULVUGVUKVUKVUBYBVUCLXKXLZJVUBVUKVUKUWDLLYCMZXKXLZKVUCVUMKVUAVUOUW
      DPVUNXKYHYDYELLUWDYFYGYIUQWHUYTVUJXJVUIYJZVUJVUIYKUYTVUJVUHQZXJVUPUYTVUCB
      KZVUQUWQVURXJAUYSVURUWQVURUWMUWPXJZYKUWQXJVURUWMVUSVURUWMQZUWOXJZIBUEZVUS
      VURUWMUWDVUCROZXJZVVBVUTVUCTKZUXSVVDVUTUXSVVEUWMUXSVURUWMUWEUXSUXLUYBXPWD
      ZUWDUUKZXPVVFVVEUXSQZVUCUWDNOVVDVVHUWDVVEUXSURUUAVUCUWDUUBWJVDVVAVVDIVUCB
      UWNVUCWMUWOVVCUWNVUCUWDRUNUUCUUDWIUWOIBUUEVFYLUWMUWPUUFVFUUGUUHUXCVUHDVUC
      JBUXBVUCUXANUNFVGUUIVUJVUHUUJVFVUJVUIUULYMYNUYTVUCUXAUYTUWMUWEUXSVVEVUFUX
      LUYBVVGVBUYTCAUXTUWQUYSUYKYOACWAUIZUWQUYSACGUUMZYOUUNUUOUUTAVUBVUDYBZUWHL
      CYCMZPUCMZLAVUBUWHTKVUDAVUBQZUWFVVNUWDCVUBUXSAPUWDUUPZWDAUXTVUBUYKWFZUUQZ
      WSYPAVUBVVMTKVUDVVNVVLAVVLTKZVUBALCUYLUYKUURZWFWSYPUXRVVKWBSZVVKUWFVVLROZ
      UWHVVMROZVVKUWFCXMMZCYCMUWFVVLRVVKUWFCAVUBUWFXDKVUDVVNUWDCVUBUWDXDKAPUWDU
      USWDZAUYHVUBUYIWFZUVAYPAVUBUYHVUDUYIYQUVBVVKVWCLCAVUBVWCTKVUDVVNUWFCVVQVV
      PYRYPVVTAVUBUXTVUDUYKYQVVKVUCCUBMZUXACUBMZVWCLRVVKVUDVWFVWGROZAVUBVUDUVCV
      VKVVEUXEUYAVUDVWHVTVUBAVVEVUDVUBUWDLVVOUXRVUBWBSYRUVDAVUBUXEVUDUXGYQAVUBU
      YAVUDUYCYQVUCUXACUVEWHWJAVUBVWFVWCWMVUDVVNVWFUWFUYGXMMVWCVVNUWDLCVWDLXDKZ
      VVNYTSVWEUVFVVNUYGCUWFXMVVNCVWEWOUVGWPYPVVKVWIUYHVVIYBZVWGLWMAVUBVWJVUDAV
      WIUYHVVIVWIAYTSUYIVVJUVJYQLCUVHXPUVIUVKUVLVVKUWFTKZVVRUYOUYPQZVWAVWBVTAVU
      BVWKVUDVVQYPAVUBVVRVUDVVSYQVWLVVKUYOUYPXAXBUVMSUWFVVLPUVNWHWJAVUBVVMLNOVU
      DAVVMPPUCMZLNAVVLPNOZVVMVWMNOZAVVLVUNPNACLLUYKUYLUYLHUVOUVPYSAVVRUYOUYOUY
      PVWNVWOVTVVSUYQUYQUYRVVLPPXCXEWJPUVTUVQUVRYSYQUWAWHUVSUWBYLUWCYNUWJEJVEYM
      $.
  $}

  ${
    $d f A $.  $d f G $.  $d f I $.  $d f T $.  $d f ph $.  $d h t G $.
    $d h A $.  $d h t I $.  $d h t T $.  $d h Z $.  $d s t G $.  $d s t I $.
    $d s S $.  $d s t T $.
    stoweidlem15.1 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem15.3 $e |- ( ph -> G : ( 1 ... M ) --> Q ) $.
    stoweidlem15.4 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    $( This lemma is used to prove the existence of a function ` p ` as in
       Lemma 1 from [BrosowskiDeutsh] p. 90: ` p ` is in the subalgebra, such
       that 0 &le; p &le; 1, p_(t_0) = 0, and p > 0 on T - U. Here
       ` ( G `` I ) ` is used to represent p_(t_i) in the paper.  (Contributed
       by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem15 $p |- ( ( ( ph /\ I e. ( 1 ... M ) ) /\ S e. T ) ->
          ( ( ( G ` I ) ` S ) e. RR /\ 0 <_ ( ( G ` I ) ` S ) /\
          ( ( G ` I ) ` S ) <_ 1 ) ) $=
      ( c1 wa cc0 cle wbr vs cfz co wcel cr wf simpl fnvinran cv wceq wral crab
      cfv elrabi eleq2s syl wi eleq1 anbi2d feq1 imbi12d vtoclg mp2and syl6eleq
      fveq1 eqeq1d breq2d breq1d anbi12d ralbidv simprd cbvralv rspccva sylanbr
      elrab sylib fveq2 sylan simpld 3jca ) AJPKUBUCZUDZQZEFUDZQZEJIUMZUMZUEUDR
      WGSTZWGPSTZWCFUEEWFWCAWFCUDZFUEWFUFZAWBUGWCWFDUDWJAWADJINUHZWJWFLHUIZUMZR
      UJZRBUIZWMUMZSTZWQPSTZQZBFUKZQZHCULZDXBHWFCUNMUOUPZWCWJAWJQZWKUQZXDAGUIZC
      UDZQZFUEXGUFZUQXFGWFCXGWFUJZXIXEXJWKXKXHWJAXGWFCURUSFUEXGWFUTVAOVBUPVCUHW
      EWHWIWCRWPWFUMZSTZXLPSTZQZBFUKZWDWHWIQZWCLWFUMZRUJZXPWCWJXSXPQZWCWFXCUDWJ
      XTQWCWFDXCWLMVDXBXTHWFCWMWFUJZWOXSXAXPYAWNXRRLWMWFVEVFYAWTXOBFYAWRXMWSXNY
      AWQXLRSWPWMWFVEZVGYAWQXLPSYBVHVIVJVIVOVPVKVKXPRUAUIZWFUMZSTZYDPSTZQZUAFUK
      WDXQYGXOUABFYCWPUJZYEXMYFXNYHYDXLRSYCWPWFVQZVGYHYDXLPSYIVHVIVLYGXQUAEFYCE
      UJZYEWHYFWIYJYDWGRSYCEWFVQZVGYJYDWGPSYKVHVIVMVNVRZVSWEWHWIYLVKVT $.
  $}

  ${
    $d f g h t A $.  $d f h t T $.  $d f ph $.  $d h t z A $.  $d h z H $.
    stoweidlem16.1 $e |- F/ t ph $.
    stoweidlem16.2 $e |- Y = { h e. A | A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t
                           ) <_ 1 ) } $.
    stoweidlem16.3 $e |- H = ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) $.
    stoweidlem16.4 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem16.5 $e |- ( ( ph /\ f e. A /\ g e. A ) -> ( t e. T |-> ( ( f `
                           t ) x. ( g ` t ) ) ) e. A ) $.
    $( Lemma for ~ stoweid .  The subset ` Y ` of functions in the algebra
       ` A ` , with values in [ 0 , 1 ], is closed under multiplication.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem16 $p |- ( ( ph /\ f e. Y /\ g e. Y ) -> H e. Y ) $=
      ( wcel cc0 cle wbr c1 cr cv w3a cfv wa wral crab cmul co cmpt simp1 fveq1
      weq breq2d breq1d anbi12d ralbidv simplbi 3ad2ant2 3ad2ant3 syl3anc nfra1
      elrab2 syl5eqel nfrab nfcxfr nfcri nf3an wf jca adantr syl simpr ffvelrnd
      nfcv wi eleq1 anbi2d feq1 imbi12d vtoclg fnvinran simprbi r19.21bi simpld
      sylc mulge0d wceq remulcld fvmpt2 syl2anc breqtrrd simprd lemul12ad 1t1e1
      1re a1i syl6breq eqbrtrd ex ralrimi nfmpt1 nfeq2 elrab sylanbrc syl6eleqr
      ralbid ) AEUAZIOZFUAZIOZUBZHPBUAZGUAZUCZQRZXNSQRZUDZBDUEZGCUFZIXKHCOPXLHU
      CZQRZXTSQRZUDZBDUEZHXSOXKHBDXLXGUCZXLXIUCZUGUHZUIZCLXKAXGCOZXICOZYHCOAXHX
      JUJZXHAYIXJXHYIPYEQRZYESQRZUDZBDUEZXRYOGXGCIGEULZXQYNBDYPXOYLXPYMYPXNYEPQ
      XLXMXGUKZUMYPXNYESQYQUNUOUPKVBZUQURZXJAYJXHXJYJPYFQRZYFSQRZUDZBDUEZXRUUCG
      XICIGFULZXQUUBBDUUDXOYTXPUUAUUDXNYFPQXLXMXIUKZUMUUDXNYFSQUUEUNUOUPKVBZUQU
      SZNUTVCXKYCBDAXHXJBJBEIBIXSKXRBGCXQBDVABCVNVDVEZVFBFIUUHVFVGXKXLDOZYCXKUU
      IUDZYAYBUUJPYGXTQUUJYEYFUUJDTXLXGUUJAYIUDZDTXGVHZXKUUKUUIXKAYIYKYSVIVJMVK
      XKUUIVLZVMZXKDTXLXIXKYJAYJUDZDTXIVHZUUGXKAYJYKUUGVIUUKUULVOUUOUUPVOEXICEF
      ULZUUKUUOUULUUPUUQYIYJAXGXICVPVQDTXGXIVRVSMVTWEWAZUUJYLYMXKYNBDXHAYOXJXHY
      IYOYRWBURWCZWDZUUJYTUUAXKUUBBDXJAUUCXHXJYJUUCUUFWBUSWCZWDZWFUUJUUIYGTOXTY
      GWGUUMUUJYEYFUUNUURWHBDYGTHLWIWJZWKUUJXTYGSQUVCUUJYGSSUGUHSQUUJYESYFSUUNS
      TOUUJWOWPZUURUVDUUTUVBUUJYLYMUUSWLUUJYTUUAUVAWLWMWNWQWRVIWSWTXRYDGHCXMHWG
      ZXQYCBDBXMHBHYHLBDYGXAVEXBUVEXOYAXPYBUVEXNXTPQXLXMHUKZUMUVEXNXTSQUVFUNUOX
      FXCXDKXE $.
  $}

  ${
    $d f g i m r t E $.  $d f g m A $.  $d f g i m r t T $.
    $d f g i m r t X $.  $d f g i m r ph $.  $d i m n t E $.  $d i m n t N $.
    $d n A $.  $d n t T $.  $d n t X $.  $d n ph $.  $d t x E $.  $d x A $.
    $d x T $.  $d x ph $.
    stoweidlem17.1 $e |- F/ t ph $.
    stoweidlem17.2 $e |- ( ph -> N e. NN ) $.
    stoweidlem17.3 $e |- ( ph -> X : ( 0 ... N ) --> A ) $.
    stoweidlem17.4 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem17.5 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem17.6 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem17.7 $e |- ( ph -> E e. RR ) $.
    stoweidlem17.8 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    $( This lemma proves that the function ` g ` (as defined in
       [BrosowskiDeutsh] p. 91, at the end of page 91) belongs to the
       subalgebra.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem17 $p |- ( ph -> ( t e. T |->
          sum_ i e. ( 0 ... N ) ( E x. ( ( X ` i ) ` t ) ) ) e. A ) $=
      ( wcel vn vm vr cn0 cc0 cfz co wa cfv cmul csu cmpt nnnn0d nn0uz syl6eleq
      cv cuz eluzfz2 ancli wi c1 caddc wceq eleq1 anbi2d oveq2 sumeq1d mpteq2dv
      syl eleq1d imbi12d weq csn cz 0z ax-mp sumeq1i mpteq2i cc cr adantr recnd
      fzsn wf cle wbr nnz clt nngt0 0re nnre ltle sylancr mpd jca eluz1i sylibr
      cn eluzfz1 ffvelrnd feq1 imbi2d expcom mpcom fnvinran mulcld fveq2 fveq1d
      vtoclga oveq2d sumsn mpteq2da syl5eq stoweidlem2 eqidd cbvmptv a1i oveq1d
      simpr simpl fveq1 eleq1i fveq1i syl6eq 3com12 3expib sylbir 3impib 3com13
      syl3anc ad2antll ad2antrl adantl nfv 3ad2ant2 sylc remulcld eqid syl2anc
      fvmpt2 eqeltrd eqcomi fvmptd eqeltrrd simprl nn0re peano2nn0 nn0red nnred
      simprrl lep1 3syl elfzle2 letrd elfz2nn0 syl3anbrc jca32 pm3.31 sumeq2sdv
      id w3a wb 3anass biimpri nf3an fzfid fzelp1 anim2i an32 sylib wss elfzuz3
      fzss2 sselda 3ad2antl3 simpl2 fsumrecl 3simpc cmin 3ad2ant3 an32s remulcl
      elfzuz fsumm1 nn0cn 3ad2ant1 ax-1cn pncand 3eqtr4rd mpbird pm2.86i nn0ind
      eqtrd exp32 ) AJUDTZAJUEJUFUGZTZUHZCEUWPICUPZHUPZKUIZUIZUJUGZHUKZULZDTZAJ
      MUMZAUWQAJUEUQUIZTZUWQAJUDUXHUXGUNUOUEJURVIUSAUAUPZUWPTZUHZCEUEUXJUFUGZUX
      CHUKZULZDTZUTAUEUWPTZUHZCEUEUEUFUGZUXCHUKZULZDTZUTAUBUPZUWPTZUHZCEUEUYCUF
      UGZUXCHUKZULZDTZUTZAUYCVAVBUGZUWPTZUHZCEUEUYKUFUGZUXCHUKZULZDTZUTZUWRUXFU
      TUAUBJUXJUEVCZUXLUXRUXPUYBUYSUXKUXQAUXJUEUWPVDVEUYSUXOUYADUYSCEUXNUXTUYSU
      XMUXSUXCHUXJUEUEUFVFVGVHVJVKUAUBVLZUXLUYEUXPUYIUYTUXKUYDAUXJUYCUWPVDVEUYT
      UXOUYHDUYTCEUXNUYGUYTUXMUYFUXCHUXJUYCUEUFVFVGVHVJVKUXJUYKVCZUXLUYMUXPUYQV
      UAUXKUYLAUXJUYKUWPVDVEVUAUXOUYPDVUACEUXNUYOVUAUXMUYNUXCHUXJUYKUEUFVFVGVHV
      JVKUXJJVCZUXLUWRUXPUXFVUBUXKUWQAUXJJUWPVDVEVUBUXOUXEDVUBCEUXNUXDVUBUXMUWP
      UXCHUXJJUEUFVFVGVHVJVKAUYBUXQAUYACEIUWSUEKUIZUIZUJUGZULZDAUYACEUEVMZUXCHU
      KZULVUFCEUXTVUHUXSVUGUXCHUEVNTZUXSVUGVCVOUEWCVPVQVRACEVUHVUELAUWSETZUHZVU
      IVUEVSTVUHVUEVCVOVUKIVUDVUKIAIVTTZVUJRWAZWBVUKVUDAEVTUWSVUCVUCDTAEVTVUCWD
      ZAUWPDUEKNAUXIUXQAJVNTZUEJWEWFZUHZUXIAJWRTZVUQMVURVUOVUPJWGVURUEJWHWFZVUP
      JWIVURUEVTTJVTTZVUSVUPUTWJJWKUEJWLWMWNWOVIUEJVOWPWQUEJWSVIWTZAEVTFUPZWDZU
      TZAVUNUTFVUCDVVBVUCVCVVCVUNAEVTVVBVUCXAXBAVVBDTZVVCSXCZXIXDXEWBXFUXCVUEHU
      EVNUWTUEVCZUXBVUDIUJVVGUWSUXAVUCUWTUEKXGXHXJXKWMXLXMABCDEFGIVUCLPQSRVVAXN
      UUAWAUYCUDTZUYJUYRVVHUYJUTZVVHUYMUYQVVIVVHUYMUHZUHZUYQCEUWSUYHUIZUWSCEIUW
      SUYKKUIZUIZUJUGZULZUIZVBUGZULZDTZVVKVVPDTZAUYIVVTUYMVWAVVIVVHUYMCEUWSCEIU
      LZUIZVVNUJUGZULZVVPDAVWEVVPVCUYLACEVWDVVOLVUKVWCIVVNUJVUKUCUWSIIEVWBVTVWB
      UCEIULZVCVUKVWFVWBUCCEIIUCCVLZIXOXPZUUBXQVUKVWGUHIXOAVUJXSVUMUUCXRXLWAUYM
      VVMDTZAVWBDTZVWEDTZAUWPDUYKKNXEZAUYLXTZAVWJUYLVULAVWJRACEBUPZULZDTZUTAVWJ
      UTBIVTVWNIVCZVWPVWJAVWQVWOVWBDVWQCEVWNIVWQUUTVHVJXBAVWNVTTVWPQXCXIXDWAVWI
      AVWJVWKAVWJUHZCEVWCUWSGUPZUIZUJUGZULZDTZUTVWRVWKUTGVVMDVWSVVMVCZVXCVWKVWR
      VXDVXBVWEDVXDCEVXAVWDVXDVWTVVNVWCUJUWSVWSVVMYAXJVHVJXBVWSDTZAVWJVXCVWJAVX
      EVXCVWJAVXEVXCVWJVWFDTAVXEUHZVXCUTZVWFVWBDVWHYBVXFCEUWSVVBUIZVWTUJUGZULZD
      TZUTVXGFVWFDVVBVWFVCZVXKVXCVXFVXLVXJVXBDVXLCEVXIVXAVXLVXHVWCVWTUJVXLVXHUW
      SVWFUIVWCUWSVVBVWFYAUWSVWFVWBVWHYCYDXRVHVJXBVVEAVXEVXKAVVEVXEVXKPYEYFXIYG
      YHYIYFXIYHYJUUDYKVVIVVHAUYLUUJVVKVVHUYEUHZUYIVVJVXMVVIVVJVVHAUYDVVHUYMXTZ
      VVHAUYLUUEVVJVVHUWOUYCJWEWFUYDVXNVVJJAVURVVHUYLMYLUMVVJUYCUYKJVVHUYCVTTZU
      YMUYCUUFZWAVVHUYKVTTUYMVVHUYKUYCUUGUUHWAAVUTVVHUYLAJMUUIYLVVJVVHVXOUYCUYK
      WEWFVXNVXPUYCUUKUULUYLUYKJWEWFVVHAUYKUEJUUMYKUUNUYCJUUOUUPUUQYMVVIVXMUYIU
      TVVJVVHUYEUYIUURWAWNVWAAUYIVVTVWAUCEIUCUPZVVMUIZUJUGZULZDTAUYIUHZVVTUTZVX
      TVVPDUCCEVXSVVOVWGVXRVVNIUJVXQUWSVVMXGXJXPZYBVYACEVVLVWTVBUGZULZDTZUTVYBG
      VXTDVWSVXTVCZVYFVVTVYAVYGVYEVVSDVYGCEVYDVVRVYGVWTVVQVVLVBVYGVWTUWSVXTUIVV
      QUWSVWSVXTYAUWSVXTVVPVYCYCYDXJVHVJXBVXEAUYIVYFUYIAVXEVYFUYIAVXEVYFUYIUCEU
      YFIVXQUXAUIZUJUGZHUKZULZDTVXFVYFUTZVYKUYHDUCCEVYJUYGVWGUYFVYIUXCHVWGVYHUX
      BIUJVXQUWSUXAXGXJUUSXPZYBVXFCEVXHVWTVBUGZULZDTZUTVYLFVYKDVVBVYKVCZVYPVYFV
      XFVYQVYOVYEDVYQCEVYNVYDVYQVXHVVLVWTVBVYQVXHUWSVYKUIVVLUWSVVBVYKYAUWSVYKUY
      HVYMYCYDXRVHVJXBVVEAVXEVYPAVVEVXEVYPOYEYFXIYGYHYIYFXIYGYHYJVVKVVHAUYLUVAZ
      UYQVVTUVBVVJVYRVVIVYRVVJVVHAUYLUVCUVDYMVYRUYPVVSDVYRCEUYOVVRVVHAUYLCVVHCY
      NLUYLCYNUVEVYRVUJUHZVVLVVOVBUGUYGVVOVBUGZVVRUYOVYSVVLUYGVVOVBVYSVUJUYGVTT
      VVLUYGVCVYRVUJXSZVYSUYFUXCHVYSUEUYCUVFVYSUWTUYFTZUHZIUXBVYSVULWUBVYRVULVU
      JAVVHVULUYLRYOWAZWAWUCVYRUWTUYNTZUHZVUJUHZUXBVTTZWUCVYSWUEUHZWUGWUBWUEVYS
      UWTUEUYCUVGUVHVYRVUJWUEUVIUVJWUFEVTUWSUXAWUFUXADTAEVTUXAWDZWUFUWPDUWTKVYR
      UWPDKWDZWUEAVVHWUKUYLNYOWAUYLVVHWUEUWTUWPTAUYLUYNUWPUWTUYLJUYKUQUITUYNUWP
      UVKUYKUEJUVLUYKUEJUVMVIUVNUVOWTVVHAUYLWUEUVPVVDAWUJUTFUXADVVBUXAVCVVCWUJA
      EVTVVBUXAXAXBVVFXIYPXEZVIYQUVQCEUYGVTUYHUYHYRYTYSXRVYSVVQVVOVVLVBVYSVUJVV
      OVTTVVQVVOVCWUAVYSIVVNWUDVYSEVTUWSVVMVYSUYMEVTVVMWDZVYRUYMVUJVVHAUYLUVRWA
      UYMVWIAWUMVWLVWMVVDAWUMUTFVVMDVVBVVMVCVVCWUMAEVTVVBVVMXAXBVVFXIYPVIWUAWTY
      QCEVVOVTVVPVVPYRYTYSXJVYSUYOUEUYKVAUVSUGZUFUGZUXCHUKZVVOVBUGVYTVYSUXCVVOH
      UEUYKVYRUYKUXHTZVUJUYLVVHWUQAUYKUEJUWCUVTWAWUIVULWUHUXCVSTVYSVULWUEWUDWAV
      YRWUEVUJWUHWULUWAVULWUHUHUXCIUXBUWBWBYSUWTUYKVCZUXBVVNIUJWURUWSUXAVVMUWTU
      YKKXGXHXJUWDVYSWUPUYGVVOVBVYSWUOUYFUXCHVYSWUNUYCUEUFVYSUYCVAVYRUYCVSTZVUJ
      VVHAWUSUYLUYCUWEUWFWAVAVSTVYSUWGXQUWHXJVGXRUWMUWIXLVJVIUWJUWNUWKUWLYP $.
  $}

  ${
    $d a t T $.  $d a A $.  $d a ph $.  $d t x z $.  $d x A $.  $d x B $.
    $d x D $.  $d x E $.  $d x z F $.  $d x T $.
    stoweidlem18.1 $e |- F/_ t D $.
    stoweidlem18.2 $e |- F/ t ph $.
    stoweidlem18.3 $e |- F = ( t e. T |-> 1 ) $.
    stoweidlem18.4 $e |- T = U. J $.
    stoweidlem18.5 $e |- ( ( ph /\ a e. RR ) -> ( t e. T |-> a ) e. A ) $.
    stoweidlem18.6 $e |- ( ph -> B e. ( Clsd ` J ) ) $.
    stoweidlem18.7 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem18.8 $e |- ( ph -> D = (/) ) $.
    $( This theorem proves Lemma 2 in [BrosowskiDeutsh] p. 92 when A is empty,
       the trivial case.  Here D is used to denote the set A of Lemma 2,
       because the variable A is used for the subalgebra.  (Contributed by
       Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem18 $p |- ( ph -> E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\
          ( x ` t ) <_ 1 ) /\ A. t e. D ( x ` t ) < E /\
          A. t e. B ( 1 - E ) < ( x ` t ) ) ) $=
      ( c1 wcel cc0 cv cfv cle wbr wa wral clt cmin co wrex cmpt cr stoweidlem4
      w3a mpan2 syl5eqel 0le1 wceq simpr fvmpt2 sylancl syl5breqr 1le1 syl6eqbr
      1re jca ex ralrimi nfcv nfeq rzalf syl a1i ltsubrpd adantr ccld wss cldss
      sselda breqtrrd nfmpt1 nfcxfr fveq1 breq2d breq1d ralbid 3anbi123d rspcev
      c0 anbi12d syl13anc ) AIDUAUBCUCZIUDZUEUFZWOTUEUFZUGZCGUHZWOHUIUFZCFUHZTH
      UJUKZWOUIUFZCEUHZUBWNBUCZUDZUEUFZXFTUEUFZUGZCGUHZXFHUIUFZCFUHZXBXFUIUFZCE
      UHZUPZBDULAICGTUMZDNATUNUAZXPDUAVGAKCDTGPUOUQURAWRCGMAWNGUAZWRAXRUGZWPWQX
      SUBTWOUEUSXSXRXQWOTUTZAXRVAVGCGTUNINVBZVCZVDXSWOTTUEYBVEVFVHVIVJAFWKUTXAS
      WTCFCFWKLCWKVKVLVMVNAXCCEMAWNEUAZXCAYCUGZXBTWOUIAXBTUIUFYCATHXQAVGVORVPVQ
      YDXRXQXTAEGWNAEJVRUDUAEGVSQEJGOVTVNWAVGYAVCWBVIVJXOWSXAXDUPBIDXEIUTZXJWSX
      LXAXNXDYEXIWRCGCXEICXEVKCIXPNCGTWCWDVLZYEXGWPXHWQYEXFWOUBUEWNXEIWEZWFYEXF
      WOTUEYGWGWLWHYEXKWTCFYFYEXFWOHUIYGWGWHYEXMXCCEYFYEXFWOXBUIYGWFWHWIWJWM $.
  $}

  ${
    $d f g m t z A $.  $d f g m z F $.  $d f g m t z T $.  $d f g m ph $.
    $d m n t A $.  $d n F $.  $d n t N $.  $d n t T $.  $d n ph $.  $d t x A $.
    $d x T $.  $d x ph $.
    stoweidlem19.1 $e |- F/_ t F $.
    stoweidlem19.2 $e |- F/ t ph $.
    stoweidlem19.3 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem19.4 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
     ( t e. T |-> ( ( f ` t ) x. (
                 g ` t ) ) ) e. A ) $.
    stoweidlem19.5 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem19.6 $e |- ( ph -> F e. A ) $.
    stoweidlem19.7 $e |- ( ph -> N e. NN0 ) $.
    $( If a set of real functions is closed under multiplication and it
       contains constants, then it is closed under finite exponentiation.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem19 $p |- ( ph -> ( t e. T |-> ( ( F ` t ) ^ N ) ) e. A ) $=
      ( wcel cexp co cmpt vn vm cn0 cv cfv wi cc0 c1 caddc wceq mpteq2dv eleq1d
      oveq2 imbi2d wa cr cc wf ancli eleq1 anbi2d feq1 imbi12d vtoclg sylc recn
      fnvinran exp0 eqcomd mpteq2da 1re stoweidlem4 mpan2 eqeltrrd simpr simpll
      3syl simplr mpd w3a cmul nfv nfmpt1 nfel1 nf3an simpl1 syl syl2anc simpl2
      expp1d 3adant2 simp2 reexpcld eqid fvmpt2 oveq1d adantr nfeq2 stoweidlem6
      syl3anc mpd3an3 eqeltrd exp31 nn0ind mpcom ) IUCQACECUDZHUEZIRSZTZDQZPACE
      XGUAUDZRSZTZDQZUFACEXGUGRSZTZDQZUFACEXGUBUDZRSZTZDQZUFZACEXGXRUHUISZRSZTZ
      DQZUFAXJUFUAUBIXKUGUJZXNXQAYGXMXPDYGCEXLXOXKUGXGRUMUKULUNXKXRUJZXNYAAYHXM
      XTDYHCEXLXSXKXRXGRUMUKULUNXKYCUJZXNYFAYIXMYEDYICEXLYDXKYCXGRUMUKULUNXKIUJ
      ZXNXJAYJXMXIDYJCEXLXHXKIXGRUMUKULUNACEUHTZXPDACEUHXOKAXFEQZUOZXOUHYMXGUPQ
      ZXGUQQZXOUHUJAEUPXFHAHDQZAYPUOZEUPHURZOAYPOUSAFUDZDQZUOZEUPYSURZUFYQYRUFF
      HDYSHUJZUUAYQUUBYRUUCYTYPAYSHDUTVAEUPYSHVBVCLVDVEVGZXGVFZXGVHVQVIVJAUHUPQ
      YKDQVKABCDUHENVLVMVNXRUCQZYBAYFUUFYBUOZAUOZAUUFYAYFUUGAVOZUUFYBAVPUUHAYAU
      UIUUFYBAVRVSAUUFYAVTZYECEXSXGWASZTZDUUJCEYDUUKAUUFYACKUUFCWBCXTDCEXSWCZWD
      WEZUUJYLUOZXGXRUUOAYLYOAUUFYAYLWFZUUJYLVOZYMYNYOUUDUUEWGWHAUUFYAYLWIZWJVJ
      UUJUULCEXFXTUEZXGWASZTZDUUJCEUUKUUTUUNUUOXSUUSXGWAUUOYLXSUPQZXSUUSUJUUQUU
      OAUUFYLUVBUUPUURUUQAUUFYLVTXGXRAYLYNUUFUUDWKAUUFYLWLWMWTYLUVBUOUUSXSCEXSU
      PXTXTWNWOVIWHWPVJAYAUVADQZUUFAYAYPUVCAYPYAOWQACDEFGXTHCYSXTUUMWRCGUDHJWRM
      WSXAWKXBXBWTXCXDXE $.
  $}

  ${
    $d f g i t y z G $.  $d f g y A $.  $d f g i t y z T $.  $d f g i y ph $.
    $d i n t x G $.  $d i n t x M $.  $d n x A $.  $d n t x T $.  $d n x ph $.
    $d x y A $.  $d y M $.
    stoweidlem20.1 $e |- F/ t ph $.
    stoweidlem20.2 $e |- F
             = ( t e. T |-> sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) $.
    stoweidlem20.3 $e |- ( ph -> M e. NN ) $.
    stoweidlem20.4 $e |- ( ph -> G : ( 1 ... M ) --> A ) $.
    stoweidlem20.5 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem20.6 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    $( If a set A of real functions from a common domain T is closed under the
       sum of two functions, then it is closed under the sum of a finite number
       of functions, indexed by G. (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem20 $p |- ( ph -> F e. A ) $=
      ( c1 wcel wa cr vn vx vy cfz co cv cfv csu cmpt cle wbr nnred leidd ancli
      cn wi wceq eleq1 breq1 anbi2d oveq2 sumeq1d mpteq2dv eleq1d imbi12d caddc
      cz cc 1z wf cuz nnuz syl6eleq eluzfz1 ffvelrnd feq1 vtoclg sylc ffvelrnda
      syl recnd fveq2 fveq1d sylancr mpteq2da feqmptd eqtr4d eqeltrd adantr w3a
      fsum1 simprl simpll simprr 3jca simp1 nnre 3ad2ant2 1re readdcld 3ad2ant1
      a1i lep1d simp3 letrd jca syl3anc simplr mpd simpl2 simpll1 nnzd ad2antrr
      nf3an elfzelz adantl elfzle1 zred elfzle2 simpll3 syl32anc 3adant3 fsump1
      nfv elfz4 simpr letrp1 simpl3 adantlr fsumrecl eqid fvmpt2 syl2anc oveq1d
      fzfid peano2nn nnge1d anabsi7 eqeltrrd nfmpt1 oveq2d stoweidlem8 syl5eqel
      simpl1 syldan exp31 nnind syl3c ) AHBDQJUDUEZBUFZGUFZIUGZUGZGUHZUIZCLAJUO
      RZUUPAJJUJUKZSZUUOCRZMMAUUQAJAJMULUMUNUAUFZUORZAUUTJUJUKZSZBDQUUTUDUEZUUM
      GUHZUIZCRZUPZUPUUPUURUUSUPZUPUAJUOUUTJUQZUVAUUPUVHUVIUUTJUOURUVJUVCUURUVG
      UUSUVJUVBUUQAUUTJJUJUSUTUVJUVFUUOCUVJBDUVEUUNUVJUVDUUIUUMGUUTJQUDVAVBVCVD
      VEVEAUBUFZJUJUKZSZBDQUVKUDUEZUUMGUHZUIZCRZUPAQJUJUKZSZBDQQUDUEZUUMGUHZUIZ
      CRZUPAUCUFZJUJUKZSZBDQUWDUDUEZUUMGUHZUIZCRZUPZAUWDQVFUEZJUJUKZSZBDQUWLUDU
      EZUUMGUHZUIZCRZUPUVHUBUCUUTUVKQUQZUVMUVSUVQUWCUWSUVLUVRAUVKQJUJUSUTUWSUVP
      UWBCUWSBDUVOUWAUWSUVNUVTUUMGUVKQQUDVAVBVCVDVEUVKUWDUQZUVMUWFUVQUWJUWTUVLU
      WEAUVKUWDJUJUSUTUWTUVPUWICUWTBDUVOUWHUWTUVNUWGUUMGUVKUWDQUDVAVBVCVDVEUVKU
      WLUQZUVMUWNUVQUWRUXAUVLUWMAUVKUWLJUJUSUTUXAUVPUWQCUXABDUVOUWPUXAUVNUWOUUM
      GUVKUWLQUDVAVBVCVDVEUVKUUTUQZUVMUVCUVQUVGUXBUVLUVBAUVKUUTJUJUSUTUXBUVPUVF
      CUXBBDUVOUVEUXBUVNUVDUUMGUVKUUTQUDVAVBVCVDVEAUWCUVRAUWBQIUGZCAUWBBDUUJUXC
      UGZUIUXCABDUWAUXDKAUUJDRZSZQVGRZUXDVHRUWAUXDUQVIUXFUXDADTUUJUXCAUXCCRZAUX
      HSZDTUXCVJZAUUICQINAJQVKUGZRQUUIRAJUOUXKMVLVMQJVNVTVOZAUXHUXLUNAEUFZCRZSZ
      DTUXMVJZUPZUXIUXJUPEUXCCUXMUXCUQZUXOUXIUXPUXJUXRUXNUXHAUXMUXCCURUTDTUXMUX
      CVPVEPVQVRZVSWAUUMUXDGQUUKQUQUUJUULUXCUUKQIWBWCWKWDWEABDTUXCUXSWFWGUXLWHW
      IUWDUORZUWKUWNUWRUXTUWKSZUWNSZAUXTUWMWJZUWJUWRUYBAUXTUWMUYAAUWMWLZUXTUWKU
      WNWMZUYAAUWMWNZWOUYBUWFUWJUYBAUXTUWMUWFUYDUYEUYFUYCAUWEAUXTUWMWPZUYCUWDUW
      LJUXTAUWDTRZUWMUWDWQWRZUYCUWDQUYIQTRUYCWSXBWTZUYCJAUXTUUPUWMMXAULZUYCUWDU
      YIXCAUXTUWMXDZXEXFXGUXTUWKUWNXHXIUYCUWJSZUWQBDUUJUWIUGZUUJUWLIUGZUGZVFUEZ
      UIZCUYCUWQUYRUQUWJUYCBDUWPUYQAUXTUWMBKUXTBYDUWMBYDXNZUYCUXESZUWPUWHUYPVFU
      EUYQUYTUUMUYPGQUWDUYTUWDUOUXKAUXTUWMUXEXJVLVMUYTUUKUWORZSZAUUKUUIRZUXEUUM
      VHRAUXTUWMUXEVUAXKVUBUXGJVGRZUUKVGRZQUUKUJUKZUUKJUJUKZVUCUXGVUBVIXBUYCVUD
      UXEVUAAUXTVUDUWMAJMXLXAZXMVUAVUEUYTUUKQUWLXOZXPVUAVUFUYTUUKQUWLXQXPVUBUUK
      UWLJVUAUUKTRZUYTVUAUUKVUIXRXPUYCUWLTRZUXEVUAUYJXMUYCJTRZUXEVUAUYKXMVUAUUK
      UWLUJUKZUYTUUKQUWLXSXPAUXTUWMUXEVUAXTXEUUKQJYEZYAUYCUXEVUAXHAVUCUXEWJZUUM
      VUODTUUJUULVUOUULCRZAVUPSZDTUULVJZAVUCVUPUXEAUUICUUKINVSYBZVUOAVUPAVUCUXE
      WPVUSXFUXQVUQVURUPEUULCUXMUULUQZUXOVUQUXPVURVUTUXNVUPAUXMUULCURUTDTUXMUUL
      VPVEPVQVRAVUCUXEXDVOZWAXGUUKUWLUQUUJUULUYOUUKUWLIWBWCYCUYTUYNUWHUYPVFUYTU
      XEUWHTRUYNUWHUQUYCUXEYFZUYTUWGUUMGUYTQUWDYOUYTUUKUWGRZSZAVUCUXEUUMTRAUXTU
      WMUXEVVCXKVVDUXGVUDVUEVUFVUGVUCUXGVVDVIXBUYCVUDUXEVVCVUHXMVVCVUEUYTUUKQUW
      DXOZXPVVCVUFUYTUUKQUWDXQXPUYCVVCVUGUXEUYCVVCSZUUKUWLJVVCVUJUYCVVCUUKVVEXR
      XPZUYCVUKVVCUYJWIUYCVULVVCUYKWIVVFVUJUYHUUKUWDUJUKZVUMVVGUYCUYHVVCUYIWIVV
      CVVHUYCUUKQUWDXSXPUUKUWDYGXGAUXTUWMVVCYHXEYIVUNYAUYCUXEVVCXHVVAXGYJBDUWHT
      UWIUWIYKYLYMYNWGWEWIUYMBDUYNUUJBDUYPUIZUGZVFUEZUIZUYRCUYCVVLUYRUQUWJUYCBD
      VVKUYQUYSUYTVVJUYPUYNVFUYTUXEUYPTRVVJUYPUQVVBUYCDTUUJUYOUYCAUYOCRZDTUYOVJ
      ZUYGUYCAUWLUUIRZVVMUYGUYCUXGVUDUWLVGRZQUWLUJUKZUWMVVOUXGUYCVIXBVUHUXTAVVP
      UWMUXTUWLUWDYPZXLWRUXTAVVQUWMUXTUWLVVRYQWRUYLUWLQJYEYAZAUUICUWLINVSZYMAVV
      MVVNUXQAVVMSZVVNUPEUYOCUXMUYOUQZUXOVWAUXPVVNVWBUXNVVMAUXMUYOCURUTDTUXMUYO
      VPVEPVQYRZYMVSBDUYPTVVIVVIYKYLYMUUAWEWIUYMAUWJVVICRZVVLCRAUXTUWMUWJUUDZUY
      CUWJYFUYMAVVOVWDVWEUYCVVOUWJVVSWIAVVOSUYOVVICAVVOVVMUYOVVIUQVVTVWABDTUYOV
      WCWFUUEVVTYSYMABCDEFUWIVVIOBDUWHYTBDUYPYTUUBXGYSWHYMUUFUUGVQUUHUUC $.
  $}

  ${
    $d f g t T $.  $d f g A $.  $d f g E $.  $d f g F $.  $d f g G $.
    $d f g H $.  $d f g ph $.  $d g S $.  $d s S $.  $d s T $.  $d t x T $.
    $d x A $.  $d x S $.  $d x ph $.
    stoweidlem21.1 $e |- F/_ t G $.
    stoweidlem21.2 $e |- F/_ t H $.
    stoweidlem21.3 $e |- F/_ t S $.
    stoweidlem21.4 $e |- F/ t ph $.
    stoweidlem21.5 $e |- G = ( t e. T |-> ( ( H ` t ) + S ) ) $.
    stoweidlem21.6 $e |- ( ph -> F : T --> RR ) $.
    stoweidlem21.7 $e |- ( ph -> S e. RR ) $.
    stoweidlem21.8 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem21.9 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem21.10 $e |- ( ph -> A. f e. A f : T --> RR ) $.
    stoweidlem21.11 $e |- ( ph -> H e. A ) $.
    stoweidlem21.12 $e |- ( ph ->
          A. t e. T ( abs ` ( ( H ` t ) - ( ( F ` t ) - S ) ) ) < E ) $.
    $( Once the Stone Weierstrass theorem has been proven for approximating
       nonnegative functions, then this lemma is used to extend the result to
       functions with (possibly) negative values.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem21 $p |- ( ph ->
          E. f e. A A. t e. T ( abs ` ( ( f ` t ) - ( F ` t ) ) ) < E ) $=
      ( vs wcel cv cfv cmin co cabs clt wbr wral wrex csn caddc cmpt wa cr wceq
      fvconst2g sylan eqcomd oveq2d mpteq2da syl5eq fconstmpt nfcv eqidd cbvmpt
      cxp eqtri wi nfeq2 simpl eleq1d imbi2d expcom vtoclga mpcom syl5eqel nfsn
      nfxp stoweidlem8 mpd3an23 eqeltrd wf feq1 rspccva syl2anc fnvinran adantr
      simpr readdcld fvmpt2 oveq1d recnd cc subsub3d eqtr4d r19.21bi eqbrtrd ex
      fveq2d ralrimi fveq1 breq1d ralbid rspcev ) AKDUFCUGZKUHZXKJUHZUIUJZUKUHZ
      IULUMZCFUNZXKGUGZUHZXMUIUJZUKUHZIULUMZCFUNZGDUOAKCFXKLUHZXKFEUPZVLZUHZUQU
      JZURZDAKCFYDEUQUJZURYIQACFYJYHPAXKFUFZUSZEYGYDUQYLYGEAEUTUFZYKYGEVASFEXKU
      TVBVCVDVEVFVGALDUFZYFDUFYIDUFUCAYFCFEURZDYFUEFEURYOUEFEVHUECFEEOUEEVIUEUG
      XKVAEVJVKVMYMAYODUFZSACFBUGZURZDUFZVNAYPVNBEUTYQEVAZYSYPAYTYRYODYTCFYQECY
      QEOVOYTYKVPVFVQVRAYQUTUFYSUAVSVTWAWBACDFGHLYFTNCFYECFVICEOWCWDWEWFWGAXPCF
      PAYKXPYLXOYDXMEUIUJUIUJZUKUHZIULYLXNUUAUKYLXNYJXMUIUJUUAYLXLYJXMUIYLYKYJU
      TUFXLYJVAAYKWNYLYDEAFUTXKLAFUTXRWHZGDUNYNFUTLWHZUBUCUUCUUDGLDFUTXRLWIWJWK
      WLZAYMYKSWMWOCFYJUTKQWPWKWQYLYDXMEYLYDUUEWRYLXMAFUTXKJRWLWRAEWSUFYKAESWRW
      MWTXAXEAUUBIULUMCFUDXBXCXDXFYCXQGKDXRKVAZYBXPCFCXRKMVOUUFYAXOIULUUFXTXNUK
      UUFXSXLXMUIXKXRKXGWQXEXHXIXJWK $.
  $}

  ${
    $d f g t z A $.  $d f g z F $.  $d f g z G $.  $d f g z I $.  $d f g t T $.
    $d f g ph $.  $d g z L $.  $d t x A $.  $d x T $.  $d x ph $.
    stoweidlem22.8 $e |- F/ t ph $.
    stoweidlem22.9 $e |- F/_ t F $.
    stoweidlem22.10 $e |- F/_ t G $.
    stoweidlem22.1 $e |- H = ( t e. T |-> ( ( F ` t ) - ( G ` t ) ) ) $.
    stoweidlem22.2 $e |- I = ( t e. T |-> -u 1 ) $.
    stoweidlem22.3 $e |- L = ( t e. T |-> ( ( I ` t ) x. ( G ` t ) ) ) $.
    stoweidlem22.4 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem22.5 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem22.6 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem22.7 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    $( If a set of real functions from a common domain is closed under
       addition, multiplication and it contains constants, then it is closed
       under subtraction.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem22 $p |- ( ( ph /\ F e. A /\ G e. A ) ->
          ( t e. T |-> ( ( F ` t ) - ( G ` t ) ) ) e. A ) $=
      ( wcel w3a cv cfv cmin co cmpt caddc nfel1 nf3an wa cneg cmul c1 cr simpr
      wf simpl1 1re renegcli stoweidlem4 mpan2 syl5eqel wi eleq1 anbi2d imbi12d
      wceq feq1 vtoclg anabsi7 mpdan syl ffvelrnd simpl3 3adant3 simp3 remulcld
      syl3anc fvmpt2 syl2anc adantl oveq1d mulm1d 3eqtrd oveq2d simpl2 mpteq2da
      recnd negsubd eqtr2d 3ad2ant1 nfmpt1 nfcxfr nfeq2 stoweidlem6 stoweidlem8
      syld3an2 syld3an3 eqeltrd ) AHDUCZIDUCZUDZCECUEZHUFZXFIUFZUGUHZUICEXGXFLU
      FZUJUHZUIZDXECEXIXKAXCXDCMCHDNUKCIDOUKULXEXFEUCZUMZXKXGXHUNZUJUHXIXNXJXOX
      GUJXNXJXFKUFZXHUOUHZUPUNZXHUOUHXOXNXMXQUQUCXJXQVJXEXMURZXNXPXHXNEUQXFKXNA
      EUQKUSZAXCXDXMUTZAKDUCZXTAKCEXRUIZDQAXRUQUCZYCDUCUPVAVBZABCDXREUBVCVDVEZA
      YBXTAFUEZDUCZUMZEUQYGUSZVFZAYBUMZXTVFFKDYGKVJZYIYLYJXTYMYHYBAYGKDVGVHEUQY
      GKVKVISVLVMVNVOXSVPXNAXDXMXHUQUCYAAXCXDXMVQXSAXDXMUDEUQXFIAXDEUQIUSZXMAXD
      YNYKAXDUMZYNVFFIDYGIVJZYIYOYJYNYPYHXDAYGIDVGVHEUQYGIVKVISVLVMVRAXDXMVSVPW
      AZVTCEXQUQLRWBWCXNXPXRXHUOXMXPXRVJZXEXMYDYRYECEXRUQKQWBVDWDWEXNXHXNXHYQWK
      ZWFWGWHXNXGXHXNXGXNEUQXFHXNAXCEUQHUSZYAAXCXDXMWIAXCYTYKAXCUMZYTVFFHDYGHVJ
      ZYIUUAYJYTUUBYHXCAYGHDVGVHEUQYGHVKVISVLVMWCXSVPWKYSWLWMWJAXCXDLDUCXLDUCXE
      LCEXQUIZDRAYBXCXDUUCDUCAXCYBXDYFWNACDEFGKICYGKCKYCQCEXRWOWPWQCGUEIOWQUAWR
      WTVEACDEFGHLTNCLUUCRCEXQWOWPWSXAXB $.
  $}

  ${
    $d f g t z T $.  $d f g A $.  $d f g z G $.  $d f g ph $.  $d g t z Z $.
    $d t x z T $.  $d t z S $.  $d x A $.  $d x z G $.  $d x z Z $.  $d x ph $.
    $d z H $.
    stoweidlem23.1 $e |- F/ t ph $.
    stoweidlem23.2 $e |- F/_ t G $.
    stoweidlem23.3 $e |- H = ( t e. T |-> ( ( G ` t ) - ( G ` Z ) ) ) $.
    stoweidlem23.4 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem23.5 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem23.6 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem23.7 $e |- ( ph -> S e. T ) $.
    stoweidlem23.8 $e |- ( ph -> Z e. T ) $.
    stoweidlem23.9 $e |- ( ph -> G e. A ) $.
    stoweidlem23.10 $e |- ( ph -> ( G ` S ) =/= ( G ` Z ) ) $.
    $( This lemma is used to prove the existence of a function p_t as in the
       beginning of Lemma 1 [BrosowskiDeutsh] p. 90: for all t in T - U, there
       exists a function p in the subalgebra, such that p_t ( t_0 ) = 0 , p_t
       ( t ) > 0, and 0 <= p_t <= 1.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem23 $p |- ( ph ->
          ( H e. A /\ ( H ` S ) =/= ( H ` Z ) /\ ( H ` Z ) = 0 ) ) $=
      ( wcel cfv wne cc0 wceq cv cmin co cmpt caddc wa cr wf ancli eleq1 anbi2d
      cneg wi feq1 imbi12d vtoclg sylc fnvinran recnd ffvelrnd negsubd mpteq2da
      adantr simpr renegcld eqid fvmpt2 syl2anc oveq2d nfneg nfeq2 simpl eleq1d
      nfcv nfmpt1 stoweidlem8 mpd3an23 eqeltrrd syl5eqel subne0d resubcld fveq2
      nffv nfov oveq1d fvmptf subidd eqtrd 3netr4d 3jca ) AJDUBEJUCZKJUCZUDWRUE
      UFAJCFCUGZIUCZKIUCZUHUIZUJZDNACFWTXAURZUKUIZUJZXCDACFXEXBLAWSFUBZULZWTXAX
      HWTAFUMWSIAIDUBZAXIULZFUMIUNZTAXITUOAGUGZDUBZULZFUMXLUNZUSXJXKUSGIDXLIUFZ
      XNXJXOXKXPXMXIAXLIDUPUQFUMXLIUTVAOVBVCZVDVEXHXAAXAUMUBXGAFUMKIXQSVFZVIVEV
      GVHACFWTWSCFXDUJZUCZUKUIZUJZXFDACFYAXELXHXTXDWTUKXHXGXDUMUBZXTXDUFAXGVJAY
      CXGAXAXRVKZVICFXDUMXSXSVLVMVNVOVHAXIXSDUBZYBDUBTAYCAYCULZYEYDAYCYDUOABUGZ
      UMUBZULZCFYGUJZDUBZUSYFYEUSBXDUMYGXDUFZYIYFYKYEYLYHYCAYGXDUMUPUQYLYJXSDYL
      CFYGXDCYGXDCXACKIMCKVTZWIZVPVQYLXGVRVHVSVAQVBVCACDFGHIXSPMCFXDWAWBWCWDWDW
      EAEIUCZXAUHUIZUEWQWRAYOXAAYOAFUMEIXQRVFZVEAXAXRVEZUAWFAEFUBYPUMUBWQYPUFRA
      YOXAYQXRWGCEXBYPFJUMCEVTZCYOXAUHCEIMYSWICUHVTZYNWJWSEUFWTYOXAUHWSEIWHWKNW
      LVNAWRXAXAUHUIZUEAKFUBUUAUMUBWRUUAUFSAXAXAXRXRWGCKXBUUAFJUMYMCXAXAUHYNYTY
      NWJWSKUFWTXAXAUHWSKIWHWKNWLVNAXAYRWMWNZWOUUBWP $.
  $}

  ${
    $d t T $.
    stoweidlem24.1 $e |- V = { t e. T | ( P ` t ) < ( D / 2 ) } $.
    stoweidlem24.2 $e |- Q
         = ( t e. T |-> ( ( 1 - ( ( P ` t ) ^ N ) ) ^ ( K ^ N ) ) ) $.
    stoweidlem24.3 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem24.4 $e |- ( ph -> N e. NN0 ) $.
    stoweidlem24.5 $e |- ( ph -> K e. NN0 ) $.
    stoweidlem24.6 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem24.8 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem24.9 $e |- ( ph -> ( 1 - E ) <
          ( 1 - ( ( ( K x. D ) / 2 ) ^ N ) ) ) $.
    stoweidlem24.10 $e |- ( ph ->
          A. t e. T ( 0 <_ ( P ` t ) /\ ( P ` t ) <_ 1 ) ) $.
    $( This lemma proves that for ` n ` sufficiently large, q_n( t ) > ( 1 -
       epsilon ), for all ` t ` in ` V ` : see Lemma 1 [BrosowskiDeutsh] p. 90,
       (at the bottom of page 90). ` Q ` is used to represent q_n in the paper,
       ` N ` to represent ` n ` in the paper, ` K ` to represent ` k ` , ` D `
       to represent &delta;, and ` E ` to represent &epsilon;.  (Contributed by
       Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem24 $p |- ( ( ph /\ t e. V ) -> ( 1 - E ) < ( Q ` t ) ) $=
      ( wcel cv wa c1 cmin co cfv cexp clt cmul cr rpred adantr resubcld nn0red
      1re a1i wf cdiv wbr rabeq2i simplbi adantl ffvelrnd remulcld cn0 reexpcld
      c2 jca nn0expcl syl rehalfcld cc0 nn0ge0d r19.21bi simpld sylan2 syl12anc
      cle mulge0 simprbi ltled lemul2a syl31anc cc wne wceq nn0cnd rpcnd pm3.2i
      2cn 2ne0 syl3anc breqtrrd leexp1a syl32anc lesub2dd ltletrd recnd mulexpd
      divass eqcomd oveq2d simprd exple1 stoweidlem10 eqbrtrrd stoweidlem12 ) A
      BUAZJTZUBZUCGUDUEZUCXHDUFZIUGUEZUDUEZHIUGUEZUGUEZXHEUFZUHXJXKUCHXLUIUEZIU
      GUEZUDUEZXPXJUCGUCUJTZXJUOUPZAGUJTXIAGQUKULUMZXJUCXSYBXJXRIXJHXLAHUJTZXIA
      HOUNZULXJFUJXHDAFUJDUQXIMULXIXHFTZAXIYFXLCVGURUEZUHUSZYHBJFKUTZVAZVBVCZVD
      ZAIVETZXINULZVFZUMZXJXNXOXJUCXMYBXJXLIYKYNVFZUMXJHVETZYMUBZXOVETZAYSXIAYR
      YMONVHULHIVIVJZVFXJXKUCHCUIUEZVGURUEZIUGUEZUDUEZXTYCAUUEUJTXIAUCUUDYAAUOU
      PAUUCIAUUBAHCYEACPUKZVDVKZNVFZUMULYPAXKUUEUHUSXIRULXJXSUUDUCYOAUUDUJTXIUU
      HULYBXJXRUJTUUCUJTZYMVLXRVRUSZXRUUCVRUSXSUUDVRUSYLAUUIXIUUGULYNXJYDVLHVRU
      SZUBZXLUJTZVLXLVRUSZUUJAUULXIAYDUUKYEAHOVMVHULZYKXIAYFUUNYJAYFUBUUNXLUCVR
      USZAUUNUUPUBZBFSVNZVOVPZHXLVSVQXJXRHYGUIUEZUUCVRXJUUMYGUJTZUULXLYGVRUSXRU
      UTVRUSYKAUVAXIACUUFVKULZUUOXJXLYGYKUVBXIYHAXIYFYHYIVTVBWAXLYGHWBWCXJHWDTZ
      CWDTZVGWDTZVGVLWEZUBZUUCUUTWFAUVCXIAHOWGULZAUVDXIACPWHULUVGXJUVEUVFWJWKWI
      UPHCVGWTWLWMXRUUCIWNWOWPWQXJUCXOXMUIUEZUDUEZXTXPVRXJUVIXSUCUDXJXSUVIXJHXL
      IUVHXJXLYKWRYNWSXAXBXJXMUJTYTXMUCVRUSZUVJXPVRUSYQUUAXJUUMUUNUUPYMUVKYKUUS
      XJUUNUUPXIAYFUUQYJUURVPXCYNXLIXDWCXMXOXEWLXFWQXIAYFXQXPWFYJABDEFHILMNOXGV
      PWM $.
  $}

  ${
    $d t T $.
    stoweidlem25.1 $e |- Q = ( t e. T |->
          ( ( 1 - ( ( P ` t ) ^ N ) ) ^ ( K ^ N ) ) ) $.
    stoweidlem25.2 $e |- ( ph -> N e. NN ) $.
    stoweidlem25.3 $e |- ( ph -> K e. NN ) $.
    stoweidlem25.4 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem25.6 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem25.7 $e |- ( ph ->
          A. t e. T ( 0 <_ ( P ` t ) /\ ( P ` t ) <_ 1 ) ) $.
    stoweidlem25.8 $e |- ( ph -> A. t e. ( T \ U ) D <_ ( P ` t ) ) $.
    stoweidlem25.9 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem25.11 $e |- ( ph -> ( 1 / ( ( K x. D ) ^ N ) ) < E ) $.
    $( This lemma proves that for n sufficiently large, q_n( t ) < &epsilon;,
       for all ` t ` in ` T \ U ` : see Lemma 1 [BrosowskiDeutsh] p. 91 (at the
       top of page 91). ` Q ` is used to represent q_n in the paper, ` N ` to
       represent n in the paper, ` K ` to represent k, ` D ` to represent
       &delta;, ` P ` to represent p, and ` E ` to represent &epsilon;.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem25 $p |- ( ( ph /\ t e. ( T \ U ) ) -> ( Q ` t ) < E ) $=
      ( wcel cv cdif wa c1 cmul co cexp cdiv cr eldifi cmin nnnn0d stoweidlem12
      cfv 1re a1i fnvinran cn0 adantr reexpcld resubcld nnexpcld eqeltrd sylan2
      nnred rpred remulcld cc nncnd nnne0d rpcnne0d mulne0 syl21anc cn wb rpcnd
      cc0 wne mulcld expne0 syl2anc mpbird rereccld cle wceq wf adantl ffvelrnd
      crp 0re clt wbr rpgt0d r19.21bi ltletrd elrpd wral rsp sylc simpld simprd
      stoweidlem1 eqbrtrd lelttrd ) ABUAZFGUBZTZUCZXEEUNZUDICUEUFZJUGUFZUHUFZHX
      GAXEFTZXIUITXEFGUJZAXMUCZXIUDXEDUNZJUGUFZUKUFZIJUGUFZUGUFZUIABDEFIJKOAJLU
      LZAIMULUMZXOXRXSXOUDXQUDUITXOUOUPXOXPJAFUIXEDOUQAJURTXMYAUSUTVAAXSURTXMAX
      SAIJMYAVBULUSUTVCVDAXLUITXGAXKAXJJAICAIMVEACNVFZVGYAUTAXKVQVRZXJVQVRZAIVH
      TIVQVRCVHTCVQVRUCYEAIMVIZAIMVJACNVKICVLVMAXJVHTJVNTZYDYEVOAICYFACNVPVSLXJ
      JVTWAWBWCUSAHUITXGAHRVFUSXHXIXTXLWDXGAXMXIXTWEXNYBVDXHXPCIJAYGXGLUSAIVNTX
      GMUSACWITXGNUSXHXPXHFUIXEDAFUIDWFXGOUSXGXMAXNWGZWHZXHVQCXPVQUITXHWJUPACUI
      TXGYCUSYIAVQCWKWLXGACNWMUSACXPWDWLBXFQWNZWOWPXHVQXPWDWLZXPUDWDWLZXHYKYLUC
      ZBFWQZXMYMAYNXGPUSYHYMBFWRWSZWTXHYKYLYOXAYJXBXCAXLHWKWLXGSUSXD $.
  $}

  ${
    $d i j t E $.  $d i A $.  $d i j t L $.  $d i j t N $.  $d i t S $.
    $d i ph $.  $d j F $.  $d j t T $.  $d t X $.
    stoweidlem26.1 $e |- F/_ t F $.
    stoweidlem26.2 $e |- F/ j ph $.
    stoweidlem26.3 $e |- F/ t ph $.
    stoweidlem26.4 $e |- D = ( j e. ( 0 ... N ) |->
          { t e. T | ( F ` t ) <_ ( ( j - ( 1 / 3 ) ) x. E ) } ) $.
    stoweidlem26.5 $e |- B = ( j e. ( 0 ... N ) |->
          { t e. T | ( ( j + ( 1 / 3 ) ) x. E ) <_ ( F ` t ) } ) $.
    stoweidlem26.6 $e |- ( ph -> N e. NN ) $.
    stoweidlem26.7 $e |- ( ph -> T e. _V ) $.
    stoweidlem26.8 $e |- ( ph -> L e. ( 1 ... N ) ) $.
    stoweidlem26.9 $e |- ( ph -> S e. ( ( D ` L ) \ ( D ` ( L - 1 ) ) ) ) $.
    stoweidlem26.10 $e |- ( ph -> F : T --> RR ) $.
    stoweidlem26.11 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem26.12 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    stoweidlem26.13 $e |- ( ( ph /\ i e. ( 0 ... N ) ) ->
          ( X ` i ) : T --> RR ) $.
    stoweidlem26.14 $e |- ( ( ph /\ i e. ( 0 ... N ) /\ t e. T ) ->
      0 <_ ( ( X ` i ) ` t ) ) $.
    stoweidlem26.15 $e |- ( ( ph /\ i e. ( 0 ... N ) /\
          t e. ( B ` i ) ) -> ( 1 - ( E / N ) ) < ( ( X ` i ) ` t ) ) $.
    $( This lemma is used to prove that there is a function ` g ` as in the
       proof of [BrosowskiDeutsh] p. 92: this lemma proves that g(t) > ( j - 4
       / 3 ) * &epsilon;.  Here ` L ` is used to represnt j in the paper, ` D `
       is used to represent A in the paper, ` S ` is used to represent t, and
       ` E ` is used to represent &epsilon;.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem26 $p |- ( ph ->
          ( ( L - ( 4 / 3 ) ) x. E ) < ( ( t e. T |-> sum_ i e. ( 0 ... N )
          ( E x. ( ( X ` i ) ` t ) ) ) ` S ) ) $=
      ( c4 c3 cdiv co cmin cmul cc0 cfz cv cfv csu clt c1 wceq wbr wa cr adantl
      wcel 1re 4re a1i 3re 3ne0 resubcld adantr remulcld 0re fzfid cle wn sylib
      crab simpld cvv caddc oveq1i cz 0z rabexg syl oveq1 oveq1d breq2d rabbidv
      fvmptg syl2anc nfcv nfbr breq1d elrabf fsumrecl redivcli recnd subid1d wb
      3cn cc eqtrd wi nfv eqbrtrrd c2 elfzelz cuz w3a zsubcld 2re mpbii breqtrd
      zred elfzle2 letrd sylibr syldan readdcld ax-1cn ltsub2dd breqtrrd subcld
      3jca elfz syl3anc mpbid simprd mulcld lttrd oveq2d 3eqtrd wo 2cn adantlr
      cmpt eleq1 mpbiri wne redivcld rpred eldif 1e0p1 wss fzp1ss ax-mp eqsstri
      cdif sseldi eleqtrd nffv ffvelrnd dividi 3lt4 3pos ltdiv1ii mpbi eqbrtrri
      fveq2 breq1 eqbrtrd ltsub23d rpgt0d mulltgt0 syl22anc chash cfn fsumconst
      0cn sylancl hashcl nn0cn 3syl mul01d rpge0d nfan nfim imbi2d 3expia com12
      cn0 vtoclgaf mpcom mulge0d fsumle ltletrd zre nndivred 2z nnzd nnred 2pos
      ltleii lesub2d zcnd eluz2 fzss2 sselda ltadd2dd divdiri 3eqtr3ri syl6breq
      3p1e4 rpcnd subsub4d ltmul1dd mulcomd subdid eqtr3d zlem1lt nngt0d ltdiv1
      1z syl112anc nnne0d dividd mulgt0d ltmul2 mulid1d subdird mulid2d mulassd
      nncnd divcld div32d eqtr4d cn elnnuz elfzp12 orcanai 1p1e2 elfzle1 mpbird
      subge0d hashfz subadd23d cneg negsubdi2i 2m1e1 negeqi eqtr3i negsubd fzn0
      c0 ad2antrr simpll wf jca ffvelrn leadd1dd lemul1 addid1 eqcomd addsubass
      mp1i subidd subsubd divcli addsubassd df-3 subaddrii pm3.2i 3pm3.2i lep1d
      1lt2 peano2zd mpbir2and npcand eqcomi 3eltr4d fzaddel neleqtrd sylnib olc
      ianor anim1i orcom anbi2i pm4.43 ltnled sylanbrc eleqtrrd 3ad2ant1 sseldd
      ltled simp2 elex 3ad2ant3 nfrab1 nfmpt nfcxfr nfel2 nf3an 3anbi3d imbi12d
      vtoclgf syld3an2 mpd3an3 fsumlt fsumcl addid1d lesub1dd syl5eqbrr fsumge0
      1m1e0 simpr lemul2 leadd2dd fsummulc2 cin ltsub2d lelttrd intnanrd mtbird
      wral ex ralrimi disj cun fzsplit uneq2d fsumsplit ltletr mp2and pm2.61dan
      3brtr4d sumex sumeq2sdv eqid ) AKUIUJUKULZUMULZIUNULZUOLUPULZIEGUQZMURZUR
      ZUNULZGUSZEBFVYRIBUQZVYTURZUNULZGUSZUUAZURZUTAKVAVBZVYQWUCUTVCZAWUJVDZVYQ
      UOWUCWULVYPIWULKVYOWUJKVEVGZAWUJWUMVAVEVGZVHKVAVEUUBUUCVFZWULUIUJUIVEVGZW
      ULVIVJUJVEVGZWULVKVJUJUOUUDZWULVLVJUUEVMAIVEVGZWUJAIUDUUFZVNZVOUOVEVGZWUL
      VPVJZAWUCVEVGZWUJAVYRWUBGAUOLVQZAVYSVYRVGZVDZIWUAAWUSWVFWUTVNZWVGFVEEVYTU
      FAEFVGZWVFAWVIEJURZKVAUJUKULZUMULZIUNULZVRVCZAEWUDJURZWVMVRVCZBFWAZVGWVIW
      VNVDAEKDURZWVQAEWVRVGZEKVAUMULZDURZVGVSZAEWVRWWAUUMVGWVSWWBVDUBEWVRWWAUUG
      VTZWBAKVYRVGWVQWCVGZWVRWVQVBAVALUPULZVYRKWWEUOVAWDULZLUPULZVYRVAWWFLUPUUH
      WEUOWFVGZWWGVYRUUIWGUOLUUJUUKUULUAUUNAFWCVGZWWDTWVPBFWCWHWIHKWVOHUQZWVKUM
      ULZIUNULZVRVCZBFWAZWVQVYRWCDWWJKVBZWWMWVPBFWWOWWLWVMWVOVRWWOWWKWVLIUNWWJK
      WVKUMWJWKWLWMQWNWOUUOWVPWVNBEFBEWPZBFWPZBWVJWVMVRBEJNWWPUUPZBVRWPZBWVMWPW
      QWUDEVBZWVOWVJWVMVRWUDEJUVDZWRWSVTWBZVNZUUQZVOZWTZVNWULVYPVEVGVYPUOUTVCWU
      SUOIUTVCZVYQUOUTVCWULKVYOWUOVYOVEVGWULUIUJVIVKVLXAVJZVMWULKUOVYOWUOWVCWXH
      WULKUOUMULZKVYOUTWULKWULKWUOXBXCWULKVYOUTVCZVAVYOUTVCZUJUJUKULZVAVYOUTUJX
      EVLUURZUJUIUTVCWXLVYOUTVCUUSUJUIUJVKVIVKUUTUVAUVBUVCWUJWXJWXKXDAKVAVYOUTU
      VEVFUUCUVFUVGWVAAWXGWUJAIUDUVHZVNVYPIUVIUVJWULVYRUOGUSZUOWUCVRAWXOUOVBWUJ
      AWXOVYRUVKURZUOUNULZUOAVYRUVLVGZUOXFVGWXOWXQVBWVEUVNVYRUOGUVMUVOAWXPAWXRW
      XPUWFVGWXPXFVGWVEVYRUVPWXPUVQUVRUVSXGVNAWXOWUCVRVCWUJAVYRUOWUBGWVEWVBWVGV
      PVJWXEWVGIWUAWVHWXDAUOIVRVCWVFAIUDUVTVNWVIWVGUOWUAVRVCZWXCWVGUOWUEVRVCZXH
      WVGWXSXHBEFWWPWVGWXSBAWVFBPWVFBXIZUWAWXSBXIUWBWWTWXTWXSWVGWWTWUEWUAUOVRWU
      DEVYTUVDZWLUWCWVGWUDFVGZWXTAWVFWYCWXTUGUWDUWEUWGUWHZUWIUWJVNXJUWKAWUJVSZV
      DZVYQIUOKXKUMULZUPULZWUAGUSZUNULZUTVCZWYJWUCVRVCZWUKWYFVYQIVAILUKULZUMULZ
      WVTUNULZUNULZWYJAVYQVEVGZWYEAVYPIAKVYOAKWWEVGZKWFVGZWUMUAKVALXLZKUWLUVRZA
      UIUJWUPAVIVJWUQAVKVJWURAVLVJUUEZVMZWUTVOZVNAWYPVEVGWYEAIWYOWUTAWYNWVTAVAW
      YMWUNAVHVJZAILWUTSUWMVMZAKVAXUAXUEVMZVOZVOVNAWYJVEVGZWYEAIWYIWUTAWYHWUAGA
      UOWYGVQZAVYSWYHVGZWVFWUAVEVGZAWYHVYRVYSALWYGXMURVGZWYHVYRUUIZAWYGWFVGZLWF
      VGZWYGLVRVCZXNZXUMAXUOXUPXUQAKXKAWYRWYSUAWYTWIZXKWFVGZAUWNVJXOZALSUWOZAWY
      GKLAKXKAKXUSXSZXKVEVGZAXPVJZVMXVCALSUWPZAWYGWXIKVRAUOXKVRVCWYGWXIVRVCUOXK
      VPXPUWQUWRAUOXKKWVBAVPVJXVEXVCUWSXQAKAKXUSUWTZXCXRAWYRKLVRVCZUAKVALXTWIYA
      ZYIZWYGLUXAZYBWYGUOLUXBZWIUXCZWXDYCZWTZVOZVNAVYQWYPUTVCWYEAVYQIWVTUNULZII
      UNULZWVTLUKULZUNULZUMULZWYPUTAVYQXVQXVRUMULZXWAXUDAXVQXVRAIWVTWUTXUGVOZAI
      IWUTWUTVOZVMAXVQXVTXWCAXVRXVSXWDAWVTLXUGSUWMZVOZVMAVYQWVTIUMULZIUNULZXWBU
      TAVYPXWGIXUCAWVTIXUGWUTVMUDAVYPKVAIWDULZUMULXWGUTAXWIVYOKAVAIXUEWUTYDXUBX
      UAAXWIVAWVKWDULZVYOUTAIWVKVAWUTWVKVEVGZAVAUJVHVKVLXAZVJZXUEUEUXDUJVAWDULZ
      UJUKULWXLWVKWDULVYOXWJUJVAUJXEYEXEVLUXEXWNUIUJUKUXHWEWXLVAWVKWDWXMWEUXFUX
      GYFAKVAIXVGVAXFVGZAYEVJZAIUDUXIZUXJYGUXKAIXWGUNULXWHXWBAIXWGXWQAWVTIAKVAX
      VGXWPYHZXWQYHUXLAIWVTIXWQXWRXWQUXMUXNXRAXVTXVRXVQXWFXWDXWCAXVTXVRVAUNULZX
      VRUTAXVSVAUTVCZXVTXWSUTVCZAXVSLLUKULZVAUTAWVTLUTVCZXVSXXBUTVCZAXVHXXCAVAK
      VRVCZXVHAWYRXXEXVHVDZUAAWYSVAWFVGZXUPWYRXXFXDXUSXXGAUXRVJZXVBKVALYJYKYLZY
      MZAWYSXUPXVHXXCXDXUSXVBKLUXOWOYLAWVTVEVGZLVEVGZXXLUOLUTVCXXCXXDXDXUGXVFXV
      FALSUXPWVTLLUXQUXSYLALALSUYHZALSUXTZUYAXRAXVSVEVGWUNXVRVEVGUOXVRUTVCXWTXX
      AXDXWEXUEXWDAIIWUTWUTWXNWXNUYBXVSVAXVRUYCUXSYLAXVRAIIXWQXWQYNUYDXRYFYOAWY
      PIWVTWYMWVTUNULZUMULZUNULXVQIXXOUNULZUMULXWAAWYOXXPIUNAWYOVAWVTUNULZXXOUM
      ULXXPAVAWYMWVTXWPAILXWQXXMXXNUYIZXWRUYEAXXRWVTXXOUMAWVTXWRUYFWKXGYPAIWVTX
      XOXWQXWRAWYMWVTXXSXWRYNUXMAXXQXVTXVQUMAXXQIIXVSUNULZUNULXVTAXXOXXTIUNAILW
      VTXWQXXMXWRXXNUYJYPAIIXVSXWQXWQAWVTLXWRXXMXXNUYIUYGUYKYPYQYGVNWYFWYOWYIUT
      VCZWYPWYJUTVCZWYFWYHWYNGUSZWYOWYIUTWYFXYCWYHUVKURZWYNUNULZWVTWYNUNULZWYOA
      XYCXYEVBZWYEAWYHUVLVGWYNXFVGXYGXUJAVAWYMXWPXXSYHZWYHWYNGUVMWOVNWYFXYDWVTW
      YNUNWYFXYDWYGUOUMULZVAWDULZWVTWYFWYGUOXMURVGZXYDXYJVBWYFWWHXUOUOWYGVRVCZX
      NXYKWYFWWHXUOXYLWWHWYFWGVJWYFKXKWYFWYRWYSAWYRWYEUAVNWYTWIXUTWYFUWNVJXOWYF
      XYLXKKVRVCZWYFKXKLUPULZVGXYMWYFKVAVAWDULZLUPULZXYNAWUJKXYPVGZAWYRWUJXYQYR
      ZUAALVAXMURVGZWYRXYRXDALUYLVGXYSSLUYMVTKVALUYNWIYLUYOWYFXYOXKLUPXYOXKVBZW
      YFUYPVJWKUUOKXKLUYQWIWYFKXKAWUMWYEXUAVNXVDWYFXPVJUYSUYRZYIUOWYGUXAYBZUOWY
      GUYTWIAXYJWVTVBWYEAXYJWYGVAWDULZKVAXKUMULZWDULZWVTAXYIWYGVAWDAWYGAKXKXVGX
      KXFVGAYSVJZYHZXCWKAKXKVAXVGYUFXWPVUAZAYUEKVAVUBZWDULZWVTAYUDYUIKWDYUDYUIV
      BAXKVAUMULZVUBYUDYUIXKVAYSYEVUCYUKVAVUDVUEVUFVJYPZAKVAXVGXWPVUGZXGYQVNXGW
      KAXYFWYOVBWYEAWVTWYNXWRXYHUXLVNYQWYFWYHWYNWUAGWYFUOWYGVQZWYFXYKWYHVUIUUDY
      UBUOWYGVUHYBAWYNVEVGWYEXUKXUFVUJWYFXUKVDZAWVFXULAWYEXUKVUKAXUKWVFWYEXVMYT
      WXDWOAXUKWYNWUAUTVCZWYEAXUKEVYSCURZVGZYUPAXUKVDZEVYSWVKWDULZIUNULZWVOVRVC
      ZBFWAZYUQYUSWVIYVAWVJVRVCZEYVCVGAWVIXUKWXBVNYUSYVAWYGWVKWDULZIUNULZWVJYUS
      YUTIYUSVYSWVKXUKVYSVEVGZAXUKVYSVYSUOWYGXLXSVFZXWKYUSXWLVJZYDZAWUSXUKWUTVN
      ZVOYUSYVEIYUSWYGWVKYUSKXKAWUMXUKXUAVNXVDYUSXPVJVMZYVIYDZYVKVOYUSFVEJVULZW
      VIVDZWVJVEVGAYVOXUKAYVNWVIUCWXBVUMVNFVEEJVUNWIYUSYUTYVEVRVCZYVAYVFVRVCZYU
      SVYSWYGWVKYVHYVLYVIXUKVYSWYGVRVCAVYSUOWYGXTVFVUOYUSYUTVEVGYVEVEVGWUSWXGVD
      ZYVPYVQXDYVJYVMAYVRXUKAWUSWXGWUTWXNVUMZVNYUTYVEIVUPYKYLAYVFWVJVRVCXUKAYVF
      WVJAYVEIAWYGWVKAKXKXUAXVEVMZXWMYDZWUTVOZAFVEEJUCWXBUUQZAYVFWVTWVKUMULZIUN
      ULZWVJYWBAYWDIAWVTWVKXUGXWMVMZWUTVOZYWCAYVEYWDIYWAYWFUDAWVTXKUJUKULZUMULZ
      YVEYWDUTAYWIYUCYWHUMULWYGVAYWHUMULZWDULYVEAWVTYUCYWHUMAWVTKXYOVAUMULZUMUL
      KYUKUMULYUCAVAYWKKUMAVAVAUOWDULZVAVAVAUMULZWDULZYWKXWOVAYWLVBAYEXWOYWLVAV
      AVUQVURVUTAUOYWMVAWDAYWMUOAVAXWPVVAVURYPAXWOXWOXWOYWNYWKVBXWPXWPXWPXWOXWO
      XWOXNYWKYWNVAVAVAVUSVURYKYQYPAYWKYUKKUMAXYOXKVAUMXYTAUYPVJWKYPAKXKVAXVGYU
      FXWPVVBYQWKAWYGVAYWHYUGXWPYWHXFVGAXKUJYSXEVLVVCZVJVVDAYWJWVKWYGWDYWJWVKVB
      AVAYWHWVKYEYWOVAUJYEXEVLVVCWXLXKVAWDULZUJUKULVAYWHWVKWDULUJYWPUJUKVVEWEWX
      MXKVAUJYSYEXEVLUXEUXFVVFVJYPYQAWVKYWHWVTXWMYWHVEVGAXKUJXPVKVLXAVJXUGAVAXK
      UTVCZWVKYWHUTVCZVVJWUNXVDWUQUOUJUTVCZVDZXNYWQYWRXDAWUNXVDYWTVHXPWUQYWSVKU
      UTVVGVVHVAXKUJUXQVUTXQYFXJUXKAYWEWVJUTVCWVJYWEVRVCZVSZAYXBWVIYRZYXBWVIVSZ
      YRZVDZYXBAYXCYXDYXBYRZVDZYXFAWVIYXGYXHWXBAWVIYXAVDZVSYXGAEWVOYWEVRVCZBFWA
      ZVGYXIAWWAYXKEAWVSWWBWWCYMAWVTVYRVGZYXKWCVGZWWAYXKVBAYXLWVTVAWDULZWWFLVAW
      DULZUPULZVGZAKVAYXOUPULZYXNYXPAKYXRVGZXXEKYXOVRVCZAXXEXVHXXIWBZAKLYXOXUAX
      VFALVAXVFXUEYDXXJALXVFVVIYAAWYSXXGYXOWFVGYXSXXEYXTVDXDXUSXXHALXVBVVKKVAYX
      OYJYKVVLAKVAXVGXWPVVMAWWFVAYXOUPWWFVAVBAVAWWFUUHVVNVJWKVVOAWWHXUPWVTWFVGZ
      XXGYXLYXQXDWWHAWGVJZXVBAKVAXUSXXHXOZXXHWVTVAUOLVVPUVJUYRAWWIYXMTYXJBFWCWH
      WIHWVTWWNYXKVYRWCDWWJWVTVBZWWMYXJBFYYEWWLYWEWVOVRYYEWWKYWDIUNWWJWVTWVKUMW
      JWKWLWMQWNWOVVQYXJYXABEFWWPWWQBWVJYWEVRWWRWWSBYWEWPWQWWTWVOWVJYWEVRWXAWRW
      SVVRWVIYXAVVTVTWVIYXCYXGWVIYXBVVSVWAWOYXGYXEYXCYXDYXBVWBVWCVTYXBWVIVWDYBA
      YWEWVJYWGYWCVWEUYRYOVWJVNYAYVBYVDBEFWWPWWQBYVAWVJVRBYVAWPWWSWWRWQWWTWVOWV
      JYVAVRWXAWLWSVWFYUSWVFYVCWCVGZYUQYVCVBXVMAYYFXUKAWWIYYFTYVBBFWCWHWIVNHVYS
      WWJWVKWDULZIUNULZWVOVRVCZBFWAZYVCVYRWCCWWJVYSVBZYYIYVBBFYYKYYHYVAWVOVRYYK
      YYGYUTIUNWWJVYSWVKWDWJWKWRWMRWNWOVWGAWVFXUKYURYUPAXUKYURXNZWYHVYRVYSYYLXU
      MXUNYYLXURXUMAXUKXURYURXVJVWHXVKYBXVLWIAXUKYURVWKVWIEWCVGZAWVFYURXNZYUPYU
      RAYYMWVFEYUQVWLVWMAWVFWUDYUQVGZXNZWYNWUEUTVCZXHYYNYUPXHBEWCWWPYYNYUPBAWVF
      YURBPWYABEYUQBVYSCBCHVYRYYJUUARBHVYRYYJBVYRWPYYIBFVWNVWOVWPBVYSWPUUPVWQVW
      RYUPBXIUWBWWTYYPYYNYYQYUPWWTYYOYURAWVFWUDEYUQUUBVWSWWTWUEWUAWYNUTWYBWLVWT
      UHVXAUWHVXBVXCYTVXDXJWYFWYOVEVGZWYIVEVGZYVRXYAXYBXDAYYRWYEXUHVNAYYSWYEXVO
      VNAYVRWYEYVSVNWYOWYIIUYCYKYLYOWYFWYHWUBGUSZYYTWVTLUPULZWUBGUSZWDULZWYJWUC
      VRWYFYYTUOWDULYYTUUUCVRWYFYYTWYFWYHWUBGYUNYUOWUBAXUKWUBVEVGZWYEAXUKWVFUUU
      DXVMWXEYCYTZXBVXEVXFWYFUOUUUBYYTWVBWYFVPVJWYFUUUAWUBGWYFWVTLVQAVYSUUUAVGZ
      UUUDWYEAUUUFVDZIWUAAWUSUUUFWUTVNAUUUFWVFXULUUUGWVFUOVYSVRVCZVYSLVRVCZUUUG
      UOWVTVYSWVBUUUGVPVJZAXXKUUUFXUGVNUUUFYVGAUUUFVYSVYSWVTLXLZXSVFAUOWVTVRVCU
      UUFAUOYWMWVTVRVXJAVAKVAXUEXUAXUEYYAVXGVXHVNUUUGWVTVYSVRVCZUUUIUUUGUUUFUUU
      LUUUIVDZAUUUFVXKUUUGVYSWFVGZYYBXUPUUUFUUUMXDUUUFUUUNAUUUKVFZAYYBUUUFYYDVN
      AXUPUUUFXVBVNZVYSWVTLYJYKYLWBYAUUUFUUUIAVYSWVTLXTVFUUUGUUUNWWHXUPWVFUUUHU
      UUIVDXDUUUOWWHUUUGWGVJUUUPVYSUOLYJYKVVLZWXDYCZVOZYTWTWYFWYHWUBGYUNUUUEWTA
      UOUUUBVRVCWYEAUUUAWUBGAWVTLVQUUUSUUUGIUOUNULZUOWUBVRUUUGIAIXFVGZUUUFXWQVN
      UVSUUUGWXSUUUTWUBVRVCZAUUUFWVFWXSUUUQWYDYCUUUGWVBXULYVRWXSUUVBXDUUUJUUURA
      YVRUUUFYVSVNUOWUAIVXLYKYLXJVXIVNVXMXJAWYJYYTVBWYEAWYHWUAIGXUJXWQYUSWUAXVN
      XBVXNVNWYFWYHUUUAWUBVYRGAWYHUUUAVXOVUIVBZWYEAWWJUUUAVGZVSZHWYHVXTUUVCAUUV
      EHWYHOAWWJWYHVGZUUVEAUUVFVDZUUVDWVTWWJVRVCZWWJLVRVCZVDZUUVGUUVHUUVIUUVGWW
      JWVTUTVCUUVHVSUUVGWWJWYGWVTUUVGWWJUUVFWWJWFVGZAWWJUOWYGXLVFZXSZAWYGVEVGUU
      VFYVTVNAXXKUUVFXUGVNZUUVGUOWWJVRVCZWWJWYGVRVCZUUVGUUVFUUVOUUVPVDZAUUVFVXK
      UUVGUUVKWWHXUOUUVFUUVQXDUUVLWWHUUVGWGVJAXUOUUVFXVAVNWWJUOWYGYJYKYLYMAWYGW
      VTUTVCZUUVFAYWQUUVRVVJAVAXKKXUEXVEXUAVXPXQVNVXQUUVGWWJWVTUUVMUUVNVWEYLVXR
      UUVGUUVKYYBXUPUUVDUUVJXDUUVLAYYBUUVFYYDVNAXUPUUVFXVBVNWWJWVTLYJYKVXSVYAVY
      BHWYHUUUAVYCYBVNWYFVYRWYHYUCLUPULZVYDZWYHUUUAVYDZWYFWYGVYRVGZVYRUUVTVBWYF
      UUWBXYLXUQYUAAXUQWYEXVIVNWYFXUOWWHXUPXNZUUWBXYLXUQVDXDAUUWCWYEAXUOWWHXUPX
      VAYYCXVBYIVNWYGUOLYJWIVVLWYGUOLVYEWIAUUVTUUWAVBWYEAUUVSUUUAWYHAYUCWVTLUPA
      YUCYUEYUJWVTYUHYULYUMYQWKVYFVNXGWYFUOLVQAWVFWUBXFVGWYEWVGIWUAAUUVAWVFXWQV
      NWVGWUAWXDXBYNYTVYGVYKWYFWYQXUIWVDXNZWYKWYLVDWUKXHAUUWDWYEAWYQXUIWVDXUDXV
      PWXFYIVNVYQWYJWUCVYHWIVYIVYJAWVIWUCWCVGWUIWUCVBWXBVYRWUBGVYLBEWUGWUCFWCWU
      HWWTVYRWUFWUBGWWTWUEWUAIUNWYBYPVYMWUHVYNWNUVOYG $.
  $}

  ${
    $d h i t w F $.  $d h l t w Y $.  $d h i z F $.  $d h w T $.  $d i q t F $.
    $d i G $.  $d i q M $.  $d i w X $.  $d i q t Y $.  $d i ph $.  $d k l Q $.
    $d k l Y $.  $d k l ph $.  $d l z Q $.  $d l G $.  $d q Q $.  $d q T $.
    $d q U $.  $d w M $.  $d w Q $.  $d w U $.  $d z Y $.
    stoweidlem27.1 $e |- G = ( w e. X |->
         { h e. Q | w = { t e. T | 0 < ( h ` t ) } } ) $.
    stoweidlem27.2 $e |- ( ph -> Q e. _V ) $.
    stoweidlem27.3 $e |- ( ph -> M e. NN ) $.
    stoweidlem27.4 $e |- ( ph -> Y Fn ran G ) $.
    stoweidlem27.5 $e |- ( ph -> ran G e. _V ) $.
    stoweidlem27.6 $e |- ( ( ph /\ l e. ran G ) -> ( Y ` l ) e. l ) $.
    stoweidlem27.7 $e |- ( ph -> F : ( 1 ... M ) -1-1-onto-> ran G ) $.
    stoweidlem27.8 $e |- ( ph -> ( T \ U ) C_ U. X ) $.
    stoweidlem27.9 $e |- F/ t ph $.
    stoweidlem27.10 $e |- F/ w ph $.
    stoweidlem27.11 $e |- F/_ h Q $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <= 1,
       p_(t_0) = 0, and p > 0 on T - U. Here ` ( q `` i ) ` is used to
       represent p_(t_i) in the paper.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem27 $p |- ( ph -> E. q ( M e. NN /\ ( q : ( 1 ... M ) --> Q /\
          A. t e. ( T \ U ) E. i e. ( 1 ... M ) 0 < ( ( q ` i ) ` t ) ) ) ) $=
      ( vk ccom cvv wcel cn c1 cfz co wf cc0 cfv clt wbr wrex cdif wral wex crn
      cv wa wfn fnex syl2anc wf1o f1ofn syl ovex sylancl coexg wss fnfco rncoss
      f1of wceq fvelrnb biimpa crab simpr elrnmpt mpbid cmpt nfmpt1 nfcxfr nfrn
      wb nfcri nfan nfv ad2antrr eleqtrd nfcv fveq1 breq2d rabbidv eqeq2d sylib
      elrabf simpld exp31 rexlimd mpd adantlr eleq1 syl5ibcom reximdva rexlimdv
      wi idd a1i ex ssrdv syl5ss df-f sylanbrc cuni sselda eluni wfun cdm dmeqi
      funmpt2 rabexgf adantr ralrimi dmmptg syl5eq eleq2d biimpar fvelrn df-rex
      fveq2 anbi2d jca simprd sylancr wfo f1ofo forn 3syl simprl fvco3 ad2antll
      adantrl eqtrd eleq1d imbi12d vtoclg anabsi7 eqeltrd eximdv sylibr simplrl
      eleq2 bitrd syldan fvmpt2 adantlrl rabid reximdv eximd exlimd feq1 fveq1d
      rexbidv ralbidv anbi12d spcegv sylc ) AMIUHZUIUJZKUKUJZULKUMUNZDUVOUOZUPC
      VEZHVEZUVOUQZUQZURUSZHUVRUTZCEFVAZVBZVFZVFZUVQUVRDNVEZUOZUPUVTUWAUWJUQZUQ
      ZURUSZHUVRUTZCUWFVBZVFZVFZNVCAMUIUJZIUIUJZUVPAMJVDZVGZUXAUIUJUWSSTUXAUIMV
      HVIAIUVRVGZUVRUIUJUWTAUVRUXAIVJZUXCUBUVRUXAIVKVLZULKUMVMUVRUIIVHVNMIUIUIV
      OVIAUVQUWHRAUVSUWGAUVOUVRVGZUVOVDZDVPUVSAUXBUVRUXAIUOZUXFSAUXDUXHUBUVRUXA
      IVSVLZUXAUVRMIVQVIAUXGMVDZDMIVRAUGUXJDAUGVEZUXJUJZUXKDUJZAUXLVFZUXMOUXAUT
      ZUXMUXNOVEZMUQZUXKVTZOUXAUTZUXOAUXLUXSAUXBUXLUXSWKSOUXAUXKMWAVLWBUXNUXRUX
      MOUXAUXNUXPUXAUJZVFUXQDUJZUXRUXMAUXTUYAUXLAUXTVFZUXPBVEZUPUVTGVEZUQZURUSZ
      CEWCZVTZGDWCZVTZBLUTZUYAUYBUXTUYKAUXTWDZUYBUXTUXTUYKWKUYLBLUYIUXPJUXAPWEV
      LWFUYBUYJUYABLAUXTBUEBOUXABJBJBLUYIWGZPBLUYIWHWIWJWLWMUYABWNUYBUYCLUJZUYJ
      UYAUYBUYNVFZUYJVFZUYAUYCUPUVTUXQUQZURUSZCEWCZVTZUYPUXQUYIUJUYAUYTVFUYPUXQ
      UXPUYIUYBUXQUXPUJZUYNUYJUAWOUYOUYJWDWPUYHUYTGUXQDGUXQWQUFUYTGWNUYDUXQVTZU
      YGUYSUYCVUBUYFUYRCEVUBUYEUYQUPURUVTUYDUXQWRWSWTXAXCXBXDXEXFXGXHUXQUXKDXIX
      JXKXGUXNUXMUXMOUXAUXTUXMUXMXMXMUXNUXTUXMXNXOXLXGXPXQXRUVRDUVOXSXTAUWECUWF
      UDAUVTUWFUJZUWEAVUCVFZUWEBVCZUWEVUDUVTUYCUJZUYNVFZBVCZVUEVUDUVTLYAZUJVUHA
      UWFVUIUVTUCYBBUVTLYCXBVUDVUGUWEBAVUCBUEVUCBWNWMZAVUGUWEXMVUCAVUGUWEAVUGVF
      ZUWBUYCJUQZUJZHUVRUTZUWEAVUGVULUXAUJZVUNAUYNVUOVUFAUYNVFZJYDUYCJYEZUJZVUO
      BLUYIJPYGAVURUYNAVUQLUYCAVUQUYMYEZLJUYMPYFAUYIUIUJZBLVBVUSLVTAVUTBLUEAUYN
      VUTAVUTUYNADUIUJVUTQUYHGDUIUFYHVLYIZXPYJBLUYIUIYKVLYLYMYNUYCJYOUUAUUIAVUO
      VFZUWAUVRUJZVUMVFZHVCZVUNVVBVVCUWAIUQZVULVTZVFZHVCZVVEVVBVVGHUVRUTZVVIVVB
      VULIVDZUJZVVJAVVLVUOAVVKUXAVULAUXDUVRUXAIUUBVVKUXAVTUBUVRUXAIUUCUVRUXAIUU
      DUUEYMYNVVBUXCVVLVVJWKAUXCVUOUXEYIHUVRVULIWAVLWFVVGHUVRYPXBVVBVVHVVDHVVBV
      VHVVDVVBVVHVFZVVCVUMVVBVVCVVGUUFZVVMUWBVULMUQZVULVVMUWBVVFMUQZVVOVVMUXHVV
      CUWBVVPVTAUXHVUOVVHUXIWOVVNUVRUXAUWAMIUUGVIVVGVVPVVOVTVVBVVCVVFVULMYQUUHU
      UJVVBVVOVULUJZVVHAVUOVVQUYBVUAXMVVBVVQXMOVULUXAUXPVULVTZUYBVVBVUAVVQVVRUX
      TVUOAUXPVULUXAXIYRVVRVUAUXQVULUJVVQUXPVULUXQUUSVVRUXQVVOVULUXPVULMYQUUKUU
      TUULUAUUMUUNYIUUOYSXPUUPXGVUMHUVRYPUUQUVAVUKVUMUWDHUVRVUKVUMUWDVUKVUMVFZU
      VTEUJZUWDVVSUVTUWDCEWCZUJVVTUWDVFVVSUVTUYCVWAAVUFUYNVUMUURVVSUWBDUJZUYCVW
      AVTZVVSUWBUYIUJZVWBVWCVFAUYNVUMVWDVUFVUPVUMVWDVUPVULUYIUWBVUPUYNVUTVULUYI
      VTAUYNWDVVABLUYIUIJPUVBVIYMWBUVCUYHVWCGUWBDGUWBWQUFVWCGWNUYDUWBVTZUYGVWAU
      YCVWEUYFUWDCEVWEUYEUWCUPURUVTUYDUWBWRWSWTXAXCXBYTWPUWDCEUVDXBYTXPUVEXGXPY
      IUVFXGVUDUWEUWEBVUJUWEBWNVUDUWEXNUVGXGXPYJYSYSUWRUWINUVOUIUWJUVOVTZUWQUWH
      UVQVWFUWKUVSUWPUWGUVRDUWJUVOUVHVWFUWOUWECUWFVWFUWNUWDHUVRVWFUWMUWCUPURVWF
      UVTUWLUWBUWAUWJUVOWRUVIWSUVJUVKUVLYRUVMUVN $.
  $}

  ${
    $d c d t x P $.  $d c d t x T $.  $d c d x U $.  $d c x ph $.
    $d s t x J $.  $d s K $.  $d s t x P $.  $d s t x T $.  $d s x U $.
    $d s x ph $.
    stoweidlem28.1 $e |- F/_ t U $.
    stoweidlem28.2 $e |- F/ t ph $.
    stoweidlem28.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem28.4 $e |- T = U. J $.
    stoweidlem28.5 $e |- ( ph -> J e. Comp ) $.
    stoweidlem28.6 $e |- ( ph -> P e. ( J Cn K ) ) $.
    stoweidlem28.7 $e |- ( ph -> A. t e. ( T \ U ) 0 < ( P ` t ) ) $.
    stoweidlem28.8 $e |- ( ph -> U e. J ) $.
    $( There exists a &delta; as in Lemma 1 [BrosowskiDeutsh] p. 90: 0 < delta
       < 1 and p >= delta on ` T \ U ` .  Here ` d ` is used to represent
       &delta; in the paper.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem28 $p |- ( ph -> E. d ( d e. RR+ /\ d < 1 /\
          A. t e. ( T \ U ) d <_ ( P ` t ) ) ) $=
      ( vx wcel wbr cle vs vc cdif c0 wceq cv crp c1 clt cfv wral w3a wex wa c2
      cdiv co 1re rehalfcli halfgt0 elrpii a1i halflt1 nfdif nfeq1 rzalf adantl
      nfcv ovex eleq1 breq1 ralbidv 3anbi123d spcev syl3anc cres wrex cuni eqid
      wn crest ccmp ccld ctop wss wb cmptop syl elssuni syl6sseqr syl2anc mpbid
      isopn2 cmpcld adantr ccn difssd cnrest wne df-ne restuni syl5rbbr biimpar
      neeq1d evth2 nfov nfuni nfres nffv nfbr nfv weq fveq2 breq2d rexbii sylib
      cbvralf raleqf rexeqbi1dv mpbird simplr simpr cr wf fcnre eldifi ffvelrnd
      simplll cc0 biimpi r19.21bi sylan elrpd 3adant3 nfcri nfra1 nf3an rsp ex
      fvres imp 3ad2antl3 simpl2 3brtr3d ralrimi wi spcegv mp2and simpl1 simprl
      anbi12d cif 3ad2ant1 simp2 simp3 stoweidlem5 exlimddv rexlimdva pm2.61dan
      simprr mpd ) ADEUCZUDUEZHUFZUGRZUVDUHUISZUVDBUFZCUJZTSZBUVBUKZULZHUMZAUVC
      UNZUHUOUPUQZUGRZUVNUHUISZUVNUVHTSZBUVBUKZUVLUVOUVMUVNUHURUSUTVAVBUVPUVMVC
      VBUVCUVRAUVQBUVBBUVBUDBDEBDVHIVDZVEVFVGUVKUVOUVPUVRULHUVNUHUOUPVIUVDUVNUE
      ZUVEUVOUVFUVPUVJUVRUVDUVNUGVJUVDUVNUHUIVKUVTUVIUVQBUVBUVDUVNUVHTVKVLVMVNV
      OAUVCVTZUNZQUFZCUVBVPZUJZUVGUWDUJZTSZBUVBUKZQUVBVQZUVLUWBUWIUWGBFUVBWAUQZ
      VRZUKZQUWKVQZUWBUWEUAUFZUWDUJZTSZUAUWKUKZQUWKVQUWMUWBQUAUWDUWJGUWKUWKVSKA
      UWJWBRZUWAAFWBRZUVBFWCUJRZUWRMAEFRZUWTPAFWDRZEDWEUXAUWTWFAUWSUXBMFWGWHZAE
      FVRZDAUXAEUXDWEPEFWIWHLWJEFDLWMWKWLUVBFWNWKWOUWBCFGWPUQZRZUVBDWEZUWDUWJGW
      PUQRAUXFUWANWOUWBDEWQUVBCFGDLWRWKAUWKUDWSZUWAUWAUVBUDWSAUXHUVBUDWTAUVBUWK
      UDAUXBUXGUVBUWKUEZUXCADEWQUVBFDLXAWKZXDXBXCXEUWQUWLQUWKUWPUWGUABUWKUAUWKV
      HBUWJBFUVBWABFVHBWAVHUVSXFXGZBUWEUWOTBUWCUWDBCUVBBCVHUVSXHZBUWCVHXIBTVHBU
      WNUWDUXLBUWNVHXIXJUWGUAXKUABXLUWOUWFUWETUWNUVGUWDXMXNXQXOXPAUWIUWMWFZUWAA
      UXIUXMUXJUWHUWLQUVBUWKUWGBUVBUWKUVSUXKXRXSWHWOXTUWBUWHUVLQUVBUWBUWCUVBRZU
      NZUWHUVLUXOUWHUNAUXNUWHUVLAUWAUXNUWHYHUWBUXNUWHYAUXOUWHYBAUXNUWHULZUBUFZU
      GRZUXQUVHTSZBUVBUKZUNZUVLUBUXPUWCCUJZUGRZUYBUVHTSZBUVBUKZUYAUBUMZAUXNUYCU
      WHAUXNUNZUYBUYGDYCUWCCADYCCYDZUXNAUXEDCFGKLUXEVSNYEZWOUXNUWCDRAUWCDEYFVGY
      GAYIUVHUISZBUVBUKZUXNYIUYBUISZOUYKUYLQUVBUYKUYLQUVBUKUYJUYLBQUVBUVSQUVBVH
      UYJQXKUYLBXKBQXLUVHUYBYIUIUVGUWCCXMXNXQYJYKYLYMYNZUXPUYDBUVBAUXNUWHBJBQUV
      BUVSYOUWGBUVBYPYQUXPUVGUVBRZUYDUXPUYNUNZUWEUWFUYBUVHTUWHAUYNUWGUXNUWHUYNU
      WGUWGBUVBYRUUAUUBUYOUXNUWEUYBUEAUXNUWHUYNUUCUWCUVBCYTWHUYNUWFUVHUEUXPUVGU
      VBCYTVGUUDYSUUEUXPUYCUYCUYEUNZUYFUUFUYMUYAUYPUBUYBUGUXQUYBUEZUXRUYCUXTUYE
      UXQUYBUGVJUYQUXSUYDBUVBUXQUYBUVHTVKVLUUKUUGWHUUHUXPUYAUNAUXRUXTUVLAUXNUWH
      UYAUUIUXPUXRUXTUUJUXPUXRUXTUUTAUXRUXTULZBUXQUXQUVNTSUXQUVNUULZCUVBDHAUXRU
      XTBJUXRBXKUXSBUVBYPYQUYSVSAUXRUYHUXTUYIUUMUYRDEWQAUXRUXTUUNAUXRUXTUUOUUPV
      OUUQVOYSUURUVAUUS $.
  $}

  ${
    $d s t x T $.  $d s x F $.  $d s t J $.  $d s x ph $.  $d t x y T $.
    $d t K $.  $d y F $.  $d y ph $.
    stoweidlem29.1 $e |- F/_ t F $.
    stoweidlem29.2 $e |- F/ t ph $.
    stoweidlem29.3 $e |- T = U. J $.
    stoweidlem29.4 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem29.5 $e |- ( ph -> J e. Comp ) $.
    stoweidlem29.6 $e |- ( ph -> F e. ( J Cn K ) ) $.
    stoweidlem29.7 $e |- ( ph -> T =/= (/) ) $.
    $( When the hypothesis for the extreme value theorem hold, then the inf of
       the range of the function belongs to the range, it is real and it a
       lower bound of the range.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem29 $p |- ( ph -> ( sup ( ran F , RR , `' < ) e. ran F /\
          sup ( ran F , RR , `' < ) e. RR /\
          A. t e. T sup ( ran F , RR , `' < ) <_ ( F ` t ) ) ) $=
      ( vx vy vs cr wcel cle wa crn clt ccnv csup cfv wbr wral wss wrex wfn ccn
      cv wf co eqid fcnre df-f sylib simprd nfcv evth2f nfv wfun cdm simpld syl
      fnfun adantr wceq fdm eqcomd eleq2d biimpa fvelrn nffv nfeq2 breq1 ralbid
      syl2anc rspcev sylan exp31 rexlimd simpr wb ad2antrr fvelrnbf mpbid nfra1
      mpd nfan nfrn nfcri rsp breq2 syl5ibcom ad2antlr ralrimi reximdv lbinfmcl
      wi imp ex sseldd dffn3 fnvinran lbinfmle syl3anc 3jca ) ADUAZQUBUCUDZXJRZ
      XKQRXKBULZDUEZSUFZBCUGAXJQUHZNULZOULZSUFZOXJUGZNXJUIZXLADCUJZXPACQDUMZYBX
      PTAEFUKUNZCDEFJIYDUOLUPZCQDUQURZUSZAXQXNSUFZBCUGZNXJUIZYAAPULZDUEZXNSUFZB
      CUGZPCUIYJAPBDEFCPDUTGPCUTBCUTZIJKLMVAAYNYJPCAPVBYJPVBAYKCRZYNYJAYPTZYLXJ
      RZYNYJYQDVCZYKDVDZRZYRAYSYPAYBYSAYBXPYFVEZCDVGVFVHAYPUUAACYTYKAYTCAYCYTCV
      IYECQDVJVFVKVLVMYKDVNVSYIYNNYLXJXQYLVIYHYMBCBXQYLBYKDGBYKUTVOVPXQYLXNSVQV
      RVTWAWBWCWJAYIXTNXJAYIXTAYITZXSOXJUUCOVBUUCXRXJRZXSUUCUUDTZXNXRVIZBCUIZXS
      UUEUUDUUGUUCUUDWDUUEYBUUDUUGWEAYBYIUUDUUBWFBCXRDYOBXRUTGWGVFWHUUEUUFXSBCU
      UCUUDBAYIBHYHBCWIWKBOXJBDGWLWMWKXSBVBYIXMCRZUUFXSXAZXAAUUDYIUUHUUIYIUUHTY
      HUUFXSYIUUHYHYHBCWNXBXNXRXQSWOWPXCWQWCWJXCWRXCWSWJZNOXJWTVSZAXJQXKYGUUKXD
      AXOBCHAUUHXOAUUHTXPYAXNXJRXOAXPUUHYGVHAYAUUHUUJVHACXJXMDAYBCXJDUMUUBCDXEU
      RXFNOXNXJXGXHXCWRXI $.
  $}

  ${
    $d f i T $.  $d f A $.  $d f G $.  $d f i ph $.  $d h i t T $.  $d h A $.
    $d h t G $.  $d h Z $.  $d i s t M $.  $d i s S $.  $d s t G $.  $d s P $.
    $d s t T $.  $d s ph $.
    stoweidlem30.1 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem30.2 $e |- P = ( t e. T |->
         ( ( 1 / M ) x. sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) ) $.
    stoweidlem30.3 $e |- ( ph -> M e. NN ) $.
    stoweidlem30.4 $e |- ( ph -> G : ( 1 ... M ) --> Q ) $.
    stoweidlem30.5 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <= 1,
       p_(t_0) = 0, and p > 0 on T - U. Z is used for t_0, P is used for p,
       ` ( G `` i ) ` is used for p_(t_i).  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem30 $p |- ( ( ph /\ S e. T ) -> ( P ` S ) = ( ( 1 / M ) x.
          sum_ i e. ( 1 ... M ) ( ( G ` i ) ` S ) ) ) $=
      ( wcel cfv vs c1 cdiv co cfz cv csu cmul wceq wa wi eleq1 fveq2 sumeq2sdv
      anbi2d oveq2d eqeq12d imbi12d cr simpr nnrecred adantr fzfid stoweidlem15
      cc0 cle wbr simp1d an32s fsumrecl remulcld fvmptg syl2anc vtoclg anabsi7
      ) AFGSZFDTZUBLUCUDZUBLUEUDZFJUFZKTZTZJUGZUHUDZUIZAUAUFZGSZUJZWFDTZVRVSWFW
      ATZJUGZUHUDZUIZUKAVPUJZWEUKUAFGWFFUIZWHWNWMWEWOWGVPAWFFGULUOWOWIVQWLWDWFF
      DUMWOWKWCVRUHWOVSWJWBJWFFWAUMUNUPUQURWHWGWLUSSWMAWGUTWHVRWKAVRUSSWGALPVAV
      BWHVSWJJWHUBLVCAVTVSSZWGWJUSSZAWPUJWGUJWQVEWJVFVGWJUBVFVGABCEWFGHIKVTLMNQ
      RVDVHVIVJVKBWFVRVSBUFZWATZJUGZUHUDWLGUSDWRWFUIZWTWKVRUHXAVSWSWJJWRWFWAUMU
      NUPOVLVMVNVO $.
  $}

  ${
    $d b h i l t v w $.  $d b u w $.  $d b h l t z $.  $d b i l G $.
    $d b l w Y $.  $d b i l ph $.  $d e h t w A $.  $d e h t w E $.
    $d e h t w M $.  $d e h w T $.  $d e h w U $.  $d h t w R $.
    $d i l t v x $.  $d i l t w M $.  $d l x B $.  $d l t w E $.  $d u G $.
    $d u w R $.  $d x E $.  $d x G $.  $d x M $.  $d x Y $.  $d z Y $.
    stoweidlem31.1 $e |- F/ h ph $.
    stoweidlem31.2 $e |- F/ t ph $.
    stoweidlem31.3 $e |- F/ w ph $.
    stoweidlem31.4 $e |- Y = { h e. A | A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t
                          ) <_ 1 ) } $.
    stoweidlem31.5 $e |- V = { w e. J | A. e e. RR+ E. h e. A ( A. t e. T ( 0
          <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) /\ A. t e. w ( h ` t )
          < e /\ A. t e. ( T \ U ) ( 1 - e ) < ( h ` t ) ) } $.
    stoweidlem31.6 $e |- G = ( w e. R |-> { h e. A | ( A. t e. T ( 0 <_ ( h `
          t ) /\ ( h ` t ) <_ 1 ) /\ A. t e. w ( h ` t ) < ( E /
      M ) /\ A. t e. ( T \ U ) ( 1 - ( E / M ) ) < ( h ` t )
      ) } ) $.
    stoweidlem31.7 $e |- ( ph -> R C_ V ) $.
    stoweidlem31.8 $e |- ( ph -> M e. NN ) $.
    stoweidlem31.9 $e |- ( ph -> v : ( 1 ... M ) -1-1-onto-> R ) $.
    stoweidlem31.10 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem31.11 $e |- ( ph -> B C_ ( T \ U ) ) $.
    stoweidlem31.12 $e |- ( ph -> V e. _V ) $.
    stoweidlem31.13 $e |- ( ph -> A e. _V ) $.
    stoweidlem31.14 $e |- ( ph -> ran G e. Fin ) $.
    $( This lemma is used to prove that there exists a function x as in the
       proof of Lemma 2 in [BrosowskiDeutsh] p. 91: assuming that ` R ` is a
       finite subset of ` V ` , ` x ` indexes a finite set of functions in the
       subalgebra (of the Stone Weierstrass theorem), such that for all ` i `
       ranging in the finite indexing set, 0 &le; x_i &le; 1, x_i < &epsilon; /
       m on V(t_i), and x_i > 1 - &epsilon; / m on ` B ` .  Here M is used to
       represent m in the paper, ` E ` is used to represent &epsilon; in the
       paper, v_i is used to represent V(t_i).  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem31 $p |- ( ph -> E. x ( x : ( 1 ... M ) --> Y /\ A. i e.
          ( 1 ... M ) ( A. t e. ( v ` i ) ( ( x ` i ) ` t ) < ( E / M ) /\
      A. t e. B ( 1 - ( E / M ) ) < ( ( x ` i ) ` t ) ) ) ) $=
      ( vl vb vu vz cv crn wfn c0 wne cfv wcel wi wral wa c1 cfz co wf clt cmin
      wbr wex syl ccom cvv vex cc0 cle w3a crab coexg adantr nfcv nfrab1 nfcxfr
      wss nfmpt nfrn nffn nfv nfral nfan wrex wceq fvelrnb nfra1 simplrr 3simpc
      wb simp3 simpr rabexg ralrimi nffv nfeq fveq2 nfcri syl2anc sylib ralbidv
      crp breq1d sylibr 3exp rexlimd mpd sylc jca fveq1 anbi12d 3anbi123d elrab
      breq2d simprbi sylanbrc syl3anc eleq1 fco fvco3 sylan fnvinran nf3an nfco
      ex nfbr ralbid syl6bi cdiv cfn fnchoice cdif cmpt mptexg syl5eqel sylancl
      ssexd sylancr simprl biimpa 3ad2ant1 simp2 a1d fnmpt nfmpt1 eqeq1d cbvrex
      simp1ll syl6bb mpbid fvmpt2 sselda rabeq2i simprd nnrpd rpdivcld 3anbi23d
      breq2 rexbidv rspccva nfne ne0i eqnetrd 3adant3 eqnetrrd 3adant1r 3adant2
      oveq2 rabid rsp elrnmpt ax-mp simp1r simpl eleqtrd elrabi simp1d eqeltrrd
      imp syl6eleqr reximdai idd dfss3 cbvral bitri df-f dffn3 wf1o f1of simpll
      a1i nfim 3anbi3d id eleq12d imbi12d vtoclgf mpcom eqeltrd 3anbi2d rabbidv
      raleq fvmptg eqtrd adantlr eleq2d elrabf simp2d ad3antrrr sseldd r19.21bi
      nfrab simp3d syldan ralrimiva feq1 fveq1d spcegv exlimddv ) AUNURZOUSZUTZ
      UOURZVAVBZUYOUYLVCZUYOVDZVEZUOUYMVFZVGZVHQVIVJZSBURZVKZEURZMURZVUCVCZVCZN
      QUUAVJZVLVNZEVUFDURZVCZVFZVHVUIVMVJZVUHVLVNZEGVFZVGZMVUBVFZVGZBVOZUNAUYMU
      UBVDVUAUNVOUMUOUYMUNUUCVPAVUAVGZUYLOVUKVQZVQZVRVDZVUBSVVCVKZVUEVUFVVCVCZV
      CZVUIVLVNZEVULVFZVUNVVGVLVNZEGVFZVGZMVUBVFZVGZVUTAVVDVUAAUYLVRVDVVBVRVDZV
      VDUNVSAOVRVDVUKVRVDVVOAOCHVTVUELURZVCZWAVNZVVQVHWAVNZVGZEIVFZVVQVUIVLVNZE
      CURZVFZVUNVVQVLVNZEIJUUDZVFZWBZLFWCZUUEZVRUEAHVRVDVWJVRVDAHRVRUKUFUUICHVW
      IVRUUFVPUUGDVSOVUKVRVRWDUUHUYLVVBVRVRWDUUJWEVVAVVEVVMVVAUYMSUYLVKZVUBUYMV
      VBVKZVVEVVAUYNUYLUSZSWIZVWKAUYNUYTUUKZVVAVVPSVDZLVWMVFZVWNVVAVWPLVWMAVUAL
      TUYNUYTLLUYMUYLLUYLWFZLOLOVWJUELCHVWILHWFVWHLFWGZWJWHZWKZWLUYSLUOUYMVXAUY
      SLWMWNWOWOVVAVVPVWMVDZVWPVVAVXBVGZVWPUOUYMWPZVWPVXCUYQVVPWQZUOUYMWPZVXDVV
      AVXBVXFVVAUYNVXBVXFXBVWOUOUYMVVPUYLWRVPUULVXCVXEVWPUOUYMVVAVXBUOAVUAUOAUO
      WMZUYNUYTUOUYNUOWMUYSUOUYMWSZWOWOVXBUOWMWOZVXCUYOUYMVDZVXEVWPVXCVXJVXEWBZ
      UYQVVPSVXCVXJVXEXCVXKAUYTVXJUYQSVDZAVUAVXBVXJVXEUUTVXCVXJUYTVXEAUYNUYTVXB
      WTUUMVXCVXJVXEUUNAUYTVXJWBZVXJUYRVGZUYOVWIWQZCHWPZVXLVXMVXJUYRAUYTVXJXCZV
      XMUYTVXJVGUYPUYRAUYTVXJXAAVXJUYPUYTAVXJVGZVWCOVCZUYOWQZCHWPZUYPVXRVXJVYAA
      VXJXDVXROHUTZVXJVYAXBAVYBVXJAVWIVRVDZCHVFVYBAVYCCHUBAVYCVWCHVDZAFVRVDZVYC
      ULVWHLFVRXEZVPUUOXFCHVWIOVRUEUUPVPZWEVYBVXJUPURZOVCZUYOWQZUPHWPVYAUPHUYOO
      WRVYJVXTUPCHCVYIUYOCVYHOCOVWJUECHVWIUUQWHZCVYHWFXGCUYOWFXHVXTUPWMVYHVWCWQ
      VYIVXSUYOVYHVWCOXIUURUUSUVAVPUVBVXRVXTUYPCHAVXJCUBCUOUYMCOVYKWKXJZWOUYPCW
      MVXRVYDVXTUYPAVYDVXTUYPVXJAVYDVXTWBVXSUYOVAAVYDVXTXCAVYDVXSVAVBVXTAVYDVGZ
      VXSVWIVAVYMVYDVYCVXSVWIWQAVYDXDVYMVYEVYCAVYEVYDULWEVYFVPCHVWIVROUEUVCXKVY
      MVWHLFWPZVWIVAVBZVYMVWAVVQKURZVLVNZEVWCVFZVHVYPVMVJZVVQVLVNZEVWFVFZWBZLFW
      PZKXNVFZVUIXNVDZVYNVYMVWCPVDZWUDVYMVWCRVDWUFWUDVGAHRVWCUFUVDWUDCRPUDUVEXL
      UVFAWUEVYDANQUIAQUGUVGUVHWEWUCVYNKVUIXNVYPVUIWQZWUBVWHLFWUGVYRVWDWUAVWGVW
      AWUGVYQVWBEVWCVYPVUIVVQVLUVJXMWUGVYTVWEEVWFWUGVYSVUNVVQVLVYPVUIVHVMUVTXOX
      MUVIUVKUVLXKVYMVWHVYOLFAVYDLTVYDLWMWOLVWIVAVWSLVAWFUVMVYMVVPFVDZVWHVYOVYM
      WUHVWHWBZVVPVWIVDZVYOWUIWUHVWHVGWUJVYMWUHVWHXAVWHLFUWAXPVWIVVPUVNVPXQXRXS
      UVOUVPUVQUVRXQXRXSUVSUYTVXJUYSUYSUOUYMUWBUWKXTZYAVXMVXJVXPVXQUYOVRVDVXJVX
      PXBUOVSCHVWIUYOOVRUEUWCUWDXLVXNVXOVXLCHVXJUYRCVYLUYRCWMWOVXLCWMVXNVYDVXOV
      XLVXNVYDVXOWBUYRVXOVXLVXJUYRVYDVXOUWEVXNVYDVXOXCUYRVXOVGZUYQVWALFWCZSWULU
      YQVWIVDZUYQWUMVDZWULUYQUYOVWIUYRVXOUWFUYRVXOXDUWGWUNUYQFVDZVTVUEUYQVCZWAV
      NZWUQVHWAVNZVGZEIVFZWUOVWHLUYQFUWHWUNWVAWUQVUIVLVNZEVWCVFZVUNWUQVLVNZEVWF
      VFZWUNWUPWVAWVCWVEWBZVWHWVFLUYQFVVPUYQWQZVWAWVAVWDWVCVWGWVEWVGVVTWUTEIWVG
      VVRWURVVSWUSWVGVVQWUQVTWAVUEVVPUYQYBZYFWVGVVQWUQVHWAWVHXOYCXMZWVGVWBWVBEV
      WCWVGVVQWUQVUIVLWVHXOXMWVGVWEWVDEVWFWVGVVQWUQVUNVLWVHYFXMYDYEYGUWIVWAWVAL
      UYQFWVIYEYHVPUCUWLXKXQXRXTYIUWJXQUWMXSVXCVWPVWPUOUYMVXIVWPUOWMVXJVWPVWPVE
      VEVXCVXJVWPUWNUXCXRXSYQXFVWNUQURZSVDZUQVWMVFVWQUQVWMSUWOWVKVWPUQLVWMLUQSL
      SWUMUCVWALFWGWHXJVWPUQWMWVJVVPSYJUWPUWQXPUYMSUYLUWRYHVVAHUYMOVKZVUBHVUKVK
      ZVWLAWVLVUAAVYBWVLVYGHOUWSXLWEAWVMVUAAVUBHVUKUWTWVMUHVUBHVUKUXAVPZWEVUBHU
      YMOVUKYKXKZVUBUYMSUYLVVBYKXKVVAVVLMVUBVVAVUFVUBVDZVGZVVIVVKWVQVVFVUFVVBVC
      ZVDZVVIWVQVVFWVRUYLVCZWVRVVAVWLWVPVVFWVTWQWVOVUBUYMVUFUYLVVBYLYMWVQAUYTWV
      RUYMVDZWVTWVRVDZAVUAWVPUXBAUYNUYTWVPWTVVAVUBUYMVUFVVBWVOYNWWAAUYTWWAWBZWW
      BAUYTWWAXCVXMUYRVEWWCWWBVEUOWVRUYMUOWVRWFWWCWWBUOAUYTWWAUOVXGVXHWWAUOWMYO
      WWBUOWMUXDUYOWVRWQZVXMWWCUYRWWBWWDVXJWWAAUYTUYOWVRUYMYJUXEWWDUYQWVTUYOWVR
      UYOWVRUYLXIWWDUXFUXGUXHWUKUXIUXJYIUXKZWVQWVSVVFVWAVWBEVULVFZVWGWBZLFWCZVD
      ZVVIWVQWVRWWHVVFAWVPWVRWWHWQVUAAWVPVGZWVRVULOVCZWWHAWVMWVPWVRWWKWQWVNVUBH
      VUFOVUKYLYMWWJVULHVDWWHVRVDZWWKWWHWQAVUBHVUFVUKWVNYNWWJVYEWWLAVYEWVPULWEW
      WGLFVRXEVPCVULVWIWWHHVROVWCVULWQZVWHWWGLFWWMVWDWWFVWAVWGVWBEVWCVULUXNUXLU
      XMUEUXOXKUXPUXQUXRZWWIVTVVGWAVNZVVGVHWAVNZVGZEIVFZVVIVVJEVWFVFZWWIVVFFVDW
      WRVVIWWSWBZWWGWWTLVVFFLVUFVVCLUYLVVBVWRLOVUKVWTLVUKWFYPYPLVUFWFXGZLFWFWWR
      VVIWWSLWWQLEILIWFWWOWWPLLVTVVGWALVTWFLWAWFZLVUEVVFWXALVUEWFXGZYRLVVGVHWAW
      XCWXBLVHWFYRWOWNVVHLEVULLVULWFLVVGVUIVLWXCLVLWFZLVUIWFYRWNVVJLEVWFLVWFWFL
      VUNVVGVLLVUNWFWXDWXCYRWNYOVVPVVFWQZVWAWWRWWFVVIVWGWWSWXEVVTWWQEIEVVPVVFEV
      VPWFEVUFVVCEUYLVVBEUYLWFZEOVUKEOVWJUEECHVWIEHWFVWHELFVWAVWDVWGEVVTEIWSVWB
      EVWCWSVWEEVWFWSYOEFWFUYDWJWHZEVUKWFYPYPZEVUFWFXGXHZWXEVVRWWOVVSWWPWXEVVQV
      VGVTWAVUEVVPVVFYBZYFWXEVVQVVGVHWAWXJXOYCYSWXEVWBVVHEVULWXIWXEVVQVVGVUIVLW
      XJXOYSWXEVWEVVJEVWFWXIWXEVVQVVGVUNVLWXJYFYSYDUXSYGZUXTYTXSWVQVVJEGVVAWVPE
      AVUAEUAUYNUYTEEUYMUYLWXFEOWXGWKZWLUYSEUOUYMWXLUYSEWMWNWOWOWVPEWMWOWVQVUEG
      VDZVVJWVQWXMVUEVWFVDVVJWVQWXMVGGVWFVUEAGVWFWIVUAWVPWXMUJUYAWVQWXMXDUYBWVQ
      VVJEVWFWVQWVSWWSWWEWVQWVSWWIWWSWWNWWIWWRVVIWWSWXKUYEYTXSUYCUYFYQXFYAUYGYA
      VUSVVNBVVCVRVUCVVCWQZVUDVVEVURVVMVUBSVUCVVCUYHWXNVUQVVLMVUBWXNVUMVVIVUPVV
      KWXNVUJVVHEVULEVUCVVCEVUCWFWXHXHZWXNVUHVVGVUIVLWXNVUEVUGVVFVUFVUCVVCYBUYI
      ZXOYSWXNVUOVVJEGWXOWXNVUHVVGVUNVLWXPYFYSYCXMYCUYJXTUYK $.
  $}

  ${
    $d f g i t G $.  $d f g t z $.  $d f g A $.  $d f g z F $.  $d f g i t T $.
    $d f g i ph $.  $d g z H $.  $d i s t G $.  $d i s t M $.  $d s t T $.
    $d s t Y $.  $d s ph $.  $d t x T $.  $d x A $.  $d x Y $.  $d x ph $.
    stoweidlem32.1 $e |- F/ t ph $.
    stoweidlem32.2 $e |- P = ( t e. T |->
          ( Y x. sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) ) $.
    stoweidlem32.3 $e |- F = ( t e. T |->
          sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) $.
    stoweidlem32.4 $e |- H = ( t e. T |-> Y ) $.
    stoweidlem32.5 $e |- ( ph -> M e. NN ) $.
    stoweidlem32.6 $e |- ( ph -> Y e. RR ) $.
    stoweidlem32.7 $e |- ( ph -> G : ( 1 ... M ) --> A ) $.
    stoweidlem32.8 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem32.9 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem32.10 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem32.11 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    $( If a set A of real functions from a common domain T is a subalgebra and
       it contains constants, then it is closed under the sum of a finite
       number of functions, indexed by G and finally scaled by a real Y.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem32 $p |- ( ph -> P e. A ) $=
      ( vs cv cfv cmul co cmpt c1 cfz csu wcel wa cr wceq fveq2 sumeq2sdv eqtri
      cbvmptv adantl simpr fzfid wf simpl fnvinran wi eleq1 anbi2d feq1 imbi12d
      a1i vtoclg syl mp2and adantlr simplr ffvelrnd fsumrecl fvmptd recnd eqidd
      eqeltrd eqtr4i adantr mulcomd oveq12d eqtr2d mpteq2da syl5eq stoweidlem20
      stoweidlem4 mpdan syl5eqel nfmpt1 nfcxfr nfeq2 stoweidlem6 mpd3an23 ) AEC
      FCUGZJUHZXBLUHZUIUJZUKZDAECFNULMUMUJZXBIUGZKUHZUHZIUNZUIUJZUKXFPACFXLXEOA
      XBFUOZUPZXEXDXCUIUJXLXNXCXDXNXCXNXCXKUQXNUFXBXGUFUGZXIUHZIUNZXKFJUQJUFFXQ
      UKZURXNJCFXKUKZXRQCUFFXKXQXBXOURXGXJXPIXBXOXIUSUTVBVAVNXOXBURZXQXKURXNXTX
      GXPXJIXOXBXIUSUTVCAXMVDZXNXGXJIXNULMVEXNXHXGUOZUPFUQXBXIAYBFUQXIVFZXMAYBU
      PZAXIDUOZYCAYBVGAXGDXHKUAVHZYDYEAYEUPZYCVIZYFAGUGZDUOZUPZFUQYIVFZVIYHGXID
      YIXIURZYKYGYLYCYMYJYEAYIXIDVJVKFUQYIXIVLVMUEVOVPVQVRAXMYBVSVTWAZWBZYNWEWC
      XNXDXNXDNUQXNUFXBNNFLUQLUFFNUKZURXNLCFNUKZYPRUFCFNNXTNWDVBWFVNXNXTUPNWDYA
      ANUQUOZXMTWGZWBZYSWEWCWHXNXDNXCXKUIYTYOWIWJWKWLAJDUOLDUOXFDUOACDFGHIJKMOQ
      SUAUBUEWMALYQDRAYRYQDUOTABCDNFUDWNWOWPACDFGHJLCYIJCJXSQCFXKWQWRWSCHUGLCLY
      QRCFNWQWRWSUCWTXAWE $.
  $}

  ${
    $d f g t z A $.  $d f g z F $.  $d f g z G $.  $d f g t z T $.
    $d f g ph $.  $d t x A $.  $d x T $.  $d x ph $.
    stoweidlem33.1 $e |- F/_ t F $.
    stoweidlem33.2 $e |- F/_ t G $.
    stoweidlem33.3 $e |- F/ t ph $.
    stoweidlem33.4 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem33.5 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem33.6 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem33.7 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    $( If a set of real functions from a common domain is closed under
       addition, multiplication and it contains constants, then it is closed
       under subtraction.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem33 $p |- ( ( ph /\ F e. A /\ G e. A ) ->
          ( t e. T |-> ( ( F ` t ) - ( G ` t ) ) ) e. A ) $=
      ( cfv co cmpt eqid cv cmin c1 cneg cmul stoweidlem22 ) ABCDEFGHICECUAZHQU
      GIQZUBRSZCEUCUDSZCEUGUJQUHUERSZLJKUITUJTUKTMNOPUF $.
  $}

  ${
    $d i j k t E $.  $d i j l s t E $.  $d i l s D $.  $d i k J $.
    $d i j k t N $.  $d i j k t T $.  $d i k ph $.  $d j k F $.
    $d j l s t X $.  $d l s J $.  $d l s t N $.  $d l s t T $.  $d l s ph $.
    $d x N $.
    stoweidlem34.1 $e |- F/_ t F $.
    stoweidlem34.2 $e |- F/ j ph $.
    stoweidlem34.3 $e |- F/ t ph $.
    stoweidlem34.4 $e |- D = ( j e. ( 0 ... N ) |->
          { t e. T | ( F ` t ) <_ ( ( j - ( 1 / 3 ) ) x. E ) } ) $.
    stoweidlem34.5 $e |- B = ( j e. ( 0 ... N ) |->
         { t e. T | ( ( j + ( 1 / 3 ) ) x. E ) <_ ( F ` t ) } ) $.
    stoweidlem34.6 $e |- J = ( t e. T |->
          { j e. ( 1 ... N ) | t e. ( D ` j ) } ) $.
    stoweidlem34.7 $e |- ( ph -> N e. NN ) $.
    stoweidlem34.8 $e |- ( ph -> T e. _V ) $.
    stoweidlem34.9 $e |- ( ph -> F : T --> RR ) $.
    stoweidlem34.10 $e |- ( ( ph /\ t e. T ) -> 0 <_ ( F ` t ) ) $.
    stoweidlem34.11 $e |- ( ( ph /\ t e. T ) ->
          ( F ` t ) < ( ( N - 1 ) x. E ) ) $.
    stoweidlem34.12 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem34.13 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    stoweidlem34.14 $e |- ( ( ph /\ j e. ( 0 ... N ) ) ->
          ( X ` j ) : T --> RR ) $.
    stoweidlem34.15 $e |- ( ( ph /\ j e. ( 0 ... N ) /\ t e. T ) ->
          0 <_ ( ( X ` j ) ` t ) ) $.
    stoweidlem34.16 $e |- ( ( ph /\ j e. ( 0 ... N ) /\ t e. T ) ->
          ( ( X ` j ) ` t ) <_ 1 ) $.
    stoweidlem34.17 $e |- ( ( ph /\ j e. ( 0 ... N ) /\
          t e. ( D ` j ) ) -> ( ( X ` j ) ` t ) < ( E / N ) ) $.
    stoweidlem34.18 $e |- ( ( ph /\ j e. ( 0 ... N ) /\ t e. ( B ` j ) ) ->
          ( 1 - ( E / N ) ) < ( ( X ` j ) ` t ) ) $.
    $( This lemma proves that for all ` t ` in ` T ` there is a ` j ` as in the
       proof of [BrosowskiDeutsh] p. 91 (at the bottom of page 91 and at the
       top of page 92):  (j-4/3) * &epsilon; < f(t) <= (j-1/3) * &epsilon; ,
       g(t) < (j+1/3) * &epsilon;, and g(t) > (j-4/3) * &epsilon;.  Here ` E `
       is used to represent &epsilon; in the paper.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem34 $p |- ( ph -> A. t e. T E. j e. RR
          ( ( ( ( j - ( 4 / 3 ) ) x. E ) < ( F ` t ) /\
          ( F ` t ) <_ ( ( j - ( 1 / 3 ) ) x. E ) ) /\
          ( ( ( t e. T |-> sum_ i e. ( 0 ... N )
          ( E x. ( ( X ` i ) ` t ) ) ) ` t ) < ( ( j + ( 1 / 3 ) ) x. E ) /\
          ( ( j - ( 4 / 3 ) ) x. E ) < ( ( t e. T |->
          sum_ i e. ( 0 ... N ) ( E x. ( ( X ` i ) ` t ) ) ) ` t ) ) ) ) $=
      ( vk vs vl cv c4 c3 cdiv co cmin cmul cfv clt wbr c1 cle wa cc0 cfz caddc
      cmpt cr wrex wcel wss crab cvv wceq simpr wex w3a adantr syl6eleq syl 3re
      cn c0 3ne0 a1i 1re simprd wb resubcld mpbid jca wi remulcld syl3anc rabid
      sylanbrc rabexg oveq1d breq2d rabbidv fvmptg syl2anc eleqtrrd nfcv nfmpt1
      mpd oveq1 nfcxfr nffv nfcri fveq2 eleq2d nfv weq sylib nfan biimpa wn 0re
      eleq1 notbid sylibr ex simplll ax-1cn oveq2d adantl oveq1i adantrr anbi2d
      cz 1z ad2antrr nfim imbi12d chvar sylancom csu ovex fvmpt2 sylancl ssrab2
      rabex syl6eqss elfznn ssriv syl6ss nnssre cdif wral wne cuz nnuz rereccli
      vx eluzfz2 nnred 1lt3 pm3.2i recgt1i mp1i ltsub2dd rpred rpgt0d syl112anc
      ltmul1 fnvinran lttr ltle 3adant2 syld cn0 nnnn0 nn0uz 3syl elrabf nfrab1
      ne0i nnwo nfmpt nfral breq1 ralbidv simp3 simp1l noel 1m1e0 syl6eq fveq2d
      cbvrexf wal cneg redivcld renegcld 3pos recgt0ii lt0neg2 ax-mp mpbi mpbii
      mul02lem2 breqtrd ltletrd ltnled nan mpbir sylnibr nnnn0d elnn0uz eluzfz1
      df-neg syl6eqr neleqtrrd alrimi eq0 nfn cbval bitri sylan9eqr mtbiri sylc
      con2d wo syl6bb simprbda elfzp12 adantlr orcanai fzssp1 nncnd cc syl5sseq
      npcand zaddcl mp2an elfzelz fzsubel syl22anc sseldd 3adant3 elrab3 mpbird
      nnzd pncan cbvrab syl6eleqr 3ad2ant1 peano2rem ex-natded5.3i ltnle ancoms
      zre ltm1 breq2 rspcev rexnal 3expia imp eldifd exp31 df-rex simprl eldifn
      reximdai simplr simpll simprr cbvmptv eqtri eleqtrd syl21anc recn 3pm3.2i
      fvmptd redivcl mp2b subsub4d 3cn divdiri 3p1e4 dividi eqtr4d syl5bb mtbid
      3eqtr3i imnan sylanr2 cxr 4re remulcl rexrd xrltnle simpl 0p1e1 0z fzp1ss
      eldifad eqsstr3i sseli wf feq1d simpllr nf3an 3anbi2d fveq1d elfzel2 3jca
      breq1d elfzel1 zred elfzle1 letrd elfzle2 adantlrr simplrl simplrr simpl1
      0le1 elfz2 simpl3 simpl2 lesub1dd rpregt0d lemul1 3ad2ant3 3impa syl31anc
      simpl1l 3anbi23d crp stoweidlem11 anbi12d nfdif nfrab fvmptf mpan2 simpld
      difeq12d ad2ant2lr simp1ll syld3an1 stoweidlem26 vtoclga ad2antlr pm2.43i
      ad2antrl eximd 3anass exbii ssrexf ralrimi ) AGUNZUOUPUQURZUSURZHUTURZBUN
      ZIVAZVBVCZWUTWUOVDUPUQURZUSURZHUTURZVEVCZVFZWUSBEVGKVHURZHWUSFUNZLVAZVAZU
      TURFUUAVJZVAZWUOWVBVIURHUTURZVBVCZWURWVLVBVCZVFZVFZGVKVLZBEOAWUSEVMZWVRAW
      VSVFZWUSJVAZVKVNWVQGWWAVLZWVRWVTWWAWEVKWVTWWAVDKVHURZWEWVTWWAWUSWUODVAZVM
      ZGWWCVOZWWCWVTWVSWWFVPVMWWAWWFVQZAWVSVRZWWEGWWCVDKVHUUBZUUFBEWWFVPJRUUCUU
      DZWWEGWWCUUEUUGUURWWCWEUURUNKUUHUUIUUJZUUKUUJWVTWUOWWAVMZWVQVFZGVSZWWBWVT
      WWLWVFWVPVTZGVSZWWNWVTWWLWUSWWDWUOVDUSURZDVAZUULZVMZVFZGVSZWWPWVTWWTGWWAV
      LZWXBWVTWUOUKUNZVEVCZUKWWAUUMZGWWAVLZWXCWVTWWAWEVNZWWAWFUUNZWXGWWKWVTKWWA
      VMWXIWVTKWWFWWAWVTKWWCVMZWUSKDVAZVMZKWWFVMWVTKVDUUOVAZVMZWXJWVTKWEWXMAKWE
      VMZWVSSWAZUUPWBVDKUUSWCWVTWUSWUTKWVBUSURZHUTURZVEVCZBEVOZWXKWVTWVSWXSWUSW
      XTVMWWHWVTWUTKVDUSURZHUTURZVBVCZWYBWXRVBVCZVFZWXSWVTWYCWYDUCWVTWYAWXQVBVC
      ZWYDWVTWVBVDKWVBVKVMZWVTUPWDWGUUQZWHZVDVKVMZWVTWIWHZWVTKWXPUUTZUPVKVMZVDU
      PVBVCZVFZWVBVDVBVCZWVTWYMWYNWDUVAUVBWYOVGWVBVBVCZWYPUPUVCWJUVDUVEWVTWYAVK
      VMWXQVKVMHVKVMZVGHVBVCZWYFWYDWKWVTKVDWYLWYKWLZWVTKWVBWYLWYIWLZAWYRWVSAHUD
      UVFZWAZAWYSWVSAHUDUVGWAZWYAWXQHUVIUVHWMWNWVTWUTVKVMZWYBVKVMZWXRVKVMZWYEWX
      SWOAEVKWUSIUAUVJZWVTWYAHWYTXUCWPWVTWXQHXUAXUCWPXUEXUFXUGVTWYEWUTWXRVBVCZW
      XSWUTWYBWXRUVKXUEXUGXUIWXSWOXUFWUTWXRUVLUVMUVNWQXIWXSBEWRWSAWXKWXTVQZWVSA
      KWVGVMZWXTVPVMZXUJAWXOKVGUUOVAZVMZXUKSWXOKUVOXUMKUVPUVQWBVGKUUSUVRAEVPVMZ
      XULTWXSBEVPWTWCGKWVEBEVOZWXTWVGVPDWUOKVQZWVEWXSBEXUQWVDWXRWUTVEXUQWVCWXQH
      UTWUOKWVBUSXJXAXBXCPXDXEWAXFWWEWXLGKWWCGKXGZGWWCXGZGBWXKGKDGDGWVGXUPVJZPG
      WVGXUPXHXKZXURXLXMXUQWWDWXKWUSWUOKDXNXOUVSWSWWJXFWWAKUWAWCWXHWXIVFWVHWXDV
      EVCZUKWWAUUMZFWWAVLWXGFUKWWAUWBXVCWXFFGWWAFWWAXGGWUSJGJBEWWFVJZRGBEWWFGEX
      GWWEGWWCUVTUWCXKZGWUSXGXLZXVBGUKWWAXVFXVBGXPUWDWXFFXPFGXQXVBWXEUKWWAWVHWU
      OWXDVEUWEUWFUWMXRXEWVTWXFWWTGWWAAWVSGNWVSGXPZXSZWVTWWLWXFWWTWVTWWLVFZWXFV
      FWUSWWDWWRXVIWWEWXFXVIWUOWWCVMZWWEXVIWUOWWFVMZXVJWWEVFZWVTWWLXVKWVTWWAWWF
      WUOWWJXOZXTWWEGWWCWRZXRWJWAXVIWXFWUSWWRVMZYAZXVIXVOWXFWVTWWLXVOWXFYAZWVTW
      WLXVOVTZWXEYAZUKWWAVLZXVQXVRWWQWWAVMWUOWWQVEVCZYAZXVTXVRWWQWWFWWAXVRWWQWU
      SWVHDVAZVMZFWWCVOZWWFXVRWWQXWEVMZXVOWVTWWLXVOUWGZXVRWWQWWCVMZXWFXVOWKXVRW
      UOVDVQZYAZXWHXVRAXVOXWJAWVSWWLXVOUWHXWGAXWIXVOAXWIXVPAXWIVFZXVOWUSWFVMWUS
      UWIXWKWWRWFWUSXWIAWWRVGDVAZWFXWIWWQVGDXWIWWQVDVDUSURZVGWUOVDVDUSXJUWJUWKU
      WLAWUSXWLVMZYAZBUWNZXWLWFVQZAXWOBOAXWLWUTWVBUWOZHUTURZVEVCZBEVOZWUSAWVSXW
      TVFZWUSXXAVMAXXBYAWOWVTXWTYAZWOWVTXWSWUTVBVCXXCWVTXWSVGWUTWVTXWRHWVTWVBWV
      TVDUPWYKWYMWVTWDWHUPVGUUNZWVTWGWHUWPUWQZXUCWPZVGVKVMZWVTYBWHZXUHWVTXWSVGH
      UTURZVGVBWVTXWRVGVBVCZXWSXXIVBVCZWYQXXJUPWDUWRUWSWYGWYQXXJWKWYHWVBUWTUXAU
      XBWVTXWRVKVMXXGWYRWYSXXJXXKWKXXEXXHXUCXUDXWRVGHUVIUVHUXCWVTWYRXXIVGVQXUCH
      UXDWCUXEUBUXFWVTXWSWUTXXFXUHUXGWMAWVSXWTUXHUXIXWTBEWRUXJAVGWVGVMZXXAVPVMZ
      XWLXXAVQAXUNXXLAKUVOVMXUNAKSUXKKUXLXRVGKUXMWCAXUOXXMTXWTBEVPWTWCGVGXUPXXA
      WVGVPDWUOVGVQZWVEXWTBEXXNWVDXWSWUTVEXXNWVCXWRHUTXXNWVCVGWVBUSURXWRWUOVGWV
      BUSXJWVBUXNUXOXAXBXCPXDXEUXPUXQXWQULUNZXWLVMZYAZULUWNXWPULXWLUXRXXQXWOULB
      XXPBBULXWLBVGDBDXUTPBGWVGXUPBWVGXGWVEBEUVTUWCXKZBVGXGXLXMUXSXWOULXPULBXQZ
      XXPXWNXXOWUSXWLYCYDUXTUYAYEUYBXOUYCYFUYEUYDWVTWWLXWJXWHWOXVOXVIXWJXWHXVIX
      WJVFAWUOVDVDVIURZKVHURVMZXWHAWVSWWLXWJYGXVIXWIXYAXVIXVJXWIXYAUYFZWVTWWLXV
      JWWEWVTWWLXVKXVLXVMXVNUYGUYHZAWWLXVJXYBWKZWVSAWWLVFWXNXYDAWXNWWLAKWEWXMSU
      UPWBWAWUOVDKUYIWCUYJWMUYKAXYAVFZVDWYAVHURZWWCWWQAXYFWWCVNXYAAVDWYAVDVIURZ
      VHURXYFWWCVDWYAUYLAXYGKVDVHAKVDAKSUYMVDUYNVMZAYHWHUYPZYIUYOWAXYEWWQXXTVDU
      SURZWYAVHURZXYFXYEXYAWWQXYKVMZAXYAVRXYEXXTYNVMZKYNVMZWUOYNVMZVDYNVMZXYAXY
      LWKXYMXYEXYPXYPXYMYOYOVDVDUYQUYRWHAXYNXYAAKSVUFZWAXYAXYOAWUOXXTKUYSYJXYPX
      YEYOWHWUOVDXXTKUYTVUAWMXYJVDWYAVHXYHXYHXYJVDVQYHYHVDVDVUGUYRYKWBVUBXEYFVU
      CXIXWDXVOFWWQWWCWVHWWQVQXWCWWRWUSWVHWWQDXNXOVUDWCVUEWWEXWDGFWWCXUSFWWCXGW
      WEFXPGBXWCGWVHDXVAGWVHXGZXLXMZGFXQZWWDXWCWUSWUOWVHDXNXOZVUHVUIWVTWWLWWGXV
      OWWJVUJXFXVRWUOVKVMZWWQVKVMZVFZXWBXVRYUBYUCWVTWWLYUBXVOXVIXVJXYOYUBXYCWUO
      VDKUYSZWUOVUOUVRZVUCWUOVUKVULYUDWWQWUOVBVCZXWBYUBYUGYUCWUOVUPWAYUCYUBYUGX
      WBWKWWQWUOVUMVUNWMWCXVSXWBUKWWQWWAWXDWWQVQZWXEXWAWXDWWQWUOVEVUQYDVURXEWXE
      UKWWAVUSXRVUTUYEVVAVVBVVCVVGXIWWTGWWAVVDXRWVTWXAWWOGXVHWVTWXAWWOWVTWXAVFZ
      WWLWVFWVPWVTWWLWWTVVEZYUIWVAWVEYUIWVAWUTWURVEVCZYAZWWTWVTWWLXVPYULWUSWWDW
      WRVVFWVTWWLXVPVFZVFZWVSYULAWVSYUMVVHYUNWVSYUKVFZYAWVSYULWOYUNWUSWUTWWQWVB
      USURZHUTURZVEVCZBEVOZVMZYUOYUNAXVJXVPYUTYAZAWVSYUMVVIWVTWWLXVJXVPXYCYLWVT
      WWLXVPVVJAXVJVFZXVPYVAYVBXVOYUTYVBWWRYUSWUSYVBUKWWQWUTWXDWVBUSURZHUTURZVE
      VCZBEVOZYUSWVGDVPDUKWVGYVFVJZVQYVBDXUTYVGPGUKWVGXUPYVFGUKXQZWVEYVEBEYVHWV
      DYVDWUTVEYVHWVCYVCHUTWUOWXDWVBUSXJXAXBXCVVKVVLWHZYUHYVFYUSVQYVBYUHYVEYURB
      EYUHYVDYUQWUTVEYUHYVCYUPHUTWXDWWQWVBUSXJXAXBXCYJYVBVGWYAVHURZWVGWWQAYVJWV
      GVNXVJAVGXYGVHURYVJWVGVGWYAUYLAXYGKVGVHXYIYIUYOWAYVBWWQXWMWYAVHURZYVJYVBX
      VJWWQYVKVMZAXVJVRYVBXYPXYNXYOXYPXVJYVLWKXYPYVBYOWHZAXYNXVJXYQWAXVJXYOAYUE
      YJYVMWUOVDVDKUYTVUAWMYVBXWMVGWYAVHXWMVGVQYVBUWJWHXAVVMVUBYVBXUOYUSVPVMAXU
      OXVJTWAZYURBEVPWTWCVVQXOYDXTVVNYUTWVSYURVFYUNYUOYURBEWRYUNYURYUKWVSYUNYUQ
      WURWUTVEYUNYUBYUQWURVQWVTWWLYUBXVPYUFYLYUBYUPWUQHUTYUBYUPWUOVDWVBVIURZUSU
      RWUQYUBWUOVDWVBWUOVVOXYHYUBYHWHWVBUYNVMZYUBWYJWYMXXDVTWYGYVPWYJWYMXXDWIWD
      WGVVPVDUPVVRWVBVVOVVSWHVVTYUBWUPYVOWUOUSWUPYVOVQYUBUPVDVIURZUPUQURUPUPUQU
      RZWVBVIURWUPYVOUPVDUPVWAYHVWAWGVWBYVQUOUPUQVWCYKYVRVDWVBVIUPVWAWGVWDYKVWH
      WHYIVWEXAWCXBYMVWFVWGWVSYUKVWIYEXIVWJYUIWURVWKVMZWUTVWKVMZWVAYULWKYUIWUQV
      KVMZWYRYVSYUIWUOWUPWVTWWLYUBWWTYUFYLYUIUOUPUOVKVMYUIVWLWHWYMYUIWDWHXXDYUI
      WGWHUWPWLAWYRWVSWXAXUBYPYWAWYRVFWURWUQHVWMVWNXEWVTYVTWXAWVTWUTXUHVWNWAWUR
      WUTVWOXEVUEYUIWVTWWLWWEWVEWVTWXAVWPYUJYUIWUSWWDWWRWVTWWLWWTVVJVWTXVIWWEVF
      ZWVSWVEYWBWUSXUPVMZWVSWVEVFZYWBAXVJWWEYWCAWVSWWLWWEYGXVIXVJWWEXYCWAXVIWWE
      VRYVBWWEYWCYVBWWDXUPWUSYVBUKWUOYVFXUPWVGDVPYVIUKGXQZYVFXUPVQYVBYWEYVEWVEB
      EYWEYVDWVDWUTVEYWEYVCWVCHUTWXDWUOWVBUSXJXAXBXCYJXVJWUOWVGVMZAWWCWVGWUOWWC
      VGVDVIURZKVHURZWVGYWGVDKVHVWQYKVGYNVMZYWHWVGVNVWRVGKVWSUXAVXAVXBYJYVBXUOX
      UPVPVMYVNWVEBEVPWTWCVVQZXOXTVVNWVEBEWRZXRWJVVNWNYUIWVNWVOYUIBEFGHKLAWXOWV
      SWXASYPAWVSWXAVVHWVTWWLXVJWWTXYCYLYUIWVHWVGVMZAEVKWVIVXCZAWVSWXAYWLYGZAYW
      FVFZEVKWUOLVAZVXCZWOAYWLVFZYWMWOGFYWRYWMGAYWLGNYWLGXPZXSYWMGXPYQXYTYWOYWR
      YWQYWMXYTYWFYWLAWUOWVHWVGYCZYMXYTEVKYWPWVIWUOWVHLXNZVXDYRUFYSZYTYUIYWLVFA
      YWLWVSWVJVDVEVCZYWNYUIYWLVRAWVSWXAYWLVXEAYWFWVSVTZWUSYWPVAZVDVEVCZWOAYWLW
      VSVTZYXCWOGFYXGYXCGAYWLWVSGNYWSXVGVXFZYXCGXPYQXYTYXDYXGYXFYXCXYTYWFYWLAWV
      SYWTVXGZXYTYXEWVJVDVEXYTWUSYWPWVIYXAVXHZVXKYRUHYSWQYUIWVHWUOKVHURVMZVFZAY
      WLXWDWVJHKUQURZVBVCZAWVSWXAYXKYGWVTWWLYXKYWLWWTXVIYXKVFZYWIXYNWVHYNVMZVTZ
      VGWVHVEVCZWVHKVEVCZVFZYWLYXOYWIXYNYXPYWIYXOVWRWHYXKXYNXVIWVHWUOKVXIZYJYXK
      YXPXVIWVHWUOKUYSZYJVXJYXOYXRYXSYXOVGWUOWVHXXGYXOYBWHYXKYUBXVIYXKWUOWVHWUO
      KVXLVXMZYJYXKWVHVKVMZXVIYXKWVHYYBVXMZYJXVIVGWUOVEVCYXKXVIVGVDWUOXXGXVIYBW
      HWYJXVIWIWHYUFVGVDVEVCXVIVYAWHXVIXVJVDWUOVEVCXYCWUOVDKVXNWCVXOWAYXKWUOWVH
      VEVCZXVIWVHWUOKVXNZYJVXOYXKYXSXVIWVHWUOKVXPYJWNZWVHVGKVYBZWSVXQYXLWVTWWLW
      WEYXKXWDWVTWXAYXKVVIWVTWWLWWTYXKVXRYXLWUSWWDWWRWVTWWLWWTYXKVXSVWTYUIYXKVR
      WVTWWLWWEVTZYXKVFZWUSWUTWVHWVBUSURZHUTURZVEVCZBEVOZXWCYYKWVSYYNWUSYYOVMYY
      KAWVSWVTWWLWWEYXKVXTZWJYYKWUTWVDYYMYYKWVTXUEYYPXUHWCYYKWVCHYYKWUOWVBYXKYU
      BYYJYYCYJZWYGYYKWYHWHZWLZYYKAWYRAWVSWWLWWEYXKVYKZXUBWCWPYYJYXKAYYMVKVMYYT
      AYXKVFZYYLHUUUAWVHWVBYXKYYDAYYEYJWYGUUUAWYHWHWLZAWYRYXKXUBWAWPYTYYKWVSWVE
      YYKYWCYWDYYKWUSWWDXUPWVTWWLWWEYXKVYCYYKAXVJWWDXUPVQYYTYYKWVTWWLXVJYYPWVTW
      WLWWEYXKVYDZXYCXEYWJXEVVMYWKXRWJYYKWVCYYLVEVCZWVDYYMVEVCZYYKWUOWVHWVBYYQY
      XKYYDYYJYYEYJYYRYXKYYFYYJYYGYJVYEYYKWVCVKVMYYLVKVMZWYRWYSVFZUUUDUUUEWKYYS
      YYJYXKAUUUFYYTUUUBYTYYKAUUUGYYTAHUDVYFWCWVCYYLHVYGWQWMVXOYYNBEWRWSYYKAYWL
      XWCYYOVQZYYTYYKWVTWWLYXKYWLYYPUUUCYYJYXKVRWVTWWLYXKVTZYXQYXTYWLUUUIYWIXYN
      YXPYWIUUUIVWRWHYXKWVTXYNWWLYYAVYHYXKWVTYXPWWLYYBVYHVXJWVTWWLYXKYXTYYHVYIY
      YIWSWQYWRYWLYYOVPVMZUUUHAYWLVRAUUUJYWLAXUOUUUJTYYNBEVPWTWCWAGWVHXUPYYOWVG
      VPDXYTWVEYYNBEXYTWVDYYMWUTVEXYTWVCYYLHUTWUOWVHWVBUSXJXAXBXCPXDXEXEXFVYJAY
      WFWWEVTZYXEYXMVBVCZWOAYWLXWDVTZYXNWOGFUUUMYXNGAYWLXWDGNYWSXYSVXFYXNGXPYQX
      YTUUUKUUUMUUULYXNXYTYWFYWLWWEXWDAYWTYUAVYLXYTYXEWVJYXMVBYXJVXKYRUIYSWQAHV
      YMVMZWVSWXAUDYPAHWVBVBVCZWVSWXAUEYPVYNYUIWVOWWLYUIWVOWOZWVTWWTWVTUMUNZWWA
      VMZWUSUUUQDVAZUUUQVDUSURZDVAZUULZVMZVFZVFZUUUQWUPUSURZHUTURZWVLVBVCZWOZUU
      UPUMWUOWWAUMGXQZUUVEYUIUUVHWVOUUVJUUVDWXAWVTUUVJUUURWWLUUVCWWTUUUQWUOWWAY
      CUUVJUUVBWWSWUSUUVJUUUSWWDUUVAWWRUUUQWUODXNUUVJUUUTWWQDUUUQWUOVDUSXJUWLWU
      AXOVYOYMUUVJUUVGWURWVLVBUUVJUUVFWUQHUTUUUQWUOWUPUSXJXAVXKYRUUVIUUURUUVEUU
      VHWVSUUVIAUUVDAXXOEVMZVFZUUUQXXOJVAZVMZXXOUUVBVMZVFZVFZUUVGXXOWVKVAZVBVCZ
      WOZUUVIULWUSEXXSUUVQUUVEUUVSUUVHXXSUUVLWVTUUVPUUVDXXSUUVKWVSAXXOWUSEYCYMX
      XSUUVNUUURUUVOUUVCXXSUUVMWWAUUUQXXOWUSJXNXOXXOWUSUUVBYCVYOVYOXXSUUVRWVLUU
      VGVBXXOWUSWVKXNXBYRUUVTUUVKUUVQBCDXXOEFGHIUUUQKLMUUVLUUVPGAUUVKGNUUVKGXPX
      SUUVNUUVOGGUMUUVMGXXOJXVEGXXOXGXLXMGULUUVBGUUUSUUVAGUUUQDXVAGUUUQXGZXLZGU
      UUTDXVAGUUUTXGXLVYPXMXSXSUUVLUUVPBAUUVKBOUUVKBXPXSUUVNUUVOBBUMUUVMBXXOJBJ
      XVDRBEWWFXHXKBXXOXGZXLXMBULUUVBBUUUSUUVABUUUQDXXRBUUUQXGXLBUUUTDXXRBUUUTX
      GXLVYPXMXSXSPQAWXOUUVKUUVPSYPAXUOUUVKUUVPTYPUUVKUUVNUUUQWWCVMZAUUVOUUVKUU
      VNVFZUUWDXXOUUUSVMZUUWEUUUQXXOWWDVMZGWWCVOZVMZUUWDUUWFVFUUVKUUVNUUWIUUVKU
      UVMUUWHUUUQUUVKUUWHVPVMUUVMUUWHVQUUWGGWWCWWIUUFBXXOWWFUUWHEJVPUUWCUUWGBGW
      WCBULWWDBWUODXXRBWUOXGXLXMBWWCXGVYQBULXQWWEUUWGGWWCWUSXXOWWDYCXCRVYRVYSXO
      XTUUWGUUWFGUUUQWWCUUWAXUSGULUUUSUUWBXMGUMXQWWDUUUSXXOWUOUUUQDXNXOUVSXRVYT
      WUBUUVLUUVNUUVOVVJAEVKIVXCUUVKUUVPUAYPAUUUNUUVKUUVPUDYPAUUUOUUVKUUVPUEYPU
      UVQYWLAYWMAUUVKUUVPYWLYGYXBYTAYWLUUVQWVSVGWVJVEVCZAUUVKUUVPYWLWVSWUCYXDVG
      YXEVEVCZWOYXGUUWJWOGFYXGUUWJGYXHUUWJGXPYQXYTYXDYXGUUWKUUWJYXIXYTYXEWVJVGV
      EYXJXBYRUGYSWUDAYWLUUVQWUSWVHCVAZVMZVDYXMUSURZWVJVBVCZAUUVKUUVPYWLUUWMWUC
      AYWFWUSWUOCVAZVMZVTZUUWNYXEVBVCZWOAYWLUUWMVTZUUWOWOGFUUWTUUWOGAYWLUUWMGNY
      WSGBUUWLGWVHCGCGWVGWVMWUTVEVCBEVOZVJQGWVGUUXAXHXKXYRXLXMVXFUUWOGXPYQXYTUU
      WRUUWTUUWSUUWOXYTYWFYWLUUWQUUWMAYWTXYTUUWPUUWLWUSWUOWVHCXNXOVYLXYTYXEWVJU
      UWNVBYXJXBYRUJYSWUDWUEWHWUFWUGWUHWHWUFWUIWUHWNVXJYFWUJXIWWOWWMGWWLWVFWVPW
      UKWULXRWVQGWWAVVDYEWVQGWWAVKXVFGVKXGWUMUYDYFWUN $.
  $}

  ${
    $d f g h i t w z $.  $d f g h k t w z $.  $d f g i l t w z $.
    $d f g i m q t $.  $d f g i l z G $.  $d f g k w z Q $.  $d f g h w T $.
    $d f g q U $.  $d f g i m ph $.  $d h k t w x $.  $d h t A $.
    $d h i t w X $.  $d k l t w z $.  $d k m t w z $.  $d k l z G $.
    $d k m ph $.  $d m z G $.  $d q Q $.  $d q T $.  $d t Z $.  $d w U $.
    $d x Q $.  $d x T $.
    stoweidlem35.1 $e |- F/ t ph $.
    stoweidlem35.2 $e |- F/ w ph $.
    stoweidlem35.3 $e |- F/ h ph $.
    stoweidlem35.4 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem35.5 $e |- W = { w e. J | E. h e. Q w =
          { t e. T | 0 < ( h ` t ) } } $.
    stoweidlem35.6 $e |- G = ( w e. X |->
          { h e. Q | w = { t e. T | 0 < ( h ` t ) } } ) $.
    stoweidlem35.7 $e |- ( ph -> A e. _V ) $.
    stoweidlem35.8 $e |- ( ph -> X e. Fin ) $.
    stoweidlem35.9 $e |- ( ph -> X C_ W ) $.
    stoweidlem35.10 $e |- ( ph -> ( T \ U ) C_ U. X ) $.
    stoweidlem35.11 $e |- ( ph -> ( T \ U ) =/= (/) ) $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       of [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <=
       1, p_(t_0) = 0, and p > 0 on T - U. Here ` ( q `` i ) ` is used to
       represent p_(t_i) in the paper.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem35 $p |- ( ph -> E. m E. q ( m e. NN /\
          ( q : ( 1 ... m ) --> Q /\ A. t e. ( T \ U ) E. i e. ( 1 ... m )
          0 < ( ( q ` i ) ` t ) ) ) ) $=
      ( vf vg vl vk cv cn wcel c1 cfz co cc0 cfv clt wbr wrex cdif wral wex crn
      wf wa wfn wf1o w3a cfn crab wceq cmpt mptfi syl5eqel rnfi syl c0 fnchoice
      wne wi adantl simprl elrnmpt ibi nfmpt1 nfcxfr nfrn nfcri sselda syl6eleq
      nfan rabid sylib simprd df-rex exbii sylibr adantr nfv nfrab1 nfeq2 eleq2
      biimprd eximd mpd adantllr exp31 reximdai idd a1i rexlimd adantlr simplrr
      n0 neeq1 fveq2 eleq1d bitrd imbi12d rspccva ex eximdv syl2anc cvv cle wal
      cuni ax-17 19.29 sylan eximi nfcv nfrab nffn nfral nff1o nf3an cbvralv wn
      sylancom ralrimiva jca mpdan ralrimivw chash wss ssn0 neneqd unieq syl6eq
      uni0 nsyl cdm dm0rn0 rabexg rabexgf fmptdf dffn2 eqeq1d syl5bbr mtbird wo
      fndm fz1f1o ord wb oveq2 f1oeq2 exbidv rspcev r19.29 eeanv biimpri df-3an
      reximdv anbi2i 2exbii simprr1 simprr2 simprr3 nfra1 nfmpt stoweidlem27 id
      elex 2eximdv exlimivv ) AJULZUMUNZUOUWKUPUQZEPULZVGURCULZIULUWNUSUSUTVAIU
      WMVBCFGVCZVDVHVHPVEZUHVEUIVEZJVEZUWQJVEAUWLUIULZKVFZVIZUJULZUWTUSZUXCUNZU
      JUXAVDZUWMUXAUHULZVJZVKZVHZUHVEUIVEZJVEZUWSAUWLUXBUXFVHZUXHVHZUHVEZUIVEZV
      HZJVEZUXLAUXPJUMVBZUXRAUXMUIVEZUXHUHVEZVHZJUMVBZUXSAUXTJUMVDUYAJUMVBZUYCA
      UXTJUMAUXAVLUNZUXTANVLUNZUYEUDUYFKVLUNUYEUYFKBNBULZURUWOHULZUSZUTVAZCFVMZ
      VNZHEVMZVOZVLUBBNUYMVPVQKVRVSVSZAUYEVHZUXBUXCVTWBZUXEWCZUJUXAVDZVHZUIVEZU
      XTUYEVUAAUJUXAUIWAWDUYPUYTUXMUIAUYTUXMWCUYEAUYTUXMAUYTVHZUXBUXFAUXBUYSWEV
      UBUKULZUWTUSZVUCUNZUKUXAVDUXFVUBVUEUKUXAVUBVUCUXAUNZVHVUCVTWBZVUEAVUFVUGU
      YTAVUFVHZUYHVUCUNZHVEZVUGVUHVUJBNVBZVUJVUHVUCUYMVNZBNVBZVUKVUFVUMAVUFVUMB
      NUYMVUCKUXAUBWFWGWDVUHVULVUJBNAVUFBRBUKUXABKBKUYNUBBNUYMWHWIWJZWKWNZVUHUY
      GNUNZVULVUJAVUPVULVUJVUFAVUPVHZVULVHZUYHUYMUNZHVEZVUJVUQVUTVULVUQUYHEUNUY
      LVHZHVEZVUTVUQUYLHEVBZVVBVUQUYGLUNZVVCVUQUYGVVCBLVMZUNVVDVVCVHVUQUYGMVVEA
      NMUYGUEWLUAWMVVCBLWOWPWQUYLHEWRWPVUSVVAHUYLHEWOWSWTXAVURVUSVUIHVUQVULHAVU
      PHSVUPHXBWNHVUCUYMUYLHEXCXDWNVULVUSVUIWCVUQVULVUIVUSVUCUYMUYHXEXFWDXGXHXI
      XJXKXHVUHVUJVUJBNVUOVUJBXBVUPVUJVUJWCWCVUHVUPVUJXLXMXNXHHVUCXQWTXOVUBVUFU
      YSVUGVUEWCZAUXBUYSVUFXPUYRVVFUJVUCUXAUXCVUCVNZUYQVUGUXEVUEUXCVUCVTXRVVGUX
      EVUDUXCUNVUEVVGUXDVUDUXCUXCVUCUWTXSXTUXCVUCVUDXEYAZYBYCUUCXHUUDVUEUXEUKUJ
      UXAVUCUXCVNZVUEUXDVUCUNUXEVVIVUDUXDVUCVUCUXCUWTXSXTVUCUXCUXDXEYAUUAWPUUEY
      DXAYEXHUUFUUGAUXAUUHUSZUMUNUOVVJUPUQZUXAUXGVJZUHVEZVHZUYDAUXAVTVNZUUBVVNA
      VVONVTVNZANYJZVTVNVVPAVVQVTAUWPVVQUUIZUWPVTWBVVQVTWBUFUGUWPVVQUUJYFUUKVVP
      VVQVTYJVTNVTUULUUNUUMUUOVVOKUUPZVTVNAVVPKUUQAVVSNVTAKNVIZVVSNVNANYGKVGVVT
      ABNUYMYGKRAUYMYGUNZVUPAEYGUNZVWAAEOUYHUSURVNZURUYIYHVAUYIUOYHVAVHZCFVDZVH
      ZHDVMZYGTADYGUNVWGYGUNUCVWFHDYGUURVSVQZUYLHEYGHEVWGTVWFHDXCWIZUUSVSXAUBUU
      TNKUVAWTNKUVFVSUVBUVCUVDAVVOVVNAUYEVVOVVNUVEUYOUXAUHUVGVSUVHXHUYAVVMJVVJU
      MUWKVVJVNZUXHVVLUHVWJUWMVVKVNUXHVVLUVIUWKVVJUOUPUVJUWMVVKUXAUXGUVKVSUVLUV
      MVSUXTUYAJUMUVNYFAUYBUXPJUMUYBUXPWCAUXPUYBUXMUXHUIUHUVOUVPXMUVRXHUXPJUMWR
      WPAUXQUXKJUXQUXKWCAUXQUWLUXNVHZUHVEZUIVEZUXKUXQUWLUXOVHZUIVEZVWMUWLUWLUIY
      IUXPVWOUWLUIYKUWLUXOUIYLYMVWNVWLUIUWLUWLUHYIUXOVWLUWLUHYKUWLUXNUHYLYMYNVS
      UXJVWKUIUHUXIUXNUWLUXBUXFUXHUVQUVSUVTWTXMYEXHAUXKUWRJAUXJUWQUIUHAUXJUWQAU
      XJVHZBCEFGHIUXGKUWKNUWTPUKUBAVWBUXJVWHXAAUWLUXIWEUXBUXFUXHUWLAUWAAUXAYGUN
      ZUXJAUYEVWQUYOUXAVLUWHVSXAVWPUXFVUFVUEUXBUXFUXHUWLAUWBUXEVUEUJVUCUXAVVHYC
      YMUXBUXFUXHUWLAUWCAVVRUXJUFXAAUXJCQUWLUXICUWLCXBUXBUXFUXHCCUXAUWTCUWTYOCK
      CKUYNUBCBNUYMCNYOUYLCHECUYGUYKUYJCFXCXDCEVWGTVWFCHDVWCVWECVWCCXBVWDCFUWDW
      NCDYOYPWIYPUWEWIWJZYQUXECUJUXAVWRUXECXBYRCUWMUXAUXGCUXGYOCUWMYOVWRYSYTWNW
      NAUXJBRUWLUXIBUWLBXBUXBUXFUXHBBUXAUWTBUWTYOVUNYQUXEBUJUXAVUNUXEBXBYRBUWMU
      XAUXGBUXGYOBUWMYOVUNYSYTWNWNVWIUWFYDUWIYEXHUWRUWQJUWQUWQUIUHUWQUWGUWJYNVS
      $.
  $}

  ${
    $d f g t z T $.  $d f g A $.  $d f g z F $.  $d f g z G $.  $d f g ph $.
    $d g t z N $.  $d h t z S $.  $d h A $.  $d h z H $.  $d h t z T $.
    $d h t z Z $.  $d s t S $.  $d s G $.  $d s J $.  $d s K $.  $d s t T $.
    $d s ph $.  $d t w z $.  $d t x N $.  $d x A $.  $d x T $.  $d x ph $.
    stoweidlem36.1 $e |- F/_ h Q $.
    stoweidlem36.2 $e |- F/_ t H $.
    stoweidlem36.3 $e |- F/_ t F $.
    stoweidlem36.4 $e |- F/_ t G $.
    stoweidlem36.5 $e |- F/ t ph $.
    stoweidlem36.6 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem36.7 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem36.8 $e |- T = U. J $.
    stoweidlem36.9 $e |- G = ( t e. T |-> ( ( F ` t ) x. ( F ` t ) ) ) $.
    stoweidlem36.10 $e |- N = sup ( ran G , RR , < ) $.
    stoweidlem36.11 $e |- H = ( t e. T |-> ( ( G ` t ) / N ) ) $.
    stoweidlem36.12 $e |- ( ph -> J e. Comp ) $.
    stoweidlem36.13 $e |- ( ph -> A C_ ( J Cn K ) ) $.
    stoweidlem36.14 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem36.15 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem36.16 $e |- ( ph -> S e. T ) $.
    stoweidlem36.17 $e |- ( ph -> Z e. T ) $.
    stoweidlem36.18 $e |- ( ph -> F e. A ) $.
    stoweidlem36.19 $e |- ( ph -> ( F ` S ) =/= ( F ` Z ) ) $.
    stoweidlem36.20 $e |- ( ph -> ( F ` Z ) = 0 ) $.
    $( This lemma is used to prove the existence of a function p_t as in Lemma
       1 of [BrosowskiDeutsh] p. 90 (at the beginning of Lemma 1): for all t in
       T - U, there exists a function p in the subalgebra, such that p_t
       ( t_0 ) = 0 , p_t ( t ) > 0, and 0 <= p_t <= 1.  Z is used for t_0 , S
       is used for t e.  T - U , h is used for p_t .  G is used for (h_t)^2 and
       the final h is a normalized version of G ( divided by its norm, see the
       variable N ).  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem36 $p |- ( ph -> E. h ( h e. Q /\ 0 < ( h ` S ) ) ) $=
      ( vs wcel cc0 cfv clt wbr cv wa wex wceq cle c1 wral crab cdiv co cmpt cr
      cmul eqid nfeq2 stoweidlem6 mpd3an23 syl5eqel sseldd fcnre fnvinran recnd
      ccn crn csup wne ne0i syl cncmpmax simp2d adantr 0re a1i ffvelrnd neeqtrd
      cc c0 msqgt0d remulcld nfcv nffv nfov fveq2 oveq12d fvmptf syl2anc simp3d
      breqtrrd breq1d rspccva ltletrd gt0ne0d neeq1i sylibr simpr fvmpt2 oveq2d
      divrecd rereccld eqtr4d mpteq2da syl5eq stoweidlem4 mpdan nfmpt1 redivcld
      eqeltrd oveq1d syl6eqel 0cn mul02i syl6breqr eqbrtrd fveq1 breq2d anbi12d
      jca syl6eq eqtrd div0d 3eqtrd msqge0d divge0 syl22anc div1d sylan wb 0lt1
      1re lediv23 syl122anc mpbird ralrimi eqeq1d ralbid elrab sylanbrc divgt0d
      ex syl6eleqr nfel2 nfv nfan eleq1 spcegf anabsi5 ) AMEUSZUTFMVAZVBVCZJVDZ
      EUSZUTFUVMVAZVBVCZVEZJVFZAMQUVMVAZUTVGZUTCVDZUVMVAZVHVCZUWBVIVHVCZVEZCGVJ
      ZVEZJDVKZEAMDUSQMVAZUTVGZUTUWAMVAZVHVCZUWKVIVHVCZVEZCGVJZVEZMUWHUSAMCGUWA
      LVAZUWACGVIPVLVMZVNZVAZVPVMZVNZDAMCGUWQPVLVMZVNUXBUHACGUXCUXAUBAUWAGUSZVE
      ZUXCUWQUWRVPVMUXAUXEUWQPUXEUWQAGVOUWALANOWFVMZGLNOUCUEUXFVQZADUXFLUJALCGU
      WAKVAZUXHVPVMZVNZDUFAKDUSZUXKUXJDUSUOUOACDGHIKKCHVDZKTVRCIVDZKTVRUKVSVTWA
      ZWBZWCZWDZWEZAPWSUSUXDAPAPLWGZVOVBWHZVOUGAUXTUXSUSZUXTVOUSZURVDZLVAZUXTVH
      VCZURGVJZAURGLNOUEUCUIUXOAFGUSZGWTWIUMGFWJWKWLZWMZWAZWEZWNAPUTWIZUXDAUXTU
      TWIUYLAUXTAUTFLVAZUXTUTVOUSAWOWPAGVOFLUXPUMWQZUYIAUTFKVAZUYOVPVMZUYMVBAUY
      OAGVOFKAUXFGKNOUCUEUXGADUXFKUJUOWBWCZUMWQZAUYOQKVAZUTUPUQWRXAAUYGUYPVOUSU
      YMUYPVGUMAUYOUYOUYRUYRXBCFUXIUYPGLVOCFXCZCUYOUYOVPCFKTUYTXDZCVPXCZVUAXEUW
      AFVGZUXHUYOUXHUYOVPUWAFKXFZVUDXGUFXHXIXKZAUYFUYGUYMUXTVHVCZAUYAUYBUYFUYHX
      JZUMUYEVUFURFGUYCFVGUYDUYMUXTVHUYCFLXFXLXMXIXNZXOPUXTUTUGXPXQZWNZYAUXEUWT
      UWRUWQVPUXEUXDUWRVOUSZUWTUWRVGAUXDXRZAVUKUXDAPUYJVUIYBZWNCGUWRVOUWSUWSVQX
      SXIXTYCYDYEALDUSUWSDUSZUXBDUSUXNAVUKVUNVUMABCDUWRGULYFYGACDGHILUWSCUXLLUA
      VRCUXMUWSCGUWRYHVRUKVSVTYJAUWJUWOAUWIQLVAZPVLVMZUTPVLVMUTAQGUSZVUPVOUSUWI
      VUPVGUNAVUOPAGVOQLUXPUNWQUYJVUIYICQUXCVUPGMVOCQXCZCVUOPVLCQLUAVURXDCVLXCZ
      CPXCZXEUWAQVGZUWQVUOPVLUWAQLXFYKUHXHXIAVUOUTPVLAVUOUYSUYSVPVMZUTAVUQVVBVO
      USVUOVVBVGUNAUYSUYSAUYSUTVOUQWOYLZVVCXBCQUXIVVBGLVOVURCUYSUYSVPCQKTVURXDZ
      VUBVVDXEVVAUXHUYSUXHUYSVPUWAQKXFZVVEXGUFXHXIAVVBUTUTVPVMUTAUYSUTUYSUTVPUQ
      UQXGUTYMYNUUAUUBYKAPUYKVUIUUCUUDAUWNCGUBAUXDUWNUXEUWLUWMUXEUTUXCUWKVHUXEU
      WQVOUSZUTUWQVHVCPVOUSZUTPVBVCZUTUXCVHVCUXQUXEUTUXIUWQVHUXEUXHAGVOUWAKUYQW
      DZUUEUXEUXDUXIVOUSUWQUXIVGVULUXEUXHUXHVVIVVIXBCGUXIVOLUFXSXIXKAVVGUXDUYJW
      NZAVVHUXDAUTUXTPVBVUHUGYOZWNZUWQPUUFUUGUXEUXDUXCVOUSUWKUXCVGVULUXEUWQPUXQ
      VVJVUJYICGUXCVOMUHXSXIZXKUXEUWKUXCVIVHVVMUXEUXCVIVHVCZUWQVIVLVMZPVHVCZUXE
      VVOUWQPVHUXEUWQUXRUUHUXEUWQUXTPVHAUYFUXDUWQUXTVHVCZVUGUYEVVQURUWAGUYCUWAV
      GUYDUWQUXTVHUYCUWALXFXLXMUUIUGYOYPUXEVVFVVGVVHVIVOUSZUTVIVBVCZVVNVVPUUJUX
      QVVJVVLVVRUXEUULWPVVSUXEUUKWPUWQPVIUUMUUNUUOYPYTUVBUUPYTUWGUWPJMDUVMMVGZU
      VTUWJUWFUWOVVTUVSUWIUTQUVMMYQUUQVVTUWEUWNCGCUVMMSVRVVTUWCUWLUWDUWMVVTUWBU
      WKUTVHUWAUVMMYQZYRVVTUWBUWKVIVHVWAXLYSUURYSUUSUUTUDUVCAUTUYMPVLVMZUVKVBAU
      YMPUYNUYJVUEVVKUVAAUYGVWBVOUSUVKVWBVGUMAUYMPUYNUYJVUIYICFUXCVWBGMVOUYTCUY
      MPVLCFLUAUYTXDVUSVUTXEVUCUWQUYMPVLUWAFLXFYKUHXHXIXKUVJUVLUVRUVQUVJUVLVEJM
      EJMXCUVJUVLJJMERUVDUVLJUVEUVFVVTUVNUVJUVPUVLUVMMEUVGVVTUVOUVKUTVBFUVMMYQY
      RYSUVHUVIXI $.
  $}

  ${
    $d f i T $.  $d f A $.  $d f G $.  $d f i ph $.  $d h i t T $.  $d h A $.
    $d h t G $.  $d h i t Z $.  $d i t M $.
    stoweidlem37.1 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem37.2 $e |- P = ( t e. T |-> ( ( 1 / M ) x.
          sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) ) $.
    stoweidlem37.3 $e |- ( ph -> M e. NN ) $.
    stoweidlem37.4 $e |- ( ph -> G : ( 1 ... M ) --> Q ) $.
    stoweidlem37.5 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem37.6 $e |- ( ph -> Z e. T ) $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       of [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <=
       1, p_(t_0) = 0, and p > 0 on T - U. Z is used for t_0, P is used for p,
       ` ( G `` i ) ` is used for p_(t_i).  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem37 $p |- ( ph -> ( P ` Z ) = 0 ) $=
      ( c1 cc0 cfv cdiv co cfz cv csu cmul wcel wceq stoweidlem30 mpdan cle wbr
      wa wral fnvinran fveq1 eqeq1d breq2d breq1d anbi12d ralbidv elrab2 simprd
      sylib simpld sumeq2dv cfn cuz wss fzfi olc sumz mp2b syl6eq oveq2d nnne0d
      wo nncnd reccld mul01d 3eqtrd ) ALDUAZSKUBUCZSKUDUCZLIUEZJUAZUAZIUFZUGUCZ
      WDTUGUCTALFUHWCWJUIRABCDELFGHIJKLMNOPQUJUKAWITWDUGAWIWETIUFZTAWEWHTIAWFWE
      UHUNZWHTUIZTBUEZWGUAZULUMZWOSULUMZUNZBFUOZWLWGCUHZWMWSUNZWLWGEUHWTXAUNAWE
      EWFJPUPLHUEZUAZTUIZTWNXBUAZULUMZXESULUMZUNZBFUOZUNXAHWGCEXBWGUIZXDWMXIWSX
      JXCWHTLXBWGUQURXJXHWRBFXJXFWPXGWQXJXEWOTULWNXBWGUQZUSXJXEWOSULXKUTVAVBVAM
      VCVEVDVFVGWEVHUHZWESVIUAVJZXLVRWKTUISKVKXLXMVLWEISVMVNVOVPAWDAKAKOVSAKOVQ
      VTWAWB $.
  $}

  ${
    $d f i T $.  $d f A $.  $d f G $.  $d f i ph $.  $d h i t T $.  $d h A $.
    $d h t G $.  $d h Z $.  $d i t M $.  $d i S $.
    stoweidlem38.1 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem38.2 $e |- P = ( t e. T |->
          ( ( 1 / M ) x. sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) ) $.
    stoweidlem38.3 $e |- ( ph -> M e. NN ) $.
    stoweidlem38.4 $e |- ( ph -> G : ( 1 ... M ) --> Q ) $.
    stoweidlem38.5 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       of [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <=
       1, p_(t_0) = 0, and p > 0 on T - U. Z is used for t_0, P is used for p,
       ` ( G `` i ) ` is used for p_(t_i).  (Contributed by GlaucoSiliprandi,
       20-Apr-2017.) $)
    stoweidlem38 $p |- ( ( ph /\ S e. T ) ->
          ( 0 <_ ( P ` S ) /\ ( P ` S ) <_ 1 ) ) $=
      ( cle c1 wcel wa cc0 cfv wbr cdiv co cfz cv cmul cr nnrecred adantr fzfid
      csu stoweidlem15 simp1d an32s fsumrecl clt 1re 0le1 nnred nngt0d syl22anc
      a1i divge0 simp2d fsumge0 mulge0d stoweidlem30 breqtrrd simp3d wceq chash
      fsumle cfn ax-1cn fsumconst sylancl cn0 nnnn0d hashfz1 syl oveq1d mulid1d
      cc nncnd 3eqtrd breqtrd 0lt1 jca divgt0 syl21anc lemul2 syl112anc eqbrtrd
      wb mpbid wne w3a nnne0d 3jca divcan1 ) AFGUAZUBZUCFDUDZSUEXGTSUEXFUCTLUFU
      GZTLUHUGZFJUIZKUDUDZJUOZUJUGZXGSXFXHXLAXHUKUAZXEALPULUMZXFXIXKJXFTLUNZAXJ
      XIUAZXEXKUKUAZAXQUBXEUBZXRUCXKSUEZXKTSUEZABCEFGHIKXJLMNQRUPZUQURZUSZAUCXH
      SUEZXEATUKUAZUCTSUEZLUKUAZUCLUTUEZYEYFAVAVFYGAVBVFALPVCZALPVDZTLVGVEUMXFX
      IXKJXPYCAXQXEXTXSXRXTYAYBVHURVIVJABCDEFGHIJKLMNOPQRVKZVLXFXGXHLUJUGZTSXFX
      GXMYMSYLXFXLLSUEZXMYMSUEZXFXLXITJUOZLSXFXIXKTJXPYCYFXFXQUBVAVFAXQXEYAXSXR
      XTYAYBVMURVPAYPLVNXEAYPXIVOUDZTUJUGZLTUJUGLAXIVQUATWGUAZYPYRVNATLUNVRXITJ
      VSVTAYQLTUJALWAUAYQLVNALPWBLWCWDWEALALPWHZWFWIUMWJXFXLUKUAYHXNUCXHUTUEZYN
      YOWRYDAYHXEYJUMXOXFYFUCTUTUEZYHYIUBZUUAYFXFVAVFUUBXFWKVFAUUCXEAYHYIYJYKWL
      UMTLWMWNXLLXHWOWPWSWQXFYSLWGUAZLUCWTZXAZYMTVNAUUFXEAYSUUDUUEYSAVRVFYTALPX
      BXCUMTLXDWDWJWL $.
  $}

  ${
    $d b B $.  $d b T $.  $d b U $.  $d b ph $.  $d e h m t w $.
    $d e h t w A $.  $d e h t w E $.  $d e h w T $.  $d e h w U $.
    $d h i m r t v w x z $.  $d i t w x z A $.  $d i t w x z E $.
    $d i w x z T $.  $d i w x z U $.  $d i m v ph $.  $d w x z Y $.  $d x B $.
    stoweidlem39.1 $e |- F/ h ph $.
    stoweidlem39.2 $e |- F/ t ph $.
    stoweidlem39.3 $e |- F/ w ph $.
    stoweidlem39.4 $e |- U = ( T \ B ) $.
    stoweidlem39.5 $e |- Y = { h e. A | A. t e. T
          ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) } $.
    stoweidlem39.6 $e |- W = { w e. J | A. e e. RR+ E. h e. A
          ( A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) /\
          A. t e. w ( h ` t ) < e /\
                  A. t e. ( T \ U ) ( 1 - e ) < ( h ` t ) ) } $.
    stoweidlem39.7 $e |- ( ph -> r e. ( ~P W i^i Fin ) ) $.
    stoweidlem39.8 $e |- ( ph -> D C_ U. r ) $.
    stoweidlem39.9 $e |- ( ph -> D =/= (/) ) $.
    stoweidlem39.10 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem39.11 $e |- ( ph -> B C_ T ) $.
    stoweidlem39.12 $e |- ( ph -> W e. _V ) $.
    stoweidlem39.13 $e |- ( ph -> A e. _V ) $.
    $( This lemma is used to prove that there exists a function x as in the
       proof of Lemma 2 in [BrosowskiDeutsh] p. 91: assuming that ` r ` is a
       finite subset of ` W ` , ` x ` indexes a finite set of functions in the
       subalgebra (of the Stone Weierstrass theorem), such that for all i
       ranging in the finite indexing set, 0 &le; x_i &le; 1, x_i < &epsilon; /
       m on V(t_i), and x_i > 1 - &epsilon; / m on ` B ` .  Here ` D ` is used
       to represent A in the paper's Lemma 2 (because ` A ` is used for the
       subalgebra), ` M ` is used to represent m in the paper, ` E ` is used to
       represent &epsilon;, and v_i is used to represent V(t_i). ` W ` is just
       a local definition, used to shorten statements.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem39 $p |- ( ph -> E. m e. NN E. v ( v : ( 1 ... m ) --> W /\
      D C_ U. ran v /\ E. x ( x : ( 1 ... m ) --> Y /\
      A. i e. ( 1 ... m ) ( A. t e. ( v ` i ) ( ( x ` i ) ` t ) < ( E / m ) /\
      A. t e. B ( 1 - ( E / m ) ) < ( ( x ` i ) ` t ) ) ) ) ) $=
      ( vb c1 cv cfz co wf1o wex cn wrex wf crn cuni wss cfv cdiv clt wral cmin
      wbr wa w3a chash wcel c0 wceq wne jca ssn0 unieq uni0 syl6eq necon3i 3syl
      wn neneqd cfn wo wi cpw cin simprbi syl fz1f1o pm2.53 mpd wb oveq2 f1oeq2
      elin exbidv rspcev f1of adantl simpll simplbi elpwid fss syl2anc ad2antrr
      wfn ccnv wfun dff1o2 simp3bi unieqd sseqtr4d cc0 cdif crab cmpt nfan eqid
      cle nfv simplr simpr sselda notnot1 intnand eldif eleq2i eldifd ralrimiva
      crp sylnibr dfss3 sylibr cvv mptfi rnfi stoweidlem31 3jca eximdv reximdva
      ex ) AUNNUOZUPUQZSUOZDUOZURZDUSZNUTVAZUUIQUUKVBZHUUKVCZVDZVEZUUIRBUOZVBEU
      OZMUOZUUSVFVFZOUUHVGUQZVHVKEUVAUUKVFVIUNUVCVJUQZUVBVHVKEGVIVLMUUIVIVLBUSZ
      VMZDUSZNUTVAAUUJVNVFZUTVOUNUVHUPUQZUUJUUKURZDUSZVLZUUNAUUJVPVQZWFZUVLAUUJ
      VPAHUUJVDZVEZHVPVRZVLUVOVPVRUUJVPVRAUVPUVQUGUHVSHUVOVTUUJVPUVOVPUVMUVOVPV
      DVPUUJVPWAWBWCWDWEWGAUUJWHVOZUVMUVLWIUVNUVLWJAUUJQWKZWHWLVOZUVRUFUVTUUJUV
      SVOZUVRUUJUVSWHXAZWMWNZUUJDWOUVMUVLWPWEWQUUMUVKNUVHUTUUHUVHVQZUULUVJDUWDU
      UIUVIVQUULUVJWRUUHUVHUNUPWSUUIUVIUUJUUKWTWNXBXCWNAUUMUVGNUTAUUHUTVOZVLZUU
      LUVFDUWFUULUVFUWFUULVLZUUOUURUVEUWGUUIUUJUUKVBZUUJQVEZUUOUULUWHUWFUUIUUJU
      UKXDXEUWGAUVTUWIAUWEUULXFUFUVTUUJQUVTUWAUVRUWBXGXHWEZUUIUUJQUUKXIXJUWGHUV
      OUUQAUVPUWEUULUGXKUULUUQUVOVQUWFUULUUPUUJUULUUKUUIXLUUKXMXNUUPUUJVQUUIUUJ
      UUKXOXPXQXEXRUWGBCDEFGUUJIJKLMOCUUJXSUUTLUOVFZYEVKUWKUNYEVKVLEIVIUWKUVCVH
      VKECUOVIUVDUWKVHVKEIJXTZVIVMLFYAZYBZPUUHQRUWFUULLAUWELTUWELYFYCUULLYFYCUW
      FUULEAUWEEUAUWEEYFYCUULEYFYCUWFUULCAUWECUBUWECYFYCUULCYFYCUDUEUWNYDUWJAUW
      EUULYGUWFUULYHAOYPVOUWEUULUIXKAGUWLVEZUWEUULAUMUOZUWLVOZUMGVIUWOAUWQUMGAU
      WPGVOZVLZUWPIJAGIUWPUJYIUWSUWPIGXTZVOZUWPJVOUWSUWPIVOZUWRWFZVLZUXAUWRUXDW
      FAUWRUXCUXBUWRYJYKXEUWPIGYLYQJUWTUWPUCYMYQYNYOUMGUWLYRYSXKAQYTVOUWEUULUKX
      KAFYTVOUWEUULULXKUWGUVRUWNWHVOUWNVCWHVOAUVRUWEUULUWCXKCUUJUWMUUAUWNUUBWEU
      UCUUDUUGUUEUUFWQ $.
  $}

  ${
    $d f g t z A $.  $d f g z F $.  $d f g z G $.  $d f g z H $.  $d f g z P $.
    $d f g t z T $.  $d f g ph $.  $d t x A $.  $d t M $.  $d t N $.  $d x T $.
    $d x ph $.
    stoweidlem40.1 $e |- F/_ t P $.
    stoweidlem40.2 $e |- F/ t ph $.
    stoweidlem40.3 $e |- Q = ( t e. T |->
          ( ( 1 - ( ( P ` t ) ^ N ) ) ^ M ) ) $.
    stoweidlem40.4 $e |- F = ( t e. T |-> ( 1 - ( ( P ` t ) ^ N ) ) ) $.
    stoweidlem40.5 $e |- G = ( t e. T |-> 1 ) $.
    stoweidlem40.6 $e |- H = ( t e. T |-> ( ( P ` t ) ^ N ) ) $.
    stoweidlem40.7 $e |- ( ph -> P e. A ) $.
    stoweidlem40.8 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem40.9 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem40.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem40.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem40.12 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem40.13 $e |- ( ph -> N e. NN ) $.
    stoweidlem40.14 $e |- ( ph -> M e. NN ) $.
    $( This lemma proves that q_n is in the subalgebra, as in the proof of
       Lemma 1 in [BrosowskiDeutsh] p. 90.  Q is used to represent q_n in the
       paper, N is used to represent n in the paper, and M is used to represent
       k^n in the paper.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem40 $p |- ( ph -> Q e. A ) $=
      ( cv cfv cexp co cmpt c1 cmin wcel wa cr wceq 1re a1i fnvinran cn0 nnnn0d
      simpr adantr reexpcld resubcld fvmpt2 syl2anc eqcomd oveq1d syl5eq nfmpt1
      mpteq2da nfcxfr adantl oveq12d stoweidlem4 syl5eqel stoweidlem19 mpd3an23
      mpan2 stoweidlem33 eqeltrd ) AFCGCUIZJUJZMUKULZUMZDAFCGUNWFEUJZNUKULZUOUL
      ZMUKULZUMWIQACGWMWHPAWFGUPZUQZWLWGMUKWOWGWLWOWNWLURUPWGWLUSAWNVEZWOUNWKUN
      URUPZWOUTVAWOWJNAGURWFEUBVBANVCUPWNANUGVDZVFVGZVHCGWLURJRVIVJVKVLVOVMABCD
      GHIJMCJCGWLUMZRCGWLVNVPPUCUEUFAJCGWFKUJZWFLUJZUOULZUMZDAJWTXDRACGWLXCPWOU
      NXAWKXBUOWNUNXAUSAWNXAUNWNWQXAUNUSUTCGUNURKSVIWCVKVQWOXBWKWOWNWKURUPXBWKU
      SWPWSCGWKURLTVIVJVKVRVOVMAKDUPLDUPXDDUPAKCGUNUMZDSAWQXEDUPUTABCDUNGUFVSWC
      VTALCGWKUMZDTABCDGHIENOPUCUEUFUAWRWAVTABCDGHIKLCKXESCGUNVNVPCLXFTCGWKVNVP
      PUCUDUEUFWDWBWEAMUHVDWAWE $.
  $}

  ${
    $d f g t y z $.  $d f g t z A $.  $d f g z F $.  $d f g t z T $.
    $d f g ph $.  $d t w A $.  $d t x z A $.  $d w T $.  $d w ph $.  $d x E $.
    $d x z T $.  $d x U $.  $d x V $.  $d x z X $.
    stoweidlem41.1 $e |- F/ t ph $.
    stoweidlem41.2 $e |- X = ( t e. T |-> ( 1 - ( y ` t ) ) ) $.
    stoweidlem41.3 $e |- F = ( t e. T |-> 1 ) $.
    stoweidlem41.4 $e |- V C_ T $.
    stoweidlem41.5 $e |- ( ph -> y e. A ) $.
    stoweidlem41.6 $e |- ( ph -> y : T --> RR ) $.
    stoweidlem41.7 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem41.8 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem41.9 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem41.10 $e |- ( ( ph /\ w e. RR ) -> ( t e. T |-> w ) e. A ) $.
    stoweidlem41.11 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem41.12 $e |- ( ph ->
          A. t e. T ( 0 <_ ( y ` t ) /\ ( y ` t ) <_ 1 ) ) $.
    stoweidlem41.13 $e |- ( ph -> A. t e. V ( 1 - E ) < ( y ` t ) ) $.
    stoweidlem41.14 $e |- ( ph -> A. t e. ( T \ U ) ( y ` t ) < E ) $.
    $( This lemma is used to prove that there exists x as in Lemma 1 of
       [BrosowskiDeutsh] p. 90: 0 <= x(t) <= 1 for all t in T, x(t) < epsilon
       for all t in V, x(t) > 1 - epsilon for all t in T \ U. Here we prove the
       very last step of the proof of Lemma 1:  "The result follows from taking
       x = 1 - q_n".  Here ` E ` is used to represent &epsilon; in the paper,
       and ` y ` to represent q_n in the paper.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem41 $p |- ( ph -> E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\
          ( x ` t ) <_ 1 ) /\ A. t e. V ( x ` t ) < E /\
          A. t e. ( T \ U ) ( 1 - E ) < ( x ` t ) ) ) $=
      ( wcel cc0 cv cfv cle wbr c1 wa wral clt cmin cdif w3a wrex cmpt wceq 1re
      co fvmpt2 mpan2 adantl oveq1d mpteq2da stoweidlem4 syl5eqel nfmpt1 nfcxfr
      cr syl6eqr nfcv stoweidlem33 mpd3an23 eqeltrrd fnvinran a1i simprd ax-1cn
      r19.21bi subid1i syl6breqr lesubd simpr resubcld breqtrrd simpld lesub2dd
      0re syl2anc syl6breq eqbrtrd jca ralrimi sseli sylan2 rpred adantr eldifi
      ex ltsub23d ltsub2dd nfeq2 fveq1 breq2d breq1d anbi12d 3anbi123d syl13anc
      ralbid rspcev ) ANFUIUJEUKZNULZUMUNZXSUOUMUNZUPZEGUQZXSKURUNZEMUQZUOKUSVF
      ZXSURUNZEGHUTZUQZUJXRBUKZULZUMUNZYKUOUMUNZUPZEGUQZYKKURUNZEMUQZYFYKURUNZE
      YHUQZVAZBFVBAEGXRLULZXRCUKZULZUSVFZVCZNFAUUEEGUOUUCUSVFZVCZNAEGUUDUUFOAXR
      GUIZUPZUUAUOUUCUSUUHUUAUOVDZAUUHUOVPUIZUUJVEEGUOVPLQVGVHVIVJVKPVQALFUIUUB
      FUIUUEFUIALEGUOVCZFQAUUKUULFUIVEADEFUOGUDVLVHVMSADEFGIJLUUBELUULQEGUOVNVO
      EUUBVROUAUBUCUDVSVTWAAYBEGOAUUHYBUUIXTYAUUIUJUUFXSUMUUIUUCUOUJAGVPXRUUBTW
      BZUUKUUIVEWCZUJVPUIUUIWOWCZUUIUUCUOUOUJUSVFZUMUUIUJUUCUMUNZUUCUOUMUNZAUUQ
      UURUPEGUFWFZWDUOWEWGZWHWIUUIUUHUUFVPUIXSUUFVDZAUUHWJUUIUOUUCUUNUUMWKEGUUF
      VPNPVGWPZWLUUIXSUUFUOUMUVBUUIUUFUUPUOUMUUIUJUUCUOUUOUUMUUNUUIUUQUURUUSWMW
      NUUTWQWRWSXFWTAYDEMOAXRMUIZYDAUVCUPZXSUUFKURUVCAUUHUVAMGXRRXAZUVBXBUVDUOK
      UUCUUKUVDVEWCAKVPUIZUVCAKUEXCZXDUVCAUUHUUCVPUIZUVEUUMXBAYFUUCURUNEMUGWFXG
      WRXFWTAYGEYHOAXRYHUIZYGAUVIUPZYFUUFXSURUVJUUCKUOUVIAUUHUVHXRGHXEZUUMXBAUV
      FUVIUVGXDUUKUVJVEWCAUUCKURUNEYHUHWFXHUVIAUUHUVAUVKUVBXBWLXFWTYTYCYEYIVABN
      FYJNVDZYOYCYQYEYSYIUVLYNYBEGEYJNENUUGPEGUUFVNVOXIZUVLYLXTYMYAUVLYKXSUJUMX
      RYJNXJZXKUVLYKXSUOUMUVNXLXMXPUVLYPYDEMUVMUVLYKXSKURUVNXLXPUVLYRYGEYHUVMUV
      LYKXSYFURUVNXKXPXNXQXO $.
  $}

  ${
    $d a i t z $.  $d a j t $.  $d a i B $.  $d a j F $.  $d a i z M $.
    $d a j ph $.  $d f g t z T $.  $d f i t z T $.  $d f g z F $.
    $d f g z M $.  $d f g t z U $.  $d f g z Y $.  $d f g ph $.  $d i z E $.
    $d i t z U $.  $d j B $.  $d z P $.
    stoweidlem42.1 $e |- F/ i ph $.
    stoweidlem42.2 $e |- F/ t ph $.
    stoweidlem42.3 $e |- F/_ t Y $.
    stoweidlem42.4 $e |- P = ( f e. Y , g e. Y |-> ( t e. T |-> ( ( f ` t )
                           x. ( g ` t ) ) ) ) $.
    stoweidlem42.5 $e |- X = ( seq 1 ( P , U ) ` M ) $.
    stoweidlem42.6 $e |- F = ( t e. T |-> ( i e. ( 1 ... M ) |-> ( ( U ` i )
                           ` t ) ) ) $.
    stoweidlem42.7 $e |- Z = ( t e. T |-> ( seq 1 ( x. , ( F ` t ) ) ` M ) )
$.
    stoweidlem42.8 $e |- ( ph -> M e. NN ) $.
    stoweidlem42.9 $e |- ( ph -> U : ( 1 ... M ) --> Y ) $.
    stoweidlem42.10 $e |- ( ( ph /\ i e. ( 1 ... M ) ) -> A. t e. B ( 1 - ( E
                            / M ) ) < ( ( U ` i ) ` t ) ) $.
    stoweidlem42.11 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem42.12 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    stoweidlem42.13 $e |- ( ( ph /\ f e. Y ) -> f : T --> RR ) $.
    stoweidlem42.14 $e |- ( ( ph /\ f e. Y /\ g e. Y ) -> ( t e. T |-> ( ( f
                            ` t ) x. ( g ` t ) ) ) e. Y ) $.
    stoweidlem42.15 $e |- ( ph -> T e. _V ) $.
    stoweidlem42.16 $e |- ( ph -> B C_ T ) $.
    $( This lemma is used to prove that ` x ` built as in Lemma 2 of
       [BrosowskiDeutsh] p. 91, is such that x > 1 - &epsilon; on B. Here ` X `
       is used to represent ` x ` in the paper, and E is used to represent
       &epsilon; in the paper.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem42 $p |- ( ph -> A. t e. B ( 1 - E ) < ( X ` t ) ) $=
      ( va vj c1 cmin co cv cfv clt wbr wcel wa cmul cseq cdiv cr 1re a1i rpred
      cexp resubcld adantr nndivred cn0 nnnn0d reexpcld cuz cn elnnuz sylib cfz
      nfv nfan cmpt nfcv nfmpt1 nfmpt nfcxfr nffv nfel1 nfim eleq1 anbi2d fveq2
      wi wceq eleq1d imbi12d cvv sselda ovex mptexg fvmpt2 syl2anc fveq1d simpr
      mp1i fnvinran simpl feq1 vtoclga sylc adantlr ffvelrnd eqid eqtrd eqeltrd
      wf jca chvar remulcl adantl cneg caddc eqcomd oveq2d cc ax-1cn negsubd c3
      cle cc0 wne wb mpbid lediv2 breqtrd eqbrtrd breqtrrd lelttrd seqcl nnne0d
      rpcnd nncnd divcan1d divcld mulcld mulneg1d 3eqtr2d renegcld 3re rereccld
      nnred 3ne0 1lt3 0lt1 ltdiv2 syl222anc div1i syl6breq lttrd nnge1d ltletrd
      ltled rpregt0d nngt0d syl121anc rpcnne0d divid syl lenegd bernneq syl3anc
      oveq1d fmptdf feq1d mpbird r19.21bi an32s crp addid2d syl221anc div1d 0re
      3pos ltaddsubd elrpd stoweidlem3 fmuldfeq ex ralrimi ) AUNJUOUPZBUQZMURZU
      SUTZBCQAUWMCVAZUWOAUWPVBZUWLUWMOURZUWNUSUWQUWLLVCUWMKURZUNVDZURZUWRUSUWQU
      WLUNJLVEUPZUOUPZLVJUPZUXAAUWLVFVAUWPAUNJUNVFVAZAVGVHZAJUFVIZVKVLUWQUXCLAU
      XCVFVAUWPAUNUXBUXFAJLUXGUCVMZVKZVLALVNVAZUWPALUCVOZVLVPUWQULUMVCVFUWSUNLA
      LUNVQURVAZUWPALVRVAZUXLUCLVSVTVLUWQIUQZUNLWAUPZVAZVBZUXNUWSURZVFVAZWOUWQU
      LUQZUXOVAZVBZUXTUWSURZVFVAZWOIULUYBUYDIUWQUYAIAUWPIPUWPIWBWCZUYAIWBWCIUYC
      VFIUXTUWSIUWMKIKBEIUXOUWMUXNFURZURZWDZWDUAIBEUYHIEWEIUXOUYGWFWGWHIUWMWEWI
      ZIUXTWEWIWJWKUXNUXTWPZUXQUYBUXSUYDUYJUXPUYAUWQUXNUXTUXOWLWMUYJUXRUYCVFUXN
      UXTUWSWNWQWRUXQUXRUYGVFUXQUXRUXNUYHURZUYGUWQUXRUYKWPUXPUWQUXNUWSUYHUWQUWM
      EVAZUYHWSVAZUWSUYHWPACEUWMUKWTZUXOWSVAUYMUWQUNLWAXAIUXOUYGWSXBXGBEUYHWSKU
      AXCXDZXEVLUXQUXPUYGVFVAUYKUYGWPUWQUXPXFUXQEVFUWMUYFAUXPEVFUYFXRZUWPAUXPVB
      ZUYFNVAZAUYRVBZUYPAUXONUXNFUDXHZUYQAUYRAUXPXIUYTXSAGUQZNVAZVBZEVFVUAXRZWO
      ZUYSUYPWOGUYFNVUAUYFWPZVUCUYSVUDUYPVUFVUBUYRAVUAUYFNWLWMEVFVUAUYFXJWRVUEV
      UBUHVHXKXLXMUWQUYLUXPUYNVLXNZIUXOUYGVFUYHUYHXOZXCXDXPZVUGXQXTUXTVFVAUMUQZ
      VFVAVBUXTVUJVCUPVFVAUWQUXTVUJYAYBUUAZAUWLUXDYKUTUWPAUWLUNUXBYCZLVCUPZYDUP
      ZUXDYKAUWLUNUXBLVCUPZUOUPUNVUOYCZYDUPVUNAJVUOUNUOAVUOJAJLAJUFUUCZALUCUUDZ
      ALUCUUBZUUEYEYFAUNVUOUNYGVAAYHVHZAUXBLAJLVUQVURVUSUUFZVURUUGYIAVUPVUMUNYD
      AVUMVUPAUXBLVVAVURUUHYEYFUUIAVUNUNVULYDUPZLVJUPZUXDYKAVULVFVAUXJUNYCVULYK
      UTZVUNVVCYKUTAUXBUXHUUJUXKAUXBUNYKUTVVDAUXBJJVEUPZUNYKAJLYKUTZUXBVVEYKUTZ
      AJLUXGALUCUUMZAJUNLUXGUXFVVHAJUNYJVEUPZUNUXGAYJYJVFVAZAUUKVHZYJYLYMAUUNVH
      UULUXFUGAVVIUNUNVEUPZUNUSAUNYJUSUTZVVIVVLUSUTZVVMAUUOVHAUXEYLUNUSUTZVVJYL
      YJUSUTZUXEVVOVVMVVNYNUXFVVOAUUPVHZVVKVVPAUWEVHUXFVVQUNYJUNUUQUURYOUNYHUUS
      UUTUVAZALUCUVBZUVCUVDAJVFVAYLJUSUTVBZLVFVAZYLLUSUTZVVTVVFVVGYNAJUFUVEZVVH
      ALUCUVFZVWCJLJYPUVGYOAJYGVAJYLYMVBVVEUNWPAJUFUVHJUVIUVJYQAUXBUNUXHUXFUVKY
      OVULLUVLUVMAVVBUXCLVJAUNUXBVUTVVAYIUVNYQYRVLUWQUXCIUWSLUWTUYIUYEUWTXOAUXM
      UWPUCVLUWQUXOVFUWSXRUXOVFUYHXRUWQIUXOUYGVFUYHUYEVUGVUHUVOUWQUXOVFUWSUYHUY
      OUVPUVQUXQUXCUYGUXRUSAUXPUWPUXCUYGUSUTZUYQVWEBCUEUVRUVSVUIYSAUXCUVTVAUWPA
      UXCUXIAYLUXBYDUPZUNUSUTYLUXCUSUTAVWFUXBUNUSAUXBVVAUWAAUXBJUNUXHUXGUXFAUXB
      JUNVEUPZJYKAUNLYKUTZUXBVWGYKUTZVVSAUXEVVOVWAVWBVVTVWHVWIYNUXFVVQVVHVWDVWC
      UNLJYPUWBYOAJVUQUWCYQVVRYTYRAYLUXBUNYLVFVAAUWDVHUXHUXFUWFYOUWGVLUWHYTUWQU
      YLUXAVFVAUWRUXAWPUYNVUKBEUXAVFOUBXCXDYSUWQAUYLUWNUWRWPAUWPXIUYNABDEFGHIKL
      MNOPRSTUAUBUJUCUDUHUIUWIXDYSUWJUWK $.
  $}

  ${
    $d f g l t A $.  $d f h s t T $.  $d f k l s t T $.  $d f g r t A $.
    $d f g t x A $.  $d f Q $.  $d f g l t S $.  $d f g l t Z $.
    $d f k l ph $.  $d h t A $.  $d h t S $.  $d h t Z $.  $d k l t A $.
    $d k l t S $.  $d k l t Z $.  $d r s t T $.  $d r t S $.  $d r ph $.
    $d s t x T $.  $d t z $.  $d x S $.  $d x Z $.  $d x ph $.
    stoweidlem43.1 $e |- F/ g ph $.
    stoweidlem43.2 $e |- F/ t ph $.
    stoweidlem43.3 $e |- F/_ h Q $.
    stoweidlem43.4 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem43.5 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem43.6 $e |- T = U. J $.
    stoweidlem43.7 $e |- ( ph -> J e. Comp ) $.
    stoweidlem43.8 $e |- ( ph -> A C_ ( J Cn K ) ) $.
    stoweidlem43.9 $e |- ( ( ph /\ f e. A /\ l e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( l ` t ) ) ) e. A ) $.
    stoweidlem43.10 $e |- ( ( ph /\ f e. A /\ l e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( l ` t ) ) ) e. A ) $.
    stoweidlem43.11 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem43.12 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. g e. A ( g ` r ) =/= ( g ` t ) ) $.
    stoweidlem43.13 $e |- ( ph -> U e. J ) $.
    stoweidlem43.14 $e |- ( ph -> Z e. U ) $.
    stoweidlem43.15 $e |- ( ph -> S e. ( T \ U ) ) $.
    $( This lemma is used to prove the existence of a function p_t as in Lemma
       1 of [BrosowskiDeutsh] p. 90 (at the beginning of Lemma 1): for all t in
       T - U, there exists a function p_t in the subalgebra, such that p_t(
       t_0 ) = 0 , p_t ( t ) > 0, and 0 <= p_t <= 1.  Hera Z is used for t_0 ,
       S is used for t e.  T - U , h is used for p_t.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem43 $p |- ( ph -> E. h ( h e. Q /\ 0 < ( h ` S ) ) ) $=
      ( vk vs cv wcel cfv wne cc0 wceq w3a wex clt wbr nfv eldifad cuni syl2anc
      wa elunii syl6eleqr eldifbd nelne2 necomd 3jca wrex simpr2 nfcv nfan nfim
      wn eleq1 neeq2 3anbi23d anbi2d fveq2 neeq2d rexbidv simpr1 neeq1 3anbi13d
      wi imbi12d neeq1d vtoclga mpcom vtoclgf df-rex sylib mpdan cmin cmpt eqid
      a1i co cr wf ccn sselda fcnre adantlr caddc 3adant1r adantr simprl simprr
      stoweidlem23 neeq12d eqeq1d 3anbi123d spcegv 3ad2ant1 pm2.43i syl exlimdd
      fveq1 cmul crn csup cdiv nfmpt1 weq oveq12d cbvmptv ccmp 3anbi2d mpteq2dv
      wss oveq1d eleq1d chvarv simpr3 stoweidlem36 ex exlimdv mpd ) AIUNZDUOZFU
      UFUPZNUUFUPZUQZUUIURUSZUTZIVAZKUNZEUOURFUUNUPVBVCVHKVAZAJUNZDUOZFUUPUPZNU
      UPUPZUQZVHZUUMJQUUMJVDAFGUOZNGUOZFNUQZUTZUVAJVAZAUVBUVCUVDAFGHUKVEZANLVFZ
      GANHUOZHLUONUVHUOUJUINHLVIVGUBVJZANFAUVIFHUOVTNFUQUJAFGHUKVKNFHVLVGVMVNAU
      VEVHZUUTJDVOZUVFUVCUVKUVLAUVBUVCUVDVPAUVBCUNZGUOZFUVMUQZUTZVHZUURUVMUUPUP
      ZUQZJDVOZWKZUVKUVLWKCNGCNVQUVKUVLCAUVECRUVECVDVRUVLCVDVSUVMNUSZUVQUVKUVTU
      VLUWBUVPUVEAUWBUVNUVCUVOUVDUVBUVMNGWAUVMNFWBWCWDUWBUVSUUTJDUWBUVRUUSUURUV
      MNUUPWEWFWGWLUVBUVQUVTAUVBUVNUVOWHAOUNZGUOZUVNUWCUVMUQZUTZVHZUWCUUPUPZUVR
      UQZJDVOZWKZUWAOFGUWCFUSZUWGUVQUWJUVTUWLUWFUVPAUWLUWDUVBUWEUVOUVNUWCFGWAUW
      CFUVMWIWJWDUWLUWIUVSJDUWLUWHUURUVRUWCFUUPWEWMWGWLUWKUWDUHXCWNWOWPWOUUTJDW
      QWRWSAUVAVHZCGUVRUUSWTXDXAZDUOZFUWNUPZNUWNUPZUQZUWQURUSZUTZUUMUWMBCDFGIPU
      UPUWNNAUVACRUVACVDVRCUUPVQUWNXBAUUGGXEUUFXFUVAAUUGVHLMXGXDZGUUFLMTUBUXAXB
      ADUXAUUFUDXHXIXJAUUGPUNZDUOZCGUVMUUFUPZUVMUXBUPZXKXDXADUOUVAUEXLABUNZXEUO
      ZCGUXFXADUOZUVAUGXJAUVBUVAUVGXMAUVCUVAUVJXMAUUQUUTXNAUUQUUTXOXPUWTUUMUWOU
      WRUWTUUMWKUWSUULUWTIUWNDUUFUWNUSZUUGUWOUUJUWRUUKUWSUUFUWNDWAUXIUUHUWPUUIU
      WQFUUFUWNYENUUFUWNYEZXQUXIUUIUWQURUXJXRXSXTYAYBYCYDAUULUUOIAUULUUOAUULVHB
      CDEFGULPKUUFUMGUMUNZUUFUPZUXLYFXDZXAZCGUVMUXNUPUXNYGXEVBYHZYIXDZXAZLMUXON
      SCGUXPYJCUUFVQCUXNVQAUULCRUULCVDVRTUAUBUMCGUXMUXDUXDYFXDUMCYKUXLUXDUXLUXD
      YFUXKUVMUUFWEZUXRYLYMUXOXBUXQXBALYNUOUULUCXMADUXAYQUULUDXMAULUNZDUOZUXCCG
      UVMUXSUPZUXEYFXDZXAZDUOZUULAUUGUXCUTZCGUXDUXEYFXDZXAZDUOZWKAUXTUXCUTZUYDW
      KIULIULYKZUYEUYIUYHUYDUYJUUGUXTAUXCUUFUXSDWAYOUYJUYGUYCDUYJCGUYFUYBUYJUXD
      UYAUXEYFUVMUUFUXSYEYRYPYSWLUFYTXLAUXGUXHUULUGXJAUVBUULUVGXMAUVCUULUVJXMAU
      UGUUJUUKWHAUUGUUJUUKVPAUUGUUJUUKUUAUUBUUCUUDUUE $.
  $}

  ${
    $d f g i t G $.  $d f i j t G $.  $d f g A $.  $d f g i t M $.
    $d f g i t T $.  $d f g i ph $.  $d h i j t G $.  $d h A $.
    $d h i j t T $.  $d h i t Z $.  $d j t x M $.  $d j U $.  $d p t T $.
    $d p A $.  $d p P $.  $d p U $.  $d p t Z $.  $d x A $.  $d x T $.
    $d x ph $.
    stoweidlem44.1 $e |- F/ j ph $.
    stoweidlem44.2 $e |- F/ t ph $.
    stoweidlem44.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem44.4 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem44.5 $e |- P = ( t e. T |->
          ( ( 1 / M ) x. sum_ i e. ( 1 ... M ) ( ( G ` i ) ` t ) ) ) $.
    stoweidlem44.6 $e |- ( ph -> M e. NN ) $.
    stoweidlem44.7 $e |- ( ph -> G : ( 1 ... M ) --> Q ) $.
    stoweidlem44.8 $e |- ( ph -> A. t e. ( T \ U ) E. j e. ( 1 ... M ) 0 <
          ( ( G ` j ) ` t ) ) $.
    stoweidlem44.9 $e |- T = U. J $.
    stoweidlem44.10 $e |- ( ph -> A C_ ( J Cn K ) ) $.
    stoweidlem44.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem44.12 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem44.13 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem44.14 $e |- ( ph -> Z e. T ) $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       of [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <=
       1, p_(t_0) = 0, and p > 0 on T - U. Z is used to represent t_0 in the
       paper.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem44 $p |- ( ph -> E. p e. A ( A. t e. T
          ( 0 <_ ( p ` t ) /\ ( p ` t ) <_ 1 ) /\ ( p ` Z ) = 0 /\
          A. t e. ( T \ U ) 0 < ( p ` t ) ) ) $=
      ( cv wcel cc0 cfv cle wbr c1 wral wceq clt cdif w3a wex wrex cfz csu cmpt
      wa co cdiv eqid nnrecred wf wss crab ssrab2 eqsstri fss sylancl ccn fcnre
      sselda stoweidlem32 stoweidlem38 ex ralrimi stoweidlem37 cmul nfan df-rex
      r19.21bi sylib cr ad2antrr simpll eldifi adantl adantr fzfid stoweidlem15
      nfv an32s simp1d fsumrecl syl2anc nnred nngt0d recgt0d csn 0re a1i simprl
      caddc 3jca snfi simpl1 simpl3 elsni simpl2 eqeltrd syl21anc readdcld fzfi
      cfn syl diffi sylan2 recnd breqtrrd 3adant2 wn wi cun fveq1 breq2d ralbid
      anbi12d mp1i 00id simprr cc fveq2 fveq1d ltadd2dd syl5eqbrr simplr simp2d
      sumsn fsumge0 leadd1dd ltletrd cin c0 eldifn imnan mpbi elin mtbir mpgbir
      eq0 undif1 snssi 3ad2ant2 ssequn2 syl5req 3adantl2 fsumsplit stoweidlem30
      mulgt0d exlimdd eleq1 nfmpt1 nfcxfr breq1d eqeq1d 3anbi123d spcegv mp2and
      nfeq2 sylibr ) ASUNZDUOZUPCUNZUWDUQZURUSZUWGUTURUSZVKZCGVAZRUWDUQZUPVBZUP
      UWGVCUSZCGHVDZVAZVEZVKZSVFZUWQSDVGAEDUOZUPUWFEUQZURUSZUXAUTURUSZVKZCGVAZR
      EUQZUPVBZUPUXAVCUSZCUWOVAZVEZUWSABCDEGIJLCGUTQVHVLZUWFLUNZNUQZUQZLVIZVJZN
      CGUTQVMVLZVJZQUXQUAUDUXPVNUXRVNUEAQUEVOZAUXKFNVPFDVQUXKDNVPUFFRKUNZUQUPVB
      UPUWFUXTUQZURUSUYAUTURUSVKCGVAVKZKDVRDUCUYBKDVSVTUXKFDNWAWBUJUKULAIUNZDUO
      VKOPWCVLZGUYCOPUBUHUYDVNADUYDUYCUIWEWDZWFZAUXEUXGUXIAUXDCGUAAUWFGUOZUXDAC
      DEFUWFGIKLNQRUCUDUEUFUYEWGWHWIACDEFGIKLNQRUCUDUEUFUYEUMWJAUXHCUWOUAAUWFUW
      OUOZUXHAUYHVKZUPUXQUXOWKVLZUXAVCUYIMUNZUXKUOZUPUWFUYKNUQZUQZVCUSZVKZUPUYJ
      VCUSZMAUYHMTUYHMXDWLUYQMXDUYIUYOMUXKVGZUYPMVFAUYRCUWOUGWNUYOMUXKWMWOUYIUY
      PVKZUXQUXOAUXQWPUOUYHUYPUXSWQUYSAUYGUXOWPUOAUYHUYPWRZUYIUYGUYPUYHUYGAUWFG
      HWSZWTXAZAUYGVKZUXKUXNLVUCUTQXBVUCUXLUXKUOZVKUXNWPUOZUPUXNURUSZUXNUTURUSZ
      AVUDUYGVUEVUFVUGVEZACDFUWFGIKNUXLQRUCUFUYEXCZXEXFZXGXHAUPUXQVCUSUYHUYPAQA
      QUEXIAQUEXJXKWQUYSUPUXKUYKXLZVDZUXNLVIZVUKUXNLVIZXPVLZUXOVCUYSUPUPVUNXPVL
      ZVUOUPWPUOZUYSXMXNZUYSUPVUNVURUYSAUYLUYGVEZVUNWPUOUYSAUYLUYGUYTUYIUYLUYOX
      OZVUBXQZVUSVUKUXNLVUKYGUOVUSUYKXRXNVUSUXLVUKUOZVKZAUYGVUDVUEAUYLUYGVVBXSA
      UYLUYGVVBXTVVCUXLUYKUXKVVBUXLUYKVBZVUSUXLUYKYAWTAUYLUYGVVBYBYCVUJYDXGZYHZ
      YEUYSVUMVUNUYSAUYGVUMWPUOZUYTVUBVUCVULUXNLUXKYGUOVULYGUOVUCUTQYFUXKVUKYIU
      UAZUXLVULUOZVUCVUDVUEUXLUXKVUKWSZVUJYJZXGZXHVVFYEUYSUPUPUPXPVLVUPVCUUBUYS
      UPVUNUPVURVVFVURUYSUPUYNVUNVCUYIUYLUYOUUCUYSUYLUYNUUDUOVUNUYNVBVUTUYSUYNU
      YSAUYLUYGUYNWPUOZUYTVUTVUBAUYLVKUYGVKVVMUPUYNURUSUYNUTURUSACDFUWFGIKNUYKQ
      RUCUFUYEXCXFYDYKUXNUYNLUYKUXKVVDUWFUXMUYMUXLUYKNUUEUUFUUKXHYLUUGUUHUYSVUS
      VUPVUOURUSVVAVUSUPVUMVUNVUQVUSXMXNAUYGVVGUYLVVLYMVVEAUYGUPVUMURUSUYLVUCVU
      LUXNLVVHVVKVUCVVIVKZVUEVUFVUGVVNAVUDUYGVUHAUYGVVIWRVVIVUDVUCVVJWTAUYGVVIU
      UIVUIYDUUJUULYMUUMYHUUNUYSVUSUXOVUOVBVVAVUSVULVUKUXNUXKLVULVUKUUOZUUPVBZV
      USVVPBUNZVVOUOZYNBBVVOUVCVVRVVQVULUOZVVQVUKUOZVKZVVSVVTYNYOVWAYNVVQUXKVUK
      UUQVVSVVTUURUUSVVQVULVUKUUTUVAUVBXNVUSVULVUKYPUXKVUKYPZUXKUXKVUKUVDVUSVUK
      UXKVQZVWBUXKVBUYLAVWCUYGUYKUXKUVEUVFVUKUXKUVGWOUVHVUSUTQXBVUSVUDVKUXNAUYG
      VUDVUEUYLVUJUVIYKUVJYHYLUVLUVMUYHAUYGUXAUYJVBVUAACDEFUWFGIKLNQRUCUDUEUFUY
      EUVKYJYLWHWIXQAUWTUWTUXJVKZUWSYOUYFUWRVWDSEDUWDEVBZUWEUWTUWQUXJUWDEDUVNVW
      EUWKUXEUWMUXGUWPUXIVWEUWJUXDCGCUWDECECGUYJVJUDCGUYJUVOUVPUWBZVWEUWHUXBUWI
      UXCVWEUWGUXAUPURUWFUWDEYQZYRVWEUWGUXAUTURVWGUVQYTYSVWEUWLUXFUPRUWDEYQUVRV
      WEUWNUXHCUWOVWFVWEUWGUXAUPVCVWGYRYSUVSYTUVTYHUWAUWQSDWMUWC $.
  $}

  ${
    $d f g t z A $.  $d f g t z N $.  $d f g z P $.  $d f g t z T $.
    $d f g ph $.  $d t x A $.  $d t y z A $.  $d t K $.  $d x T $.  $d x ph $.
    $d y E $.  $d y z Q $.  $d y z T $.  $d y U $.  $d y V $.
    stoweidlem45.1 $e |- F/_ t P $.
    stoweidlem45.2 $e |- F/ t ph $.
    stoweidlem45.3 $e |- V = { t e. T | ( P ` t ) < ( D / 2 ) } $.
    stoweidlem45.4 $e |- Q = ( t e. T |->
          ( ( 1 - ( ( P ` t ) ^ N ) ) ^ ( K ^ N ) ) ) $.
    stoweidlem45.5 $e |- ( ph -> N e. NN ) $.
    stoweidlem45.6 $e |- ( ph -> K e. NN ) $.
    stoweidlem45.7 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem45.8 $e |- ( ph -> D < 1 ) $.
    stoweidlem45.9 $e |- ( ph -> P e. A ) $.
    stoweidlem45.10 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem45.11 $e |- ( ph -> A. t e. T ( 0 <_ ( P ` t ) /\
          ( P ` t ) <_ 1 ) ) $.
    stoweidlem45.12 $e |- ( ph -> A. t e. ( T \ U ) D <_ ( P ` t ) ) $.
    stoweidlem45.13 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem45.14 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem45.15 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem45.16 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem45.17 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem45.18 $e |- ( ph -> ( 1 - E ) <
          ( 1 - ( ( ( K x. D ) / 2 ) ^ N ) ) ) $.
    stoweidlem45.19 $e |- ( ph -> ( 1 / ( ( K x. D ) ^ N ) ) < E ) $.
    $( This lemma proves that, given an appropriate ` K ` (in another theorem
       we prove such a ` K ` exists), there exists a function q_n as in the
       proof of Lemma 1 in [BrosowskiDeutsh] p. 91 ( at the top of page 91): 0
       <= q_n <= 1 , q_n < &epsilon; on T \ U, and q_n > 1 - &epsilon; on
       ` V ` .  We use y to represent the final q_n in the paper (the one with
       n large enough), ` N ` to represent ` n ` in the paper, ` K ` to
       represent ` k ` , ` D ` to represent &delta;, ` E ` to represent
       &epsilon;, and ` P ` to represent ` p ` .  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem45 $p |- ( ph -> E. y e. A ( A. t e. T ( 0 <_ ( y ` t ) /\
          ( y ` t ) <_ 1 ) /\ A. t e. V ( 1 - E ) < ( y ` t ) /\
          A. t e. ( T \ U ) ( y ` t ) < E ) ) $=
      ( wcel cc0 cv cfv cle wbr c1 wa wral cmin co clt cdif wrex cexp cmpt eqid
      w3a nnnn0d nnexpcld stoweidlem40 cr 1re fnvinran adantr reexpcld resubcld
      nn0expcld 1m1e0 r19.21bi simpld simprd exple1 syl31anc lesub2dd syl5eqbrr
      a1i cn0 expge0d stoweidlem12 breqtrrd 0re ax-1cn subid1i syl6breq eqbrtrd
      jca ex ralrimi stoweidlem24 stoweidlem25 nfmpt1 nfcxfr nfeq2 fveq1 breq2d
      wceq breq1d anbi12d ralbid 3anbi123d rspcev syl13anc ) AHEUPUQDURZHUSZUTV
      AZXTVBUTVAZVCZDIVDZVBMVEVFZXTVGVAZDPVDZXTMVGVAZDIJVHZVDZUQXSCURZUSZUTVAZY
      LVBUTVAZVCZDIVDZYEYLVGVAZDPVDZYLMVGVAZDYIVDZVMZCEVIABDEGHIKLDIVBXSGUSZOVJ
      VFZVEVFZVKZDIVBVKZDIUUCVKZNOVJVFZOQRTUUEVLUUFVLUUGVLUEUFUIUJUKULUAANOUBAO
      UAVNZVOVPAYCDIRAXSIUPZYCAUUJVCZYAYBUUKUQUUDUUHVJVFZXTUTUUKUUDUUHUUKVBUUCV
      BVQUPUUKVRWLZUUKUUBOAIVQXSGUFVSZAOWMUPZUUJUUIVTZWAZWBZAUUHWMUPZUUJANOANUB
      VNZUUIWCVTZUUKUQVBVBVEVFUUDUTWDUUKUUCVBVBUUQUUMUUMUUKUUBVQUPUQUUBUTVAZUUB
      VBUTVAZUUOUUCVBUTVAUUNUUKUVBUVCAUVBUVCVCDIUGWEZWFZUUKUVBUVCUVDWGUUPUUBOWH
      WIWJWKZWNADGHINOTUFUUIUUTWOZWPUUKXTUULVBUTUVGUUKUUDVQUPUQUUDUTVAUUDVBUTVA
      UUSUULVBUTVAUURUVFUUKUUDVBUQVEVFVBUTUUKUQUUCVBUQVQUPUUKWQWLUUQUUMUUKUUBOU
      UNUUPUVEWNWJVBWRWSWTUVAUUDUUHWHWIXAXBXCXDAYFDPRAXSPUPYFADFGHIMNOPSTUFUUIU
      UTUCUMUNUGXEXCXDAYHDYIRAXSYIUPYHADFGHIJMNOTUAUBUCUFUGUHUMUOXFXCXDUUAYDYGY
      JVMCHEYKHXLZYPYDYRYGYTYJUVHYOYCDIDYKHDHDIUULVKTDIUULXGXHXIZUVHYMYAYNYBUVH
      YLXTUQUTXSYKHXJZXKUVHYLXTVBUTUVJXMXNXOUVHYQYFDPUVIUVHYLXTYEVGUVJXKXOUVHYS
      YHDYIUVIUVHYLXTMVGUVJXMXOXPXQXR $.
  $}

  ${
    $d f g h s t z T $.  $d f g q s t z T $.  $d f q r s t T $.
    $d f q s t x z T $.  $d f g h t A $.  $d f g z Q $.  $d f g q s U $.
    $d f g h t z Z $.  $d f g s ph $.  $d g h s t w z T $.  $d g s z W $.
    $d q r t A $.  $d q t x z Z $.  $d r s U $.  $d r s ph $.  $d t w z J $.
    $d t z K $.  $d w z Q $.  $d x A $.  $d x U $.  $d x ph $.
    stoweidlem46.1 $e |- F/_ t U $.
    stoweidlem46.2 $e |- F/_ h Q $.
    stoweidlem46.3 $e |- F/ q ph $.
    stoweidlem46.4 $e |- F/ t ph $.
    stoweidlem46.5 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem46.6 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem46.7 $e |- W = { w e. J | E. h e. Q w =
          { t e. T | 0 < ( h ` t ) } } $.
    stoweidlem46.8 $e |- T = U. J $.
    stoweidlem46.9 $e |- ( ph -> J e. Comp ) $.
    stoweidlem46.10 $e |- ( ph -> A C_ ( J Cn K ) ) $.
    stoweidlem46.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem46.12 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem46.13 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem46.14 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem46.15 $e |- ( ph -> U e. J ) $.
    stoweidlem46.16 $e |- ( ph -> Z e. U ) $.
    stoweidlem46.17 $e |- ( ph -> T e. _V ) $.
    $( This lemma proves that sets U(t) as defined in Lemma 1 of
       [BrosowskiDeutsh] p. 90, are a cover of T \ U. Using this lemma, in a
       later theorem we will prove that a finite subcover exists.  (Contributed
       by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem46 $p |- ( ph -> ( T \ U ) C_ U. W ) $=
      ( vs cdif cuni cv wcel wex cc0 cfv clt wbr nfv nfan nfcv nfdif nfel2 ccmp
      wa adantr ccn co wss caddc cmpt 3adant1r cmul cr adantlr wne stoweidlem43
      w3a wrex simpr weq eleq1 fveq1 breq2d anbi12d cbvex sylib crab cvv rabexg
      syl ad2antrr eldifi ad2antlr simprr fveq2 elrab sylanbrc wceq simpll wral
      cle c1 syl6eleq eqeq1d breq1d ralbidv simpld sseldd ad2ant2r eqid cxr 0xr
      a1i rfcnpre1 syl2anc eqidd rabbidv eqeq2d rspcegf eqeq1 rexbidv syl6eleqr
      nfrab1 nfcxfr eleq2 spcegf imp syl12anc exlimddv elunif sylibr ex ssrdv )
      AUOGHUPZNUQZAUOURZUUAUSZUUCUUBUSZAUUDVKZUUCCURZUSZUUGNUSZVKZCUTZUUEUUFJUR
      ZFUSZVAUUCUULVBZVCVDZVKZUUKJUUFKURZFUSZVAUUCUUQVBZVCVDZVKZKUTUUPJUTUUFBDE
      FUUCGHIQKLMOPJAUUDQTUUDQVEVFAUUDDUADUUCUUADGHDGVGRVHVIVFSUBUCUEALVJUSUUDU
      FVLAELMVMVNZVOZUUDUGVLAIURZEUSZUULEUSZDGDURZUVDVBZUVGUULVBZVPVNVQEUSUUDUH
      VRAUVEUVFDGUVHUVIVSVNVQEUSUUDUIVRABURZVTUSDGUVJVQEUSUUDUJWAAPURZGUSUVGGUS
      UVKUVGWBWDUVKQURZVBUVGUVLVBWBQEWEUUDUKWAAHLUSUUDULVLAOHUSUUDUMVLAUUDWFWCU
      VAUUPKJUVAJVEUUMUUOKKUULFSVIUUOKVEVFKJWGZUURUUMUUTUUOUUQUULFWHUVMUUSUUNVA
      VCUUCUUQUULWIWJWKWLWMUUFUUPVKZVAUVIVCVDZDGWNZWOUSZUUCUVPUSZUVPNUSZUUKAUVQ
      UUDUUPAGWOUSUVQUNUVODGWOWPWQWRUVNUUCGUSZUUOUVRUUDUVTAUUPUUCGHWSWTUUFUUMUU
      OXAUVOUUODUUCGDUOWGUVIUUNVAVCUVGUUCUULXBWJXCXDUVNUVPUUGVAUVGUUQVBZVCVDZDG
      WNZXEZKFWEZCLWNZNUVNUVPLUSZUVPUWCXEZKFWEZUVPUWFUSUVNAUULUVBUSZUWGAUUDUUPX
      FAUUMUWJUUDUUOAUUMVKZEUVBUULAUVCUUMUGVLUWKUVFOUULVBZVAXEZVAUVIXHVDZUVIXIX
      HVDZVKZDGXGZVKZUWKUULOUUQVBZVAXEZVAUWAXHVDZUWAXIXHVDZVKZDGXGZVKZKEWNZUSUV
      FUWRVKUWKUULFUXFAUUMWFZUCXJUXEUWRKUULEUVMUWTUWMUXDUWQUVMUWSUWLVAOUUQUULWI
      XKUVMUXCUWPDGUVMUXAUWNUXBUWOUVMUWAUVIVAXHUVGUUQUULWIZWJUVMUWAUVIXIXHUXHXL
      WKXMWKXCWMXNXOXPAUWJVKZDUVPVAUULLMGDVAVGDUULVGAUWJDUAUWJDVEVFUBUEUVPXQVAX
      RUSUXIXSXTAUWJWFYAYBAUUMUWIUUDUUOUWKUUMUVPUVPXEZUWIUXGUWKUVPYCUWHUXJKUULF
      UXJKVEKUULVGSUVMUWCUVPUVPUVMUWBUVODGUVMUWAUVIVAVCUXHWJYDYEYFYBXPUWEUWICUV
      PLUUGUVPXEZUWDUWHKFUUGUVPUWCYGYHXCXDUDYIUVQUVRUVSVKZUUKUUJUXLCUVPWOCUVPVG
      UVRUVSCUVRCVECUVPNCNUWFUDUWECLYJYKZVIVFUXKUUHUVRUUIUVSUUGUVPUUCYLUUGUVPNW
      HWKYMYNYOYPCUUCNCUUCVGUXMYQYRYSYT $.
  $}

  ${
    $d t J $.  $d t K $.  $d t T $.
    stoweidlem47.1 $e |- F/_ t F $.
    stoweidlem47.2 $e |- F/_ t S $.
    stoweidlem47.3 $e |- F/ t ph $.
    stoweidlem47.4 $e |- T = U. J $.
    stoweidlem47.5 $e |- G = ( T X. { -u S } ) $.
    stoweidlem47.6 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem47.7 $e |- ( ph -> J e. Top ) $.
    stoweidlem47.8 $e |- C = ( J Cn K ) $.
    stoweidlem47.9 $e |- ( ph -> F e. C ) $.
    stoweidlem47.10 $e |- ( ph -> S e. RR ) $.
    $( Subtracting a constant from a real continuous function gives another
       continuous function.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem47 $p |- ( ph -> ( t e. T |-> ( ( F ` t ) - S ) ) e. C ) $=
      ( wcel cv cfv caddc co cmpt cmin wa cneg csn cxp fveq1i cr wceq fvconst2g
      renegcld sylan syl5eq oveq2d fcnre fnvinran recnd cc adantr negsubd eqtrd
      mpteq2da ccn nfcv nfneg nfsn nfxp nfcxfr ctop ctopon a1i istopon sylanbrc
      cuni syl6eleq crn ctg retopon eqeltri cnconst2 syl3anc syl5eqel refsum2cn
      cioo syl6eleqr eqeltrrd ) ABEBUAZFUBZWKGUBZUCUDZUEZBEWLDUFUDZUECABEWNWPLA
      WKETZUGZWNWLDUHZUCUDWPWRWMWSWLUCWRWMWKEWSUIZUJZUBZWSWKGXANUKAWSULTZWQXBWS
      UMADSUOZEWSWKULUNUPUQURWRWLDWRWLAEULWKFACEFHIOMQRUSUTVAADVBTWQADSVAVCVDVE
      VFAWOHIVGUDZCABFGHIEJBGXANBEWTBEVHBWSBDKVIVJVKVLLOAHVMTEHVRUMZHEVNUBTZPXF
      AMVOEHVPVQZAFCXERQVSAGXAXENAXGIULVNUBZTZXCXAXETXHXJAIWHVTWAUBXIOWBWCVOXDW
      SHIEULWDWEWFWGQWIWJ $.
  $}

  ${
    $d f g h t A $.  $d f h i t T $.  $d f g t z A $.  $d f g z F $.
    $d f g z M $.  $d f g h t U $.  $d f g z Y $.  $d f g ph $.  $d g h t T $.
    $d i j k t z $.  $d i j k D $.  $d i j z E $.  $d i j k z M $.
    $d i t z U $.  $d i j W $.  $d j t w $.  $d j k z F $.  $d j k ph $.
    $d w M $.  $d w W $.  $d w ph $.  $d z P $.  $d z T $.
    stoweidlem48.1 $e |- F/ i ph $.
    stoweidlem48.2 $e |- F/ t ph $.
    stoweidlem48.3 $e |- Y = { h e. A | A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t
                           ) <_ 1 ) } $.
    stoweidlem48.4 $e |- P = ( f e. Y , g e. Y |-> ( t e. T |-> ( ( f ` t )
                           x. ( g ` t ) ) ) ) $.
    stoweidlem48.5 $e |- X = ( seq 1 ( P , U ) ` M ) $.
    stoweidlem48.6 $e |- F = ( t e. T |-> ( i e. ( 1 ... M ) |-> ( ( U ` i )
                           ` t ) ) ) $.
    stoweidlem48.7 $e |- Z = ( t e. T |-> ( seq 1 ( x. , ( F ` t ) ) ` M ) )
$.
    stoweidlem48.8 $e |- ( ph -> M e. NN ) $.
    stoweidlem48.9 $e |- ( ph -> W : ( 1 ... M ) --> V ) $.
    stoweidlem48.10 $e |- ( ph -> U : ( 1 ... M ) --> Y ) $.
    stoweidlem48.11 $e |- ( ph -> D C_ U. ran W ) $.
    stoweidlem48.12 $e |- ( ph -> D C_ T ) $.
    stoweidlem48.13 $e |- ( ( ph /\ i e. ( 1 ... M ) ) -> A. t e. ( W ` i ) (
                            ( U ` i ) ` t ) < E ) $.
    stoweidlem48.14 $e |- ( ph -> T e. _V ) $.
    stoweidlem48.15 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem48.16 $e |- ( ( ph /\ f e. A /\ g e. A ) -> ( t e. T |-> ( ( f
                            ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem48.17 $e |- ( ph -> E e. RR+ ) $.
    $( This lemma is used to prove that ` x ` built as in Lemma 2 of
       [BrosowskiDeutsh] p. 91, is such that x < &epsilon; on ` A ` .  Here
       ` X ` is used to represent ` x ` in the paper, ` E ` is used to
       represent &epsilon; in the paper, and ` D ` is used to represent ` A `
       in the paper (because ` A ` is always used to represent the
       subalgebra).  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem48 $p |- ( ph -> A. t e. D ( X ` t ) < E ) $=
      ( vk vj vw cv cfv clt wbr wcel wa wceq sselda cc0 c1 wral crab nfra1 nfcv
      cle nfrab nfcxfr cr eleq2i biimpi weq fveq1 breq2d breq1d anbi12d ralbidv
      wf elrab sylib simpld sylan2 cmul co cmpt eqid stoweidlem16 fmuldfeq cseq
      syldan cuz cn elnnuz adantr cfz nfv nfan fnvinran elrab2 simpl jca anbi2d
      wi eleq1 feq1 imbi12d a1i vtoclga sylc adantlr simplr ffvelrnd fmptdf cvv
      simpr ovex fvmpt2 syl2anc nffv simprd r19.21bi syl21anc fveq1d eqbrtrd ex
      wrex mpd w3a nfim fveq2 chvar reximdva mptexg feq1d mpbird remulcl adantl
      mp1i seqcl nfmpt1 nfmpt simpll eqtrd breqtrrd crp crn wex cuni wfn wb ffn
      eluni fvelrnb 3syl adantrl eleqtrrd reximdv adantrr exlimdv simplll nf3an
      biimpa eleq2d 3anbi23d 3impa syl3anc eqeq12d biimprd fmul01lt1 ralrimi
      nfeq1 ) ABUTZQVAZLVBVCZBDUAAUVTDVDZUWBAUWCVEZUWAUVTSVAZLVBAUWCUVTFVDZUWAU
      WEVFADFUVTUKVGZABEFGHIKMNQRSTBRVHUVTJUTZVAZVNVCZUWIVIVNVCZVEZBFVJZJCVKZUB
      UWMBJCUWLBFVLBCVMVOVPUCUDUEUFUMUGUIHUTZRVDZAUWOCVDZFVQUWOWFZUWPUWQVHUVTUW
      OVAZVNVCZUWSVIVNVCZVEZBFVJZUWPUWOUWNVDZUWQUXCVEUWPUXDRUWNUWOUBVRVSUWMUXCJ
      UWOCJHVTZUWLUXBBFUXEUWJUWTUWKUXAUXEUWIUWSVHVNUVTUWHUWOWAZWBUXEUWIUWSVIVNU
      XFWCWDWEWGWHWIUNWJABCFHIJBFUWSUVTIUTVAWKWLWMZRUAUBUXGWNUNUOWOWPWRUWDUWENW
      KUVTMVAZVIWQZVAZLVBUWDUWFUXJVQVDUWEUXJVFUWGUWDUQURWKVQUXHVINANVIWSVAVDZUW
      CANWTVDZUXKUGNXAWHXBUWDVINXCWLZVQUQUTZUXHAUWCUWFUXMVQUXHWFZUWGAUWFVEZUXOU
      XMVQKUXMUVTKUTZGVAZVAZWMZWFUXPKUXMUXSVQUXTAUWFKTUWFKXDXEUXPUXQUXMVDZVEFVQ
      UVTUXRAUYAFVQUXRWFZUWFAUYAVEZUXRCVDZAUYDVEZUYBUYCUYDVHUXSVNVCZUXSVIVNVCZV
      EZBFVJZUYCUXRRVDUYDUYIVEAUXMRUXQGUIXFUWMUYIJUXRCRUWHUXRVFZUWLUYHBFUYJUWJU
      YFUWKUYGUYJUWIUXSVHVNUVTUWHUXRWAZWBUYJUWIUXSVIVNUYKWCWDWEUBXGWHZWIZUYCAUY
      DAUYAXHUYMXIAUWQVEZUWRXKZUYEUYBXKHUXRCUWOUXRVFZUYNUYEUWRUYBUYPUWQUYDAUWOU
      XRCXLXJFVQUWOUXRXMXNUYOUWQUNXOXPXQXRAUWFUYAXSXTZUXTWNZYAUXPUXMVQUXHUXTUXP
      UWFUXTYBVDZUXHUXTVFAUWFYCUXMYBVDUYSUXPVINXCYDKUXMUXSYBUUAUUFBFUXTYBMUEYEY
      FZUUBUUCWRZXFUXNVQVDURUTZVQVDVEUXNVUBWKWLVQVDUWDUXNVUBUUDUUEUUGBFUXJVQSUF
      YEYFUWDUXIUXHKURLNKUVTMKMBFUXTWMUEKBFUXTKFVMKUXMUXSUUHUUIVPKUVTVMYGZAUWCK
      TUWCKXDXEZURUXIVMUXIWNAUXLUWCUGXBVUAUWDUYAVEZVHUXSUXQUXHVAZVNVUEAUYAUWFUY
      FAUWCUYAUUJZUWDUYAYCZUWDUWFUYAUWGXBZUYCUWFVEZUYFUYGUYCUYHBFUYCUYDUYIUYLYH
      YIZWIYJVUEVUFUXQUXTVAZUXSVUEAUWFVUFVULVFVUGVUIUXPUXQUXHUXTUYTYKYFVUEUYAUX
      SVQVDZVULUXSVFVUHVUEAUWFUYAVUMVUGVUIVUHUYQYJKUXMUXSVQUXTUYRYEYFUUKZUULVUE
      VUFUXSVIVNVUNVUEAUYAUWFUYGVUGVUHVUIVUJUYFUYGVUKYHYJYLALUUMVDUWCUPXBUWDUVT
      VUBGVAZVAZLVBVCZURUXMYNZVUBUXHVAZLVBVCZURUXMYNUWDUVTVUBPVAZVDZURUXMYNZVUR
      UWDUVTUSUTZVDZVVDPUUNZVDZVEZUSUUOZVVCUWDUVTVVFUUPZVDVVIADVVJUVTUJVGUSUVTV
      VFUUTWHAVVIVVCXKUWCAVVHVVCUSAVVHVVCAVVHVEVVAVVDVFZURUXMYNZVVCAVVGVVLVVEAV
      VGVVLAUXMOPWFPUXMUUQVVGVVLUURUHUXMOPUUSURUXMVVDPUVAUVBUVJUVCAVVEVVLVVCXKV
      VGAVVEVEZVVKVVBURUXMVVMVVKVVBVVMVVKVEUVTVVDVVAAVVEVVKXSVVMVVKYCUVDYMUVEUV
      FYOYMUVGXBYOUWDVVBVUQURUXMUWDVUBUXMVDZVEZVVBVUQVVOVVBVEAVVNVVBVUQAUWCVVNV
      VBUVHUWDVVNVVBXSVVOVVBYCAUYAUVTUXQPVAZVDZYPZUXSLVBVCZXKAVVNVVBYPZVUQXKKUR
      VVTVUQKAVVNVVBKTVVNKXDZVVBKXDUVIVUQKXDYQKURVTZVVRVVTVVSVUQVWBUYAVVNVVQVVB
      AUXQVUBUXMXLZVWBVVPVVAUVTUXQVUBPYRUVKUVLVWBUXSVUPLVBVWBUVTUXRVUOUXQVUBGYR
      YKZWCXNAUYAVVQVVSUYCVVSBVVPULYIUVMYSUVNYMYTYOUWDVUQVUTURUXMVVOVUTVUQVVOVU
      SVUPLVBVUEVUFUXSVFZXKVVOVUSVUPVFZXKKURVVOVWFKUWDVVNKVUDVWAXEKVUSVUPKVUBUX
      HVUCKVUBVMYGUVSYQVWBVUEVVOVWEVWFVWBUYAVVNUWDVWCXJVWBVUFVUSUXSVUPUXQVUBUXH
      YRVWDUVOXNVUNYSWCUVPYTYOUVQYLYLYMUVR $.
  $}

  ${
    $d f g k n t z A $.  $d f g k n t D $.  $d f g k n t E $.  $d f g z P $.
    $d f g k n t z T $.  $d f g k n ph $.  $d i j k x D $.  $d i k n x D $.
    $d i k n x E $.  $d i k n x ph $.  $d k n t y z A $.  $d k n y U $.
    $d k n y V $.  $d t x A $.  $d x T $.  $d y E $.  $d y z P $.  $d y z T $.
    stoweidlem49.1 $e |- F/_ t P $.
    stoweidlem49.2 $e |- F/ t ph $.
    stoweidlem49.3 $e |- V = { t e. T | ( P ` t ) < ( D / 2 ) } $.
    stoweidlem49.4 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem49.5 $e |- ( ph -> D < 1 ) $.
    stoweidlem49.6 $e |- ( ph -> P e. A ) $.
    stoweidlem49.7 $e |- ( ph -> P : T --> RR ) $.
    stoweidlem49.8 $e |- ( ph -> A. t e. T ( 0 <_ ( P ` t ) /\
          ( P ` t ) <_ 1 ) ) $.
    stoweidlem49.9 $e |- ( ph -> A. t e. ( T \ U ) D <_ ( P ` t ) ) $.
    stoweidlem49.10 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem49.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem49.12 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem49.13 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem49.14 $e |- ( ph -> E e. RR+ ) $.
    $( There exists a function q_n as in the proof of Lemma 1 in
       [BrosowskiDeutsh] p. 91 (at the top of page 91): 0 <= q_n <= 1 , q_n <
       &epsilon; on ` T \ U ` , and q_n > 1 - &epsilon; on ` V ` .  Here y is
       used to represent the final q_n in the paper (the one with n large
       enough), ` N ` represents ` n ` in the paper, ` K ` represents ` k ` ,
       ` D ` represents &delta;, ` E ` represents &epsilon;, and ` P `
       represents ` p ` .  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem49 $p |- ( ph -> E. y e. A ( A. t e. T ( 0 <_ ( y ` t ) /\
          ( y ` t ) <_ 1 ) /\ A. t e. V ( 1 - E ) < ( y ` t ) /\
           A. t e. ( T \ U ) ( y ` t ) < E ) ) $=
      ( vk vn vj vi c1 cmin co cv cmul c2 cdiv cexp clt wbr wa wrex cc0 cfv cle
      cn wral cdif w3a crab breq2 cbvrabv stoweidlem14 wcel cmpt eqid cr adantl
      cn0 nnre rpred adantr remulcld simprl rehalfcld nngt0 rpgt0d mulgt0d 2pos
      crp 2re pm3.2i divgt0 syl21anc elrpd simprr ad2antrr stoweidlem7 reximdva
      a1i ex mpd nfv simplrr simplrl wf simplll sylancom caddc simp1ll syld3an1
      nfan stoweidlem45 rexlimdvva ) AULLUMUNZULUHUOZFUPUNZUQURUNZUIUOZUSUNUMUN
      UTVAZULXRXTUSUNURUNLUTVAZVBZUIVGVCZUHVGVCZVDDUOZCUOVEZVFVAYGULVFVAVBDHVHX
      PYGUTVADMVHYGLUTVADHIVIZVHVJCEVCZAULXRUTVAZXSULUTVAZVBZUHVGVCYEAULFURUNZU
      JUOZUTVAZUJVGVKFUKUHYOYMUKUOZUTVAUJUKVGYNYPYMUTVLVMQRVNAYLYDUHVGAXQVGVOZV
      BZYLYDYRYLVBXRXSUKUILUKVTULXRURUNYPUSUNVPZUKVTXSYPUSUNVPZYSVQYTVQYRXRVRVO
      ZYLYRXQFYQXQVRVOAXQWAVSZAFVRVOYQAFQWBWCZWDZWCYRYJYKWEYRXSWKVOYLYRXSYRXRUU
      DWFYRUUAVDXRUTVAUQVRVOZVDUQUTVAZVBZVDXSUTVAUUDYRXQFUUBUUCYQVDXQUTVAAXQWGV
      SAVDFUTVAYQAFQWHWCWIUUGYRUUEUUFWLWJWMXAXRUQWNWOWPWCYRYJYKWQALWKVOZYQYLUGW
      RWSXBWTXCAYCYIUHUIVGVGAYQXTVGVOZVBZVBZYCYIUUKYCVBZBCDEFGDHULYFGVEZXTUSUNU
      MUNXQXTUSUNUSUNVPZHIJKLXQXTMNUUKYCDAUUJDOUUJDXDXMYCDXDXMPUUNVQAYQUUIYCXEA
      YQUUIYCXFAFWKVOUUJYCQWRAFULUTVAUUJYCRWRAGEVOUUJYCSWRAHVRGXGUUJYCTWRAVDUUM
      VFVAUUMULVFVAVBDHVHUUJYCUAWRAFUUMVFVADYHVHUUJYCUBWRUULJUOZEVOZAHVRUUOXGAU
      UJYCUUPXHUCXIAUUPUULKUOZEVOZDHYFUUOVEZYFUUQVEZXJUNVPEVOAUUJYCUUPUURXKZUDX
      LAUUPUULUURDHUUSUUTUPUNVPEVOUVAUEXLUULBUOZVRVOZADHUVBVPEVOAUUJYCUVCXHUFXI
      AUUHUUJYCUGWRUUKYAYBWEUUKYAYBWQXNXBXOXC $.
  $}

  ${
    $d c u J $.  $d c u T $.  $d c u U $.  $d c u W $.  $d f g h t z T $.
    $d f g q t z T $.  $d f q r t A $.  $d f q t x z T $.  $d f g z Q $.
    $d f g q U $.  $d f g h t z Z $.  $d f g q ph $.  $d g h t w z T $.
    $d g h t A $.  $d g z W $.  $d q t x z Z $.  $d r t T $.  $d r U $.
    $d r ph $.  $d t w z J $.  $d t z K $.  $d u ph $.  $d w z Q $.  $d x A $.
    $d x U $.  $d x ph $.
    stoweidlem50.1 $e |- F/_ t U $.
    stoweidlem50.2 $e |- F/ t ph $.
    stoweidlem50.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem50.4 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem50.5 $e |- W = { w e. J | E. h e. Q w =
          { t e. T | 0 < ( h ` t ) } } $.
    stoweidlem50.6 $e |- T = U. J $.
    stoweidlem50.7 $e |- C = ( J Cn K ) $.
    stoweidlem50.8 $e |- ( ph -> J e. Comp ) $.
    stoweidlem50.9 $e |- ( ph -> A C_ C ) $.
    stoweidlem50.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem50.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem50.12 $e |- ( ( ph /\ x e. RR ) ->
          ( t e. T |-> x ) e. A ) $.
    stoweidlem50.13 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem50.14 $e |- ( ph -> U e. J ) $.
    stoweidlem50.15 $e |- ( ph -> Z e. U ) $.
    $( This lemma proves that sets U(t) as defined in Lemma 1 of
       [BrosowskiDeutsh] p. 90, contain a finite subcover of T \ U.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem50 $p |- ( ph -> E. u ( u e. Fin /\ u C_ W /\
          ( T \ U ) C_ U. u ) ) $=
      ( vc cdif cuni wss cv cfn wcel w3a wex cfv cc0 wceq cle c1 wa wral nfrab1
      wbr crab nfcxfr nfv ccn co syl6sseq cvv ccmp uniexg syl5eqel stoweidlem46
      syl cpw cin wrex crest ccld dfin4 elssuni syl6sseqr dfss1 syl5eqr eqeltrd
      wi sylib ctop cmptop difssd iscld2 syl2anc mpbird cmpcld cmpsub mpbid clt
      wb ssrab2 eqsstri rabexg elpwg mpbiri unieq sseq2d ineq1d rexeqdv imbi12d
      pweq rspccva df-rex elin simprbi ad2antrl simplbi elpwid simprr ex eximdv
      imp 3jca mpd mpdan ) AIJUPZPUQZURZDUSZUTVAZYQPURZYNYQUQURZVBZDVCZABCEFHIJ
      KLMNOPQRSTMHQMUSZVDVEVFVEEUSUUCVDZVGVLUUDVHVGVLVIEIVJVIZMFVMUCUUEMFVKVNAS
      VOUAUBUCUDUEUGAFGNOVPVQUHUFVRUIUJUKULUMUNAINUQZVSUEANVTVAZUUFVSVAUGNVTWAW
      DWBWCAYPVIZYQPWEZUTWFZVAZYTVIZDVCZUUBUUHYTDUUJWGZUUMAYPUUNAYNUOUSZUQZURZY
      TDUUOWEZUTWFZWGZWPZUONWEZVJZPUVBVAZYPUUNWPZANYNWHVQVTVAZUVCAUUGYNNWIVDVAZ
      UVFUGAUVGIYNUPZNVAZAUVHJNAUVHIJWFZJIJWJAJIURUVJJVFAJUUFIAJNVAJUUFURUMJNWK
      WDUEWLJIWMWQWNUMWOANWRVAZYNIURZUVGUVIXHAUUGUVKUGNWSWDZAIJWTZYNNIUEXAXBXCY
      NNXDXBAUVKUVLUVFUVCXHUVMUVNYNNIUODUEXEXBXFAUVDPNURZPCUSVEUUDXGVLEIVMVFMHW
      GZCNVMZNUDUVPCNXIXJAPVSVAUVDUVOXHAPUVQVSUDAUUGUVQVSVAUGUVPCNVTXKWDWBPNVSX
      LWDXMUVAUVEUOPUVBUUOPVFZUUQYPUUTUUNUVRUUPYOYNUUOPXNXOUVRYTDUUSUUJUVRUURUU
      IUTUUOPXSXPXQXRXTXBYJYTDUUJYAWQUUHUULUUADUUHUULUUAUUHUULVIZYRYSYTUUKYRUUH
      YTUUKYQUUIVAZYRYQUUIUTYBZYCYDUVSYQPUUKUVTUUHYTUUKUVTYRUWAYEYDYFUUHUUKYTYG
      YKYHYIYLYM $.
  $}

  ${
    $d f g h t z A $.  $d f h i t z M $.  $d f g z F $.  $d f g h t z T $.
    $d f g h t z U $.  $d f g z Y $.  $d f g ph $.  $d g h t z M $.
    $d i w z T $.  $d i B $.  $d i D $.  $d i z E $.  $d i t z U $.
    $d i w z W $.  $d t x z A $.  $d x B $.  $d x D $.  $d x z E $.
    $d x z T $.  $d x z X $.  $d z P $.  $d z V $.
    stoweidlem51.1 $e |- F/ i ph $.
    stoweidlem51.2 $e |- F/ t ph $.
    stoweidlem51.3 $e |- F/ w ph $.
    stoweidlem51.4 $e |- F/_ w V $.
    stoweidlem51.5 $e |- Y = { h e. A | A. t e. T ( 0 <_ ( h ` t ) /\
          ( h ` t ) <_ 1 ) } $.
    stoweidlem51.6 $e |- P = ( f e. Y , g e. Y |-> ( t e. T |->
          ( ( f ` t ) x. ( g ` t ) ) ) ) $.
    stoweidlem51.7 $e |- X = ( seq 1 ( P , U ) ` M ) $.
    stoweidlem51.8 $e |- F = ( t e. T |-> ( i e. ( 1 ... M ) |->
          ( ( U ` i ) ` t ) ) ) $.
    stoweidlem51.9 $e |- Z = ( t e. T |-> ( seq 1 ( x. , ( F ` t ) ) ` M ) ) $.
    stoweidlem51.10 $e |- ( ph -> M e. NN ) $.
    stoweidlem51.11 $e |- ( ph -> W : ( 1 ... M ) --> V ) $.
    stoweidlem51.12 $e |- ( ph -> U : ( 1 ... M ) --> Y ) $.
    stoweidlem51.13 $e |- ( ( ph /\ w e. V ) -> w C_ T ) $.
    stoweidlem51.14 $e |- ( ph -> D C_ U. ran W ) $.
    stoweidlem51.15 $e |- ( ph -> D C_ T ) $.
    stoweidlem51.16 $e |- ( ph -> B C_ T ) $.
    stoweidlem51.17 $e |- ( ( ph /\ i e. ( 1 ... M ) ) ->
          A. t e. ( W ` i ) ( ( U ` i ) ` t ) < ( E / M ) ) $.
    stoweidlem51.18 $e |- ( ( ph /\ i e. ( 1 ... M ) ) ->
          A. t e. B ( 1 - ( E / M ) ) < ( ( U ` i ) ` t ) ) $.
    stoweidlem51.19 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem51.20 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem51.21 $e |- ( ph -> T e. _V ) $.
    stoweidlem51.22 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem51.23 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( There exists a function x as in the proof of Lemma 2 in
       [BrosowskiDeutsh] p. 91.  Here ` D ` is used to represent ` A ` in the
       paper, because here ` A ` is used for the subalgebra of functions. ` E `
       is used to represent &epsilon; in the paper.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem51 $p |- ( ph -> E. x ( x e. A /\
          ( A. t e. T ( 0 <_ ( x ` t ) /\ ( x ` t ) <_ 1 ) /\
           A. t e. D ( x ` t ) < E /\ A. t e. B ( 1 - E ) < ( x ` t ) ) ) ) $=
      ( wcel cc0 cv cfv cle wbr c1 wa wral clt cmin w3a wex crab ssrab2 eqsstri
      co cz cfz 1z a1i nnzd 3jca nnge1d nnred leidd jca sylanbrc cmul cmpt eqid
      elfz2 stoweidlem16 fmulcl sseldi eleq2i cseq nfcv cmpt2 nfrab1 nfseq nffv
      nfcxfr nfmpt2 nfbr nfan nfral wceq nfra1 nfrab nfmpt1 nfeq2 breq2d breq1d
      fveq1 anbi12d ralbid elrabf bitri sylib simprd nfv cr wf fnvinran ralbidv
      cdiv elrab2 wi eleq1 anbi2d imbi12d wss sylc ad2antrr simplbi syl vtoclga
      feq1 anabsi7 syldan adantr simpl nfel2 nfim sseq1 vtoclgf sselda ffvelrnd
      wne nnne0d redivcld r19.21bi wb 1re 0lt1 nngt0d rpregt0d lediv2 syl221anc
      rpred mpbid rpcnd div1d breqtrd ltletrd ralrimi stoweidlem48 sseli sylan2
      ex stoweidlem42 3anbi123d spcegv ) ATEVFZUVTVGDVHZTVIZVJVKZUWBVLVJVKZVMZD
      IVNZUWBOVOVKZDGVNZVLOVPWBZUWBVOVKZDFVNZVQZVMZBVHZEVFZVGUWAUWNVIZVJVKZUWPV
      LVJVKZVMZDIVNZUWPOVOVKZDGVNZUWIUWPVOVKZDFVNZVQZVMZBVRAUAETUAVGUWAMVHZVIZV
      JVKZUXHVLVJVKZVMZDIVNZMEVSZEUGUXLMEVTWAZADHIJKLQQTUAUHUIAVLWCVFZQWCVFZUXP
      VQVLQVJVKZQQVJVKZVMQVLQWDWBZVFAUXOUXPUXPUXOAWEWFAQULWGZUXTWHAUXQUXRAQULWI
      ZAQAQULWJZWKWLQVLQWQWMUNADEIKLMDIUWAKVHZVIUWALVHVIWNWBZWOZUAUDUGUYEWPVBVA
      WRZVCWSZWTZAUVTUWLUYHAUWFUWHUWKAUVTUWFATUAVFZUVTUWFVMZUYGUYITUXMVFUYJUAUX
      MTUGXAUXLUWFMTEMTQHJVLXBZVIZUIMQUYKMHJVLMVLXCZMHKLUAUAUYEXDZUHKLMUAUAUYEM
      UAUXMUGUXLMEXEXHZUYOMUYEXCXIXHMJXCXFMQXCXGXHZMEXCUWEMDIMIXCUWCUWDMMVGUWBV
      JMVGXCMVJXCZMUWATUYPMUWAXCXGZXJMUWBVLVJUYRUYQUYMXJXKXLUXGTXMZUXKUWEDIDUXG
      TDTUYLUIDQUYKDHJVLDVLXCDHUYNUHKLDUAUAUYEDUAUXMUGUXLDMEUXKDIXNDEXCXOXHZUYT
      DIUYDXPXIXHDJXCXFDQXCXGXHZXQUYSUXIUWCUXJUWDUYSUXHUWBVGVJUWAUXGTXTZXRUYSUX
      HUWBVLVJVUBXSYAYBYCYDYEYFADEGHIJKLMNOPQRSTUAUBUCUDUGUHUIUJUKULUMUNUPUQANV
      HZUXSVFZVMZUWAVUCJVIZVIZOVOVKZDVUCSVIZAVUDDUDVUDDYGXKVUEUWAVUIVFZVUHVUEVU
      JVMZVUGOQYLWBZOVUKIYHUWAVUFVUEIYHVUFYIZVUJAVUDVUFEVFZVUMVUEVUFUAVFZVUNAUX
      SUAVUCJUNYJVUOVUNVGVUGVJVKZVUGVLVJVKZVMZDIVNZUXLVUSMVUFEUAUXGVUFXMZUXKVUR
      DIVUTUXIVUPUXJVUQVUTUXHVUGVGVJUWAUXGVUFXTZXRVUTUXHVUGVLVJVVAXSYAYKUGYMUUA
      UUBAVUNVUMAUYCEVFZVMZIYHUYCYIZYNZAVUNVMZVUMYNKVUFEUYCVUFXMZVVCVVFVVDVUMVV
      GVVBVUNAUYCVUFEYOYPIYHUYCVUFUUDYQVVEVVBVBWFUUCUUEUUFUUGVUEVUIIUWAVUEVUIRV
      FZAVVHVMZVUIIYRZAUXSRVUCSUMYJZVUEAVVHAVUDUUHVVKWLACVHZRVFZVMZVVLIYRZYNVVI
      VVJYNCVUIRCVUIXCVVIVVJCAVVHCUECVUIRUFUUIXKVVJCYGUUJVVLVUIXMZVVNVVIVVOVVJV
      VPVVMVVHAVVLVUIRYOYPVVLVUIIUUKYQUOUULYSUUMUUNVUKOQAOYHVFZVUDVUJAOVDUVFYTZ
      AQYHVFZVUDVUJUYBYTAQVGUUOVUDVUJAQULUUPYTUUQVVRVUEVUGVULVOVKDVUIUSUURAVULO
      VJVKVUDVUJAVULOVLYLWBZOVJAUXQVULVVTVJVKZUYAAVLYHVFZVGVLVOVKZVVSVGQVOVKVVQ
      VGOVOVKVMUXQVWAUUSVWBAUUTWFVWCAUVAWFUYBAQULUVBAOVDUVCVLQOUVDUVEUVGAOAOVDU
      VHUVIUVJYTUVKUVPUVLVCVBVAVDUVMADFHIJKLNOPQTUAUBUCUDUYTUHUIUJUKULUNUTVDVEU
      YCUAVFAVVBVVDUAEUYCUXNUVNVBUVOUYFVCURUVQWHWLUXFUWMBTEUWNTXMZUWOUVTUXEUWLU
      WNTEYOVWDUWTUWFUXBUWHUXDUWKVWDUWSUWEDIDUWNTVUAXQZVWDUWQUWCUWRUWDVWDUWPUWB
      VGVJUWAUWNTXTZXRVWDUWPUWBVLVJVWFXSYAYBVWDUXAUWGDGVWEVWDUWPUWBOVOVWFXSYBVW
      DUXCUWJDFVWEVWDUWPUWBUWIVOVWFXRYBUVRYAUVSYS $.
  $}

  ${
    $d a e t y $.  $d a t y A $.  $d a t D $.  $d a t y T $.  $d a y U $.
    $d a e y V $.  $d a e y ph $.  $d e f g t y $.  $d e t v x $.
    $d f g t y z A $.  $d f g t D $.  $d f g y z P $.  $d f g t y z T $.
    $d f g y z U $.  $d f g y z V $.  $d f g y ph $.  $d t v Z $.  $d v z A $.
    $d v J $.  $d v x T $.  $d v x U $.  $d v x V $.  $d x y A $.
    stoweidlem52.1 $e |- F/_ t U $.
    stoweidlem52.2 $e |- F/ t ph $.
    stoweidlem52.3 $e |- F/_ t P $.
    stoweidlem52.4 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem52.5 $e |- V = { t e. T | ( P ` t ) < ( D / 2 ) } $.
    stoweidlem52.7 $e |- T = U. J $.
    stoweidlem52.8 $e |- C = ( J Cn K ) $.
    stoweidlem52.9 $e |- ( ph -> A C_ C ) $.
    stoweidlem52.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem52.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t )
                     x. ( g ` t ) ) ) e. A ) $.
    stoweidlem52.12 $e |- ( ( ph /\ a e. RR ) -> ( t e. T |-> a ) e. A ) $.
    stoweidlem52.13 $e |- ( ph -> D e. RR+ ) $.
    stoweidlem52.14 $e |- ( ph -> D < 1 ) $.
    stoweidlem52.15 $e |- ( ph -> U e. J ) $.
    stoweidlem52.16 $e |- ( ph -> Z e. U ) $.
    stoweidlem52.17 $e |- ( ph -> P e. A ) $.
    stoweidlem52.18 $e |- ( ph -> A. t e. T ( 0 <_ ( P ` t ) /\
          ( P ` t ) <_ 1 ) ) $.
    stoweidlem52.19 $e |- ( ph -> ( P ` Z ) = 0 ) $.
    stoweidlem52.20 $e |- ( ph -> A. t e. ( T \ U ) D <_ ( P ` t ) ) $.
    $( There exists a neighborood V as in Lemma 1 of [BrosowskiDeutsh] p. 90.
       Here Z is used to represent t_0 in the paper, and v is used to represent
       V in the paper.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem52 $p |- ( ph -> E. v e. J ( ( Z e. v /\ v C_ U ) /\
          A. e e. RR+ E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\
          ( x ` t ) <_ 1 ) /\ A. t e. v ( x ` t ) < e /\
          A. t e. ( T \ U ) ( 1 - e ) < ( x ` t ) ) ) ) $=
      ( vy wcel wss wa cc0 cv cfv cle wbr c1 wral clt cmin co cdif w3a wrex crp
      c2 cdiv nfcv rpred rehalfcld rexrd ccn syl6sseq sseldd rfcnpre2 crab cuni
      elssuni syl syl6sseqr 2re a1i rpgt0d 2pos divgt0d eqbrtrd nffv nfbr fveq2
      cr wceq breq1d elrabf sylanbrc syl6eleqr wn wf fcnre adantr biimpi adantl
      rabeq2i simpld ffvelrnd simprd halfpos mpbid lttrd ad2antrr anim1i sylibr
      wb eldif rsp sylc lenltd ex ralrimi nfv nfan sselda adantlr cmpt 3adant1r
      nfra1 eqid syl2anc sylan syl3an1 anbi12d condan nfrab1 nfcxfr dfss3f cmul
      caddc simpr stoweidlem49 nf3an ssrab2 eqsstri simplr simpr1 simpr2 simpr3
      simplll simpllr stoweidlem41 exp31 rexlimdv mpd jca31 eleq2 sseq1 3anbi2d
      raleqf rexbidv ralbidv rspcev ) APNUSQPUSZPJUTZVAZVBDVCZBVCVDZVEVFUVNVGVE
      VFVADIVHZUVNKVCZVIVFZDPVHZVGUVPVJVKZUVNVIVFDIJVLZVHZVMZBEVNZKVOVHZVAZQCVC
      ZUSZUWFJUTZVAZUVOUVQDUWFVHZUWAVMZBEVNZKVOVHZVAZCNVNADPGVPVQVKZHNOIDUWOVRZ
      UATUBUDUCAUWOAGAGUJVSZVTZWAAENOWBVKZHAEFUWSUFUEWCUNWDWEAUVJUVKUWDAQUVMHVD
      ZUWOVIVFZDIWFZPAQIUSQHVDZUWOVIVFZQUXBUSAJIQAJNWGZIAJNUSJUXEUTULJNWHWIUDWJ
      UMWDAUXCVBUWOVIUPAGVPUWQVPWTUSAWKWLAGUJWMZVBVPVIVFAWNWLWOWPUXAUXDDQIDQVRZ
      DIVRDUXCUWOVIDQHUAUXGWQDVIVRUWPWRUVMQXAUWTUXCUWOVIUVMQHWSXBXCXDUCXEAUVMJU
      SZDPVHUVKAUXHDPTAUVMPUSZUXHAUXIVAZUXHUWTGVIVFZUXJUXKUXHXFZUXJUWTUWOGUXJIW
      TUVMHAIWTHXGZUXIAFIHNOUBUDUEAEFHUFUNWDXHZXIUXJUVMIUSZUXAUXIUXOUXAVAZAUXIU
      XPUXADPIUCXLXJXKZXMZXNZAUWOWTUSUXIUWRXIAGWTUSZUXIUWQXIUXJUXOUXAUXQXOAUWOG
      VIVFZUXIAVBGVIVFZUYAUXFAUXTUYBUYAYBUWQGXPWIXQXIXRXIUXJUXLVAZGUWTVEVFZUXKX
      FUYCUYDDUVTVHZUVMUVTUSZUYDAUYEUXIUXLUQXSUYCUXOUXLVAUYFUXJUXOUXLUXRXTUVMIJ
      YCYAUYDDUVTYDYEUYCGUWTAUXTUXIUXLUWQXSUXJUWTWTUSUXLUXSXIYFXQUUAYGYHDPJDPUX
      BUCUXADIUUBUUCZSUUDYAAUWCKVOAKYIAUVPVOUSZUWCAUYHVAZVBUVMURVCZVDZVEVFUYKVG
      VEVFVAZDIVHZUVSUYKVIVFZDPVHZUYKUVPVIVFZDUVTVHZVMZUREVNUWCUYIRURDEGHIJLMUV
      PPUAAUYHDTUYHDYIYJZUCAGVOUSUYHUJXIAGVGVIVFUYHUKXIAHEUSUYHUNXIAUXMUYHUXNXI
      AVBUWTVEVFUWTVGVEVFVADIVHUYHUOXIAUYEUYHUQXIALVCZEUSZIWTUYTXGZUYHAVUAVAFIU
      YTNOUBUDUEAEFUYTUFYKXHZYLAVUAMVCZEUSZDIUVMUYTVDZUVMVUDVDZUUFVKYMEUSZUYHUG
      YNAVUAVUEDIVUFVUGUUEVKYMEUSZUYHUHYNARVCZWTUSZDIVUJYMEUSZUYHUIYLAUYHUUGUUH
      UYIUYRUWCUREUYIUYJEUSZUYRUWCUYIVUMVAZUYRVAZBURRDEIJLMUVPDIVGYMZPDIVGUYKVJ
      VKYMZVUNUYRDUYIVUMDUYSVUMDYIYJUYMUYOUYQDUYLDIYOUYNDPYOUYPDUVTYOUUIYJVUQYP
      VUPYPPUXBIUCUXADIUUJUUKUYIVUMUYRUULZVUOAVUMIWTUYJXGAUYHVUMUYRUUPZVURAVUMV
      AFIUYJNOUBUDUEAEFUYJUFYKXHYQVUOAVUAVUBVUSVUCYRVUOAVUAVUEVUHVUSUGYSVUOAVUA
      VUEVUIVUSUHYSVUOAVUKVULVUSUIYRAUYHVUMUYRUUQVUNUYMUYOUYQUUMVUNUYMUYOUYQUUN
      VUNUYMUYOUYQUUOUURUUSUUTUVAYGYHUVBUWNUWECPNUWFPXAZUWIUVLUWMUWDVUTUWGUVJUW
      HUVKUWFPQUVCUWFPJUVDYTVUTUWLUWCKVOVUTUWKUWBBEVUTUWJUVRUVOUWAUVQDUWFPDUWFV
      RUYGUVFUVEUVGUVHYTUVIYQ $.
  $}

  ${
    $d f g h i m q t y T $.  $d f i m q r t T $.  $d f i m q t x T $.
    $d f g h m q t A $.  $d f g i m q y Q $.  $d f g h i m q y U $.
    $d f g h m q t y Z $.  $d f g h i m q y ph $.  $d g h i m t w T $.
    $d g i m W $.  $d h i m q s t T $.  $d h i m q t u T $.  $d h t u w J $.
    $d i k m q r s $.  $d m p q t y T $.  $d m q t z $.  $d p q t A $.
    $d p q y U $.  $d p q t y Z $.  $d r t A $.  $d r s U $.  $d r ph $.
    $d t K $.  $d u w Q $.  $d u w U $.  $d u W $.  $d u w ph $.  $d x A $.
    $d x Q $.  $d x U $.  $d x Z $.  $d x ph $.  $d z Q $.
    stoweidlem53.1 $e |- F/_ t U $.
    stoweidlem53.2 $e |- F/ t ph $.
    stoweidlem53.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem53.4 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem53.5 $e |- W = { w e. J | E. h e. Q w =
          { t e. T | 0 < ( h ` t ) } } $.
    stoweidlem53.6 $e |- T = U. J $.
    stoweidlem53.7 $e |- C = ( J Cn K ) $.
    stoweidlem53.8 $e |- ( ph -> J e. Comp ) $.
    stoweidlem53.9 $e |- ( ph -> A C_ C ) $.
    stoweidlem53.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem53.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem53.12 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem53.13 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem53.14 $e |- ( ph -> U e. J ) $.
    stoweidlem53.15 $e |- ( ph -> ( T \ U ) =/= (/) ) $.
    stoweidlem53.16 $e |- ( ph -> Z e. U ) $.
    $( This lemma is used to prove the existence of a function p as in Lemma 1
       of [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p <=
       1, p_(t_0) = 0, and p > 0 on T - U. (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem53 $p |- ( ph -> E. p e. A ( A. t e. T ( 0 <_ ( p ` t ) /\
      ( p ` t ) <_ 1 ) /\ ( p ` Z ) = 0 /\ A. t e. ( T \ U ) 0 < ( p ` t ) ) )
                 $=
      ( vm vi vu vy cv cn wcel c1 cfz co cc0 cfv clt wbr wrex cdif wral wex cle
      wf wceq w3a cfn wss cuni stoweidlem50 crab cmpt nfv nfcv nfra1 nfan nfrab
      nfcxfr nfrab1 nfeq2 nfrex nfss nfdif nf3an nfre1 eqid cvv ccn ctop cmptop
      wa ccmp syl cioo crn ctg retop eqeltri cnfex syl6sseq ssexd adantr simpr1
      sylancl simpr2 simpr3 c0 wne stoweidlem35 exlimddv cdiv cmul nfral simprl
      csu simprrl simprrr caddc 3adant1r adantlr elssuni syl6sseqr stoweidlem44
      nff cr sseldd ex exlimdvv mpd ) AUPUTZVAVBZVCUUAVDVEZGRUTZVOZVFDUTZUQUTUU
      DVGVGVHVIZUQUUCVJZDHIVKZVLZXBZXBZRVMUPVMZVFUUFSUTZVGZVNVIUUOVCVNVIXBDHVLP
      UUNVGVFVPVFUUOVHVIDUUIVLVQSEVJZAURUTZVRVBZUUQOVSZUUIUUQVTZVSZVQZUUMURABCU
      RDEFGHIJKLMNOPQRTUAUBUCUDUEUFUGUHUIUJUKULUMUOWAAUVBXBCDEGHILUQUPCUUQCUTZV
      FUUFLUTZVGZVHVIZDHWBZVPZLGWBWCZMOUUQPRAUVBDUAUURUUSUVADUURDWDDUUQODUUQWED
      OUVHLGVJZCMWBZUDUVJDCMUVHDLGDGPUVDVGVFVPZVFUVEVNVIUVEVCVNVIXBZDHVLZXBZLEW
      BUCUVODLEUVLUVNDUVLDWDUVMDHWFWGDEWEWHWIZDUVCUVGUVFDHWJWKWLDMWEWHWIWMDUUIU
      UTDHIDHWETWNDUUTWEWMWOWGAUVBCACWDUURUUSUVACUURCWDCUUQOCUUQWECOUVKUDUVJCMW
      JWIWMUVACWDWOWGAUVBLALWDUURUUSUVALUURLWDLUUQOLUUQWELOUVKUDUVJLCMUVHLGWPLM
      WEWHWIWMUVALWDWOWGUCUDUVIWQAEWRVBUVBAEMNWSVEZWRAMWTVBZNWTVBUVQWRVBAMXCVBU
      VRUGMXAXDNXEXFXGVGWTUBXHXIMNXJXOAEFUVQUHUFXKZXLXMAUURUUSUVAXNAUURUUSUVAXP
      AUURUUSUVAXQAUUIXRXSUVBUNXMXTYAAUULUUPUPRAUULUUPAUULXBBDEDHVCUUAYBVEUUCUU
      FUSUTUUDVGVGUSYFYCVEWCZGHIJKLUSUQUUDMNUUAPSAUULUQAUQWDUUBUUKUQUUBUQWDUUEU
      UJUQUUEUQWDUUHUQDUUIUQUUIWEUUGUQUUCWPYDWGWGWGAUULDUAUUBUUKDUUBDWDUUEUUJDD
      UUCGUUDDUUDWEDUUCWEUVPYOUUHDUUIWFWGWGWGUBUCUVTWQAUUBUUKYEAUUBUUEUUJYGAUUB
      UUEUUJYHUEAEUVQVSUULUVSXMAJUTZEVBZKUTZEVBZDHUUFUWAVGZUUFUWCVGZYIVEWCEVBUU
      LUIYJAUWBUWDDHUWEUWFYCVEWCEVBUULUJYJABUTZYPVBDHUWGWCEVBUULUKYKAPHVBUULAIH
      PAIMVBZIHVSUMUWHIMVTHIMYLUEYMXDUOYQXMYNYRYSYT $.
  $}

  ${
    $d f g h i t y z T $.  $d f g h t y z A $.  $d f g i y B $.
    $d f g i y z E $.  $d f g z F $.  $d f g h i t z M $.  $d f g i z W $.
    $d f g i z Y $.  $d f g ph $.  $d i t w y z T $.  $d i y D $.
    $d t x y z A $.  $d w y B $.  $d w y z E $.  $d w z M $.  $d w z W $.
    $d w z Y $.  $d x y B $.  $d x y D $.  $d x y z E $.  $d x z M $.
    $d x z P $.  $d x y z T $.  $d z V $.
    stoweidlem54.1 $e |- F/ i ph $.
    stoweidlem54.2 $e |- F/ t ph $.
    stoweidlem54.3 $e |- F/ y ph $.
    stoweidlem54.4 $e |- F/ w ph $.
    stoweidlem54.5 $e |- T = U. J $.
    stoweidlem54.6 $e |-
          Y = { h e. A | A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) } $.
    stoweidlem54.7 $e |- P = ( f e. Y , g e. Y |->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) ) $.
    stoweidlem54.8 $e |- F = ( t e. T |->
          ( i e. ( 1 ... M ) |-> ( ( y ` i ) ` t ) ) ) $.
    stoweidlem54.9 $e |- Z = ( t e. T |-> ( seq 1 ( x. , ( F ` t ) ) ` M ) ) $.
    stoweidlem54.10 $e |- V = { w e. J | A. e e. RR+ E. h e. A ( A. t e. T ( 0
          <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) /\ A. t e. w ( h ` t )
      < e /\ A. t e. ( T \ U ) ( 1 - e ) < ( h ` t ) ) } $.
    stoweidlem54.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem54.12 $e |- ( ( ph /\ f e. A ) -> f : T --> RR ) $.
    stoweidlem54.13 $e |- ( ph -> M e. NN ) $.
    stoweidlem54.14 $e |- ( ph -> W : ( 1 ... M ) --> V ) $.
    stoweidlem54.15 $e |- ( ph -> B C_ T ) $.
    stoweidlem54.16 $e |- ( ph -> D C_ U. ran W ) $.
    stoweidlem54.17 $e |- ( ph -> D C_ T ) $.
    stoweidlem54.18 $e |- ( ph -> E. y ( y : ( 1 ... M ) --> Y /\ A. i e. ( 1
          ... M ) ( A. t e. ( W ` i ) ( ( y ` i ) ` t ) < ( E / M )
      /\ A. t e. B ( 1 - ( E / M ) ) < ( ( y ` i ) ` t ) ) ) ) $.
    stoweidlem54.19 $e |- ( ph -> T e. _V ) $.
    stoweidlem54.20 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem54.21 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( There exists a function ` x ` as in the proof of Lemma 2 in
       [BrosowskiDeutsh] p. 91.  Here ` D ` is used to represent ` A ` in the
       paper, because here ` A ` is used for the subalgebra of functions. ` E `
       is used to represent &epsilon; in the paper.  (Contributed by Glauco
       Siliprandi, 20-Apr-2017.) $)
    stoweidlem54 $p |- ( ph -> E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\
          ( x ` t ) <_ 1 ) /\ A. t e. D ( x ` t ) < E /\
          A. t e. B ( 1 - E ) < ( x ` t ) ) ) $=
      ( cv wcel cc0 cfv cle wbr c1 wa wral clt cmin co w3a wex wrex cfz wf cdiv
      nfv cseq nfra1 nfan nfcv crab nfrab nfcxfr nff nfral cdif crp nfrab1 eqid
      cn adantr simprl simpr rabeq2i simplbi cuni elssuni syl6sseqr 3syl r19.26
      wss crn ad2antll r19.21bi simprbi cmul cmpt 3adant1r adantlr stoweidlem51
      cr cvv c3 exlimdd df-rex sylibr ) ABVFZFVGVHEVFZYEVIZVJVKYGVLVJVKVMEJVNYG
      QVOVKEHVNVLQVPVQYGVOVKEGVNVRZVMBVSZYHBFVTAVLTWAVQZUCCVFZWBZYFPVFZYKVIVIZQ
      TWCVQZVOVKZEYMUBVIZVNZVLYOVPVQYNVOVKZEGVNZVMZPYJVNZVMZYICUGYICWDVBAUUCVMZ
      BDEFGHIJYKMNOPQRTUAUBTIYKVLWEVIZUCUDAUUCPUEYLUUBPYLPWDUUAPYJWFWGWGAUUCEUF
      YLUUBEEYJUCYKEYKWHEYJWHZEUCVHYFOVFVIZVJVKUUGVLVJVKVMZEJVNZOFWIUJUUIEOFUUH
      EJWFEFWHWJWKWLUUAEPYJUUFYRYTEYPEYQWFYSEGWFWGWMWGWGAUUCDUHUUCDWDWGDUAUUIUU
      GLVFZVOVKEDVFZVNVLUUJVPVQUUGVOVKEJKWNVNVROFVTLWOVNZDSWIUNUULDSWPWKUJUKUUE
      WQULUMATWRVGUUCUQWSAYJUAUBWBUUCURWSAYLUUBWTUUDUUKUAVGZVMUUMUUKSVGZUUKJXIU
      UDUUMXAUUMUUNUULUULDUASUNXBXCUUNUUKSXDJUUKSXEUIXFXGAHUBXJXDXIUUCUTWSAHJXI
      UUCVAWSAGJXIUUCUSWSUUDYRPYJUUBYRPYJVNZAYLUUBUUOYTPYJVNZYRYTPYJXHZXCXKXLUU
      DYTPYJUUBUUPAYLUUBUUOUUPUUQXMXKXLAMVFZFVGZNVFZFVGEJYFUURVIYFUUTVIXNVQXOFV
      GUUCUOXPAUUSJXSUURWBUUCUPXQAJXTVGUUCVCWSAQWOVGUUCVDWSAQVLYAWCVQVOVKUUCVEW
      SXRYBYHBFYCYD $.
  $}

  ${
    $d f g h q t z T $.  $d f g q r t A $.  $d f h q t x z T $.
    $d f g q z Q $.  $d f g h q U $.  $d f g h q t z Z $.  $d f g h q ph $.
    $d g h t w z T $.  $d g z W $.  $d h q t x A $.  $d h t w z J $.
    $d p q t z T $.  $d p q t A $.  $d p q U $.  $d p q t z Z $.  $d r t x A $.
    $d r t x T $.  $d r x U $.  $d r x ph $.  $d t z K $.  $d w x z Q $.
    $d w x U $.  $d w x ph $.  $d x z Z $.
    stoweidlem55.1 $e |- F/_ t U $.
    stoweidlem55.2 $e |- F/ t ph $.
    stoweidlem55.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem55.4 $e |- ( ph -> J e. Comp ) $.
    stoweidlem55.5 $e |- T = U. J $.
    stoweidlem55.6 $e |- C = ( J Cn K ) $.
    stoweidlem55.7 $e |- ( ph -> A C_ C ) $.
    stoweidlem55.8 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
         ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem55.9 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
         ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem55.10 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem55.11 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem55.12 $e |- ( ph -> U e. J ) $.
    stoweidlem55.13 $e |- ( ph -> Z e. U ) $.
    stoweidlem55.14 $e |- Q = { h e. A | ( ( h ` Z ) = 0 /\
          A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) ) } $.
    stoweidlem55.15 $e |- W = { w e. J | E. h e. Q w =
        { t e. T | 0 < ( h ` t ) } } $.
    $( This lemma proves the existence of a function p as in the proof of Lemma
       1 in [BrosowskiDeutsh] p. 90: p is in the subalgebra, such that 0 <= p
       <= 1, p_(t_0) = 0, and p > 0 on T - U. Here Z is used to represent t_0
       in the paper.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem55 $p |- ( ph -> E. p e. A ( A. t e. T ( 0 <_ ( p ` t ) /\
       ( p ` t ) <_ 1 ) /\ ( p ` Z ) = 0 /\ A. t e. ( T \ U ) 0 < ( p ` t ) ) )
                $=
      ( cdif c0 wceq cc0 cv cfv cle wbr wral clt w3a wrex cmpt wcel stoweidlem4
      c1 wa cr 0re mpan2 adantr nfcv nfdif nfeq nfan 0le0 cc 0cn eqid syl5breqr
      fvmpt2 adantl 0le1 syl6eqbr jca ralrimi cuni elunii syl6eleqr eqidd fvmpt
      c0ex 3syl rzalf nfmpt1 fveq1 breq2d breq1d ralbid eqeq1d 3anbi123d rspcev
      ex anbi12d syl13anc wn nfn ccmp wss caddc 3adant1r cmul adantlr wne df-ne
      co biimpri stoweidlem53 pm2.61dan ) AHIUOZUPUQZURDUSZSUSZUTZVAVBZYHVJVAVB
      ZVKZDHVCZPYGUTZURUQZURYHVDVBZDYDVCZVEZSEVFZAYEVKZDHURVGZEVHZURYFYTUTZVAVB
      ZUUBVJVAVBZVKZDHVCZPYTUTZURUQZURUUBVDVBZDYDVCZYRAUUAYEAURVLVHUUAVMABDEURH
      UIVIVNVOYSUUEDHAYEDUADYDUPDHIDHVPTVQDUPVPVRZVSYSYFHVHZUUEYSUULVKUUCUUDUUL
      UUCYSUULURURUUBVAVTUULURWAVHUUBURUQWBDHURWAYTYTWCZWEVNZWDWFUULUUDYSUULUUB
      URVJVAUUNWGWHWFWIXGWJAUUHYEAPIVHZIMVHZVKZPHVHUUHAUUOUUPULUKWIUUQPMWKHPIMW
      LUDWMDPURURHYTYFPUQURWNUUMWPWOWQVOYEUUJAUUIDYDUUKWRWFYQUUFUUHUUJVESYTEYGY
      TUQZYLUUFYNUUHYPUUJUURYKUUEDHDYGYTDYGVPDHURWSVRZUURYIUUCYJUUDUURYHUUBURVA
      YFYGYTWTZXAUURYHUUBVJVAUUTXBXHXCUURYMUUGURPYGYTWTXDUURYOUUIDYDUUSUURYHUUB
      URVDUUTXAXCXEXFXIAYEXJZVKBCDEFGHIJKLMNOPQRSTAUVADUAYEDUUKXKVSUBUMUNUDUEAM
      XLVHUVAUCVOAEFXMUVAUFVOAJUSZEVHZKUSZEVHZDHYFUVBUTZYFUVDUTZXNXTVGEVHUVAUGX
      OAUVCUVEDHUVFUVGXPXTVGEVHUVAUHXOABUSZVLVHDHUVHVGEVHUVAUIXQAQUSZHVHUULUVIY
      FXRVEUVIRUSZUTYFUVJUTXRREVFUVAUJXQAUUPUVAUKVOUVAYDUPXRZAUVKUVAYDUPXSYAWFA
      UUOUVAULVOYBYC $.
  $}

  ${
    $d d e f g p t A $.  $d d e p t v x A $.  $d d e f p t y A $.
    $d d g p t J $.  $d d e f g p t T $.  $d d e f g p U $.
    $d d e f g p t Z $.  $d d e f g p ph $.  $d f g h q t A $.
    $d f g q r t A $.  $d g h t w A $.  $d h q t y A $.  $d h t w J $.
    $d h q t y T $.  $d h q y U $.  $d h q t y Z $.  $d h q y ph $.
    $d p q t y A $.  $d r t y A $.  $d r t y T $.  $d r y U $.  $d r y ph $.
    $d t z $.  $d t K $.  $d v J $.  $d v x T $.  $d v x U $.  $d v Z $.
    $d w y A $.  $d w y T $.  $d w y U $.  $d w y Z $.  $d w y ph $.
    stoweidlem56.1 $e |- F/_ t U $.
    stoweidlem56.2 $e |- F/ t ph $.
    stoweidlem56.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem56.4 $e |- ( ph -> J e. Comp ) $.
    stoweidlem56.5 $e |- T = U. J $.
    stoweidlem56.6 $e |- C = ( J Cn K ) $.
    stoweidlem56.7 $e |- ( ph -> A C_ C ) $.
    stoweidlem56.8 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem56.9 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem56.10 $e |- ( ( ph /\ y e. RR ) -> ( t e. T |-> y ) e. A ) $.
    stoweidlem56.11 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem56.12 $e |- ( ph -> U e. J ) $.
    stoweidlem56.13 $e |- ( ph -> Z e. U ) $.
    $( This theorem proves Lemma 1 in [BrosowskiDeutsh] p. 90.  Here ` Z ` is
       used to represent t_0 in the paper, ` v ` is used to represent ` V ` in
       the paper, and ` e ` is used to represent &epsilon; (Contributed by
       Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem56 $p |- ( ph -> E. v e. J ( ( Z e. v /\ v C_ U ) /\
        A. e e. RR+ E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\ ( x ` t ) <_ 1 )
          /\ A. t e. v ( x ` t ) < e /\ A. t e. ( T \ U )
          ( 1 - e ) < ( x ` t ) ) ) ) $=
      ( vd vp vw vh cv crp wcel c1 clt wbr cc0 cfv cle wa wral wceq w3a wex wss
      cdif cmin co wrex crab stoweidlem55 df-rex sylib simpl simprl simprr3 nfv
      eqid nfra1 nf3an ccmp 3ad2ant1 sselda syl6eleq 3adant3 simp3 stoweidlem28
      ccn syl3anc simpr1 simpr2 simplrl simprr1 adantr simprr2 simpr3 ex eximdv
      3jca jca mpd c2 cdiv nfan nfcv cmpt 3adant1r cmul adantlr simpr3l simp3r1
      caddc cr adantl simp3r2 simp3r3 stoweidlem52 exlimdvv ) AUKUOZUPUQZYCURUS
      UTZULUOZFUQZVAEUOZYFVBZVCUTYIURVCUTVDZEHVEZOYFVBVAVFZYCYIVCUTZEHIVJZVEZVG
      ZVDZVGZUKVHZULVHZODUOZUQUUAIVIVDVAYHBUOVBZVCUTUUBURVCUTVDEHVEUUBJUOZUSUTE
      UUAVEURUUCVKVLUUBUSUTEYNVEVGBFVMJUPVEVDDMVMZAYGYKYLVAYIUSUTZEYNVEZVGZVDZU
      LVHZYTAUUGULFVMUUIACUMEFGOUNUOZVBVAVFVAYHUUJVBZVCUTUUKURVCUTVDEHVEVDUNFVN
      ZHIKLUNMNUMUOVAUUKUSUTEHVNVFUNUULVMUMMVNZOPQULRSTUAUBUCUDUEUFUGUHUIUJUULW
      BUUMWBVOUUGULFVPVQAUUHYSULAUUHYSAUUHVDZYDYEYOVGZUKVHZYSUUNAYGUUFUUPAUUHVR
      AYGUUGVSYKYLUUFYGAVTAYGUUFVGEYFHIMNUKRAYGUUFESYGEWAZUUEEYNWCWDTUBAYGMWEUQ
      UUFUAWFAYGYFMNWLVLZUQUUFAYGVDYFGUURAFGYFUDWGUCWHWIAYGUUFWJAYGIMUQZUUFUIWF
      WKWMUUNUUOYRUKUUNUUOYRUUNUUOVDZYDYEYQUUNYDYEYOWNUUNYDYEYOWOUUTYGYPAYGUUGU
      UOWPUUTYKYLYOUUNYKUUOYKYLUUFYGAWQWRUUNYLUUOYKYLUUFYGAWSWRUUNYDYEYOWTXCXDX
      CXAXBXEXAXBXEAYRUUDULUKAYRUUDAYRVDBDEFGYCYFHIJKLMNYIYCXFXGVLUSUTEHVNZOCRA
      YRESYDYEYQEYDEWAYEEWAYGYPEUUQYKYLYOEYJEHWCYLEWAYMEYNWCWDXHWDXHEYFXITUVAWB
      UBUCAFGVIYRUDWRAKUOZFUQZLUOZFUQZEHYHUVBVBZYHUVDVBZXPVLXJFUQYRUEXKAUVCUVEE
      HUVFUVGXLVLXJFUQYRUFXKACUOZXQUQEHUVHXJFUQYRUGXMAYDYEYQWNAYDYEYQWOAUUSYRUI
      WRAOIUQYRUJWRYGYPYDYEAXNYRYKAYKYLYOYGYDYEXOXRYRYLAYKYLYOYGYDYEXSXRYRYOAYK
      YLYOYGYDYEXTXRYAXAYBXE $.
  $}

  ${
    $d a e f s t $.  $d a f q r s t $.  $d a e f t A $.  $d a e f s D $.
    $d a e f t T $.  $d a e f U $.  $d a e f s ph $.  $d e f g h m t A $.
    $d e h m t w A $.  $d e f g h m t E $.  $d f g h i m r t v y A $.
    $d f g h m t v x y A $.  $d f g i m r v y B $.  $d f g i m r v y V $.
    $d f g i r y Y $.  $d g q r s t $.  $d g h i m r v y D $.  $d g h t J $.
    $d g h i m r t v y T $.  $d g h i r y U $.  $d g h i m r v y ph $.
    $d i m r t v w y A $.  $d i m r t v w y E $.  $d k u D $.  $d k u J $.
    $d k u T $.  $d k u V $.  $d q r t A $.  $d q r s D $.  $d q r t T $.
    $d q r U $.  $d q r s ph $.  $d r u w D $.  $d s t w $.  $d s z V $.
    $d s w B $.  $d t K $.  $d u w ph $.  $d w J $.  $d w y T $.  $d w y U $.
    $d w y Y $.  $d x y B $.  $d x y D $.  $d x y E $.  $d x y T $.
    stoweidlem57.1 $e |- F/_ t D $.
    stoweidlem57.2 $e |- F/_ t U $.
    stoweidlem57.3 $e |- F/ t ph $.
    stoweidlem57.4 $e |- Y = { h e. A | A. t e. T ( 0 <_ ( h ` t ) /\
          ( h ` t ) <_ 1 ) } $.
    stoweidlem57.5 $e |- V = { w e. J | A. e e. RR+ E. h e. A
          ( A. t e. T ( 0 <_ ( h ` t ) /\ ( h ` t ) <_ 1 ) /\
      A. t e. w ( h ` t ) < e /\ A. t e. ( T \ U ) ( 1 - e ) < ( h ` t ) ) } $.
    stoweidlem57.6 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem57.7 $e |- T = U. J $.
    stoweidlem57.8 $e |- C = ( J Cn K ) $.
    stoweidlem57.9 $e |- U = ( T \ B ) $.
    stoweidlem57.10 $e |- ( ph -> J e. Comp ) $.
    stoweidlem57.11 $e |- ( ph -> A C_ C ) $.
    stoweidlem57.12 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem57.13 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem57.14 $e |- ( ( ph /\ a e. RR ) -> ( t e. T |-> a ) e. A ) $.
    stoweidlem57.15 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem57.16 $e |- ( ph -> B e. ( Clsd ` J ) ) $.
    stoweidlem57.17 $e |- ( ph -> D e. ( Clsd ` J ) ) $.
    stoweidlem57.18 $e |- ( ph -> ( B i^i D ) = (/) ) $.
    stoweidlem57.19 $e |- ( ph -> D =/= (/) ) $.
    stoweidlem57.20 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem57.21 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( There exists a function x as in the proof of Lemma 2 in
       [BrosowskiDeutsh] p. 91.  In this theorem, it is proven the non-trivial
       case (the closed set D is nonempty).  Here D is used to represent A in
       the paper, because the variable A is used for the subalgebra of
       functions.  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem57 $p |- ( ph -> E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\
          ( x ` t ) <_ 1 ) /\ A. t e. D ( x ` t ) < E /\ A. t e. B ( 1 - E ) <
          ( x ` t ) ) ) $=
      ( vm vv vy vi vu vs vk c1 cv co wf crn cuni wss cfv cdiv clt wral cmin wa
      wbr wex w3a cn wrex cc0 cle wne cpw cfn cin wcel cdif crp nfcri nfan ccmp
      c0 adantr cmpt 3adant1r cmul cr adantlr ccld ctop wb mpbid syl5eqel cldss
      3syl syl sselda wceq sylanbrc nfcv crab nfcxfr sylibr ex wi syl2anc unieq
      cvv sseq2d mpd nfv nfral nfrab nfpw nfin nf3an 3ad2ant1 nff eqid ad2antrr
      nfra1 cfz caddc cmptop iscld simprd disjr sylib r19.21bi eldifd syl6eleqr
      stoweidlem56 simpl simprll simprr rabeq2i jca32 rexex nfrab1 elunif ssrdv
      wn reximi2 crest cmpcld cmpsub ssrab2 eqsstri elfvexd rabexg elpwg mpbiri
      pweq ineq1d rexeqdv imbi12d rspccva csn simplbi elpwi ssdifssd vex difexg
      elin ax-mp elpw simprbi 3ad2ant2 unidif0 sseq2i biimpri 3ad2ant3 eldifsni
      diffi rgen a1i raleq anbi12d rspcev syl12anc rexlimdv3a nfre1 nfrex simp2
      nfss simp3l simpld ccn cioo ctg retop eqeltri cnfex syl6sseq stoweidlem39
      sylancl ssexd cmpt2 cseq nfex nfe1 simp1ll syld3an1 fcnre sylancom simplr
      simplll simpr1 simpr2 feq3 biimpi anim1i eximi adantl uniexg stoweidlem54
      c3 exlimdv rexlimdva ) AVKVDVLZUUAVMZRVEVLZVNZHVUAVOVPZVQZUYTSVFVLZVNZDVL
      ZVGVLZVUEVRVRZOUYSVSVMZVTWDZDVUHVUAVRZWAZVKVUJWBVMVUIVTWDZDFWAZWCZVGUYTWA
      ZWCZVFWEZWFZVEWEZVDWGWHZWIVUGBVLVRZWJWDVVCVKWJWDWCDIWAVVCOVTWDDHWAVKOWBVM
      VVCVTWDDFWAWFBEWHZAHTVLZVPZVQZCVLZXAWKZCVVEWAZWCZTRWLZWMWNZWHZVVBAHVHVLZV
      PZVQZVHVVMWHZVVNAHRVPZVQZVVRAVIHVVSAVIVLZHWOZVWAVVSWOZAVWBWCZVWAVVHWOZVVH
      RWOZWCZCWEZVWCVWDVWEVVHJVQZWCZWIVUGNVLVRZWJWDVWKVKWJWDWCZDIWAZVWKKVLZVTWD
      ZDVVHWAZVKVWNWBVMVWKVTWDZDIJWPZWAZWFZNEWHZKWQWAZWCZCPWHVWGCPWHVWHVWDNUBCD
      EGIJKLMPQVWATUAUDAVWBDUEDVIHUCWRWSUHAPWTWOZVWBULXBUIUJAEGVQVWBUMXBALVLZEW
      OZMVLZEWOZDIVUGVXEVRZVUGVXGVRZUUBVMXCEWOVWBUNXDAVXFVXHDIVXIVXJXEVMXCZEWOZ
      VWBUOXDAUBVLZXFWODIVXMXCEWOVWBUPXGAVVEIWOVUGIWOVVEVUGWKWFVVEUAVLZVRVUGVXN
      VRWKUAEWHVWBUQXGAJPWOVWBAJIFWPZPUKAFIVQZVXOPWOZAFPXHVRZWOZVXPVXQWCZURAVXD
      PXIWOZVXSVXTXJULPUUCZFPIUIUUDXNXKZUUEXLXBVWDVWAVXOJVWDVWAIFAHIVWAAHVXRWOZ
      HIVQZUSHPIUIXMXOZXPAVWAFWOUVAZVIHAFHWNXAXQVYGVIHWAUTVIFHUUFUUGUUHUUIUKUUJ
      UUKVXCVWGCPPVVHPWOZVXCWCZVYHVWEVWFVYHVXCUULZVYHVWEVWIVXBUUMVYIVYHVXBVWFVY
      JVYHVWJVXBUUNVXBCRPUGUUOXRUUPUVBVWGCPUUQXNCVWARCVWAXSCRVXBCPXTZUGVXBCPUUR
      YAZUUSYBYCUUTAHVJVLZVPZVQZVVQVHVYMWLZWMWNZWHZYDZVJPWLZWAZRVYTWOZVVTVVRYDZ
      APHUVCVMWTWOZWUAAVXDVYDWUDULUSHPUVDYEAVYAVYEWUDWUAXJAVXDVYAULVYBXOZVYFHPI
      VJVHUIUVEYEXKAWUBRPVQZRVYKPUGVXBCPUVFUVGARYGWOZWUBWUFXJARVYKYGUGAPYGWOVYK
      YGWOAFXHPURUVHVXBCPYGUVIXOXLZRPYGUVJXOUVKVYSWUCVJRVYTVYMRXQZVYOVVTVYRVVRW
      UIVYNVVSHVYMRYFYHWUIVVQVHVYQVVMWUIVYPVVLWMVYMRUVLUVMUVNUVOUVPYEYIAVVQVVNV
      HVVMAVVOVVMWOZVVQWFZVVOXAUVQZWPZVVMWOZHWUMVPZVQZVVICWUMWAZVVNWUJAWUNVVQWU
      JWUMVVLWOZWUMWMWOZWUNWUJVVOVVLWOZWURWUJWUTVVOWMWOZVVOVVLWMUWCZUVRWUTWUMRV
      QWURWUTVVORWULVVORUVSUVTWUMRVVOYGWOWUMYGWOVHUWAVVOWULYGUWBUWDUWEYBXOWUJWV
      AWUSWUJWUTWVAWVBUWFVVOWULUWMXOWUMVVLWMUWCXRUWGVVQAWUPWUJWUPVVQWUOVVPHVVOU
      WHUWIUWJUWKWUQWUKVVICWUMVVHVVOXAUWLUWNUWOVVKWUPWUQWCTWUMVVMVVEWUMXQZVVGWU
      PVVJWUQWVCVVFWUOHVVEWUMYFYHVVICVVEWUMUWPUWQUWRUWSUWTYIAVVKVVBTVVMAVVEVVMW
      OZVVKWFVFCVEDEFHIJKNVGVDOPRSTAWVDVVKNANYJNTVVMNVVLWMNRNRVYKUGVXBNCPVXANKW
      QNWQXSVWTNEUXAYKNPXSYLYAYMNWMXSYNWRVVKNYJYOAWVDVVKDUEDTVVMDVVLWMDRDRVYKUG
      VXBDCPVXADKWQDWQXSVWTDNEDEXSZVWMVWPVWSDVWLDIYTZVWODVVHYTVWQDVWRYTYOUXBYKD
      PXSYLYAZYMDWMXSYNWRVVGVVJDDHVVFUCDVVFXSUXDVVJDYJWSYOAWVDVVKCACYJCTVVMCVVL
      WMCRVYLYMCWMXSYNWRVVGVVJCVVGCYJVVICVVEYTWSYOUKUFUGAWVDVVKUXCAWVDVVGVVJUXE
      AWVDHXAWKVVKVAYPAWVDOWQWOZVVKVBYPAWVDVXPVVKAVXPVXQVYCUXFYPAWVDWUGVVKWUHYP
      AWVDEYGWOVVKAEPQUXGVMZYGAVYAQXIWOWVIYGWOWUEQUXHVOUXIVRXIUHUXJUXKPQUXLUXOA
      EGWVIUMUJUXMUXPYPUXNUWTYIAVVAVVDVDWGAUYSWGWOZWCZVUTVVDVEWVKVUTVVDWVKVUTWC
      ZBVFCDEFHLMVWMNEXTZWVMVXKUXQZIJKLMNVGODIVGUYTVUIXCXCZPUYSRVUAWVMDIUYSXEVU
      GWVOVRVKUXRVRXCZWVKVUTVGWVKVGYJVUBVUDVUSVGVUBVGYJVUDVGYJVURVGVFVUFVUQVGVU
      FVGYJVUPVGUYTYTWSUXSYOWSWVKVUTDAWVJDUEWVJDYJWSVUBVUDVUSDDUYTRVUADVUAXSDUY
      TXSZWVGYQDHVUCUCDVUCXSUXDVURDVFVUFVUQDDUYTSVUEDVUEXSWVQDSWVMUFVWMDNEWVFWV
      EYLYAYQVUPDVGUYTWVQVUMVUODVUKDVULYTVUNDFYTWSYKWSUXSYOWSWVKVUTVFWVKVFYJVUB
      VUDVUSVFVUBVFYJVUDVFYJVURVFUXTYOWSWVKVUTCWVKCYJVUBVUDVUSCCUYTRVUACVUAXSCU
      YTXSVYLYQVUDCYJVUSCYJYOWSUIWVMYRWVNYRWVOYRWVPYRUGAVXFWVLVXHVXLAWVJVUTVXFV
      XHUYAUOUYBWVLVXFAIXFVXEVNAWVJVUTVXFUYFAVXFWCGIVXEPQUHUIUJAEGVXEUMXPUYCUYD
      AWVJVUTUYEWVKVUBVUDVUSUYGAVXPWVJVUTAVXSVXPURFPIUIXMXOYSWVKVUBVUDVUSUYHAVY
      EWVJVUTVYFYSVUTUYTWVMVUEVNZVUQWCZVFWEZWVKVUSVUBWVTVUDVURWVSVFVUFWVRVUQVUF
      WVRSWVMXQVUFWVRXJUFSWVMUYTVUEUYIUWDUYJUYKUYLUWKUYMAIYGWOWVJVUTAIPVPZYGUIA
      VXDWWAYGWOULPWTUYNXOXLYSAWVHWVJVUTVBYSAOVKUYPVSVMVTWDWVJVUTVCYSUYOYCUYQUY
      RYI $.
  $}

  ${
    $d a e f r t A $.  $d a f q r t A $.  $d a e f r D $.  $d a e f r t T $.
    $d a e f r U $.  $d a e f r ph $.  $d e f g h r t w A $.
    $d e f g h r t w E $.  $d f g h t x A $.  $d f g r w B $.
    $d f g h r t w J $.  $d g q r t A $.  $d g h r w D $.  $d g h r t w T $.
    $d g h r w U $.  $d g h r w ph $.  $d q r D $.  $d q r t T $.  $d q r U $.
    $d q r ph $.  $d t K $.  $d x B $.  $d x D $.  $d x E $.  $d x T $.
    stoweidlem58.1 $e |- F/_ t D $.
    stoweidlem58.2 $e |- F/_ t U $.
    stoweidlem58.3 $e |- F/ t ph $.
    stoweidlem58.4 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem58.5 $e |- T = U. J $.
    stoweidlem58.6 $e |- C = ( J Cn K ) $.
    stoweidlem58.7 $e |- ( ph -> J e. Comp ) $.
    stoweidlem58.8 $e |- ( ph -> A C_ C ) $.
    stoweidlem58.9 $e |- ( ( ph /\ f e. A /\ g e. A ) -> ( t e. T |->
          ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem58.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem58.11 $e |- ( ( ph /\ a e. RR ) -> ( t e. T |-> a ) e. A ) $.
    stoweidlem58.12 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem58.13 $e |- ( ph -> B e. ( Clsd ` J ) ) $.
    stoweidlem58.14 $e |- ( ph -> D e. ( Clsd ` J ) ) $.
    stoweidlem58.15 $e |- ( ph -> ( B i^i D ) = (/) ) $.
    stoweidlem58.16 $e |- U = ( T \ B ) $.
    stoweidlem58.17 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem58.18 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( This theorem proves Lemma 2 in [BrosowskiDeutsh] p. 91.  Here D is used
       to represent the set A of Lemma 2, because here the variable A is used
       for the subalgebra of functions.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem58 $p |- ( ph -> E. x e. A ( A. t e. T ( 0 <_ ( x ` t ) /\
          ( x ` t ) <_ 1 ) /\ A. t e. D ( x ` t ) < E /\ A. t e. B ( 1 - E ) <
          ( x ` t ) ) ) $=
      ( vw ve vh cc0 cv cfv cle wbr c1 wa wral clt cmin co wrex wceq cmpt nfeq1
      w3a c0 nfan eqid wcel adantlr ccld adantr crp simpr stoweidlem18 wne cdif
      cr crab nfcv nfne ccmp wss caddc 3adant1r cmul c3 stoweidlem57 pm2.61dane
      cin cdiv ) AUSCUTZBUTVAZVBVCXBVDVBVCVECHVFXBLVGVCCGVFVDLVHVIXBVGVCCEVFVNB
      DVJGVOAGVOVKZVEBCDEGHLCHVDVLZMQRAXCCTCGVORVMVPXDVQUBAQUTZWGVRZCHXEVLDVRZX
      CUHVSAEMVTVAZVRZXCUJWAALWBVRZXCUNWAAXCWCWDAGVOWEZVEBUPCDEFGHIUQJKURLMNUSX
      AURUTVAZVBVCXLVDVBVCVECHVFZXLUQUTZVGVCCUPUTVFVDXNVHVIXLVGVCCHIWFVFVNURDVJ
      UQWBVFUPMWHZXMURDWHZOPQRSAXKCTCGVORCVOWIWJVPXPVQXOVQUAUBUCUMAMWKVRXKUDWAA
      DFWLXKUEWAAJUTZDVRZKUTZDVRZCHXAXQVAZXAXSVAZWMVIVLDVRXKUFWNAXRXTCHYAYBWOVI
      VLDVRXKUGWNAXFXGXKUHVSAOUTZHVRXAHVRYCXAWEVNYCPUTZVAXAYDVAWEPDVJXKUIVSAXIX
      KUJWAAGXHVRXKUKWAAEGWSVOVKXKULWAAXKWCAXJXKUNWAALVDWPWTVIVGVCXKUOWAWQWR $.
  $}

  ${
    $d a j t w y $.  $d a y B $.  $d a y D $.  $d a w H $.  $d a j t y N $.
    $d a j Y $.  $d f g j q r t N $.  $d f g j t x N $.  $d f j q r t y N $.
    $d f g q r t A $.  $d f g q r B $.  $d f g q r D $.  $d f g r t E $.
    $d f g r t J $.  $d f g q r t T $.  $d f g j q r ph $.  $d h j t w y $.
    $d h j t x y N $.  $d h t x y A $.  $d h x y B $.  $d h x y D $.
    $d h t x y E $.  $d h w H $.  $d h t x y T $.  $d h j w y ph $.
    $d j t y z N $.  $d t K $.  $d x H $.  $d x Y $.  $d x y ph $.  $d z B $.
    $d z D $.  $d z E $.  $d z H $.  $d z Y $.
    stoweidlem59.1 $e |- F/_ t F $.
    stoweidlem59.2 $e |- F/ t ph $.
    stoweidlem59.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem59.4 $e |- T = U. J $.
    stoweidlem59.5 $e |- C = ( J Cn K ) $.
    stoweidlem59.6 $e |- D = ( j e. ( 0 ... N ) |->
          { t e. T | ( F ` t ) <_ ( ( j - ( 1 / 3 ) ) x. E ) } ) $.
    stoweidlem59.7 $e |- B = ( j e. ( 0 ... N ) |->
          { t e. T | ( ( j + ( 1 / 3 ) ) x. E ) <_ ( F ` t ) } ) $.
    stoweidlem59.8 $e |- Y = { y e. A | A. t e. T
          ( 0 <_ ( y ` t ) /\ ( y ` t ) <_ 1 ) } $.
    stoweidlem59.9 $e |- H = ( j e. ( 0 ... N ) |-> { y e. Y | ( A. t e.
       ( D ` j ) ( y ` t ) < ( E / N ) /\ A. t e. ( B ` j ) ( 1 - ( E / N ) ) <
      ( y ` t ) ) } ) $.
    stoweidlem59.10 $e |- ( ph -> J e. Comp ) $.
    stoweidlem59.11 $e |- ( ph -> A C_ C ) $.
    stoweidlem59.12 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem59.13 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem59.14 $e |- ( ( ph /\ y e. RR ) -> ( t e. T |-> y ) e. A ) $.
    stoweidlem59.15 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem59.16 $e |- ( ph -> F e. C ) $.
    stoweidlem59.17 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem59.18 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    stoweidlem59.19 $e |- ( ph -> N e. NN ) $.
    $( This lemma proves that there exists a function ` x ` as in the proof in
       [BrosowskiDeutsh] p. 91, after Lemma 2: x_j is in the subalgebra, 0 <=
       x_j <= 1, x_j < &epsilon; / n on A_j (meaning A in the paper), x_j > 1 -
       \epslon / n on B_j.  Here ` D ` is used to represent A in the paper
       (because A is used for the subalgebra of functions), ` E ` is used to
       represent &epsilon;.  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stoweidlem59 $p |- ( ph -> E. x ( x : ( 0 ... N ) --> A /\ A. j e.
       ( 0 ... N ) ( A. t e. T ( 0 <_ ( ( x ` j ) ` t ) /\ ( ( x ` j ) ` t ) <_
        1 ) /\ A. t e. ( D ` j ) ( ( x ` j ) ` t ) < ( E / N ) /\ A. t e. ( B `
          j ) ( 1 - ( E / N ) ) < ( ( x ` j ) ` t ) ) ) ) $=
      ( vh vw vz va cv crn c0 wne cfv wcel wi wral wa cc0 co wf cle wbr c1 cdiv
      clt w3a wex cfn crab cvv nfrab1 nfcxfr nfcv nfv weq breq1d ralbidv breq2d
      fveq1 anbi12d ctop syl sylancl wss a1i rabexg cmpt sylib nfra1 nfan simpr
      wceq wrex wb nffv nfeq fveq2 biimpa adantr fvmpt2 syl2anc c3 cmul adantlr
      nfmpt cr eqid adantl eqeltrd wn ad2antrr mpan2 mpbid eleq2d rabid ralrimi
      simprd ex nfcri nfral syl21anc imbi12d nfbr ralbid wfn cmin cbvrab cmptop
      cfz ccn ccmp cioo ctg retop eqeltri cnfex syl6sseq ssexd eqsstri syl5eqel
      ssrab2 ralrimivw fnmpt fzfi fnfi rnfi fnchoice ccom simprl ovex rnex fnex
      mptex coexg dffn3 cuni simplrr fvelrnb nfmpt1 eqeq1d cbvrex syl6bbr simp3
      cdif caddc nfdif 3adant1r ccld uniexg elfzelz zred 3re 3ne0 readdcl rpred
      rereccli remulcld syl6eleq rfcnpre3 rfcnpre4 cin syl6eqss sselda ffvelrnd
      resubcl fcnre id crp 3pos recgt0ii elrpii ltsubrp ltaddrp rpregt0d ltmul1
      lttrd syl3anc ltletrd ltnled intnand sylnibr neleqtrrd disj eleq1 cbvralf
      nfn notbid bitri sylibr nnrpd rpdivcld nndivred nnge1d 0lt1 pm3.2i nngt0d
      1re nnred lediv2 syl121anc rpcnd div1d breqtrd stoweidlem58 df-rex elrab2
      lelttrd simprr1 simprr2 simprr3 jca elrabf eximdv exlimiv eqnetrd 3adant3
      sylanbrc mpd ne0i eqnetrrd 3exp rexlimdv rsp chfnrn wal nfrn nffn fnunirn
      syl3c syl6bb nfuni simp1l simp2 simpld rexlimd alrimi dfss2f syl6ss sstrd
      fss fco simpll fvco2 sylancom wfun cdm fnfun fndm eleqtrrd fvelrn eleq12d
      neeq1 rspccva sylc nfco nfel nfim anbi2d vtoclgf anabsi7 eleq2i 3jca feq1
      nfrab fveq1d 3anbi123d spcegv exlimddv ) AVAVEZOVFZUUAZVBVEZVGVHZVXHVXEVI
      ZVXHVJZVKZVBVXFVLZVMZVNRUUEVOZEBVEZVPZVNDVEZLVEZVXPVIZVIZVQVRZVYAVSVQVRZV
      MZDIVLZVYAMRVTVOZWAVRZDVXSHVIZVLZVSVYFUUBVOZVYAWAVRZDVXSFVIZVLZWBZLVXOVLZ
      VMZBWCZVAAVXFWDVJZVXNVAWCAOWDVJZVYRAOVXOUUAZVXOWDVJVYSAVXRCVEZVIZVYFWAVRZ
      DVYHVLZVYJWUBWAVRZDVYLVLZVMZCSWEZWFVJZLVXOVLVYTAWUILVXOAWUHVXRVCVEZVIZVYF
      WAVRZDVYHVLZVYJWUKWAVRZDVYLVLZVMZVCSWEZWFWUGWUPCVCSCSVNWUBVQVRZWUBVSVQVRZ
      VMZDIVLZCEWEZUIWVACEWGWHZVCSWIWUGVCWJWUPCWJCVCWKZWUDWUMWUFWUOWVDWUCWULDVY
      HWVDWUBWUKVYFWAVXRWUAWUJWOZWLWMWVDWUEWUNDVYLWVDWUBWUKVYJWAWVEWNWMWPUUCASW
      FVJWUQWFVJASEWFAEPQUUFVOZWFAPWQVJZQWQVJWVFWFVJAPUUGVJZWVGUKPUUDWRQUUHVFUU
      IVIWQUDUUJUUKPQUULWSAEGWVFULUFUUMUUNSEWTASWVBEUIWVACEUUQUUOZXAUUNWUPVCSWF
      XBWRUUPZUURLVXOWUHOWFUJUUSWRZVNRUUTVXOOUVAWSOUVBWRVBVXFVAUVCWRAVXNVMZVXEO
      UVDZWFVJZVXOEWVMVPZVNVXRVXSWVMVIZVIZVQVRZWVQVSVQVRZVMZDIVLZWVQVYFWAVRZDVY
      HVLZVYJWVQWAVRZDVYLVLZWBZLVXOVLZVMZVYQWVLVXEWFVJZOWFVJWVNWVLVXGVXFWFVJWWI
      AVXGVXMUVEZOOLVXOWUHXCZWFUJLVXOWUHVNRUUEUVFUVIUUKZUVGVXFWFVXEUVHWSWWLVXEO
      WFWFUVJWSWVLWVOWWGWVLVXFEVXEVPZVXOVXFOVPZWVOWVLVXFVXEVFZVXEVPZWWOEWTWWMWV
      LVXGWWPWWJVXFVXEUVKXDWVLWWOVXFUVLZEWVLVXGVXKVBVXFVLWWOWWQWTWWJWVLVXKVBVXF
      AVXNVBAVBWJVXGVXMVBVXGVBWJVXLVBVXFXEXFXFWVLVXHVXFVJZVXKWVLWWRVMVXMWWRVXIV
      XKAVXGVXMWWRUVMWVLWWRXGAWWRVXIVXNAWWRVMVXSOVIZVXHXHZLVXOXIZVXIAWWRWXAAVYT
      WWRWXAXJWVKVYTWWRVDVEZOVIZVXHXHZVDVXOXIWXAVDVXOVXHOUVNWWTWXDLVDVXOWWTVDWJ
      LWXCVXHLWXBOLOWWKUJLVXOWUHUVOWHZLWXBWIXKLVXHWIXLLVDWKWWSWXCVXHVXSWXBOXMUV
      PUVQUVRWRXNAWXAVXIVKWWRAWWTVXILVXOAVXSVXOVJZWWTVXIAWXFWWTWBWWSVXHVGAWXFWW
      TUVSAWXFWWSVGVHZWWTAWXFVMZWWSWUHVGWXHWXFWUIWWSWUHXHAWXFXGZAWUIWXFWVJXOLVX
      OWUHWFOUJXPXQZWXHVXPWUHVJZBWCZWUHVGVHZWXHVXPEVJZVNVXRVXPVIZVQVRZWXOVSVQVR
      ZVMZDIVLZWXOVYFWAVRZDVYHVLZVYJWXOWAVRZDVYLVLZWBZVMZBWCZWXLWXHWYDBEXIWYFWX
      HBDEVYLGVYHIIVYLUVTZJKVYFPQTUACDVXSHDHLVXOVXRNVIZVXSVSXRVTVOZUUBVOZMXSVOZ
      VQVRZDIWEZXCUGDLVXOWYMDVXOWIZWYLDIWGYAWHDVXSWIZXKZDIVYLDIWIDVXSFDFLVXOVXS
      WYIUWAVOZMXSVOZWYHVQVRZDIWEZXCUHDLVXOWYTWYNWYSDIWGYAWHWYOXKZUWBAWXFDUCWXF
      DWJXFZUDUEUFAWVHWXFUKXOAEGWTWXFULXOAJVEZEVJZKVEZEVJZDIVXRXUCVIZVXRXUEVIZU
      WAVOXCEVJWXFUMUWCAXUDXUFDIXUGXUHXSVOXCEVJWXFUNUWCAWUAYBVJDIWUAXCEVJWXFUOX
      TATVEZIVJVXRIVJZXUIVXRVHWBXUIUAVEZVIVXRXUKVIVHUAEXIWXFUPXTWXHVYLWYTPUWDVI
      ZWXHWXFWYTWFVJZVYLWYTXHWXIWXHIWFVJZXUMAXUNWXFAIPUVLZWFUEAWVHXUOWFVJUKPUUG
      UWEWRUUPXOZWYSDIWFXBWRLVXOWYTWFFUHXPXQZWXHDWYTWYRINPQUBUDUEWYTYCWXHWYQMWX
      FWYQYBVJZAWXFVXSYBVJZWYIYBVJZXURWXFVXSVXSVNRUWFUWGZXRUWHUWIUWLZVXSWYIUWJZ
      WSYDZAMYBVJZWXFAMURUWKZXOZUWMZANWVFVJWXFANGWVFUQUFUWNXOZUWOYEWXHVYHWYMXUL
      WXHWXFWYMWFVJZVYHWYMXHZWXIWXHXUNXVJXUPWYLDIWFXBWRLVXOWYMWFHUGXPXQZWXHDWYM
      WYKINPQUBUDUEWYMYCWXHWYJMWXFWYJYBVJZAWXFXUSXUTXVMXVAXVBVXSWYIUXAZWSYDZXVG
      UWMZXVIUWPYEWXHVXRVYHVJZYFZDVYLVLZVYLVYHUWQVGXHZWXHXVRDVYLXUBWXHVXRVYLVJZ
      XVRWXHXWAVMZVYHWYMVXRXWBXUJWYLVMVXRWYMVJXWBWYLXUJXWBWYKWYHWAVRWYLYFXWBWYK
      WYRWYHWXHWYKYBVJXWAXVPXOZWXHWYRYBVJXWAXVHXOXWBIYBVXRNAIYBNVPWXFXWAAGINPQU
      DUEUFUQUXBYGWXHVYLIVXRWXHVYLWYTIXUQWYSDIUUQUWRUWSUWTZWXHWYKWYRWAVRZXWAWXH
      WYJWYQWAVRZXWEWXFXWFAWXFXUSXWFXVAXUSWYJVXSWYQXUSXUTXVMXVBXVNYHXUSUXCXUSXU
      TXURXVBXVCYHXUSWYIUXDVJZWYJVXSWAVRWYIXVBXRUWHUXEUXFUXGZVXSWYIUXHYHXUSXWGV
      XSWYQWAVRXWHVXSWYIUXIYHUXLWRYDWXHXVMXURXVEVNMWAVRVMZXWFXWEXJXVOXVDAXWIWXF
      AMURUXJZXOWYJWYQMUXKUXMYIXOXWBXUJWYSXWBVXRWYTVJZXUJWYSVMWXHXWAXWKWXHVYLWY
      TVXRXUQYJXNWYSDIYKXDYMUXNXWBWYKWYHXWCXWDUXOYIUXPWYLDIYKUXQWXHXVKXWAXVLXOU
      XRYNYLXVTWXBVYHVJZYFZVDVYLVLXVSVDVYLVYHUXSXWMXVRVDDVYLVDVYLWIXUAXWLDDVDVY
      HWYPYOUYBXVRVDWJVDDWKXWLXVQWXBVXRVYHUXTUYCUYAUYDUYEWYGYCAVYFUXDVJWXFAMRUR
      ARUTUYFUYGXOAVYFWYIWAVRWXFAVYFMWYIAMRXVFUTUYHXVFXUTAXVBXAAVYFMVSVTVOZMVQA
      VSRVQVRZVYFXWNVQVRZARUTUYIAVSYBVJZVNVSWAVRZVMZRYBVJVNRWAVRXWIXWOXWPXJXWSA
      XWQXWRUYMUYJUYKXAARUTUYNARUTUYLXWJVSRMUYOUYPYIAMAMURUYQUYRUYSUSVUCXOUYTWY
      DBEVUAXDWXHWYEWXKBWXHWYEWXKWXHWYEVMZVXPSVJZWYAWYCVMZWXKXWTWXNWXSXXAWXHWXN
      WYDUVEWXSWYAWYCWXNWXHVUDWVAWXSCVXPESCBWKZWUTWXRDIXXCWURWXPWUSWXQXXCWUBWXO
      VNVQVXRWUAVXPWOZWNXXCWUBWXOVSVQXXDWLWPWMUIVUBVUMXWTWYAWYCWXSWYAWYCWXNWXHV
      UEWXSWYAWYCWXNWXHVUFVUGWUGXXBCVXPSCVXPWIWVCXXBCWJXXCWUDWYAWUFWYCXXCWUCWXT
      DVYHXXCWUBWXOVYFWAXXDWLWMXXCWUEWYBDVYLXXCWUBWXOVYJWAXXDWNWMWPVUHVUMYNVUIV
      UNWXKWXMBWUHVXPVUOVUJWRVUKZVULVUPVUQVURXOVUNXTVXLVBVXFVUSVVEYNYLVBVXFVXEV
      UTXQWVLWWQSEWVLWUAWWQVJZWUASVJZVKZCVVAWWQSWTWVLXXHCAVXNCACWJVXGVXMCCVXFVX
      ECVXEWIZCOCOWWKUJCLVXOWUHCVXOWIWUGCSWGYAWHZVVBZVVCVXLCVBVXFXXKVXLCWJYPXFX
      FWVLXXFXXGAXXFXXGVXNAXXFVMZWUAWWSVJZLVXOXIZXXGAXXFXXNAVYTXXFXXNXJWVKVYTXX
      FWUAWUJOVIZVJZVCVXOXIXXNVCWUAOVXOVVDXXPXXMVCLVXOLCXXOLWUJOWXELWUJWIXKYOXX
      MVCWJVCLWKXXOWWSWUAWUJVXSOXMYJUVQVVFWRXNXXLXXMXXGLVXOAXXFLALWJZLCWWQLVXFL
      OWXEVVBZVVGYOXFXXGLWJXXLWXFXXMXXGXXLWXFXXMWBAWXFXXMXXGAXXFWXFXXMVVHXXLWXF
      XXMVVIXXLWXFXXMUVSWXHXXMVMZXXGWUGXXSWUAWUHVJZXXGWUGVMWXHXXMXXTWXHWWSWUHWU
      AWXJYJXNWUGCSYKXDZVVJZYQVUQVVKVUNXTYNVVLCWWQSCVXFXXKVVGWVCVVMUYEWVIVVNVVO
      VXFWWOEVXEVVPXQAWWNVXNAVYTWWNWVKVXOOUVKXDXOVXOVXFEVXEOVVQXQWVLWWFLVXOAVXN
      LXXQVXGVXMLLVXFVXELVXEWIZXXRVVCVXLLVBVXFXXRVXLLWJYPXFXFWVLWXFWWFWVLWXFVMZ
      WWAWWCWWEXYDWVPEVJZWWAXYDWVPSVJZXYEWWAVMZXYDAWXFWVPWWSVJZXYFAVXNWXFVVRZWV
      LWXFXGZXYDWVPWWSVXEVIZWWSWVLWXFVYTWVPXYKXHAVYTVXNWXFWVKYGVXOVXEOVXSVVSVVT
      XYDVXMWWSVXFVJZVMWXGXYKWWSVJZXYDVXMXYLAVXGVXMWXFUVMXYDOVWAZVXSOVWBZVJZXYL
      AXYNVXNWXFAVYTXYNWVKVXOOVWCWRYGAWXFXYPVXNWXHVXSVXOXYOWXIAXYOVXOXHZWXFAVYT
      XYQWVKVXOOVWDWRXOVWEXTVXSOVWFXQVUGAWXFWXGVXNXXEXTVXLWXGXYMVKVBWWSVXFVXHWW
      SXHZVXIWXGVXKXYMVXHWWSVGVWHXYRVXJXYKVXHWWSVXHWWSVXEXMXYRUXCVWGYRVWIVWJYEZ
      WXHXYHXYFXXSXXGVKWXHXYHVMZXYFVKCWVPWWSCVXSWVMCVXEOXXIXXJVWKCVXSWIZXKZXYTX
      YFCWXHXYHCWXHCWJCWVPWWSYUBCVXSOXXJYUAXKVWLXFZCWVPSYUBWVCVWLVWMWUAWVPXHZXX
      SXYTXXGXYFYUDXXMXYHWXHWUAWVPWWSUXTVWNZWUAWVPSUXTYRXYBVWOVWPYQXYFWVPWVBVJX
      YGSWVBWVPUIVWQWVAWWACWVPEYUBCEWIWVTCDICIWIWVRWVSCCVNWVQVQCVNWICVQWIZCVXRW
      VPYUBCVXRWIXKZYSCWVQVSVQYUGYUFCVSWIYSXFYPYUDWUTWVTDIDWUAWVPDWUAWIDVXSWVMD
      VXEODVXEWIDOWWKUJDLVXOWUHWYNWUGDCSWUDWUFDWUCDVYHXEWUEDVYLXEXFDSWVBUIWVADC
      EWUTDIXEDEWIVWTWHVWTYAWHVWKZWYOXKXLZYUDWURWVRWUSWVSYUDWUBWVQVNVQVXRWUAWVP
      WOZWNYUDWUBWVQVSVQYUJWLWPYTVUHUYDXDYMXYDAWXFXYHWWCXYIXYJXYSWXHXYHWWCXXSWU
      DVKXYTWWCVKCWVPWWSYUBXYTWWCCYUCWWBCDVYHCVYHWICWVQVYFWAYUGCWAWIZCVYFWIYSYP
      VWMYUDXXSXYTWUDWWCYUEYUDWUCWWBDVYHYUIYUDWUBWVQVYFWAYUJWLYTYRXXSWUDWUFXXSX
      XGWUGXYAYMZVVJVWOVWPYQXYDAWXFXYHWWEXYIXYJXYSWXHXYHWWEXXSWUFVKXYTWWEVKCWVP
      WWSYUBXYTWWECYUCWWDCDVYLCVYLWICVYJWVQWACVYJWIYUKYUGYSYPVWMYUDXXSXYTWUFWWE
      YUEYUDWUEWWDDVYLYUIYUDWUBWVQVYJWAYUJWNYTYRXXSWUDWUFYULYMVWOVWPYQVWRYNYLVU
      GVYPWWHBWVMWFVXPWVMXHZVXQWVOVYOWWGVXOEVXPWVMVWSYUMVYNWWFLVXOLVXPWVMLVXPWI
      LVXEOXYCWXEVWKXLYUMVYEWWAVYIWWCVYMWWEYUMVYDWVTDIDVXPWVMDVXPWIYUHXLZYUMVYB
      WVRVYCWVSYUMVYAWVQVNVQYUMVXRVXTWVPVXSVXPWVMWOVXAZWNYUMVYAWVQVSVQYUOWLWPYT
      YUMVYGWWBDVYHYUNYUMVYAWVQVYFWAYUOWLYTYUMVYKWWDDVYLYUNYUMVYAWVQVYJWAYUOWNY
      TVXBYTWPVXCVWJVXD $.
  $}

  ${
    $d f g i j n t x A $.  $d f g j n q r t A $.  $d f j n q r t y A $.
    $d f g i x B $.  $d f g i x D $.  $d f g i j n t x E $.  $d f g r t J $.
    $d f g i j n t x T $.  $d f g i j n x ph $.  $d g i j n x F $.
    $d j s t E $.  $d m n t E $.  $d m n F $.  $d m n t T $.  $d m n ph $.
    $d q r y B $.  $d q r y D $.  $d q r t y T $.  $d q r y ph $.
    $d r t y E $.  $d s F $.  $d s t T $.  $d t K $.  $d x y A $.
    stoweidlem60.1 $e |- F/_ t F $.
    stoweidlem60.2 $e |- F/ t ph $.
    stoweidlem60.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem60.4 $e |- T = U. J $.
    stoweidlem60.5 $e |- C = ( J Cn K ) $.
    stoweidlem60.6 $e |- D = ( j e. ( 0 ... n ) |->
          { t e. T | ( F ` t ) <_ ( ( j - ( 1 / 3 ) ) x. E ) } ) $.
    stoweidlem60.7 $e |- B = ( j e. ( 0 ... n ) |->
          { t e. T | ( ( j + ( 1 / 3 ) ) x. E ) <_ ( F ` t ) } ) $.
    stoweidlem60.8 $e |- ( ph -> J e. Comp ) $.
    stoweidlem60.9 $e |- ( ph -> T =/= (/) ) $.
    stoweidlem60.10 $e |- ( ph -> A C_ C ) $.
    stoweidlem60.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem60.12 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem60.13 $e |- ( ( ph /\ y e. RR ) -> ( t e. T |-> y ) e. A ) $.
    stoweidlem60.14 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem60.15 $e |- ( ph -> F e. C ) $.
    stoweidlem60.16 $e |- ( ph -> A. t e. T 0 <_ ( F ` t ) ) $.
    stoweidlem60.17 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem60.18 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( This lemma proves that there exists a function g as in the proof in
       [BrosowskiDeutsh] p. 91 (this parte of the proof actually spans through
       pages 91-92): g is in the subalgebra, and for all ` t ` in ` T ` , there
       is a ` j ` such that (j-4/3)*&epsilon; < f(t) <= (j-1/3)*&epsilon; and
       (j-4/3)*&epsilon; < g(t) < (j+1/3)*&epsilon;.  Here ` F ` is used to
       represent f in the paper, and ` E ` is used to represent &epsilon;.
       (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem60 $p |- ( ph -> E. g e. A A. t e. T E. j e. RR
          ( ( ( ( j - ( 4 / 3 ) ) x. E ) < ( F ` t ) /\
          ( F ` t ) <_ ( ( j - ( 1 / 3 ) ) x. E ) ) /\
          ( ( g ` t ) < ( ( j + ( 1 / 3 ) ) x. E ) /\
          ( ( j - ( 4 / 3 ) ) x. E ) < ( g ` t ) ) ) ) $=
      ( vx vm vi cv c4 c3 cdiv co cmin cmul cfv clt wbr c1 cle wa caddc cr wrex
      wral wex cn wcel cc0 cfz w3a rfcnnnub nnre adantl rpred adantr wne rpne0d
      wf redivcld 1re a1i readdcld arch syl nfv nfra1 simp-5l fnvinran sylancom
      nfan fcnre simp-5r nnred simpllr resubcld remulcld r19.21bi simpr syl2anc
      simplr mpbid 3ad2ant1 ex crab cmpt eqid ccmp 3adant1r adantlr simpl nf3an
      mpd simp2 simp3 simp1 syl3an1 3ad2antl1 sselda syl3anc cvv simp1r3 ralimi
      3syl rsp imp syl21anc idd exlimdv simpl1 simpl2 simpl3 ltaddsubd 3ad2ant2
      rpgt0d ltdivmul2 syl112anc syl31anc lttrd reximdva rexlimdva df-rex sylib
      ralrimi wss crp stoweidlem59 adantrr 19.42v sylanbrc 3anass sylibr eximdv
      wb exbii csu simpr1l simpr2 stoweidlem17 nfcv nfral cuni syl5eqel simpr1r
      uniexg simplr2 ffvelrn 3adant1 r19.26-3 simp1bi simp2bi stoweidlem34 wceq
      simpll simp3bi nfmpt1 breq1d breq2d anbi12d anbi2d rexbidv ralbid 2eximdv
      nfeq2 fveq1 rspcev ) AKUTZVAVBVCVDVEVDMVFVDZCUTZNVGZVHVIUXAUWRVJVBVCVDZVE
      VDMVFVDVKVIVLZUWTJUTZVGZUWRUXBVMVDMVFVDZVHVIZUWSUXEVHVIZVLZVLZKVNVOZCHVPZ
      JDVOZUQVQZUXMAUXNLVQZUXNALUTZVRVSZUXAUXPVJVEVDZMVFVDZVHVIZCHVPZVLZVTUXPWA
      VDZDUQUTZWJZVTUWTUWRUYDVGZVGZVKVIZUYGVJVKVIZVLZCHVPZUYGMUXPVCVDZVHVIZCUWR
      GVGZVPZVJUYLVEVDZUYGVHVIZCUWREVGZVPZWBZKUYCVPZWBZUQVQZLVQZUXOAUYBLVQZVUDA
      UYALVRVOZVUEAUXAURUTZVHVIZCHVPZURVRVOVUFACFHURNOPSTUAUFUBUGUCUMWCAVUIVUFU
      RVRAVUGVRVSZVLZVUIVUFVUKVUIVLZVUGMVCVDZVJVMVDZUXPVHVIZLVRVOZVUFVULVUNVNVS
      ZVUPVUKVUQVUIVUKVUMVJVUKVUGMVUJVUGVNVSZAVUGWDZWEAMVNVSZVUJAMUOWFZWGAMVTWH
      VUJAMUOWIWGWKZVJVNVSZVUKWLWMWNWGVUNLWOWPVULVUOUYALVRVULUXQVLZVUOUYAVVDVUO
      VLZUXTCHVVDVUOCVULUXQCVUKVUICAVUJCTVUJCWQXBVUHCHWRXBUXQCWQZXBVUOCWQXBVVEU
      WTHVSZUXTVVEVVGVLZUXAVUGUXSVVEVVGAUXAVNVSAVUJVUIUXQVUOVVGWSZAHVNUWTNAFHNO
      PUAUBUCUMXCZWTXAVVHVUGAVUJVUIUXQVUOVVGXDZXEVVHUXRMVVHUXPVJVVHUXPVULUXQVUO
      VVGXFZXEVVCVVHWLWMXGVVHAVUTVVIVVAWPXHVVEVUHCHVUKVUIUXQVUOXFXIVVHAVUJUXQVU
      OVUGUXSVHVIZVVIVVKVVLVVDVUOVVGXLAVUJUXQWBZVUOVLZVUMUXRVHVIZVVMVVOVUOVVPVV
      NVUOXJVVOVUMVJUXPVVOAVUJVUMVNVSAVUJUXQVUOUUAZAVUJUXQVUOUUBVVBXKVVCVVOWLWM
      ZVVOUXPAVUJUXQVUOUUCXEZUUDXMVVOVURUXRVNVSVUTVTMVHVIZVVPVVMUVEVVNVURVUOVUJ
      AVURUXQVUSUUEWGVVOUXPVJVVSVVRXGVVNVUTVUOAVUJVUTUXQVVAXNWGVVOAVVTVVQAMUOUU
      FWPVUGUXRMUUGUUHXMUUIUUJXOUUOXOUUKYDXOUULYDUYALVRUUMUUNAUYBVUCLAUYBVUCAUY
      BVLZUYBUYEVUAVLZVLZUQVQZVUCVWAUYBVWBUQVQZVWDAUYBXJAUXQVWEUYAAUXQVLUQBCDEF
      GHIJKMNKUYCUWTBUTZVGZUYLVHVICUYNVPUYPVWGVHVICUYRVPVLBVTVWGVKVIVWGVJVKVIVL
      CHVPBDXPZXPXQZOPUXPVWHQRSAUXQCTVVFXBUAUBUCUDUEVWHXRVWIXRAOXSVSZUXQUFWGADF
      UUPUXQUHWGAIUTZDVSZUXDDVSZCHUWTVWKVGZUXEVMVDXQDVSZUXQUIXTAVWLVWMCHVWNUXEV
      FVDXQDVSZUXQUJXTAVWFVNVSZCHVWFXQDVSZUXQUKYAAQUTZHVSVVGVWSUWTWHWBVWSRUTZVG
      UWTVWTVGWHRDVOUXQULYAANFVSUXQUMWGAMUUQVSZUXQUOWGAMUXBVHVIZUXQUPWGAUXQXJUU
      RUUSUYBVWBUQUUTUVAVUBVWCUQUYBUYEVUAUVBUVFUVCXOUVDYDAVUBUXMLUQAVUBUXMAVUBV
      LZCHUYCMUWTUSUTUYDVGVGVFVDUSUVGZXQZDVSZUXCUWTVXEVGZUXFVHVIZUWSVXGVHVIZVLZ
      VLZKVNVOZCHVPZUXMVXCAUXQUYEVXFAVUBYBUXQUYAUYEVUAAUVHZAUYBUYEVUAUVIAUXQUYE
      WBZBCDHIJUSMUXPUYDAUXQUYECTVVFUYECWQZYCAUXQUYEYEAUXQUYEYFVXOAVWLVWMVWOAUX
      QUYEYGZUIYHVXOAVWLVWMVWPVXQUJYHAUXQVWQVWRUYEUKYIVXOMAUXQVXAUYEUOXNWFAUXQV
      WLHVNVWKWJUYEAVWLVLFHVWKOPUAUBUCADFVWKUHYJXCYIUVJYKVXCCEGHUSKMNCHUWTUYNVS
      ZKVJUXPWAVDXPXQZUXPUYDSAVUBKAKWQUYBUYEVUAKUYBKWQUYEKWQUYTKUYCWRYCXBAVUBCT
      UYBUYEVUACUXQUYACVVFUXTCHWRXBVXPUYTCKUYCCUYCUVKUYKUYOUYSCUYJCHWRUYMCUYNWR
      UYQCUYRWRYCUVLYCXBUDUEVXSXRVXNAHYLVSVUBAHOUVMZYLUBAVWJVXTYLVSUFOXSUVPWPUV
      NWGAHVNNWJVUBVVJWGAVVGVTUXAVKVIZVUBAVYACHUNXIYAVXCUXTCHUXQUYAUYEVUAAUVOXI
      AVXAVUBUOWGAVXBVUBUPWGVXCUWRUYCVSZVLAUYEVYBHVNUYFWJZAVUBVYBUWEUYBUYEVUAAV
      YBUVQVXCVYBXJAUYEVYBWBAUYFDVSZVYCAUYEVYBYGUYEVYBVYDAUYCDUWRUYDUVRUVSAVYDV
      LFHUYFOPUAUBUCADFUYFUHYJXCXKYKVXCVYBVVGWBZUYHCHVPZKUYCVPZVYBVVGUYHVYEVUAU
      YKKUYCVPZVYGUYBUYEVUAAVYBVVGYMZVUAVYHUYOKUYCVPZUYSKUYCVPZUYKUYOUYSKUYCUVT
      ZUWAZUYKVYFKUYCUYJUYHCHUYHUYIYBYNYNYOVXCVYBVVGYEZVXCVYBVVGYFZVYGVYBVLUYHC
      HVYGVYBVYFVYFKUYCYPYQXIYRVYEUYICHVPZKUYCVPZVYBVVGUYIVYEVUAVYHVYQVYIVYMUYK
      VYPKUYCUYJUYICHUYHUYIXJYNYNYOVYNVYOVYQVYBVLUYICHVYQVYBVYPVYPKUYCYPYQXIYRV
      XCVYBVXRWBZVYJVYBVXRUYMVYRVUAVYJUYBUYEVUAAVYBVXRYMVUAVYHVYJVYKVYLUWBWPVXC
      VYBVXRYEVXCVYBVXRYFVYJVYBVLUYMCUYNVYJVYBUYOUYOKUYCYPYQXIYRVXCVYBUWTUYRVSZ
      WBZVYKVYBVYSUYQVYTVUAVYKUYBUYEVUAAVYBVYSYMVUAVYHVYJVYKVYLUWFWPVXCVYBVYSYE
      VXCVYBVYSYFVYKVYBVLUYQCUYRVYKVYBUYSUYSKUYCYPYQXIYRUWCUXLVXMJVXEDUXDVXEUWD
      ZUXKVXLCHCUXDVXECHVXDUWGUWOWUAUXJVXKKVNWUAUXIVXJUXCWUAUXGVXHUXHVXIWUAUXEV
      XGUXFVHUWTUXDVXEUWPZUWHWUAUXEVXGUWSVHWUBUWIUWJUWKUWLUWMUWQXKXOUWNYDAUXNUX
      NLAUXNYSYTYDAUXMUXMUQAUXMYSYTYD $.
  $}

  ${
    $d f g j n q r t x A $.  $d f g j n q r t x E $.  $d f g j n q r x F $.
    $d f g r t J $.  $d f g j n q r t x T $.  $d f g j n q r x ph $.  $d g i $.
    $d t K $.
    stoweidlem61.1 $e |- F/_ t F $.
    stoweidlem61.2 $e |- F/ t ph $.
    stoweidlem61.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem61.4 $e |- ( ph -> J e. Comp ) $.
    stoweidlem61.5 $e |- T = U. J $.
    stoweidlem61.6 $e |- ( ph -> T =/= (/) ) $.
    stoweidlem61.7 $e |- C = ( J Cn K ) $.
    stoweidlem61.8 $e |- ( ph -> A C_ C ) $.
    stoweidlem61.9 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem61.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem61.11 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem61.12 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem61.13 $e |- ( ph -> F e. C ) $.
    stoweidlem61.14 $e |- ( ph -> A. t e. T 0 <_ ( F ` t ) ) $.
    stoweidlem61.15 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem61.16 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( This lemma proves that there exists a function ` g ` as in the proof in
       [BrosowskiDeutsh] p. 92: ` g ` is in the subalgebra, and for all ` t `
       in ` T ` , abs( f(t) - g(t) ) < 2*&epsilon;.  Here ` F ` is used to
       represent f in the paper, and ` E ` is used to represent &epsilon;.  For
       this lemma there's the further assumption that the function ` F ` to be
       approximated is nonnegative (this assumption is removed in a later
       theorem).  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem61 $p |- ( ph -> E. g e. A A. t e. T ( abs ` ( ( g ` t ) -
          ( F ` t ) ) ) < ( 2 x. E ) ) $=
      ( vj vn cv c4 c3 cdiv co cmin cmul cfv clt wbr c1 wa caddc wrex wral cabs
      cle cr c2 cc0 cfz crab cmpt eqid stoweidlem60 wcel nfv crp ad2antrr fcnre
      wi fnvinran adantlr sselda simpll1 simpll2 simpll3 simplr simprll simprlr
      nfan w3a simprrr simprrl stoweidlem13 rexlimdva syl3anc ralimdaa reximdva
      ex mpd ) AUKUMZUNUOUPUQURUQIUSUQZCUMZJUTZVAVBZXGXDVCUOUPUQZURUQIUSUQVIVBZ
      VDZXFHUMZUTZXDXIVEUQIUSUQZVAVBZXEXMVAVBZVDZVDZUKVJVFZCFVGZHDVFXMXGURUQVHU
      TVKIUSUQVAVBZCFVGZHDVFABCDUKVLULUMVMUQZXNXGVIVBCFVNVOZEUKYCXJCFVNVOZFGHUK
      ULIJKLMNOPQSUAYEVPYDVPRTUBUCUDUEUFUGUHUIUJVQAXTYBHDAXLDVRZVDZXSYACFAYFCPY
      FCVSWMYGXFFVRZVDIVTVRZXGVJVRZXMVJVRZXSYAWCAYIYFYHUIWAAYHYJYFAFVJXFJAEFJKL
      QSUAUGWBWDWEYGFVJXFXLYGEFXLKLQSUAADEXLUBWFWBWDYIYJYKWNZXRYAUKVJYLXDVJVRZV
      DZXRYAYNXRVDUKIXGXMYIYJYKYMXRWGYIYJYKYMXRWHYIYJYKYMXRWIYLYMXRWJYNXHXJXQWK
      YNXHXJXQWLYNXKXOXPWOYNXKXOXPWPWQXBWRWSWTXAXC $.
  $}

  ${
    $d f g h t A $.  $d f h q r t x A $.  $d f g h t E $.  $d f g h F $.
    $d f g h H $.  $d f h r t J $.  $d f g h t T $.  $d f g h ph $.
    $d q r t x E $.  $d q r x H $.  $d q r t x T $.  $d q r x ph $.  $d t K $.
    $d x F $.
    stoweidlem62.1 $e |- F/_ t F $.
    stoweidlem62.2 $e |- F/ f ph $.
    stoweidlem62.3 $e |- F/ t ph $.
    stoweidlem62.4 $e |- H = ( t e. T |-> ( ( F ` t ) -
          sup ( ran F , RR , `' < ) ) ) $.
    stoweidlem62.5 $e |- K = ( topGen ` ran (,) ) $.
    stoweidlem62.6 $e |- T = U. J $.
    stoweidlem62.7 $e |- ( ph -> J e. Comp ) $.
    stoweidlem62.8 $e |- C = ( J Cn K ) $.
    stoweidlem62.9 $e |- ( ph -> A C_ C ) $.
    stoweidlem62.10 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) + ( g ` t ) ) ) e. A ) $.
    stoweidlem62.11 $e |- ( ( ph /\ f e. A /\ g e. A ) ->
          ( t e. T |-> ( ( f ` t ) x. ( g ` t ) ) ) e. A ) $.
    stoweidlem62.12 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweidlem62.13 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) ->
          E. q e. A ( q ` r ) =/= ( q ` t ) ) $.
    stoweidlem62.14 $e |- ( ph -> F e. C ) $.
    stoweidlem62.15 $e |- ( ph -> E e. RR+ ) $.
    stoweidlem62.16 $e |- ( ph -> T =/= (/) ) $.
    stoweidlem62.17 $e |- ( ph -> E < ( 1 / 3 ) ) $.
    $( This theorem proves the Stone Weierstrass theorem for the non-trivial
       case in which T is nonempty.  The proof follows [BrosowskiDeutsh] p. 89
       (through page 92).  (Contributed by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweidlem62 $p |- ( ph -> E. f e. A A. t e. T ( abs ` ( ( f ` t ) -
          ( F ` t ) ) ) < E ) $=
      ( vh cv cfv cmin co cabs clt wbr wral wrex c2 cdiv cmul cr ccnv csup cmpt
      crn nfmpt1 nfcxfr wcel w3a caddc wceq eleq1 3anbi3d fveq1 oveq2d mpteq2dv
      wi eleq1d imbi12d chvarv cneg csn cxp nfrn nfcv eqid ccmp ctop cmptop syl
      nfsup cle ccn syl6eleq stoweidlem29 simp2d stoweidlem47 syl5eqel r19.21bi
      cc0 wa simp3d fcnre fnvinran adantr subge0d mpbird simpr resubcld syl2anc
      fvmpt2 breqtrrd ex ralrimi rphalfcld c1 rpred rehalfcld 3re 3ne0 rereccli
      c3 a1i crp rphalflt lttrd stoweidlem61 nfra1 nfan rsp rpcnd cc wf adantlr
      cuni 2cn wne 2ne0 divcan2d breq2d biimpd sylan9r reximdv mpd nfv 3adant1r
      sseld eleq2i syl6ib cioo ctg uniretop unieqi eqtr4i cnf syl6 wb feq2 mp1i
      sylibrd simprl eqcomd simplrr imp sylancom eqbrtrd stoweidlem21 rexlimddv
      fveq2d ) ACUNZUMUNZUOZUVOKUOZUPUQZURUOZIUSUTZCFVAZUVOGUNZUOZUVOJUOZUPUQUR
      UOIUSUTCFVAGDVBUMDAUVTVCIVCVDUQZVEUQZUSUTZCFVAZUMDVBUWBUMDVBABCDEFGUMUWFK
      LMNOCKCFUWEJVJZVFUSVGZVHZUPUQZVIZSCFUWMVKVLRTUBUAUKUCUDAUWCDVMZHUNZDVMZVN
      ZCFUWDUVOUWPUOZVOUQZVIZDVMZWBAUWOUVPDVMZVNZCFUWDUVQVOUQZVIZDVMZWBHUMUWPUV
      PVPZUWRUXDUXBUXGUXHUWQUXCAUWOUWPUVPDVQVRZUXHUXAUXFDUXHCFUWTUXEUXHUWSUVQUW
      DVOUVOUWPUVPVSZVTWAWCWDUEWEUWRCFUWDUWSVEUQZVIZDVMZWBUXDCFUWDUVQVEUQZVIZDV
      MZWBHUMUXHUWRUXDUXMUXPUXIUXHUXLUXODUXHCFUXKUXNUXHUWSUVQUWDVEUXJVTWAWCWDUF
      WEUGUHAKUWNESACEUWLFJFUWLWFWGWHZLMPCUWJVFUWKCJPWICVFWJCUWKWJWPZRUAUXQWKTA
      LWLVMLWMVMUBLWNWOUCUIAUWLUWJVMZUWLVFVMZUWLUWEWQUTZCFVAZACFJLMPRUATUBAJELM
      WRUQZUIUCWSUKWTZXAZXBXCAXEUVRWQUTZCFRAUVOFVMZUYFAUYGXFZXEUWMUVRWQUYHXEUWM
      WQUTUYAAUYACFAUXSUXTUYBUYDXGXDUYHUWEUWLAFVFUVOJAEFJLMTUAUCUIXHZXIZAUXTUYG
      UYEXJZXKXLUYHUYGUWMVFVMUVRUWMVPAUYGXMUYHUWEUWLUYJUYKXNCFUWMVFKSXPXOZXQXRX
      SAIUJXTAUWFIYAYGVDUQZAIAIUJYBZYCUYNUYMVFVMAYGYDYEYFYHAIYIVMUWFIUSUTUJIYJW
      OULYKYLAUWIUWBUMDAUWIUWBAUWIXFUWACFAUWICRUWHCFYMYNUWIUYGUWHAUWAUWHCFYOAUW
      HUWAAUWGIUVTUSAIVCAIUJYPVCYQVMAUUAYHVCXEUUBAUUCYHUUDUUEUUFUUGXSXRUUHUUIAU
      XCUWBXFZXFZBCDUWLFGHIJCFUVQUWLVOUQZVIZUVPCFUYQVKCUVPWJUXRAUYOCRUXCUWBCUXC
      CUUJUWACFYMYNYNZUYRWKAFVFJYRUYOUYIXJAUXTUYOUYEXJAUWOUWQUXBUYOUEUUKABUNZVF
      VMCFUYTVIDVMUYOUGYSAFVFUWCYRZGDVAUYOAVUAGDQAUWOLYTZVFUWCYRZVUAAUWOUWCUYCV
      MZVUCAUWOUWCEVMVUDADEUWCUDUULEUYCUWCUCUUMUUNUWCLMVUBVFVUBWKVFUUOVJUUPUOZY
      TMYTUUQMVUETUURUUSUUTUVAFVUBVPVUAVUCUVBAUAFVUBVFUWCUVCUVDUVEXSXJAUXCUWBUV
      FUYPUVQUWMUPUQZURUOZIUSUTZCFUYSUYPUYGVUHUYPUYGXFVUGUVTIUSAUYGVUGUVTVPUYOU
      YHVUFUVSURUYHUWMUVRUVQUPUYHUVRUWMUYLUVGVTUVNYSUYPUYGUWBUWAAUXCUWBUYGUVHUW
      BUYGUWAUWACFYOUVIUVJUVKXRXSUVLUVM $.
  $}

  ${
    $d f g t A $.  $d f h r t x A $.  $d f g t E $.  $d f g F $.  $d f r t J $.
    $d f g t T $.  $d f g ph $.  $d h r t x E $.  $d h r x F $.
    $d h r t x T $.  $d h r x ph $.  $d t K $.
    stoweid.1 $e |- F/_ t F $.
    stoweid.2 $e |- F/ t ph $.
    stoweid.3 $e |- K = ( topGen ` ran (,) ) $.
    stoweid.4 $e |- ( ph -> J e. Comp ) $.
    stoweid.5 $e |- T = U. J $.
    stoweid.6 $e |- C = ( J Cn K ) $.
    stoweid.7 $e |- ( ph -> A C_ C ) $.
    stoweid.8 $e |- ( ( ph /\ f e. A /\ g e. A ) -> ( t e. T |-> ( ( f ` t ) +
                    ( g ` t ) ) ) e. A ) $.
    stoweid.9 $e |- ( ( ph /\ f e. A /\ g e. A ) -> ( t e. T |-> ( ( f ` t ) x.
                    ( g ` t ) ) ) e. A ) $.
    stoweid.10 $e |- ( ( ph /\ x e. RR ) -> ( t e. T |-> x ) e. A ) $.
    stoweid.11 $e |- ( ( ph /\ ( r e. T /\ t e. T /\ r =/= t ) ) -> E. h e. A (
                     h ` r ) =/= ( h ` t ) ) $.
    stoweid.12 $e |- ( ph -> F e. C ) $.
    stoweid.13 $e |- ( ph -> E e. RR+ ) $.
    $( This theorem proves the Stone-Weierstrass theorem for real valued
       functions: let ` J ` be a compact topology on ` T ` , and ` C ` be the
       set of real continuous functions on ` T ` .  Assume that ` A ` is a
       subalgebra of ` C ` (closed under addition and multiplication of
       functions) containing constant functions and discriminating points (if
       ` r ` and ` t ` are distinct points in ` T ` , then there exists a
       function ` h ` in ` A ` such that h(r) is distinct from h(t) ).  Then,
       for any continuous function ` F ` and for any positive real ` E ` ,
       there exists a function ` f ` in the subalgebra ` A ` , such that ` f `
       approximates ` F ` up to ` E ` ( ` E ` represents the usual &epsilon;
       value).  As a classical example, given any a,b reals, the closed
       interval ` T = [ a , b ] ` could be taken, along with the subalgebra
       ` A ` of real polynomials on ` T ` , and then use this theorem to easily
       prove that real polynomials are dense in the standard metric space of
       continuous functions on ` [ a , b ] ` .  The proof and lemmas are
       written following [BrosowskiDeutsh] p. 89 (through page 92).  Some
       effort is put in avoiding the use of the axiom of choice.  (Contributed
       by Glauco Siliprandi, 20-Apr-2017.) $)
    stoweid $p |- ( ph -> E. f e. A A. t e. T
          ( abs ` ( ( f ` t ) - ( F ` t ) ) ) < E ) $=
      ( cv cfv cmin co cabs c1 c4 cdiv cle wbr cif wral wrex c0 wceq simpr cmpt
      clt wa wcel cr ralrimiva 1re id mpteq2dv eleq1d rspccv adantr stoweidlem9
      ee10 crn ccnv csup nfv nfan eqid ccmp wss caddc 3adant1r cmul adantlr wne
      wn w3a crp 4re 4pos elrpii a1i rpreccld ifcl syl2anc df-ne biimpri adantl
      rpred cc0 0re gtneii rereccli 3re 3ne0 cxr rpxrd xrmin2 3lt4 3pos ltrecii
      c3 mpbi lelttrd stoweidlem62 pm2.61dan xrmin1 ad2antrr wi wf simplr fcnre
      cc sseldd ffvelrn recn 3syl subcld abscld gt0ne0ii 3pm3.2i redivcl ltletr
      jca mp1i syl3anc mpan2d ralimdaa reximdva mpd ) ACUHZGUHZUIZUUFKUIZUJUKZU
      LUIZJUMUNUOUKZUPUQZJUULURZVEUQZCFUSZGDUTZUUKJVEUQZCFUSZGDUTAFVAVBZUUQAUUT
      VFCDFGUUNKAUUTVCACFUMVDZDVGZUUTACFBUHZVDZDVGZBVHUSUMVHVGZUVBAUVEBVHUDVIVJ
      UVEUVBBUMVHUVCUMVBZUVDUVADUVGCFUVCUMUVGVKVLVMVNVQVOVPAUUTWKZVFBCDEFGHUUNK
      CFUUIKVRVHVEVSVTUJUKVDZLMNIOAUVHGAGWAUVHGWAWBAUVHCPUVHCWAWBUVIWCQSALWDVGU
      VHRVOTADEWEZUVHUAVOAUUGDVGZHUHZDVGZCFUUHUUFUVLUIZWFUKVDDVGUVHUBWGAUVKUVMC
      FUUHUVNWHUKVDDVGUVHUCWGAUVCVHVGUVEUVHUDWIANUHZFVGUUFFVGZUVOUUFWJWLUVOIUHZ
      UIUUFUVQUIWJIDUTUVHUEWIAKEVGZUVHUFVOAUUNWMVGZUVHAJWMVGUULWMVGUVSUGAUNUNWM
      VGAUNWNWOWPWQWRZUUMJUULWMWSWTVOUVHFVAWJZAUWAUVHFVAXAXBXCAUUNUMXQUOUKZVEUQ
      UVHAUUNUULUWBAJVHVGZUULVHVGZUUNVHVGZAJUGXDZUWDAUNWNXEUNXFWOXGXHWQZUUMJUUL
      VHWSZWTUWGUWBVHVGAXQXIXJXHWQAJXKVGZUULXKVGZUUNUULUPUQAJUGXLZAUULUVTXLZJUU
      LXMWTUULUWBVEUQZAXQUNVEUQUWMXNXQUNXIWNXOWOXPXRWQXSVOXTYAAUUPUUSGDAUVKVFZU
      UOUURCFAUVKCPUVKCWAWBUWNUVPVFZUUOUUNJUPUQZUURAUWPUVKUVPAUWIUWJUWPUWKUWLJU
      ULYBWTYCUWOUUKVHVGUWEUWCUUOUWPVFUURYDUWOUUJUWOUUHUUIUWOFVHUUGYEZUVPVFUUHV
      HVGUUHYHVGUWOUWQUVPUWOEFUUGLMQSTUWODEUUGAUVJUVKUVPUAYCAUVKUVPYFYIYGUWNUVP
      VCZYSFVHUUFUUGYJUUHYKYLUWOFVHKYEZUVPVFUUIVHVGUUIYHVGUWOUWSUVPUWOEFKLMQSTA
      UVRUVKUVPUFYCYGUWRYSFVHUUFKYJUUIYKYLYMYNAUWEUVKUVPAUWCUWDUWEUWFUVFUNVHVGZ
      UNXEWJZWLUWDAUVFUWTUXAVJWNUNWNWOYOYPUMUNYQYTUWHWTYCAUWCUVKUVPUWFYCUUKUUNJ
      YRUUAUUBUUCUUDUUE $.
  $}

  ${
    $d f g t A $.  $d f h r t x A $.  $d f g t E $.  $d f g t F $.
    $d f r t J $.  $d f g t T $.  $d h r t x E $.  $d h r t x F $.
    $d h r t x T $.  $d t K $.
    stowei.1 $e |- K = ( topGen ` ran (,) ) $.
    stowei.2 $e |- J e. Comp $.
    stowei.3 $e |- T = U. J $.
    stowei.4 $e |- C = ( J Cn K ) $.
    stowei.5 $e |- A C_ C $.
    stowei.6 $e |- ( ( f e. A /\ g e. A ) -> ( t e. T |-> ( ( f ` t ) + ( g ` t
                   ) ) ) e. A ) $.
    stowei.7 $e |- ( ( f e. A /\ g e. A ) -> ( t e. T |-> ( ( f ` t ) x. ( g `
                   t ) ) ) e. A ) $.
    stowei.8 $e |- ( x e. RR -> ( t e. T |-> x ) e. A ) $.
    stowei.9 $e |- ( ( r e. T /\ t e. T /\ r =/= t ) -> E. h e. A ( h ` r ) =/=
                   ( h ` t ) ) $.
    stowei.10 $e |- F e. C $.
    stowei.11 $e |- E e. RR+ $.
    $( This theorem proves the Stone-Weierstrass theorem for real valued
       functions: let ` J ` be a compact topology on ` T ` , and ` C ` be the
       set of real continuous functions on ` T ` .  Assume that ` A ` is a
       subalgebra of ` C ` (closed under addition and multiplication of
       functions) containing constant functions and discriminating points (if
       ` r ` and ` t ` are distinct points in ` T ` , then there exists a
       function ` h ` in ` A ` such that h(r) is distinct from h(t) ).  Then,
       for any continuous function ` F ` and for any positive real ` E ` ,
       there exists a function ` f ` in the subalgebra ` A ` , such that ` f `
       approximates ` F ` up to ` E ` ( ` E ` represents the usual &epsilon;
       value).  As a classical example, given any a,b reals, the closed
       interval ` T = [ a , b ] ` could be taken, along with the subalgebra
       ` A ` of real polynomials on ` T ` , and then use this theorem to easily
       prove that real polynomials are dense in the standard metric space of
       continuous functions on ` [ a , b ] ` .  The proof and lemmas are
       written following [BrosowskiDeutsh] p. 89 (through page 92).  Some
       effort is put in avoiding the use of the axiom of choice.  The deduction
       version of this theorem is ~ stoweid : often times it will be better to
       use ~ stoweid in other proofs (but this version is probably easier to be
       read and understood).  (Contributed by Glauco Siliprandi,
       20-Apr-2017.) $)
    stowei $p |- E. f e. A A. t e. T ( abs ` ( ( f ` t ) - ( F ` t ) ) ) < E
               $=
      ( cv cfv cmin co cabs clt wbr wral wrex wtru nfcv nftru ccmp wcel a1i wss
      caddc cmpt 3adant1 cmul cr adantl wne w3a crp stoweid trud ) BUEZFUEZUFZV
      LJUFUGUHUIUFIUJUKBEULFCUMUNABCDEFGHIJKLMBJUOBUPNKUQURUNOUSPQCDUTUNRUSVMCU
      RZGUEZCURZBEVNVLVPUFZVAUHVBCURUNSVCVOVQBEVNVRVDUHVBCURUNTVCAUEZVEURBEVSVB
      CURUNUAVFMUEZEURVLEURVTVLVGVHVTHUEZUFVLWAUFVGHCUMUNUBVFJDURUNUCUSIVIURUNU
      DUSVJVK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                         Wallis' product for &pi;
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d n x $.  $d N n $.  $d N x $.  $d ph x $.
    wallispilem1.1 $e |- I = ( n e. NN0 |-> S. ( 0 (,) pi ) ( ( sin ` x ) ^ n
                           ) _d x ) $.
    wallispilem1.2 $e |- ( ph -> N e. NN0 ) $.
    $( ` I ` is monotone: increasing the exponent, the integral decreases.
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    wallispilem1 $p
                   |- ( ph -> ( I ` ( N + 1 ) ) <_ ( I ` N ) ) $=
  ( cc0 cpi co cfv cexp cle cr wcel cn0 syl adantr wbr wceq cioo csin citg cmpt
  cv c1 caddc cibl 0re a1i pire peano2nn0 iblioosinexp syl3anc elioore resincld
  wa adantl reexpcld cuz nn0zd uzid peano2uz clt jctil sinq12gt0 ltle sylc cneg
  cz sinbnd simprd leexp2rd itgle oveq2 itgeq2dv itgex fvmpt 3brtr4d ) ABHIUAJZ
  BUEZUBKZEUFUGJZLJZUCZBVTWBELJZUCZWCDKZEDKZMABVTWDWFAHNOZINOZWCPOZBVTWDUDUHOWJ
  AUIUJZWKAUKUJZAEPOZWLGEULQZBHIWCUMUNAWJWKWOBVTWFUDUHOWMWNGBHIEUMUNAWAVTOZUQZW
  BWCWQWBNOZAWQWAWAHIUOZUPZURZAWLWQWPRUSWRWBEXBAWOWQGRZUSWRWBEWCXBXCAWCEUTKZOZW
  QAEXDOZXEAEVJOXFAEGVAEVBQEEVCQRWQHWBMSZAWQWJWSUQHWBVDSXGWQWSWJXAUIVEWAVFHWBVG
  VHURWQWBUFMSZAWQUFVIWBMSZXHWQWANOXIXHUQWTWAVKQVLURVMVNAWLWHWETWPCWCBVTWBCUEZL
  JZUCZWEPDXJWCTZBVTXKWDXMXKWDTWQXJWCWBLVORVPFBVTWDVQVRQAWOWIWGTGCEXLWGPDXJETZB
  VTXKWFXNXKWFTWQXJEWBLVORVPFBVTWFVQVRQVS $.
  $}

  ${
    $d n x $.  $d N n $.  $d N x $.
    wallispilem2.1 $e
      |- I = ( n e. NN0 |-> S. ( 0 (,) pi ) ( ( sin ` x ) ^ n ) _d x )
                          $.
    $( A first set of properties for the sequence ` I ` that will be used in
       the proof of the Wallis product formula (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    wallispilem2 $p
      |- ( ( I ` 0 ) = pi /\ ( I ` 1 ) = 2 /\ ( N e. ( ZZ>= ` 2 ) ->
      ( I ` N ) = ( ( ( N - 1 ) / N ) x. ( I ` ( N - 2 ) ) ) ) )
                        $=
  ( cc0 cfv cpi wceq c1 c2 wcel cmin co cn0 cexp cc cr pire eqtri cuz cdiv cmul
  wi 0nn0 cioo cv csin citg wa oveq2 adantr ax-resscn sstri sseli sincld adantl
  ioossre exp0d eqtrd itgeq2dv cvol ioombl ioovolcl mp2an ax-1cn itgconst mp3an
  cdm 0re recni mulid2i cle pipos ltleii volioo subid1i syl6eq elexi fvmpt 1nn0
  wbr ax-mp simpl oveq2d exp1d itgex itgsin0pi id itgsinexp 3pm3.2i ) FCGHIZJCG
  ZKIDKUAGLZDCGDJMNDUBNDKMNCGUCNIUDFOLWLUEBFAFHUFNZAUGZUHGZBUGZPNZUIZHOCWRFIZWT
  AWOJUIZHXAAWOWSJXAWPWOLZUJZWSWQFPNZJXAWSXEIXCWRFWQPUKULXDWQXCWQQLZXAXCWPWOQWP
  WORQFHURUMUNUOUPZUQUSUTVAXBJWOVBGZUCNZHWOVBVILXHRLZJQLXBXIIFHVCFRLZHRLZXJVJSF
  HVDVEZVFAWOJVGVHXIXHHXHXHXMVKVLXHHFMNZHXKXLFHVMWBXHXNIVJSFHVJSVNVOFHVPVHHHSVK
  VQTTTVREHRSVSVTWCWMAWOWQUIZKJOLWMXOIWABJWTXOOCWRJIZAWOWSWQXPXCUJZWSWQJPNWQXQW
  RJWQPXPXCWDWEXQWQXCXFXPXGUQWFUTVAEAWOWQWGVTWCAWHTWNABCDEWNWIWJWK $.
  $}

  ${
    $d k m y $.  $d m n x $.  $d m w y $.  $d I k $.  $d I m $.  $d I w $.
    $d I y $.  $d N m $.  $d N w $.
    wallispilem3.1 $e |- I = ( n e. NN0 |->
      S. ( 0 (,) pi ) ( ( sin ` x ) ^ n ) _d x ) $.
    $( I maps to real values (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    wallispilem3 $p |- ( N e. NN0 -> ( I ` N ) e. RR+ ) $=
      ( vm cn0 wcel cle wbr cfv crp wi wa cc0 c1 co wceq a1i c2 vw vy vk imbi1d
      cv caddc breq2 ralbidv simpr nn0ge0 adantr cr nn0re 0re letri3d mpbir2and
      wral fveq2d cpi cuz cmin cdiv cmul wallispilem2 simp1i pire pipos eqeltri
      elrpii syl6eqel ex rgen nfv nfra1 nfan simpllr simplr rsp sylc simp2i 2rp
      fveq2 simp3i adantl cn clt eluz2b2 simplbi nnre 1re resubcld syl eluzelre
      1m1e0 simprbi ltsub1dd syl5eqbrr elrpd nnrpd breq1 eleq1d imbi12d cbvralv
      rpdivcld biimpi ad3antlr uznn0sub jca simplll simp2 oveq1d 3ad2ant1 recnd
      w3a cc df-2 oveq2d id ax-1cn pnpcan2d eqtrd lem1d eqbrtrd syl3anc rspccva
      rpmulcld eqeltrd adantllr wo simp3 nn0p1nn elnnuz sylib uzp1 1p1e2 mpjaod
      simpl1 3ad2ant2 mpbird mpjaodan fveq2i eleq2i orbi2i adantlr 3ad2antl1 wb
      simpl2 simpl3 wne simp1 nnm1nn0 nn0ge0d ltsubaddd lelttrd gt0ne0d elnnne0
      sylanbrc nnleltp1 syl2anc elnn0 orcomd orcd readdcld leloed mpbid ralrimi
      olcd exp31 nn0ind ancri leidd ) DGHZFUEZDIJZUVMCKZLHZMZFGUQZUVLNDDIJZDCKZ
      LHZUVLUVRUVMUAUEZIJZUVPMZFGUQUVMOIJZUVPMZFGUQUVMUBUEZIJZUVPMZFGUQZUVMUWGP
      UFQZIJZUVPMZFGUQZUVRUAUBDUWBORZUWDUWFFGUWOUWCUWEUVPUWBOUVMIUGUDUHUWBUWGRZ
      UWDUWIFGUWPUWCUWHUVPUWBUWGUVMIUGUDUHUWBUWKRZUWDUWMFGUWQUWCUWLUVPUWBUWKUVM
      IUGUDUHUWBDRZUWDUVQFGUWRUWCUVNUVPUWBDUVMIUGUDUHUWFFGUVMGHZUWEUVPUWSUWENZU
      VOOCKZLUWTUVMOCUWTUVMORZUWEOUVMIJZUWSUWEUIUWSUXCUWEUVMUJUKUWTUVMOUWSUVMUL
      HZUWEUVMUMZUKOULHZUWTUNSUOUPURUXAUSLUXAUSRZPCKZTRZUVMTUTKZHZUVOUVMPVAQZUV
      MVBQZUVMTVAQZCKZVCQZRZMZABCUVMEVDZVEUSVFVGVIVHVJVKVLUWGGHZUWJUWNUXTUWJNZU
      WMFGUXTUWJFUXTFVMUWIFGVNVOUYAUWSUWLUVPUYAUWSNZUWLNZUWHUVPUVMUWKRZUYCUWJUW
      SUWIUXTUWJUWSUWLVPUYAUWSUWLVQZUWIFGVRVSUYCUYDUVPUYBUYDUVPUWLUYBUYDNZUVMPR
      ZUVPUXKUYGUVPMUYFUYGUVOUXHLUVMPCWBUXHTLUXGUXIUXRUXSVTWAVHVJSUYFUXKUVPUYAU
      YDUXKUVPUWSUYAUYDNZUXKNZUVOUXPLUXKUXQUYHUXGUXIUXRUXSWCWDUYIUXMUXOUXKUXMLH
      UYHUXKUXLUVMUXKUXLUXKUVMWEHZUXLULHZUXKUYJPUVMWFJZUVMWGZWHZUYJUVMPUVMWIZPU
      LHZUYJWJSWKZWLUXKOPPVAQUXLWFWNUXKPUVMPUYPUXKWJSZTUVMWMUYRUXKUYJUYLUYMWOWP
      WQWRUXKUVMUYNWSXDWDUYIUCUEZUWGIJZUYSCKZLHZMZUCGUQZUXNGHZNUXNUWGIJZUXOLHZU
      YIVUDVUEUWJVUDUXTUYDUXKUWJVUDUWIVUCFUCGUVMUYSRZUWHUYTUVPVUBUVMUYSUWGIWTVU
      HUVOVUALUVMUYSCWBXAXBXCXEXFUXKVUEUYHTUVMXGWDXHUYIUXTUYDUXKVUFUXTUWJUYDUXK
      XIUYAUYDUXKVQUYHUXKUIUXTUYDUXKXNZUXNUWGPVAQZUWGIVUIUXNUWKTVAQZVUJVUIUVMUW
      KTVAUXTUYDUXKXJXKVUIUWGXOHZVUKVUJRVUIUWGUXTUYDUWGULHZUXKUWGUMZXLZXMVULVUK
      UWKPPUFQZVAQVUJVULTVUPUWKVATVUPRVULXPSXQVULUWGPPVULXRPXOHVULXSSZVUQXTYAWL
      YAVUIUWGVUOYBYCYDVUCVUFVUGMUCUXNGUYSUXNRZUYTVUFVUBVUGUYSUXNUWGIWTVURVUAUX
      OLUYSUXNCWBXAXBYEVSYFYGYHVKUYFUXTUWSUYDUYGUXKYIZUXTUWJUWSUYDXIUYAUWSUYDVQ
      UYBUYDUIUXTUWSUYDXNZUVMPUTKHZVUSVUTUYJVVAVUTUVMUWKWEUXTUWSUYDYJUXTUWSUWKW
      EHUYDUWGYKXLYGUVMYLYMVVAUYGUVMVUPUTKZHZYIVUSPUVMYNVVCUXKUYGVVBUXJUVMVUPTU
      TYOUUAUUBUUCYMWLYDYPUUDVKUYCUXTUWSUWLUWHUYDYIZUXTUWJUWSUWLXIUYEUYBUWLUIUX
      TUWSUWLXNZUVMUWKWFJZVVDUYDVVEVVFNUXTUWSVVFVVDUXTUWSUWLVVFYQUXTUWSUWLVVFUU
      GVVEVVFUIUXTUWSVVFXNZUWHUYDVVGUXBUWHUYJUXTUWSUXBUWHVVFUXTUXBNUVMOUWGIUXTU
      XBUIUXTOUWGIJUXBUWGUJUKYCUUEVVGUYJNUXTUYJVVFUWHUXTUWSVVFUYJYQVVGUYJUIUXTU
      WSVVFUYJUUHUXTUYJVVFXNZUWHVVFUXTUYJVVFYJZVVHUYJUWGWEHZUWHVVFUUFUXTUYJVVFX
      JVVHUXTUWGOUUIVVJUXTUYJVVFUUJVVHUWGVVHOUXLUWGUXFVVHUNSUYJUXTUYKVVFUYQYRUX
      TUYJVUMVVFVUNXLZUYJUXTOUXLIJVVFUYJUXLUVMUUKUULYRVVHUXLUWGWFJVVFVVIVVHUVMP
      UWGUYJUXTUXDVVFUYOYRUYPVVHWJSVVKUUMYSUUNUUOUWGUUPUUQUVMUWGUURUUSYSYDUWSUX
      TUXBUYJYIVVFUWSUYJUXBUWSUYJUXBYIUVMUUTXEUVAYRYTUVBYDVVEUYDNUYDUWHVVEUYDUI
      UVGVVEUWLVVFUYDYIUXTUWSUWLYJVVEUVMUWKUWSUXTUXDUWLUXEYRVVEUWGPUXTUWSVUMUWL
      VUNXLUYPVVEWJSUVCUVDUVEYTYDYPUVHUVFVKUVIUVJUVLDDUMUVKUVQUVSUWAMFDGUVMDRZU
      VNUVSUVPUWAUVMDDIWTVVLUVOUVTLUVMDCWBXAXBYEVS $.
  $}

  ${
    $d k w y $.  $d n x y $.  $d n y z $.  $d w y z $.  $d F w $.  $d F x $.
    $d F y $.  $d F z $.  $d I x $.  $d I y $.
    wallispilem4.1 $e |- F = ( k e. NN |-> ( ( ( 2 x. k ) /
      ( ( 2 x. k ) - 1 ) ) x. ( ( 2 x. k ) / ( ( 2 x. k ) + 1 ) ) ) ) $.
    wallispilem4.2 $e |- I = ( n e. NN0 |->
      S. ( 0 (,) pi ) ( ( sin ` z ) ^ n ) _d z ) $.
    wallispilem4.3 $e |- G = ( n e. NN |->
      ( ( I ` ( 2 x. n ) ) / ( I ` ( ( 2 x. n ) + 1 ) ) ) ) $.
    wallispilem4.4 $e |- H = ( n e. NN |-> ( ( pi / 2 ) x.
      ( 1 / ( seq 1 ( x. , F ) ` n ) ) ) ) $.
    $( ` F ` maps to explicit expression for the ratio of two consecutive
       values of ` I ` (Contributed by Glauco Siliprandi, 30-Jun-2017.) $)
    wallispilem4 $p
                   |- G = H $=
  ( c2 cmul co c1 caddc cdiv wceq c3 wcel vx vy vw cn cfv cmpt cpi oveq2 fveq2d
  cv cseq oveq1d oveq12d fveq2 oveq2d eqeq12d mulid1i fveq2i oveq1i 2p1e3 eqtri
  2cn oveq12i cuz cz 2z ax-mp cc0 wi wallispilem2 simp3i 2m1e1 cc wne wa ax-1cn
  cmin 2ne0 divcli 3eqtri cle wbr 2re 3re ltleii 3cn eqtr2i 3ne0 syl6eq eqeltri
  3m1e2 adantl a1i nncn eqtrd mulcld addsubassd 3eqtrd 3eqtr4d zmulcld nnre 1re
  cr readdcld 0re 2pos mpbid lemulge11d eluz1i sylanbrc itgsinexp remulcld 3pos
  nnge1 mpbii addcld mulne0d divcld cn0 wallispilem3 rpcnd syl clt crp rpcnne0d
  adantr resubcld 1lt2 nnrp redivcld eqeltrd rpmulcld rpdivcld mulge0d ge0p1rpd
  fvmptd 2rp eqcomd rpne0d divassd uzid subidi simp1i pm3.2i pire recni mulid2i
  div32 mp3an 3nn nnzi 2lt3 mpbir3an eqcomi subaddrii simp2i mulcomi 3eqtr2i 1z
  eluz2 seq1 1nn div1i ovex fvmpt oveq2i mulcli divne0i mulne0i eqnetrri adddid
  divreci mulid1d nnz peano2zd nn0ge0d addge02d pncand addassd zaddcld addge01d
  nnnn0 letrd peano2nn nnne0d 2nn0 nn0mulcld nngt0 mulgt0d elrp sylibr ltaddrpd
  jctir gt0ne0d divne0d zsubcld subge0d mpbird elnn0z divmuldiv syl21anc elnnuz
  lttrd jca31 biimpi seqp1 ltaddrp2d mulgt1d subne0d eqnetrd cfz elfznn mulid2d
  gtned id ltmul1d eqbrtrrd lelttrd posdifd elrpd rpge0d rpmulcl seqcl rpaddcld
  divdiv1 syl3anc reccld eqnetrrd divmuldivd divdivdivd 3eqtr2d halfcld mulcomd
  divdiv2d ex nnind mpteq2ia 3eqtr4i ) CUDLCUJZMNZGUEZUYTOPNZGUEZQNZUFCUDUGLQNZ
  OUYSMDOUKZUEZQNZMNZUFEFCUDVUDVUILUAUJZMNZGUEZVUKOPNZGUEZQNZVUEOVUJVUFUEZQNZMN
  ZRLOMNZGUEZVUSOPNZGUEZQNZVUEOOVUFUEZQNZMNZRLUBUJZMNZGUEZVVHOPNZGUEZQNZVUEOVVG
  VUFUEZQNZMNZRZLVVGOPNZMNZGUEZVVROPNZGUEZQNZVUEOVVQVUFUEZQNZMNZRZVUDVUIRUAUBUY
  SVUJORZVUOVVCVURVVFVWGVULVUTVUNVVBQVWGVUKVUSGVUJOLMUHZUIVWGVUMVVAGVWGVUKVUSOP
  VWHULUIUMVWGVUQVVEVUEMVWGVUPVVDOQVUJOVUFUNUOUOUPVUJVVGRZVUOVVLVURVVOVWIVULVVI
  VUNVVKQVWIVUKVVHGVUJVVGLMUHZUIVWIVUMVVJGVWIVUKVVHOPVWJULUIUMVWIVUQVVNVUEMVWIV
  UPVVMOQVUJVVGVUFUNUOUOUPVUJVVQRZVUOVWBVURVWEVWKVULVVSVUNVWAQVWKVUKVVRGVUJVVQL
  MUHZUIVWKVUMVVTGVWKVUKVVROPVWLULUIUMVWKVUQVWDVUEMVWKVUPVWCOQVUJVVQVUFUNUOUOUP
  VUJUYSRZVUOVUDVURVUIVWMVULVUAVUNVUCQVWMVUKUYTGVUJUYSLMUHZUIVWMVUMVUBGVWMVUKUY
  TOPVWNULUIUMVWMVUQVUHVUEMVWMVUPVUGOQVUJUYSVUFUNUOUOUPVVCLGUEZSGUEZQNVUELLSQNZ
  MNZQNZVVFVUTVWOVVBVWPQVUSLGLVBUQZURVVASGVVALOPNZSVUSLOPVWTUSUTVAURVCVWOVUEVWP
  VWRQVWOLOVQNZLQNZLLVQNZGUEZMNZOLQNZUGMNZVUELLVDUEZTZVWOVXFRZLVETZVXJVFLUUAVGV
  HGUEZUGRZOGUEZLRZVXJVXKVIZACGLIVJZVKVGVXCVXGVXEUGMVXBOLQVLUSVXEVXMUGVXDVHGLVB
  UUBURVXNVXPVXQVXRUUCVAVCVXHOVUEMNZVUEOVMTZLVMTZLVHVNZVOUGVMTZVXHVXSRVPVYAVYBV
  BVRUUDUGUUEUUFZOLUGUUHUUIVUEUGLVYDVBVRVSZUUGVAVTVWPSOVQNZSQNZSLVQNZGUEZMNZVWQ
  LMNVWRSVXITZVWPVYJRZVYKVXLSVETZLSWAWBVFSUUJUUKZLSWCWDUULWELSUUTUUMVXNVXPVYKVY
  LVIACGSIVJVKVGVWQVYGLVYIMLVYFSQVYFLWKUUNUSVYIVXOLVYHOGSLOWFVBVPUTUUOZURVXNVXP
  VXQVXRUUPWGVCVWQLLSVBWFWHVSZVBUUQUURVCVWSVUEVVDQNVVFVWRVVDVUEQVVDODUEZVWROVET
  VVDVYQRUUSMDOUVAVGZOUDTVYQVWRRUVBBOLBUJZMNZVYTOVQNZQNZVYTVYTOPNZQNZMNZVWRUDDV
  YSORZWUBLWUDVWQMWUFWUBLOQNLWUFVYTLWUAOQWUFVYTVUSLVYSOLMUHZVWTWIZWUFWUAVUSOVQN
  ZOWUFVYTVUSOVQWUGULWUIVXBOVUSLOVQVWTUSVLVAWIUMLVBUVCWIWUFVYTLWUCSQWUHWUFWUCVX
  ASWUFVYTLOPWUHULUTWIUMUMHLVWQMUVDUVEVGZWGZUVFVUEVVDVYEVVDVYQVMVYRVYQVWRVMWUJL
  VWQVBVYPUVGWJWJVWRVVDVHWUKLVWQVBVYPVRLSVBWFVRWHUVHUVIUVJUVLVAVTVVGUDTZVVPVWFW
  ULVVPVOVVJVVRQNZVVRVVHSPNZQNZQNZVVLMNZWUPVVOMNZVWBVWEVVPWUQWURRWULVVLVVOWUPMU
  HWLWULVWBWUQRVVPWULVWBWUPVVIWUNLVQNZGUEZQNZMNZWUQWULVVROVQNZVVRQNZVVIMNZWUNOV
  QNZWUNQNZWUTMNZQNWUMVVIMNZWUOWUTMNZQNZVWBWVBWULWVEWVIWVHWVJQWULWVDWUMVVIMWULW
  VCVVJVVRQWULWVCVVHLPNZOVQNVVHVXBPNVVJWULVVRWVLOVQWULVVRVVHVUSPNWVLWULLVVGOVYA
  WULVBWMZVVGWNZVXTWULVPWMZUVKWULVUSLVVHPWULLWVMUVMUOWOZULWULVVHLOWULLVVGWVMWVN
  WPZWVMWVOWQWULVXBOVVHPVXBORWULVLWMUOWRZULULWULWVGWUOWUTMWULWVFVVRWUNQWULVVHVY
  FPNWVLWVFVVRWULVYFLVVHPVYFLRWULWKWMUOWULVVHSOWVQSVMTWULWFWMZWVOWQWVPWSULULUMW
  ULVVSWVEVWAWVHQWULVVSWVDVVRLVQNZGUEZMNWVEWULACGVVRIWULVVRVETLVVRWAWBVVRVXITWU
  LLVVQVXLWULVFWMZWULVVGVVGUVNZUVOWTWULLVVQLXCTZWULWCWMZWULVVGOVVGXAZOXCTZWULXB
  WMZXDZVHLWAWBZWULVHLXEWCXFWEZWMZWULVHVVGWAWBOVVQWAWBWULVVGVVGUWBZUVPZWULOVVGW
  WHWWFUVQXGXHLVVRVFXIXJXKWULWWAVVIWVDMWULWVTVVHGWULWVTWVLLVQNVVHWULVVRWVLLVQWV
  PULWULVVHLWVQWVMUVRWOUIUOWOWULVWAWUNGUEWVHWULVVTWUNGWULVVTWVLOPNVVHVXAPNWUNWU
  LVVRWVLOPWVPULWULVVHLOWVQWVMWVOUVSWULVXASVVHPVXASRWULUTWMUOWRZUIWULACGWUNIWUL
  WUNVETLWUNWAWBZWUNVXITWULVVHSWULLVVGWWBWWCWTVYMWULVYNWMUVTZWULLVVHWUNWWEWULLV
  VGWWEWWFXLZWULVVHSWWRSXCTZWULWDWMZXDZWULLVVGWWEWWFWWLVVGXNXHWULVHSWAWBVVHWUNW
  AWBVHSXEWDXMWEWULVVHSWWRWWTUWAXOUWCZLWUNVFXIXJXKWOUMWULWUMVMTVVIVMTZWUOVMTZWU
  OVHVNZVOWUTVMTWUTVHVNVOZVOWVBWVKRWULVVJVVRWULVVHOWVQWVOXPZWULLVVQWVMWULVVGOWV
  NWVOXPZWPZWULLVVQWVMWXHVYBWULVRWMWULVVQVVGUWDZUWEXQZXRZWULVVHXSTZWXCWULLVVGLX
  STWULUWFWMWWMUWGWXMVVIACGVVHIXTYAYBWULWXDWXEWXFWULVVRWUNWXIWULVVHSWVQWVSXPZWU
  LWUNWULVHVVHWUNVHXCTWULXEWMWWRWXAWULLVVGWWEWWFVHLYCWBWULXFWMVVGUWHUWIWULVVHSW
  WRWULWWSVHSYCWBZVOSYDTWULWWSWXOWWTXMUWMSUWJUWKZUWLUXCUWNZXRZWULVVRWUNWXIWXNWX
  KWXQUWOZWULWUTWULWUSXSTZWUTYDTWULWUSVETVHWUSWAWBZWXTWULWUNLWWQWWBUWPWULWYAWWP
  WXBWULWUNLWXAWWEUWQUWRWUSUWSXJACGWUSIXTYBYEUXDWUMVVIWUOWUTUWTUXAWSWULWVAVVLWU
  PMWULWUTVVKVVIQWULWUSVVJGWULWUSVVHVYHPNVVJWULVVHSLWVQWVSWVMWQWULVYHOVVHPVYHOR
  WULVYOWMUOWOUIUOUOWOYFWULVWEWURRVVPWULVWEVUEOVVMVVRWVCQNZVVRVVTQNZMNZMNZQNZMN
  ZWURWULVWDWYFVUEMWULVWCWYEOQWULVWCVVMVVQDUEZMNZWYEWULVVGOVDUETZVWCWYIRWULWYJV
  VGUXBUXEZMDOVVGUXFYBWULWYHWYDVVMMWULBVVQWUEWYDUDDXCDBUDWUEUFRZWULHWMVYSVVQRZW
  UEWYDRWULWYMWUBWYBWUDWYCMWYMVYTVVRWUAWVCQVYSVVQLMUHZWYMVYTVVROVQWYNULUMWYMVYT
  VVRWUCVVTQWYNWYMVYTVVROPWYNULUMUMWLWXJWULWYBWYCWULVVRWVCWULLVVQWWEWWIXLZWULVV
  ROWYOWWHYGWULVVROWXIWVOWULOVVRWWHWULLVVQWWEWWIOLYCWBZWULYHWMWULOVVGWWHVVGYIZU
  XGUXHUXNUXIZYJWULVVRVVTWYOWULVVTWUNXCWWOWXAYKWULVVTWUNVHWWOWXQUXJYJXLYPUOWOUO
  UOWULWYGVUEOVVMVVRVVJQNZWUOMNZMNZQNZMNZVVOWUPMNZWURWULWYFXUBVUEMWULWYEXUAOQWU
  LWYDWYTVVMMWULWYBWYSWYCWUOMWULWVCVVJVVRQWVRUOWULVVTWUNVVRQWWOUOUMUOUOUOWULXUC
  VUEVVNWYTQNZMNVVOWYTQNZXUDWULXUBXUEVUEMWULXUEXUBWULVXTVVMVMTVVMVHVNVOWYTVMTWY
  TVHVNVOXUEXUBRWVOWULVVMWULUCAMYDDOVVGWYKWULUCUJZOVVGUXKNTZVOXUGUDTZXUGDUEZYDT
  XUHXUIWULXUGVVGUXLWLXUIXUJLXUGMNZXUKOVQNZQNZXUKXUKOPNZQNZMNZYDXUIBXUGWUEXUPUD
  DYDWYLXUIHWMVYSXUGRZWUEXUPRXUIXUQWUBXUMWUDXUOMXUQVYTXUKWUAXULQVYSXUGLMUHZXUQV
  YTXUKOVQXURULUMXUQVYTXUKWUCXUNQXURXUQVYTXUKOPXURULUMUMWLXUIUXOXUIXUMXUOXUIXUK
  XULXUILXUGLYDTZXUIYQWMXUGYIZYLZXUIXULXUIXUKOXUILXUGWWDXUIWCWMZXUGXAZXLZWWGXUI
  XBWMZYGXUIOXUKYCWBVHXULYCWBXUIOXUGXUKXVEXVCXVDXUGXNXUIOXUGMNZXUGXUKYCXUIXUGXU
  GWNUXMXUIWYPXVFXUKYCWBYHXUIOLXUGXVEXVBXUTUXPXOUXQUXRXUIOXUKXVEXVDUXSXGUXTYMXU
  IXUKXUNXVAXUIXUKXVDXUILXUGXVBXVCWWJXUIWWKWMXUIXUGXUTUYAYNYOYMYLZYPXVGYKYBXUGY
  DTAUJZYDTVOXUGXVHMNYDTWULXUGXVHUYBWLUYCZYEWULWYTWULWYSWUOWULVVRVVJWULLVVQXUSW
  ULYQWMZWULVVGWWFWWNYOYLZWULVVHWWRWULLVVGWWEWWFWWLWWNYNYOYMWULVVRWUNXVKWULVVHS
  WULLVVGXVJWYQYLWXPUYDYMYLZYEOVVMWYTUYEUYFYRUOWULVUEVVNWYTVUEVMTWULVYEWMZWULVV
  MWULVVMXVIYAWULVVMXVIYSUYGZWULWYTXVLYAWULWYTXVLYSYTWULXUFVVOVVRVVRMNZVVJWUNMN
  ZQNZQNZVVOXVPXVOQNZMNZXUDWULWYTXVQVVOQWULVVRVVJVVRWUNWXIWXGWXIWXNWULWVCVVJVHW
  VRWYRUYHZWXQUYIUOWULXVRVVOXVPMNXVOQNXVTWULVVOXVOXVPWULVUEVVNXVMXVNWPZWULVVRVV
  RWXIWXIWPZWULVVJWUNWXGWXNWPZWULVVRVVRWXIWXIWXKWXKXQZWULVVJWUNWXGWXNXWAWXQXQUY
  NWULVVOXVPXVOXWBXWDXWCXWEYTWOWULXVSWUPVVOMWULWUPXVSWULVVJVVRVVRWUNWXGWXIWXIWX
  NWXKWXQWXKUYJYRUOWRUYKWULVVOWUPWULVUEVVNWULUGVYCWULVYDWMUYLXVNWPWULWUMWUOWXLW
  XRWXSXRUYMWRWOYFWSUYOUYPUYQJKUYR $.
  $}

  ${
    $d k n x $.  $d F x $.  $d G k $.  $d L k $.
    wallispilem5.1 $e |- F = ( k e. NN |-> ( ( ( 2 x. k ) / ( ( 2 x. k ) - 1
                            ) ) x. ( ( 2 x. k ) / ( ( 2 x. k ) + 1 ) ) ) ) $.
    wallispilem5.2 $e |- I = ( n e. NN0 |-> S. ( 0 (,) pi ) ( ( sin ` x ) ^
                            n ) _d x ) $.
    wallispilem5.3 $e |- G = ( n e. NN |-> ( ( I ` ( 2 x. n ) ) / ( I ` ( (
                            2 x. n ) + 1 ) ) ) ) $.
    wallispilem5.4 $e |- H = ( n e. NN |-> ( ( pi / 2 ) x. ( 1 / ( seq 1 (
                            x. , F ) ` n ) ) ) ) $.
    wallispilem5.5 $e |- L = ( n e. NN |-> ( ( ( 2 x. n ) + 1 ) / ( 2 x. n )
                            ) ) $.
    $( The sequence ` H ` converges to 1.  (Contributed by Glauco Siliprandi,
       30-Jun-2017.) $)
    wallispilem5 $p
                   |- H ~~> 1 $=
  ( c1 cn wcel a1i c2 co cdiv cli wallispilem4 wbr wtru cvv nnuz cz 2cn cc0 wne
  1z cc 2ne0 zcnd clim1fr1 cv cmul cfv caddc cmpt nnex mptex eqeltri cr wf 2nn0
  cn0 nnnn0 nn0mulcld 1nn0 nn0addcld nn0red nncn nnne0 redivcld fmpti ffvelrnda
  mulne0d crp wallispilem3 syl rpred rerpdivcld cle cmin 2nn id nnmulcld mulcld
  nnm1nn0 ax-1cn npcand fveq2d wallispilem1 eqbrtrrd addcld divcld rpcnd rpne0d
  lediv1dd divcan4d cuz 2re nnre remulcld 1re readdcld nn0ge0d nnge1 lemulge11d
  ltp1d lelttrd ltled wb nn0zd eluz syl2anc mpbird itgsinexp pncand oveq1d wceq
  2m1e1 eqcomi oveq2d subsub3d eqtr2d oveq12d peano2nnd nnne0d mulassd divcan6d
  eqtrd mulid2d 3eqtr2d eqtr3d breqtrrd nfcv nffv adantl rpdivcld cpi cioo csin
  cexp citg nfmpt1 nfcxfr nfov oveq2 fvmptf mpdan simpr fvmptd 3brtr4d climsqz2
  wa dividd trud eqbrtrri ) EFNUAABCDEFGIJKLUBENUAUCUDNBHENUEOUFNUGPUDUKQZUDRNC
  HMRULPZUDUHQRUIUJZUDUMQUDNUVAUNUOEUEPUDECORCUPZUQSZGURZUVENUSSZGURZTSZUTUEKCO
  UVIVAVBVCQUDOVDBUPZHOVDHVEUDCOVDUVGUVETSZHMUVDOPZUVGUVEUVLUVGUVLUVENUVLRUVDRV
  GPZUVLVFQUVDVHVIZNVGPZUVLVJQVKZVLUVLUVEUVNVLUVLRUVDUVBUVLUHQUVDVMUVCUVLUMQUVD
  VNVRVOVPQVQUDOVDUVJEOVDEVEUDCOVDUVIEKUVLUVFUVHUVLUVFUVLUVEVGPUVFVSPUVNACGUVEJ
  VTWAWBUVLUVGVGPUVHVSPUVPACGUVGJVTWAWCVPQVQUVJOPZUVJEURZUVJHURZWDUCUDUVQRUVJUQ
  SZGURZUVTNUSSZGURZTSZUWBUVTTSZUVRUVSWDUVQUWDUVTNWESZGURZUWCTSZUWEWDUVQUWAUWGU
  WCUVQUWAUVQUVTVGPUWAVSPUVQRUVJUVMUVQVFQZUVJVHVIZACGUVTJVTWAZWBZUVQUWGUVQUWFVG
  PZUWGVSPUVQUVTOPUWMUVQRUVJROPUVQWFQUVQWGZWHZUVTWJWAZACGUWFJVTWAZWBUVQUWBVGPUW
  CVSPUVQUVTNUWJUVOUVQVJQVKZACGUWBJVTWAZUVQUWFNUSSZGURUWAUWGWDUVQUWTUVTGUVQUVTN
  UVQRUVJUVBUVQUHQZUVJVMZWIZNULPUVQWKQZWLWMUVQACGUWFJUWPWNWOWTUVQUWEUWCUQSZUWCT
  SUWEUWHUVQUWEUWCUVQUWBUVTUVQUVTNUXCUXDWPZUXCUVQRUVJUXAUXBUVCUVQUMQUVJVNVRZWQZ
  UVQUWCUWSWRZUVQUWCUWSWSZXAUVQUXEUWGUWCTUVQUXEUWEUVTUWBTSZUWGUQSZUQSUWEUXKUQSZ
  UWGUQSZUWGUVQUWCUXLUWEUQUVQUWCUWBNWESZUWBTSZUWBRWESZGURZUQSUXLUVQACGUWBJUVQUW
  BRXBURPZRUWBWDUCZUVQRUWBRVDPUVQXCQZUVQUVTNUVQRUVJUYAUVJXDZXEZNVDPUVQXFQXGZUVQ
  RUVTUWBUYAUYCUYDUVQRUVJUYAUYBUVQRUWIXHUVJXIXJUVQUVTUYCXKXLXMUVQRUGPUWBUGPUXSU
  XTXNUVQRUWIXOUVQUWBUWRXORUWBXPXQXRXSUVQUXPUXKUXRUWGUQUVQUXOUVTUWBTUVQUVTNUXCU
  XDXTYAUVQUXQUWFGUVQUWFUVTRNWESZWESUXQUVQNUYEUVTWENUYEYBUVQUYENYCYDQYEUVQUVTRN
  UXCUXAUXDYFYGWMYHYMYEUVQUWEUXKUWGUXHUVQUVTUWBUXCUXFUVQUWBUVQUVTUWOYIYJZWQUVQU
  WGUWQWRZYKUVQUXNNUWGUQSUWGUVQUXMNUWGUQUVQUWBUVTUXFUXCUYFUXGYLYAUVQUWGUYGYNYMY
  OYAYPYQUVQUWDVSPUVRUWDYBUVQUWAUWCUWKUWSUUACUVJUVIUWDOEVSCUVJYRCUWAUWCTCUVTGCG
  CVGAUIUUBUUCSAUPUUDURUVDUUESUUFZUTJCVGUYHUUGUUHZCUVTYRYSCTYRCUWBGUYICUWBYRYSU
  UIUVDUVJYBZUVFUWAUVHUWCTUYJUVEUVTGUVDUVJRUQUUJZWMUYJUVGUWBGUYJUVEUVTNUSUYKYAW
  MYHKUUKUULZUVQCUVJUVKUWEOHULHCOUVKUTYBUVQMQUVQUYJUUQZUVGUWBUVEUVTTUYMUVEUVTNU
  SUYMUVDUVJRUQUVQUYJUUMYEZYAUYNYHUWNUXHUUNUUOYTUVQNUVRWDUCUDUVQNUWDUVRWDUVQUWC
  UWCTSNUWDWDUVQUWCUXIUXJUURUVQUWCUWAUWCUVQUWCUWSWBUWLUWSUVQACGUVTJUWJWNWTWOUYL
  YQYTUUPUUSUUT $.
  $}

  ${
    $d j k n $.  $d j n w $.  $d k n x $.  $d F j $.  $d F n $.  $d F w $.
    $d F x $.  $d W j $.
    wallispi.1 $e |- F = ( k e. NN |-> ( ( ( 2 x. k ) / ( ( 2 x. k ) - 1 ) ) x.
                     ( ( 2 x. k ) / ( ( 2 x. k ) + 1 ) ) ) ) $.
    wallispi.2 $e |- W = ( n e. NN |-> ( seq 1 ( x. , F ) ` n ) ) $.
    $( Wallis' formula for &pi; :  Wallis' product converges to &pi; / 2 .
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    wallispi $p |- W ~~> ( pi / 2 ) $=
      ( c1 c2 cpi cdiv co wtru cn cmul cfv wcel a1i cc0 cc crp vj vx vw cli wbr
      cv cseq cmpt cvv nnuz cz 1z cn0 cioo csin cexp citg eqid wallispilem5 2cn
      caddc pire recni wne pipos gt0ne0ii divcld mptex wf halfcld elnnuz biimpi
      nnex cuz cfz cmin wceq weq oveq2 oveq1d oveq12d adantl elfznn nncn mulcld
      ax-1cn subcld cr 1re clt remulcld 2re nnre 1rp 1lt2 ltmul1dd cle 0re 2pos
      1t1e1 ltleii nnge1 lemul2ad ltletrd syl5eqbrr gtned subne0d addcld rpgt0d
      readdcld 2rp nnrp rpmulcld ltaddrp2d lttrd fvmptd nnrpd resubcld ltsub1dd
      syl 1m1e0 elrpd rpdivcld nnred rpge0d mulge0d ge0p1rpd eqeltrd wa rpmulcl
      seqcl rpcnd rpne0d reccld fmpti ffvelrnda fveq2 eqidd oveq2d 2ne0 vtoclga
      eleq1d divrecd divcan6d eqcomd mulassd 3eqtrd id 3eqtr4d climmulc2 divcli
      rpreccld mulid1i syl6breq divne0i csn cdif recne0d eqnetrd elsni necon3ai
      eldifd recrecd fvmpt3 3eqtr4rd eqeltri climrec trud recdiv mp4an breqtri
      wn ) DGHIJKZJKZIHJKZUDDUVNUDUELUVMUABMGBUFZNCGUGZOZJKZUHZDGUIMUJGUKPLULQZ
      LUVTUVMGNKUVMUDLGUVMUABMUVOUVSNKZUHZUVTGUIMUJUWAUWCGUDUELUBABCBMHUVPNKZBU
      MUBRIUNKUBUFUOOUVPUPKUQUHZOUWDGVAKZUWEOJKUHZUWCUWEBMUWFUWDJKUHZEUWEURUWGU
      RUWCURZUWHURUSQLHIHSPZLUTQISPZLIVBVCZQIRVDZLIVBVEVFZQVGUVTUIPLBMUVSVMVHQL
      MSUAUFZUWCMSUWCVILBMSUWBUWCUWIUVPMPZUVOUVSUWPIUWKUWPUWLQVJUWPUVRUWPUVRUWP
      UAUCNTCGUVPUWPUVPGVNOPUVPVKVLUWOGUVPVOKPZUWOCOZTPUWPUWQUWRHUWONKZUWSGVPKZ
      JKZUWSUWSGVAKZJKZNKZTUWQAUWOHAUFZNKZUXFGVPKZJKZUXFUXFGVAKZJKZNKZUXDMCSCAM
      UXKUHVQUWQEQAUAVRZUXKUXDVQUWQUXLUXHUXAUXJUXCNUXLUXFUWSUXGUWTJUXEUWOHNVSZU
      XLUXFUWSGVPUXMVTWAUXLUXFUWSUXIUXBJUXMUXLUXFUWSGVAUXMVTWAWAWBUWOUVPWCZUWQU
      WOMPZUXDSPUXNUXOUXAUXCUXOUWSUWTUXOHUWOUWJUXOUTQZUWOWDWEZUXOUWSGUXQGSPUXOW
      FQZWGUXOUWSGUXQUXRUXOGUWSGWHPUXOWIQZUXOGGGNKZUWSWJWTUXOUXTHGNKUWSUXOGGUXS
      UXSWKUXOHGHWHPZUXOWLQZUXSWKUXOHUWOUYBUWOWMZWKZUXOGHGUXSUYBGTPUXOWNQZGHWJU
      EUXOWOQWPUXOGUWOHUXSUYCUYBRHWQUEUXORHWRWLWSXAQUWOXBXCXDXEZXFXGVGUXOUWSUXB
      UXQUXOUWSGUXQUXRXHUXORUXBRWHPUXOWRQZUXORGUXBUYGUXSUXOUWSGUYDUXSXJUXOGUYEX
      IUXOGUWSUXSUXOHUWOHTPZUXOXKQZUWOXLXMXNXOXFVGWEXTXPUWQUXAUXCUWQUWSUWTUWQHU
      WOUYHUWQXKQZUWQUWOUXNXQZXMZUWQUXOUWTTPUXNUXOUWTUXOUWSGUYDUXSXRUXORGGVPKUW
      TWJYAUXOGUWSGUXSUYDUXSUYFXSXEYBXTYCUWQUWSUXBUYLUWQUWSUWQHUWOUYAUWQWLQZUWQ
      UWOUXNYDZWKUWQHUWOUYMUYNUWQHUYJYEUWQUWOUYKYEYFYGYCXMYHWBUWOTPUCUFZTPYIUWO
      UYONKTPUWPUWOUYOYJWBYKZYLUWPUVRUYPYMYNWEYOQYPUXOUWOUVTOZUVMUWOUWCOZNKZVQL
      UXOGUWOUVQOZJKZUVMUVOVUANKZNKZUYQUYSUXOVUAGVUANKUVMUVONKZVUANKVUCUXOGUYTU
      XRUXOUYTUVRTPUYTTPBUWOMBUAVRZUVRUYTTUVPUWOUVQYQZUUBUYPUUAZYLZUXOUYTVUGYMZ
      UUCUXOGVUDVUANUXOVUDGUXOHIUXPUWKUXOUWLQZUXOHUYIYMUWMUXOUWNQZUUDUUEVTUXOUV
      MUVOVUAUXOHIUXPVUJVUKVGUXOIVUJVJZUXOUYTVUHVUIYNZUUFUUGUXOBUWOUVSVUAMUVTTU
      XOUVTYRZVUEUVSVUAVQUXOVUEUVRUYTGJVUFYSWBZUXOUUHZUXOUYTVUGUULXPZUXOUYRVUBU
      VMNUXOBUWOUWBVUBMUWCSUXOUWCYRUXOVUEYIUVSVUAUVONVUOYSVUPUXOUVOVUAVULVUMWEX
      PYSUUIWBUUJUVMHIUTUWLUWNUUKUUMUUNUVMRVDLHIUTUWLYTUWNUUOQUXOUYQSRUUPZUUQPL
      UXOUYQSVURUXOUYQVUASVUQVUMYHUXOUYQRVDUYQVURPZUVLUXOUYQVUARVUQUXOUYTVUHVUI
      UURUUSVUSUYQRUYQRUUTUVAXTUVBWBUXOUWODOZGUYQJKZVQLUXOGVUAJKUYTVVAVUTUXOUYT
      VUHVUIUVCUXOUYQVUAGJUXOBUWOUVSVUAMUVTSVUNVUOVUPVUMXPYSBUWOUVRUYTMDTVUFFUY
      PUVDUVEWBDUIPLDBMUVRUHUIFBMUVRVMVHUVFQUVGUVHUWJHRVDUWKUWMUVNUVOVQUTYTUWLU
      WNHIUVIUVJUVK $.
  $}

  ${
    $d k w x y $.  $d N x $.
    $( An intermediate step between the first version of the Wallis' formula
       for &pi; and the second version of Wallis' formula.  This second version
       will then be used to prove Stirling's approximation formula for the
       factorial.  (Contributed by Glauco Siliprandi, 30-Jun-2017.) $)
    wallispi2lem1 $p
      |- ( N e. NN -> ( seq 1 ( x. , ( k e. NN |-> ( ( ( 2 x. k ) /
      ( ( 2 x. k ) - 1 ) ) x. ( ( 2 x. k ) / ( ( 2 x. k ) + 1 ) ) ) ) ) ` N ) =
      ( ( 1 / ( ( 2 x. N ) + 1 ) ) x. ( seq 1 ( x. , ( k e. NN |->
      ( ( ( 2 x. k ) ^ 4 ) /
      ( ( ( 2 x. k ) x. ( ( 2 x. k ) - 1 ) ) ^ 2 ) ) ) ) ` N ) ) )
                        $=
  ( cmul c2 co c1 cmin cdiv caddc c4 cexp wceq oveq1d oveq2d oveq12d wcel c3 cc
  cfv a1i vx vy vw cv cn cmpt cseq fveq2 oveq2 eqeq12d cz 1z seq1 1nn eqid ovex
  ax-mp fvmpt 2cn mulid1i oveq1i 2m1e1 eqtri oveq12i ax-1cn 3cn 3ne0 divmuldivi
  2p1e3 ax-1ne0 2t2e4 mulid2i 3eqtri cc0 wne 4cn divrec2 mp3an eqcomi oveq2i c6
  cdc 2exp4 sq2 4t4e16 0re 4pos gtneii divcan3i wa cuz elnnuz biimpi adantr syl
  seqp1 simpr crp eqidd adantl peano2nn nnre nnnn0 nn0ge0d ge0p1rpd rpmulcld cr
  2rp 2re 1re readdcld remulcld clt wbr rpdivcld fvmptd recnd rpne0d divmuldivd
  1lt2 cle mulcld divdiv1d sqvald eqcomd sqcld divcld nncn addcld 2nn id nnne0d
  nnmulcld reccld 4nn0 mulne0d 2z expne0d eqtrd 3eqtrd resubcld mulgt1d posdifd
  nnrp ltaddrp2d mpbid elrpd rpge0d 0le1 addge0d mulge0d rpcnd gt0ne0d divrec2d
  3eqtr2d peano2nnd cfz elfznn cn0 nnexpcld nncnd subcld syl5breqr 2nn0 nn0ge0i
  nnne0 nnge1 lemul2ad ltletrd gtned subne0d eqeltrd mulcl seqcl mul12d mulcomd
  mulassd mulid2d adddid addsubassd eqtr4d 2p2e4 subaddrii nn0zi expsubd sqmuld
  expclzd ex nnind ) UAUDZCAUEDAUDZCEZUWLFGEZHEZUWLUWLFIEZHEZCEZUFZFUGZSZFDUWJC
  EZFIEZHEZUWJCAUEUWLJKEZUWLUWMCEZDKEZHEZUFZFUGZSZCEZLFUWSSZFDFCEZFIEZHEZFUXISZ
  CEZLUBUDZUWSSZFDUXRCEZFIEZHEZUXRUXISZCEZLZUXRFIEZUWSSZFDUYFCEZFIEZHEZUYFUXISZ
  CEZLZBUWSSZFDBCEZFIEZHEZBUXISZCEZLUAUBBUWJFLZUWTUXLUXKUXQUWJFUWSUHUYTUXCUXOUX
  JUXPCUYTUXBUXNFHUYTUXAUXMFIUWJFDCUIMNUWJFUXIUHOUJUWJUXRLZUWTUXSUXKUYDUWJUXRUW
  SUHVUAUXCUYBUXJUYCCVUAUXBUYAFHVUAUXAUXTFIUWJUXRDCUIMNUWJUXRUXIUHOUJUWJUYFLZUW
  TUYGUXKUYLUWJUYFUWSUHVUBUXCUYJUXJUYKCVUBUXBUYIFHVUBUXAUYHFIUWJUYFDCUIMNUWJUYF
  UXIUHOUJUWJBLZUWTUYNUXKUYSUWJBUWSUHVUCUXCUYQUXJUYRCVUCUXBUYPFHVUCUXAUYOFIUWJB
  DCUIMNUWJBUXIUHOUJUXLFUWRSZUXMUXMFGEZHEZUXMUXNHEZCEZUXQFUKPZUXLVUDLULCUWRFUMU
  QFUEPZVUDVUHLUNAFUWQVUHUEUWRUWKFLZUWNVUFUWPVUGCVUKUWLUXMUWMVUEHUWKFDCUIZVUKUW
  LUXMFGVULMZOVUKUWLUXMUWOUXNHVULVUKUWLUXMFIVULMOOUWRUOVUFVUGCUPURUQVUHJQHEZFQH
  EZJCEZUXQVUHDFHEZDQHEZCEDDCEZFQCEZHEVUNVUFVUQVUGVURCUXMDVUEFHDUSUTZVUEDFGEZFU
  XMDFGVVAVAVBVCZVDUXMDUXNQHVVAUXNDFIEQUXMDFIVVAVAVIVCZVDVDDFDQUSVEUSVFVJVGVHVU
  SJVUTQHVKQVFVLVDVMJRPQRPQVNVOVUNVUPLVPVFVGJQVQVRVUOUXOJUXPCQUXNFHUXNQVVDVSVTU
  XPJUXPFUXHSZUXMJKEZUXMVUECEZDKEZHEZJVUIUXPVVELULCUXHFUMUQVUJVVEVVILUNAFUXGVVI
  UEUXHVUKUXDVVFUXFVVHHVUKUWLUXMJKVULMVUKUXEVVGDKVUKUWLUXMUWMVUECVULVUMOMOUXHUO
  VVFVVHHUPURUQVVIDJKEZDDKEZHEZJVVFVVJVVHVVKHUXMDJKVVAVAVVGDDKVVGUXMDUXMDVUEFCV
  VAVVCVDVVAVCVAVDVVLFWAWBZJHEJJCEZJHEJVVJVVMVVKJHWCWDVDVVMVVNJHVVNVVMWEVSVAJJV
  PVPVNJWFWGWHWIVMVCVMVSVDVMVMUXRUEPZUYEUYMVVOUYEWJZUYGUXSUYFUWRSZCEZUYDVVQCEZU
  YLVVPUXRFWKSPZUYGVVRLVVOVVTUYEVVOVVTUXRWLWMZWNCUWRFUXRWPWOVVPUXSUYDVVQCVVOUYE
  WQMVVOVVSUYLLUYEVVOVVSUYJUYCUYHJKEZUYHUYHFGEZCEZDKEZHEZCEZCEZUYJUYCUYFUXHSZCE
  ZCEUYLVVOVVSUYDUYHVWCHEZUYHUYIHEZCEZCEUYDUYHDKEZVWCHEZUYIHEZCEZVWHVVOVVQVWMUY
  DCVVOAUYFUWQVWMUEUWRWRVVOUWRWSUWKUYFLZUWQVWMLVVOVWRUWNVWKUWPVWLCVWRUWLUYHUWMV
  WCHUWKUYFDCUIZVWRUWLUYHFGVWSMOVWRUWLUYHUWOUYIHVWSVWRUWLUYHFIVWSMOOWTUXRXAZVVO
  VWKVWLVVOUYHVWCVVODUYFDWRPVVOXHTZVVOUXRUXRXBZVVOUXRUXRXCXDZXEXFZVVOVWCVVOUYHF
  VVODUYFDXGPZVVOXITZVVOUXRFVXBFXGPZVVOXJTZXKZXLZVXHUUAZVVOFUYHXMXNVNVWCXMXNVVO
  DUYFVXFVXIFDXMXNVVOXTTVVOFUXRVXHUXRUUDUUEUUBVVOFUYHVXHVXJUUCUUFZUUGXOVVOUYHUY
  IVXDVVOUYHVXJVVODUYFVXFVXIVVODVXAUUHVVOUXRFVXBVXHVXCVNFYAXNVVOUUITUUJUUKXEZXO
  XFXPNVVOVWMVWPUYDCVVOVWMUYHUYHCEZVWCUYICEHEVXNVWCHEZUYIHEVWPVVOUYHVWCUYHUYIVV
  OUYHVXJXQZVVOVWCVXKXQZVXPVVOUYIVXMUULZVVOVWCVXLUUMZVVOUYIVXMXRZXSVVOVXNVWCUYI
  VVOUYHUYHVXPVXPYBVXQVXRVXSVXTYCVVOVXOVWOUYIHVVOVXNVWNVWCHVVOVWNVXNVVOUYHVXPYD
  YEMMUUONVVOVWQUYDUYJVWOCEZCEUYJUYDVWOCEZCEVWHVVOVWPVYAUYDCVVOVWOUYIVVOVWNVWCV
  VOUYHVXPYFZVXQVXSYGZVXRVXTUUNNVVOUYDUYJVWOVVOUYBUYCVVOUYAVVOUXTFVVODUXRDRPZVV
  OUSTZUXRYHZYBZFRPZVVOVETZYIZVVOUYAVVOUXTVVODUXRDUEPZVVOYJTZVVOYKYMUUPYLZYNZVV
  OUAUCCRUXHFUXRVWAVVOUWJFUXRUUQEPZWJZUWJUXHSUXAJKEZUXAUXAFGEZCEZDKEZHEZRVYQAUW
  JUXGWUBUEUXHRVYQUXHWSUWKUWJLZUXGWUBLVYQWUCUXDVYRUXFWUAHWUCUWLUXAJKUWKUWJDCUIZ
  MWUCUXEVYTDKWUCUWLUXAUWMVYSCWUDWUCUWLUXAFGWUDMOMOWTVYPUWJUEPZVVOUWJUXRUURZWTV
  YPWUBRPZVVOVYPWUEWUGWUFWUEVYRWUAWUEVYRWUEUXAJWUEDUWJVYLWUEYJTZWUEYKYMJUUSPWUE
  YOTUUTUVAWUEVYTWUEUXAVYSWUEDUWJVYEWUEUSTZUWJYHZYBZWUEUXAFWUKVYIWUEVETZUVBZYBZ
  YFWUEVYTDWUNWUEUXAVYSWUKWUMWUEDUWJWUIWUJWUEDWUHYLUWJUVFYPWUEUXAFWUKWULWUEFUXA
  VXGWUEXJTZWUEFUXMUXAWUOWUEDFVXEWUEXITZWUOXLWUEDUWJWUPUWJXBZXLWUEFDUXMXMXTUXMD
  LZWUEVVATUVCWUEFUWJDWUOWUQWUPVNDYAXNWUEDUVDUVETUWJUVGUVHUVIUVJUVKYPDUKPZWUEYQ
  TYRYGWOWTZXPWUTUVLUWJRPUCUDZRPWJUWJWVACERPVVOUWJWVAUVMWTUVNZYBVVOUYIVXRVXTYNV
  YDUVOVVOVYBVWGUYJCVVOVYBUYCUYBCEZVWOCEUYCUYBVWOCEZCEVWGVVOUYDWVCVWOCVVOUYBUYC
  VYOWVBUVPMVVOUYCUYBVWOWVBVYOVYDUVQVVOWVDVWFUYCCVVOWVDFVWNCEZUYAVWCCEZHEVWNUYA
  DKEZHEZVWFVVOFUYAVWNVWCVYJVYKVYCVXQVYNVXSXSVVOWVEVWNWVFWVGHVVOVWNVYCUVRVVOWVF
  UYAUYACEWVGVVOVWCUYAUYACVVOVWCUXTDIEZFGEUXTVVBIEUYAVVOUYHWVIFGVVOUYHUXTUXMIEW
  VIVVODUXRFVYFVYGVYJUVSVVOUXMDUXTIWURVVOVVATNYSMVVOUXTDFVYHVYFVYJUVTVVOVVBFUXT
  IVVBFLVVOVBTNYTZNVVOUYAVYKYDUWAOVVOWVHVWBVWNHEZVWCDKEZHEVWBVWNWVLCEZHEVWFVVOV
  WNWVKWVGWVLHVVOVWNUYHJDGEZKEWVKVVODWVNUYHKDWVNLVVOWVNDJDDVPUSUSUWBUWCVSTNVVOU
  YHJDVXPVVOUYHVXDXRZWUSVVOYQTZJUKPVVOJYOUWDTZUWEYSVVOUYAVWCDKVVOVWCUYAWVJYEMOV
  VOVWBVWNWVLVVOUYHJVXPWVOWVQUWGZVYCVVOVWCVXQYFVVOUYHDVXPVVODUYFVYFVVOUXRFVYGVY
  JYIVVODVYMYLVVOUYFVWTYLYPWVPYRVVOVWCDVXQVXSWVPYRYCVVOWVMVWEVWBHVVOVWEWVMVVOUY
  HVWCVXPVXQUWFYENYTYTNYTNYTYTVVOVWGVWJUYJCVVOVWFVWIUYCCVVOVWIVWFVVOAUYFUXGVWFU
  EUXHRVVOUXHWSVVOVWRWJZUXDVWBUXFVWEHWVSUWLUYHJKWVSUWKUYFDCVVOVWRWQNZMWVSUXEVWD
  DKWVSUWLUYHUWMVWCCWVTWVSUWLUYHFGWVTMOMOVWTVVOVWBVWEWVRVVOVWDVVOUYHVWCVXPVXQYB
  ZYFVVOVWDDWWAVVOUYHVWCVXPVXQWVOVXSYPWVPYRYGXPYENNVVOVWJUYKUYJCVVOUYKVWJVVOVVT
  UYKVWJLVWACUXHFUXRWPWOYENYTWNYTUWHUWI $.
  $}

  ${
    $d k x y $.  $d N x $.
    $( Two expressions are proven to be equal, and this is used to complete the
       proof of the second version of Wallis' formula for &pi; .  (Contributed
       by Glauco Siliprandi, 30-Jun-2017.) $)
    wallispi2lem2 $p
      |- ( N e. NN -> ( seq 1 ( x. , ( k e. NN |-> ( ( ( 2 x. k ) ^ 4 ) /
      ( ( ( 2 x. k ) x. ( ( 2 x. k ) - 1 ) ) ^ 2 ) ) ) ) ` N ) = ( ( ( 2 ^
      ( 4 x. N ) ) x. ( ( ! ` N ) ^ 4 ) ) / ( ( ! ` ( 2 x. N ) ) ^ 2 ) ) )
                        $=
  ( cmul c2 co c4 cexp cmin cdiv cfv cfa wceq caddc oveq2 oveq2d oveq1d oveq12d
  c1 wcel a1i vx vy cv cn cmpt cseq fveq2 fveq2d eqeq12d cz seq1 ax-mp 1nn eqid
  1z ovex fvmpt 2cn mulid1i oveq1i c6 cdc 2exp4 cc0 1nn0 6nn0 0nn0 1t1e1 ax-1cn
  addid1i eqtri nn0cni dec0h decmul1c eqtr4i 2nn0 2t2e4 sq1 numexp2x eqcomi 4cn
  oveq2i fac1 oveq12i 3eqtri 2m1e1 fveq2i wa cuz elnnuz biimpi adantr seqp1 syl
  fac2 simpr cc eqidd adantl peano2nn nncn addcld mulcld cn0 4nn0 expcld subcld
  sqcld clt wbr 2pos gt0ne0d nnne0d mulne0d cr 1re nnre readdcld 1lt2 ltaddrp2d
  2re nnrp mulgt1d gtned subne0d 2z expne0d divcld nn0mulcld faccl 3syl mulexpd
  fvmptd eqcomd 3eqtrd adddid df-2 eqtr4d facp1 3eqtr3d nnnn0 divmuldivd syl6eq
  mulcomd syl5eqel addsubassd mulassd 3eqtr4d addassd nn0addcld 3eqtr4g 3eqtrrd
  mul4d eqtrd expaddd ex nnind ) UAUCZCAUDDAUCZCEZFGEZUUTUUTRHEZCEZDGEZIEZUEZRU
  FZJZDFUURCEZGEZUURKJZFGEZCEZDUURCEZKJZDGEZIEZLRUVGJZDFRCEZGEZRKJZFGEZCEZDRCEZ
  KJZDGEZIEZLUBUCZUVGJZDFUWHCEZGEZUWHKJZFGEZCEZDUWHCEZKJZDGEZIEZLZUWHRMEZUVGJZD
  FUWTCEZGEZUWTKJZFGEZCEZDUWTCEZKJZDGEZIEZLZBUVGJZDFBCEZGEZBKJZFGEZCEZDBCEZKJZD
  GEZIEZLUAUBBUURRLZUVHUVRUVQUWGUURRUVGUGUYBUVMUWCUVPUWFIUYBUVJUVTUVLUWBCUYBUVI
  UVSDGUURRFCNOUYBUVKUWAFGUURRKUGPQUYBUVOUWEDGUYBUVNUWDKUURRDCNUHPQUIUURUWHLZUV
  HUWIUVQUWRUURUWHUVGUGUYCUVMUWNUVPUWQIUYCUVJUWKUVLUWMCUYCUVIUWJDGUURUWHFCNOUYC
  UVKUWLFGUURUWHKUGPQUYCUVOUWPDGUYCUVNUWOKUURUWHDCNUHPQUIUURUWTLZUVHUXAUVQUXJUU
  RUWTUVGUGUYDUVMUXFUVPUXIIUYDUVJUXCUVLUXECUYDUVIUXBDGUURUWTFCNOUYDUVKUXDFGUURU
  WTKUGPQUYDUVOUXHDGUYDUVNUXGKUURUWTDCNUHPQUIUURBLZUVHUXLUVQUYAUURBUVGUGUYEUVMU
  XQUVPUXTIUYEUVJUXNUVLUXPCUYEUVIUXMDGUURBFCNOUYEUVKUXOFGUURBKUGPQUYEUVOUXSDGUY
  EUVNUXRKUURBDCNUHPQUIUVRRUVFJZUWDFGEZUWDUWDRHEZCEZDGEZIEZUWGRUJSUVRUYFLUOCUVF
  RUKULRUDSUYFUYKLUMARUVEUYKUDUVFUUSRLZUVAUYGUVDUYJIUYLUUTUWDFGUUSRDCNZPUYLUVCU
  YIDGUYLUUTUWDUVBUYHCUYMUYLUUTUWDRHUYMPQPQUVFUNUYGUYJIUPUQULUYGUWCUYJUWFIUYGDF
  GEZUWCUWDDFGDURUSZUTUYNUYNRCEZUYNRFGEZCEUWCUYNRVAVBUYPVCRVARVARVDUYNVEVEVFVCV
  FVGRRCEZVDMERVDMERUYRRVDMVHUTRVIVJVKVARCEVAVDVAVBVAVAVFVLUSVAVFVMVKVNVORUYQUY
  NCUYQRRRRDFVEVPVQVRVHVSVTWBUYNUVTUYQUWBCFUVSDGUVSFFWAUSVTZWBRUWAFGUWARWCVTUTW
  DWEVKUYIUWEDGUYIUWDRCEZDUWEUYHRUWDCUYHDRHEZRUWDDRHUYOUTWFVKWBUYTUWDDUWDDRCUYO
  UTUYOVKUWEDUWEDKJDUWDDKUYOWGWOVKVTWEUTWDWEUWHUDSZUWSUXKVUBUWSWHZUXAUWIUWTUVFJ
  ZCEZUWRVUDCEZUXJVUCUWHRWIJSZUXAVUELVUBVUGUWSVUBVUGUWHWJWKWLCUVFRUWHWMWNVUCUWI
  UWRVUDCVUBUWSWPPVUBVUFUXJLUWSVUBVUFUWRUXGFGEZUXGUXGRHEZCEZDGEZIEZCEZUWKUYNCEZ
  UWLUWTCEZFGEZCEZUWODMEZKJZDGEZIEZUXJVUBVUDVULUWRCVUBAUWTUVEVULUDUVFWQVUBUVFWR
  UUSUWTLZUVEVULLVUBVVBUVAVUHUVDVUKIVVBUUTUXGFGUUSUWTDCNZPVVBUVCVUJDGVVBUUTUXGU
  VBVUICVVCVVBUUTUXGRHVVCPQPQWSUWHWTZVUBVUHVUKVUBUXGFVUBDUWTDWQSVUBURTZVUBUWHRU
  WHXAZRWQSVUBVITZXBZXCZFXDSVUBXETZXFZVUBVUJVUBUXGVUIVVIVUBUXGRVVIVVGXGZXCZXHZV
  UBVUJDVVMVUBUXGVUIVVIVVLVUBDUWTVVEVVHVUBDVDDXIXJVUBXKTXLVUBUWTVVDXMXNVUBUXGRV
  VIVVGVUBRUXGRXOSVUBXPTZVUBDUWTDXOSVUBYATVUBUWHRUWHXQVVOXRRDXIXJVUBXSTVUBRUWHV
  VOUWHYBXTYCYDYEXNDUJSVUBYFTZYGZYHYMOVUBVUMUWNVUHCEZUWQVUKCEZIEVVAVUBUWNUWQVUH
  VUKVUBUWKUWMVUBDUWJVVEVUBFUWHVVJUWHUUAZYIZXFZVUBUWLFVUBUWHXDSZUWLUDSUWLWQSVVT
  UWHYJUWLXAYKZVVJXFZXCVUBUWPVUBUWOXDSZUWPUDSZUWPWQSVUBDUWHDXDSVUBVPTZVVTYIZUWO
  YJZUWPXAYKZXHVVKVVNVUBUWPDVWKVUBUWPVUBVWFVWGVWIVWJWNXMVVPYGVVQUUBVUBVVRVUQVVS
  VUTIVUBVVRUWNUYNUWTFGEZCEZCEVUNUWMVWLCEZCEVUQVUBVUHVWMUWNCVUBDUWTFVVEVVHVVJYL
  OVUBUWKUWMUYNVWLVWBVWEVUBDFVVEVVJXFVUBUWTFVVHVVJXFUUMVUBVWNVUPVUNCVUBVUPVWNVU
  BUWLUWTFVWDVVHVVJYLYNOYOVUBUWPVUJCEZDGEUWPUWORMEZCEZUXGCEZDGEVVSVUTVUBVWOVWRD
  GVUBUWPUXGVWPCEZCEUWPVWPUXGCEZCEVWOVWRVUBVWSVWTUWPCVUBUXGVWPVVIVUBUWORVUBDUWH
  VVEVVFXCZVVGXBZUUDOVUBVUJVWSUWPCVUBVUIVWPUXGCVUBVUIUWOUWDMEZRHEUWOUYHMEVWPVUB
  UXGVXCRHVUBDUWHRVVEVVFVVGYPZPVUBUWOUWDRVXAVUBUWDDWQUYOVVEUUEVVGUUFVUBUYHRUWOM
  VUBUYHVUARVUBUWDDRHUWDDLVUBUYOTPWFUUCOYOOOVUBUWPVWPUXGVWKVXBVVIUUGUUHPVUBUWPV
  UJDVWKVVMVWHYLVUBVWRVUSDGVUBVUSVWPRMEZKJZVWPKJZVXECEZVWRVUBVURVXEKVUBVURUWORR
  MEZMEZVXEVUBDVXIUWOMDVXILVUBYQTZOVUBUWORRVXAVVGVVGUUIZYRUHVUBVWPXDSVXFVXHLVUB
  UWORVWIRXDSVUBVETUUJVWPYSWNVUBVXGVWQVXEUXGCVUBVWFVXGVWQLVWIUWOYSWNVUBVXEVXJVU
  RUXGVXLVUBVXIDUWOMVUBDVXIVXKYNZOVUBVURVXCUXGVUBDUWDUWOMVUBVXIDDUWDVXMYQUYOUUK
  OVXDYRZYOQUULPYTQUUNVUBVUQUXFVUTUXIIVUBVUNUXCVUPUXECVUBDUWJFMEZGEDUWJUVSMEZGE
  VUNUXCVUBVXOVXPDGVUBFUVSUWJMFUVSLVUBUYSTOOVUBDUWJFVVEVVJVWAUUOVUBVXPUXBDGVUBU
  XBVXPVUBFUWHRFWQSVUBWATVVFVVGYPYNOYTVUBVUOUXDFGVUBUXDVUOVUBVWCUXDVUOLVVTUWHYS
  WNYNPQVUBVUSUXHDGVUBVURUXGKVXNUHPQYOWLYOUUPUUQ $.
  $}

  ${
    $d k m n w $.  $d k u $.  $d k n x $.  $d k x y $.  $d C x $.
    wallispi2.1 $e   |- V = ( n e. NN |-> ( ( ( ( 2 ^ ( 4 x. n ) ) x.
      ( ( ! ` n ) ^ 4 ) ) / ( ( ! ` ( 2 x. n ) ) ^ 2 ) ) /
      ( ( 2 x. n ) + 1 ) ) ) $.
    $( An alternative version of Wallis' formula for &pi; ; this second formula
       uses factorials and it is later used to proof Stirling's approximation
       formula.  (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    wallispi2 $p
                   |- V ~~> ( pi / 2 ) $=
  ( vk vm cn c2 cv cmul co c1 cdiv cmpt c4 cexp cfv wcel cc a1i oveq1d vw caddc
  cmin eqid cseq cfa ax-1cn 2cn nncn mulcld addcld cuz elnnuz biimpi cfz weq wa
  eqidd simpr oveq2d oveq12d elfznn nncnd cn0 4nn0 expcld subcld sqcld cc0 2ne0
  wne nnne0d mulne0d cr 1re 2re remulcld clt wbr 1lt2 mulid1i syl6breqr cle 0re
  nnred 2pos ltleii elfzle1 lemul2ad ltletrd gtned subne0d cz 2z expne0d divcld
  fvmptd eqeltrd adantl mulcl seqcl 2nn nnmulcld peano2nnd div32d wallispi2lem2
  id mulid2d 3eqtrd mpteq2ia wallispi2lem1 3eqtr4ri wallispi ) DADFGDHZIJZXOKUC
  JZLJXOXOKUBJLJIJMZBXQUDAFKGAHZIJZKUBJZLJXRIDFXONOJZXOXPIJZGOJZLJZMZKUEPZIJZMA
  FGNXRIJOJXRUFPNOJIJXSUFPGOJLJZXTLJZMAFXRIXQKUEPZMBAFYGYIXRFQZYGKYFXTLJZIJYLYI
  YKKXTYFKRQZYKUGSZYKXSKYKGXRGRQZYKUHSXRUIUJYNUKZYKEUAIRYEKXRYKXRKULPQXRUMUNEHZ
  KXRUOJQZYQYEPZRQYKYRYSGYQIJZNOJZYTYTKUCJZIJZGOJZLJZRYRDYQYDUUEFYERYRYEURYRDEU
  PZUQZYAUUAYCUUDLUUGXOYTNOUUGXNYQGIYRUUFUSUTZTUUGYBUUCGOUUGXOYTXPUUBIUUHUUGXOY
  TKUCUUHTVATVAYQXRVBZYRUUAUUDYRYTNYRGYQYOYRUHSZYRYQUUIVCZUJZNVDQYRVESVFYRUUCYR
  YTUUBUULYRYTKUULYMYRUGSZVGZUJZVHYRUUCGUUOYRYTUUBUULUUNYRGYQUUJUUKGVIVKYRVJSYR
  YQUUIVLVMYRYTKUULUUMYRKYTKVNQYRVOSZYRKGKIJZYTUUPYRGKGVNQYRVPSZUUPVQYRGYQUURYR
  YQUUIWEZVQYRKGUUQVRKGVRVSYRVTSGUHWAWBYRKYQGUUPUUSUURVIGWCVSYRVIGWDVPWFWGSYQKX
  RWHWIWJWKWLVMGWMQYRWNSWOWPZWQUUTWRWSYQRQUAHZRQUQYQUVAIJRQYKYQUVAWTWSXAZYKXTYK
  XSYKGXRGFQYKXBSYKXGXCXDVLZXEYKYLYKYFXTUVBYPUVCWPXHYKYFYHXTLDXRXFTXIXJAFYJYGDX
  RXKXJCXLXM $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                 Stirling's approximation formula for ` n ` factorial
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)


  ${
    $d k n $.  $d F k $.  $d G k $.  $d H k $.  $d L k $.
    stirlinglem1.1 $e |- H = ( n e. NN |-> ( ( n ^ 2 ) /
      ( n x. ( ( 2 x. n ) + 1 ) ) ) )
                              $.
    stirlinglem1.2 $e
      |- F = ( n e. NN |-> ( 1 - ( 1 / ( ( 2 x. n ) + 1 ) ) ) )
                              $.
    stirlinglem1.3 $e |- G = ( n e. NN |-> ( 1 / ( ( 2 x. n ) + 1 ) ) )
                              $.
    stirlinglem1.4 $e |- L = ( n e. NN |-> ( 1 / n ) ) $.
    $( A simple limit of fractions is computed.  (Contributed by Glauco
       Siliprandi, 30-Jun-2017.) $)
    stirlinglem1 $p
                   |- H ~~> ( 1 / 2 ) $=
  ( c1 c2 cdiv co cmul wtru cn wcel a1i cc0 cmin vk cli wbr cvv nnuz cz 1z cmpt
  cv cc ax-1cn divcnv ax-mp eqbrtri caddc nnex mptex eqeltri cfv cr crp wceq wa
  simpr oveq2d nnrp rpreccld fvmptd nnrecre eqeltrd adantl oveq1d nnre remulcld
  id 2re cle 0le1 1re 1lt2 ltleii 0re letri mp2an rpge0d mulge0d ge0p1rpd rpred
  readdcld nncn mulid2d ltmul1dd eqbrtrrd ltp1d lttrd lediv2ad 3brtr4d breqtrrd
  clt ltled recnd 2cn mulcld addcld rpne0d reccld subcld eqcomd eqtrd climsubc2
  climsqz2 subid1i syl6breq halfcld cexp sqcld adddid mul12d sqvald mulid1d wne
  oveq12d 2ne0 divcan2d eqtr4d 3eqtrd 2z rpexpcld rphalfcld rpaddcld divmuldivd
  pncand divsubdird dividd nnne0 divcld divne0d divcan5rd divcan6d adddird trud
  div12d 2m1e1 eqcomi oveq2i exp1d expm1d 3eqtr3a eqtr3d 3eqtr2d mpteq2ia eqtri
  climmulc2 reccli mulid1i breqtri ) DJKLMZJNMZUUQUBDUURUBUCOJUUQUABDJUDPUEJUFQ
  OUGRZOBJSTMJUBOSJUACBJUDPUEUUSOSUAECJUDPUEUUSESUBUCOEAPJAUIZLMZUHZSUBIJUJQZUV
  BSUBUCUKJAULUMUNRCUDQOCAPJKUUTNMZJUOMZLMZUHZUDHAPUVFUPUQURRUAUIZPQZUVHEUSZUTQ
  OUVIUVJJUVHLMZUTUVIAUVHUVAUVKPEVAEUVBVBUVIIRUVIUUTUVHVBZVCZUUTUVHJLUVIUVLVDZV
  EUVIVOZUVIUVHUVHVFZVGVHZUVHVIVJVKUVIUVHCUSZUTQOUVIUVRJKUVHNMZJUOMZLMZUTUVIAUV
  HUVFUWAPCVACUVGVBUVIHRUVMUVEUVTJLUVMUVDUVSJUOUVMUUTUVHKNUVNVEVLVEZUVOUVIUVTUV
  IUVSUVIKUVHKUTQUVIVPRZUVHVMZVNZUVIKUVHUWCUWDSKVQUCZUVISJVQUCZJKVQUCUWFVRJKVSV
  PVTWASJKWBVSVPWCWDRUVIUVHUVPWEWFWGZVGZVHZUVIUWAUWIWHVJVKZUVIUVRUVJVQUCOUVIUWA
  UVKUVRUVJVQUVIUVHUVTJUVPUWHJUTQUVIVSRZUWGUVIVRRUVIUVHUVTUWDUVIUVSJUWEUWLWIZUV
  IUVHUVSUVTUWDUWEUWMUVIJUVHNMUVHUVSWSUVIUVHUVHWJZWKUVIJKUVHUWLUWCUVPJKWSUCUVIV
  TRWLWMUVIUVSUWEWNWOWTWPUWJUVQWQVKUVISUVRVQUCOUVISUWAUVRVQUVIUWAUWIWEUWJWRVKXK
  UVCOUKRZBUDQOBAPJUVFTMZUHZUDGAPUWPUPUQURROUVIVCUVRUWKXAUVIUVHBUSZJUVRTMZVBOUV
  IUWRJUWATMZUWSUVIAUVHUWPUWTPBUJBUWQVBUVIGRUVMUVFUWAJTUWBVEZUVOUVIJUWAUVCUVIUK
  RZUVIUVTUVIUVSJUVIKUVHKUJQZUVIXBRUWNXCUXBXDUVIUVTUWHXEXFXGZVHZUVIUWAUVRJTUVIU
  VRUWAUWJXHVEXIVKXJJUKXLXMOJUWOXNDUDQODAPUUTKXOMZUUTUVENMZLMZUHZUDFAPUXHUPUQUR
  RUVIUWRUJQOUVIUWRUWTUJUXEUXDVJVKUVIUVHDUSZUUQUWRNMZVBOUVIUXJUUQUWTNMZUXKUVIAU
  VHUUQUWPNMZUXLPDUJDAPUXMUHZVBUVIDUXIUXNFAPUXHUXMUUTPQZUXHJUXFNMZKUXFUUTKLMZUO
  MZNMZLMUUQUXFUXRLMZNMUXMUXOUXFUXPUXGUXSLUXOUXPUXFUXOUXFUXOUUTUUTWJZXPZWKXHUXO
  UXGUUTUVDNMZUUTJNMZUOMKUXFNMZUUTUOMZUXSUXOUUTUVDJUYAUXOKUUTUXCUXOXBRZUYAXCUVC
  UXOUKRZXQUXOUYCUYEUYDUUTUOUXOUYCKUUTUUTNMZNMUYEUXOUUTKUUTUYAUYGUYAXRUXOUYIUXF
  KNUXOUXFUYIUXOUUTUYAXSXHVEXIUXOUUTUYAXTYBUXOUYFUYEKUXQNMZUOMUXSUXOUUTUYJUYEUO
  UXOUYJUUTUXOUUTKUYAUYGKSYAUXOYCRZYDXHVEUXOKUXFUXQUYGUYBUXOUUTUYAXNZXQYEYFYBUX
  OJKUXFUXRUYHUYGUYBUXOUXFUXQUYBUYLXDZUYKUXOUXRUXOUXFUXQUXOUUTKUUTVFZKUFQUXOYGR
  ZYHUXOUUTUYNYIYJXEZYKUXOUXTUWPUUQNUXOUXTJUXQUXRLMZTMZUWPUXOUXTUXRUXQTMZUXRLMU
  XRUXRLMZUYQTMUYRUXOUXFUYSUXRLUXOUYSUXFUXOUXFUXQUYBUYLYLXHVLUXOUXRUXQUXRUYMUYL
  UYMUYPYMUXOUYTJUYQTUXOUXRUYMUYPYNVLYFUXOUYQUVFJTUXOUXQKUUTLMZNMZUXRVUANMZLMUY
  QUVFUXOUXQUXRVUAUYLUYMUXOKUUTUYGUYAUUTYOZYPZUYPUXOKUUTUYGUYAUYKVUDYQYRUXOVUBJ
  VUCUVELUXOUUTKUYAUYGVUDUYKYSZUXOVUCUXFVUANMZVUBUOMUVEUXOUXFUXQVUAUYBUYLVUEYTU
  XOVUGUVDVUBJUOUXOVUGKUXFUUTLMZNMUVDUXOUXFKUUTUYBUYGUYAVUDUUBUXOVUHUUTKNUXOUUT
  VUHUXOUUTJXOMUUTKJTMZXOMUUTVUHJVUIUUTXOVUIJUUCUUDUUEUXOUUTUYAUUFUXOUUTKUYAVUD
  UYOUUGUUHXHVEXIVUFYBXIYBUUIVEXIVEUUJUUKUULRUVMUWPUWTUUQNUXAVEUVOUVIUUQUWTUVIJ
  UXBXNUXDXCVHUVIUWRUWTUUQNUXEVEYEVKUUMUUAUUQKXBYCUUNUUOUUP $.
  $}

  ${
    $d k n $.  $d N k $.
    stirlinglem2.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) / ( ( sqr ` ( 2 x. n ) )
      x. ( ( n / _e ) ^ n ) ) ) ) $.
    $( ` A ` maps to positive reals.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem2 $p |- ( N e. NN -> ( A ` N ) e. RR+ ) $=
      ( vk cn wcel cfv cfa c2 cmul co csqr ceu cdiv cexp crp wceq a1i oveq12d
      cn0 nnnn0 faccl nnrp 3syl 2rp rpmulcld rpsqrcld epr rpdivcld nnz rpexpcld
      wa cv fveq2 oveq2 fveq2d oveq1 id cbvmptv eqtri simpr oveq2d oveq1d simpl
      cmpt fvmptd mpdan eqeltrd ) CFGZCAHZCIHZJCKLZMHZCNOLZCPLZKLZOLZQVJVRQGZVK
      VRRVJVLVQVJCUAGVLFGVLQGCUBCUCVLUDUEVJVNVPVJVMVJJCJQGVJUFSCUDZUGUHVJVOCVJC
      NVTNQGVJUISUJCUKULUGUJZVJVSUMZECEUNZIHZJWCKLZMHZWCNOLZWCPLZKLZOLZVRFAQAEF
      WJVFZRWBABFBUNZIHZJWLKLZMHZWLNOLZWLPLZKLZOLZVFWKDBEFWSWJWLWCRZWMWDWRWIOWL
      WCIUOWTWOWFWQWHKWTWNWEMWLWCJKUPUQWTWPWGWLWCPWLWCNOURWTUSTTTUTVASWBWCCRZUM
      ZWDVLWIVQOXBWCCIWBXAVBZUQXBWFVNWHVPKXBWEVMMXBWCCJKXCVCUQXBWGVOWCCPXBWCCNO
      XCVDXCTTTVJVSVEVJVSVBVGVHWAVI $.
  $}

  ${
    $d m n $.  $d n ph $.
    stirlinglem3.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) / ( ( sqr ` ( 2 x.
                               n ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem3.2 $e |- D = ( n e. NN |-> ( A ` ( 2 x. n ) ) ) $.
    stirlinglem3.3 $e |- E = ( n e. NN |-> ( ( sqr ` ( 2 x. n ) ) x. ( (
                               n / _e ) ^ n ) ) ) $.
    stirlinglem3.4 $e |- V = ( n e. NN |-> ( ( ( ( 2 ^ ( 4 x. n ) ) x. (
         ( ! ` n ) ^ 4 ) ) / ( ( ! ` ( 2 x. n ) ) ^ 2 ) )
         / ( ( 2 x. n ) + 1 ) ) ) $.
    $( Long but simple algebraic transformations are applied to show that
       ` V ` , the Wallis formula for &pi; , can be expressed in terms of
       ` A ` , the Stirling's approximation formula for the factorial, up to a
       constant factor.  This will allow (in a later theorem) to determine the
       right constant factor to be put into the ` A ` , in order to get the
       exact Stirling's formula.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem3 $p |- V = ( n e. NN |-> ( ( ( ( A ` n ) ^ 4 ) /
      ( ( D ` n ) ^ 2 ) ) x. ( ( n ^ 2 ) / ( n x. ( ( 2 x. n ) + 1 ) ) ) ) )
                           $=
      ( cn c2 c4 cmul co cexp cdiv wcel cc a1i oveq1d vm cv cfa caddc cmpt csqr
      cfv c1 ceu wceq cn0 nnnn0 faccl nncn 3syl 2cn mulcld sqrcld ere recni cc0
      wne epos gt0ne0ii divcld expcld crp nnrp rpmulcld sqrgt0d gt0ne0d divne0d
      2rp nnne0 nnz expne0d mulne0d fvmpt2 mpdan oveq12d expdivd nn0zd divcan1d
      4nn0 3eqtrd eqcomd oveq2d 2nn0 nn0mulcld sqcld rpne0d cz 2z zmulcld fveq2
      eqtr3d oveq2 fveq2d oveq1 cbvmptv eqtri adantl 2nn nnmulcld fvmptd fveq1d
      id eqidd eqeltrd mpteq2ia mulcomd eqtrd eqnetrd divmuldivd div23d mulassd
      ax-1cn addcld cr 0re 2re nnre remulcld 1re readdcld nngt0d mulexpd sqmuld
      nnred 3eqtr4d cle wbr rprege0d resqrth syl 2t2e4 expmuld 3eqtr3d divdiv1d
      wa ltp1d divassd div12d eqcomi sq2 4cn 4pos gtneii dividi sqvald divcan4d
      lttrd nn0cnd mulid2d mul32d eqeltrrd dividd 3eqtr2d reccld mul12d mulid1d
      divdiv2d recidd 3eqtri ) ECJKLCUBZMNZONZUVEUCUGZLONZMNZKUVEMNZUCUGZKONZPN
      ZUVKUHUDNZPNZUECJUVGUVEAUGZLONZUVEDUGZLONZMNZMNZUVEBUGZKONZUVKDUGZKONZMNZ
      PNZUVOPNZUECJUVRUWDPNZUVEKONZUVEUVOMNPNZMNZUEICJUVPUWIUVEJQZUVNUWHUVOPUWN
      UVJUWBUVMUWGPUWNUVIUWAUVGMUWNUWAUVIUWNUWAUVHUVKUFUGZUVEUIPNZUVEONZMNZPNZL
      ONZUWRLONZMNUVIUXAPNZUXAMNUVIUWNUVRUWTUVTUXAMUWNUVQUWSLOUWNUWSRQUVQUWSUJU
      WNUVHUWRUWNUVEUKQUVHJQUVHRQUVEULZUVEUMUVHUNUOZUWNUWOUWQUWNUVKUWNKUVEKRQUW
      NUPSZUVEUNZUQZURZUWNUWPUVEUWNUVEUIUXFUIRQUWNUIUSUTSZUIVAVBUWNUIUSVCVDSZVE
      ZUXCVFZUQZUWNUWOUWQUXHUXLUWNUWOUWNUVKUWNKUVEKVGQUWNVMSZUVEVHVIZVJVKUWNUWP
      UVEUXKUWNUVEUIUXFUXIUVEVNZUXJVLUVEVOZVPVQZVEZCJUWSRAFVRVSZTUWNUVSUWRLOUWN
      UWRRQUVSUWRUJUXMCJUWRRDHVRVSTZVTUWNUWTUXBUXAMUWNUVHUWRLUXDUXMUXRLUKQUWNWD
      SZWATUWNUVIUXAUWNUVHLUXDUYBVFZUWNUWRLUXMUYBVFZUWNUWRLUXMUXRUWNLUYBWBZVPWC
      WEZWFWGUWNUVMUVKAUGZKONZUVKUAJKUAUBZMNZUFUGZUYIUIPNZUYIONZMNZUEZUGZKONZMN
      ZUYHUVKCJUWRUEZUGZKONZMNUWGUWNUVMUVLKUVKMNZUFUGZUVKUIPNZUVKONZMNZPNZKONZV
      UFKONZMNZUYHVUIMNUYRUWNUVMVUIPNZVUIMNUVMVUJUWNUVMVUIUWNUVLUWNUVKUKQZUVLJQ
      ZUVLRQUWNKUVEKUKQUWNWHSZUXCWIZUVKUMZUVLUNUOZWJUWNVUFUWNVUCVUEUWNVUBUWNKUV
      KUXEUXGUQURZUWNVUDUVKUWNUVKUIUXGUXIUXJVEZVUOVFZUQZWJUWNVUFKVVAUWNVUCVUEVU
      RVUTUWNVUCUWNVUBUWNKUVKUXNUXOVIZVJVKZUWNVUDUVKVUSUWNUVKUIUXGUXIUWNKUVEUXE
      UXFUWNKUXNWKZUXPVQZUXJVLUWNKUVEKWLQUWNWMSZUXQWNVPZVQZVVFVPWCUWNVUKVUHVUIM
      UWNVUHVUKUWNUVLVUFKVUQVVAVVHVUNWAWFTWPUWNVUHUYHVUIMUWNUYHVUHUWNUYGVUGKOUW
      NUAUVKUYIUCUGZUYNPNZVUGJARAUAJVVJUEZUJUWNACJUWSUEVVKFCUAJUWSVVJUVEUYIUJZU
      VHVVIUWRUYNPUVEUYIUCWOVVLUWOUYKUWQUYMMVVLUVKUYJUFUVEUYIKMWQWRVVLUWPUYLUVE
      UYIOUVEUYIUIPWSVVLXGVTVTZVTWTXASUYIUVKUJZVVJVUGUJUWNVVNVVIUVLUYNVUFPUYIUV
      KUCWOVVNUYKVUCUYMVUEMVVNUYJVUBUFUYIUVKKMWQWRVVNUYLVUDUYIUVKOUYIUVKUIPWSVV
      NXGVTVTZVTXBUWNKUVEKJQUWNXCSUWNXGXDZUWNUVLVUFVUQVVAVVHVEZXEZTWFTUWNVUIUYQ
      UYHMUWNUYQVUIUWNUYPVUFKOUWNUAUVKUYNVUFJUYORUWNUYOXHVVNUYNVUFUJUWNVVOXBZVV
      PVVAXETWFWGWEUWNUYQVUAUYHMUWNUYPUYTKOUWNUYTUYPUWNUVKUYSUYOUYSUYOUJUWNCUAJ
      UWRUYNVVMWTSZXFWFTWGUWNUYHUWDVUAUWFMUWNUYGUWCKOUWNUWCUYGUWNUYGRQUWCUYGUJU
      WNUYGVUGRVVRVVQXIZCJUYGRBGVRVSZWFTUWNUYTUWEKOUWNUWEUYTUWNUVKDUYSDUYSUJUWN
      HSZXFWFTVTWEVTTXJCJUWIUWMUWNUWIUWAUVGMNZUWGPNZUVOPNUWAUWDPNZUVGUWFPNZMNZU
      VOPNZUWMUWNUWHVWEUVOPUWNUWBVWDUWGPUWNUVGUWAUWNKUVFUXEUWNLUVEUYBUXCWIZVFZU
      WNUWAUVIRUYFUYCXIZXKTTUWNVWEVWHUVOPUWNVWHVWEUWNUWAUWDUVGUWFVWLUWNUWCUWNUW
      CUYGRVWBVWAXIZWJZVWKUWNUWEUWNUWEVUFRUWNUAUVKUYNVUFJDRUWNDUYSUYOVWCVVTXLVV
      SVVPVVAXEZVVAXIZWJZUWNUWCKVWMUWNUWCUYGVAVWBUWNUYGVUGVAVVRUWNUVLVUFVUQVVAU
      WNVULVUMUVLVAVBVUOVUPUVLVNUOVVHVLXMXMVVFVPZUWNUWEKVWPUWNUWEVUFVAVWOVVHXMV
      VFVPZXNWFTUWNVWIUWJUVTMNZVWGMNZUVOPNUWJUVTVWGMNZMNZUVOPNZUWMUWNVWHVXAUVOP
      UWNVWFVWTVWGMUWNUVRUVTUWDUWNUVQLUWNUVQUWSRUXTUXSXIUYBVFZUWNUVTUXARUYAUYDX
      IZVWNVWRXOTTUWNVXAVXCUVOPUWNUWJUVTVWGUWNUVRUWDVXEVWNVWRVEZVXFUWNUVGUWFVWK
      VWQVWSVEZXPTUWNVXDUWJVXBUVOPNZMNUWMUWNUWJVXBUVOVXGUWNUVTVWGVXFVXHUQUWNUVK
      UHUXGUHRQUWNXQSXRZUWNUVOUWNVAUVKUVOVAXSQUWNXTSUWNUVKVVPYIZUWNUVKUHUWNKUVE
      KXSQUWNYASUVEYBYCUHXSQUWNYDSYEUWNUVKVVPYFUWNUVKVXKUUAUULVKZUUBUWNVXIUWLUW
      JMUWNVXIUWKUVEPNZUVOPNUWLUWNVXBVXMUVOPUWNVXBUVGUVTUWFPNZMNUVGUWOLONZVUCKO
      NZPNZUWQLONZVUEKONZPNZMNZMNZVXMUWNUVTUVGUWFVXFVWKVWQVWSUUCUWNVXNVYAUVGMUW
      NUXAVUIPNVXOVXRMNZVXPVXSMNZPNVXNVYAUWNUXAVYCVUIVYDPUWNUWOUWQLUXHUXLUYBYGU
      WNVUCVUEVURVUTYHVTUWNUVTUXAUWFVUIPUYAUWNUWEVUFKOVWOTVTUWNVXOVXPVXRVXSUWNU
      WOLUXHUYBVFUWNVUCVURWJUWNUWQLUXLUYBVFZUWNVUEVUTWJUWNVUCKVURVVCVVFVPUWNVUE
      KVUTVVGVVFVPXNYJWGUWNVYBUVGUVEUHUVGPNZMNZMNUVEUVGVYFMNZMNZVXMUWNVYAVYGUVG
      MUWNVXQUVEVXTVYFMUWNVXQVXOVUBPNUVKKONZUVFPNZUVEUWNVXPVUBVXOPUWNVUBXSQVAVU
      BYKYLYTVXPVUBUJUWNVUBVVBYMVUBYNYOWGUWNVXOVYJVUBUVFPUWNVXOUWOKKMNZONUWOKON
      ZKONVYJUWNLVYLUWOOLVYLUJUWNVYLLYPUUDSWGUWNUWOKKUXHVUNVUNYQUWNVYMUVKKOUWNU
      VKXSQVAUVKYKYLYTVYMUVKUJUWNUVKUXOYMUVKYNYOTWEUWNVYLUVEMNZVUBUVFUWNKKUVEUX
      EUXEUXFXPUWNVYLLUVEMVYLLUJUWNYPSTZWPVTUWNVYKLUWKMNZUVFPNZUVEUWNVYJVYPUVFP
      UWNVYJKKONZUWKMNVYPUWNKUVEUXEUXFYHUWNVYRLUWKMVYRLUJUWNUUESTXLTUWNLLPNZVXM
      MNUHUVEMNVYQUVEUWNVYSUHVXMUVEMVYSUHUJUWNLUUFVALXTUUGUUHZUUISUWNVXMUVEUVEM
      NZUVEPNUVEUWNUWKWUAUVEPUWNUVEUXFUUJTUWNUVEUVEUXFUXFUXPUUKXLZVTUWNLLUWKUVE
      UWNLUYBUUMZWUCUWNUVEUXFWJZUXFLVAVBUWNVYTSUXPXNUWNUVEUXFUUNYRXLWEUWNVXTUVE
      UVFONZUIUVFONZPNZUVKUVFONZWUFPNZPNWUGWUFMNZWUHPNZVYFUWNVXRWUGVXSWUIPUWNUW
      PUVELMNZONUWPUVFONVXRWUGUWNWULUVFUWPOUWNUVELUXFWUCXKWGUWNUWPUVELUXKUYBUXC
      YQUWNUVEUIUVFUXFUXIUXJVWJWAYRZUWNVUDUVKKMNZONVUDUVFONVXSWUIUWNWUNUVFVUDOU
      WNWUNVYNUVFUWNKUVEKUXEUXFUXEUUOVYOXLWGUWNVUDUVKKVUSVUNVUOYQUWNUVKUIUVFUXG
      UXIUXJVWJWAYRVTUWNWUGWUHWUFUWNVXRWUGRWUMVYEUUPUWNUVKUVFUXGVWJVFUWNUIUVFUX
      IVWJVFZUWNUVKUVFUXGVVEUWNLUVEUYEUXQWNZVPUWNUIUVFUXIUXJWUPVPZUVBUWNWUKWUEW
      UHPNWUEUVGWUEMNZPNZVYFUWNWUJWUEWUHPUWNWUEWUFUWNUVEUVFUXFVWJVFZWUOWUQWCTUW
      NWUHWURWUEPUWNKUVEUVFUXEUXFVWJYGWGUWNWUSWUEWUEUVGMNZPNWUEWUEPNZUVGPNVYFUW
      NWURWVAWUEPUWNUVGWUEVWKWUTXKWGUWNWUEWUEUVGWUTWUTVWKUWNUVEUVFUXFUXPWUPVPZU
      WNKUVFUXEVVDWUPVPZYSUWNWVBUHUVGPUWNWUEWUTWVCUUQTUURWEWEVTWGUWNUVGUVEVYFVW
      KUXFUWNUVGVWKWVDUUSUUTUWNUVEUHMNUVEVYIVXMUWNUVEUXFUVAUWNVYHUHUVEMUWNUVGVW
      KWVDUVCWGWUBYJWEWETUWNUWKUVEUVOWUDUXFVXJUXPVXLYSXLWGXLWEWEXJUVD $.
  $}

  ${
    $d k n $.  $d A k $.  $d N k $.  $d N n $.
    stirlinglem4.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) /
      ( ( sqr ` ( 2 x. n ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem4.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    stirlinglem4.3 $e |- J = ( n e. NN |-> ( ( ( ( 1 + ( 2 x. n ) ) / 2 ) x.
      ( log ` ( ( n + 1 ) / n ) ) ) - 1 ) ) $.
    $( Algebraic manipulation of ` ( ( B ` n ) - ( B ` ( n + 1 ) ) ) ` .  It
       will be used in other theorems to show that ` B ` is decreasing.
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    stirlinglem4 $p |- ( N e. NN -> ( ( B ` N ) -
      ( B ` ( N + 1 ) ) ) = ( J ` N ) )
                                  $=
      ( cn wcel c1 co cdiv cfv cmul ceu clog c2 oveq12d oveq1d caddc csqr nnnn0
      vk cexp cmin nn0ge0d ge0p1rpd rpdivcld rpsqrcld nnz rpexpcld rpmulcld crp
      nnre nnrp epr a1i relogdivd relogmuld wceq logsqr syl cz relogexp syl2anc
      eqtrd peano2nn nncnd nnne0 divcld nnne0d divne0d logcld cc 2cn 2rp rpne0d
      nncn divrec2d ax-1cn halfcld adddird mulcomd eqtr3d oveq2d mulcld divdird
      divcan4d eqtr4d 3eqtrd loge cr stirlinglem2 relogcld nfcv cfa cmpt nfmpt1
      cv nfcxfr nffv fveq2 fveq2d fvmptf mpdan cbvmpt eqtri wa simpr fvmptd cn0
      faccl 3syl simpl rpcnd adantr sqrcld ere recni cc0 nnnn0d expne0d mulne0d
      expcld divassd divdiv32d divdiv1d eqcomd dividd div23d sqrmuld divmuldivd
      wne 3eqtr2d mulid2d expdivd expp1d div32d 3eqtr4d epos gtneii oveq2 oveq1
      0re nnzd id peano2zd facp1 recdivd rpred rpge0d sqrdivd divdivdivd reccld
      nnred addcld subcld ) EIJZEKUALZEMLZUBNZUVAEUELZOLZPMLZQNZKREOLZUALZRMLZU
      VAQNZOLZKUFLZEBNZUUTBNZUFLZEDNZUUSUVFUVDQNZPQNZUFLUVLUUSUVDPUUSUVBUVCUUSU
      VAUUSUUTEUUSEEUOZUUSEEUCZUGZUHZEUPZUIZUJZUUSUVAEUWDEUKZULZUMPUNJUUSUQURZU
      SUUSUVQUVKUVRKUFUUSUVQUVJRMLZEUVJOLZUALZKRMLZUVJOLZUWJUALZUVKUUSUVQUVBQNZ
      UVCQNZUALUWKUUSUVBUVCUWEUWGUTUUSUWOUWIUWPUWJUAUUSUVAUNJZUWOUWIVAUWDUVAVBV
      CUUSUWQEVDJUWPUWJVAUWDUWFUVAEVEVFSVGUUSUWIUWMUWJUAUUSUVJRUUSUVAUUSUUTEUUS
      UUTEVHZVIZEVSZEVJZVKZUUSUUTEUWSUWTUUSUUTUWRVLZUXAVMVNZRVOJZUUSVPURZUUSRRU
      NJUUSVQURZVRZVTTUUSUWLEUALZUVJOLUWNUVKUUSUWLEUVJUUSKKVOJUUSWAURZWBUWTUXDW
      CUUSUXIUVIUVJOUUSUXIUWLUVGRMLZUALUVIUUSEUXKUWLUAUUSEROLZRMLEUXKUUSERUWTUX
      FUXHWIUUSUXLUVGRMUUSERUWTUXFWDTWEWFUUSKUVGRUXJUUSREUXFUWTWGZUXFUXHWHWJTWE
      WKUVRKVAUUSWLURSVGUUSUVOEANZQNZUUTANZQNZUFLUXNUXPMLZQNUVFUUSUVMUXOUVNUXQU
      FUUSUXOWMJUVMUXOVAUUSUXNACEFWNZWOCECWTZANZQNZUXOIBWMCEWPZCUXNQCQWPZCEACAC
      IUXTWQNZRUXTOLZUBNZUXTPMLZUXTUELZOLZMLZWRZFCIUYKWSXAZUYCXBXBUXTEVAZUYAUXN
      QUXTEAXCXDGXEXFUUSUDUUTUDWTZANZQNZUXQIBWMBUDIUYQWRZVAUUSBCIUYBWRUYRGCUDIU
      YBUYQUDUYBWPCUYPQUYDCUYOAUYMCUYOWPXBXBUXTUYOVAZUYAUYPQUXTUYOAXCXDXGXHURUU
      SUYOUUTVAZXIZUYPUXPQVUAUYOUUTAUUSUYTXJZXDXDUWRUUSUXPUUSUUTIJUXPUNJUWRACUU
      TFWNVCZWOXKSUUSUXNUXPUXSVUCUSUUSUXRUVEQUUSUXREWQNZUVGUBNZEPMLZEUELZOLZMLZ
      UUTWQNZRUUTOLZUBNZUUTPMLZUUTUELZOLZMLZMLZUVBUUTMLZUUTUUTUELZEEUELZMLZOLZP
      MLZUVEUUSUXNVUIUXPVUPMUUSVUIUNJZUXNVUIVAUUSVUDVUHUUSEXLJZVUDIJVUDUNJUVTEX
      MVUDUPXNZUUSVUEVUGUUSUVGUUSREUXGUWCUMUJZUUSVUFEUUSEPUWCUWHUIUWFULZUMZUIUU
      SVVDXIZCEUYKVUIIAVOAUYLVAVVJFURVVJUYNXIZUYEVUDUYJVUHMVVKUXTEWQVVJUYNXJZXD
      VVKUYGVUEUYIVUGOVVKUYFUVGUBVVKUXTEROVVLWFXDVVKUYHVUFUXTEUEVVKUXTEPMVVLTVV
      LSSSUUSVVDXOZVVJVUDVUHUUSVUDVOJVVDUUSVUDVVFXPZXQVVJVUEVUGVVJUVGVVJREUXEVV
      JVPURVVJEVVMVIZWGXRZVVJVUFEVVJEPVVOPVOJVVJPXSXTURZPYAYNVVJYAPUUEUUAUUBURZ
      VKZVVJEVVMYBYEZWGVVJVUEVUGVVPVVTUUSVUEYAYNVVDUUSVUEVVGVRZXQVVJVUFEVVSVVJE
      PVVOVVQVVJEVVMVLVVRVMVVJEVVMUUFYCYDVKXKXFUUSUDUUTUYOWQNZRUYOOLZUBNZUYOPML
      ZUYOUELZOLZMLZVUPIAUNAUDIVWHWRZVAUUSAUYLVWIFCUDIUYKVWHUDUYKWPCVWHWPUYSUYE
      VWBUYJVWGMUXTUYOWQXCUYSUYGVWDUYIVWFOUYSUYFVWCUBUXTUYOROUUCXDUYSUYHVWEUXTU
      YOUEUXTUYOPMUUDUYSUUGSSSXGXHURVUAVWBVUJVWGVUOMVUAUYOUUTWQVUBXDVUAVWDVULVW
      FVUNOVUAVWCVUKUBVUAUYOUUTROVUBWFXDVUAVWEVUMUYOUUTUEVUAUYOUUTPMVUBTVUBSSSU
      WRUUSVUJVUOUUSUUTXLJVUJIJVUJUNJUUSUUTUWRYBZUUTXMVUJUPXNUUSVULVUNUUSVUKUUS
      RUUTUXGUWBUMUJZUUSVUMUUTUUSUUTPUWBUWHUIUUSEUWFUUHZULZUMZUIXKSUUSVUQVUIVUD
      UUTVUOMLZOLZMLVUDVWPMLZVUHMLZVVCUUSVUPVWPVUIMUUSVUPVUDUUTOLZVUOMLVWPUUSVU
      JVWSVUOMUUSVVEVUJVWSVAUVTEUUIVCTUUSVUDUUTVUOVVNUWSUUSVUOVWNXPZUUSVUOVWNVR
      ZYFVGWFUUSVUDVUHVWPVVNUUSVUHVVIXPUUSVUDVWOVVNUUSUUTVUOUWSVWTVXAVKZWGUUSVU
      HVVIVRUUSVUDVWOVVNVXBUUSVUDVVFVRZUUSUUTVUOUWSVWTUXCVXAVMZYDYGUUSVWRVUDVUD
      MLZVWOMLZVUHMLKVWOMLZVUHMLZVVCUUSVWQVXFVUHMUUSVXFVWQUUSVUDVUDVWOVVNVVNVXB
      VXCVXDYHYITUUSVXFVXGVUHMUUSVXEKVWOMUUSVUDVVNVXCYJTTUUSVXHVUOUUTMLZVUHMLZU
      VBVUNOLZUUTMLZVUGMLZVVCUUSVXGVXIVUHMUUSUUTVUOUWSVWTUXCVXAUUJTUUSVXIVUEMLZ
      VUGMLVXJVXMUUSVXIVUEVUGUUSVUOUUTVWTUWSUXCVKUUSVUEVVGXPZUUSVUGVVHXPZVWAUUS
      VUGVVHVRZYHUUSVXNVXLVUGMUUSVXNVUOVUEMLZUUTMLVXLUUSVUOUUTVUEVWTUWSVXOUXCVW
      AYGUUSVXRVXKUUTMUUSVXRVULVUEMLZVUNOLKUVBOLZVUNOLVXKUUSVULVUNVUEUUSVULVWKX
      PUUSVUNVWMXPZVXOVWAYKUUSVXSVXTVUNOUUSVXSRUBNZUUTUBNZOLZVYBEUBNZOLZMLVYBVY
      BMLZVYCVYEMLZOLVXTUUSVULVYDVUEVYFMUUSRUUTUUSRUXGUUKZUUSRUXGUULZUUSUUTUWRU
      UPZUUSUUTVWJUGZYLUUSREVYIVYJUVSUWAYLSUUSVYBVYBVYCVYEUUSRUXFXRZVYMUUSUUTUW
      SXRUUSEUWTXRUUSVYBUUSRUXGUJVRZUUSVYEUUSEUWCUJVRYMUUSVYGKVYHUVBOUUSVYBVYMV
      YNYJUUSUVBVYHUUSUUTEVYKVYLUWCUUMYISYOTUUSVXTUVBVUNOUUSUVBUUSUVAUXBXRZYPTW
      KTVGTWEUUSVXMVXKVUGMLZUUTMLUVBKPMLZVVAOLZOLZUUTMLZVVCUUSVXKUUTVUGUUSUVBVU
      NVYOVYAWGUWSVXPUXCVXQYGUUSVYPVYSUUTMUUSVYPUVBVUNVUGMLZOLUVBVUSPUUTUELZMLZ
      VUTPEUELZMLZMLZOLVYSUUSUVBVUNVUGVYOVYAVXPVXQYFUUSWUAWUFUVBOUUSVUNWUCVUGWU
      EMUUSUUTPUUTUWSUUSPUWHXPZUUSPUWHVRZVWJYQUUSEPEUWTWUGWUHUVTYQSWFUUSWUFVYRU
      VBOUUSWUFVUSWUDOLZWUBVUTOLZMLWUDVUSOLZWUJMLZVYRUUSVUSWUBVUTWUDUUSUUTUUTUW
      SVWJYEZUUSPUUTWUGVWJYEZUUSEEUWTUVTYEZUUSPEWUGUVTYEZUUSPUUTWUGWUHVWLYCZUUS
      PEWUGWUHUWFYCZUUSEEUWTUXAUWFYCZUUNUUSWUIWUKWUJMUUSVUSWUDWUMWUPWDTUUSWUDWU
      BMLZVVAOLWULVYRUUSWUDWUBVUSVUTWUPWUNWUMWUOWUQWUSYMUUSWUTVYQVVAOUUSWUTWUDW
      UDPOLZMLWUDWUDMLZPMLVYQUUSWUBWVAWUDMUUSPEWUGUVTYRWFUUSWUDWUDPWUPWUPWUGWUR
      WUHYHUUSWVBKPMUUSWUDWUPWURYJTYOTWEWKWFWKTUUSVURVYROLVURVVAPMLZOLVYTVVCUUS
      VYRWVCVUROUUSVYRKWVCOLWVCUUSKPVVAUXJWUGUUSVUSVUTWUMWUOWUSVKZWUHYSUUSWVCUU
      SVVAPWVDWUGWUHVKYPVGWFUUSUVBVYRUUTVYOUUSVYQVVAUUSPWUGWUHUUOWVDWGUWSUXCYKU
      USVURVVAPUUSUVBUUTVYOUWSUXCVKWVDWUGWUHYFYTWKWKWKWKUUSVVBUVDPMUUSVVBUVBVVA
      UUTMLZOLUVDUUSUVBUUTVVAVYOUWSWVDUXCYSUUSWVEUVCUVBOUUSVUSUUTMLZVUTMLUUTEUE
      LZVUTMLWVEUVCUUSWVFWVGVUTMUUSWVFWVGUUTOLZUUTMLWVGUUSVUSWVHUUTMUUSUUTEUWSU
      VTYRTUUSWVGUUTUUSUUTEUWSUVTYEUWSUXCWIVGTUUSVUSVUTUUTWUMWUOUWSWUSUXCYGUUSU
      UTEEUWSUWTUXAUVTYQYTWFVGTWKXDYOUUSUVLVOJZUVPUVLVAUUSUVKKUUSUVIUVJUUSUVHUU
      SKUVGUXJUXMUUQWBUXDWGUXJUURUUSWVIXIZCEKUYFUALZRMLZUXTKUALZUXTMLZQNZOLZKUF
      LZUVLIDVODCIWVQWRVAWVJHURWVJUYNXIZWVPUVKKUFWVRWVLUVIWVOUVJOWVRWVKUVHRMWVR
      UYFUVGKUAWVRUXTEROWVJUYNXJZWFWFTWVRWVNUVAQWVRWVMUUTUXTEMWVRUXTEKUAWVSTWVS
      SXDSTUUSWVIXOUUSWVIXJXKXFYT $.
  $}

  ${
    $d i k n ph $.  $d j k n ph $.  $d D i $.  $d D k $.  $d D n $.  $d E i $.
    $d E k $.  $d E n $.  $d F k $.  $d F n $.  $d G k $.  $d G n $.  $d H k $.
    $d H n $.  $d T j $.  $d T k $.  $d T n $.
    stirlinglem5.1 $e |- D = ( j e. NN |-> ( ( -u 1 ^ ( j - 1
                                          ) ) x. ( ( T ^ j ) / j ) ) ) $.
    stirlinglem5.2 $e |- E = ( j e. NN |-> ( ( T ^ j ) / j ) )
$.
    stirlinglem5.3 $e |- F = ( j e. NN |-> ( ( ( -u 1 ^ ( j -
       1 ) ) x. ( ( T ^ j ) / j ) ) + ( ( T ^ j ) / j ) ) ) $.
    stirlinglem5.4 $e |- H = ( j e. NN0 |-> ( 2 x. ( ( 1 / ( (
       2 x. j ) + 1 ) ) x. ( T ^ ( ( 2 x. j ) + 1 ) ) ) ) ) $.
    stirlinglem5.5 $e |- G = ( j e. NN0 |-> ( ( 2 x. j ) + 1 ) ) $.
    stirlinglem5.6 $e |- ( ph -> T e. RR+ ) $.
    stirlinglem5.7 $e |- ( ph -> ( abs ` T ) < 1 ) $.
    $( If ` T ` is between ` 0 ` and ` 1 ` , then a series (without alternating
       negative and positive terms) is given that converges to log
       (1+T)/(1-T) .  (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    stirlinglem5 $p
       |- ( ph -> seq 0 ( + , H ) ~~> ( log ` ( ( 1 + T ) / ( 1 - T ) ) ) )
                                      $=
  ( c1 co wcel a1i c2 vk vn vi caddc cc0 cseq clog cfv cmin cdiv cli wbr cvv cn
  cneg nnuz cz 1z cv cexp cmul cmpt wceq wa cc ax-1cn negcld cn0 nnm1nn0 adantl
  expcld nncn rpred recnd adantr nnnn0 wne eqcomd oveq1d eqtrd seqeq3d cabs clt
  oveq2d addcld eqid syl2anc fveq2d eqbrtrd wb cr 1re mpbird syl simpr oveq2 id
  weq oveq12d nnnn0d nncnd nnne0d divcld mulcld fvmptd eqeltrd seqcl crp logcld
  ad2antrr mpbid gtned breqtrd 2nn0 nn0mulcld nn0p1nn 2re remulcld readdcld 2rp
  ltadd1dd 2cn cdivides wn wrex 1nn0 elrnmpt nsyl wral ralnex neneqad cle simpl
  0re wi ltnled syl21anc breqtrrd 3eqtrd nn0addcld nnne0 pncan2d mpteq2dva ccom
  div32d eqtr3d cbl cnmetdval 1m1e0 subsub4d df-neg eqcomi 3eqtr3d absnegd cxmt
  cxr cnxmet rexrd elbl2 syl22anc logtayl2 seqex logtayl cuz syl6eleq cfz oveq1
  elfznn simpll seradd climadd 1rp rpaddcld rpne0d subcld absltd simprd subne0d
  addcl negsubd nn0uz 0z fmpti nn0re ltp1d ltmul2dd nn0cn peano2nn0 3brtr4d crn
  wf cdif eldifi fvmptg eldifn 0nn0 num0h eqeq2d rspcev mp2an ax-mp mpbir eleq1
  wo nn1m1nn ord mpd nfcv nfmpt1 nfcxfr nfrn nfdif nfcri sylibr r19.21bi necomd
  mtbid adantlr simplr zred mulcomd elnn0z sylnib nan anabss1 rpregt0d mulltgt0
  mpbi addid2d nnge1 adantll mtand pm2.61dan neneqd ralrimi nnzd odd2np1 mtbird
  ex sylib notnotrd npcand oddp1even oexpneg syl3anc 1exp negeqd mulm1d addcomd
  nn0zd negidd nn0ge0i nn0ge0d mulge0d 0lt1 addgegt0d m1expeven mulid2d 2timesd
  pncand divrec2d 3eqtr2d eqtr2d reccld 3eqtr4d isercoll2 resubcld subidd elrpd
  ltsub1dd relogdivd ) AUDHUEUFZPCUDQZUGUHZPCUIQZUGUHZUIQZVVMVVOUJQUGUHUKAVVLVV
  QUKULUDFPUFZVVQUKULAVVRVVNVVPUOZUDQVVQUKAVVNVVSUAUDBPUFZUDEPUFZVVRPUMUNUPPUQR
  AURSZAVVTUDDUNPUOZDUSZPUIQZUTQZVWDUJQZVVMPUIQZVWDUTQZVAQZVBZPUFZVVNUKABVWKUDP
  ABDUNVWFCVWDUTQZVWDUJQZVAQZVBZVWKBVWPVCZAISADUNVWOVWJAVWDUNRZVDZVWGVWMVAQVWOV
  WJVWSVWFVWDVWMVWSVWCVWEVWSPPVERZVWSVFSZVGVWRVWEVHRAVWDVIVJVKVWRVWDVERAVWDVLVJ
  VWSCVWDACVERZVWRACACNVMZVNZVOZVWRVWDVHRZAVWDVPVJVKVWRVWDUEVQAVWDUUAVJUUEVWSVW
  MVWIVWGVAVWSCVWHVWDUTVWSVWHCVWSPCVXAVXEUUBVRVSWDUUFUUCVTWAAVVMPPWBUIUUDZUUGUH
  QZRZVWLVVNUKULAVXIPVVMVXGQZPWCULZAVXJPVVMUIQZWBUHZPWCAVWTVVMVERZVXJVXMVCVWTAV
  FSZAPCVXOVXDWEZPVVMVXGVXGWFUUHWGAVXMCUOZWBUHZPWCAVXLVXQWBAPPUIQZCUIQUECUIQZVX
  LVXQAVXSUECUIVXSUEVCAUUISVSAPPCVXOVXOVXDUUJVXTVXQVCAVXQVXTCUUKUULSUUMWHAVXRCW
  BUHZPWCACVXDUUNOWIWIWIAVXGVEUUOUHRZPUUPRVWTVXNVXIVXKWJVYBAUUQSAPPWKRZAWLSZUUR
  VXOVXPVVMVXGPPVEUUSUUTWMVVMVXHDVXHWFUVAWNWIVVRUMRAUDFPUVBSAVWAUDDUNVWNVBZPUFZ
  VVSUKAEVYEUDPEVYEVCZAJSWAAVXBVYAPWCULZVYFVVSUKULVXDOCDUVCWGWIAUAUSZUNRZVDZUBU
  CUDVEBPVYIVYKVYIUNPUVDUHAVYJWOUPUVEZVYKUBUSZPVYIUVFQRZVDZVYMBUHZVWCVYMPUIQZUT
  QZCVYMUTQZVYMUJQZVAQZVEVYODVYMVWOWUAUNBVEVWQVYOISDUBWRZVWOWUAVCZVYOWUBVWFVYRV
  WNVYTVAWUBVWEVYQVWCUTVWDVYMPUIUVGWDWUBVWMVYSVWDVYMUJVWDVYMCUTWPWUBWQWSZWSZVJV
  YNVYMUNRZVYKVYMVYIUVHVJZVYOVYRVYTVYOWUFVYRVERZWUGWUFVWCVYQWUFPVWTWUFVFSVGVYMV
  IZVKZWNVYOVYSVYMVYOCVYMAVXBVYJVYNVXDXJVYOVYMWUGWTVKVYOVYMWUGXAVYOVYMWUGXBXCZX
  DZXEWULXFZVYMVERUCUSZVERVDVYMWUNUDQVERVYKVYMWUNUVSVJZXGVYKUBUCUDVEEPVYIVYLVYO
  VYMEUHZVYTVEVYODVYMVWNVYTUNEVEVYGVYOJSWUBVWNVYTVCZVYOWUDVJWUGWUKXEWUKXFZWUOXG
  VYKUBBEFPVYIVYLWUMWURVYOAWUFVYMFUHZVYPWUPUDQZVCAVYJVYNUVIWUGAWUFVDZWUSWUAVYTU
  DQZWUTWVADVYMVWOVWNUDQZWVBUNFVEFDUNWVCVBVCZWVAKSWUBWVCWVBVCWVAWUBVWOWUAVWNVYT
  UDWUEWUDWSZVJAWUFWOZWVAWUAVYTWVAVYRVYTWUFWUHAWUJVJWVAVYSVYMWVACVYMAVXBWUFVXDV
  OWVAVYMWVFWTVKWVAVYMWVFXAWVAVYMWVFXBXCZXDZWVGWEZXEZWVAWUAVYPVYTWUPUDWVAVYPWUA
  WVADVYMVWOWUAUNBVEVWQWVAISWUBWUCWVAWUEVJWVFWVHXEVRWVAWUPVYTWVADVYMVWNVYTUNEVE
  VYGWVAJSWUBWUQWVAWUDVJWVFWVGXEVRWSVTWGUVJUVKAVVNVVPAVVMVXPAVVMAPCPXHRAUVLSNUV
  MZUVNXIAVVOAPCVXOVXDUVOAPCVXOVXDACPVXCAVWCCWCULZCPWCULZAVYHWVLWVMVDOACPVXCVYD
  UVPXKUVQZXLUVRXIUVTXMAVVQUAUBFGHUEPUNVHUWAUPUEUQRAUWBSVWBVHUNGUWKADVHUNTVWDVA
  QZPUDQZGMVXFWVOVHRWVPUNRZVXFTVWDTVHRZVXFXNSVXFWQXOWVOXPWNUWCSVYIVHRZVYIGUHZVY
  IPUDQZGUHZWCULAWVSTVYIVAQZPUDQZTWWAVAQZPUDQZWVTWWBWCWVSWWCWWEPWVSTVYITWKRZWVS
  XQSZVYIUWDZXRWVSTWWAWWHWVSVYIPWWIVYCWVSWLSZXSZXRWWJWVSVYIWWATWWIWWKTXHRZWVSXT
  SWVSVYIWWIUWEUWFYAWVSDVYIWVPWWDVHGVEGDVHWVPVBZVCWVSMSZWVSDUAWRZVDZWVOWWCPUDWW
  PVWDVYITVAWVSWWOWOWDVSZWVSWQZWVSWWCPWVSTVYITVERZWVSYBSZVYIUWGZXDZVWTWVSVFSZWE
  XEWVSDWWAWVPWWFVHGVEWWNWVSVWDWWAVCZVDZWVOWWEPUDWXEVWDWWATVAWVSWXDWOWDVSVYIUWH
  WVSWWEPWVSTWWAWWTWVSVYIPWXAWXCWEXDWXCWEXEUWIVJAVYMUNGUWJZUWLZRZVDZWUSWVBVWCVY
  TVAQZVYTUDQZUEWXIWUFWVBVERWUSWVBVCWXHWUFAVYMUNWXFUWMZVJZWXIWUAVYTWXIVYRVYTWXH
  WUHAWXHVWCVYQWXHPVWTWXHVFSZVGWXHWUFVYQVHRWXLWUIWNZVKVJWXIVYSVYMWXICVYMAVXBWXH
  VXDVOWXIVYMWXMWTVKWXIVYMWXMXAWXIVYMWXMXBXCZXDWXPWEDVYMWVCWVBUNVEFWVEKUWNWGWXI
  WUAWXJVYTUDWXIVYRVWCVYTVAWXHVYRVWCVCAWXHVYRPVYQUTQZUOZVWCWXHVWTVYQUNRZTVYQYCU
  LYDZVYRWXRVCWXNWXHVYMPVCZYDWXSWXHVYMWXFRZWYAVYMUNWXFUWOZWYAWYBPWXFRZWYDWYAWYD
  PWVPVCZDVHYEZUEVHRPTUEVAQZPUDQZVCZWYFUWPPTXNYFUWQWYEWYIDUEVHVWDUEVCZWVPWYHPWY
  JWVOWYGPUDVWDUETVAWPVSUWRUWSUWTVWTWYDWYFWJVFDVHWVPPGVEMYGUXAUXBSVYMPWXFUXCWMY
  HWXHWYAWXSWXHWUFWYAWXSUXDWXLVYMUXEWNUXFUXGWXHWXTTVYQPUDQZYCULZWXHTVYMWYKYCWXH
  TVYMYCULZWXHWYMYDZWVPVYMVCZDUQYEZWXHWYOYDZDUQYIWYPYDWXHWYQDUQDUBWXGDUNWXFDUNU
  XHDGDGWWMMDVHWVPUXIUXJUXKUXLUXMWXHVWDUQRZWYQWXHWYRVDZWVPVYMWYSVXFWVPVYMVQZWXH
  VXFWYTWYRWXHVXFVDZVYMWVPXUAVYMWVPWXHVYMWVPVCZYDZDVHWXHXUBDVHYEZYDXUCDVHYIWXHW
  YBXUDWYCDVHWVPVYMGWXGMYGUXQXUBDVHYJUXNUXOYKUXPUXRWYSVXFYDZVDWYRXUEWUFWYTWXHWY
  RXUEUXSWYSXUEWOWXHWUFWYRXUEWXLXJWYRXUEVDZWUFVDZWVPVYMXUGWYOWVQXUFWVQYDWUFXUFP
  WVPYLULZWVQXUFWVPPWCULXUHYDXUFWVPUEPUDQPWCXUFWVOUEPXUFTVWDWWGXUFXQSXUFVWDWYRX
  UEYMUXTZXRZUEWKRZXUFYNSZVYCXUFWLSZXUFWVOVWDTVAQZUEWCXUFTVWDWWSXUFYBSXUFVWDXUI
  VNUYAXUFVWDWKRVWDUEWCULZWWGUETWCULVDXUNUEWCULXUIXUFXUOUEVWDYLULZYDZWYRXUEXUQX
  UFWYRXUPVDZYDYOXUFWYRVDXUQYOXUFVXFXURWYRXUEWOVWDUYBUYCXUFWYRXUPUYDUYHUYEXUFVW
  DUEXUIXULYPWMXUFTWWLXUFXTSUYFVWDTUYGYQWIYAXUFPVWTXUFVFSUYIXMXUFWVPPXUFWVOPXUJ
  XUMXSXUMYPXKWVPUYJYHVOWUFWYOWVQXUFWUFWYOVDWVPVYMUNWUFWYOWOWUFWYOYMXFUYKUYLYKY
  QUYMUYNUYSUYOWYODUQYJUYTWXHVYMUQRWYNWYPWJWXHVYMWXLUYPDVYMUYQWNUYRVUAWXHVYMPWX
  HVYMWXLXAWXNVUBYRWXHVYQUQRZWXTWYLWJWXHVYQWXOVUJZVYQVUCWNWMPVYQVUDVUEWXHWXQPWX
  HXUSWXQPVCXUTVYQVUFWNVUGVTVJVSVSWXIWXKVYTUOZVYTUDQVYTXVAUDQUEWXIWXJXVAVYTUDWX
  IVYTWXPVUHVSWXIXVAVYTWXIVYTWXPVGWXPVUIWXIVYTWXPVUKYSYSWVAWUSWVBVEWVJWVIXFAWVS
  VDZTPWWDUJQZCWWDUTQZVAQZVAQZWWDFUHZVYIHUHWVTFUHXVBXVGVWCWWDPUIQZUTQZXVDWWDUJQ
  ZVAQZXVJUDQZXVFXVBDWWDWVCXVLUNFVEWVDXVBKSXVBVWDWWDVCZVDZVWOXVKVWNXVJUDXVNVWFX
  VIVWNXVJVAXVNVWEXVHVWCUTXVNVWDWWDPUIXVBXVMWOZVSWDXVNVWMXVDVWDWWDUJXVNVWDWWDCU
  TXVOWDXVOWSZWSXVPWSXVBWWCVHRWWDUNRXVBTVYIWVRXVBXNSAWVSWOZXOZWWCXPWNXVBXVKXVJX
  VBXVIXVJWVSXVIVERAWVSVWCXVHWVSPWXCVGWVSXVHWWCVHWVSWWCPWXBWXCVUTZWVSTVYIWVRWVS
  XNSWWRXOZXFVKVJXVBXVDWWDXVBCWWDAVXBWVSVXDVOXVBWWCPXVRPVHRZXVBYFSYTVKZXVBWWCPX
  VBTVYIWWSXVBYBSZWVSVYIVERAWXAVJXDVWTXVBVFSWEZXVBUEWWDXUKXVBYNSXVBWWCPXVBTVYIW
  WGXVBXQSZWVSVYIWKRAWWIVJZXRVYCXVBWLSXVBTVYIXWEXWFUETYLULXVBTXNVULSXVBVYIXVQVU
  MVUNUEPWCULXVBVUOSVUPXLZXCZXDXWHWEXEXVBXVLXVJXVJUDQTXVJVAQXVFXVBXVKXVJXVJUDXV
  BXVKPXVJVAQXVJXVBXVIPXVJVAXVBXVIVWCWWCUTQZPXVBXVHWWCVWCUTWVSXVHWWCVCAXVSVJWDW
  VSXWIPVCAVYIVUQVJVTVSXVBXVJXWHVURVTVSXVBXVJXWHVUSXVBXVJXVETVAXVBXVDWWDXWBXWDX
  WGVVAWDVVBVVCXVBDVYITPWVPUJQZCWVPUTQZVAQZVAQZXVFVHHVEHDVHXWMVBVCXVBLSXVBWWOVD
  ZXWLXVETVAXWNXWJXVCXWKXVDVAXWNWVPWWDPUJXWNWVOWWCPUDXWNVWDVYITVAXVBWWOWOWDVSZW
  DXWNWVPWWDCUTXWOWDWSWDXVQXVBTXVEXWCXVBXVCXVDXVBWWDXWDXWGVVDXWBXDXDXEXVBWVTWWD
  FWVSWVTWWDVCAWVSDVYIWVPWWDVHGVHWWNWWQWWRWVSWWCPXVTXWAWVSYFSYTXEVJWHVVEVVFWMAV
  VMVVOWVKAVVOAPCVYDVXCVVGAUECCUIQZVVOWCAXWPUEACVXDVVHVRACPCVXCVYDVXCWVNVVJWIVV
  IVVKYR $.
  $}

  ${
    $d N j $.
    stirlinglem6.1 $e |- H = ( j e. NN0 |-> ( 2 x. ( ( 1 / ( ( 2 x. j ) + 1 ) )
      x. ( ( 1 / ( ( 2 x. N ) + 1 ) ) ^ ( ( 2 x. j ) + 1 ) ) ) ) ) $.
    $( A series that converges to log (N+1)/N (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    stirlinglem6 $p
      |- ( N e. NN -> seq 0 ( + , H ) ~~> ( log ` ( ( N + 1 ) / N ) ) )
                                     $=
  ( cn wcel caddc cc0 c1 c2 cmul co cdiv cmin cmpt a1i wbr clt eqcomd oveq1d cv
  cseq clog cfv cli cneg cexp cn0 eqid cr 2re nnre remulcld cle 0re 2pos ltleii
  nngt0 ltled mulge0d ge0p1rpd rpreccld cabs 1re renegcld rpred 0lt1 wb lt0neg2
  ax-mp mpbi rpgt0d lttrd crp 1rp cc ax-1cn 2rp nnrp rpmulcld ltaddrp2d eqbrtrd
  ltrec1d absltd mpbir2and stirlinglem5 2cn nncn mulcld addcld readdcld mulgt0d
  div1d gt0ne0d dividd oveq12d divdird divsubdird addassd oveq2d mulid1d adddid
  ltp1d wceq 1p1e2 eqtr4d 3eqtrd pncand eqtrd divcan7d divmuldivd divcld fveq2d
  mulid2d breqtrd ) CEFZGBHUBIIJCKLZIGLZMLZGLZIXSNLZMLZUCUDCIGLZCMLZUCUDUEXPAEI
  UFZAUAZINLUGLXSYFUGLYFMLZKLZOZXSAAEYGOZAEYHYGGLOZAUHJYFKLIGLOZBYIUIYJUIYKUIDY
  LUIXPXRXPXQXPJCJUJFXPUKPZCULZUMZXPJCYMYNHJUNQXPHJUOUKUPUQPXPHCHUJFXPUOPZYNCUR
  ZUSUTVAZVBZXPXSVCUDIRQYEXSRQXSIRQXPYEHXSXPIIUJFZXPVDPZVEYPXPXSYSVFZYEHRQZXPHI
  RQZUUCVGYTUUDUUCVHVDIVIVJVKPXPXSYSVLVMXPIXRIVNFXPVOPYRXPIIMLIXRRXPIIVPFXPVQPZ
  WMXPIXQUUAXPJCJVNFXPVRPCVSVTWAWBWCXPXSIUUBUUAWDWEWFXPYBYDUCXPYBXRXRMLZXSGLZUU
  FXSNLZMLZJYCKLZXRMLZXQXRMLZMLZYDXPXTUUGYAUUHMXPIUUFXSGXPUUFIXPXRXPXQIXPJCJVPF
  XPWGPZCWHZWIZUUEWJZXPXRXPHXQXRYPYOXPXQIYOUUAWKXPJCYMYNHJRQXPUPPZYQWLZXPXQYOXC
  VMWNZWOSZTXPIUUFXSNUVATWPXPUUIXRIGLZXRMLZXRINLZXRMLZMLUUMXPUUGUVCUUHUVEMXPUVC
  UUGXPXRIXRUUQUUEUUQUUTWQSXPUVEUUHXPXRIXRUUQUUEUUQUUTWRSWPXPUVCUUKUVEUULMXPUVB
  UUJXRMXPUVBXQIIGLZGLXQJGLZUUJXPXQIIUUPUUEUUEWSXPUVFJXQGUVFJXDXPXEPWTXPUVGXQJI
  KLZGLUUJXPJUVHXQGXPUVHJXPJUUNXASWTXPJCIUUNUUOUUEXBXFXGTXPUVDXQXRMXPXQIUUPUUEX
  HTWPXIXPUUMUUJXQMLZJJMLZYDKLZYDXPUUJXQXRXPJYCUUNXPCIUUOUUEWJZWIUUPUUQXPXQUUSW
  NUUTXJXPUVKUVIXPJJYCCUUNUUNUVLUUOXPJUURWNZXPCYQWNZXKSXPUVKIYDKLYDXPUVJIYDKXPJ
  UUNUVMWOTXPYDXPYCCUVLUUOUVNXLXNXIXGXGXMXO $.
  $}

  ${
    $d i j n $.  $d j k n $.  $d H i $.  $d H j $.  $d H n $.  $d K j $.
    $d K n $.  $d N i $.  $d N j $.  $d N k $.  $d N n $.
    stirlinglem7.1 $e |- J = ( n e. NN |-> ( ( ( ( 1 + ( 2 x. n ) ) / 2 ) x.
      ( log ` ( ( n + 1 ) / n ) ) ) - 1 ) ) $.
    stirlinglem7.2 $e |- K = ( k e. NN |-> ( ( 1 / ( ( 2 x. k ) + 1 ) ) x.
      ( ( 1 / ( ( 2 x. N ) + 1 ) ) ^ ( 2 x. k ) ) ) ) $.
    stirlinglem7.3 $e |- H = ( k e. NN0 |-> ( 2 x. ( ( 1 / ( ( 2 x. k ) + 1 ) )
      x. ( ( 1 / ( ( 2 x. N ) + 1 ) ) ^ ( ( 2 x. k ) + 1 ) ) ) ) )
                                    $.
    $( Algebraic manipulation of the formula for J(n) (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    stirlinglem7 $p |- ( N e. NN -> seq 1 ( + , K ) ~~> ( J ` N ) )
                                  $=
      ( wcel caddc c1 c2 cmul co cdiv a1i cc0 cc oveq2d vj vi cn cseq clog cmin
      cfv cli cvv nnuz cz 1z wceq 1e0p1 seqeq1d cn0 nn0uz 0nn0 cv cexp cmpt weq
      wa oveq2 oveq1d oveq12d adantl simpr 2cn mulcld ax-1cn addcld wne 0re 2re
      nn0cn nn0re remulcld 1re cle wbr 2pos ltleii nn0ge0 mulge0d clt addgegt0d
      cr 0lt1 ltned necomd reccld nncn adantr nnre nngt0 gt0ne0d 2nn0 nn0mulcld
      ltled 1nn0 nn0addcld expcld eqeltrd stirlinglem6 clim2ser eqbrtrd 0z seq1
      fvmptd mp1i 0cn mul01d eqcomd eqtrd breqtrd syl6eqelr syl6eqr div1d exp1d
      mulid2d divassd mulid1d 3eqtr2d 3eqtrd halfcld seqex cuz elnnuz lttrd syl
      readdcld ad2antrr 2ne0 nn0zd expne0d addcomd eqtr4d divcld id cfz biimpri
      biimpi elfzuz nnnn0 3syl nn0cnd elfznn crp 2rp nnrp ltaddrp2d addcl seqcl
      simprl simprr adddid div32d mul12d exprecd divrecd mulcomd expp1d zmulcld
      rpmulcld divcan3d divdiv1d 3eqtr4d dividd 1exp expdivd seqdistr climmulc2
      eqeltrrd nnne0 ltp1d divne0d logcld subdid divcan6d oveq1 fveq2d breqtrrd
      2z subcld ) FUCJZKELUDZLMFNOZKOZMPOZFLKOZFPOZUEUGZNOZLUFOZFDUGUHUWFUWGUWJ
      UWMMUWHLKOZPOZUFOZNOZUWOUHUWFUWRUWJUAKCLUDZUWGLUIUCUJLUKJUWFULQUWFUWTUWMR
      KCRUDUGZUFOZUWRUHUWFUWTKCRLKOZUDUXBUHUWFLUXCKCLUXCUMUWFUNQZUOUWFUWMUACRRU
      PUQRUPJUWFURQZUWFUAUSZUPJZVCZUXFCUGMLMUXFNOZLKOZPOZLUWPPOZUXJUTOZNOZNOZSU
      XHAUXFMLMAUSZNOZLKOZPOZUXLUXRUTOZNOZNOZUXOUPCSCAUPUYBVAUMZUXHIQAUAVBZUYBU
      XOUMUXHUYDUYAUXNMNUYDUXSUXKUXTUXMNUYDUXRUXJLPUYDUXQUXILKUXPUXFMNVDVEZTUYD
      UXRUXJUXLUTUYETVFTVGUWFUXGVHZUXHMUXNMSJZUXHVIQZUXHUXKUXMUXHUXJUXGUXJSJUWF
      UXGUXILUXGMUXFUYGUXGVIQUXFVPVJLSJZUXGVKQVLVGUXHRUXJUXGRUXJVMUWFUXGRUXJRWH
      JZUXGVNQUXGUXILUXGMUXFMWHJZUXGVOQZUXFVQZVRLWHJZUXGVSQUXGMUXFUYLUYMRMVTWAZ
      UXGRMVNVOWBWCZQUXFWDWERLWFWAZUXGWIQWGWJVGWKWLUXHUXLUXJUXHUWPUXHUWHLUXHMFU
      YHUWFFSJZUXGFWMZWNVJUYIUXHVKQVLUWFUWPRVMZUXGUWFUWPUWFUWHLUWFMFUYKUWFVOQZF
      WOZVRUYNUWFVSQZUWFMFVUAVUBUYOUWFUYPQUWFRFUYJUWFVNQZVUBFWPZWTWEUYQUWFWIQZW
      GWQZWNWLUXHUXILUXHMUXFMUPJZUXHWRQUYFWSLUPJZUXHXAQXBXCVJVJZXJVUJXDACFIXEXF
      XGUWFUXAUWQUWMUFUWFUXARCUGZMLMRNOZLKOZPOZUXLVUMUTOZNOZNOZUWQRUKJUXAVUKUMU
      WFXHKCRXIXKUWFARUYBVUQUPCSUYCUWFIQUWFUXPRUMZVCZUYAVUPMNVUSUXSVUNUXTVUONVU
      SUXRVUMLPVUSUXQVULLKVUSUXPRMNUWFVURVHTVEZTVUSUXRVUMUXLUTVUTTVFTUXEUWFMVUP
      UYGUWFVIQZUWFVUNVUOUWFVUMUWFVULLUWFMRVVARSJUWFXLQVJUYIUWFVKQZVLUWFVUMUWFR
      LVUMWFVUFUWFLUXCVUMUXDUWFRVULLKUWFVULRUWFMVVAXMZXNVEXOZXPWQWLUWFUXLVUMUWF
      UWPUWFUWHLUWFMFVVAUYSVJZVVBVLZVUGWLZUWFVUMLUPVVDXAXQXCVJVJXJUWFVUQMUXLNOM
      LNOZUWPPOUWQUWFVUPUXLMNUWFVUPLUXLNOUXLUWFVUNLVUOUXLNUWFVUNLLPOLUWFVUMLLPU
      WFVUMUXCLUWFVULRLKVVCVEUNXRZTUWFLVVBXSXOUWFVUOUXLLUTOUXLUWFVUMLUXLUTVVITU
      WFUXLVVGXTXOVFUWFUXLVVGYAXOTUWFMLUWPVVAVVBVVFVUGYBUWFVVHMUWPPUWFMVVAYCVEY
      DYETXPUWFUWIUWFLUWHVVBVVEVLZYFZUWGUIJUWFKELYGQUWFUXFUCJZVCZBUBKSCLUXFVVLU
      XFLYHUGZJZUWFVVLVVOUXFYIUUCVGZVVMBUSZLUXFUUAOJZVCZVVQCUGZMLMVVQNOZLKOZPOZ
      UXLVWBUTOZNOZNOZSVVSAVVQUYBVWFUPCSUYCVVSIQABVBZUYBVWFUMVVSVWGUYAVWEMNVWGU
      XSVWCUXTVWDNVWGUXRVWBLPVWGUXQVWALKUXPVVQMNVDZVEZTZVWGUXRVWBUXLUTVWITVFTVG
      VVRVVQUPJZVVMVVRVVQVVNJZVVQUCJZVWKVVQLUXFUUDVWMVWLVVQYIUUBVVQUUEUUFVGZVVS
      MVWEUYGVVSVIQZVVSVWCVWDVVSVWBVVSVWALVVSMVVQVWOVVSVVQVWNUUGVJUYIVVSVKQZVLV
      VRVWBRVMZVVMVVRVWMVWQVVQUXFUUHZVWMVWBVWMRLVWBUYJVWMVNQUYNVWMVSQZVWMVWALVW
      MMVVQUYKVWMVOQVVQWOVRVWSYLUYQVWMWIQVWMLVWAVWSVWMMVVQMUUIJVWMUUJQVVQUUKUVE
      UULYJWQYKVGWLZVVSUXLVWBUWFUXLSJVVLVVRVVGYMZVVSVWALVVSMVVQVUHVVSWRQVWNWSZV
      UIVVSXAQXBZXCZVJZVJZXJZVXFXDZVVQSJZUBUSZSJZVCZVVQVXJKOSJVVMVVQVXJUUMVGZUU
      NVVMBUBUWJKSNECLUXFVXMVVMVXLVCZUWJVVQVXJVXNUWIVXNLUWHUYIVXNVKQVXNMFUYGVXN
      VIQUWFUYRVVLVXLUYSYMVJVLYFVVMVXIVXKUUOVVMVXIVXKUUPUUQVVPVXHVVSVVQEUGVWCUX
      LVWAUTOZNOZUWJVWFNOZUWJVVTNOVVSAVVQUXSUXLUXQUTOZNOZVXPUCESEAUCVXSVAUMVVSH
      QVWGVXSVXPUMVVSVWGUXSVWCVXRVXONVWJVWGUXQVWAUXLUTVWHTVFVGVVRVWMVVMVWRVGVVS
      VWCVXOVWTVVSUXLVWAVXAVXBXCVJXJVVSVXQUWIVWFMPOZNOUWIVWENOZVXPVVSUWIMVWFUWF
      UWISJVVLVVRVVJYMZVWOVXFMRVMZVVSYNQZUURVVSVXTVWEUWINVVSVWEMVXEVWOVYDUVFTVV
      SVYAVWCUWIVWDNOZNOVWCUWPUWPPOZUWPVWAUTOZPOZNOVXPVVSUWIVWCVWDVYBVWTVXDUUSV
      VSVYEVYHVWCNVVSVYEUWILUWPVWBUTOZPOZNOUWIVYIPOZVYHVVSVWDVYJUWINVVSUWPVWBUW
      FUWPSJVVLVVRVVFYMZUWFUYTVVLVVRVUGYMZVVSVWBVXCYOZUUTTVVSUWIVYIVYBVVSUWPVWB
      VYLVXCXCVVSUWPVWBVYLVYMVYNYPUVAVVSUWIVYGUWPNOZPOUWPUWPVYGNOZPOVYKVYHVVSUW
      IUWPVYOVYPPVVSLUWHVWPVVSMFVWOUWFUYRVVLVVRUYSYMVJYQVVSVYGUWPVVSUWPVWAVYLVX
      BXCZVYLUVBVFVVSVYIVYOUWIPVVSUWPVWAVYLVXBUVCTVVSUWPUWPVYGVYLVYLVYQVYMVVSUW
      PVWAVYLVYMVVSMVVQMUKJVVSUWDQVVSVVQVWNYOUVDZYPUVGUVHYDTVVSVYHVXOVWCNVVSVYH
      LVWAUTOZVYGPOVXOVVSVYFVYSVYGPVVSVYFLVYSVVSUWPVYLVYMUVIVVSVWAUKJVYSLUMVYRV
      WAUVJYKYRVEVVSLUWPVWAVWPVYLVYMVXBUVKYRTYEYEVVSVWFVVTUWJNVVSVVTVWFVXGXNTYD
      UVLUVMUWFUWSUWPMPOZUWRNOVYTUWMNOZVYTUWQNOZUFOUWOUWFUWJVYTUWRNUWFUWIUWPMPU
      WFLUWHVVBVVEYQVEZVEUWFVYTUWMUWQUWFUWJVYTSWUCVVKUVNUWFUWLUWFUWKFUWFFLUYSVV
      BVLZUYSFUVOZYSUWFUWKFWUDUYSUWFUWKUWFRFUWKVUDVUBUWFFLVUBVUCYLVUEUWFFVUBUVP
      YJWQWUEUVQUVRZUWFMUWPVVAVVFVUGYSUVSUWFWUAUWNWUBLUFUWFVYTUWJUWMNUWFUWPUWIM
      PUWFUWHLVVEVVBYQVEVEUWFUWPMVVFVVAVUGVYCUWFYNQUVTVFYEXPUWFBFLVWAKOZMPOZVVQ
      LKOZVVQPOZUEUGZNOZLUFOZUWOUCDSDBUCWUMVAUMUWFGQVVQFUMZWUMUWOUMUWFWUNWULUWN
      LUFWUNWUHUWJWUKUWMNWUNWUGUWIMPWUNVWAUWHLKVVQFMNVDTVEWUNWUJUWLUEWUNWUIUWKV
      VQFPVVQFLKUWAWUNYTVFUWBVFVEVGUWFYTUWFUWNLUWFUWJUWMVVKWUFVJVVBUWEXJUWC $.
  $}

  ${
    $d k n $.
    stirlinglem8.1 $e |- F/ n ph $.
    stirlinglem8.2 $e |- F/_ n A $.
    stirlinglem8.3 $e |- F/_ n D $.
    stirlinglem8.4 $e |- D = ( n e. NN |-> ( A ` ( 2 x. n ) ) ) $.
    stirlinglem8.5 $e |- ( ph -> A : NN --> RR+ ) $.
    stirlinglem8.6 $e |- F = ( n e. NN |-> ( ( ( A ` n ) ^ 4 ) / ( ( D `
                               n ) ^ 2 ) ) ) $.
    stirlinglem8.7 $e |- L = ( n e. NN |-> ( ( A ` n ) ^ 4 ) ) $.
    stirlinglem8.8 $e |- M = ( n e. NN |-> ( ( D ` n ) ^ 2 ) ) $.
    stirlinglem8.9 $e |- ( ( ph /\ n e. NN ) -> ( D ` n ) e. RR+ ) $.
    stirlinglem8.10 $e |- ( ph -> C e. RR+ ) $.
    stirlinglem8.11 $e |- ( ph -> A ~~> C ) $.
    $( If ` A ` converges to ` C ` , then ` F ` converges to C^2 .
       (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    stirlinglem8 $p
                   |- ( ph -> F ~~> ( C ^ 2 ) ) $=
  ( cn vk c4 cexp co c2 cdiv cli c1 cvv cv cfv cmpt nfmpt1 nfcxfr nnuz wcel a1i
  cz 1z crp wf cc wss rrpsscn fss sylancl 4nn0 nnex mptex eqeltri wa wceq simpr
  cn0 ffvelrnda rpcnd expcld fvmpt2 syl2anc climexp cmul adantr 2nn id nnmulcld
  adantl ffvelrnd fmptdf fex 1nn 2cn ax-1cn mulcld oveq2 fvmptg sylancr eqeltrd
  eqid caddc cuz cle wbr cr nnred nnge1d leadd2dd mpdan oveq1d cbvmptv peano2nn
  oveq2d fvmptd nncn adddid mulid1d 3eqtrd 3brtr4d wb nnzd peano2zd eluz mpbird
  1re eqcomd fveq2d eqtrd climsuse 2nn0 rpne0d 2z expne0d cc0 eqeltrrd rpexpcld
  sqcld csn neneqd 0cn elsnc2g nn0zd ax-mp sylnibr eldifd rpdivcld oveq12d cmin
  eqtr4d climdivf 4cn 2p2e4 subaddrii eqcomi expsubd breqtrrd ) AFCUBUCUDZCUEUC
  UDZUFUDZUUPUGAUUOUUPEGHFUHUITIEGETEUJZBUKZUBUCUDZULZOETUUTUMUNZEHETUURDUKZUEU
  CUDZULZPETUVDUMUNZEFETUUTUVDUFUDZULZNETUVGUMUNUOUHURUPAUSUQZACEBGUHUBUITIJUVB
  UOUVIATUTBVAUTVBVCTVBBVAZMVDTUTVBBVEVFZSUBVNUPZAVGUQZGUIUPAGUVAUIOETUUTVHVIVJ
  UQAUURTUPZVKZUVNUUTVBUPUURGUKZUUTVLZAUVNVMZUVOUUSUBUVOUUSATUTUURBMVOZVPZUVLUV
  OVGUQZVQZETUUTVBGOVRVSVTFUIUPAFUVHUINETUVGVHVIVJUQACEDHUHUEUITIKUVFUOUVIAETUE
  UURWAUDZBUKZVBDIUVOTVBUWCBAUVJUVNUVKWBUVNUWCTUPZAUVNUEUURUETUPZUVNWCUQZUVNWDW
  EZWFWGZLWHACEBDETUWCULZUHUIUITIJKETUWCUMUOUVIAUVJTUIUPBUIUPUVKVHTVBUIBWIVFUVT
  SAUHUWJUKZUEUHWAUDZTAUHTUPZUWLVBUPUWKUWLVLWJAUEUHUEVBUPZAWKUQUHVBUPZAWLUQWMEU
  HUWCUWLTVBUWJUURUHUEWAWNUWJWRZWOWPAUEUHUWFAWCUQUWMAWJUQWEWQUVNUURUHWSUDZUWJUK
  ZUURUWJUKZUHWSUDZWTUKUPZAUVNUXAUWTUWRXAXBZUVNUWCUHWSUDUWCUEWSUDZUWTUWRXAUVNUH
  UEUWCUHXCUPUVNYCUQUVNUEUWGXDUVNUWCUWHXDUVNUEUWGXEXFUVNUWSUWCUHWSUVNUWEUWSUWCV
  LZUWHETUWCTUWJUWPVRXGZXHUVNUWRUEUWQWAUDZUWCUWLWSUDUXCUVNUAUWQUEUAUJZWAUDZUXFT
  UWJTUWJUATUXHULVLUVNEUATUWCUXHUURUXGUEWAWNXIUQUVNUXGUWQVLZVKUXGUWQUEWAUVNUXIV
  MXKUURXJZUVNUEUWQUWGUXJWEZXLZUVNUEUURUHUWNUVNWKUQZUURXMUWOUVNWLUQXNUVNUWLUEUW
  CWSUVNUEUXMXOXKXPXQUVNUWTURUPUWRURUPUXAUXBXRUVNUWSUVNUWSUWCURUXEUVNUWCUWHXSWQ
  XTUVNUWRUXFURUXLUVNUXFUXKXSWQUWTUWRYAVSYBWFDUIUPADETUWDULUILETUWDVHVIVJUQUVOU
  VCUWDUWSBUKUVOUVNUWDVBUPUVCUWDVLUVRUWIETUWDVBDLVRVSZUVOUWCUWSBUVOUWSUWCUVNUXD
  AUXEWFYDYEYFYGUEVNUPAYHUQHUIUPAHUVEUIPETUVDVHVIVJUQUVOUVNUVDVBUPUURHUKZUVDVLU
  VRUVOUVCUVOUVCQVPYOZETUVDVBHPVRVSZVTACUEACRVPZACRYIZUEURUPZAYJUQZYKATVBUURGAE
  TUUTVBGIUWBOWHVOUVOUXOVBYLYPZUVOUXOUVDVBUXQUXPWQUVOUXOYLVLZUXOUYBUPZUVOUXOYLU
  VOUXOUVOUXOUWDUEUCUDZUTUVOUXOUVDUYEUXQUVOUVCUWDUEUCUXNXHYFUVOUWDUEUVOUVCUWDUT
  UXNQYMUXTUVOYJUQZYNWQYIYQYLVBUPUYDUYCXRYRUXOYLVBYSUUAUUBUUCUVOUURFUKZUVGUVPUX
  OUFUDUVOUVNUVGUTUPUYGUVGVLUVRUVOUUTUVDUVOUUSUBUVSUVOUBUWAYTYNZUVOUVCUEQUYFYNU
  UDETUVGUTFNVRVSUVOUVPUUTUXOUVDUFUVOUVNUUTUTUPUVQUVRUYHETUUTUTGOVRVSUXQUUEUUGU
  UHAUUPCUBUEUUFUDZUCUDUUQAUEUYICUCUEUYIVLAUYIUEUBUEUEUUIWKWKUUJUUKUULUQXKACUBU
  EUXRUXSUYAAUBUVMYTUUMYFUUN $.
  $}

  ${
    $d k n $.  $d K n $.  $d N k $.  $d N n $.
    stirlinglem9.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) /
      ( ( sqr ` ( 2 x. n ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem9.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    stirlinglem9.3 $e |- J = ( n e. NN |-> ( ( ( ( 1 + ( 2 x. n ) ) / 2 ) x.
      ( log ` ( ( n + 1 ) / n ) ) ) - 1 ) ) $.
    stirlinglem9.4 $e |- K = ( k e. NN |-> ( ( 1 / ( ( 2 x. k ) + 1 ) ) x.
      ( ( 1 / ( ( 2 x. N ) + 1 ) ) ^ ( 2 x. k ) ) ) ) $.
    $( ` ( ( B `` N ) - ( B `` ( N + 1 ) ) ) ` is expressed as a limit of a
       series.  This result will be used both to prove that ` B ` is decreasing
       and to prove that ` B ` is bounded (below).  It will follow that ` B `
       converges in the reals.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem9 $p
      |- ( N e. NN -> seq 1 ( + , K ) ~~> ( ( B ` N ) - ( B ` ( N + 1 ) ) ) )
                                    $=
  ( cn wcel caddc c1 cfv co c2 cmul cdiv cseq cmin cli cn0 cv cexp stirlinglem7
  cmpt eqid stirlinglem4 breqtrrd ) GLMNFOUAGEPGBPGONQBPUBQUCCDCUDRORCUESQONQZT
  QORGSQONQTQULUFQSQSQUHZEFGJKUMUIUGABDEGHIJUJUK $.
  $}

  ${
    $d i j n $.  $d j k n $.  $d B j $.  $d K i $.  $d K j $.  $d K n $.
    $d L i $.  $d L j $.  $d L n $.  $d N i $.  $d N j $.  $d N k $.  $d N n $.
    stirlinglem10.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) / ( ( sqr
      ` ( 2 x. n ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem10.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    stirlinglem10.4 $e |- K = ( k e. NN |-> ( ( 1 / ( ( 2 x. k ) +
      1 ) ) x. ( ( 1 / ( ( 2 x. N ) + 1 ) ) ^ ( 2 x. k ) ) ) ) $.
    stirlinglem10.5 $e |- L = ( k e. NN |-> ( ( 1 / ( ( ( 2 x. N )
                                       + 1 ) ^ 2 ) ) ^ k ) ) $.
    $( A bound for any B(N)-B(N + 1) that will allow to find a lower bound for
       the whole ` B ` sequence.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem10 $p |- ( N e. NN -> ( ( B ` N ) - ( B ` ( N + 1 ) ) ) <_
      ( ( 1 / 4 ) x. ( 1 / ( N x. ( N + 1 ) ) ) ) )
                                   $=
      ( wcel c1 caddc co c4 cdiv cmul a1i c2 vj vi cfv cmin cseq nnuz cn0 nn0zd
      cn 1nn0 cv clog cmpt eqid stirlinglem9 cexp cli cc 2cn nncn mulcld ax-1cn
      addcld sqcld cc0 0re 1re 2re nnre remulcld readdcld clt wbr 0lt1 crp nnrp
      cr 2rp rpmulcld ltaddrp2d lttrd gt0ne0d expne0d reccld cabs cneg renegcld
      cz 2z resqcld rereccld wb lt0neg2 ax-mp sqgt0d recgt0d 2nn expgt1 syl3anc
      sylib elrpd recgt1d wa wceq weq oveq2d adantl adantr nnnn0d expcld fvmptd
      mpbid eqcomd oveq1d eqtrd mulid1d 3eqtr2d adddid eqtr4d 3eqtrd divmuldivd
      wne oveq12d mulne0d mulid2d breqtrd oveq2 syl adantlr reexpcld seqcl 1exp
      eqeltrd cle expdivd nn0ge0d mulge0d ge0p1rpd ltled rpexpcld mpbir2and cuz
      absltd simpr elnnuz biimpri geolim2 exp1d dividd divsubdir binom2 sylancl
      rpcnne0d sqmuld sq2 mulassd 2t2e4 4cn sqvald sq1 pncand nnne0 nngt0 ltp1d
      4pos divdivdivd mulcomd 3eqtr3d biimpi cfz elfznn nncnd nn0mulcld readdcl
      2nn0 elfzelz zmulcld expmuld 3eqtr4d nnred rpge0d lediv2ad div1d rpreccld
      1rp lemul1d eqbrtrd 3brtr4d serle climle ) GUILZGBUCGMNOZBUCUDOMPQOZMGUWL
      ROZQOZROZUANEMUENFMUEZMUIUFUWKMMUGLUWKUJSZUHABCDDUIMTDUKZROZNOTQOUWSMNOUW
      SQOULUCROMUDOUMZEGHIUXAUNJUOUWKUWQMTGROZMNOZTUPOZQOZMUPOZMUXEUDOZQOZUWPUQ
      UWKUXEUAFMUWKUXDUWKUXCUWKUXBMUWKTGTURLZUWKUSSZGUTZVAZMURLZUWKVBSZVCZVDZUW
      KUXCTUXOUWKUXCUWKVEMUXCVEVQLZUWKVFSZMVQLZUWKVGSZUWKUXBMUWKTGTVQLZUWKVHSGV
      IZVJUXTVKZVEMVLVMZUWKVNSZUWKMUXBUXTUWKTGTVOLZUWKVRSGVPVSVTZWAWBZTWHLZUWKW
      ISWCZWDZUWKUXEWEUCMVLVMMWFZUXEVLVMUXEMVLVMZUWKUYLVEUXEUWKMUXTWGUXRUWKUXDU
      WKUXCUYCWJZUYJWKZUWKUYDUYLVEVLVMZUYEUXSUYDUYPWLVGMWMWNWTUWKUXDUYNUWKUXCUY
      CUYHWOZWPWAUWKMUXDVLVMZUYMUWKUXCVQLTUILZMUXCVLVMUYRUYCUYSUWKWQSUYGUXCTWRW
      SUWKUXDUWKUXDUYNUYQXAZXBXLUWKUXEMUYOUXTUUCUUAUWRUWKUAUKZMUUBUCLZXCZCVUAUX
      ECUKZUPOZUXEVUAUPOUIFURFCUIVUEUMXDZVUCKSVUCCUAXEZXCVUDVUAUXEUPVUCVUGUUDXF
      VUBVUAUILZUWKVUHVUBVUAUUEZUUFXGZVUCUXEVUAUWKUXEURLZVUBUYKXHVUCVUAVUJXIXJX
      KUUGUWKUXHUXEPUWNROZUXDQOZQOZUWPUWKUXFUXEUXGVUMQUWKUXEUYKUUHUWKUXGUXDUXDQ
      OZUXEUDOZUXDMUDOZUXDQOZVUMUWKMVUOUXEUDUWKVUOMUWKUXDUXPUYJUUIZXMXNUWKUXDUR
      LZUXMVUTUXDVEYBXCVURVUPXDUXPUXNUWKUXDUYTUUMUXDMUXDUUJWSUWKVUQVULUXDQUWKVU
      QUXBTUPOZTUXBMROZROZNOZMTUPOZNOZMUDOVULMNOZMUDOVULUWKUXDVVFMUDUWKUXBURLUX
      MUXDVVFXDUXLVBUXBMUUKUULXNUWKVVFVVGMUDUWKVVDVULVVEMNUWKVVDPGTUPOZROZPGROZ
      NOPVVHGNOZROVULUWKVVAVVIVVCVVJNUWKVVATTUPOZVVHROVVIUWKTGUXJUXKUUNUWKVVLPV
      VHRVVLPXDUWKUUOSXNXOUWKVVCTUXBROTTROZGROVVJUWKVVBUXBTRUWKUXBUXLXPXFUWKTTG
      UXJUXJUXKUUPUWKVVMPGRVVMPXDUWKUUQSXNXQYCUWKPVVHGPURLUWKUURSZUWKGUXKVDUXKX
      RUWKVVKUWNPRUWKVVKGGROZGMROZNOUWNUWKVVHVVOGVVPNUWKGUXKUUSUWKVVPGUWKGUXKXP
      XMYCUWKGGMUXKUXKUXNXRXSXFXQVVEMXDUWKUUTSYCXNUWKVULMUWKPUWNVVNUWKGUWLUXKUW
      KGMUXKUXNVCZVAZVAZUXNUVAXTXNXQYCUWKVUNMUXDROZUXDVULROZQOUXDMROZVWAQOZUWPU
      WKMUXDVULUXDUXNUXPVVSUXPUYJUYJUWKPUWNVVNVVRUWKPVEPVLVMUWKUVESWBZUWKGUWLUX
      KVVQGUVBUWKUWLUWKVEGUWLUXRUYBUWKGMUYBUXTVKGUVCZUWKGUYBUVDWAWBYDZYDZUVFUWK
      VVTVWBVWAQUWKMUXDUXNUXPUVGXNUWKVUOMVULQOZROMUWPROVWCUWPUWKVUOMVWHUWPRVUSU
      WKVWHMMROZVULQOUWPUWKMVWIVULQUWKVWIMUWKMUXNXPXMXNUWKMPMUWNUXNVVNUXNVVRVWD
      VWFYAXSYCUWKUXDUXDMVULUXPUXPUXNVVSUYJVWGYAUWKUWPUWKUWMUWOUWKPVVNVWDWDUWKU
      WNVVRVWFWDVAYEUVHXTXOYFUWKVUHXCZDUBNVQEMVUAVUHVUBUWKVUHVUBVUIUVIXGZVWJUWS
      MVUAUVJOLZXCZUWSEUCZMUWTMNOZQOZMUXCQOZUWTUPOZROZVQUWKVWLVWNVWSXDVUHUWKVWL
      XCZCUWSMTVUDROZMNOZQOZVWQVXAUPOZROZVWSUIEURECUIVXEUMXDVWTJSCDXEZVXEVWSXDV
      WTVXFVXCVWPVXDVWRRVXFVXBVWOMQVXFVXAUWTMNVUDUWSTRYGZXNXFVXFVXAUWTVWQUPVXGX
      FYCXGVWLUWSUILZUWKUWSVUAUVKZXGZVWTVWPVWRVWTVWOVWTUWTMVWTTUWSUXIVWTUSSZVWT
      UWSVXJUVLVAUXMVWTVBSZVCVWLVWOVEYBUWKVWLVWOVWLVXHVEVWOVLVMVXIVXHVEMVWOUXQV
      XHVFSUXSVXHVGSZVXHUWTMVXHTUWSUYAVXHVHSUWSVIVJVXMVKZUYDVXHVNSVXHMUWTVXMVXH
      TUWSUYFVXHVRSUWSVPVSVTZWAZYHWBXGWDVWTVWQUWTVWTUXCVWTUXBMVWTTGVXKUWKGURLVW
      LUXKXHVAVXLVCZUWKUXCVEYBVWLUYHXHZWDVWTTUWSTUGLVWTUVOSZVWTUWSVXJXIZUVMZXJV
      AXKZYIVWMVWPVWRVWLVWPVQLZVWJVWLVXHVYCVXIVXHVWOVXNVXHVWOVXPWBWKZYHXGUWKVWL
      VWRVQLVUHVWTVWQUWTUWKVWQVQLVWLUWKUXCUYCUYHWKXHVYAYJYIVJYMZUWSVQLUBUKZVQLX
      CUWSVYFNOVQLVWJUWSVYFUVNXGZYKVWJDUBNVQFMVUAVWKUWKVWLUWSFUCZVQLVUHVWTVYHUX
      EUWSUPOZVQVWTCUWSVUEVYIUIFURVUFVWTKSVXFVUEVYIXDVWTVUDUWSUXEUPYGXGVXJVWTUX
      EUWSUWKVUKVWLUYKXHVXTXJZXKZVWTUXEUWSUWKUXEVQLVWLUYOXHVXTYJYMYIZVYGYKVWJDE
      FMVUAVWKVYEVYLUWKVWLVWNVYHYNVMVUHVWTVWSVYIVWNVYHYNVWTVWSVWPVYIROZVYIYNVWT
      VWRVYIVWPRVWTMUWTUPOZUXCUWTUPOZQOMUWSUPOZUXDUWSUPOZQOVWRVYIVWTVYNVYPVYOVY
      QQVWLVYNVYPXDUWKVWLVYNMVYPVWLUWTWHLVYNMXDVWLTUWSUYIVWLWISUWSMVUAUVPZUVQUW
      TYLYHVWLUWSWHLZVYPMXDVYRUWSYLYHXSXGVWTUXCTUWSVXQVXTVXSUVRYCVWTMUXCUWTVXLV
      XQVXRVYAYOVWTMUXDUWSVXLVWTUXCVXQVDVWTUXCTVXQVXRUYIVWTWISZWCVXTYOUVSXFVWTV
      YMMVYIROZVYIYNVWTVWPMYNVMVYMWUAYNVMVWTVWPMMQOMYNVWTMVWOMMVOLVWTUWESZVWTUW
      TVWTTUWSUYAVWTVHSZVWTUWSVXJUVTZVJVWTTUWSWUCWUDVWTTVXSYPZVWTUWSVXTYPYQYRUX
      SVWTVGSZVWTMWUBUWAVWLMVWOYNVMZUWKVWLVXHWUGVXIVXHMVWOVXMVXNVXOYSYHXGUWBVWT
      MVXLUWCYFVWTVWPMVYIVWTVXHVYCVXJVYDYHWUFVWTUXEUWSVWTUXDVWTUXCTVWTUXBVWTTGW
      UCUWKGVQLVWLUYBXHZVJVWTTGWUCWUHWUEUWKVEGYNVMVWLUWKVEGUXRUYBVWEYSXHYQYRVYT
      YTUWDVWLVYSUWKVYRXGYTUWFXLVWTVYIVYJYEYFUWGVYBVYKUWHYIUWIUWJ $.
  $}

  ${
    $d j k $.  $d k n $.  $d B j $.  $d K j $.  $d K n $.  $d N j $.  $d N k $.
    $d N n $.
    stirlinglem11.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) /
      ( ( sqr ` ( 2 x. n ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem11.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    stirlinglem11.3 $e |- K = ( k e. NN |-> ( ( 1 / ( ( 2 x. k ) + 1 ) ) x.
      ( ( 1 / ( ( 2 x. N ) + 1 ) ) ^ ( 2 x. k ) ) ) )
                                  $.
    $( ` B ` is decreasing.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem11 $p |- ( N e. NN -> ( B ` ( N + 1 ) ) < ( B ` N ) )
                                $=
      ( cn wcel c1 caddc co cfv cc0 cr a1i c2 cmul vj clt wbr cmin cdiv cexp cv
      0re cc cmpt wceq simpr oveq2d oveq1d oveq12d 1nn 2cn ax-1cn mulcld addcld
      wa wne c3 mulid1i oveq1i 2p1e3 eqtri 3ne0 eqnetri reccld 1re 2re remulcld
      nncn nnre readdcld 0lt1 crp 2rp nnrp rpmulcld ltaddrp2d lttrd gt0ne0d cn0
      2nn0 nn0mulcld expcld fvmptd remulcli readdcli rereccli rereccld reexpcld
      1nn0 eqeltrd clog stirlinglem2 relogcld nfcv cfa csqr nfmpt1 nfcxfr fveq2
      ceu fveq2d fvmptf mpdan peano2nn syl syl2anc resubcld cle nn0ge0i mulge0d
      nffv 0le1 ge0p1rpd rpreccld rpge0d cz 2z zmulcld rpexpcld rpgt0d cseq cuz
      eqid peano2zd nnuz oveq2 adantl nnnn0 stirlinglem9 clim2ser divge0d recnd
      1z adantr uznnssnn mp2b sseld imdistani eluzelre sseli 1p1e2 eluzle letrd
      wss syl5eqbrr expge0d breqtrrd iserge0 seq1 mp1i breqtrd leadd1dd addid2d
      subcld npcand 3brtr3d ltletrd posdifd mpbird ) FJKZFLMNZBOZFBOZUBUCPUVIUV
      HUDNZUBUCUVFPLEOZUVJPQKZUVFUHRZUVFUVKLSLTNZLMNZUENZLSFTNZLMNZUENZUVNUFNZT
      NZQUVFCLLSCUGZTNZLMNZUENZUVSUWCUFNZTNZUWAJEUIECJUWGUJUKZUVFIRUVFUWBLUKZVA
      ZUWEUVPUWFUVTTUWJUWDUVOLUEUWJUWCUVNLMUWJUWBLSTUVFUWIULUMZUNUMUWJUWCUVNUVS
      UFUWKUMUOLJKZUVFUPRZUVFUVPUVTUVFUVOUVFUVNLUVFSLSUIKZUVFUQRZLUIKZUVFURRZUS
      UWQUTUVOPVBUVFUVOVCPUVOSLMNVCUVNSLMSUQVDVEVFVGVHVIZRVJUVFUVSUVNUVFUVRUVFU
      VQLUVFSFUWOFVNZUSUWQUTUVFUVRUVFPLUVRUVMLQKZUVFVKRZUVFUVQLUVFSFSQKZUVFVLRZ
      FVOZVMZUXAVPZPLUBUCZUVFVQRUVFLUVQUXAUVFSFSVRKZUVFVSRFVTZWAWBWCWDZVJUVFSLS
      WEKZUVFWFRLWEKUVFWORWGZWHUSZWIZUVFUVPUVTUVPQKUVFUVOUVNLSLVLVKWJVKWKUWRWLR
      UVFUVSUVNUVFUVRUXFUXJWMUXLWNVMWPZUVFUVIUVHUVFUVIFAOZWQOZQUVFUXQQKUVIUXQUK
      UVFUXPADFGWRWSZDFDUGZAOZWQOZUXQJBQDFWTZDUXPWQDWQWTZDFADADJUXSXAOSUXSTNZXB
      OUXSXFUENUXSUFNTNUENZUJGDJUYEXCXDZUYBXQXQUXSFUKUXTUXPWQUXSFAXEXGHXHXIUXRW
      PZUVFUVHUVGAOZWQOZQUVFUVGJKZUYIQKUVHUYIUKFXJZUVFUYHUVFUYJUYHVRKUYKADUVGGW
      RXKWSZDUVGUYAUYIJBQDUVGWTZDUYHWQUYCDUVGAUYFUYMXQXQUXSUVGUKUXTUYHWQUXSUVGA
      XEXGHXHXLUYLWPZXMZUVFUVKUVFUVKUWAVRUXNUVFUVPUVTUVFUVOUVFUVNUVFSLUXCUXAVMU
      VFSLUXCUXAPSXNUCZUVFSWFXOZRZPLXNUCZUVFXRRXPXSXTUVFUVSUVNUVFUVRUVFUVQUXEUV
      FSFUXCUXDUYRUVFFUXIYAZXPXSXTUVFSLSYBKUVFYCRLYBKZUVFYSRZYDYEWAWPYFUVFPUVKM
      NUVJUVKUDNZUVKMNUVKUVJXNUVFPVUCUVKUVMUVFUVJUVKUYOUXOXMUXOUVFPUVJLMELYGOZU
      DNZVUCXNUVFVUEUAELLMNZVUFYHOZVUGYIUVFLVUBYJUVFUVJUAELLJYKUWMUVFUAUGZJKZVA
      ZVUHEOZLSVUHTNZLMNZUENZUVSVULUFNZTNZUIVUJCVUHUWGVUPJEUIUWHVUJIRUWBVUHUKZU
      WGVUPUKVUJVUQUWEVUNUWFVUOTVUQUWDVUMLUEVUQUWCVULLMUWBVUHSTYLZUNUMVUQUWCVUL
      UVSUFVURUMUOYMUVFVUIULVUJVUNVUOVUJVUMVUJVULLVUJSVUHUWNVUJUQRZVUIVUHUIKUVF
      VUHVNYMUSUWPVUJURRZUTZVUJVUMVUJPLVUMUVLVUJUHRUWTVUJVKRZVUJVULLVUJSVUHUXBV
      UJVLRVUIVUHQKZUVFVUHVOZYMZVMVVBVPUXGVUJVQRVUJLVULVVBVUJSVUHUXHVUJVSRVUIVU
      HVRKUVFVUHVTZYMWAWBWCWDVJVUJUVSVULVUJUVRVUJUVQLVUJSFVUSUVFFUIKVUIUWSYTUSV
      UTUTUVFUVRPVBZVUIUXJYTVJVUJSVUHUXKVUJWFRVUIVUHWEKUVFVUHYNYMWGZWHZUSWIZVUJ
      VUNVUOVUJVUMVVAVUIVUMPVBZUVFVUIVUMVUIPLVUMUVLVUIUHRUWTVUIVKRZVUIVULLVUISV
      UHUXBVUIVLRVVDVMVVLVPUXGVUIVQRVUILVULVVLVUISVUHUXHVUIVSRVVFWAWBWCWDZYMVJV
      VIUSWPABCDDJLUYDMNSUENUXSLMNUXSUENWQOTNLUDNUJZEFGHVVNYIIYOYPUVFVUHVUGKZVA
      ZVUKVUPQVVPVUJVUKVUPUKUVFVVOVUIUVFVUGJVUHVUGJUUJZUVFUWLVUFJKVVQUPLXJVUFUU
      AUUBZRUUCUUDZVVJXKZVVPVUNVUOVVOVUNQKUVFVVOVUMVVOVULLVVOSVUHUXBVVOVLRZVUFV
      UHUUEZVMUWTVVOVKRVPVVOVUIVVKVUGJVUHVVRUUFVVMXKWMYMZVVPUVSVULVVPUVRUVFUVRQ
      KVVOUXFYTUVFVVGVVOUXJYTWMZVVPVUJVULWEKVVSVVHXKZWNZVMWPVVPPVUPVUKXNVVPVUNV
      UOVWCVWFVVPLVUMUWTVVPVKRZVVPVULVVPSVUHUXBVVPVLRZVVPVUJVVCVVSVVEXKZVMVVPSV
      UHVWHVWIUYPVVPUYQRZVVOPVUHXNUCUVFVVOPSVUHUVLVVOUHRVWAVWBUYPVVOUYQRVVOSVUF
      VUHXNUUGVUFVUHUUHUUKUUIYMXPXSUYSVVPXRRZYQVVPUVSVULVWDVWEVVPLUVRVWGVVPUVQV
      VPSFVWHUVFFQKVVOUXDYTZVMVVPSFVWHVWLVWJUVFPFXNUCVVOUYTYTXPXSVWKYQUULXPVVTU
      UMUUNUVFVUDUVKUVJUDVUAVUDUVKUKUVFYSMELUUOUUPUMUUQUURUVFUVKUVFUVKUWAUIUXNU
      XMWPZUUSUVFUVJUVKUVFUVIUVHUVFUVIUYGYRUVFUVHUYNYRUUTVWMUVAUVBUVCUVFUVHUVIU
      YNUYGUVDUVE $.
  $}

  ${
    $d i j n $.  $d j k n $.  $d B j $.  $d B k $.  $d F j $.  $d K i $.
    $d K j $.  $d K n $.  $d L i $.  $d L j $.  $d L n $.  $d N i $.  $d N j $.
    $d N k $.  $d N n $.
    stirlinglem12.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) /
      ( ( sqr ` ( 2 x. n ) ) x. ( ( n / _e ) ^ n ) ) ) )
                                    $.
    stirlinglem12.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    stirlinglem12.3 $e |- F = ( n e. NN |-> ( 1 / ( n x. ( n + 1 ) ) ) ) $.
    $( The sequence ` B ` is bounded below.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem12 $p
                   |- ( N e. NN -> ( ( B ` 1 ) - ( 1 / 4 ) ) <_ ( B ` N ) ) $=
  ( vj cn wcel c1 cfv co cr clog wceq a1i caddc adantl vk cdiv 1nn stirlinglem2
  vi c4 crp relogcl mp2b cv nfcv cfa cmul csqr ceu cexp cmpt nfmpt1 nfcxfr nffv
  c2 fveq2 fveq2d fvmptf mp2an eqeltri relogcld eqeltrd 4re cc0 0re 4pos gtneii
  mpdan rereccli cmin cfz csu cle cfzo cuz elnnuz biimpi elfznn syl weq syl2anc
  wa cc rpcnd wne rpne0d logcld fsumtscopo cz nnz fzoval sumeq1d fzfid peano2nn
  eqtr3d resubcld fsumrecl nnred readdcld remulcld ax-1cn addcld nnne0d mulne0d
  1re recnd rereccld wbr eqid stirlinglem10 fsumle elrpii clt 0lt1 divge0d nnuz
  ltled uztrn2 simpr oveq1d oveq12d oveq2d id nnre nncn cseq cli climrel adantr
  releldmi eqcomd eqbrtrd reccld wtru nnne0 fvmptd cdm seqeq1 trireciplem ax-mp
  wn simpl wo elnn1uz2 sylib ord mpd uz2m1nn npcand clim2ser pm2.61dan isumrecl
  seqeq1d rpge0d ge0p1rpd rpmulcld isumge0 leadd2dd addid1d mulcld isumsplit 1z
  nnrpd 3brtr4d isumclim breqtrd lemul2ad 4cn gt0ne0d fsummulc2 mulid1d 3brtr3d
  trud letrd subled ) EJKZLBMZEBMZLUFUBNZUWCOKUWBUWCLAMZPMZOLJKZUWGOKZUWCUWGQUC
  UWHUWFUGKUWIUCACLFUDUWFUHUIZCLCUJZAMZPMZUWGJBOCLUKZCUWFPCPUKZCLACACJUWKULMVAU
  WKUMNUNMUWKUOUBNUWKUPNUMNUBNZUQFCJUWPURUSZUWNUTUTUWKLQUWLUWFPUWKLAVBVCGVDVEUW
  JVFRUWBUWDEAMZPMZOUWBUWSOKUWDUWSQUWBUWRACEFUDVGZCEUWMUWSJBOCEUKZCUWRPUWOCEAUW
  QUXAUTUTUWKEQUWLUWRPUWKEAVBVCGVDVNUWTVHUWEOKZUWBUFVIVJUFVKVLVMVOZRZUWBUWCUWDV
  PNZLELVPNZVQNZIUJZBMZUXHLSNZBMZVPNZIVRZUWEVSUWBLEVTNZUXLIVRUXEUXMUWBUAUJZBMZU
  XIUXKUWCIUAUWDLEUXOUXHBVBUXOUXJBVBUXOLBVBUXOEBVBUWBELWAMKEWBWCUWBUXOLEVQNKZWH
  ZUXPUXOAMZPMZWIUXQUXPUXTQZUWBUXQUXOJKZUXTOKUYAUXOEWDZUXQUXSUXQUYBUXSUGKUYCACU
  XOFUDZWEZVGCUXOUWMUXTJBOCUXOUKZCUXSPUWOCUXOAUWQUYFUTUTCUAWFUWLUXSPUWKUXOAVBVC
  GVDWGTUXRUXSUXQUXSWIKUWBUXQUXSUYEWJTUXQUXSVJWKZUWBUXQUYBUYGUYCUYBUXSUYDWLWETW
  MVHWNUWBUXNUXGUXLIUWBEWOKUXNUXGQEWPZLEWQWEWRXAUWBUXMUXGUWELUXHUXJUMNZUBNZUMNZ
  IVRZUWEUWBUXGUXLIUWBLUXFWSZUWBUXHUXGKZWHZUXIUXKUYOUXHJKZUXIOKUYNUYPUWBUXHUXFW
  DZTZUYPUXIUXHAMZPMZOUYPUYTOKUXIUYTQUYPUYSACUXHFUDVGZCUXHUWMUYTJBOCUXHUKZCUYSP
  UWOCUXHAUWQVUBUTUTCIWFZUWLUYSPUWKUXHAVBVCGVDVNVUAVHWEUYNUXKOKZUWBUYNUYPVUDUYQ
  UYPUXKUXJAMZPMZOUYPUXJJKZVUFOKUXKVUFQUXHWTZUYPVUEUYPVUGVUEUGKVUHACUXJFUDWEVGZ
  CUXJUWMVUFJBOCUXJUKZCVUEPUWOCUXJAUWQVUJUTUTUWKUXJQUWLVUEPUWKUXJAVBVCGVDWGVUIV
  HWETXBZXCUWBUXGUYKIUYMUYOUWEUYJUXBUYOUXCRUYNUYJOKUWBUYNUYIUYNUXHUXJUYNUXHUYQX
  DZUYNUXHLVULLOKZUYNXKRXEXFUYNUXHUXJUYNUXHVULXLZUYNUXHLVUNLWIKZUYNXGRXHUYNUXHU
  YQXIUYNUYPUXJVJWKZUYQUYPUXJVUHXIZWEXJXMTZXFZXCUXDUWBUXGUXLUYKIUYMVUKVUSUYOUYP
  UXLUYKVSXNUYRABUECUEJLVAUEUJZUMNZLSNUBNLVAUXHUMNLSNZUBNVVAUPNUMNUQZUEJLVVBVAU
  PNUBNVUTUPNUQZUXHFGVVCXOVVDXOXPWEXQUWBUWEUXGUYJIVRZUMNUWELUMNUYLUWEVSUWBVVELU
  WEUWBUXGUYJIUYMVURXCZVUMUWBXKRZUXDUWBLUFVVGUFUGKUWBUFVIVLXRRUWBVJLVJOKUWBVKRZ
  VVGVJLXSXNUWBXTRYCZYAUWBVVEJUYJIVRZLVSUWBVVEVJSNZVVEEWAMZUYJIVRZSNVVEVVJVSUWB
  VJVVMVVEVVHUWBUYJIDEVVLVVLXOZUYHUWBUXHVVLKZWHZUYPUXHDMZUYJQZLUXHEJYBYDZUYPCUX
  HLUWKUWKLSNZUMNZUBNZUYJJDODCJVWBUQQUYPHRUYPVUCWHZVWAUYILUBVWCUWKUXHVVTUXJUMUY
  PVUCYEZVWCUWKUXHLSVWDYFYGYHUYPYIUYPUYIUYPUXHUXJUXHYJZUYPUXHLVWEVUMUYPXKRXEXFU
  YPUXHUXJUXHYKZUYPUXHLVWFVUOUYPXGRXHUXHUUAZVUQXJXMZUUBZWEZVVPUYIVVPUXHUXJVVPUX
  HVVSXDZVVPUXHLVWKVUMVVPXKRZXEXFVVPUXHUXJVVPUXHVWKXLZVVPUXHLVWMVUOVVPXGRXHVVPU
  XHVVSXIVVPUYPVUPVVSVUQWEXJXMZUWBELQZSDEYLZYMUUCZKZVWOVWRUWBVWOVWPSDLYLZVWQSDE
  LUUDVWSVWQKZVWOVWSLYMXNZVWTCDHUUEZVWSLYMYNYPUUFZRVHTUWBVWOUUGZWHZUWBUXFJKZVWR
  UWBVXDUUHZVXEEVAWAMKZVXFVXEVXDVXHUWBVXDYEVXEVWOVXHVXEUWBVWOVXHUUIVXGEUUJUUKUU
  LUUMEUUNWEUWBVXFWHZVWPLUXFVWSMVPNZYMXNVWRVXIVWPSDUXFLSNZYLZVXJYMVXIEVXKSDVXIV
  XKEVXIELUWBEWIKVXFEYKYOVUOVXIXGRUUOYQUUSVXFVXLVXJYMXNUWBVXFLIDLUXFJYBVXFYIUYP
  VVQWIKVXFUYPVVQUYJWIVWIUYPUYJVWHXLZVHTVXAVXFVXBRUUPTYRVWPVXJYMYNYPWEWGUUQZUUR
  VVFUWBUYJIDEVVLVVNUYHVWJVWNVXNVVPLUYIVWLVVPUXHUXJVVPUXHVVSUVIZVVPUXHVWKVVPUXH
  VXOUUTUVAUVBUWBVJLVSXNVVOVVIYOYAUVCUVDUWBVVKVVEUWBVVEUWBVVEVVFXLUVEYQUWBUYJID
  LEVVLJYBVVNUWBYIUYPVVRUWBVWITUWBUYPWHZUYIVXPUXHUXJUYPUXHWIKUWBVWFTZVXPUXHLVXQ
  VUOVXPXGRXHZUVFVXPUXHUXJVXQVXRUYPUXHVJWKUWBVWGTUYPVUPUWBVUQTXJYSVWTUWBVXCRUVG
  UVJVVJLQZUWBVXSYTUYJLIDLJYBLWOKYTUVHRUYPVVRYTVWITUYPUYJWIKYTVXMTVXAYTVXBRUVKU
  VSRUVLUVMUWBUXGUYJUWEIUYMUWBUFUFWIKUWBUVNRUWBUFVJUFXSXNUWBVLRUVOYSZUYOUYJVURX
  LUVPUWBUWEVXTUVQUVRUVTYRUWA $.
  $}

  ${
    $d j n x y $.  $d j n z $.  $d A j $.  $d B d $.  $d B j $.  $d B x $.
    $d B y $.
    stirlinglem13.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) /
      ( ( sqr ` ( 2 x. n ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem13.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    $( ` B ` is decreasing and has a lower bound, then it converges.  Since
       ` B ` is ` log A ` , in another theorem it is proven that ` A `
       converges as well.  (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    stirlinglem13 $p |- E. d e. RR B ~~> d $=
      ( vj cr wcel cfv clog wceq cn c1 c2 cmul co ceu cdiv a1i vx vy vz crn clt
      ccnv csup cli wbr cv wrex wss c0 wne cle wral cvv wb vex elrnmpt ax-mp wa
      simpr stirlinglem2 relogcld eqeltrd rexlimiva sylbi ssriv 1nn crp relogcl
      adantr nfcv csqr cexp cmpt nfmpt1 nfcxfr fveq2 fveq2d fvmptf mp2an eqeq2d
      cfa nffv rspcev eqeltri cbvmpt eqtri ne0i c4 cmin 4re cc0 0re 4pos gtneii
      mpbir rereccli resubcli caddc eqid stirlinglem12 rgen breq1 ralbidv fnmpt
      wfn fvelrnb sylib nfra1 nfv nfan w3a simp1l simp2 sylc simp3 breqtrd 3exp
      rsp rexlimd mpd ralrimiva reximi infmrcl mp3an wtru nnuz cz 1z cc oveq12d
      nncn 3syl mulcld divcld rpmulcld rpdivcld wf fmpti peano2nn oveq2d oveq1d
      cn0 nnnn0d faccl 2cn ax-1cn addcld sqrcld ere recni epos expcld nnre 0le1
      2rp 1re nnge1 letrd ge0p1rpd sqrgt0d gt0ne0d divne0d nnz peano2zd expne0d
      nnne0d mulne0d fvmptd nnrp rpsqrcld rpexpcld ffvelrni stirlinglem11 ltled
      epr syl2anc adantl climinf trud breq2 ) BUDZHUEUFUGZHIZBUWFUHUIZBDUJZUHUI
      ZDHUKUWEHULUWEUMUNZUAUJZUBUJZUOUIZUBUWEUPZUAHUKZUWGUBUWEHUWMUWEIZUWMCUJZA
      JZKJZLZCMUKZUWMHIZUWMUQIUWQUXBURUBUSCMUWTUWMBUQFUTVAUXAUXCCMUWRMIZUXAVBUW
      MUWTHUXDUXAVCUXDUWTHIZUXAUXDUWSACUWREVDVEZVMVFVGVHVINBJZUWEIZUWKUXHUXGGUJ
      ZAJZKJZLZGMUKZNMIZUXGNAJZKJZLZUXMVJUXNUXPHIZUXQVJUXOVKIZUXRUXNUXSVJACNEVD
      VAUXOVLVAZCNUWTUXPMBHCNVNZCUXOKCKVNZCNACACMUWRWEJZOUWRPQZVOJZUWRRSQZUWRVP
      QZPQZSQZVQZECMUYIVRVSZUYAWFWFUWRNLUWSUXOKUWRNAVTWAFWBWCZUXLUXQGNMUXINLZUX
      KUXPUXGUYMUXJUXOKUXINAVTWAWDWGWCUXGHIUXHUXMURUXGUXPHUYLUXTWHZGMUXKUXGBHBC
      MUWTVQGMUXKVQFCGMUWTUXKGUWTVNCUXJKUYBCUXIAUYKCUXIVNWFWFUWRUXILUWSUXJKUWRU
      XIAVTWAWIWJUTVAWSUWEUXGWKVAUWLUXIBJZUOUIZGMUPZUAHUKZUWPUXGNWLSQZWMQZHIUYT
      UYOUOUIZGMUPZUYRUXGUYSUYNWLWNWOWLWPWQWRWTXAVUAGMABCCMNUWRUWRNXBQPQSQVQZUX
      IEFVUCXCXDXEUYQVUBUAUYTHUWLUYTLUYPVUAGMUWLUYTUYOUOXFXGWGWCZUYQUWOUAHUYQUW
      NUBUWEUYQUWQVBZUYOUWMLZGMUKZUWNVUEUWQVUGUYQUWQVCBMXIZUWQVUGURUXECMUPVUHUX
      ECMUXFXECMUWTBHFXHVAGMUWMBXJVAXKVUEVUFUWNGMUYQUWQGUYPGMXLUWQGXMXNUWNGXMVU
      EUXIMIZVUFUWNVUEVUIVUFXOZUWLUYOUWMUOVUJUYQVUIUYPUYQUWQVUIVUFXPVUEVUIVUFXQ
      UYPGMYBXRVUEVUIVUFXSXTYAYCYDYEYFVAUAUBUWEYGYHUWHYIUAGBNMYJNYKIYIYLTMHBUUA
      YICMHUWTBFUXFUUBZTVUIUXINXBQZBJZUYOUOUIYIVUIVUMUYOVUIVUMVULAJZKJZHVUIVULM
      IVUOHIVUMVUOLUXIUUCZVUIVUNVUIVUNVULWEJZOVULPQZVOJZVULRSQZVULVPQZPQZSQZVKV
      UICVULUYIVVCMAYMAUYJLVUIETVUIUWRVULLZVBZUYCVUQUYHVVBSVVEUWRVULWEVUIVVDVCZ
      WAVVEUYEVUSUYGVVAPVVEUYDVURVOVVEUWRVULOPVVFUUDWAVVEUYFVUTUWRVULVPVVEUWRVU
      LRSVVFUUEVVFYNYNYNVUPVUIVUQVVBVUIVULUUFIZVUQMIZVUQYMIVUIVULVUPUUGZVULUUHZ
      VUQYOYPVUIVUSVVAVUIVURVUIOVULOYMIVUIUUITVUIUXINUXIYONYMIVUIUUJTUUKZYQUULZ
      VUIVUTVULVUIVULRVVKRYMIVUIRUUMUUNTZRWOUNVUIWORWPUUOWRTZYRZVVIUUPZYQVUIVUS
      VVAVVLVVPVUIVUSVUIVURVUIOVULOVKIVUIUUSTVUIUXIUXIUUQZVUIWONUXIWOHIVUIWPTNH
      IVUIUUTTVVQWONUOUIVUIUURTUXIUVAUVBUVCZYSZUVDUVEVUIVUTVULVVOVUIVULRVVKVVMV
      UIVULVUPUVJVVNUVFVUIUXIUXIUVGUVHZUVIUVKYRUVLVUIVUQVVBVUIVVGVVHVUQVKIVVIVV
      JVUQUVMYPVUIVUSVVAVUIVURVVSUVNVUIVUTVULVUIVULRVVRRVKIVUIUVSTYTVVTUVOYSYTV
      FVEZCVULUWTVUOMBHCVULVNZCVUNKUYBCVULAUYKVWBWFWFVVDUWSVUNKUWRVULAVTWAFWBUV
      TVWAVFMHUXIBVUKUVPABUCCUCMNOUCUJPQZNXBQSQNOUXIPQNXBQSQVWCVPQPQVQZUXIEFVWD
      XCUVQUVRUWAUYRYIVUDTUWBUWCUWJUWHDUWFHUWIUWFBUHUWDWGWC $.
  $}

  ${
    $d c d $.  $d d k $.  $d k n $.  $d x y $.  $d A c $.  $d A d $.  $d A k $.
    $d B d $.  $d B k $.
    stirlinglem14.1 $e |- A = ( n e. NN |-> ( ( ! ` n ) / ( ( sqr ` ( 2 x. n
                             ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem14.2 $e |- B = ( n e. NN |-> ( log ` ( A ` n ) ) ) $.
    $( The sequence ` A ` converges to a positive real.  This proves that the
       Stirling's formula converges to the factorial, up to a constant.  In
       another theorem, using Wallis' formula for &pi;& , such constant is
       exactly determined, thus proving the Stirling's formula.  (Contributed
       by Glauco Siliprandi, 29-Jun-2017.) $)
    stirlinglem14 $p |- E. c e. RR+ A ~~> c $=
      ( crp wcel ce cfv cc cn a1i co c2 cmul ceu wceq cc0 cvv vd vk cv cli wrex
      wbr cr stirlinglem13 wa simpl rpefcld ccom c1 nnuz cz ccncf efcn clog cfa
      1z wf csqr cdiv cexp cn0 nnnn0 faccl nncn 3syl 2cn mulcld sqrcld epr rpcn
      ax-mp wne 0re epos gtneii divcld expcld 2rp nnrp rpmulcld sqrgt0d gt0ne0d
      nnne0 divne0d nnz expne0d mulne0d fvmpt2 mpdan eqeltrd logcld fmpti simpr
      eqnetrd recnd climcncf wb wtru elexi cmpt nnex mptex eqeltri coex funmpt2
      wfun id crab rabid2 rpsqrcld rpdivcld rpexpcld relogcl elex mprgbir dmmpt
      cdm eqtr4i syl6eleq fvco sylancr fveq2d oveq2d oveq1d oveq12d fvmptd nfcv
      nfmpt1 nfcxfr nffv fveq2 fvmptf eflog syl2anc 3eqtrd adantl climeq rspcev
      trud sylib breq2 rexlimiva ) BUAUCZUDUFZUAUGUEADUCZUDUFZDGUEZABCUAEFUHUUH
      UUKUAUGUUGUGHZUUHUIZUUGIJZGHAUUNUDUFZUUKUUMUUGUULUUHUJZUKUUMIBULZUUNUDUFZ
      UUOUUMKKUUGIBUMLUNUMUOHZUUMUTMIKKUPNZHUUMUQMLKBVAUUMCLKCUCZAJZURJZBFUVALH
      ZUVBUVDUVBUVAUSJZOUVAPNZVBJZUVAQVCNZUVAVDNZPNZVCNZKUVDUVKKHUVBUVKRUVDUVEU
      VJUVDUVAVEHZUVELHZUVEKHUVAVFZUVAVGZUVEVHVIZUVDUVGUVIUVDUVFUVDOUVAOKHZUVDV
      JMUVAVHZVKVLZUVDUVHUVAUVDUVAQUVRQKHZUVDQGHZUVTVMQVNVOZMZQSVPZUVDSQVQVRVSZ
      MZVTZUVNWAZVKZUVDUVGUVIUVSUWHUVDUVGUVDUVFUVDOUVAOGHZUVDWBMUVAWCZWDZWEWFUV
      DUVHUVAUWGUVDUVAQUVRUWCUVAWGUWFWHUVAWIZWJWKZVTZCLUVKKAEWLWMZUWOWNUVDUVBUV
      KSUWPUVDUVEUVJUVPUWIUVDUVLUVMUVESVPUVNUVOUVEWGVIUWNWHWRWOWPMUULUUHWQUUMUU
      GUUPWSWTUURUUOXAXBUUNUBUUQAUMTTLUNUUQTHXBIBIUUTUQXCBCLUVCXDTFCLUVCXEXFXGX
      HMATHXBACLUVKXDZTECLUVKXEXFXGMUUSXBUTMUBUCZLHZUWRUUQJZUWRAJZRXBUWSUWTUWRB
      JZIJZUXAURJZIJZUXAUWSBXJUWRBYAZHUWTUXCRCLUVCBFXIUWSUWRLUXFUWSXKZLUVCTHZCL
      XLZUXFLUXIRUXHCLUXHCLXMUVDUVBGHUVCUGHUXHUVDUVBUVKGUWPUVDUVEUVJUVDUVLUVMUV
      EGHUVNUVOUVEWCVIUVDUVGUVIUVDUVFUWLXNUVDUVHUVAUVDUVAQUWKUWAUVDVMMXOUWMXPWD
      XOWNUVBXQUVCUGXRVIXSCLUVCBFXTYBYCUWRIBYDYEUWSUXBUXDIUWSUXDKHUXBUXDRUWSUXA
      UWSUXAUWRUSJZOUWRPNZVBJZUWRQVCNZUWRVDNZPNZVCNZKUWSCUWRUVKUXPLAKAUWQRUWSEM
      UWSUVAUWRRZUIZUVEUXJUVJUXOVCUXRUVAUWRUSUWSUXQWQZYFUXRUVGUXLUVIUXNPUXRUVFU
      XKVBUXRUVAUWROPUXSYGYFUXRUVHUXMUVAUWRVDUXRUVAUWRQVCUXSYHUXSYIYIYIUXGUWSUX
      JUXOUWSUWRVEHZUXJLHZUXJKHUWRVFZUWRVGZUXJVHVIZUWSUXLUXNUWSUXKUWSOUWRUVQUWS
      VJMUWRVHZVKVLZUWSUXMUWRUWSUWRQUYEUVTUWSUWBMZUWDUWSUWEMZVTZUYBWAZVKZUWSUXL
      UXNUYFUYJUWSUXLUWSUXKUWSOUWRUWJUWSWBMUWRWCWDWEWFUWSUXMUWRUYIUWSUWRQUYEUYG
      UWRWGUYHWHUWRWIWJWKZVTZYJZUYMWNZUWSUXAUXPSUYNUWSUXJUXOUYDUYKUWSUXTUYAUXJS
      VPUYBUYCUXJWGVIUYLWHWRZWOCUWRUVCUXDLBKCUWRYKZCUXAURCURYKCUWRACAUWQECLUVKY
      LYMUYQYNYNUXQUVBUXAURUVAUWRAYOYFFYPWMYFUWSUXAKHUXASVPUXEUXARUYOUYPUXAYQYR
      YSYTUUAUUCUUDUUJUUODUUNGUUIUUNAUDUUEUUBYRUUFVO $.
  $}

  ${
    $d k n $.  $d k ph $.  $d m n $.  $d A k $.  $d C k $.  $d C n $.
    stirlinglem15.1 $e |- F/ n ph $.
    stirlinglem15.2 $e |- S = ( n e. NN0 |-> ( ( sqr ` ( ( 2 x. pi ) x. n ) )
                            x. ( ( n / _e ) ^ n ) ) ) $.
    stirlinglem15.3 $e |- A = ( n e. NN |-> ( ( ! ` n ) / ( ( sqr ` ( 2 x. n
                            ) ) x. ( ( n / _e ) ^ n ) ) ) ) $.
    stirlinglem15.4 $e |- D = ( n e. NN |-> ( A ` ( 2 x. n ) ) ) $.
    stirlinglem15.5 $e |- E = ( n e. NN |-> ( ( sqr ` ( 2 x. n ) ) x. ( ( n /
                            _e ) ^ n ) ) ) $.
    stirlinglem15.6 $e |- V = ( n e. NN |-> ( ( ( ( 2 ^ ( 4 x. n ) ) x. ( ( !
       ` n ) ^ 4 ) ) / ( ( ! ` ( 2 x. n ) ) ^ 2 ) ) / ( ( 2
       x. n ) + 1 ) ) ) $.
    stirlinglem15.7 $e |- F = ( n e. NN |-> ( ( ( A ` n ) ^ 4 ) / ( ( D ` n )
                            ^ 2 ) ) ) $.
    stirlinglem15.8 $e |- H = ( n e. NN |-> ( ( n ^ 2 ) / ( n x. ( ( 2 x. n )
                            + 1 ) ) ) ) $.
    stirlinglem15.9 $e |- ( ph -> C e. RR+ ) $.
    stirlinglem15.10 $e |- ( ph -> A ~~> C ) $.
    $( The Stirling's formula is proven using a number of local definitions.
       The main theorem ~ stirling will use this final lemma, but it will not
       expose the local definitions.  (Contributed by Glauco Siliprandi,
       29-Jun-2017.) $)
    stirlinglem15 $p
      |- ( ph -> ( n e. NN |-> ( ( ! ` n ) / ( S ` n ) ) ) ~~> 1 )
                        $=
  ( vk cn cv cfa cfv cdiv co cmpt c1 cli wcel wa c2 cpi cmul csqr ceu cexp wceq
  cn0 cc nnnn0 adantl 2cn a1i pire mulcld nncn sqrcld ere cc0 wne epos gt0ne0ii
  recni divcld expcld fvmpt2 syl2anc oveq2d mulassd wbr cvv nfmpt1 nfcxfr caddc
  c4 nnuz cz 1z crp faccl syl nnrpd 2rp nnrp rpmulcld rpsqrcld epr rpdivcld nnz
  wf id mpdan eqeltrd mptex sqrgt0d gt0ne0d nnne0 divne0d expne0d mulne0d rpcnd
  eqid nnex sqcld rpne0d ax-1cn cr 0lt1 oveq12d oveq1d 2pos eqtrd fveq2d adantr
  clt cle 3eqtrd 2re 0re ltleii sqrmuld eqcomd mpteq2da simpr nfcv nfov eqbrtrd
  reccld rpexpcld fmpti 2nn nnmulcld ffvelrnd stirlinglem8 eqeltri stirlinglem1
  cmin nncnd 4nn0 addcld nnred 1re nngt0d addgt0d stirlinglem3 eqtr4d wallispi2
  2z climmulf climuni sylancl halfcld recne0d divcan4d divcan7d rprege0d eqtr3d
  div1d 3eqtr3d mulcomd remulcld mulge0d nn0red nn0ge0d mul12d divdiv1d 3eqtr4d
  sqrsq pipos ancli divrec2d 3syl fvmptd fveq2 cbvmpt climmulc2 recid2d breqtrd
  nffv fveq1d ) AFUBFUCZUDUEZUWMEUEZUFUGZUHFUBUWMBUEZCUFUGZUHZUIUJAFUBUWPUWRKAU
  WMUBUKZULZUWPUWNUMUNUOUGZUWMUOUGZUPUEZUWMUQUFUGZUWMURUGZUOUGZUFUGZUWNUMUWMUOU
  GZUPUEZUXFUOUGZUFUGZCUFUGZUWRUXAUWOUXGUWNUFUXAUWMUTUKZUXGVAUKUWOUXGUSUWTUXNAU
  WMVBZVCZUXAUXDUXFUXAUXCUXAUXBUWMUXAUMUNUMVAUKZUXAVDVEZUNVAUKZUXAUNVFVOZVEZVGU
  WTUWMVAUKAUWMVHZVCZVGVIUWTUXFVAUKAUWTUXEUWMUWTUWMUQUYBUQVAUKZUWTUQVJVOZVEZUQV
  KVLZUWTUQVJVMVNZVEZVPZUXOVQZVCZVGFUTUXGVAELVRVSVTUXAUWNUNUPUEZUXJUOUGZUXFUOUG
  ZUFUGUWNUXKCUOUGZUFUGUXHUXMUXAUYOUYPUWNUFUXAUYOUYMUXKUOUGCUXKUOUGUYPUXAUYMUXJ
  UXFUXAUNUYAVIZUWTUXJVAUKAUWTUXIUWTUMUWMUXQUWTVDVEUYBVGZVIZVCZUYLWAUXAUYMCUXKU
  OAUYMCUSUWTACUMURUGZUPUEZUYMCAVUAUNUPAVUAUIUMUFUGZUOUGZVUCUFUGUNUMUFUGZVUCUFU
  GZVUAUNAVUDVUEVUCUFAJVUDUJWBJVUEUJWBVUDVUEUSAVUAVUCFHIJUIWCUBKFHFUBUWQWGURUGZ
  UWMDUEZUMURUGZUFUGZUHQFUBVUJWDWEFIFUBUWMUMURUGZUWMUXIUIWFUGZUOUGZUFUGZUHRFUBV
  UNWDWEFJFUBUMWGUWMUOUGURUGUWNWGURUGUOUGUXIUDUEUMURUGUFUGVULUFUGZUHZPFUBVUOWDW
  EWHUIWIUKAWJVEZABCDFHFUBVUGUHZFUBVUIUHZKFBFUBUXLUHZMFUBUXLWDWEZFDFUBUXIBUEZUH
  NFUBVVBWDWENUBWKBXBZAFUBWKUXLBMUWTUWNUXKUWTUWNUWTUXNUWNUBUKUXOUWMWLWMZWNUWTUX
  JUXFUWTUXIUWTUMUWMUMWKUKZUWTWOVEUWMWPZWQZWRUWTUXEUWMUWTUWMUQVVFUQWKUKUWTWSVEW
  TUWMXAZUUAWQWTUUBZVEQVURXNVUSXNUWTVUHWKUKAUWTVUHVVBWKUWTVVBWKUKVUHVVBUSUWTUBW
  KUXIBVVCUWTVVIVEUWTUMUWMUMUBUKUWTUUCVEUWTXCUUDZUUEZFUBVVBWKDNVRXDVVKXEZVCSTUU
  FJWCUKAJVUPWCPFUBVUOXOXFUUGVEIVUCUJWBAFFUBUIUIVULUFUGZUUIUGUHZFUBVVMUHZIFUBUI
  UWMUFUGUHZRVVNXNVVOXNVVPXNUUHVEUWTUWMHUEZVAUKAUWTVVQVUJVAUWTVUJVAUKVVQVUJUSUW
  TVUGVUIUWTUWQWGUWTUWQUXLVAUWTUXLVAUKZUWQUXLUSZUWTUWNUXKUWTUWNVVDUUJZUWTUXJUXF
  UYSUYKVGZUWTUXJUXFUYSUYKUWTUXJUWTUXIVVGXGXHZUWTUXEUWMUYJUWTUWMUQUYBUYFUWMXIZU
  YIXJVVHXKXLVPZFUBUXLVABMVRZXDVWDXEZWGUTUKUWTUUKVEVQUWTVUHUWTVUHVVLXMZXPUWTVUH
  UMVWGUWTVUHVVLXQUMWIUKUWTUUTVEXKVPZFUBVUJVAHQVRXDZVWHXEVCUWTUWMIUEZVAUKAUWTVW
  JVUNVAUWTVUNVAUKVWJVUNUSUWTVUKVUMUWTUWMUYBXPUWTUWMVULUYBUWTUXIUIUYRUIVAUKZUWT
  XRVEUULZVGUWTUWMVULUYBVWLVWCUWTVULUWTUXIUIUWTUXIVVJUUMUIXSUKUWTUUNVEUWTUXIVVJ
  UUOVKUIYGWBZUWTXTVEUUPXHXLVPZFUBVUNVAIRVRXDZVWNXEVCUWTUWMJUEZVVQVWJUOUGZUSAUW
  TVWPVUJVUNUOUGZVWQUWTVWRVAUKVWPVWRUSUWTVUJVUNVWHVWNVGFUBVWRVAJBDFGJMNOPUUQVRX
  DUWTVVQVUJVWJVUNUOVWIVWOYAUURVCUVAFJPUUSVUDVUEJUVBUVCYBAVUAVUCACACSXMZXPAUIVW
  KAXRVEZUVDAUMUXQAVDVEZAUMVKUMYGWBAYCVEXHZUVEUVFAVUFUNUIUFUGUNAUNUIUMUXSAUXTVE
  ZVWTVXAAUIVWMAXTVEXHVXBUVGAUNVXCUVJYDUVKYEACXSUKVKCYHWBULVUBCUSACSUVHCUVTWMUV
  IYFYBUXACUXKACVAUKZUWTVWSYFZUWTUXKVAUKAVWAVCZUVLYIVTUXAUXGUYOUWNUFUXAUXDUYNUX
  FUOUXAUXDUXBUPUEZUWMUPUEZUOUGZUYNUXAUXBUWMUXAUMUNUMXSUKUXAYJVEZUNXSUKUXAVFVEZ
  UVMUXAUMUNVXJVXKVKUMYHWBUXAVKUMYKYJYCYLVEZVKUNYHWBUXAVKUNYKVFUWAYLVEZUVNUXAUW
  MUXPUVOZUXAUWMUXPUVPZYMUXAVXIUMUPUEZUYMUOUGZVXHUOUGVXPUYMVXHUOUGUOUGZUYNUXAVX
  GVXQVXHUOUXAUMUNVXJVXLVXKVXMYMYBUXAVXPUYMVXHUXAUMUXRVIZUYQUXAUWMUYCVIZWAUXAVX
  RUYMVXPVXHUOUGZUOUGUYNUXAVXPUYMVXHVXSUYQVXTUVQUXAVYAUXJUYMUOUXAUXJVYAUXAUMUWM
  VXJVXLVXNVXOYMYNVTYDYIYDYBVTUXAUWNUXKCUWTUWNVAUKAVVTVCVXFVXEUXAUXJUXFUYTUYLUW
  TUXJVKVLAVWBVCUXAUXEUWMUXAUWMUQUYCUYDUXAUYEVEZUYGUXAUYHVEZVPUXAUWMUQUYCVYBUWT
  UWMVKVLAVWCVCVYCXJUWTUWMWIUKAVVHVCXKXLACVKVLZUWTACSXQZYFZUVRUVSUXAUXLUWQCUFUX
  AUWQUXLUXAUWTVVRULZVVSUWTVYGAUWTVVRVWDUWBVCVWEWMYNYBYIYOAUWSFUBUICUFUGZUWQUOU
  GZUHZUIUJAFUBUWRVYIKUXAUWQCUWTUWQVAUKAVWFVCVXEVYFUWCYOAVYJVYHCUOUGUIUJACVYHUA
  BVYJUIWCUBWHVUQTACVWSVYEYTVYJWCUKAFUBVYIXOXFVEUAUCZUBUKZVYKBUEZVAUKAVYLVYMVYK
  UDUEZUMVYKUOUGZUPUEZVYKUQUFUGZVYKURUGZUOUGZUFUGZVAVYLFVYKUXLVYTUBBVABVUTUSVYL
  MVEVYLUWMVYKUSZULZUWNVYNUXKVYSUFWUBUWMVYKUDVYLWUAYPZYEWUBUXJVYPUXFVYRUOWUBUXI
  VYOUPWUBUWMVYKUMUOWUCVTYEWUBUXEVYQUWMVYKURWUBUWMVYKUQUFWUCYBWUCYAYAYAVYLXCVYL
  VYNVYSVYLVYKUTUKVYNUBUKVYNVAUKVYKVBZVYKWLVYNVHUWDVYLVYPVYRVYLVYOVYLUMVYKUXQVY
  LVDVEVYKVHZVGVIZVYLVYQVYKVYLVYKUQWUEUYDVYLUYEVEZUYGVYLUYHVEZVPZWUDVQZVGVYLVYP
  VYRWUFWUJVYLVYPVYLVYOVYLUMVYKVVEVYLWOVEVYKWPWQXGXHVYLVYQVYKWUIVYLVYKUQWUEWUGV
  YKXIWUHXJVYKXAXKXLVPZUWEWUKXEVCZAVYLULZVYKVYJUEVYKUAUBVYHVYMUOUGZUHZUEZWUNWUM
  VYKVYJWUOVYJWUOUSWUMFUAUBVYIWUNUAVYIYQFVYHVYMUOFUICUFFUIYQFUFYQFCYQYRFUOYQFVY
  KBVVAFVYKYQUWKYRWUAUWQVYMVYHUOUWMVYKBUWFVTUWGVEUWLWUMVYLWUNVAUKWUPWUNUSAVYLYP
  WUMVYHVYMWUMCAVXDVYLVWSYFAVYDVYLVYEYFYTWULVGUAUBWUNVAWUOWUOXNVRVSYDUWHACVWSVY
  EUWIUWJYSYS $.
  $}

  ${
    $d c n $.  $d S c $.
    stirling.1 $e |- S = ( n e. NN0 |-> ( ( sqr ` ( ( 2 x. pi ) x. n ) ) x. ( (
                     n / _e ) ^ n ) ) ) $.
    $( Stirling's approximation formula for ` n ` factorial.  The proof follows
       two major steps: first it is proven that ` S ` and ` n ` factorial are
       asymptotically equivalent, up to an unknown constant.  Then, using
       Wallis' formula for &pi; it is proven that the unknown constant is the
       square root of &pi; and then the exact Stirling's formula is
       established.  (Contributed by Glauco Siliprandi, 29-Jun-2017.) $)
    stirling $p |- ( n e. NN |-> ( ( ! ` n ) / ( S ` n ) ) ) ~~> 1 $=
      ( vc cn cv cfa cfv c2 cmul co cdiv cexp cmpt cli wbr crp c1 eqid c4 caddc
      csqr ceu wrex clog stirlinglem14 wcel wa nfv nfmpt1 nfcv nfbr simpl simpr
      nfan stirlinglem15 rexlimiva ax-mp ) BEBFZGHZIUSJKZUBHUSUCLKUSMKJKZLKZNZD
      FZOPZDQUDBEUTUSAHLKNROPZVDBEUSVDHZUEHNZBDVDSZVISUFVFVGDQVEQUGZVFUHVDVEBEV
      AVDHNZABBEVBNZBEVHTMKUSVLHIMKLKNZBEUSIMKUSVARUAKZJKLKNZBEITUSJKMKUTTMKJKV
      AGHIMKLKVOLKNZVKVFBVKBUIBVDVEOBEVCUJBOUKBVEUKULUOCVJVLSVMSVQSVNSVPSVKVFUM
      VKVFUNUPUQUR $.
  $}

  ${
    stirlingr.1 $e   |- S = ( n e. NN0 |-> ( ( sqr ` ( ( 2 x. pi ) x. n ) ) x.
      ( ( n / _e ) ^ n ) ) ) $.
    stirlingr.2 $e    |- R = ( ~~>t ` ( topGen ` ran (,) ) ) $.
    $( Stirling's approximation formula for ` n ` factorial: here convergence
       is expressed with respect to the standard topology on the reals.  The
       main theorem ~ stirling is proven for convergence in the topology of
       complex numbers.  The variable ` R ` is used to denote convergence with
       respect to the standard topology on the reals.  (Contributed by Glauco
       Siliprandi, 29-Jun-2017.) $)
    stirlingr $p   |- ( n e. NN |-> ( ( ! ` n ) / ( S ` n ) ) ) R 1 $=
      ( cn cfv co c1 wbr wtru wcel a1i cr c2 cpi cmul ceu crp cc0 cfa cdiv cmpt
      cv cli stirling wb nnuz cz 1z wf eqid cn0 nnnn0 faccl nnre 3syl csqr cexp
      wceq 2re pire remulcld 0re clt 2pos ltled ltleii mulge0d nn0ge0d resqrcld
      cle pipos ere wne epos gtneii redivcld reexpcld fvmpt2 syl2anc 2rp elrpii
      rpmulcld nnrp rpsqrcld epr rpdivcld nnz rpexpcld eqeltrd rerpdivcld fmpti
      climreeq trud mpbir ) CFCUDZUAGZWQBGZUBHZUCZIAJZXAIUEJZBCDUFXBXCUGKIAXAIF
      EUHIUILKUJMFNXAUKKCFNWTXAXAULWQFLZWRWSXDWQUMLZWRFLWRNLWQUNZWQUOWRUPUQXDWS
      OPQHZWQQHZURGZWQRUBHZWQUSHZQHZSXDXEXLNLWSXLUTXFXDXIXKXDXHXDXGWQXDOPONLXDV
      AMZPNLXDVBMZVCZWQUPZVCXDXGWQXOXPXDOPXMXNXDTOTNLXDVDMXMTOVEJXDVFMVGTPVLJXD
      TPVDVBVMVHMVIXDWQXFVJVIVKXDXJWQXDWQRXPRNLXDVNMRTVOXDTRVDVPVQMVRXFVSVCCUMX
      LNBDVTWAXDXIXKXDXHXDXGWQXDOPOSLXDWBMPSLXDPVBVMWCMWDWQWEZWDWFXDXJWQXDWQRXQ
      RSLXDWGMWHWQWIWJWDWKWLWMMWNWOWP $.
  $}

$( (End of Glauco Siliprandi's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Saveliy Skresanov
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Ceva's theorem
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    sigar $e |- G = ( x e. CC , y e. CC |->
                          ( Im ` ( ( * ` x ) x. y ) ) ) $.
    $( Define the signed area by treating complex numbers as vectors with two
       components.  (Contributed by Saveliy Skresanov, 19-Sep-2017.) $)
    sigarval $p |- ( ( A e. CC /\ B e. CC )
          -> ( A G B ) = ( Im ` ( ( * ` A ) x. B ) ) ) $=
      ( cc cv ccj cfv cmul co cim wceq wa simpl fveq2d simpr oveq12d fvex
      ovmpt2a ) ABCDGGAHZIJZBHZKLZMJCIJZDKLZMJEUBCNZUDDNZOZUEUGMUJUCUFUDDKUJUBC
      IUHUIPQUHUIRSQFUGMTUA $.

    $( Signed area takes value in reals.  (Contributed by Saveliy Skresanov,
       19-Sep-2017.) $)
    sigarim $p |- ( ( A e. CC /\ B e. CC ) -> ( A G B ) e. RR ) $=
      ( cc wcel wa co ccj cfv cmul cim cr sigarval simpl cjcld simpr mulcld
      imcld eqeltrd ) CGHZDGHZIZCDEJCKLZDMJZNLOABCDEFPUEUGUEUFDUECUCUDQRUCUDSTU
      AUB $.

    $( Signed area is anticommutative.  (Contributed by Saveliy Skresanov,
       19-Sep-2017.) $)
    sigarac $p |- ( ( A e. CC /\ B e. CC ) -> ( A G B ) = -u ( B G A ) ) $=
      ( cc wcel wa co ccj cfv cmul cim cneg sigarval cjcl adantl simpl cjmuld
      simpr cjcjd oveq1d cjcld mulcomd 3eqtrrd fveq2d mulcld 3eqtrd wceq ancoms
      imcjd negeqd eqtr4d ) CGHZDGHZIZCDEJZDKLZCMJZNLZOZDCEJZOUQURCKLZDMJZNLUTK
      LZNLVBABCDEFPUQVEVFNUQVFUSKLZVDMJDVDMJVEUQUSCUPUSGHUODQRZUOUPSZTUQVGDVDMU
      QDUOUPUAZUBUCUQDVDVJUQCVIUDUEUFUGUQUTUQUSCVHVIUHULUIUQVCVAUPUOVCVAUJABDCE
      FPUKUMUN $.

    $( Signed area is additive by the first argument.  (Contributed by Saveliy
       Skresanov, 19-Sep-2017.) $)
    sigaraf $p |- ( ( A e. CC /\ B e. CC /\ C e. CC )
          -> ( ( A + C ) G B ) = ( ( A G B ) + ( C G B ) ) ) $=
      ( cc wcel caddc co ccj cfv cmul cim wceq wa cjcld eqtrd sigarval 3adant2
      w3a cjadd oveq1d simp1 simp3 adddird fveq2d mulcld imaddd syl2anc 3adant3
      simp2 addcld 3simpc ancomd syl oveq12d 3eqtr4d ) CHIZDHIZEHIZUBZCEJKZLMZD
      NKZOMZCLMZDNKZOMZELMZDNKZOMZJKZVDDFKZCDFKZEDFKZJKVCVGVIVLJKZOMVNVCVFVROVC
      VFVHVKJKZDNKZVRUTVBVFVTPVAUTVBQVEVSDNCEUCUDUAVCVHVKDVCCUTVAVBUEZRZVCEUTVA
      VBUFZRZUTVAVBUMZUGSUHVCVIVLVCVHDWBWEUIVCVKDWDWEUIUJSVCVDHIVAVOVGPVCCEWAWC
      UNWEABVDDFGTUKVCVPVJVQVMJUTVAVPVJPVBABCDFGTULVCVBVAQVQVMPVCVAVBUTVAVBUOUP
      ABEDFGTUQURUS $.

    $( Signed area is additive (with respect to subtraction) by the first
       argument.  (Contributed by Saveliy Skresanov, 19-Sep-2017.) $)
    sigarmf $p |- ( ( A e. CC /\ B e. CC /\ C e. CC )
          -> ( ( A - C ) G B ) = ( ( A G B ) - ( C G B ) ) ) $=
      ( cc wcel cmin co ccj cfv cmul cim wceq wa cjcld eqtrd sigarval w3a cjsub
      oveq1d 3adant2 subdird fveq2d mulcld imsubd subcld syl2anc 3adant3 3simpc
      simp1 simp3 simp2 ancomd syl oveq12d 3eqtr4d ) CHIZDHIZEHIZUAZCEJKZLMZDNK
      ZOMZCLMZDNKZOMZELMZDNKZOMZJKZVDDFKZCDFKZEDFKZJKVCVGVIVLJKZOMVNVCVFVROVCVF
      VHVKJKZDNKZVRUTVBVFVTPVAUTVBQVEVSDNCEUBUCUDVCVHVKDVCCUTVAVBUMZRZVCEUTVAVB
      UNZRZUTVAVBUOZUESUFVCVIVLVCVHDWBWEUGVCVKDWDWEUGUHSVCVDHIVAVOVGPVCCEWAWCUI
      WEABVDDFGTUJVCVPVJVQVMJUTVAVPVJPVBABCDFGTUKVCVBVAQVQVMPVCVAVBUTVAVBULUPAB
      EDFGTUQURUS $.

    $( Signed area is additive by the second argument.  (Contributed by Saveliy
       Skresanov, 19-Sep-2017.) $)
    sigaras $p |- ( ( A e. CC /\ B e. CC /\ C e. CC )
          -> ( A G ( B + C ) ) = ( ( A G B ) + ( A G C ) ) ) $=
      ( cc wcel w3a caddc co cneg wceq sigarac syl2anc wa cr ancomd sigarim syl
      simp1 simp2 simp3 addcld sigaraf negeqd 3com12 3simpa recnd 3simpb negdid
      eqtrd eqcomd oveq12d 3eqtrd ) CHIZDHIZEHIZJZCDEKLZFLZVACFLZMZDCFLZMZECFLZ
      MZKLZCDFLZCEFLZKLUTUQVAHIVBVDNUQURUSUBZUTDEUQURUSUCZUQURUSUDZUEABCVAFGOPU
      TVDVEVGKLZMZVIURUQUSVDVPNURUQUSJVCVOABDCEFGUFUGUHUTVEVGUTVEUTURUQQVERIUTU
      QURUQURUSUISABDCFGTUAUJUTVGUTUSUQQVGRIUTUQUSUQURUSUKSABECFGTUAUJULUMUTVFV
      JVHVKKUTVJVFUTUQURVJVFNVLVMABCDFGOPUNUTVKVHUTUQUSVKVHNVLVNABCEFGOPUNUOUP
      $.

    $( Signed area is additive (with respect to subtraction) by the second
       argument.  (Contributed by Saveliy Skresanov, 19-Sep-2017.) $)
    sigarms $p |- ( ( A e. CC /\ B e. CC /\ C e. CC )
          -> ( A G ( B - C ) ) = ( ( A G B ) - ( A G C ) ) ) $=
      ( cc wcel w3a cmin co cneg wceq sigarac syl2anc wa cr ancomd sigarim syl
      simp1 simp2 simp3 subcld negeqd 3com12 3simpa recnd 3simpb caddc negsubdi
      sigarmf simpl negcld simpr subnegd eqtr4d eqtrd eqcomd oveq12d 3eqtrd ) C
      HIZDHIZEHIZJZCDEKLZFLZVGCFLZMZDCFLZMZECFLZMZKLZCDFLZCEFLZKLVFVCVGHIVHVJNV
      CVDVEUBZVFDEVCVDVEUCZVCVDVEUDZUEABCVGFGOPVFVJVKVMKLZMZVOVDVCVEVJWBNVDVCVE
      JVIWAABDCEFGUMUFUGVFVKHIZVMHIZWBVONVFVKVFVDVCQVKRIVFVCVDVCVDVEUHSABDCFGTU
      AUIVFVMVFVEVCQVMRIVFVCVEVCVDVEUJSABECFGTUAUIWCWDQZWBVLVMUKLVOVKVMULWEVLVM
      WEVKWCWDUNUOWCWDUPUQURPUSVFVLVPVNVQKVFVPVLVFVCVDVPVLNVRVSABCDFGOPUTVFVQVN
      VFVCVEVQVNNVRVTABCEFGOPUTVAVB $.

    $( Signed area is linear by the second argument.  (Contributed by Saveliy
       Skresanov, 19-Sep-2017.) $)
    sigarls $p |- ( ( A e. CC /\ B e. CC /\ C e. RR )
          -> ( A G ( B x. C ) ) = ( ( A G B ) x. C ) ) $=
      ( cc wcel cfv cmul cim recnd 3adant1 fveq2d mulcld mulcomd 3eqtr4d wceq
      co cr w3a ccj simp1 cjcld simp2 wa simpr mulassd simp3 immul2d syl eqtr3d
      imcl simpl sigarval syl2anc 3adant3 oveq1d ) CHIZDHIZEUAIZUBZCUCJZDEKTZKT
      ZLJZVDDKTZLJZEKTZCVEFTZCDFTZEKTVCVHEKTZLJZVGVJVCVMVFLVCVDDEVCCUTVAVBUDZUE
      ZUTVAVBUFZVAVBEHIUTVAVBUGZEVAVBUHMZNZUIOVCEVHKTZLJEVIKTVNVJVCEVHUTVAVBUJV
      CVDDVPVQPZUKVCVMWALVCVHEWBVTQOVCVIEVCVHHIZVIHIWBWCVIVHUNMULVTQRUMVCUTVEHI
      ZVKVGSVOVAVBWDUTVRDEVAVBUOVSPNABCVEFGUPUQVCVLVIEKUTVAVLVISVBABCDFGUPURUSR
      $.

    $( Signed area of a flat parallelogram is zero.  (Contributed by Saveliy
       Skresanov, 20-Sep-2017.) $)
    sigarid $p |- ( A e. CC -> ( A G A ) = 0 ) $=
      ( cc wcel co ccj cfv cmul cim cc0 wceq sigarval anidms cr cjcl id mulcomd
      cjmulrcl eqeltrd reim0d eqtrd ) CFGZCCDHZCIJZCKHZLJZMUEUFUINABCCDEOPUEUHU
      EUHCUGKHQUEUGCCRUESTCUAUBUCUD $.

    $( Expand the signed area formula by linearity.  (Contributed by Saveliy
       Skresanov, 20-Sep-2017.) $)
    sigarexp $p |- ( ( A e. CC /\ B e. CC /\ C e. CC )
  -> ( ( A - C ) G ( B - C ) ) = ( ( ( A G B ) - ( A G C ) ) - ( C G B ) ) ) $=
      ( cc wcel w3a cmin co wceq simp2 simp3 subcld sigarms cc0 oveq2d 3eqtrd
      sigarmf syld3an2 oveq1d syld3an1 sigarid wa sigarim recnd syl2anc subid1d
      syl ) CHIZDHIZEHIZJZCEKLDEKLZFLZCUPFLZEUPFLZKLZCDFLCEFLKLZUSKLVAEDFLZKLUL
      UPHIUMUNUQUTMUODEULUMUNNZULUMUNOZPABCUPEFGUAUBUOURVAUSKABCDEFGQUCUOUSVBVA
      KUOUSVBEEFLZKLZVBRKLVBUNUMULUNUSVFMVDABEDEFGQUDUOVERVBKUOUNVERMVDABEFGUEU
      KSUOVBUOUNUMVBHIVDVCUNUMUFVBABEDFGUGUHUIUJTST $.

    $( Signed area ` ( A - C ) G ( B - C ) ` acts as a double area of a
       triangle ` A B C ` .  Here we prove that cyclically permuting the
       vertices doesn't change the area.  (Contributed by Saveliy Skresanov,
       20-Sep-2017.) $)
    sigarperm $p |- ( ( A e. CC /\ B e. CC /\ C e. CC )
          -> ( ( A - C ) G ( B - C ) ) = ( ( B - A ) G ( C - A ) ) ) $=
      ( cc wcel co cmin caddc cneg wa sigarim recnd syl2anc negsubd wceq cr w3a
      simp2 simp3 sigarac eqcomd oveq2d eqtr3d oveq1d sigarexp addcomd 3eqtr2rd
      simp1 3comr sub32d 3eqtrd 3eqtr4rd ) CHIZDHIZEHIZUAZDEFJZDCFJZKJZCEFJZKJZ
      VACDFJZLJZVDKJZDCKJECKJFJZCEKJDEKJFJZUTVCVGVDKUTVAVBMZLJVCVGUTVAVBUTURUSV
      AHIUQURUSUBZUQURUSUCZURUSNVAABDEFGOPQZUTURUQVBHIVLUQURUSULZURUQNVBABDCFGO
      PQRUTVKVFVALUTVFVKUTUQURVFVKSVOVLABCDFGUDQUEUFUGUHURUSUQVIVESABDECFGUIUMU
      TVJVFVDKJEDFJZKJVFVPKJZVDKJVHABCDEFGUIUTVFVDVPUTVFUTUQURVFTIVOVLABCDFGOQP
      ZUTVDUTUQUSVDTIVOVMABCEFGOQPUTVPUTUSURVPTIVMVLABEDFGOQPZUNUTVQVGVDKUTVGVF
      VALJVFVPMZLJVQUTVAVFVNVRUJUTVTVAVFLUTVAVTUTURUSVAVTSVLVMABDEFGUDQUEUFUTVF
      VPVRVSRUKUHUOUP $.

    sigardiv.a $e |- ( ph -> ( A e. CC /\ B e. CC /\ C e. CC ) ) $.
    sigardiv.b $e |- ( ph -> -. C = A ) $.
    sigardiv.c $e |- ( ph -> ( ( B - A ) G ( C - A ) ) = 0 ) $.
    $( If signed area between vectors ` B - A ` and ` C - A ` is zero, then
       those vectors lie on the same line.  (Contributed by Saveliy Skresanov,
       22-Sep-2017.) $)
    sigardiv $p |- ( ph -> ( ( B - A ) / ( C - A ) ) e. RR ) $=
      ( co cdiv ccj cfv cr cc wcel cmul eqeltrrd simp2d simp1d subcld divcan5rd
      cmin simp3d neneqad subne0d cjdivd cjne0d mulcld cim cc0 sigarval syl2anc
      cjcld wceq eqtr3d reim0bd mulcomd cjmulrcld mulne0d redivcld cjred divcld
      eqeltrd cjcjd ) AEDUELZFDUELZMLZNOZVJPAVKNOVKVJAVKAVKVHNOZVINOZMLZPAVHVIA
      EDADQRZEQRZFQRZIUAAVOVPVQIUBZUCZAFDAVOVPVQIUFZVRUCZAFDVTVRAFDJUGUHZUIAVLV
      ISLZVMVISLZMLVNPAVLVMVIAVHVSUPZAVIWAUPZWAAVIWAWBUJZWBUDAWCWDAWCAVLVIWEWAU
      KAVHVIGLZWCULOZUMAVHQRVIQRWHWIUQVSWABCVHVIGHUNUOKURUSAVIVMSLWDPAVIVMWAWFU
      TAVIWAVATAVMVIWFWAWGWBVBVCTVFZVDAVJAVHVIVSWAWBVEVGURWJT $.
  $}

  ${
    $d x y A $.  $d x y B $.
    sigarimcd.sigar $e |- G = ( x e. CC , y e. CC |->
                          ( Im ` ( ( * ` x ) x. y ) ) ) $.
    sigarimcd.a $e |- ( ph -> ( A e. CC /\ B e. CC ) ) $.
    $( Signed area takes value in complex numbers.  Deduction version.
       (Contributed by Saveliy Skresanov, 23-Sep-2017.) $)
    sigarimcd $p |- ( ph -> ( A G B ) e. CC ) $=
      ( cc wcel wa co sigarim recnd syl ) ADIJEIJKZDEFLZIJHPQBCDEFGMNO $.

    sigariz.a $e |- ( ph -> ( A G B ) = 0 ) $.
    $( If signed area is zero, the signed area with swapped arguments is also
       zero.  Deduction version.  ( Contributed by Saveliy Skresanov,
       23-Sep-2017.)  (Contributed by Saveliy Skresanov, 24-Sep-2017.) $)
    sigariz $p |- ( ph -> ( B G A ) = 0 ) $=
      ( cc0 cneg co cc wcel wa wceq sigarac syl eqtr3d negeqd sigarimcd negnegd
      neg0 a1i ancomd 3eqtr3rd ) AJKZEDFLZKZKJUHAJUIADEFLZJUIIADMNZEMNZOUJUIPHB
      CDEFGQRSTUGJPAUCUDAUHABCEDFGAUKULHUEUAUBUF $.
  $}

  ${
    $d t x y A $.  $d t x y B $.  $d t x y C $.  $d t G $.  $d t ph $.
    sigarcol.sigar $e |- G
        = ( x e. CC , y e. CC |-> ( Im ` ( ( * ` x ) x. y ) ) ) $.
    sigarcol.a $e |- ( ph -> ( A e. CC /\ B e. CC /\ C e. CC ) ) $.
    sigarcol.b $e |- ( ph -> -. A = B ) $.
    $( Given three points ` A ` , ` B ` and ` C ` such that ` -. A = B ` , the
       point ` C ` lies on the line going through ` A ` and ` B ` iff the
       corresponding signed area is zero.  That justifies the usage of signed
       area as a collinearity indicator.  (Contributed by Saveliy Skresanov,
       22-Sep-2017.) $)
    sigarcol $p |- ( ph -> ( ( ( A - C ) G ( B - C ) ) = 0
          <-> E. t e. RR C = ( B + ( t x. ( A - B ) ) ) ) ) $=
      ( cmin co cc0 wceq cmul caddc wcel cc adantr cv cr wrex w3a simp2d simp3d
      wa cdiv simp1d 3jca wn sigarperm syl eqtrd eqeq1d biimpa sigardiv neneqad
      subcld subne0d divcan1d oveq2d pncan3d eqtr2d oveq1 eqeq2d rspcev syl2anc
      ex 3ad2ant1 simp3 oveq1d simp2 recnd pncan2d mulcomd cneg sigarac sigarls
      mulcld syl3anc sigarid mul02d 3eqtrd negeqd neg0 a1i rexlimdv3a impbid )
      AEGLMFGLMHMZNOZGFDUAZEFLMZPMZQMZOZDUBUCZAWKWQAWKUGZGFLMZWMUHMZUBRGFWTWMPM
      ZQMZOZWQWRBCFGEHIAFSRZGSRZESRZUDZWKAXDXEXFAXFXDXEJUEZAXFXDXEJUFZAXFXDXEJU
      IZUJZTAEFOUKWKKTZAWKWSWMHMZNOAWJXMNAWJFELMGELMHMZXMAXFXDXEUDWJXNOJBCEFGHI
      ULUMAXGXNXMOXKBCFGEHIULUMUNZUOUPUQWRXBFWSQMGWRXAWSFQWRWSWMAWSSRWKAGFXIXHU
      STAWMSRZWKAEFXJXHUSTWREFAXFWKXJTAXDWKXHTZWREFXLURUTVAVBWRFGXQAXEWKXITVCVD
      WPXCDWTUBWLWTOZWOXBGXRWNXAFQWLWTWMPVEVBVFVGVHVIAWPWKDUBAWLUBRZWPUDZWJXMWM
      WLPMZWMHMZNAXSWJXMOWPXOVJXTXMWNWMHMYBXTWSWNWMHXTWSWOFLMWNXTGWOFLAXSWPVKVL
      XTFWNAXSXDWPXHVJZXTWLWMXTWLAXSWPVMZVNZXTEFAXSXFWPXJVJYCUSZVTVOUNVLXTWNYAW
      MHXTWLWMYEYFVPVLUNXTYBWMYAHMZVQZNVQZNXTYASRXPYBYHOXTWMWLYFYEVTYFBCYAWMHIV
      RVHXTYGNXTYGWMWMHMZWLPMZNWLPMNXTXPXPXSYGYKOYFYFYDBCWMWMWLHIVSWAXTYJNWLPXT
      XPYJNOYFBCWMHIWBUMVLXTWLYEWCWDWEYINOXTWFWGWDWDWHWI $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.
    sharhght.sigar $e |- G
        = ( x e. CC , y e. CC |-> ( Im ` ( ( * ` x ) x. y ) ) ) $.
    sharhght.a $e |- ( ph -> ( A e. CC /\ B e. CC /\ C e. CC ) ) $.
    sharhght.b $e |- ( ph -> ( D e. CC /\ ( ( A - D ) G ( B - D ) ) = 0 ) ) $.
    $( Let ` A B C ` be a triangle, and let ` D ` lie on the line ` A B ` .
       Then (doubled) areas of triangles ` A D C ` and ` C D B ` relate as
       lengths of corresponding bases ` A D ` and ` D B ` .  (Contributed by
       Saveliy Skresanov, 23-Sep-2017.) $)
    sharhght $p |- ( ph -> ( ( ( C - A ) G ( D - A ) ) x. ( B - D ) )
          = ( ( ( C - B ) G ( D - B ) ) x. ( A - D ) ) ) $=
      ( wceq cmin co cmul cc0 cc wcel subcld adantr wa cr simp3d simp1d sigarim
      simpld syl2anc recnd mul01d simp2d simpr subeq0bd oveq2d ccj cfv sigarval
      cim eqcomd cjcld eqtrd fveq2d 0re a1i reim0d 3eqtrd oveq1d mul02d 3eqtr4d
      wn cdiv caddc npncand sigaraf syl3anc eqtr3d sigarperm addid1d 3eqtr2d c1
      simprd cneg negsubdi2d neneqad subne0d dividd negeqd mulm1d 3jca sigardiv
      divnegd div32d sigarls divcld mulassd divcan1d pm2.61dan ) AEGLZFDMNZGDMN
      ZHNZEGMNZONZFEMNZGEMNZHNZDGMNZONZLAWQUAZWTPONPXBXGXHWTXHWTXHWRQRZWSQRZWTU
      BRAXIWQAFDADQRZEQRZFQRZJUCZAXKXLXMJUDZSTAXJWQAGDAGQRZXFXAHNZPLZKUFZXOSZTB
      CWRWSHIUEUGUHUIXHXAPWTOXHEGAXLWQAXKXLXMJUJZTAWQUKZULUMXHXGPXFONPXHXEPXFOX
      HXEXCUNUOZXDONZUQUOZPUQUOPXHXCQRZXDQRZXEYELAYFWQAFEXNYASTZAYGWQAGEXSYASTB
      CXCXDHIUPUGXHYDPUQXHYDYCPONPXHXDPYCOXHGEAXPWQXSTZXHEGYBURULUMXHYCXHXCYHUS
      UIUTVAXHPPUBRXHVBVCVDVEVFXHXFXHDGAXKWQXOTYISVGUTVHAWQVIZUAZXBXEXFXAVJNZON
      ZXAONXEYLXAONZONXGYKWTYMXAOYKWTXCWSHNZXCXDYLONZHNZYMYKWTYOEDMNZWSHNZVKNZY
      OPVKNYOYKXCYRVKNZWSHNZWTYTYKUUAWRWSHYKFEDAXMYJXNTZAXLYJYATZAXKYJXOTZVLVFY
      KYFXJYRQRUUBYTLYKFEUUCUUDSZAXJYJXTTZYKEDUUDUUESBCXCWSYRHIVMVNVOYKPYSYOVKY
      KXQPYSAXRYJAXPXRKVTTZYKXKXLXPXQYSLUUEUUDAXPYJXSTZBCDEGHIVPVNVOUMYKYOYKYOY
      KYFXJYOUBRUUFUUGBCXCWSHIUEUGUHVQVRYKWSYPXCHYKXDXAVJNZXFONZWSYPYKUUKVSWAZX
      FONXFWAWSYKUUJUULXFOYKUUJXAWAZXAVJNXAXAVJNZWAUULYKXDUUMXAVJYKUUMXDYKEGUUD
      UUIWBURVFYKXAXAYKEGUUDUUISZUUOYKEGUUDUUIYKEGAYJUKZWCWDZWJYKUUNVSYKXAUUOUU
      QWEWFVRVFYKXFYKDGUUEUUISZWGYKDGUUEUUIWBVEYKXDXAXFYKGEUUIUUDSZUUOUURUUQWKV
      OUMYKYFYGYLUBRYQYMLUUFUUSYKBCGDEHIYKXPXKXLUUIUUEUUDWHUUPUUHWIBCXCXDYLHIWL
      VNVEVFYKXEYLXAYKYFYGXEQRUUFUUSYFYGUAXEBCXCXDHIUEUHUGYKXFXAUURUUOUUQWMUUOW
      NYKYNXFXEOYKXFXAUURUUOUUQWOUMVEWP $.

    $( Subtracting (double) area of ` A D C ` from ` A B C ` yields the
       (double) area of ` D B C ` .  (Contributed by Saveliy Skresanov,
       23-Sep-2017.) $)
    sigaradd $p |- ( ph -> ( ( ( B - C ) G ( A - C ) )
              - ( ( D - C ) G ( A - C ) ) ) = ( ( B - C ) G ( D - C ) ) ) $=
      ( cmin co cc0 cc wcel wceq subcld cneg c1 simp1d nnncan1d sigarms syl3anc
      simp3d simpld oveq2d simp2d eqtr3d sigarac syl2anc simprd negeqd jca neg0
      sigarimcd negnegd 3eqtr3d subid1d 3eqtrd nnncan2d oveq1d sigarmf 3eqtr2rd
      a1i cmul cr 1re renegcld sigarls mulm1d ax-1cn mulcomd negsubdi2d 3eqtr4d
      negcld sigarperm ) AEFLMZDFLMZHMGFLMZVSHMLMZEGLMZVTHMZFGLMZWBHMZVRVTHMZAW
      CWBVSHMZVRVTLMZVSHMZWAAWCWGWBDGLMZHMZLMZWGNLMWGAWBVSWJLMZHMZWCWLAWMVTWBHA
      DFGADOPZEOPZFOPZJUAZAWOWPWQJUEZAGOPZWJWBHMZNQZKUFZUBUGAWBOPZVSOPZWJOPZWNW
      LQAEGAWOWPWQJUHZXCRZADFWRWSRZADGWRXCRZBCWBVSWJHIUCUDUIAWKNWGLAWKSZSNSZWKN
      AXKNAXAXKNAXFXDXAXKQXJXHBCWJWBHIUJUKAWTXBKULUIUMAWKABCWBWJHIAXDXFXHXJUNUP
      UQXLNQAUOVEURUGAWGABCWBVSHIAXDXEXHXIUNUPUSUTAWHWBVSHAEGFXGXCWSVAVBAVROPXE
      VTOPWIWAQAEFXGWSRXIAGFXCWSRBCVRVSVTHIVCUDVDAWBWDTSZVFMZHMZWBWDHMZXMVFMZWC
      WEAXDWDOPZXMVGPXOXQQXHAFGWSXCRZATTVGPAVHVEVIBCWBWDXMHIVJUDAXNVTWBHAXMWDVF
      MWDSXNVTAWDXSVKAXMWDATTOPAVLVEVPZXSVMAFGWSXCVNURUGAXMXPVFMXPSZXQWEAXPABCW
      BWDHIAXDXRXHXSUNUPZVKAXPXMYBXTVMAXRXDWEYAQXSXHBCWDWBHIUJUKVOURAWQWPWTWEWF
      QWSXGXCBCFEGHIVQUDUT $.
  $}

  ${
    cevathlem1.a $e |- ( ph -> ( A e. CC /\ B e. CC /\ C e. CC ) ) $.
    cevathlem1.b $e |- ( ph -> ( D e. CC /\ E e. CC /\ F e. CC ) ) $.
    cevathlem1.c $e |- ( ph -> ( G e. CC /\ H e. CC /\ K e. CC ) ) $.
    cevathlem1.d $e |- ( ph -> ( A =/= 0 /\ E =/= 0 /\ C =/= 0 ) ) $.
    cevathlem1.e $e |- ( ph -> ( ( A x. B ) = ( C x. D ) /\ ( E x. F )
        = ( A x. G ) /\ ( C x. H ) = ( E x. K ) ) ) $.
    $( Ceva's theorem first lemma.  Multiplies three identities and divides by
       the common factors.  (Contributed by Saveliy Skresanov, 24-Sep-2017.) $)
    cevathlem1 $p |- ( ph -> ( ( B x. F ) x. H ) = ( ( D x. G ) x. K ) ) $=
      ( cmul co cc wcel mulcld simp2d simp3d cc0 wne mulne0d wceq oveq12d mul4d
      simp1d 3eqtr3d mul32d mulcomd oveq1d eqtrd eqtr4d mulcanad ) ACGPQZIPQZEH
      PQZJPQZBFPQZDPQZAUQIACGABRSZCRSZDRSZKUAZAERSZFRSZGRSZLUBZTZAHRSZIRSZJRSZM
      UAZTAUSJAEHAVGVHVILUIZAVLVMVNMUIZTZAVLVMVNMUBZTAVADABFAVCVDVEKUIZAVGVHVIL
      UAZTZAVCVDVEKUBZTAVADWBWCABFVTWAABUCUDZFUCUDZDUCUDZNUIAWDWEWFNUAUEAWDWEWF
      NUBUEAVBURPQZDBPQZFPQZUTPQZVBUTPQAVAUQPQZDIPQZPQWHUSPQZFJPQZPQWGWJAWKWMWL
      WNPABCPQZFGPQZPQDEPQZBHPQZPQWKWMAWOWQWPWRPAWOWQUFZWPWRUFZWLWNUFZOUIAWSWTX
      AOUAUGABCFGVTVFWAVJUHADEBHWCVPVTVQUHUJAWSWTXAOUBUGAVAUQDIWBVKWCVOUHAWHUSF
      JADBWCVTTVRWAVSUHUJAVBWIUTPAVBBDPQZFPQWIABFDVTWAWCUKAXBWHFPABDVTWCULUMUNU
      MUOUP $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y D $.  $d x y O $.
    $d x y E $.  $d x y F $.
    cevath.sigar $e |- G
        = ( x e. CC , y e. CC |-> ( Im ` ( ( * ` x ) x. y ) ) ) $.
    cevath.a $e |- ( ph -> ( A e. CC /\ B e. CC /\ C e. CC ) ) $.
    cevath.b $e |- ( ph -> ( F e. CC /\ D e. CC /\ E e. CC ) ) $.
    cevath.c $e |- ( ph -> O e. CC ) $.
    cevath.d $e |- ( ph -> ( ( ( A - O ) G ( D - O ) ) = 0
       /\ ( ( B - O ) G ( E - O ) ) = 0 /\ ( ( C - O ) G ( F - O ) ) = 0 ) ) $.
    cevath.e $e |- ( ph -> ( ( ( A - F ) G ( B - F ) ) = 0
       /\ ( ( B - D ) G ( C - D ) ) = 0 /\ ( ( C - E ) G ( A - E ) ) = 0 ) ) $.
    cevath.f $e |- ( ph -> ( ( ( A - O ) G ( B - O ) ) =/= 0
   /\ ( ( B - O ) G ( C - O ) ) =/= 0 /\ ( ( C - O ) G ( A - O ) ) =/= 0 ) ) $.
    $( Ceva's theorem second lemma.  Relate (doubled) areas of triangles
       ` C A O ` and ` A B O ` with of segments ` B D ` and ` D C ` .
       (Contributed by Saveliy Skresanov, 24-Sep-2017.) $)
    cevathlem2 $p |- ( ph -> ( ( ( C - O ) G ( A - O ) ) x. ( B - D ) )
          = ( ( ( A - O ) G ( B - O ) ) x. ( D - C ) ) ) $=
      ( cmin co cmul cneg wcel simp2d simp1d 3jca cc0 wceq jca sigariz sigaradd
      cc subcld sigarperm syl3anc eqtr4d oveq1d sigarimcd simp3d subdird eqtr3d
      sharhght oveq12d cr sigarim syl2anc recnd 3eqtrrd sigarac mulneg12 oveq2d
      negsubdi2d eqtrd 3eqtrd ) AFKSTZDKSTZJTZEGSTZUATZEKSTZVPJTZFGSTZUATZVPVTJ
      TZUBZWBUATZWDGFSTZUATZAWCDESTZGESTZJTZWBUATZKESTZWJJTZWBUATZSTZDFSTZWGJTZ
      VRUATZKFSTZWGJTZVRUATZSTZVSAWKWNSTZWBUATWCWPAXDWAWBUAAXDWIWMJTZWAABCGDEKJ
      LAGULUCZDULUCZEULUCZAIULUCXFHULUCNUDZAXGXHFULUCZMUEZAXGXHXJMUDZUFAKULUCZG
      KSTZVPJTUGUHOABCVPXNJLAVPULUCZXNULUCADKXKOUMZAGKXIOUMUIAVPXNJTUGUHVTHKSTJ
      TUGUHVOIKSTJTUGUHPUEUJUIZUKAXHXGXMWAXEUHXLXKOBCEDKJLUNUOUPUQAWKWNWBABCWIW
      JJLAWIULUCWJULUCZADEXKXLUMAGEXIXLUMZUIURABCWMWJJLAWMULUCXRAKEOXLUMXSUIURA
      FGAXGXHXJMUSZXIUMZUTVAAWLWSWOXBSABCEFDGJLAXHXJXGXLXTXKUFAXFVRWBJTUGUHZXIA
      DISTEISTJTUGUHYBFHSTDHSTJTUGUHQUDUIZVBABCEFKGJLAXHXJXMXLXTOUFYCVBVCAWRXAS
      TZVRUATXCVSAWRXAVRAWRAWQULUCWGULUCZWRVDUCADFXKXTUMAGFXIXTUMZBCWQWGJLVEVFV
      GABCWTWGJLAWTULUCYEAKFOXTUMYFUIURAEGXLXIUMUTAYDVQVRUAAYDWQWTJTZVQABCGDFKJ
      LAXFXGXJXIXKXTUFXQUKAXJXGXMVQYGUHXTXKOBCFDKJLUNUOUPUQVAVHAWAWEWBUAAVTULUC
      ZXOWAWEUHAEKXLOUMZXPBCVTVPJLVIVFUQAWFWDWBUBZUATZWHAWDULUCWBULUCWFYKUHABCV
      PVTJLAXOYHXPYIUIURYAWDWBVJVFAYJWGWDUAAFGXTXIVLVKVMVN $.


    $( Ceva's theorem.  Let ` A B C ` be a triangle and let points ` F ` ,
       ` D ` and ` E ` lie on sides ` A B ` , ` B C ` , ` C A `
       correspondingly.  Suppose that cevians ` A D ` , ` B E ` and ` C F `
       intersect at one point ` O ` .  Then triangle's sides are partitioned
       into segments and their lengths satisfy a certain identity.  Here we
       obtain a bit stronger version by using complex numbers themselves
       instead of their absolute values.

       The proof goes by applying ~ cevathlem2 three times and then using
       ~ cevathlem1 to multiply obtained identities and prove the theorem.

       In the theorem statement we are using function ` G ` as a collinearity
       indicator.  For justification of that use, see ~ sigarcol .
       (Contributed by Saveliy Skresanov, 24-Sep-2017.) $)
    cevath $p |- ( ph -> ( ( ( A - F ) x. ( C - E ) ) x. ( B - D ) )
          = ( ( ( F - B ) x. ( E - A ) ) x. ( D - C ) ) ) $=
      ( co cc cmin wcel simp2d subcld simp3d jca sigarimcd simp1d 3jca cc0 cmul
      wne wceq cevathlem2 cevathlem1 ) AEKUASZFKUASZJSZDIUASZUQDKUASZJSZIEUASZU
      TUPJSZFHUASZHDUASZEGUASZGFUASZAURTUBUSTUBVATUBABCUPUQJLAUPTUBZUQTUBZAEKAD
      TUBZETUBZFTUBZMUCZOUDZAFKAVJVKVLMUEZOUDZUFUGADIAVJVKVLMUHZAITUBZGTUBZHTUB
      ZNUHZUDABCUQUTJLAVIUTTUBZVPADKVQOUDZUFUGUIAVBTUBVCTUBVDTUBAIEWAVMUDABCUTU
      PJLAWBVHWCVNUFUGAFHVOAVRVSVTNUEZUDUIAVETUBVFTUBVGTUBAHDWDVQUDAEGVMAVRVSVT
      NUCZUDAGFWEVOUDUIAURUJULZVCUJULZVAUJULZAWGWFWHRUCZAWGWFWHRUHZAWGWFWHRUEZU
      IAURUSUKSVAVBUKSUMVCVDUKSURVEUKSUMVAVFUKSVCVGUKSUMABCFDEIGHJKLAVLVJVKVOVQ
      VMUIAVTVRVSWDWAWEUIOAUQIKUASJSUJUMZUTGKUASJSUJUMZUPHKUASJSUJUMZAWMWNWLPUE
      ZAWMWNWLPUHZAWMWNWLPUCZUIAVDDHUASJSUJUMZUSEIUASJSUJUMZVFFGUASJSUJUMZAWSWT
      WRQUEZAWSWTWRQUHZAWSWTWRQUCZUIAWHWGWFWKWJWIUIUNABCEFDHIGJKLAVKVLVJVMVOVQU
      IAVSVTVRWEWDWAUIOAWNWLWMWQWOWPUIAWTWRWSXCXAXBUIAWFWHWGWIWKWJUIUNABCDEFGHI
      JKLMNOPQRUNUIUO $.
  $}

$( (End of Saveliy Skresanov's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Jarvin Udandy
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

  $( Table of Contents [ Search Code: pyY6vpz5mecT2rh9 ]
   Table of Contents for MathBox

   Note: All search codes are randomly generated strings.

   0| Table of Contents [ Search Code: pyY6vpz5mecT2rh9 ]
   1| Preface for Mathbox [ Search Code: gmFp93ENa4XAkymc ]
   2| Main Section [ Search Code: MnBcpxXHRCLsx9Bj ]
    -Propositional Calculus
   3| Experimental Section [ Search Code: 6hFY3NX45ggpE7Hx ]
        -Propositional Calculus
    - ?

  $)

  $( PREFACE FOR MATHBOX [ Search Code: gmFp93ENa4XAkymc ]

    Aim: Prove interesting results, personally meaningful results, or
    supplement set.mm as much as possible.


    The order of declaring things:
    variables, wffs, constants, definitions, followed by
    broad-use-formulas, and lastly more subject-specific results.

    Occasionally grouping like-formulas
    when sensible.


  $)


  $( BEGIN MAIN SECTION [ Search Code: MnBcpxXHRCLsx9Bj ]
   This section of the mathbox is for official results.
  $)

  $v jph $.  $( jarvin Greek phi $)
  $v jps $.  $( jarvin Greek psi $)
  $v jch $.  $( jarvin Greek chi $)
  $v jth $.  $( jarvin Greek theta $)
  $v jta $.  $( jarvin Greek tau $)
  $v jet $.  $( jarvin Greek eta $)
  $v jze $.  $( jarvin Greek zeta $)
  $v jsi $.  $( jarvin Greek sigma $)
  $v jrh $.  $( jarvin Greek rho $)
  $v jmu $.  $( jarvin Greek mu $)
  $v jla $.  $( jarvin Greek lambda $)

  $( Let variable ` jph ` be a wff. $)
  wjph $f wff jph $.
  $( Let variable ` jps ` be a wff. $)
  wjps $f wff jps $.
  $( Let variable ` jch ` be a wff. $)
  wjch $f wff jch $.
  $( Let variable ` jth ` be a wff. $)
  wjth $f wff jth $.
  $( Let variable ` jta ` be a wff. $)
  wjta $f wff jta $.
  $( Let variable ` jet ` be a wff. $)
  wjet $f wff jet $.
  $( Let variable ` jze ` be a wff. $)
  wjze $f wff jze $.
  $( Let variable ` jsi ` be a wff. $)
  wjsi $f wff jsi $.
  $( Let variable ` jrh ` be a wff. $)
  wjrh $f wff jrh $.
  $( Let variable ` jmu ` be a wff. $)
  wjmu $f wff jmu $.
  $( Let variable ` jla ` be a wff. $)
  wjla $f wff jla $.


  $( The third axiom of a system called "L" but proven to be a theorem since
     set.mm uses a different third axiom.  This is named hirst after Holly P.
     Hirst and Jeffry L. Hirst.  Axiom A3 of [Mendelson] p. 35.  (Contributed
     by Jarvin Udandy, 7-Feb-2015.)  (Proof modification is discouraged.) $)
  hirstL-ax3 $p |- ( ( -. ph -> -. ps ) -> ( ( -. ph -> ps ) -> ph ) ) $=
    ( wn wi wo pm4.64 pm4.66 pm2.64 com12 sylbi syl5bi ) ACZBDABEZLBCZDZAABFOAN
    EZMADABGMPAABHIJK $.

  $( Recovery of ~ ax-3 from ~ hirstL-ax3 .  (Contributed by Jarvin Udandy,
     3-Jul-2015.) $)
  ax3h $p |- ( ( -. ph -> -. ps ) -> ( ps -> ph ) ) $=
    ( ax-3 ) ABC $.

  $( A closed form showing (a implies b and b implies a) same-as (a same-as b)
     (Contributed by Jarvin Udandy, 3-Sep-2016.) $)
  aibandbiaiffaiffb $p |- ( ( ( ph -> ps ) /\ ( ps -> ph ) ) <->
( ph <-> ps ) ) $=
    ( wb wi wa dfbi2 bicomi ) ABCABDBADEABFG $.

  $( A closed form showing (a implies b and b implies a) implies (a same-as b)
     (Contributed by Jarvin Udandy, 3-Sep-2016.) $)
  aibandbiaiaiffb $p |- ( ( ( ph -> ps ) /\ ( ps -> ph ) ) ->
( ph <-> ps ) ) $=
    ( wb wi wa dfbi2 biimpri ) ABCABDBADEABFG $.


  ${
    notatnand.1 $e |- -. ph $.
    $( Do not use.  Use intnanr instead.  Given not a, there exists a proof for
       not (a and b).  (Contributed by Jarvin Udandy, 31-Aug-2016.) $)
    notatnand $p |- -. ( ph /\ ps ) $=
      ( intnanr ) ABCD $.
  $}

  ${
    aistia.1 $e |- ( ph <-> T. ) $.
    $( Given a is equivalent to T., there exists a proof for a.  (Contributed
       by Jarvin Udandy, 30-Aug-2016.) $)
    aistia $p |- ph $=
      ( wtru wb tbtru mpbir ) AACDBAEF $.
  $}

  ${
    aisfina.1 $e |- ( ph <-> F. ) $.
    $( Given a is equivalent to F., there exists a proof for not a.
       (Contributed by Jarvin Udandy, 30-Aug-2016.) $)
    aisfina $p |- -. ph $=
      ( wn wfal wb nbfal mpbir ) ACADEBAFG $.
  $}

  ${
    bothtbothsame.1 $e |- ( ph <-> T. ) $.
    bothtbothsame.2 $e |- ( ps <-> T. ) $.
    $( Given both a,b are equivalent to T., there exists a proof for a is the
       same as b.  (Contributed by Jarvin Udandy, 31-Aug-2016.) $)
    bothtbothsame $p |- ( ph <-> ps ) $=
      ( wtru bitr4i ) AEBCDF $.
  $}

  ${
    bothfbothsame.1 $e |- ( ph <-> F. ) $.
    bothfbothsame.2 $e |- ( ps <-> F. ) $.
    $( Given both a,b are equivalent to F., there exists a proof for a is the
       same as b.  (Contributed by Jarvin Udandy, 31-Aug-2016.) $)
    bothfbothsame $p |- ( ph <-> ps ) $=
      ( wfal bitr4i ) AEBCDF $.
  $}

  ${
    aiffbbtat.1 $e |- ( ph <-> ps ) $.
    aiffbbtat.2 $e |- ( ps <-> T. ) $.
    $( Given a is equivalent to b, b is equivalent to T. there exists a proof
       for a is equivalent to T. (Contributed by Jarvin Udandy,
       29-Aug-2016.) $)
    aiffbbtat $p |- ( ph <-> T. ) $=
      ( wtru bitri ) ABECDF $.
  $}

  ${
    aisbbisfaisf.1 $e |- ( ph <-> ps ) $.
    aisbbisfaisf.2 $e |- ( ps <-> F. ) $.
    $( Given a is equivalent to b, b is equivalent to F. there exists a proof
       for a is equivalent to F. (Contributed by Jarvin Udandy,
       30-Aug-2016.) $)
    aisbbisfaisf $p |- ( ph <-> F. ) $=
      ( wfal bitri ) ABECDF $.
  $}

  ${
    axorbtnotaiffb.1 $e |- ( ph \/_ ps ) $.
    $( Given a is exclusive to b, there exists a proof for (not (a
       if-and-only-if b)) df-xor is a closed form of this.  (Contributed by
       Jarvin Udandy, 7-Sep-2016.) $)
    axorbtnotaiffb $p |- -. ( ph <-> ps ) $=
      ( wxo wb wn df-xor mpbi ) ABDABEFCABGH $.
  $}

  ${
    aiffnbandciffatnotciffb.1 $e |- ( ph <-> -. ps ) $.
    aiffnbandciffatnotciffb.2 $e |- ( ch <-> ph ) $.
    $( Given a is equivalent to NOT b, c is equivalent to a. there exists a
       proof for ( not ( c iff b ) ).  (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    aiffnbandciffatnotciffb $p |- -. ( ch <-> ps ) $=
      ( wb wn bitri xor3 mpbir ) CBFGCBGZFCAKEDHCBIJ $.
  $}

  ${
    axorbciffatcxorb.1 $e |- ( ph \/_ ps ) $.
    axorbciffatcxorb.2 $e |- ( ch <-> ph ) $.
    $( Given a is equivalent to NOT b, c is equivalent to a. there exists a
       proof for ( c xor b ) .  (Contributed by Jarvin Udandy, 7-Sep-2016.) $)
    axorbciffatcxorb $p |- ( ch \/_ ps ) $=
      ( wxo wb wn axorbtnotaiffb xor3 mpbi aiffnbandciffatnotciffb df-xor mpbir
      ) CBFCBGHABCABGHABHGABDIABJKELCBMN $.
  $}

  ${
    aibnbna.1 $e |- ( ph -> ps ) $.
    aibnbna.2 $e |- -. ps $.
    $( Given a implies b, not b, there exists a proof for not a.  (Contributed
       by Jarvin Udandy, 1-Sep-2016.) $)
    aibnbna $p |- -. ph $=
      ( mto ) ABDCE $.
  $}

  ${
    aibnbaif.1 $e |- ( ph -> ps ) $.
    aibnbaif.2 $e |- -. ps $.
    $( Given a implies b, not b, there exists a proof for a is F. (Contributed
       by Jarvin Udandy, 1-Sep-2016.) $)
    aibnbaif $p |- ( ph <-> F. ) $=
      ( aibnbna bifal ) AABCDEF $.
  $}

  ${
    aiffbtbat.1 $e |- ( ph <-> ps ) $.
    aiffbtbat.2 $e |- ( T. <-> ps ) $.
    $( Given a is equivalent to b, T. is equivalent to b. there exists a proof
       for a is equivalent to T. (Contributed by Jarvin Udandy,
       29-Aug-2016.) $)
    aiffbtbat $p |- ( ph <-> T. ) $=
      ( wtru bitr4i ) ABECDF $.
  $}

  ${
    astbstanbst.1 $e |- ( ph <-> T. ) $.
    astbstanbst.2 $e |- ( ps <-> T. ) $.
    $( Given a is equivalent to T., also given that b is equivalent to T, there
       exists a proof for a and b is equivalent to T. (Contributed by Jarvin
       Udandy, 29-Aug-2016.) $)
    astbstanbst $p |- ( ( ph /\ ps ) <-> T. ) $=
      ( wa aistia pm3.2i bitru ) ABEABACFBDFGH $.
  $}

  ${
    aistbistaandb.1 $e |- ( ph <-> T. ) $.
    aistbistaandb.2 $e |- ( ps <-> T. ) $.
    $( Given a is equivalent to T., also given that b is equivalent to T, there
       exists a proof for (a and b).  (Contributed by Jarvin Udandy,
       9-Sep-2016.) $)
    aistbistaandb $p |- ( ph /\ ps ) $=
      ( aistia pm3.2i ) ABACEBDEF $.
  $}

  ${
    aisbnaxb.1 $e |- ( ph <-> ps ) $.
    $( Given a is equivalent to b, there exists a proof for (not (a xor b)).
       (Contributed by Jarvin Udandy, 28-Aug-2016.) $)
    aisbnaxb $p |- -. ( ph \/_ ps ) $=
      ( wxo wb wn notnoti df-xor mtbir ) ABDABEZFJCGABHI $.
  $}


  ${
    iatbtatnnb.1 $e |- ( ph -> ps ) $.
    $( Given a implies b, there exists a proof for a implies not not b.
       (Contributed by Jarvin Udandy, 2-Sep-2016.) $)
    iatbtatnnb $p |- ( ph -> -. -. ps ) $=
      ( wn notnot sylib ) ABBDDCBEF $.
  $}


  $( If a implies b, then a implies not not b (Contributed by Jarvin Udandy,
     28-Aug-2016.) $)
  atbiffatnnb $p |- ( ( ph -> ps ) -> ( ph -> -. -. ps ) ) $=
    ( wn idd notnot syl6ib a2i ) ABBCCZABBHABDBEFG $.

  $( Application of bicom1 with a, b swapped.  (Contributed by Jarvin Udandy,
     31-Aug-2016.) $)
  bisaiaisb $p |- ( ( ps <-> ph ) -> ( ph <-> ps ) ) $=
    ( bicom1 ) BAC $.

  $( If a implies b, then a implies not not b (Contributed by Jarvin Udandy,
     29-Aug-2016.) $)
  atbiffatnnbalt $p |- ( ( ph -> ps ) -> ( ph -> -. -. ps ) ) $=
    ( atbiffatnnb ) ABC $.

  ${
    abnotbtaxb.1 $e   |- ph $.
    abnotbtaxb.2 $e   |- -. ps $.
    $( Assuming a, not b, there exists a proof a-xor-b.)  (Contributed by
       Jarvin Udandy, 31-Aug-2016.) $)
    abnotbtaxb $p |- ( ph \/_ ps ) $=
      ( wxo wb wn wa xor3 wi pm5.1 ibibr mpbi mp2an bitri mpbir2an df-xor mpbir
      ) ABEABFGZSABGZCDSATFZATHZABIATUAUBFZCDUBUAJUBUCJATKUBUALMNOPABQR $.
  $}

  ${
    abnotataxb.1 $e   |- -. ph $.
    abnotataxb.2 $e   |- ps $.
    $( Assuming not a, b, there exists a proof a-xor-b.)  (Contributed by
       Jarvin Udandy, 31-Aug-2016.) $)
    abnotataxb $p |- ( ph \/_ ps ) $=
      ( wxo wb wn wa wo pm3.2i olci xor mpbir df-xor ) ABEABFGZOABGHZBAGZHZIRPB
      QDCJKABLMABNM $.
  $}

  ${
    conimpf.1 $e   |- ph $.
    conimpf.2 $e   |- -. ps $.
    conimpf.3 $e   |- ( ph -> ps ) $.
    $( Assuming a, not b, and a implies b, there exists a proof that a is
       false.)  (Contributed by Jarvin Udandy, 28-Aug-2016.) $)
    conimpf $p     |- ( ph <-> F. ) $=
      ( aibnbaif ) ABEDF $.
  $}

  ${
    conimpfalt.1 $e   |- ph $.
    conimpfalt.2 $e   |- -. ps $.
    conimpfalt.3 $e   |- ( ph -> ps ) $.
    $( Assuming a, not b, and a implies b, there exists a proof that a is
       false.)  (Contributed by Jarvin Udandy, 29-Aug-2016.) $)
    conimpfalt $p     |- ( ph <-> F. ) $=
      ( aibnbaif ) ABEDF $.
  $}

  ${
    aistbisfiaxb.1 $e |- ( ph <-> T. ) $.
    aistbisfiaxb.2 $e |- ( ps <-> F. ) $.
    $( Given a is equivalent to T., Given b is equivalent to F. there exists a
       proof for a-xor-b.  (Contributed by Jarvin Udandy, 31-Aug-2016.) $)
    aistbisfiaxb $p |- ( ph \/_ ps ) $=
      ( aistia aisfina abnotbtaxb ) ABACEBDFG $.
  $}

  ${
    aisfbistiaxb.1 $e |- ( ph <-> F. ) $.
    aisfbistiaxb.2 $e |- ( ps <-> T. ) $.
    $( Given a is equivalent to F., Given b is equivalent to T., there exists a
       proof for a-xor-b.  (Contributed by Jarvin Udandy, 31-Aug-2016.) $)
    aisfbistiaxb $p |- ( ph \/_ ps ) $=
      ( aisfina aistia abnotataxb ) ABACEBDFG $.
  $}

  ${
    abcdta.1 $e |- ( ( ( ph /\ ps ) /\ ch ) /\ th ) $.
    $( Given (((a and b) and c) and d), there exists a proof for a (Contributed
       by Jarvin Udandy, 3-Sep-2016.) $)
    abcdta $p |- ph $=
      ( wa simpli ) ABABFZCHCFDEGGG $.
  $}

  ${
    abcdtb.1 $e |- ( ( ( ph /\ ps ) /\ ch ) /\ th ) $.
    $( Given (((a and b) and c) and d), there exists a proof for b (Contributed
       by Jarvin Udandy, 3-Sep-2016.) $)
    abcdtb $p |- ps $=
      ( wa simpli simpri ) ABABFZCICFDEGGH $.
  $}

  ${
    abcdtc.1 $e |- ( ( ( ph /\ ps ) /\ ch ) /\ th ) $.
    $( Given (((a and b) and c) and d), there exists a proof for c (Contributed
       by Jarvin Udandy, 3-Sep-2016.) $)
    abcdtc $p |- ch $=
      ( wa simpli simpri ) ABFZCICFDEGH $.
  $}

  ${
    abcdtd.1 $e |- ( ( ( ph /\ ps ) /\ ch ) /\ th ) $.
    $( Given (((a and b) and c) and d), there exists a proof for d (Contributed
       by Jarvin Udandy, 3-Sep-2016.) $)
    abcdtd $p |- th $=
      ( wa simpri ) ABFCFDEG $.
  $}


  $(
    The dandysum binary to decimal equivalence table.
    Please note the differences! In binary 0100 would normally be the value of
    '4' in Decimal.
        Here it is '2' in Decimal.

        1111 = is 15 in Decimal
        0111 = is 14 in Decimal
        1011 = is 13 in Decimal
        0011 = is 12 in Decimal
        1101 = is 11 in Decimal
        0101 = is 10 in Decimal
        1001 = is 9 in Decimal
        0001 = is 8 in Decimal
        1110 = is 7 in Decimal
        0110 = is 6 in Decimal
        1010 = is 5 in Decimal
        0010 = is 4 in Decimal
        1100 = is 3 in Decimal
        0100 = is 2 in Decimal
        1000 = is 1 in Decimal
        0000 = is 0 in Decimal

  $)

  ${
    mdandyv0.1 $e |- ( ph <-> F. ) $.
    mdandyv0.2 $e |- ( ps <-> T. ) $.
    mdandyv0.3 $e |- ( ch <-> F. ) $.
    mdandyv0.4 $e |- ( th <-> F. ) $.
    mdandyv0.5 $e |- ( ta <-> F. ) $.
    mdandyv0.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv0 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ph ) ) /\
( ta <-> ph ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothfbothsame pm3.2i ) CAMZDAMZNZEAMZNFAMSTQRCAIGODAJGOPEAKGOPFAL
      GOP $.
  $}

  ${
    mdandyv1.1 $e |- ( ph <-> F. ) $.
    mdandyv1.2 $e |- ( ps <-> T. ) $.
    mdandyv1.3 $e |- ( ch <-> T. ) $.
    mdandyv1.4 $e |- ( th <-> F. ) $.
    mdandyv1.5 $e |- ( ta <-> F. ) $.
    mdandyv1.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv1 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ph ) ) /\
( ta <-> ph ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothtbothsame bothfbothsame pm3.2i ) CBMZDAMZNZEAMZNFAMTUARSCBIHO
      DAJGPQEAKGPQFALGPQ $.
  $}

  ${
    mdandyv2.1 $e |- ( ph <-> F. ) $.
    mdandyv2.2 $e |- ( ps <-> T. ) $.
    mdandyv2.3 $e |- ( ch <-> F. ) $.
    mdandyv2.4 $e |- ( th <-> T. ) $.
    mdandyv2.5 $e |- ( ta <-> F. ) $.
    mdandyv2.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv2 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ps ) ) /\
( ta <-> ph ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothfbothsame bothtbothsame pm3.2i ) CAMZDBMZNZEAMZNFAMTUARSCAIGO
      DBJHPQEAKGOQFALGOQ $.
  $}

  ${
    mdandyv3.1 $e |- ( ph <-> F. ) $.
    mdandyv3.2 $e |- ( ps <-> T. ) $.
    mdandyv3.3 $e |- ( ch <-> T. ) $.
    mdandyv3.4 $e |- ( th <-> T. ) $.
    mdandyv3.5 $e |- ( ta <-> F. ) $.
    mdandyv3.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv3 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ps ) ) /\
( ta <-> ph ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothtbothsame pm3.2i bothfbothsame ) CBMZDBMZNZEAMZNFAMTUARSCBIHO
      DBJHOPEAKGQPFALGQP $.
  $}

  ${
    mdandyv4.1 $e |- ( ph <-> F. ) $.
    mdandyv4.2 $e |- ( ps <-> T. ) $.
    mdandyv4.3 $e |- ( ch <-> F. ) $.
    mdandyv4.4 $e |- ( th <-> F. ) $.
    mdandyv4.5 $e |- ( ta <-> T. ) $.
    mdandyv4.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv4 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ph ) ) /\
( ta <-> ps ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothfbothsame pm3.2i bothtbothsame ) CAMZDAMZNZEBMZNFAMTUARSCAIGO
      DAJGOPEBKHQPFALGOP $.
  $}

  ${
    mdandyv5.1 $e |- ( ph <-> F. ) $.
    mdandyv5.2 $e |- ( ps <-> T. ) $.
    mdandyv5.3 $e |- ( ch <-> T. ) $.
    mdandyv5.4 $e |- ( th <-> F. ) $.
    mdandyv5.5 $e |- ( ta <-> T. ) $.
    mdandyv5.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv5 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ph ) ) /\
( ta <-> ps ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothtbothsame bothfbothsame pm3.2i ) CBMZDAMZNZEBMZNFAMTUARSCBIHO
      DAJGPQEBKHOQFALGPQ $.
  $}

  ${
    mdandyv6.1 $e |- ( ph <-> F. ) $.
    mdandyv6.2 $e |- ( ps <-> T. ) $.
    mdandyv6.3 $e |- ( ch <-> F. ) $.
    mdandyv6.4 $e |- ( th <-> T. ) $.
    mdandyv6.5 $e |- ( ta <-> T. ) $.
    mdandyv6.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv6 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ps ) ) /\
( ta <-> ps ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothfbothsame bothtbothsame pm3.2i ) CAMZDBMZNZEBMZNFAMTUARSCAIGO
      DBJHPQEBKHPQFALGOQ $.
  $}

  ${
    mdandyv7.1 $e |- ( ph <-> F. ) $.
    mdandyv7.2 $e |- ( ps <-> T. ) $.
    mdandyv7.3 $e |- ( ch <-> T. ) $.
    mdandyv7.4 $e |- ( th <-> T. ) $.
    mdandyv7.5 $e |- ( ta <-> T. ) $.
    mdandyv7.6 $e |- ( et <-> F. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv7 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ps ) ) /\
( ta <-> ps ) ) /\
( et <-> ph ) )
$=
      ( wb wa bothtbothsame pm3.2i bothfbothsame ) CBMZDBMZNZEBMZNFAMTUARSCBIHO
      DBJHOPEBKHOPFALGQP $.
  $}

  ${
    mdandyv8.1 $e |- ( ph <-> F. ) $.
    mdandyv8.2 $e |- ( ps <-> T. ) $.
    mdandyv8.3 $e |- ( ch <-> F. ) $.
    mdandyv8.4 $e |- ( th <-> F. ) $.
    mdandyv8.5 $e |- ( ta <-> F. ) $.
    mdandyv8.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv8 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ph ) ) /\
( ta <-> ph ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothfbothsame pm3.2i bothtbothsame ) CAMZDAMZNZEAMZNFBMTUARSCAIGO
      DAJGOPEAKGOPFBLHQP $.
  $}

  ${
    mdandyv9.1 $e |- ( ph <-> F. ) $.
    mdandyv9.2 $e |- ( ps <-> T. ) $.
    mdandyv9.3 $e |- ( ch <-> T. ) $.
    mdandyv9.4 $e |- ( th <-> F. ) $.
    mdandyv9.5 $e |- ( ta <-> F. ) $.
    mdandyv9.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv9 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ph ) ) /\
( ta <-> ph ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothtbothsame bothfbothsame pm3.2i ) CBMZDAMZNZEAMZNFBMTUARSCBIHO
      DAJGPQEAKGPQFBLHOQ $.
  $}

  ${
    mdandyv10.1 $e |- ( ph <-> F. ) $.
    mdandyv10.2 $e |- ( ps <-> T. ) $.
    mdandyv10.3 $e |- ( ch <-> F. ) $.
    mdandyv10.4 $e |- ( th <-> T. ) $.
    mdandyv10.5 $e |- ( ta <-> F. ) $.
    mdandyv10.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv10 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ps ) ) /\
( ta <-> ph ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothfbothsame bothtbothsame pm3.2i ) CAMZDBMZNZEAMZNFBMTUARSCAIGO
      DBJHPQEAKGOQFBLHPQ $.
  $}

  ${
    mdandyv11.1 $e |- ( ph <-> F. ) $.
    mdandyv11.2 $e |- ( ps <-> T. ) $.
    mdandyv11.3 $e |- ( ch <-> T. ) $.
    mdandyv11.4 $e |- ( th <-> T. ) $.
    mdandyv11.5 $e |- ( ta <-> F. ) $.
    mdandyv11.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv11 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ps ) ) /\
( ta <-> ph ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothtbothsame pm3.2i bothfbothsame ) CBMZDBMZNZEAMZNFBMTUARSCBIHO
      DBJHOPEAKGQPFBLHOP $.
  $}

  ${
    mdandyv12.1 $e |- ( ph <-> F. ) $.
    mdandyv12.2 $e |- ( ps <-> T. ) $.
    mdandyv12.3 $e |- ( ch <-> F. ) $.
    mdandyv12.4 $e |- ( th <-> F. ) $.
    mdandyv12.5 $e |- ( ta <-> T. ) $.
    mdandyv12.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv12 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ph ) ) /\
( ta <-> ps ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothfbothsame pm3.2i bothtbothsame ) CAMZDAMZNZEBMZNFBMTUARSCAIGO
      DAJGOPEBKHQPFBLHQP $.
  $}

  ${
    mdandyv13.1 $e |- ( ph <-> F. ) $.
    mdandyv13.2 $e |- ( ps <-> T. ) $.
    mdandyv13.3 $e |- ( ch <-> T. ) $.
    mdandyv13.4 $e |- ( th <-> F. ) $.
    mdandyv13.5 $e |- ( ta <-> T. ) $.
    mdandyv13.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv13 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ph ) ) /\
( ta <-> ps ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothtbothsame bothfbothsame pm3.2i ) CBMZDAMZNZEBMZNFBMTUARSCBIHO
      DAJGPQEBKHOQFBLHOQ $.
  $}

  ${
    mdandyv14.1 $e |- ( ph <-> F. ) $.
    mdandyv14.2 $e |- ( ps <-> T. ) $.
    mdandyv14.3 $e |- ( ch <-> F. ) $.
    mdandyv14.4 $e |- ( th <-> T. ) $.
    mdandyv14.5 $e |- ( ta <-> T. ) $.
    mdandyv14.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv14 $p |- ( ( ( ( ch <-> ph ) /\ ( th <-> ps ) ) /\
( ta <-> ps ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothfbothsame bothtbothsame pm3.2i ) CAMZDBMZNZEBMZNFBMTUARSCAIGO
      DBJHPQEBKHPQFBLHPQ $.
  $}

  ${
    mdandyv15.1 $e |- ( ph <-> F. ) $.
    mdandyv15.2 $e |- ( ps <-> T. ) $.
    mdandyv15.3 $e |- ( ch <-> T. ) $.
    mdandyv15.4 $e |- ( th <-> T. ) $.
    mdandyv15.5 $e |- ( ta <-> T. ) $.
    mdandyv15.6 $e |- ( et <-> T. ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ph, ps accordingly (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    mdandyv15 $p |- ( ( ( ( ch <-> ps ) /\ ( th <-> ps ) ) /\
( ta <-> ps ) ) /\
( et <-> ps ) )
$=
      ( wb wa bothtbothsame pm3.2i ) CBMZDBMZNZEBMZNFBMSTQRCBIHODBJHOPEBKHOPFBL
      HOP $.
  $}

  ${
    mdandyvr0.1 $e |- ( ph <-> ze ) $.
    mdandyvr0.2 $e |- ( ps <-> si ) $.
    mdandyvr0.3 $e |- ( ch <-> ph ) $.
    mdandyvr0.4 $e |- ( th <-> ph ) $.
    mdandyvr0.5 $e |- ( ta <-> ph ) $.
    mdandyvr0.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr0 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> ze ) ) /\
( ta <-> ze ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CGOZDGOZPZEGOZPFGOUAUBSTCAGKIQDAGLIQREAGMIQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr1.1 $e |- ( ph <-> ze ) $.
    mdandyvr1.2 $e |- ( ps <-> si ) $.
    mdandyvr1.3 $e |- ( ch <-> ps ) $.
    mdandyvr1.4 $e |- ( th <-> ph ) $.
    mdandyvr1.5 $e |- ( ta <-> ph ) $.
    mdandyvr1.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr1 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> ze ) ) /\
( ta <-> ze ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CHOZDGOZPZEGOZPFGOUAUBSTCBHKJQDAGLIQREAGMIQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr2.1 $e |- ( ph <-> ze ) $.
    mdandyvr2.2 $e |- ( ps <-> si ) $.
    mdandyvr2.3 $e |- ( ch <-> ph ) $.
    mdandyvr2.4 $e |- ( th <-> ps ) $.
    mdandyvr2.5 $e |- ( ta <-> ph ) $.
    mdandyvr2.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr2 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> si ) ) /\
( ta <-> ze ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CGOZDHOZPZEGOZPFGOUAUBSTCAGKIQDBHLJQREAGMIQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr3.1 $e |- ( ph <-> ze ) $.
    mdandyvr3.2 $e |- ( ps <-> si ) $.
    mdandyvr3.3 $e |- ( ch <-> ps ) $.
    mdandyvr3.4 $e |- ( th <-> ps ) $.
    mdandyvr3.5 $e |- ( ta <-> ph ) $.
    mdandyvr3.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr3 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> si ) ) /\
( ta <-> ze ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CHOZDHOZPZEGOZPFGOUAUBSTCBHKJQDBHLJQREAGMIQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr4.1 $e |- ( ph <-> ze ) $.
    mdandyvr4.2 $e |- ( ps <-> si ) $.
    mdandyvr4.3 $e |- ( ch <-> ph ) $.
    mdandyvr4.4 $e |- ( th <-> ph ) $.
    mdandyvr4.5 $e |- ( ta <-> ps ) $.
    mdandyvr4.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr4 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> ze ) ) /\
( ta <-> si ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CGOZDGOZPZEHOZPFGOUAUBSTCAGKIQDAGLIQREBHMJQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr5.1 $e |- ( ph <-> ze ) $.
    mdandyvr5.2 $e |- ( ps <-> si ) $.
    mdandyvr5.3 $e |- ( ch <-> ps ) $.
    mdandyvr5.4 $e |- ( th <-> ph ) $.
    mdandyvr5.5 $e |- ( ta <-> ps ) $.
    mdandyvr5.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr5 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> ze ) ) /\
( ta <-> si ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CHOZDGOZPZEHOZPFGOUAUBSTCBHKJQDAGLIQREBHMJQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr6.1 $e |- ( ph <-> ze ) $.
    mdandyvr6.2 $e |- ( ps <-> si ) $.
    mdandyvr6.3 $e |- ( ch <-> ph ) $.
    mdandyvr6.4 $e |- ( th <-> ps ) $.
    mdandyvr6.5 $e |- ( ta <-> ps ) $.
    mdandyvr6.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr6 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> si ) ) /\
( ta <-> si ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CGOZDHOZPZEHOZPFGOUAUBSTCAGKIQDBHLJQREBHMJQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr7.1 $e |- ( ph <-> ze ) $.
    mdandyvr7.2 $e |- ( ps <-> si ) $.
    mdandyvr7.3 $e |- ( ch <-> ps ) $.
    mdandyvr7.4 $e |- ( th <-> ps ) $.
    mdandyvr7.5 $e |- ( ta <-> ps ) $.
    mdandyvr7.6 $e |- ( et <-> ph ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr7 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> si ) ) /\
( ta <-> si ) ) /\
( et <-> ze ) )
$=
      ( wb wa bitri pm3.2i ) CHOZDHOZPZEHOZPFGOUAUBSTCBHKJQDBHLJQREBHMJQRFAGNIQ
      R $.
  $}

  ${
    mdandyvr8.1 $e |- ( ph <-> ze ) $.
    mdandyvr8.2 $e |- ( ps <-> si ) $.
    mdandyvr8.3 $e |- ( ch <-> ph ) $.
    mdandyvr8.4 $e |- ( th <-> ph ) $.
    mdandyvr8.5 $e |- ( ta <-> ph ) $.
    mdandyvr8.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr8 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> ze ) ) /\
( ta <-> ze ) ) /\
( et <-> si ) )
$=
      ( mdandyvr7 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr9.1 $e |- ( ph <-> ze ) $.
    mdandyvr9.2 $e |- ( ps <-> si ) $.
    mdandyvr9.3 $e |- ( ch <-> ps ) $.
    mdandyvr9.4 $e |- ( th <-> ph ) $.
    mdandyvr9.5 $e |- ( ta <-> ph ) $.
    mdandyvr9.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr9 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> ze ) ) /\
( ta <-> ze ) ) /\
( et <-> si ) )
$=
      ( mdandyvr6 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr10.1 $e |- ( ph <-> ze ) $.
    mdandyvr10.2 $e |- ( ps <-> si ) $.
    mdandyvr10.3 $e |- ( ch <-> ph ) $.
    mdandyvr10.4 $e |- ( th <-> ps ) $.
    mdandyvr10.5 $e |- ( ta <-> ph ) $.
    mdandyvr10.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr10 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> si ) ) /\
( ta <-> ze ) ) /\
( et <-> si ) )
$=
      ( mdandyvr5 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr11.1 $e |- ( ph <-> ze ) $.
    mdandyvr11.2 $e |- ( ps <-> si ) $.
    mdandyvr11.3 $e |- ( ch <-> ps ) $.
    mdandyvr11.4 $e |- ( th <-> ps ) $.
    mdandyvr11.5 $e |- ( ta <-> ph ) $.
    mdandyvr11.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr11 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> si ) ) /\
( ta <-> ze ) ) /\
( et <-> si ) )
$=
      ( mdandyvr4 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr12.1 $e |- ( ph <-> ze ) $.
    mdandyvr12.2 $e |- ( ps <-> si ) $.
    mdandyvr12.3 $e |- ( ch <-> ph ) $.
    mdandyvr12.4 $e |- ( th <-> ph ) $.
    mdandyvr12.5 $e |- ( ta <-> ps ) $.
    mdandyvr12.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr12 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> ze ) ) /\
( ta <-> si ) ) /\
( et <-> si ) )
$=
      ( mdandyvr3 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr13.1 $e |- ( ph <-> ze ) $.
    mdandyvr13.2 $e |- ( ps <-> si ) $.
    mdandyvr13.3 $e |- ( ch <-> ps ) $.
    mdandyvr13.4 $e |- ( th <-> ph ) $.
    mdandyvr13.5 $e |- ( ta <-> ps ) $.
    mdandyvr13.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr13 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> ze ) ) /\
( ta <-> si ) ) /\
( et <-> si ) )
$=
      ( mdandyvr2 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr14.1 $e |- ( ph <-> ze ) $.
    mdandyvr14.2 $e |- ( ps <-> si ) $.
    mdandyvr14.3 $e |- ( ch <-> ph ) $.
    mdandyvr14.4 $e |- ( th <-> ps ) $.
    mdandyvr14.5 $e |- ( ta <-> ps ) $.
    mdandyvr14.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr14 $p |- ( ( ( ( ch <-> ze ) /\ ( th <-> si ) ) /\
( ta <-> si ) ) /\
( et <-> si ) )
$=
      ( mdandyvr1 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvr15.1 $e |- ( ph <-> ze ) $.
    mdandyvr15.2 $e |- ( ps <-> si ) $.
    mdandyvr15.3 $e |- ( ch <-> ps ) $.
    mdandyvr15.4 $e |- ( th <-> ps ) $.
    mdandyvr15.5 $e |- ( ta <-> ps ) $.
    mdandyvr15.6 $e |- ( et <-> ps ) $.
    $( Given the equivalences set in the hypotheses, there exist a proof where
       ch, th, ta, et match ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvr15 $p |- ( ( ( ( ch <-> si ) /\ ( th <-> si ) ) /\
( ta <-> si ) ) /\
( et <-> si ) )
$=
      ( mdandyvr0 ) BACDEFHGJIKLMNO $.
  $}


  ${
    mdandyvrx0.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx0.2 $e |- ( ps \/_ si ) $.
    mdandyvrx0.3 $e |- ( ch <-> ph ) $.
    mdandyvrx0.4 $e |- ( th <-> ph ) $.
    mdandyvrx0.5 $e |- ( ta <-> ph ) $.
    mdandyvrx0.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx0 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ ze ) ) /\
( ta \/_ ze ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CGOZDGOZPZEGOZPFGOUAUBSTAGCIKQAGDILQRA
      GEIMQRAGFINQR $.
  $}

  ${
    mdandyvrx1.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx1.2 $e |- ( ps \/_ si ) $.
    mdandyvrx1.3 $e |- ( ch <-> ps ) $.
    mdandyvrx1.4 $e |- ( th <-> ph ) $.
    mdandyvrx1.5 $e |- ( ta <-> ph ) $.
    mdandyvrx1.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx1 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ ze ) ) /\
( ta \/_ ze ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CHOZDGOZPZEGOZPFGOUAUBSTBHCJKQAGDILQRA
      GEIMQRAGFINQR $.
  $}

  ${
    mdandyvrx2.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx2.2 $e |- ( ps \/_ si ) $.
    mdandyvrx2.3 $e |- ( ch <-> ph ) $.
    mdandyvrx2.4 $e |- ( th <-> ps ) $.
    mdandyvrx2.5 $e |- ( ta <-> ph ) $.
    mdandyvrx2.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx2 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ si ) ) /\
( ta \/_ ze ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CGOZDHOZPZEGOZPFGOUAUBSTAGCIKQBHDJLQRA
      GEIMQRAGFINQR $.
  $}

  ${
    mdandyvrx3.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx3.2 $e |- ( ps \/_ si ) $.
    mdandyvrx3.3 $e |- ( ch <-> ps ) $.
    mdandyvrx3.4 $e |- ( th <-> ps ) $.
    mdandyvrx3.5 $e |- ( ta <-> ph ) $.
    mdandyvrx3.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx3 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ si ) ) /\
( ta \/_ ze ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CHOZDHOZPZEGOZPFGOUAUBSTBHCJKQBHDJLQRA
      GEIMQRAGFINQR $.
  $}

  ${
    mdandyvrx4.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx4.2 $e |- ( ps \/_ si ) $.
    mdandyvrx4.3 $e |- ( ch <-> ph ) $.
    mdandyvrx4.4 $e |- ( th <-> ph ) $.
    mdandyvrx4.5 $e |- ( ta <-> ps ) $.
    mdandyvrx4.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx4 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ ze ) ) /\
( ta \/_ si ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CGOZDGOZPZEHOZPFGOUAUBSTAGCIKQAGDILQRB
      HEJMQRAGFINQR $.
  $}

  ${
    mdandyvrx5.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx5.2 $e |- ( ps \/_ si ) $.
    mdandyvrx5.3 $e |- ( ch <-> ps ) $.
    mdandyvrx5.4 $e |- ( th <-> ph ) $.
    mdandyvrx5.5 $e |- ( ta <-> ps ) $.
    mdandyvrx5.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx5 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ ze ) ) /\
( ta \/_ si ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CHOZDGOZPZEHOZPFGOUAUBSTBHCJKQAGDILQRB
      HEJMQRAGFINQR $.
  $}

  ${
    mdandyvrx6.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx6.2 $e |- ( ps \/_ si ) $.
    mdandyvrx6.3 $e |- ( ch <-> ph ) $.
    mdandyvrx6.4 $e |- ( th <-> ps ) $.
    mdandyvrx6.5 $e |- ( ta <-> ps ) $.
    mdandyvrx6.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx6 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ si ) ) /\
( ta \/_ si ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CGOZDHOZPZEHOZPFGOUAUBSTAGCIKQBHDJLQRB
      HEJMQRAGFINQR $.
  $}

  ${
    mdandyvrx7.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx7.2 $e |- ( ps \/_ si ) $.
    mdandyvrx7.3 $e |- ( ch <-> ps ) $.
    mdandyvrx7.4 $e |- ( th <-> ps ) $.
    mdandyvrx7.5 $e |- ( ta <-> ps ) $.
    mdandyvrx7.6 $e |- ( et <-> ph ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx7 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ si ) ) /\
( ta \/_ si ) ) /\
( et \/_ ze ) )
$=
      ( wxo wa axorbciffatcxorb pm3.2i ) CHOZDHOZPZEHOZPFGOUAUBSTBHCJKQBHDJLQRB
      HEJMQRAGFINQR $.
  $}

  ${
    mdandyvrx8.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx8.2 $e |- ( ps \/_ si ) $.
    mdandyvrx8.3 $e |- ( ch <-> ph ) $.
    mdandyvrx8.4 $e |- ( th <-> ph ) $.
    mdandyvrx8.5 $e |- ( ta <-> ph ) $.
    mdandyvrx8.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx8 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ ze ) ) /\
( ta \/_ ze ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx7 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx9.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx9.2 $e |- ( ps \/_ si ) $.
    mdandyvrx9.3 $e |- ( ch <-> ps ) $.
    mdandyvrx9.4 $e |- ( th <-> ph ) $.
    mdandyvrx9.5 $e |- ( ta <-> ph ) $.
    mdandyvrx9.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx9 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ ze ) ) /\
( ta \/_ ze ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx6 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx10.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx10.2 $e |- ( ps \/_ si ) $.
    mdandyvrx10.3 $e |- ( ch <-> ph ) $.
    mdandyvrx10.4 $e |- ( th <-> ps ) $.
    mdandyvrx10.5 $e |- ( ta <-> ph ) $.
    mdandyvrx10.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx10 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ si ) ) /\
( ta \/_ ze ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx5 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx11.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx11.2 $e |- ( ps \/_ si ) $.
    mdandyvrx11.3 $e |- ( ch <-> ps ) $.
    mdandyvrx11.4 $e |- ( th <-> ps ) $.
    mdandyvrx11.5 $e |- ( ta <-> ph ) $.
    mdandyvrx11.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx11 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ si ) ) /\
( ta \/_ ze ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx4 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx12.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx12.2 $e |- ( ps \/_ si ) $.
    mdandyvrx12.3 $e |- ( ch <-> ph ) $.
    mdandyvrx12.4 $e |- ( th <-> ph ) $.
    mdandyvrx12.5 $e |- ( ta <-> ps ) $.
    mdandyvrx12.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx12 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ ze ) ) /\
( ta \/_ si ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx3 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx13.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx13.2 $e |- ( ps \/_ si ) $.
    mdandyvrx13.3 $e |- ( ch <-> ps ) $.
    mdandyvrx13.4 $e |- ( th <-> ph ) $.
    mdandyvrx13.5 $e |- ( ta <-> ps ) $.
    mdandyvrx13.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx13 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ ze ) ) /\
( ta \/_ si ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx2 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx14.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx14.2 $e |- ( ps \/_ si ) $.
    mdandyvrx14.3 $e |- ( ch <-> ph ) $.
    mdandyvrx14.4 $e |- ( th <-> ps ) $.
    mdandyvrx14.5 $e |- ( ta <-> ps ) $.
    mdandyvrx14.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx14 $p |- ( ( ( ( ch \/_ ze ) /\ ( th \/_ si ) ) /\
( ta \/_ si ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx1 ) BACDEFHGJIKLMNO $.
  $}

  ${
    mdandyvrx15.1 $e |- ( ph \/_ ze ) $.
    mdandyvrx15.2 $e |- ( ps \/_ si ) $.
    mdandyvrx15.3 $e |- ( ch <-> ps ) $.
    mdandyvrx15.4 $e |- ( th <-> ps ) $.
    mdandyvrx15.5 $e |- ( ta <-> ps ) $.
    mdandyvrx15.6 $e |- ( et <-> ps ) $.
    $( Given the exclusivities set in the hypotheses, there exist a proof where
       ch, th, ta, et exclude ze, si accordingly (Contributed by Jarvin Udandy,
       7-Sep-2016.) $)
    mdandyvrx15 $p |- ( ( ( ( ch \/_ si ) /\ ( th \/_ si ) ) /\
( ta \/_ si ) ) /\
( et \/_ si ) )
$=
      ( mdandyvrx0 ) BACDEFHGJIKLMNO $.
  $}

  ${
    H15NH16TH15IH16.1 $e |- ph $.
    H15NH16TH15IH16.2 $e |- ps $.
    H15NH16TH15IH16.3 $e |- ch $.
    H15NH16TH15IH16.4 $e |- th $.
    H15NH16TH15IH16.5 $e |- ta $.
    H15NH16TH15IH16.6 $e |- et $.
    H15NH16TH15IH16.7 $e |- ze $.
    H15NH16TH15IH16.8 $e |- si $.
    H15NH16TH15IH16.9 $e |- rh $.
    H15NH16TH15IH16.10 $e |- mu $.
    H15NH16TH15IH16.11 $e |- la $.
    H15NH16TH15IH16.12 $e |- ka $.
    H15NH16TH15IH16.13 $e |- jph $.
    H15NH16TH15IH16.14 $e |- jps $.
    H15NH16TH15IH16.15 $e |- jch $.
    H15NH16TH15IH16.16 $e |- jth $.
    $( Given 15 hypotheses and a 16th hypothesis, there exists a proof the 15
       imply the 16th.  (Contributed by Jarvin Udandy, 8-Sep-2016.) $)
    H15NH16TH15IH16 $p |- ( ( ( ( ( ( ( ( ( ( ( ( ( ( ( ph /\ ps ) /\ ch )
/\ th ) /\
 ta ) /\ et ) /\ ze ) /\ si ) /\ rh ) /\ mu ) /\ la ) /\ ka ) /\ jph )
/\ jps ) /\
jch ) -> jth )
$=
      ( wa a1i ) PABUMCUMDUMEUMFUMGUMHUMIUMJUMKUMLUMMUMNUMOUMULUN $.
  $}

  $( END MAIN SECTION
   This is the end-of the main section.
  $)


  $( BEGIN EXPERIMENTS [ Search Code: 6hFY3NX45ggpE7Hx ]
   This section of the mathbox is for experiments/works-in-progress that aren't
   officially ready, are suggested to me to try, or have a high chance of being
   removed later on.

   Self-Rule: Every theorem must have in its description that it is subject to
   modification by the author and at increased risk of being abandoned
   or removed.

   Like so:
   (Experimental! Has increased risk of ..
   abandonment/removal/modification by author.)

   This section should be at the very end of the mathbox to make full use of
   available theorems elsewhere in the mathbox.

    The order of declaring things:
    variables, wffs, constants, definitions, followed by
    broad-use-formulas, and lastly more subject-specific results.

    Occasionally grouping like-formulas
    when sensible.

    But now keep the experimental versions of all that beyond this point.
  $)

  ${
    dandysum2p2e4.a $e |- ( ph <-> ( th /\ ta ) ) $.
    dandysum2p2e4.b $e |- ( ps <-> ( et /\ ze ) ) $.
    dandysum2p2e4.c $e |- ( ch <-> ( si /\ rh ) ) $.
    dandysum2p2e4.d $e |- ( th <-> F. ) $.
    dandysum2p2e4.e $e |- ( ta <-> F. ) $.
    dandysum2p2e4.f $e |- ( et <-> T. ) $.
    dandysum2p2e4.g $e |- ( ze <-> T. ) $.
    dandysum2p2e4.h $e |- ( si <-> F. ) $.
    dandysum2p2e4.i $e |- ( rh <-> F. ) $.
    dandysum2p2e4.j $e |- ( mu <-> F. ) $.
    dandysum2p2e4.k $e |- ( la <-> F. ) $.
    dandysum2p2e4.l $e |- ( ka <-> ( ( th \/_ ta ) \/_ ( th /\ ta ) ) ) $.
    dandysum2p2e4.m $e |- ( jph <-> ( ( et \/_ ze ) \/ ph ) ) $.
    dandysum2p2e4.n $e |- ( jps <-> ( ( si \/_ rh ) \/ ps ) ) $.
    dandysum2p2e4.o $e |- ( jch <-> ( ( mu \/_ la ) \/ ch ) ) $.
    $(

       CONTRADICTION PROVED AT 1 + 1 = 2 .

       Given the right hypotheses we can prove a dandysum of 2+2=4.  The qed
       step is the value '4' in Decimal BEING IMPLIED by the hypotheses.

       Note:  Values that when added which exceed a 4bit value are not
       supported.

       Note:  Digits begin from left (least) to right (greatest). e.g. 1000
       would be '1', 0100 would be '2'. 0010 would be '4'.

       How to perceive the hypotheses' bits in order:  ( th <-> F. ), ( ta <->
       F. ) Would be input value X's first bit, and input value Y's first bit.

       ( et <-> F ), ( ze <-> F. ) would be input value X's second bit, and
       input value Y's second bit.  (Contributed by Jarvin Udandy,
       6-Sep-2016.) $)
    dandysum2p2e4 $p |- ( ( ( ( ( ( ( ( ( ( ( ( ( ( ( ( ph <-> ( th /\ ta ) )
/\
    ( ps <-> ( et /\ ze ) ) ) /\ ( ch <-> ( si /\ rh ) ) )
    /\ ( th <-> F. ) ) /\ ( ta <-> F. ) ) /\ ( et <-> T. ) )
/\ ( ze <-> T. ) )
/\
    ( si <-> F. ) ) /\ ( rh <-> F. ) )
    /\ ( mu <-> F. ) ) /\ ( la <-> F. ) )
    /\ ( ka <-> ( ( th \/_ ta ) \/_ ( th /\ ta ) ) ) )
    /\ ( jph <-> ( ( et \/_ ze ) \/ ph ) ) )
    /\ ( jps <-> ( ( si \/_ rh ) \/ ps ) ) )
    /\ ( jch <-> ( ( mu \/_ la ) \/ ch ) ) )
    -> ( ( ( ( ka <-> F. ) /\ ( jph <-> F. ) ) /\ ( jps <-> T. ) )
/\ ( jch <-> F. ) ) )
    $=
      ( wfal wb wtru wxo biimpi bothfbothsame aisbnaxb aisfina notatnand 2false
      wa aibnbaif bothtbothsame mtbir pm3.2ni pm3.2i astbstanbst aiffbbtat olci
      wo aistia bitru a1i ) LUKULZMUKULZVAZNUMULZVAZOUKULZVAADEVAZULBFGVAZULVAC
      HIVAZULVADUKULVAEUKULVAFUMULVAGUMULVAHUKULVAIUKULVAJUKULVAKUKULVALDEUNZVT
      UNZULVAMFGUNZAVJZULVANHIUNZBVJZULVAOJKUNZCVJZULVAVRVSVPVQVNVOLWDLWDUGUOWC
      VTWCVTDEDESTUPUQDEDSURUSZUTUQVBMWFMWFUHUOWEAFGFGUAUBVCUQAVTWKPVDVEVBVFNWH
      UIWHBWGBBWAQFGUAUBVGVHVKVIVLVHVFOWJOWJUJUOWICJKJKUEUFUPUQCWBHIHUCURUSRVDV
      EVBVFVM $.
  $}


  ${
    mdandysum2p2e4.1 $e |- ( jth <-> F. ) $.
    mdandysum2p2e4.2 $e |- ( jta <-> T. ) $.
    mdandysum2p2e4.a $e |- ( ph <-> ( th /\ ta ) ) $.
    mdandysum2p2e4.b $e |- ( ps <-> ( et /\ ze ) ) $.
    mdandysum2p2e4.c $e |- ( ch <-> ( si /\ rh ) ) $.
    mdandysum2p2e4.d $e |- ( th <-> jth ) $.
    mdandysum2p2e4.e $e |- ( ta <-> jth ) $.
    mdandysum2p2e4.f $e |- ( et <-> jta ) $.
    mdandysum2p2e4.g $e |- ( ze <-> jta ) $.
    mdandysum2p2e4.h $e |- ( si <-> jth ) $.
    mdandysum2p2e4.i $e |- ( rh <-> jth ) $.
    mdandysum2p2e4.j $e |- ( mu <-> jth ) $.
    mdandysum2p2e4.k $e |- ( la <-> jth ) $.
    mdandysum2p2e4.l $e |- ( ka <-> ( ( th \/_ ta ) \/_ ( th /\ ta ) ) ) $.
    mdandysum2p2e4.m $e |- ( jph <-> ( ( et \/_ ze ) \/ ph ) ) $.
    mdandysum2p2e4.n $e |- ( jps <-> ( ( si \/_ rh ) \/ ps ) ) $.
    mdandysum2p2e4.o $e |- ( jch <-> ( ( mu \/_ la ) \/ ch ) ) $.
    $( CONTRADICTION PROVED AT 1 + 1 = 2 .  Luckily Mario Carneiro did a
       successful version of his own.

       See Mario's Relevant Work: 1.3.14 Half-adders and full adders in
       propositional calculus

       Given the right hypotheses we can prove a dandysum of 2+2=4.  The qed
       step is the value '4' in Decimal BEING IMPLIED by the hypotheses.

       Note:  Values that when added which exceed a 4bit value are not
       supported.

       Note:  Digits begin from left (least) to right (greatest). e.g. 1000
       would be '1', 0100 would be '2'. 0010 would be '4'.

       How to perceive the hypotheses' bits in order:  ( th <-> F. ), ( ta <->
       F. ) Would be input value X's first bit, and input value Y's first bit.

       ( et <-> F. ), ( ze <-> F. ) would be input value X's second bit, and
       input value Y's second bit.

       In mdandysum2p2e4, one might imagine what jth or jta could be then do
       the math with their truths.  Also limited to the restriction jth, jta
       are having opposite truths equivalent to the stated truth constants.

       (Contributed by Jarvin Udandy, 6-Sep-2016.) $)
    mdandysum2p2e4 $p |- ( ( ( ( ( ( ( ( ( ( ( ( ( ( ( ( ph <-> ( th /\ ta ) )
/\
    ( ps <-> ( et /\ ze ) ) ) /\ ( ch <-> ( si /\ rh ) ) )
    /\ ( th <-> F. ) ) /\ ( ta <-> F. ) ) /\ ( et <-> T. ) )
/\ ( ze <-> T. ) )
/\
    ( si <-> F. ) ) /\ ( rh <-> F. ) )
    /\ ( mu <-> F. ) ) /\ ( la <-> F. ) )
    /\ ( ka <-> ( ( th \/_ ta ) \/_ ( th /\ ta ) ) ) )
    /\ ( jph <-> ( ( et \/_ ze ) \/ ph ) ) )
    /\ ( jps <-> ( ( si \/_ rh ) \/ ps ) ) )
    /\ ( jch <-> ( ( mu \/_ la ) \/ ch ) ) )
    -> ( ( ( ( ka <-> F. ) /\ ( jph <-> F. ) ) /\ ( jps <-> T. ) )
/\ ( jch <-> F. ) ) )
    $=
      ( aisbbisfaisf aiffbbtat dandysum2p2e4 ) ABCDEFGHIJKLMNOTUAUBDPUCRUOEPUDR
      UOFQUESUPGQUFSUPHPUGRUOIPUHRUOJPUIRUOKPUJRUOUKULUMUNUQ $.
  $}

  $( END EXPERIMENTS
   This is the end-of the experiment section of the mathbox.
   Which should be at the end of the mathbox too.
  $)

$( (End of Jarvin Udandy's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Alexander van der Vekens
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Double restricted existential uniqueness
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Restricted quantification (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    r19.32.1 $e |- F/ x ph $.
    $( Theorem 19.32 of [Margaris] p. 90 with restricted quantifiers, analogous
       to ~ r19.32v .  (Contributed by Alexander van der Vekens,
       29-Jun-2017.) $)
    r19.32 $p |- ( A. x e. A ( ph \/ ps ) <-> ( ph \/ A. x e. A ps ) ) $=
      ( wn wi wral wo nfn r19.21 df-or ralbii 3bitr4i ) AFZBGZCDHOBCDHZGABIZCDH
      AQIOBCDACEJKRPCDABLMAQLN $.
  $}

  ${
    $d x y A $.  $d y ph $.
    $( An equivalent expression for restricted existence, analogous to
       ~ exsb .  (Contributed by Alexander van der Vekens, 1-Jul-2017.) $)
    rexsb $p |- ( E. x e. A ph <-> E. y e. A A. x ( x = y -> ph ) ) $=
      ( weq wi wal nfv nfa1 ax11v sp com12 impbid cbvrex ) ABCEZAFZBGZBCDACHPBI
      OAQABCJQOAPBKLMN $.

    $( An equivalent expression for restricted existence, analogous to
       ~ exsb .  (Contributed by Alexander van der Vekens, 1-Jul-2017.) $)
    rexrsb $p |- ( E. x e. A ph <-> E. y e. A A. x e. A ( x = y -> ph ) ) $=
      ( wrex weq wi wal wral rexsb cv wcel alral df-ral wa 19.27v eleq1 biimprd
      pm2.04 pm2.83 ax-mp imp alimi sylbir ex sylbi com12 impbid2 rexbiia bitri
      3syl ) ABDEBCFZAGZBHZCDEUMBDIZCDEABCDJUNUOCDCKZDLZUNUOUMBDMUOUQUNUOBKZDLZ
      UMGZBHZUQUNGUMBDNVAUQUNVAUQOUTUQOZBHUNUTUQBPVBUMBUTUQUMUTULUSAGGZULUQAGGZ
      UQUMGUSULASULUQUSGGVCVDGULUSUQURUPDQRULUQUSATUAULUQASUKUBUCUDUEUFUGUHUIUJ
      $.
  $}

  ${
    $d w x y z B $.  $d w x z A $.  $d z w ph $.
    $( An equivalent expression for double restricted existence, analogous to
       ~ rexsb .  (Contributed by Alexander van der Vekens, 1-Jul-2017.) $)
    2rexsb $p |- ( E. x e. A E. y e. B ph <-> E. z e. A E. w e. B
                   A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      ( wrex weq wi wal wa rexsb rexbii rexcom bitri impexp albii 19.21v bitr2i
      ) ACGHZBFHZCEIZAJZCKZBFHZEGHZBDIZUCLAJZCKZBKZEGHDFHZUBUEEGHZBFHUGUAUMBFAC
      EGMNUEBEFGOPUGUKDFHZEGHULUFUNEGUFUHUEJZBKZDFHUNUEBDFMUPUKDFUOUJBUJUHUDJZC
      KUOUIUQCUHUCAQRUHUDCSTRNPNUKEDGFOPP $.

    $( An equivalent expression for double restricted existence, analogous to
       ~ 2exsb .  (Contributed by Alexander van der Vekens, 1-Jul-2017.) $)
    2rexrsb $p |- ( E. x e. A E. y e. B ph <-> E. z e. A E. w e. B
                   A. x e. A A. y e. B ( ( x = z /\ y = w ) -> ph ) ) $=
      ( wrex wi wral wa rexrsb rexbii rexcom bitri impexp ralbii r19.21v bitr2i
      weq ) ACGHZBFHZCETZAIZCGJZBFHZEGHZBDTZUCKAIZCGJZBFJZEGHDFHZUBUEEGHZBFHUGU
      AUMBFACEGLMUEBEFGNOUGUKDFHZEGHULUFUNEGUFUHUEIZBFJZDFHUNUEBDFLUPUKDFUOUJBF
      UJUHUDIZCGJUOUIUQCGUHUCAPQUHUDCGRSQMOMUKEDGFNOO $.
  $}

  ${
    $d x A $.  $d z A $.  $d x y B $.  $d z y B $.  $d w B $.
    cbvral2.1 $e |- F/ z ph $.
    cbvral2.2 $e |- F/ x ch $.
    cbvral2.3 $e |- F/ w ch $.
    cbvral2.4 $e |- F/ y ps $.
    cbvral2.5 $e |- ( x = z -> ( ph <-> ch ) ) $.
    cbvral2.6 $e |- ( y = w -> ( ch <-> ps ) ) $.
    $( Change bound variables of double restricted universal quantification,
       using implicit substitution, analogous to ~ cbvral2v .  (Contributed by
       Alexander van der Vekens, 2-Jul-2017.) $)
    cbvral2 $p |- ( A. x e. A A. y e. B ph <-> A. z e. A A. w e. B ps ) $=
      ( wral nfcv nfral weq cbvral ralbidv ralbii bitri ) AEIPZDHPCEIPZFHPBGIPZ
      FHPUDUEDFHAFEIFIQJRCDEIDIQKRDFSACEINUATUEUFFHCBEGILMOTUBUC $.

    $( Change bound variables of double restricted universal quantification,
       using implicit substitution, analogous to ~ cbvrex2v .  (Contributed by
       Alexander van der Vekens, 2-Jul-2017.) $)
    cbvrex2 $p |- ( E. x e. A E. y e. B ph <-> E. z e. A E. w e. B ps ) $=
      ( wrex nfcv nfrex weq cbvrex rexbidv rexbii bitri ) AEIPZDHPCEIPZFHPBGIPZ
      FHPUDUEDFHAFEIFIQJRCDEIDIQKRDFSACEINUATUEUFFHCBEGILMOTUBUC $.
  $}

  $( Split a biconditional and distribute 2 quantifiers, analogous to ~ 2albiim
     and ~ ralbiim .  (Contributed by Alexander van der Vekens, 2-Jul-2017.) $)
  2ralbiim $p |- ( A. x e. A A. y e. B ( ph <-> ps ) <->
                   ( A. x e. A A. y e. B ( ph -> ps )
                     /\ A. x e. A A. y e. B ( ps -> ph ) ) ) $=
    ( wb wral wi wa ralbiim ralbii r19.26 bitri ) ABGDFHZCEHABIDFHZBAIDFHZJZCEH
    PCEHQCEHJORCEABDFKLPQCEMN $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      The empty set (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y A $.  $d x y B $.
    raaan2.1 $e |- F/ y ph $.
    raaan2.2 $e |- F/ x ps $.
    $( Rearrange restricted quantifiers with two different restricting classes,
       analogous to ~ raaan .  It is necessary that either both restricting
       classes are empty or both are not empty.  (Contributed by Alexander van
       der Vekens, 29-Jun-2017.) $)
    raaan2 $p |- ( ( A = (/) <-> B = (/) )
                   -> ( A. x e. A A. y e. B ( ph /\ ps ) <->
                        ( A. x e. A ph /\ A. y e. B ps ) ) ) $=
      ( c0 wceq wb wa wn wo wral rzal adantr wne df-ne sylbir dfbi3 adantl nfcv
      pm5.1 syl12anc r19.28z ralbidv nfral r19.27z sylan9bbr jaoi sylbi ) EIJZF
      IJZKUMUNLZUMMZUNMZLZNABLDFOZCEOZACEOZBDFOZLZKZUMUNUAUOVDURUOUTVAVBVDUMUTU
      NUSCEPQUMVAUNACEPQUNVBUMBDFPUBUTVCUDUEUQUTAVBLZCEOZUPVCUQFIRZUTVFKFISVGUS
      VECEABDFGUFUGTUPEIRVFVCKEISAVBCEBCDFCFUCHUHUITUJUKUL $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Restricted uniqueness and "at most one" quantification
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    rmoimi.1 $e |- ( ph -> ps ) $.
    $( Restricted "at most one" is preserved through implication (note wff
       reversal).  (Contributed by Alexander van der Vekens, 17-Jun-2017.) $)
    rmoimi $p |- ( E* x e. A ps -> E* x e. A ph ) $=
      ( wi cv wcel a1i rmoimia ) ABCDABFCGDHEIJ $.
  $}

  $( Double restricted existential uniqueness in terms of restricted existence
     and restricted "at most one."  (Contributed by Alexander van der Vekens,
     17-Jun-2017.) $)
  2reu5a $p |- ( E! x e. A E! y e. B ph <->
                ( E. x e. A ( E. y e. B ph /\ E* y e. B ph )
                  /\ E* x e. A ( E. y e. B ph /\ E* y e. B ph ) ) ) $=
    ( wreu wrex wrmo wa reu5 rexbii rmobii anbi12i bitri ) ACEFZBDFOBDGZOBDHZIA
    CEGACEHIZBDGZRBDHZIOBDJPSQTORBDACEJZKORBDUALMN $.

  $( Restricted uniqueness implies restricted "at most one" through
     implication, analogous to ~ euimmo .  (Contributed by Alexander van der
     Vekens, 25-Jun-2017.) $)
  reuimrmo $p |- ( A. x e. A ( ph -> ps )
                   -> ( E! x e. A ps -> E* x e. A ph ) ) $=
    ( wreu wrmo wi wral reurmo rmoim syl5 ) BCDEBCDFABGCDHACDFBCDIABCDJK $.

  ${
    $d x y A $.  $d y ph $.  $d y ps $.
    rmoanim.1 $e |- F/ x ph $.
    $( Introduction of a conjunct into restricted "at most one" quantifier,
       analogous to ~ moanim .  (Contributed by Alexander van der Vekens,
       25-Jun-2017.) $)
    rmoanim $p |- ( E* x e. A ( ph /\ ps ) <-> ( ph -> E* x e. A ps ) ) $=
      ( vy wa weq wi wral wex wrmo impexp ralbii r19.21 bitri exbii rmo2 imbi2i
      nfv 19.37v bitr4i 3bitr4i ) ABGZCFHZIZCDJZFKABUEIZCDJZIZFKZUDCDLABCDLZIZU
      GUJFUGAUHIZCDJUJUFUNCDABUEMNAUHCDEOPQUDCFDUDFTRUMAUIFKZIUKULUOABCFDBFTRSA
      UIFUAUBUC $.

    $( Introduction of a conjunct into restricted uniqueness quantifier,
       analogous to ~ euan .  (Contributed by Alexander van der Vekens,
       2-Jul-2017.) $)
    reuan $p |- ( E! x e. A ( ph /\ ps ) <-> ( ph /\ E! x e. A ps ) ) $=
      ( wa wreu wrex wrmo wi cv wcel simpl a1i rexlimi adantr simpr reximi reu5
      biimpa nfre1 ancrd impbid2 rmobida jca32 anbi2i 3imtr4i wb reubida impbii
      a1d ibar ) ABFZCDGZABCDGZFZUMCDHZUMCDIZFZABCDHZBCDIZFZFUNUPUSAUTVAUQAURUM
      ACDEUMAJCKDLZABMNOZPUQUTURUMBCDABQZRPUQURVAUQUMBCDUMCDUAUQVCFZUMBVEVFBAVF
      ABUQAVCVDPUKUBUCUDTUEUMCDSUOVBABCDSUFUGAUOUNABUMCDEABUMUHVCABULPUITUJ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Analogs to Existential uniqueness (double quantification)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d y A $.  $d x y $.  $d x B $.
    $( Double restricted quantification with existential uniqueness, analogous
       to ~ 2euex .  (Contributed by Alexander van der Vekens, 24-Jun-2017.) $)
    2reurex $p |- ( E! x e. A E. y e. B ph -> E. y e. B E! x e. A ph ) $=
      ( wrex wreu wrmo wa reu5 rexcom nfcv nfre1 nfrmo cv wcel wi wral impcom
      ex rspe ralrimivw rmoim syl rmo5 sylib reximdai syl5bi sylbi ) ACEFZBDGUJ
      BDFZUJBDHZIABDGZCEFZUJBDJULUKUNUKABDFZCEFULUNABCDEKULUOUMCEUJCBDCDLACEMNU
      LCOEPZUOUMQZULUPIABDHZUQUPULURUPAUJQZBDRULURQUPUSBDUPAUJACEUATUBAUJBDUCUD
      SABDUEUFTUGUHSUI $.

    $( Double restricted quantification with restricted existential uniqueness
       and restricted "at most one.", analogous to ~ 2eumo .  (Contributed by
       Alexander van der Vekens, 24-Jun-2017.) $)
    2reurmo $p |- ( E! x e. A E* y e. B ph -> E* x e. A E! y e. B ph ) $=
      ( wreu wrmo wi reuimrmo cv wcel reurmo a1i mprg ) ACEFZACEGZHZPBDFOBDGHBD
      OPBDIQBJDKACELMN $.

    $( Double restricted existential uniqueness, analogous to ~ 2eu2ex .
       (Contributed by Alexander van der Vekens, 25-Jun-2017.) $)
    2reu2rex $p |- ( E! x e. A E! y e. B ph -> E. x e. A E. y e. B ph ) $=
      ( wreu wrex reurex reximi syl ) ACEFZBDFKBDGACEGZBDGKBDHKLBDACEHIJ $.

    $( A condition allowing swap of restricted "at most one" and restricted
       existential quantifiers, analogous to ~ 2moswap .  (Contributed by
       Alexander van der Vekens, 25-Jun-2017.) $)
    2rmoswap $p |- ( A. x e. A E* y e. B ph
                   -> ( E* x e. A E. y e. B ph -> E* y e. B E. x e. A ph ) ) $=
      ( wrmo wral cv wcel wa wmo wrex wi df-rmo wal r19.42v df-rex bitri bitr3i
      wex ralbii df-ral moanimv albii bitr4i 2moswap exbii mobii 3imtr4g sylbi
      an12 ) ACEFZBDGCHEIZAJZCKZBDGZACELZBDFZABDLZCEFZMZULUOBDACENUAUPBHDIZUNJZ
      CKZBOZVAUPVBUOMZBOVEUOBDUBVDVFBVBUNCUCUDUEVEVCCTZBKZVCBTZCKZURUTVCBCUFURV
      BUQJZBKVHUQBDNVKVGBVKVBAJZCELZVGVBACEPVMUMVLJZCTVGVLCEQVNVCCUMVBAUKUGRSUH
      RUTUMUSJZCKVJUSCENVOVICVOUNBDLVIUMABDPUNBDQSUHRUIUJUJ $.

    $( Double restricted existential uniqueness implies double restricted
       uniqueness quantification, analogous to ~ 2exeu .  (Contributed by
       Alexander van der Vekens, 25-Jun-2017.) $)
    2rexreu $p |- ( ( E! x e. A E. y e. B ph /\ E! y e. B E. x e. A ph )
                  -> E! x e. A E! y e. B ph ) $=
      ( wrex wreu wa wrmo reurmo reurex rmoimi syl 2reurex anim12ci reu5 sylibr
      ) ACEFZBDGZABDFCEGZHACEGZBDFZUABDIZHUABDGSUCTUBSRBDIUCRBDJUARBDACEKLMACBE
      DNOUABDPQ $.
  $}

  ${
    $d x y A $.  $d x B $.
    $( Double restricted existential uniqueness.  This theorem shows a
       condition under which a "naive" definition matches the correct one,
       analogous to ~ 2eu1 .  (Contributed by Alexander van der Vekens,
       25-Jun-2017.) $)
    2reu1 $p |- ( A. x e. A E* y e. B ph -> ( E! x e. A E! y e. B ph
                <-> ( E! x e. A E. y e. B ph /\ E! y e. B E. x e. A ph ) ) ) $=
      ( wrmo wral wreu wrex wa wi 2reu5a simprbi cv wcel simprr jca sylib com12
      reu5 adantr impcom ex rmoimia nfra1 rmoanim ancrd 2rmoswap imdistani syl6
      rsp syl 2reu2rex rexcom jctild anbi12i an4 bitri syl6ibr 2rexreu impbid1
      ) ACEFZBDGZACEHBDHZACEIZBDHZABDIZCEHZJZVDVCVIVDVCVEBDIZVGCEIZJZVEBDFZVGCE
      FZJZJZVIVDVCVOVLVDVEVBJZBDFZVCVOKVDVQBDIVRABCDELMVRVCVMVCJVOVRVCVMVRVCVEJ
      ZBDFVCVMKVSVQBDBNDOZVSVQVTVSJVEVBVTVCVEPVSVTVBVCVTVBKVEVBBDUKUAUBQUCUDVCV
      EBDVBBDUEUFRUGVMVCVNVCVMVNABCDEUHSUIUJULVDVJVKABCDEUMZVDVJVKWAABCDEUNRQUO
      VIVJVMJZVKVNJZJVPVFWBVHWCVEBDTVGCETUPVJVMVKVNUQURUSSABCDEUTVA $.

    $( Double restricted existential uniqueness, analogous to ~ 2eu2 .
       (Contributed by Alexander van der Vekens, 29-Jun-2017.) $)
    2reu2 $p |- ( E! y e. B E. x e. A ph
                  -> ( E! x e. A E! y e. B ph <-> E! x e. A E. y e. B ph ) ) $=
      ( wrex wreu wrmo wral wi reurmo 2rmorex wa 2reu1 simpl syl6bi 3syl expcom
      2rexreu impbid ) ABDFZCEGZACEGBDGZACEFBDGZUBUACEHACEHBDIZUCUDJUACEKACBEDL
      UEUCUDUBMUDABCDENUDUBOPQUDUBUCABCDESRT $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Double restricted existential uniqueness, analogous to ~ 2eu3 .
       (Contributed by Alexander van der Vekens, 29-Jun-2017.) $)
    2reu3 $p |- ( A. x e. A A. y e. B ( E* x e. A ph \/ E* y e. B ph ) ->
                ( ( E! x e. A E! y e. B ph /\ E! y e. B E! x e. A ph )
                <-> ( E! x e. A E. y e. B ph /\ E! y e. B E. x e. A ph ) ) ) $=
      ( wrmo wo wral wreu wa wrex orcom ralbii nfrmo1 r19.32 bitri 2reu1 biimpd
      wb 2rexreu nfcv nfral wi ancom syl6ib adantld adantrd jaoi ancoms impbid1
      jca sylbi ) ABDFZACEFZGZCEHZBDHZUMCEHZUNBDHZGZACEIBDIZABDICEIZJZACEKBDIZA
      BDKCEIZJZSUQURUNGZBDHUTUPVGBDUPUNURGZVGUPUNUMGZCEHVHUOVICEUMUNLMUNUMCEACE
      NOPUNURLPMURUNBDUMBCEBEUAABDNUBOPUTVCVFURVCVFUCUSURVBVFVAURVBVEVDJZVFURVB
      VJACBEDQRVEVDUDUEUFUSVAVFVBUSVAVFABCDEQRUGUHVFVAVBABCDETVEVDVBACBEDTUIUKU
      JUL $.
  $}

  ${
    $d z w ph $.  $d w x y z A $.  $d w x y z B $.
    $( Definition of double restricted existential uniqueness ("exactly one
       ` x ` and exactly one ` y ` "), analogous to ~ 2eu4 with the additional
       requirement that the restricting classes are not empty (which is not
       necessary as shown in ~ 2reu4 ).  (Contributed by Alexander van der
       Vekens, 1-Jul-2017.) $)
    2reu4a $p |- ( ( A =/= (/) /\ B =/= (/) )
                -> ( ( E! x e. A E. y e. B ph /\ E! y e. B E. x e. A ph ) <->
                    ( E. x e. A E. y e. B ph /\ E. z e. A E. w e. B
                      A. x e. A A. y e. B ( ph -> ( x = z /\ y = w ) ) ) ) ) $=
      ( c0 wne wa wrex wreu weq wi wral wb a1i bitri r19.26 adantr reu3 anbi12i
      an4 rexcom anbi2i anidm cv wcel nfra1 r19.3rz bicomd anbi2d ralbii bitr4d
      jcab syl5rbb ad2antlr ralcom anbi12d syl5bb ralbidv r19.23v 2ralbii wn wo
      wceq df-ne biimpi anim12i olcd dfbi3 sylibr nfv nfim raaan2 syl 2rexbidva
      nfre1 3bitrd reeanv syl6rbb ) FHIZGHIZJZACGKZBFLZABFKZCGLZJZWEBFKZWEBDMZN
      ZBFOZDFKZJZWGCGKZWGCEMZNZCGOZEGKZJZJZWJWPJZWNWTJZJZWJAWKWQJNZCGOZBFOZEGKD
      FKZJWIXBPWDWFWOWHXAWEBDFUAWGCEGUAUBQXBXEPWDWJWNWPWTUCQWDXCWJXDXIXCWJPWDXC
      WJWJJWJWPWJWJACBGFUDUEWJUFRQWDXIWMWSJZEGKDFKXDWDXHXJDEFGWDDUGFUHEUGGUHJZJ
      ZXHAWKNZCGOZAWQNZBFOZJZCGOZBFOZWLWRJZCGOBFOZXJXLXHXNXOCGOZBFOZJZBFOZXSYEX
      NBFOZYCBFOZJZXLXHXNYCBFSXLYHYFYCJZXHXLYGYCYFWDYGYCPZXKWBYJWCWBYCYGYCBFYBB
      FUIUJUKTTULXHYIPXLXHXNYBJZBFOYIXGYKBFXGXMXOJZCGOYKXFYLCGAWKWQUOUMXMXOCGSR
      UMXNYBBFSRQUNUPXLXRYDBFXRXNCGOZXPCGOZJXLYDXNXPCGSXLYMXNYNYCXLXNYMWCXNYMPW
      BXKXNCGXMCGUIUJUQUKYNYCPXLXOCBGFURQUSUTVAUNXSYAPXLXQXTBCFGXNWLXPWRAWKCGVB
      AWQBFVBUBVCQWDYAXJPZXKWDFHVFZGHVFZPZYOWDYPYQJZYPVDZYQVDZJZVEYRWDUUBYSWBYT
      WCUUAWBYTFHVGVHWCUUAGHVGVHVIVJYPYQVKVLWLWRBCFGWEWKCACGVRWKCVMVNWGWQBABFVR
      WQBVMVNVOVPTVSVQWMWSDEFGVTWAUSVS $.

    $( Definition of double restricted existential uniqueness ("exactly one
       ` x ` and exactly one ` y ` "), analogous to ~ 2eu4 .  (Contributed by
       Alexander van der Vekens, 1-Jul-2017.) $)
    2reu4 $p |- ( ( E! x e. A E. y e. B ph /\ E! y e. B E. x e. A ph ) <->
                    ( E. x e. A E. y e. B ph /\ E. z e. A E. w e. B
                      A. x e. A A. y e. B ( ph -> ( x = z /\ y = w ) ) ) ) $=
      ( wrex wreu wa c0 wne weq wral reurex rexn0 syl anim12i cv wcel rexlimivv
      wi ne0i a1d adantr 2reu4a pm5.21nii ) ACGHZBFIZABFHZCGIZJFKLZGKLZJZUHBFHZ
      ABDMCEMJUBCGNBFNEGHDFHZJUIULUKUMUIUOULUHBFOUHBFPQUKUJCGHUMUJCGOUJCGPQRUOU
      NUPAUNBCFGBSZFTZCSZGTZJUNAURULUTUMFUQUCGUSUCRUDUAUEABCDEFGUFUG $.
  $}

  ${
    $d x A $.  $d x y B $.
    $( Two equivalent expressions for double restricted existential uniqueness,
       analogous to ~ 2eu7 .  (Contributed by Alexander van der Vekens,
       2-Jul-2017.) $)
    2reu7 $p |- ( ( E! x e. A E. y e. B ph /\ E! y e. B E. x e. A ph ) <->
                  E! x e. A E! y e. B ( E. x e. A ph /\ E. y e. B ph ) ) $=
      ( wrex wreu wa nfcv nfre1 nfreu reuan ancom reubii 3bitri 3bitr4ri ) ABDF
      ZCEGZACEFZHZBDGRSBDGZHQSHZCEGZBDGUARHRSBDQBCEBEIABDJKLUCTBDUCSQHZCEGSRHTU
      BUDCEQSMNSQCEACEJLSRMONUARMP $.
  $}

  ${
    $d x y A $.  $d x y B $.
    $( Two equivalent expressions for double restricted existential uniqueness,
       analogous to ~ 2eu8 .  Curiously, we can put ` E! ` on either of the
       internal conjuncts but not both.  We can also commute
       ` E! x e. A E! y e. B ` using ~ 2reu7 .  (Contributed by Alexander van
       der Vekens, 2-Jul-2017.) $)
    2reu8 $p |- ( E! x e. A E! y e. B ( E. x e. A ph /\ E. y e. B ph ) <->
                  E! x e. A E! y e. B ( E! x e. A ph /\ E. y e. B ph ) ) $=
      ( wrex wreu wa 2reu2 pm5.32i nfreu1 nfreu reuan ancom reubii nfre1 3bitri
      nfcv 3bitr4ri 2reu7 3bitr3ri ) ACEFZBDGZABDGZCEGZHZUCABDFZCEGZHUDUBHZCEGZ
      BDGZUGUBHCEGBDGUCUEUHACBEDIJUEUBHZBDGUEUCHUKUFUEUBBDUDBCEBERABDKLMUJULBDU
      JUBUDHZCEGUBUEHULUIUMCEUDUBNOUBUDCEACEPMUBUENQOUCUENSABCDETUA $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Alternative definitions of function's and operation's values
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
The current definition of the value ` ( F `` A ) ` of a function ` F ` for an
argument ` A ` (see ~ df-fv ) assures that this value is always a set,
see ~ fex . This is because this definition can be applied to any classes ` F `
and ` A ` , and evaluates to the empty set when it is not meaningful (as shown
by ~ ndmfv and ~ fvprc ).

Although it is very convenient for many theorems on functions and their proofs,
there are some cases in which from ` ( F `` A ) = (/) ` alone it cannot be
decided/derived if ` ( F `` A ) ` is meaningful ( ` F ` is actually a function
which is defined for ` A ` and really has the function value ` (/) ` ) or not.
Therefore, additional assumptions are required, such as ` (/) e/ ran F ` ,
` (/) e. ran F ` or ` Fun F /\ A e. dom F ` (see, for example, ~ ndmfvrcl ).

To avoid such an ambiguity, an alternative definition ` ( F ''' A ) ` ( see
~ df-afv ) would be possible which evaluates to the universal class
( ` ( F ''' A ) = _V ` ) if it is not meaningful (see ~ afvnfundmuv ,
~ ndmafv , ~ afvprc and ~ nfunsnafv ), and which corresponds to the current
definition ( ` ( F `` A ) = ( F ''' A ) ` ) if it is (see ~ afvfundmfveq ).
That means ` ( F ''' A ) = _V -> ( F `` A ) = (/) ` (see ~ afvpcfv0 ), but
` ( F `` A ) = (/) -> ( F ''' A ) = _V ` is not generally valid.

In the theory of partial functions, it is a common case that ` F ` is not
defined at ` A ` , which also would result in ` ( F ''' A ) = _V ` . In this
context we say ` ( F ''' A ) ` "is not defined" instead of "is not meaningful".

With this definition the following intuitive equivalence holds:
` ( F ''' A ) e. _V ` <-> " ` ( F ''' A ) ` is meaningful/defined".

An interesting question would be if ` ( F `` A ) ` could be replaced by
` ( F ''' A ) ` in most of the theorems based on function's values. If we look
at the (currently 19) proofs using the definition ~ df-fv of ` ( F `` A ) `,
we see that analogons for the following 8 theorems can be proven using the
alternative definition: ~ fveq1 -> ~ afveq1 , ~ fveq2 -> ~ afveq2 ,
~ nffv -> ~ nfafv , ~ csbfv12gOLD -> csbafv12g , ~ fvres -> ~ afvres ,
~ rlimdm -> ~ rlimdmafv , ~ tz6.12-1 -> ~ tz6.12-1-afv , ~ fveu -> ~ afveu .

3 theorems proved by directly using ~ df-fv are within a mathbox ( ~ fvsb ) or
not used ( ~ isumclim3 , ~ avril1 ).

However, the remaining 8 theorems proved by directly using ~ df-fv are used
more or less often:

* ~ fvex : used in about 1750 proofs.

* ~ tz6.12-1 : root theorem of many theorems which have not a strict analogon,
and which are used many times: ~ fvprc (used in about 127 proofs), ~ tz6.12i
(used - indirectly via ~ fvbr0 and ~ fvrn0 - in 18 proofs, and in ~ fvclss used
in ~ fvclex used in ~ fvresex , which is not used!), ~ dcomex (used in 4
proofs), ~ ndmfv (used in 86 proofs) and ~ nfunsn (used by ~ dffv2 which is
not used).

* ~ fv2 : only used by ~ elfv , which is only used by ~ fv3 , which is not
used.

* ~ dffv3 : used by ~ dffv4 (the previous "df-fv"), which now is only used
in deprecated (usage discouraged) theorems or within mathboxes
( ~ csbfv12gALTOLD , ~ csbfv12gALTVD ), by ~ shftval (itself used in 9 proofs),
by ~dffv5 (mathbox) and by ~ fvco2 , which has the analogon ~ afvco2 .

* ~ fvopab5 : used only by ~ ajval (not used) and by ~ adjval ( used -
indirectly - in 9 proofs).

* ~ zsum : used (via ~ isum , ~ sum0 and ~ fsumsers ) in more than 90 proofs.

* ~ isumshft : used in ~ pserdv2 and (via ~ logtayl ) 4 other proofs.

* ~ ovtpos : used in 14 proofs.

As a result of this analysis we can say that the current definition of a
function's value is crucial for Metamath and cannot be exchanged easily with
an alternative definition. While ~ fv2 , ~ dffv3 , ~ fvopab5 , ~ zsum ,
~ isumshft and ~ ovtpos are not critical or are, hopefully, also valid for
the alternative definition, ~ fvex and ~ tz6.12-1 (and the theorems based on
them) are essential for the current definition of function values.

With the same arguments, an alternatvie definition of operation's values
` (( A O B )) ` could be meaningful to avoid ambiguities, see ~ df-aov .

For additional discussions/material see
 ~ https://groups.google.com/forum/#!topic/metamath/cteNUppB6A4 .
$)

$( *** Definition moved to the front so that the text above will appear
   in the html output! *** $)

  $c defAt $. $( "defined at" predicate $)
  $c ''' $. $( Threefold straight apostrophe (function value symbol) $)
  $c (( $.  $( Double left parenthesis $)
  $c )) $.  $( Double right parenthesis $)

  $( Extend the definition of a wff to include the "defined at" predicate.
     (Read:  (The Function) ` F ` is defined at (the argument) ` A ` ).  In a
     previous version, the token "def@" was used.  However, since the @ is used
     (informally) as a replacement for $ in commented out sections that may be
     deleted some day.  While there is no violation of any standard to use the
     @ in a token, it could make the search for such commented-out sections
     slightly more difficult.  (See remark of Norman Megill at
     ~ https://groups.google.com/forum/#!topic/metamath/cteNUppB6A4 ). $)
  wdfat $a wff F defAt A $.

  $( Extend the definition of a class to include the value of a function.
     (Read:  The value of ` F ` at ` A ` , or " ` F ` of ` A ` .").  In a
     previous version, the symbol " ' " was used.  However, since the
     similarity with the symbol ` `` ` used for the current definition of a
     function's value (see ~ df-fv ), which, by the way, was intended to
     visualize that in many cases ` `` ` and " ' " are exchangeable, makes
     reading the theorems, especially those which uses both definitions as
     ~ dfafv2 , very difficult, 3 apostrophes ` ''' ` are used now so that it's
     easier to distinguish from ~ df-fv and ~ df-ima .  And not three backticks
     ( three times ` `` ` ) since that would be annoying to escape in a
     comment.  (See remark of Norman Megill and Gerard Lang at
     ~ https://groups.google.com/forum/#!topic/metamath/cteNUppB6A4 ). $)
  cafv $a class ( F ''' A ) $.

  $( Extend class notation to include the value of an operation ` F ` (such as
     ` + ` ) for two arguments ` A ` and ` B ` .  Note that the syntax is
     simply three class symbols in a row surrounded by special parentheses
     (exclamation mark with underscore) in contrast to the current definition,
     see ~ df-ov . $)
  caov $a class (( A F B )) $.

  $( Definition of the predicate that determines if some class ` F ` is defined
     as function for an argument ` A ` or, in other words, if the function
     value for some class ` F ` for an argument ` A ` is defined.  We say that
     ` F ` is defined at ` A ` if a ` F ` is a function restricted to the
     member ` A ` of its domain.  (Contributed by Alexander van der Vekens,
     25-May-2017.) $)
  df-dfat $a |- ( F defAt A <-> ( A e. dom F /\ Fun ( F |` { A } ) ) ) $.

  ${
    $d x A $.  $d x F $.
    $( Alternative definition of the value of a function, ` ( F ''' A ) ` ,
       also known as function application.  In contrast to ` ( F `` A ) = (/) `
       (see ~ df-fv and ~ ndmfv ), ` ( F ''' A ) = _V ` if F is not defined for
       A!  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
    df-afv $a |- ( F ''' A ) = if ( F defAt A , ( iota x A F x ) , _V ) $.
  $}

  $( Define the value of an operation.  In contrast to ~ df-ov , the
     alternative definition for a function value ( see ~ df-afv ) is used.  By
     this, the value of the operation applied to two arguments is the universal
     class if the operation is not defined for these two arguments.  There are
     still no restrictions of any kind on what those class expressions may be,
     although only certain kinds of class expressions - a binary operation
     ` F ` and its arguments ` A ` and ` B ` - will be useful for proving
     meaningful theorems.  (Contributed by Alexander van der Vekens,
     26-May-2017.) $)
  df-aov $a |- (( A F B )) = ( F ''' <. A , B >. ) $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Restricted quantification (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d X x $.  $d A x $.  $d ph x $.  $d th x $.
    ralbinrald.1 $e |- ( ph -> X e. A ) $.
    ralbinrald.2 $e |- ( x e. A -> x = X ) $.
    ralbinrald.3 $e |- ( x = X -> ( ps <-> th ) ) $.
    $( Elemination of a restricted universal quantification under certain
       conditions.  (Contributed by Alexander van der Vekens, 2-Aug-2017.) $)
    ralbinrald $p |- ( ph -> ( A. x e. A ps <-> th ) ) $=
      ( wral cv wceq wb adantl rspcdv wcel wa bicomd syl biimpd ralrimdva
      impbid ) ABDEJCABCDFEGDKZFLZBCMAINOACBDEAUCEPZQCBUECBMZAUEUDUFHUDBCIRSNTU
      AUB $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       The universal class (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( If a class is the universal class it doesn't belong to any class,
     generalisation of ~ nvel .  (Contributed by Alexander van der Vekens,
     26-May-2017.) $)
  nvelim $p |- ( A = _V -> -. A e. B ) $=
    ( cvv wceq wcel nvel wb eleq1 eqcoms mtbii ) ACDCBEZABEZBFKLGCACABHIJ $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
            Introduce the Axiom of Power Sets (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( If a statement holds for all sets, there is not a unique set for which the
     statement holds.  (Contributed by Alexander van der Vekens,
     28-Nov-2017.) $)
  alneu $p |- ( A. x ph -> -. E! x ph ) $=
    ( weu wal wn wex eunex exnal sylib con2i ) ABCZABDZKAEBFLEABGABHIJ $.

  ${
    $d A y $.  $d V y $.
    $( If there is a unique second component in an ordered pair contained in a
       given set, the first component must be a set.  (Contributed by Alexander
       van der Vekens, 29-Nov-2017.) $)
    eu2ndop1stv $p |- ( E! y <. A , y >. e. V -> A e. _V ) $=
      ( cv cop wcel wex weu cvv euex wi nfeu1 nfcv nfel1 wn wa c0 opprc1 eleq1d
      nfim wal ax-17 alneu syl syl6bi impcom eubidv notbid adantl mpbird exlimi
      wb ex con4d mpcom ) BADZEZCFZAGURAHZBIFZURAJURUSUTKAUSUTAURALABIABMNTURUT
      USURUTOZUSOZURVAPVBQCFZAHZOZVAURVEVAURVCVEVAUQQCBUPRSZVCVCAUAVEVCAUBVCAUC
      UDUEUFVAVBVEULURVAUSVDVAURVCAVFUGUHUIUJUMUNUKUO $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Relations (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Distribute proper substitution through a relation predicate.  (Contributed
     by Alexander van der Vekens, 23-Jul-2017.) $)
  sbcrel $p |- ( A e. V -> ( [. A / x ]. Rel R <-> Rel [_ A / x ]_ R ) ) $=
    ( wcel cvv cxp wss wsbc sbcssg csbconstg sseq2d bitrd df-rel sbcbii 3bitr4g
    csb wrel ) BDEZCFFGZHZABIZABCQZTHZCRZABIUCRSUBUCABTQZHUDABCTDJSUFTUCABTDKLM
    UEUAABCNOUCNP $.

  ${
    $d A w y $.  $d B w y $.  $d V w y $.  $d x w y $.
    $( Distribute proper substitution through the domain of a class.
       (Contributed by Alexander van der Vekens, 23-Jul-2017.)  (Revised by NM,
       24-Aug-2018.) $)
    csbdm $p |- [_ A / x ]_ dom B = dom [_ A / x ]_ B $=
      ( vy vw cv cop wcel wex cab csb cdm csbab sbcex2 sbcel2 exbii bitri abbii
      wsbc dfdm3 eqtri csbeq2i 3eqtr4i ) ABDFEFGZCHZEIZDJZKZUDABCKZHZEIZDJZABCL
      ZKUILUHUFABSZDJULUFADBMUNUKDUNUEABSZEIUKUEEABNUOUJEABUDCOPQRUAABUMUGDECTU
      BDEUITUC $.

    $( Distribute proper substitution through the domain of a class.
       (Contributed by Alexander van der Vekens, 23-Jul-2017.)  Obsolete as of
       24-Aug-2018.  Use ~ csbdm instead.  (New usage is discouraged.)
       (Proof modification is discouraged.) $)
    csbdmgOLD $p |- ( A e. V -> [_ A / x ]_ dom B = dom [_ A / x ]_ B ) $=
      ( vy vw wcel cv cop wex cab csb cdm csbabgOLD sbcexgOLD sbcel2gOLD exbidv
      wsbc bitrd dfdm3 abbidv eqtrd csbeq2i 3eqtr4g ) BDGZABEHFHIZCGZFJZEKZLZUF
      ABCLZGZFJZEKZABCMZLUKMUEUJUHABRZEKUNUHAEBDNUEUPUMEUEUPUGABRZFJUMUGFABDOUE
      UQULFABUFCDPQSUAUBABUOUIEFCTUCEFUKTUD $.
  $}

  ${
    $d A x y $.  $d B x y $.  $d C x y $.  $d V x y $.
    dmmpt2g.1 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( Domain of a class given by the "maps to" notation, closed form of
       ~ dmmpt2 .  (Contributed by Alexander van der Vekens, 1-Jun-2017.) $)
    dmmpt2g $p |- ( C e. V -> dom F = ( A X. B ) ) $=
      ( wcel wral cxp wfn cdm wceq cv wa simpl ralrimivva fnmpt2 fndm 3syl ) EG
      IZUBBDJACJFCDKZLFMUCNUBUBABCDUBAOCIBODIPQRABCDEFGHSUCFTUA $.
  $}

  $( Element of the domain of a restriction to a singleton.  (Contributed by
     Alexander van der Vekens, 2-Jul-2017.) $)
  eldmressn $p |- ( B e. dom ( F |` { A } ) -> B = A ) $=
    ( wceq csn cdm cin cres wcel wa elin elsni adantr sylbi dmres eleq2s ) BADZ
    BAEZCFZGZCRHFBTIBRIZBSIZJQBRSKUAQUBBALMNCROP $.

  $( The domain of a restriction to a singleton is a singleton.  (Contributed
     by Alexander van der Vekens, 2-Jul-2017.) $)
  dmressnsn $p |- ( A e. dom F -> dom ( F |` { A } ) = { A } ) $=
    ( cdm wcel csn cres cin dmres wss wceq snssi df-ss sylib syl5eq ) ABCZDZBAE
    ZFCQOGZQBQHPQOIRQJAOKQOLMN $.


  $( The element of the domain of a restriction to a singleton is the element
     of the singleton.  (Contributed by Alexander van der Vekens,
     2-Jul-2017.) $)
  eldmressnsn $p |- ( A e. dom F -> A e. dom ( F |` { A } ) ) $=
    ( cdm wcel csn cres snidg dmressnsn eleqtrrd ) ABCZDAAEZBKFCAJGABHI $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Functions (extension)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d A w y z $.  $d F w y z $.  $d V w y z $.  $d x w y z $.
    $( Distribute proper substitution through the function predicate.
       (Contributed by Alexander van der Vekens, 23-Jul-2017.) $)
    sbcfung $p |- ( A e. V -> ( [. A / x ]. Fun F <-> Fun [_ A / x ]_ F ) ) $=
      ( vw vz vy wrel cv wbr wi wal wex wa wsbc csb wfun sbcal csbconstg syl5bb
      wcel weq sbcan sbcrel sbcex2 sbcimg sbcbr123 breq12d imbi12d bitrd albidv
      sbcg exbidv anbi12d dffun3 sbcbii 3bitr4g ) BDUAZCHZEIZFIZCJZFGUBZKZFLZGM
      ZELZNZABOZABCPZHZUTVAVJJZVCKZFLZGMZELZNZCQZABOVJQVIUSABOZVGABOZNURVQUSVGA
      BUCURVSVKVTVPABCDUDVTVFABOZELURVPVFEABRURWAVOEWAVEABOZGMURVOVEGABUEURWBVN
      GWBVDABOZFLURVNVDFABRURWCVMFURWCVBABOZVCABOZKVMVBVCABDUFURWDVLWEVCWDABUTP
      ZABVAPZVJJURVLABUTVACUGURWFUTWGVAVJABUTDSABVADSUHTVCABDULUIUJUKTUMTUKTUNT
      VRVHABEFGCUOUPEFGVJUOUQ $.
  $}

  $( If a function's value at an argument is the universal class (which can
     never be the case because of ~ fvex ), the function's value at this
     argument is any set (especially the empty set).  In short "If a function's
     value is a proper class, it is a set", which sounds strange/contradictory,
     but which is a consequence of that a contradiction implies anything ( see
     ~ pm2.21i ).  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  fveqvfvv $p |- ( ( F ` A ) = _V -> ( F ` A ) = B ) $=
    ( cfv wceq cvv wcel wi fvex eleq1a ax-mp vprc pm2.21i syl eqcoms ) ACDZBEZF
    PFPEZFFGZQPFGRSHACIPFFJKSQLMNO $.

  $( Composition of two functions, generalization of ~ funco .  (Contributed by
     Alexander van der Vekens, 25-Jul-2017.) $)
  funresfunco $p |- ( ( Fun ( F |` ran G ) /\ Fun G ) -> Fun ( F o. G ) ) $=
    ( crn cres wfun ccom funco wss wceq ssid cores ax-mp eqcomi funeqi sylibr
    wa ) ABCZDZEBEPRBFZEABFZERBGTSSTQQHSTIQJABQKLMNO $.

  $( Composition of two functions, similar to ~ fnco .  (Contributed by
     Alexander van der Vekens, 25-Jul-2017.) $)
  fnresfnco $p |- ( ( ( F |` ran G ) Fn ran G /\ G Fn B )
                    -> ( F o. G ) Fn B ) $=
    ( crn cres wfn wa ccom wfun cdm wceq fnfun funresfunco syl2an wss cin dmres
    fndm eqeq1i syl df-ss biimpri sylbi adantr dmcosseq adantl eqtrd sylanbrc
    df-fn ) BCDZEZUJFZCAFZGZBCHZIZUOJZAKUOAFULUKICIUPUMUJUKLACLBCMNUNUQCJZAUNUJ
    BJZOZUQURKULUTUMULUKJZUJKZUTUJUKRVBUJUSPZUJKZUTVAVCUJBUJQSUTVDUJUSUAUBUCTUD
    BCUETUMURAKULACRUFUGUOAUIUH $.

  $( A composition restricted to a singleton is a function under certain
     conditions.  (Contributed by Alexander van der Vekens, 25-Jul-2017.) $)
  funcoressn $p |- ( ( ( ( G ` X ) e. dom F /\ Fun ( F |` { ( G ` X ) } ) )
                       /\ ( G Fn A /\ X e. A ) )
                     -> Fun ( ( F o. G ) |` { X } ) ) $=
    ( cfv cdm wcel csn cres wfun wa wfn ccom crn wceq syl adantr adantl fnfun
    wi dmressnsn df-fn simplbi2com imp cima fnsnfv df-ima reseq2d fneq12d mpbid
    syl6eq funres funfn sylib fnresfnco syl2anc resco funeqi sylibr ) DCEZBFGZB
    UTHZIZJZKZCALZDAGZKZKZBCDHZIZMZJZBCMVJIZJVIVLVKFZLZVMVIBVKNZIZVQLZVKVOLZVPV
    IVCVBLZVSVEWAVHVAVDWAVAVCFVBOZVDWATUTBUAWAVDWBVCVBUBUCPUDQVIVBVQVCVRVIVBVQB
    VIVBCVJUEZVQVHVBWCOVEADCUFRCVJUGUKZUHWDUIUJVHVTVEVFVTVGVFCJZVTACSWEVKJVTVJC
    ULVKUMUNPQRVOBVKUOUPVOVLSPVNVLBCVJUQURUS $.

  ${
    $d A x y $.  $d F x y $.  $d G x y $.  $d X x y $.  $d A z $.  $d F z $.
    $d G z $.  $d X z $.  $d y z $.
    $( A restriction to a singleton with a function value is a function under
       certain conditions.  (Contributed by Alexander van der Vekens,
       25-Jul-2017.) $)
    funressnfv $p |- ( ( ( X e. dom ( F o. G ) /\ Fun ( ( F o. G ) |` { X } ) )
                         /\ ( G Fn A /\ X e. A ) )
                       -> Fun ( F |` { ( G ` X ) } ) ) $=
      ( vx vy vz cdm wcel wfun wa cv wbr wmo wi wceq adantl wb eqcoms ex relres
      ccom csn cres wfn cfv wrel a1i dmfco biimpd funfni dmressnsn eleq2 dffun7
      wral elsn snidg adantr mpbid wal fvex isseti eqcom fnbrfvb syl5bb biimpcd
      wex breq1 anim12ii eximdv mpi cvv simpr vex brcog sylancl mpbird biantrud
      brres syl6rbbr ad2antlr alrimiv moim syl com23 rspcimdv com13 sylbi mpcom
      sylibd imp31 snid biantru mobidv syl6rbb syl6bi syl6com ralrimiv sylanbrc
      a1d pm2.43i ) DBCUBZHZIZXBDUCZUDZJZKCAUEZDAIZKZKZBDCUFZUCZUDZUGZELZFLZXNM
      ZFNZEXNHZUOXNJXOXKBXMUAUHXKXSEXTXKXPXTIZXSOZXDXGXJXKYBOZXDXJYCOXGXJXDXLBH
      IZYCXDYDOADCCJDCHIKXDYDDBCUIUJUKYDXTXMPZYCXLBULYEYAXKXSYEYAXPXMIZXKXSOZXT
      XMXPUMYFXPXLPZYGEXLUPYHXKXSYHXKKZXLXQBMZXLXMIZKZFNZXSXKYMYHXKYJFNZYMXDXGX
      JYNXFHZXEPZXDXGXJYNOZODXBULXGXDYPYQXGXFUGZXPXQXFMZFNZEYOUOZKXDYPYQOOZEFXF
      UNUUAUUBYRYPXDUUAYQYPXDUUAYQOYPXDKZYTYQEDYOUUCDXEIZDYOIZXDUUDYPDXCUQQYPUU
      DUUERZXDUUFXEYOXEYODUMSURUSUUCXPDPZKZXJYTYNUUHXJYTYNOZUUHXJKZYJYSOZFUTUUI
      UUJUUKFUUJYJDXQXFMZYSXJYJUULOUUHXJYJUULXJYJKZUULDXQXBMZUUMUUNDGLZCMZUUOXQ
      BMZKZGVGZUUMUUOXLPZGVGUUSGXLDCVAZVBUUMUUTUURGXJUUTUUPYJUUQXJUUTUUPUUTXLUU
      OPXJUUPUUOXLVCADUUOCVDVEUJUUTYJUUQYJUUQRXLUUOXLUUOXQBVHSVFVIVJVKXJUUNUUSR
      ZYJXJXIXQVLIUVBXHXIVMFVNZGDXQBCAVLVOVPURVQXIUULUUNRXHYJXIUUNUUNUUDKUULXIU
      UDUUNDAUQVRDXQXBXEUVCVSVTWAVQTQUUGUULYSRZUUCXJUVDDXPDXPXQXFVHSWAWJWBYJYSF
      WCWDTWEWFTWGQWHWGWIWKXKYJYLFYJYLRXKYKYJXLUVAWLWMUHWNUSQYIYLXRFYHYLXRRXKYH
      XRXLXQXNMYLXPXLXQXNVHXLXQBXMUVCVSWOURWNUSTWHWPWEWDWQWTWKXAWREFXNUNWS $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Predicate "defined at"
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    dfateq12d.1 $e |- ( ph -> F = G ) $.
    dfateq12d.2 $e |- ( ph -> A = B ) $.
    $( Equality deduction for "defined at".  (Contributed by Alexander van der
       Vekens, 26-May-2017.) $)
    dfateq12d $p |- ( ph -> ( F defAt A <-> G defAt B ) ) $=
      ( cdm wcel cres wfun wa wdfat dmeqd eleq12d sneqd reseq12d funeqd df-dfat
      csn anbi12d 3bitr4g ) ABDHZIZDBTZJZKZLCEHZIZECTZJZKZLBDMCEMAUDUIUGULABCUC
      UHGADEFNOAUFUKADEUEUJFABCGPQRUABDSCESUB $.
  $}

  ${
    nfdfat.1 $e |- F/_ x F $.
    nfdfat.2 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for "defined at".  To prove a
       deduction version of this theorem is not easily possible because many
       deduction versions for bound-variable hypothesis builder for constructs
       the definition of "defined at" is based on are not available (e.g. for
       Fun/Rel, dom, C_, etc.).  (Contributed by Alexander van der Vekens,
       26-May-2017.) $)
    nfdfat $p |- F/ x F defAt A $=
      ( wdfat cdm wcel csn cres wfun wa df-dfat nfdm nfel nfsn nfres nffun nfan
      nfxfr ) BCFBCGZHZCBIZJZKZLABCMUBUEAABUAEACDNOAUDACUCDABEPQRST $.
  $}

  ${
    $d x y A $.  $d x y F $.
    $( Alternate definition of the predicate "defined at" not using the ` Fun `
       predicate.  (Contributed by Alexander van der Vekens, 22-Jul-2017.) $)
    dfdfat2 $p |- ( F defAt A <-> ( A e. dom F /\ E! y A F y ) ) $=
      ( vx wdfat cdm wcel csn cres wfun wbr weu wral df-dfat wrel relres dffun8
      wa cv eubidv mpbiran anbi2i wb vex a1i ralbidv eldmressnsn eldmressn wceq
      brres breq1 anbi1d elsn biimpri biantrud bitr4d ralbinrald pm5.32i 3bitri
      bitrd ) BCEBCFGZCBHZIZJZRVADSZASZVCKZALZDVCFZMZRVABVFCKZALZRBCNVDVJVAVDVC
      OVJCVBPDAVCQUAUBVAVJVLVAVJVEVFCKZVEVBGZRZALZDVIMVLVAVHVPDVIVAVGVOAVGVOUCV
      AVEVFCVBAUDUJUETUFVAVPVLDVIBBCUGBVECUHVEBUIZVOVKAVQVOVKVNRVKVQVMVKVNVEBVF
      CUKULVQVNVKVNVQDBUMUNUOUPTUQUTURUS $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
       Alternative definition of the value of a function
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x F $.
    $( Alternative definition of ` ( F ''' A ) ` using ` ( F `` A ) `
       directly.  (Contributed by Alexander van der Vekens, 22-Jul-2017.) $)
    dfafv2 $p |- ( F ''' A ) = if ( F defAt A , ( F ` A ) , _V ) $=
      ( vx cafv wdfat wbr cio cvv cif cfv df-afv df-fv eqcomi ifeq1 ax-mp eqtri
      cv wceq ) ABDABEZACQBFCGZHIZSABJZHIZCABKTUBRUAUCRUBTCABLMSTUBHNOP $.
  $}

  ${
    afveq12d.1 $e |- ( ph -> F = G ) $.
    afveq12d.2 $e |- ( ph -> A = B ) $.
    $( Equality deduction for function value, analogous to ~ fveq12d .
       (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    afveq12d $p |- ( ph -> ( F ''' A ) = ( G ''' B ) ) $=
      ( wdfat cfv cvv cif cafv dfateq12d fveq12d eqidd ifbieq12d dfafv2 3eqtr4g
      ) ABDHZBDIZJKCEHZCEIZJKBDLCELASUATJUBJABCDEFGMABCDEFGNAJOPBDQCEQR $.
  $}

  $( Equality theorem for function value, analogous to ~ fveq1 .  (Contributed
     by Alexander van der Vekens, 22-Jul-2017.) $)
  afveq1 $p |- ( F = G -> ( F ''' A ) = ( G ''' A ) ) $=
    ( wceq id eqidd afveq12d ) BCDZAABCHEHAFG $.

  $( Equality theorem for function value, analogous to ~ fveq1 .  (Contributed
     by Alexander van der Vekens, 22-Jul-2017.) $)
  afveq2 $p |- ( A = B -> ( F ''' A ) = ( F ''' B ) ) $=
    ( wceq eqidd id afveq12d ) ABDZABCCHCEHFG $.

  ${
    nfafv.1 $e |- F/_ x F $.
    nfafv.2 $e |- F/_ x A $.
    $( Bound-variable hypothesis builder for function value, analogous to
       ~ nffv .  To prove a deduction version of this analogous to ~ nffvd is
       not easily possible because a deduction version of ~ nfdfat cannot be
       shown easily.  (Contributed by Alexander van der Vekens,
       26-May-2017.) $)
    nfafv $p |- F/_ x ( F ''' A ) $=
      ( cafv wdfat cfv cvv cif dfafv2 nfdfat nffv nfcv nfif nfcxfr ) ABCFBCGZBC
      HZIJBCKQARIABCDELABCDEMAINOP $.
  $}

  ${
    $d A y $.  $d B y $.  $d F y $.  $d x y $.
    $( Move class substitution in and out of a function value, analogous to
       ~ csbfv12gOLD , with a direct proof proposed by Mario Carneiro,
       analogous to ~ csbovgOLD .  (Contributed by Alexander van der Vekens,
       23-Jul-2017.) $)
    csbafv12g $p |- ( A e. V -> [_ A / x ]_ ( F ''' B )
                                = ( [_ A / x ]_ F ''' [_ A / x ]_ B ) ) $=
      ( vy cv cafv csb csbeq1 afveq12d eqeq12d vex nfcsb1v nfafv csbeq1a csbief
      wceq weq vtoclg ) AFGZCDHZIZAUACIZAUADIZHZRABUBIZABCIZABDIZHZRFBEUABRZUCU
      GUFUJAUABUBJUKUDUHUEUIAUABDJAUABCJKLAUAUBUFFMAUDUEAUADNAUACNOAFSCUDDUEAUA
      DPAUACPKQT $.
  $}

  $( If a class is a function restricted to a member of its domain, then the
     function value for this member is equal for both definitions.
     (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  afvfundmfveq $p |- ( F defAt A -> ( F ''' A ) = ( F ` A ) ) $=
    ( wdfat cafv cfv cvv cif dfafv2 iftrue syl5eq ) ABCZABDKABEZFGLABHKLFIJ $.

  $( If a set is not in the domain of a class or the class is not a function
     restricted to the set, then the function value for this set is the
     universe.  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  afvnfundmuv $p |- ( -. F defAt A -> ( F ''' A ) = _V ) $=
    ( wdfat wn cafv cfv cvv cif dfafv2 iffalse syl5eq ) ABCZDABELABFZGHGABILMGJ
    K $.

  $( The value of a class outside its domain is the universe, compare with
     ~ ndmfv .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  ndmafv $p |- ( -. A e. dom F -> ( F ''' A ) = _V ) $=
    ( cdm wcel wn wdfat cafv cvv wceq csn cres wfun df-dfat simplbi afvnfundmuv
    con3i syl ) ABCDZEABFZEABGHISRSRBAJKLABMNPABOQ $.

  $( If the function value of a class for an argument is a set, the argument is
     contained in the domain of the class.  (Contributed by Alexander van der
     Vekens, 25-May-2017.) $)
  afvvdm $p |- ( ( F ''' A ) e. B -> A e. dom F ) $=
    ( cdm wcel cafv wn cvv wceq ndmafv nvelim syl con4i ) ACDEZACFZBEZNGOHIPGAC
    JOBKLM $.

  $( If the restriction of a class to a singleton is not a function, its value
     is the universe, compare with ~ nfunsn (Contributed by Alexander van der
     Vekens, 25-May-2017.) $)
  nfunsnafv $p |- ( -. Fun ( F |` { A } ) -> ( F ''' A ) = _V ) $=
    ( csn cres wfun wn wdfat cafv cvv wceq cdm wcel df-dfat simprbi afvnfundmuv
    con3i syl ) BACDEZFABGZFABHIJSRSABKLRABMNPABOQ $.

  $( If the function value of a class for an argument is a set, the class
     restricted to the singleton of the argument is a function.  (Contributed
     by Alexander van der Vekens, 25-May-2017.) $)
  afvvfunressn $p |- ( ( F ''' A ) e. B -> Fun ( F |` { A } ) ) $=
    ( csn cres wfun cafv wcel wn cvv wceq nfunsnafv nvelim syl con4i ) CADEFZAC
    GZBHZPIQJKRIACLQBMNO $.

  $( A function's value at a proper class is the universe, compare with
     ~ fvprc .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  afvprc $p |- ( -. A e. _V -> ( F ''' A ) = _V ) $=
    ( cvv wcel wn cdm cafv wceq elex con3i ndmafv syl ) ACDZEABFZDZEABGCHOMANIJ
    ABKL $.

  $( If a function's value at an argument is a set, the argument is also a
     set.  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  afvvv $p |- ( ( F ''' A ) e. B -> A e. _V ) $=
    ( cvv wcel cafv wn wceq afvprc nvelim syl con4i ) ADEZACFZBEZMGNDHOGACINBJK
    L $.

  $( If the value of the alternative function at an argument is the universe,
     the function's value at this argument is the empty set.  (Contributed by
     Alexander van der Vekens, 25-May-2017.) $)
  afvpcfv0 $p |- ( ( F ''' A ) = _V -> ( F ` A ) = (/) ) $=
    ( cafv cvv wceq wdfat cfv cif c0 dfafv2 eqeq1i wa wn wo eqcom eqif fveqvfvv
    bitri eqcoms sylbi adantl wne cdm wcel cres wfun fvfundmfvn0 df-dfat sylibr
    csn necon1bi adantr jaoi ) ABCZDEABFZABGZDHZDEZUPIEZUNUQDABJKURUODUPEZLZUOM
    ZDDEZLZNZUSURDUQEVEUQDOUODUPDPRVAUSVDUTUSUOUSUPDAIBQSUAVBUSVCUOUPIUPIUBABUC
    UDBAUJUEUFLUOABUGABUHUIUKULUMTT $.

  $( The value of the alternative function at a set as argument equals the
     function's value at this argument.  (Contributed by Alexander van der
     Vekens, 25-May-2017.) $)
  afvnufveq $p |- ( ( F ''' A ) =/= _V -> ( F ''' A ) = ( F ` A ) ) $=
    ( cafv cfv wceq cvv wn wdfat afvfundmfveq con3i afvnfundmuv syl necon1ai )
    ABCZABDEZNFOGABHZGNFEPOABIJABKLM $.

  $( The value of the alternative function at a set as argument equals the
     function's value at this argument.  (Contributed by Alexander van der
     Vekens, 25-May-2017.) $)
  afvvfveq $p |- ( ( F ''' A ) e. B -> ( F ''' A ) = ( F ` A ) ) $=
    ( cafv wcel cvv wne cfv wceq nvelim necon2ai afvnufveq syl ) ACDZBEZNFGNACH
    IONFNBJKACLM $.

  $( If the value of the alternative function at an argument is the empty set,
     the function's value at this argument is the empty set.  (Contributed by
     Alexander van der Vekens, 25-May-2017.) $)
  afv0fv0 $p |- ( ( F ''' A ) = (/) -> ( F ` A ) = (/) ) $=
    ( cafv cvv wcel c0 wceq cfv wi 0ex eleq1a ax-mp afvvfveq eqeq1 biimpd mpcom
    syl ) ABCZDEZRFGZABHZFGZFDETSIJFDRKLSRUAGZTUBIADBMUCTUBRUAFNOQP $.

  $( If the function's value at an argument is not the empty set, it equals the
     value of the alternative function at this argument.  (Contributed by
     Alexander van der Vekens, 25-May-2017.) $)
  afvfvn0fveq $p |- ( ( F ` A ) =/= (/) -> ( F ''' A ) = ( F ` A ) ) $=
    ( cfv wne wdfat cafv wceq cdm wcel csn cres wfun fvfundmfvn0 df-dfat sylibr
    c0 wa afvfundmfveq syl ) ABCZPDZABEZABFTGUAABHIBAJKLQUBABMABNOABRS $.

  $( The function's value at an argument is an element of a set if and only if
     the value of the alternative function at this argument is an element of
     that set, if the set does not contain the empty set.  (Contributed by
     Alexander van der Vekens, 25-May-2017.) $)
  afv0nbfvbi $p |- ( (/) e/ B -> ( ( F ''' A ) e. B <-> ( F ` A ) e. B ) ) $=
    ( c0 wnel cafv wcel cfv wceq afvvfveq eleq1 biimpd mpcom wi wa wne cdm cres
    csn wfun df-nel nelne2 sylan2b ancoms fvfundmfvn0 wdfat afvfundmfveq sylbir
    wn df-dfat wb eqcoms 4syl ex pm2.43d impbid2 ) DBEZACFZBGZACHZBGZURUTIZUSVA
    ABCJVBUSVAURUTBKLMUQVAUSUQVAVAUSNZUQVAOUTDPZACQGCASRTOZVBVCVAUQVDUQVADBGUIV
    DDBUAUTDBUBUCUDACUEVEACUFVBACUJACUGUHVBVAUSVAUSUKUTURUTURBKULLUMUNUOUP $.

  $( The function's value at an argument is the empty set if and only if the
     value of the alternative function at this argument is either the empty set
     or the universe.  (Contributed by Alexander van der Vekens,
     25-May-2017.) $)
  afvfv0bi $p |- ( ( F ` A ) = (/)
                     <-> ( ( F ''' A ) = (/) \/ ( F ''' A ) = _V ) ) $=
    ( cfv c0 wceq cvv wo wn wa ioran wi wne df-ne afvnufveq sylbir eqeq1 notbid
    cafv biimpd syl impcom sylbi con4i afv0fv0 afvpcfv0 jaoi impbii ) ABCZDEZAB
    RZDEZUJFEZGZUMUIUMHUKHZULHZIUIHZUKULJUOUNUPUOUJUHEZUNUPKUOUJFLUQUJFMABNOUQU
    NUPUQUKUIUJUHDPQSTUAUBUCUKUIULABUDABUEUFUG $.

$( ------------------ $)

  ${
    $d A x $.  $d F x $.
    $( The value of a function at a unique point, analogous to ~ fveu .
       (Contributed by Alexander van der Vekens, 29-Nov-2017.) $)
    afveu $p |- ( E! x A F x -> ( F ''' A ) = U. { x | A F x } ) $=
      ( cvv wcel cv wbr weu cafv cab cuni wceq df-br eubii eu2ndop1stv sylbi wa
      cop cdm wi wex euex eldmg syl5ibrcom impcom dfdfat2 cfv afvfundmfveq fveu
      wdfat sylan9eq ex sylbir expcom pm2.43a adantl mpd mpancom ) BDEZBAFZCGZA
      HZBCIZVAAJKZLZVBBUTRCEZAHUSVAVFABUTCMNABCOPUSVBQBCSEZVEVBUSVGVBVGUSVAAUAV
      AAUBABCDUCUDUEVBVGVETUSVGVBVEVGVBVBVETZVGVBQBCUJZVHABCUFVIVBVEVIVBVCBCUGV
      DBCUHABCUIUKULUMUNUOUPUQUR $.
  $}

  $( Equivalence of function value and binary relation, analogous to
     ~ fnbrfvb .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  fnbrafvb $p |- ( ( F Fn A /\ B e. A ) ->
                   ( ( F ''' B ) = C <-> B F C ) ) $=
    ( wfn wcel wa cafv wceq cfv wbr cdm csn cres wfun wi fndm wb eleq2 syl imp
    eqcoms biimpd snssi adantl fnssresb adantr fnfun wdfat df-dfat afvfundmfveq
    wss mpbird sylbir syl2anc eqeq1d fnbrfvb bitrd ) DAEZBAFZGZBDHZCIBDJZCIBCDK
    VAVBVCCVABDLZFZDBMZNZOZVBVCIZUSUTVEUSVDAIZUTVEPADQVJUTVEUTVERAVDAVDBSUBUCTU
    AVAVGVFEZVHVAVKVFAULZUTVLUSBAUDUEUSVKVLRUTAVFDUFUGUMVFVGUHTVEVHGBDUIVIBDUJB
    DUKUNUOUPABCDUQUR $.

  $( Equivalence of function value and ordered pair membership, analogous to
     ~ fnopfvb .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  fnopafvb $p |- ( ( F Fn A /\ B e. A ) ->
                   ( ( F ''' B ) = C <-> <. B , C >. e. F ) ) $=
    ( wfn wcel wa cafv wceq wbr cop fnbrafvb df-br syl6bb ) DAEBAFGBDHCIBCDJBCK
    DFABCDLBCDMN $.

  $( Equivalence of function value and binary relation, analogous to
     ~ funbrfvb .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  funbrafvb $p |- ( ( Fun F /\ A e. dom F ) ->
                   ( ( F ''' A ) = B <-> A F B ) ) $=
    ( wfun cdm wfn wcel cafv wceq wbr wb funfn fnbrafvb sylanb ) CDCCEZFAOGACHB
    IABCJKCLOABCMN $.

  $( Equivalence of function value and ordered pair membership, analogous to
     ~ funopfvb .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  funopafvb $p |- ( ( Fun F /\ A e. dom F ) ->
                   ( ( F ''' A ) = B <-> <. A , B >. e. F ) ) $=
    ( wfun cdm wfn wcel cafv wceq cop wb funfn fnopafvb sylanb ) CDCCEZFAOGACHB
    IABJCGKCLOABCMN $.

  $( The second argument of a binary relation on a function is the function's
     value, analogous to ~ funbrfv .  (Contributed by Alexander van der Vekens,
     25-May-2017.) $)
  funbrafv $p |- ( Fun F -> ( A F B -> ( F ''' A ) = B ) ) $=
    ( wfun wbr cafv wceq wi wrel funrel wa cdm releldm funbrafvb biimprd expcom
    wcel syl ex pm2.43i com14 com13 ) CDZABCEZACFBGZHZUCCIZUCUFHZCJUDUCUGUEUDUC
    UGUEHHUGUDUCUDUEUGUDUHUGUDKACLQZUHABCMUCUIUFUCUIKUEUDABCNOPRSUATUBRT $.

  ${
    $d x y z w A $.  $d x y B $.  $d x y z w F $.  $d x y C $.
    $( Function value in terms of a binary relation, analogous to
       ~ funbrfv2b .  (Contributed by Alexander van der Vekens,
       25-May-2017.) $)
    funbrafv2b $p |- ( Fun F ->
                       ( A F B <-> ( A e. dom F /\ ( F ''' A ) = B ) ) ) $=
      ( wfun wbr wcel wa cafv wceq wrel wi funrel releldm ex pm4.71rd funbrafvb
      cdm syl pm5.32da bitr4d ) CDZABCEZACQFZUBGUCACHBIZGUAUBUCUACJZUBUCKCLUEUB
      UCABCMNROUAUCUDUBABCPST $.

    $( Representation of a function in terms of its values, analogous to
       ~ dffn5 (only one direction of implication!).  (Contributed by Alexander
       van der Vekens, 25-May-2017.) $)
    dfafn5a $p |- ( F Fn A -> F = ( x e. A |-> ( F ''' x ) ) ) $=
      ( vy wfn cv wcel cafv wceq wa copab cmpt wrel fnrel dfrel4v sylib fnbr ex
      wbr pm4.71rd eqcom fnbrafvb syl5bb pm5.32da bitr4d opabbidv eqtrd syl6eqr
      df-mpt ) CBEZCAFZBGZDFZUKCHZIZJZADKZABUNLUJCUKUMCSZADKZUQUJCMCUSIBCNADCOP
      UJURUPADUJURULURJUPUJURULUJURULBUKUMCQRTUJULUOURUOUNUMIUJULJURUMUNUABUKUM
      CUBUCUDUEUFUGADBUNUIUH $.

    $( Representation of a function in terms of its values, analogous to
       ~ dffn5 (only if it is assumed that the function value for each x is a
       set).  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
    dfafn5b $p |- ( A. x e. A ( F ''' x ) e. V
                    -> ( F Fn A <-> F = ( x e. A |-> ( F ''' x ) ) ) ) $=
      ( cv cafv wcel wral cmpt wceq dfafn5a eqid fnmpt fneq1 syl5ibrcom impbid2
      wfn ) AECFZDGABHZCBQZCABRIZJZABCKSTUBUABQABRUADUALMBCUANOP $.

    $( The range of a function expressed as a collection of the function's
       values, analogous to ~ fnrnfv .  (Contributed by Alexander van der
       Vekens, 25-May-2017.) $)
    fnrnafv $p |- ( F Fn A -> ran F = { y | E. x e. A y = ( F ''' x ) } ) $=
      ( wfn crn cv cafv cmpt wceq wrex cab dfafn5a rneqd eqid rnmpt syl6eq ) DC
      EZDFACAGDHZIZFBGSJACKBLRDTACDMNABCSTTOPQ $.

    $( A member of a function's range is a value of the function, analogous to
       ~ fvelrnb with the additional requirement that the member must be a
       set.  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
    afvelrnb $p |- ( ( F Fn A /\ B e. V )
                     -> ( B e. ran F <-> E. x e. A ( F ''' x ) = B ) ) $=
      ( vy wfn wcel wa crn cv cafv wceq wrex cab fnrnafv adantr eleq2d wb eqeq1
      eqcom syl6bb rexbidv elabg adantl bitrd ) DBGZCEHZIZCDJZHCFKZAKDLZMZABNZF
      OZHZULCMZABNZUIUJUOCUGUJUOMUHAFBDPQRUHUPURSUGUNURFCEUKCMZUMUQABUSUMCULMUQ
      UKCULTCULUAUBUCUDUEUF $.

    $( A member of a function's range is a value of the function, only one
       direction of implication of ~ fvelrnb .  (Contributed by Alexander van
       der Vekens, 1-Jun-2017.) $)
    afvelrnb0 $p |- ( F Fn A
                      -> ( B e. ran F -> E. x e. A ( F ''' x ) = B ) ) $=
      ( vy wfn crn wcel cv cafv wceq wrex cab fnrnafv eleq2d eqeq1 eqcom syl6bb
      rexbidv elabg ibi syl6bi ) DBFZCDGZHCEIZAIDJZKZABLZEMZHZUFCKZABLZUCUDUICA
      EBDNOUJULUHULECUIUECKZUGUKABUMUGCUFKUKUECUFPCUFQRSTUAUB $.

    $( Alternate definition of the image of a function, analogous to
       ~ dfimafn .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
    dfaimafn $p |- ( ( Fun F /\ A C_ dom F ) ->
                  ( F " A ) = { y | E. x e. A ( F ''' x ) = y } ) $=
      ( wfun cdm wss wa cv cafv wceq wrex cab wbr cima wcel wb ssel funbrafvb
      ex syl9r imp31 rexbidva abbidv dfima2 syl6reqr ) DEZCDFZGZHZAIZDJBIZKZACL
      ZBMUKULDNZACLZBMDCOUJUNUPBUJUMUOACUGUIUKCPZUMUOQZUIUQUKUHPZUGURCUHUKRUGUS
      URUKULDSTUAUBUCUDABDCUEUF $.

    $( Alternate definition of the image of a function as an indexed union of
       singletons of function values, analogous to ~ dfimafn2 .  (Contributed
       by Alexander van der Vekens, 25-May-2017.) $)
    dfaimafn2 $p |- ( ( Fun F /\ A C_ dom F ) ->
                   ( F " A ) = U_ x e. A { ( F ''' x ) } ) $=
      ( vy wfun cdm wss wa cima cv cafv wceq cab ciun csn wrex dfaimafn syl6eqr
      iunab wcel df-sn eqcom abbii eqtri a1i iuneq2i ) CEBCFGHZCBIZABAJZCKZDJZL
      ZDMZNZABUJOZNUGUHULABPDMUNADBCQULADBSRABUOUMUOUMLUIBTUOUKUJLZDMUMDUJUAUPU
      LDUKUJUBUCUDUEUFR $.

    $( Function value in an image, analogous to ~ fvelima .  (Contributed by
       Alexander van der Vekens, 25-May-2017.) $)
    afvelima $p |- ( ( Fun F /\ A e. ( F " B ) ) ->
                  E. x e. B ( F ''' x ) = A ) $=
      ( wfun cima wcel cafv wceq wrex wbr elimag ibi funbrafv reximdv syl5 imp
      cv ) DEZBDCFZGZARZDHBIZACJZUAUBBDKZACJZSUDUAUFABDCTLMSUEUCACUBBDNOPQ $.
  $}

  $( A function's value belongs to its range, analogous to ~ fvelrn .
     (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  afvelrn $p |- ( ( Fun F /\ A e. dom F ) -> ( F ''' A ) e. ran F ) $=
    ( wfun cdm wcel wa cfv cafv crn wdfat wceq csn funres anim1i ancomd df-dfat
    cres sylibr afvfundmfveq eqcomd syl fvelrn eqeltrrd ) BCZABDEZFZABGZABHZBIU
    FABJZUGUHKUFUEBALZQCZFUIUFUKUEUDUKUEUJBMNOABPRUIUHUGABSTUAABUBUC $.

  $( A function's value belongs to its range, analogous to ~ fnfvelrn .
     (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  fnafvelrn $p |- ( ( F Fn A /\ B e. A ) -> ( F ''' B ) e. ran F ) $=
    ( cafv crn wcel afvelrn funfni ) BCDCEFABCBCGH $.

  $( A function's value belongs to its codomain, analogous to ~ ffvelrn .
     (Contributed by Alexander van der Vekens, 25-May-2017.) $)
  fafvelrn $p |- ( ( F : A --> B /\ C e. A ) -> ( F ''' C ) e. B ) $=
    ( wf wcel wa cafv crn wfn ffn fnafvelrn sylan wi frn sseld adantr mpd ) ABD
    EZCAFZGCDHZDIZFZUABFZSDAJTUCABDKACDLMSUCUDNTSUBBUAABDOPQR $.

  ${
    $d x y A $.  $d x y B $.  $d x y F $.
    $( A function maps to a class to which all values belong, analogous to
       ~ ffnfv .  (Contributed by Alexander van der Vekens, 25-May-2017.) $)
    ffnafv $p |- ( F : A --> B
                   <-> ( F Fn A /\ A. x e. A ( F ''' x ) e. B ) ) $=
      ( vy wf wfn cv cafv wcel wral wa ffn fafvelrn ralrimiva jca crn wss simpl
      wceq wrex afvelrnb0 nfra1 nfv rsp eleq1 biimpcd syl6 rexlimd sylan9 ssrdv
      wi df-f sylanbrc impbii ) BCDFZDBGZAHZDIZCJZABKZLZUPUQVABCDMUPUTABBCURDNO
      PVBUQDQZCRUPUQVASVBEVCCUQEHZVCJUSVDTZABUAVAVDCJZABVDDUBVAVEVFABUTABUCVFAU
      DVAURBJUTVEVFULUTABUEVEUTVFUSVDCUFUGUHUIUJUKBCDUMUNUO $.
  $}

  $( The value of a restricted function, analogous to ~ fvres .  (Contributed
     by Alexander van der Vekens, 22-Jul-2017.) $)
  afvres $p |- ( A e. B -> ( ( F |` B ) ''' A ) = ( F ''' A ) ) $=
    ( cdm wcel cres wfun wa cafv wceq cfv syl eqcomd funeqd biimpd impcom wdfat
    anim12d df-dfat cvv csn cin elin biimpri dmres syl6eleqr snssi afvfundmfveq
    ex resabs1 sylbir fvres adantl adantr 3eqtrd wn wi pm3.4 sylbi eleq2s com12
    wss con3d afvnfundmuv sylnbir eqtrd pm2.61ian ) ACDZEZCAUAZFZGZHZABEZACBFZI
    ZACIZJVMVNHZVPAVOKZACKZVQVRAVODZEZVOVJFZGZHZVPVSJZVNVMWEVNVIWBVLWDVNVIWBVNV
    IHZABVHUBZWAAWHEZWGABVHUCZUDCBUEZUFUIVNVLWDVNVKWCVNWCVKVNVJBVBWCVKJABUGCVJB
    UJLZMNORPWEAVOQZWFAVOSZAVOUHUKLVNVSVTJVMABCULUMVMVTVQJVNVMVQVTVMACQZVQVTJAC
    SZACUHUKMUNUOVMUPZVNHZVPTVQWRWEUPZVPTJZVNWQWSVNWEVMVNWBVIWDVLWBVNVIVNVIUQZA
    WHWAWIWGXAWJVNVIURUSWKUTVAVNWDVLVNWCVKWLNORVCPWEWMWTWNAVOVDVELWQTVQJVNWQVQT
    VMWOVQTJWPACVDVEMUNVFVG $.

  ${
    $d x y A $.  $d x y F $.
    $( Function value.  Theorem 6.12(1) of [TakeutiZaring] p. 27, analogous to
       ~ tz6.12 .  (Contributed by Alexander van der Vekens, 29-Nov-2017.) $)
    tz6.12-afv $p |- ( ( <. A , y >. e. F /\ E! y <. A , y >. e. F )
                        -> ( F ''' A ) = y ) $=
      ( vx cvv wcel cv cop weu wa cafv wceq wi wbr simpl adantl com12 sylbir ex
      syl cfv cdm csn cres wfun vex a1i df-br biimpri breldmg syl3anc wral elsn
      wb breq1 syl5bbr eqcoms eubidv biimpd sylbi ralrimiv wfn fnres fnfun impr
      jca wdfat df-dfat afvfundmfveq tz6.12 eqtrd eu2ndop1stv pm2.24d pm2.61i
      wn ) BEFZBAGZHCFZVRAIZJZBCKZVQLZMVPVTWBVPVTJZWABCUAZVQWCBCUBFZCBUCZUDZUEZ
      JZWAWDLZVPVRVSWIVPVRJZWEVSWIMWKVPVQEFZBVQCNZWEVPVROWLWKAUFUGVRWMVPWMVRBVQ
      CUHZUIPBVQEECUJUKWEVSWIWEVSJZWEWHWEVSOWODGZVQCNZAIZDWFULZWHWOWRDWFVSWPWFF
      ZWRMWEWTVSWRWTWPBLZVSWRMDBUMXAVSWRXAVRWQAVRWQUNBWPVRWMBWPLWQWNBWPVQCUOUPU
      QURUSUTQPVAWSWGWFVBWHDAWFCVCWFWGVDRTVFSTVEWIBCVGWJBCVHBCVIRTVTWDVQLVPABCV
      JPVKSVTVPVOZWBVSXBWBMVRVSVPWBABCVLVMPQVN $.

    $( Function value (Theorem 6.12(1) of [TakeutiZaring] p. 27, analogous to
       ~ tz6.12-1 .  (Contributed by Alexander van der Vekens, 29-Nov-2017.) $)
    tz6.12-1-afv $p |- ( ( A F y /\ E! y A F y ) -> ( F ''' A ) = y ) $=
      ( cv wbr cop wcel weu cafv wceq df-br eubii tz6.12-afv syl2anb ) BADZCEZB
      OFCGZQAHBCIOJPAHBOCKZPQARLABCMN $.
  $}

  $( Domains of a function composition, analogous to ~ dmfco .  (Contributed by
     Alexander van der Vekens, 23-Jul-2017.) $)
  dmfcoafv $p |- ( ( Fun G /\ A e. dom G ) ->
                   ( A e. dom ( F o. G ) <-> ( G ''' A ) e. dom F ) ) $=
    ( wfun cdm wcel wa ccom cfv cafv dmfco cres wceq funres anim2i ancoms wdfat
    csn df-dfat afvfundmfveq sylbir syl eqcomd eleq1d bitrd ) CDZACEFZGZABCHEFA
    CIZBEZFACJZUJFABCKUHUIUKUJUHUKUIUHUGCARZLDZGZUKUIMZUGUFUNUFUMUGULCNOPUNACQU
    OACSACTUAUBUCUDUE $.

  $( Value of a function composition, analogous to ~ fvco2 .  (Contributed by
     Alexander van der Vekens, 23-Jul-2017.) $)
  afvco2 $p |- ( ( G Fn A /\ X e. A ) -> ( ( F o. G ) ''' X ) =
                 ( F ''' ( G ''' X ) ) ) $=
    ( wcel wa cafv cfv cdm cres wfun wceq adantl imp wdfat df-dfat afvfundmfveq
    wi wn cvv wfn ccom csn fvco2 simpll wb df-fn eleq2 eqcoms biimpd jca sylanb
    syl mpbird funcoressn sylbir syl2anc adantr 3eqtr4d wo funfni bicomd notbid
    dmfco ianor ndmafv syl6com funressnfv afvnfundmuv sylnbir nsyl4 com12 con1d
    ex jaoi sylbi eqcomd eqtrd pm2.61ian eqidd fnfun funres afveq12d ) CAUAZDAE
    ZFZDBCUBZGZDCHZBGZDCGZBGWIBIEZBWIUCJKZFZWFWHWJLWNWFFZDWGHZWIBHZWHWJWFWPWQLW
    NABCDUDMWODWGIEZWGDUCZJKZWHWPLZWOWRWLWLWMWFUEWOCKZDCIZEZFZWRWLUFZWFXEWNWDXB
    XCALZFZWEXECAUGZXHWEFXBXDXBXGWEUEXHWEXDXGWEXDRZXBXGWEXDWEXDUFAXCAXCDUHUIUJM
    ZNUKULMDBCVDZUMUNABCDUOWRWTFZDWGOZXADWGPZDWGQUPUQWNWJWQLZWFWNWIBOZXPWIBPZWI
    BQUPURUSWNSZWFFWHTWJXSWFWHTLZXSWLSZWMSZUTWFXTRZWLWMVEYAYCYBWFYAWRSZXTWFYAYD
    WFWLWRWFWRWLXFADCXLVAVBVCUJDWGVFVGWFYBXTWFXTWMXTSWFWMXMWFWMRXTXMWFWMABCDVHV
    NXMXNXTXODWGVIVJVKVLVMVLVOVPNXSTWJLWFXSWJTWNXQWJTLXRWIBVIVJVQURVRVSWFWIWKBB
    WFBVTWFWKWIWFXDCWSJKZWKWILZWDWEXDWDXHXJXIXKVPNWDYEWEWDXBYEACWAWSCWBUMURXDYE
    FDCOYFDCPDCQUPUQVQWCVR $.

  ${
    $d F w x y z $.  $d ph w x y z $.
    rlimdmafv.1 $e |- ( ph -> F : A --> CC ) $.
    rlimdmafv.2 $e |- ( ph -> sup ( A , RR* , < ) = +oo ) $.
    $( Two ways to express that a function has a limit, analogous to
       ~ rlimdm .  (Contributed by Alexander van der Vekens, 27-Nov-2017.) $)
    rlimdmafv $p |- ( ph -> ( F e. dom ~~>r <-> F ~~>r ( ~~>r ''' F ) ) ) $=
      ( vx vy vz vw crli wcel wbr cv wex wa wceq cvv weq breq2 adantr cdm eldmg
      cafv ibi simpr cfv weu rlimrel brrelexi adantl vex a1i breldmg syl3anc wi
      wdfat wal biimprd spimev cc wf cxr clt csup cpnf simprl simprr rlimuni ex
      alrimivv eu4 sylanbrc dfdfat2 afvfundmfveq syl df-fv wb syl5ibrcom impbid
      cio expr iota5 mpan2 syl5eq eqtrd breqtrrd exlimdv syl5 releldmi impbid1
      ) ACJUAZKZCCJUCZJLZWLCFMZJLZFNZAWNWLWQFCJWKUBUDAWPWNFAWPWNAWPOZCWOWMJAWPU
      EZWRWMCJUFZWOWRCJUPZWMWTPWRWLCGMZJLZGUGZXAWRCQKZWOQKZWPWLWPXEACWOJUHUIUJX
      FWRFUKZULWSCWOQQJUMUNWRXCGNZXCCHMZJLZOZGHRZUOZHUQGUQXDWPXHAWPXCGFGFRXCWPX
      BWOCJSURUSUJWRXMGHWRXKXLWRXKOBXBXICWRBUTCVAZXKAXNWPDTTWRBVBVCVDVEPZXKAXOW
      PETTWRXCXJVFWRXCXJVGVHVIVJXCXJGHXBXICJSVKVLGCJVMVLCJVNVOWRWTCIMZJLZIVTZWO
      ICJVPWRXFXRWOPXGWRXQIWOQWRXQIFRZVQXFWRXQXSAWPXQXSAWPXQOZOBXPWOCAXNXTDTAXO
      XTETAWPXQVGAWPXQVFVHWAWRXQXSWPWSXPWOCJSVRVSTWBWCWDWEWFVIWGWHCWMJUHWIWJ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
      Alternative definition of the value of an operation
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    aoveq123d.1 $e |- ( ph -> F = G ) $.
    aoveq123d.2 $e |- ( ph -> A = B ) $.
    aoveq123d.3 $e |- ( ph -> C = D ) $.
    $( Equality deduction for operation value, analogous to ~ oveq123d .
       (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    aoveq123d $p |- ( ph -> (( A F C )) = (( B G D )) ) $=
      ( cop cafv caov opeq12d afveq12d df-aov 3eqtr4g ) ABDKZFLCEKZGLBDFMCEGMAR
      SFGHABCDEIJNOBDFPCEGPQ $.
  $}

  ${
    nfaov.2 $e |- F/_ x A $.
    nfaov.3 $e |- F/_ x F $.
    nfaov.4 $e |- F/_ x B $.
    $( Bound-variable hypothesis builder for operation value, analogous to
       ~ nfov .  To prove a deduction version of this analogous to ~ nfovd is
       not quickly possible because many deduction versions for bound-variable
       hypothesis builder for constructs the definition of alternative
       operation values is based on are not available (see ~ nfafv ).
       (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    nfaov $p |- F/_ x (( A F B )) $=
      ( caov cop cafv df-aov nfop nfafv nfcxfr ) ABCDHBCIZDJBCDKAODFABCEGLMN $.
  $}

  ${
    $d x y $.  $d y A $.  $d y B $.  $d y C $.  $d y F $.
    $( Move class substitution in and out of an operation.  (Contributed by
       Alexander van der Vekens, 26-May-2017.) $)
    csbaovg $p |- ( A e. D -> [_ A / x ]_ (( B F C )) =
           (( [_ A / x ]_ B [_ A / x ]_ F [_ A / x ]_ C )) ) $=
      ( vy caov csb wceq csbeq1 aoveq123d eqeq12d vex nfcsb1v nfaov weq csbeq1a
      cv csbief vtoclg ) AGSZCDFHZIZAUBCIZAUBDIZAUBFIZHZJABUCIZABCIZABDIZABFIZH
      ZJGBEUBBJZUDUIUHUMAUBBUCKUNUEUJUFUKUGULAUBBFKAUBBCKAUBBDKLMAUBUCUHGNAUEUF
      UGAUBCOAUBFOAUBDOPAGQCUEDUFFUGAUBFRAUBCRAUBDRLTUA $.
  $}

  $( If a class is a function restricted to an ordered pair of its domain, then
     the value of the operation on this pair is equal for both definitions.
     (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  aovfundmoveq $p |- ( F defAt <. A , B >. -> (( A F B )) = ( A F B ) ) $=
    ( cop wdfat cafv cfv caov co afvfundmfveq df-aov df-ov 3eqtr4g ) ABDZCENCFN
    CGABCHABCINCJABCKABCLM $.

  $( If an ordered pair is not in the domain of a class or the class is not a
     function restricted to the ordered pair, then the operation value for this
     pair is the universal class.  (Contributed by Alexander van der Vekens,
     26-May-2017.) $)
  aovnfundmuv $p |- ( -. F defAt <. A , B >. -> (( A F B )) = _V ) $=
    ( cop wdfat wn caov cafv cvv df-aov afvnfundmuv syl5eq ) ABDZCEFABCGMCHIABC
    JMCKL $.

  $( The value of an operation outside its domain, analogous to ~ ndmafv .
     (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  ndmaov $p |- ( -. <. A , B >. e. dom F -> (( A F B )) = _V ) $=
    ( cop cdm wcel wn caov cafv cvv df-aov ndmafv syl5eq ) ABDZCEFGABCHNCIJABCK
    NCLM $.

  $( The value of an operation outside its domain, analogous to ~ ndmovg .
     (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  ndmaovg $p |- ( ( dom F = ( R X. S ) /\ -. ( A e. R /\ B e. S ) )
              -> (( A F B )) = _V ) $=
    ( cdm cxp wceq wcel wa wn cop caov cvv opelxp eleq2 eqcoms syl5bbr notbid
    wb biimpa ndmaov syl ) EFZCDGZHZACIBDIJZKZJABLZUDIZKZABEMNHUFUHUKUFUGUJUGUI
    UEIZUFUJABCDOULUJTUEUDUEUDUIPQRSUAABEUBUC $.

  $( If the operation value of a class for an ordered pair is a set, the
     ordered pair is contained in the domain of the class.  (Contributed by
     Alexander van der Vekens, 26-May-2017.) $)
  aovvdm $p |- ( (( A F B )) e. C -> <. A , B >. e. dom F ) $=
    ( caov wcel cop cafv cdm df-aov eleq1i afvvdm sylbi ) ABDEZCFABGZDHZCFODIFN
    PCABDJKOCDLM $.

  $( If the restriction of a class to a singleton is not a function, its
     operation value is the universal class.  (Contributed by Alexander van der
     Vekens, 26-May-2017.) $)
  nfunsnaov $p |- ( -. Fun ( F |` { <. A , B >. } ) -> (( A F B )) = _V ) $=
    ( cop csn cres wfun wn caov cafv cvv df-aov nfunsnafv syl5eq ) CABDZEFGHABC
    IOCJKABCLOCMN $.

  $( If the operation value of a class for an argument is a set, the class
     restricted to the singleton of the argument is a function.  (Contributed
     by Alexander van der Vekens, 26-May-2017.) $)
  aovvfunressn $p |- ( (( A F B )) e. C -> Fun ( F |` { <. A , B >. } ) ) $=
    ( caov wcel cop cafv csn cres wfun df-aov eleq1i afvvfunressn sylbi ) ABDEZ
    CFABGZDHZCFDQIJKPRCABDLMQCDNO $.

  ${
    aovprc.1 $e |- Rel dom F $.
    $( The value of an operation when the one of the arguments is a proper
       class, analogous to ~ ovprc .  (Contributed by Alexander van der Vekens,
       26-May-2017.) $)
    aovprc $p |- ( -. ( A e. _V /\ B e. _V ) -> (( A F B )) = _V ) $=
      ( cvv wcel wa caov cop cafv df-aov cdm wceq wbr df-br wrel brrelex12 mpan
      wn sylbir con3i ndmafv syl syl5eq ) AEFBEFGZSZABCHABIZCJZEABCKUFUGCLZFZSU
      HEMUJUEUJABUINZUEABUIOUIPUKUEDABUIQRTUAUGCUBUCUD $.

    $( Reverse closure for an operation value, analogous to ~ afvvv .  In
       contrast to ~ ovrcl , elementhood of the operation's value in a set is
       required, not containing an element.  (Contributed by Alexander van der
       Vekens, 26-May-2017.) $)
    aovrcl $p |- ( (( A F B )) e. C -> ( A e. _V /\ B e. _V ) ) $=
      ( caov wcel cop cafv cvv wa df-aov eleq1i cdm afvvdm df-br wrel brrelex12
      wbr mpan sylbir syl sylbi ) ABDFZCGABHZDIZCGZAJGBJGKZUDUFCABDLMUGUEDNZGZU
      HUECDOUJABUISZUHABUIPUIQUKUHEABUIRTUAUBUC $.
  $}

  $( If the alternative value of the operation on an ordered pair is the
     universal class, the operation's value at this ordered pair is the empty
     set.  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  aovpcov0 $p |- ( (( A F B )) = _V -> ( A F B ) = (/) ) $=
    ( cop cafv cvv wceq cfv c0 caov co afvpcfv0 df-aov eqeq1i df-ov 3imtr4i ) A
    BDZCEZFGQCHZIGABCJZFGABCKZIGQCLTRFABCMNUASIABCONP $.

  $( The alternative value of the operation on an ordered pair equals the
     operation's value at this ordered pair.  (Contributed by Alexander van der
     Vekens, 26-May-2017.) $)
  aovnuoveq $p |- ( (( A F B )) =/= _V -> (( A F B )) = ( A F B ) ) $=
    ( caov cvv wne cop cafv co wceq df-aov neeq1i afvnufveq df-ov 3eqtr4g sylbi
    cfv ) ABCDZEFABGZCHZEFZRABCIZJRTEABCKZLUATSCQRUBSCMUCABCNOP $.

  $( The alternative value of the operation on an ordered pair equals the
     operation's value on this ordered pair.  (Contributed by Alexander van der
     Vekens, 26-May-2017.) $)
  aovvoveq $p |- ( (( A F B )) e. C -> (( A F B )) = ( A F B ) ) $=
    ( caov wcel cop cafv co wceq df-aov eleq1i cfv afvvfveq df-ov 3eqtr4g sylbi
    ) ABDEZCFABGZDHZCFZRABDIZJRTCABDKZLUATSDMRUBSCDNUCABDOPQ $.

  $( If the alternative value of the operation on an ordered pair is the empty
     set, the operation's value at this ordered pair is the empty set.
     (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  aov0ov0 $p |- ( (( A F B )) = (/) -> ( A F B ) = (/) ) $=
    ( cop cafv c0 wceq cfv caov co afv0fv0 df-aov eqeq1i df-ov 3imtr4i ) ABDZCE
    ZFGPCHZFGABCIZFGABCJZFGPCKSQFABCLMTRFABCNMO $.

  $( If the operation's value at an argument is not the empty set, it equals
     the value of the alternative operation at this argument.  (Contributed by
     Alexander van der Vekens, 26-May-2017.) $)
  aovovn0oveq $p |- ( ( A F B ) =/= (/) -> (( A F B )) = ( A F B ) ) $=
    ( co c0 wne cop cfv caov wceq df-ov neeq1i afvfvn0fveq df-aov 3eqtr4g sylbi
    cafv ) ABCDZEFABGZCHZEFZABCIZRJRTEABCKZLUASCQTUBRSCMABCNUCOP $.

  $( The operation's value on an ordered pair is an element of a set if and
     only if the alternative value of the operation on this ordered pair is an
     element of that set, if the set does not contain the empty set.
     (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  aov0nbovbi $p |- ( (/) e/ C -> ( (( A F B )) e. C <-> ( A F B ) e. C ) ) $=
    ( c0 wnel cop cafv wcel cfv caov co afv0nbfvbi df-aov eleq1i df-ov 3bitr4g
    ) ECFABGZDHZCIRDJZCIABDKZCIABDLZCIRCDMUASCABDNOUBTCABDPOQ $.

  $( The operation's value on an ordered pair is the empty set if and only if
     the alternative value of the operation on this ordered pair is either the
     empty set or the universal class.  (Contributed by Alexander van der
     Vekens, 26-May-2017.) $)
  aovov0bi $p |- ( ( A F B ) = (/)
                     <-> ( (( A F B )) = (/) \/ (( A F B )) = _V ) ) $=
    ( co c0 wceq cop cfv cafv cvv wo caov eqeq1i afvfv0bi df-aov bicomi orbi12i
    df-ov 3bitri ) ABCDZEFABGZCHZEFUACIZEFZUCJFZKABCLZEFZUFJFZKTUBEABCRMUACNUDU
    GUEUHUGUDUFUCEABCOZMPUHUEUFUCJUIMPQS $.

  $( --------------------------- $)

  ${
    $d x A $.  $d x y B $.  $d x y C $.  $d y D $.  $d x y F $.  $d x y S $.
    $( A frequently used special case of ~ rspc2ev for operation values,
       analogous to ~ rspceov .  (Contributed by Alexander van der Vekens,
       26-May-2017.) $)
    rspceaov $p |- ( ( C e. A /\ D e. B /\ S = (( C F D )) ) ->
                 E. x e. A E. y e. B S = (( x F y )) ) $=
      ( cv caov wceq eqidd id aoveq123d eqeq2d rspc2ev ) GAIZBIZHJZKGEFHJZKGERH
      JZKABEFCDQEKZSUAGUBQERRHHUBHLUBMUBRLNORFKZUATGUCEERFHHUCHLUCELUCMNOP $.
  $}

  $( Equivalence of operation value and ordered triple membership, analogous to
     ~ fnopfvb .  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
  fnotaovb $p |- ( ( F Fn ( A X. B ) /\ C e. A /\ D e. B ) ->
                   ( (( C F D )) = R <-> <. C , D , R >. e. F ) ) $=
    ( cxp wfn wcel w3a cop cafv wceq caov cotp wb wa opelxpi fnopafvb sylan2
    3impb df-aov eqeq1i df-ot eleq1i 3bitr4g ) FABGZHZCAIZDBIZJCDKZFLZEMZUKEKZF
    IZCDFNZEMCDEOZFIUHUIUJUMUOPZUIUJQUHUKUGIURCDABRUGUKEFSTUAUPULECDFUBUCUQUNFC
    DEUDUEUF $.

  ${
    $d x y w A $.  $d x y w B $.  $d x y w C $.  $d x y w F $.
    $( An operation maps to a class to which all values belong, analogous to
       ~ ffnov .  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    ffnaov $p |- ( F : ( A X. B ) --> C <-> ( F Fn ( A X. B ) /\
         A. x e. A A. y e. B (( x F y )) e. C ) ) $=
      ( vw cxp wf wfn cv cafv wcel wral wa caov ffnafv cop wceq afveq2 syl6eqr
      df-aov eleq1d ralxp anbi2i bitri ) CDHZEFIFUGJZGKZFLZEMZGUGNZOUHAKZBKZFPZ
      EMZBDNACNZOGUGEFQULUQUHUKUPGABCDUIUMUNRZSZUJUOEUSUJURFLUOUIURFTUMUNFUBUAU
      CUDUEUF $.
  $}

  ${
    $d x y A $.  $d y B $.  $d x y C $.  $d x y F $.  $d x y R $.  $d x y S $.
    faovcl.1 $e |- F : ( R X. S ) --> C $.
    $( Closure law for an operation, analogous to ~ fovcl .  (Contributed by
       Alexander van der Vekens, 26-May-2017.) $)
    faovcl $p |- ( ( A e. R /\ B e. S ) -> (( A F B )) e. C ) $=
      ( vx vy wcel wa cv caov wral cxp wceq eqidd id aoveq123d eleq1d wf ffnaov
      wfn simprbi ax-mp rspc2v mpi ) ADJBEJKHLZILZFMZCJZIENHDNZABFMZCJZDEOZCFUA
      ZULGUPFUOUCULHIDECFUBUDUEUKUNAUIFMZCJHIABDEUHAPZUJUQCURUHAUIUIFFURFQURRUR
      UIQSTUIBPZUQUMCUSAAUIBFFUSFQUSAQUSRSTUFUG $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x y V $.
    aovmpt4g.3 $e |- F = ( x e. A , y e. B |-> C ) $.
    $( Value of a function given by the "maps to" notation, analogous to
       ~ ovmpt4g .  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    aovmpt4g $p |- ( ( x e. A /\ y e. B /\ C e. V ) -> (( x F y )) = C ) $=
      ( cv wcel w3a caov co cop cdm csn cres wfun wceq wa dmmpt2g opelxpi eleq2
      cxp wi syl5ibr syl impcom 3impa mpt2fun funres ax-mp df-dfat aovfundmoveq
      wdfat sylbir sylancl ovmpt4g eqtrd ) AIZCJZBIZDJZEGJZKZUTVBFLZUTVBFMZEVEU
      TVBNZFOZJZFVHPZQRZVFVGSZVAVCVDVJVDVAVCTZVJVDVICDUDZSZVNVJUEABCDEFGHUAVNVJ
      VPVHVOJUTVBCDUBVIVOVHUCUFUGUHUIFRVLABCDEFHUJVKFUKULVJVLTVHFUOVMVHFUMUTVBF
      UNUPUQABCDEFGHURUS $.
  $}

  ${
    $d x y S $.  $d x y F $.
    aoprssdm.1 $e |- ( ( x e. S /\ y e. S ) -> (( x F y )) e. S ) $.
    $( Domain of closure of an operation.  In contrast to ~ oprssdm , no
       additional property for S ( ` -. (/) e. S ` ) is required!  (Contributed
       by Alexander van der Vekens, 26-May-2017.) $)
    aoprssdm $p |- ( S X. S ) C_ dom F $=
      ( cxp cdm relxp cv wcel wa opelxp cafv caov df-aov syl5eqelr afvvdm sylbi
      cop syl relssi ) ABCCFZDGZCCHAIZBIZSZUBJUDCJUECJKZUFUCJZUDUECCLUGUFDMZCJU
      HUGUIUDUEDNCUDUEDOEPUFCDQTRUA $.
  $}

  ${
    ndmaov.1 $e |- dom F = ( S X. S ) $.
    ${
      ndmaovcl.2 $e |- ( ( A e. S /\ B e. S ) -> (( A F B )) e. S ) $.
      ndmaovcl.3 $e |- (( A F B )) e. _V $.
      $( The "closure" of an operation outside its domain, when the operation's
         value is a set in contrast to ~ ndmovcl where it is required that the
         domain contains the empty set ( ` (/) e. S ` ).  (Contributed by
         Alexander van der Vekens, 26-May-2017.) $)
      ndmaovcl $p |- (( A F B )) e. S $=
        ( wcel wa caov cop cxp opelxp cdm eqcomi eleq2i cvv wn wceq ndmaov vprc
        eleq1 biimpd pm2.21i syl6com mpsyl sylnbi sylnbir pm2.61i ) ACHBCHIZABD
        JZCHZFUJABKZCCLZHZULABCCMUOUMDNZHZULUNUPUMUPUNEOPUKQHZUQRUKQSZULGABDTUS
        URQQHZULUSURUTUKQQUBUCUTULUAUDUEUFUGUHUI $.
    $}

    $( Reverse closure law, in contrast to ~ ndmovrcl where it is required that
       the operation's domain doesn't contain the empty set
       ( ` -. (/) e. S ` ), no additional asumption is required.  (Contributed
       by Alexander van der Vekens, 26-May-2017.) $)
    ndmaovrcl $p |- ( (( A F B )) e. S -> ( A e. S /\ B e. S ) ) $=
      ( caov wcel cop cdm wa aovvdm cxp opelxp biimpi eleq2s syl ) ABDFCGABHZDI
      ZGACGBCGJZABCDKSQCCLZRQTGSABCCMNEOP $.

    $( Any operation is commutative outside its domain, analogous to
       ~ ndmovcom .  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    ndmaovcom $p |- ( -. ( A e. S /\ B e. S ) -> (( A F B )) = (( B F A )) ) $=
      ( wcel wa wn caov cvv cop cdm wceq cxp opelxp eqcomi eleq2i bitr3i ndmaov
      sylnbi ancom 3bitr2i eqtr4d ) ACFZBCFZGZHABDIZJBADIZUFABKZDLZFZUGJMUFUICC
      NZFUKABCCOULUJUIUJULEPZQRABDSTUFBAKZUJFZUHJMUFUEUDGUNULFUOUDUEUABACCOULUJ
      UNUMQUBBADSTUC $.

    $( Any operation is associative outside its domain.  In contrast to
       ~ ndmovass where it is required that the operation's domain doesn't
       contain the empty set ( ` -. (/) e. S ` ), no additional assumption is
       required.  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
    ndmaovass $p |- ( -. ( A e. S /\ B e. S /\ C e. S ) ->
                      (( (( A F B )) F C )) = (( A F (( B F C )) )) ) $=
      ( wcel wn caov cvv cop wceq wa eleq2i opelxp bitri wi aovvdm sylbi syl
      w3a cdm cxp df-3an simplbi2 imp con3i ndmaov 3anass biimpri expcom impcom
      a1d pm2.43i eqtr4d ) ADGZBDGZCDGZUAZHZABEIZCEIZJABCEIZEIZUTVACKZEUBZGZHVB
      JLVGUSVGVADGZURMZUSVGVEDDUCZGVIVFVJVEFNVACDDOPVHURUSVHABKZVFGZURUSQZABDER
      VLUPUQMZVMVLVKVJGVNVFVJVKFNABDDOPUSVNURUPUQURUDUESTUFSUGVACEUHTUTAVCKZVFG
      ZHVDJLVPUSVPUSVPUPVCDGZMZVPUSQZVPVOVJGVRVFVJVOFNAVCDDOPVQUPVSVQBCKZVFGZUP
      VSQZBCDERWAUQURMZWBWAVTVJGWCVFVJVTFNBCDDOPUPWCVSUPWCMZUSVPUSWDUPUQURUIUJU
      MUKSTULSUNUGAVCEUHTUO $.

    ${
      ndmaov.6 $e |- dom G = ( S X. S ) $.
      $( Any operation is distributive outside its domain.  In contrast to
         ~ ndmovdistr where it is required that the operation's domain doesn't
         contain the empty set ( ` -. (/) e. S ` ), no additional assumption is
         required.  (Contributed by Alexander van der Vekens, 26-May-2017.) $)
      ndmaovdistr $p |- ( -. ( A e. S /\ B e. S /\ C e. S ) ->
          (( A G (( B F C )) )) = (( (( A G B )) F (( A G C )) )) ) $=
        ( wcel wn caov cvv cop wa eleq2i opelxp bitri wi sylbi syl w3a cdm wceq
        aovvdm 3anass simplbi2com impcom con3i ndmaov simpll simprr simplr 3jca
        cxp ex com12 imp eqtr4d ) ADIZBDIZCDIZUAZJZABCEKZFKZLABFKZACFKZEKZVCAVD
        MZFUBZIZJVELUCVKVBVKUSVDDIZNZVBVKVIDDUNZIVMVJVNVIHOAVDDDPQVLUSVBVLBCMZE
        UBZIZUSVBRZBCDEUDVQUTVANZVRVQVOVNIVSVPVNVOGOBCDDPQVBUSVSUSUTVAUEUFSTUGS
        UHAVDFUITVCVFVGMZVPIZJVHLUCWAVBWAVFDIZVGDIZNZVBWAVTVNIWDVPVNVTGOVFVGDDP
        QWBWCVBWBABMZVJIZWCVBRZABDFUDWFUSUTNZWGWFWEVNIWHVJVNWEHOABDDPQWCWHVBWCA
        CMZVJIZWHVBRZACDFUDWJUSVANZWKWJWIVNIWLVJVNWIHOACDDPQWLWHVBWLWHNUSUTVAUS
        VAWHUJWLUSUTUKUSVAWHULUMUOSTUPSTUQSUHVFVGEUITUR $.
    $}
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Auxiliary theorems for graph theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Additional theorems for classical first order logic with equality, ZF set
theory and theory of real and complex numbers used for proving the theorems
for graph theory.
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Logical disjunction and conjunction
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    jaoi3.1 $e |- ( ph -> ps ) $.
    jaoi3.2 $e |- ( ( -. ph /\ ch ) -> ps ) $.
    $( Inference separating a disjunct of an antecedent.  (Contributed by
       Alexander van der Vekens, 25-May-2018.) $)
    jaoi3 $p |- ( ( ph \/ ch ) -> ps ) $=
      ( wn wa jaoi jaoi2 ) ABCABAFCGDEHI $.
  $}

  ${
    $d A x $.  $d ph x $.  $d ta x $.
    $( Selecting one statement from a disjunction if one of the disjuncted
       statements is false.  (Contributed by Alexander van der Vekens,
       6-Sep-2018.) $)
    ornld $p |- ( ph -> ( ( ( ph -> ( th \/ ta ) ) /\ -. th ) -> ta ) ) $=
      ( wo wi wn wa pm5.5 anbi1d orcom anbi1i pm5.61 bitri syl6bb simpl syl6bi
      ) AABCDZEZBFZGZCSGZCATQSGZUAARQSAQHIUBCBDZSGUAQUCSBCJKCBLMNCSOP $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Abbreviated conjunction and disjunction of three wff's
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Associative law for four conjunctions with a triple conjunction.
     (Contributed by Alexander van der Vekens, 24-Jun-2018.) $)
  3an4anass $p |- ( ( ( ph /\ ps /\ ch ) /\ th )
                    <-> ( ( ph /\ ps ) /\ ( ch /\ th ) ) ) $=
    ( w3a wa df-3an anbi1i anass bitri ) ABCEZDFABFZCFZDFLCDFFKMDABCGHLCDIJ $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Negated equality and membership - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( A contradiction concerning equality implies anything.  (Contributed by
     Alexander van der Vekens, 25-Jan-2018.) $)
  eqneqall $p |- ( A = B -> ( A =/= B -> ph ) ) $=
    ( wne wceq wn df-ne pm2.24 syl5bi ) BCDBCEZFJABCGJAHI $.

  $( A contradiction concerning membership implies anything.  (Contributed by
     Alexander van der Vekens, 25-Jan-2018.) $)
  elnelall $p |- ( A e. B -> ( A e/ B -> ph ) ) $=
    ( wnel wcel wn df-nel pm2.24 syl5bi ) BCDBCEZFJABCGJAHI $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Proper substitution of classes for sets into classes - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Distribute proper substitution through a pair of classes.  (Contributed by
     Alexander van der Vekens, 4-Sep-2018.) $)
  csbprg $p |- ( C e. V
            -> [_ C / x ]_ { A , B } = { [_ C / x ]_ A , [_ C / x ]_ B } ) $=
    ( wcel csn cun csb cpr csbun csbsng uneq12d syl5eq df-pr csbeq2i 3eqtr4g )
    DEFZADBGZCGZHZIZADBIZGZADCIZGZHZADBCJZIUCUEJRUBADSIZADTIZHUGADSTKRUIUDUJUFA
    DBELADCELMNADUHUABCOPUCUEOQ $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           The empty set - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d A x $.  $d ph x $.
    $( Specialization for restricted generalization with a nonempty set.
       (Contributed by Alexander van der Vekens, 6-Sep-2018.) $)
    rspn0 $p |- ( A =/= (/) -> ( A. x e. A ph -> ph ) ) $=
      ( c0 wne cv wcel wex wral wi n0 nfra1 nfv nfim rsp com12 exlimi sylbi ) C
      DEBFCGZBHABCIZAJZBCKSUABTABABCLABMNTSAABCOPQR $.
  $}

  ${
    $d A x $.
    $( A contradiction concerning restricted generalization for a non-empty set
       implies anything.  (Contributed by Alexander van der Vekens,
       4-Sep-2018.) $)
    ralnralall $p |- ( A =/= (/)
                       -> ( ( A. x e. A ph /\ A. x e. A -. ph ) -> ps ) ) $=
      ( wral wn wa c0 wne r19.26 wfal pm3.24 bifal ralbii r19.3rzv falim syl5bi
      syl6bir syl5bir ) ACDEAFZCDEGATGZCDEZDHIZBATCDJUBKCDEZUCBUAKCDUAALMNUCUDK
      BKCDOBPRQS $.
  $}

  ${
    $d A x $.  $d ph x $.  $d ta x $.
    $( A contradiction concerning restricted generalization for a non-empty set
       implies anything.  (Contributed by Alexander van der Vekens,
       6-Sep-2018.) $)
    ralralimp $p |- ( ( ph /\ A =/= (/) )
                -> ( A. x e. A ( ( ph -> ( th \/ ta ) ) /\ -. th ) -> ta ) ) $=
      ( c0 wne wa wo wi wn wral pm5.5 adantr anbi1d orcom anbi1i pm5.61 bitri
      wb syl6bb ralbidv r19.26 rspn0 adantrd syl5bi adantl sylbid ) AEFGZHZABCI
      ZJZBKZHZDELCUMHZDELZCUJUNUODEUJUNUKUMHZUOUJULUKUMAULUKTUIAUKMNOUQCBIZUMHU
      OUKURUMBCPQCBRSUAUBUIUPCJAUPCDELZUMDELZHUICCUMDEUCUIUSCUTCDEUDUEUFUGUH $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           "Weak deduction theorem" for set theory - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    ifeqda.1 $e |- ( ( ph /\ ps ) -> A = C ) $.
    ifeqda.2 $e |- ( ( ph /\ -. ps ) -> B = C ) $.
    $( Separation of the values of the conditional operator.  (Contributed by
       Alexander van der Vekens, 13-Apr-2018.) $)
    ifeqda $p |- ( ph -> if ( ps , A , B ) = C ) $=
      ( cif wceq wa iftrue adantl eqtrd wn iffalse pm2.61dan ) ABBCDHZEIABJQCEB
      QCIABCDKLFMABNZJQDERQDIABCDOLGMP $.
  $}

  ${
    2if2.1 $e |- ( ( ph /\ ps ) -> D = A ) $.
    2if2.2 $e |- ( ( ph /\ -. ps /\ th ) -> D = B ) $.
    2if2.3 $e |- ( ( ph /\ -. ps /\ -. th ) -> D = C ) $.
    $( Resolve two nested conditionals.  (Contributed by Alexander van der
       Vekens, 27-Mar-2018.) $)
    2if2 $p |- ( ph -> D = if ( ps , A , if ( th , B , C ) ) ) $=
      ( cif wceq wa iftrue adantl eqtr4d wn 3expa iffalse pm2.61dan eqcomd
      eqtrd ) ABGBDCEFKZKZLABMGDUDHBUDDLABDUCNOPABQZMZGUCUDUFCGUCLUFCMGEUCAUECG
      ELIRCUCELUFCEFNOPUFCQZMGFUCAUEUGGFLJRUGFUCLUFUGUCFCEFSUAOUBTUEUDUCLABDUCS
      OPT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
          Power classes - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The cross product of three sets is a set.  (Contributed by Alexander van
     der Vekens, 21-Feb-2018.) $)
  3xpexg $p |- ( V e. W -> ( ( V X. V ) X. V ) e. _V ) $=
    ( cxp cvv wcel xpexg anidms mpancom ) AACZDEZABEZIACDEKJAABBFGIADBFH $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
          Unordered and ordered pairs - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    nelprd.1 $e |- ( ph -> A =/= B ) $.
    nelprd.2 $e |- ( ph -> A =/= C ) $.
    $( If an element doesn't match the items in an unordered pair, it is not in
       the unordered pair, deduction version.  (Contributed by Alexander van
       der Vekens, 25-Jan-2018.) $)
    nelprd $p |- ( ph -> -. A e. { B , C } ) $=
      ( wne cpr wcel wn wa wceq wo neanior elpri con3i sylbi syl2anc ) ABCGZBDG
      ZBCDHIZJZEFSTKBCLBDLMZJUBBCBDNUAUCBCDOPQR $.
  $}

  $( A (proper) pair is equal to another (maybe inproper) pair containing one
     element of the first pair if and only if the other element of the first
     pair is contained in the second pair.  (Contributed by Alexander van der
     Vekens, 26-Jan-2018.) $)
  pr1eqbg $p |- ( ( ( A e. U /\ B e. V /\ C e. X ) /\ A =/= B )
                  -> ( A = C <-> { A , B } = { B , C } ) ) $=
    ( wcel w3a wne wa wceq wo cpr wb eqid biantru orbi2i a1i wn syl df-ne biorf
    biimpi adantl intnanrd 3simpa 3simpc jca adantr preq12bg 3bitr4d ) ADGZBEGZ
    CFGZHZABIZJZABKZBCKZJZACKZLZUTVABBKZJZLZVAABMBCMKZVBVENUQVAVDUTVCVABOPQRUQU
    TSVAVBNUQURUSUPURSZUOUPVGABUAUCUDUEUTVAUBTUQULUMJZUMUNJZJZVFVENUOVJUPUOVHVI
    ULUMUNUFULUMUNUGUHUIABBCDEEFUJTUK $.

  $( A (proper) pair is not equal to another (maybe inproper) pair containing
     one element of the first pair if and only if the other element of the
     first pair is not contained in the second pair.  (Contributed by Alexander
     van der Vekens, 26-Jan-2018.) $)
  pr1nebg $p |- ( ( ( A e. U /\ B e. V /\ C e. X ) /\ A =/= B )
                  -> ( A =/= C <-> { A , B } =/= { B , C } ) ) $=
    ( wcel w3a wne wa cpr pr1eqbg necon3bid ) ADGBEGCFGHABIJACABKBCKABCDEFLM $.

  ${
    $d x Y $.
    $( Restricted universal quantification on a class difference with a
       singleton in terms of an implication.  (Contributed by Alexander van der
       Vekens, 26-Jan-2018.) $)
    raldifsnb $p |- ( A. x e. A ( x =/= Y -> ph )
                      <-> A. x e. ( A \ { Y } ) ph ) $=
      ( cv wne wi wral csn wnel cdif wcel wceq wn elsn nnel nne 3bitr4ri imbi1i
      con4bii ralbii raldifb bitri ) BEZDFZAGZBCHUDDIZJZAGZBCHABCUGKHUFUIBCUEUH
      AUEUHUDUGLUDDMUHNUENBDOUDUGPUDDQRTSUAABCUGUBUC $.
  $}

  $( Restricted existential quantification over a set with two elements
     removed.  (Contributed by Alexander van der Vekens, 7-Feb-2018.) $)
  rexdifpr $p |- ( E. x e. ( A \ { B , C } ) ph
      <-> E. x e. A ( x =/= B /\ x =/= C /\ ph ) ) $=
    ( cv wne w3a cpr cdif wcel eldifpr 3anass bitri anbi1i df-3an bicomi anbi2i
    wa anass rexbii2 ) ABFZDGZUBEGZAHZBCDEIJZCUBUFKZASUBCKZUCUDSZSZASZUHUESZUGU
    JAUGUHUCUDHUJUBCDELUHUCUDMNOUKUHUIASZSULUHUIATUMUEUHUEUMUCUDAPQRNNUA $.

  $( Removing two elements as pair of elements corresponds to removing each of
     the two elements as singletons.  (Contributed by Alexander van der Vekens,
     13-Jul-2018.) $)
  difpr $p |- ( A \ { B , C } ) = ( ( A \ { B } ) \ { C } ) $=
    ( cpr cdif csn cun df-pr difeq2i difun1 eqtri ) ABCDZEABFZCFZGZEAMENELOABCH
    IAMNJK $.

  ${
    $d A p x y z $.  $d B p x y z $.  $d C p x y z $.  $d D p x y z $.
    $( A member of a nested cross product is an ordered triple.  (Contributed
       by Alexander van der Vekens, 15-Feb-2018.) $)
    el2xptp $p |- ( A e. ( ( B X. C ) X. D )
                    <-> E. x e. B E. y e. C E. z e. D A = <. x , y , z >. ) $=
      ( vp cxp wcel cv cop wceq wrex cotp elxp2 opeq1 eqeq2d rexbidv rexbii
      rexxp df-ot eqcomi eqeq2i 3bitri ) DEFIZGIJDHKZCKZLZMZCGNZHUFNDAKZBKZLZUH
      LZMZCGNZBFNZAENDULUMUHOZMZCGNZBFNZAENHCDUFGPUKUQHABEFUGUNMZUJUPCGVCUIUODU
      GUNUHQRSUAURVBAEUQVABFUPUTCGUOUSDUSUOULUMUHUBUCUDTTTUE $.
  $}

  $( A member of a nested cross product is an ordered triple.  (Contributed by
     Alexander van der Vekens, 15-Feb-2018.) $)
  el2xptp0 $p |- ( ( X e. U /\ Y e. V /\ Z e. W )
                -> ( ( A e. ( ( U X. V ) X. W ) /\ ( ( 1st ` ( 1st ` A ) ) = X
                           /\ ( 2nd ` ( 1st ` A ) ) = Y /\ ( 2nd ` A ) = Z ) )
                     <-> A = <. X , Y , Z >. ) ) $=
    ( wcel w3a cxp c1st cfv wceq c2nd wa cop ad2antrl id adantl sylan9eqr xp1st
    cotp 3adant3 eqopi syl2anc simprr3 jca wb eqeq2i eqop syl5bb mpbird opelxpi
    df-ot 3ad2ant3 opelxp sylanbrc adantr eleq1 fveq2 fveq2d ot1stg ot2ndg 3jca
    syl5eqel ot3rdg impbida ) EBHZFCHZGDHZIZABCJZDJZHZAKLZKLZEMZVONLZFMZANLZGMZ
    IZOZAEFGUBZMZVKWCOZWEVOEFPZMZWAOZWFWHWAWFVOVLHZVQVSOZWHVNWJVKWBAVLDUAQWCWKV
    KWBWKVNVQVSWKWAWKRUCSSVOEFBCUDUEVQVSWAVNVKUFUGVNWEWIUHVKWBWEAWGGPZMVNWIWDWL
    AEFGUNZUIAWGGVLDUJUKQULVKWEOZVNWBWNVNWDVMHZVKWOWEVKWDWLVMWMVKWGVLHZVJWLVMHV
    HVIWPVJEFBCUMUCVJVHVJVIVJRUOWGGVLDUPUQVEURWEVNWOUHVKAWDVMUSSULWNVQVSWAWEVKV
    PWDKLZKLEWEVOWQKAWDKUTZVAEFGBCDVBTWEVKVRWQNLFWEVOWQNWRVAEFGBCDVCTWEVKVTWDNL
    ZGAWDNUTVJVHWSGMVIEFGDVFUOTVDUGVG $.

  $( An ordered triple is an element of a doubled cross product.  (Contributed
     by Alexander van der Vekens, 26-Feb-2018.) $)
  otel3xp $p |- ( ( T = <. A , B , C >. /\ ( A e. X /\ B e. Y /\ C e. Z ) )
                         -> T e. ( ( X X. Y ) X. Z ) ) $=
    ( cotp wceq wcel w3a cxp cop df-ot wa 3simpa opelxp sylibr simp3 sylanbrc
    syl5eqel eleq1 syl5ibr imp ) DABCHZIZAEJZBFJZCGJZKZDEFLZGLZJZUJUMUFUEULJUJU
    EABMZCMZULABCNUJUNUKJZUIUOULJUJUGUHOUPUGUHUIPABEFQRUGUHUISUNCUKGQTUADUEULUB
    UCUD $.

  $( The components of an ordered triple.  (Contributed by Alexander van der
     Vekens, 2-Mar-2018.) $)
  oteqimp $p |- ( T = <. A , B , C >. -> ( ( A e. X /\ B e. Y /\ C e. Z )
                         -> ( ( 1st ` ( 1st ` T ) ) = A
                           /\ ( 2nd ` ( 1st ` T ) ) = B
                           /\ ( 2nd ` T ) = C ) ) ) $=
    ( wcel w3a c1st cfv wceq c2nd cotp ot1stg ot2ndg ot3rdg fveq2 fveq2d eqeq1d
    3ad2ant3 3jca 3anbi123d syl5ibr ) AEHZBFHZCGHZIZDJKZJKZALZUIMKZBLZDMKZCLZID
    ABCNZLZUPJKZJKZALZURMKZBLZUPMKZCLZIUHUTVBVDABCEFGOABCEFGPUGUEVDUFABCGQUAUBU
    QUKUTUMVBUOVDUQUJUSAUQUIURJDUPJRZSTUQULVABUQUIURMVESTUQUNVCCDUPMRTUCUD $.

  $( Ordered triple theorem, closed form.  (Contributed by Alexander van der
     Vekens, 10-Mar-2018.) $)
  otthg $p |- ( ( A e. U /\ B e. V /\ C e. W )
                  -> ( <. A , B , C >. = <. D , E , F >.
                       <-> ( A = D /\ B = E /\ C = F ) ) ) $=
    ( cotp wceq cop wcel w3a df-ot eqeq12i wa wb cvv opthg opex 3ad2ant3 anbi1d
    mpan df-3an syl6bbr 3adant3 bitrd syl5bb ) ABCJZDFGJZKABLZCLZDFLZGLZKZAEMZB
    HMZCIMZNZADKZBFKZCGKZNZUJUMUKUOABCODFGOPUTUPULUNKZVCQZVDUSUQUPVFRZURULSMUSV
    GABUAULCUNGSITUDUBUQURVFVDRUSUQURQZVFVAVBQZVCQVDVHVEVIVCABDFEHTUCVAVBVCUEUF
    UGUHUI $.

  ${
    $d A c d $.  $d B c d $.  $d V c d $.  $d X c d $.  $d Y c d $.
    $( The singletons consisting of ordered triples which have distinct third
       components are disjunct.  (Contributed by Alexander van der Vekens,
       10-Mar-2018.) $)
    otsndisj $p |- ( ( A e. X /\ B e. Y )
                   -> Disj_ c e. V { <. A , B , c >. } ) $=
      ( vd wcel wa weq cv cotp csn cin c0 wceq wo wral wdisj wn orc a1d wne w3a
      wi wb otthg 3expa adantrr simp3 syl6bi con3rr3 imp neneqad disjsn2 syl ex
      olcd pm2.61i ralrimivva oteq3 sneqd disjor sylibr ) ADHZBEHZIZFGJZABFKZLZ
      MZABGKZLZMZNOPZQZGCRFCRFCVKSVGVPFGCCVHVGVICHZVLCHZIIZVPUEVHVPVSVHVOUAUBVH
      TZVSVPVTVSIZVOVHWAVJVMUCVOWAVJVMVTVSVJVMPZTVSWBVHVSWBAAPZBBPZVHUDZVHVGVQW
      BWEUFZVRVEVFVQWFABVIADBVLECUGUHUIWCWDVHUJUKULUMUNVJVMUOUPURUQUSUTCVKVNFGV
      HVJVMVIVLABVAVBVCVD $.
  $}

  ${
    $d B a c d e s $.  $d V a c d e s $.  $d W a c d e s $.  $d X a c d e s $.
    $d Y c d $.
    $( The union of singletons consisting of ordered triples which have
       distinct first and third components are disjunct.  (Contributed by
       Alexander van der Vekens, 10-Mar-2018.) $)
    otiunsndisj $p |- ( B e. X
                 -> Disj_ a e. V U_ c e. ( W \ { a } ) { <. a , B , c >. } ) $=
      ( vd vs ve wcel cv csn cotp ciun wceq wral wa wn ex adantr weq cdif c0 wo
      cin wdisj wi orc a1d eliun w3a wb simprl adantl simpl otthg syl3anc simp1
      wrex syl6bi con3d com13 imp31 eqeq1 notbid sylbi mpbird sylnibr rexlimdva
      elsn nrexdv syl5bi ralrimiv oteq3 sneqd cbviunv eleq2i notbii ralbii disj
      sylibr olcd pm2.61i ralrimivva sneq difeq2d oteq1 iuneq12d disjor ) ADJZE
      GUAZFCEKZLZUBZWLAFKZMZLZNZFCGKZLZUBZWSAWOMZLZNZUEUCOZUDZGBPEBPEBWRUFWJXFE
      GBBWKWJWLBJZWSBJZQZQZXFUGWKXFXJWKXEUHUIWKRZXJXFXKXJQZXEWKXLHKZXDJZRZHWRPZ
      XEXLXMIXAWSAIKZMZLZNZJZRZHWRPXPXLYBHWRXMWRJXMWQJZFWNUSXLYBFXMWNWQUJXLYCYB
      FWNXLWOWNJZQZYCYBYEYCQZXMXSJZIXAUSYAYFYGIXAYFXQXAJZQZXMXROZYGYIYJRZWPXROZ
      RZYFYMYHYEYMYCXKXJYDYMYDXJXKYMYDXJXKYMUGYDXJQZYLWKYNYLWKAAOZFIUAZUKZWKYNX
      GWJYDYLYQULXJXGYDWJXGXHUMUNYDWJXIUMYDXJUOWLAWOWSBAXQDWNUPUQWKYOYPURUTVASV
      BVCTTYFYKYMULZYHYCYRYEYCXMWPOZYRHWPVJYSYJYLXMWPXRVDVEVFUNTVGHXRVJVHVKIXMX
      AXSUJVHSVIVLVMXOYBHWRXNYAXDXTXMFIXAXCXSYPXBXRWOXQWSAVNVOVPVQVRVSWAHWRXDVT
      WAWBSWCWDBWRXDEGWKFWNXAWQXCWKWMWTCWLWSWEWFWKWPXBWLWSAWOWGVOWHWIWA $.
  $}

  ${
    $d B a c d e s $.  $d V a c d e s $.  $d W a c d e s $.  $d X a c d e s $.
    $d Y c d $.
    $( The union of singletons consisting of ordered triples which have
       distinct first and third components are disjunct.  (Contributed by
       Alexander van der Vekens, 10-Mar-2018.) $)
    otiunsndisjX $p |- ( B e. X
                      -> Disj_ a e. V U_ c e. W { <. a , B , c >. } ) $=
      ( vd vs ve wcel cv cotp csn ciun wceq wral wa wn ex adantr c0 wo wdisj wi
      weq cin orc a1d wrex eliun w3a wb simprl adantl simpl otthg syl3anc simp1
      syl6bi con3d com13 imp31 elsn eqeq1 notbid sylbi mpbird sylnibr ralrimiva
      ralnex sylib rexlimdva syl5bi imp oteq3 sneqd eleq2i notbii ralbii sylibr
      cbviunv disj olcd pm2.61i ralrimivva oteq1 iuneq2d disjor ) ADJZEGUEZFCEK
      ZAFKZLZMZNZFCGKZAWLLZMZNZUFUAOZUBZGBPEBPEBWOUCWIXAEGBBWJWIWKBJZWPBJZQZQZX
      AUDWJXAXEWJWTUGUHWJRZXEXAXFXEQZWTWJXGHKZWSJZRZHWOPZWTXGXHICWPAIKZLZMZNZJZ
      RZHWOPXKXGXQHWOXGXHWOJZXQXRXHWNJZFCUIXGXQFXHCWNUJXGXSXQFCXGWLCJZQZXSXQYAX
      SQZXHXNJZICUIZXPYBYCRZICPYDRYBYEICYBXLCJZQZXHXMOZYCYGYHRZWMXMOZRZYBYKYFYA
      YKXSXFXEXTYKXTXEXFYKXTXEXFYKUDXTXEQZYJWJYLYJWJAAOZFIUEZUKZWJYLXBWIXTYJYOU
      LXEXBXTWIXBXCUMUNXTWIXDUMXTXEUOWKAWLWPBAXLDCUPUQWJYMYNURUSUTSVAVBTTYBYIYK
      ULZYFXSYPYAXSXHWMOZYPHWMVCYQYHYJXHWMXMVDVEVFUNTVGHXMVCVHVIYCICVJVKIXHCXNU
      JVHSVLVMVNVIXJXQHWOXIXPWSXOXHFICWRXNYNWQXMWLXLWPAVOVPWAVQVRVSVTHWOWSWBVTW
      CSWDWEBWOWSEGWJFCWNWRWJWMWQWKWPAWLWFVPWGWHVT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Indexed union and intersection - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x B $.  $d x D $.  $d x E $.
    iunxprg.1 $e |- ( x = A -> C = D ) $.
    iunxprg.2 $e |- ( x = B -> C = E ) $.
    $( A pair index picks out two instances of an indexed union's argument.
       (Contributed by Alexander van der Vekens, 2-Feb-2018.) $)
    iunxprg $p |- ( ( A e. V /\ B e. W )
                    -> U_ x e. { A , B } C = ( D u. E ) ) $=
      ( wcel wa cpr ciun csn cun wceq df-pr iuneq1 iunxsng iunxun adantr adantl
      ax-mp eqtri uneq12d syl5eq ) BGKZCHKZLZABCMZDNZABOZDNZACOZDNZPZEFPULAUMUO
      PZDNZUQUKURQULUSQBCRAUKURDSUDAUMUODUAUEUJUNEUPFUHUNEQUIABDEGITUBUIUPFQUHA
      CDFHJTUCUFUG $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                Ordered-pair class abstractions - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d A x y $.
    $( Membership in an ordered pair class builder implies membership in a
       cross product.  (Contributed by Alexander van der Vekens,
       23-Jun-2018.) $)
    elopaelxp $p |- ( A e. { <. x , y >. | ps } -> A e. ( _V X. _V ) ) $=
      ( cv cop wceq wa wex copab wcel cvv cxp simpl 2eximi elopab elvv 3imtr4i
      ) DBECEFGZAHZCIBISCIBIDABCJKDLLMKTSBCSANOABCDPBCDQR $.
  $}

  ${
    $d x y A $.  $d x y B $.
    opelopabgf.x $e |- F/ x ps $.
    opelopabgf.y $e |- F/ y ch $.
    opelopabgf.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    opelopabgf.2 $e |- ( y = B -> ( ps <-> ch ) ) $.
    $( The law of concretion.  Theorem 9.5 of [Quine] p. 61.  This version of
       ~ opelopabg uses bound-variable hypotheses in place of distinct variable
       conditions."  (Contributed by Alexander van der Vekens, 8-Jul-2018.) $)
    opelopabgf $p |- ( ( A e. V /\ B e. W )
                       -> ( <. A , B >. e. { <. x , y >. | ph } <-> ch ) ) $=
      ( wcel wa cop copab wsbc wb sbciegf opelopabsb nfcv nfsbc cv wceq sbcbidv
      a1i adantr adantl 3bitrd ) FHNZGINZOZFGPADEQNZAEGRZDFRZBEGRZCUNUPSUMADEFG
      UAUGUKUPUQSULUOUQDFHBDEGDGUBJUCDUDFUEABEGLUFTUHULUQCSUKBCEGIKMTUIUJ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                  Introduce the Axiom of Union - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x A $.  $d x y B $.  $d x C $.  $d x ch $.  $d x y ph $.  $d y ps $.
    ralxfrd2.1 $e |- ( ( ph /\ y e. C ) -> A e. B ) $.
    ralxfrd2.2 $e |- ( ( ph /\ x e. B ) -> E. y e. C x = A ) $.
    ralxfrd2.3 $e |- ( ( ph /\ y e. C /\ x = A ) -> ( ps <-> ch ) ) $.
    $( Transfer universal quantification from a variable ` x ` to another
       variable ` y ` contained in expression ` A ` .  Variant of ~ ralxfrd .
       (Contributed by Alexander van der Vekens, 25-Apr-2018.) $)
    ralxfrd2 $p |- ( ph -> ( A. x e. B ps <-> A. y e. C ch ) ) $=
      ( wral cv wcel wa wceq wb 3expa ralrimdva wrex rspcdv r19.29 simplr simpr
      simplll syl3anc exbiri com23 imp3a rexlimdva syl5 mpan2d impbid ) ABDGLZC
      EHLZAUNCEHAEMHNZOBCDFGIAUPDMZFPZBCQZKRUASAUOBDGAUQGNZOZUOUREHTZBJUOVBOCUR
      OZEHTVABCUREHUBVAVCBEHVAUPOZCURBVDURCBVDURBCVDUROAUPURUSAUTUPURUEVAUPURUC
      VDURUDKUFUGUHUIUJUKULSUM $.

    $( Transfer existence from a variable ` x ` to another variable ` y `
       contained in expression ` A ` .  Variant of ~ rexxfrd .  (Contributed by
       Alexander van der Vekens, 25-Apr-2018.) $)
    rexxfrd2 $p |- ( ph -> ( E. x e. B ps <-> E. y e. C ch ) ) $=
      ( wn wral wrex cv wcel wceq w3a notbid dfrex2 ralxfrd2 3bitr4g ) ABLZDGMZ
      LCLZEHMZLBDGNCEHNAUDUFAUCUEDEFGHIJAEOHPDOFQRBCKSUASBDGTCEHTUB $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                         Relations - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The restriction of a relation by a set ` B ` is identical with the
     restriction by the intersection of ` B ` with the domain of the relation.
     (Contributed by Alexander van der Vekens, 3-Feb-2018.) $)
  resisresindm $p |- ( Rel F -> ( F |` B ) = ( F |` ( B i^i dom F ) ) ) $=
    ( wrel cres cin cdm resdm eqcomd ineq2d wss wceq resss df-ss eqcomi resindi
    mpbi 3eqtr4g ) BCZBADZBEZSBBFZDZESBAUAEDRBUBSRUBBBGHITSSBJTSKBALSBMPNBAUAOQ
    $.

  $( An element of the domain (of a relation) is an element of the domain of
     the restriction (of the relation) to the singleton containing this
     element.  (Contributed by Alexander van der Vekens, 22-Jul-2018.) $)
  eldmeldmressn $p |- ( X e. dom F <-> X e. dom ( F |` { X } ) ) $=
    ( cdm wcel csn cres eldmressnsn cin elin simprbi dmres eleq2s impbii ) BACZ
    DZBABEZFCZDBAGOBPNHZQBRDBPDOBPNIJAPKLM $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                         Functions - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d V x $.  $d X x $.
    $( Distribute proper substitution through the function predicate with a
       domain.  (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    sbcfng $p |- ( X e. V -> ( [. X / x ]. F Fn A
                              <-> [_ X / x ]_ F Fn [_ X / x ]_ A ) ) $=
      ( wcel wfn wsbc wfun cdm wa csb wb df-fn a1i sbcbidv sbcfung sbceqg csbdm
      wceq eqeq1i syl6bb anbi12d sbcan 3bitr4g bitrd ) EDFZCBGZAEHCIZCJZBTZKZAE
      HZAECLZAEBLZGZUGUHULAEUHULMUGCBNOPUGUIAEHZUKAEHZKUNIZUNJZUOTZKUMUPUGUQUSU
      RVAAECDQUGURAEUJLZUOTVAAEUJBDRVBUTUOAECSUAUBUCUIUKAEUDUNUONUEUF $.

    $( Distribute proper substitution through the function predicate with
       domain and codomain.  (Contributed by Alexander van der Vekens,
       15-Jul-2018.) $)
    sbcfg $p |- ( X e. V -> ( [. X / x ]. F : A --> B
                 <-> [_ X / x ]_ F : [_ X / x ]_ A --> [_ X / x ]_ B ) ) $=
      ( wcel wf wsbc wfn crn wss wa csb wb df-f a1i sbcbidv sbcfng sbcssg csbrn
      sseq1i syl6bb anbi12d sbcan 3bitr4g bitrd ) FEGZBCDHZAFIDBJZDKZCLZMZAFIZA
      FBNZAFCNZAFDNZHZUHUIUMAFUIUMOUHBCDPQRUHUJAFIZULAFIZMUQUOJZUQKZUPLZMUNURUH
      USVAUTVCABDEFSUHUTAFUKNZUPLVCAFUKCETVDVBUPAFDUAUBUCUDUJULAFUEUOUPUQPUFUG
      $.
  $}

  $( A function with empty domain is empty.  (Contributed by Alexander van der
     Vekens, 30-Jun-2018.) $)
  f0bi $p |- ( F : (/) --> X <-> F = (/) ) $=
    ( c0 wf wceq wfn ffn fn0 sylib f0 feq1 mpbiri impbii ) CBADZACEZNACFOCBAGAH
    IONCBCDBJCBACKLM $.

  ${
    $d E y $.  $d Y y $.
    $( If there is no element in the range of a function, its domain must be
       empty.  (Contributed by Alexander van der Vekens, 12-Jul-2018.) $)
    f0rn0 $p |- ( ( E : X --> Y /\ -. E. y e. Y y e. ran E ) -> X = (/) ) $=
      ( wf cv crn wcel wrex wn c0 wceq cdm wi fdm wa cin sylbi syl5bir imp wral
      wss frn ralnex df-ss incom eqeq1i eqtr2 ex syl adantl dm0rn0 sylibr eqeq1
      disj wb eqcoms adantr mpbird exp32 mpcom ) CDBEZAFBGZHZADIJZCKLZBMZCLZVBV
      EVFNCDBOVHVBVEVFVHVBVEPZPZVFVGKLZVJVCKLZVKVIVLVHVBVEVLVBVCDUBZVEVLNCDBUCV
      EVDJADUAZVMVLVDADUDVNDVCQZKLZVMVLADVCUOVMVCDQZVCLZVPVLNZVCDUEVRVOVCLZVSVQ
      VOVCVCDUFUGVTVPVLVOVCKUHUIRRSSUJTUKBULUMVHVFVKUPZVIWACVGCVGKUNUQURUSUTVAT
      $.
  $}

  $( Equality of function values with conditional arguments, see also ~ fvif .
     (Contributed by Alexander van der Vekens, 21-May-2018.) $)
  fvifeq $p |- ( A = if ( ph , B , C )
                 -> ( F ` A ) = if ( ph , ( F ` B ) , ( F ` C ) ) ) $=
    ( cif wceq cfv fveq2 fvif syl6eq ) BACDFZGBEHLEHACEHDEHFBLEIACDEJK $.

  $( If two one-to-one functions are applied on different arguments, also the
     values are different.  (Contributed by Alexander van der Vekens,
     25-Jan-2018.) $)
  2f1fvneq $p |- ( ( ( E : D -1-1-> R /\ F : C -1-1-> D )
                       /\ ( A e. C /\ B e. C ) /\ A =/= B )
                   -> ( ( ( E ` ( F ` A ) ) = X /\ ( E ` ( F ` B ) ) = Y )
                        -> X =/= Y ) ) $=
    ( wf1 wa wcel wne cfv wceq wn wi f1veqaeq ffvelrn ex necon3ad 3impia simpll
    w3a adantll wf f1f anim12dan syl adantl syl2anc con3and eqeq12 notbid df-ne
    imp biimpri syl6bi syl5com 3adant3 mpd ) DEFJZCDGJZKZACLZBCLZKZABMZUDAGNZBG
    NZOZPZVIFNZHOVJFNZIOKZHIMZQZVDVGVHVLVDVGKZVKABVCVGVKABOQVBCDABGRUEUAUBVDVGV
    LVQQVHVRVLVQVRVLKVMVNOZPZVOVPVRVSVKVRVBVIDLZVJDLZKZVSVKQVBVCVGUCVDVGWCVCVGW
    CQZVBVCCDGUFZWDCDGUGWEVGWCWEVEWAVFWBCDAGSCDBGSUHTUIUJUPDEVIVJFRUKULVOVTHIOZ
    PZVPVOVSWFVMHVNIUMUNVPWGHIUOUQURUSTUTVA $.

  ${
    $d x y A $.  $d x y F $.
    $( A one-to-one function in terms of different function values for
       different arguments.  (Contributed by Alexander van der Vekens,
       26-Jan-2018.) $)
    dff14a $p |- ( F : A -1-1-> B <-> ( F : A --> B /\
             A. x e. A A. y e. A ( x =/= y -> ( F ` x ) =/= ( F ` y ) ) ) ) $=
      ( wf1 wf cv cfv wceq weq wi wral wa wne dff13 wn df-ne bicomi bitri
      con34b imbi12i 2ralbii anbi2i ) CDEFCDEGZAHZEIZBHZEIZJZABKZLZBCMACMZNUEUF
      UHOZUGUIOZLZBCMACMZNABCDEPUMUQUEULUPABCCULUKQZUJQZLUPUJUKUAURUNUSUOUNURUF
      UHRSUOUSUGUIRSUBTUCUDT $.

    $( A one-to-one function in terms of different function values for
       different arguments.  (Contributed by Alexander van der Vekens,
       26-Jan-2018.) $)
    dff14b $p |- ( F : A -1-1-> B <-> ( F : A --> B /\
             A. x e. A A. y e. ( A \ { x } ) ( F ` x ) =/= ( F ` y ) ) ) $=
      ( wf1 wf cv wne cfv wi wral wa csn cdif dff14a necom imbi1i ralbii bitri
      raldifsnb anbi2i ) CDEFCDEGZAHZBHZIZUDEJUEEJIZKZBCLZACLZMUCUGBCUDNOLZACLZ
      MABCDEPUJULUCUIUKACUIUEUDIZUGKZBCLUKUHUNBCUFUMUGUDUEQRSUGBCUDUATSUBT $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y X $.  $d x y Y $.
    f12dfv.a $e |- A = { X , Y } $.
    $( A one-to-one function with a pair as domain in terms of function
       values.  (Contributed by Alexander van der Vekens, 2-Mar-2018.) $)
    f12dfv $p |- ( ( ( X e. U /\ Y e. V ) /\ X =/= Y )
      -> ( F : A -1-1-> B <-> ( F : A --> B /\ ( F ` X ) =/= ( F ` Y ) ) ) ) $=
      ( vx vy cfv wne csn cdif wral wa wb wceq fveq2 adantr wf1 wcel dff14b cpr
      wf cv raleqi sneq difeq2d neeq1d raleqbidv ralprg difeq1i difprsn1 syl5eq
      adantl raleqdv neeq2d ralsng bitrd difprsn2 anbi12d necom pm4.71i syl6bbr
      biimpi syl5bb anbi2d ) ABDUAABDUEZIUFZDKZJUFZDKZLZJAVJMZNZOZIAOZPFCUBZGEU
      BZPZFGLZPZVIFDKZGDKZLZPIJABDUCWCVRWFVIVRVQIFGUDZOZWCWFVQIAWGHUGWCWHWDVMLZ
      JAFMZNZOZWEVMLZJAGMZNZOZPZWFWAWHWQQWBVQWLWPIFGCEVJFRZVNWIJVPWKWRVOWJAVJFU
      HUIWRVKWDVMVJFDSUJUKVJGRZVNWMJVPWOWSVOWNAVJGUHUIWSVKWEVMVJGDSUJUKULTWCWQW
      FWEWDLZPWFWCWLWFWPWTWCWLWIJWNOZWFWCWIJWKWNWBWKWNRWAWBWKWGWJNWNAWGWJHUMFGU
      NUOUPUQWAXAWFQZWBVTXBVSWIWFJGEVLGRVMWEWDVLGDSURUSUPTUTWCWPWMJWJOZWTWCWMJW
      OWJWBWOWJRWAWBWOWGWNNWJAWGWNHUMFGVAUOUPUQWAXCWTQZWBVSXDVTWMWTJFCVLFRVMWDW
      EVLFDSURUSTTUTVBWFWTWFWTWDWEVCVFVDVEUTVGVHVG $.
  $}

  ${
    $d x y A $.  $d x y F $.  $d x y X $.  $d x y Y $.  $d x y Z $.
    f13dfv.a $e |- A = { X , Y , Z } $.
    $( A one-to-one function with a triple as domain in terms of function
       values.  (Contributed by Alexander van der Vekens, 26-Jan-2018.) $)
    f13dfv $p |- ( ( ( X e. U /\ Y e. V /\ Z e. W )
                     /\ ( X =/= Y /\ X =/= Z /\ Y =/= Z ) )
        -> ( F : A -1-1-> B <-> ( F : A --> B /\ ( ( F ` X ) =/= ( F ` Y )
              /\ ( F ` X ) =/= ( F ` Z ) /\ ( F ` Y ) =/= ( F ` Z ) ) ) ) ) $=
      ( vx vy wne cdif wral wa w3a wceq fveq2 necom wf1 cfv csn wcel dff14b ctp
      wf cv raleqi wb sneq difeq2d neeq1d raleqbidv raltpg adantr difeq1i tprot
      cpr anbi12i biimpi 3adant3 diftpsn3 syl syl5eq adantl neeq2d ralprg bitrd
      raleqdv 3adant1 tpcomb anim2i 3adant2 3anbi123d ancom 3anbi2i 3an6 3anrot
      bicomi 3anbi123i anidm 3ancoma bitri 3bitri a1i syl5bb anbi2d ) ABDUAABDU
      GZKUHZDUBZLUHZDUBZMZLAWJUCZNZOZKAOZPGCUDZHEUDZIFUDZQZGHMZGIMZHIMZQZPZWIGD
      UBZHDUBZMZXHIDUBZMZXIXKMZQZPKLABDUEXGWRXNWIWRWQKGHIUFZOZXGXNWQKAXOJUIXGXP
      XHWMMZLAGUCZNZOZXIWMMZLAHUCZNZOZXKWMMZLAIUCZNZOZQZXNXBXPYIUJXFWQXTYDYHKGH
      ICEFWJGRZWNXQLWPXSYJWOXRAWJGUKULYJWKXHWMWJGDSUMUNWJHRZWNYALWPYCYKWOYBAWJH
      UKULYKWKXIWMWJHDSUMUNWJIRZWNYELWPYGYLWOYFAWJIUKULYLWKXKWMWJIDSUMUNUOUPXGY
      IXJXLPZXIXHMZXMPZXKXHMZXKXIMZPZQZXNXGXTYMYDYOYHYRXGXTXQLHIUSZOZYMXGXQLXSY
      TXFXSYTRXBXFXSXOXRNZYTAXOXRJUQXFUUBHIGUFZXRNZYTXOUUCXRGHIURUQXFHGMZIGMZPZ
      UUDYTRXCXDUUGXEXCXDPUUGXCUUEXDUUFGHTGITUTVAVBHIGVCVDVEVEVFVJXBUUAYMUJZXFW
      TXAUUHWSXQXJXLLHIEFWLHRZWMXIXHWLHDSZVGWLIRZWMXKXHWLIDSZVGVHVKUPVIXGYDYALG
      IUSZOZYOXGYALYCUUMXFYCUUMRXBXFYCXOYBNZUUMAXOYBJUQXFUUOGIHUFZYBNZUUMXOUUPY
      BGHIVLUQXFXCIHMZPZUUQUUMRXCXEUUSXDXEUURXCXEUURHITVAVMVNGIHVCVDVEVEVFVJXBU
      UNYOUJZXFWSXAUUTWTYAYNXMLGICFWLGRZWMXHXIWLGDSZVGUUKWMXKXIUULVGVHVNUPVIXGY
      HYELGHUSZOZYRXGYELYGUVCXFYGUVCRXBXFYGXOYFNZUVCAXOYFJUQXDXEUVEUVCRXCGHIVCV
      KVEVFVJXBUVDYRUJZXFWSWTUVFXAYEYPYQLGHCEUVAWMXHXKUVBVGUUIWMXIXKUUJVGVHVBUP
      VIVOYSXNUJXGYSYMXMYNPZYRQXJXMYPQZXLYNYQQZPZXNYOUVGYMYRYNXMVPVQXJXLXMYNYPY
      QVRUVJYPXJXMQZUVKPUVKXNUVHUVKUVIUVKUVKUVHYPXJXMVSVTXLYPYNXJYQXMXHXKTXIXHT
      XKXITWAUTUVKWBUVKXJYPXMQXNYPXJXMWCYPXLXJXMXKXHTVQWDWEWEWFVIVIWGWHWG $.
  $}

  ${
    f13idfv.a $e |- A = ( 0 ... 2 ) $.
    $( A one-to-one function with a set of 3 sequential integers as domain in
       terms of function values.  (Contributed by Alexander van der Vekens,
       26-Jan-2018.) $)
    f13idfv $p |- ( F : A -1-1-> B
      <-> ( F : A --> B /\ ( ( F ` 0 ) =/= ( F ` 1 ) /\ ( F ` 0 ) =/= ( F ` 2 )
                             /\ ( F ` 1 ) =/= ( F ` 2 ) ) ) ) $=
      ( cc0 cz wcel c1 c2 w3a wne wf1 cfv 2z 3pm3.2i necomi co c3 cfzo eqtri wf
      wa wb 0z 1z ax-1ne0 2ne0 1ne2 cfz caddc wceq fzval3 ax-mp 2p1e3 fzo0to3tp
      ctp oveq2i f13dfv mp2an ) EFGZHFGZIFGZJEHKZEIKZHIKZJABCLABCUAECMZHCMZKVFI
      CMZKVGVHKJUBUCUTVAVBUDUENOVCVDVEHEUFPIEUGPUHOABFCFFEHIAEIUIQZEHIUPZDVIERS
      QZVJVIEIHUJQZSQZVKVBVIVMUKNEIULUMVLRESUNUQTUOTTURUS $.
  $}

  ${
    $d i x X $.  $d i x Y $.  $d i x F $.
    $( The range of a one-to-one function ` F ` of an unordered pair into a set
       is the unordered pair of the function values.  (Contributed by Alexander
       van der Vekens, 2-Feb-2018.) $)
    rnfdmpr $p |- ( ( X e. V /\ Y e. W )
                -> ( F Fn { X , Y } -> ran F = { ( F ` X ) , ( F ` Y ) } ) ) $=
      ( vx vi wcel wa cpr cfv wceq cv cab cun fveq2 eqeq2d abbidv csn df-sn wfn
      wrex fnrnfv adantl ciun iunxprg adantr iunab eqcomi uneq12i df-pr 3eqtr3g
      crn eqtr4i eqtrd ex ) DBHECHIZADEJZUAZAUMZDAKZEAKZJZLUQUSIZUTFMZGMZAKZLZG
      URUBFNZVCUSUTVILUQGFURAUCUDVDGURVHFNZUEZVEVALZFNZVEVBLZFNZOZVIVCUQVKVPLUS
      GDEVJVMVOBCVFDLZVHVLFVQVGVAVEVFDAPQRVFELZVHVNFVRVGVBVEVFEAPQRUFUGVHGFURUH
      VPVASZVBSZOVCVMVSVOVTVSVMFVATUIVTVOFVBTUIUJVAVBUKUNULUOUP $.
  $}

  $( The image of the range of a function ` F ` under a function ` E ` when
     ` F ` is a function of a pair into the domain of ` E ` .  (Contributed by
     Alexander van der Vekens, 2-Feb-2018.) $)
  imarnf1pr $p |- ( ( X e. V /\ Y e. W )
          -> ( ( ( F : { X , Y } --> dom E /\ E : dom E --> R )
                 /\ ( ( E ` ( F ` X ) ) = A /\ ( E ` ( F ` Y ) ) = B ) )
               -> ( E " ran F ) = { A , B } ) ) $=
    ( wcel wa cpr wf cfv wceq cima wi wfn ffn adantr cdm adantl simpll ffvelrnd
    crn prid1g prid2g ad2antll fnimapr syl3anc ex impcom rnfdmpr syl5com eqcomd
    imaeq2d preq12 3eqtr3d ) HFJZIGJZKZHILZDUAZEMZVCCDMZKZHENZDNZAOIENZDNZBOKZK
    ZDEUEZPZABLZOVAVLKZDVGVILZPZVHVJLZVNVOVLVAVRVSOZVFVAVTQVKVFVAVTVFVAKZDVCRZV
    GVCJVIVCJVTVFWBVAVEWBVDVCCDSUBTWAVBVCHEVDVEVAUCZVAHVBJZVFUSWDUTHIFUFTUBUDWA
    VBVCIEWCUTIVBJVFUSHIGUGUHUDVCVGVIDUIUJUKTULVPVQVMDVPVMVQVLVAVMVQOZVFVAWEQZV
    KVDWFVEVDEVBRVAWEVBVCESEFGHIUMUNTTULUOUPVKVSVOOVAVFVHVJABUQUHURUK $.

  ${
    $d F x $.  $d X x $.
    $( If the function value of a function is in the range of the function
       restricted to the singleton containing the argument, then the function
       value of the function is in the range of the function.  (Contributed by
       Alexander van der Vekens, 22-Jul-2018.) $)
    fvelrnfvelrnressn $p |- ( X e. V -> ( ( F ` X ) e. ran ( F |` { X } )
                              -> ( F ` X ) e. ran F ) ) $=
      ( vx cfv csn cres crn wcel cima df-ima eleq2i cop cv wex opeq1 eleq1d cvv
      wceq wb spcegv fvex elimasng mpan2 elrn2g mp1i 3imtr4d syl5bir ) CAEZACFZ
      GHZIUIAUJJZIZCBIZUIAHIZULUKUIAUJKLUNCUIMZAIZDNZUIMZAIZDOZUMUOUTUQDCBURCSU
      SUPAURCUIPQUAUNUIRIZUMUQTCAUBZACUIBRUCUDVBUOVATUNVCDUIARUEUFUGUH $.
  $}

  $( The function value of a function restricted to the singleton containing
     the argument equals the function value of the function for this argument.
     (Contributed by Alexander van der Vekens, 22-Jul-2018.) $)
  fvressn $p |- ( X e. V -> ( ( F |` { X } ) ` X ) = ( F ` X ) ) $=
    ( wcel csn cres cfv wceq snidg fvres syl ) CBDCCEZDCALFGCAGHCBICLAJK $.

  $( If the function value of a class is not null, the function value is an
     element of the range of the class.  (Contributed by Alexander van der
     Vekens, 22-Jul-2018.) $)
  fvn0fvelrn $p |- ( ( F ` X ) =/= (/) -> ( F ` X ) e. ran F ) $=
    ( cfv c0 wne cdm wcel csn cres wfun wa crn fvfundmfvn0 eldmeldmressn biimpi
    wi fvelrn pm3.2 syl ex com13 mpd imp eleq1d fvelrnfvelrnressn sylbid impcom
    fvressn 3syl ) BACZDEBAFZGZABHIZJZKBUMCZUMLZGZULKZUJALGZBAMULUNURULBUMFGZUN
    URPULUTABNOUNUTULURUNUTULURPZUNUTKUQVABUMQUQULRSTUAUBUCULUQUSULUQUJUPGUSULU
    OUJUPAUKBUHUDAUKBUEUFUGUI $.

  ${
    $d M x y $.  $d V x $.  $d X x y $.  $d Y y $.  $d m y $.
    elfvmptrab1.f $e |- F = ( x e. V |-> { y e. [_ x / m ]_ M | ph } ) $.
    elfvmptrab1.v $e |- ( X e. V -> [_ X / m ]_ M e. _V ) $.
    $( Implications for the value of a function defined by the maps-to notation
       with a class abstraction as a result having an element.  Here, the base
       set of the class abstraction depends on the argument of the function
       (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    elfvmptrab1 $p |- ( Y e. ( F ` X )
                        -> ( X e. V /\ Y e. [_ X / m ]_ M ) ) $=
      ( cfv wcel csb c0 crab cvv wceq 3syl nfcv wa wne ne0i ndmfv necon1ai wsbc
      cdm wi dmmptss sseli rabexg nfsbc1v nfcsb csbeq1 sbceq1a rabeqbidv fvmptf
      cv nfrab syl2anc eleq2d elrabi anim12i ex sylbid pm2.43i ) IHELZMZHGMZIDH
      FNZMZUAZVHVGOUBHEUGZMZVHVLUHVGIUCVNVGOHEUDUEVNVHIABHUFZCVJPZMZVLVNVGVPIVN
      VIVPQMZVGVPRVMGHBGACDBURZFNZPZEJUIUJZVNVIVJQMVRWBKVOCVJQUKSBHWAVPGEQBHTZV
      OBCVJABHULBDHFWCBFTUMUSVSHRAVOCVTVJDVSHFUNABHUOUPJUQUTVAVNVQVLVNVIVQVKWBV
      OCIVJVBVCVDVESVF $.
  $}

  ${
    $d M m x y $.  $d V x $.  $d X x y $.  $d Y y $.
    elfvmptrab.f $e |- F = ( x e. V |-> { y e. M | ph } ) $.
    elfvmptrab.v $e |- ( X e. V -> M e. _V ) $.
    $( Implications for the value of a function defined by the maps-to notation
       with a class abstration as a result having an element.  (Contributed by
       Alexander van der Vekens, 15-Jul-2018.) $)
    elfvmptrab $p |- ( Y e. ( F ` X ) -> ( X e. V /\ Y e. M ) ) $=
      ( vm cfv wcel csb wa crab cmpt wceq csbconstg syl cv rabeq mpteq2ia eqtri
      eqcomd cvv eqeltrd elfvmptrab1 eleq2d biimpd imdistani ) HGDLMGFMZHKGENZM
      ZOULHEMZOABCKDEFGHDBFACEPZQBFACKBUAZENZPZQIBFUPUSUQFMZEURRUPUSRUTUREKUQEF
      SUEACEURUBTUCUDULUMEUFKGEFSZJUGUHULUNUOULUNUOULUMEHVAUIUJUKT $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Operations - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d X w x y z $.  $d Y w x y z $.  $d Z w x y z $.  $d ph w $.
    $( If a pair and a class are in a relationship given by a class abstraction
       of a collection of nested ordered pairs, the involved classes are sets.
       (Contributed by Alexander van der Vekens, 8-Jul-2018.) $)
    oprabv $p |- ( <. X , Y >. { <. <. x , y >. , z >. | ph } Z
                   -> ( X e. _V /\ Y e. _V /\ Z e. _V ) ) $=
      ( vw cop cvv wcel wa mpan wi cv wceq wex wb nfcv nfex coprab wbr w3a wrel
      reloprab brrelex12 df-br copab wsbc opex nfeq1 nfan nfsbc1v eqeq1 2exbidv
      nfv anbi1d sbceq1a anbi2d opelopabgf eqcom opth bitri eleq1 eqcoms mpbiri
      anim12i sylbi adantr exlimivv anim1i df-3an sylibr expcom sylbid dfoprab2
      vex com12 eleq2s adantl mpcom ) EFIZJKZGJKZLZWBGABCDUAZUBZEJKZFJKZWDUCZWF
      UDWGWEABCDUEWBGWFUFMWDWGWJNWCWGWDWJWGWBGIZWFKWDWJNZWBGWFUGWLWKHOZBOZCOZIZ
      PZALZCQBQZHDUHZWFWDWKWTKZWJWDXAWBWPPZADGUIZLZCQZBQZWJWCWDXAXFREFUJWSXBALZ
      CQZBQXFHDWBGJJXHHBXGHCXBAHHWBWPHWBSUKAHUPULTTXEDBXDDCXBXCDDWBWPDWBSUKADGU
      MULTTWMWBPZWRXGBCXIWQXBAWMWBWPUNUQUODOGPZXGXDBCXJAXCXBADGURUSUOUTMXFWDWJX
      FWDLWHWILZWDLWJXFXKWDXDXKBCXBXKXCXBWNEPZWOFPZLZXKXBWPWBPXNWBWPVAWNWOEFBVQ
      ZCVQZVBVCXLWHXMWIXLWHWNJKZXOWHXQREWNEWNJVDVEVFXMWIWOJKZXPWIXRRFWOFWOJVDVE
      VFVGVHVIVJVKWHWIWDVLVMVNVOVRABCDHVPVSVHVRVTWA $.
  $}

  ${
    $d M x y z $.  $d X x y z $.  $d Y x y z $.  $d Z z $.
    elovmpt2rab.o $e |- O = ( x e. _V , y e. _V |-> { z e. M | ph } ) $.
    elovmpt2rab.v $e |- ( ( X e. _V /\ Y e. _V ) -> M e. _V ) $.
    $( Implications for the value of an operation defined by the maps-to
       notation with a class abstration as a result having an element.
       (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    elovmpt2rab $p |- ( Z e. ( X O Y ) -> ( X e. _V /\ Y e. _V /\ Z e. M ) ) $=
      ( cvv wcel wa crab wsbc wceq cv nfcv nfel1 w3a elmpt2cl cmpt2 a1i sbceq1a
      co wb sylan9bbr adantl rabbidv eqidd simpl simpr rabexg syl nfsbc1v nfrab
      nfan nfsbc ovmpt2dxf eleq2d elrabi df-3an simplbi2com com12 sylbid mpcom
      wi ) GLMZHLMZNZIGHFUFZMZVIVJIEMZUAZBCLLADEOZGHFIJUBVKVMIACHPZBGPZDEOZMZVO
      VKVLVSIVKBCGHLLVPVSFLLFBCLLVPUCQVKJUDVKBRGQZCRHQZNZNAVRDEWCAVRUGVKWBAVQWA
      VRACHUEVQBGUEUHUIUJVKWANLUKVIVJULVIVJUMVKELMVSLMKVRDELUNUOVIVJBBGLBGSTBHL
      BHSZTURVIVJCCGLCGSZTCHLCHSTURWEWDVRBDEVQBGUPBESUQVRCDEVQCBGWEACHUPUSCESUQ
      UTVAVTVKVOVTVNVKVOVHVRDIEVBVOVKVNVIVJVNVCVDUOVEVFVG $.
  $}

  ${
    $d M x y z $.  $d X x y z $.  $d Y x y z $.  $d Z z $.  $d m z $.
    elovmpt2rab1.o $e |- O = ( x e. _V , y e. _V
                              |-> { z e. [_ x / m ]_ M | ph } ) $.
    elovmpt2rab1.v $e |- ( ( X e. _V /\ Y e. _V ) -> [_ X / m ]_ M e. _V ) $.
    $( Implications for the value of an operation defined by the maps-to
       notation with a class abstraction as a result having an element.  Here,
       the base set of the class abstraction depends on the first operand.
       (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    elovmpt2rab1 $p |- ( Z e. ( X O Y )
                         -> ( X e. _V /\ Y e. _V /\ Z e. [_ X / m ]_ M ) ) $=
      ( cvv wcel wa csb cv wceq nfcv nfel1 co w3a crab elmpt2cl wsbc a1i csbeq1
      cmpt2 ad2antrl wb sylan9bbr adantl rabeqbidv eqidd simpl simpr rabexg syl
      sbceq1a nfan nfcsb nfrab nfsbc ovmpt2dxf eleq2d elrabi df-3an simplbi2com
      nfsbc1v wi com12 sylbid mpcom ) HMNZIMNZOZJHIGUAZNZVNVOJEHFPZNZUBZBCMMADE
      BQZFPZUCZHIGJKUDVPVRJACIUEZBHUEZDVSUCZNZWAVPVQWGJVPBCHIMMWDWGGMMGBCMMWDUH
      RVPKUFVPWBHRZCQIRZOZOAWFDWCVSWIWCVSRVPWJEWBHFUGUIWKAWFUJVPWJAWEWIWFACIUSW
      EBHUSUKULUMVPWIOMUNVNVOUOVNVOUPVPVSMNWGMNLWFDVSMUQURVNVOBBHMBHSZTBIMBISZT
      UTVNVOCCHMCHSZTCIMCISTUTWNWMWFBDVSWEBHVIBEHFWLBFSVAVBWFCDVSWECBHWNACIVIVC
      CEHFWNCFSVAVBVDVEWHVPWAWHVTVPWAVJWFDJVSVFWAVPVTVNVOVTVGVHURVKVLVM $.
  $}

  ${
    $d M a x y z $.  $d N a x y z $.  $d X a x y z $.  $d Y a x y z $.
    $d a n $.  $d a m z $.
    ovmpt3rab1.o $e |- O = ( x e. _V , y e. _V
                |-> ( z e. [_ x / m ]_ M |-> { a e. [_ x / n ]_ N | ph } ) ) $.
    ovmpt3rab1.1 $e |- ( ( X e. _V /\ Y e. _V ) -> [_ X / m ]_ M e. _V ) $.
    $( The value of an operation defined by the maps-to notation with a
       function into a class abstraction as a result.  Here, the base set of
       the class abstraction depends on the first operand.  (Contributed by
       Alexander van der Vekens, 16-Jul-2018.) $)
    ovmpt3rab1 $p |- ( ( X e. _V /\ Y e. _V )
            -> ( X O Y ) = ( z e. [_ X / m ]_ M
                 |-> { a e. [_ X / n ]_ N | [. X / x ]. [. Y / y ]. ph } ) ) $=
      ( cvv wcel wa csb wceq nfcv cv crab cmpt wsbc cmpt2 csbeq1 adantr sbceq1a
      a1i wb sylan9bbr rabeqbidv mpteq12dva adantl eqidd simpl simpr mptexg syl
      nfel1 nfan nfcsb nfsbc1v nfrab nfmpt nfsbc ovmpt2dxf ) JOPZKOPZQZBCJKOODE
      BUAZGRZALFVKHRZUBZUCZDEJGRZACKUDZBJUDZLFJHRZUBZUCZIOOIBCOOVOUESVJMUIVKJSZ
      CUAKSZQZVOWASVJWDDVLVNVPVTWBVLVPSWCEVKJGUFUGWDDUAVLPZQAVRLVMVSWDVMVSSZWEW
      BWFWCFVKJHUFUGUGWDAVRUJWEWCAVQWBVRACKUHVQBJUHUKUGULUMUNVJWBQOUOVHVIUPVHVI
      UQVJVPOPWAOPNDVPVTOURUSVHVIBBJOBJTZUTBKOBKTZUTVAVHVICCJOCJTZUTCKOCKTUTVAW
      IWHBDVPVTBEJGWGBGTVBVRBLVSVQBJVCBFJHWGBHTVBVDVECDVPVTCEJGWICGTVBVRCLVSVQC
      BJWIACKVCVFCFJHWICHTVBVDVEVG $.

    $d M a t x y z $.  $d N t $.  $d X t $.  $d Y t $.  $d A a $.  $d Z a z $.
    $d m t $.  $d n t $.  $d ph t $.
    ovmpt3rab1.2 $e |- ( ( X e. _V /\ Y e. _V ) -> [_ X / n ]_ N e. _V ) $.
    $( Implications for the value of an operation defined by the maps-to
       notation with a function into a class abstraction as a result having an
       element.  Here, the base set of the class abstraction depends on the
       first operand.  (Contributed by Alexander van der Vekens,
       16-Jul-2018.) $)
    elovmpt3rab1 $p |- ( A e. ( ( X O Y ) ` Z ) -> ( ( X e. _V /\ Y e. _V )
                        /\ ( Z e. [_ X / m ]_ M /\ A e. [_ X / n ]_ N ) ) ) $=
      ( wcel cvv c0 vt co cfv wa csb wne cdm ne0i ndmfv necon1ai wsbc crab cmpt
      wi w3a wceq ovmpt3rab1 3adant3 dmeqd eleq2d cv copab dmopabss sseli simp3
      rabexg syl nfcv nfsbc1v nfcsb nfrab sbceq1a rabbidv fvmptf syl2anc fveq1d
      eqid wb eqeq1d mpbird 3expa simpll simpr elrabi anim12i jca ex sylbid a1d
      com23 wn mpt2ndm0 fveq1 syl6eq eqneqall 3syl pm2.61i mpcom syl5com df-mpt
      0fv dmeqi eleq2s syl6bi w3o 3ianor wo df-3or ianor dm0 eleq2i syl6bb noel
      pm2.21i sylbir jaoi sylbi pm2.43i ) EMKLJUBZUCZRZKSRZLSRZUDZMFKHUEZRZEGKI
      UEZRZUDZUDZYAXTTUFZMXSUGZRZYAYJUNZXTEUHZYMXTTMXSUIUJYBYCYDUOZYMYNUNZYPYMM
      DYEACLUKBKUKZNYGULZUMZUGZRYNYPYLUUAMYPXSYTYBYCXSYTUPYDABCDFGHIJKLNOPUQZUR
      USUTYNMDVAZYERUAVAYSUPZUDDUAVBZUGZUUAMUUFRYFYAYJUUFYEMUUDDUAYEVCVDYKYAYFY
      JUNZYOYDYKYAUUGUNZUNZYDUUHYKYDYFYAYJYDYFYNYDYFUDZYAEYRDMUKZNYGULZRZYJUUJX
      TUULEYBYCYFXTUULUPZYBYCYFUOZUUNMYTUCZUULUPZUUOYFUULSRZUUQYBYCYFVEUUOYGSRZ
      UURYBYCUUSYFQURUUKNYGSVFVGDMYSUULYEYTSDMVHUUKDNYGYRDMVIDGKIDKVHDIVHVJVKUU
      CMUPYRUUKNYGYRDMVLVMYTVQVNVOYBYCUUNUUQVRYFYDXTUUPUULYDMXSYTUUBVPVSURVTWAU
      TUUJUUMYJUUJUUMUDYDYIYDYFUUMWBUUJYFUUMYHYDYFWCUUKNEYGWDWEWFWGWHWGWJWIYDWK
      ZXSTUPZXTTUPUUIBCDFBVAZHUEANGUVBIUEULUMJKLSSOWLZUVAXTMTUCTMXSTWMMXAWNUUHX
      TTWOWPWQWRWSYTUUEDUAYEYSWTXBXCXDYPWKYBWKZYCWKZUUTXEZYQYBYCYDXFUVFUVDUVEXG
      ZUUTXGYQUVDUVEUUTXHUVGYQUUTUVGUUTYQYBYCXIUUTYMMTRZYNUUTYMMTUGZRUVHUUTYLUV
      IMUUTXSTUVCUSUTUVITMXJXKXLUVHYNMXMXNXDZXOUVJXPXQXQWQWPXR $.
  $}

  ${
    $d M a m x y z $.  $d N a n x y z $.  $d X a x y z $.  $d Y a x y z $.
    $d Z a z $.  $d A a $.
    elovmpt3rab.o $e |- O = ( x e. _V , y e. _V
                              |-> ( z e. M |-> { a e. N | ph } ) ) $.
    elovmpt3rab.1 $e |- ( ( X e. _V /\ Y e. _V ) -> M e. _V ) $.
    elovmpt3rab.2 $e |- ( ( X e. _V /\ Y e. _V ) -> N e. _V ) $.
    $( Implications for the value of an operation defined by the maps-to
       notation with a class abstration as a result having an element.
       (Contributed by Alexander van der Vekens, 17-Jul-2018.) $)
    elovmpt3rab $p |- ( A e. ( ( X O Y ) ` Z ) -> ( ( X e. _V /\ Y e. _V )
                        /\ ( Z e. M /\ A e. N ) ) ) $=
      ( vm wcel cvv wa adantr vn co cfv csb crab cmpt cmpt2 cv csbconstg eqcomd
      wceq rabeq syl mpteq12dva mpt2eq3ia eqtri eleq1d biimprd mpd elovmpt3rab1
      wi wb eleq2d anbi12d biimpd imdistani ) EKIJHUBUCQIRQZJRQZSZKPIFUDZQZEUAI
      GUDZQZSZSVIKFQZEGQZSZSABCDEPUAFGHIJKLHBCRRDFALGUEZUFZUGBCRRDPBUHZFUDZALUA
      VTGUDZUEZUFZUGMBCRRVSWDVTRQZCUHRQZSZDFVRWAWCWGWAFWEWAFUKWFPVTFRUITUJWGVRW
      CUKZDUHFQWGGWBUKWHWGWBGWEWBGUKWFUAVTGRUITUJALGWBULUMTUNUOUPVIFRQZVJRQZNVG
      WIWJVAVHVGWJWIVGVJFRPIFRUIZUQURTUSVIGRQZVLRQZOVGWLWMVAVHVGWMWLVGVLGRUAIGR
      UIZUQURTUSUTVIVNVQVIVNVQVIVKVOVMVPVGVKVOVBVHVGVJFKWKVCTVGVMVPVBVHVGVLGEWN
      VCTVDVEVFUM $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Equinumerosity - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The restriction of a function by a finite set is finite.  (Contributed by
     Alexander van der Vekens, 3-Feb-2018.) $)
  resfnfinfin $p |- ( ( F Fn A /\ B e. Fin ) -> ( F |` B ) e. Fin ) $=
    ( wfn cfn wcel wa cres cdm cin wrel wceq fnrel adantr resisresindm syl wfun
    wi fnfun funfn sylib fnresin2 infi fnfi sylan2 ex 3syl imp eqeltrd ) CADZBE
    FZGZCBHZCBCIZJZHZEULCKZUMUPLUJUQUKACMNBCOPUJUKUPEFZUJCUNDZUPUODZUKURRUJCQUS
    ACSCTUAUNBCUBUTUKURUKUTUOEFURBUNUCUOUPUDUEUFUGUHUI $.

  $( The cross product of three finite sets is a finite set.  (Contributed by
     Alexander van der Vekens, 11-Mar-2018.) $)
  3xpfi $p |- ( V e. Fin -> ( ( V X. V ) X. V ) e. Fin ) $=
    ( cxp cfn wcel xpfi anidms mpancom ) AABZCDZACDZHABCDJIAAEFHAEG $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Subtraction - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( A complex number minus 1 is a complex number.  (Contributed by Alexander
     van der Vekens, 18-Mar-2018.) $)
  cnm1cn $p |- ( N e. CC -> ( N - 1 ) e. CC ) $=
    ( cc wcel c1 cmin co ax-1cn subcl mpan2 ) ABCDBCADEFBCGADHI $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Multiplication - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( k times k minus 1 is a complex number if k is a complex number.
     (Contributed by Alexander van der Vekens, 11-Mar-2018.) $)
  kcnktkm1cn $p |- ( K e. CC -> ( K x. ( K - 1 ) ) e. CC ) $=
    ( cc wcel c1 cmin co id ax-1cn a1i subcld mulcld ) ABCZAADEFLGZLADMDBCLHIJK
    $.

  $( Two times a complex number minus the number itself results in the number
     itself.  (Contributed by Alexander van der Vekens, 8-Jun-2018.) $)
  2txmxeqx $p |- ( X e. CC -> ( ( 2 x. X ) - X ) = X ) $=
    ( cc wcel c2 cmul co cmin caddc 2times oveq1d id pncan2d eqtrd ) ABCZDAEFZA
    GFAAHFZAGFANOPAGAIJNAANKZQLM $.

  ${
    mulsubfacd.1 $e |- ( ph -> A e. CC ) $.
    mulsubfacd.2 $e |- ( ph -> B e. CC ) $.
    $( Multiplication followed by the subtraction of a factor.  (Contributed by
       Alexander van der Vekens, 28-Aug-2018.) $)
    mulsubfacd $p |- ( ph -> ( ( A x. B ) - B ) = ( ( A - 1 ) x. B ) ) $=
      ( c1 cmin co cmul cc wcel ax-1cn a1i subdird mulid2d oveq2d eqtr2d ) ABFG
      HCIHBCIHZFCIHZGHRCGHABFCDFJKALMENASCRGACEOPQ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Ordering on reals (cont.) - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Addition and subtraction on one side of 'less or equal'.  (Contributed by
     Alexander van der Vekens, 18-Mar-2018.) $)
  leaddsuble $p |- ( ( A e. RR /\ B e. RR /\ C e. RR ) ->
                    ( B <_ C <-> ( ( A + B ) - C ) <_ A ) ) $=
    ( cr wcel w3a cle caddc co cmin wb leadd2 3comr readdcl 3adant3 simp3 simp1
    wbr lesubaddd bitr4d ) ADEZBDEZCDEZFZBCGRZABHIZACHIGRZUFCJIAGRUBUCUAUEUGKBC
    ALMUDUFCAUAUBUFDEUCABNOUAUBUCPUAUBUCQST $.

  $( If two real numbers are less than a third real number, the sum of the real
     numbers is less then twice the third real number.  (Contributed by
     Alexander van der Vekens, 21-May-2018.) $)
  2leaddle2 $p |- ( ( A e. RR /\ B e. RR /\ C e. RR )
                 -> ( ( A < C /\ B < C ) -> ( A + B ) < ( 2 x. C ) ) ) $=
    ( cr wcel w3a clt wbr wa caddc co c2 cle readdcl 3adant3 3ad2ant3 adantr id
    jca sylc cmul anidms 2re remulcl mpan 3jca simpr lt2add recn leidd eqbrtrrd
    2timesd ltletr ex ) ADEZBDEZCDEZFZACGHBCGHIZABJKZLCUAKZGHZURUSIZUTDEZCCJKZD
    EZVADEZFZUTVEGHZVEVAMHZIVBURVHUSURVDVFVGUOUPVDUQABNOUQUOVFUPUQVFCCNUBPUQUOV
    GUPLDEUQVGUCLCUDUEZPUFQVCVIVJVCUOUPIZUQUQIZIZUSVIURVNUSURVLVMUOUPVLUQVLROUQ
    UOVMUPUQUQUQUQRZVOSPSQURUSUGABCCUHTURVJUSUQUOVJUPUQVAVEVAMUQCCUIULUQVAVKUJU
    KPQSUTVEVAUMTUN $.

  $( If adding a real number to a real number results in a value less then the
     second real number, the first real number must be not positive.
     (Contributed by Alexander van der Vekens, 30-May-2018.) $)
  leaddle0 $p |- ( ( A e. RR /\ B e. RR ) -> ( ( A + B ) <_ A <-> B <_ 0 ) ) $=
    ( cr wcel wa caddc co cle wbr cmin wb leaddsub2 3anidm13 wceq subidd adantr
    cc0 recn breq2d bitrd ) ACDZBCDZEZABFGAHIZBAAJGZHIZBQHIUAUBUDUFKABALMUCUEQB
    HUAUEQNUBUAAAROPST $.

  $( Variant of trichotomy law for 'less than'.  (Contributed by Alexander van
     der Vekens, 8-Jun-2018.) $)
  ltnltne $p |- ( ( A e. RR /\ B e. RR ) ->
                ( A < B <-> ( -. B < A /\ -. B = A ) ) ) $=
    ( cr wcel wa clt wbr cle wn wceq wo ltnle wb leloe ancoms notbid a1i 3bitrd
    ioran ) ACDZBCDZEZABFGBAHGZIBAFGZBAJZKZIZUDIUEIEZABLUBUCUFUATUCUFMBANOPUGUH
    MUBUDUESQR $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Nonnegative integers (as a subset of complex numbers) - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The result of subtracting a positive integer from 0 is not a nonnegative
     integer.  (Contributed by Alexander van der Vekens, 19-Mar-2018.) $)
  0mnnnnn0 $p |- ( N e. NN -> ( 0 - N ) e/ NN0 ) $=
    ( cn wcel cc0 cmin co cn0 wnel cr 0re wn nnel cneg df-neg eqcomi eleq1i cle
    wbr nn0ge0 syl5bi nnre le0neg1d clt wi a1i ltnled pm2.21 syl6bi mpd sylbird
    nngt0 syl5 mt4i ) ABCZDAEFZGHZDICZJUPKUOGCZUNUQKZUOGLURAMZGCZUNUSUOUTGUTUOA
    NOPVADUTQRZUNUSUTSUNVBADQRZUSUNAAUAZUBUNDAUCRZVCUSUDZAUKUNVEVCKVFUNDAUQUNJU
    EVDUFVCUSUGUHUIUJULTTUM $.

  $( Subtracting a nonnegative integer from a nonnegative integer which is
     greater than or equal to the first one results in a nonnegative integer.
     (Contributed by Alexander van der Vekens, 6-Apr-2018.) $)
  lesubnn0 $p |- ( ( A e. NN0 /\ B e. NN0 )
                   -> ( B <_ A -> ( A - B ) e. NN0 ) ) $=
    ( cn0 wcel wa cle wbr cc0 cmin co cr nn0re subge0 syl2an nn0z zsubcl anim1i
    wb cz elnn0z sylibr ex sylbird ) ACDZBCDZEZBAFGZHABIJZFGZUHCDZUDAKDBKDUIUGR
    UEALBLABMNUFUIUJUFUIEUHSDZUIEUJUFUKUIUDASDBSDUKUEAOBOABPNQUHTUAUBUC $.

  $( Subtracting a nonnegative integer from a nonnegative integer which is
     greater than the first one results in a nonnegative integer.  (Contributed
     by Alexander van der Vekens, 6-Apr-2018.) $)
  ltsubnn0 $p |- ( ( A e. NN0 /\ B e. NN0 )
                   -> ( B < A -> ( A - B ) e. NN0 ) ) $=
    ( cn0 wcel wa clt wbr cle cmin co cr wi nn0re ltle syl2anr lesubnn0 syld )
    ACDZBCDZEBAFGZBAHGZABIJCDSBKDAKDTUALRBMAMBANOABPQ $.

  $( Closure law for addition of reals, restricted to nonnnegative integers.
     (Contributed by Alexander van der Vekens, 6-Apr-2018.) $)
  nn0readdcl $p |- ( ( A e. NN0 /\ B e. NN0 ) -> ( A + B ) e. RR ) $=
    ( cn0 wcel wa caddc co nn0addcl nn0red ) ACDBCDEABFGABHI $.

  $( Closure law for subtraction of reals, restricted to nonnnegative
     integers.  (Contributed by Alexander van der Vekens, 6-Apr-2018.) $)
  nn0resubcl $p |- ( ( A e. NN0 /\ B e. NN0 ) -> ( A - B ) e. RR ) $=
    ( cn0 wcel cr cmin co nn0re resubcl syl2an ) ACDAEDBEDABFGEDBCDAHBHABIJ $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Upper partititions of integers - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( 1 is an integer greater than or equal to 0.  (Contributed by Alexander van
     der Vekens, 8-Jun-2018.) $)
  1eluzge0 $p |- 1 e. ( ZZ>= ` 0 ) $=
    ( c1 cc0 cuz cfv wcel cz cle wbr 0z 1z 0le1 eluz2 mpbir3an ) ABCDEBFEAFEBAG
    HIJKBALM $.

  $( 2 is an integer greater than or equal to 0.  (Contributed by Alexander van
     der Vekens, 8-Jun-2018.) $)
  2eluzge0 $p |- 2 e. ( ZZ>= ` 0 ) $=
    ( c2 cc0 cuz cfv wcel cz cle wbr 0z 2z 0re 2re 2pos ltleii eluz2 mpbir3an )
    ABCDEBFEAFEBAGHIJBAKLMNBAOP $.

  $( 2 is an integer greater than or equal to 1.  (Contributed by Alexander van
     der Vekens, 8-Jun-2018.) $)
  2eluzge1 $p |- 2 e. ( ZZ>= ` 1 ) $=
    ( c2 c1 cuz cfv wcel cz cle wbr 1z 2z 1re 2re 1lt2 ltleii eluz2 mpbir3an )
    ABCDEBFEAFEBAGHIJBAKLMNBAOP $.

  $( An upper integer is also an upper integer with a smaller bound.
     (Contributed by Alexander van der Vekens, 17-Jun-2018.) $)
  uzletr $p |- ( ( A e. ZZ /\ A <_ B )
                 -> ( N e. ( ZZ>= ` B ) -> N e. ( ZZ>= ` A ) ) ) $=
    ( cuz cfv wcel cz cle wbr w3a wa eluz2 simpll simpr2 wi cr ancom 3anass zre
    ex bitr4i 3anim123i sylbi syl exp3acom23 com23 3impia com3l imp31 syl3anbrc
    letr syl5bi ) CBDEFBGFZCGFZBCHIZJZAGFZABHIZKZCADEFZBCLUSUPUTUSUPKUQUNACHIZU
    TUQURUPMUSUMUNUONUQURUPVAUPUQURVAUMUNUOUQURVAOZOUMUNKZUQUOVBVCUQUOVBOVCUQKZ
    URUOVAVDAPFZBPFZCPFZJZURUOKVAOVDUQUMUNJZVHVDUQVCKVIVCUQQUQUMUNRUAUQVEUMVFUN
    VGASBSCSUBUCABCUKUDUETUFUGUHUIACLUJTUL $.

  $( If an integer is greater than or edual to a nonnegative integer, it is a
     nonnegative integer.  (Contributed by Alexander van der Vekens,
     27-Aug-2018.) $)
  eluzge0nn0 $p |- ( N e. ( ZZ>= ` M ) -> ( 0 <_ M -> N e. NN0 ) ) $=
    ( cuz cfv wcel cz cle wbr w3a cc0 cn0 wi eluz2 wa simpl2 cr zre 0re a1i ex
    simpl simpr 3jca syl2an letr syl exp3acom23 3imp1 elnn0z sylanbrc sylbi ) B
    ACDEAFEZBFEZABGHZIZJAGHZBKEZLABMUOUPUQUOUPNUMJBGHZUQULUMUNUPOULUMUNUPURULUM
    UNUPURLLULUMNZUPUNURUSJPEZAPEZBPEZIZUPUNNURLULVAVBVCUMAQBQVAVBNZUTVAVBUTVDR
    SVAVBUAVAVBUBUCUDJABUEUFUGTUHBUIUJTUK $.

  $( If an integer is greater than 2, it is a nonnegative integer.
     (Contributed by Alexander van der Vekens, 27-Aug-2018.) $)
  eluzge2nn0 $p |- ( N e. ( ZZ>= ` 2 ) -> N e. NN0 ) $=
    ( c2 cuz cfv wcel cc0 cle wbr cn0 0re 2re 2pos ltleii eluzge0nn0 mpi ) ABCD
    EFBGHAIEFBJKLMBANO $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Finite intervals of integers - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Subset relationship for finite sets of sequential integers.  (Contributed
     by Alexander van der Vekens, 16-Mar-2018.) $)
  ssfz12 $p |- ( ( K e. ZZ /\ L e. ZZ /\ K <_ L )
                 -> ( ( K ... L ) C_ ( M ... N ) -> ( M <_ K /\ L <_ N ) ) ) $=
    ( cz wcel cle wbr w3a cfz co wa wi cuz cfv syl ssel2 eluz2 3ad2ant3 sylbi
    wss eluz biimp3ar eluzfz1 eluzfz2 elfzuz3 elfzuz pm3.21 com13 com12 3syl ex
    a1i com4t com24 pm2.43i com14 mpcom mpd ) AEFZBEFZABGHZIZAABJKZFZVDCDJKZUAZ
    CAGHZBDGHZLZMZVCBANOFZVEUTVAVLVBABUBUCZABUDPBVDFZVCVEVKMVCVLVNVMABUEPVGVCVE
    VNVJVGVCVEVNVJMZMMVGVEVCVGVOVGVEVCVGVOMMZVGVELAVFFZVPVDVFAQVGVNVQVCVJVGVNVQ
    VCVJMZMZVGVNLBVFFDBNOFZVSVDVFBQBCDUFVQVTVRVQACNOFZVTVRMZACDUGWACEFZUTVHIWBC
    ARVHWCWBUTVCVTVHVJVTVHVJMZMVCVTVADEFZVIIWDBDRVIVAWDWEVIVHUHSTUMUISTPUJUKULU
    NPULUOUPUQURUS $.

  $( Membership of an integer in a finite set of sequential integers starting
     at 0.  (Contributed by Alexander van der Vekens, 25-May-2018.) $)
  elfz2z $p |- ( ( K e. ZZ /\ N e. ZZ )
                 -> ( K e. ( 0 ... N ) <-> ( 0 <_ K /\ K <_ N ) ) ) $=
    ( cc0 cfz co wcel cn0 wa cle wbr cz w3a elfz2nn0 adantr elnn0z cr wi adantl
    zre ex df-3an bitri wb nn0ge0 simpll anim1i sylibr 0re a1i syl3anc simplbi2
    letr syld exp3acom23 imp31 jca impbid2 pm5.32rd syl5bb ) ACBDEFZAGFZBGFZHZA
    BIJZHZAKFZBKFZHZCAIJZVDHZUTVAVBVDLVEABMVAVBVDUAUBVHVDVCVIVHVDVCVIUCVHVDHZVC
    VIVAVIVBAUDNVKVIVCVKVIHZVAVBVLVFVIHVAVKVFVIVFVGVDUEUFAOUGVHVDVIVBVHVIVDVBVH
    VJCBIJZVBVHCPFZAPFZBPFZVJVMQVNVHUHUIVFVOVGASNVGVPVFBSRCABULUJVGVMVBQVFVBVGV
    MBOUKRUMUNUOUPTUQTURUS $.

  $( Subtracting the left border of a finite sets of sequential integers from
     an element of this set.  (Contributed by Alexander van der Vekens,
     29-Mar-2018.) $)
  elfzmlbm $p |- ( K e. ( M ... N ) -> ( K - M ) e. ( 0 ... ( N - M ) ) ) $=
    ( cz wcel w3a cle wbr wa cmin co cn0 cfz wi znn0sub biimpd com12 impcom zre
    cr cc0 3adant2 adantr 3anim123i 3com23 syl 3adant3 imp 3com13 lesub1 adantl
    letr syld wb 3jca elfz2 elfz2nn0 3imtr4i ) BDEZCDEZADEZFZBAGHZACGHZIZIZABJK
    ZLEZCBJKZLEZVGVIGHZFABCMKEVGUAVIMKEVFVHVJVKVEVBVHVCVBVHNVDVBVCVHUSVAVCVHNUT
    USVAIVCVHBAOPUBQUCRVBVEVJVBVEBCGHZVJVBBTEZATEZCTEZFZVEVLNUSVAUTVPUSVMVAVNUT
    VOBSZASZCSZUDUEBACULUFUSUTVLVJNVAUSUTIVLVJBCOPUGUMUHVEVBVKVDVBVKNVCVBVDVKVB
    VDVKVBVNVOVMFZVDVKUNVAUTUSVTVAVNUTVOUSVMVRVSVQUDUIACBUJUFPQUKRUOABCUPVGVIUQ
    UR $.

  $( Subtracting the lower bound of a finite sets of sequential integers from
     an element of this set.  (Contributed by Alexander van der Vekens,
     29-Mar-2018.) $)
  elfzmlbp $p |- ( ( N e. ZZ /\ K e. ( M ... ( M + N ) ) )
                   -> ( K - M ) e. ( 0 ... N ) ) $=
    ( cz wcel co cfz wa cn0 cle wbr w3a cc0 wi wb adantr cr zre adantl imp cmin
    caddc elfz2 znn0sub biimpcd impcom zaddcl adantlr zred letr syl3anc addge01
    syl2an elnn0z simplbi2 sylbird syld df-3an bitr3i 3anim123i sylbi lesubadd2
    3ancoma syl biimprcd 3jca exp31 com23 3adant2 com12 syl5bi elfz2nn0 sylibr
    ) CDEZABBCUBFZGFEZHABUAFZIEZCIEZVQCJKZLZVQMCGFEVNVPWAVPBDEZVODEZADEZLZBAJKZ
    AVOJKZHZHZVNWAABVOUCWIVNWAWEWHVNWANZWBWDWHWJNWCWBWDHZVNWHWAWKVNWHWAWKVNHZWH
    HVRVSVTWHWLVRWFWLVRNWGWLWFVRWKWFVROVNBAUDPUEPUFWLWHVSWLWHBVOJKZVSWLBQEZAQEZ
    VOQEWHWMNWKWNVNWBWNWDBRZPZPWKWOVNWDWOWBARZSPWLVOWBVNWCWDBCUGUHUIBAVOUJUKWLW
    MMCJKZVSWKWNCQEZWSWMOVNWQCRZBCULUMVNWSVSNWKVSVNWSCUNUOSUPUQTWHWLVTWGWLVTNWF
    WLVTWGWLWOWNWTLZVTWGOWLWDWBVNLZXBWLWBWDVNLXCWBWDVNURWBWDVNVCUSWDWOWBWNVNWTW
    RWPXAUTVAABCVBVDVESUFVFVGVHVITVJVKTVQCVLVM $.

  $( Transitive law of ordering for integers.  (Contributed by Alexander van
     der Vekens, 3-Apr-2018.) $)
  zletr $p |- ( ( J e. ZZ /\ K e. ZZ /\ L e. ZZ )
                -> ( ( J <_ K /\ K <_ L ) -> J <_ L ) ) $=
    ( cz wcel cr cle wbr wa wi zre letr syl3an ) ADEAFEBDEBFECDECFEABGHBCGHIACG
    HJAKBKCKABCLM $.

  $( An element of a finite set of sequential integers is an element of a
     finite set of sequential integers with the upper bound being an element of
     the finite set of sequential integers with the same lower bound as for the
     first interval and the element under consideration as upper bound.
     (Contributed by Alexander van der Vekens, 3-Apr-2018.) $)
  elfzelfzelfz $p |- ( ( K e. ( 0 ... N ) /\ L e. ( K ... N ) )
                       -> K e. ( 0 ... L ) ) $=
    ( cc0 cfz co wa cn0 cle wbr w3a wi elfz2nn0 cz elfz2 elnn0z sylbi com12 imp
    wcel simpr1 simpr zletr mp3an1 simplbi2 sylsyld exp3a impancom com13 adantr
    0z 3ad2ant3 3ad2ant1 impcom simplrl 3jca ex sylibr ) ADCEFTZBACEFTZGAHTZBHT
    ZABIJZKZADBEFTUSUTVDUSVACHTZACIJZKZUTVDLACMUTVGVDUTANTZCNTZBNTZKZVCBCIJZGZG
    ZVGVDLBACOVNVGVDVNVGGVAVBVCVNVAVEVFUAVGVNVBVAVEVNVBLVFVNVAVBVKVMVAVBLZVJVHV
    MVOLVIVMVJVOVCVJVOLVLVAVJVCVBVAVHDAIJZGVJVCVBLZLAPVHVJVPVQVHVJGZVPVCVBVRVJV
    PVCGZDBIJZVBVHVJUBDNTVHVJVSVTLUKDABUCUDVBVJVTBPUEUFUGUHQUIUJRULSRUMUNVKVCVL
    VGUOUPUQQRQSABMUR $.

  $( An element of a finite set of sequential integers is an element of an
     extended finite set of sequential integers.  (Contributed by Alexander van
     der Vekens, 28-Mar-2018.) $)
  elfzelfzadd $p |- ( ( A e. NN0 /\ B e. NN0 )
                      -> ( N e. ( 0 ... A ) -> N e. ( 0 ... ( A + B ) ) ) ) $=
    ( cn0 wcel wa cc0 cfz co caddc cuz cfv wss cz cle wbr nn0z adantr cr nn0re
    nn0addcl nn0zd nn0ge0 adantl addge01 syl2an mpbid eluz2 syl3anbrc fzss2 syl
    wb sseld ) ADEZBDEZFZGAHIZGABJIZHIZCUPURAKLEZUQUSMUPANEZURNEAUROPZUTUNVAUOA
    QRUPURABUAUBUPGBOPZVBUOVCUNBUCUDUNASEBSEVCVBULUOATBTABUEUFUGAURUHUIAGURUJUK
    UM $.

  $( 0 is an element of a finite set of sequential integers from 0 to a
     nonnegative integer.  (Contributed by Alexander van der Vekens,
     6-Apr-2018.) $)
  0elfz $p |- ( N e. NN0 -> 0 e. ( 0 ... N ) ) $=
    ( cn0 wcel cc0 cle wbr cfz co 0nn0 a1i id nn0ge0 elfz2nn0 syl3anbrc ) ABCZD
    BCZODAEFDDAGHCPOIJOKALDAMN $.

  $( If there are two elements in a finite set of sequential integers from 0,
     these two elements as well as the upper bound are nonnegative integers.
     (Contributed by Alexander van der Vekens, 7-Apr-2018.) $)
  2elfz3nn0 $p |- ( ( A e. ( 0 ... N ) /\ B e. ( 0 ... N ) )
                    -> ( A e. NN0 /\ B e. NN0 /\ N e. NN0 ) ) $=
    ( cc0 cfz co wcel cn0 w3a elfznn0 cle wbr wi elfz2nn0 wa 3anass simplbi2com
    3adant3 sylbi mpan9 ) ADCEFZGAHGZBUAGZUBBHGZCHGZIZACJUCUDUEBCKLZIUBUFMZBCNU
    DUEUHUGUFUBUDUEOUBUDUEPQRST $.

  $( The addition of two members of a finite set of sequential integers
     starting at 0 is commutative.  (Contributed by Alexander van der Vekens,
     22-May-2018.)  (Revised by Alexander van der Vekens, 9-Jun-2018.) $)
  fz0addcom $p |- ( ( A e. ( 0 ... N ) /\ B e. ( 0 ... N ) )
                    -> ( A + B ) = ( B + A ) ) $=
    ( cc0 cfz co wcel cc caddc wceq elfznn0 nn0cnd addcom syl2an ) ADCEFZGZAHGB
    HGABIFBAIFJBOGZPAACKLQBBCKLABMN $.

  $( A member of a finite set of sequential integers starting at 0 is a member
     of a finite set of sequential integers from 0 to a member of a finite set
     of sequential integers starting at the right border of the first finite
     set of sequential integers.  (Contributed by Alexander van der Vekens,
     27-May-2018.) $)
  elfz0fzfz0 $p |- ( ( M e. ( 0 ... L ) /\ N e. ( L ... X ) )
                     -> M e. ( 0 ... N ) ) $=
    ( cc0 cfz co wcel wa cn0 cle wbr w3a wi elfz2nn0 cz cr adantr imp sylbi zre
    elfz2 nn0re 3anim123i 3expa syl simplll simpr elnn0z 0re a1i adantl syl3anc
    letr exp4b com23 sylanbrc 3jca ex syld 3impia com13 com12 3ad2ant3 sylibr )
    BEAFGHZCADFGHZIBJHZCJHZBCKLZMZBECFGHVFVGVKVFVHAJHZBAKLZMZVGVKNBAOVGVNVKVGAP
    HZDPHZCPHZMZACKLZCDKLZIZIVNVKNZCADUBVRWAWBVQVOWAWBNVPWAVQWBVSVQWBNVTVNVQVSV
    KVHVLVMVQVSVKNZNVHVLIZVQVMWCWDVQVMVSVKWDVQIZVMVSIZVJVKWEBQHZAQHZCQHZMZWFVJN
    VHVLVQWJVHWGVLWHVQWIBUCAUCCUAZUDUEBACUNUFWEVJVKWEVJIZVHVIVJVHVLVQVJUGWLVQEC
    KLZVIWEVQVJWDVQUHRWEVJWMWDVQVJWMNZVHVQWNNZVLVHBPHZEBKLZIWOBUIWPWQWOWPVQWQWN
    WPVQWQVJWMWPVQIZEQHZWGWIWQVJIWMNWSWRUJUKWPWGVQBUARVQWIWPWKULEBCUNUMUOUPSTRS
    SCUIUQWEVJUHURUSUTUOUPVAVBRVCVDSTVCTSBCOVE $.

  $( Subtracting the difference of a member of a finite range of integers and
     the lower bound of the range from the difference of the upper bound and
     the lower bound of the range equals the difference of the upper bound of
     the range and the member.  (Contributed by Alexander van der Vekens,
     27-May-2018.) $)
  fzmmmeqm $p |- ( M e. ( L ... N )
                   -> ( ( N - L ) - ( M - L ) ) = ( N - M ) ) $=
    ( cfz co wcel cc w3a cmin wceq cz cle wa elfz2 3anim123i 3comr adantr sylbi
    wbr zcn nnncan2 syl ) BACDEFZCGFZBGFZAGFZHZCAIEBAIEIECBIEJUCAKFZCKFZBKFZHZA
    BLSBCLSMZMUGBACNUKUGULUIUJUHUGUIUDUJUEUHUFCTBTATOPQRCBAUAUB $.

  $( If there is a member in a finite set of sequential integers, the upper
     bound is also a member of this finite set of sequential integers.
     (Contributed by Alexander van der Vekens, 31-May-2018.) $)
  elfzubelfz $p |- ( K e. ( M ... N ) -> N e. ( M ... N ) ) $=
    ( cfz co wcel cuz cfv elfzuz2 eluzfz2 syl ) ABCDEZFCBGHFCLFABCIBCJK $.

  $( If the sum of two integers of a finite set of sequential nonnegative
     integers is greater than the upper bound, the difference between one of
     the integers and the difference between the upper bound and the other
     integer is in the finite set of sequential nonnegative integers right
     bounded by the first integer.  (Contributed by Alexander van der Vekens,
     7-Apr-2018.)  (Revised by Alexander van der Vekens, 31-May-2018.) $)
  2elfz2melfz $p |- ( ( A e. ( 0 ... N ) /\ B e. ( 0 ... N ) )
                  -> ( N < ( A + B ) -> ( B - ( N - A ) ) e. ( 0 ... A ) ) ) $=
    ( cc0 co wcel wa caddc wbr cmin cle cz wi adantr cr zre ad2antrr adantl imp
    zred cfz clt elfzelz elfzel2 simplr zsubcl adantlr zsubcld zaddcl expcom id
    cn0 ltsub1d anim12i resubcld readdcl simpll jca ltle 3syl zcn subidd cc w3a
    wceq simp3 simp1 addcomd oveq1d subsub3 eqtr4d syl3anc sylibd sylbid elnn0z
    breq12d sylanbrc exp31 syl2anc mpan9 elfznn0 zcnd npcan breqtrrd lesubadd2d
    elfzle2 syl mpbird elfz2nn0 syl3anbrc ex ) ADCUAEZFZBWLFZGZCABHEZUBIZBCAJEZ
    JEZDAUAEFZWOWQGWSULFZAULFZWSAKIZWTWOWQXAWMALFZWNWQXAMZADCUCZWNCLFZBLFZXDXEM
    BDCUDBDCUCZXGXHGZXDWQXAXJXDGZWQGWSLFZDWSKIZXAXKXLWQXKBWRXGXHXDUEXGXDWRLFXHC
    AUFUGUHNXKWQXMXKWQCCJEZWPCJEZUBIZXMXKCWPCXGCOFZXHXDCPZQZXJXDWPOFZXHXDXTMXGX
    DXHXTXDXHGWPABUITUJRSXSUMXKXPXNXOKIZXMXKXQBOFZGZAOFZGZXNOFZXOOFZGXPYAMXJYCX
    DYDXGXQXHYBXRBPUNAPUNYEYFYGXQYFYBYDXQCCXQUKZYHUOQYEWPCYCYDXTYBYDXTMXQYDYBXT
    ABUPUJRSXQYBYDUQUOURXNXOUSUTXKXNDXOWSKXGXNDVEXHXDXGCCVAZVBQXKBVCFZCVCFZAVCF
    ZXOWSVEXJYJXDXHYJXGBVARNXGYKXHXDYIQXDYLXJAVARYJYKYLVDZXOBAHEZCJEWSYMWPYNCJY
    MABYJYKYLVFYJYKYLVGVHVIBCAVJVKVLVPVMVNSWSVOVQVRVSVTSWMXBWNWQACWAQWOXCWQWOXC
    BWRAHEZKIWOBCYOKWNBCKIWMBDCWFRWOYKYLGZYOCVEWMYPWNWMYKYLWMCADCUDZWBWMAXFWBUR
    NCAWCWGWDWOBWRAWNYBWMWNBXITRWMWROFWNWMCAWMCYQTWMAXFTZUONWMYDWNYRNWEWHNWSAWI
    WJWK $.

  $( If a member of a finite set of sequential integers with a lower bound
     being a member of a zero based finite set of sequential integers with the
     same uppoer bound, this member is also a member of the zero based finite
     set of sequential integers.  (Contributed by Alexander van der Vekens,
     21-Apr-2018.) $)
  fz0fzelfz0 $p |- ( ( N e. ( 0 ... R ) /\ M e. ( N ... R ) )
                     -> M e. ( 0 ... R ) ) $=
    ( cc0 cfz co wcel wa cn0 cle wbr w3a wi elfz2nn0 cz adantr 3jca imp sylbi
    cr elfz2 simplr 0re a1i nn0re zre adantl nn0ge0 anim1i letr elnn0z sylanbrc
    exp31 com23 3ad2ant1 com13 adantrd 3ad2ant3 simpr2 simplrr ex com12 sylibr
    sylc ) CDAEFZGZBCAEFGZHBIGZAIGZBAJKZLZBVEGVFVGVKVFCIGZVICAJKZLZVGVKMCANVGVN
    VKVGCOGZAOGZBOGZLZCBJKZVJHZHZVNVKMBCAUAWAVNVKWAVNHVHVIVJWAVNVHVRVTVNVHMZVQV
    OVTWBMVPVQVSWBVJVNVSVQVHVLVIVSVQVHMMVMVLVQVSVHVLVQVSVHVLVQHZVSHZVQDBJKZVHVL
    VQVSUBWDDTGZCTGZBTGZLZDCJKZVSHWEWCWIVSWCWFWGWHWFWCUCUDVLWGVQCUEPVQWHVLBUFUG
    QPWCWJVSVLWJVQCUHPUIDCBUJVDBUKULUMUNUOUPUQURRRWAVLVIVMUSVRVSVJVNUTQVASVBSRB
    ANVC $.

  $( The difference of a nonnegative integer in a finite set of sequential
     integers and a member of a finite set of sequential integers with the same
     upper bound and the nonnegative integer as lower bound is a member of the
     finite set of sequential integers.  (Contributed by Alexander van der
     Vekens, 6-Jun-2018.) $)
  fz0fzdiffz0 $p |- ( ( M e. ( 0 ... N ) /\ K e. ( M ... N ) )
                      -> ( K - M ) e. ( 0 ... N ) ) $=
    ( cc0 cfz co wcel wa cn0 cle wbr w3a adantl wb elfznn0 adantr mpbid wi cz
    cr cmin fz0fzelfz0 elfzle1 nn0sub syl2anr elfz3nn0 elfz2 zsubcl zred ancoms
    elfz2nn0 3adant2 zre 3ad2ant3 3ad2ant2 3jca nn0ge0 nn0re syl2an anim1i letr
    subge02 sylc exp31 a1i com14 impcom sylbi com13 3adant3 imp mpancom sylibr
    ) BDCEFZGZABCEFGZHZABUAFZIGZCIGZVRCJKZLZVRVNGAVNGZVQWBCABUBWCVQHZVSVTWAWDBA
    JKZVSVQWEWCVPWEVOABCUCMMVQBIGZAIGWEVSNWCVOWFVPBCOPACOBAUDUEQWCVTVQACUFPVQWA
    WCVOVPWAVOWFVTBCJKZLVPWARZBCUKWFVTWHWGVTWFWHVPWFVTWAVPBSGZCSGZASGZLZWEACJKZ
    HZHWFVTWARRZABCUGWNWLWOWMWLWORWEVTWLWFWMWAWLWFWMWARRRVTWLWFWMWAWLWFHZWMHVRT
    GZATGZCTGZLZVRAJKZWMHWAWPWTWMWLWTWFWLWQWRWSWIWKWQWJWKWIWQWKWIHVRABUHUIUJULW
    KWIWRWJAUMUNZWJWIWSWKCUMUOUPPPWPXAWMWPDBJKZXAWFXCWLBUQMWLWRBTGXCXANWFXBBURA
    BVBUSQUTVRACVAVCVDVEVFMVGVHVIVGVJVHVKMUPVLVRCUKVM $.

  $( The sum of two integers in zero based finite sets of sequential integers
     is greater than or equal to zero.  (Contributed by Alexander van der
     Vekens, 8-Jun-2018.) $)
  fz0addge0 $p |- ( ( A e. ( 0 ... M ) /\ B e. ( 0 ... N ) )
                    -> 0 <_ ( A + B ) ) $=
    ( cc0 cfz co wcel wa cn0 cr cle wbr caddc elfznn0 anim12i nn0ge0 jca addge0
    nn0re 3syl ) AECFGHZBEDFGHZIAJHZBJHZIZAKHZBKHZIZEALMZEBLMZIZIEABNGLMUBUDUCU
    EACOBDOPUFUIULUDUGUEUHATBTPUDUJUEUKAQBQPRABSUA $.

  ${
    $d F i $.  $d M i $.  $d P i $.
    $( Two functions over a zero-based finite interval of integers are equal if
       and only if their domains have the same length and the function values
       are the same at each position.  (Contributed by Alexander van der
       Vekens, 30-Jun-2018.) $)
    2ffzeq $p |- ( ( M e. NN0 /\ F : ( 0 ... M ) --> X
                              /\ P : ( 0 ... N ) --> Y ) -> ( F = P
              <-> ( M = N /\ A. i e. ( 0 ... M ) ( F ` i ) = ( P ` i ) ) ) ) $=
      ( cn0 wcel cc0 cfz co wf w3a wceq cfv wa wfn wb ffn cv anim12i syl fzopth
      wral 3adant1 eqfnfv2 cuz elnn0uz sylbi simpr syl6bi anim1d anim1i impbid1
      oveq2 3ad2ant1 bitrd ) DHIZJDKLZFCMZJEKLZGAMZNZCAOZUTVBOZBUAZCPVGAPOBUTUE
      ZQZDEOZVHQZVDCUTRZAVBRZQZVEVISVAVCVNUSVAVLVCVMUTFCTVBGATUBUFBUTVBCAUGUCUS
      VAVIVKSVCUSVIVKUSVFVJVHUSVFJJOZVJQZVJUSDJUHPIVFVPSDUIJEJDUDUJVOVJUKULUMVJ
      VFVHDEJKUPUNUOUQUR $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Half-open integer ranges - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( A member of a half-open integer range starting at 0 is a nonnegative
     integer.  (Contributed by Alexander van der Vekens, 21-May-2018.) $)
  elfzonn0 $p |- ( K e. ( 0 ..^ N ) -> K e. NN0 ) $=
    ( cc0 cfzo co wcel cuz cfv cn0 elfzouz elnn0uz sylibr ) ACBDEFACGHFAIFACBJA
    KL $.

  $( Subset relationship for half-open sequences of integers with lower bounds
     0 and 1.  (Contributed by Alexander van der Vekens, 18-Mar-2018.) $)
  fzo0ss1 $p |- ( 1 ..^ N ) C_ ( 0 ..^ N ) $=
    ( c1 cc0 cuz cfv wcel cfzo co wss cn0 1nn0 elnn0uz mpbi fzoss1 ax-mp ) BCDE
    FZBAGHCAGHIBJFPKBLMBCANO $.

  $( A half open integer range starting from a nonnegative integer is a subset
     of the nonnegative integers.  (Contributed by Alexander van der Vekens,
     13-May-2018.) $)
  fzossnn0 $p |- ( M e. NN0 -> ( M ..^ N ) C_ NN0 ) $=
    ( cn0 wcel cfzo co cc0 cfz fzossfz wss cuz fzss1 nn0uz eleq2s syl5ss fzssuz
    cfv sseqtr4i syl6ss ) ACDZABEFZGBHFZCTUAABHFZUBABIUCUBJAGKQZCAGBLMNOUBUDCGB
    PMRS $.

  $( A half open integer range starting from 0 is the union of the singleton
     set containing 0 and a half open integer range starting from 1.
     (Contributed by Alexander van der Vekens, 18-May-2018.) $)
  fzo0sn0fzo1 $p |- ( N e. NN -> ( 0 ..^ N ) = ( { 0 } u. ( 1 ..^ N ) ) ) $=
    ( cn wcel cc0 cfzo co c1 cun csn cfz wceq cn0 cle 1nn0 nnnn0 nnge1 elfz2nn0
    wbr a1i syl3anbrc fzosplit syl fzo01 uneq1d eqtrd ) ABCZDAEFZDGEFZGAEFZHZDI
    ZUIHUFGDAJFCZUGUJKUFGLCZALCGAMRULUMUFNSAOAPGAQTDAGUAUBUFUHUKUIUHUKKUFUCSUDU
    E $.

  $( If an integer between 0 and an upper bound of a half open interval of
     integers is subtracted from this upper bound, the result is contained in
     this half open interval.  (Contributed by Alexander van der Vekens,
     18-Mar-2018.) $)
  ubmelfzo $p |- ( K e. ( 1 ..^ N ) -> ( N - K ) e. ( 0 ..^ N ) ) $=
    ( cfzo co wcel cn clt wbr w3a cc0 wa wi cz caddc cuz cfv adantr syl2an wb
    ex c1 cmin elfzo1 cn0 elnnnn0b nn0z nnz cle simpr cr zre com12 impcom eluz1
    ad2antrr mpbir2and zcn addid1d fveq2d eleq2d mpbird zaddcl ltaddpos2 adantl
    ltle biimpcd elfzo2 syl3anbrc simpl 0z a1i 3jca fzosubel2 syl2anc com13 imp
    com14 sylbi 3imp ) AUABCDEAFEZBFEZABGHZIBAUBDJBCDEZBAUCVTWAWBWCVTAUDEZJAGHZ
    KWAWBWCLLZAUEWDWEWFWBWEWAWDWCWBWEWAWDWCLLWDWAWBWEKZWCWDWAWGWCLZWDAMEZBMEZWH
    WAAUFBUGWIWJKZWGWCWKWGKZBAJNDZABNDZCDEZWIJMEZWJIZWCWLBWMOPZEZWNMEZBWNGHZWOW
    LWSBAOPZEZWLXCWJABUHHZWKWJWGWIWJUIZQWGWKXDWBWKXDLWEWKWBXDWIAUJEZBUJEZWBXDLW
    JAUKZBUKZABVERULQUMWIXCWJXDKSWJWGABUNUOUPWIWSXCSWJWGWIWRXBBWIWMAOWIAAUQURUS
    UTUOVAWKWTWGABVBQWGWKXAWEWKXALWBWKWEXAWIXFXGWEXASWJXHXIABVCRVFVDUMBWMWNVGVH
    WKWQWGWKWIWPWJWIWJVIWPWKVJVKXEVLQBAJBVMVNTRTVOTVQVPVRVSVR $.

  $( If an integer between 0 and an upper bound of a half open interval of
     integers minus 1 is subtracted from this upper bound, the result is
     contained in this half open interval.  (Contributed by Alexander van der
     Vekens, 23-Mar-2018.) $)
  ubmelm1fzo $p |- ( K e. ( 1 ..^ N ) -> ( ( N - K ) - 1 ) e. ( 0 ..^ N ) ) $=
    ( c1 cfzo co clt wbr cc0 wa wi cz caddc cuz cle adantr ax-1cn a1i cr adantl
    wcel cn w3a cmin elfzo1 cn0 elnnnn0b nn0z nnz cfv zsubcl ancoms zltp1le zcn
    wceq cc addcomd breq1d bitrd biimpd com12 impcom 1re leaddsub syl3anc mpbid
    wb zre 1z eluz1i sylanbrc addid1i fveq2i syl6eleqr zaddcld ltsubpos resubcl
    syl2an syl2anr ltle syl2anc zleltp1 sylancom breq2d sylbid elfzo2 syl3anbrc
    id syld 0z simpr 3jca fzosubel2 ex com13 com14 imp sylbi 3imp ) ACBDETAUATZ
    BUATZABFGZUBBAUCEZCUCEHBDETZBAUDWSWTXAXCWSAUETZHAFGZIWTXAXCJJZAUFXDXEXFXAXE
    WTXDXCXAXEWTXDXCJJXDWTXAXEIZXCXDWTXGXCJZXDAKTZBKTZXHWTAUGBUHXIXJIZXGXCXKXGI
    ZXBCHLEZCBLEZDETZCKTZHKTZXJUBZXCXLXBXMMUIZTXNKTZXBXNFGZXOXLXBCMUIZXSXLXBKTZ
    CXBNGZXBYBTXKYCXGXJXIYCBAUJUKZOXLCALEZBNGZYDXGXKYGXAXKYGJXEXKXAYGXKXAYGXKXA
    ACLEZBNGYGABULXKYHYFBNXIYHYFUNXJXIACAUMCUOTZXIPQUPOUQURUSUTOVAXKYGYDVFZXGXK
    CRTZARTZBRTZYJYKXKVBQXIYLXJAVGZOXJYMXIBVGZSZCABVCVDOVECXBVHVIVJXMCMCPVKVLVM
    XKXTXGXJXTXIXJCBXPXJVHQXJWGVNSOXGXKYAXEXKYAJXAXKXEYAXKXEXBBFGZYAXIYLYMXEYQV
    FXJYNYOABVOVQXKYQXBBNGZYAXKXBRTZYMYQYRJXJYMYLYSXIYOYNBAVPVRYPXBBVSVTXKYRXBB
    CLEZFGZYAXIXJYCYRUUAVFYEXBBWAWBXKUUAYAXKYTXNXBFXJYTXNUNXIXJBCBUMYIXJPQUPSWC
    USWDWHWDUTSVAXBXMXNWEWFXKXRXGXKXPXQXJXPXKVHQXQXKWIQXIXJWJWKOXBCHBWLVTWMVQWM
    WNWMWOWPWQWRWQ $.

  $( An integer between 1 and an upper bound of a half open interval of
     integers is not 0 and between 0 and the upper bound of a half open
     interval of integers.  (Contributed by Alexander van der Vekens,
     21-Mar-2018.) $)
  fzo1fzo0n0 $p |- ( K e. ( 1 ..^ N ) <-> ( K e. ( 0 ..^ N ) /\ K =/= 0 ) ) $=
    ( c1 cfzo co wcel cc0 wa cz clt wbr w3a cn wi adantr a1i adantl imp sylbir
    cr wne cuz cfv elfzo2 cn0 elnnuz nnnn0 nngt0 0re nnre lttr syl3anc simplbi2
    zre elnnz syld exp4b com13 mpcom simpr 3jca ex elfzo0 sylibr nnne0 3ad2ant1
    3imp jca sylbi cle elnnne0 nnge1 3ad2antl1 simpl3 wb nn0z nnz 3adant3 elfzo
    1z syl mpbir2and sylanb impbii ) ACBDEFZAGBDEFZAGUAZHZWEACUBUCFZBIFZABJKZLZ
    WHACBUDWLWFWGWLAUEFZBMFZWKLZWFWIWJWKWOWIAMFZWJWKWONZNAUFZWPWJWQWPWJHZWKWOWS
    WKHWMWNWKWSWMWKWPWMWJAUGOOWSWKWNWPWJWKWNNZGAJKZWPWJWTNAUHWJWPXAWTWJWPXAWKWN
    WJWPHZXAWKHZGBJKZWNXBGTFZATFZBTFZXCXDNXEXBUIPWPXFWJAUJQWJXGWPBUNOGABUKULWJX
    DWNNWPWNWJXDBUOUMOUPUQURUSRRWSWKUTVAVBVBSVGABVCZVDWIWJWGWKWIWPWGWRAVESVFVHV
    IWFWOWGWEXHWOWGHZWECAVJKZWKWMWNWGXJWKWMWGHWPXJAVKAVLSVMWMWNWKWGVNXIAIFZCIFZ
    WJLZWEXJWKHVOWOXMWGWMWNXMWKWMWNHZXKXLWJWMXKWNAVPOXLXNVTPWNWJWMBVQQVAVROACBV
    SWAWBWCWD $.

  $( An integer increased by another interger is an element of a half-open
     range of integers if and only if the integer is contained in the half-open
     range of integers with bounds decreased by the other integer.
     (Contributed by Alexander van der Vekens, 30-Mar-2018.) $)
  elfzomelpfzo $p |- ( ( ( M e. ZZ /\ N e. ZZ ) /\ ( K e. ZZ /\ L e. ZZ ) )
      -> ( K e. ( ( M - L ) ..^ ( N - L ) ) <-> ( K + L ) e. ( M ..^ N ) ) ) $=
    ( cz wcel wa cmin co cuz cfv clt wbr w3a cfzo adantr 2thd adantl cr zre cle
    caddc zsubcl ad2ant2rl simpl zaddcl lesubaddd 3anbi123d eluz2 3bitr4g simpr
    ad2ant2l ltaddsubd bicomd elfzo2 ) CEFZDEFZGZAEFZBEFZGZGZACBHIZJKFZDBHIZEFZ
    AVELMZNABUBIZCJKFZUQVHDLMZNAVCVEOIFVHCDOIFVBVDVIVFUQVGVJVBVCEFZUSVCAUAMZNUP
    VHEFZCVHUAMZNVDVIVBVKUPUSVMVLVNVBVKUPUPUTVKUQUSCBUCUDURUPVAUPUQUEPQVBUSVMVA
    USURUSUTUERVAVMURABUFRQVBCBAURCSFZVAUPVOUQCTPPVABSFZURUTVPUSBTRRZVAASFZURUS
    VRUTATPRZUGUHVCAUICVHUIUJVBVFUQUQUTVFUPUSDBUCULURUQVAUPUQUKPQVBVJVGVBABDVSV
    QURDSFZVAUQVTUPDTRPUMUNUHAVCVEUOVHCDUOUJ $.

  $( Subset relationship for half-open integer ranges.  (Contributed by
     Alexander van der Vekens, 16-Mar-2018.) $)
  ssfzo12 $p |- ( ( K e. ZZ /\ L e. ZZ /\ K < L )
                 -> ( ( K ..^ L ) C_ ( M ..^ N ) -> ( M <_ K /\ L <_ N ) ) ) $=
    ( cfzo co wcel cz clt wbr w3a wss cle wa wi fzolb2 biimp3ar ssel2 ex mpcom
    c1 cmin fzoend elfzolt2 wb simp2 elfzoel2 zlem1lt elfzole1 pm3.2 syl adantr
    syl2anr sylbird com13 3syl com24 syl5com pm2.43a com14 ) AABEFZGZAHGZBHGZAB
    IJZKZVACDEFZLZCAMJZBDMJZNZOZVCVDVBVEABPQBUAUBFZVAGZVBVFVLOABUCVHVBVFVNVKVBV
    HVFVNVKOOZVHVBVHVOOVHVBNAVGGZVHVOVAVGARVHVNVFVPVKVHVNVFVPVKOOZVHVNNVMVGGVMD
    IJZVQVAVGVMRVMCDUDVPVFVRVKVPVFVRVKOVPVFNVRVJVKVFVDDHGVJVRUEVPVCVDVEUFACDUGB
    DUHUMVPVJVKOZVFVPVIVSACDUIVIVJUJUKULUNSUOUPSUQURSUSUTTT $.

  $( Removing a singleton from a half-open range at the end.  (Contributed by
     Alexander van der Vekens, 23-Mar-2018.) $)
  fzosplitsnm1 $p |- ( ( A e. ZZ /\ B e. ( ZZ>= ` ( A + 1 ) ) ) ->
      ( A ..^ B ) = ( ( A ..^ ( B - 1 ) ) u. { ( B - 1 ) } ) ) $=
    ( cz wcel c1 caddc co cuz cfv wa cfzo cmin cun csn wceq eluzelz zcnd adantl
    cc syl ax-1cn npcan eqcomd sylancl cfz eluzp1m1 peano2zm uzid peano2uz 4syl
    oveq2d elfzuzb sylanbrc fzosplit fzosn uneq2d 3eqtrd ) ACDZBAEFGZHIDZJZABKG
    ABELGZEFGZKGZAVBKGZVBVCKGZMZVEVBNZMVABVCAKVABSDZESDZBVCOUTVIURUTBUSBPZQRUAV
    IVJJVCBBEUBUCUDUKVAVBAVCUEGDZVDVGOVAVBAHIDVCVBHIZDZVLABUFVABCDZVBCDZVBVMDVN
    UTVOURVKRBUGZVBUHVBVBUIUJVBAVCULUMAVCVBUNTVAVFVHVEVAVPVFVHOUTVPURUTVOVPVKVQ
    TRVBUOTUPUQ $.

  $( If an element of a half-open range of integers is not contained in the
     lower subrange, it must be in the upper subrange.  (Contributed by
     Alexander van der Vekens, 30-Mar-2018.) $)
  elfzonelfzo $p |- ( N e. ZZ -> ( ( K e. ( M ..^ R ) /\ -. K e. ( M ..^ N ) )
                                   -> K e. ( N ..^ R ) ) ) $=
    ( cfzo co wcel wn wa cz cuz cfv clt wbr w3a wi elfzo2 3ad2ant1 cr ex cle wb
    simpr eluzelz ad2antrr eluzelre zre ltnle syl2an 3expa sylibr sylbird con1d
    id com23 imp31 eluz2 syl3anbrc simpll2 simpll3 sylanb com12 ) BCAEFGZBCDEFG
    ZHZIDJGZBDAEFGZVCBCKLGZAJGZBAMNZOZVEVFVGPBCAQVKVEIZVFVGVLVFIZBDKLGZVIVJVGVM
    VFBJGZDBUANZVNVLVFUCVKVOVEVFVHVIVOVJCBUDRUEVKVEVFVPVHVIVEVFVPPPVJVHVFVEVPVH
    VFVEVPPVHVFIZVPVDVQVPHZBDMNZVDVHBSGDSGVSVRUBVFCBUFDUGBDUHUIVQVSVDVQVSIVHVFV
    SOZVDVHVFVSVTVTUNUJBCDQUKTULUMTUORUPDBUQURVHVIVJVEVFUSVHVIVJVEVFUTBDAQURTVA
    VB $.

  $( The value of the size function on a finite 0-based sequence.  (Contributed
     by Alexander van der Vekens, 25-Mar-2018.) $)
  fseq0hash $p |- ( ( N e. NN0 /\ F Fn ( 0 ..^ N ) ) -> ( # ` F ) = N ) $=
    ( cc0 cfzo co wfn cn0 wcel chash cfv hashfn hashfzo0 sylan9eqr ) ACBDEZFBGH
    AIJNIJBNAKBLM $.

  $( The result of subtracting a nonnegative integer from a positive integer
     and adding another nonnegative integer which is less than the first one,
     is less then the positive integer.  (Contributed by Alexander van der
     Vekens, 19-May-2018.) $)
  fzonmapblen $p |- ( ( A e. ( 0 ..^ N ) /\ B e. ( 0 ..^ N ) /\ B < A )
                      -> ( B + ( N - A ) ) < N ) $=
    ( cc0 cfzo co wcel clt wbr cmin caddc cr wa wi cn0 cn anim12i adantr recn
    cc w3a elfzo0 nn0re nnre 3adant3 sylbi elfzoelz simpr simpll resubcl ancoms
    zred ltadd1d biimpa wceq pncan3 syl breqtrd ex syl2an 3impia ) ADCEFZGZBVBG
    ZBAHIZBCAJFZKFZCHIZVCALGZCLGZMZBLGZVEVHNVDVCAOGZCPGZACHIZUAVKACUBVMVNVKVOVM
    VIVNVJAUCCUDQUEUFVDBBDCUGULVKVLMZVEVHVPVEMZVGAVFKFZCHVPVEVGVRHIVPBAVFVKVLUH
    VIVJVLUIVKVFLGZVLVJVIVSCAUJUKRUMUNVQATGZCTGZMZVRCUOVPWBVEVKWBVLVIVTVJWAASCS
    QRRACUPUQURUSUTVA $.

  $( Subtracting a difference from a number which is not less than the
     difference results in a bounded nonnegative integer.  (Contributed by
     Alexander van der Vekens, 21-May-2018.) $)
  subsubelfzo0 $p |- ( ( A e. ( 0 ..^ N ) /\ I e. ( 0 ..^ N )
                 /\ -. I < ( N - A ) ) -> ( I - ( N - A ) ) e. ( 0 ..^ A ) ) $=
    ( cc0 co wcel cmin clt wbr w3a cz cn0 wi wa cle cr wb adantr syl2anr adantl
    cfzo wn cuz cfv cn elfzo0 nnre 3ad2ant2 nn0re resubcl 3ad2ant1 lenlt bicomd
    syl2anc biimpd imp nnz nn0z zsubcl syl2an impancom subge0 mpbird jca elnn0z
    ltle sylibr simplr1 nn0sub mpbid elnn0uz sylib ltsub1d cc wceq nn0cn breq2d
    nncn nncan sylbid com3l 3impia impcom 3jca syl5bi 3adant2 sylbi 3imp elfzo2
    ex ) ADCUAEZFZBWKFZBCAGEZHIUBZJBWNGEZDUCUDFZAKFZWPAHIZJZWPDAUAEFWLWMWOWTWLA
    LFZCUEFZACHIZJWMWOWTMZMZACUFXAXCXEXBWMBLFZXBBCHIZJZXAXCNZXDBCUFXIXHXDXIXHNZ
    WOWTXJWONZWQWRWSXKWPLFZWQXKWNBOIZXLXJWOXMXJWOXMXJWNPFZBPFZWOXMQXHCPFZAPFZXN
    XIXBXFXPXGCUGZUHZXAXQXCAUIZRZCAUJZSXHXOXIXFXBXOXGBUIZUKTXNXONXMWOWNBULUMUNU
    OUPXKWNLFZXFXMXLQXJYDWOXJWNKFZDWNOIZNYDXJYEYFXHCKFZWRYEXIXBXFYGXGCUQUHXAWRX
    CAURRZCAUSSXJYFACOIZXIXHYIXAXHXCYIXAXQXPXCYIMXHXTXSACVFUTVAUPXHXPXQYFYIQXIX
    SYACAVBSVCVDWNVEVGRXFXBXGXIWOVHWNBVIUNVJWPVKVLXJWRWOXIWRXHYHRRXJWSWOXHXIWSX
    FXBXGXIWSMXIXFXBNZXGWSXAYJXGWSMZMXCXAYJYKXAYJNZXGWPCWNGEZHIZWSYLBCWNYJXOXAX
    FXOXBYCRTYJXPXAXBXPXFXRTZTYJXPXQXNXAYOXTYBSVMYLYNWSYLYMAWPHYJCVNFZAVNFYMAVO
    XAXBYPXFCVRTAVPCAVSSVQUOVTWJRWAWBWCRWDWJWJWEWFWGWHWPDAWIVG $.

  $( If a non-negative integer in a finite interval of integers is not the
     upper bound of the interval, it is contained in the corresponding
     half-open range of integers.  (Contributed by Alexander van der Vekens,
     15-Jun-2018.) $)
  fzofzim $p |- ( ( K =/= M /\ K e. ( 0 ... M ) ) -> K e. ( 0 ..^ M ) ) $=
    ( wne cc0 co wcel wa cn0 clt wbr w3a cle wi cr nn0re adantl exp3a sylbi imp
    cz cfz cn cfzo elfz2nn0 simpl1 necom ltlen syl2an bicomd elnn0z 0re a1i zre
    adantr lelttr syl3anc nn0z elnnz simplbi2 syl impancom sylbid syl7bi 3impia
    wb syld biimpd exp4b 3imp syl5bi 3jca ex impcom elfzo0 sylibr ) ABCZADBUAEF
    ZGAHFZBUBFZABIJZKZADBUCEFVQVPWAVQVRBHFZABLJZKZVPWAMABUDWDVPWAWDVPGVRVSVTVRW
    BWCVPUEWDVPVSVRWBWCVPVSMVPBACZVRWBGZWCVSABUFZWFWCWEVSWFWCWEGZVTVSWFVTWHVRAN
    FZBNFZVTWHVEWBAOBOZABUGUHUIZVRWBVTVSMZVRATFZDALJZGWBWMMAUJWNWBWOWMWNWBGZWOV
    TVSWPWOVTGZDBIJZVSWPDNFZWIWJWQWRMWSWPUKULWNWIWBAUMUNWBWJWNWKPDABUOUPWBWRVSM
    ZWNWBBTFZWTBUQVSXAWRBURUSUTPVFQVARSVBQVCVDSWDVPVTVPWEWDVTWGVRWBWCWEVTMVRWBW
    CWEVTWFWHVTWLVGVHVIVJSVKVLRVMABVNVO $.

  $( A finite interval of integers as union of a half-open range of integers
     and a singleton.  (Contributed by Alexander van der Vekens,
     15-Jun-2018.) $)
  fzisfzounsn $p |- ( B e. ( ZZ>= ` A )
                      -> ( A ... B ) = ( ( A ..^ B ) u. { B } ) ) $=
    ( cuz cfv wcel cfz co caddc cfzo csn cun wceq eluzelz fzval3 syl fzosplitsn
    c1 cz eqtrd ) BACDEZABFGZABQHGIGZABIGBJKTBREUAUBLABMABNOABPS $.

  $( The lower limit of a half-open range of integers which is equal to a
     non-empty empty half-open range of integers is element of the half-open
     range.  (Contributed by Alexander van der Vekens, 1-Jul-2018.) $)
  el2fzo $p |- ( ( M e. ZZ /\ N e. ZZ /\ M < N )
                 -> ( ( M ..^ N ) = ( J ..^ K ) -> J e. ( J ..^ K ) ) ) $=
    ( cz wcel clt wbr w3a cfzo co wceq wa cuz cfv fzolb biimpri wi cr zre simpr
    adantr eleqtrd elfzo2 biimpi eluzel2 simp2 cle eluz2 3anim123i 3expa lelttr
    3ad2ant1 syl exp4b com23 3impia sylbi 3imp syl3anbrc 3syl ex ) CEFZDEFCDGHI
    ZCDJKZABJKZLZAVFFZVDVGMZCVFFZCANOFZBEFZCBGHZIZVHVICVEVFVDCVEFZVGVOVDCDPQUBV
    DVGUAUCVJVNCABUDUEVNAEFZVLABGHZVHVKVLVPVMACUFUMVKVLVMUGVKVLVMVQVKVPVCACUHHZ
    IVLVMVQRZRZACUIVPVCVRVTVPVCMZVLVRVSWAVLVRVMVQWAVLMASFZCSFZBSFZIZVRVMMVQRVPV
    CVLWEVPWBVCWCVLWDATCTBTUJUKACBULUNUOUPUQURUSABPUTVAVB $.

  $( A half-open range of integers can represent an ordered pair, analogous to
     ~ fzopth .  (Contributed by Alexander van der Vekens, 1-Jul-2018.) $)
  fzoopth $p |- ( ( M e. ZZ /\ N e. ZZ /\ M < N ) ->
                ( ( M ..^ N ) = ( J ..^ K ) <-> ( M = J /\ N = K ) ) ) $=
    ( cz wcel clt wbr w3a co wceq wa cuz cfv wss uzss 3syl wb syl wi cfzo simpl
    fzolb sylibr simpr eleqtrd elfzouz el2fzo imp eleqtrrd eqssd uz11 mpbid cle
    simpl1 c1 fzoend elfzoel2 eleq2 eqcoms elfzo2 simprl zlem1lt ancoms biimprd
    cmin impancom impcom 3jca expcom 3adant1 a1d sylbi syl6bi com23 com13 mpcom
    eluz2 biimpri pm3.2 3ad2ant2 com12 com3l syl3anbrc simpl2 ex oveq12 impbid1
    jca ) CEFZDEFZCDGHZIZCDUAJZABUAJZKZCAKZDBKZLZWMWPWSWMWPLZWQWRWTCMNZAMNZKZWQ
    WTXAXBWTCWOFCXBFXAXBOWTCWNWOWTWMCWNFZWMWPUBCDUCZUDWMWPUEZUFCABUGACPQWTAWNFA
    XAFXBXAOWTAWOWNWMWPAWOFZABCDUHUIZXFUJACDUGCAPQUKWTWJXCWQRWJWKWLWPUOCAULSUMW
    TDMNZBMNZKZWRWTXIXJWTBEFZWKBDUNHZIZDXJFZXIXJOXGWTXNXHXGBUPVFJZWOFZWTXNTZABU
    QXLXQXRXPABURWTXQXLXNWPWMXQXLXNTZTWPXQWMXSWPXQXPWNFZWMXSTZXQXTRWOWNWOWNXPUS
    UTXTXPXAFZWKXPDGHZIZYAXPCDVAYDXSWMWKYCXSYBXLWKYCLZXNXLYELXLWKXMXLYEUBXLWKYC
    VBYEXLXMWKXLYCXMWKXLLXMYCXLWKXMYCRBDVCVDVEVGVHVIVJVKVLVMVNVOVHVPVQSVQXOXNBD
    VRVSBDPQWTWKXLDUPVFJZBGHZLZLZBXIFZXJXIOWMWPYIXDWMWPYITZXDWMXEVSXDYFWNFZWMYK
    TCDUQWPYLWMYIWPYLYFWOFZWMYITZWNWOYFUSYMYFXBFZXLYGIYNYFABVAXLYGYNYOWMYHYIWKW
    JYHYITWLWKYHVTWAWBVKVMVNWCSVQUIYIWKXLDBUNHZYJWKYHUBWKXLYGVBYHWKYPXLWKYGYPXL
    WKLYPYGWKXLYPYGRDBVCVDVEVGVHDBVRWDDBPQUKWTWKXKWRRWJWKWLWPWEDBULSUMWIWFCADBU
    AWGWH $.

  ${
    $d F i $.  $d M i $.  $d P i $.
    $( Two functions over a zero-based half-open integer range are equal if and
       only if their domains have the same length and the function values are
       the same at each position.  (Contributed by Alexander van der Vekens,
       1-Jul-2018.) $)
    2ffzoeq $p |- ( ( ( M e. NN0 /\ N e. NN0 ) /\ ( F : ( 0 ..^ M ) --> X
                             /\ P : ( 0 ..^ N ) --> Y ) ) -> ( F = P
              <-> ( M = N /\ A. i e. ( 0 ..^ M ) ( F ` i ) = ( P ` i ) ) ) ) $=
      ( cc0 wceq wcel wa cfzo wf wb wi c0 adantl syl impcom adantr cn0 cfv wral
      co cv eqeq1 anbi1d f0bi wfn ffn fndmu cle wbr cz nn0z fzon sylancr nn0ge0
      0z cr 0re a1i nn0re letri3d biimprd mpand sylbird syl5com ex sylbir com3l
      syl6bi oveq2 fzo0 syl6eq feq2d syl6bb imbi2d 3imtr4d feq2i biimpd anbi12d
      bitri eqtr3 com12 exp3a impbid ral0 raleqdv mpbiri biantrud bitrd anim12i
      imp wn eqfnfv2 wne df-ne cn elnnne0 clt w3a nnz nngt0 3jca fzoopth anim1d
      simpr anim1i impbid1 impancom syl5bir pm2.61ian ) DHIZDUAJZEUAJZKZHDLUDZF
      CMZHELUDZGAMZKZKZCAIZDEIZBUEZCUBYFAUBIZBXRUCZKZNXNYCKZYDYEYIYJYDYEYCXNYDY
      EOZYBXQXNYKOXNYBXQYKXNCPIZYAKZXQYDHEIZOZOZYBXQYKOYMYPOXNYDYMXQYNYDYMAPIZY
      AKXQYNOZYDYLYQYACAPUFUGYQYAYRYQPGAMZYAYROAGUHZYSAPUIZYAYRPGAUJYAAXTUIZUUA
      YROXTGAUJZUUBUUAYRUUBUUAKXTPIZXQYNXTPAUKXQUUDEHULUMZYNXQHUNJZEUNJZUUEUUDN
      USXPUUGXOEUOQHEUPUQXPUUEYNOXOXPHEULUMZUUEYNEURXPYNUUHUUEKXPHEHUTJXPVAVBEV
      CVDVEVFQVGVHVIRVHVJWNVLVKVBXNXSYLYAXNXSPFCMZYLXNXRPFCXNXRHHLUDZPDHHLVMZHV
      NZVOZVPCFUHZVQUGXNYKYOXQXNYEYNYDDHEUFVRVRVSVKSSYCXNYEYDOZYBXNUUOOXQYBXNYE
      YDXNYEKZYBYDUUPYBYLYQKYDUUPXSYLYAYQXNXSYLNYEXNXSUUJFCMZYLXNXRUUJFCUUKVPUU
      QUUIYLUUJPFCUULVTUUNWCVQTUUPEHIZYAYQNYEXNUURYEXNUURDEHUFWASUURYAUUJGAMZYQ
      UURXTUUJGAEHHLVMVPUUSYSYQUUJPGAUULVTYTWCVQRWBCAPWDVLWEWFQSWGXNYEYINYCXNYH
      YEXNYHYGBPUCYGBWHXNYGBXRPUUMWIWJWKTWLXNWOZYCKZYDXRXTIZYHKZYIUVACXRUIZUUBK
      ZYDUVCNYCUVEUUTYBUVEXQXSUVDYAUUBXRFCUJUUCWMQQBXRXTCAWPRYCUUTUVCYINZXQUUTU
      VFOYBUUTDHWQZXQUVFDHWRXOUVGXPUVFXOUVGKDWSJZXPUVFODWTUVHXPUVFUVHXPKZUVCYIU
      VIUVBYEYHUVIUVBHHIZYEKZYEUVIUUFDUNJZHDXAUMZXBZUVBUVKNUVHUVNXPUVHUUFUVLUVM
      UUFUVHUSVBDXCDXDXETHEHDXFRUVJYEXHVLXGYEUVBYHDEHLVMXIXJVIVJXKXLTSWLXM $.
  $}

  $( A nonnegative integer is element of the half open range of nonnegative
     integers with the element increased by one as an upper bound.
     (Contributed by Alexander van der Vekens, 5-Aug-2018.) $)
  fzonn0p1 $p |- ( N e. NN0 -> N e. ( 0 ..^ ( N + 1 ) ) ) $=
    ( cn0 wcel c1 caddc co cn clt wbr cc0 cfzo id nn0p1nn nn0re ltp1d syl3anbrc
    elfzo0 ) ABCZRADEFZGCASHIAJSKFCRLAMRAANOASQP $.

  $( A nonnegative integer is element of the half open range of nonnegative
     integers with the element increased by one as an upper bound.
     (Contributed by Alexander van der Vekens, 5-Aug-2018.) $)
  fzonn0p1p1 $p |- ( I e. ( 0 ..^ N ) -> ( I + 1 ) e. ( 0 ..^ ( N + 1 ) ) ) $=
    ( cc0 cfzo co wcel cn0 cn clt wbr w3a c1 elfzo0 peano2nn0 3ad2ant1 peano2nn
    caddc 3ad2ant2 simp3 cr wb nn0re nnre 1re a1i ltadd1 syl3an mpbid syl3anbrc
    sylbi ) ACBDEFAGFZBHFZABIJZKZALQEZCBLQEZDEFZABMUNUOGFZUPHFZUOUPIJZUQUKULURU
    MANOULUKUSUMBPRUNUMUTUKULUMSUKATFULBTFUMLTFZUMUTUAAUBBUCVAUMUDUEABLUFUGUHUO
    UPMUIUJ $.

  $( A half open range of nonnegative integers is a subset of a alf open range
     of nonnegative integers with the upperbound increased by one.
     (Contributed by Alexander van der Vekens, 5-Aug-2018.) $)
  fzossfzop1 $p |- ( N e. NN0 -> ( 0 ..^ N ) C_ ( 0 ..^ ( N + 1 ) ) ) $=
    ( cn0 wcel c1 caddc co cuz cfv cc0 cfzo wss cz cle wbr w3a nn0z peano2z zre
    id syl lep1d 3jca eluz2 sylibr fzoss2 ) ABCZADEFZAGHCZIAJFIUGJFKUFALCZUGLCZ
    AUGMNZOZUHUFUIULAPUIUIUJUKUISAQUIAARUAUBTAUGUCUDAIUGUET $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        The floor (greatest integer) function - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Closure law for division of a nonnegative integer by a positive integer.
     (Contributed by Alexander van der Vekens, 14-Apr-2018.) $)
  nn0nndivcl $p |- ( ( K e. NN0 /\ L e. NN ) -> ( K / L ) e. RR ) $=
    ( cn0 wcel cn wa cr cc0 wne w3a cdiv co elnnne0 adantr ad2antrl simprr 3jca
    nn0re sylan2b redivcl syl ) ACDZBEDZFAGDZBGDZBHIZJZABKLGDUCUBBCDZUFFZUGBMUB
    UIFUDUEUFUBUDUIARNUHUEUBUFBROUBUHUFPQSABTUA $.

  $( Division of a nonnegative integer by a positive number is positive.
     (Contributed by Alexander van der Vekens, 14-Apr-2018.) $)
  nn0ge0div $p |- ( ( K e. NN0 /\ L e. NN ) -> 0 <_ ( K / L ) ) $=
    ( cn0 wcel cn wa cc0 cle wbr cdiv co nn0ge0 adantr cr clt wb cz elnnz nn0re
    w3a zre ad2antrl simprr 3jca sylan2b ge0div syl mpbid ) ACDZBEDZFZGAHIZGABJ
    KHIZUIULUJALMUKANDZBNDZGBOIZTZULUMPUJUIBQDZUPFZUQBRUIUSFUNUOUPUIUNUSASMURUO
    UIUPBUAUBUIURUPUCUDUEABUFUGUH $.

  $( The floor function of a divison of a nonnegative integer by a positive
     integer is a positive integer.  (Contributed by Alexander van der Vekens,
     14-Apr-2018.) $)
  fldivnn0 $p |- ( ( K e. NN0 /\ L e. NN ) -> ( |_ ` ( K / L ) ) e. NN0 ) $=
    ( cn0 wcel cn wa cdiv co cr cc0 cle wbr cfl cfv nn0nndivcl flge0nn0 syl2anc
    nn0ge0div ) ACDBEDFABGHZIDJSKLSMNCDABOABRSPQ $.

  $( The floor function of a divison of a real number by a positive real number
     is a real number.  (Contributed by Alexander van der Vekens,
     14-Apr-2018.) $)
  refldivcl $p |- ( ( K e. RR /\ L e. RR+ ) -> ( |_ ` ( K / L ) ) e. RR ) $=
    ( cr wcel crp wa cdiv co cfl cfv rerpdivcl reflcl syl ) ACDBEDFABGHZCDNIJCD
    ABKNLM $.

  $( The floor function of a divison of a real number by a positive real number
     is less than or equal to the division.  (Contributed by Alexander van der
     Vekens, 14-Apr-2018.) $)
  fldivle $p |- ( ( K e. RR /\ L e. RR+ )
                  -> ( |_ ` ( K / L ) ) <_ ( K / L ) ) $=
    ( cr wcel crp wa cdiv co cfl cfv cle wbr c1 caddc clt rerpdivcl fllelt 3syl
    simpl ) ACDBEDFABGHZCDTIJZTKLZTUAMNHOLZFUBABPTQUBUCSR $.

  $( The floor function of a divison of a nonnegative integer by a positive
     integer is less than or equal to the division.  (Contributed by Alexander
     van der Vekens, 14-Apr-2018.) $)
  fldivnn0le $p |- ( ( K e. NN0 /\ L e. NN )
                     -> ( |_ ` ( K / L ) ) <_ ( K / L ) ) $=
    ( cn0 wcel cr crp cdiv co cfl cfv cle wbr cn nn0re nnrp fldivle syl2an ) AC
    DAEDBFDABGHZIJRKLBMDANBOABPQ $.

  $( The floor function of a divison of a nonnegative integer by a positive
     integer is less than the division of a greater denominator by the same
     positive integer.  (Contributed by Alexander van der Vekens,
     14-Apr-2018.) $)
  flltdivnn0lt $p |- ( ( K e. NN0 /\ N e. NN0 /\ L e. NN )
                       -> ( K < N -> ( |_ ` ( K / L ) ) < ( N / L ) ) ) $=
    ( cn0 wcel cn w3a clt wbr cdiv co cfl wa cr nn0nndivcl 3adant2 adantr nn0re
    syl jca cfv cle reflcl 3adant1 3jca fldivnn0le simpr cc0 wb nngt0 3anim123i
    nnre ltdiv1 mpbid lelttr sylc ex ) ADEZCDEZBFEZGZACHIZABJKZLUAZCBJKZHIZVAVB
    MZVDNEZVCNEZVENEZGZVDVCUBIZVCVEHIZMVFVAVKVBVAVHVIVJURUTVHUSURUTMVIVHABOZVCU
    CSPURUTVIUSVNPUSUTVJURCBOUDUEQVGVLVMVAVLVBURUTVLUSABUFPQVGVBVMVAVBUGVGANEZC
    NEZBNEZUHBHIZMZGZVBVMUIVAVTVBURVOUSVPUTVSARCRUTVQVRBULBUJTUKQACBUMSUNTVDVCV
    EUOUPUQ $.

  $( If the dividend of a division is less than the difference between a real
     number and the divisor, the floor function of the division plus 1 is less
     than the division of the real number by the divisor.  (Contributed by
     Alexander van der Vekens, 14-Apr-2018.) $)
  ltdifltdiv $p |- ( ( A e. RR /\ B e. RR+ /\ C e. RR )
                     -> ( A < ( C - B )
                          -> ( ( |_ ` ( A / B ) ) + 1 ) < ( C / B ) ) ) $=
    ( cr wcel co clt wbr cdiv c1 caddc wa syl 3adant3 adantr cmul recn 3ad2ant2
    wb cc crp w3a cmin cfl cfv refldivcl peano2re rerpdivcl 3adant1 1re a1i cle
    ancoms 3simpa fldivle leadd1dd rpre ltaddsub syl3an2 biimpar ax-1cn adddird
    rpcn 3ad2ant1 cc0 wne rpne0 divcan1d mulid2d oveq12d eqtrd 3ad2ant3 breq12d
    wceq mpbird simp2 ltmul1d lelttrd ex ) ADEZBUAEZCDEZUBZACBUCFGHZABIFZUDUEZJ
    KFZCBIFZGHWCWDLZWGWEJKFZWHWCWGDEZWDVTWAWKWBVTWALZWFDEZWKABUFZWFUGMNOWCWJDEZ
    WDVTWAWOWBWLWEDEZWOABUHZWEUGZMNOWCWHDEZWDWAWBWSVTWBWAWSCBUHUMUIZOWIWFWEJWCW
    MWDVTWAWMWBWNNOWCWPWDVTWAWPWBWQNZOJDEWIUJUKWIWLWFWEULHWCWLWDVTWAWBUNOABUOMU
    PWIWJWHGHZWJBPFZWHBPFZGHZWIXEABKFZCGHZWCXGWDWAVTBDEWBXGWDSBUQABCURUSUTWCXEX
    GSWDWCXCXFXDCGWCXCWEBPFZJBPFZKFXFWCWEJBVTWAWETEZWBWLWPXJWQWEQMNJTEWCVAUKWAV
    TBTEWBBVCZRZVBWCXHAXIBKWCABVTWAATEWBAQVDXLWAVTBVEVFWBBVGRZVHWAVTXIBVNWBWABX
    KVIRVJVKWCCBWBVTCTEWACQVLXLXMVHVMOVOWCXBXESWDWCWJWHBWCWPWOXAWRMWTVTWAWBVPVQ
    OVOVRVS $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        The modulo (remainder) operation - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The value of the modulo operation (multiplication in reversed order).
     (Contributed by Alexander van der Vekens, 14-Apr-2018.) $)
  modvalr $p |- ( ( A e. RR /\ B e. RR+ )
                  -> ( A mod B ) = ( A - ( ( |_ ` ( A / B ) ) x. B ) ) ) $=
    ( cr wcel crp wa cmo co cdiv cfl cfv cmul cmin modval rpcn adantl rerpdivcl
    cc reflcl recnd syl mulcomd oveq2d eqtrd ) ACDZBEDZFZABGHABABIHZJKZLHZMHAUI
    BLHZMHABNUGUJUKAMUGBUIUFBRDUEBOPUGUHCDZUIRDABQULUIUHSTUAUBUCUD $.

  $( Partition of a division into its integer part and the remainder.
     (Contributed by Alexander van der Vekens, 14-Apr-2018.) $)
  flpmodeq $p |- ( ( A e. RR /\ B e. RR+ )
                   -> ( ( ( |_ ` ( A / B ) ) x. B ) + ( A mod B ) ) = A ) $=
    ( cr wcel crp wa cdiv co cfl cfv cmul cmin cmo wceq caddc modvalr eqcomd cc
    recn adantr rerpdivcl flcl zcnd syl adantl mulcld modcl recnd subaddd mpbid
    rpcn ) ACDZBEDZFZAABGHZIJZBKHZLHZABMHZNUQUSOHANUNUSURABPQUNAUQUSULARDUMASTU
    NUPBUNUOCDZUPRDABUAUTUPUOUBUCUDUMBRDULBUKUEUFUNUSABUGUHUIUJ $.

  $( The value of the modulo operation (expressed with sum of denominator and
     nominator).  (Contributed by Alexander van der Vekens, 14-Apr-2018.) $)
  modvalp1 $p |- ( ( A e. RR /\ B e. RR+ )
      -> ( ( A + B ) - ( ( ( |_ ` ( A / B ) ) + 1 ) x. B ) ) = ( A mod B ) ) $=
    ( cr wcel crp wa caddc co cdiv cfl cfv cmul cmin c1 cc adantr adantl oveq2d
    cmo recn refldivcl recnd rpcn mulcld pnpcan2d ax-1cn a1i adddird wceq eqtrd
    mulid2d modvalr 3eqtr4d ) ACDZBEDZFZABGHZABIHJKZBLHZBGHZMHAUSMHUQURNGHBLHZM
    HABSHUPAUSBUNAODUOATPUPURBUPURABUAUBZUOBODUNBUCZQZUDVDUEUPVAUTUQMUPVAUSNBLH
    ZGHUTUPURNBVBNODUPUFUGVDUHUPVEBUSGUOVEBUIUNUOBVCUKQRUJRABULUM $.

  $( If a real number is between a positive real number and the double of the
     positive real number, the real number modulo the positive real number
     equals the real number minus the positive real number.  (Contributed by
     Alexander van der Vekens, 13-May-2018.) $)
  2submod $p |- ( ( ( A e. RR /\ B e. RR+ ) /\ ( B <_ A /\ A < ( 2 x. B ) ) )
                 -> ( A mod B ) = ( A - B ) ) $=
    ( cr wcel crp wa cle wbr c2 cmul clt cmin cmo wceq syl adantl adantr sylan2
    co c1 rpre ax-1rid oveq2d oveq1d cz w3a simpl simpr 1z a1i 3jca modcyc2 cc0
    resubcl wb subge0 bicomd caddc rpcn 2timesd breq2d ltsubaddd bitr4d anbi12d
    jca biimpa modid syl2anc 3eqtr3d ) ACDZBEDZFZBAGHZAIBJSZKHZFZFZABTJSZLSZBMS
    ZABLSZBMSZABMSZWAVLVTWBNVPVLVSWABMVLVRBALVKVRBNZVJVKBCDZWDBUAZBUBOPUCUDQVQV
    JVKTUEDZUFZVTWCNVLWHVPVLVJVKWGVJVKUGZVJVKUHZWGVLUIUJUKQABTULOVQWACDZVKFZUMW
    AGHZWABKHZFZWBWANVLWLVPVLWKVKVKVJWEWKWFABUNRWJVEQVLVPWOVLVMWMVOWNVLWMVMVKVJ
    WEWMVMUOWFABUPRUQVLVOABBURSZKHWNVLVNWPAKVKVNWPNVJVKBBUSUTPVAVLABBWIVKWEVJWF
    PZWQVBVCVDVFWABVGVHVI $.

  $( The sum of a real number modulo a positive real number and another real
     number equals the sum of the two real numbers modulo the positive real
     number.  (Contributed by Alexander van der Vekens, 13-May-2018.) $)
  modaddmod $p |- ( ( A e. RR /\ B e. RR /\ M e. RR+ )
                    -> ( ( ( A mod M ) + B ) mod M ) = ( ( A + B ) mod M ) ) $=
    ( cr wcel crp w3a cmo co wceq caddc modcl simpl jca 3adant2 modabs2 modadd1
    wa 3simpc syl3anc ) ADEZBDEZCFEZGACHIZDEZUARZUBUCRUDCHIUDJZUDBKICHIABKICHIJ
    UAUCUFUBUAUCRUEUAACLUAUCMNOUAUBUCSUAUCUGUBACPOUDABCQT $.

  $( The sum of a real number modulo a positive real number and another real
     number equals the sum of the two real numbers modulo the positive real
     number.  (Contributed by Alexander van der Vekens, 17-May-2018.) $)
  modadd2mod $p |- ( ( A e. RR /\ B e. RR /\ M e. RR+ )
                    -> ( ( B + ( A mod M ) ) mod M ) = ( ( B + A ) mod M ) ) $=
    ( cr wcel crp w3a cmo co caddc cc recn 3ad2ant2 modcl recnd 3adant2 addcomd
    wa oveq1d wceq modaddmod addcom syl2an 3adant3 3eqtrd ) ADEZBDEZCFEZGZBACHI
    ZJIZCHIUJBJIZCHIABJIZCHIZBAJIZCHIZUIUKULCHUIBUJUGUFBKEZUHBLZMUFUHUJKEUGUFUH
    RUJACNOPQSABCUAUFUGUNUPTUHUFUGRUMUOCHUFAKEUQUMUOTUGALURABUBUCSUDUE $.

  $( The difference of a real number modulo a positive real number and another
     real number equals the difference of the two real numbers modulo the
     positive real number.  (Contributed by Alexander van der Vekens,
     17-May-2018.) $)
  modsubmod $p |- ( ( A e. RR /\ B e. RR /\ M e. RR+ )
                    -> ( ( ( A mod M ) - B ) mod M ) = ( ( A - B ) mod M ) ) $=
    ( cr wcel crp w3a cmo co modcl 3adant2 simp1 simp2 simp3 wceq modabs2 eqidd
    modsub12d ) ADEZBDEZCFEZGZACHIZABBCSUAUCDETACJKSTUALSTUAMZUDSTUANSUAUCCHIUC
    OTACPKUBBCHIQR $.

  $( The difference of a real number modulo a positive real number and another
     real number modulo this positive real number equals the difference of the
     two real numbers modulo the positive real number.  (Contributed by
     Alexander van der Vekens, 17-May-2018.) $)
  modsubmodmod $p |- ( ( A e. RR /\ B e. RR /\ M e. RR+ )
          -> ( ( ( A mod M ) - ( B mod M ) ) mod M ) = ( ( A - B ) mod M ) ) $=
    ( cr wcel crp w3a co modcl 3adant2 simp1 3adant1 simp2 simp3 wceq modsub12d
    cmo modabs2 ) ADEZBDEZCFEZGACQHZABCQHZBCSUAUBDETACIJSTUAKTUAUCDESBCILSTUAMS
    TUANSUAUBCQHUBOTACRJTUAUCCQHUCOSBCRLP $.

  $( The product of a real number modulo a positive real number and an integer
     equals the product of the real number and the integer modulo the positive
     real number.  (Contributed by Alexander van der Vekens, 17-May-2018.) $)
  modmulmod $p |- ( ( A e. RR /\ B e. ZZ /\ M e. RR+ )
                  -> ( ( ( A mod M ) x. B ) mod M ) = ( ( A x. B ) mod M ) ) $=
    ( cr wcel cz crp w3a cmo co wa wceq cmul modcl simpl 3adant2 3simpc modabs2
    jca modmul1 syl3anc ) ADEZBFEZCGEZHACIJZDEZUBKZUCUDKUECIJUELZUEBMJCIJABMJCI
    JLUBUDUGUCUBUDKUFUBACNUBUDOSPUBUCUDQUBUDUHUCACRPUEABCTUA $.

  $( The sum of a real number and the product of a second real number modulo a
     positive real number and an integer equals the sum of the real number and
     the product of the other real number and the integer modulo the positive
     real number.  (Contributed by Alexander van der Vekens, 17-May-2018.) $)
  modaddmulmod $p |- ( ( ( A e. RR /\ B e. RR /\ C e. ZZ ) /\ M e. RR+ )
                       -> ( ( A + ( ( B mod M ) x. C ) ) mod M )
                          = ( ( A + ( B x. C ) ) mod M ) ) $=
    ( cr wcel wa cmo cmul caddc recn adantr modcld 3ad2ant3 addcomd oveq1d wceq
    co cc 3adant1 w3a crp 3ad2ant1 simpl2 simpr recnd zcn mulcld remulcld simpl
    cz zre adantl anim1i simpl3 modmulmod syl3anc remulcl sylan2 modabs2 eqtr4d
    simp1 sylan modadd1 syl211anc modaddmod mulcl syl2an eqtrd 3eqtrd ) AEFZBEF
    ZCUKFZUAZDUBFZGZABDHRZCIRZJRZDHRVRAJRZDHRZBCIRZDHRZAJRDHRZAWBJRZDHRZVPVSVTD
    HVPAVRVNASFZVOVKVLWGVMAKUCZLVPVQCVPVQVPBDVKVLVMVOUDZVNVOUEZMZUFVNCSFZVOVMVK
    WLVLCUGZNLUHOPVPVREFWCEFVKVOGVRDHRZWCDHRZQWAWDQVPVQCWKVNCEFZVOVMVKWPVLCULZN
    LUIVPWBDVNWBEFZVOVLVMWRVKVLVMGBCVLVMUJVMWPVLWQUMUITLWJMVNVKVOVKVLVMVBZUNVPW
    NWCWOVPVLVMVOWNWCQWIVKVLVMVOUOWJBCDUPUQVNWRVOWOWCQVLVMWRVKVMVLWPWRWQBCURUST
    ZWBDUTVCVAVRWCADVDVEVPWDWBAJRZDHRZWFVPWRVKVOWDXBQVNWRVOWTLVNVKVOWSLWJWBADVF
    UQVPXAWEDHVNXAWEQVOVNWBAVLVMWBSFZVKVLBSFWLXCVMBKWMBCVGVHTWHOLPVIVJ $.

  $( A positive real number modulo itself is 0 .  (Contributed by Alexander van
     der Vekens, 15-May-2018.) $)
  modid0 $p |- ( N e. RR+ -> ( N mod N ) = 0 ) $=
    ( crp wcel cmo co cc0 wceq cdiv cz c1 rpcn rpne0 dividd 1z syl6eqel cr rpre
    wb mod0 mpancom mpbird ) ABCZAADEFGZAAHEZICZUBUDJIUBAAKALMNOAPCUBUCUERAQAAS
    TUA $.

  $( The product of an integer and a positive integer is 0 modulo the positive
     integer.  (Contributed by Alexander van der Vekens, 17-May-2018.) $)
  modidmul0 $p |- ( ( A e. ZZ /\ N e. NN ) -> ( ( A x. N ) mod N ) = 0 ) $=
    ( cz wcel cn wa cmul co cmo cc0 wceq cdiv simpr nnz adantl simpl nncn nnne0
    c1 cr dividd 1z syl6eqel zdivmul syl31anc crp wb zre nnre remulcl nnrp mod0
    syl2an syl2anc mpbird ) ACDZBEDZFZABGHZBIHJKZUSBLHCDZURUQBCDZUPBBLHZCDZVAUP
    UQMUQVBUPBNOUPUQPUQVDUPUQVCSCUQBBQBRUAUBUCOBABUDUEURUSTDZBUFDZUTVAUGUPATDBT
    DVEUQAUHBUIABUJUMUQVFUPBUKOUSBULUNUO $.

  $( If a nonnegative integer is less than the double of a positive integer,
     the nonnegative integer modulo the positive integer equals the nonnegative
     integer or the nonnegative integer minus the positive integer.
     (Contributed by Alexander van der Vekens, 21-May-2018.) $)
  modifeq2int $p |- ( ( A e. NN0 /\ B e. NN /\ A < ( 2 x. B ) )
                      -> ( A mod B ) = if ( A < B , A , ( A - B ) ) ) $=
    ( clt wbr cn0 wcel cn c2 cmul co w3a wa cr cle 3adant3 adantl eqcomd adantr
    wceq eqtrd cmo cmin cif wi crp cc0 nn0re nnrp nn0ge0 3ad2ant1 anim1i ancoms
    anim12i modid syl2anc iftrue ex wn wb lenlt syl2anr biimpar simpl3 syl12anc
    nnre 2submod iffalse expcom pm2.61i ) ABCDZAEFZBGFZAHBIJCDZKZABUAJZVJAABUBJ
    ZUCZSZUDVJVNVRVJVNLZVOAVQVSAMFZBUEFZLZUFANDZVJLZVOASVNWBVJVKVLWBVMVKVTVLWAA
    UGZBUHUMOZPVNVJWDVNWCVJVKVLWCVMAUIUJUKULABUNUOVJAVQSVNVJVQAVJAVPUPQRTUQVNVJ
    URZVRVNWGLZVOVPVQWHWBBANDZVMVOVPSVNWBWGWFRVNWIWGVKVLWIWGUSZVMVLBMFVTWJVKBVE
    WEBAUTVAOVBVKVLVMWGVCABVFVDWHVQVPWGVQVPSVNVJAVPVGPQTVHVI $.

  $( Two times a positive real number module the real number is zero.
     (Contributed by Alexander van der Vekens, 8-Jun-2018.) $)
  2txmodxeq0 $p |- ( X e. RR+ -> ( ( 2 x. X ) mod X ) = 0 ) $=
    ( crp wcel c2 cmul co cmo cc0 wceq cdiv cz 2cn rpcn rpne0 divcan4d syl6eqel
    cc a1i 2z cr wb 2re rpre remulcld mod0 mpancom mpbird ) ABCZDAEFZAGFHIZUIAJ
    FZKCZUHUKDKUHDADQCUHLRAMANOSPUITCUHUJULUAUHDADTCUHUBRAUCUDUIAUEUFUG $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        The ` # ` (finite set size) function - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The size of the image of a one-to-one function ` E ` under the range of a
     function ` F ` which is a one-to-one function into the domain of ` E `
     equals the size of the function ` F ` .  (Contributed by Alexander van der
     Vekens, 4-Feb-2018.) $)
  hashimarn $p |- ( ( E : dom E -1-1-> ran E /\ E e. V )
                    -> ( F : ( 0 ..^ ( # ` F ) ) -1-1-> dom E
                         -> ( # ` ( E " ran F ) ) = ( # ` F ) ) ) $=
    ( cdm crn wf1 wcel wa cc0 chash cfv cfzo wceq syl adantl sylib f1fun adantr
    wfun cvv co cima cres wss wf f1f frn ssdmres fveq2d wfn funres funfn hashfn
    fdm ovex syl6eqel funrnex sylc simpll f1ssres syl2anc hashf1rn imp syl21anc
    rnexg eqtr3d df-ima fveq2i syl6reqr a1i dmexg simpr 3eqtr4d ex ) ADZAEZAFZA
    CGZHZIBJKZLUAZVOBFZABEZUBZJKZVTMVSWBHZAWCUCZDZJKZWCJKZWEVTWFWHWCJWFWCVOUDZW
    HWCMWBWKVSWBWAVOBUEZWKWAVOBUFZWAVOBUGNOZWCAUHPUIWFWIWGEZJKZWEWFWGJKZWIWPWFW
    GWHUJZWQWIMVSWRWBVQWRVRVQASZWRVOVPAQWSWGSWRWCAUKWGULPNRRWHWGUMNWFWCTGZVPTGZ
    WCVPWGFZWQWPMZWBWTVSWBBDZTGZBSWTWBWLXEWMWLXDWATWAVOBUNIVTLUOZUPNWAVOBQTBUQU
    ROVSXAWBVRXAVQACVEORWFVQWKXBVQVRWBUSWNVOVPWCAUTVAWTXAHXBXCWCVPWGTTVBVCVDVFW
    DWOJAWCVGVHVIWFWATGZVOTGZWBVTWJMZXGWFXFVJVSXHWBVRXHVQACVKORVSWBVLXGXHHWBXIW
    AVOBTTVBVCVDVMVN $.

  $( If the size of the image of a one-to-one function ` E ` under the range of
     a function ` F ` which is a one-to-one function into the domain of ` E `
     is a nonnegative integer, the size of the function ` F ` is the same
     nonnegative integer.  (Contributed by Alexander van der Vekens,
     4-Feb-2018.) $)
  hashimarni $p |- ( ( E : dom E -1-1-> ran E /\ E e. V )
                     -> ( ( F : ( 0 ..^ ( # ` F ) ) -1-1-> dom E
                /\ P = ( E " ran F ) /\ ( # ` P ) = N ) -> ( # ` F ) = N ) ) $=
    ( cc0 chash cfv cfzo co cdm wf1 crn cima wceq w3a wcel wa wi wb fveq2 id ex
    eqeq1d adantl hashimarn impcom adantr sylbid exp31 com23 com34 3imp com12
    sylan9req ) FCGHZIJBKZCLZABCMNZOZAGHZDOZPUQBMBLBEQRZUPDOZURUTVBVCVDSURUTVCV
    BVDURVCUTVBVDSZURVCUTVEURVCRZUTRVBUSGHZDOZVDUTVBVHTVFUTVAVGDAUSGUAUDUEVFVHV
    DSUTVFVHVDVFVHUPVGDVCURVGUPOBCEUFUGVHUBUOUCUHUIUJUKULUMUN $.

  $( The size of a function with a half-open range of integers, starting with
     0, as domain equals the right border of this range.  (Contributed by
     Alexander van der Vekens, 26-Jan-2018.) $)
  hashfirdm $p |- ( ( N e. NN0 /\ F : ( 0 ..^ N ) --> B ) -> ( # ` F ) = N ) $=
    ( cn0 wcel cc0 cfzo co wf wa chash cfv wceq wfun ffun adantl cdm cfn eqeq2d
    wb wfn ffn fzofi fnfi sylancl hashfun syl fdm fveq2 sylan9bbr sylan2 bitr2d
    hashfzo0 mpbird ) CDEZFCGHZABIZJZBKLZCMZBNZUQVAUOUPABOPURVAUSBQZKLZMZUTUQVA
    VDTZUOUQBREZVEUQBUPUAUPREVFUPABUBFCUCUPBUDUEBUFUGPUQUOVBUPMZVDUTTUPABUHVGVD
    USUPKLZMUOUTVGVCVHUSVBUPKUISUOVHCUSCUMSUJUKULUN $.

  $( The size of a function with a finite set of sequential integers, starting
     with 0, as domain equals the right border of this range increased by 1.
     (Contributed by Alexander van der Vekens, 15-Mar-2018.) $)
  hashfzdm $p |- ( ( N e. NN0 /\ F : ( 0 ... N ) --> B )
                   -> ( # ` F ) = ( N + 1 ) ) $=
    ( cn0 wcel cc0 cfz co wf wa chash cfv c1 caddc wceq wfun adantl cfn eqeq2d
    wb ffun cdm wfn ffn fzfi fnfi sylancl hashfun syl fdm fveq2 cmin cuz hashfz
    elnn0uz sylbi nn0cn subid1d oveq1d eqtrd sylan9bbr sylan2 bitr2d mpbird ) C
    DEZFCGHZABIZJZBKLZCMNHZOZBPZVGVLVEVFABUAQVHVLVIBUBZKLZOZVKVGVLVOTZVEVGBREZV
    PVGBVFUCVFREVQVFABUDFCUEVFBUFUGBUHUIQVGVEVMVFOZVOVKTVFABUJVRVOVIVFKLZOVEVKV
    RVNVSVIVMVFKUKSVEVSVJVIVEVSCFULHZMNHZVJVECFUMLEVSWAOCUOFCUNUPVEVTCMNVECCUQU
    RUSUTSVAVBVCVD $.

  ${
    $d V a $.
    $( The size of a set is 1 in terms of existential uniqueness.  (Contributed
       by Alexander van der Vekens, 8-Feb-2018.) $)
    euhash1 $p |- ( V e. W -> ( ( # ` V ) = 1 <-> E! a a e. V ) ) $=
      ( wcel chash cfv c1 wceq c1o cen cfn wb wi hash1 eqeq2i ax-mp a1d wn cpnf
      syl wbr cv weu eqcomi com 1onn nnfi hashen mpan2 syl5bb hashinf eqeq1 wne
      wa cr 1re renepnf df-ne pm2.21 eqcoms syl6bi hasheni biimpi impbid expcom
      sylbi com12 pm2.61i euen1b syl6bb ) ABDZAEFZGHZAIJUAZCUBADCUCAKDZVKVMVNLZ
      MVOVPVKVMVLIEFZHZVOVNGVQVLVQGNUDOVOIKDZVRVNLIUEDVSUFIUGPAIUHUIUJQVKVORZVP
      VKVTUNVLSHZVPABUKWAVMVNWAVMSGHVNVLSGULVNGSGSUMZGSHZVNMZGUODWBUPGUQPWBWCRW
      DGSURWCVNUSVFPUTVAVNWAVMVNVRWAVMMAIVBVRVMWAVRVMVQGVLNOVCQTVGVDTVEVHCAVIVJ
      $.
  $}

  $( The value of the size function on a finite 0-based sequence.  (Contributed
     by Alexander van der Vekens, 25-Jun-2018.) $)
  fz0hash $p |- ( ( N e. NN0 /\ F Fn ( 0 ... N ) )
                  -> ( # ` F ) = ( N + 1 ) ) $=
    ( cc0 cfz co wfn cn0 wcel chash cfv c1 caddc hashfn cmin cuz elnn0uz hashfz
    wceq sylbi nn0cn subid1d oveq1d eqtrd sylan9eqr ) ACBDEZFBGHZAIJUEIJZBKLEZU
    EAMUFUGBCNEZKLEZUHUFBCOJHUGUJRBPCBQSUFUIBKLUFBBTUAUBUCUD $.

  $( The size of a subset is less then or equal to the size of its superset.
     (Contributed by Alexander van der Vekens, 14-Jul-2018.) $)
  hashss $p |- ( ( A e. V /\ B C_ A ) -> ( # ` B ) <_ ( # ` A ) ) $=
    ( cfn wcel wss wa chash cfv cle wbr wi cdom com12 adantl wb cpnf cvv adantr
    ex ssdomg impcom ssfi adantrl simpl hashdom syl2anc mpbird wceq hashinf cxr
    ssexg ancoms hashxrcl pnfge 3syl breq2 sylibrd expcom mpd impancom pm2.61i
    wn ) ADEZACEZBAFZGZBHIZAHIZJKZLVDVGVJVDVGGZVJBAMKZVGVDVLVFVDVLLVEVDVFVLBADU
    ANOUBVKBDEZVDVJVLPVDVFVMVEABUCUDVDVGUEBADUFUGUHTVGVDVCZVJVEVNVFVJVEVNGVIQUI
    ZVFVJLZACUJVEVOVPLVNVOVEVPVOVEGVFVHQJKZVJVEVFVQLVOVEVFVQVGBREZVHUKEVQVFVEVR
    BACULUMBRUNVHUOUPTOVOVJVQPVEVIQVHJUQSURUSSUTVANVB $.

  ${
    $d V a b $.  $d W a b $.
    $( A set of size two is an unordered pair of its elements.  (Contributed by
       Alexander van der Vekens, 12-Jul-2017.) $)
    hash2prv $p |- ( ( V e. W /\ ( # ` V ) = 2 )
                     -> E. a e. V E. b e. V V = { a , b } ) $=
      ( cv cpr wceq wex wcel chash cfv c2 wa wrex hash2pr vex prid1 prid2 eleq2
      wi pm3.2i anbi12d mpbiri ancri a1i 2eximdv impcom r2ex sylibr mpancom ) A
      CEZDEZFZGZDHCHZABIAJKLGMZUNDANCANZABCDOUOUPMUKAIZULAIZMZUNMZDHCHZUQUPUOVB
      UPUNVACDUNVATUPUNUTUNUTUKUMIZULUMIZMVCVDUKULCPQUKULDPRUAUNURVCUSVDAUMUKSA
      UMULSUBUCUDUEUFUGUNCDAAUHUIUJ $.
  $}

  ${
    $d P a b $.  $d V a b $.
    $( A subset of size two is an unordered pair of elements of its superset.
       (Contributed by Alexander van der Vekens, 12-Jul-2017.) $)
    hash2sspr $p |- ( ( P e. ~P V /\ ( # ` P ) = 2 )
                     -> E. a e. V E. b e. V P = { a , b } ) $=
      ( cv cpr wceq wex cpw wcel chash cfv c2 wa wrex hash2pr vex elelpwi mpan
      wi eleq1 prid1 prid2 syl6bi com12 adantr ancrd 2eximdv impcom r2ex sylibr
      jca mpancom ) ACEZDEZFZGZDHCHZABIZJZAKLMGZNZUQDBOCBOZAUSCDPURVBNUNBJZUOBJ
      ZNZUQNZDHCHZVCVBURVHVBUQVGCDVBUQVFUTUQVFTVAUQUTVFUQUTUPUSJZVFAUPUSUAVIVDV
      EUNUPJVIVDUNUOCQUBUNUPBRSUOUPJVIVEUNUODQUCUOUPBRSULUDUEUFUGUHUIUQCDBBUJUK
      UM $.
  $}

  ${
    $d P x y z $.  $d V x y z $.
    $( An element of the set of subsets with two elements is an unordered
       pair.  (Contributed by Alexander van der Vekens, 12-Jul-2018.) $)
    elss2pr $p |- ( P e. { z e. ~P V | ( # ` z ) = 2 }
                    -> E. x e. V E. y e. V P = { x , y } ) $=
      ( cv chash cfv c2 wceq cpw crab wcel wa wrex fveq2 eqeq1d elrab hash2sspr
      cpr sylbi ) DCFZGHZIJZCEKZLMDUEMDGHZIJZNDAFBFTJBEOAEOUDUGCDUEUBDJUCUFIUBD
      GPQRDEABSUA $.
  $}

  ${
    $d V e p v w $.  $d X p v w $.
    $( If there is an element of the set of subsets with two elements in a set,
       an unordered pair of sets is in the set.  (Contributed by Alexander van
       der Vekens, 12-Jul-2018.) $)
    exprelprel $p |- ( E. p e. { e e. ~P V | ( # ` e ) = 2 } p e. X
                    -> E. v e. V E. w e. V { v , w } e. X ) $=
      ( cv wcel cpr wrex chash cfv wceq cpw crab elss2pr eleq1 biimpcd reximdv
      c2 syl5com rexlimiv ) FGZEHZBGAGIZEHZADJZBDJZFCGKLTMCDNOZUCUIHUCUEMZADJZB
      DJUDUHBACUCDPUDUKUGBDUDUJUFADUJUDUFUCUEEQRSSUAUB $.
  $}

  $( Value of the numeric cardinality of a nonempty range of nonnegative
     integers.  (Contributed by Alexander van der Vekens, 21-Jul-2018.) $)
  hashfz0 $p |- ( B e. NN0 -> ( # ` ( 0 ... B ) ) = ( B + 1 ) ) $=
    ( cn0 wcel cc0 cfz co chash cfv cmin c1 caddc cuz wceq elnn0uz hashfz sylbi
    nn0cn subid1d oveq1d eqtrd ) ABCZDAEFGHZADIFZJKFZAJKFUAADLHCUBUDMANDAOPUAUC
    AJKUAAAQRST $.

  ${
    $d F f $.  $d N f $.
    $( The size of a function on a half-open integer range.  (Contributed by
       Alexander van der Vekens, 21-Jun-2018.) $)
    ffzohash $p |- ( ( N e. NN0 /\ F Fn ( 0 ..^ N ) ) -> ( # ` F ) = N ) $=
      ( cc0 cfzo co wfn cn0 wcel chash cfv hashfn hashfzo0 sylan9eqr ) ACBDEZFB
      GHAIJNIJBNAKBLM $.
  $}

  $( If the size of a set is greater than 0, the set is not empty.
     (Contributed by Alexander van der Vekens, 5-Aug-2018.) $)
  hashgt0n0 $p |- ( ( A e. V /\ 0 < ( # ` A ) ) -> A =/= (/) ) $=
    ( wcel cc0 chash cfv clt wbr wa c0 wne cr 0re a1i ltne sylan wceq wb adantr
    hasheq0 bicomd necon3bid mpbird ) ABCZDAEFZGHZIZAJKUEDKZUDDLCZUFUHUIUDMNDUE
    OPUGAJUEDUGUEDQZAJQZUDUJUKRUFABTSUAUBUC $.

  ${
    $d X x y z $.  $d Y x y z $.  $d ph z $.
    $( A class abstraction with a restricted existential quantification
       expressed as indext union.  (Contributed by Alexander van der Vekens,
       29-Jul-2018.) $)
    rabasiun $p |- { x e. X | E. y e. Y ph } = U_ y e. Y { x e. X | ph } $=
      ( vz cv wcel wrex wa cab crab ciun wsb nfcv nfcri nfv nfan nfs1v nfrex
      weq eleq1 sbequ12 rexbidv anbi12d cbvab elrabf bicomi rexbii bitr3i abbii
      r19.42v eqtri df-rab df-iun 3eqtr4i ) BGZDHZACEIZJZBKZFGZABDLZHZCEIZFKZUS
      BDLCEVCMVAVBDHZABFNZCEIZJZFKVFUTVJBFURUSFFBDFDOPUSFQRVGVIBBFDBDOZPVHBCEBE
      OABFSZTRBFUAZURVGUSVIUQVBDUBVMAVHCEABFUCZUDUEUFVJVEFVJVGVHJZCEIVEVGVHCEUL
      VOVDCEVDVOAVHBVBDBVBOVKVLVNUGUHUIUJUKUMUSBDUNCFEVCUOUP $.
  $}

  ${
    $d X x y $.  $d Y x y $.  $d ph y $.
    hashrabrex.1 $e |- ( ph -> Y e. Fin ) $.
    hashrabrex.2 $e |- ( ( ph /\ y e. Y ) -> { x e. X | ps } e. Fin ) $.
    hashrabrex.3 $e |- ( ph -> Disj_ y e. Y { x e. X | ps } ) $.
    $( The number of elements in a class abstraction with a restricted
       existential quantification.  (Contributed by Alexander van der Vekens,
       29-Jul-2018.) $)
    hashrabrex $p |- ( ph -> ( # ` { x e. X | E. y e. Y ps } )
                             = sum_ y e. Y ( # ` { x e. X | ps } ) ) $=
      ( wrex crab chash cfv ciun csu rabasiun fveq2i hashiun syl5eq ) ABDFJCEKZ
      LMDFBCEKZNZLMFUALMDOTUBLBCDEFPQADFUAGHIRS $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Words over a set - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d V v $.  $d W v $.
    $( A word of length 1 starts with a symbol.  (Contributed by Alexander van
       der Vekens, 20-Jul-2018.) $)
    wrdlen1 $p |- ( ( W e. Word V /\ ( # ` W ) = 1 )
                    -> E. v e. V ( W ` 0 ) = v ) $=
      ( cword wcel cc0 chash cfzo co wf c1 wceq cv wrex wrdf oveq2 fzo01 syl6eq
      cfv csn feq2d cop c0ex fsn2 risset eqcom rexbii bitri biimpi adantr sylbi
      wa syl6bi mpan9 ) CBDEFCGSZHIZBCJZUOKLZFCSZAMZLZABNZBCOURUQFTZBCJZVBURUPV
      CBCURUPFKHIVCUOKFHPQRUAVDUSBEZCFUSUBTLZULVBFBCUCUDVEVBVFVEVBVEUTUSLZABNVB
      AUSBUEVGVAABUTUSUFUGUHUIUJUKUMUN $.
  $}

  ${
    $d S l w x $.  $d V l w x $.
    $( Class substitution for the symbols of a word.  (Contributed by Alexander
       van der Vekens, 15-Jul-2018.) $)
    csbwrdg $p |- ( S e. V -> [_ S / x ]_ Word x = Word S ) $=
      ( vl vw wcel cv cword csb cc0 cfzo cn0 wrex cab df-word csbeq2i csbconstg
      co wf wsbc sbcrex sbcfg csbvarg feq123d bitrd rexbidv syl5bb abbidv csbab
      3eqtr4g syl5eq ) BCFZABAGZHZIABJDGKRZUMEGZSZDLMZENZIZBHZABUNUSEUMDOPULURA
      BTZENUOBUPSZDLMZENUTVAULVBVDEVBUQABTZDLMULVDUQADBLUAULVEVCDLULVEABUOIZABU
      MIZABUPIZSVCAUOUMUPCBUBULVFUOVGBVHUPABUPCQABUOCQABCUCUDUEUFUGUHURAEBUIEBD
      OUJUK $.
  $}

  $( A zero-based sequence is a word.  (Contributed by Alexander van der
     Vekens, 31-Jan-2018.) $)
  iswrd0i $p |- ( W : ( 0 ... L ) --> S -> W e. Word S ) $=
    ( cz wcel cc0 co wf cword wa c1 caddc cfzo fzval3 feq2d biimpa iswrdi sylbi
    cfz c0 syl wn wne cuz cfv fzn0 eluzelz necon1bi fzo0 eqcomi feq2i pm2.61ian
    syl6bi imp ) BDEZFBSGZACHZCAIEZUOUQJFBKLGZMGZACHZURUOUQVAUOUPUTACFBNOPAUSCQ
    UAUOUBZUQURVBUQTACHZURVBUPTACUOUPTUPTUCBFUDUEEUOFBUFFBUGRUHOVCFFMGZACHURTVD
    ACVDTFUIUJUKAFCQRUMUNUL $.

  $( A symbol at a position "outside" of a word.  (Contributed by Alexander van
     der Vekens, 26-May-2018.) $)
  wrdsymb0 $p |- ( ( W e. Word V /\ I e. ZZ )
                   -> ( ( I < 0 \/ ( # ` W ) <_ I ) -> ( W ` I ) = (/) ) ) $=
    ( wcel wa cc0 clt wbr cfv cle wo wn wceq wi cn0 wb biimpa xchnxbir sylibr
    cr cword cz chash cdm c0 cfzo co wf wrdf fdm syl lencl cn w3o zre 0re ltnle
    adantl olcd ianor elnn0z 3mix1d nn0re lenlt syl2an 3mix3d jaodan w3a 3ianor
    sylancl elfzo0 eleq2 notbid syl5ibr exp4c sylc imp ndmfv syl6 ) CBUADZAUBDZ
    EAFGHZCUCIZAJHZKZACUDZDZLZACIUEMVTWAWEWHNZVTWFFWCUFUGZMZWCODZWAWINVTWJBCUHW
    KBCUIWJBCUJUKBCULWKWLWAWEWHWLWAEZWEEZWHWKAWJDZLZWNAODZLZWCUMDZLZAWCGHZLZUNZ
    WPWMWBXCWDWMWBEZWRWTXBXDWALZFAJHZLZKZWRXDXGXEWMWBXGWAWBXGPZWLWAATDZFTDXIAUO
    ZUPAFUQVJURQUSWAXFEXHWQWAXFUTAVARSVBWMWDEXBWRWTWMWDXBWLWCTDXJWDXBPWAWCVCXKW
    CAVDVEQVFVGWQWSXAVHXCWOWQWSXAVIAWCVKRSWKWGWOWFWJAVLVMVNVOVPVQACVRVS $.

  $( A word is a function with a zero-based sequence of integers as domain.
     (Contributed by Alexander van der Vekens, 13-Apr-2018.) $)
  wrdfn $p |- ( W e. Word S -> W Fn ( 0 ..^ ( # ` W ) ) ) $=
    ( cword wcel cc0 chash cfv cfzo co wf wfn wrdf ffn syl ) BACDEBFGHIZABJBOKA
    BLOABMN $.

  ${
    $d U i $.  $d W i $.
    $( Two words are equal iff they have the same length and the same symbol at
       each position.  (Contributed by Alexander van der Vekens,
       13-Apr-2018.) $)
    wrdeq0 $p |- ( ( U e. Word V /\ W e. Word V )
          -> ( U = W <-> ( ( # ` U ) = ( # ` W ) /\ A. i e. ( 0 ..^ ( # ` U ) )
                                                 ( U ` i ) = ( W ` i ) ) ) ) $=
      ( cword wcel wa wceq cc0 chash cfv co cv wfn wrdfn cn0 lencl hashfzo0 syl
      cfzo wb eqfnfv2 syl2an fveq2 eqeqan12d syl5ib oveq2 impbid1 anbi1d bitrd
      wral ) ACEZFZDULFZGZADHZIAJKZTLZIDJKZTLZHZBMZAKVBDKHBURUKZGZUQUSHZVCGUMAU
      RNDUTNUPVDUAUNCAOCDOBURUTADUBUCUOVAVEVCUOVAVEVAURJKZUTJKZHUOVEURUTJUDUMUN
      VFUQVGUSUMUQPFVFUQHCAQUQRSUNUSPFVGUSHCDQUSRSUEUFUQUSITUGUHUIUJ $.
  $}

  $( A symbol within a word over a set belongs to this set.  (Contributed by
     Alexander van der Vekens, 28-Jun-2018.) $)
  wrdsymb $p |- ( ( P e. Word V /\ I e. ( 0 ..^ ( # ` P ) ) )
                  -> ( P ` I ) e. V ) $=
    ( cword wcel cc0 chash cfv cfzo co wrdf ffvelrnda ) ACDEFAGHIJCBACAKL $.

  $( The first symbol within a non-empty word over a set belongs to this set.
     (Contributed by Alexander van der Vekens, 28-Jun-2018.) $)
  wrdsymb1 $p |- ( ( P e. Word V /\ 1 <_ ( # ` P ) ) -> ( P ` 0 ) e. V ) $=
    ( cword wcel c1 chash cfv cle wbr cc0 cfzo co wa cn0 lencl elnnnn0c biimpri
    cn sylan lbfzo0 sylibr wrdsymb syldan ) ABCDZEAFGZHIZJJUEKLDZJAGBDUDUFMUERD
    ZUGUDUENDZUFUHBAOUHUIUFMUEPQSUETUAAJBUBUC $.

  ${
    $d S i $.  $d W i $.
    $( Two words are equal if and only if they have the same length and the
       same symbols at each position.  (Contributed by Alexander van der
       Vekens, 1-Jul-2018.) $)
    2wrdeq $p |- ( ( W e. Word V /\ S e. Word V ) -> ( W = S
            <-> ( ( # ` W ) = ( # ` S )
                  /\ A. i e. ( 0 ..^ ( # ` W ) ) ( W ` i ) = ( S ` i ) ) ) ) $=
      ( cword wcel wa chash cfv cn0 cc0 cfzo co wf wceq wral lencl anim12i wrdf
      cv wb 2ffzoeq syl2anc ) DCEZFZAUDFZGDHIZJFZAHIZJFZGKUGLMZCDNZKUILMCANZGDA
      OUGUIOBTZDIUNAIOBUKPGUAUEUHUFUJCDQCAQRUEULUFUMCDSCASRABDUGUICCUBUC $.
  $}

  $( A word with length at least 2 is not empty.  (Contributed by Alexander van
     der Vekens, 18-Jun-2018.) $)
  wrdlenge2n0 $p |- ( ( P e. Word V /\ 2 <_ ( # ` P ) ) -> P =/= (/) ) $=
    ( cword wcel c2 chash cfv cle wbr c0 wne cr wi wa cc0 clt 0re a1i imp wceq
    lencl nn0red w3a 2re simpl 3jca adantr 2pos simpr ltletr syl12anc ltne mpan
    ex wb hasheq0 adantl necon3bid syl5ib syld mpancom ) ABCZDZEAFGZHIZAJKZVDLD
    ZVCVEVFMVCVDBAUAUBVGVCNZVEOVDPIZVFVHVEVIVHVENZOLDZELDZVGUCZOEPIZVEVIVHVMVEV
    HVKVLVGVKVHQRVLVHUDRVGVCUEUFUGVNVJUHRVHVEUIVMVNVENVIOEVDUJSUKUNVIVDOKZVHVFV
    KVIVOQOVDULUMVHVDOAJVCVDOTAJTUOVGAVBUPUQURUSUTVAS $.

  ${
    $( A word of length 1 is a singleton word consisting of the first symbol of
       the word.  (Contributed by Alexander van der Vekens, 22-Jul-2018.) $)
    wrdl1s1 $p |- ( S e. V -> ( ( ( W e. Word V /\ ( # ` W ) = 1 )
                                /\ ( W ` 0 ) = S ) <-> W = <" S "> ) ) $=
      ( wcel cword chash cfv c1 wceq wa cc0 cs1 wi eqs1 s1eq eqeq2d ax-1 syl6bi
      eqeq1d anbi12d mpan9 com12 s1cl s1len jctir s1fv eleq1 fveq2 fveq1 impbid
      jca syl5ibrcom ) ABDZCBEZDZCFGZHIZJZKCGZAIZJZCALZIZVAUMVCURCUSLZIZUTUMVCM
      ZBCNUTVEVCVFUTVDVBCUSAOPVCUMQRUAUBUMVAVCVBUNDZVBFGZHIZJZKVBGZAIZJUMVJVLUM
      VGVIABUCAUDUEABUFUKVCURVJUTVLVCUOVGUQVICVBUNUGVCUPVHHCVBFUHSTVCUSVKAKCVBU
      ISTULUJ $.
  $}

  $( A word of length 2.  (Contributed by Alexander van der Vekens,
     27-Jul-2018.) $)
  wrdlen2 $p |- ( ( S e. V /\ T e. V ) -> ( W = { <. 0 , S >. , <. 1 , T >. }
                  -> ( ( W e. Word V /\ ( # ` W ) = 2 )
                       /\ ( ( W ` 0 ) = S /\ ( W ` 1 ) = T ) ) ) ) $=
    ( wcel wa cc0 c1 cpr wceq chash cfv c2 wf cvv a1i syl3anc adantr wb adantl
    cop cword cfzo co wne c0ex 1ex pm3.2i simpl ax-1ne0 necomi wi wss fzo0to2pr
    fprg eqcomi feq2d biimpa prssi syl2anc ex impcom feq1 mpbird mpancom iswrdi
    fss syl fveq2 wn neii intnanrd opthg mtbird neneqad opex hashprg mp1i mpbid
    sylan9eqr jca fvpr1g simpr fvpr2g fveq1 eqeq1d anbi12d ) ACEZBCEZFZDGAUAZHB
    UAZIZJZDCUBEZDKLZMJZFZGDLZAJZHDLZBJZFZFWJWNFZWRXCXDWOWQXDGMUCUDZCDNZWOGHIZA
    BIZWMNZXDXFXDGOEZHOEZFZWJGHUEZXIXLXDXJXKUFUGUHPWJWNUIXMXDHGUJUKZPGHABOOCCUO
    QXIXDFXFXECWMNZXDXIXOWJXIXOULWNWJXIXOWJXIFXEXHWMNZXHCUMZXOWJXIXPWJXGXEXHWMX
    GXEJWJXEXGUNUPPUQURWJXQXIABCUSRXEXHCWMVGUTVARVBXDXFXOSZXIWNXRWJXECDWMVCTTVD
    VECMDVFVHWNWJWPWMKLZMDWMKVIWJWKWLUEZXSMJZWJWKWLWJWKWLJZGHJZABJZFZWJYCYDYCVJ
    WJGHXNVKPVLWJXJWHYBYESXJWJUFPZWHWIUIZGAHBOCVMUTVNVOWKOEZWLOEZFXTYASWJYHYIGA
    VPHBVPUHWKWLOVQVRVSVTWAXDXCGWMLZAJZHWMLZBJZFZWJYNWNWJYKYMWJXJWHXMYKYFYGXMWJ
    XNPZGHABOCWBQWJXKWIXMYMXKWJUGPWHWIWCYOGHABOCWDQWARWNXCYNSWJWNWTYKXBYMWNWSYJ
    AGDWMWEWFWNXAYLBHDWMWEWFWGTVDWAVA $.

  $( Length of a prefix of a word reduced by a single symbol, analogous to
     ~ swrd0len .  (Contributed by Alexander van der Vekens, 4-Aug-2018.) $)
  swrd0len0 $p |- ( ( W e. Word V /\ N e. NN0 /\ ( # ` W ) = ( N + 1 ) )
                  -> ( # ` ( W substr <. 0 , N >. ) ) = N ) $=
    ( cword wcel cn0 chash cfv c1 caddc co wceq w3a cc0 cfz cop csubstr cle wbr
    simp1 id peano2nn0 nn0re lep1d elfz2nn0 syl3anbrc 3ad2ant2 wb eleq2d mpbird
    oveq2 3ad2ant3 swrd0len syl2anc ) CBDEZAFEZCGHZAIJKZLZMZUOANUQOKZEZCNAPQKGH
    ALUOUPUSTUTVBANUROKZEZUPUOVDUSUPUPURFEAURRSVDUPUAAUBUPAAUCUDAURUEUFUGUSUOVB
    VDUHUPUSVAVCAUQURNOUKUIULUJBCAUMUN $.

  $( A prefixing subword consisting of at least one symbol is not empty.
     (Contributed by Alexander van der Vekens, 4-Aug-2018.) $)
  swrdn0 $p |- ( ( W e. Word V /\ N e. NN /\ N <_ ( # ` W ) )
                  -> ( W substr <. 0 , N >. ) =/= (/) ) $=
    ( wcel cn cle wbr cc0 co c0 wne cfzo cn0 wi wa c1 cr ad2antlr syl wceq nnre
    cword chash cfv w3a cop csubstr cin lencl simpll nn0re ad2antrr nnge1 simpr
    1re a1i letrd elnnnn0c sylanbrc exp31 lbfzo0 sylibr biimpri 3ad2ant2 inelcm
    3imp syl2anc wfn wb wrdfn 3ad2ant1 fnresdisj cfz simp1 nnnn0 simp3 elfz2nn0
    cres syl3anbrc swrd0val eqeq1d bicomd bitr2d necon3bid mpbird ) CBUBDZAEDZA
    CUCUDZFGZUEZCHAUFUGIZJKHWHLIZHALIZUHZJKZWJHWLDZHWMDZWOWJWHEDZWPWFWGWIWRWFWH
    MDZWGWIWRNNBCUIZWSWGWIWRWSWGOZWIOZWSPWHFGWRWSWGWIUJXBPAWHPQDXBUOUPWGAQDWSWI
    AUARWSWHQDWGWIWHUKULWGPAFGWSWIAUMRXAWIUNUQWHURUSUTSVFWHVAVBWGWFWQWIWQWGAVAV
    CVDHWLWMVEVGWJWKJWNJWJWNJTZCWMVRZJTZWKJTZWJCWLVHZXCXEVIWFWGXGWIBCVJVKWLWMCV
    LSWJWFAHWHVMIDZXEXFVIWFWGWIVNWJAMDZWSWIXHWGWFXIWIAVOVDWFWGWSWIWTVKWFWGWIVPA
    WHVQVSWFXHOZXFXEXJWKXDJBCAVTWAWBVGWCWDWE $.

  $( Value of a symbol in the left half of a word concatenated with a single
     symbol.  (Contributed by Alexander van der Vekens, 5-Aug-2018.) $)
  ccats1val1 $p |- ( ( W e. Word V /\ S e. V /\ I e. ( 0 ..^ ( # ` W ) ) )
                     -> ( ( W concat <" S "> ) ` I ) = ( W ` I ) ) $=
    ( wcel cword cs1 cc0 chash cfv cfzo co cconcat wceq s1cl ccatval1 syl3an2 )
    ACEDCFZEAGZREBHDIJKLEBDSMLJBDJNACOCDSBPQ $.

  $( Value of the symbol concatenated with a word.  (Contributed by Alexander
     van der Vekens, 5-Aug-2018.) $)
  ccats1val2 $p |- ( ( W e. Word V /\ S e. V /\ I = ( # ` W ) )
                     -> ( ( W concat <" S "> ) ` I ) = S ) $=
    ( cword wcel chash cfv wceq w3a co cmin cc0 caddc 3ad2ant2 c1 cz syl oveq2i
    cfzo cs1 cconcat simp1 s1cl wa cn0 lencl clt wbr nn0z id peano2z ltp1d 3jca
    fzolb sylibr s1len syl6eleqr adantr wb eleq1 adantl mpbird 3adant2 ccatval2
    zre syl3anc oveq1 3ad2ant3 nn0cnd subidd 3ad2ant1 eqtrd fveq2d s1fv 3eqtrd
    ) DCEZFZACFZBDGHZIZJZBDAUAZUBKHZBVTLKZWCHZMWCHZAWBVRWCVQFZBVTVTWCGHZNKZTKZF
    ZWDWFIVRVSWAUCVSVRWHWAACUDOVRWAWLVSVRWAUEWLVTWKFZVRWMWAVRVTVTVTPNKZTKZWKVRV
    TUFFZVTWOFZCDUGZWPVTQFZWNQFZVTWNUHUIZJZWQWPWSXBVTUJWSWSWTXAWSUKVTULWSVTVTVF
    UMUNRVTWNUOUPRWJWNVTTWIPVTNAUQSSURUSWAWLWMUTVRBVTWKVAVBVCVDCDWCBVEVGWBWEMWC
    WBWEVTVTLKZMWAVRWEXCIVSBVTVTLVHVIVRVSXCMIWAVRVTVRVTWRVJVKVLVMVNVSVRWGAIWAAC
    VOOVP $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Words over a set - extension (concatenations)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( An element of a finite set of sequential integers up to the length of a
     word is an element of an extended finite set of sequential integers up to
     the length of a concatenation of this word with another word.
     (Contributed by Alexander van der Vekens, 28-Mar-2018.) $)
  elfzelfzccat $p |- ( ( A e. Word V /\ B e. Word V )
                       -> ( N e. ( 0 ... ( # ` A ) )
                            -> N e. ( 0 ... ( # ` ( A concat B ) ) ) ) ) $=
    ( cword wcel wa cc0 chash cfv cfz co caddc cconcat cn0 wi lencl elfzelfzadd
    syl2an ccatlen oveq2d eleq2d sylibrd ) ADEZFZBUDFZGZCHAIJZKLFZCHUHBIJZMLZKL
    ZFZCHABNLIJZKLZFUEUHOFUJOFUIUMPUFDAQDBQUHUJCRSUGUOULCUGUNUKHKDABTUAUBUC $.

  ${
    $d A x $.  $d B x $.  $d V x $.
    $( The concatenation of two words is a function over the half-open interval
       of integers having the sum of the lengths of the word as length.
       (Contributed by Alexander van der Vekens, 30-Mar-2018.) $)
    ccatvalfn $p |- ( ( A e. Word V /\ B e. Word V )
                  -> ( A concat B ) Fn ( 0 ..^ ( ( # ` A ) + ( # ` B ) ) ) ) $=
      ( vx cword wcel wa cconcat co cc0 chash cfv caddc cfzo cmin cif cmpt fvex
      cv wfn wceq ccatfval ifex eqid fnmpti fneq1 mpbiri syl ) ACEZFBUIFGABHIZD
      JAKLZBKLMINIZDSZJUKNIFZUMALZUMUKOIZBLZPZQZUAZUJULTZDABUIUIUBUTVAUSULTDULU
      RUSUNUOUQUMARUPBRUCUSUDUEULUJUSUFUGUH $.
  $}

  $( The symbol at a given position in a concatenated word.  (Contributed by
     Alexander van der Vekens, 26-May-2018.) $)
  ccatsymb $p |- ( ( S e. Word B /\ T e. Word B /\ I e. ZZ )
                   -> ( ( S concat T ) ` I ) = if ( I < ( # ` S ) ,
                                   ( S ` I ) , ( T ` ( I - ( # ` S ) ) ) ) ) $=
    ( wcel cz cfv clt wbr co cc0 cle wa wceq wi 3adant3 cr adantr ex c0 w3a cif
    cword chash cmin cconcat id ad2antrl cn0 cn simp3 simpl elnn0z sylanbrc 0re
    cfzo a1i adantl lencl nn0red lelttr syl3anc nn0zd jctild 3adant2 exp3acom23
    zre impcom elnnz sylibr simpr elfzo0 syl3anbrc df-3an ccatval1 eqcomd wn wb
    imp syl jca 3ad2ant3 ltnle orcd wrdsymb0 sylc ccatcl eqtr4d sylbird pm2.61i
    wo com12 caddc cuz lenlt syl2an biimpri eluz2 sylan zaddcl ccatval2 readdcl
    elfzo2 lenltd ccatlen eqbrtrd olcd simp2 zsubcl sylan2 ancoms syl3an biimpa
    leaddsub2 ifeqda ) BAUCZEZCXPEZDFEZUAZDBUDGZHIZDBGZDYAUEJZCGZUBDBCUFJZGZXTY
    BYCYEYGKDLIZXTYBMZYCYGNZOYHYIYJYHYIMZXQXRDKYAUPJEZUAZYJYKXQXRMZYLYMXTYNYHYB
    XQXRYNXSYNUGPZUHYKDUIEZYAUJEZYBYLYKXSYHYPXTXSYHYBXQXRXSUKZUHYHYIULDUMUNYKYA
    FEZKYAHIZMZYQYIYHUUAXTYBYHUUAOXTYHYBUUAXQXSYHYBMZUUAOXRXQXSMZUUBYTYSUUCKQEZ
    DQEZYAQEZUUBYTOUUDUUCUOUQXSUUEXQDVGZURXQUUFXSXQYAABUSZUTZRKDYAVAVBXQYSXSXQY
    AUUHVCZRVDVEVFVSVHYAVIVJYIYBYHXTYBVKURDYAVLVMXQXRYLVNUNYMYGYCABCDVOVPVTSYIY
    HVQZYJXTUUKYJOYBXTUUKDKHIZYJXTUUEUUDMZUULUUKVRXSXQUUMXRXSUUEUUDUUGUUDXSUOUQ
    WAWBDKWCVTXTUULYJXTUULMZYCTYGUUNUUCUULYADLIZWKYCTNXTUUCUULXQXSUUCXRUUCUGVER
    UUNUULUUOXTUULVKZWDDABWEWFUUNYFXPEZXSMZUULYFUDGZDLIZWKZYGTNZXTUURUULXTUUQXS
    XQXRUUQXSABCWGPYRWAZRUUNUULUUTUUPWDDAYFWEZWFWHSWIRWLWJXTYBVQZMZYGYEDYACUDGZ
    WMJZHIZUVFYGYENZOUVIUVFUVJUVIUVFMZXQXRDYAUVHUPJEZUAZUVJUVKYNUVLUVMXTYNUVIUV
    EYOUHUVKDYAWNGEZUVHFEZUVIUVLUVFUVNUVIXTUVEUVNXQXSUVEUVNOZXRXQYSXSUVPUUJYSXS
    MZUVEUUOUVNYSUUFUUEUUOUVEVRXSYAVGUUGYADWOWPUVQUUOUVNUVQUUOMZYSXSUUOUAZUVNUV
    SUVRYSXSUUOVNWQYADWRVJSWIWSVEVSURXTUVOUVIUVEXQXRUVOXSXQYSUVGFEUVOXRUUJXRUVG
    ACUSZVCYAUVGWTWPPUHUVIUVFULDYAUVHXCVMXQXRUVLVNUNABCDXAVTSUVFUVIVQZUVJXTUWAU
    VJOUVEXTUWAUVHDLIZUVJXTUVHDXQXRUVHQEZXSXQUUFUVGQEZUWCXRUUIXRUVGUVTUTZYAUVGX
    BWPPXSXQUUEXRUUGWBXDXTUWBUVJXTUWBMZYGTYEUWFUURUVAUVBXTUURUWBUVCRUWFUUTUULUW
    FUUSUVHDLXTUUSUVHNZUWBXQXRUWGXSABCXEPRXTUWBVKXFXGUVDWFUWFXRYDFEZMZYDKHIZUVG
    YDLIZWKYETNXTUWIUWBXTXRUWHXQXRXSXHXQXSUWHXRXSXQUWHXQXSYSUWHUUJDYAXIXJXKVEWA
    RUWFUWKUWJXTUWBUWKXQUUFXRUWDXSUUEUWBUWKVRUUIUWEUUGYAUVGDXNXLXMXGYDACWEWFWHS
    WIRWLWJVPXOVP $.

  $( The length of a non-empty word is the length of the word concatenated with
     its first symbol minus 1.  (Contributed by Alexander van der Vekens,
     28-Jun-2018.) $)
  wrdlenccats1lenm1 $p |- ( ( P e. Word V /\ 1 <_ ( # ` P ) ) ->
                  ( # ` P ) = ( ( # ` ( P concat <" ( P ` 0 ) "> ) ) - 1 ) ) $=
    ( cword wcel c1 chash cfv cle wbr wa caddc co cmin cc0 cs1 cconcat wceq a1i
    eqcomd oveq1d s1len oveq2d lencl nn0cnd ax-1cn pncand adantr wrdsymb1 s1cld
    cc ccatlen syldan 3eqtr3d ) ABCZDZEAFGZHIZJZUPEKLZEMLZUPNAGZOZFGZKLZEMLUPAV
    BPLFGZEMLURUSVDEMUREVCUPKURVCEVCEQURVAUARSUBTUOUTUPQUQUOUPEUOUPBAUCUDEUJDUO
    UERUFUGURVDVEEMURVEVDUOUQVBUNDVEVDQURVABABUHUIBAVBUKULSTUM $.

  ${
    $d V v x y z $.  $d Y v y z $.  $d Z z $.
    elovmpt2wrd.o $e |- O = ( v e. _V , y e. _V |-> { z e. Word v | ph } ) $.
    $( Implications for the value of an operation defined by the maps-to
       notation with a class abstration of words as a result having an
       element.  (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    elovmpt2wrd $p |- ( Z e. ( V O Y )
                        -> ( V e. _V /\ Y e. _V /\ Z e. Word V ) ) $=
      ( vx wcel cvv cv cword csb w3a crab cmpt2 wa adantr co wceq csbwrdg rabeq
      eqcomd syl mpt2eq3ia eqtri wrdexg elovmpt2rab1 wb eleq2d id 3expia sylbid
      eqeltrd 3impia ) HFGEUAKFLKZGLKZHJFJMNZOZKZPURUSHFNZKZPZADBCJUTEFGHEDBLLA
      CDMZNZQZRDBLLACJVFUTOZQZRIDBLLVHVJVFLKZBMLKZSVGVIUBZVHVJUBVKVMVLVKVIVGJVF
      LUCUETACVGVIUDUFUGUHURVALKUSURVAVCLJFLUCZFLUIUPTUJURUSVBVEURUSSVBVDVEURVB
      VDUKUSURVAVCHVNULTURUSVDVEVEUMUNUOUQUF $.
  $}

  ${
    $d V n v x y z $.  $d N n z $.  $d Y n v y z $.  $d Z z $.
    elovmptnn0wrd.o $e |- O = ( v e. _V , y e. _V
                |-> ( n e. NN0 |-> { z e. Word v | ph } ) ) $.
    $( Implications for the value of an operation defined by the maps-to
       notation with a function of nonnegative integers into a class
       abstraction of words as a result having an element.  (Contributed by
       Alexander van der Vekens, 16-Jul-2018.) $)
    elovmptnn0wrd $p |- ( Z e. ( ( V O Y ) ` N ) -> ( ( V e. _V /\ Y e. _V )
                        /\ ( N e. NN0 /\ Z e. Word V ) ) ) $=
      ( vx wcel cvv wa cn0 csb cv cword adantr co cfv crab cmpt cmpt2 csbconstg
      eqcomd csbwrdg rabeq syl mpteq12dva mpt2eq3ia eqtri nn0ex syl6eqel wrdexg
      wceq eqeltrd elovmpt3rab1 wb eleq2d anbi12d biimpd imdistani ) JFHIGUAUBM
      HNMZINMZOZFBHPQZMZJLHLRSZQZMZOZOVGFPMZJHSZMZOZOADBEJBLPVJGHIFCGDBNNEPACDR
      ZSZUCZUDZUEDBNNEBVRPQZACLVRVJQZUCZUDZUEKDBNNWAWEVRNMZBRNMZOZEPVTWBWDWFPWB
      UQWGWFWBPBVRPNUFUGTWHERPMZOVSWCUQZVTWDUQWHWJWIWFWJWGWFWCVSLVRNUHUGTTACVSW
      CUIUJUKULUMVEVHNMVFVEVHPNBHPNUFZUNUOTVEVKNMVFVEVKVONLHNUHZHNUPURTUSVGVMVQ
      VGVMVQVGVIVNVLVPVEVIVNUTVFVEVHPFWKVATVEVLVPUTVFVEVKVOJWLVATVBVCVDUJ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Words over a set - extension (subwords)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d F i $.  $d L i $.  $d V i $.  $d W i $.
    $( The value of the subword extractor is the empty set (undefined) if the
       range is not valid.  (Contributed by Alexander van der Vekens,
       16-Mar-2018.) $)
    swrdltnd $p |- ( ( W e. Word V /\ F e. ZZ /\ L e. ZZ )
                     -> ( L <_ F -> ( W substr <. F , L >. ) = (/) ) ) $=
      ( vi wcel cz cle wbr co c0 wceq wa cfzo cc0 cmpt adantr wb fzon syl cword
      w3a cop csubstr cdm wss cmin caddc cfv cif swrdval simpr 3simpc mpbid 0ss
      cv syl6eqss iftrue cr suble0 syl2anr biimpar zsubcl ancoms jctil 3adantl1
      zre 0z mpteq1 mpt0 syl6eq 3eqtrd ex ) DCUAZFZAGFZBGFZUBZBAHIZDABUCUDJZKLV
      RVSMZVTABNJZDUEZUFZEOBAUGJZNJZEUPAUHJDUIZPZKUJZWHKVRVTWILVSEDABVNUKQWAWDW
      IWHLWAWBKWCWAVSWBKLZVRVSULWAVPVQMZVSWJRVRWKVSVOVPVQUMQABSTUNWCUOUQWDWHKUR
      TWAWHEKWGPZKWAWFKLZWHWLLVPVQVSWMVOWKVSMZWEOHIZWMWKWOVSVQBUSFAUSFWOVSRVPBV
      GAVGBAUTVAVBWNOGFZWEGFZMZWOWMRWKWRVSWKWQWPVQVPWQBAVCVDVHVEQOWESTUNVFEWFKW
      GVITEWGVJVKVLVM $.

    $( The value of the subword extractor is the empty set (undefined) if the
       range is not valid.  (Contributed by Alexander van der Vekens,
       16-Mar-2018.) $)
    swrdnd $p |- ( ( W e. Word V /\ F e. ZZ /\ L e. ZZ )
                   -> ( ( F < 0 \/ L <_ F \/ ( # ` W ) < L )
                        -> ( W substr <. F , L >. ) = (/) ) ) $=
      ( vi cle wbr wcel cc0 clt co c0 wceq wi com13 wn wa cfzo cr wb cz w3a cfv
      cword chash w3o cop csubstr swrdltnd a1i wo 3orcomb df-3or bitri cdm cmin
      wss caddc cmpt cif swrdval adantl simpl2 simpl3 zre anim12i 3adant1 ltnle
      cv syl biimpar ssfzo12 syl3anc 0re lenltd 3ad2ant2 biimpd cn0 lencl nn0re
      lenlt syl2anr sylan 3adant2 anim12d adantr syld ioran syl6ibr con2d imp31
      ex wrdf fdm sseq2d notbid 3ad2ant1 mpbird iffalse eqtrd com23 pm2.24 jaoi
      wf a1d sylbi pm2.61i ) BAFGZDCUDZHZAUAHZBUAHZUBZAIJGZXHDUEUCZBJGZUFZDABUG
      UHKZLMZNNXQXMXHXSXMXHXSNNXQABCDUIUJOXQXMXHPZXSXQXNXPUKZXHUKZXMXTXSNZNZXQX
      NXPXHUFYBXNXHXPULXNXPXHUMUNYAYDXHYAXTXMXSYAXTXMXSNYAXTQZXMXSYEXMQZXRABRKZ
      DUOZUQZEIBAUPKRKEVIAURKDUCUSZLUTZLXMXRYKMYEEDABXIVAVBYFYIPZYKLMYFYLYGIXOR
      KZUQZPZYAXTXMYOXMXTYAYOXMXTYAYONXMXTQZYNYAYPYNXNPZXPPZQZYAPYPYNIAFGZBXOFG
      ZQZYSYPXKXLABJGZYNUUBNXJXKXLXTVCXJXKXLXTVDXMUUCXTXMASHZBSHZQZUUCXTTXKXLUU
      FXJXKUUDXLUUEAVEZBVEZVFVGABVHVJVKABIXOVLVMXMUUBYSNXTXMYTYQUUAYRXMYTYQXKXJ
      YTYQTXLXKIAISHXKVNUJUUGVOVPVQXMUUAYRXJXLUUAYRTZXKXJXOVRHZXLUUICDVSXLUUEXO
      SHUUIUUJUUHXOVTBXOWAWBWCWDVQWEWFWGXNXPWHWIWJWLOWKXMYLYOTZYEXJXKUUKXLXJYIY
      NXJYHYMYGXJYMCDXDYHYMMCDWMYMCDWNVJWOWPWQVBWRYIYJLWSVJWTWLWLXAXHYCXMXHXSXB
      XEXCXFOXG $.
  $}

  ${
    $d F x $.  $d L x $.
    $( A subword of an empty set is always the empty set.  REMARK:  The
       antecedent ` ( F e. ZZ /\ L e. ZZ ) ` should not be necessary!
       (Contributed by Alexander van der Vekens, 31-Mar-2018.) $)
    swrd0 $p |- ( ( F e. ZZ /\ L e. ZZ )
                  -> ( (/) substr <. F , L >. ) = (/) ) $=
      ( vx wbr cz wcel wa c0 co wceq cvv w3a cc0 clt cfv a1i 3jca wn cfzo wss
      cle cop csubstr wi cword chash w3o simpl simpr 3mix2 swrdnd syl2an expcom
      wrd0 imp cdm cmin caddc cmpt cif 0ex adantl swrdval syl ss0b fzon biimprd
      cv syl5bi con3d impcom dm0 sseq2i sylnibr iffalse eqtrd ex pm2.61i ) BAUA
      DZAEFZBEFZGZHABUBUCIZHJZUDWBVSWDWBHKUEFZVTWALZAMNDZVSHUFOBNDZUGZWDVSWBWEV
      TWAWEWBKUNPVTWAUHZVTWAUIZQVSWGWHUJWFWIWDABKHUKUOULUMVSRZWBWDWLWBGZWCABSIZ
      HUPZTZCMBAUQISICVHAURIHOUSZHUTZHWMHKFZVTWALZWCWRJWBWTWLWBWSVTWAWSWBVAPWJW
      KQVBCHABKVCVDWMWPRWRHJWMWNHTZWPWBWLXARWBXAVSXAWNHJZWBVSWNVEWBVSXBABVFVGVI
      VJVKWOHWNVLVMVNWPWQHVOVDVPVQVR $.
  $}

  $( Length of a right-anchored subword.  (Contributed by Alexander van der
     Vekens, 5-Apr-2018.) $)
  swrdrlen $p |- ( ( S e. Word A /\ F e. ( 0 ... ( # ` S ) ) )
           -> ( # ` ( S substr <. F , ( # ` S ) >. ) ) = ( ( # ` S ) - F ) ) $=
    ( cword wcel cc0 chash cfv cfz cop csubstr cmin wceq cn0 lencl nn0fz0 sylib
    co adantr swrdlen mpd3an3 ) BADEZCFBGHZIRZEZUCUDEZBCUCJKRGHUCCLRMUBUFUEUBUC
    NEUFABOUCPQSABCUCTUA $.

  $( The sum of the lengths of two parts of a word is the length of the word.
     (Contributed by Alexander van der Vekens, 1-Apr-2018.) $)
  addlenrevswrd $p |- ( ( W e. Word V /\ M e. ( 0 ... ( # ` W ) ) )
                       -> ( ( # ` ( W substr <. M , ( # ` W ) >. ) )
                          + ( # ` ( W substr <. 0 , M >. ) ) ) = ( # ` W ) ) $=
    ( cword wcel cc0 chash cfv cfz co wa cop csubstr caddc cmin wceq cn0 cle cc
    syl2an wbr w3a elfz2nn0 nn0fz0 biimpi 3ad2ant2 sylbi adantl swrdlen mpd3an3
    swrd0len oveq12d cz lencl elfzelz nn0cn zcn npcan eqtrd ) CBDEZAFCGHZIJZEZK
    ZCAVALMJGHZCFALMJGHZNJVAAOJZANJZVAVDVEVGVFANUTVCVAVBEZVEVGPVCVIUTVCAQEZVAQE
    ZAVARUAZUBVIAVAUCVKVJVIVLVKVIVAUDUEUFUGUHBCAVAUIUJBCAUKULUTVKAUMEZVHVAPZVCB
    CUNAFVAUOVKVASEASEVNVMVAUPAUQVAAURTTUS $.

  ${
    $d A x $.  $d F x $.  $d L x $.  $d S x $.
    $( Value of the subword extractor as function with domain.  (Contributed by
       Alexander van der Vekens, 28-Mar-2018.) $)
    swrdvalfn $p |- ( ( S e. Word A /\ F e. ( 0 ... L )
                                    /\ L e. ( 0 ... ( # ` S ) ) )
                      -> ( S substr <. F , L >. ) Fn ( 0 ..^ ( L - F ) ) ) $=
      ( vx cword wcel cc0 cfz co chash cfv w3a cop csubstr cmin cfzo caddc wfn
      cv cmpt wceq swrdval2 fvex eqid fnmpti fneq1 mpbiri syl ) BAFGCHDIJGDHBKL
      IJGMBCDNOJZEHDCPJQJZETCRJZBLZUAZUBZUJUKSZEABCDUCUOUPUNUKSEUKUMUNULBUDUNUE
      UFUKUJUNUGUHUI $.
  $}

  $( Lemma for ~ swrdvalodm .  (Contributed by Alexander van der Vekens,
     24-May-2018.) $)
  swrdvalodmlem1 $p |- ( ( N e. NN0 /\ A e. ZZ /\ B e. ZZ )
                         -> ( ( N <_ A \/ B <_ 0 )
                            -> ( ( A ..^ B ) C_ ( 0 ..^ N ) -> B <_ A ) ) ) $=
    ( wcel cz w3a cle wbr cc0 cfzo co wi wa wn cr zre 3adant1 syl3anc letr imp
    cn0 wo wss clt simpl2 simpl3 wb ltnle syl2an biimpar ssfzo12 adantl 0re a1i
    adantr exp3acom23 con3d ex com23 nn0re 3anim123i 3coml syl expdimp impancom
    anim12d ioran ancom bitri syl6ibr syld con2d con4d ) CUADZAEDZBEDZFZCAGHZBI
    GHZUBZABJKICJKUCZBAGHZLVQVTMWBWAVQWBNZVTWANVQWCMZWAVTWDWAIAGHZBCGHZMZVTNZWD
    VOVPABUDHZWAWGLVNVOVPWCUEVNVOVPWCUFVQWIWCVOVPWIWCUGZVNVOAODZBODZWJVPAPZBPZA
    BUHUIQUJABICUKRWDWGVSNZVRNZMZWHWDWEWOWFWPVQWCWEWOLVQWEWCWOVOVPWEWCWOLZLVNVO
    VPMZWEWRWSWEMVSWBWSWEVSWBLWSVSWEWBWSWLIODZWKVSWEMWBLVPWLVOWNULWTWSUMUNVOWKV
    PWMUOBIASRUPTUQURQUSTVQWFWCWPVQWFMVRWBVQWFVRWBVQWLCODZWKFZWFVRMWBLVPVNVOXBV
    PWLVNXAVOWKWNCUTWMVAVBBCASVCVDUQVEVFWHWPWOMWQVRVSVGWPWOVHVIVJVKVLVEVMUR $.

  ${
    $d A x $.  $d B x $.  $d V x $.  $d W x $.
    $( Value of the subword extractor outside its intended domain.
       (Contributed by Alexander van der Vekens, 26-May-2018.) $)
    swrdvalodm2 $p |- ( ( W e. Word V /\ A e. ZZ /\ B e. ZZ )
                        -> ( ( B <_ A \/ ( # ` W ) < B \/ A < 0 )
                             -> ( W substr <. A , B >. ) = (/) ) ) $=
      ( vx cle wbr clt cc0 wcel w3a co c0 wceq wi wn wa cfzo cr com12 chash cfv
      w3o cword cz cop csubstr wo 3orass pm2.24 cdm wss cmin caddc cmpt swrdval
      cv cif ad2antrr cn0 wf wrdf fdm syl lencl 3anass simpll simplr zre syl2an
      ltnle biimpar 3jca expcom adantr 3adant1 imp ssfzo12 nn0re syl2anr pm2.21
      lenlt syl6bi 3adant2 adantl com13 a1d 0re a1i lenltd 3ad2ant2 jaoi impcom
      syld sylanbr con3and sseq2 notbid syl5ibr exp3a exp4c sylc 3impib iffalse
      wb eqtrd ex com23 jaoi3 swrdltnd pm2.61d2 sylbi ) BAFGZDUAUBZBHGZAIHGZUCZ
      DCUDZJZAUEJZBUEJZKZDABUFUGLZMNZXQXMXOXPUHZUHZYBYDOZXMXOXPUIYFXMYGXMXMPZYG
      OYEXMYGUJYHYEQZYBYHYDYBYIYHYDOYBYIQZYHYDYJYHQZYCABRLZDUKZULZEIBAUMLRLEUQA
      UNLDUBUOZMURZMYBYCYPNYIYHEDABXRUPUSYKYNPZYPMNYJYHYQYBYIYHYQOZXSXTYAYIYROZ
      XSYMIXNRLZNZXNUTJZXTYAQZYSOXSYTCDVAUUACDVBYTCDVCVDCDVEUUAUUBUUCYIYRUUAUUB
      UUCQZYIQZYHYQUUEYHQYQUUAYLYTULZPUUEUUFXMUUDUUBXTYAKZYIUUFXMOUUBXTYAVFUUGY
      IQZUUFIAFGZBXNFGZQZXMUUHXTYAABHGZKZUUFUUKOUUGYIUUMXTYAYIUUMOUUBYIUUCUUMYH
      UUCUUMOYEUUCYHUUMUUCYHQXTYAUULXTYAYHVGXTYAYHVHUUCUULYHXTASJBSJZUULYHXEYAA
      VIZBVIZABVKVJVLVMVNVOTVPVQABIXNVRVDYIUUGUUKXMOZYEYHUUGUUQOZXOYHUUROXPXOUU
      RYHUUKUUGXOXMUUJUUGXOXMOZOUUIUUGUUJUUSUUBYAUUJUUSOXTUUBYAQUUJXOPZUUSYAUUN
      XNSJUUJUUTXEUUBUUPXNVSBXNWBVTXOXMWAWCWDTWEWFWGXPUURYHUUKUUGXPXMUUIUUGXPXM
      OZOUUJUUGUUIUVAXTUUBUUIUVAOYAXTUUIXPPUVAXTIAISJXTWHWIUUOWJXPXMWAWCWKTVOWF
      WGWLWMWMWNWOWPUUAYNUUFYMYTYLWQWRWSWTXAXBXCVQVQYNYOMXDVDXFXGVNXHXIYBXMYDAB
      CDXJTXKXLT $.

    $( Value of the subword extractor outside its intended domain.
       (Contributed by Alexander van der Vekens, 24-May-2018.) $)
    swrdvalodm $p |- ( ( W e. Word V /\ A e. ZZ /\ B e. ZZ )
                       -> ( ( B <_ A \/ ( # ` W ) <_ A \/ B <_ 0 )
                            -> ( W substr <. A , B >. ) = (/) ) ) $=
      ( vx cle wbr cfv cc0 wcel cz w3a co c0 wceq wi wn wa cfzo imp chash cword
      w3o cop csubstr wo 3orass pm2.24 cdm wss cmin caddc cmpt swrdval ad2antrr
      cv cif cn0 wrdf fdm syl lencl 3anass swrdvalodmlem1 sylanbr con3and sseq2
      wf notbid syl5ibr exp3a exp4c sylc 3impib iffalse eqtrd expcom com23 jaoi
      ex swrdltnd com12 pm2.61d2 sylbi ) BAFGZDUAHZAFGZBIFGZUCZDCUBZJZAKJZBKJZL
      ZDABUDUEMZNOZWIWEWGWHUFZUFZWNWPPZWEWGWHUGWRWEWSWEWEQZWSPWQWEWSUHWQWNWTWPW
      NWQWTWPPWNWQRZWTWPXAWTRZWOABSMZDUIZUJZEIBAUKMSMEUPAULMDHUMZNUQZNWNWOXGOWQ
      WTEDABWJUNUOXBXEQZXGNOXAWTXHWNWQWTXHPZWKWLWMWQXIPZWKXDIWFSMZOZWFURJZWLWMR
      ZXJPWKXKCDVHXLCDUSXKCDUTVACDVBXLXMXNWQXIXLXMXNRZWQRZWTXHXPWTRXHXLXCXKUJZQ
      XPXQWEXOXMWLWMLZWQXQWEPZXMWLWMVCXRWQXSABWFVDTVEVFXLXEXQXDXKXCVGVIVJVKVLVM
      VNTTXEXFNVOVAVPVTVQVRVSWNWEWPABCDWAWBWCWDWB $.
  $}

  $( The length of two reversely concatenated parts of a word is the length of
     the word.  (Contributed by Alexander van der Vekens, 1-Apr-2018.) $)
  lenrevcctswrd $p |- ( ( W e. Word V /\ M e. ( 0 ... ( # ` W ) ) )
                -> ( # ` ( ( W substr <. M , ( # ` W ) >. )
                           concat ( W substr <. 0 , M >. ) ) ) = ( # ` W ) ) $=
    ( cword wcel cc0 chash cfv cfz co cop csubstr cconcat caddc wceq swrdcl jca
    wa adantr ccatlen syl addlenrevswrd eqtrd ) CBDZEZAFCGHZIJEZRZCAUFKLJZCFAKL
    JZMJGHZUIGHUJGHNJZUFUHUIUDEZUJUDEZRZUKULOUEUOUGUEUMUNBCAUFPBCFAPQSBUIUJTUAA
    BCUBUC $.

  $( A non-empty word is the prefix of the word concatenated with its first
     symbol.  (Contributed by Alexander van der Vekens, 28-Jun-2018.) $)
  ccats1swrdid $p |- ( ( P e. Word V /\ 1 <_ ( # ` P ) ) ->
           P = ( ( P concat <" ( P ` 0 ) "> ) substr <. 0 , ( # ` P ) >. ) ) $=
    ( cword wcel c1 chash cfv cle wbr cc0 cs1 cconcat cop csubstr wceq wrdsymb1
    wa co s1cld swrdccat1 syldan eqcomd ) ABCZDZEAFGZHIZQZAJAGZKZLRJUEMNRZAUDUF
    UIUCDUJAOUGUHBABPSBAUITUAUB $.

  $( A symbol in an left-anchored subword, indexed using the subword's
     indices.  (Contributed by Alexander van der Vekens, 16-Jun-2018.) $)
  swrd0fv $p |- ( ( S e. Word A /\ L e. ( 0 ... ( # ` S ) )
                    /\ X e. ( 0 ..^ L ) ) ->
                              ( ( S substr <. 0 , L >. ) ` X ) = ( S ` X ) ) $=
    ( cword wcel cc0 chash cfv cfz co cfzo w3a cop csubstr caddc cmin wceq zcnd
    syl simp1 cn0 elfznn0 0elfz 3ad2ant2 wa elfzelz subid1 eqcomd adantl oveq2d
    simp2 eleq2d biimp3a swrdfv syl31anc elfzoelz addid1d 3ad2ant3 fveq2d eqtrd
    cc ) BAEFZCGBHIZJKFZDGCLKZFZMZDBGCNOKIZDGPKZBIZDBIVHVCGGCJKFZVEDGCGQKZLKZFZ
    VIVKRVCVEVGUAVEVCVLVGVECUBFVLCVDUCCUDTUEVCVEVGULVCVEVGVOVCVEUFZVFVNDVPCVMGL
    VECVMRZVCVECVBFZVQVECCGVDUGSVRVMCCUHUITUJUKUMUNABGCDUOUPVHVJDBVGVCVJDRVEVGD
    VGDDGCUQSURUSUTVA $.

  $( The first symbol in a left-anchored subword.  (Contributed by Alexander
     van der Vekens, 16-Jun-2018.) $)
  swrd0fv0 $p |- ( ( S e. Word A /\ L e. ( 1 ... ( # ` S ) ) )
                           -> ( ( S substr <. 0 , L >. ) ` 0 ) = ( S ` 0 ) ) $=
    ( cword wcel c1 chash cfv cfz co wa cc0 cfzo cop csubstr wceq simpl cuz wss
    adantl cn0 1nn0 elnn0uz mpbi fzss1 ax-mp sseli elfznn lbfzo0 sylibr swrd0fv
    cn syl3anc ) BADEZCFBGHZIJZEZKUNCLUOIJZEZLLCMJEZLBLCNOJHLBHPUNUQQUQUSUNUPUR
    CFLRHEZUPURSFUAEVAUBFUCUDFLUOUEUFUGTUQUTUNUQCULEUTCUOUHCUIUJTABCLUKUM $.

  $( A symbol in a word truncated by one symbol.  (Contributed by Alexander van
     der Vekens, 16-Jun-2018.) $)
  swrdtrcfv $p |- ( ( S e. Word A /\ S =/= (/)
                         /\ X e. ( 0 ..^ ( ( # ` S ) - 1 ) ) )
           -> ( ( S substr <. 0 , ( ( # ` S ) - 1 ) >. ) ` X ) = ( S ` X ) ) $=
    ( cword wcel chash cfv c1 cmin co cc0 cfz c0 wne cfzo cop csubstr cn0 syl
    wa wceq w3a cn lennncl cle wbr 1nn0 nnnn0 nnge1 elfz2nn0 syl3anbrc elfz1end
    a1i biimpi jca 3adant3 fz0fzdiffz0 swrd0fv syld3an2 ) BADEZBFGZHIJZKVALJZEZ
    BMNZCKVBOJEZCBKVBPQJGCBGUAUTVEVFUBHVCEZVAHVALJEZTZVDUTVEVIVFUTVETVAUCEZVIAB
    UDVJVGVHVJHREZVAREHVAUEUFVGVKVJUGUMVAUHVAUIHVAUJUKVJVHVAULUNUOSUPVAHVAUQSAB
    VBCURUS $.

  $( The first symbol in a word truncated by one symbol.  (Contributed by
     Alexander van der Vekens, 16-Jun-2018.) $)
  swrdtrcfv0 $p |- ( ( S e. Word A /\ 2 <_ ( # ` S ) )
           -> ( ( S substr <. 0 , ( ( # ` S ) - 1 ) >. ) ` 0 ) = ( S ` 0 ) ) $=
    ( cword wcel c2 chash cfv cle wbr wa c0 wne cc0 c1 cmin co wceq wb adantr
    cz cfzo cop csubstr simpl cn0 wi lencl nn0n0n1ge2b hasheq0 adantl necon3bid
    biimpd adantrd sylbird mpancom imp cn cuz a1i nn0zd simpr syl3anbrc uz2m1nn
    2z eluz2 syl lbfzo0 sylibr swrdtrcfv syl3anc ) BACZDZEBFGZHIZJZVLBKLZMMVMNO
    PZUAPDZMBMVQUBUCPGMBGQVLVNUDVLVNVPVMUEDZVLVNVPUFABUGZVSVLJZVNVMMLZVMNLZJZVP
    VSWDVNRVLVMUHSWAWBVPWCWAWBVPWAVMMBKVLVMMQBKQRVSBVKUIUJUKULUMUNUOUPVOVQUQDZV
    RVOVMEURGDZWEVOETDZVMTDZVNWFWGVOVDUSVLWHVNVLVMVTUTSVLVNVAEVMVEVBVMVCVFVQVGV
    HABMVIVJ $.

  ${
    $d N i $.  $d U i $.  $d V i $.  $d W i $.
    $( If two words have the same prefix, their symbols are identical with this
       prefix.  (Contributed by Alexander van der Vekens, 5-Jul-2018.) $)
    swdeq $p |- ( ( ( U e. Word V /\ W e. Word V )
                    /\ ( N e. NN0 /\ N <_ ( # ` U ) /\ N <_ ( # ` W ) ) )
                  -> ( ( U substr <. 0 , N >. ) = ( W substr <. 0 , N >. )
                       -> A. i e. ( 0 ..^ N ) ( U ` i ) = ( W ` i ) ) ) $=
      ( wcel wa cn0 chash cfv cle wbr csubstr co wceq cfzo wral swrdcl ad2antrr
      cc0 cword w3a cop cv wb anim12i adantr wrdeq0 syl cfz simpll simpr1 lencl
      simpr2 elfz2nn0 syl3anbrc swrd0len oveq2d raleqdv swrd0fv syl3anc simp-4r
      jca simpr ad2antlr simpr3 eqeq12d ralbidva bitrd biimpd expimpd sylbid )
      ADUAZFZEVMFZGZCHFZCAIJZKLZCEIJZKLZUBZGZATCUCZMNZEWDMNZOZWEIJZWFIJOZBUDZWE
      JZWJWFJZOZBTWHPNZQZGZWJAJZWJEJZOZBTCPNZQZWCWEVMFZWFVMFZGZWGWPUEVPXDWBVNXB
      VOXCDATCRDETCRUFUGWEBDWFUHUIWCWIWOXAWCWIGZWOXAXEWOWMBWTQXAXEWMBWNWTXEWHCT
      PXEVNCTVRUJNFZGZWHCOWCXGWIWCVNXFVNVOWBUKZWCVQVRHFZVSXFVPVQVSWAULZVNXIVOWB
      DAUMSVPVQVSWAUNCVRUOUPZVCUGDACUQUIURUSXEWMWSBWTXEWJWTFZGZWKWQWLWRXMVNXFXL
      WKWQOWCVNWIXLXHSWCXFWIXLXKSXEXLVDZDACWJUTVAXMVOCTVTUJNFZXLWLWROVNVOWBWIXL
      VBWCXOWIXLWCVQVTHFZWAXOXJVOXPVNWBDEUMVEVPVQVSWAVFCVTUOUPSXNDECWJUTVAVGVHV
      IVJVKVL $.
  $}

  ${
    $d M i $.  $d N i $.  $d U i $.  $d V i $.  $d W i $.
    $( Two subwords of words are equal iff they have the same length and the
       same symbols at each position.  (Contributed by Alexander van der
       Vekens, 7-Aug-2018.) $)
    swrdeq $p |- ( ( ( W e. Word V /\ U e. Word V ) /\ ( M e. NN0 /\ N e. NN0 )
                   /\ ( M <_ ( # ` W ) /\ N <_ ( # ` U ) ) )
                 -> ( ( W substr <. 0 , M >. ) = ( U substr <. 0 , N >. )
             <-> ( M = N /\ A. i e. ( 0 ..^ M ) ( W ` i ) = ( U ` i ) ) ) ) $=
      ( wcel wa cn0 chash cfv cc0 co wceq cfzo wral 3ad2ant1 simpl adantr simpr
      cword cle wbr w3a cop csubstr cv swrdcl anim12i wrdeq0 syl 3ad2ant2 lencl
      wb cfz 3ad2ant3 elfz2nn0 syl3anbrc swrd0len syl2anc adantl eqeq12d anbi1d
      oveq2d raleqdv swrd0fv syl3anc oveq2 eleq2d wi 3jca sylbid ralbidva bitrd
      ex imp pm5.32da 3bitrd ) FEUAZGZAVSGZHZCIGZDIGZHZCFJKZUBUCZDAJKZUBUCZHZUD
      ZFLCUEUFMZALDUEUFMZNZWLJKZWMJKZNZBUGZWLKZWRWMKZNZBLWOOMZPZHZCDNZXCHXEWRFK
      ZWRAKZNZBLCOMZPZHWKWLVSGZWMVSGZHZWNXDUNWBWEXMWJVTXKWAXLEFLCUHEALDUHUIQWLB
      EWMUJUKWKWQXEXCWKWOCWPDWKVTCLWFUOMGZWOCNZWBWEVTWJVTWARQZWKWCWFIGZWGXNWEWB
      WCWJWCWDRULWBWEXQWJVTXQWAEFUMSQWJWBWGWEWGWIRUPCWFUQURZEFCUSZUTWKWADLWHUOM
      GZWPDNWBWEWAWJVTWATQZWKWDWHIGZWIXTWEWBWDWJWCWDTULWBWEYBWJWAYBVTEAUMVAQWJW
      BWIWEWGWITUPDWHUQURZEADUSUTVBVCWKXEXCXJWKXEHZXCXABXIPXJYDXABXBXIYDWOCLOYD
      VTXNXOWKVTXEXPSZWKXNXEXRSZXSUTVDVEYDXAXHBXIYDWRXIGZHZWSXFWTXGYHVTXNYGWSXF
      NYDVTYGYESYDXNYGYFSYDYGTEFCWRVFVGYHWAXTWRLDOMZGZUDZWTXGNYDYGYKYDYGYJYKXEY
      GYJUNWKXEXIYIWRCDLOVHVIVAWKYJYKVJXEWKYJYKWKYJHWAXTYJWKWAYJYASWKXTYJYCSWKY
      JTVKVOSVLVPEADWRVFUKVBVMVNVQVR $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Words over a set - extension (subwords of subwords)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d L x $.  $d M x $.  $d N x $.  $d V x $.  $d W x $.
    $( A prefix of a subword.  (Contributed by Alexander van der Vekens,
       2-Apr-2018.) $)
    swrd0swrd $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) )
                        /\ M e. ( 0 ... N ) ) -> ( L e. ( 0 ... ( N - M ) )
                      -> ( ( W substr <. M , N >. ) substr <. 0 , L >. )
                         = ( W substr <. M , ( M + L ) >. ) ) ) $=
      ( wcel cc0 cfv co w3a wceq wa 3ad2ant1 adantr sylbi cle adantl wi ex imp
      vx cword chash cfz cmin cop csubstr caddc cfzo cres swrdcl 3ancomb eqcomd
      swrdlen oveq2d eleq2d biimpa swrd0val syl2anc wfn wss biimpi swrdvalfn cz
      syl cuz wbr elfz2nn0 nn0z id 3anim123i eluz2 sylibr fzoss2 fnssres simpl1
      cn0 simpl nn0addcl nn0ge0 cr wb nn0re addge01 syl2an mpbid 3ad2ant3 com12
      3jca impcom simp2 3ad2ant2 leaddsub2d bicomd adantlr syl3anc exp4b sylbid
      letr com23 com25 com24 com14 3imp 3adant1 com13 3adant2 syl3anbrc elfzelz
      cc zcn pncan2 expcom fneq2d mpbird cv elfzel2 elfzle2 sselda swrdfv fvres
      leaddsub2 exp3a expimpd syl5bi syl2anb 3eqtr4d eqfnfvd eqtrd ) EDUBZFZCGE
      UCHZUDIZFZBGCUDIFZJZAGCBUEIZUDIZFZEBCUFUGIZGAUFUGIZEBBAUHIZUFUGIZKYPYSLZU
      UAYTGAUIIZUJZUUCUUDYTYJFZAGYTUCHZUDIZFZUUAUUFKYPUUGYSYKYNUUGYODEBCUKMNYPY
      SUUJYPYRUUIAYPYQUUHGUDYPUUHYQYPYKYOYNJZUUHYQKYKYNYOULZDEBCUNOUMUOUPUQDYTA
      URUSUUDUAUUEUUFUUCUUDYTGYQUIIZUTZUUEUUMVAZUUFUUEUTUUDUUKUUNYPUUKYSYPUUKUU
      LVBNZDEBCVCVEUUDYQAVFHFZUUOUUDAVDFZYQVDFZAYQPVGZJZUUQYSUVAYPYSAVQFZYQVQFZ
      UUTJZUVAAYQVHZUVBUURUVCUUSUUTUUTAVIYQVIUUTVJVKOQAYQVLZVMAGYQVNZVEUUMUUEYT
      VOUSUUDUUCUUEUTUUCGUUBBUEIZUIIZUTZUUDYKBGUUBUDIFZUUBYMFZUVJYKYNYOYSVPZUUD
      BVQFZUUBVQFZBUUBPVGZJZUVKYSYPUVQYSUVDYPUVQRZUVEUVBUVCUVRUUTYPUVBUVQYOYKUV
      BUVQRZYNYOUVNCVQFZBCPVGZJZUVSBCVHZUVNUVTUVSUWAUVNUVBUVQUVNUVBLZUVNUVOUVPU
      VNUVBVRBAVSZUWDGAPVGZUVPUVBUWFUVNAVTQUVNBWAFZAWAFZUWFUVPWBUVBBWCZAWCZBAWD
      WEWFZWISMOWGWHMOWJBUUBVHZVMUUDUVOYLVQFZUUBYLPVGZUVLYSYPUVOYSUVDYPUVORZUVE
      UVBUVCUWOUUTYPUVBUVOYOYKUVBUVORZYNYOUWBUWPUWCUVNUVTUWPUWAUVNUVBUVOUWESMZO
      WGWHMOWJYPUWMYSYNYKUWMYOYNUVTUWMCYLPVGZJZUWMCYLVHZUVTUWMUWRWKZOWLNYSYPUWN
      YSUVDYPUWNRZUVEUVBUUTUXBUVCUVBUUTUXBYPUUTUVBUWNYNYOUUTUVBUWNRRZYKYNYOUXCY
      NUWSYOUXCRZUWTUVTUWMUWRUXDYOUWMUWRUVTUXCYOUWBUWMUWRUVTUXCRRRZUWCUVNUVTUXE
      UWAUVNUVTUWRUWMUXCUVNUVTUWRUWMUXCRRUVNUVTLZUVBUWMUUTUWRUWNUXFUVBUWMUUTUWR
      UWNRZRRUXFUVBLZUUTUWMUXGUXHUUTUUBCPVGZUWMUXGRUXHUXIUUTUXHBACUXFUWGUVBUVNU
      WGUVTUWINNUVBUWHUXFUWJQUXFCWAFZUVBUVTUXJUVNCWCZQNZWMWNUXHUWMUXIUXGUXHUWMU
      XIUWRUWNUXHUWMLUUBWAFZUXJYLWAFZUXIUWRLZUWNRZUXHUXMUWMUVNUVBUXMUVTUWDUVOUX
      MUWEUUBWCVEZWONUXHUXJUWMUXLNUWMUXNUXHYLWCZQUUBCYLWSZWPWQWTWRWTSXASXBMOXCX
      DOTXEXFTXGOWJUUBYLVHZXHDEBUUBVCWPUUDUUEUVIUUCUUDAUVHGUIUUDUVHAYPYSUVHAKZY
      OYKYSUYARZYNYOBVDFZUYBBGCXIYSUYCUYAYSUURUYCUYARAGYQXIZUYCUURUYAUYCBXJFAXJ
      FUYAUURBXKAXKBAXLWEXMVEWHVEWGTUMUOZXNXOUUDUAXPZUUEFZLZUYFYTHZUYFBUHIEHZUY
      FUUFHZUYFUUCHZUYHUUKUYFUUMFUYIUYJKUUDUUKUYGUUPNUUDUUEUUMUYFUUDUUQUUOUUDUU
      RUUSUUTUUQYSUURYPUYDQYSUUSYPAGYQXQQYSUUTYPAGYQXRQUVFXHUVGVEXSDEBCUYFXTUSU
      YGUYKUYIKUUDUYFUUEYTYAQUYHYKUVKUVLJUYFUVIFZUYLUYJKUYHYKUVKUVLUUDYKUYGUVMN
      UUDUVKUYGYSYPUVKYSUVDYPUVKRZUVEUVBUVCUYNUUTYPUVBUVKYOYKUVBUVKRZYNYOUWBUYO
      UWCUWBUVBUVKUWBUVBLUVNUVOUVPUVKUVNUVTUWAUVBVPUWBUVBUVOUWQTUWBUVBUVPUVNUVT
      UVBUVPRUWAUVNUVBUVPUWKSMTUWLXHSOWGWHMOWJNUUDUVLUYGYPYSUVLYNYOYSUVLRZYKYNU
      WSUWBUYPYOUWTUWCYSUVDUWSUWBLZUVLUVEUYQUVDUVLUYQUVDLUVOUWMUWNUVLUYQUVDUVOU
      WBUVDUVORZUWSUVNUVTUYRUWAUVDUVNUVOUVBUVCUVNUVORUUTUVNUVBUVOUWEXMMWHMQTUYQ
      UWMUVDUWSUWMUWBUXANNUVDUYQUWNUVBUUTUYQUWNRUVCUYQUVBUUTLZUWNUWBUWSUYSUWNRZ
      UVNUVTUWSUYTRUWAUWSUVNUYTUVTUWMUWRUVNUYTRUVTUYSUWRUVNUWMUWNUVTUVBUUTUWRUV
      NUWMUWNRZRRUVTUVBLZUVNUWRUUTVUAVUBUVNUWRUUTVUARRVUBUVNLZUUTUWRVUAVUCUUTUX
      IUWRVUARVUCUWGUWHUXJUUTUXIWBUVNUWGVUBUWIQVUBUWHUVNUVBUWHUVTUWJQNVUBUXJUVN
      UVTUXJUVBUXKNNZUWGUWHUXJJUXIUUTBACYBWNWPVUCUXIUWRVUAVUCUWMUXOUWNVUCUWMUXP
      VUCUWMLUXMUXJUXNUXPVUCUXMUWMVUBUVNUXMUVBUVNUXMRUVTUVNUVBUXMUXQXMQTNVUCUXJ
      UWMVUDNUWMUXNVUCUXRQUXSWPSWTYCWRWTSXBYDXAXDWHMWJWHXGWJUXTXHSYEYFXETNWIUUD
      UYGUYMUUDUUEUVIUYFUYEUPUQDEBUUBUYFXTUSYGYHYIS $.
  $}

  $( Lemma for ~ swrdswrd .  (Contributed by Alexander van der Vekens,
     4-Apr-2018.) $)
  swrdswrdlem $p |- ( ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) )
                             /\ M e. ( 0 ... N ) )
                  /\ ( K e. ( 0 ... ( N - M ) ) /\ L e. ( K ... ( N - M ) ) ) )
                         -> ( W e. Word V /\ ( M + K ) e. ( 0 ... ( M + L ) )
                              /\ ( M + L ) e. ( 0 ... ( # ` W ) ) ) ) $=
    ( wcel cc0 co w3a wa cn0 cle wbr wi adantr impcom ex sylbi imp cfv cfz cmin
    cword chash caddc simpl1 cz elfz2 elfz2nn0 nn0addcl expcom elnn0z cr adantl
    0re a1i zre letr syl3anc sylbir syld exp3a com34 impancom nn0re biimpa 3jca
    leadd2d com23 3ad2ant1 3ad2ant3 com13 sylibr simpr2 anim12i simpllr simplll
    com12 simpr leaddsub2d readdcl sylbird syl2an com25 com24 com15 com35 imp3a
    a1dd 3imp exp41 3adant1 com3l ) FEUDGZDHFUEUAZUBIZGZCHDUBIGZJZAHDCUCIZUBIGZ
    BAXAUBIGZKZKZWOCAUFIZHCBUFIZUBIGZXGWQGZWOWRWSXDUGXEXFLGZXGLGZXFXGMNZJZXHXDW
    TXMXCXBWTXMOZXCAUHGZXAUHGZBUHGZJZABMNZBXAMNZKZKZXBXNOZBAXAUIZXRYAYCXQXOYAYC
    OXPYAXQYCXSXQYCOXTXBXQXSXNXBALGZXALGZAXAMNZJZXQXSXNOZOZAXAUJZYEYFYJYGYEXQYI
    WTXSYEXQKZXMWSWOXSYLXMOOZWRWSCLGZDLGZCDMNZJZYMCDUJZYNYOYMYPYNYLXSXMYNYLXSXM
    OYNYLKZXSXMYSXSKXJXKXLYSXJXSYLYNXJYEYNXJOXQYNYEXJCAUKULPQPYSXSXKYLYNXSXKOZY
    EXQYNYTOZYEXOHAMNZKZXQUUAOAUMZXOXQUUBUUAXOXQKZUUBXSYNXKUUEUUBXSYNXKOZUUEUUB
    XSKZHBMNZUUFUUEHUNGZAUNGZBUNGZUUGUUHOUUIUUEUPUQXOUUJXQAURPXQUUKXOBURZUOHABU
    SUTZXQUUHUUFOXOXQUUHUUFXQUUHKBLGZUUFBUMYNUUNXKCBUKULVARUOVBVCVDVESTQZTYSXSX
    LYSABCYLUUJYNYEUUJXQAVFPUOYLUUKYNXQUUKYEUULUOUOYNCUNGZYLCVFZPVIVGVHRRVJVKSV
    LVMRVKSVMPVSVLTSQQXFXGUJVNXEXKWPLGZXGWPMNZJZXIXDWTUUTXCXBWTUUTOZXCYBXBUVAOZ
    YDXRYAUVBXQXOYAUVBOXPXBXQYAUVAXBYHXQYAUVAOZOZYKYEYFUVDYGYEXQUVCWTYAYLUUTWRW
    SYAYLUUTOOZWOWRWSUVEWRYOUURDWPMNZJZWSUVEODWPUJWSUVGUVEWSYQUVGUVEOZYRYNYOUVH
    YPYNYLYAUVGUUTYNYLYAUVGUUTYSYAKZUVGKXKUURUUSUVIXKUVGYAYSXKXSYSXKOXTYSXSXKUU
    OVSPQPUVIYOUURUVFVOUVIUVGUUSYSYAUVGUUSOZYLYNYAUVJOZYEXQYNUVKOZYEUUCXQUVLOUU
    DXOXQUUBUVLUUEYAYNUUBUVJUUEXSXTYNUUBUVJOOUUEUUBXTYNXSUVJUUEUUBXSYNXTUVJUUEU
    UBXSYNXTUVJOOZUUEUUGUUHUVMUUMXQUUHUVMOXOUVGUUHYNXTXQUUSYOUURUVFUUHYNXTXQUUS
    OOZOOYOYNUVFUUHUURUVNYOYNUVFUUHUURUVNOOOYOYNKZUURUUHUVFUVNUVOUURUUHUVFUVNOO
    UVOUURKZXQUVFXTUUHUUSUVPXQUVFXTUUHUUSOZOOZUVPDUNGZUUPKZWPUNGZKZUUKUVRXQUVOU
    VTUURUWAYOUVSYNUUPDVFUUQVPWPVFVPUULUWBUUKKZXTUVFUVQUWCXTXGDMNZUVFUVQOZUWCCB
    DUVSUUPUWAUUKVQUWBUUKVTUVSUUPUWAUUKVRZWAUWCUWDUWEUWCUWDKUVFUUSUUHUWCUWDUVFU
    USOZUWCXGUNGZUVSUWAUWDUWGOUWBUUKUWHUVTUUKUWHOZUWAUUPUWIUVSUUPUUKUWHCBWBRUOP
    TUWFUWBUWAUUKUVTUWAVTPUWHUVSUWAJUWDUVFUUSXGDWPUSVCUTTWJRWCVJWDRWERWFRWEWKWG
    UOVBVCWHWEWIWFVESTQTTVHWLWFVKSVSSTWMVMRVKSWNVLTSQQXGWPUJVNVH $.

  ${
    $d K x y $.  $d L x y $.  $d M x y $.  $d N x y $.  $d V x y $.
    $d W x y $.
    $( A subword of a subword.  (Contributed by Alexander van der Vekens,
       4-Apr-2018.) $)
    swrdswrd $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) )
                         /\ M e. ( 0 ... N ) )
                 -> ( ( K e. ( 0 ... ( N - M ) ) /\ L e. ( K ... ( N - M ) ) )
                    -> ( ( W substr <. M , N >. ) substr <. K , L >. )
                       = ( W substr <. ( M + K ) , ( M + L ) >. ) ) ) $=
      ( vx wcel cc0 cfv cfz co w3a wa caddc wceq adantr adantl wi wbr cword cop
      vy chash cmin csubstr cfzo cv swrdcl 3ad2ant1 elfzelfzelfz cuz wss elfzuz
      cmpt fzss1 syl sseld impr 3ancomb biimpi swrdlen oveq2d eleqtrrd swrdval2
      syl3anc wfn fvex eqid fnmpti swrdswrdlem swrdvalfn cz elfzelz cc ad2antrl
      a1i zcn ad2antll pnpcan eqcomd expcom syl2anr syl5com 3ad2ant3 imp fneq2d
      mpbird cvv simpr weq oveq1 oveq1d fveq2d sylancl elfzoelz 3anim123i 3expa
      fvmptg bcxmaslem2 exp31 com13 impcom eqtrd ad3antrrr cn0 cle elfz2nn0 clt
      elfz2 cn elfzo0 cr wb nn0re zre ltaddsub bicomd nn0addcl ex elnn0z lelttr
      0re ltletr elnnnn0b simplbi2 syld exp4b com23 exp3a a1d com24 sylbi mpcom
      impancom imp41 syl3anbrc com12 swrdfv syl2anc exp41 3adant2 com14 3adant3
      sylbid mpteq2dva fveq1d com3l mpan9 eleq2d biimpa 3eqtr4d eqfnfvd ) FEUAZ
      HZDIFUDJKLZHZCIDKLHZMZAIDCUELZKLZHZBAUUTKLZHZNZFCDUBUFLZABUBUFLZFCAOLZCBO
      LZUBUFLZPUUSUVENZUVGGIBAUELZUGLZGUHZAOLZUVFJZUOZUVJUVKUVFUUNHZAIBKLHZBIUV
      FUDJZKLZHUVGUVQPUUSUVRUVEUUOUUQUVRUUREFCDUIUJQUVEUVSUUSABUUTUKRUVKBUVAUWA
      UUSUVBUVDBUVAHUUSUVBNZUVCUVABUWBAIULJHZUVCUVAUMUVBUWCUUSAIUUTUNRAIUUTUPUQ
      URUSUVKUVTUUTIKUVKUUOUURUUQMZUVTUUTPUUSUWDUVEUUSUWDUUOUUQUURUTVAZQEFCDVBU
      QVCVDGEUVFABVEVFUVKUCUVMUVQUVJUVQUVMVGUVKGUVMUVPUVQUVOUVFVHUVQVIVJVQUVKUV
      JUVMVGUVJIUVIUVHUELZUGLZVGZUVKUUOUVHIUVIKLHUVIUUPHMZUWHABCDEFVKZEFUVHUVIV
      LUQUVKUVMUWGUVJUVKUVLUWFIUGUUSUVEUVLUWFPZUURUUOUVEUWKSZUUQUURCVMHZUVEUWKC
      IDVNZUVDBVMHZAVMHZUWMUWKSZUVBBAUUTVNZAIUUTVNZUWMUWOUWPNZUWKUWMUWTNCVOHZBV
      OHZAVOHZUWKUWMUXAUWTCVRZQUWOUXBUWMUWPBVRZVPUWPUXCUWMUWOAVRZVSUXAUXBUXCMZU
      WFUVLCBAVTWAZVFWBWCWDWEWFVCWGWHUVKUCUHZUVMHZNZUXIGUVMUVOCOLZFJZUOZJZUXIUV
      HOLZFJZUXIUVQJUXIUVJJZUXKUXOUXIAOLZCOLZFJZUXQUXKUXJUYAWIHUXOUYAPUVKUXJWJU
      XTFVHGUXIUXMUYAUVMWIUXNGUCWKZUXLUXTFUYBUVOUXSCOUVNUXIAOWLWMWNUXNVIWSWOUXK
      UXTUXPFUXJUVKUXTUXPPZUXJUXIVMHZUVKUYCUXIIUVLWPUUSUVEUYDUYCSZUURUUOUVEUYES
      UUQUURUWMUVEUYEUWNUVBUWMUYESZUVDUVBUWPUYFUWSUYDUWMUWPUYCUYDUWMUWPUYCUYDUW
      MNUWPNUXIVOHZUXAUXCMZUYCUYDUWMUWPUYHUYDUYGUWMUXAUWPUXCUXIVRUXDUXFWQWRUYHU
      XPUXTUXICAWTWAUQXAXBUQQWDWEWFWDXCWNXDUXKUXIUVQUXNUXKGUVMUVPUXMUXKUVNUVMHZ
      NUWDUVOIUUTUGLHZUVPUXMPUUSUWDUVEUXJUYIUWEXEUXKUYIUYJUVKUYIUYJSZUXJUVEUYKU
      USUVBUVDUYKUVBAXFHZUUTXFHZAUUTXGTZMUVDUYKSZAUUTXHUYLUYMUYOUYNUVDUYLUYMNZU
      YKUVDUWPUUTVMHZUWOMZABXGTZBUUTXGTZNZNUYPUYKSZBAUUTXJUYRVUAVUBUWOUWPVUAVUB
      SUYQVUAUWOVUBUYTUWOVUBSUYSUYIUWOUYPUYTUYJUYIUVNXFHZUVLXKHZUVNUVLXITZMUWOU
      YPUYTUYJSZSZSZUVNUVLXLVUCVUEVUHVUDVUCUWOVUEVUGUYPVUEVUCUWONZVUFUYLUYMVUEV
      UIVUFSSUYLVUIVUEUYMVUFUYLVUIVUEUYMVUFSZSUYLVUINZVUEUVOBXITZVUJVUKUVNXMHZA
      XMHZBXMHZVUEVULXNVUCVUMUYLUWOUVNXOVPUYLVUNVUIAXOQUWOVUOUYLVUCBXPZVSZVUMVU
      NVUOMVULVUEUVNABXQXRVFVUKVULUYMUYTUYJVUKVULNUYMNUYTNUVOXFHZUUTXKHZUVOUUTX
      ITZUYJVUKVURVULUYMUYTVUIUYLVURVUCUYLVURSUWOVUCUYLVURUVNAXSZXTQXCXEVUKVULU
      YMUYTVUSVUIUYLVULUYMUYTVUSSZSZSZVUCUYLUWOVVDVURVUCUYLNZUWOVVDSZVVAVURUVOV
      MHZIUVOXGTZNVVEVVFSZUVOYAVVGVVHVVIVVGUWOVVEVVHVVDVVGUWOVVEVVHVVDSZSVVGUWO
      NZVVJVVEVVKVVHVULVVCVVKVVHVULNZIBXITZVVCVVKIXMHZUVOXMHZVUOVVLVVMSVVNVVKYC
      VQVVGVVOUWOUVOXPQUWOVUOVVGVUPRIUVOBYBVFUWOVVMVVCSVVGUWOUYMVVMVVBUWOUYMVVM
      UYTVUSUWOUYMNZVVMUYTNZIUUTXITZVUSVVPVVNVUOUUTXMHZVVQVVRSVVNVVPYCVQUWOVUOU
      YMVUPQUYMVVSUWOUUTXOZRIBUUTYDVFUYMVVRVUSSUWOVUSUYMVVRUUTYEYFRYGYHYIRYGYJY
      KXTYLWFYMYNYOXCYPVUKVULUYMUYTVUTVUKUYMVULUYTVUTSVUKUYMVULUYTVUTVUKUYMNVVO
      VUOVVSVULUYTNVUTSVUKVVOUYMVUIUYLVVOVUCUYLVVOSUWOVUCUYLVVOVVEVURVVOVVAUVOX
      OUQXTQXCQVUKVUOUYMVUQQUYMVVSVUKVVTRUVOBUUTYDVFYHYIYPUVOUUTXLYQUUAUUEXTYLW
      FXBYOUUBYMUUCRYRWEWFYMYRUUDYMWFRQWFEFCDUVOYSYTUUFUUGUXKUWIUXIUWGHZUXRUXQP
      UVKUWIUXJUWJQUVKUXJVWAUVKUVMUWGUXIUVKUVLUWFIUGUUSUVEUWKUURUUOUWLUUQUURUWM
      UVEUWKUWNUVBUWPUVDUWQUWSUVDUWOUWPUWQSUWRUWMUWOUWPUWKUWMUWOUWPUWKUWMUWONUW
      PNUXGUWKUWMUWOUWPUXGUWMUXAUWOUXBUWPUXCUXDUXEUXFWQWRUXHUQXAUUHUQUUIWDWEWFV
      CUUJUUKEFUVHUVIUXIYSYTUULUUMXDXT $.
  $}

  $( A prefix of a prefix with the same length is the prefix.  (Contributed by
     Alexander van der Vekens, 5-Apr-2018.) $)
  swrd0swrdid $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) ) )
                        -> ( ( W substr <. 0 , N >. ) substr <. 0 , N >. )
                           = ( W substr <. 0 , N >. ) ) $=
    ( cword wcel cc0 chash cfv cfz co wa cop csubstr wceq sylbi 3ad2ant1 adantl
    w3a cn0 oveq2d caddc cmin simpl simpr cle wbr elfz2nn0 elnn0uz eluzfz1 3jca
    cuz nn0fz0 biimpi nn0cn subid1d eleqtrrd swrd0swrd cz cc elfzelz zcn addid2
    sylc 3syl opeq2d eqtrd ) CBDEZAFCGHZIJEZKZCFALZMJZVKMJZCFFAUAJZLZMJZVLVJVGV
    IFFAIJZEZRAFAFUBJZIJZEZVMVPNVJVGVIVRVGVIUCVGVIUDVIVRVGVIASEZVHSEZAVHUEUFZRZ
    VRAVHUGZWBWCVRWDWBAFUKHEVRAUHFAUIOPOQUJVIWAVGVIWEWAWFWBWCWAWDWBAVQVTWBAVQEA
    ULUMWBVSAFIWBAAUNUOTUPPOQAFABCUQVCVJVOVKCMVJVNAFVIVNANZVGVIAUREAUSEWGAFVHUT
    AVAAVBVDQVETVF $.

  $( A subword of a prefix.  (Contributed by Alexander van der Vekens,
     6-Apr-2018.) $)
  swrdswrd0 $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) ) )
                      -> ( ( K e. ( 0 ... N ) /\ L e. ( K ... N ) )
                           -> ( ( W substr <. 0 , N >. ) substr <. K , L >. )
                                = ( W substr <. K , L >. ) ) ) $=
    ( wcel cc0 cfz co wa cop csubstr wceq caddc syl adantl adantr oveq2d eleq2d
    elfzelz cword chash cfv w3a cmin simpl simpr cn0 elfznn0 0elfz 3jca subid1d
    cz zcn eqcomd anbi12d biimpa swrdswrd sylc cc zcnd addid2d opeq12d eqtrd ex
    ) EDUAFZCGEUBUCZHIFZJZAGCHIZFZBACHIZFZJZEGCKLIABKZLIZEVOLIZMVIVNJZVPEGANIZG
    BNIZKZLIZVQVRVFVHGVJFZUDZAGCGUEIZHIZFZBAWEHIZFZJZVPWBMVIWDVNVIVFVHWCVFVHUFV
    FVHUGVHWCVFVHCUHFWCCVGUICUJOPUKQVIVNWJVIVKWGVMWIVIVJWFAVICWEGHVHCWEMZVFVHCU
    MFZWKCGVGTWLWECWLCCUNULUOOPZRSVIVLWHBVICWEAHWMRSUPUQABGCDEURUSVRWAVOELVRVSA
    VTBVRAVNAUTFZVIVKWNVMVKAAGCTVAQPVBVRBVNBUTFZVIVMWOVKVMBBACTVAPPVBVCRVDVE $.

  $( A prefix of a prefix.  (Contributed by Alexander van der Vekens,
     7-Apr-2018.) $)
  swrd0swrd0 $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) )
       /\ L e. ( 0 ... N ) ) -> ( ( W substr <. 0 , N >. ) substr <. 0 , L >. )
                                = ( W substr <. 0 , L >. ) ) $=
    ( cword wcel cc0 chash cfv cfz co w3a cop csubstr wceq 3simpa elfznn0 0elfz
    wa cn0 syl 3ad2ant2 simp3 jca swrdswrd0 sylc ) DCEFZBGDHIZJKFZAGBJKZFZLZUGU
    ISGUJFZUKSDGBMNKGAMZNKDUNNKOUGUIUKPULUMUKUIUGUMUKUIBTFUMBUHQBRUAUBUGUIUKUCU
    DGABCDUEUF $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Words over a set - extension (subwords of concatenations)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( The subword of a concatenation of an empty word with another word is the
     subword of the second concatenated word.  (Contributed by Alexander van
     der Vekens, 27-Mar-2018.)  (Revised by Alexander van der Vekens,
     23-May-2018.) $)
  swrdccat3a0 $p |- ( ( A = (/) /\ B e. Word V )
       -> ( ( A concat B ) substr <. M , N >. ) = ( B substr <. M , N >. ) ) $=
    ( c0 wceq cword wcel wa cconcat cop csubstr oveq1 ccatlid sylan9eq oveq1d
    co ) AFGZBEHIZJABKRZBCDLMSTUAFBKRBAFBKNEBOPQ $.

  $( The subword of a concatenation as function.  (Contributed by Alexander van
     der Vekens, 27-May-2018.) $)
  swrdccatfn $p |- ( ( ( A e. Word V /\ B e. Word V )
          /\ ( M e. ( 0 ... N ) /\ N e. ( 0 ... ( ( # ` A ) + ( # ` B ) ) ) ) )
           -> ( ( A concat B ) substr <. M , N >. ) Fn ( 0 ..^ ( N - M ) ) ) $=
    ( cword wcel wa cc0 cfz chash cfv caddc cconcat cop csubstr cmin cfzo wfn
    co ccatcl adantr simprl ccatlen eqcomd oveq2d eleq2d biimpcd adantl syl3anc
    wi impcom swrdvalfn ) AEFZGBUNGHZCIDJTGZDIAKLBKLMTZJTZGZHZHABNTZUNGZUPDIVAK
    LZJTZGZVACDOPTIDCQTRTSUOVBUTEABUAUBUOUPUSUCUTUOVEUSUOVEUKUPUOUSVEUOURVDDUOU
    QVCIJUOVCUQEABUDUEUFUGUHUIULEVACDUMUJ $.

  ${
    $d A k $.  $d B k $.  $d M k $.  $d N k $.  $d V k $.
    $( The subword of a concatenation of two words within the first of the
       concatenated words.  (Contributed by Alexander van der Vekens,
       28-Mar-2018.) $)
    swrdccatin1 $p |- ( ( A e. Word V /\ B e. Word V )
                        -> ( ( M e. ( 0 ... N ) /\ N e. ( 0 ... ( # ` A ) ) )
     -> ( ( A concat B ) substr <. M , N >. ) = ( A substr <. M , N >. ) ) ) $=
      ( cfv cc0 wceq wcel wa cfz co csubstr syl adantl adantr w3a ad2antrr cn0
      wi vk chash cword cconcat cop oveq2 eleq2d elfz1eq c0 swrd00 eqtr4i opeq1
      oveq2d 3eqtr4a opeq2 eqeq12d imbi12d mpbiri syl6bi com23 a1d wn cmin cfzo
      imp3a wfn ccatcl simprl elfzelfzccat com12 impcom syl3anc 3anass simplbi2
      swrdvalfn ad2antrl imp cv caddc simprr clt wbr elfzo0 cle elfz2nn0 expcom
      cn nn0addcl 3ad2ant1 sylbi lencl df-ne elnnne0 syl5bir cr nn0re ltaddsubd
      wne ltletr exp3a sylbird ex com24 3impia com13 impancom 3adant2 a1i imp32
      syl5bi syl3anbrc ccatval1 swrdfv sylancom sylan 3eqtr4d eqfnfvd pm2.61i
      3jca ) AUBFZGHZAEUCZIZBYBIZJZCGDKLZIZDGXTKLZIZJZABUDLZCDUEZMLZAYLMLZHZTZT
      YAYPYEYAYGYIYOYAYIYGYOYAYIDGGKLZIZYGYOTZYAYHYQDXTGGKUFUGYRDGHZYSDGUHYTYSC
      YQIZYKCGUEZMLZAUUBMLZHZTUUACGHZUUECGUHUUFYKGGUEZMLZAUUGMLZUUCUUDUUHUIUUIY
      KGUJAGUJUKUUFUUBUUGYKMCGGULZUMUUFUUBUUGAMUUJUMUNNYTYGUUAYOUUEYTYFYQCDGGKU
      FUGYTYMUUCYNUUDYTYLUUBYKMDGCUOZUMYTYLUUBAMUUKUMUPUQURNUSUTVEVAYAVBZYEYPUU
      LYEJZYJYOUUMYJJZUAGDCVCLZVDLZYMYNUUNYKYBIZYGDGYKUBFKLIZYMUUPVFUUMUUQYJYEU
      UQUULEABVGOZPUUMYGYIVHZYJUUMUURYIUUMUURTYGUUMYIUURYEYIUURTUULABDEVIOVJOVK
      ZEYKCDVOVLUUNYCYGYIQZYNUUPVFUUMYJUVBYCYJUVBTUULYDUVBYCYJYCYGYIVMVNVPVQZEA
      CDVONUUNUAVRZUUPIZJZUVDCVSLZYKFZUVGAFZUVDYMFZUVDYNFZUVFYCYDUVGGXTVDLIZUVH
      UVIHUUMYCYJUVEUULYCYDVHRUUMYDYJUVEUULYCYDVTRUVFUVGSIZXTWGIZUVGXTWAWBZUVLU
      VEUUNUVMUVEUVDSIZUUOWGIZUVDUUOWAWBZQZUUNUVMTZUVDUUOWCZUVPUVQUVTUVRUUNUVPU
      VMYGUVPUVMTZUUMYIYGCSIZDSIZCDWDWBZQZUWBCDWEZUWCUWDUWBUWEUVPUWCUVMUVDCWHZW
      FWIWJVPVJWIWJVKUUMUVNYJUVEYEUULUVNYCUULUVNTZYDYCXTSIZUWIEAWKUULXTGWRZUWJU
      VNXTGWLUVNUWJUWKXTWMVNWNNPVKRUUNUVEUVOUVEUVSUUNUVOUWAUUMYGYIUVSUVOTZYGYIU
      WLTZTUUMYGUWFUWMUWGUWCUWDUWMUWEYIUWCUWLYIUWDUWJDXTWDWBZQZUWCUWLTDXTWEUVSU
      WCUWOUVOUVPUVRUWCUWOUVOTZTUVQUVPUWCUVRUWPUWOUVRUVPUWCJZUVOUWDUWJUWNUVRUWQ
      UVOTTUWDUWJJZUWQUVRUWNUVOUWRUWQUVRUWNUVOTZTUWRUWQJZUVRUVGDWAWBZUWSUWTUVDC
      DUVPUVDWOIUWRUWCUVDWPVPUWQCWOIZUWRUWCUXBUVPCWPOOUWDDWOIZUWJUWQDWPRZWQUWTU
      XAUWNUVOUWTUVGWOIZUXCXTWOIZUXAUWNJUVOTUWQUXEUWRUWQUVMUXEUWHUVGWPNOUXDUWRU
      XFUWQUWJUXFUWDXTWPOPUVGDXTWSVLWTXAXBXCXDXEXFXGXEWJVJWIWJXHXIXJVQUVGXTWCXK
      EABUVGXLVLUUNUVEUUQYGUURQUVJUVHHUVFUUQYGUURUUMUUQYJUVEUUSRUUNYGUVEUUTPUUN
      UURUVEUVAPXSEYKCDUVDXMXNUUNUVBUVEUVKUVIHUVCEACDUVDXMXOXPXQXBXBXR $.
  $}

  $( Lemma for ~ swrdccatin2 .  (Contributed by Alexander van der Vekens,
     29-Mar-2018.) $)
  swrdccatin2lem1 $p |- ( ( ( A e. NN0 /\ B e. NN0 ) /\ ( M e. ( A ... N )
            /\ N e. ( ( A + 1 ) ... ( A + B ) ) /\ K e. ( 0 ..^ ( N - M ) ) ) )
                       -> ( K + M ) e. ( A ..^ ( A + B ) ) ) $=
    ( cn0 wcel wa cfz co caddc cfzo id cz 3ad2ant1 adantl cuz cfv wss syl cmin
    cc0 w3a 3ad2antr2 3ad2antr1 simpr3 elfzel2 elfzelz fzoaddel2 syl3anc elfzuz
    c1 fzoss1 sselda syl2anc elfzuz3 fzoss2 ) AFGBFGHZDAEIJGZEAULKJZABKJZIJGZCU
    BEDUAJLJGZUCZHZURVBHZCDKJZAELJZGZVGAVALJZGURUSVBVFVCVFMUDVEURUSHZVGDELJZGZV
    IURVBUSVKVCVKMUEVEVCENGZDNGZVMURUSVBVCUFVDVNURUSVBVNVCDAEUGOPVDVOURUSVBVOVC
    DAEUHOPCEDUIUJVKVLVHVGVKDAQRGZVLVHSUSVPURDAEUKPDAEUMTUNUOVFVHVJVGVFVAEQRGZV
    HVJSVBVQUREUTVAUPPEAVAUQTUNUO $.

  $( Lemma 2 for ~ swrdccatin12 .  (Contributed by Alexander van der Vekens,
     30-Mar-2018.)  (Revised by Alexander van der Vekens, 23-May-2018.) $)
  swrdccatin12lem2 $p |- ( ( L e. NN0 /\ M e. NN0 /\ N e. ZZ )
              -> ( ( K e. ( 0 ..^ ( N - M ) ) /\ -. K e. ( 0 ..^ ( L - M ) ) )
                     -> K e. ( ( L - M ) ..^ ( ( L - M ) + ( N - L ) ) ) ) ) $=
    ( cn0 wcel cz w3a cc0 cmin co cfzo wn wa caddc nn0z zsubcl syl2an cc nn0cn
    3adant3 elfzonelfzo imp sylan wb npncan3 syl3an oveq2d eleq2d adantr mpbird
    wceq zcn ex ) BEFZCEFZDGFZHZAIDCJKZLKFAIBCJKZLKFMNZAUTUTDBJKOKZLKZFZURVANVD
    AUTUSLKZFZURUTGFZVAVFUOUPVGUQUOBGFCGFVGUPBPCPBCQRUAVGVAVFUSAIUTUBUCUDURVDVF
    UEVAURVCVEAURVBUSUTLUOBSFUPCSFUQDSFVBUSULBTCTDUMBCDUFUGUHUIUJUKUN $.

  $( Lemma 1 for ~ swrdccatin12lem3 .  (Contributed by Alexander van der
     Vekens, 30-Mar-2018.)  (Revised by Alexander van der Vekens,
     27-May-2018.) $)
  swrdccatin12lem3a $p |- ( ( M e. ( 0 ... L ) /\ N e. ( L ... X ) )
               -> ( ( K e. ( 0 ..^ ( N - M ) ) /\ -. K e. ( 0 ..^ ( L - M ) ) )
                    -> ( K + M ) e. ( L ..^ X ) ) ) $=
    ( cc0 co wcel wa cfzo cz wi w3a cle wbr adantr sylbi syl simpr adantl caddc
    cfz cmin wn elfz2 zsubcl 3adant1 elfzonelfzo elfzoelz elfzelz simpl anim12i
    wb anim12ci jca syl5 imp impcom elfzomelpfzo cuz cfv wss simpl3 simpl2 3jca
    exp32 eluz2 sylibr fzoss2 sseld sylbid ex com23 mpcom com12 syld ) CFBUBGHZ
    DBEUBGHZIZAFDCUCGZJGHAFBCUCGZJGHUDIZAWAVTJGHZACUAGZBEJGZHZVSWAKHZWBWCLVQWGV
    RVQFKHZBKHZCKHZMZFCNOCBNOIZIZWGCFBUEZWKWGWLWIWJWGWHBCUFUGPQPVTAFWAUHRWCVSWF
    AKHZWCVSWFLAWAVTUIWOVSWCWFWOVSWCWFLWOVSIZWCWDBDJGZHZWFWPWIDKHZIZWOWJIZIZWCW
    RUMVSWOXBVQVRWOXBLZVQWMVRXCLZWNWKXDWLWIWJXDWHVRWSWIWJIZXCDBEUJXEWSWOXBXEWSW
    OIZIWTXAXEWIXFWSWIWJUKWSWOUKULXEWJXFWOWIWJSWSWOSUNUOVFUPUGPQUQURACBDUSRWPWQ
    WEWDWPEDUTVAHZWQWEVBWPWSEKHZDENOZMZXGVSXJWOVRXJVQVRWIXHWSMZBDNOZXIIZIZXJDBE
    UEXNWSXHXIWIXHWSXMVCWIXHWSXMVDXMXIXKXLXISTVEQTTDEVGVHDBEVIRVJVKVLVMVNVOVP
    $.

  $( Lemma 2 for ~ swrdccatin12lem3 .  (Contributed by Alexander van der
     Vekens, 30-Mar-2018.)  (Revised by Alexander van der Vekens,
     27-May-2018.) $)
  swrdccatin12lem3b $p |- ( ( M e. ( 0 ... L ) /\ N e. ( L ... X ) )
               -> ( ( K e. ( 0 ..^ ( N - M ) ) /\ -. K e. ( 0 ..^ ( L - M ) ) )
                    -> ( K - ( L - M ) ) e. ( 0 ..^ ( ( N - L ) - 0 ) ) ) ) $=
    ( cc0 co wcel wa cmin cfzo cz wi w3a cle wbr adantr sylbi caddc cc wn elfz2
    cfz zsubcl 3adant1 elfzonelfzo syl wceq elfz2nn0 nn0cn elfzelz subcl ancoms
    cn0 zcn addid1d eqcomd adantl simprr npncan3d subid1 adantrl oveq2d oveq12d
    simpl eqtr3d ex 3syl com12 syl2an 3adant3 imp eleq2d biimpa zsubcld 3adant2
    0z a1i 3jca fzosubel2 syl2anc syld ) CFBUCGHZDBEUCGHZIZAFDCJGZKGHAFBCJGZKGH
    UAIZAWGWFKGZHZAWGJGFDBJGZFJGZKGHZWEWGLHZWHWJMWCWNWDWCFLHZBLHZCLHZNZFCOPCBOP
    ZIZIWNCFBUBWRWNWTWPWQWNWOBCUDUEQRQZWFAFWGUFUGWEWJWMWEWJIAWGFSGZWGWLSGZKGZHZ
    WNWOWLLHZNZWMWEWJXEWEWIXDAWCWDWIXDUHZWCCUNHZBUNHZWSNWDXHMZCBUIXIXJXKWSXICTH
    ZBTHZXKXJCUJBUJWDXLXMIZXHWDDLHZDTHZXNXHMDBEUKDUOXPXNXHXPXNIZWGXBWFXCKXNWGXB
    UHXPXNXBWGXNWGXMXLWGTHBCULUMUPUQURXQWGWKSGWFXCXQBCDXPXLXMUSXNXLXPXLXMVEURXP
    XNVEUTXQWKWLWGSXPXMWKWLUHZXLXPXMIWKTHZXRDBULXSWLWKWKVAUQUGVBVCVFVDVGVHVIVJV
    KRVLVMVNWEXGWJWEWNWOXFXAWOWEVQVRWDXFWCWDWPELHZXONZBDOPDEOPIZIXFDBEUBYAXFYBW
    PXOXFXTWPXOIZWKFXOWPWKLHDBUDUMWOYCVQVRVOVPQRURVSQAWGFWLVTWAVGWB $.

  ${
    $d A k $.  $d B k $.  $d L k $.  $d M k $.  $d N k $.  $d V k $.  $d X k $.
    swrdccatin12.l $e |- L = ( # ` A ) $.
    $( The subword of a concatenation of two words within the second of the
       concatenated words.  (Contributed by Alexander van der Vekens,
       28-Mar-2018.)  (Revised by Alexander van der Vekens, 27-May-2018.) $)
    swrdccatin2 $p |- ( ( A e. Word V /\ B e. Word V )
                  -> ( ( M e. ( L ... N ) /\ N e. ( L ... ( L + ( # ` B ) ) ) )
                           -> ( ( A concat B ) substr <. M , N >. )
                              = ( B substr <. ( M - L ) , ( N - L ) >. ) ) ) $=
      ( wcel wa cfz co cfv cmin wceq cc0 wi syl adantr adantl impcom vk cconcat
      cword chash caddc cop csubstr cfzo wfn wb oveq1 eleq2d id oveq12d anbi12d
      ax-mp cn0 lencl cuz wss elnn0uz biimpi fzss1 sseld anim12d imp swrdccatfn
      syl5bi syldan cc w3a cz cle wbr elfz2 3anim123i 3comr sylbi oveq2d fneq2d
      zcn nnncan2 mpbird simpr elfzmlbm ad2antrl nn0zd elfzmlbp com12 swrdvalfn
      ex syl3anc cv clt cif simpl elfzoelz elfzelz zaddcl expcom syl5com df-3an
      sylanbrc ccatsymb wn elfzonn0 cr zre anim12i elnn0z 0re a1i anim1i ancoms
      anim2i le2add syl2anc recn breq1d sylibd lenltd exp3a mpan9 eqcomi breq2i
      addid2d readdcl notbii syl6ibr 3adant2 iffalse ad2antrr addsubassd eqeq1d
      com23 oveq2 syl5ib fveq2d 3eqtrd swrdfv ccatcl syl5eqel fzmmmeqm syl31anc
      ccatlen biimpd 3jca sylan 3eqtr4d eqfnfvd ) AFUCZHZBUUKHZIZDCEJKZHZECCBUD
      LZUEKZJKZHZIZABUBKZDEUFUGKZBDCMKZECMKZUFUGKZNUUNUVAIZUAOUVEUVDMKZUHKZUVCU
      VFUVGUVCUVIUIUVCOEDMKZUHKZUIZUUNUVADOEJKZHZEOAUDLZUUQUEKZJKZHZIZUVLUUNUVA
      UVSUVADUVOEJKZHZEUVOUVPJKZHZIZUUNUVSCUVONZUVAUWDUJGUWEUUPUWAUUTUWCUWEUUOU
      VTDCUVOEJUKULUWEUUSUWBEUWECUVOUURUVPJUWEUMCUVOUUQUEUKUNULZUOUPUULUWDUVSPZ
      UUMUULUVOUQHZUWGFAURZUWHUWAUVNUWCUVRUWHUVTUVMDUWHUVOOUSLZHZUVTUVMUTUWHUWK
      UVOVAVBZUVOOEVCQVDUWHUWBUVQEUWHUWKUWBUVQUTZUWLUVOOUVPVCZQVDVEQRVHVFABDEFV
      GVIUVGUVIUVKUVCUVGUVHUVJOUHUVAUVHUVJNZUUNUVAEVJHZDVJHZCVJHZVKZUWOUUPUWSUU
      TUUPCVLHZEVLHZDVLHZVKZCDVMVNZDEVMVNZIZIZUWSDCEVOZUXCUWSUXFUXAUXBUWTUWSUXA
      UWPUXBUWQUWTUWREWADWAZCWAZVPVQRVRREDCWBQSVSVTWCUVGUUMUVDOUVEJKHZUVEOUUQJK
      HZUVFUVIUIUUNUUMUVAUULUUMWDRZUUPUXKUUNUUTDCEWEWFZUVAUUNUXLUUTUUNUXLPZUUPU
      UNUUTUXLUUNUUQVLHZUUTUXLPZUUMUXPUULUUMUUQFBURWGZSUXPUUTUXLECUUQWHWKZQWIST
      FBUVDUVEWJWLUVGUAWMZUVIHZIZUXTDUEKZUVBLZUXTUVDUEKZBLZUXTUVCLZUXTUVFLZUYBU
      YDUYCUVOWNVNZUYCALZUYCUVOMKZBLZWOZUYLUYFUYBUULUUMUYCVLHZVKZUYDUYMNUYBUUNU
      YNUYOUVGUUNUYAUUNUVAWPRUYAUVGUYNUYAUXTVLHZUVGUYNUXTOUVHWQZUUPUYPUYNPZUUNU
      UTUUPUXBUYRDCEWRUYPUXBUYNUXTDWSWTQWFXATUULUUMUYNXBXCFABUYCXDQUYBUYIXEZUYM
      UYLNUYAUVGUYSUYAUXTUQHZUVGUYSUXTUVHXFUUPUYTUYSPZUUNUUTUUPUXGVUAUXHUXFUXCV
      UAUXDUXCVUAPUXEUXCUXDVUAUWTUXBUXDVUAPUXAUWTUXBIZUYTUXDUYSVUBUYTUXDUYSPVUB
      UYTIUXDUYCCWNVNZXEZUYSVUBCXGHZDXGHZIZUYTUXDVUDPZUWTVUEUXBVUFCXHDXHXIUYTUY
      POUXTVMVNZIVUGVUHPZUXTXJUYPUXTXGHZVUIVUJUXTXHVUIVUKVUGVUHVUKVUGIZVUIVUHVU
      LVUIUXDVUDVULVUIUXDIZCUYCVMVNZVUDVULVUMOCUEKZUYCVMVNZVUNVULOXGHZVUEIZVUKV
      UFIZVUMVUPPVUGVURVUKVUFVUEVURVUFVUQVUEVUQVUFXKXLXMXNSVUGVUFVUKVUEVUFWDXOZ
      OCUXTDXPXQVULVUOCUYCVMVUEVUOCNVUKVUFVUECCXRYFWFXSXTVULCUYCVUGVUEVUKVUEVUF
      WPSVULVUSUYCXGHVUTUXTDYGQYAXTYBWIYBYCVRYCUYIVUCUVOCUYCWNCUVOGYDYEYHYIWKYO
      YJWIRTVRWFXATUYIUYJUYLYKQUYBUYKUYEBUYAUVGUYKUYENZUYAUYPUVGVVAUYQUUPUYPVVA
      PZUUNUUTUUPUXGVVBUXHUXCVVBUXFUWTUXBVVBUXAVUBUYPVVAUWEVUBUYPIZVVAPGVVCUYCC
      MKZUYENUWEVVAVVCUXTDCUYPUXTVJHVUBUXTWASVUBUWQUYPUXBUWQUWTUXISRUWTUWRUXBUY
      PUXJYLYMUWEVVDUYKUYECUVOUYCMYPYNYQUPWKYJRVRWFXATYRYSUYBUVBUUKHZUVNEOUVBUD
      LZJKZHZUXTUVKHZUYGUYDNUUNVVEUVAUYAFABUUAYLUVGUVNUYAUVAUUNUVNUUPUUNUVNPUUT
      UUNUUPUVNUULUUPUVNPUUMUULUUOUVMDUULCUWJHZUUOUVMUTUULUWHVVJUWIUWHCUVOUWJGU
      WLUUBQCOEVCQVDRWIRTRUVGVVHUYAUVAUUNVVHUUTUUNVVHPZUUPUUTUWCVVKUWEUUTUWCUJG
      UWFUPUWCUUNVVHUWCUUNIVVHUVRUUNUWCUVRUUNUWBUVQEUUNUWKUWMUULUWKUUMUULUWHUWK
      UWIUWLQRUWNQVDTUUNVVHUVRUJUWCUUNVVGUVQEUUNVVFUVPOJFABUUEVSULSWCWKVRSTRUVG
      UYAVVIUUPUYAVVIPUUNUUTUUPUYAVVIUUPUVIUVKUXTUUPUVHUVJOUHCDEUUCVSULUUFWFVFF
      UVBDEUXTYTUUDUVGUUMUXKUXLVKUYAUYHUYFNUVGUUMUXKUXLUXMUXNUVAUUNUXLUUTUXOUUP
      UUNUUTUXLUUMUXQUULUUMUXPUXQUXRUXSQSWISTUUGFBUVDUVEUXTYTUUHUUIUUJWK $.

    $( Lemma for ~ swrdccatin12lem3 and ~ swrdccatin12lem4 .  (Contributed by
       Alexander van der Vekens, 30-Mar-2018.)  (Revised by Alexander van der
       Vekens, 27-May-2018.) $)
    swrdccatin12lem3c $p |- ( ( ( A e. Word V /\ B e. Word V )
                  /\ ( M e. ( 0 ... L ) /\ N e. ( L ... ( L + ( # ` B ) ) ) ) )
                             -> ( ( A concat B ) e. Word V /\ M e. ( 0 ... N )
                                /\ N e. ( 0 ... ( # ` ( A concat B ) ) ) ) ) $=
      ( cword wcel wa cc0 cfz co chash cfv caddc cconcat ccatcl adantr adantl
      elfz0fzfz0 cuz wss elfzuz2 fzss1 sseld impr wb ccatlen wceq eqcomi oveq1d
      syl a1i eqtrd oveq2d eleq2d mpbird 3jca ) AFHZIBUTIJZDKCLMIZECCBNOZPMZLMZ
      IZJZJZABQMZUTIZDKELMIZEKVINOZLMZIZVAVJVGFABRSVGVKVACDEVDUATVHVNEKVDLMZIZV
      AVBVFVPVAVBJZVEVOEVQCKUBOIZVEVOUCVBVRVADKCUDTCKVDUEUMUFUGVAVNVPUHVGVAVMVO
      EVAVLVDKLVAVLANOZVCPMVDFABUIVAVSCVCPVSCUJVACVSGUKUNULUOUPUQSURUS $.

    $( Lemma 3 for ~ swrdccatin12 .  (Contributed by Alexander van der Vekens,
       30-Mar-2018.)  (Revised by Alexander van der Vekens, 27-May-2018.) $)
    swrdccatin12lem3 $p |- ( ( ( A e. Word V /\ B e. Word V )
          /\ ( M e. ( 0 ... L ) /\ N e. ( L ... ( L + ( # ` B ) ) ) ) )
              -> ( ( K e. ( 0 ..^ ( N - M ) ) /\ -. K e. ( 0 ..^ ( L - M ) ) )
                     -> ( ( ( A concat B ) substr <. M , N >. ) ` K )
                    = ( ( B substr <. 0 , ( N - L ) >. ) `
                        ( K - ( # ` ( A substr <. M , L >. ) ) ) ) ) ) $=
      ( wcel wa cc0 cfz co cfv cmin wceq adantr wi adantl imp cword chash caddc
      cfzo wn cconcat cop csubstr w3a swrdccatin12lem3c simprl syl2anc elfzoelz
      swrdfv cz cn0 cle wbr elfz2nn0 cc nn0cn anim12i zcn ancoms anim2i addid1d
      subcl syl simpr simplr simpll subsub3d eqtr2d syl2an oveq2 eqcoms syl5ibr
      eqeq1d ax-mp ex 3adant3 sylbi impcom fveq2d swrdccatin12lem3a wb id oveq1
      syl5com eleq2d sylibr df-3an sylanbrc ccatval2 elfz2 zsubcl cr zre subge0
      oveq12d syl2anr biimprd elnn0z com12 3adant2 0elfz lencl elfzel2 3ad2ant3
      expcom exp3acom23 nn0re 3jca lesubadd2 3imtr4g swrdccatin12lem3b syl31anc
      com13 com23 3eqtr4d elnn0uz eluzfz2 syl5eqel swrdlen eqcomd oveq2d 3eqtrd
      cuz ) AGUAZIZBYIIZJZEKDLMIZFDDBUBNZUCMZLMIZJZJZCKFEOMZUDMIZCKDEOMZUDMIUEZ
      JZCABUFMZEFUGUHMNZCAEDUGUHMUBNZOMZBKFDOMZUGUHMZNZPYRUUCJZUUECEUCMZUUDNZCU
      UAOMZUUINZUUJUUKUUDYIIEKFLMIFKUUDUBNLMIUIZYTUUEUUMPYRUUPUUCABDEFGHUJQYRYT
      UUBUKGUUDEFCUNULUUKUULAUBNZOMZBNZUUNKUCMZBNZUUMUUOUUKUURUUTBUUCYRUURUUTPZ
      YTYRUVBRUUBYTCUOIZYRUVBCKYSUMYQUVCUVBRZYLYMUVDYPYMEUPIZDUPIZEDUQURZUIUVDE
      DUSUVEUVFUVDUVGUVEUVFJZUVCUVBDUUQPZUVHUVCJZUVBRHUVJUVBUVIUULDOMZUUTPZUVHE
      UTIZDUTIZJZCUTIZUVLUVCUVEUVMUVFUVNEVADVAVBCVCUVOUVPJZUUTUUNUVKUVQUUNUVQUV
      PUUAUTIZJZUUNUTIUVPUVOUVSUVOUVRUVPUVNUVMUVRDEVGVDVEVDCUUAVGVHVFUVQCDEUVOU
      VPVIUVMUVNUVPVJUVMUVNUVPVKVLVMVNUVIUURUVKUUTUURUVKPUUQDUUQDUULOVOVPVRVQVS
      VTWAWBQSWIQWCWDUUKYJYKUULUUQUUQYNUCMZUDMZIZUIZUUMUUSPUUKYLUWBUWCYLYQUUCVK
      UUKUULDYOUDMZIZUWBYRUUCUWEYQUUCUWERYLCDEFYOWESTUVIUWBUWEWFZHUWFUUQDUUQDPZ
      UWAUWDUULUWGUUQDUVTYOUDUWGWGUUQDYNUCWHWTWJVPVSWKYJYKUWBWLWMGABUULWNVHUUKY
      KKKUUHLMIZUUHKYNLMIZUUNKUUHKOMUDMIZUUOUVAPYRYKUUCYJYKYQVJQYRUWHUUCYQUWHYL
      YQUUHUPIZUWHYPUWKYMYPDUOIZYOUOIZFUOIZUIZDFUQURZFYOUQURZJZJZUWKFDYOWOZUWOU
      WRUWKUWLUWNUWRUWKRUWMUWRUWLUWNJZUWKUWPUXAUWKRUWQUXAUWPUWKUXAUWPJUUHUOIZKU
      UHUQURZUWKUXAUXBUWPUWNUWLUXBFDWPVDQUXAUWPUXCUXAUXCUWPUWNFWQIZDWQIZUXCUWPW
      FUWLFWRZDWRZFDWSXAXBTUUHXCWMXJQZXDXETWBSUUHXFVHSQYRUWIUUCYLYQUWIYKYQUWIRY
      JYKYNUPIZYQUWIGBXGYMYPUXIUWIRZYMUWLYPUXJREKDXHUWLUXIYPUWIUWLUXIYPUWIRUWLU
      XIJZUWSUWKUXIUUHYNUQURZUIZYPUWIUXKUWSUXMUXKUWSJUWKUXIUXLUXKUWSUWKUWLUWSUW
      KRUXIUWSUWLUWKUWOUWRUWLUWKRZUWNUWLUWRUXNRUWMUWRUWNUXNUWRUWLUWNUWKUXHXKXDX
      ITXDQTUWLUXIUWSVJUWSUXKUXLUWRUWOUXKUXLRZUWQUWOUXORUWPUXKUWOUWQUXLUXKUWOUW
      QUXLRZUXKUWOJZUXDUXEYNWQIZUIZUXPUXQUXDUXEUXRUWOUXDUXKUWNUWLUXDUWMUXFXISUX
      KUXEUWOUWLUXEUXIUXGQQUXKUXRUWOUXIUXRUWLYNXLSQXMUXSUXLUWQFDYNXNXBVHVTXRSWC
      WCXMVTUWTUUHYNUSXOVTXSVHTWISTQYRUUCUWJYQUUCUWJRYLCDEFYOXPSTGBKUUHUUNUNXQX
      TUUKUUNUUGUUIUUKUUAUUFCOUUKUUFUUAUUKYJYMDKUUQLMZIZUIZUUFUUAPYRUYBUUCYRYJY
      MUYAYJYKYQVKYLYMYPUKYLUYAYQYJUYAYKYJUUQUPIZUYAGAXGUYCDUUQUXTHUYCUUQKYHNIU
      UQUXTIUUQYAKUUQYBWBYCVHQQXMQGAEDYDVHYEYFWDYGVT $.

    $( Lemma 4 for ~ swrdccatin12 .  (Contributed by Alexander van der Vekens,
       30-Mar-2018.)  (Revised by Alexander van der Vekens, 27-May-2018.) $)
    swrdccatin12lem4 $p |- ( ( ( A e. Word V /\ B e. Word V )
          /\ ( M e. ( 0 ... L ) /\ N e. ( L ... ( L + ( # ` B ) ) ) ) )
                  -> ( ( K e. ( 0 ..^ ( N - M ) ) /\ K e. ( 0 ..^ ( L - M ) ) )
                       -> ( ( ( A concat B ) substr <. M , N >. ) ` K )
                          = ( ( A substr <. M , L >. ) ` K ) ) ) $=
      ( wcel wa cc0 cfz co cfv wceq w3a cn0 clt wbr wi cword chash cmin cconcat
      caddc cfzo cop csubstr simpll elfzo0 lencl cle elfz2nn0 nn0addcl 3ad2ant1
      cn ex com12 imp cz elnnz cr nn0re posdif syl2an elnn0z 0re a1i zre adantr
      wb adantl lelttr syl3anc nn0z anim1i sylibr exp3a impancom sylbi 3ad2ant2
      syld sylbird 3adant3 ltaddsubd exbiri com23 3adant2 impcom 3jca a1d eleq1
      a1ii breq2 3anbi23d imbi2d eqcoms mpsyl df-3an sylanbrc swrdccatin12lem3c
      3imtr4d syl simprl swrdfv syl2anc eleq1i elnn0uz eluzfz2 eqcomi syl6eleqr
      ccatval1 cuz oveq2i sylbir ad3antrrr simprr syl31anc 3eqtr4d ) AGUAZIZBXT
      IZJZEKDLMZIZFDDBUBNUEMLMIZJZJZCKFEUCMUFMIZCKDEUCMZUFMIZJZCABUDMZEFUGUHMNZ
      CAEDUGUHMNZOYHYLJZCEUEMZYMNZYQANZYNYOYPYAYBYQKAUBNZUFMIZPZYRYSOYPYCUUAUUB
      YCYGYLUIYPYQQIZYTUPIZYQYTRSZPZUUAYLYHUUFYKYHUUFTZYIYKCQIZYJUPIZCYJRSZPZUU
      GCYJUJYHUUKUUFYCYGUUKUUFTZYAYGUULTZYBDYTOYAYTQIZUUMHGAUKZUUNUUMTYTDYTDOZD
      QIZYGUUKUUCDUPIZYQDRSZPZTZTZUUNUUMUUPUUQUVBYEYFUVAYEEQIZUUQEDULSZPZYFUVAT
      EDUMUVEUVAYFUVEUUKUUTUVEUUKJUUCUURUUSUVEUUKUUCUVCUUQUUKUUCTUVDUUKUVCUUCUU
      HUUIUVCUUCTUUJUUHUVCUUCCEUNUQUOURUOUSUVEUUKUURUVCUUQUUKUURTUVDUUKUVCUUQJZ
      UURUUIUUHUVFUURTZUUJUUIYJUTIZKYJRSZJUVGYJVAUVIUVGUVHUVFUVIUURUVFUVIEDRSZU
      URUVCEVBIZDVBIZUVJUVIVKUUQEVCZDVCZEDVDVEUVCUUQUVJUURTZUVCEUTIZKEULSZJUUQU
      VOTEVFUVPUUQUVQUVOUVPUUQJZUVQUVJUURUVRUVQUVJJZKDRSZUURUVRKVBIZUVKUVLUVSUV
      TTUWAUVRVGVHUVPUVKUUQEVIVJUUQUVLUVPUVNVLKEDVMVNUUQUVTUURTUVPUUQUVTUURUUQU
      VTJDUTIZUVTJUURUUQUWBUVTDVOVPDVAVQUQVLWBVRVSVTUSWCURVLVTWAURWDUSUUKUVEUUS
      UUHUUJUVEUUSTZUUIUUHUUJUWCUUHUVEUUJUUSUUHUVEUUSUUJUUHUVEJCEDUUHCVBIUVECVC
      VJUVEUVKUUHUVCUUQUVKUVDUVMUOVLUVEUVLUUHUUQUVCUVLUVDUVNWAVLWEWFWGUSWHWIWJU
      QWKVTUSWMYTDQWLUUPUULUVAYGUUPUUFUUTUUKUUPUUDUURUUEUUSUUCYTDUPWLYTDYQRWNWO
      WPWPXBWQWRVJUSURVTVLWIYQYTUJVQYAYBUUAWSWTGABYQXLXCYPYMXTIEKFLMIFKYMUBNLMI
      PZYIYNYROYHUWDYLABDEFGHXAVJYHYIYKXDGYMEFCXEXFYPYAYEDKYTLMZIZYKYOYSOYHYAYL
      YAYBYGUIVJYHYEYLYCYEYFXDVJYAUWFYBYGYLYAUUNUWFUUOUUNUUQUWFDYTQHXGUUQDYDUWE
      UUQDKXMNIDYDIDXHKDXIVTYTDKLDYTHXJXNXKXOXCXPYHYIYKXQGAEDCXEXRXSUQ $.

    $( The subword of a concatenation of two words within both of the
       concatenated words.  (Contributed by Alexander van der Vekens,
       5-Apr-2018.)  (Revised by Alexander van der Vekens, 27-May-2018.) $)
    swrdccatin12 $p |- ( ( A e. Word V /\ B e. Word V )
     -> ( ( M e. ( 0 ... L ) /\ N e. ( L ... ( L + ( # ` B ) ) ) )
          -> ( ( A concat B ) substr <. M , N >. )
               = ( ( A substr <. M , L >. )
                   concat ( B substr <. 0 , ( N - L ) >. ) ) ) ) $=
      ( wcel wa cc0 cfz co cfv caddc wceq cfzo adantr w3a syl adantl vk cconcat
      cword chash cop csubstr cmin wfn ccatcl cz cle wbr wi elfz2 simpl1 simpl3
      cuz simprl eluz2 syl3anbrc fzss2 sseld sylbi impcom elfzuz2 fzss1 ccatlen
      wss eqcomi oveq1i syl6eq oveq2d sseqtr4d swrdvalfn syl3anc swrdcl anim12i
      impr ccatvalfn simpll cn0 lencl elnn0uz eluzfz2 syl5eqel swrdlen elfzmlbp
      simpr nn0zd swrd0len syl2anc oveq12d elfz2nn0 elfzelz nn0cn ad2antrl 3jca
      cc zcn ex com12 3adant3 imp npncan3 eqtr2d fneq2d mpbird cv anim2i ancomd
      swrdccatin12lem4 sylc simpl nn0fz0 biimpi eleqtrrd df-3an sylanbrc eqtr4d
      ccatval1 swrdccatin12lem3 elfzuz eluzelz ancoms swrdccatin12lem2 ccatval2
      wn syl5com jca pm2.61ian eqfnfvd ) AFUCZHZBYLHZIZDJCKLZHZECCBUDMZNLZKLZHZ
      IZABUBLZDEUEUFLZADCUEUFLZBJECUGLZUEUFLZUBLZOYOUUBIZUAJEDUGLZPLZUUDUUHUUIU
      UCYLHZDJEKLZHZEJUUCUDMZKLZHZUUDUUKUHYOUULUUBFABUIQUUBUUNYOUUAYQUUNUUACUJH
      ZYSUJHZEUJHZRZCEUKULZEYSUKULZIZIZYQUUNUMECYSUNUVEYPUUMDUVEECUQMHZYPUUMVHU
      VEUURUUTUVBUVFUURUUSUUTUVDUOUURUUSUUTUVDUPUVAUVBUVCURCEUSUTCJEVASVBVCVDTY
      OYQUUAUUQYOYQIZYTUUPEUVGYTJYSKLZUUPUVGCJUQMZHZYTUVHVHYQUVJYODJCVETCJYSVFS
      UVGUUOYSJKYOUUOYSOYQYOUUOAUDMZYRNLYSFABVGUVKCYRNCUVKGVIVJVKQVLVMVBVRFUUCD
      EVNVOUUIUUHUUKUHUUHJUUEUDMZUUGUDMZNLZPLZUHZUUIUUEYLHZUUGYLHZIZUVPYOUVSUUB
      YMUVQYNUVRFADCVPFBJUUFVPVQQZUUEUUGFVSSUUIUUKUVOUUHUUIUUJUVNJPUUIUVNCDUGLZ
      UUFNLZUUJUUIUVLUWAUVMUUFNUUIYMYQCJUVKKLZHZUVLUWAOZYMYNUUBVTZYOYQUUAURZYOU
      WDUUBYMUWDYNYMUVKWAHZUWDFAWBZUWHCUVKUWCGUWHUVKUVIHUVKUWCHZUVKWCJUVKWDVCWE
      SQQFADCWFZVOUUIYNUUFJYRKLHZUVMUUFOZYOYNUUBYMYNWHZQUUIYRUJHZUUAIUWLYOUWOUU
      BUUAYNUWOYMYNYRFBWBWITZYQUUAWHVQECYRWGZSFBUUFWJZWKWLUUICWRHZDWRHZEWRHZRZU
      WBUUJOUUBUXBYOYQUUAUXBYQDWAHZCWAHZDCUKULZRZUUAUXBUMZDCWMZUXCUXDUXGUXEUUAU
      XCUXDIZUXBUUAUUTUXIUXBUMECYSWNUUTUXIUXBUUTUXIIUWSUWTUXAUXIUWSUUTUXDUWSUXC
      CWOTTUXCUWTUUTUXDDWOWPUUTUXAUXIEWSQWQWTSXAXBVCXCTCDEXDSXEVLXFXGUAXHZJUWAP
      LZHZUUIUXJUUKHZIZUXJUUDMZUXJUUHMZOUXLUXNIZUXOUXJUUEMZUXPUXQUUIUXMUXLIUXOU
      XROUXLUUIUXMURUXQUXLUXMUXNUXMUXLUUIUXMWHZXIXJABUXJCDEFGXKXLUXQUVQUVRUXJJU
      VLPLZHZRZUXPUXROUXQUVSUYAUYBUUIUVSUXLUXMUVTWPUXQUXJUXKUXTUXLUXNXMUXQUVLUW
      AJPUXQYMYQUWDRZUWEUUIUYCUXLUXMUUIYMYQUWDUWFUWGYOUWDUUBYMUWDYNYMCUVKUWCGYM
      UWHUWJUWIUWHUWJUVKXNXOSWEQQZWQWPUWKSVLXPUVQUVRUYAXQXRFUUEUUGUXJXTSXSUXLYG
      ZUXNIZUXOUXJUVLUGLUUGMZUXPUYFUUIUXMUYEIZUXOUYGOUYEUUIUXMURUYFUYEUXMUXNUXM
      UYEUXSXIXJZABUXJCDEFGYAXLUYFUVQUVRUXJUVLUVNPLZHZRZUXPUYGOUYFUVSUYKUYLUUIU
      VSUYEUXMUVTWPUYFUXJUWAUWBPLZUYJUYFUXDUXCUUTRZUYHUXJUYMHUUIUYNUYEUXMUUBUYN
      YOUUAYQUYNUUAUVFYQUYNUMECYSYBUVFUUTYQUYNCEYCYQUXFUUTUYNUMZUXHUXCUXDUYOUXE
      UXDUXCUYOUXDUXCIZUUTUYNUYPUUTIUXDUXCUUTUXDUXCUUTVTUYPUXCUUTUXDUXCWHQUYPUU
      TWHWQWTYDXBVCYHSVDTWPUYIUXJCDEYEXLUUIUYJUYMOUYEUXMUUIUVLUWAUVNUWBPUUIYMYQ
      UWDUWEUWFUWGUYDUWKVOZUUIUVLUWAUVMUUFNUYQUUIYNUWLIZUWMUUBYOUYRUUAYOUYRUMYQ
      UUAYOUYRUUAYOIZYNUWLYOYNUUAUWNTUYSUWOUUAUWLYOUWOUUAUWPTUUAYOXMUWQWKYIWTTV
      DUWRSWLWLWPXPUVQUVRUYKXQXRFUUEUUGUXJYFSXSYJYKWT $.

    $( The subword of a concatenation is either a subword of the first
       concatenated word or a subword of the second concatenated word or a
       concatenation of a suffix of the first word with a prefix of the second
       word.  (Contributed by Alexander van der Vekens, 30-Mar-2018.)  (Revised
       by Alexander van der Vekens, 28-May-2018.) $)
    swrdccat3 $p |- ( ( A e. Word V /\ B e. Word V )
                -> ( ( M e. ( 0 ... N ) /\ N e. ( 0 ... ( L + ( # ` B ) ) ) )
                           -> ( ( A concat B ) substr <. M , N >. )
          = if ( N <_ L , ( A substr <. M , N >. ) ,
            if ( L <_ M , ( B substr <. ( M - L ) , ( N - L ) >. ) ,
                         ( ( A substr <. M , L >. )
                           concat ( B substr <. 0 , ( N - L ) >. ) ) ) ) ) ) $=
      ( wcel wa cfz co cle wbr wi cn0 adantr adantl ex imp w3a cword chash cmin
      cc0 cfv caddc cconcat cop csubstr cif simpll simpl ad2antlr lencl elfznn0
      wceq simplr breq2i biimpi elfz2nn0 syl3anbrc syl5com jca swrdccatin1 sylc
      wn simp1l eleq1i nn0z 3ad2ant2 3ad2ant1 3jca simpl3 anim1i elfz2 sylanbrc
      cz ancomd sylbi com12 sylbir syl a1d 3imp syl5eqel eqcomi clt cr wb nn0re
      ltnle syl2anr bicomd sylbid syl5bi imp32 swrdccatin2 syl2an impcom expcom
      ltle exp32 a1dd 3adant3 simp3 swrdccatin12 2if2 ) AFUAZHZBXHHZIZDUDEJKHZE
      UDCBUBUEUFKZJKHZIZABUGKDEUHZUIKZECLMZAXPUIKZCDLMZBDCUCKECUCKZUHUIKZADCUHU
      IKBUDYAUHUIKUGKZUJUJUPXKXOIZXRXTXSYBYCXQYDXRIZXKXLEUDAUBUEZJKHZIXQXSUPXKX
      OXRUKYEXLYGXOXLXKXRXLXNULUMYDXRYGXKXOXRYGNZXIXOYHNXJXIYFOHZXOYHFAUNZXNYIY
      HNXLXNYIYHXNYIIZXRYGYKXRIEOHZYIEYFLMZYGYKYLXRXNYLYIEXMUOPPXNYIXRUQXRYMYKX
      RYMCYFELGURUSQEYFUTVARRQVBPSSVCABDEFVDVEYDXRVFZXTTZXKDCEJKHZECXMJKHZIXQYB
      UPXKXOYNXTVGYOYPYQYDYNXTYPYDXTYPNZYNXKXOYRXIXOYRNZXJXIYIYSYJYICOHZYSCYFOG
      VHXOYTYRXLYTYRNZXNXLDOHZYLDELMZTZUUADEUTZUUDYTYRUUDYTIZXTYPUUFXTIZCVQHZEV
      QHZDVQHZTZXTUUCIYPUUFUUKXTUUFUUHUUIUUJYTUUHUUDCVIZQUUDUUIYTYLUUBUUIUUCEVI
      ZVJPUUDUUJYTUUBYLUUJUUCDVIVKPVLPUUGUUCXTUUFUUCXTUUBYLUUCYTVMVNVRDCEVOVPRR
      VSPVTWAWBPSWCWDYDYNXTYQYDYNYQXTXKXOYNYQNZXIXOUUNNXJXIYIXOUUNYJXNYIUUNNZXL
      XNYLXMOHZEXMLMZTZUUOEXMUTZUURYIYNYQUURYIYNIZIZUUHXMVQHZUUITZCELMZUUQIZYQU
      VAUUHUVBUUIUUTUUHUURYIUUHYNYICYFVQGYFVIWEPQUURUVBUUTUUPYLUVBUUQXMVIVJZPUU
      RUUIUUTYLUUPUUIUUQUUMVKZPVLUVAUVDUUQUURYIYNUVDYLUUPYIYNUVDNZNUUQYIYTYLUVH
      YFCOCYFGWFVHZYLYTUVHYLYTIZYNCEWGMZUVDUVJUVKYNYTCWHHZEWHHZUVKYNWIYLCWJZEWJ
      ZCEWKZWLWMYTUVLUVMUVKUVDNZYLUVNUVOCEXAZWLWNRWOVKWPYLUUPUUQUUTVMVCECXMVOZV
      PXBVSQVBPSXCWDVCABCDEFGWQVEYDYNXTVFZTZXKDUDCJKHZYQIXQYCUPXKXOYNUVTVGUWAUW
      BYQYDYNUVTUWBYDUVTUWBNZYNXKXOUWCXIXOUWCNXJXIYIXOUWCYJXLYIUWCNXNYIYTXLUWCU
      VIXLUUDYTUWCNZUUEUUBYLUWDUUCYTUUBYLIZUWCYTUWEIZUVTDCWGMZUWBUWFUWGUVTUWEDW
      HHZUVLUWGUVTWIYTUUBUWHYLDWJZPUVNDCWKWLWMUWEYTUWGUWBNZUUBYTUWJNYLUUBYTUWJU
      UBYTIZUWGUWBUWKUWGIUUBYTDCLMZUWBUUBYTUWGUKUUBYTUWGUQUWKUWGUWLUUBUWHUVLUWG
      UWLNYTUWIUVNDCXAWRSDCUTVARRPWSWNWTXDVSWOPVBPSWCWDYDYNUVTYQYDYNYQUVTXOXKUU
      NXNXKUUNNZXLXNUURUWMUUSXKUURUUNXIUURUUNNZXJXIYIUWNYJYIYTUWNUVIYTUURUUNYTU
      URIZYNUVKYQYTUVLUVMYNUVKWIUURUVNYLUUPUVMUUQUVOVKZUVLUVMIUVKYNUVPWMWRUWOUV
      KYQUWOUVKIZUVCUVEYQUWOUVCUVKUWOUUHUVBUUIYTUUHUURUULPUURUVBYTUVFQUURUUIYTU
      VGQVLPUWQUVDUUQUWOUVKUVDYTUVLUVMUVQUURUVNUWPUVRWRSUURUUQYTUVKYLUUPUUQXEUM
      VCUVSVPRWNRVSWBPVTVSQWSXCWDVCABCDEFGXFVEXGR $.

    $( The subword of a concatenation of two words as concatenation of subwords
       of the two concatenated words.  (Contributed by Alexander van der
       Vekens, 29-May-2018.) $)
    swrdccat $p |- ( ( A e. Word V /\ B e. Word V )
              -> ( ( M e. ( 0 ... N ) /\ N e. ( 0 ... ( L + ( # ` B ) ) ) )
                  -> ( ( A concat B ) substr <. M , N >. )
                     = ( ( A substr <. M , if ( N <_ L , N , L ) >. ) concat
                         ( B substr <. if ( 0 <_ ( M - L ) , ( M - L ) , 0 ) ,
                                                        ( N - L ) >. ) ) ) ) $=
      ( wcel wa cc0 co cconcat csubstr wceq wi adantr w3a c0 adantl syl cfz cfv
      cword chash caddc cop cle wbr cif swrdccat3 imp cn0 lencl eqcomi elfz2nn0
      cmin eleq1i iftrue opeq2d oveq2d opeq1d cz simpr nn0z zsubcl sylan sylan2
      anim12i 3anass sylibr ad2antrl cr nn0re wb subge0 adantlr simpl 3jca letr
      exp3a com23 sylbid syl2an impcom lesub1 mpbid swrdltnd sylc eqtrd iffalse
      jca a1i suble0 biimpar sylan9eq pm2.61ian oveq12d swrdcl ccatrid 3ad2ant2
      wn 0z 3anim123i 3expb 3adant2 biimprd ccatlid 3ad2ant1 con3and 2if2 com12
      biimpd ex 3adant3 sylbi com13 mpcom eqtr4d ) AFUCZHZBXSHZIZDJEUAKHZEJCBUD
      UBUEKUAKHZIZABLKDEUFZMKZADECUGUHZECUIZUFZMKZBJDCUPKZUGUHZYLJUIZECUPKZUFZM
      KZLKZNYBYEIYGYHAYFMKZCDUGUHZBYLYOUFZMKZADCUFZMKZBJYOUFZMKZLKZUIUIZYRYBYEY
      GUUHNABCDEFGUJUKYBYEYRUUHNZAUDUBZULHZYBYEUUIOZXTUUKYAFAUMPUUKCULHZYBUULOU
      UJCULCUUJGUNUQYEYBUUMUUIYCYBUUMUUIOZOZYDYCDULHZEULHZDEUGUHZQUUODEUOUUPUUQ
      UUOUURYBUUPUUQIZUUNYBUUSUUMUUIYBUUSUUMIZUUIYBUUTIZYHYTYSUUBUUGYRUVAYHIZYR
      YSRLKZYSUVBYKYSYQRLUVBYJYFAMUVBYIEDYHYIENUVAYHECURSUSUTYMUVBYQRNYMUVBIZYQ
      UUBRYMYQUUBNUVBYMYPUUABMYMYNYLYOYMYLJURVAZUTPUVDYAYLVBHZYOVBHZQZYOYLUGUHZ
      UUBRNUVAUVHYMYHUVAYAUVFUVGIZIUVHYBYAUUTUVJXTYAVCZUUMUUSCVBHZUVJCVDZUUSUVL
      IUVFUVGUUSDVBHZUVLUVFUUPUVNUUQDVDPZDCVEVFUUSEVBHZUVLUVGUUQUVPUUPEVDSZECVE
      ZVFWKVGVHYAUVFUVGVIVJVKUVDEDUGUHZUVIUVBYMUVSUVAYHYMUVSOZUUTYHUVTOZYBUUSDV
      LHZEVLHZIZCVLHZUWAUUMUUPUWBUUQUWCDVMZEVMZVHCVMZUWDUWEIZYMYHUVSUWIYMYTYHUV
      SOUWBUWEYMYTVNZUWCDCVOZVPUWIYHYTUVSUWIYHYTUVSUWIUWCUWEUWBQYHYTIUVSOUWIUWC
      UWEUWBUWDUWCUWEUWBUWCVCPUWDUWEVCUWDUWBUWEUWBUWCVQPVRECDVSTVTWAWBWAWCSUKWD
      UVDUWCUWBUWEQZUVSUVIVNUVAUWLYMYHUUTUWLYBUUTUWCUWBUWEUUSUWCUUMUUQUWCUUPUWG
      SZPUUSUWBUUMUUPUWBUUQUWFPZPUUMUWEUUSUWHSVRSVKEDCWETWFYLYOFBWGWHWIYMXAZUVB
      YQUUFRUWOYPUUEBMUWOYNJYOYMYLJWJZVAUTUVBYAJVBHZUVGQYOJUGUHZUUFRNUVBYAUWQUV
      GUVAYAYHYBYAUUTUVKPPUWQUVBXBWLUVAUVGYHUUTUVGYBUUSUVPUVLUVGUUMUVQUVMUVRWCS
      PVRUVAUWRYHUVAUWCUWEIZUWRYHVNUUTUWSYBUUSUWCUUMUWEUWMUWHVHSECWMTWNJYOFBWGW
      HWOWPWQUVAUVCYSNZYHYBUWTUUTXTUWTYAXTYSXSHUWTFADEWRFYSWSTPPPWIUVAYHXAZYTQZ
      YRRUUBLKZUUBUXBYKRYQUUBLUXBYKUUDRUXBYJUUCAMUXBYICDUXAUVAYICNZYTYHECWJZWTU
      SUTUVAYTUUDRNZUXAUVAYTUXFUVAXTUVNUVLQZYTUXFOYBUUSUUMUXGYBXTUUSUVNUUMUVLXT
      YAVQUVOUVMXCXDDCFAWGTUKXEWIUXBYPUUABMUXBYMYPUUANUVAYTYMUXAUVAYTYMUUTYTYMO
      YBUUTYMYTUUSUWBUWEUWJUUMUWNUWHUWKWCXFSUKXEUVETUTWQUVAUXAUXCUUBNZYTYBUXHUU
      TYBUUBXSHZUXHYAUXIXTFBYLYOWRSFUUBXGTPXHWIUVAUXAYTXAZQZYKUUDYQUUFLUXKYJUUC
      AMUXKYICDUXAUVAUXDUXJUXEWTUSUTUXKYPUUEBMUXKYNJYOUXKUWOYNJNUVAUXJUWOUXAUVA
      YMYTUVAYMYTUUTUWJYBUUPUUMUWJUUQUUPUWBUWEUWJUUMUWFUWHUWKWCVPSXLXIXEUWPTVAU
      TWQXJXMVTXKXNXOPXPXOXQUKXRXM $.

    $( A prefix of a concatenation is either a prefix of the first concatenated
       word or a concatenation of the first word with a prefix of the second
       word.  (Contributed by Alexander van der Vekens, 31-Mar-2018.)  (Revised
       by Alexander van der Vekens, 29-May-2018.) $)
    swrdccat3a $p |- ( ( A e. Word V /\ B e. Word V )
                      -> ( N e. ( 0 ... ( L + ( # ` B ) ) )
                           -> ( ( A concat B ) substr <. 0 , N >. )
         = if ( N <_ L , ( A substr <. 0 , N >. ) ,
                         ( A concat ( B substr <. 0 , ( N - L ) >. ) ) ) ) ) $=
      ( wcel wa cc0 co cconcat cop csubstr cmin cif wceq cn0 syl imp adantr cfv
      cword chash caddc cfz cle wbr elfznn0 0elfz ancri swrdccat3 sylan2 iftrue
      adantl wn w3a iffalse 3ad2ant2 wi wb lencl nn0le0eq0 biimpd eqeq1i biimpi
      syl5eqel c0 hasheq0 syl5ib 0cn subidi oveq2 eqcoms syl5eqr opeq1d oveq12d
      oveq2d swrdcl ccatlid eqtrd ex syld 3adant2 opeq2i oveq2i swrdid 3ad2ant1
      syl5req oveq1d 2if2 eqtr4d ) AEUBZGZBWLGZHZDICBUCUAUDJZUEJGZABKJIDLZMJZDC
      UFUGZAWRMJZABIDCNJZLZMJZKJZOZPWOWQHZWSWTXACIUFUGZBICNJZXBLZMJZAICLZMJZXDK
      JZOOZXFWQWOIIDUEJGZWQHZWSXOPZWQXPWQDQGXPDWPUHDUIRUJWOXQXRABCIDEFUKSULXGWT
      XHXAXKXNXFWTXFXAPXGWTXAXEUMUNXGWTUOZXHUPXFXEXKXSXGXFXEPZXHWTXAXEUQZURXGXH
      XEXKPZXSXGXHYBWOXHYBUSWQWOXHCIPZYBWMXHYCUSWNWMXHYCWMCQGXHYCUTWMCAUCUAZQFE
      AVAVFCVBRVCTWOYCYBWOYCHZXEVGXKKJZXKYEAVGXDXKKWOYCAVGPZWMYCYGUSWNYCYDIPZWM
      YGYCYHCYDIFVDVEAWLVHVITSYEXCXJBMYEIXIXBYCIXIPWOYCIIINJZXIIVJVKYIXIPICICIN
      VLVMVNUNVOVQVPWOYFXKPZYCWNYJWMWNXKWLGYJEBXIXBVREXKVSRUNTVTWAWBTSWCVTXGXSX
      HUOZUPZXFXEXNXSXGXTYKYAURYLAXMXDKXGXSAXMPZYKWOYMWQWMYMWNWMXMAIYDLZMJAXLYN
      AMCYDIFWDWEEAWFWHTTWGWIVTWJWKWA $.

    $( Lemma for ~ swrdccat3b .  (Contributed by Alexander van der Vekens,
       30-May-2018.) $)
    swrdccat3blem $p |- ( ( ( ( A e. Word V /\ B e. Word V )
              /\ M e. ( 0 ... ( L + ( # ` B ) ) ) ) /\ ( L + ( # ` B ) ) <_ L )
                    -> if ( L <_ M , ( B substr <. ( M - L ) , ( # ` B ) >. ) ,
                                     ( ( A substr <. M , L >. ) concat B ) )
                                = ( A substr <. M , ( L + ( # ` B ) ) >. ) ) $=
      ( wcel wa cc0 co cle cop csubstr wceq wi cn0 syl c0 oveq2d adantr cfv cfz
      cword chash caddc wbr cmin cconcat cif lencl nn0le0eq0 biimpd hasheq0 imp
      adantl eqcomi eleq1i nn0re w3a elfz2nn0 recn addid1d breq2d anim1i ancoms
      cr wb letri3 biimprd exp4b com23 sylbid com3l impcom 3adant2 com12 syl5bi
      sylbi elfznn0 swrd00 eqtr4i nn0cn subidd opeq1d 3eqtr4a eleq1 oveq1 opeq1
      opeq2d a1i eqeq12d 3imtr4d a1d syld wn swrdcl ccatrid addid1 eqcomd eqtrd
      cc ifeqda ex ad3antrrr oveq2 eleq2d simpr oveq12d ifeq12d imbi12d adantll
      opeq2 mpbird mpdan sylbir leaddle0 syl2an pm2.24 syl6bi pm2.61d ) AEUCZGZ
      BYAGZHZDICBUDUAZUEJZUBJZGZHZYFCKUFZHYEIKUFZCDKUFZBDCUGJZYELZMJZADCLZMJZBU
      HJZUIZADYFLZMJZNZYIYKUUBOZYJYDYHUUCYDYKYHUUBYDYKYEINZYHUUBOZYCYKUUDOZYBYC
      YEPGZUUFEBUJZUUGYKUUDYEUKULQUOYDUUDUUEYDUUDHZBRNZUUEYDUUDUUJYCUUDUUJOYBYC
      UUDUUJBYAUMULUOUNUUIUUJHUUEDICIUEJZUBJZGZYLRYMILZMJZYQRUHJZUIZADUUKLZMJZN
      ZOZYBUVAYCUUDUUJYBUUMUUTYBUUMHZYLUUOUUPUUSUVBYLUUOUUSNZUVBYLDCNZUVCYBUUMY
      LUVDOZYBAUDUAZPGZUUMUVEOZEAUJZUVGCPGZUVHUVFCPCUVFFUPUQZUVJCVFGZUVHCURZUUM
      DPGZUUKPGZDUUKKUFZUSZUVLUVEDUUKUTUVQUVLUVEUVNUVPUVLUVEOZUVOUVPUVNUVRUVLUV
      PUVNUVEUVLUVPDCKUFZUVNUVEOUVLUUKCDKUVLCCVAVBVCUVLUVNUVSUVEUVLUVNUVSYLUVDU
      VLUVNHZUVDUVSYLHZUVTDVFGZUVLHZUVDUWAVGUVNUVLUWCUVNUWBUVLDURVDVEDCVHQVIVJV
      KVLVMVNVOVPVQQVRQUNUUMYBUVDUVCOZUUMUVNYBUWDODUUKVSUVNUWDYBUVDUVNUVCUVDUVJ
      RCCUGJZILZMJZACUUKLZMJZNZUVNUVCUVJUWJOUVDUVJRIILZMJZACCLZMJZUWGUWIUWLRUWN
      RIVTACVTWAUVJUWFUWKRMUVJUWEIIUVJCCWBZWCWDSUVJUWHUWMAMUVJUUKCCUVJCUWOVBWIS
      WEWJDCPWFUVDUUOUWGUUSUWIUVDUUNUWFRMUVDYMUWEIDCCUGWGWDSUVDUURUWHAMDCUUKWHS
      WKWLVPWMQVNWNUNUVBUUPUUSNZYLWOYBUWPUUMYBUUPYQUUSYBYQYAGUUPYQNEADCWPEYQWQQ
      YBYPUURAMYBCUUKDYBCXAGZCUUKNYBUVGUWQUVIUVGUVJUWQUVKUWOVRQUWQUUKCCWRWSQWIS
      WTTTXBXCXDUUDUUJUUEUVAVGYDUUDUUJHZYHUUMUUBUUTUUDYHUUMVGUUJUUDYGUULDUUDYFU
      UKIUBYEICUEXEZSXFTUWRYSUUQUUAUUSUWRYLYOUUOYRUUPUWRBRYNUUNMUUDUUJXGUUDYNUU
      NNUUJYEIYMXLTXHUUJYRUUPNUUDBRYQUHXEUOXIUUDUUAUUSNUUJUUDYTUURAMUUDYFUUKDUW
      SWISTWKXJXKXMXNXCWNVKUNTYIYJYKWOUUBOZYDYJUWTOYHYDYJYKUWTYBUVLYEVFGZYJYKVG
      YCYBUVGUVLUVIUVGUVJUVLCUVFPFUQUVMXOQYCUUGUXAUUHYEURQCYEXPXQYKUUBXRXSTUNXT
      $.

    $( A suffix of a concatenation is either a suffix of the second
       concatenated word or a concatenation of a suffix of the first word with
       the second word.  (Contributed by Alexander van der Vekens,
       31-Mar-2018.)  (Revised by Alexander van der Vekens, 30-May-2018.) $)
    swrdccat3b $p |- ( ( A e. Word V /\ B e. Word V )
                 -> ( M e. ( 0 ... ( L + ( # ` B ) ) )
                      -> ( ( A concat B ) substr <. M , ( L + ( # ` B ) ) >. )
         = if ( L <_ M , ( B substr <. ( M - L ) , ( # ` B ) >. ) ,
                         ( ( A substr <. M , L >. ) concat B ) ) ) ) $=
      ( wcel wa cc0 cfv co cconcat cop csubstr cle wbr cif wceq w3a cc cfz cmin
      cword chash caddc simpl simpr cn0 elfz2nn0 elnn0uz eluzfz2 sylbi 3ad2ant2
      cuz adantl swrdccat3 imp syl12anc swrdccat3blem wn iftrue 3ad2ant3 nn0cnd
      lencl eqcomi eleq1i pncan2 sylanb syl2an eqcomd adantr opeq2d oveq2d 2if2
      3ad2ant1 eqtrd iffalse swrdid eqtr2d eqtr4d ex ) AEUCZGZBWBGZHZDICBUDJZUE
      KZUAKZGZABLKDWGMZNKZCDOPZBDCUBKZWFMZNKZADCMNKZBLKZQZRWEWIHZWKWGCOPZAWJNKZ
      WLBWMWGCUBKZMZNKZWPBIXBMZNKZLKZQQZWRWSWEWIWGWHGZWKXHRZWEWIUFWEWIUGWIXIWEW
      IDUHGZWGUHGZDWGOPZSXIDWGUIXLXKXIXMXLWGIUNJGXIWGUJIWGUKULUMULUOWEWIXIHXJAB
      CDWGEFUPUQURWSWTWLXAXDXGWRABCDEFUSWSWTUTZWLSZWRWOXDWLWSWRWORXNWLWOWQVAVBX
      OWNXCBNXOWFXBWMWSXNWFXBRZWLWEXPWIWEXBWFWCAUDJZTGZWFTGZXBWFRZWDWCXQEAVDVCW
      DWFEBVDVCXRCTGXSXTXQCTCXQFVEVFCWFVGVHVIZVJVKVOVLVMVPWSXNWLUTZSZWRWQXGYBWS
      WRWQRXNWLWOWQVQVBYCBXFWPLYCXFBIWFMZNKZBYCXEYDBNYCXBWFIWSXNXTYBWEXTWIYAVKV
      OVLVMWSXNYEBRZYBWEYFWIWDYFWCEBVRUOVKVOVSVMVPVNVTWA $.
  $}

  ${
    swrdccat.l $e |- ( ph -> ( # ` A ) = L ) $.
    ${
      swrdccatin1.d $e |- ( ph -> ( ( A e. Word V /\ B e. Word V )
                             /\ ( M e. ( 0 ... N ) /\ N e. ( 0 ... L ) ) ) ) $.
      $( The subword of a concatenation of two words within the first of the
         concatenated words.  (Contributed by Alexander van der Vekens,
         31-May-2018.) $)
      swrdccatin1d $p |- ( ph -> ( ( A concat B ) substr <. M , N >. )
                                 = ( A substr <. M , N >. ) ) $=
        ( cword wcel wa cc0 cfz co chash cfv csubstr wceq anbi2d cconcat cop wb
        oveq2 eleq2d eqcoms syl5ib mpcom swrdccatin1 imp syl ) ABGJZKCULKLZEMFN
        OKZFMBPQZNOZKZLZLZBCUAOEFUBZROBUTROSZUODSZAUSHAUMUNFMDNOZKZLZLVBUSIVBVE
        URUMVBVDUQUNVDUQUCDUODUOSVCUPFDUOMNUDUEUFTTUGUHUMURVABCEFGUIUJUK $.
    $}

    ${
      swrdccatin2.d $e |- ( ph -> ( ( A e. Word V /\ B e. Word V )
             /\ ( M e. ( L ... N ) /\ N e. ( L ... ( L + ( # ` B ) ) ) ) ) ) $.
      $( The subword of a concatenation of two words within the second of the
         concatenated words.  (Contributed by Alexander van der Vekens,
         31-May-2018.) $)
      swrdccatin2d $p |- ( ph -> ( ( A concat B ) substr <. M , N >. )
                                = ( B substr <. ( M - L ) , ( N - L ) >. ) ) $=
        ( chash cfv wceq co cop csubstr cmin wcel wa cfz caddc cconcat cword id
        oveq1 eleq2d oveq12d anbi12d anbi2d syl5ibr eqid swrdccatin2 syl6 oveq2
        imp opeq12d oveq2d eqeq2d sylibd mpcom ) BJKZDLZABCUAMEFNOMZCEDPMZFDPMZ
        NZOMZLZHVAAVBCEUTPMZFUTPMZNZOMZLZVGVAABGUBZQCVMQRZEUTFSMZQZFUTUTCJKZTMZ
        SMZQZRZRZVLAWBVAVNEDFSMZQZFDDVQTMZSMZQZRZRIVAWAWHVNVAVPWDVTWGVAVOWCEUTD
        FSUDUEVAVSWFFVAUTDVRWESVAUCUTDVQTUDUFUEUGUHUIVNWAVLBCUTEFGUTUJUKUNULVAV
        KVFVBVAVJVECOVAVHVCVIVDUTDEPUMUTDFPUMUOUPUQURUS $.
    $}

    ${
      swrdccatin12.d $e |- ( ph -> ( ( A e. Word V /\ B e. Word V )
             /\ ( M e. ( 0 ... L ) /\ N e. ( L ... ( L + ( # ` B ) ) ) ) ) ) $.
      $( The subword of a concatenation of two words within both of the
         concatenated words.  (Contributed by Alexander van der Vekens,
         31-May-2018.) $)
      swrdccatin12d $p |- ( ph -> ( ( A concat B ) substr <. M , N >. )
                               = ( ( A substr <. M , L >. )
                                 concat ( B substr <. 0 , ( N - L ) >. ) ) ) $=
        ( wceq cconcat co cop csubstr cc0 cmin wa wcel cfz caddc chash cword wb
        cfv adantl oveq2 eleq2d oveq1 oveq12d anbi12d anbi2d adantr mpbird eqid
        id swrdccatin12 imp syl ex opeq2 oveq2d opeq2d eqeq2d sylibd mpcom ) BU
        AUDZDJZABCKLEFMNLZBEDMZNLZCOFDPLZMZNLZKLZJZHVGAVHBEVFMZNLZCOFVFPLZMZNLZ
        KLZJZVOVGAWBVGAQZBGUBZRCWDRQZEOVFSLZRZFVFVFCUAUDZTLZSLZRZQZQZWBWCWMWEEO
        DSLZRZFDDWHTLZSLZRZQZQZAWTVGIUEVGWMWTUCAVGWLWSWEVGWGWOWKWRVGWFWNEVFDOSU
        FUGVGWJWQFVGVFDWIWPSVGUOVFDWHTUHUIUGUJUKULUMWEWLWBBCVFEFGVFUNUPUQURUSVG
        WAVNVHVGVQVJVTVMKVGVPVIBNVFDEUTVAVGVSVLCNVGVRVKOVFDFPUFVBVAUIVCVDVE $.
    $}
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Finite and infinite sums - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d A k x $.  $d B x $.
    $( A finite sum with integer summands is an integer.  (Contributed by
       Alexander van der Vekens, 31-Aug-2018.) $)
    fsumz $p |- ( ( A e. Fin /\ A. k e. A B e. ZZ )
                            -> sum_ k e. A B e. ZZ ) $=
      ( vx cfn wcel cz wral wa csu cv csb nfcv nfcsb1v csbeq1a cbvsumi simpl wi
      rspcsbela expcom adantl imp fsumzcl syl5eqel ) AEFZBGFCAHZIZABCJACDKZBLZD
      JGABUICDDBMCUHBNCUHBOPUGAUIDUEUFQUGUHAFZUIGFZUFUJUKRUEUJUFUKCUHABGSTUAUBU
      CUD $.

    $d X k x $.
    $( A finite sum with one of its integer summands removed is a real number.
       (Contributed by Alexander van der Vekens, 31-Aug-2018.) $)
    fsummsndifre $p |- ( ( A e. Fin /\ A. k e. A B e. ZZ )
                            -> sum_ k e. ( A \ { X } ) B e. RR ) $=
      ( vx cfn wcel cz wral wa csn cdif csu cv csb nfcv nfcsb1v csbeq1a cbvsumi
      cr diffi adantr wi eldifi rspcsbela sylan zred expcom adantl imp fsumrecl
      syl5eqel ) AFGZBHGCAIZJZADKZLZBCMUQCENZBOZEMTUQBUSCEEBPCURBQCURBRSUOUQUSE
      UMUQFGUNAUPUAUBUOURUQGZUSTGZUNUTVAUCUMUTUNVAUTUNJUSUTURAGUNUSHGURAUPUDCUR
      ABHUEUFUGUHUIUJUKUL $.

    $( Separate out a term in a finite sum by splitting the sum into two
       parts.  (Contributed by Alexander van der Vekens, 31-Aug-2018.) $)
    fsumsplitsndif $p |- ( ( A e. Fin /\ X e. A /\ A. k e. A B e. ZZ )
          -> sum_ k e. A B = ( sum_ k e. ( A \ { X } ) B + [_ X / k ]_ B ) ) $=
      ( vx cfn wcel cz wral csu caddc co csb wceq cun cc rspcsbela zcnd cbvsumi
      wa w3a csn cdif cv wn cin neldifsnd disjsn sylibr uncom simp2 snssd undif
      c0 wss sylib syl5req simp1 expcom 3ad2ant3 fsumsplit nfcv nfcsb1v csbeq1a
      wi imp oveq12i 3eqtr4g 3adant1 sumsns syl2anc oveq2d eqtrd ) AFGZDAGZBHGC
      AIZUAZABCJZADUBZUCZBCJZVSBCJZKLZWACDBMZKLVQACEUDZBMZEJVTWFEJZVSWFEJZKLVRW
      CVQVTVSWFAEVQDVTGUEVTVSUFUNNVQDAUGVTDUHUIVQVTVSOVSVTOZAVTVSUJVQVSAUOWIANV
      QDAVNVOVPUKZULVSAUMUPUQVNVOVPURVQWEAGZWFPGZVPVNWKWLVEVOWKVPWLWKVPTWFCWEAB
      HQRUSUTVFVAABWFCEEBVBZCWEBVCZCWEBVDZSWAWGWBWHKVTBWFCEWMWNWOSVSBWFCEWMWNWO
      SVGVHVQWBWDWAKVQVOWDPGZWBWDNWJVOVPWPVNVOVPTWDCDABHQRVIBCDAVJVKVLVM $.

    $d N k x $.
    $( A finite sum of summands modulo a positive number with one of its
       summands removed is a real number.  (Contributed by Alexander van der
       Vekens, 31-Aug-2018.) $)
    fsummmodsndifre $p |- ( ( A e. Fin /\ N e. NN /\ A. k e. A B e. ZZ )
                            -> sum_ k e. ( A \ { X } ) ( B mod N ) e. RR ) $=
      ( vx cfn wcel cn cz cmo co csu csb cr wa wi cvv adantr syl5eqel wral cdif
      w3a cv nfcv nfcsb1v csbeq1a cbvsumi diffi 3ad2ant1 eldifi rspcsbela sylan
      csn expcom 3ad2ant3 imp wceq vex csbov1g ax-mp zre adantl crp nnrp modcld
      ex 3ad2ant2 mpd fsumrecl ) AGHZDIHZBJHCAUAZUCZAEUNZUBZBDKLZCMVPCFUDZVQNZF
      MOVPVQVSCFFVQUECVRVQUFCVRVQUGUHVNVPVSFVKVLVPGHVMAVOUIUJVNVRVPHZPCVRBNZJHZ
      VSOHZVNVTWBVMVKVTWBQVLVTVMWBVTVRAHVMWBVRAVOUKCVRABJULUMUOUPUQVNWBWCQZVTVL
      VKWDVMVLWBWCVLWBPZVSWADKLZOVRRHVSWFURFUSCVRBDKRUTVAWEWADWBWAOHVLWAVBVCVLD
      VDHWBDVESVFTVGVHSVIVJT $.
  $}

  ${
    $d A k $.  $d k z $.
    $( Lemma 1 for ~ modfsummods .  (Contributed by Alexander van der Vekens,
       1-Sep-2018.) $)
    modfsummodslem1 $p |- ( A. k e. ( A u. { z } ) B e. ZZ
                            -> [_ z / k ]_ B e. ZZ ) $=
      ( cv csn cun wcel cz wral csb vex snid elun2 ax-mp rspcsbela mpan ) AEZBR
      FZGZHZCIHDTJDRCKIHRSHUARALMRSBNODRTCIPQ $.

    $d A k x $.  $d B x $.  $d k x z $.
    $( A finite sum with an additional integer summand is an integer.
       (Contributed by Alexander van der Vekens, 1-Sep-2018.) $)
    fsummsnunz $p |- ( ( A e. Fin /\ A. k e. ( A u. { z } ) B e. ZZ )
                       -> sum_ k e. ( A u. { z } ) B e. ZZ ) $=
      ( vx cfn wcel cz cv csn cun wral wa csu nfcv nfcsb1v csbeq1a cbvsumi snfi
      csb a1i unfi syldan wi rspcsbela expcom adantl imp fsumzcl syl5eqel ) BFG
      ZCHGDBAIZJZKZLZMZUNCDNUNDEIZCTZENHUNCURDEECODUQCPDUQCQRUPUNUREUKUOUMFGZUN
      FGUSUPULSUABUMUBUCUPUQUNGZURHGZUOUTVAUDUKUTUOVADUQUNCHUEUFUGUHUIUJ $.

    $( Separate out a term in a finite sum by splitting the sum into two
       parts.  (Contributed by Alexander van der Vekens, 1-Sep-2018.) $)
    fsumsplitsnun $p |- ( ( A e. Fin /\ z e/ A
                             /\ A. k e. ( A u. { z } ) B e. ZZ )
                           -> sum_ k e. ( A u. { z } ) B
                              = ( sum_ k e. A B + [_ z / k ]_ B ) ) $=
      ( vx cfn wcel cv wnel cz csu caddc co csb wceq rspcsbela 3ad2ant3 cbvsumi
      zcnd cvv csn cun w3a cin c0 wn df-nel disjsn biimpri sylbi 3ad2ant2 eqidd
      wral snfi unfi mpan2 3ad2ant1 wa wi expcom fsumsplit nfcv nfcsb1v csbeq1a
      imp oveq12i 3eqtr4g vex snid elun2 ax-mp mpan sumsns sylancr oveq2d eqtrd
      cc ) BFGZAHZBIZCJGDBVSUAZUBZUMZUCZWBCDKZBCDKZWACDKZLMZWFDVSCNZLMWDWBDEHZC
      NZEKBWKEKZWAWKEKZLMWEWHWDBWAWKWBEVTVRBWAUDUEOZWCVTVSBGUFZWNVSBUGWNWOBVSUH
      UIUJUKWDWBULVRVTWBFGZWCVRWAFGWPVSUNBWAUOUPUQWDWJWBGZURWKWDWQWKJGZWCVRWQWR
      USVTWQWCWRDWJWBCJPUTQVESVAWBCWKDEECVBZDWJCVCZDWJCVDZRWFWLWGWMLBCWKDEWSWTX
      ARWACWKDEWSWTXARVFVGWDWGWIWFLWDVSTGWIVQGZWGWIOAVHZWCVRXBVTWCWIVSWBGZWCWIJ
      GVSWAGXDVSXCVIVSWABVJVKDVSWBCJPVLSQCDVSTVMVNVOVP $.

    $d N k x $.
    $( A finite sum of summands modulo a positive number with an additional
       summand is an integer.  (Contributed by Alexander van der Vekens,
       1-Sep-2018.) $)
    fsummmodsnunre $p |- ( ( A e. Fin /\ N e. NN
                             /\ A. k e. ( A u. { z } ) B e. ZZ )
                           -> sum_ k e. ( A u. { z } ) ( B mod N ) e. ZZ ) $=
      ( vx cfn wcel cn cz cv csn cmo co csu csb wa wi cvv syl5eqel cun wral w3a
      nfcv nfcsb1v csbeq1a cbvsumi snfi unfi 3ad2ant1 rspcsbela expcom 3ad2ant3
      mpan2 imp wceq csbov1g ax-mp simpr simpl zmodcld nn0zd ex 3ad2ant2 adantr
      vex mpd fsumzcl ) BGHZEIHZCJHDBAKZLZUAZUBZUCZVMCEMNZDOVMDFKZVPPZFOJVMVPVR
      DFFVPUDDVQVPUEDVQVPUFUGVOVMVRFVIVJVMGHZVNVIVLGHVSVKUHBVLUIUNUJVOVQVMHZQDV
      QCPZJHZVRJHZVOVTWBVNVIVTWBRVJVTVNWBDVQVMCJUKULUMUOVOWBWCRZVTVJVIWDVNVJWBW
      CVJWBQZVRWAEMNZJVQSHVRWFUPFVFDVQCEMSUQURWEWFWEWAEVJWBUSVJWBUTVAVBTVCVDVEV
      GVHT $.
  $}

  ${
    $d A k $.  $d N k $.  $d k z $.
    $( Induction step for ~ modfsummod .  (Contributed by Alexander van der
       Vekens, 1-Sep-2018.) $)
    modfsummods $p |- ( ( A e. Fin /\ N e. NN
                          /\ A. k e. ( A u. { z } ) B e. ZZ )
              -> ( ( sum_ k e. A B mod N ) = ( sum_ k e. A ( B mod N ) mod N )
                   -> ( sum_ k e. ( A u. { z } ) B mod N )
                        = ( sum_ k e. ( A u. { z } ) ( B mod N ) mod N ) ) ) $=
      ( wcel cz wral csu cmo co wceq oveq1d sylbi syl wa caddc adantl adantr cr
      cv cfn cn csn cun w3a wi wss snssi ssequn1 wb uncom eqeq1i sumeq1 eqeq12d
      eqcoms biimpd a1d wn wnel df-nel csb simp1 simpl simpr3 fsumsplitsnun crp
      3jca ralunb fsumz sylan2 zred modfsummodslem1 3ad2ant3 3ad2ant2 modaddabs
      3adant2 nnrp syl3anc eqcomd simpr jca modabs2 oveq12d eqtrd zmodcl expcom
      nn0zd ralimdv impcom 3adant1 cn0 anim1i ancoms nn0red imp cvv vex csbov1g
      com12 mp1i oveq2d 3eqtrd exp31 sylbir pm2.61i ) AUAZBFZBUBFZEUCFZCGFZDBXG
      UDZUEZHZUFZBCDIZEJKZBCEJKZDIZEJKZLZXMCDIZEJKZXMXRDIZEJKZLZUGZUGZXHXLBUHZY
      HXGBUIYIXLBUEZBLZYHXLBUJYKYGXOYKYAYFYKXMBLYAYFUKZYJXMBXLBULUMYLBXMBXMLZXQ
      YCXTYEYMXPYBEJBXMCDUNMYMXSYDEJBXMXRDUNMUOUPNUQURNOXHUSXGBUTZYHXGBVAYNXOYA
      YFYNXOPZYAPZYCXPDXGCVBZQKZEJKZXTYQEJKZEJKZQKZEJKZYEYPYBYREJYPXIYNXNUFZYBY
      RLYOUUDYAYOXIYNXNXOXIYNXIXJXNVCZRZYNXOVDZYNXIXJXNVEVHSABCDVFOMYPYSXQYTQKZ
      EJKZUUCYOYSUUILYAYOUUIYSYOXPTFYQTFZEVGFZUUIYSLYOXPXOXPGFZYNXIXNUULXJXNXIX
      KDBHZUULXNUUMXKDXLHZPZUUMXKDBXLVIZUUMUUNVDNBCDVJVKVQRVLYOYQXOYQGFZYNXNXIU
      UQXJABCDVMZVNRVLXOUUKYNXJXIUUKXNEVRVORZXPYQEVPVSVTSYPUUHUUBEJYPXQXTYTUUAQ
      YOYAWAYPUUJUUKPZYTUUALYOUUTYAYOUUJUUKXOUUJYNXNXIUUJXJXNYQUURVLVNRUUSWBSUU
      TUUAYTYQEWCVTOWDMWEYPUUCXSYTQKZEJKZYEYPXSTFZYTTFZUUKUUCUVBLYOUVCYAXOUVCYN
      XOXIXRGFZDBHZPZUVCXOXIUVFUUEXJXNUVFXIXNXJUVFXNUUOXJUVFUGZUUPUUMUVHUUNXJUU
      MUVFXJXKUVEDBXKXJUVEXKXJPXRCEWFWHWGZWIWTSNWJWKWBUVGXSBXRDVJVLORSYOUVDYAXO
      UVDYNXJXNUVDXIXJXNPZYTUVJUUQXJPZYTWLFXNXJUVKXNUUQXJUURWMWNYQEWFOWOWKRSYOU
      UKYAUUSSXSYTEVPVSYPUVAYDEJYPYDUVAYPYDXSDXGXRVBZQKZUVAYPXIYNUVEDXMHZYDUVML
      YOXIYAUUFSYOYNYAUUGSYOUVNYAXOUVNYNXJXNUVNXIXJXNUVNXJXKUVEDXMUVIWIWPWKRSAB
      XRDVFVSYPUVLYTXSQXGWQFUVLYTLYPAWRDXGCEJWQWSXAXBWEVTMWEXCXDXEXF $.
  $}

  ${
    $d A k x y z $.  $d B x y z $.  $d N k x y z $.
    modfsummod.n $e |- ( ph -> N e. NN ) $.
    modfsummod.1 $e |- ( ph -> A e. Fin ) $.
    modfsummod.2 $e |- ( ph -> A. k e. A B e. ZZ ) $.
    $( A finite sum modulo a positive real number equals the finite sum of
       their summands modulo the positive real number, modulo the positive real
       number.  (Contributed by Alexander van der Vekens, 1-Sep-2018.) $)
    modfsummod $p |- ( ph -> ( sum_ k e. A B mod N )
                            = ( sum_ k e. A ( B mod N ) mod N ) ) $=
      ( wcel wral csu cmo co wceq wa wi c0 raleq sumeq1 oveq1d vx vy vz cfn csn
      cz cn cv cun anbi1d eqeq12d imbi12d weq cc0 sum0 a1i oveq1i adantl simpll
      syl6reqr simplrr ralun ad2antrl imp modfsummods syl3anc a2d ralunb anbi1i
      ex com23 imbi1i an32 impexp 3bitri syl6ibr findcard2 syl mp2and ) ACUFIZD
      BJZEUGIZBCDKZELMZBCELMZDKZELMZNZHFABUDIWAWBOZWHPZGVTDUAUHZJZWBOZWKCDKZELM
      ZWKWEDKZELMZNZPVTDQJZWBOZQCDKZELMZQWEDKZELMZNZPVTDUBUHZJZWBOZXFCDKZELMZXF
      WEDKZELMZNZPZVTDXFUCUHUEZUIZJZWBOZXPCDKZELMZXPWEDKZELMZNZPZWJUAUBUCBWKQNZ
      WMWTWRXEYEWLWSWBVTDWKQRUJYEWOXBWQXDYEWNXAELWKQCDSTYEWPXCELWKQWEDSTUKULUAU
      BUMZWMXHWRXMYFWLXGWBVTDWKXFRUJYFWOXJWQXLYFWNXIELWKXFCDSTYFWPXKELWKXFWEDST
      UKULWKXPNZWMXRWRYCYGWLXQWBVTDWKXPRUJYGWOXTWQYBYGWNXSELWKXPCDSTYGWPYAELWKX
      PWEDSTUKULWKBNZWMWIWRWHYHWLWAWBVTDWKBRUJYHWOWDWQWGYHWNWCELWKBCDSTYHWPWFEL
      WKBWEDSTUKULWBXEWSWBXDUNELMXBWBXCUNELXCUNNWBWEDUOUPTXAUNELCDUOUQUTURXFUDI
      ZXNXHVTDXOJZYCPZPZYDYIXHXMYKYIXHXMYKPYIXHOZYJXMYCYMYJXMYCPZYMYJOYIWBXQYNY
      IXHYJUSYIXGWBYJVAYMYJXQXGYJXQPYIWBXGYJXQVTDXFXOVBVJVCVDUCXFCDEVEVFVJVKVJV
      GYDXGYJOZWBOZYCPXHYJOZYCPYLXRYPYCXQYOWBVTDXFXOVHVIVLYPYQYCXGYJWBVMVLXHYJY
      CVNVOVPVQVRVS $.
  $}

  $( If an integer is divisible by a positive number, the product of this
     integer with another integer modulo the positive number is 0.
     (Contributed by Alexander van der Vekens, 30-Aug-2018.) $)
  mulmoddvds $p |- ( ( N e. NN /\ A e. ZZ /\ B e. ZZ ) -> ( N || A
                  -> ( ( A x. B ) mod N ) = 0 ) ) $=
    ( cn wcel cz w3a cdivides wbr cmul co cmo cc0 wa cr adantr syl oveq1d eqtrd
    wceq crp zre id 3anim123i 3comr modmulmod eqcomd wb dvdsval3 3adant3 biimpa
    nnrp zcn mul02d adantl 0mod 3adant2 ex ) CDEZAFEZBFEZGZCAHIZABJKCLKZMTVBVCN
    ZVDACLKZBJKZCLKZMVEAOEZVACUAEZGZVDVHTVBVKVCUTVAUSVKUTVIVAVAUSVJAUBVAUCCULZU
    DUEPVKVHVDABCUFUGQVEVHMBJKZCLKZMVEVGVMCLVEVFMBJVBVCVFMTZUSUTVCVOUHVACAUIUJU
    KRRVBVNMTZVCUSVAVPUTUSVANZVNMCLKZMVQVMMCLVAVMMTUSVABBUMUNUORUSVRMTZVAUSVJVS
    VLCUPQPSUQPSSUR $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                             The divides relation
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)


$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
             Prime numbers: elementary properties - extension
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( A prime number is an integer greater than 1.  (Contributed by Alexander
     van der Vekens, 17-May-2018.) $)
  prmgt1 $p |- ( P e. Prime -> 1 < P ) $=
    ( cprime wcel c2 cuz cfv c1 clt wbr prmuz2 cz cle w3a eluz2 caddc wceq df-2
    co a1i breq1d wb 1z zltp1le mpan biimprd sylbid imp 3adant1 sylbi syl ) ABC
    ADEFCZGAHIZAJUKDKCZAKCZDALIZMULDANUNUOULUMUNUOULUNUOGGORZALIZULUNDUPALDUPPU
    NQSTUNULUQGKCUNULUQUAUBGAUCUDUEUFUGUHUIUJ $.

  $( A prime number divides an integer minus 1 iff the integer modulo the prime
     number is 1.  (Contributed by Alexander van der Vekens, 17-May-2018.) $)
  modprm1div $p |- ( ( P e. Prime /\ A e. ZZ )
                     -> ( ( A mod P ) = 1 <-> P || ( A - 1 ) ) ) $=
    ( cprime wcel cz wa cmo co c1 wceq cmin cdivides wbr clt prmnn nnred prmgt1
    cr 1mod adantr eqcomd syl2anc eqeq2d cn wb simpr a1i moddvds syl3anc bitrd
    1z ) BCDZAEDZFZABGHZIJUOIBGHZJZBAIKHLMZUNIUPUOULIUPJZUMULBRDZIBNMZUSULBBOZP
    BQUTVAFUPIBSUAUBTUCUNBUDDZUMIEDZUQURUEULVCUMVBTULUMUFVDUNUKUGAIBUHUIUJ $.

  ${
    modprminv.1 $e |- R = ( ( A ^ ( P - 2 ) ) mod P ) $.
    $( Show an explicit expression for the modular inverse of ` A mod P ` .
       This is an application of ~ prmdiv .  (Contributed by Alexander van der
       Vekens, 15-May-2018.) $)
    modprminv $p |- ( ( P e. Prime /\ A e. ZZ /\ -. P || A )
               -> ( R e. ( 1 ... ( P - 1 ) ) /\ ( ( A x. R ) mod P ) = 1 ) ) $=
      ( cprime wcel cz cdivides wbr wn w3a c1 cmin co cfz cmul cmo wceq sylan2
      wa prmdiv wb wi elfzelz zmulcl modprm1div expr 3adant3 pm5.32d mpbird ) B
      EFZAGFZBAHIJZKZCLBLMNZONFZACPNZBQNLRZTUPBUQLMNHIZTABCDUAUNUPURUSUKULUPURU
      SUBZUCUMUKULUPUTULUPTUKUQGFZUTUPULCGFVACLUOUDACUESUQBUFSUGUHUIUJ $.

    $( The modular inverse of ` A mod P ` is unique.  (Contributed by Alexander
       van der Vekens, 17-May-2018.) $)
    modprminveq $p |- ( ( P e. Prime /\ A e. ZZ /\ -. P || A )
                  -> ( ( S e. ( 0 ... ( P - 1 ) ) /\ ( ( A x. S ) mod P ) = 1 )
                       <-> S = R ) ) $=
      ( cprime wcel cz cdivides wbr wn w3a cc0 c1 cmin co cfz wceq wa sylan2 wb
      cmul cmo wi elfzelz zmulcl modprm1div expr 3adant3 pm5.32d prmdiveq bitrd
      ) BFGZAHGZBAIJKZLZDMBNOPZQPGZADUBPZBUCPNRZSURBUSNOPIJZSDCRUPURUTVAUMUNURU
      TVAUAZUDUOUMUNURVBUNURSUMUSHGZVBURUNDHGVCDMUQUEADUFTUSBUGTUHUIUJABCDEUKUL
      $.
  $}

  ${
    $d N i s $.  $d P i s $.
    $( For any prime number and for any positive integer less than this prime
       number, there is a unique modular inverse of this positive integer.
       (Contributed by Alexander van der Vekens, 12-May-2018.) $)
    reumodprminv $p |- ( ( P e. Prime /\ N e. ( 1 ..^ P ) )
                   -> E! i e. ( 1 ... ( P - 1 ) ) ( ( N x. i ) mod P ) = 1 ) $=
      ( vs wcel c1 co wa cv cmul cmo wceq wi cmin cfz wral cz syl jca cc0 c2 wn
      cprime cfzo weq wrex wreu cdivides wbr simpl elfzoelz adantl prmnn adantr
      cexp prmz fzoval eleq2d biimpa fzm1ndvds w3a eqid modprminv simpld simprd
      cn cuz cfv wss cn0 1nn0 elnn0uz mpbi fzss1 3ad2ant1 imdistani modprminveq
      mp1i sseld eqcomd expr ralrimiva syl3anc oveq2 oveq1d eqeq1d eqeq1 imbi2d
      ralbidv anbi12d rspcev reu8 sylibr ) AUCEZCFAUDGZEZHZCBIZJGZAKGZFLZCDIZJG
      ZAKGZFLZBDUEZMZDFAFNGZOGZPZHZBXIUFZXABXIUGWQCAUANGUOGAKGZXIEZCXMJGZAKGZFL
      ZXEXMXBLZMZDXIPZHZHZXLWQWNCQEZACUHUIUBZYBWNWPUJWPYCWNCFAUKULWQAVFEZCXIEZH
      YDWQYEYFWNYEWPAUMUNWNWPYFWNWOXICWNAQEWOXILAUPFAUQRURUSSACUTRWNYCYDVAZXNYA
      YGXNXQCAXMXMVBZVCZVDYGXQXTYGXNXQYIVEYGXSDXIYGXBXIEZHYGXBTXHOGZEZHXSYGYJYL
      WNYCYJYLMYDWNXIYKXBFTVGVHEZXIYKVIWNFVJEYMVKFVLVMFTXHVNVRVSVOVPYGYLXEXRYGY
      LXEHZHXBXMYGYNXBXMLCAXMXBYHVQUSVTWARWBSSWCXKYABXMXIWRXMLZXAXQXJXTYOWTXPFY
      OWSXOAKWRXMCJWDWEWFYOXGXSDXIYOXFXRXEWRXMXBWGWHWIWJWKRXAXEBDXIXFWTXDFXFWSX
      CAKWRXBCJWDWEWFWLWM $.
  $}

  ${
    $d I j r $.  $d N j r $.  $d P j r $.
    $( For two positive integers less than a given prime number there is always
       a nonnegative integer (less than the given prime number) so that the sum
       of one of the two positive integers and the other of the positive
       integers multiplied by the nonnegative integer is 0 ( modulo the given
       prime number).  (Contributed by Alexander van der Vekens,
       17-May-2018.) $)
    modprm0 $p |- ( ( P e. Prime /\ N e. ( 1 ..^ P ) /\ I e. ( 1 ..^ P ) )
                   -> E. j e. ( 0 ..^ P ) ( ( I + ( j x. N ) ) mod P ) = 0 ) $=
      ( vr wcel c1 co cmul caddc cmo cc0 wceq wa cmin cz 3ad2ant1 adantl oveq1d
      cr cprime cfzo w3a cv wrex wi cfz wreu reumodprminv reurex cn prmz adantr
      elfzelz elfzoelz 3ad2ant3 zmulcl syl2an zsubcld prmnn zmodfzo syl2anc crp
      zred nnred remulcl resubcld 3ad2ant2 nnrpd modaddmulmod syl31anc cc nncnd
      zcnd mulcl subdird oveq2d mulcom modidmul0 syl2anr eqtrd mul32d modmulmod
      3adant3 syl3anc eqtr4d oveq12d remulcld modsubmodmod impancom imp mulid2d
      eqeq1d biimpd cle wbr clt anim12ci cuz cfv elfzo2 eluz2 0re a1i 3jca 0le1
      1re zre anim1i letr sylc 3adant1 sylbi simp3 jca 3adant2 modid modadd2mod
      syl 3eqtr3d 0cn pncan3d 0mod 3eqtrd oveq1 rspcev rexlimiva 3syl pm2.43i
      ex ) AUAFZDGAUBHZFZCYLFZUCZCBUDZDIHZJHZAKHZLMZBLAUBHZUEZYKYMYOUUBUFZYNYKY
      MNZDEUDZIHZAKHZGMZEGAGOHZUGHZUHUUHEUUJUEUUCAEDUIUUHEUUJUJUUHUUCEUUJUUEUUJ
      FZUUHNZYOUUBUULYONZAUUECIHZOHZAKHZUUAFZCUUPDIHZJHZAKHZLMZUUBUUMUUOPFAUKFZ
      UUQUUMAUUNYOAPFZUULYKYMUVCYNAULQRUULUUEPFZCPFZUUNPFYOUUKUVDUUHUUEGUUIUNZU
      MYNYKUVEYMCGAUOZUPZUUECUQURUSYOUVBUULYKYMUVBYNAUTZQRUUOAVAVBUUMUUTCUUODIH
      ZJHZAKHZCADIHZUUNDIHZOHZJHZAKHZLUUMCTFZUUOTFDPFZAVCFZUUTUVLMYOUVRUULYNYKU
      VRYMYNCUVGVDZUPZRZUUMAUUNYOATFZUULYKYMUWDYNYKAUVIVEZQRUULUUETFZUVRUUNTFYO
      UUKUWFUUHUUKUUEUVFVDUMZUWBUUECVFURZVGYOUVSUULYMYKUVSYNDGAUOZVHRYOUVTUULYK
      YMUVTYNYKAUVIVIZQRZCUUODAVJVKUUMUVKUVPAKUUMUVJUVOCJUUMAUUNDYOAVLFZUULYKYM
      UWLYNYKAUVIVMZQRUULUUEVLFZCVLFZUUNVLFYOUUKUWNUUHUUKUUEUVFVNZUMZYNYKUWOYMY
      NCUVGVNZUPZUUECVOURYODVLFZUULYMYKUWTYNYMDUWIVNZVHZRZVPVQSUUMCUVOAKHZJHZAK
      HZCLCOHZAKHZJHZAKHZUVQLUUMUXEUXIAKUUMUXDUXHCJUUMUVMAKHZUVNAKHZOHZAKHZLUUE
      DIHZAKHZCIHZAKHZOHZAKHZUXDUXHUUMUXMUXSAKUUMUXKLUXLUXROYOUXKLMZUULYKYMUYAY
      NUUDUXKDAIHZAKHZLUUDUVMUYBAKYKUWLUWTUVMUYBMYMUWMUXAADVRURSYMUVSUVBUYCLMYK
      UWIUVIDAVSVTWAWDRUUMUXLUXOCIHZAKHZUXRUUMUVNUYDAKUUMUUECDUULUWNYOUWQUMYOUW
      OUULUWSRZUXCWBSUUMUXOTFZUVEUVTUXRUYEMUULUWFDTFZUYGYOUWGYMYKUYHYNYMDUWIVDZ
      VHZUUEDVFURYOUVEUULUVHRUWKUXOCAWCWEWFWGSUUMUVMTFZUVNTFUVTUXNUXDMYOUYKUULY
      KYMUYKYNYKUWDUYHUYKYMUWEUYIADVFURWDRZUUMUUNDUWHYOUYHUULUYJRWHZUWKUVMUVNAW
      IWEUUMUXTLGCIHZAKHZOHZAKHUXHUUMUXSUYPAKUUMUXRUYOLOUUMUXQUYNAKUUMUXPGCIUUL
      YOUXPGMZUUKYOUUHUYQUUKYONZUUHUYQUYRUUGUXPGUYRUUFUXOAKYOUWTUWNUUFUXOMUUKUX
      BUWPDUUEVRVTSWMWNWJWKSSVQSUUMUYPUXGAKUUMUYOCLOUUMUYOCAKHZCUUMUYNCAKUUMCUY
      FWLSUUMUVRUVTNZLCWOWPZCAWQWPZNZNZUYSCMYOVUDUULYKYNVUDYMYKYNNZUYTVUCYKUVTY
      NUVRUWJUWAWRYNVUCYKYNCGWSWTFZUVCVUBUCZVUCCGAXAVUGVUAVUBVUFUVCVUAVUBVUFGPF
      ZUVEGCWOWPZUCVUAGCXBUVEVUIVUAVUHUVEVUINLTFZGTFZUVRUCZLGWOWPZVUINVUAUVEVUL
      VUIUVEVUJVUKUVRVUJUVEXCXDVUKUVEXGXDCXHXEUMUVEVUMVUIVUMUVEXFXDXILGCXJXKXLX
      MQVUFUVCVUBXNXOXMRXOXPRCAXQXSWAVQSWAXTVQSUUMUVOTFUVRUVTUXFUVQMUUMUVMUVNUY
      LUYMVGUWCUWKUVOCAXRWEUUMUXJCUXGJHZAKHZLAKHZLUUMUXGTFZUVRUVTUCZUXJVUOMYOVU
      RUULYKYNVURYMVUEVUQUVRUVTYNVUQYKYNLCVUJYNXCXDUWAVGRYNUVRYKUWARYKUVTYNUWJU
      MXEXPRUXGCAXRXSUUMVUNLAKYOVUNLMZUULYNYKVUSYMYNCLUWRLVLFYNYAXDYBUPRSYOVUPL
      MZUULYKYMVUTYNYKUVTVUTUWJAYCXSQRYDXTYDYTUVABUUPUUAYPUUPMZYSUUTLVVAYRUUSAK
      VVAYQUURCJYPUUPDIYEVQSWMYFVBYJYGYHWDYI $.
  $}

  ${
    $d i j n p $.
    $( For two positive integers less than a given prime number there is always
       a nonnegative integer (less than the given prime number) so that the sum
       of one of the two positive integers and the other of the positive
       integers multiplied by the nonnegative integer is 0 ( modulo the given
       prime number).  (Contributed by Alexander van der Vekens,
       17-May-2018.) $)
    modprm0g $p |- A. p e. Prime A. n e. ( 1 ..^ p ) A. i e. ( 1 ..^ p )
                   E. j e. ( 0 ..^ p ) ( ( i + ( j x. n ) ) mod p ) = 0 $=
      ( cv cmul co caddc cmo cc0 wceq cfzo wrex cprime c1 modprm0 rgen3 ) AEZBE
      CEZFGHGDEZIGJKBJTLGMDCANOTLGZUATBRSPQ $.
  $}

  $( Subtracting 2 from a prime number results in a nonnegative integer.
     (Contributed by Alexander van der Vekens, 30-Aug-2018.) $)
  prmm2nn0 $p |- ( P e. Prime -> ( P - 2 ) e. NN0 ) $=
    ( cprime wcel c2 cuz cfv cmin co cn0 prmuz2 uznn0sub syl ) ABCADEFCADGHICAJ
    DAKL $.

  $( If an integer minus 1 is divisible by a prime number, the integer itself
     is not divisible by this prime number.  (Contributed by Alexander van der
     Vekens, 30-Aug-2018.) $)
  m1dvdsndvds $p |- ( ( P e. Prime /\ A e. ZZ )
                      -> ( P || ( A - 1 ) -> -. P || A ) ) $=
    ( cprime wcel cz wa cmo co c1 wceq cc0 wn cmin cdivides wbr wi ax-1ne0 neii
    wb eqeq1 eqcoms mtbii a1i modprm1div cn prmnn dvdsval3 sylan bicomd 3imtr3d
    notbid ) BCDZAEDZFZABGHZIJZUOKJZLZBAIMHNOBANOZLUPURPUNUPIKJZUQIKQRUTUQSIUOI
    UOKTUAUBUCABUDUNUQUSUNUSUQULBUEDUMUSUQSBUFBAUGUHUIUKUJ $.

  $( If an integer minus 1 is divisible by a prime number, then the integer to
     the power of the prime number minus 2 is 1 modulo the prime number.
     (Contributed by Alexander van der Vekens, 30-Aug-2018.) $)
  powm2modprm $p |- ( ( P e. Prime /\ A e. ZZ ) -> ( P || ( A - 1 )
                  -> ( ( A ^ ( P - 2 ) ) mod P ) = 1 ) ) $=
    ( wcel cz wa c1 cmin co cdivides wbr cmo wceq cmul simpr adantr syl syl3anc
    oveq1d cr zmodcld cprime cexp simpll m1dvdsndvds imp w3a cfz eqid modprminv
    c2 wn eqcomd modprm1div biimpar crp zre ad2antlr cn0 prmm2nn0 anim2i ancoms
    zexpcl prmnn nn0zd nnrpd modmulmod nn0cnd mulid2d reexpcl syl2anr jca eqtrd
    cn modabs2 3eqtr3d eqtr2d ex ) BUACZADCZEZBAFGHIJZABUJGHZUBHZBKHZFLVTWAEZFA
    WDMHBKHZWDWEVRVSBAIJUKZFWFLZVRVSWAUCVTVSWAVRVSNOVTWAWGABUDUEVRVSWGUFWDFBFGH
    UGHCZWFFLZEZWHABWDWDUHUIWKWFFWIWJNULPQWEABKHZWDMHZBKHZFWDMHZBKHZWFWDWEWMWOB
    KWEWLFWDMVTWLFLWAABUMUNRRWEASCZWDDCBUOCZWNWFLVSWQVRWAAUPZUQWEWDWEWCBWEVSWBU
    RCZEZWCDCZVTXAWAVSVRXAVRWTVSBUSZUTVAZOAWBVBZPVTBVMCZWAVRXFVSBVCZOZOTVDVTWRW
    AVRWRVSVRBXGVEOZOAWDBVFQWEWPWDBKHZWDVTWPXJLWAVTWOWDBKVTWDVTWDVTWCBVTXAXBXDX
    EPXHTVGVHROWEWCSCZWREZXJWDLVTXLWAVTXKWRVSWQWTXKVRWSXCAWBVIVJXIVKOWCBVNPVLVO
    VPVQ $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
    Words over a set - extension (cyclic shift)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
A word/string can be regarded as "necklace" by connecting the two ends of the
word/string together (see Wikipedia "Necklace (combinatorics)",
~ https://en.wikipedia.org/wiki/Necklace_(combinatorics) ).

Two strings are regarded as the same necklace if one string can be
rotated/circularly shifted/cyclically shifted to obtain the second string.
To cope with words in the sense of necklaces, the rotation/cyclic shift
` CyclShift ` is defined as the basic operation, see ~ df-csh . The main
theorems in this section are about counting the number of different necklaces
resulting from cyclically shifting a given word, see ~ cshwssizesame for words
consisting of identical symbols and ~ cshwssize for words having lengths which
are prime numbers.
$)

  $c CyclShift $.
  $c LastS $.

  $( Extend class notation with Cyclical Shifts. $)
  ccsh $a class CyclShift $.

  $( Extend class notation with the Last Symbol of a word. $)
  clswrd $a class LastS $.

  ${
    $d f l n w $.
    $( Perform a cyclic shift for an arbitrary class.  Meaningful only for
       words ` w e. Word S ` or at least functions over an half-open range of
       nonnegative integers.  The result is also only meaningful if
       ` 0 <_ n <_ ( # `` w ) ` .  (Contributed by Alexander van der Vekens,
       20-May-2018.) $)
    df-csh $a |- CyclShift
                 = ( w e. { f | E. l e. NN0 f Fn ( 0 ..^ l ) } , n e. NN0
                   |-> ( ( w substr <. n , ( # ` w ) >. )
                         concat ( w substr <. 0 , n >. ) ) ) $.
  $}

  ${
    $d n v w $.
    $( Extract the last symbol of a word.  May be not meaningful for other sets
       which are not words.  The name ` LastS ` (as abbreviation of
       "LastSymbol") is a compromise between usually used names for
       corresponding functions in computer programs (as last() or lastChar()),
       the terminology used for words in set.mm ("symbol" instead of
       "character") and brevity ("LastS" is shorter than "LastChar" and
       "LastSymbol").  (Contributed by Alexander van der Vekens,
       18-Mar-2018.) $)
    df-lswrd $a |- LastS = ( w e. _V |-> ( w ` ( ( # ` w ) - 1 ) ) ) $.
  $}

  ${
    $d N n w $.  $d W n w $.  $d f l n w $.
    $( Perform a cyclic shift for a function over a range of nonnegative
       integers.  (Contributed by Alexander van der Vekens, 20-May-2018.) $)
    cshfn $p |- ( ( W e. { f | E. l e. NN0 f Fn ( 0 ..^ l ) } /\ N e. NN0 )
                -> ( W CyclShift N ) = ( ( W substr <. N , ( # ` W ) >. )
                                         concat ( W substr <. 0 , N >. ) ) ) $=
      ( vw vn cv cc0 co cn0 wcel wa chash cfv csubstr cconcat ccsh wceq oveq12d
      cop cfzo wfn wrex cab cvv cmpt2 df-csh a1i simpl simpr fveq2 adantr opeq2
      opeq12d adantl ovex ovmpt2d ) CAGHDGUAIUBDJUCAUDZKZBJKZLZEFCBURJEGZFGZVBM
      NZTZOIZVBHVCTZOIZPIZCBCMNZTZOIZCHBTZOIZPIZQUEQEFURJVIUFRVAEAFDUGUHVBCRZVC
      BRZLZVIVORVAVRVFVLVHVNPVRVBCVEVKOVPVQUIZVRVCBVDVJVPVQUJVPVDVJRVQVBCMUKULU
      NSVRVBCVGVMOVSVQVGVMRVPVCBHUMUOSSUOUSUTUIUSUTUJVOUEKVAVLVNPUPUHUQ $.
  $}

  ${
    $d V l $.  $d W l w $.
    $( Perform a cyclic shift for a word.  (Contributed by Alexander van der
       Vekens, 20-May-2018.) $)
    cshword $p |- ( ( W e. Word V /\ N e. NN0 )
                -> ( W CyclShift N ) = ( ( W substr <. N , ( # ` W ) >. )
                                         concat ( W substr <. 0 , N >. ) ) ) $=
      ( vw vl cword wcel cv cc0 cfzo co wfn cn0 wrex cab ccsh chash cop csubstr
      wceq cfv cconcat wf iswrd ffn reximi sylbi fneq1 elabg mpbird cshfn sylan
      rexbidv ) CBFZGZCDHZIEHJKZLZEMNZDOGZAMGCAPKCACQUARSKCIARSKUBKTUOUTCUQLZEM
      NZUOUQBCUCZEMNVBBCEUDVCVAEMUQBCUEUFUGUSVBDCUNUPCTURVAEMUQUPCUHUMUIUJDACEU
      KUL $.
  $}

  ${
    $d f l n w $.
    $( A cyclical shift is the empty set if the number of shifts is not a
       nonnegative integer.  (Contributed by Alexander van der Vekens,
       21-May-2018.) $)
    cshnnn0 $p |- ( -. N e. NN0 -> ( W CyclShift N ) = (/) ) $=
      ( vf vl vw vn cn0 wcel wn ccsh cdm cv cc0 cfzo co wfn cop csubstr cconcat
      wceq wrex cab cxp wa c0 chash cfv df-csh dmmpt2 id intnand ndmovg sylancr
      ovex ) AGHZIZJKCLMDLNOPDGUACUBZGUCTBUQHZUOUDIBAJOUETEFUQGELZFLZUSUFUGQROZ
      USMUTQROZSOJECFDUHVAVBSUNUIUPUOURUPUJUKBAUQGJULUM $.
  $}

  $( A cyclically shifted word is the empty set if the number of shifts is out
     of the range of the word.  (Contributed by Alexander van der Vekens,
     16-May-2018.)  (Revised by Alexander van der Vekens, 21-May-2018.) $)
  cshwoor $p |- ( ( W e. Word V /\ N e. NN0 )
                 -> ( ( # ` W ) < N -> ( W CyclShift N ) = (/) ) ) $=
    ( cword wcel wa clt wbr co c0 cop csubstr cc0 cconcat adantr cz w3a cle cvv
    wceq cn0 chash cfv ccsh cshword w3o simpl nn0z adantl lencl nn0zd cr nn0red
    3jca wi nn0re ltle syl2an imp 3mix2 syl swrdnd 0z a1i 3mix3 oveq12d ccatlid
    sylc wrd0 mp1i 3eqtrd ex ) CBDEZAUAEZFZCUBUCZAGHZCAUDIZJTVOVQFZVRCAVPKLIZCM
    AKLIZNIZJJNIZJVOVRWBTVQABCUEOVSVTJWAJNVSVMAPEZVPPEZQZAMGHZVPARHZVPVPGHZUFZV
    TJTVOWFVQVOVMWDWEVMVNUGZVNWDVMAUHUIZVMWEVNVMVPBCUJZUKOUNOVSWHWJVOVQWHVMVPUL
    EAULEVQWHUOVNVMVPWMUMAUPVPAUQURUSWHWGWIUTVAAVPBCVBVHVSVMMPEZWDQZMMGHZAMRHZV
    QUFZWAJTVOWOVQVOVMWNWDWKWNVOVCVDWLUNOVQWRVOVQWPWQVEUIMABCVBVHVFJSDEWCJTVSSV
    ISJVGVJVKVL $.

  $( A word cyclically shifted by 0 is the word itself.  (Contributed by
     Alexander van der Vekens, 16-May-2018.)  (Revised by Alexander van der
     Vekens, 20-May-2018.) $)
  cshw0 $p |- ( W e. Word V -> ( W CyclShift 0 ) = W ) $=
    ( cword wcel cc0 ccsh co chash cfv cop csubstr cconcat c0 wceq 0nn0 cshword
    cn0 mpan2 swrdid swrd00 a1i oveq12d ccatrid 3eqtrd ) BACDZBEFGZBEBHIJKGZBEE
    JKGZLGZBMLGBUEEQDUFUINOEABPRUEUGBUHMLABSUHMNUEBETUAUBABUCUD $.

  $( A word cyclically shifted by its length is the word itself.  (Contributed
     by Alexander van der Vekens, 16-May-2018.)  (Revised by Alexander van der
     Vekens, 20-May-2018.) $)
  cshwn $p |- ( W e. Word V -> ( W CyclShift ( # ` W ) ) = W ) $=
    ( cword wcel chash cfv ccsh co cop csubstr cc0 cconcat c0 cn0 lencl cshword
    wceq mpdan swrd00 a1i swrdid oveq12d ccatlid 3eqtrd ) BACDZBBEFZGHZBUFUFIJH
    ZBKUFIJHZLHZMBLHBUEUFNDUGUJQABOUFABPRUEUHMUIBLUHMQUEBUFSTABUAUBABUCUD $.

  $( A cyclically shifted word is a word over the same set as for the original
     word.  (Contributed by Alexander van der Vekens, 16-May-2018.)  (Revised
     by Alexander van der Vekens, 21-May-2018.) $)
  cshwcl $p |- ( W e. Word V -> ( W CyclShift N ) e. Word V ) $=
    ( cn0 wcel cword ccsh co wi wa chash cfv cop csubstr cconcat cshword swrdcl
    cc0 ccatcl syl2anc adantr eqeltrd expcom wn c0 cshnnn0 syl6eqel a1d pm2.61i
    wrd0 ) ADEZCBFZEZCAGHZULEZIUMUKUOUMUKJUNCACKLZMNHZCRAMNHZOHZULABCPUMUSULEZU
    KUMUQULEURULEUTBCAUPQBCRAQBUQURSTUAUBUCUKUDZUOUMVAUNUEULACUFBUJUGUHUI $.

  $( The length of a cyclically shifted word is the same as the length of the
     original word.  (Contributed by Alexander van der Vekens, 16-May-2018.)
     (Revised by Alexander van der Vekens, 20-May-2018.) $)
  cshwlen $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) ) )
                  -> ( # ` ( W CyclShift N ) ) = ( # ` W ) ) $=
    ( cword wcel cc0 chash cfv cfz co wa ccsh cop csubstr caddc cn0 wceq swrdcl
    adantr cc cconcat cmin elfznn0 cshword sylan2 ccatlen syl2anc lencl cle wbr
    fveq2d nn0re leidd fznn0 mpbir2and syl swrdlen mpd3an3 swrd0len eqtrd nn0cn
    id oveq12d nn0cnd npcan syl2an sylan 3eqtrd ) CBDZEZAFCGHZIJZEZKZCALJZGHCAV
    KMNJZCFAMNJZUAJZGHZVKAUBJZAOJZVKVNVOVRGVMVJAPEVOVRQAVKUCZABCUDUEUKVNVSVPGHZ
    VQGHZOJZWAVJVSWEQZVMVJVPVIEVQVIEWFBCAVKRBCFARBVPVQUFUGSVNWCVTWDAOVJVMVKVLEZ
    WCVTQVJWGVMVJVKPEZWGBCUHZWHWGWHVKVKUIUJWHVBWHVKVKULUMVKVKUNUOUPSBCAVKUQURBC
    AUSVCUTVJWHVMWAVKQZWIWHVKTEATEWJVMVKVAVMAWBVDVKAVEVFVGVH $.

  $( The symbol at a given index of a cyclically shifted word is the symbol at
     the shifted index of the original word.  (Contributed by Alexander van der
     Vekens, 17-May-2018.)  (Revised by Alexander van der Vekens,
     21-May-2018.) $)
  cshwidx $p |- ( ( W e. Word V /\ N e. ( 0 ..^ ( # ` W ) ) )
             -> ( I e. ( 0 ..^ ( # ` W ) ) -> ( ( W CyclShift N ) ` I )
      = if ( I < ( ( # ` W ) - N ) , ( W ` ( I + N ) ) ,
                                     ( W ` ( ( I + N ) - ( # ` W ) ) ) ) ) ) $=
    ( wcel cc0 cfv cfzo co wa cmin wbr wceq syl adantr ad2antrr adantl w3a 3jca
    wi cword chash ccsh clt cif cop csubstr cconcat cn0 elfzonn0 anim2i cshword
    caddc fveq1d swrdcl cn cz elfzo0 nn0z zsubcl syl2anr 3adant3 sylbi ad3antlr
    nnz cr cle 0re a1i nn0re nnre resubcl elfzole1 anim1i lelttr elnnz sylanbrc
    sylc simpr syl3anbrc cfz simpl elfzofz lencl nn0fz0 swrdlen oveq2d eleqtrrd
    sylib ccatval1 syl3anc wb elfzoelz 0z com12 imp elfzo mpbird swrdfv syl2anc
    expr eqtrd eqcomd wn 3ad2ant2 zre 3ad2ant1 lenltd biimpar simplr3 jca exp31
    syl5bi expcom impcom addlenrevswrd ccatval2 fveq2d 0elfz subsubelfzo0 nn0cn
    oveq12d cc subid1d nncn anim12i subcl ancoms addid1d subsub3d ex ifeqda ) D
    CUAZEZBFDUBGZHIZEZJZAYPEZADBUCIZGZAYOBKIZUDLZABUMIZDGZUUDYOKIZDGZUEZMYRYSJZ
    UUAADBYOUFUGIZDFBUFUGIZUHIZGZUUHUUIAYTUULYRYTUULMZYSYRYNBUIEZJUUNYQUUOYNBYO
    UJZUKBCDULNOUNUUIUUHUUMUUIUUCUUEUUGUUMUUIUUCJZUUMUUEUUQUUMAUUJGZUUEUUQUUJYM
    EZUUKYMEZAFUUJUBGZHIZEUUMUURMYRUUSYSUUCYNUUSYQCDBYOUOOZPYRUUTYSUUCYNUUTYQCD
    FBUOOZPUUQAFUUBHIZUVBUUQAUIEZUUBUPEZUUCAUVEEZUUIUVFUUCYSUVFYRAYOUJZQOUUQUUB
    UQEZFUUBUDLZUVGYQUVJYNYSUUCYQUUOYOUPEZBYOUDLZRZUVJBYOURZUUOUVLUVJUVMUVLYOUQ
    EZBUQEZUVJUUOYOVEZBUSYOBUTZVAZVBVCVDUUQFVFEZAVFEZUUBVFEZRFAVGLZUUCJZUVKUUQU
    WAUWBUWCUWAUUQVHVIUUIUWBUUCYSUWBYRYSUVFUWBUVIAVJZNQOYQUWCYNYSUUCYQUVNUWCUVO
    UUOUVLUWCUVMUVLYOVFEZBVFEZUWCUUOYOVKZBVJYOBVLZVAVBVCVDSUUIUWDUUCYSUWDYRAFYO
    VMQVNZFAUUBVOVRUUBVPVQUUIUUCVSAUUBURVTUUQUVAUUBFHUUQYNBFYOWAIZEZYOUWLEZRZUV
    AUUBMZYRUWOYSUUCYRYNUWMUWNYNYQWBZYQUWMYNBFYOWCZQZYNUWNYQYNYOUIEZUWNCDWDZYOW
    EZWIOZSZPCDBYOWFZNWGWHCUUJUUKAWJWKUUQUWOUVHUURUUEMYRUWOYSUUCYRYNUWMUWNUWQUW
    SYRUWTUWNYNUWTYQUXAOUXBWISPUUQUVHUWEUWKUUQAUQEZFUQEZUVJRZUVHUWEWLUUIUXHUUCY
    RYSUXHYQYSUXHTZYNYQUVQUXIBFYOWMZYSUVQUXHYSUVFUVLAYOUDLZRZUVQUXHTZAYOURZUVFU
    VLUXMUXKUVFUVLUVQUXHUVFUVLUVQJZJZUXFUXGUVJUVFUXFUXOAUSOUXGUXPWNVIUXOUVJUVFU
    XOUVPUVQJUVJUVLUVPUVQUVRVNUVSNQSXAVBVCWONQWPOAFUUBWQNWRCDBYOAWSWTXBXCUUIUUC
    XDZJZUUMUUGUXRUUMAUVAKIZUUKGZUUGUXRUUSUUTAUVAUVAUUKUBGUMIZHIZEUUMUXTMYRUUSY
    SUXQUVCPYRUUTYSUXQUVDPUXRAUUBYOHIZUYBUXRAUYCEZUUBAVGLZUXKJZUUIUXQUYFYRYSUXQ
    UYFTZYSUXLYRUYGUXNYQUXLUYGTZYNYQUVQUYHUXJUVQUXLUXQUYFUVQUXLJZUXQJUYEUXKUYIU
    YEUXQUYIUUBAUXLUWGUWHUWCUVQUVLUVFUWGUXKUWIXEBXFUWJVAUXLUWBUVQUVFUVLUWBUXKUW
    FXGQXHXIUVFUVLUXKUVQUXQXJXKXLNQXMWPWPUXRUXFUVJUVPRZUYDUYFWLUUIUYJUXQYSYRUYJ
    YSUXFYRUYJTAFYOWMYRUXFUYJYQUXFUYJTZYNYQUVNUYKUVOUUOUVLUYKUVMUXFUUOUVLJZUYJU
    XFUYLJUXFUVJUVPUXFUYLWBUYLUVJUXFUVTQUYLUVPUXFUVLUVPUUOUVRQQSXNVBVCQWONXOOAU
    UBYOWQNWRUXRUVAUUBUYAYOHUXRUWOUWPYRUWOYSUXQUXDPUXENUXRYNUWMJZUYAYOMYRUYMYSU
    XQYQUWMYNUWRUKPBCDXPNYBWHCUUJUUKAXQWKUXRUXTAUUBKIZUUKGZUUGUUIUXTUYOMUXQUUIU
    XSUYNUUKUUIUVAUUBAKYRUWPYSYRYNUWMUWNUWPUWQUWSUXCUXEWKOWGXROUXRUYOUYNFUMIZDG
    ZUUGUXRYNFFBWAIEZUWMRZUYNFBFKIZHIZEUYOUYQMYRUYSYSUXQYRYNUYRUWMUWQYQUYRYNYQU
    UOUYRUUPBXSNQUWSSPUXRUYNFBHIZVUAUXRYQYSUXQUYNVUBEYRYQYSUXQYNYQVSPUUIYSUXQYR
    YSVSOUUIUXQVSBAYOXTWKUXRUYTBFHYQUYTBMYNYSUXQYQBYQUUOBYCEZUUPBYAZNYDVDWGWHCD
    FBUYNWSWTUUIUYQUUGMUXQUUIUYPUUFDYRYSUYPUUFMZYQYSVUETZYNYQUVNVUFUVOUUOUVLVUF
    UVMYSUYLVUEYSUVFUYLVUETUVIUVFUYLVUEUVFUYLJAYCEZVUCYOYCEZJZJZVUEUVFVUGUYLVUI
    AYAUUOVUCUVLVUHVUDYOYEYFYFVUJUYPUYNUUFVUJUYNVUJVUGUUBYCEZJUYNYCEVUIVUKVUGVU
    HVUCVUKYOBYGYHUKAUUBYGNYIVUJAYOBVUGVUIWBVUIVUHVUGVUCVUHVSQVUIVUCVUGVUCVUHWB
    QYJXBNYKNWOVBVCQWPXROXBXBXBXCYLXCXBYK $.

  $( The symbol at a given index of a cyclically shifted word is the symbol at
     the shifted index of the original word.  (Contributed by Alexander van der
     Vekens, 13-May-2018.)  (Revised by Alexander van der Vekens,
     21-May-2018.) $)
  cshwidxmod $p |- ( ( W e. Word V /\ N e. ( 0 ..^ ( # ` W ) ) )
             -> ( I e. ( 0 ..^ ( # ` W ) ) -> ( ( W CyclShift N ) ` I )
                                   = ( W ` ( ( I + N ) mod ( # ` W ) ) ) ) ) $=
    ( wcel cfv co wa wceq cmin clt wbr cif imp cn0 w3a elfzo0 cr nn0re adantl
    cword cc0 chash cfzo ccsh caddc cmo cshwidx wi cn cmul simp1 simpl nn0addcl
    c2 syl2anr simpr2 3ad2ant1 ad2antrr nnre 3ad2ant2 3jca simpr simp3 anim12ci
    2leaddle2 sylc modifeq2int syl3anc ltaddsubd bicomd ifbid eqtr4d ex 3adant2
    syl5bi sylbi fvifeq eqcomd syl eqtrd ) DCUAEZBUBDUCFZUDGZEZHZAWDEZADBUEGFZA
    BUFGZWCUGGZDFZIWFWGHZWHAWCBJGKLZWIDFWIWCJGZDFMZWKWFWGWHWOIABCDUHNWLWJWMWIWN
    MZIZWOWKIWFWGWQWEWGWQUIZWBWEBOEZWCUJEZBWCKLZPWRBWCQWSXAWRWTWGAOEZWTAWCKLZPZ
    WSXAHZWQAWCQXEXDWQXEXDHZWJWIWCKLZWIWNMZWPXFWIOEZWTWIUOWCUKGKLZWJXHIXDXBWSXI
    XEXBWTXCULWSXAUMABUNUPXEXBWTXCUQXFAREZBREZWCREZPXCXAHXJXFXKXLXMXDXKXEXBWTXK
    XCASURTZWSXLXAXDBSUSZXDXMXEWTXBXMXCWCUTVATZVBXEXAXDXCWSXAVCXBWTXCVDVEABWCVF
    VGWIWCVHVIXFWMXGWIWNXFXGWMXFABWCXNXOXPVJVKVLVMVNVPVOVQTNWQWKWOWMWJWIWNDVRVS
    VTWAVN $.

  $( The symbol at index 0 of a cyclically shifted word is the symbol at index
     N of the original word.  (Contributed by Alexander van der Vekens,
     15-May-2018.)  (Revised by Alexander van der Vekens, 21-May-2018.) $)
  cshwidx0 $p |- ( ( W e. Word V /\ N e. ( 0 ..^ ( # ` W ) ) )
                    -> ( ( W CyclShift N ) ` 0 ) = ( W ` N ) ) $=
    ( cword wcel cc0 chash cfv cfzo co wa ccsh cmin clt wbr caddc cif adantl cr
    wceq elfzolt3b cshwidx mpd cn0 cn w3a elfzo0 wb nn0re posdif syl2an biimp3a
    nnre sylbi iftrue syl elfzoelz zcnd addid2d fveq2d 3eqtrd ) CBDEZAFCGHZIJZE
    ZKZFCALJHZFVCAMJNOZFAPJZCHZVIVCMJCHZQZVJACHVFFVDEZVGVLTVEVMVBAFVCUARFABCUBU
    CVFVHVLVJTVEVHVBVEAUDEZVCUEEZAVCNOZUFVHAVCUGVNVOVPVHVNASEVCSEVPVHUHVOAUIVCU
    MAVCUJUKULUNRVHVJVKUOUPVFVIACVEVIATVBVEAVEAAFVCUQURUSRUTVA $.

  $( The symbol at index ((n-N)-1) of a cyclically shifted word of length n
     (not 0) is the symbol at index (n-1) of the original word.  (Contributed
     by Alexander van der Vekens, 23-Mar-2018.)  (Revised by Alexander van der
     Vekens, 21-May-2018.) $)
  cshwidxm1 $p |- ( ( W e. Word V /\ N e. ( 1 ..^ ( # ` W ) ) )
                     -> ( ( W CyclShift N ) ` ( ( ( # ` W ) - N ) - 1 ) )
                        = ( W ` ( ( # ` W ) - 1 ) ) ) $=
    ( wcel c1 cfv cfzo co wa cmin clt wbr caddc wceq adantl cr cn w3a nnre cc
    cword chash ccsh cif fzo0ss1 sseli anim2i ubmelm1fzo cshwidx elfzo1 resubcl
    cc0 sylc syl2anr 3adant3 sylbi iftrue syl elfzoel2 zcnd elfzoelz ax-1cn a1i
    ltm1d sub32 oveq1d cnm1cn 3ad2ant1 simp2 npcand eqtrd syl3anc fveq2d 3eqtrd
    ) CBUADZAECUBFZGHZDZIZVPAJHZEJHZCAUCHFZWAVTKLZWAAMHZCFZWDVPJHCFZUDZWEVPEJHZ
    CFZVSVOAULVPGHZDZIWAWJDZWBWGNVRWKVOVQWJAVPUEUFUGVRWLVOAVPUHOWAABCUIUMVSWCWG
    WENVSVTVRVTPDZVOVRAQDZVPQDZAVPKLZRWMVPAUJWNWOWMWPWOVPPDAPDWMWNVPSASVPAUKUNU
    OUPOVDWCWEWFUQURVRWEWINVOVRWDWHCVRVPTDZATDZETDZWDWHNVRVPAEVPUSUTVRAAEVPVAUT
    WSVRVBVCWQWRWSRZWDWHAJHZAMHWHWTWAXAAMVPAEVEVFWTWHAWQWRWHTDWSVPVGVHWQWRWSVIV
    JVKVLVMOVN $.

  $( The symbol at index (n-N) of a cyclically shifted word of length n (not 0)
     is the symbol at index 0 of the original word.  (Contributed by Alexander
     van der Vekens, 18-Mar-2018.)  (Revised by Alexander van der Vekens,
     21-May-2018.) $)
  cshwidxm $p |- ( ( W e. Word V /\ N e. ( 1 ..^ ( # ` W ) ) )
                  -> ( ( W CyclShift N ) ` ( ( # ` W ) - N ) ) = ( W ` 0 ) ) $=
    ( wcel cfv cfzo co wa cmin clt wbr cc0 wceq adantl cn cr nnre syl2an ancoms
    cc cword c1 chash ccsh caddc cif fzo0ss1 sseli anim2i ubmelfzo cshwidx sylc
    w3a elfzo1 resubcl 3adant3 sylbi ltnrd iffalse syl subcl simpr addcld npcan
    wn nncn subeq0bd fveq2d 3eqtrd ) CBUADZAUBCUCEZFGZDZHZVKAIGZCAUDGEZVOVOJKZV
    OAUEGZCEZVRVKIGZCEZUFZWALCEZVNVJALVKFGZDZHVOWDDZVPWBMVMWEVJVLWDAVKUGUHUIVMW
    FVJAVKUJNVOABCUKULVNVQVEZWBWAMVMWGVJVMVOVMAODZVKODZAVKJKZUMZVOPDZVKAUNZWHWI
    WLWJWIWHWLWIVKPDAPDWLWHVKQAQVKAUORSUPUQURNVQVSWAUSUTVMWAWCMVJVMVTLCVMWKVTLM
    ZWMWHWIWNWJWHATDZVKTDZWNWIAVFVKVFWOWPHVRVKWPWOVRTDWPWOHVOAVKAVAWPWOVBVCSWPW
    OVRVKMVKAVDSVGRUPUQVHNVI $.

  $( The symbol at index (n-1) of a cyclically shifted word of length n (not 0)
     is the symbol at index (N-1) of the original word.  (Contributed by
     Alexander van der Vekens, 18-Mar-2018.)  (Revised by Alexander van der
     Vekens, 21-May-2018.) $)
  cshwidxn $p |- ( ( N e. ( 1 ..^ ( # ` W ) ) /\ W e. Word V )
          -> ( ( W CyclShift N ) ` ( ( # ` W ) - 1 ) ) = ( W ` ( N - 1 ) ) ) $=
    ( c1 cfv cfzo co wcel wa cmin clt wbr caddc wceq ancoms cn syl adantr cr cc
    chash cword cif cc0 fzo0ss1 sseli anim2i cn0 elfzo0 simp2bi fzo0end cshwidx
    ccsh sylc wn w3a elfzo1 nnnlt1 3ad2ant1 wb nnre 1re a1i adantl 3jca 3adant3
    ltsub2 mtbid sylbi iffalse nncn simpl ax-1cn simpr subadd23d cnm1cn addcomd
    eqtrd addcl sylan subadd2d mpbird syl2an fveq2d 3eqtrd ) ADCUAEZFGZHZCBUBHZ
    IZWFDJGZCAUMGEZWKWFAJGKLZWKAMGZCEZWNWFJGZCEZUCZWQADJGZCEWJWIAUDWFFGZHZIZWKW
    THZWLWRNWIWHXBWHXAWIWGWTAWFUEUFZUGOWJWFPHZXCWHXEWIWHXAXEXDXAAUHHXEAWFKLZAWF
    UIUJQRWFUKQWKABCULUNWJWMUOZWRWQNWHXGWIWHAPHZXEXFUPZXGWFAUQZXIADKLZWMXHXEXKU
    OXFAURUSXIASHZDSHZWFSHZUPZXKWMUTXHXEXOXFXHXEIZXLXMXNXHXLXEAVARXMXPVBVCXEXNX
    HWFVAVDVEVFADWFVGQVHVIRWMWOWQVJQWJWPWSCWHWPWSNZWIWHXIXQXJXHXEXQXFXHATHZWFTH
    ZXQXEAVKWFVKXRXSIZXQWSWFMGZWNNXTYAAWKMGWNXTADWFXRXSVLZDTHXTVMVCXRXSVNZVOXTA
    WKYBXSWKTHZXRWFVPZVDVQVRXTWNWFWSXSXRWNTHZXSYDXRYFYEWKAVSVTOYCXRWSTHXSAVPRWA
    WBWCVFVIRWDWE $.

  $( Lemma 1 for ~ 2cshw1 .  (Contributed by Alexander van der Vekens,
     5-Apr-2018.)  (Revised by Alexander van der Vekens, 31-May-2018.) $)
  2cshw1lem1 $p |- ( W e. Word V -> ( ( M e. ( 0 ... ( # ` W ) )
                   /\ N e. ( 0 ... ( # ` W ) ) /\ ( M + N ) <_ ( # ` W ) )
         -> ( ( ( W substr <. M , ( # ` W ) >. )
                concat ( W substr <. 0 , M >. ) ) substr <. N , ( # ` W ) >. )
            = ( ( W substr <. ( N + M ) , ( # ` W ) >. )
                concat ( W substr <. 0 , M >. ) ) ) ) $=
    ( wcel cc0 cfz co cle wbr w3a cop csubstr wa adantr wi 3adant3 3ad2ant1 imp
    wceq cword chash cfv caddc cconcat cmin swrdcl jca cn0 simp1 adantl nn0sub2
    elfz2nn0 cr wb nn0re 3anim123i 3expb expcom com12 leaddsub2 syl biimpd 3jca
    exp31 syl5bi sylbi 3imp sylibr cz zsubcl ancoms simpl zaddcld syl2an nn0ge0
    nn0z simpr anim12ci subge02 mpbid leidd 3ad2ant2 nn0cn npcan breqtrrd elfz2
    cc sylanbrc swrdrlen oveq2d eleq2d oveq12d anbi12d 3ad2antr1 mpbir2and eqid
    swrd0len swrdccatin12 sylc opeq2d lencl nn0fz0 sylib syl3anc elnn0z 0re a1i
    zre resubcl syl2anr letr anim1i ex syld exp4b sylbid anim12i jctird syl5com
    com3l swrdswrd eqtrd elfzelz nncan swrd0swrdid addcom pncan3 adantll oveq1d
    zcn opeq12d ) DCUAZEZAFDUBUCZGHZEZBYPEZABUDHZYOIJZKZDAYOLMHZDFALZMHZUEHBYOL
    MHZDBAUDHZYOLZMHZUUDUEHZTYNUUANZUUEUUBBUUBUBUCZLZMHZUUDFYOUUKUFHZLZMHZUEHZU
    UIUUJUUBYMEZUUDYMEZNZBFUUKGHZEZYOUUKUUKUUDUBUCZUDHZGHZEZNZUUEUUQTYNUUTUUAYN
    UURUUSCDAYOUGCDFAUGUHOUUJUVGBFYOAUFHZGHZEZYOUVHUVHAUDHZGHZEZUUJBUIEZUVHUIEZ
    BUVHIJZKZUVJUUAUVQYNYQYRYTUVQYQAUIEZYOUIEZAYOIJZKZYRYTUVQPZPAYOUMZYRUVNUVSB
    YOIJZKZUWAUWBBYOUMZUWAUWEYTUVQUWAUWENZYTNUVNUVOUVPUWGUVNYTUWEUVNUWAUVNUVSUW
    DUJZUKOUWGUVOYTUWAUVOUWEAYOULOOUWGYTUVPUWGYTUVPUWGAUNEZBUNEZYOUNEZKZYTUVPUO
    ZUWAUWEUWLUVRUVSUWEUWLPUVTUWEUVRUWLUVNUVSUVRUWLPUWDUVRUVNUVSNUWLUVRUVNUVSUW
    LUVRUWIUVNUWJUVSUWKAUPZBUPZYOUPZUQURUSQUTRSABYOVAZVBVCSVDVEVFVGVHUKBUVHUMZV
    IUUAUVMYNYQYRUVMYTYQUWAUVMUWCUWAUVHVJEZUVKVJEZYOVJEZKZUVHYOIJZYOUVKIJZNUVMU
    VRUVSUXBUVTUVRAVJEZUXAUXBUVSAVQZYOVQZUXEUXANZUWSUWTUXAUXAUXEUWSYOAVKZVLZUXH
    UVHAUXJUXEUXAVMVNUXEUXAVRVDVOQUWAUXCUXDUWAFAIJZUXCUVRUVSUXKUVTAVPRUWAUWKUWI
    NZUXKUXCUOUVRUVSUXLUVTUVRUWIUVSUWKUWNUWPVSQYOAVTVBWAUWAYOYOUVKIUVSUVRYOYOIJ
    UVTUVSYOUWPWBWCUWAYOWHEZAWHEZNZUVKYOTUVRUVSUXOUVTUVRUXNUVSUXMAWDYOWDZVSQYOA
    WEVBWFUHYOUVHUVKWGWIVGRUKYNYRYQUVGUVJUVMNUOYTYNYQNZUVBUVJUVFUVMUXQUVAUVIBUX
    QUUKUVHFGCDAWJZWKWLUXQUVEUVLYOUXQUUKUVHUVDUVKGUXRUXQUUKUVHUVCAUDUXRCDAWRWMW
    MWLWNWOWPUUBUUDUUKBYOCUUKWQWSWTUUJUUQDYSAUVHUDHZLZMHZUUDUEHUUIUUJUUMUYAUUPU
    UDUEUUJUUMUUBBUVHLZMHZUYAUUJUULUYBUUBMUUJUUKUVHBYNYRYQUUKUVHTYTUXRWOZXAWKUU
    JYNYOYPEZYQKZUVJUVHBUVHGHEZNZUYCUYATYNYRYQUYFYTUXQYNUYEYQYNYQVMYNUYEYQYNUVS
    UYECDXBZYOXCXDOYNYQVRVDWOUUAUYHYNYQYRYTUYHYQUWAYRYTUYHPZPUWCYRUWAUYJYRUWEUW
    AUYJPUWFUWEUWAYTUYHUWEUWANZYTNZUVJUYGUYLUVQUVJUYKYTUVQUYKYTUVPUVQUYKUWIUWJU
    WKUWMUWAUWIUWEUVRUVSUWIUVTUWNRUKUWEUWJUWAUVNUVSUWJUWDUWOROUWAUWKUWEUVSUVRUW
    KUVTUWPWCUKUWQXEUYKUVPUVQUYKUVPNUVNUVOUVPUYKUVNUVPUWEUVNUWAUWHOOUYKUVPUVOUW
    EUWAUVPUVOPZUVNUVSUWAUYMPZUWDUVNBVJEZFBIJZNUYNBXFUYOUYPUYNUWAUYOUYPUYMUVRUV
    SUYOUYPUYMPPUVTUVRUVSNZUYOUYPUVPUVOUYQUYONZUYPUVPNZFUVHIJZUVOUYRFUNEZUWJUVH
    UNEZUYSUYTPVUAUYRXGXHUYOUWJUYQBXIUKUYQVUBUYOUVSUWKUWIVUBUVRUWPUWNYOAXJZXKOF
    BUVHXLXEUYQUYTUVOPUYOUYQUYTUVOUYQUYTNUWSUYTNUVOUYQUWSUYTUVSUXAUXEUWSUVRUXGU
    XFUXIXKXMUVHXFVIXNOXOXPQYASVGRSSUYKUVPVRVDXNXQSUWRVIUYLUYOUWSUWSKZUVPUVHUVH
    IJZNZUYGUYKVUDYTUWEUWAVUDUVNUVSUWAVUDPUWDUWAUVNVUDUVRUVSUVNVUDPUVTUYQUVNVUD
    UYQUXHUYOVUDUVNUVRUXEUVSUXAUXFUXGXRBVQUXHUYONUYOUWSUWSUXHUYOVRUXHUWSUYOUXJO
    ZVUGVDVOXNQUTRSOUYKYTVUFUWEUWAYTVUFPZUVNUVSUWAVUHPUWDUVNUWJUWAVUHUWOUVRUVSU
    WJVUHPZUVTUVRUWIUWKVUIUVSUWNUWPUWIUWKNZUWJVUHVUJUWJNZYTUVPVUEVUKUWIUWJUWKYT
    UVPPVUJUWIUWJUWIUWKVMOVUJUWJVRVUJUWKUWJUWIUWKVROUWLYTUVPUWQVCXEVUKUVHVUJVUB
    UWJUWKUWIVUBVUCVLOWBXSXNVOQXTRSSUVHBUVHWGWIUHVEVGUTVGVHUKBUVHAYOCDYBWTYCUUJ
    UUPUUDUUCMHZUUDUUJUUOUUCUUDMUUJUUNAFUUJUUNYOUVHUFHZAUUJUUKUVHYOUFUYDWKYNUUA
    VUMATZYNUVSUUAVUNUYIYQYRUVSVUNPZYTYQUXEVUOAFYOYDZUVSUXEVUNUVSUXMUXNVUNUXEUX
    PAYKZYOAYEVOUSVBRXTSYCXAWKYNYRYQVULUUDTYTACDYFWOYCWMUUJUYAUUHUUDUEUUJUXTUUG
    DMYNUUAUXTUUGTZYNUVSUUAVURUYIYQYRUVSVURPZYTYRUYOUXEVUSYQBFYOYDVUPUYOUXENZUV
    SVURVUTBWHEZUXNNZUXMVURUVSUYOVVAUXEUXNBYKVUQXRUXPVVBUXMNYSUUFUXSYOVVBYSUUFT
    ZUXMUXNVVAVVCABYGVLOUXNUXMUXSYOTVVAAYOYHYIYLVOXNXKQXTSWKYJYCYCXN $.

  $( Lemma 2 for ~ 2cshw1 .  (Contributed by Alexander van der Vekens,
     1-Apr-2018.)  (Revised by Alexander van der Vekens, 31-May-2018.) $)
  2cshw1lem2 $p |- ( W e. Word V -> ( ( M e. ( 0 ... ( # ` W ) )
                   /\ N e. ( 0 ... ( # ` W ) ) /\ ( M + N ) <_ ( # ` W ) )
         -> ( ( ( W substr <. M , ( # ` W ) >. )
                concat ( W substr <. 0 , M >. ) ) substr <. 0 , N >. )
            = ( W substr <. M , ( N + M ) >. ) ) ) $=
    ( wcel cc0 cfv co cle wbr w3a cop csubstr wceq wa adantr wi cr adantl ex wb
    cword chash cfz caddc cconcat cif swrdcl simpr2 addlenrevswrd oveq2d eleq2d
    cmin jca 3ad2antr1 mpbird eqid swrdccat3a cn0 elfz2nn0 cz elfzelz nn0re zre
    sylc leaddsub2 biimpd syl3anc syl com12 3adant3 sylbi 3imp simpl simpr1 cuz
    elfzuz2 eluzfz2 3ad2ant1 swrdlen breqtrrd iftrue ad2antlr leaddsub2d nn0ge0
    3jca simplll 0re a1i resubcl syl2an expcom imp zsubcl syl2anr anim1i elnn0z
    letr nn0z sylibr syld exp3a exp31 com14 mpcom imp41 simpr syl6ibr swrd0swrd
    sylbid com23 com13 fz0addcom opeq2d eqtrd 3eqtrd ) DCUBZEZAFDUCGZUDHZEZBXTE
    ZABUEHZXSIJZKZDAXSLMHZDFALMHZUFHFBLZMHZDABAUEHZLZMHZNXRYEOZYIBYFUCGZIJZYFYH
    MHZYFYGFBYNUMHLMHUFHZUGZYPYLYMYFXQEZYGXQEZOZBFYNYGUCGUEHZUDHZEZYIYRNXRUUAYE
    XRYSYTCDAXSUHCDFAUHUNPYMUUDYBXRYAYBYDUIXRYBYAUUDYBUAYDXRYAOZUUCXTBUUEUUBXSF
    UDACDUJUKULUOUPYFYGYNBCYNUQURVEYMYOYRYPNYMBXSAUMHZYNIYEBUUFIJZXRYAYBYDUUGYA
    AUSEZXSUSEZAXSIJZKZYBYDUUGQZQZAXSUTZUUHUUIUUMUUJYBUUHUUIOZUULYBBVAEZUUOUULQ
    BFXSVBUUPUUOUULUUPUUOOAREZBREZXSREZUULUUOUUQUUPUUHUUQUUIAVCZPSUUPUURUUOBVDP
    UUOUUSUUPUUIUUSUUHXSVCZSSUUQUURUUSKYDUUGABXSVFVGVHTVIVJVKVLVMSYMXRYAXSXTEZY
    NUUFNXRYEVNZXRYAYBYDVOZYEUVBXRYAYBUVBYDYAXSFVPGEUVBAFXSVQFXSVRVIVSSZCDAXSVT
    VHWAYOYPYQWBVIYMYPDAYCLZMHZYLYMXRUVBYAKBFUUFUDHEZYPUVGNYMXRUVBYAUVCUVEUVDWF
    YEUVHXRYAYBYDUVHYAYDYBUVHYAUUKYDYBUVHQQZUUNUUHUUIUVIUUJYBYDUUHUVHYBBUSEZUUI
    BXSIJZKYDUUHUVHQQZBXSUTUVJUUIUVLUVKUVJUUIOZUUHYDUVHUVMUUHYDUVHQUVMUUHOZYDUV
    JUUFUSEZUUGKZUVHUVNYDUUGUVPUVNABXSUUHUUQUVMUUTSUVMUURUUHUVJUURUUIBVCZPPUUIU
    USUVJUUHUVAWCWDUVNUUGUVPUVNUUGOUVJUVOUUGUVJUUIUUHUUGWGUVJUUIUUHUUGUVOFBIJZU
    VJUUIUUHUUGUVOQZQQBWEUUHUVJUUIUVRUVSUUHUVJUUIUVRUVSQUUHUVJOZUUIOZUVRUUGUVOU
    WAUVRUUGOZFUUFIJZUVOUWAFREZUURUUFREZUWBUWCQUWDUWAWHWIUVJUURUUHUUIUVQWCUVTUU
    IUWEUUHUUIUWEQUVJUUIUUHUWEUUIUUSUUQUWEUUHUVAUUTXSAWJWKWLPWMFBUUFWRVHUWAUWCU
    VOUWAUWCOUUFVAEZUWCOUVOUWAUWFUWCUUIXSVAEAVAEZUWFUVTXSWSUUHUWGUVJAWSPXSAWNWO
    WPUUFWQWTTXAXBXCXDXEXFUVNUUGXGWFTXJBUUFUTXHTXKVKVLXLVSVLXKVMSBAXSCDXIVEYMUV
    FYKDMYMYCYJAYEYCYJNZXRYAYBUWHYDABXSXMVKSXNUKXOXPT $.

  $( Lemma 3 for ~ 2cshw1 .  (Contributed by Alexander van der Vekens,
     1-Apr-2018.)  (Revised by Alexander van der Vekens, 22-May-2018.) $)
  2cshw1lem3 $p |- ( ( W e. Word V /\ ( M e. ( 0 ... ( # ` W ) )
                     /\ N e. ( 0 ... ( # ` W ) ) /\ ( M + N ) <_ ( # ` W ) ) )
                    -> ( ( ( W substr <. ( N + M ) , ( # ` W ) >. )
                           concat ( W substr <. 0 , M >. ) )
                         concat ( W substr <. M , ( N + M ) >. ) )
                                               = ( W CyclShift ( M + N ) ) ) $=
    ( wcel cc0 cfz co cle wbr w3a wa csubstr cconcat wceq 3adant3 adantl syl2an
    cop cn0 cword chash caddc ccsh fz0addcom opeq1d oveq2d opeq2d elfznn0 0elfz
    cfv 3ad2ant1 simpl nn0addcl ancoms nn0ge0 cr wb nn0re addge02 3jca elfz2nn0
    syl sylibr elfz3nn0 breq1d biimp3a syl3anbrc ccatswrd sylan2 eqtr4d oveq12d
    mpbid cshword swrdcl ccatass syl3anc adantr 3eqtr4rd ) DCUAZEZAFDUBUKZGHZEZ
    BWCEZABUCHZWBIJZKZLZDWFWBSZMHZDFWFSZMHZNHZDBAUCHZWBSZMHZDFASMHZDAWOSMHZNHZN
    HZDWFUDHZWQWRNHWSNHZWIWKWQWMWTNWHWKWQOZWAWDWEXDWGWDWELZWJWPDMXEWFWOWBABWBUE
    ZUFUGPQWIWMDFWOSZMHZWTWHWMXHOZWAWDWEXIWGXEWLXGDMXEWFWOFXFUHUGPQWHWAFFAGHEZA
    FWOGHEZWOWCEZKWTXHOWHXJXKXLWDWEXJWGWDATEZXJAWBUIZAUJVCULWDWEXKWGXEXMWOTEZAW
    OIJZKZXKWDXMBTEZXQWEXNBWBUIZXMXRLZXMXOXPXMXRUMXRXMXOBAUNZUOXTFBIJZXPXRYBXMB
    UPQXMAUQEBUQEYBXPURXRAUSBUSABUTRVMVARAWOVBVDPWHXOWBTEZWOWBIJZXLWDWEXOWGWEWD
    XOWEXRXMXOWDXSXNYARUOPWDWEYCWGAWBVEULWDWEWGYDXEWFWOWBIXFVFVGWOWBVBVHVACDFAW
    OVIVJVKVLWHWAWFTEZXBWNOWDWEYEWGWDXMXRYEWEXNXSABUNRPWFCDVNVJWAXCXAOZWHWAWQVT
    EWRVTEWSVTEYFCDWOWBVOCDFAVOCDAWOVOCWQWRWSVPVQVRVS $.

  $( Cyclically shifting a word two times (without "overflow").  (Contributed
     by Alexander van der Vekens, 5-Apr-2018.)  (Revised by Alexander van der
     Vekens, 31-May-2018.) $)
  2cshw1 $p |- ( W e. Word V -> ( ( M e. ( 0 ... ( # ` W ) )
                   /\ N e. ( 0 ... ( # ` W ) ) /\ ( M + N ) <_ ( # ` W ) )
        -> ( ( W CyclShift M ) CyclShift N ) = ( W CyclShift ( M + N ) ) ) ) $=
    ( wcel cc0 chash cfv co caddc ccsh wceq cop csubstr cconcat elfznn0 cshword
    cn0 oveq1d swrdcl cword cfz cle wbr w3a wa 3ad2ant1 sylan2 syl2anc 3ad2ant2
    ccatcl syl2an lenrevcctswrd opeq2d oveq2d 2cshw1lem1 imp 2cshw1lem2 oveq12d
    3ad2antr1 2cshw1lem3 eqtrd 3eqtrd ex ) DCUAZEZAFDGHZUBIZEZBVHEZABJIZVGUCUDZ
    UEZDAKIZBKIZDVKKIZLVFVMUFZVODAVGMNIZDFAMNIZOIZBKIZVPVQVNVTBKVMVFAREZVNVTLVI
    VJWBVLAVGPUGACDQUHSVQWAVTBVTGHZMZNIZVTFBMNIZOIZVTBVGMZNIZWFOIZVPVFVTVEEZBRE
    ZWAWGLVMVFVRVEEVSVEEWKCDAVGTCDFATCVRVSUKUIVJVIWLVLBVGPUJBCVTQULVQWEWIWFOVQW
    DWHVTNVQWCVGBVFVJVIWCVGLVLACDUMUTUNUOSVQWJDBAJIZVGMNIVSOIZDAWMMNIZOIVPVQWIW
    NWFWOOVFVMWIWNLABCDUPUQVFVMWFWOLABCDURUQUSABCDVAVBVCVBVD $.

  $( Lemma 1 for ~ 2cshw2 .  (Contributed by Alexander van der Vekens,
     7-Apr-2018.)  (Revised by Alexander van der Vekens, 31-May-2018.) $)
  2cshw2lem1 $p |- ( W e. Word V -> ( ( M e. ( 0 ... ( # ` W ) )
                   /\ N e. ( 0 ... ( # ` W ) ) /\ ( # ` W ) < ( M + N ) )
         -> ( ( ( W substr <. M , ( # ` W ) >. )
                concat ( W substr <. 0 , M >. ) ) substr <. N , ( # ` W ) >. )
             = ( W substr <. ( ( M + N ) - ( # ` W ) ) , M >. ) ) ) $=
    ( wcel cc0 cfv cfz wbr w3a csubstr cmin wceq 3ad2ant1 syl adantr cle adantl
    co wa cword chash caddc clt cconcat elfzubelfz anim2i 3anass sylibr swrdlen
    cop ancli swrdcl cz elfzel2 elfzelz zsubcld 3jca 3adant3 cr wi zred readdcl
    syl2an ltle syl2anc lesubadd2d sylibrd 3impia elfz2nn0 simp3 sylbi 3ad2ant2
    jca cn0 jca32 elfz2 nn0cn subidd nn0ge0 eqbrtrd wb nn0re suble mpbird eluz2
    eluzfz2 simp1 swrd0len oveq2d npcan eqtrd eleqtrrd swrdccatin2d 2elfz2melfz
    cuz zcn nn0z zsubcl sylan simpr breqtrrd zre resubcl syl3anbrc nncan eleq1d
    cc mpan9 swrdswrd0 sylc anim12i simpl simprr subsub3d addcom adantrr oveq1d
    ex ancoms opeq12d com12 imp ) DCUAZEZAFDUBGZHSZEZBYGEZYFABUCSZUDIZJZDAYFUKK
    SZDFAUKKSZUESBYFUKKSZDYJYFLSZAUKZKSZMYEYLTZYOYNBYFALSZLSZYFYTLSZUKZKSZYRYSY
    MYNYTBYFCYSYEYHYFYGEZJZYMUBGYTMYSYEYHUUETZTUUFYLUUGYEYHYIUUGYKYHUUEAFYFUFUL
    NUGYEYHUUEUHUICDAYFUJOYSYMYDEZYNYDEZTZBYTYFHSZEZYFYTYTYNUBGZUCSZHSZEYEUUJYL
    YEUUHUUICDAYFUMCDFAUMVNPYLUULYEYLYTUNEZYFUNEZBUNEZJZYTBQIZBYFQIZTTUULYLUUSU
    UTUVAYHYIUUSYKYHYITZUUPUUQUURYHUUPYIYHYFAAFYFUOZAFYFUPZUQZPYIUUQYHBFYFUORZY
    IUURYHBFYFUPZRURUSYHYIYKUUTUVBYKYFYJQIZUUTUVBYFUTEZYJUTEZYKUVHVAUVBYFUVFVBY
    HAUTEZBUTEZUVJYIYHAUVDVBZYIBUVGVBZABVCVDYFYJVEVFUVBYFABYHUVIYIYHYFUVCVBPYHU
    VKYIUVMPYIUVLYHUVNRVGVHVIYIYHUVAYKYIBVOEZYFVOEZUVAJZUVABYFVJZUVOUVPUVAVKZVL
    VMVPBYTYFVQUIRYSYFUUKUUOYSYFYTWPGEZYFUUKEYSUUPUUQYTYFQIZJZUVTYLUWBYEYHYIUWB
    YKYHUUPUUQUWAUVEUVCYHAVOEZUVPAYFQIZJZUWAAYFVJZUWEUWAYFYFLSZAQIZUWEUWGFAQUVP
    UWCUWGFMUWDUVPYFYFVRZVSVMUWCUVPFAQIUWDAVTNWAUWEUVIUVKUVIJZUWAUWHWBUWCUVPUWJ
    UWDUWCUVPTZUVIUVKUVIUVPUVIUWCYFWCZRZUWCUVKUVPAWCPUWMURUSYFAYFWDOWEVLURNRYTY
    FWFUIYTYFWGOYSUUNYFYTHYSUUNYTAUCSZYFYSUUMAYTUCYSYEYHTZUUMAMYLYHYEYHYIYKWHUG
    ZCDAWIOWJYLUWNYFMZYEYHYIUWQYKYHYFXHEZAXHEZUWQYHUUQUWRUVCYFWQOYHAUNEZUWSUVDA
    WQZOYFAWKZVFNRWLWJWMVPWNYSUUDDUUCKSZYRYSUWOUUAFAHSEZUUBUUAAHSZEZTZUUDUXCMUW
    PYLUXGYEYLUXDUXFYHYIYKUXDABYFWOVIYHYIUXFYKYHUWTYIUXFUVDYIUVQUWTUXFVAUVRUVQU
    WTUXFUVQUWTTZUXFAUXEEZUXHAUUAWPGEZUXIUXHUUAUNEUWTUUAAQIZUXJUXHBYTUVQUURUWTU
    VOUVPUURUVABWRNPUVQUUQUWTUUPUVPUVOUUQUVAYFWRVMYFAWSWTUQUVQUWTXAUXHUXKBUWNQI
    UXHBYFUWNQUVQUVAUWTUVSPUVQUWRUWSUWQUWTUVPUVOUWRUVAUWIVMZUXAUXBVDXBUXHBYTAUV
    QUVLUWTUVOUVPUVLUVABWCNPUVQUVIUVKYTUTEUWTUVPUVOUVIUVAUWLVMAXCZYFAXDVDUWTUVK
    UVQUXMRVGWEUUAAWFXEUUAAWGOUVQUWRUWSUXFUXIWBUWTUXLUXAUWRUWSTUUBAUXEYFAXFZXGV
    DWEXSVLXIUSVNRUUAUUBACDXJXKYSUUCYQDKYLUUCYQMZYEYHYIUXOYKYHYIUXOYHUWEYIUXOVA
    ZUWFUWCUVPUXPUWDYIUWKUXOYIUURUWKUXOVAUVGUURUWKUXOUURBXHEZUWSUWRTZUXOUWKBWQU
    WCUWSUVPUWRAVRUWIXLUXQUXRTZUUAYPUUBAUXSUUABAUCSZYFLSYPUXSBYFAUXQUXRXMUXQUWS
    UWRXNUXRUWSUXQUWSUWRXMRXOUXSUXTYJYFLUXQUWSUXTYJMUWRBAXPXQXRWLUXRUUBAMZUXQUW
    RUWSUYAUXNXTRYAVDXSOYBUSVLYCUSRWJWLWLXS $.

  $( Lemma 2 for ~ 2cshw2 .  (Contributed by Alexander van der Vekens,
     7-Apr-2018.)  (Revised by Alexander van der Vekens, 1-Jun-2018.) $)
  2cshw2lem2 $p |- ( W e. Word V -> ( ( M e. ( 0 ... ( # ` W ) )
                   /\ N e. ( 0 ... ( # ` W ) ) /\ ( # ` W ) < ( M + N ) )
         -> ( ( ( W substr <. M , ( # ` W ) >. )
               concat ( W substr <. 0 , M >. ) ) substr <. 0 , N >. )
            = ( ( W substr <. M , ( # ` W ) >. )
               concat ( W substr <. 0 , ( ( M + N ) - ( # ` W ) ) >. ) ) ) ) $=
    ( wcel cc0 cfz co caddc wbr w3a cop csubstr cconcat cmin wceq wa cle adantl
    3adant3 cword chash cfv clt eqidd swrdcl jca cn0 0nn0 a1i fznn0sub elfz2nn0
    adantr wi cr wb nn0re subge0 syl2an biimprd expcom 3imp sylbi 3jca 3ad2ant1
    sylibr cz 2elfz3nn0 nn0z 3anim123i zsubcl ancoms 3adant2 simpl zaddcld 3syl
    simp2 3coml ltsubadd2 bicomd resubcl syl2anr 3ad2ant2 sylbid 3impia elfzle2
    ltle cc nn0cn anim12ci npcan syl breq2d mpbird jca32 elfz2 3ad2antr1 oveq2d
    swrdrlen eleq2d swrd0len oveq12d anbi12d swrdccatin12d simpr1 lencl swrdlen
    nn0fz0 sylib syl3anc opeq2d cuz eluzfz2b elfzmlbm swrd0swrd sylc elfzubelfz
    elfzuz3 eqtrd 2elfz2melfz eqeltrd pncan3 subsub3 3comr addcom oveq1d 3eqtrd
    swrd0swrd0 ex ) DCUAZEZAFDUBUCZGHZEZBYMEZYLABIHZUDJZKZDAYLLZMHZDFALMHZNHFBL
    MHZYTDFYPYLOHZLZMHZNHZPYKYRQZUUBYTFYTUBUCZLZMHZUUAFBUUHOHZLZMHZNHDAAYLAOHZI
    HZLZMHZDUULMHZNHUUFUUGYTUUAUUHFBCUUGUUHUEUUGYTYJEZUUAYJEZQZFFUUHGHZEZBUUHUU
    HUUAUBUCZIHZGHZEZQZYKUVAYRYKUUSUUTCDAYLUFCDFAUFUGUMUUGUVHFFUUNGHZEZBUUNUUNA
    IHZGHZEZQZYRUVNYKYRUVJUVMYRFUHEZUUNUHEZFUUNRJZKZUVJYNYOUVRYQYNUVOUVPUVQUVOY
    NUIUJAFYLUKYNAUHEZYLUHEZAYLRJZKZUVQAYLULZUVSUVTUWAUVQUVTUVSUWAUVQUNUVTUVSQU
    VQUWAUVTYLUOEZAUOEZUVQUWAUPUVSYLUQZAUQZYLAURUSUTVAVBVCVDVEFUUNULVFYRUUNVGEZ
    UVKVGEZBVGEZKZUUNBRJZBUVKRJZQQUVMYRUWKUWLUWMYNYOUWKYQYNYOQZUVSBUHEZUVTKZAVG
    EZUWJYLVGEZKZUWKABYLVHZUVSUWQUWOUWJUVTUWRAVIBVIYLVIVJUWSUWHUWIUWJUWQUWRUWHU
    WJUWRUWQUWHYLAVKVLZVMUWQUWRUWIUWJUWQUWRQUUNAUXAUWQUWRVNVOVMUWQUWJUWRVQVDVPT
    YNYOYQUWLUWNYQUUNBUDJZUWLUWNUWPUWDUWEBUOEZKZYQUXBUPUWTUVTUVSUWOUXDUVTUWDUVS
    UWEUWOUXCUWFUWGBUQZVJVRUXDUXBYQYLABVSVTVPUWNUWPUUNUOEZUXCQUXBUWLUNUWTUWPUXF
    UXCUVSUVTUXFUWOUVTUWDUWEUXFUVSUWFUWGYLAWAWBVMUWOUVSUXCUVTUXEWCUGUUNBWGVPWDW
    EYNYOUWMYQUWNUWMBYLRJZYOUXGYNBFYLWFSYNUWMUXGUPYOYNUVKYLBRYNYLWHEZAWHEZQZUVK
    YLPYNUWBUXJUWCUVSUVTUXJUWAUVSUXIUVTUXHAWIZYLWIZWJTVCYLAWKWLWMUMWNTWOBUUNUVK
    WPVFUGSUUGUVCUVJUVGUVMUUGUVBUVIFUUGUUHUUNFGYKYOYNUUHUUNPZYQCDAWSWQZWRWTUUGU
    VFUVLBUUGUUHUUNUVEUVKGUXNUUGUUHUUNUVDAIUXNYKYOYNUVDAPYQCDAXAWQXBXBWTXCWNUGX
    DUUGUUJUUQUUMUURNUUGUUJYTFUUNLZMHZUUQUUGUUIUXOYTMUUGUUHUUNFUUGYKYNYLYMEZUXM
    YKYRVNZYKYNYOYQXEZYKUXQYRYKUVTUXQCDXFYLXHXIUMZCDAYLXGZXJZXKWRUUGYKUXQYNKUUN
    UVIEZUXPUUQPUUGYKUXQYNUXRUXTUXSVDUUGYLAYLGHEZUYCYRUYDYKYNYOUYDYQYNYLAXLUCEU
    YDAFYLXRAYLXMXIVESYLAYLXNWLUUNAYLCDXOXPXSUUGYKYNUUKFAGHZEUUMUURPUXRUXSUUGUU
    KBUUNOHZUYEUUGUUHUUNBOUUGYKYNUXQUXMUXRUXSYRUXQYKYNYOUXQYQAFYLXQVESUYAXJWRYR
    UYFUYEEZYKYNYOYQUYGABYLXTWESYAUUKACDYHXJXBUUGUUQYTUURUUENUUGUUPYSDMUUGUUOYL
    AYRUUOYLPZYKYNYOUYHYQYNUWBUYHUWCUVSUVTUYHUWAUVSUXIUXHUYHUVTUXKUXLAYLYBUSTVC
    VESXKWRUUGUULUUDDMUUGUUKUUCFUUGUUKUYFUUCUUGUUHUUNBOUYBWRYRUYFUUCPZYKYNYOUYI
    YQUWNUWPUXIBWHEZUXHKZUYIUWTUVSUXIUWOUYJUVTUXHUXKBWIUXLVJUYKUYFBAIHZYLOHZUUC
    UYJUXHUXIUYFUYMPBYLAYCYDUYKUYLYPYLOUXIUYJUYLYPPZUXHUYJUXIUYNBAYEVLTYFXSVPTS
    XSXKWRXBYGYI $.

  $( Lemma 3 for ~ 2cshw2 .  (Contributed by Alexander van der Vekens,
     6-Apr-2018.)  (Revised by Alexander van der Vekens, 4-Jun-2018.) $)
  2cshw2lem3 $p |- ( ( W e. Word V /\ ( M e. ( 0 ... ( # ` W ) )
                       /\ N e. ( 0 ... ( # ` W ) ) /\ ( # ` W ) < ( M + N ) ) )
                  -> ( ( W substr <. ( ( M + N ) - ( # ` W ) ) , M >. ) concat
                     ( ( W substr <. M , ( # ` W ) >. ) concat
                       ( W substr <. 0 , ( ( M + N ) - ( # ` W ) ) >. ) ) )
                     = ( W CyclShift ( ( M + N ) - ( # ` W ) ) ) ) $=
    ( wcel cc0 co wbr w3a wa cop csubstr cconcat wceq cn0 wi adantr cr nn0re ex
    cword chash cfv cfz caddc clt cmin ccsh simpl cle elfznn0 elfz2nn0 nn0addcl
    expcom imp simplr jca 3adantl3 ltsubnn0 syl 3anim123i 3coml leaddsuble 3exp
    wb biimpd com34 3imp1 3jca sylbi syl5com 3imp sylibr adantl simpr1 3ad2ant1
    elfzubelfz ccatswrd eqcomd oveq1d sylan2 ancoms 3adant3 syl6 cshword swrdcl
    syl13anc ccatass syl3anc 3eqtr4rd ) DCUAZEZAFDUBUCZUDGZEZBWNEZWMABUEGZUFHZI
    ZJZDWQWMUGGZWMKLGZDFXAKLGZMGZDXAAKLGZDAWMKLGZMGZXCMGZDXAUHGZXEXFXCMGMGZWTXB
    XGXCMWTWLXAFAUDGEZWOWMWNEZXBXGNWLWSUIWSXKWLWSXAOEZAOEZXAAUJHZIZXKWOWPWRXPWO
    XNWPWRXPPZAWMUKZWPBOEZWMOEZBWMUJHZIZXNXQPBWMULZYBXNXQYBXNJZWRXPYDWRJXMXNXOY
    DWRXMYDWQOEZXTJZWRXMPZXSXTXNYFYAXSXTJZXNJZYEXTYHXNYEXSXNYEPXTXNXSYEABUMZUNQ
    UOXSXTXNUPZUQURWQWMUSZUTUOYBXNWRUPYDXOWRXSXTYAXNXOXSXTXNYAXOXSXTXNYAXOPXSXT
    XNIZYAXOYMAREZBREZWMREZIZYAXOVEXNXSXTYQXNYNXSYOXTYPASBSWMSVAVBABWMVCUTVFVDV
    GVHQVITTVJVKVLXAAULVMVNWLWOWPWRVOWSXLWLWOWPXLWRAFWMVQVPVNWLXKWOXLIJXGXBCDXA
    AWMVRVSWGVTWSWLXMXIXDNWOWPWRXMWOWPYFYGWOXNWPYFXRWPYBXNYFPZYCXSXTYRYAYHXNYFY
    IYEXTXNYHYEYHXNXSYEXSXTUIYJWAWBYKUQTWCVJVKYLWDVLXACDWEWAWLXJXHNZWSWLXEWKEZX
    FWKEZXCWKEZYSCDXAAWFCDAWMWFCDFXAWFYTUUAUUBIXHXJCXEXFXCWHVSWIQWJ $.

  $( Cyclically shifting a word two times (with "overflow").  (Contributed by
     Alexander van der Vekens, 7-Apr-2018.)  (Revised by Alexander van der
     Vekens, 4-Jun-2018.) $)
  2cshw2 $p |- ( W e. Word V -> ( ( M e. ( 0 ... ( # ` W ) )
                   /\ N e. ( 0 ... ( # ` W ) ) /\ ( # ` W ) < ( M + N ) )
                -> ( ( W CyclShift M ) CyclShift N )
                     = ( W CyclShift ( ( M + N ) - ( # ` W ) ) ) ) ) $=
    ( wcel cc0 chash cfv co ccsh cop csubstr cconcat cn0 elfznn0 cshword swrdcl
    wceq imp eqtrd cword cfz caddc clt wbr w3a wa 3ad2ant1 sylan2 oveq1d ccatcl
    3ad2ant2 syl2an lenrevcctswrd 3ad2antr1 opeq2d oveq2d 2cshw2lem1 2cshw2lem2
    cmin syl2anc oveq12d 2cshw2lem3 ex ) DCUAZEZAFDGHZUBIZEZBVHEZVGABUCIZUDUEZU
    FZDAJIZBJIZDVKVGUTIZJIZRVFVMUGZVODAVGKLIZDFAKLIZMIZBJIZVQVRVNWABJVMVFANEZVN
    WARVIVJWCVLAVGOUHACDPUIUJVRWBWABWAGHZKZLIZWAFBKLIZMIZVQVFWAVEEZBNEZWBWHRVMV
    FVSVEEVTVEEWICDAVGQCDFAQCVSVTUKVAVJVIWJVLBVGOULBCWAPUMVRWHDVPAKLIZVSDFVPKLI
    MIZMIVQVRWFWKWGWLMVRWFWABVGKZLIZWKVRWEWMWALVRWDVGBVFVJVIWDVGRVLACDUNUOUPUQV
    FVMWNWKRABCDURSTVFVMWGWLRABCDUSSVBABCDVCTTTVD $.

  $( Cyclically shifting a word two times.  (Contributed by Alexander van der
     Vekens, 7-Apr-2018.)  (Revised by Alexander van der Vekens,
     4-Jun-2018.) $)
  2cshw $p |- ( W e. Word V
                -> ( ( M e. ( 0 ... ( # ` W ) ) /\ N e. ( 0 ... ( # ` W ) ) )
          -> ( ( W CyclShift M ) CyclShift N )
               = if ( ( M + N ) <_ ( # ` W ) , ( W CyclShift ( M + N ) ) ,
                             ( W CyclShift ( ( M + N ) - ( # ` W ) ) ) ) ) ) $=
    ( co wbr wcel wa ccsh simplr simprl adantl w3a imp syl13anc ad2antrr eqtr4d
    wceq ex cr caddc chash cfv cle cword cc0 cfz cif simpr simpll 2cshw1 iftrue
    cmin wi wn clt wb lencl nn0red elfznn0 nn0addcl syl2an ltnle syl2anr exbiri
    cn0 com13 imp31 2cshw2 iffalse pm2.61ian ) ABUAEZDUBUCZUDFZDCUEGZAUFVMUGEZG
    ZBVPGZHZDAIEBIEZVNDVLIEZDVLVMUMEIEZUHZRZUNVNVOHZVSWDWEVSHZVTWAWCWFVOVQVRVNV
    TWARZVNVOVSJWEVQVRKVSVRWEVQVRUIZLVNVOVSUJVOVQVRVNMWGABCDUKNOVNWCWARVOVSVNWA
    WBULPQSVNUOZVOHZVSWDWJVSHZVTWBWCWKVOVQVRVMVLUPFZVTWBRZWIVOVSJWJVQVRKVSVRWJW
    HLWIVOVSWLVSVOWIWLVSVOWLWIVOVMTGVLTGZWLWIUQVSVOVMCDURUSVQAVFGZBVFGZWNVRAVMU
    TBVMUTWOWPHVLABVAUSVBVMVLVCVDVEVGVHVOVQVRWLMWMABCDVINOWIWCWBRVOVSVNWAWBVJPQ
    SVK $.

  $( Cyclically shifting a word two times using ` mod ` .  (Contributed by
     Alexander van der Vekens, 8-Jun-2018.) $)
  2cshwmod $p |- ( ( W e. Word V /\ W =/= (/) )
                  -> ( ( M e. ( 0 ... ( # ` W ) ) /\ N e. ( 0 ... ( # ` W ) ) )
                        -> ( ( W CyclShift M ) CyclShift N )
                           = ( W CyclShift ( ( M + N ) mod ( # ` W ) ) ) ) ) $=
    ( co wbr wcel wa cc0 ccsh wceq wi cle ad2antlr adantr syl2an syl imp oveq2d
    ex caddc chash cfv clt cword c0 wne cfz cmo simpl simprl simprr cn0 elfzelz
    cr cz w3a elfz2nn0 3simpa sylbi zre nn0re readdcl ad2antll jca com12 2cshw1
    ltle syl13anc crp hasheq0 bicomd necon3abid lencl df-ne elnnne0 nnrp sylbir
    wn syl5bir sylbid adantl zred anim12ci fz0addge0 syl2anc eqtr4d zaddcl eqle
    cn modid sylan expcom cshwn ad2antrl eqtrd modid0 wb eqeq1d ad2antrr mpbird
    oveq1 cshw0 eqtr2d 3eqtrd cmin ancoms ltnltne exbiri 3adant3 impcom c2 cmul
    2cshw2 lennncl nncn 2txmxeqx 2txmodxeq0 syldan eqeq12d syl5ibr ad4antr nnre
    cc a1d lenltd com24 le2add anabsan2 recn 2timesd eqcomd 2re remulcld biimpd
    a1i com23 com13 3adant2 pm2.61ian breq2d id lenlt syld exp3a notbid 2submod
    eqcom pm2.61i ) ABUAEZDUBUCZUDFZDCUEZGZDUFUGZHZAIUUKUHEZGZBUUQGZHZDAJEBJEZD
    UUJUUKUIEZJEZKZLZUULUUPHZUUTUVDUVFUUTHZUVADUUJJEZUVCUVGUUNUURUUSUUJUUKMFZUV
    AUVHKZUUPUUNUULUUTUUNUUOUJNUVFUURUUSUKUVFUURUUSULUVFUUTUVIUULUUTUVILZUUPUUT
    UULUVIUUTUUJUOGZUUKUOGZHZUULUVILUURAUPGZBUMGZUUKUMGZHZUVNUUSAIUUKUNZUUSUVPU
    VQBUUKMFZUQZUVRBUUKURZUVPUVQUVTUSUTUVOUVRHUVLUVMUVOAUOGZBUOGZUVLUVRAVAUVPUW
    DUVQBVBZOABVCZPUVQUVMUVOUVPUUKVBZVDVEPUUJUUKVHQVFORUUNUURUUSUVIUQUVJABCDVGR
    ZVIUVGUVBUUJDJUVGUVLUUKVJGZHZIUUJMFZUULHUVBUUJKUVFUWIUUTUVLUUPUWIUULUUNUUOU
    WIUUNUUOUUKIKZVSZUWIUUNUWLDUFUUNUWLDUFKDUUMVKVLVMZUUNUVQUWMUWILCDVNZUWMUUKI
    UGZUVQUWIUUKIVOZUVQUWPUWIUVQUWPHUUKWJGZUWIUUKVPUUKVQZVRTZVTQWARWBUURUWCUWDU
    VLUUSUURAUVSWCUUSBBIUUKUNZWCUWFPWDUVFUULUUTUWKUULUUPUJABUUKUUKWEWDUUJUUKWKW
    FSWGTUUJUUKKZUULVSZUUPHZUVEUXBUXDHZUUTUVDUXEUUTHZUVAUVHDUVCUXFUUNUURUUSUVIU
    VJUXDUUNUXBUUTUXCUUNUUOUKZNUXEUURUUSUKUXEUURUUSULUXEUUTUVIUXBUVKUXDUUTUXBUV
    IUUTUVLUXBUVIUUTUUJUURUVOBUPGZUUJUPGUUSUVSUXAABWHPWCUUJUUKWIWLWMORUWHVIUXFU
    VHDUUKJEZDUXFUUJUUKDJUXEUXBUUTUXBUXDUJOSUXDUXIDKZUXBUUTUUNUXJUXCUUOCDWNZWON
    WPUXFUVCDIJEZDUXFUVBIDJUXFUVBIKZUUKUUKUIEZIKZUXDUXOUXBUUTUUPUXOUXCUUPUWIUXO
    UUNUUOUWIUUNUUOUWMUWIUWNUWMUWPUUNUWIUWQUUNUVQUWPUWILUWOUWTQVTWARUUKWQQWBNUX
    BUXMUXOWRUXDUUTUXBUVBUXNIUUJUUKUUKUIXBWSWTXASUXDUXLDKZUXBUUTUUNUXPUXCUUOCDX
    CZWONXDXETUXBVSZUXDHZUUTUVDUXSUUTHZUVADUUJUUKXFEZJEZUVCUXTUUNUURUUSUUKUUJUD
    FZUVAUYBKZUXDUUNUXRUUTUXGNUXSUURUUSUKUXSUURUUSULUXSUUTUYCUXDUXRUUTUYCLZUXCU
    XRUYELUUPUXCUXRUYEUUTUXCUXRHZUYCUURUUSUYFUYCLZUURAUMGZUVQAUUKMFZUQZUUSUYGLZ
    AUUKURZUYHUVQUYKUYIUUSUYHUVQHZUYGUUSUXHUYMUYGLZUXAUXHUWDUYNBVAUWDUYMUYCUYFU
    WDUYMHUVMUVLUYCUYFWRUVQUVMUWDUYHUWGVDUYMUWDUVLUYMUWCUWDUVLUYHUWCUVQAVBZOUWF
    WLXGUUKUUJXHWFXIQQVFXJUTRVFTOXKRUUNUURUUSUYCUQUYDABCDXNRVIUUJXLUUKXMEZKZUXT
    UYBUVCKZLUXTUYRUYQDUYPUUKXFEZJEZDUYPUUKUIEZJEZKZUXSUUTVUCUUPUUTVUCLUXRUXCUU
    PVUCUUTUUNUUOUWRVUCCDXOZUUNUWRHZUYTUXIDVUBVUEUYSUUKDJUWRUYSUUKKZUUNUWRUUKYD
    GZVUFUUKXPUUKXQQWBSUUNUXJUWRUXKOVUEVUBUXLDVUEVUAIDJUWRVUAIKZUUNUWRUWIVUHUWS
    UUKXRQWBSUUNUXPUWRUXQOXDXEXSYEVDRUYQUYBUYTUVCVUBUYQUYAUYSDJUUJUYPUUKXFXBSUY
    QUVBVUADJUUJUYPUUKUIXBSXTYAUYQVSZUXTUYRVUIUXTHZUYAUVBDJVUJUVBUYAVUJUWJUUKUU
    JMFZUUJUYPUDFZHZHZUVBUYAKUXTVUIVUNUUTUXSVUIVUNLZUURUUSUXSVUOLZUURUYJUUSVUPL
    ZUYLUYHUYIVUQUVQUUSUYHUYIHZVUPUUSUWAVURVUPLZUWBUVPUVTVUSUVQUXSVURUVPUVTHZVU
    OUXDUXRVURVUTVUOLZLZUUPUXCUXRVVBLZUUPUWRUXCVVCLVUDUWRUXCVVCUWRUXCHZUXRVVBVV
    DUXRHZVURVVAVVEVURHZVUTVUOVVFVUTHZVUIVUNVVGVUIHZUWJVUMVVHUVLUWIVVGUVLVUIVVF
    VUTUVLUYHVUTUVLLVVEUYIUYHVUTUVLUYHUWCUWDUVLVUTUYOUVPUWDUVTUWEOUWFPTWORZOVVD
    UWIUXRVURVUTVUIUWRUWIUXCUWSOYBVEVVHVUKVULVVGVUKVUIVVFVUTVUKVVEVURVUTVUKLZVV
    DVURVVJLZUXRUWRUXCVVKUWRVUTVURUXCVUKUWRVUTVURUXCVUKLLUWRVUTHZVURVUKUXCVVLVU
    RHUUKUUJUWRUVMVUTVURUUKYCZWTVVLVURUVLUVPVURUVLLUWRUVTVURUVPUVLVURUWCUWDUVLU
    VPUYHUWCUYIUYOOUWEUWFPWMWORYFXITYGRORROVVHVULUYPUUJUDFVSZUYPUUJKZVSZHZVVHVV
    NVVPVVGVVNVUIVVFVUTVVNVVEVURVUTVVNLZUWRVURVVRLZUXCUXRUWRUVMVVSVVMVUTVURUVMV
    VNUVPUVTVURUVMVVNLZLZUVPUWDUVTVWALUWEVURUVTUWDVVTUYHUYIUVTUWDVVTLZLZUYHUWCU
    YIVWCLUYOUWCUYIUVTVWBUWCUWDUYIUVTHZVVTUWCUWDVWDVVTLUWCUWDHZUVMVWDVVNVWEUVMV
    WDVVNLVWEUVMHZVWDUUJUUKUUKUAEZMFZVVNVWEUVMVWDVWHLABUUKUUKYHYIVWFVWHUUJUYPMF
    ZVVNVWFVWGUYPUUJMVWFUYPVWGVWFUUKUVMVUGVWEUUKYJWBYKYLUUAVWFVWIVVNVWEUVLUYPUO
    GZVWIVVNWRUVMUWFUVMXLUUKXLUOGZUVMYMYPUVMUUBYNUUJUYPUUCPYOWAUUDTYQTYQUUEQRYR
    QRYRQWTRROVVGVUIVVPVVGVUIVVPVVGUYQVVOUYQVVOWRVVGUUJUYPUUHYPUUFYORVEVVHUVLVW
    JHZVULVVQWRVVGVWLVUIVVGUVLVWJVVIUWRVWJUXCUXRVURVUTUWRXLUUKVWKUWRYMYPVVMYNYB
    VEOUUJUYPXHQXAVEVETTTTTQXKXKYRYSUTVFYSUTRXKXKUUJUUKUUGQYLSTUUIWPTYTYT $.

  $( Cyclically shifting a word two times resulting in the word itself.
     (Contributed by Alexander van der Vekens, 7-Apr-2018.)  (Revised by
     Alexander van der Vekens, 5-Jun-2018.) $)
  2cshwid $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) ) )
                 -> ( ( W CyclShift N ) CyclShift ( ( # ` W ) - N ) ) = W ) $=
    ( cword wcel cc0 chash co wa ccsh cle wbr w3a wceq cn0 nn0cn adantl 3adant3
    cc sylbi cfv cfz cmin caddc id fznn0sub2 elfz2nn0 pncan3 syl2an nn0re leidd
    eqbrtrd 3jca 2cshw1 imp sylan2 oveq2d cshwn adantr 3eqtrd ) CBDEZAFCGUAZUBH
    ZEZIZCAJHVBAUCHZJHZCAVFUDHZJHZCVBJHZCVDVAVDVFVCEZVHVBKLZMZVGVINZVDVDVKVLVDU
    EAVBUFVDAOEZVBOEZAVBKLZMZVLAVBUGZVOVPVLVQVOVPIVHVBVBKVOASEVBSEVHVBNZVPAPVBP
    AVBUHUIZVPVBVBKLVOVPVBVBUJUKQULRTUMVAVMVNAVFBCUNUOUPVEVHVBCJVDVTVAVDVRVTVSV
    OVPVTVQWARTQUQVAVJCNVDBCURUSUT $.

  ${
    $d W w $.
    $( Extract the last symbol of a word.  May be not meaningful for other set
       which are not words.  (Contributed by Alexander van der Vekens,
       18-Mar-2018.) $)
    lswrd $p |- ( W e. X -> ( LastS ` W ) = ( W ` ( ( # ` W ) - 1 ) ) ) $=
      ( vw wcel cvv chash cfv c1 cmin co clswrd wceq elex fvex cv fveq2 fveq12d
      id oveq1d df-lswrd fvmptg sylancl ) ABDAEDAFGZHIJZAGZEDAKGUELABMUDANCACOZ
      FGZHIJZUFGUEEEKUFALZUHUDUFAUIRUIUGUCHIUFAFPSQCTUAUB $.
  $}

  $( The last symbol of a not empty word exists.  The empty set must be
     excluded as symbol, because otherwise, it cannot be distinguished between
     valid cases ( ` (/) ` is the last symbol) and invalid cases ( ` (/) `
     means that no last symbol exists.  This is because of the special
     definition of a function in set.mm.  (Contributed by Alexander van der
     Vekens, 18-Mar-2018.) $)
  lswrdn0 $p |- ( ( W e. Word V /\ (/) e/ V /\ ( # ` W ) =/= 0 )
                  -> ( LastS ` W ) =/= (/) ) $=
    ( cword wcel c0 wnel chash cfv cc0 wne w3a clswrd c1 cmin co wceq wi cn0 wa
    com12 lswrd 3ad2ant1 cfzo wrdf lencl simpll clt wbr elnnne0 biimpri nnm1nn0
    wf cn syl nn0re ltm1d adantr elfzo0 syl3anbrc adantll ffvelrnd ex wn eleq1a
    syl2anc eqcoms nnel syl6ibr necon2ad syl6 com23 3imp eqnetrd ) BACZDZEAFZBG
    HZIJZKBLHZVQMNOZBHZEVOVPVSWAPVRBVNUAUBVOVPVRWAEJZVOVRVPWBVOVRWAADZVPWBQVOIV
    QUCOZABULZVQRDZVRWCQABUDABUEWEWFSZVRWCWGVRSWDAVTBWEWFVRUFWFVRVTWDDZWEWFVRSZ
    VTRDZVQUMDZVTVQUGUHZWHWIWKWJWKWIVQUIUJZVQUKUNWMWFWLVRWFVQVQUOUPUQVTVQURUSUT
    VAVBVEWCVPWAEWCWAEPZEADZVPVCWNWCWOWCWOQEWAWCEWAPWOWAAEVDTVFTEAVGVHVIVJVKVLV
    M $.

  $( The last symbol of an empty word does not exist.  (Contributed by
     Alexander van der Vekens, 19-Mar-2018.) $)
  lswrd0 $p |- ( ( W e. Word V /\ ( # ` W ) = 0 ) -> ( LastS ` W ) = (/) ) $=
    ( cword wcel chash cfv cc0 wceq wa clswrd c1 cmin co c0 lswrd adantr wn cn0
    cn syl oveq1 fveq2d cdm cfzo wf wrdf lencl wi fdm clt wbr w3a wnel 0mnnnnn0
    w3o 1nn mp1i df-nel sylib 3mix1 3ianor sylibr elfzo0 sylnibr notbid syl5ibr
    eleq2 sylc ndmfv sylan9eqr eqtrd ) BACZDZBEFZGHZIBJFZVNKLMZBFZNVMVPVRHVOBVL
    OPVOVMVRGKLMZBFZNVOVQVSBVNGKLUAUBVMVSBUCZDZQZVTNHVMGVNUDMZABUEZVNRDZWCABUFA
    BUGWEWAWDHZWFWCUHWDABUIWFWCWGVSWDDZQWFVSRDZVNSDZVSVNUJUKZULZWHWFWIQZWJQZWKQ
    ZUOZWLQWFWMWPWFVSRUMZWMKSDWQWFUPKUNUQVSRURUSWMWNWOUTTWIWJWKVAVBVSVNVCVDWGWB
    WHWAWDVSVGVEVFTVHVSBVITVJVK $.

  $( The last symbol of a word of length 1 is the first symbol of this word.
     (Contributed by Alexander van der Vekens, 19-Mar-2018.) $)
  lswrd1 $p |- ( ( W e. Word V /\ ( # ` W ) = 1 )
                 -> ( LastS ` W ) = ( W ` 0 ) ) $=
    ( cword wcel chash cfv c1 wceq clswrd cmin co cc0 lswrd oveq1 syl6eq fveq2d
    1m1e0 sylan9eq ) BACZDBEFZGHZBIFTGJKZBFLBFBSMUAUBLBUAUBGGJKLTGGJNQOPR $.

  $( The last symbol of a non-empty word concatenated with its first symbol is
     the first symbol.  (Contributed by Alexander van der Vekens,
     28-Jun-2018.) $)
  lstccats1fst $p |- ( ( P e. Word V /\ 1 <_ ( # ` P ) )
                      -> ( LastS ` ( P concat <" ( P ` 0 ) "> ) )
                          = ( ( P concat <" ( P ` 0 ) "> ) ` 0 ) ) $=
    ( wcel c1 chash cfv wbr cc0 co cmin wceq syl eqcomd fveq2d caddc cfzo nn0zd
    cz clt adantr cword cle cs1 cconcat clswrd wrdsymb1 s1cld wrdlenccats1lenm1
    wa ccatcl syldan lswrd simpl lencl cfn wrdfin hashcl 3syl zaddcld cr nn0red
    ltp1d s1len oveq2i syl6breqr fzolb syl3anbrc ccatval2 syl3anc nn0cnd subidd
    cn0 s1fv eqtrd cn elnnnn0c simplbi2 imp lbfzo0 sylibr w3a ccatval1 3eqtrd
    wi ) ABUAZCZDAEFZUBGZUIZAHAFZUCZUDIZUEFZWLEFDJIZWLFZWGWLFZHWLFZWIWLWECZWMWO
    KWFWHWKWECZWRWIWJBABUFZUGZBAWKUJUKWLWEULLWIWNWGWLWIWGWNABUHMNWIWPWGWGJIZWKF
    ZWJWQWIWFWSWGWGWGWKEFZOIZPICZWPXCKWFWHUMZXAWIWGRCZXERCWGXESGXFWFXHWHWFWGBAU
    NZQTZWIWGXDXJWIXDWIWSWKUOCXDVLCXABWKUPWKUQURQUSWIWGWGDOIXESWIWGWFWGUTCWHWFW
    GXIVATVBXDDWGOWJVCVDVEWGXEVFVGBAWKWGVHVIWIXCHWKFZWJWIXBHWKWFXBHKWHWFWGWFWGX
    IVJVKTNWIWJBCXKWJKWTWJBVMLVNWIWFWSHHWGPICZWJWQKXGXAWIWGVOCZXLWFWHXMWFWGVLCZ
    WHXMWDXIXMXNWHWGVPVQLVRWGVSVTWFWSXLWAWQWJBAWKHWBMVIWCWC $.

  $( The last symbol in a left-anchored subword.  (Contributed by Alexander van
     der Vekens, 24-Jun-2018.) $)
  swrd0fvls $p |- ( ( S e. Word A /\ L e. ( 1 ... ( # ` S ) ) )
          -> ( LastS ` ( S substr <. 0 , L >. ) ) = ( S ` ( L - 1 ) ) ) $=
    ( cword wcel c1 chash cfv cfz co wa cc0 cop csubstr clswrd cmin wceq swrdcl
    syl adantl adantr lswrd cuz wss cn0 1nn0 nn0uz eleqtri fzss1 ax-mp swrd0len
    sseli sylan2 oveq1d fveq2d cfzo simpl elfznn fzo0end swrd0fv syl3anc 3eqtrd
    cn ) BADZEZCFBGHZIJZEZKZBLCMNJZOHZVJGHZFPJZVJHZCFPJZVJHZVOBHZVIVJVDEZVKVNQV
    EVRVHABLCRUAVJVDUBSVIVMVOVJVIVLCFPVHVECLVFIJZEZVLCQVGVSCFLUCHZEVGVSUDFUEWAU
    FUGUHFLVFUIUJULZABCUKUMUNUOVIVEVTVOLCUPJEZVPVQQVEVHUQVHVTVEWBTVHWCVEVHCVCEW
    CCVFURCUSSTABCVOUTVAVB $.

  $( Closure of the last symbol: the last symbol of a not empty word is a
     symbol.  (Contributed by Alexander van der Vekens, 2-Aug-2018.) $)
  lswrdcl $p |- ( ( W e. Word V /\ W =/= (/) ) -> ( LastS ` W ) e. V ) $=
    ( cword wcel c0 wne wa clswrd cfv chash c1 cmin co wceq lswrd adantr cc0 wf
    cfzo cn0 wrdf cn clt wbr hasheq0 necon3bid wi lencl elnnne0 nnm1nn0 id nnre
    w3a ltm1d 3jca sylbir ex syl sylbird imp elfzo0 sylibr ffvelrnd eqeltrd ) B
    ACZDZBEFZGZBHIZBJIZKLMZBIZAVFVIVLNVGBVEOPVHQVJSMZAVKBVFVMABRVGABUAPVHVKTDZV
    JUBDZVKVJUCUDZUMZVKVMDVFVGVQVFVGVJQFZVQVFVJQBEBVEUEUFVFVJTDZVRVQUGABUHVSVRV
    QVSVRGVOVQVJUIVOVNVOVPVJUJVOUKVOVJVJULUNUOUPUQURUSUTVKVJVAVBVCVD $.

  $( Reconstruct a nonempty word from its prefix and last symbol.  (Contributed
     by Alexander van der Vekens, 5-Aug-2018.) $)
  swrdccatwrd $p |- ( ( W e. Word V /\ W =/= (/) )
                      -> ( ( W substr <. 0 , ( ( # ` W ) - 1 ) >. )
                           concat <" ( LastS ` W ) "> ) = W ) $=
    ( wcel cc0 cfv c1 cop csubstr cs1 cconcat wceq syl syldan a1i oveq2d adantr
    co cfz cn0 biimpi cword c0 wne chash cmin clswrd caddc cfzo lennncl fzo0end
    wa cn swrds1 nncn cc ax-1cn npcand eqcomd opeq2d lswrd 3eqtr4rd w3a nnm1nn0
    s1eqd 0elfz cle wbr 1nn0 nnnn0 nnge1 elfz2nn0 syl3anbrc fz0fzdiffz0 syl2anc
    elfz1end nn0fz0 3jca ccatswrd swrdid 3eqtrd ) BAUAZCZBUBUCZUKZBDBUDEZFUEQZG
    HQZBUFEZIZJQWGBWFWEGZHQZJQZBDWEGHQZBWDWIWKWGJWDBWFWFFUGQZGZHQZWFBEZIZWKWIWB
    WCWFDWEUHQCZWPWRKWDWEULCZWSABUIZWEUJLAWFBUMMWDWJWOBHWDWEWNWFWDWTWEWNKXAWTWN
    WEWTWEFWEUNFUOCWTUPNUQURLUSOWDWHWQWBWHWQKWCBWAUTPVDVAOWBWCDDWFRQCZWFDWERQZC
    ZWEXCCZVBZWLWMKWDWTXFXAWTXBXDXEWTWFSCXBWEVCWFVELWTFXCCZWEFWERQCZXDWTFSCZWES
    CZFWEVFVGXGXIWTVHNWEVIZWEVJFWEVKVLWTXHWEVOTWEFWEVMVNWTXJXEXKXJXEWEVPTLVQLAB
    DWFWEVRMWBWMBKWCABVSPVT $.

  $( The last symbol of a non-empty word concatenated with a symbol is the
     symbol itself.  (Contributed by Alexander van der Vekens, 6-Aug-2018.) $)
  lstccats1 $p |- ( ( W e. Word V /\ S e. V )
                    -> ( LastS ` ( W concat <" S "> ) ) = S ) $=
    ( cword wcel wa cs1 cconcat co clswrd cfv chash c1 cmin cvv wceq ovex caddc
    oveq1d a1i lswrd mp1i ccatlen sylan2 s1len oveq2d cn0 lencl nn0cn cc ax-1cn
    s1cl pncand syl adantr 3eqtrd ccats1val2 mpd3an3 eqtrd ) CBDZEZABEZFZCAGZHI
    ZJKZVELKZMNIZVEKZAVEOEVFVIPVCCVDHQVEOUAUBVAVBVHCLKZPVIAPVCVHVJVDLKZRIZMNIVJ
    MRIZMNIZVJVCVGVLMNVBVAVDUTEVGVLPABULBCVDUCUDSVCVLVMMNVCVKMVJRVKMPVCAUETUFSV
    AVNVJPZVBVAVJUGEZVOBCUHVPVJMVJUIMUJEVPUKTUMUNUOUPAVHBCUQURUS $.

  ${
    $d U i $.  $d V i $.  $d W i $.
    $( Two words are equal iff they have the same length and the same prefix
       and the same last symbol.  (Contributed by Alexander van der Vekens,
       7-Aug-2018.) $)
    wrdeqswrdlst $p |- ( ( ( W e. Word V /\ U e. Word V )
                         /\ ( W =/= (/) /\ U =/= (/) ) )
        -> ( W = U <-> ( ( # ` W ) = ( # ` U ) /\ ( LastS ` W ) = ( LastS ` U )
                         /\ ( W substr <. 0 , ( ( # ` W ) - 1 ) >. )
                            = ( U substr <. 0 , ( ( # ` W ) - 1 ) >. ) ) ) ) $=
      ( vi wcel wa wceq cfv cc0 co wral c1 cmin wb adantr cuz syl adantl 3bitrd
      a1i cword c0 wne chash cv cfzo clswrd cop csubstr w3a wrdeq0 csn cz caddc
      cun 0z cn lennncl elnnuz 1e0p1 fveq2i eleq2i biimpi ad2ant2r fzosplitsnm1
      sylbi sylancr raleqdv ralunb syl6bb ovex fveq2 eqeq12d ralsng mp1i fveq2d
      cvv oveq1 eqeq2d lswrd eqcomd ad2antrr anbi2d ancom eqid biantrur cn0 cle
      wbr simpll nnm1nn0 lencl nn0re lem1d breq2 eqcoms mpbird swrdeq syl122anc
      an12 bicomd pm5.32da 3anass bicomi ) CBUAZEZAXEEZFZCUBUCZAUBUCZFZFZCAGZCU
      DHZAUDHZGZDUEZCHZXQAHZGZDIXNUFJZKZFZXPCUGHZAUGHZGZCIXNLMJZUHZUIJAYHUIJGZF
      ZFZXPYFYIUJZXHXMYCNXKCDBAUKOXLXPYBYJXLXPFZYBXTDIYGUFJZKZXTDYGULZKZFZYFYGY
      GGZYOFZFZYJYMYBXTDYNYPUOZKYRYMXTDYAUUBYMIUMEXNILUNJZPHZEZYAUUBGUPXLUUEXPX
      FXIUUEXGXJXFXIFZXNUQEZUUEBCURZUUGXNLPHZEZUUEXNUSUUJUUEUUIUUDXNLUUCPUTVAVB
      VCVFQVDOIXNVEVGVHXTDYNYPVIVJYMYRYOYFFZYFYOFZUUAYMYQYFYOYMYQYGCHZYGAHZGZUU
      MXOLMJZAHZGZYFYGVQEYQUUONYMXNLMVKXTUUODYGVQXQYGGXRUUMXSUUNXQYGCVLXQYGAVLV
      MVNVOXPUUOUURNXLXPUUNUUQUUMXPYGUUPAXNXOLMVRVPVSRXHUURYFNXKXPXHUUMYDUUQYEX
      HYDUUMXFYDUUMGXGCXEVTOWAXHYEUUQXGYEUUQGXFAXEVTRWAVMWBSWCUUKUULNYMYOYFWDTY
      MUULYSUULFZUUAUULUUSNYMYSUULYGWEWFTYSYFYOWTVJSYMYTYIYFYMYIYTYMXHYGWGEZUUT
      YGXNWHWIZYGXOWHWIZYIYTNXHXKXPWJXLUUTXPXFXIUUTXGXJUUFUUGUUTUUHXNWKQVDOZUVC
      XHUVAXKXPXFUVAXGXFXNWGEZUVABCWLUVDXNXNWMWNQOWBZYMUVBUVAUVEXPUVBUVANZXLUVF
      XOXNXOXNYGWHWOWPRWQADYGYGBCWRWSXAWCSXBYKYLNXLYLYKXPYFYIXCXDTS $.
  $}

  $( The last symbol in a word truncated by one symbol.  (Contributed by
     Alexander van der Vekens, 16-Jun-2018.) $)
  swrdtrcfvl $p |- ( ( S e. Word A /\ 2 <_ ( # ` S ) )
                       -> ( LastS ` ( S substr <. 0 , ( ( # ` S ) - 1 ) >. ) )
                          = ( S ` ( ( # ` S ) - 2 ) ) ) $=
    ( wcel c2 cfv cle wbr wa cc0 c1 cmin co wceq cn0 w3a cz syl adantr clt a1i
    cword chash cop csubstr clswrd cvv ovex lswrd mp1i cfz nn0z peano2zm cr 0re
    lencl 2re nn0re 3jca 2pos simpr ltletr imp syl12anc wb 0nn0 nn0ltlem1 mpbid
    jctl elnn0z sylanbrc simpl lem1d sylan elfz2nn0 sylibr syldan oveq1d nn0cnd
    swrd0len caddc cc ax-1cn subsub4d 1p1e2 oveq2d eqtrd fveq2d wne nn0n0n1ge2b
    c0 wi hasheq0 adantl necon3bid biimpd adantrd sylbird mpancom cn 2z zsubcld
    cfzo subge0d biimpar cuz syl3anbrc uz2m1nn 1lt2 1re ltsub2 elfzo0 swrdtrcfv
    eluz2 syl3anc ) BAUAZCZDBUBEZFGZHZBIXQJKLZUCZUDLZUEEZYBUBEZJKLZYBEZXQDKLZBE
    ZYBUFCYCYFMXSBYAUDUGYBUFUHUIXSYFYGYBEZYHXSYEYGYBXSYEXTJKLZYGXSYDXTJKXPXRXTI
    XQUJLCZYDXTMXSXTNCZXQNCZXTXQFGZOZYKXPYMXRYOABUOZYMXRHZYLYMYNYQXTPCZIXTFGZYL
    YMYRXRYMXQPCZYRXQUKZXQULQRYQIXQSGZYSYQIUMCZDUMCZXQUMCZOZIDSGZXRUUBYMUUFXRYM
    UUCUUDUUEUUCYMUNTUUDYMUPTZXQUQZURRUUGYQUSTYMXRUTZUUFUUGXRHUUBIDXQVAVBVCYQIN
    CZYMHZUUBYSVDYMUULXRYMUUKVEVHRIXQVFQVGXTVIVJYMXRVKYMYNXRYMXQUUIVLRURVMXTXQV
    NVOABXTVSVPVQXPYJYGMXRXPYJXQJJVTLZKLYGXPXQJJXPXQYPVRJWACXPWBTZUUNWCXPUUMDXQ
    KUUMDMXPWDTWEWFRWFWGXSXPBWJWHZYGIXTXBLCZYIYHMXPXRVKXPXRUUOYMXPXRUUOWKYPYMXP
    HZXRXQIWHZXQJWHZHZUUOYMUUTXRVDXPXQWIRUUQUURUUOUUSUUQUURUUOUUQXQIBWJXPXQIMBW
    JMVDYMBXOWLWMWNWOWPWQWRVBXSYGNCZXTWSCZYGXTSGZOZUUPXPYMXRUVDYPYQUVAUVBUVCYQY
    GPCZIYGFGZUVAYMUVEXRYMXQDUUADPCZYMWTTXARYMUVFXRYMXQDUUIUUHXCXDYGVIVJYQXQDXE
    ECZUVBYQUVGYTXRUVHUVGYQWTTYMYTXRUUARUUJDXQXMXFXQXGQYQJDSGZUVCUVIYQXHTYQJUMC
    ZUUDUUEOZUVIUVCVDYMUVKXRYMUVJUUDUUEUVJYMXITUUHUUIURRJDXQXJQVGURVMYGXTXKVOAB
    YGXLXNWFWF $.

  $( The last symbol of a word cyclically shifted by N positions is the symbol
     at index (N-1) of the original word.  (Contributed by Alexander van der
     Vekens, 21-Mar-2018.)  (Revised by Alexander van der Vekens,
     5-Jun-2018.) $)
  lswrdcshw $p |- ( ( W e. Word V /\ N e. ( 1 ..^ ( # ` W ) ) )
                      -> ( LastS ` ( W CyclShift N ) ) = ( W ` ( N - 1 ) ) ) $=
    ( cword wcel c1 chash cfv cfzo co ccsh clswrd cmin cvv wceq ovex lswrd mp1i
    wa cc0 cfz fzo0ss1 fzossfz ssel2 sseldi mpan cshwlen sylan2 oveq1d cshwidxn
    wss fveq2d ancoms 3eqtrd ) CBDEZAFCGHZIJZEZSZCAKJZLHZUTGHZFMJZUTHZUPFMJZUTH
    ZAFMJCHZUTNEVAVDOUSCAKPUTNQRUSVCVEUTUSVBUPFMURUOATUPUAJZEZVBUPOUQTUPIJZUKZU
    RVIUPUBVKURSVJVHATUPUCUQVJAUDUEUFABCUGUHUIULURUOVFVGOABCUJUMUN $.

  $( Cyclically shifting a word two times is commutative.  (Contributed by
     Alexander van der Vekens, 21-Apr-2018.)  (Revised by Alexander van der
     Vekens, 5-Jun-2018.) $)
  2cshwcom $p |- ( ( W e. Word V /\ ( N e. ( 0 ... ( # ` W ) )
      /\ M e. ( 0 ... ( # ` W ) ) ) ) -> ( ( W CyclShift N ) CyclShift M )
                                       = ( ( W CyclShift M ) CyclShift N ) ) $=
    ( caddc co cle wbr wcel wa ccsh wceq cmin cif iftrue adantr 2cshw fz0addcom
    imp adantl chash cfv cword cc0 cfz ancom2s ancoms breq1d biimpac syl oveq2d
    ad2antll 3eqtrd 3eqtr4rd wn iffalse notbid oveq1d pm2.61ian ) ABEFZDUAUBZGH
    ZDCUCIZBUDVAUEFZIZAVDIZJZJZDBKFAKFZDAKFBKFZLVBVHJZVBDUTKFZDUTVAMFZKFZNZVLVJ
    VIVBVOVLLVHVBVLVNOPVHVJVOLZVBVCVFVEVPVCVFVEJVPABCDQSUFZTVKVIBAEFZVAGHZDVRKF
    ZDVRVAMFZKFZNZVTVLVHVIWCLZVBVCVGWDBACDQSZTVKVSWCVTLVHVBVSVHUTVRVAGVGUTVRLZV
    CVFVEWFABVARUGTUHZUIVSVTWBOUJVKVRUTDKVGVRUTLVBVCBAVARZULUKUMUNVBUOZVHJZVOVN
    VJVIWIVOVNLVHVBVLVNUPPVHVPWIVQTWJVIWCWBVNVHWDWIWETWJVSUOZWCWBLVHWIWKVHVBVSW
    GUQUIVSVTWBUPUJVGWBVNLWIVCVGWAVMDKVGVRUTVAMWHURUKULUMUNUS $.

  $( If the results of cyclically shifting two words are equal, the length of
     the two words was equal.  (Contributed by Alexander van der Vekens,
     21-Apr-2018.)  (Revised by Alexander van der Vekens, 5-Jun-2018.) $)
  cshwleneq $p |- ( ( ( W e. Word V /\ U e. Word V )
                    /\ ( N e. ( 0 ... ( # ` W ) ) /\ M e. ( 0 ... ( # ` U ) ) )
                    /\ ( W CyclShift N ) = ( U CyclShift M ) )
                          -> ( # ` W ) = ( # ` U ) ) $=
    ( cword wcel wa cc0 chash cfv cfz co ccsh wceq w3a cshwlen ad2ant2r 3adant3
    simpr eqcomd wb fveq2 eqeq2d 3ad2ant3 mpbid anim12i syl eqtrd ) EDFZGZAUJGZ
    HZCIEJKZLMGZBIAJKZLMGZHZECNMZABNMZOZPZUNUTJKZUPVBUNUSJKZOZUNVCOZUMURVEVAUMU
    RHVDUNUKUOVDUNOULUQCDEQRUASVAUMVEVFUBURVAVDVCUNUSUTJUCUDUEUFVBULUQHZVCUPOUM
    URVGVAUMULURUQUKULTUOUQTUGSBDAQUHUI $.

  $( Cyclically shifting a word three times results in a once cyclically
     shifted word under certain circumstances.  (Contributed by Alexander van
     der Vekens, 6-Jun-2018.) $)
  3cshw $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) )
                /\ M e. ( 0 ... ( # ` W ) ) ) -> ( W CyclShift N ) =
         ( ( ( W CyclShift M ) CyclShift N ) CyclShift ( ( # ` W ) - M ) ) ) $=
    ( cword wcel cc0 chash cfv cfz co w3a ccsh cmin wceq 2cshwid 3adant2 eqcomd
    wa eleq2d oveq1d cshwcl 3ad2ant1 fznn0sub2 3ad2ant3 simp2 wb cshwlen oveq2d
    anbi12d mpbir2and 2cshwcom syl2anc eqtrd ) DCEZFZBGDHIZJKZFZAURFZLZDBMKDAMK
    ZUQANKZMKZBMKZVBBMKVCMKZVADVDBMVAVDDUPUTVDDOUSACDPQRUAVAVBUOFZVCGVBHIZJKZFZ
    BVIFZSZVEVFOUPUSVGUTACDUBUCVAVLVCURFZUSUTUPVMUSAUQUDUEUPUSUTUFUPUTVLVMUSSUG
    USUPUTSZVJVMVKUSVNVIURVCVNVHUQGJACDUHUIZTVNVIURBVOTUJQUKBVCCVBULUMUN $.

  $( If cyclically shifting two words (of the same length) results in the same
     word, cyclically shifting one of the words by the difference of the
     numbers of shifts results in the other word.  (Contributed by Alexander
     van der Vekens, 21-Apr-2018.)  (Revised by Alexander van der Vekens,
     6-Jun-2018.) $)
  cshweqdif2 $p |- ( ( W e. Word V /\ U e. Word V /\ ( # ` W ) = ( # ` U ) )
                    -> ( ( N e. ( 0 ... ( # ` W ) ) /\ M e. ( N ... ( # ` W ) )
                         /\ ( W CyclShift N ) = ( U CyclShift M ) )
                          -> ( U CyclShift ( M - N ) ) = W ) ) $=
    ( wcel wceq w3a cc0 cfz co ccsh cmin wa 3adant3 adantl 3ad2ant3 cle wbr syl
    cword chash caddc wi simpl fz0fzdiffz0 fz0fzelfz0 3cshw syl3anc ex 3ad2ant2
    cfv oveq2 eleq2d 3anbi12d wb oveq1 oveq2d eqeq2d 3imtr4d eqcoms simp1 elfz2
    imp cz cc zcn pncan3 syl2an eqcomd 3adant2 breq1d biimpcd impcom sylbi 3jca
    2cshw1 elfzelz zcnd anim12i 3eqtrd oveq1d fznn0sub2 syl2anr cr adantr leidd
    zre eqbrtrd 3adant1 elfzel2 syl2anc cshwn ) EDUAZFZAWNFZEUBULZAUBULZGZHZCIW
    QJKZFZBCWQJKZFZECLKZABLKZGZHZABCMKZLKZEGWTXHNZXJEBWQBMKZUCKZLKZEWQLKZEXKXJX
    FXILKZXLLKZEBLKZXLLKZXNWTXHXJXQGZWTCIWRJKZFZBCWRJKZFZXGHZXJXPWRBMKZLKZGZXHX
    TWPWOYEYHUDWSWPYEYHWPYENWPXIYAFZBYAFZYHWPYEUEYEYIWPYBYDYIXGBCWRUFOPYEYJWPYB
    YDYJXGWRBCUGOPBXIDAUHUIUJUKWTXBYBXDYDXGWTXAYACWSWOXAYAGWPWQWRIJUMQUNWTXCYCB
    WSWOXCYCGWPWQWRCJUMQUNUOWSWOXTYHUPWPWSXQYGXJWSXLYFXPLWQWRBMUQURUSQUTVDXKXPX
    RXLLXKXPXEXILKZECXIUCKZLKZXRXHXPYKGZWTXGXBYNXDYNXFXEXFXEXILUQVAQPWTWOXBXIXA
    FZYLWQRSZHZYKYMGZXHWOWPWSVBZXBXDYQXGXBXDNZXBYOYPXBXDUEBCWQUFXDYPXBXDCVEFZWQ
    VEFZBVEFZHZCBRSZBWQRSZNZNZYPBCWQVCZUUGUUDYPUUFUUDYPUDUUEUUDUUFYPUUDBYLWQRUU
    AUUCBYLGUUBUUAUUCNYLBUUACVFFZBVFFZYLBGZUUCCVGBVGZCBVHZVIVJVKVLVMPVNVOPVPOWO
    YQYRCXIDEVQVDVIXKYLBELXKUUJUUKNZUULXHUUOWTXBXDUUOXGXBUUJXDUUKXBCCIWQVRVSXDB
    BCWQVRZVSVTOPUUNTURWAWBWTWOBXAFZXLXAFZXMWQRSZHZXSXNGZXHYSXBXDUUTXGYTUUQUURU
    USWQBCUGZYTUUQUURUVBBWQWCTXDUUSXBXDUUHUUSUUIUUDUUSUUGUUBUUCUUSUUAUUBUUCNZXM
    WQWQRUUCUUKWQVFFZXMWQGZUUBUUMWQVGZBWQVHZWDUVCWQUUBWQWEFUUCWQWHWFWGWIWJWFVOP
    VPOWOUUTUVABXLDEVQVDVIWAXKXMWQELXHUVEWTXDXBUVEXGXDUUKUVDNZUVEXDUUCUUBUVHUUP
    BCWQWKUUCUUKUUBUVDUUMUVFVTWLUVGTUKPURWTXOEGZXHWTWOUVIYSDEWMTWFWAUJ $.

  $( If cyclically shifting two words (of the same length) results in the same
     word, cyclically shifting one of the words by the difference of the
     numbers of shifts results in the other word.  (Contributed by Alexander
     van der Vekens, 22-Apr-2018.)  (Revised by Alexander van der Vekens,
     7-Jun-2018.) $)
  cshweqdif2s $p |- ( ( ( W e. Word V /\ U e. Word V )
               /\ ( N e. ( 0 ... ( # ` W ) ) /\ M e. ( N ... ( # ` U ) ) ) )
                     -> ( ( W CyclShift N ) = ( U CyclShift M )
                          -> ( U CyclShift ( M - N ) ) = W ) ) $=
    ( wcel wa cc0 cfz co wceq w3a cn0 cle wbr wi cr adantr ex adantl cword ccsh
    chash cfv cmin simpll simpl elfz2nn0 elfz2 nn0ge0 0re a1i 3ad2ant1 3ad2ant3
    zre 3jca letr syl simp3 anim1i elnn0z sylibr 3ad2ant2 syl3anc simplbi2 syld
    cz exp3acom23 imp31 jca exp4b com13 com14 imp impcom com12 simplrr sylanbrc
    df-3an sylbi simpr simpllr simplrl oveq2 eqcoms eleq2d biimpcd expcom com23
    cshwleneq mpancom cshweqdif2 ) EDUAZFZAWMFZGZCHEUCUDZIJFZBCAUCUDZIJZFZGZGZE
    CUBJABUBJKZABCUEJUBJEKZXCXDGZWNWOWQWSKZLZWRBCWQIJZFZXDLZGZXEXGXFXLXFWPWRBHW
    SIJFZGZXDXGWPXBXDUFXCXNXDXBXNWPXBWRXMWRXAUGXBBMFZWSMFZBWSNOZLZXMWRXAXRWRCMF
    ZWQMFZCWQNOZLZXAXRPCWQUHXAYBXRXACVGFZWSVGFZBVGFZLZCBNOZXQGZGZYBXRPBCWSUIYIY
    BXRYIYBGXOXPGZXQXRYBYIYJXSXTYIYJPZYAXSHCNOZYKCUJYIYLYJYHYFYLYJPZYGXQYFYMPYL
    XQYFYGYJYFXQYLYGYJPYFXQYLYGYJYFXQGZYLYGGZHBNOZYJYNHQFZCQFZBQFZLZYOYPPYFYTXQ
    YFYQYRYSYQYFUKULZYCYDYRYECUOUMYEYCYSYDBUOUNZUPRHCBUQURYNYPYJYNYPGZXOXPUUCYE
    YPGXOYNYEYPYFYEXQYCYDYEUSRUTBVAVBYFXQYPXPYFYPXQXPYFYPXQGZHWSNOZXPYFYQYSWSQF
    ZUUDUUEPUUAUUBYDYCUUFYEWSUOVCHBWSUQVDYDYCUUEXPPYEXPYDUUEWSVAVEVCVFVHVIVJSVF
    VKVLVMVNVOVPURUMVOYFYGXQYBVQXOXPXQVSVRSVTVPVTVNBWSUHVBVJTRXCXDWAABCDEWJVDXG
    XFGZXHXKUUGWNWOXGXFWNXGXCWNXDWNWOXBUFRTXFWOXGWNWOXBXDWBTXGXFUGUPXFXGXKXCXDX
    GXKPZXBXDUUHPWPXBXGXDXKXGXBXDXKPXGXBGZXDXKUUIXDGWRXJXDXGWRXAXDWCUUIXJXDXBXG
    XJXAXGXJPWRXGXAXJXGWTXIBWTXIKWSWQWSWQCIWDWEWFWGTVORUUIXDWAUPSWHWITVNVOVJWKX
    HXKXEABCDEWLVNURS $.

  $( If cyclically shifting a word by two positions results in the same word,
     cyclically shifting the word by the difference of these two positions
     results in the original word itself.  (Contributed by Alexander van der
     Vekens, 21-Apr-2018.)  (Revised by Alexander van der Vekens,
     7-Jun-2018.) $)
  cshweqdifid $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) )
       /\ M e. ( N ... ( # ` W ) ) ) -> ( ( W CyclShift N ) = ( W CyclShift M )
                                       -> ( W CyclShift ( M - N ) ) = W ) ) $=
    ( cword wcel cc0 chash cfv cfz co w3a wa ccsh wceq cmin wi ancri 3ad2ant1
    id 3simpc cshweqdif2s syl2anc ) DCEFZBGDHIZJKFZABUEJKFZLUDUDMZUFUGMDBNKDANK
    ODABPKNKDOQUDUFUHUGUDUDUDTRSUDUFUGUADABCDUBUC $.

  $( If cyclically shifting a word A by n positions results in word B, then
     cyclically shifting the word B by (N-n) positions results in word A.
     (Contributed by Alexander van der Vekens, 22-Apr-2018.)  (Revised by
     Alexander van der Vekens, 7-Jun-2018.) $)
  cshwsym $p |- ( ( W e. Word V /\ N e. ( 0 ... ( # ` W ) ) )
     -> ( ( W CyclShift N ) = B -> ( B CyclShift ( ( # ` W ) - N ) ) = W ) ) $=
    ( cword wcel cc0 chash cfv cfz co wa ccsh cmin wceq 2cshwid oveq1 syl5ibcom
    eqeq1d ) DCEFBGDHIZJKFLDBMKZTBNKZMKZDOUAAOZAUBMKZDOBCDPUDUCUEDUAAUBMQSR $.

  ${
    $d I j y x $.  $d L j x y $.  $d V j x y $.  $d W j x y $.
    $( If cyclically shifting a word by L position results in the word itself,
       the symbol at any position is repeated at multiples of L (modulo the
       length of the word) positions in the word.  (Contributed by Alexander
       van der Vekens, 13-May-2018.)  (Revised by Alexander van der Vekens,
       7-Jun-2018.) $)
    cshweqrep $p |- ( ( W e. Word V /\ L e. ( 0 ..^ ( # ` W ) ) )
      -> ( ( ( W CyclShift L ) = W /\ I e. ( 0 ..^ ( # ` W ) ) ) -> A. j e. NN0
                ( W ` I ) = ( W ` ( ( I + ( j x. L ) ) mod ( # ` W ) ) ) ) ) $=
      ( wcel cc0 cfv co wa wceq cmul caddc cmo cn0 oveq2d oveq1d adantl adantr
      wi vx vy cword chash cfzo ccsh cv wral c1 oveq1 fveq2d eqeq2d imbi2d cmin
      weq cfz cz elfzoel2 fzoval syl eleq2d biimpd com12 impcom cn elfzoelz clt
      wb wbr elfzo0 simp2bi zmodid2 syl2anr mpbird zred mul02lem2 zcnd ad2antll
      cr addid1d eqtr2d eqtr3d eqcoms ad2antrl simprl nn0z zmulcl zaddcl sylan2
      fveq1 expcom ex com13 syl5com imp zmodfzo syl2anc cshwidxmod sylc w3a zre
      nn0re nnrp remulcl readdcl ancoms simpllr simpr modaddmod syl3anc cc recn
      crp recnd addassd ax-1cn adddird mulid2d eqtrd exp31 com23 syl2an 3adant3
      a1i 3syl sylbi 3eqtrd a2d nn0ind ralrimiv ) EDUCFZCGEUDHZUEIZFZJZECUFIZEK
      ZBYMFZJZBEHZBAUGZCLIZMIZYLNIZEHZKZAOUHYOYSJZUUFAOUUAOFUUGUUFUUGYTBUAUGZCL
      IZMIZYLNIZEHZKZTUUGYTBGCLIZMIZYLNIZEHZKZTUUGYTBUBUGZCLIZMIZYLNIZEHZKZTUUG
      YTBUUSUIMIZCLIZMIZYLNIZEHZKZTUUGUUFTUAUBUUAUUHGKZUUMUURUUGUVKUULUUQYTUVKU
      UKUUPEUVKUUJUUOYLNUVKUUIUUNBMUUHGCLUJPQUKULUMUAUBUOZUUMUVDUUGUVLUULUVCYTU
      VLUUKUVBEUVLUUJUVAYLNUVLUUIUUTBMUUHUUSCLUJPQUKULUMUUHUVEKZUUMUVJUUGUVMUUL
      UVIYTUVMUUKUVHEUVMUUJUVGYLNUVMUUIUVFBMUUHUVECLUJPQUKULUMUAAUOZUUMUUFUUGUV
      NUULUUEYTUVNUUKUUDEUVNUUJUUCYLNUVNUUIUUBBMUUHUUACLUJPQUKULUMUUGBUUPEUUGBY
      LNIZBUUPUUGUVOBKZBGYLUIUNIUPIZFZYSYOUVRYRYOUVRTYQYOYRUVRYOYRUVRYOYMUVQBYO
      YLUQFZYMUVQKYNUVSYKCGYLURRGYLUSUTVAVBVCRVDYSBUQFZYLVEFZUVPUVRVHYOYRUVTYQB
      GYLVFZRYNUWAYKYNCOFZUWACYLVGVIZCYLVJZVKRBYLVLVMVNUUGBUUOYLNUUGUUOBGMIZBUU
      GUUNGBMYOUUNGKZYSYNUWGYKYNCVSFZUWGYNCCGYLVFZVOCVPUTRSPYRUWFBKYOYQYRBYRBUW
      BVQVTVRWAQWBUKUUSOFZUUGUVDUVJUWJUUGUVDUVJTUWJUUGJZUVDUVJUWKUVCUVIYTUWKUVC
      UVBYPHZUVBCMIYLNIZEHZUVIUUGUVCUWLKZUWJYQUWOYOYRUWOEYPUVBEYPWJWCWDRUWKYOUV
      BYMFZUWLUWNKUWJYOYSWEUWKUVAUQFZUWAUWPUUGUWJUWQYOYSUWJUWQTZYNYSUWRTYKYNCUQ
      FZYSUWRUWIYRUWSUWRTZYQYRUVTUWTUWBUWJUWSUVTUWQUWJUUSUQFZUWSUVTUWQTZTUUSWFU
      XAUWSUXBUVTUXAUWSJZUWQUXCUVTUUTUQFUWQUUSCWGBUUTWHWIWKWLUTWMUTRWNRWOVDYSUW
      AUWJYOYRUWAYQYRBOFUWABYLVGVIBYLVJVKRVRUVAYLWPWQUVBCDEWRWSUWKUWMUVHEUUGUWJ
      UWMUVHKZYSYOUWJUXDTZYRYOUXETYQYOYRUXEYNYRUXETZYKYNUWCUWAUWDWTUXFUWEUWCUWA
      UXFUWDYRUWCUWAJZUXEYRUVTBVSFZUXGUXETUWBBXAUWJUXGUXHUXDUWJUUSVSFZUXGUXHUXD
      TZUUSXBUWCUWHYLXMFZUXIUXJTZUWACXBYLXCUWHUXKUXLUWHUXIUXKUXJUXIUWHUXKUXJTUX
      IUWHJZUXHUXKUXDUXMUXHUXKUXDUXMUXHJZUXKJZUWMUVACMIZYLNIZUVHUXOUVAVSFZUWHUX
      KUWMUXQKUXNUXRUXKUXHUXMUXRUXMUXHUUTVSFUXRUUSCXDZBUUTXEWIXFSUXIUWHUXHUXKXG
      UXNUXKXHUVACYLXIXJUXOUXPUVGYLNUXNUXPUVGKUXKUXNUXPBUUTCMIZMIUVGUXNBUUTCUXH
      BXKFUXMBXLRUXMUUTXKFUXHUXMUUTUXSXNSUXMCXKFZUXHUWHUYAUXICXLZRZSXOUXNUXTUVF
      BMUXMUXTUVFKUXHUXMUVFUUTUICLIZMIUXTUXMUUSUICUXIUUSXKFUWHUUSXLSUIXKFUXMXPY
      DUYCXQUXMUYDCUUTMUWHUYDCKUXIUWHCUYBXRRPWASPXSSQXSXTYAWKYAWOYBWNWMYEVCYCYF
      RVCRVDVDUKYGULVBWLYHYIVCYJWL $.
  $}

  ${
    $d V i $.  $d W i $.
    $( If cyclically shifting a word by 1 position results in the word itself,
       the word is build of identical symbols.  Remark: also "valid" for an
       empty word!  (Contributed by Alexander van der Vekens, 13-May-2018.)
       (Revised by Alexander van der Vekens, 7-Jun-2018.) $)
    cshw1 $p |- ( ( W e. Word V /\ ( W CyclShift 1 ) = W )
                  -> A. i e. ( 0 ..^ ( # ` W ) ) ( W ` i ) = ( W ` 0 ) ) $=
      ( cfv cc0 wceq wcel c1 co wa cfzo wral wi c0 caddc cn0 wbr adantr syl ex
      chash cword ccsh cv ral0 oveq2 fzo0 syl6eq raleqdv mpbiri a1d wn cmul cmo
      simprl lencl cn clt 1nn0 a1i wne df-ne elnnne0 simplbi2com sylbir biimpri
      impcom ad2antll wb nngt1ne1 mpbird elfzo0 syl3anbrc 0nn0 id nngt0 syl5bir
      simprr com12 imp cshweqrep syl22anc wss fzossnn0 ssralv mp2b eqcom w3a cr
      nn0re ax-1rid oveq2d nn0cn addid2d eqtrd oveq1d 3ad2ant1 crp nnrp anim12i
      cle 3adant3 nn0ge0 anim1i 3adant2 modid sylbi fveq2d eqeq1d biimpd syl5bi
      syl2anc ralimia impancom csn eqid c0ex fveq2 ralsn mpbir pm2.61d2 pm2.61i
      fzo01 ) CUADZEFZCBUBGZCHUCICFZJZAUDZCDZECDZFZAEYDKIZLZMYEYNYHYEYNYLANLYLA
      UEYEYLAYMNYEYMEEKINYDEEKUFEUGUHUIUJUKYEULZYHYNYOYHJYDHFZYNYOYPULZYHYNYOYQ
      JZYHYNYRYHJZYKEYIHUMIZOIZYDUNIZCDZFZAPLZYNYSYFHYMGZYGEYMGZUUEYRYFYGUOYHYR
      UUFYFYRUUFMZYGYFYDPGZUUHBCUPZUUIYRUUFUUIYRJZHPGZYDUQGZHYDURQZUUFUULUUKUSU
      TYRUUIUUMYOUUIUUMMZYQYOYDEVAZUUOYDEVBZUUMUUIUUPYDVCZVDVERVGZUUKUUNYDHVAZY
      QUUTUUIYOUUTYQYDHVBVFVHUUKUUMUUNUUTVIUUSYDVJSVKHYDVLVMTSRVGYRYFYGVRYRYHUU
      GYOYHUUGMYQYHYOUUGYFYOUUGMZYGYFUUIUVAUUJYOUUPUUIUUGUUQUUIUUPUUGUUIUUPJUUM
      UUGUURUUMEPGZUUMEYDURQUUGUVBUUMVNUTUUMVOYDVPEYDVLVMVETVQSRVSRVTYFUUFJYGUU
      GJUUEAEHBCWAVTWBUUEUUDAYMLZYNUVBYMPWCUUEUVCMVNEYDWDUUDAYMPWEWFUUDYLAYMUUD
      UUCYKFZYIYMGZYLYKUUCWGUVEUVDYLUVEUUCYJYKUVEUUBYICUVEYIPGZUUMYIYDURQZWHZUU
      BYIFYIYDVLUVHUUBYIYDUNIZYIUVFUUMUUBUVIFUVGUVFUUAYIYDUNUVFUUAEYIOIYIUVFYTY
      IEOUVFYIWIGZYTYIFYIWJZYIWKSWLUVFYIYIWMWNWOWPWQUVHUVJYDWRGZJZEYIXAQZUVGJZU
      VIYIFUVFUUMUVMUVGUVFUVJUUMUVLUVKYDWSWTXBUVFUVGUVOUUMUVFUVNUVGYIXCXDXEYIYD
      XFXLWOXGXHXIXJXKXMSSTXNYPYNYLAEXOZLZUVQYKYKFZYKXPYLUVRAEXQYIEFYJYKYKYIECX
      RXIXSXTYPYLAYMUVPYPYMEHKIUVPYDHEKUFYCUHUIUJYATYB $.
  $}

  ${
    $d V i v $.  $d W i v $.
    $( If cyclically shifting a (not empty) word by 1 position results in the
       word itself, the word is build of identical symbols.  (Contributed by
       Alexander van der Vekens, 14-May-2018.)  (Revised by Alexander van der
       Vekens, 7-Jun-2018.) $)
    cshw1v $p |- ( ( W e. Word V /\ W =/= (/) /\ ( W CyclShift 1 ) = W )
                   -> E. v e. V A. i e. ( 0 ..^ ( # ` W ) ) ( W ` i ) = v ) $=
      ( cword wcel c0 wne c1 ccsh co wceq w3a cc0 cfv cv chash cfzo wral wrex
      wi wa cn lennncl wrdf 3ad2ant1 lbfzo0 biimpri ffvelrn syl2anr syl 3adant3
      wf ex pm2.43i cshw1 3adant2 eqeq2 ralbidv rspcev syl2anc ) DCEFZDGHZDIJKD
      LZMZNDOZCFZBPDOZVFLZBNDQOZRKZSZVHAPZLZBVKSZACTVEVGVBVCVEVGUAZVDVBVCUBVJUC
      FZVPCDUDVQVEVGVEVKCDUMZNVKFZVGVQVBVCVRVDCDUEUFVSVQVJUGUHVKCNDUIUJUNUKULUO
      VBVDVLVCBCDUPUQVOVLAVFCVMVFLVNVIBVKVMVFVHURUSUTVA $.
  $}

  ${
    $d L i j $.  $d V i j $.  $d W i j $.
    $( Cyclically shifting a word consisting of identical symbols results in
       the word itself.  (Contributed by Alexander van der Vekens,
       18-May-2018.)  (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwsame $p |- ( ( W e. Word V /\ A. i e. ( 0 ..^ ( # ` W ) )
                          ( W ` i ) = ( W ` 0 ) ) -> ( L e. ( 0 ..^ ( # ` W ) )
                      -> ( W CyclShift L ) = W ) ) $=
      ( vj wcel cv cfv cc0 wceq chash cfzo co wral wa cz elfzoelz adantr adantl
      jca cword ccsh cfz simpl elfzofz cshwlen syl2an cmo cn zaddcl syl2anr cn0
      caddc clt wbr elfzo0 simp2bi zmodfzo wb fveq2 eqeq1d rspcdv impancom impl
      syl cshwidxmod imp adantllr wi weq rspccv 3eqtr4d ralrimiva oveq2d mpbird
      raleqdv cshwcl wrdeq0 syl2anc ex ) DCUAZFZAGZDHZIDHZJZAIDKHZLMZNZOZBWHFZD
      BUBMZDJZWJWKOZWMWLKHZWGJZEGZWLHZWQDHZJZEIWOLMZNZOZWNWPXBWJWBBIWGUCMFWPWKW
      BWIUDZBIWGUEBCDUFUGZWNXBWTEWHNWNWTEWHWNWQWHFZOWQBUMMZWGUHMZDHZWEWRWSWJWKX
      FXIWEJZWBWKXFOZWIXJWBXKOZWFXJAXHWHXLXGPFZWGUIFZOZXHWHFXKXOWBXKXMXNXFWQPFB
      PFXMWKWQIWGQBIWGQWQBUJUKWKXNXFWKBULFXNBWGUNUOBWGUPUQRTSXGWGURVEWCXHJZWFXJ
      USXLXPWDXIWEWCXHDUTVASVBVCVDWBWKXFWRXIJZWIWBWKOXFXQWQBCDVFVGVHWNXFWSWEJZW
      JXFXRVIZWKWIXSWBWFXRAWQWHAEVJWDWSWEWCWQDUTVAVKSRVGVLVMWNWTEXAWHWNWOWGILXE
      VNVPVOTWNWLWAFZWBWMXCUSWNWBXTWJWBWKXDRZBCDVQVEYAWLECDVRVSVOVT $.
  $}

  ${
    $d K i $.  $d L i $.  $d V i $.  $d W i $.
    $( If cyclically shifting a word consisting of identical symbols by
       different amounts of positions, the resulting words are identical.
       (Contributed by Alexander van der Vekens, 18-May-2018.)  (Revised by
       Alexander van der Vekens, 8-Jun-2018.) $)
    cshwsame0 $p |- ( ( W e. Word V /\ A. i e. ( 0 ..^ ( # ` W ) )
                        ( W ` i ) = ( W ` 0 ) ) -> ( ( L e. ( 0 ..^ ( # ` W ) )
                                  /\ K e. ( 0 ..^ ( # ` W ) ) )
                                -> ( W CyclShift L ) = ( W CyclShift K ) ) ) $=
      ( cword wcel cv cfv cc0 wceq chash cfzo co wa ccsh cshwsame com12 impcom
      wi wral adantr adantl eqtr4d ex ) EDFGAHEIJEIKAJELIMNZUAOZCUFGZBUFGZOZECP
      NZEBPNZKUGUJOUKEULUJUGUKEKZUHUGUMTUIUGUHUMACDEQRUBSUJUGULEKZUIUGUNTUHUGUI
      UNABDEQRUCSUDUE $.
  $}

  ${
    $d L i j k $.  $d V i j k $.  $d W i j k $.  $d ph i j k $.
    cshwssize.0 $e |- ( ph -> ( W e. Word V /\ ( # ` W ) e. Prime ) ) $.
    $( If cyclically shifting a word of length being a prime number by at least
       two positions (and not by as much positions as the length of the word)
       results in the word itself, the word is build of identical symbols, with
       the possible exception of the first one.  (Contributed by Alexander van
       der Vekens, 18-May-2018.)  (Revised by Alexander van der Vekens,
       8-Jun-2018.) $)
    cshwssizelem1a $p |- ( ( ph /\ L e. ( 2 ..^ ( # ` W ) ) )
             -> ( ( W CyclShift L ) = W
                  -> A. i e. ( 1 ..^ ( # ` W ) ) ( W ` i ) = ( W ` 0 ) ) ) $=
      ( vj vk cfv cc0 wceq c1 co c2 wcel wa wi wfal cn0 wne cfzo wral ccsh ax-1
      cv chash a1d wn wrex rexnal caddc cmo cword cprime simpl cuz wss 2eluzge0
      cmul fzoss1 ax-mp sseli anim12i sylan ad2antlr cshweqrep sylc df-ne eqcom
      1eluzge0 biimpi adantl eqnetrd ralimdv impcom simprd adantr simpr modprm0
      ex 2eluzge1 syl3anc elfzonn0 weq oveq1 oveq2d oveq1d fveq2d neeq1d biimpd
      rspcimdv fveq2 neirr pm2.21 mp1i syl9 rexlimdva mpd syl5com syl5bir com23
      sylbid mpcom falim syl6 com13 sylbir pm2.61i ) BUEZEIZJEIZKZBLEUFIZUAMZUB
      ZACNXMUAMZOZPZECUCMEKZXOQZQZXOXTXRXOXSUDUGXOUHXLUHZBXNUIZYAXLBXNUJXSXRYCX
      OXSXRYCXOQXSXRPZYCRXOYDYBRBXNXJXIGUEZCUSMZUKMZXMULMZEIZKZGSUBZYDXIXNOZPZY
      BRQYMEDUMOZCJXMUAMZOZPZXSXIYOOZPYKXRYQXSYLAYNXMUNOZPZXQYQFYTYNXQYPYNYSUOX
      PYOCNJUPIZOXPYOUQURNJXMUTVAVBVCVDVEYDXSYLYRXSXRUOXNYOXILUUAOXNYOUQVJLJXMU
      TVAVBVCGXICDEVFVGYKYBYMRYBXJXKTZYKYMRQZXJXKVHYKUUBUUCYKUUBPYIXKTZGSUBZYMR
      UUBYKUUEUUBYJUUDGSUUBYJUUDUUBYJPYIXJXKYJYIXJKZUUBYJUUFXJYIVIVKVLUUBYJUOVM
      VTVNVOYMXIHUEZCUSMZUKMZXMULMZJKZHYOUIZUUERQZYMYSCXNOZYLUULXRYSXSYLAYSXQAY
      NYSFVPVQVEXRUUNXSYLXQUUNAXPXNCNLUPIOXPXNUQWANLXMUTVAVBVLVEYDYLVRXMHXICVSW
      BYMUUKUUMHYOYMUUGYOOZPZUUEUUJEIZXKTZUUKRUUPUUDUURGUUGSUUOUUGSOYMUUGXMWCVL
      GHWDZUUDUURQUUPUUSUUDUURUUSYIUUQXKUUSYHUUJEUUSYGUUIXMULUUSYFUUHXIUKYEUUGC
      USWEWFWGWHWIWJVLWKUUKUURXKXKTZRUUKUUQXKXKUUJJEWLWIUUTUHUUTRQUUKXKWMUUTRWN
      WOXBWPWQWRWSVTWTXAXCWQXOXDXEVTXFXGXH $.

    $( If cyclically shifting a word of length being a prime number by at least
       two positions (and not by as many positions as the length of the word)
       results in the word itself, the word is build of identical symbols.
       (Contributed by Alexander van der Vekens, 18-May-2018.)  (Revised by
       Alexander van der Vekens, 8-Jun-2018.) $)
    cshwssizelem1 $p |- ( ( ph /\ L e. ( 2 ..^ ( # ` W ) ) )
             -> ( ( W CyclShift L ) = W
                  -> A. i e. ( 0 ..^ ( # ` W ) ) ( W ` i ) = ( W ` 0 ) ) ) $=
      ( c2 chash cfv cfzo co wcel wa ccsh wceq cv cc0 wral csn syl eqidd eqeq1d
      c1 fveq2 ralsn sylibr cshwssizelem1a imp cun cn cword cprime prmnn adantl
      c0ex ad2antrr fzo0sn0fzo1 raleqdv ralunb syl6bb mpbir2and ex ) ACGEHIZJKL
      ZMZECNKEOZBPZEIZQEIZOZBQVCJKZRZVEVFMZVLVJBQSZRZVJBUCVCJKZRZVMVIVIOZVOVMVI
      UAVJVRBQUOVGQOVHVIVIVGQEUDUBUEUFVEVFVQABCDEFUGUHVMVLVJBVNVPUIZRVOVQMVMVJB
      VKVSVMVCUJLZVKVSOAVTVDVFAEDUKLZVCULLZMVTFWBVTWAVCUMUNTUPVCUQTURVJBVNVPUSU
      TVAVB $.

    $( If cyclically shifting a word of length being a prime number results in
       the word itself, the shift must be either by 0 or by as much positions
       as the length of the word or the word must be build of identical
       symbols.  (Contributed by Alexander van der Vekens, 18-May-2018.)
       (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwssizelem2 $p |- ( ( ph /\ L e. ( 0 ... ( # ` W ) )
                            /\ ( W CyclShift L ) = W )
                  -> ( L = 0 \/ L = ( # ` W ) \/
                       A. i e. ( 0 ..^ ( # ` W ) ) ( W ` i ) = ( W ` 0 ) ) ) $=
      ( cc0 cfv co wcel wceq w3a wa adantr wn c1 wi ex wne adantl chash ccsh wo
      cfz cv cfzo wral w3o id orcd eleq1 oveq2 eqeq1d 3anbi23d cword cprime syl
      cshw1 a1d 3imp syl6bi adantld c2 simprr1 cuz cz clt wbr ioran cn0 elfznn0
      cn df-ne biimpri anim2i elnnne0 sylibr eluz2b3 3ad2ant2 com12 com23 sylbi
      jca imp impcom elfzel2 necom bitri cr cle elfz2nn0 nn0re 3anim123i leltne
      mpbird elfzo2 syl3anbrc simprr3 cshwssizelem1 sylc pm2.61i olcd pm2.61ian
      wb df-3or ) ACGEUAHZUDIZJZECUBIZEKZLZCGKZCXFKZUCZBUEEHGEHKBGXFUFIUGZUCZXL
      XMXOUHXNXKXPXNXKMXNXOXNXNXKXNUINUJXNOZXKMZXOXNCPKZXRXOQXSXKXOXQXSXKAPXGJZ
      EPUBIZEKZLXOXSXHXTXJYBACPXGUKXSXIYAECPEUBULUMUNAXTYBXOAYBXOQZXTAEDUOJZXFU
      PJZMYCFYDYCYEYDYBXOBDEURRNUQUSUTVAVBXSOZXRXOYFXRMZACVCXFUFIJZMXJXOYGAYHAX
      HXJXQYFVDYGCVCVEHJZXFVFJZCXFVGVHZYHXRYFYIXQXKYFYIQZXQXLOZXMOZMZXKYLQZXLXM
      VIZYMYPYNYMYFXKYIYMYFXKYIQXKYMYFMZYIXHAYRYIQZXJXHCVJJZYSCXFVKYTYRYIYTYRMZ
      CVLJZCPSZMYIUUAUUBUUCUUAYTCGSZMUUBYRUUDYTYMUUDYFUUDYMCGVMVNNVOCVPVQYRUUCY
      TYFUUCYMUUCYFCPVMVNTTWCCVRVQRUQVSVTRWANWBWDWEXRYJYFXKYJXQXHAYJXJCGXFWFVST
      TXRYKYFXQXKYKXQYOXKYKQZYQYNUUEYMXKYNYKXHAYNYKQXJXHYNYKXHYNMZYKXFCSZYNUUGX
      HUUGYNUUGCXFSYNXFCWGCXFVMWHVNTUUFCWIJZXFWIJZCXFWJVHZLZYKUUGXDXHUUKYNXHYTX
      FVJJZUUJLUUKCXFWKYTUUHUULUUIUUJUUJCWLXFWLUUJUIWMWBNCXFWNUQWORVSVTTWBWDTCV
      CXFWPWQWCAXHXJXQYFWRABCDEFWSWTRXAXBXCXLXMXOXEVQ $.

    $( If cyclically shifting a word of length being a prime number not
       consisting of identical symbols by at least one position (and not by as
       many positions as the length of the word), the result will not be the
       word itself.  (Contributed by Alexander van der Vekens, 19-May-2018.)
       (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwssizelem3 $p |- ( ( ph /\ E. i e. ( 0 ..^ ( # ` W ) )
                          ( W ` i ) =/= ( W ` 0 ) /\ L e. ( 1 ..^ ( # ` W ) ) )
                           -> ( W CyclShift L ) =/= W ) $=
      ( cfv cc0 wne cfzo co wcel wi wceq wn df-ne wa ad2antlr sylbi com12 chash
      cv wrex c1 w3a ccsh wral rexbii rexnal bitri w3o cfz simpll fzo0ss1 sstri
      fzossfz sseli simpr cshwssizelem2 syl3anc clt wbr elfzo1 nnne0 pm2.21 syl
      cn 3ad2ant1 nnre ltne sylan eqcom syl5bi 3adant2 ax-1 3jaoi mpcom pm2.24d
      cr exp31 com34 com23 3imp pm2.61ine ) ABUBEGZHEGZIZBHEUAGZJKZUCZCUDWHJKZL
      ZUEZECUFKZEIZMWNEWMWNENZWOAWJWLWPWOMZWJWEWFNZBWIUGZOZAWLWQMWJWROZBWIUCWTW
      GXABWIWEWFPUHWRBWIUIUJAWLWTWQAWLWPWTWOAWLWPWTWOMAWLQZWPQZWSWOCHNZCWHNZWSU
      KZXCWSXCACHWHULKZLZWPXFAWLWPUMWLXHAWPWKXGCWKWIXGWHUNHWHUPUOUQRXBWPURABCDE
      FUSUTXDXCWSMXEWSXCXDWSWLXDWSMZAWPWLCVGLZWHVGLZCWHVAVBZUEZXIWHCVCZXJXKXIXL
      XJCHIZXICVDXOXDOXICHPXDWSVESVFVHSRTXCXEWSWLXEWSMZAWPWLXMXPXNXJXLXPXKXJXLQ
      WHCIZXPXJCVSLXLXQCVICWHVJVKXQWHCNZOZXPWHCPXEXRXSWSCWHVLXRWSVEVMSVFVNSRTWS
      XCVOVPVQVRVTWAWBVMWCTWOWMVOWD $.

    $d K i $.
    $( If cyclically shifting a word of length being a prime number and not of
       identical symbols by different numbers of positions, the resulting words
       are different.  (Contributed by Alexander van der Vekens, 19-May-2018.)
       (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwssizelem4a $p |- ( ( ph /\ E. i e. ( 0 ..^ ( # ` W ) )
         ( W ` i ) =/= ( W ` 0 ) ) -> ( ( L e. ( 0 ..^ ( # ` W ) )
                                       /\ K e. ( 0 ..^ ( # ` W ) ) /\ K < L )
                              -> ( W CyclShift L ) =/= ( W CyclShift K ) ) ) $=
      ( cc0 co wa wcel clt wbr ccsh wi adantl cr cz 3adant3 sylbi cfv wne chash
      cv cfzo wrex w3a wceq caddc oveq1 eqcomd ad2antrr cword cfz cprime simpld
      cle adantr elfzofz 3ad2ant2 fznn0sub2 syl 3ad2ant1 cn0 cn elfzo0 elfzoelz
      cmin zre nnre nn0re resubcl syl2anr readdcld jca ex com12 imp fzonmapblen
      ltle 2cshw1 syl13anc 2cshwid syl2an 3eqtr3d c1 simplrl simplrr 3simpa nnz
      sylc zsubcl anim2i ancoms zaddcl elnn0z simplr wb biimp3a addgegt0d elnnz
      posdif sylanbrc simp2bi elfzo1 syl3anbrc cshwssizelem3 syl3anc pm2.21ddne
      nn0z ax-1 a1d pm2.61ine ) ABUDFUAHFUAUBBHFUCUAZUEIZUFZJZDXOKZCXOKZCDLMZUG
      ZFDNIZFCNIZUBZOZOYBYCYBYCUHZXQYEYFXQJZYAYDYGYAJZYDFCXNDVHIZUIIZNIZFYHYCYI
      NIZYBYINIZYKFYFYLYMUHXQYAYFYMYLYBYCYINUJUKULYHFEUMKZCHXNUNIZKZYIYOKZYJXNU
      QMZYLYKUHZYGYNYAXQYNYFAYNXPAYNXNUOKGUPURPZURYAYPYGXSXRYPXTCHXNUSUTPYAYQYG
      XRXSYQXTXRDYOKZYQDHXNUSZDXNVAVBVCPYAYRYGYAYJQKZXNQKZJZYJXNLMZYRXRXSUUEXTX
      RXSUUEXRDVDKZXNVEKZDXNLMZUGZXSUUEOZDXNVFZUUGUUHUUKUUIXSUUGUUHJZUUEXSCRKZU
      UMUUEOCHXNVGZUUNUUMUUEUUNUUMJZUUCUUDUUPCYIUUNCQKZUUMCVIZURUUMYIQKZUUNUUHU
      UDDQKZUUSUUGXNVJZDVKZXNDVLVMZPVNUUMUUDUUNUUHUUDUUGUVAPPVOVPVBVQSTVRSDCXNV
      SZYJXNVTWKPYNYPYQYRUGYSCYIEFWAVRWBYGYNUUAYMFUHYAYTXRXSUUAXTUUBVCDEFWCWDWE
      YHAXPYJWFXNUEIKZYKFUBYFAXPYAWGYFAXPYAWHYAUVEYGYAYJVEKZUUHUUFUVEYAYJRKZHYJ
      LMZUVFXRXSUVGXTXRUUMUUNUVGXSXRUUJUUMUULUUGUUHUUIWITUUOUUMUUNJUUNYIRKZJZUV
      GUUNUUMUVJUUMUVIUUNUUHXNRKDRKUVIUUGXNWJDXJXNDWLVMWMWNCYIWOVBWDSXRXSUVHXTX
      RXSUVHXRUUJXSUVHOUULXSUUJUVHXSCVDKZUUHCXNLMZUGUUJUVHOZCXNVFUVKUUHUVMUVLUV
      KUUNHCUQMZJZUVMCWPUVOUUJUVHUVOUUJJCYIUUNUUQUVNUUJUURULUUJUUSUVOUUGUUHUUSU
      UIUVCSPUUNUVNUUJWQUUJHYILMZUVOUUGUUHUUIUVPUUGUUTUUDUUIUVPWRUUHUVBUVADXNXB
      WDWSPWTVPTVCTVQTVRSYJXAXCXRXSUUHXTXRUUGUUHUUIUULXDVCUVDXNYJXEXFPABYJEFGXG
      XHXIVPVPYDYEXQYDYAXKXLXM $.

    $( If cyclically shifting a word of length being a prime number and not of
       identical symbols by different numbers of positions, the resulting words
       are different.  (Contributed by Alexander van der Vekens, 19-May-2018.)
       (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwssizelem4 $p |- ( ( ph /\ E. i e. ( 0 ..^ ( # ` W ) )
         ( W ` i ) =/= ( W ` 0 ) ) -> ( ( L e. ( 0 ..^ ( # ` W ) )
                                       /\ K e. ( 0 ..^ ( # ` W ) ) /\ K =/= L )
                              -> ( W CyclShift L ) =/= ( W CyclShift K ) ) ) $=
      ( cc0 cfv co wcel wne w3a wa ccsh wi clt wbr cr elfzoelz chash cfzo cv wo
      wrex wb zred lttri2 syl2anr cshwssizelem4a com12 3expia imp necomd expcom
      ancoms jaod sylbid 3impia ) DHFUAIZUBJZKZCVAKZCDLZMABUCFIHFILBVAUENZFDOJZ
      FCOJZLZVBVCVDVEVHPZVBVCNZVDCDQRZDCQRZUDZVIVCCSKDSKVDVMUFVBVCCCHUTTUGVBDDH
      UTTUGCDUHUIVJVKVIVLVBVCVKVIVEVBVCVKMVHABCDEFGUJUKULVCVBVLVIPVCVBVLVIVEVCV
      BVLMZVHVEVNNVGVFVEVNVGVFLABDCEFGUJUMUNUOULUPUQURUSUK $.

    $d i n $.  $d j n $.  $d ph n $.  $d W n $.
    $( The singletons resulting by cyclically shifting a given word of length
       being a prime number and not consisting of identical symbols is a
       disjoint collection.  (Contributed by Alexander van der Vekens,
       19-May-2018.)  (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwsdisj $p |- ( ( ph /\ E. i e. ( 0 ..^ ( # ` W ) )
                              ( W ` i ) =/= ( W ` 0 ) )
                   -> Disj_ n e. ( 0 ..^ ( # ` W ) ) { ( W CyclShift n ) } ) $=
      ( vj cv cfv cc0 wne chash cfzo co wrex wa ccsh csn wral wcel weq cin wceq
      c0 wo wdisj wi orc a1d simprl simprrl simprrr biimpi adantr cshwssizelem4
      necom w3a imp syl13anc disjsn2 syl olcd pm2.61ine ralrimivva oveq2 disjor
      ex sneqd sylibr ) ABHEIJEIKBJELIMNZOPZCGUAZECHZQNZRZEGHZQNZRZUBUDUCZUEZGV
      JSCVJSCVJVOUFVKVTCGVJVJVKVMVJTZVPVJTZPZPZVTUGVMVPVLVTWDVLVSUHUIVMVPKZWDVT
      WEWDPZVSVLWFVNVQKZVSWFVKWAWBVPVMKZWGWEVKWCUJWEVKWAWBUKWEVKWAWBULWEWHWDWEW
      HVMVPUPUMUNVKWAWBWHUQWGABVPVMDEFUOURUSVNVQUTVAVBVGVCVDVJVOVRCGVLVNVQVMVPE
      QVEVHVFVI $.

    $d n w $.  $d V n $.  $d W w $.  $d ph w $.
    cshwssize.m $e |- M = { w e. Word V | E. n e. ( 0 ..^ ( # ` W ) )
                                            ( W CyclShift n ) = w } $.
    $( The set of (different!) words resulting by cyclically shifting a given
       word (not necessarily of length being a prime number) is an indexed
       union.  (Contributed by Alexander van der Vekens, 19-May-2018.)
       (Revised by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwsiun $p |- ( ph
                  -> M = U_ n e. ( 0 ..^ ( # ` W ) ) { ( W CyclShift n ) } ) $=
      ( cv ccsh co wceq wrex wcel cab wa eqcom biimpi reximi adantl chash cword
      cc0 cfv cfzo crab csn df-rab cprime simpld adantr cshwcl eleq1 syl5ibrcom
      ciun syl rexlimdva imp jca ex impbid2 wb elsn bicomi rexbidv bitrd abbidv
      a1i syl5eq df-iun 3eqtr4g ) AFCIZJKZBIZLZCUCFUAUDZUEKZMZBEUBZUFZVNVMUGZNZ
      CVQMZBOZDCVQWAUOAVTVNVSNZVRPZBOWDVRBVSUHAWFWCBAWFVNVMLZCVQMZWCAWFWHVRWHWE
      VOWGCVQVOWGVMVNQRSTAWHWFAWHPWEVRAWHWEAWGWECVQAVLVQNZPZWEWGVMVSNZWJFVSNZWK
      AWLWIAWLVPUINGUJUKVLEFULUPVNVMVSUMUNUQURWHVRAWGVOCVQWGVOVNVMQRSTUSUTVAAWG
      WBCVQWGWBVBAWBWGBVMVCVDVHVEVFVGVIHCBVQWAVJVK $.

    $( The class of (different!) words resulting by cyclically shifting a given
       word (not necessarily of length being a prime number) is a set.
       (Contributed by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwsex $p |- ( ph -> M e. _V ) $=
      ( cc0 chash cfv cfzo co cv ccsh csn ciun cvv cshwsiun wcel wral ovex snex
      a1i ralrimivw iunexg sylancr eqeltrd ) ADCIFJKZLMZFCNOMZPZQZRABCDEFGHSAUJ
      RTULRTZCUJUAUMRTIUILUBAUNCUJUNAUKUCUDUECUJULRRUFUGUH $.

    $d i y $.  $d M x $.  $d V w x y $.  $d W x y $.  $d X n x y $.  $d ph y $.
    $( If a word consists of identical symbols, the size of the set of
       (different!) words resulting by cyclically shifting the original word
       (not necessarily of length being a prime number) equals 1.  (Contributed
       by Alexander van der Vekens, 18-May-2018.)  (Revised by Alexander van
       der Vekens, 8-Jun-2018.) $)
    cshwssizesame $p |- ( ph -> ( A. i e. ( 0 ..^ ( # ` W ) )
                                  ( W ` i ) = ( W ` 0 ) -> ( # ` M ) = 1 ) ) $=
      ( vx vy cv cfv cc0 wceq wa wrex wcel adantr syl chash cfzo co wral c1 csn
      wex ccsh cword crab weq wi cprime simpld prmnn adantl lbfzo0 sylibr cshw0
      wreu oveq2 eqeq1d rspcev syl2anc eqeq2 rexbidv anim1i cshwsame imp biimpd
      rexlimdva ralrimiva eqeq1 imbi2d ralbidv reu7 sylanbrc reusn sylib eqeq1i
      cn exbii cvv wb cshwsex hash1snb mpbird ex ) ACLGMNGMOCNGUAMZUBUCZUDZEUAM
      UEOZAWKPZWLEJLUFZOZJUGZWMGDLZUHUCZBLZOZDWJQZBFUIZUJZWNOZJUGZWPWMXABXBUTZX
      EWMXABXBQZWRKLZOZDWJQZBKUKZULZKXBUDZBXBQZXFWMGXBRZWRGOZDWJQZXGAXOWKAXOWIU
      MRZHUNZSZWMNWJRZGNUHUCZGOZXQAYAWKAWIWARZYAAXOXRPYDHXRYDXOWIUOUPTWIUQURSAY
      CWKAXOYCXSFGUSTSXPYCDNWJWQNOWRYBGWQNGUHVAVBVCVDXAXQBGXBWSGOZWTXPDWJWSGWRV
      EVFVCVDWMXOXJGXHOZULZKXBUDZXNXTWMYGKXBWMXHXBRZPZXIYFDWJYJWQWJRZPZXIYFYLWR
      GXHYJYKXPYJXOWKPZYKXPULWMYMYIAXOWKXSVGSCWQFGVHTVIVBVJVKVLXMYHBGXBYEXLYGKX
      BYEXKYFXJWSGXHVMVNVOVCVDXAXJBKXBXKWTXIDWJWSXHWRVEVFVPVQXABJXBVRVSWOXDJEXC
      WNIVTWBURWMEWCRZWLWPWDAYNWKABDEFGHIWESEWCJWFTWGWH $.

    $( If a word (not consisting of identical symbols) has a length being a
       prime number, the size of the set of (different!) words resulting by
       cyclically shifting the original word equals the length of the original
       word.  (Contributed by Alexander van der Vekens, 19-May-2018.)  (Revised
       by Alexander van der Vekens, 8-Jun-2018.) $)
    cshwssizensame $p |- ( ph -> ( E. i e. ( 0 ..^ ( # ` W ) )
                        ( W ` i ) =/= ( W ` 0 ) -> ( # ` M ) = ( # ` W ) ) ) $=
      ( cv cfv cc0 chash co wceq wa wcel a1i c1 cmul wne cfzo wrex ccsh csn csu
      ciun cshwsiun adantr fveq2d cfn fzofi snfi cshwsdisj hashiun ovex hashsng
      cvv mp1i sumeq2sdv ax-1cn fsumconst sylancr cword cprime cn0 prmnn nnnn0d
      cc adantl hashfzo0 3syl oveq1d cr nnred ax-1rid 3eqtrd eqtrd ex ) ACJGKLG
      KUACLGMKZUBNZUCZEMKZVTOAWBPZWCDWAGDJZUDNZUEZUGZMKWAWGMKZDUFZVTWDEWHMAEWHO
      WBABDEFGHIUHUIUJWDDWAWGWAUKQZWDLVTULZRWGUKQWDWEWAQPWFUMRACDFGHUNUOWDWJWAS
      DUFZVTWDWAWISDWFURQWISOWDGWEUDUPWFURUQUSUTAWMVTOWBAWMWAMKZSTNZVTSTNZVTAWK
      SVIQZWMWOOWLWQAVARWASDVBVCAWNVTSTAGFVDQZVTVEQZPZVTVFQZWNVTOHWSXAWRWSVTVTV
      GZVHVJVTVKVLVMAWTVTVNQZWPVTOHWSXCWRWSVTXBVOVJVTVPVLVQUIVRVQVS $.

    $( If a word has a length being a prime number, the size of the set of
       (different!) words resulting by cyclically shifting the original word
       equals the length of the original word or 1.  (Contributed by Alexander
       van der Vekens, 19-May-2018.)  (Revised by Alexander van der Vekens,
       8-Jun-2018.) $)
    cshwssize $p |- ( ph -> ( ( # ` M ) = ( # ` W ) \/ ( # ` M ) = 1 ) ) $=
      ( vi cv cfv cc0 wceq chash cfzo co wral syl6com wn wrex cshwssizesame olc
      c1 wo wi wne rexnal df-ne bicomi rexbii bitr3i cshwssizensame orc pm2.61i
      sylbi ) IJFKZLFKZMZILFNKZOPZQZADNKZUSMZVBUCMZUDZUEZAVAVDVEABICDEFGHUAVDVC
      UBRVASZUPUQUFZIUTTZVFVGURSZIUTTVIURIUTUGVJVHIUTVHVJUPUQUHUIUJUKAVIVCVEABI
      CDEFGHULVCVDUMRUOUN $.

    $( The class of (different!) words resulting by cyclically shifting
       something (not necessarily a word) is a set.  (Contributed by Alexander
       van der Vekens, 8-Jun-2018.) $)
    cshwsexa $p |- M e. _V $=
      ( vy cv cc0 cfzo co wcel wceq wa cab cvv eqtri wtru chash cword ccsh wrex
      cfv wex crab df-rab r19.42v bicomi abbii df-rex abid2 ovex eqeltri weq wi
      wal tru pm3.2i a1i eqtr3 ex eqcoms adantl com12 ad2antlr alrimiv spcimedv
      imp mp1i zfrep4 ) DCJZKFUAUEZLMZNZBJZEUBZNZFVMUCMZVQOZPZPCUFZBQZRDWACVOUD
      ZBVRUGZWDHWFVSWEPZBQZWDWEBVRUHWHWBCVOUDZBQWDWGWIBWIWGVSWACVOUIUJUKWIWCBWB
      CVOULUKSSSVPWBCBIVPCQVORCVOUMKVNLUNUOTTPWBBIUPZUQZBURZIUFZVPTTUSUSUTTTWMT
      WLTIVTRVTRNTFVMUCUNVATIJZVTOZPZTWLWPTPWKBWOWKTTWBWOWJWAWOWJUQZVSWQVQVTVQV
      TOWOWJVQWNVTVBVCVDVEVFVGVHVCVIVJVKVLUO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
        Graph theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                        Undirected hypergraphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $( An edge of an undirected hypergraph contains only vertices.
       (Contributed by Alexander van der Vekens, 18-Feb-2018.) $)
    uhgraedgrnv $p |- ( ( V UHGrph E /\ F e. ran E /\ N e. F ) -> N e. V ) $=
      ( cuhg wbr crn wcel cdm cpw c0 csn cdif wf wi uhgraf wfn wa sylbi syl wss
      df-f ssel2 wn eldif elpwi sseld adantr ex adantl 3imp ) DAEFZBAGZHZCBHZCD
      HZULAIZDJZKLZMZANZUNUOUPOZOZADPVAAUQQZUMUTUAZRVCUQUTAUBVEVCVDVEUNVBVEUNRB
      UTHZVBUMUTBUCVFBURHZBUSHUDZRVBBURUSUEVGVBVHVGBDCBDUFUGUHSTUIUJSTUK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                        Undirected simple graphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( An undirected simple graph without loops is an undirected hypergraph.
     (Contributed by Alexander van der Vekens, 9-Feb-2018.) $)
  usisuhgra $p |- ( V USGrph E -> V UHGrph E ) $=
    ( cusg wbr cumg cuhg usisumgra umisuhgra syl ) BACDBAEDBAFDABGABHI $.

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                 Neighbors, complete graphs and universal vertices
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

$( *** neighbors *** $)

  $( The class of neighbors of a vertex in a finite graph is a finite set.
     (Contributed by Alexander van der Vekens, 7-Mar-2018.) $)
  nbfiusgrafi $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                      -> ( <. V , E >. Neighbors N ) e. Fin ) $=
    ( cusg wbr cfn wcel w3a cop cnbgra co simp1 simp3 3adant3 nbusgrafi syl3anc
    usgrafis ) CADEZCFGZBCGZHRTAFGZCAIBJKFGRSTLRSTMRSUATACQNABCOP $.

  $( The neighbors of a vertex in a graph are a subset of all vertices of the
     graph except the vertex itself.  TODO: can replace ~ nbgrassovt .
     (Contributed by by Alexander van der Vekens, 13-Jul-2018.) $)
  nbgrassvwo $p |- ( V USGrph E
                     -> ( <. V , E >. Neighbors N ) C_ ( V \ { N } ) ) $=
    ( cusg wbr cop cnbgra wnel wss csn cdif nbgranself2 nbgrassvt cin wceq wcel
    co c0 wn df-nel biimpi disjsn sylibr reldisj syl5ibcom sylc ) CADEBCAFBGQZH
    ZUGCIZUGCBJZKIZABCLABCMUHUGUJNROZUIUKUHBUGPSZULUHUMBUGTUAUGBUBUCUGUJCUDUEUF
    $.

  $( The neighbors of a vertex in a graph are a subset of all vertices of the
     graph except the vertex itself and a vertex which is not a neighbor.
     (Contributed by Alexander van der Vekens, 13-Jul-2018.) $)
  nbgrassvwo2 $p |- ( ( V USGrph E /\ M e/ ( <. V , E >. Neighbors N ) )
                      -> ( <. V , E >. Neighbors N ) C_ ( V \ { M , N } ) ) $=
    ( cusg wbr cop cnbgra co wnel wa csn cdif cpr wss wi nbgrassvwo cin c0 wceq
    wcel df-nel biimpi disjsn sylibr reldisj syl5ib syl imp prcom difeq2i difpr
    wn eqtri syl6sseqr ) DAEFZBDAGCHIZJZKUQDCLMZBLZMZDBCNZMZUPURUQVAOZUPUQUSOZU
    RVDPACDQURUQUTRSTZVEVDURBUQUAUMZVFURVGBUQUBUCUQBUDUEUQUTUSUFUGUHUIVCDCBNZMV
    AVBVHDBCUJUKDCBULUNUO $.

$( *** complete graphs *** $)

$( *** universal vertices *** $)

  ${
    $d E n v $.  $d N n v $.  $d V n v $.
    $( A vertex in a undirected simple graph is universal iff all the other
       vertices are its neighbors.  (Contributed by Alexander van der Vekens,
       13-Jul-2018.) $)
    uvtxnb $p |- ( ( V USGrph E /\ N e. V ) -> ( N e. ( V UnivVertex E )
                   <-> ( <. V , E >. Neighbors N ) = ( V \ { N } ) ) ) $=
      ( vv vn cusg wbr wcel wa co wceq wi ex adantr cv cpr wb wral biimpi cvv
      cuvtx cop cnbgra csn cdif uvtxnbgra crn crab nbusgra eqeq1d simplr eleq1i
      prcom a1i ralrimivw preq2 eleq1d ralrab sylibr eqcom adantl mpbird usgrav
      weq raleqdv uvtxel syl mpbir2and sylbid impbid ) CAFGZBCHZIZBCAUAJHZCAUBB
      UCJZCBUDUEZKZVKVNVQLVLVKVNVQABCUFMNVMVQBDOZPZAUGZHZDCUHZVPKZVNVKVQWCQVLVK
      VOWBVPDABCUIUJNVMWCVNVMWCIZVNVLEOZBPZVTHZEVPRZVKVLWCUKWDWHWGEWBRZVMWIWCVM
      BWEPZVTHZWGLZECRWIVMWLECWLVMWKWGWJWFVTBWEUMULSUNUOWAWKWGEDCDEVDVSWJVTVRWE
      BUPUQURUSNWDWGEVPWBWCVPWBKZVMWCWMWBVPUTSVAVEVBVMVNVLWHIQZWCVKWNVLVKCTHATH
      IWNACVCEABCTTVFVGNNVHMVIVJ $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                  Walks, Paths and Cycles
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

$( *** Walks and Trails *** $)

  $( The set of vertices of a walk cannot be empty, i.e. a walk always consists
     of at least one vertex.  (Contributed by Alexander van der Vekens,
     19-Jul-2018.) $)
  wlkn0 $p |- ( F ( V Walks E ) P -> P =/= (/) ) $=
    ( cwalk co wbr cdm cword wcel cc0 chash cfv cfz wf wa c0 wne wb syl cn0 fdm
    2mwlk lencl wceq cuz elnn0uz fzn0 neeq1 eqcoms biimpcd sylbir sylbi syl5com
    wi impcom wrel frel reldm0 necon3bid adantl mpbird sylan ) CADBEFGCBHZIJZKC
    LMZNFZDAOZPAQRZABCDUCVEVFUAJZVHVIVDCUDVJVHPVIAHZQRZVHVJVLVHVKVGUEZVJVLVGDAU
    BVJVFKUFMJZVMVLUOZVFUGVNVGQRZVOKVFUHVMVPVLVPVLSVGVKVGVKQUIUJUKULUMUNUPVHVIV
    LSZVJVHAUQZVQVGDAURVRAQVKQAUSUTTVAVBVCT $.

  ${
    $d E e f k p v $.  $d V e f k p v $.  $d W e f k p v $.
    $( The components of a walk are words/functions over a zero based range of
       integers.  (Contributed by Alexander van der Vekens, 23-Jun-2018.) $)
    wlkelwrd $p |- ( W e. ( V Walks E ) -> ( ( 1st ` W ) e. Word dom E
                    /\ ( 2nd ` W ) : ( 0 ... ( # ` ( 1st ` W ) ) ) --> V ) ) $=
      ( vf vp vk ve vv cwalk co wcel cvv cv cc0 cfv wf wceq wral w3a fveq1 cfzo
      cdm cword chash cfz c1 caddc cpr copab c1st c2nd wa df-wlk wlks syl6eqelr
      vex ovex mp2an wb dmeq wrdeq syl eleq2d adantl feq3 adantr eqeq1d ralbidv
      3anbi123d opabbidv eleq1 fveq2 oveq2d feq2d fveq2d raleqbidv feq1 preq12d
      elovmpt2 eqeq2d 3anbi23d elopabi 3simpa 3ad2ant3 sylbi ) CBAIJKBLKZALKZCD
      MZAUBZUCZKZNWHUDOZUEJZBEMZPZFMZWHOZAOZWPWNOZWPUFUGJZWNOZUHZQZFNWLUAJZRZSZ
      DEUIZKZSCUJOZWJKZNXIUDOZUEJZBCUKOZPZULZLLWHGMZUBZUCZKZWMHMZWNPZWQXPOZXBQZ
      FXDRZSZDEUIZIXGCBAHGHGDFEUMXTLKZXPLKZYFLKHUPGUPYGYHULYFXTXPIJLDFXPXTLLEUN
      XTXPIUQUOURXTBQZXPAQZULZYEXFDEYKXSWKYAWOYDXEYJXSWKUSYIYJXRWJWHYJXQWIQXRWJ
      QXPAUTXQWIVAVBVCVDYIYAWOUSYJXTBWMWNVEVFYKYCXCFXDYKYBWRXBYJYBWRQYIWQXPATVD
      VGVHVIVJVSXHWFXOWGXHXJXNWPXIOZAOZWPXMOZWTXMOZUHZQZFNXKUAJZRZSZXOXFXJXLBWN
      PZYMXBQZFYRRZSYTDECWHXIQZWKXJWOUUAXEUUCWHXIWJVKUUDWMXLBWNUUDWLXKNUEWHXIUD
      VLZVMVNUUDXCUUBFXDYRUUDWLXKNUAUUEVMUUDWRYMXBUUDWQYLAWPWHXITVOVGVPVIWNXMQZ
      UUAXNUUCYSXJXLBWNXMVQUUFUUBYQFYRUUFXBYPYMUUFWSYNXAYOWPWNXMTWTWNXMTVRVTVHW
      AWBXJXNYSWCVBWDWE $.
  $}

  ${
    $d e f k p v $.
    $( The walks (in an undirected simple graph) are (ordered) pairs.
       (Contributed by Alexander van der Vekens, 30-Jun-2018.) $)
    relwlk $p |- Rel ( V Walks E ) $=
      ( vf ve vv vp vk cv cdm cword wcel cc0 chash cfv cfz co wf c1 caddc cvv
      cpr wceq cfzo wral w3a cwalk df-wlk relmpt2opab ) CHZDHZIJKLUIMNZOPEHFHZQ
      GHZUINUJNUMULNUMRSPULNUAUBGLUKUCPUDUEEDCFTTBAUFEDCGFUGUH $.
  $}

  $( A walk (in an undirected simple graph) is an ordered pair.  (Contributed
     by Alexander van der Vekens, 30-Jun-2018.) $)
  wlkop $p |- ( W e. ( V Walks E ) -> W = <. ( 1st ` W ) , ( 2nd ` W ) >. ) $=
    ( cwalk co wrel wcel c1st cfv c2nd cop wceq relwlk 1st2nd mpan ) BADEZFCPGC
    CHICJIKLABMCPNO $.

  $( The number of vertices of a walk (in an undirected graph) is the number of
     its edges plus 1.  (Contributed by Alexander van der Vekens,
     29-Jun-2018.) $)
  wlklenpislenfp1 $p |- ( F ( V Walks E ) P
                          -> ( # ` P ) = ( ( # ` F ) + 1 ) ) $=
    ( cwalk co wbr cdm cword wcel cc0 chash cfv cfz wf wa c1 caddc wceq 2mwlk
    cn0 lencl hashfzdm sylan syl ) CADBEFGCBHZIJZKCLMZNFDAOZPALMUHQRFSZABCDTUGU
    HUAJUIUJUFCUBDAUHUCUDUE $.

  $( The number of edges of a walk (in an undirected graph) is the number of
     its vertices minus 1.  (Contributed by Alexander van der Vekens,
     1-Jul-2018.) $)
  wlklenfislenpm1 $p |- ( F ( V Walks E ) P
                          -> ( # ` F ) = ( ( # ` P ) - 1 ) ) $=
    ( cwalk co wbr cdm cword wcel cc0 chash cfv cfz wf wa c1 cmin wceq cc 2mwlk
    cn0 lencl caddc hashfzdm nn0cn ax-1cn pncan sylancl eqcomd oveq1 syl5ibrcom
    wi eqeq2d adantr mpd sylan syl ) CADBEFGCBHZIJZKCLMZNFDAOZPVAALMZQRFZSZABCD
    UAUTVAUBJZVBVEUSCUCVFVBPVCVAQUDFZSZVEDAVAUEVFVHVEUMVBVFVEVHVAVGQRFZSVFVIVAV
    FVATJQTJVIVASVAUFUGVAQUHUIUJVHVDVIVAVCVGQRUKUNULUOUPUQUR $.

  ${
    $d E k $.  $d F k $.  $d P k $.
    $( Generalisation of ~ iswlk :  Properties of a pair of functions to be a
       walk (in an undirected graph).  (Contributed by Alexander van der
       Vekens, 23-Jun-2018.) $)
    iswlkg $p |- ( ( V e. X /\ E e. Y ) -> ( F ( V Walks E ) P
                 <-> ( F e. Word dom E
                       /\ P : ( 0 ... ( # ` F ) ) --> V
                       /\ A. k e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` k ) )
                             = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) ) ) $=
      ( wcel wa cwalk co cc0 cfv cfz w3a cvv wi iswlk mpcom ex wbr cdm cword wf
      chash cv c1 caddc cpr wceq cfzo wral cn0 wlkbprop biimpd 3adant1 cpm ovex
      mp3an1 anim2d adantr com12 3adant3 impcom biimprd expcom imp3a impbid2
      fpmg ) EFHZCGHZIZDAECJKUAZDCUBUCZHZLDUEMZNKZEAUDZBUFZDMCMVSAMVSUGUHKAMUIU
      JBLVPUKKULZOZVPUMHZEPHCPHIZDPHAPHIZOVMWAACDEUNWCWDVMWAQWBWCWDIVMWAABCDEPP
      PPRUOUPSVLWAVMVOAEVQUQKZHZIZVLWAIVMWAVLWGVOVRVLWGQVTVLVOVRIZWGVJWHWGQVKVJ
      VRWFVOVJVRWFVQPHVJVRWFLVPNURVQEAPFVIUSTUTVAVBVCVDWGVLWAVMVLWGWAVMQVLWGIVM
      WAABCDEVNFGWERVEVFVGSTVH $.
  $}

  ${
    $d E k $.  $d F k $.  $d P k $.
    wlkcomp.1 $e |- F = ( 1st ` W ) $.
    wlkcomp.2 $e |- P = ( 2nd ` W ) $.
    $( A walk expressed by properties of its components.  (Contributed by
       Alexander van der Vekens, 23-Jun-2018.) $)
    wlkcomp $p |- ( ( V e. X /\ E e. Y /\ W e. ( S X. T ) )
                    -> ( W e. ( V Walks E ) <-> ( F e. Word dom E
              /\ P : ( 0 ... ( # ` F ) ) --> V /\ A. k e. ( 0 ..^ ( # ` F ) )
                 ( E ` ( F ` k ) ) = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) ) ) $=
      ( wcel w3a co cc0 cfv wceq wb eqcomi cxp cwalk wbr cdm cword chash cfz wf
      cv c1 caddc cpr cfzo wral cop c1st c2nd pm3.2i eqop mpbiri eleq1d syl6bbr
      wa df-br 3ad2ant3 iswlkg 3adant3 bitrd ) GIMZEJMZHBCUAMZNHGEUBOZMZFAVLUCZ
      FEUDUEMPFUFQZUGOGAUHDUIZFQEQVPAQVPUJUKOAQULRDPVOUMOUNNZVKVIVMVNSVJVKVMFAU
      OZVLMVNVKHVRVLVKHVRRHUPQZFRZHUQQZARZVCVTWBFVSKTAWALTURHFABCUSUTVAFAVLVDVB
      VEVIVJVNVQSVKADEFGIJVFVGVH $.

    $d E e f p v $.  $d V e f k p v $.  $d W e f k p v $.
    $( Implications for the properties of the components of a walk.
       (Contributed by Alexander van der Vekens, 23-Jun-2018.) $)
    wlkcompim $p |- ( W e. ( V Walks E ) -> ( F e. Word dom E
                /\ P : ( 0 ... ( # ` F ) ) --> V /\ A. k e. ( 0 ..^ ( # ` F ) )
                   ( E ` ( F ` k ) ) = { ( P ` k ) , ( P ` ( k + 1 ) ) } ) ) $=
      ( vf vp ve vv cwalk co wcel cfv cv wceq w3a cvv cdm cword cc0 chash wf c1
      cfz caddc cpr cfzo wral copab wi df-wlk wa wlks ovex syl6eqelr mp2an dmeq
      vex wb wrdeq syl eleq2d adantl feq3 adantr fveq1 eqeq1d ralbidv 3anbi123d
      opabbidv elovmpt2 cxp elopaelxp wlkcomp biimpd syl3an3 sylbi pm2.43i ) FE
      CMNOZDCUAZUBZOUCDUDPZUGNEAUEBQZDPCPWFAPWFUFUHNZAPUIRBUCWEUJNUKSZWBETOZCTO
      ZFIQZWDOZUCWKUDPZUGNZEJQZUEZWFWKPZCPZWFWOPWGWOPUIZRZBUCWMUJNZUKZSZIJULZOZ
      SWBWHUMZTTWKKQZUAZUBZOZWNLQZWOUEZWQXGPZWSRZBXAUKZSZIJULZMXDFECLKLKIBJUNXK
      TOZXGTOZXQTOLVAKVAXRXSUOXQXKXGMNTIBXGXKTTJUPXKXGMUQURUSXKERZXGCRZUOZXPXCI
      JYBXJWLXLWPXOXBYAXJWLVBXTYAXIWDWKYAXHWCRXIWDRXGCUTXHWCVCVDVEVFXTXLWPVBYAX
      KEWNWOVGVHYBXNWTBXAYBXMWRWSYAXMWRRXTWQXGCVIVFVJVKVLVMVNXEWIWJFTTVOOZXFXCI
      JFVPWIWJYCSWBWHATTBCDEFTTGHVQVRVSVTWA $.
  $}

  ${
    $d A x $.  $d B x $.  $d N x $.  $d A y $.  $d B y $.  $d N y $.
    $( Conditions for which two walks (within the same graph) are the same.
       (Contributed by Alexander van der Vekens, 1-Jul-2018.) $)
    2wlkeq $p |- ( ( A e. ( V Walks E ) /\ B e. ( V Walks E )
          /\ N = ( # ` ( 1st ` A ) ) ) -> ( A = B <-> ( N = ( # ` ( 1st ` B ) )
      /\ A. x e. ( 0 ..^ N ) ( ( 1st ` A ) ` x ) = ( ( 1st ` B ) ` x )
      /\ A. y e. ( 0 ... N ) ( ( 2nd ` A ) ` y ) = ( ( 2nd ` B ) ` y ) ) ) ) $=
      ( co wcel cfv chash wceq wa cc0 wral cfz wb cvv adantr anbi12d cwalk c1st
      w3a c2nd cv cxp cop wlkop 1st2ndb sylibr xpopth bicomd syl2an 3adant3 cdm
      cfzo cword wf c1 cmin wlkelwrd anim12i eleq1 df-br wlklenfislenpm1 sylbir
      wbr syl6bi mpcom 2wrdeq ad2ant2r cn0 lencl simplr simprr 3jca syl syl2anc
      2ffzeq eqeq1 oveq2 bibi2d 3ad2ant3 mpbird 3anass anandi bitr2i a1i 3bitrd
      raleqdv ) CGEUAHZIZDWKIZFCUBJZKJZLZUCZCDLZWNDUBJZLZCUDJZDUDJZLZMZFWSKJZLZ
      AUEZWNJXGWSJLZANFUPHZOZMZXFBUEZXAJXLXBJLZBNFPHZOZMZMZXFXJXOUCZWLWMWRXDQZW
      PWLCRRUFZIZDXTIZXSWMWLCWNXAUGZLZYAEGCUHZCUIUJWMDWSXBUGZLZYBEGDUHZDUIUJYAY
      BMXDWRCDRRRRUKULUMUNWQXDXQQZXDWOXELZXHANWOUPHZOZMZYJXMBNWOPHZOZMZMZQZWLWM
      YRWPWLWMMWNEUOZUQZIZYNGXAURZMZWSYTIZNXEPHGXBURZMZMZWOXAKJUSUTHLZXEXBKJUSU
      THLZMZYRWLUUCWMUUFEGCVAEGDVAVBWLUUHWMUUIYDWLUUHYEYDWLYCWKIZUUHCYCWKVCUUKW
      NXAWKVGUUHWNXAWKVDXAEWNGVEVFVHVIYGWMUUIYHYGWMYFWKIZUUIDYFWKVCUULWSXBWKVGU
      UIWSXBWKVDXBEWSGVEVFVHVIVBUUGUUJMZWTYMXCYPUUGWTYMQZUUJUUAUUDUUNUUBUUEWSAY
      SWNVJVKSUUMWOVLIZUUBUUEUCZXCYPQUUGUUPUUJUUGUUOUUBUUEUUCUUOUUFUUAUUOUUBYSW
      NVMSSUUAUUBUUFVNUUCUUDUUEVOVPSXBBXAWOXEGGVSVQTVRUNWPWLYIYRQWMWPXQYQXDWPXK
      YMXPYPWPXFYJXJYLFWOXEVTZWPXHAXIYKFWONUPWAWJTWPXFYJXOYOUUQWPXMBXNYNFWONPWA
      WJTTWBWCWDXQXRQWQXRXFXJXOMMXQXFXJXOWEXFXJXOWFWGWHWI $.

    $d E x y $.  $d V x y $.
    $( Conditions for which two walks within the same undirected simple graph
       are the same.  It is sufficient that the vertices (in the same order)
       are identical.  (Contributed by Alexander van der Vekens,
       3-Jul-2018.) $)
    usg2wlkeq $p |- ( ( V USGrph E /\ ( A e. ( V Walks E )
               /\ B e. ( V Walks E ) ) /\ N = ( # ` ( 1st ` A ) ) )
                   -> ( A = B <-> ( N = ( # ` ( 1st ` B ) )
      /\ A. y e. ( 0 ... N ) ( ( 2nd ` A ) ` y ) = ( ( 2nd ` B ) ` y ) ) ) ) $=
      ( vx co wcel wa cfv wceq w3a cc0 cfzo wral wi imp com12 adantr cusg cwalk
      wbr c1st chash cv c2nd cfz wb 3anan32 a1i 2wlkeq 3expa 3adant1 c1 fzofzp1
      caddc cpr adantl fveq2 eqeq12d rspcdv impancom ralrimiv weq oveq1 cbvralv
      fveq2d sylibr wss fzossfz ssralv r19.26 preq12 ralimdv syl5bir exp3a syld
      syl mpd ex cdm cword eqid wlkcompim oveq2 eqcoms raleqdv bi2anan9r biimpd
      eqeq2 syl6bi com13 ral2imi sylbir 3ad2ant3 syl2an 3imp1 eqcom crn usgraf1
      wf wf1 3ad2ant1 wlkelwrd eleq2d wrdsymb expcom jcad jca f1veqaeq ralimdva
      syl5bi 3syld expimpd pm4.71d 3bitr4d ) FDUAUCZBFDUBHZIZCXSIZJZEBUDKZUEKZL
      ZMZECUDKZUEKZLZAUFZYCKZYJYGKZLZANEOHZPZYJBUGKZKZYJCUGKZKZLZANEUHHZPZMZYIU
      UBJZYOJZBCLZUUDUUCUUEUIYFYIYOUUBUJUKYBYEUUFUUCUIZXRXTYAYEUUGAABCDEFULUMUN
      YFUUDYOYFYIUUBYOYFYIJZUUBYQYJUOUQHZYPKZURZYSUUIYRKZURZLZAYNPZYLDKZYKDKZLZ
      AYNPZYOUUHUUBUUOUUHUUBJZUUJUULLZAYNPZUUOUUTGUFZUOUQHZYPKZUVDYRKZLZGYNPUVB
      UUTUVGGYNUUHUVCYNIZUUBUVGUUHUVHJZYTUVGAUVDUUAUVHUVDUUAIUUHNEUVCUPUSYJUVDL
      ZYTUVGUIUVIUVJYQUVEYSUVFYJUVDYPUTYJUVDYRUTVAUSVBVCVDUVAUVGAGYNAGVEZUUJUVE
      UULUVFUVKUUIUVDYPYJUVCUOUQVFZVHUVKUUIUVDYRUVLVHVAVGVIUUHUUBUVBUUOQZUUHUUB
      YTAYNPZUVMUUHYNUUAVJZUUBUVNQUVOUUHNEVKUKYTAYNUUAVLVSUUHUVNUVBUUOUVNUVBJYT
      UVAJZAYNPUUHUUOYTUVAAYNVMUUHUVPUUNAYNUVPUUNQUUHYQUUJYSUULVNUKVOVPVQVRRVTW
      AXRYBYEYIUUOUUSQZYBYEYIUVQQQQXRYBYEYIUVQXTYCDWBZWCZIZNYDUHHFYPXBZUUQUUKLZ
      ANYDOHZPZMZYGUVSIZNYHUHHFYRXBZUUPUUMLZANYHOHZPZMZYEYIJZUVQQZYAYPADYCFBYCW
      DYPWDWEYRADYGFCYGWDYRWDWEUWEUWKUWMUWDUVTUWKUWMQUWAUWKUWDUWMUWJUWFUWDUWMQU
      WGUWJUWDUWMUWLUWJUWDJZUVQUWLUWNUWHAYNPZUWBAYNPZJZUVQYIUWJUWOYEUWDUWPYIUWH
      AUWIYNUWIYNLYHEYHENOWFWGWHYEUWBAUWCYNUWCYNLYDEYDENOWFWGWHWIUWQUWHUWBJZAYN
      PUVQUWHUWBAYNVMUWRUUNUURAYNUWHUWBUUNUURQUUNUWBUWHUURUUNUWBUUQUUMLZUWHUURQ
      UUKUUMUUQWKUWSUWHUURUWHUURUIUUMUUQUUMUUQUUPWKWGWJWLWMRWNWOWLSWAWPSWPRWQVQ
      UKWRUUHUURYMAYNUURUUQUUPLZUUHYJYNIZJZYMUUPUUQWSUXBUVRDWTZDXCZYKUVRIZYLUVR
      IZJZJUWTYMQUXBUXDUXGUUHUXDUXAYFUXDYIXRYBUXDYEDFXAXDTTUUHUXAUXGYFYIUXAUXGQ
      ZYBYEYIUXHQZXRYBYEUXIYBYEYIUXHYBUWLUXAUXGXTUVTUWAJZUWFUWGJZUWLUXAJZUXGQZY
      ADFBXEDFCXEUXJUXKUXMUVTUXKUXMQUWAUXKUVTUXMUWFUVTUXMQUWGUWFUVTUXMUWFUVTJUX
      LUXEUXFUVTUXLUXEQUWFUXLUVTUXEUWLUXAUVTUXEQZYEUXAUXNQYIYEUXAYJUWCIZUXNYEYN
      UWCYJEYDNOWFXFUVTUXOUXEYCYJUVRXGXHWLTRSUSUWFUXLUXFQUVTUXLUWFUXFUWLUXAUWFU
      XFQZYIUXAUXPQYEYIUXAYJUWIIZUXPYIYNUWIYJEYHNOWFXFUWFUXQUXFYGYJUVRXGXHWLUSR
      STXIWATSTRWQVQVQRUNRRXJUVRUXCYKYLDXKVSXMXLXNXOXPXQ $.
  $}

$( *** Paths and Simple Paths *** $)

  ${
    $d x E $.  $d x F $.  $d x P $.
    $( In a undirected simple graph, any path of length 2 is a simple path.
       (Contributed by Alexander van der Vekens, 25-Jan-2018.) $)
    usgra2pthspth $p |- ( ( V USGrph E /\ ( # ` F ) = 2 )
                         -> ( F ( V Paths E ) P <-> F ( V SPaths E ) P ) ) $=
      ( vx wbr cfv c2 wceq wa co wi wcel cvv w3a c1 cfzo cc0 cpr adantl cn0 cin
      cusg chash cpath cspath ctrail cwalk pthistrl trliswlk wlkbprop 3syl cres
      ccnv wfun cima c0 wb ispth 3adant1 3anass cdm wf1 wf cv caddc wral istrl2
      cfz adantr fzo0to2pr raleqi c0ex fveq2 fveq2d oveq1 0p1e1 preq12d eqeq12d
      1ex syl6eq 1p1e2 ralpr bitri wne crn usgraf1 simpll cn lbfzo0 mpbir prid2
      2nn eleqtrri pm3.2i a1i ax-1ne0 necomi 2f1fvneq impancom imp simpllr fvex
      syl211anc usgranloopv mpan2 com12 impcom 3pm3.2i simpl pr1nebg simpr 3jca
      sylancr ex sylbird syl2anc eqid f13idfv sylanbrc df-f1 simprd a1d mpancom
      sylib exp31 syl5bi 3impia eqidd f1eq123d raleqdv 3anbi123d reseq2d cnveqd
      oveq2 feq2d funeqd imaeq2d mpbird sylbid ineq12d eqeq1d anbi12d imdistand
      preq2 imbi1d imbi12d isspth ad3antrrr exp41 com24 mpcom spthispth impbid1
      com13 ) DBUCFZCUDGZHIZJCADBUEKFZCADBUFKFZUUPUURUUSUUTLUUSUURUUPUUTUUQUAMZ
      DNMBNMJZCNMANMJZOZUUSUURUUPUUTLLZUUSCADBUGKFZCADBUHKFUVDABCDUIABCDUJABCDU
      KULUVDUUSUVFAPUUQQKZUMZUNZUOZARUUQSZUPZAUVGUPZUBZUQIZOZUVEUVBUVCUUSUVPURU
      VAABCDNNNNUSUTUVDUUPUURUVPUUTUVDUUPUURUVPUUTUVDUUPJZUURJZUVPJUUTUVFAUNUOZ
      JZUVRUVPUVTUVPUVFUVJUVOJZJUVRUVTUVFUVJUVOVAUVRUVFUWAUVSUVRUVFRUUQQKZBVBZC
      VCZRUUQVIKZDAVDZEVEZCGZBGZUWGAGZUWGPVFKZAGZSZIZEUWBVGZOZUWAUVSLZUVQUVFUWP
      URZUURUVDUWRUUPUVBUVCUWRUVAAEBCDNNNNVHUTVJVJUVRUWPUWQLZRHQKZUWCCVCZRHVIKZ
      DAVDZUWNEUWTVGZOZAPHQKZUMZUNZUOZARHSZUPZAUXFUPZUBZUQIZJZUVSLZLZUVQUXQUURU
      XEUVQUXPUXAUXCUXDUVQUXPLZUXDRCGZBGZRAGZPAGZSZIZPCGZBGZUYBHAGZSZIZJZUXAUXC
      JZUXRUXDUWNERPSZVGUYJUWNEUWTUYLVKVLUWNUYDUYIERPVMVTUWGRIZUWIUXTUWMUYCUYMU
      WHUXSBUWGRCVNVOUYMUWJUYAUWLUYBUWGRAVNUYMUWKPAUYMUWKRPVFKPUWGRPVFVPVQWAVOV
      RVSUWGPIZUWIUYFUWMUYHUYNUWHUYEBUWGPCVNVOUYNUWJUYBUWLUYGUWGPAVNUYNUWKHAUYN
      UWKPPVFKHUWGPPVFVPWBWAVOVRVSWCWDUYKUYJUVQUXPUYCUYHWEZUYKUYJJZUVQJZUXPUYPU
      VQUYOUYKUVQUYJUYOUYKUVQJZUWCBWFZBVCZUXARUWTMZPUWTMZJZRPWEZUYJUYOLUVQUYTUY
      KUUPUYTUVDBDWGTTUXAUXCUVQWHVUCUYRVUAVUBVUAHWIMWMHWJWKPUYLUWTRPVTWLVKWNWOW
      PVUDUYRPRWQWRWPRPUWTUWCUYSBCUYCUYHWSXDWTXAUYOUYQJZUVSUXOVUEUXCUVSVUEUXBDA
      VCZUXCUVSJVUEUXCUYAUYBWEZUYAUYGWEZUYBUYGWEZOZVUFUYQUXCUYOUXAUXCUYJUVQXBTU
      YQUYOVUJUYPUVQUYOVUJLZUYJUVQVUKLUYKUVQUYJVUKUUPUYJVUKLUVDUUPUYJVUKUUPUYJJ
      VUGVUIVUKUYJUUPVUGUYDUUPVUGLUYIUUPUYDVUGUUPUYANMZUYDVUGLRAXCZBUYAUYBDNUXS
      XEXFXGVJXHUYJUUPVUIUYIUUPVUILUYDUUPUYIVUIUUPUYBNMZUYIVUILPAXCZBUYBUYGDNUY
      EXEXFXGTXHVUGVUIJZUYOVUHVUJVUPVULVUNUYGNMZOVUGVUHUYOURVULVUNVUQVUMVUOHAXC
      XIVUGVUIXJUYAUYBUYGNNNXKXNVUPVUHVUJVUPVUHJVUGVUHVUIVUGVUIVUHWHVUPVUHXLVUP
      VUIVUHVUGVUIXLVJXMXOXPXQXOTXGTXAXHUXBDAUXBXRXSXTUXBDAYAYEYBYCYDYFYGYHXGVJ
      UURUWSUXQURUVQUURUWPUXEUWQUXPUURUWDUXAUWFUXCUWOUXDUURUWBUWTUWCUWCCCUURCYI
      UUQHRQYOZUURUWCYIYJUURUWEUXBDAUUQHRVIYOYPUURUWNEUWBUWTVURYKYLUURUWAUXOUVS
      UURUVJUXIUVOUXNUURUVIUXHUURUVHUXGUURUVGUXFAUUQHPQYOZYMYNYQUURUVNUXMUQUURU
      VLUXKUVMUXLUURUVKUXJAUUQHRUUEYRUURUVGUXFAVUSYRUUAUUBUUCUUFUUGTYSYTUUDYGXA
      UVDUUTUVTURZUUPUURUVPUVBUVCVUTUVAABCDNNNNUUHUTUUIYSUUJUUKYTUULUUOXAABCDUU
      MUUN $.
  $}

  ${
    $d i E $.  $d i F $.  $d i P $.
    $( Lemma 1 for ~ usgra2wlkspth .  (Contributed by Alexander van der Vekens,
       2-Mar-2018.) $)
    usgra2wlkspthlem1 $p |- ( ( F e. Word dom E /\ E : dom E -1-1-> ran E
                                /\ ( # ` F ) = 2 )
       -> ( ( ( ( P ` 0 ) = A /\ ( P ` ( # ` F ) ) = B /\ A =/= B )
              /\ A. i e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` i ) )
   = { ( P ` i ) , ( P ` ( i + 1 ) ) } ) -> Fun `' F ) ) $=
      ( wcel cfv c2 wceq cc0 c1 caddc co cpr wa wi wb fveq2 cvv cdm cword chash
      crn wf1 wne w3a cv cfzo wral ccnv wfun wf wrdf simpl adantr oveq2 syl6req
      fzo0to2pr adantl feq2d mpbird preq1 eqeq2d bi2anan9 3adant3 eqeq1d anbi1d
      preq2 anbi2d eqtr2 wo fvex a1i eleq1 eqcoms jca anim12i preq12bg syl eqtr
      jaoi syl6bi syl5com impcom com12 necon3d a1d exp31 com25 3impia imp com13
      sylbid 3anbi2d syl6eq raleqdv c0ex 1ex fveq2d oveq1 0p1e1 preq12d eqeq12d
      fveq2i 1p1e2 ralpr syl6bb anbi12d imbi1d imbi12d pm3.2i ax-1ne0 eqid mp1i
      necomi f12dfv df-f1 sylib simprd ex expcom 3imp ) FEUAZUBGZYDEUDEUEZFUCHZ
      IJZKCHZAJZYGCHZBJZABUFZUGZDUHZFHZEHZYOCHZYOLMNZCHZOZJZDKYGUINZUJZPZFUKULZ
      QZYEUUCYDFUMZYFYHUUGQQYDFUNYHYFUUHUUGYHYFUUHUUGQUUHYHYFPZUUGUUHUUIPZUUEUU
      FUUJUUEPZKLOZYDFUMZUUFUUKUULYDFUEZUUMUUFPUUKUUNUUMKFHZLFHZUFZPZUUKUUMUUQU
      UKUUMUUHUUJUUHUUEUUHUUIUOUPUUKUULUUCYDFUUJUULUUCJZUUEUUIUUSUUHYHUUSYFYHUU
      CKIUINZUULYGIKUIUQZUSURUPUTUPVAVBUUJUUEUUQUUIUUHUUEUUQQZUUIUUHUVBQZUUTYDF
      UMZYJICHZBJZYMUGZUUOEHZYILCHZOZJZUUPEHZUVIUVEOZJZPZPZUUQQZQZUVPUVDUUIUUQU
      VGUVOUVDUUIUUQQQZUVGUVOUVHAUVIOZJZUVLUVIBOZJZPZUVSYJUVFUVOUWDRYMYJUVKUWAU
      VFUVNUWCYJUVJUVTUVHYIAUVIVCVDUVFUVMUWBUVLUVEBUVIVIVDVEVFYJUVFYMUWDUVSQYJU
      VFPZUUIUWDUVDYMUUQUWEUUIUWDUVDYMUUQQZQUWEUUIPZUWDPZUWFUVDUWHUUOUUPABUUOUU
      PJZUWHABJZUWIUWHUWGUVLUVTJZUWCPZPUWJUWIUWDUWLUWGUWIUWAUWKUWCUWIUVHUVLUVTU
      UOUUPESVGVHVJUWLUWGUWJUWLUVTUWBJZUWGUWJUVLUVTUWBVKUWGUWMAUVIJUVIBJPZUWJUV
      IUVIJZPZVLZUWJUWGATGZUVITGZPZUWSBTGZPZPZUWMUWQRUWEUXCUUIYJUWTUVFUXBYJUWRU
      WSYJUWRYITGZUXDYJKCVMVNUWRUXDRAYIAYITVOVPVBUWSYJLCVMZVNVQUVFUWSUXAUWSUVFU
      XEVNUVFUXAUVETGZUXFUVFICVMVNUXAUXFRBUVEBUVETVOVPVBVQVRUPAUVIUVIBTTTTVSVTU
      WNUWJUWPAUVIBWAUWJUWOUOWBWCWDWEWCWFWGWHWIWJWKWNWLWMYHUVCUVRRYFYHUUHUVDUVB
      UVQYHUUCUUTYDFUVAVAYHUUEUVPUUQYHYNUVGUUDUVOYHYLUVFYJYMYHYKUVEBYGICSVGWOYH
      UUDUUBDUULUJUVOYHUUBDUUCUULYHUUCUUTUULUVAUSWPWQUUBUVKUVNDKLWRWSYOKJZYQUVH
      UUAUVJUXGYPUUOEYOKFSWTUXGYRYIYTUVIYOKCSUXGYTKLMNZCHUVIUXGYSUXHCYOKLMXAWTU
      XHLCXBXEWPXCXDYOLJZYQUVLUUAUVMUXIYPUUPEYOLFSWTUXIYRUVIYTUVEYOLCSUXIYTLLMN
      ZCHUVEUXIYSUXJCYOLLMXAWTUXJICXFXEWPXCXDXGXHXIXJXKUPVBWEWLVQKTGZLTGZPZKLUF
      ZPUUNUURRUUKUXMUXNUXKUXLWRWSXLLKXMXPXLUULYDTFTKLUULXNXQXOVBUULYDFXRXSXTYA
      YBYAWMVTYC $.

    $( Lemma 2 for ~ usgra2wlkspth .  (Contributed by Alexander van der Vekens,
       2-Mar-2018.) $)
    usgra2wlkspthlem2 $p |- ( ( ( F e. Word dom E /\ ( # ` F ) = 2 )
        /\ ( V USGrph E /\ P : ( 0 ... ( # ` F ) ) --> V ) )
       -> ( ( ( ( P ` 0 ) = A /\ ( P ` ( # ` F ) ) = B /\ A =/= B )
              /\ A. i e. ( 0 ..^ ( # ` F ) ) ( E ` ( F ` i ) )
   = { ( P ` i ) , ( P ` ( i + 1 ) ) } ) -> Fun `' P ) ) $=
      ( cc0 cfv co wf wa wcel c2 wceq wne w3a c1 wi adantr cusg wbr chash cword
      cfz cdm cv caddc cpr cfzo wral ccnv wfun ctp wf1 oveq2 feq2d fz0tp biimpi
      feq2i syl6bi ad2antll impcom eqeq12 biimpd necon3d 3impia adantl usgrafun
      crn simplr wrdf c0ex prid1 fzo0to2pr eleqtrri ffvelrn mpan2 mpan9 syl2anr
      fvelrn wb eleq1 mpbid usgraedgrn syl2anc ex 1ex prid2 anim12d adantld imp
      3anan12 sylanbrc exp41 fveq2 eqeq1d 3anbi2d syl6eq raleqdv 2wlklem syl6bb
      anbi12d imbi1d imbi12d mpbird jca cvv cz 3pm3.2i ax-1ne0 necomi 2ne0 1ne2
      2z pm3.2i eqid f13dfv mp1i df-f1 sylib simprd expcom com23 impancom ) GEU
      AUBZHFUCIZUEJZGCKZLFEUFZUDMZYGNOZLZHCIZAOZYGCIZBOZABPZQZDUGZFIEIYTCIYTRUH
      JCIUIOZDHYGUJJZUKZLZCULUMZSZYFYMYIUUFYFYMLZUUDYIUUEUUGUUDYIUUESYIUUGUUDLZ
      UUEYIUUHLZHRNUNZGCKZUUEUUIUUJGCUOZUUKUUELUUIUULUUKYNRCIZPZYNNCIZPZUUMUUOP
      ZQZLZUUIUUKUURUUHYIUUKUUGYIUUKSZUUDYLUUTYFYKYLYIHNUEJZGCKZUUKYLYHUVAGCYGN
      HUEUPUQZUVBUUKUVAUUJGCURUTUSVAVBTVCUUHYIUURUUGUUDYIUURSZUUGUUDUVDSZYOUUOB
      OZYRQZHFIZEIZYNUUMUIZOZRFIZEIZUUMUUOUIZOZLZLZUVBUURSZSZYMYFUVSYMYFUVQUVBU
      URYMYFLZUVQLZUVBLUUPUUNUUQLZUURUWAUUPUVBUVQUUPUVTUVGUUPUVPYOUVFYRUUPYOUVF
      LZYNUUOABUWCYNUUOOABOYNAUUOBVDVEVFVGTVHTUWAUWBUVBUVTUVQUWBUVTUVPUWBUVGUVT
      UVKUUNUVOUUQUVTUVKUUNUVTUVKLZYFUVJEVJZMZUUNYMYFUVKVKUWDUVIUWEMZUWFUVTUWGU
      VKYFEUMZUVHYJMZUWGYMEGVIZYKUUBYJFKZYLUWIYJFVLZYLUWKHNUJJZYJFKZUWIYLUUBUWM
      YJFYGNHUJUPZUQZUWNHUWMMUWIHHRUIZUWMHRVMVNVOVPUWMYJHFVQVRVAVSUVHEWAVTTUVKU
      WGUWFWBUVTUVIUVJUWEWCVHWDEYNUUMGWEWFWGUVTUVOUUQUVTUVOLZYFUVNUWEMZUUQYMYFU
      VOVKUWRUVMUWEMZUWSUVTUWTUVOYFUWHUVLYJMZUWTYMUWJYKUWKYLUXAUWLYLUWKUWNUXAUW
      PUWNRUWMMUXARUWQUWMHRWHWIVOVPUWMYJRFVQVRVAVSUVLEWAVTTUVOUWTUWSWBUVTUVMUVN
      UWEWCVHWDEUUMUUOGWEWFWGWJWKWLTUUNUUPUUQWMWNWOVCYLUVEUVSWBYFYKYLUUDUVQUVDU
      VRYLYSUVGUUCUVPYLYQUVFYOYRYLYPUUOBYGNCWPWQWRYLUUCUUADUWQUKUVPYLUUADUUBUWQ
      YLUUBUWMUWQUWOVOWSWTCDEFXAXBXCYLYIUVBUURUVCXDXEVBXFWLVCXGHXHMZRXHMZNXIMZQ
      ZHRPZHNPZRNPZQZLUULUUSWBUUIUXEUXIUXBUXCUXDVMWHXOXJUXFUXGUXHRHXKXLNHXMXLXN
      XJXPUUJGXHCXHXIHRNUUJXQXRXSXFUUJGCXTYAYBYCWGYDYEVC $.

    $( In a undirected simple graph, any walk of length 2 between two different
       vertices is a simple path.  (Contributed by Alexander van der Vekens,
       2-Mar-2018.) $)
    usgra2wlkspth $p |- ( ( V USGrph E /\ ( # ` F ) = 2 /\ A =/= B )
         -> ( F ( A ( V WalkOn E ) B ) P <-> F ( A ( V SPathOn E ) B ) P ) ) $=
      ( vi wbr cfv w3a co cvv wcel wa wi 3ad2ant1 adantl ad3antlr jca syl chash
      cusg c2 wceq wne cwlkon cspthon cwalk wlkonprop cspath simplr ctrail ccnv
      cc0 wfun cdm cword cfz wf cv c1 caddc cfzo wral wb iswlk 3adant3 ad4antlr
      cpr crn usgraf1 simp2 3jca simpl simpr simp3 usgra2wlkspthlem1 sylc exp31
      id wf1 sylbid com13 com3r 3imp impcom imp31 ad3antrrr istrl mpbird syl6bi
      ex 2mwlk com12 ad2antrr usgra2wlkspthlem2 isspth mpbir2and isspthon mpcom
      spthonprp impbid1 ) FDUBHZEUAIZUCUDZABUEZJZECABFDUFKKHZECABFDUGKKHZXHXGXI
      FLMDLMNZELMCLMNZAFMBFMNZJZECFDUHKHZUNCIAUDZXDCIBUDZJZNZXHXGXIOABCDEFUIXRX
      HXGXIXRXHNZXGNZXIXHECFDUJKHZXRXHXGUKXTYAECFDULKHZCUMUOZXTYBEDUPZUQMZEUMUO
      ZNZUNXDURKFCUSZGUTZEIDIYICIYIVAVBKCIVIUDGUNXDVCKVDZJZXRXHXGYKXQXMXHXGYKOO
      ZXNXOXPXMYLOZXOXPXNYMXOXPXNYMOXMXNXOXPNZYLXMXNYEYHYJJZYNYLOXJXKXNYOVEXLCG
      DEFLLLLVFVGZXMYOYNYLXMYONZYNNZXHXGYKYRXHNZXGNZYGYHYJYTYEYFYOYEXMYNXHXGYEY
      HYEYJYEVTPVHZYTYEYDDVJDWAZXEJXOXPXFJZYJNZYFYTYEUUBXEUUAXGUUBYSXCXEUUBXFDF
      VKPQXGXEYSXCXEXFVLZQVMYTUUCYJYTXOXPXFYNXOYQXHXGXOXPVNRYNXPYQXHXGXOXPVORXG
      XFYSXCXEXFVPZQVMYOYJXMYNXHXGYEYHYJVPZVHZSABCGDEVQVRSYOYHXMYNXHXGYEYHYJVLV
      HUUHVMVSVSWBWCWLWDWEWFWGXTXJXKNZYBYKVEXMUUIXQXHXGXJXKUUIXLUUIVTVGWHZCGDEF
      LLLLWITWJXTYEXENZXCYHNZNUUDYCXTUUKUULXTYEXEXQYEXMXHXGXNXOYEXPXNYEYHNZYECD
      EFWMZYEYHVNTPRXGXEXSUUEQSXTXCYHXGXCXSXCXEXCXFXCVTPQXQYHXMXHXGXNXOYHXPXNUU
      MYHUUNYEYHVOTPRSSXTUUCYJXTXOXPXFXQXOXMXHXGXNXOXPVLRXQXPXMXHXGXNXOXPVPRXGX
      FXSUUFQVMXRYJXHXGXQXMYJXNXOXMYJOXPXMXNYJXMXNYOYJYPUUGWKWNPWFWOSABCGDEFWPV
      RXTUUIYAYBYCNVEUUJCDEFLLLLWQTWRXMXIXHYANZVEXQXHXGABCDEFLLLLWSWHWRVSWTWNXI
      XMUUONXHABCDEFXAUUOXHXMXHYAVNQTXB $.
  $}

  ${
    $d i E $.  $d i F $.  $d i P $.
    $( The vertices of a simple path are distinct, so the vertex function is
       one-to-one.  (Contributed by Alexander van der Vekens, 26-Jan-2018.) $)
    spthdifv $p |- ( F ( V SPaths E ) P
                     -> P : ( 0 ... ( # ` F ) ) -1-1-> V ) $=
      ( vi cvv wcel wa cspath wbr cc0 chash cfv cfz wf1 cpath ctrail w3a 3syl
      co spthispth pthistrl cwalk cn0 trliswlk wlkbprop 3simpc ccnv wfun isspth
      cfzo cdm wf cv caddc cpr wceq wral istrl2 anbi1d biimpri 3ad2antl2 syl6bi
      c1 df-f1 sylbid mpcom ) DFGBFGHZCFGAFGHZHZCADBITJZKCLMZNTZDAOZVKCADBPTJCA
      DBQTJZVJABCDUAABCDUBVOCADBUCTJVLUDGZVHVIRVJABCDUEABCDUFVPVHVIUGSSVJVKVOAU
      HUIZHZVNABCDFFFFUJVJVRKVLUKTZBULCOZVMDAUMZEUNZCMBMWBAMWBVDUOTAMUPUQEVSURZ
      RZVQHVNVJVOWDVQAEBCDFFFFUSUTWAVTVQVNWCVNWAVQHVMDAVEVAVBVCVFVG $.
  $}

  ${
    $d E x y z $.  $d F x y z $.  $d P x y z $.  $d V x y z $.  $d i E $.
    $d i F $.  $d i P $.
    $( Lemma for ~ usgra2pth .  (Contributed by Alexander van der Vekens,
       27-Jan-2018.) $)
    usgra2pthlem1 $p |- ( ( F : ( 0 ..^ ( # ` F ) ) -1-1-> dom E
                     /\ P : ( 0 ... ( # ` F ) ) --> V
                     /\ A. i e. ( 0 ..^ ( # ` F ) )
                        ( E ` ( F ` i ) ) = { ( P ` i ) , ( P ` ( i + 1 ) ) } )
             -> ( ( V USGrph E /\ ( # ` F ) = 2 )
             -> E. x e. V E. y e. ( V \ { x } ) E. z e. ( V \ { x , y } )
                ( ( ( P ` 0 ) = x /\ ( P ` 1 ) = y /\ ( P ` 2 ) = z )
                   /\ ( ( E ` ( F ` 0 ) ) = { x , y }
                   /\ ( E ` ( F ` 1 ) ) = { y , z } ) ) ) ) $=
      ( cc0 cfv c1 cpr wceq c2 wa wi wcel adantl cvv wb chash co cdm wf1 cfz wf
      cfzo caddc wral cusg wbr w3a cdif wrex csn cn0 cle 0nn0 2nn0 0re 2re 2pos
      cv ltleii elfz2nn0 mpbir3an ffvelrn mpan2 1nn0 1re 1lt2 wne wn simpr fvex
      jctir prcom eqeq2i biimpi adantr usgranloopv sylc elsnc necon3bbii sylibr
      ad2antlr eldifd sneq difeq2d eleq2d mpbird leidi crn usgraf1 ad2antrr jca
      simpl 2nn lbfzo0 mpbir clt elfzo0 pm3.2i a1i ax-1ne0 necomi 3jca 2f1fvneq
      cn necom 3pm3.2i jca31 imp syl pr1nebg sylancr syl5bb nelprd preq12 eqcom
      adantll 3anbi123i 3expa preq12d eqeq2d biimpa exp41 imp31 rspcimedv com15
      anbi12d pm2.43i com12 oveq2 raleqdv fveq2 fveq2d oveq1 syl6eq eqeq12d 1ex
      fzo0to2pr raleqi 0p1e1 1p1e2 ralprg mp2an bitri syl6bb feq2d f1eq2 imbi1d
      c0ex imbi12d 3imtr4d com14 com23 3imp ) IGUAJZUGUBZFUCZGUDZIUUSUEUBZHDUFZ
      EVCZGJZFJZUVEDJZUVEKUHUBZDJZLZMZEUUTUIZHFUJUKZUUSNMZOZIDJZAVCZMZKDJZBVCZM
      ZNDJZCVCZMZULZIGJZFJZUVRUWALZMZKGJZFJZUWAUWDLZMZOZOZCHUWIUMZUNZBHUVRUOZUM
      ZUNZAHUNZPZUVBUVMUVDUXCUVPUVMUVDUVBUXBUVPUWHUVQUVTLZMZUWLUVTUWCLZMZOZINUE
      UBZHDUFZINUGUBZUVAGUDZUXBPZPZUVMUVDUVBUXBPZPUVNUXHUXNPUVOUXHUVNUXNUXHUVNU
      XNPUXLUXHUVNUXJUXHUXBUXLUXHUVNUXJUXHUXBPUXLUXHOZUVNOZUXJOZUXAUXHAUVQHUXJU
      VQHQZUXQUXJIUXIQZUXSUXTIUPQNUPQZINUQUKURUSINUTVAVBVDINVEVFUXIHIDVGVHRUXRU
      VRUVQMZOZUWRUXHBUVTUWTUYCUVTUWTQZUVTHUVQUOZUMZQZUXRUYGUYBUXRUVTHUYEUXJUVT
      HQZUXQUXJKUXIQZUYHUYIKUPQZUYAKNUQUKVIUSKNVJVAVKVDKNVEVFUXIHKDVGVHRUXRUVTU
      VQVLZUVTUYEQZVMUXQUYKUXJUXQUVNUVTSQZOUWHUVTUVQLZMZUYKUXQUVNUYMUXPUVNVNZKD
      VOZVPUXHUYOUXLUVNUXEUYOUXGUXEUYOUXDUYNUWHUVQUVTVQVRVSVTWFFUVTUVQHSUWGWAWB
      VTUYLUVTUVQUVTUVQUYQWCWDWEWGVTUYBUYDUYGTUXRUYBUWTUYFUVTUYBUWSUYEHUVRUVQWH
      WIWJRWKUYCUWAUVTMZOZUWPUXHCUWCUWQUYSUWCUWQQZUWCHUXDUMZQZUXRVUBUYBUYRUXRUW
      CHUXDUXJUWCHQZUXQUXJNUXIQZVUCVUDUYAUYANNUQUKUSUSNVAWLNNVEVFUXIHNDVGVHRUXR
      UWCUVQUVTUXRUWCUVQVLZUXDUXFVLZUXRUVAFWMZFUDZUXLOZIUXKQZKUXKQZOZIKVLZULUXH
      VUFUXRVUIVULVUMUXRVUHUXLUVNVUHUXPUXJFHWNWFUXPUXLUVNUXJUXLUXHWQWOWPVULUXRV
      UJVUKVUJNXIQZWRNWSWTVUKUYJVUNKNXAUKVIWRVKKNXBVFXCXDVUMUXRKIXEXFXDXGUXPUXH
      UVNUXJUXLUXHVNWOIKUXKUVAVUGFGUXDUXFXHWBVUEUVQUWCVLZUXRVUFUWCUVQXJUXRUVQSQ
      ZUYMUWCSQZULUVQUVTVLZVUOVUFTVUPUYMVUQIDVOZUYQNDVOZXKUXRUVNVUPOZUXEOZVURUX
      QVVBUXJUXQUVNVUPUXEUYPVUPUXQVUSXDUXHUXEUXLUVNUXEUXGWQWFXLVTVVAUXEVURFUVQU
      VTHSUWGWAXMXNUVQUVTUWCSSSXOXPXQWKUXRUVNVUQOZUWLUWCUVTLZMZOZUWCUVTVLZUXQVV
      FUXJUXQUVNVUQVVEUYPVUQUXQVUTXDUXHVVEUXLUVNUXGVVEUXEUXGVVEUXFVVDUWLUVTUWCV
      QVRVSRWFXLVTVVCVVEVVGFUWCUVTHSUWKWAXMXNXRWGWOUYBUYRUYTVUBTUXRUYBUYROZUWQV
      UAUWCVVHUWIUXDHUVRUWAUVQUVTXSWIWJYAWKUYCUYRUWDUWCMZUXHUWPPZUYBUYRVVIVVJPP
      UXRUYBUYRVVIUXHUWPVVHVVIOZUXHOUWFUWOVVKUWFUXHUYBUYRVVIUWFUYBUYRVVIULUWFUY
      BUVSUYRUWBVVIUWEUVRUVQXTZUWAUVTXTZUWDUWCXTZYBVSYCVTVVKUXHUWOVVKUXEUWJUXGU
      WNVVKUXDUWIUWHVVKUVQUVRUVTUWAUYBUVSUYRVVIUYBUVSVVLVSWOUYRUWBUYBVVIUYRUWBV
      VMVSWFZYDYEVVKUXFUWMUWLVVKUVTUWAUWCUWDVVOVVIUWEVVHVVIUWEVVNVSRYDYEYKYFWPY
      GRYHYIYIYIYGYJYLYMVTUVOUVMUXHTUVNUVOUVMUVLEUXKUIZUXHUVOUVLEUUTUXKUUSNIUGY
      NZYOVVPUVLEIKLZUIZUXHUVLEUXKVVRUUBUUCISQKSQVVSUXHTUUMUUAUVLUXEUXGEIKSSUVE
      IMZUVGUWHUVKUXDVVTUVFUWGFUVEIGYPYQVVTUVHUVQUVJUVTUVEIDYPVVTUVIKDVVTUVIIKU
      HUBKUVEIKUHYRUUDYSYQYDYTUVEKMZUVGUWLUVKUXFVWAUVFUWKFUVEKGYPYQVWAUVHUVTUVJ
      UWCUVEKDYPVWAUVINDVWAUVIKKUHUBNUVEKKUHYRUUEYSYQYDYTUUFUUGUUHUUIRUVPUVDUXJ
      UXOUXMUVOUVDUXJTUVNUVOUVCUXIHDUUSNIUEYNUUJRUVOUXOUXMTUVNUVOUVBUXLUXBUVOUU
      TUXKMUVBUXLTVVQUUTUXKUVAGUUKXNUULRUUNUUOUUPUUQUUR $.

    $( In a undirected simply graph, there is a path of length 2 if and only if
       there are three distinct vertices so that one of them is connected to
       each of the two others by an edge.  (Contributed by Alexander van der
       Vekens, 27-Jan-2018.) $)
    usgra2pth $p |- ( V USGrph E -> ( ( F ( V Paths E ) P /\ ( # ` F ) = 2 )
     <-> ( F : ( 0 ..^ 2 ) -1-1-> dom E /\ P : ( 0 ... 2 ) -1-1-> V
           /\ E. x e. V E. y e. ( V \ { x } ) E. z e. ( V \ { x , y } )
                ( ( ( P ` 0 ) = x /\ ( P ` 1 ) = y /\ ( P ` 2 ) = z )
           /\ ( ( E ` ( F ` 0 ) ) = { x , y }
                /\ ( E ` ( F ` 1 ) ) = { y , z } ) ) ) ) ) $=
      ( vi co cfv c2 wceq wa cc0 c1 cpr wi cvv wcel adantl cusg wbr cpath chash
      cfzo cdm wf1 cfz cv w3a cdif wrex cspath usgra2pthspth spthispth pthistrl
      csn ctrail cwalk cn0 trliswlk wlkbprop 3simpc 3syl ccnv wfun isspth caddc
      wf istrl2 anbi1d oveq2 f1eq2 syl biimpd com12 3ad2ant1 adantr feq2d df-f1
      wb simplbi2 a1i sylbid com3l 3ad2ant2 imp usgra2pthlem1 3jcad mpcom com13
      wral ex f1f hashfirdm sylancr eqcoms ad2antrr syl5ib eqcom biimpi preq12d
      2nn0 eqeq2d impcom 3ad2ant3 jca rexlimivw a1d fzo0to2pr syl6eq c0ex fveq2
      raleqdv fveq2d oveq1 0p1e1 eqeq12d 1p1e2 ralprg mp2an bitrd imbi2d mpbird
      1ex 3jca simprbi usgrav ovex sylancl anim12i simpr simp-4l 3imp impbid
      fex ) GEUAUBZFDGEUCIUBZFUDJZKLZMZNKUEIZEUFZFUGZNKUHIZGDUGZNDJZAUIZLZODJZB
      UIZLZKDJZCUIZLZUJZNFJZEJZUUHUUKPZLZOFJZEJZUUKUUNPZLZMZMZCGUUSUKZULZBGUUHU
      QUKZULZAGULZUJZUUAYQUVLYRYTYQUVLQYQYTYRUVLYQYTYRUVLQYQYTMZYRFDGEUMIUBZUVL
      DEFGUNZUVNUVMUVLGRSERSMZFRSZDRSZMZMZUVNUVMUVLQZUVNYRFDGEURIUBZUVTDEFGUODE
      FGUPUWBFDGEUSIUBYSUTSZUVPUVSUJUVTDEFGVADEFGVBUWCUVPUVSVCVDVDUVTUVNUWBDVEV
      FZMZUWADEFGRRRRVGZUVTUWENYSUEIZUUCFUGZNYSUHIZGDVIZHUIZFJZEJZUWKDJZUWKOVHI
      ZDJZPZLZHUWGWLZUJZUWDMZUWAUVTUWBUWTUWDDHEFGRRRRVJVKZUVTUXAUWAUVTUXAMUVMUU
      DUUFUVKUXAUVMUUDQZUVTUWTUXCUWDUWHUWJUXCUWSUVMUWHUUDYTUWHUUDQYQYTUWHUUDYTU
      WGUUBLUWHUUDWAYSKNUEVLZUWGUUBUUCFVMVNVOTVPVQVRTUXAUVMUUFQZUVTUWTUWDUXEUWJ
      UWHUWDUXEQUWSUVMUWJUWDUUFYTUWJUWDUUFQZQYQYTUWJUUEGDVIZUXFYTUWIUUEGDYSKNUH
      VLVSUXGUXFQYTUUFUXGUWDUUEGDVTZWBWCWDTWEWFWGTUXAUVMUVKQZUVTUWTUXIUWDABCDHE
      FGWHVRTWIWMWDWDWJVPWDWMWKWGVPUVLYQUUAUUDUUFUVKYQUUAQZYTUUDUUFUVKUXJQZQZUU
      DKUTSUUBUUCFVIZYTXCUUBUUCFWNZUUCFKWOWPYTUUDUXLYTUUDMZUUFUXKUXOUUFMZUVKUXJ
      UXPUVKMZYQUUAUXQYQMZYRYTUXRYRUVNUXRUVNUXAUXRUWTUWDUXRUWHUWJUWSUXPUWHUVKYQ
      UXOUWHUUFYTUUDUWHYTUUDUWHYTUUBUWGLZUUDUWHWAUXSKYSKYSNUEVLWQUUBUWGUUCFVMVN
      VOWGVRWRUXPUWJUVKYQUXOUUFUWJUUFUXGUXOUWJUUEGDWNZUXOUUEUWIGDYTUUEUWILZUUDU
      YAKYSKYSNUHVLWQVRVSWSWGWRUXQYQUWSUXPUVKYQUWSQZYTUVKUYBQZUUDUUFYTUYCUVKYQU
      URUUGUUJPZLZUVBUUJUUMPZLZMZQZQZUYJYTUVKUYHYQUVJUYHAGUVHUYHBUVIUVFUYHCUVGU
      VFUYEUYGUVEUUPUYEUUTUUPUYEQUVDUUPUUTUYEUUPUUTUYEUUPUUSUYDUURUUPUUHUUGUUKU
      UJUUIUULUUHUUGLZUUOUUIUYKUUGUUHWTXAVQUULUUIUUKUUJLZUUOUULUYLUUJUUKWTXAWFZ
      XBXDVOVPVRXEUVEUUPUYGUVDUUPUYGQUUTUUPUVDUYGUUPUVDUYGUUPUVCUYFUVBUUPUUKUUJ
      UUNUUMUYMUUOUUIUUNUUMLZUULUUOUYNUUMUUNWTXAXFXBXDVOVPTXEXGXHXHXHXIWCYTUYBU
      YIUVKYTUWSUYHYQYTUWSUWRHNOPZWLZUYHYTUWRHUWGUYOYTUWGUUBUYOUXDXJXKXNUYPUYHW
      AZYTNRSORSUYQXLYEUWRUYEUYGHNORRUWKNLZUWMUURUWQUYDUYRUWLUUQEUWKNFXMXOUYRUW
      NUUGUWPUUJUWKNDXMUYRUWOODUYRUWONOVHIOUWKNOVHXPXQXKXOXBXRUWKOLZUWMUVBUWQUY
      FUYSUWLUVAEUWKOFXMXOUYSUWNUUJUWPUUMUWKODXMUYSUWOKDUYSUWOOOVHIKUWKOOVHXPXS
      XKXOXBXRXTYAWCYBYCYCYDWRWGWGYFUXPUWDUVKYQUUFUWDUXOUUFUXGUWDUXHYGTWRXGUXRU
      VTUVNUXAWAUXRUVPUVSYQUVPUXQEGYHTUXPUVSUVKYQUXOUVQUUFUVRUUDUVQYTUUDUXMUUBR
      SUVQUXNNKUEYIUUBUUCRFYPYJTUUFUXGUUERSUVRUXTNKUHYIUUEGRDYPYJYKWRXGUVTUVNUW
      EUXAUWFUXBYBVNYDUXRUVMYRUVNWAUXRYQYTUXQYQYLYTUUDUUFUVKYQYMZXGUVOVNYDUYTXG
      WMWMWMWMWJYNVPYO $.

    $( In a undirected simply graph, there is a path of length 2 if and only if
       there are three distinct vertices so that one of them is connected to
       each of the two others by an edge.  (Contributed by Alexander van der
       Vekens, 27-Jan-2018.) $)
    usgra2pth0 $p |- ( V USGrph E -> ( ( F ( V Paths E ) P /\ ( # ` F ) = 2 )
     <-> ( F : ( 0 ..^ 2 ) -1-1-> dom E /\ P : ( 0 ... 2 ) -1-1-> V
           /\ E. x e. V E. y e. ( V \ { x } ) E. z e. ( V \ { x , y } )
                ( ( ( P ` 0 ) = x /\ ( P ` 1 ) = z /\ ( P ` 2 ) = y )
           /\ ( ( E ` ( F ` 0 ) ) = { x , z }
                /\ ( E ` ( F ` 1 ) ) = { z , y } ) ) ) ) ) $=
      ( co cfv c2 wceq wa cc0 cv w3a cpr cdif wrex wne rexbii cusg wbr cfzo cdm
      cpath chash wf1 cfz c1 csn usgra2pth wb wcel r19.42v bitr3i rexcom df-3an
      rexdifpr anass ancom necom anbi2ci anbi1i 3bitri 3bitr4i 3bitr2i rexdifsn
      a1i rexbidva 3anbi3d bitrd ) GEUAUBZFDGEUEHUBFUFIJKLMJUCHEUDFUGZMJUHHGDUG
      ZMDIANZKUIDICNZKJDIBNZKOMFIEIVOVPPZKUIFIEIVPVQPKLLZBGVRQZRZCGVOUJQZRZAGRZ
      OVMVNVSCGVOVQPQZRZBWBRZAGRZOACBDEFGUKVLWDWHVMVNVLWCWGAGWCWGULVLVOGUMLVPVO
      SZWALZCGRZVQVOSZWFLZBGRZWCWGWKWLVQVPSZWIVSLZOZBGRZCGRWQCGRZBGRWNWJWRCGWJW
      PBVTRWRWIVSBVTUNWPBGVOVPURUOTWQCBGGUPWSWMBGWSWIVPVQSZWLVSLZOZCGRXACWERWMW
      QXBCGWQWLWOLZWPLXCWILZVSLZXBWLWOWPUQXCWIVSUSWIWTLZWLLZVSLXFXALXEXBXFWLVSU
      SXDXGVSXDWLWOWILZLXHWLLXGWLWOWIUSWLXHUTXHXFWLWOWTWIVQVPVAVBVCVDVCWIWTXAUQ
      VEVFTXACGVOVQURWLVSCWEUNVFTVDWACGVOVGWFBGVOVGVEVHVIVJVK $.
  $}

  $( Lemma 1 for ~ usgra2adedgspth .  (Contributed by Alexander van der Vekens,
     1-Feb-2018.) $)
  usgra2adedgspthlem1 $p |- ( ( V USGrph E
                        /\ ( { A , B } e. ran E /\ { B , C } e. ran E ) )
                      -> ( ( E ` ( `' E ` { A , B } ) ) = { A , B }
                        /\ ( E ` ( `' E ` { B , C } ) ) = { B , C } ) ) $=
    ( cusg wbr cpr crn wcel wa ccnv cfv wceq cdm wf1o wi f1ocnvfv2 ex adantr
    usgraf1o anim12d mpancom imp ) EDFGZABHZDIZJZBCHZUGJZKZUFDLZMDMUFNZUIULMDMU
    INZKZDOZUGDPZUEUKUOQDEUAUQUEKUHUMUJUNUQUHUMQUEUQUHUMUPUGUFDRSTUQUJUNQUEUQUJ
    UNUPUGUIDRSTUBUCUD $.

  $( Lemma for ~ usgra2adedgspth .  (Contributed by Alexander van der Vekens,
     1-Feb-2018.) $)
  usgra2adedgspthlem2 $p |- ( ( ( V USGrph E /\ A =/= C )
                        /\ ( { A , B } e. ran E /\ { B , C } e. ran E ) )
                      -> ( ( `' E ` { A , B } ) =/= ( `' E ` { B , C } )
                           /\ ( E ` ( `' E ` { A , B } ) ) = { A , B }
                           /\ ( E ` ( `' E ` { B , C } ) ) = { B , C } ) ) $=
    ( cusg wbr wne wa cpr wcel cfv wceq wi adantlr usgraedgrnv syl ex com13 imp
    crn ccnv w3a cdm usgraf1o wf1 f1of1 f1ocnvfvrneq wo wb pm3.2 pm2.43i adantl
    wf1o preq12bg eqtr simpl jaoi syl6bi syld necon3d exp31 usgra2adedgspthlem1
    com34 mpcom imp31 3anass sylanbrc ) EDFGZACHZIABJZDUAZKZBCJZVLKZIZIVKDUBZLZ
    VNVQLZHZVRDLVKMZVSDLVNMZIZVTWAWBUCVIVJVPVTDUDZVLDUNZVIVJVPVTNNZDEUEWEWDVLDU
    FZVIWFNWDVLDUGWGVIVPVJVTWGVIVPVJVTNWGVIIZVPIZVRVSACWIVRVSMZVKVNMZACMZWGVPWJ
    WKNVIWDVLVKVNDUHOWIWKABMBCMIZWLBBMZIZUIZWLWIAEKBEKZIZWQCEKIZIZWKWPUJWHVPWTV
    IVPWTNZWGVIXAVPVIVIWTVMVOVIVIWTNZNVIVOVMXBVIVOVMXBNZVIVOIWSXCDBCEPVIVMWSWTV
    IVMWSWTNZVIVMIWRXDDABEPWRWSUKQRSQRSTSULUMTABBCEEEEUOQWMWLWOABCUPWLWNUQURUSU
    TVAVBVDQVEVFVIVPWCVJABCDEVCOVTWAWBVGVH $.

  ${
    usgra2adedgspth.f $e |- F = { <. 0 , ( `' E ` { A , B } ) >. ,
                                  <. 1 , ( `' E ` { B , C } ) >. } $.
    usgra2adedgspth.p $e |- P = { <. 0 , A >. , <. 1 , B >. , <. 2 , C >. } $.
    $( In an undirected simple graph, two adjacent edges form a simple path of
       length 2.  (Contributed by Alexander van der Vekens, 1-Feb-2018.) $)
    usgra2adedgspth $p |- ( ( V USGrph E /\ A =/= C ) -> ( ( { A , B } e. ran E
                           /\ { B , C } e. ran E ) -> F ( V SPaths E ) P ) ) $=
      ( wbr wne wa cpr wcel cvv w3a cfv wceq usgraedgrnv simprd cusg crn cspath
      co ccnv usgrav ad2antrr adantrr simpld adantrl usgraedgrn ad2ant2r simplr
      3jca adantlr ad2ant2rl usgra2adedgspthlem2 fvex pm3.2i constr2spth imp ex
      syl31anc ) GEUAJZACKZLZABMZEUBZNZBCMZVHNZLZFDGEUCUDJZVFVLLZGONEONLZAGNZBG
      NZCGNZPZABKZVEBCKZPZVGEUEZQZVJWCQZKWDEQVGRWEEQVJRPZVMVDVOVEVLEGUFUGVDVLVS
      VEVDVLLZVPVQVRWGVPVQVDVIVPVQLVKEABGSUHZUIWGVPVQWHTWGVQVRVDVKVQVRLVIEBCGSU
      JTUNUOVNVTVEWAVDVIVTVEVKEABGUKULVDVEVLUMVDVKWAVEVIEBCGUKUPUNABCEGUQVOVSWB
      PWFVMABCDOEFWDWEGOOOWDONWEONVGWCURVJWCURUSHIUTVAVCVB $.

    $( In an undirected simple graph, two adjacent edges form a walk between
       two (different) vertices.  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    usgra2adedgwlk $p |- ( V USGrph E
                           -> ( ( { A , B } e. ran E /\ { B , C } e. ran E )
                                -> ( F ( V Walks E ) P /\ ( # ` F ) = 2
                /\ ( A = ( P ` 0 ) /\ B = ( P ` 1 ) /\ C = ( P ` 2 ) ) ) ) ) $=
      ( wbr cpr wcel wa cfv c2 wceq w3a cvv simprd eqcomd cusg crn cwalk co cc0
      chash c1 usgrav adantr usgraedgrnv ancomd adantrr adantrl 3jca ccnv simpl
      jca usgra2adedgspthlem1 adantl fvex constr2wlk sylc 2trllemA a1i 2wlklemA
      pm3.2i 2wlklemB 2wlklemC 3anim123i mpancom ex ) GEUAJZABKZEUBZLZBCKZVNLZM
      ZFDGEUCUDJZFUFNOPZAUEDNZPZBUGDNZPZCODNZPZQZQZGRLERLMZAGLZBGLZCGLZQZMZVLVR
      MZWHWOWIWMVLWIVREGUHUIWOWJWKWLWOWKWJVLVOWKWJMVQVLVOMWJWKEABGUJZUKULSWOWJW
      KVLVOWJWKMVQWPULSWOWKWLVLVQWKWLMVOEBCGUJUMSUNUQWNWOMZVSVTWGWQWNVMEUOZNZEN
      VMPVPWRNZENVPPMZVSWNWOUPWOXAWNABCEGURUSABCDREFWSWTGRRRWSRLWTRLVMWRUTVPWRU
      TVFZHIVAVBVTWQRFWSWTRXBHVCVDWNWGWOWMWGWIWJWBWKWDWLWFWJWAAABCDGIVETWKWCBAB
      CDGIVGTWLWECABCDGIVHTVIUSUIUNVJVK $.

    $( In an undirected simple graph, two adjacent edges form a walk between
       two (different) vertices.  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    usgra2adedgwlkon $p |- ( V USGrph E -> ( ( { A , B } e. ran E
                   /\ { B , C } e. ran E ) -> F ( A ( V WalkOn E ) C ) P ) ) $=
      ( wbr cpr wcel wa co cc0 cfv wceq cvv simprd cop cusg crn cwalk chash w3a
      cwlkon ccnv usgrav adantr usgraedgrnv adantrr adantrl usgra2adedgspthlem1
      ancomd 3jca jca fvex pm3.2i constr2wlk sylc ex anim12d 2wlklemA c2 fveq2i
      2trllemA 2wlklemC syl5eq adantl anim12i imp 3anass sylanbrc wb c1 eqeltri
      syl6 prex ctp tpex a1i simpld anim12dan iswlkon syl3anc mpbird ) GEUAJZAB
      KZEUBZLZBCKZWILZMZFDACGEUFNNJZWGWMMZWNFDGEUCNJZODPAQZFUDPZDPZCQZUEZWOWPWQ
      WTMZXAWOGRLERLMZAGLZBGLZCGLZUEZMWHEUGZPZEPWHQWKXHPZEPWKQMWPWOXCXGWGXCWMEG
      UHUIZWOXDXEXFWOXEXDWGWJXEXDMWLWGWJMZXDXEEABGUJZUNUKSWOXDXEWGWJXDXEMZWLXMU
      KSWOXEXFWGWLXEXFMZWJEBCGUJZULSUOUPABCEGUMABCDREFXIXJGRRRXIRLXJRLWHXHUQWKX
      HUQURZHIUSUTWGWMXBWGWMXNXOMXBWGWJXNWLXOWGWJXNXMVAWGWLXOXPVAVBXNWQXOWTXDWQ
      XEABCDGIVCUIXFWTXEXFWSVDDPCWRVDDRFXIXJRXQHVFVEABCDGIVGVHVIVJVQVKWPWQWTVLV
      MWOXCFRLZDRLZMZXDXFMWNXAVNXKXTWOXRXSFOXITZVOXJTZKRHYAYBVRVPDOATZVOBTZVDCT
      ZVSRIYCYDYEVTVPURWAWGWJXDWLXFXLXDXEXMWBWGWLMXEXFXPSWCACDEFGRRRRWDWEWFVA
      $.
      $( with using usgra2adedgwlk (proof is longer!):
      wbr wcel wa co cfv c2 wceq cc0 c1 w3a cvv cusg cpr cwalk usgra2adedgwlk
      crn chash cwlkon simp1 eqcom biimpi 3ad2ant1 3ad2ant3 fveq2 sylan9eq 3jca
      3adant1 wb cn0 cdm cword wf wi wlkbprop 2mwlk simp-4l simp-4r oveq2 feq2d
      cfz anbi2d ctp c0ex tpid1 fz0tp eleqtrri ffvelrn mpan2 cz elexi tpid3 jca
      adantl syl6bi impcom adantr eleq1 bi2anan9 3adant2 mpbird exp41 sylc 3imp
      2z iswlkon syl syl6 ) GEUAJABUBEUEZKBCUBWQKLFDGEUCMJZFUFNZOPZAQDNZPZBRDNP
      ZCODNZPZSZSZFDACGEUGMMJZABCDEFGHIUDXGXHWRXAAPZWSDNZCPZSZXGWRXIXKWRWTXFUHX
      FWRXIWTXBXCXIXEXBXIAXAUIUJUKULWTXFXKWRWTXFXJXDCWSODUMXEXBXDCPZXCXEXMCXDUI
      UJULUNUPUOXGGTKETKLZFTKDTKLZAGKZCGKZLZSZXHXLUQWRWTXFXSWRWSURKZXNXOSFEUSUT
      KZQWSVIMZGDVAZLZWTXFXSVBVBZDEFGVCDEFGVDXNXOYDYEVBXTXNXOLZYDWTXFXSYFYDLZWT
      LZXFLZXNXOXRXNXOYDWTXFVEXNXOYDWTXFVFYIXRXAGKZXDGKZLZYHYLXFWTYGYLWTYGYFYAQ
      OVIMZGDVAZLZLYLWTYDYOYFWTYCYNYAWTYBYMGDWSOQVIVGVHVJVJYOYLYFYNYLYAYNYJYKYN
      QYMKYJQQROVKZYMQROVLVMVNVOYMGQDVPVQYNOYMKYKOYPYMQROOVRWMVSVTVNVOYMGODVPVQ
      WAWBWBWCWDWEXFXRYLUQZYHXBXEYQXCXBXPYJXEXQYKAXAGWFCXDGWFWGWHWBWIUOWJUPWKWL
      ACDEFGTTTTWNWOWIWP $)

    $( In an undirected simple graph, two adjacent edges are an unordered pair
       of unordered pairs.  (Contributed by Alexander van der Vekens,
       1-Feb-2018.) $)
    usgra2adedglem1 $p |- ( V USGrph E
                            -> ( ( { A , B } e. ran E /\ { B , C } e. ran E )
                            -> { { A , B } , { B , C } } = ( E " ran F ) ) ) $=
      ( crn cpr wcel wa cima wceq cfv cc0 cop c1 cvv cusg wbr cdm wf1o usgraf1o
      wi ccnv rneqi c0ex 1ex rnpropg mp2an eqtri a1i imaeq2d wfn f1ofn f1ocnvdm
      adantr adantrr adantrl fnimapr syl3anc f1ocnvfv2 preq12d 3eqtrrd ex syl )
      GEUAUBEUCZEJZEUDZABKZVJLZBCKZVJLZMZVLVNKZEFJZNZOZUFEGUEVKVPVTVKVPMZVSEVLE
      UGZPZVNWBPZKZNZWCEPZWDEPZKZVQWAVRWEEVRWEOWAVRQWCRSWDRKZJZWEFWJHUHQTLSTLWK
      WEOUIUJQSWCWDTTUKULUMUNUOWAEVIUPZWCVILZWDVILZWFWIOVKWLVPVIVJEUQUSVKVMWMVO
      VIVJVLEURUTVKVOWNVMVIVJVNEURVAVIWCWDEVBVCWAWGVLWHVNVKVMWGVLOVOVIVJVLEVDUT
      VKVOWHVNOVMVIVJVNEVDVAVEVFVGVH $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d C f p $.  $d E f p $.  $d V f p $.
    $( In an undirected simple graph, two adjacent edges form a walk between
       two (different) vertices.  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    usg2wlk $p |- ( ( V USGrph E /\ { A , B } e. ran E /\ { B , C } e. ran E )
                    -> E. f E. p ( f ( V Walks E ) p /\ ( # ` f ) = 2
                  /\ ( A = ( p ` 0 ) /\ B = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) $=
      ( cc0 cpr cfv cop c1 cvv wcel c2 wbr w3a chash wceq fveq1 ccnv ctp wa crn
      cusg cwalk co cv prex tpex pm3.2i eqid usgra2adedgwlk 3impib breq12 fveq2
      wex wb eqeq1d adantr eqeq2d 3anbi123d adantl spc2egv mpsyl ) HABIZEUAZJKZ
      LBCIZVGJKZIZMNZHAKZLBKZOCKZUBZMNZUCFEUEPZVFEUDZNZVIVSNZQVKVPFEUFUGZPZVKRJ
      ZOSZAHVPJZSZBLVPJZSZCOVPJZSZQZQZDUHZGUHZWBPZWNRJZOSZAHWOJZSZBLWOJZSZCOWOJ
      ZSZQZQZGUQDUQVLVQVHVJUIVMVNVOUJUKVRVTWAWMABCVPEVKFVKULVPULUMUNXFWMDGVKVPM
      MWNVKSZWOVPSZUCWPWCWRWEXEWLWNVKWOVPWBUOXGWRWEURXHXGWQWDOWNVKRUPUSUTXHXEWL
      URXGXHWTWGXBWIXDWKXHWSWFAHWOVPTVAXHXAWHBLWOVPTVAXHXCWJCOWOVPTVAVBVCVBVDVE
      $.

    $( In an undirected simple graph, two adjacent edges form a walk between
       two (different) vertices.  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    usg2wlkon $p |- ( V USGrph E -> ( ( { A , B } e. ran E
         /\ { B , C } e. ran E ) -> E. f E. p f ( A ( V WalkOn E ) C ) p ) ) $=
      ( wbr cpr wcel wa cv co wex cc0 cfv cop c1 cvv eqid cusg cwlkon ccnv prex
      crn c2 ctp tpex pm3.2i usgra2adedgwlkon imp breq12 spc2egv mpsyl ex ) FEU
      AHZABIZEUEZJBCIZURJKZDLZGLZACFEUBMMZHZGNDNZOUQEUCZPQZRUSVFPQZIZSJZOAQZRBQ
      ZUFCQZUGZSJZKUPUTKVIVNVCHZVEVJVOVGVHUDVKVLVMUHUIUPUTVPABCVNEVIFVITVNTUJUK
      VDVPDGVIVNSSVAVIVBVNVCULUMUNUO $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
        Walks as words
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c WWalks $.
  $c WWalksN $.

  $( Extend class notation with Walks (of a graph) as Word over the set of
     vertices. $)
  cwwlk $a class WWalks $.

  $( Extend class notation with Walks (of a graph) of a fixed length as Word
     over the set of vertices. $)
  cwwlkn $a class WWalksN $.

  ${
    $d e i v w $.
    $( Define the set of all Walks (in an undirected graph) as words over the
       set of vertices.  Such a word corresponds to the sequence p(0) p(1) ...
       p(n-1) p(n) of the vertices in a walk p(0) e(f(1)) p(1) e(f(2)) ...
       p(n-1) e(f(n)) p(n) as defined in ~ df-wlk . ` w = (/) ` has to be
       excluded because a walk always consists of at least one vertex, see
       ~ wlkn0 .  (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    df-wwlk $a |- WWalks = ( v e. _V , e e. _V |-> { w e. Word v | ( w =/= (/)
                         /\ A. i e. ( 0 ..^ ( ( # ` w ) - 1 ) )
                            { ( w ` i ) , ( w ` ( i + 1 ) ) } e. ran e ) } ) $.
  $}

  ${
    $d e n v w $.
    $( Define the set of all Walks (in an undirected graph) of a fixed length n
       as words over the set of vertices.  Such a word corresponds to the
       sequence p(0) p(1) ... p(n) of the vertices in a walk p(0) e(f(1)) p(1)
       e(f(2)) ... p(n-1) e(f(n)) p(n) as defined in ~ df-wlk .  (Contributed
       by Alexander van der Vekens, 15-Jul-2018.) $)
    df-wwlkn $a |- WWalksN = ( v e. _V , e e. _V |-> ( n e. NN0 |->
                         { w e. ( v WWalks e ) | ( # ` w ) = ( n + 1 ) } ) ) $.
  $}

  ${
    $d E e i v w $.  $d V e i v w $.
    $( The set of walks (in an undirected graph) as words over the set of
       vertices.  (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    wwlk $p |- ( ( V e. X /\ E e. Y ) -> ( V WWalks E ) = { w e. Word V |
            ( w =/= (/) /\ A. i e. ( 0 ..^ ( ( # ` w ) - 1 ) )
                            { ( w ` i ) , ( w ` ( i + 1 ) ) } e. ran E ) } ) $=
      ( vv ve wcel cvv cwwlk co cv cfv c1 crn wral wa cword wceq c0 wne cpr cc0
      caddc chash cmin cfzo crab elex cmpt2 a1i wrdeq adantr rneq adantl eleq2d
      df-wwlk ralbidv anbi2d rabeqbidv simpl simpr wrdexg rabexg ovmpt2d syl2an
      syl ) DEIDJIZCJIZDCKLAMZUAUBZBMZVKNVMOUELVKNUCZCPZIZBUDVKUFNOUGLUHLZQZRZA
      DSZUIZTCFIDEUJCFUJVIVJRZGHDCJJVLVNHMZPZIZBVQQZRZAGMZSZUIZWAKJKGHJJWJUKTWB
      AGHBURULWHDTZWCCTZRZWJWATWBWMWGVSAWIVTWKWIVTTWLWHDUMUNWMWFVRVLWMWEVPBVQWM
      WDVOVNWLWDVOTWKWCCUOUPUQUSUTVAUPVIVJVBVIVJVCWBVTJIZWAJIVIWNVJDJVDUNVSAVTJ
      VEVHVFVG $.
  $}

  ${
    $d E e i n v w $.  $d V e i n v w $.  $d N n w $.  $d X e v $.  $d Y e v $.
    $( The set of walks (in an undirected graph) of a fixed length as words
       over the set of vertices.  (Contributed by Alexander van der Vekens,
       15-Jul-2018.) $)
    wwlkn $p |- ( ( V e. X /\ E e. Y /\ N e. NN0 )
                  -> ( ( V WWalksN E ) ` N )
                       = { w e. ( V WWalks E ) | ( # ` w ) = ( N + 1 ) } ) $=
      ( vn vv ve wcel cn0 cwwlkn co cfv cv c1 caddc wceq cwwlk cvv chash rabexg
      w3a crab cmpt simp3 ovex mp1i oveq1 eqeq2d rabbidv eqid fvmptg syl2anc wb
      wa cmpt2 df-wwlkn a1i oveq12 rabeq syl mpteq2dv adantl adantr nn0ex mptex
      elex ovmpt2d fveq1d eqeq1d 3adant3 mpbird ) DEJZBFJZCKJZUCZCDBLMZNZAOUANZ
      CPQMZRZADBSMZUDZRZCGKVTGOZPQMZRZAWCUDZUEZNZWDRZVQVPWDTJZWLVNVOVPUFWCTJWMV
      QDBSUGWBAWCTUBUHGCWIWDKTWJWFCRZWHWBAWCWNWGWAVTWFCPQUIUJUKWJULUMUNVNVOWEWL
      UOVPVNVOUPZVSWKWDWOCVRWJWOHIDBTTGKWHAHOZIOZSMZUDZUEZWJLTLHITTWTUQRWOAHIGU
      RUSWPDRWQBRUPZWTWJRWOXAGKWSWIXAWRWCRWSWIRWPDWQBSUTWHAWRWCVAVBVCVDVNDTJVOD
      EVHVEVOBTJVNBFVHVDWJTJWOGKWIVFVGUSVIVJVKVLVM $.
  $}

  ${
    $d E i w $.  $d V i w $.  $d W i w $.
    $( Properties of a word to represent a walk (in an undirected graph).
       (Contributed by Alexander van der Vekens, 15-Jul-2018.) $)
    iswwlk $p |- ( ( V e. X /\ E e. Y ) -> ( W e. ( V WWalks E )
       <-> ( W =/= (/) /\ W e. Word V /\ A. i e. ( 0 ..^ ( ( # ` W ) - 1 ) )
                            { ( W ` i ) , ( W ` ( i + 1 ) ) } e. ran E ) ) ) $=
      ( vw wcel wa co cv c0 wne cfv c1 cpr cc0 chash cmin cfzo cwwlk caddc wral
      crn cword crab wwlk eleq2d neeq1 fveq2 oveq1d oveq2d fveq1 preq12d eleq1d
      w3a wceq raleqbidv anbi12d elrab 3anass 3ancoma 3bitr2i syl6bb ) CEHBFHIZ
      DCBUAJZHDGKZLMZAKZVGNZVIOUBJZVGNZPZBUDZHZAQVGRNZOSJZTJZUCZIZGCUEZUFZHZDLM
      ZDWAHZVIDNZVKDNZPZVNHZAQDRNZOSJZTJZUCZUPZVEVFWBDGABCEFUGUHWCWEWDWMIZIWEWD
      WMUPWNVTWOGDWAVGDUQZVHWDVSWMVGDLUIWPVOWIAVRWLWPVQWKQTWPVPWJOSVGDRUJUKULWP
      VMWHVNWPVJWFVLWGVIVGDUMVKVGDUMUNUOURUSUTWEWDWMVAWEWDWMVBVCVD $.
  $}

  ${
    $d E w $.  $d N w $.  $d V w $.  $d W w $.
    $( Properties of a word to represent a walk of a fixed length (in an
       undirected graph).  (Contributed by Alexander van der Vekens,
       15-Jul-2018.) $)
    iswwlkn $p |- ( ( V e. X /\ E e. Y /\ N e. NN0 )
               -> ( W e. ( ( V WWalksN E ) ` N )
                    <-> ( W e. ( V WWalks E ) /\ ( # ` W ) = ( N + 1 ) ) ) ) $=
      ( vw wcel cn0 w3a cwwlkn co cfv cv chash c1 caddc wceq cwwlk crab eleq2d
      wa wwlkn fveq2 eqeq1d elrab syl6bb ) CEHAFHBIHJZDBCAKLMZHDGNZOMZBPQLZRZGC
      ASLZTZHDUNHDOMZULRZUBUHUIUODGABCEFUCUAUMUQGDUNUJDRUKUPULUJDOUDUEUFUG $.
  $}

  ${
    $d V e v w $.  $d E e v w $.  $d P w $.  $d e i v w $.
    $( Properties of a walk (in an undirected graph) as word.  (Contributed by
       Alexander van der Vekens, 15-Jul-2018.) $)
    wwlkprop $p |- ( P e. ( V WWalks E )
                     -> ( V e. _V /\ E e. _V /\ P e. Word V ) ) $=
      ( vw vi ve vv cv c0 wne cfv c1 caddc co cpr crn wcel cc0 chash cmin cwwlk
      cfzo wral wa df-wwlk elovmpt2wrd ) DHZIJEHZUGKUHLMNUGKOFHPQERUGSKLTNUBNUC
      UDFDGUACBADGFEUEUF $.
  $}

  ${
    $d E e n v w $.  $d N n w $.  $d P w $.  $d e v w i $.  $d V e n v w $.
    $( Properties of a walk of a fixed length (in an undirected graph) as
       word.  (Contributed by Alexander van der Vekens, 16-Jul-2018.) $)
    wwlknprop $p |- ( P e. ( ( V WWalksN E ) ` N )
             -> ( ( V e. _V /\ E e. _V ) /\ ( N e. NN0 /\ P e. Word V ) ) ) $=
      ( vw vi ve vn vv cv cfv c1 caddc co wcel wa cwwlkn cvv cn0 cab c0 wne cpr
      crn chash cmin cfzo wral wceq cwwlk crab cmpt cmpt2 cword df-wwlkn df-rab
      cc0 w3a wb iswwlk adantr anbi1d abbidv syl5eq 3anan12 anbi1i anass eqtr4i
      bitri abbii syl6eq mpteq2dva mpt2eq3ia eqtri elovmptnn0wrd ) EJZUAUBZFJZV
      PKVRLMNVPKUCGJZUDOFUQVPUEKZLUFNUGNUHZPZVTHJZLMNUIZPZGEIHCQDBAQIGRRHSWDEIJ
      ZVSUJNZUKZULZUMIGRRHSWEEWFUNZUKZULZUMEIGHUOIGRRWIWLWFROVSROPZHSWHWKWMWCSO
      ZPZWHVQVPWJOZWAURZWDPZETZWKWOWHVPWGOZWDPZETWSWDEWGUPWOXAWREWOWTWQWDWMWTWQ
      USWNFVSWFVPRRUTVAVBVCVDWSWPWEPZETWKWRXBEWRWPWBPZWDPXBWQXCWDVQWPWAVEVFWPWB
      WDVGVIVJWEEWJUPVHVKVLVMVNVO $.
  $}

  ${
    $d E i $.  $d N i $.  $d V i $.  $d W i $.
    $( Implications for a set being a walk of length n (represented by a
       word).  (Contributed by Alexander van der Vekens, 17-Jun-2018.) $)
    wwlknimp $p |- ( W e. ( ( V WWalksN E ) ` N ) -> ( W e. Word V
         /\ ( # ` W ) = ( N + 1 ) /\ A. i e. ( 0 ..^ N )
                             { ( W ` i ) , ( W ` ( i + 1 ) ) } e. ran E ) ) $=
      ( cvv wcel wa co cfv c1 caddc wceq cc0 cfzo wral w3a wi cmin ex cn0 cword
      cwwlkn chash cv cpr crn wwlknprop cwwlk iswwlkn simprr c0 wne oveq1 nn0cn
      iswwlk cc ax-1cn a1i pncand adantl sylan9eqr oveq2d biimpd com23 impancom
      raleqdv 3adant1 syl6bi 3impia imp32 jca sylbid 3expa ancoms anim2i 3anass
      imp sylibr exp44 impcom mpcom ) DFGZBFGZHZCUAGZEDUBGZHZHECDBUCIJGZWGEUDJZ
      CKLIZMZAUEZEJWMKLIEJUFBUGGZANCOIZPZQZEBCDUHWHWEWIWQRZWGWFWEWRRWGWFWEWIWQW
      GWFWEHZWIHZHWGWLWPHZHWQWTXAWGWSWIXAWEWFWIXARZWCWDWFXBWCWDWFQZWIEDBUIIGZWL
      HZXABCDEFFUJXCXEXAXCXEHWLWPXCXDWLUKXCXDWLWPWCWDWFXDWLWPRZRWEXDWFXFWEXDEUL
      UMZWGWNANWJKSIZOIZPZQWFXFRZABDEFFUPWGXJXKXGWGWFXJXFWGWFHZWLXJWPXLWLXJWPRX
      LWLHZXJWPXMWNAXIWOXMXHCNOWLXLXHWKKSIZCWJWKKSUNWFXNCMWGWFCKCUOKUQGWFURUSUT
      VAVBVCVGVDTVEVFVHVIVEVJVKVLTVMVNVOVRVPWGWLWPVQVSVTWAWAWB $.
  $}

  ${
    $d E w $.  $d V w $.
    $( Walks (represented by words) are words.  (Contributed by Alexander van
       der Vekens, 17-Jul-2018.) $)
    wwlksswrd $p |- ( V WWalks E ) C_ Word V $=
      ( vw cwwlk co cword cv wcel cvv wwlkprop simp3d ssriv ) CBADEZBFZCGZMHBIH
      AIHONHOABJKL $.
  $}

  ${
    $d V v $.  $d W v $.
    $( A walk of length 0 is represented by a singleton word.  (Contributed by
       Alexander van der Vekens, 20-Jul-2018.) $)
    wwlkn0 $p |- ( W e. ( ( V WWalksN E ) ` 0 ) -> E. v e. V W = <" v "> ) $=
      ( cvv wcel wa cc0 cn0 co cfv cs1 wceq wrex c1 wb syl wi mpcom adantl 0nn0
      cword cwwlkn wwlknprop cwwlk chash caddc w3a simpl simpr a1i 3jca iswwlkn
      adantr 0p1e1 eqeq2i eqs1 wrdlen1 s1eq reximi eqcoms rexbidv syl5ib expcom
      cv eqeq1 sylbi com12 sylbid ) CEFZBEFZGZHIFZDCUBFZGZGZDHCBUCJKFZDAVEZLZMZ
      ACNZDBHCUDVPVQDCBUEJFZDUFKZHOUGJZMZGZWAVPVJVKVMUHZVQWFPVLWGVOVLVJVKVMVJVK
      UIVJVKUJVMVLUAUKULUNBHCDEEUMQVOWFWARZVLVNWHVMWFVNWAWEVNWARZWBWEWCOMZWIWDO
      WCUOUPVNWJWADHDKZLZMZVNWJGZWACDUQWNWLVSMZACNZWMWAWNWKVRMZACNWPACDURWQWOAC
      WKVRUSUTQWMWOVTACWOVTPWLDWLDVSVFVAVBVCSVDVGTVHTTVIS $.
  $}

  ${
    $d E i $.  $d F i $.  $d P i $.  $d V i $.
    $( The sequence of vertices in a walk is a walk as word in an undirected
       simple graph.  (Contributed by Alexander van der Vekens,
       20-Jul-2018.) $)
    wlkiswwlk1 $p |- ( V USGrph E
                       -> ( F ( V Walks E ) P -> P e. ( V WWalks E ) ) ) $=
      ( vi co wcel cfv cvv wa w3a wi cc0 c1 wceq cfzo wral cmin adantl adantr
      cwalk wbr cwwlk chash cn0 wlkbprop c0 wne wlkn0 cdm cword cfz wf cv caddc
      cusg cpr iswlk crn simprl iswrd0i 3ad2ant2 lencl hashfzdm cc nn0cn ax-1cn
      pncan eqcomd sylancl oveq1 eqcoms eqeq2d syl5ib mpcom sylan ad2antrr wfun
      oveq2d raleqdv usgrafun ad3antlr wrdf simplll adantll eleq2d biimpa exp31
      ffvelrnd syl2anc imp jca fvelrn syl wb eleq1 mpbird ralimdva sylbid com24
      ex 3impia impcom 3jca iswwlk bicomd sylibd exp4b mpdi 3adant1 com12 ) CAD
      BUAFUBZDBUPUBZADBUCFGZCUDHZUEGZDIGBIGJZCIGAIGJZKXLXMXNLZABCDUFXQXRXLXSLXP
      XQXRJZXLAUGUHZXSABCDUIXTXLCBUJZUKGZMXOULFDAUMZEUNZCHZBHZYEAHYENUOFAHUQZOZ
      EMXOPFZQZKZYAXSLAEBCDIIIIURXTYLYAXMXNXTYLJZYAXMJZYAADUKGZYHBUSZGZEMAUDHZN
      RFZPFZQZKZXNYMYNUUBYMYNJYAYOUUAYMYAXMUTYMYOYNYLYOXTYDYCYOYKDXOAVAVBSTYMYN
      UUAYLXTYNUUALZYCYDYKXTUUCLYCYDJZYNXTYKUUAUUDYNXTYKUUALUUDYNJXTJZYKYIEYTQU
      UAUUEYIEYJYTUUEXOYSMPUUDXOYSOZYNXTYCXPYDUUFYBCVCZYRXONUOFZOZXPYDJZUUFDAXO
      VDUUJXOUUHNRFZOZUUIUUFXPUULYDXPXOVEGZNVEGZUULXOVFVGUUMUUNJUUKXOXONVHVIVJT
      UUIUUKYSXOUUKYSOUUHYRUUHYRNRVKVLVMVNVOZVPVQVSVTUUEYIYQEYTUUEYEYTGZJZYIYQU
      UQYIJZYQYGYPGZUURBVRZYFYBGZJZUUSUUQUVBYIUUQUUTUVAYNUUTUUDXTUUPXMUUTYABDWA
      SWBUUEUUPUVAUUDUUPUVALZYNXTYCYDUVCYCYJYBCUMZXPYDUVCLYBCWCUUGUVDXPJZYDUUPU
      VAUVEYDJZUUPJYJYBYECUVDXPYDUUPWDUVFUUPYEYJGUVFYTYJYEUVFYSXOMPXPYDYSXOOUVD
      UUJXOYSUUOVIWEVSWFWGWIWHWJWKVQWKWLTYFBWMWNYIYQUUSWOZUUQUVGYHYGYHYGYPWPVLS
      WQXAWRWSWHWTXBXCWKXDXAXQUUBXNWOXRYLXQXNUUBEBDAIIXEXFVQXGXHWSXIXJVOXK $.
  $}

  ${
    $d E i x $.  $d F i $.  $d I x $.  $d P i x $.  $d V i x $.
    wlkiswwlk2lem.f $e |- F = ( x e. ( 0 ..^ ( ( # ` P ) - 1 ) ) |->
                            ( `' E ` { ( P ` x ) , ( P ` ( x + 1 ) ) } ) ) $.
    $( Lemma 1 for ~ wlkiswwlk2 .  (Contributed by Alexander van der Vekens,
       20-Jul-2018.) $)
    wlkiswwlk2lem1 $p |- ( ( P e. Word V /\ 1 <_ ( # ` P ) )
                           -> ( # ` F ) = ( ( # ` P ) - 1 ) ) $=
      ( cword wcel c1 chash cfv cle wbr wa cmin co cn0 cc0 cfzo wfn cn elnnnn0c
      wceq lencl biimpri sylan nnm1nn0 syl caddc cpr ccnv fvex ffzohash sylancl
      cv fnmpti ) BEGHZIBJKZLMZNZURIOPZQHZDRVASPZTDJKVAUCUTURUAHZVBUQURQHZUSVDE
      BUDVDVEUSNURUBUEUFURUGUHAVCAUOZBKVFIUIPBKUJZCUKZKDVGVHULFUPDVAUMUN $.

    $( Lemma 2 for ~ wlkiswwlk2 .  (Contributed by Alexander van der Vekens,
       20-Jul-2018.) $)
    wlkiswwlk2lem2 $p |- ( ( ( # ` P ) e. NN0
                                   /\ I e. ( 0 ..^ ( ( # ` P ) - 1 ) ) )
               -> ( F ` I ) = ( `' E ` { ( P ` I ) , ( P ` ( I + 1 ) ) } ) ) $=
      ( chash cfv cn0 wcel cc0 c1 cmin co caddc cpr cvv wceq a1i fveq2d cfzo wa
      cv ccnv cmpt fveq2 oveq1 preq12d adantl simpr fvex fvmptd ) BGHZIJZEKUMLM
      NUANZJZUBZAEAUCZBHZURLONZBHZPZCUDZHZEBHZELONZBHZPZVCHZUODQDAUOVDUERUQFSUR
      ERZVDVIRUQVJVBVHVCVJUSVEVAVGUREBUFVJUTVFBURELOUGTUHTUIUNUPUJVIQJUQVHVCUKS
      UL $.

    $( Lemma 3 for ~ wlkiswwlk2 .  (Contributed by Alexander van der Vekens,
       20-Jul-2018.) $)
    wlkiswwlk2lem3 $p |- ( ( P e. Word V /\ 1 <_ ( # ` P ) )
                           -> P : ( 0 ... ( # ` F ) ) --> V ) $=
      ( cword wcel c1 chash cfv cle wbr wa cmin co wceq cc0 cfz wf wi cfzo wrdf
      wlkiswwlk2lem1 cn0 lencl cz nn0z fzoval syl oveq2 eqcoms sylan9eq biimpcd
      feq2d exp3a sylc adantr mpd ) BEGHZIBJKZLMZNDJKZVAIOPZQZRVCSPZEBTZABCDEFU
      DUTVEVGUAZVBUTRVAUBPZEBTZVAUEHZVHEBUCEBUFVJVKVEVGVKVENZVJVGVLVIVFEBVKVEVI
      RVDSPZVFVKVAUGHVIVMQVAUHRVAUIUJVMVFQVDVCVDVCRSUKULUMUOUNUPUQURUS $.

    $( Lemma 4 for ~ wlkiswwlk2 .  (Contributed by Alexander van der Vekens,
       20-Jul-2018.) $)
    wlkiswwlk2lem4 $p |- ( ( V USGrph E /\ P e. Word V /\ 1 <_ ( # ` P ) )
       -> ( A. i e. ( 0 ..^ ( ( # ` P ) - 1 ) )
            { ( P ` i ) , ( P ` ( i + 1 ) ) } e. ran E
               -> A. i e. ( 0 ..^ ( # ` F ) )
                   ( E ` ( F ` i ) ) = { ( P ` i ) , ( P ` ( i + 1 ) ) } ) ) $=
      ( chash cfv c1 co wceq wbr wcel cc0 cfzo wral wi wa sylan cmin cusg cword
      cle w3a cv caddc cpr crn wlkiswwlk2lem1 3adant1 ccnv lencl wlkiswwlk2lem2
      cn0 3ad2ant2 adantr fveq2d cdm usgraf1o 3ad2ant1 f1ocnvfv2 eqtrd ralimdva
      wf1o ex oveq2 raleqdv imbi2d syl5ibr mpcom ) EHIZBHIZJUAKZLZFDUBMZBFUCNZJ
      VMUDMZUEZCUFZBIVTJUGKBIUHZDUIZNZCOVNPKZQZVTEIZDIZWALZCOVLPKZQZRZVQVRVOVPA
      BDEFGUJUKVSWKVOWEWHCWDQZRVSWCWHCWDVSVTWDNZSZWCWHWNWCSZWGWADULIZDIZWAWOWFW
      PDWNWFWPLZWCVSVMUONZWMWRVQVPWSVRFBUMUPABDEVTGUNTUQURWNDUSZWBDVEZWCWQWALVS
      XAWMVPVQXAVRDFUTVAUQWTWBWADVBTVCVFVDVOWJWLWEVOWHCWIWDVLVNOPVGVHVIVJVK $.

    $( Lemma 5 for ~ wlkiswwlk2 .  (Contributed by Alexander van der Vekens,
       21-Jul-2018.) $)
    wlkiswwlk2lem5 $p |- ( ( V USGrph E /\ P e. Word V /\ 1 <_ ( # ` P ) )
                           -> ( A. i e. ( 0 ..^ ( ( # ` P ) - 1 ) )
                                { ( P ` i ) , ( P ` ( i + 1 ) ) } e. ran E
                               -> F e. Word dom E ) ) $=
      ( cusg wbr cword wcel c1 chash cfv cle cv caddc co cpr wa w3a crn cc0 cdm
      cmin cfzo wral wf ccnv wf1o usgraf1o 3ad2ant1 ad2antrr simpr weq wb fveq2
      oveq1 fveq2d preq12d eleq1d adantl rspcdv impancom f1ocnvdm syl2anc fmptd
      imp iswrdi syl ex ) FDHIZBFJKZLBMNZOIZUAZCPZBNZVQLQRZBNZSZDUBZKZCUCVNLUER
      ZUFRZUGZEDUDZJKZVPWFTZWEWGEUHWHWIAWEAPZBNZWJLQRZBNZSZDUINZWGEWIWJWEKZTWGW
      BDUJZWNWBKZWOWGKVPWQWFWPVLVMWQVODFUKULUMWIWPWRVPWPWFWRVPWPTZWCWRCWJWEVPWP
      UNCAUOZWCWRUPWSWTWAWNWBWTVRWKVTWMVQWJBUQWTVSWLBVQWJLQURUSUTVAVBVCVDVHWGWB
      WNDVEVFGVGWGWDEVIVJVK $.

    $( Lemma 6 for ~ wlkiswwlk2 .  (Contributed by Alexander van der Vekens,
       21-Jul-2018.) $)
    wlkiswwlk2lem6 $p |- ( ( V USGrph E /\ P e. Word V /\ 1 <_ ( # ` P ) )
                           -> ( A. i e. ( 0 ..^ ( ( # ` P ) - 1 ) )
                                { ( P ` i ) , ( P ` ( i + 1 ) ) } e. ran E
         -> ( F e. Word dom E /\ P : ( 0 ... ( # ` F ) ) --> V
              /\ A. i e. ( 0 ..^ ( # ` F ) )
                 ( E ` ( F ` i ) ) = { ( P ` i ) , ( P ` ( i + 1 ) ) } ) ) ) $=
      ( cusg wbr cword wcel c1 chash cfv w3a co cc0 cfzo wral imp cle caddc cpr
      cv crn cmin cdm wceq wlkiswwlk2lem5 wlkiswwlk2lem3 3adant1 wlkiswwlk2lem4
      cfz wf wa adantr 3jca ex ) FDHIZBFJKZLBMNZUAIZOZCUDZBNVDLUBPBNUCZDUEKCQVA
      LUFPRPSZEDUGJKZQEMNZUMPFBUNZVDENDNVEUHCQVHRPSZOVCVFUOVGVIVJVCVFVGABCDEFGU
      ITVCVIVFUTVBVIUSABDEFGUJUKUPVCVFVJABCDEFGULTUQUR $.
  $}

  ${
    $d E f i x $.  $d P f i x $.  $d V f i x $.
    $( A walk as word corresponds to the sequence of vertices in a walk in an
       undirected simple graph.  (Contributed by Alexander van der Vekens,
       21-Jul-2018.) $)
    wlkiswwlk2 $p |- ( V USGrph E -> ( P e. ( V WWalks E )
                                       -> E. f f ( V Walks E ) P ) ) $=
      ( vi vx co wcel wbr cv cvv w3a wi cfv c1 cc0 chash cfzo wa adantr cusg c0
      cwwlk cwalk wex cword wwlkprop wne caddc cpr crn cmin wral iswwlk 3adant3
      wb cdm cfz wf wceq ccnv cmpt ovex mptexg mp1i simpr adantl hashge1 ancoms
      cle 3jca eqid wlkiswwlk2lem6 eleq1 fveq2 oveq2d feq2d fveq1 fveq2d eqeq1d
      syl raleqbidv 3anbi123d imbi2d mpbird spcimedv ex com23 3impia impcom imp
      exp3a 3simpa vex jctl 3ad2ant3 jca iswlk exbidv sylbid mpcom com12 ) ADCU
      CGHZDCUAIZBJZADCUDGIZBUEZDKHZCKHZADUFZHZLZXCXDXGMZACDUGXLXCAUBUHZXKEJZANX
      OOUIGANUJZCUKHEPAQNZOULGZRGZUMZLZXMXHXIXCYAUPXKECDAKKUNUOXLYAXMXLYASZXDXG
      YBXDSZXGXECUQUFZHZPXEQNZURGZDAUSZXOXENZCNZXPUTZEPYFRGZUMZLZBUEZYBXDYOYAXL
      XDYOMYAXLXDYOXNXKXTXLXDSZYOMXNXKSZYPXTYOYQYPXTYOMYQYPSZYNXTBFXSFJZANYSOUI
      GANUJCVANZVBZKXSKHUUAKHYRPXRRVCFXSYTKVDVEYRXEUUAUTZSZXTYNMZXTUUAYDHZPUUAQ
      NZURGZDAUSZXOUUANZCNZXPUTZEPUUFRGZUMZLZMZUUCXDXKOXQVJIZLZUUOYRUUQUUBYRXDX
      KUUPYPXDYQXLXDVFVGYQXKYPXNXKVFTYQUUPYPXKXNUUPAXJVHVITVKTFAECUUADUUAVLVMWA
      UUBUUDUUOUPYRUUBYNUUNXTUUBYEUUEYHUUHYMUUMXEUUAYDVNUUBYGUUGDAUUBYFUUFPURXE
      UUAQVOZVPVQUUBYKUUKEYLUULUUBYFUUFPRUURVPUUBYJUUJXPUUBYIUUICXOXEUUAVRVSVTW
      BWCWDVGWEWFWGWHWIWLWJWKYCXFYNBYCXHXISZXEKHZXKSZSZXFYNUPYBUVBXDXLUVBYAXLUU
      SUVAXHXIXKWMXKXHUVAXIXKUUTBWNWOWPWQTTAECXEDKKKXJWRWAWSWEWGWGWTXAXB $.
  $}

  ${
    $d E f $.  $d P f $.  $d V f $.
    $( A walk as word corresponds to a walk in an undirected simple graph.
       (Contributed by Alexander van der Vekens, 21-Jul-2018.) $)
    wlkiswwlk $p |- ( V USGrph E -> ( E. f f ( V Walks E ) P
                                      <-> P e. ( V WWalks E ) ) ) $=
      ( cusg wbr cv cwalk wex cwwlk wcel wlkiswwlk1 exlimdv wlkiswwlk2 impbid
      co ) DCEFZBGZADCHPFZBIADCJPKZQSTBACRDLMABCDNO $.
  $}

  $( The sequence of vertices in a walk of length n is a walk as word of length
     n in an undirected simple graph.  (Contributed by Alexander van der
     Vekens, 21-Jul-2018.) $)
  wlklniswwlkn1 $p |- ( V USGrph E -> ( ( F ( V Walks E ) P /\ ( # ` F ) = N )
                        -> P e. ( ( V WWalksN E ) ` N ) ) ) $=
    ( co chash cfv wceq wa wcel cn0 cvv wi adantr c1 caddc com12 adantl wb cusg
    cwalk wbr cwwlkn w3a wlkbprop cwwlk wlkiswwlk1 imp cdm cword cc0 cfz wf wfn
    2mwlk ffn hashfn hashfz0 3ad2ant1 eqeq1 eqcoms syl5ib 3syl syl oveq1 eqeq2d
    sylibd impcom simpl2l simpl2r eleq1 biimpcd 3jca iswwlkn mpbir2and mpancom
    ex ) CAEBUBFUCZCGHZDIZJZEBUAUCZADEBUDFHKZVTLKZEMKZBMKZJZCMKAMKJZUEZWBWCWDNV
    SWJWAABCEUFOWJWBJZWCWDWKWCJZWDAEBUGFKZAGHZDPQFZIZWKWCWMWBWCWMNZWJVSWQWAWCVS
    WMABCEUHROSUIWKWPWCWBWJWPWBWJWNVTPQFZIZWPVSWJWSNZWAVSCBUJUKKZULVTUMFZEAUNZJ
    WTABCEUPXCWTXAXCAXBUOWNXBGHZIZWTXBEAUQXBAURWJXDWRIZXEWSWEWHXFWIVTUSUTXFWSTX
    DWNXDWNWRVAVBVCVDSVEOWAWSWPTVSWAWRWOWNVTDPQVFVGSVHVIOWLWFWGDLKZUEZWDWMWPJTW
    KXHWCWKWFWGXGWFWGWEWIWBVJWFWGWEWIWBVKWBWJXGWAWJXGNVSWJWAXGWEWHWAXGNWIWAWEXG
    VTDLVLVMUTRSVIVNOBDEAMMVOVEVPVRVQR $.

  ${
    $d E f $.  $d N f $.  $d P f $.  $d V f $.
    $( A walk of length n as word corresponds to the sequence of vertices in a
       walk of length n in an undirected simple graph.  (Contributed by
       Alexander van der Vekens, 21-Jul-2018.) $)
    wlklniswwlkn2 $p |- ( V USGrph E -> ( P e. ( ( V WWalksN E ) ` N )
                          -> E. f ( f ( V Walks E ) P /\ ( # ` f ) = N ) ) ) $=
      ( co cfv wcel chash wceq wa wex cvv cn0 wi c1 adantr adantl cmin cc cwalk
      cwwlkn cusg cv cword wwlknprop cwwlk caddc wb simpl simpr iswwlkn syl3anc
      wbr lencl nn0cn syl ax-1cn a1i subadd2d syl6rbb biimpcd impcom wlkiswwlk2
      eqcom com12 imp cdm cc0 cfz wf 2mwlk wfn ffn hashfn hashfz0 eqeq2d pncand
      eqcomd oveq1 syl5ibrcom sylbid 3syl mpan9 jca ex eximdv mpd anbi2d exbidv
      eqeq2 syl5ib exp3a mpcom ) ADECUBFGHZECUCUNZBUDZAECUAFUNZWQIGZDJZKZBLZEMH
      ZCMHZKZDNHZAEUEHZKZKZWOWPXBOZACDEUFXIWOAECUGFHZAIGZDPUHFZJZKZXJXIXCXDXFWO
      XOUIXEXCXHXCXDUJQXEXDXHXCXDUKQXHXFXEXFXGUJRCDEAMMULUMXIXOXJXLPSFZDJZXIXOK
      ZXJXOXIXQXNXIXQOXKXIXNXQXHXNXQUIXEXHXQXMXLJXNXHXLPDXGXLTHZXFXGXLNHXSEAUOX
      LUPUQRPTHZXHURUSXFDTHXGDUPQUTXMXLVEVARVBRVCXQXRWPXBXRWPKZWRWSXPJZKZBLZXQX
      BYAWRBLZYDXRWPYEXOWPYEOZXIXKYFXNWPXKYEABCEVDVFQRVGYAWRYCBYAWRYCYAWRKWRYBY
      AWRUKWRYBYAWRWQCVHZUEHZVIWSVJFZEAVKZKYBACWQEVLYHWSNHZYJYBYGWQUOYJAYIVMXLY
      IIGZJZYKYBOYIEAVNYIAVOYKYMYBYKYMXLWSPUHFZJZYBYKYLYNXLWSVPVQYKYBYOWSYNPSFZ
      JYKYPWSYKWSPWSUPXTYKURUSVRVSYOXPYPWSXLYNPSVTVQWAWBVFWCWDUQRWEWFWGWHXQYCXA
      BXQYBWTWRXPDWSWKWIWJWLWMWNWFWBWNVF $.

    $( A walk of length n as word corresponds to a walk with length n in an
       undirected simple graph.  (Contributed by Alexander van der Vekens,
       21-Jul-2018.) $)
    wlklniswwlkn $p |- ( V USGrph E -> ( E. f ( f ( V Walks E ) P
                     /\ ( # ` f ) = N ) <-> P e. ( ( V WWalksN E ) ` N ) ) ) $=
      ( cusg wbr cv cwalk co chash cfv wceq wa wex cwwlkn wlklniswwlkn1 exlimdv
      wcel wlklniswwlkn2 impbid ) ECFGZBHZAECIJGUCKLDMNZBOADECPJLSZUBUDUEBACUCD
      EQRABCDETUA $.
  $}

  $( A walk of a fixed length as word is a walk (in an undirected graph) as
     word.  (Contributed by Alexander van der Vekens, 17-Jul-2018.) $)
  wwlkiswwlkn $p |- ( P e. ( ( V WWalksN E ) ` N ) -> P e. ( V WWalks E ) ) $=
    ( cvv wcel wa cn0 cword cwwlkn co cfv cwwlk wwlknprop chash c1 caddc simpll
    wceq wb simplr simprl iswwlkn syl3anc simpl syl6bi mpcom ) DEFZBEFZGZCHFZAD
    IFZGZGZACDBJKLFZADBMKFZABCDNUNUOUPAOLCPQKSZGZUPUNUHUIUKUOURTUHUIUMRUHUIUMUA
    UJUKULUBBCDAEEUCUDUPUQUEUFUG $.

  ${
    $d E w $.  $d N w $.  $d V w $.
    $( The walks of a fixed length as words are walks (in an undirected graph)
       as words.  (Contributed by Alexander van der Vekens, 17-Jul-2018.) $)
    wwlksswwlkn $p |- ( ( V WWalksN E ) ` N ) C_ ( V WWalks E ) $=
      ( vw cwwlkn co cfv cwwlk cv wwlkiswwlkn ssriv ) DBCAEFGCAHFDIABCJK $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
 Walks/paths of length 2 as ordered triples
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c 2WalksOt $.
  $c 2WalksOnOt $.
  $c 2SPathOnOt $.
  $c 2SPathsOt $.

  $( Extend class notation with walks (of a graph) of length 2 as ordered
     triple. $)
  c2wlkot $a class 2WalksOt $.

  $( Extend class notation with walks between two vertices (within a graph) of
     length 2 as ordered triple. $)
  c2wlkonot $a class 2WalksOnOt $.

  $( Extend class notation with paths (of a graph) of length 2 as ordered
     triple. $)
  c2spthot $a class 2SPathsOt $.

  $( Extend class notation with simple paths between two vertices (within a
     graph) of length 2 as ordered triple. $)
  c2pthonot $a class 2SPathOnOt $.

  ${
    $d a b e v t f p $.
    $( Define the collection of walks of length 2 with particular endpoints as
       ordered triple (in a graph).  (Contributed by Alexander van der Vekens,
       15-Feb-2018.) $)
    df-2wlkonot $a |- 2WalksOnOt = ( v e. _V , e e. _V
     |-> ( a e. v , b e. v |-> { t e. ( ( v X. v ) X. v ) |
         E. f E. p ( f ( a ( v WalkOn e ) b ) p /\ ( # ` f ) = 2
            /\ ( ( 1st ` ( 1st ` t ) ) = a /\ ( 2nd ` ( 1st ` t ) ) = ( p ` 1 )
                       /\ ( 2nd ` t ) = b ) ) } ) ) $.

    $( Define the collection of all walks of length 2 as ordered triple (in a
       graph).  (Contributed by Alexander van der Vekens, 15-Feb-2018.) $)
    df-2wlksot $a |- 2WalksOt = ( v e. _V , e e. _V |->
      { t e. ( ( v X. v ) X. v ) | E. a e. v E. b e. v
                                   t e. ( a ( v 2WalksOnOt e ) b ) } ) $.

    $( Define the collection of simple paths of length 2 with particular
       endpoints as ordered triple (in a graph) .  (Contributed by Alexander
       van der Vekens, 1-Mar-2018.) $)
    df-2spthonot $a |- 2SPathOnOt = ( v e. _V , e e. _V
     |-> ( a e. v , b e. v |-> { t e. ( ( v X. v ) X. v ) |
         E. f E. p ( f ( a ( v SPathOn e ) b ) p /\ ( # ` f ) = 2
            /\ ( ( 1st ` ( 1st ` t ) ) = a /\ ( 2nd ` ( 1st ` t ) ) = ( p ` 1 )
                       /\ ( 2nd ` t ) = b ) ) } ) ) $.

    $( Define the collection of all simple paths of length 2 as ordered
       triple.  (in a graph) (Contributed by Alexander van der Vekens,
       1-Mar-2018.) $)
    df-2spthsot $a |- 2SPathsOt = ( v e. _V , e e. _V |->
      { t e. ( ( v X. v ) X. v ) | E. a e. v E. b e. v
                                   t e. ( a ( v 2SPathOnOt e ) b ) } ) $.
  $}

  $( Lemma for ~ el2wlkonot .  (Contributed by Alexander van der Vekens,
     15-Feb-2018.) $)
  el2wlkonotlem $p |- ( ( f ( V Walks E ) p /\ ( # ` f ) = 2 )
                         -> ( p ` 1 ) e. V ) $=
    ( cv cwalk co wbr chash cfv c2 wceq c1 wcel cdm cword cc0 cfz wf wa ctp 1ex
    wi 2mwlk oveq2 feq2d tpid2 fz0tp eleqtrri ffvelrn mpan2 syl6bi com12 adantl
    syl imp ) AEZDEZCBFGHZUQIJZKLZMURJCNZUSUQBOPNZQUTRGZCURSZTVAVBUCZURBUQCUDVE
    VFVCVAVEVBVAVEQKRGZCURSZVBVAVDVGCURUTKQRUEUFVHMVGNVBMQMKUAVGQMKUBUGUHUIVGCM
    URUJUKULUMUNUOUP $.

  ${
    $d E a b e v t f p $.  $d V a b e v t f p $.
    $( The set of walks of length 2 between two vertices (in a graph) as
       ordered triple.  (Contributed by Alexander van der Vekens,
       15-Feb-2018.) $)
    is2wlkonot $p |- ( ( V e. X /\ E e. Y )
                       -> ( V 2WalksOnOt E ) = ( a e. V , b e. V |->
     { t e. ( ( V X. V ) X. V ) |
         E. f E. p ( f ( a ( V WalkOn E ) b ) p /\ ( # ` f ) = 2
            /\ ( ( 1st ` ( 1st ` t ) ) = a /\ ( 2nd ` ( 1st ` t ) ) = ( p ` 1 )
                       /\ ( 2nd ` t ) = b ) ) } ) ) $=
      ( vv ve wcel cvv cv cwlkon co cfv wceq wex cxp wa wbr chash c1st c2nd w3a
      c2 c1 crab cmpt2 c2wlkonot adantr adantl mpt2exga anidms simpl id xpeq12d
      elex oveq12 oveqd breqd 3anbi1d 2exbidv rabeqbidv mpt2eq123dv df-2wlkonot
      ovmpt2ga syl3anc ) DELZCFLZUADMLZCMLZHIDDBNZGNZHNZINZDCOPZPZUBZVNUCQUGRZA
      NZUDQZUDQVPRWCUEQUHVOQRWBUEQVQRUFZUFZGSBSZADDTZDTZUIZUJZMLZDCUKPWJRVJVLVK
      DEUSULVKVMVJCFUSUMVJWKVKVJWKHIDDWIEEUNUOULJKDCMMHIJNZWLVNVOVPVQWLKNZOPZPZ
      UBZWAWDUFZGSBSZAWLWLTZWLTZUIZUJWJUKMWLDRZWMCRZUAZHIWLWLXADDWIXBXCUPZXEXDW
      RWFAWTWHXBWTWHRXCXBWSWGWLDXBWLDWLDXBUQZXFURXFURULXDWQWEBGXDWPVTWAWDXDWOVS
      VNVOXDWNVRVPVQWLDWMCOUTVAVBVCVDVEVFJAKBGHIVGVHVI $.

    $( The set of simple paths of length 2 between two vertices (in a graph) as
       ordered triple.  (Contributed by Alexander van der Vekens,
       1-Mar-2018.) $)
    is2spthonot $p |- ( ( V e. X /\ E e. Y )
                       -> ( V 2SPathOnOt E ) = ( a e. V , b e. V |->
     { t e. ( ( V X. V ) X. V ) |
         E. f E. p ( f ( a ( V SPathOn E ) b ) p /\ ( # ` f ) = 2
            /\ ( ( 1st ` ( 1st ` t ) ) = a /\ ( 2nd ` ( 1st ` t ) ) = ( p ` 1 )
                       /\ ( 2nd ` t ) = b ) ) } ) ) $=
      ( vv ve wcel cvv cv cspthon co cfv wceq wex cxp wa wbr chash c2 c1st c2nd
      w3a crab cmpt2 c2pthonot elex adantr adantl mpt2exga anidms simpl xpeq12d
      c1 oveq12 oveqd breqd 3anbi1d rabeqbidv mpt2eq123dv df-2spthonot ovmpt2ga
      id 2exbidv syl3anc ) DELZCFLZUADMLZCMLZHIDDBNZGNZHNZINZDCOPZPZUBZVNUCQUDR
      ZANZUEQZUEQVPRWCUFQURVOQRWBUFQVQRUGZUGZGSBSZADDTZDTZUHZUIZMLZDCUJPWJRVJVL
      VKDEUKULVKVMVJCFUKUMVJWKVKVJWKHIDDWIEEUNUOULJKDCMMHIJNZWLVNVOVPVQWLKNZOPZ
      PZUBZWAWDUGZGSBSZAWLWLTZWLTZUHZUIWJUJMWLDRZWMCRZUAZHIWLWLXADDWIXBXCUPZXEX
      DWRWFAWTWHXBWTWHRXCXBWSWGWLDXBWLDWLDXBVGZXFUQXFUQULXDWQWEBGXDWPVTWAWDXDWO
      VSVNVOXDWNVRVPVQWLDWMCOUSUTVAVBVHVCVDJAKBGHIVEVFVI $.

    $d A a b f p t $.  $d B a b f p t $.
    $( The set of walks of length 2 between two vertices (in a graph) as
       ordered triple.  (Contributed by Alexander van der Vekens,
       15-Feb-2018.) $)
    2wlkonot $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V ) )
           -> ( A ( V 2WalksOnOt E ) B ) = { t e. ( ( V X. V ) X. V ) |
                E. f E. p ( f ( A ( V WalkOn E ) B ) p /\ ( # ` f ) = 2
            /\ ( ( 1st ` ( 1st ` t ) ) = A /\ ( 2nd ` ( 1st ` t ) ) = ( p ` 1 )
                       /\ ( 2nd ` t ) = B ) ) } ) $=
      ( va vb wcel wa co cv cfv wceq w3a wex cvv c2wlkonot cwlkon chash c2 c1st
      wbr c2nd c1 crab cmpt2 is2wlkonot adantr oveqd simprl simprr xpexg anidms
      cxp mpancom ad2antrr rabexg oveq12 breqd wb eqeq2 adantl 3anbi13d 2exbidv
      syl rabbidv eqid ovmpt2ga syl3anc eqtrd ) FGLZEHLZMZBFLZCFLZMZMZBCFEUANZN
      BCJKFFDOZIOZJOZKOZFEUBNZNZUFZWCUCPUDQZAOZUEPZUEPZWEQZWLUGPUHWDPQZWKUGPZWF
      QZRZRZISDSZAFFURZFURZUIZUJZNZWCWDBCWGNZUFZWJWMBQZWOWPCQZRZRZISDSZAXBUIZWA
      WBXDBCVQWBXDQVTADEFGHIJKUKULUMWAVRVSXMTLZXEXMQVQVRVSUNVQVRVSUOWAXBTLZXNVO
      XOVPVTXATLZVOXOVOXPFFGGUPUQXAFTGUPUSUTXLAXBTVAVIJKBCFFXCXMXDTWEBQZWFCQZMZ
      WTXLAXBXSWSXKDIXSWIXGWRXJWJXSWHXFWCWDWEBWFCWGVBVCXSWNXHWQXIWOXQWNXHVDXRWE
      BWMVEULXRWQXIVDXQWFCWPVEVFVGVGVHVJXDVKVLVMVN $.

    $( The set of simple paths of length 2 between two vertices (in a graph) as
       ordered triple.  (Contributed by Alexander van der Vekens,
       1-Mar-2018.) $)
    2spthonot $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ B e. V ) )
           -> ( A ( V 2SPathOnOt E ) B ) = { t e. ( ( V X. V ) X. V ) |
                E. f E. p ( f ( A ( V SPathOn E ) B ) p /\ ( # ` f ) = 2
            /\ ( ( 1st ` ( 1st ` t ) ) = A /\ ( 2nd ` ( 1st ` t ) ) = ( p ` 1 )
                       /\ ( 2nd ` t ) = B ) ) } ) $=
      ( va vb wcel wa co cv cfv wceq w3a wex cvv c2pthonot cspthon wbr chash c2
      c1st c2nd c1 cxp crab cmpt2 is2spthonot adantr oveqd simprl simprr anidms
      xpexg mpancom ad2antrr rabexg syl oveq12 breqd wb adantl 3anbi13d 2exbidv
      eqeq2 rabbidv eqid ovmpt2ga syl3anc eqtrd ) FGLZEHLZMZBFLZCFLZMZMZBCFEUAN
      ZNBCJKFFDOZIOZJOZKOZFEUBNZNZUCZWCUDPUEQZAOZUFPZUFPZWEQZWLUGPUHWDPQZWKUGPZ
      WFQZRZRZISDSZAFFUIZFUIZUJZUKZNZWCWDBCWGNZUCZWJWMBQZWOWPCQZRZRZISDSZAXBUJZ
      WAWBXDBCVQWBXDQVTADEFGHIJKULUMUNWAVRVSXMTLZXEXMQVQVRVSUOVQVRVSUPWAXBTLZXN
      VOXOVPVTXATLZVOXOVOXPFFGGURUQXAFTGURUSUTXLAXBTVAVBJKBCFFXCXMXDTWEBQZWFCQZ
      MZWTXLAXBXSWSXKDIXSWIXGWRXJWJXSWHXFWCWDWEBWFCWGVCVDXSWNXHWQXIWOXQWNXHVEXR
      WEBWMVIUMXRWQXIVEXQWFCWPVIVFVGVGVHVJXDVKVLVMVN $.
  $}

  ${
    $d E a b e t v $.  $d V a b e t v $.
    $( The set of walks of length 2 (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 21-Feb-2018.) $)
    2wlksot $p |- ( ( V e. X /\ E e. Y ) -> ( V 2WalksOt E )
                  = { t e. ( ( V X. V ) X. V ) | E. a e. V E. b e. V
                                   t e. ( a ( V 2WalksOnOt E ) b ) } ) $=
      ( vv ve wcel wa cvv cv c2wlkonot co wrex cxp crab wceq adantr elex adantl
      c2wlkot 3xpexg rabexg syl xpeq12d simpl oveq12 eleq2d rexeqbidv rabeqbidv
      id oveqd df-2wlksot ovmpt2ga syl3anc ) CDJZBEJZKZCLJZBLJZAMZFMZGMZCBNOZOZ
      JZGCPZFCPZACCQZCQZRZLJZCBUCOVMSURVAUSCDUATUSVBURBEUAUBUTVLLJZVNURVOUSCDUD
      TVJAVLLUEUFHICBLLVCVDVEHMZIMZNOZOZJZGVPPZFVPPZAVPVPQZVPQZRVMUCLVPCSZVQBSZ
      KZWBVJAWDVLWEWDVLSWFWEWCVKVPCWEVPCVPCWEUMZWHUGWHUGTWGWAVIFVPCWEWFUHZWGVTV
      HGVPCWIWGVSVGVCWGVRVFVDVEVPCVQBNUIUNUJUKUKULHAIFGUOUPUQ $.

    $( The set of simple paths of length 2 (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 28-Feb-2018.) $)
    2spthsot $p |- ( ( V e. X /\ E e. Y ) -> ( V 2SPathsOt E )
                  = { t e. ( ( V X. V ) X. V ) | E. a e. V E. b e. V
                                   t e. ( a ( V 2SPathOnOt E ) b ) } ) $=
      ( vv ve wcel wa cvv cv c2pthonot co wrex cxp crab wceq adantr elex adantl
      c2spthot 3xpexg rabexg syl id xpeq12d simpl oveq12 oveqd eleq2d rexeqbidv
      rabeqbidv df-2spthsot ovmpt2ga syl3anc ) CDJZBEJZKZCLJZBLJZAMZFMZGMZCBNOZ
      OZJZGCPZFCPZACCQZCQZRZLJZCBUCOVMSURVAUSCDUATUSVBURBEUAUBUTVLLJZVNURVOUSCD
      UDTVJAVLLUEUFHICBLLVCVDVEHMZIMZNOZOZJZGVPPZFVPPZAVPVPQZVPQZRVMUCLVPCSZVQB
      SZKZWBVJAWDVLWEWDVLSWFWEWCVKVPCWEVPCVPCWEUGZWHUHWHUHTWGWAVIFVPCWEWFUIZWGV
      TVHGVPCWIWGVSVGVCWGVRVFVDVEVPCVQBNUJUKULUMUMUNHAIFGUOUPUQ $.
  $}

  ${
    $d A b f p t $.  $d C b f p t $.  $d E b f p t $.  $d T b f p t $.
    $d V b f p t $.  $d X b f p $.  $d Y b f p $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 15-Feb-2018.) $)
    el2wlkonot $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ C e. V ) )
       -> ( T e. ( A ( V 2WalksOnOt E ) C ) <-> E. b e. V ( T = <. A , b , C >.
                     /\ E. f E. p ( f ( V Walks E ) p /\ ( # ` f ) = 2
           /\ ( A = ( p ` 0 ) /\ b = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) ) ) $=
      ( wcel wa cfv wceq w3a wex wi adantl adantr ex vt c2wlkonot co cxp cwlkon
      cv wbr chash c2 c1st c2nd cotp cwalk cc0 wrex crab 2wlkonot eleq2d fveq2d
      c1 fveq2 eqeq1d 3anbi123d 3anbi3d 2exbidv elrab syl6bb cvv vex pm3.2i a1i
      wb simpl simpr iswlkon syl3anc anbi2d el2wlkonotlem 3ad2ant1 imp el2xptp0
      3anbi1d oteq2 eqcoms eqeq2d biimpcd ad2antrr impcom eqcom biimpi 3jca jca
      syl6bi rspcimedv com12 exp41 com15 pm2.43i com24 sylbid com23 com4t com14
      otel3xp sylan2 adantll id 3ad2ant3 syl5ibr 3ad2ant2 oteqimp eqeq2 3anbi2d
      3imp syl5 imbi2d syl5ib impbid bitrd 19.42vv rexcom4 exbii bitr2i 3bitr3g
      rexlimdva rexbii ) FGKEHKLZAFKZBFKZLZLZCABFEUBUCUCZKZCFFUDFUDZKZDUFZIUFZA
      BFEUEUCUCUGZYPUHMZUINZCUJMZUJMZANZUUAUKMZUTYQMZNZCUKMZBNZOZOZIPDPZLZCAJUF
      ZBULZNZYPYQFEUMUCUGZYTAUNYQMZNZUUMUUENZBUIYQMZNZOZOZIPDPLZJFUOZYKYMCYRYTU
      AUFZUJMZUJMZANZUVGUKMZUUENZUVFUKMZBNZOZOZIPDPZUAYNUPZKUULYKYLUVQCUAABDEFG
      HIUQURUVPUUKUACYNUVFCNZUVOUUJDIUVRUVNUUIYRYTUVRUVIUUCUVKUUFUVMUUHUVRUVHUU
      BAUVRUVGUUAUJUVFCUJVAZUSVBUVRUVJUUDUUEUVRUVGUUAUKUVSUSVBUVRUVLUUGBUVFCUKV
      AVBVCVDVEVFVGYKUULUUOUVCLZIPZDPZJFUOZUVEYKYOUUJLZIPDPUVTJFUOZIPZDPZUULUWC
      YKUWDUWEDIYKUWDYOUUPUUQANZYSYQMZBNZOZYTUUIOZLZUWEYKUUJUWLYOYKYRUWKYTUUIYK
      YGYPVHKZYQVHKZLZYJYRUWKVLYGYJVMUWPYKUWNUWODVIIVIVJVKYGYJVNABYQEYPFVHGHVHV
      OVPWBVQYKUWMUWEUWMYKUWEUWLYOYKUWEQZUWKYTUUIYOUWQQZUWKUUIYTUWRYOUUIYTUWKUW
      QYOUUIYTUWKUWQQQUWKYKYOUUILZYTUWEUWKYKUWSYTUWEQQUWKYKLZYTUWSUWEUWTYTUWSUW
      EQUWTYTLZUWSCAUUEBULZNZUWEUXAYHUUEFKZYIUWSUXCVLUWTYHYTYKYHUWKYJYHYGYHYIVM
      ZRRSUWTYTUXDUWKYTUXDQZYKUUPUWHUXFUWJUUPYTUXDDEFIVRZTVSSVTUWTYIYTYKYIUWKYJ
      YIYGYHYIVNZRRSCFFFAUUEBWAVPUWTYTUXCUWEQZUWKYTUXIQZYKUUPUWHUWJUXJUUPYTUWJU
      WHUXIUUPYTUWJUWHUXIQQZUUPYTLZUXKUXCUXLUWJUWHUXLUWEUXCUXLUWJUWHUXLUWEQUXLU
      XCUXLLZUWJLZUWHLZUWEUXLUVTUXOJUUEFUXGUUSUXOUVTQUXLUUSUXOUVTUUSUXOLZUUOUVC
      UXOUUSUUOUXMUUSUUOQZUWJUWHUXCUXQUXLUUSUXCUUOUUSUXBUUNCUXBUUNNUUEUUMUUEUUM
      ABWCWDWEWFSWGWHUXPUUPYTUVBUXOUUPUUSUXMUUPUWJUWHUXLUUPUXCUUPYTVMRWGRUXOYTU
      USUXMYTUWJUWHUXLYTUXCUUPYTVNRWGRUXPUURUUSUVAUXOUURUUSUWHUURUXNUWHUURUUQAW
      IWJRRUUSUXOVMUXOUVAUUSUXNUVAUWHUXMUWJUVAUXLUWJUVAQZUXCYTUXRUUPYTUWJUUTBNZ
      UVAYTUWIUUTBYSUIYQVAVBZUXSUVAUUTBWIWJWMRRVTSRWKWKWLTRWNWOWPWQWRTWSXNSVTWT
      TXATXBTXCXAXNWHWOYKUVTUWMJFYKUUMFKZLZUVTUWMUYBUVTLZYOUWLUYBUVTYOYJUYAUVTY
      OQYGUVTYJUYALZYOUUOUYDYOQUVCUUOUYDYOUYDUUOYHUYAYIOZYOUYDYHUYAYIYJYHUYAUXE
      SYJUYAVNYJYIUYAUXHSWKZAUUMBCFFFXDXETSWOXFVTUYCUWKYTUUIUYCUUPUWHUWJUVTUUPU
      YBUVCUUPUUOUUPYTUUPUVBUUPXGVSRRUVTUWHUYBUVCUWHUUOUVBUUPUWHYTUURUUSUWHUVAU
      URUWHAUUQWIWJVSXHRRUVTUWJUYBUVCUWJUUOUUPYTUVBUWJYTUVBUWJQQUUPUVBUWJYTUXSU
      VAUURUXSUUSUVAUXSBUUTWIWJXHUXTXIVKXNRRWKUVTYTUYBUVCYTUUOYTUUPYTUVBYTXGXJR
      RUVTUYBUUIUVCUUOUYBUUIQZUVBUUPUUOUYGQZYTUUSUURUYHUVAUUOUYBUUCUUDUUMNZUUHO
      ZQUUSUYGUYBUYEUUOUYJYJUYAUYEYGUYFXFAUUMBCFFFXKXOUUSUYJUUIUYBUUSUYIUUFUUCU
      UHUUMUUEUUDXLXMXPXQXJXHWHWHWKWLTYEXRXSVEYOUUJDIXTUWCUWAJFUOZDPUWGUWAJDFYA
      UYKUWFDUVTJIFYAYBYCYDUWBUVDJFUUOUVCDIXTYFVGXS $.

    $( A simple path of length 2 between two vertices (in a graph) as ordered
       triple.  (Contributed by Alexander van der Vekens, 2-Mar-2018.) $)
    el2spthonot $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ C e. V ) )
       -> ( T e. ( A ( V 2SPathOnOt E ) C ) <-> E. b e. V ( T = <. A , b , C >.
                     /\ E. f E. p ( f ( V SPaths E ) p /\ ( # ` f ) = 2
           /\ ( A = ( p ` 0 ) /\ b = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) ) ) $=
      ( wcel wa co cfv wceq w3a wex wi ad2antll adantr vt c2pthonot cxp cspthon
      cv wbr chash c2 c1st c2nd c1 cotp cspath wrex crab 2spthonot eleq2d fveq2
      cc0 fveq2d eqeq1d 3anbi123d 3anbi3d 2exbidv elrab syl6bb cwlkon wb pm3.2i
      cvv vex isspthon mp3an2 3anbi1d anbi2d simpl cpath ctrail cwalk spthispth
      pthistrl trliswlk el2wlkonotlem ex 4syl adantl imp simpr el2xptp0 syl3anc
      oteq2 eqcoms eqeq2d biimpd simpllr iswlkon eqcom biimpi 3jca sylbid com12
      a1i 3adant1 com3l imp41 jctird rspcimedv exp4b 3imp impcom otel3xp sylan2
      com24 imp31 3syl 3ad2ant1 3ad2ant3 syl5ibr mpbird id jca 3ad2ant2 oteqimp
      eqeq2 3anbi2d imbi2d rexlimdva impbid bitrd 19.42vv rexcom4 exbii 3bitr3g
      bitr2i rexbii ) FGKEHKLZAFKZBFKZLZLZCABFEUBMMZKZCFFUCFUCZKZDUEZIUEZABFEUD
      MMUFZUUEUGNZUHOZCUINZUINZAOZUUJUJNZUKUUFNZOZCUJNZBOZPZPZIQDQZLZCAJUEZBULZ
      OZUUEUUFFEUMMUFZUUIAUSUUFNZOZUVBUUNOZBUHUUFNZOZPZPZIQDQLZJFUNZYTUUBCUUGUU
      IUAUEZUINZUINZAOZUVPUJNZUUNOZUVOUJNZBOZPZPZIQDQZUAUUCUOZKUVAYTUUAUWFCUAAB
      DEFGHIUPUQUWEUUTUACUUCUVOCOZUWDUUSDIUWGUWCUURUUGUUIUWGUVRUULUVTUUOUWBUUQU
      WGUVQUUKAUWGUVPUUJUIUVOCUIURZUTVAUWGUVSUUMUUNUWGUVPUUJUJUWHUTVAUWGUWAUUPB
      UVOCUJURVAVBVCVDVEVFYTUVAUVDUVLLZIQZDQZJFUNZUVNYTUUDUUSLZIQDQUWIJFUNZIQZD
      QZUVAUWLYTUWMUWNDIYTUWMUUDUUEUUFABFEVGMMUFZUVELZUUIUURPZLZUWNYTUUSUWSUUDY
      TUUGUWRUUIUURYPUUEVJKZUUFVJKZLZYSUUGUWRVHUXAUXBDVKIVKVIZABUUFEUUEFVJGHVJV
      LVMVNVOYTUWTUWNUWTYTUWNUWSUUDYTUWNRZUWRUUIUURUUDUXERZUWRUUIUURUXFRUWRUUIL
      ZYTUUDUURUWNUXGYTUUDUURUWNUXGYTLZUUDUURLZCAUUNBULZOZUWNUXHYQUUNFKZYRUXIUX
      KVHYSYQUXGYPYQYRVPZSUXGUXLYTUWRUUIUXLUVEUUIUXLRZUWQUVEUUEUUFFEVQMUFZUUEUU
      FFEVRMUFZUUEUUFFEVSMUFZUXNUUFEUUEFVTZUUFEUUEFWAZUUFEUUEFWBZUXQUUIUXLDEFIW
      CWDWEWFWGTZYSYRUXGYPYQYRWHZSCFFFAUUNBWIWJUXHUWIUXKJUUNFUYAUXHUVHLZUXKUVDU
      VLUVHUXKUVDRUXHUVHUXKUVDUVHUXJUVCCUXJUVCOUUNUVBUUNUVBABWKWLWMWNWFUYCUVEUU
      IUVKUXHUVEUVHUWQUVEUUIYTWOTUWRUUIYTUVHWOUWRUUIYTUVHUVKUWQUUIYTUVHUVKRZRRU
      VEYTUWQUUIUYDYTUWQUXQUVFAOZUUHUUFNZBOZPZUUIUYDRZYPUXCYSUWQUYHVHZUXDABUUFE
      UUEFVJGHVJWPVMZUYHUYIRYTUYEUYGUYIUXQUUIUYEUYGLZUYDUUIUYLUYEUVIBOZLZUYDUUI
      UYGUYMUYEUUIUYFUVIBUUHUHUUFURVAZVOUYNUYDRUUIUYNUVHUVKUYNUVHLUVGUVHUVJUYNU
      VGUVHUYEUVGUYMUYEUVGUVFAWQWRTTUYNUVHWHUYNUVJUVHUYMUVJUYEUYMUVJUVIBWQWRWFT
      WSWDXBWTXAXCXBWTXDTXEWSXFXGWTXHXMWDXIXJXAYTUWIUWTJFYTUVBFKZLZUWIUWTUYQUWI
      LZUUDUWSYTUYPUWIUUDYSUYPUWIUUDRZRYPYSUYPUYSUWIYSUYPLZUUDUVDUYTUUDRUVLUVDU
      YTUUDUYTUVDYQUYPYRPZUUDUYTYQUYPYRYSYQUYPUXMTYSUYPWHYSYRUYPUYBTWSAUVBBCFFF
      XKXLWDTXAWDWFXNUYRUWRUUIUURUYRUWQUVEUYRUWQUYHUYRUXQUYEUYGUVLUXQUYQUVDUVEU
      UIUXQUVKUVEUXOUXPUXQUXRUXSUXTXOXPSUVLUYEUYQUVDUVKUVEUYEUUIUVGUVHUYEUVJUVG
      UYEAUVFWQWRXPXQSUVLUYGUYQUVDUVEUUIUVKUYGUUIUVKUYGRRUVEUVKUYGUUIUYMUVJUVGU
      YMUVHUVJUYMBUVIWQWRXQUYOXRXBXISWSUYQUYJUWIYTUYJUYPUYKTTXSUVLUVEUYQUVDUVEU
      UIUVEUVKUVEXTXPSYAUVLUUIUYQUVDUUIUVEUUIUVKUUIXTYBSUWIUYQUURUVLUVDUYQUURRZ
      UVKUVEUVDVUBRZUUIUVHUVGVUCUVJUVDVUBUVHUYQUULUUMUVBOZUUQPZRUVDUYQVUEUYQUVD
      VUAVUEUYQYQUYPYRYTYQUYPYSYQYPUXMWFTYTUYPWHYTYRUYPYSYRYPUYBWFTWSUVDVUAVUEA
      UVBBCFFFYCWGXLWDUVHUURVUEUYQUVHUUOVUDUULUUQUUOVUDVHUUNUVBUUNUVBUUMYDWLYEY
      FXRYBXQXJXJWSYAWDYGYHYIVDUUDUUSDIYJUWLUWJJFUNZDQUWPUWJJDFYKVUFUWODUWIJIFY
      KYLYNYMUWKUVMJFUVDUVLDIYJYOVFYI $.

    $( A simple path of length 2 between two vertices (in a graph) as ordered
       triple.  (Contributed by Alexander van der Vekens, 9-Mar-2018.) $)
    el2spthonot0 $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ C e. V ) )
       -> ( T e. ( A ( V 2SPathOnOt E ) C ) <-> E. b e. V ( T = <. A , b , C >.
                     /\ <. A , b , C >. e. ( A ( V 2SPathOnOt E ) C ) ) ) ) $=
      ( vf vp wcel wa wceq cfv w3a wex c1st c2nd adantr cvv vt c2pthonot cspath
      co cv cotp wbr chash c2 cc0 c1 wrex el2spthonot cspthon cxp crab wb fveq2
      fveq2d eqeq1d 3anbi123d 3anbi3d 2exbidv elrab a1i 2spthonot eleq2d simpr1
      eqcoms 3ad2ant1 3ad2ant3 adantl sylan9eq 3adant1 simpr2 eqidd simpl simpr
      id 3jca oteqimp imp syl13anc eqeq2 3ad2ant2 3anbi2d mpbid simpr11 wi fvex
      eleq1 mpbii vex ot2ndg syl3anc ad2antlr sylbid com12 3imp impbida adantll
      pm3.2i isspthonpth mp3an2 bicomd 3anbi1d bitrd otel3xp biantrurd 3bitr4rd
      ex anbi2d rexbidva ) EFKDGKLZAEKZBEKZLZLZCABEDUBUDUDZKCAHUEZBUFZMZIUEZJUE
      ZEDUCUDUGZYCUHNZUIMZAUJYDNZMZXTUKYDNZMZBUIYDNZMZOZOZJPIPZLZHEULYBYAXSKZLZ
      HEULABCIDEFGJHUMXRYQYSHEXRXTEKZLZYPYRYBUUAYAYCYDABEDUNUDUDUGZYGUAUEZQNZQN
      ZAMZUUDRNZYJMZUUCRNZBMZOZOZJPIPZUAEEUOEUOZUPZKZYAUUNKZUUBYGYAQNZQNZAMZUUR
      RNZYJMZYARNZBMZOZOZJPIPZLZYRYPUUPUVHUQUUAUUMUVGUAYAUUNUUCYAMZUULUVFIJUVIU
      UKUVEUUBYGUVIUUFUUTUUHUVBUUJUVDUVIUUEUUSAUVIUUDUURQUUCYAQURZUSUTUVIUUGUVA
      YJUVIUUDUURRUVJUSUTUVIUUIUVCBUUCYARURUTVAVBVCVDVEUUAXSUUOYAXRXSUUOMYTUAAB
      IDEFGJVFSVGUUAYPUVGUVHUUAYOUVFIJUUAYOYEYHAMZYFYDNZBMZOZYGUVEOZUVFXQYTYOUV
      OUQXNXQYTLZYOUVOUVPYOLZUVNYGUVEUVQYEUVKUVMUVPYEYGYNVHYOUVKUVPYNYEUVKYGYIY
      KUVKYMUVKYHAUVKVSVIVJVKVLYOUVMUVPYGYNUVMYEYGYNUVLYLBYFUIYDURZYMYIYLBMZYKU
      VSYLBUVSVSVIVKVMVNVLVTUVPYEYGYNVOUVQUUTUVAXTMZUVDOZUVEUVPUWAYOUVPYAYAMZXO
      YTXPUWAUVPYAVPXQXOYTXOXPVQZSXQYTVRXQXPYTXOXPVRZSUWBXOYTXPOUWAAXTBYAEEEWAW
      BWCSUVQUVTUVBUUTUVDYOUVTUVBUQZUVPYNYEUWEYGYKYIUWEYMXTYJUVAWDWEVKVLWFWGVTU
      VPUVOLYEYGYNYEUVKUVMYGUVEUVPWHUVPUVNYGUVEVOUVOYNUVPUVNYGUVEYNYGUVNUVEYNWI
      ZYGUVNYEUVKUVSOZUWFYGUVMUVSYEUVKYGUVLYLBUVRUTVBUWGUWFWIYGUVKUVSUWFYEUVEUV
      KUVSLZYNUVBUUTUWHYNWIUVDUWHUVBYNUWHUVBYKYNUWHUVAXTYJUWHATKZXTTKZBTKZUVTUV
      KUWIUVSUVKYHTKUWIUJYDWJYHATWKWLSUWJUWHHWMVEUVSUWKUVKUVSYLTKUWKUIYDWJYLBTW
      KWLVLAXTBTTTWNWOUTUWHYKYNUWHYKLYIYKYMUWHYIYKUVKYIUVSYIAYHYIVSVISSUWHYKVRU
      VSYMUVKYKYMBYLYMVSVIWPVTXKWQWRWEWRVNVEWQWRWSVLVTWTXAUUAUVNUUBYGUVEUUAUUBU
      VNXRUUBUVNUQZYTXNYCTKZYDTKZLXQUWLUWMUWNIWMJWMXBABYDDYCETFGTXCXDSXEXFXGVCU
      UAUUQUVGUUAUWBXOYTXPUUQUUAYAVPXQXOXNYTUWCWPXRYTVRXQXPXNYTUWDWPAXTBYAEEEXH
      WCXIXGXJXLXMXG $.
  $}

  ${
    $d A b f p $.  $d B b f p $.  $d C b f p $.  $d E b f p $.  $d V b f p $.
    $d R b f p $.  $d S b f p $.  $d X b f p $.  $d Y b f p $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 15-Feb-2018.) $)
    el2wlkonotot0 $p |- ( ( ( V e. X /\ E e. Y ) /\ ( R e. V /\ S e. V ) )
                          -> ( <. A , B , C >. e. ( R ( V 2WalksOnOt E ) S )
         <-> ( A = R /\ C = S /\ E. f E. p ( f ( V Walks E ) p /\ ( # ` f ) = 2
              /\ ( A = ( p ` 0 ) /\ B = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) ) ) $=
      ( vb wcel wa wceq wex wi adantl adantr ex c2wlkonot co cv cwalk wbr chash
      cotp cfv c2 cc0 c1 wrex el2wlkonot wb 19.42vv bicomi rexbii rexcom4 exbii
      w3a 3bitri a1i cop eqcom df-ot eqeq12i bitri cvv opex simpr jca opthg syl
      simpl sylan anbi1d 3bitrd biimpi anim12i simpr1 3anim123d 3ad2ant3 impcom
      simp2 eqtr2 com12 syl6bi imp3a rexlimdva el2wlkonotlem eleq1 mpbird com13
      3jca a1d 3ad2ant2 oteq123d simplr2 eqcoms rspcimedv impbid 2exbidv df-3an
      3imp imp syl6bbr ) HIMGJMNZDHMZEHMZNZNZABCUGZDEHGUAUBUBMXLDLUCZEUGZOZFUCZ
      KUCZHGUDUBUEZXPUFUHUIOZDUJXQUHZOZXMUKXQUHZOZEUIXQUHZOZUTZUTZKPFPNZLHULZXO
      YGNZLHULZKPZFPZADOZCEOZXRXSAXTOZBYBOZCYDOZUTZUTZKPFPZUTZDEXLFGHIJKLUMYIYM
      UNXKYIYJKPZFPZLHULUUCLHULZFPYMYHUUDLHUUDYHXOYGFKUOUPUQUUCLFHURUUEYLFYJLKH
      URUSVAVBXKYMYNYONZYTNZKPFPZUUBXKYKUUGFKXKYKUUGXKYJUUGLHXKXMHMZNZXOYGUUGUU
      JXODAOZXMBOZNZECOZNZYGUUGQUUJXODXMVCZEVCZABVCZCVCZOZUUPUUROZUUNNZUUOXOUUT
      UNUUJXOXNXLOUUTXLXNVDXNUUQXLUUSDXMEVEABCVEVFVGVBUUJUUPVHMZXINZUUTUVBUNXKU
      VDUUIXJUVDXGXJUVCXIUVCXJDXMVIVBXHXIVJVKRSUUPEUURCVHHVLVMUUJUVAUUMUUNXKXHU
      UIUVAUUMUNXJXHXGXHXIVNRDXMABHHVLVOVPVQUUOYGUUGUUOYGNZUUFYTUUOUUFYGUUMYNUU
      NYOUUKYNUULUUKYNDAVDVRSUUNYOECVDVRVSSUVEXRXSYSUUOXRXSYFVTYGXSUUOXRXSYFWDR
      YGUUOYSYFXRUUOYSQXSUUOYFYSUUOYAYPYCYQYEYRUUMYAYPQZUUNUUKUVFUULUUKYAYPDAXT
      WETSSUUMYCYQQZUUNUULUVGUUKUULYCYQXMBYBWETRSUUNYEYRQUUMUUNYEYRECYDWETRWAWF
      WBWCWNVKTWGWHWIUUGXKYKUUGYJXKLBHYTUUFBHMZXRXSYSUUFUVHQZYSXSXRUVIYQYPXSXRU
      VIQQYRXRXSYQUVIXRXSYQUVIQXRXSNZYQUVIUVJYQNZUVHUUFUVKUVHYBHMZUVJUVLYQFGHKW
      JSYQUVHUVLUNUVJBYBHWKRWLWOTTWMWPWMXDWCUUGUULNZYJXKUVMXOYGUVMADBXMCEUUGYNU
      ULUUFYNYTYNYOVNSSUULBXMOZUUGUULUVNXMBVDVRRUUGYOUULUUFYOYTYNYOVJSSWQUVMXRX
      SYFUUGXRUULUUFXRXSYSVTSXRXSYSUUFUULWRUUGUULYFYTUUFUULYFQZYSXRUUFUVOQXSUUL
      UUFYSYFUULUUFYSYFQUULUUFNYPYAYQYCYRYEUUFYPYAQZUULYNUVPYOYNYPYAADXTWETSRUU
      LYQYCQZUUFUVQBXMUVNYQYCBXMYBWETWSSUUFYRYEQZUULYOUVRYNYOYRYECEYDWETRRWATWM
      WBWCXEWNVKWOWTWFXAXBUUBUUFUUANZUUHYNYOUUAXCUUHUVSUUFYTFKUOUPVGXFVQ $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d C f p $.  $d E f p $.  $d V f p $.
    $d X f p $.  $d Y f p $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 15-Feb-2018.) $)
    el2wlkonotot $p |- ( ( ( V e. X /\ E e. Y ) /\ ( A e. V /\ C e. V ) )
                          -> ( <. A , B , C >. e. ( A ( V 2WalksOnOt E ) C )
           <-> E. f E. p ( f ( V Walks E ) p /\ ( # ` f ) = 2
                /\ ( A = ( p ` 0 ) /\ B = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) ) $=
      ( wcel wa co wceq cv cfv c2 w3a wex wb a1i cotp c2wlkonot cwalk wbr chash
      cc0 c1 el2wlkonotot0 df-3an eqid ibar bicomd mp2an 3bitrd ) FGJEHJKAFJCFJ
      KKZABCUAACFEUBLLJAAMZCCMZDNZINZFEUCLUDURUEOPMAUFUSOMBUGUSOMCPUSOMQQIRDRZQ
      ZUPUQKZUTKZUTABCACDEFGHIUHVAVCSUOUPUQUTUITVCUTSZUOUPUQVDAUJCUJVBUTVCVBUTU
      KULUMTUN $.

    $d R f p $.  $d S f p $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 8-Mar-2018.) $)
    el2wlkonotot1 $p |- ( ( ( V e. X /\ E e. Y ) /\ ( R e. V /\ S e. V ) )
        -> ( <. A , B , C >. e. ( R ( V 2WalksOnOt E ) S ) <-> ( A = R /\ C = S
                      /\ <. A , B , C >. e. ( A ( V 2WalksOnOt E ) C ) ) ) ) $=
      ( vf vp wcel wa co wceq cv cfv c2 w3a wb c2wlkonot cwalk wbr chash cc0 c1
      cotp wex el2wlkonotot0 simpll wi eleq1 eqcoms bi2anan9 biimpcd adantl imp
      el2wlkonotot syl2anc bicomd pm5.32da df-3an 3bitr4g bitrd ) GHLFILMZDGLZE
      GLZMZMZABCUGZDEGFUANZNLADOZCEOZJPZKPZGFUBNUCVNUDQROAUEVOQOBUFVOQOCRVOQOSS
      KUHJUHZSZVLVMVJACVKNLZSZABCDEJFGHIKUIVIVLVMMZVPMVTVRMVQVSVIVTVPVRVIVTMZVR
      VPWAVEAGLZCGLZMZVRVPTVEVHVTUJVIVTWDVHVTWDUKVEVTVHWDVLVFWBVMVGWCVFWBTDADAG
      ULUMVGWCTECECGULUMUNUOUPUQABCJFGHIKURUSUTVAVLVMVPVBVLVMVRVBVCVD $.
  $}

  ${
    $d A f p t $.  $d B t $.  $d C f p t $.  $d T t $.  $d E a b c e f p t v $.
    $d V a b c e f p t v $.
    $( If an ordered triple represents a walk of length 2, its components are
       vertices.  (Contributed by Alexander van der Vekens, 19-Feb-2018.) $)
    2wlkonot3v $p |- ( T e. ( A ( V 2WalksOnOt E ) C )
                 -> ( ( V e. _V /\ E e. _V ) /\ ( A e. V /\ C e. V )
                                             /\ T e. ( ( V X. V ) X. V ) ) ) $=
      ( va vb vf vp vt co wcel cvv wa w3a c0 wn cfv cv wceq vv ve c2wlkonot cxp
      vc wne cop cdm wi ne0i df-ov ndmfv syl5eq necon1ai cwlkon chash c1st c2nd
      wbr c2 c1 crab cmpt2 simpl id xpeq12d adantr oveq12 oveqd 3anbi1d 2exbidv
      wex breqd rabeqbidv mpt2eq123dv df-2wlkonot dmeqd eleq2d coprab dmoprabss
      ovmpt2ga sseli opelxp 2wlkonot elrabi simpr 3jca syl5 sylbid expcom sylbi
      ex com12 3adant3 syl df-mpt2 dmeqi eleq2s 3ianor wo df-3or ianor mpt2ndm0
      w3o dm0 eleq2i syl6bb noel pm2.21i syl6bi anor ancri mpt2exga pm2.24d imp
      sylbir jaoi jaoi2 pm2.61i 3syl pm2.43i ) CABEDUCKZKZLZEMLZDMLZNZAELBELNZC
      EEUDZEUDZLZOZYDYCPUFABUGZYBUHZLZYDYLUIZYCCUJYOYCPYOQYCYMYBRPABYBUKYMYBULU
      MUNYEYFFGEEHSZISZFSZGSZEDUOKZKZUSZYQUPRUTTZJSZUQRZUQRZYSTUUFURRVAYRRTZUUE
      URRZYTTOZOZIVLHVLZJYJVBZVCZMLZOZYOYPUIZUUPYOYMUUNUHZLZYPUUPYNUURYMUUPYBUU
      NUAUBEDMMFGUASZUUTYQYRYSYTUUTUBSZUOKZKZUSZUUDUUJOZIVLHVLZJUUTUUTUDZUUTUDZ
      VBZVCZUUNUCMUUTETZUVADTZNZFGUUTUUTUVIEEUUMUVKUVLVDZUVNUVMUVFUULJUVHYJUVKU
      VHYJTUVLUVKUVGYIUUTEUVKUUTEUUTEUVKVEZUVOVFUVOVFVGUVMUVEUUKHIUVMUVDUUCUUDU
      UJUVMUVCUUBYQYRUVMUVBUUAYSYTUUTEUVADUOVHVIVMVJVKVNVOUAJUBHIFGVPZWAVQVRUUS
      UUPYPUUPYPUIZYMYSELYTELNUESUUMTZNFGUEVSZUHZUURYMUVTLYMYILZUVQUVTYIYMUVRFG
      UEEEVTWBUUPUWAYPYEYFUWAYPUIUUOUWAYGYPUWAYHYGYPUIABEEWCYGYHYPYGYHNZYDCYQYR
      ABUUAKUSUUDUUGATUUHUUIBTOOIVLHVLZJYJVBZLZYLUWBYCUWDCJABHDEMMIWDVRUWEYKUWB
      YLUWCJCYJWEUWBYKYLUWBYKNYGYHYKUWBYGYKYGYHVDVGUWBYHYKYGYHWFVGUWBYKWFWGWLWH
      WIWJWKWMWNWMWOUUNUVSFGUEEEUUMWPWQWRWMWIUUPQYEQZYFQZUUOQZXDZUUQYEYFUUOWSUW
      IUWFUWGWTZUWHWTUUQUWFUWGUWHXAUWJUUQUWHUWJUUQUWJQZUWHNUWJYGQZUUQYEYFXBUWLY
      OYMPLZYPUWLYOYMPUHZLUWMUWLYNUWNYMUWLYBPUAUBUVJUCEDMMUVPXCVQVRUWNPYMXEXFXG
      UWMYPYMXHXIXJXPUWKUWHUUQUWKYGUWHUUQUIYEYFXKYGUUOUUQYGYEYENZUUOYEUWOYFYEYE
      YEVEXLVGFGEEUUMMMXMWOXNXPXOXQXRWKWKXSXTYA $.

    $( If an ordered triple represents a simple path of length 2, its
       components are vertices.  (Contributed by Alexander van der Vekens,
       1-Mar-2018.) $)
    2spthonot3v $p |- ( T e. ( A ( V 2SPathOnOt E ) C )
                 -> ( ( V e. _V /\ E e. _V ) /\ ( A e. V /\ C e. V )
                                             /\ T e. ( ( V X. V ) X. V ) ) ) $=
      ( va vb vf vp vt co wcel cvv wa w3a c0 wn cfv cv wceq vv ve c2pthonot cxp
      vc wne cop cdm wi ne0i df-ov ndmfv syl5eq necon1ai cspthon wbr chash c1st
      c2 c2nd c1 wex crab cmpt2 simpl xpeq12d adantr oveq12 oveqd breqd 3anbi1d
      rabeqbidv mpt2eq123dv df-2spthonot ovmpt2ga dmeqd eleq2d coprab dmoprabss
      id 2exbidv sseli opelxp 2spthonot elrabi simpr 3jca ex syl5 sylbid expcom
      sylbi com12 3adant3 syl df-mpt2 dmeqi eleq2s w3o 3ianor wo ianor mpt2ndm0
      df-3or dm0 eleq2i syl6bb noel pm2.21i syl6bi sylbir anor mpt2exga pm2.24d
      ancri imp jaoi jaoi2 pm2.61i 3syl pm2.43i ) CABEDUCKZKZLZEMLZDMLZNZAELBEL
      NZCEEUDZEUDZLZOZYDYCPUFABUGZYBUHZLZYDYLUIZYCCUJYOYCPYOQYCYMYBRPABYBUKYMYB
      ULUMUNYEYFFGEEHSZISZFSZGSZEDUOKZKZUPZYQUQRUSTZJSZURRZURRZYSTUUFUTRVAYRRTZ
      UUEUTRZYTTOZOZIVBHVBZJYJVCZVDZMLZOZYOYPUIZUUPYOYMUUNUHZLZYPUUPYNUURYMUUPY
      BUUNUAUBEDMMFGUASZUUTYQYRYSYTUUTUBSZUOKZKZUPZUUDUUJOZIVBHVBZJUUTUUTUDZUUT
      UDZVCZVDZUUNUCMUUTETZUVADTZNZFGUUTUUTUVIEEUUMUVKUVLVEZUVNUVMUVFUULJUVHYJU
      VKUVHYJTUVLUVKUVGYIUUTEUVKUUTEUUTEUVKVTZUVOVFUVOVFVGUVMUVEUUKHIUVMUVDUUCU
      UDUUJUVMUVCUUBYQYRUVMUVBUUAYSYTUUTEUVADUOVHVIVJVKWAVLVMUAJUBHIFGVNZVOVPVQ
      UUSUUPYPUUPYPUIZYMYSELYTELNUESUUMTZNFGUEVRZUHZUURYMUVTLYMYILZUVQUVTYIYMUV
      RFGUEEEVSWBUUPUWAYPYEYFUWAYPUIUUOUWAYGYPUWAYHYGYPUIABEEWCYGYHYPYGYHNZYDCY
      QYRABUUAKUPUUDUUGATUUHUUIBTOOIVBHVBZJYJVCZLZYLUWBYCUWDCJABHDEMMIWDVQUWEYK
      UWBYLUWCJCYJWEUWBYKYLUWBYKNYGYHYKUWBYGYKYGYHVEVGUWBYHYKYGYHWFVGUWBYKWFWGW
      HWIWJWKWLWMWNWMWOUUNUVSFGUEEEUUMWPWQWRWMWJUUPQYEQZYFQZUUOQZWSZUUQYEYFUUOW
      TUWIUWFUWGXAZUWHXAUUQUWFUWGUWHXDUWJUUQUWHUWJUUQUWJQZUWHNUWJYGQZUUQYEYFXBU
      WLYOYMPLZYPUWLYOYMPUHZLUWMUWLYNUWNYMUWLYBPUAUBUVJUCEDMMUVPXCVPVQUWNPYMXEX
      FXGUWMYPYMXHXIXJXKUWKUWHUUQUWKYGUWHUUQUIYEYFXLYGUUOUUQYGYEYENZUUOYEUWOYFY
      EYEYEVTXOVGFGEEUUMMMXMWOXNXKXPXQXRWLWLXSXTYA $.
  $}

  $( If an ordered tripple represents a walk of length 2, its components are
     vertices.  (Contributed by Alexander van der Vekens, 19-Feb-2018.) $)
  2wlkonotv $p |- ( <. A , B , C >. e. ( A ( V 2WalksOnOt E ) C )
        -> ( ( V e. _V /\ E e. _V ) /\ ( A e. V /\ B e. V /\ C e. V ) ) ) $=
    ( cotp c2wlkonot co wcel cvv wa cxp w3a 2wlkonot3v 3simpb cop eleq1i opelxp
    df-ot sylbi df-3an biimpri sylanb anim2i 3syl ) ABCFZACEDGHHIEJIDJIKZAEIZCE
    IZKZUFEELZELZIZMUGUMKUGUHBEIZUIMZKACUFDENUGUJUMOUMUOUGUMABPZCPZULIZUOUFUQUL
    ABCSQURUPUKIZUIKUOUPCUKERUSUHUNKZUIUOABEERUOUTUIKUHUNUIUAUBUCTTUDUE $.

  ${
    $d T a b t $.  $d E a b t $.  $d V a b t $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 21-Feb-2018.) $)
    el2wlksoton $p |- ( ( V e. X /\ E e. Y ) -> ( T e. ( V 2WalksOt E )
                 <-> E. a e. V E. b e. V T e. ( a ( V 2WalksOnOt E ) b ) ) ) $=
      ( vt wcel wa c2wlkot co cv c2wlkonot wrex cxp crab a1i simpr cvv wb eleq1
      2wlksot eleq2d wceq 2rexbidv elrab 2wlkonot3v simp3d rexlimivv adantl jca
      wi ex impbid2 3bitrd ) CDIBEIJZACBKLZIAHMZFMZGMZCBNLLZIZGCOFCOZHCCPCPZQZI
      ZAVEIZAVBIZGCOFCOZJZVJUQURVFAHBCDEFGUCUDVGVKUAUQVDVJHAVEUSAUEVCVIFGCCUSAV
      BUBUFUGRUQVKVJVHVJSUQVJVKUQVJJVHVJVJVHUQVIVHFGCCVIVHUMUTCIVACIJZVICTIBTIJ
      VLVHUTVAABCUHUIRUJUKUQVJSULUNUOUP $.

    $( A simple path of length 2 between two vertices (in a graph) as ordered
       triple.  (Contributed by Alexander van der Vekens, 1-Mar-2018.) $)
    el2spthsoton $p |- ( ( V e. X /\ E e. Y ) -> ( T e. ( V 2SPathsOt E )
                <-> E. a e. V E. b e. V T e. ( a ( V 2SPathOnOt E ) b ) ) ) $=
      ( vt wcel wa c2spthot co cv c2pthonot wrex cxp crab a1i simpr cvv wb wceq
      2spthsot eleq2d eleq1 2rexbidv wi 2spthonot3v simp3d rexlimivv adantl jca
      elrab ex impbid2 3bitrd ) CDIBEIJZACBKLZIAHMZFMZGMZCBNLLZIZGCOFCOZHCCPCPZ
      QZIZAVEIZAVBIZGCOFCOZJZVJUQURVFAHBCDEFGUCUDVGVKUAUQVDVJHAVEUSAUBVCVIFGCCU
      SAVBUEUFUMRUQVKVJVHVJSUQVJVKUQVJJVHVJVJVHUQVIVHFGCCVIVHUGUTCIVACIJZVICTIB
      TIJVLVHUTVAABCUHUIRUJUKUQVJSULUNUOUP $.
  $}

  ${
    $d T a b c f p $.  $d E a b c f p $.  $d V a b c f p $.  $d X a b c f p $.
    $d Y a b c f p $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 21-Feb-2018.) $)
    el2wlksot $p |- ( ( V e. X /\ E e. Y ) -> ( T e. ( V 2WalksOt E )
         <-> E. a e. V E. b e. V E. c e. V ( T = <. a , b , c >.
                     /\ E. f E. p ( f ( V Walks E ) p /\ ( # ` f ) = 2
           /\ ( a = ( p ` 0 ) /\ b = ( p ` 1 ) /\ c = ( p ` 2 ) ) ) ) ) ) $=
      ( wcel wa co cv wrex wceq cfv c2 w3a wex c2wlkot c2wlkonot cotp cwalk wbr
      chash cc0 c1 el2wlksoton el2wlkonot 2rexbidva rexcom a1i rexbidv 3bitrd
      wb ) DEKCFKLZADCUAMKAHNZJNZDCUBMMKZJDOHDOAURINZUSUCPBNZGNZDCUDMUEVBUFQRPU
      RUGVCQPVAUHVCQPUSRVCQPSSGTBTLZIDOZJDOZHDOVDJDOIDOZHDOACDEFHJUIUQUTVEHJDDU
      RUSABCDEFGIUJUKUQVFVGHDVFVGUPUQVDJIDDULUMUNUO $.

    $( A simple path of length 2 between two vertices (in a graph) as ordered
       triple.  (Contributed by Alexander van der Vekens, 28-Feb-2018.) $)
    el2pthsot $p |- ( ( V e. X /\ E e. Y ) -> ( T e. ( V 2SPathsOt E )
         <-> E. a e. V E. b e. V E. c e. V ( T = <. a , b , c >.
                     /\ E. f E. p ( f ( V SPaths E ) p /\ ( # ` f ) = 2
           /\ ( a = ( p ` 0 ) /\ b = ( p ` 1 ) /\ c = ( p ` 2 ) ) ) ) ) ) $=
      ( wcel wa co cv wrex wceq cfv c2 w3a wex c2spthot c2pthonot wbr chash cc0
      cspath c1 el2spthsoton el2spthonot 2rexbidva wb rexcom a1i rexbidv 3bitrd
      cotp ) DEKCFKLZADCUAMKAHNZJNZDCUBMMKZJDOHDOAURINZUSUPPBNZGNZDCUFMUCVBUDQR
      PURUEVCQPVAUGVCQPUSRVCQPSSGTBTLZIDOZJDOZHDOVDJDOIDOZHDOACDEFHJUHUQUTVEHJD
      DURUSABCDEFGIUIUJUQVFVGHDVFVGUKUQVDJIDDULUMUNUO $.
  $}

  ${
    $d A a b f p t $.  $d B a b f p t $.  $d C a b f p t $.  $d E a b f p t $.
    $d V a b f p t $.  $d X a b f p $.  $d Y a b f p $.
    $( A walk of length 2 between two vertices (in a graph) as ordered triple.
       (Contributed by Alexander van der Vekens, 26-Feb-2018.) $)
    el2wlksotot $p |- ( ( ( V e. X /\ E e. Y ) /\
      ( A e. V /\ B e. V /\ C e. V ) ) -> ( <. A , B , C >. e. ( V 2WalksOt E )
           <-> E. f E. p ( f ( V Walks E ) p /\ ( # ` f ) = 2
                /\ ( A = ( p ` 0 ) /\ B = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) ) $=
      ( vt va vb wcel wa w3a co cv wrex cfv wceq cotp c2wlkot c2wlkonot cxp wbr
      crab cwalk chash c2 cc0 c1 wex 2wlksot adantr eleq2d eleq1 2rexbidv elrab
      a1i eqid otel3xp mpan adantl biantrurd el2wlkonotot0 adantlr simp3 syl6bi
      rexlimdvva el2wlkonotot bicomd 3adantr2 simplr1 simplr3 simpr oveq1 oveq2
      wb rspc2ev syl3anc ex sylbid impbid 3bitr2d bitrd ) FGMEHMNZAFMZBFMZCFMZO
      ZNZABCUAZFEUBPZMWLJQZKQZLQZFEUCPZPZMZLFRKFRZJFFUDFUDZUFZMZDQZIQZFEUGPUEXD
      UHSUITAUJXESTBUKXESTCUIXESTOOIULDULZWKWMXBWLWFWMXBTWJJEFGHKLUMUNUOWKXCWLX
      AMZWLWRMZLFRKFRZNZXIXFXCXJVRWKWTXIJWLXAWNWLTWSXHKLFFWNWLWRUPUQURUSWKXGXIW
      JXGWFWLWLTWJXGWLUTABCWLFFFVAVBVCVDWKXIXFWKXHXFKLFFWKWOFMWPFMNZNXHAWOTZCWP
      TZXFOZXFWFXKXHXNVRWJABCWOWPDEFGHIVEVFXLXMXFVGVHVIWKXFWLACWQPZMZXIWFWGWIXF
      XPVRWHWFWGWINNXPXFABCDEFGHIVJVKVLWKXPXIWKXPNWGWIXPXIWGWHWIWFXPVMWGWHWIWFX
      PVNWKXPVOXHXPWLAWPWQPZMKLACFFWOATWRXQWLWOAWPWQVPUOWPCTXQXOWLWPCAWQVQUOVSV
      TWAWBWCWDWE $.
  $}

  ${
    $d A f p $.  $d B f p $.  $d C f p $.  $d E f i p x $.  $d V f p x $.
    $( A walk of length 2 between two vertices as ordered triple in an
       undirected simple graph.  This theorem would also hold for undirected
       multigraphs, but to proof this the cases ` A = B ` and/or ` B = C ` must
       be considered separately.  (Contributed by Alexander van der Vekens,
       18-Feb-2018.) $)
    usg2wlkonot $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V ) )
                  -> ( <. A , B , C >. e. ( A ( V 2WalksOnOt E ) C )
                       <-> ( { A , B } e. ran E /\ { B , C } e. ran E ) ) ) $=
      ( vf vp wbr wcel w3a wa co cfv c2 wceq cc0 c1 cpr cvv wi cusg cwalk chash
      cotp c2wlkonot cv wex crn usgrav el2wlkonotot expcom 3adant2 impcom sylan
      wb cdm wf cfz pm3.2i is2wlk sylancl preq12 3adant3 eqeq2d 3adant1 anbi12d
      cfzo vex bicomd 3anbi3d wfun usgrafun c0ex prid1 fzo0to2pr eleqtrri mpan2
      ffvelrn fvelrn sylan2 eleq1 syl5ibcom 1ex prid2 anim12d com24 3imp syl6bi
      a1d com14 sylbid exp3acom3r com13 imp exlimdvv 3expib adantr impbid bitrd
      usg2wlk ) EDUAHZAEIZBEIZCEIZJZKZABCUDACEDUELLIZFUFZGUFZEDUBLHZXHUCMNOZAPX
      IMZOZBQXIMZOZCNXIMZOZJZJZGUGFUGZABRZDUHZIZBCRZYBIZKZXAESIDSIKZXEXGXTUOZDE
      UIZXEYGYHXBXDYGYHTXCYGXBXDKYHABCFDESSGUJUKULUMUNXFXTYFXFXSYFFGXAXEXSYFTXS
      XEXAYFXJXKXRXEXAYFTTZXRXJXKYJXAXJXKKZXEXRYFXAYKPNVGLZDUPZXHUQZPNURLEXIUQZ
      PXHMZDMZXLXNRZOZQXHMZDMZXNXPRZOZKZJZXEXRYFTTXAYGXHSIZXISIZKYKUUEUOYIUUFUU
      GFVHGVHUSXIDXHESSSSUTVAXRUUEXEXAYFXRUUEYNYOYQYAOZUUAYDOZKZJYJXRUUDUUJYNYO
      XRUUJUUDXRUUHYSUUIUUCXRYAYRYQXMXOYAYROXQABXLXNVBVCVDXRYDUUBUUAXOXQYDUUBOX
      MBCXNXPVBVEVDVFVIVJYNYOUUJYJYNUUJYJTYOYNXAXEUUJYFXAYNXEUUJYFTZTXAYNKUUKXE
      XADVKZYNUUKDEVLUULYNKZUUHYCUUIYEUUMYQYBIZUUHYCYNUULYPYMIZUUNYNPYLIUUOPPQR
      ZYLPQVMVNVOVPYLYMPXHVRVQYPDVSVTYQYAYBWAWBUUMUUAYBIZUUIYEYNUULYTYMIZUUQYNQ
      YLIUURQUUPYLPQWCWDVOVPYLYMQXHVRVQYTDVSVTUUAYDYBWAWBWEUNWIUKWFWIWGWHWJWKWJ
      WLWGWMWNWOXAYFXTTXEXAYCYEXTABCFDEGWTWPWQWRWS $.

    $( A walk of length 2 between two different vertices as ordered triple
       corresponds to a simple path of length 2 in an undirected simple graph.
       (Contributed by Alexander van der Vekens, 16-Feb-2018.) $)
    usg2wotspth $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V )
             /\ A =/= C ) -> ( <. A , B , C >. e. ( A ( V 2WalksOnOt E ) C )
                       <-> E. f E. p ( f ( V SPaths E ) p /\ ( # ` f ) = 2
                /\ ( A = ( p ` 0 ) /\ B = ( p ` 1 ) /\ C = ( p ` 2 ) ) ) ) ) $=
      ( wbr wcel w3a wne co cfv wceq cc0 c1 cvv wa wi imp cusg cotp cwalk chash
      c2wlkonot cv c2 cspath wb usgrav el2wlkonotot expcom 3adant2 impcom sylan
      wex 3adant3 ccnv wfun simpr1 cdm wf cfz cpr vex pm3.2i is2wlk sylancl crn
      cfzo usgrafun c0ex prid1 fzo0to2pr eleqtrri mpan2 fvelrn sylan2 syl5ibcom
      ffvelrn eleq1 1ex prid2 anim12d simpllr usgraedgrn ex simplll simpl simpr
      wf1 neeq12d biimpd adantl exp31 a1i syl2and adantr com23 f13idfv sylanbrc
      3jca eqid df-f1 sylib simprd syld com24 3imp com12 sylbid com14 com13 a1d
      3impia wlkdvspth syl2anc simpr2 simpr3 ctrail spthispth pthistrl trliswlk
      cpath 3syl 3anim1i impbid1 2exbidv bitrd ) FEUAHZAFIZBFIZCFIZJZACKZJZABCU
      BACFEUELLIZDUFZGUFZFEUCLHZYRUDMUGNZAOYSMZNZBPYSMZNZCUGYSMZNZJZJZGUPDUPZYR
      YSFEUHLHZUUAUUHJZGUPDUPYJYNYQUUJUIZYOYJFQIEQIRZYNUUMEFUJZYNUUNUUMYKYMUUNU
      UMSYLUUNYKYMRUUMABCDEFQQGUKULUMUNUOUQYPUUIUULDGYPUUIUULYPUUIUULYPUUIRZUUK
      UUAUUHUUPYTYSURUSZUUKYPYTUUAUUHUTYPUUIUUQYJYNYOUUIUUQSZYJYOUURSYNUUIYOYJU
      UQYTUUAUUHYOYJUUQSSZUUHYTUUARZUUSYJUUTYOUUHUUQYJUUTOUGVJLZEVAZYRVBZOUGVCL
      ZFYSVBZOYRMZEMZUUBUUDVDZNZPYRMZEMZUUDUUFVDZNZRZJZYOUUHUUQSSZYJUUNYRQIZYSQ
      IZRUUTUVOUIUUOUVQUVRDVEGVEVFYSEYRFQQQQVGVHUVOYJUVPUVCUVEUVNYJUVPSUVCYJUVN
      UVEUVPYJUVCUVNUVEUVPSZSYJUVCRUVNUVHEVIZIZUVLUVTIZRZUVSYJEUSZUVCUVNUWCSEFV
      KUWDUVCRZUVIUWAUVMUWBUWEUVGUVTIZUVIUWAUVCUWDUVFUVBIZUWFUVCOUVAIUWGOOPVDZU
      VAOPVLVMVNVOUVAUVBOYRVTVPUVFEVQVRUVGUVHUVTWAVSUWEUVKUVTIZUVMUWBUVCUWDUVJU
      VBIZUWIUVCPUVAIUWJPUWHUVAOPWBWCVNVOUVAUVBPYRVTVPUVJEVQVRUVKUVLUVTWAVSWDUO
      YJUWCUVSSUVCYJUWCUVEUVPYJUWCRZUVERZYOUUHUUQUWLYORZUUHRZUVEUUQUWNUVDFYSWKZ
      UVEUUQRUWNUVEUUBUUDKZUUBUUFKZUUDUUFKZJZUWOUWKUVEYOUUHWEUWMUUHUWSUWLYOUUHU
      WSSUWLUUHYOUWSUWKUUHYOUWSSSZUVEYJUWCUWTYJUWAUWPUWBUWRUWTYJUWAUWPEUUBUUDFW
      FWGYJUWBUWREUUDUUFFWFWGUWPUWRRZUWTSYJUXAUUHYOUWSUXAUUHRZYORUWPUWQUWRUWPUW
      RUUHYOWHUXBYOUWQUUHYOUWQSZUXAUUCUUGUXCUUEUUCUUGRZYOUWQUXDAUUBCUUFUUCUUGWI
      UUCUUGWJWLWMUMWNTUWPUWRUUHYOWEXBWOWPWQTWRWSTTUVDFYSUVDXCWTXAUVDFYSXDXEXFW
      OWOWRXGULXHXIXJXKXLXJXOXMXNXITYSEYRFXPXQYPYTUUAUUHXRYPYTUUAUUHXSXBWGUUKYT
      UUAUUHUUKYRYSFEYDLHYRYSFEXTLHYTYSEYRFYAYSEYRFYBYSEYRFYCYEYFYGYHYI $.
  $}

  ${
    $d A f p t $.  $d B f p t $.  $d E f p t $.  $d V f p t $.
    $( For two different vertices, a walk of length 2 between these vertices as
       ordered triple is a simple path of length 2 between these vertices as
       ordered triple in an undirected simple graph.  (Contributed by Alexander
       van der Vekens, 2-Mar-2018.) $)
    2pthwlkonot $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V ) /\ A =/= B )
               -> ( A ( V 2SPathOnOt E ) B ) = ( A ( V 2WalksOnOt E ) B ) ) $=
      ( vf vp vt wbr wcel wa w3a cv co cfv wceq c1st c2nd wex wb cvv cusg chash
      wne cspthon c2 c1 cxp crab cwlkon c2pthonot c2wlkonot simpr1 simpl simpr3
      wi usgra2wlkspth syl3anc bicomd ex adantr pm5.32rd 3anass 3bitr4g 2exbidv
      com12 rabbidva usgrav 2spthonot sylan 3adant3 2wlkonot 3eqtr4d ) DCUAHZAD
      IBDIJZABUCZKZELZFLZABDCUDMMHZVQUBNUEOZGLZPNZPNAOWBQNUFVRNOWAQNBOKZKZFRERZ
      GDDUGDUGZUHZVQVRABDCUIMMHZVTWCKZFRERZGWFUHZABDCUJMMZABDCUKMMZVPWEWJGWFVPW
      EWJSWAWFIVPWDWIEFVPVSVTWCJZJWHWNJWDWIVPWNVSWHWNVPVSWHSZVTVPWOUOWCVTVPWOVT
      VPJZWHVSWPVMVTVOWHVSSVTVMVNVOULVTVPUMVTVMVNVOUNABVRCVQDUPUQURUSUTVEVAVSVT
      WCVBWHVTWCVBVCVDUTVFVMVNWLWGOZVOVMDTICTIJZVNWQCDVGZGABECDTTFVHVIVJVMVNWMW
      KOZVOVMWRVNWTWSGABECDTTFVKVIVJVL $.
  $}

  ${
    $d E u w x y $.  $d V u w x y $.  $d X w $.  $d Y w $.
    $( The set of (simple) paths of length 2 (in a graph) is the set of
       (simple) paths of length 2 between any two different vertices.
       (Contributed by Alexander van der Vekens, 27-Feb-2018.) $)
    2wot2wont $p |- ( ( V e. X /\ E e. Y ) -> ( V 2WalksOt E ) =
                 U_ x e. V U_ y e. V ( x ( V 2WalksOnOt E ) y ) ) $=
      ( vu vw wcel wa c2wlkot co cv c2wlkonot wrex cab ciun el2wlksoton rexbidv
      vex weq eleq1 elab syl6bbr eqrdv dfiunv2 syl6eqr ) DEICFIJZDCKLZGMZAMBMDC
      NLLZIZBDOZADOZGPZADBDUKQQUHHUIUOUHHMZUIIUPUKIZBDOZADOZUPUOIUPCDEFABRUNUSG
      UPHTGHUAZUMURADUTULUQBDUJUPUKUBSSUCUDUEABGDDUKUFUG $.
  $}

  ${
    $d E b f i p t $.  $d V b f p t $.  $d X b f p t $.  $d Y b f p t $.
    $( If the set of simple paths of length 2 between two vertices (in a graph)
       is not empty, the two vertices must be not equal.  (Contributed by
       Alexander van der Vekens, 3-Mar-2018.) $)
    2spontn0vne $p |- ( ( X ( V 2SPathOnOt E ) Y ) =/= (/) -> X =/= Y ) $=
      ( vt vb vf vp co wne cv wcel cvv wa w3a wi wceq cfv c2 cc0 vi 2spthonot3v
      c2pthonot c0 wex n0 cxp cotp cspath wbr chash c1 wrex el2spthonot cdm wf1
      cfzo cfz wf caddc cpr wral ccnv wfun wb ctrail isspth istrl2 anbi1d bitrd
      vex mpanr12 adantr df-f1 eqidd oveq2 f1eq123d f13idfv simpr2 sylbi syl6bi
      a1d com3l imp31 simpl simpr neeq12d 3adant2 adantl mpbird exp41 3ad2antl2
      eqid sylbir com12 sylbid 3impd exlimdvv adantld rexlimdva 3adant3 exlimiv
      mpcom ) CDBAUCIIZUDJEKZXDLZEUECDJZEXDUFXFXGEBMLAMLNZCBLDBLNZXEBBUGBUGLZOX
      FXGCDXEABUBXHXIXFXGPXJXHXINZXFXECFKZDUHQZGKZHKZBAUIIUJZXNUKRZSQZCTXORZQZX
      LULXORZQZDSXORZQZOZOZHUEGUEZNZFBUMXGCDXEGABMMHFUNXKYHXGFBXKXLBLZNZYGXGXMY
      JYFXGGHYJXPXRYEXGYJXPTXQUQIZAUOXNUPZTXQURIZBXOUSZUAKZXNRARYOXORYOULUTIXOR
      VAQUAYKVBZOZXOVCVDZNZXRYEXGPPZXKXPYSVEZYIXHUUAXIXHXNMLZXOMLZUUAGVKHVKXHUU
      BUUCNNZXPXNXOBAVFIUJZYRNYSXOAXNBMMMMVGUUDUUEYQYRXOUAAXNBMMMMVHVIVJVLVMVMY
      SYJYTYNYLYRYJYTPZYPYNYRNYMBXOUPZUUFYMBXOVNUUGYJXRYEXGUUGYJNXRNZYENXGXSYCJ
      ZUUHUUIYEUUGYJXRUUIXRUUGYJUUIXRUUGTSURIZBXOUPZYJUUIPXRYMUUJBBXOXOXRXOVOXQ
      STURVPXRBVOVQUUKUUIYJUUKUUJBXOUSZXSYAJZUUIYAYCJZONUUIUUJBXOUUJWMVRUULUUMU
      UIUUNVSVTWBWAWCWDVMYEXGUUIVEZUUHXTYDUUOYBXTYDNCXSDYCXTYDWEXTYDWFWGWHWIWJW
      KWNWLWOWPWQWRWSWTWPXAXCXBVT $.
  $}

  $( A simple path of length 2 between two vertices as ordered triple
     corresponds to two adjacent edges in an undirected simple graph.
     (Contributed by Alexander van der Vekens, 8-Mar-2018.) $)
  usg2spthonot $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V ) )
                       -> ( <. A , B , C >. e. ( A ( V 2SPathOnOt E ) C )
             <-> ( A =/= C /\ { A , B } e. ran E /\ { B , C } e. ran E ) ) ) $=
    ( wcel w3a wa co wne cpr wi wceq simpl adantl syl3anc eleq2d adantr sylbid
    ex cusg wbr cotp c2pthonot c0 ne0i 2spontn0vne c2wlkonot 3simpb 2pthwlkonot
    crn syl usg2wlkonot biimpa 3anass sylanbrc com23 mpcom bicomd anbi2d syl5bb
    wb com12 simpr eqcomd biimpd expimpd impbid ) EDUAUBZAEFZBEFZCEFZGZHZABCUCZ
    ACEDUDIIZFZACJZABKDUKZFZBCKVSFZGZVQVNWBVRVQVNWBLVQVPUEJVRVPVOUFDEACUGULVRVN
    VQWBVRVNVQWBLVRVNHZVQVOACEDUHIIZFZWBWCVPWDVOWCVIVJVLHZVRVPWDMVNVIVRVIVMNZOV
    NWFVRVMWFVIVJVKVLUIOZOVRVNNZACDEUJZPQWCWEWBWCWEHVRVTWAHZWBWCVRWEWIRWCWEWKVN
    WEWKVBVRABCDEUMZOUNVRVTWAUOZUPTSTUQURVCVNWBVRWEHZVQWBVRWKHVNWNWMVNWKWEVRVNW
    EWKWLUSUTVAVNVRWEVQVNVRHZWEVQWOWDVPVOWOVIWFVRWDVPMVNVIVRWGRVNWFVRWHRVNVRVDV
    IWFVRGVPWDWJVEPQVFVGSVH $.

  $( A simple path of length 2 between two vertices as ordered triple
     corresponds to two adjacent edges in an undirected simple graph.
     (Contributed by Alexander van der Vekens, 8-Mar-2018.) $)
  usg2spthonot0 $p |- ( ( V USGrph E /\ ( A e. V /\ B e. V /\ C e. V ) )
                       -> ( <. S , B , T >. e. ( A ( V 2SPathOnOt E ) C )
                 <-> ( ( S = A /\ T = C /\ A =/= C )
                       /\ ( { A , B } e. ran E /\ { B , C } e. ran E ) ) ) ) $=
    ( wcel w3a wa co wceq cpr wi syl adantl cvv wb adantr eleq1 cusg wbr wne c0
    cotp c2pthonot ne0i 2spontn0vne c2wlkonot 3simpb 2pthwlkonot syl3anc eleq2d
    simpl usgrav anim12i el2wlkonotot1 df-3an syl6bb bitrd simpll simpr 3jca ex
    com12 simprrr 3anbi13d mpbird usg2wlkonot syl2anc preq1 eleq1d preq2 biimpd
    crn anbi12d sylbid impancom jcad com23 eqcoms adantld 3adant3 impcom bitr2d
    mpcom pm5.32da ancom bitri anbi1i bicomi anbi2i 3bitri bicomd anbi2d eqcomd
    anass expimpd impbid ) GFUAUBZAGHZBGHZCGHZIZJZDBEUEZACGFUFKKZHZDALZECLZACUC
    ZIZABMZFVOZHZBCMZXNHZJZJZXHXEXSXKXHXEXSNXHXGUDUCXKXGXFUGFGACUHOXKXEXHXSXKXE
    XHXSNXKXEJZXHXIXJJZXFDEGFUIKZKHZJZXSXTXHXFACYBKZHZYDXTXGYEXFXTWTXAXCJZXKXGY
    ELXEWTXKWTXDUNPZXEYGXKXDYGWTXAXBXCUJZPZPXKXEUNACFGUKZULUMXTYFXIXJYCIZYDXTGQ
    HFQHJZYGJZYFYLRZXEYNXKWTYMXDYGFGUOYIUPZPDBEACFGQQUQZOXIXJYCURZUSUTXTYDXLXRX
    KYDXLNXEYDXKXLYAXKXLNYCYAXKXLYAXKJZXIXJXKXIXJXKVAYAXJXKXIXJVBSYAXKVBVCVDSVE
    SYDXTXRYAXTYCXRYAXTJZYCDBMZXNHZBEMZXNHZJZXRYTWTDGHZXBEGHZIZYCUUERZXTWTYAYHP
    YTUUHXDYAXKWTXDVFYAUUHXDRXTYAUUFXAUUGXCXBXIUUFXARXJDAGTSXJUUGXCRXIECGTPVGSV
    HDBEFGVIZVJYAUUEXRNXTYAUUEXRYAUUBXOUUDXQYAUUAXMXNXIUUAXMLXJDABVKSVLYAUUCXPX
    NXJUUCXPLXIECBVMPVLVPZVNSVQVRVEVSVQVDVTWFVEXEXSXKYFJZXHXEXSXKYLJZUULXEXSXLY
    CJZUUMXEXLXRYCXEXLJZYCUUEXRUUOWTUUHUUIWTXDXLVAXLXEUUHXIXJXEUUHNXKYAXDUUHWTY
    AXDUUHYAXAUUFXCUUGXBXIXAUUFRZXJUUPADADGTWASXJXCUUGRZXIUUQCECEGTWAPVGVNWBWCW
    DUUJVJXLUUEXRRZXEXIXJUURXKUUKWCPWEWGUUNXKYAJZYCJXKYDJUUMXLUUSYCXLYSUUSXIXJX
    KURYAXKWHWIWJXKYAYCWQYDYLXKYLYDYRWKWLWMUSXEYLYFXKXEYFYLXEYNYOYPYQOWNWOUTXEX
    KYFXHXEXKJZYFXHUUTYEXGXFUUTWTYGXKYEXGLWTXDXKVAXEYGXKYJSXEXKVBWTYGXKIXGYEYKW
    PULUMVNWRVQWS $.

  ${
    $d A b $.  $d C b $.  $d E b $.  $d T b $.  $d V b $.
    $( A simple path of length 2 between two vertices as ordered triple
       corresponds to two adjacent edges in an undirected simple graph.
       (Contributed by Alexander van der Vekens, 9-Mar-2018.) $)
    usg2spthonot1 $p |- ( ( V USGrph E /\ ( A e. V /\ C e. V ) )
            -> ( T e. ( A ( V 2SPathOnOt E ) C )
                 <-> E. b e. V ( ( T = <. A , b , C >. /\ A =/= C )
                       /\ ( { A , b } e. ran E /\ { b , C } e. ran E ) ) ) ) $=
      ( cusg wbr wcel wa c2pthonot co cv wceq wrex cpr cvv wb anim1i eqidd cotp
      wne crn usgrav el2spthonot0 sylan w3a simplrl simpr simplrr usg2spthonot0
      simpll syl13anc simp3 id 3jca impbii syl6bb anbi2d anass syl6bbr rexbidva
      bitrd ) EDGHZAEIZBEIZJZJZCABEDKLLZIZCAFMZBUAZNZVLVIIZJZFEOZVMABUBZJAVKPDU
      CZIVKBPVRIJZJZFEOVDEQIDQIJVGVJVPRDEUDABCDEQQFUEUFVHVOVTFEVHVKEIZJZVOVMVQV
      SJZJVTWBVNWCVMWBVNAANZBBNZVQUGZVSJZWCWBVDVEWAVFVNWGRVDVGWAULVDVEVFWAUHVHW
      AUIVDVEVFWAUJAVKBABDEUKUMWGWCWFVQVSWDWEVQUNSVQWFVSVQWDWEVQVQATVQBTVQUOUPS
      UQURUSVMVQVSUTVAVBVC $.
  $}

  ${
    $d E p w x y $.  $d V p w x y $.
    $( The set of simple paths of length 2 (in a graph) is the double union of
       the simple paths of length 2 between different vertices.  (Contributed
       by Alexander van der Vekens, 3-Mar-2018.) $)
    2spot2iun2spont $p |- ( ( V e. _V /\ E e. _V ) -> ( V 2SPathsOt E ) =
                U_ x e. V U_ y e. ( V \ { x } ) ( x ( V 2SPathOnOt E ) y ) ) $=
      ( vp vw cvv wcel wa c2spthot c2pthonot csn cdif wrex ciun rexbidv syl6bbr
      co cv wne cab el2spthsoton wi c0 ne0i 2spontn0vne syl necomd a1i pm4.71rd
      rexdifsn vex weq eleq1 elab bitrd eqrdv dfiunv2 syl6eqr ) DGHCGHIZDCJRZES
      ZASZBSZDCKRRZHZBDVCLMZNZADNZEUAZADBVGVEOOUTFVAVJUTFSZVAHVKVEHZBDNZADNZVKV
      JHZVKCDGGABUBUTVNVLBVGNZADNZVOUTVMVPADUTVMVDVCTZVLIZBDNVPUTVLVSBDUTVLVRVL
      VRUCUTVLVCVDVLVEUDTVCVDTVEVKUECDVCVDUFUGUHUIUJPVLBDVCUKQPVIVQEVKFULEFUMZV
      HVPADVTVFVLBVGVBVKVEUNPPUOQUPUQABEDVGVEURUS $.
  $}

  ${
    $d A f p t $.  $d B f p t $.  $d E f p t $.  $d V f p t $.
    $( In a finite graph, the set of simple paths of length 2 between two
       vertices (as ordered triples) is finite.  (Contributed by Alexander van
       der Vekens, 4-Mar-2018.) $)
    2spotfi $p |- ( ( ( V e. Fin /\ E e. X ) /\ ( A e. V /\ B e. V ) )
                    -> ( A ( V 2SPathOnOt E ) B ) e. Fin ) $=
      ( vf vp vt cfn wcel wa co cv cfv wceq c1st c2nd w3a wex cxp c2pthonot wbr
      cspthon chash c2 c1 crab 2spthonot xpfi anidms mpancom rabfi syl ad2antrr
      eqeltrd ) DIJZCEJZKADJBDJKZKABDCUALLFMZGMZABDCUCLLUBUSUDNUEOHMZPNZPNAOVBQ
      NUFUTNOVAQNBORRGSFSZHDDTZDTZUGZIHABFCDIEGUHUPVFIJZUQURUPVEIJZVGVDIJZUPVHU
      PVIDDUIUJVDDUIUKVCHVEULUMUNUO $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
 Vertex Degree
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d E v $.  $d V v $.
    $( In a finite graph, the degree of each vertex is finite.  (Contributed by
       Alexander van der Vekens, 10-Mar-2018.) $)
    usgfidegfi $p |- ( ( V USGrph E /\ V e. Fin )
                      -> A. v e. V ( ( V VDeg E ) ` v ) e. NN0 ) $=
      ( cusg wbr cfn wcel wa cv cvdg co cfv cn0 cdm wfn w3a wf crn wi mpcom wf1
      usgraf1 usgrafis simplrr f1fn adantl dmfi ad2antrr exp31 expcom com13 imp
      3jca vdgrfif syl ffvelrnda ralrimiva ) CBDEZCFGZHZAIZCBJKZLMGACUTCMVAVBUT
      USBBNZOZVCFGZPZCMVBQURUSVFVCBRZBUAZURUSVFSBCUBUSURVHVFURUSVHVFSZBFGZUTVIB
      CUCVJUTVHVFVJUTHZVHHUSVDVEVJURUSVHUDVHVDVKVCVGBUEUFVJVEUTVHBUGUHUMUITUJUK
      TULVCBCFUNUOUPUQ $.
  $}

  ${
    $d K v $.  $d E v $.  $d V v $.
    $( In a finite graph, the degree of each vertex is finite.  (Contributed by
       Alexander van der Vekens, 6-Mar-2018.) $)
    usgfiregdegfi $p |- ( ( V USGrph E /\ V e. Fin /\ V =/= (/) )
                     -> ( A. v e. V ( ( V VDeg E ) ` v ) = K -> K e. NN0 ) ) $=
      ( cusg wbr cfn wcel c0 wne cv cvdg co cfv wceq wral cn0 wi wa usgfidegfi
      r19.26 eleq1 biimpac ralimi wrex c1 c2 1ne2 reximdva0 mpan r19.36zv mpbid
      idd syl5com sylbir ex com23 syl 3impia ) DBEFZDGHZDIJZAKZDBLMNZCOZADPZCQH
      ZRZUTVASVDQHZADPZVBVHRABDTVJVFVBVGVJVFVBVGRZVJVFSVIVESZADPZVKVIVEADUAVMVG
      ADPZVBVGVLVGADVEVIVGVDCQUBUCUDVBVGVGRZADUEZVNVGRUFUGJZVBVPUHVQVOADVQVCDHS
      VGUMUIUJVGVGADUKULUNUOUPUQURUS $.
  $}

  ${
    $d E x $.  $d U x $.  $d V x $.
    $( The value of the vertex degree function for simple undirected graphs in
       terms of edges.  (Contributed by Alexander van der Vekens,
       9-Jul-2018.) $)
    vdusgravaledg $p |- ( ( V USGrph E /\ U e. V ) ->
           ( ( V VDeg E ) ` U ) = ( # ` { x e. V | { U , x } e. ran E } ) ) $=
      ( cusg wbr wcel wa cop cnbgra co chash cfv cvdg cpr crn crab hashnbgravdg
      cv wceq nbusgra adantr fveq2d eqtr3d ) DCEFZBDGZHZDCIBJKZLMBDCNKMBASOCPGA
      DQZLMBCDRUGUHUILUEUHUITUFACBDUAUBUCUD $.
  $}

  ${
    $d E v $.  $d V v $.
    $( In a finite complete undirected simple graph with n vertices every
       vertex has degree (n-1).  (Contributed by Alexander van der Vekens,
       9-Jul-2018.) $)
    usgrauvtxvd $p |- ( ( V USGrph E /\ V e. Fin ) -> ( K e. ( V UnivVertex E )
                        -> ( ( V VDeg E ) ` K ) = ( ( # ` V ) - 1 ) ) ) $=
      ( cusg wbr cfn wcel wa cuvtx co cvdg cfv chash c1 cmin wceq adantl adantr
      cop ex cnbgra csn cdif uvtxnbgra adantlr fveq2 simpl anim12i hashnbgravdg
      uvtxisvtx syl wi hashdifsn syl5com impcom 3eqtr3d mpdan ) CADEZCFGZHZBCAI
      JGZBCAKJLZCMLNOJZPZUTVAHZCASBUAJZCBUBUCZPZVDURVAVHUSABCUDUEVEVHHZVFMLZVGM
      LZVBVCVHVJVKPVEVFVGMUFQVIURBCGZHZVJVBPVEVMVHUTURVAVLURUSUGABCUJZUHRBACUIU
      KVEVKVCPZVHVAUTVOVAVLUTVOVNUSVLVOULURUSVLVOCBUMTQUNUORUPUQT $.
  $}

  ${
    $d E v $.  $d V v $.
    $( In a finite complete undirected simple graph with n vertices every
       vertex has degree (n-1).  (Contributed by Alexander van der Vekens,
       9-Jul-2018.) $)
    vdcusgra $p |- ( ( V ComplUSGrph E /\ V e. Fin )
                     -> A. v e. V ( ( V VDeg E ) ` v ) = ( ( # ` V ) - 1 ) ) $=
      ( ccusgra wbr cfn wcel wa cv cvdg co cfv chash c1 cmin wceq cnbgra adantr
      cop csn cdif nbcusgra adantlr cusisusgra hashnbgravdg sylan fveq2 adantll
      cusg hashdifsn sylan9eqr eqtr3d mpdan ralrimiva ) CBDEZCFGZHZAIZCBJKLZCML
      NOKZPZACUQURCGZHZCBSURQKZCURTUAZPZVAUOVBVFUPBURCUBUCVCVFHVDMLZUSUTVCVGUSP
      ZVFUQCBUIEZVBVHUOVIUPBCUDRURBCUEUFRVFVCVGVEMLZUTVDVEMUGUPVBVJUTPUOCURUJUH
      UKULUMUN $.
  $}

  ${
    $d E v $.  $d N v $.  $d V v $.
    $( The number of the neighbors of a vertex in a finite undirected simple
       graph is a nonnegative integer.  (Contributed by Alexander van der
       Vekens, 14-Jul-2018.) $)
    nbhashnn0 $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                      -> ( # ` ( <. V , E >. Neighbors N ) ) e. NN0 ) $=
      ( vv cusg wbr cfn wcel w3a cop cnbgra co chash cfv cvdg wceq hashnbgravdg
      cn0 3adant2 cv wral usgfidegfi 3adant3 wi fveq2 eleq1d rspcva ex 3ad2ant3
      mpd eqeltrd ) CAEFZCGHZBCHZIZCAJBKLMNZBCAOLZNZRULUNUPURPUMBACQSUODTZUQNZR
      HZDCUAZURRHZULUMVBUNDACUBUCUNULVBVCUDUMUNVBVCVAVCDBCUSBPUTURRUSBUQUEUFUGU
      HUIUJUK $.
  $}

  $( If the number of the neighbors of a vertex in a finite graph is the number
     of vertices of the graph minus 1, each vertex except the first mentioned
     vertex is a neighbor of this vertex.  (Contributed by Alexander van der
     Vekens, 14-Jul-2018.) $)
  nbhashuvtx1 $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                   -> ( ( # ` ( <. V , E >. Neighbors N ) ) = ( ( # ` V ) - 1 )
                        -> ( ( M e. V /\ M =/= N )
                             -> M e. ( <. V , E >. Neighbors N ) ) ) ) $=
    ( co wcel wbr chash cfv c1 cmin wceq wa wi cle ex 3ad2ant2 c2 wb cz cop cfn
    cnbgra cusg w3a wne ax-1 a1d wn wnel df-nel cpr cdif wss nbgrassvwo2 difexg
    3ad2ant1 cvv hashss syl simpl2 simpl simp3 syl2anr hashssdif syl2anc simprr
    prssi hashprg mpbid oveq2d eqtrd breq2d nbhashnn0 nn0z hashcl peano2zm 3syl
    clt cn0 zltlem1 caddc nn0cnd ax-1cn a1i subsub4d 1p1e2 oveq2i syl6eq adantr
    cc bitrd cr nn0red simpr ltned eqneqall com12 syl6 sylbid com23 com34 3syld
    sylbird sylbir pm2.61i ) BDAUACUCEZFZDAUDGZDUBFZCDFZUEZXGHIZDHIZJKEZLZBDFZB
    CUFZMZXHNZNZNZXHYAXLXHXTXPXHXSUGUHUHXHUIBXGUJZYBBXGUKXLYCYAXLYCXGDBCULZUMZU
    NZXMYEHIZOGZYAXIXJYCYFNXKXIYCYFABCDUOPUQXLYEURFZYFYHNXJXIYIXKDYDUBUPQYIYFYH
    YEXGURUSPUTXLYHXSXPXHXLXSYHXPXHNZXLXSYHYJNXLXSMZYHXMXNRKEZOGZYJYKYGYLXMOYKY
    GXNYDHIZKEZYLYKXJYDDUNZYGYOLXIXJXKXSVAXSXQXKYPXLXQXRVBZXIXJXKVCZBCDVHVDDYDV
    EVFYKYNRXNKYKXRYNRLZXLXQXRVGXSXQXKXRYSSXLYQYRBCDVIVDVJVKVLVMYKYMXMXOVSGZYJX
    LYTYMSXSXLYTXMXOJKEZOGZYMXLXMTFZXOTFZYTUUBSXLXMVTFUUCACDVNZXMVOUTXJXIUUDXKX
    JXNVTFXNTFUUDDVPZXNVOXNVQVRQXMXOWAVFXLUUAYLXMOXLUUAXNJJWBEZKEYLXLXNJJXJXIXN
    WKFXKXJXNUUFWCQJWKFXLWDWEZUUHWFUUGRXNKWGWHWIVMWLWJYKYTXMXOUFZYJYKYTUUIYKYTM
    XMXOYKXMWMFZYTXLUUJXSXLXMUUEWNWJWJYKYTWOWPPXPUUIXHXHXMXOWQWRWSXDWTPXAXBXCWR
    XEXF $.

  ${
    $d E v $.  $d N v $.  $d V v $.
    $( If the number of the neighbors of a vertex in a graph is the number of
       vertices of the graph minus 1, the vertex is universal.  (Contributed by
       Alexander van der Vekens, 14-Jul-2018.) $)
    nbhashuvtx $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                   -> ( ( # ` ( <. V , E >. Neighbors N ) ) = ( ( # ` V ) - 1 )
                        -> N e. ( V UnivVertex E ) ) ) $=
      ( vv cusg wbr cfn wcel w3a cop cnbgra co chash cfv c1 cmin wceq wa adantr
      wi cuvtx csn cdif cv nbgrassvwo sseld 3ad2ant1 eldifsn nbhashuvtx1 syl5bi
      wne imp impbid eqrdv wb uvtxnb 3adant2 mpbird ex ) CAEFZCGHZBCHZIZCAJBKLZ
      MNCMNOPLQZBCAUALHZVCVERZVFVDCBUBUCZQZVGDVDVHVGDUDZVDHZVJVHHZVCVKVLTZVEUTV
      AVMVBUTVDVHVJABCUEUFUGSVLVJCHVJBUKRZVGVKVJCBUHVCVEVNVKTAVJBCUIULUJUMUNVCV
      FVIUOZVEUTVBVOVAABCUPUQSURUS $.
  $}

  $( A universal vertex has ` n - 1 ` neighbors in a graph with ` n ` vertices,
     a biconditional version of ~ uvtxnm1nbgra .  (Contributed by Alexander van
     der Vekens, 14-Jul-2018.) $)
  uvtxhashnb $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
        -> ( N e. ( V UnivVertex E )
             <-> ( # ` ( <. V , E >. Neighbors N ) ) = ( ( # ` V ) - 1 ) ) ) $=
    ( cusg wbr cfn wcel w3a cuvtx co cop cnbgra chash c1 cmin wceq uvtxnm1nbgra
    cfv wi 3adant3 nbhashuvtx impbid ) CADEZCFGZBCGZHBCAIJGZCAKBLJMRCMRNOJPZUCU
    DUFUGSUEABCQTABCUAUB $.

  $( In a finite undirected simple graph with n vertices a vertex is universal
     if the vertex has degree ` n - 1 ` .  (Contributed by Alexander van der
     Vekens, 14-Jul-2018.) $)
  usgrauvtxvdbi $p |- ( ( V USGrph E /\ V e. Fin /\ K e. V )
                       -> ( K e. ( V UnivVertex E )
                            <-> ( ( V VDeg E ) ` K ) = ( ( # ` V ) - 1 ) ) ) $=
    ( cusg wbr cfn wcel w3a cuvtx co cop cnbgra chash cmin wceq cvdg uvtxhashnb
    cfv c1 hashnbgravdg 3adant2 eqeq1d bitrd ) CADEZCFGZBCGZHZBCAIJGCAKBLJMRZCM
    RSNJZOBCAPJRZUIOABCQUGUHUJUIUDUFUHUJOUEBACTUAUBUC $.

  ${
    $d E n v $.  $d V n v $.
    $( In a finite complete undirected simple graph with n vertices every
       vertex has degree ` n - 1 ` .  (Contributed by Alexander van der Vekens,
       14-Jul-2018.) $)
    vdiscusgra $p |- ( ( V USGrph E /\ V e. Fin )
                       -> ( A. v e. V ( ( V VDeg E ) ` v ) = ( ( # ` V ) - 1 )
                            -> V ComplUSGrph E ) ) $=
      ( vn cusg wbr cfn wcel wa cv cvdg co cfv chash wceq simpr ad2antrr mpbird
      wb ex c1 cmin wral ccusgra cuvtx uvtxisvtx weq fveq2 eqeq1d rspcva expcom
      wi adantl imp simplll usgrauvtxvdbi syl3anc impbid2 eqrdv cusgrauvtxb ) C
      BEFZCGHZIZAJZCBKLZMZCNMUAUBLZOZACUCZCBUDFZVCVIIZVJCBUELZCOZVKDVLCVKDJZVLH
      ZVNCHZBVNCUFVKVPVOVKVPIZVOVNVEMZVGOZVKVPVSVIVPVSULVCVPVIVSVHVSAVNCADUGVFV
      RVGVDVNVEUHUIUJUKUMUNVQVAVBVPVOVSSVAVBVIVPUOVCVBVIVPVAVBPQVKVPPBVNCUPUQRT
      URUSVAVJVMSVBVIBCUTQRT $.
  $}

  ${
    $d E e p v w $.  $d V e p v w $.
    $( If every vertex in a simple graph has degree 0, there is no edge in the
       graph.  (Contributed by Alexander van der Vekens, 12-Jul-2018.) $)
    usgravd00 $p |- ( V USGrph E -> ( A. v e. V ( ( V VDeg E ) ` v ) = 0
                                      -> E = (/) ) ) $=
      ( ve vp vw cdm cv chash cfv c2 wceq wral c0 wi wa wcel wrex wn syl cpw co
      crab wf1 cusg wbr cvdg cc0 usgraf0 wf f1f crn simpll usgravd0nedg adantll
      cpr ralimdva ralnex exprelprel a1i con3d syl5bi syld imp f0rn0 syl2anc wb
      wrel frel reldm0 ad2antrr mpbird exp31 mpcom ) BGZDHIJKLDCUAUCZBUDZCBUEUF
      ZAHZCBUGUBJUHLZACMZBNLZOZDBCUIVQVOVPBUJZVRWCOVOVPBUKWDVRWAWBWDVRPZWAPZWBV
      ONLZWFWDEHBULZQEVPRZSZWGWDVRWAUMWEWAWJWEWAVSFHUPWHQFCRZSZACMZWJWEVTWLACVR
      VSCQVTWLOWDFVSBCUNUOUQWMWKACRZSWEWJWKACURWEWIWNWIWNOWEFADCWHEUSUTVAVBVCVD
      EBVOVPVEVFWDWBWGVGZVRWAWDBVHWOVOVPBVIBVJTVKVLVMTVN $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
 Regular graphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $c RegGrph $.
  $c RegUSGrph $.

  $( Extend class notation to include the class of all regular graphs. $)
  crgra $a class RegGrph $.
  $( Extend class notation to include the class of all regular undirected
     simple graphs. $)
  crusgra $a class RegUSGrph $.

  ${
    $d e v k p $.
    $( Define the set of k-regular "graphs".  (Contributed by Alexander van der
       Vekens, 6-Jul-2018.) $)
    df-rgra $a |- RegGrph = { <. <. v , e >. , k >. | ( k e. NN0
                              /\ A. p e. v ( ( v VDeg e ) ` p ) = k ) } $.

    $( Define the set of k-regular undirected simple graphs.  (Contributed by
       Alexander van der Vekens, 6-Jul-2018.) $)
    df-rusgra $a |- RegUSGrph = { <. <. v , e >. , k >. | ( v USGrph e
         /\ <. v , e >. RegGrph k ) } $.
  $}

  ${
    $d E e k p v $.  $d K e k p v $.  $d V e k p v $.
    $( The property of being a k-regular graph.  (Contributed by Alexander van
       der Vekens, 7-Jul-2018.) $)
    isrgra $p |- ( ( V e. X /\ E e. Y /\ K e. Z ) -> ( <. V , E >. RegGrph K
                  <-> ( K e. NN0 /\ A. p e. V ( ( V VDeg E ) ` p ) = K ) ) ) $=
      ( vk vv ve cop crgra wcel w3a cn0 cv cvdg co wceq wa wbr cfv df-br coprab
      wral df-rgra eleq2i wb eleq1 3ad2ant3 simp1 oveq12 fveq1d 3adant3 eqeq12d
      simp3 raleqbidv anbi12d eloprabga syl5bb ) CAKZBLUAVABKZLMZCDMAEMBFMNZBOM
      ZGPZCAQRZUBZBSZGCUEZTZVABLUCVCVBHPZOMZVFIPZJPZQRZUBZVLSZGVNUEZTZIJHUDZMVD
      VKLWAVBIJHGUFUGVTVKIJHCABDEFVNCSZVOASZVLBSZNZVMVEVSVJWDWBVMVEUHWCVLBOUIUJ
      WEVRVIGVNCWBWCWDUKWEVQVHVLBWBWCVQVHSWDWBWCTVFVPVGVNCVOAQULUMUNWBWCWDUPUOU
      QURUSUTUT $.

    $( The property of being a k-regular undirected simple graph.  (Contributed
       by Alexander van der Vekens, 7-Jul-2018.) $)
    isrusgra $p |- ( ( V e. X /\ E e. Y /\ K e. Z )
                     -> ( <. V , E >. RegUSGrph K
                          <-> ( V USGrph E /\ K e. NN0
                                /\ A. p e. V ( ( V VDeg E ) ` p ) = K ) ) ) $=
      ( vv ve vk wcel w3a cop crusgra wbr cusg cv wceq wa crgra cn0 cvdg co cfv
      wral coprab df-br df-rusgra eleq2i bitri wb breq12 3adant3 opeq12 breq12d
      simp3 anbi12d eloprabga syl5bb isrgra anbi2d bitrd 3anass syl6bbr ) CDKAE
      KBFKLZCAMZBNOZCAPOZBUAKZGQCAUBUCUDBRGCUEZSZSZVHVIVJLVEVGVHVFBTOZSZVLVGVFB
      MZHQZIQZPOZVPVQMZJQZTOZSZHIJUFZKZVEVNVGVONKWDVFBNUGNWCVOHIJUHUIUJWBVNHIJC
      ABDEFVPCRZVQARZVTBRZLZVRVHWAVMWEWFVRVHUKWGVPCVQAPULUMWHVSVFVTBTWEWFVSVFRW
      GVPVQCAUNUMWEWFWGUPUOUQURUSVEVMVKVHABCDEFGUTVAVBVHVIVJVCVD $.

    $( The properties of a k-regular graph.  (Contributed by Alexander van der
       Vekens, 8-Jul-2018.) $)
    rgraprop $p |- ( <. V , E >. RegGrph K -> ( K e. NN0
                                   /\ A. p e. V ( ( V VDeg E ) ` p ) = K ) ) $=
      ( vk vv ve cvv wcel w3a crgra wbr cn0 cv cvdg co cfv wceq wral wa df-rgra
      cop coprab breqi oprabv sylbi isrgra biimpd mpcom ) CHIAHIBHIJZCAUBZBKLZB
      MIDNZCAOPQBRDCSTZULUKBENZMIUMFNZGNOPQUORDUPSTZFGEUCZLUJUKBKURFGEDUAUDUQFG
      ECABUEUFUJULUNABCHHHDUGUHUI $.

    $( The properties of a k-regular undirected simple graph.  (Contributed by
       Alexander van der Vekens, 8-Jul-2018.) $)
    rusgraprop $p |- ( <. V , E >. RegUSGrph K -> ( V USGrph E /\ K e. NN0
                                   /\ A. p e. V ( ( V VDeg E ) ` p ) = K ) ) $=
      ( vv ve vk cvv wcel w3a cop crusgra wbr cusg cn0 cv cvdg co cfv wceq wral
      crgra wa coprab df-rusgra breqi oprabv sylbi isrusgra biimpd mpcom ) CHIA
      HIBHIJZCAKZBLMZCANMBOIDPCAQRSBTDCUAJZUNUMBEPZFPZNMUPUQKGPUBMUCZEFGUDZMULU
      MBLUSEFGUEUFUREFGCABUGUHULUNUOABCHHHDUIUJUK $.

    $( A k-regular undirected simple graph is a k-regular graph.  (Contributed
       by Alexander van der Vekens, 8-Jul-2018.) $)
    rusgrargra $p |- ( <. V , E >. RegUSGrph K -> <. V , E >. RegGrph K ) $=
      ( vv ve vk vp cvv wcel w3a cop crusgra wbr crgra cv cusg coprab df-rusgra
      wa breqi oprabv sylbi cn0 cvdg co cfv wceq wral isrusgra biimprcd 3adant1
      wi isrgra com12 sylbid mpcom ) CHIAHIBHIJZCAKZBLMZURBNMZUSURBDOZEOZPMVAVB
      KFONMSZDEFQZMUQURBLVDDEFRTVCDEFCABUAUBUQUSCAPMZBUCIZGOCAUDUEUFBUGGCUHZJZU
      TABCHHHGUIVHUQUTVFVGUQUTULVEUQUTVFVGSABCHHHGUMUJUKUNUOUP $.
  $}

  ${
    $d E p $.  $d K p $.  $d V p $.
    $( Any k-regular undirected simple graph is an undirected simple graph.
       (Contributed by Alexander van der Vekens, 8-Jul-2018.) $)
    rusisusgra $p |- ( <. V , E >. RegUSGrph K -> V USGrph E ) $=
      ( vp cop crusgra wbr cusg cn0 wcel cv cvdg co wceq wral rusgraprop simp1d
      cfv ) CAEBFGCAHGBIJDKCALMRBNDCOABCDPQ $.
  $}

  ${
    $d p v $.
    $( A graph is 0-regular if it has no edges.  (Contributed by Alexander van
       der Vekens, 8-Jul-2018.) $)
    0egra0rgra $p |- A. v <. v , (/) >. RegGrph 0 $=
      ( vp cv c0 cop cc0 crgra wbr cvv wcel vex 0ex c0ex w3a cn0 cvdg wceq wral
      co cfv 0nn0 a1i wel wi vdgr0 ex 3ad2ant1 ralrimiv isrgra mpbir2and ax-gen
      mp3an ) ACZDEFGHZAUMIJZDIJZFIJZUNAKLMUOUPUQNZUNFOJZBCZUMDPSTFQZBUMRUSURUA
      UBURVABUMUOUPBAUCZVAUDUQUOVBVAUTUMIUEUFUGUHDFUMIIIBUIUJULUK $.
  $}

  ${
    $d E k p $.  $d V k $.
    $( A graph with no vertices is k-regular for every k.  (Contributed by
       Alexander van der Vekens, 10-Jul-2018.) $)
    0vgrargra $p |- ( E e. V -> A. k e. NN0 <. (/) , E >. RegGrph k ) $=
      ( vp wcel c0 cop cv crgra wbr cn0 wa cvdg co cfv wceq wral simpr ral0 cvv
      a1i wb 0ex isrgra mp3an1 mpbir2and ralrimiva ) BCEZFBGAHZIJZAKUHUIKEZLZUJ
      UKDHFBMNOUIPZDFQZUHUKRUNULUMDSUAFTEUHUKUJUKUNLUBUCBUIFTCKDUDUEUFUG $.
  $}

  ${
    $d E v $.  $d V v $.
    $( A complete undirected simple graph with n vertices (at least one) is
       (n-1)-regular.  (Contributed by Alexander van der Vekens,
       10-Jul-2018.) $)
    cusgraisrusgra $p |- ( ( V ComplUSGrph E /\ V e. Fin /\ V =/= (/) )
                           -> <. V , E >. RegUSGrph ( ( # ` V ) - 1 ) ) $=
      ( vv ccusgra wbr cfn wcel chash cfv c1 cmin co wceq wa adantr imp syl cvv
      wral w3a c0 wne cop crusgra cv cnbgra csn cdif wi nbcusgra ralrimiva cusg
      cn0 cvdg cusisusgra hashnncl nnm1nn0 syl6bir ad2antlr anim1i hashnbgravdg
      cn fveq2 simprl hashdifsn sylan sylan9eqr eqtr3d ralimdva usgrav ovex a1i
      ex wb df-3an sylanbrc isrusgra mpbir3and expcom exp3a mpcom 3impib ) BADE
      ZBFGZBUAUBZBAUCZBHIZJKLZUDEZWFCUEZUFLZBWJUGUHZMZCBSZWCWDWENZWIUIWCWMCBAWJ
      BUJUKWNWCWOWIWCWONZWNWIWPWNNZWIBAULEZWHUMGZWJBAUNLIZWHMZCBSZWPWRWNWCWRWOA
      BUOZOZOWOWSWCWNWDWEWSWDWEWGVBGWSBUPWGUQURPUSWPWNXBWPWMXACBWPWJBGZNZWMXAXF
      WMNZWKHIZWTWHXGWRXENZXHWTMXFXIWMWPWRXEXDUTOWJABVAQWMXFXHWLHIZWHWKWLHVCWPW
      DXEXJWHMWCWDWEVDBWJVEVFVGVHVMVIPWQBRGZARGZWHRGZTZWIWRWSXBTVNWPXNWNWPXKXLN
      ZXMXNWCXOWOWCWRXOXCABVJQOXMWPWGJKVKVLXKXLXMVOVPOAWHBRRRCVQQVRVSVTWAWB $.
  $}

  ${
    $d E v $.  $d V v $.
    $( An undirected simple graph is 0-regular iff it has no edges.
       (Contributed by Alexander van der Vekens, 12-Jul-2018.) $)
    0eusgraiff0rgra $p |- ( V USGrph E
                            -> ( <. V , E >. RegGrph 0 <-> E = (/) ) ) $=
      ( vv cusg wbr cop cc0 crgra c0 wceq cn0 wcel cv wa wi com12 adantl breq1d
      syl cvv cvdg co cfv wral rgraprop usgravd00 usgrav 0egra0rgra id wb opeq1
      wal spcdv mpi opeq2 syl5ibrcom adantr impbid ) BADEZBAFZGHEZAIJZVAUSVBVAG
      KLZCMZBAUAUBUCGJCBUDZNUSVBOZAGBCUEVEVFVCUSVEVBCABUFPQSPUSBTLZATLZNVBVAOZA
      BUGVGVIVHVGVAVBBIFZGHEZVGVDIFZGHEZCULVKCUHVGVMVKCBTVGUIVDBJZVMVKUJVGVNVLV
      JGHVDBIUKRQUMUNVBUTVJGHAIBUORUPUQSUR $.

    $( A finite undirected simple graph with n vertices is complete iff it is
       (n-1)-regular.  Hint:  If the definition of ` RegGrph ` allowed for
       ` k e. ZZ ` , then the assumption ` V =/= (/) ` could be removed.
       Furthermore, if the definition of ` RegGrph ` also allowed for
       ` k e. ( ZZ u. { +oo } ) ` , then the theorem would also hold for
       inifinite graphs.  (Contributed by Alexander van der Vekens,
       14-Jul-2018.) $)
    cusgraiffrusgra $p |- ( ( V USGrph E /\ V e. Fin /\ V =/= (/) )
        -> ( V ComplUSGrph E <-> <. V , E >. RegUSGrph ( ( # ` V ) - 1 ) ) ) $=
      ( vv cusg wbr cfn wcel c0 wne w3a ccusgra cop chash c1 cmin co crusgra wi
      cfv cusgraisrusgra a1d 3exp com14 3imp cv cvdg wceq cn0 rusgraprop simp3d
      wral vdiscusgra 3adant3 syl5 impbid ) BADEZBFGZBHIZJZBAKEZBALBMSNOPZQEZUP
      UQURUTVBRUTUQURUPVBUTUQURUPVBRUTUQURJVBUPABTUAUBUCUDVBCUEBAUFPSVAUGCBUKZU
      SUTVBUPVAUHGVCAVABCUIUJUPUQVCUTRURCABULUMUNUO $.
  $}

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
                        Friendship graphs
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
In this section, the basics for the friendship theorem, which is one from the
"100 theorem list" (#83), are provided, including the definition of
friendship graphs ~ df-frgra as special undirected simple graphs without
loops (see ~ frisusgra ) and the proofs of the friendship theorem for small
graphs (with up to 3 vertices), see ~ 1to3vfriendship . The general friendship
theorem, which should be called "friendship", but which is still to be proven,
would be ` |- ( V =/= (/) -> ( V FriendGrph E
                -> E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E ) ) ` .
The case ` V = (/) ` (a graph without vertices) must be excluded either from
the definition of a friendship graph, or from the theorem. If it is not
excluded from the definition, which is the case with ~ df-frgra , a graph
without vertices is a friendship graph (see ~ frgra0 ), but the
friendship condition ` E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E `
does not hold (because of ` -. E. x e. (/) ph ` , see ~ rex0 ).

Further results of this sections are: Any graph with exactly one vertex is a
friendship graph, see ~ frgra1v , any graph with exactly 2 (different)
vertices is not a friendship graph, see ~ frgra2v , a graph with exactly 3
(different) vertices is a friendship graph if and only if it is a complete
graph (every two vertices are connected by an edge), see ~ frgra3v , and
every friendship graph (with 1 or 3 vertices) is a windmill graph, see
~ 1to3vfriswmgra (The generalization of this theorem "Every friendship graph
(with at least one vertex) is a windmill graph" is a stronger result than the
"friendship theorem". This generalization was proven by Mertzios and Unger, see
Theorem 1 of [MertziosUnger] p. 152.).

The first steps to prove the friendship theorem following the approach of
Mertzios and Unger are already made, see ~ 2pthfrgrarn2 and ~ n4cyclfrgra
(these theorems correspond to Proposition 1 of [MertziosUnger] p. 153.). In
addition, the first three Lemmas ("claims") in the proof of [Huneke] p. 1 are
proven, see ~ frgrancvvdgeq , ~ frgraregorufr and ~ frgregordn0 .
$)

  $c FriendGrph $.

  $( Extend class notation with Friendship Graphs. $)
  cfrgra $a class FriendGrph $.

  ${
    $d e v k l x $.
    $( Define the class of all Friendship Graphs.  A graph is called a
       friendship graph if every pair of its vertices has exactly one common
       neighbor.  (Contributed by Alexander van der Vekens and Mario Carneiro,
       2-Oct-2017.) $)
    df-frgra $a |- FriendGrph = { <. v , e >. | ( v USGrph e
                      /\ A. k e. v A. l e. ( v \ { k } )
                            E! x e. v { { x , k } , { x , l } } C_ ran e ) } $.
  $}

  ${
    $d V e k l v x $.  $d E k l v e x $.
    $( The property of being a friendship graph.  (Contributed by Alexander van
       der Vekens, 4-Oct-2017.) $)
    isfrgra $p |- ( ( V e. X /\ E e. Y ) -> ( V FriendGrph E
            <-> ( V USGrph E /\ A. k e. V A. l e. ( V \ { k } )
                  E! x e. V { { x , k } , { x , l } } C_ ran E ) ) ) $=
      ( vv ve cv cusg wbr cpr crn wss wreu cdif wral wa wceq csn cfrgra anbi12d
      breq1 difeq1 reueq1 raleqbidv raleqbi1dv sseq2d reubidv 2ralbidv df-frgra
      breq2 rneq brabg ) HJZIJZKLZAJZBJZMUSGJMMZUQNZOZAUPPZGUPUTUAZQZRZBUPRZSDU
      QKLZVCADPZGDVEQZRZBDRZSDCKLZVACNZOZADPZGVKRBDRZSHIDCEFUBUPDTZURVIVHVMUPDU
      QKUDVGVLBUPDVSVDVJGVFVKUPDVEUEVCAUPDUFUGUHUCUQCTZVIVNVMVRUQCDKUMVTVJVQBGD
      VKVTVCVPADVTVBVOVAUQCUNUIUJUKUCAHIBGULUO $.
  $}

  ${
    $d e k l v x $.  $d V k l x $.  $d E k l x $.
    $( A friendship graph is an undirected simple graph without loops with
       special properties.  (Contributed by Alexander van der Vekens,
       4-Oct-2017.) $)
    frisusgrapr $p |- ( V FriendGrph E ->
                      ( V USGrph E /\ A. k e. V A. l e. ( V \ { k } )
                  E! x e. V { { x , k } , { x , l } } C_ ran E ) ) $=
      ( vv ve cfrgra wbr cusg cv cpr crn wss wreu cdif wral wa cvv wcel isfrgra
      csn wb df-frgra relopabi brrelexi brrelex2i syl2anc ibi ) DCHIZDCJIAKZBKZ
      LUKEKLLZCMNADOEDULUBZPQBDQRZUJDSTCSTUJUOUCDCHFKZGKZJIUMUQMNAUPOEUPUNPQBUP
      QRFGHAFGBEUDUEZUFDCHURUGABCDSSEUAUHUI $.
  $}

  ${
    $d V k l x $.  $d E k l x $.
    $( A friendship graph is an undirected simple graph without loops.
       (Contributed by Alexander van der Vekens, 4-Oct-2017.) $)
    frisusgra $p |- ( V FriendGrph E -> V USGrph E ) $=
      ( vx vk cfrgra wbr cusg cpr crn wss wreu csn cdif wral frisusgrapr simpld
      vl cv ) BAEFBAGFCRZDRZHSQRHHAIJCBKQBTLMNDBNCDABQOP $.
  $}

  ${
    $d E k l x $.
    $( Any graph with no vertex is a friendship graph if and only if the edge
       function is empty.  (Contributed by Alexander van der Vekens,
       4-Oct-2017.) $)
    frgra0v $p |- ( (/) FriendGrph E <-> E = (/) ) $=
      ( vx vk vl c0 cfrgra wbr wceq cusg frisusgra usgra0v sylib cv cpr crn wss
      wral cvv wcel 0ex wreu csn cdif biimpri ral0 a1i wa eleq1 isfrgra sylancr
      wb mpbiri mpbir2and impbii ) EAFGZAEHZUOEAIGZUPAEJAKZLUPUOUQBMZCMZNUSDMNN
      AOPBEUADEUTUBUCQZCEQZUQUPURUDVBUPVACUEUFUPERSZARSZUOUQVBUGUKTUPVDVCTAERUH
      ULBCAERRDUIUJUMUN $.
  $}

  $( Any empty graph (graph without vertices) is a friendship graph.
     (Contributed by Alexander van der Vekens, 30-Sep-2017.) $)
  frgra0 $p |- (/) FriendGrph (/) $=
    ( c0 cfrgra wbr wceq eqid frgra0v mpbir ) AABCAADAEAFG $.

  ${
    $d A a b c $.  $d C a b c $.  $d E a b c $.  $d V a b c $.
    $( Any two (different) vertices in a friendship graph have a unique common
       neighbor.  (Contributed by Alexander van der Vekens, 19-Dec-2017.) $)
    frgraunss $p |- ( V FriendGrph E -> ( ( A e. V /\ C e. V /\ A =/= C )
                      -> E! b e. V { { A , b } , { b , C } } C_ ran E ) ) $=
      ( va vc wbr cv cpr wss wreu csn cdif wral wa wcel wi ex syl cusg crn wceq
      cfrgra wne frisusgrapr sneq difeq2d preq2 preq1d sseq1d reubidv raleqbidv
      w3a rspcva elsni eqcomd necon3ai anim2i eldif sylibr preq2d preq1i sseq1i
      wn prcom reubii sylib com13 com24 3imp com12 adantl ) DCUDHDCUAHZEIZFIZJZ
      VOGIZJZJZCUBZKZEDLZGDVPMZNZOZFDOZPADQZBDQZABUEZUNZAVOJZVOBJZJZWAKZEDLZRZE
      FCDGUFWGWQVNWKWGWPWHWIWJWGWPRWHWGWJWIWPWHWGWJWIWPRRZWHWGPVOAJZVSJZWAKZEDL
      ZGDAMZNZOZWRWFXEFADVPAUCZWCXBGWEXDXFWDXCDVPAUGUHXFWBXAEDXFVTWTWAXFVQWSVSV
      PAVOUIUJUKULUMUOWIWJXEWPWIWJXEWPRZWIWJPZBXDQZXGXHWIBXCQZVEZPXIWJXKWIXJABX
      JBABAUPUQURUSBDXCUTVAXIXEWPXIXEPWSWMJZWAKZEDLZWPXBXNGBXDVRBUCZXAXMEDXOWTX
      LWAXOVSWMWSVRBVOUIVBUKULUOXMWOEDXLWNWAWSWLWMVOAVFVCVDVGVHSTSVITSVJVKVLVMT
      $.

    $( Any two (different) vertices in a friendship graph have a unique common
       neighbor.  (Contributed by Alexander van der Vekens, 19-Dec-2017.) $)
    frgraun $p |- ( V FriendGrph E -> ( ( A e. V /\ C e. V /\ A =/= C )
               -> E! b e. V ( { A , b } e. ran E /\ { b , C } e. ran E ) ) ) $=
      ( cfrgra wbr wcel wne w3a cv cpr crn wss wreu frgraunss prex prss bicomi
      wa reubii syl6ib ) DCFGADHBDHABIJAEKZLZUCBLZLCMZNZEDOUDUFHUEUFHTZEDOABCDE
      PUGUHEDUHUGUDUEUFAUCQUCBQRSUAUB $.
  $}

  ${
    $d V k l n x $.  $d E k l n x $.
    $( In a friendship graph, the neighborhoods of two different vertices have
       exactly one vertex in common.  (Contributed by Alexander van der Vekens,
       19-Dec-2017.) $)
    frisusgranb $p |- ( V FriendGrph E ->
              A. k e. V A. l e. ( V \ { k } ) E. x e. V
   ( ( <. V , E >. Neighbors k ) i^i ( <. V , E >. Neighbors l ) ) = { x } ) $=
      ( vn wbr cv cpr wss csn wral wa cnbgra co cin wceq wcel crab wex cusg crn
      cfrgra wreu cdif cop wrex frisusgrapr ssrab2 sseq1 vex snss sylibr adantl
      mpbii nbusgra ineq12d ad3antrrr inrab syl6eq prcom eleq1i anbi12i zfpair2
      wb prss bitri a1i rabbidva adantr simpr 3eqtrd jca ex eximdv reusn df-rex
      3imtr4g ralimdva imp syl ) DCUCGDCUAGZFHZBHZIZWCEHZIZICUBZJZFDUDZEDWDKUEZ
      LZBDLZMDCUFZWDNOZWNWFNOZPZAHZKZQZADUGZEWKLZBDLZFBCDEUHWBWMXCWBWLXBBDWBWDD
      RZMZWJXAEWKXEWFWKRZMZWIFDSZWSQZATWRDRZWTMZATWJXAXGXIXKAXGXIXKXGXIMZXJWTXI
      XJXGXIWSDJZXJXIXHDJXMWIFDUIXHWSDUJUOWRDAUKULUMUNXLWQWDWCIZWHRZWFWCIZWHRZM
      ZFDSZXHWSXLWQXOFDSZXQFDSZPZXSWBWQYBQXDXFXIWBWOXTWPYAFCWDDUPFCWFDUPUQURXOX
      QFDUSUTXGXSXHQXIXGXRWIFDXRWIVEXGWCDRMXRWEWHRZWGWHRZMWIXOYCXQYDXNWEWHWDWCV
      AVBXPWGWHWFWCVAVBVCWEWGWHFBVDFEVDVFVGVHVIVJXGXIVKVLVMVNVOWIFADVPWTADVQVRV
      SVSVTWA $.
  $}

  ${
    $d V k l x $.  $d E k l x $.
    $( Any graph with only one vertex is a friendship graph.  (Contributed by
       Alexander van der Vekens, 4-Oct-2017.) $)
    frgra1v $p |- ( ( V e. X /\ { V } USGrph E ) -> { V } FriendGrph E ) $=
      ( vx vk vl csn cusg wbr wcel cvv wa cv cpr wss wreu cdif wral c0 wb difid
      cfrgra wi usgrav simplr ral0 wceq sneq difeq2d syl6eq preq2 preq1d sseq1d
      reubidv raleqbidv ralsng adantl mpbiri isfrgra ad2antrr mpbir2and mpancom
      crn ex impcom ) BGZAHIZBCJZVFAUBIZVFKJAKJLZVGVHVIUCAVFUDVJVGLZVHVIVKVHLZV
      IVGDMZEMZNZVMFMNZNZAVCZOZDVFPZFVFVNGZQZRZEVFRZVJVGVHUEVLWDVMBNZVPNZVROZDV
      FPZFSRZWHFUFVHWDWITVKWCWIEBCVNBUGZVTWHFWBSWJWBVFVFQSWJWAVFVFVNBUHUIVFUAUJ
      WJVSWGDVFWJVQWFVRWJVOWEVPVNBVMUKULUMUNUOUPUQURVJVIVGWDLTVGVHDEAVFKKFUSUTV
      AVDVBVE $.
  $}

  ${
    $d A k l x $.  $d B k l x $.  $d E k l x $.  $d X k l x $.  $d Y k l x $.
    $( Any graph with two (different) vertices is not a friendship graph.
       (Contributed by Alexander van der Vekens, 30-Sep-2017.) $)
    frgra2v $p |- ( ( ( A e. X /\ B e. Y ) /\ A =/= B )
                   -> -. { A , B } FriendGrph E ) $=
      ( vx vk vl cpr wcel wa wn wss crio wceq wrex adantl wb sseq1d mpbird cusg
      wbr wne cfrgra wi cv crn wreu csn cdif wral cund cfv wrmo eqid usgraedgrn
      prex prss neneqd expcom sylbir com12 mt2i adantr jca preq1 preq12d notbid
      ralprg ad2antrr ralnex sylib intnanrd reu5 sylnibr riotaundb preq2 preq2d
      wo riotabidv eqeq1d rexsng olcd difprsn1 rexeqdv difprsn2 orbi12d difeq2d
      preq1d rexeqbidv rexprg rexnal a1i rexbidv syl5bbr intnand usgrav isfrgra
      sneq cvv syl mtbird frisusgra con3i a1d pm2.61i ) ABIZCUAUBZADJZBEJZKZABU
      CZKZXGCUDUBZLZUEXMXHXOXMXHKZXNXHFUFZGUFZIZXQHUFZIZIZCUGZMZFXGUHZHXGXRUIZU
      JZUKZGXGUKZKZXPYIXHXPYILZYDFXGNZXGULUMZOZHYGPZGXGPZXPYPXQAIZYAIZYCMZFXGNZ
      YMOZHXGAUIZUJZPZXQBIZYAIZYCMZFXGNZYMOZHXGBUIZUJZPZVSZXPUUMUUAHUUJPZUUIHUU
      BPZVSZXPUUOUUNXPUUOUUEYQIZYCMZFXGNZYMOZXPUURFXGUHZLUUTXPUURFXGPZUURFXGUNZ
      KUVAXPUVBUVCXPUURLZFXGUKZUVBLXPUVEXGAAIZIZYCMZLZBBIZBAIZIZYCMZLZKZXHUVOXM
      XHUVIUVNXHUVHAAOZAUOUVHXHUVPLZUVHXGYCJZUVFYCJZKXHUVQUEZXGUVFYCABUQZAAUQUR
      UVSUVTUVRXHUVSUVQXHUVSKAACAAXGUPUSUTQVAVBVCXHUVMBBOZBUOUVMXHUWBLZUVMUVJYC
      JZUVKYCJZKXHUWCUEZUVJUVKYCBBUQBAUQURUWDUWFUWEXHUWDUWCXHUWDKBBCBBXGUPUSUTV
      DVAVBVCVEQXKUVEUVORXLXHUVDUVIUVNFABDEXQAOZUURUVHUWGUUQUVGYCUWGUUEXGYQUVFX
      QABVFXQAAVFVGSVHXQBOZUURUVMUWHUUQUVLYCUWHUUEUVJYQUVKXQBBVFXQBAVFVGSVHVIVJ
      TUURFXGVKVLVMUURFXGVNVOUURFXGUWAVPVLXKUUOUUTRZXLXHXIUWIXJUUIUUTHADXTAOZUU
      HUUSYMUWJUUGUURFXGUWJUUFUUQYCUWJYAYQUUEXTAXQVQVRSVTWAWBVDVJTWCXMUUMUUPRXH
      XMUUDUUNUULUUOXMUUAHUUCUUJXLUUCUUJOXKABWDQWEXMUUIHUUKUUBXLUUKUUBOXKABWFQW
      EWGVDTXKYPUUMRXLXHYOUUDUULGABDEXRAOZYNUUAHYGUUCUWKYFUUBXGXRAWSWHUWKYLYTYM
      UWKYDYSFXGUWKYBYRYCUWKXSYQYAXRAXQVQWISVTWAWJXRBOZYNUUIHYGUUKUWLYFUUJXGXRB
      WSWHUWLYLUUHYMUWLYDUUGFXGUWLYBUUFYCUWLXSUUEYAXRBXQVQWISVTWAWJWKVJTYKYHLZG
      XGPXPYPYHGXGWLXPUWMYOGXGUWMYELZHYGPXPYOYEHYGWLXPUWNYNHYGUWNYNRXPYDFXGUWAV
      PWMWNWOWNWOTWPXPXGWTJCWTJKZXNYJRXHUWOXMCXGWQQFGCXGWTWTHWRXAXBUTXHLXOXMXNX
      HCXGXCXDXEXF $.
  $}

  ${
    $d A k l x y $.  $d B k l x y $.  $d C k l x y $.  $d E k l x y $.
    $d X k l x y $.  $d Y k l x y $.  $d Z k l x y $.
    $( Lemma 1 for ~ frgra3v .  (Contributed by Alexander van der Vekens,
       4-Oct-2017.) $)
    frgra3vlem1 $p |- ( ( ( ( A e. X /\ B e. Y /\ C e. Z )
          /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
          /\ { A , B , C } USGrph E ) -> A. x A. y
             ( ( ( x e. { A , B , C } /\ { { x , A } , { x , B } } C_ ran E )
              /\ ( y e. { A , B , C } /\ { { y , A } , { y , B } } C_ ran E ) )
          -> x = y ) ) $=
      ( wcel wa cpr wi wceq a1ii preq1 eqeq2 imbi2d 3imtr4d sylbi w3a cusg eltp
      wne ctp wbr cv crn wss weq w3o vex eqidd a1i preq12d prex prss usgraedgrn
      sseq1d wn df-ne eqid pm2.24i syl expcom adantr sylbir adantld 3jaoi eqeq1
      imbi12d syl5ibr adantl a1d pm2.21 ee10 com13 com12 com3l imp31 alrimivv
      imp ) CGJDHJEIJUAZCDUDCEUDDEUDUAZKZCDEUEZFUBUFZKZAUGZWFJZWICLZWIDLZLZFUHZ
      UIZKBUGZWFJZWPCLZWPDLZLZWNUIZKZKZABUJZMABXCWHXDWJWOXBWHXDMZWJWICNZWIDNZWI
      ENZUKZWOXBXEMMWICDEAULUCXBXIWOXEWQXAXIWOXEMZMZWQWPCNZWPDNZWPENZUKZXAXKMWP
      CDEBULUCXIXOXAXJXFXOXAXJMZMXGXHXOXPXFXACCLZCDLZLZWNUIZWHCWPNZMZMZMZXLYDXM
      XNXLXTXTWHCCNZMZMZXAYCXLXTYGYFXTWHCUMUNOXLWTXSWNXLWRXQWSXRWPCCPWPCDPUOUSZ
      XLYBYFXTXLYAYEWHWPCCQRRSXMDCLZDDLZLZWNUIZXTWHCDNZMZMZXAYCXMYLYOXTWGYMWEXT
      XQWNJZXRWNJZKZWGYMMZXQXRWNCCUPCDUPUQZYPYSYQWGYPYMWGYPKZCCUDZYMFCCWFURZUUB
      YEUTZYMCCVAZYEYMCVBZVCTVDVEVFVGVHOXMWTYKWNXMWRYIWSYJWPDCPWPDDPUOUSZXMYBYN
      XTXMYAYMWHWPDCQRRSXNECLZEDLZLZWNUIZXTWHCENZMZMZXAYCXNUUKUUNXTWGUULWEXTYRW
      GUULMZYTYPUUOYQWGYPUULUUAUUBUULUUCUUBUUDUULUUEYEUULUUFVCTVDVEVFVGVHOXNWTU
      UJWNXNWRUUHWSUUIWPECPWPEDPUOUSZXNYBUUMXTXNYAUULWHWPECQRRSVIXFXJYCXAXFWOXT
      XEYBXFWMXSWNXFWKXQWLXRWICCPWICDPUOUSXFXDYAWHWICWPVJRVKRVLXOXPXGXAYLWHDWPN
      ZMZMZMZXLUUTXMXNXLXTYLWHDCNZMZMZXAUUSXLXTUVCYLWGUVAWEYLYIWNJZYJWNJZKZWGUV
      AMZYIYJWNDCUPDDUPUQZUVEUVGUVDWGUVEUVAWGUVEKZDDUDZUVAFDDWFURZUVJDDNZUTZUVA
      DDVAZUVLUVADVBZVCTVDVEVMVGVHOYHXLUURUVBYLXLUUQUVAWHWPCDQRRSXMYLYLWHUVLMZM
      ZXAUUSXMYLUVQUVPYLWHDUMUNOUUGXMUURUVPYLXMUUQUVLWHWPDDQRRSXNUUKYLWHDENZMZM
      ZXAUUSXNUUKUVTYLWGUVRWEYLUVFWGUVRMZUVHUVEUWAUVDWGUVEUVRUVIUVJUVRUVKUVJUVM
      UVRUVNUVLUVRUVOVCTVDVEVMVGVHOUUPXNUURUVSYLXNUUQUVRWHWPEDQRRSVIXGXJUUSXAXG
      WOYLXEUURXGWMYKWNXGWKYIWLYJWIDCPWIDDPUOUSXGXDUUQWHWIDWPVJRVKRVLXOXPXHXAUU
      KWHEWPNZMZMZMZXLUWEXMXNXLXTUUKWHECNZMZMZXAUWDXTUWHMXLXTUWGUUKXTWGUWFWEXTY
      RWGUWFMZYTYPUWIYQWGYPUWFUUAUUBUWFUUCUUBUUDUWFUUEYEUWFUUFVCTVDVEVFVGVHVNUN
      YHXLUWCUWGUUKXLUWBUWFWHWPCEQRRSXMYLUUKWHEDNZMZMZXAUWDYLUWLMXMYLUWKUUKWHYL
      UWJWEWGYLUWJMZWCWGUWMMWDYLWGWCUWJYLUVFWGWCUWJMZMZUVHUVEUWOUVDWGUVEUWNUVIU
      VJUVLUWNUVKUVOUVJUVMUVLUWNMUVNUVLUWNVOTVPVEVMVGVQVFWBVRVNUNUUGXMUWCUWKUUK
      XMUWBUWJWHWPDEQRRSXNUUKUUKWHEENZMZMZXAUWDXNUUKUWRUWQUUKWHEUMUNOUUPXNUWCUW
      QUUKXNUWBUWPWHWPEEQRRSVIXHXJUWDXAXHWOUUKXEUWCXHWMUUJWNXHWKUUHWLUUIWIECPWI
      EDPUOUSXHXDUWBWHWIEWPVJRVKRVLVIVSTWBVSTVTVRWA $.

    $( Lemma 2 for ~ frgra3v .  (Contributed by Alexander van der Vekens,
       4-Oct-2017.) $)
    frgra3vlem2 $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
             /\ ( A =/= B /\ A =/= C /\ B =/= C ) ) -> ( { A , B , C } USGrph E
                 -> ( E! x e. { A , B , C } { { x , A } , { x , B } } C_ ran E
                      <-> ( { C , A } e. ran E /\ { C , B } e. ran E ) ) ) ) $=
      ( vy wcel wne wa cpr wss wi preq1 preq12d sseq1d wceq prex w3a ctp wbr cv
      cusg crn wb weu df-reu wex weq wal eleq1 anbi12d eu4 frgra3vlem1 biantrud
      wreu w3o vex eltp prss usgraedgrn wn df-ne pm2.24i sylbi syl adantl com12
      eqid ex adantr sylbir syl6bi ax-1 3jaoi imp exlimdv prssi 3mix3 ad3antrrr
      wrex rextpg mpbird df-rex sylib impbid bitr3d syl5bb ) BFJCGJDHJUAZBCKBDK
      CDKUAZLZBCDUBZEUEUCZAUDZBMZWPCMZMZEUFZNZAWNURZDBMZWTJDCMZWTJLZUGXBWPWNJZX
      ALZAUHZWMWOLZXEXAAWNUIXHXGAUJZXGIUDZWNJZXKBMZXKCMZMZWTNZLZLAIUKZOIULAULZL
      ZXIXEXGXQAIXRXFXLXAXPWPXKWNUMXRWSXOWTXRWQXMWRXNWPXKBPWPXKCPQRUNUOXIXJXTXE
      XIXSXJAIBCDEFGHUPUQXIXJXEXIXGXEAXGXIXEXFXAXIXEOZXFWPBSZWPCSZWPDSZUSXAYAOZ
      WPBCDAUTVAYBYEYCYDYBXABBMZBCMZMZWTNZYAYBWSYHWTYBWQYFWRYGWPBBPWPBCPQRZYIYF
      WTJZYGWTJZLYAYFYGWTBBTBCTVBYKYAYLXIYKXEWOYKXEOWMWOYKXEWOYKLBBKZXEEBBWNVCY
      MBBSZVDXEBBVEYNXEBVKVFVGVHVLVIVJVMVNVOYCXACBMZCCMZMZWTNZYAYCWSYQWTYCWQYOW
      RYPWPCBPWPCCPQRZYRYOWTJZYPWTJZLYAYOYPWTCBTCCTVBUUAYAYTXIUUAXEWOUUAXEOWMWO
      UUAXEWOUUALCCKZXEECCWNVCUUBCCSZVDXECCVEUUCXECVKVFVGVHVLVIVJVIVNVOYDXAXCXD
      MZWTNZYAYDWSUUDWTYDWQXCWRXDWPDBPWPDCPQRZUUEXEYAXCXDWTDBTDCTVBXEXIVPVNVOVQ
      VGVRVJVSXIXEXJXIXELZXAAWNWCZXJUUGUUHYIYRUUEUSZUUGUUEUUIXEUUEXIXCXDWTVTVIU
      UEYIYRWAVHWKUUHUUIUGWLWOXEXAYIYRUUEABCDFGHYJYSUUFWDWBWEXAAWNWFWGVLWHWIWJW
      JVL $.

    $( Any graph with three vertices which are completely connected with each
       other is a friendship graph.  (Contributed by Alexander van der Vekens,
       5-Oct-2017.) $)
    frgra3v $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                      /\ ( A =/= B /\ A =/= C /\ B =/= C ) )
                    -> ( { A , B , C } USGrph E
                         -> ( { A , B , C } FriendGrph E
                              <-> ( { A , B } e. ran E /\ { B , C } e. ran E
                                 /\ { C , A } e. ran E ) ) ) ) $=
      ( vx vl wcel w3a wa cusg cpr wb wss wreu wceq sseq1d 3anbi123i vk wne ctp
      wbr cfrgra crn cv csn cdif wral cvv usgrav isfrgra syl adantl ibar bitr4d
      sneq difeq2d preq2 preq1d reubidv raleqbidv raltpg adantr tprot a1i necom
      difeq1d biimpi anim12i 3adant3 diftpsn3 eqtrd raleqdv id anim12ci 3adant2
      eqcomi 3adant1 3anbi123d preq2d ralprg ancoms frgra3vlem2 3ancomb 3ancoma
      3bitrd biid bitri anbi12i tpcomb breq1i reueq1 mp1i bitrd syl2anb anbi12d
      imp 3anrot bitr3i tpcoma biimpri syl2an 3anrev 3com13 eqtri eleq1i anbi2i
      prcom anandir bitr4i df-3an 3bitri anabs1 anidm ex ) AEJZBFJZCGJZKZABUBZA
      CUBZBCUBZKZLZABCUCZDMUDZYGDUEUDZABNZDUFZJZBCNZYKJZCANZYKJZKZOYFYHLZYIHUGZ
      UAUGZNZYSIUGZNZNZYKPZHYGQZIYGYTUHZUIZUJZUAYGUJZYSANZYSBNZNZYKPZHYGQZUUKYS
      CNZNZYKPZHYGQZLZUULUUPNZYKPZHYGQZUULUUKNZYKPZHYGQZLZUUPUUKNZYKPZHYGQZUUPU
      ULNZYKPZHYGQZLZKZYQYRYIYHUUJLZUUJYHYIUVPOZYFYHYGUKJDUKJLUVQDYGULHUADYGUKU
      KIUMUNUOYHUUJUVPOYFYHUUJUPUOUQYRUUJUUKUUCNZYKPZHYGQZIYGAUHZUIZUJZUULUUCNZ
      YKPZHYGQZIYGBUHZUIZUJZUUPUUCNZYKPZHYGQZIYGCUHZUIZUJZKZUVTIYMUJZUWFIYOUJZU
      WLIYJUJZKZUVOYFUUJUWPOZYHYAUXAYEUUIUWCUWIUWOUAABCEFGYTARZUUFUVTIUUHUWBUXB
      UUGUWAYGYTAURUSUXBUUEUVSHYGUXBUUDUVRYKUXBUUAUUKUUCYTAYSUTVASVBVCYTBRZUUFU
      WFIUUHUWHUXCUUGUWGYGYTBURUSUXCUUEUWEHYGUXCUUDUWDYKUXCUUAUULUUCYTBYSUTVASV
      BVCYTCRZUUFUWLIUUHUWNUXDUUGUWMYGYTCURUSUXDUUEUWKHYGUXDUUDUWJYKUXDUUAUUPUU
      CYTCYSUTVASVBVCVDVEVEYFUWPUWTOZYHYEUXEYAYEUWCUWQUWIUWRUWOUWSYEUVTIUWBYMYE
      UWBBCAUCZUWAUIZYMYEYGUXFUWAYGUXFRZYEABCVFZVGVIYEBAUBZCAUBZLZUXGYMRYBYCUXL
      YDYBUXJYCUXKYBUXJABVHZVJYCUXKACVHZVJVKVLBCAVMUNVNVOYEUWFIUWHYOYEUWHCABUCZ
      UWGUIZYOYEYGUXOUWGYGUXORZYEUXOYGCABVFVSZVGVIYECBUBZYBLZUXPYORYBYDUXTYCYBY
      BYDUXSYBVPYDUXSBCVHZVJVQVRCABVMUNVNVOYEUWLIUWNYJYCYDUWNYJRYBABCVMVTVOWAUO
      VEYFUWTUVOOZYHYAUYBYEYAUWQUUTUWRUVGUWSUVNXSXTUWQUUTOXRUVTUUOUUSIBCFGUUBBR
      ZUVSUUNHYGUYCUVRUUMYKUYCUUCUULUUKUUBBYSUTZWBSVBUUBCRZUVSUURHYGUYEUVRUUQYK
      UYEUUCUUPUUKUUBCYSUTZWBSVBWCVTXRXTUWRUVGOZXSXTXRUYGUWFUVCUVFICAGEUYEUWEUV
      BHYGUYEUWDUVAYKUYEUUCUUPUULUYFWBSVBUUBARZUWEUVEHYGUYHUWDUVDYKUYHUUCUUKUUL
      UUBAYSUTZWBSVBWCWDVRXRXSUWSUVNOXTUWLUVJUVMIABEFUYHUWKUVIHYGUYHUWJUVHYKUYH
      UUCUUKUUPUYIWBSVBUYCUWKUVLHYGUYCUWJUVKYKUYCUUCUULUUPUYDWBSVBWCVLWAVEVEWHY
      RUVOYPCBNZYKJZLZBANZYKJZYNLZLZYLACNZYKJZLZUYKYPLZLZYNUYNLZUYRYLLZLZKZYQYR
      UUTUYPUVGVUAUVNVUDYRUUOUYLUUSUYOYFYHUUOUYLOHABCDEFGWEWSYFXRXTXSKZYCYBUXSK
      ZLZACBUCZDMUDZUUSUYOOYHYAVUFYEVUGXRXSXTWFYEYCYBYDKVUGYBYCYDWGYCYCYBYBYDUX
      SYCWIZYBWIZUYATWJWKYGVUIDMABCWLZWMVUHVUJLZUUSUURHVUIQZUYOYGVUIRUUSVUOOVUN
      VUMUURHYGVUIWNWOVUHVUJVUOUYOOHACBDEGFWEWSWPWQWRYRUVCUYSUVFUYTYFXSXTXRKZYD
      UXJUXKKZLZUXFDMUDZUVCUYSOYHYAVUPYEVUQXRXSXTWTYEYDYBYCKVUQYDYBYCWTYDYDYBUX
      JYCUXKYDWIZUXMUXNTXAWKYGUXFDMUXIWMVURVUSLZUVCUVBHUXFQZUYSUXHUVCVVBOVVAUXI
      UVBHYGUXFWNWOVURVUSVVBUYSOHBCADFGEWEWSWPWQYFXSXRXTKZUXJYDYCKZLZBACUCZDMUD
      ZUVFUYTOYHYAVVCYEVVDXRXSXTWGYEYBYDYCKVVDYBYCYDWFYBUXJYDYDYCYCUXMVUTVUKTWJ
      WKYGVVFDMABCXBZWMVVEVVGLZUVFUVEHVVFQZUYTYGVVFRUVFVVJOVVIVVHUVEHYGVVFWNWOV
      VEVVGVVJUYTOHBACDFEGWEWSWPWQWRYRUVJVUBUVMVUCYFXTXRXSKZUXKUXSYBKZLZUXODMUD
      ZUVJVUBOYHYAVVKYEVVLVVKYAXTXRXSWTXCYEVVLYEYCYDYBKVVLYBYCYDWTYCUXKYDUXSYBY
      BUXNUYAVULTWJVJVKYHVVNYGUXODMUXRWMVJVVMVVNLZUVJUVIHUXOQZVUBUXQUVJVVPOVVOU
      XRUVIHYGUXOWNWOVVMVVNVVPVUBOHCABDGEFWEWSWPXDYFXTXSXRKZUXSUXKUXJKZLZCBAUCZ
      DMUDZUVMVUCOYHYAVVQYEVVRYAVVQXRXSXTXEVJYDYCYBVVRYDYCYBKVVRYDUXSYCUXKYBUXJ
      UYAUXNUXMTVJXFVKYHVWAYGVVTDMYGUXFVVTUXIBCAXBXGZWMVJVVSVWALZUVMUVLHVVTQZVU
      CYGVVTRUVMVWDOVWCVWBUVLHYGVVTWNWOVVSVWAVWDVUCOHCBADGFEWEWSWPXDWRWAVUEYQOY
      RVUEYPUYNLUYKLZYLUYKLUYRLZYNUYRLUYNLZKYQYQYQKZYQUYPVWEVUAVWFVUDVWGUYPUYLU
      YNUYKLZLVWEUYOVWIUYLYNUYKUYNYMUYJYKBCXJXHXIXIYPUYNUYKXKXLVUAUYSUYKUYRLZLV
      WFUYTVWJUYSYPUYRUYKYOUYQYKCAXJXHXIXIYLUYKUYRXKXLVUDVUBUYRUYNLZLVWGVUCVWKV
      UBYLUYNUYRYJUYMYKABXJXHXIXIYNUYRUYNXKXLTVWEYQVWFYQVWGYQVWEYPUYNUYKKZYQYPU
      YNUYKXMVWLUYNUYKYPKYQYPUYNUYKWTUYNYLUYKYNYPYPUYMYJYKBAXJXHZUYJYMYKCBXJXHZ
      YPWITWJXAVWFYLUYKUYRKYQYLUYKUYRXMYLYLUYKYNUYRYPYLWIVWNUYQYOYKACXJXHZTXAVW
      GYNUYRUYNKZYQYNUYRUYNXMVWPUYRUYNYNKUYNYNUYRKYQYNUYRUYNWTUYRUYNYNWTUYNYLYN
      YNUYRYPVWMYNWIVWOTXNXATVWHYQYQLZYQLVWQYQYQYQYQXMYQYQXOYQXPXNXNVGWPWHXQ $.
  $}

  ${
    $d A h v w $.  $d E h $.  $d V h v w $.
    $( Every graph with one vertex is a windmill graph.  (Contributed by
       Alexander van der Vekens, 5-Oct-2017.) $)
    1vwmgra $p |- ( ( A e. X /\ V = { A } )
              -> E. h e. V A. v e. ( V \ { h } ) ( { v , h } e. ran E
                      /\ E! w e. ( V \ { h } ) { v , w } e. ran E ) ) $=
      ( wcel csn wceq wa cv cpr cdif wreu wral wrex c0 wb reueq1 crn ral0 difid
      difeq2d syl6eq preq2 eleq1d anbi12d raleqbidv rexsng mpbiri adantr difeq1
      sneq syl anbi2d rexeqbi1dv adantl mpbird ) CGHZFCIZJZKBLZDLZMZEUAZHZVCALM
      VFHZAFVDIZNZOZKZBVJPZDFQZVGVHAVAVINZOZKZBVOPZDVAQZUTVSVBUTVSVCCMZVFHZVHAV
      AVANZOZKZBRPZWDBUBVRWEDCGVDCJZVQWDBVORWFVOWBRWFVIVAVAVDCUNUDZVAUCUEWFVGWA
      VPWCWFVEVTVFVDCVCUFUGWFVOWBJVPWCSWGVHAVOWBTUOUHUIUJUKULVBVNVSSUTVMVRDFVAV
      BVLVQBVJVOFVAVIUMZVBVKVPVGVBVJVOJVKVPSWHVHAVJVOTUOUPUIUQURUS $.
  $}

  ${
    $d A w y $.  $d B w y $.  $d C w y $.  $d E w y $.  $d X w y $.
    $d Y w y $.
    $( Lemma for ~ 3vfriswmgra .  (Contributed by Alexander van der Vekens,
       6-Oct-2017.) $)
    3vfriswmgralem $p |- ( ( ( A e. X /\ B e. Y ) /\ A =/= B
                           /\ { A , B , C } USGrph E ) -> ( { A , B } e. ran E
                           -> E! w e. { A , B } { A , w } e. ran E ) ) $=
      ( vy wcel wa cpr wi wo wceq preq2 eleq1d eqeq2 imbi2d 3imtr4d sylbi simpr
      wne ctp cusg wbr w3a crn cv wreu weu wex weq wrex olcd wb rexprg 3ad2ant1
      wal adantr mpbird df-rex sylib vex elpr eqidd a1i a1ii usgraedgrn wn eqid
      df-ne pm2.24i syl 3ad2ant3 com12 jaoi eqeq1 imbi12d syl5ibr a1d com3l imp
      ex imp31 alrimivv eleq1 anbi12d eu4 sylanbrc df-reu sylibr ) BFICGIJZBCUB
      ZBCDUCZEUDUEZUFZBCKZEUGZIZBAUHZKZWRIZAWQUIZWPWSJZWTWQIZXBJZAUJZXCXDXFAUKZ
      XFHUHZWQIZBXIKZWRIZJZJZAHULZLZHURAURXGXDXBAWQUMZXHXDXQBBKZWRIZWSMZXDWSXSW
      PWSUAUNWPXQXTUOZWSWLWMYAWOXBXSWSABCFGWTBNZXAXRWRWTBBOPZWTCNZXAWQWRWTCBOPZ
      UPUQUSUTXBAWQVAVBXDXPAHXNXDXOXEXBXMXDXOLZXEYBYDMZXBXMYFLLWTBCAVCVDXMYGXBY
      FXJXLYGXBYFLZLZXJXIBNZXICNZMZXLYILXIBCHVCVDYGYLXLYHYBYLXLYHLZLYDYLYMYBXLX
      SXDBXINZLZLZLZYJYQYKYJXSXSXDBBNZLZLZXLYPYJXSYTYSXSXDBVEVFVGYJXKXRWRXIBBOP
      ZYJYOYSXSYJYNYRXDXIBBQRRSYKWSXSXDBCNZLZLZXLYPYKWSUUDXDXSUUBWPXSUUBLZWSWOW
      LUUEWMWOXSUUBWOXSJZBBUBZUUBEBBWNVHZUUGYRVIZUUBBBVKZYRUUBBVJZVLTVMWCVNUSVO
      VGYKXKWQWRXICBOPZYKYOUUCXSYKYNUUBXDXICBQRRSVPYBYHYPXLYBXBXSYFYOYCYBXOYNXD
      WTBXIVQRVRRVSYLYMYDXLWSXDCXINZLZLZLZYJUUPYKYJXSWSXDCBNZLZLZXLUUOXSUUSLYJX
      SUURWSXDXSUUQWPXSUUQLZWSWOWLUUTWMWOXSUUQUUFUUGUUQUUHUUGUUIUUQUUJYRUUQUUKV
      LTVMWCVNUSVOVTVFUUAYJUUNUURWSYJUUMUUQXDXIBCQRRSYKWSWSXDCCNZLZLZXLUUOYKWSU
      VCUVBWSXDCVEVFVGUULYKUUNUVBWSYKUUMUVAXDXICCQRRSVPYDYHUUOXLYDXBWSYFUUNYEYD
      XOUUMXDWTCXIVQRVRRVSVPWATWBWATWDVOWEXFXMAHXOXEXJXBXLWTXIWQWFXOXAXKWRWTXIB
      OPWGWHWIXBAWQWJWKWC $.
  $}

  ${
    $d A h v w $.  $d B h v w $.  $d C h v w $.  $d E h v w $.  $d V h v w $.
    $d X v w $.  $d Y v w $.
    $( Every friendship graph with three (different) vertices is a windmill
       graph.  (Contributed by Alexander van der Vekens, 6-Oct-2017.) $)
    3vfriswmgra $p |- ( ( ( A e. X /\ B e. Y /\ C e. Z )
                      /\ ( A =/= B /\ A =/= C /\ B =/= C )
                      /\ V = { A , B , C } ) -> ( V FriendGrph E
              -> E. h e. V A. v e. ( V \ { h } ) ( { v , h } e. ran E
                      /\ E! w e. ( V \ { h } ) { v , w } e. ran E ) ) ) $=
      ( wcel wceq cpr wreu wa wb 3ad2ant1 adantr eleq1d w3a wne ctp wbr crn csn
      cfrgra cv cdif wral wrex wi cusg frisusgra frgra3v 3adant3 imp w3o eleq1i
      prcom biimpi 3ad2ant3 adantl id 3ad2ant2 simpr 3jca 3vfriswmgralem syl2an
      jca simpr2 pm3.22 necom tpcoma breq1i reueq1 ax-mp sylibr reubidv anbi12d
      preq1 ralprg mpbird diftpsn3 3adant1 anbi2d raleqbidv 3mix3 difeq2d preq2
      syl sneq rextpg sylbid expcom com23 mpcom com12 difeq1 rexeqbi1dv imbi12d
      ex breq1 ) CILZDJLZEKLZUAZCDUBZCEUBZDEUBZUAZHCDEUCZMZUAZHGUGUDZBUHZFUHZNZ
      GUEZLZXPAUHZNZXSLZAHXQUFZUIZOZPZBYEUJZFHUKZULZXLGUGUDZXTYCAXLYDUIZOZPZBYL
      UJZFXLUKZULZYKXNYPXLGUMUDZYKXNYPULGXLUNYRXNYKYPXNYRYQXNYRPZYKCDNZXSLZDENZ
      XSLZECNZXSLZUAZYPXNYRYKUUFQZXGXKYRUUGULXMCDEGIJKUOUPUQYSUUFYPYSUUFPZYPXPC
      NZXSLZYCAXLCUFZUIZOZPZBUULUJZXPDNZXSLZYCAXLDUFZUIZOZPZBUUSUJZXPENZXSLZYCA
      XLEUFZUIZOZPZBUVFUJZURZUUHUVIUVJUUHUVIUVDYCAYTOZPZBYTUJZUUHUVMCENZXSLZCYA
      NZXSLZAYTOZPZUUCDYANZXSLZAYTOZPZPZUUHUVSUWCUUHUVOUVRUUFUVOYSUUEUUAUVOUUCU
      UEUVOUUDUVNXSECUTUSVAVBVCYSXDXEPZXHYRUAZUUAUVRUUFYSUWEXHYRXNUWEYRXGXKUWEX
      MXDXEUWEXFUWEVDUPRSXNXHYRXKXGXHXMXHXIXHXJXHVDRVESXNYRVFVGUUAUUCUUAUUEUUAV
      DRUWFUUAUVRACDEGIJVHUQVIVJUUHUUCUWBYSUUAUUCUUEVKYSXEXDPZDCUBZDCEUCZGUMUDZ
      UAZDCNZXSLZUWBUUFYSUWGUWHUWJXNUWGYRXGXKUWGXMXDXEUWGXFXDXEVLUPRSXNUWHYRXKX
      GUWHXMXHXIUWHXJXHUWHCDVMVARVESYRUWJXNYRUWJXLUWIGUMCDEVNVOVAVCVGUUAUUCUWMU
      UEUUAUWMYTUWLXSCDUTZUSVARUWKUWMPUWAAUWLOZUWBUWKUWMUWOADCEGJIVHUQYTUWLMUWB
      UWOQUWNUWAAYTUWLVPVQVRVIVJVJYSUVMUWDQZUUFXNUWPYRXGXKUWPXMXDXEUWPXFUVLUVSU
      WCBCDIJXPCMZUVDUVOUVKUVRUWQUVCUVNXSXPCEWATUWQYCUVQAYTUWQYBUVPXSXPCYAWATVS
      VTXPDMZUVDUUCUVKUWBUWRUVCUUBXSXPDEWATUWRYCUWAAYTUWRYBUVTXSXPDYAWATVSVTWBU
      PRSSWCYSUVIUVMQZUUFXNUWSYRXKXGUWSXMXKUVHUVLBUVFYTXIXJUVFYTMZXHCDEWDWEZXKU
      VGUVKUVDXKUWTUVGUVKQUXAYCAUVFYTVPWKWFWGVESSWCUVIUUOUVBWHWKYSYPUVJQZUUFXNU
      XBYRXGXKUXBXMYOUUOUVBUVIFCDEIJKXQCMZYNUUNBYLUULUXCYDUUKXLXQCWLWIZUXCXTUUJ
      YMUUMUXCXRUUIXSXQCXPWJTUXCYLUULMYMUUMQUXDYCAYLUULVPWKVTWGXQDMZYNUVABYLUUS
      UXEYDUURXLXQDWLWIZUXEXTUUQYMUUTUXEXRUUPXSXQDXPWJTUXEYLUUSMYMUUTQUXFYCAYLU
      USVPWKVTWGXQEMZYNUVHBYLUVFUXGYDUVEXLXQEWLWIZUXGXTUVDYMUVGUXGXRUVCXSXQEXPW
      JTUXGYLUVFMYMUVGQUXHYCAYLUVFVPWKVTWGWMRSSWCXBWNWOWPWQWRXMXGYJYQQXKXMXOYKY
      IYPHXLGUGXCYHYOFHXLXMYGYNBYEYLHXLYDWSZXMYFYMXTXMYEYLMYFYMQUXIYCAYEYLVPWKW
      FWGWTXAVBWC $.

    $( Every friendship graph with one or two vertices is a windmill graph.
       (Contributed by Alexander van der Vekens, 6-Oct-2017.) $)
    1to2vfriswmgra $p |- ( ( A e. X /\ ( V = { A } \/ V = { A , B } ) )
                           -> ( V FriendGrph E
                -> E. h e. V A. v e. ( V \ { h } ) ( { v , h } e. ran E
                        /\ E! w e. ( V \ { h } ) { v , w } e. ran E ) ) ) $=
      ( csn wceq cpr wo wcel cfrgra wbr cv wa wi expcom wn crn cdif 1vwmgra a1d
      wreu wral wrex cvv wne wb breq1 adantr pm3.22 anass sylibr frgra2v adantl
      syl pm2.21d sylbid ex com23 ianor prprc2 preq2 eqcoms dfsn2 syl6eqr sylbi
      nne jaoi eqeq2d syl6bi pm2.61i impcom ) GCIZJZGCDKZJZLCHMZGFNOZBPZEPZKFUA
      ZMWBAPKWDMAGWCIUBZUEQBWEUFEGUGZRZVQVTWGRZVSVTVQWGVTVQQWFWAABCEFGHUCUDSZDU
      HMZCDUIZQZVSWHRWLVTVSWGWLVTVSWGRVSWLVTQZWGVSWMQZWAVRFNOZWFVSWAWOUJWMGVRFN
      UKULWNWOWFWMWOTZVSWMVTWJQWKQZWPWMVTWLQWQWLVTUMVTWJWKUNUOCDFHUHUPURUQUSUTS
      VAVBWLTZVSVQWHWRVRVPGWRWJTZWKTZLVRVPJZWJWKVCWSXAWTCDVDWTCDJZXACDVJXBVRCCK
      ZVPVRXCJDCDCCVEVFCVGVHVIVKVIVLWIVMVNVKVO $.

    $( Every friendship graph with one, two or three vertices is a windmill
       graph.  (Contributed by Alexander van der Vekens, 6-Oct-2017.) $)
    1to3vfriswmgra $p |- ( ( A e. X /\ ( V = { A } \/ V = { A , B }
                           \/ V = { A , B , C } ) ) -> ( V FriendGrph E
                -> E. h e. V A. v e. ( V \ { h } ) ( { v , h } e. ran E
                        /\ E! w e. ( V \ { h } ) { v , w } e. ran E ) ) ) $=
      ( wceq cpr ctp wcel cv wa wi wo expcom cvv wne csn w3o wbr cdif wreu wral
      cfrgra crn wrex df-3or 1to2vfriswmgra tppreq3 eqeq2d olc anim1i ancomd ex
      syl syl6bi wn tpprceq3 tprot eqeq1i biimpi prcom syl6eq sylan2 a1d tpcoma
      com23 w3a simpl anim12i ad2antrr 3anass sylibr simpr necomd df-3an simplr
      3vfriswmgra syl3anc exp41 ecase pm2.61ine jaoi sylbi impcom ) HCUAJZHCDKZ
      JZHCDELZJZUBZCIMZHGUGUCBNZFNZKGUHZMWPANKWRMAHWQUAUDZUEOBWSUFFHUIPZWNWIWKQ
      ZWMQWOWTPZWIWKWMUJXAXBWMWOXAWTABCDFGHIUKZRWMXBPZDEDEJZWMWKXBXEWLWJHCDEULU
      MWKWOWTWKWOOZWOXAOWTXFXAWOWKXAWOWKWIUNZUOUPXCURUQUSDSMZDCTZOZESMZECTZOZDE
      TZXDPXJUTZXDXNXOECDLZECKZJZXDECDVAXRWMHCEKZJZXBXRWLXSHXRWLXQXSXRWLXQJXPWL
      XQECDVBVCVDECVEVFUMWOXTWTXTWOWIXTQWTXTWIUNABCEFGHIUKVGRUSURVHXMUTZWMXNXBY
      ADCELZDCKZJZWMXNXBPZPDCEVAYDWMWKYEYDWLWJHYDWLYCWJYDWLYCJYBWLYCDCEVIVCVDDC
      VEVFUMWKXBXNWOWKWTWKWOXAWTXGXCVGRVHUSURVJXJXMOZXNWMWOWTYFXNOZWMOZWOOZWOXH
      XKVKZCDTZCETZXNVKZWMWTYIWOXHXKOZOYJYIYNWOYHYNWOYFYNXNWMXJXHXMXKXHXIVLXKXL
      VLVMVNUOUPWOXHXKVOVPYGYMWMWOYGYKYLOZXNOYMYFYOXNXJYKXMYLXJDCXHXIVQVRXMECXK
      XLVQVRVMUOYKYLXNVSVPVNYGWMWOVTABCDEFGHISSWAWBWCWDWEWFWGWH $.
  $}

  ${
    $d A v w x $.  $d B v w x $.  $d C v w x $.  $d E v w x $.  $d V v w x $.
    $d X w x $.
    $( The friendship theorem for small graphs:  In every friendship graph with
       one, two or three vertices, there is a vertex which is adjacent to all
       other vertices.  (Contributed by Alexander van der Vekens,
       6-Oct-2017.) $)
    1to3vfriendship $p |- ( ( A e. X /\ ( V = { A } \/ V = { A , B }
                            \/ V = { A , B , C } ) ) -> ( V FriendGrph E
                   -> E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E ) ) $=
      ( vx wcel csn wceq cpr ctp w3o wa cfrgra cv wral wrex cdif 1to3vfriswmgra
      wbr crn wreu prcom eleq1i biimpi adantr ralimi reximi syl6 ) CHJGCKLGCDML
      GCDENLOPGFQUCARZBRZMZFUDZJZUMIRMUPJIGUNKUAZUEZPZAURSZBGTUNUMMZUPJZAURSZBG
      TIACDEBFGHUBVAVDBGUTVCAURUQVCUSUQVCUOVBUPUMUNUFUGUHUIUJUKUL $.
  $}

  ${
    $d E a b c $.  $d V a b c $.
    $( Between any two (different) vertices in a friendship graph is a 2-path
       (path of length 2), see Proposition 1 of [MertziosUnger] p. 153 :  "A
       friendship graph G ..., as well as the distance between any two nodes in
       G is at most two".  (Contributed by Alexander van der Vekens,
       15-Nov-2017.) $)
    2pthfrgrarn $p |- ( V FriendGrph E -> A. a e. V A. c e. ( V \ { a } )
                    E. b e. V ( { a , b } e. ran E /\ { b , c } e. ran E ) ) $=
      ( cfrgra wbr cusg cv cpr crn wss wreu wral wcel wrex zfpair2 syl ralimdva
      wa csn cdif frisusgrapr wi reurex prcom eleq1i anbi1i prss biimpri reximi
      bitri a1i imp ) BAFGBAHGZDIZCIZJZUPEIZJZJAKZLZDBMZEBUQUAUBZNZCBNZTUQUPJZV
      AOZUTVAOZTZDBPZEVDNZCBNZDCABEUCUOVFVMUOVEVLCBUOUQBOTZVCVKEVDVCVKUDVNUSVDO
      TVCVBDBPVKVBDBUEVBVJDBVJVBVJURVAOZVITVBVHVOVIVGURVAUQUPUFUGUHURUTVADCQDEQ
      UIULUJUKRUMSSUNR $.

    $( Between any two (different) vertices in a friendship graph is a 2-path
       (path of length 2), see Proposition 1 of [MertziosUnger] p. 153 :  "A
       friendship graph G ..., as well as the distance between any two nodes in
       G is at most two".  (Contributed by Alexander van der Vekens,
       16-Nov-2017.) $)
    2pthfrgrarn2 $p |- ( V FriendGrph E -> A. a e. V A. c e. ( V \ { a } )
                    E. b e. V ( ( { a , b } e. ran E /\ { b , c } e. ran E )
                             /\ ( a =/= b /\ b =/= c ) ) ) $=
      ( cfrgra wbr cv cpr crn wcel wa wrex csn cdif wral usgraedgrn ex ralimdva
      wne 2pthfrgrarn cusg frisusgra anim12d syl ad3antrrr ancld reximdva mpd
      wi ) BAFGZCHZDHZIAJZKZUMEHZIUNKZLZDBMZEBULNOZPZCBPURULUMTZUMUPTZLZLZDBMZE
      UTPZCBPABCDEUAUKVAVGCBUKULBKZLZUSVFEUTVIUPUTKZLZURVEDBVKUMBKZLURVDUKURVDU
      JZVHVJVLUKBAUBGZVMABUCVNUOVBUQVCVNUOVBAULUMBQRVNUQVCAUMUPBQRUDUEUFUGUHSSU
      I $.
  $}

  ${
    $d V a b m f p $.  $d E a b m f p $.
    $( Between any two (different) vertices in a friendship graph is a 2-path
       (path of length 2), see Proposition 1 of [MertziosUnger] p. 153 :  "A
       friendship graph G ..., as well as the distance between any two nodes in
       G is at most two".  (Contributed by Alexander van der Vekens,
       6-Dec-2017.) $)
    2pthfrgra $p |- ( V FriendGrph E -> A. a e. V A. b e. ( V \ { a } )
                 E. f E. p ( f ( a ( V PathOn E ) b ) p /\ ( # ` f ) = 2 ) ) $=
      ( vm wbr cv cpr wcel wa wne wral cfv wceq cvv sylbi wi adantl cfrgra wrex
      crn csn cdif cpthon chash wex 2pthfrgrarn2 w3a ccnv cusg frisusgra usgrav
      co c2 syl ad2antrr simpr eldifsn simpl ad2antlr 3jca adantr simpll biimpi
      necom simplr ex com12 imp cdm usgraf1o fveq2 f1ocnvfv2 syl2an eqeq12d weq
      wf1o prcom eqeq2i vex preqr1 wn df-ne bitri pm2.21 sylbid syl5com biimpri
      syl5 a1d pm2.61i expcom exp31 com14 3syl imp41 2pthon3v syl31anc ralimdva
      rexlimdva mpd ) CBUAHZEIZGIZJZBUCZKZXFFIZJZXHKZLZXEXFMZXFXJMZLZLZGCUBZFCX
      EUDUEZNZECNAIZDIXEXJCBUFUOUOHYAUGOUPPLDUHAUHZFXSNZECNBCEGFUIXDXTYCECXDXEC
      KZLZXRYBFXSYEXJXSKZLZXQYBGCYGXFCKZLZXQYBYIXQLCQKBQKLZYDYHXJCKZUJZXNXEXJMZ
      XOUJZXGBUKZOZXKYOOZMZYPBOZXGPZYQBOZXKPZUJZYBYGYJYHXQXDYJYDYFXDCBULHZYJBCU
      MZBCUNUQURURYIYLXQYIYDYHYKYEYDYFYHXDYDUSURYGYHUSYFYKYEYHYFYKXJXEMZLZYKXJC
      XEUTZYKUUFVARVBVCVDYIXQYNYFXQYNSZYEYHYFUUGUUIUUHUUFUUIYKXQUUFYNXPUUFYNSXM
      XPUUFYNXPUUFLXNYMXOXNXOUUFVEUUFYMXPUUFYMXJXEVGZVFTXNXOUUFVHVCVITVJTRVBVKY
      EYFYHXQUUCXDYDYFYHXQUUCSZSSZXDUUDBVLZXHBVSZYDUULSUUEBCVMYHYDYFUUNUUKYHYDY
      FUUNUUKSUUNYHYDLZYFLZUUKUUNUUPLZXQUUCUUQXQLZYRYTUUBYPYQPZUURYRSUUSYSUUAPZ
      UURYRYPYQBVNUURUUTXGXKPZYRUURYSXGUUAXKUUQUUNXIYTXQUUNUUPVAZXIXLXPVEUUMXHX
      GBVOVPZUUQUUNXLUUBXQUVBXIXLXPVHUUMXHXKBVOVPZVQUVAEFVRZUURYRUVAXGXJXFJZPUV
      EXKUVFXGXFXJVTWAXEXJXFEWBFWBWCRUUPUVEYRSZUUNXQYFUVGUUOYFUUGUVGUUHUUFUVGYK
      UUFUVEWDZUVGUUFYMUVHUUJXEXJWEWFUVEYRWGRTRTVBWKWHWIUUSWDZYRUURYRUVIYPYQWEW
      JWLWMUVCUVDVCVIWNWOWPWQVKWRXEXFXJABCQQDWSWTVIXBXAXAXC $.
  $}

  ${
    $d A a x z $.  $d C x z $.  $d E a x z $.  $d V a x z $.  $d A u v y $.
    $d C y $.  $d E u v y $.  $d V u v y $.  $d V v x y $.  $d b c x y $.
    $d A c b $.  $d E c b $.  $d V c b $.
    $( Every vertex in a friendship graph ( with more than 1 vertex) is part of
       a 3-cycle.  (Contributed by Alexander van der Vekens, 16-Nov-2017.) $)
    3cyclfrgrarn1 $p |- ( ( V FriendGrph E /\ ( A e. V /\ C e. V ) /\ A =/= C )
                          -> E. b e. V E. c e. V ( { A , b } e. ran E
                          /\ { b , c } e. ran E /\ { c , A } e. ran E ) ) $=
      ( vx vz vy vv wcel wa wne cv cpr wrex wral wi eleq1d adantr va cfrgra wbr
      vu crn w3a cdif 2pthfrgrarn2 necom eldifsn simplbi2com sylbi com12 adantl
      csn wceq difeq2d preq1 anbi1d neeq1 anbi12d rexbidv raleqbidv rspcv preq2
      imp sneq anbi2d neeq2 sylsyld 2pthfrgrarn weq prcom eleq1i anbi12ci biidd
      3anbi123d rspc2ev 3expa expcom 3expib syl5bi com13 rexlimdva exp31 impcom
      syl9 com24 com15 pm2.43i com4t syl com14 rexlimiv syl6 pm2.43a mpcom 3imp
      ex ) DCUBUCZADKZBDKZLZABMZAENZOZCUEZKZXEFNZOZXGKZXIAOZXGKZUFZFDPEDPZUANZG
      NZOZXGKZXQHNZOZXGKZLZXPXQMZXQXTMZLZLZGDPZHDXPUOZUGZQZUADQZWTXCXDXORRCDUAG
      HUHXCXDYLWTXOXCXDYLWTXORZRYLXCXDLZYMYNYLAXQOZXGKZXQBOZXGKZLZAXQMZXQBMZLZL
      ZGDPZYNYMRZYNBDAUOZUGZKZYLYPYBLZYTYELZLZGDPZHUUGQZUUDXCXDUUHXBXDUUHRXAXDX
      BUUHXDBAMZXBUUHRABUIUUHXBUUNBDAUJUKULUMUNVFXCYLUUMRZXDXAUUOXBYKUUMUAADXPA
      UPZYHUULHYJUUGUUPYIUUFDXPAVGUQUUPYGUUKGDUUPYCUUIYFUUJUUPXSYPYBUUPXRYOXGXP
      AXQURSUSUUPYDYTYEXPAXQUTUSVAVBVCVDTTUULUUDHBUUGXTBUPZUUKUUCGDUUQUUIYSUUJU
      UBUUQYBYRYPUUQYAYQXGXTBXQVESVHUUQYEUUAYTXTBXQVIVHVAVBVDVJUUCUUEGDWTUUCYNX
      QDKZXOWTUDNZINZOZXGKZUUTJNZOZXGKZLZIDPZJDUUSUOZUGZQZUDDQZUUCYNUURXORZRRCD
      UDIJVKYNUURUVKUUCXOXCUURUVKUUCXORRZRZXDXAUVNXBUURXAUVMUURXAUVMRUUCUURXAUV
      KUURXOUUBYSUURXAUVKUVLRZRRZYTYSUVPRUUAYTXAUURYSUVOYTXAUURYSUVORYTXALZUURL
      ZUVKAUUTOZXGKZUUTXQOZXGKZLZIDPZYSUVLUVRXQUUGKZUVKUVTUVELZIDPZJUUGQZUWDUVQ
      UURUWEYTUURUWERZXAYTXQAMZUWIAXQUIUWEUURUWJXQDAUJUKULTVFUVQUVKUWHRZUURXAUW
      KYTUVJUWHUDADUUSAUPZUVGUWGJUVIUUGUWLUVHUUFDUUSAVGUQUWLUVFUWFIDUWLUVBUVTUV
      EUWLUVAUVSXGUUSAUUTURSUSVBVCVDUNTUWGUWDJXQUUGJGVLZUWFUWCIDUWMUVEUWBUVTUWM
      UVDUWAXGUVCXQUUTVESVHVBVDVJUURUWDYSXOUURUWCYSXORIDYSUWCUURUUTDKZLZXOYPUWC
      UWOXORZRYRUWCXQUUTOZXGKZUUTAOZXGKZLYPUWPUVTUWTUWBUWRUVSUWSXGAUUTVMVNUWAUW
      QXGUUTXQVMVNVOYPUWRUWTUWPUWOYPUWRUWTUFZXOUURUWNUXAXOXNUXAYPXQXIOZXGKZXMUF
      EFXQUUTDDEGVLZXHYPXKUXCXMXMUXDXFYOXGXEXQAVESUXDXJUXBXGXEXQXIURSUXDXMVPVQF
      IVLZYPYPUXCUWRXMUWTUXEYPVPUXEUXBUWQXGXIUUTXQVESUXEXLUWSXGXIUUTAURSVQVRVSV
      TWAWBTWCWDWCWGWEWHTWFWIWJUMTTWKWLWMWNWOWPWSWKWQWR $.
  $}

  ${
    $d E a b c x $.  $d V a b c x $.
    $( Every vertex in a friendship graph ( with more than 1 vertex) is part of
       a 3-cycle.  (Contributed by Alexander van der Vekens, 16-Nov-2017.) $)
    3cyclfrgrarn $p |- ( ( V FriendGrph E /\ 1 < ( # ` V ) )
                         -> A. a e. V E. b e. V E. c e. V ( { a , b } e. ran E
                            /\ { b , c } e. ran E /\ { c , a } e. ran E ) ) $=
      ( vx cfrgra wbr c1 cv cpr wcel wrex cvv wa wi syl expcom com23 imp usgrav
      chash cfv clt crn w3a wral cusg frisusgra hashgt12el2 3expa 3cyclfrgrarn1
      wne 3expb com34 rexlimiv com24 pm2.43i com13 ralrimiv exp31 adantr mpcom
      ex ) BAGHZIBUBUCUDHZCJZDJZKAUEZLVHEJZKVILVJVGKVILUFEBMDBMZCBUGZBNLZANLZOZ
      VEVFVLPZVEBAUHHVOABUIABUAQVMVEVPPVNVMVFVEVLVMVFVEVLVMVFOZVEOVKCBVQVEVGBLZ
      VKPZVRVEVQVKVRVEVQVKPPVRVQVEVRVKVQVRVEVSPZVQVROVGFJZUMZFBMZVTVMVFVRWCVGBN
      FUJUKWBVTFBWABLZWBVRVEVKWDVRWBVEVKPZVRWDWBWEPVRWDOZWBWEVEWFWBOVKVEWFWBVKV
      GWAABDEULUNRVDRSUOUPQRUQURUSTUTVASVBVCT $.
  $}

  ${
    $d E a b c x $.  $d V a b c x $.
    $( Every vertex in a friendship graph ( with more than 1 vertex) is part of
       a 3-cycle.  (Contributed by Alexander van der Vekens, 10-Dec-2017.) $)
    3cyclfrgrarn2 $p |- ( ( V FriendGrph E /\ 1 < ( # ` V ) )
            -> A. a e. V E. b e. V E. c e. V ( b =/= c /\ ( { a , b } e. ran E
                           /\ { b , c } e. ran E /\ { c , a } e. ran E ) ) ) $=
      ( cfrgra wbr c1 chash cfv clt wa cv cpr crn wcel wrex wral wi reximdv w3a
      wne 3cyclfrgrarn cusg frisusgra usgraedgrn expcom 3ad2ant2 syl5com adantr
      ancrd ralimdv mpd ) BAFGZHBIJKGZLZCMZDMZNAOZPZUREMZNUSPZVAUQNUSPZUAZEBQZD
      BQZCBRURVAUBZVDLZEBQZDBQZCBRABCDEUCUPVFVJCBUPVEVIDBUPVDVHEBUPVDVGUNVDVGSU
      OUNBAUDGZVDVGABUEVBUTVKVGSVCVKVBVGAURVABUFUGUHUIUJUKTTULUM $.
  $}

  ${
    $d E v b c f p $.  $d V v b c f p $.
    $( Every vertex in a friendship graph (with more than 1 vertex) is part of
       a 3-cycle.  (Contributed by Alexander van der Vekens, 19-Nov-2017.) $)
    3cyclfrgra $p |- ( ( V FriendGrph E /\ 1 < ( # ` V ) ) -> A. v e. V
        E. f E. p ( f ( V Cycles E ) p /\ ( # ` f ) = 3 /\ ( p ` 0 ) = v ) ) $=
      ( vb vc wbr chash cfv wa cv cpr wcel w3a wrex wral wceq wex simpr clt crn
      cfrgra c1 ccycl co c3 3cyclfrgrarn frisusgra ad4antr adantr simprl simprr
      cc0 cusg 3jca constr3cyclpe syl3anc ex rexlimdvva ralimdva mpd ) DCUCHZUD
      DIJUAHZKZALZFLZMCUBZNVGGLZMVHNVIVFMVHNOZGDPFDPZADQBLZELZDCUEUFHVLIJUGRUNV
      MJVFROESBSZADQCDAFGUHVEVKVNADVEVFDNZKZVJVNFGDDVPVGDNZVIDNZKZKZVJVNVTVJKDC
      UOHZVOVQVROZVJVNVCWAVDVOVSVJCDUIUJVTWBVJVTVOVQVRVPVOVSVEVOTUKVPVQVRULVPVQ
      VRUMUPUKVTVJTVFVGVIBCDEUQURUSUTVAVB $.
  $}

  $( In a (maybe degenerated) 4-cycle, two vertices have two (maybe not
     different) common neighbors.  (Contributed by Alexander van der Vekens,
     19-Nov-2017.) $)
  4cycl2v2nb $p |- ( ( ( { A , B } e. ran E /\ { B , C } e. ran E )
                    /\ ( { C , D } e. ran E /\ { D , A } e. ran E ) )
                    -> ( { { A , B } , { B , C } } C_ ran E
                      /\ { { A , D } , { D , C } } C_ ran E ) ) $=
    ( cpr crn wcel wa wss prssi prcom eleq1i biimpi syl2anr anim12i ) ABFZEGZHB
    CFZRHIQSFRJCDFZRHZDAFZRHZIADFZDCFZFRJZQSRKUCUDRHZUERHZUFUAUCUGUBUDRDALMNUAU
    HTUERCDLMNUDUERKOP $.

  ${
    $d A x y $.  $d B x y $.  $d C x y $.  $d D y $.  $d E x y $.  $d V x y $.
    $( In a 4-cycle, two distinct vertices have not a unique common neighbor.
       (Contributed by Alexander van der Vekens, 19-Nov-2017.) $)
    4cycl2vnunb $p |- ( ( ( { A , B } e. ran E /\ { B , C } e. ran E )
                       /\ ( { C , D } e. ran E /\ { D , A } e. ran E )
                       /\ ( B e. V /\ D e. V /\ B =/= D ) )
                       -> -. E! x e. V { { A , x } , { x , C } } C_ ran E ) $=
      ( vy cpr wcel wa wne wss wn wi wrex preq2 preq1 preq12d sseq1d crn w3a cv
      wreu 4cycl2v2nb wral wceq anbi1d neeq1 anbi12d anbi2d neeq2 rspc2ev 3expa
      weq expcom ex com13 3impia impcom rexnal annim df-ne bicomi anbi2i bitr3i
      rexbii sylibr intnand reu4 sylnibr syl ) BCIZFUAZJCDIZVNJKZDEIVNJEBIVNJKZ
      CGJZEGJZCELZUBZBAUCZIZWBDIZIZVNMZAGUDZNZVPVQKVMVOIZVNMZBEIZEDIZIZVNMZKZWA
      WHOBCDEFUEWOWAWHWOWAKZWFAGPZWFBHUCZIZWRDIZIZVNMZKZAHUOZOZHGUFZAGUFZKWGWPX
      GWQWPXCWBWRLZKZHGPZAGPZXGNZWAWOXKVRVSVTWOXKOWOVTVRVSKZXKWOVTXMXKOXMWOVTKZ
      XKVRVSXNXKXIXNWJXBKZCWRLZKAHCEGGWBCUGZXCXOXHXPXQWFWJXBXQWEWIVNXQWCVMWDVOW
      BCBQWBCDRSTUHWBCWRUIUJWREUGZXOWOXPVTXRXBWNWJXRXAWMVNXRWSWKWTWLWREBQWREDRS
      TUKWRECULUJUMUNUPUQURUSUTXLXFNZAGPXKXFAGVAXSXJAGXSXENZHGPXJXEHGVAXTXIHGXT
      XCXDNZKXIXCXDVBYAXHXCXHYAWBWRVCVDVEVFVGVFVGVFVHVIWFXBAHGXDWEXAVNXDWCWSWDW
      TWBWRBQWBWRDRSTVJVKUQVLUS $.
  $}

  ${
    $d E a b c d k l x $.  $d P a b c d $.  $d V a b c d k l x $.
    $d F a b c d $.
    $( There is no 4-cycle in a friendship graph, see Proposition 1 of
       [MertziosUnger] p. 153 :  "A friendship graph G contains no C4 as a
       subgraph ...".  (Contributed by Alexander van der Vekens,
       19-Nov-2017.) $)
    n4cyclfrgra $p |- ( ( V FriendGrph E /\ F ( V Cycles E ) P )
                        -> ( # ` F ) =/= 4 ) $=
      ( va vb vc vd vx vk vl wa wne wi cv cpr wcel wrex adantl adantr wbr ccycl
      cfrgra chash cfv wceq cusg frisusgra w3a crn 4cycl4dv4e wss wreu csn cdif
      co wral frisusgrapr simpl necom biimpi 3ad2ant2 ad2antrl eldifsn sylanbrc
      c4 weq difeq2d preq2 preq1d sseq1d reubidv raleqbidv rspcv preq2d sylsyld
      prcom preq1i sseq1i reubii wn simpr simprr2 4cycl2vnunb syl113anc pm2.21d
      sneq com12 sylbi syl6 pm2.43b rexlimdvva rexlimivv 3exp com34 com23 mpcom
      syl ex imp df-ne biimpri pm2.61d1 ) DBUCUAZCADBUBUPUAZLCUDUEZVFUFZXFVFMZX
      DXEXGXHNZDBUGUAZXDXEXINBDUHXJXEXDXIXJXEXGXDXHXJXEXGXDXHNZXJXEXGUIEOZFOZPB
      UJZQXMGOZPXNQLZXOHOZPXNQXQXLPXNQLZLZXLXMMZXLXOMZXLXQMZUIZXMXOMZXMXQMZXOXQ
      MZUIZLZLZHDRGDRZFDREDRXKABCDEFGHUKYJXKEFDDXLDQZXMDQZLZYIXKGHDDYMXODQZXQDQ
      ZLZLZYIXKXDYQYILZXHXDXJIOZJOZPZYSKOZPZPZXNULZIDUMZKDYTUNZUOZUQZJDUQZLYRXH
      NZIJBDKURUUJUUKXJUUJYRXHYRUUJYSXLPZYSXOPZPZXNULZIDUMZUUKYRXODXLUNZUOZQZUU
      JUULUUCPZXNULZIDUMZKUURUQZUUPYRYNXOXLMZUUSYQYNYIYPYNYMYNYOUSSTYIUVDYQYCUV
      DXSYGYAXTUVDYBYAUVDXLXOUTVAVBVCSXODXLVDVEYQUUJUVCNZYIYMUVEYPYKUVEYLUUIUVC
      JXLDJEVGZUUFUVBKUUHUURUVFUUGUUQDYTXLWGVHUVFUUEUVAIDUVFUUDUUTXNUVFUUAUULUU
      CYTXLYSVIVJVKVLVMVNTTTUVBUUPKXOUURKGVGZUVAUUOIDUVGUUTUUNXNUVGUUCUUMUULUUB
      XOYSVIVOVKVLVNVPUUPXLYSPZUUMPZXNULZIDUMZUUKUUOUVJIDUUNUVIXNUULUVHUUMYSXLV
      QVRVSVTYRUVKXHYRUVKXHYRXPXRYLYOYEUVKWAXSXPYQYHXPXRUSVCXSXRYQYHXPXRWBVCYQY
      LYIYMYLYPYKYLWBTTYQYOYIYPYOYMYNYOWBSTYIYEYQYDYEYFYCXSWCSIXLXMXOXQBDWDWEWF
      WHWIWJWKSWRWHWSWLWMWRWNWOWPWQWTXHXGWAXFVFXAXBXC $.
  $}

  ${
    $d A a c x $.  $d C c x $.  $d B x $.  $d E a c x $.  $d V a c x $.
    $( A graph with a 4-cycle is not a friendhip graph.  (Contributed by
       Alexander van der Vekens, 19-Dec-2017.) $)
    4cyclusnfrgra $p |- ( ( V USGrph E /\ ( A e. V /\ C e. V /\ A =/= C )
                                       /\ ( B e. V /\ D e. V /\ B =/= D ) )
                          -> ( ( ( { A , B } e. ran E /\ { B , C } e. ran E )
                              /\ ( { C , D } e. ran E /\ { D , A } e. ran E ) )
                               -> -. V FriendGrph E ) ) $=
      ( vx cusg wbr wcel wne w3a cpr crn wa cfrgra wn cv wss wi syl3anc syl6com
      wreu simprl simprr simpl3 4cycl2vnunb frgraunss pm2.24 3ad2ant2 com23 mpd
      adantr pm2.01d ex ) FEHIZAFJCFJACKLZBFJDFJBDKLZLZABMENZJBCMUTJOZCDMUTJDAM
      UTJOZOZFEPIZQZUSVCOZVDVFAGRZMVGCMMUTSGFUCZQZVDVETZVFVAVBURVIUSVAVBUDUSVAV
      BUEUPUQURVCUFGABCDEFUGUAUSVIVJTVCUSVDVIVEUQUPVDVIVETZTURVDUQVHVKACEFGUHVH
      VEUIUBUJUKUMULUNUO $.
  $}

  ${
    frgranbnb.x $e |- ( ph -> X e. V ) $.
    frgranbnb.nx $e |- D = ( <. V , E >. Neighbors X ) $.
    frgranbnb.f $e |- ( ph -> V FriendGrph E ) $.
    $( If two neighbors of a specific vertex have a common neighbor in a
       friendship graph, then this common neighbor must be the specific
       vertex.  (Contributed by Alexander van der Vekens, 19-Dec-2017.) $)
    frgranbnb $p |- ( ( ph /\ ( U e. D /\ W e. D ) /\ U =/= W )
              -> ( ( { U , A } e. ran E /\ { W , A } e. ran E ) -> A = X ) ) $=
      ( wcel wa wne cpr wi syl5bi adantr adantl ex crn wceq cusg wbr cfrgra syl
      frisusgra cop cnbgra eleq2i nbgraeledg anim12d imp nbgraisvtx usgraedgrnv
      co biimpd adantrr ax-1 a1d w3a wn simpl simprrr necom biimpi 3jca simprlr
      prcom eleq1i anim1i ancomd anim12i 4cyclusnfrgra sylc pm2.21d com23 exp41
      anim2i com25 mpcom com15 pm2.61ine com13 com12 com14 mp2d 3imp ) ADCLZGCL
      ZMZDGNZDBOEUAZLZGBOZWMLZMZBHUBZPZFEUCUDZAWKWLWSPZPAFEUEUDZWTKEFUGZUFWTWKA
      XAWTWKAXAPZWTWKMDHOZWMLZGHOWMLZMZDFLZGFLZMZXDWTWKXHWTWIXFWJXGWIDFEUHHUIUP
      ZLZWTXFCXLDJUJZWTXMXFEHDFUKUQQWJGXLLZWTXGCXLGJUJZWTXOXGEHGFUKUQQULUMWTWKX
      KWTWIXIWJXJWIXMWTXIXNEHDFUNQWJXOWTXJXPEHGFUNQULUMWTXHXKXDPPWKWLXHXKAWTWSW
      LXHXKAWTWSPPPWTXKAWLXHMZWSWTWQAXQXKWRWTWQAXQXKWRPPZPZXIBFLZMZWTWQMZXSWTWN
      YAWPEDBFUOURXTYBXSPXIYBXTXSWQXTXSPWTAXTWQXRAHFLZXBXTWQXRPZPIKYCXTXBYDYCXT
      XBYDPYCXTMZXKWQXQXBWRYEXKWQXQXBWRPZPPXQWQYEXKMZYFWLXHWQYGYFPZPZWLXHYIPZPB
      HWRYJWLWRYIXHWRYHWQWRYFYGWRXBUSUTUTUTUTBHNZWLYJXBXHWQYGYKWLMZWRWTXBXHWQYG
      YLWRPZPPPXCWTYGXHWQXBYMWTYGXHWQXBYMPWTYGMZXHMZWQMZYLXBWRYPYLYFYPYLMZXBWRY
      QWTXJXIGDNZVAZYCXTHBNZVAZVAZXGHDOZWMLZMZWNBGOZWMLZMZMZXBVBYPYLUUBYOYLUUBP
      ZWQYNUUJXHYNYLUUBYNYLMZWTYSUUAYNWTYLWTYGVCRUUKXJXIYRYNXJYLWTYEXIXJVDRYNXI
      YLYGXIWTXKXIYEXIXJVCSSRYLYRYNWLYRYKWLYRDGVEVFSSVGUUKYCXTYTYNYCYLYGYCWTYEY
      CXKYCXTVCRSRYNXTYLWTYCXTXKVHRYLYTYNYKYTWLYKYTBHVEVFRSVGVGTRRUMYPUUIYLYOUU
      EWQUUHXHUUEYNXHUUDXGXFUUDXGXFUUDXEUUCWMDHVIVJVFVKVLSWPUUGWNWPUUGWOUUFWMGB
      VIVJVFVSVMRGHDBEFVNVOVPTVQVRVTWAWBTWCUMWDTVTTVQVOWDSWESWATVTWFTWBRWGTVQWA
      WH $.
  $}

  ${
    $d E f k n p $.  $d V f k n p $.
    $( A friendship graph is connected, see 1. remark after Proposition 1 of
       [MertziosUnger] p. 153 :  "An arbitrary friendship graph has to be
       connected, ...  ".  (Contributed by Alexander van der Vekens,
       6-Dec-2017.) $)
    frconngra $p |- ( V FriendGrph E -> V ConnGrph E ) $=
      ( vf vp vk vn cvv wcel wa cfrgra wbr cconngra cusg frisusgra syl wex wral
      cv co ralimi usgrav cpthon csn cdif chash cfv wceq 2pthfrgra simpl 2eximi
      c2 isconngra1 syl5ibr mpcom ) BGHAGHIZBAJKZBALKZUPBAMKUOABNABUAOUPUQUOCRZ
      DRERZFRBAUBSSKZDPCPZFBUSUCUDZQZEBQZUPUTURUEUFUKUGZIZDPCPZFVBQZEBQVDCABDEF
      UHVHVCEBVGVAFVBVFUTCDUTVEUIUJTTOCEFABGGDULUMUN $.
  $}

  ${
    $d E a $.  $d N a $.  $d V a $.
    $( A vertex in a friendship graph has degree 0 if the graph consists of
       only one vertex.  (Contributed by Alexander van der Vekens,
       6-Dec-2017.) $)
    vdfrgra0 $p |- ( ( V FriendGrph E /\ N e. V /\ ( # ` V ) = 1 )
                     -> ( ( V VDeg E ) ` N ) = 0 ) $=
      ( va cfrgra wbr wcel cfv wceq cvdg co c0 cc0 cvv wa wi cusg frisusgra syl
      syl6bi chash c1 w3a usgrav cv csn wex hash1snb adantr breq1 usgra1v sylib
      wb a1d exlimiv com24 mpcom 3imp oveq2d fveq1d simpld anim1i 3adant3 vdgr0
      eqtrd ) CAEFZBCGZCUAHUBIZUCZBCAJKZHBCLJKZHZMVIBVJVKVIALCJVFVGVHALIZCNGZAN
      GZOZVFVGVHVMPPVFCAQFVPACRACUDSZVPVHVGVFVMVPVHCDUEZUFZIZDUGZVGVFVMPZPZVNVH
      WAUMVOCNDUHUIVTWCDVTWBVGVTVFVSAEFZVMCVSAEUJWDVSAQFVMAVSRVRAUKULTUNUOTUPUQ
      URUSUTVIVNVGOZVLMIVFVGWEVHVFVNVGVFVNVOVQVAVBVCBCNVDSVE $.

    $( A vertex in a friendship graph has degree 0 if the graph consists of
       only one vertex.  (Contributed by Alexander van der Vekens,
       21-Dec-2017.) $)
    vdgfrgra0 $p |- ( ( V FriendGrph E /\ N e. V /\ ( # ` V ) = 1 )
                     -> ( ( V VDeg E ) ` N ) = 0 ) $=
      ( va cfrgra wbr wcel cfv wceq cvdg co c0 cc0 cvv wa wi cusg frisusgra syl
      syl6bi chash c1 w3a usgrav cv csn wex hash1snb adantr breq1 usgra1v sylib
      wb a1d exlimiv com24 mpcom 3imp oveq2d fveq1d simpld anim1i 3adant3 vdgr0
      eqtrd ) CAEFZBCGZCUAHUBIZUCZBCAJKZHBCLJKZHZMVIBVJVKVIALCJVFVGVHALIZCNGZAN
      GZOZVFVGVHVMPPVFCAQFVPACRACUDSZVPVHVGVFVMVPVHCDUEZUFZIZDUGZVGVFVMPZPZVNVH
      WAUMVOCNDUHUIVTWCDVTWBVGVTVFVSAEFZVMCVSAEUJWDVSAQFVMAVSRVRAUKULTUNUOTUPUQ
      URUSUTVIVNVGOZVLMIVFVGWEVHVFVNVGVFVNVOVQVAVBVCBCNVDSVE $.
  $}

  ${
    $d E a b c x $.  $d N a b c x $.  $d V a b c x $.
    $( A vertex in a friendship graph with more than one vertex cannot have
       degree 0.  (Contributed by Alexander van der Vekens, 9-Dec-2017.) $)
    vdn0frgrav2 $p |- ( ( V FriendGrph E /\ E e. Fin /\ N e. V )
                     -> ( 1 < ( # ` V ) -> ( ( V VDeg E ) ` N ) =/= 0 ) ) $=
      ( vx va vb vc wbr cfn wcel w3a cfv cc0 wa cv wceq syl wrex wi cpr c1 cvdg
      cfrgra chash clt co wne cdm crab cusg frisusgra 3ad2ant1 simp3 simp2 3jca
      adantr vdusgraval 3adant3 wral wfn wfun usgrafun funfn sylib 3cyclfrgrarn
      crn preq1 eleq1d preq2 3anbi13d 2rexbidv rspcva fvelrnb prid1g syl5ibrcom
      wn eleq2 reximdv a1dd com13 syl6bi com12 com25 rexlimivv ex pm2.43a com3l
      a1i expcom com15 mpcom 3imp1 rexnal notnot bicomi rexbii bitr3i sylibr c0
      cvv wb dmfi 3ad2ant2 rabexg hasheq0 3syl rabeq0 syl6bb necon3abid eqnetrd
      mpbird ) CAUCHZAIJZBCJZKZUACUDLUEHZBCAUBUFLZMUGXOXPNZXQBDOALZJZDAUHZUIZUD
      LZMXRCAUJHZXNXMKZXQYCPZXOYEXPXOYDXNXMXLXMYDXNACUKZULXLXMXNUMXLXMXNUNUOUPY
      DXNYFXMDBACUQURQXRYCMUGXTVPZDYAUSZVPZXRXTDYARZYJXLXMXNXPYKAYAUTZXLXMXNXPY
      KSSSXLYDYLYGYDAVAYLACVBAVCVDQXPXLXMXNYLYKXLXPXMXNYLYKSZSSZXLXPNEOZFOZTZAV
      FZJZYPGOZTYRJZYTYOTZYRJZKZGCRFCRZECUSZYNACEFGVEXNUUFXMYMUUFXNXMYMSZXNUUFX
      NUUGSZXNUUFNBYPTZYRJZUUAYTBTZYRJZKZGCRFCRZUUHUUEUUNEBCYOBPZUUDUUMFGCCUUOY
      SUUJUUCUULUUAUUOYQUUIYRYOBYPVGVHUUOUUBUUKYRYOBYTVIVHVJVKVLUUMUUHFGCCYPCJZ
      UUMUUHSYTCJUUMUUPUUHUUJUUAUUPUUHSUULUUJYLXNXMUUPYKYLUUJXNXMUUPYKSZSSZYLUU
      JXSUUIPZDYARZUURDYAUUIAVMXMXNUUTUUQXNUUTUUQSSXMXNUUTYKUUPXNUUSXTDYAXNXTUU
      SBUUIJBYPCVNXSUUIBVQVOVRVSWHVTWAWBWCULWBUPWDQWEWFWGQWIWJWKWLYJYHVPZDYARYK
      YHDYAWMUVAXTDYAXTUVAXTWNWOWPWQWRXRYIYCMXRYCMPZYBWSPZYIXRYAIJZYBWTJUVBUVCX
      AXOUVDXPXMXLUVDXNAXBXCUPXTDYAIXDYBWTXEXFXTDYAXGXHXIXKXJWE $.

    $( A vertex in a friendship graph with more than one vertex cannot have
       degree 0.  (Contributed by Alexander van der Vekens, 21-Dec-2017.) $)
    vdgn0frgrav2 $p |- ( ( V FriendGrph E /\ N e. V )
                     -> ( 1 < ( # ` V ) -> ( ( V VDeg E ) ` N ) =/= 0 ) ) $=
      ( vx va vb vc wbr wcel wa cfv cc0 cv wceq adantr syl wrex wi cpr cvv cvdg
      cfrgra c1 chash clt co wne cdm crab cusg frisusgra anim1i vdusgraval wral
      wn wfn wfun usgrafun funfn sylib 3cyclfrgrarn preq1 eleq1d preq2 3anbi13d
      crn w3a 2rexbidv rspcva fvelrnb prid1g eleq2 syl5ibrcom a1dd com12 syl6bi
      reximdv com24 3ad2ant1 rexlimivv pm2.43b expcom com14 mpcom rexnal notnot
      ex imp31 bicomi rexbii bitr3i sylibr c0 usgrav adantl 3syl rabexg hasheq0
      wb dmexg rabeq0 syl6bb necon3abid mpbird eqnetrd ) CAUBHZBCIZJZUCCUDKUEHZ
      BCAUAUFKZLUGXHXIJZXJBDMAKZIZDAUHZUIZUDKZLXKCAUJHZXGJZXJXPNXHXRXIXFXQXGACU
      KZULODBACUMPXKXPLUGXMUOZDXNUNZUOZXKXMDXNQZYBXFXGXIYCAXNUPZXFXGXIYCRRXFXQY
      DXSXQAUQYDACURAUSUTPXIXFXGYDYCXFXIXGYDYCRZRZXFXIJEMZFMZSZAVFZIZYHGMZSYJIZ
      YLYGSZYJIZVGZGCQFCQZECUNZYFACEFGVAYRXGYEXGYRYFXGYRJBYHSZYJIZYMYLBSZYJIZVG
      ZGCQFCQZYFYQUUDEBCYGBNZYPUUCFGCCUUEYKYTYOUUBYMUUEYIYSYJYGBYHVBVCUUEYNUUAY
      JYGBYLVDVCVEVHVIUUCYFFGCCYHCIZUUCYFRYLCIUUCUUFYFYTYMUUFYFRUUBYTYDXGUUFYCY
      DYTXGUUFYCRZRZYDYTXLYSNZDXNQZUUHDXNYSAVJXGUUJUUGXGUUJYCUUFXGUUIXMDXNXGXMU
      UIBYSIBYHCVKXLYSBVLVMVQVNVOVPVOVRVSVOOVTPWGWAPWBWCWDWHYBXTUOZDXNQYCXTDXNW
      EUUKXMDXNXMUUKXMWFWIWJWKWLXKYAXPLXKXPLNZXOWMNZYAXKXNTIZXOTIUULUUMWSXHUUNX
      IXFUUNXGXFXQCTIZATIZJUUNXSACWNUUPUUNUUOATWTWOWPOOXMDXNTWQXOTWRWPXMDXNXAXB
      XCXDXEWG $.
  $}

  ${
    $d E a b c x $.  $d N a b c x $.  $d V a b c x $.  $d E i x $.  $d N i x $.
    $( Any vertex in a friendship graph does not have degree 1, see 2. remark
       after Proposition 1 of [MertziosUnger] p. 153 :  "... no node v of it [a
       friendship graph] may have deg(v) = 1.".  (Contributed by Alexander van
       der Vekens, 10-Dec-2017.) $)
    vdn1frgrav2 $p |- ( ( V FriendGrph E /\ E e. Fin /\ N e. V )
                        -> ( 1 < ( # ` V ) -> ( ( V VDeg E ) ` N ) =/= 1 ) ) $=
      ( vx vb vc va vi wcel w3a c1 cfv wa cv wceq syl cpr wrex wi ex cfrgra wbr
      cfn chash clt cvdg co wne crab cusg frisusgra 3ad2ant1 simp3 simp2 adantr
      cdm 3jca vdusgraval 3adant3 wreu crn 3cyclfrgrarn2 3ad2antl1 preq1 eleq1d
      wral preq2 3anbi13d anbi2d 2rexbidv rspcva adantl simplr simplll ad3antlr
      wn 3simpb usgra2edg1 syl31anc a1d a1i rexlimivv pm2.43a com25 com13 3imp1
      mpd csn wex cvv wb dmfi 3ad2ant2 rabexg hash1snb reusn syl6bbr necon3abid
      mpbird eqnetrd ) CAUAUBZAUCIZBCIZJZKCUDLUEUBZBCAUFUGLZKUHXDXEMZXFBDNALIZD
      AUPZUIZUDLZKXGCAUJUBZXCXBJZXFXKOZXDXMXEXDXLXCXBXAXBXLXCACUKZULXAXBXCUMXAX
      BXCUNUQUOXLXCXNXBDBACURUSPXGXKKUHXHDXIUTZVPZXGENZFNZUHZGNZXRQZAVAZIZXRXSQ
      YCIZXSYAQZYCIZJZMZFCRECRZGCVFZXQXAXBXEYKXCACGEFVBVCXAXBXCXEYKXQSZXCXBXAXE
      YLSXCYKXAXEXBXQYKXCXAXEXBXQSZSZSZXCYKXCYOSZXCYKMXTBXRQZYCIZYEXSBQZYCIZJZM
      ZFCRECRZYPYJUUCGBCYABOZYIUUBEFCCUUDYHUUAXTUUDYDYRYGYTYEUUDYBYQYCYABXRVDVE
      UUDYFYSYCYABXSVGVEVHVIVJVKUUBYPEFCCUUBYPSXRCIXSCIMUUBXCYOUUBXCMZXAYNUUEXA
      MZYMXEUUFXQXBUUFXLXCXTYRYTMZXQXAXLUUEXOVLUUBXCXAVMXTUUAXCXAVNUUAUUGXTXCXA
      YRYEYTVQVODABCEFVRVSVTVTTTWAWBPTWCWDWEWFWGXGXPXKKXGXKKOZXJHNWHOHWIZXPXGXJ
      WJIZUUHUUIWKXGXIUCIZUUJXDUUKXEXBXAUUKXCAWLWMUOXHDXIUCWNPXJWJHWOPXHDHXIWPW
      QWRWSWTT $.

    $( Any vertex in a friendship graph does not have degree 1, see 2. remark
       after Proposition 1 of [MertziosUnger] p. 153 :  "... no node v of it [a
       friendship graph] may have deg(v) = 1.".  (Contributed by Alexander van
       der Vekens, 21-Dec-2017.) $)
    vdgn1frgrav2 $p |- ( ( V FriendGrph E /\ N e. V )
                       -> ( 1 < ( # ` V ) -> ( ( V VDeg E ) ` N ) =/= 1 ) ) $=
      ( vx vb vc va vi wbr wcel wa c1 cfv cv wceq cpr wrex wi ex cvv cfrgra clt
      chash cvdg co wne cdm crab cusg frisusgra anim1i adantr vdusgraval syl wn
      wreu crn wral 3cyclfrgrarn2 adantlr preq1 eleq1d 3anbi13d anbi2d 2rexbidv
      w3a preq2 rspcva adantl simplr simplll 3simpb ad3antlr usgra2edg1 a1d a1i
      syl31anc rexlimivv pm2.43a com24 com3r imp31 mpd csn wex wb usgrav simprd
      dmexg 3syl rabexg hash1snb reusn syl6bbr necon3abid mpbird eqnetrd ) CAUA
      IZBCJZKZLCUCMUBIZBCAUDUEMZLUFWTXAKZXBBDNAMJZDAUGZUHZUCMZLXCCAUIIZWSKZXBXG
      OWTXIXAWRXHWSACUJZUKULDBACUMUNXCXGLUFXDDXEUPZUOZXCENZFNZUFZGNZXMPZAUQZJZX
      MXNPXRJZXNXPPZXRJZVFZKZFCQECQZGCURZXLWRXAYFWSACGEFUSUTWRWSXAYFXLRZWSXAWRY
      GWSYFWRXAXLYFWSWRXAXLRZRZWSYFWSYIRZWSYFKXOBXMPZXRJZXTXNBPZXRJZVFZKZFCQECQ
      ZYJYEYQGBCXPBOZYDYPEFCCYRYCYOXOYRXSYLYBYNXTYRXQYKXRXPBXMVAVBYRYAYMXRXPBXN
      VGVBVCVDVEVHYPYJEFCCYPYJRXMCJXNCJKYPWSYIYPWSKZWRYHYSWRKZXLXAYTXHWSXOYLYNK
      ZXLWRXHYSXJVIYPWSWRVJXOYOWSWRVKYOUUAXOWSWRYLXTYNVLVMDABCEFVNVQVOSSVPVRUNS
      VSVTWAWBWCXCXKXGLXCXGLOZXFHNWDOHWEZXKXCXETJZXFTJUUBUUCWFWTUUDXAWRUUDWSWRX
      HATJZUUDXJXHCTJUUEACWGWHATWIWJULULXDDXETWKXFTHWLWJXDDHXEWMWNWOWPWQS $.
  $}

  $( Any vertex in a friendship graph (with more than one vertex - then,
     actually, the graph must have at least three vertices, because otherwise,
     it would not be a friendship graph) has at least degree 2, see 3. remark
     after Proposition 1 of [MertziosUnger] p. 153 :  "It follows that deg(v)
     >= 2 for every node v of a friendship graph".  (Contributed by Alexander
     van der Vekens, 21-Dec-2017.) $)
  vdgfrgragt2 $p |- ( ( V FriendGrph E /\ N e. V )
                     -> ( 1 < ( # ` V ) -> 2 <_ ( ( V VDeg E ) ` N ) ) ) $=
    ( cfrgra wbr wcel wa c1 cfv c2 cle wne imp wi cn0 cpnf cvv syl adantr a1d
    chash clt cvdg co cc0 vdgn0frgrav2 vdgn1frgrav2 csn cun cdm wfn w3a wf cusg
    frisusgra usgrav simpld wfun usgrafun funfn sylib dmexg 3jca vdgrf ffvelrnd
    simprd simpr wo elun nn0n0n1ge2 3exp wceq elsni cxr rexri pnfge ax-mp breq2
    2re mpbiri jaoi sylbi mp2d ex ) CADEZBCFZGZHCUAIUBEZJBCAUCUDZIZKEZWGWHGWJUE
    LZWJHLZWKWGWHWLABCUFMWGWHWMABCUGMWGWLWMWKNZNZWHWGWJOPUHZUIZFZWOWGCWQBWIWGCQ
    FZAAUJZUKZWTQFZULZCWQWIUMWEXCWFWEWSXAXBWECAUNEZWSACUOZXDWSAQFZACUPZUQRWEAUR
    ZXAWEXDXHXEACUSRAUTVAWEXFXBWEXDXFXEXDWSXFXGVFRAQVBRVCSWTACQQVDRWEWFVGVEWRWJ
    OFZWJWPFZVHWOWJOWPVIXIWOXJXIWLWMWKWJVJVKXJWJPVLZWOWJPVMXKWNWLXKWKWMXKWKJPKE
    ZJVNFXLJVSVOJVPVQWJPJKVRVTTTRWAWBRSWCWD $.

  ${
    $d y D $.  $d a b x y V $.  $d a b x y E $.  $d b y Y $.  $d y ph $.
    frgrancvvdeq.nx $e |- D = ( <. V , E >. Neighbors X ) $.
    frgrancvvdeq.ny $e |- N = ( <. V , E >. Neighbors Y ) $.
    frgrancvvdeq.x $e |- ( ph -> X e. V ) $.
    frgrancvvdeq.y $e |- ( ph -> Y e. V ) $.
    frgrancvvdeq.ne $e |- ( ph -> X =/= Y ) $.
    frgrancvvdeq.xy $e |- ( ph -> Y e/ D ) $.
    frgrancvvdeq.f $e |- ( ph -> V FriendGrph E ) $.
    $( The function A maps each neighbor x of X to a neighbor y of Y. In a
       a friendship graph, there is a unique y, the common neighbor of x and Y.
       This corresponds to the map "alpha" defined in the proof of the
       [friendship] theorem in [Huneke] p. 1: "Define a map a : N(x) -> N(y) by
       sending a vertex z [in] N(x) to the common neighbor of z and y.". $)
    frgrancvvdeq.a $e |- A = ( x e. D |->
                             ( iota_ y e. N { x , y } e. ran E ) ) $.
    $( Lemma 1 for ~ frgrancvvdeq .  (Contributed by Alexander van der Vekens,
       22-Dec-2017.) $)
    frgrancvvdeqlem1 $p |- ( ( ph /\ x e. D ) -> Y e. ( V \ { x } ) ) $=
      ( wcel adantr cv wa csn wceq wn wi df-nel eleq1a con3rr3 sylbi syl imp wb
      wnel elsncg mtbird eldifd ) ABUAZESZUBZJHURUCZAJHSZUSNTUTJVASZJURUDZAUSVD
      UEZAJEUNZUSVEUFZPVFJESZUEVGJEUGUSVDVHUREJUHUIUJUKULAVCVDUMZUSAVBVINJURHUO
      UKTUPUQ $.

    $( Lemma 2 for ~ frgrancvvdeq .  (Contributed by Alexander van der Vekens,
       23-Dec-2017.) $)
    frgrancvvdeqlem2 $p |- ( ph -> X e/ N ) $=
      ( wnel wcel cop cnbgra co wi cpr crn cfrgra wbr cusg frisusgra nbgraeledg
      wb 3syl wn df-nel eleq2i xchbinx notbid syl5bb prcom eleq1i pm2.21 sylnbi
      syl6bi mpd sylbid com12 ax-1 sylbir pm2.61i eqidd wceq neleq12d mpbird
      a1i ) AIGSIHFUAZJUBUCZSZIVQTZAVRUDZAVSVRAVSIJUEZFUFZTZVRAHFUGUHZHFUIUHZVS
      WCULQFHUJZFJIHUKUMAJESZWCVRUDZPAWGJIUEZWBTZUNZWHWGJVPIUBUCZTZUNAWKWGJETWM
      JEUOEWLJKUPUQAWMWJAWDWEWMWJULQWFFIJHUKUMURUSWJWCWHWIWAWBJIUTVAWCVRVBVCVDV
      EVFVGVSUNVRVTIVQUOVRAVHVIVJAIIGVQAIVKGVQVLALVOVMVN $.

    $( Lemma 3 for ~ frgrancvvdeq .  In a friendship graph, for each neighbor
       of a vertex there is exacly one neighbor of another vertex so that there
       is an edge between these two neighbors.  (Contributed by Alexander van
       der Vekens, 22-Dec-2017.) $)
    frgrancvvdeqlem3 $p |- ( ( ph /\ x e. D )
                             -> E! y e. N { x , y } e. ran E ) $=
      ( wcel wa cv cpr crn wss wreu cfrgra wbr wne w3a adantr cop cnbgra eleq2i
      co cusg wi frisusgra nbgraisvtx 3syl syl5bi imp csn cdif frgrancvvdeqlem1
      wn eldif wceq vex snid eleq1 eqcoms mpbiri necon3bi adantl sylbi syl 3jca
      wb frgraunss sylc prex prss simpr sylbir ad2antll eleq2d nbgraeledg bitrd
      weu a1i mpbird simpl ex syl5bb biimpd impcom ad2antlr id anim12ci mpancom
      jca sylib impancom com12 impbid eubidv df-reu 3imtr4g mpd ) ABUAZESZTZXJC
      UAZUBZXMJUBZUBFUCZUDZCHUEZXNXPSZCGUEZXLHFUFUGZXJHSZJHSZXJJUHZUIXRAYAXKQUJ
      XLYBYCYDAXKYBXKXJHFUKZIULUNZSZAYBEYFXJKUMAYAHFUOUGZYGYBUPQFHUQZFIXJHURUSU
      TVAAYCXKNUJXLJHXJVBZVCSZYDABCDEFGHIJKLMNOPQRVDYKYCJYJSZVEZTYDJHYJVFYMYDYC
      YLXJJXJJVGYLXJYJSZXJBVHVIYLYNVRJXJJXJYJVJVKVLVMVNVOVPVQXJJFHCVSVTXLXMHSZX
      QTZCWIZXMGSZXSTZCWIZXRXTXLYQYTXLYPYSCXLYPYSXLYPYSXLYPTZYRXSUUAYRXOXPSZXQU
      UBXLYOXQXSUUBTZUUBXNXOXPXJXMWAXMJWAWBZXSUUBWCWDWEXLYRUUBVRZYPAUUEXKAYRXMY
      EJULUNZSZUUBAGUUFXMGUUFVGALWJWFAYAYHUUGUUBVRQYIFJXMHWGUSZWHUJUJWKXQXSXLYO
      XQUUCXSUUDXSUUBWLWDWEXAWMYSXLYPYRXLXSYPUUBYRXLTZXSYPUPXLYRUUBAYRUUBUPXKAY
      RUUBYRUUGAUUBGUUFXMLUMZUUHWNWOUJWPUUBUUITZXSYPUUKXSTZYOXQUUIYOUUBXSXLYRYO
      AYRYOUPXKYRUUGAYOUUJAYAYHUUGYOUPQYIFJXMHURUSUTUJWPWQUULUUCXQUUKUUBXSXSUUB
      UUIWLXSWRWSUUDXBXAWMWTXCXDXEXFWOXQCHXGXSCGXGXHXI $.

    $d a b n x y V $.  $d n D $.  $d n E $.  $d n y N $.  $d n Y $.  $d n ph $.
    $( Lemma 4 for ~ frgrancvvdeq .  The restricted iota of a vertex is the
       intersection of the corresponding neighborhoods.  (Contributed by
       Alexander van der Vekens, 18-Dec-2017.) $)
    frgrancvvdeqlem4 $p |- ( ( ph /\ x e. D )
                             -> { ( iota_ y e. N { x , y } e. ran E ) }
                                  = ( ( <. V , E >. Neighbors x ) i^i N ) ) $=
      ( vn wcel va vb cv wa cop cnbgra co cin cpr crn crio csn ineq2i cdif wceq
      wrex wral eleq2i cusg wbr wi cfrgra frisusgra nbgraisvtx frgrancvvdeqlem1
      syl syl5bi imp adantr frisusgranb jca31 sneq difeq2d oveq2 ineq1d rexbidv
      weq eqeq1d raleqbidv rspcva ineq2d vex snid wb eleq2 eqcoms biimpi syl6bi
      elin nbgraeledg prcom eleq1i syl6bb biimpd eqcomi adantl frgrancvvdeqlem3
      mpi com12 wreu preq2 eleq1d riota2 syl2an mpbid sylan eqcomd sneqd mpbird
      eqeq1 ex rexlimivw expcom impancom mpcom syl5req ) ABUCZETZUDZHFUEZXQUFUG
      ZGUHYAXTJUFUGZUHZXQCUCZUIZFUJZTZCGUKZULZGYBYALUMXQHTZJHXQULZUNZTZUDZXTUAU
      CZUFUGZXTUBUCZUFUGZUHZSUCZULZUOZSHUPZUBHYOULZUNZUQZUAHUQZUDXSYCYIUOZXSYJY
      MUUGAXRYJXRXQXTIUFUGZTZAYJEUUIXQKURAHFUSUTZUUJYJVAAHFVBUTZUUKQFHVCVFZFIXQ
      HVDVFVGVHABCDEFGHIJKLMNOPQRVEXSUULUUGAUULXRQVISUAFHUBVJVFVKYNUUGXSUUHVAZY
      JUUGYMUUNYJUUGUDYAYRUHZUUAUOZSHUPZUBYLUQZYMUUNVAUUFUURUAXQHUABVQZUUCUUQUB
      UUEYLUUSUUDYKHYOXQVLVMUUSUUBUUPSHUUSYSUUOUUAUUSYPYAYRYOXQXTUFVNVOVRVPVSVT
      YMUURUUNYMUURUDYCUUAUOZSHUPZUUNUUQUVAUBJYLYQJUOZUUPUUTSHUVBUUOYCUUAUVBYRY
      BYAYQJXTUFVNWAVRVPVTUUTUUNSHUUTXSUUHUUTXSUDZUUHUUAYIUOZUVCYTYHUVCYHYTUUTY
      TYATZYTYBTZUDZXSYHYTUOZUUTYTUUATZUVGYTSWBWCUUTUVIYTYCTZUVGUVIUVJWDUUAYCUU
      AYCYTWEWFUVJUVGYTYAYBWIWGWHWRUVGXSUDXQYTUIZYFTZUVHUVGXSUVLUVEXSUVLVAUVFXS
      UVEUVLAUVEUVLVAZXRAUUKUVMUUMUUKUVEUVLUUKUVEYTXQUIZYFTUVLFXQYTHWJUVNUVKYFY
      TXQWKWLWMWNVFVIWSVIVHUVGYTGTZYGCGWTUVLUVHWDXSUVFUVOUVEUVFUVOYBGYTGYBLWOUR
      WGWPABCDEFGHIJKLMNOPQRWQYGUVLCGYTCSVQYEUVKYFYDYTXQXAXBXCXDXEXFXGXHUUTUUHU
      VDWDXSYCUUAYIXJVIXIXKXLVFXMVFXNVHXOXP $.

    $d x D $.  $d x N $.  $d x ph $.
    $( Lemma 5 for ~ frgrancvvdeq .  The mapping of neighbors to neighbors is a
       function.  (Contributed by Alexander van der Vekens, 22-Dec-2017.) $)
    frgrancvvdeqlem5 $p |- ( ph -> A : D --> N ) $=
      ( cv wcel cpr crn crio wa wreu frgrancvvdeqlem3 riotacl syl fmptd ) ABEBS
      ZCSUAFUBTZCGUCZGDAUJETUDUKCGUEULGTABCDEFGHIJKLMNOPQRUFUKCGUGUHRUI $.

    $( Lemma 6 for ~ frgrancvvdeq .  The mapping of neighbors to neighbors
       applied on a vertex is the intersection of the corresponding
       neighborhoods.  (Contributed by Alexander van der Vekens,
       23-Dec-2017.) $)
    frgrancvvdeqlem6 $p |- ( ( ph /\ x e. D ) -> { ( A ` x ) }
                             = ( ( <. V , E >. Neighbors x ) i^i N ) ) $=
      ( cv wcel wa cfv csn cpr crn crio cop cnbgra co cin cvv wceq simpr fvmpt2
      riotaex sylancl sneqd frgrancvvdeqlem4 eqtrd ) ABSZETZUAZUTDUBZUCUTCSUDFU
      ETZCGUFZUCHFUGUTUHUIGUJVBVCVEVBVAVEUKTVCVEULAVAUMVDCGUOBEVEUKDRUNUPUQABCD
      EFGHIJKLMNOPQRURUS $.

    $( Lemma 7 for ~ frgrancvvdeq .  (Contributed by Alexander van der Vekens,
       23-Dec-2017.) $)
    frgrancvvdeqlem7 $p |- ( ( ph /\ x e. D )
                             -> { x , ( A ` x ) } e. ran E ) $=
      ( wcel wi cv cfv csn cop cnbgra co cin wceq cpr crn frgrancvvdeqlem6 fvex
      snid eleq2 biimpd elin cfrgra wbr cusg frisusgra nbgraeledg eleq1i syl6bb
      wa prcom 3syl adantr com12 sylbi syl6com ax-mp mpcom ) BUAZDUBZUCZHFUDVMU
      EUFZGUGZUHZAVMESZVDZVMVNUIZFUJZSZABCDEFGHIJKLMNOPQRUKVNVOSZVRVTWCTZTVNVMD
      ULUMVRWDVNVQSZWEVRWDWFVOVQVNUNUOWFVNVPSZVNGSZVDWEVNVPGUPWGWEWHVTWGWCAWGWC
      TZVSAHFUQURHFUSURZWIQFHUTWJWGWCWJWGVNVMUIZWBSWCFVMVNHVAWKWAWBVNVMVEVBVCUO
      VFVGVHVGVIVJVKVL $.

    $( Lemma A for ~ frgrancvvdeq .  This corresponds to the following
       observation in [Huneke] p. 1:  "This common neighbor cannot be x, as x
       and y are not adjacent.".  (Contributed by Alexander van der Vekens,
       23-Dec-2017.) $)
    frgrancvvdeqlemA $p |- ( ph -> A. x e. D ( A ` x ) =/= X ) $=
      ( wcel wa cv cfv wne csn cop cnbgra co wceq frgrancvvdeqlem6 wi fvex snid
      cin eleq2 biimpa elin wnel frgrancvvdeqlem2 wn df-nel eleq1 biimpcd df-ne
      con3rr3 syl6ibr sylbi syl adantr com12 adantl mpan2 mpcom ralrimiva ) ABU
      AZDUBZIUCZBEVOUDZHFUEVNUFUGZGUMZUHZAVNESZTZVPABCDEFGHIJKLMNOPQRUIVTVOVQSZ
      WBVPUJZVOVNDUKULVTWCTVOVSSZWDVTWCWEVQVSVOUNUOWEVOVRSZVOGSZTWDVOVRGUPWGWDW
      FWBWGVPAWGVPUJZWAAIGUQZWHABCDEFGHIJKLMNOPQRURWIIGSZUSZWHIGUTWKWGVOIUHZUSV
      PWGWLWJWLWGWJVOIGVAVBVDVOIVCVEVFVGVHVIVJVFVGVKVLVM $.

    $d u w A $.  $d u w D $.  $d u w x y N $.  $d u w E $.  $d u w V $.
    $d u w ph $.
    $( Lemma B for ~ frgrancvvdeq .  This corresponds to the following
       observation in [Huneke] p. 1:  "The map is one-to-one since z in N(x) is
       uniquely determined as the common neighbor of x and a(x)".  (Contributed
       by Alexander van der Vekens, 23-Dec-2017.) $)
    frgrancvvdeqlemB $p |- ( ph -> A : D -1-1-> ran A ) $=
      ( wa wi vu vw wf crn wf1 frgrancvvdeqlem5 cfv wceq weq wral wfn ffn dffn3
      cv sylib adantl wcel wn ffvelrn adantll adantr wnel frgrancvvdeqlem2 crio
      cpr preq1 eleq1d riotabidv cbvmptv eqtri frgrancvvdeqlem7 anim12dan preq2
      cmpt anbi2d eqcoms biimpa wne df-ne frgranbnb 3expa df-nel pm2.24d expcom
      wb eleq1 com13 sylbi com12 syl6 com23 sylbir syl5com com24 mpcom ex com3r
      com15 exp3a imp41 mpid pm2.18d ralrimiva dff13 sylanbrc ) EGDUCZAEDUDZDUE
      ZABCDEFGHIJKLMNOPQRUFAXFXHAXFSZEXGDUCZUAUNZDUGZUBUNZDUGZUHZUAUBUIZTZUBEUJ
      ZUAEUJXHXFXJAXFDEUKXJEGDULEDUMUOUPXIXRUAEXIXKEUQZSZXQUBEXTXMEUQZSZXOXPYBX
      OSZXPYCXPURZXLGUQZXPYBYEXOXTYEYAXFXSYEAEGXKDUSUTVAVAXIXSYAXOYDYEXPTZTZAXS
      YAXOYGTZTTXFAXSYAYHIGVBZAXSYASZYHTABCDEFGHIJKLMNOPQRVCYDAYJXOYIYFAYJYDXOY
      IYFTZTZAYJYDYLTZXKXLVEFUDZUQZXMXNVEZYNUQZSZAYJSZYMAXSYOYAYQAUACDEFGHIJKLM
      NOPQDBEBUNZCUNZVEZYNUQZCGVDZVNZUAEXKUUAVEZYNUQZCGVDZVNRBUAEUUDUUHBUAUIZUU
      CUUGCGUUIUUBUUFYNYTXKUUAVFVGVHVIVJVKAUBCDEFGHIJKLMNOPQDUUEUBEXMUUAVEZYNUQ
      ZCGVDZVNRBUBEUUDUULBUBUIZUUCUUKCGUUMUUBUUJYNYTXMUUAVFVGVHVIVJVKVLYRXOYDYS
      YKXOYRYDYSYKTZTXOYRSYOXMXLVEZYNUQZSZYDUUNXOYRUUQYRUUQWEXNXLXNXLUHZYQUUPYO
      UURYPUUOYNXNXLXMVMVGVOVPVQYDXKXMVRZUUQUUNTXKXMVSUUSYSUUQYKYSUUSUUQYKTYSUU
      SSUUQXLIUHZYKAYJUUSUUQUUTTAXLEXKFHXMIMKQVTWAYIUUTYFYIIGUQZURZUUTYFTIGWBYE
      UUTUVBXPUUTYEUVBXPTUUTYESUVAXPUUTYEUVAXLIGWFVQWCWDWGWHWIWJWDWKWLWMWDWNWOW
      PWQWRWOWSVAWTXAXBWPXCXCUAUBEXGDXDXEWDWO $.

    $d m n x y E $.  $d m X $.  $d m V $.  $d m D $.  $d m N $.  $d m n A $.
    $d m ph $.
    $( Lemma C for ~ frgrancvvdeq .  This corresponds to the following
       observation in [Huneke] p. 1:  "By symmetry the map is onto".
       (Contributed by Alexander van der Vekens, 24-Dec-2017.) $)
    frgrancvvdeqlemC $p |- ( ph -> A : D -onto-> N ) $=
      ( vm wcel vn wf cv cfv wceq wrex wral wfo frgrancvvdeqlem5 wa wex cpr crn
      cfrgra wbr wne w3a wreu adantr cnbgra co eleq2i cusg frisusgra nbgraisvtx
      cop wi 3syl syl5bi imp wnel frgrancvvdeqlem2 df-nel eleq1 biimpcd con3rr3
      df-ne syl6ibr sylbi syl 3jca jca frgraun reurex df-rex simprrr nbgraeledg
      wn sylib ad2antlr syl5bb mpbird biimprcd adantl com12 cin elin csn simpll
      wb bicomd biimpa sylibr crio cmpt preq1 eleq1d riotabidv frgrancvvdeqlem6
      weq eqtri eleq2 eqcoms elsni syl6bi expcom ad2antll com3r sylbir ex com14
      cbvmptv imp31 mpd mpdan eximdv ralrimiva dffo3 sylanbrc ) AEGDUBUAUCZSUCZ
      DUDZUEZSEUFZUAGUGEGDUHABCDEFGHIJKLMNOPQRUIAYNUAGAYJGTZUJZYKETZYMUJZSUKZYN
      YPYKHTZYJYKULFUMZTZYKIULUUATZUJZUJZSUKZYSYPHFUNUOZYJHTZIHTZYJIUPZUQZUJUUD
      SHURZUUFYPUUGUUKAUUGYOQUSYPUUHUUIUUJAYOUUHYOYJHFVFZJUTVAZTZAUUHGUUNYJLVBA
      UUGHFVCUOZUUOUUHVGQFHVDZFJYJHVEVHVIVJAUUIYOMUSAYOUUJAIGVKZYOUUJVGZABCDEFG
      HIJKLMNOPQRVLUURIGTZWHZUUSIGVMUVAYOYJIUEZWHUUJYOUVBUUTUVBYOUUTYJIGVNVOVPY
      JIVQVRVSVTVJWAWBUUGUUKUULYJIFHSWCVJUULUUDSHUFUUFUUDSHWDUUDSHWEWIVHYPUUEYR
      SAYOUUEYRVGZAUUPYOUVCVGAUUGUUPQUUQVTAUUPUJZYOUVCUVDYOUJZUUEYRUVEUUEUJZYQY
      MUVFYQUUCUVEYTUUBUUCWFYQYKUUMIUTVAZTZUVFUUCEUVGYKKVBZUVEUVHUUCWTZUUEUUPUV
      JAYOFIYKHWGZWJUSWKWLUVFYJUUMYKUTVAZTZYMUVEUUEUVMUUPUUEUVMVGAYOUUEUUPUVMUU
      DUUPUVMVGZYTUUBUVNUUCUUPUVMUUBFYKYJHWGWMUSWNWOWJVJUVDYOUUEUVMYMVGUVMYOUUE
      UVDYMUVMYOUUEUVDYMVGVGZUVMYOUJYJUVLGWPZTZUVOYJUVLGWQUUEUVDUVQYMUUCUVDUVQY
      MVGZVGYTUUBUVDUUCUVRUVDUUCUJZAYQUJYLWRZUVPUEZUVRUVSAYQAUUPUUCWSUVSUVHYQUV
      DUUCUVHUUPUUCUVHWTAUUPUVHUUCUVKXAWNXBUVIXCWBASCDEFGHIJKLMNOPQDBEBUCZCUCZU
      LZUUATZCGXDZXESEYKUWCULZUUATZCGXDZXERBSEUWFUWIBSXJZUWEUWHCGUWJUWDUWGUUAUW
      BYKUWCXFXGXHYBXKXIUWAUVQYJUVTTZYMUVQUWKWTUVPUVTUVPUVTYJXLXMYJYLXNXOVHXPXQ
      XRXSXTYAYCYDWBXTXTYEVJYFYDYMSEWEXCYGSUAEGDYHYI $.

    $( Lemma 8 for ~ frgrancvvdeq .  (Contributed by Alexander van der Vekens,
       24-Dec-2017.) $)
    frgrancvvdeqlem8 $p |- ( ph -> A : D -1-1-onto-> N ) $=
      ( wf1 wfo wf1o crn wss frgrancvvdeqlemB frgrancvvdeqlem5 frn f1ss syl2anc
      wf syl frgrancvvdeqlemC df-f1o sylanbrc ) AEGDSZEGDTEGDUAAEDUBZDSUOGUCZUN
      ABCDEFGHIJKLMNOPQRUDAEGDUIUPABCDEFGHIJKLMNOPQRUEEGDUFUJEUOGDUGUHABCDEFGHI
      JKLMNOPQRUKEGDULUM $.
  $}

  ${
    $d E f u w x y $.  $d V f u w x y $.
    $( Lemma 9 for ~ frgrancvvdeq .  (Contributed by Alexander van der Vekens,
       24-Dec-2017.) $)
    frgrancvvdeqlem9 $p |- ( V FriendGrph E
        -> A. x e. V A. y e. ( V \ { x } ) ( y e/ ( <. V , E >. Neighbors x )
             -> E. f f : ( <. V , E >. Neighbors x )
                         -1-1-onto-> ( <. V , E >. Neighbors y ) ) ) $=
      ( vu vw cfrgra wbr cv cop cnbgra co wf1o wcel cvv eqid ad2antlr ralrimiva
      wa wnel wex wi csn cdif wral cpr crn crio cmpt ovex mptexg simpllr eldifi
      mp1i wne wn eldif weq biimpri equcoms necon3bi adantl sylbi simpr simplll
      elsn frgrancvvdeqlem8 f1oeq1 spcegv sylc ex ) EDHIZBJZEDKZAJZLMZUAZVQVOVN
      LMZCJZNZCUBZUCZBEVPUDZUEZUFAEVMVPEOZTZWCBWEWGVNWEOZTZVRWBWIVRTZFVQFJGJUGD
      UHOGVSUIZUJZPOZVQVSWLNZWBVQPOWMWJVOVPLUKFVQWKPULUOWJFGWLVQDVSEVPVNVQQVSQV
      MWFWHVRUMWHVNEOZWGVRVNEWDUNRWHVPVNUPZWGVRWHWOVNWDOZUQZTWPVNEWDURWRWPWOWQV
      PVNWQBAWQBAUSBVPVGUTVAVBVCVDRWIVRVEVMWFWHVRVFWLQVHWAWNCWLPVQVSVTWLVIVJVKV
      LSS $.
  $}

  ${
    $d E f x y $.  $d V f x y $.
    $( In a finite friendship graph, two vertices which are not connected by an
       edge have the same degree.  This corresponds to the first Lemma
       ("claim") of the proof of the (friendship) theorem in [Huneke] p. 1:
       "If x,y are elements of (the friendship graph) G and are not adjacent,
       then they have the same degree (i.e., the same number of adjacent
       vertices).".  (Contributed by Alexander van der Vekens, 19-Dec-2017.) $)
    frgrancvvdeq $p |- ( ( V FriendGrph E /\ E e. Fin )
        -> A. x e. V A. y e. ( V \ { x } ) ( y e/ ( <. V , E >. Neighbors x )
             -> ( ( V VDeg E ) ` x ) = ( ( V VDeg E ) ` y ) ) ) $=
      ( vf wbr cfn wcel wa cv cnbgra co wi wral cfv wceq adantr simpr 3jca syl
      cfrgra cop wnel wf1o wex csn cdif cvdg frgrancvvdeqlem9 chash imp wb cusg
      w3a frisusgra nbusgrafi eldifi adantl hasheqf1o syl2anc hashnbgravd exp31
      mpbird 3eqtr3d ralimdva mpd ) DCUAFZCGHZIZBJZDCUBZAJZKLZUCZVMVKVJKLZEJUDE
      UEZMZBDVLUFZUGZNZADNZVNVLDCUHLZOZVJWBOZPZMZBVSNZADNVGWAVHABECDUIQVIVTWGAD
      VIVLDHZIZVQWFBVSWIVJVSHZIZVQVNWEWKVQIZVNIZVMUJOZVOUJOZWCWDWMWNWOPZVPWLVNV
      PWKVQRUKWLWPVPULZVNWKWQVQWKVMGHZVOGHZWQWKDCUMFZWHVHUNZWRWIXAWJWIWTWHVHVIW
      TWHVGWTVHCDUOQQZVIWHRZVIVHWHVGVHRQZSQCVLDUPTWKWTVJDHZVHUNZWSWKWTXEVHWIWTW
      JXBQZWJXEWIVJDVRUQURWIVHWJXDQZSZCVJDUPTVMVOEUSUTQQVCWMXAWNWCPWLXAVNWKXAVQ
      WKWTWHVHXGWIWHWJXCQXHSQQVLCDVATWMXFWOWDPWLXFVNWKXFVQXIQQVJCDVATVDVBVEVEVF
      $.

    $( In a friendship graph, two vertices which are not connected by an edge
       have the same degree.  This corresponds to the first Lemma ("claim") of
       the proof of the (friendship) theorem in [Huneke] p. 1:  "If x,y, are
       elements of (the friendship graph) G and are not adjacent, then they
       have the same degree (i.e., the same number of adjacent vertices).".
       (Contributed by Alexander van der Vekens, 19-Dec-2017.) $)
    frgrancvvdgeq $p |- ( V FriendGrph E -> A. x e. V A. y e. ( V \ { x } )
             ( y e/ ( <. V , E >. Neighbors x )
             -> ( ( V VDeg E ) ` x ) = ( ( V VDeg E ) ` y ) ) ) $=
      ( vf wbr cv cnbgra co wi wral cfv wceq wcel chash cvv ovex ad2antrr jca
      wa cfrgra cop wnel wf1o cdif cvdg frgrancvvdeqlem9 pm3.2i hasheqf1oi mp1i
      wex csn imim2d imp31 cusg frisusgra simplr hashnbgravdg syl eldifi adantl
      3eqtr3d exp31 ralimdva mpd ) DCUAFZBGZDCUBZAGZHIZUCZVJVHVGHIZEGUDEUKZJZBD
      VIULZUEZKZADKVKVIDCUFIZLZVGVRLZMZJZBVPKZADKABECDUGVFVQWCADVFVIDNZTZVNWBBV
      PWEVGVPNZTZVNVKWAWGVNTVKTZVJOLZVLOLZVSVTWGVNVKWIWJMZWGVMWKVKVJPNZVLPNZTVM
      WKJWGWLWMVHVIHQVHVGHQUHVJVLEPPUIUJUMUNWHDCUOFZWDTZWIVSMWGWOVNVKWGWNWDVFWN
      WDWFCDUPRZVFWDWFUQSRVICDURUSWHWNVGDNZTZWJVTMWGWRVNVKWGWNWQWPWFWQWEVGDVOUT
      VASRVGCDURUSVBVCVDVDVE $.
  $}

  ${
    $d x A $.  $d x E $.  $d x K $.  $d x V $.  $d x X $.  $d x Y $.
    frgrawopreg.a $e |- A = { x e. V | ( ( V VDeg E ) ` x ) = K } $.
    frgrawopreg.b $e |- B = ( V \ A ) $.
    $( The definition of A and B corresponds to the definition in the proof of
       [Huneke] p. 2: "Let A be the set of all vertices of degree k, let B be
       the set of all vertices of degree different from k, ..." $)

    $( Lemma 1 for ~ frgrawopreg .  In a friendship graph, the classes A and B
       are sets.  (Contributed by Alexander van der Vekens, 31-Dec-2017.) $)
    frgrawopreglem1 $p |- ( V FriendGrph E -> ( A e. _V /\ B e. _V ) ) $=
      ( cfrgra wbr cusg cvv wcel wa frisusgra usgrav cv cvdg co syl5eqel rabexg
      cfv wceq crab cdif difexg jca adantr 3syl ) FDIJFDKJFLMZDLMZNBLMZCLMZNZDF
      ODFPUJUNUKUJULUMUJBAQFDRSUBEUCZAFUDLGUOAFLUATUJCFBUELHFBLUFTUGUHUI $.

    $( Lemma 2 for ~ frgrawopreg .  In a friendship graph with at least 2
       vertices, the degree of a vertex must be at least 2.  (Contributed by
       Alexander van der Vekens, 30-Dec-2017.) $)
    frgrawopreglem2 $p |- ( ( V FriendGrph E /\ 1 < ( # ` V ) /\ A =/= (/) )
                            -> 1 < K ) $=
      ( wbr c1 clt wcel wi wceq cn0 cpnf c2 cle sylbi com13 cfrgra chash cfv c0
      wne cv wex n0 cvdg co wa rabeq2i exbii csn cun frisusgra vdgrnn0pnf sylan
      cusg vdgfrgragt2 wo elun cmin cz wb nn0z zlem1lt sylancr 2m1e1 a1i breq1d
      2z bitrd biimpd elsni cr 1re ltpnf ax-mp id syl5breqr a1d syl eleq1 breq2
      jaoi imbi1d 3imtr4d syl6com mpcom expcom com24 imp exlimiv 3imp ) FDUAIZJ
      FUBUCKIZBUDUEZJEKIZWRWQWPWSWRAUFZBLZAUGZWQWPWSMMZABUHXBWTFLZWTFDUIUJUCZEN
      ZUKZAUGXCXAXGAXFABFGULUMXGXCAXDXFXCXDWPWQXFWSWPXDWQXFWSMZMZXEOPUNZUOZLZWP
      XDUKZXIWPFDUSIXDXLDFUPDFWTUQURWQXMXLXHXMWQQXERIZXLXHMDWTFUTXFXLXNWSXFEXKL
      ZQERIZWSMZXLXNWSMXOXQMXFXOEOLZEXJLZVAXQEOXJVBXRXQXSXRXPWSXRXPQJVCUJZEKIZW
      SXRQVDLEVDLXPYAVEVLEVFQEVGVHXRXTJEKXTJNXRVIVJVKVMVNXSEPNZXQEPVOYBWSXPYBJP
      EKJVPLJPKIVQJVRVSYBVTWAWBWCWFSVJXEEXKWDXFXNXPWSXEEQRWEWGWHTWITWJWKWLWMWNS
      STWO $.

    $( Lemma 3 for ~ frgrawopreg .  The vertices in the sets A and B have
       different degrees.  (Contributed by Alexander van der Vekens,
       30-Dec-2017.) $)
    frgrawopreglem3 $p |- ( ( X e. A /\ Y e. B )
                        -> ( ( V VDeg E ) ` X ) =/= ( ( V VDeg E ) ` Y ) ) $=
      ( wcel cfv wne wceq wa wi fveq2 eqeq1d elrab2 wn cvdg co cdif eldif bitri
      cv eleq2i ianor pm2.21 necom df-ne biimpri neeq1 syl5ibr adantl com12 a1d
      wo jaoi sylbi sylnbi impcom syl5bi imp ) GBKZHCKZGFDUAUBZLZHVGLZMZVEGFKZV
      HENZOZVFVJPAUFZVGLZENZVLAGFBVNGNVOVHEVNGVGQRISVFHFKZHBKZTZOZVMVJVFHFBUCZK
      VTCWAHJUGHFBUDUEVTVMVJVSVQVMVJPZVRVQVIENZOZVQWBPZVPWCAHFBVNHNVOVIEVNHVGQR
      ISWDTVQTZWCTZURWEVQWCUHWFWEWGVQWBUIWGWBVQVMWGVJVLWGVJPVKWGVJVLEVIMZWHWGWH
      VIEMWGEVIUJVIEUKUEULVHEVIUMUNUOUPUQUSUTVAVBUPVCUTVD $.

    $d b A $.  $d x y a b E $.  $d a b y V $.
    $( Lemma 4 for ~ frgrawopreg .  In a friendship graph each vertex with
       degree K is connected with a vertex with degree other than K. This
       corresponds to the observation in the proof of [Huneke] p. 2:  "By the
       first claim, every vertex in A is adjacent to every vertex in B."
       (Contributed by Alexander van der Vekens, 30-Dec-2017.) $)
    frgrawopreglem4 $p |- ( V FriendGrph E
                            -> A. a e. A A. b e. B { a , b } e. ran E ) $=
      ( vy cv wcel wa cfv wceq wi syl wn a1d cfrgra wbr cpr crn frgrawopreglem3
      cvdg co wne cop cnbgra wnel csn cdif wral frgrancvvdgeq elrabi eleq2s weq
      crab difeq2d wb oveq2 neleq2 fveq2 eqeq1d imbi12d raleqbidv adantr eleq2i
      sneq rspcv eldif bitri simpll eleq1a con3rr3 adantl imp sylnibr eldifd ex
      elsn sylbi impcom neleq1 eqeq2d nnel cusg nbgraeledg eleq1i syl6bb biimpa
      frisusgra prcom expcom df-ne pm2.24 syl5bi ja com12 3syld com3l ralrimivv
      mpcom mpdi ) FDUAUBZGLZHLZUCZDUDZMZGHBCXFXGBMZXHCMZNZXGFDUFUGZOZXHXOOZUHZ
      XKABCDEFXGXHIJUEKLZFDUIZALZUJUGZUKZYAXOOZXSXOOZPZQZKFYAULZUMZUNZAFUNZXFXN
      XRXKQZQAKDFUOXNYKXFYLXNYKXSXTXGUJUGZUKZXPYEPZQZKFXGULZUMZUNZXHYMUKZXPXQPZ
      QZXFYLQZXLYKYSQZXMXLXGFMZUUDUUEXGYDEPZAFUSBUUFAXGFUPIUQYJYSAXGFAGURZYGYPK
      YIYRUUGYHYQFYAXGVJUTUUGYCYNYFYOUUGYBYMPYCYNVAYAXGXTUJVBYBYMXSVCRUUGYDXPYE
      YAXGXOVDVEVFVGVKRVHXNXHYRMZYSUUBQXMXLUUHXMXHFMZXHBMZSZNZXLUUHQXMXHFBUMZMU
      ULCUUMXHJVIXHFBVLVMUULXLUUHUULXLNZXHFYQUUIUUKXLVNUUNHGURZXHYQMUULXLUUOSZU
      UKXLUUPQUUIXLUUOUUJXGBXHVOVPVQVRHXGWBVSVTWAWCWDYPUUBKXHYRKHURZYNYTYOUUAXS
      XHYMWEUUQYEXQXPXSXHXOVDWFVFVKRUUBXNUUCYTUUAXNUUCQZYTSXHYMMZUURXHYMWGUUSUU
      CXNXFUUSYLXFUUSNXKXRXFUUSXKXFUUSXHXGUCZXJMZXKXFFDWHUBUUSUVAVADFWMDXGXHFWI
      RUUTXIXJXHXGWNWJWKWLTWOTWCUUAUUCXNUUAYLXFXRUUASUUAXKXPXQWPUUAXKWQWRTTWSWT
      XAXBXDXEXC $.

    $d a y A $.  $d c z A $.  $d a b x y B $.  $d c z B $.  $d c x z E $.
    $d c z V $.  $d b c y $.
    $( Lemma 5 for ~ frgrawopreg .  If A as well as B contain at least two
       vertices in a friendship graph, there is a 4-cycle in the graph.  This
       corresponds to the observation in the proof of [Huneke] p. 2:  "...
       otherwise, there are two different vertices in A, and they have two
       common neighbors in B, ...".  (Contributed by Alexander van der Vekens,
       31-Dec-2017.) $)
    frgrawopreglem5 $p |- ( ( V FriendGrph E
                              /\ 1 < ( # ` A ) /\ 1 < ( # ` B ) )
          -> E. a e. A E. x e. A E. b e. B E. y e. B ( ( b =/= y /\ a =/= x )
                /\ ( { a , b } e. ran E /\ { x , b } e. ran E )
                /\ ( { a , y } e. ran E /\ { x , y } e. ran E ) ) ) $=
      ( vz vc cv wa wcel wrex wi adantr wral cfrgra wbr cfv clt wne cpr crn w3a
      c1 chash cvv frgrawopreglem1 hashgt12el ex ad2antrr adantll reeanv rexcom
      imp 2rexbii simpr ancomd frgrawopreglem4 rsp2 syl expdimp weq preq1 preq2
      eleq1d cbvral2v sylbi exp3a imp31 jca 3jca reximdva syl5bi sylbir syl2anc
      com12 exp31 com24 mpcom 3imp ) GEUAUBZUICUJUCUDUBZUIDUJUCUDUBZINZBNZUEZHN
      ZANZUEZOZWLWIUFEUGZPZWMWIUFZWPPZOZWLWJUFWPPZWMWJUFZWPPZOZUHZBDQZIDQZACQZH
      CQZCUKPZDUKPZOZWFWGWHXIRRACDEFGJKULXLWHWGWFXIXLWHWGWFXIRZXLWHOZWGOWNACQZH
      CQZWKBDQZIDQZXMXNWGXPXJWGXPRXKWHXJWGXPCUKHAUMUNUOUSXNXRWGXKWHXRXJDUKIBUMU
      PSXPXROXOXQOZIDQHCQZXMXOXQHICDUQXTWNWKOZBDQZACQZIDQZHCQZXMYCXSHICDWNWKABC
      DUQUTWFYEXIWFYDXHHCYDYBIDQZACQWFWLCPZOZXHYBIADCURYHYFXGACYHWMCPZOZYBXFIDY
      JWIDPZOZYAXEBDYLWJDPZOZYAXEYNYAOZWOWTXDYOWNWKYNYAVAVBYNWTYAYNWQWSYLWQYMYJ
      YKWQYHYKWQRYIWFYGYKWQWFWQIDTHCTYGYKOWQRACDEFGHIJKVCWQHICDVDVEVFSUSSYLWSYM
      YHYIYKWSWFYIYKWSRRYGWFYIYKWSWFLNZMNZUFZWPPZMDTLCTZYIYKOWSRZACDEFGLMJKVCZY
      TWSIDTACTUUAYSWSWMYQUFZWPPZLMAICDLAVGYRUUCWPYPWMYQVHVJZMIVGUUCWRWPYQWIWMV
      IVJVKWSAICDVDVLVEVMSVNSVOSYNXDYAYNXAXCYLYMXAYHYMXARYIYKWFYGYMXAWFXABDTHCT
      YGYMOXARACDEFGHBJKVCXAHBCDVDVEVFUOUSYLYMXCYJYMXCRZYKYHYIUUFWFYIUUFRYGWFYI
      YMXCWFYTYIYMOXCRZUUBYTXCBDTACTUUGYSXCUUDLMABCDUUEMBVGUUCXBWPYQWJWMVIVJVKX
      CABCDVDVLVEVMSUSSUSVOSVPUNVQVQVQVRVQWAVSVSVTWBWCWDWE $.

    $( In a friendship graph there are either no vertices or exactly one vertex
       having degree K, or all or all except one vertices have degree K.
       (Contributed by Alexander van der Vekens, 31-Dec-2017.) $)
    frgrawopreg $p |- ( V FriendGrph E -> ( ( ( # ` A ) = 1 \/ A = (/) )
                                         \/ ( ( # ` B ) = 1 \/ B = (/) ) ) ) $=
      ( vb vy va cvv wcel wa wbr wceq wi adantr a1d cpr cfrgra chash cfv c1 cc0
      c0 wo frgrawopreglem1 clt w3o hashv01gt1 anim12i hasheq0 biimpd olcd orcd
      impcom ex orc adantl cv wne crn wrex frgrawopreglem5 3expb cusg frisusgra
      w3a wn simplll cvdg crab elrabi ad2antrl rabeq2i simplbi ad2antll simpr1r
      co eleq2s 3jca cdif eleq2i eldif bitri simpr1l prcom eleq1i biimpi anim2i
      anim1i ancomd 3adant1 ad3antlr 4cyclusnfrgra syl31anc pm2.21d exp41 com25
      imp mpcom rexlimdvv rexlimdvva mpd expcom 3jaoi com12 ) BLMZCLMZNZFDUAOZB
      UBUCZUDPZBUFPZUGZCUBUCZUDPZCUFPZUGZUGZABCDEFGHUHXMUEPZXNUDXMUIOZUJZXQUEPZ
      XRUDXQUIOZUJZNXKXLYAQZXIYDXJYGBLUKCLUKULYDYGXKYHQZYBYGYIQXNYCYBYIYGYBXKYH
      YBXKNZYAXLYJXPXTYJXOXNXKYBXOXIYBXOQXJXIYBXOBLUMUNRUQUOUPSURSXNYIYGXNYHXKX
      NYAXLXNXPXTXNXOUSUPSSSYGYCYIYEYCYIQXRYFYEYIYCYEXKYHYEXKNZYAXLYKXTXPYKXSXR
      XKYEXSXJYEXSQXIXJYEXSCLUMUNUTUQUOUOSURSXRYIYCXRYHXKXRYAXLXRXTXPXRXSUSUOSS
      SYCYFYIYCYFNZYHXKXLYLYAXLYLNIVAZJVAZVBZKVAZAVAZVBZNZYPYMTDVCZMZYQYMTZYTMZ
      NZYPYNTZYTMZYQYNTYTMZNZVIZJCVDICVDZABVDKBVDZYAXLYCYFUUKAJBCDEFKIGHVEVFXLU
      UKYAQYLXLUUJYAKABBXLYPBMZYQBMZNZNUUIYAIJCCXLUUNYMCMZYNCMZNZUUIYAQQZFDVGOZ
      XLUUNUURQDFVHUUSUUIUUNUUQXLYAUUSUUIUUNUUQYHUUSUUINZUUNNZUUQNZXLYAUVBUUSYP
      FMZYQFMZYRVIZYMFMZYNFMZYOVIZUUAYMYQTZYTMZNZUUGYNYPTZYTMZNZNZXLVJZUUSUUIUU
      NUUQVKUVBUVCUVDYRUVAUVCUUQUULUVCUUTUUMUVCYPYQFDVLVTUCEPZAFVMBUVQAYPFVNGWA
      VORUVAUVDUUQUUMUVDUUTUULUUMUVDUVQUVQABFGVPVQVRRUVAYRUUQUUTYRUUNYOYRUUDUUH
      UUSVSRRWBUVBUVFUVGYOUUOUVFUVAUUPUUOUVFYMBMVJZUUOYMFBWCZMUVFUVRNCUVSYMHWDY
      MFBWEWFVQVOUUPUVGUVAUUOUUPUVGYNBMVJZUUPYNUVSMUVGUVTNCUVSYNHWDYNFBWEWFVQVR
      UVAYOUUQUUTYOUUNYOYRUUDUUHUUSWGRRWBUUIUVOUUSUUNUUQUUDUUHUVOYSUUDUVKUUHUVN
      UUCUVJUUAUUCUVJUUBUVIYTYQYMWHWIWJWKUUHUVMUUGUUFUVMUUGUUFUVMUUEUVLYTYPYNWH
      WIWJWLWMULWNWOUUSUVEUVHVIUVOUVPYPYMYQYNDFWPXAWQWRWSWTXBXAXCXDRXEXFSXFXGXH
      XGXAXBXB $.

    $d u v w x A $.  $d u v w B $.  $d u v w V $.  $d u v w E $.
    $( According to the proof of the friendship theorem in [Huneke] p. 2:  "If
       A ... is a singleton, then that singleton is a universal friend".
       (Contributed by Alexander van der Vekens, 1-Jan-2018.) $)
    frgrawopreg1 $p |- ( ( V FriendGrph E /\ ( # ` A ) = 1 )
                     -> E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E ) $=
      ( vu cfv wceq cv cpr wcel wral wrex cvv wi cfrgra wbr c1 crn csn cdif wex
      chash wb frgrawopreglem1 simpld hash1snb syl exsnrex wss cvdg crab ssrab2
      co eqsstri ssrexv ax-mp frgrawopreglem4 vex eleq2 mpbiri weq preq1 eleq1d
      snid ralbidv rspcv difeq2 syl5eq raleqdv sylibd syl5com reximdv sylbi imp
      com12 sylbid ) HFUAUBZDUHLUCMZCNZBNZOZFUDZPZBHWEUEZUFZQZCHRZWCWDDWJMZCUGZ
      WMWCDSPZWDWOUIWCWPESPADEFGHIJUJUKDSCULUMWOWCWMWOWNCDRZWCWMTCDUNWQWNCHRZWC
      WMDHUOWQWRTDANHFUPUSLGMZAHUQHIWSAHURUTWNCDHVAVBWCWNWLCHWCKNZWFOZWHPZBEQZK
      DQZWNWLADEFGHKBIJVCWNXDWIBEQZWLWNWEDPZXDXETWNXFWEWJPWECVDVJDWJWEVEVFXCXEK
      WEDKCVGZXBWIBEXGXAWGWHWTWEWFVHVIVKVLUMWNWIBEWKWNEHDUFWKJDWJHVMVNVOVPVQVRV
      QVSWAWBVT $.

    $( According to the proof of the friendship theorem in [Huneke] p. 2:
       "If ...  B is a singleton, then that singleton is a universal friend".
       (Contributed by Alexander van der Vekens, 1-Jan-2018.) $)
    frgrawopreg2 $p |- ( ( V FriendGrph E /\ ( # ` B ) = 1 )
                     -> E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E ) $=
      ( vu wceq cv cpr wcel cdif wral wrex cvv wi cfrgra wbr cfv c1 crn csn wex
      chash wb frgrawopreglem1 simprd hash1snb syl exsnrex difss eqsstri ssrexv
      wss ax-mp frgrawopreglem4 ralcom vex snid eleq2 mpbiri weq eleq1d ralbidv
      preq2 rspcv eqeq1i cvdg crab ssrab2 dfss4 eqcom bitri difeq2 syl5eq sylbi
      co mpbi prcom eleq1i raleqbidv sylibd syl5bi syl5com reximdv com12 sylbid
      a1i imp ) HFUAUBZEUHUCUDLZCMZBMZNZFUEZOZBHWPUFZPZQZCHRZWNWOEXALZCUGZXDWNE
      SOZWOXFUIWNDSOXGADEFGHIJUJUKESCULUMXFWNXDXFXECERZWNXDTCEUNXHXECHRZWNXDEHU
      RXHXITEHDPZHJHDUOUPXECEHUQUSWNXEXCCHWNWQKMZNZWSOZKEQBDQZXEXCADEFGHBKIJUTX
      NXMBDQZKEQZXEXCXMBKDEVAXEXPWQWPNZWSOZBDQZXCXEWPEOZXPXSTXEXTWPXAOWPCVBVCEX
      AWPVDVEXOXSKWPEKCVFZXMXRBDYAXLXQWSXKWPWQVIVGVHVJUMXEXRWTBDXBXEXJXALZDXBLE
      XJXAJVKYBDHXJPZXBDHURZDYCLZDAMHFVLWAUCGLZAHVMHIYFAHVNUPYDYCDLYEDHVOYCDVPV
      QWBXJXAHVRVSVTXRWTUIXEXQWRWSWQWPWCWDWLWEWFWGWHWIWHVTWJWKWM $.
  $}

  ${
    $d r s t v w K $.  $d r s t v w V $.  $d r s t v w E $.
    $( For each nonnegative integer K there are either no edges having degree
       K, or all vertices have degree K in a friendship graph, unless there is
       a universal friend.  This corresponds to the second claim in the proof
       of the friendship theorem in [Huneke] p. 2:  "... all vertices have
       degree k, unless there is a universal friend."  (Contributed by
       Alexander van der Vekens, 1-Jan-2018.) $)
    frgraregorufr0 $p |- ( V FriendGrph E
                 -> ( A. v e. V ( ( V VDeg E ) ` v ) = K
                   \/ A. v e. V ( ( V VDeg E ) ` v ) =/= K
                   \/ E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E ) ) $=
      ( vt vr vs cv cfv wceq wral cdif crab wo weq fveq2 eqeq1d cbvrabv syl wbr
      cfrgra cvdg co wne cpr crn wcel csn wrex w3o chash c1 c0 eqid frgrawopreg
      wi wa difeq2i frgrawopreg1 3mix3 expcom rabeq0 df-ne biimpri ralimi 3mix2
      wn a1d sylbi jaoi frgrawopreg2 difrab0eq rabid2 3mix1 mpcom biidd wb sneq
      difeq2d preq1 eleq1d raleqbidv cbvrexv a1i 3orbi123d mpbird ) ECUBUAZBIZE
      CUCUDZJZDKZBELZWKDUEZBELZWIAIZUFZCUGZUHZAEWIUIZMZLZBEUJZUKWMWOFIZWPUFZWRU
      HZAEXDUIZMZLZFEUJZUKZWLBENZULJUMKZXLUNKZOZEXLMZULJUMKZXPUNKZOZOWHXKFXLXPC
      DEWLXDWJJZDKBFEBFPZWKXTDWIXDWJQRSXPUOUPXOWHXKUQZXSXMYBXNWHXMXKWHXMURXJXKG
      AFXLEHIZWJJZDKZHENZMCDEWLGIZWJJZDKZBGEBGPWKYHDWIYGWJQRSZYFXLEYEWLHBEHBPYD
      WKDYCWIWJQRSUSUTXJWMWOVAZTVBXNWLVHZBELZYBWLBEVCYMXKWHYMWOXKYLWNBEWNYLWKDV
      DVEVFWOWMXJVGTVIVJVKXQYBXRWHXQXKWHXQURXJXKHAFYIGENZXPCDEYIYEGHEGHPYHYDDYG
      YCWJQRSXLYNEYJUSVLYKTVBXREXLKZYBWLBEVMYOWMYBWLBEVNWMXKWHWMWOXJVOVIVJVJVKV
      KVPWHWMWMWOWOXCXJWHWMVQWHWOVQXCXJVRWHXBXIBFEYAWSXFAXAXHYAWTXGEWIXDVSVTYAW
      QXEWRWIXDWPWAWBWCWDWEWFWG $.
  $}

  ${
    $d a v w K $.  $d a v w V $.  $d a v w E $.
    $( For each nonnegative integer K there are either no edges having degree
       K, or all vertices have degree K in a friendship graph, unless there is
       a universal friend.  This corresponds to the second claim in the proof
       of the friendship theorem in [Huneke] p. 2:  "Suppose there is a vertex
       of degree k > 1. ... all vertices have degree k, unless there is a
       universal friend. ...  It follows that G is k-regular, i.e., the degree
       of every vertex is k".  (Contributed by Alexander van der Vekens,
       1-Jan-2018.) $)
    frgraregorufr $p |- ( V FriendGrph E
                          -> ( E. a e. V ( ( V VDeg E ) ` a ) = K
              -> ( A. v e. V ( ( V VDeg E ) ` v ) = K
                \/ E. v e. V A. w e. ( V \ { v } ) { v , w } e. ran E ) ) ) $=
      ( cfrgra wbr cv cvdg co cfv wceq wral wne wcel wrex wi a1d syl cpr crn wo
      csn cdif w3o frgraregorufr0 orc wa weq fveq2 neeq1d rspcva wn df-ne sylbi
      pm2.21 ancoms rexlimdva olc 3jaoi ) ECGHBIZECJKZLZDMBENZVDDOZBENZVBAIUACU
      BPAEVBUDUENBEQZUFFIZVCLZDMZFEQZVEVHUCZRZABCDEUGVEVNVGVHVEVMVLVEVHUHSVGVKV
      MFEVIEPZVGVKVMRZVOVGUIVJDOZVPVFVQBVIEBFUJVDVJDVBVIVCUKULUMVQVKUNVPVJDUOVK
      VMUQUPTURUSVHVMVLVHVEUTSVAT $.
  $}

  ${
    $d A b $.  $d C b $.  $d E b $.  $d V b $.
    $( Any two (different) vertices in a friendship graph have a unique common
       neighbor.  (Contributed by Alexander van der Vekens, 18-Feb-2018.) $)
    frgraeu $p |- ( V FriendGrph E -> ( ( A e. V /\ C e. V /\ A =/= C )
               -> E! b ( { A , b } e. ran E /\ { b , C } e. ran E ) ) ) $=
      ( cfrgra wbr wcel wne w3a cv cpr crn wa weu wreu frgraun imp wi adantr ex
      df-reu frisusgra usgraedgrnv simprd expcom syl5com pm4.71rd bicomd eubidv
      cusg biimpcd sylbi mpcom ) DCFGZADHZBDHABIJZAEKZLCMZHZURBLUSHZNZEOZVBEDPZ
      UOUQNZVCUOUQVDABCDEQRVDURDHZVBNZEOZVEVCSVBEDUBVEVHVCVEVGVBEVEVBVGVEVBVFUO
      VBVFSUQUODCUKGZVBVFCDUCUTVIVFSVAVIUTVFVIUTNUPVFCAURDUDUEUFTUGTUHUIUJULUMU
      NUA $.
  $}

  ${
    $d A c $.  $d B c $.  $d E c $.  $d V c $.
    $( For two different vertices in a friendship graph, there is exactly one
       third vertex being the middle vertex of a (simple) path/walk of length 2
       between the two vertices as ordered triple.  (Contributed by Alexander
       van der Vekens, 18-Feb-2018.) $)
    frg2woteu $p |- ( ( V FriendGrph E /\ ( A e. V /\ B e. V ) /\ A =/= B )
                -> E! c e. V <. A , c , B >. e. ( A ( V 2WalksOnOt E ) B ) ) $=
      ( cfrgra wbr wcel wa wne w3a cv cotp co wreu cpr adantr simpr wb ad2antlr
      c2wlkonot crn simp1 simpl 3jca 3adant1 frgraun sylc frisusgra usg2wlkonot
      cusg syl13anc reubidva 3adant3 mpbird ) DCFGZADHZBDHZIZABJZKZAELZBMABDCUA
      NNHZEDOZAVBPCUBZHVBBPVEHIZEDOZVAUPUQURUTKZVGUPUSUTUCUSUTVHUPUSUTIUQURUTUS
      UQUTUQURUDZQUSURUTUQURRZQUSUTRUEUFABCDEUGUHUPUSVDVGSUTUPUSIZVCVFEDVKVBDHZ
      IDCUKGZUQVLURVCVFSVKVMVLUPVMUSCDUIQQUSUQUPVLVITVKVLRUSURUPVLVJTAVBBCDUJUL
      UMUNUO $.
  $}

  ${
    $d A c p x $.  $d B c p x $.  $d E c p x $.  $d V c p x $.
    $( In a friendship graph, there is always a path/walk of length 2 between
       two different vertices as ordered triple.  (Contributed by Alexander van
       der Vekens, 18-Feb-2018.) $)
    frg2wotn0 $p |- ( ( V FriendGrph E /\ ( A e. V /\ B e. V ) /\ A =/= B )
                                    -> ( A ( V 2WalksOnOt E ) B ) =/= (/) ) $=
      ( vc cfrgra wbr wcel wa wne w3a cotp c2wlkonot wreu wrex frg2woteu reurex
      cv co c0 ne0i rexlimivw 3syl ) DCFGADHBDHIABJKAERBLZABDCMSSZHZEDNUFEDOUET
      JZABCDEPUFEDQUFUGEDUEUDUAUBUC $.
  $}

  ${
    $d A c d f p t u w $.  $d B c d f p t u w $.  $d E c d f p t u w $.
    $d V c d f p t u w $.  $d A c d x y $.  $d B x y $.  $d E x y $.
    $d V x y $.
    $( In a friendship graph, there is exactly one walk of length 2 between two
       different vertices as ordered triple.  (Contributed by Alexander van der
       Vekens, 19-Feb-2018.) $)
    frg2wot1 $p |- ( ( V FriendGrph E /\ ( A e. V /\ B e. V ) /\ A =/= B )
                          -> ( # ` ( A ( V 2WalksOnOt E ) B ) ) = 1 ) $=
      ( vw vt vd vf vp vc vx vy wcel wa w3a wceq cv weq wi cvv cfrgra c2wlkonot
      wbr wne co chash cfv c1 weu c0 frg2wotn0 wmo wal cotp cwalk c2 cc0 wex wb
      wrex cusg frisusgra usgrav syl anim1i 3adant3 anbi12d wreu frg2woteu wral
      el2wlkonot oteq2 eleq1d reu4 anbi1d syl6bb equequ1 equcom imbi12d rspc2va
      ancom syl6 ex com12 adantl sylbi impl eleq1 bi2anan9 eqeq12 syl5ibr com23
      adantr rexlimdva adantrd imp sylbid pm2.43d alrimivv sylibr n0moeu syl5ib
      com13 mo4 mpcom ovex euhash1 mp1i mpbird ) DCUAUCZADMBDMNZABUDZOZABDCUBUE
      ZUEZUFUGUHPZEQZXOMZEUIZXOUJUDZXMXSABCDUKXMXREULZXTXSXMXRFQZXOMZNZEFRZSZFU
      MEUMYAXMYFEFXMYDYEXMYDXQAGQZBUNZPZHQZIQZDCUOUEUCZYJUFUGUPPZAUQYKUGPZYGUHY
      KUGZPBUPYKUGPZOOIURHURZNZGDUTZYBAJQZBUNZPZYLYMYNYTYOPYPOOIURHURZNZJDUTZNZ
      YFXMXRYSYCUUEXMDTMCTMNZXKNZXRYSUSXJXKUUHXLXJUUGXKXJDCVAUCUUGCDVBCDVCVDVEV
      FZABXQHCDTTIGVKVDXMUUHYCUUEUSUUIABYBHCDTTIJVKVDVGUUFXMYFYSUUEXMYFSXMUUEYS
      YFXMUUDYSYFSZJDXMYTDMZNZUUBUUJUUCUULYSUUBYFUULYRUUBYFSZGDYRUULYGDMZNZUUMY
      IUUOUUMSYQYIUUBUUOYFYIUUBUUOYFSUUOYFYIUUBNZYHXOMZUUAXOMZNZYHUUAPZSZXMUUKU
      UNUVAXMAKQZBUNZXOMZKDVHZUUKUUNNZUVASZABCDKVIUVEUVDKDUTZUVDALQZBUNZXOMZNZK
      LRZSZLDVJKDVJZNUVGUVDUVKKLDUVMUVCUVJXOUVBUVIABVLVMVNUVOUVGUVHUVFUVOUVAUVF
      UVOUVAUVFUVONUUSGJRZUUTUVNUUSUVPSUVKUURNZLJRZSKLYTYGDDKJRZUVLUVQUVMUVRUVS
      UVLUURUVKNUVQUVSUVDUURUVKUVSUVCUUAXOUVBYTABVLVMVOUURUVKWAVPUVSUVMJLRUVRKJ
      LVQJLVRVPVSLGRZUVQUUSUVRUVPUVTUVKUUQUURUVTUVJYHXOUVIYGABVLVMVOLGJVQVSVTYG
      YTABVLWBWCWDWEWFVDWGUUPYDUUSYEUUTYIXRUUQUUBYCUURXQYHXOWHYBUUAXOWHWIXQYHYB
      UUAWJVSWKWCWLWMWDWNWLWOWNXCWPWDWQWRWSXRYCEFXQYBXOWHXDWTEXOXAXBXEXOTMXPXSU
      SXMABXNXFXOTEXGXHXI $.
  $}

  ${
    $( In a friendship graph, there is exactly one simple path of length 2
       between two different vertices as ordered triple.  (Contributed by
       Alexander van der Vekens, 3-Mar-2018.) $)
    frg2spot1 $p |- ( ( V FriendGrph E /\ ( A e. V /\ B e. V ) /\ A =/= B )
                          -> ( # ` ( A ( V 2SPathOnOt E ) B ) ) = 1 ) $=
      ( cfrgra wbr wcel wa wne w3a c2pthonot chash cfv c2wlkonot cusg frisusgra
      co c1 wceq 2pthwlkonot syl3an1 fveq2d frg2wot1 eqtrd ) DCEFZADGBDGHZABIZJ
      ZABDCKQQZLMABDCNQQZLMRUHUIUJLUEDCOFUFUGUIUJSCDPABCDTUAUBABCDUCUD $.
  $}

  ${
    $d A p q $.  $d B p q $.  $d E p q $.  $d P p q $.  $d Q p q $.  $d V p $.
    $( There is a (simple) path of length 2 from one vertex to another vertex
       in a friendship graph if and only if there is a (simple) path of length
       2 from the other vertex back to the first vertex.  (Contributed by
       Alexander van der Vekens, 20-Feb-2018.) $)
    frg2woteqm $p |- ( ( V FriendGrph E /\ A =/= B )
         -> ( ( <. A , P , B >. e. ( A ( V 2WalksOnOt E ) B )
             /\ <. B , Q , A >. e. ( B ( V 2WalksOnOt E ) A ) ) -> Q = P ) ) $=
      ( vp vq co wcel wa wceq w3a wi cpr adantr anbi12d adantl preq2 eleq1d wbr
      cotp c2wlkonot cfrgra wne cvv 2wlkonotv anim12i cusg wb frisusgra simprr3
      crn simpl simprr1 usg2wlkonot syl2anr simprr cv weu necom biimpi ad2antll
      3jca frgraeu sylc wex weq preq1 prcom syl6eq ancom syl6bb bi2anan9 eqeq12
      wal eu4 eqcom imbi12d spc2gv expcom 3ad2ant2 impcom com12 sylbi sylbid ex
      mpcom com23 imp ) ACBUBABFEUCIZIJZBDAUBBAWKIJZKZFEUDUAZABUEZKZDCLZFUFJEUF
      JKZAFJZCFJZBFJZMZKZWSXBDFJZWTMZKZKWNWQWRNZWLXDWMXGACBEFUGBDAEFUGUHXDXGWNX
      HNZXCXGXINZWSXAWTXJXBXAXGXIXAXGKZWQWNWRXKWQWNWRNXKWQKZWNACOZEUMZJZCBOZXNJ
      ZKZBDOZXNJZDAOZXNJZKZKZWRXLWLXRWMYCWQFEUIUAZXCWLXRUJXKWOYEWPEFUKPZXKWTXAX
      BXBXEWTWSXAULZXAXGUNXBXEWTWSXAUOZVDACBEFUPUQWQYEXFWMYCUJXKYFXAWSXFURBDAEF
      UPUQQBGUSZOZXNJZYIAOZXNJZKZGUTZXLYDWRNZXLWOXBWTBAUEZMYOWQWOXKWOWPUNRXLXBW
      TYQXKXBWQYHPXKWTWQYGPWPYQXKWOWPYQABVAVBVCVDBAEFGVEVFYOYNGVGZYNBHUSZOZXNJZ
      YSAOZXNJZKZKZGHVHZNZHVPGVPZKXLYPNZYNUUDGHUUFYKUUAYMUUCUUFYJYTXNYIYSBSTUUF
      YLUUBXNYIYSAVITQVQUUHUUIYRXLUUHYPXKUUHYPNZWQXGXAUUJXFXAUUJNZWSXEXBUUKWTXA
      XEUUJUUGYPGHCDFFYICLZYSDLZKZUUEYDUUFWRUULYNXRUUMUUDYCUULYNXQXOKXRUULYKXQY
      MXOUULYJXPXNUULYJBCOXPYICBSBCVJVKTUULYLXMXNUULYLCAOXMYICAVICAVJVKTQXQXOVL
      VMUUMUUAXTUUCYBUUMYTXSXNYSDBSTUUMUUBYAXNYSDAVITQVNUUNUUFCDLWRYICYSDVOCDVR
      VMVSVTWAWBRWCPWDRWEWHWFWGWIWGWBRWJWHWD $.
  $}

  ${
    $d A c d f p $.  $d B c d f p $.  $d E c d f p $.  $d P c d f p $.
    $d Q c d f p $.  $d V c d f p $.
    $( There is a (simple) path of length 2 from one vertex to another vertex
       in a friendship graph if and only if there is a (simple) path of length
       2 from the other vertex back to the first vertex.  (Contributed by
       Alexander van der Vekens, 14-Feb-2018.) $)
    frg2woteq $p |- ( ( V FriendGrph E /\ A =/= B )
    -> ( ( P e. ( A ( V 2WalksOnOt E ) B ) /\ Q e. ( B ( V 2WalksOnOt E ) A ) )
                  -> ( ( 1st ` ( 1st ` P ) ) = ( 2nd ` Q )
                    /\ ( 2nd ` ( 1st ` P ) ) = ( 2nd ` ( 1st ` P ) )
                    /\ ( 1st ` ( 1st ` Q ) ) = ( 2nd ` P ) ) ) ) $=
      ( vc vf vp wcel wa c1st cfv c2nd wceq w3a cvv wi ad2antrr adantl vd co cv
      c2wlkonot cfrgra wbr wne cxp 2wlkonot3v adantr cotp cwalk chash c2 cc0 c1
      wex wrex el2wlkonot pm3.22 anim2i syl anbi12d 3adant3 el2wlkonotot bicomd
      3simpa weq frg2woteqm fveq2 fveq2d vex ot1stg mp3an2 ot3rdg eqtr2d 3eqtrd
      wb ad2antlr eqidd simpr simpl 3jca eqcomd eqtrd syl6 exp3a com14 3ad2ant2
      a1i ex imp31 sylbid expimpd com23 rexlimdva imp3a mpcom com12 ) CABFEUDUB
      ZUBZJZDBAWTUBZJZKZFEUEUFABUGKZCLMZLMZDNMZOZXGNMZXKOZDLMZLMZCNMZOZPZFQJEQJ
      KZAFJZBFJZKZCFFUHFUHJZPZXEXFXQRZXBYCXDABCEFUIUJYCXECAGUCZBUKZOZHUCZIUCZFE
      ULUBUFZYHUMMUNOZAUOYIMZOYEUPYIMZOBUNYIMZOPPIUQHUQZKZGFURZDBUAUCZAUKZOZYJY
      KBYLOYRYMOAYNOPPIUQHUQZKZUAFURZKZYDXRYAXEUUDVRYBXRYAKZXBYQXDUUCABCHEFQQIG
      USUUEXRXTXSKZKZXDUUCVRYAUUFXRXSXTUTVAZBADHEFQQIUAUSVBVCVDYCYQUUCYDYCYPUUC
      YDRGFYCYEFJZKZUUCYPYDUUJUUBYPYDRZUAFUUJYRFJZKZYTUUAUUKUUMYTKZUUAYSXCJZUUK
      UUNUUGUUAUUOVRUUJUUGUULYTYCUUGUUIXRYAUUGYBUUHVDUJSUUGUUOUUABYRAHEFQQIVEVF
      VBUUNYPUUOYDUUNYGYOUUOYDRZUUNYGKZYOYFXAJZUUPUUQUUEYOUURVRUUMUUEYTYGYCUUEU
      UIUULXRYAYBVGSSUUEUURYOAYEBHEFQQIVEVFVBUUMYTYGUURUUPRZYCYTYGUUSRZRZUUIUUL
      YAXRUVAYBYAYTUUTYAYTKZYGUUSXFUURUUOUVBYGKZXQXFUURUUOUVCXQRZXFUURUUOKUAGVH
      ZUVDABYEYREFVIUVEUVCXQUVEUVCKZXJXLXPUVFXHYFLMZLMZAXIUVCXHUVHOZUVEYGUVIUVB
      YGXGUVGLCYFLVJVKTTUVCUVHAOZUVEYAUVJYTYGXSYEQJXTUVJGVLAYEBFQFVMVNSTUVFXIYS
      NMZAUVCXIUVKOZUVEYTUVLYAYGDYSNVJVSTUVCUVKAOZUVEYAUVMYTYGXSUVMXTBYRAFVOUJS
      TVPVQUVFXKVTUVFXNYSLMZLMZBXOUVCXNUVOOZUVEYTUVPYAYGYTXMUVNLDYSLVJVKVSTUVFX
      TYRQJZXSPZUVOBOUVCUVRUVEYAUVRYTYGYAXTUVQXSXSXTWAUVQYAUAVLWJXSXTWBWCSTBYRA
      FQFVMVBUVFBYFNMZXOUVFUVSBUVCUVSBOZUVEYAUVTYTYGXTUVTXSAYEBFVOTSTWDUVFYFCNU
      VFCYFUVCYGUVEUVBYGWATWDVKWEVQWCWKWFWGWHWKWKWISWLWMWNWOWMWNWPWOWPWQWMWRWS
      $.
  $}

  ${
    $d A b c f g p q s t u $.  $d E b c f g p q s t u $.
    $d V b c f g p q s t u $.  $d X b c f g p q t $.  $d Y b c f g p q t $.
    $( All simple paths of length 2 as ordered triple from a fixed vertex to
       another vertex are disjunct.  (Contributed by Alexander van der Vekens,
       4-Mar-2018.) $)
    2spotdisj $p |- ( ( ( V e. X /\ E e. Y ) /\ A e. V )
                    -> Disj_ b e. ( V \ { A } ) ( A ( V 2SPathOnOt E ) b ) ) $=
      ( vc vf vp vt wcel wa cv wceq wn cfv c1st c2nd w3a wex vg vq vs c2pthonot
      vu weq co cin c0 wo csn cdif wral wdisj wnel wi orc a1d cspthon wbr chash
      c2 c1 cxp 2spthonot anassrs adantr adantlr ineq12d ad2antrl w3o wal eqtr2
      crab ex con3rr3 com12 3ad2ant3 impcom syl 3ianor sylibr exlimdvv alrimivv
      3mix3 2nexaln bicomi 2albii bitr4i intnand fveq2 fveq2d 3anbi123d 3anbi3d
      imp eqeq1d 2exbidv elrab sylnibr ralrimiva ralrab disj eqtrd olcd pm2.61i
      raldifb sylib oveq2 disjor ) CDKBEKLZACKZLZFGUFZAFMZCBUDUGZUGZAGMZXOUGZUH
      ZUINZUJZGCAUKZULZUMZFYCUMZFYCXPUNXLXNYBUOZYDUPZFCUMYEXLYGFCXLXNCKZLZYFYDY
      IYFLZXQYBUOZYAUPZGCUMYDYJYLGCYJXQCKZLZYKYAXMYNYKLZYAUPXMYAYOXMXTUQURXMOZY
      OYAYPYOLZXTXMYQXSUAMZUBMZAXNCBUSUGZUGUTZYRVAPVBNZUCMZQPZQPZANZUUDRPZVCYSP
      ZNZUUCRPZXNNZSZSZUBTUATZUCCCVDCVDZVNZHMZIMZAXQYTUGUTZUUQVAPVBNZUEMZQPZQPZ
      ANZUVBRPZVCUURPZNZUVARPZXQNZSZSZITHTZUEUUOVNZUHZUIYNXSUVNNZYPYKYIYMUVOYFY
      IYMLXPUUPXRUVMYIXPUUPNZYMXJXKYHUVPUCAXNUABCDEUBVEVFVGXLYMXRUVMNZYHXJXKYMU
      VQUEAXQHBCDEIVEVFVHVIVHVJYQJMZUVMKZOZJUUPUMZUVNUINYQUUAUUBUVRQPZQPZANZUWB
      RPZUUHNZUVRRPZXNNZSZSZUBTUATZUVTUPZJUUOUMUWAYQUWLJUUOYQUVRUUOKZLZUWKUVTUW
      NUWKLZUWMUUSUUTUWDUWEUVFNZUWGXQNZSZSZITHTZLUVSUWOUWTUWMUWOUUSOZUUTOZUWROZ
      VKZIVLHVLZUWTOZUWOUXDHIUWNUWKUXDUWNUWJUXDUAUBUWNUWJUXDUWNUWJLZUXCUXDUXGUW
      DOZUWPOZUWQOZVKZUXCUXGUXJUXKUWJUWNUXJUWIUUAUWNUXJUPZUUBUWHUWDUXLUWFUWNUWH
      UXJYQUWHUXJUPZUWMYPUXMYOUWHUWQXMUWHUWQXMUWGXNXQVMVOVPVGVGVQVRVRVSUXJUXHUX
      IWEVTUWDUWPUWQWAWBUXCUXAUXBWEVTVOWCWOWDUXFUWSOZIVLHVLUXEUWSHIWFUXDUXNHIUX
      NUXDUUSUUTUWRWAWGWHWIWBWJUVLUWTUEUVRUUOUEJUFZUVKUWSHIUXOUVJUWRUUSUUTUXOUV
      DUWDUVGUWPUVIUWQUXOUVCUWCAUXOUVBUWBQUVAUVRQWKZWLWPUXOUVEUWEUVFUXOUVBUWBRU
      XPWLWPUXOUVHUWGXQUVAUVRRWKWPWMWNWQWRWSVOWTUUNUWKUVTJUCUUOUCJUFZUUMUWJUAUB
      UXQUULUWIUUAUUBUXQUUFUWDUUIUWFUUKUWHUXQUUEUWCAUXQUUDUWBQUUCUVRQWKZWLWPUXQ
      UUGUWEUUHUXQUUDUWBRUXRWLWPUXQUUJUWGXNUUCUVRRWKWPWMWNWQXAWBJUUPUVMXBWBXCXD
      VOXEVOWTYAGCYBXFXGVOWTYDFCYBXFXGYCXPXRFGXNXQAXOXHXIWB $.
  $}

  ${
    $d E a b c d f m n p t $.  $d V a b c d f m n p t $.
    $d X a b c d f m n p t $.  $d Y a b c d f m n p t $.
    $( All simple paths of length 2 as ordered triple from a fixed vertex to
       another vertex are disjunct.  (Contributed by Alexander van der Vekens,
       5-Mar-2018.) $)
    2spotiundisj $p |- ( ( V e. X /\ E e. Y )
          -> Disj_ a e. V U_ b e. ( V \ { a } ) ( a ( V 2SPathOnOt E ) b ) ) $=
      ( vc vt vd vn vf vp vm wcel wa cv wceq wral wn adantr cdif c2pthonot ciun
      weq csn co cin c0 wo wdisj wi orc a1d wrex eliun cotp cspath wbr chash c2
      cfv cc0 c1 w3a wex wb adantl simprrl eldifi el2spthonot syl12anc vex otth
      simpl simp1bi con3i eqeq1 notbid syl5ibr impcom ex rexlimdva sylbid imp41
      orcd ianor sylibr ralrimiva ralnex simprr anim12i jca ad3antlr imp mtbird
      sylib sylnibr syl5bi oveq2 cbviunv eleq2i notbii ralbii disj olcd pm2.61i
      syl ralrimivva sneq difeq2d oveq1 iuneq12d disjor ) BCNADNOZEGUDZFBEPZUEZ
      UAZXPFPZBAUBUFZUFZUCZFBGPZUEZUAZYCXSXTUFZUCZUGUHQZUIZGBREBREBYBUJXNYIEGBB
      XOXNXPBNZYCBNZOZOZYIUKXOYIYMXOYHULUMXOSZYMYIYNYMOZYHXOYOHPZYGNZSZHYBRZYHY
      OYPIYEYCIPZXTUFZUCZNZSZHYBRYSYOUUDHYBYOYPYBNZUUDUUEYPYANZFXRUNYOUUDFYPXRY
      AUOYOUUFUUDFXRYOXSXRNZOZUUFUUDUUHUUFOZYPUUANZIYEUNZUUCUUIUUJSZIYERUUKSUUI
      UULIYEUUIYTYENZOZUUJYPYCJPZYTUPZQZKPZLPZBAUQUFURZUURUSVAUTQZYCVBUUSVAZQUU
      OVCUUSVAZQYTUTUUSVAZQVDVDLVEKVEZOZJBUNZUUNUVFSZJBRUVGSUUNUVHJBUUNUUOBNZOU
      UQSZUVESZUIZUVHUUHUUFUUMUVIUVLUUHUUFYPXPMPZXSUPZQZUUTUVAXPUVBQUVMUVCQXSUV
      DQVDVDLVEKVEZOZMBUNZUUMUVIUVLUKZUKZUUHXNYJXSBNZUUFUVRVFYOXNUUGYMXNYNXNYLV
      NZVGTYOYJUUGYNXNYJYKVHTUUGUWAYOXSBXQVIVGXPXSYPKABCDLMVJVKUUHUVQUVTMBUUHUV
      MBNZOZUVQUVTUWDUVQOZUVSUUMUWEUVLUVIUWEUVJUVKUVQUWDUVJUVOUWDUVJUKUVPUWDUVJ
      UVOUVNUUPQZSZUUHUWGUWCYOUWGUUGYNUWGYMUWFXOUWFXOMJUDFIUDXPUVMYCUUOXSYTEVLM
      VLFVLVMVOVPTTTUVOUUQUWFYPUVNUUPVQVRVSTVTWEUMUMWAWBWCWDUUQUVEWFWGWHUVFJBWI
      WPUUNXNYKYTBNZOZOZUUJUVGVFUUIUUMUWJYMUUMUWJUKYNUUGUUFYMUUMUWJYMUUMOXNUWIY
      MXNUUMUWBTYMYKUUMUWHXNYJYKWJYTBYDVIWKWLWAWMWNYCYTYPKABCDLJVJXGWOWHUUJIYEW
      IWPIYPYEUUAUOWQWAWBWRWNWHYRUUDHYBYQUUCYGUUBYPFIYEYFUUAXSYTYCXTWSWTXAXBXCW
      GHYBYGXDWGXEWAXFXHBYBYGEGXOFXRYEYAYFXOXQYDBXPYCXIXJXPYCXSXTXKXLXMWG $.
  $}

  ${
    $d E a b $.  $d V a b $.
    $( The number of simple paths of length 2 is n*(n-1) in a friendship graph
       with ` n ` vertices.  This corresponds to the proof of the third claim
       in the proof of the friendship theorem in [Huneke] p. 2:  "... the paths
       of length two in G: by assumption there are ( n 2 ) such paths.".
       However, the order of vertices is not respected by Huneke, so he only
       counts half of the paths which are existing when respecting the order as
       it is the case for simple paths represented by orderes triples.
       (Contributed by Alexander van der Vekens, 6-Mar-2018.) $)
    frghash2spot $p |- ( ( V FriendGrph E /\ ( V e. Fin /\ V =/= (/) ) )
        -> ( # ` ( V 2SPathsOt E ) ) = ( ( # ` V ) x. ( ( # ` V ) - 1 ) ) ) $=
      ( va vb cfn wcel wa co chash cfv csu cmul wceq cvv 3syl adantr adantl syl
      c1 3eqtrd cfrgra wbr c0 wne c2spthot cv csn cdif c2pthonot ciun cmin cusg
      frisusgra usgrav 2spot2iun2spont fveq2d simpl diffi simpr anim12ci eldifi
      wral anim12i 2spotfi syl2anc ralrimiva iunfi wdisj 2spotiundisj 2spotdisj
      hashiun sylan simplll eldifsni necomd frg2spot1 syl3anc sumeq2dv cc jctir
      ax-1cn fsumconst hashdifsn adantlr oveq1d cr cn0 hashnncl biimpar nnm1nn0
      cn nn0red ax-1rid adantll hashcl nn0cnd a1i subcld mpdan eqtrd ) BAUAUBZB
      EFZBUCUDZGZGZBAUEHZIJZCBDBCUFZUGZUHZXHDUFZBAUIHHZUJZUJZIJZBXMIJZCKZBIJZXR
      SUKHZLHZXAXGXOMXDXAXFXNIXABAULUBZBNFZANFZGZXFXNMABUMZABUNZCDABUOOUPPXECBX
      MXDXBXAXBXCUQZQXEXHBFZGZXJEFZXLEFZDXJVBXMEFXEYJYHXDYJXAXBYJXCBXIURZPQPZYI
      YKDXJYIXKXJFZGZXBYCGZYHXKBFZGZYKYIYPYNXEYPYHXAYCXDXBXAYAYDYCYEYFYBYCUSOYG
      UTZPPYIYHYNYQXEYHUSXKBXIVAVCZXHXKABNVDVEZVFDXJXLVGVEXACBXMVHZXDXAYAYDUUBY
      EYFABNNCDVIOPVKXEXQBXSCKZXTXEBXPXSCYIXPXJXLIJZDKXJSDKZXSYIDXJXLYMUUAXEYPY
      HDXJXLVHYSXHABENDVJVLVKYIXJUUDSDYOXAYRXHXKUDZUUDSMXAXDYHYNVMYTYNUUFYIYNXK
      XHXKBXHVNVOQXHXKABVPVQVRXDYHUUEXSMXAXDYHGZUUEXJIJZSLHZXSSLHZXSUUGYJSVSFZG
      ZUUEUUIMXDUULYHXBUULXCXBYJUUKYLWAVTPPXJSDWBRUUGUUHXSSLXBYHUUHXSMXCBXHWCWD
      WEXDUUJXSMZYHXDXSWFFUUMXDXSXDXRWKFZXSWGFXBUUNXCBWHWIXRWJRWLXSWMRPTWNTVRXD
      UUCXTMZXAXBUUOXCXBXSVSFUUOXBXRSXBXRBWOWPUUKXBWAWQWRBXSCWBWSPQWTT $.
  $}

  ${
    $d E a b p $.  $d V a b p $.  $d X a b p $.
    $( If there are no vertices, then there are no paths (of length 2), too.
       (Contributed by Alexander van der Vekens, 11-Mar-2018.) $)
    2spot0 $p |- ( ( V = (/) /\ E e. X ) -> ( V 2SPathsOt E ) = (/) ) $=
      ( vp va vb c0 wceq wcel wa co cv wrex cxp cvv wral ralrimiva ralnex sylib
      wn c2spthot c2pthonot 0ex eleq1 mpbiri 2spthsot sylan w3a 2spthonot3v n0i
      crab adantr 3ad2ant2 syl con2i ad4antr rabeq0 sylibr eqtrd ) BGHZACIZJZBA
      UAKZDLZELZFLZBAUBKKIZFBMZEBMZDBBNBNZUKZGUTBOIZVAVCVKHUTVLGOIUCBGOUDUEDABO
      CEFUFUGVBVITZDVJPVKGHVBVMDVJVBVDVJIZJZVHTZEBPVMVOVPEBVOVEBIZJZVGTZFBPVPVR
      VSFBUTVSVAVNVQVFBIZVGUTVGVLAOIJZVQVTJZVNUHUTTZVEVFVDABUIWBWAWCVNVQWCVTBVE
      UJULUMUNUOUPQVGFBRSQVHEBRSQVIDVJUQURUS $.
  $}

  ${
    $d E m p t x y z $.  $d N a m p t x y z $.  $d V a m p t x y z $.
    $d E a $.  $d M z $.
    usgreghash2spot.m $e |- M = ( a e. V |-> { t e. ( ( V X. V ) X. V ) |
                 ( t e. ( V 2SPathsOt E ) /\ ( 2nd ` ( 1st ` t ) ) = a ) } ) $.
    $( The set of paths of length 2 with a given vertex in the middle for a
       finite graph is the union of all paths of length 2 from one neighbor to
       another neighbor of this vertex via this vertex.  (Contributed by
       Alexander van der Vekens, 9-Mar-2018.) $)
    usg2spot2nb $p |- ( ( V USGrph E /\ V e. Fin /\ N e. V )
                -> ( M ` N ) = U_ x e. ( <. V , E >. Neighbors N )
                                U_ y e. ( ( <. V , E >. Neighbors N ) \ { x } )
                                          { <. x , N , y >. } ) $=
      ( wcel cfv cv wrex c1st wceq wa cvv wb wi imp vp vz cusg wbr cfn w3a cotp
      vm csn cop cnbgra co cdif cab ciun c2spthot c2nd crab simp3 3xpexg rabexg
      cxp syl 3ad2ant2 eqeq2 anbi2d rabbidv fvmptg eleq2d syl2anc wne cpr eleq1
      crn weq fveq2 fveq2d eqeq1d anbi12d elrab c2pthonot el2spthsoton 3ad2ant1
      a1i usgrav usg2spthonot1 3ad2antl1 2rexbidva bitrd anbi1d r19.41vv anbi2i
      ancom 3bitrri wex wn bicomi vex ot2ndg mp3an syl6eq simpr simplrl simplrr
      elsn ad3antrrr 3jca necom df-ne bitri biimpi ad4antlr prcom eleq1i adantr
      ad5antlr simp-5l jca32 exp31 exp41 oteq2 eqeq2d preq2 eleq1d preq1 imbi1d
      com12 imp31 3ad2ant3 exp3acom3r com13 com23 adantl 3adant3 nbgrael syl5bb
      jca df-rex exbii 3bitrd imbi2d imbi12d sylbid com24 com14 imp41 rexlimdva
      3imtr4d exp3acom23 impcom simprl2 simpll2 anim12i anim1i ancoms rspcimedv
      ex syl5ibr com15 3adant2 simpl simprl simprr sylan9eqr eqidd mpbird jca31
      otel3xp impbid1 eldif notbid 3bitr4d 2exbidv rexbii 19.42v 3bitri r19.42v
      id bitr3i 3bitr4g 2rexbidv elab eqrdv dfiunv2 syl6eqr ) GDUCUDZGUEJZFGJZU
      FZFEKZUALZALZFBLZUGZUIZJZBGDUJFUKULZUWLUIZUMZMAUWQMZUAUNZAUWQBUWSUWOUOUOU
      WIUBUWJUXAUWIUBLZUWJJZUXBCLZGDUPULZJZUXDNKZUQKZFOZPZCGGVBGVBZURZJZUXBUWOJ
      ZBUWSMZAUWQMZUXBUXAJZUWIUWHUXLQJZUXCUXMRUWFUWGUWHUSUWGUWFUXRUWHUWGUXKQJUX
      RGUEUTUXJCUXKQVAVCVDUWHUXRPUWJUXLUXBHFUXFUXHHLZOZPZCUXKURUXLGQEUXSFOZUYAU
      XJCUXKUYBUXTUXIUXFUXSFUXHVEVFVGIVHVIVJUWIUXMUXBUXKJZUXBUXEJZUXBNKZUQKZFOZ
      PZPZUYCUXBUWLUHLZUWMUGZOZUWLUWMVKZPZUWLUYJVLZDVNZJZUYJUWMVLZUYPJZPZPZUHGM
      ZBGMAGMZUYGPZPZUXPUXMUYIRUWIUXJUYHCUXBUXKCUBVOZUXFUYDUXIUYGUXDUXBUXEVMVUF
      UXHUYFFVUFUXGUYEUQUXDUXBNVPVQVRVSVTWDUWIUYHVUDUYCUWIUYDVUCUYGUWIUYDUXBUWL
      UWMGDWAULULJZBGMAGMZVUCUWFUWGUYDVUHRZUWHUWFGQJDQJPZVUIDGWEZUXBDGQQABWBVCW
      CUWIVUGVUBABGGUWFUWGUWLGJZUWMGJZPVUGVUBRUWHUWLUWMUXBDGUHWFWGWHWIWJVFVUEVU
      BUYGPZUYCPZBGMZAGMZUWIUXPVUQVUNBGMAGMZUYCPUYCVURPVUEVUNUYCABGGWKVURUYCWMV
      URVUDUYCVUBUYGABGGWKWLWNUWIVULVUMVUOPZPZBWOZAWOZUWMUWSJZUWLUWQJZUXNPZPZBW
      OZAWOZVUQUXPUWIVUTVVFABUWIUWHVUMFUWMVLZUYPJZUFZBAVOZWPZPZUWHVULFUWLVLZUYP
      JZUFZUXBUWNOZPZPZVVNVVQUXNPZPZVUTVVFVVTVWBRUWIVVSVWAVVNVVRUXNVVQUXNVVRUBU
      WNXEWQWLWLWDUWIVUTVVTVUTUWIVVTVUSVULUWIVVTSZVUMVUOVULVWCSVUMVULVUOVWCVUOV
      UMVULVWCVUNUYCVUMVULPZVWCSVUNVWDUYCVWCVUBUYGVWDUYCPZVWCSVWEUYGVUBVWCVWEUY
      GVUBVWCSVWEUYGPZVUAVWCUHGUWIVWFUYJGJZPZVUAVVTUWHUWFVWHVUAPZVVTSUWGVWIUWHV
      VTVWEUYGVWGVUAUWHVVTSZVWDUYGVWGVUAVWJSSSUYCVUAUYGVWGVWDVWJUYLUYMUYTUYGVWG
      VWDVWJSZSZSUYLUYGUYTUYMVWLUYLUYGUYJFOZUYTUYMVWLSZSZUYLUYFUYJFUYLUYFUYKNKZ
      UQKZUYJUYLUYEVWPUQUXBUYKNVPVQUWLQJUYJQJUWMQJVWQUYJOAWRUHWRBWRUWLUYJUWMQQQ
      WSWTXAVRVWMUYLVWOVWMVVRUWLFVLZUYPJZVVJPZUYMUWHVWKSZSZSZUYLVWOVVRVXCSVWMVV
      RVWTUYMUWHVWKVVRVWTPZUYMPZUWHPZVWDUWHVVTVXFVWDPZUWHPZVVNVVQVVRVXHVVKVVMVX
      HUWHVUMVVJVXGUWHXBZVXFVUMVULUWHXCVXEVVJUWHVWDUWHVVRVWSVVJUYMXDXFXGUYMVVMV
      XDUWHVWDUWHUYMVVMUYMUWMUWLVKVVMUWLUWMXHUWMUWLXIXJZXKXLYQVXHUWHVULVVPVXIVX
      FVUMVULUWHXDVWTVVPVVRUYMUWHVWDUWHVWSVVPVVJVWSVVPVWRVVOUYPUWLFXMXNXKXOXPXG
      VVRVWTUYMUWHVWDUWHXQXRXSXTWDVWMUYKUWNUXBUYJFUWLUWMYAYBZVWMUYTVWTVWNVXBVWM
      UYQVWSUYSVVJVWMUYOVWRUYPUYJFUWLYCYDVWMUYRVVIUYPUYJFUWMYEYDVSZVWMVWLVXAUYM
      VWMVWGUWHVWKUYJFGVMYFUUAUUBUUHYGUUCUUDYHUUEXOUUFYGYIYJUUGUUQYKTUUITYJYLTU
      UJYGVVTVULVUMVUOUWHVULVVPVVRVVNUUKUWHVUMVVJVVMVVSUULVVTVUBUYGUYCVVKVVMVVS
      VUBVVJUWHVVMVVSVUBSSVUMVVSVVMVVJVUBVVQVVRVVMVVJVUBSSZUWHVVPVVRVXMSZVULUWH
      VVPVXNVVJVVPVVRVVMUWHVUBVVJVVPVVRVVMUWHVUBSSUWHVVJVVPPZVVRPZVVMVUBUWHVUAV
      XPVVMPZUHFGUWHUVRVWMVXQVUASUWHVXQVUAVWMVVRUYMPZVWTPVXQVXRVWTVXPVVRVVMUYMV
      XOVVRXBVVMUYMUYMVVMVXJWQXKUUMVXPVWTVVMVXOVWTVVRVVPVVJVWTVVPVWSVVJVVPVWSVV
      OVWRUYPFUWLXMXNXKUUNUUOXOXOYQVWMUYNVXRUYTVWTVWMUYLVVRUYMVXKWJVXLVSUURYMUU
      PYJXSUUSTUUTTYKYIYHVVNVVSUYGVVKVVSUYGSZVVMUWHVUMVXSVVJVVSUWHVUMPZUYGVVQVV
      RVXTUYGSZVULUWHVVRVYASVVPVULVXTVVRUYGVULVXTVVRUYGVVRVULVXTPZUYFUWNNKZUQKZ
      FVVRUYEVYCUQUXBUWNNVPVQVYBVULUWHVUMUFZVYDFOVYBVULUWHVUMVULVXTUVAVULUWHVUM
      UVBVULUWHVUMUVCXGZUWLFUWMGGGWSVCUVDXSYLVDTYGYNXOTVVNVVSUYCVVKVVSUYCSZVVMU
      WHVUMVYGVVJVVSVXTUYCVVQVVRVXTUYCSZVULUWHVVRVYHSVVPVULVXTVVRUYCVULVXTVVRUY
      CVYBVVRPUYCUWNUXKJZVYBVYIVVRVYBUWNUWNOVYEVYIVYBUWNUVEVYFUWLFUWMUWNGGGUVHV
      JXOVVRUYCVYIRVYBUXBUWNUXKVMYMUVFXSYLVDTYGYNXOTUVGXRUVIUWIVVCVVNVVEVWAVVCU
      WMUWQJZUWMUWRJZWPZPUWIVVNUWMUWQUWRUVJUWIVYJVVKVYLVVMUWFUWGVYJVVKRZUWHUWFV
      UJVYMVUKDFUWMGQQYOVCWCUWIVYKVVLVYKVVLRUWIBUWLXEWDUVKVSYPUWIVVDVVQUXNUWFUW
      GVVDVVQRZUWHUWFVUJVYNVUKDFUWLGQQYOVCWCWJVSUVLUVMVUQVUSBWOZAGMVULVYOPZAWOV
      VBVUPVYOAGVUOBGYRUVNVYOAGYRVYPVVAAVVAVYPVULVUSBUVOWQYSUVPUXPVVDUXOPZAWOVV
      HUXOAUWQYRVYQVVGAVYQVVEBUWSMVVGVVDUXNBUWSUVQVVEBUWSYRUVSYSXJUVTYPYTUXPUXQ
      RUWIUXQUXPUWTUXPUAUXBUBWRUAUBVOUWPUXNABUWQUWSUWKUXBUWOVMUWAUWBWQWDYTUWCAB
      UAUWQUWSUWOUWDUWE $.

    $d E c d t v $.  $d K d c $.  $d V c d v $.  $d a c d v $.
    $( According to the proof of the third claim in the proof of the friendship
       theorem in [Huneke] p. 2:  "For each vertex v, there are exactly ( k 2 )
       paths with length two having v in the middle, ..." in a finite k-regular
       graph.  For simple paths of length 2 represented by ordered triples, we
       have again k*(k-1) such paths.  (Contributed by Alexander van der
       Vekens, 10-Mar-2018.) $)
    usgreghash2spotv $p |- ( ( V USGrph E /\ V e. Fin )
          -> A. v e. V ( ( ( V VDeg E ) ` v ) = K
               -> ( # ` ( M ` v ) ) = ( K x. ( K - 1 ) ) ) ) $=
      ( vd vc cfn wcel wa co cfv wceq chash c1 cmul csu cusg wbr cv cvdg wi cop
      cmin cnbgra csn cdif cotp ciun usg2spot2nb 3expa fveq2d nbfiusgrafi diffi
      wral w3a syl adantr a1i ralrimiva iunfi syl2anc wdisj nbgrassvt ad3antrrr
      snfi wss ssdifd iunss1 simpr otiunsndisj disjss2 hashiun eqtrd nbgraisvtx
      sylc ad2antrr imp otsndisj otex hashsng mp1i sumeq2dv cc ax-1cn fsumconst
      cvv sylancl 3eqtrd hashdifsn sylan oveq1d cr cn0 hashcl peano2rem ax-1rid
      nn0red nn0cnd subcld hashnbgravdg wb eqeq1 eqcoms id oveq1 oveq12d syl6bi
      3syl adantlr ex ) FCUAUBZFKLZMZAUCZFCUDNOZDPZXREOZQOZDDRUGNZSNZPZUEAFXQXR
      FLZMZXTYEYGXTMZYBFCUFXRUHNZIYIJUCZUIZUJZYJXRIUCZUKZUIZULZQOZJTZYIYLQOZRSN
      ZJTZYDYGYBYRPXTYGYBJYIYPULZQOYRYGYAUUBQXOXPYFYAUUBPJIBCEXRFGHUMUNUOYGJYIY
      PXOXPYFYIKLZCXRFUPZUNZYGYJYILZMZYLKLZYOKLZIYLURYPKLYGUUHUUFXOXPYFUUHXOXPY
      FUSUUCUUHUUDYIYKUQUTUNZVAUUGUUIIYLUUIUUGYMYLLZMYNVIZVBVCIYLYOVDVEYGYPIFYK
      UJZYOULZVJZJYIURJYIUUNVFZJYIYPVFYGUUOJYIUUGYLUUMVJUUOUUGYIFYKXOYIFVJXPYFU
      UFCXRFVGVHVKIYLUUMYOVLUTVCYGYFUUPXQYFVMZXRYIFFJIVNUTJYIYPUUNVOVSVPVQVAYHY
      IYQYTJYHUUFMZYQYLYOQOZITYLRITZYTUURIYLYOYGUUHXTUUFUUJVTZUUIUURUUKMZUULVBU
      URYJFLZYFIYLYOVFYHUUFUVCXOUUFUVCUEXPYFXTCXRYJFVRVHWAYGYFXTUUFUUQVTYJXRYLF
      FIWBVEVPUURYLUUSRIYNWJLUUSRPUVBYJXRYMWCYNWJWDWEWFUURUUHRWGLZUUTYTPUVAWHYL
      RIWIWKWLWFYHUUAYIYIQOZRUGNZJTZUVEUVFSNZYDYHYIYTUVFJUURYTUVFRSNZUVFUURYSUV
      FRSYHUUCUUFYSUVFPYGUUCXTUUEVAZYIYJWMWNWOYGUVIUVFPZXTUUFYGUVEWPLUVFWPLUVKY
      GUVEYGUUCUVEWQLUUEYIWRUTZXAUVEWSUVFWTXLVTVQWFYHUUCUVFWGLZUVGUVHPUVJYGUVMX
      TYGUVERYGUVEUVLXBUVDYGWHVBXCVAYIUVFJWIVEYGXTUVHYDPZXOYFXTUVNUEZXPXOYFMUVE
      XSPZUVOXRCFXDUVPXTUVEDPZUVNXTUVQXEXSUVEXSUVEDXFXGUVQUVEDUVFYCSUVQXHUVEDRU
      GXIXJXKUTXMWAWLWLXNVC $.

    $d f p q x y z $.  $d E f q $.  $d K x $.  $d K p $.  $d M p v $.
    $d V f q $.  $d v x $.
    $( In a finite k-regular graph the set of all paths of length two is the
       union of all the paths of length 2 over the vertices which are in the
       the middle of such a path.  (Contributed by Alexander van der Vekens,
       10-Mar-2018.) $)
    usgreg2spot $p |- ( ( V USGrph E /\ V e. Fin )
                       -> ( A. v e. V ( ( V VDeg E ) ` v ) = K
                            -> ( V 2SPathsOt E ) = U_ x e. V ( M ` x ) ) ) $=
      ( vy vz wcel wa cv cfv wceq wrex c1st c2nd cvv vp vf vq cusg wbr cfn cvdg
      co wral c2spthot ciun cxp wi cotp cspath chash c2 cc0 c1 w3a wb el2pthsot
      wex usgrav syl simpr ad2antrr adantr 3jca eqidd otel3xp syl2anc jca fveq2
      ot2ndg fveq2d eqeq1d eleq1 anbi12d syl5ibr com12 rexlimdva r19.41v syl6ib
      reximdva sylbid pm4.71rd anass bicomi ancom r19.42v 3bitr4i bitri syl6bbr
      rexbii crab 3xpexg rabexg ad3antlr weq eqeq2 anbi2d rabbidv fvmptg eleq2d
      elrab syl6rbb rexbidva bitrd eliun eqrdv ex ) GDUDUEZGUFLZMZBNGDUGUHOEPBG
      UIZGDUJUHZAGANZFOZUKZPXOXPMZUAXQXTYAUANZXQLZYBXSLZAGQZYBXTLYAYCYBGGULGULZ
      LZYCYBROZSOZXRPZMZMZAGQZYEYAYCYJAGQZYGMZYCMZYMYAYCYOXMYCYOUMXNXPXMYCYBJNZ
      XRKNZUNZPZUBNZUCNZGDUOUHUEUUAUPOUQPYQURUUBOPXRUSUUBOPYRUQUUBOPUTUTUCVCUBV
      CZMZKGQZAGQZJGQZYOXMGTLDTLMYCUUGVADGVDYBUBDGTTUCJAKVBVEXMUUFYOJGXMYQGLZMZ
      UUFYJYGMZAGQYOUUIUUEUUJAGUUIXRGLZMZUUDUUJKGUUDUULYRGLZMZUUJYTUUNUUJUMUUCU
      UNUUJYTYSROZSOZXRPZYSYFLZMUUNUUQUURUUNUUHUUKUUMUTZUUQUUNUUHUUKUUMUUIUUHUU
      KUUMXMUUHVFVGUULUUKUUMUUIUUKVFVHUULUUMVFVIZYQXRYRGGGVOVEUUNYSYSPUUSUURUUN
      YSVJUUTYQXRYRYSGGGVKVLVMYTYJUUQYGUURYTYIUUPXRYTYHUUOSYBYSRVNVPVQYBYSYFVRV
      SVTVHWAWBWEYJYGAGWCWDWBWFVGWGYMYGYCMZYJMZAGQZYPYLUVBAGUVBYLYGYCYJWHWIWOUV
      AYNMYNUVAMUVCYPUVAYNWJUVAYJAGWKYNYGYCWHWLWMWNYAYLYDAGYAUUKMZYDYBCNZXQLZUV
      EROZSOZXRPZMZCYFWPZLYLUVDXSUVKYBUVDUUKUVKTLZXSUVKPYAUUKVFXNUVLXMXPUUKXNYF
      TLUVLGUFWQUVJCYFTWRVEWSHXRUVFUVHHNZPZMZCYFWPUVKGTFHAWTZUVOUVJCYFUVPUVNUVI
      UVFUVMXRUVHXAXBXCIXDVLXEUVJYKCYBYFCUAWTZUVFYCUVIYJUVEYBXQVRUVQUVHYIXRUVQU
      VGYHSUVEYBRVNVPVQVSXFXGXHXIAYBGXSXJWNXKXL $.

    $d E b $.  $d M t x y $.  $d V b c d t x y $.
    $( The sets of paths of length 2 with a given vertex in the middle are
       distinct for different vertices in the middle.  (Contributed by
       Alexander van der Vekens, 11-Mar-2018.) $)
    2spotmdisj $p |- ( V e. _V -> Disj_ x e. V ( M ` x ) ) $=
      ( vy vb vc vd cvv wcel weq cv cfv wceq wa wi wn cin c0 wral wdisj orc a1d
      wo cxp c2spthot co c1st c2nd crab simpl xpexg anidms mpancom rabexg eqeq2
      anbi2d rabbidv fvmptg syl2anr eleq2d rabid cotp wrex el2xptp ot2ndg 3expa
      syl eqeq1d adantr ax-8 adantl sylbid con3d ex a1dd com12 a1i fveq2 fveq2d
      notbid imbi2d 3imtr4d com13 rexlimdva rexlimivv sylbi com23 imp31 intnand
      imp syl5bi wb simpr syl6bb mpbird ralrimiva disj sylibr expcom ralrimivva
      olcd pm2.61i disjor ) ELMZAHNZAOZDPZHOZDPZUAUBQZUGZHEUCAEUCAEXKUDXHXOAHEE
      XIXHXJEMZXLEMZRZRZXOSXIXOXSXIXNUEUFXSXITZXOXSXTRZXNXIYABOZXMMZTZBXKUCXNYA
      YDBXKYAYBXKMZRZYDYBEEUHZEUHZMZYBECUIUJMZYBUKPZULPZXLQZRZRZTZYFYNYIYFYMYJX
      SXTYEYMTZXSYEXTYQXSYEYBYJYLXJQZRZBYHUMZMZXTYQSZXSXKYTYBXRXPYTLMZXKYTQXHXP
      XQUNXHYHLMZUUCYGLMZXHUUDXHUUEEELLUOUPYGELLUOUQZYSBYHLURVKFXJYJYLFOZQZRZBY
      HUMZYTELDFANZUUIYSBYHUUKUUHYRYJUUGXJYLUSUTVAGVBVCVDUUAYIYSRZXSUUBYSBYHVEX
      RUULUUBSXHUULXRUUBYIYSXRUUBSZYIYBIOZJOZKOZVFZQZKEVGZJEVGIEVGYSUUMSZIJKYBE
      EEVHUUSUUTIJEEUUNEMZUUOEMZRZUURUUTKEYSUURUVCUUPEMZRZUUMYRUURUVEUUMSZSYJUU
      RYRUVFUURUUQUKPZULPZXJQZUVEXRXTUVHXLQZTZSZSZSZYRUVFUVIUVNSUURUVEUVIUVMUVE
      UVIJANZUVMUVEUVHUUOXJUVAUVBUVDUVHUUOQZUUNUUOUUPEEEVIVJZVLUVEUVOUVLXRUVEUV
      OUVLUVEUVORZUVJXIUVRUVJJHNZXIUVRUVHUUOXLUVEUVPUVOUVQVMVLUVOUVSXISUVEJAHVN
      VOVPVQVRVSVPVTWAUURYLUVHXJUURYKUVGULYBUUQUKWBWCZVLUURUUMUVMUVEUURUUBUVLXR
      UURYQUVKXTUURYMUVJUURYLUVHXLUVTVLWDWEWEWEWFVTVOWGWHWIWJWNVTVOWOVPWKWLWMWM
      YAYDYPWPZYEXSUWAXTXSYCYOXSYCYBYNBYHUMZMYOXSXMUWBYBXRXQUWBLMZXMUWBQXHXPXQW
      QXHUUDUWCUUFYNBYHLURVKFXLUUJUWBELDFHNZUUIYNBYHUWDUUHYMYJUUGXLYLUSUTVAGVBV
      CVDYNBYHVEWRWDVMVMWSWTBXKXMXAXBXEXCXFXDEXKXMAHXJXLDWBXGXB $.
  $}

  ${
    $d E a s t v y $.  $d K v y $.  $d V a s t v y $.
    $( In a finite k-regular graph with N vertices there are N times " ` k `
       choose 2 " paths with length 2, according to the proof of the third
       claim in the proof of the friendship theorem in [Huneke] p. 2:  "...
       giving n * ( k 2 ) total paths of length two.", if the direction of
       traversing the path is not respected.  For simple paths of length 2
       represented by ordered triples, however, we have again n*k*(k-1) such
       paths.  (Contributed by Alexander van der Vekens, 11-Mar-2018.) $)
    usgreghash2spot $p |- ( ( V USGrph E /\ V e. Fin /\ V =/= (/) )
          -> ( A. v e. V ( ( V VDeg E ) ` v ) = K
      -> ( # ` ( V 2SPathsOt E ) ) = ( ( # ` V ) x. ( K x. ( K - 1 ) ) ) ) ) $=
      ( vy va vs vt cfn wcel cv co cfv wceq wral chash wa c1st wi syl cusg cvdg
      wbr c0 wne w3a c2spthot cmin cmul c2nd cxp crab cmpt ciun csu eleq1 fveq2
      weq fveq2d eqeq1d anbi12d cbvrabv mpteq2i usgreg2spot 3adant3 simpl simpr
      c1 imp cvv 3xpfi rabexg ad2antrr eqeq2 anbi2d rabbidv eqid fvmptg syl2anc
      rabfi eqeltrd wdisj elex 2spotmdisj adantr hashiun usgreghash2spotv ralim
      3ad2antl2 rspccva sumeq2dv cc simpl2 cn0 usgfidegfi r19.26 biimpac ralimi
      sylan wrex r19.2z nn0cn kcnktkm1cn rexlimivw expcom sylbir ex com23 3imp1
      fsumconst eqtrd 3eqtrd ) DBUAUCZDIJZDUDUEZUFZAKZDBUBLMZCNZADOZDBUGLZPMZDP
      MCCVHUHLUILZUILZNXPXTQZYBEDEKZFDGKZYAJZYGRMZUJMZFKZNZQZGDDUKDUKZULZUMZMZU
      NZPMZDYQPMZEUOZYDYEYAYRPXPXTYAYRNZXMXNXTUUBSXOEAHBCYPDFFDYOHKZYAJZUUCRMZU
      JMZYKNZQZHYNULYMUUHGHYNGHURZYHUUDYLUUGYGUUCYAUPUUIYJUUFYKUUIYIUUEUJYGUUCR
      UQUSUTVAVBVCZVDVEVIUSXNXMXTYSUUANXOXNXTQZEDYQXNXTVFUUKYFDJZQZYQYHYJYFNZQZ
      GYNULZIUUMUULUUPVJJZYQUUPNUUKUULVGXNUUQXTUULXNYNIJZUUQDVKZUUOGYNIVLTVMFYF
      YOUUPDVJYPFEURZYMUUOGYNUUTYLUUNYHYKYFYJVNVOVPYPVQVRVSUUMUURUUPIJXNUURXTUU
      LUUSVMUUOGYNVTTWAXNEDYQWBZXTXNDVJJUVADIWCEHBYPDFUUJWDTWEWFWIYEUUADYCEUOZY
      DYEDYTYCEYEXQYPMZPMZYCNZADOZUULYTYCNZXPXTUVFXMXNXTUVFSZXOXMXNQZXSUVESADOU
      VHAHBCYPDFUUJWGXSUVEADWHTVEVIUVEUVGAYFDAEURZUVDYTYCUVJUVCYQPXQYFYPUQUSUTW
      JWSWKYEXNYCWLJZUVBYDNXMXNXOXTWMXMXNXOXTUVKXMXNXOXTUVKSSZUVIXRWNJZADOZUVLA
      BDWOUVNXTXOUVKUVNXTXOUVKSZUVNXTQUVMXSQZADOZUVOUVMXSADWPUVQCWNJZADOZUVOUVP
      UVRADXSUVMUVRXRCWNUPWQWRXOUVSUVKXOUVSQUVRADWTUVKUVRADXAUVRUVKADUVRCWLJUVK
      CXBCXCTXDTXETXFXGXHTXGXIDYCEXJVSXKXLXG $.
  $}

  ${
    $d E v $.  $d K v $.  $d V v $.
    $( If a nonempty friendship graph is k-regular, its order is k(k-1)+1.
       This corresponds to the third claim in the proof of the friendship
       theorem in [Huneke] p. 2:  "Next we claim that the number n of vertices
       in G is exactly k(k-1)+1.".  (Contributed by Alexander van der Vekens,
       11-Mar-2018.) $)
    frgregordn0 $p |- ( ( V FriendGrph E /\ V e. Fin /\ V =/= (/) )
                      -> ( A. v e. V ( ( V VDeg E ) ` v ) = K
                           -> ( # ` V ) = ( ( K x. ( K - 1 ) ) + 1 ) ) ) $=
      ( wbr cfn wcel c0 wne w3a co cfv wceq c1 cmul wi imp adantr cc cc0 cfrgra
      cv cvdg wral chash cmin caddc cusg frisusgra usgreghash2spot frghash2spot
      c2spthot syl3an1 3impb eqeq1 hashcl nn0cnd ax-1cn a1i subcld 3ad2ant2 cn0
      usgfiregdegfi nn0cn kcnktkm1cn syl hasheq0 biimpd necon3d 3adant1 mulcand
      wa subadd2 eqcom syl6bb syl3anc sylbid com12 syl6bi com23 mpcom mpd ex )
      DBUAEZDFGZDHIZJZAUBDBUCKLCMADUDZDUELZCCNUFKOKZNUGKZMZWGWHVLZDBULKUELZWIWJ
      OKZMZWLWGWHWPWDDBUHEZWEWFWHWPPBDUIZABCDUJUMQWNWIWINUFKZOKZMZWMWPWLPWGXAWH
      WDWEWFXABDUKUNRXAWPWMWLXAWPWTWOMZWMWLPWNWTWOUOWMXBWLWMXBWSWJMZWLWMWSWJWIW
      GWSSGZWHWEWDXDWFWEWINWEWIDUPUQZNSGZWEURUSUTVARWMCVBGZWJSGZWGWHXGWDWQWEWFW
      HXGPWRABCDVCUMQXGCSGXHCVDCVEVFVFZWGWISGZWHWEWDXJWFXEVARZWGWITIZWHWEWFXLWD
      WEWFXLWEWITDHWEWITMDHMDFVGVHVIQVJRVKWMXJXFXHXCWLPXKXFWMURUSXIXJXFXHJZXCWL
      XMXCWKWIMWLWINWJVMWKWIVNVOVHVPVQVRVSVTWAWBWC $.
  $}

$( (End of Alexander van der Vekens's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for David A. Wheeler
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

  This is the mathbox of David A. Wheeler, dwheeler at dwheeler dot com.
  Among other things, I have added a number of formal definitions for
  widely-used functions, e.g., those defined in
  ISO 80000-2:2009(E)
  _Quantities and units - Part 2: Mathematical signs and
  symbols used in the natural sciences and technology_
  and the
  _NIST Digital Library of Mathematical Functions_ ~ http://dlmf.nist.gov/ .

$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Natural deduction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    19.8ad.1 $e |- ( ph -> ps ) $.
    $( If a wff is true, it is true for at least one instance.  Deductive form
       of ~ 19.8a .  (Contributed by DAW, 13-Feb-2017.) $)
    19.8ad $p |- ( ph -> E. x ps ) $=
      ( wex 19.8a syl ) ABBCEDBCFG $.
  $}

  ${
    sbidd.1 $e |- ( ph -> [ x / x ] ps ) $.
    $( An identity theorem for substitution.  See ~ sbid .  See Remark 9.1 in
       [Megill] p. 447 (p. 15 of the preprint).  (Contributed by DAW,
       18-Feb-2017.) $)
    sbidd $p |- ( ph -> ps ) $=
      ( wsb sbid sylib ) ABCCEBDBCFG $.
  $}

  $( An identity theorem for substitution.  See ~ sbid .  See Remark 9.1 in
     [Megill] p. 447 (p. 15 of the preprint).  (Contributed by DAW,
     18-Feb-2017.) $)
  sbidd-misc $p |- ( ( ph -> [ x / x ] ps ) <-> ( ph -> ps ) )
    $=
    ( wsb sbid imbi2i ) BCCDBABCEF $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Greater than, greater than or equal to.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  As a stylistic issue, set.mm prefers 'less than' instead of
  'greater than' to reduce the number of conversion steps.
  Here we formally define the widely-used relations
  'greater than' and 'greater than or equal to', so that we
  have formal definitions of them, as well as a few related theorems.

$)

  $( Define the 'greater than or equal to' predicate over the extended
     reals. $)

  $c >_ $. $( 'Greater than or equal to' relation (over extended reals). $)
  $c > $. $( 'Greater than' relation (over extended reals) $)

  $( Extend wff notation to include the 'greater than or equal to' relation,
     see ~ df-gte . $)
  cge-real $a class >_ $.
  $( Extend wff notation to include the 'greater than' relation, see
     ~ df-gt . $)
  cgt $a class > $.

  $( Define the 'greater than or equal' predicate over the reals.  Defined in
     ISO 80000-2:2009(E) operation 2-7.10.  It is used as a primitive in the
     "NIST Digital Library of Mathematical Functions" , front introduction,
     "Common Notations and Definitions" section at
     ~ http://dlmf.nist.gov/front/introduction#Sx4 .  This relation is merely
     the converse of the 'less than or equal to' relation defined by ~ df-le .

     We do not write this as ` ( x >_ y <-> y <_ x ) ` , and similarly we do
     not write `` > `` as ` ( x > y <-> y < x ) ` , because these are not
     definitional axioms as understood by mmj2 (those definitions will be
     flagged as being "potentially non-conservative").  We could write them
     this way:
     ` |- > = { <. x , y >. | ( ( x e. RR* /\ y e. RR* ) /\ y < x ) } ` and
     ` |- >_ = { <. x , y >. | ( ( x e. RR* /\ y e. RR* ) /\ y <_ x ) } ` but
     these are very complicated.  This definition of ` >_ ` , and the similar
     one for ` > ` ( ~ df-gt ), are a bit strange when you see them for the
     first time, but these definitions are much simpler for us to process and
     are clearly conservative definitions.  (My thanks to Mario Carneiro for
     pointing out this simpler approach.)  See ~ gte-lte for a more
     conventional expression of the relationship between ` < ` and ` > ` .  As
     a stylistic issue, set.mm prefers 'less than' instead of 'greater than' to
     reduce the number of conversion steps.  Thus, we discourage its use, but
     include its definition so that there _is_ a formal definition of this
     symbol.

     (Contributed by David A. Wheeler, 10-May-2015.)
     (New usage is discouraged.) $)
  df-gte $a |- >_ = `' <_ $.

  $( The 'greater than' relation is merely the converse of the 'less than or
     equal to' relation defined by ~ df-lt .  Defined in ISO 80000-2:2009(E)
     operation 2-7.12.  See ~ df-gte for a discussion on why this approach is
     used for the definition.  See ~ gt-lt and ~ gt-lth for more conventional
     expression of the relationship between ` < ` and ` > ` .

     As a stylistic issue, set.mm prefers 'less than or equal' instead of
     'greater than or equal' to reduce the number of conversion steps.  Thus,
     we discourage its use, but include its definition so that there _is_ a
     formal definition of this symbol.

     (Contributed by David A. Wheeler, 19-Apr-2015.)
     (New usage is discouraged.) $)
  df-gt $a |- > = `' < $.

  $( Simple relationship between ` <_ ` and ` >_ ` .  (Contributed by David A.
     Wheeler, 10-May-2015.)  (New usage is discouraged.) $)
  gte-lte $p |- ( ( A e. _V /\ B e. _V ) -> ( A >_ B <-> B <_ A ) ) $=
    ( cge-real wbr cle ccnv cvv wcel wa df-gte breqi brcnvg syl5bb ) ABCDABEFZD
    AGHBGHIBAEDABCNJKABGGELM $.

  $( Simple relationship between ` < ` and ` > ` .  (Contributed by David A.
     Wheeler, 19-Apr-2015.)  (New usage is discouraged.) $)
  gt-lt $p |- ( ( A e. _V /\ B e. _V ) -> ( A > B <-> B < A ) ) $=
    ( cgt wbr clt ccnv cvv wcel wa df-gt breqi brcnvg syl5bb ) ABCDABEFZDAGHBGH
    IBAEDABCNJKABGGELM $.

  ${
    gte-lteh.1 $e |- A e. _V $.
    gte-lteh.2 $e |- B e. _V $.
    $( Relationship between ` <_ ` and ` >_ ` using hypotheses.  (Contributed
       by David A. Wheeler, 10-May-2015.)  (New usage is discouraged.) $)
    gte-lteh $p |- ( A >_ B <-> B <_ A ) $=
      ( cge-real wbr cle ccnv df-gte breqi brcnv bitri ) ABEFABGHZFBAGFABEMIJAB
      GCDKL $.
  $}

  ${
    gt-lth.1 $e |- A e. _V $.
    gt-lth.2 $e |- B e. _V $.
    $( Relationship between ` < ` and ` > ` using hypotheses.  (Contributed by
       David A. Wheeler, 19-Apr-2015.)  (New usage is discouraged.) $)
    gt-lth $p |- ( A > B <-> B < A ) $=
      ( cgt wbr clt ccnv df-gt breqi brcnv bitri ) ABEFABGHZFBAGFABEMIJABGCDKL
      $.
  $}
  $( Simple example of ` > ` , in this case, 0 is not greater than 0.  This is
     useful as an example, and helps us gain confidence that we've correctly
     defined the symbol.  (Contributed by David A. Wheeler, 1-Jan-2017.)
     (New usage is discouraged.) $)
  ex-gt $p |- -. 0 > 0 $=
    ( cc0 cgt wbr clt 0re ltnri c0ex gt-lth mtbir ) AABCAADCAEFAAGGHI $.

  $( Simple example of ` >_ ` , in this case, 0 is greater than or equal to 0.
     This is useful as an example, and helps us gain confidence that we've
     correctly defined the symbol.  (Contributed by David A. Wheeler,
     1-Jan-2017.)  (New usage is discouraged.) $)
  ex-gte $p |- 0 >_ 0 $=
    ( cc0 cge-real wbr cle 0le0 c0ex gte-lteh mpbir ) AABCAADCEAAFFGH $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Hyperbolic trig functions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  It is a convention of set.mm to not use sinh and so on directly,
  and instead of use expansions such as ` ( cos `` ( _i x. x ) ) ` .
  However, I believe it's important to give formal definitions for
  these conventional functions as they are typically used,
  so here they are.  A few related identities are also proved.

$)

  $c sinh $. $( Hyperbolic sine function. $)
  $c cosh $. $( Hyperbolic cosine function. $)
  $c tanh $. $( Hyperbolic tangent function. $)

  $( Extend class notation to include the hyperbolic sine function, see
     ~ df-sinh . $)
  csinh $a class sinh $.
  $( Extend class notation to include the hyperbolic cosine function. see
     ~ df-cosh . $)
  ccosh $a class cosh $.
  $( Extend class notation to include the hyperbolic tangent function, see
     ~ df-tanh . $)
  ctanh $a class tanh $.

  $( Define the hyperbolic sine function (sinh).  We define it this way for
     ~ cmpt , which requires the form ` ( x e. A |-> B ) ` .  See
     ~ sinhval-named for a simple way to evaluate it.  We define this function
     by dividing by ` _i ` , which uses fewer operations than many conventional
     definitions (and thus is more convenient to use in metamath).  See
     ~ sinh-conventional for a justification that our definition is the same as
     the conventional definition of sinh used in other sources.  (Contributed
     by David A. Wheeler, 20-Apr-2015.) $)
  df-sinh $a |- sinh = ( x e. CC |-> ( ( sin ` ( _i x. x ) ) / _i ) ) $.

  $( Define the hyperbolic cosine function (cosh).  We define it this way for
     ~ cmpt , which requires the form ` ( x e. A |-> B ) ` .  (Contributed by
     David A. Wheeler, 10-May-2015.) $)
  df-cosh $a |- cosh = ( x e. CC |-> ( cos ` ( _i x. x ) ) ) $.

  $( Define the hyperbolic tangent function (tanh).  We define it this way for
     ~ cmpt , which requires the form ` ( x e. A |-> B ) ` .  (Contributed by
     David A. Wheeler, 10-May-2015.) $)
  df-tanh $a |- tanh = ( x e. ( `' cosh " ( CC \ { 0 } ) ) |->
                       ( ( tan ` ( _i x. x ) ) / _i ) ) $.


  ${
    $d x A $.
    $( Value of the named sinh function.  Here we show the simple conversion to
       the conventional form used in set.mm, using the definition given by
       ~ df-sinh .  See ~ sinhval for a theorem to convert this further.  See
       ~ sinh-conventional for a justification that our definition is the same
       as the conventional definition of sinh used in other sources.
       (Contributed by David A. Wheeler, 20-Apr-2015.) $)
    sinhval-named $p |- ( A e. CC ->
                          ( sinh ` A ) = ( ( sin ` ( _i x. A ) ) / _i ) ) $=
      ( vx ci cv cmul co csin cfv cdiv cc csinh wceq fveq2d oveq1d df-sinh ovex
      oveq2 fvmpt ) BACBDZEFZGHZCIFCAEFZGHZCIFJKSALZUAUCCIUDTUBGSACEQMNBOUCCIPR
      $.
  $}

  ${
    $d x A $.
    $( Value of the named cosh function.  Here we show the simple conversion to
       the conventional form used in set.mm, using the definition given by
       ~ df-cosh .  See ~ coshval for a theorem to convert this further.
       (Contributed by David A. Wheeler, 10-May-2015.) $)
    coshval-named $p |- ( A e. CC -> ( cosh ` A ) = ( cos ` ( _i x. A ) ) ) $=
      ( vx ci cv cmul co ccos cfv cc ccosh wceq oveq2 fveq2d df-cosh fvex fvmpt
      ) BACBDZEFZGHCAEFZGHIJQAKRSGQACELMBNSGOP $.
  $}

  ${
    $d x A $.
    $( Value of the named tanh function.  Here we show the simple conversion to
       the conventional form used in set.mm, using the definition given by
       ~ df-tanh .  (Contributed by David A. Wheeler, 10-May-2015.) $)
    tanhval-named $p |- ( A e. ( `' cosh " ( CC \ { 0 } ) ) ->
                          ( tanh ` A ) = ( ( tan ` ( _i x. A ) ) / _i ) ) $=
      ( vx ci cv cmul co ctan cfv cdiv ccosh ccnv cc0 csn cdif cima ctanh oveq2
      cc wceq fveq2d oveq1d df-tanh ovex fvmpt ) BACBDZEFZGHZCIFCAEFZGHZCIFJKRL
      MNOPUEASZUGUICIUJUFUHGUEACEQTUABUBUICIUCUD $.
  $}


  $( Conventional definition of sinh.  Here we show that the sinh definition
     we're using has the same meaning as the conventional definition used in
     some other sources.  We choose a slightly different definition of sinh
     because it has fewer operations, and thus is more convenient to manipulate
     using metamath.  (Contributed by David A. Wheeler, 10-May-2015.) $)
  sinh-conventional $p |- ( A e. CC ->
                 ( sinh ` A ) = ( -u _i x. ( sin ` ( _i x. A ) ) ) ) $=
    ( cc wcel csinh cfv ci cmul co csin cdiv c1 cneg sinhval-named ax-icn mulcl
    wceq mpan sincld cc0 wne ine0 divrec2 mp3an23 syl irec oveq1i a1i 3eqtrd )
    ABCZADEFAGHZIEZFJHZKFJHZUKGHZFLZUKGHZAMUIUKBCZULUNPZUIUJFBCZUIUJBCNFAOQRUQU
    SFSTURNUAUKFUBUCUDUNUPPUIUMUOUKGUEUFUGUH $.


  $( TODO: Show that tanh(x) = -i tan(ix). $)

  $( Prove that ` ( sinh `` A ) + ( cosh `` A ) = ( exp `` A ) ` using the
     conventional hyperbolic trig functions.  (Contributed by David A. Wheeler,
     27-May-2015.) $)
  sinhpcosh $p |- ( A e. CC ->
                   ( ( sinh ` A ) + ( cosh ` A ) ) = ( exp ` A ) ) $=
    ( cc wcel csinh cfv ccosh caddc co c2 ce cmul cdiv cneg cmin eqtrd 2cn 2ne0
    ci efcl a1i csin sinhval-named sinhval coshval-named coshval oveq12d cc0 wa
    ccos wne wceq addcld subcld divdir syl3an1 syl3an2 3anidm12 mpanr12 2timesd
    negcl syl nppcand addassd 3eqtr2rd oveq1d 3eqtr2d divcan3d ) ABCZADEZAFEZGH
    ZIAJEZKHZILHZVLVHVKVLAMZJEZNHZILHZVLVPGHZILHZGHZVQVSGHZILHZVNVHVIVRVJVTGVHV
    IRAKHZUAERLHVRAUBAUCOVHVJWDUIEVTAUDAUEOUFVHIBCZIUGUJZWCWAUKZPQVHWEWFUHZWGVH
    VHVSBCZWHWGVHVLVPASZVHVOBCVPBCAUTVOSVAZULVHVQBCWIWHWGVHVLVPWJWKUMZVQVSIUNUO
    UPUQURVHWBVMILVHVMVLVLGHVQVLGHVPGHWBVHVLWJUSVHVLVPVLWJWKWJVBVHVQVLVPWLWJWKV
    CVDVEVFVHVLIWJWEVHPTWFVHQTVGO $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Reciprocal trig functions (sec, csc, cot)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Define the traditional reciprocal trigonometric functions
  secant (sec), cosecant (csc), and cotangent (cos), along with
  various identities involving them.

$)


  $c sec $. $( Secant function. $)
  $c csc $. $( Cosecant function. $)
  $c cot $. $( Cotangent function. $)

  $( Extend class notation to include the secant function, see ~ df-sec . $)
  csec $a class sec $.

  $( Extend class notation to include the cosecant function, see ~ df-csc . $)
  ccsc $a class csc $.

  $( Extend class notation to include the cotangent function, see ~ df-cot . $)
  ccot $a class cot $.

  ${
    $d x y $.
    $( Define the secant function.  We define it this way for ~ cmpt , which
       requires the form ` ( x e. A |-> B ) ` .  The sec function is defined in
       ISO 80000-2:2009(E) operation 2-13.6 and "NIST Digital Library of
       Mathematical Functions" section on "Trigonometric Functions"
       ~ http://dlmf.nist.gov/4.14 (Contributed by David A. Wheeler,
       14-Mar-2014.) $)
    df-sec $a |- sec = ( x e. { y e. CC | ( cos ` y ) =/= 0 } |->
                       ( 1 / ( cos ` x ) ) ) $.

    $( Define the cosecant function.  We define it this way for ~ cmpt , which
       requires the form ` ( x e. A |-> B ) ` .  The csc function is defined in
       ISO 80000-2:2009(E) operation 2-13.7 and "NIST Digital Library of
       Mathematical Functions" section on "Trigonometric Functions"
       ~ http://dlmf.nist.gov/4.14 (Contributed by David A. Wheeler,
       14-Mar-2014.) $)
    df-csc $a |- csc = ( x e. { y e. CC | ( sin ` y ) =/= 0 } |->
                       ( 1 / ( sin ` x ) ) ) $.

    $( Define the cotangent function.  We define it this way for ~ cmpt , which
       requires the form ` ( x e. A |-> B ) ` .  The cot function is defined in
       ISO 80000-2:2009(E) operation 2-13.5 and "NIST Digital Library of
       Mathematical Functions" section on "Trigonometric Functions"
       ~ http://dlmf.nist.gov/4.14 (Contributed by David A. Wheeler,
       14-Mar-2014.) $)
    df-cot $a |- cot = ( x e. { y e. CC | ( sin ` y ) =/= 0 } |->
                       ( ( cos ` x ) / ( sin ` x ) ) ) $.
  $}

  ${
    $d x y A $.
    $( Value of the secant function.  (Contributed by David A. Wheeler,
       14-Mar-2014.) $)
    secval $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
                   ( sec ` A ) = ( 1 / ( cos ` A ) ) ) $=
      ( vy vx cc wcel ccos cfv cc0 wa cv crab csec c1 cdiv co wceq fveq2 neeq1d
      wne elrab oveq2d df-sec ovex fvmpt sylbir ) ADEAFGZHSZIABJZFGZHSZBDKZEALG
      MUFNOZPUJUGBADUHAPUIUFHUHAFQRTCAMCJZFGZNOULUKLUMAPUNUFMNUMAFQUACBUBMUFNUC
      UDUE $.

    $( Value of the cosecant function.  (Contributed by David A. Wheeler,
       14-Mar-2014.) $)
    cscval $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 ) ->
                   ( csc ` A ) = ( 1 / ( sin ` A ) ) ) $=
      ( vy vx cc wcel csin cfv cc0 wa cv crab ccsc c1 cdiv co wceq fveq2 neeq1d
      wne elrab oveq2d df-csc ovex fvmpt sylbir ) ADEAFGZHSZIABJZFGZHSZBDKZEALG
      MUFNOZPUJUGBADUHAPUIUFHUHAFQRTCAMCJZFGZNOULUKLUMAPUNUFMNUMAFQUACBUBMUFNUC
      UDUE $.

    $( Value of the cotangent function.  (Contributed by David A. Wheeler,
       14-Mar-2014.) $)
    cotval $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 ) ->
                   ( cot ` A ) = ( ( cos ` A ) / ( sin ` A ) ) ) $=
      ( vy vx cc wcel csin cfv cc0 wne wa cv crab ccot ccos cdiv co wceq neeq1d
      fveq2 elrab oveq12d df-cot ovex fvmpt sylbir ) ADEAFGZHIZJABKZFGZHIZBDLZE
      AMGANGZUFOPZQUJUGBADUHAQUIUFHUHAFSRTCACKZNGZUNFGZOPUMUKMUNAQUOULUPUFOUNAN
      SUNAFSUACBUBULUFOUCUDUE $.
  $}

  $( The closure of the secant function with a complex argument.  (Contributed
     by David A. Wheeler, 14-Mar-2014.) $)
  seccl $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
              ( sec ` A ) e. CC ) $=
    ( cc wcel ccos cfv cc0 wne wa csec c1 cdiv secval coscl adantr simpr reccld
    co eqeltrd ) ABCZADEZFGZHZAIEJTKQBALUBTSTBCUAAMNSUAOPR $.

  $( The closure of the cosecant function with a complex argument.
     (Contributed by David A. Wheeler, 14-Mar-2014.) $)
  csccl $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 ) ->
              ( csc ` A ) e. CC ) $=
    ( cc wcel csin cfv cc0 wne wa ccsc c1 cdiv cscval sincl adantr simpr reccld
    co eqeltrd ) ABCZADEZFGZHZAIEJTKQBALUBTSTBCUAAMNSUAOPR $.

  $( The closure of the cotangent function with a complex argument.
     (Contributed by David A. Wheeler, 15-Mar-2014.) $)
  cotcl $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 ) -> ( cot ` A ) e. CC ) $=
    ( cc wcel csin cfv cc0 wa ccot ccos cdiv co cotval coscl adantr sincl simpr
    wne divcld eqeltrd ) ABCZADEZFQZGZAHEAIEZUAJKBALUCUDUATUDBCUBAMNTUABCUBAONT
    UBPRS $.

  $( The closure of the secant function with a real argument.  (Contributed by
     David A. Wheeler, 15-Mar-2014.) $)
  reseccl $p |- ( ( A e. RR /\ ( cos ` A ) =/= 0 ) -> ( sec ` A ) e. RR ) $=
    ( cr wcel ccos cfv cc0 wa csec c1 cdiv co cc wceq recn secval sylan recoscl
    wne 1re a1i redivcl syl3an1 syl3an2 3anidm12 eqeltrd ) ABCZADEZFRZGAHEZIUGJ
    KZBUFALCUHUIUJMANAOPUFUHUJBCZUFUFUGBCZUHUKAQUFIBCZULUHUKUMUFSTIUGUAUBUCUDUE
    $.

  $( The closure of the cosecant function with a real argument.  (Contributed
     by David A. Wheeler, 15-Mar-2014.) $)
  recsccl $p |- ( ( A e. RR /\ ( sin ` A ) =/= 0 ) -> ( csc ` A ) e. RR ) $=
    ( cr wcel csin cfv cc0 wa ccsc c1 cdiv co cc wceq recn cscval sylan resincl
    wne 1re a1i redivcl syl3an1 syl3an2 3anidm12 eqeltrd ) ABCZADEZFRZGAHEZIUGJ
    KZBUFALCUHUIUJMANAOPUFUHUJBCZUFUFUGBCZUHUKAQUFIBCZULUHUKUMUFSTIUGUAUBUCUDUE
    $.

  $( The closure of the cotangent function with a real argument.  (Contributed
     by David A. Wheeler, 15-Mar-2014.) $)
  recotcl $p |- ( ( A e. RR /\ ( sin ` A ) =/= 0 ) -> ( cot ` A ) e. RR ) $=
    ( cr wcel csin cfv cc0 wne wa ccot ccos cdiv co cc wceq recn cotval resincl
    sylan recoscl redivcl syl3an1 syl3an2 3anidm12 eqeltrd ) ABCZADEZFGZHAIEZAJ
    EZUFKLZBUEAMCUGUHUJNAOAPRUEUGUJBCZUEUEUFBCZUGUKAQUEUIBCULUGUKASUIUFTUAUBUCU
    D $.

  $( The reciprocal of secant is cosine.  (Contributed by David A. Wheeler,
     14-Mar-2014.) $)
  recsec $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
                 ( cos ` A ) = ( 1 / ( sec ` A ) ) ) $=
    ( cc wcel ccos cfv cc0 wne wa c1 csec cdiv secval oveq2d coscl recrec sylan
    co wceq eqtr2d ) ABCZADEZFGZHZIAJEZKQIIUAKQZKQZUAUCUDUEIKALMTUABCUBUFUARANU
    AOPS $.

  $( The reciprocal of cosecant is sine.  (Contributed by David A. Wheeler,
     14-Mar-2014.) $)
  reccsc $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 ) ->
               ( sin ` A ) = ( 1 / ( csc ` A ) ) ) $=
    ( cc wcel csin cfv cc0 wne wa c1 ccsc cdiv cscval oveq2d sincl recrec sylan
    co wceq eqtr2d ) ABCZADEZFGZHZIAJEZKQIIUAKQZKQZUAUCUDUEIKALMTUABCUBUFUARANU
    AOPS $.

  $( The reciprocal of cotangent is tangent.  (Contributed by David A. Wheeler,
     21-Mar-2014.) $)
  reccot $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 /\ ( cos ` A ) =/= 0 ) ->
                   ( tan ` A ) = ( 1 / ( cot ` A ) ) ) $=
    ( cc wcel csin cfv cc0 wne ccos w3a c1 cdiv co ccot ctan sincl coscl recdiv
    wceq wa sylanl1 sylanr1 3impdi 3com23 cotval 3adant3 oveq2d tanval 3eqtr4rd
    3adant2 ) ABCZADEZFGZAHEZFGZIZJUMUKKLZKLZUKUMKLZJAMEZKLANEZUJUNULUQURRZUJUN
    ULVAUJUJUNSUKBCZULVAAOUJUMBCUNVBULSVAAPUMUKQTUAUBUCUOUSUPJKUJULUSUPRUNAUDUE
    UFUJUNUTURRULAUGUIUH $.

  $( The reciprocal of tangent is cotangent.  (Contributed by David A. Wheeler,
     21-Mar-2014.) $)
  rectan $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 /\ ( cos ` A ) =/= 0 ) ->
                   ( cot ` A ) = ( 1 / ( tan ` A ) ) ) $=
    ( cc wcel csin cfv cc0 wne ccos w3a c1 cdiv co ctan ccot coscl sincl recdiv
    wceq wa sylanl1 sylanr1 3impdi tanval 3adant2 oveq2d 3adant3 3eqtr4rd
    cotval ) ABCZADEZFGZAHEZFGZIZJUJULKLZKLZULUJKLZJAMEZKLANEZUIUKUMUPUQRZUIUIU
    KSULBCZUMUTAOUIUJBCUKVAUMSUTAPUJULQTUAUBUNURUOJKUIUMURUORUKAUCUDUEUIUKUSUQR
    UMAUHUFUG $.

  $( The value of the secant function at zero is one.  (Contributed by David A.
     Wheeler, 16-Mar-2014.) $)
  sec0 $p |- ( sec ` 0 ) = 1 $=
    ( cc0 csec cfv c1 ccos cdiv co cc wcel wne wceq cos0 ax-1ne0 eqnetri secval
    0cn mp2an oveq2i ax-1cn div1i 3eqtri ) ABCZDAECZFGZDDFGDAHIUCAJUBUDKPUCDALM
    NAOQUCDDFLRDSTUA $.

  $( Prove the tangent squared secant squared identity ` ( 1 + ( ( tan ` A ) ^
     2 ) ) = ( ( sec ` A ) ^ 2 ) ) ` .  (Contributed by David A. Wheeler,
     25-May-2015.) $)
  onetansqsecsq $p |- ( ( A e. CC /\ ( cos ` A ) =/= 0 ) ->
                      ( 1 + ( ( tan ` A ) ^ 2 ) ) = ( ( sec ` A ) ^ 2 ) ) $=
    ( cc wcel cfv cc0 wne wa c1 c2 cexp co caddc cdiv wceq sqcld oveq1d syl3an2
    sylan 3anidm12 eqtrd ccos ctan csec csin wb coscl sqeq0 syl necon3bid divid
    biimpar syldan eqcomd tanval 2nn0 sincl expdiv syl3an1 mp3an3 3impb oveq12d
    cn0 divdir eqtr4d addcomd eqtr3d adantr secval ax-1cn mp3an13 oveq1i syl6eq
    sincossq sq1 ) ABCZAUADZEFZGZHAUBDZIJKZLKZHVPIJKZMKZAUCDZIJKZVRWAWBAUDDZIJK
    ZLKZWBMKZWCVRWAWBWBMKZWGWBMKZLKZWIVRHWJVTWKLVRWJHVOVQWBEFZWJHNZVOWMVQVOWBEV
    PEVOVPBCZWBENVPENUEAUFZVPUGUHUIUKZVOWBBCZWMWNVOVPWPOZWBUJRULUMVRVTWFVPMKZIJ
    KZWKVRVSWTIJAUNPVOVQXAWKNZVOVOWOVQXBWPVOWOVQXBVOWOVQGZIVBCZXBUOVOWFBCXCXDXB
    AUPZWFVPIUQURUSUTQSTVAVOVQWMWIWLNZWQVOWMXFVOVOWRWMXFWSVOWRWMXFVOWRWMGZXFVOV
    OWGBCZXGXFVOWFXEOZVOWRXHXGXFWSWBWGWBVCURQSUTQSULVDVOWIWCNVQVOWHHWBMVOWGWBLK
    WHHVOWGWBXIWSVEAVMVFPVGTVRWEHVPMKZIJKZWCVRWDXJIJAVHPVRXKHIJKZWBMKZWCVOWOVQX
    KXMNZWPHBCXCXDXNVIUOHVPIUQVJRXLHWBMVNVKVLTVD $.

  $( Prove the tangent squared cosecant squared identity ` ( 1 + ( ( cot ` A )
     ^ 2 ) ) = ( ( csc ` A ) ^ 2 ) ) ` .  (Contributed by David A. Wheeler,
     27-May-2015.) $)
  cotsqcscsq $p |- ( ( A e. CC /\ ( sin ` A ) =/= 0 ) ->
                  ( 1 + ( ( cot ` A ) ^ 2 ) ) = ( ( csc ` A ) ^ 2 ) ) $=
    ( cc wcel cfv cc0 wne wa c1 c2 cexp co caddc cdiv oveq1d oveq2d wceq adantr
    sqcld 2nn0 expdiv csin ccot ccos cotval sincossq sincl wb sqne0 syl biimpar
    ccsc dividd coscl divdird jca mp3an3 anassrs 3eqtr4rd cscval ax-1cn mp3an13
    cn0 sylan sq1 oveq1i syl6eq eqtrd eqtr4d ) ABCZAUADZEFZGZHAUBDZIJKZLKHAUCDZ
    VJMKZIJKZLKZAUKDZIJKZVLVNVQHLVLVMVPIJAUDNOVLVJIJKZVOIJKZLKZWAMKZHWAMKZVRVTV
    IWDWEPVKVIWCHWAMAUENQVLWAWAMKZWBWAMKZLKHWGLKWDVRVLWFHWGLVLWAVIWABCVKVIVJAUF
    ZRQZVIWAEFZVKVIVJBCZWJVKUGWHVJUHUIUJZULNVLWAWBWAWIVIWBBCVKVIVOAUMZRQWIWLUNV
    LVQWGHLVIVOBCZWKGVKVQWGPZVIWNWKWMWHUOWNWKVKWOWNWKVKGZIVBCZWOSVOVJITUPUQVCOU
    RVLVTHVJMKZIJKZWEVLVSWRIJAUSNVLWSHIJKZWAMKZWEVIWKVKWSXAPZWHHBCWPWQXBUTSHVJI
    TVAVCWTHWAMVDVEVFVGURVH $.


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                          Identities for "if"
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Utility theorems for "if".

$)

  $( If A is not a member of B, but an "if" condition requires it, then the
     "false" branch results.  This is a simple utility to provide a slight
     shortening and simplification of proofs vs. applying ~ iffalse directly in
     this case.  (Contributed by David A. Wheeler, 15-May-2015.) $)
  ifnmfalse $p |- ( A e/ B -> if ( A e. B , C , D ) = D ) $=
    ( wnel wcel wn cif wceq df-nel iffalse sylbi ) ABEABFZGMCDHDIABJMCDKL $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Not-member-of
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    AnelBC.1 $e |- A =/= B $.
    AnelBC.2 $e |- A =/= C $.
    $( If an element doesn't match the items in an unordered pair, it is not in
       the unordered pair, using ` e/ ` .  (Contributed by David A. Wheeler,
       10-May-2015.) $)
    AnelBC $p |- A e/ { B , C } $=
      ( cpr wnel wcel wn nelpri df-nel mpbir ) ABCFZGAMHIABCDEJAMKL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Decimal point
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Define the decimal point operator and the decimal fraction constructor.
  This can model traditional decimal point notation, and serve
  as a convenient way to write some fractional numbers.
  See ~ df-dp and ~ df-dp2 for more information; ~~? dfpval
  provides a more convenient way to obtain a value.
  This is intentionally similar to ~ df-dec .

  TODO: Fix non-existent label dfpval.

$)

  $c _ $. $( Decimal fraction indicator for digits after decimal point $)
  $c . $. $( Decimal point. $)

  $( Constant used for decimal fraction constructor.  See ~ df-dp2 . $)
  cdp2 $a class _ A B $.
  $( Decimal point operator.  See ~ df-dp . $)
  cdp $a class . $.

  $( Define the "decimal fraction constructor", which is used to build up
     "decimal fractions" in base 10.  This is intentionally similar to
     ~ df-dec .  (Contributed by David A. Wheeler, 15-May-2015.) $)
  df-dp2 $a |- _ A B = ( A + ( B / 10 ) ) $.

  ${
    $d x y $.

    $( Define the ` . ` (decimal point) operator.  For example,
       ` ( 1 . 5 ) = ( 3 / 2 ) ` , and
       ` -u ( ; 3 2 . _ 7 _ 1 8 ) = -u ( ; ; ; ; 3 2 7 1 8 / ; ; ; 1 0 0 0 ) `
       Unary minus, if applied, should normally be applied in front of the
       parentheses.

       Metamath intentionally does not have a built-in construct for numbers,
       so it can show that numbers are something you can build based on set
       theory.  However, that means that metamath has no built-in way to handle
       decimal numbers as traditionally written, e.g., "2.54", and its parsing
       system intentionally does not include the complexities necessary to
       define such a parsing system.  Here we create a system for modeling
       traditional decimal point notation; it is not syntactically identical,
       but it is sufficiently similar so it is a reasonable model of decimal
       point notation.  It should also serve as a convenient way to write some
       fractional numbers.

       The RHS is ` RR ` , not ` QQ ` ; this should simplify some proofs.  The
       LHS is ` NN0 ` , since that is what is used in practice.  The definition
       intentionally does not allow negative numbers on the LHS; if it did,
       nonzero fractions would produce the wrong results.  (It would be
       possible to define the decimal point to do this, but using it would be
       more complicated, and the expression ` -u ( A . B ) ` is just as
       convenient.)  (Contributed by David A. Wheeler, 15-May-2015.) $)
    df-dp $a |- . = ( x e. NN0 , y e. RR |-> _ x y ) $.
  $}

  $( Define the closure for the decimal fraction constructor if both values are
     reals.  (Contributed by David A. Wheeler, 15-May-2015.) $)
  dp2cl $p |- ( ( A e. RR /\ B e. RR ) -> _ A B e. RR ) $=
    ( cr wcel wa cdp2 c10 cdiv caddc df-dp2 cc0 wne 10re 10pos gt0ne0ii redivcl
    co mp3an23 readdcl sylan2 syl5eqel ) ACDZBCDZEABFABGHQZIQZCABJUCUBUDCDZUECD
    UCGCDGKLUFMGMNOBGPRAUDSTUA $.

  ${
    $d x y A $.  $d x y B $.
    $( Define the value of the decimal point operator.  See ~ df-dp .
       (Contributed by David A. Wheeler, 15-May-2015.) $)
    dpval $p |- ( ( A e. NN0 /\ B e. RR ) -> ( A . B ) = _ A B ) $=
      ( vx vy cn0 cr cv cdp2 cdp c10 cdiv caddc wceq df-dp2 oveq1 syl5eq oveq2d
      co syl6eqr df-dp cvv ovex eqeltri ovmpt2 ) CDABEFCGZDGZHZABHZIAUFJKRZLRZU
      EAMUGUEUILRUJUEUFNUEAUILOPUFBMZUJABJKRZLRZUHUKUIULALUFBJKOQABNZSCDTUHUMUA
      UNAULLUBUCUD $.
  $}

  $( Prove that the closure of the decimal point is ` RR ` as we have defined
     it.  See ~ df-dp .  (Contributed by David A. Wheeler, 15-May-2015.) $)
  dpcl $p |- ( ( A e. NN0 /\ B e. RR ) -> ( A . B ) e. RR ) $=
    ( cn0 wcel cr wa cdp co cdp2 dpval nn0re dp2cl sylan eqeltrd ) ACDZBEDZFABG
    HABIZEABJOAEDPQEDAKABLMN $.


  $( Prove a simple equivalence involving the decimal point.  See ~ df-dp and
     ~ dpcl .  (Contributed by David A. Wheeler, 15-May-2015.) $)
  dpfrac1 $p |- ( ( A e. NN0 /\ B e. RR ) -> ( A . B ) = ( ; A B / 10 ) ) $=
    ( cn0 wcel cr wa cdp2 c10 cdiv co caddc cdp df-dp2 dpval cc wceq nn0cn recn
    cdc 10re cmul df-dec oveq1i recni mulcl mpan cc0 wne gt0ne0ii pm3.2i divdir
    10pos mp3an3 sylan divcan3 mp3an23 oveq1d adantr syl5eq syl2an 3eqtr4a
    eqtrd ) ACDZBEDZFABGABHIJZKJZABLJABSZHIJZABMABNVCAODZBODZVHVFPVDAQBRVIVJFZV
    HHAUAJZBKJZHIJZVFVGVMHIABUBUCVKVNVLHIJZVEKJZVFVIVLODZVJVNVPPZHODZVIVQHTUDZH
    AUEUFVQVJVSHUGUHZFVRVSWAVTHTULUIZUJVLBHUKUMUNVIVPVFPVJVIVOAVEKVIVSWAVOAPVTW
    BAHUOUPUQURVBUSUTVA $.


  $( TODO: Work out conversions and demos. E.G.,

     dpval.1 $e |- A e. NN0 $.
     dpval.2 $e |- B e. QQ $.
     dpval $p |- ( A . B ) = _ A B $.

     dpcl $p |- ( A . B ) e. QQ $.

     dpfracp1.1 $e |- ( ; A B . C ) = ( D / E ) $.
     dpfracp1 $p |- ( A . _ B C ) = ( D / ; E 0 ) $.
  $)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Signum (sgn or sign) function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c sgn $. $( Signum function, often written "sgn" or "sign". $)

  $( Extend class notation to include the Signum function. $)
  csgn $a class sgn $.

  $( Signum function.  Pronounced "signum" , otherwise it might be confused
     with "sine".  Defined as "sgn" in ISO 80000-2:2009(E) operation 2-9.13.
     It is named "sign" (with the same definition) in the "NIST Digital Library
     of Mathematical Functions" , front introduction, "Common Notations and
     Definitions" section at ~ http://dlmf.nist.gov/front/introduction#Sx4 .
     We define this over ` RR* ` ( ~ df-xr ) instead of ` RR ` so that it can
     accept ` +oo ` and ` -oo ` .  Note that ~ df-psgn defines the sign of a
     permutation, which is different.  Value shown in ~ sgnval .  (Contributed
     by David A. Wheeler, 15-May-2015.) $)
  df-sgn $a |- sgn = ( x e. RR* |-> if ( x = 0 , 0 ,
                                         if ( x < 0 , -u 1 , 1 ) ) ) $.

  ${
    $d x A $.
    $( Value of Signum function.  Pronounced "signum" .  See ~ df-sgn .
       (Contributed by David A. Wheeler, 15-May-2015.) $)
    sgnval $p |- ( A e. RR* -> ( sgn ` A ) =
                             if ( A = 0 , 0 , if ( A < 0 , -u 1 , 1 ) ) ) $=
      ( vx cv cc0 wceq clt wbr c1 cneg cif cxr csgn eqeq1 breq1 ifbieq2d df-sgn
      ifbid c0ex negex ifex 1ex fvmpt ) BABCZDEZDUCDFGZHIZHJZJADEZDADFGZUFHJZJK
      LUCAEZUDUHUGUJDUCADMUKUEUIUFHUCADFNQOBPUHDUJRUIUFHHSUATTUB $.

  $}

  $( Proof that signum of 0 is 0.  (Contributed by David A. Wheeler,
     15-May-2015.) $)
  sgn0 $p |- ( sgn ` 0 ) = 0 $=
    ( cc0 csgn cfv wceq clt wbr cneg cif cxr wcel 0xr sgnval ax-mp iftrue eqtri
    c1 eqid ) ABCZAADZAAAEFPGPHZHZAAIJRUADKALMSUAADAQSATNMO $.

  $( Proof that signum of positive extended real is 1.  (Contributed by David
     A. Wheeler, 15-May-2015.) $)
  sgnp $p |- ( ( A e. RR* /\ 0 < A ) -> ( sgn ` A ) = 1 ) $=
    ( cxr wcel cc0 clt wbr wa csgn cfv wceq c1 cif sgnval adantr wn wne iffalse
    cneg 0xr syl xrltne mp3an1 neneqd wi xrltnsym mpan imp 3eqtrd ) ABCZDAEFZGZ
    AHIZADJZDADEFZKRZKLZLZUPKUIULUQJUJAMNUKUMOUQUPJUKADDBCZUIUJADPSDAUAUBUCUMDU
    PQTUKUNOZUPKJUIUJUSURUIUJUSUDSDAUEUFUGUNUOKQTUH $.

  $( Proof that signum of positive reals is 1.  (Contributed by David A.
     Wheeler, 18-May-2015.) $)
  sgnrrp $p |- ( A e. RR+ -> ( sgn ` A ) = 1 ) $=
    ( crp wcel cxr cc0 clt wbr csgn cfv c1 wceq rpxr rpgt0 sgnp syl2anc ) ABCAD
    CEAFGAHIJKALAMANO $.

  $( Proof that the signum of 1 is 1.  (Contributed by David A. Wheeler,
     26-Jun-2016.) $)
  sgn1 $p |- ( sgn ` 1 ) = 1 $=
    ( c1 cxr wcel cc0 clt wbr csgn cfv wceq 1re rexri 0lt1 sgnp mp2an ) ABCDAEF
    AGHAIAJKLAMN $.

  $( Proof that the signum of ` +oo ` is 1.  (Contributed by David A. Wheeler,
     26-Jun-2016.) $)
  sgnpnf $p |- ( sgn ` +oo ) = 1 $=
    ( cpnf cxr wcel cc0 clt wbr csgn cfv c1 wceq pnfxr cr 0re ltpnf ax-mp mp2an
    sgnp ) ABCDAEFZAGHIJKDLCRMDNOAQP $.

  $( Proof that signum of negative extended real is -1.  (Contributed by David
     A. Wheeler, 15-May-2015.) $)
  sgnn $p |- ( ( A e. RR* /\ A < 0 ) -> ( sgn ` A ) = -u 1 ) $=
    ( cxr wcel cc0 clt wbr wa csgn cfv wceq c1 cneg cif sgnval adantr wn xrltne
    wne 0xr mp3an2 necom df-ne bitri sylib iffalse syl iftrue adantl 3eqtrd ) A
    BCZADEFZGZAHIZADJZDUKKLZKMZMZUPUOUJUMUQJUKANOULUNPZUQUPJULDARZURUJDBCUKUSSA
    DQTUSADRURDAUAADUBUCUDUNDUPUEUFUKUPUOJUJUKUOKUGUHUI $.

  $( Proof that the signum of ` -oo ` is -1.  (Contributed by David A. Wheeler,
     26-Jun-2016.) $)
  sgnmnf $p |- ( sgn ` -oo ) = -u 1 $=
    ( cmnf cxr wcel cc0 clt wbr csgn cfv c1 cneg wceq mnfxr cr mnflt ax-mp sgnn
    0re mp2an ) ABCADEFZAGHIJKLDMCSQDNOAPR $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Ceiling function
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c ceiling $. $( Ceiling function. $)

  $( Extend class notation to include the ceiling function. $)
  ccei $a class ceiling $.

  $( The ceiling function.  Defined in ISO 80000-2:2009(E) operation 2-9.18 and
     the "NIST Digital Library of Mathematical Functions" , front introduction,
     "Common Notations and Definitions" section at
     ~ http://dlmf.nist.gov/front/introduction#Sx4 .

     By convention metamath users tend to expand this construct directly,
     instead of using the definition.  However, we want to make sure this is
     separately and formally defined.  Proof ~ ceicl shows that the ceiling
     function returns an integer when provided a real.  Formalized by David A.
     Wheeler.  (Contributed by David A. Wheeler, 19-May-2015.) $)
  df-ceiling $a |- ceiling = ( x e. RR |-> -u ( |_ ` -u x ) ) $.

  ${
    $d x A $.
    $( The value of the ceiling function.  (Contributed by David A. Wheeler,
       19-May-2015.) $)
    ceilingval $p |- ( A e. RR -> ( ceiling ` A ) = -u ( |_ ` -u A ) ) $=
      ( vx cv cneg cfl cfv ccei wceq negeq fveq2d negeqd df-ceiling negex fvmpt
      cr ) BABCZDZEFZDADZEFZDOGPAHZRTUAQSEPAIJKBLTMN $.
  $}

  $( Closure of the ceiling function; the real work is in ~ ceicl .
     (Contributed by David A. Wheeler, 19-May-2015.) $)
  ceilingcl $p |- ( A e. RR -> ( ceiling ` A ) e. ZZ ) $=
    ( cr wcel ccei cfv cneg cfl cz ceilingval ceicl eqeltrd ) ABCADEAFGEFHAIAJK
    $.

  $( TODO: Here are some other functions to define.

     Reciprocal and arc hyperbolic functions, per
     "NIST Digital Library of Mathematical Functions" ,
     "Hyperbolic Functions - Definitions and Periodicity" at
     ~ http://dlmf.nist.gov/4.28
     and ISO 80000-2:2009(E) operation 2-13.17 and on.
     Note that ISO names the reciprocal sinh as "arsinh" and so on
     (no letter "c"), while NIST names them "Arcsinh" and "arcsinh" and so on
     (using the letter "c") - see ~ http://dlmf.nist.gov/4.37 .
     Also, the "elementary properties" stated at ~ http://dlmf.nist.gov/4.30
     should be checked to ensure all are proven.

     Double-factorial '!!', per
     "NIST Digital Library of Mathematical Functions" , front introduction,
     "Common Notations and Definitions" section at
     ~ http://dlmf.nist.gov/front/introduction#Sx4 .

     Arithmetic mean aka average
     "NIST Digital Library of Mathematical Functions" , front introduction,
     "Common Notations and Definitions" section at
      ~ http://dlmf.nist.gov/1.2#iv .

     Geometric mean
     "NIST Digital Library of Mathematical Functions" , front introduction,
     "Common Notations and Definitions" section at
      ~ http://dlmf.nist.gov/1.2#iv .

     Harmonic mean
     "NIST Digital Library of Mathematical Functions" , front introduction,
     "Common Notations and Definitions" section at
      ~ http://dlmf.nist.gov/1.2#iv .
 $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Logarithms generalized to arbitrary base using ` logb `
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( ` _e ` is not 0.  (Contributed by David A. Wheeler, 17-Oct-2017.) $)
  ene0 $p |- _e =/= 0 $=
    ( ceu ere epos gt0ne0ii ) ABCD $.

  $( ` _e ` is not 1.  (Contributed by David A. Wheeler, 17-Oct-2017.) $)
  ene1 $p |- _e =/= 1 $=
    ( c1 ceu 1re c2 clt wbr 1lt2 c3 egt2lt3 simpli 2re ere lttri mp2an gtneii )
    ABCADEFDBEFZABEFGPBHEFIJADBCKLMNO $.

  $( Using ` _e ` as the base is the same as ` log ` .  (Contributed by David
     A. Wheeler, 17-Oct-2017.) $)
  elogb $p |- ( A e. ( CC \ { 0 } ) -> ( _e logb A ) = ( log ` A ) ) $=
    ( cc cc0 csn cdif wcel ceu clogb co clog cfv cdiv c1 cpr wceq wne ere recni
    ene0 ene1 eldifpr mpbir3an mpan eldifi eldifsni logcld loge oveq2i div1 syl
    logbval syl5eq eqtrd ) ABCDZEFZGAHIZAJKZGJKZLIZUQGBCMNEFZUOUPUSOUTGBFGCPGMP
    GQRSTGBCMUAUBGAUKUCUOUQBFZUSUQOUOAABUNUDABCUEUFVAUSUQMLIUQURMUQLUGUHUQUIULU
    JUM $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Logarithm laws generalized to an arbitrary base - log_
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Define "log using an arbitrary base" function and then prove some
  of its properties.  This builds on previous work by Stefan O'Rear.

  This supports the notational form
  ` ( ( log_ `` B ) `` X ) ` ;  that looks a little more like traditional
  notation, but is different from other 2-parameter functions.
  E.G., ` ( ( log_ `` 10 ) `` ; ; 1 0 0 ) = 2 `

  This form is less convenient to work with inside metamath as compared
  to the ` ( B logb X ) ` form defined separately.
$)

  $c log_ $. $( Logarithm generalized to an arbitrary base. $)

  $( Extend class notation to include the logarithm generalized to an arbitrary
     base. $)
  clog_ $a class log_ $.

  ${
    $d b x $.
    $( Define the ` log_ ` operator.  This is the logarithm generalized to an
       arbitrary base.  It can be used as ` ( ( log_ `` B ) `` X ) ` for "log
       base B of X".  This formulation suggested by Mario Carneiro.
       (Contributed by David A. Wheeler, 14-Jul-2017.) $)
    df-log_ $a |- log_ =
      ( b e. ( CC \ { 0 , 1 } ) |->
        ( x e. ( CC \ { 0 } ) |-> ( ( log ` x ) / ( log ` b ) ) ) ) $.
  $}

  $( Define the value of the ` log_ ` function, the logarithm generalized to an
     arbitrary base. (Contributed by David A. Wheeler, 14-Jul-2017.)
  log_val $p |- (
        ( B e. ( CC \ { 0 , 1 } ) /\ X e. ( CC \ { 0 } ) )
       ->
       ( ( log_ ` B ) ` X ) = ( ( log ` X ) / ( log ` B ) )
       )
    $= ? $.
 $)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Miscellaneous
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  Miscellaneous proofs.

$)

  $( Prove that 5 - 4 = 1.  (Contributed by David A. Wheeler, 31-Jan-2017.) $)
  5m4e1 $p |- ( 5 - 4 ) = 1 $=
    ( c5 c4 c1 5nn0 nn0cni 4cn ax-1cn 4p1e5 subaddrii ) ABCADEFGHI $.

  $( Prove that ` 2 + 2 =/= 5 ` .  In George Orwell's "1984", Part One, Chapter
     Seven, the protagonist Winston notes that, "In the end the Party would
     announce that two and two made five, and you would have to believe it."
     ~ http://www.sparknotes.com/lit/1984/section4.rhtml .  More generally, the
     phrase ` 2 + 2 = 5 ` has come to represent an obviously false dogma one
     may be required to believe.  See the Wikipedia article for more about
     this: ~ https://en.wikipedia.org/wiki/2_%2B_2_%3D_5 .  Unsurprisingly, we
     can easily prove that this claim is false.  (Contributed by David A.
     Wheeler, 31-Jan-2017.) $)
  2p2ne5 $p |- ( 2 + 2 ) =/= 5 $=
    ( c2 caddc co c4 c5 2p2e4 4re 4lt5 ltneii eqnetri ) AABCDEFDEGHIJ $.

  $( Resolution rule.  This is the primary inference rule in some automated
     theorem provers such as prover9.  The resolution rule can be traced back
     to Davis and Putnam (1960).  (Contributed by David A. Wheeler,
     9-Feb-2017.) $)
  resolution $p |- ( ( ( ph /\ ps ) \/ ( -. ph /\ ch ) ) -> ( ps \/ ch ) )
    $=
    ( wa wn simpr orim12i ) ABDBAEZCDCABFHCFG $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                Examples
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  These should be moved into the "examples" section.  These exist
  to prove specific concrete examples of definitions; examples make
  definitions easier to understand, and proving them means that the
  examples are justifiably correct.

$)

$( (End of David A. Wheeler's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Alan Sare
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Supplementary "adant" deductions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    ad4ant13.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant13 $p |- ( ( ( ( ph /\ th ) /\ ps ) /\ ta ) -> ch ) $=
      ( ex a1i24 imp41 ) ADBECADBECABCFGHI $.
  $}

  ${
    ad4ant14.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant14 $p |- ( ( ( ( ph /\ th ) /\ ta ) /\ ps ) -> ch ) $=
      ( wi ex a1d imp41 ) ADEBCAEBCGZGDAKEABCFHIIJ $.
  $}

  ${
    ad4ant123.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant123 $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ ta ) -> th ) $=
      ( 3exp a1i4 imp41 ) ABCEDABCEDABCDFGHI $.
  $}

  ${
    ad4ant124.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant124 $p |- ( ( ( ( ph /\ ps ) /\ ta ) /\ ch ) -> th ) $=
      ( wi 3exp a1dd imp41 ) ABECDABCDGEABCDFHIJ $.
  $}

  ${
    ad4ant134.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant134 $p |- ( ( ( ( ph /\ ta ) /\ ps ) /\ ch ) -> th ) $=
      ( wi 3exp a1d imp41 ) AEBCDABCDGGEABCDFHIJ $.
  $}

  ${
    ad4ant23.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant23 $p |- ( ( ( ( th /\ ph ) /\ ps ) /\ ta ) -> ch ) $=
      ( ex a1i14 imp41 ) DABECDABECABCFGHI $.
  $}

  ${
    ad4ant24.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant24 $p |- ( ( ( ( th /\ ph ) /\ ta ) /\ ps ) -> ch ) $=
      ( wi ex a1i13 imp41 ) DAEBCDAEBCGABCFHIJ $.
  $}

  ${
    ad4ant234.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad4ant234 $p |- ( ( ( ( ta /\ ph ) /\ ps ) /\ ch ) -> th ) $=
      ( wi 3exp a1i imp41 ) EABCDABCDGGGEABCDFHIJ $.
  $}

  ${
    ad5ant12.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant12 $p |- ( ( ( ( ( ph /\ ps ) /\ th ) /\ ta ) /\ et ) -> ch ) $=
      ( wa ad3antrrr ) ABHCDEFGI $.
  $}

  ${
    ad5ant13.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant13 $p |- ( ( ( ( ( ph /\ th ) /\ ps ) /\ ta ) /\ et ) -> ch ) $=
      ( wa wi ex a1i34 a1i4 com45 com23 imp imp41 ) ADHBEFCADBEFCIIZIABDQABDFEC
      ABDFECIABDECABCGJKLMNOP $.
  $}

  ${
    ad5ant14.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant14 $p |- ( ( ( ( ( ph /\ th ) /\ ta ) /\ ps ) /\ et ) -> ch ) $=
      ( wa wi ex a1i34 a1i4 com45 com23 com34 imp imp41 ) ADHEBFCADEBFCIZIIADBE
      RABDERIABDFECABDFECIABDECABCGJKLMNOPQ $.
  $}

  ${
    ad5ant15.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant15 $p |- ( ( ( ( ( ph /\ th ) /\ ta ) /\ et ) /\ ps ) -> ch ) $=
      ( wa wi ex a1i34 a1i4 com45 com23 com34 imp imp41 ) ADHEFBCADEFBCIIIADEBF
      CADBEFCIZABDERIABDFECABDFECIABDECABCGJKLMNOMPQ $.
  $}

  ${
    ad5ant23.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant23 $p |- ( ( ( ( ( th /\ ph ) /\ ps ) /\ ta ) /\ et ) -> ch ) $=
      ( wa wi ex a1i34 a1i4 com45 com3r imp imp41 ) DAHBEFCDABEFCIIZIABDQABDFEC
      ABDFECIABDECABCGJKLMNOP $.
  $}

  ${
    ad5ant24.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant24 $p |- ( ( ( ( ( th /\ ph ) /\ ta ) /\ ps ) /\ et ) -> ch ) $=
      ( wa wi ex a1i34 a1i4 com45 com3r com34 imp imp41 ) DAHEBFCDAEBFCIZIIDABE
      RABDERIABDFECABDFECIABDECABCGJKLMNOPQ $.
  $}

  ${
    ad5ant25.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant25 $p |- ( ( ( ( ( th /\ ph ) /\ ta ) /\ et ) /\ ps ) -> ch ) $=
      ( wa wi ex a1i34 a1i4 com45 com3r com34 imp imp41 ) DAHEFBCDAEFBCIIIDAEBF
      CDABEFCIZABDERIABDFECABDFECIABDECABCGJKLMNOMPQ $.
  $}

  ${
    ad5ant245.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant245 $p |- ( ( ( ( ( ta /\ ph ) /\ et ) /\ ps ) /\ ch ) -> th ) $=
      ( wa wi 3exp a1i4 com5r com45 com34 imp imp41 ) EAHFBCDEAFBCDIZIIEABFQEAB
      CFDABCFEDABCFEDIABCEDABCDGJKKLMNOP $.
  $}

  ${
    ad5ant234.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant234 $p |- ( ( ( ( ( ta /\ ph ) /\ ps ) /\ ch ) /\ et ) -> th ) $=
      ( wa wi 3exp a1i4 com5r imp imp41 ) EAHBCFDEABCFDIIIABCFEDABCFEDIABCEDABC
      DGJKKLMN $.
  $}

  ${
    ad5ant235.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant235 $p |- ( ( ( ( ( ta /\ ph ) /\ ps ) /\ et ) /\ ch ) -> th ) $=
      ( wa wi 3exp a1i4 com5r com45 imp imp41 ) EAHBFCDEABFCDIIIEABCFDABCFEDABC
      FEDIABCEDABCDGJKKLMNO $.
  $}

  ${
    ad5ant123.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant123 $p |- ( ( ( ( ( ph /\ ps ) /\ ch ) /\ ta ) /\ et ) -> th ) $=
      ( wa wi 3exp a1i4 com45 imp imp41 ) ABHCEFDABCEFDIIIABCFEDABCFEDIABCEDABC
      DGJKKLMN $.
  $}

  ${
    ad5ant124.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant124 $p |- ( ( ( ( ( ph /\ ps ) /\ ta ) /\ ch ) /\ et ) -> th ) $=
      ( wa wi 3exp a1i4 com45 com34 imp imp41 ) ABHECFDABECFDIZIIABCEPABCFEDABC
      FEDIABCEDABCDGJKKLMNO $.
  $}

  ${
    ad5ant125.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant125 $p |- ( ( ( ( ( ph /\ ps ) /\ ta ) /\ et ) /\ ch ) -> th ) $=
      ( wa wi 3exp a1i4 com35 imp imp41 ) ABHEFCDABEFCDIIIABCFEDABCFEDIABCEDABC
      DGJKKLMN $.
  $}

  ${
    ad5ant134.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant134 $p |- ( ( ( ( ( ph /\ ta ) /\ ps ) /\ ch ) /\ et ) -> th ) $=
      ( wa wi 3exp a1i4 com45 com34 com23 imp imp41 ) AEHBCFDAEBCFDIZIZIABERABC
      EQABCFEDABCFEDIABCEDABCDGJKKLMNOP $.
  $}

  ${
    ad5ant135.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant135 $p |- ( ( ( ( ( ph /\ ta ) /\ ps ) /\ et ) /\ ch ) -> th ) $=
      ( wa wi 3exp a1i4 com45 com34 com23 imp imp41 ) AEHBFCDAEBFCDIIIAEBCFDABE
      CFDIZIABCEQABCFEDABCFEDIABCEDABCDGJKKLMNLOP $.
  $}

  ${
    ad5ant145.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant145 $p |- ( ( ( ( ( ph /\ ta ) /\ et ) /\ ps ) /\ ch ) -> th ) $=
      ( wa wi 3exp a1i4 com45 com34 com23 imp imp41 ) AEHFBCDAEFBCDIZIIAEBFQAEB
      CFDABECFDIZIABCERABCFEDABCFEDIABCEDABCDGJKKLMNLMOP $.
  $}

  ${
    ad5ant1345.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant1345 $p |- ( ( ( ( ( ph /\ et ) /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( wa wi exp41 adantr imp41 ) AFHBCDEABCDEIIIFABCDEGJKL $.
  $}

  ${
    ad5ant2345.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $.
    $( Deduction adding conjuncts to antecedent.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    ad5ant2345 $p |- ( ( ( ( ( et /\ ph ) /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( wa wi exp41 adantl imp41 ) FAHBCDEABCDEIIIFABCDEGJKL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Supplementary unification deductions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    biimp.1 $e |- ( ph <-> ( ps -> ch ) ) $.
    $( Importation inference similar to ~ imp , except the outermost
       implication of the hypothesis is a biconditional.  (Contributed by Alan
       Sare, 6-Nov-2017.) $)
    biimp $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wi biimpi imp ) ABCABCEDFG $.
  $}

  ${
    bi2imp.1 $e |- ( ph <-> ( ps <-> ch ) ) $.
    $( Importation inference similar to ~ imp , except the both implications of
       the hypothesis are biconditionals.  (Contributed by Alan Sare,
       6-Nov-2017.) $)
    bi2imp $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wb biimpi biimpa ) ABCABCEDFG $.
  $}

  ${
    bi3impb.1 $e |- ( ( ph /\ ( ps /\ ch ) ) <-> th ) $.
    $( Similar to ~ 3impb with implication in hypothesis replaced by
       biconditional.  (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi3impb $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa biimpi 3impb ) ABCDABCFFDEGH $.
  $}

  ${
    bi3impa.1 $e |- ( ( ( ph /\ ps ) /\ ch ) <-> th ) $.
    $( Similar to ~ 3impa with implication in hypothesis replaced by
       biconditional.  (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi3impa $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa biimpi 3impa ) ABCDABFCFDEGH $.
  $}

  ${
    bi23impib.1 $e |- ( ph -> ( ( ps /\ ch ) <-> th ) ) $.
    $( ~ 3impib with the inner implication of the hypothesis a biconditional.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi23impib $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa biimpd 3impib ) ABCDABCFDEGH $.
  $}

  ${
    bi13impib.1 $e |- ( ph <-> ( ( ps /\ ch ) -> th ) ) $.
    $( ~ 3impib with the outer implication of the hypothesis a biconditional.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi13impib $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa wi biimpi 3impib ) ABCDABCFDGEHI $.
  $}

  ${
    bi123impib.1 $e |- ( ph <-> ( ( ps /\ ch ) <-> th ) ) $.
    $( ~ 3impib with the implications of the hypothesis biconditionals.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi123impib $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa wb biimpi bi23impib ) ABCDABCFDGEHI $.
  $}

  ${
    bi13impia.1 $e |- ( ( ph /\ ps ) <-> ( ch -> th ) ) $.
    $( ~ 3impia with the outer implication of the hypothesis a biconditional.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi13impia $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa wi biimpi 3impia ) ABCDABFCDGEHI $.
  $}

  ${
    bi123impia.1 $e |- ( ( ph /\ ps ) <-> ( ch <-> th ) ) $.
    $( ~ 3impia with the implications of the hypothesis biconditionals.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi123impia $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa wb biimpi biimp3a ) ABCDABFCDGEHI $.
  $}

  ${
    bi33imp12.1 $e |- ( ph -> ( ps -> ( ch <-> th ) ) ) $.
    $( ~ 3imp with innermost implication of the hypothesis a biconditional.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi33imp12 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wb wi bi1 syl6 3imp ) ABCDABCDFCDGECDHIJ $.
  $}

  ${
    bi23imp13.1 $e |- ( ph -> ( ps <-> ( ch -> th ) ) ) $.
    $( ~ 3imp with middle implication of the hypothesis a biconditional.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi23imp13 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wi biimpd 3imp ) ABCDABCDFEGH $.
  $}

  ${
    bi13imp23.1 $e |- ( ph <-> ( ps -> ( ch -> th ) ) ) $.
    $( ~ 3imp with outermost implication of the hypothesis a biconditional.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi13imp23 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wi biimpi 3imp ) ABCDABCDFFEGH $.
  $}

  ${
    bi13imp2.1 $e |- ( ph <-> ( ps -> ( ch <-> th ) ) ) $.
    $( Similar to ~ 3imp except the outermost and innermost implications are
       biconditionals.  (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi13imp2 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wb wi biimpi bi33imp12 ) ABCDABCDFGEHI $.
  $}

  ${
    bi12imp3.1 $e |- ( ph <-> ( ps <-> ( ch -> th ) ) ) $.
    $( Similar to ~ 3imp except all but innermost implication are
       biconditionals.  (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi12imp3 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wi wb biimpi bi23imp13 ) ABCDABCDFGEHI $.
  $}

  ${
    bi23imp1.1 $e |- ( ph -> ( ps <-> ( ch <-> th ) ) ) $.
    $( Similar to ~ 3imp except all but outermost implication are
       biconditionals.  (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi23imp1 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wb wi bi1 syl6bi 3imp ) ABCDABCDFCDGECDHIJ $.
  $}

  ${
    bi23imp0.1 $e |- ( ph <-> ( ps <-> ( ch <-> th ) ) ) $.
    $( Similar to ~ 3imp except all implications are biconditionals.
       (Contributed by Alan Sare, 6-Nov-2017.) $)
    bi123imp0 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wb wi bi1 syl6 sylbi 3imp ) ABCDABCDFZFZBCDGZGEMBLNBLHCDHIJK $.
  $}

  ${
    4animp1.1 $e |- ( ( ph /\ ps /\ ch ) -> ( ta <-> th ) ) $.
    $( A single hypothesis unification deduction with an assertion which is an
       implication with a 4-right-nested conjunction antecedent.  (Contributed
       by Alan Sare, 30-May-2018.) $)
    4animp1 $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( wa id simprd w3a wb simplll syl simpllr simplr 3jca mpbird ) ABGZCGZDGZ
      EDTSDTHZITABCJEDKTABCTTAUAABCDLMTTBUAABCDNMTTCUARCDOMPFMQ $.
      $( [30-May-2018] $)
  $}

  ${
    4an31.1 $e |- ( ( ( ( ch /\ ps ) /\ ph ) /\ th ) -> ta ) $.
    $( A rearrangement of conjuncts for a 4-right-nested conjunction.
       (Contributed by Alan Sare, 30-May-2018.) $)
    4an31 $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( wa id an31 anbi1i sylib syl ) ABGCGZDGZCBGAGZDGZENNPNHMODABCIJKFL $.
      $( [28-May-2018] $)
  $}

  ${
    4an4132.1 $e |- ( ( ( ( th /\ ch ) /\ ps ) /\ ph ) -> ta ) $.
    $( A rearrangement of conjuncts for a 4-right-nested conjunction.
       (Contributed by Alan Sare, 30-May-2018.) $)
    4an4132 $p |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $=
      ( wa wi id simprd simplr syl jca simpllr simplll imim1i ax-mp ) DCGZBGZAG
      ZEHABGZCGZDGZEHFUCTEUCSAUCRBUCDCUCUBDUCIZJUCUCCUDUACDKLMUCUCBUDABCDNLMUCU
      CAUDABCDOLMPQ $.
      $( [30-May-2018] $)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Conventional Metamath proofs, some derived from VD proofs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( ~ idn3 without virtual deduction connectives.  Special theorem needed for
     Alan Sare's virtual deduction translation tool.  (Contributed by Alan
     Sare, 23-Jul-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  iidn3 $p |- ( ph -> ( ps -> ( ch -> ch ) ) ) $=
    ( wi id a1ii ) ABCCDCEF $.

  ${
    ee222.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee222.2 $e |- ( ph -> ( ps -> th ) ) $.
    ee222.3 $e |- ( ph -> ( ps -> ta ) ) $.
    ee222.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e222 without virtual deduction connectives.  Special theorem needed
       for Alan Sare's virtual deduction translation tool.  (Contributed by
       Alan Sare, 7-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee222 $p |- ( ph -> ( ps -> et ) ) $=
      ( wa imp syl3c ex ) ABFABKCDEFABCGLABDHLABEILJMN $.
  $}

  ${
    ee3bir.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee3bir.2 $e |- ( ta <-> th ) $.
    $( Right-biconditional form of ~ e3 without virtual deduction connectives.
       Special theorem needed for Alan Sare's virtual deduction translation
       tool.  (Contributed by Alan Sare, 22-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee3bir $p |- ( ph -> ( ps -> ( ch -> ta ) ) ) $=
      ( biimpri syl8 ) ABCDEFEDGHI $.
  $}

  ${
    ee13.1 $e |- ( ph -> ps ) $.
    ee13.2 $e |- ( ph -> ( ch -> ( th -> ta ) ) ) $.
    ee13.3 $e |- ( ps -> ( ta -> et ) ) $.
    $( ~ e13 without virtual deduction connectives.  Special theorem needed for
       Alan Sare's virtual deduction translation tool.  (Contributed by Alan
       Sare, 28-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee13 $p |- ( ph -> ( ch -> ( th -> et ) ) ) $=
      ( wi syl syl6d ) ACDEFHABEFJGIKL $.
  $}

  ${
    ee121.1 $e |- ( ph -> ps ) $.
    ee121.2 $e |- ( ph -> ( ch -> th ) ) $.
    ee121.3 $e |- ( ph -> ta ) $.
    ee121.4 $e |- ( ps -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e121 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee121 $p |- ( ph -> ( ch -> et ) ) $=
      ( a1d ee222 ) ACBDEFABCGKHAECIKJL $.
  $}

  ${
    ee122.1 $e |- ( ph -> ps ) $.
    ee122.2 $e |- ( ph -> ( ch -> th ) ) $.
    ee122.3 $e |- ( ph -> ( ch -> ta ) ) $.
    ee122.4 $e |- ( ps -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e122 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee122 $p |- ( ph -> ( ch -> et ) ) $=
      ( a1d ee222 ) ACBDEFABCGKHIJL $.
  $}

  ${
    ee333.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee333.2 $e |- ( ph -> ( ps -> ( ch -> ta ) ) ) $.
    ee333.3 $e |- ( ph -> ( ps -> ( ch -> et ) ) ) $.
    ee333.4 $e |- ( th -> ( ta -> ( et -> ze ) ) ) $.
    $( ~ e333 without virtual deductions.  (Contributed by Alan Sare,
       17-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee333 $p |- ( ph -> ( ps -> ( ch -> ze ) ) ) $=
      ( w3a 3imp syl3c 3exp ) ABCGABCLDEFGABCDHMABCEIMABCFJMKNO $.
  $}

  ${
    ee323.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee323.2 $e |- ( ph -> ( ps -> ta ) ) $.
    ee323.3 $e |- ( ph -> ( ps -> ( ch -> et ) ) ) $.
    ee323.4 $e |- ( th -> ( ta -> ( et -> ze ) ) ) $.
    $( ~ e323 without virtual deductions.  (Contributed by Alan Sare,
       17-Apr-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee323 $p |- ( ph -> ( ps -> ( ch -> ze ) ) ) $=
      ( a1dd ee333 ) ABCDEFGHABECILJKM $.
  $}

  $( If the second and third disjuncts of a true triple disjunction are false,
     then the first disjunct is true.  Automatically derived from
     ~ 3ornot23VD .  (Contributed by Alan Sare, 31-Dec-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  3ornot23 $p |- ( ( -. ph /\ -. ps ) -> ( ( ch \/ ph \/ ps ) -> ch ) ) $=
    ( wn w3o wi idd pm2.21 3jaao 3anidm12 ) ADZBDZCABECFKCCKALBKCGACHBCHIJ $.

  $( ~ orbi1 with order of disjuncts reversed.  Derived from ~ orbi1rVD .
     (Contributed by Alan Sare, 31-Dec-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  orbi1r $p |- ( ( ph <-> ps ) -> ( ( ch \/ ph ) <-> ( ch \/ ps ) ) ) $=
    ( wb id orbi2d ) ABDZABCGEF $.

  $( Closed nested implication form of ~ bitr3i .  Derived automatically from
     ~ bitr3VD .  (Contributed by Alan Sare, 31-Dec-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  bitr3 $p |- ( ( ph <-> ps ) -> ( ( ph <-> ch ) -> ( ps <-> ch ) ) ) $=
    ( wb bibi1 biimpd ) ABDACDBCDABCEF $.

  $( ~ pm4.39 with a 3-conjunct antecedent.  This proof is ~ 3orbi123VD
     automatically translated and minimized.  (Contributed by Alan Sare,
     31-Dec-2011.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  3orbi123 $p |- ( ( ( ph <-> ps ) /\ ( ch <-> th ) /\ ( ta <-> et ) ) ->
                 ( ( ph \/ ch \/ ta ) <-> ( ps \/ th \/ et ) ) ) $=
    ( wb w3a simp1 simp2 simp3 3orbi123d ) ABGZCDGZEFGZHABCDEFMNOIMNOJMNOKL $.

  $( Closed form of ~ syl5 .  Derived automatically from ~ syl5impVD .
     (Contributed by Alan Sare, 31-Dec-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  syl5imp $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( th -> ps ) ->
                ( ph -> ( th -> ch ) ) ) ) $=
    ( wi pm2.04 imim2d com34 ) ABCEEZDBEDACIBACEDABCFGH $.

  $( The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  After the
     User's Proof was completed, it was minimized.  The completed User's Proof
     before minimization is not shown.  (Contributed by Alan Sare,
     18-Mar-2012.)  (Proof modification is discouraged.)
     (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::    <TD> ` |- ( ( ( ps /\ ch ) -> th ) <-> ( ps -> ( ch -> `
     ` th ) ) ) `
     <TR> <TD> qed:1: <TD> ` |- ( ( ph -> ( ( ps /\ ch ) -> th ) ) <-> ( ph `
     ` -> ( ps -> ( ch -> th ) ) ) ) `
     </TABLE> </HTML> $)
  impexp3a $p |- ( ( ph -> ( ( ps /\ ch ) -> th ) ) <->
                 ( ph -> ( ps -> ( ch -> th ) ) ) ) $=
    ( wa wi impexp imbi2i ) BCEDFBCDFFABCDGH $.

  $( The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant. The
     completed Virtual Deduction Proof (not shown) was minimized.  The
     minimized proof is shown.
     (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::      <TD> ` |- ( ( ph -> ( ps -> ( ch -> th ) ) ) `
     ` -> ( ph -> ( ch -> ( ps -> th ) ) ) ) `
     <TR> <TD> 2::      <TD> ` |- ( ( ph -> ( ch -> ( ps -> th ) ) ) `
     ` -> ( ch -> ( ph -> ( ps -> th ) ) ) ) `
     <TR> <TD> 3:1,2:   <TD> ` |- ( ( ph -> ( ps -> ( ch -> th ) ) ) `
     ` -> ( ch -> ( ph -> ( ps -> th ) ) ) ) `
     <TR> <TD> 4::      <TD> ` |- ( ( ch -> ( ph -> ( ps -> th ) ) ) `
     ` -> ( ph -> ( ch -> ( ps -> th ) ) ) ) `
     <TR> <TD> 5::      <TD> ` |- ( ( ph -> ( ch -> ( ps -> th ) ) ) `
     ` -> ( ph -> ( ps -> ( ch -> th ) ) ) ) `
     <TR> <TD> 6:4,5:   <TD> ` |- ( ( ch -> ( ph -> ( ps -> th ) ) ) `
     ` -> ( ph -> ( ps -> ( ch -> th ) ) ) ) `
     <TR> <TD> qed:3,6: <TD> ` |- ( ( ph -> ( ps -> ( ch -> th ) ) ) `
     ` <-> ( ch -> ( ph -> ( ps -> th ) ) ) ) `
     </TABLE> </HTML>  $)
  com3rgbi $p |- ( ( ph -> ( ps -> ( ch -> th ) ) ) <->
                 ( ch -> ( ph -> ( ps -> th ) ) ) ) $=
    ( wi pm2.04 com24 com34 impbii ) ABCDEZEEZCABDEZEEZKBACDABJFGMACBDCALFHI $.

  $( The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant. The
     completed Virtual Deduction Proof (not shown) was minimized.  The
     minimized proof is shown. (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::      <TD> ` |- ( ( ph -> ( ( ps /\ ch ) -> th ) ) `
     ` <-> ( ph -> ( ps -> ( ch -> th ) ) ) ) `
     <TR> <TD> 2::      <TD> ` |- ( ( ps -> ( ch -> ( ph -> th ) ) ) `
     ` <-> ( ph -> ( ps -> ( ch -> th ) ) ) ) `
     <TR> <TD> qed:1,2: <TD> ` |- ( ( ph -> ( ( ps /\ ch ) -> th ) ) `
     ` <-> ( ps -> ( ch -> ( ph -> th ) ) ) ) `
     </TABLE> </HTML> $)
  impexp3acom3r $p |- ( ( ph -> ( ( ps /\ ch ) -> th ) ) <->
                      ( ps -> ( ch -> ( ph -> th ) ) ) ) $=
    ( wa wi impexp3a com3rgbi bitr4i ) ABCEDFFABCDFFFBCADFFFABCDGBCADHI $.

  ${
    ee1111.1 $e |- ( ph -> ps ) $.
    ee1111.2 $e |- ( ph -> ch ) $.
    ee1111.3 $e |- ( ph -> th ) $.
    ee1111.4 $e |- ( ph -> ta ) $.
    ee1111.5 $e |- ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) $.
    $( Non-virtual deduction form of ~ e1111 . (Contributed by Alan Sare,
       18-Mar-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       The following User's Proof is a Virtual Deduction proof
       completed automatically by the tools program completeusersproof.cmd,
       which invokes Mel O'Cat's mmj2 and Norm Megill's Metamath Proof
       Assistant.  The completed Virtual Deduction Proof (not shown) was
       minimized.  The minimized proof is shown.
       <HTML> <TABLE>
       <TR> <TD> h1::     <TD> ` |- ( ph -> ps )  `
       <TR> <TD> h2::     <TD> ` |- ( ph -> ch ) `
       <TR> <TD> h3::     <TD> ` |- ( ph -> th ) `
       <TR> <TD> h4::     <TD> ` |- ( ph -> ta ) `
       <TR> <TD> h5::    <TD> ` |- ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) `
       <TR> <TD> 6:1,5:  <TD> ` |- ( ph -> ( ch -> ( th -> ( ta -> et ) ) ) ) `
       <TR> <TD> 7:6:    <TD> ` |- ( ch -> ( ph -> ( th -> ( ta -> et ) ) ) ) `
       <TR> <TD> 8:2,7:  <TD> ` |- ( ph -> ( ph -> ( th -> ( ta -> et ) ) ) ) `
       <TR> <TD> 9:8:     <TD> ` |- ( ph -> ( th -> ( ta -> et ) ) ) `
       <TR> <TD> 10:9:    <TD> ` |- ( th -> ( ph -> ( ta -> et ) ) ) `
       <TR> <TD> 11:3,10: <TD> ` |- ( ph -> ( ph -> ( ta -> et ) ) ) `
       <TR> <TD> 12:11:   <TD> ` |- ( ph -> ( ta -> et ) ) `
       <TR> <TD> 13:12:   <TD> ` |- ( ta -> ( ph -> et ) ) `
       <TR> <TD> 14:4,13: <TD> ` |- ( ph -> ( ph -> et ) ) `
       <TR> <TD> qed:14:  <TD> ` |- ( ph -> et )  `
       </TABLE> </HTML> $)
    ee1111 $p |- ( ph -> et ) $=
      ( wi syl3c mpd ) AEFJABCDEFLGHIKMN $.
  $}

  $( Logical equivalence of a 2-left-nested implication and a 1-left-nested
     implicated
     when two antecedents of the former implication are identical.
     (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant. The
     completed Virtual
     Deduction Proof (not shown) was minimized.  The minimized proof is
     shown.
     <HTML> <TABLE>
     <TR> <TD> 1::      <TD> ` |- ( ( ph -> ( ps -> ( ph -> ch ) ) ) `
     ` -> ( ph -> ( ph -> ( ps -> ch ) ) ) ) `
     <TR> <TD> 2::      <TD> ` |- ( ( ph -> ( ph -> ( ps -> ch ) ) ) `
     ` -> ( ph -> ( ps -> ch ) ) ) `
     <TR> <TD> 3:1,2:   <TD> ` |- ( ( ph -> ( ps -> ( ph -> ch ) ) ) `
     ` -> ( ph -> ( ps -> ch ) ) ) `
     <TR> <TD> 4::      <TD> ` |- ( ( ph -> ( ps -> ch ) ) -> ( ps `
     ` -> ( ph -> ch ) ) ) `
     <TR> <TD> 5:3,4:   <TD> ` |- ( ( ph -> ( ps -> ( ph -> ch ) ) ) `
     ` -> ( ps -> ( ph -> ch ) ) ) `
     <TR> <TD> 6::      <TD> ` |- ( ( ps -> ( ph -> ch ) ) -> ( ph `
     ` -> ( ps -> ( ph -> ch ) ) ) ) `
     <TR> <TD> qed:5,6: <TD> ` |- ( ( ph -> ( ps -> ( ph -> ch ) ) ) `
     ` <-> ( ps -> ( ph -> ch ) ) ) `
     </TABLE> </HTML> $)
  pm2.43bgbi $p |- ( ( ph -> ( ps -> ( ph -> ch ) ) ) <->
               ( ps -> ( ph -> ch ) ) ) $=
    ( wi mercolem6 ax-1 impbii ) ABACDDZDHABCEHAFG $.

  $( Logical equivalence of a 3-left-nested implication and a 2-left-nested
     implicated when two antecedents of the former implication are identical.
     (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     The following User's Proof is
     a Virtual Deduction proof completed automatically by the tools program
     completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm Megill's
     Metamath Proof Assistant.  The completed Virtual Deduction Proof (not
     shown) was minimized.  The minimized proof is shown.
     <HTML> <TABLE>
     <TR> <TD> 1::      <TD> ` |- ( ( ph -> ( ps -> ( ch -> ( ph -> th ) ) ) `
     ` ) -> ( ph -> ( ps -> ( ph -> ( ch -> th ) ) ) ) ) `
     <TR> <TD> 2::      <TD> ` |- ( ( ph -> ( ps -> ( ph -> ( ch -> th ) ) ) `
     ` ) -> ( ps -> ( ph -> ( ch -> th ) ) ) ) `
     <TR> <TD> 3:1,2:   <TD> ` |- ( ( ph -> ( ps -> ( ch -> ( ph -> th ) ) ) `
     ` ) -> ( ps -> ( ph -> ( ch -> th ) ) ) ) `
     <TR> <TD> 4::      <TD> ` |- ( ( ps -> ( ph -> ( ch -> th ) ) )  `
     ` -> ( ps -> ( ch -> ( ph -> th ) ) ) ) `
     <TR> <TD> 5:3,4:   <TD> ` |- ( ( ph -> ( ps -> ( ch -> ( ph -> th ) ) ) `
     ` ) -> ( ps -> ( ch -> ( ph -> th ) ) ) )  `
     <TR> <TD> 6::      <TD> ` |- ( ( ps -> ( ch -> ( ph -> th ) ) )  `
     ` -> ( ph -> ( ps -> ( ch -> ( ph -> th ) ) ) ) ) `
     <TR> <TD> qed:5,6: <TD> ` |- ( ( ph -> ( ps -> ( ch -> ( ph -> th ) ) ) `
     ` ) <-> ( ps -> ( ch -> ( ph -> th ) ) ) ) `
     </TABLE> </HTML> $)
  pm2.43cbi $p |- ( ( ph -> ( ps -> ( ch -> ( ph -> th ) ) ) ) <->
                   ( ps -> ( ch -> ( ph -> th ) ) ) ) $=
    ( wi wn pm2.24 com4l id ja ax-1 impbii ) ABCADEEEZEMAMMAAFBCDABCDEEGHMIJMAK
    L $.

  ${
    ee233.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee233.2 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    ee233.3 $e |- ( ph -> ( ps -> ( th -> et ) ) ) $.
    ee233.4 $e |- ( ch -> ( ta -> ( et -> ze ) ) ) $.
    $( Non-virtual deduction form of ~ e233 . (Contributed by Alan Sare,
       18-Mar-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant. The
       completed Virtual
       Deduction Proof (not shown) was minimized.  The minimized proof is
       shown.
       <HTML> <TABLE>
       <TR> <TD> h1::     <TD> ` |- ( ph -> ( ps -> ch ) )   `
       <TR> <TD> h2::     <TD> ` |- ( ph -> ( ps -> ( th -> ta ) ) )  `
       <TR> <TD> h3::     <TD> ` |- ( ph -> ( ps -> ( th -> et ) ) )  `
       <TR> <TD> h4::     <TD> ` |- ( ch -> ( ta -> ( et -> ze ) ) ) `
       <TR> <TD> 5:1,4:   <TD> ` |- ( ph -> ( ps -> ( ta -> ( et -> ze ) ) ) `
       ` ) `
       <TR> <TD> 6:5:     <TD> ` |- ( ta -> ( ph -> ( ps -> ( et -> ze ) ) ) `
       ` ) `
       <TR> <TD> 7:2,6:   <TD> ` |- ( ph -> ( ps -> ( th -> ( ph -> ( ps  `
       ` -> ( et -> ze ) ) ) ) ) ) `
       <TR> <TD> 8:7:     <TD> ` |- ( ps -> ( th -> ( ph -> ( ps -> ( et  `
       ` -> ze ) ) ) ) ) `
       <TR> <TD> 9:8:     <TD> ` |- ( th -> ( ph -> ( ps -> ( et -> ze ) ) ) `
       ` ) `
       <TR> <TD> 10:9:    <TD> ` |- ( ph -> ( ps -> ( th -> ( et -> ze ) ) ) `
       ` ) `
       <TR> <TD> 11:10:   <TD> ` |- ( et -> ( ph -> ( ps -> ( th -> ze ) ) ) `
       ` ) `
       <TR> <TD> 12:3,11: <TD> ` |- ( ph -> ( ps -> ( th -> ( ph -> ( ps  `
       ` -> ( th -> ze ) ) ) ) ) ) `
       <TR> <TD> 13:12:   <TD> ` |- ( ps -> ( th -> ( ph -> ( ps -> ( th  `
       ` -> ze ) ) ) ) ) `
       <TR> <TD> 14:13:   <TD> ` |- ( th -> ( ph -> ( ps -> ( th -> ze ) ) ) `
       ` ) `
       <TR> <TD> qed:14:  <TD> ` |- ( ph -> ( ps -> ( th -> ze ) ) ) `
       </TABLE> </HTML> $)
    ee233 $p |- ( ph -> ( ps -> ( th -> ze ) ) ) $=
      ( wi syl6 com3r syl8 pm2.43cbi mpbi com14 ) DABDGLZLZLZLZUABUBLZUBAUCLUCA
      BDFUAJDABFGBDABFGLZLZLZLZLZUGAUHLUHABDEUFIABEUDABCEUDLHKMNOABDUEPQBDAUDPQ
      ROABDTPQBDASPQDABGPQ $.
  $}

  $( Implication form of ~ imbi12i . ~ imbi12 is ~ imbi12VD without virtual
     deductions and was automatically derived from ~ imbi12VD using the tools
     program translate..without..overwriting.cmd and Metamath's minimize
     command.  (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  imbi12 $p |- ( ( ph <-> ps ) -> ( ( ch <-> th ) -> ( ( ph -> ch )
               <-> ( ps -> th ) ) ) ) $=
    ( wb wi wn simplim simprim imbi12d expi ) ABEZCDEZACFBDFELMGZFGABCDLNHLMIJK
    $.

  $( Join three logical equivalences to form equivalence of implications.
     ~ imbi13 is ~ imbi13VD without virtual deductions and was automatically
     derived from ~ imbi13VD using the tools program
     translate..without..overwriting.cmd and Metamath's minimize command.
     (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  imbi13 $p |- ( ( ph <-> ps ) -> ( ( ch <-> th ) -> ( ( ta <-> et ) ->
               ( ( ph -> ( ch -> ta ) ) <-> ( ps -> ( th -> et ) ) ) ) ) ) $=
    ( wb wi imbi12 syl9r ) CDGEFGCEHZDFHZGABGAKHBLHGCDEFIABKLIJ $.

  ${
    ee33.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee33.2 $e |- ( ph -> ( ps -> ( ch -> ta ) ) ) $.
    ee33.3 $e |- ( th -> ( ta -> et ) ) $.
    $( Non-virtual deduction form of ~ e33 . (Contributed by Alan Sare,
       18-Mar-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.)
       The following User's Proof is a Virtual Deduction proof
       completed automatically by the tools program completeusersproof.cmd,
       which invokes Mel O'Cat's mmj2 and Norm Megill's Metamath Proof
       Assistant.  The completed Virtual Deduction Proof (not shown) was
       minimized.  The minimized proof is shown.
       <HTML> <TABLE>
       <TR> <TD> h1::   <TD> ` |- ( ph -> ( ps -> ( ch -> th ) ) )  `
       <TR> <TD> h2::   <TD> ` |- ( ph -> ( ps -> ( ch -> ta ) ) )  `
       <TR> <TD> h3::   <TD> ` |- ( th -> ( ta -> et ) ) `
       <TR> <TD> 4:1,3: <TD> ` |- ( ph -> ( ps -> ( ch -> ( ta -> et ) ) ) ) `
       <TR> <TD> 5:4:   <TD> ` |- ( ta -> ( ph -> ( ps -> ( ch -> et ) ) ) ) `
       <TR> <TD> 6:2,5: <TD> ` |- ( ph -> ( ps -> ( ch -> ( ph -> ( ps -> `
       ` ( ch -> et ) ) ) ) ) ) `
       <TR> <TD> 7:6:   <TD> ` |- ( ps -> ( ch -> ( ph -> ( ps -> ( ch -> `
       ` et ) ) ) ) ) `
       <TR> <TD> 8:7:   <TD> ` |- ( ch -> ( ph -> ( ps -> ( ch -> et ) ) ) ) `
       <TR> <TD> qed:8: <TD> ` |- ( ph -> ( ps -> ( ch -> et ) ) ) `
       </TABLE> </HTML> $)
    ee33 $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( wi imim3i ee22 ) ABCDJCEJCFJGHDEFCIKL $.
  $}

  $( Bi-conditional contraposition variation.  This proof is ~ con5VD
     automatically translated and minimized.  (Contributed by Alan Sare,
     21-Apr-2013.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  con5 $p |- ( ( ph <-> -. ps ) -> ( -. ph -> ps ) ) $=
    ( wn wb bi2 con1d ) ABCZDBAAGEF $.

  ${
    con5i.1 $e |- ( ph <-> -. ps ) $.
    $( Inference form of ~ con5 .  (Contributed by Alan Sare, 21-Apr-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    con5i $p |- ( -. ph -> ps ) $=
      ( wn wb wi con5 ax-mp ) ABDEADBFCABGH $.
  $}

  ${
    exlimexi.1 $e |- ( ps -> A. x ps ) $.
    exlimexi.2 $e |- ( E. x ph -> ( ph -> ps ) ) $.
    $( Inference similar to Theorem 19.23 of [Margaris] p. 90.  (Contributed by
       Alan Sare, 21-Apr-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    exlimexi $p |- ( E. x ph -> ps ) $=
      ( wex hbe1 exlimdh pm2.43i ) ACFZBJABCACGDEHI $.
  $}

  ${
    $d x y $.
    $( Equivalence for substitution.  Alternate proof of ~ sb5 .  This proof is
       ~ sb5ALTVD automatically translated and minimized.  (Contributed by Alan
       Sare, 21-Apr-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sb5ALT $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      ( wsb weq wa wex equsb1 sban simplbi2com mpi spsbe syl wi simpr a1i simpl
      hbs1 sbequ1 com12 ee22 exlimexi impbii ) ABCDZBCEZAFZBGZUDUFBCDZUGUDUEBCD
      ZUHBCHUHUIUDUEABCIJKUFBCLMUFUDBABCRUGUFAUEUDUFANUGUEAOPUFUENUGUEAQPUEAUDA
      BCSTUAUBUC $.
  $}

  ${
    eexinst01.1 $e |- E. x ps $.
    eexinst01.2 $e |- ( ph -> ( ps -> ch ) ) $.
    eexinst01.3 $e |- ( ph -> A. x ph ) $.
    eexinst01.4 $e |- ( ch -> A. x ch ) $.
    $( ~ exinst01 without virtual deductions.  (Contributed by Alan Sare,
       21-Apr-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eexinst01 $p |- ( ph -> ch ) $=
      ( wex exlimdh mpi ) ABDICEABCDGHFJK $.
  $}

  ${
    eexinst11.1 $e |- ( ph -> E. x ps ) $.
    eexinst11.2 $e |- ( ph -> ( ps -> ch ) ) $.
    eexinst11.3 $e |- ( ph -> A. x ph ) $.
    eexinst11.4 $e |- ( ch -> A. x ch ) $.
    $( ~ exinst11 without virtual deductions.  (Contributed by Alan Sare,
       21-Apr-2013.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eexinst11 $p |- ( ph -> ch ) $=
      ( wex exlimdh syl5com pm2.43i ) ACABDIACEABCDGHFJKL $.
  $}

  ${
    vk15.4j.1 $e |- -. ( E. x -. ph /\ E. x ( ps /\ -. ch ) ) $.
    vk15.4j.2 $e |- ( A. x ch -> -. E. x ( th /\ ta ) ) $.
    vk15.4j.3 $e |- -. A. x ( ta -> ph ) $.
    $( Excercise 4j of Unit 15 of "Understanding Symbolic Logic", Fifth Edition
       (2008), by Virginia Klenk.  This proof is the minimized Hilbert-style
       axiomatic version of the Fitch-style Natural Deduction proof found on
       page 442 of Klenk and was automatically derived from that proof.
       ~ vk15.4j is ~ vk15.4jVD automatically translated and minimized.
       (Contributed by Alan Sare, 21-Apr-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    vk15.4j $p |- ( -. E. x -. th -> -. A. x ps ) $=
      ( wn wex wal wa wi exanali 19.21bi a1i 19.8a syl6 hbe1 mpbir alex biimpri
      simpl ee12an notnot1 con3 ee02 hbn eexinst01 exnal sylibr wo pm3.13 ax-mp
      hbn1 simpr syl pm2.53 mpsyl con5i con3d eexinst11 sylib ) DJZFKZJZBJZFKZB
      FLJVGCJZVIFVGCFLZJZVJFKVGEAJZMZVLFVNFKEANFLJIEAFOUAZVKDEMZFKZJZNVGVNVRJZV
      LHVGVNVQVSVGDVNEVQVGDFDFLVGDFUBUCPVNENVGEVMUDQVPFRUEVQUFSVKVRUGUHVFFVEFTU
      IZCFUPUJCFUKULVGVJVHVIVGBCVGBCNZFVGBVJMFKZJZWAFLZVMFKZJZWCUMZVGWFJZWCWEWB
      MJWGGWEWBUNUOVGWEWHVGVNWEFVOVGVNVMWEVNVMNVGEVMUQQVMFRSVTVMFTUJWEUFURWFWCU
      SUTWBWDBCFOVAURPVBVHFRSVTVHFTVCBFUKVD $.
  $}

  $( Converse of double negation.  Alternate proof of ~ notnot2 .  This proof
     is ~ notnot2ALTVD automatically translated and minimized.  (Contributed by
     Alan Sare, 21-Apr-2013.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  notnot2ALT $p |- ( -. -. ph -> ph ) $=
    ( wn id pm2.21 mt4d ) ABZBZGAGCFGBDE $.

  $( Contraposition.  Alternate proof of ~ con3 .  This proof is ~ con3ALTVD
     automatically translated and minimized.  (Contributed by Alan Sare,
     21-Apr-2013.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  con3ALT $p |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) $=
    ( wi wn notnot2 imim1i con1d ) ABCADZBHDABAEFG $.

  ${
    $d A x $.  $d B x $.  $d C x $.  $d C y $.  $d D x $.  $d D y $.
    $( Quantification restricted to a subclass for two quantifiers. ~ ssralv
       for two quantifiers.  The proof of ~ ssralv2 was automatically generated
       by minimizing the automatically translated proof of ~ ssralv2VD .  The
       automatic translation is by the tools program
       translate_without_overwriting.cmd (Contributed by Alan Sare,
       18-Feb-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ssralv2 $p |- ( ( A C_ B /\ C C_ D ) -> ( A. x e. B A. y e. D ph ->
                    A. x e. A A. y e. C ph ) ) $=
      ( wss wa wral nfv nfra1 cv wcel wi wal ssralv adantr df-ral syl6ib adantl
      sp syl6 syl6d ralrimd ) DEHZFGHZIZACGJZBEJZACFJZBDUHBKUIBELUHUJBMDNZUIUKU
      HUJULUIOZBPZUMUHUJUIBDJZUNUFUJUOOUGUIBDEQRUIBDSTUMBUBUCUGUIUKOUFACFGQUAUD
      UE $.
  $}

  $( ~ sbcor with a 3-disjuncts.  This proof is ~ sbc3orgVD automatically
     translated and minimized.  (Contributed by Alan Sare, 31-Dec-2011.)
     (Revised by NM, 24-Aug-2018.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  sbc3or $p |- ( [. A / x ]. ( ph \/ ps \/ ch ) <->
                ( [. A / x ]. ph \/ [. A / x ]. ps \/ [. A / x ]. ch ) ) $=
    ( w3o wsbc wo sbcor df-3or bicomi sbcbii orbi1i 3bitr3i bitr4i ) ABCFZDEGZA
    DEGZBDEGZHZCDEGZHZRSUAFABHZCHZDEGUCDEGZUAHQUBUCCDEIUDPDEPUDABCJKLUETUAABDEI
    MNRSUAJO $.

  $( ~ sbcorgOLD with a 3-disjuncts.  This proof is ~ sbc3orgVD automatically
     translated and minimized.  (Contributed by Alan Sare, 31-Dec-2011.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  sbc3orgOLD $p |- ( A e. V -> ( [. A / x ]. ( ph \/ ps \/ ch ) <->
                ( [. A / x ]. ph \/ [. A / x ]. ps \/ [. A / x ]. ch ) ) ) $=
    ( wcel w3o wsbc wo sbcorgOLD df-3or bicomi sbcbiiOLD orbi1d 3bitr3d syl6bbr
    ) EFGZABCHZDEIZADEIZBDEIZJZCDEIZJZUAUBUDHRABJZCJZDEIUFDEIZUDJTUEUFCDEFKUGSD
    EFSUGABCLMNRUHUCUDABDEFKOPUAUBUDLQ $.

  ${
    $d x ps $.  $d x ch $.
    $( Closed form of ~ alrimi with 2 additional conjuncts having no occurences
       of the quantifying variable.  This proof is ~ 19.21a3con13vVD
       automatically translated and minimized.  (Contributed by Alan Sare,
       31-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    alrim3con13v $p |- ( ( ph -> A. x ph ) ->
                        ( ( ps /\ ph /\ ch ) -> A. x ( ps /\ ph /\ ch ) ) ) $=
      ( wal w3a simp1 a1i ax-17 syl6 simp2 imim1i simp3 3jcad 19.26-3an syl6ibr
      wi ) AADEZQZBACFZBDEZRCDEZFTDESTUARUBSTBUATBQSBACGHBDIJTARBACKLSTCUBTCQSB
      ACMHCDIJNBACDOP $.
  $}

  ${
    $d A y $.  $d B x $.  $d D x y $.
    $( ~ rspsbc with two quantifying variables.  This proof is ~ rspsbc2VD
       automatically translated and minimized.  (Contributed by Alan Sare,
       31-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    rspsbc2 $p |- ( A e. B -> ( C e. D -> ( A. x e. B A. y e. D ph ->
                  [. C / y ]. [. A / x ]. ph ) ) ) $=
      ( wcel wral wsbc idd wi rspsbc a1d sbcralg biimpd syl6d ee23 ) DEHZFGHZTA
      CGIZBEIZABDJZCGIZUCCFJSTKSTUBUABDJZUDSUBUELTUABDEMNSUEUDABCDGEOPQUCCFGMR
      $.
  $}

  ${
    $d A y $.  $d x y $.
    $( Substitution of a set variable for another set variable in a 3-conjunct
       formula.  Derived automatically from ~ sbcoreleleqVD .  (Contributed by
       Alan Sare, 31-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sbcoreleleq $p |- ( A e. V ->
          ( [. A / y ]. ( x e. y \/ y e. x \/ x = y )
                <-> ( x e. A \/ A e. x \/ x = A ) ) ) $=
      ( wcel cv wceq w3o wel wsbc weq wb sbcel2gv sbcel1v eqsbc3r 3impexpbicomi
      a1i 3orbi123 syl3c sbc3or syl6rbbr ) CDEZAFZCEZCUCEZUCCGZHZABIZBCJZBAIZBC
      JZABKZBCJZHZUHUJULHBCJUBUIUDLZUKUELZUMUFLZUGUNLBUCCDMUPUBBCUCNQBCUCDOUOUP
      UQUNUGUIUDUKUEUMUFRPSUHUJULBCTUA $.

  $}

  ${
    $d A x y $.  $d B x y $.
    $( If a class is transitive and any two distinct elements of the class are
       E-comparable, then every element of that class is transitive.  Derived
       automatically from ~ tratrbVD .  (Contributed by Alan Sare,
       31-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    tratrb $p |- ( ( Tr A /\ A. x e. A A. y e. A ( x e. y \/ y e. x \/ x = y )
                 /\ B e. A ) -> Tr B ) $=
      ( wtr wel weq w3o wral wcel w3a cv wa wi wal nfv nf3an wn a1i con3 biimpd
      nfra1 nfra2 wceq simpl simpr pm3.2an3 ee22 en3lp syl6mpi eleq2 syl6 pm3.2
      biimprcd ee23 en2lp wsbc simp3 simp1 exp3a ee121 ralcom2 3ad2ant2 rspsbc2
      trel ee122 wb equid sbceq1a ax-mp syl6ibr sbcoreleleq sylsyld 3ornot23 ex
      ee222 alrimi dftr2 sylibr ) CEZABFZBAFZABGHZBCIZACIZDCJZKZWABLZDJZMZALZDJ
      ZNZBOZAODEWGWNAVTWEWFAVTAPWDACUBWFAPQWGWMBVTWEWFBVTBPWCABCCUCWFBPQWGWJDWK
      JZRZWKDUDZRZWLWOWQHZWLWGWJWOWAWIWOKZNZWTRWPWGWJWAWIXAWJWANWGWAWIUESZWJWIN
      WGWAWIUFSZWAWIWOUGUHWKWHDUIWOWTTUJWGWJWQWAWBMZNXDRWRWGWJWAWQWBXDXBWGWJWIW
      QWBNXCWQWBWIWKDWHUKUNULWAWBUMUOWKWHUPWQXDTUJWGWFWJWCBDUQZWSVTWEWFURZWGWJX
      EAWKUQZXEWGWFWJWKCJZWCACIBCIZXGXFWGVTWJWAWHCJZXHVTWEWFUSZXBWGVTWJWIWFXJXK
      XCXFVTWIWFXJCWHDVEUTVAVTWAXJXHCWKWHVEUTVFWEVTXIWFWCABCVBVCWCBADCWKCVDVAAA
      GXEXGVGAVHXEAWKVIVJVKWFXEWSABDCVLUAVMWPWRWSWLNWOWQWLVNVOVPVQVQABDVRVS $.
  $}

  ${
    $( ~ ax-5 for a 3 element left-nested implication.  Derived automatically
       from ~ 3ax5VD .  (Contributed by Alan Sare, 31-Dec-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    3ax5 $p |- ( A. x ( ph -> ( ps -> ch ) ) -> ( A. x ph ->
               ( A. x ps -> A. x ch ) ) ) $=
      ( wi wal ax-5 syl6 ) ABCEZEDFADFIDFBDFCDFEAIDGBCDGH $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( An element of an ordinal class is ordinal.  Proposition 7.6 of
       [TakeutiZaring] p. 36.  This is an alternate proof of ~ ordelord using
       the Axiom of Regularity indirectly through ~ dford2 . dford2 is a weaker
       definition of ordinal number.  Given the Axiom of Regularity, it need
       not be assumed that ` _E Fr A ` because this is inferred by the Axiom of
       Regularity. ~ ordelordALT is ~ ordelordALTVD without virtual deductions
       and was automatically derived from ~ ordelordALTVD using the tools
       program translate..without..overwriting.cmd and Metamath's minimize
       command.  (Contributed by Alan Sare, 18-Feb-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ordelordALT $p |- ( ( Ord A /\ B e. A ) -> Ord B ) $=
      ( vx vy word wcel wa wtr wel weq wral ordtr adantr dford2 simprbi 3orcomb
      w3o 2ralbii sylib simpr tratrb syl3anc wss trss wi ssralv2 syl3c sylanbrc
      sylc ex ) AEZBAFZGZBHZCDIZCDJZDCIZQZDBKCBKZBEUMAHZUOUQUPQZDAKCAKZULUNUKUT
      ULALMZUMURDAKCAKZVBUKVDULUKUTVDCDANOMZURVACDAAUOUPUQPRSUKULTZCDABUAUBUMBA
      UCZVGVDUSUMUTULVGVCVFABUDUIZVHVEVGVGVDUSUEURCDBABAUFUJUGCDBNUH $.
  $}

  $( Distribution of class substitution over a left-nested implication.
     Similar to ~ sbcimg . ~ sbcim2g is ~ sbcim2gVD without virtual deductions
     and was automatically derived from ~ sbcim2gVD using the tools program
     translate..without..overwriting.cmd and Metamath's minimize command.
     (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  sbcim2g $p |- ( A e. V -> ( [. A / x ]. ( ph -> ( ps -> ch ) ) <->
         ( [. A / x ]. ph -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ) ) $=
    ( wcel wi wsbc sbcimg biimpd imbi2 biimpcd ee21 idd bi2 ee13 sylibrd impbid
    wb ) EFGZABCHZHDEIZADEIZBDEICDEIHZHZUAUCUDUBDEIZHZUGUETZUFUAUCUHAUBDEFJZKBC
    DEFJZUIUHUFUGUEUDLMNUAUFUHUCUAUIUFUDUEUGUKUAUFOUGUEPQUJRS $.


  $( Implication form of ~ sbcbiiOLD . ~ sbcbi is ~ sbcbiVD without virtual
     deductions and was automatically derived from ~ sbcbiVD using the tools
     program translate..without..overwriting.cmd and Metamath's minimize
     command.  (Contributed by Alan Sare, 18-Mar-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  sbcbi $p |- ( A e. V -> ( A. x ( ph <-> ps ) -> ( [. A / x ]. ph <->
                  [. A / x ]. ps ) ) ) $=
    ( wcel wb wal wsbc spsbc sbcbig sylibd ) DEFABGZCHMCDIACDIBCDIGMCDEJABCDEKL
    $.


  ${
    $d A x y z $.  $d V y z $.
    $( Formula-building inference rule for class substitution, substituting a
       class variable for the set variable of the transitivity predicate.
       ~ trsbc is ~ trsbcVD without virtual deductions and was automatically
       derived from ~ trsbcVD using the tools program
       translate..without..overwriting.cmd and Metamath's minimize command.
       (Contributed by Alan Sare, 18-Mar-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    trsbc $p |- ( A e. V -> ( [. A / x ]. Tr x <-> Tr A ) ) $=
      ( vz vy wcel wel wa wi wal wsbc cv wtr sbcal sbcel2gv pm3.31 pm3.3 impbii
      wb sbcbii sbcim2g imbi13 syl3c bitrd 3bitr3g albidv syl5bb dftr2 3bitr4g
      sbcg ) BCFZDEGZEAGZHDAGZIZEJZDJZABKZULELZBFZHDLZBFZIZEJZDJZALZMZABKBMURUP
      ABKZDJUKVEUPDABNUKVHVDDVHUOABKZEJUKVDUOEABNUKVIVCEUKULUMUNIIZABKZULUTVBII
      ZVIVCUKVKULABKZUMABKZUNABKZIIZVLULUMUNABCUAUKVMULSVNUTSVOVBSVPVLSULABCUJA
      USBCOAVABCOVMULVNUTVOVBUBUCUDVJUOABVJUOULUMUNPULUMUNQRTVLVCULUTVBPULUTVBQ
      RUEUFUGUFUGVGUQABDEVFUHTDEBUHUI $.

  $}

  ${
    $d A q x y z $.
    $( The union of a class of transitive sets is transitive.  Alternate proof
       of ~ truni . ~ truniALT is ~ truniALTVD without virtual deductions and
       was automatically derived from ~ truniALTVD using the tools program
       translate..without..overwriting.cmd and Metamath's minimize command.
       (Contributed by Alan Sare, 18-Mar-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    truniALT $p |- ( A. x e. A Tr x -> Tr U. A ) $=
      ( vz vy vq cv wtr wral wel cuni wcel wa wi wal simpr a1i syl6ib a1ii ee33
      simpl eluni wsbc rspsbc com12 syl6d trsbc biimpd trel exp3acom3r ee233 ex
      wex elunii alrimdv 19.23v mpdd alrimivv dftr2 sylibr ) AFGZABHZCDIZDFZBJZ
      KZLZCFZVDKZMZDNCNVDGVAVICDVAVFDEIZEFZBKZLZEULZVHVAVFVEVNVFVEMVAVBVEOPEVCB
      UAQVAVFVMVHMZENVNVHMVAVFVOEVAVFVMCEIZVLVHVAVFVBVMVJVKGZVPVFVBMVAVBVETPVAV
      FVMVJMVJVLTRVAVFVMVLUTAVKUBZVQVAVFVMVLMVJVLORZVAVFVMVLVRVSVLVAVRUTAVKBUCU
      DUEVLVRVQAVKBUFUGSVQVBVJVPVKVGVCUHUIUJVSVPVLVHVGVKBUMUKSUNVMVHEUOQUPUQCDV
      DURUS $.
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d D y $.  $d x y $.
    $( Distribute proper substitution through a subclass relation.  This
       theorem was automatically derived from ~ sbcssgVD .  (Contributed by
       Alan Sare, 22-Jul-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sbcssOLD $p |- ( A e. B -> ( [. A / x ]. C C_ D <->
      [_ A / x ]_ C C_ [_ A / x ]_ D ) ) $=
      ( vy wcel wss wsbc cv csb wal dfss2 sbcbiiOLD sbcalgOLD sbcimg sbcel2gOLD
      wi wb bitrd imbi12d alrimiv albi syl syl6bbr ) BCGZDEHZABIZFJZABDKZGZUIAB
      EKZGZRZFLZUJULHUFUHUIDGZUIEGZRZFLZABIZUOUGUSABCFDEMNUFUTURABIZFLZUOURFABC
      OUFVAUNSZFLVBUOSUFVCFUFVAUPABIZUQABIZRUNUPUQABCPUFVDUKVEUMABUIDCQABUIECQU
      ATUBVAUNFUCUDTTFUJULMUE $.

  $}

  ${
    $d a b y $.  $d b x y $.
    $( Lemma for ~ onfrALT .  (Contributed by Alan Sare, 22-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    onfrALTlem5 $p |- ( [. ( a i^i x ) / b ]. ( ( b C_ ( a i^i x )
      /\ b =/= (/) ) -> E. y e. b ( b i^i y ) = (/) )
        <-> ( ( ( a i^i x ) C_ ( a i^i x ) /\ ( a i^i x ) =/= (/) ) ->
              E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = (/) ) ) $=
      ( cv cin wss c0 wne wa wceq wrex wi wsbc cvv wb ax-mp bitri wex csb inex1
      wcel vex sbcimg sbcan sseq1 sbcie wn df-ne sbcbii sbcng bicomd necon3bbii
      eqsbc3 3bitr2i anbi12i wel df-rex sbcel2gv sbceqg csbin csbvarg csbconstg
      ineq12i eqtri csb0 eqeq12i exbii sbcex2 3bitr4i imbi12i ) DEZCEZAEZFZGZVL
      HIZJZVLBEZFZHKZBVLLZMDVONZVRDVONZWBDVONZMZVOVOGZVOHIZJZVOVSFZHKZBVOLZMVOO
      UBZWCWFPVMVNCUCUAZVRWBDVOOUDQWDWIWEWLWDVPDVONZVQDVONZJWIVPVQDVOUEWOWGWPWH
      VPWGDVOWNVLVOVOUFUGWPVLHKZUHZDVONZWQDVONZUHZWHVQWRDVOVLHUIUJWMXAWSPWNWMWS
      XAWQDVOOUKULQWTVOHWMWTVOHKPWNDVOHOUNQUMUOUPRWEBDUQZWAJZBSZDVONZWLWBXDDVOW
      ABVLURUJXCDVONZBSVSVOUBZWKJZBSXEWLXFXHBXFXBDVONZWADVONZJXHXBWADVOUEXIXGXJ
      WKWMXIXGPWNDVSVOOUSQXJDVOVTTZDVOHTZKZWKWMXJXMPWNDVOVTHOUTQXKWJXLHXKDVOVLT
      ZDVOVSTZFWJDVOVLVSVAXNVOXOVSWMXNVOKWNDVOOVBQWMXOVSKWNDVOVSOVCQVDVEDVOVFVG
      RUPRVHXCBDVOVIWKBVOURVJRVKR $.

  $}

  ${
    $d a x $.
    $( Lemma for ~ onfrALT .  (Contributed by Alan Sare, 22-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    onfrALTlem4 $p |- ( [. y / x ]. ( x e. a /\ ( a i^i x ) = (/) ) <->
                        ( y e. a /\ ( a i^i y ) = (/) ) ) $=
      ( wel cv cin c0 wceq wa wsbc sbcan sbcel1v csb wcel wb sbceqg ax-mp bitri
      cvv vex csbin csbconstg csbvarg ineq12i eqtri csb0 eqeq12i anbi12i ) ACDZ
      CEZAEZFZGHZIABEZJUIAUNJZUMAUNJZIBCDZUJUNFZGHZIUIUMAUNKUOUQUPUSAUNUJLUPAUN
      ULMZAUNGMZHZUSUNSNZUPVBOBTZAUNULGSPQUTURVAGUTAUNUJMZAUNUKMZFURAUNUJUKUAVE
      UJVFUNVCVEUJHVDAUNUJSUBQVCVFUNHVDAUNSUCQUDUEAUNUFUGRUHR $.

  $}

  ${
    $d a b y $.  $d b x y $.
    $( Lemma for ~ onfrALT .  (Contributed by Alan Sare, 22-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    onfrALTlem3 $p |- ( ( a C_ On /\ a =/= (/) ) ->
                        ( ( x e. a /\ -. ( a i^i x ) = (/) ) ->
                        E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = (/) ) ) $=
      ( vb cv con0 wss c0 wne wa cin wceq wrex wi ee02 cvv wcel cep wwe syl6 wn
      wel ssid simpr a1i df-ne syl6ibr pm3.2 wsbc wal vex inex2 word simpl ssel
      wfr syl2im eloni ordwe inss2 wess com12 syl6mpi dfepfr syl6ib onfrALTlem5
      wefr spsbc mpdd ) CEZFGZVJHIZJZACUBZVJAEZKZHLUAZJZVPVPGZVPHIZJZVPBEZKHLBV
      PMZVSVMVRVTWAVPUCVMVRVQVTVRVQNVMVNVQUDUEVPHUFUGVSVTUHOVMVRDEZVPGWDHIJWDWB
      KHLBWDMNZDVPUIZWAWCNVPPQVMVRWEDUJZWFVOVJAUKULVMVRVPRUPZWGVMVRVPRSZWHVMVRV
      ORSZVPVOGZWIVMVRVOUMZWJVMVRVOFQZWLVMVKVRVNWMVKVLUNVNVQUNVJFVOUOUQVOURTVOU
      STVJVOUTWKWJWIVPVORVAVBVCVPRVGTDBVPVDVEWEDVPPVHOABCDVFVEVI $.

  $}

  ${
    $d ch x $.  $d ph x $.  $d ps x $.
    ggen31.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( ~ gen31 without virtual deductions.  (Contributed by Alan Sare,
       22-Jul-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ggen31 $p |- ( ph -> ( ps -> ( ch -> A. x th ) ) ) $=
      ( wal wi wa imp alrimdv ex ) ABCDEGHABICDEABCDHFJKL $.
  $}

  ${
    $d a y z $.  $d x y z $.
    $( Lemma for ~ onfrALT .  (Contributed by Alan Sare, 22-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    onfrALTlem2 $p |- ( ( a C_ On /\ a =/= (/) ) -> ( ( x e. a /\
                      -. ( a i^i x ) = (/) ) -> E. y e. a ( a i^i y ) =
                      (/) ) ) $=
      ( vz cv con0 wss c0 wa wel cin wceq wcel a1ii sseli syl8 simpl syl6 ee33
      wi wne wex wrex onfrALTlem3 df-rex syl6ib wal simpr inss2 inss1 word ssel
      wn wtr syl2im eloni ordtr trel exp3acom23 ee233 elin simplbi2 simplbi2com
      simpll exp4a ggen31 dfss2 biimpri ex pm3.21 idi alrimdv exim mpdd syl6ibr
      sseq0 ) CEZFGZVQHUAZIZACJZVQAEZKZHLUMZIZBCJZVQBEZKZHLZIZBUBZWIBVQUCVTWEWG
      WCMZWCWGKZHLZIZBUBZWKVTWEWNBWCUCWPABCUDWNBWCUEUFVTWEWOWJTZBUGWPWKTVTWEWQB
      VTWEWQTTVTWEWOWIWFWJVTWEWOWHWMGZWNWIVTWEWODEZWHMZWSWMMZTZDUGZWRVTWEWOXBDV
      TWEWOWTXAVTWEWOWTIZDBJZWSWCMZXAVTWEXDWTXEVTWEXDWTTWOWTUHNZWHWGWSVQWGUIOPZ
      VTWEXDDCJZDAJZXFVTWEXDWTXIXGWHVQWSVQWGUJOPVTWEWBUNZXDBAJZXEXJVTWEWBUKZXKV
      TWEWBFMZXMVTVRWEWAXNVRVSQWAWDQVQFWBULUOWBUPRWBUQRVTWEXDWLXLVTWEXDWLTWLWNW
      TVDNWCWBWGVQWBUIOPXHXKXEXLXJWBWSWGURUSUTXFXIXJWSVQWBVAVBSXAXFXEWSWCWGVAVC
      SVEVFWRXCDWHWMVGVHPVTWEWOWNTWLWNUHNWRWNWIWHWMVPVISVTWEWOWLWFVTWEWOWLTWLWN
      QNWCVQWGVQWBUJOPWIWFVJSVKVLWOWJBVMRVNWIBVQUEVO $.
  $}

  ${
    $d ph y $.
    $( A theorem pertaining to the substitution for an existentially quantified
       variable when the substituted variable does not occur in the quantified
       wff.  (Contributed by Alan Sare, 22-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    cbvexsv $p |- ( E. x ph <-> E. y [ y / x ] ph ) $=
      ( cvv wrex wsb wex cbvrexsv rexv 3bitr3i ) ABDEABCFZCDEABGKCGABCDHABIKCIJ
      $.
  $}

  ${
    $d a x y $.
    $( Lemma for ~ onfrALT .  (Contributed by Alan Sare, 22-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    onfrALTlem1 $p |- ( ( a C_ On /\ a =/= (/) ) -> ( ( x e. a /\ ( a i^i x ) =
                      (/) ) -> E. y e. a ( a i^i y ) = (/) ) ) $=
      ( cv con0 wss c0 wne wa wel cin wceq wex wrex wsb wi 19.8a cbvexsv syl6ib
      a1i wsbc sbsbc onfrALTlem4 bitri exbii df-rex syl6ibr ) CDZEFUHGHIZACJUHA
      DKGLIZBCJUHBDZKGLZIZBMZULBUHNUIUJUJABOZBMZUNUIUJUJAMZUPUJUQPUIUJAQTUJABRS
      UOUMBUOUJAUKUAUMUJABUBABCUCUDUESULBUHUFUG $.
  $}

  ${
    $d a x y $.
    $( The epsilon relation is foundational on the class of ordinal numbers.
       ~ onfrALT is an alternate proof of ~ onfr . ~ onfrALTVD is the Virtual
       Deduction proof from which ~ onfrALT is derived.  The Virtual Deduction
       proof mirrors the working proof of ~ onfr which is the main part of the
       proof of Theorem 7.12 of the first edition of TakeutiZaring.  The proof
       of the corresponding Proposition 7.12 of [TakeutiZaring] p. 38 (second
       edition) does not contain the working proof equivalent of ~ onfrALTVD .
       This theorem does not rely on the Axiom of Regularity.  (Contributed by
       Alan Sare, 22-Jul-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    onfrALT $p |- _E Fr On $=
      ( va vy vx con0 cep wfr cv wss c0 wne wa cin wceq wi dfepfr simpr wel wex
      wrex exp3a n0 wn onfrALTlem1 onfrALTlem2 pm2.61 exlimdv syl5bi mpd mpgbir
      ee22 ) DEFAGZDHZUKIJZKZUKBGLIMBUKSZNAABDOUNUMUOULUMPUMCAQZCRUNUOCUKUAUNUP
      UOCUNUPUKCGLIMZUONUQUBZUONUOUNUPUQUOCBAUCTUNUPURUOCBAUDTUQUOUEUJUFUGUHUI
      $.
  $}

  $( Formula-building implication rule for class substitution.  Closed form of
     ~ csbeq2i . ~ csbeq2g is derived from the virtual deduction proof
     ~ csbeq2gVD .  (Contributed by Alan Sare, 10-Nov-2012.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  csbeq2g $p |- ( A e. V -> ( A. x B = C ->
                   [_ A / x ]_ B = [_ A / x ]_ C ) ) $=
    ( wcel wceq wal wsbc csb spsbc sbceqg sylibd ) BEFCDGZAHNABIABCJABDJGNABEKA
    BCDELM $.

  $( Closed form of right-to-left implication of ~ 19.41 , Theorem 19.41 of
     [Margaris] p. 90.  Derived from ~ 19.41rgVD .  (Contributed by Alan Sare,
     8-Feb-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  19.41rg $p |- ( A. x ( ps -> A. x ps ) -> ( ( E. x ph /\ ps ) ->
                  E. x ( ph /\ ps ) ) ) $=
    ( wal wi wex wa sp pm3.21 a1i al2imi exim syl6 syld com23 imp3a ) BBCDZEZCD
    ZACFZBABGZCFZSBTUBSBQTUBEZRCHSQAUAEZCDUCRBUDCBUDERBAIJKAUACLMNOP $.

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( Ordered pair membership in a class abstraction of pairs.  Compare to
       ~ elopab .  (Contributed by Alan Sare, 8-Feb-2014.)  (Revised by Mario
       Carneiro, 6-May-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    opelopab4 $p |- ( <. u , v >. e. { <. x , y >. | ph } <->
                     E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) $=
      ( cv cop copab wcel wceq wex elopab vex eqcom bitr3i anbi1i 2exbii bitr4i
      wa opth ) EFZDFZGZABCHIUCBFZCFZGZJZASZCKBKUDUAJUEUBJSZASZCKBKABCUCLUJUHBC
      UIUGAUIUFUCJUGUDUEUAUBBMCMTUFUCNOPQR $.
  $}

  $( ~ pm13.193 for two variables. ~ pm13.193 is Theorem *13.193 in
     [WhiteheadRussell] p. 179.  Derived from ~ 2pm13.193VD .  (Contributed by
     Alan Sare, 8-Feb-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  2pm13.193 $p |- ( ( ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) <->
                    ( ( x = u /\ y = v ) /\ ph ) ) $=
    ( weq wa wsb simpll simplr simpr sbequ2 sylc jca31 sbequ1 impbii ) BEFZCDFZ
    GZACDHZBEHZGZSAGZUBQRAQRUAIZQRUAJZUBRTAUEUBQUATUDSUAKTBELMACDLMNUCQRUAQRAIZ
    QRAJZUCQTUAUFUCRATUGSAKACDOMTBEOMNP $.

  $( A closed form of ~ hbn . ~ hbnt is another closed form of ~ hbn .
     (Contributed by Alan Sare, 8-Feb-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  hbntal $p |- ( A. x ( ph -> A. x ph ) -> A. x ( -. ph -> A. x -. ph ) ) $=
    ( wal wi wn hba1 ax6o con1i con3 al2imi syl5 alimi syl ) AABCZDZBCZPBCAEZQB
    CZDZBCOBFPSBQNEZBCZPRUAAABGHOTQBANIJKLM $.

  $( A closed form of ~ hbim .  Derived from ~ hbimpgVD .  (Contributed by Alan
     Sare, 8-Feb-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  hbimpg $p |- ( ( A. x ( ph -> A. x ph ) /\ A. x ( ps -> A. x ps ) ) ->
                  A. x ( ( ph -> ps ) -> A. x ( ph -> ps ) ) ) $=
    ( wal wi wa hba1 hban wn hbntal adantr 19.21bi pm2.21 alimi syl6 simpr ax-1
    jad alrimih ) AACDEZCDZBBCDZEZCDZFZABEZUFCDZECUAUDCTCGUCCGHUEABUGUEAIZUHCDZ
    UGUEUHUIEZCUAUJCDUDACJKLUHUFCABMNOUEBUBUGUEUCCUAUDPLBUFCBAQNORS $.

  $( Closed form of ~ hbal .  Derived from ~ hbalgVD .  (Contributed by Alan
     Sare, 8-Feb-2014.)  (Proof modification is discouraged.)
     (New usage is discouraged.) $)
  hbalg $p |- ( A. y ( ph -> A. x ph ) ->
                  A. y ( A. y ph -> A. x A. y ph ) ) $=
    ( wal wi alim ax-7 syl6 a5i ) AABDZEZACDZLBDZECKCDLJCDMAJCFACBGHI $.

  $( Closed form of ~ nfex .  Derived from ~ hbexgVD .  (Contributed by Alan
     Sare, 8-Feb-2014.)  (Revised by Mario Carneiro, 12-Dec-2016.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  hbexg $p |- ( A. x A. y ( ph -> A. x ph ) ->
                  A. x A. y ( E. y ph -> A. x E. y ph ) ) $=
    ( wal wi wex nfa2 wnf sp alimi df-nf sylibr nfexd sylib alrimi alcom ) AABD
    EZCDZBDZACFZTBDEZBDZCDUACDBDSUBCQCBGZSTBHUBSABCUCSQBDABHRQBQCIJABKLMTBKNOUA
    CBPN $.

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( Alternate form of ~ a9e for non-distinct ` x ` , ` y ` and ` u = v ` .
       ~ a9e2eq is derived from ~ a9e2eqVD .  (Contributed by Alan Sare,
       25-Mar-2014.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    a9e2eq $p |- ( A. x x = y -> ( u = v ->
                  E. x E. y ( x = u /\ y = v ) ) ) $=
      ( weq wal wa wex a9ev hbae wi ax-8 sps ancld eximdh mpi a5i ax10o mpd syl
      19.2 excomim equtrr anim2d 2eximdv syl5com ) ABEZAFZADEZBDEZGZBHAHZDCEZUI
      BCEZGZBHAHUHUKAHZBHZULUHUPBFZUQUHUPAFURUGUPAUHUIAHUPADIUHUIUKAABAJUHUIUJU
      GUIUJKAABDLMNOPQUPABRSUPBUATUKBAUBTUMUKUOABUMUJUNUIDCBUCUDUEUF $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x z $.  $d y z $.
    $( If at least two sets exist ( ~ dtru ) , then the same is true expressed
       in an alternate form similar to the form of ~ a9e . ~ a9e2nd is derived
       from ~ a9e2ndVD .  (Contributed by Alan Sare, 25-Mar-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    a9e2nd $p |- ( -. A. x x = y ->
                       E. x E. y ( x = u /\ y = v ) ) $=
      ( vz weq wal wn wa wex wi cv cvv wcel vex id ax-17 syl idi alimi a9e mpbi
      pm3.2i 19.42v biimpri ax-mp isset anbi1i exbii hbnae hbn1 equequ1 dvelimh
      wb 19.41rg exim pm2.27 mpsyl excomim ) ABFZAGHZADFZBCFZIZBJAJZKVAVDAJZBJZ
      VEVBAJZVCIZBJZVAVJVGKZVGDLZMNZVCIZBJZVJVMVCBJZIZVOVMVPDOBCUAUCVOVQVMVCBUD
      UEUFVNVIBVMVHVCAVLUGUHUIUBVAVIVFKZBGZVKVAVAVSVAPZVAVABGVSABBUJVAVRBVAVRKV
      AVCVCAGKZAGZVRVAVAWBVTVAVAAGWBUTAUKVAWAAVAWAKVAVAWAVTECFZVCABEWCAQVCEQEBF
      ZWCVCUNZKWDWDWEWDPEBCULRSUMRSTRRVBVCAUORSTRRVIVFBUPRVJVGUQURVDBAUSRS $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( "At least two sets exist" expressed in the form of ~ dtru is logically
       equivalent to the same expressed in a form similar to ~ a9e if ~ dtru is
       false implies ` u = v ` . ~ a9e2ndeq is derived from ~ a9e2ndeqVD .
       (Contributed by Alan Sare, 25-Mar-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    a9e2ndeq $p |- ( ( -. A. x x = y \/ u = v ) <->
                        E. x E. y ( x = u /\ y = v ) ) $=
      ( cv wceq wal wn wo wa wex a1d wne biimprcd syl6 eximdv nfnae 19.9 syl6ib
      wi a9e2nd a9e2eq pm2.61i jaoi olc excom neeq1 adantrd simpr neeq2 ee22 sp
      a1i necon3ai syl5bi orc pm2.61ine impbii ) AEZBEZFZAGZHZDEZCEZFZIZUSVDFZU
      TVEFZJZBKAKZVCVKVFABCDUAZVBVFVKTABCDUBVCVKVFVLLUCUDVKVGTVDVEVFVGVKVFVCUEL
      VDVEMZVKVCVGVMVKVCBKZVCVKVJAKZBKVMVNVJABUFVMVOVCBVMVOVCAKVCVMVJVCAVMVJUSU
      TMZVCVMVJUSVEMZVIVPVMVHVQVIVHVQVMUSVDVEUGNUHVJVITVMVHVIUIUMVIVPVQUTVEUSUJ
      NUKVBUSUTVAAULUNOPVCAABAQRSPUOVCBABBQRSVCVFUPOUQUR $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( Equivalence for double substitution ~ 2sb5 without distinct ` x ` ,
       ` y ` requirement. ~ 2sb5nd is derived from ~ 2sb5ndVD .  (Contributed
       by Alan Sare, 30-Apr-2014.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    2sb5nd $p |- ( ( -. A. x x = y \/ u = v ) -> ( [ u / x ] [ v / y ] ph
                 <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) $=
      ( cv wceq wal wn wo wa wex wsb wb a9e2ndeq wi exbii nfs1v 19.41 bitr3i
      anabs5 2pm13.193 nfsb bitr2i anbi2i pm5.32 mpbir sylbi ) BFZCFZGBHIEFZDFZ
      GJUIUKGUJULGKZCLZBLZACDMZBEMZUMAKZCLZBLZNZBCDEOUOVAPUOUQKZUOUTKZNVBUOVBKV
      CUOUQUAVBUTUOUTUNUQKZBLVBUSVDBUSUMUQKZCLVDVEURCABCDEUBQUMUQCUPBECACDRUCST
      QUNUQBUPBERSUDUETUOUQUTUFUGUH $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    2uasbanh.1 $e |- ( ch <-> ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\
                     E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) $.
    $( Distribute the unabbreviated form of proper substitution in and out of a
       conjunction. ~ 2uasbanh is derived from ~ 2uasbanhVD .  (Contributed by
       Alan Sare, 31-May-2014.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    2uasbanh $p |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( ph /\ ps ) ) <->
                ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\
                E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) $=
      ( weq wa wex simpl jca 2eximi wsb wb syl 2sb5nd mpbird sban simprl simprr
      simplbi wal wn a9e2ndeq sylibr simprbi sbbii bitri sylanbrc sylbir impbii
      wo mpbid ) DGIEFIJZABJZJZEKDKZUPAJZEKDKZUPBJZEKDKZJZUSVAVCURUTDEURUPAUPUQ
      LZUPABUAMNURVBDEURUPBVEUPABUBMNMVDCUSHCUQEFOZDGOZUSCAEFOZDGOZBEFOZDGOZVGC
      VIVACVAVCHUCZCDEIDUDUEGFIUNZVIVAPCUPEKDKZVMCVAVNVLUTUPDEUPALNQDEFGUFUGZAD
      EFGRQSCVKVCCVAVCHUHCVMVKVCPVOBDEFGRQSVGVHVJJZDGOVIVKJVFVPDGABEFTUIVHVJDGT
      UJUKCVMVGUSPVOUQDEFGRQUOULUM $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( Distribute the unabbreviated form of proper substitution in and out of a
       conjunction.  (Contributed by Alan Sare, 31-May-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    2uasban $p |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( ph /\ ps ) ) <->
               ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\
               E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) $=
      ( cv wceq wa wex biid 2uasbanh ) ABCGFGHDGEGHIZAIDJCJMBIDJCJIZCDEFNKL $.
  $}

  $( Absorption of an existential quantifier of a double existential quantifier
     of non-distinct variables. ~ e2ebind is derived from ~ e2ebindVD .
     (Contributed by Alan Sare, 27-Nov-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  e2ebind $p |- ( A. x x = y -> ( E. x E. y ph <-> E. y ph ) ) $=
    ( wex wb wceq wal nfe1 19.9 biidd drex1 drex2 excom syl6bb syl5rbbr aecoms
    cv ) ACDZBDZRECBRRCDZCQBQFCGZSRCACHIUATABDZCDSRUBCBCAACBUAAJKLACBMNOP $.

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    elpwgded.1 $e |- ( ph -> A e. _V ) $.
    elpwgded.2 $e |- ( ps -> A C_ B ) $.
    $( ~ elpwgdedVD in conventional notation.  (Contributed by Alan Sare,
       23-Apr-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    elpwgded $p |- ( ( ph /\ ps ) -> A e. ~P B ) $=
      ( cvv wcel wss cpw elpwg biimpar syl2an ) ACGHZCDIZCDJHZBEFNPOCDGKLM $.
  $}

  ${
    trelded.1 $e |- ( ph -> Tr A ) $.
    trelded.2 $e |- ( ps -> B e. C ) $.
    trelded.3 $e |- ( ch -> C e. A ) $.
    $( Deduction form of ~ trel .  In a transitive class, the membership
       relation is transitive.  (Contributed by Alan Sare, 3-Dec-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    trelded $p |- ( ( ph /\ ps /\ ch ) -> B e. A ) $=
      ( wtr wcel trel 3impib syl3an ) ADJZBEFKZCFDKZEDKZGHIOPQRDEFLMN $.
  $}

  ${
    jaoded.1 $e |- ( ph -> ( ps -> ch ) ) $.
    jaoded.2 $e |- ( th -> ( ta -> ch ) ) $.
    jaoded.3 $e |- ( et -> ( ps \/ ta ) ) $.
    $( Deduction form of ~ jao .  Disjunction of antecedents.  (Contributed by
       Alan Sare, 3-Dec-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    jaoded $p |- ( ( ph /\ th /\ et ) -> ch ) $=
      ( wi wo jao 3imp syl3an ) ABCJZDECJZFBEKZCGHIOPQCBCELMN $.
  $}

  ${
    3imp31.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( The importation inference ~ 3imp with commutation of the first and third
       conjuncts of the assertion relative to the hypothesis.  (Contributed by
       Alan Sare, 11-Sep-2016.)  (Proof modification is discouraged.) $)
    3imp31 $p |- ( ( ch /\ ps /\ ph ) -> th ) $=
      ( com13 3imp ) CBADABCDEFG $.
  $}

  ${
    3imp21.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( The importation inference ~ 3imp with commutation of the first and
       second conjuncts of the assertion relative to the hypothesis.
       (Contributed by Alan Sare, 11-Sep-2016.)
       (Proof modification is discouraged.) $)
    3imp21 $p |- ( ( ps /\ ph /\ ch ) -> th ) $=
      ( 3imp 3com12 ) ABCDABCDEFG $.
  $}

  ${
    biimpa21.1 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( ~ biimpa with commutation of the first and second conjuncts of the
       assertion.  (Contributed by Alan Sare, 11-Sep-2016.) $)
    biimpa21 $p |- ( ( ps /\ ph ) -> ch ) $=
      ( biimpac ) ABCDE $.
  $}

  ${
    sbtT.1 $e |- ( T. -> ph ) $.
    $( A substitution into a theorem remains true. ~ sbt with the existence of
       no virtual hypotheses for the hypothesis expressed as the empty virtual
       hypothesis collection.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sbtT $p |- [ y / x ] ph $=
      ( trud sbt ) ABCADEF $.
  $}

  ${
    ex3.1 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $.
    $( Apply ~ ex to a hypothesis with a 3-right-nested conjunction antecedent,
       with the antecedent of the assertion being a triple conjunction rather
       than a 2-right-nested conjunction.  (Contributed by Alan Sare,
       22-Apr-2018.) $)
    ex3 $p |- ( ( ph /\ ps /\ ch ) -> ( th -> ta ) ) $=
      ( w3a wa wi df-3an ex sylbi ) ABCGABHCHZDEIABCJMDEFKL $.
  $}

  ${
    $( If a double conjunction is false and the second conjunct is true, then
       the first conjunct is false.
       ~ http://www.virtualdeduction.com/not12an2impnot1vd.html is the Virtual
       Deduction proof verified by automatically transforming it into the
       Metamath proof of ~ not12an2impnot1 using completeusersproof, which is
       verified by the Metamath program.
       ~ http://www.virtualdeduction.com/not12an2impnot1ro.html is a form of
       the completed proof which preserves the Virtual Deduction proof's step
       numbers and their ordering.  (Contributed by Alan Sare, 13-Jun-2018.) $)
    not12an2impnot1 $p |- ( ( -. ( ph /\ ps ) /\ ps ) -> -. ph ) $=
      ( wa wn id simprd wi simpld pm3.21 con3rr3 syl mpd ) ABCZDZBCZBADZONBOEZF
      ONBPGONBQHBAMBAIJKL $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                What is Virtual Deduction?
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c (. $. $( Left parenthesis for virtual deduction for virtual hypotheses.
      [21-Apr-2011] $)

  $c ). $. $( Right parenthesis for virtual deduction.
      [9-Nov-2011] $)

  $c ->. $. $(  Symbol for virtual inference.
      [9-Nov-2011] $)

  $c ->.. $. $(  Bold arrow of Kleene's classical system G1.
      [19-May-2013] $)

  $c ,. $. $( Comma between two adjacent virtual hypotheses.
      [28-Jul-2016] $)

  ${
    $( A Virtual Deduction proof in a Hilbert-style deductive system is the
       analog of a sequent calculus proof. A theorem is proven in a Gentzen
       system in order to prove more directly, which may be more intuitive
       and easier for some people. The analog of this proof in Metamath's
       Hilbert-style system is verified by the Metamath program.

       <HTML> <TABLE> </TABLE> </HTML>

       Natural Deduction is a well-known proof method orignally proposed by
       Gentzen in 1935 and comprehensively summarized by Prawitz in his 1965
       monograph "Natural deduction: a proof-theoretic study".  Gentzen wished
       to construct "a formalism that comes as close as possible to natural
       reasoning".  Natural deduction is a response to dissatisfaction with
       axiomatic proofs such as Hilbert-style axiomatic proofs, which the
       proofs of Metamath are.  In 1926, in Poland, Lukasiewicz advocated a
       more natural treatment of logic.  Jaskowski made the earliest attempts
       at defining a more natural deduction.  Natural deduction in its modern
       form was independently proposed by Gentzen.

       Sequent calculus, the chief alternative to Natural Deduction, was
       created by Gentzen. The following is an except from Stephen Cole
       Kleene's seminal 1952 book "Introduction to Metamathematics", which
       contains the first formulation of sequent calculus in the modern style.
       Kleene states on page 440:

       . . . the proof of (Gentzen's Hauptsatz) breaks down into a list of
       cases,
       each of which is simple to handle. . . . Gentzen's normal form for
       proofs in the predicate calculus requires a different classification of
       the deductive steps than is given by the postulates of the formal system
       of predicate calculus of Chapter IV (Section 19). The implication symbol
       ` -> ` (the Metamath symbol for implication has been substituted here
       for
       the symbol used by Kleene) has to be separated in its role of mediating
       inferences from its role as a component symbol of the formula being
       proved. In the former role it will be replaced by a new formal symbol
       ` ->.. ` (read "gives" or "entails"), to which properties will be
       assigned similar to those of the informal symbol ` |- ` in our former
       derived rules.

       Gentzen's classification of the deductive operations is made explicit
       by setting up a new formal system of the predicate calculus. The formal
       system of propositional and predicate calculus studied previously
       (Chapters IV ff.) we call now a "Hilbert-type system", and denote by
       H. Precisely, H denotes any one or a particular one of several
       systems, according to whether we are considering propositional calculus
       or predicate calculus, in the classical or the intuitionistic version
       (Section 23), and according to the sense in which we are using "term"
       and "formula" (Sections 117,25,31,37,72-76). The same respective
       choices will apply to the "Gentzen-type system G1" which we introduce
       now and the G2, G3 and G3a later.

       The transformation or deductive rules of G1 will apply to objects which
       are not formulas of the system H, but are built from them by an
       additional formation rule, so we use a new term "sequent" for these
       objects. (Gentzen says "Sequenz", which we translate as "sequent",
       because we have already used "sequence" for any succession of objects,
       where the German is "Folge".) A sequent is a formal expression of the
       form ` ph ` , . . . , ` ps ->.. ch ` , . . . , ` th ` where ` ph `
       , . . . , ` ps ` and ` ch ` , . . . , ` th ` are seqences of a finite
       number of 0 or more formulas (substituting Metamath notation for
       Kleene's notation). The part ` ph ` , . . . , ` ps ` is the antecedent,
       and ` ch ` , . . . , ` th ` the succedent of the sequent ` ph ` , . . .
       , ` ps ->.. ch ` , . . . , ` th ` .

       When the antecedent and the succedent each have a finite number of 1 or
       more formulas, the sequent ` ph ` , . . . , ` ps ->.. ch ` , . . .
       ` th ` has the same interpretation for G1 as the formula
       ` ( ( ph /\ ` . . . ` /\ ps ) -> ( ch \/ ` . . . ` \/ th ) ) ` for H.
       The interpretation extends to the case of an antecedent of 0 formulas by
       regarding ` ( ph /\ ` . . . ` /\ ps ) ` for 0 formulas (the
       "empty conjunction") as true and ` ( ch \/ ` . . . ` \/ th ) ` for 0
       formulas (the "empty disjunction") as false.

       . . . As in Chapter V, we use Greek capitals . . . to stand for finite
       sequences of zero or more formulas, but now also as antecedent
       (succedent), or parts of antecedent (succedent), with separating formal
       commas included. . . . (End of Kleene excerpt)

       In chapter V entitled "Formal Deduction" Kleene states, on page 86:

       Section 20. Formal deduction.  Formal proofs of even quite elementary
       theorems tend to be long. As a price for having analyzed logical
       deduction into simple steps, more of those steps have to be used.

       The purpose of formalizing a theory is to get an explicit definition of
       what constitutes proof in the theory.  Having achieved this, there is no
       need always to appeal directly to the definition. The labor required to
       establish the formal provability of formulas can be greatly lessened by
       using metamathematical theorems concerning the existence of formal
       proofs.  If the demonstrations of those theorems do have the finitary
       character which metamathematics is supposed to have, the demonstrations
       will indicate, at least implicitly, methods for obtaining the formal
       proofs. The use of the metamathematical theorems then amounts to
       abbreviation, often of very great extent, in the presentation of formal
       proofs.

       The simpler of such metamathematical theorems we shall call derived
       rules, since they express principles which can be said to be derived
       from the postulated rules by showing that the use of them as additional
       methods of inference does not increase the class of provable formulas.
       We shall seek by means of derived rules to bring the methods for
       establishing the facts of formal provability as close as possible to the
       informal methods of the theory which is being formalized.

       In setting up the formal system, proof was given the simplest possible
       structure, consisting of a single sequence of formulas. Some of our
       derived rules, called "direct rules", will serve to abbreviate for us
       whole segments of such a sequence; we can then, so to speak, use these
       segments as prefabricated units in building proofs.

       But also, in mathematical practice, proofs are common which have a more
       complicated structure, employing "subsidiary deduction", i.e. deduction
       under assumptions for the sake of the argument, which assumptions are
       subsequently discharged.  For example, subsidiary deduction is used in a
       proof by reductio ad absurdum, and less obtrusively when we place the
       hypothesis of a theorem on a par with proved propositions to deduce the
       conclusion. Other derived rules, called "subsidiary deduction rules",
       will give us this kind of procedure.

       We now introduce, by a metamathematical definition, the notion of
       "formal deducibility under assumptions". Given a list ` ph ` , . . .
       ` ps ` of ` 0 ` or more (occurences of) formulas, a finite sequence of
       one or more (occurences of) formulas is called a (formal) deduction from
       the assumption formulas ` ph ` , . . . ` ps ` , if each formula of the
       sequence is either one of the formulas ` ph ` , . . . ` ps ` , or an
       axiom, or an immediate consequence of preceding formulas of a sequence.
       A deduction is said to be deducible from the assumption formulas (in
       symbols, ` ph ` ,. . . . ,. ` ps |- ch ` ), and is called the conclusion
       (or endformula) of the deduction. (The symbol ` |- ` may be read
       "yields".) (End of Kleene excerpt)

       Gentzen's normal form is a certain direct fashion for proofs and
       deductions. His sequent calculus, formulated in the modern style by
       Kleene, is the classical system G1.  In this system, the new formal
       symbol ` ->.. ` has properties similar to the informal symbol ` |- ` of
       Kleene's above language of formal deducibility under assumptions.

       Kleene states on page 440:

       . . . This leads us to inquire whether there may not be a theorem about
       the predicate calculus asserting that, if a formula is provable (or
       deducible from other formulas), it is provable (or deducible) in a
       certain direct fashion; in other words, a theorem giving a normal form
       for proofs and deductions, the proofs and deduction in normal form being
       in some sense direct. (End of Kleene excerpt)

       There is such a theorem, which was proven by Kleene.

       Formal proofs in H of even quite elementary theorems tend to be long. As
       a price for having analyzed logical deduction into simple steps, more of
       those steps have to be used. The proofs of Metamath are fully detailed
       formal proofs. We wish to have a means of writing rigorously verifiable
       mathematical proofs in a more direct fashion. Natural Deduction is a
       system for proving theorems and deductions in a more direct fashion.
       However, Natural Deduction is not compatible for use with Metamath,
       which uses a Hilbert-type system. Instead, Kleene's classical system G1
       may be used for proving Metamath deductions and theorems in a more
       direct fashion.

       The system of Metamath is an H system, not a Gentzen system.  Therefore,
       proofs in Kleene's classical system G1 ("G1") cannot be included in
       Metamath's system H, which we shall henceforth call "system H" or "H".
       However, we may translate proofs in G1 into proofs in H.

       By Kleene's THEOREM 47 (page 446)

       <HTML> <TABLE>
       <TR> <TD> if ` |- ->.. ph ` in G1 then ` |- ph ` in H
       </TABLE> </HTML>

       By Kleene's COROLLARY of THEOREM 47 (page 448)

       <HTML> <TABLE>
       <TR> <TD> if ` |- ph ->.. ps ` in G1 then ` |- (. ph ->. ps ). ` in H
       <TR> <TD> if ` |- ph ,. ps ->.. ch ` in G1 then
       ` |- (. (. ph ,. ps ). ->. ch ). ` in H
       <TR> <TD> if ` |- ph ,. ps ,. ch ->.. th ` in G1 then
       ` |- (. (. ph ,. ps ,. ch ). ->. th ). ` in H
       </TABLE> </HTML>

       ` ->. ` denotes the same connective denoted by ` -> ` . " , " , in the
       context of Virtual Deduction, denotes the same connective denoted by
       ` /\ ` . This Virtual Deduction notation is specified by the following
       set.mm definitions:

       <HTML> <TABLE>
       <TR> <TD> ~ df-vd1 <TD> ` |- ( (. ph ->. ps ). <-> ( ph -> ps ) ) `
       <TR> <TD> ~ dfvd2an <TD> ` |- ( (. (. ph ,. ps ). ->. ch ). <-> `
       ` ( ( ph /\ ps ) -> ch ) ) `
       <TR> <TD> ~ dfvd3an <TD> ` |- ( (. (. ph ,. ps ,. ch ). ->. th ). <-> `
       ` ( ( ph /\ ps /\ ch ) -> th ) ) `
       </TABLE> </HTML>

       ` ->. ` replaces ` ->.. ` in the analog in H of a sequent in G1 having
       a non-empty antecedent. If ` ->. ` occurs as the outermost connective
       denoted by ` ->. ` or ` -> ` and occurs exactly once, we call the analog
       in H of a sequent in G1 a "virtual deduction" because the corresponding
       ` ->.. ` of the sequent is assigned properties similar to ` |- ` .

       While sequent calculus proofs (proofs in G1) may have as steps
       sequents with 0, 1, or more formulas in the succedent, we shall only
       prove in G1 using sequents with exactly 1 formula in the succedent.

       The User proves in G1 in order to obtain the benefits of more direct
       proving using sequent calculus, then translates the proof in G1 into a
       proof in H. The reference theorems and deductions to be used for proving
       in G1 are translations of theorems and deductions in set.mm.

       Each theorem ` |- ph ` in set.mm corresponds to the theorem
       ` |- ->.. ph ` in G1. Deductions in G1 corresponding to deductions in H
       are similarly determined. Theorems in H with one or more occurences of
       either ` ->. ` or ` -> ` may also be translated into theorems in G1 for
       by replacing the outermost occurence of ` ->. ` or ` -> ` of the theorem
       in H with ` ->.. ` .  Deductions in H may be translated into deductions
       in G1 in a similar manner.  The only theorems and deductions in H useful
       for proving in G1 for the purpose of obtaining proofs in H are those in
       which, for each hypothesis or assertion, there are 0 or 1 occurences of
       ` ->. ` and it is the outermost occurence of ` ->. ` or ` -> ` .
       Kleene's THEOREM 46 and its COROLLARY 2 are used for translating from H
       to G1. By Kleene's THEOREM 46 (page 445)

       <HTML> <TABLE>
       <TR> <TD> if ` |- ph ` in H then ` |- ->.. ph ` in G1
       </TABLE> </HTML>

       By Kleene's COROLLARY 2 of THEOREM 46 (page 446)

       <HTML> <TABLE>
       <TR> <TD> if ` |- (. ph ->. ps ). ` in H  then ` |- ph ->.. ps ` in G1
       <TR> <TD> if ` |- (. (. ph ,. ps ). ->. ch ). ` in H then
       ` |- ph ,. ps ->.. ch ` in G1
       <TR> <TD> if ` |- (. (. ph ,. ps ,. ch ). ->. th ). ` in H then
       ` |- ph ,. ps ,. ch ->.. th ` in G1
       </TABLE> </HTML>

       To prove in H the User simply proves in G1 and translates each G1 proof
       step into a H proof step. The translation is trivial and immediate. The
       proof in H is in Virtual Deduction notation. It is a working proof in
       the
       sense that, if it has no errors, each theorem and deduction of the proof
       is true, but may or may not, after being translated into conventional
       notation, unify with any theorem or deduction schemata in set.mm. Each
       theorem or deduction schemata in set.mm has a particular form. The
       working proof written by the User (the "User's Proof" or
       "Virtual Deduction Proof") may contain theorems and deductions which
       would unify with a variant of a theorem or deduction schemata in set.mm,
       but not with any particular form of that theorem or deduction schemata
       in
       set.mm.

       The computer program completeusersproof.c may be applied to a Virtual
       Deduction proof to automatically add steps to the proof ("technical
       steps") which, if possible, transforms the form of a theorem or
       deduction of the Virtual Deduction proof not unifiable with a theorem or
       deduction schemata in set.mm into a variant form which is. For
       theorems and deductions of the Virtual Deduction proof which are
       completable in this way, completeusersproof saves the User the extra
       work involved in satisfying the constraint that the theorem or deduction
       is in a form which unifies with a theorem or deduction schemata in
       set.mm. mmj2, which is invoked by completeusersproof, automatically
       finds one of the reference theorems or deductions in set.mm which
       unifies
       with each theorem and deduction in the proof satisfying this constraint
       and labels the theorem or the assertion step of the deduction.

       The analogs in H of the postulates of G1 are the set.mm postulates.
       The postulates in G1 corresponding to the Metamath postulates are not
       the classical system G1 postulates of Kleene (pages 442 and 443). set.mm
       has the predicate calculus postulates and other posulates. The
       Kleene classical system G1 postulates correspond to predicate
       calculus postulates which differ from the Metamath system G1 postulates
       corresponding to the predicate calculus postulates of Metamath's system
       H. Metamath's predicate calculus G1 postulates are presumably
       deducible from the Kleene classical G1 postulates and the Kleene
       classical G1 postulates are deducible from Metamath's G1 postulates. It
       should be recognized that, because of the different postulates, the
       classical G1 system corresponding to Metamath's system H is not
       identical to Kleene's classical system G1.

       Why not create a separate database (setg.mm) of proofs in G1, avoiding
       the need to translate from H to G1 and from G1 back to H? The
       translations are trivial. Sequents make the language more complex than
       is necessary. More direct proving using sequent calculus may be done as
       a means towards the end of constructing proofs in H. Then, the language
       may be kept as simple as possible. A system G1 database would be
       redundant because it would duplicate the information contained in the
       corresponding system H database.

       For earlier proofs, each "User's Proof" in the web page description of
       a Virtual Deduction proof in set.mm is the analog in H of the User's
       working proof in G1. The User's Proof is automatically completed by
       completeusersproof.cmd (superseded by completeusersproof.c in September
       of 2016). The completed proof is the Virtual Deduction proof, which is
       the analog in H of the corresponding fully detailed proof in G1. The
       completed Virtual Deduction proof of these earlier proofs may be
       automatically translated into a conventional Metamath proof.

       The input for completeusersproof.c is a Virtual Deduction proof. Unlike
       completeusersproof.cmd, the completed proof is in conventional notation.
       completeusersproof.c eliminates the virtual deduction notation of the
       Virtual Deduction proof after utilizing the information it provides.

       Applying mmj2's unify command is essential to completeusersproof. The
       mmj2 program is invoked within the completeusersproof.c function
       mmj2Unify(). The original mmj2 program was written by Mel O'Cat. Mario
       Carneiro has enhanced it. mmj2Unify() is called multiple times during
       the execution of completeusersproof.

       A Virtual Deduction proof is a Metamath-specific version of a Natural
       Deduction Proof. In order for mmj2 to complete a Virtual Deduction
       proof it is necessary that each theorem or deduction of the proof
       is in a form which unifies with a theorem or deduction schemata in
       set.mm. completeusersproof weakens this constraint.

       The User may write a Virtual Deduction proof and automatically transform
       it into a complete Metamath proof using the completeusersproof tool. The
       completed proof has been checked by the Metamath program. The task of
       writing a complete Metamath proof is reduced to writing what is
       essentially a Natural Deduction Proof.

       The completeusersproof program and all associated files necessary to
       use it may be downloaded from the Metamath web site. All syntax
       definitions, theorems, and deductions necessary to create Virtual
       Deduction proofs are contained in set.mm. Examples of Virtual Deduction
       proofs in mmj2 Proof Worksheet .txt format are included in the
       completeusersproof download.

       ~ http://www.virtualdeduction.com/suctrvd.html ,
       ~ http://www.virtualdeduction.com/sineq0altvd.html ,
       ~ http://www.virtualdeduction.com/iunconlem2vd.html ,
       ~ http://www.virtualdeduction.com/isosctrlem1altvd.html , and
       ~ http://www.virtualdeduction.com/chordthmaltvd.html are examples
       of Virtual Deduction proofs.

       Generally, proving using Virtual Deduction and completeusersproof
       reduces the amount Metamath-specific knowledge required by the User.
       Often, no knowledge of the specific theorems and deductions in set.mm
       is required to write some of the subproofs of a Virtual Deduction
       proof. Often, no knowledge of the Metamath-specific names of reference
       theorems and deductions in set.mm is required for writing some of the
       subproofs of a User's Proof. Often, the User may write subproofs of
       a proof using theorems or deductions commonly used in mathematics and
       correctly assume that some form of each is contained in set.mm and that
       completeusersproof will automatically generate the technical steps
       necessary to utilize them to complete the subproofs. Often, the fraction
       of the work which may be considered tedious is reduced and the total
       amount of work is reduced. $)
    wvd1 $a wff (. ph ->. ps ). $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Virtual Deduction Theorems
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $( Definition of virtual deduction.  (Contributed by Alan Sare,
       21-Apr-2011.)  (New usage is discouraged.) $)
    df-vd1 $a |- ( (. ph ->. ps ). <-> ( ph -> ps ) ) $.
  $}

  ${
    in1.1 $e |- (. ph ->. ps ). $.
    $( Inference form of ~ df-vd1 .  Virtual deduction introduction rule of
       converting the virtual hypothesis of a 1-virtual hypothesis virtual
       deduction into an antecedent.  (Contributed by Alan Sare, 14-Nov-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    in1 $p |- ( ph -> ps ) $=
      ( wvd1 wi df-vd1 mpbi ) ABDABECABFG $.
  $}

  ${
    iin1.1 $e |- ( ph -> ps ) $.
    $( ~ in1 without virtual deductions.  (Contributed by Alan Sare,
       23-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    iin1 $p |- ( ph -> ps ) $=
      (  ) C $.
  $}

  ${
    dfvd1ir.1 $e |- ( ph -> ps ) $.
    $( Inference form of ~ df-vd1 with the virtual deduction as the assertion.
       (Contributed by Alan Sare, 14-Nov-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dfvd1ir $p |- (. ph ->. ps ). $=
      ( wvd1 wi df-vd1 mpbir ) ABDABECABFG $.
  $}

  ${
    $( Virtual deduction identity rule which is ~ id with virtual deduction
       symbols.  (Contributed by Alan Sare, 24-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    idn1 $p |- (. ph ->. ph ). $=
      ( id dfvd1ir ) AAABC $.
  $}

  ${
    $d x ph $.  $d y ph $.  $d x y $.
    $( Quantification of two variables over a formula in which they do not
       occur.  (Contributed by Alan Sare, 12-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax172 $p |- ( ph -> A. x A. y ph ) $=
      ( wal ax-17 syl ) AACDZGBDACEGBEF $.
  $}

  ${
    $( Left-to-right part of definition of virtual deduction.  (Contributed by
       Alan Sare, 21-Apr-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd1imp $p |- ( (. ph ->. ps ). -> ( ph -> ps ) ) $=
      ( wvd1 wi df-vd1 biimpi ) ABCABDABEF $.
  $}

  ${
    $( Right-to-left part of definition of virtual deduction.  (Contributed by
       Alan Sare, 21-Apr-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd1impr $p |- ( ( ph -> ps ) -> (. ph ->. ps ). ) $=
      ( wvd1 wi df-vd1 biimpri ) ABCABDABEF $.
  $}

  ${
    $( Syntax for a 2-hypothesis virtual deduction.
       (New usage is discouraged.) $)
    wvd2 $a wff (. ph ,. ps ->. ch ). $.
  $}

  ${
    $( Definition of a 2-hypothesis virtual deduction.  (Contributed by Alan
       Sare, 14-Nov-2011.)  (New usage is discouraged.) $)
    df-vd2 $a |- ( (. ph ,. ps ->. ch ). <-> ( ( ph /\ ps ) -> ch ) ) $.
  $}

  ${
    $( Definition of a 2-hypothesis virtual deduction.  (Contributed by Alan
       Sare, 14-Nov-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd2 $p |- ( (. ph ,. ps ->. ch ). <-> ( ph -> ( ps -> ch ) ) ) $=
      ( wvd2 wa wi df-vd2 impexp bitri ) ABCDABECFABCFFABCGABCHI $.
  $}

  ${
    $( Syntax for a 2-virtual hypotheses collection.  (Contributed by Alan
       Sare, 23-Apr-2015.)  (New usage is discouraged.) $)
    wvhc2 $a wff (. ph ,. ps ). $.
  $}

  $( Definition of a 2-virtual hypotheses collection.  (Contributed by Alan
     Sare, 23-Apr-2015.)  (New usage is discouraged.) $)
  df-vhc2 $a |- ( (. ph ,. ps ). <-> ( ph /\ ps ) ) $.

  $( Definition of a 2-hypothesis virtual deduction in vd conjunction form.
     (Contributed by Alan Sare, 23-Apr-2015.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  dfvd2an $p |- ( (. (. ph ,. ps ). ->. ch ). <-> ( ( ph /\ ps ) -> ch ) ) $=
    ( wvhc2 wvd1 wi wa df-vd1 df-vhc2 imbi1i bitri ) ABDZCELCFABGZCFLCHLMCABIJK
    $.

  ${
    dfvd2ani.1 $e |- (. (. ph ,. ps ). ->. ch ). $.
    $( Inference form of ~ dfvd2an .  (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dfvd2ani $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wvhc2 wvd1 wa wi dfvd2an mpbi ) ABECFABGCHDABCIJ $.
  $}

  ${
    dfvd2anir.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Right-to-left inference form of ~ dfvd2an .  (Contributed by Alan Sare,
       23-Apr-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd2anir $p |- (. (. ph ,. ps ). ->. ch ). $=
      ( wvhc2 wvd1 wa wi dfvd2an mpbir ) ABECFABGCHDABCIJ $.
  $}

  ${
    dfvd2i.1 $e |- (. ph ,. ps ->. ch ). $.
    $( Inference form of ~ dfvd2 .  (Contributed by Alan Sare, 14-Nov-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dfvd2i $p |- ( ph -> ( ps -> ch ) ) $=
      ( wvd2 wi dfvd2 mpbi ) ABCEABCFFDABCGH $.
  $}

  ${
    dfvd2ir.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Right-to-left inference form of ~ dfvd2 .  (Contributed by Alan Sare,
       14-Nov-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd2ir $p |- (. ph ,. ps ->. ch ). $=
      ( wvd2 wi dfvd2 mpbir ) ABCEABCFFDABCGH $.
  $}

  ${
    $( Syntax for a 3-hypothesis virtual deduction.
       (New usage is discouraged.) $)
    wvd3 $a wff (. ph ,. ps ,. ch ->. th ). $.
  $}

  ${
    $( Syntax for a 3-virtual hypotheses collection.  (Contributed by Alan
       Sare, 13-Jun-2015.)  (New usage is discouraged.) $)
    wvhc3 $a wff (. ph ,. ps ,. ch ). $.
  $}

  $( Definition of a 3-virtual hypotheses collection.  (Contributed by Alan
     Sare, 13-Jun-2015.)  (New usage is discouraged.) $)
  df-vhc3 $a |- ( (. ph ,. ps ,. ch ). <-> ( ph /\ ps /\ ch ) ) $.

  ${
    $( Definition of a 3-hypothesis virtual deduction.  (Contributed by Alan
       Sare, 14-Nov-2011.)  (New usage is discouraged.) $)
    df-vd3 $a |- ( (. ph ,. ps ,. ch ->. th ). <->
                 ( ( ph /\ ps /\ ch ) -> th ) ) $.
  $}

  ${
    $( Definition of a 3-hypothesis virtual deduction.  (Contributed by Alan
       Sare, 14-Nov-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd3 $p |- ( (. ph ,. ps ,. ch ->. th ). <->
                 ( ph -> ( ps -> ( ch -> th ) ) ) ) $=
      ( wvd3 w3a wi df-vd3 wa df-3an imbi1i impexp bitri ) ABCDEABCFZDGZABCDGZG
      GZABCDHOABIZPGZQORCIZDGSNTDABCJKRCDLMABPLMM $.
  $}

  ${
    dfvd3i.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    $( Inference form of ~ dfvd3 .  (Contributed by Alan Sare, 14-Nov-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dfvd3i $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      ( wvd3 wi dfvd3 mpbi ) ABCDFABCDGGGEABCDHI $.
  $}

  ${
    dfvd3ir.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Right-to-left inference form of ~ dfvd3 .  (Contributed by Alan Sare,
       14-Nov-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd3ir $p |- (. ph ,. ps ,. ch ->. th ). $=
      ( wvd3 wi dfvd3 mpbir ) ABCDFABCDGGGEABCDHI $.
  $}

  $( Definition of a 3-hypothesis virtual deduction in vd conjunction form.
     (Contributed by Alan Sare, 13-Jun-2015.)
     (Proof modification is discouraged.)  (New usage is discouraged.) $)
  dfvd3an $p |- ( (. (. ph ,. ps ,. ch ). ->. th ). <->
                ( ( ph /\ ps /\ ch ) -> th ) ) $=
    ( wvhc3 wvd1 wi w3a df-vd1 df-vhc3 imbi1i bitri ) ABCEZDFMDGABCHZDGMDIMNDAB
    CJKL $.

  ${
    dfvd3ani.1 $e |- (. (. ph ,. ps ,. ch ). ->. th ). $.
    $( Inference form of ~ dfvd3an .  (Contributed by Alan Sare, 13-Jun-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dfvd3ani $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wvhc3 wvd1 w3a wi dfvd3an mpbi ) ABCFDGABCHDIEABCDJK $.
  $}

  ${
    dfvd3anir.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( Right-to-left inference form of ~ dfvd3an .  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd3anir $p |- (. (. ph ,. ps ,. ch ). ->. th ). $=
      ( wvhc3 wvd1 w3a wi dfvd3an mpbir ) ABCFDGABCHDIEABCDJK $.
  $}

  ${
    $( Syntax for a 4-virtual hypotheses collection.  (Contributed by Alan
       Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc4 $a wff (. ph ,. ps ,. ch ,. th ). $.
  $}

  ${
    $( Syntax for a 5-virtual hypotheses collection.  (Contributed by Alan
       Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc5 $a wff (. ph ,. ps ,. ch ,. th ,. ta ). $.
  $}

  ${
    $( Syntax for a 6-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc6 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ). $.
  $}

  ${
    $( Syntax for a 7-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc7 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ,. ze ). $.
  $}

  ${
    $( Syntax for an 8-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc8 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ,. ze ,. si ). $.
  $}

  ${
    $( Syntax for a 9-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc9 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ,. ze ,. si ,. rh ). $.
  $}

  ${
    $( Syntax for a 10-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc10 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ,.
                     ze ,. si ,. rh ,. mu ). $.
  $}

  ${
    $( Syntax for an 11-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc11 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ,.
                     ze ,. si ,. rh ,. mu ,. la ). $.
  $}

  ${
    $( Syntax for an 12-element virtual hypotheses collection.  (Contributed by
       Alan Sare, 17-Oct-2017.)  (New usage is discouraged.) $)
    wvhc12 $a wff (. ph ,. ps ,. ch ,. th ,. ta ,. et ,.
                     ze ,. si ,. rh ,. mu ,. la ,. ka ). $.
  $}

  ${
    vd01.1 $e |- ph $.
    $( A virtual hypothesis virtually infers a theorem.  (Contributed by Alan
       Sare, 14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    vd01 $p |- (. ps ->. ph ). $=
      ( a1i dfvd1ir ) BAABCDE $.
  $}

  ${
    vd02.1 $e |- ph $.
    $( 2 virtual hypotheses virtually infer a theorem.  (Contributed by Alan
       Sare, 14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    vd02 $p |- (. ps ,. ch ->. ph ). $=
      ( wi a1i dfvd2ir ) BCACAEBACDFFG $.
  $}

  ${
    vd03.1 $e |- ph $.
    $( A theorem is virtually inferred by the 3 virtual hypotheses.
       (Contributed by Alan Sare, 12-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    vd03 $p |- (. ps ,. ch ,. th ->. ph ). $=
      ( wi a1i dfvd3ir ) BCDACDAFZFBICADEGGGH $.
  $}

  ${
    vd12.1 $e |- (. ph ->. ps ). $.
    $( A virtual deduction with 1 virtual hypothesis virtually inferring a
       virtual conclusion infers that the same conclusion is virtually inferred
       by the same virtual hypothesis and an additional hypothesis.
       (Contributed by Alan Sare, 12-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    vd12 $p |- (. ph ,. ch ->. ps ). $=
      ( in1 a1d dfvd2ir ) ACBABCABDEFG $.
  $}

  ${
    vd13.1 $e |- (. ph ->. ps ). $.
    $( A virtual deduction with 1 virtual hypothesis virtually inferring a
       virtual conclusion infers that the same conclusion is virtually inferred
       by the same virtual hypothesis and a two additional hypotheses.
       (Contributed by Alan Sare, 12-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    vd13 $p |- (. ph ,. ch ,. th ->. ps ). $=
      ( in1 a1d a1dd dfvd3ir ) ACDBACBDABCABEFGHI $.
  $}

  ${
    vd23.1 $e |- (. ph ,. ps ->. ch ). $.
    $( A virtual deduction with 2 virtual hypotheses virtually inferring a
       virtual conclusion infers that the same conclusion is virtually inferred
       by the same 2 virtual hypotheses and a third hypothesis.  (Contributed
       by Alan Sare, 12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    vd23 $p |- (. ph ,. ps ,. th ->. ch ). $=
      ( dfvd2i a1dd dfvd3ir ) ABDCABCDABCEFGH $.
  $}

  ${
    $( The virtual deduction form of a 2-antecedent nested implication implies
       the 2-antecedent nested implication.  (Contributed by Alan Sare,
       21-Apr-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dfvd2imp $p |- ( (. ph ,. ps ->. ch ). -> ( ph -> ( ps -> ch ) ) ) $=
      ( wvd2 wi dfvd2 biimpi ) ABCDABCEEABCFG $.
  $}

  ${
    $( A 2-antecedent nested implication implies its virtual deduction form.
       (Contributed by Alan Sare, 21-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    dfvd2impr $p |- ( ( ph -> ( ps -> ch ) ) -> (. ph ,. ps ->. ch ). ) $=
      ( wvd2 wi dfvd2 biimpri ) ABCDABCEEABCFG $.
  $}

  ${
    in2.1 $e |- (. ph ,. ps ->. ch ). $.
    $( The virtual deduction introduction rule of converting the end virtual
       hypothesis of 2 virtual hypotheses into an antecedent.  (Contributed by
       Alan Sare, 21-Apr-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    in2 $p |- (. ph ->. ( ps -> ch ) ). $=
      ( wi dfvd2i dfvd1ir ) ABCEABCDFG $.
  $}

  ${
    int2.1 $e |- (. (. ph ,. ps ). ->. ch ). $.
    $( The virtual deduction introduction rule of converting the end virtual
       hypothesis of 2 virtual hypotheses into an antecedent.  Conventional
       form of ~ int2 is ~ ex .  (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    int2 $p |- (. ph ->. ( ps -> ch ) ). $=
      ( wi dfvd2ani ex dfvd1ir ) ABCEABCABCDFGH $.
  $}

  ${
    iin2.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( ~ in2 without virtual deductions.  (Contributed by Alan Sare,
       20-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    iin2 $p |- ( ph -> ( ps -> ch ) ) $=
      (  ) D $.
  $}

  ${
    in2an.1 $e |- (. ph ,. ( ps /\ ch ) ->. th ). $.
    $( The virtual deduction introduction rule converting the second conjunct
       of the second virtual hypothesis into the antecedent of the conclusion.
       ~ exp3a is the non-virtual deduction form of ~ in2an .  (Contributed by
       Alan Sare, 30-Jun-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    in2an $p |- (. ph ,. ps ->. ( ch -> th ) ). $=
      ( wi wa dfvd2i exp3a dfvd2ir ) ABCDFABCDABCGDEHIJ $.
  $}

  ${
    in3.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    $( The virtual deduction introduction rule of converting the end virtual
       hypothesis of 3 virtual hypotheses into an antecedent.  (Contributed by
       Alan Sare, 12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    in3 $p |- (. ph ,. ps ->. ( ch -> th ) ). $=
      ( wi dfvd3i dfvd2ir ) ABCDFABCDEGH $.
  $}

  ${
    iin3.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( ~ in3 without virtual deduction connectives.  Special theorem needed for
       Alan Sare's virtual deduction translation tool.  (Contributed by Alan
       Sare, 23-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    iin3 $p |- ( ph -> ( ps -> ( ch -> th ) ) ) $=
      (  ) E $.
  $}

  ${
    in3an.1 $e |- (. ph ,. ps ,. ( ch /\ th ) ->. ta ). $.
    $( The virtual deduction introduction rule converting the second conjunct
       of the third virtual hypothesis into the antecedent of the conclusion.
       ~ exp4a is the non-virtual deduction form of ~ in3an .  (Contributed by
       Alan Sare, 25-Jun-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    in3an $p |- (. ph ,. ps ,. ch ->. ( th -> ta ) ). $=
      ( wi wa dfvd3i exp4a dfvd3ir ) ABCDEGABCDEABCDHEFIJK $.
  $}

  ${
    int3.1 $e |- (. (. ph ,. ps ,. ch ). ->. th ). $.
    $( The virtual deduction introduction rule of converting the end virtual
       hypothesis of 3 virtual hypotheses into an antecedent.  Conventional
       form of ~ int3 is ~ 3expia .  (Contributed by Alan Sare, 13-Jun-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    int3 $p |- (. (. ph ,. ps ). ->. ( ch -> th ) ). $=
      ( wi dfvd3ani 3expia dfvd2anir ) ABCDFABCDABCDEGHI $.
  $}

  ${
    $( Virtual deduction identity rule which is ~ idd with virtual deduction
       symbols.  (Contributed by Alan Sare, 21-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    idn2 $p |- (. ph ,. ps ->. ps ). $=
      ( idd dfvd2ir ) ABBABCD $.
  $}

  ${
    $( Virtual deduction identity rule. ~ simpr in conjunction form Virtual
       Deduction notation.  (Contributed by Alan Sare, 5-Sep-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    iden2 $p |- (. (. ph ,. ps ). ->. ps ). $=
      ( wvhc2 wvd1 wa wi simpr dfvd2an mpbir ) ABCBDABEBFABGABBHI $.
  $}

  ${
    $( Virtual deduction identity rule for 3 virtual hypotheses.  (Contributed
       by Alan Sare, 11-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    idn3 $p |- (. ph ,. ps ,. ch ->. ch ). $=
      ( wi idd a1i dfvd3ir ) ABCCBCCDDABCEFG $.
  $}

  ${
    $d x ph $.
    gen11.1 $e |- (. ph ->. ps ). $.
    $( Virtual deduction generalizing rule for 1 quantifying variable and 1
       virtual hypothesis. ~ alrimiv is ~ gen11 without virtual deductions.
       (Contributed by Alan Sare, 21-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    gen11 $p |- (. ph ->. A. x ps ). $=
      ( wal wi wvd1 dfvd1imp ax-mp alrimiv dfvd1impr ) ABCEZFALGABCABGABFDABHIJ
      ALKI $.
  $}

  ${
    gen11nv.1 $e |- ( ph -> A. x ph ) $.
    gen11nv.2 $e |- (. ph ->. ps ). $.
    $( Virtual deduction generalizing rule for 1 quantifying variable and 1
       virtual hypothesis without distinct variables. ~ alrimih is ~ gen11nv
       without virtual deductions.  (Contributed by Alan Sare, 12-Dec-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    gen11nv $p |- (. ph ->. A. x ps ). $=
      ( wal in1 alrimih dfvd1ir ) ABCFABCDABEGHI $.
  $}

  ${
    $d x ph $.  $d y ph $.
    gen12.1 $e |- (. ph ->. ps ). $.
    $( Virtual deduction generalizing rule for 2 quantifying variables and 1
       virtual hypothesis. ~ gen12 is ~ alrimivv with virtual deductions.
       (Contributed by Alan Sare, 2-May-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    gen12 $p |- (. ph ->. A. x A. y ps ). $=
      ( wal in1 alrimivv dfvd1ir ) ABDFCFABCDABEGHI $.
  $}

  ${
    $d x ph $.  $d x ps $.
    gen21.1 $e |- (. ph ,. ps ->. ch ). $.
    $( Virtual deduction generalizing rule for 1 quantifying variables and 2
       virtual hypothesis. ~ gen21 is ~ alrimdv with virtual deductions.
       (Contributed by Alan Sare, 25-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    gen21 $p |- (. ph ,. ps ->. A. x ch ). $=
      ( wal dfvd2i alrimdv dfvd2ir ) ABCDFABCDABCEGHI $.
  $}

  ${
    gen21nv.1 $e |- ( ph -> A. x ph ) $.
    gen21nv.2 $e |- ( ps -> A. x ps ) $.
    gen21nv.3 $e |- (. ph ,. ps ->. ch ). $.
    $( Virtual deduction form of ~ alrimdh .  (Contributed by Alan Sare,
       31-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    gen21nv $p |- (. ph ,. ps ->. A. x ch ). $=
      ( wal dfvd2i alrimdh dfvd2ir ) ABCDHABCDEFABCGIJK $.
  $}

  ${
    $d ch x $.  $d ph x $.  $d ps x $.
    gen31.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    $( Virtual deduction generalizing rule for 1 quantifying variable and 3
       virtual hypothesis. ~ gen31 is ~ ggen31 with virtual deductions.
       (Contributed by Alan Sare, 22-Jun-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    gen31 $p |- (. ph ,. ps ,. ch ->. A. x th ). $=
      ( wal dfvd3i ggen31 dfvd3ir ) ABCDEGABCDEABCDFHIJ $.
  $}

  ${
    $d x ph $.  $d y ph $.  $d x ps $.  $d y ps $.
    gen22.1 $e |- (. ph ,. ps ->. ch ). $.
    $( Virtual deduction generalizing rule for 2 quantifying variables and 2
       virtual hypothesis.  (Contributed by Alan Sare, 25-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    gen22 $p |- (. ph ,. ps ->. A. x A. y ch ). $=
      ( wal dfvd2i alrimdv dfvd2ir ) ABCEGZDGABKDABCEABCFHIIJ $.
  $}

  ${
    $d x ph $.  $d y ph $.  $d x ps $.  $d y ps $.
    ggen22.1 $e |- ( ph -> ( ps -> ch ) ) $.
    $( ~ gen22 without virtual deductions.  (Contributed by Alan Sare,
       25-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ggen22 $p |- ( ph -> ( ps -> A. x A. y ch ) ) $=
      ( wal alrimdv ) ABCEGDABCEFHH $.
  $}

  ${
    exinst.1 $e |- ( ps -> A. x ps ) $.
    exinst.2 $e |- (. E. x ph ,. ph ->. ps ). $.
    $( Existential Instantiation.  Virtual deduction form of ~ exlimexi .
       (Contributed by Alan Sare, 21-Apr-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    exinst $p |- ( E. x ph -> ps ) $=
      ( wex dfvd2i exlimexi ) ABCDACFABEGH $.
  $}

  ${
    exinst01.1 $e |- E. x ps $.
    exinst01.2 $e |- (. ph ,. ps ->. ch ). $.
    exinst01.3 $e |- ( ph -> A. x ph ) $.
    exinst01.4 $e |- ( ch -> A. x ch ) $.
    $( Existential Instantiation.  Virtual Deduction rule corresponding to a
       special case of the Natural Deduction Sequent Calculus rule called Rule
       C in [Margaris] p. 79 and E ` E. ` in Table 1 on page 4 of the paper
       "Extracting information from intermediate T-systems" (2000) presented at
       IMLA99 by Mauro Ferrari, Camillo Fiorentini, and Pierangelo Miglioli.
       (Contributed by Alan Sare, 21-Apr-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    exinst01 $p |- (. ph ->. ch ). $=
      ( dfvd2i eexinst01 dfvd1ir ) ACABCDEABCFIGHJK $.
  $}

  ${
    exinst11.1 $e |- (. ph ->. E. x ps ). $.
    exinst11.2 $e |- (. ph ,. ps ->. ch ). $.
    exinst11.3 $e |- ( ph -> A. x ph ) $.
    exinst11.4 $e |- ( ch -> A. x ch ) $.
    $( Existential Instantiation.  Virtual Deduction rule corresponding to a
       special case of the Natural Deduction Sequent Calculus rule called Rule
       C in [Margaris] p. 79 and E ` E. ` in Table 1 on page 4 of the paper
       "Extracting information from intermediate T-systems" (2000) presented at
       IMLA99 by Mauro Ferrari, Camillo Fiorentini, and Pierangelo Miglioli.
       (Contributed by Alan Sare, 21-Apr-2013.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    exinst11 $p |- (. ph ->. ch ). $=
      ( wex in1 dfvd2i eexinst11 dfvd1ir ) ACABCDABDIEJABCFKGHLM $.
  $}

  ${
    e1_.1 $e |- (. ph ->. ps ). $.
    e1_.2 $e |- ( ps -> ch ) $.
    $( A Virtual deduction elimination rule. ~ syl is ~ e1_ without virtual
       deductions.  (Contributed by Alan Sare, 11-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e1_ $p |- (. ph ->. ch ). $=
      ( in1 syl dfvd1ir ) ACABCABDFEGH $.
  $}

  ${
    el1.1 $e |- (. ph ->. ps ). $.
    el1.2 $e |- ( ps -> ch ) $.
    $( A Virtual deduction elimination rule. ~ syl is ~ el1 without virtual
       deductions.  (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    el1 $p |- (. ph ->. ch ). $=
      ( in1 syl dfvd1ir ) ACABCABDFEGH $.
  $}

  ${
    e1bi.1 $e |- (. ph ->. ps ). $.
    e1bi.2 $e |- ( ps <-> ch ) $.
    $( Biconditional form of ~ e1_ . ~ sylib is ~ e1bi without virtual
       deductions.  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e1bi $p |- (. ph ->. ch ). $=
      ( biimpi e1_ ) ABCDBCEFG $.
  $}

  ${
    e1bir.1 $e |- (. ph ->. ps ). $.
    e1bir.2 $e |- ( ch <-> ps ) $.
    $( Right biconditional form of ~ e1_ . ~ sylibr is ~ e1bir without virtual
       deductions.  (Contributed by Alan Sare, 24-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e1bir $p |- (. ph ->. ch ). $=
      ( biimpri e1_ ) ABCDCBEFG $.
  $}

  ${
    e2.1 $e |- (. ph ,. ps ->. ch ). $.
    e2.2 $e |- ( ch -> th ) $.
    $( A virtual deduction elimination rule. ~ syl6 is ~ e2 without virtual
       deductions.  (Contributed by Alan Sare, 21-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e2 $p |- (. ph ,. ps ->. th ). $=
      ( dfvd2i syl6 dfvd2ir ) ABDABCDABCEGFHI $.
  $}

  ${
    e2bi.1 $e |- (. ph ,. ps ->. ch ). $.
    e2bi.2 $e |- ( ch <-> th ) $.
    $( Bi-conditional form of ~ e2 . ~ syl6ib is ~ e2bi without virtual
       deductions.  (Contributed by Alan Sare, 10-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e2bi $p |- (. ph ,. ps ->. th ). $=
      ( biimpi e2 ) ABCDECDFGH $.
  $}

  ${
    e2bir.1 $e |- (. ph ,. ps ->. ch ). $.
    e2bir.2 $e |- ( th <-> ch ) $.
    $( Right bi-conditional form of ~ e2 . ~ syl6ibr is ~ e2bir without virtual
       deductions.  (Contributed by Alan Sare, 29-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e2bir $p |- (. ph ,. ps ->. th ). $=
      ( biimpri e2 ) ABCDEDCFGH $.
  $}

  ${
    ee223.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee223.2 $e |- ( ph -> ( ps -> th ) ) $.
    ee223.3 $e |- ( ph -> ( ps -> ( ta -> et ) ) ) $.
    ee223.4 $e |- ( ch -> ( th -> ( et -> ze ) ) ) $.
    $( ~ e223 without virtual deductions.  (Contributed by Alan Sare,
       12-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee223 $p |- ( ph -> ( ps -> ( ta -> ze ) ) ) $=
      ( wi syl6 com34 com23 com12 syl8 pm2.43a pm2.43d mpdd ) ABDEGLIABEDGABEDG
      LZLABEBUABAEBUALZLABEAUBABEFAUBLJAFUBABFUAABDFGABCDFGLLHKMNOPQNRNSNT $.
  $}

  ${
    e223.1 $e |- (. ph ,. ps ->. ch ). $.
    e223.2 $e |- (. ph ,. ps ->. th ). $.
    e223.3 $e |- (. ph ,. ps ,. ta ->. et ). $.
    e223.4 $e |- ( ch -> ( th -> ( et -> ze ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Dec-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e223 $p |- (. ph ,. ps ,. ta ->. ze ). $=
      ( wi in2 in1 in3 ee223 dfvd3ir ) ABEGABCDEFGABCLABCHMNABDLABDIMNABEFLZLAB
      RABEFJOMNKPQ $.
  $}

  ${
    e222.1 $e |- (. ph ,. ps ->. ch ). $.
    e222.2 $e |- (. ph ,. ps ->. th ). $.
    e222.3 $e |- (. ph ,. ps ->. ta ). $.
    e222.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e222 $p |- (. ph ,. ps ->. et ). $=
      ( wa dfvd2i imp wi syl2im pm2.43i syl5com ex dfvd2ir ) ABFABFABKZFTETFABE
      ABEILMTEFNZTCTDUAABCABCGLMABDABDHLMJOPQPRS $.
  $}

  ${
    e220.1 $e |- (. ph ,. ps ->. ch ). $.
    e220.2 $e |- (. ph ,. ps ->. th ). $.
    e220.3 $e |- ta $.
    e220.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e220 $p |- (. ph ,. ps ->. et ). $=
      ( vd02 e222 ) ABCDEFGHEABIKJL $.
  $}

  ${
    ee220.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee220.2 $e |- ( ph -> ( ps -> th ) ) $.
    ee220.3 $e |- ta $.
    ee220.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e220 without virtual deductions.  (Contributed by Alan Sare,
       12-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee220 $p |- ( ph -> ( ps -> et ) ) $=
      ( a1ii ee222 ) ABCDEFGHABEIKJL $.
  $}

  ${
    e202.1 $e |- (. ph ,. ps ->. ch ). $.
    e202.2 $e |- th $.
    e202.3 $e |- (. ph ,. ps ->. ta ). $.
    e202.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e202 $p |- (. ph ,. ps ->. et ). $=
      ( vd02 e222 ) ABCDEFGDABHKIJL $.
  $}

  ${
    ee202.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee202.2 $e |- th $.
    ee202.3 $e |- ( ph -> ( ps -> ta ) ) $.
    ee202.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e202 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee202 $p |- ( ph -> ( ps -> et ) ) $=
      ( wi a1i ee222 ) ABCDEFGBDKADBHLLIJM $.
  $}

  ${
    e022.1 $e |- ph $.
    e022.2 $e |- (. ps ,. ch ->. th ). $.
    e022.3 $e |- (. ps ,. ch ->. ta ). $.
    e022.4 $e |- ( ph -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e022 $p |- (. ps ,. ch ->. et ). $=
      ( vd02 e222 ) BCADEFABCGKHIJL $.
  $}

  ${
    ee022.1 $e |- ph $.
    ee022.2 $e |- ( ps -> ( ch -> th ) ) $.
    ee022.3 $e |- ( ps -> ( ch -> ta ) ) $.
    ee022.4 $e |- ( ph -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e022 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee022 $p |- ( ps -> ( ch -> et ) ) $=
      ( wi a1i ee222 ) BCADEFCAKBACGLLHIJM $.
  $}

  ${
    e002.1 $e |- ph $.
    e002.2 $e |- ps $.
    e002.3 $e |- (. ch ,. th ->. ta ). $.
    e002.4 $e |- ( ph -> ( ps -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e002 $p |- (. ch ,. th ->. et ). $=
      ( vd02 e222 ) CDABEFACDGKBCDHKIJL $.
  $}

  ${
    ee002.1 $e |- ph $.
    ee002.2 $e |- ps $.
    ee002.3 $e |- ( ch -> ( th -> ta ) ) $.
    ee002.4 $e |- ( ph -> ( ps -> ( ta -> et ) ) ) $.
    $( ~ e002 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee002 $p |- ( ch -> ( th -> et ) ) $=
      ( wi a1i ee222 ) CDABEFDAKCADGLLDBKCBDHLLIJM $.
  $}

  ${
    e020.1 $e |- ph $.
    e020.2 $e |- (. ps ,. ch ->. th ). $.
    e020.3 $e |- ta $.
    e020.4 $e |- ( ph -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e020 $p |- (. ps ,. ch ->. et ). $=
      ( vd02 e222 ) BCADEFABCGKHEBCIKJL $.
  $}

  ${
    ee020.1 $e |- ph $.
    ee020.2 $e |- ( ps -> ( ch -> th ) ) $.
    ee020.3 $e |- ta $.
    ee020.4 $e |- ( ph -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e020 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee020 $p |- ( ps -> ( ch -> et ) ) $=
      ( wi a1i ee222 ) BCADEFCAKBACGLLHCEKBECILLJM $.
  $}

  ${
    e200.1 $e |- (. ph ,. ps ->. ch ). $.
    e200.2 $e |- th $.
    e200.3 $e |- ta $.
    e200.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e200 $p |- (. ph ,. ps ->. et ). $=
      ( vd02 e222 ) ABCDEFGDABHKEABIKJL $.
  $}

  ${
    ee200.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee200.2 $e |- th $.
    ee200.3 $e |- ta $.
    ee200.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e200 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee200 $p |- ( ph -> ( ps -> et ) ) $=
      ( wi a1i ee222 ) ABCDEFGBDKADBHLLBEKAEBILLJM $.
  $}

  ${
    e221.1 $e |- (. ph ,. ps ->. ch ). $.
    e221.2 $e |- (. ph ,. ps ->. th ). $.
    e221.3 $e |- (. ph ->. ta ). $.
    e221.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e221 $p |- (. ph ,. ps ->. et ). $=
      ( vd12 e222 ) ABCDEFGHAEBIKJL $.
  $}

  ${
    ee221.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee221.2 $e |- ( ph -> ( ps -> th ) ) $.
    ee221.3 $e |- ( ph -> ta ) $.
    ee221.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e221 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee221 $p |- ( ph -> ( ps -> et ) ) $=
      ( a1d ee222 ) ABCDEFGHAEBIKJL $.
  $}

  ${
    e212.1 $e |- (. ph ,. ps ->. ch ). $.
    e212.2 $e |- (. ph ->. th ). $.
    e212.3 $e |- (. ph ,. ps ->. ta ). $.
    e212.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e212 $p |- (. ph ,. ps ->. et ). $=
      ( vd12 e222 ) ABCDEFGADBHKIJL $.
  $}

  ${
    ee212.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee212.2 $e |- ( ph -> th ) $.
    ee212.3 $e |- ( ph -> ( ps -> ta ) ) $.
    ee212.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e212 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee212 $p |- ( ph -> ( ps -> et ) ) $=
      ( a1d ee222 ) ABCDEFGADBHKIJL $.
  $}

  ${
    e122.1 $e |- (. ph ->. ps ). $.
    e122.2 $e |- (. ph ,. ch ->. th ). $.
    e122.3 $e |- (. ph ,. ch ->. ta ). $.
    e122.4 $e |- ( ps -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e122 $p |- (. ph ,. ch ->. et ). $=
      ( vd12 e222 ) ACBDEFABCGKHIJL $.
  $}

  ${
    e112.1 $e |- (. ph ->. ps ). $.
    e112.2 $e |- (. ph ->. ch ). $.
    e112.3 $e |- (. ph ,. th ->. ta ). $.
    e112.4 $e |- ( ps -> ( ch -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e112 $p |- (. ph ,. th ->. et ). $=
      ( vd12 e222 ) ADBCEFABDGKACDHKIJL $.
  $}

  ${
    ee112.1 $e |- ( ph -> ps ) $.
    ee112.2 $e |- ( ph -> ch ) $.
    ee112.3 $e |- ( ph -> ( th -> ta ) ) $.
    ee112.4 $e |- ( ps -> ( ch -> ( ta -> et ) ) ) $.
    $( ~ e112 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee112 $p |- ( ph -> ( th -> et ) ) $=
      ( a1d ee222 ) ADBCEFABDGKACDHKIJL $.
  $}

  ${
    e121.1 $e |- (. ph ->. ps ). $.
    e121.2 $e |- (. ph ,. ch ->. th ). $.
    e121.3 $e |- (. ph ->. ta ). $.
    e121.4 $e |- ( ps -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e121 $p |- (. ph ,. ch ->. et ). $=
      ( vd12 e222 ) ACBDEFABCGKHAECIKJL $.
  $}

  ${
    e211.1 $e |- (. ph ,. ps ->. ch ). $.
    e211.2 $e |- (. ph ->. th ). $.
    e211.3 $e |- (. ph ->. ta ). $.
    e211.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e211 $p |- (. ph ,. ps ->. et ). $=
      ( vd12 e222 ) ABCDEFGADBHKAEBIKJL $.
  $}

  ${
    ee211.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee211.2 $e |- ( ph -> th ) $.
    ee211.3 $e |- ( ph -> ta ) $.
    ee211.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e211 without virtual deductions.  (Contributed by Alan Sare,
       13-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee211 $p |- ( ph -> ( ps -> et ) ) $=
      ( a1d ee222 ) ABCDEFGADBHKAEBIKJL $.
  $}

  ${
    e210.1 $e |- (. ph ,. ps ->. ch ). $.
    e210.2 $e |- (. ph ->. th ). $.
    e210.3 $e |- ta $.
    e210.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e210 $p |- (. ph ,. ps ->. et ). $=
      ( vd01 e211 ) ABCDEFGHEAIKJL $.
  $}

  ${
    ee210.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee210.2 $e |- ( ph -> th ) $.
    ee210.3 $e |- ta $.
    ee210.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e210 without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee210 $p |- ( ph -> ( ps -> et ) ) $=
      ( a1d wi a1i ee222 ) ABCDEFGADBHKBELAEBIMMJN $.
  $}

  ${
    e201.1 $e |- (. ph ,. ps ->. ch ). $.
    e201.2 $e |- th $.
    e201.3 $e |- (. ph ->. ta ). $.
    e201.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e201 $p |- (. ph ,. ps ->. et ). $=
      ( vd01 e211 ) ABCDEFGDAHKIJL $.
  $}

  ${
    ee201.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee201.2 $e |- th $.
    ee201.3 $e |- ( ph -> ta ) $.
    ee201.4 $e |- ( ch -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e201 without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee201 $p |- ( ph -> ( ps -> et ) ) $=
      ( wi a1i a1d ee222 ) ABCDEFGBDKADBHLLAEBIMJN $.
  $}

  ${
    e120.1 $e |- (. ph ->. ps ). $.
    e120.2 $e |- (. ph ,. ch ->. th ). $.
    e120.3 $e |- ta $.
    e120.4 $e |- ( ps -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       10-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e120 $p |- (. ph ,. ch ->. et ). $=
      ( vd12 e220 ) ACBDEFABCGKHIJL $.
  $}

  ${
    ee120.1 $e |- ( ph -> ps ) $.
    ee120.2 $e |- ( ph -> ( ch -> th ) ) $.
    ee120.3 $e |- ta $.
    ee120.4 $e |- ( ps -> ( th -> ( ta -> et ) ) ) $.
    $( Virtual deduction rule ~ e120 without virtual deduction symbols.
       (Contributed by Alan Sare, 14-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee120 $p |- ( ph -> ( ch -> et ) ) $=
      ( a1d wi a1i ee222 ) ACBDEFABCGKHCELAECIMMJN $.
  $}

  ${
    e021.1 $e |- ph $.
    e021.2 $e |- (. ps ,. ch ->. th ). $.
    e021.3 $e |- (. ps ->. ta ). $.
    e021.4 $e |- ( ph -> ( th -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e021 $p |- (. ps ,. ch ->. et ). $=
      ( vd01 e121 ) BACDEFABGKHIJL $.
  $}

  ${
    ee021.1 $e |- ph $.
    ee021.2 $e |- ( ps -> ( ch -> th ) ) $.
    ee021.3 $e |- ( ps -> ta ) $.
    ee021.4 $e |- ( ph -> ( th -> ( ta -> et ) ) ) $.
    $( ~ e021 without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee021 $p |- ( ps -> ( ch -> et ) ) $=
      ( wi a1i a1d ee222 ) BCADEFCAKBACGLLHBECIMJN $.
  $}

  ${
    e012.1 $e |- ph $.
    e012.2 $e |- (. ps ->. ch ). $.
    e012.3 $e |- (. ps ,. th ->. ta ). $.
    e012.4 $e |- ( ph -> ( ch -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e012 $p |- (. ps ,. th ->. et ). $=
      ( vd01 e112 ) BACDEFABGKHIJL $.
  $}

  ${
    ee012.1 $e |- ph $.
    ee012.2 $e |- ( ps -> ch ) $.
    ee012.3 $e |- ( ps -> ( th -> ta ) ) $.
    ee012.4 $e |- ( ph -> ( ch -> ( ta -> et ) ) ) $.
    $( ~ e012 without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee012 $p |- ( ps -> ( th -> et ) ) $=
      ( wi a1i a1d ee222 ) BDACEFDAKBADGLLBCDHMIJN $.
  $}

  ${
    e102.1 $e |- (. ph ->. ps ). $.
    e102.2 $e |- ch $.
    e102.3 $e |- (. ph ,. th ->. ta ). $.
    e102.4 $e |- ( ps -> ( ch -> ( ta -> et ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e102 $p |- (. ph ,. th ->. et ). $=
      ( vd01 e112 ) ABCDEFGCAHKIJL $.
  $}

  ${
    ee102.1 $e |- ( ph -> ps ) $.
    ee102.2 $e |- ch $.
    ee102.3 $e |- ( ph -> ( th -> ta ) ) $.
    ee102.4 $e |- ( ps -> ( ch -> ( ta -> et ) ) ) $.
    $( ~ e102 without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee102 $p |- ( ph -> ( th -> et ) ) $=
      ( a1d wi a1i ee222 ) ADBCEFABDGKDCLACDHMMIJN $.
  $}

  ${
    e22.1 $e |- (. ph ,. ps ->. ch ). $.
    e22.2 $e |- (. ph ,. ps ->. th ). $.
    e22.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       2-May-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e22 $p |- (. ph ,. ps ->. ta ). $=
      ( wi a1i e222 ) ABCCDEFFGCDEIICHJK $.
  $}

  ${
    e22an.1 $e |- (. ph ,. ps ->. ch ). $.
    e22an.2 $e |- (. ph ,. ps ->. th ). $.
    e22an.3 $e |- ( ( ch /\ th ) -> ta ) $.
    $( Conjunction form of ~ e22 .  (Contributed by Alan Sare, 11-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e22an $p |- (. ph ,. ps ->. ta ). $=
      ( ex e22 ) ABCDEFGCDEHIJ $.
  $}

  ${
    ee22an.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee22an.2 $e |- ( ph -> ( ps -> th ) ) $.
    ee22an.3 $e |- ( ( ch /\ th ) -> ta ) $.
    $( ~ e22an without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee22an $p |- ( ph -> ( ps -> ta ) ) $=
      ( ex ee22 ) ABCDEFGCDEHIJ $.
  $}

  ${
    e111.1 $e |- (. ph ->. ps ). $.
    e111.2 $e |- (. ph ->. ch ). $.
    e111.3 $e |- (. ph ->. th ). $.
    e111.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e111 $p |- (. ph ->. ta ). $=
      ( in1 wi syl2im pm2.43i syl5com dfvd1ir ) AEAEADAEADHJADEKZABACPABFJACGJI
      LMNMO $.
  $}

  ${
    e1111.1 $e |- (. ph ->. ps ). $.
    e1111.2 $e |- (. ph ->. ch ). $.
    e1111.3 $e |- (. ph ->. th ). $.
    e1111.4 $e |- (. ph ->. ta ). $.
    e1111.5 $e |- ( ps -> ( ch -> ( th -> ( ta -> et ) ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       6-Mar-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e1111 $p |- (. ph ->. et ). $=
      ( in1 ee1111 dfvd1ir ) AFABCDEFABGLACHLADILAEJLKMN $.
  $}

  ${
    e110.1 $e |- (. ph ->. ps ). $.
    e110.2 $e |- (. ph ->. ch ). $.
    e110.3 $e |- th $.
    e110.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e110 $p |- (. ph ->. ta ). $=
      ( vd01 e111 ) ABCDEFGDAHJIK $.
  $}

  ${
    ee110.1 $e |- ( ph -> ps ) $.
    ee110.2 $e |- ( ph -> ch ) $.
    ee110.3 $e |- th $.
    ee110.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( ~ e110 without virtual deductions.  (Contributed by Alan Sare,
       22-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee110 $p |- ( ph -> ta ) $=
      ( a1i syl3c ) ABCDEFGDAHJIK $.
  $}

  ${
    e101.1 $e |- (. ph ->. ps ). $.
    e101.2 $e |- ch $.
    e101.3 $e |- (. ph ->. th ). $.
    e101.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e101 $p |- (. ph ->. ta ). $=
      ( vd01 e111 ) ABCDEFCAGJHIK $.
  $}

  ${
    ee101.1 $e |- ( ph -> ps ) $.
    ee101.2 $e |- ch $.
    ee101.3 $e |- ( ph -> th ) $.
    ee101.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( ~ e101 without virtual deductions.  (Contributed by Alan Sare,
       23-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee101 $p |- ( ph -> ta ) $=
      ( a1i syl3c ) ABCDEFCAGJHIK $.
  $}

  ${
    e011.1 $e |- ph $.
    e011.2 $e |- (. ps ->. ch ). $.
    e011.3 $e |- (. ps ->. th ). $.
    e011.4 $e |- ( ph -> ( ch -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e011 $p |- (. ps ->. ta ). $=
      ( vd01 e111 ) BACDEABFJGHIK $.
  $}

  ${
    ee011.1 $e |- ph $.
    ee011.2 $e |- ( ps -> ch ) $.
    ee011.3 $e |- ( ps -> th ) $.
    ee011.4 $e |- ( ph -> ( ch -> ( th -> ta ) ) ) $.
    $( ~ e011 without virtual deductions.  (Contributed by Alan Sare,
       25-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee011 $p |- ( ps -> ta ) $=
      ( a1i syl3c ) BACDEABFJGHIK $.
  $}

  ${
    e100.1 $e |- (. ph ->. ps ). $.
    e100.2 $e |- ch $.
    e100.3 $e |- th $.
    e100.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e100 $p |- (. ph ->. ta ). $=
      ( vd01 e111 ) ABCDEFCAGJDAHJIK $.
  $}

  ${
    ee100.1 $e |- ( ph -> ps ) $.
    ee100.2 $e |- ch $.
    ee100.3 $e |- th $.
    ee100.4 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    $( ~ e100 without virtual deductions.  (Contributed by Alan Sare,
       23-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee100 $p |- ( ph -> ta ) $=
      ( a1i syl3c ) ABCDEFCAGJDAHJIK $.
  $}

  ${
    e010.1 $e |- ph $.
    e010.2 $e |- (. ps ->. ch ). $.
    e010.3 $e |- th $.
    e010.4 $e |- ( ph -> ( ch -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e010 $p |- (. ps ->. ta ). $=
      ( vd01 e111 ) BACDEABFJGDBHJIK $.
  $}

  ${
    ee010.1 $e |- ph $.
    ee010.2 $e |- ( ps -> ch ) $.
    ee010.3 $e |- th $.
    ee010.4 $e |- ( ph -> ( ch -> ( th -> ta ) ) ) $.
    $( ~ e010 without virtual deductions.  (Contributed by Alan Sare,
       23-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee010 $p |- ( ps -> ta ) $=
      ( a1i syl3c ) BACDEABFJGDBHJIK $.
  $}

  ${
    e001.1 $e |- ph $.
    e001.2 $e |- ps $.
    e001.3 $e |- (. ch ->. th ). $.
    e001.4 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e001 $p |- (. ch ->. ta ). $=
      ( vd01 e111 ) CABDEACFJBCGJHIK $.
  $}

  ${
    ee001.1 $e |- ph $.
    ee001.2 $e |- ps $.
    ee001.3 $e |- ( ch -> th ) $.
    ee001.4 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    $( ~ e001 without virtual deductions.  (Contributed by Alan Sare,
       23-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee001 $p |- ( ch -> ta ) $=
      ( a1i syl3c ) CABDEACFJBCGJHIK $.
  $}

  ${
    e11.1 $e |- (. ph ->. ps ). $.
    e11.2 $e |- (. ph ->. ch ). $.
    e11.3 $e |- ( ps -> ( ch -> th ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e11 $p |- (. ph ->. th ). $=
      ( wi a1i e111 ) ABBCDEEFBCDHHBGIJ $.
  $}

  ${
    e11an.1 $e |- (. ph ->. ps ). $.
    e11an.2 $e |- (. ph ->. ch ). $.
    e11an.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( Conjunction form of ~ e11 .  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e11an $p |- (. ph ->. th ). $=
      ( ex e11 ) ABCDEFBCDGHI $.
  $}

  ${
    ee11an.1 $e |- ( ph -> ps ) $.
    ee11an.2 $e |- ( ph -> ch ) $.
    ee11an.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( ~ e11an without virtual deductions. ~ syl22anc is also ~ e11an without
       virtual deductions, exept with a different order of hypotheses.
       (Contributed by Alan Sare, 8-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee11an $p |- ( ph -> th ) $=
      ( ex sylc ) ABCDEFBCDGHI $.
  $}

  ${
    e01.1 $e |- ph $.
    e01.2 $e |- (. ps ->. ch ). $.
    e01.3 $e |- ( ph -> ( ch -> th ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       25-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e01 $p |- (. ps ->. th ). $=
      ( vd01 e11 ) BACDABEHFGI $.
  $}

  ${
    e01an.1 $e |- ph $.
    e01an.2 $e |- (. ps ->. ch ). $.
    e01an.3 $e |- ( ( ph /\ ch ) -> th ) $.
    $( Conjunction form of ~ e01 .  (Contributed by Alan Sare, 11-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e01an $p |- (. ps ->. th ). $=
      ( ex e01 ) ABCDEFACDGHI $.
  $}

  ${
    ee01an.1 $e |- ph $.
    ee01an.2 $e |- ( ps -> ch ) $.
    ee01an.3 $e |- ( ( ph /\ ch ) -> th ) $.
    $( ~ e01an without virtual deductions. ~ sylancr is also a form of ~ e01an
       without virtual deduction, except the order of the hypotheses is
       different.  (Contributed by Alan Sare, 25-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee01an $p |- ( ps -> th ) $=
      ( sylancr ) BACDEFGH $.
  $}

  ${
    e10.1 $e |- (. ph ->. ps ). $.
    e10.2 $e |- ch $.
    e10.3 $e |- ( ps -> ( ch -> th ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e10 $p |- (. ph ->. th ). $=
      ( vd01 e11 ) ABCDECAFHGI $.
  $}

  ${
    e10an.1 $e |- (. ph ->. ps ). $.
    e10an.2 $e |- ch $.
    e10an.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( Conjunction form of ~ e10 .  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e10an $p |- (. ph ->. th ). $=
      ( ex e10 ) ABCDEFBCDGHI $.
  $}

  ${
    ee10an.1 $e |- ( ph -> ps ) $.
    ee10an.2 $e |- ch $.
    ee10an.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( ~ e10an without virtual deductions. ~ sylancl is also ~ e10an without
       virtual deductions, except the order of the hypotheses is different.
       (Contributed by Alan Sare, 25-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee10an $p |- ( ph -> th ) $=
      ( sylancl ) ABCDEFGH $.
  $}

  ${
    e02.1 $e |- ph $.
    e02.2 $e |- (. ps ,. ch ->. th ). $.
    e02.3 $e |- ( ph -> ( th -> ta ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e02 $p |- (. ps ,. ch ->. ta ). $=
      ( vd02 e22 ) BCADEABCFIGHJ $.
  $}

  ${
    e02an.1 $e |- ph $.
    e02an.2 $e |- (. ps ,. ch ->. th ). $.
    e02an.3 $e |- ( ( ph /\ th ) -> ta ) $.
    $( Conjunction form of ~ e02 .  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e02an $p |- (. ps ,. ch ->. ta ). $=
      ( ex e02 ) ABCDEFGADEHIJ $.
  $}

  ${
    ee02an.1 $e |- ph $.
    ee02an.2 $e |- ( ps -> ( ch -> th ) ) $.
    ee02an.3 $e |- ( ( ph /\ th ) -> ta ) $.
    $( ~ e02an without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee02an $p |- ( ps -> ( ch -> ta ) ) $=
      ( ex ee02 ) ABCDEFGADEHIJ $.
  $}

  ${
    eel021.1 $e |- ph $.
    eel021.2 $e |- ( ( ps /\ ch ) -> th ) $.
    eel021.3 $e |- ( ( ph /\ th ) -> ta ) $.
    $( ~ el021old without virtual deductions.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eel021old $p |- ( ( ps /\ ch ) -> ta ) $=
      ( wa sylancr ) BCIADEFGHJ $.
  $}

  ${
    el021old.1 $e |- ph $.
    el021old.2 $e |- (. (. ps ,. ch ). ->. th ). $.
    el021old.3 $e |- ( ( ph /\ th ) -> ta ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    el021old $p |- (. (. ps ,. ch ). ->. ta ). $=
      ( wa dfvd2ani sylancr dfvd2anir ) BCEBCIADEFBCDGJHKL $.
  $}

  ${
    eel132.1 $e |- ( ph -> ps ) $.
    eel132.2 $e |- ( ( ch /\ th ) -> ta ) $.
    eel132.3 $e |- ( ( ps /\ ta ) -> et ) $.
    $( ~ syl2an with antecedents in standard conjunction form.  (Contributed by
       Alan Sare, 26-Aug-2016.) $)
    eel132 $p |- ( ( ph /\ ch /\ th ) -> et ) $=
      ( wa syl2an 3impb ) ACDFABEFCDJGHIKL $.
  $}

  ${
    eel2221.1 $e |- ( ph -> ps ) $.
    eel2221.2 $e |- ( ph -> ch ) $.
    eel2221.3 $e |- ( ( th /\ ph ) -> ta ) $.
    eel2221.4 $e |- ( ( ps /\ ch /\ ta ) -> et ) $.
    $( Deduction related to ~ syl3an with antecedents in standard conjunction
       form.  (Contributed by Alan Sare, 31-Aug-2016.) $)
    eel2221 $p |- ( ( th /\ ph ) -> et ) $=
      ( wa wi 3exp sylc syl5 anabsi7 ) DAFDAKEAFIABCEFLGHBCEFJMNOP $.
  $}

  ${
    eel112.1 $e |- ( ph -> ps ) $.
    eel112.2 $e |- ( ph -> ch ) $.
    eel112.3 $e |- ( th -> ta ) $.
    eel112.4 $e |- ( ( ps /\ ch /\ ta ) -> et ) $.
    $( ~ syl3an with antecedents in standard conjunction form.  (Contributed by
       Alan Sare, 31-Aug-2016.) $)
    eel112 $p |- ( ( ph /\ th ) -> et ) $=
      ( syl3an 3anidm12 ) ADFABACDEFGHIJKL $.
  $}

  ${
    eel000cT.1 $e |- ph $.
    eel000cT.2 $e |- ps $.
    eel000cT.3 $e |- ch $.
    eel000cT.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eel000cT $p |- ( T. -> th ) $=
      ( wtru mp3an1 mpan ax-mp a1i ) DICDGBCDFABCDEHJKLM $.
  $}

  ${
    eel0TT.1 $e |- ph $.
    eel0TT.2 $e |- ( T. -> ps ) $.
    eel0TT.3 $e |- ( T. -> ch ) $.
    eel0TT.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eel0TT $p |- th $=
      ( wtru wa truan mp3an1 sylan sylbir syl trud ) DICDGCICJDCKIBCDFABCDEHLMN
      OP $.
  $}

  ${
    eelT00.1 $e |- ( T. -> ph ) $.
    eelT00.2 $e |- ps $.
    eelT00.3 $e |- ch $.
    eelT00.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT00 $p |- th $=
      ( wa wtru w3a 3anass truan bitri syl3an1 sylbir mpan ax-mp ) CDGBCDFBCIZJ
      BCKZDTJSISJBCLSMNJABCDEHOPQR $.
  $}

  ${
    eelTTT.1 $e |- ( T. -> ph ) $.
    eelTTT.2 $e |- ( T. -> ps ) $.
    eelTTT.3 $e |- ( T. -> ch ) $.
    eelTTT.4 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelTTT $p |- th $=
      ( wtru wa truan w3a 3anass bitri syl3an1 sylbir sylan syl trud ) DICDGCIC
      JDCKIBCDFBCJZIBCLZDUAITJTIBCMTKNIABCDEHOPQPRS $.
  $}

  ${
    eel011.1 $e |- ph $.
    eel011.2 $e |- ( ps -> ch ) $.
    eel011.3 $e |- ( ps -> th ) $.
    eel011.4 $e |- ( ( ph /\ ch /\ th ) -> ta ) $.
    $( ~ mp3an with antecedents in standard conjunction form and with two
       hypotheses which are implications.  (Contributed by Alan Sare,
       28-Aug-2016.) $)
    eel011 $p |- ( ps -> ta ) $=
      ( mp3an1 syl2anc ) BCDEGHACDEFIJK $.
  $}

  ${
    eelT11.1 $e |- ( T. -> ph ) $.
    eelT11.2 $e |- ( ps -> ch ) $.
    eelT11.3 $e |- ( ps -> th ) $.
    eelT11.4 $e |- ( ( ph /\ ch /\ th ) -> ta ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT11 $p |- ( ps -> ta ) $=
      ( wtru w3a wa 3anass truan anidm 3bitri syl3an1 syl3an2 syl3an3 sylbir )
      BJBBKZEUAJBBLZLUBBJBBMUBNBOPBJBDEHBJCDEGJACDEFIQRST $.
  $}

  ${
    eel012.1 $e |- ph $.
    eel012.2 $e |- ( ps -> ch ) $.
    eel012.3 $e |- ( th -> ta ) $.
    eel012.4 $e |- ( ( ph /\ ch /\ ta ) -> et ) $.
    $( ~ mp3an with antecedents in standard conjunction form and with two
       hypotheses which are implications.  (Contributed by Alan Sare,
       28-Aug-2016.) $)
    eel012 $p |- ( ( ps /\ th ) -> et ) $=
      ( mp3an1 syl2an ) BCEFDHIACEFGJKL $.
  $}

  ${
    eel0121.1 $e |- ph $.
    eel0121.2 $e |- ( ps -> ch ) $.
    eel0121.3 $e |- ( ( ps /\ th ) -> ta ) $.
    eel0121.4 $e |- ( ( ph /\ ch /\ ta ) -> et ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 17-Oct-2017.) $)
    eel0121 $p |- ( ( ps /\ th ) -> et ) $=
      ( wa eel012 anabss5 ) BDFABCBDKEFGHIJLM $.
  $}

  ${
    eelT1.1 $e |- ( T. -> ph ) $.
    eelT1.2 $e |- ( ps -> ch ) $.
    eelT1.3 $e |- ( ( ph /\ ch ) -> th ) $.
    $( Syllogism inference combined with modus ponens.  (Contributed by Jeff
       Madsen, 2-Sep-2009.)  (Revised by Alan Sare, 23-Dec-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT1 $p |- ( ps -> th ) $=
      ( trud sylancr ) BACDAEHFGI $.
  $}

  ${
    eelT12.1 $e |- ( T. -> ph ) $.
    eelT12.2 $e |- ( ps -> ch ) $.
    eelT12.3 $e |- ( th -> ta ) $.
    eelT12.4 $e |- ( ( ph /\ ch /\ ta ) -> et ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT12 $p |- ( ( ps /\ th ) -> et ) $=
      ( wa wtru w3a 3anass truan bitri syl3an1 syl3an2 syl3an3 sylbir ) BDKZLBD
      MZFUBLUAKUALBDNUAOPDLBEFIBLCEFHLACEFGJQRST $.
  $}

  ${
    eel001.1 $e |- ph $.
    eel001.2 $e |- ps $.
    eel001.3 $e |- ( ch -> th ) $.
    eel001.4 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( ~ mp3an with antecedents in standard conjunction form and with one
       hypothesis an implication.  (Contributed by Alan Sare, 28-Aug-2016.) $)
    eel001 $p |- ( ch -> ta ) $=
      ( mp3an12 syl ) CDEHABDEFGIJK $.
  $}

  ${
    eelTT1.1 $e |- ( T. -> ph ) $.
    eelTT1.2 $e |- ( T. -> ps ) $.
    eelTT1.3 $e |- ( ch -> th ) $.
    eelTT1.4 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelTT1 $p |- ( ch -> ta ) $=
      ( wtru w3a wa 3anass anabs5 truan 3bitri syl3an1 syl3an2 syl3an3 sylbir )
      CJJCKZEUAJJCLZLUBCJJCMJCNCOPCJJDEHJJBDEGJABDEFIQRST $.
  $}

  ${
    eelT01.1 $e |- ( T. -> ph ) $.
    eelT01.2 $e |- ps $.
    eelT01.3 $e |- ( ch -> th ) $.
    eelT01.4 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT01 $p |- ( ch -> ta ) $=
      ( wtru w3a wa 3anass truan simpr jctl impbii 3bitri syl3an1 syl3an3
      sylbir ) CJBCKZEUBJBCLZLUCCJBCMUCNUCCBCOCBGPQRCJBDEHJABDEFISTUA $.
  $}

  ${
    eel0T1.1 $e |- ph $.
    eel0T1.2 $e |- ( T. -> ps ) $.
    eel0T1.3 $e |- ( ch -> th ) $.
    eel0T1.4 $e |- ( ( ph /\ ps /\ th ) -> ta ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eel0T1 $p |- ( ch -> ta ) $=
      ( wtru w3a wa 3anass simpr jctl impbii truan 3bitri syl3an2 syl3an3
      sylbir ) CAJCKZEUBAJCLZLZUCCAJCMUDUCAUCNUCAFOPCQRCAJDEHJABDEGISTUA $.
  $}

  ${
    eel121.1 $e |- ( ph -> ps ) $.
    eel121.2 $e |- ( ( ph /\ ch ) -> th ) $.
    eel121.3 $e |- ( ( ps /\ th ) -> ta ) $.
    $( ~ syl2an with antecedents in standard conjunction form.  (Contributed by
       Alan Sare, 27-Aug-2016.) $)
    eel121 $p |- ( ( ph /\ ch ) -> ta ) $=
      ( wa syl2an anabss5 ) ACEABDEACIFGHJK $.
  $}

  ${
    eel12131.1 $e |- ( ph -> ps ) $.
    eel12131.2 $e |- ( ( ph /\ ch ) -> th ) $.
    eel12131.3 $e |- ( ( ph /\ ta ) -> et ) $.
    eel12131.4 $e |- ( ( ps /\ th /\ et ) -> ze ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 17-Oct-2017.) $)
    eel12131 $p |- ( ( ph /\ ch /\ ta ) -> ze ) $=
      ( wi wa 3exp syl syl5com ex pm2.43b com13 com3l 3imp ) ACEGEACGEACGLZAEAU
      BLZAEMFUCJCAFGCAFGLZACAUDLACMDAUDIABDUDLHBDFGKNOPQRSOQRTUA $.
  $}

  ${
    eel2131.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    eel2131.2 $e |- ( ( ph /\ th ) -> ta ) $.
    eel2131.3 $e |- ( ( ch /\ ta ) -> et ) $.
    $( ~ syl2an with antecedents in standard conjunction form.  (Contributed by
       Alan Sare, 26-Aug-2016.) $)
    eel2131 $p |- ( ( ph /\ ps /\ th ) -> et ) $=
      ( wa syl2an 3impdi ) ABDFABJCEFADJGHIKL $.
  $}

  ${
    eel3132.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    eel3132.2 $e |- ( ( th /\ ps ) -> ta ) $.
    eel3132.3 $e |- ( ( ch /\ ta ) -> et ) $.
    $( ~ syl2an with antecedents in standard conjunction form.  (Contributed by
       Alan Sare, 27-Aug-2016.) $)
    eel3132 $p |- ( ( ph /\ th /\ ps ) -> et ) $=
      ( wa syl2an 3impdir ) ABDFABJCEFDBJGHIKL $.
  $}

  ${
    eel32131.1 $e |- ( ( ph /\ ps /\ ch ) -> th ) $.
    eel32131.2 $e |- ( ( ph /\ ch ) -> ta ) $.
    eel32131.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 17-Oct-2017.) $)
    eel32131 $p |- ( ( ph /\ ps /\ ch ) -> et ) $=
      ( wi wa 3exp ex syl8 com4r syl pm2.43b pm2.43i com3l 3imp ) ABCFCABFCABFJ
      JCABCFCABCFJJZACAUAJZACKEUBHABCEFABCDEFJABCDGLDEFIMNOPMQORST $.
  $}

  ${
    eel221.1 $e |- ( ph -> ps ) $.
    eel221.2 $e |- ( ( ch /\ ph ) -> th ) $.
    eel221.3 $e |- ( ( ps /\ th ) -> ta ) $.
    $( ~ syl2an with antecedents in standard conjunction form.  (Contributed by
       Alan Sare, 27-Aug-2016.) $)
    eel221 $p |- ( ( ch /\ ph ) -> ta ) $=
      ( wa syl2an anabss7 ) CAEABDECAIFGHJK $.
  $}

  ${
    eel0321old.1 $e |- ph $.
    eel0321old.2 $e |- ( ( ps /\ ch /\ th ) -> ta ) $.
    eel0321old.3 $e |- ( ( ph /\ ta ) -> et ) $.
    $( ~ el0321old without virtual deductions.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eel0321old $p |- ( ( ps /\ ch /\ th ) -> et ) $=
      ( w3a sylancr ) BCDJAEFGHIK $.
  $}

  ${
    el0321old.1 $e |- ph $.
    el0321old.2 $e |- (. (. ps ,. ch ,. th ). ->. ta ). $.
    el0321old.3 $e |- ( ( ph /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    el0321old $p |- (. (. ps ,. ch ,. th ). ->. et ). $=
      ( dfvd3ani eel0321old dfvd3anir ) BCDFABCDEFGBCDEHJIKL $.
  $}

  ${
    eel2122old.1 $e |- ( ( ph /\ ps ) -> ch ) $.
    eel2122old.2 $e |- ( ps -> th ) $.
    eel2122old.3 $e |- ( ps -> ta ) $.
    eel2122old.4 $e |- ( ( ch /\ th /\ ta ) -> et ) $.
    $( ~ el2122old without virtual deductions.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eel2122old $p |- ( ( ph /\ ps ) -> et ) $=
      ( wi wa 3exp syl syl5 syl7 ex pm2.43d imp ) ABFABFABBFKZABBTKBEABLZBFIBDU
      AEFKZHUACDUBKGCDEFJMNOPQRRS $.
  $}

  ${
    el2122old.1 $e |- (. (. ph ,. ps ). ->. ch ). $.
    el2122old.2 $e |- (. ps ->. th ). $.
    el2122old.3 $e |- (. ps ->. ta ). $.
    el2122old.4 $e |- ( ( ch /\ th /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    el2122old $p |- (. (. ph ,. ps ). ->. et ). $=
      ( dfvd2ani in1 eel2122old dfvd2anir ) ABFABCDEFABCGKBDHLBEILJMN $.
  $}

  ${
    eel0001.1 $e |- ph $.
    eel0001.2 $e |- ps $.
    eel0001.3 $e |- ch $.
    eel0001.4 $e |- ( th -> ta ) $.
    eel0001.5 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ ta ) -> et ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 17-Oct-2017.) $)
    eel0001 $p |- ( th -> et ) $=
      ( wi exp41 mp2 mpsyl ) CDEFIJABCEFLLGHABCEFKMNO $.
  $}

  ${
    eel0000.1 $e |- ph $.
    eel0000.2 $e |- ps $.
    eel0000.3 $e |- ch $.
    eel0000.4 $e |- th $.
    eel0000.5 $e |- ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) -> ta ) $.
    $( Elimination rule similar to ~ mp4an , except with a left-nested
       conjunction unification theorem.  (Contributed by Alan Sare,
       17-Oct-2017.) $)
    eel0000 $p |- ta $=
      ( wi exp41 mp2 ) CDEHIABCDEKKFGABCDEJLMM $.
  $}

  ${
    eel1111.1 $e |- ( ph -> ps ) $.
    eel1111.2 $e |- ( ph -> ch ) $.
    eel1111.3 $e |- ( ph -> th ) $.
    eel1111.4 $e |- ( ph -> ta ) $.
    eel1111.5 $e |- ( ( ( ( ps /\ ch ) /\ th ) /\ ta ) -> et ) $.
    $( 4 hypothesis elimination deduction for an assertion with a singleton
       virtual hypothesis collection.  Similar to ~ syl112anc except the
       unification theorem uses left-nested conjunction.  (Contributed by Alan
       Sare, 17-Oct-2017.) $)
    eel1111 $p |- ( ph -> et ) $=
      ( wi exp41 syl3c mpd ) AEFJABCDEFLGHIBCDEFKMNO $.
  $}

  ${
    eel00001.1 $e |- ph $.
    eel00001.2 $e |- ps $.
    eel00001.3 $e |- ch $.
    eel00001.4 $e |- th $.
    eel00001.5 $e |- ( ta -> et ) $.
    eel00001.6 $e |- ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ et ) -> ze ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 17-Oct-2017.) $)
    eel00001 $p |- ( ta -> ze ) $=
      ( wi wa exp41 mp2an mp2 syl ) EFGLCDFGNZJKABCDTNNHIABOCDFGMPQRS $.
  $}

  ${
    eel00000.1 $e |- ph $.
    eel00000.2 $e |- ps $.
    eel00000.3 $e |- ch $.
    eel00000.4 $e |- th $.
    eel00000.5 $e |- ta $.
    eel00000.6 $e |- ( ( ( ( ( ph /\ ps ) /\ ch ) /\ th ) /\ ta ) -> et ) $.
    $( Elimination rule similar ~ eel0000 , except with five hpothesis steps
       (Contributed by Alan Sare, 17-Oct-2017.) $)
    eel00000 $p |- et $=
      ( wi wa exp41 mpan mp2 ) DEFJKBCDEFMMZHIABCRMGABNCDEFLOPQQ $.
  $}

  ${
    eel11111.1 $e |- ( ph -> ps ) $.
    eel11111.2 $e |- ( ph -> ch ) $.
    eel11111.3 $e |- ( ph -> th ) $.
    eel11111.4 $e |- ( ph -> ta ) $.
    eel11111.5 $e |- ( ph -> et ) $.
    eel11111.6 $e |- ( ( ( ( ( ps /\ ch ) /\ th ) /\ ta ) /\ et ) -> ze ) $.
    $( 5 hypothesis elimination deduction for an assertion with a singleton
       virtual hypothesis collection.  Similar to ~ syl113anc except the
       unification theorem uses left-nested conjunction.  (Contributed by Alan
       Sare, 17-Oct-2017.) $)
    eel11111 $p |- ( ph -> ze ) $=
      ( wi wa exp41 ex syl3c mp2d ) AEFGKLABCDEFGNNZHIJBCDTNBCODEFGMPQRS $.
  $}

  ${
    e12.1 $e |- (. ph ->. ps ). $.
    e12.2 $e |- (. ph ,. ch ->. th ). $.
    e12.3 $e |- ( ps -> ( th -> ta ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       21-Apr-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e12 $p |- (. ph ,. ch ->. ta ). $=
      ( vd12 e22 ) ACBDEABCFIGHJ $.
  $}

  ${
    e12an.1 $e |- (. ph ->. ps ). $.
    e12an.2 $e |- (. ph ,. ch ->. th ). $.
    e12an.3 $e |- ( ( ps /\ th ) -> ta ) $.
    $( Conjunction form of ~ e12 .  (Contributed by Alan Sare, 11-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e12an $p |- (. ph ,. ch ->. ta ). $=
      ( ex e12 ) ABCDEFGBDEHIJ $.
  $}

  ${
    el12.1 $e |- (. ph ->. ps ). $.
    el12.2 $e |- (. ta ->. ch ). $.
    el12.3 $e |- ( ( ps /\ ch ) -> th ) $.
    $( Virtual deduction form of ~ syl2an .  (Contributed by Alan Sare,
       23-Apr-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    el12 $p |- (. (. ph ,. ta ). ->. th ). $=
      ( in1 syl2an dfvd2anir ) AEDABCDEABFIECGIHJK $.
  $}

  ${

    e20.1 $e |- (. ph ,. ps ->. ch ). $.
    e20.2 $e |- th $.
    e20.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e20 $p |- (. ph ,. ps ->. ta ). $=
      ( vd02 e22 ) ABCDEFDABGIHJ $.
  $}

  ${

    e20an.1 $e |- (. ph ,. ps ->. ch ). $.
    e20an.2 $e |- th $.
    e20an.3 $e |- ( ( ch /\ th ) -> ta ) $.
    $( Conjunction form of ~ e20 .  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e20an $p |- (. ph ,. ps ->. ta ). $=
      ( ex e20 ) ABCDEFGCDEHIJ $.
  $}

  ${
    ee20an.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee20an.2 $e |- th $.
    ee20an.3 $e |- ( ( ch /\ th ) -> ta ) $.
    $( ~ e20an without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee20an $p |- ( ph -> ( ps -> ta ) ) $=
      ( ex syl6mpi ) ABCDEFGCDEHIJ $.
  $}

  ${

    e21.1 $e |- (. ph ,. ps ->. ch ). $.
    e21.2 $e |- (. ph ->. th ). $.
    e21.3 $e |- ( ch -> ( th -> ta ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e21 $p |- (. ph ,. ps ->. ta ). $=
      ( vd12 e22 ) ABCDEFADBGIHJ $.
  $}

  ${

    e21an.1 $e |- (. ph ,. ps ->. ch ). $.
    e21an.2 $e |- (. ph ->. th ). $.
    e21an.3 $e |- ( ( ch /\ th ) -> ta ) $.
    $( Conjunction form of ~ e21 .  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e21an $p |- (. ph ,. ps ->. ta ). $=
      ( ex e21 ) ABCDEFGCDEHIJ $.
  $}

  ${
    ee21an.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee21an.2 $e |- ( ph -> th ) $.
    ee21an.3 $e |- ( ( ch /\ th ) -> ta ) $.
    $( ~ e21an without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee21an $p |- ( ph -> ( ps -> ta ) ) $=
      ( ex ee21 ) ABCDEFGCDEHIJ $.
  $}

  ${
    e333.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e333.2 $e |- (. ph ,. ps ,. ch ->. ta ). $.
    e333.3 $e |- (. ph ,. ps ,. ch ->. et ). $.
    e333.4 $e |- ( th -> ( ta -> ( et -> ze ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e333 $p |- (. ph ,. ps ,. ch ->. ze ). $=
      ( w3a dfvd3i 3imp wi syl2im pm2.43i syl5com 3exp dfvd3ir ) ABCGABCGABCLZG
      UAFUAGABCFABCFJMNUAFGOZUADUAEUBABCDABCDHMNABCEABCEIMNKPQRQST $.
  $}

  ${
    e33.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e33.2 $e |- (. ph ,. ps ,. ch ->. ta ). $.
    e33.3 $e |- ( th -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e33 $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( wi a1i e333 ) ABCDDEFGGHDEFJJDIKL $.
  $}

  ${
    e33an.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e33an.2 $e |- (. ph ,. ps ,. ch ->. ta ). $.
    e33an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( Conjunction form of ~ e33 .  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e33an $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( ex e33 ) ABCDEFGHDEFIJK $.
  $}

  ${
    ee33an.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee33an.2 $e |- ( ph -> ( ps -> ( ch -> ta ) ) ) $.
    ee33an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( ~ e33an without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee33an $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( ex ee33 ) ABCDEFGHDEFIJK $.
  $}

  ${
    e3.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e3.2 $e |- ( th -> ta ) $.
    $( Meta-connective form of ~ syl8 .  (Contributed by Alan Sare,
       15-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e3 $p |- (. ph ,. ps ,. ch ->. ta ). $=
      ( wi a1i e33 ) ABCDDEFFDEHDGIJ $.
  $}

  ${
    e3bi.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e3bi.2 $e |- ( th <-> ta ) $.
    $( Biconditional form of ~ e3 . ~ syl8ib is ~ e3bi without virtual
       deductions.  (Contributed by Alan Sare, 15-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e3bi $p |- (. ph ,. ps ,. ch ->. ta ). $=
      ( biimpi e3 ) ABCDEFDEGHI $.
  $}

  ${
    e3bir.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e3bir.2 $e |- ( ta <-> th ) $.
    $( Right biconditional form of ~ e3 .  (Contributed by Alan Sare,
       15-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e3bir $p |- (. ph ,. ps ,. ch ->. ta ). $=
      ( biimpri e3 ) ABCDEFEDGHI $.
  $}

  ${
    e03.1 $e |- ph $.
    e03.2 $e |- (. ps ,. ch ,. th ->. ta ). $.
    e03.3 $e |- ( ph -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e03 $p |- (. ps ,. ch ,. th ->. et ). $=
      ( vd03 e33 ) BCDAEFABCDGJHIK $.
  $}

  ${
    ee03.1 $e |- ph $.
    ee03.2 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    ee03.3 $e |- ( ph -> ( ta -> et ) ) $.
    $( ~ e03 without virtual deductions.  (Contributed by Alan Sare,
       17-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee03 $p |- ( ps -> ( ch -> ( th -> et ) ) ) $=
      ( a1i a1d a1dd ee33 ) BCDAEFBCADBACABGJKLHIM $.
  $}

  ${
    e03an.1 $e |- ph $.
    e03an.2 $e |- (. ps ,. ch ,. th ->. ta ). $.
    e03an.3 $e |- ( ( ph /\ ta ) -> et ) $.
    $( Conjunction form of ~ e03 .  (Contributed by Alan Sare, 12-Jun-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e03an $p |- (. ps ,. ch ,. th ->. et ). $=
      ( ex e03 ) ABCDEFGHAEFIJK $.
  $}

  ${
    ee03an.1 $e |- ph $.
    ee03an.2 $e |- ( ps -> ( ch -> ( th -> ta ) ) ) $.
    ee03an.3 $e |- ( ( ph /\ ta ) -> et ) $.
    $( Conjunction form of ~ ee03 .  (Contributed by Alan Sare, 18-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee03an $p |- ( ps -> ( ch -> ( th -> et ) ) ) $=
      ( ex ee03 ) ABCDEFGHAEFIJK $.
  $}

  ${
    e30.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e30.2 $e |- ta $.
    e30.3 $e |- ( th -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e30 $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( vd03 e33 ) ABCDEFGEABCHJIK $.
  $}

  ${
    ee30.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee30.2 $e |- ta $.
    ee30.3 $e |- ( th -> ( ta -> et ) ) $.
    $( ~ e30 without virtual deductions.  (Contributed by Alan Sare,
       17-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee30 $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( wi a1i ee33 ) ABCDEFGBCEJZJAMBECHKKKIL $.
  $}

  ${
    e30an.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e30an.2 $e |- ta $.
    e30an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e30an $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( ex e30 ) ABCDEFGHDEFIJK $.
  $}

  ${
    ee30an.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee30an.2 $e |- ta $.
    ee30an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( Conjunction form of ~ ee30 .  (Contributed by Alan Sare, 17-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ee30an $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( ex ee30 ) ABCDEFGHDEFIJK $.
  $}

  ${
    e13.1 $e |- (. ph ->. ps ). $.
    e13.2 $e |- (. ph ,. ch ,. th ->. ta ). $.
    e13.3 $e |- ( ps -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       13-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e13 $p |- (. ph ,. ch ,. th ->. et ). $=
      ( vd13 e33 ) ACDBEFABCDGJHIK $.
  $}

  ${
    e13an.1 $e |- (. ph ->. ps ). $.
    e13an.2 $e |- (. ph ,. ch ,. th ->. ta ). $.
    e13an.3 $e |- ( ( ps /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e13an $p |- (. ph ,. ch ,. th ->. et ). $=
      ( ex e13 ) ABCDEFGHBEFIJK $.
  $}

  ${
    ee13an.1 $e |- ( ph -> ps ) $.
    ee13an.2 $e |- ( ph -> ( ch -> ( th -> ta ) ) ) $.
    ee13an.3 $e |- ( ( ps /\ ta ) -> et ) $.
    $( ~ e13an without virtual deductions.  (Contributed by Alan Sare,
       8-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee13an $p |- ( ph -> ( ch -> ( th -> et ) ) ) $=
      ( ex ee13 ) ABCDEFGHBEFIJK $.
  $}

  ${
    e31.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e31.2 $e |- (. ph ->. ta ). $.
    e31.3 $e |- ( th -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       13-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e31 $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( vd13 e33 ) ABCDEFGAEBCHJIK $.
  $}

  ${
    ee31.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee31.2 $e |- ( ph -> ta ) $.
    ee31.3 $e |- ( th -> ( ta -> et ) ) $.
    $( ~ e31 without virtual deductions.  (Contributed by Alan Sare,
       25-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee31 $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( wi a1d ee33 ) ABCDEFGACEJBAECHKKIL $.
  $}

  ${
    e31an.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e31an.2 $e |- (. ph ->. ta ). $.
    e31an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e31an $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( ex e31 ) ABCDEFGHDEFIJK $.
  $}

  ${
    ee31an.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee31an.2 $e |- ( ph -> ta ) $.
    ee31an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( ~ e31an without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee31an $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( wi a1d ee33an ) ABCDEFGACEJBAECHKKIL $.
  $}

  ${
    e23.1 $e |- (. ph ,. ps ->. ch ). $.
    e23.2 $e |- (. ph ,. ps ,. th ->. ta ). $.
    e23.3 $e |- ( ch -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e23 $p |- (. ph ,. ps ,. th ->. et ). $=
      ( vd23 e33 ) ABDCEFABCDGJHIK $.
  $}

  ${
    e23an.1 $e |- (. ph ,. ps ->. ch ). $.
    e23an.2 $e |- (. ph ,. ps ,. th ->. ta ). $.
    e23an.3 $e |- ( ( ch /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e23an $p |- (. ph ,. ps ,. th ->. et ). $=
      ( ex e23 ) ABCDEFGHCEFIJK $.
  $}

  ${
    ee23an.1 $e |- ( ph -> ( ps -> ch ) ) $.
    ee23an.2 $e |- ( ph -> ( ps -> ( th -> ta ) ) ) $.
    ee23an.3 $e |- ( ( ch /\ ta ) -> et ) $.
    $( ~ e23an without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee23an $p |- ( ph -> ( ps -> ( th -> et ) ) ) $=
      ( a1dd ee33an ) ABDCEFABCDGJHIK $.
  $}

  ${
    e32.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e32.2 $e |- (. ph ,. ps ->. ta ). $.
    e32.3 $e |- ( th -> ( ta -> et ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e32 $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( vd23 e33 ) ABCDEFGABECHJIK $.
  $}

  ${
    ee32.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee32.2 $e |- ( ph -> ( ps -> ta ) ) $.
    ee32.3 $e |- ( th -> ( ta -> et ) ) $.
    $( ~ e32 without virtual deductions.  (Contributed by Alan Sare,
       18-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee32 $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( a1dd ee33 ) ABCDEFGABECHJIK $.
  $}

  ${
    e32an.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e32an.2 $e |- (. ph ,. ps ->. ta ). $.
    e32an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       24-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e32an $p |- (. ph ,. ps ,. ch ->. et ). $=
      ( ex e32 ) ABCDEFGHDEFIJK $.
  $}

  ${
    ee32an.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee32an.2 $e |- ( ph -> ( ps -> ta ) ) $.
    ee32an.3 $e |- ( ( th /\ ta ) -> et ) $.
    $( ~ e33an without virtual deductions.  (Contributed by Alan Sare,
       14-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee32an $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( a1dd ee33an ) ABCDEFGABECHJIK $.
  $}

  ${
    e123.1 $e |- (. ph ->. ps ). $.
    e123.2 $e |- (. ph ,. ch ->. th ). $.
    e123.3 $e |- (. ph ,. ch ,. ta ->. et ). $.
    e123.4 $e |- ( ps -> ( th -> ( et -> ze ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       12-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e123 $p |- (. ph ,. ch ,. ta ->. ze ). $=
      ( vd13 vd23 e333 ) ACEBDFGABCEHLACDEIMJKN $.
  $}

  ${
    ee123.1 $e |- ( ph -> ps ) $.
    ee123.2 $e |- ( ph -> ( ch -> th ) ) $.
    ee123.3 $e |- ( ph -> ( ch -> ( ta -> et ) ) ) $.
    ee123.4 $e |- ( ps -> ( th -> ( et -> ze ) ) ) $.
    $( ~ e123 without virtual deductions.  (Contributed by Alan Sare,
       25-Jul-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    ee123 $p |- ( ph -> ( ch -> ( ta -> ze ) ) ) $=
      ( wi a1d a1dd ee333 ) ACEBDFGAEBLCABEHMMACDEINJKO $.
  $}

  ${
    el123.1 $e |- (. ph ->. ps ). $.
    el123.2 $e |- (. ch ->. th ). $.
    el123.3 $e |- (. ta ->. et ). $.
    el123.4 $e |- ( ( ps /\ th /\ et ) -> ze ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    el123 $p |- (. (. ph ,. ch ,. ta ). ->. ze ). $=
      ( in1 syl3an dfvd3anir ) ACEGABCDEFGABHLCDILEFJLKMN $.
  $}

  ${
    e233.1 $e |- (. ph ,. ps ->. ch ). $.
    e233.2 $e |- (. ph ,. ps ,. th ->. ta ). $.
    e233.3 $e |- (. ph ,. ps ,. th ->. et ). $.
    e233.4 $e |- ( ch -> ( ta -> ( et -> ze ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       29-Feb-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e233 $p |- (. ph ,. ps ,. th ->. ze ). $=
      ( dfvd2i dfvd3i wi idi ee233 dfvd3ir ) ABDGABCDEFGABCHLABDEIMABDFJMCEFGNN
      NKOPQ $.
  $}

  ${
    e323.1 $e |- (. ph ,. ps ,. ch ->. th ). $.
    e323.2 $e |- (. ph ,. ps ->. ta ). $.
    e323.3 $e |- (. ph ,. ps ,. ch ->. et ). $.
    e323.4 $e |- ( th -> ( ta -> ( et -> ze ) ) ) $.
    $( A virtual deduction elimination rule.  (Contributed by Alan Sare,
       17-Apr-2012.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e323 $p |- (. ph ,. ps ,. ch ->. ze ). $=
      ( dfvd3i dfvd2i ee323 dfvd3ir ) ABCGABCDEFGABCDHLABEIMABCFJLKNO $.
  $}

  ${
    e000.1 $e |- ph $.
    e000.2 $e |- ps $.
    e000.3 $e |- ch $.
    e000.4 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( A virtual deduction elimination rule.  The non-virtual deduction form of
       ~ e000 is the virtual deduction form.  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e000 $p |- th $=
      ( wi mp2 ax-mp ) CDGABCDIEFHJK $.
  $}

  ${
    e00.1 $e |- ph $.
    e00.2 $e |- ps $.
    e00.3 $e |- ( ph -> ( ps -> ch ) ) $.
    $( Elimination rule identical to ~ mp2 .  The non-virtual deduction form is
       the virtual deduction form, which is ~ mp2 .  (Contributed by Alan Sare,
       14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e00 $p |- ch $=
      ( mp2 ) ABCDEFG $.
  $}

  ${
    e00an.1 $e |- ph $.
    e00an.2 $e |- ps $.
    e00an.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( Elimination rule identical to ~ mp2an .  The non-virtual deduction form
       is the virtual deduction form, which is ~ mp2an .  (Contributed by Alan
       Sare, 15-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e00an $p |- ch $=
      ( mp2an ) ABCDEFG $.
  $}

  ${
    eel00cT.1 $e |- ph $.
    eel00cT.2 $e |- ps $.
    eel00cT.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eel00cT $p |- ( T. -> ch ) $=
      ( wtru mpan ax-mp a1i ) CGBCEABCDFHIJ $.
  $}

  ${
    eelTT.1 $e |- ( T. -> ph ) $.
    eelTT.2 $e |- ( T. -> ps ) $.
    eelTT.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelTT $p |- ch $=
      ( wtru wa truan sylan sylbir syl trud ) CGBCEBGBHCBIGABCDFJKLM $.
  $}

  ${
    e0_.1 $e |- ph $.
    e0_.2 $e |- ( ph -> ps ) $.
    $( Elimination rule identical to ~ ax-mp .  The non-virtual deduction form
       is the virtual deduction form, which is ~ ax-mp .  (Contributed by Alan
       Sare, 14-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e0_ $p |- ps $=
      ( ax-mp ) ABCDE $.
  $}

  ${
    eelT.1 $e |- ( T. -> ph ) $.
    eelT.2 $e |- ( ph -> ps ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 5-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT $p |- ps $=
      ( wtru syl trud ) BEABCDFG $.
  $}

  ${
    eel0cT.1 $e |- ph $.
    eel0cT.2 $e |- ( ph -> ps ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eel0cT $p |- ( T. -> ps ) $=
      ( wtru ax-mp a1i ) BEABCDFG $.
  $}

  ${
    eelT0.1 $e |- ( T. -> ph ) $.
    eelT0.2 $e |- ps $.
    eelT0.3 $e |- ( ( ph /\ ps ) -> ch ) $.
    $( An elimination deduction.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    eelT0 $p |- ch $=
      ( wtru sylan mpan2 trud ) CGBCEGABCDFHIJ $.
  $}

  ${
    e0bi.1 $e |- ph $.
    e0bi.2 $e |- ( ph <-> ps ) $.
    $( Elimination rule identical to ~ mpbi .  The non-virtual deduction form
       is the virtual deduction form, which is ~ mpbi .  (Contributed by Alan
       Sare, 15-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e0bi $p |- ps $=
      ( mpbi ) ABCDE $.
  $}

  ${
    e0bir.1 $e |- ph $.
    e0bir.2 $e |- ( ps <-> ph ) $.
    $( Elimination rule identical to ~ mpbir .  The non-virtual deduction form
       is the virtual deduction form, which is ~ mpbir .  (Contributed by Alan
       Sare, 15-Jun-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    e0bir $p |- ps $=
      ( mpbir ) BACDE $.
  $}

  ${
    uun0.1.1 $e |- ( T. -> ph ) $.
    uun0.1.2 $e |- ( ps -> ch ) $.
    uun0.1.3 $e |- ( ( T. /\ ps ) -> th ) $.
    $( Convention notation form of ~ un0.1 .  (Contributed by Alan Sare,
       23-Apr-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    uun0.1 $p |- ( ps -> th ) $=
      ( wtru wi tru wa pm3.2i simpri ex ax-mp ) HBDIJHBDHAIZBCIZKZHBKDIZRSPQEFL
      GLMNO $.
  $}

  ${
    un0.1.1 $e |- (. T. ->. ph ). $.
    un0.1.2 $e |- (. ps ->. ch ). $.
    un0.1.3 $e |- (. (. T. ,. ps ). ->. th ). $.
    $( ` T. ` is the constant true, a tautology ( see: ~ df-tru ).  Kleene's
       "empty conjunction" is logically equivalent to ` T. ` .  In a virtual
       deduction we shall interpret ` T. ` to be the empty wff or the empty
       collection of virtual hypotheses. ` T. ` in a virtual deduction
       translated into conventional notation we shall interpret to be Kleene's
       empty conjunction.  If ` th ` is true given the empty collection of
       virtual hypotheses and another collection of virtual hypotheses, then it
       is true given only the other collection of virtual hypotheses.
       (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    un0.1 $p |- (. ps ->. th ). $=
      ( wtru in1 dfvd2ani uun0.1 dfvd1ir ) BDABCDHAEIBCFIHBDGJKL $.
  $}

  ${
    uunT1.1 $e |- ( ( T. /\ ph ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 3-Dec-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT1 $p |- ( ph -> ps ) $=
      ( wtru wn wo orc wb df-tru exmid a1i biidd impbii bitri sylibr mpancom )
      DABAAAEZFZDAQGDAAHZRAISRRSAJKRALMNOCP $.
  $}

  ${
    uunT1p1.1 $e |- ( ( ph /\ T. ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT1p1 $p |- ( ph -> ps ) $=
      ( wtru wa ancom truan bitri sylbir ) AADEZBJDAEAADFAGHCI $.
  $}

  ${
    uunT21.1 $e |- ( ( T. /\ ( ph /\ ps ) ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 3-Dec-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT21 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa uunT1 ) ABECDF $.
  $}

  ${
    uun121.1 $e |- ( ( ph /\ ( ph /\ ps ) ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun121 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa anabs5 sylbir ) ABEZAHECABFDG $.
  $}

  ${
    uun121p1.1 $e |- ( ( ( ph /\ ps ) /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun121p1 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa anabs1 sylbir ) ABEZHAECABFDG $.
  $}

  ${
    uun132.1 $e |- ( ( ph /\ ( ps /\ ch ) ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun132 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( w3a wa 3anass sylbi ) ABCFABCGGDABCHEI $.
  $}

  ${
    uun132p1.1 $e |- ( ( ( ps /\ ch ) /\ ph ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun132p1 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( w3a wa 3anass ancom bitri sylbi ) ABCFZBCGZAGZDLAMGNABCHAMIJEK $.
  $}

  ${
    anabss7p1.1 $e |- ( ( ( ps /\ ph ) /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  This would have been named uun221 if the 0th permutation
       did not exist in set.mm as ~ anabss7 .  (Contributed by Alan Sare,
       4-Feb-2017.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    anabss7p1 $p |- ( ( ps /\ ph ) -> ch ) $=
      ( anabss3 ) BACDE $.
  $}

  ${
    un10.1 $e |- (. (. ph ,. T. ). ->. ps ). $.
    $( A unionizing deduction (Contributed by Alan Sare, 28-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    un10 $p |- (. ph ->. ps ). $=
      ( wtru wa tru jctr dfvd2ani syl dfvd1ir ) ABAADEBADFGADBCHIJ $.
  $}

  ${
    un01.1 $e |- (. (. T. ,. ph ). ->. ps ). $.
    $( A unionizing deduction (Contributed by Alan Sare, 28-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    un01 $p |- (. ph ->. ps ). $=
      ( wtru wa tru jctl dfvd2ani syl dfvd1ir ) ABADAEBADFGDABCHIJ $.
  $}

  ${
    un2122.1 $e |- ( ( ( ph /\ ps ) /\ ps /\ ps ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 3-Dec-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    un2122 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa w3a 3anass anandir ancom anabs7 bitri bitr3i sylbir ) ABEZNBBFZCONBB
      EEZNNBBGPNBEZNABBHQBNENNBIABJKLKDM $.
  $}

  ${
    uun2131.1 $e |- ( ( ( ph /\ ps ) /\ ( ph /\ ch ) ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun2131 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( 3impdi ) ABCDEF $.
  $}

  ${
    uun2131p1.1 $e |- ( ( ( ph /\ ch ) /\ ( ph /\ ps ) ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun2131p1 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( wa ancom sylbi 3impdi ) ABCDABFZACFZFKJFDJKGEHI $.
  $}

  ${
    uunTT1.1 $e |- ( ( T. /\ T. /\ ph ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunTT1 $p |- ( ph -> ps ) $=
      ( wtru w3a wa 3anass anabs5 truan 3bitri sylbir ) ADDAEZBLDDAFZFMADDAGDAH
      AIJCK $.
  $}

  ${
    uunTT1p1.1 $e |- ( ( T. /\ ph /\ T. ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunTT1p1 $p |- ( ph -> ps ) $=
      ( wtru w3a wa 3ancomb 3anass anabs5 3bitri truan bitri sylbir ) ADADEZBND
      AFZANDDAEDOFODADGDDAHDAIJAKLCM $.
  $}

  ${
    uunTT1p2.1 $e |- ( ( ph /\ T. /\ T. ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunTT1p2 $p |- ( ph -> ps ) $=
      ( wtru w3a wa 3anrot 3anass anabs5 3bitri truan bitri sylbir ) AADDEZBNDA
      FZANDDAEDOFOADDGDDAHDAIJAKLCM $.
  $}

  ${
    uunT11.1 $e |- ( ( T. /\ ph /\ ph ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT11 $p |- ( ph -> ps ) $=
      ( wtru w3a wa 3anass truan anidm 3bitri sylbir ) ADAAEZBLDAAFZFMADAAGMHAI
      JCK $.
  $}

  ${
    uunT11p1.1 $e |- ( ( ph /\ T. /\ ph ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT11p1 $p |- ( ph -> ps ) $=
      ( wtru w3a wa 3anrot 3anass truan 3bitri anidm bitri sylbir ) AADAEZBNAAF
      ZANDAAEDOFOADAGDAAHOIJAKLCM $.
  $}

  ${
    uunT11p2.1 $e |- ( ( ph /\ ph /\ T. ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT11p2 $p |- ( ph -> ps ) $=
      ( wtru w3a wa 3anrev 3anass truan 3bitri anidm bitri sylbir ) AAADEZBNAAF
      ZANDAAEDOFOAADGDAAHOIJAKLCM $.
  $}

  ${
    uunT12.1 $e |- ( ( T. /\ ph /\ ps ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT12 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wtru w3a 3anass truan bitri sylbir ) ABEZFABGZCMFLELFABHLIJDK $.
  $}

  ${
    uunT12p1.1 $e |- ( ( T. /\ ps /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT12p1 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wtru w3a 3anass truan bitri ancom bitr4i sylbir ) ABEZFBAGZCOBAEZNOF
      PEPFBAHPIJABKLDM $.
  $}

  ${
    uunT12p2.1 $e |- ( ( ph /\ T. /\ ps ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT12p2 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wtru w3a 3anrot 3anass bitri truan ancom bitr4i sylbir ) ABEZAFBGZCP
      BAEZOPFQEZQPFBAGRAFBHFBAIJQKJABLMDN $.
  $}

  ${
    uunT12p3.1 $e |- ( ( ps /\ T. /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT12p3 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wtru w3a 3ancoma 3anass bitri truan ancom bitr4i sylbir ) ABEZBFAGZC
      PBAEZOPFQEZQPFBAGRBFAHFBAIJQKJABLMDN $.
  $}

  ${
    uunT12p4.1 $e |- ( ( ph /\ ps /\ T. ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT12p4 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wtru w3a 3anrot 3anass bitr3i truan bitri sylbir ) ABEZABFGZCOFNEZNO
      FABGPFABHFABIJNKLDM $.
  $}

  ${
    uunT12p5.1 $e |- ( ( ps /\ ph /\ T. ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uunT12p5 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( wa wtru w3a 3anrev 3anass bitri truan sylbir ) ABEZBAFGZCNFMEZMNFABGOBA
      FHFABIJMKJDL $.
  $}

  ${
    uun111.1 $e |- ( ( ph /\ ph /\ ph ) -> ps ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun111 $p |- ( ph -> ps ) $=
      ( w3a wa 3anass anabs5 anidm 3bitri sylbir ) AAAADZBKAAAEZELAAAAFAAGAHICJ
      $.
  $}

  ${
    3anidm12p1.1 $e |- ( ( ph /\ ps /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual hypotheses.
       ~ 3anidm12 denotes the deduction which would have been named uun112 if
       it did not pre-exist in set.mm.  This second permutation's name is based
       on this pre-existing name.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    3anidm12p1 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( 3anidm13 ) ABCDE $.
  $}

  ${
    3anidm12p2.1 $e |- ( ( ps /\ ph /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    3anidm12p2 $p |- ( ( ph /\ ps ) -> ch ) $=
      ( w3a 3anrot sylbir 3anidm12 ) ABCAABEBAAECBAAFDGH $.
  $}

  ${
    uun123.1 $e |- ( ( ph /\ ch /\ ps ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun123 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( w3a 3ancomb sylbir ) ABCFACBFDACBGEH $.
  $}

  ${
    uun123p1.1 $e |- ( ( ps /\ ph /\ ch ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun123p1 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( 3com12 ) BACDEF $.
  $}

  ${
    uun123p2.1 $e |- ( ( ch /\ ph /\ ps ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun123p2 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( 3coml ) CABDEF $.
  $}

  ${
    uun123p3.1 $e |- ( ( ps /\ ch /\ ph ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun123p3 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( 3comr ) BCADEF $.
  $}

  ${
    uun123p4.1 $e |- ( ( ch /\ ps /\ ph ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun123p4 $p |- ( ( ph /\ ps /\ ch ) -> th ) $=
      ( 3com13 ) CBADEF $.
  $}

  ${
    uun2221.1 $e |- ( ( ph /\ ph /\ ( ps /\ ph ) ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 30-Dec-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun2221 $p |- ( ( ps /\ ph ) -> ch ) $=
      ( wa w3a wi 3anass anabs5 bitri ancom anbi2i bitr4i imbi1i mpbi ) AABAEZF
      ZCGPCGDQPCQAABEZEZPQAPEZSQATETAAPHAPIJRPAABKZLMSRPABIUAJJNO $.
  $}

  ${
    uun2221p1.1 $e |- ( ( ph /\ ( ps /\ ph ) /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun2221p1 $p |- ( ( ps /\ ph ) -> ch ) $=
      ( wa w3a 3anrot imbi1i mpbir 3anass anabs5 bitri ancom anbi2i bitr4i mpbi
      wi ) AABAEZFZCQZRCQTARAFZCQDSUACAARGHISRCSAABEZEZRSAREZUCSAUDEUDAARJARKLU
      BRAABMZNOUCUBRABKUELLHP $.
  $}

  ${
    uun2221p2.1 $e |- ( ( ( ps /\ ph ) /\ ph /\ ph ) -> ch ) $.
    $( A deduction unionizing a non-unionized collection of virtual
       hypotheses.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    uun2221p2 $p |- ( ( ps /\ ph ) -> ch ) $=
      ( wa w3a 3anrev imbi1i mpbir 3anass anabs5 bitri ancom anbi2i bitr4i mpbi
      wi ) AABAEZFZCQZRCQTRAAFZCQDSUACAARGHISRCSAABEZEZRSAREZUCSAUDEUDAARJARKLU
      BRAABMZNOUCUBRABKUELLHP $.
  $}

  ${
    3impdirp1.1 $e |- ( ( ( ch /\ ps ) /\ ( ph /\ ps ) ) -> th ) $.
    $( A deduction unionizing a non-unionized collection of virtual hypotheses.
       ~ 3impdir is ~~? uun3132 and is in set.mm. ~ 3impdirp1 is ~~?
       uun3132p1.  (Contributed by Alan Sare, 4-Feb-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    3impdirp1 $p |- ( ( ph /\ ch /\ ps ) -> th ) $=
      ( wa ancom sylbir 3impdir ) ABCDABFZCBFZFKJFDKJGEHI $.
  $}

  ${
    3impcombi.1 $e |- ( ( ph /\ ps /\ ph ) -> ( ch <-> th ) ) $.
    $( A 1-hypothesis propositional calculus deduction (Contributed by Alan
       Sare, 25-Sep-2017.) $)
    3impcombi $p |- ( ( ps /\ ph /\ ch ) -> th ) $=
      ( wi w3a biimpd 3anidm13 ancoms 3impia ) BACDABCDFZABLABAGCDEHIJK $.
  $}

  ${
    3imp231.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    $( Importation inference.  (Contributed by Alan Sare, 17-Oct-2017.) $)
    3imp231 $p |- ( ( ps /\ ch /\ ph ) -> th ) $=
      ( com3l 3imp ) BCADABCDEFG $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Theorems proved using virtual deduction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x A $.
    $( Virtual deduction proof of the left-to-right implication of ~ dftr4 .  A
       transitive class is a subset of its power class.  This proof corresponds
       to the virtual deduction proof of ~ dftr4 without accumulating results.
       (Contributed by Alan Sare, 29-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    trsspwALT $p |- ( Tr A -> A C_ ~P A ) $=
      ( vx wtr cpw wss cv wcel wi wal wb dfss2 idn1 idn2 trss e12 vex e2bir in2
      elpw gen11 bi2 e01 in1 ) ACZAADZEZUFBFZAGZUGUEGZHZBIZJUDUKUFBAUEKUDUJBUDU
      HUIUDUHUGAEZUIUDUDUHUHULUDLUDUHMAUGNOUGABPSQRTUFUKUAUBUC $.
  $}

  ${
    $d x A $.
    $( Virtual deduction proof of ~ trsspwALT .  This proof is the same as the
       proof of ~ trsspwALT except each virtual deduction symbol is replaced by
       its non-virtual deduction symbol equivalent.  A transitive class is a
       subset of its power class.  (Contributed by Alan Sare, 23-Jul-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    trsspwALT2 $p |- ( Tr A -> A C_ ~P A ) $=
      ( vx wtr cpw wss wi cv wcel wal wb dfss2 id idd trss sylsyld elpw syl6ibr
      vex idi alrimiv bi2 mpsyl ) ACZAADZEZFUEBGZAHZUFUDHZFZBIZJUCUJUEBAUDKUCUI
      BUCUIFUCUGUFAEZUHUCUCUGUGUKUCLUCUGMAUFNOUFABRPQSTUEUJUAUBS $.
  $}

  ${
    $d x A $.
    $( Short predicate calculus proof of the left-to-right implication of
       ~ dftr4 .  A transitive class is a subset of its power class.  This
       proof was constructed by applying Metamath's minimize command to the
       proof of ~ trsspwALT2 , which is the virtual deduction proof ~ trsspwALT
       without virtual deductions.  (Contributed by Alan Sare, 30-Apr-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    trsspwALT3 $p |- ( Tr A -> A C_ ~P A ) $=
      ( vx wtr cpw cv wcel wss trss vex elpw syl6ibr ssrdv ) ACZBAADZMBEZAFOAGO
      NFAOHOABIJKL $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( Virtual deduction proof of the right-to-left implication of ~ dftr4 .  A
       class which is a subclass of its power class is transitive.  This proof
       corresponds to the virtual deduction proof of ~ sspwtr without
       accumulating results.  (Contributed by Alan Sare, 2-May-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sspwtr $p |- ( A C_ ~P A -> Tr A ) $=
      ( vz vy cpw wss wtr cv wcel wa wi wal wb dftr2 idn1 idn2 simpr ssel elpwi
      e2 e12 simpl e22 in2 gen12 bi2 e01 in1 ) AADZEZAFZUJBGZCGZHZULAHZIZUKAHZJ
      ZCKBKZLUIURUJBCAMUIUQBCUIUOUPUIUOULAEZUMUPUIUOULUHHZUSUIUIUOUNUTUINUIUOUO
      UNUIUOOZUMUNPSAUHULQTULARSUIUOUOUMVAUMUNUASULAUKQUBUCUDUJURUEUFUG $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( Virtual deduction proof of ~ sspwtr .  This proof is the same as the
       proof of ~ sspwtr except each virtual deduction symbol is replaced by
       its non-virtual deduction symbol equivalent.  A class which is a
       subclass of its power class is transitive.  (Contributed by Alan Sare,
       3-May-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sspwtrALT $p |- ( A C_ ~P A -> Tr A ) $=
      ( vz vy cpw wss wtr wi wel cv wcel wa wal wb dftr2 simpr ssel elpwi syl56
      idd idi simpl syl6 ee22 alrimivv bi2 mpsyl ) AADZEZAFZGUIBCHZCIZAJZKZBIZA
      JZGZCLBLZMUHUQUIBCANUHUPBCUHUPGUHUMUKAEZUJUOUMULUHUKUGJURUJULOAUGUKPUKAQR
      UHUMUMUJUHUMSUJULUAUBUKAUNPUCTUDUIUQUEUFT $.
  $}

  ${
    $d A y $.  $d F y $.  $d B y $.  $d C y $.  $d x y $.
    $( Move class substitution in and out of a function value.  The proof is
       derived from the virtual deduction proof ~ csbfv12gALTVD .  (Contributed
       by Alan Sare, 10-Nov-2012.)  Obsolete as of 20-Aug-2018.  Use ~ csbfv12
       instead.  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    csbfv12gALTOLD $p |- ( A e. C -> [_ A / x ]_ ( F ` B )
              = ( [_ A / x ]_ F ` [_ A / x ]_ B ) ) $=
      ( vy wcel csn cima wceq cab cuni csb cfv csbunigOLD csbabgOLD eqtrd dffv4
      cv wsbc sbceqg csbima12gOLD csbsng imaeq2d csbconstg eqeq12d bitrd abbidv
      unieqd csbeq2i 3eqtr4g ) BDGZABECHZIZFSHZJZFKZLZMZABEMZABCMZHZIZUOJZFKZLZ
      ABCENZMVAUTNULUSABUQMZLVFABUQDOULVHVEULVHUPABTZFKVEUPAFBDPULVIVDFULVIABUN
      MZABUOMZJVDABUNUODUAULVJVCVKUOULVJUTABUMMZIVCABUMDEUBULVLVBUTABCDUCUDQABU
      ODUEUFUGUHQUIQABVGURFCERUJFVAUTRUK $.
  $}

  $( Move class substitution in and out of the image of a function.  The proof
     is derived from the virtual deduction proof ~ csbima12gALTVD .
     (Contributed by Alan Sare, 10-Nov-2012.)  Obsolete as of 20-Aug-2018.  Use
     ~ csbfv12 instead.  (Proof modification is discouraged.)  (Proof
     modification is discouraged.)  (New usage is discouraged.) $)
  csbima12gALTOLD $p |- ( A e. C -> [_ A / x ]_ ( F " B ) =
                 ( [_ A / x ]_ F " [_ A / x ]_ B ) ) $=
    ( wcel cres crn csb csbrngOLD csbresgOLD rneqd eqtrd df-ima csbeq2i 3eqtr4g
    cima ) BDFZABECGZHZIZABEIZABCIZGZHZABECQZIUBUCQRUAABSIZHUEABSDJRUGUDABECDKL
    MABUFTECNOUBUCNP $.

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( Short predicate calculus proof of the right-to-left implication of
       ~ dftr4 .  A class which is a subclass of its power class is
       transitive.  This proof was constructed by applying Metamath's minimize
       command to the proof of ~ sspwtrALT , which is the virtual deduction
       proof ~ sspwtr without virtual deductions.  (Contributed by Alan Sare,
       3-May-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sspwtrALT2 $p |- ( A C_ ~P A -> Tr A ) $=
      ( vz vy cpw wss cv wcel wa wal wtr ssel adantld elpwi syl6 simpl a1i ee22
      wi alrimivv dftr2 sylibr ) AADZEZBFZCFZGZUEAGZHZUDAGZRZCIBIAJUCUJBCUCUHUE
      AEZUFUIUCUHUEUBGZUKUCUGULUFAUBUEKLUEAMNUHUFRUCUFUGOPUEAUDKQSBCATUA $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( Virtual deduction proof of ~ pwtr .  (Contributed by Alan Sare,
       25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    pwtrVD $p |- ( Tr A -> Tr ~P A ) $=
      ( vz vy wtr cpw cv wcel wa wi wal wb dftr2 idn1 idn2 simpr e2 elpwi simpl
      wss ssel e22 trss e12 vex elpw e2bir in2 gen12 bi2 e01 in1 ) ADZAEZDZUNBF
      ZCFZGZUPUMGZHZUOUMGZIZCJBJZKULVBUNBCUMLULVABCULUSUTULUSUOASZUTULULUSUOAGZ
      VCULMULUSUPASZUQVDULUSURVEULUSUSURULUSNZUQUROPUPAQPULUSUSUQVFUQURRPUPAUOT
      UAAUOUBUCUOABUDUEUFUGUHUNVBUIUJUK $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    pwtrrVD.1 $e |- A e. _V $.
    $( Virtual deduction proof of ~ pwtr .  (Contributed by Alan Sare,
       25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    pwtrrVD $p |- ( Tr ~P A -> Tr A ) $=
      ( vz vy cpw wtr cv wcel wa wi wal wb dftr2 wss idn1 idn2 simpr pwid trel
      e2 exp3a e120 elpwi simpl ssel e22 in2 gen12 bi2 e01 in1 ) AEZFZAFZUNCGZD
      GZHZUPAHZIZUOAHZJZDKCKZLUMVBUNCDAMUMVACDUMUSUTUMUSUPANZUQUTUMUSUPULHZVCUM
      UMUSURAULHZVDUMOUMUSUSURUMUSPZUQURQTABRUMURVEVDULUPASUAUBUPAUCTUMUSUSUQVF
      UQURUDTUPAUOUEUFUGUHUNVBUIUJUK $.
  $}

  ${
    $d A x $.  $d B x $.
    $( Virtual deduction proof of ~ snssiALT .  (Contributed by Alan Sare,
       11-Sep-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    snssiALTVD $p |- ( A e. B -> { A } C_ B ) $=
      ( vx wcel csn wss cv wi wal dfss2 wceq idn1 idn2 elsn e2bi eleq1a e12 in2
      wb gen11 bi2 e01 in1 ) ABDZAEZBFZUFCGZUEDZUGBDZHZCIZSUDUKUFCUEBJUDUJCUDUH
      UIUDUDUHUGAKZUIUDLUDUHUHULUDUHMCANOABUGPQRTUFUKUAUBUC $.
  $}

  ${
    $d A x $.  $d B x $.
    $( If a class is an element of another class, then its singleton is a
       subclass of that other class.  Alternate proof of ~ snssi .  This
       theorem was automatically generated from ~ snssiALTVD using a
       translation program.  (Contributed by Alan Sare, 11-Sep-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    snssiALT $p |- ( A e. B -> { A } C_ B ) $=
      ( vx wcel cv csn wi wal wss wceq elsn eleq1a syl5bi alrimiv dfss2 sylibr
      ) ABDZCEZAFZDZRBDZGZCHSBIQUBCTRAJQUACAKABRLMNCSBOP $.
  $}

  ${
    $d A x $.  $d B x $.
    snsslVD.1 $e |- A e. _V $.
    $( Virtual deduction proof of ~ snssl .  (Contributed by Alan Sare,
       25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    snsslVD $p |- ( { A } C_ B -> A e. B ) $=
      ( csn wss wcel idn1 snid ssel2 e10an in1 ) ADZBEZABFZMMALFNMGACHLBAIJK $.
  $}

  ${
    $d A x $.  $d B x $.
    snssl.1 $e |- A e. _V $.
    $( If a singleton is a subclass of another class, then the singleton's
       element is an element of that other class.  This theorem is the
       right-to-left implication of the biconditional ~ snss .  The proof of
       this theorem was automatically generated from ~ snsslVD using a tools
       command file, translateMWO.cmd , by translating the proof into its
       non-virtual deduction form and minimizing it.  (Contributed by Alan
       Sare, 25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    snssl $p |- ( { A } C_ B -> A e. B ) $=
      ( csn wss wcel snid ssel2 mpan2 ) ADZBEAJFABFACGJBAHI $.
  $}

  ${
    $( Virtual deduction proof of ~ snelpwi .  (Contributed by Alan Sare,
       25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    snelpwrVD $p |- ( A e. B -> { A } e. ~P B ) $=
      ( wcel csn cpw cvv wss snex idn1 snssi e1_ elpwg biimprd e01 in1 ) ABCZAD
      ZBECZQFCZPQBGZRAHPPTPIABJKSRTQBFLMNO $.
  $}

  ${
    $d A x y $.
    $( Virtual deduction proof of ~ unipwr .  (Contributed by Alan Sare,
       25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    unipwrVD $p |- A C_ U. ~P A $=
      ( vx cpw cuni wcel csn vex snid idn1 snelpwi e1_ elunii e01an in1 ssriv
      cv ) BAACZDZBPZAEZSREZSSFZETUBQEZUASBGHTTUCTISAJKSUBQLMNO $.
  $}

  ${
    $d A x y $.
    $( A class is a subclass of the union of its power class.  This theorem is
       the right-to-left subclass lemma of ~ unipw .  The proof of this theorem
       was automatically generated from ~ unipwrVD using a tools command file ,
       translateMWO.cmd , by translating the proof into its non-virtual
       deduction form and minimizing it.  (Contributed by Alan Sare,
       25-Aug-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    unipwr $p |- A C_ U. ~P A $=
      ( vx cpw cuni cv wcel csn vex snid snelpwi elunii sylancr ssriv ) BAACZDZ
      BEZAFPPGZFQNFPOFPBHIPAJPQNKLM $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Virtual deduction proof of ~ sstrALT2 .  (Contributed by Alan Sare,
       11-Sep-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sstrALT2VD $p |- ( ( A C_ B /\ B C_ C ) -> A C_ C ) $=
      ( vx wss wa cv wcel wi wal wb dfss2 idn1 simpr e1_ simpl idn2 ssel2 e12an
      in2 gen11 bi2 e01 in1 ) ABEZBCEZFZACEZUHDGZAHZUICHZIZDJZKUGUMUHDACLUGULDU
      GUJUKUGUFUJUIBHZUKUGUGUFUGMZUEUFNOUGUEUJUJUNUGUGUEUOUEUFPOUGUJQABUIRSBCUI
      RSTUAUHUMUBUCUD $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Virtual deduction proof of ~ sstr , transitivity of subclasses, Theorem
       6 of [Suppes] p. 23.  This theorem was automatically generated from
       ~ sstrALT2VD using the command file translate_without_overwriting.cmd .
       It was not minimized because the automated minimization excluding
       duplicates generates a minimized proof which, although not directly
       containing any duplicates, indirectly contains a duplicate.  That is,
       the trace back of the minimized proof contains a duplicate.  This is
       undesirable because some step(s) of the minimized proof use the proven
       theorem.  (Contributed by Alan Sare, 11-Sep-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sstrALT2 $p |- ( ( A C_ B /\ B C_ C ) -> A C_ C ) $=
      ( vx wss cv wcel wi wal wb wa dfss2 simpr syl simpl idd ssel2 ee12an idi
      id alrimiv bi2 mpsyl ) ACEZDFZAGZUECGZHZDIZJABEZBCEZKZUIUDDACLULUHDULUHHU
      LUKUFUEBGZUGULULUKULTZUJUKMNULUJUFUFUMULULUJUNUJUKONULUFPABUEQRBCUEQRSUAU
      DUIUBUC $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( Virtual deduction proof of ~ suctrALT2 .  (Contributed by Alan Sare,
       11-Sep-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    suctrALT2VD $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr csuc cv wcel wa wi wal wb dftr2 wceq wss sssucid idn3 e03 in3
      wo e2 idn1 idn2 simpl trel exp3a e123 ssel eleq2 biimpcd e23 simpr elsuci
      jao e222 in2 gen12 bi2 e01 in1 ) ADZAEZDZVBBFZCFZGZVDVAGZHZVCVAGZIZCJBJZK
      UTVJVBBCVALUTVIBCUTVGVHUTVGVDAGZVHIVDAMZVHIVKVLSZVHUTVGVKVHAVANZUTVGVKVCA
      GZVHAOZUTUTVGVEVKVKVOUTUAUTVGVGVEUTVGUBZVEVFUCTZUTVGVKPUTVEVKVOAVCVDUDUEU
      FAVAVCUGZQRUTVGVLVHVNUTVGVLVOVHVPUTVGVEVLVLVOVRUTVGVLPVLVEVOVDAVCUHUIUJVS
      QRUTVGVFVMUTVGVGVFVQVEVFUKTVDAULTVKVHVLUMUNUOUPVBVJUQURUS $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y $.
    $( Virtual deduction proof of ~ suctr .  The sucessor of a transitive class
       is transitive.  This proof was generated automatically from the virtual
       deduction proof ~ suctrALT2VD using the tools command file
       translate_without_overwriting_minimize_excluding_duplicates.cmd .
       (Contributed by Alan Sare, 11-Sep-2011.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    suctrALT2 $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr wel cv csuc wcel wa wi wal wceq wo wss sssucid trel exp3a a1i
      ee03 syl6 adantrd ssel simpl eleq2 biimpcd simpr jao ee222 alrimivv dftr2
      elsuci sylibr ) ADZBCEZCFZAGZHZIZBFZUPHZJZCKBKUPDUMVABCUMURUOAHZUTJUOALZU
      TJVBVCMZUTAUPNZUMURVBUSAHZUTAOZUMUNVBVFJUQUMUNVBVFAUSUOPQUAAUPUSUBZSVEUMU
      RVCVFUTVGUMURUNVCVFJURUNJUMUNUQUCRVCUNVFUOAUSUDUETVHSUMURUQVDURUQJUMUNUQU
      FRUOAUKTVBUTVCUGUHUIBCUPUJUL $.
  $}

  ${
    $d x A $.  $d x B $.
    $( Virtual deduction proof of ~ elex2 .  (Contributed by Alan Sare,
       25-Sep-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    elex2VD $p |- ( A e. B -> E. x x e. B ) $=
      ( wcel cv wex wceq wi wal idn1 idn2 eleq1a e12 in2 gen11 elisset e1_ exim
      e11 in1 ) BCDZAEZCDZAFZUAUBBGZUCHZAIUEAFZUDUAUFAUAUEUCUAUAUEUEUCUAJZUAUEK
      BCUBLMNOUAUAUGUHABCPQUEUCARST $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.
    $( Virtual deduction proof of ~ elex22 .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    elex22VD $p |- ( ( A e. B /\ A e. C ) -> E. x ( x e. B /\ x e. C ) ) $=
      ( wcel wa cv wex wceq wi idn1 simpl e1_ elisset wal idn2 eleq1a e12 simpr
      pm3.2 e22 in2 gen11 exim pm2.27 e11 in1 ) BCEZBDEZFZAGZCEZUKDEZFZAHZUJUKB
      IZAHZUQUOJZUOUJUHUQUJUJUHUJKZUHUILMZABCNMUJUPUNJZAOURUJVAAUJUPUNUJUPULUMU
      NUJUHUPUPULUTUJUPPZBCUKQRUJUIUPUPUMUJUJUIUSUHUISMVBBDUKQRULUMTUAUBUCUPUNA
      UDMUQUOUEUFUG $.
  $}

  ${
    $d x C $.  $d x A $.
    $( Virtual deduction proof of ~ eqsbc3r .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    eqsbc3rVD $p |- ( A e. B -> ( [. A / x ]. C = x <-> C = A ) ) $=
      ( wcel cv wceq wsbc wb wi idn1 eqsbc3 e1_ eqcom sbcbiiOLD bi1 e12 in2 bi2
      idn2 e2bi e2bir bi3 e11 in1 ) BCEZDAFZGZABHZDBGZIZUFUIUJJUJUIJUKUFUIUJUFU
      IBDGZUJUFUGDGZABHZULIZUIUNULUFUFUOUFKZABDCLMZUFUIUNIZUIUIUNUFUFURUPUHUMAB
      CDUGNOMZUFUITUIUNPQUNULPQBDNZUARUFUJUIUFURUJUNUIUSUFUOUJULUNUQUFUJUJULUFU
      JTUTUBUNULSQUIUNSQRUIUJUCUDUE $.

  $}

  ${
    $d x y A $.
    $( Virtual deduction proof of ~ zfregs2 .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    zfregs2VD $p |- ( A =/= (/) -> -. A. x e. A E. y ( y e. A /\ y e. x ) ) $=
      ( c0 wne cv wcel wa wex wral wn wrex wal cin wceq idn1 zfregs rexbii e1bi
      wi incom eqeq1i disj1 alinexa dfrex2 notnot2 notnot1 impbii ralbii notbii
      e1_ in1 ) CDEZBFZCGZUNAFZGZHBIZACJZKZUMURKZKZACJZKZUTUMVAACLZVDUMUOUQKTBM
      ZACLZVEUMCUPNZDOZACLZVGUMUPCNZDOZACLZVJUMUMVMUMPACQUKVLVIACVKVHDUPCUAUBRS
      VIVFACBCUPUCRSVFVAACUOUQBUDRSVAACUESVCUSVBURACVBURURUFURUGUHUIUJSUL $.
  $}

  ${
    $d x A $.  $d x B $.  $d x C $.  $d x D $.  $d x ps $.
    $( Virtual deduction proof of ~ tpid3g .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    tpid3gVD $p |- ( A e. B -> A e. { C , D , A } ) $=
      ( vx wcel ctp cv wceq wex wi wal idn2 w3o cab 3mix3 e2 abid e2bir dftp2
      eleq2i eleq1 biimpd e22 in2 gen11 19.23v e1bi idn1 elisset e1_ id e11 in1
      ) ABFZACDAGZFZUOEHZAIZEJZUQKZUTUQUOUSUQKZELVAUOVBEUOUSUQUOUSUSURUPFZUQUOU
      SMZUOUSURURCIZURDIZUSNZEOZFZVCUOUSVGVIUOUSUSVGVDUSVEVFPQVGERSUPVHURECDATU
      ASUSVCUQURAUPUBUCUDUEUFUSUQEUGUHUOUOUTUOUIEABUJUKVAULUMUN $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Virtual deduction proof of ~ en3lplem1 .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    en3lplem1VD $p |- ( ( A e. B /\ B e. C /\ C e. A ) ->
                    ( x = A -> E. y ( y e. { A , B , C } /\ y e. x ) ) ) $=
      ( wcel w3a cv wceq ctp wa wex wi idn1 simp3 e1_ tpid3g idn2 eleq2 biimprd
      e21 pm3.2 e12 elex22 e2 in2 in1 ) CDFZDEFZECFZGZAHZCIZBHZCDEJZFUNULFKBLZM
      UKUMUPUKUMEUOFZEULFZKZUPUKUQUMURUSUKUJUQUKUKUJUKNUHUIUJOPZECCDQPUKUMUMUJU
      RUKUMRUTUMURUJULCESTUAUQURUBUCBEUOULUDUEUFUG $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.
    $( Virtual deduction proof of ~ en3lplem2 .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    en3lplem2VD $p |- ( ( A e. B /\ B e. C /\ C e. A ) -> ( x e. { A , B , C }
                    -> E. y ( y e. { A , B , C } /\ y e. x ) ) ) $=
      ( wcel w3a cv ctp wa wex wi wceq wo idn3 en3lplem1VD e13 in3 eleq2i e2bi
      idn1 3anrot e1bi tprot anbi1i exbii e3bir jao e22 e1bir e3bi w3o cab idn2
      dftp2 abid df-3or e222 in2 in1 ) CDFZDEFZECFZGZAHZCDEIZFZBHZVFFZVHVEFZJZB
      KZLVDVGVLVDVGVECMZVEDMZNZVLLZVEEMZVLLVOVQNZVLVDVGVMVLLVNVLLVPVDVGVMVLVDVD
      VGVMVMVLVDUAZVDVGVMOABCDEPQRVDVGVNVLVDVGVNVHDECIZFZVJJZBKZVLVDVBVCVAGZVGV
      NVNWCVDVDWDVSVAVBVCUBUCVDVGVNOABDECPQVKWBBVIWAVJVFVTVHCDEUDSUEUFUGRVMVLVN
      UHUIVDVGVQVLVDVGVQVHECDIZFZVJJZBKZVLVDVCVAVBGZVGVQVQWHVDVDWIVSVCVAVBUBUJV
      DVGVQOABECDPQWGVKBWFVIVJWEVFVHECDUDSUEUFUKRVDVGVMVNVQULZVRVDVGVEWJAUMZFZW
      JVDVGVGWLVDVGUNVFWKVEACDEUOSTWJAUPTVMVNVQUQTVOVLVQUHURUSUT $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x y C $.  $d x ph $.
    $( Virtual deduction proof of ~ en3lp .  (Contributed by Alan Sare,
       24-Oct-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    en3lpVD $p |- -. ( A e. B /\ B e. C /\ C e. A ) $=
      ( vy vx ctp c0 wne wceq wo wcel w3a wn pm2.1 df-ne bicomi orbi1i cv con3i
      e1_ mpbi wa wex wral zfregs2 wi wal en3lplem2VD alrimiv df-ral sylibr syl
      idn1 noel eleq2 notbid biimprd e10 tpid3g simp3 in1 jaoi ax-mp ) ABCFZGHZ
      VDGIZJZABKZBCKZCAKZLZMZVFMZVFJVGVFNVMVEVFVEVMVDGOPQUAVEVLVFVEDRZVDKVNERZK
      UBDUCZEVDUDZMVLEDVDUEVKVQVKVOVDKVPUFZEUGVQVKVREEDABCUHUIVPEVDUJUKSULVFVLV
      FVJMZVLVFCVDKZMZVSVFVFCGKZMZWAVFUMCUNVFWAWCVFVTWBVDGCUOUPUQURVJVTCAABUSST
      VKVJVHVIVJUTSTVAVBVC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Theorems proved using virtual deduction with mmj2 assistance
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    pm3.26bi2VD.1 $e |- ( ph <-> ( ps /\ ch ) ) $.
    $( Virtual deduction proof of ~ simplbi2 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> h1::        <TD> ` |- ( ph <-> ( ps /\ ch ) ) `
       <TR> <TD> 3:1,?: ~ e0_   <TD> ` |- ( ( ps /\ ch ) -> ph )  `
       <TR> <TD> qed:3,?: ~ e0_ <TD> ` |- ( ps -> ( ch -> ph ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    simplbi2VD $p |- ( ps -> ( ch -> ph ) ) $=
      ( wa wi wb bi2 e0_ pm3.3 ) BCEZAFZBCAFFAKGLDAKHIBCAJI $.
  $}

  ${
    $( Virtual deduction proof of ~ 3ornot23 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <DT> 1::            <TD> ` |- (. ( -. ph /\ -. ps ) ->. ( -. ph `
       ` /\ -. ps ) ). `
       <TR> <TD> 2::            <TD> ` |- (. ( -. ph /\ -. ps ) ,. ( ch \/ ph `
       ` \/ ps ) ->. ( ch \/ ph \/ ps ) ).                  `
       <TR> <TD> 3:1,?: ~ e1_    <TD> ` |- (. ( -. ph /\ -. ps ) ->. -. ph ). `
       <TR> <TD> 4:1,?: ~ e1_    <TD> ` |- (. ( -. ph /\ -. ps ) ->. -. ps ). `
       <TR> <TD> 5:3,4,?: ~ e11  <TD> ` |- (. ( -. ph /\ -. ps ) ->. -. ( ph `
       ` \/ ps ) ). `
       <TR> <TD> 6:2,?: ~ e2     <TD> ` |- (. ( -. ph /\ -. ps ) ,. ( ch \/ ph
       `
       ` \/ ps ) ->. ( ch \/ ( ph \/ ps ) ) ).  `
       <TR> <TD> 7:5,6,?: ~ e12  <TD> ` |- (. ( -. ph /\ -. ps ) ,. ( ch \/ ph
       `
       ` \/ ps ) ->. ch ). `
       <TR> <TD> 8:7:           <TD> ` |- (. ( -. ph /\ -. ps ) ->. ( ( ch `
       ` \/ ph \/ ps ) -> ch ) ). `
       <TR> <TD> qed:8:         <TD> ` |- ( ( -. ph /\ -. ps ) -> ( ( ch `
       ` \/ ph \/ ps ) -> ch ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    3ornot23VD $p |- ( ( -. ph /\ -. ps ) -> ( ( ch \/ ph \/ ps ) -> ch ) ) $=
      ( wn wa w3o wi idn1 simpl e1_ simpr ioran simplbi2 e11 idn2 3orass biimpi
      wo e2 orel2 e12 in2 in1 ) ADZBDZEZCABFZCGUFUGCUFABRZDZUGCUHRZCUFUDUEUIUFU
      FUDUFHZUDUEIJUFUFUEUKUDUEKJUIUDUEABLMNUFUGUGUJUFUGOUGUJCABPQSUHCTUAUBUC
      $.
  $}

  ${
    $( Virtual deduction proof of ~ orbi1r . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |- (. ( ph <-> ps ) ->. ( ph <-> ps ) ). `
       <TR> <TD> 2::         <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ph ) `
       ` ->. ( ch \/ ph ) ). `
       <TR> <TD> 3:2,?: ~ e2    <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ph ) `
       ` ->. ( ph \/ ch ) ). `
       <TR> <TD> 4:1,3,?: ~ e12 <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ph ) `
       ` ->. ( ps \/ ch ) ). `
       <TR> <TD> 5:4,?: ~ e2    <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ph ) `
       ` ->. ( ch \/ ps ) ). `
       <TR> <TD> 6:5:        <TD> ` |- (. ( ph <-> ps ) ->. ( ( ch \/ ph ) `
       ` -> ( ch \/ ps ) ) ). `
       <TR> <TD> 7::         <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ps ) `
       ` ->. ( ch \/ ps ) ). `
       <TR> <TD> 8:7,?: ~ e2    <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ps ) `
       ` ->. ( ps \/ ch ) ). `
       <TR> <TD> 9:1,8,?: ~ e12 <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ps ) `
       ` ->. ( ph \/ ch ) ). `
       <TR> <TD> 10:9,?: ~ e2   <TD> ` |- (. ( ph <-> ps ) ,. ( ch \/ ps ) `
       ` ->. ( ch \/ ph ) ). `
       <TR> <TD> 11:10:      <TD> ` |- (. ( ph <-> ps ) ->. ( ( ch \/ ps ) `
       ` -> ( ch \/ ph ) ) ). `
       <TR> <TD> 12:6,11,?: ~ e11 <TD> ` |- (. ( ph <-> ps ) ->. ( ( ch `
       ` \/ ph ) <-> ( ch \/ ps ) ) ). `
       <TR> <TD> qed:12:     <TD> ` |- ( ( ph <-> ps ) -> ( ( ch \/ ph ) `
       ` <-> ( ch \/ ps ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    orbi1rVD $p |- ( ( ph <-> ps ) -> ( ( ch \/ ph ) <-> ( ch \/ ps ) ) ) $=
      ( wb wo wi idn1 idn2 pm1.4 e2 orbi1 biimpd e12 in2 biimprd bi3 e11 in1 )
      ABDZCAEZCBEZDZSTUAFUATFUBSTUASTBCEZUASSTACEZUCSGZSTTUDSTHCAIJSUDUCABCKZLM
      BCIJNSUATSUAUDTSSUAUCUDUESUAUAUCSUAHCBIJSUDUCUFOMACIJNTUAPQR $.
  $}

  ${
    $( Virtual deduction proof of ~ bitr3 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::           <TD> ` |- (. ( ph <-> ps ) ->. ( ph `
       ` <-> ps ) ). `
       <TR> <TD> 2:1,?: ~ e1_     <TD> ` |- (. ( ph <-> ps ) ->. ( ps `
       ` <-> ph ) ). `
       <TR> <TD> 3::           <TD> ` |- (. ( ph <-> ps ) ,. ( ph <-> ch ) `
       ` ->. ( ph <-> ch ) ). `
       <TR> <TD> 4:3,?: ~ e2      <TD> ` |- (. ( ph <-> ps ) ,. ( ph <-> ch ) `
       ` ->. ( ch <-> ph ) ). `
       <TR> <TD> 5:2,4,?: ~ e12   <TD> ` |- (. ( ph <-> ps ) ,. ( ph <-> ch ) `
       ` ->. ( ps <-> ch ) ). `
       <TR> <TD> 6:5:          <TD> ` |- (. ( ph <-> ps ) ->. ( ( ph `
       ` <-> ch ) -> ( ps <-> ch ) ) ). `
       <TR> <TD> qed:6:        <TD> ` |- ( ( ph <-> ps ) -> ( ( ph <-> ch ) `
       ` -> ( ps <-> ch ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    bitr3VD $p |- ( ( ph <-> ps ) -> ( ( ph <-> ch ) -> ( ps <-> ch ) ) ) $=
      ( wb id bicomd biantr ex syl2im ) ABDZBADZACDZCADZBCDZJABJEFLACLEFKMNBACG
      HI $.
  $}

  ${
    $( Virtual deduction proof of ~ 3orbi123 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) )  ->. ( ( ph <-> ps ) /\ ( ch <-> th ) /\ `
       ` ( ta <-> et ) ) ). `
       <TR> <TD> 2:1,?: ~ e1_   <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) ->. ( ph <-> ps ) ). `
       <TR> <TD> 3:1,?: ~ e1_   <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) ->. ( ch <-> th ) ). `
       <TR> <TD> 4:1,?: ~ e1_   <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) ->. ( ta <-> et ) ). `
       <TR> <TD> 5:2,3,?: ~ e11 <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) ->. ( ( ph \/ ch ) <-> ( ps \/ th ) ) ). `
       <TR> <TD> 6:5,4,?: ~ e11 <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) ->. ( ( ( ph \/ ch ) \/ ta )  <-> ( ( ps \/ th ) `
       ` \/ et ) ) ). `
       <TR> <TD> 7:?:        <TD> ` |- ( ( ( ph \/ ch ) \/ ta ) <-> ( ph `
       ` \/ ch \/ ta ) ) `
       <TR> <TD> 8:6,7,?: ~ e10 <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) ->. ( ( ph \/ ch \/ ta )  <-> ( ( ps \/ th ) `
       ` \/ et ) ) ). `
       <TR> <TD> 9:?:        <TD> ` |- ( ( ( ps \/ th ) \/ et ) <-> `
       ` ( ps \/ th \/ et ) ) `
       <TR> <TD> 10:8,9,?: ~ e10 <TD> ` |- (. ( ( ph <-> ps ) /\ ( ch `
       ` <-> th ) /\ ( ta <-> et ) ) ->. ( ( ph \/ ch \/ ta ) <-> ( ps \/ `
       ` th \/ et ) ) ). `
       <TR> <TD> qed:10:       <TD> ` |- ( ( ( ph <-> ps ) /\ ( ch <-> th ) `
       ` /\ ( ta <-> et ) ) -> ( ( ph \/ ch \/ ta ) <-> ( ps \/ th `
       ` \/ et ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    3orbi123VD $p |- ( ( ( ph <-> ps ) /\ ( ch <-> th ) /\ ( ta <-> et ) ) ->
                   ( ( ph \/ ch \/ ta ) <-> ( ps \/ th \/ et ) ) ) $=
      ( wb w3a w3o wo idn1 simp1 e1_ simp2 pm4.39 ex e11 df-3or bicomi e10 bitr
      simp3 bitr3 com12 in1 ) ABGZCDGZEFGZHZACEIZBDFIZGZUIUJBDJZFJZGZUNUKGZULUI
      ACJZEJZUNGZURUJGZUOUIUQUMGZUHUSUIUFUGVAUIUIUFUIKZUFUGUHLMUIUIUGVBUFUGUHNM
      UFUGVAACBDOPQUIUIUHVBUFUGUHUBMVAUHUSUQEUMFOPQUJURACERSUTUSUOURUJUNUCUDTUK
      UNBDFRSUOUPULUJUNUKUAPTUE $.
  $}

  $( Virtual deduction proof of ~ sbc3orgOLD . The following user's proof is
     completed by invoking mmj2's unify command and using mmj2's StepSelector
     to pick all remaining steps of the Metamath proof.
     <HTML> <TABLE>
     <TR> <TD> 1::           <TD> ` |- (. A e. B ->. A e. B ). `
     <TR> <TD> 2:1,?: ~ e1_     <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ( ph `
     ` \/ ps ) \/ ch ) <-> ( [. A / x ]. ( ph \/ ps ) `
     ` \/ [. A / x ]. ch ) ) ). `
     <TR> <TD> 3::           <TD> ` |- ( ( ( ph \/ ps ) \/ ch ) <-> ( ph `
     ` \/ ps \/ ch ) ) `
     <TR> <TD> 32:3:         <TD> ` |- A. x ( ( ( ph \/ ps ) \/ ch ) `
     ` <-> ( ph \/ ps \/ ch ) ) `
     <TR> <TD> 33:1,32,?: ~ e10 <TD> ` |- (. A e. B ->. [. A / x ]. ( ( ( ph `
     ` \/ ps ) \/ ch ) <-> ( ph \/ ps \/ ch ) ) ). `
     <TR> <TD> 4:1,33,?: ~ e11  <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ( ph `
     ` \/ ps ) \/ ch ) <-> [. A / x ]. ( ph \/ ps \/ ch ) ) ). `
     <TR> <TD> 5:2,4,?: ~ e11   <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph `
     ` \/ ps \/ ch ) <-> ( [. A / x ]. ( ph \/ ps ) \/ [. A / x ]. ch ) ) ). `
     <TR> <TD> 6:1,?: ~ e1_     <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph `
     ` \/ ps ) <-> ( [. A / x ]. ph \/ [. A / x ]. ps ) ) ). `
     <TR> <TD> 7:6,?: ~ e1_     <TD> ` |- (. A e. B ->. ( ( [. A / x ]. ( ph `
     ` \/ ps ) \/ [. A / x ]. ch ) <-> ( ( [. A / x ]. ph \/ [. A / x ]. ps ) `
     ` \/ [. A / x ]. ch ) ) ). `
     <TR> <TD> 8:5,7,?: ~ e11   <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph `
     ` \/ ps \/ ch ) <-> ( ( [. A / x ]. ph \/ [. A / x ]. ps ) `
     ` \/ [. A / x ]. ch ) ) ). `
     <TR> <TD> 9:?:          <TD> ` |- ( ( ( [. A / x ]. ph `
     ` \/ [. A / x ]. ps ) \/ [. A / x ]. ch ) <-> ( [. A / x ]. ph `
     ` \/ [. A / x ]. ps \/ [. A / x ]. ch ) ) `
     <TR> <TD> 10:8,9,?: ~ e10  <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph `
     ` \/ ps \/ ch ) <-> ( [. A / x ]. ph \/ [. A / x ]. ps `
     ` \/ [. A / x ]. ch ) ) ). `
     <TR> <TD> qed:10:       <TD> ` |- ( A e. B -> ( [. A / x ]. ( ph `
     ` \/ ps \/ ch ) <-> ( [. A / x ]. ph \/ [. A / x ]. ps `
     ` \/ [. A / x ]. ch ) ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  sbc3orgVD $p |- ( A e. B -> ( [. A / x ]. ( ph \/ ps \/ ch ) <->
                ( [. A / x ]. ph \/ [. A / x ]. ps \/ [. A / x ]. ch ) ) ) $=
    ( wcel w3o wsbc wb idn1 sbcorgOLD e1_ df-3or bicomi e10 e11 bibi1 biimprd
    wo wal ax-gen spsbc sbcbig biimpd bitr3 com12 orbi1 in1 ) EFGZABCHZDEIZADEI
    ZBDEIZCDEIZHZJZUJULUMUNTZUOTZJZUSUPJZUQUJULABTZDEIZUOTZJZVDUSJZUTUJVBCTZDEI
    ZVDJZVHULJZVEUJUJVIUJKZVBCDEFLMUJUJVGUKJZDEIZVJVKUJUJVLDUAVMVKVLDUKVGABCNOU
    BVLDEFUCPUJVMVJVGUKDEFUDUEQVJVIVEVHULVDUFUGQUJVCURJZVFUJUJVNVKABDEFLMVCURUO
    UHMVEUTVFULVDUSRSQUPUSUMUNUONOUTUQVAULUSUPRSPUI $.


  ${
    $d x ps $.  $d x ch $.
    $( Virtual deduction proof of ~ alrim3con13v . The following user's
       proof is completed by invoking mmj2's unify command and using mmj2's
       StepSelector to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::            <TD> ` |- (. ( ph -> A. x ph ) `
       ` ->. ( ph -> A. x ph ) ). `
       <TR> <TD> 2::            <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps /\ ph `
       ` /\
       ch ) ->. ( ps /\ ph /\ ch ) ). `
       <TR> <TD> 3:2,?: ~ e2       <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. ps ). `
       <TR> <TD> 4:2,?: ~ e2       <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. ph ). `
       <TR> <TD> 5:2,?: ~ e2       <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. ch ). `
       <TR> <TD> 6:1,4,?: ~ e12    <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. A. x ph ). `
       <TR> <TD> 7:3,?: ~ e2       <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. A. x ps ). `
       <TR> <TD> 8:5,?: ~ e2       <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. A. x ch ). `
       <TR> <TD> 9:7,6,8,?: ~ e222 <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. ( A. x ps /\ A. x ph /\ A. x ch ) ). `
       <TR> <TD> 10:9,?: ~ e2      <TD> ` |- (. ( ph -> A. x ph ) ,. ( ps `
       ` /\ ph /\ ch ) ->. A. x ( ps /\ ph /\ ch ) ). `
       <TR> <TD> 11:10:in2      <TD> ` |- (. ( ph -> A. x ph ) ->. ( ( ps `
       ` /\ ph /\ ch ) -> A. x ( ps /\ ph /\ ch ) ) ). `
       <TR> <TD> qed:11:in1     <TD> ` |- ( ( ph -> A. x ph ) -> ( ( ps `
       ` /\ ph /\ ch ) -> A. x ( ps /\ ph /\ ch ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    19.21a3con13vVD $p |- ( ( ph -> A. x ph ) ->
                        ( ( ps /\ ph /\ ch ) -> A. x ( ps /\ ph /\ ch ) ) ) $=
      ( wal wi w3a idn2 simp1 e2 ax-17 idn1 simp2 simp3 pm3.2an3 e222 19.26-3an
      id e12 biimpri in2 in1 ) AADEZFZBACGZUEDEZFUDUEUFUDUEBDEZUCCDEZGZUFUDUEUG
      UCUHUIUDUEBUGUDUEUEBUDUEHZBACIJBDKJUDUDUEAUCUDLUDUEUEAUJBACMJUDRSUDUECUHU
      DUEUECUJBACNJCDKJUGUCUHOPUFUIBACDQTJUAUB $.
  $}

  ${
    $( Virtual deduction proof of ~ exbir . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |- (. ( ( ph /\ ps ) -> ( ch <-> th ) ) `
       ` ->. ( ( ph /\ ps ) -> ( ch <-> th ) ) ). `
       <TR> <TD> 2::         <TD> ` |- (. ( ( ph /\ ps ) -> ( ch <-> th ) ) ,.
       `
       ` ( ph /\ ps ) ->. ( ph /\ ps ) ). `
       <TR> <TD> 3::         <TD> ` |- (. ( ( ph /\ ps ) -> ( ch <-> th ) ) ,.
       `
       ` ( ph /\ ps ) , th ->. th ). `
       <TR> <TD> 5:1,2,?: ~ e12 <TD> ` |- (. ( ( ph /\ ps ) -> ( ch `
       ` <-> th ) ) , ( ph /\ ps )  ->. ( ch <-> th ) ). `
       <TR> <TD> 6:3,5,?: ~ e32 <TD> ` |- (. ( ( ph /\ ps ) -> ( ch `
       ` <-> th ) ) , ( ph /\ ps ) , th ->. ch ). `
       <TR> <TD> 7:6:        <TD> ` |- (. ( ( ph /\ ps ) -> ( ch `
       ` <-> th ) ) , ( ph /\ ps ) ->. ( th -> ch ) ). `
       <TR> <TD> 8:7:        <TD> ` |- (. ( ( ph /\ ps ) -> ( ch <-> th ) ) `
       ` ->. ( ( ph /\ ps ) -> ( th -> ch ) ) ). `
       <TR> <TD> 9:8,?: ~ e1_   <TD> ` |- (. ( ( ph /\ ps ) -> ( ch `
       ` <-> th ) ) ->. ( ph -> ( ps -> ( th -> ch ) ) ) ). `
       <TR> <TD> qed:9:      <TD> ` |- ( ( ( ph /\ ps ) -> ( ch <-> th ) ) `
       ` -> ( ph -> ( ps -> ( th -> ch ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 13-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    exbirVD $p |- ( ( ( ph /\ ps ) -> ( ch <-> th ) ) ->
                ( ph -> ( ps -> ( th -> ch ) ) ) ) $=
      ( wa wb wi idn3 idn1 idn2 id e12 bi2 com12 e32 in3 in2 pm3.3 e1_ in1 ) AB
      EZCDFZGZABDCGZGGZUCUAUDGUEUCUAUDUCUADCUCUADDUBCUCUADHUCUCUAUAUBUCIUCUAJUC
      KLUBDCCDMNOPQABUDRST $.
  $}

  ${
    exbiriVD.1 $e |- ( ( ph /\ ps ) -> ( ch <-> th ) ) $.
    $( Virtual deduction proof of ~ exbiri . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> h1::        <TD> ` |- ( ( ph /\ ps ) -> ( ch <-> th ) ) `
       <TR> <TD> 2::         <TD> ` |- (. ph ->. ph ). `
       <TR> <TD> 3::         <TD> ` |- (. ph ,. ps ->. ps ). `
       <TR> <TD> 4::         <TD> ` |- (. ph ,. ps ,. th ->. th ). `
       <TR> <TD> 5:2,1,?: ~ e10 <TD> ` |- (. ph ->. ( ps -> ( ch <-> th ) ) ).
       `
       <TR> <TD> 6:3,5,?: ~ e21 <TD> ` |- (. ph ,. ps ->. ( ch <-> th ) ). `
       <TR> <TD> 7:4,6,?: ~ e32 <TD> ` |- (. ph ,. ps ,. th ->. ch ). `
       <TR> <TD> 8:7:        <TD> ` |- (. ph ,. ps ->. ( th -> ch ) ). `
       <TR> <TD> 9:8:        <TD> ` |- (. ph ->. ( ps -> ( th -> ch ) ) ). `
       <TR> <TD> qed:9:      <TD> ` |- ( ph -> ( ps -> ( th -> ch ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    exbiriVD $p |- ( ph -> ( ps -> ( th -> ch ) ) ) $=
      ( wi wb idn3 idn2 wa idn1 pm3.3 com12 e10 pm2.27 e21 bi2 e32 in3 in2 in1
      ) ABDCFZFABUBABDCABDDCDGZCABDHABBBUCFZUCABIAAABJUCFZUDAKEUEAUDABUCLMNBUCO
      PUCDCCDQMRSTUA $.
  $}

  ${
    $d A y $.  $d B x $.  $d D x y $.
    $( Virtual deduction proof of ~ rspsbc2 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::            <TD> ` |- (. A e. B ->. A e. B ). `
       <TR> <TD> 2::            <TD> ` |- (. A e. B ,. C e. D ->. C e. D ). `
       <TR> <TD> 3::            <TD> ` |- (. A e. B ,. C e. D ,. A. x e. B `
       ` A. y e. D ph ->. A. x e. B A. y e. D ph ). `
       <TR> <TD> 4:1,3,?: ~ e13    <TD> ` |- (. A e. B ,. C e. D ,. A. x e. B `
       ` A. y e. D ph ->. [. A / x ]. A. y e. D ph ). `
       <TR> <TD> 5:1,4,?: ~ e13    <TD> ` |- (. A e. B ,. C e. D ,. A. x e. B `
       ` A. y e. D ph ->. A. y e. D [. A / x ]. ph ). `
       <TR> <TD> 6:2,5,?: ~ e23    <TD> ` |- (. A e. B ,. C e. D ,. A. x e. B `
       ` A. y e. D ph ->. [. C / y ]. [. A / x ]. ph ). `
       <TR> <TD> 7:6:           <TD> ` |- (. A e. B ,. C e. D ->. ( A. x e. B `
       ` A. y e. D ph -> [. C / y ]. [. A / x ]. ph ) ). `
       <TR> <TD> 8:7:           <TD> ` |- (. A e. B ->. ( C e. D `
       ` -> ( A. x e. B A. y e. D ph -> [. C / y ]. [. A / x ]. ph ) ) ). `
       <TR> <TD> qed:8:         <TD> ` |- ( A e. B -> ( C e. D `
       ` -> ( A. x e. B A. y e. D ph -> [. C / y ]. [. A / x ]. ph ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    rspsbc2VD $p |- ( A e. B -> ( C e. D -> ( A. x e. B A. y e. D ph ->
                  [. C / y ]. [. A / x ]. ph ) ) ) $=
      ( wcel wral wsbc wi idn2 idn1 idn3 rspsbc e13 sbcralg biimpd e23 in3 in2
      in1 ) DEHZFGHZACGIZBEIZABDJZCFJZKZKUCUDUIUCUDUFUHUCUDUDUFUGCGIZUHUCUDLUCU
      CUDUFUEBDJZUJUCMZUCUCUDUFUFUKULUCUDUFNUEBDEOPUCUKUJABCDGEQRPUGCFGOSTUAUB
      $.

  $}

  ${
    $( Virtual deduction proof of ~ 3impexp . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::                <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> th ) ->. ( ( ph /\ ps /\ ch ) -> th ) ).  `
       <TR> <TD> 2::                <TD> ` |- ( ( ph /\ ps /\ ch ) `
       ` <-> ( ( ph /\ ps ) /\ ch ) )  `
       <TR> <TD> 3:1,2,?: ~ e10        <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> th ) ->. ( ( ( ph /\ ps ) /\ ch ) -> th ) ). `
       <TR> <TD> 4:3,?: ~ e1_          <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> th ) ->. ( ( ph /\ ps ) -> ( ch -> th ) ) ). `
       <TR> <TD> 5:4,?: ~ e1_          <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> th ) ->. ( ph -> ( ps -> ( ch -> th ) ) ) ). `
       <TR> <TD> 6:5:               <TD> ` |- ( ( ( ph /\ ps /\ ch ) -> th ) `
       ` -> ( ph -> ( ps -> ( ch -> th ) ) ) ) `
       <TR> <TD> 7::                <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> th ) ) ) ->. ( ph -> ( ps -> ( ch -> th ) ) ) ). `
       <TR> <TD> 8:7,?: ~ e1_          <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> th ) ) ) ->. ( ( ph /\ ps ) -> ( ch -> th ) ) ). `
       <TR> <TD> 9:8,?: ~ e1_          <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> th ) ) ) ->. ( ( ( ph /\ ps ) /\ ch ) -> th ) ). `
       <TR> <TD> 10:2,9,?: ~ e01       <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> th ) ) ) ->. ( ( ph /\ ps /\ ch ) -> th ) ). `
       <TR> <TD> 11:10:             <TD> ` |- ( ( ph -> ( ps -> ( ch `
       ` -> th ) ) ) -> ( ( ph /\ ps /\ ch ) -> th ) ) `
       <TR> <TD> qed:6,11,?: ~ e00     <TD> ` |- ( ( ( ph /\ ps /\ ch ) `
       ` -> th ) <-> ( ph -> ( ps -> ( ch -> th ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    3impexpVD $p |- ( ( ( ph /\ ps /\ ch ) -> th ) <->
                  ( ph -> ( ps -> ( ch -> th ) ) ) ) $=
      ( w3a wi wb wa idn1 df-3an imbi1 biimpcd e10 pm3.3 e1_ in1 pm3.31 biimprd
      e01 bi3 e00 ) ABCEZDFZABCDFZFFZFUEUCFUCUEGUCUEUCABHZUDFZUEUCUFCHZDFZUGUCU
      CUBUHGZUIUCIABCJZUJUCUIUBUHDKZLMUFCDNOABUDNOPUEUCUJUEUIUCUKUEUGUIUEUEUGUE
      IABUDQOUFCDQOUJUCUIULRSPUCUETUA $.
  $}

  ${
    $( Virtual deduction proof of ~ 3impexpbicom . The following user's proof
       is completed by invoking mmj2's unify command and using mmj2's
       StepSelector to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::                <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> ( th <-> ta ) ) ->. ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) ). `
       <TR> <TD> 2::                <TD> ` |- ( ( th <-> ta ) <-> ( ta `
       ` <-> th ) ) `
       <TR> <TD> 3:1,2,?: ~ e10        <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> ( th <-> ta ) ) ->. ( ( ph /\ ps /\ ch ) -> ( ta <-> th ) ) ). `
       <TR> <TD> 4:3,?: ~ e1_          <TD> ` |- (. ( ( ph /\ ps /\ ch ) `
       ` -> ( th <-> ta ) ) ->. ( ph -> ( ps -> ( ch -> ( ta `
       ` <-> th ) ) ) ) ). `
       <TR> <TD> 5:4:               <TD> ` |- ( ( ( ph /\ ps /\ ch ) `
       ` -> ( th <-> ta ) ) -> ( ph -> ( ps -> ( ch -> ( ta `
       ` <-> th ) ) ) ) ) `
       <TR> <TD> 6::                <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> ( ta <-> th ) ) ) ) ->. ( ph -> ( ps -> ( ch -> ( ta `
       ` <-> th ) ) ) ) ). `
       <TR> <TD> 7:6,?: ~ e1_          <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> ( ta <-> th ) ) ) ) ->. ( ( ph /\ ps /\ ch ) -> ( ta `
       ` <-> th ) ) ). `
       <TR> <TD> 8:7,2,?: ~ e10        <TD> ` |- (. ( ph -> ( ps -> ( ch `
       ` -> ( ta <-> th ) ) ) ) ->. ( ( ph /\ ps /\ ch ) -> ( th `
       ` <-> ta ) ) ). `
       <TR> <TD> 9:8:               <TD> ` |- ( ( ph -> ( ps -> ( ch `
       ` -> ( ta <-> th ) ) ) ) -> ( ( ph /\ ps /\ ch ) -> ( th `
       ` <-> ta ) ) ) `
       <TR> <TD> qed:5,9,?: ~ e00      <TD> ` |- ( ( ( ph /\ ps /\ ch ) `
       ` -> ( th <-> ta ) ) <-> ( ph -> ( ps -> ( ch -> ( ta `
       ` <-> th ) ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    3impexpbicomVD $p |- ( ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) <->
                       ( ph -> ( ps -> ( ch -> ( ta <-> th ) ) ) ) ) $=
      ( w3a wb idn1 bicom imbi2 biimpcd e10 3impexp biimpi e1_ biimpri biimprcd
      wi in1 bi3 e00 ) ABCFZDEGZRZABCEDGZRRRZRUFUDRUDUFGUDUFUDUBUERZUFUDUDUCUEG
      ZUGUDHDEIZUHUDUGUCUEUBJZKLUGUFABCUEMZNOSUFUDUFUGUHUDUFUFUGUFHUGUFUKPOUIUH
      UDUGUJQLSUDUFTUA $.
  $}

  ${
    3impexpbicomiVD.1 $e |- ( ( ph /\ ps /\ ch ) -> ( th <-> ta ) ) $.
    $( Virtual deduction proof of ~ 3impexpbicomi . The following user's proof
       is completed by invoking mmj2's unify command and using mmj2's
       StepSelector to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> h1::               <TD> ` |- ( ( ph /\ ps /\ ch ) -> ( th `
       ` <-> ta ) ) `
       <TR> <TD> qed:1,?: ~ e0_        <TD> ` |- ( ph -> ( ps -> ( ch `
       ` -> ( ta <-> th ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    3impexpbicomiVD $p |- ( ph -> ( ps -> ( ch -> ( ta <-> th ) ) ) ) $=
      ( w3a wb wi 3impexpbicom biimpi e0_ ) ABCGDEHIZABCEDHIIIZFMNABCDEJKL $.
  $}

  ${
    $d A y $.  $d x y $.
    $( Virtual deduction proof of ~ sbcoreleleq . The following user's proof
       is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::            <TD> ` |- (. A e. B ->. A e. B ). `
       <TR> <TD> 2:1,?: ~ e1_      <TD> ` |- (. A e. B ->. ( [. A / y ]. x e. `
       ` y <-> x e. A ) ). `
       <TR> <TD> 3:1,?: ~ e1_      <TD> ` |- (. A e. B ->. ( [. A / y ]. y e. `
       ` x <-> A e. x ) ). `
       <TR> <TD> 4:1,?: ~ e1_      <TD> ` |- (. A e. B ->. ( [. A / y ]. x = `
       ` y <-> x = A ) ). `
       <TR> <TD> 5:2,3,4,?: ~ e111 <TD> ` |- (. A e. B ->. ( ( x e. A `
       ` \/ A e. x \/ x = A ) <-> ( [. A / y ]. x e. y \/ [. A / y ]. y e. x `
       ` \/ [. A / y ]. x = y ) ) ). `
       <TR> <TD> 6:1,?: ~ e1_      <TD> ` |- (. A e. B `
       ` ->. ( [. A / y ]. ( x e. y \/ y e. x \/ x = y ) <-> ( [. A / y ]. x `
       ` e. y \/ [. A / y ]. y e. x \/ [. A / y ]. x = y ) ) ). `
       <TR> <TD> 7:5,6: ~ e11      <TD> ` |- (. A e. B ->. ( [. A / y ]. ( x `
       ` e. y \/ y e. x \/ x = y ) <-> ( x e. A \/ A e. x \/ x = A ) ) ).  `
       <TR> <TD> qed:7:         <TD> ` |- ( A e. B -> ( [. A / y ]. ( x e. y `
       ` \/ y e. x \/ x = y ) <-> ( x e. A \/ A e. x \/ x = A ) ) )  `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    sbcoreleleqVD $p |- ( A e. B
       -> ( [. A / y ]. ( x e. y \/ y e. x \/ x = y )
             <-> ( x e. A \/ A e. x \/ x = A ) ) ) $=
      ( wcel cv wceq w3o wsbc wb idn1 sbcel2gv e1_ sbcel1gvOLD eqsbc3r 3orbi123
      3impexpbicomi e111 sbc3orgOLD biantr expcom e11 in1 ) CDEAFBFEBFAFEAFBFGH
      BCIAFCECAFEAFCGHJCDEAFCECAFEAFCGHAFBFEBCIBFAFEBCIAFBFGBCIHJAFBFEBFAFEAFBF
      GHBCIAFBFEBCIBFAFEBCIAFBFGBCIHJAFBFEBFAFEAFBFGHBCIAFCECAFEAFCGHJCDEAFBFEB
      CIAFCEJBFAFEBCICAFEJAFBFGBCIAFCGJAFCECAFEAFCGHAFBFEBCIBFAFEBCIAFBFGBCIHJC
      DECDEAFBFEBCIAFCEJCDEKBAFCDLMCDECDEBFAFEBCICAFEJCDEKBCAFDNMCDECDEAFBFGBCI
      AFCGJCDEKBCAFDOMAFBFEBCIAFCEJBFAFEBCICAFEJAFBFGBCIAFCGJAFBFEBCIBFAFEBCIAF
      BFGBCIHAFCECAFEAFCGHAFBFEBCIAFCEBFAFEBCICAFEAFBFGBCIAFCGPQRCDECDEAFBFEBFA
      FEAFBFGHBCIAFBFEBCIBFAFEBCIAFBFGBCIHJCDEKAFBFEBFAFEAFBFGBCDSMAFBFEBFAFEAF
      BFGHBCIAFBFEBCIBFAFEBCIAFBFGBCIHJAFCECAFEAFCGHAFBFEBCIBFAFEBCIAFBFGBCIHJA
      FBFEBFAFEAFBFGHBCIAFCECAFEAFCGHJAFBFEBFAFEAFBFGHBCIAFBFEBCIBFAFEBCIAFBFGB
      CIHAFCECAFEAFCGHTUAUBUC $.

  $}

  ${
    $d A y $.  $d B x $.  $d x y $.
    $( Virtual deduction proof of ~ nfra2 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's
       StepSelector to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::              <TD> ` |- ( A. y e. B A. x e. A ph -> `
       ` A. y A. y e. B A. x e. A ph ) `
       <TR> <TD> 2::              <TD> ` |- ( A. x e. A A. y e. B ph <-> `
       ` A. y e. B A. x e. A ph ) `
       <TR> <TD> 3:1,2,?: ~ e00   <TD> ` |- ( A. x e. A A. y e. B ph -> `
       ` A. y A. y e. B A. x e. A ph ) `
       <TR> <TD> 4:2:             <TD> ` |- A. y ( A. x e. A A. y e. B ph <-> `
       ` A. y e. B A. x e. A ph ) `
       <TR> <TD> 5:4,?: ~ e0_     <TD> ` |- ( A. y A. x e. A A. y e. B ph <-> `
       ` A. y A. y e. B A. x e. A ph ) `
       <TR> <TD> qed:3,5,?: ~ e00 <TD> ` |- ( A. x e. A A. y e. B ph -> `
       ` A. y A. x e. A A. y e. B ph ) `
       </HTML> </TABLE>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    hbra2VD $p |- ( A. x e. A A. y e. B ph -> A. y A. x e. A A. y e. B ph ) $=
      ( wral ralcom hbra1 hbxfrbi ) ACEFBDFABDFZCEFCABCDEGJCEHI $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( Virtual deduction proof of ~ tratrb . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::                <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) `
       ` ->. ( Tr A /\ A. x e. A A. y e. A ( x e. y \/ y e. x \/ x = y ) `
       ` /\ B e. A ) ). `
       <TR> <TD> 2:1,?: ~ e1_          <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ->. Tr A ). `
       <TR> <TD> 3:1,?: ~ e1_          <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) `
       ` ->. A. x e. A A. y e. A ( x e. y \/ y e. x \/ x = y ) ). `
       <TR> <TD> 4:1,?: ~ e1_          <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ->. B e. A ). `
       <TR> <TD> 5::                <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. ( x e. y /\ y e. B ) ). `
       <TR> <TD> 6:5,?: ~ e2           <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. x e. y ). `
       <TR> <TD> 7:5,?: ~ e2           <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. y e. B ). `
       <TR> <TD> 8:2,7,4,?: ~ e121     <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. y e. A ). `
       <TR> <TD> 9:2,6,8,?: ~ e122     <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. x e. A ).  `
       <TR> <TD> 10::               <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) , B e. x ->. B e. x ). `
       <TR> <TD> 11:6,7,10,?: ~ e223   <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) , B e. x ->. ( x e. y /\ y e. B /\ B e. x ) ). `
       <TR> <TD> 12:11:             <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. ( B e. x -> ( x e. y /\ y e. B /\ B e. x ) ) ). `
       <TR> <TD> 13::               <TD> ` |- -. ( x e. y /\ y e. B `
       ` /\ B e. x ) `
       <TR> <TD> 14:12,13,?: ~ e20     <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. -. B e. x ). `
       <TR> <TD> 15::               <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) , x = B ->. x = B ). `
       <TR> <TD> 16:7,15,?: ~ e23      <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) , x = B ->. y e. x ). `
       <TR> <TD> 17:6,16,?: ~ e23      <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) , x = B ->. ( x e. y /\ y e. x ) ). `
       <TR> <TD> 18:17:             <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. ( x = B -> ( x e. y /\ y e. x ) ) ). `
       <TR> <TD> 19::               <TD> ` |- -. ( x e. y /\ y e. x ) `
       <TR> <TD> 20:18,19,?: ~ e20     <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. -. x = B ). `
       <TR> <TD> 21:3,?: ~ e1_         <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ->. A. y e. A `
       ` A. x e. A ( x e. y \/ y e. x \/ x = y ) ). `
       <TR> <TD> 22:21,9,4,?: ~ e121   <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. [. x / x ]. [. B / y ]. ( x e. y \/ y e. x `
       ` \/ x = y ) ). `
       <TR> <TD> 23:22,?: ~ e2         <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. [. B / y ]. ( x e. y \/ y e. x \/ x = y ) ). `
       <TR> <TD> 24:4,23,?: ~ e12      <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. ( x e. B \/ B e. x \/ x = B ) ). `
       <TR> <TD> 25:14,20,24,?: ~ e222 <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) , ( x e. y `
       ` /\ y e. B ) ->. x e. B ). `
       <TR> <TD> 26:25:             <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ->. ( ( x e. y `
       ` /\ y e. B ) -> x e. B ) ). `
       <TR> <TD> 27::               <TD> ` |- ( A. x e. A A. y e. A ( x e. y `
       ` \/ y e. x \/ x = y ) -> A. y A. x e. A A. y e. A ( x e. y \/ `
       ` y e. x \/ x = y ) ) `
       <TR> <TD> 28:27,?: ~ e0_        <TD> ` |- ( ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) `
       ` -> A. y ( Tr A /\ A. x e. A A. y e. A ( x e. y \/ y e. x `
       ` \/ x = y ) /\ B e. A ) ) `
       <TR> <TD> 29:28,26:          <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) `
       ` ->. A. y ( ( x e. y /\ y e. B ) -> x e. B ) ). `
       <TR> <TD> 30::               <TD> ` |- ( A. x e. A A. y e. A ( x e. y `
       ` \/ y e. x \/ x = y ) -> A. x A. x e. A A. y e. A ( x e. y `
       ` \/ y e. x \/ x = y ) ) `
       <TR> <TD> 31:30,?: ~ e0_        <TD> ` |- ( ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) -> A. x ( Tr A `
       ` /\ A. x e. A A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ) `
       <TR> <TD> 32:31,29:          <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ->. A. x `
       ` A. y ( ( x e. y /\ y e. B ) -> x e. B ) ). `
       <TR> <TD> 33:32,?: ~ e1_        <TD> ` |- (. ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) ->. Tr B ). `
       <TR> <TD> qed:33:            <TD> ` |- ( ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A ) -> Tr B ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    tratrbVD $p |- ( ( Tr A
           /\ A. x e. A A. y e. A ( x e. y \/ y e. x \/ x = y ) /\ B e. A )
        -> Tr B ) $=
      ( wtr wel weq w3o wral wcel w3a cv wa wi wal hbra1 alrim3con13v wn e2 e1_
      e0_ ax-17 hbral wceq idn2 simpl simpr idn3 pm3.2an3 e223 en3lp con3 eleq2
      in3 e20 biimprcd e23 pm3.2 en2lp wsbc idn1 simp3 simp2 ralcom2 simp1 trel
      exp3a e121 rspsbc2 com13 wb equid sbceq2a ax-mp biimpi sbcoreleleq biimpd
      e122 e12 3ornot23 ex e222 in2 gen11nv dftr2 biimpri in1 ) CEZABFZBAFZABGH
      ZBCIZACIZDCJZKZDEZWOWIBLZDJZMZALZDJZNZBOZAOZWPWOXCAWMWMAONWOWOAONWLACPWMW
      HWNAQUAWOXBBWMWMBONWOWOBONWLBACWTCJZBUBWKBCPUCWMWHWNBQUAWOWSXAWOWSDWTJZRZ
      WTDUDZRZXAXFXHHZXAWOWSXFWIWRXFKZNXKRXGWOWSXFXKWOWSWIWRXFXFXKWOWSWSWIWOWSU
      EZWIWRUFSZWOWSWSWRXLWIWRUGSZWOWSXFUHWIWRXFUIUJUNWTWQDUKXFXKULUOWOWSXHWIWJ
      MZNXORXIWOWSXHXOWOWSWIXHWJXOXMWOWSWRXHXHWJXNWOWSXHUHXHWJWRWTDWQUMUPUQWIWJ
      URUQUNWTWQUSXHXOULUOWOWNWSWKBDUTZXJWOWOWNWOVAZWHWMWNVBTZWOWSXPAWTUTZXPWOW
      KACIBCIZWSXEWNXSWOWMXTWOWOWMXQWHWMWNVCTWKABCVDTWOWHWSWIWQCJZXEWOWOWHXQWHW
      MWNVETZXMWOWHWSWRWNYAYBXNXRWHWRWNYACWQDVFVGVHWHWIYAXECWTWQVFVGVRXRWNXEXTX
      SWKBADCWTCVIVJVHXSXPAAGXSXPVKAVLXPAWTVMVNVOSWNXPXJABDCVPVQVSXGXIXJXANXFXH
      XAVTWAWBWCWDWDWPXDABDWEWFTWG $.
  $}

  ${
    $( Virtual deduction proof of ~ 3ax5 . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |- (. A. x ( ph -> ( ps -> ch ) ) `
       ` ->. A. x ( ph -> ( ps -> ch ) ) ). `
       <TR> <TD> 2:1,?: ~ e1_   <TD> ` |- (. A. x ( ph -> ( ps -> ch ) ) `
       ` ->. ( A. x ph -> A. x ( ps -> ch ) ) ). `
       <TR> <TD> 3::         <TD> ` |- ( A. x ( ps -> ch ) -> ( A. x ps `
       ` -> A. x ch ) ) `
       <TR> <TD> 4:2,3,?: ~ e10 <TD> ` |- (. A. x ( ph -> ( ps -> ch ) ) `
       ` ->. ( A. x ph -> ( A. x ps -> A. x ch ) ) ). `
       <TR> <TD> qed:4:      <TD> ` |- ( A. x ( ph -> ( ps -> ch ) ) `
       ` -> ( A. x ph -> ( A. x ps -> A. x ch ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    3ax5VD $p |- ( A. x ( ph -> ( ps -> ch ) ) -> ( A. x ph ->
               ( A. x ps -> A. x ch ) ) ) $=
      ( wi wal idn1 ax-5 e1_ imim1 e10 in1 ) ABCEZEDFZADFZBDFCDFEZEZNOMDFZEZRPE
      QNNSNGAMDHIBCDHORPJKL $.
  $}

  ${
    $( Virtual deduction proof of ~ syl5imp . The following user's proof is
       completed by invoking mmj2's unify command and using mmj2's StepSelector
       to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |- (. ( ph -> ( ps -> ch ) ) ->. ( ph `
       ` -> ( ps -> ch ) ) ). `
       <TR> <TD> 2:1,?: ~ e1_   <TD> ` |- (. ( ph -> ( ps -> ch ) ) ->. ( ps `
       ` -> ( ph -> ch ) ) ). `
       <TR> <TD> 3::         <TD> ` |- (. ( ph -> ( ps -> ch ) ) ,. ( th `
       ` -> ps ) ->. ( th -> ps ) ). `
       <TR> <TD> 4:3,2,?: ~ e21 <TD> ` |- (. ( ph -> ( ps -> ch ) ) ,. ( th `
       ` -> ps )  ->. ( th -> ( ph -> ch ) ) ). `
       <TR> <TD> 5:4,?: ~ e2    <TD> ` |- (. ( ph -> ( ps -> ch ) ) ,. ( th `
       ` -> ps )  ->. ( ph -> ( th -> ch ) ) ). `
       <TR> <TD> 6:5:        <TD> ` |- (. ( ph -> ( ps -> ch ) ) ->. ( ( th `
       ` -> ps ) -> ( ph -> ( th -> ch ) ) ) ). `
       <TR> <TD> qed:6:      <TD> ` |- ( ( ph -> ( ps -> ch ) ) -> ( ( th `
       ` -> ps ) -> ( ph -> ( th -> ch ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    syl5impVD $p |- ( ( ph -> ( ps -> ch ) ) -> ( ( th -> ps ) ->
                  ( ph -> ( th -> ch ) ) ) ) $=
      ( wi idn2 idn1 pm2.04 e1_ imim1 e21 e2 in2 in1 ) ABCEEZDBEZADCEEZEOPQOPDA
      CEZEZQOPPBREZSOPFOOTOGABCHIDBRJKDACHLMN $.
  $}

  ${
    idiVD.1 $e |- ph $.
    $( Virtual deduction proof of ~ idi . The following user's
       proof is completed by invoking mmj2's unify command and using mmj2's
       StepSelector to pick all remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> h1::        <TD> ` |- ph `
       <TR> <TD> qed:1,?: ~ e0_ <TD> ` |- ph `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 31-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    idiVD $p |- ph $=
      ( id e0_ ) AABACD $.
  $}

  ${
    $( Closed form of ~ ancoms . The following user's proof is completed by
       invoking mmj2's unify command and using mmj2's StepSelector to pick all
       remaining steps of the Metamath proof.
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |-  ( ( ph /\ ps ) <-> ( ps /\ ph ) )  `
       <TR> <TD> qed:1,?: ~ e0_ <TD> ` |- ( ( ( ph /\ ps ) -> ch ) <-> ( ( ps `
       ` /\ ph ) -> ch ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 25-Dec-2011.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    ancomsimpVD $p |- ( ( ( ph /\ ps ) -> ch ) <-> ( ( ps /\ ph ) -> ch ) ) $=
      ( wa wb wi ancom imbi1 e0_ ) ABDZBADZEJCFKCFEABGJKCHI $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.  $d C y $.  $d D x $.  $d D y $.
    $( Quantification restricted to a subclass for two quantifiers.  ~ ssralv
       for two quantifiers.  The following User's Proof is a Virtual Deduction
       proof completed automatically by the tools program
       completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm
       Megill's Metamath Proof Assistant. ~ ssralv2 is ~ ssralv2VD without
       virtual deductions and was automatically derived from ~ ssralv2VD .
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- (. ( A C_ B /\ C C_ D ) ->. ( A C_ B `
       ` /\ C C_ D ) ). `
       <TR> <TD> 2::          <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. A. x e. B A. y e. D ph ). `
       <TR> <TD> 3:1:         <TD> ` |- (. ( A C_ B /\ C C_ D ) ->. A C_ B ). `
       <TR> <TD> 4:3,2:       <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. A. x e. A A. y e. D ph ). `
       <TR> <TD> 5:4:         <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. A. x ( x e. A -> A. y e. D ph ) ). `
       <TR> <TD> 6:5:         <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. ( x e. A -> A. y e. D ph ) ). `
       <TR> <TD> 7::          <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph , x e. A ->. x e. A ). `
       <TR> <TD> 8:7,6:       <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph , x e. A ->. A. y e. D ph ). `
       <TR> <TD> 9:1:         <TD> ` |- (. ( A C_ B /\ C C_ D ) ->. C C_ D ). `
       <TR> <TD> 10:9,8:      <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph , x e. A ->. A. y e. C ph ). `
       <TR> <TD> 11:10:       <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. ( x e. A -> A. y e. C ph ) ). `
       <TR> <TD> 12::         <TD> ` |- ( ( A C_ B /\ C C_ D ) `
       ` -> A. x ( A C_ B /\ C C_ D ) ) `
       <TR> <TD> 13::         <TD> ` |- ( A. x e. B A. y e. D ph `
       ` -> A. x A. x e. B A. y e. D ph ) `
       <TR> <TD> 14:12,13,11: <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. A. x ( x e. A -> A. y e. C ph ) ). `
       <TR> <TD> 15:14:       <TD> ` |- (. ( A C_ B /\ C C_ D ) ,. A. x e. B `
       ` A. y e. D ph ->. A. x e. A A. y e. C ph ). `
       <TR> <TD> 16:15:       <TD> ` |- (. ( A C_ B /\ C C_ D ) `
       ` ->. ( A. x e. B A. y e. D ph -> A. x e. A A. y e. C ph ) ). `
       <TR> <TD> qed:16:      <TD> ` |- ( ( A C_ B /\ C C_ D ) `
       ` -> ( A. x e. B A. y e. D ph -> A. x e. A A. y e. C ph ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 10-Feb-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    ssralv2VD $p |- ( ( A C_ B /\ C C_ D ) -> ( A. x e. B A. y e. D ph ->
                    A. x e. A A. y e. C ph ) ) $=
      ( wss wa wral wi cv wcel wal ax-17 hbra1 e1_ ssralv df-ral e2 simpr simpl
      idn1 idn3 idn2 e12 biimpi sp pm2.27 e32 e13 in3 gen21nv biimpri in2 in1 )
      DEHZFGHZIZACGJZBEJZACFJZBDJZKUSVAVCUSVABLDMZVBKZBNZVCUSVAVEBUSBOUTBEPUSVA
      VDVBUSURVAVDUTVBUSUSURUSUCZUQURUAQUSVAVDVDVDUTKZUTUSVAVDUDUSVAVHBNZVHUSVA
      UTBDJZVIUSUQVAVAVJUSUSUQVGUQURUBQUSVAUEUTBDERUFVJVIUTBDSUGTVHBUHTVDUTUIUJ
      ACFGRUKULUMVCVFVBBDSUNTUOUP $.
  $}

  ${
    $d A x y $.  $d B x y $.
    $( An element of an ordinal class is ordinal.  Proposition 7.6 of
       [TakeutiZaring] p. 36.  This is an alternate proof of ~ ordelord using
       the Axiom of Regularity indirectly through ~ dford2 .  dford2 is a
       weaker definition of ordinal number.  Given the Axiom of Regularity, it
       need not be assumed that ` _E Fr A ` because this is inferred by the
       Axiom of Regularity.  The following User's Proof is a Virtual Deduction
       proof completed automatically by the tools program
       completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm
       Megill's Metamath Proof Assistant. ~ ordelordALT is ~ ordelordALTVD
       without virtual deductions and was automatically derived from
       ~ ordelordALTVD using the tools program
       translate..without..overwriting.cmd and Metamath's minimize command.
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- (. ( Ord A /\ B e. A ) ->. ( Ord A `
       ` /\ B e. A ) ). `
       <TR> <TD> 2:1:       <TD> ` |- (. ( Ord A /\ B e. A ) ->. Ord A ). `
       <TR> <TD> 3:1:       <TD> ` |- (. ( Ord A /\ B e. A ) ->. B e. A ). `
       <TR> <TD> 4:2:       <TD> ` |- (. ( Ord A /\ B e. A ) ->. Tr A ). `
       <TR> <TD> 5:2:       <TD> ` |- (. ( Ord A /\ B e. A ) ->. A. x e. A `
       ` A. y e. A ( x e. y \/ x = y \/ y e. x ) ). `
       <TR> <TD> 6:4,3:     <TD> ` |- (. ( Ord A /\ B e. A ) ->. B C_ A ). `
       <TR> <TD> 7:6,6,5:   <TD> ` |- (. ( Ord A /\ B e. A ) ->. A. x e. B `
       ` A. y e. B ( x e. y \/ x = y \/ y e. x ) ). `
       <TR> <TD> 8::        <TD> ` |- ( ( x e. y \/ x = y \/ y e. x ) `
       ` <-> ( x e. y \/ y e. x \/ x = y ) ) `
       <TR> <TD> 9:8:       <TD> ` |- A. y ( ( x e. y \/ x = y \/ y e. x ) `
       ` <-> ( x e. y \/ y e. x \/ x = y ) ) `
       <TR> <TD> 10:9:      <TD> ` |- A. y e. A ( ( x e. y \/ x = y `
       ` \/ y e. x ) <-> ( x e. y \/ y e. x \/ x = y ) ) `
       <TR> <TD> 11:10:     <TD> ` |- ( A. y e. A ( x e. y \/ x = y `
       ` \/ y e. x ) <-> A. y e. A ( x e. y \/ y e. x \/ x = y ) ) `
       <TR> <TD> 12:11:     <TD> ` |- A. x ( A. y e. A ( x e. y \/ x = y `
       ` \/ y e. x ) <-> A. y e. A ( x e. y \/ y e. x \/ x = y ) ) `
       <TR> <TD> 13:12:     <TD> ` |- A. x e. A ( A. y e. A ( x e. y `
       ` \/ x = y \/ y e. x ) <-> A. y e. A ( x e. y \/ y e. x \/ x = y ) ) `
       <TR> <TD> 14:13:     <TD> ` |- ( A. x e. A A. y e. A ( x e. y `
       ` \/ x = y \/ y e. x ) <-> A. x e. A A. y e. A ( x e. y \/ y e. x `
       ` \/ x = y ) ) `
       <TR> <TD> 15:14,5:   <TD> ` |- (. ( Ord A /\ B e. A ) ->. A. x e. A `
       ` A. y e. A ( x e. y \/ y e. x \/ x = y ) ). `
       <TR> <TD> 16:4,15,3: <TD> ` |- (. ( Ord A /\ B e. A ) ->. Tr B ). `
       <TR> <TD> 17:16,7:   <TD> ` |- (. ( Ord A /\ B e. A ) ->. Ord B ). `
       <TR> <TD> qed:17:    <TD> ` |- ( ( Ord A /\ B e. A ) -> Ord B ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 12-Feb-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    ordelordALTVD $p |- ( ( Ord A /\ B e. A ) -> Ord B ) $=
      ( vx vy word wcel wtr cv w3o wral e1_ dford2 wb wal ax-gen alral e0_ e111
      ralbi e11 wa wceq idn1 simpl ordtr simprbi 3orcomb e1bi simpr tratrb 3exp
      wss trss wi ssralv2 ex simplbi2 in1 ) AEZBAFZUAZBEZVABGZCHZDHZFZVDVEUBZVE
      VDFZIZDBJCBJZVBVAAGZVFVHVGIZDAJZCAJZUTVCVAUSVKVAVAUSVAUCZUSUTUDKZAUEKZVAV
      IDAJZCAJZVNVAUSVSVPUSVKVSCDALUFKZVRVMMZCAJZVSVNMWACNWBWACVIVLMZDAJZWAWCDN
      WDWCDVFVGVHUGOWCDAPQVIVLDASQOWACAPQVRVMCASQUHVAVAUTVOUSUTUIKZVKVNUTVCCDAB
      UJUKRVABAULZWFVSVJVAVKUTWFVQWEABUMTZWGVTWFWFVSVJUNVICDBABAUOUPRVBVCVJCDBL
      UQTUR $.
  $}

  ${
    $( If a class equals the union of two other classes, then it equals the
       union of those two classes commuted. The following User's Proof is a
       Virtual Deduction proof completed automatically by the tools program
       completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm
       Megill's Metamath Proof Assistant. ~ equncom is ~ equncomVD without
       virtual deductions and was automatically derived from ~ equncomVD .
       <HTML> <TABLE>
       <TR> <TD> 1::    <TD> ` |- (. A = ( B u. C ) ->. A = ( B u. C ) ). `
       <TR> <TD> 2::    <TD> ` |- ( B u. C ) = ( C u. B ) `
       <TR> <TD> 3:1,2: <TD> ` |- (. A = ( B u. C ) ->. A = ( C u. B ) ). `
       <TR> <TD> 4:3:   <TD> ` |- ( A = ( B u. C ) -> A = ( C u. B ) ) `
       <TR> <TD> 5::    <TD> ` |- (. A = ( C u. B ) ->. A = ( C u. B ) ). `
       <TR> <TD> 6:5,2: <TD> ` |- (. A = ( C u. B ) ->. A = ( B u. C ) ). `
       <TR> <TD> 7:6:   <TD> ` |- ( A = ( C u. B ) -> A = ( B u. C ) ) `
       <TR> <TD> 8:4,7: <TD> ` |- ( A = ( B u. C ) <-> A = ( C u. B ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 17-Feb-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    equncomVD $p |- ( A = ( B u. C ) <-> A = ( C u. B ) ) $=
      ( cun wceq idn1 uncom eqeq1 biimprd e10 in1 eqeq2 biimprcd impbii ) ABCDZ
      EZACBDZEZPRPPOQEZRPFBCGZPRSAOQHIJKRPRRSPRFTSPROQALMJKN $.
  $}

  ${
    equncomiVD.1 $e |- A = ( B u. C ) $.
    $( Inference form of ~ equncom . The following User's Proof is a
       Virtual Deduction proof completed automatically by the tools program
       completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm
       Megill's Metamath Proof Assistant. ~ equncomi is ~ equncomiVD without
       virtual deductions and was automatically derived from ~ equncomiVD .
       <HTML> <TABLE>
       <TR> <TD> h1::   <TD> ` |- A = ( B u. C ) `
       <TR> <TD> qed:1: <TD> ` |- A = ( C u. B ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Feb-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    equncomiVD $p |- A = ( C u. B ) $=
      ( cun wceq equncom biimpi e0_ ) ABCEFZACBEFZDJKABCGHI $.
  $}

  ${
    sucidALTVD.1 $e |- A e. _V $.
    $( A set belongs to its successor.  Alternate proof of ~ sucid .
       The following User's Proof is a Virtual Deduction proof
       completed automatically by the tools program
       completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm
       Megill's Metamath Proof Assistant.  ~ sucidALT is ~ sucidALTVD
       without virtual deductions and was automatically derived from
       ~ sucidALTVD . This proof illustrates that
       completeusersproof.cmd will generate a Metamath proof from any
       User's Proof which is "conventional" in the sense that no step
       is a virtual deduction, provided that all necessary unification
       theorems and transformation deductions are in set.mm.
       completeusersproof.cmd automatically converts such a
       conventional proof into a Virtual Deduction proof for which each
       step happens to be a 0-virtual hypothesis virtual deduction.
       The user does not need to search for reference theorem labels or
       deduction labels nor does he(she) need to use theorems and
       deductions which unify with reference theorems and deductions in
       set.mm.  All that is necessary is that each theorem or deduction
       of the User's Proof unifies with some reference theorem or
       deduction in set.mm or is a semantic variation of some theorem
       or deduction which unifies with some reference theorem or
       deduction in set.mm.  The definition of "semantic variation" has
       not been precisely defined.  If it is obvious that a theorem or
       deduction has the same meaning as another theorem or deduction,
       then it is a semantic variation of the latter theorem or
       deduction.  For example, step 4 of the User's Proof is a
       semantic variation of the definition (axiom)
       ` suc A = ( A u. { A } ) ` , which unifies with ~ df-suc , a
       reference definition (axiom) in set.mm.  Also, a theorem or
       deduction is said to be a semantic variation of another
       theorem or deduction if it is obvious upon cursory inspection
       that it has the same meaning as a weaker form of the latter
       theorem or deduction.  For example, the deduction ` Ord A `
       infers  ` A. x e. A A. y e. A ( x e. y \/ x = y \/ y e. x ) ` is a
       semantic variation of the theorem ` ( Ord A <-> ( Tr A /\ A. x e. A `
       ` A. y e. A ( x e. y \/ x = y \/ y e. x ) ) ) ` , which unifies with
       the set.mm reference definition (axiom) ~ dford2 .
       <HTML> <TABLE>
       <TR> <TD> h1::     <TD> ` |- A e. _V   `
       <TR> <TD> 2:1:     <TD> ` |- A e. { A } `
       <TR> <TD> 3:2:     <TD> ` |- A e. ( { A } u. A ) `
       <TR> <TD> 4::      <TD> ` |- suc A = ( { A } u. A ) `
       <TR> <TD> qed:3,4: <TD> ` |- A e. suc A  `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Feb-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    sucidALTVD $p |- A e. suc A $=
      ( csn cun csuc wcel snid elun1 e0_ df-suc equncomi eleqtrri ) AACZADZAEZA
      MFANFABGAMAHIOAMAJKL $.
  $}

  ${
    sucidALT.1 $e |- A e. _V $.
    $( A set belongs to its successor.  This proof was automatically derived
       from ~ sucidALTVD using translate_without_overwriting.cmd and
       minimizing.  (Contributed by Alan Sare, 18-Feb-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sucidALT $p |- A e. suc A $=
      ( csn cun csuc wcel snid elun1 ax-mp df-suc equncomi eleqtrri ) AACZADZAE
      ZAMFANFABGAMAHIOAMAJKL $.
  $}

  ${
    sucidVD.1 $e |- A e. _V $.
    $( A set belongs to its successor.  The following User's Proof is a
       Virtual Deduction proof completed automatically by the tools
       program completeusersproof.cmd, which invokes Mel O'Cat's mmj2
       and Norm Megill's Metamath Proof Assistant.  ~ sucid is
       ~ sucidVD without virtual deductions and was automatically
       derived from ~ sucidVD .
       <HTML> <TABLE>
       <TR> <TD> h1::     <TD> ` |- A e. _V   `
       <TR> <TD> 2:1:     <TD> ` |- A e. { A } `
       <TR> <TD> 3:2:     <TD> ` |- A e. ( A u. { A } ) `
       <TR> <TD> 4::      <TD> ` |- suc A = ( A u. { A } ) `
       <TR> <TD> qed:3,4: <TD> ` |- A e. suc A  `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Feb-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    sucidVD $p |- A e. suc A $=
      ( csn cun csuc wcel snid elun2 e0_ df-suc eleqtrri ) AAACZDZAEALFAMFABGAL
      AHIAJK $.
  $}

  ${
    $( Implication form of ~ imbi12i . The following User's Proof is a Virtual
       Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ imbi12
       is ~ imbi12VD without virtual deductions and was automatically derived
       from ~ imbi12VD .
       <HTML> <TABLE>
       <TR> <TD> 1::      <TD> ` |- (. ( ph <-> ps ) ->. ( ph <-> ps ) ). `
       <TR> <TD> 2::      <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) `
       ` ->. ( ch <-> th ) ). `
       <TR> <TD> 3::      <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ph `
       ` -> ch ) ->. ( ph -> ch ) ). `
       <TR> <TD> 4:1,3:   <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ph `
       ` -> ch ) ->. ( ps -> ch ) ). `
       <TR> <TD> 5:2,4:   <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ph `
       ` -> ch ) ->. ( ps -> th ) ). `
       <TR> <TD> 6:5:     <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) `
       ` ->. ( ( ph -> ch ) -> ( ps -> th ) ) ). `
       <TR> <TD> 7::      <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ps `
       ` -> th ) ->. ( ps -> th ) ). `
       <TR> <TD> 8:1,7:   <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ps `
       ` -> th ) ->. ( ph -> th ) ). `
       <TR> <TD> 9:2,8:   <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ps `
       ` -> th ) ->. ( ph -> ch ) ). `
       <TR> <TD> 10:9:    <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) `
       ` ->. ( ( ps -> th ) -> ( ph -> ch ) ) ). `
       <TR> <TD> 11:6,10: <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) `
       ` ->. ( ( ph -> ch ) <-> ( ps -> th ) ) ). `
       <TR> <TD> 12:11:   <TD> ` |- (. ( ph <-> ps ) ->. ( ( ch <-> th ) `
       ` -> ( ( ph -> ch ) <-> ( ps -> th ) ) ) ).   `
       <TR> <TD> qed:12:  <TD> ` |- ( ( ph <-> ps ) -> ( ( ch <-> th ) `
       ` -> ( ( ph -> ch ) <-> ( ps -> th ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    imbi12VD $p |- ( ( ph <-> ps ) -> ( ( ch <-> th ) -> ( ( ph -> ch )
                 <-> ( ps -> th ) ) ) ) $=
      ( wb wi idn2 idn1 idn3 bi2 imim1d e13 bi1 imim2d e23 in3 bi3 e22 in2 in1
      ) ABEZCDEZACFZBDFZEZFUAUBUEUAUBUCUDFUDUCFUEUAUBUCUDUAUBUBUCBCFZUDUAUBGZUA
      UAUBUCUCUFUAHZUAUBUCIUABACABJKLUBCDBCDMNOPUAUBUDUCUAUBUBUDADFZUCUGUAUAUBU
      DUDUIUHUAUBUDIUAABDABMKLUBDCACDJNOPUCUDQRST $.
  $}

  ${
    $( Join three logical equivalences to form equivalence of implications. The
       following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ imbi13
       is ~ imbi13VD without virtual deductions and was automatically derived
       from ~ imbi13VD .
       <HTML> <TABLE>
       <TR> <TD> 1::      <TD> ` |- (. ( ph <-> ps ) ->. ( ph <-> ps ) ). `
       <TR> <TD> 2::      <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) `
       ` ->. ( ch <-> th ) ). `
       <TR> <TD> 3::      <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ta `
       ` <-> et ) ->. ( ta <-> et ) ). `
       <TR> <TD> 4:2,3:   <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ta `
       ` <-> et ) ->. ( ( ch -> ta ) <-> ( th -> et ) ) ). `
       <TR> <TD> 5:1,4:   <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) ,. ( ta `
       ` <-> et ) ->. ( ( ph -> ( ch -> ta ) ) <-> ( ps -> ( th -> et ) ) ) ).
       `
       <TR> <TD> 6:5:     <TD> ` |- (. ( ph <-> ps ) ,. ( ch <-> th ) `
       ` ->. ( ( ta <-> et ) -> ( ( ph -> ( ch -> ta ) ) <-> ( ps -> ( th `
       ` -> et ) ) ) ) ). `
       <TR> <TD> 7:6:     <TD> ` |- (. ( ph <-> ps ) ->. ( ( ch <-> th ) `
       ` -> ( ( ta <-> et ) -> ( ( ph -> ( ch -> ta ) ) <-> ( ps -> ( th `
       ` -> et ) ) ) ) ) ).  `
       <TR> <TD> qed:7:   <TD> ` |- ( ( ph <-> ps ) -> ( ( ch <-> th ) `
       ` -> ( ( ta <-> et ) -> ( ( ph -> ( ch -> ta ) ) <-> ( ps -> ( th `
       ` -> et ) ) ) ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    imbi13VD $p |- ( ( ph <-> ps ) -> ( ( ch <-> th ) -> ( ( ta <-> et ) ->
                 ( ( ph -> ( ch -> ta ) ) <-> ( ps -> ( th -> et ) ) ) ) ) ) $=
      ( wb wi idn1 idn2 idn3 imbi12 e23 e13 in3 in2 in1 ) ABGZCDGZEFGZACEHZHBDF
      HZHGZHZHRSUDRSTUCRRSTUAUBGZUCRIRSSTTUERSJRSTKCDEFLMABUAUBLNOPQ $.
  $}

  $( Distribution of class substitution over a left-nested implication.
     Similar
     to ~ sbcimg . The following User's Proof is a Virtual Deduction proof
     completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ sbcim2g
     is ~ sbcim2gVD without virtual deductions and was automatically derived
     from ~ sbcim2gVD .
     <HTML> <TABLE>
     <TR> <TD> 1::      <TD> ` |- (. A e. B ->. A e. B ). `
     <TR> <TD> 2::      <TD> ` |- (. A e. B ,. [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) ->. [. A / x ]. ( ph -> ( ps -> ch ) ) ). `
     <TR> <TD> 3:1,2:   <TD> ` |- (. A e. B ,. [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) ->. ( [. A / x ]. ph -> [. A / x ]. ( ps -> ch ) ) ). `
     <TR> <TD> 4:1:     <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ps -> ch ) `
     ` <-> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ). `
     <TR> <TD> 5:3,4:   <TD> ` |- (. A e. B ,. [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) ->. ( [. A / x ]. ph -> ( [. A / x ]. ps `
     ` -> [. A / x ]. ch ) ) ). `
     <TR> <TD> 6:5:     <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) -> ( [. A / x ]. ph -> ( [. A / x ]. ps `
     ` -> [. A / x ]. ch ) ) ) ). `
     <TR> <TD> 7::      <TD> ` |- (. A e. B ,. ( [. A / x ]. ph `
     ` -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ->. ( [. A / x ]. ph `
     ` -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ). `
     <TR> <TD> 8:4,7:   <TD> ` |- (. A e. B ,. ( [. A / x ]. ph `
     ` -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ->. ( [. A / x ]. ph `
     ` -> [. A / x ]. ( ps -> ch ) ) ). `
     <TR> <TD> 9:1:     <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) <-> ( [. A / x ]. ph -> [. A / x ]. ( ps -> ch ) ) ) ). `
     <TR> <TD> 10:8,9:  <TD> ` |- (. A e. B ,. ( [. A / x ]. ph `
     ` -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ->. [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) ). `
     <TR> <TD> 11:10:   <TD> ` |- (. A e. B ->. ( ( [. A / x ]. ph `
     ` -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) -> [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) ) ). `
     <TR> <TD> 12:6,11: <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ph `
     ` -> ( ps -> ch ) ) <-> ( [. A / x ]. ph -> ( [. A / x ]. ps `
     ` -> [. A / x ]. ch ) ) ) ). `
     <TR> <TD> qed:12:  <TD> ` |- ( A e. B -> ( [. A / x ]. ( ph -> ( ps `
     ` -> ch ) ) <-> ( [. A / x ]. ph -> ( [. A / x ]. ps `
     ` -> [. A / x ]. ch ) ) ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  sbcim2gVD $p |- ( A e. B -> ( [. A / x ]. ( ph -> ( ps -> ch ) ) <->
            ( [. A / x ]. ph -> ( [. A / x ]. ps -> [. A / x ]. ch ) ) ) ) $=
    ( wcel wi wsbc wb idn1 idn2 sbcimg biimpd e12 e1_ imbi2 e21 in2 bi2 biimpcd
    imim2d com12 bi3 e11 in1 ) EFGZABCHZHDEIZADEIZBDEICDEIHZHZJZUGUIULHULUIHUMU
    GUIULUGUIUJUHDEIZHZUNUKJZULUGUGUIUIUOUGKZUGUILUGUIUOAUHDEFMZNOUGUGUPUQBCDEF
    MPZUPUOULUNUKUJQUARSUGULUIUGULUOUIUOJZUIUGUPULULUOUSUGULLUPUKUNUJUNUKTUBOUG
    UGUTUQURPUTUOUIUIUOTUCRSUIULUDUEUF $.


  $( Implication form of ~ sbcbiiOLD . The following User's Proof is a
     Virtual
     Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ sbcbi
     is ~ sbcbiVD without virtual deductions and was automatically derived
     from ~ sbcbiVD .
     <HTML> <TABLE>
     <TR> <TD> 1::           <TD> ` |- (. A e. B ->. A e. B ).  `
     <TR> <TD> 2::           <TD> ` |- (. A e. B ,. A. x ( ph <-> ps ) `
     ` ->. A. x ( ph <-> ps ) ). `
     <TR> <TD> 3:1,2:        <TD> ` |- (. A e. B ,. A. x ( ph <-> ps ) `
     ` ->. [. A / x ]. ( ph <-> ps ) ). `
     <TR> <TD> 4:1,3:        <TD> ` |- (. A e. B ,. A. x ( ph <-> ps ) `
     ` ->. ( [. A / x ]. ph <-> [. A / x ]. ps ) ). `
     <TR> <TD> 5:4:          <TD> ` |- (. A e. B ->. ( A. x ( ph <-> ps ) `
     ` -> ( [. A / x ]. ph <-> [. A / x ]. ps ) ) ). `
     <TR> <TD> qed:5:        <TD> ` |- ( A e. B -> ( A. x ( ph <-> ps ) `
     ` -> ( [. A / x ]. ph <-> [. A / x ]. ps ) ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  sbcbiVD $p |- ( A e. B -> ( A. x ( ph <-> ps ) -> ( [. A / x ]. ph <->
                  [. A / x ]. ps ) ) ) $=
    ( wcel wb wal wsbc wi idn1 idn2 spsbc e12 sbcbig biimpd in2 in1 ) DEFZABGZC
    HZACDIBCDIGZJSUAUBSSUATCDIZUBSKZSSUAUAUCUDSUALTCDEMNSUCUBABCDEOPNQR $.


  ${
    $d A x y z $.  $d B y z $.
    $( Formula-building inference rule for class substitution, substituting a
       class
       variable for the set variable of the transitivity predicate. The
       following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ trsbc
       is ~ trsbcVD without virtual deductions and was automatically derived
       from ~ trsbcVD .
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- (. A e. B ->. A e. B ). `
       <TR> <TD> 2:1:       <TD> ` |- (. A e. B ->. ( [. A / x ]. z e. y `
       ` <-> z e. y ) ). `
       <TR> <TD> 3:1:       <TD> ` |- (. A e. B ->. ( [. A / x ]. y e. x `
       ` <-> y e. A ) ). `
       <TR> <TD> 4:1:       <TD> ` |- (. A e. B ->. ( [. A / x ]. z e. x `
       ` <-> z e. A ) ). `
       <TR> <TD> 5:1,2,3,4: <TD> ` |- (. A e. B ->. ( ( [. A / x ]. z e. y `
       ` -> ( [. A / x ]. y e. x -> [. A / x ]. z e. x ) ) <-> (  z e. y `
       ` -> (  y e. A ->  z e. A ) ) ) ). `
       <TR> <TD> 6:1:       <TD> ` |- (. A e. B ->. ( [. A / x ]. (  z e. y `
       ` -> ( y e. x ->  z e. x ) )  <-> ( [. A / x ]. z e. y -> `
       ` ( [. A / x ]. y e. x -> [. A / x ]. z e. x ) ) ) ). `
       <TR> <TD> 7:5,6:     <TD> ` |- (. A e. B ->. ( [. A / x ]. (  z e. y `
       ` -> ( y e. x ->  z e. x ) )  <-> ( z e. y -> (  y e. A `
       ` -> z e. A ) ) ) ). `
       <TR> <TD> 8::        <TD> ` |- ( (  z e. y -> (  y e. A `
       ` ->  z e. A ) ) <-> ( ( z e. y /\  y e. A ) ->  z e. A ) ) `
       <TR> <TD> 9:7,8:     <TD> ` |- (. A e. B ->. ( [. A / x ]. (  z e. y `
       ` -> ( y e. x ->  z e. x ) )  <-> ( ( z e. y /\  y e. A ) `
       ` ->  z e. A ) ) ). `
       <TR> <TD> 10::       <TD> ` |- ( (  z e. y -> (  y e. x `
       ` ->  z e. x ) ) <-> ( ( z e. y /\  y e. x ) ->  z e. x ) ) `
       <TR> <TD> 11:10:     <TD> ` |- A. x ( (  z e. y -> (  y e. x `
       ` ->  z e. x ) ) <-> ( ( z e. y /\  y e. x ) ->  z e. x ) ) `
       <TR> <TD> 12:1,11:   <TD> ` |- (. A e. B ->. ( [. A / x ]. (  z e. y `
       ` -> ( y e. x ->  z e. x ) ) <-> [. A / x ]. ( ( z e. y /\  y e. x ) `
       ` ->  z e. x ) ) ). `
       <TR> <TD> 13:9,12:   <TD> ` |- (. A e. B ->. ( [. A / x ]. ( ( z e. y `
       ` /\ y e. x ) ->  z e. x ) <-> ( ( z e. y /\  y e. A ) `
       ` ->  z e. A ) ) ). `
       <TR> <TD> 14:13:     <TD> ` |- (. A e. B ->. A. y ( [. A / x ]. ( ( z `
       ` e. y /\  y e. x ) ->  z e. x ) <-> ( ( z e. y /\  y e. A ) `
       ` ->  z e. A ) ) ). `
       <TR> <TD> 15:14:     <TD> ` |- (. A e. B ->. ( A. y [. A / x ]. ( ( z `
       ` e. y /\  y e. x ) ->  z e. x ) <->  A. y ( ( z e. y /\ y e. A ) `
       ` ->  z e. A ) ) ).  `
       <TR> <TD> 16:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. A. y ( ( z `
       ` e. y /\  y e. x ) ->  z e. x ) <-> A. y [. A / x ]. ( ( z e. y `
       ` /\  y e. x ) -> z e. x ) ) ). `
       <TR> <TD> 17:15,16:  <TD> ` |- (. A e. B ->. ( [. A / x ]. A. y ( ( z `
       ` e. y /\  y e. x ) ->  z e. x ) <-> A. y ( ( z e. y /\  y e. A ) `
       ` ->  z e. A ) ) ). `
       <TR> <TD> 18:17:     <TD> ` |- (. A e. B ->. A. z ( [. A / x ]. A. y ( (
       `
       ` z e. y /\  y e. x ) ->  z e. x ) <-> A. y ( ( z e. y /\  y e. A ) `
       ` ->  z e. A ) ) ). `
       <TR> <TD> 19:18:     <TD> ` |- (. A e. B ->. ( A. z [. A / x ]. A. y ( (
       `
       ` z e. y /\  y e. x ) ->  z e. x ) <-> A. z A. y ( ( z e. y `
       ` /\ y e. A ) -> z e. A ) ) ). `
       <TR> <TD> 20:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. A. z A. y ( (
       `
       ` z e. y /\  y e. x ) ->  z e. x ) <-> A. z [. A / x ]. A. y ( ( z `
       ` e. y /\ y e. x ) ->  z e. x ) ) ). `
       <TR> <TD> 21:19,20:  <TD> ` |- (. A e. B ->. ( [. A / x ]. A. z A. y ( (
       `
       ` z e. y /\  y e. x ) ->  z e. x ) <-> A. z A. y ( ( z e. y `
       ` /\ y e. A )  -> z e. A ) ) ). `
       <TR> <TD> 22::       <TD> ` |- ( Tr A <-> A. z A. y ( ( z e. y `
       ` /\ y e. A ) ->  z e. A ) ) `
       <TR> <TD> 23:21,22:  <TD> ` |- (. A e. B ->. ( [. A / x ]. A. z A. y ( (
       `
       ` z e. y /\  y e. x ) ->  z e. x ) <-> Tr A ) ). `
       <TR> <TD> 24::       <TD> ` |- ( Tr x <-> A. z A. y ( ( z e. y /\  y `
       ` e. x ) ->  z e. x ) ) `
       <TR> <TD> 25:24:     <TD> ` |- A. x ( Tr x <-> A. z A. y ( ( z e. y `
       ` /\ y e. x ) ->  z e. x ) ) `
       <TR> <TD> 26:1,25:   <TD> ` |- (. A e. B ->. ( [. A / x ]. Tr x `
       ` <-> [. A  / x ]. A. z A. y ( ( z e. y /\  y e. x ) ->  z e. x ) ) ). `
       <TR> <TD> 27:23,26:  <TD> ` |- (. A e. B ->. ( [. A / x ]. Tr x `
       ` <-> Tr A ) ). `
       <TR> <TD> qed:27:    <TD> ` |- ( A e. B -> ( [. A / x ]. Tr x `
       ` <-> Tr A ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    trsbcVD $p |- ( A e. B -> ( [. A / x ]. Tr x <-> Tr A ) ) $=
      ( vz vy wcel cv wtr wsbc wb wa wal e1_ sbcel2gv bibi1 biimprcd e11 pm3.31
      wi e10 idn1 biidd sbcieg imbi13 e1111 sbcim2g pm3.3 impbii biimprd ax-gen
      wceq a1i sbcbi bitr3 com12 gen11 albi sbcalgOLD dftr2 biantr ex in1 ) BCF
      ZAGZHZABIZBHZJZVCDGZEGZFZVJVDFZKVIVDFZSZELZDLZABIZVGJZVFVQJZVHVCVQVKVJBFZ
      KVIBFZSZELZDLZJZVGWDJZVRVCVOABIZDLZWDJZVQWHJZWEVCWGWCJZDLWIVCWKDVCVNABIZE
      LZWCJZWGWMJZWKVCWLWBJZELWNVCWPEVCVKVLVMSSZABIZWBJZWRWLJZWPVCWRVKVTWASSZJZ
      XAWBJZWSVCVKABIZVLABIZVMABIZSSZXAJZWRXGJZXBVCVCXDVKJZXEVTJZXFWAJZXHVCUAZV
      CVCXJXMVKVKABCVDBUKVKUBUCMVCVCXKXMAVJBCNMVCVCXLXMAVIBCNMXJXKXLXHSSSVCXDVK
      XEVTXFWAUDULUEVCVCXIXMVKVLVMABCUFMXIXBXHWRXGXAOPQXAWBVKVTWARVKVTWAUGUHXBW
      SXCWRXAWBOUITVCVCWQVNJZALWTXMXNAWQVNVKVLVMRVKVLVMUGUHUJWQVNABCUMTWTWSWPWR
      WLWBUNUOQUPWLWBEUQMVCVCWOXMVNEABCURMWOWKWNWGWMWCOPQUPWGWCDUQMVCVCWJXMVODA
      BCURMWJWEWIVQWHWDOPQDEBUSWEWFVRVQWDVGUTVATVCVCVEVPJZALVSXMXOADEVDUSUJVEVP
      ABCUMTVSVHVRVFVQVGOPQVB $.

  $}

  ${
    $d A q x y z $.
    $( The union of a class of transitive sets is transitive. The following
       User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ truniALT
       is ~ truniALTVD without virtual deductions and was automatically derived
       from ~ truniALTVD .
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- (. A. x e. A Tr x ->. A. x e. A `
       ` Tr x ). `
       <TR> <TD> 2::        <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. ( z e. y /\ y e. U. A ) ).  `
       <TR> <TD> 3:2:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. z e. y ). `
       <TR> <TD> 4:2:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. y e. U. A ). `
       <TR> <TD> 5:4:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. E. q ( y e. q /\ q e. A ) ). `
       <TR> <TD> 6::        <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. ( y e. q /\ q e. A ) ). `
       <TR> <TD> 7:6:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. y e. q ). `
       <TR> <TD> 8:6:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. q e. A ). `
       <TR> <TD> 9:1,8:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. [ q / x ] Tr x ). `
       <TR> <TD> 10:8,9:    <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. Tr q ). `
       <TR> <TD> 11:3,7,10: <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. z e. q ). `
       <TR> <TD> 12:11,8:   <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) , ( y e. q /\ q e. A ) ->. z e. U. A ). `
       <TR> <TD> 13:12:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. ( ( y e. q /\ q e. A ) -> z e. U. A ) ). `
       <TR> <TD> 14:13:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. A. q ( ( y e. q /\ q e. A ) -> z e. U. A ) ). `
       <TR> <TD> 15:14:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. ( E. q ( y e. q /\ q e. A ) -> z e. U. A ) ). `
       <TR> <TD> 16:5,15:   <TD> ` |- (. A. x e. A Tr x ,. ( z e. y `
       ` /\ y e. U. A ) ->. z e. U. A ). `
       <TR> <TD> 17:16:     <TD> ` |- (. A. x e. A Tr x ->. ( ( z e. y `
       ` /\ y e. U. A ) -> z e. U. A ) ). `
       <TR> <TD> 18:17:     <TD> ` |- (. A. x e. A Tr x `
       ` ->. A. z A. y ( ( z e. y /\ y e. U. A ) -> z e. U. A ) ). `
       <TR> <TD> 19:18:     <TD> ` |- (. A. x e. A Tr x ->. Tr U. A ). `
       <TR> <TD> qed:19:    <TD> ` |- ( A. x e. A Tr x -> Tr U. A ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    truniALTVD $p |- ( A. x e. A Tr x -> Tr U. A ) $=
      ( vz vy vq cv wtr wral cuni wel wcel wa wi wal simpr e2 biimpi simpl e33
      e3 wex idn2 eluni idn3 wsbc idn1 rspsbc com12 e13 trsbc biimpd exp3acom3r
      trel e233 elunii ex in3 gen21 19.23v pm2.27 e22 in2 gen12 biimpri e1_ in1
      dftr2 ) AFGZABHZBIZGZVICDJZDFZVJKZLZCFZVJKZMZDNCNZVKVIVRCDVIVOVQVIVODEJZE
      FZBKZLZEUAZWDVQMZVQVIVOVNWDVIVOVOVNVIVOUBZVLVNOPVNWDEVMBUCQPVIVOWCVQMZENZ
      WEVIVOWGEVIVOWCVQVIVOWCCEJZWBVQVIVOVLWCVTWAGZWIVIVOVOVLWFVLVNRPVIVOWCWCVT
      VIVOWCUDZVTWBRTVIVOWCWBVHAWAUEZWJVIVOWCWCWBWKVTWBOTZVIVIVOWCWBWLVIUFWMWBV
      IWLVHAWABUGUHUIWBWLWJAWABUJUKSWJVLVTWIWAVPVMUMULUNWMWIWBVQVPWABUOUPSUQURW
      HWEWCVQEUSQPWDVQUTVAVBVCVKVSCDVJVGVDVEVF $.
  $}

  ${
    ee33VD.1 $e |- ( ph -> ( ps -> ( ch -> th ) ) ) $.
    ee33VD.2 $e |- ( ph -> ( ps -> ( ch -> ta ) ) ) $.
    ee33VD.3 $e |- ( th -> ( ta -> et ) ) $.
    $( Non-virtual deduction form of ~ e33 . The following User's Proof is a
       Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ ee33
       is ~ ee33VD without virtual deductions and was automatically derived
       from ~ ee33VD .
       <HTML> <TABLE>
       <TR> <TD> h1::   <TD> ` |- ( ph -> ( ps -> ( ch -> th ) ) )  `
       <TR> <TD> h2::   <TD> ` |- ( ph -> ( ps -> ( ch -> ta ) ) )  `
       <TR> <TD> h3::   <TD> ` |- ( th -> ( ta -> et ) ) `
       <TR> <TD> 4:1,3: <TD> ` |- ( ph -> ( ps -> ( ch -> ( ta -> et ) ) ) ) `
       <TR> <TD> 5:4:   <TD> ` |- ( ta -> ( ph -> ( ps -> ( ch -> et ) ) ) ) `
       <TR> <TD> 6:2,5: <TD> ` |- ( ph -> ( ps -> ( ch -> ( ph -> ( ps `
       ` -> ( ch -> et ) ) ) ) ) ) `
       <TR> <TD> 7:6:   <TD> ` |- ( ps -> ( ch -> ( ph -> ( ps -> ( ch `
       ` -> et ) ) ) ) ) `
       <TR> <TD> 8:7:   <TD> ` |- ( ch -> ( ph -> ( ps -> ( ch -> et ) ) ) ) `
       <TR> <TD> qed:8: <TD> ` |- ( ph -> ( ps -> ( ch -> et ) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 18-Mar-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    ee33VD $p |- ( ph -> ( ps -> ( ch -> et ) ) ) $=
      ( wi syl8 com4r pm2.43cbi biimpi e0_ ) CABCFJZJZJZJZRBSJZSATJZTABCERHABCE
      FABCDEFJGIKLKUATABCQMNOTSBCAPMNOSRCABFMNO $.
  $}

  ${
    $d A q x y z $.
    $( The intersection of a class of transitive sets is transitive. Virtual
       deduction proof of ~ trintALT .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ trintALT
       is ~ trintALTVD without virtual deductions and was automatically derived
       from ~ trintALTVD .
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- (. A. x e. A Tr x ->. A. x e. A Tr x ). `
       <TR> <TD> 2::        <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. ( z e. y /\ y e. |^| A ) ). `
       <TR> <TD> 3:2:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. z e. y ). `
       <TR> <TD> 4:2:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. y e. |^| A ). `
       <TR> <TD> 5:4:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. A. q e. A y e. q ). `
       <TR> <TD> 6:5:       <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. ( q e. A -> y e. q ) ). `
       <TR> <TD> 7::        <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) , q e. A ->. q e. A ). `
       <TR> <TD> 8:7,6:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) , q e. A ->. y e. q ). `
       <TR> <TD> 9:7,1:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) , q e. A ->. [ q / x ] Tr x ). `
       <TR> <TD> 10:7,9:    <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) , q e. A ->. Tr q ). `
       <TR> <TD> 11:10,3,8: <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) , q e. A ->. z e. q ). `
       <TR> <TD> 12:11:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. ( q e. A -> z e. q ) ). `
       <TR> <TD> 13:12:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. A. q ( q e. A -> z e. q ) ). `
       <TR> <TD> 14:13:     <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. A. q e. A z e. q ). `
       <TR> <TD> 15:3,14:   <TD> ` |- (. A. x e. A Tr x ,. ( z e. y /\ y e. `
       ` |^| A ) ->. z e. |^| A ). `
       <TR> <TD> 16:15:     <TD> ` |- (. A. x e. A Tr x ->. ( ( z e. y /\ y `
       ` e. |^| A ) -> z e. |^| A ) ). `
       <TR> <TD> 17:16:     <TD> ` |- (. A. x e. A Tr x ->. A. z A. y ( ( z `
       ` e. y /\ y e. |^| A ) -> z e. |^| A ) ). `
       <TR> <TD> 18:17:     <TD> ` |- (. A. x e. A Tr x ->. Tr |^| A ). `
       <TR> <TD> qed:18:    <TD> ` |- ( A. x e. A Tr x -> Tr |^| A ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 17-Apr-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    trintALTVD $p |- ( A. x e. A Tr x -> Tr |^| A ) $=
      ( vz vy vq cv wtr wral cint wcel wa wi wal idn2 simpl e2 wsbc idn3 elintg
      biimpri idn1 rspsbc e31 trsbc biimpd e33 simpr ibi pm2.27 trel exp3a e323
      rsp e32 in3 gen21 df-ral biimprd e22 in2 gen12 dftr2 e1_ in1 ) AFGZABHZBI
      ZGZVFCFZDFZJZVJVGJZKZVIVGJZLZDMCMZVHVFVOCDVFVMVNVFVMVKVIEFZJZEBHZVNVFVMVM
      VKVFVMNZVKVLOPZVFVMVQBJZVRLZEMZVSVFVMWCEVFVMWBVRVFVMWBVQGZVKVJVQJZVRVFVMW
      BWBVEAVQQZWEVFVMWBRZVFVMWBWBVFWGWHVFUAVEAVQBUBUCWBWGWEAVQBUDUEUFWAVFVMWBW
      BWBWFLZWFWHVFVMWFEBHZWIVFVMVLWJVFVMVMVLVTVKVLUGPVLWJEVJBVGSUHPWFEBUMPWBWF
      UIUNWEVKWFVRVQVIVJUJUKULUOUPVSWDVREBUQTPVKVNVSEVIBVJSURUSUTVAVHVPCDVGVBTV
      CVD $.
  $}

  ${
    $d A q x y z $.
    $( The intersection of a class of transitive sets is transitive.  Exercise
       5(b) of [Enderton] p. 73. ~ trintALT is an alternative proof of
       ~ trint . ~ trintALT is ~ trintALTVD without virtual deductions and was
       automatically derived from ~ trintALTVD using the tools program
       translate..without..overwriting.cmd and Metamath's minimize command.
       (Contributed by Alan Sare, 17-Apr-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    trintALT $p |- ( A. x e. A Tr x -> Tr |^| A ) $=
      ( vz vy vq cv wtr wral wel cint wcel wa wi wal simpl a1i wsbc elintg syl6
      iidn3 id rspsbc ee31 trsbc biimpd ee33 simpr ibi rsp exp3a ee323 ralrimdv
      trel biimprd ee22 alrimivv dftr2 sylibr ) AFGZABHZCDIZDFZBJZKZLZCFZVCKZMZ
      DNCNVCGUTVHCDUTVEVACEIZEBHZVGVEVAMUTVAVDOPZUTVEVIEBUTVEEFZBKZVLGZVADEIZVI
      UTVEVMVMUSAVLQZVNUTVEVMTZUTVEVMVMUTVPVQUTUAUSAVLBUBUCVMVPVNAVLBUDUEUFVKUT
      VEVOEBHZVMVOMUTVEVDVRVEVDMUTVAVDUGPVDVREVBBVCRUHSVOEBUISVNVAVOVIVLVFVBUMU
      JUKULVAVGVJEVFBVBRUNUOUPCDVCUQUR $.
  $}

  ${
    $d A x $.  $d B x $.  $d C x $.
    $( The first equality of Exercise 13 of [TakeutiZaring] p. 22. Virtual
       deduction proof of ~ undif3 .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ undif3
       is ~ undif3VD without virtual deductions and was automatically derived
       from ~ undif3VD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- ( x e. ( A u. ( B \ C ) ) <-> ( x e. A `
       ` \/ x e. ( B \ C ) ) ) `
       <TR> <TD> 2::       <TD> ` |- ( x e. ( B \ C ) <-> ( x e. B /\ -. x e. `
       ` C ) ) `
       <TR> <TD> 3:2:      <TD> ` |- ( ( x e. A \/ x e. ( B \ C ) ) <-> ( x `
       ` e. A \/ ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 4:1,3:    <TD> ` |- ( x e. ( A u. ( B \ C ) ) <-> ( x e. A `
       ` \/ ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 5::       <TD> ` |- (. x e. A ->. x e. A ). `
       <TR> <TD> 6:5:      <TD> ` |- (. x e. A ->. ( x e. A \/ x e. B ) ). `
       <TR> <TD> 7:5:      <TD> ` |- (. x e. A ->. ( -. x e. C \/ x e. A ) ). `
       <TR> <TD> 8:6,7:    <TD> ` |- (. x e. A ->. ( ( x e. A \/ x e. B ) /\ `
       ` ( -. x e. C \/ x e. A ) ) ). `
       <TR> <TD> 9:8:      <TD> ` |- ( x e. A -> ( ( x e. A \/ x e. B ) /\ ( `
       ` -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 10::      <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. ( x e. B `
       ` /\ -. x e. C ) ). `
       <TR> <TD> 11:10:    <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. x e. B ). `
       <TR> <TD> 12:10:    <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. -. x e. C `
       ` ). `
       <TR> <TD> 13:11:    <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. ( x e. A `
       ` \/ x e. B ) ). `
       <TR> <TD> 14:12:    <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. ( -. x e. `
       ` C \/ x e. A ) ). `
       <TR> <TD> 15:13,14: <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. ( ( x e. `
       ` A \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ). `
       <TR> <TD> 16:15:    <TD> ` |- ( ( x e. B /\ -. x e. C ) -> ( ( x e. A `
       ` \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 17:9,16:  <TD> ` |- ( ( x e. A \/ ( x e. B /\ -. x e. C ) ) `
       ` -> ( ( x e. A \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 18::      <TD> ` |- (. ( x e. A /\ -. x e. C ) ->. ( x e. A `
       ` /\ -. x e. C ) ). `
       <TR> <TD> 19:18:    <TD> ` |- (. ( x e. A /\ -. x e. C ) ->. x e. A ). `
       <TR> <TD> 20:18:    <TD> ` |- (. ( x e. A /\ -. x e. C ) ->. -. x e. C `
       ` ). `
       <TR> <TD> 21:18:    <TD> ` |- (. ( x e. A /\ -. x e. C ) ->. ( x e. A `
       ` \/ ( x e. B /\ -. x e. C ) ) ). `
       <TR> <TD> 22:21:    <TD> ` |- ( ( x e. A /\ -. x e. C ) -> ( x e. A \/ `
       ` ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 23::      <TD> ` |- (. ( x e. A /\ x e. A ) ->. ( x e. A /\ `
       ` x e. A ) ). `
       <TR> <TD> 24:23:    <TD> ` |- (. ( x e. A /\ x e. A ) ->. x e. A ). `
       <TR> <TD> 25:24:    <TD> ` |- (. ( x e. A /\ x e. A ) ->. ( x e. A \/ `
       ` ( x e. B /\ -. x e. C ) ) ). `
       <TR> <TD> 26:25:    <TD> ` |- ( ( x e. A /\ x e. A ) -> ( x e. A \/ ( `
       ` x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 27:10:    <TD> ` |- (. ( x e. B /\ -. x e. C ) ->. ( x e. A `
       ` \/ ( x e. B /\ -. x e. C ) ) ). `
       <TR> <TD> 28:27:    <TD> ` |- ( ( x e. B /\ -. x e. C ) -> ( x e. A \/ `
       ` ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 29::      <TD> ` |- (. ( x e. B /\ x e. A ) ->. ( x e. B /\ `
       ` x e. A ) ). `
       <TR> <TD> 30:29:    <TD> ` |- (. ( x e. B /\ x e. A ) ->. x e. A ). `
       <TR> <TD> 31:30:    <TD> ` |- (. ( x e. B /\ x e. A ) ->. ( x e. A \/ `
       ` ( x e. B /\ -. x e. C ) ) ). `
       <TR> <TD> 32:31:    <TD> ` |- ( ( x e. B /\ x e. A ) -> ( x e. A \/ ( `
       ` x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 33:22,26: <TD> ` |- ( ( ( x e. A /\ -. x e. C ) \/ ( x e. A `
       ` /\ x e. A ) ) -> ( x e. A \/ ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 34:28,32: <TD> ` |- ( ( ( x e. B /\ -. x e. C ) \/ ( x e. B `
       ` /\ x e. A ) ) -> ( x e. A \/ ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 35:33,34: <TD> ` |- ( ( ( ( x e. A /\ -. x e. C ) \/ ( x e. `
       ` A /\ x e. A ) ) \/ ( ( x e. B /\ -. x e. C ) \/ ( x e. B /\ x e. A ) )
       ) `
       ` -> ( x e. A \/ ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 36::      <TD> ` |- ( ( ( ( x e. A /\ -. x e. C ) \/ ( x e. `
       ` A /\ x e. A ) ) \/ ( ( x e. B /\ -. x e. C ) \/ ( x e. B /\ x e. A ) )
       ) `
       ` <-> ( ( x e. A \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 37:36,35: <TD> ` |- ( ( ( x e. A \/ x e. B ) /\ ( -. x e. C `
       ` \/ x e. A ) ) -> ( x e. A \/ ( x e. B /\ -. x e. C ) ) ) `
       <TR> <TD> 38:17,37: <TD> ` |- ( ( x e. A \/ ( x e. B /\ -. x e. C ) ) `
       ` <-> ( ( x e. A \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 39::      <TD> ` |- ( x e. ( C \ A ) <-> ( x e. C /\ -. x e. `
       ` A ) ) `
       <TR> <TD> 40:39:    <TD> ` |- ( -. x e. ( C \ A ) <-> -. ( x e. C /\ `
       ` -. x e. A ) ) `
       <TR> <TD> 41::      <TD> ` |- ( -. ( x e. C /\ -. x e. A ) <-> ( -. x `
       ` e. C \/ x e. A ) ) `
       <TR> <TD> 42:40,41: <TD> ` |- ( -. x e. ( C \ A ) <-> ( -. x e. C \/ x `
       ` e. A ) ) `
       <TR> <TD> 43::      <TD> ` |- ( x e. ( A u. B ) <-> ( x e. A \/ x e. B `
       ` ) ) `
       <TR> <TD> 44:43,42: <TD> ` |- ( ( x e. ( A u. B ) /\ -. x e. ( C \ A ) `
       ` ) <-> ( ( x e. A \/ x e. B ) /\ ( -. x e. C /\ x e. A ) ) ) `
       <TR> <TD> 45::      <TD> ` |- ( x e. ( ( A u. B ) \ ( C \ A ) ) <-> ( `
       ` x e. ( A u. B ) /\ -. x e. ( C \ A ) ) ) `
       <TR> <TD> 46:45,44: <TD> ` |- ( x e. ( ( A u. B ) \ ( C \ A ) ) <-> ( `
       ` ( x e. A \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 47:4,38:  <TD> ` |- ( x e. ( A u. ( B \ C ) ) <-> ( ( x e. A `
       ` \/ x e. B ) /\ ( -. x e. C \/ x e. A ) ) ) `
       <TR> <TD> 48:46,47: <TD> ` |- ( x e. ( A u. ( B \ C ) ) <-> x e. ( ( A `
       ` u. B ) \ ( C \ A ) ) ) `
       <TR> <TD> 49:48:    <TD> ` |- A. x ( x e. ( A u. ( B \ C ) ) <-> x e. `
       ` ( ( A u. B ) \ ( C \ A ) ) ) `
       <TR> <TD> qed:49:   <TD> ` |- ( A u. ( B \ C ) ) = ( ( A u. B ) \ ( C `
       ` \ A ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 17-Apr-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    undif3VD $p |- ( A u. ( B \ C ) ) = ( ( A u. B ) \ ( C \ A ) ) $=
      ( vx cdif cun wcel wo wn elun eldif bitri idn1 orc e1_ olc in1 simpl jaoi
      wa cv wb wal wceq orbi2i pm3.2 e11 simpr bicomi orcd sylbir impbii notbii
      anddi pm4.53 anbi12i bitr4i ax-gen dfcleq biimpri e0_ ) DUAZABCEZFZGZVBAB
      FZCAEZEZGZUBZDUCZVDVHUDZVJDVEVBAGZVBBGZHZVBCGZIZVMHZTZVIVEVMVNVQTZHZVSVEV
      MVBVCGZHWAVBAVCJWBVTVMVBBCKUELWAVSVMVSVTVMVSVMVOVRVSVMVMVOVMMZVMVNNOVMVMV
      RWCVMVQPOVOVRUFZUGQVTVSVTVOVRVSVTVNVOVTVTVNVTMZVNVQROVNVMPOVTVQVRVTVTVQWE
      VNVQUHOVQVMNOWDUGQSVSVMVQTZVMVMTZHZVTVNVMTZHZHZWAVSWKVMVNVQVMUNUIWHWAWJWF
      WAWGWFWAWFWFWAWFMWFVMVTVMVQRUJOQWGWAWGVMWAWGWGVMWGMVMVMROVMVTNZOQSVTWAWIV
      TWAVTVTWAWEVTVMPOQWIWAWIVMWAWIWIVMWIMVNVMUHOWLOQSSUKULLVIVBVFGZVBVGGZIZTV
      SVBVFVGKWMVOWOVRVBABJWOVPVMITZIVRWNWPVBCAKUMVPVMUOLUPLUQURVLVKDVDVHUSUTVA
      $.
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d D y $.  $d x y $.
    $( Virtual deduction proof of ~ sbcssg .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ sbcssg
       is ~ sbcssgVD without virtual deductions and was automatically derived
       from ~ sbcssgVD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- (. A e. B ->. A e. B ). `
       <TR> <TD> 2:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. y e. C <-> y `
       ` e. [_ A / x ]_ C ) ). `
       <TR> <TD> 3:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. y e. D <-> y `
       ` e. [_ A / x ]_ D ) ). `
       <TR> <TD> 4:2,3:    <TD> ` |- (. A e. B ->. ( ( [. A / x ]. y e. C -> `
       ` [. A / x ]. y e. D ) <-> ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D `
       `  ) ) ). `
       <TR> <TD> 5:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. ( y e. C -> `
       ` y e. D ) <-> ( [. A / x ]. y e. C -> [. A / x ]. y e. D ) ) ). `
       <TR> <TD> 6:4,5:    <TD> ` |- (. A e. B ->. ( [. A / x ]. ( y e. C -> `
       ` y e. D ) <-> ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D ) ) ). `
       <TR> <TD> 7:6:      <TD> ` |- (. A e. B ->. A. y ( [. A / x ]. ( y e. `
       ` C -> y e. D ) <-> ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D ) ) ). `
       <TR> <TD> 8:7:      <TD> ` |- (. A e. B ->. ( A. y [. A / x ]. ( y e. `
       ` C -> y e. D ) <-> A. y ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D ) `
       ` ) ). `
       <TR> <TD> 9:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. A. y ( y e. `
       ` C -> y e. D ) <-> A. y [. A / x ]. ( y e. C -> y e. D ) ) ). `
       <TR> <TD> 10:8,9:   <TD> ` |- (. A e. B ->. ( [. A / x ]. A. y ( y e. `
       ` C -> y e. D ) <-> A. y ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D ) `
       ` ) ). `
       <TR> <TD> 11::      <TD> ` |- ( C C_ D <-> A. y ( y e. C -> y e. D ) ) `
       <TR> <TD> 110:11:   <TD> ` |- A. x ( C C_ D <-> A. y ( y e. C -> y e. `
       ` D ) ) `
       <TR> <TD> 12:1,110: <TD> ` |- (. A e. B ->. ( [. A / x ]. C C_ D <-> `
       ` [. A / x ]. A. y ( y e. C -> y e. D ) ) ). `
       <TR> <TD> 13:10,12: <TD> ` |- (. A e. B ->. ( [. A / x ]. C C_ D <-> `
       ` A. y ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D ) ) ). `
       <TR> <TD> 14::      <TD> ` |- ( [_ A / x ]_ C C_ [_ A / x ]_ D <-> A. `
       ` y ( y e. [_ A / x ]_ C -> y e. [_ A / x ]_ D ) ) `
       <TR> <TD> 15:13,14: <TD> ` |- (. A e. B ->. ( [. A / x ]. C C_ D <-> `
       ` [_ A / x ]_ C C_ [_ A / x ]_ D ) ). `
       <TR> <TD> qed:15:   <TD> ` |- ( A e. B -> ( [. A / x ]. C C_ D <-> [_ `
       ` A / x ]_ C C_ [_ A / x ]_ D ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    sbcssgVD $p |- ( A e. B -> ( [. A / x ]. C C_ D
          <-> [_ A / x ]_ C C_ [_ A / x ]_ D ) ) $=
      ( vy wcel wss wsbc csb wb wal sbcel2gOLD e1_ e11 bibi1 biimprcd dfss2 e10
      wi cv idn1 imbi12 sbcimg gen11 albi sbcalgOLD ax-gen sbcbi biantr ex in1
      ) BCGZDEHZABIZABDJZABEJZHZKZUMUOFUAZUPGZUTUQGZTZFLZKZURVDKZUSUMUTDGZUTEGZ
      TZFLZABIZVDKZUOVKKZVEUMVIABIZFLZVDKZVKVOKZVLUMVNVCKZFLVPUMVRFUMVGABIZVHAB
      IZTZVCKZVNWAKZVRUMVSVAKZVTVBKZWBUMUMWDUMUBZABUTDCMNUMUMWEWFABUTECMNVSVAVT
      VBUCOUMUMWCWFVGVHABCUDNWCVRWBVNWAVCPQOUEVNVCFUFNUMUMVQWFVIFABCUGNVQVLVPVK
      VOVDPQOUMUMUNVJKZALVMWFWGAFDERUHUNVJABCUISVMVEVLUOVKVDPQOFUPUQRVEVFUSUOVD
      URUJUKSUL $.

  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d D y $.  $d x y $.
    $( Virtual deduction proof of ~ csbingOLD .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       csbingOLD
       is ~ csbingVD without virtual deductions and was automatically derived
       from ~ csbingVD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- (. A e. B ->. A e. B ). `
       <TR> <TD> 2::       <TD> ` |- ( C i^i D ) = { y | ( y e. C /\ y e. D ) `
       ` } `
       <TR> <TD> 20:2:     <TD> ` |- A. x ( C i^i D ) = { y | ( y e. C /\ y `
       ` e. D ) } `
       <TR> <TD> 30:1,20:  <TD> ` |- (. A e. B ->. [. A / x ]. ( C i^i D ) = `
       ` { y | ( y e. C /\ y e. D ) } ). `
       <TR> <TD> 3:1,30:   <TD> ` |- (. A e. B ->. [_ A / x ]_ ( C i^i D ) = `
       ` [_ A / x ]_ { y | ( y e. C /\ y e. D ) } ). `
       <TR> <TD> 4:1:      <TD> ` |- (. A e. B ->. [_ A / x ]_ { y | ( y e. C `
       ` /\ y e. D ) } = { y | [. A / x ]. ( y e. C /\ y e. D ) } ). `
       <TR> <TD> 5:3,4:    <TD> ` |- (. A e. B ->. [_ A / x ]_ ( C i^i D ) = `
       ` { y | [. A / x ]. ( y e. C /\ y e. D ) } ). `
       <TR> <TD> 6:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. y e. C <-> y `
       ` e. [_ A / x ]_ C ) ). `
       <TR> <TD> 7:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. y e. D <-> y `
       ` e. [_ A / x ]_ D ) ). `
       <TR> <TD> 8:6,7:    <TD> ` |- (. A e. B ->. ( ( [. A / x ]. y e. C /\ `
       `[. A / x ]. y e. D ) <-> ( y e. [_ A / x ]_ C /\ y e. [_ A / x ]_ D ) `
       ` ) ). `
       <TR> <TD> 9:1:      <TD> ` |- (. A e. B ->. ( [. A / x ]. ( y e. C /\ `
       ` y e. D ) <-> ( [. A / x ]. y e. C /\ [. A / x ]. y e. D ) ) ). `
       <TR> <TD> 10:9,8:   <TD> ` |- (. A e. B ->. ( [. A / x ]. ( y e. C /\ `
       ` y e. D ) <-> ( y e. [_ A / x ]_ C /\ y e. [_ A / x ]_ D ) ) ). `
       <TR> <TD> 11:10:    <TD> ` |- (. A e. B ->. A. y ( [. A / x ]. ( y e. `
       ` C /\ y e. D ) <-> ( y e. [_ A / x ]_ C /\ y e. [_ A / x ]_ D ) ) ). `
       <TR> <TD> 12:11:    <TD> ` |- (. A e. B ->. { y | [. A / x ]. ( y e. C `
       ` /\ y e. D ) } = { y | ( y e. [_ A / x ]_ C /\ y e. [_ A / x ]_ D ) }
       ). `
       <TR> <TD> 13:5,12:  <TD> ` |- (. A e. B ->. [_ A / x ]_ ( C i^i D ) = `
       ` { y | ( y e. [_ A / x ]_ C /\ y e. [_ A / x ]_ D ) } ). `
       <TR> <TD> 14::      <TD> ` |- ( [_ A / x ]_ C i^i [_ A / x ]_ D ) = { `
       ` y | ( y e. [_ A / x ]_ C /\ y e. [_ A / x ]_ D ) } `
       <TR> <TD> 15:13,14: <TD> ` |- (. A e. B ->. [_ A / x ]_ ( C i^i D ) = `
       ` ( [_ A / x ]_ C i^i [_ A / x ]_ D ) ). `
       <TR> <TD> qed:15:   <TD> ` |- ( A e. B -> [_ A / x ]_ ( C i^i D ) = ( `
       ` [_ A / x ]_ C i^i [_ A / x ]_ D ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    csbingVD $p |- ( A e. B -> [_ A / x ]_ ( C i^i D ) =
                  ( [_ A / x ]_ C i^i [_ A / x ]_ D ) ) $=
      ( vy wcel cin csb wceq wa cab wsbc wal df-in e10 e11 e1_ biimprd wb spsbc
      cv ax-gen sbceqg biimpd csbabgOLD eqeq1 sbcangOLD sbcel2gOLD pm4.38 bibi1
      idn1 ex gen11 abbi biimpi eqeq2 biimprcd in1 ) BCGZABDEHZIZABDIZABEIZHZJZ
      UTVBFUBZVCGZVGVDGZKZFLZJZVEVKJZVFUTVBVGDGZVGEGZKZABMZFLZJZVRVKJZVLUTVBABV
      PFLZIZJZWBVRJZVSUTUTVAWAJZABMZWCUTULZUTUTWEANWFWGWEAFDEOUCWEABCUAPUTWFWCA
      BVAWACUDUEQUTUTWDWGVPAFBCUFRWCVSWDVBWBVRUGSQUTVQVJTZFNZVTUTWHFUTVQVNABMZV
      OABMZKZTZWLVJTZWHUTUTWMWGVNVOABCUHRUTWJVHTZWKVITZWNUTUTWOWGABVGDCUIRUTUTW
      PWGABVGECUIRWOWPWNWJWKVHVIUJUMQWMWHWNVQWLVJUKSQUNWIVTVQVJFUOUPRVSVLVTVBVR
      VKUGSQFVCVDOVMVFVLVEVKVBUQURPUS $.
  $}

  ${
    $d a b y $.  $d b x y $.
    $( Virtual deduction proof of ~ onfrALTlem5 .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.
       ~ onfrALTlem5 is ~ onfrALTlem5VD without virtual deductions and was
       automatically derived
       from ~ onfrALTlem5VD .
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- a e. _V `
       <TR> <TD> 2:1:       <TD> ` |- ( a i^i x ) e. _V `
       <TR> <TD> 3:2:       <TD> ` |- ( [. ( a i^i x ) / b ]. b = (/) <-> ( a `
       ` i^i x ) = (/) ) `
       <TR> <TD> 4:3:       <TD> ` |- ( -. [. ( a i^i x ) / b ]. b = (/) <-> `
       ` -. ( a i^i x ) = (/) ) `
       <TR> <TD> 5::        <TD> ` |- ( ( a i^i x ) =/= (/) <-> -. ( a i^i x `
       ` ) = (/) ) `
       <TR> <TD> 6:4,5:     <TD> ` |- ( -. [. ( a i^i x ) / b ]. b = (/) <-> `
       ` ( a i^i x ) =/= (/) ) `
       <TR> <TD> 7:2:       <TD> ` |- ( -. [. ( a i^i x ) / b ]. b = (/) <-> `
       ` [. ( a i^i x ) / b ]. -. b = (/) ) `
       <TR> <TD> 8::        <TD> ` |- ( b =/= (/) <-> -. b = (/) ) `
       <TR> <TD> 9:8:       <TD> ` |- A. b ( b =/= (/) <-> -. b = (/) ) `
       <TR> <TD> 10:2,9:    <TD> ` |- ( [. ( a i^i x ) / b ]. b =/= (/) <-> `
       ` [. ( a i^i x ) / b ]. -. b = (/) ) `
       <TR> <TD> 11:7,10:   <TD> ` |- ( -. [. ( a i^i x ) / b ]. b = (/) <-> `
       ` [. ( a i^i x ) / b ]. b =/= (/) ) `
       <TR> <TD> 12:6,11:   <TD> ` |- ( [. ( a i^i x ) / b ]. b =/= (/) <-> ( `
       ` a i^i x ) =/= (/) ) `
       <TR> <TD> 13:2:      <TD> ` |- ( [. ( a i^i x ) / b ]. b C_ ( a i^i x `
       ` ) <-> ( a i^i x ) C_ ( a i^i x ) ) `
       <TR> <TD> 14:12,13:  <TD> ` |- ( ( [. ( a i^i x ) / b ]. b C_ ( a i^i `
       ` x ) /\ [. ( a i^i x ) / b ]. b =/= (/) ) <-> ( ( a i^i x ) C_ ( a `
       ` i^i x ) /\ ( a i^i x ) =/= (/) ) ) `
       <TR> <TD> 15:2:      <TD> ` |- ( [. ( a i^i x ) / b ]. ( b C_ ( a i^i `
       ` x ) /\ b =/= (/) ) <-> ( [. ( a i^i x ) / b ]. b C_ ( a i^i x ) /\ `
       ` [. ( a i^i x ) / b ]. b =/= (/) ) ) `
       <TR> <TD> 16:15,14:  <TD> ` |- ( [. ( a i^i x ) / b ]. ( b C_ ( a i^i `
       ` x ) /\ b =/= (/) ) <-> ( ( a i^i x ) C_ ( a i^i x ) /\ ( a i^i x ) `
       ` =/= (/) ) ) `
       <TR> <TD> 17:2:      <TD> ` |- [_ ( a i^i x ) / b ]_ ( b i^i y ) = ( `
       ` [_ ( a i^i x ) / b ]_ b i^i [_ ( a i^i x ) / b ]_ y ) `
       <TR> <TD> 18:2:      <TD> ` |- [_ ( a i^i x ) / b ]_ b = ( a i^i x ) `
       <TR> <TD> 19:2:      <TD> ` |- [_ ( a i^i x ) / b ]_ y = y `
       <TR> <TD> 20:18,19:  <TD> ` |- ( [_ ( a i^i x ) / b ]_ b i^i [_ ( a `
       ` i^i x ) / b ]_ y ) = ( ( a i^i x ) i^i y ) `
       <TR> <TD> 21:17,20:  <TD> ` |- [_ ( a i^i x ) / b ]_ ( b i^i y ) = ( ( `
       ` a i^i x ) i^i y ) `
       <TR> <TD> 22:2:      <TD> ` |- ( [. ( a i^i x ) / b ]. ( b i^i y ) = `
       ` (/) <-> [_ ( a i^i x ) / b ]_ ( b i^i y ) = [_ ( a i^i x ) / b ]_ `
       ` (/) ) `
       <TR> <TD> 23:2:      <TD> ` |- [_ ( a i^i x ) / b ]_ (/) = (/) `
       <TR> <TD> 24:21,23:  <TD> ` |- ( [_ ( a i^i x ) / b ]_ ( b i^i y ) = `
       ` [_ ( a i^i x ) / b ]_ (/) <-> ( ( a i^i x ) i^i y ) = (/) ) `
       <TR> <TD> 25:22,24:  <TD> ` |- ( [. ( a i^i x ) / b ]. ( b i^i y ) = `
       ` (/) <-> ( ( a i^i x ) i^i y ) = (/) ) `
       <TR> <TD> 26:2:      <TD> ` |- ( [. ( a i^i x ) / b ]. y e. b <-> y e. `
       ` ( a i^i x ) ) `
       <TR> <TD> 27:25,26:  <TD> ` |- ( ( [. ( a i^i x ) / b ]. y e. b /\ [. `
       ` ( a i^i x ) / b ]. ( b i^i y ) = (/) ) <-> ( y e. ( a i^i x ) /\ ( ( `
       ` a i^i x ) i^i y ) = (/) ) ) `
       <TR> <TD> 28:2:      <TD> ` |- ( [. ( a i^i x ) / b ]. ( y e. b /\ ( b `
       ` i^i y ) = (/) ) <-> ( [. ( a i^i x ) / b ]. y e. b /\ [. ( a i^i x ) `
       ` / b ]. ( b i^i y ) = (/) ) ) `
       <TR> <TD> 29:27,28:  <TD> ` |- ( [. ( a i^i x ) / b ]. ( y e. b /\ ( b `
       ` i^i y ) = (/) ) <-> ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i y ) = `
       ` (/) ) ) `
       <TR> <TD> 30:29:     <TD> ` |-  A. y ( [. ( a i^i x ) / b ]. ( y e. b `
       ` /\ ( b i^i y ) = (/) ) <-> ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i `
       ` y ) = (/) ) ) `
       <TR> <TD> 31:30:     <TD> ` |- ( E. y [. ( a i^i x ) / b ]. ( y e. b `
       ` /\ ( b i^i y ) = (/) ) <-> E. y ( y e. ( a i^i x ) /\ ( ( a i^i x ) `
       ` i^i y ) = (/) ) ) `
       <TR> <TD> 32::       <TD> ` |- ( E. y e. ( a i^i x ) ( ( a i^i x ) i^i `
       ` y ) = (/) <-> E. y ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i y ) = (/) `
       ` ) ) `
       <TR> <TD> 33:31,32:  <TD> ` |- ( E. y [. ( a i^i x ) / b ]. ( y e. b `
       ` /\ ( b i^i y ) = (/) ) <-> E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) `
       ` = (/) ) `
       <TR> <TD> 34:2:      <TD> ` |- ( E. y [. ( a i^i x ) / b ]. ( y e. b `
       ` /\ ( b i^i y ) = (/) ) <-> [. ( a i^i x ) / b ]. E. y ( y e. b /\ ( `
       ` b i^i y ) = (/) ) ) `
       <TR> <TD> 35:33,34:  <TD> ` |- ( [. ( a i^i x ) / b ]. E. y ( y e. b `
       ` /\ ( b i^i y ) = (/) ) <-> E. y e. ( a i^i x ) ( ( a i^i x ) i^i y `
       ` ) = (/) ) `
       <TR> <TD> 36::       <TD> ` |- ( E. y e. b ( b i^i y ) = (/) <-> E. y `
       ` ( y e. b /\ ( b i^i y ) = (/) ) ) `
       <TR> <TD> 37:36:     <TD> ` |- A. b ( E. y e. b ( b i^i y ) = (/) <-> `
       ` E. y ( y e. b /\ ( b i^i y ) = (/) ) ) `
       <TR> <TD> 38:2,37:   <TD> ` |- ( [. ( a i^i x ) / b ]. E. y e. b ( b `
       ` i^i y ) = (/) <-> [. ( a i^i x ) / b ]. E. y ( y e. b /\ ( b i^i y ) `
       ` = (/) ) ) `
       <TR> <TD> 39:35,38:  <TD> ` |- ( [. ( a i^i x ) / b ]. E. y e. b ( b `
       ` i^i y ) = (/) <-> E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = (/) ) `
       <TR> <TD> 40:16,39:  <TD> ` |- ( ( [. ( a i^i x ) / b ]. ( b C_ ( a `
       ` i^i x ) /\ b =/= (/) ) -> [. ( a i^i x ) / b ]. E. y e. b ( b i^i `
       ` y ) = (/) ) <-> ( ( ( a i^i x ) C_ ( a i^i x ) /\ ( a i^i x ) =/= `
       ` (/) ) -> E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = (/) ) ) `
       <TR> <TD> 41:2:      <TD> ` |- ( [. ( a i^i x ) / b ]. ( ( b C_ ( a `
       ` i^i x ) /\ b =/= (/) ) -> E. y e. b ( b i^i y ) = (/) ) <-> ( [. ( a `
       ` i^i x ) / b ]. ( b C_ ( a i^i x ) /\ b =/= (/) ) -> [. ( a i^i x ) / `
       ` b ]. E. y e. b ( b i^i y ) = (/) ) ) `
       <TR> <TD> qed:40,41: <TD> ` |- ( [. ( a i^i x ) / b ]. ( ( b C_ ( a `
       ` i^i x ) /\ b =/= (/) ) -> E. y e. b ( b i^i y ) = (/) ) <-> ( ( ( a `
       ` i^i x ) C_ ( a i^i x ) /\ ( a i^i x ) =/= (/) ) -> E. y e. ( a i^i x `
       ` ) ( ( a i^i x ) i^i y ) = (/) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    onfrALTlem5VD $p |- ( [. ( a i^i x ) / b ]. ( ( b C_ ( a i^i x )
          /\ b =/= (/) )
       ->
          E. y e. b ( b i^i y ) = (/) )
            <-> ( ( ( a i^i x ) C_ ( a i^i x ) /\ ( a i^i x ) =/= (/) ) ->
                 E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = (/) ) ) $=
      ( cv cin c0 wa wceq wi wsbc cvv wcel wb e0_ wn wal ax-gen bitri csb inex1
      wss wne vex sbcimg sbcangOLD sseq1 sbcieg sbcng bicomd df-ne sbcbi bitr4i
      wrex e00 eqsbc3 notbii bitr3i anbi12i df-rex sbcexgOLD sbcel2gv csbingOLD
      wex sbceqg csbvarg csbconstg ineq12i eqtri eqeq12i exbi imbi12i ) DEZCEZA
      EZFZUBZVMGUCZHZVMBEZFZGIZBVMUNZJDVPKZVSDVPKZWCDVPKZJZVPVPUBZVPGUCZHZVPVTF
      ZGIZBVPUNZJVPLMZWDWGNVNVOCUDUAZVSWCDVPLUEOWEWJWFWMWEVQDVPKZVRDVPKZHZWJWNW
      EWRNWOVQVRDVPLUFOWPWHWQWIWNWPWHNWOVQWHDVPLVMVPVPUGUHOWQVMGIZDVPKZPZWIXAWS
      PZDVPKZWQWNXAXCNWOWNXCXAWSDVPLUIUJOWNVRXBNZDQWQXCNWOXDDVMGUKRVRXBDVPLULUO
      UMXAVPGIZPWIWTXEWNWTXENWODVPGLUPOUQVPGUKUMURUSSWFVTVMMZWBHZBVDZDVPKZWMWNW
      CXHNZDQWFXINWOXJDWBBVMUTRWCXHDVPLULUOXIXGDVPKZBVDZWMWNXLXINWOWNXIXLXGBDVP
      LVAUJOXLVTVPMZWLHZBVDZWMXKXNNZBQXLXONXPBXKXFDVPKZWBDVPKZHZXNWNXKXSNWOXFWB
      DVPLUFOXQXMXRWLWNXQXMNWODVTVPLVBOXRDVPWATZDVPGTZIZWLWNXRYBNWODVPWAGLVEOXT
      WKYAGXTDVPVMTZDVPVTTZFZWKWNXTYEIWODVPLVMVTVCOYCVPYDVTWNYCVPIWODVPLVFOWNYD
      VTIWODVPVTLVGOVHVIWNYAGIWODVPGLVGOVJSUSSRXKXNBVKOWLBVPUTUMURSVLS $.

  $}

  ${
    $d a x $.
    $( Virtual deduction proof of ~ onfrALTlem4 .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       onfrALTlem4
       is ~ onfrALTlem4VD without virtual deductions and was automatically
       derived
       from ~ onfrALTlem4VD .
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- y e. _V `
       <TR> <TD> 2:1:       <TD> ` |- ( [. y / x ]. ( a i^i x ) = (/) <-> [_ `
       ` y / x ]_ ( a i^i x ) = [_ y / x ]_ (/) ) `
       <TR> <TD> 3:1:       <TD> ` |- [_ y / x ]_ ( a i^i x ) = ( [_ y / x ]_ `
       ` a i^i [_ y / x ]_ x ) `
       <TR> <TD> 4:1:       <TD> ` |- [_ y / x ]_ a = a `
       <TR> <TD> 5:1:       <TD> ` |- [_ y / x ]_ x = y `
       <TR> <TD> 6:4,5:     <TD> ` |- ( [_ y / x ]_ a i^i [_ y / x ]_ x ) = ( `
       ` a i^i y ) `
       <TR> <TD> 7:3,6:     <TD> ` |- [_ y / x ]_ ( a i^i x ) = ( a i^i y ) `
       <TR> <TD> 8:1:       <TD> ` |- [_ y / x ]_ (/) = (/) `
       <TR> <TD> 9:7,8:     <TD> ` |- ( [_ y / x ]_ ( a i^i x ) = [_ y / x ]_ `
       ` (/) <-> ( a i^i y ) = (/) ) `
       <TR> <TD> 10:2,9:    <TD> ` |- ( [. y / x ]. ( a i^i x ) = (/) <-> ( a `
       ` i^i y ) = (/) ) `
       <TR> <TD> 11:1:      <TD> ` |- ( [. y / x ]. x e. a <-> y e. a ) `
       <TR> <TD> 12:11,10:  <TD> ` |- ( ( [. y / x ]. x e. a /\ [. y / x ]. ( `
       ` a i^i x ) = (/) )  <-> ( y e. a /\ ( a i^i y ) = (/) ) ) `
       <TR> <TD> 13:1:      <TD> ` |- ( [. y / x ]. ( x e. a /\ ( a i^i x ) = `
       ` (/) ) <-> ( [. y / x ]. x e. a /\ [. y / x ]. ( a i^i x ) = (/) ) ) `
       <TR> <TD> qed:13,12: <TD> ` |- ( [. y / x ]. ( x e. a /\ ( a i^i x ) = `
       ` (/) ) <-> ( y e. a /\ ( a i^i y ) = (/) ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    onfrALTlem4VD $p |- ( [. y / x ]. ( x e. a /\ ( a i^i x ) = (/) ) <->
                        ( y e. a /\ ( a i^i y ) = (/) ) ) $=
      ( wel cv cin c0 wceq wa wsbc cvv wcel vex sbcangOLD sbcel1gvOLD csbconstg
      wb e0_ csb bitri sbceqg csbingOLD csbvarg ineq12i eqtri eqeq12i anbi12i )
      ACDZCEZAEZFZGHZIABEZJZUHAUMJZULAUMJZIZBCDZUIUMFZGHZIUMKLZUNUQQBMZUHULAUMK
      NRUOURUPUTVAUOURQVBAUMUIKORUPAUMUKSZAUMGSZHZUTVAUPVEQVBAUMUKGKUARVCUSVDGV
      CAUMUISZAUMUJSZFZUSVAVCVHHVBAUMKUIUJUBRVFUIVGUMVAVFUIHVBAUMUIKPRVAVGUMHVB
      AUMKUCRUDUEVAVDGHVBAUMGKPRUFTUGT $.

  $}

  ${
    $d a b y $.  $d b x y $.
    $( Virtual deduction proof of ~ onfrALTlem3 .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       onfrALTlem3
       is ~ onfrALTlem3VD without virtual deductions and was automatically
       derived
       from ~ onfrALTlem3VD .
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. ( a `
       ` C_ On /\ a =/= (/) ) ). `
       <TR> <TD> 2::          <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( x e. a /\ -. ( a i^i x ) = (/) ) ).
       `
       <TR> <TD> 3:2:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. x e. a ). `
       <TR> <TD> 4:1:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. a C_ `
       ` On ). `
       <TR> <TD> 5:3,4:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. x e. On ). `
       <TR> <TD> 6:5:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. Ord x ). `
       <TR> <TD> 7:6:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. _E We x ). `
       <TR> <TD> 8::          <TD> ` |- ( a i^i x ) C_ x `
       <TR> <TD> 9:7,8:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. _E We ( a i^i x ) ). `
       <TR> <TD> 10:9:        <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. _E Fr ( a i^i x ) ). `
       <TR> <TD> 11:10:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. A. b ( ( b C_ ( a i^i x ) /\ b =/= `
       ` (/) ) -> E. y e. b ( b i^i y ) = (/) ) ). `
       <TR> <TD> 12::         <TD> ` |- x e. _V `
       <TR> <TD> 13:12,8:     <TD> ` |- ( a i^i x ) e. _V `
       <TR> <TD> 14:13,11:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. [. ( a i^i x ) / b ]. ( ( b C_ ( a `
       ` i^i x ) /\ b =/= (/) ) -> E. y e. b ( b i^i y ) = (/) ) ). `
       <TR> <TD> 15::         <TD> ` |- ( [. ( a i^i x ) / b ]. ( ( b C_ ( a `
       ` i^i x ) /\ b =/= (/) ) -> E. y e. b ( b i^i y ) = (/) ) <-> ( ( ( a
       i^i `
       ` x ) C_ ( a i^i x ) /\ ( a i^i x ) =/= (/) ) -> E. y e. ( a i^i x ) ( `
       ` ( a i^i x ) i^i y ) = (/) ) ) `
       <TR> <TD> 16:14,15:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( ( ( a i^i x ) C_ ( a i^i x ) /\ ( `
       ` a i^i x ) =/= (/) ) -> E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = `
       ` (/) ) ). `
       <TR> <TD> 17::         <TD> ` |- ( a i^i x ) C_ ( a i^i x ) `
       <TR> <TD> 18:2:        <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. -. ( a i^i x ) = (/) ). `
       <TR> <TD> 19:18:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( a i^i x ) =/= (/) ). `
       <TR> <TD> 20:17,19:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( ( a i^i x ) C_ ( a i^i x ) /\ ( a
       i^i `
       ` x ) =/= (/) ) ). `
       <TR> <TD> qed:16,20:   <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. E. y e. ( a i^i x ) ( ( a i^i x ) i^i
       y `
       ` ) = (/) ). `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    onfrALTlem3VD $p |- (. ( a C_ On /\ a =/= (/) ) ,.
                        ( x e. a /\ -. ( a i^i x ) = (/) )
           ->. E. y e. ( a i^i x ) ( ( a i^i x ) i^i y ) = (/) ). $=
      ( vb cv con0 wss c0 wne wa wcel cin wceq wrex wi cvv cep wwe simpl e2 wal
      wn wsbc vex inss2 ssexi wfr word idn2 idn1 e1_ ssel com12 e21 eloni ordwe
      wess e20 wefr dfepfr biimpi spsbc e02 onfrALTlem5 e2bi ssid simpr biimpri
      df-ne pm3.2 id e22 ) CEZFGZVMHIZJZAEZVMKZVMVQLZHMUBZJZVSVSGZVSHIZJZVSBEZL
      HMBVSNZOZWDWFVPWADEZVSGWHHIJWHWELHMBWHNOZDVSUCZWGVSPKVPWAWIDUAZWJVSVQAUDV
      MVQUEZUFVPWAVSQUGZWKVPWAVSQRZWMVPWAVQQRZVSVQGZWNVPWAVQUHZWOVPWAVQFKZWQVPW
      AVRVNWRVPWAWAVRVPWAUIZVRVTSTVPVPVNVPUJVNVOSUKVNVRWRVMFVQULUMUNVQUOTVQUPTW
      LWPWOWNVSVQQUQUMURVSQUSTWMWKDBVSUTVATWIDVSPVBVCABCDVDVEWBVPWAWCWDVSVFVPWA
      VTWCVPWAWAVTWSVRVTVGTWCVTVSHVIVHTWBWCVJVCWGVKVL $.
  $}

  $( Virtual deduction proof of ~ simplbi2comg .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
     simplbi2comg
     is ~ simplbi2comgVD without virtual deductions and was automatically
     derived
     from ~ simplbi2comgVD .
     <HTML> <TABLE>
     <TR> <TD> 1::    <TD> ` |- (. ( ph <-> ( ps /\ ch ) ) ->. ( ph <-> ( `
     ` ps /\ ch ) ) ). `
     <TR> <TD> 2:1:   <TD> ` |- (. ( ph <-> ( ps /\ ch ) ) ->. ( ( ps /\ ch `
     ` ) -> ph ) ). `
     <TR> <TD> 3:2:   <TD> ` |- (. ( ph <-> ( ps /\ ch ) ) ->. ( ps -> ( ch `
     ` -> ph ) ) ). `
     <TR> <TD> 4:3:   <TD> ` |- (. ( ph <-> ( ps /\ ch ) ) ->. ( ch -> ( ps `
     ` -> ph ) ) ). `
     <TR> <TD> qed:4: <TD> ` |- ( ( ph <-> ( ps /\ ch ) ) -> ( ch -> ( ps `
     ` -> ph ) ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  simplbi2comgVD $p |- ( ( ph <-> ( ps /\ ch ) ) ->
                         ( ch -> ( ps -> ph ) ) ) $=
    ( wa wb wi idn1 bi2 e1_ pm3.3 pm2.04 in1 ) ABCDZEZCBAFFZNBCAFFZONMAFZPNNQNG
    AMHIBCAJIBCAKIL $.

  ${
    $d a y z $.  $d x y z $.
    $( Virtual deduction proof of ~ onfrALTlem2 .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       onfrALTlem2
       is ~ onfrALTlem2VD without virtual deductions and was automatically
       derived
       from ~ onfrALTlem2VD .
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. ( ( y e. ( a i^i x ) /\ ( ( a
       i^i `
       ` x ) i^i y ) = (/) ) /\ z e. ( a i^i y ) ) ). `
       <TR> <TD> 2:1:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. z e. ( a i^i y ) ). `
       <TR> <TD> 3:2:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. z e. a ). `
       <TR> <TD> 4::          <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. ( a `
       ` C_ On /\ a =/= (/) ) ). `
       <TR> <TD> 5::          <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( x e. a /\ -. ( a i^i x ) = (/) ) ).
       `
       <TR> <TD> 6:5:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. x e. a ). `
       <TR> <TD> 7:4:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. a C_ `
       ` On ). `
       <TR> <TD> 8:6,7:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. x e. On ). `
       <TR> <TD> 9:8:         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. Ord x ). `
       <TR> <TD> 10:9:        <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. Tr x ). `
       <TR> <TD> 11:1:        <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->.  y e. ( a i^i x ) ). `
       <TR> <TD> 12:11:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. y e. x ). `
       <TR> <TD> 13:2:        <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. z e. y ). `
       <TR> <TD> 14:10,12,13: <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. z e. x ). `
       <TR> <TD> 15:3,14:     <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. z e. ( a i^i x ) ). `
       <TR> <TD> 16:13,15:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       i^i `
       ` y ) = (/) ) /\ z e. ( a i^i y ) ) ->. z e. ( ( a i^i x ) i^i y ) ). `
       <TR> <TD> 17:16:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. ( z e. ( a i^i y ) -> z e. ( ( a i^i x ) i^i y ) ) ). `
       <TR> <TD> 18:17:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. A. z ( z e. ( a i^i y ) -> z e. ( ( a i^i x ) i^i y ) )
       ). `
       <TR> <TD> 19:18:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. ( a i^i y ) C_ ( ( a i^i x ) i^i y ) ). `
       <TR> <TD> 20::         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i y ) = (/) ) ). `
       <TR> <TD> 21:20:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. ( ( a i^i x ) i^i y ) = (/) ). `
       <TR> <TD> 22:19,21:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. ( a i^i y ) = (/) ). `
       <TR> <TD> 23:20:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. y e. ( a i^i x ) ). `
       <TR> <TD> 24:23:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. y e. a ). `
       <TR> <TD> 25:22,24:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) , ( y e. ( a i^i x ) /\ ( ( a i^i x ) i^i
       y `
       ` ) = (/) ) ->. ( y e. a /\ ( a i^i y ) = (/) ) ). `
       <TR> <TD> 26:25:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( ( y e. ( a i^i x ) /\ ( ( a i^i x )
       `
       ` i^i y ) = (/) ) -> ( y e. a /\ ( a i^i y ) = (/) ) ) ). `
       <TR> <TD> 27:26:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. A. y ( ( y e. ( a i^i x ) /\ ( ( a i^i
       x `
       ` ) i^i y ) = (/) ) -> ( y e. a /\ ( a i^i y ) = (/) ) ) ). `
       <TR> <TD> 28:27:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. ( E. y ( y e. ( a i^i x ) /\ ( ( a i^i
       x `
       ` ) i^i y ) = (/) ) -> E. y ( y e. a /\ ( a i^i y ) = (/) ) ) ). `
       <TR> <TD> 29::         <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. E. y e. ( a i^i x ) ( ( a i^i x ) i^i
       y `
       ` ) = (/) ). `
       <TR> <TD> 30:29:       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. E. y ( y e. ( a i^i x ) /\ ( ( a i^i x
       ) `
       ` i^i y ) = (/) ) ). `
       <TR> <TD> 31:28,30:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. E. y ( y e. a /\ ( a i^i y ) = (/) )
       ). `
       <TR> <TD> qed:31:      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. `
       ` a /\ -. ( a i^i x ) = (/) ) ->. E. y e. a ( a i^i y ) = (/) ). `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    onfrALTlem2VD $p |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\
                        -. ( a i^i x ) = (/) ) ->. E. y e. a ( a i^i y ) =
                        (/) ). $=
      ( vz cv con0 wss c0 wa wcel cin wceq wex wrex wi e3 sseli simpl e2 e33 wn
      wne wal idn3 simpr inss2 inss1 wtr word idn2 idn1 ssel com12 eloni simpll
      e1_ e21 ordtr trel exp3acom23 e233 simplbi2 simplbi2com in3an gen31 dfss2
      elin biimpri sseq0 ex pm3.21 in3 gen21 onfrALTlem3VD df-rex biimpi id e22
      exim ) CEZFGZVTHUBZIZAEZVTJZVTWDKZHLUAZIZBEZVTJZVTWIKZHLZIZBMZWLBVTNZWCWH
      WIWFJZWFWIKZHLZIZBMZWNOZWTWNWCWHWSWMOZBUCXAWCWHXBBWCWHWSWMWCWHWSWLWJWMWCW
      HWSWKWQGZWRWLWCWHWSDEZWKJZXDWQJZOZDUCZXCWCWHWSXGDWCWHWSXEXFWCWHWSXEIZXDWI
      JZXDWFJZXFWCWHXIXEXJWCWHXIXIXEWCWHXIUDZWSXEUEPZWKWIXDVTWIUFQPZWCWHXIXDVTJ
      ZXDWDJZXKWCWHXIXEXOXMWKVTXDVTWIUGQPWCWHWDUHZXIWIWDJZXJXPWCWHWDUIZXQWCWHWD
      FJZXSWCWHWEWAXTWCWHWHWEWCWHUJWEWGRSWCWCWAWCUKWAWBRUPWAWEXTVTFWDULUMUQWDUN
      SWDURSWCWHXIWPXRWCWHXIXIWPXLWPWRXEUOPWFWDWIVTWDUFQPXNXQXJXRXPWDXDWIUSUTVA
      XKXOXPXDVTWDVGVBTXFXKXJXDWFWIVGVCTVDVEXCXHDWKWQVFVHPWCWHWSWSWRWCWHWSUDZWP
      WRUEPXCWRWLWKWQVIVJTWCWHWSWPWJWCWHWSWSWPYAWPWRRPWFVTWIVTWDUGQPWLWJVKTVLVM
      WSWMBVSSWCWHWRBWFNZWTABCVNYBWTWRBWFVOVPSXAVQVRWOWNWLBVTVOVHS $.
  $}

  ${
    $d a x y $.
    $( Virtual deduction proof of ~ onfrALTlem1 .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       onfrALTlem1
       is ~ onfrALTlem1VD without virtual deductions and was automatically
       derived
       from ~ onfrALTlem1VD .
       <HTML> <TABLE>
       <TR> <TD> 1::      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\
       `
       ` ( a i^i x ) = (/) ) ->. ( x e. a /\ ( a i^i x ) = (/) ) ). `
       <TR> <TD> 2:1:     <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\
       `
       ` ( a i^i x ) = (/) ) ->. E. x ( x e. a /\ ( a i^i x ) = (/) ) ). `
       <TR> <TD> 3:2:     <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\
       `
       ` ( a i^i x ) = (/) ) ->. E. y [ y / x ] ( x e. a /\ ( a i^i x ) = (/) )
       `
       ` ). `
       <TR> <TD> 4::      <TD> ` |- ( [ y / x ] ( x e. a /\ ( a i^i x ) = (/) `
       ` ) <-> ( y e. a /\ ( a i^i y ) = (/) ) ) `
       <TR> <TD> 5:4:     <TD> ` |- A. y ( [ y / x ] ( x e. a /\ ( a i^i x ) `
       ` = (/) ) <-> ( y e. a /\ ( a i^i y ) = (/) ) ) `
       <TR> <TD> 6:5:     <TD> ` |- ( E. y [ y / x ] ( x e. a /\ ( a i^i x ) `
       ` = (/) ) <-> E. y ( y e. a /\ ( a i^i y ) = (/) ) ) `
       <TR> <TD> 7:3,6:   <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\
       `
       ` ( a i^i x ) = (/) ) ->. E. y ( y e. a /\ ( a i^i y ) = (/) ) ). `
       <TR> <TD> 8::      <TD> ` |- (  E. y e. a ( a i^i y ) = (/) <-> E. y ( `
       ` y e. a /\ ( a i^i y ) = (/) ) ) `
       <TR> <TD> qed:7,8: <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\
       `
       ` ( a i^i x ) = (/) ) ->. E. y e. a ( a i^i y ) = (/) ). `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    onfrALTlem1VD $p |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a /\ ( a i^i x )
                   = (/) ) ->. E. y e. a ( a i^i y ) = (/) ). $=
      ( cv con0 wss c0 wne wa wcel cin wceq wex wrex wsb idn2 19.8a e2 cbvexsv
      wb biimpi wal wsbc sbsbc onfrALTlem4 bitri ax-gen exbi e2bi df-rex e2bir
      e0_ ) CDZEFUMGHIZADZUMJUMUOKGLIZBDZUMJUMUQKGLZIZBMZURBUMNUNUPUPABOZBMZUTU
      NUPUPAMZVBUNUPUPVCUNUPPUPAQRVCVBUPABSUARVAUSTZBUBVBUTTVDBVAUPAUQUCUSUPABU
      DABCUEUFUGVAUSBUHULUIURBUMUJUK $.
  $}

  ${
    $d a x y $.
    $( Virtual deduction proof of ~ onfrALT .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ onfrALT
       is ~ onfrALTVD without virtual deductions and was automatically derived
       from ~ onfrALTVD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a `
       ` /\ -. ( a i^i x ) = (/) ) ->. E. y e. a ( a i^i y ) = (/) ). `
       <TR> <TD> 2::       <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. ( x e. a `
       ` /\ ( a i^i x ) = (/) ) ->. E. y e. a ( a i^i y ) = (/) ). `
       <TR> <TD> 3:1:      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. x e. a ->.
       `
       ` ( -. ( a i^i x ) = (/) -> E. y e. a ( a i^i y ) = (/) ) ). `
       <TR> <TD> 4:2:      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. x e. a ->.
       `
       ` ( ( a i^i x ) = (/) -> E. y e. a ( a i^i y ) = (/) ) ). `
       <TR> <TD> 5::       <TD> ` |- ( ( a i^i x ) = (/) \/ -. ( a i^i x ) = `
       ` (/) ) `
       <TR> <TD> 6:5,4,3:  <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ,. x e. a ->.
       `
       ` E. y e. a ( a i^i y ) = (/) ). `
       <TR> <TD> 7:6:      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. ( x e. a `
       ` -> E. y e. a ( a i^i y ) = (/) ) ). `
       <TR> <TD> 8:7:      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. A. x ( x `
       ` e. a -> E. y e. a ( a i^i y ) = (/) ) ). `
       <TR> <TD> 9:8:      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. ( E. x x `
       ` e. a -> E. y e. a ( a i^i y ) = (/) ) ). `
       <TR> <TD> 10::      <TD> ` |- ( a =/= (/) <-> E. x x e. a ) `
       <TR> <TD> 11:9,10:  <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. ( a =/= `
       ` (/) -> E. y e. a ( a i^i y ) = (/) ) ). `
       <TR> <TD> 12::      <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. ( a C_ `
       ` On /\ a =/= (/) ) ). `
       <TR> <TD> 13:12:    <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. a =/= `
       ` (/) ). `
       <TR> <TD> 14:13,11: <TD> ` |- (. ( a C_ On /\ a =/= (/) ) ->. E. y e. `
       ` a ( a i^i y ) = (/) ). `
       <TR> <TD> 15:14:    <TD> ` |- ( ( a C_ On /\ a =/= (/) ) -> E. y e. a `
       ` ( a i^i y ) = (/) ) `
       <TR> <TD> 16:15:    <TD> ` |- A. a ( ( a C_ On /\ a =/= (/) ) -> E. y `
       ` e. a ( a i^i y ) = (/) ) `
       <TR> <TD> qed:16:   <TD> ` |- _E Fr On `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 22-Jul-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    onfrALTVD $p |- _E Fr On $=
      ( va vy vx cv con0 wss c0 wne wa cin wceq wrex wal cep wfr idn1 simpr e1_
      wi in2an wcel wex wb wn exmid onfrALTlem1VD onfrALTlem2VD pm2.61 a1i e022
      wo in2 gen11 19.23v biimpi n0 imbi1 biimprcd e10 pm2.27 e11 ax-gen dfepfr
      in1 biimpri e0_ ) ADZEFZVGGHZIZVGBDJGKBVGLZSZAMZENOZVLAVJVKVJVIVIVKSZVKVJ
      VJVIVJPVHVIQRVJCDZVGUAZCUBZVKSZVIVRUCZVOVJVQVKSZCMZVSVJWACVJVQVKVGVPJGKZW
      CUDZUKZVJVQWCVKSZWDVKSZVKWCUEVJVQWCVKCBAUFTVJVQWDVKCBAUGTWFWGVKSSWEWCVKUH
      UIUJULUMWBVSVQVKCUNUORCVGUPVTVOVSVIVRVKUQURUSVIVKUTVAVDVBVNVMABEVCVEVF $.
  $}

  $( Virtual deduction proof of ~ csbeq2g .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ csbeq2g
     is ~ csbeq2gVD without virtual deductions and was automatically derived
     from ~ csbeq2gVD .
     <HTML> <TABLE>
     <TR> <TD> 1::       <TD> ` |- (. A e. V ->. A e. V  ). `
     <TR> <TD> 2:1:      <TD> ` |- (. A e. V ->. ( A. x B = C -> [. A / x ]. `
     ` B = C ) ). `
     <TR> <TD> 3:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. B = C <-> [_ A `
     ` / x ]_ B = [_ A / x ]_ C ) ). `
     <TR> <TD> 4:2,3:    <TD> ` |- (. A e. V ->. ( A. x B = C -> [_ A / x `
     ` ]_ B = [_ A / x ]_ C ) ). `
     <TR> <TD> qed:4:    <TD> ` |- ( A e. V -> ( A. x B = C -> [_ A / x ]_ `
     ` B = [_ A / x ]_ C ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  csbeq2gVD $p |- ( A e. V -> ( A. x B = C ->
                   [_ A / x ]_ B = [_ A / x ]_ C ) ) $=
    ( wcel wceq wal csb wi wsbc wb idn1 spsbc e1_ sbceqg imbi2 biimpcd e11 in1
    ) BEFZCDGZAHZABCIABDIGZJZUAUCUBABKZJZUFUDLZUEUAUAUGUAMZUBABENOUAUAUHUIABCDE
    POUHUGUEUFUDUCQRST $.

  ${
    $d A y $.  $d B y $.  $d V y $.  $d x y $.
    $( Virtual deduction proof of ~ csbsng .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ csbsng
       is ~ csbsngVD without virtual deductions and was automatically derived
       from ~ csbsngVD .
       <HTML> <TABLE>
       <TR> <TD> 1::           <TD> ` |- (. A e. V ->. A e. V ). `
       <TR> <TD> 2:1:          <TD> ` |- (. A e. V ->. ( [. A / x ]. y = B `
       ` <-> [_ A / x ]_ y = [_ A / x ]_ B ) ). `
       <TR> <TD> 3:1:          <TD> ` |- (. A e. V ->. [_ A / x ]_ y = y ). `
       <TR> <TD> 4:3:          <TD> ` |- (. A e. V ->. ( [_ A / x ]_ y = [_ A `
       ` / x ]_ B <-> y = [_ A / x ]_ B ) ). `
       <TR> <TD> 5:2,4:        <TD> ` |- (. A e. V ->. ( [. A / x ]. y = B `
       ` <-> y = [_ A / x ]_ B ) ). `
       <TR> <TD> 6:5:          <TD> ` |- (. A e. V ->. A. y ( [. A / x ]. y `
       ` = B <-> y = [_ A / x ]_ B ) ). `
       <TR> <TD> 7:6:          <TD> ` |- (. A e. V ->. { y | [. A / x ]. y = `
       ` B } = { y | y = [_ A / x ]_ B } ). `
       <TR> <TD> 8:1:          <TD> ` |- (. A e. V ->. { y | [. A / x ]. y = `
       ` B } = [_ A / x ]_ { y |  y = B } ). `
       <TR> <TD> 9:7,8:        <TD> ` |- (. A e. V ->. [_ A / x ]_ { y |  y `
       ` = B } = { y | y = [_ A / x ]_ B } ). `
       <TR> <TD> 10::          <TD> ` |- { B } = { y |  y = B } `
       <TR> <TD> 11:10:        <TD> ` |- A. x { B } = { y |  y = B } `
       <TR> <TD> 12:1,11:      <TD> ` |- (. A e. V ->. [_ A / x ]_ { B } = [_ `
       ` A / x ]_ { y |  y = B } ). `
       <TR> <TD> 13:9,12:      <TD> ` |- (. A e. V ->. [_ A / x ]_ { B } = { `
       ` y | y = [_ A / x ]_ B } ). `
       <TR> <TD> 14::          <TD> ` |- { [_ A / x ]_  B } = { y |  y = [_ A `
       ` / x ]_ B } `
       <TR> <TD> 15:13,14:     <TD> ` |- (. A e. V ->. [_ A / x ]_ { B } = { `
       ` [_ A / x ]_ B } ). `
       <TR> <TD> qed:15:       <TD> ` |- ( A e. V -> [_ A / x ]_ { B } = { [_ `
       ` A / x ]_ B } ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    csbsngVD $p |- ( A e. V -> [_ A / x ]_ { B } = { [_ A / x ]_ B } ) $=
      ( vy wcel csn csb wceq cv cab wsbc wb wal e1_ eqeq1 e11 df-sn e10 eqeq2
      idn1 sbceqg csbconstg bibi1 biimprd gen11 biimpi csbabgOLD eqcomd biimpcd
      abbi ax-gen csbeq2g biimpd biimprcd in1 ) BDFZABCGZHZABCHZGZIZUQUSEJZUTIZ
      EKZIZVAVEIZVBUQABVCCIZEKZHZVEIZUSVJIZVFUQVHABLZEKZVEIZVNVJIZVKUQVMVDMZENZ
      VOUQVQEUQVMABVCHZUTIZMZVTVDMZVQUQUQWAUQUAZABVCCDUBOUQVSVCIZWBUQUQWDWCABVC
      DUCOVSVCUTPOWAVQWBVMVTVDUDUEQUFVRVOVMVDEUKUGOUQUQVPWCUQVJVNVHAEBDUHUIOVPV
      OVKVNVJVEPUJQUQUQURVIIZANVLWCWEAECRULABURVIDUMSVKVLVFVJVEUSTUNQEUTRVGVBVF
      VAVEUSTUOSUP $.
  $}

  ${
    $d A w y z $.  $d B w y z $.  $d C w y z $.  $d V w y z $.  $d w x y z $.
    $( Virtual deduction proof of ~ csbxpgOLD .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       csbxpgOLD
       is ~ csbxpgVD without virtual deductions and was automatically derived
       from ~ csbxpgVD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- (. A e. V ->. A e. V ). `
       <TR> <TD> 2:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. w e. B <-> `
       ` [_ A / x ]_ w e. [_ A / x ]_ B ) ). `
       <TR> <TD> 3:1:      <TD> ` |- (. A e. V ->. [_ A / x ]_ w = w ). `
       <TR> <TD> 4:3:      <TD> ` |- (. A e. V ->. ( [_ A / x ]_ w e. [_ A / `
       ` x ]_ B <-> w e. [_ A / x ]_ B ) ). `
       <TR> <TD> 5:2,4:    <TD> ` |- (. A e. V ->. ( [. A / x ]. w e. B <-> w `
       ` e. [_ A / x ]_ B ) ). `
       <TR> <TD> 6:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. y e. C <-> `
       ` [_ A / x ]_ y e. [_ A / x ]_ C ) ). `
       <TR> <TD> 7:1:      <TD> ` |- (. A e. V ->. [_ A / x ]_ y = y ). `
       <TR> <TD> 8:7:      <TD> ` |- (. A e. V ->. ( [_ A / x ]_ y e. [_ A / `
       ` x ]_ C <-> y e. [_ A / x ]_ C ) ). `
       <TR> <TD> 9:6,8:    <TD> ` |- (. A e. V ->. ( [. A / x ]. y e. C <-> y `
       ` e. [_ A / x ]_ C ) ). `
       <TR> <TD> 10:5,9:   <TD> ` |- (. A e. V ->. ( ( [. A / x ]. w e. B /\ `
       ` [. A / x ]. y e. C ) <-> ( w e. [_ A / x ]_ B /\ `
       ` y e. [_ A / x ]_ C ) ) ). `
       <TR> <TD> 11:1:     <TD> ` |- (. A e. V ->. ( [. A / x ]. ( w e. B /\ `
       ` y e. C ) <-> ( [. A / x ]. w e. B /\ [. A / x ]. y e. C ) ) ). `
       <TR> <TD> 12:10,11: <TD> ` |- (. A e. V ->. ( [. A / x ]. ( w e. B /\ `
       ` y e. C ) <-> ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ). `
       <TR> <TD> 13:1:     <TD> ` |- (. A e. V ->. ( [. A / x ]. z = <. w ,. `
       ` y >. <-> z = <. w , y >. ) ). `
       <TR> <TD> 14:12,13: <TD> ` |- (. A e. V ->. ( ( [. A / x ]. z = <. w `
       ` ,. y >. /\ [. A / x ]. ( w e. B /\ y e. C ) ) <-> ( z = <. w , y >. `
       ` /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 15:1:     <TD> ` |- (. A e. V ->. ( [. A / x ]. ( z = <. w `
       ` ,. y >. /\ ( w e. B /\ y e. C ) ) <-> ( [. A / x ]. z = <. w , y >. `
       ` /\ [. A / x ]. ( w e. B /\ y e. C ) ) ) ). `
       <TR> <TD> 16:14,15: <TD> ` |- (. A e. V ->. ( [. A / x ]. ( z = <. w `
       ` ,. y >. /\ ( w e. B /\ y e. C ) ) <-> ( z = <. w , y >. /\ `
       ` ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 17:16:    <TD> ` |- (. A e. V ->. A. y ( [. A / x ]. ( z = `
       ` <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> ( z = <. w , y >. /\ `
       ` ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 18:17:    <TD> ` |- (. A e. V ->. ( E. y [. A / x ]. ( z = `
       ` <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. y ( z = <. w , y >. /\ `
       ` ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 19:1:     <TD> ` |- (. A e. V ->. ( [. A / x ]. E. y ( z = `
       ` <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. y [. A / x ]. ( z = `
       ` <. w , y >. /\ ( w e. B /\ y e. C ) ) ) ). `
       <TR> <TD> 20:18,19: <TD> ` |- (. A e. V ->. ( [. A / x ]. E. y ( z = `
       ` <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. y ( z = <. w , y >. /\ `
       ` ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 21:20:    <TD> ` |- (. A e. V ->. A. w ( [. A / x ]. E. y ( `
       ` z = <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. y ( z = `
       ` <. w , y >. /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 22:21:    <TD> ` |- (. A e. V ->. ( E. w [. A / x ]. E. y ( `
       ` z = <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. w E. y ( z = `
       ` <. w , y >. /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 23:1:     <TD> ` |- (. A e. V ->. ( [. A / x ]. E. w E. y ( `
       ` z = <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. w [. A / x ]. E. y `
       ` ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) ) ). `
       <TR> <TD> 24:22,23: <TD> ` |- (. A e. V ->. ( [. A / x ]. E. w E. y ( `
       ` z = <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. w E. y ( z = `
       ` <. w , y >. /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 25:24:    <TD> ` |- (. A e. V ->. A. z ( [. A / x ]. E. w E. `
       ` y ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) <-> E. w E. y ( z = `
       ` <. w , y >. /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) ) ). `
       <TR> <TD> 26:25:    <TD> ` |- (. A e. V ->. { z | [. A / x ]. E. w E. `
       ` y ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) } = { z | E. w E. y ( `
       ` z = <. w , y >. /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) } `
       ` ). `
       <TR> <TD> 27:1:     <TD> ` |- (. A e. V ->. [_ A / x ]_ { z |  E. w E. `
       ` y ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) } = { z | [. A / x ]. `
       ` E. w E. y ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) } ). `
       <TR> <TD> 28:26,27: <TD> ` |- (. A e. V ->. [_ A / x ]_ { z |  E. w E. `
       ` y ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) } = { z | E. w E. y ( `
       ` z = <. w , y >. /\ ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) } `
       ` ). `
       <TR> <TD> 29::      <TD> ` |- { <. w ,. y >. | ( w e. B /\ y e. C ) } `
       ` = { z |  E. w E. y ( z = <. w , y >. /\ ( w e. B /\ y e. C ) ) } `
       <TR> <TD> 30::      <TD> ` |- ( B X. C ) = { <. w ,. y >. | ( w e. B `
       ` /\ y e. C ) } `
       <TR> <TD> 31:29,30: <TD> ` |- ( B X. C ) = { z |  E. w E. y ( z = <. w `
       ` , y >. /\ ( w e. B /\ y e. C ) ) } `
       <TR> <TD> 32:31:    <TD> ` |- A. x ( B X. C ) = { z |  E. w E. y ( z = `
       ` <. w , y >. /\ ( w e. B /\ y e. C ) ) } `
       <TR> <TD> 33:1,32:  <TD> ` |- (. A e. V ->.  [_ A / x ]_ ( B X. C ) = `
       ` [_ A / x ]_ { z |  E. w E. y ( z = <. w , y >. /\ ( w e. B /\ `
       ` y e. C ) ) } ). `
       <TR> <TD> 34:28,33: <TD> ` |- (. A e. V ->.  [_ A / x ]_ ( B X. C ) = `
       ` { z | E. w E. y ( z = <. w , y >. /\ ( w e. [_ A / x ]_ B /\ `
       ` y e. [_ A / x ]_ C ) ) } ). `
       <TR> <TD> 35::      <TD> ` |- { <. w ,. y >. | ( w e. [_ A / x ]_ B /\ `
       ` y e. [_ A / x ]_ C ) } = { z | E. w E. y ( z = <. w , y >. /\ `
       ` ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) ) } `
       <TR> <TD> 36::      <TD> ` |- ( [_ A / x ]_ B X. [_ A / x ]_ C ) = { `
       ` <. w , y >. | ( w e. [_ A / x ]_ B /\ y e. [_ A / x ]_ C ) } `
       <TR> <TD> 37:35,36: <TD> ` |- ( [_ A / x ]_ B X. [_ A / x ]_ C ) = { z `
       ` | E. w E. y ( z = <. w , y >. /\ ( w e. [_ A / x ]_ B /\ `
       ` y e. [_ A / x ]_ C ) ) } `
       <TR> <TD> 38:34,37: <TD> ` |- (. A e. V ->.  [_ A / x ]_ ( B X. C ) = `
       ` ( [_ A / x ]_ B X. [_ A / x ]_ C ) ). `
       <TR> <TD> qed:38:   <TD> ` |- ( A e. V ->  [_ A / x ]_ ( B X. C ) = ( `
       ` [_ A / x ]_ B X. [_ A / x ]_ C ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    csbxpgVD $p |- ( A e. V -> [_ A / x ]_ ( B X. C ) =
                ( [_ A / x ]_ B X. [_ A / x ]_ C ) ) $=
      ( vz vw vy wcel csb wceq wa wex wsbc wb wal e1_ bibi1 e11 biimprcd cxp cv
      cop cab idn1 sbcel12gOLD csbconstg eleq1 biimprd pm4.38 ex sbcangOLD sbcg
      expcom gen11 exbi sbcexgOLD abbi biimpi csbabgOLD eqeq2 copab df-xp eqtri
      biimpd df-opab ax-gen csbeq2g e10 in1 ) BEIZABCDUAZJZABCJZABDJZUAZKZVKVMF
      UBGUBZHUBZUCKZVRVNIZVSVOIZLZLZHMZGMZFUDZKZVPWGKZVQVKABVTVRCIZVSDIZLZLZHMZ
      GMZFUDZJZWGKZVMWQKZWHVKWOABNZFUDZWGKZWQXAKZWRVKWTWFOZFPZXBVKXDFVKWNABNZGM
      ZWFOZWTXGOZXDVKXFWEOZGPXHVKXJGVKWMABNZHMZWEOZXFXLOZXJVKXKWDOZHPXMVKXOHVKV
      TABNZWLABNZLZWDOZXKXROZXOVKXQWCOZXPVTOZXSVKWJABNZWKABNZLZWCOZXQYEOZYAVKYC
      WAOZYDWBOZYFVKYCABVRJZVNIZOZYKWAOZYHVKVKYLVKUEZABVRCEUFQVKYJVRKZYMVKVKYOY
      NABVREUGQYJVRVNUHQYLYHYMYCYKWARUISVKYDABVSJZVOIZOZYQWBOZYIVKVKYRYNABVSDEU
      FQVKYPVSKZYSVKVKYTYNABVSEUGQYPVSVOUHQYRYIYSYDYQWBRUISYHYIYFYCYDWAWBUJUKSV
      KVKYGYNWJWKABEULQYGYAYFXQYEWCRTSVKVKYBYNVTABEUMQYBYAXSXPXQVTWCUJUNSVKVKXT
      YNVTWLABEULQXTXOXSXKXRWDRTSUOXKWDHUPQVKVKXNYNWMHABEUQQXNXJXMXFXLWERTSUOXF
      WEGUPQVKVKXIYNWNGABEUQQXIXDXHWTXGWFRTSUOXEXBWTWFFURUSQVKVKXCYNWOAFBEUTQXB
      XCWRXAWGWQVAVESVKVKVLWPKZAPWSYNUUAAVLWLGHVBWPGHCDVCWLGHFVFVDVGABVLWPEVHVI
      WRWSWHWQWGVMVAVESVPWCGHVBWGGHVNVOVCWCGHFVFVDWIVQWHVPWGVMVATVIVJ $.
  $}

  $( Virtual deduction proof of ~ csbresgOLD .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ csbresgOLD
     is ~ csbresgVD without virtual deductions and was automatically derived
     from ~ csbresgVD .
     <HTML> <TABLE>
     <TR> <TD> 1::       <TD> ` |- (. A e. V ->. A e. V ). `
     <TR> <TD> 2:1:      <TD> ` |- (. A e. V ->. [_ A / x ]_  _V = _V ). `
     <TR> <TD> 3:2:      <TD> ` |- (. A e. V ->. ( [_ A / x ]_ C X. [_ A / `
     ` x ]_  _V ) = ( [_ A / x ]_ C X. _V ) ). `
     <TR> <TD> 4:1:      <TD> ` |- (. A e. V ->. [_ A / x ]_ ( C X. _V ) = `
     ` ( [_ A / x ]_ C X. [_ A / x ]_  _V ) ). `
     <TR> <TD> 5:3,4:    <TD> ` |- (. A e. V ->. [_ A / x ]_ ( C X. _V ) = `
     ` ( [_ A / x ]_ C X. _V ) ). `
     <TR> <TD> 6:5:      <TD> ` |- (. A e. V ->. ( [_ A / x ]_ B i^i [_ A / `
     ` x ]_ ( C X. _V ) ) = `
     ` ( [_ A / x ]_ B i^i ( [_ A / x ]_ C X. _V ) ) ). `
     <TR> <TD> 7:1:      <TD> ` |- (. A e. V ->. [_ A / x ]_ ( B i^i ( C X. `
     ` _V ) ) = ( [_ A / x ]_ B i^i [_ A / x ]_ ( C X. _V ) ) ). `
     <TR> <TD> 8:6,7:    <TD> ` |- (. A e. V ->. [_ A / x ]_ ( B i^i ( C X. `
     ` _V ) ) = ( [_ A / x ]_ B i^i ( [_ A / x ]_ C X. _V ) ) ). `
     <TR> <TD> 9::       <TD> ` |- ( B |`` C ) = ( B i^i ( C X. _V ) ) `
     <TR> <TD> 10:9:     <TD> ` |- A. x ( B |`` C ) = ( B i^i ( C X. _V ) ) `
     <TR> <TD> 11:1,10:  <TD> ` |- (. A e. V ->. [_ A / x ]_ ( B |`` C ) = `
     ` [_ A / x ]_ ( B i^i ( C X. _V ) ) ). `
     <TR> <TD> 12:8,11:  <TD> ` |- (. A e. V ->. [_ A / x ]_ ( B |`` C ) `
     ` = ( `
     ` [_ A / x ]_ B i^i ( [_ A / x ]_ C X. _V ) ) ). `
     <TR> <TD> 13::      <TD> ` |- ( [_ A / x ]_ B |`` [_ A / x ]_ C ) = ( `
     ` [_ A / x ]_ B i^i ( [_ A / x ]_ C X. _V ) ) `
     <TR> <TD> 14:12,13: <TD> ` |- (. A e. V ->. [_ A / x ]_ ( B |`` C ) = `
     ` ( `
     ` [_ A / x ]_ B |`` [_ A / x ]_ C ) ). `
     <TR> <TD> qed:14:   <TD> ` |- ( A e. V -> [_ A / x ]_ ( B |`` C ) = ( `
     ` [_ A / x ]_ B |`` [_ A / x ]_ C ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  csbresgVD $p |- ( A e. V -> [_ A / x ]_ ( B |` C ) =
                 ( [_ A / x ]_ B |` [_ A / x ]_ C ) ) $=
    ( wcel cres csb wceq cvv cxp cin idn1 csbconstg e1_ eqeq2 biimpd e11 df-res
    e10 xpeq2 csbxpgOLD ineq2 csbingOLD wal ax-gen csbeq2g biimprcd in1 ) BEFZA
    BCDGZHZABCHZABDHZGZIZUJULUMUNJKZLZIZUOURIZUPUJABCDJKZLZHZURIZULVCIZUSUJUMAB
    VAHZLZURIZVCVGIZVDUJVFUQIZVHUJUNABJHZKZUQIZVFVLIZVJUJVKJIZVMUJUJVOUJMZABJEN
    OVKJUNUAOUJUJVNVPABDJEUBOVMVNVJVLUQVFPQRVFUQUMUCOUJUJVIVPABECVAUDOVHVIVDVGU
    RVCPQRUJUJUKVBIZAUEVEVPVQACDSUFABUKVBEUGTVDVEUSVCURULPQRUMUNSUTUPUSUOURULPU
    HTUI $.

  ${
    $d A w y $.  $d B w y $.  $d V w y $.  $d x w y $.
    $( Virtual deduction proof of ~ csbrngOLD .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       csbrngOLD
       is ~ csbrngVD without virtual deductions and was automatically derived
       from ~ csbrngVD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- (. A e. V ->. A e. V ). `
       <TR> <TD> 2:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. <. w ,. y >. `
       ` e. B <-> [_ A / x ]_ <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 3:1:      <TD> ` |- (. A e. V ->. [_ A / x ]_ <. w ,. y >. = `
       ` <. w , y >. ). `
       <TR> <TD> 4:3:      <TD> ` |- (. A e. V ->. ( [_ A / x ]_ <. w ,. y >. `
       ` e. [_ A / x ]_ B <->  <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 5:2,4:    <TD> ` |- (. A e. V ->. ( [. A / x ]. <. w ,. y >. `
       ` e. B <-> <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 6:5:      <TD> ` |- (. A e. V ->. A. w ( [. A / x ]. <. w ,. `
       ` y >. e. B <-> <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 7:6:      <TD> ` |- (. A e. V ->. ( E. w [. A / x ]. <. w ,. `
       ` y >. e. B <-> E. w <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 8:1:      <TD> ` |- (. A e. V ->. ( E. w [. A / x ]. <. w ,. `
       ` y >. e. B <-> [. A / x ]. E. w  <. w , y >. e. B ) ). `
       <TR> <TD> 9:7,8:    <TD> ` |- (. A e. V ->. ( [. A / x ]. E. w  <. w `
       ` ,. y >. e. B <-> E. w <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 10:9:     <TD> ` |- (. A e. V ->. A. y ( [. A / x ]. E. w `
       `  <. w , y >. e. B <-> E. w <. w , y >. e. [_ A / x ]_ B ) ). `
       <TR> <TD> 11:10:    <TD> ` |- (. A e. V ->. { y | [. A / x ]. E. w  <. `
       ` w , y >. e. B } = { y | E. w <. w , y >. e. [_ A / x ]_ B } ). `
       <TR> <TD> 12:1:     <TD> ` |- (. A e. V ->. [_ A / x ]_ { y |  E. w `
       ` <. w , y >. e. B } = { y | [. A / x ]. E. w  <. w , y >. e. B } ). `
       <TR> <TD> 13:11,12: <TD> ` |- (. A e. V ->. [_ A / x ]_ { y |  E. w `
       ` <. w , y >. e. B } = { y | E. w <. w , y >. e. [_ A / x ]_ B } ). `
       <TR> <TD> 14::      <TD> ` |- ran B = { y |  E. w  <. w ,. y >. e. B } `
       <TR> <TD> 15:14:    <TD> ` |- A. x ran B = { y |  E. w  <. w ,. y >. `
       ` e. B } `
       <TR> <TD> 16:1,15:  <TD> ` |- (. A e. V ->. [_ A / x ]_ ran B = [_ A / `
       ` x ]_ { y |  E. w  <. w , y >. e. B } ). `
       <TR> <TD> 17:13,16: <TD> ` |- (. A e. V ->. [_ A / x ]_ ran B = { y | `
       ` E. w <. w , y >. e. [_ A / x ]_ B } ). `
       <TR> <TD> 18::      <TD> ` |-  ran [_ A / x ]_ B = { y |  E. w  <. w `
       ` ,. y >. e. [_ A / x ]_ B } `
       <TR> <TD> 19:17,18: <TD> ` |- (. A e. V ->. [_ A / x ]_ ran B = ran [_ `
       ` A / x ]_ B ). `
       <TR> <TD> qed:19:   <TD> ` |- ( A e. V -> [_ A / x ]_ ran B = ran [_ A `
       ` / x ]_ B ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    csbrngVD $p |- ( A e. V -> [_ A / x ]_ ran B = ran [_ A / x ]_ B ) $=
      ( vw vy wcel crn csb wceq cv wex cab wsbc wb wal e1_ e11 gen11 eqeq2 idn1
      cop sbcel12gOLD csbconstg eleq1 bibi1 biimprd exbi sbcexgOLD bicomd bitr3
      com12 abbi biimpi csbabgOLD biimpd dfrn3 ax-gen csbeq2g e10 biimprcd in1
      ) BDGZABCHZIZABCIZHZJZVCVEEKFKUBZVFGZELZFMZJZVGVLJZVHVCABVICGZELZFMZIZVLJ
      ZVEVRJZVMVCVPABNZFMZVLJZVRWBJZVSVCWAVKOZFPZWCVCWEFVCVOABNZELZVKOZWHWAOZWE
      VCWGVJOZEPWIVCWKEVCWGABVIIZVFGZOZWMVJOZWKVCVCWNVCUAZABVICDUCQVCWLVIJZWOVC
      VCWQWPABVIDUDQWLVIVFUEQWNWKWOWGWMVJUFUGRSWGVJEUHQVCVCWJWPVCWAWHVOEABDUIUJ
      QWJWIWEWHWAVKUKULRSWFWCWAVKFUMUNQVCVCWDWPVPAFBDUOQWCWDVSWBVLVRTUPRVCVCVDV
      QJZAPVTWPWRAEFCUQURABVDVQDUSUTVSVTVMVRVLVETUPREFVFUQVNVHVMVGVLVETVAUTVB
      $.
  $}

  $( Virtual deduction proof of ~ csbima12gALTOLD .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.
     ~ csbima12gALTOLD is ~ csbima12gALTVD without virtual deductions and was
     automatically derived from ~ csbima12gALTVD .
     <HTML> <TABLE>
     <TR> <TD> 1::       <TD> ` |- (. A e. C ->. A e. C ). `
     <TR> <TD> 2:1:      <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F |`` B ) = `
     ` ( `
     ` [_ A / x ]_ F |`` [_ A / x ]_ B ) ). `
     <TR> <TD> 3:2:      <TD> ` |- (. A e. C ->. `
     ` ran [_ A / x ]_ ( F |`` B ) `
     ` = ran ( [_ A / x ]_ F |`` [_ A / x ]_ B ) ). `
     <TR> <TD> 4:1:      <TD> ` |- (. A e. C ->. `
     ` [_ A / x ]_ ran ( F |`` B ) `
     ` = ran [_ A / x ]_ ( F |`` B ) ). `
     <TR> <TD> 5:3,4:    <TD> ` |- (. A e. C ->. `
     ` [_ A / x ]_ ran ( F |`` B ) `
     ` = ran ( [_ A / x ]_ F |`` [_ A / x ]_ B ) ). `
     <TR> <TD> 6::       <TD> ` |- ( F " B ) = ran ( F |`` B ) `
     <TR> <TD> 7:6:      <TD> ` |- A. x ( F " B ) = ran ( F |`` B ) `
     <TR> <TD> 8:1,7:    <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F " B ) = [_ `
     ` A / x ]_ ran ( F |`` B ) ). `
     <TR> <TD> 9:5,8:    <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F " B ) = `
     ` ran ( [_ A / x ]_ F |`` [_ A / x ]_ B ) ). `
     <TR> <TD> 10::      <TD> ` |- ( [_ A / x ]_ F " [_ A / x ]_ B ) = ran `
     ` ( [_ A / x ]_ F |`` [_ A / x ]_ B ) `
     <TR> <TD> 11:9,10:  <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F " B ) = ( `
     ` [_ A / x ]_ F " [_ A / x ]_ B ) ). `
     <TR> <TD> qed:11:   <TD> ` |- ( A e. C -> [_ A / x ]_ ( F " B ) = ( [_ `
     ` A / x ]_ F " [_ A / x ]_ B ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  csbima12gALTVD $p |- ( A e. C -> [_ A / x ]_ ( F " B ) =
                 ( [_ A / x ]_ F " [_ A / x ]_ B ) ) $=
    ( wcel cima csb wceq cres crn idn1 csbresgOLD e1_ rneq eqeq2 biimpd e11 e10
    df-ima csbrngOLD wal ax-gen csbeq2g biimprcd in1 ) BDFZABECGZHZABEHZABCHZGZ
    IZUGUIUJUKJZKZIZULUOIZUMUGABECJZKZHZUOIZUIUTIZUPUGABURHZKZUOIZUTVDIZVAUGVCU
    NIZVEUGUGVGUGLZABECDMNVCUNONUGUGVFVHABURDUANVEVFVAVDUOUTPQRUGUGUHUSIZAUBVBV
    HVIAECTUCABUHUSDUDSVAVBUPUTUOUIPQRUJUKTUQUMUPULUOUIPUESUF $.

  ${
    $d A y z $.  $d B y z $.  $d V y z $.  $d x y z $.
    $( Virtual deduction proof of ~ csbunigOLD .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       csbunigOLD
       is ~ csbunigVD without virtual deductions and was automatically derived
       from ~ csbunigVD .
       <HTML> <TABLE>
       <TR> <TD> 1::       <TD> ` |- (. A e. V ->. A e. V ). `
       <TR> <TD> 2:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. z e. y <-> z `
       ` e. y ) ). `
       <TR> <TD> 3:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. y e. B <-> y `
       ` e. [_ A / x ]_ B ) ). `
       <TR> <TD> 4:2,3:    <TD> ` |- (. A e. V ->. ( ( [. A / x ]. z e. y /\`
       ` [. A / x ]. y e. B ) <-> ( z e. y /\ y e. [_ A / x ]_ B ) ) ). `
       <TR> <TD> 5:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. ( z e. y /\`
       ` y e. B ) <-> ( [. A / x ]. z e. y /\ [. A / x ]. y e. B ) ) ). `
       <TR> <TD> 6:4,5:    <TD> ` |- (. A e. V ->. ( [. A / x ]. ( z e. y /\`
       ` y e. B ) <-> ( z e. y /\ y e. [_ A / x ]_ B ) ) ). `
       <TR> <TD> 7:6:      <TD> ` |- (. A e. V ->. A. y ( [. A / x ]. ( z e.`
       ` y /\ y e. B ) <-> ( z e. y /\ y e. [_ A / x ]_ B ) ) ). `
       <TR> <TD> 8:7:      <TD> ` |- (. A e. V ->. ( E. y [. A / x ]. ( z e.`
       ` y /\ y e. B ) <-> E. y ( z e. y /\ y e. [_ A / x ]_ B ) ) ). `
       <TR> <TD> 9:1:      <TD> ` |- (. A e. V ->. ( [. A / x ]. E. y ( z e.`
       ` y /\ y e. B ) <-> E. y [. A / x ]. ( z e. y /\ y e. B ) ) ). `
       <TR> <TD> 10:8,9:   <TD> ` |- (. A e. V ->. ( [. A / x ]. E. y ( z e.`
       ` y /\ y e. B ) <-> E. y ( z e. y /\ y e. [_ A / x ]_ B ) ) ). `
       <TR> <TD> 11:10:    <TD> ` |- (. A e. V ->. A. z ( [. A / x ]. E. y (`
       ` z e. y /\ y e. B ) <-> E. y ( z e. y /\ y e. [_ A / x ]_ B ) ) ). `
       <TR> <TD> 12:11:    <TD> ` |- (. A e. V ->. { z | [. A / x ]. E. y (`
       ` z e. y /\ y e. B ) } = { z | E. y ( z e. y /\ `
       ` y e. [_ A / x ]_ B ) } ). `
       <TR> <TD> 13:1:     <TD> ` |- (. A e. V ->. [_ A / x ]_ { z | E. y ( z `
       ` e. y /\ y e. B ) } = { z | [. A / x ]. E. y ( z e. y /\ y e. B ) }`
       ` ). `
       <TR> <TD> 14:12,13: <TD> ` |- (. A e. V ->. [_ A / x ]_ { z | E. y ( z `
       ` e. y /\ y e. B ) } = { z | E. y ( z e. y /\ `
       ` y e. [_ A / x ]_ B ) } ). `
       <TR> <TD> 15::      <TD> ` |- U. B = { z | E. y ( z e. y /\ y e. B ) } `
       <TR> <TD> 16:15:    <TD> ` |- A. x U. B = { z | E. y ( z e. y /\ y e. `
       ` B ) } `
       <TR> <TD> 17:1,16:  <TD> ` |- (. A e. V ->. [. A / x ]. U. B = { z |`
       ` E. y ( z e. y /\ y e. B ) } ). `
       <TR> <TD> 18:1,17:  <TD> ` |- (. A e. V ->. [_ A / x ]_ U. B = [_ A / `
       ` x ]_ { z | E. y ( z e. y /\ y e. B ) } ). `
       <TR> <TD> 19:14,18: <TD> ` |- (. A e. V ->. [_ A / x ]_ U. B = { z | `
       ` E. y ( z e. y /\ y e. [_ A / x ]_ B ) } ). `
       <TR> <TD> 20::      <TD> ` |- U. [_ A / x ]_ B = { z | E. y ( z e. y `
       ` /\ y e. [_ A / x ]_ B ) } `
       <TR> <TD> 21:19,20: <TD> ` |- (. A e. V ->. [_ A / x ]_ U. B = U. [_ A `
       ` / x ]_ B ). `
       <TR> <TD> qed:21:   <TD> ` |- ( A e. V -> [_ A / x ]_ U. B = U. [_ A / `
       ` x ]_ B ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    csbunigVD $p |- ( A e. V -> [_ A / x ]_ U. B = U. [_ A / x ]_ B ) $=
      ( vz vy wcel csb wceq wa wex cab wsbc wal e1_ e11 biimprcd eqeq2 biimpd
      wb cuni cv idn1 sbcg sbcel2gOLD pm4.38 ex sbcangOLD bibi1 gen11 sbcexgOLD
      exbi abbi biimpi csbabgOLD df-uni ax-gen spsbc e10 sbceqg in1 ) BDGZABCUA
      ZHZABCHZUAZIZVBVDEUBFUBZGZVHVEGZJZFKZELZIZVFVMIZVGVBABVIVHCGZJZFKZELZHZVM
      IZVDVTIZVNVBVRABMZELZVMIZVTWDIZWAVBWCVLTZENZWEVBWGEVBVQABMZFKZVLTZWCWJTZW
      GVBWIVKTZFNWKVBWMFVBVIABMZVPABMZJZVKTZWIWPTZWMVBWNVITZWOVJTZWQVBVBWSVBUCZ
      VIABDUDOVBVBWTXAABVHCDUEOWSWTWQWNWOVIVJUFUGPVBVBWRXAVIVPABDUHOWRWMWQWIWPV
      KUIQPUJWIVKFULOVBVBWLXAVQFABDUKOWLWGWKWCWJVLUIQPUJWHWEWCVLEUMUNOVBVBWFXAV
      RAEBDUOOWEWFWAWDVMVTRSPVBVBVCVSIZABMZWBXAVBVBXBANXCXAXBAEFCUPUQXBABDURUSV
      BXCWBABVCVSDUTSPWAWBVNVTVMVDRSPEFVEUPVOVGVNVFVMVDRQUSVA $.
  $}

  ${
    $d A y $.  $d F y $.  $d B y $.  $d C y $.  $d x y $.
    $( Virtual deduction proof of ~ csbfv12gALTOLD .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~
       csbfv12gALTOLD
       is ~ csbfv12gALTVD without virtual deductions and was automatically
       derived
       from ~ csbfv12gALTVD .
       <HTML> <TABLE>
       <TR> <TD> 1::           <TD> ` |- (. A e. C ->. A e. C ). `
       <TR> <TD> 2:1:          <TD> ` |- (. A e. C ->. [_ A / x ]_ { y } = { `
       ` y } ). `
       <TR> <TD> 3:1:          <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F " { B `
       ` } ) = ( [_ A / x ]_ F " [_ A / x ]_ { B } ) ). `
       <TR> <TD> 4:1:          <TD> ` |- (. A e. C ->. [_ A / x ]_ { B } = { `
       ` [_ A / x ]_ B } ). `
       <TR> <TD> 5:4:          <TD> ` |- (. A e. C ->. ( [_ A / x ]_ F " [_ A `
       ` / x ]_ { B } ) = ( [_ A / x ]_ F " { [_ A / x ]_ B } ) ). `
       <TR> <TD> 6:3,5:        <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F " { B `
       ` } ) = ( [_ A / x ]_ F " { [_ A / x ]_ B } ) ). `
       <TR> <TD> 7:1:          <TD> ` |- (. A e. C ->. ( [. A / x ]. ( F " { `
       ` B } ) = { y } <-> [_ A / x ]_ ( F " { B } ) = [_ A / x ]_ { y } ) ). `
       <TR> <TD> 8:6,2:        <TD> ` |- (. A e. C ->. ( [_ A / x ]_ ( F " { `
       ` B } ) = [_ A / x ]_ { y } <-> ( [_ A / x ]_ F " { [_ A / x ]_ B } ) `
       ` = { y } ) ). `
       <TR> <TD> 9:7,8:        <TD> ` |- (. A e. C ->. ( [. A / x ]. ( F " { `
       ` B } ) = { y } <-> ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = { y } ) `
       ` ). `
       <TR> <TD> 10:9:         <TD> ` |- (. A e. C ->. A. y ( [. A / x ]. ( F `
       ` " { B } ) = { y } <-> ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = `
       ` { y } ) ). `
       <TR> <TD> 11:10:        <TD> ` |- (. A e. C ->. { y | [. A / x ]. ( F `
       ` " { B } ) = { y } } = { y | ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = `
       ` { y } } ). `
       <TR> <TD> 12:1:         <TD> ` |- (. A e. C ->. [_ A / x ]_ { y | ( F `
       ` " { B } ) = { y } } = { y | [. A / x ]. ( F " { B } ) = { y } } ). `
       <TR> <TD> 13:11,12:     <TD> ` |- (. A e. C ->. [_ A / x ]_ { y | ( F `
       ` " { B } ) = { y } } = { y | ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = `
       ` { y `
       ` } } ). `
       <TR> <TD> 14:13:        <TD> ` |- (. A e. C ->. U. [_ A / x ]_ { y | ( `
       ` F " { B } ) = { y } } = U. { y | ( [_ A / x ]_ F " `
       ` { [_ A / x ]_ B } ) = `
       ` { y } } ). `
       <TR> <TD> 15:1:         <TD> ` |- (. A e. C ->. [_ A / x ]_ U. { y | ( `
       ` F " { B } ) = { y } } = U. [_ A / x ]_ { y | ( F " { B } ) = `
       ` { y } } ). `
       <TR> <TD> 16:14,15:     <TD> ` |- (. A e. C ->. [_ A / x ]_ U. { y | ( `
       ` F " { B } ) = { y } } = `
       ` U. { y | ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = `
       ` { y } } ). `
       <TR> <TD> 17::          <TD> ` |- ( F `` B ) = `
       ` U. { y | ( F " { B } ) = `
       ` { y } } `
       <TR> <TD> 18:17:        <TD> ` |- A. x ( F `` B ) = U. { y | ( F " { B `
       ` } ) = { y } } `
       <TR> <TD> 19:1,18:      <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F `` B ) `
       ` = [_ A / x ]_ U. { y | ( F " { B } ) = { y } } ). `
       <TR> <TD> 20:16,19:     <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F `` B ) `
       ` = U. { y | ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = { y } } ). `
       <TR> <TD> 21::          <TD> ` |- ( [_ A / x ]_ F `` [_ A / x ]_ B ) = `
       ` U. { y | ( [_ A / x ]_ F " { [_ A / x ]_ B } ) = { y } } `
       <TR> <TD> 22:20,21:     <TD> ` |- (. A e. C ->. [_ A / x ]_ ( F `` B ) `
       ` = ( [_ A / x ]_ F `` [_ A / x ]_ B ) ). `
       <TR> <TD> qed:22:       <TD> ` |- ( A e. C -> [_ A / x ]_ ( F `` B ) = `
       ` ( [_ A / x ]_ F `` [_ A / x ]_ B ) ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 10-Nov-2012.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    csbfv12gALTVD $p |- ( A e. C -> [_ A / x ]_ ( F ` B ) =
                ( [_ A / x ]_ F ` [_ A / x ]_ B ) ) $=
      ( vy cfv csb wceq csn cima cab cuni wb wal e1_ biimprd e11 eqeq2 biimpd
      wcel cv wsbc idn1 sbceqg csbima12gOLD csbsng imaeq2 eqeq1 csbconstg bibi1
      eqeq12 ex gen11 abbi biimpi csbabgOLD unieq csbunigOLD ax-gen csbeq2g e10
      dffv4 biimprcd in1 ) BDUAZABCEGZHZABCHZABEHZGZIZVFVHVJVIJZKZFUBJZIZFLZMZI
      ZVKVRIZVLVFABECJZKZVOIZFLZMZHZVRIZVHWFIZVSVFABWDHZMZVRIZWFWJIZWGVFWIVQIZW
      KVFWCABUCZFLZVQIZWIWOIZWMVFWNVPNZFOZWPVFWRFVFWNABWBHZABVOHZIZNZXBVPNZWRVF
      VFXCVFUDZABWBVODUEPVFWTVNIZXAVOIZXDVFWTVJABWAHZKZIZXIVNIZXFVFVFXJXEABWADE
      UFPVFXHVMIZXKVFVFXLXEABCDUGPXHVMVJUHPXJXFXKWTXIVNUIQRVFVFXGXEABVODUJPXFXG
      XDWTVNXAVOULUMRXCWRXDWNXBVPUKQRUNWSWPWNVPFUOUPPVFVFWQXEWCAFBDUQPWPWQWMWOV
      QWISTRWIVQURPVFVFWLXEABWDDUSPWKWLWGWJVRWFSTRVFVFVGWEIZAOWHXEXMAFCEVCUTABV
      GWEDVAVBWGWHVSWFVRVHSTRFVIVJVCVTVLVSVKVRVHSVDVBVE $.
  $}

  $( Virtual deduction proof of ~ con5 .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ con5
     is ~ con5VD without virtual deductions and was automatically derived
     from ~ con5VD .
     <HTML> <TABLE>
     <TR> <TD> 1::    <TD> ` |- (. ( ph <-> -. ps ) ->. ( ph <-> -. ps ) ). `
     <TR> <TD> 2:1:   <TD> ` |- (. ( ph <-> -. ps ) ->. ( -. ps -> ph ) ). `
     <TR> <TD> 3:2:   <TD> ` |- (. ( ph <-> -. ps ) ->. ( -. ph -> -. -. ps `
     ` ) ). `
     <TR> <TD> 4::    <TD> ` |- ( ps <-> -. -. ps ) `
     <TR> <TD> 5:3,4: <TD> ` |- (. ( ph <-> -. ps ) ->. ( -. ph -> ps ) ). `
     <TR> <TD> qed:5: <TD> ` |- ( ( ph <-> -. ps ) -> ( -. ph -> ps ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 21-Apr-2013.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  con5VD $p |- ( ( ph <-> -. ps ) -> ( -. ph -> ps ) ) $=
    ( wn wb wi idn1 bi2 e1_ con3 notnot imbi2 biimprcd e10 in1 ) ABCZDZACZBEZPQ
    OCZEZBSDZRPOAEZTPPUBPFAOGHOAIHBJUARTBSQKLMN $.

  ${
    $d ph z $.  $d u v x z $.  $d u v y z $.
    $( Virtual deduction proof of ~ relopab .
       The following User's Proof is a Virtual Deduction proof completed
       automatically by the tools program completeusersproof.cmd, which invokes
       Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ relopab
       is ~ relopabVD without virtual deductions and was automatically derived
       from ~ relopabVD .
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- (. y = v ->. y = v ). `
       <TR> <TD> 2:1:         <TD> ` |- (. y = v ->. <. x ,. y >. = <. x ,. v `
       ` >. ). `
       <TR> <TD> 3::          <TD> ` |- (. y = v ,. x = u ->. x = u ). `
       <TR> <TD> 4:3:         <TD> ` |- (. y = v ,. x = u ->. <. x ,. v >. = <.
       `
       ` u , v >. ). `
       <TR> <TD> 5:2,4:       <TD> ` |- (. y = v ,. x = u ->. <. x ,. y >. = <.
       `
       ` u , v >. ). `
       <TR> <TD> 6:5:         <TD> ` |- (. y = v ,. x = u ->. ( z = <. x ,. y `
       ` >. -> z = <. u , v >. ) ). `
       <TR> <TD> 7:6:         <TD> ` |- (. y = v ->. ( x = u -> ( z = <. x ,. `
       ` y >. -> z = <. u , v >. ) ) ). `
       <TR> <TD> 8:7:         <TD> ` |- ( y = v -> ( x = u -> ( z = <. x ,. y `
       ` >. -> z = <. u , v >. ) ) ) `
       <TR> <TD> 9:8:         <TD> ` |- ( E. v y = v ->  E. v ( x = u -> ( z `
       ` = <. x , y >. -> z = <. u , v >. ) ) ) `
       <TR> <TD> 90::         <TD> ` |- ( v = y <-> y = v ) `
       <TR> <TD> 91:90:       <TD> ` |- ( E. v v = y <-> E. v y = v ) `
       <TR> <TD> 92::         <TD> ` |- E. v v = y `
       <TR> <TD> 10:91,92:    <TD> ` |- E. v y = v `
       <TR> <TD> 11:9,10:     <TD> ` |- E. v ( x = u -> ( z = <. x ,. y >. -> `
       ` z = <. u , v >. ) ) `
       <TR> <TD> 12:11:       <TD> ` |- ( x = u -> E. v ( z = <. x ,. y >. -> `
       ` z = <. u , v >. ) ) `
       <TR> <TD> 13::         <TD> ` |- ( E. v ( z = <. x ,. y >. -> z = <. u `
       ` , v >. ) -> ( z = <. x , y >. -> E. v z = <. u , v >. ) ) `
       <TR> <TD> 14:12,13:    <TD> ` |- ( x = u -> ( z = <. x ,. y >. -> E. v `
       ` z = <. u , v >. ) ) `
       <TR> <TD> 15:14:       <TD> ` |- ( E. u x = u -> E. u ( z = <. x ,. y `
       ` >. -> E. v z = <. u , v >. ) ) `
       <TR> <TD> 150::        <TD> ` |- ( u = x <-> x = u ) `
       <TR> <TD> 151:150:     <TD> ` |- ( E. u u = x <-> E. u x = u ) `
       <TR> <TD> 152::        <TD> ` |- E. u u = x `
       <TR> <TD> 16:151,152:  <TD> ` |- E. u x = u `
       <TR> <TD> 17:15,16:    <TD> ` |- E. u ( z = <. x ,. y >. -> E. v z = <.
       `
       ` u , v >. ) `
       <TR> <TD> 18:17:       <TD> ` |- ( z = <. x ,. y >. -> E. u E. v z = <.
       `
       ` u , v >. ) `
       <TR> <TD> 19:18:       <TD> ` |- ( E. y z = <. x ,. y >. -> E. y E. u `
       ` E. v z = <. u , v >. ) `
       <TR> <TD> 20::         <TD> ` |- ( E. y E. u E. v z = <. u ,. v >. -> `
       ` E. u E. v z = <. u , v >. ) `
       <TR> <TD> 21:19,20:    <TD> ` |- ( E. y z = <. x ,. y >. -> E. u E. v z
       `
       ` = <. u , v >. ) `
       <TR> <TD> 22:21:       <TD> ` |- ( E. x E. y z = <. x ,. y >. -> E. x `
       ` E. u E. v z = <. u , v >. ) `
       <TR> <TD> 23::         <TD> ` |- ( E. x E. u E. v z = <. u ,. v >. -> `
       ` E. u E. v z = <. u , v >. ) `
       <TR> <TD> 24:22,23:    <TD> ` |- ( E. x E. y z = <. x ,. y >. -> E. u `
       ` E. v z = <. u , v >. ) `
       <TR> <TD> 25:24:       <TD> ` |- { z | E. x E. y z = <. x ,. y >. } C_ `
       ` { z | E. u E. v z = <. u , v >. } `
       <TR> <TD> 26::         <TD> ` |- x e. _V `
       <TR> <TD> 27::         <TD> ` |- y e. _V `
       <TR> <TD> 28:26,27:    <TD> ` |- ( x e. _V /\ y e. _V ) `
       <TR> <TD> 29:28:       <TD> ` |- ( z = <. x ,. y >. <-> ( z = <. x ,. y
       `
       ` >. /\ ( x e. _V /\ y e. _V ) ) ) `
       <TR> <TD> 30:29:       <TD> ` |- ( E. y z = <. x ,. y >. <-> E. y ( z =
       `
       ` <. x , y >. /\ ( x e. _V /\ y e. _V ) ) ) `
       <TR> <TD> 31:30:       <TD> ` |- ( E. x E. y z = <. x ,. y >. <-> E. x `
       ` E. y ( z = <. x , y >. /\ ( x e. _V /\ y e. _V ) ) ) `
       <TR> <TD> 32:31:       <TD> ` |- { z | E. x E. y z = <. x ,. y >. } = {
       `
       ` z | E. x E. y ( z = <. x , y >. /\ ( x e. _V /\ y e. _V ) ) } `
       <TR> <TD> 320:25,32:   <TD> ` |- { z | E. x E. y ( z = <. x ,. y >. /\ `
       ` ( x e. _V /\ y e. _V ) ) } C_ { z | E. u E. v z = <. u , v >. } `
       <TR> <TD> 33::         <TD> ` |- u e. _V `
       <TR> <TD> 34::         <TD> ` |- v e. _V `
       <TR> <TD> 35:33,34:    <TD> ` |- ( u e. _V /\ v e. _V ) `
       <TR> <TD> 36:35:       <TD> ` |- ( z = <. u ,. v >. <-> ( z = <. u ,. v
       `
       ` >. /\ ( u e. _V /\ v e. _V ) ) ) `
       <TR> <TD> 37:36:       <TD> ` |- ( E. v z = <. u ,. v >. <-> E. v ( z =
       `
       ` <. u , v >. /\ ( u e. _V /\ v e. _V ) ) ) `
       <TR> <TD> 38:37:       <TD> ` |- ( E. u E. v z = <. u ,. v >. <-> E. u `
       ` E. v ( z = <. u , v >. /\ ( u e. _V /\ v e. _V ) ) ) `
       <TR> <TD> 39:38:       <TD> ` |- { z | E. u E. v z = <. u ,. v >. } = {
       `
       ` z | E. u E. v ( z = <. u , v >. /\ ( u e. _V /\ v e. _V ) ) } `
       <TR> <TD> 40:320,39:   <TD> ` |- { z | E. x E. y ( z = <. x ,. y >. /\ `
       ` ( x e. _V /\ y e. _V ) ) } C_ { z | E. u E. v ( z = <. u , v >. /\ `
       ` ( u e. _V /\ v e. _V ) ) } `
       <TR> <TD> 41::         <TD> ` |- { <. x ,. y >. | ( x e. _V /\ y e. _V `
       ` ) } = { z | E. x E. y ( z = <. x , y >. /\ ( x e. _V /\ y e. _V ) ) `
       ` } `
       <TR> <TD> 42::         <TD> ` |- { <. u ,. v >. | ( u e. _V /\ v e. _V `
       ` ) } = { z | E. u E. v ( z = <. u , v >. /\ ( u e. _V /\ v e. _V ) ) `
       ` } `
       <TR> <TD> 43:40,41,42: <TD> ` |- { <. x ,. y >. | ( x e. _V /\ y e. _V `
       ` ) } C_ { <. u , v >. | ( u e. _V /\ v e. _V ) } `
       <TR> <TD> 44::         <TD> ` |- { <. u ,. v >. | ( u e. _V /\ v e. _V `
       ` ) } = ( _V X. _V ) `
       <TR> <TD> 45:43,44:    <TD> ` |- { <. x ,. y >. | ( x e. _V /\ y e. _V `
       ` ) } C_ ( _V X. _V ) `
       <TR> <TD> 46:28:       <TD> ` |- ( ph -> ( x e. _V /\ y e. _V ) ) `
       <TR> <TD> 47:46:       <TD> ` |- { <. x ,. y >. | ph } C_ { <. x ,. y >.
       `
       ` | ( x e. _V /\ y e. _V ) } `
       <TR> <TD> 48:45,47:    <TD> ` |- { <. x ,. y >. | ph } C_ ( _V X. _V ) `
       <TR> <TD> qed:48:      <TD> ` |- Rel { <. x ,. y >. | ph } `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 9-Jul-2013.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    relopabVD $p |- Rel { <. x , y >. | ph } $=
      ( vu vv vz copab cvv cv wcel wa vex cop wceq wex cab exbii eximi biimpi
      wi cxp wss wrel pm3.2i ssopab2i biantru abbii a9ev equcom mpbi idn1 opeq2
      a1i e1_ idn2 opeq1 e2 eqeq1 biimprd e12 eqeq2 biimpd in2 in1 ax-mp 19.37v
      19.37aiv 19.9v ss2abi eqsstr3i sseqtri df-opab 3sstr4i df-xp eqcomi sstri
      syl df-rel biimpri e0_ ) ABCGZHHUAZUBZWAUCZWABIZHJZCIZHJZKZBCGZWBAWIBCWIA
      WFWHBLCLUDZUMUEWJDIZHJZEIZHJZKZDEGZWBFIZWEWGMZNZWIKZCOZBOZFPZWRWLWNMZNZWP
      KZEOZDOZFPZWJWQXDXFEOZDOZFPZXJXDWTCOZBOZFPXMXOXCFXNXBBWTXACWIWTWKUFQQUGXO
      XLFXOXLBOZXLXNXLBXNXLCOZXLWTXLCWTXKDWEWLNZDOZWTXKTZDOWLWENZDOXSDBUHYAXRDD
      BUIQUJXRXTDXRWTXFTZEOZXTXRYBEWGWNNZEOZXRYBTZEOWNWGNZEOYEECUHYGYDEECUIQUJY
      DYFEYDYFYDXRYBYDXRWSXENZYBYDWSWEWNMZNZXRYIXENZYHYDYDYJYDUKWGWNWEULUNYDXRX
      RYKYDXRUOWEWLWNUPUQYJYHYKWSYIXEURUSUTYHWTXFWSXEWRVAVBUQVCVDRVEVGYCXTWTXFE
      VFSVQRVEVGRXQXLXLCVHSVQRXPXLXLBVHSVQVIVJXLXIFXKXHDXFXGEWPXFWMWODLELUDUFQQ
      UGVKWIBCFVLWPDEFVLVMWBWQDEHHVNVOVKVPWDWCWAVRVSVT $.
  $}

  $( Virtual deduction proof of ~ 19.41rg .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ 19.41rg
     is ~ 19.41rgVD without virtual deductions and was automatically derived
     from ~ 19.41rgVD . (Contributed by Alan Sare, 8-Feb-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::       <TD> ` |- ( ps -> ( ph -> ( ph /\ ps ) ) ) `
     <TR> <TD> 2:1:      <TD> ` |- ( ( ps -> A. x ps ) -> ( ps -> ( ph -> ( `
     ` ph /\ ps ) ) ) ) `
     <TR> <TD> 3:2:      <TD> ` |- A. x ( ( ps -> A. x ps ) -> ( ps -> ( ph `
     ` -> ( ph /\ ps ) ) ) ) `
     <TR> <TD> 4:3:      <TD> ` |- ( A. x ( ps -> A. x ps ) -> ( A. x ps -> `
     ` A. x ( ph -> ( ph /\ ps ) ) ) ) `
     <TR> <TD> 5::       <TD> ` |- (. A. x ( ps -> A. x ps ) ->. A. x ( ps `
     ` -> A. x ps ) ). `
     <TR> <TD> 6:4,5:    <TD> ` |- (. A. x ( ps -> A. x ps ) ->. ( A. x ps `
     ` -> A. x ( ph -> ( ph /\ ps ) ) ) ). `
     <TR> <TD> 7::       <TD> ` |- (. A. x ( ps -> A. x ps ) ,. A. x ps ->. `
     ` A. x ps ). `
     <TR> <TD> 8:6,7:    <TD> ` |- (. A. x ( ps -> A. x ps ) ,. A. x ps ->. `
     ` A. x ( ph -> ( ph /\ ps ) ) ). `
     <TR> <TD> 9:8:      <TD> ` |- (. A. x ( ps -> A. x ps ) ,. A. x ps ->. `
     ` ( E. x ph -> E. x ( ph /\ ps ) ) ). `
     <TR> <TD> 10:9:     <TD> ` |- (. A. x ( ps -> A. x ps ) ->. ( A. x ps `
     ` -> ( E. x ph -> E. x ( ph /\ ps ) ) ) ). `
     <TR> <TD> 11:5:     <TD> ` |- (. A. x ( ps -> A. x ps ) ->. ( ps -> A. `
     ` x ps ) ). `
     <TR> <TD> 12:10,11: <TD> ` |- (. A. x ( ps -> A. x ps ) ->. ( ps -> ( `
     ` E. x ph -> E. x ( ph /\ ps ) ) ) ). `
     <TR> <TD> 13:12:    <TD> ` |- (. A. x ( ps -> A. x ps ) ->. ( E. x ph `
     ` -> ( ps -> E. x ( ph /\ ps ) ) ) ). `
     <TR> <TD> 14:13:    <TD> ` |- (. A. x ( ps -> A. x ps ) ->. ( ( E. x `
     ` ph /\ ps ) -> E. x ( ph /\ ps ) ) ). `
     <TR> <TD> qed:14:   <TD> ` |- ( A. x ( ps -> A. x ps ) -> ( ( E. x ph `
     ` /\ ps ) -> E. x ( ph /\ ps ) ) ) `
     </TABLE> </HTML> $)
  19.41rgVD $p |- ( A. x ( ps -> A. x ps ) -> ( ( E. x ph /\ ps ) ->
                  E. x ( ph /\ ps ) ) ) $=
    ( wal wi wex wa idn1 pm3.2 com12 a1i ax-gen 3ax5 e0_ e1_ idn2 id e12 exim
    e2 in2 sp imim2 e11 pm2.04 pm3.31 in1 ) BBCDZEZCDZACFZBGABGZCFZEZUJUKBUMEEZ
    UNUJBUKUMEZEZUOUJUHUPEUIUQUJUHUPUJUHAULEZCDZUPUJUHUSEZUHUHUSUJUJUTUJHZUIBUR
    EZEZCDUJUTEVCCVBUIABULABIJKLUIBURCMNOUJUHPUTQRAULCSTUAUJUJUIVAUICUBOUHUPBUC
    UDBUKUMUEOUKBUMUFOUG $.

  $( Virtual deduction proof of ~ 2pm13.193 .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant. ~ 2pm13.193
     is ~ 2pm13.193VD without virtual deductions and was automatically
     derived from ~ 2pm13.193VD . (Contributed by Alan Sare, 8-Feb-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::        <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ). `
     <TR> <TD> 2:1:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( x = u /\ y = v ) ). `
     <TR> <TD> 3:2:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. x = u ). `
     <TR> <TD> 4:1:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. [ u / x ] [ v / y ] ph ). `
     <TR> <TD> 5:3,4:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( [ u / x ] [ v / y ] ph /\ x = u ) ). `
     <TR> <TD> 6:5:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( [ v / y ] ph /\ x = u ) ). `
     <TR> <TD> 7:6:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. [ v / y ] ph ). `
     <TR> <TD> 8:2:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. y = v ). `
     <TR> <TD> 9:7,8:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( [ v / y ] ph /\ y = v ) ). `
     <TR> <TD> 10:9:      <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( ph /\ y = v ) ). `
     <TR> <TD> 11:10:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ph ). `
     <TR> <TD> 12:2,11:   <TD> ` |- (. ( ( x = u /\ y = v ) /\ [ u / x ] [ `
     ` v / y ] ph ) ->. ( ( x = u /\ y = v ) /\ ph ) ). `
     <TR> <TD> 13:12:     <TD> ` |- ( ( ( x = u /\ y = v ) /\ [ u / x ] [ v `
     ` / y ] ph ) -> ( ( x = u /\ y = v ) /\ ph ) ) `
     <TR> <TD> 14::       <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( ( `
     ` x = u /\ y = v ) /\ ph ) ). `
     <TR> <TD> 15:14:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( x `
     ` = u /\ y = v ) ). `
     <TR> <TD> 16:15:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. y = `
     ` v ). `
     <TR> <TD> 17:14:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ph `
     ` ). `
     <TR> <TD> 18:16,17:  <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( `
     ` ph /\ y = v ) ). `
     <TR> <TD> 19:18:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( [ `
     ` v / y ] ph /\ y = v ) ). `
     <TR> <TD> 20:15:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. x = `
     ` u ). `
     <TR> <TD> 21:19:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. [ v `
     ` / y ] ph ). `
     <TR> <TD> 22:20,21:  <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( [ `
     ` v / y ] ph /\ x = u ) ). `
     <TR> <TD> 23:22:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( [ `
     ` u / x ] [ v / y ] ph /\ x = u ) ). `
     <TR> <TD> 24:23:     <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. [ u `
     ` / x ] [ v / y ] ph ). `
     <TR> <TD> 25:15,24:  <TD> ` |- (. ( ( x = u /\ y = v ) /\ ph ) ->. ( ( `
     ` x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ). `
     <TR> <TD> 26:25:     <TD> ` |- ( ( ( x = u /\ y = v ) /\ ph ) -> ( ( x `
     ` = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ) `
     <TR> <TD> qed:13,26: <TD> ` |- ( ( ( x = u /\ y = v ) /\ [ u / x ] [ v `
     ` / y ] ph ) <-> ( ( x = u /\ y = v ) /\ ph ) ) `
     </TABLE> </HTML> $)
  2pm13.193VD $p |- ( ( ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) <->
                    ( ( x = u /\ y = v ) /\ ph ) ) $=
    ( cv wceq wa wsb idn1 simpl e1_ simpr pm3.21 sbequ2 imdistanri pm3.2 sbequ1
    e11 in1 impbii ) BFEFGZCFDFGZHZACDIZBEIZHZUDAHZUGUHUGUDAUHUGUGUDUGJZUDUFKLZ
    UGAUCHZAUGUEUCHZUKUGUEUCULUGUEUBHZUEUGUFUBHZUMUGUBUFUNUGUDUBUJUBUCKZLUGUGUF
    UIUDUFMLUBUFNSUBUFUEUEBEOPLUEUBKLUGUDUCUJUBUCMZLUEUCQSUCUEAACDOPLAUCKLUDAQS
    TUHUGUHUDUFUGUHUHUDUHJZUDAKLZUHUNUFUHUMUNUHUBUEUMUHUDUBURUOLUHULUEUHUKULUHU
    CAUKUHUDUCURUPLUHUHAUQUDAMLUCANSUCAUEACDRPLUEUCKLUBUENSUBUEUFUEBERPLUFUBKLU
    DUFQSTUA $.

  $( Virtual deduction proof of ~ hbimpg .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ hbimpg
     is ~ hbimpgVD without virtual deductions and was automatically derived
     from ~ hbimpgVD . (Contributed by Alan Sare, 8-Feb-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::       <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( A. x ( ph -> A. x ph ) /\ A. x ( ps -> `
     ` A. x ps ) ) ). `
     <TR> <TD> 2:1:      <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. A. x ( ph -> A. x ph ) ). `
     <TR> <TD> 3::       <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) , -. ph ->. -. ph ). `
     <TR> <TD> 4:2:      <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. A. x ( -. ph -> A. x -. ph ) ). `
     <TR> <TD> 5:4:      <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( -. ph -> A. x -. ph ) ). `
     <TR> <TD> 6:3,5:    <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) , -. ph ->. A. x -. ph ). `
     <TR> <TD> 7::       <TD> ` |- ( -. ph -> ( ph -> ps ) ) `
     <TR> <TD> 8:7:      <TD> ` |- ( A. x -. ph -> A. x ( ph -> ps ) ) `
     <TR> <TD> 9:6,8:    <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) , -. ph ->. A. x ( ph -> ps ) ). `
     <TR> <TD> 10:9:     <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( -. ph -> A. x ( ph -> ps ) ) ). `
     <TR> <TD> 11::      <TD> ` |- ( ps -> ( ph -> ps ) ) `
     <TR> <TD> 12:11:    <TD> ` |- ( A. x ps -> A. x ( ph -> ps ) ) `
     <TR> <TD> 13:1:     <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. A. x ( ps -> A. x ps ) ). `
     <TR> <TD> 14:13:    <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( ps -> A. x ps ) ). `
     <TR> <TD> 15:14,12: <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( ps -> A. x ( ph -> ps ) ) ). `
     <TR> <TD> 16:10,15: <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( ( -. ph \/ ps ) -> A. x ( ph -> ps ) ) ). `
     <TR> <TD> 17::      <TD> ` |- ( ( ph -> ps ) <-> ( -. ph \/ ps ) ) `
     <TR> <TD> 18:16,17: <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. ( ( ph -> ps ) -> A. x ( ph -> ps ) ) ). `
     <TR> <TD> 19::      <TD> ` |- ( A. x ( ph -> A. x ph ) -> A. x A. x ( `
     ` ph -> A. x ph ) ) `
     <TR> <TD> 20::      <TD> ` |- ( A. x ( ps -> A. x ps ) -> A. x A. x ( `
     ` ps -> A. x ps ) ) `
     <TR> <TD> 21:19,20: <TD> ` |- ( ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) -> A. x ( A. x ( ph -> A. x ph ) /\ A. x ( ps -> `
     ` A. x ps ) ) ) `
     <TR> <TD> 22:21,18: <TD> ` |- (. ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) ->. A. x ( ( ph -> ps ) -> A. x ( ph -> ps ) ) ). `
     <TR> <TD> qed:22:   <TD> ` |- ( ( A. x ( ph -> A. x ph ) /\ A. x ( ps `
     ` -> A. x ps ) ) -> A. x ( ( ph -> ps ) -> A. x ( ph -> ps ) ) ) `
     </TABLE> </HTML> $)
  hbimpgVD $p |- ( ( A. x ( ph -> A. x ph ) /\ A. x ( ps -> A. x ps ) ) ->
                  A. x ( ( ph -> ps ) -> A. x ( ph -> ps ) ) ) $=
    ( wal wi wa hba1 hban wn wo wb idn2 idn1 simpl e1_ hbntal pm2.27 alimi e10
    sp e21 pm2.21 in2 simpr ax-1 imim1 jao e11 imor imbi1 biimprcd gen11nv in1
    e2 ) AACDEZCDZBBCDZEZCDZFZABEZVACDZEZCDUTVCCUPUSCUOCGURCGHUTAIZBJZVBEZVAVEK
    ZVCUTVDVBEBVBEZVFUTVDVBUTVDVDCDZVBUTVDVDVDVIEZVIUTVDLUTVJCDZVJUTUPVKUTUTUPU
    TMZUPUSNOACPOVJCTOVDVIQUAVDVACABUBRUNUCUTURUQVBEVHUTUSURUTUTUSVLUPUSUDOURCT
    OBVACBAUERBUQVBUFSVDVBBUGUHABUIVGVCVFVAVEVBUJUKSULUM $.

  $( Virtual deduction proof of ~ hbalg .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ hbalg
     is ~ hbalgVD without virtual deductions and was automatically derived
     from ~ hbalgVD . (Contributed by Alan Sare, 8-Feb-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::        <TD> ` |- (. A. y ( ph -> A. x ph ) ->. A. y ( ph `
     ` -> A. x ph ) ). `
     <TR> <TD> 2:1:       <TD> ` |- (. A. y ( ph -> A. x ph ) ->. ( A. y ph `
     ` -> A. y A. x ph ) ). `
     <TR> <TD> 3::        <TD> ` |- ( A. y A. x ph -> A. x A. y ph ) `
     <TR> <TD> 4:2,3:     <TD> ` |- (. A. y ( ph -> A. x ph ) ->. ( A. y ph `
     ` -> A. x A. y ph ) ). `
     <TR> <TD> 5::        <TD> ` |- ( A. y ( ph -> A. x ph ) -> A. y A. y ( `
     ` ph -> A. x ph ) ) `
     <TR> <TD> 6:5,4:     <TD> ` |- (. A. y ( ph -> A. x ph ) ->. A. y ( A. `
     ` y ph -> A. x A. y ph ) ). `
     <TR> <TD> qed:6:     <TD> ` |- ( A. y ( ph -> A. x ph ) -> A. y ( A. y `
     ` ph -> A. x A. y ph ) ) `
     </TABLE> </HTML> $)
  hbalgVD $p |- ( A. y ( ph -> A. x ph ) ->
                  A. y ( A. y ph -> A. x A. y ph ) ) $=
    ( wal wi hba1 idn1 ax-5 e1_ ax-7 imim1 e10 gen11nv in1 ) AABDZEZCDZACDZRBDZ
    EZCDQTCPCFQROCDZEZUASETQQUBQGAOCHIACBJRUASKLMN $.

  $( Virtual deduction proof of ~ hbexg .
     The following User's Proof is a Virtual Deduction proof completed
     automatically by the tools program completeusersproof.cmd, which invokes
     Mel O'Cat's mmj2 and Norm Megill's Metamath Proof Assistant.  ~ hbexg
     is ~ hbexgVD without virtual deductions and was automatically derived
     from ~ hbexgVD . (Contributed by Alan Sare, 8-Feb-2014.)
     (Proof modification is discouraged.)  (New usage is discouraged.)
     <HTML> <TABLE>
     <TR> <TD> 1::        <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` A. y ( ph -> A. x ph ) ). `
     <TR> <TD> 2:1:       <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. y `
     ` A. x ( ph -> A. x ph ) ). `
     <TR> <TD> 3:2:       <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` ( ph -> A. x ph ) ). `
     <TR> <TD> 4:3:       <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` ( -. ph -> A. x -. ph ) ). `
     <TR> <TD> 5::        <TD> ` |- ( A. x A. y ( ph -> A. x ph ) <-> A. y `
     ` A. x ( ph -> A. x ph ) ) `
     <TR> <TD> 6::        <TD> ` |- ( A. y A. x ( ph -> A. x ph ) -> A. y `
     ` A. y A. x ( ph -> A. x ph ) ) `
     <TR> <TD> 7:5:       <TD> ` |- ( A. y A. x A. y ( ph -> A. x ph ) <-> `
     ` A. y A. y A. x ( ph -> A. x ph ) ) `
     <TR> <TD> 8:5,6,7:   <TD> ` |- ( A. x A. y ( ph -> A. x ph ) -> A. y `
     ` A. x A. y ( ph -> A. x ph ) ) `
     <TR> <TD> 9:8,4:     <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. y `
     ` A. x ( -. ph -> A. x -. ph ) ). `
     <TR> <TD> 10:9:      <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` A. y ( -. ph -> A. x -. ph ) ). `
     <TR> <TD> 11:10:     <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. y `
     ` ( -. ph -> A. x -. ph ) ). `
     <TR> <TD> 12:11:     <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. y `
     ` ( A. y -. ph -> A. x A. y -. ph ) ). `
     <TR> <TD> 13:12:     <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. ( A. `
     ` y -. ph -> A. x A. y -. ph ) ). `
     <TR> <TD> 14::       <TD> ` |- ( A. x A. y ( ph -> A. x ph ) -> A. x `
     ` A. x A. y ( ph -> A. x ph ) ) `
     <TR> <TD> 15:13,14:  <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` ( A. y -. ph -> A. x A. y -. ph ) ). `
     <TR> <TD> 16:15:     <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` ( -. A. y -. ph -> A. x -. A. y -. ph ) ). `
     <TR> <TD> 17:16:     <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. ( -. `
     ` A. y -. ph -> A. x -. A. y -. ph ) ). `
     <TR> <TD> 18::       <TD> ` |- ( E. y ph <-> -. A. y -. ph ) `
     <TR> <TD> 19:17,18:  <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. ( E. `
     ` y ph -> A. x -. A. y -. ph ) ). `
     <TR> <TD> 20:18:     <TD> ` |- ( A. x E. y ph <-> A. x -. A. y -. ph ) `
     <TR> <TD> 21:19,20:  <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. ( E. `
     ` y ph -> A. x E. y ph ) ). `
     <TR> <TD> 22:8,21:   <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. y `
     ` ( E. y ph -> A. x E. y ph ) ). `
     <TR> <TD> 23:14,22:  <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` A. y ( E. y ph -> A. x E. y ph ) ). `
     <TR> <TD> qed:23:    <TD> ` |- (. A. x A. y ( ph -> A. x ph ) ->. A. x `
     ` A. y ( E. y ph -> A. x E. y ph ) ). `
     </TABLE> </HTML> $)
  hbexgVD $p |- ( A. x A. y ( ph -> A. x ph ) ->
                  A. x A. y ( E. y ph -> A. x E. y ph ) ) $=
    ( wal wi wex hba1 alcom albii 3imtr4i wn wb idn1 ax-7 e1_ sp hbntal gen11nv
    biimprcd e10 hbalg df-ex imbi1 imbi2 in1 ) AABDEZCDZBDZACFZUIBDZEZCDZBDUHUL
    BUGBGZUHUKCUFBDZCDZUOCDUHUHCDUNCGUFBCHZUHUOCUPIJZUHUIAKZCDZKZBDZEZUJVALZUKU
    HUTVAEZUIUTLZVBUHVDBDZVDUHUSUSBDEZBDVFUHVGBUMUHVGCDZVGUHURURBDEZCDZVHUHVJBD
    ZVJUHVIBDZCDVKUHVLCUQUHUNVLUHUOUNUHUHUOUHMUFBCNOUNCPOABQORVICBNOVJBPOURBCUA
    OVGCPORUSBQOVDBPOACUBZVEVBVDUIUTVAUCSTUIUTBVMIVCUKVBUJVAUIUDSTRRUE $.

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( The following User's Proof is a Virtual Deduction proof (see: ~ wvd1 )
       completed automatically by a Metamath tools program invoking mmj2 and
       the Metamath Proof Assistant.  ~ a9e2eq is ~ a9e2eqVD without virtual
       deductions and was automatically derived from ~ a9e2eqVD . (Contributed
       by Alan Sare, 25-Mar-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- (. A. x x = y ->. A. x x = y ). `
       <TR> <TD> 2::        <TD> ` |- (. A. x x = y ,. x = u ->. x = u ). `
       <TR> <TD> 3:1:       <TD> ` |- (. A. x x = y ->. x = y ). `
       <TR> <TD> 4:2,3:     <TD> ` |- (. A. x x = y ,. x = u ->. y = u ). `
       <TR> <TD> 5:2,4:     <TD> ` |- (. A. x x = y ,. x = u ->. ( x = u /\ y `
       ` = u ) ). `
       <TR> <TD> 6:5:       <TD> ` |- (. A. x x = y ->. ( x = u -> ( x = u /\ `
       ` y = u ) ) ). `
       <TR> <TD> 7:6:       <TD> ` |- ( A. x x = y -> ( x = u -> ( x = u /\ y `
       ` = u ) ) ) `
       <TR> <TD> 8:7:       <TD> ` |- ( A. x A. x x = y -> A. x ( x = u -> ( `
       ` x = u /\ y = u ) ) ) `
       <TR> <TD> 9::        <TD> ` |- ( A. x x = y <-> A. x A. x x = y ) `
       <TR> <TD> 10:8,9:    <TD> ` |- ( A. x x = y -> A. x ( x = u -> ( x = u `
       ` /\ y = u ) ) ) `
       <TR> <TD> 11:1,10:   <TD> ` |- (. A. x x = y ->. A. x ( x = u -> ( x = `
       ` u /\ y = u ) ) ). `
       <TR> <TD> 12:11:     <TD> ` |- (. A. x x = y ->. ( E. x x = u -> E. x `
       ` ( x = u /\ y = u ) ) ). `
       <TR> <TD> 13::       <TD> ` |- E. x x = u `
       <TR> <TD> 14:13,12:  <TD> ` |- (. A. x x = y ->. E. x ( x = u /\ y = u `
       ` ) ). `
       <TR> <TD> 140:14:    <TD> ` |- ( A. x x = y -> E. x ( x = u /\ y = u ) `
       ` ) `
       <TR> <TD> 141:140:   <TD> ` |- ( A. x x = y -> A. x E. x ( x = u /\ y `
       ` = u ) ) `
       <TR> <TD> 15:1,141:  <TD> ` |- (. A. x x = y ->. A. x E. x ( x = u /\ `
       ` y = u ) ). `
       <TR> <TD> 16:1,15:   <TD> ` |- (. A. x x = y ->. A. y E. x ( x = u /\ `
       ` y = u ) ). `
       <TR> <TD> 17:16:     <TD> ` |- (. A. x x = y ->. E. y E. x ( x = u /\ `
       ` y = u ) ). `
       <TR> <TD> 18:17:     <TD> ` |- (. A. x x = y ->. E. x E. y ( x = u /\ `
       ` y = u ) ). `
       <TR> <TD> 19::       <TD> ` |- (. u = v ->. u = v ). `
       <TR> <TD> 20::       <TD> ` |- (. u = v ,. ( x = u /\ y = u ) ->. ( x =
       `
       ` u /\ y = u ) ). `
       <TR> <TD> 21:20:     <TD> ` |- (. u = v ,. ( x = u /\ y = u ) ->. y = u
       `
       ` ). `
       <TR> <TD> 22:19,21:  <TD> ` |- (. u = v ,. ( x = u /\ y = u ) ->. y = v
       `
       ` ). `
       <TR> <TD> 23:20:     <TD> ` |- (. u = v ,. ( x = u /\ y = u ) ->. x = u
       `
       ` ). `
       <TR> <TD> 24:22,23:  <TD> ` |- (. u = v ,. ( x = u /\ y = u ) ->. ( x =
       `
       ` u /\ y = v ) ). `
       <TR> <TD> 25:24:     <TD> ` |- (. u = v ->. ( ( x = u /\ y = u ) -> ( `
       ` x = u /\ y = v ) ) ). `
       <TR> <TD> 26:25:     <TD> ` |- (. u = v ->. A. y ( ( x = u /\ y = u ) `
       ` -> ( x = u /\ y = v ) ) ). `
       <TR> <TD> 27:26:     <TD> ` |- (. u = v ->. ( E. y ( x = u /\ y = u ) `
       ` -> E. y ( x = u /\ y = v ) ) ). `
       <TR> <TD> 28:27:     <TD> ` |- (. u = v ->. A. x ( E. y ( x = u /\ y = `
       ` u ) -> E. y ( x = u /\ y = v ) ) ). `
       <TR> <TD> 29:28:     <TD> ` |- (. u = v ->. ( E. x E. y ( x = u /\ y = `
       ` u ) -> E. x E. y ( x = u /\ y = v ) ) ). `
       <TR> <TD> 30:29:     <TD> ` |- ( u = v -> ( E. x E. y ( x = u /\ y = u `
       ` ) -> E. x E. y ( x = u /\ y = v ) ) ) `
       <TR> <TD> 31:18,30:  <TD> ` |- (. A. x x = y ->. ( u = v -> E. x E. y `
       ` ( x = u /\ y = v ) ) ). `
       <TR> <TD> qed:31:    <TD> ` |- ( A. x x = y -> ( u = v -> E. x E. y ( `
       ` x = u /\ y = v ) ) ) `
       </TABLE> </HTML> $)
    a9e2eqVD $p |- ( A. x x = y -> ( u = v ->
                  E. x E. y ( x = u /\ y = v ) ) ) $=
      ( cv wceq wal wa wex wi idn1 sp idn2 e1_ com12 e22 in2 in1 exim e2 impbii
      a9ev hba1 ax-8 e21 pm3.2 alimi sylbi e01 a5i ax10o e11 19.2 excomim simpr
      pm2.27 equtrr e12 simpl pm3.21 gen11 pm2.04 e10 ) AEZBEZFZAGZDEZCEZFZVDVH
      FZVEVIFZHZBIZAIZJZVGVKVEVHFZHZBIZAIZVJVTVOJZJZVPVGVRAIZBIZVTVGWCBGZWDVGVG
      WCAGZWEVGKZVGVGWFWGVFWCAVGWCVKAIZVGWHWCJZWCADUBVGVKVRJZAGZWIVGVGWKWGVGVGA
      GZWKVGWLVFAUCVGALUAVGWJAVGWJVGVKVRVGVKVKVQVRVGVKMZVGVKVKVFVQWMVGVGVFWGVFA
      LNVFVKVQABDUDOUEVKVQUFPQRUGUHNVKVRASNWHWCUPUIRUJNWCABUKULWCBUMNVRBAUNNVJW
      AVJVSVNJZAGWAVJWNAVJVRVMJZBGWNVJWOBVJVRVMVJVRVLVKVMVJVJVRVQVLVJKVJVRVRVQV
      JVRMZVKVQUOTDCBUQURVJVRVRVKWPVKVQUSTVLVKUTPQVAVRVMBSNVAVSVNASNRWBVTVPVJVT
      VOVBOVCR $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x z $.  $d y z $.
    $( The following User's Proof is a Virtual Deduction proof (see: ~ wvd1 )
       completed automatically by a Metamath tools program invoking mmj2 and
       the Metamath Proof Assistant. ~ a9e2eq is ~ a9e2ndVD without virtual
       deductions and was automatically derived from ~ a9e2ndVD . (Contributed
       by Alan Sare, 25-Mar-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- E. y y = v `
       <TR> <TD> 2::          <TD> ` |- u e. _V `
       <TR> <TD> 3:1,2:       <TD> ` |- ( u e. _V /\ E. y y = v ) `
       <TR> <TD> 4:3:         <TD> ` |- E. y ( u e. _V /\ y = v ) `
       <TR> <TD> 5::          <TD> ` |- ( u e. _V <-> E. x x = u ) `
       <TR> <TD> 6:5:         <TD> ` |- ( ( u e. _V /\ y = v ) <-> ( E. x x = `
       ` u /\ y = v ) ) `
       <TR> <TD> 7:6:         <TD> ` |- ( E. y ( u e. _V /\ y = v ) <-> E. y `
       ` ( E. x x = u /\ y = v ) ) `
       <TR> <TD> 8:4,7:       <TD> ` |- E. y ( E. x x = u /\ y = v ) `
       <TR> <TD> 9::          <TD> ` |- ( z = v -> A. x z = v ) `
       <TR> <TD> 10::         <TD> ` |- ( y = v -> A. z y = v ) `
       <TR> <TD> 11::         <TD> ` |- (. z = y ->. z = y ). `
       <TR> <TD> 12:11:       <TD> ` |- (. z = y ->. ( z = v <-> y = v ) ). `
       <TR> <TD> 120:11:      <TD> ` |- ( z = y -> ( z = v <-> y = v ) ) `
       <TR> <TD> 13:9,10,120: <TD> ` |- ( -. A. x x = y -> ( y = v -> A. x y `
       ` = v ) ) `
       <TR> <TD> 14::         <TD> ` |- (. -. A. x x = y ->. -. A. x x = y ). `
       <TR> <TD> 15:14,13:    <TD> ` |- (. -. A. x x = y ->. ( y = v -> A. x `
       ` y = v ) ). `
       <TR> <TD> 16:15:       <TD> ` |- ( -. A. x x = y -> ( y = v -> A. x y `
       ` = v ) ) `
       <TR> <TD> 17:16:       <TD> ` |- ( A. x -. A. x x = y -> A. x ( y = v `
       ` -> A. x y = v ) ) `
       <TR> <TD> 18::         <TD> ` |- ( -. A. x x = y -> A. x -. A. x x = y `
       ` ) `
       <TR> <TD> 19:17,18:    <TD> ` |- ( -. A. x x = y -> A. x ( y = v -> A. `
       ` x y = v ) ) `
       <TR> <TD> 20:14,19:    <TD> ` |- (. -. A. x x = y ->. A. x ( y = v -> `
       ` A. x y = v ) ). `
       <TR> <TD> 21:20:       <TD> ` |- (. -. A. x x = y ->. ( ( E. x x = u `
       ` /\ y = v ) -> E. x ( x = u /\ y = v ) ) ). `
       <TR> <TD> 22:21:       <TD> ` |- ( -. A. x x = y -> ( ( E. x x = u /\ `
       ` y = v ) -> E. x ( x = u /\ y = v ) ) ) `
       <TR> <TD> 23:22:       <TD> ` |- ( A. y -. A. x x = y -> A. y ( ( E. x `
       ` x = u /\ y = v ) -> E. x ( x = u /\ y = v ) ) ) `
       <TR> <TD> 24::         <TD> ` |- ( -. A. x x = y -> A. y -. A. x x = y `
       ` ) `
       <TR> <TD> 25:23,24:    <TD> ` |- ( -. A. x x = y -> A. y ( ( E. x x = `
       ` u /\ y = v ) -> E. x ( x = u /\ y = v ) ) ) `
       <TR> <TD> 26:14,25:    <TD> ` |- (. -. A. x x = y ->. A. y ( ( E. x x `
       ` = u /\ y = v ) -> E. x ( x = u /\ y = v ) ) ). `
       <TR> <TD> 27:26:       <TD> ` |- (. -. A. x x = y ->. ( E. y ( E. x x `
       ` = u /\ y = v ) -> E. y E. x ( x = u /\ y = v ) ) ). `
       <TR> <TD> 28:8,27:     <TD> ` |- (. -. A. x x = y ->.  E. y E. x ( x = `
       ` u /\ y = v ) ). `
       <TR> <TD> 29:28:       <TD> ` |- (. -. A. x x = y ->.  E. x E. y ( x = `
       ` u /\ y = v ) ). `
       <TR> <TD> qed:29:      <TD> ` |- ( -. A. x x = y -> E. x E. y ( x = u `
       ` /\ y = v ) ) `
       </TABLE> </HTML> $)
    a9e2ndVD $p |- ( -. A. x x = y ->
                       E. x E. y ( x = u /\ y = v ) ) $=
      ( vz cv wceq wal wn wa wex wi cvv wcel idn1 ax-17 e1_ in1 alimi syl isset
      vex a9e pm3.2i 19.42v biimpri e0_ anbi1i exbii mpbi hbnae hbn1 wb equequ1
      dvelimh 19.41rg exim pm2.27 e01 excomim ) AFZBFZGZAHIZVADFZGZVBCFZGZJZBKA
      KZVDVIAKZBKZVJVFAKZVHJZBKZVDVOVLLZVLVEMNZVHJZBKZVOVQVHBKZJZVSVQVTDUBBCUCU
      DVSWAVQVHBUEUFUGVRVNBVQVMVHAVEUAUHUIUJVDVNVKLZBHZVPVDVDWCVDOZVDVDBHWCABBU
      KVDWBBVDWBVDVHVHAHLZAHZWBVDVDWFWDVDVDAHWFVCAULVDWEAVDWEVDVDWEWDEFZVGGZVHA
      BEWHAPVHEPWGVBGZWHVHUMZWIWIWJWIOEBCUNQRUOQRSTQVFVHAUPQRSTQVNVKBUQQVOVLURU
      SVIBAUTQR $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( The following User's Proof is a Virtual Deduction proof (see: ~ wvd1 )
       completed automatically by a Metamath tools program invoking mmj2 and
       the Metamath Proof Assistant. ~ a9e2eq is ~ a9e2ndeqVD without virtual
       deductions and was automatically derived from ~ a9e2ndeqVD .
       (Contributed by Alan Sare, 25-Mar-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- (. u =/= v ->. u =/= v ). `
       <TR> <TD> 2::          <TD> ` |- (. u =/= v ,. ( x = u /\ y = v ) ->. (
       `
       ` x = u /\ y = v ) ). `
       <TR> <TD> 3:2:         <TD> ` |- (. u =/= v ,. ( x = u /\ y = v ) ->. x
       `
       ` = u ). `
       <TR> <TD> 4:1,3:       <TD> ` |- (. u =/= v ,. ( x = u /\ y = v ) ->. x
       `
       ` =/= v ). `
       <TR> <TD> 5:2:         <TD> ` |- (. u =/= v ,. ( x = u /\ y = v ) ->. y
       `
       ` = v ). `
       <TR> <TD> 6:4,5:       <TD> ` |- (. u =/= v ,. ( x = u /\ y = v ) ->. x
       `
       ` =/= y ). `
       <TR> <TD> 7::          <TD> ` |- ( A. x x = y -> x = y ) `
       <TR> <TD> 8:7:         <TD> ` |- ( -. x = y -> -. A. x x = y ) `
       <TR> <TD> 9::          <TD> ` |- ( -. x = y <-> x =/= y ) `
       <TR> <TD> 10:8,9:      <TD> ` |- ( x =/= y -> -. A. x x = y ) `
       <TR> <TD> 11:6,10:     <TD> ` |- (. u =/= v ,. ( x = u /\ y = v ) ->. `
       ` -. A. x x = y ). `
       <TR> <TD> 12:11:       <TD> ` |- (. u =/= v ->. ( ( x = u /\ y = v ) `
       ` -> -. A. x x = y ) ). `
       <TR> <TD> 13:12:       <TD> ` |- (. u =/= v ->. A. x ( ( x = u /\ y = `
       ` v ) -> -. A. x x = y ) ). `
       <TR> <TD> 14:13:       <TD> ` |- (. u =/= v ->. ( E. x ( x = u /\ y = `
       ` v ) -> E. x -. A. x x = y ) ). `
       <TR> <TD> 15::         <TD> ` |- ( -. A. x x = y -> A. x -. A. x x = y `
       ` ) `
       <TR> <TD> 19:15:       <TD> ` |- ( E. x -. A. x x = y <-> -. A. x x = `
       ` y ) `
       <TR> <TD> 20:14,19:    <TD> ` |- (. u =/= v ->. ( E. x ( x = u /\ y = `
       ` v ) -> -. A. x x = y ) ). `
       <TR> <TD> 21:20:       <TD> ` |- (. u =/= v ->. A. y ( E. x ( x = u /\ `
       ` y = v ) -> -. A. x x = y ) ). `
       <TR> <TD> 22:21:       <TD> ` |- (. u =/= v ->. ( E. y E. x ( x = u /\ `
       ` y = v ) -> E. y -. A. x x = y ) ). `
       <TR> <TD> 23::         <TD> ` |- ( E. x E. y ( x = u /\ y = v ) <-> E. `
       ` y E. x ( x = u /\ y = v ) ) `
       <TR> <TD> 24:22,23:    <TD> ` |- (. u =/= v ->. ( E. x E. y ( x = u /\ `
       ` y = v ) -> E. y -. A. x x = y ) ). `
       <TR> <TD> 25::         <TD> ` |- ( -. A. x x = y -> A. y -. A. x x = y `
       ` ) `
       <TR> <TD> 26:25:       <TD> ` |- ( E. y -. A. x x = y -> E. y A. y -. `
       ` A. x x = y ) `
       <TR> <TD> 260::        <TD> ` |- ( A. y -. A. x x = y -> A. y A. y -. `
       ` A. x x = y ) `
       <TR> <TD> 27:260:      <TD> ` |- ( E. y A. y -. A. x x = y <-> A. y -. `
       ` A. x x = y ) `
       <TR> <TD> 270:26,27:   <TD> ` |- ( E. y -. A. x x = y -> A. y -. A. x `
       ` x = y ) `
       <TR> <TD> 28::         <TD> ` |- ( A. y -. A. x x = y -> -. A. x x = y `
       ` ) `
       <TR> <TD> 29:270,28:   <TD> ` |- ( E. y -. A. x x = y -> -. A. x x = y `
       ` ) `
       <TR> <TD> 30:24,29:    <TD> ` |- (. u =/= v ->. ( E. x E. y ( x = u /\ `
       ` y = v ) -> -. A. x x = y ) ). `
       <TR> <TD> 31:30:       <TD> ` |- (. u =/= v ->. ( E. x E. y ( x = u /\ `
       ` y = v ) -> ( -. A. x x = y \/ u = v ) ) ). `
       <TR> <TD> 32:31:       <TD> ` |- ( u =/= v -> ( E. x E. y ( x = u /\ y `
       ` = v ) -> ( -. A. x x = y \/ u = v ) ) ) `
       <TR> <TD> 33::         <TD> ` |- (. u = v ->. u = v ). `
       <TR> <TD> 34:33:       <TD> ` |- (. u = v ->. ( E. x E. y ( x = u /\ y `
       ` = v ) -> u = v ) ). `
       <TR> <TD> 35:34:       <TD> ` |- (. u = v ->. ( E. x E. y ( x = u /\ y `
       ` = v ) -> ( -. A. x x = y \/ u = v ) ) ). `
       <TR> <TD> 36:35:       <TD> ` |- ( u = v -> ( E. x E. y ( x = u /\ y = `
       ` v ) -> ( -. A. x x = y \/ u = v ) ) ) `
       <TR> <TD> 37::         <TD> ` |- ( u = v \/ u =/= v ) `
       <TR> <TD> 38:32,36,37: <TD> ` |- ( E. x E. y ( x = u /\ y = v ) -> ( `
       ` -. A. x x = y \/ u = v ) ) `
       <TR> <TD> 39::         <TD> ` |- ( A. x x = y -> ( u = v -> E. x E. y `
       ` ( x = u /\ y = v ) ) ) `
       <TR> <TD> 40::         <TD> ` |- ( -. A. x x = y -> E. x E. y ( x = u `
       ` /\ y = v ) ) `
       <TR> <TD> 41:40:       <TD> ` |- ( -. A. x x = y -> ( u = v -> E. x E. `
       ` y ( x = u /\ y = v ) ) ) `
       <TR> <TD> 42::         <TD> ` |- ( A. x x = y \/ -. A. x x = y ) `
       <TR> <TD> 43:39,41,42: <TD> ` |- ( u = v -> E. x E. y ( x = u /\ y = v `
       ` ) ) `
       <TR> <TD> 44:40,43:    <TD> ` |- ( ( -. A. x x = y \/ u = v ) -> E. x `
       ` E. y ( x = u /\ y = v ) ) `
       <TR> <TD> qed:38,44:   <TD> ` |- ( ( -. A. x x = y \/ u = v ) <-> E. x `
       ` E. y ( x = u /\ y = v ) ) `
       </TABLE> </HTML> $)
    a9e2ndeqVD $p |- ( ( -. A. x x = y \/ u = v ) <->
                        E. x E. y ( x = u /\ y = v ) ) $=
      ( cv wceq wal wn wo wex wi jao e000 wne wb idn1 e2 biimprcd e1_ e10 exmid
      wa a9e2nd a9e2eq a1d jaoi simpl neeq1 e12 simpr neeq2 e22 df-ne bicomi sp
      idn2 con3i sylbir in2 gen11 exim nfnae 19.9 imbi2 excom imbi1 hbnae eximi
      biimpcd nfa1 sylib syl imim1 orc imim2i in1 ax-1 olc exmidne com12 impbii
      ) AEZBEZFZAGZHZDEZCEZFZIZWBWGFZWCWHFZUBZBJAJZWFWNWIABCDUCZWEWIWNKZKWFWPKW
      EWFIWPABCDUDWFWNWIWOUEWEUAWEWPWFLMUFWGWHNZWNWJKZKZWIWRKZWIWQIZWRWQWRWQWNW
      FKZWRWQWNWFBJZKZXCWFKXBWQWMAJZBJZXCKZWNXFOZXDWQXEWFKZBGXGWQXIBWQXEWFAJZKZ
      XJWFOZXIWQWMWFKZAGXKWQXMAWQWMWFWQWMWBWCNZWFWQWMWBWHNZWLXNWQWQWMWKXOWQPWQW
      MWMWKWQWMUPZWKWLUGQWKXOWQWBWGWHUHRUIWQWMWMWLXPWKWLUJQWLXNXOWCWHWBUKRULXNW
      DHZWFXNXQWBWCUMUNWEWDWDAUOUQURQUSUTWMWFAVASWFAABAVBVCXLXKXIXJWFXEVDVITUTX
      EWFBVASWMABVEXHXDXGWNXFXCVFRTXCWFBGZWFXCXRBJXRWFXRBABBVGVHXRBWFBVJVCVKWFB
      UOVLWNXCWFVMTWFWJWNWFWIVNVOSVPWIWRWIWNWIKZWRWIWIXSWIPWIWNVQSWIWJWNWIWFVRV
      OSVPWGWHVSWTWSXAWRKWIWRWQLVTMWA $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( The following User's Proof is a Virtual Deduction proof (see: ~ wvd1 )
       completed automatically by a Metamath tools program invoking mmj2 and
       the Metamath Proof Assistant. ~ 2sb5nd is ~ 2sb5ndVD without virtual
       deductions and was automatically derived from ~ 2sb5ndVD . (Contributed
       by Alan Sare, 30-Apr-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::          <TD> ` |- ( ( ( x = u /\ y = v ) /\ [ u / x ] [ `
       ` v / y ] ph ) <-> ( ( x = u /\ y = v ) /\ ph ) ) `
       <TR> <TD> 2:1:         <TD> ` |- ( E. y ( ( x = u /\ y = v ) /\ [ u / `
       ` x ] [ v / y ] ph ) <-> E. y ( ( x = u /\ y = v ) /\ ph ) ) `
       <TR> <TD> 3::          <TD> ` |- ( [ v / y ] ph -> A. y [ v / y ] ph ) `
       <TR> <TD> 4:3:         <TD> ` |- [ u / x ] ( [ v / y ] ph -> A. y [ v `
       ` / y ] ph ) `
       <TR> <TD> 5:4:         <TD> ` |- ( [ u / x ] [ v / y ] ph -> [ u / x ] `
       ` A. y [ v / y ] ph ) `
       <TR> <TD> 6::          <TD> ` |- (. -. A. x x = y ->. -. A. x x = y ). `
       <TR> <TD> 7::          <TD> ` |- ( A. y y = x -> A. x x = y ) `
       <TR> <TD> 8:7:         <TD> ` |- ( -. A. x x = y -> -. A. y y = x ) `
       <TR> <TD> 9:6,8:       <TD> ` |- (. -. A. x x = y ->. -. A. y y = x ). `
       <TR> <TD> 10:9:        <TD> ` |- ( [ u / x ] A. y [ v / y ] ph <-> A. `
       ` y [ u / x ] [ v / y ] ph ) `
       <TR> <TD> 11:5,10:     <TD> ` |- ( [ u / x ] [ v / y ] ph -> A. y [ u `
       ` / x ] [ v / y ] ph ) `
       <TR> <TD> 12:11:       <TD> ` |- ( -. A. x x = y -> ( [ u / x ] [ v / `
       ` y ] ph -> A. y [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 13::         <TD> ` |- ( [ u / x ] [ v / y ] ph -> A. x [ u `
       ` / x ] [ v / y ] ph ) `
       <TR> <TD> 14::         <TD> ` |- (. A. x x = y ->. A. x x = y ). `
       <TR> <TD> 15:14:       <TD> ` |- (. A. x x = y ->. ( A. x [ u / x ] [ `
       ` v / y ] ph -> A. y [ u / x ] [ v / y ] ph ) ). `
       <TR> <TD> 16:13,15:    <TD> ` |- (. A. x x = y ->. ( [ u / x ] [ v / y `
       ` ] ph -> A. y [ u / x ] [ v / y ] ph ) ). `
       <TR> <TD> 17:16:       <TD> ` |- ( A. x x = y -> ( [ u / x ] [ v / y ] `
       ` ph -> A. y [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 19:12,17:    <TD> ` |- ( [ u / x ] [ v / y ] ph -> A. y [ u `
       ` / x ] [ v / y ] ph ) `
       <TR> <TD> 20:19:       <TD> ` |- ( E. y ( ( x = u /\ y = v ) /\ [ u / `
       ` x ] [ v / y ] ph )  <-> ( E. y ( x = u /\ y = v ) /\ `
       ` [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 21:2,20:     <TD> ` |- ( E. y ( ( x = u /\ y = v ) /\ ph ) `
       ` <-> ( E. y ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 22:21:       <TD> ` |- ( E. x E. y ( ( x = u /\ y = v ) /\ `
       ` ph ) <-> E. x ( E. y ( x = u /\ y = v ) /\ `
       ` [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 23:13:       <TD> ` |- ( E. x ( E. y ( x = u /\ y = v ) /\ [ `
       ` u / x ] [ v / y ] ph ) <-> ( E. x E. y ( x = u /\ y = v ) /\ `
       ` [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 24:22,23:    <TD> ` |- ( ( E. x E. y ( x = u /\ y = v ) /\ [ `
       ` u / x ] [ v / y ] ph ) <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) `
       <TR> <TD> 240:24:      <TD> ` |- ( ( E. x E. y ( x = u /\ y = v ) /\ ( `
       ` E. x E. y ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ) <-> `
       ` ( E. x E. y ( x = u /\ y = v ) /\ E. x E. y ( ( x = u /\ y = v ) /\ `
       ` ph ) ) ) `
       <TR> <TD> 241::        <TD> ` |- ( ( E. x E. y ( x = u /\ y = v ) /\ ( `
       ` E. x E. y ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ) <-> `
       ` ( E. x E. y ( x = u /\ y = v ) /\ [ u / x ] [ v / y ] ph ) ) `
       <TR> <TD> 242:241,240: <TD> ` |- ( ( E. x E. y ( x = u /\ y = v ) /\ [ `
       ` u / x ] [ v / y ] ph ) <-> ( E. x E. y ( x = u /\ y = v ) /\ `
       ` E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) `
       <TR> <TD> 243::        <TD> ` |- ( ( E. x E. y ( x = u /\ y = v ) -> ( `
       ` [ u / x ] [ v / y ] ph <-> E. x E. y ( ( x = u /\ y = v ) /\ `
       ` ph ) ) ) <->  ( ( E. x E. y ( x = u /\ y = v ) /\ `
       ` [ u / x ] [ v / y ] ph ) <-> ( E. x E. y ( x = u /\ y = v ) /\ `
       ` E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) ) `
       <TR> <TD> 25:242,243:  <TD> ` |- ( E. x E. y ( x = u /\ y = v ) -> ( [ `
       ` u / x ] [ v / y ] ph <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) `
       <TR> <TD> 26::         <TD> ` |- ( ( -. A. x x = y \/ u = v ) <-> E. x `
       ` E. y ( x = u /\ y = v ) ) `
       <TR> <TD> qed:25,26:   <TD> ` |- ( ( -. A. x x = y \/ u = v ) -> ( [ u `
       ` / x ] [ v / y ] ph <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) `
       </TABLE> </HTML> $)
    2sb5ndVD $p |- ( ( -. A. x x = y \/ u = v ) -> ( [ u / x ] [ v / y ] ph
                 <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) $=
      ( cv wceq wal wn wa wex wsb wb wi exbii hbs1 idn1 e1_ e01 in1 wo a9e2ndeq
      2pm13.193 ax10o imim1 sbt sbi1 e0_ ax10 con3i sbal2 imbi2 biimpcd pm2.61i
      anabs5 nfi 19.41 bitr3i bitr2i anbi2i pm5.32 mpbir sylbi ) BFZCFZGBHZIZEF
      ZDFZGUAVDVHGVEVIGJZCKZBKZACDLZBELZVJAJZCKZBKZMZBCDEUBVLVRNVLVNJZVLVQJZMVS
      VLVSJVTVLVNUOVSVQVLVQVKVNJZBKVSVPWABVPVJVNJZCKWAWBVOCABCDEUCOVJVNCVNCVFVN
      VNCHZNZVFWDVNVNBHZNVFWEWCNZWDVMBEPZVFVFWFVFQVNBCUDRVNWEWCUESTVGWDVNVMCHZB
      ELZNZVGWIWCMZWDVMWHNZBELWJWLBEACDPUFVMWHBEUGUHVGVEVDGCHZIZWKVGVGWNVGQWMVF
      CBUIUJRVMCBEUKRWKWJWDWIWCVNULUMSTUNUPUQUROVKVNBVNBWGUPUQUSUTURVLVNVQVAVBV
      C $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    2uasbanhVD.1 $e |- ( ch <-> ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\
                     E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) $.
    $( The following User's Proof is a Virtual Deduction proof (see: ~ wvd1 )
       completed automatically by a Metamath tools program invoking mmj2 and
       the Metamath Proof Assistant. ~ 2uasbanh is ~ 2uasbanhVD without virtual
       deductions and was automatically derived from ~ 2uasbanhVD .
       (Contributed by Alan Sare, 31-May-2014.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> h1::         <TD> ` |- ( ch <-> ( E. x E. y ( ( x = u /\ y = `
       ` v ) /\ ph ) /\ E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) `
       <TR> <TD> 100:1:       <TD> ` |- ( ch -> ( E. x E. y ( ( x = u /\ y = `
       ` v ) /\ ph ) /\ E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) `
       <TR> <TD> 2:100:       <TD> ` |- (. ch ->. ( E. x E. y ( ( x = u /\ y `
       ` = v ) /\ ph ) /\ E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ). `
       <TR> <TD> 3:2:         <TD> ` |- (. ch ->. E. x E. y ( ( x = u /\ y = `
       ` v ) /\ ph ) ). `
       <TR> <TD> 4:3:         <TD> ` |- (. ch ->. E. x E. y ( x = u /\ y = v `
       ` ) ). `
       <TR> <TD> 5:4:         <TD> ` |- (. ch ->. ( -. A. x x = y \/ u = v ) `
       ` ). `
       <TR> <TD> 6:5:         <TD> ` |- (. ch ->. ( [ u / x ] [ v / y ] ph `
       ` <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ). `
       <TR> <TD> 7:3,6:       <TD> ` |- (. ch ->. [ u / x ] [ v / y ] ph ). `
       <TR> <TD> 8:2:         <TD> ` |- (. ch ->. E. x E. y ( ( x = u /\ y = `
       ` v ) /\ ps ) ). `
       <TR> <TD> 9:5:         <TD> ` |- (. ch ->. ( [ u / x ] [ v / y ] ps `
       ` <-> E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ). `
       <TR> <TD> 10:8,9:      <TD> ` |- (. ch ->. [ u / x ] [ v / y ] ps ). `
       <TR> <TD> 101::        <TD> ` |- ( [ v / y ] ( ph /\ ps ) <-> ( [ v / `
       ` y ] ph /\ [ v / y ] ps ) ) `
       <TR> <TD> 102:101:     <TD> ` |- ( [ u / x ] [ v / y ] ( ph /\ ps ) `
       ` <-> [ u / x ] ( [ v / y ] ph /\ [ v / y ] ps ) ) `
       <TR> <TD> 103::        <TD> ` |- ( [ u / x ] ( [ v / y ] ph /\ [ v / y `
       ` ] ps ) <-> ( [ u / x ] [ v / y ] ph /\ [ u / x ] [ v / y ] ps ) ) `
       <TR> <TD> 104:102,103: <TD> ` |- ( [ u / x ] [ v / y ] ( ph /\ ps ) `
       ` <->  ( [ u / x ] [ v / y ] ph /\ [ u / x ] [ v / y ] ps ) ) `
       <TR> <TD> 11:7,10,104: <TD> ` |- (. ch ->. [ u / x ] [ v / y ] ( ph /\ `
       ` ps ) ). `
       <TR> <TD> 110:5:       <TD> ` |- (. ch ->. ( [ u / x ] [ v / y ] ( ph `
       ` /\ ps ) <-> E. x E. y ( ( x = u /\ y = v ) /\ ( ph /\ ps ) ) ) ). `
       <TR> <TD> 12:11,110:   <TD> ` |- (. ch ->. E. x E. y ( ( x = u /\ y = `
       ` v ) /\ ( ph /\ ps ) ) ). `
       <TR> <TD> 120:12:      <TD> ` |- ( ch -> E. x E. y ( ( x = u /\ y = v `
       ` ) /\ ( ph /\ ps ) ) ) `
       <TR> <TD> 13:1,120:    <TD> ` |- ( ( E. x E. y ( ( x = u /\ y = v ) /\ `
       ` ph ) /\ E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) -> `
       ` E. x E. y ( ( x = u `
       ` /\ y = v ) /\ ( ph /\ ps ) ) ) `
       <TR> <TD> 14::         <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ( ( x = u /\ y = v ) /\ ( ph /\ ps ) ) ). `
       <TR> <TD> 15:14:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ( x = u /\ y = v ) ). `
       <TR> <TD> 16:14:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ( ph /\ ps ) ). `
       <TR> <TD> 17:16:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ph ). `
       <TR> <TD> 18:15,17:    <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ( ( x = u /\ y = v ) /\ ph ) ). `
       <TR> <TD> 19:18:       <TD> ` |- ( ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) -> ( ( x = u /\ y = v ) /\ ph ) ) `
       <TR> <TD> 20:19:       <TD> ` |- ( E. y ( ( x = u /\ y = v ) /\ ( ph `
       ` /\ ps ) ) -> E. y ( ( x = u /\ y = v ) /\ ph ) ) `
       <TR> <TD> 21:20:       <TD> ` |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( `
       ` ph /\ ps ) ) -> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) `
       <TR> <TD> 22:16:       <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ps ). `
       <TR> <TD> 23:15,22:    <TD> ` |- (. ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) ->. ( ( x = u /\ y = v ) /\ ps ) ). `
       <TR> <TD> 24:23:       <TD> ` |- ( ( ( x = u /\ y = v ) /\ ( ph /\ ps `
       ` ) ) -> ( ( x = u /\ y = v ) /\ ps ) ) `
       <TR> <TD> 25:24:       <TD> ` |- ( E. y ( ( x = u /\ y = v ) /\ ( ph `
       ` /\ ps ) ) -> E. y ( ( x = u /\ y = v ) /\ ps ) ) `
       <TR> <TD> 26:25:       <TD> ` |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( `
       ` ph /\ ps ) ) -> E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) `
       <TR> <TD> 27:21,26:    <TD> ` |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( `
       ` ph /\ ps ) ) -> ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\ `
       ` E. x E. y ( `
       ` ( x = u /\ y = v ) /\ ps ) ) ) `
       <TR> <TD> qed:13,27:   <TD> ` |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( `
       ` ph /\ ps ) ) <-> ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\ `
       ` E. x E. y ( `
       ` ( x = u /\ y = v ) /\ ps ) ) ) `
       </TABLE> </HTML> $)
    2uasbanhVD $p |- ( E. x E. y ( ( x = u /\ y = v ) /\ ( ph /\ ps ) ) <->
                ( E. x E. y ( ( x = u /\ y = v ) /\ ph ) /\
                E. x E. y ( ( x = u /\ y = v ) /\ ps ) ) ) $=
      ( cv wceq wa wex simpl e1_ simpr e11 in1 eximi wsb wb idn1 biimpi dfvd1ir
      pm3.2 jca wal wn wo 2eximi a9e2ndeq biimpri 2sb5nd com12 sban sbbii bitri
      bi2 simplbi2comg com13 e110 bi1 sylbir impbii ) DIZGIZJEIZFIZJKZABKZKZELZ
      DLZVHAKZELZDLZVHBKZELZDLZKZVLVOVRVKVNDVJVMEVJVMVJVHAVMVJVJVHVJUAZVHVIMNZV
      JVIAVJVJVIVTVHVIONZABMNVHAUDPQRRVKVQDVJVPEVJVPVJVHBVPWAVJVIBWBABONVHBUDPQ
      RRUEVSCVLHCVLCVIEFSZDGSZWDVLTZVLCAEFSZDGSZBEFSZDGSZWDWGWIKZTZWDCVOWGVOTZW
      GCVSVOCVSCVSHUBUCZVOVRMNZCVDVFJDUFUGVEVGJUHZWLCVHELDLZWOCVOWPWNVMVHDEVHAM
      UINWOWPDEFGUJUKNZADEFGULNWLVOWGWGVOUQUMPCVRWIVRTZWICVSVRWMVOVRONCWOWRWQBD
      EFGULNWRVRWIWIVRUQUMPWDWFWHKZDGSWJWCWSDGABEFUNUOWFWHDGUNUPWKWIWGWDWDWGWIU
      RUSUTCWOWEWQVIDEFGULNWEWDVLWDVLVAUMPQVBVC $.
  $}

  $( The following User's Proof is a Virtual Deduction proof (see:
     ~ wvd1 ) completed automatically by a Metamath tools program invoking
     mmj2 and the Metamath Proof Assistant. ~ e2ebind is ~ e2ebindVD without
     virtual deductions and was automatically derived from ~ e2ebindVD
     <HTML> <TABLE>
     <TR> <TD> 1::          <TD> ` |- ( ph <-> ph ) `
     <TR> <TD> 2:1:         <TD> ` |- ( A. y y = x -> ( ph <-> ph ) ) `
     <TR> <TD> 3:2:         <TD> ` |- ( A. y y = x -> ( E. y ph <-> E. x ph `
     ` ) ) `
     <TR> <TD> 4::          <TD> ` |- (. A. y y = x ->. A. y y = x ). `
     <TR> <TD> 5:3,4:       <TD> ` |- (. A. y y = x ->. ( E. y ph <-> E. x `
     ` ph ) ). `
     <TR> <TD> 6::          <TD> ` |- ( A. y y = x -> A. y A. y y = x ) `
     <TR> <TD> 7:5,6:       <TD> ` |- (. A. y y = x ->. A. y ( E. y ph <-> `
     ` E. x ph ) ). `
     <TR> <TD> 8:7:         <TD> ` |- (. A. y y = x ->. ( E. y E. y ph <-> `
     ` E. y E. x ph ) ). `
     <TR> <TD> 9::          <TD> ` |- ( E. y E. x ph <-> E. x E. y ph ) `
     <TR> <TD> 10:8,9:      <TD> ` |- (. A. y y = x ->. ( E. y E. y ph <-> `
     ` E. x E. y ph ) ). `
     <TR> <TD> 11::         <TD> ` |- ( E. y ph -> A. y E. y ph ) `
     <TR> <TD> 12:11:       <TD> ` |- ( E. y E. y ph <-> E. y ph ) `
     <TR> <TD> 13:10,12:    <TD> ` |- (. A. y y = x ->. ( E. x E. y ph <-> `
     ` E. y ph ) ). `
     <TR> <TD> 14:13:       <TD> ` |- ( A. y y = x -> ( E. x E. y ph <-> E. `
     ` y ph ) ) `
     <TR> <TD> 15::         <TD> ` |- ( A. y y = x <-> A. x x = y ) `
     <TR> <TD> qed:14,15:   <TD> ` |- ( A. x x = y -> ( E. x E. y ph <-> E. `
     ` y ph ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 27-Nov-2014.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  e2ebindVD $p |- ( A. x x = y -> ( E. x E. y ph <-> E. y ph ) ) $=
    ( cv wceq wal wex wb ax10 hba1 idn1 biid a1i drex1 gen11nv exbi excom bibi1
    e1_ e10 biimprd nfe1 19.9 bitr3 in1 syl ) BDZCDZEBFUHUGEZCFZACGZBGZUKHZBCIU
    JUMUJUKCGZULHZUNUKHUMUJUNABGZCGZHZUQULHZUOUJUKUPHZCFURUJUTCUICJUJUJUTUJKAAC
    BAAHUJALMNSOUKUPCPSACBQURUOUSUNUQULRUATUKCACUBUCUNULUKUDTUEUF $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Virtual Deduction transcriptions of textbook proofs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d x y $.
    $( The following User's Proof is a Natural Deduction Sequent Calculus
       transcription of the Fitch-style Natural Deduction proof of Unit 20
       Excercise 3.a., which is ~sb5 , found in the "Answers to Starred
       Exercises" on page 457 of "Understanding Symbolic Logic", Fifth
       Edition (2008), by Virginia Klenk. The same proof may also be
       interpreted as a Virtual Deduction Hilbert-style axiomatic proof. It
       was completed automatically by the tools program completeusersproof.cmd,
       which invokes Mel O'Cat's mmj2 and Norm Megill's Metamath Proof
       Assistant.  ~ sb5ALT is ~ sb5ALTVD without virtual deductions and
       was automatically derived from ~ sb5ALTVD .
       <HTML> <TABLE>
       <TR> <TD> 1::        <TD> ` |- (. [ y / x ] ph ->. [ y / x ] ph ). `
       <TR> <TD> 2::        <TD> ` |- [ y / x ] x = y `
       <TR> <TD> 3:1,2:     <TD> ` |- (. [ y / x ] ph ->. [ y / x ] ( x = y `
       ` /\ ph ) ). `
       <TR> <TD> 4:3:       <TD> ` |- (. [ y / x ] ph ->.  E. x ( x = y /\ ph `
       ` ) ). `
       <TR> <TD> 5:4:       <TD> ` |- ( [ y / x ] ph -> E. x ( x = y /\ ph ) `
       ` ) `
       <TR> <TD> 6::        <TD> ` |- (. E. x ( x = y /\ ph ) ->. E. x ( x = `
       ` y /\ ph ) ). `
       <TR> <TD> 7::        <TD> ` |- (. E. x ( x = y /\ ph ) ,. ( x = y /\ ph
       `
       ` ) ->. ( x = y /\ ph ) ). `
       <TR> <TD> 8:7:       <TD> ` |- (. E. x ( x = y /\ ph ) ,. ( x = y /\ ph
       `
       ` ) ->. ph ). `
       <TR> <TD> 9:7:       <TD> ` |- (. E. x ( x = y /\ ph ) ,. ( x = y /\ ph
       `
       ` ) ->. x = y ). `
       <TR> <TD> 10:8,9:    <TD> ` |- (. E. x ( x = y /\ ph ) ,. ( x = y /\ ph
       `
       ` ) ->. [ y / x ] ph ). `
       <TR> <TD> 101::      <TD> ` |- ( [ y / x ] ph -> A. x [ y / x ] ph ) `
       <TR> <TD> 11:101,10: <TD> ` |- ( E. x ( x = y /\ ph ) -> [ y / x ] ph `
       ` ) `
       <TR> <TD> 12:5,11:   <TD> ` |- ( ( [ y / x ] ph ->  E. x ( x = y /\ ph `
       ` ) ) /\ ( E. x ( x = y /\ ph ) -> [ y / x ] ph ) ) `
       <TR> <TD> qed:12:    <TD> ` |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) `
       ` ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 21-Apr-2013.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    sb5ALTVD $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      ( wsb cv wceq wa wex wi wb idn1 equsb1 sban simplbi2com e10 spsbe e1_ in1
      hbs1 e2 idn2 simpr simpl sbequ1 com12 e22 exinst pm3.2i bi3 imp e0_ ) ABC
      DZBECEFZAGZBHZIZUOULIZGULUOJZUPUQULUOULUNBCDZUOULULUMBCDZUSULKBCLUSUTULUM
      ABCMNOUNBCPQRUNULBABCSUOUNAUMULUOUNUNAUOUNUAZUMAUBTUOUNUNUMVAUMAUCTUMAULA
      BCUDUEUFUGUHUPUQURULUOUIUJUK $.
  $}

  ${
    vk15.4jVD.1 $e |- -. ( E. x -. ph /\ E. x ( ps /\ -. ch ) ) $.
    vk15.4jVD.2 $e |- ( A. x ch -> -. E. x ( th /\ ta ) ) $.
    vk15.4jVD.3 $e |- -. A. x ( ta -> ph ) $.
    $( The following User's Proof is a Natural Deduction Sequent Calculus
       transcription of the Fitch-style Natural Deduction proof of Unit 15
       Excercise 4.f. found in the "Answers to Starred Exercises" on page 442
       of "Understanding Symbolic Logic", Fifth Edition (2008), by Virginia
       Klenk. The same proof may also be interpreted to be a Virtual Deduction
       Hilbert-style axiomatic proof. It was completed automatically by the
       tools program completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and
       Norm Megill's Metamath Proof Assistant.  ~ vk15.4j is ~ vk15.4jVD
       without virtual deductions and was automatically derived
       from ~ vk15.4jVD . Step numbers greater than 25 are additional steps
       necessary for the sequent calculus proof not contained in the
       Fitch-style proof. Otherwise, step i of the User's Proof corresponds to
       step i of the Fitch-style proof.
       <HTML> <TABLE>
       <TR> <TD> h1::               <TD> ` |- -. ( E. x -. ph /\ E. x ( ps /\ `
       ` -. ch ) ) `
       <TR> <TD> h2::               <TD> ` |- ( A. x ch -> -. E. x ( th /\ ta `
       ` ) ) `
       <TR> <TD> h3::               <TD> ` |- -. A. x ( ta -> ph ) `
       <TR> <TD> 4::                <TD> ` |- (. -. E. x -. th ->. -. E. x -. `
       ` th ). `
       <TR> <TD> 5:4:               <TD> ` |- (. -. E. x -. th ->. A. x th ). `
       <TR> <TD> 6:3:               <TD> ` |- E. x ( ta /\ -. ph ) `
       <TR> <TD> 7::                <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. ( ta /\ -. ph ) ). `
       <TR> <TD> 8:7:               <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. ta ). `
       <TR> <TD> 9:7:               <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. -. ph ). `
       <TR> <TD> 10:5:              <TD> ` |- (. -. E. x -. th ->. th ). `
       <TR> <TD> 11:10,8:           <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. ( th /\ ta ) ). `
       <TR> <TD> 12:11:             <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. E. x ( th /\ ta ) ). `
       <TR> <TD> 13:12:             <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. -. -. E. x ( th /\ ta ) ). `
       <TR> <TD> 14:2,13:           <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. -. A. x ch ). `
       <TR> <TD> 140::              <TD> ` |- ( E. x -. th -> A. x E. x -. th `
       ` ) `
       <TR> <TD> 141:140:           <TD> ` |- ( -. E. x -. th -> A. x -. E. x `
       ` -. th ) `
       <TR> <TD> 142::              <TD> ` |- ( A. x ch -> A. x A. x ch ) `
       <TR> <TD> 143:142:           <TD> ` |- ( -. A. x ch -> A. x -. A. x ch `
       ` ) `
       <TR> <TD> 144:6,14,141,143:  <TD> ` |- (. -. E. x -. th ->. -. A. x ch `
       ` ). `
       <TR> <TD> 15:1:              <TD> ` |- ( -. E. x -. ph \/ -. E. x ( ps `
       ` /\ -. ch ) ) `
       <TR> <TD> 16:9:              <TD> ` |- (. -. E. x -. th ,. ( ta /\ -. `
       ` ph ) ->. E. x -. ph ). `
       <TR> <TD> 161::              <TD> ` |- ( E. x -. ph -> A. x E. x -. ph `
       ` ) `
       <TR> <TD> 162:6,16,141,161:  <TD> ` |- (. -. E. x -. th ->. E. x -. ph `
       ` ). `
       <TR> <TD> 17:162:            <TD> ` |- (. -. E. x -. th ->. -. -. E. x `
       ` -. ph ). `
       <TR> <TD> 18:15,17:          <TD> ` |- (. -. E. x -. th ->. -. E. x ( `
       ` ps /\ -. ch ) ). `
       <TR> <TD> 19:18:             <TD> ` |- (. -. E. x -. th ->. A. x ( ps `
       ` -> ch ) ). `
       <TR> <TD> 20:144:            <TD> ` |- (. -. E. x -. th ->. E. x -. ch `
       ` ). `
       <TR> <TD> 21::               <TD> ` |- (. -. E. x -. th ,. -. ch ->. -.
       `
       ` ch ). `
       <TR> <TD> 22:19:             <TD> ` |- (. -. E. x -. th ->. ( ps -> ch `
       ` ) ). `
       <TR> <TD> 23:21,22:          <TD> ` |- (. -. E. x -. th ,. -. ch ->. -.
       `
       ` ps ). `
       <TR> <TD> 24:23:             <TD> ` |- (. -. E. x -. th ,. -. ch ->. E.
       `
       ` x -. ps ). `
       <TR> <TD> 240::              <TD> ` |- ( E. x -. ps -> A. x E. x -. ps `
       ` ) `
       <TR> <TD> 241:20,24,141,240: <TD> ` |- (. -. E. x -. th ->. E. x -. ps `
       ` ). `
       <TR> <TD> 25:241:            <TD> ` |- (. -. E. x -. th ->. -. A. x ps `
       ` ). `
       <TR> <TD> qed:25:            <TD> ` |- ( -. E. x -. th -> -. A. x ps ) `
       </TABLE> </HTML>
       (Contributed by Alan Sare, 21-Apr-2013.) (Proof modification is
       discouraged.)  (New usage is discouraged.) $)
    vk15.4jVD $p |- ( -. E. x -. th -> -. A. x ps ) $=
      ( wn wex wal wa wi exanali biimpri e1_ e2 19.8a hbe1 idn1 alex idn2 simpl
      e0_ sp pm3.2 e12 notnot1 con3 e02 hbn hba1 exinst01 exnal wo pm3.13 simpr
      pm2.53 e01 con5i com12 e21 exinst11 biimpi in1 ) DJZFKZJZBFLJZVIBJZFKZVJV
      ICJZVLFVICFLZJZVMFKZVIEAJZMZVOFEANFLJZVRFKZIVTVSEAFOPUEZVNDEMZFKZJZNVIVRW
      DJZVOHVIVRWCWEVIVRWBWCVIDVREWBVIDFLZDVIVIWFVIUAWFVIDFUBPQDFUFQVIVRVREVIVR
      UCZEVQUDRDEUGUHWBFSRWCUIRVNWDUJUKVHFVGFTULZVNFCFUMULUNVPVOCFUOPQVIVMVKVLV
      IVMVMBCNZVKVIVMUCVIWIFLZWIVIBVMMFKZJZWJVQFKZJZWLUPZVIWNJZWLWMWKMJWOGWMWKU
      QUEVIWMWPVIVRWMFWAVIVRVQWMVIVRVRVQWGEVQURRVQFSRWHVQFTUNWMUIQWNWLUSUTWKWJB
      CFOVAQWIFUFQWIVMVKBCUJVBVCVKFSRWHVKFTVDVLVJBFUOVEQVF $.
  $}

  $( The following User's Proof is a Natural Deduction Sequent Calculus
     transcription of the Fitch-style Natural Deduction proof of Theorem 5 of
     Section 14 of [Margaris] p. 59 ( which is ~ notnot2 ). The same proof
     may also be interpreted as a Virtual Deduction Hilbert-style
     axiomatic proof. It was completed automatically by the tools program
     completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm Megill's
     Metamath Proof Assistant.  ~ notnot2ALT is ~ notnot2ALTVD
     without virtual deductions and was automatically derived
     from ~ notnot2ALTVD . Step i of the User's Proof corresponds to
     step i of the Fitch-style proof.
     <HTML> <TABLE>
     <TR> <TD> 1::    <TD> ` |- (. -. -. ph ->. -. -. ph ). `
     <TR> <TD> 2::    <TD> ` |- ( -. -. ph -> ( -. ph -> -. -. -. ph ) ) `
     <TR> <TD> 3:1:   <TD> ` |- (. -. -. ph ->. ( -. ph -> -. -. -. ph ) ). `
     <TR> <TD> 4::    <TD> ` |- ( ( -. ph -> -. -. -. ph ) -> ( -. -. ph -> `
     ` ph ) ) `
     <TR> <TD> 5:3:   <TD> ` |- (. -. -. ph ->. ( -. -. ph -> ph ) ). `
     <TR> <TD> 6:5,1: <TD> ` |- (. -. -. ph ->. ph ). `
     <TR> <TD> qed:6: <TD> ` |- ( -. -. ph -> ph ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 21-Apr-2013.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  notnot2ALTVD $p |- ( -. -. ph -> ph ) $=
    ( wn wi idn1 pm2.21 e1_ ax-3 id e11 in1 ) ABZBZALLACZLALKLBZCZMLLOLDZKNEFAL
    GFPMHIJ $.

  $( The following User's Proof is a Natural Deduction Sequent Calculus
     transcription of the Fitch-style Natural Deduction proof of Theorem 7 of
     Section 14 of [Margaris] p. 60 ( which is ~ con3 ). The same proof
     may also be interpreted to be a Virtual Deduction Hilbert-style
     axiomatic proof. It was completed automatically by the tools program
     completeusersproof.cmd, which invokes Mel O'Cat's mmj2 and Norm Megill's
     Metamath Proof Assistant.  ~ con3ALT is ~ con3ALTVD
     without virtual deductions and was automatically derived
     from ~ con3ALTVD . Step i of the User's Proof corresponds to
     step i of the Fitch-style proof.
     <HTML> <TABLE>
     <TR> <TD> 1::     <TD> ` |- (. ( ph -> ps ) ->. ( ph -> ps ) ). `
     <TR> <TD> 2::     <TD> ` |- (. ( ph -> ps ) ,. -. -. ph ->. -. -. ph ). `
     <TR> <TD> 3::     <TD> ` |- ( -. -. ph -> ph ) `
     <TR> <TD> 4:2:    <TD> ` |- (. ( ph -> ps ) ,. -. -. ph ->. ph ). `
     <TR> <TD> 5:1,4:  <TD> ` |- (. ( ph -> ps ) ,. -. -. ph ->. ps ). `
     <TR> <TD> 6::     <TD> ` |- ( ps -> -. -. ps ) `
     <TR> <TD> 7:6,5:  <TD> ` |- (. ( ph -> ps ) ,. -. -. ph ->. -. -. ps ). `
     <TR> <TD> 8:7:    <TD> ` |- (. ( ph -> ps ) ->. ( -. -. ph -> -. -. ps `
     ` ) ). `
     <TR> <TD> 9::     <TD> ` |- ( ( -. -. ph -> -. -. ps ) -> ( -. ps -> `
     ` -. ph ) ) `
     <TR> <TD> 10:8:   <TD> ` |- (. ( ph -> ps ) ->. ( -. ps -> -. ph ) ). `
     <TR> <TD> qed:10: <TD> ` |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) `
     </TABLE> </HTML>
     (Contributed by Alan Sare, 21-Apr-2013.) (Proof modification is
     discouraged.)  (New usage is discouraged.) $)
  con3ALTVD $p |- ( ( ph -> ps ) -> ( -. ps -> -. ph ) ) $=
    ( wi wn idn1 idn2 notnot2 e2 id e12 notnot1 in2 ax-3 e1_ in1 ) ABCZBDZADZCZ
    PRDZQDZCSPTUAPTBUAPPTABPEPTTAPTFAGHPIJBKHLRQMNO $.

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Theorems proved using conjunction-form virtual deduction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    elpwgdedVD.1 $e |- (. ph ->. A e. _V ). $.
    elpwgdedVD.2 $e |- (. ps ->. A C_ B ). $.
    $( Membership in a power class.  Theorem 86 of [Suppes] p. 47.  Derived
       from ~ elpwg .  In form of VD deduction with ` ph ` and ` ps ` as
       variable virtual hypothesis collections based on Mario Carneiro's
       metavariable concept. ~ elpwgded is ~ elpwgdedVD using conventional
       notation.  (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    elpwgdedVD $p |- (. (. ph ,. ps ). ->. A e. ~P B ). $=
      ( cvv wcel wss cpw elpwg biimpar el12 ) ACGHZCDIZCDJHZBEFNPOCDGKLM $.
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class is a subclass of another class, then its power class is a
       subclass of that other class's power class.  Left-to-right implication
       of Exercise 18 of [TakeutiZaring] p. 18. ~ sspwimp , using conventional
       notation, was translated from virtual deduction form, ~ sspwimpVD ,
       using a translation program.  (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    sspwimp $p |- ( A C_ B -> ~P A C_ ~P B ) $=
      ( vx wss cpw cv wcel wi wal cvv wa wtru vex a1i id syl sstr ancoms syl2an
      elpwi elpwgded uun0.1 ex alrimiv dfss2 biimpri iin1 ) ABDZAEZBEZDZUHCFZUI
      GZULUJGZHZCIZUKUHUOCUHUMUNULJGZUHUMKZULBDZUNUQLCMNZUHUHULADZUSUMUHOUMUMVA
      UMOULATPVAUHUSULABQRSZLURULBUTVBUAUBUCUDUKUPCUIUJUEUFPUG $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The following User's Proof is a Virtual Deduction proof ( see: ~ wvd1 )
       using conjunction-form virtual hypothesis collections.  It was completed
       manually, but has the potential to be completed automatically by a tools
       program which would invoke Mel O'Cat's mmj2 and Norm Megill's Metamath
       Proof Assistant. ~ sspwimp is ~ sspwimpVD without virtual deductions and
       was derived from ~ sspwimpVD . (Contributed by Alan Sare, 23-Apr-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::    <TD> ` |- (.    A C_ B ->. A C_ B ). `
       <TR> <TD> 2::    <TD> ` |- (. `  .............. ` x e. ~P A `
       `->. x e. ~P A ). `
       <TR> <TD> 3:2:   <TD> ` |- (. `  .............. ` x e. ~P A `
       ` ->. x C_ A ). `
       <TR> <TD> 4:3,1: <TD> ` |- (. (. A C_ B ,. x e. ~P A ). ->. x C_ B ). `
       <TR> <TD> 5::    <TD> ` |- x e. _V `
       <TR> <TD> 6:4,5: <TD> ` |- (. (. A C_ B ,. x e. ~P A ). ->. x e. ~P B `
       ` ). `
       <TR> <TD> 7:6:   <TD> ` |- (.    A C_ B ->. ( x e. ~P A -> x e. ~P B ) `
       ` ). `
       <TR> <TD> 8:7:   <TD> ` |- (.    A C_ B ->. A. x ( x e. ~P A -> x e. `
       ` ~P B ) ). `
       <TR> <TD> 9:8:   <TD> ` |- (.    A C_ B ->. ~P A C_ ~P B ). `
       <TR> <TD> qed:9: <TD> ` |- ( A C_ B -> ~P A C_ ~P B ) `
       </TABLE> </HTML> $)
    sspwimpVD $p |- ( A C_ B -> ~P A C_ ~P B ) $=
      ( vx wss cpw cv wcel wi wal cvv wvhc2 wtru vex vd01 idn1 elpwi el1 ancoms
      sstr el12 elpwgdedVD un0.1 int2 gen11 dfss2 biimpri in1 ) ABDZAEZBEZDZUHC
      FZUIGZULUJGZHZCIZUKUHUOCUHUMUNULJGZUHUMKZULBDZUNUQLCMNZUHUHULADZUSUMUHOUM
      UMVAUMOULAPQVAUHUSULABSRTZLURULBUTVBUAUBUCUDUKUPCUIUJUEUFQUG $.
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class is a subclass of another class, then its power class is a
       subclass of that other class's power class.  Left-to-right implication
       of Exercise 18 of [TakeutiZaring] p. 18. ~ sspwimpcf , using
       conventional notation, was translated from its virtual deduction form,
       ~ sspwimpcfVD , using a translation program.  (Contributed by Alan Sare,
       13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sspwimpcf $p |- ( A C_ B -> ~P A C_ ~P B ) $=
      ( vx wss cpw cv wcel wi wal cvv vex elpwi syl sstr2 impcom syl2an biimpar
      id elpwg eel021old ex alrimiv dfss2 biimpri iin1 ) ABDZAEZBEZDZUFCFZUGGZU
      JUHGZHZCIZUIUFUMCUFUKULUJJGZUFUKUJBDZULCKUFUFUJADZUPUKUFRUKUKUQUKRUJALMUQ
      UFUPUJABNOPUOULUPUJBJSQTUAUBUIUNCUGUHUCUDMUE $.
  $}

  ${
    $d x A $.  $d x B $.
    $( The following User's Proof is a Virtual Deduction proof ( see: ~ wvd1 )
       using conjunction-form virtual hypothesis collections.  It was completed
       automatically by a tools program which would invokes Mel O'Cat's mmj2
       and Norm Megill's Metamath Proof Assistant. ~ sspwimpcf is ~ sspwimpcfVD
       without virtual deductions and was derived from ~ sspwimpcfVD . The
       version of completeusersproof.cmd used is capable of only generating
       conjunction-form unification theorems, not unification deductions.
       (Contributed by Alan Sare, 13-Jun-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::    <TD> ` |- (.    A C_ B ->. A C_ B ). `
       <TR> <TD> 2::    <TD> ` |- (. `  ........... ` x e. ~P A `
       `->. x e. ~P A ). `
       <TR> <TD> 3:2:   <TD> ` |- (. `  ........... ` x e. ~P A `
       ` ->. x C_ A ). `
       <TR> <TD> 4:3,1: <TD> ` |- (. (. A C_ B ,. x e. ~P A ). ->. x C_ B ). `
       <TR> <TD> 5::    <TD> ` |- x e. _V `
       <TR> <TD> 6:4,5: <TD> ` |- (. (. A C_ B ,. x e. ~P A ). ->. x e. ~P B `
       ` ). `
       <TR> <TD> 7:6:   <TD> ` |- (.    A C_ B ->. ( x e. ~P A -> x e. ~P B ) `
       ` ). `
       <TR> <TD> 8:7:   <TD> ` |- (.    A C_ B ->. A. x ( x e. ~P A -> x e. `
       ` ~P B ) ). `
       <TR> <TD> 9:8:   <TD> ` |- (.    A C_ B ->. ~P A C_ ~P B ). `
       <TR> <TD> qed:9: <TD> ` |- ( A C_ B -> ~P A C_ ~P B ) `
       </TABLE> </HTML> $)
    sspwimpcfVD $p |- ( A C_ B -> ~P A C_ ~P B ) $=
      ( vx wss cpw cv wcel wal cvv vex idn1 elpwi el1 sstr2 impcom el12 biimpar
      wi elpwg el021old int2 gen11 dfss2 biimpri in1 ) ABDZAEZBEZDZUFCFZUGGZUJU
      HGZRZCHZUIUFUMCUFUKULUJIGZUFUKUJBDZULCJUFUFUJADZUPUKUFKUKUKUQUKKUJALMUQUF
      UPUJABNOPUOULUPUJBISQTUAUBUIUNCUGUHUCUDMUE $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y A $.
    $( The sucessor of a transitive class is transitive. ~ suctrALTcf , using
       conventional notation, was translated from virtual deduction form,
       ~ suctrALTcfVD , using a translation program.  (Contributed by Alan
       Sare, 13-Jun-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    suctrALTcf $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr csuc cv wcel wa wi wal wceq wo wss sssucid id syl trel 3impib
      simpl ex syl3an ssel2 eel0321old 3expia eleq2 biimpac syl2an simpr elsuci
      eel021old jao 3imp eel2122old alrimivv dftr2 biimpri iin1 ) ADZAEZDZURBFZ
      CFZGZVBUSGZHZVAUSGZIZCJBJZUTURVGBCURVEVFURVEVBAGZVFIZVBAKZVFIZVIVKLZVFURV
      EVIVFAUSMZURVEVIVAAGZVFANZURURVEVCVIVIVOUROVEVEVCVEOZVCVDSPZVIOURVCVIVOAV
      AVBQRUAAUSVAUBZUCUDVEVKVFVNVEVKVOVFVPVEVCVKVOVKVRVKOVKVCVOVBAVAUEUFUGVSUJ
      TVEVDVMVEVEVDVQVCVDUHPVBAUIPVJVLVMVFVIVFVKUKULUMTUNUTVHBCUSUOUPPUQ $.
  $}

  ${
    $d z A $.  $d y A $.  $d z y A $.
    $( The following User's Proof is a Virtual Deduction proof ( see: ~ wvd1 )
       using conjunction-form virtual hypothesis collections. The
       conjunction-form version of completeusersproof.cmd. It allows the User
       to avoid superflous virtual hypotheses. This proof was completed
       automatically by a tools program which invokes Mel O'Cat's
       mmj2 and Norm Megill's Metamath Proof Assistant. ~ suctrALTcf
       is ~ suctrALTcfVD without virtual deductions and was derived
       automatically from ~ suctrALTcfVD . The version of
       completeusersproof.cmd used is capable of only generating
       conjunction-form unification theorems, not unification deductions.
       (Contributed by Alan Sare, 13-Jun-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.)
       <HTML> <TABLE>
       <TR> <TD> 1::         <TD> ` |- (.    Tr A ->. Tr A ). `
       <TR> <TD> 2::         <TD> ` |- (. ` ......... ` ( z e. y /\ y e. `
       ` suc A ) ->. ( z e. y /\ y e. suc A ) ). `
       <TR> <TD> 3:2:        <TD> ` |- (. ` ......... ` ( z e. y /\ y e. `
       ` suc A )  ->. z e. y ). `
       <TR> <TD> 4::         <TD> ` |- (. ` ...................................
       ....... ` y e. A ->. y e. A ). `
       <TR> <TD> 5:1,3,4:    <TD> ` |- (. (. Tr A ,. ( z e. y /\ y e. suc A ) `
       ` , y e. A ). ->. z e. A ). `
       <TR> <TD> 6::         <TD> ` |- A C_ suc A `
       <TR> <TD> 7:5,6:      <TD> ` |- (. (. Tr A ,. ( z e. y /\ y e. suc A ) `
       ` , y e. A ). ->. z e. suc A ). `
       <TR> <TD> 8:7:        <TD> ` |- (. (. Tr A ,. ( z e. y /\ y e. suc A ) `
       ` ). ->. ( y e. A -> z e. suc A ) ). `
       <TR> <TD> 9::         <TD> ` |- (. ` ...................................
       ...... ` y = A ->. y = A ). `
       <TR> <TD> 10:3,9:     <TD> ` |- (. ` ........ ` (. ( z e. y /\ y e. `
       ` suc A ) , y = A ). ->. z e. A ). `
       <TR> <TD> 11:10,6:    <TD> ` |- (. ` ........ ` (. ( z e. y /\ y e. `
       ` suc A ) , y = A ). ->. z e. suc A ). `
       <TR> <TD> 12:11:      <TD> ` |- (. ` .......... ` ( z e. y /\ y e. `
       ` suc A ) ->. ( y = A -> z e. suc A ) ). `
       <TR> <TD> 13:2:       <TD> ` |- (. ` .......... ` ( z e. y /\ y e. `
       ` suc A )  ->. y e. suc A ). `
       <TR> <TD> 14:13:      <TD> ` |- (. ` .......... ` ( z e. y /\ y e. `
       ` suc A ) ->. ( y e. A \/ y = A ) ). `
       <TR> <TD> 15:8,12,14: <TD> ` |- (. (. Tr A ,. ( z e. y /\ y e. suc A ) `
       ` ). ->. z e. suc A ). `
       <TR> <TD> 16:15:      <TD> ` |- ` ` (. Tr A ->. ( ( z e. y /\ y e. `
       ` suc A ) -> z e. suc A ) ). `
       <TR> <TD> 17:16:      <TD> ` |- ` ` (. Tr A ->. A. z A. y ( ( z e. `
       ` y /\ y e. suc A ) -> z e. suc A ) ). `
       <TR> <TD> 18:17:      <TD> ` |- ` ` (. Tr A ->. Tr suc A ). `
       <TR> <TD> qed:18:     <TD> ` |- ( Tr A -> Tr suc A ) `
       </TABLE> </HTML> $)
    suctrALTcfVD $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr csuc cv wcel wa wi wal wceq wss sssucid idn1 simpl el1 3impib
      wo trel int2 el123 ssel2 el0321old int3 eleq2 biimpac el12 el021old simpr
      elsuci jao 3imp el2122old gen12 dftr2 biimpri in1 ) ADZAEZDZURBFZCFZGZVBU
      SGZHZVAUSGZIZCJBJZUTURVGBCURVEVFURVEVBAGZVFIZVBAKZVFIZVIVKRZVFURVEVIVFAUS
      LZURVEVIVAAGZVFAMZURURVEVCVIVIVOURNVEVEVCVENZVCVDOPZVINURVCVIVOAVAVBSQUAA
      USVAUBZUCUDVEVKVFVNVEVKVOVFVPVEVCVKVOVKVRVKNVKVCVOVBAVAUEUFUGVSUHTVEVDVMV
      EVEVDVQVCVDUIPVBAUJPVJVLVMVFVIVFVKUKULUMTUNUTVHBCUSUOUPPUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
    Theorems with VD proofs in conventional notation derived from VD proofs
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d z A $.  $d y A $.  $d z y A $.
    $( The successor of a transtive class is transitive. ~ suctrALT3 is the
       completed proof in conventional notation of the Virtual Deduction proof
       ~ http://www.virtualdeduction.com/suctralt3vd.html .  It was completed
       manually.  The potential for automated derivation from the VD proof
       exists.  See ~ wvd1 for a description of Virtual Deduction.  Some
       sub-theorems of the proof were completed using a unification deduction
       ( e.g. , the sub-theorem whose assertion is step 19 used ~ jaoded ).
       Unification deductions employ Mario Carneiro's metavariable concept.
       Some sub-theorems were completed using a unification theorem ( e.g. ,
       the sub-theorem whose assertion is step 24 used ~ dftr2 ) .
       (Contributed by Alan Sare, 3-Dec-2015.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    suctrALT3 $p |- ( Tr A -> Tr suc A ) $=
      ( vz vy wtr csuc wi cv wcel wa wal wceq w3a sssucid simpld trelded sseldi
      id 3expia ex syl eleq2 biimpac syl2an simprd elsuci jaoded alrimivv dftr2
      wo un2122 biimpri idi ) ADZAEZDZFUMBGZCGZHZUQUNHZIZUPUNHZFZCJBJZUOUMVBBCU
      MUTVAUMUTVAUMUTIUQAHZVAUTUQAKZUTUMUTVDVAUMUTVDLAUNUPAMZUMUTVDAUPUQUMQUTUR
      USUTQZNZVDQOPRUTVEVAUTVEIAUNUPVFUTURVEUPAHZVEVHVEQVEURVIUQAUPUAUBUCPSUTUS
      VDVEUIUTURUSVGUDUQAUETUFUJSUGUOVCBCUNUHUKTUL $.
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class is a subclass of another class, then its power class is a
       subclass of that other class's power class.  Left-to-right implication
       of Exercise 18 of [TakeutiZaring] p. 18. ~ sspwimpALT is the completed
       proof in conventional notation of the Virtual Deduction proof
       ~ http://www.virtualdeduction.com/sspwimpaltvd.html .  It was completed
       manually.  The potential for automated derivation from the VD proof
       exists.  See ~ wvd1 for a description of Virtual Deduction.  Some
       sub-theorems of the proof were completed using a unification deduction
       ( e.g. , the sub-theorem whose assertion is step 9 used ~ elpwgded ).
       Unification deductions employ Mario Carneiro's metavariable concept.
       Some sub-theorems were completed using a unification theorem ( e.g. ,
       the sub-theorem whose assertion is step 5 used ~ elpwi ) .  (Contributed
       by Alan Sare, 3-Dec-2015.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    sspwimpALT $p |- ( A C_ B -> ~P A C_ ~P B ) $=
      ( vx wss cpw wi cv wcel wal wa wtru cvv vex a1i id syl sylan9ssr elpwgded
      elpwi uunT1 ex alrimiv dfss2 biimpri idi ) ABDZAEZBEZDZFUFCGZUGHZUJUHHZFZ
      CIZUIUFUMCUFUKULUFUKJZULKUOUJBUJLHKCMNUKUFUJABUKUKUJADUKOUJASPUFOQRTUAUBU
      IUNCUGUHUCUDPUE $.
  $}

  ${
    $d q x A $.
    unisnALT.1 $e |- A e. _V $.
    $( A set equals the union of its singleton.  Theorem 8.2 of [Quine] p. 53.
       The User manually input on a mmj2 Proof Worksheet, without labels, all
       steps of ~ unisnALT except 1, 11, 15, 21, and 30.  With execution of the
       mmj2 unification command, mmj2 could find labels for all steps except
       for 2, 12, 16, 22, and 31 (and the then non-existing steps 1, 11, 15,
       21, and 30) . mmj2 could not find reference theorems for those five
       steps because the hypothesis field of each of these steps was empty and
       none of those steps unifies with a theorem in set.mm.  Each of these
       five steps is a semantic variation of a theorem in set.mm and is 2-step
       provable. mmj2 does not have the ability to automatically generate the
       semantic variation in set.mm of a theorem in a mmj2 Proof Worksheet
       unless the theorem in the Proof Worksheet is labeled with a 1-hypothesis
       deduction whose hypothesis is a theorem in set.mm which unifies with the
       theorem in the Proof Worksheet.  The stepprover.c program, which invokes
       mmj2, has this capability. stepprover.c automatically generated steps 1,
       11, 15, 21, and 30, labeled all steps, and generated the RPN proof of
       ~ unisnALT .  Roughly speaking, stepprover.c added to the Proof
       Worksheet a labeled duplicate step of each non-unifying theorem for each
       label in a text file, labels.txt, containing a list of labels provided
       by the User.  Upon mmj2 unification, stepprover.c identified a label for
       each of the five theorems which 2-step proves it.  For ~ unisnALT , the
       label list is a list of all 1-hypothesis propositional calculus
       deductions in set.mm. stepproverp.c is the same as stepprover.c except
       that it intermittently pauses during execution, allowing the User to
       observe the changes to a text file caused by the execution of particular
       statements of the program.  (Contributed by Alan Sare, 19-Aug-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    unisnALT $p |- U. { A } = A $=
      ( vx vq csn cuni cv wcel wi wal wss wa biimpi id syl ax-gen ax-mp sylancl
      dfss2 biimpri eluni simpl simpr elsni eleq2 biimpac syl2anc 19.23v pm3.35
      wex wceq snid elunii eqssi ) AEZFZACGZUPHZUQAHZIZCJZUPAKZUTCURUQDGZHZVCUO
      HZLZDUJZVGUSIZUSURVGDUQUOUAMVFUSIZDJZVHVIDVFVDVCAUKZUSVFVFVDVFNZVDVEUBOVF
      VEVKVFVFVEVLVDVEUCOVCAUDOVKVDUSVCAUQUEUFUGPVJVHVFUSDUHMQVGUSUIRPVBVACUPAS
      TQUSURIZCJZAUPKZVMCUSUSAUOHURUSNABULUQAUOUMRPVOVNCAUPSTQUN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      Theorems with a proof in conventional notation automatically derived
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      by completeusersproof.c from a Virtual Deduction User's Proof
$)

  ${
    $( Converse of double negation.  Theorem *2.14 of [WhiteheadRussell]
       p. 102.  Proof derived by completeusersproof.c from User's Proof in
       VirtualDeductionProofs.txt.  (Contributed by Alan Sare, 11-Sep-2016.) $)
    notnot2ALT2 $p |- ( -. -. ph -> ph ) $=
      ( notnot2 ) AB $.
  $}

  ${
    $d x A $.  $d x B $.
    $( If a class is a subclass of another class, then its power class is a
       subclass of that other class's power class.  Left-to-right implication
       of Exercise 18 of [TakeutiZaring] p. 18.  Proof derived by
       completeusersproof.c from User's Proof in VirtualDeductionProofs.txt.
       The User's Proof in html format is displayed in
       ~ http://www.virtualdeduction.com/sspwimpaltvd.html .  (Contributed by
       Alan Sare, 11-Sep-2016.) $)
    sspwimpALT2 $p |- ( A C_ B -> ~P A C_ ~P B ) $=
      ( vx wss cpw cv wa cvv vex elpwi id sylan9ssr elpwg biimpar sylancr ssrdv
      wcel ex ) ABDZCAEZBEZSCFZTQZUBUAQZSUCGUBHQZUBBDZUDCIUCSUBABUBAJSKLUEUDUFU
      BBHMNORP $.
  $}

  ${
    $( Absorption of an existential quantifier of a double existential
       quantifier of non-distinct variables.  The proof is derived by
       completeusersproof.c from User's Proof in VirtualDeductionProofs.txt.
       The User's Proof in html format is displayed in ~ e2ebindVD .
       (Contributed by Alan Sare, 11-Sep-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    e2ebindALT $p |- ( A. x x = y -> ( E. x E. y ph <-> E. y ph ) ) $=
      ( weq wal wex wb ax10 nfe1 19.9 excom nfa1 id a1i drex1 syl alrimi impcom
      biid sylancr exbi bitr ex bitr3 ) BCDBECBDZCEZACFZBFZUGGZBCHUFUGCFZUGGZUJ
      UHGZUIUGCACIJUFABFZCFZUHGZUJUNGZULACBKUFUGUMGZCEUPUFUQCUECLUFUFUQUFMAACBA
      AGUFASNOPQUGUMCUAPUPUOULUPUOULUJUNUHUBUCRTULUKUIUJUHUGUDRTP $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x z $.  $d y z $.
    $( If at least two sets exist ( ~ dtru ) , then the same is true expressed
       in an alternate form similar to the form of ~ a9e .  The proof is
       derived by completeusersproof.c from User's Proof in
       VirtualDeductionProofs.txt.  The User's Proof in html format is
       displayed in ~ a9e2ndVD .  (Contributed by Alan Sare, 11-Sep-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    a9e2ndALT $p |- ( -. A. x x = y -> E. x E. y ( x = u /\ y = v ) ) $=
      ( vz cv wceq wal wn wa wex wi cvv wcel ax-mp id ax-17 syl idi alimi isset
      vex a9e pm3.2i 19.42v biimpri anbi1i exbii mpbi hbnae hbn1 wb equequ1 a1i
      dvelimh 19.41rg exim pm3.35 sylancr excomim ) AFZBFZGZAHIZVADFZGZVBCFZGZJ
      ZBKAKZLVDVIAKZBKZVJVDVFAKZVHJZBKZVOVLLZVLVEMNZVHJZBKZVOVQVHBKZJZVSVQVTDUB
      BCUCUDVSWAVQVHBUEUFOVRVNBVQVMVHAVEUAUGUHUIVDVNVKLZBHZVPVDVDWCVDPZVDVDBHWC
      ABBUJVDWBBVDWBLVDVHVHAHLZAHZWBVDVDWFWDVDVDAHWFVCAUKVDWEAVDWELVDVDWEWDEFZV
      GGZVHABEWHAQVHEQWGVBGZWILZWIWHVHULLZWIPWKWJEBCUMUNOUORSTRRVFVHAUPRSTRRVNV
      KBUQRVOVLURUSVIBAUTRS $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( "At least two sets exist" expressed in the form of ~ dtru is logically
       equivalent to the same expressed in a form similar to ~ a9e if ~ dtru is
       false implies ` u = v ` .  Proof derived by completeusersproof.c from
       User's Proof in VirtualDeductionProofs.txt.  The User's Proof in html
       format is displayed in ~ a9e2ndeqVD .  (Contributed by Alan Sare,
       11-Sep-2016.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    a9e2ndeqALT $p |- ( ( -. A. x x = y \/ u = v ) <->
                        E. x E. y ( x = u /\ y = v ) ) $=
      ( cv wceq wal wn wo wa wex wi jao mp3an wne nfa1 19.9 sp syl sylancr 3imp
      a9e2nd a9e2eq a1d exmid jaoi hbnae eximi sylib wb excom id simpr pm13.181
      nfn simpl ancoms eel121 neeq2 biimparc syl2anc df-ne bicomi con3i alrimiv
      sylbir exim imbi2 biimpa imbi1 biimpar pm3.34 orc imim2i idi ax-1 exmidne
      ex olc 3imp21 impbii ) AEZBEZFZAGZHZDEZCEZFZIZWBWGFZWCWHFZJZBKAKZWFWNWIAB
      CDUBZWEWIWNLZLZWFWPLZWEWFIZWPABCDUCWFWNWIWOUDWEUEWQWRWSWPWEWPWFMUANUFWGWH
      OZWNWJLZLZWIXALZWIWTIZXAXBWTWNWFLZXAWTWFBKZWFLWNXFLZXEXFWFBGZWFXFXHBKXHWF
      XHBABBUGUHXHBWFBPQUIWFBRSWTWNWMAKZBKZUJZXJXFLZXGWMABUKWTXIWFLZBGXLWTXMBWT
      WFAKZWFUJZXIXNLZXMWFAWEAWDAPUOQWTWMWFLZAGXPWTXQAWTWMWFWTWMJZWBWCOZWFXRWBW
      HOZWLXSWTWTWMWKXTWTULXRWMWKWTWMUMZWKWLUPSWKWTXTWBWGWHUNUQURXRWMWLYAWKWLUM
      SWLXSXTWCWHWBUSUTVAXSWDHZWFXSYBWBWCVBVCWEWDWDARVDVFSVRVEWMWFAVGSXOXPXMXNW
      FXIVHVITVEXIWFBVGSXKXGXLWNXJXFVJVKTWNXFWFVLTWFWJWNWFWIVMVNSVOXCWIWNWILZXA
      WIWIYCWIULWIWNVPSWIWJWNWIWFVSVNSVOWGWHVQXCXBXDXAWIXAWTMVTNWA $.
  $}

  ${
    $d u x $.  $d u y $.  $d v x $.  $d v y $.
    $( Equivalence for double substitution ~ 2sb5 without distinct ` x ` ,
       ` y ` requirement. ~ 2sb5nd is derived from ~ 2sb5ndVD .  The proof is
       derived by completeusersproof.c from User's Proof in
       VirtualDeductionProofs.txt.  The User's Proof in html format is
       displayed in ~ 2sb5ndVD .  (Contributed by Alan Sare, 19-Sep-2016.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    2sb5ndALT $p |- ( ( -. A. x x = y \/ u = v ) -> ( [ u / x ] [ v / y ] ph
                 <-> E. x E. y ( ( x = u /\ y = v ) /\ ph ) ) ) $=
      ( cv wceq wal wn wa wex wsb wb wi exbii hbs1 id syl sylancr 19.41 wo sbi1
      a9e2ndeq anabs5 2pm13.193 ax10o sbt ax-mp ax10 con3i sbal2 imbi2 biimpa21
      pm3.33 pm2.61i nfi bitr3i nfs1v bitr2i anbi2i pm5.32 mpbir sylbi ) BFZCFZ
      GBHZIZEFZDFZGUAVDVHGVEVIGJZCKZBKZACDLZBELZVJAJZCKZBKZMZBCDEUCVLVRNVLVNJZV
      LVQJZMVSVLVSJVTVLVNUDVSVQVLVQVKVNJZBKVSVPWABVPVJVNJZCKWAWBVOCABCDEUEOVJVN
      CVNCVFVNVNCHZNZVFVNVNBHZNWEWCNZWDVMBEPVFVFWFVFQVNBCUFRVNWEWCUNSVGVNVMCHZB
      ELZNZWHWCMZWDVMWGNZBELWIWKBEACDPUGVMWGBEUBUHVGVEVDGCHZIZWJVGVGWMVGQWLVFCB
      UIUJRVMCBEUKRWJWIWDWHWCVNULUMSUOUPTUQOVKVNBVMBEURTUSUTUQVLVNVQVAVBVC $.
  $}

  ${
    $d A v w x y $.  $d B v w x y $.  $d C v w x y $.  $d D v w x y $.
    $d F v w $.  $d ph v w $.  $d P v w x y $.
    chordthmALT.angdef $e |- F = ( x e. ( CC \ { 0 } ) , y e. ( CC \ { 0 } )
                                  |-> ( Im ` ( log ` ( y / x ) ) ) ) $.
    chordthmALT.A $e |- ( ph -> A e. CC ) $.
    chordthmALT.B $e |- ( ph -> B e. CC ) $.
    chordthmALT.C $e |- ( ph -> C e. CC ) $.
    chordthmALT.D $e |- ( ph -> D e. CC ) $.
    chordthmALT.P $e |- ( ph -> P e. CC ) $.
    chordthmALT.AneP $e |- ( ph -> A =/= P ) $.
    chordthmALT.BneP $e |- ( ph -> B =/= P ) $.
    chordthmALT.CneP $e |- ( ph -> C =/= P ) $.
    chordthmALT.DneP $e |- ( ph -> D =/= P ) $.
    chordthmALT.APB $e |- ( ph -> ( ( A - P ) F ( B - P ) ) = pi ) $.
    chordthmALT.CPD $e |- ( ph -> ( ( C - P ) F ( D - P ) ) = pi ) $.
    chordthmALT.Q $e |- ( ph -> Q e. CC ) $.
    chordthmALT.ABcirc $e |- ( ph -> ( abs ` ( A - Q ) ) =
                              ( abs ` ( B - Q ) ) ) $.
    chordthmALT.ACcirc $e |- ( ph -> ( abs ` ( A - Q ) ) =
                              ( abs ` ( C - Q ) ) ) $.
    chordthmALT.ADcirc $e |- ( ph -> ( abs ` ( A - Q ) ) =
                              ( abs ` ( D - Q ) ) ) $.
    $( The intersecting chords theorem. If points A, B, C, and D lie on a
       circle (with center Q, say), and the point P is on the interior of the
       segments AB and CD, then the two products of lengths PA ` x. ` PB and
       PC ` x. ` PD are equal. The Euclidean plane is identified with the
       complex plane, and the fact that P is on AB and on CD is expressed by
       the hypothesis that the angles APB and CPD are equal to ` pi ` . The
       result is proven by using ~ chordthmlem5 twice to show that PA
       ` x. ` PB and PC ` x. ` PD both equal BQ<HTML><sup>2</sup></HTML> ` - `
       PQ<HTML><sup>2</sup></HTML>. This is similar to the proof of the
       theorem given in Euclid's Elements_, where it is Proposition III.35.
       Proven by David Moews on 28-Feb-2017 as ~ chordthm .
       ~ http://www.virtualdeduction.com/chordthmaltvd.html is a Virtual
       Deduction User's Proof transcription of ~ chordthm . That VD User's
       Proof was input into completeusersproof, automatically generating this
       ~ chordthmALT Metamath proof.  (Contributed by Alan Sare, 19-Sep-2017.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    chordthmALT $p |- ( ph -> ( ( abs ` ( P - A ) ) x.
                       ( abs ` ( P - B ) ) ) = ( ( abs ` ( P - C ) ) x.
                       ( abs ` ( P - D ) ) ) ) $=
      ( vv vw cv cc0 c1 cioo co wcel cmul cmin caddc wceq wex cabs cfv wrex cpi
      wa necomd angpieqvd mpbid df-rex biimpi syl adantr w3a cexp eqtr3d oveq1d
      c2 3ad2ant1 cc cicc ioossicc 3ad2ant2 3ad2ant3 chordthmlem5 3expb 3adant2
      id sseldi 3adant3 3eqtr4d 3expia exlimdv mpd ex ) AUGUIZUJUKULUMZUNZHWNFU
      OUMUKWNUPUMGUOUMUQUMURZVDZUGUSZHDUPUMUTVAHEUPUMUTVAUOUMZHFUPUMUTVAHGUPUMU
      TVAUOUMZURZAWQUGWOVBZWSAFHUPUMGHUPUMJUMVCURXCUBABCUGFHGJKNPOSAGHTVEVFVGXC
      WSWQUGWOVHVIVJAWRXBUGAWRXBAWRVDZUHUIZWOUNZHXEDUOUMUKXEUPUMEUOUMUQUMURZVDZ
      UHUSZXBAXIWRAXGUHWOVBZXIADHUPUMEHUPUMJUMVCURXJUAABCUHDHEJKLPMQAEHRVEVFVGX
      JXIXGUHWOVHVIVJVKXDXHXBUHAWRXHXBAWRXHVLEIUPUMUTVAZVPVMUMZHIUPUMUTVAVPVMUM
      ZUPUMZGIUPUMUTVAZVPVMUMZXMUPUMZWTXAAWRXNXQURXHAXLXPXMUPAXKXOVPVMADIUPUMUT
      VAZXKXOUDUFVNVOVOVQAXHWTXNURZWRAXFXGXSAXFXGVLDEHIXEAXFDVRUNXGLVQAXFEVRUNX
      GMVQAXFIVRUNZXGUCVQXFAXEUJUKVSUMZUNXGXFWOYAXEUJUKVTZXFWFWGWAXGAXGXFXGWFWB
      AXFXRXKURXGUDVQWCWDWEAWRXAXQURZXHAWPWQYCAWPWQVLFGHIWNAWPFVRUNWQNVQAWPGVRU
      NWQOVQAWPXTWQUCVQWPAWNYAUNWQWPWOYAWNYBWPWFWGWAWQAWQWPWQWFWBAWPFIUPUMUTVAZ
      XOURWQAXRYDXOUEUFVNVQWCWDWHWIWJWKWLWMWKWL $.
  $}

  ${
    $( Lemma for ~ isosctr .  This proof was automatically derived by
       completeusersproof from its Virtual Deduction proof counterpart
       ~ http://www.virtualdeduction.com/isosctrlem1altvd.html .  As it is
       verified by the Metamath program, ~ isosctrlem1ALT verifies
       ~ http://www.virtualdeduction.com/isosctrlem1altvd.html .  (Contributed
       by Alan Sare, 22-Apr-2018.) $)
    isosctrlem1ALT $p |- ( ( A e. CC /\ ( abs ` A ) = 1 /\ -. 1 = A ) ->
                         ( Im ` ( log ` ( 1 - A ) ) ) =/= pi ) $=
      ( cc wcel cfv c1 wceq cmin co cpi cr wa ax-1cn a1i adantr cc0 wi idi pire
      cle wbr cabs wn w3a clog cim subcld wne subeq0 biimpd sylancr con3d df-ne
      id biimpri syl6 imp logcld imcld 3adant2 cdiv 2re 2ne0 redivcli cneg cicc
      c2 cxr renegcli rexri cre recld recnd subidd ax-mp releabsd adantl lesub1
      1re breqtrd 3impcombi eel0121 eqbrtrrd wtru rered trud oveq1 eqcomd resub
      syl5eq argrege0 3coml 3com13 eel12131 iccleub eel001 clt crp pipos elrpii
      rphalflt lelttrd ltned ) ABCZAUADZEFZEAFZUBZUCZEAGHZUDDZUEDZIXCXGXKJCXEXC
      XGKZXJXLXIXCXIBCZXGXCEAEBCZXCLMXCUMZUFZNXCXGXIOUGZXCXGXIOFZUBZXQXCXRXFXCX
      NXCXRXFPZLXOXNXCKZXTPYAXRXFEAUHUIQUJUKXQXSXIOULUNUOUPZUQURUSZXHXKIVFUTHZI
      YCYDJCXHIVFRVAVBVCZMIJCXHRMYDVDZVGCYDVGCXHXKYFYDVEHCZXKYDSTYFYDYEVHVIYDYE
      VIXCXMXEOXIVJDZSTZXGXQYGXPXCXEKZOEAVJDZGHZYHSYJYKYKGHZOYLSXCYMOFXEXCYKXCY
      KXCAXOVKZVLVMNEJCZXCYKJCZXEYKESTZYMYLSTZXNYOLYOXNVRMVNZYNYJYKXDESXCYKXDST
      XEXCAXOVONXEXEXCXEUMVPVSYOYPYQUCYRPYPYOYQYRYKEYKVQVTQWAWBXCYLYHFXEXCYLEVJ
      DZYKGHZYHYTEFZYLUUAFUUBWCEYOWCYSMWDWEUUBUUAYLYTEYKGWFWGVNXCXNXCUUAYHFZLXO
      YAUUCPYAYHUUAEAWHWGQUJWINVSYBXQYIXMYGXMXQYIYGXIWJWKWLWMYFYDXKWNWOYDIWPTZX
      HIWQCUUDIRWRWSIWTVNMXAXB $.
  $}

  ${
    $d k u v ph $.  $d k u w $.  $d A k $.  $d A u $.  $d A v $.  $d A w $.
    $d B u $.  $d B v $.  $d B w $.  $d J k $.  $d J u $.  $d J v $.  $d P k $.
    $d X k $.  $d X u $.  $d X v $.
    iunconlem2.1 $e |- ( ps <-> ( ( ( ( ( ( ph /\ u e. J ) /\ v e. J ) /\
    ( u i^i U_ k e. A B ) =/= (/) ) /\ ( v i^i U_ k e. A B ) =/= (/) ) /\
    ( u i^i v ) C_ ( X \ U_ k e. A B ) ) /\ U_ k e. A B C_ ( u u. v ) ) ) $.
    iunconlem2.2 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    iunconlem2.3 $e |- ( ( ph /\ k e. A ) -> B C_ X ) $.
    iunconlem2.4 $e |- ( ( ph /\ k e. A ) -> P e. B ) $.
    iunconlem2.5 $e |- ( ( ph /\ k e. A ) -> ( J |`t B ) e. Con ) $.
    $( The indexed union of connected overlapping subspaces sharing a common
       point is connected.  This proof was automatically derived by
       completeusersproof from its Virtual Deduction proof counterpart
       ~ http://www.virtualdeduction.com/iunconlem2vd.html .  As it is verified
       by the Metamath program, ~ iunconlem2 verifies
       ~ http://www.virtualdeduction.com/iunconlem2vd.html .  (Contributed by
       Alan Sare, 22-Apr-2018.) $)
    iunconlem2 $p |- ( ph -> ( J |`t U_ k e. A B ) e. Con ) $=
      ( wcel c0 syl wa nfcv vw ctopon cfv ciun wss cv cin wne cdif w3a cun wral
      wn wi crest co ccon ralrimiv iunss biimpri biimpi simprd wrex wex simp-4r
      ex wo n0 inss2 id sseldi eliun rexn0 exlimiv wnf nfv nfan nfiu1 nfin nfne
      nfdif nfss nfbii mpbir simp-6l sylan ralrimi r19.2z ancoms syl2anc sseldd
      elun sylbir simp-6r simp-5r simpllr simplr iunconlem incom syl5eqss uncom
      syl6sseqr pm4.56 idi pm2.65da ex3 3impd 3expia ralrimivv connsub biimp3ar
      imp3a syl3anc ) AIJUBUCPZHEFUDZJUEZDUFZXOUGZQUHZCUFZXOUGZQUHZXQXTUGZJXOUI
      ZUEZUJXOXQXTUKZUEZUMZUNZCIULDIULZIXOUOUPUQPZLAFJUEZHEULZXPAYLHEAHUFEPZYLM
      VFURXPYMHEFJUSUTRAYIDCIIAXQIPZXTIPZYIAYOYPYIUNAYOYPYIAYOYPUJXSYBYEYHAYOYP
      XSYBYEYHUNZUNAYOSZYPSZXSSZYBYQYTYBSZYEYHUUAYESZYGGXQPZGXTPZVGZUUBYGSZBUUE
      KBGYFPZUUEBXOYFGBUUBYGBUUFKVAZVBZBGFPZHEVCZGXOPZBEQUHZUUJHEULZUUKBUAUFZXR
      PZUAVDZUUMBXSUUQBUUFXSUUHYSXSYBYEYGVERZXSUUQUAXRVHVARUUPUUMUAUUPUUOFPZHEV
      CZUUMUUPUUOXOPZUUTUUPXRXOUUOXQXOVIUUPVJVKUVAUUTHUUOEFVLVARUUSHEVMRVNRBUUJ
      HEBHVOUUFHVOUUBYGHUUAYEHYTYBHYSXSHYRYPHYRHVPYPHVPVQHXRQHXQXOHXQTHEFVRZVSH
      QTZVTVQHYAQHXTXOHXTTUVBVSUVCVTVQHYCYDHYCTHJXOHJTUVBWAWBVQHXOYFUVBHYFTWBVQ
      BUUFHKWCWDZBYNUUJBAYNUUJBUUFAUUHAYOYPXSYBYEYGWERZNWFZVFWGUUNUUMUUKUUMUUNU
      UKUUJHEWHWIWIWJUULUUKHGEFVLUTRWKUUGUUEGXQXTWLVARWMUUFBUUEUMZKBUUCUMZUUDUM
      ZUVGBEFGXQHIXTJBAXNUVELRZBAYNYLUVEMWFZUVFBAYNIFUOUPUQPUVEOWFZBUUFYOUUHAYO
      YPXSYBYEYGWNRZBUUFYPUUHYRYPXSYBYEYGWORZBUUFYBUUHYTYBYEYGWPRBUUFYEUUHUUAYE
      YGWQRZUUIUVDWRBEFGXTHIXQJUVJUVKUVFUVLUVNUVMUURBXTXQUGYCYDXTXQWSUVOWTBXOYF
      XTXQUKUUIXTXQXAXBUVDWRUVHUVISZUVGUNUVPUVGUUCUUDXCVAXDWJWMXEVFVFXFXGXHVFXL
      XIXNXPYKYJDCXOIJXJXKXM $.
  $}

  ${
    $d k u v ph $.  $d k u w $.  $d A k $.  $d A u $.  $d A v $.  $d A w $.
    $d B u $.  $d B v $.  $d B w $.  $d J k $.  $d J u $.  $d J v $.  $d P k $.
    $d X k $.  $d X u $.  $d X v $.
    iunconALT.1 $e |- ( ph -> J e. ( TopOn ` X ) ) $.
    iunconALT.2 $e |- ( ( ph /\ k e. A ) -> B C_ X ) $.
    iunconALT.3 $e |- ( ( ph /\ k e. A ) -> P e. B ) $.
    iunconALT.4 $e |- ( ( ph /\ k e. A ) -> ( J |`t B ) e. Con ) $.
    $( The indexed union of connected overlapping subspaces sharing a common
       point is connected.  This proof was automatically derived by
       completeusersproof from its Virtual Deduction proof counterpart
       ~ http://www.virtualdeduction.com/iunconaltvd.html .  As it is verified
       by the Metamath program, ~ iunconALT verifies
       ~ http://www.virtualdeduction.com/iunconaltvd.html .  (Contributed by
       Alan Sare, 22-Apr-2018.) $)
    iunconALT $p |- ( ph -> ( J |`t U_ k e. A B ) e. Con ) $=
      ( vu vv cv wcel wa cin c0 wne wss ciun cdif cun biid iunconlem2 ) AALNZFO
      PMNZFOPUFEBCUAZQRSPUGUHQRSPUFUGQGUHUBTPUHUFUGUCTPZMLBCDEFGUIUDHIJKUE $.
  $}

  ${
    $( A complex number whose sine is zero is an integer multiple of ` pi ` .
       The Virtual Deduction form of the proof is
       ~ http://www.virtualdeduction.com/sineq0altvd.html .  The Metamath form
       of the proof is ~ sineq0ALT .  The Virtual Deduction proof is based on
       Mario Carneiro's revision of Norm Megill's proof of ~ sineq0 .  The
       Virtual Deduction proof is verified by automatically transforming it
       into the Metamath form of the proof using completeusersproof, which is
       verified by the Metamath program.  The proof of
       ~ http://www.virtualdeduction.com/sineq0altro.html is a form of the
       completed proof which preserves the Virtual Deduction proof's step
       numbers and their ordering.  (Contributed by Alan Sare, 13-Jun-2018.) $)
    sineq0ALT $p |- ( A e. CC -> ( ( sin ` A ) = 0 <-> ( A / pi ) e. ZZ ) ) $=
      ( cc wcel csin cfv cc0 wceq cpi co wa c2 cmul adantr ci ce cabs c1 fveq2d
      a1i wn cdiv cz crp cr cmo pire pipos elrpii wne 2ne0 2cn 2re ax-mp mulcld
      id caddc axicn mul12d 2timesd eqtr3d efadd syl2anc eqtrd cneg cmin sinval
      sylan9req wb efcl syl negcli subcld mulcli ine0 mulne0i diveq0ad subeq0ad
      mpbid oveq2d eqtr4d negidi oveq1i adddird syl5reqr mul02d ef0 3eqtrd abs1
      syl6eq absefib biimparc ancoms eel121 mulre 4animp1 4an31 eel1111 clt wbr
      wo w3a modcld recnd sincld cfl cle 0re ltleii gt0ne0 3adant3 3com23 mp3an
      cioo redivcld flcld znegcld wi abssinper eqcomd mpd negcld recni mulneg1d
      ex zcnd mulcomd negeqd oveq2 ad3antrrr 4an4132 negsubd modval mpan2 rexri
      cxr notbii sylib sylancr biimp3a eel011 adantl abs00d notnot bicomi con3i
      abs0 ltne neneqd expcom mpi sylbir sinq12gt0 nsyl mp2an 3anan12 modlt jca
      elioo2 not12an2impnot1 modge0 leloe idi pm2.53 imp 3com12 divcan1d sinkpi
      mod0 impbid ) ABCZADEZFGZAHUAIZUBCZUVJUVLUVNHUCCZUVJUVLJZAUDCZAHUEIZFGZUV
      NHUFUGUHZUVPKFUIZKUDCZUVJKALIZUDCZUVQUWAUVPUJSUWBUVPKBCZUWBUKUWBUWEULSUMS
      UVJUVJUVLUVJUOZMZUVJUWCBCZUVLNUWCLIZOEZPEZQGZUWDUVJKAUWEUVJUKSZUWFUNUVPUW
      KQPEQUVPUWJQPUVPUWJNALIZOEZUWOLIZQUVJUWJUWPGUVLUVJUWJUWNUWNUPIZOEZUWPUVJU
      WIUWQOUVJKUWNLIUWIUWQUVJKNAUWMNBCUVJUQSZUWFURUVJUWNUVJNAUWSUWFUNZUSUTRUVJ
      UWNBCZUXAUWRUWPGUWTUWTUWNUWNVAVBVCMUVPUWPUWNNVDZALIZUPIZOEZFOEZQUVPUWPUWO
      UXCOEZLIZUXEUVPUWOUXGUWOLUVPUWOUXGVEIZFGZUWOUXGGZUVPUXIKNLIZUAIZFGZUXJUVJ
      UVLUXMUVKFAVFUVLUOZVGUVJUXNUXJVHUVLUVJUXIUXLUVJUWOUXGUVJUXAUWOBCUWTUWNVIV
      JZUVJUXCBCZUXGBCUVJUXBAUXBBCUVJNUQVKSZUWFUNZUXCVIVJZVLUXLBCUVJKNUKUQVMSUX
      LFUIUVJKNUKUQUJVNVOSVPMVRUVJUXJUXKVHUVLUVJUWOUXGUXPUXTVQMVRVSUVJUXEUXHGZU
      VLUVJUXAUXQUYAUWTUXSUWNUXCVAVBMVTUVJUXEUXFGUVLUVJUXDFOUVJUXDFALIZFUVJUYBN
      UXBUPIZALIUXDUYCFALNUQWAWBUVJNUXBAUWSUXRUWFWCWDUVJAUWFWEVCRMUXFQGUVPWFSWG
      VCRWHWIUWLUWHUWDUWHUWDUWLUWCWJWKWLWMUWAUWBUVJUWDUVQUVJUWBUWAUWDUVQAKWNWOW
      PWQZUVPFUVRUVPFUVRWRWSZTZUYEFUVRGZWTZUYGUVPUYEUVRUDCZUVRHWRWSZJZJZTZUYKUY
      FUVPUYIUYEUYJXAZTZUYMUVPUVRFHXMICZTUYOUVPFUVRDEZWRWSZUYPUVPUYQFGZUYRTZUVP
      UYQUVPUVRUVPUVRUVPAHUYDUVOUVPUVTSXBZXCXDUVPUVKPEZUYQPEZFUVPVUBAHUVMXEEZLI
      ZVEIZDEZPEZVUCUVPVUBAVUDVDZHLIZUPIZDEZPEZVUHUVPVUIUBCZVUBVUMGZUVPVUDUVPUV
      MUVPAHUYDHUDCZUVPUFSHFUIZUVPVUPFHXFWSZFHWRWSZVUQUFFHXGUFUGXHUGVUPVUSVURVU
      QVUPVUSVUQVURHXIXJXKXLZSXNXOZXPUVJVUNVUOXQUVLUVJVUNVUOUVJVUNJVUMVUBAVUIXR
      XSYDMXTUVPVULVUGPUVPVUKVUFDUVPVUKAVUEVDZUPIZVUFUVPUVJVUJBCZVVBBCZVUJVVBGZ
      VUKVVCGZUWGUVPVUIHUVPVUDUVPVUDVVAYEZYAHBCZUVPHUFYBZSZUNUVPVUEUVPHVUDVVKVV
      HUNZYAUVPVUJVUDHLIZVDVVBUVPVUDHVVHVVKYCUVPVVMVUEUVPVUDHVVHVVKYFYGVCUVJVVD
      VVEVVFVVGVVFVVGVVEVVDUVJVUJVVBAUPYHYIYJWQUVPAVUEUWGVVLYKVCRRVCUVPUVQVUCVU
      HGZUYDUVQUVOVVNUVTUVQUVOJZUYQVUGPVVOUVRVUFDAHYLRRYMVJVTUVLVUBFGUVJUVLVUBF
      PEFUVLUVKFPUXORUUFWIUUAUTUUBUYSUYSTZTZUYTUYSVVQUYSUUCUUDUYRVVPUYRFUDCZVVP
      XGVVRUYRVVPVVRUYRJUYQFFUYQUUGUUHUUIUUJUUEUUKVJUVRUULUUMUYPUYNFYOCHYOCUYPU
      YNVHFXGYNHUFYNFHUVRUURUUNYPYQUYNUYLUYIUYEUYJUUOYPYQUVPUYIUYJVUAUVPUVOUVQU
      YJUVTUYDUVQUVOUYJAHUUPWLYRUUQUYEUYKUUSVBVVRUVPUYIFUVRXFWSZUYHXGVUAUVPUVOU
      VQVVSUVTUYDUVQUVOVVSAHUUTWLYRVVRUYIVVSXAUYHXQVVRUYIVVSUYHFUVRUVAYSUVBYTUY
      HUYFUYGUYHUYFUYGUYEUYGUVCUVDWLVBXSUVQUVOUVSUVNUVQUVOUVSUVNAHUVHYSUVEYTYDU
      VJUVNUVLUVJUVNUVKUVMHLIZDEZFUVJVVTADUVJAHUWFVVIUVJVVJSVUQUVJVUTSUVFRUVNUV
      NVWAFGUVNUOUVMUVGVJVGYDUVI $.
  $}

$( (End of Alan Sare's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                  Mathbox for Jonathan Ben-Naim
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

Note:  On 4-Sep-2016 and after, 745 unused theorems were deleted from this
mathbox, and 359 theorems used only once or twice were merged into their
referencing theorems.  The originals can be recovered from set.mm versions
prior to this date.

$)


  $v ph' $.
  $v ps' $.
  $v ch' $.
  $v th' $.
  $v ta' $.
  $v et' $.
  $v ze' $.
  $v si' $.
  $v rh' $.

  $v ph" $.
  $v ps" $.
  $v ch" $.
  $v th" $.
  $v ta" $.
  $v et" $.
  $v ze" $.
  $v si" $.
  $v rh" $.

  $v ph0 $.
  $v ps0 $.
  $v ch0_ $. $( because ch0 is already used $)
  $v th0 $.
  $v ta0 $.
  $v et0 $.
  $v ze0 $.
  $v si0 $.
  $v rh0 $.

  $v ph1 $.
  $v ps1 $.
  $v ch1 $.
  $v th1 $.
  $v ta1 $.
  $v et1 $.
  $v ze1 $.
  $v si1 $.
  $v rh1 $.


  bnjwphm $f wff ph' $.
  bnjwpsm $f wff ps' $.
  bnjwchm $f wff ch' $.
  bnjwthm $f wff th' $.
  bnjwtam $f wff ta' $.
  bnjwetm $f wff et' $.
  bnjwzem $f wff ze' $.
  bnjwsim $f wff si' $.
  bnjwrhm $f wff rh' $.

  bnjwphn $f wff ph" $.
  bnjwpsn $f wff ps" $.
  bnjwchn $f wff ch" $.
  bnjwthn $f wff th" $.
  bnjwtan $f wff ta" $.
  bnjwetn $f wff et" $.
  bnjwzen $f wff ze" $.
  bnjwsin $f wff si" $.
  bnjwrhn $f wff rh" $.

  bnjwph0 $f wff ph0 $.
  bnjwps0 $f wff ps0 $.
  bnjwch0_ $f wff ch0_ $.
  bnjwth0 $f wff th0 $.
  bnjwta0 $f wff ta0 $.
  bnjwet0 $f wff et0 $.
  bnjwze0 $f wff ze0 $.
  bnjwsi0 $f wff si0 $.
  bnjwrh0 $f wff rh0 $.

  bnjwph1 $f wff ph1 $.
  bnjwps1 $f wff ps1 $.
  bnjwch1 $f wff ch1 $.
  bnjwth1 $f wff th1 $.
  bnjwta1 $f wff ta1 $.
  bnjwet1 $f wff et1 $.
  bnjwze1 $f wff ze1 $.
  bnjwsi1 $f wff si1 $.
  bnjwrh1 $f wff rh1 $.


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


  $v a' $.
  $v b' $.
  $v c' $.
  $v d' $.
  $v e' $.
  $v f' $.
  $v g' $.
  $v h' $.
  $v i' $.
  $v j' $.
  $v k' $.
  $v l' $.
  $v m' $.
  $v n' $.
  $v o'_ $.
  $v p' $.
  $v q' $.
  $v r' $.
  $v s'_ $.
  $v t' $.
  $v u' $.
  $v v'_ $.
  $v w' $.
  $v x' $.
  $v y' $.
  $v z' $.

  $v a" $.
  $v b" $.
  $v c" $.
  $v d" $.
  $v e" $.
  $v f" $.
  $v g" $.
  $v h" $.
  $v i" $.
  $v j" $.
  $v k" $.
  $v l" $.
  $v m" $.
  $v n" $.
  $v o"_ $.
  $v p" $.
  $v q" $.
  $v r" $.
  $v s"_ $.
  $v t" $.
  $v u" $.
  $v v"_ $.
  $v w" $.
  $v x" $.
  $v y" $.
  $v z" $.

  $v a0_ $.
  $v b0_ $.
  $v c0_ $. $( because c0 is already used $)
  $v d0 $.
  $v e0 $.
  $v f0_ $. $( because f0 is already used $)
  $v g0 $.
  $v h0 $.
  $v i0 $.
  $v j0 $.
  $v k0 $.
  $v l0 $.
  $v m0 $.
  $v n0_ $. $( because n0 is already used $)
  $v o0_ $. $( because o0 is already used $)
  $v p0 $.
  $v q0 $.
  $v r0 $.
  $v s0 $.
  $v t0 $.
  $v u0 $.
  $v v0 $.
  $v w0 $.
  $v x0 $.
  $v y0 $.
  $v z0 $.

  $v a1_ $.
  $v b1_ $.
  $v c1_ $. $( because c1 is already used $)
  $v d1 $.
  $v e1 $.
  $v f1 $.
  $v g1 $.
  $v h1 $.
  $v i1 $.
  $v j1 $.
  $v k1 $.
  $v l1 $.
  $v m1 $.
  $v n1 $.
  $v o1_ $. $( because o1 is already used $)
  $v p1 $.
  $v q1 $.
  $v r1 $.
  $v s1 $.
  $v t1 $.
  $v u1 $.
  $v v1 $.
  $v w1 $.
  $v x1 $.
  $v y1 $.
  $v z1 $.

  bnjvam $f set a' $.
  bnjvbm $f set b' $.
  bnjvcm $f set c' $.
  bnjvdm $f set d' $.
  bnjvem $f set e' $.
  bnjvfm $f set f' $.
  bnjvgm $f set g' $.
  bnjvhm $f set h' $.
  bnjvim $f set i' $.
  bnjvjm $f set j' $.
  bnjvkm $f set k' $.
  bnjvlm $f set l' $.
  bnjvmm $f set m' $.
  bnjvnm $f set n' $.
  bnjvom_ $f set o'_ $.
  bnjvpm $f set p' $.
  bnjvqm $f set q' $.
  bnjvrm $f set r' $.
  bnjvsm_ $f set s'_ $.
  bnjvtm $f set t' $.
  bnjvum $f set u' $.
  bnjvvm_ $f set v'_ $.
  bnjvwm $f set w' $.
  bnjvxm $f set x' $.
  bnjvym $f set y' $.
  bnjvzm $f set z' $.

  bnjvan $f set a" $.
  bnjvbn $f set b" $.
  bnjvcn $f set c" $.
  bnjvdn $f set d" $.
  bnjven $f set e" $.
  bnjvfn $f set f" $.
  bnjvgn $f set g" $.
  bnjvhn $f set h" $.
  bnjvin $f set i" $.
  bnjvjn $f set j" $.
  bnjvkn $f set k" $.
  bnjvln $f set l" $.
  bnjvmn $f set m" $.
  bnjvnn $f set n" $.
  bnjvon_ $f set o"_ $.
  bnjvpn $f set p" $.
  bnjvqn $f set q" $.
  bnjvrn $f set r" $.
  bnjvsn_ $f set s"_ $.
  bnjvtn $f set t" $.
  bnjvun $f set u" $.
  bnjvvn_ $f set v"_ $.
  bnjvwn $f set w" $.
  bnjvxn $f set x" $.
  bnjvyn $f set y" $.
  bnjvzn $f set z" $.

  bnjva0_ $f set a0_ $.
  bnjvb0_ $f set b0_ $.
  bnjvc0_ $f set c0_ $.
  bnjvd0 $f set d0 $.
  bnjve0 $f set e0 $.
  bnjvf0_ $f set f0_ $.
  bnjvg0 $f set g0 $.
  bnjvh0 $f set h0 $.
  bnjvi0 $f set i0 $.
  bnjvj0 $f set j0 $.
  bnjvk0 $f set k0 $.
  bnjvl0 $f set l0 $.
  bnjvm0 $f set m0 $.
  bnjvn0_ $f set n0_ $.
  bnjvo0_ $f set o0_ $.
  bnjvp0 $f set p0 $.
  bnjvq0 $f set q0 $.
  bnjvr0 $f set r0 $.
  bnjvs0 $f set s0 $.
  bnjvt0 $f set t0 $.
  bnjvu0 $f set u0 $.
  bnjvv0 $f set v0 $.
  bnjvw0 $f set w0 $.
  bnjvx0 $f set x0 $.
  bnjvy0 $f set y0 $.
  bnjvz0 $f set z0 $.

  bnjva1_ $f set a1_ $.
  bnjvb1_ $f set b1_ $.
  bnjvc1_ $f set c1_ $.
  bnjvd1 $f set d1 $.
  bnjve1 $f set e1 $.
  bnjvf1 $f set f1 $.
  bnjvg1 $f set g1 $.
  bnjvh1 $f set h1 $.
  bnjvi1 $f set i1 $.
  bnjvj1 $f set j1 $.
  bnjvk1 $f set k1 $.
  bnjvl1 $f set l1 $.
  bnjvm1 $f set m1 $.
  bnjvn1 $f set n1 $.
  bnjvo1_ $f set o1_ $.
  bnjvp1 $f set p1 $.
  bnjvq1 $f set q1 $.
  bnjvr1 $f set r1 $.
  bnjvs1 $f set s1 $.
  bnjvt1 $f set t1 $.
  bnjvu1 $f set u1 $.
  bnjvv1 $f set v1 $.
  bnjvw1 $f set w1 $.
  bnjvx1 $f set x1 $.
  bnjvy1 $f set y1 $.
  bnjvz1 $f set z1 $.


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


  $v A' $.
  $v B' $.
  $v C' $.
  $v D' $.
  $v E' $.
  $v F' $.
  $v G' $.
  $v H' $.
  $v I' $.
  $v J' $.
  $v K' $.
  $v L' $.
  $v M' $.
  $v N' $.
  $v O' $.
  $v P' $.
  $v Q' $.
  $v R' $.
  $v S' $.
  $v T' $.
  $v U' $.
  $v V' $.
  $v W' $.
  $v X' $.
  $v Y' $.
  $v Z' $.

  $v A" $.
  $v B" $.
  $v C" $.
  $v D" $.
  $v E" $.
  $v F" $.
  $v G" $.
  $v H" $.
  $v I" $.
  $v J" $.
  $v K" $.
  $v L" $.
  $v M" $.
  $v N" $.
  $v O" $.
  $v P" $.
  $v Q" $.
  $v R" $.
  $v S" $.
  $v T" $.
  $v U" $.
  $v V" $.
  $v W" $.
  $v X" $.
  $v Y" $.
  $v Z" $.

  $v A0 $.
  $v B0 $.
  $v C0 $.
  $v D0 $.
  $v E0 $.
  $v F0 $.
  $v G0 $.
  $v H0 $.
  $v I0 $.
  $v J0 $.
  $v K0 $.
  $v L0 $.
  $v M0 $.
  $v N0 $.
  $v O0 $.
  $v P0 $.
  $v Q0 $.
  $v R0 $.
  $v S0 $.
  $v T0 $.
  $v U0 $.
  $v V0 $.
  $v W0 $.
  $v X0 $.
  $v Y0 $.
  $v Z0 $.

  $v A1_ $. $( because A1 is already used $)
  $v B1_ $. $( because B1 is already used $)
  $v C1_ $. $( because C1 is already used $)
  $v D1_ $. $( because D1 is already used $)
  $v E1 $.
  $v F1_ $. $( because F1 is already used $)
  $v G1_ $. $( because G1 is already used $)
  $v H1_ $. $( because H1 is already used $)
  $v I1_ $. $( because I1 is already used $)
  $v J1 $.
  $v K1 $.
  $v L1_ $. $( because L1 is already used $)
  $v M1_ $. $( because M1 is already used $)
  $v N1 $.
  $v O1_ $. $( because O1 is already used $)
  $v P1 $.
  $v Q1 $.
  $v R1_ $. $( because R1 is already used $)
  $v S1_ $. $( because S1 is already used $)
  $v T1 $.
  $v U1 $.
  $v V1_ $. $( because V1 is already used $)
  $v W1 $.
  $v X1 $.
  $v Y1 $.
  $v Z1 $.

  bnjcAm $f class A' $.
  bnjcBm $f class B' $.
  bnjcCm $f class C' $.
  bnjcDm $f class D' $.
  bnjcEm $f class E' $.
  bnjcFm $f class F' $.
  bnjcGm $f class G' $.
  bnjcHm $f class H' $.
  bnjcIm $f class I' $.
  bnjcJm $f class J' $.
  bnjcKm $f class K' $.
  bnjcLm $f class L' $.
  bnjcMm $f class M' $.
  bnjcNm $f class N' $.
  bnjcOm $f class O' $.
  bnjcPm $f class P' $.
  bnjcQm $f class Q' $.
  bnjcRm $f class R' $.
  bnjcSm $f class S' $.
  bnjcTm $f class T' $.
  bnjcUm $f class U' $.
  bnjcVm $f class V' $.
  bnjcWm $f class W' $.
  bnjcXm $f class X' $.
  bnjcYm $f class Y' $.
  bnjcZm $f class Z' $.

  bnjcAn $f class A" $.
  bnjcBn $f class B" $.
  bnjcCn $f class C" $.
  bnjcDn $f class D" $.
  bnjcEn $f class E" $.
  bnjcFn $f class F" $.
  bnjcGn $f class G" $.
  bnjcHn $f class H" $.
  bnjcIn $f class I" $.
  bnjcJn $f class J" $.
  bnjcKn $f class K" $.
  bnjcLn $f class L" $.
  bnjcMn $f class M" $.
  bnjcNn $f class N" $.
  bnjcOn $f class O" $.
  bnjcPn $f class P" $.
  bnjcQn $f class Q" $.
  bnjcRn $f class R" $.
  bnjcSn $f class S" $.
  bnjcTn $f class T" $.
  bnjcUn $f class U" $.
  bnjcVn $f class V" $.
  bnjcWn $f class W" $.
  bnjcXn $f class X" $.
  bnjcYn $f class Y" $.
  bnjcZn $f class Z" $.

  bnjcA0 $f class A0 $.
  bnjcB0 $f class B0 $.
  bnjcC0 $f class C0 $.
  bnjcD0 $f class D0 $.
  bnjcE0 $f class E0 $.
  bnjcF0 $f class F0 $.
  bnjcG0 $f class G0 $.
  bnjcH0 $f class H0 $.
  bnjcI0 $f class I0 $.
  bnjcJ0 $f class J0 $.
  bnjcK0 $f class K0 $.
  bnjcL0 $f class L0 $.
  bnjcM0 $f class M0 $.
  bnjcN0 $f class N0 $.
  bnjcO0 $f class O0 $.
  bnjcP0 $f class P0 $.
  bnjcQ0 $f class Q0 $.
  bnjcR0 $f class R0 $.
  bnjcS0 $f class S0 $.
  bnjcT0 $f class T0 $.
  bnjcU0 $f class U0 $.
  bnjcV0 $f class V0 $.
  bnjcW0 $f class W0 $.
  bnjcX0 $f class X0 $.
  bnjcY0 $f class Y0 $.
  bnjcZ0 $f class Z0 $.

  bnjcA1 $f class A1_ $.
  bnjcB1 $f class B1_ $.
  bnjcC1 $f class C1_ $.
  bnjcD1 $f class D1_ $.
  bnjcE1 $f class E1 $.
  bnjcF1 $f class F1_ $.
  bnjcG1 $f class G1_ $.
  bnjcH1 $f class H1_ $.
  bnjcI1 $f class I1_ $.
  bnjcJ1 $f class J1 $.
  bnjcK1 $f class K1 $.
  bnjcL1 $f class L1_ $.
  bnjcM1 $f class M1_ $.
  bnjcN1 $f class N1 $.
  bnjcO1_ $f class O1_ $.
  bnjcP1 $f class P1 $.
  bnjcQ1 $f class Q1 $.
  bnjcR1_ $f class R1_ $.
  bnjcS1 $f class S1_ $.
  bnjcT1 $f class T1 $.
  bnjcU1 $f class U1 $.
  bnjcV1 $f class V1_ $.
  bnjcW1 $f class W1 $.
  bnjcX1 $f class X1 $.
  bnjcY1 $f class Y1 $.
  bnjcZ1 $f class Z1 $.


  $( Extend wff notation with the 4-way conjunction.
     (New usage is discouraged.) $)
  w-bnj17 $a wff ( ph /\ ps /\ ch /\ th ) $.

  ${
    $( Define the 4-way conjunction.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    df-bnj17 $a |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ( ph /\ ps /\ ch ) /\ th )
        ) $.
  $}


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


$( Function meta-constant representing the function giving:
   the class of all elements of ` A ` that are "smaller" than ` X ` according
   to ` R `. $)

  $c _pred $.

  $( Extend class notation with the function giving: the class of all elements
     of ` A ` that are "smaller" than ` X ` according to ` R ` .
     (New usage is discouraged.) $)
  c-bnj14 $a class _pred ( X , A , R ) $.

  ${
    $d X y $.  $d A y $.  $d R y $.
    $( Define the function giving: the class of all elements of ` A ` that are
       "smaller" than ` X ` according to ` R ` .  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    df-bnj14 $a |- _pred ( X , A , R ) = { y e. A | y R X } $.
  $}


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


$( Predicate meta-constant representing the following predicate:
   ` R ` is set-like on ` A `. $)

  $c _Se $.

  $( Extend wff notation with the following predicate: ` R ` is set-like on
     ` A ` .  (New usage is discouraged.) $)
  w-bnj13 $a wff R _Se A $.

  ${
    $d R x $.  $d A x $.
    $( Define the following predicate: ` R ` is set-like on ` A ` .
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    df-bnj13 $a |- ( R _Se A <-> A. x e. A _pred ( x , A , R ) e. _V ) $.
  $}


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


$( Predicate meta-constant representing the following predicate:
   ` R ` is both well-founded and set-like on ` A `. $)

  $c _FrSe $.

  $( Extend wff notation with the following predicate: ` R ` is both
     well-founded and set-like on ` A ` .  (New usage is discouraged.) $)
  w-bnj15 $a wff R _FrSe A $.

  ${
    $( Define the following predicate: ` R ` is both well-founded and set-like
       on ` A ` .  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    df-bnj15 $a |- ( R _FrSe A <-> ( R Fr A /\ R _Se A ) ) $.
  $}


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


$( Function meta-constant representing the function giving:
   the transitive closure of ` X ` in ` A ` by ` R `. $)

  $c _trCl $.

  $( Extend class notation with the function giving: the transitive closure of
     ` X ` in ` A ` by ` R ` .  (New usage is discouraged.) $)
  c-bnj18 $a class _trCl ( X , A , R ) $.

  ${
    $d X f n i y $.  $d A f n i y $.  $d R f n i y $.
    $( Define the function giving: the transitive closure of ` X ` in ` A ` by
       ` R ` .  This definition has been designed for facilitating verification
       that it is eliminable and that the $d restrictions are sound and
       complete.  For a more readable definition see ~ bnj882 .  (Contributed
       by Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    df-bnj18 $a |- _trCl ( X , A , R ) = U_ f e. { f | E. n e. ( om \ { (/) } )
        ( f Fn n /\ ( f ` (/) ) = _pred ( X , A , R ) /\ A. i e. om ( suc i e.
        n -> ( f ` suc i ) = U_ y e. ( f ` i ) _pred ( y , A , R ) ) ) } U_ i
        e. dom f ( f ` i ) $.
  $}


$( -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- $)


$( Predicate meta-constant representing the following predicate:
   ` B ` is transitive for ` A ` and ` R `. $)

  $c _TrFo $.

  $( Extend wff notation with the following predicate: ` B ` is transitive for
     ` A ` and ` R ` .  (New usage is discouraged.) $)
  w-bnj19 $a wff _TrFo ( B , A , R ) $.

  ${
    $d B x $.  $d A x $.  $d R x $.
    $( Define the following predicate: ` B ` is transitive for ` A ` and
       ` R ` .  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    df-bnj19 $a |- ( _TrFo ( B , A , R ) <-> A. x e. B _pred ( x , A , R ) C_ B
        ) $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              First order logic and set theory
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (Proof shortened by Andrew Salmon, 14-Jun-2011.)
     (New usage is discouraged.) $)
  bnj170 $p |- ( ( ph /\ ps /\ ch ) <-> ( ( ps /\ ch ) /\ ph ) ) $=
    ( w3a wa 3anrot df-3an bitri ) ABCDBCADBCEAEABCFBCAGH $.

  ${
    bnj240.1 $e |- ( ps -> ps' ) $.
    bnj240.2 $e |- ( ch -> ch' ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj240 $p |- ( ( ph /\ ps /\ ch ) -> ( ps' /\ ch' ) ) $=
      ( wa w3a 3ad2ant1 3ad2ant2 jca 3comr ) BCADEHBCAIDEBCDAFJCBEAGKLM $.
  $}

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj248 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ( ( ph /\ ps ) /\ ch ) /\ th
      ) ) $=
    ( w-bnj17 w3a wa df-bnj17 df-3an anbi1i bitri ) ABCDEABCFZDGABGCGZDGABCDHLM
    DABCIJK $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj250 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ph /\ ( ( ps /\ ch ) /\ th )
      ) ) $=
    ( w-bnj17 w3a wa df-bnj17 3anass anbi1i anass 3bitri ) ABCDEABCFZDGABCGZGZD
    GANDGGABCDHMODABCIJANDKL $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj251 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ph /\ ( ps /\ ( ch /\ th ) )
      ) ) $=
    ( w-bnj17 wa bnj250 anass anbi2i bitri ) ABCDEABCFDFZFABCDFFZFABCDGKLABCDHI
    J $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj252 $p |- ( ( ph /\ ps /\ ch /\ th )
      <-> ( ph /\ ( ps /\ ch /\ th ) ) ) $=
    ( w-bnj17 wa w3a bnj250 df-3an anbi2i bitr4i ) ABCDEABCFDFZFABCDGZFABCDHMLA
    BCDIJK $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj253 $p |- ( ( ph /\ ps /\ ch /\ th )
      <-> ( ( ph /\ ps ) /\ ch /\ th ) ) $=
    ( w-bnj17 wa w3a bnj248 df-3an bitr4i ) ABCDEABFZCFDFKCDGABCDHKCDIJ $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj255 $p |- ( ( ph /\ ps /\ ch /\ th )
      <-> ( ph /\ ps /\ ( ch /\ th ) ) ) $=
    ( w-bnj17 wa w3a bnj251 3anass bitr4i ) ABCDEABCDFZFFABKGABCDHABKIJ $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj256 $p |- ( ( ph /\ ps /\ ch /\ th )
      <-> ( ( ph /\ ps ) /\ ( ch /\ th ) ) ) $=
    ( w-bnj17 wa bnj248 anass bitri ) ABCDEABFZCFDFJCDFFABCDGJCDHI $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj257 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ph /\ ps /\ th /\ ch ) ) $=
    ( wa w-bnj17 ancom anbi2i bnj256 3bitr4i ) ABEZCDEZEKDCEZEABCDFABDCFLMKCDGH
    ABCDIABDCIJ $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj258 $p |- ( ( ph /\ ps /\ ch /\ th )
      <-> ( ( ph /\ ps /\ th ) /\ ch ) ) $=
    ( w-bnj17 w3a wa bnj257 df-bnj17 bitri ) ABCDEABDCEABDFCGABCDHABDCIJ $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj268 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ph /\ ch /\ ps /\ th ) ) $=
    ( w3a wa w-bnj17 3ancomb anbi1i df-bnj17 3bitr4i ) ABCEZDFACBEZDFABCDGACBDG
    LMDABCHIABCDJACBDJK $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj290 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ph /\ ch /\ th /\ ps ) ) $=
    ( w3a wa w-bnj17 3anrot anbi2i bnj252 3bitr4i ) ABCDEZFACDBEZFABCDGACDBGLMA
    BCDHIABCDJACDBJK $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj291 $p |- ( ( ph /\ ps /\ ch /\ th )
      <-> ( ( ph /\ ch /\ th ) /\ ps ) ) $=
    ( w-bnj17 w3a wa bnj290 df-bnj17 bitri ) ABCDEACDBEACDFBGABCDHACDBIJ $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj312 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ps /\ ph /\ ch /\ th ) ) $=
    ( w3a wa w-bnj17 3ancoma anbi1i df-bnj17 3bitr4i ) ABCEZDFBACEZDFABCDGBACDG
    LMDABCHIABCDJBACDJK $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (Proof shortened by Andrew Salmon, 14-Jun-2011.)
     (New usage is discouraged.) $)
  bnj334 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ch /\ ph /\ ps /\ th ) ) $=
    ( w-bnj17 bnj290 bnj257 bnj312 3bitri ) ABCDEACDBEACBDECABDEABCDFACDBGACBDH
    I $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (Proof shortened by Andrew Salmon, 14-Jun-2011.)
     (New usage is discouraged.) $)
  bnj345 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( th /\ ph /\ ps /\ ch ) ) $=
    ( w-bnj17 wa w3a bnj334 bnj250 3anass bitr4i 3anrev 3bitri ) ABCDECABDEZCAB
    FZDGZDABCEZABCDHNCODFFPCABDICODJKPDOCGZQCODLQDOCFFRDABCIDOCJKKM $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (Proof shortened by Andrew Salmon, 14-Jun-2011.)
     (New usage is discouraged.) $)
  bnj422 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ch /\ th /\ ph /\ ps ) ) $=
    ( w-bnj17 bnj345 bitri ) ABCDEDABCECDABEABCDFDABCFG $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj432 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ( ch /\ th ) /\ ( ph /\ ps )
      ) ) $=
    ( w-bnj17 wa bnj422 bnj256 bitri ) ABCDECDABECDFABFFABCDGCDABHI $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj446 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ( ps /\ ch /\ th ) /\ ph ) )
      $=
    ( w-bnj17 w3a wa bnj345 df-bnj17 bitr3i ) ABCDEBCDAEBCDFAGBCDAHBCDAIJ $.

  ${
    $d A x $.
    bnj21.1 $e |- B = { x e. A | ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj21 $p |- B C_ A $=
      ( crab ssrab2 eqsstri ) DABCFCEABCGH $.
  $}

  ${
    $d A x $.  $d A y z $.  $d B w y z $.  $d R v w y z $.
    bnj23.1 $e |- B = { x e. A | -. ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj23 $p |- ( A. z e. B -. z R y
        -> A. w e. A ( w R y -> [. w / x ]. ph ) ) $=
      ( cv wbr wn wral wsbc wi wcel wa cvv wb syl5bir vex sbcng ax-mp crab nfcv
      eleq2i elrabsf bitri weq breq1 notbid rspccv expdimp con4d ralrimiva ) DJ
      ZCJZHKZLZDGMZEJZUQHKZABVANZOEFUTVAFPZQZVCVBVCLZALZBVANZVEVBLZVARPVHVFSEUA
      ABVARUBUCUTVDVHVIVDVHQZVAGPZUTVIVKVAVGBFUDZPVJGVLVAIUFVGBVAFBFUEUGUHUSVID
      VAGDEUIURVBUPVAUQHUJUKULTUMTUNUO $.
  $}

  ${
    bnj31.1 $e |- ( ph -> E. x e. A ps ) $.
    bnj31.2 $e |- ( ps -> ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj31 $p |- ( ph -> E. x e. A ch ) $=
      ( wrex reximi syl ) ABDEHCDEHFBCDEGIJ $.
  $}

  ${
    $d A x y $.  $d x y $.  $d y z $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj62 $p |- ( [. z / x ]. x Fn A <-> z Fn A ) $=
      ( vy cv wfn wsbc vex fneq1 sbcie sbcbii sbcco 3bitr3i ) AEZCFZADEZGZDBEZG
      PCFZDRGOARGRCFZQSDROSAPDHCNPIJKOADRLSTDRBHCPRIJM $.

  $}

  ${
    $d Z w x $.  $d ph w $.  $d w x y $.
    bnj89.1 $e |- Z e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj89 $p |- ( [. Z / y ]. E! x ph <-> E! x [. Z / y ]. ph ) $=
      ( vw weq wal wex wsbc weu sbcex2 sbcal exbii cvv wcel sbcbig ax-mp df-eu
      wb sbcg bibi2i bitri albii 3bitri sbcbii 3bitr4i ) ABFGZTZBHZFIZCDJZACDJZ
      UHTZBHZFIZABKZCDJUMBKULUJCDJZFIUICDJZBHZFIUPUJFCDLURUTFUIBCDMNUTUOFUSUNBU
      SUMUHCDJZTZUNDOPZUSVBTEAUHCDOQRVAUHUMVCVAUHTEUHCDOUARUBUCUDNUEUQUKCDABFSU
      FUMBFSUG $.

  $}

  ${
    $d Y y $.  $d x y z $.
    bnj90.1 $e |- Y e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj90 $p |- ( [. Y / x ]. z Fn x <-> z Fn Y ) $=
      ( vy cvv wcel cv wfn wsbc wb fneq2 sbcie2g ax-mp ) CFGBHZAHZIZACJOCIZKDQO
      EHZIRAECFPSOLSCOLMN $.
  $}

  ${
    bnj101.1 $e |- E. x ph $.
    bnj101.2 $e |- ( ph -> ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj101 $p |- E. x ps $=
      ( eximii ) ABCDEF $.
  $}

  ${
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj105 $p |- 1o e. _V $=
      ( c1o c0 csn cvv df1o2 p0ex eqeltri ) ABCDEFG $.
  $}

  ${
    bnj115.1 $e |- ( et <-> A. n e. D ( ta -> th ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj115 $p |- ( et <-> A. n ( ( n e. D /\ ta ) -> th ) ) $=
      ( wi wral cv wcel wal wa df-ral impexp bicomi albii 3bitri ) CBAGZEDHEIDJ
      ZRGZEKSBLAGZEKFREDMTUAEUATSBANOPQ $.
  $}

  ${
    $d ps x $.
    bnj132.1 $e |- ( ph <-> E. x ( ps -> ch ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Andrew Salmon, 26-Jun-2011.)
       (New usage is discouraged.) $)
    bnj132 $p |- ( ph <-> ( ps -> E. x ch ) ) $=
      ( wi wex 19.37v bitri ) ABCFDGBCDGFEBCDHI $.
  $}

  ${
    bnj133.1 $e |- ( ph <-> E. x ps ) $.
    bnj133.2 $e |- ( ch <-> ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj133 $p |- ( ph <-> E. x ch ) $=
      ( wex exbii bitr4i ) ABDGCDGECBDFHI $.
  $}

  $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
     3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
     (New usage is discouraged.) $)
  bnj142 $p |- ( F Fn { A } -> ( u e. F -> u = <. A , ( F ` A ) >. ) ) $=
    ( csn wfn cv wcel cfv cop wceq cres fnresdm wss fnfun funressn syl eqsstr3d
    wfun sseld elsni syl6 ) CBDZEZAFZCGUDBBCHIZDZGUDUEJUCCUFUDUCCCUBKZUFUBCLUCC
    RUGUFMUBCNBCOPQSUDUETUA $.

  ${
    $d A u $.  $d F u $.
    bnj145.1 $e |- A e. _V $.
    bnj145.2 $e |- ( F ` A ) e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj145 $p |- ( F Fn { A } -> F = { <. A , ( F ` A ) >. } ) $=
      ( vu csn wfn cv wcel cfv cop wb wal wceq bnj142 wfun cdm wa df-fn sylibr
      snid eleq2 mpbiri anim2i sylbi funfvop syl syl5ibrcom impbid alrimiv elsn
      eleq1 bibi2i albii dfcleq ) BAFZGZEHZBIZURAABJKZFZIZLZEMZBVANUQUSURUTNZLZ
      EMVDUQVFEUQUSVEEABOUQUSVEUTBIZUQBPZABQZIZRZVGUQVHVIUPNZRVKBUPSVLVJVHVLVJA
      UPIACUAVIUPAUBUCUDUEABUFUGURUTBULUHUIUJVCVFEVBVEUSEUTUKUMUNTEBVAUOT $.
  $}

  ${
    bnj156.1 $e |- ( ze0 <-> ( f Fn 1o /\ ph' /\ ps' ) ) $.
    bnj156.2 $e |- ( ze1 <-> [. g / f ]. ze0 ) $.
    bnj156.3 $e |- ( ph1 <-> [. g / f ]. ph' ) $.
    bnj156.4 $e |- ( ps1 <-> [. g / f ]. ps' ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj156 $p |- ( ze1 <-> ( g Fn 1o /\ ph1 /\ ps1 ) ) $=
      ( cv wsbc c1o wfn w3a sbcbii bicomi bitri sbc3an bnj62 3anbi123i ) HEABMZ
      NZUDOPZFGQZJUEAMOPZCDQZAUDNZUGEUIAUDIRUJUHAUDNZCAUDNZDAUDNZQUGUHCDAUDUAUK
      UFULFUMGABOUBFULKSGUMLSUCTTT $.
  $}

  ${
    $d m p $.
    bnj158.1 $e |- D = ( om \ { (/) } ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj158 $p |- ( m e. D -> E. p e. om m = suc p ) $=
      ( cv wcel com c0 wne wa csuc wceq wrex csn cdif eldifsn bitri nnsuc sylbi
      eleq2i ) BEZAFZUAGFUAHIJZUACEKLCGMUBUAGHNOZFUCAUDUADTUAGHPQCUARS $.
  $}

  ${
    $d m n $.
    bnj168.1 $e |- D = ( om \ { (/) } ) $.
    $( First-order logic and set theory.  Revised to remove dependence on
       ~ ax-reg .  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)  (Revised by
       NM, 21-Dec-2016.)  (New usage is discouraged.) $)
    bnj168 $p |- ( ( n =/= 1o /\ n e. D ) -> E. m e. D n = suc m ) $=
      ( cv c1o wne wcel wa csuc wceq wex wrex com anim2i sylibr con0 syl sylib
      c0 bnj158 r19.42v neeq1 biimpac df-1o wb nnon 0elon suc11 sylancl syl5rbb
      eqeq2i necon3bid syl5ibr ancld reximia anass rexbii simpr df-rex csn cdif
      bnj31 eleq2i eldifsn bitr2i simprl jca eximi ) CEZFGZVJAHZIZBEZAHZVJVNJZK
      ZIZBLZVQBAMVMVNNHZVQVNTGZIZIZBLZVSVMWBBNMWDVMVKWBIZWBBNVMVKVQIZWAIZBNMZWE
      BNMVMWFBNMZWHVMVKVQBNMZIWIVLWJVKACBDUAOVKVQBNUBPWFWGBNVTWFWAWFWAVTVPFGZVQ
      VKWKVJVPFUCUDVTVNTVPFVPFKVPTJZKZVTVNTKZFWLVPUEULVTVNQHTQHWMWNUFVNUGUHVNTU
      IUJUKUMUNUOUPRWGWEBNVKVQWAUQURSVKWBUSVCWBBNUTSWCVRBWCVOVQWCVTWAIZVOWBWAVT
      VQWAUSOVOVNNTVAVBZHWOAWPVNDVDVNNTVEVFSVTVQWAVGVHVIRVQBAUTP $.
  $}

  ${
    bnj206.1 $e |- ( ph' <-> [. M / n ]. ph ) $.
    bnj206.2 $e |- ( ps' <-> [. M / n ]. ps ) $.
    bnj206.3 $e |- ( ch' <-> [. M / n ]. ch ) $.
    bnj206.4 $e |- M e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj206 $p |- ( [. M / n ]. ( ph /\ ps /\ ch )
         <-> ( ph' /\ ps' /\ ch' ) ) $=
      ( w3a wsbc sbc3an bicomi 3anbi123i bitri ) ABCMDENADENZBDENZCDENZMFGHMABC
      DEOSFTGUAHFSIPGTJPHUAKPQR $.
  $}

  ${
    bnj216.1 $e |- B e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj216 $p |- ( A = suc B -> B e. A ) $=
      ( csuc wceq wcel sucid eleq2 mpbiri ) ABDZEBAFBJFBCGAJBHI $.
  $}

  $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
     3-Jun-2011.)  (New usage is discouraged.) $)
  bnj219 $p |- ( n = suc m -> m _E n ) $=
    ( cv csuc wceq wel cep wbr vex bnj216 epel sylibr ) BCZACZDEABFNMGHMNAIJABK
    L $.

  ${
    $d C x $.
    bnj226.1 $e |- B C_ C $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj226 $p |- U_ x e. A B C_ C $=
      ( ciun wss wral rgenw iunss mpbir ) ABCFDGCDGZABHLABEIABCDJK $.
  $}

  ${
    bnj228.1 $e |- ( ph <-> A. x e. A ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Andrew Salmon, 9-Jul-2011.)
       (New usage is discouraged.) $)
    bnj228 $p |- ( ( x e. A /\ ph ) -> ps ) $=
      ( cv wcel wral wi rsp sylbi impcom ) ACFDGZBABCDHMBIEBCDJKL $.
  $}

  ${
    bnj519.1 $e |- A e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Revised by Mario Carneiro, 6-May-2015.)
       (New usage is discouraged.) $)
    bnj519 $p |- ( B e. _V -> Fun { <. A , B >. } ) $=
      ( cvv wcel cop csn wfun funsng mpan ) ADEBDEABFGHCABDDIJ $.
  $}

  ${
    $d A x $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj521 $p |- ( A i^i { A } ) = (/) $=
      ( vx csn cin c0 wne wn wceq cv wcel elirr elin elsn eleq1 biimpac sylan2b
      wex wa sylbi exlimiv mto n0 mtbir nne mpbi ) AACZDZEFZGUGEHUHBIZUGJZBQZUK
      AAJZAKUJULBUJUIAJZUIUFJZRULUIAUFLUNUMUIAHZULBAMUOUMULUIAANOPSTUABUGUBUCUG
      EUDUE $.
  $}

  ${
    bnj524.1 $e |- ( ph <-> ps ) $.
    bnj524.2 $e |- A e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj524 $p |- ( [. A / x ]. ph <-> [. A / x ]. ps ) $=
      ( sbcbii ) ABCDEG $.
  $}

  ${
    $d ph x $.
    bnj525.1 $e |- A e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj525 $p |- ( [. A / x ]. ph <-> ph ) $=
      ( cvv wcel wsbc wb sbcg ax-mp ) CEFABCGAHDABCEIJ $.
  $}

  ${
    $d ps x $.
    bnj534.1 $e |- ( ch -> ( E. x ph /\ ps ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj534 $p |- ( ch -> E. x ( ph /\ ps ) ) $=
      ( wex wa 19.41v sylibr ) CADFBGABGDFEABDHI $.
  $}

  ${
    $d A x $.  $d B y $.  $d x y $.
    bnj538.1 $e |- A e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj538 $p |- ( [. A / y ]. A. x e. B ph
          <-> A. x e. B [. A / y ]. ph ) $=
      ( wral wsbc cv wcel wi wal df-ral sbcbii cvv wb sbcimg ax-mp bnj525 bitri
      imbi1i albii sbcal 3bitr4i ) ABEGZCDHBIEJZAKZBLZCDHZACDHZBEGZUEUHCDABEMNU
      GCDHZBLUFUJKZBLUIUKULUMBULUFCDHZUJKZUMDOJULUOPFUFACDOQRUNUFUJUFCDFSUATUBU
      GBCDUCUJBEMUDT $.
  $}

  ${
    bnj529.1 $e |- D = ( om \ { (/) } ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj529 $p |- ( M e. D -> (/) e. M ) $=
      ( wcel com c0 wne wa word csn eldifsn biimpi eleq2s nnord anim1i ord0eln0
      cdif biimpar 3syl ) BADBEDZBFGZHZBIZUAHFBDZUBBEFJQZABUEDUBBEFKLCMTUCUABNO
      UCUDUABPRS $.
  $}

  $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
     3-Jun-2011.)  (New usage is discouraged.) $)
  bnj551 $p |- ( ( m = suc p /\ m = suc i ) -> p = i ) $=
    ( cv csuc wceq wa eqtr2 suc11reg sylib ) BDZCDZEZFKADZEZFGMOFLNFKMOHLNIJ $.

  ${
    bnj563.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj563.21 $e |- ( rh <-> ( i e. om /\ suc i e. n /\ m =/= suc i ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj563 $p |- ( ( et /\ rh ) -> suc i e. m ) $=
      ( cv csuc wceq wcel wne wa com w-bnj17 w3a bnj312 wo bnj252 bitri simplbi
      sylbi simp2bi simp3bi jca necom eleq2 biimpa wi elsuci orcom bitr3i sylib
      neor imp sylan 3impa syl3an3b 3expb syl2an ) AFJZEJZKZLZDJZKZVCMZVDVHNZOV
      HVDMZBAVDCMZVFGJZPMZVDVMKLZQZVFHVPVFVLVNVORZVPVFVLVNVOQVFVQOVLVFVNVOSVFVL
      VNVOUAUBUCUDBVIVJBVGPMZVIVJIUEBVRVIVJIUFUGVFVIVJVKVJVFVIVHVDNZVKVDVHUHVFV
      IVSVKVFVIOVHVEMZVSVKVFVIVTVCVEVHUIUJVTVSVKVTVKVHVDLZTZVSVKUKZVHVDULWBWAVK
      TWCWAVKUMVKVHVDUPUNUOUQURUSUTVAVB $.
  $}

  ${
    bnj564.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj564 $p |- ( ta -> dom f = m ) $=
      ( cv wfn cdm wceq simp1bi fndm syl ) ABGZCGZHZNIOJAPDEFKONLM $.
  $}

  ${
    bnj593.1 $e |- ( ph -> E. x ps ) $.
    bnj593.2 $e |- ( ps -> ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj593 $p |- ( ph -> E. x ch ) $=
      ( wex eximi syl ) ABDGCDGEBCDFHI $.
  $}

  ${
    bnj596.1 $e |- ( ph -> A. x ph ) $.
    bnj596.2 $e |- ( ph -> E. x ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj596 $p |- ( ph -> E. x ( ph /\ ps ) ) $=
      ( wex wa ancli nfi 19.42 sylibr ) AABCFZGABGCFALEHABCACDIJK $.
  $}

  ${
    $d A y $.  $d ph y $.  $d ps y $.  $d ps' x $.  $d x y $.
    bnj610.1 $e |- A e. _V $.
    bnj610.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    bnj610.3 $e |- ( x = y -> ( ph <-> ps' ) ) $.
    bnj610.4 $e |- ( y = A -> ( ps' <-> ps ) ) $.
    $( Pass from equality ( ` x = A ` ) to substitution ( ` [. A / x ]. ` )
       without the distinct variable restriction ($d ` A ` ` x ` ).
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj610 $p |- ( [. A / x ]. ph <-> ps ) $=
      ( cv wsbc vex sbcie sbcbii sbcco 3bitr3i ) ACDKZLZDELFDELACELBSFDEAFCRDMI
      NOACDEPFBDEGJNQ $.
  $}

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj642 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ph ) $=
    ( w-bnj17 w3a bnj446 simprbi ) ABCDEBCDFAABCDGH $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj643 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ps ) $=
    ( w-bnj17 w3a bnj291 simprbi ) ABCDEACDFBABCDGH $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj645 $p |- ( ( ph /\ ps /\ ch /\ th ) -> th ) $=
    ( w-bnj17 w3a df-bnj17 simprbi ) ABCDEABCFDABCDGH $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj658 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ( ph /\ ps /\ ch ) ) $=
    ( w-bnj17 w3a df-bnj17 simplbi ) ABCDEABCFDABCDGH $.

  $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj667 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ( ps /\ ch /\ th ) ) $=
    ( w-bnj17 w3a bnj446 simplbi ) ABCDEBCDFAABCDGH $.

  ${
    bnj705.1 $e |- ( ph -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj705 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ta ) $=
      ( w-bnj17 bnj642 syl ) ABCDGAEABCDHFI $.
  $}

  ${
    bnj706.1 $e |- ( ps -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj706 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ta ) $=
      ( w-bnj17 bnj643 syl ) ABCDGBEABCDHFI $.
  $}

  ${
    bnj707.1 $e |- ( ch -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj707 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ta ) $=
      ( w-bnj17 w3a bnj258 simprbi syl ) ABCDGZCELABDHCABCDIJFK $.
  $}

  ${
    bnj708.1 $e |- ( th -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj708 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ta ) $=
      ( w-bnj17 bnj645 syl ) ABCDGDEABCDHFI $.
  $}

  ${
    bnj721.1 $e |- ( ( ph /\ ps /\ ch ) -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj721 $p |- ( ( ph /\ ps /\ ch /\ th ) -> ta ) $=
      ( w-bnj17 w3a bnj658 syl ) ABCDGABCHEABCDIFJ $.
  $}

  ${
    bnj832.1 $e |- ( et <-> ( ph /\ ps ) ) $.
    bnj832.2 $e |- ( ph -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj832 $p |- ( et -> ta ) $=
      ( wa adantr sylbi ) DABGCEACBFHI $.
  $}

  ${
    bnj833.1 $e |- ( et <-> ( ph /\ ps ) ) $.
    bnj833.2 $e |- ( ps -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj833 $p |- ( et -> ta ) $=
      ( wa adantl sylbi ) DABGCEBCAFHI $.
  $}

  ${
    bnj835.1 $e |- ( et <-> ( ph /\ ps /\ ch ) ) $.
    bnj835.2 $e |- ( ph -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj835 $p |- ( et -> ta ) $=
      ( w3a 3ad2ant1 sylbi ) EABCHDFABDCGIJ $.
  $}

  ${
    bnj836.1 $e |- ( et <-> ( ph /\ ps /\ ch ) ) $.
    bnj836.2 $e |- ( ps -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj836 $p |- ( et -> ta ) $=
      ( w3a 3ad2ant2 sylbi ) EABCHDFBADCGIJ $.
  $}

  ${
    bnj837.1 $e |- ( et <-> ( ph /\ ps /\ ch ) ) $.
    bnj837.2 $e |- ( ch -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj837 $p |- ( et -> ta ) $=
      ( w3a 3ad2ant3 sylbi ) EABCHDFCADBGIJ $.
  $}

  ${
    bnj769.1 $e |- ( et <-> ( ph /\ ps /\ ch /\ th ) ) $.
    bnj769.2 $e |- ( ph -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj769 $p |- ( et -> ta ) $=
      ( w-bnj17 bnj705 sylbi ) FABCDIEGABCDEHJK $.
  $}

  ${
    bnj770.1 $e |- ( et <-> ( ph /\ ps /\ ch /\ th ) ) $.
    bnj770.2 $e |- ( ps -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj770 $p |- ( et -> ta ) $=
      ( w-bnj17 bnj706 sylbi ) FABCDIEGABCDEHJK $.
  $}

  ${
    bnj771.1 $e |- ( et <-> ( ph /\ ps /\ ch /\ th ) ) $.
    bnj771.2 $e |- ( ch -> ta ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj771 $p |- ( et -> ta ) $=
      ( w-bnj17 bnj707 sylbi ) FABCDIEGABCDEHJK $.
  $}

  ${
    bnj887.1 $e |- ( ph <-> ph' ) $.
    bnj887.2 $e |- ( ps <-> ps' ) $.
    bnj887.3 $e |- ( ch <-> ch' ) $.
    bnj887.4 $e |- ( th <-> th' ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj887 $p |- ( ( ph /\ ps /\ ch /\ th ) <-> ( ph' /\ ps' /\ ch' /\ th' ) )
        $=
      ( w3a wa w-bnj17 3anbi123i anbi12i df-bnj17 3bitr4i ) ABCMZDNEFGMZHNABCDO
      EFGHOTUADHAEBFCGIJKPLQABCDREFGHRS $.
  $}

  ${
    bnj918.1 $e |- G = ( f u. { <. n , C >. } ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj918 $p |- G e. _V $=
      ( cv cop csn cun cvv vex snex unex eqeltri ) DBFZCFAGZHZIJEOQBKPLMN $.
  $}

  ${
    $d D n $.  $d F n $.  $d P n $.
    bnj919.1 $e |- ( ch <-> ( n e. D /\ F Fn n /\ ph /\ ps ) ) $.
    bnj919.2 $e |- ( ph' <-> [. P / n ]. ph ) $.
    bnj919.3 $e |- ( ps' <-> [. P / n ]. ps ) $.
    bnj919.4 $e |- ( ch' <-> [. P / n ]. ch ) $.
    bnj919.5 $e |- P e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj919 $p |- ( ch' <-> ( P e. D /\ F Fn P /\ ph' /\ ps' ) ) $=
      ( wsbc wcel w3a wa nfxfr cv wfn w-bnj17 sbcbii cvv df-bnj17 nfsbc1v nf3an
      wb nfan wceq eleq1 fneq2 sbceq1a syl6bbr 3anbi123d anbi12d bnj252 3bitr4g
      nfv sbciegf ax-mp 3bitri ) JCFEPFUAZDQZGVDUBZABUCZFEPZEDQZGEUBZHIUCZNCVGF
      EKUDEUEQVHVKUIOVGVKFEUEVKVIVJHRZISFVIVJHIUFVLIFVIVJHFVIFUTVJFUTHAFEPZFLAF
      EUGTUHIBFEPZFMBFEUGTUJTVDEUKZVEVFABRZSVIVJHIRZSVGVKVOVEVIVPVQVDEDULVOVFVJ
      AHBIVDEGUMVOAVMHAFEUNLUOVOBVNIBFEUNMUOUPUQVEVFABURVIVJHIURUSVAVBVC $.
  $}

  ${
    bnj923.1 $e |- D = ( om \ { (/) } ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj923 $p |- ( n e. D -> n e. om ) $=
      ( cv com wcel c0 csn cdif eldifi eleq2s ) BDZEFLEGHZIALEMJCK $.
  $}

  $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
     3-Jun-2011.)  (New usage is discouraged.) $)
  bnj926 $p |- ( ( ph /\ ( ps <-> ph ) ) -> ps ) $=
    ( wb bicom bi1 impcom sylan2b ) BACAABCZBBADHABABEFG $.

  ${
    bnj927.1 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj927.2 $e |- C e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj927 $p |- ( ( p = suc n /\ f Fn n ) -> G Fn p ) $=
      ( cv csuc wceq wfn wa csn cun cop cin c0 simpr vex a1i fnsn fnun syl21anc
      bnj521 fneq1i sylibr df-suc eqeq2i biimpi adantr fneq2d mpbird ) EHZCHZIZ
      JZBHZUNKZLZDUMKDUNUNMZNZKZUSUQUNAOMZNZVAKZVBUSURVCUTKZUNUTPQJZVEUPURRVFUS
      UNACSGUATVGUSUNUDTUNUTUQVCUBUCVADVDFUEUFUSUMVADUPUMVAJZURUPVHUOVAUMUNUGUH
      UIUJUKUL $.
  $}

  ${
    bnj930.1 $e |- ( ph -> F Fn A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj930 $p |- ( ph -> Fun F ) $=
      ( wfn wfun fnfun syl ) ACBECFDBCGH $.
  $}

  ${
    bnj931.1 $e |- A = ( B u. C ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj931 $p |- B C_ A $=
      ( cun ssun1 sseqtr4i ) BBCEABCFDG $.
  $}

  ${
    $d ps x $.
    bnj937.1 $e |- ( ph -> E. x ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj937 $p |- ( ph -> ps ) $=
      ( wex 19.9v sylib ) ABCEBDBCFG $.
  $}

  ${
    bnj941.1 $e |- G = ( f u. { <. n , C >. } ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj941 $p |- ( C e. _V -> ( ( p = suc n /\ f Fn n ) -> G Fn p ) ) $=
      ( cvv wcel cv csuc wceq wfn wa wi c0 cif cop csn cun opeq2 sneqd eqid 0ex
      uneq2d syl5eq fneq1d imbi2d elimel bnj927 dedth ) AGHZEIZCIZJKBIZUMLMZDUL
      LZNUOUNUMUKAOPZQZRZSZULLZNAOAUQKZUPVAUOVBULDUTVBDUNUMAQZRZSUTFVBVDUSUNVBV
      CURAUQUMTUAUDUEUFUGUQBCUTEUTUBAOGUCUHUIUJ $.
  $}

  ${
    bnj945.1 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj945 $p |- ( ( C e. _V /\ f Fn n /\ p = suc n /\ A e. n ) -> ( G ` A ) =
        ( f ` A ) ) $=
      ( cvv wcel cv wfn csuc wceq w-bnj17 wfun wss w3a cfv wa bitri fndm eleq2d
      cdm ad2antll pm5.32i bnj941 imp bnj930 cop csn bnj931 jctir anim1i sylbir
      df-bnj17 3ancomb 3anass anbi1i df-3an 3imtr4i funssfv syl ) BHIZCJZDJZKZF
      JZVELMZAVEIZNZEOZVDEPZAVDUCZIZQZAERAVDRMVCVHVFSZSZVISZVKVLSZVNSZVJVOVRVQV
      NSVTVQVNVIVQVMVEAVFVMVEMVCVHVEVDUAUDUBUEVQVSVNVQVKVLVQVGEVCVPEVGKBCDEFGUF
      UGUHEVDVEBUIUJGUKULUMUNVJVCVFVHQZVISVRVCVFVHVIUOWAVQVIWAVCVHVFQVQVCVFVHUP
      VCVHVFUQTURTVKVLVNUSUTAEVDVAVB $.
  $}

  ${
    bnj946.1 $e |- ( ph <-> A. x e. A ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj946 $p |- ( ph <-> A. x ( x e. A -> ps ) ) $=
      ( wral cv wcel wi wal df-ral bitri ) ABCDFCGDHBICJEBCDKL $.
  $}

  ${
    bnj951.1 $e |- ( ta -> ph ) $.
    bnj951.2 $e |- ( ta -> ps ) $.
    bnj951.3 $e |- ( ta -> ch ) $.
    bnj951.4 $e |- ( ta -> th ) $.
    $( ` /\ ` -manipulation.  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj951 $p |- ( ta -> ( ph /\ ps /\ ch /\ th ) ) $=
      ( w3a w-bnj17 3jca df-bnj17 sylanbrc ) EABCJDABCDKEABCFGHLIABCDMN $.
  $}

  ${
    $d A y $.  $d B y $.  $d C y $.  $d x y $.
    bnj956.1 $e |- ( A = B -> A. x A = B ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj956 $p |- ( A = B -> U_ x e. A C = U_ x e. B C ) $=
      ( vy wceq cv wcel wrex cab ciun wal wb wa wex eleq2 syl df-rex df-iun
      anbi1d alimi exbi 3bitr4g abbidv 3eqtr4g ) BCGZFHDIZABJZFKUHACJZFKABDLACD
      LUGUIUJFUGUGAMZUIUJNEUKAHZBIZUHOZAPZULCIZUHOZAPZUIUJUKUNUQNZAMUOURNUGUSAU
      GUMUPUHBCULQUAUBUNUQAUCRUHABSUHACSUDRUEAFBDTAFCDTUF $.
  $}

  ${
    $d D f h $.  $d G h $.  $d N f h $.  $d ch h $.  $d h ph $.  $d h ph' $.
    $d h ps $.  $d h ps' $.
    bnj976.1 $e |- ( ch <-> ( N e. D /\ f Fn N /\ ph /\ ps ) ) $.
    bnj976.2 $e |- ( ph' <-> [. G / f ]. ph ) $.
    bnj976.3 $e |- ( ps' <-> [. G / f ]. ps ) $.
    bnj976.4 $e |- ( ch' <-> [. G / f ]. ch ) $.
    bnj976.5 $e |- G e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj976 $p |- ( ch' <-> ( N e. D /\ G Fn N /\ ph' /\ ps' ) ) $=
      ( vh wsbc wfn w3a wa cv wcel w-bnj17 wceq bnj252 sbcbii vex bnj525 sbc3an
      sbcco bnj62 3anbi1i bitri anbi12i 3bitr4ri 3bitr4i sbceq1a bitr4i syl6bbr
      sbcan fneq1 3anbi123d anbi2d 3bitr4g syl5bb sbcie 3bitr2i ) JCEFQCEPUAZQZ
      PFQGDUBZFGRZHIUCZNCEPFUJVIVLPFOVIVJVHGRZAEVHQZBEVHQZUCZVHFUDZVLVJEUAGRZAB
      UCZEVHQVJVRABSZTZEVHQZVIVPVSWAEVHVJVRABUEUFCVSEVHKUFVJEVHQZVTEVHQZTVJVMVN
      VOSZTZWBVPWCVJWDWEVJEVHPUGUHWDVREVHQZVNVOSWEVRABEVHUIWGVMVNVOEPGUKULUMUNV
      JVTEVHUTVJVMVNVOUEZUOUPVQWFVJVKHISZTVPVLVQWEWIVJVQVMVKVNHVOIGVHFVAVQVNVNP
      FQZHVNPFUQHAEFQWJLAEPFUJURUSVQVOVOPFQZIVOPFUQIBEFQWKMBEPFUJURUSVBVCWHVJVK
      HIUEVDVEVFVG $.
  $}

  ${
    bnj982.1 $e |- ( ph -> A. x ph ) $.
    bnj982.2 $e |- ( ps -> A. x ps ) $.
    bnj982.3 $e |- ( ch -> A. x ch ) $.
    bnj982.4 $e |- ( th -> A. x th ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj982 $p |- ( ( ph /\ ps /\ ch /\ th ) -> A. x ( ph /\ ps /\ ch /\ th ) )
        $=
      ( w-bnj17 w3a wa df-bnj17 hb3an hban hbxfrbi ) ABCDJABCKZDLEABCDMQDEABCEF
      GHNIOP $.
  $}

  ${
    $d ch p $.  $d et p $.  $d p th $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1019 $p |- ( E. p ( th /\ ch /\ ta /\ et ) <-> ( th /\ ch /\ et /\ E. p
        ta ) ) $=
      ( w3a wa wex w-bnj17 19.42v bnj258 exbii df-bnj17 3bitr4i ) BADFZCGZEHOCE
      HZGBACDIZEHBADQIOCEJRPEBACDKLBADQMN $.
  $}

  ${
    bnj1023.1 $e |- E. x ( ph -> ps ) $.
    bnj1023.2 $e |- ( ps -> ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1023 $p |- E. x ( ph -> ch ) $=
      ( wi wa wal wex a1i ax-gen exintr mp2 pm3.33 bnj101 ) ABGZBCGZHZACGDQRGZD
      IQDJSDJTDRQFKLEQRDMNABCOP $.
  $}

  ${
    bnj1095.1 $e |- ( ph <-> A. x e. A ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1095 $p |- ( ph -> A. x ph ) $=
      ( wral hbra1 hbxfrbi ) ABCDFCEBCDGH $.
  $}

  ${
    $d ch x $.  $d ta x $.  $d th x $.
    bnj1096.1 $e |- ( ph -> A. x ph ) $.
    bnj1096.2 $e |- ( ps <-> ( ch /\ th /\ ta /\ ph ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1096 $p |- ( ps -> A. x ps ) $=
      ( w-bnj17 ax-17 bnj982 hbxfrbi ) BCDEAIFHCDEAFCFJDFJEFJGKL $.
  $}

  ${
    $d D j $.  $d i j $.  $d j n $.
    bnj1098.1 $e |- D = ( om \ { (/) } ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1098 $p |- E. j ( ( i =/= (/) /\ i e. n /\ n e. D ) -> ( j e. n /\ i =
        suc j ) ) $=
      ( cv c0 wne wel wcel w3a com csuc wceq wa wi wrex wex 3anrev df-3an bitri
      simpr bnj923 adantr elnn syl2anc anim1i sylbi df-rex imbi2i 19.37v bitr4i
      syl mpbi ancr bnj101 vex bnj216 ad2antlr simpr2 word 3simpc ancomd adantl
      nnsuc nnord ordtr1 4syl mp2and simplr jca bnj1023 ) BFZGHZBDIZDFZAJZKZCFZ
      LJZVMVSMNZOZVROZCDIZWAOCVRWBPZVRWCPCVRWACLQZPZWECRZVRVMLJZVNOZWFVRVQVOOZV
      NOZWJVRVQVOVNKWLVNVOVQSVQVOVNTUAWKWIVNWKVOVPLJZWIVQVOUBVQWMVOADEUCUDZVMVP
      UEUFUGUHCVMVEUMWGVRWBCRZPWHWFWOVRWACLUIUJVRWBCUKULUNVRWBUOUPWCWDWAWCCBIZV
      OWDWAWPVTVRVMVSCUQURUSWBVNVOVQUTWCWKWMVPVAWPVOOWDPVRWKWBVRVOVQVNVOVQVBVCV
      DWNVPVFVSVMVPVGVHVIVTWAVRVJVKVL $.
  $}

  ${
    bnj1101.1 $e |- E. x ( ph -> ps ) $.
    bnj1101.2 $e |- ( ch -> ph ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1101 $p |- E. x ( ch -> ps ) $=
      ( wi wex wa pm3.42 bnj101 pm4.71i imbi1i exbii mpbir ) CBGZDHCAIZBGZDHABG
      RDECABJKPRDCQBCAFLMNO $.
  $}

  ${
    $d C x $.  $d D x $.
    bnj1113.1 $e |- ( A = B -> C = D ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1113 $p |- ( A = B -> U_ x e. C E = U_ x e. D E ) $=
      ( wceq iuneq1d ) BCHADEFGI $.
  $}

  ${
    bnj1109.1 $e |- E. x ( ( A =/= B /\ ph ) -> ps ) $.
    bnj1109.2 $e |- ( ( A = B /\ ph ) -> ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1109 $p |- E. x ( ph -> ps ) $=
      ( wceq wi wne wa wex wal ex a1i ax-gen impexp exbii mpbi exintr mp2 df-ne
      exancom wn imbi1i pm2.61 imp sylan2b bnj101 ) DEHZABIZIZDEJZUKIZKZUKCUNUL
      KCLZUOCLUNULIZCMUNCLZUPUQCULUNUJABGNOPUMAKBIZCLURFUSUNCUMABQRSUNULCTUAUNU
      LCUCSUNULUJUDZUKIZUKUMUTUKDEUBUEULVAUKUJUKUFUGUHUI $.
  $}

  ${
    bnj1131.1 $e |- ( ph -> A. x ph ) $.
    bnj1131.2 $e |- E. x ph $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1131 $p |- ph $=
      ( wex 19.9h mpbi ) ABEADABCFG $.
  $}

  ${
    bnj1138.1 $e |- A = ( B u. C ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1138 $p |- ( X e. A <-> ( X e. B \/ X e. C ) ) $=
      ( wcel cun wo eleq2i elun bitri ) DAFDBCGZFDBFDCFHALDEIDBCJK $.
  $}

  ${
    bnj1142.1 $e |- ( ph -> A. x ( x e. A -> ps ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1142 $p |- ( ph -> A. x e. A ps ) $=
      ( cv wcel wi wal wral df-ral sylibr ) ACFDGBHCIBCDJEBCDKL $.
  $}

  ${
    $d A x y z $.  $d B x y z $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1143 $p |- U_ x e. A B C_ B $=
      ( vy vz c0 wceq cv wcel wrex cab df-iun wal wex notnot neq0 xchbinx sylbi
      wn notbii wss wa df-rex exsimpl con3i alrimiv eqeq1i eleq2i exbii 3bitr3i
      ciun alnex abid albii 3bitr2i sylibr syl5eq 0ss syl6eqss wne iunconst syl
      eqimss pm2.61ine ) ABCUKZCUAZBFBFGZVEFCVGVEDHCIABJDKZFADBCLZVGEHZCIZABJZS
      ZEMZVHFGZVGVMEVGAHBIZANZSVMVGVGSVQVGOABPQVLVQVLVPVKUBANVQVKABUCVPVKAUDRUE
      RUFVOVJVLEKZIZENZSVSSZEMVNVOVOSZVTVOOVEFGZSVJVEIZENWBVTEVEPWCVOVEVHFVIUGT
      WDVSEVEVRVJAEBCLUHUIUJQVSEULWAVMEVSVLVLEUMTUNUOUPUQCURUSBFUTVECGVFABCVAVE
      CVCVBVD $.
  $}

  ${
    $d A w y $.  $d B w x y $.
    bnj1146.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1146 $p |- U_ x e. A B C_ B $=
      ( vw ciun cv wcel wrex cab wa wex nfv nfi nfan weq eleq1 df-rex df-iun
      anbi1d cbvex 3bitr4i abbii 3eqtr4i bnj1143 eqsstri ) ACDGZBCDGZDFHDIZACJZ
      FKUJBCJZFKUHUIUKULFAHZCIZUJLZAMBHZCIZUJLZBMUKULUOURABUOBNUQUJAUQAEOUJANPA
      BQUNUQUJUMUPCRUAUBUJACSUJBCSUCUDAFCDTBFCDTUEBCDUFUG $.
  $}

  ${
    bnj1149.1 $e |- ( ph -> A e. _V ) $.
    bnj1149.2 $e |- ( ph -> B e. _V ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1149 $p |- ( ph -> ( A u. B ) e. _V ) $=
      ( cvv wcel cun unexg syl2anc ) ABFGCFGBCHFGDEBCFFIJ $.
  $}

  ${
    bnj1153.1 $e |- ( ph -> X e. A ) $.
    bnj1153.2 $e |- ( ph -> X e. B ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1153 $p |- ( ph -> X e. ( A i^i B ) ) $=
      ( wcel cin elin sylanbrc ) ADBGDCGDBCHGEFDBCIJ $.
  $}

  ${
    $d B w y z $.  $d B x y z $.  $d R w y z $.  $d R x y z $.
    bnj1185.1 $e |- ( ph -> E. z e. B A. w e. B -. w R z ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1185 $p |- ( ph -> E. x e. B A. y e. B -. y R x ) $=
      ( cv wbr wn wral wrex weq breq1 notbid wcel wa wex df-rex cbvralv ralbidv
      rexbii sylib eleq1 breq2 anbi12d cbvexv 3bitr4ri sylibr ) ACIZDIZGJZKZCFL
      ZDFMZUKBIZGJZKZCFLZBFMZAEIZULGJZKZEFLZDFMUPHVEUODFVDUNECFECNVCUMVBUKULGOP
      UAUCUDULFQZUORZDSUQFQZUTRZBSUPVAVGVIDBDBNZVFVHUOUTULUQFUEVJUNUSCFVJUMURUL
      UQUKGUFPUBUGUHUODFTUTBFTUIUJ $.
  $}

  ${
    bnj1196.1 $e |- ( ph -> E. x e. A ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1196 $p |- ( ph -> E. x ( x e. A /\ ps ) ) $=
      ( wrex cv wcel wa wex df-rex sylib ) ABCDFCGDHBICJEBCDKL $.
  $}

  ${
    bnj1198.1 $e |- ( ph -> E. x ps ) $.
    bnj1198.2 $e |- ( ps' <-> ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1198 $p |- ( ph -> E. x ps' ) $=
      ( wex exbii sylibr ) ABCGDCGEDBCFHI $.
  $}

  ${
    $d ch x $.
    bnj1209.1 $e |- ( ch -> E. x e. B ph ) $.
    bnj1209.2 $e |- ( th <-> ( ch /\ x e. B /\ ph ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1209 $p |- ( ch -> E. x th ) $=
      ( cv wcel wa wex bnj1196 ancli 19.42v sylibr w3a 3anass bitri bnj1198 ) B
      BDHEIZAJZJZDCBBUADKZJUBDKBUCBADEFLMBUADNOCBTAPUBGBTAQRS $.
  $}

  ${
    bnj1211.1 $e |- ( ph -> A. x e. A ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1211 $p |- ( ph -> A. x ( x e. A -> ps ) ) $=
      ( wral cv wcel wi wal df-ral sylib ) ABCDFCGDHBICJEBCDKL $.
  $}

  ${
    bnj1213.1 $e |- A C_ B $.
    bnj1213.2 $e |- ( th -> x e. A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1213 $p |- ( th -> x e. B ) $=
      ( cv sseldi ) ACDBGEFH $.
  $}

  ${
    $d A x $.
    bnj1212.1 $e |- B = { x e. A | ph } $.
    bnj1212.2 $e |- ( th <-> ( ch /\ x e. B /\ ta ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1212 $p |- ( th -> x e. A ) $=
      ( bnj21 cv wcel simp2bi bnj1213 ) CEGFAEFGHJCBEKGLDIMN $.
  $}

  ${
    bnj1219.1 $e |- ( ch <-> ( ph /\ ps /\ ze ) ) $.
    bnj1219.2 $e |- ( th <-> ( ch /\ ta /\ et ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1219 $p |- ( th -> ps ) $=
      ( simp2bi bnj835 ) CEFBDICABGHJK $.
  $}

  ${
    bnj1224.1 $e |- -. ( th /\ ta /\ et ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1224 $p |- ( ( th /\ ta ) -> -. et ) $=
      ( wa w3a df-3an mtbi imnani ) ABEZCABCFJCEDABCGHI $.
  $}

  ${
    $d x y $.
    bnj1230.1 $e |- B = { x e. A | ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1230 $p |- ( y e. B -> A. x y e. B ) $=
      ( crab nfrab1 nfcxfr nfcrii ) BCEBEABDGFABDHIJ $.
  $}

  ${
    bnj1232.1 $e |- ( ph <-> ( ps /\ ch /\ th /\ ta ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1232 $p |- ( ph -> ps ) $=
      ( w-bnj17 bnj642 sylbi ) ABCDEGBFBCDEHI $.
  $}

  ${
    bnj1235.1 $e |- ( ph <-> ( ps /\ ch /\ th /\ ta ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1235 $p |- ( ph -> ch ) $=
      ( id bnj770 ) BCDECAFCGH $.
  $}

  $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
     3-Jun-2011.)  (New usage is discouraged.) $)
  bnj1239 $p |- ( E. x e. A ( ps /\ ch ) -> E. x e. A ps ) $=
    ( wa simpl reximi ) ABEACDABFG $.

  ${
    bnj1238.1 $e |- ( ph <-> E. x e. A ( ps /\ ch ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1238 $p |- ( ph -> E. x e. A ps ) $=
      ( wa wrex bnj1239 sylbi ) ABCGDEHBDEHFBCDEIJ $.
  $}

  ${
    bnj1241.1 $e |- ( ph -> A C_ B ) $.
    bnj1241.2 $e |- ( ps -> C = A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1241 $p |- ( ( ph /\ ps ) -> C C_ B ) $=
      ( wa wceq eqcomd adantl wss adantr eqsstr3d ) ABHECDBCEIABECGJKACDLBFMN
      $.
  $}

  ${
    bnj1247.1 $e |- ( ph <-> ( ps /\ ch /\ th /\ ta ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1247 $p |- ( ph -> th ) $=
      ( id bnj771 ) BCDEDAFDGH $.
  $}

  ${
    bnj1254.1 $e |- ( ph <-> ( ps /\ ch /\ th /\ ta ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1254 $p |- ( ph -> ta ) $=
      ( w-bnj17 id bnj708 sylbi ) ABCDEGEFBCDEEEHIJ $.
  $}

  ${
    bnj1262.1 $e |- A C_ B $.
    bnj1262.2 $e |- ( ph -> C = A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1262 $p |- ( ph -> C C_ B ) $=
      ( syl6eqss ) ADBCFEG $.
  $}

  ${
    bnj1266.1 $e |- ( ch -> E. x ( ph /\ ps ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1266 $p |- ( ch -> E. x ps ) $=
      ( wa simpr bnj593 ) CABFBDEABGH $.
  $}

  ${
    $d ps x $.
    bnj1265.1 $e |- ( ph -> E. x e. A ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1265 $p |- ( ph -> ps ) $=
      ( cv wcel bnj1196 bnj1266 bnj937 ) ABCCFDGBACABCDEHIJ $.
  $}

  ${
    bnj1275.1 $e |- ( ph -> E. x ( ps /\ ch ) ) $.
    bnj1275.2 $e |- ( ph -> A. x ph ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1275 $p |- ( ph -> E. x ( ph /\ ps /\ ch ) ) $=
      ( wa w3a bnj596 3anass bnj1198 ) AABCGZGDABCHALDFEIABCJK $.
  $}

  ${
    bnj1276.1 $e |- ( ph -> A. x ph ) $.
    bnj1276.2 $e |- ( ps -> A. x ps ) $.
    bnj1276.3 $e |- ( ch -> A. x ch ) $.
    bnj1276.4 $e |- ( th <-> ( ph /\ ps /\ ch ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1276 $p |- ( th -> A. x th ) $=
      ( w3a hb3an hbxfrbi ) DABCJEIABCEFGHKL $.
  $}

  ${
    bnj1292.1 $e |- A = ( B i^i C ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1292 $p |- A C_ B $=
      ( cin inss1 eqsstri ) ABCEBDBCFG $.
  $}

  ${
    bnj1293.1 $e |- A = ( B i^i C ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1293 $p |- A C_ C $=
      ( cin inss2 eqsstri ) ABCECDBCFG $.
  $}

  ${
    bnj1294.1 $e |- ( ph -> A. x e. A ps ) $.
    bnj1294.2 $e |- ( ph -> x e. A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1294 $p |- ( ph -> ps ) $=
      ( cv wcel wral wi wal df-ral sp impcom sylan2b syl2anc ) ACGDHZBCDIZBFERQ
      QBJZCKZBBCDLTQBSCMNOP $.
  $}

  ${
    bnj1299.1 $e |- ( ph -> E. x e. A ( ps /\ ch ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1299 $p |- ( ph -> E. x e. A ps ) $=
      ( wa wrex bnj1239 syl ) ABCGDEHBDEHFBCDEIJ $.
  $}

  ${
    bnj1304.1 $e |- ( ph -> E. x ps ) $.
    bnj1304.2 $e |- ( ps -> ch ) $.
    bnj1304.3 $e |- ( ps -> -. ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1304 $p |- -. ph $=
      ( wn wa wex wal notnot anbi2i exbii ioran exnal 3bitr2ri notbii exancom
      wo 3bitri exmid mpgbi jca bnj593 mto ) ACCHZIZDJZCUGTZUIHZDUJDKZULHZHUGCI
      ZDJZHUKULLUMUOUOUGUGHZIZDJUJHZDJUMUNUQDCUPUGCLMNURUQDCUGONUJDPQRUOUIUGCDS
      RUACUBUCABUHDEBCUGFGUDUEUF $.
  $}

  ${
    $d A y $.  $d B y $.  $d x y $.
    bnj1316.1 $e |- ( y e. A -> A. x y e. A ) $.
    bnj1316.2 $e |- ( y e. B -> A. x y e. B ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1316 $p |- ( A = B -> U_ x e. A C = U_ x e. B C ) $=
      ( wceq nfcii nfeq nfri bnj956 ) ACDECDHAACDABCFIABDGIJKL $.
  $}

  ${
    $d x y $.
    bnj1317.1 $e |- A = { x | ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1317 $p |- ( y e. A -> A. x y e. A ) $=
      ( cab hbab1 hbxfreq ) BCDABFEABCGH $.
  $}

  $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
     3-Jun-2011.)  (New usage is discouraged.) $)
  bnj1322 $p |- ( A = B -> ( A i^i B ) = A ) $=
    ( wceq wss cin eqimss df-ss sylib ) ABCABDABEACABFABGH $.

  ${
    bnj1340.1 $e |- ( ps -> E. x th ) $.
    bnj1340.2 $e |- ( ch <-> ( ps /\ th ) ) $.
    bnj1340.3 $e |- ( ps -> A. x ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1340 $p |- ( ps -> E. x ch ) $=
      ( wa bnj596 bnj1198 ) AACHDBACDGEIFJ $.
  $}

  ${
    bnj1345.1 $e |- ( ph -> E. x ( ps /\ ch ) ) $.
    bnj1345.2 $e |- ( th <-> ( ph /\ ps /\ ch ) ) $.
    bnj1345.3 $e |- ( ph -> A. x ph ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1345 $p |- ( ph -> E. x th ) $=
      ( w3a bnj1275 bnj1198 ) AABCIEDABCEFHJGK $.
  $}

  ${
    $d ph x $.  $d ps x $.
    bnj1350.1 $e |- ( ch -> A. x ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1350 $p |- ( ( ph /\ ps /\ ch ) -> A. x ( ph /\ ps /\ ch ) ) $=
      ( ax-17 hb3an ) ABCDADFBDFEG $.
  $}

  ${
    $d ps x $.
    bnj1351.1 $e |- ( ph -> A. x ph ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1351 $p |- ( ( ph /\ ps ) -> A. x ( ph /\ ps ) ) $=
      ( ax-17 hban ) ABCDBCEF $.
  $}

  ${
    $d ph x $.
    bnj1352.1 $e |- ( ps -> A. x ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1352 $p |- ( ( ph /\ ps ) -> A. x ( ph /\ ps ) ) $=
      ( ax-17 hban ) ABCACEDF $.
  $}

  ${
    $d A x $.  $d B x $.
    bnj1361.1 $e |- ( ph -> A. x ( x e. A -> x e. B ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1361 $p |- ( ph -> A C_ B ) $=
      ( cv wcel wi wal wss dfss2 sylibr ) ABFZCGMDGHBICDJEBCDKL $.
  $}

  ${
    $d A w x y z $.  $d B w z $.  $d ph w z $.
    bnj1366.1 $e |- ( ps <-> ( A e. _V /\ A. x e. A E! y ph /\ B = { y | E. x
        e. A ph } ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj1366 $p |- ( ps -> B e. _V ) $=
      ( cio cmpt crn cvv wrex cab wcel weu wral wceq cv wb syl simp3bi wal nfcv
      simp2bi nfeu1 nfral nfra1 wa rsp imp iota1 eqcom syl6bb rexbida abid eqid
      iotaex 3bitr4g alrimi nfab1 nfiota1 nfmpt nfrn cleqf sylibr eqtrd simp1bi
      elrnmpti mptexg rnexg 3syl eqeltrd ) BFCEADHZIZJZKBFACELZDMZVOBEKNZADOZCE
      PZFVQQZGUABDRZVQNZWBVONZSZDUBZVQVOQBVTWFBVRVTWAGUDVTWEDVSDCEDEUCZADUEUFVT
      VPWBVMQZCELWCWDVTAWHCEVSCEUGVTCRENZUHVSAWHSVTWIVSVSCEUIUJVSAVMWBQWHADUKVM
      WBULUMTUNVPDUOCEVMWBVNVNUPADUQVHURUSTDVQVOVPDUTDVNDCEVMWGADVAVBVCVDVEVFBV
      RVNKNVOKNBVRVTWAGVGCEVMKVIVNKVJVKVL $.
  $}

  ${
    $d A f g x y z $.  $d D x $.  $d g ph $.  $d ps x y z $.
    bnj1379.1 $e |- ( ph <-> A. f e. A Fun f ) $.
    bnj1379.2 $e |- D = ( dom f i^i dom g ) $.
    bnj1379.3 $e |- ( ps <-> ( ph /\ A. f e. A A. g e. A ( f |` D ) = ( g |` D
        ) ) ) $.
    bnj1379.5 $e |- ( ch <-> ( ps /\ <. x , y >. e. U. A /\ <. x , z >. e. U. A
        ) ) $.
    bnj1379.6 $e |- ( th <-> ( ch /\ f e. A /\ <. x , y >. e. f ) ) $.
    bnj1379.7 $e |- ( ta <-> ( th /\ g e. A /\ <. x , z >. e. g ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1379 $p |- ( ps -> Fun U. A ) $=
      ( wcel bnj835 cuni wrel cv cop wa wceq wi wal wfun wral bnj1095 nfi nfra1
      cres nfan nfxfr bnj946 biimpi 19.21bi bnj832 funrel ralrimi reluni sylibr
      syl6 w3a wex wrex eluni2 bnj1196 nfv nf3an nfri bnj1345 simp3bi syl nfra2
      bnj836 cfv simprbi bnj1219 bnj1294 simp2bi fveq1d opeldm bnj837 syl6eleqr
      cdm cin vex bnj1153 fvres 3eqtr3d funopfv sylc funeq cbvralv sylib bnj593
      bnj937 sylbir 3expib alrimivv alrimiv dffun4 sylanbrc ) BIUAZUBZFUCZGUCZU
      DZXGSZXIHUCZUDZXGSZUEXJXMUFZUGZHUHGUHZFUHXGUIBKUCZUBZKIUJXHBXTKIBAXSJUNZL
      UCZJUNZUFZLIUJZKIUJZUEZKOAYFKAKAXSUIZKIMUKULYEKIUMUOUPZBXSISZYHXTAYFYJYHU
      GZBOAYKKAYKKUHAYHKIMUQURUSUTXSVAVEVBKIVCVDBXRFBXQGHBXLXOXPBXLXOVFZCXPPCXP
      KCDXPKCYJXKXSSZDKBXLXOYJYMUEKVGCPXLYMKIXLYMKIVHKXKIVIURVJVRQCKCYLKPBXLXOK
      YIXLKVKXOKVKVLUPVMVNDXPLDEXPLDYBISZXNYBSZELDXOYNYOUELVGCYJYMXODQCBXLXOPVO
      TXOYOLIXOYOLIVHLXNIVIURVJVPRDLDCYJYMVFLQCYJYMLCYLLPBXLXOLBYGLOAYFLALVKYDK
      LIIVQUOUPXLLVKXOLVKVLUPYJLVKYMLVKVLUPVMVNEXIXSVSZXIYBVSZXJXMEXIYAVSZXIYCV
      SZYPYQEXIYAYCEYDLIEYEKIDYNYOYFERCYJYMYFDQBXLXOYFCPBAYFOVTTTTCYJDEYNYOYMQR
      WAZWBEDYNYORWCZWBWDEXIJSZYRYPUFEXIXSWHZYBWHZWIJEUUCUUDXIEYMXIUUCSDYNYOYME
      RDCYJYMQVOTZXIXJXSFWJZGWJWEVPDYNYOXIUUDSERXIXMYBUUFHWJWEWFWKNWGZXIJXSWLVP
      EUUBYSYQUFUUGXIJYBWLVPWMEYHYMYPXJUFEYHKIDYNYOYHKIUJZERCYJYMUUHDQBXLXOUUHC
      PAYFUUHBOAUUHMURUTTTTZYTWBUUEXIXJXSWNWOEYBUIZYOYQXMUFEUUJLIEUUHUUJLIUJUUI
      YHUUJKLIXSYBWPWQWRUUAWBEDYNYORVOXIXMYBWNWOWMWSWTWSWTXAXBXCXDFGHXGXEXF $.
  $}

  ${
    $d A f g x y z $.  $d D x $.  $d g ph $.  $d ps x y z $.
    bnj1383.1 $e |- ( ph <-> A. f e. A Fun f ) $.
    bnj1383.2 $e |- D = ( dom f i^i dom g ) $.
    bnj1383.3 $e |- ( ps <-> ( ph /\ A. f e. A A. g e. A ( f |` D ) = ( g |` D
        ) ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1383 $p |- ( ps -> Fun U. A ) $=
      ( vx vy vz cv cop cuni wcel w3a biid bnj1379 ) ABBJMZKMNZCOZPTLMNZUBPQZUD
      EMZCPUAUEPQZUFFMZCPUCUGPQZJKLCDEFGHIUDRUFRUHRS $.
  $}

  ${
    $d A g h x $.  $d D h $.  $d E f $.  $d f g h x $.  $d g ph' $.
    bnj1385.1 $e |- ( ph <-> A. f e. A Fun f ) $.
    bnj1385.2 $e |- D = ( dom f i^i dom g ) $.
    bnj1385.3 $e |- ( ps <-> ( ph /\ A. f e. A A. g e. A ( f |` D ) = ( g |` D
        ) ) ) $.
    bnj1385.4 $e |- ( x e. A -> A. f x e. A ) $.
    bnj1385.5 $e |- ( ph' <-> A. h e. A Fun h ) $.
    bnj1385.6 $e |- E = ( dom h i^i dom g ) $.
    bnj1385.7 $e |- ( ps' <-> ( ph' /\ A. h e. A A. g e. A ( h |` E ) = ( g |`
        E ) ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1385 $p |- ( ps -> Fun U. A ) $=
      ( cres wral cuni wfun cv wceq wa wcel wi wal nfcii nfcri nfim eleq1 funeq
      nfv imbi12d cbval df-ral 3bitr4i nfral cdm cin dmeq ineq1d 3eqtr4g reseq1
      reseq2d eqtrd eqeq12d ralbidv anbi12i bnj1383 sylbi ) BKDUAUBAFUCZESZGUCZ
      ESZUDZGDTZFDTZUEJHUCZISZVOISZUDZGDTZHDTZUEBKAJVSWEVMUBZFDTZVTUBZHDTZAJVMD
      UFZWFUGZFUHVTDUFZWHUGZHUHWGWIWKWMFHWKHUNWLWHFFHDFCDOUIZUJZWHFUNUKVMVTUDZW
      JWLWFWHVMVTDULZVMVTUMUOUPWFFDUQWHHDUQURLPURWJVRUGZFUHWLWDUGZHUHVSWEWRWSFH
      WRHUNWLWDFWOWCFGDWNWCFUNUSUKWPWJWLVRWDWQWPVQWCGDWPVNWAVPWBWPVNVMISWAWPEIV
      MWPVMUTZVOUTZVAVTUTZXAVAEIWPWTXBXAVMVTVBVCMQVDZVFVMVTIVEVGWPEIVOXCVFVHVIU
      OUPVRFDUQWDHDUQURVJNRURJKDIHGPQRVKVL $.
  $}

  ${
    $d A g h x $.  $d D h $.  $d f g h x $.
    bnj1386.1 $e |- ( ph <-> A. f e. A Fun f ) $.
    bnj1386.2 $e |- D = ( dom f i^i dom g ) $.
    bnj1386.3 $e |- ( ps <-> ( ph /\ A. f e. A A. g e. A ( f |` D ) = ( g |` D
        ) ) ) $.
    bnj1386.4 $e |- ( x e. A -> A. f x e. A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1386 $p |- ( ps -> Fun U. A ) $=
      ( vh cv cdm cin wfun wral cres wceq biid wa eqid bnj1385 ) ABCDEFGLLMZNGM
      ZNOZUDPLDQZUGUDUFRUEUFRSGDQLDQUAZHIJKUGTUFUBUHTUC $.
  $}

  ${
    bnj1397.1 $e |- ( ph -> E. x ps ) $.
    bnj1397.2 $e |- ( ps -> A. x ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1397 $p |- ( ph -> ps ) $=
      ( wex 19.9h sylib ) ABCFBDBCEGH $.
  $}

  ${
    $d A y z $.  $d x y z $.
    bnj1400.1 $e |- ( y e. A -> A. x y e. A ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1400 $p |- dom U. A = U_ x e. A dom x $=
      ( vz cuni cdm cv ciun dmuni wcel wrex cab df-iun nfcv nfv weq dmeq eqtr4i
      nfcii eleq2d cbvrexf abbii ) CFGECEHZGZIZACAHZGZIZECJUIBHZUHKZACLZBMZUFAB
      CUHNUFUJUEKZECLZBMUMEBCUENULUOBUKUNAECABCDTECOUKEPUNAPAEQUHUEUJUGUDRUAUBU
      CSSS $.
  $}

  ${
    $d X y $.
    bnj1405.1 $e |- ( ph -> X e. U_ y e. A B ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1405 $p |- ( ph -> E. y e. A X e. B ) $=
      ( ciun wcel wrex eliun sylib ) AEBCDGHEDHBCIFBECDJK $.
  $}

  ${
    bnj1422.1 $e |- ( ph -> Fun A ) $.
    bnj1422.2 $e |- ( ph -> dom A = B ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1422 $p |- ( ph -> A Fn B ) $=
      ( wfun cdm wceq wfn df-fn sylanbrc ) ABFBGCHBCIDEBCJK $.
  $}

  ${
    bnj1424.1 $e |- A = ( B u. C ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1424 $p |- ( D e. A -> ( D e. B \/ D e. C ) ) $=
      ( wcel wo bnj1138 biimpi ) DAFDBFDCFGABCDEHI $.
  $}

  ${
    bnj1436.1 $e |- A = { x | ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1436 $p |- ( x e. A -> ph ) $=
      ( cv wcel abeq2i biimpi ) BECFAABCDGH $.
  $}

  ${
    $d y z $.
    bnj1441.1 $e |- ( x e. A -> A. y x e. A ) $.
    bnj1441.2 $e |- ( ph -> A. y ph ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1441 $p |- ( z e. { x e. A | ph } -> A. y z e. { x e. A | ph } ) $=
      ( crab cv wcel wa cab df-rab hban hbab hbxfreq ) CDABEHBIEJZAKZBLABEMRCBD
      QACFGNOP $.
  $}

  ${
    bnj1454.1 $e |- A = { x | ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1454 $p |- ( B e. _V -> ( B e. A <-> [. B / x ]. ph ) ) $=
      ( cvv wcel wsbc cab wb df-sbc a1i eleq2i syl6rbbr ) DFGZABDHZDABIZGZDCGPR
      JOABDKLCQDEMN $.
  $}

  ${
    $d ph x $.
    bnj1459.1 $e |- ( ps <-> ( ph /\ x e. A ) ) $.
    bnj1459.2 $e |- ( ps -> ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1459 $p |- ( ph -> A. x e. A ch ) $=
      ( cv wcel wa sylbir ralrimiva ) ACDEADHEIJBCFGKL $.
  $}

  ${
    $d A x $.  $d V x $.
    bnj1464.1 $e |- ( ps -> A. x ps ) $.
    bnj1464.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj1464 $p |- ( A e. V -> ( [. A / x ]. ph <-> ps ) ) $=
      ( nfi sbciegf ) ABCDEBCFHGI $.
  $}

  ${
    $d A x $.  $d V x $.
    bnj1465.1 $e |- ( x = A -> ( ph <-> ps ) ) $.
    bnj1465.2 $e |- ( ps -> A. x ps ) $.
    bnj1465.3 $e |- ( ch -> ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1465 $p |- ( ( ch /\ A e. V ) -> E. x ph ) $=
      ( wcel wa wsbc adantr wb bnj1464 adantl mpbird spesbcd ) CEFJZKZADETADELZ
      BCBSIMSUABNCABDEFHGOPQR $.
  $}

  ${
    $d A w y $.  $d V y $.  $d ph y $.  $d ps y $.  $d w x y $.
    bnj1468.1 $e |- ( ps -> A. x ps ) $.
    bnj1468.2 $e |- ( x = A -> ( ph <-> ps ) ) $.
    bnj1468.3 $e |- ( y e. A -> A. x y e. A ) $.
    $( Conversion of implicit substitution to explicit class substitution.
       (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj1468 $p |- ( A e. V -> ( [. A / x ]. ph <-> ps ) ) $=
      ( wsbc cv wcel sbcco ax-17 wceq wb wi nfcii nfeq2 nfsbc1v nfbi nfim eqeq1
      nfi nfri weq syl6bir sbceq1a bibi1d sylibd bnj101 bnj1131 bnj1464 syl5bbr
      a9ev ) ACEJACDKZJZDEJEFLBACDEMUQBDEFBDNUPEOZUQBPZQZCUTCURUSCCUPECDEIRSUQB
      CACUPTBCGUDUAUBUECDUFZUTCCDUOVAURABPZUSVAURCKZEOVBVCUPEUCHUGVAAUQBACUPUHU
      IUJUKULUMUN $.
  $}

  ${
    $d D y $.  $d x y $.
    bnj1476.1 $e |- D = { x e. A | -. ph } $.
    bnj1476.2 $e |- ( ps -> D = (/) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1476 $p |- ( ps -> A. x e. A ph ) $=
      ( vy cv wcel wn wal wi c0 wceq eq0 crab nfrab1 nfcxfr nfcri nfn nfv eleq1
      notbid cbval bitri sylib wa rabeq2i notbii biimpi iman sylibr syl bnj1142
      alimi ) BACDBCIZEJZKZCLZUQDJZAMZCLBENOZUTGVCHIZEJZKZHLUTHEPVFUSHCVECCHECE
      AKZCDQFVGCDRSTUAUSHUBVDUQOVEURVDUQEUCUDUEUFUGUSVBCUSVAVGUHZKZVBUSVIURVHVG
      CEDFUIUJUKVAAULUMUPUNUO $.
  $}

  ${
    bnj1502.1 $e |- ( ph -> Fun F ) $.
    bnj1502.2 $e |- ( ph -> G C_ F ) $.
    bnj1502.3 $e |- ( ph -> A e. dom G ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1502 $p |- ( ph -> ( F ` A ) = ( G ` A ) ) $=
      ( wfun wss cdm wcel cfv wceq funssfv syl3anc ) ACHDCIBDJKBCLBDLMEFGBCDNO
      $.
  $}

  ${
    bnj1503.1 $e |- ( ph -> Fun F ) $.
    bnj1503.2 $e |- ( ph -> G C_ F ) $.
    bnj1503.3 $e |- ( ph -> A C_ dom G ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1503 $p |- ( ph -> ( F |` A ) = ( G |` A ) ) $=
      ( wfun wss cdm cres wceq fun2ssres syl3anc ) ACHDCIBDJICBKDBKLEFGBCDMN $.
  $}

  ${
    bnj1517.1 $e |- A = { x | ( ph /\ ps ) } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1517 $p |- ( x e. A -> ps ) $=
      ( cv wcel wa bnj1436 simprd ) CFDGABABHCDEIJ $.
  $}

  ${
    bnj1521.1 $e |- ( ch -> E. x e. B ph ) $.
    bnj1521.2 $e |- ( th <-> ( ch /\ x e. B /\ ph ) ) $.
    bnj1521.3 $e |- ( ch -> A. x ch ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1521 $p |- ( ch -> E. x th ) $=
      ( cv wcel bnj1196 bnj1345 ) BDIEJACDBADEFKGHL $.
  $}

  ${
    bnj1533.1 $e |- ( th -> A. z e. B -. z e. D ) $.
    bnj1533.2 $e |- B C_ A $.
    bnj1533.3 $e |- D = { z e. A | C =/= E } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1533 $p |- ( th -> A. z e. B C = E ) $=
      ( wceq cv wcel wn wi wal bnj1211 wa imbi2i impexp wne rabeq2i nne 3bitr2i
      notbii imnan sseli imim1i ax-1 anim1i simpr mpd jca impbii imbi1i 3bitr3i
      simpl mpbi sylbi alimi syl bnj1142 ) AEGKZBDABLZDMZVDFMZNZOZBPVEVCOZBPAVG
      BDHQVHVIBVHVEVDCMZVCOZOZVIVGVKVEVGVJEGUAZRZNVJVMNZOVKVFVNVMBFCJUBUEVJVMUF
      VOVCVJEGUCSUDSVKVIOZVLVIOZVEVJVCDCVDIUGUHVKVERZVCOVLVERZVCOVPVQVRVSVCVRVS
      VKVLVEVKVEUIUJVSVKVEVSVEVKVLVEUKZVLVEUQULVTUMUNUOVKVEVCTVLVEVCTUPURUSUTVA
      VB $.
  $}

  ${
    $d A w x z $.  $d F w z $.  $d H w x z $.
    bnj1534.1 $e |- D = { x e. A | ( F ` x ) =/= ( H ` x ) } $.
    bnj1534.2 $e |- ( w e. F -> A. x w e. F ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1534 $p |- D = { z e. A | ( F ` z ) =/= ( H ` z ) } $=
      ( cv cfv wne crab nfcv nfv nfcii nffv nfne weq fveq2 neeq12d cbvrab eqtri
      ) EAJZFKZUDGKZLZADMBJZFKZUHGKZLZBDMHUGUKABDADNBDNUGBOAUIUJAUHFACFIPAUHNQA
      UJNRABSUEUIUFUJUDUHFTUDUHGTUAUBUC $.
  $}

  ${
    $d B x $.  $d F x $.  $d G x $.
    bnj1536.1 $e |- ( ph -> F Fn A ) $.
    bnj1536.2 $e |- ( ph -> G Fn A ) $.
    bnj1536.3 $e |- ( ph -> B C_ A ) $.
    bnj1536.4 $e |- ( ph -> A. x e. B ( F ` x ) = ( G ` x ) ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1536 $p |- ( ph -> ( F |` B ) = ( G |` B ) ) $=
      ( cres wceq cv cfv wral wfn wss wb fvreseq syl21anc mpbird ) AEDKFDKLZBMZ
      ENUCFNLBDOZJAECPFCPDCQUBUDRGHIBCDEFSTUA $.
  $}

  ${
    bnj1538.1 $e |- A = { x e. B | ph } $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1538 $p |- ( x e. A -> ph ) $=
      ( cv wcel rabeq2i simprbi ) BFZCGJDGAABCDEHI $.
  $}

  ${
    bnj1541.1 $e |- ( ph <-> ( ps /\ A =/= B ) ) $.
    bnj1541.2 $e |- -. ph $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1541 $p |- ( ps -> A = B ) $=
      ( wne wn wceq wa mtbi imnani nne sylib ) BCDGZHCDIBOABOJFEKLCDMN $.
  $}

  ${
    $d A x y $.  $d F w y $.  $d G w x y $.
    bnj1542.1 $e |- ( ph -> F Fn A ) $.
    bnj1542.2 $e |- ( ph -> G Fn A ) $.
    bnj1542.3 $e |- ( ph -> F =/= G ) $.
    bnj1542.4 $e |- ( w e. F -> A. x w e. F ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1542 $p |- ( ph -> E. x e. A ( F ` x ) =/= ( G ` x ) ) $=
      ( vy cv cfv wne wrex wfn wceq wn nfcv fveq2 wb wa eqfnfv necon3abid df-ne
      wral rexbii rexnal bitri syl6bbr syl2anc mpbid nfv nfcii nffv nfne cbvrex
      neeq12d sylibr ) AKLZEMZUTFMZNZKDOZBLZEMZVEFMZNZBDOAEFNZVDIAEDPZFDPZVIVDU
      AGHVJVKUBZVIVAVBQZKDUFZRZVDVLVNEFKDEFUCUDVDVMRZKDOVOVCVPKDVAVBUEUGVMKDUHU
      IUJUKULVHVCBKDVHKUMBVAVBBUTEBCEJUNBUTSUOBVBSUPVEUTQVFVAVGVBVEUTETVEUTFTUR
      UQUS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well founded induction and recursion
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y z w $.  $d R x y z w $.  $d ph y z w $.  $d ps z $.
    bnj110.1 $e |- A e. _V $.
    bnj110.2 $e |- ( ps <-> A. y e. A ( y R x -> [. y / x ]. ph ) ) $.
    $( Well-founded induction restricted to a set ( ` A e. _V ` ).  The proof
       has been taken from Chapter 4 of Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj110 $p |- ( ( R Fr A /\ A. x e. A ( ps -> ph ) ) -> A. x e. A ph ) $=
      ( vz vw wi wral wa wn wsbc cvv wcel wb ax-mp bitri wfr cv crab ralnex vex
      wrex sbcng bicomi ralbii bitr3i df-rab eleq2i df-sbc sbcan sbcel1v anbi1i
      cab simprbi mprgbir wbr wss c0 wne rabex biantrur rexnal rabn0 ssrab2 fri
      syl2anb eqid bnj23 wal df-ral sbcbii sbcal sbcimg nfv csb sbcbr2g csbvarg
      sbcgf wceq breq2i nfsbc1v imbi12i albii 3bitr4i sylibr bnj31 nfim sbceq1a
      weq imbi12d cbvral elrabi imim1i ralimi2 sylbi rexim syl mpan9 an32s iman
      mto mpbir ) EFUAZBAKZCELZMZACELZKXJXKNZMZNXMACIUBZOZIANZCEUCZUFZXRNZXPCXN
      OZIXQXSXONZIXQLXTIXQLXOIXQUDYAXTIXQXTYAXNPQZXTYARIUEZACXNPUGSUHUIUJXNXQQZ
      XNEQZXTYDXNCUBZEQZXPMZCUQZQZYEXTMZXQYIXNXPCEUKULYJYHCXNOZYKYHCXNUMYLYGCXN
      OZXTMYKYGXPCXNUNYMYEXTCXNEUOUPTUJTURUSXGXLXIXRXGXLMZBCXNOZIXQUFZXIXRYNJUB
      XNFUTNJXQLZYOIXQXGXQPQZXGMXQEVAZXQVBVCZMZYQIXQUFXLYRXGXPCEGVDVEXLXPCEUFZU
      UAACEVFUUBYTUUAXPCEVGYSYTXPCEVHVEUJUJIJEXQPFVIVJYQDUBZXNFUTZACUUCOZKZDELZ
      YOACIJDEXQFXQVKVLUUCYFFUTZUUEKZDELZCXNOZUUCEQZUUFKZDVMZYOUUGUUKUULUUIKZDV
      MZCXNOZUUNUUJUUPCXNUUIDEVNVOUUQUUOCXNOZDVMUUNUUODCXNVPUURUUMDUURUULCXNOZU
      UICXNOZKZUUMYBUURUVARYCUULUUICXNPVQSUUSUULUUTUUFYBUUSUULRYCUULCXNPUULCVRW
      BSUUTUUHCXNOZUUECXNOZKZUUFYBUUTUVDRYCUUHUUECXNPVQSUVBUUDUVCUUEUVBUUCCXNYF
      VSZFUTZUUDYBUVBUVFRYCCXNUUCYFFPVTSUVEXNUUCFYBUVEXNWCYCCXNPWASWDTYBUVCUUER
      YCUUECXNPACUUCWEWBSWFTWFTWGTTBUUJCXNHVOUUFDEVNWHWIWJXIYOXOKZIXQLZYPXRKXIU
      VGIELUVHXHUVGCIEXHIVRYOXOCBCXNWEACXNWEWKCIWMBYOAXOBCXNWLACXNWLWNWOUVGUVGI
      EXQYDYEUVGXPCXNEWPWQWRWSYOXOIXQWTXAXBXCXEXJXKXDXF $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d ph y $.
    bnj157.1 $e |- ( ps <-> A. y e. A ( y R x -> [. y / x ]. ph ) ) $.
    bnj157.2 $e |- A e. _V $.
    bnj157.3 $e |- R Fr A $.
    $( Well-founded induction restricted to a set ( ` A e. _V ` ).  The proof
       has been taken from Chapter 4 of Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj157 $p |- ( A. x e. A ( ps -> ph ) -> A. x e. A ph ) $=
      ( wfr wi wral bnj110 mpan ) EFJBAKCELACELIABCDEFHGMN $.
  $}

  ${
    $d A f $.  $d B f g $.  $d G f g $.  $d R f $.  $d Y g $.  $d d f g $.
    $d f g x $.
    bnj66.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d ) }
        $.
    bnj66.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj66.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G ` Y
        ) ) } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj66 $p |- ( g e. C -> Rel g ) $=
      ( cv wfn cfv cres cop wceq wrex wcel c-bnj14 wral wa wrel cab fneq1 fveq1
      reseq1 opeq2d syl6eqr fveq2d eqeq12d ralbidv anbi12d rexbidv cbvabv fnrel
      eqtr4i bnj1436 bnj1239 rexlimivw 3syl ) GNZDUAVDJNZOZANZVDPZVGVDBEVGUBZQZ
      RZHPZSZAVEUCZUDZJCTZVFJCTVDUEZVPGDDFNZVEOZVGVRPZIHPZSZAVEUCZUDZJCTZFUFVPG
      UFMVPWEGFVDVRSZVOWDJCWFVFVSVNWCVEVDVRUGWFVMWBAVEWFVHVTVLWAVGVDVRUHWFVKIHW
      FVKVGVRVIQZRIWFVJWGVGVDVRVIUIUJLUKULUMUNUOUPUQUSUTVFVNJCVAVFVQJCVEVDURVBV
      C $.
  $}

  ${
    $d A y $.  $d R y $.  $d f y $.  $d x y $.
    bnj91.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj91.2 $e |- Z e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj91 $p |- ( [. Z / y ]. ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $=
      ( wsbc c0 cv cfv c-bnj14 wceq sbcbii bnj525 bitri ) ACGJKFLMDEBLNOZCGJSAS
      CGHPSCGIQR $.
  $}

  ${
    $d A n $.  $d R n $.  $d Z i $.  $d f n $.  $d i n $.  $d n y $.
    bnj92.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e. (
        f ` i ) _pred ( y , A , R ) ) ) $.
    bnj92.2 $e |- Z e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj92 $p |- ( [. Z / n ]. ps
     <-> A. i e. om ( suc i e. Z
          -> ( f ` suc i ) = U_ y e. ( f ` i ) _pred ( y , A , R ) ) ) $=
      ( wsbc cv wcel cfv wi com wral cvv wb ax-mp csuc c-bnj14 ciun wceq sbcbii
      bnj538 sbcimg sbcel2gv bnj525 imbi12i bitri ralbii 3bitri ) AGHKFLZUAZGLM
      ZUOELZNBUNUQNCDBLUBUCUDZOZFPQZGHKUSGHKZFPQUOHMZUROZFPQAUTGHIUEUSFGHPJUFVA
      VCFPVAUPGHKZURGHKZOZVCHRMZVAVFSJUPURGHRUGTVDVBVEURVGVDVBSJGUOHRUHTURGHJUI
      UJUKULUM $.
  $}

  ${
    $d A x $.  $d R x $.
    $( Technical lemma for ~ bnj97 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj93 $p |- ( ( R _FrSe A /\ x e. A ) -> _pred ( x , A , R ) e. _V ) $=
      ( w-bnj15 cv c-bnj14 cvv wcel w-bnj13 wfr df-bnj15 simprbi df-bnj13 sylib
      wral r19.21bi ) BCDZBCAEFGHZABQBCIZRABOQBCJSBCKLABCMNP $.
  $}

  ${
    bnj95.1 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    $( Technical lemma for ~ bnj124 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj95 $p |- F e. _V $=
      ( c0 cv c-bnj14 cop csn cvv snex eqeltri ) DFBCAGHIZJKENLM $.
  $}

  ${
    $d x A $.  $d x R $.
    bnj96.1 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    $( Technical lemma for ~ bnj150 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Revised by Mario Carneiro, 6-May-2015.)
       (New usage is discouraged.) $)
    bnj96 $p |- ( ( R _FrSe A /\ x e. A ) -> dom F = 1o ) $=
      ( w-bnj15 cv wcel wa c-bnj14 cop csn cdm c1o cvv wceq bnj93 dmsnopg syl
      c0 dmeqi df1o2 3eqtr4g ) BCFAGZBHIZTBCUDJZKLZMZTLZDMNUEUFOHUHUIPABCQTUFOR
      SDUGEUAUBUC $.

    $( Technical lemma for ~ bnj150 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj97 $p |- ( ( R _FrSe A /\ x e. A ) -> ( F ` (/) ) = _pred ( x , A , R )
        ) $=
      ( w-bnj15 cv wcel wa wfun c-bnj14 cop cfv wceq cvv bnj93 csn 0ex bnj519
      c0 funeqi sylibr syl opex snid eleqtrri funopfv ee10 ) BCFAGZBHIZDJZTBCUI
      KZLZDHTDMULNUJULOHZUKABCPUNUMQZJUKTULRSDUOEUAUBUCUMUODUMTULUDUEEUFTULDUGU
      H $.
  $}

  ${
    $d i j $.  $d i x $.
    $( Technical lemma for ~ bnj150 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj98 $p |- A. i e. om ( suc i e. 1o -> ( F ` suc i ) = U_ y e. ( F ` i )
        _pred ( y , A , R ) ) $=
      ( vx cv csuc c1o wcel cfv c-bnj14 ciun wceq wi com c0 wn vex csn sucid wo
      n0i ax-mp cab cun df-suc df-un eqtri df1o2 eleq12i elsni sylbi syl5eq mto
      pm2.21i rgenw ) DGZHZIJZUSEKAUREKBCAGLMNZODPUTVAUTUSQNZURUSJVBRURDSUAUSUR
      UCUDUTUSFGZURJVCURTZJUBFUEZQUSURVDUFVEURUGFURVDUHUIZUTVEQTZJVEQNUSVEIVGVF
      UJUKVEQULUMUNUOUPUQ $.
  $}

  ${
    $d A f n $.  $d F f i y $.  $d R f n $.  $d i n y $.
    bnj106.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj106.2 $e |- F e. _V $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj106 $p |- ( [. F / f ]. [. 1o / n ]. ps
        <-> A. i e. om ( suc i e. 1o -> ( F ` suc i )
            = U_ y e. ( F ` i ) _pred ( y , A , R ) ) ) $=
      ( c1o wsbc cv cfv ciun wceq wi com wral fveq1 c-bnj14 bnj105 bnj92 sbcbii
      csuc wcel bnj1113 eqeq12d imbi2d ralbidv sbcie bitri ) AGKLZEHLFMZUEZKUFZ
      UOEMZNZBUNUQNZCDBMUAZOZPZQZFRSZEHLUPUOHNZBUNHNZUTOZPZQZFRSZUMVDEHABCDEFGK
      IUBUCUDVDVJEHJUQHPZVCVIFRVKVBVHUPVKURVEVAVGUOUQHTBUQHUSVFUTUNUQHTUGUHUIUJ
      UKUL $.
  $}

  ${
    $d A n $.  $d R n $.  $d f n $.  $d n x $.
    bnj118.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj118.2 $e |- ( ph' <-> [. 1o / n ]. ph ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj118 $p |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $=
      ( c1o wsbc c0 cv cfv c-bnj14 wceq bnj105 bnj91 bitri ) GAFJKLEMNCDBMOPIAB
      FCDEJHQRS $.
  $}

  ${
    $d A n $.  $d R n $.  $d f n $.  $d n x $.
    bnj121.1 $e |- ( ze <-> ( ( R _FrSe A /\ x e. A ) -> ( f Fn n /\ ph /\ ps )
        ) ) $.
    bnj121.2 $e |- ( ze' <-> [. 1o / n ]. ze ) $.
    bnj121.3 $e |- ( ph' <-> [. 1o / n ]. ph ) $.
    bnj121.4 $e |- ( ps' <-> [. 1o / n ]. ps ) $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj121 $p |- ( ze' <-> ( ( R _FrSe A /\ x e. A )
         -> ( f Fn 1o /\ ph' /\ ps' ) ) ) $=
      ( c1o wsbc cv w3a wi w-bnj15 wcel wa sbcbii bnj105 bnj90 bicomi 3anbi123i
      wfn sbc3an bitr4i imbi2i cvv wb nfv sbc19.21g ax-mp 3bitr4i ) CHPQEFUADRE
      UBUCZGRZHRUIZABSZTZHPQZKUSUTPUIZIJSZTZCVCHPLUDMVGUSVBHPQZTZVDVFVHUSVFVAHP
      QZAHPQZBHPQZSVHVEVJIVKJVLVJVEHGPUEUFUGNOUHVAABHPUJUKULPUMUBVDVIUNUEUSVBHP
      UMUSHUOUPUQUKUR $.
  $}

  ${
    $d A f $.  $d R f $.  $d f x z $.  $d z F $.
    bnj124.1 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    bnj124.2 $e |- ( ph" <-> [. F / f ]. ph' ) $.
    bnj124.3 $e |- ( ps" <-> [. F / f ]. ps' ) $.
    bnj124.4 $e |- ( ze" <-> [. F / f ]. ze' ) $.
    bnj124.5 $e |- ( ze' <-> ( ( R _FrSe A /\ x e. A ) -> ( f Fn 1o /\ ph' /\
        ps' ) ) ) $.
    $( Technical lemma for ~ bnj150 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj124 $p |- ( ze"
          <-> ( ( R _FrSe A /\ x e. A ) -> ( F Fn 1o /\ ph" /\ ps" ) ) ) $=
      ( wsbc cv c1o wfn vz w-bnj15 wcel wa w3a wi sbcbii cvv wb bnj95 sbc19.21g
      nfv ax-mp fneq1 sbcie2g bicomi bnj206 imbi2i 3bitri bitri ) KHDEQZBCUBARB
      UCUDZESTZIJUEZUFZOVAVBDRZSTZFGUEZUFZDEQZVBVHDEQZUFZVEHVIDEPUGEUHUCZVJVLUI
      ABCELUJZVBVHDEUHVBDULUKUMVKVDVBVGFGDEVCIJVGDEQZVCVMVOVCUIVNVGUARZSTVCDUAE
      UHSVFVPUNSVPEUNUOUMUPMNVNUQURUSUT $.
  $}

  ${
    $d A f n $.  $d F f $.  $d R f n $.  $d f n x $.
    bnj125.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj125.2 $e |- ( ph' <-> [. 1o / n ]. ph ) $.
    bnj125.3 $e |- ( ph" <-> [. F / f ]. ph' ) $.
    bnj125.4 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    $( Technical lemma for ~ bnj150 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj125 $p |- ( ph" <-> ( F ` (/) ) = _pred ( x , A , R ) ) $=
      ( wsbc c0 cfv cv wceq c1o bitri c-bnj14 sbcbii bnj105 bnj91 bnj95 eqeq1d
      fveq1 sbcie ) IHEGNZOGPZCDBQUAZRZLUIAFSNZEGNZULHUMEGKUBUNOEQZPZUKRZEGNULU
      MUQEGABFCDESJUCUDUBUQULEGBCDGMUEUOGRUPUJUKOUOGUGUFUHTTT $.
  $}

  ${
    $d A f n $.  $d F f i y $.  $d R f n $.  $d i n y $.
    bnj126.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj126.2 $e |- ( ps' <-> [. 1o / n ]. ps ) $.
    bnj126.3 $e |- ( ps" <-> [. F / f ]. ps' ) $.
    bnj126.4 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    $( Technical lemma for ~ bnj150 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj126 $p |- ( ps" <-> A. i e. om ( suc i e. 1o
        -> ( F ` suc i ) = U_ y e. ( F ` i ) _pred ( y , A , R ) ) ) $=
      ( wsbc c1o cv csuc cfv wcel c-bnj14 ciun wceq wi wral sbcbii bnj95 bnj106
      com 3bitri ) KJFIPAHQPZFIPGRZSZQUAUNITCUMITDECRUBUCUDUEGUJUFNJULFIMUGACDE
      FGHILBDEIOUHUIUK $.
  $}

  ${
    $d A n $.  $d R n $.  $d f n $.  $d n x $.
    bnj130.1 $e |- ( th <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn n /\ ph /\
        ps ) ) ) $.
    bnj130.2 $e |- ( ph' <-> [. 1o / n ]. ph ) $.
    bnj130.3 $e |- ( ps' <-> [. 1o / n ]. ps ) $.
    bnj130.4 $e |- ( th' <-> [. 1o / n ]. th ) $.
    $( Technical lemma for ~ bnj151 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj130 $p |- ( th'
        <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn 1o /\ ph' /\ ps' ) ) ) $=
      ( c1o wsbc cv w3a weu w-bnj15 wa wfn sbcbii bnj105 bnj90 bicomi 3anbi123i
      wcel wi sbc3an bitr4i eubii bnj89 imbi2i cvv nfv sbc19.21g ax-mp 3bitr4i
      wb ) CHPQEFUADREUIUBZGRZHRUCZABSZGTZUJZHPQZKVBVCPUCZIJSZGTZUJZCVGHPLUDOVL
      VBVFHPQZUJZVHVKVMVBVKVEHPQZGTVMVJVOGVJVDHPQZAHPQZBHPQZSVOVIVPIVQJVRVPVIHG
      PUEUFUGMNUHVDABHPUKULUMVEGHPUEUNULUOPUPUIVHVNVAUEVBVFHPUPVBHUQURUSULUT $.
  $}

  ${
    $d A f g x $.  $d R f g x $.  $d f ze1 $.  $d g ze0 $.
    bnj149.1 $e |- ( th1 <-> ( ( R _FrSe A /\ x e. A ) -> E* f ( f Fn 1o /\ ph'
        /\ ps' ) ) ) $.
    bnj149.2 $e |- ( ze0 <-> ( f Fn 1o /\ ph' /\ ps' ) ) $.
    bnj149.3 $e |- ( ze1 <-> [. g / f ]. ze0 ) $.
    bnj149.4 $e |- ( ph1 <-> [. g / f ]. ph' ) $.
    bnj149.5 $e |- ( ps1 <-> [. g / f ]. ps' ) $.
    bnj149.6 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj151 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj149 $p |- th1 $=
      ( wcel c0 w-bnj15 cv wa c1o wfn w3a wmo c-bnj14 cop csn wceq wal cfv wral
      wi wf simpr1 df1o2 fneq2i sylib simpr2 fvex elsnc sylibr 0ex fveq2 eleq1d
      ralsn ffnfv sylanbrc wb bnj93 adantr fsng sylancr mpbid ex alrimiv mo2icl
      cvv syl mpbir ) KBCUAAUBZBSUCZDUBZUDUEZFGUFZDUGZUOWDWGWETBCWCUHZUIUJZUKZU
      OZDULWHWDWLDWDWGWKWDWGUCZTUJZWIUJZWEUPZWKWMWEWNUEZEUBZWEUMZWOSZEWNUNZWPWM
      WFWQWDWFFGUQUDWNWEURUSUTWMTWEUMZWOSZXAWMXBWIUKZXCWMFXDWDWFFGVARUTXBWITWEV
      BVCVDWTXCETVEWRTUKWSXBWOWRTWEVFVGVHVDEWNWOWEVIVJWMTVTSWIVTSZWPWKVKVEWDXEW
      GABCVLVMTWIVTVTWEVNVOVPVQVRWGDWJVSWAMWB $.
  $}

  ${
    $d A f n x $.  $d F f i y $.  $d R f n x $.  $d f ze" $.  $d i n y $.
    bnj150.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj150.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj150.3 $e |- ( ze <-> ( ( R _FrSe A /\ x e. A ) -> ( f Fn n /\ ph /\ ps )
        ) ) $.
    bnj150.4 $e |- ( ph' <-> [. 1o / n ]. ph ) $.
    bnj150.5 $e |- ( ps' <-> [. 1o / n ]. ps ) $.
    bnj150.6 $e |- ( th0 <-> ( ( R _FrSe A /\ x e. A ) -> E. f ( f Fn 1o /\ ph'
        /\ ps' ) ) ) $.
    bnj150.7 $e |- ( ze' <-> [. 1o / n ]. ze ) $.
    bnj150.8 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    bnj150.9 $e |- ( ph" <-> [. F / f ]. ph' ) $.
    bnj150.10 $e |- ( ps" <-> [. F / f ]. ps' ) $.
    bnj150.11 $e |- ( ze" <-> [. F / f ]. ze' ) $.
    $( Technical lemma for ~ bnj151 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj150 $p |- th0 $=
      ( wex w-bnj15 cv wcel wa c1o wfn w3a wi c0 c-bnj14 cop csn wfun cvv bnj93
      0ex funsng sylancr funeqi sylibr bnj96 bnj1422 cfv wceq bnj97 bnj125 csuc
      jca ciun wral bnj98 bnj126 mpbir jctir df-3an bnj121 bnj124 bnj95 sbceq1a
      com wsbc syl6bbr spcev ax-mp 19.37v bitr4i bnj133 ) RNHUJZQWRQFGUKDULZFUM
      UNZKUOUPZOPUQZURWTXAOUNZPUNXBWTXCPWTXAOWTKUOWTUSFGWSUTZVAVBZVCZKVCWTUSVDU
      MXDVDUMXFVFDFGVEUSXDVDVDVGVHKXEUFVIVJDFGKUFVKVLWTUSKVMXDVNODFGKUFVOADFGHJ
      KLOSUBUGUFVPVJVRPIULZVQZUOUMXHKVMEXGKVMFGEULUTVSVNURIWJVTEFGIKWABDEFGHIJK
      MPTUCUHUFWBWCWDXAOPWEVJDFGHKLMNOPQUFUGUHUIABCDFGHJLMNUAUEUBUCWFZWGWCNQHKD
      FGKUFWHHULZKVNNNHKWKQNHKWIUIWLWMWNRWTXJUOUPLMUQZURZNHRWTXKHUJURXLHUJUDWTX
      KHWOWPXIWQWC $.
  $}

  ${
    $d A f g x $.  $d A f n x $.  $d F f i y $.  $d R f g x $.  $d R f n x $.
    $d f ze1 $.  $d f ze" $.  $d g ze0 $.  $d i n y $.  $d m n $.
    bnj151.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj151.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj151.3 $e |- D = ( om \ { (/) } ) $.
    bnj151.4 $e |- ( th <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn n /\ ph /\
        ps ) ) ) $.
    bnj151.5 $e |- ( ta <-> A. m e. D ( m _E n -> [. m / n ]. th ) ) $.
    bnj151.6 $e |- ( ze <-> ( ( R _FrSe A /\ x e. A ) -> ( f Fn n /\ ph /\ ps )
        ) ) $.
    bnj151.7 $e |- ( ph' <-> [. 1o / n ]. ph ) $.
    bnj151.8 $e |- ( ps' <-> [. 1o / n ]. ps ) $.
    bnj151.9 $e |- ( th' <-> [. 1o / n ]. th ) $.
    bnj151.10 $e |- ( th0 <-> ( ( R _FrSe A /\ x e. A ) -> E. f ( f Fn 1o /\
        ph' /\ ps' ) ) ) $.
    bnj151.11 $e |- ( th1 <-> ( ( R _FrSe A /\ x e. A ) -> E* f ( f Fn 1o /\
        ph' /\ ps' ) ) ) $.
    bnj151.12 $e |- ( ze' <-> [. 1o / n ]. ze ) $.
    bnj151.13 $e |- F = { <. (/) , _pred ( x , A , R ) >. } $.
    bnj151.14 $e |- ( ph" <-> [. F / f ]. ph' ) $.
    bnj151.15 $e |- ( ps" <-> [. F / f ]. ps' ) $.
    bnj151.16 $e |- ( ze" <-> [. F / f ]. ze' ) $.
    bnj151.17 $e |- ( ze0 <-> ( f Fn 1o /\ ph' /\ ps' ) ) $.
    bnj151.18 $e |- ( ze1 <-> [. g / f ]. ze0 ) $.
    bnj151.19 $e |- ( ph1 <-> [. g / f ]. ph' ) $.
    bnj151.20 $e |- ( ps1 <-> [. g / f ]. ps' ) $.
    $( Technical lemma for ~ bnj153 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj151 $p |- ( n = 1o -> ( ( n e. D /\ ta ) -> th ) ) $=
      ( cv c1o wceq wcel wa w-bnj15 wfn w3a weu wi wex wmo bnj150 bnj118 bnj149
      mpbi eu5 sylanbrc bnj130 mpbir wsbc sbceq1a syl6bbr mpbiri a1d ) OVJZVKVL
      ZCWOIVMDVNWPCSSHJVOFVJHVMVNZKVJVKVPQRVQZKVRZVSWQWRKVTZWRKWAZWSUDWQWTVSABE
      FGHJKMOPQRTUAUBUCUDUJUKUOUPUQUSVAVBVCVDVEWBUSWEUHWQXAVSFHJKLQRUEUFUGUHUIU
      TVFVGVHVIAFHJKOQUJUPWCWDUTWEWRKWFWGABCFHJKOQRSUMUPUQURWHWIWPCCOVKWJSCOVKW
      KURWLWMWN $.
  $}

  ${
    $d A f $.  $d R f $.  $d f g $.  $d f x $.
    bnj154.1 $e |- ( ph1 <-> [. g / f ]. ph' ) $.
    bnj154.2 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj153 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj154 $p |- ( ph1 <-> ( g ` (/) ) = _pred ( x , A , R ) ) $=
      ( cv wsbc c0 cfv c-bnj14 wceq sbcbii vex weq fveq1 eqeq1d sbcie 3bitri )
      GFDEJZKLDJZMZBCAJNZOZDUCKLUCMZUFOZHFUGDUCIPUGUIDUCEQDERUEUHUFLUDUCSTUAUB
      $.
  $}

  ${
    $d A f $.  $d R f $.  $d f g i y $.
    bnj155.1 $e |- ( ps1 <-> [. g / f ]. ps' ) $.
    bnj155.2 $e |- ( ps' <-> A. i e. om ( suc i e. 1o -> ( f ` suc i ) = U_ y
        e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj153 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj155 $p |- ( ps1 <-> A. i e. om ( suc i e. 1o
        -> ( g ` suc i ) = U_ y e. ( g ` i ) _pred ( y , A , R ) ) ) $=
      ( cv wsbc csuc cfv ciun wceq wi com wral fveq1 c1o c-bnj14 sbcbii vex weq
      wcel iuneq1d eqeq12d imbi2d ralbidv sbcie 3bitri ) HGDEKZLFKZMZUAUFZUODKZ
      NZAUNUQNZBCAKUBZOZPZQZFRSZDUMLUPUOUMNZAUNUMNZUTOZPZQZFRSZIGVDDUMJUCVDVJDU
      MEUDDEUEZVCVIFRVKVBVHUPVKURVEVAVGUOUQUMTVKAUSVFUTUNUQUMTUGUHUIUJUKUL $.
  $}

  ${
    $d A f g i x y $.  $d A f i n x y $.  $d R f g i x y $.  $d R f i n x y $.
    $d m n $.
    bnj153.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj153.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj153.3 $e |- D = ( om \ { (/) } ) $.
    bnj153.4 $e |- ( th <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn n /\ ph /\
        ps ) ) ) $.
    bnj153.5 $e |- ( ta <-> A. m e. D ( m _E n -> [. m / n ]. th ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj153 $p |- ( n = 1o -> ( ( n e. D /\ ta ) -> th ) ) $=
      ( wsbc biid vg w-bnj15 cv wcel wa wfn w3a wi c0 c-bnj14 cop csn wceq csuc
      cfv c1o ciun com wex wmo bnj118 bicomi bnj105 bnj92 bnj121 anbi2i anbi12i
      wral df-3an 3bitr4i imbi2i eqid sbcbii bnj124 bnj125 bnj126 bitr2i bnj156
      bitri bnj154 bnj155 bitr3i bnj151 ) ABCDGIUBEUCZGUDUEZJUCZMUCUFABUGUHZEFG
      HIJUAKLMUIGIWDUJZUKULZUIWFUOWHUMZKUCZUNZUPUDZWLWFUOFWKWFUOGIFUCUJZUQUMUHK
      URVHZCMUPSZWEWFUPUFZWJWOUGZUHZWJJWISZWOJWISZWEWIUPUFZUIWIUOWHUMZWMWLWIUOF
      WKWIUOWNUQUMUHKURVHZUGZUHZWEWRJUSUHZWRWJJUAUCZSZWOJXHSZWEWRJUTUHZXHUPUFZU
      IXHUOWHUMZWMWLXHUOFWKXHUOWNUQUMUHKURVHZUGZNOPQRWGTZAMUPSZWJAEGIJMXQNXQTZV
      AZVBBMUPSZWOBFGIJKMUPOVCVDZVBWPTXGTXKTWGMUPSZWSYBWEWQXQXTUGZUHWSABWGEGIJM
      XQXTYBXPYBTXRXTTZVEZYCWRWEWQXQUEZXTUEWQWJUEZWOUEYCWRYFYGXTWOXQWJWQXSVFYAV
      GWQXQXTVIWQWJWOVIVJZVKVSVBZWIVLZWTTXATWSJWISYBJWISZXFWSYBJWIYIVMYKWEXBXQJ
      WISZXTJWISZUGZUHXFEGIJWIXQXTYBYLYMYKYJYLTZYMTZYKTYEVNYNXEWEXBYLUEZYMUEXBX
      CUEZXDUEYNXEYQYRYMXDYLXCXBAEGIJMWIXQYLNXRYOYJVOVFBEFGIJKMWIXTYMOYDYPYJVPV
      GXBYLYMVIXBXCXDVIVJVKVSVQWRTXOYCJXHSZWRJXHSYSXLXQJXHSZXTJXHSZUGZXOJUAXQXT
      YCYTUUAYSYCTYSTYTTZUUATZVRXLYTUEZUUAUEXLXMUEZXNUEUUBXOUUEUUFUUAXNYTXMXLEG
      IJUAXQYTUUCXSVTVFFGIJUAKXTUUAUUDXTXTWOYDYAVSWAVGXLYTUUAVIXLXMXNVIVJVSYCWR
      JXHYHVMWBXITXJTWC $.
  $}

  ${
    $d A n $.  $d M f $.  $d R n $.  $d f n $.  $d n x $.
    bnj207.1 $e |- ( ch <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn n /\ ph /\
        ps ) ) ) $.
    bnj207.2 $e |- ( ph' <-> [. M / n ]. ph ) $.
    bnj207.3 $e |- ( ps' <-> [. M / n ]. ps ) $.
    bnj207.4 $e |- ( ch' <-> [. M / n ]. ch ) $.
    bnj207.5 $e |- M e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj207 $p |- ( ch' <-> ( ( R _FrSe A /\ x e. A )
        -> E! f ( f Fn M /\ ph' /\ ps' ) ) ) $=
      ( wsbc cv bitri w-bnj15 wcel wa wfn w3a weu wi sbcbii cvv sbc19.21g ax-mp
      wb nfv bnj89 bnj90 bicomi bnj206 eubii imbi2i ) LCHIRZEFUADSEUBUCZGSZIUDZ
      JKUEZGUFZUGZPUTVAVBHSUDZABUEZGUFZUGZHIRZVFCVJHIMUHVKVAVIHIRZUGZVFIUIUBVKV
      MULQVAVIHIUIVAHUMUJUKVLVEVAVLVHHIRZGUFVEVHGHIQUNVNVDGVGABHIVCJKVGHIRVCHGI
      QUOUPNOQUQURTUSTTT $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.
    $( First-order logic and set theory.  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj213 $p |- _pred ( X , A , R ) C_ A $=
      ( vy cv wbr c-bnj14 df-bnj14 bnj21 ) DECBFDAABCGDABCHI $.
  $}

  ${
    $d A i m $.  $d F i m y $.  $d N i m $.  $d R i m $.
    bnj222.1 $e |- ( ps <-> A. i e. om ( suc i e. N -> ( F ` suc i ) = U_ y e.
        ( F ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj229 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj222 $p |- ( ps <-> A. m e. om ( suc m e. N -> ( F ` suc m ) = U_ y e. (
        F ` m ) _pred ( y , A , R ) ) ) $=
      ( cv csuc wcel cfv c-bnj14 ciun wceq wi com wral suceq eleq1d fveq2 bitri
      fveq2d bnj1113 eqeq12d imbi12d cbvralv ) AEJZKZHLZUJGMZBUIGMZCDBJNZOZPZQZ
      ERSFJZKZHLZUSGMZBURGMZUNOZPZQZFRSIUQVEEFRUIURPZUKUTUPVDVFUJUSHUIURTZUAVFU
      LVAUOVCVFUJUSGVGUDBUIURUMVBUNUIURGUBUEUFUGUHUC $.
  $}

  ${
    $d A i m y $.  $d F i m y $.  $d N i m $.  $d R i m $.
    bnj229.1 $e |- ( ps <-> A. i e. om ( suc i e. N -> ( F ` suc i ) = U_ y e.
        ( F ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj517 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj229 $p |- ( ( n e. N /\ ( suc m = n /\ m e. om /\ ps ) ) -> ( F ` n ) C_
        A ) $=
      ( cv wcel csuc wceq com w3a wa cfv c-bnj14 wi bnj213 bnj226 bnj222 bnj228
      ciun adantl eleq1 fveq2 eqeq1d imbi12d adantr mpbid 3impb impcom bnj1262
      wb ) GKZILZFKZMZUQNZUSOLZAPZQBUSHRZCDBKZSZUEZCUQHRZBVDVFCCDVEUAUBVCURVHVG
      NZVAVBAURVITZVAVBAQZQUTILZUTHRZVGNZTZVJVKVOVAAVOFOABCDEFHIJUCUDUFVAVOVJUP
      VKVAVLURVNVIUTUQIUGVAVMVHVGUTUQHUHUIUJUKULUMUNUO $.
  $}

  ${
    $d i m n y A $.  $d i m n F $.  $d i m n N $.  $d m ph $.  $d m ps $.
    bnj517.1 $e |- ( ph <-> ( F ` (/) ) = _pred ( X , A , R ) ) $.
    bnj517.2 $e |- ( ps <-> A. i e. om ( suc i e. N -> ( F ` suc i ) = U_ y e.
        ( F ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj518 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj517 $p |- ( ( N e. om /\ ph /\ ps ) -> A. n e. N ( F ` n ) C_ A ) $=
      ( vm com wcel cv cfv wss wral wceq w3a wa c0 csuc wrex fveq2 simpl2 sylib
      c-bnj14 sylan9eqr bnj213 syl6eqss wi ciun eleq1 biimpd eqeq1d rgenw iunss
      r19.29r mpbir sseq1 mpbiri syl6bir imim12d rexlimivw com3l sylbi 3ad2ant3
      imp syl ex imp31 wo simpr simpl1 syl2anc nn0suc mpjaodan ralrimiva sseq1d
      elnn cbvralv ) INOZABUAZMPZHQZDRZMISGPZHQZDRZGISWEWHMIWEWFIOZUBZWFUCTZWHW
      FFPZUDZTZFNUEZWMWNUBWGDEJUIZDWNWMWGUCHQZWSWFUCHUFWMAWTWSTWDABWLUGKUHUJDEJ
      UKULWEWLWRWHBWDWLWRWHUMUMZABWPIOZWPHQZCWOHQZDECPZUIZUNZTZUMZFNSZXALWRXJWL
      WHWRXJWLWHUMZWRXJUBWQXIUBZFNUEXKWQXIFNUTXLXKFNWQXIXKWQWLXBXHWHWQWLXBWFWPI
      UOUPWQXHWGXGTZWHWQWGXCXGWFWPHUFUQXMWHXGDRZXNXFDRZCXDSXOCXDDEXEUKURCXDXFDU
      SVAWGXGDVBVCVDVEVJVFVKVLVGVHVIVMWMWFNOZWNWRVNWMWLWDXPWEWLVOWDABWLVPWFIWBV
      QFWFVRVKVSVTWHWKMGIWFWITWGWJDWFWIHUFWAWCUH $.
  $}

  ${
    $d f i p y $.  $d i n p $.  $d i p y A $.  $d y R $.
    bnj518.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj518.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj518.3 $e |- ( ta <-> ( ph /\ ps /\ n e. om /\ p e. n ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj518 $p |- ( ( R _FrSe A /\ ta ) -> A. y e. ( f ` p ) _pred ( y , A , R )
        e. _V ) $=
      ( w-bnj15 cv wcel w-bnj17 wa sylbi cfv wss c-bnj14 cvv wral com bitri w3a
      bnj334 df-bnj17 bnj517 r19.21bi ssel bnj93 ex sylan9r ralrimiv sylan2 ) C
      FGOZKPZHPZUAZFUBZFGEPZUCUDQZEVBUECJPZUFQZABUTVFQZRZVCCABVGVHRVINABVGVHUIU
      GVIVGABUHZVHSVCVGABVHUJVJVCKVFABEFGIKVAVFDPLMUKULTTUSVCSVEEVBVCVDVBQVDFQZ
      USVEVBFVDUMUSVKVEEFGUNUOUPUQUR $.
  $}

  ${
    $d A n $.  $d F n $.  $d R n $.  $d X n $.
    bnj523.1 $e |- ( ph <-> ( F ` (/) ) = _pred ( X , A , R ) ) $.
    bnj523.2 $e |- ( ph' <-> [. M / n ]. ph ) $.
    bnj523.3 $e |- M e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj523 $p |- ( ph' <-> ( F ` (/) ) = _pred ( X , A , R ) ) $=
      ( wsbc c0 cfv c-bnj14 wceq sbcbii bnj525 3bitri ) HADFLMENBCGOPZDFLTJATDF
      IQTDFKRS $.
  $}

  ${
    $d A f $.  $d G f $.  $d R f $.  $d X f $.
    bnj526.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj526.2 $e |- ( ph" <-> [. G / f ]. ph ) $.
    bnj526.3 $e |- G e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj526 $p |- ( ph" <-> ( G ` (/) ) = _pred ( X , A , R ) ) $=
      ( wsbc c0 cv cfv c-bnj14 wceq sbcbii fveq1 eqeq1d sbcie 3bitri ) GADEKLDM
      ZNZBCFOZPZDEKLENZUDPZIAUEDEHQUEUGDEJUBEPUCUFUDLUBERSTUA $.
  $}

  ${
    bnj528.1 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R ) >.
        } ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj528 $p |- G e. _V $=
      ( cv cfv c-bnj14 ciun bnj918 ) AGIDIJBCAIKLDEFHM $.
  $}

  ${
    $d A i p y $.  $d R i p y $.  $d f i p y $.  $d i m p $.  $d p ph' $.
    bnj535.1 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj535.2 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj535.3 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R ) >.
        } ) $.
    bnj535.4 $e |- ( ta <-> ( ph' /\ ps' /\ m e. om /\ p e. m ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj535 $p |- ( ( R _FrSe A /\ ta /\ n = ( m u. { m } ) /\ f Fn m ) -> G Fn
        n ) $=
      ( cv wfn cvv w-bnj15 csn cun wceq w-bnj17 bnj422 bnj251 bitri cfv c-bnj14
      ciun cop wcel wfun wral fvex bnj518 iunexg sylancr vex bnj519 syl dmsnopg
      wa cdm bnj1422 cin c0 bnj521 mpan2 sylan2 fneq1i sylibr fneq2 syl5ibr imp
      fnun sylbi ) DEUAZAIRZHRZWAUBZUCZUDZFRZWASZUEZWDWFVSAVDZVDZVDZJVTSZWGWDWF
      VSAUEWJVSAWDWFUFWDWFVSAUGUHWDWIWKWIWKWDJWCSZWIWEWACKRZWEUIZDECRUJZUKZULUB
      ZUCZWCSZWLWHWFWQWBSZWSWHWQWBWHWPTUMZWQUNWHWNTUMWOTUMCWNUOXAWMWEUPLMABCDEF
      GHKNOQUQCWNWOTTURUSZWAWPHUTVAVBWHXAWQVEWBUDXBWAWPTVCVBVFWFWTVDWAWBVGVHUDW
      SWAVIWAWBWEWQVQVJVKWCJWRPVLVMVTWCJVNVOVPVR $.
  $}

  ${
    $d A n $.  $d F n $.  $d M i $.  $d R n $.  $d i n $.  $d n y $.
    bnj539.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( F ` suc i ) = U_ y e.
        ( F ` i ) _pred ( y , A , R ) ) ) $.
    bnj539.2 $e |- ( ps' <-> [. M / n ]. ps ) $.
    bnj539.3 $e |- M e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj539 $p |- ( ps' <-> A. i e. om ( suc i e. M
        -> ( F ` suc i ) = U_ y e. ( F ` i ) _pred ( y , A , R ) ) ) $=
      ( wsbc cv wcel wi com wral cvv bitri csuc c-bnj14 ciun wceq sbcbii bnj538
      cfv wb sbcimg ax-mp sbcel2gv bnj525 imbi12i ralbii ) IAFHMZENZUAZHOZUQGUG
      BUPGUGCDBNUBUCUDZPZEQRZKUOUQFNOZUSPZEQRZFHMZVAAVDFHJUEVEVCFHMZEQRVAVCEFHQ
      LUFVFUTEQVFVBFHMZUSFHMZPZUTHSOZVFVIUHLVBUSFHSUIUJVGURVHUSVJVGURUHLFUQHSUK
      UJUSFHLULUMTUNTTT $.
  $}

  ${
    $d A f $.  $d G f i y $.  $d N f $.  $d R f $.
    bnj540.1 $e |- ( ps <-> A. i e. om ( suc i e. N -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj540.2 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj540.3 $e |- G e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj540 $p |- ( ps" <-> A. i e. om ( suc i e. N
        -> ( G ` suc i ) = U_ y e. ( G ` i ) _pred ( y , A , R ) ) ) $=
      ( wsbc cv wcel cfv wceq wi com wral csuc c-bnj14 sbcbii bnj538 cvv sbcimg
      ciun wb ax-mp ralbii 3bitri bnj525 fveq1 bnj1113 eqeq12d sbcie imbi12i )
      IAEGMZFNZUAZHOZEGMZUTENZPZBUSVCPZCDBNUBZUGZQZEGMZRZFSTZVAUTGPZBUSGPZVFUGZ
      QZRZFSTKURVAVHRZFSTZEGMVQEGMZFSTVKAVREGJUCVQFEGSLUDVSVJFSGUEOVSVJUHLVAVHE
      GUEUFUIUJUKVJVPFSVBVAVIVOVAEGLULVHVOEGLVCGQVDVLVGVNUTVCGUMBVCGVEVMVFUSVCG
      UMUNUOUPUQUJUK $.
  $}

  ${
    $d A i p y $.  $d R i p y $.  $d f i p y $.  $d i m p $.  $d p ph' $.
    bnj543.1 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj543.2 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj543.3 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R ) >.
        } ) $.
    bnj543.4 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj543.5 $e |- ( si <-> ( m e. om /\ n = suc m /\ p e. m ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj543 $p |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $=
      ( wa w-bnj15 w3a cv com wcel w-bnj17 csuc wceq bnj257 bnj268 bitri bnj253
      wfn bnj256 3bitr3i 3anbi1i bnj170 3anan32 anbi12i 3bitr4ri anbi2i 3bitr4i
      3anass bnj252 csn cun df-suc eqeq2i 3anbi2i biid bnj535 sylbi ) EFUAZABUB
      ZVMMNIUCZUDUEZLUCVOUEZUFZJUCZVOUGZUHZGUCVOUMZUFZKVSUMZVMABTZTVMVRWAWBUBZT
      ZVNWCWEWFVMMNTZVPVQTZTZWAWBUBZWHWBTZWIWATZTZWFWEWHWIWAWBUFZWHWBWIWAUFZWKW
      NWOWHWIWBWAUFWPWHWIWAWBUIWHWIWBWAUJUKWHWIWAWBULWHWBWIWAUNUOVRWJWAWBMNVPVQ
      UNUPAWLBWMAWBMNUBWLRWBMNUQUKBVPWAVQUBWMSVPWAVQURUKUSUTVAVMABVCVMVRWAWBVDZ
      VBWCVMVRVSVOVOVEVFZUHZWBUFZWDWGVMVRWSWBUBZTWCWTWFXAVMWAWSVRWBVTWRVSVOVGVH
      VIVAWQVMVRWSWBVDVBVRCDEFGHIJKLMNOPQVRVJVKVLVL $.
  $}

  ${
    $d A i p y $.  $d R i p y $.  $d f i p y $.  $d i m p $.  $d p ph' $.
    bnj544.1 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj544.2 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj544.3 $e |- D = ( om \ { (/) } ) $.
    bnj544.4 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R ) >.
        } ) $.
    bnj544.5 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj544.6 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj544 $p |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $=
      ( w-bnj15 cv com wcel csuc wceq w3a wfn bnj923 3anim1i sylbi biid syl3an3
      bnj543 ) BEGUBAJUCZUDUEZKUCZUPUFUGZMUCUPUEZUHZLURUIBUPFUEZUSUTUHVAUAVBUQU
      SUTFJRUJUKULAVACDEGHIJKLMNOPQSTVAUMUOUN $.
  $}

  ${
    bnj545.1 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj545.2 $e |- D = ( om \ { (/) } ) $.
    bnj545.3 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R ) >.
        } ) $.
    bnj545.4 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj545.5 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj545.6 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    bnj545.7 $e |- ( ph" <-> ( G ` (/) ) = _pred ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj545 $p |- ( ( R _FrSe A /\ ta /\ si ) -> ph" ) $=
      ( w-bnj15 w3a c0 cfv cv wceq wfun wss cdm wcel wa simp1bi anim12i 3adant1
      wfn csuc bnj529 fndm biimparc syl2anr syl bnj930 jca c-bnj14 ciun cop csn
      eleq2 bnj931 jctil df-3an 3anrot 3bitr3i funssfv simp2bi 3ad2ant2 sylan2b
      ancom sylibr eqtr syl2anc ) EGUCZABUDZUEKUFZUEHUGZUFZUHZMOWEKUIZWGKUJZUEW
      GUKZULZUDZWIWEWKWMWJUMZUMZWNWEWOWKWEWMWJWEWGIUGZUQZWQFULZUMZWMABWTWDAWRBW
      SAWRMNSUNBWSJUGZWQURUHLUGZWQULTUNUOUPWSUEWQULZWLWQUHZWMWRFWQQUSWQWGUTXDWM
      XCWLWQUEVJVAVBVCWEXAKUAVDVEKWGWQDXBWGUFEGDUGVFVGVHVIRVKVLWMWJWKUDWOWKUMWN
      WPWMWJWKVMWMWJWKVNWOWKVTVOWAUEKWGVPVCAWDMBAWRMNSVQVRWIMUMWFEGCUGVFZUHZOMW
      IWHXEUHXFPWFWHXEWBVSUBWAWC $.
  $}

  ${
    $d A i p y $.  $d R i p y $.  $d f i p y $.  $d i m p $.  $d p ph' $.
    bnj546.1 $e |- D = ( om \ { (/) } ) $.
    bnj546.2 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj546.3 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj546.4 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj546.5 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj546 $p |- ( ( R _FrSe A /\ ta /\ si ) -> U_ y e. ( f ` p ) _pred ( y , A
        , R ) e. _V ) $=
      ( wcel w-bnj15 w3a cv com w-bnj17 wa c-bnj14 cvv cfv wral ciun wfn 3simpc
      sylbi csuc wceq bnj923 3ad2ant1 simp3 jca bnj256 sylibr anim2i 3impb biid
      anim12i bnj518 fvex iunexg mpan 3syl ) EGUAZABUBVLMNJUCZUDTZLUCZVMTZUEZUF
      ZEGDUCUGZUHTDVOHUCZUIZUJZDWAVSUKUHTZVLABVRABUFZVQVLWDMNUFZVNVPUFZUFVQAWEB
      WFAVTVMULZMNUBWEPWGMNUMUNBVMFTZKUCVMUOUPZVPUBZWFQWJVNVPWHWIVNVPFJOUQURWHW
      IVPUSUTUNVFMNVNVPVAVBVCVDMNVQCDEGHIJLRSVQVEVGWAUHTWBWCVOVTVHDWAVSUHUHVIVJ
      VK $.
  $}

  ${
    $d G y $.  $d f y $.  $d i y $.
    bnj548.1 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj548.2 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj548.3 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj548.4 $e |- G = ( f u. { <. m , C >. } ) $.
    bnj548.5 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj548 $p |- ( ( ( R _FrSe A /\ ta /\ si ) /\ i e. m ) -> B = K ) $=
      ( w-bnj15 w3a cv wcel wa wfun wss cdm cfv wceq bnj930 adantr simp1bi fndm
      wfn eleq2 biimpar sylan 3ad2antl2 jca cop csn bnj931 jctil 3anan12 sylibr
      funssfv c-bnj14 ciun iuneq1 eqcomd 3eqtr4g 3syl ) DGUAZABUBZIUCZJUCZUDZUE
      ZLUFZHUCZLUGZVPWAUHZUDZUBZVPLUIZVPWAUIZUJZEMUJVSWBVTWDUEZUEWEVSWIWBVSVTWD
      VOVTVRVOKUCLTUKULAVNVRWDBAWAVQUOZVRWDAWJNOPUMWJWCVQUJZVRWDVQWAUNWKWDVRWCV
      QVPUPUQURURUSUTLWAVQFVAVBSVCVDVTWBWDVEVFVPLWAVGWHCWGDGCUCVHZVIZCWFWLVIZEM
      WHWNWMCWFWGWLVJVKQRVLVM $.
  $}

  ${
    $d A i p y $.  $d G y $.  $d R i p y $.  $d f i p y $.  $d i m p $.
    $d p ph' $.
    bnj553.1 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj553.2 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj553.3 $e |- D = ( om \ { (/) } ) $.
    bnj553.4 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R ) >.
        } ) $.
    bnj553.5 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj553.6 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj553.7 $e |- C = U_ y e. ( f ` p ) _pred ( y , A , R ) $.
    bnj553.8 $e |- G = ( f u. { <. m , C >. } ) $.
    bnj553.9 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj553.10 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj553.11 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj553.12 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj553 $p |- ( ( ( R _FrSe A /\ ta /\ si ) /\ i e. m /\ p = i ) -> ( G ` m
        ) = L ) $=
      ( w-bnj15 w3a wcel wceq cfv wfun cop bnj930 csn cun opex snid elun2 ax-mp
      eleqtrri funopfv ee10 3ad2ant1 c-bnj14 ciun fveq2 bnj1113 3ad2ant3 bnj548
      cv 3eqtr4g 3adant3 eqeq12i eqcom bitri sylibr 3eqtr2rd eqtrd ) EIULABUMZK
      VPZLVPZUNZQVPZWFUOZUMZWGNUPZGPWEWHWLGUOZWJWENUQWGGURZNUNWMWEMVPNUKUSWNJVP
      ZWNUTZVAZNWNWPUNWNWQUNWNWGGVBVCWNWPWOVDVEUGVFWGGNVGVHVIWKPOFGWJWEPOUOWHWJ
      DWINUPZEIDVPVJZVKDWFNUPZWSVKPODWIWFWRWTWSWIWFNVLVMUJUIVQVNWEWHFOUOWJABDEF
      DWIWOUPZWSVKZIJKLMNORSUDUHUIUCUKVOVRWJWEFGUOZWHWJXBDWFWOUPZWSVKZUOZXCDWIW
      FXAXDWSWIWFWOVLVMXCXEXBUOXFFXEGXBUHUFVSXEXBVTWAWBVNWCWD $.
  $}

  ${
    $d G y $.  $d i y $.  $d p y $.
    bnj554.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj554.20 $e |- ( ze <-> ( i e. om /\ suc i e. n /\ m = suc i ) ) $.
    bnj554.21 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj554.22 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj554.23 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj554.24 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj554 $p |- ( ( et /\ ze ) -> ( ( G ` m ) = L <-> ( G ` suc i ) = K ) ) $=
      ( wceq cv csuc cfv wb wcel com bnj1254 simp3bi simpr bnj551 fveq2 c-bnj14
      wa ciun iuneq1 3eqtr4g syl eqeqan12d syl2anc syl2an ) AHUAZMUAZUBTZVAGUAZ
      UBZTZVAJUCZLTVEJUCZKTUDZBAVAEUEIUAZVAUBTVBUFUEVCNUGBVDUFUEVEVJUEVFOUHVCVF
      UMVFVBVDTZVIVCVFUIGHMUJVFVKVGVHLKVAVEJUKVKVBJUCZVDJUCZTZLKTVBVDJUKVNCVLDF
      CUAULZUNCVMVOUNLKCVLVMVOUOSRUPUQURUSUT $.
  $}

  ${
    bnj556.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj556.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj556 $p |- ( et -> si ) $=
      ( cv wcel csuc wceq w3a com wa vex bnj216 3anim3i adantr w-bnj17 3imtr4i
      bnj258 bitri ) DIZCJZEIUDKLZUDFIZKLZMZUGNJZOZUEUFUGUDJZMZABUIUMUJUHULUEUF
      UDUGFPQRSAUEUFUJUHTUKHUEUFUJUHUBUCGUA $.
  $}

  ${
    $d A i p y $.  $d G y $.  $d R i p y $.  $d f i p y $.  $d i m p $.
    $d p ph' $.
    bnj557.3 $e |- D = ( om \ { (/) } ) $.
    bnj557.16 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R )
        >. } ) $.
    bnj557.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj557.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj557.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj557.20 $e |- ( ze <-> ( i e. om /\ suc i e. n /\ m = suc i ) ) $.
    bnj557.21 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj557.22 $e |- C = U_ y e. ( f ` p ) _pred ( y , A , R ) $.
    bnj557.23 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj557.24 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj557.25 $e |- G = ( f u. { <. m , C >. } ) $.
    bnj557.28 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj557.29 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y
        e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj557.36 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj557 $p |- ( ( R _FrSe A /\ ta /\ et /\ ze ) -> ( G ` m ) = L ) $=
      ( w-bnj15 w-bnj17 w3a wcel wceq cfv df-bnj17 bnj256 bitr3i bnj556 3anim3i
      cv wa com csuc bnj216 bnj837 anim12i sylbir bnj1254 simp3bi bnj551 syl2an
      vex adantl jca df-3an 3imtr4i bnj553 syl ) GKUPZABCUQZWFADURZMVGZNVGZUSZS
      VGZWIUTZURZWJPVARUTWFAVHZBCVHZVHZWHWKVHZWMVHWGWNWQWRWMWQWFABURZCVHZWRWTWG
      WQWFABCVBWFABCVCZVDWSWHCWKBDWFABDJNOSUEUFVEVFWIVIUSZWIVJZOVGZUSZWJXCUTZWK
      CUGWJWIMVSVKVLVMVNWPWMWOBWJWLVJUTZXFWMCBWJJUSXDWJVJUTWLVIUSXGUFVOCXBXEXFU
      GVPMNSVQVRVTWAXAWHWKWMWBWCADEFGHIJKLMNOPQRSTUAUMUNUBUCUDUEUIULUHUJUKUOWDW
      E $.
  $}

  ${
    $d A i p y $.  $d G y $.  $d R i p y $.  $d f i p y $.  $d i m p $.
    $d p ph' $.
    bnj558.3 $e |- D = ( om \ { (/) } ) $.
    bnj558.16 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R )
        >. } ) $.
    bnj558.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj558.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj558.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj558.20 $e |- ( ze <-> ( i e. om /\ suc i e. n /\ m = suc i ) ) $.
    bnj558.21 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj558.22 $e |- C = U_ y e. ( f ` p ) _pred ( y , A , R ) $.
    bnj558.23 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj558.24 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj558.25 $e |- G = ( f u. { <. m , C >. } ) $.
    bnj558.28 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj558.29 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y
        e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj558.36 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj558 $p |- ( ( R _FrSe A /\ ta /\ et /\ ze ) -> ( G ` suc i ) = K ) $=
      ( w-bnj15 w-bnj17 cv cfv wceq csuc bnj557 wa wb w3a bnj422 bnj253 simp1bi
      bitri bnj554 syl mpbid ) GKUPZABCUQZNURPUSRUTZMURVAPUSQUTZABCDEFGHIJKLMNO
      PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVBVNBCVCZVOVPVDVNVQVMAVNBCVMAUQVQVMAVE
      VMABCVFBCVMAVGVIVHBCFGJKMNOPQRSUFUGUJUKUJUKVJVKVL $.
  $}

  ${
    bnj561.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj561.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj561.37 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj561 $p |- ( ( R _FrSe A /\ ta /\ et ) -> G Fn n ) $=
      ( w-bnj15 cv wfn bnj556 syl3an3 ) BDFNACIHOPBCEGHJKLQMR $.
  $}

  ${
    bnj562.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj562.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj562.38 $e |- ( ( R _FrSe A /\ ta /\ si ) -> ph" ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj562 $p |- ( ( R _FrSe A /\ ta /\ et ) -> ph" ) $=
      ( w-bnj15 bnj556 syl3an3 ) BDFNACJBCEGHIKLOMP $.
  $}

  ${
    $d G y $.  $d f y $.  $d i y $.
    bnj570.3 $e |- D = ( om \ { (/) } ) $.
    bnj570.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj570.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj570.21 $e |- ( rh <-> ( i e. om /\ suc i e. n /\ m =/= suc i ) ) $.
    bnj570.24 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj570.26 $e |- G = ( f u. { <. m , C >. } ) $.
    bnj570.40 $e |- ( ( R _FrSe A /\ ta /\ et ) -> G Fn n ) $.
    bnj570.30 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y
        e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj570 $p |- ( ( R _FrSe A /\ ta /\ et /\ rh ) -> ( G ` suc i ) = K ) $=
      ( w-bnj15 w-bnj17 cv csuc cfv c-bnj14 ciun wa wceq bnj251 com wfn simp3bi
      wcel wne simp1bi adantl bnj563 jca wi bnj946 sp sylbi imp32 syl2an bnj833
      wal wfun w3a bnj930 bnj721 wss cop csn bnj931 a1i cdm bnj667 bnj564 eleq2
      biimpar 3impb syl bnj1502 word bnj252 simplbi c0 cdif eldifi eleq2s nnord
      3syl adantr anim12i elelsuc ordsucelsuc sylan2 iuneq1d 3eqtr4d syl6eqr
      fndm ) EHUFZABCUGZJUHZUIZMUJZDXJMUJZEHDUHUKZULZNXIXKIUHZUJZDXJXPUJZXNULZX
      LXOXHABCUMZUMZXQXSUNZXIXHABCUOAQXJUPUSZXKKUHZUSZUMYBXTAXPYDUQZPQSURXTYCYE
      CYCBCYCXKLUHZUSYDXKUTUAVAVBBCGJKLOTUAVCZVDQYCYEYBQYCYEYBVEZVEZJVLYJQYIJUP
      UEVFYJJVGVHVIVJVKXIXKMXPXHABCMVMXHABVNYGMUDVOVPZXPMVQXIMXPYDFVRVSUCVTWAZX
      IABCVNZXKXPWBZUSZXHABCWCZABCYOAYNYDUNZYEYOXTAIKPQSWDYHYQYOYEYNYDXKWEWFVJW
      GWHWIXIDXMXRXNXIXJMXPYKYLXIYMXJYNUSZYPABCYRYAYFYDWJZYEUMZUMYQXJYDUSZUMYRA
      YFXTYTAYFPQSVAXTYSYEBYSCBYDGUSZYDUPUSZYSBUUBYGYDUIZUNZOUHZUPUSZYDUUFUIUNZ
      UGZUUBTUUIUUBUUEUUGUUHVNUUBUUEUUGUUHWKWLVHUUCYDUPWMVSZWNGYDUPUUJWORWPYDWQ
      WRWSYHVDWTYFYQYTUUAYDXPXGYEYSXKUUDUSZUUAXKYDXAYSUUAUUKXJYDXBWFXCWTYQYRUUA
      YNYDXJWEWFWRWGWHWIXDXEUBXF $.
  $}

  ${
    $d A i p y $.  $d G y $.  $d R i p y $.  $d et i $.  $d f i p y $.
    $d i m p $.  $d i p ph' $.
    bnj571.3 $e |- D = ( om \ { (/) } ) $.
    bnj571.16 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R )
        >. } ) $.
    bnj571.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj571.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj571.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj571.20 $e |- ( ze <-> ( i e. om /\ suc i e. n /\ m = suc i ) ) $.
    bnj571.22 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj571.23 $e |- C = U_ y e. ( f ` p ) _pred ( y , A , R ) $.
    bnj571.24 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj571.25 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj571.26 $e |- G = ( f u. { <. m , C >. } ) $.
    bnj571.29 $e |- ( ph' <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj571.30 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y
        e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj571.38 $e |- ( ( R _FrSe A /\ ta /\ si ) -> G Fn n ) $.
    bnj571.21 $e |- ( rh <-> ( i e. om /\ suc i e. n /\ m =/= suc i ) ) $.
    bnj571.40 $e |- ( ( R _FrSe A /\ ta /\ et ) -> G Fn n ) $.
    bnj571.33 $e |- ( ps" <-> A. i e. om ( suc i e. n -> ( G ` suc i ) = U_ y
        e. ( G ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj571 $p |- ( ( R _FrSe A /\ ta /\ et ) -> ps" ) $=
      ( w-bnj15 w3a cv com wcel csuc cfv c-bnj14 ciun wceq wi wal nfv wfn nfra1
      wral nfxfr nf3an wa w-bnj17 df-bnj17 3anass 3anrot df-3an anbi2i 3bitr4ri
      bitri bnj558 sylbir 3expib bnj570 pm2.61ine syl6eq alrimi bnj946 sylibr
      wne exp32 ) HLVAZABVBZNVCZVDVEZXAVFZPVCVEZXCQVGZGXAQVGHLGVCVHZVIZVJZVKZVK
      ZNVLUCWTXJNWSABNWSNVMAMVCZOVCZVNZUAUBVBNUFXMUAUBNXMNVMUANVMUBXCXLVEXCXKVG
      GXAXKVGXFVIVJVKZNVDVPNUPXNNVDVOVQVRVQBNVMVRWTXBXDXHWTXBXDVSZVSZXERXGXPXER
      VJZVKXLXCXLXCVJZWTXOXQXRWTXOVBZWSABCVTZXQXTWTCVSZXSWSABCWAWTXOXRVBWTXOXRV
      SZVSXSYAWTXOXRWBXRWTXOWCCYBWTCXBXDXRVBYBUIXBXDXRWDWGWEWFWGABCDFGHIJKLMNOP
      QRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQWHWIWJXLXCWQZWTXOXQYCWTXOVBZWSABEVTZX
      QYEWTEVSZYDWSABEWAWTXOYCVBWTXOYCVSZVSYDYFWTXOYCWBYCWTXOWCEYGWTEXBXDYCVBYG
      URXBXDYCWDWGWEWFWGABEGHGTVCXKVGXFVIKLMNOPQRTUAUBUDUFUHURULUEUSUPWKWIWJWLU
      LWMWRWNUCXINVDUTWOWP $.
  $}

$( MARKER 4 - TODO DELETE $)
  ${
    $d A f m $.  $d A f p $.  $d R f m $.  $d R f p $.  $d et f $.  $d m n $.
    $d m ph $.  $d m ps $.  $d m x $.  $d n p $.  $d p ph $.  $d p ps $.
    $d p th $.  $d p x $.
    bnj605.5 $e |- ( th <-> A. m e. D ( m _E n -> [. m / n ]. ch ) ) $.
    bnj605.13 $e |- ( ph" <-> [. f / f ]. ph ) $.
    bnj605.14 $e |- ( ps" <-> [. f / f ]. ps ) $.
    bnj605.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj605.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj605.28 $e |- f e. _V $.
    bnj605.31 $e |- ( ch' <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn m /\ ph'
        /\ ps' ) ) ) $.
    bnj605.32 $e |- ( ph" <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj605.33 $e |- ( ps" <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y
        e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj605.37 $e |- ( ( n =/= 1o /\ n e. D ) -> E. m E. p et ) $.
    bnj605.38 $e |- ( ( th /\ m e. D /\ m _E n ) -> ch' ) $.
    bnj605.41 $e |- ( ( R _FrSe A /\ ta /\ et ) -> f Fn n ) $.
    bnj605.42 $e |- ( ( R _FrSe A /\ ta /\ et ) -> ph" ) $.
    bnj605.43 $e |- ( ( R _FrSe A /\ ta /\ et ) -> ps" ) $.
    $( Technical lemma.  This lemma may no longer be used or have become an
       indirect lemma of the theorem in question (i.e. a lemma of a lemma... of
       the theorem).  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj605 $p |- ( ( n =/= 1o /\ n e. D /\ th )
        -> ( ( R _FrSe A /\ x e. A ) -> E. f ( f Fn n /\ ph /\ ps ) ) ) $=
      ( cv c1o wne wcel w-bnj15 wa wfn w3a wex wi anim1i nfv 19.41 cep wbr wsbc
      exbii bnj1095 nfi bitr2i sylib csuc wceq com bnj1232 bnj219 bnj770 bnj170
      jca sylibr syl simpl 2eximi w-bnj17 bnj248 weu pm3.35 sylan2b euex bnj832
      bnj1198 3jca 3com23 3expia eximdv adantlr sylbi mpd bnj432 biid 3anbi123i
      sbcid bitri 3imtr3i ex exlimivv 3syl 3impa ) OUPZUQURZXNJUSZDIKUTZGUPIUSZ
      VAZLUPZXNVBZABVCZLVDZVEZXOXPVAZDVAZFDVAZPVDZNVDZSFVAZPVDNVDYDYFFPVDZNVDZD
      VAZYIYEYLDUKVFYIYKDVAZNVDYMYHYNNFDPDPVGVHVLYKDNDNDNUPZXNVIVJZCOYOVKVENJUB
      VMVNVHVOVPYGYJNPYGSFYGDYOJUSZYPVCZSYGYQYPVAZDVAYRFYSDFYQYPFYQXNYOVQVRZPUP
      ZVSUSZYOUUAVQVRZUFVTYQYTUUBUUCYPFUFNOWAWBWDVFDYQYPWCWEULWFFDWGWDWHYJYDNPY
      JXSYCXQXRSFWIZYATUAVCZLVDZYJXSVAYCUUDELVDZUUFXSSVAZFUUGUUDXQXRSFWJZUUHXTY
      OVBQRVCZLEUUHUUJLWKZUUJLVDSXSXSUUKVEUUKUHXSUUKWLWMUUJLWNWFUEWPWOUUDUUHFVA
      UUGUUFVEZUUIXSFUULSXQFUULXRXQFVAEUUELXQFEUUEXQEFUUEXQEFVCYATUAUMUNUOWQWRW
      SWTXAXAXBXCXQXRSFXDUUEYBLYAYATAUABYAXETALXTVKAUCALXGXHUABLXTVKBUDBLXGXHXF
      VLXIXJXKXLXM $.
  $}

  ${
    $d f n $.
    bnj581.3 $e |- ( ch <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj581.4 $e |- ( ph' <-> [. g / f ]. ph ) $.
    bnj581.5 $e |- ( ps' <-> [. g / f ]. ps ) $.
    bnj581.6 $e |- ( ch' <-> [. g / f ]. ch ) $.
    $( Technical lemma for ~ bnj580 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Unnecessary distinct variable restrictions
       were removed by Andrew Salmon, 9-Jul-2011.)  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj581 $p |- ( ch' <-> ( g Fn n /\ ph' /\ ps' ) ) $=
      ( cv wsbc wfn w3a sbcbii sbc3an bnj62 bicomi 3anbi123i bitr4i 3bitri ) IC
      DENZODNFNZPZABQZDUEOZUEUFPZGHQZMCUHDUEJRUIUGDUEOZADUEOZBDUEOZQUKUGABDUESU
      JULGUMHUNULUJDEUFTUAKLUBUCUD $.
  $}

  ${
    $d A i k $.  $d R i k $.  $d f i k y $.  $d i k n $.
    bnj589.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj589 $p |- ( ps <-> A. k e. om ( suc k e. n -> ( f ` suc k ) = U_ y e. (
        f ` k ) _pred ( y , A , R ) ) ) $=
      ( cv bnj222 ) ABCDFGEJHJIK $.
  $}

  ${
    bnj590.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj590 $p |- ( ( B = suc i /\ ps ) -> ( i e. om -> ( B e. n -> ( f ` B ) =
        U_ y e. ( f ` i ) _pred ( y , A , R ) ) ) ) $=
      ( cv csuc wceq com wcel cfv c-bnj14 ciun wi wral rsp sylbi eqeq1d imbi12d
      eleq1 fveq2 imbi2d syl5ibr imp ) DGJZKZLZAUIMNZDHJZNZDFJZOZBUIUOOCEBJPQZL
      ZRZRZAUTUKULUJUMNZUJUOOZUQLZRZRZAVDGMSVEIVDGMTUAUKUSVDULUKUNVAURVCDUJUMUD
      UKUPVBUQDUJUOUEUBUCUFUGUH $.
  $}

  ${
    $d D j $.  $d ch j $.  $d ch' j $.  $d f j $.  $d g j $.  $d j k $.
    $d j n $.
    bnj591.1 $e |- ( th <-> ( ( n e. D /\ ch /\ ch' ) -> ( f ` j ) = ( g ` j )
        ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj591 $p |- ( [. k / j ]. th
        <-> ( ( n e. D /\ ch /\ ch' ) -> ( f ` k ) = ( g ` k ) ) ) $=
      ( cv wsbc wcel w3a cfv wceq wi sbcbii vex fveq2 weq eqeq12d imbi2d sbcie
      bitri ) BFGKZLHKCMAINZFKZDKZOZUHEKZOZPZQZFUFLUGUFUIOZUFUKOZPZQZBUNFUFJRUN
      URFUFGSFGUAZUMUQUGUSUJUOULUPUHUFUITUHUFUKTUBUCUDUE $.
  $}

  ${
    $d A i k $.  $d D k $.  $d R i k $.  $d ch k $.  $d ch' k $.  $d f i k y $.
    $d g i k y $.  $d i k n $.  $d j k $.
    bnj594.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj594.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj594.3 $e |- ( ch <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj594.7 $e |- D = ( om \ { (/) } ) $.
    bnj594.9 $e |- ( ph' <-> ( g ` (/) ) = _pred ( x , A , R ) ) $.
    bnj594.10 $e |- ( ps' <-> A. i e. om ( suc i e. n -> ( g ` suc i ) = U_ y
        e. ( g ` i ) _pred ( y , A , R ) ) ) $.
    bnj594.11 $e |- ( ch' <-> ( g Fn n /\ ph' /\ ps' ) ) $.
    bnj594.15 $e |- ( th <-> ( ( n e. D /\ ch /\ ch' ) -> ( f ` j ) = ( g ` j )
        ) ) $.
    bnj594.16 $e |- ( [. k / j ]. th
        <-> ( ( n e. D /\ ch /\ ch' ) -> ( f ` k ) = ( g ` k ) ) ) $.
    bnj594.17 $e |- ( ta <-> A. k e. n ( k _E j -> [. k / j ]. th ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj594 $p |- ( ( j e. n /\ ta ) -> th ) $=
      ( wel wa wi cv wceq wcel w3a cfv c-bnj14 wfn simp2bi sylib syl2an 3adant1
      c0 eqtr3 fveq2 eqeq12d syl5ibr sylibr a1d wne w-bnj17 bnj253 bnj252 anidm
      3anbi1i 3bitr3i wex csuc df-bnj17 cep wsbc bnj1095 bnj1352 hbxfrbi bnj170
      wbr wrex bnj923 elnn sylan2 anim1i sylbi nnsuc rexex bnj721 bnj596 bnj667
      com 3syl bnj258 ciun bnj219 3ad2ant3 adantr vex bnj216 df-3an 3anrot word
      ancom csn cdif eldifi eleq2s nnord ordtr1 imp syl3an3 wral rsp mpd bnj446
      mpan9 pm3.35 sylan2b iuneq1 bnj658 bnj240 simpl anim2i simp3 simpl1 bitri
      simp3bi anim12i bnj589 bnj590 syldan simpr 3eqtr4d ex syl 3imtr3i expimpd
      bnj593 19.9v syl5bir 3expib pm2.61ine ) NPUJZEUKZDULNUMZVDUUMVDUNZDUULUUN
      PUMZIUOZCSUPZUUMKUMZUQZUUMLUMZUQZUNZULZDUUQUVBUUNVDUURUQZVDUUTUQZUNZCSUVF
      UUPCUVDHJFUMURZUNZUVEUVGUNZUVFSCAUVHCUURUUOUSZABUBUTTVASQUVISUUTUUOUSZQRU
      FUTUDVAUVDUVEUVGVEVBVCUUNUUSUVDUVAUVEUUMVDUURVFUUMVDUUTVFVGVHUGVIVJUUMVDV
      KZUUKEDUVLUUKEUPZUVCDUUQUUPUUQUKZUVMUVBUUPUUPCSVLUUPUUPUKZCSUPUVNUUQUUPUU
      PCSVMUUPUUPCSVNUVOUUPCSUUPVOVPVQUVMUUPUUQUVBUVLUUKUUPEVLZUVCOVRUVMUUPUKUV
      CUVPUVPUUMOUMZVSUNZUKZUVCOUVPUVROUVPUVLUUKUUPUPZEUKOUVLUUKUUPEVTUVTEOEUVQ
      UUMWAWGZDNUVQWBZULZOUUOUIWCWDWEUVLUUKUUPEUVROVRZUVTUUMWSUOZUVLUKZUVROWSWH
      UWDUVTUUKUUPUKZUVLUKUWFUVLUUKUUPWFUWGUWEUVLUUPUUKUUOWSUOZUWEIPUCWIUUMUUOW
      JWKZWLWMOUUMWNUVROWSWOWTWPWQUVSUUKUUPUVREVLZUVCUVSUUKUUPEUPZUVRUKUWJUVPUW
      KUVRUVLUUKUUPEWRWLUUKUUPUVREXAVIUWJUUQUVBUWJUUQUKZGUVQUURUQZHJGUMURZXBZGU
      VQUUTUQZUWNXBZUUSUVAUWLUWBUUPCSVLZUWMUWPUNZUWOUWQUNUWLUWBUUQUKUWRUWJUWBUU
      QUWJUUKUUPUVRUPZEUKZUWBUUKUUPUVREVTUXAUWAUWBUWTUWAEUVRUUKUWAUUPONXCXDXEUW
      TOPUJZEUWCUVRUUKUUPONUJZUXBUUMUVQOXFXGZUUKUUPUXCUPZUUPUXCUUKUKZUKZUXBUXCU
      UKUUPUPUXFUUPUKUXEUXGUXCUUKUUPXHUXCUUKUUPXIUXFUUPXKVQUUPUXFUXBUUPUWHUUOXJ
      UXFUXBULUWHUUOWSVDXLZXMIUUOWSUXHXNUCXOUUOXPUVQUUMUUOXQWTXRWMXSEUWCOUUOXTU
      XBUWCULUIUWCOUUOYAWMYDYBWMWLUWBUUPCSVNVIUWRUUQUWBUKUWSUWBUUPCSYCUWBUUQUUQ
      UWSULUWSUHUUQUWSYEYFWMGUWMUWPUWNYGWTUWLUWTBRUKZUKZUWTBUKUUSUWOUNZUWJUWTUU
      QUXIUUKUUPUVREYHUUPCSBRCUVJABUBYOSUVKQRUFYOYIYPZUXIBUWTBRYJYKUWTBUVRBUKZU
      XKUWTUVRBUUKUUPUVRYLZWLUWTUXMUKUUKUXKUUKUUPUVRUXMYMUWTUVQWSUOZUXMUUKUXKUL
      UWTUVRUWGUKZUXOUWTUWGUVRUKUXPUUKUUPUVRXHUWGUVRXKYNUVRUXCUWEUXOUWGUXDUWIUV
      QUUMWJVBWMZBGHUUMJKOPBGHJKMOPUAYQYRYDYBYSWTUWLUXJUWTRUKUVAUWQUNZUXLUXIRUW
      TBRYTYKUWTRUVRRUKZUXRUWTUVRRUXNWLUWTUXSUKUUKUXRUUKUUPUVRUXSYMUWTUXOUXSUUK
      UXRULUXQRGHUUMJLOPRGHJLMOPUEYQYRYDYBYSWTUUAUUBUUCUUFUVLUUKUUPEXAUVCOUUGUU
      DUUEUUHUGVIUUIUUJ $.
  $}

  ${
    $d A f i k $.  $d D f g j k $.  $d R f i k $.  $d ch g j k $.
    $d ch' j k $.  $d f g i k n $.  $d f x $.  $d f g i k y $.  $d j k n $.
    $d k th $.
    bnj580.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj580.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj580.3 $e |- ( ch <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj580.4 $e |- ( ph' <-> [. g / f ]. ph ) $.
    bnj580.5 $e |- ( ps' <-> [. g / f ]. ps ) $.
    bnj580.6 $e |- ( ch' <-> [. g / f ]. ch ) $.
    bnj580.7 $e |- D = ( om \ { (/) } ) $.
    bnj580.8 $e |- ( th <-> ( ( n e. D /\ ch /\ ch' ) -> ( f ` j ) = ( g ` j )
        ) ) $.
    bnj580.9 $e |- ( ta <-> A. k e. n ( k _E j -> [. k / j ]. th ) ) $.
    $( Technical lemma for ~ bnj579 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj580 $p |- ( n e. D -> E* f ch ) $=
      ( cv wcel weq wal wmo w3a wfn cfv wceq wral simp1bi bnj581 bnj240 cep wfr
      wa wi wel bnj154 vex bnj540 bnj591 bnj594 ex bnj110 mpan2 ralbii r19.21be
      rgen sylib com word bnj923 nnord ordfr 3syl 3ad2ant1 pm4.71ri bitri mpbir
      imbi1i impexp r19.21v mpbi eqfnfv biimprd sylc 3expib alrimivv wsbc sbsbc
      wsb anbi2i 2albii nfv mo3 3bitr4i sylibr ) PUIZIUJZCSVDZKLUKZVEZLULKULZCK
      UMZXHXKKLXHCSXJXHCSUNZKUIZXGUOZLUIZXGUOZVDZNUIZXOUPXTXQUPUQZNXGURZXJXHCSX
      PXRCXPABUBUSSXRQRABCKLPQRSUBUCUDUEUTZUSVAXNYAVEZNXGURZXNYBVEYEXGVBVCZYDVE
      ZNXGURYFYDNXGYFDNXGURZYEYFEDVEZNXGURYHYINXGNPVFEDABCDEFGHIJKLMNOPQRSTUAUB
      UFFHJKLAQUCTVGBGHJKMXQXGRUAUDLVHVIYCUGCDIKLNOPSUGVJUHVKVLVQDENOXGVBPVHUHV
      MVNDYDNXGUGVOVRVPYDYGNXGYDYFXNVDZYAVEYGXNYJYAXNYFXHCYFSXHXGVSUJXGVTYFIPUF
      WAXGWBXGWCWDWEWFWIYFXNYAWJWGVOWHXNYANXGWKWLXSXJYBNXGXOXQWMWNWOWPWQCCKLWTZ
      VDZXJVEZLULKULCCKXQWRZVDZXJVEZLULKULXMXLYMYPKLYLYOXJYKYNCCKLWSXAWIXBCKLCL
      XCXDXKYPKLXIYOXJSYNCUEXAWIXBXEXF $.
  $}

  ${
    $d A f i k $.  $d D f g j k $.  $d R f i k $.  $d f g i k n $.  $d f x $.
    $d f g i k y $.  $d g j k ph $.  $d g j k ps $.  $d j k n $.
    bnj579.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj579.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj579.3 $e |- D = ( om \ { (/) } ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj579 $p |- ( n e. D -> E* f ( f Fn n /\ ph /\ ps ) ) $=
      ( vg vj vk cv w3a wsbc biid wfn wcel cfv wceq wi cep wbr wral bnj580 ) AB
      HQZJQZUAABRZUKFUBULULHNQZSZROQZUJUCUOUMUCUDUEZPQZUOUFUGUPOUQSUEPUKUHZCDEF
      GHNIOPJAHUMSZBHUMSZUNKLULTUSTUTTUNTMUPTURTUI $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.  $d Y y $.
    $( Equality theorem for the ` _pred ` function constant.  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj602 $p |- ( X = Y -> _pred ( X , A , R ) = _pred ( Y , A , R ) ) $=
      ( vy wceq cv wbr crab c-bnj14 breq2 rabbidv df-bnj14 3eqtr4g ) CDFZEGZCBH
      ZEAIPDBHZEAIABCJABDJOQREACDPBKLEABCMEABDMN $.
  $}

  ${
    $d A f h $.  $d A f m $.  $d A f p $.  $d G h i y $.  $d G h w $.
    $d R f h $.  $d R f m $.  $d R f p $.  $d et f $.  $d f h i y $.
    $d f h n $.  $d f h x $.  $d h ph $.  $d h ps $.  $d m n $.  $d m ph $.
    $d m ps $.  $d m x $.  $d n p $.  $d p ph $.  $d p ps $.  $d p th $.
    $d p x $.
    bnj607.5 $e |- ( th <-> A. m e. D ( m _E n -> [. m / n ]. ch ) ) $.
    bnj607.13 $e |- ( ph" <-> [. G / f ]. ph ) $.
    bnj607.14 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj607.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj607.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj607.28 $e |- G e. _V $.
    bnj607.31 $e |- ( ch' <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn m /\ ph'
        /\ ps' ) ) ) $.
    bnj607.32 $e |- ( ph" <-> ( G ` (/) ) = _pred ( x , A , R ) ) $.
    bnj607.33 $e |- ( ps" <-> A. i e. om ( suc i e. n -> ( G ` suc i ) = U_ y
        e. ( G ` i ) _pred ( y , A , R ) ) ) $.
    bnj607.37 $e |- ( ( n =/= 1o /\ n e. D ) -> E. m E. p et ) $.
    bnj607.38 $e |- ( ( th /\ m e. D /\ m _E n ) -> ch' ) $.
    bnj607.41 $e |- ( ( R _FrSe A /\ ta /\ et ) -> G Fn n ) $.
    bnj607.42 $e |- ( ( R _FrSe A /\ ta /\ et ) -> ph" ) $.
    bnj607.43 $e |- ( ( R _FrSe A /\ ta /\ et ) -> ps" ) $.
    bnj607.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj607.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj607.400 $e |- ( ph0 <-> [. h / f ]. ph ) $.
    bnj607.401 $e |- ( ps0 <-> [. h / f ]. ps ) $.
    bnj607.300 $e |- ( ph1 <-> [. G / h ]. ph0 ) $.
    bnj607.301 $e |- ( ps1 <-> [. G / h ]. ps0 ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj607 $p |- ( ( n =/= 1o /\ n e. D /\ th )
        -> ( ( R _FrSe A /\ x e. A ) -> E. f ( f Fn n /\ ph /\ ps ) ) ) $=
      ( cv c1o wne wcel w-bnj15 wa wfn w3a wex wi anim1i nfv 19.41 cep wbr wsbc
      exbii bnj1095 nfi bitr2i sylib csuc wceq com bnj1232 bnj219 bnj770 bnj170
      jca sylibr syl simpl 2eximi weu biimpi euex impcom bnj1198 adantrr 3com23
      syl6 3expia eximdv ad2ant2rl mpd 3jca eximi nfe1 nfcv nfsbc1v nfxfr nf3an
      id cvv fneq1 sbceq1a syl6bbr 3anbi123d spcegf ax-mp c0 cfv c-bnj14 bnj154
      bnj526 bitr4i ciun wral vex bnj540 anbi12i 3anass 3syl anbi2i 3bitr4i weq
      cbvex 3imtr4i exlimi expcom exlimivv 3impa ) PVHZVIVJZUUJJVKZDIKVLZGVHZIV
      KZVMZLVHZUUJVNZABVOZLVPZVQZUUKUULVMZDVMZFDVMZRVPZOVPZUAFVMZRVPOVPUVAUVCFR
      VPZOVPZDVMZUVFUVBUVIDUQVRUVFUVHDVMZOVPUVJUVEUVKOFDRDRVSVTWDUVHDODODOVHZUU
      JWAWBZCPUVLWCVQOJUHWEWFVTWGWHUVDUVGORUVDUAFUVDDUVLJVKZUVMVOZUAUVDUVNUVMVM
      ZDVMUVOFUVPDFUVNUVMFUVNUUJUVLWIWJZRVHZWKVKZUVLUVRWIWJZULWLUVNUVQUVSUVTUVM
      FULOPWMWNWPVRDUVNUVMWOWQURWRFDWSWPWTUVGUVAORUUPUVGUUTUUPUVGVMZUUMEFVOZLVP
      ZQUUJVNZUBUCVOZLVPUUTUWAELVPZUWCUUPUAUWFFUUPUAVMUUQUVLVNSTVOZLEUAUUPUWGLV
      PZUAUUPUWGLXAZUWHUAUUPUWIVQUNXBUWGLXCXHXDUKXEXFUUMFUWFUWCVQUUOUAUUMFVMEUW
      BLUUMFEUWBUUMEFUWBUWBXTXGXIXJXKXLUWBUWELUWBUWDUBUCUSUTVAXMXNUWEUUTLUUSLXO
      UWDUFUGVOZMVHZUUJVNZUDUEVOZMVPZUWEUUTQYAVKUWJUWNVQUMUWMUWJMQYAMQXPUWDUFUG
      MUWDMVSUFUDMQWCZMVFUDMQXQXRUGUEMQWCZMVGUEMQXQXRXSUWKQWJZUWLUWDUDUFUEUGUUJ
      UWKQYBUWQUDUWOUFUDMQYCVFYDUWQUEUWPUGUEMQYCVGYDYEYFYGUWDUBUCVMZVMUWDUFUGVM
      ZVMUWEUWJUWRUWSUWDUBUFUCUGUBYHQYIIKUUNYJWJUFUOUDIKMQUUNUFGIKLMAUDVDVBYKVF
      UMYLYMUCNVHZWIZUUJVKUXAQYIHUWTQYIIKHVHYJYNWJVQNWKYOUGUPUEHIKMNQUUJUGBHIKL
      NUWKUUJUEVCVEMYPYQVGUMYQYMYRUUAUWDUBUCYSUWDUFUGYSUUBUUSUWMLMUUSMVSUWLUDUE
      LUWLLVSUDALUWKWCZLVDALUWKXQXRUEBLUWKWCZLVEBLUWKXQXRXSLMUUCZUURUWLAUDBUEUU
      JUUQUWKYBUXDAUXBUDALUWKYCVDYDUXDBUXCUEBLUWKYCVEYDYEUUDUUEUUFYTUUGUUHYTUUI
      $.
  $}

  ${
    $d A e f $.  $d G e $.  $d R e f $.  $d X e f $.  $d e ph $.
    bnj609.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj609.2 $e |- ( ph" <-> [. G / f ]. ph ) $.
    bnj609.3 $e |- G e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj609 $p |- ( ph" <-> ( G ` (/) ) = _pred ( X , A , R ) ) $=
      ( ve wsbc c0 cfv c-bnj14 wceq cv fveq1 eqeq1d bitri dfsbcq sbcbii vex weq
      sbcie vtoclb ) GADELZMENZBCFOZPZIADKQZLZMUKNZUIPZUGUJKEJADUKEUAUKEPUMUHUI
      MUKERSULMDQZNZUIPZDUKLUNAUQDUKHUBUQUNDUKKUCDKUDUPUMUIMUOUKRSUETUFT $.
  $}

  ${
    $d A e f $.  $d G e i y $.  $d N f $.  $d R e f $.  $d f i y $.
    bnj611.1 $e |- ( ps <-> A. i e. om ( suc i e. N -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj611.2 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj611.3 $e |- G e. _V $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj611 $p |- ( ps" <-> A. i e. om ( suc i e. N
        -> ( G ` suc i ) = U_ y e. ( G ` i ) _pred ( y , A , R ) ) ) $=
      ( wsbc cv wcel cfv wceq wi com fveq1 ve csuc c-bnj14 ciun wral wal df-ral
      bicomi sbcbii cvv nfv sbc19.21g ax-mp bnj1113 eqeq12d bnj610 imbi2i bitri
      wb albii sbcal 3bitr4ri ) IAEGMZFNZUBZHOZVEGPZBVDGPZCDBNUCZUDZQZRZFSUEZKV
      DSOZVFVEENZPZBVDVOPZVIUDZQZRZRZFUFZEGMZVTFSUEZEGMVMVCWBWDEGWDWBVTFSUGUHUI
      WAEGMZFUFVNVLRZFUFWCVMWEWFFWEVNVTEGMZRZWFGUJOZWEWHUSLVNVTEGUJVNEUKULUMWGV
      LVNWGVFVSEGMZRZVLWIWGWKUSLVFVSEGUJVFEUKULUMWJVKVFVSVKEUAGVEUANZPZBVDWLPZV
      IUDZQLVOGQVPVGVRVJVEVOGTBVOGVQVHVIVDVOGTUNUOVOWLQVPWMVRWOVEVOWLTBVOWLVQWN
      VIVDVOWLTUNUOWLGQWMVGWOVJVEWLGTBWLGWNVHVIVDWLGTUNUOUPUQURUQURUTWAFEGVAVLF
      SUGVBAWDEGJUIVBUR $.
  $}

  ${
    $d A f i m n p z $.  $d A f i n p y $.  $d D f p $.  $d G i y z $.
    $d R f i m n p z $.  $d R f i n p y $.  $d et f i $.  $d f m n p x z $.
    $d i p ph' $.  $d m p ph z $.  $d m p ps z $.  $d p th $.
    bnj600.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj600.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj600.3 $e |- D = ( om \ { (/) } ) $.
    bnj600.4 $e |- ( ch <-> ( ( R _FrSe A /\ x e. A )
        -> E! f ( f Fn n /\ ph /\ ps ) ) ) $.
    bnj600.5 $e |- ( th <-> A. m e. D ( m _E n -> [. m / n ]. ch ) ) $.
    bnj600.10 $e |- ( ph' <-> [. m / n ]. ph ) $.
    bnj600.11 $e |- ( ps' <-> [. m / n ]. ps ) $.
    bnj600.12 $e |- ( ch' <-> [. m / n ]. ch ) $.
    bnj600.13 $e |- ( ph" <-> [. G / f ]. ph ) $.
    bnj600.14 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj600.15 $e |- ( ch" <-> [. G / f ]. ch ) $.
    bnj600.16 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R )
        >. } ) $.
    bnj600.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj600.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj600.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj600.20 $e |- ( ze <-> ( i e. om /\ suc i e. n /\ m = suc i ) ) $.
    bnj600.21 $e |- ( rh <-> ( i e. om /\ suc i e. n /\ m =/= suc i ) ) $.
    bnj600.22 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj600.23 $e |- C = U_ y e. ( f ` p ) _pred ( y , A , R ) $.
    bnj600.24 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj600.25 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj600.26 $e |- G = ( f u. { <. m , C >. } ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj600 $p |- ( n =/= 1o -> ( ( n e. D /\ th ) -> ch ) ) $=
      ( vz cv c1o wne wcel w3a w-bnj15 wa wfn weu wi wex wmo wsbc bnj528 bnj207
      vex bnj609 bnj611 csuc wceq com w-bnj17 bnj168 df-rex sylib bnj158 adantr
      wrex ancri bnj534 bnj432 exbii sylibr eximi syl 2exbii cep wbr wral sylbi
      rsp 3imp bnj523 bnj539 bnj544 bnj561 bnj545 bnj562 bnj571 biid bnj607 a1d
      bnj579 3ad2ant2 jcad eu5 syl6ibr 3expib ) TVNZVOVPZYLOVQZDCYMYNDVRZLPVSJV
      NZLVQVTZQVNZYLWAABVRZQWBZWCCYOYQYSQWDZYSQWEZVTYTYOYQUUAUUBABCDEFJKLOPQVMR
      STUAUDUEUFUGUHUIAQVMVNZWFZBQUUCWFZUUDVMUAWFZUUEVMUAWFZUOUSUTVCVEKLPQSUAUD
      VBWGZABCJLPQTSVNZUEUFUGUNUPUQURSWIZWHALPQUAYPUHUKUSUUHWJZBKLPQRUAYLUIULUT
      UUHWKZYMYNVTZUUIOVQZYLUUIWLWMZUDVNZWNVQZUUIUUPWLWMZWOZUDWDZSWDZFUDWDSWDUU
      MUUNUUOVTZSWDZUVAUUMUUOSOXAUVCOSTUMWPUUOSOWQWRUVBUUTSUVBUUQUURVTZUVBVTZUD
      WDUUTUVDUVBUVBUDUVBUVDUDWDZUUNUVFUUOUUNUURUDWNXAUVFOSUDUMWSUURUDWNWQWRWTX
      BXCUUSUVEUDUUNUUOUUQUURXDXEXFXGXHFUUSSUDVEXIXFDUUNUUIYLXJXKZVRCTUUIWFZUGD
      UUNUVGUVHDUVGUVHWCZSOXLUUNUVIWCUOUVISOXNXMXOURXFEFHLOPSTUAUDVDVEEHJKLOPQR
      STUAUDUEUFALPTYRUUIYPUEUKUPUUJXPZBKLPRTYRUUIUFULUQUUJXQZUMVBVCVDXRZXSZEFH
      LOPSTUDUHVDVEEHJKLOPQSTUAUDUEUFUHUVJUMVBVCVDUVLUUKXTYAEFGHIJKLMNOPQRSTUAU
      BUCUDUEUFUIUMVBVCVDVEVFVHVIVJVKVLUVJUVKUVLVGUVMUULYBUKULUUDYCUUEYCUUFYCUU
      GYCYDYNYMYQUUBWCDYNUUBYQABJKLOPQRTUKULUMYFYEYGYHYSQYIYJUNXFYK $.
  $}

  ${
    $d A f i m n p y $.  $d A f i p y z $.  $d D f i p $.  $d R f i m n p y $.
    $d R f i p y z $.  $d f m n p x $.  $d i m p ph $.  $d m p ps $.
    $d p th $.
    bnj601.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj601.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj601.3 $e |- D = ( om \ { (/) } ) $.
    bnj601.4 $e |- ( ch <-> ( ( R _FrSe A /\ x e. A ) -> E! f ( f Fn n /\ ph /\
        ps ) ) ) $.
    bnj601.5 $e |- ( th <-> A. m e. D ( m _E n -> [. m / n ]. ch ) ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj601 $p |- ( n =/= 1o -> ( ( n e. D /\ th ) -> ch ) ) $=
      ( wsbc biid vp vz wfn w3a wcel csuc wceq com w-bnj17 wel wne c-bnj14 ciun
      cv cfv cop csn cun bnj602 cbviunv opeq2i sneqi uneq2i dfsbcq ax-mp eqcomi
      wb eqid bnj600 ) ABCDJUNZLUNZUCAMVKSZBMVKSZUDZVKHUEZMUNZVKUFUGZUAUNZUHUEV
      KVRUFUGUIZKUNZUHUEZVTUFZVPUEZVKWBUGUDZVOVQUALUJUDZWAWCVKWBUKUDZEFGFVTVJUO
      GIFUNZULZUMZFVRVJUOZWHUMZHIJKLMVJVKUBWJGIUBUNZULZUMZUPZUQZURZFVTWQUOWHUMZ
      FVRWQUOWHUMZUAVLVMCMVKSZAJVJVKWKUPZUQZURZSZBJXCSZCJXCSZNOPQRVLTVMTWTTXCWQ
      UGZXDAJWQSVGXBWPVJXAWOWKWNVKFUBWJWHWMGIWGWLUSUTVAVBVCZAJXCWQVDVEXGXEBJWQS
      VGXHBJXCWQVDVEXGXFCJWQSVGXHCJXCWQVDVEXCWQXHVFZVNTWETVSTWDTWFTWIVHWKVHWRVH
      WSVHXIVI $.
  $}

  ${
    $d A f i n x y z $.  $d D f i n x z $.  $d R f i n x y z $.  $d X f n x $.
    $d ph x $.  $d ps x z $.
    bnj852.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj852.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj852.3 $e |- D = ( om \ { (/) } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj852 $p |- ( ( R _FrSe A /\ X e. A )
         -> A. n e. D E! f ( f Fn n /\ ph /\ ps ) ) $=
      ( vx vz wcel wa cv wral wi w-bnj15 wfn w3a weu wceq elisset adantl bnj534
      wex ancri cfv c-bnj14 eleq1 anbi2d biimpar cep wbr wsbc biid com csn cdif
      c0 cvv difexg ax-mp eqeltri zfregfr bnj157 c1o bnj153 bnj601 pm2.61ine ex
      omex mprg r19.21v mpbi syl wb bnj602 eqeq2d syl6bbr 3anbi2d eubidv adantr
      ralbidv mpbid bnj593 bnj937 ) DFUAZJDPZQZGRZIRZUBZABUCZGUDZIESZNWMNRZJUEZ
      WMQZWSNXAWMWMNWMXANUIZWLXCWKNJDUFUGUJUHXBWPVCWNUKZDFWTULZUEZBUCZGUDZIESZW
      SXBWKWTDPZQZXIXAXKWMXAXJWLWKWTJDUMUNUOXKXHTZIESZXKXITORZWOUPUQXLIXNURTOES
      ZXLTXMIEXLXOIOEUPXOUSZEUTVCVAZVBZVDMUTVDPXRVDPVOUTXQVDVEVFVGEVHVIWOEPZXOX
      LXSXOQXLTWOVJXFBXLXONCDEFGHOIXFUSZLMXLUSZXPVKXFBXLXONCDEFGHOIXTLMYAXPVLVM
      VNVPXKXHIEVQVRVSXAXIWSVTWMXAXHWRIEXAXGWQGXAXFAWPBXAXFXDDFJULZUEAXAXEYBXDD
      FWTJWAWBKWCWDWEWGWFWHWIWJ $.
  $}

  ${
    $d A f i n y $.  $d D f i n $.  $d D f n w $.  $d R f i n y $.  $d X f n $.
    $d ph w $.  $d ps w $.
    bnj864.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj864.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj864.3 $e |- D = ( om \ { (/) } ) $.
    bnj864.4 $e |- ( ch <-> ( R _FrSe A /\ X e. A /\ n e. D ) ) $.
    bnj864.5 $e |- ( th <-> ( f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj864 $p |- ( ch -> E! f th ) $=
      ( wcel wi wal w-bnj15 w3a wfn weu wral bnj852 df-ral imbi2i 19.21v impexp
      cv wa df-3an bicomi imbi1i bitr3i albii 3bitr2i mpbi spi eubii 3imtr4i )
      FHUAZLFRZKUKZGRZUBZIUKVEUCABUBZIUDZCDIUDVGVISZKVCVDULZVIKGUEZSZVJKTZABEFG
      HIJKLMNOUFVMVKVFVISZKTZSVKVOSZKTVNVLVPVKVIKGUGUHVKVOKUIVQVJKVQVKVFULZVISV
      JVKVFVIUJVRVGVIVGVRVCVDVFUMUNUOUPUQURUSUTPDVHIQVAVB $.
  $}

  ${
    $d A f i n y z $.  $d A f n w $.  $d D f i n z $.  $d D f n w $.
    $d R f i n y z $.  $d R f n w $.  $d X f n w z $.  $d ph w z $.
    $d ps w z $.
    bnj865.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj865.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj865.3 $e |- D = ( om \ { (/) } ) $.
    bnj865.5 $e |- ( ch <-> ( R _FrSe A /\ X e. A /\ n e. D ) ) $.
    bnj865.6 $e |- ( th <-> ( f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj865 $p |- E. w A. n ( ch -> E. f e. w th ) $=
      ( wi wex vz cv wrex wal wfn w3a w-bnj15 wcel wral weu bnj852 com csn cdif
      wa c0 cvv omex difexg ax-mp eqeltri raleq exbidv imbi12d zfrep6 vtocl syl
      wceq 19.37v mpbir df-ral imbi2i 19.21v bitr4i impexp df-3an bicomi imbi1i
      exbii bitr3i albii bitri mpbi rexbii ) CDJFUBZUCZSZLUDZFTCJUBLUBZUEABUFZJ
      WEUCZSZLUDZFTZGIUGZMGUHZWIHUHZUFZWKSZLUDZFTZWNWOWPUOZWKLHUIZSZFTZXAXEXBXC
      FTZSXBWJJUJZLHUIZXFABEGHIJKLMNOPUKXGLUAUBZUIZWKLXIUIZFTZSXHXFSUAHHULUPUMZ
      UNZUQPULUQUHXNUQUHURULXMUQUSUTVAXIHVHZXJXHXLXFXGLXIHVBXOXKXCFWKLXIHVBVCVD
      WJLJUAFVEVFVGXBXCFVIVJXEXBWQWKSZSZLUDZFTXAXDXRFXDXBXPLUDZSXRXCXSXBWKLHVKV
      LXBXPLVMVNVSXRWTFXQWSLXQXBWQUOZWKSWSXBWQWKVOXTWRWKWRXTWOWPWQVPVQVRVTWAVSW
      BWCWTWMFWSWLLWRCWKCWRQVQVRWAVSWCWHWMFWGWLLWFWKCDWJJWERWDVLWAVSVJ $.
  $}

$( MARKER 6 - TODO DELETE $)
  ${
    $d D f g $.  $d f g n $.  $d g ph $.  $d g ps $.
    bnj873.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj873.7 $e |- ( ph' <-> [. g / f ]. ph ) $.
    bnj873.8 $e |- ( ps' <-> [. g / f ]. ps ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj873 $p |- B = { g | E. n e. D ( g Fn n /\ ph' /\ ps' ) } $=
      ( cv wfn w3a wrex cab nfv wsbc nfsbc1v nfcv nfxfr nf3an nfrex weq sbceq1a
      fneq1 syl6bbr 3anbi123d rexbidv cbvab eqtri ) CEMZGMZNZABOZGDPZEQFMZUNNZH
      IOZGDPZFQJUQVAEFUQFRUTEGDEDUAUSHIEUSERHAEURSZEKAEURTUBIBEURSZELBEURTUBUCU
      DEFUEZUPUTGDVDUOUSAHBIUNUMURUGVDAVBHAEURUFKUHVDBVCIBEURUFLUHUIUJUKUL $.
  $}

  ${
    $d A f i n y $.  $d A f n w $.  $d B g w $.  $d D f g n w $.  $d D f i n $.
    $d R f i n y $.  $d R f n w $.  $d X f n w $.  $d ch f g $.  $d g ph w $.
    $d g ps w $.  $d g n ta w $.  $d g th $.
    bnj849.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj849.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj849.3 $e |- D = ( om \ { (/) } ) $.
    bnj849.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj849.5 $e |- ( ch <-> ( R _FrSe A /\ X e. A /\ n e. D ) ) $.
    bnj849.6 $e |- ( th <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj849.7 $e |- ( ph' <-> [. g / f ]. ph ) $.
    bnj849.8 $e |- ( ps' <-> [. g / f ]. ps ) $.
    bnj849.9 $e |- ( th' <-> [. g / f ]. th ) $.
    bnj849.10 $e |- ( ta <-> ( R _FrSe A /\ X e. A ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj849 $p |- ( ( R _FrSe A /\ X e. A ) -> B e. _V ) $=
      ( vw w-bnj15 wcel wa cvv cv wrex wi wal wex bnj865 wss wfn w3a cab bnj873
      wel df-rex 19.29 an12 df-3an anbi1i 3bitr4i wsbc bnj581 bitr3i weu bnj864
      exancom bitri biimpi nfeu1 nfe1 nfan nfsbc1v nfv nfim weq sbceq1a imbi12d
      id elequ1 imbi2d eupick chvar syl2an syl5bir embantd imp3a sylbir expimpd
      ex syl5bi exlimdv syl5 expdimp abssdv syl5eqss vex ssex syl mpi ) GJUJZOG
      UKZULZEHUMUKZUHECDKUIUNZUOZUPZNUQZUIURXNABCDFUIGIJKMNOSTUAUCUDUSEXRXNUIEX
      RXNEXRULZHXOUTXNXSHLUNZNUNZVAPQVBZNIUOZLVCXOABHIKLNPQUBUEUFVDXSYCLXOYCYAI
      UKZYBULZNURZXSLUIVEZYBNIVFEXRYFYGXRYFULXQYEULZNUREYGXQYENVGEYHYGNYHYDXQYB
      ULZULEYGXQYDYBVHEYDYIYGEYDULZCYIYGUPXKXLYDVBXMYDULCYJXKXLYDVIUCEXMYDUHVJV
      KCXQYBYGCCXPYBYGUPZCWICXPYKYBDKXTVLZCXPULYGYLRYBUGABDKLNPQRUDUEUFUGVMVNCD
      KVOZDKUIVEZULZKURZYLYGUPZXPABCDFGIJKMNOSTUAUCUDVPXPYPXPYNDULKURYPDKXOVFYN
      DKVQVRVSYMYPULZDYNUPZUPYRYQUPKLYRYQKYMYPKDKVTYOKWAWBYLYGKDKXTWCYGKWDWEWEK
      LWFZYSYQYRYTDYLYNYGDKXTWGKLUIWJWHWKDYNKWLWMWNWOWTWPWQWRWSXAXBXCXDXAXEXFHX
      OUIXGXHXIWTXBXJWR $.
  $}

  ${
    $d A f i n y w $.  $d R f i n y w $.  $d X f i n y w $.  $d w B $.
    bnj882.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj882.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj882.3 $e |- D = ( om \ { (/) } ) $.
    bnj882.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Definition (using hypotheses for readability) of the function giving the
       transitive closure of ` X ` in ` A ` by ` R ` .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj882 $p |- _trCl ( X , A , R ) = U_ f e. B U_ i e. dom f ( f ` i ) $=
      ( vw cv wcel ciun wrex c-bnj18 wfn cfv c-bnj14 wceq csuc com wral w3a csn
      c0 wi cdif cab cdm df-bnj18 df-iun anbi12i anbi2i 3anass 3bitr4i rexeqbii
      wa abbii eqtri eleq2i anbi1i rexbii2 eqtr4i ) DGKUAHHQZJQZUBZUKVJUCDGKUDU
      EZIQZUFZVKRVOVJUCCVNVJUCZDGCQUDSUEULIUGUHZUIZJUGUKUJUMZTZHUNZIVJUOVPSZSZH
      EWBSZCDGHIJKUPWDPQWBRZHETZPUNZWCHPEWBUQWCWEHWATZPUNWGHPWAWBUQWFWHPWEWEHEW
      AVJERVJWARWEEWAVJEVLABUIZJFTZHUNWAOWJVTHWIVRJFVSNVLABVCZVCVLVMVQVCZVCWIVR
      WKWLVLAVMBVQLMURUSVLABUTVLVMVQUTVAVBVDVEVFVGVHVDVIVIVI $.
  $}

  ${
    $d f i n x y A $.  $d f i n x y R $.  $d f i n x y X $.  $d f i n x y Y $.
    $( Equality theorem for transitive closure.  (Contributed by Mario
       Carneiro, 22-Dec-2016.)  (New usage is discouraged.) $)
    bnj18eq1 $p |- ( X = Y -> _trCl ( X , A , R ) = _trCl ( Y , A , R ) ) $=
      ( vf vn vi vy vx wceq cv c0 cfv c-bnj14 wcel ciun com w3a wrex cab wfn wi
      csuc wral csn cdif cdm c-bnj18 bnj602 eqeq2d 3anbi2d abbidv eleq2d anbi1d
      rexbidv rexbidv2 df-iun 3eqtr4g df-bnj18 ) CDJZEEKZFKZUAZLVAMZABCNZJZGKZU
      CZVBOVHVAMHVGVAMZABHKNPJUBGQUDZRZFQLUEUFZSZETZGVAUGVIPZPZEVCVDABDNZJZVJRZ
      FVLSZETZVOPZABCUHABDUHUTIKVOOZEVNSZITWCEWASZITVPWBUTWDWEIUTWCWCEVNWAUTVAV
      NOVAWAOWCUTVNWAVAUTVMVTEUTVKVSFVLUTVFVRVCVJUTVEVQVDABCDUIUJUKUOULUMUNUPUL
      EIVNVOUQEIWAVOUQURHABEGFCUSHABEGFDUSUR $.
  $}

  ${
    $d A f g i n y w z $.  $d R f g i n y w z $.  $d X f g i n y w z $.
    $( Property of ` _trCl ` .  Under certain conditions, the transitive
       closure of ` X ` in ` A ` by ` R ` is a set.  (Contributed by Jonathan
       Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj893 $p |- ( ( R _FrSe A /\ X e. A ) -> _trCl ( X , A , R ) e. _V ) $=
      ( vf vn vi vy vg vw wcel cv c0 cfv wceq ciun com wrex cvv biid wsbc vz wa
      w-bnj15 c-bnj18 wfn c-bnj14 csuc wi wral w3a csn cdif cab cdm eqid bnj882
      vex fveq1 eqeq1d sbcie bicomi iuneq1d eqeq12d imbi2d bnj873 eleq2i anbi1i
      ralbidv rexbii2 abbii df-iun 3eqtr4i bnj849 dmex fvex iunex rgenw sylancl
      weq iunexg syl5eqel ) ABUCZCAJZUBZABCUDDDKZEKZUELWEMZABCUFZNZFKZUGZWFJZWK
      WEMZGWJWEMZABGKUFZOZNZUHZFPUIZUJEPLUKULZQDUMZFWEUNZWNOZOZRWIWSGAXAWTBDFEC
      WISWSSWTUOZXAUOZUPWDXDDHKZWFUELXGMZWHNZWLWKXGMZGWJXGMZWOOZNZUHZFPUIZUJZEW
      TQHUMZXCOZRIKXCJZDXAQZIUMXSDXQQZIUMXDXRXTYAIXSXSDXAXQWEXAJWEXQJXSXAXQWEWI
      WSXAWTDHEXIXOXFWIDXGTXIWIXIDXGHUQZDHVSZWGXHWHLWEXGURUSUTVAWSDXGTXOWSXODXG
      YBYCWRXNFPYCWQXMWLYCWMXJWPXLWKWEXGURYCGWNXKWOWJWEXGURVBVCVDVHUTVAVEVFVGVI
      VJDIXAXCVKDIXQXCVKVLWDXQRJXCRJZDXQUIXRRJXIXOWBWCWFWTJUJZXPWDGAXQWTBHUAFEC
      XIHUAKZTZXOHYFTZXPHYFTZXISXOSXEXQUOYESXPSYGSYHSYISWDSVMYDDXQFXBWNWEDUQVNW
      JWEVOVPVQDXQXCRRVTVRWAWA $.
  $}

  ${
    $d f n $.
    bnj900.3 $e |- D = ( om \ { (/) } ) $.
    bnj900.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj900 $p |- ( f e. B -> (/) e. dom f ) $=
      ( cv wcel cdm wceq wa wi wex c0 wfn w3a wrex reximi bnj1436 simp1 bnj1196
      fndm 3syl cab nfre1 nfab nfcxfr nfcri 19.37 mpbir nfv nfim eleq2 biimparc
      bnj529 sylan imim2i exlimi ax-mp ) EIZCJZFIZDJZVBKZVDLZMZNZFOZVCPVFJZNZVJ
      VCVHFONVCVGFDVCVBVDQZABRZFDSZVMFDSVGFDSVOECHUAVNVMFDVMABUBTVMVGFDVDVBUDTU
      EUCVCVHFFECFCVOEUFHVOFEVNFDUGUHUIUJZUKULVIVLFVCVKFVPVKFUMUNVHVKVCVEPVDJZV
      GVKDVDGUQVGVKVQVFVDPUOUPURUSUTVA $.
  $}

  ${
    $d A f i n y $.  $d R f i n y $.  $d X f i n y $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj906 $p |- ( ( R _FrSe A /\ X e. A ) -> _pred ( X , A , R ) C_ _trCl ( X
        , A , R ) ) $=
      ( vf vn vi vy wcel wa cv c0 cfv c-bnj14 wceq ciun com wrex wex c1o syl wi
      w-bnj15 wfn csuc wral w3a csn cdif cab c-bnj18 wss weu 1onn mpbir2an ne0i
      wne 1n0 eldifsn ax-mp biid eqid bnj852 r19.2z sylancr bnj31 rexcom4 sylib
      euex abid bnj1198 simp2 reximi sylbi df-rex 19.41v simprbi bnj900 ssiun2s
      cdm fveq2 ssiun2 bnj882 syl6sseqr sstrd eqsstr3d exlimiv ) ABUBCAHIZDJZWH
      EJZUCZKWHLZABCMZNZFJZUDZWIHWOWHLGWNWHLZABGJMONUAFPUEZUFZEPKUGUHZQZDUIZHZD
      RWLABCUJZUKZWGWTDXBWGWRDRZEWSQWTDRWGWRDULZXEEWSWGWSKUPZXFEWSUEXFEWSQSWSHZ
      XGXHSPHSKUPUMUQSPKURUNWSSUOUSWMWQGAWSBDFECWMUTZWQUTZWSVAZVBXFEWSVCVDWRDVH
      VEWREDWSVFVGWTDVIZVJXBXDDXBWLWKXCXBWMEWSQZWMXBWTXMXLWRWMEWSWJWMWQVKVLVMXM
      WIWSHZWMIERZWMWMEWSVNXOXNERWMXNWMEVOVPVMTXBWKFWHVSZWPOZXCXBKXPHWKXQUKWMWQ
      XAWSDEXKXAVAZVQFXPWPKWKWNKWHVTVRTXBXQDXAXQOXCDXAXQWAWMWQGAXAWSBDFECXIXJXK
      XRWBWCWDWEWFT $.
  $}

  ${
    $d A f i m n p $.  $d A f i n p y $.  $d D p $.  $d G i y $.
    $d R f i m n p $.  $d R f i n p y $.  $d et f i $.  $d f m n p x $.
    $d i p ph' $.  $d m p ph $.  $d m p ps $.  $d p th $.
    bnj908.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( x , A , R ) ) $.
    bnj908.2 $e |- ( ps <-> A. i e. om ( suc i e. n
        -> ( f ` suc i ) = U_ y e. ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj908.3 $e |- D = ( om \ { (/) } ) $.
    bnj908.4 $e |- ( ch <-> ( ( R _FrSe A /\ x e. A )
        -> E! f ( f Fn n /\ ph /\ ps ) ) ) $.
    bnj908.5 $e |- ( th <-> A. m e. D ( m _E n -> [. m / n ]. ch ) ) $.
    bnj908.10 $e |- ( ph' <-> [. m / n ]. ph ) $.
    bnj908.11 $e |- ( ps' <-> [. m / n ]. ps ) $.
    bnj908.12 $e |- ( ch' <-> [. m / n ]. ch ) $.
    bnj908.13 $e |- ( ph" <-> [. G / f ]. ph ) $.
    bnj908.14 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj908.15 $e |- ( ch" <-> [. G / f ]. ch ) $.
    bnj908.16 $e |- G = ( f u. { <. m , U_ y e. ( f ` p ) _pred ( y , A , R )
        >. } ) $.
    bnj908.17 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj908.18 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj908.19 $e |- ( et <-> ( m e. D /\ n = suc m /\ p e. om /\ m = suc p ) )
        $.
    bnj908.20 $e |- ( ze <-> ( i e. om /\ suc i e. n /\ m = suc i ) ) $.
    bnj908.21 $e |- ( rh <-> ( i e. om /\ suc i e. n /\ m =/= suc i ) ) $.
    bnj908.22 $e |- B = U_ y e. ( f ` i ) _pred ( y , A , R ) $.
    bnj908.23 $e |- C = U_ y e. ( f ` p ) _pred ( y , A , R ) $.
    bnj908.24 $e |- K = U_ y e. ( G ` i ) _pred ( y , A , R ) $.
    bnj908.25 $e |- L = U_ y e. ( G ` p ) _pred ( y , A , R ) $.
    bnj908.26 $e |- G = ( f u. { <. m , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj908 $p |- ( ( R _FrSe A /\ x e. A /\ ch' /\ et )
        -> E. f ( G Fn n /\ ph" /\ ps" ) ) $=
      ( w-bnj15 cv wcel w-bnj17 w3a wfn wa wex bnj248 weu wi bnj207 biimpi euex
      vex syl6 impcom bnj832 bnj645 19.41v sylanbrc bnj642 bnj170 bnj523 bnj539
      bnj1198 bnj544 bnj561 bnj528 bnj609 bnj545 bnj562 bnj611 bnj571 bnj593
      3jca ) LPVMZJVNZLVOZUGFVPZXIEFVQZUATVNZVRZUHUIVQQXLEFVSZXIVSZQXMXLXPQVTZX
      IXQQVTXLEQVTZFXRXIXKVSZUGVSZFXSXLXIXKUGFWAYAQVNZSVNZVRUEUFVQZQEUGXTYDQVTZ
      UGXTYDQWBZYEUGXTYFWCABCJLPQTYCUEUFUGUNUPUQURSWGZWDWEYDQWFWHWIVCWRWJXIXKUG
      FWKEFQWLWMXIXKUGFWNXPXIQWLWMXIEFWOWRXMXOUHUIEFHLOPSTUAUDVDVEEHJKLOPQRSTUA
      UDUEUFALPTYBYCXJUEUKUPYGWPZBKLPRTYBYCUFULUQYGWQZUMVBVCVDWSZWTZEFHLOPSTUDU
      HVDVEEHJKLOPQSTUAUDUEUFUHYHUMVBVCVDYJALPQUAXJUHUKUSKLPQSUAUDVBXAZXBXCXDEF
      GHIJKLMNOPQRSTUAUBUCUDUEUFUIUMVBVCVDVEVFVHVIVJVKVLYHYIYJVGYKBKLPQRUAXNUIU
      LUTYLXEXFXHXG $.
  $}

  ${
    $d f i $.  $d i n $.  $d i ph $.
    bnj911.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj911.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj911 $p |- ( ( f Fn n /\ ph /\ ps ) -> A. i ( f Fn n /\ ph /\ ps ) ) $=
      ( cv wfn csuc wcel cfv c-bnj14 ciun wceq wi com bnj1095 bnj1350 ) FLZHLZM
      ABGBGLZNZUEOUGUDPCUFUDPDECLQRSTGUAKUBUC $.
  $}

  ${
    $d A f i n y $.  $d D i $.  $d R f i n y $.  $d X f i n y $.  $d i ph $.
    bnj916.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj916.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj916.3 $e |- D = ( om \ { (/) } ) $.
    bnj916.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj916.5 $e |- ( ch <-> ( f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj916 $p |- ( y e. _trCl ( X , A , R ) -> E. f E. n E. i ( n e. D /\ ch /\
        i e. n /\ y e. ( f ` i ) ) ) $=
      ( wcel wex wa cv c-bnj18 cdm cfv w-bnj17 wfn w3a bnj256 2exbii 19.41v nfv
      wrex bnj911 nfi 19.42 exbii df-rex anbi12i 3bitr4i bitri 3anbi2i df-bnj17
      nfan anbi1i 3exbii ciun bnj882 eleq2i eliun rexbii 3bitri abeq2i 3bitr4ri
      wb bnj643 bnj564 eleq2d anbi1 bnj334 bnj252 3bitr4g 3syl ibi 2eximi eximi
      sylbi ) DUAZEHLUBZRZKUAZGRZCJUAZIUAZUCZRZWGWLWMUDZRZUEZJSKSZISZWKCWLWJRZW
      QUEZJSKSZISWKWMWJUFABUGZWOWQUEZJSKSZISXDKGULZWQJWNULZTZISZWTWIXFXIIXFWKXD
      TZWOWQTZTZJSZKSZXIXEXMKJWKXDWOWQUHUIXKXLJSZTZKSXKKSZXPTXOXIXKXPKUJXNXQKXK
      XLJWKXDJWKJUKXDJABDEHIJKLMNUMUNVCUOUPXGXRXHXPXDKGUQWQJWNUQURUSUTUPWRXEIKJ
      WKCWOUGZWQTWKXDWOUGZWQTWRXEXSXTWQCXDWKWOQVAVDWKCWOWQVBWKXDWOWQVBUSVEWIXHI
      FULZWMFRZXHTZISXJWIWGIFJWNWPVFZVFZRWGYDRZIFULYAWHYEWGABDEFGHIJKLMNOPVGVHI
      WGFYDVIYFXHIFJWGWNWPVIVJVKXHIFUQYCXIIYBXGXHXGIFPVLVDUPVKVMWSXCIWRXBKJWRXB
      WRCWOXAVNZWRXBVNWKCWOWQVOCWNWJWLCIKABQVPVQYGWOWKCWQUGZTZXAYHTZWRXBWOXAYHV
      RWRWOWKCWQUEYIWKCWOWQVSWOWKCWQVTUTXBXAWKCWQUEYJWKCXAWQVSXAWKCWQVTUTWAWBWC
      WDWEWF $.
  $}

  ${
    $d A f i n y $.  $d D i $.  $d R f i n y $.  $d X f i n y $.  $d i ph $.
    bnj917.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj917.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj917.3 $e |- D = ( om \ { (/) } ) $.
    bnj917.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj917.5 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj917 $p |- ( y e. _trCl ( X , A , R ) -> E. f E. n E. i ( ch /\ i e. n /\
        y e. ( f ` i ) ) ) $=
      ( cv wcel wex c-bnj18 wfn w3a w-bnj17 biid bnj916 wa bnj252 bitri 3anbi1i
      cfv bnj253 bitr4i 3exbii sylibr ) DRZEHLUASKRZGSZIRZUQUBZABUCZJRZUQSZUPVB
      USUKSZUDZJTKTITCVCVDUCZJTKTITABVADEFGHIJKLMNOPVAUEUFVFVEIKJVFURVAUGZVCVDU
      CVECVGVCVDCURUTABUDVGQURUTABUHUIUJURVAVCVDULUMUNUO $.
  $}

  ${
    $d A f n $.  $d R f n $.  $d X f n $.
    bnj934.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj934.4 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj934.7 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj934.50 $e |- G e. _V $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj934 $p |- ( ( ph /\ ( G ` (/) ) = ( f ` (/) ) ) -> ph" ) $=
      ( c0 cfv cv wceq wa wsbc c-bnj14 eqtr sylan2b bnj523 bitr4i sbcbii bnj609
      vex bitri sylibr ancoms ) OFPZODQZPZRZAJUOASULBCGUAZRZJAUOUNUPRZUQKULUNUP
      UBUCABCDFGJKJIDFTADFTMIADFIURAABCEUMHQGIKLHUHUDKUEUFUINUGUJUK $.
  $}

  ${
    $d A f n $.  $d R f n $.  $d X f n $.
    bnj929.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj929.4 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj929.7 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj929.10 $e |- D = ( om \ { (/) } ) $.
    bnj929.13 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj929.50 $e |- C e. _V $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj929 $p |- ( ( n e. D /\ p = suc n /\ f Fn n /\ ph ) -> ph" ) $=
      ( w-bnj17 c0 cv wcel csuc wceq wfn cfv bnj645 wa wfun bnj334 bnj257 bitri
      w3a bnj345 bnj253 3bitri simp1bi bnj927 bnj930 syl wss cop csn bnj931 a1i
      cdm bnj268 bitr3i fndm bnj529 eleq2 biimpar syl2anr bnj1502 bnj918 bnj934
      syl2anc ) GUAZDUBZJUAZVRUCUDZFUAZVRUEZASZATHUFTWBUFUDLVSWAWCAUGWDTHWBWDWA
      WCUHZHUIWDWEVSAWDWCVSAWASZWAWCVSASWEVSAUMWDWCVSWAASWFVSWAWCAUJWCVSWAAUKUL
      WCVSAWAUNWAWCVSAUOUPUQWEVTHCFGHJQRURUSUTWBHVAWDHWBVRCVBVCQVDVEWDVSWCUHZTW
      BVFZUBZWDWGWAAWDVSWCWAASWGWAAUMVSWCWAAVGVSWCWAAUOVHUQWCWHVRUDZTVRUBZWIVSV
      RWBVIDVRPVJWJWIWKWHVRTVKVLVMUTVNABEFGHIJKLMNOCFGHQVOVPVQ $.
  $}

  ${
    $d A i p y $.  $d A p x y $.  $d R i p y $.  $d R p x y $.  $d X x $.
    $d f i p y $.  $d f p x y $.  $d i m p $.  $d si x $.  $d ta x $.
    bnj938.1 $e |- D = ( om \ { (/) } ) $.
    bnj938.2 $e |- ( ta <-> ( f Fn m /\ ph' /\ ps' ) ) $.
    bnj938.3 $e |- ( si <-> ( m e. D /\ n = suc m /\ p e. m ) ) $.
    bnj938.4 $e |- ( ph' <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj938.5 $e |- ( ps' <-> A. i e. om ( suc i e. m -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj938 $p |- ( ( R _FrSe A /\ X e. A /\ ta /\ si ) -> U_ y e. ( f ` p )
        _pred ( y , A , R ) e. _V ) $=
      ( vx cv wceq wex w-bnj15 wcel w-bnj17 cfv c-bnj14 ciun cvv elisset bnj706
      wi wfn c0 w3a bnj291 simplbi bnj602 eqeq2d syl6bbr 3anbi2d syl5ibr bnj546
      biid syl6 exlimiv mpcom ) TUAZKUBZTUCZDFUDZKDUEZABUFZCLUAGUAZUGDFCUAUHUIU
      JUEZVLVMABVKTKDUKULVJVNVPUMTVJVNVLVOIUAUNZUOVOUGZDFVIUHZUBZNUPZBUPZVPVNWB
      VJVLABUPZVNWCVMVLVMABUQURVJWAAVLBVJWAVQMNUPAVJVTMVQNVJVTVRDFKUHZUBMVJVSWD
      VRDFVIKUSUTRVAVBPVAVBVCWABTCDEFGHIJLVTNOWAVEQVTVESVDVFVGVH $.
  $}

  ${
    $d A f i m n $.  $d A f i m y $.  $d R f i m n $.  $d R f i m y $.
    $d X f n $.
    bnj944.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj944.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj944.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj944.4 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj944.7 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj944.10 $e |- D = ( om \ { (/) } ) $.
    bnj944.12 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj944.13 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj944.14 $e |- ( ta <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj944.15 $e |- ( si <-> ( n e. D /\ p = suc n /\ m e. n ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj944 $p |- ( ( ( R _FrSe A /\ X e. A )
        /\ ( ch /\ n = suc m /\ p = suc n ) ) -> ph" ) $=
      ( w-bnj15 wcel wa csuc wceq w3a cvv wfn w-bnj17 simpl bnj667 sylbi sylibr
      cv 3ad2ant1 adantl bnj1232 vex bnj216 id 3anim123i bitri bnj253 syl3anbrc
      3ancomb cfv c-bnj14 ciun bnj938 syl5eqel syl bnj658 simp3 bnj291 sylanbrc
      wi c0 cif cop csn cun wsbc opeq2 sneqd uneq2d syl5eq dfsbcq syl5bb imbi2d
      wb biid eqid 0ex elimel bnj929 dedth sylc ) GJUJZPGUKZULZCNVCZMVCZUMUNZQV
      CXJUMUNZUOZULZHUPUKZXJIUKZXMKVCZXJUQZAURZSXOXGXHDEURZXPXOXIDEYAXIXNUSXNDX
      ICXLDXMCXSABUOZDCXQXSABURZYBUBXQXSABUTVAUHVBVDVEXNEXIXNXQXKXJUKZXMUOZECXQ
      XLYDXMXMCXQXSABUBVFXJXKMVGVHXMVIVJEXQXMYDUOYEUIXQXMYDVNVKVBVEXGXHDEVLVMYA
      HFXKXRVOGJFVCVPVQUPUFDEFGIJKLNQPMABUEUHUITUAVRVSVTXNXTXIXNXQXSAUOZXMXTCXL
      YFXMCYCYFUBXQXSABWAVAVDCXLXMWBXQXMXSAWCWDVEXPXTSWEXTRKXRXJXPHWFWGZWHZWIZW
      JZWKZWEHWFHYGUNZSYKXTSRKOWKZYLYKUDYLOYJUNYMYKWSYLOXRXJHWHZWIZWJYJUGYLYOYI
      XRYLYNYHHYGXJWLWMWNWORKOYJWPVTWQWRAGYGIJKNYJPQRYKTUCYKWTUEYJXAHWFUPXBXCXD
      XEXF $.
  $}

  ${
    bnj953.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj953.2 $e |- ( ( G ` i ) = ( f ` i ) -> A. y ( G ` i ) = ( f ` i ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj953 $p |- ( ( ( G ` i ) = ( f ` i ) /\ ( G ` suc i ) = ( f ` suc i ) /\
        ( i e. om /\ suc i e. n ) /\ ps ) -> ( G ` suc i ) = U_ y e. ( G ` i )
        _pred ( y , A , R ) ) $=
      ( cv cfv wceq csuc com wcel wa w-bnj17 c-bnj14 ciun bnj312 bnj251 sylan2b
      bitri wi wal bnj115 sp impcom bnj956 eqtr3 syl2anr eqtr sylan2 sylbi ) FK
      ZHLZUPEKZLZMZUPNZHLZVAURLZMZUPOPVAGKPZQZARZVDUTVFAQZQZQZVBBUQCDBKSZTZMZVG
      VDUTVFARVJUTVDVFAUAVDUTVFAUBUDVIVDVCVLMZVMVHVCBUSVKTZMZVLVOMVNUTAVFVFVPUE
      ZFUFZVPVPVEAOFIUGVRVFVPVQFUHUIUCBUQUSVKJUJVCVLVOUKULVBVCVLUMUNUO $.
  $}

  ${
    $d C w $.  $d G w $.  $d f y z $.  $d i w y $.  $d i y z $.  $d n w y $.
    bnj958.1 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj958.2 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj958 $p |- ( ( G ` i ) = ( f ` i ) -> A. y ( G ` i ) = ( f ` i ) ) $=
      ( cv cfv wceq cop csn cun nfcv c-bnj14 nfcxfr ciun nfiu1 nfop nfsn nfeq1
      nfun nffv nfri ) FLZIMZUIELZMZNAAUJULAUIIAIUKHLZCOZPZQKAUKUOAUKRAUNAUMCAU
      MRACAGLUKMZBDALSZUAJAUPUQUBTUCUDUFTAUIRUGUEUH $.
  $}

  ${
    $d A e f $.  $d C w $.  $d G e i w $.  $d N f $.  $d R e f $.
    $d e f i w y $.  $d n w y $.
    bnj1000.1 $e |- ( ps <-> A. i e. om ( suc i e. N
        -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1000.2 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj1000.3 $e |- G e. _V $.
    bnj1000.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj1000.16 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1000 $p |- ( ps" <-> A. i e. om ( suc i e. N
        -> ( G ` suc i ) = U_ y e. ( G ` i ) _pred ( y , A , R ) ) ) $=
      ( cv cfv wceq ve vw wsbc csuc wcel c-bnj14 ciun wi com wral df-ral bicomi
      wal sbcbii cvv wb nfv sbc19.21g ax-mp fveq1 ax-17 cop csn cun nfcv nfcxfr
      nfiu1 nfop nfsn nfun nffv nfcrii bnj1316 syl eqeq12d bnj956 bnj610 imbi2i
      bitri albii sbcal 3bitr4ri ) LAFJUCZGRZUDZKUEZWEJSZBWDJSZCEBRUFZUGZTZUHZG
      UIUJZNWDUIUEZWFWEFRZSZBWDWOSZWIUGZTZUHZUHZGUMZFJUCZWTGUIUJZFJUCWMWCXBXDFJ
      XDXBWTGUIUKULUNXAFJUCZGUMWNWLUHZGUMXCWMXEXFGXEWNWTFJUCZUHZXFJUOUEZXEXHUPO
      WNWTFJUOWNFUQURUSXGWLWNXGWFWSFJUCZUHZWLXIXGXKUPOWFWSFJUOWFFUQURUSXJWKWFWS
      WKFUAJWEUARZSZBWDXLSZWIUGZTOWOJTZWPWGWRWJWEWOJUTXPWQWHTWRWJTWDWOJUTBUBWQW
      HWIUBRZWQUEBVABUBWHBWDJBJWOIRZDVBZVCZVDQBWOXTBWOVEBXSBXRDBXRVEBDBHRWOSZWI
      UGPBYAWIVGVFVHVIVJVFBWDVEVKVLZVMVNVOWOXLTZWPXMWRXOWEWOXLUTYCWQXNTZWRXOTWD
      WOXLUTBWQXNWIYDBVAVPVNVOXLJTZXMWGXOWJWEXLJUTYEXNWHTXOWJTWDXLJUTBUBXNWHWIX
      QXNUEBVAYBVMVNVOVQVRVSVRVSVTXAGFJWAWLGUIUKWBAXDFJMUNWBVS $.
  $}

  ${
    $d A e f $.  $d C w $.  $d G e i $.  $d G i w $.  $d N f $.  $d R e f $.
    $d e f i y $.  $d e i y z $.  $d n w y $.
    bnj965.1 $e |- ( ps <-> A. i e. om ( suc i e. N -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj965.2 $e |- ( ps" <-> [. G / f ]. ps ) $.
    bnj965.12000 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj965.13000 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj852 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj965 $p |- ( ps" <-> A. i e. om ( suc i e. N
        -> ( G ` suc i ) = U_ y e. ( G ` i ) _pred ( y , A , R ) ) ) $=
      ( bnj918 bnj1000 ) ABCDEFGHIJKLMNDFIJPQOPR $.
  $}

  ${
    $d A f i n $.  $d D i $.  $d G i $.  $d R f i n $.  $d X i $.  $d f i p $.
    $d f i n y $.  $d i m $.  $d i ph $.
    bnj964.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj964.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj964.5 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj964.8 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj964.12 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj964.13 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj964.96 $e |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc
        n ) /\ ( i e. om /\ suc i e. p /\ suc i e. n ) ) -> ( G ` suc i ) = U_
        y e. ( G ` i ) _pred ( y , A , R ) ) $.
    bnj964.165 $e |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p =
        suc n ) /\ ( i e. om /\ suc i e. p /\ n = suc i ) ) -> ( G ` suc i ) =
        U_ y e. ( G ` i ) _pred ( y , A , R ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj964 $p |- ( ( ( R _FrSe A /\ X e. A )
        /\ ( ch /\ n = suc m /\ p = suc n ) ) -> ps" ) $=
      ( w-bnj15 wcel wa cv csuc wceq w3a com cfv c-bnj14 wi wal nfv wfn bnj1095
      ciun bnj1096 nfi nf3an nfan w-bnj17 bnj255 wo bnj645 simp3 bnj706 biimpac
      eleq2 elsuci eqcom orbi2i syl syl2anc df-3an 3anbi3i bitr4i bnj345 bnj252
      sylib 3bitri anbi2i sylbir ex jaoi 3expia alrimi vex bnj539 bnj965 bnj115
      mpcom sylibr ) EHUFNEUGUHZCLUIZKUIUJUKZOUIZWSUJZUKZULZUHZJUIZUMUGZXFUJZXA
      UGZUHZXHMUNDXFMUNEHDUIUOZVAUKZUPZJUQQXEXMJWRXDJWRJURCWTXCJCJBCWSGUGIUIZWS
      USAJBXHWSUGZXHXNUNDXFXNUNXKVAUKUPJUMRUTSVBVCWTJURXCJURVDVEWRXDXJXLWRXDXJU
      LZWRXDXGXIVFZXLWRXDXGXIVGZXOWSXHUKZVHZXQXLXQXIXCXTWRXDXGXIVIWRXDXGXIXCCWT
      XCVJVKXIXCUHXHXBUGZXTXCXIYAXAXBXHVMVLYAXOXHWSUKZVHXTXHWSVNYBXSXOXHWSVOVPW
      DVQVRXOXQXLUPXSXOXQXLXOXQUHZWRXDXGXIXOULZULZXLYEXOXPUHZYCYEWRXDXJXOVFZXOW
      RXDXJVFYFYEWRXDXJXOUHZULYGYDYHWRXDXGXIXOVSVTWRXDXJXOVGWAWRXDXJXOWBXOWRXDX
      JWCWEXQXPXOXRWFWAUDWGWHXSXQXLXSXQUHZWRXDXGXIXSULZULZXLYKXSXPUHZYIYKWRXDXJ
      XSVFZXSWRXDXJVFYLYKWRXDXJXSUHZULYMYJYNWRXDXGXIXSVSVTWRXDXJXSVGWAWRXDXJXSW
      BXSWRXDXJWCWEXQXPXSXRWFWAUEWGWHWIWPWGWJWKXLXIQUMJPDEFHIJKLMXAQBDEHJLXNXAP
      RTOWLWMUAUBUCWNWOWQ $.
  $}

  ${
    $d f y $.  $d i y $.  $d m y $.  $d n y $.
    bnj966.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj966.10 $e |- D = ( om \ { (/) } ) $.
    bnj966.12 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj966.13 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj966.44 $e |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc
        n ) ) -> C e. _V ) $.
    bnj966.53 $e |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc
        n ) ) -> G Fn p ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj966 $p |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc n
        ) /\ ( i e. om /\ suc i e. p /\ n = suc i ) ) -> ( G ` suc i ) = U_ y
        e. ( G ` i ) _pred ( y , A , R ) ) $=
      ( w-bnj15 wcel csuc wceq w3a com cfv c-bnj14 ciun wfun cop bnj930 3adant3
      wa cv csn cun opex snid elun2 ax-mp eleqtrri funopfv simp22 simp33 bnj551
      ee10 wb syl2anc suceq eqeq2d biimpac fveq2d bnj1113 syl5eq adantl eqeq12d
      fveq2 mpbid cvv wfn w-bnj17 3ad2ant1 3ad2ant2 simp23 bnj951 bnj923 bnj769
      bnj1235 bnj240 vex bnj216 syl bnj658 anim1i df-bnj17 sylibr bnj945 bnj958
      simp3 bnj956 mpbird ) EHUBNEUCUOZCLUPZKUPZUDZUEZOUPZXEUDUEZUFZJUPZUGUCZXL
      UDZXIUCZXEXNUEZUFZUFZXNMUHZDXLMUHZEHDUPUIZUJZUEZXSDXLIUPZUHZYAUJZUEZXRXEM
      UHZFUEZYGXRMUKZXEFULZMUCYIXDXKYJXQXDXKUOXIMUAUMUNYKYDYKUQZURZMYKYLUCYKYMU
      CYKXEFUSUTYKYLYDVAVBSVCXEFMVDVHXRXHXFXLUEZYIYGVIXDCXHXJXQVEZXRXHXPYNYOXDX
      KXMXOXPVFZJLKVGVJXHYNUOZYHXSFYFYQXEXNMYNXHXPYNXGXNXEXFXLVKVLVMVNYNFYFUEXH
      YNFDXFYDUHZYAUJYFRDXFXLYRYEYAXFXLYDVSVOVPVQVRVJVTXRXTYEUEZYCYGVIXRFWAUCZY
      DXEWBZXJXPWCZXLXEUCZYSYTUUAXJXPXRXDXKYTXQTUNXKXDUUAXQCXHUUAXJCXEGUCZUUAAB
      PWJWDWEXDCXHXJXQWFYPWGXRXEUGUCZXPUOUUCXDXKXQUUEXPCXHUUEXJUUDUUAABUUECPGLQ
      WHWIWDXMXOXPXAWKXPUUCUUEXEXLJWLWMVQWNUUBUUCUOZYTUUAXJUUCWCZYSUUFYTUUAXJUF
      ZUUCUOUUGUUBUUHUUCYTUUAXJXPWOWPYTUUAXJUUCWQWRXLFILMOSWSWNVJYSYBYFXSDXTYEY
      ADEFHIJKLMRSWTXBVLWNXC $.
  $}

  ${
    $d f y $.  $d i y $.  $d n y $.
    bnj967.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj967.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj967.10 $e |- D = ( om \ { (/) } ) $.
    bnj967.12 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj967.13 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj967.44 $e |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc
        n ) ) -> C e. _V ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj967 $p |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc n
        ) /\ ( i e. om /\ suc i e. p /\ suc i e. n ) ) -> ( G ` suc i ) = U_ y
        e. ( G ` i ) _pred ( y , A , R ) ) $=
      ( w-bnj15 wcel csuc wceq w3a com cfv w-bnj17 c-bnj14 ciun cvv wfn 3adant3
      wa cv 3ad2ant1 3ad2ant2 simp23 simp3 3ad2ant3 bnj951 bnj923 bnj769 bnj240
      bnj1235 wtr word nnord ordtr syl trsuc sylan bnj658 anim1i sylibr syl2anc
      df-bnj17 bnj945 3simpb bnj1254 bnj958 bnj953 ) EHUBNEUCUOZCLUPZKUPUDUEZOU
      PZWEUDUEZUFZJUPZUGUCZWJUDZWGUCZWLWEUCZUFZUFZWJMUHZWJIUPZUHUEZWLMUHZWLWRUH
      UEZWKWNUOZBUIWTDWQEHDUPUJUKUEWSXAXBBWPWPFULUCZWRWEUMZWHWJWEUCZUIZWSWPXCXD
      WHWNUIZXEXFXCXDWHWNWPWDWIXCWOUAUNWIWDXDWOCWFXDWHCWEGUCZXDABQVFUQURWDCWFWH
      WOUSWOWDWNWIWKWMWNUTZVAVBZWPWEUGUCZWNUOXEWDWIWOXKWNCWFXKWHXHXDABXKCQGLRVC
      VDUQXIVEXKWEVGZWNXEXKWEVHXLWEVIWEVJVKWEWJVLVMVKXGXEUOXCXDWHUFZXEUOXFXGXMX
      EXCXDWHWNVNVOXCXDWHXEVRVPVQWJFILMOTVSVKWPXGXAXJWLFILMOTVSVKWOWDXBWIWKWMWN
      VTVAWIWDBWOCWFBWHCXHXDABQWAUQURVBBDEHIJLMPDEFHIJKLMSTWBWCVK $.
  $}

  ${
    $d A i m y $.  $d R i m y $.  $d f i m y $.  $d i m n $.
    bnj969.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj969.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj969.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj969.10 $e |- D = ( om \ { (/) } ) $.
    bnj969.12 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj969.14 $e |- ( ta <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj969.15 $e |- ( si <-> ( n e. D /\ p = suc n /\ m e. n ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj969 $p |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc n
        ) ) -> C e. _V ) $=
      ( w-bnj15 wcel wa cv csuc wceq w3a w-bnj17 cvv simpl wfn 3imtr4i 3ad2ant1
      bnj667 adantl bnj1232 vex bnj216 id 3anim123i 3ancomb bitri sylibr bnj256
      jca32 cfv c-bnj14 ciun bnj938 syl5eqel syl ) GJUDZOGUEZUFZCNUGZMUGZUHUIZP
      UGVRUHUIZUJZUFZVOVPDEUKZHULUEWCVQDEUFUFWDWCVQDEVQWBUMWBDVQCVTDWAVRIUEZKUG
      ZVRUNZABUKWGABUJCDWEWGABUQSUBUOUPURWBEVQWBWEVSVRUEZWAUJZECWEVTWHWAWACWEWG
      ABSUSVRVSMUTVAWAVBVCEWEWAWHUJWIUCWEWAWHVDVEVFURVHVOVPDEVGVFWDHFVSWFVIGJFU
      GVJVKULUADEFGIJKLNPOMABTUBUCQRVLVMVN $.
  $}

  ${
    bnj970.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj970.10 $e |- D = ( om \ { (/) } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj970 $p |- ( ( ( R _FrSe A /\ X e. A ) /\ ( ch /\ n = suc m /\ p = suc n
        ) ) -> p e. D ) $=
      ( wcel wa cv wceq com c0 wne w-bnj15 csuc w3a wfn bnj1232 3ad2ant1 adantl
      simpr3 bnj923 wb peano2 eleq1 bnj926 syl2an sylan csn df-suc eqeq2i ssun2
      cun wss vex snnz ssn0 mp2an neeq1 mpbiri sylbi cdif eleq2i bitri sylanbrc
      eldifsn syl2anc ) DFUAJDNOZCIPZHPUBQZKPZVPUBZQZUCZOVPENZVTVRENZWAWBVOCVQW
      BVTCWBGPVPUDABLUEUFUGVOCVQVTUHWBVTOVRRNZVRSTZWCWBVPRNZVTWDEIMUIWFVSRNZWDW
      GUJWDVTVPUKVRVSRULWGWDUMUNUOVTWEWBVTVRVPVPUPZUTZQZWEVSWIVRVPUQURWJWEWISTZ
      WHWIVAWHSTWKWHVPUSVPIVBVCWHWIVDVEVRWISVFVGVHUGWCVRRSUPVIZNWDWEOEWLVRMVJVR
      RSVMVKVLVN $.
  $}

  ${
    $d A f i m n y $.  $d D f i n $.  $d G i $.  $d R f i m n y $.
    $d X f i n $.  $d f i n p $.  $d i ph $.
    bnj910.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj910.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj910.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj910.4 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj910.5 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj910.6 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj910.7 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj910.8 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj910.9 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj910.10 $e |- D = ( om \ { (/) } ) $.
    bnj910.11 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj910.12 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj910.13 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj910.14 $e |- ( ta <-> ( f Fn n /\ ph /\ ps ) ) $.
    bnj910.15 $e |- ( si <-> ( n e. D /\ p = suc n /\ m e. n ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj910 $p |- ( ( ( R _FrSe A /\ X e. A )
        /\ ( ch /\ n = suc m /\ p = suc n ) ) -> ch" ) $=
      ( w-bnj15 wcel csuc wceq w3a wfn w-bnj17 bnj970 cvv bnj969 simpr3 bnj1235
      wa cv adantl bnj941 3impib syl3anc bnj944 bnj967 bnj966 bnj964 bnj951 vex
      3ad2ant1 bnj919 bnj918 bnj976 sylibr ) GKUTQGVAVLZCOVMZNVMVBVCZRVMZWJVBVC
      ZVDZVLZWLJVAZPWLVEZUBUCVFUDWPWQUBUCWOABCGJKLNOQRUGUNVGWOIVHVAZWMLVMZWJVEZ
      WQABCDEFGIJKLMNOQRUEUFUGUNUPURUSVIZWICWKWMVJWNWTWICWKWTWMCWJJVAWTABUGVKWD
      VNWRWMWTWQILOPRUQVOVPVQZABCDEFGIJKLMNOPQRSUBUEUFUGUHUKUNUPUQURUSVRABCFGIJ
      KLMNOPQRTUCUFUGUIULUPUQABCFGIJKLMNOPQRUFUGUNUPUQXAVSABCFGIJKLMNOPQRUGUNUP
      UQXAXBVTWAWBSTUAJLPWLUBUCUDABCJWLOWSSTUAUGUHUIUJRWCWEUKULUMILOPUQWFWGWH
      $.
  $}

  ${
    $d A y z $.  $d R y z $.  $d X y z $.
    bnj978.1 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj978.2 $e |- ( th -> z e. _trCl ( X , A , R ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj978 $p |- ( ( R _FrSe A /\ X e. A ) -> _TrFo ( _trCl ( X , A , R ) , A ,
        R ) ) $=
      ( w-bnj15 wcel wa cv wral wi wal 2albii 19.21v imbi2i 3bitri sylibr bitri
      c-bnj14 c-bnj18 wss w-bnj19 w-bnj17 sylbir gen2 w3a bnj253 imbi1i 3impexp
      albii df-ral bicomi mpbi dfss2 ralbii df-bnj19 ) DEIZFDJZKZDEBLZUBZDEFUCZ
      UDZBVEMZDVEEUEVBCLZVDJZVHVEJZNZCOZBVEMZVGUTVAVCVEJZVIUFZVJNZCOBOZVBVMNZVP
      BCVOAVJGHUGUHVQVBVNVIUIZVJNZCOBOVBVNVKNZNZCOZBOZVRVPVTBCVOVSVJUTVAVNVIUJU
      KPVTWBBCVBVNVIVJULPWDVBVNVLNZNZBOVBWEBOZNVRWCWFBWCVBWACOZNWFVBWACQWHWEVBV
      NVKCQRUAUMVBWEBQWGVMVBVMWGVLBVEUNUORSSUPVFVLBVECVDVEUQURTBDVEEUST $.
  $}

  ${
    $d A f i n y $.  $d A f i w y $.  $d D i y $.  $d R f i n y $.
    $d R f i w y $.  $d X f i n y $.  $d Z f i n y $.  $d i ph y $.
    bnj981.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj981.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj981.3 $e |- D = ( om \ { (/) } ) $.
    bnj981.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj981.5 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj981 $p |- ( Z e. _trCl ( X , A , R ) -> E. f E. n E. i ( ch /\ i e. n /\
        Z e. ( f ` i ) ) ) $=
      ( wcel wex c-bnj18 cv cfv w3a wceq elisset bnj917 3anbi3d 3exbidv imbi12d
      wi eleq1 mpbii bnj593 nfv wfn csuc c-bnj14 ciun com wral nfcv nfiu1 nfeq2
      nfim nfral nfxfr nfri bnj1096 nfi nf3an nfex bnj1397 pm2.43i ) MEHLUAZSZC
      JUBZKUBZSZMVQIUBZUCZSZUDZJTZKTZITZVPVPWFUKZDVPDUBZMUEZWGDDMVOUFWIWHVOSZCV
      SWHWASZUDZJTKTITZUKWGABCDEFGHIJKLNOPQRUGWIWJVPWMWFWHMVOULWIWLWCIKJWIWKWBC
      VSWHMWAULUHUIUJUMUNWGDVPWFDVPDUOWEDIWDDKWCDJCVSWBDCDBCVRGSVTVRUPADBDBVQUQ
      ZVRSZWNVTUCZDWAEHWHURZUSZUEZUKZJUTVADOWTDJUTDUTVBWOWSDWODUODWPWRDWAWQVCVD
      VEVFVGVHRVIVJVSDUOWBDUOVKVLVLVLVEVHVMVN $.
  $}

  ${
    $d A f i n y $.  $d D i $.  $d R f i n y $.  $d X f i n y $.  $d Z f i n $.
    $d i ph $.
    bnj983.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj983.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj983.3 $e |- D = ( om \ { (/) } ) $.
    bnj983.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj983.5 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj983 $p |- ( Z e. _trCl ( X , A , R ) <-> E. f E. n E. i ( ch /\ i e. n
        /\ Z e. ( f ` i ) ) ) $=
      ( wcel wex c-bnj18 cv cdm cfv wa w3a wrex ciun bnj882 eleq2i eliun rexbii
      wfn bitri df-rex abeq2i anbi1i exbii 3bitri w-bnj17 bnj252 anbi12i bitr4i
      bnj133 19.41v csuc c-bnj14 wi com bnj1095 bnj1096 nfi 19.42 2exbii 3anass
      wceq 3exbii wb fndm bnj770 eleq2 3anbi2d syl 3ad2ant1 ibir impbii 3bitr2i
      ibi ) MEHLUAZSZCJUBZIUBZUCZSZMWKWLUDZSZUEZUEZJTZKTITZCWNWPUFZJTKTITCWKKUB
      ZSZWPUFZJTKTITWJCWQJTZUEZKTZITWTWJCKTZXEUEZXGIWJWLXBUMZABUFZKGUGZWPJWMUGZ
      UEZXIIWJMIFJWMWOUHZUHZSZXMIFUGZXNITZWIXPMABDEFGHIJKLNOPQUIUJXQMXOSZIFUGXR
      IMFXOUKXTXMIFJMWMWOUKULUNXRWLFSZXMUEZITXSXMIFUOYBXNIYAXLXMXLIFQUPUQURUNUS
      XIXBGSZXKUEZKTZXEUEXNXHYEXECYDKCYCXJABUTYDRYCXJABVAUNURUQXLYEXMXEXKKGUOWP
      JWMUOVBVCVDCXEKVEVDWSXFIKCWQJCJBCYCXJAJBWKVFZXBSYFWLUDDWOEHDUBVGUHVPVHJVI
      OVJRVKVLVMVNVCXAWRIKJCWNWPVOVQXAXDIKJXAXDXAXDCWNXAXDVRZWPCWMXBVPZYGYCXJAB
      YHCRXBWLVSVTYHWNXCCWPWMXBWKWAWBWCZWDWHXDXACXCYGWPYIWDWEWFVQWG $.
  $}

$( MARKER 1 - TODO DELETE $)

  ${
    bnj984.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj984.11 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj984 $p |- ( G e. A -> ( G e. B <-> [. G / f ]. E. n ch ) ) $=
      ( wcel cv wfn w3a wrex wsbc wex cab sbc8g eleq2i wa df-rex w-bnj17 bnj252
      syl6rbbr bitri bnj133 sbcbii syl6bb ) IDLZIELZGMHMZNZABOZHFPZGIQZCHRZGIQU
      KUQIUPGSZLULUPGIDTEUSIKUAUFUPURGIUPUMFLZUOUBZCHUOHFUCCUTUNABUDVAJUTUNABUE
      UGUHUIUJ $.
  $}

  ${
    $d G p $.  $d ch p $.  $d f p $.
    bnj985.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj985.6 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj985.9 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj985.11 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj985.13 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj985 $p |- ( G e. B <-> E. p ch" ) $=
      ( wcel wex wsbc cvv wb bnj918 bnj984 ax-mp sbcex2 cv wsb sb8e sbsbc exbii
      nfv bitri bnj133 sbcbii 3bitr4i ) IDRZCHSZGITZLJSZIUARUQUSUBEGHIQUCABCUAD
      FGHIMPUDUEKJSZGITKGITZJSUSUTKJGIUFURVAGIURCHJUGTZKJURCHJUHZJSVCJSCHJCJULU
      IVDVCJCHJUJUKUMNUNUOLVBJOUKUPUM $.
  $}

  ${
    $d m n p $.
    bnj986.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj986.10 $e |- D = ( om \ { (/) } ) $.
    bnj986.15 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj986 $p |- ( ch -> E. m E. p ta ) $=
      ( cv com wcel csuc wceq wa wex wfn bnj158 bnj769 bnj1196 vex sucex isseti
      wrex jctir exdistr 19.41v bitr2i sylib w3a df-3an bitri 2exbii sylibr ) C
      GMZNOZHMZURPQZRZIMUTPZQZRZISGSZDISGSCVBGSZVDISZRZVFCVGVHCVAGNUTEOFMUTTABV
      AGNUGCJEHGKUAUBUCIVCUTHUDUEUFUHVFVBVHRGSVIVBVDGIUIVBVHGUJUKULDVEGIDUSVAVD
      UMVELUSVAVDUNUOUPUQ $.
  $}

  ${
    $d A f i n y $.  $d D i $.  $d R f i n y $.  $d X f i n y $.  $d ch m p $.
    $d et m p $.  $d f i n th $.  $d i ph $.  $d m n p th $.
    bnj996.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj996.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj996.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj996.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj996.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj996.6 $e |- ( et <-> ( i e. n /\ y e. ( f ` i ) ) ) $.
    bnj996.13 $e |- D = ( om \ { (/) } ) $.
    bnj996.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj996 $p |- E. f E. n E. i E. m E. p ( th -> ( ch /\ ta /\ et ) ) $=
      ( w3a wi wex wa wel cfv wcel w-bnj15 c-bnj18 c-bnj14 bnj917 bnj771 3anass
      cv anbi2i bitr4i 3exbii sylib bnj986 19.42vv sylibr anim1i 19.41vv df-3an
      ancli 2exbii 2eximi bnj593 19.37v exbii bnj132 mpbir ) DCEFUGZUHRUIZOUIZN
      UIZPUIZMUIZDVSRUIZOUIZNUIZPUIZMUIUHDCFUJZNUIPUIZWHMDCNPUKZGUTZNUTMUTULUMZ
      UGZNUIPUIMUIZWJMUIILUNQIUMWLILQUOUMHUTILWLUPUMWODUBABCGIJKLMNPQSTUEUFUAUQ
      URWNWIMPNWNCWKWMUJZUJWICWKWMUSFWPCUDVAVBVCVDWIWFPNWICEUJZFUJZRUIOUIZWFWIW
      QRUIOUIZFUJWSCWTFCCERUIOUIZUJWTCXAABCEKMOPRUAUEUCVEVKCEORVFVGVHWQFORVIVGV
      SWRORCEFVJVLVGVMVNWDDWHMWCDWHUHMWCDWGPWBDWGUHPWBDWFNWADWFUHNWADWEOVTDWEUH
      ODVSRVOVPVQVPVQVPVQVPVQVR $.
  $}

  ${
    $d A f i m n y $.  $d D f i n $.  $d G i $.  $d R f i m n y $.
    $d X f i n $.  $d f i n p $.  $d i ph $.
    bnj998.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj998.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj998.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj998.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj998.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj998.7 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj998.8 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj998.9 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj998.10 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj998.11 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj998.12 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj998.13 $e |- D = ( om \ { (/) } ) $.
    bnj998.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj998.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj998.16 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj998 $p |- ( ( th /\ ch /\ ta /\ et ) -> ch" ) $=
      ( w-bnj17 w-bnj15 wcel wa cv csuc wceq w3a c-bnj18 c-bnj14 bnj253 simp1bi
      sylbi bnj705 bnj643 com 3simpc bnj707 bnj255 syl3anbrc bnj252 biid bnj910
      sylib wfn syl ) DCEFVBZIMVCZSIVDZVEZCQVFZPVFZVGVHZTVFWLVGVHZVIVEZUFWHWKCW
      NWOVBZWPWHWKCWNWOVEZWQDCEFWKDWIWJGVFZIMSVJVDZHVFIMWSVKVDZVBZWKUJXBWKWTXAW
      IWJWTXAVLVMVNVODCEFVPDCEFWREWMVQVDZWNWOVIWRUKXCWNWOVRVNVSWKCWNWOVTWAWKCWN
      WOWBWEABCNVFWLWFABVIZWLLVDWOWMWLVDVIZGIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIULUMU
      NUOUPUQURUSUTVAXDWCXEWCWDWG $.
  $}

  ${
    $d f i n y $.  $d A f n $.  $d D f n $.  $d G i $.  $d R f n $.
    $d X f n $.  $d f i n p $.
    bnj999.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj999.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj999.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj999.7 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj999.8 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj999.9 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj999.10 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj999.11 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj999.12 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj999.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj999.16 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj999 $p |- ( ( ch" /\ i e. om /\ suc i e. p /\ y e. ( G ` i ) )
        -> _pred ( y , A , R ) C_ ( G ` suc i ) ) $=
      ( cv com wcel cfv w-bnj17 c-bnj14 wss w3a wa wfn vex bnj919 bnj918 bnj976
      csuc bnj1254 anim1i bnj252 3imtr4i ciun ssiun2 bnj708 3simpa ancomd simp3
      wceq wi bnj539 bnj965 bnj228 sylc bnj721 sseqtr4d syl ) UAJUMZUNUOZWGVGZO
      UMZUOZDUMZWGMUPZUOZUQZTWHWKWNUQZEHWLURZWIMUPZUSUAWHWKWNUTZVATWSVAWOWPUATW
      SUAWJGUOMWJVBSTPQRGIMWJSTUAABCGWJLIUMZPQRUDUEUFUGOVCZVDUHUIUJFILMULVEVFVH
      VIUAWHWKWNVJTWHWKWNVJVKWPWQDWMWQVLZWRTWHWKWNWQXBUSDWMWQVMVNTWHWKWNWRXBVRZ
      TWHWKUTZWHTVAWKXCXDTWHTWHWKVOVPTWHWKVQTWKXCVSJUNQDEFHIJKLMWJTBDEHJLWTWJQU
      CUFXAVTUIUKULWAWBWCWDWEWF $.
  $}

  ${
    bnj1001.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1001.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj1001.6 $e |- ( et <-> ( i e. n /\ y e. ( f ` i ) ) ) $.
    bnj1001.13 $e |- D = ( om \ { (/) } ) $.
    bnj1001.27 $e |- ( ( th /\ ch /\ ta /\ et ) -> ch" ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1001 $p |- ( ( th /\ ch /\ ta /\ et ) -> ( ch" /\ i e. om /\ suc i e. p
        ) ) $=
      ( wcel w-bnj17 com csuc cfv simplbi bnj708 wfn bnj1232 bnj706 bnj923 elnn
      cv syl syl2anc wb wceq simp3bi bnj707 word nnord ordsucelsuc biimpa eleq2
      wa 3syl anim12i syl21anc bnj926 3jca ) DCEFUAZNJULZUBTZVKUCZMULZTZSVJVKLU
      LZTZVPUBTZVLDCEFVQFVQGULVKIULZUDTQUEUFZVJVPHTZVRDCEFWACWAVSVPUGABOUHUIZHL
      RUJZUMVKVPUKUNVJVMVPUCZTZVOWEUOZVDZVOVJWAVQVNWDUPZWGWBVTDCEFWHEKULZUBTVPW
      IUCUPWHPUQURWAVQVDWEWHWFWAVQWEWAVRVPUSVQWEUOWCVPUTVKVPVAVEVBVNWDVMVCVFVGW
      EVOVHUMVI $.
  $}

  ${
    $d A f i m n y $.  $d D f n $.  $d G i $.  $d R f i m n y $.  $d X f n $.
    $d f i n p $.
    bnj1006.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1006.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1006.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1006.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj1006.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj1006.6 $e |- ( et <-> ( i e. n /\ y e. ( f ` i ) ) ) $.
    bnj1006.7 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj1006.8 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj1006.9 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj1006.10 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj1006.11 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj1006.12 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj1006.13 $e |- D = ( om \ { (/) } ) $.
    bnj1006.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj1006.16 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj1006.28 $e |- ( ( th /\ ch /\ ta /\ et ) -> ( ch" /\ i e. om /\ suc i e.
        p ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1006 $p |- ( ( th /\ ch /\ ta /\ et ) -> _pred ( y , A , R ) C_ ( G `
        suc i ) ) $=
      ( w-bnj17 cv cfv wcel c-bnj14 csuc wss wel simprbi bnj708 cvv wfn w-bnj15
      wceq wa w3a c-bnj18 bnj253 simp1bi bnj705 bnj643 com 3simpc bnj707 3anass
      sylanbrc biid bnj969 syl2anc bnj1235 bnj706 simp3bi simplbi bnj951 bnj945
      sylbi syl eleqtrrd anim1i df-bnj17 sylibr bnj999 mpdan ) DCEFVBZGVCZNVCZQ
      VDZVEZILXFVFZXGVGZQVDVHZXEXFXGMVCZVDZXHDCEFXFXNVEZFNPVIZXOUKVJVKXEJVLVEZX
      MPVCZVMZSVCZXRVGVOZXPVBXHXNVOXQXSYAXPXEXEILVNZRIVEZVPZCXROVCZVGVOZYAVQZXQ
      DCEFYDDYBYCXFILRVRVEZHVCXJVEZVBZYDUIYJYDYHYIYBYCYHYIVSVTWQWAXECYFYAVPZYGD
      CEFWBDCEFYKEYEWCVEZYFYAVQYKUJYLYFYAWDWQWECYFYAWFWGABCXSABVQZXRKVEZYAOPVIV
      QZGIJKLMNOPRSUFUGUHURUSYMWHYOWHWIWJDCEFXSCYNXSABUHWKWLDCEFYAEYLYFYAUJWMWE
      DCEFXPFXPXOUKWNVKWOXGJMPQSUTWPWRWSXEXIVPZUEXGWCVEZXKXTVEZXIVBZXLYPUEYQYRV
      QZXIVPYSXEYTXIVAWTUEYQYRXIXAXBABCGIJKLMNOPQRSTUAUBUCUDUEUFUGUHULUMUNUOUPU
      QUSUTXCWRXD $.
  $}

  ${
    $d A f i n y $.  $d D i $.  $d R f i n y $.  $d X f i n y $.  $d f g i $.
    $d i j $.  $d i ph $.
    bnj1014.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1014.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1014.13 $e |- D = ( om \ { (/) } ) $.
    bnj1014.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1014 $p |- ( ( g e. B /\ j e. dom g ) -> ( g ` j ) C_ _trCl ( X , A , R
        ) ) $=
      ( cv wcel nfv cdm wa cfv c-bnj18 wss wi wfn w3a wrex cab bnj911 nfi nfrex
      nfcv nfab nfcxfr nfcri nfan nfim nfri weq a9ev bnj1317 eleq1 dmeq anbi12d
      eleq2d fveq1 sseq1d imbi12d ciun ssiun2 bnj882 syl6sseqr sylan9ssr anbi2d
      chvar wb fveq2 equcoms mpbiri bnj101 bnj1131 ) IRZESZKRZWDUAZSZUBZWFWDUCZ
      DGMUDZUEZUFZJWMJWIWLJWEWHJJIEJEHRZLRUGABUHZLFUIZHUJQWPJHWOJLFJFUNWOJABCDG
      HJLMNOUKULUMUOUPUQWHJTURWLJTUSUTJKVAZWMJJKVBWQWMWEJRZWGSZUBZWRWDUCZWKUEZU
      FZWNESZWRWNUAZSZUBZWRWNUCZWKUEZUFXCHIWTXBHWEWSHWEHWPHIEQVCULWSHTURXBHTUSH
      IVAZXGWTXIXBXJXDWEXFWSWNWDEVDXJXEWGWRWNWDVEVGVFXJXHXAWKWRWNWDVHVIVJXFXDXH
      JXEXHVKZWKJXEXHVLXDXKHEXKVKWKHEXKVLABCDEFGHJLMNOPQVMVNVOVQWMXCVRKJKJVAZWI
      WTWLXBXLWHWSWEWFWRWGVDVPXLWJXAWKWFWRWDVSVIVJVTWAWBWC $.
  $}

  ${
    $d A f g i $.  $d A g i j $.  $d A f i n y $.  $d B g j $.  $d D i $.
    $d G g j $.  $d J j $.  $d R f g i $.  $d R g i j $.  $d R f i n y $.
    $d X f g i $.  $d X g i j $.  $d X f i n y $.  $d i ph $.
    bnj1015.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1015.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1015.13 $e |- D = ( om \ { (/) } ) $.
    bnj1015.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1015.15 $e |- G e. V $.
    bnj1015.16 $e |- J e. V $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1015 $p |- ( ( G e. B /\ J e. dom G ) -> ( G ` J ) C_ _trCl ( X , A , R
        ) ) $=
      ( vj vg wcel cv cdm wa cfv c-bnj18 wss wi elexi eleq1 anbi2d fveq2 sseq1d
      wceq imbi12d dmeq eleq2d anbi12d fveq1 bnj1014 vtocl ) KEUCZUAUDZKUEZUCZU
      FZVEKUGZDGNUHZUIZUJZVDLVFUCZUFZLKUGZVJUIZUJUALLMTUKVELUPZVHVNVKVPVQVGVMVD
      VELVFULUMVQVIVOVJVELKUNUOUQUBUDZEUCZVEVRUEZUCZUFZVEVRUGZVJUIZUJVLUBKKMSUK
      VRKUPZWBVHWDVKWEVSVDWAVGVRKEULWEVTVFVEVRKURUSUTWEWCVIVJVEVRKVAUOUQABCDEFG
      HUBIUAJNOPQRVBVCVC $.
  $}

  ${
    $d A f i m n y $.  $d D f i n $.  $d G i p $.  $d R f i m n y $.
    $d X f i n y $.  $d ch p $.  $d et p $.  $d f i n p $.  $d i ph $.
    $d p th $.
    bnj1018.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1018.2 $e |- ( ps <-> A. i e. om ( suc i e. n
        -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1018.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1018.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj1018.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj1018.7 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj1018.8 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj1018.9 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj1018.10 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj1018.11 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj1018.12 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj1018.13 $e |- D = ( om \ { (/) } ) $.
    bnj1018.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1018.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj1018.16 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj1018.26 $e |- ( ch" <-> ( p e. D /\ G Fn p /\ ph" /\ ps" ) ) $.
    bnj1018.29 $e |- ( ( th /\ ch /\ ta /\ et ) -> ch" ) $.
    bnj1018.30 $e |- ( ( th /\ ch /\ ta /\ et ) -> ( ch" /\ i e. om /\ suc i e.
        p ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1018 $p |- ( ( th /\ ch /\ et /\ E. p ta )
        -> ( G ` suc i ) C_ _trCl ( X , A , R ) ) $=
      ( wex w-bnj17 wcel cv csuc cdm cfv c-bnj18 wss w3a df-bnj17 bnj258 sylbir
      wa ex eximdv bnj985 syl6ibr imp sylbi bnj1019 com simp3d wfn wceq bnj1235
      fndm 3syl eleqtrrd exlimiv cvv bnj918 vex sucex bnj1015 syl2anc ) DCFETVE
      ZVFZRJVGZOVHZVIZRVJZVGZXERVKIMSVLVMXBDCFVNZXAVRXCDCFXAVOXHXAXCXHXAUFTVEXC
      XHEUFTXHEUFXHEVRDCEFVFZUFDCEFVPVCVQVSVTABCJKLNQRTUCUFUIUNUQUSVAWAWBWCWDXB
      XITVEXGCDEFTWEXIXGTXIXETVHZXFXIUFXDWFVGXEXJVGVDWGXIUFRXJWHZXFXJWIVCUFXJLV
      GXKUDUEVBWJXJRWKWLWMWNVQABGIJLMNOQRXEWOSUGUHURUSKNQRVAWPXDOWQWRWSWT $.
  $}

  ${
    $d A f i m n y $.  $d A f i n p y $.  $d D f i n $.  $d G i p $.
    $d R f i m n y $.  $d R f i n p y $.  $d X f i n y $.  $d ch p $.
    $d et p $.  $d i ph $.  $d p th $.
    bnj1020.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1020.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1020.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1020.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj1020.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj1020.6 $e |- ( et <-> ( i e. n /\ y e. ( f ` i ) ) ) $.
    bnj1020.7 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj1020.8 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj1020.9 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj1020.10 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj1020.11 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj1020.12 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj1020.13 $e |- D = ( om \ { (/) } ) $.
    bnj1020.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1020.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj1020.16 $e |- G = ( f u. { <. n , C >. } ) $.
    bnj1020.26 $e |- ( ch" <-> ( p e. D /\ G Fn p /\ ph" /\ ps" ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1020 $p |- ( ( th /\ ch /\ et /\ E. p ta ) -> _pred ( y , A , R ) C_
        _trCl ( X , A , R ) ) $=
      ( wex w-bnj17 c-bnj14 csuc cfv c-bnj18 wss bnj1019 bnj998 bnj1001 bnj1006
      cv exlimiv sylbir bnj1018 sstrd ) DCFETVDVEZIMGVOVFZOVOVGRVHZIMSVIVTDCEFV
      EZTVDWAWBVJZCDEFTVKWCWDTABCDEFGHIKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUO
      UPUQURUSVAVBABCDEFGLNOPQTUFUIUKULUSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJUKUMUNUOUPUQURUSUTVAVBVLZVMZVNVPVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
      IUJUKUMUNUOUPUQURUSUTVAVBVCWEWFVRVS $.
  $}

  ${
    $d A f i n y $.  $d D i $.  $d R f i n y $.  $d X f i n y $.  $d ch m p $.
    $d et m p $.  $d f i n th $.  $d i ph $.  $d m n p th $.
    bnj1021.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1021.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1021.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1021.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj1021.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj1021.6 $e |- ( et <-> ( i e. n /\ y e. ( f ` i ) ) ) $.
    bnj1021.13 $e |- D = ( om \ { (/) } ) $.
    bnj1021.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1021 $p |- E. f E. n E. i E. m ( th -> ( th /\ ch /\ et /\ E. p ta ) )
        $=
      ( w-bnj17 wi wex w3a bnj996 anclb bnj252 imbi2i bitr4i 2exbii 3exbii mpbi
      wa 19.37v bnj1019 bitri ) DDCEFUGZUHZRUIZOUIZNUIZPUIMUIZDDCFERUIUGZUHZOUI
      NUIZPUIMUIDCEFUJZUHZRUIOUIZNUIPUIMUIVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUKV
      NVFMPNVMVDORVMDDVLUSZUHVDDVLULVCVODDCEFUMUNUOUPUQURVGVKMPVEVJNOVEDVCRUIZU
      HVJDVCRUTVPVIDCDEFRVAUNVBUPUPUR $.
  $}

  ${
    $d A f i m n p y $.  $d A y z $.  $d D f i n $.  $d G i p $.
    $d R f i m n p y $.  $d R y z $.  $d X f i m n y $.  $d X y z $.
    $d ch m p $.  $d et m p $.  $d f i m n p th $.  $d i ph $.
    bnj907.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj907.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj907.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj907.4 $e |- ( th <-> ( R _FrSe A /\ X e. A /\ y e. _trCl ( X , A , R )
        /\ z e. _pred ( y , A , R ) ) ) $.
    bnj907.5 $e |- ( ta <-> ( m e. om /\ n = suc m /\ p = suc n ) ) $.
    bnj907.6 $e |- ( et <-> ( i e. n /\ y e. ( f ` i ) ) ) $.
    bnj907.7 $e |- ( ph' <-> [. p / n ]. ph ) $.
    bnj907.8 $e |- ( ps' <-> [. p / n ]. ps ) $.
    bnj907.9 $e |- ( ch' <-> [. p / n ]. ch ) $.
    bnj907.10 $e |- ( ph" <-> [. G / f ]. ph' ) $.
    bnj907.11 $e |- ( ps" <-> [. G / f ]. ps' ) $.
    bnj907.12 $e |- ( ch" <-> [. G / f ]. ch' ) $.
    bnj907.13 $e |- D = ( om \ { (/) } ) $.
    bnj907.14 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj907.15 $e |- C = U_ y e. ( f ` m ) _pred ( y , A , R ) $.
    bnj907.16 $e |- G = ( f u. { <. n , C >. } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj907 $p |- ( ( R _FrSe A /\ X e. A )
        -> _TrFo ( _trCl ( X , A , R ) , A , R ) ) $=
      ( cv c-bnj14 c-bnj18 wss wex w-bnj17 bnj1021 wal vex bnj919 bnj918 bnj976
      wi bnj1020 ax-gen wa 19.29r pm3.33 bnj593 mpan2 2eximi 19.9v mpbi w-bnj15
      bnj101 wcel bnj1254 sseldd bnj978 ) DGHIMSUJDIMGVCZVDZIMSVEZHVCZDWMWNVFZV
      OZPVGZWQWROVGZWRWSQVGZWSWTNVGWTDDCFETVGVHZVOZPVGZOVGQVGWTNABCDEFGHIJLMNOP
      QSTUGUHUIUJUKULUSUTVIXCWRQOXCXAWPVOZPVJZWRXDPABCDEFGHIJKLMNOPQRSTUAUBUCUD
      UEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBUAUBUCLNRTVCZUDUEUFABCLXFQNVCUAUBUCUI
      UMUNUOTVKVLUPUQURKNQRVBVMVNVPVQXCXEVRXBXDVRWQPXBXDPVSDXAWPVTWAWBWCWGWTNWD
      WEWSQWDWEWROWDWEWQPWDWEDIMWFSIWHWLWNWHWOWMWHUJWIWJWK $.
  $}

  ${
    $d A f i m n p y z $.  $d R f i m n p y z $.  $d X f i m n p y z $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1029 $p |- ( ( R _FrSe A /\ X e. A )
        -> _TrFo ( _trCl ( X , A , R ) , A , R ) ) $=
      ( vf vi vn vy vz vm vp c0 cv cfv wceq csuc wcel com wsbc biid eqid wi csn
      c-bnj14 ciun wral cdif wfn w-bnj17 w-bnj15 c-bnj18 w3a wel wa cab cop cun
      wrex bnj907 ) KDLZMABCUCNZELZOZFLZPVBUSMGVAUSMZABGLZUCZUDNUAEQUEZVCQKUBUF
      ZPUSVCUGZUTVGUHZABUICAPVEABCUJPHLVFPUHZILZQPVCVLONJLZVCONUKZEFULVEVDPUMZG
      HAVIUTVGUKFVHUQDUNZGVLUSMVFUDZVHBDEIFUSVCVQUOUBUPZCJUTFVMRZVGFVMRZVJFVMRZ
      VSDVRRZVTDVRRZWADVRRZUTSVGSVJSVKSVNSVOSVSSVTSWASWBSWCSWDSVHTVPTVQTVRTUR
      $.
  $}

  ${
    $d A f i n y $.  $d A f i n z $.  $d B z $.  $d D i $.  $d R f i n y $.
    $d R f i n z $.  $d X f i n y $.  $d X f i n z $.  $d f i n ta z $.
    $d f i n th z $.  $d i ph $.
    bnj1033.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1033.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1033.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1033.4 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1033.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1033.6 $e |- ( et <-> z e. _trCl ( X , A , R ) ) $.
    bnj1033.7 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1033.8 $e |- D = ( om \ { (/) } ) $.
    bnj1033.9 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1033.10 $e |- ( E. f E. n E. i ( th /\ ta /\ ch /\ ze ) -> z e. B ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1033 $p |- ( ( th /\ ta ) -> _trCl ( X , A , R ) C_ B ) $=
      ( wa c-bnj18 cv wcel wel cfv w3a bnj983 19.42v df-3an exbii 3bitr4i bitri
      w-bnj17 bnj255 anbi2i 3anass bitr4i 3anbi3i 3exbii sylbir syl3an3b 3expia
      wex ssrdv ) DEUIZIJMRUJZKDEIUKZVOULZVPKULZVQDECOPUMZVPOUKNUKUNULZUOZOVLZP
      VLZNVLZVRABCHJQLMNOPRVPSTUFUGUAUPDEWDUOZDEWAUOZOVLZPVLZNVLZVRWIDEWCUOZNVL
      ZWEWHWJNWHDEWBUOZPVLZWJWGWLPVNWAUIZOVLVNWBUIZWGWLVNWAOUQWFWNODEWAURUSDEWB
      URZUTUSWOPVLVNWCUIZWMWJVNWBPUQWLWOPWPUSDEWCURZUTVAUSWQNVLVNWDUIWKWEVNWCNU
      QWJWQNWRUSDEWDURUTVAWIDECGVBZOVLPVLNVLVRWSWFNPOWSDECGUIZUOWFDECGVCWTWADEW
      TCVSVTUIZUIWAGXACUEVDCVSVTVEVFVGVAVHUHVIVIVJVKVM $.
  $}

  ${
    $d A f i n y $.  $d A f i n z $.  $d B z $.  $d D i $.  $d R f i n y $.
    $d R f i n z $.  $d X f i n y $.  $d X f i n z $.  $d f i n ta z $.
    $d f i n th z $.  $d i ph $.
    bnj1034.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1034.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1034.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1034.4 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1034.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1034.7 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1034.8 $e |- D = ( om \ { (/) } ) $.
    bnj1034.9 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1034.10 $e |- ( E. f E. n E. i ( th /\ ta /\ ch /\ ze ) -> z e. B ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1034 $p |- ( ( th /\ ta ) -> _trCl ( X , A , R ) C_ B ) $=
      ( cv c-bnj18 wcel biid bnj1033 ) ABCDEHUGILQUHUIZFGHIJKLMNOPQRSTUAUBULUJU
      CUDUEUFUK $.
  $}

  ${
    bnj1039.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1039.2 $e |- ( ps' <-> [. j / i ]. ps ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1039 $p |- ( ps' <-> A. i e. om ( suc i e. n
        -> ( f ` suc i ) = U_ y e. ( f ` i ) _pred ( y , A , R ) ) ) $=
      ( cv wsbc csuc wcel cfv c-bnj14 ciun com cvv wceq wi wral vex nfra1 nfxfr
      wb sbcgf ax-mp 3bitri ) IAFGLZMZAFLZNZHLOUNELZPBUMUOPCDBLQRUAUBZFSUCZKUKT
      OULAUGGUDAFUKTAUQFJUPFSUEUFUHUIJUJ $.
  $}

  ${
    $d D i $.  $d f i $.  $d i n $.
    bnj1040.1 $e |- ( ph' <-> [. j / i ]. ph ) $.
    bnj1040.2 $e |- ( ps' <-> [. j / i ]. ps ) $.
    bnj1040.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1040.4 $e |- ( ch' <-> [. j / i ]. ch ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1040 $p |- ( ch' <-> ( n e. D /\ f Fn n /\ ph' /\ ps' ) ) $=
      ( cv wsbc w-bnj17 sbcbii wa wcel wfn w3a df-bnj17 vex bnj525 bicomi sbcan
      bnj887 sbc3an anbi1i 3bitri 3bitr4ri ) KCFGPZQHPZDUAZEPUOUBZABRZFUNQZUPUQ
      IJRZOCURFUNNSUPFUNQZUQFUNQZAFUNQZBFUNQZRVAVBVCUCZVDTZUTUSVAVBVCVDUDUPUQIJ
      VAVBVCVDVAUPUPFUNGUEZUFUGVBUQUQFUNVGUFUGLMUIUSUPUQAUCZBTZFUNQVHFUNQZVDTVF
      URVIFUNUPUQABUDSVHBFUNUHVJVEVDUPUQAFUNUJUKULUMUL $.
  $}

  ${
    bnj1047.1 $e |- ( rh <-> A. j e. n ( j _E i -> [. j / i ]. et ) ) $.
    bnj1047.2 $e |- ( et' <-> [. j / i ]. et ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1047 $p |- ( rh <-> A. j e. n ( j _E i -> et' ) ) $=
      ( cv cep wbr wsbc wi wral imbi2i ralbii bitr4i ) BDIZCIJKZACRLZMZDEIZNSFM
      ZDUBNGUCUADUBFTSHOPQ $.
  $}

  ${
    bnj1049.1 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1049.2 $e |- ( et <-> ( ( th /\ ta /\ ch /\ ze ) -> z e. B ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1049 $p |- ( A. i e. n et <-> A. i et ) $=
      ( cv wral wcel wi wal df-ral bitr4i bitri w-bnj17 wa imbi2i impexp bnj708
      cfv simplbi pm4.71ri bicomi imbi1i albii ) DIJMZNIMZULOZDPZIQDIQDIULRUODI
      UOBCAEUAZFMZGOZPZDUOUNUPUBZURPZUSUOUNUSPVADUSUNLUCUNUPURUDSUTUPURUPUTUPUN
      BCAEUNEUNUQUMHMUFOKUGUEUHUIUJTLSUKT $.
  $}

  ${
    $d A f i n y $.  $d A f i n z $.  $d B f i n z $.  $d D i $.
    $d R f i n y $.  $d R f i n z $.  $d X f i n y $.  $d X f i n z $.
    $d et j $.  $d f i n ta z $.  $d f i n th z $.  $d i j n $.  $d i ph $.
    bnj1052.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1052.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1052.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1052.4 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1052.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1052.6 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1052.7 $e |- D = ( om \ { (/) } ) $.
    bnj1052.8 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1052.9 $e |- ( et <-> ( ( th /\ ta /\ ch /\ ze ) -> z e. B ) ) $.
    bnj1052.10 $e |- ( rh <-> A. j e. n ( j _E i -> [. j / i ]. et ) ) $.
    bnj1052.37 $e |- ( ( th /\ ta /\ ch /\ ze ) -> ( _E Fr n /\ A. i e. n ( rh
        -> et ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1052 $p |- ( ( th /\ ta ) -> _trCl ( X , A , R ) C_ B ) $=
      ( w-bnj17 cv wcel wi wal wex 19.23vv albii 19.23v bitri cep wfr wa bnj110
      wral vex bnj1049 sylib 19.21bi mpcom gen2 mpgbi bnj1034 ) ABCDEGIJKLMNOPR
      STUAUBUCUDUEUFUGUHDECGULZJUMLUNZUOZPUPRUPZVOPUQRUQZOUQVPUOZOVROUPVSVPUOZO
      UPVTVRWAOVOVPRPURUSVSVPOUTVAVQRPRUMZVBVCHFUOPWBVFVDZVOVPUKWCFVQWCFPWCFPWB
      VFFPUPFHPQWBVBRVGUJVECDEFGJLOPRUFUIVHVIVJUIVIVKVLVMVN $.
  $}

  ${
    $d A f i n y $.  $d A f i n z $.  $d B f i n z $.  $d D i $.
    $d R f i n y $.  $d R f i n z $.  $d X f i n y $.  $d X f i n z $.
    $d et j $.  $d f i n ta z $.  $d f i n th z $.  $d i j n $.  $d i ph $.
    bnj1053.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1053.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1053.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1053.4 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1053.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1053.6 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1053.7 $e |- D = ( om \ { (/) } ) $.
    bnj1053.8 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1053.9 $e |- ( et <-> ( ( th /\ ta /\ ch /\ ze ) -> z e. B ) ) $.
    bnj1053.10 $e |- ( rh <-> A. j e. n ( j _E i -> [. j / i ]. et ) ) $.
    bnj1053.37 $e |- ( ( th /\ ta /\ ch /\ ze ) -> A. i e. n ( rh -> et ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1053 $p |- ( ( th /\ ta ) -> _trCl ( X , A , R ) C_ B ) $=
      ( w-bnj17 cv cep wfr wi wral wcel wfn word bnj923 nnord ordfr 3syl bnj769
      com bnj707 jca bnj1052 ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJDECGULRU
      MZUNUOZHFUPPVJUQDECGVKVJMURZOUMVJUSABVKCUCVLVJVFURVJUTVKMRUGVAVJVBVJVCVDV
      EVGUKVHVI $.
  $}

  ${
    bnj1071.7 $e |- D = ( om \ { (/) } ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1071 $p |- ( n e. D -> _E Fr n ) $=
      ( cv wcel com word cep wfr bnj923 nnord ordfr 3syl ) BDZAENFENGNHIABCJNKN
      LM $.
  $}

  ${
    bnj1083.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1083.8 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1083 $p |- ( f e. K <-> E. n ch ) $=
      ( cv wfn w3a wrex wcel wa wex df-rex abeq2i w-bnj17 bnj252 bitri 3bitr4i
      exbii ) EJZFJZKZABLZFDMZUEDNZUGOZFPUDGNCFPUGFDQUHEGIRCUJFCUIUFABSUJHUIUFA
      BTUAUCUB $.
  $}

  ${
    $d et j $.  $d i j $.  $d j n $.
    bnj1090.9 $e |- ( et <-> ( ( f e. K /\ i e. dom f ) -> ( f ` i ) C_ B ) )
        $.
    bnj1090.10 $e |- ( rh <-> A. j e. n ( j _E i -> [. j / i ]. et ) ) $.
    bnj1090.17 $e |- ( et' <-> [. j / i ]. et ) $.
    bnj1090.18 $e |- ( si <-> ( ( j e. n /\ j _E i ) -> et' ) ) $.
    bnj1090.19 $e |- ( ph0 <-> ( i e. n /\ si /\ f e. K /\ i e. dom f ) ) $.
    bnj1090.28 $e |- ( ( th /\ ta /\ ch /\ ze ) -> A. i E. j ( ph0 -> ( f ` i )
        C_ B ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1090 $p |- ( ( th /\ ta /\ ch /\ ze ) -> A. i e. n ( rh -> et ) ) $=
      ( w-bnj17 cv cfv wss wi wex wal wral wel wcel cdm wa impexp exbii cep wbr
      imbi1i imbi2i 19.37v wsbc bnj115 albii bitr4i 19.36v bitr2i bnj256 bnj133
      3bitr4i df-ral sylibr ) BCAEUBOJUCZIUCZUDHUEZUFZKUGZJUHZGDUFZJLUCZUIZUAJL
      UJZVRUFZJUHWAFVMMUKZVLVMULUKZUBZVNUFZKUGZJUHVTVQWBWGJWBWAFUMZDUFZWFKWIKUG
      WAFDUFZUFZKUGZWBWIWKKWAFDUNUOWAWJKUGZUFWAKLUJKUCZVLUPUQZUMZNUFZDUFZKUGZUF
      WLWBWMWSWAWJWRKFWQDSURUOUSWAWJKUTVRWSWAVRWQKUHZDUFWSGWTDGWPDJWNVAZUFZKUHW
      TXAWOGVSKQVBWQXBKNXAWPRUSVCVDURWQDKVEVDUSVIVFWHWCWDUMZUMZVNUFWHXCVNUFZUFW
      FWIWHXCVNUNWEXDVNWAFWCWDVGURDXEWHPUSVIVHVCVRJVSVJVPWGJVOWFKOWEVNTURUOVCVI
      VK $.
  $}

  ${
    $d ch j $.  $d i ta $.  $d i th $.  $d j ta $.  $d j th $.  $d D i $.
    $d f i $.  $d i n $.  $d i ph $.
    bnj1093.1 $e |- E. j ( ( ( th /\ ta /\ ch ) /\ ph0 ) -> ( f ` i ) C_ B ) $.
    bnj1093.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1093.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1093 $p |- ( ( th /\ ta /\ ch /\ ze ) -> A. i E. j ( ph0 -> ( f ` i ) C_
        B ) ) $=
      ( cv cfv wss wi wex wal w3a wcel wfn csuc c-bnj14 bnj1095 bnj1096 bnj1350
      ciun wceq com wa impexp exbii mpbi 19.37aiv alrimih bnj721 ) DECFPMTZLTZU
      AZIUBZUCZNUDZMUEDECUFZVIMDECMBCOTZJUGVEVKUHAMBVDUIZVKUGVLVEUAGVFHKGTUJUNU
      OUCMUPRUKSULUMVJVHNVJPUQVGUCZNUDVJVHUCZNUDQVMVNNVJPVGURUSUTVAVBVC $.
  $}

  ${
    bnj1097.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1097.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1097.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1097 $p |- ( ( i = (/) /\ ( ( th /\ ta /\ ch ) /\ ph0 ) ) -> ( f ` i )
        C_ B ) $=
      ( cv c0 wa wceq w3a cfv c-bnj14 wss wfn biimpi bnj771 3ad2ant3 adantr cvv
      wcel w-bnj19 simp3bi 3ad2ant2 jca anim2i 3anass sylibr fveq2 eqeq1d simpr
      biimpar eqsstrd 3impa syl ) KRZSUAZDECUBZNTZTZVHSJRZUCZFIMUDZUAZVNGUEZUBZ
      VGVLUCZGUEZVKVHVOVPTZTVQVJVTVHVJVOVPVIVONCDVOELRZHULVLWAUFABVOCPAVOOUGUHU
      IUJVIVPNEDVPCEGUKULFGIUMVPQUNUOUJUPUQVHVOVPURUSVHVOVPVSVHVOTZVPTVRVNGWBVR
      VNUAZVPVHWCVOVHVRVMVNVGSVLUTVAVCUJWBVPVBVDVEVF $.
  $}

  ${
    $d D j $.  $d i j $.  $d j n $.
    bnj1110.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1110.7 $e |- D = ( om \ { (/) } ) $.
    bnj1110.18 $e |- ( si <-> ( ( j e. n /\ j _E i ) -> et' ) ) $.
    bnj1110.19 $e |- ( ph0 <-> ( i e. n /\ si /\ f e. K /\ i e. dom f ) ) $.
    bnj1110.26 $e |- ( et' <-> ( ( f e. K /\ j e. dom f ) -> ( f ` j ) C_ B ) )
        $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1110 $p |- E. j ( ( i =/= (/) /\ ( ( th /\ ta /\ ch ) /\ ph0 ) )
        -> ( j e. n /\ i = suc j /\ ( f ` j ) C_ B ) ) $=
      ( cv c0 wne w3a wa cdm wcel wel csuc wceq cep wbr w-bnj17 cfv wss bnj1098
      wb wi wex bnj219 adantl ancli df-3an sylibr bnj1023 wfn 3ad2ant3 anim12ci
      bnj1232 anim2i 3anass bnj1101 3simpb ad2antll sylib syl5 a2i pm3.43 mpdan
      bnj1235 bnj101 bnj1247 pm3.43i ax-mp bnj770 ad2antrl eleq2d bnj268 bnj251
      bitr3i imbi2i exbii mpbir simp1 bnj706 simp2 bnj258 simprbi bnj642 mpbird
      fndm bnj645 mp2and 3jca ) JUAZUBUCZDECUDZOUEZUEZKUAZIUAZUFZUGZKLUHZUQZXNX
      EXJUIUJZXJXEUKULZUDZXKMUGZNUMZXNXPXJXKUNGUOZUDKXIXTURZKUSXIXOXSXRNUEZUEZU
      EZURZKUSXIYDURZYFKXIYCURZYGKXIXRURZYHKXFJLUHZLUAZHUGZUDZXRXIKYMXNXPUEZXRK
      HJKLQUPYNYNXQUEXRYNXQXPXQXNKJUTVAVBXNXPXQVCVDVEXIXFYJYLUEZUEYMXHYOXFXGYLO
      YJCDYLECYLXKYKVFZABPVIVGOYJFXSXEXLUGZSVIVHVJXFYJYLVKVDVLYIXINURYHXIXRNXRX
      NXQUEZXINXNXPXQVMXIFYRNUROFXFXGOYJFXSYQSVTVNRVOVPVQXIXRNVRVSWAXIXSURYHYGU
      ROXSXFXGOYJFXSYQSWBVNXIXSYCWCWDWAXIXOURYGYFURXIXLYKXJXGXLYKUJZXFOCDYSEYLY
      PABYSCPYKXKXAWEVGWFWGXIXOYDWCWDWAYBYFKXTYEXIXTXOXSXRNUMYEXOXSXRNWHXOXSXRN
      WIWJWKWLWMXTXNXPYAXOXRXSNXNXNXPXQWNWOZXOXRXSNXPXNXPXQWPWOXTXSXMYAXTXOXRNU
      DXSXOXRXSNWQWRXTXMXNYTXOXRXSNWSWTXTNXSXMUEYAURXOXRXSNXBTVOXCXDVE $.
  $}

  ${
    $d A i j $.  $d R i j $.  $d f i j y $.  $d i j n $.
    bnj1112.1 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1112 $p |- ( ps <-> A. j ( ( j e. om /\ suc j e. n ) -> ( f ` suc j ) =
        U_ y e. ( f ` j ) _pred ( y , A , R ) ) ) $=
      ( cv com wcel csuc wa cfv c-bnj14 ciun wceq wi wal bnj115 anbi12d bnj1113
      eleq1 suceq eleq1d fveq2d fveq2 eqeq12d imbi12d cbvalv bitri ) AFJZKLZUMM
      ZHJZLZNZUOEJZOZBUMUSOZCDBJPZQZRZSZFTGJZKLZVFMZUPLZNZVHUSOZBVFUSOZVBQZRZSZ
      GTVDUQAKFIUAVEVOFGUMVFRZURVJVDVNVPUNVGUQVIUMVFKUDVPUOVHUPUMVFUEZUFUBVPUTV
      KVCVMVPUOVHUSVQUGBUMVFVAVLVBUMVFUSUHUCUIUJUKUL $.
  $}

  ${
    $d A i j y $.  $d B y $.  $d D j $.  $d R i j y $.  $d f i j y $.
    $d i j n $.
    bnj1118.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1118.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1118.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1118.7 $e |- D = ( om \ { (/) } ) $.
    bnj1118.18 $e |- ( si <-> ( ( j e. n /\ j _E i ) -> et' ) ) $.
    bnj1118.19 $e |- ( ph0 <-> ( i e. n /\ si /\ f e. K /\ i e. dom f ) ) $.
    bnj1118.26 $e |- ( et' <-> ( ( f e. K /\ j e. dom f ) -> ( f ` j ) C_ B ) )
        $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1118 $p |- E. j ( ( i =/= (/) /\ ( ( th /\ ta /\ ch ) /\ ph0 ) ) -> ( f
        ` i ) C_ B ) $=
      ( cv c0 wne w3a wa wcel csuc wceq cfv wss bnj1110 ancl bnj101 com w-bnj17
      w-bnj19 simpr2 wfn bnj1254 3ad2ant3 ad2antrl adantr bnj1232 simpr1 bnj923
      anim1i ancomd syl2anc elnn syl cdm adantl ad2antlr bnj951 c-bnj14 simp2bi
      wi cvv 3ad2ant2 simp3 anim12i ciun bnj256 wal bnj1112 biimpi eleq1 anbi2d
      19.21bi fveq2 eqeq1d imbi12d syl5ibr imp31 sylbi wral ssralv syl5bi iunss
      df-bnj19 impcom sylibr sseq1 biimpar syl2an bnj1023 ) MUGZUHUIZDECUJZSUKZ
      UKZXQNUGZOUGZULZXMXRUMZUNZXRLUGZUOZIUPZUJZUKZXMYCUOZIUPZNXQYFWCXQYGWCNABC
      DEFIJLMNOPRSUAUCUDUEUFUQXQYFURUSYGYBBXRUTULZXMXSULZVAZHIKVBZYEUKZYIYBBYJY
      KYGXQXTYBYEVCXQBYFXOBXNSCDBECXSJULZYCXSVDZABUAVEVFVGVHYGXTXSUTULZUKZYJYGY
      OXTYRXQYOYFXOYOXNSCDYOECYOYPABUAVIVFVGVHXQXTYBYEVJYOXTUKYQXTYOYQXTJOUCVKV
      LVMVNXRXSVOVPXPYKXNYFSYKXOSYKFYCPULXMYCVQULUEVIVRVSVTXQYMYFYEXOYMXNSEDYMC
      EIWDULYMHKQWAIUPUBWBWEVGXTYBYEWFWGYLYHGYDHKGUGWAZWHZUNZYTIUPZYIYNYLYBBUKY
      JYKUKZUKUUAYBBYJYKWIYBBUUCUUABUUCUUAWCYBYJYAXSULZUKZYAYCUOZYTUNZWCZBUUHNB
      UUHNWJBGHKLMNOTWKWLWOYBUUCUUEUUAUUGYBYKUUDYJXMYAXSWMWNYBYHUUFYTXMYAYCWPWQ
      WRWSWTXAYNYSIUPZGYDXBZUUBYEYMUUJYMUUIGIXBYEUUJGHIKXFUUIGYDIXCXDXGGYDYSIXE
      XHUUAYIUUBYHYTIXIXJXKVNXL $.
  $}

  ${
    bnj1121.1 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1121.2 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1121.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1121.4 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1121.5 $e |- ( et <-> ( ( f e. K /\ i e. dom f ) -> ( f ` i ) C_ B ) )
        $.
    bnj1121.6 $e |- ( ( th /\ ta /\ ch /\ ze ) -> A. i e. n et ) $.
    bnj1121.7 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1121 $p |- ( ( th /\ ta /\ ch /\ ze ) -> z e. B ) $=
      ( w-bnj17 cfv wcel cdm wss wex 19.8a bnj707 bnj1083 sylibr simplbi bnj708
      cv wfn wceq bnj1235 fndm syl eleqtrrd wa wi bnj1294 mp2and simprbi sseldd
      sylib ) DECGUEZNUQZMUQZUFZJHUQZVKVMPUGZVLVMUHZUGZVNJUIZVKCOUJZVPDECGVTCOU
      KULABCKMOPTUDUMUNVKVLOUQZVQDECGVLWAUGZGWBVOVNUGZUAUOUPZVKVMWAURZVQWAUSDEC
      GWECWAKUGWEABTUTULWAVMVAVBVCVKFVPVRVDVSVEVKFNWAUCWDVFUBVJVGDECGWCGWBWCUAV
      HUPVI $.
  $}

  ${
    $d B i $.  $d D i $.  $d f i $.  $d i j $.  $d i n $.  $d i ph $.
    bnj1123.4 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1123.3 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1123.1 $e |- ( et <-> ( ( f e. K /\ i e. dom f ) -> ( f ` i ) C_ B ) )
        $.
    bnj1123.2 $e |- ( et' <-> [. j / i ]. et ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1123 $p |- ( et'
        <-> ( ( f e. K /\ j e. dom f ) -> ( f ` j ) C_ B ) ) $=
      ( cv wcel wsbc cdm wa cfv wss wi sbcbii cvv vex wfn w3a wrex cab nfcv nfv
      csuc c-bnj14 ciun wceq com bnj1095 nfi nf3an nfrex nfab nfcxfr nfcri nfan
      wb nfim weq eleq1 anbi2d fveq2 sseq1d imbi12d sbciegf ax-mp 3bitri ) NCJK
      SZUAISZMTZJSZWAUBZTZUCZWCWAUDZFUEZUFZJVTUAZWBVTWDTZUCZVTWAUDZFUEZUFZRCWIJ
      VTQUGVTUHTWJWOVIKUIWIWOJVTUHWLWNJWBWKJJIMJMWALSZUJZABUKZLGULZIUMPWSJIWRJL
      GJGUNWQABJWQJUOAJUOBJBWCUPZWPTWTWAUDDWGEHDSUQURUSUFJUTOVAVBVCVDVEVFVGWKJU
      OVHWNJUOVJJKVKZWFWLWHWNXAWEWKWBWCVTWDVLVMXAWGWMFWCVTWAVNVOVPVQVRVS $.
  $}

  ${
    $d A f i j n y $.  $d A f i n z $.  $d B f i n y $.  $d B f i n z $.
    $d D i j $.  $d R f i j n y $.  $d R f i n z $.  $d X f i n y $.
    $d X f i n z $.  $d ch j $.  $d et j $.  $d f i j n ta $.  $d f i j n th $.
    $d i ph $.  $d ta z $.  $d th z $.
    bnj1030.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1030.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1030.3 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1030.4 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1030.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    bnj1030.6 $e |- ( ze <-> ( i e. n /\ z e. ( f ` i ) ) ) $.
    bnj1030.7 $e |- D = ( om \ { (/) } ) $.
    bnj1030.8 $e |- K = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1030.9 $e |- ( et <-> ( ( f e. K /\ i e. dom f ) -> ( f ` i ) C_ B ) )
        $.
    bnj1030.10 $e |- ( rh <-> A. j e. n ( j _E i -> [. j / i ]. et ) ) $.
    bnj1030.11 $e |- ( ph' <-> [. j / i ]. ph ) $.
    bnj1030.12 $e |- ( ps' <-> [. j / i ]. ps ) $.
    bnj1030.13 $e |- ( ch' <-> [. j / i ]. ch ) $.
    bnj1030.14 $e |- ( th' <-> [. j / i ]. th ) $.
    bnj1030.15 $e |- ( ta' <-> [. j / i ]. ta ) $.
    bnj1030.16 $e |- ( ze' <-> [. j / i ]. ze ) $.
    bnj1030.17 $e |- ( et' <-> [. j / i ]. et ) $.
    bnj1030.18 $e |- ( si <-> ( ( j e. n /\ j _E i ) -> et' ) ) $.
    bnj1030.19 $e |- ( ph0 <-> ( i e. n /\ si /\ f e. K /\ i e. dom f ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1030 $p |- ( ( th /\ ta ) -> _trCl ( X , A , R ) C_ B ) $=
      ( w-bnj17 cv wcel wal wex 19.23vv albii 19.23v bitri cep wfr wral bnj1071
      wfn bnj769 bnj707 w3a cfv bnj1123 bnj1118 bnj1097 bnj1109 bnj1093 bnj1090
      wi wa wss c0 vex bnj110 syl2anc bnj1121 gen2 mpgbi bnj1034 ) ABCDEGJKLMNO
      PQSTUAUJUKULUMUNUOUPUQDECGVIZKVJMVKZWMZQVLSVLZXDQVMSVMZPVMXEWMZPXGPVLXHXE
      WMZPVLXIXGXJPXDXESQVNVOXHXEPVPVQXFSQABCDEFGKLMNOPQSTUAUMUNULUOURXDSVJZVRV
      SZIFWMQXKVTFQXKVTDECGXLXKNVKPVJZXKWBABXLCULNSUPWAWCWDCDEFGHIMPQRSTUGUIURU
      SVFVGVHABCDEGJLMNOPQRSUIDECWEUIWNQVJZXMWFMWORXNWPABCDEHJLMNOPQRSTUAUGUIUK
      ULUNUPVGVHABFJLMNOPQRSTUGUKUQURVFWGWHABCDELMNOPQSUAUIUJULUNWIWJUKULWKWLFI
      QRXKVRSWQUSWRWSUQWTXAXBXC $.
  $}

  ${
    $d A f i j n y $.  $d A f i n z $.  $d B f i j n y $.  $d B f i n z $.
    $d R f i j n y $.  $d R f i n z $.  $d X f i j n y $.  $d X f i n z $.
    $d f i j n ta $.  $d f i j n th $.  $d ta z $.  $d th z $.
    bnj1124.4 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1124.5 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1124 $p |- ( ( th /\ ta ) -> _trCl ( X , A , R ) C_ B ) $=
      ( vf vi vn vy vj cv cfv wcel wi wa wsbc biid vz c0 c-bnj14 wceq csuc ciun
      com wral csn cdif wfn w-bnj17 w3a wrex cab cdm wss wel cep eqid bnj1030
      wbr ) UBINZOCEFUCUDZJNZUEZKNZPVFVCOLVEVCOZCELNUCUFUDQJUGUHZVGUGUBUIUJZPVC
      VGUKZVDVIULZABVCVKVDVIUMKVJUNIUOZPZVEVCUPPZRVHDUQQZJKURZUANVHPRZMKURMNZVE
      USVBZRVPJVSSZQZVTWAQMVGUHZLUACDVJEIJMKVMFVDJVSSZVIJVSSZVLJVSSZAJVSSZBJVSS
      ZWAVRJVSSZVQWBVNVOULZVDTVITVLTGHVRTVJUTVMUTVPTWCTWDTWETWFTWGTWHTWITWATWBT
      WJTVA $.
  $}

  ${
    $d i j n $.  $d j th $.
    bnj1133.3 $e |- D = ( om \ { (/) } ) $.
    bnj1133.5 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1133.7 $e |- ( ta <-> A. j e. n ( j _E i -> [. j / i ]. th ) ) $.
    bnj1133.8 $e |- ( ( i e. n /\ ta ) -> th ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1133 $p |- ( ch -> A. i e. n th ) $=
      ( cv cep wfr wi wral wcel wfn bnj769 wa impexp bicomi albii mpgbir df-ral
      bnj1071 wal mpbir vex bnj110 sylancl ) CJOZPQZEDRZHUOSZDHUOSUOFTGOUOUAABU
      PCLFJKUIUBURHOUOTZUQRZHUJZVAUSEUCDRZHUTVBHVBUTUSEDUDUEUFNUGUQHUOUHUKDEHIU
      OPJULMUMUN $.
  $}

  ${
    $d A f i j n y $.  $d D i j y $.  $d R f i j n y $.  $d X f i n y $.
    $d Y f i n y $.  $d ch j $.  $d i ph y $.  $d j th $.
    bnj1128.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1128.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1128.3 $e |- D = ( om \ { (/) } ) $.
    bnj1128.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1128.5 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1128.6 $e |- ( th <-> ( ch -> ( f ` i ) C_ A ) ) $.
    bnj1128.7 $e |- ( ta <-> A. j e. n ( j _E i -> [. j / i ]. th ) ) $.
    bnj1128.8 $e |- ( ph' <-> [. j / i ]. ph ) $.
    bnj1128.9 $e |- ( ps' <-> [. j / i ]. ps ) $.
    bnj1128.10 $e |- ( ch' <-> [. j / i ]. ch ) $.
    bnj1128.11 $e |- ( th' <-> [. j / i ]. th ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1128 $p |- ( Y e. _trCl ( X , A , R ) -> Y e. A ) $=
      ( c-bnj18 wcel wex wel cv cfv w3a bnj981 wss simp1 simp2 wral nfv cep wbr
      wi wa wsbc nfra1 nfxfr nf3an nfim nfri wne csuc wceq bnj1098 simpl simpr1
      wfn bnj1232 3ad2ant3 adantl 3jca bnj1101 bnj101 df-3an imbi2i exbii mpbir
      c0 ancl c-bnj14 ciun bnj213 bnj226 simp21 com simp3r w-bnj17 biid cvv vex
      wb sbcg ax-mp bitr2i bnj1039 bitr4i bnj887 bnj1040 3bitr4i sylbi 3ad2ant2
      bnj1254 simp3l bnj923 elnn sylan2 syl2anc bnj589 rsp eleq1 eqeq1d imbi12d
      fveq2 imbi2d syl5ibr syl3c bnj1262 bnj1023 bnj1247 biimpi bnj1109 bnj1131
      mpd sylan9eq sylib 19.9v 3expia sylibr bnj1133 ralbii simp3 sseldd 2eximi
      syl bnj593 3bitri ) PGJOULUMZPGUMZLUNZNUNZKUNZUULUUKCLNUOZPLUPZKUPZUQZUMZ
      URZLUNNUNUUNKABCFGHIJKLNOPUAUBUCUDUEUSUVAUULNLUVAUUSGPUVACUUPCUUSGUTZCUUP
      UUTVAZCUUPUUTVBUVCCCUVBVGZLNUPZVCZUUPUVDVGCDLUVEVCUVFABCDEIKLMNUCUEUGUUPE
      VHUVDDUUPECUVBUUPECURZUVBVGZMUVHMUVGUVBMUUPECMUUPMVDEMUPZUUQVEVFDLUVIVIVG
      ZMUVEVCMUGUVJMUVEVJVKCMVDVLUVBMVDVMVNUVGUVBMUUQWLUUQWLVOZUVGVHZUVKUVGMNUO
      ZUUQUVIVPZVQZVHZURZUVBMUVLUVQVGZMUNUVLUVLUVPVHZVGZMUNUVLUVPVGUVTMUVKUUPUV
      EIUMZURUVPUVLMILMNUCVRUVLUVKUUPUWAUVKUVGVSUVKUUPECVTUVGUWAUVKCUUPUWAECUWA
      UURUVEWAZABUEWBWCZWDWEWFUVLUVPWMWGUVRUVTMUVQUVSUVLUVKUVGUVPWHWIWJWKUVQFUV
      IUURUQZGJFUPZWNZWOZGUUSFUWDUWFGGJUWEWPWQUVQUUPUUSUWGVQZUVKUUPECUVPWRUVQUV
      ORUVIWSUMZUUPUWHVGZUVKUVGUVMUVOWTUVGUVKRUVPCUUPRECSRUWAUWBABXAUWAUWBQRXAC
      SUWAUWBABUWAUWBQRUWAXBUWBXBQALUVIVIZAUHUVIXCUMUWKAXEMXDALUVIXCXFXGXHBUUQV
      PZUVEUMUWLUURUQFUUSUWFWOVQVGLWSVCRUBBFGJKLMNRUBUIXIZXJXKUEABCIKLMNQRSUHUI
      UEUJXLZXMSUWAUWBQRUWNXPXNWCXOUVQUVMUWAUWIUVKUVGUVMUVOXQUVGUVKUWAUVPUWCXOU
      WAUVMUVEWSUMUWIINUCXRUVIUVEXSXTYARUWIUWJVGUVOUWIUVNUVEUMZUVNUURUQZUWGVQZV
      GZVGZRUWRMWSVCUWSRFGJKLMNUWMYBUWRMWSYCXNUVOUWJUWRUWIUVOUUPUWOUWHUWQUUQUVN
      UVEYDUVOUUSUWPUWGUUQUVNUURYGYEYFYHYIYJYQYKYLUVGUUQWLVQZAUVBCUUPAECUWAUWBA
      BUEYMWCUWTAVHGJOWNZGUUSGJOWPUWTAUUSWLUURUQZUXAUUQWLUURYGAUXBUXAVQUAYNYRYK
      XTYOYPUUAUFUUBUUCDUVDLUVEUFUUDYSUVDLUVEYCUUHYJCUUPUUTUUEUUFUUGUUIUUOUUNUU
      MUULUUNKYTUUMNYTUULLYTUUJYS $.
  $}

  ${
    $d A f i j n y $.  $d R f i j n y $.  $d X f i j n y $.  $d Y f i n y $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1127 $p |- ( Y e. _trCl ( X , A , R ) -> Y e. A ) $=
      ( vf vi vn vy vj c0 cv cfv c-bnj14 wceq wcel wi com wral wsbc biid csuc
      ciun csn cdif wfn w-bnj17 wss cep wbr w3a wrex cab eqid bnj1128 ) JEKZLAB
      CMNZFKZUAZGKZOURUOLHUQUOLZABHKMUBNPFQRZUSQJUCUDZOUOUSUEZUPVAUFZVDUTAUGPZI
      KZUQUHUIVEFVFSZPIUSRZHAVCUPVAUJGVBUKEULZVBBEFIGCDUPFVFSZVAFVFSZVDFVFSZVGU
      PTVATVBUMVIUMVDTVETVHTVJTVKTVLTVGTUN $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.  $d Y y $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1125 $p |- ( ( R _FrSe A /\ X e. A /\ Y e. _trCl ( X , A , R ) ) ->
        _trCl ( Y , A , R ) C_ _trCl ( X , A , R ) ) $=
      ( w-bnj15 wcel c-bnj18 w3a cvv w-bnj19 c-bnj14 wss simp1 bnj1127 3ad2ant3
      vy bnj893 3adant3 wi biid bnj1029 simp3 cv wceq wex elisset wral df-bnj19
      rsp sylbi syl eleq1 bnj602 sseq1d imbi12d syl5ib exlimiv mpcom wa bnj1124
      mpd syl23anc ) ABEZCAFZDABCGZFZHZVCDAFZVEIFZAVEBJZABDKZVELZABDGVELVCVDVFM
      VFVCVHVDABCDNOVCVDVIVFABCQRVCVDVJVFABCUARZVGVFVLVCVDVFUBPUCZDUDZPUEZVGVFV
      LSZVFVCVPVDPDVEUFOVOVGVQSPVGVNVEFZABVNKZVELZSZVOVQVGVJWAVMVJVTPVEUGWAPAVE
      BUHVTPVEUIUJUKVOVRVFVTVLVNDVEULVOVSVKVEABVNDUMUNUOUPUQURVAVCVHUSZVIVJVLHZ
      AVEBDWBTWCTUTVB $.
  $}

  ${
    $d A f i j n y $.  $d A f w $.  $d B w $.  $d D i j $.  $d R f i j n y $.
    $d X f i n y $.  $d ch j $.  $d i ph $.
    bnj1145.1 $e |- ( ph <-> ( f ` (/) ) = _pred ( X , A , R ) ) $.
    bnj1145.2 $e |- ( ps <-> A. i e. om ( suc i e. n -> ( f ` suc i ) = U_ y e.
        ( f ` i ) _pred ( y , A , R ) ) ) $.
    bnj1145.3 $e |- D = ( om \ { (/) } ) $.
    bnj1145.4 $e |- B = { f | E. n e. D ( f Fn n /\ ph /\ ps ) } $.
    bnj1145.5 $e |- ( ch <-> ( n e. D /\ f Fn n /\ ph /\ ps ) ) $.
    bnj1145.6 $e |- ( th <-> ( ( i =/= (/) /\ i e. n /\ ch ) /\ ( j e. n /\ i =
        suc j ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1145 $p |- _trCl ( X , A , R ) C_ A $=
      ( vw c-bnj18 cv cdm cfv ciun bnj882 wss ss2iun wcel wral wex bnj1083 csuc
      wfn c-bnj14 wceq wi com bnj1095 bnj1096 nfi wa c0 wne w3a bnj1098 bnj1232
      3anim3i bnj1101 ancl bnj101 imbi2i exbii mpbir bnj213 bnj226 simpr bnj833
      simp2 3ad2ant3 bnj923 elnn sylan2 syl2anc bnj832 vex bnj216 sylan w-bnj17
      eqeltrrd bnj589 biimpi bnj708 rsp syl sylbi mp2d wb eqeq1d mpbird bnj1262
      fveq2 bnj1023 3anass imbi1i mpbi bnj771 sseq1 mpbiri biimpar syl2an 19.9v
      adantrl bnj1109 expcom bnj770 eleq2 imbi1d ralrimi exlimiv bnj1143 syl6ss
      fndm mprg wrex bnj1317 bnj1146 sstri eqsstri ) FINUBJGKJUCZUDZKUCZYKUEZUF
      ZUFZFABEFGHIJKMNOPQRUGYPJGFUFZFYOFUHZYPYQUHJGJGYOFUIYKGUJZYNFUHZKYLUKZYRY
      SCMULUUAABCHJMGSRUMCUUAMCYTKYLCKBCMUCZHUJZYKUUBUOZAKBYMUNZUUBUJUUEYKUEEYN
      FIEUCZUPZUFUQURKUSPUTSVAVBCYMYLUJZYTURZYMUUBUJZYTURZUUJCYTUUJCVCZYTURZLUL
      UUMUULYTLYMVDYMVDVEZUUJCVFZYTURZLULUUNUULVCZYTURZLULUUODYTLUUODURZLULUUOU
      UOLUCZUUBUJZYMUUTUNZUQZVCZVCZURZLULUUOUVDURUVFLUUNUUJUUCVFUVDUUOLHKLMQVGC
      UUCUUNUUJCUUCUUDABSVHZVIVJUUOUVDVKVLUUSUVFLDUVEUUOTVMVNVODEUUTYKUEZUUGUFZ
      FYNEUVHUUGFFIUUFVPVQDYNUVIUQZUVBYKUEZUVIUQZDUUTUSUJZUVBUUBUJZUVLDUVCYMUSU
      JZUVMUUOUVDUVCDTUVAUVCVRVSZUUOUVDUVODTUUOUUJUUCUVOUUNUUJCVTZCUUNUUCUUJUVG
      WAUUCUUJUUBUSUJUVOHMQWBYMUUBWCWDWEWFUVCUUTYMUJUVOUVMYMUUTLWGWHUUTYMWCWIWE
      DYMUVBUUBUVPUUOUVDUUJDTUVQWFWKUUOUVDUVMUVNUVLURZURZDTCUUNUVSUUJCUUCUUDABW
      JZUVSSUVTUVRLUSUKZUVSUUCUUDABUWABUWABEFIJKLMPWLWMWNUVRLUSWOWPWQWAWFWRDUVC
      UVJUVLWSUVPUVCYNUVKUVIYMUVBYKXCWTWPXAXBXDUUPUURLUUOUUQYTUUNUUJCXEXFVNXGYM
      VDUQZCYTUUJCUWBVDYKUEZFINUPZUQZYTUUCUUDABUWECSAUWEOWMXHUWBYNUWCUQZUWCFUHZ
      YTUWEYMVDYKXCUWEUWGUWDFUHFINVPUWCUWDFXIXJUWFYTUWGYNUWCFXIXKXLWDXNXOUUMLXM
      XGXPCYLUUBUQZUUIUUKWSUUCUUDABUWHCSUUBYKYDXQUWHUUHUUJYTYLUUBYMXRXSWPXAXTYA
      WQUUAYOKYLFUFFKYLYNFUIKYLFYBYCWPYEJUAGFUUDABVFMHYFJUAGRYGYHYIYJ $.
  $}

  ${
    $d A f i j n y $.  $d R f i j n y $.  $d X f i j n y $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1147 $p |- _trCl ( X , A , R ) C_ A $=
      ( vf vi vn vy vj c0 cv cfv c-bnj14 wceq csuc wcel com w3a wa biid eqid wi
      ciun wral csn cdif wfn w-bnj17 wne wrex cab bnj1145 ) IDJZKABCLMZEJZNZFJZ
      OUOULKGUNULKABGJLUBMUAEPUCZUPPIUDUEZOULUPUFZUMUQUGZUNIUHUNUPOUTQHJZUPOUNV
      ANMRRZGAUSUMUQQFURUIDUJZURBDEHFCUMSUQSURTVCTUTSVBSUK $.
  $}

  ${
    $d v y A $.  $d v B $.  $d v y R $.  $d v y X $.
    bnj1137.1 $e |- B = ( _pred ( X , A , R ) u. U_ y e. _trCl ( X , A , R )
        _trCl ( y , A , R ) ) $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj1137 $p |- ( ( R _FrSe A /\ X e. A ) -> _TrFo ( B , A , R ) ) $=
      ( vv wcel wa cv c-bnj14 wss wral c-bnj18 sseli bnj906 sylan2 sselda sstrd
      syl w-bnj15 w-bnj19 ciun wo cun eleq2i elun bitri bnj213 adantlr bnj18eq1
      ssiun2s bnj1147 rgenw iunss mpbir bnj1125 3expia ralrimiv sylibr sseqtr4i
      jaodan ssun2 syl6ss sylan2b ralrimiva df-bnj19 ) BDUAZEBHZIZBDGJZKZCLZGCM
      BCDUBVJVMGCVKCHZVJVKBDEKZHZVKABDENZBDAJZNZUCZHZUDZVMVNVKVOVTUEZHWBCWCVKFU
      FVKVOVTUGUHVJWBIVLVTCVJVPVLVTLWAVJVPIZVLBDVKNZVTVPVJVKBHZVLWELZVOBVKBDEUI
      OVHWFWGVIBDVKPUJZQWDVKVQHZWEVTLZVJVOVQVKBDEPRAVQVSVKWEBDVRVKUKULZTSVJWAIZ
      VLWEVTWAVJWFWGVTBVKVTBLVSBLZAVQMWMAVQBDVRUMUNAVQVSBUOUPOWHQWLWIWJVJVTVQVK
      VJVSVQLZAVQMVTVQLVJWNAVQVHVIVRVQHWNBDEVRUQURUSAVQVSVQUOUTRWKTSVBVTWCCVTVO
      VCFVAVDVEVFGBCDVGUT $.
  $}

  ${
    $d A x $.  $d R x $.  $d X x $.
    $( Property of ` _pred ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1148 $p |- ( ( R _FrSe A /\ X e. A ) -> _pred ( X , A , R ) e. _V ) $=
      ( vx w-bnj15 wcel wa c-bnj14 cvv wi cv wceq wex adantl bnj93 eleq1 anbi2d
      elisset bnj602 eleq1d imbi12d mpbii bnj593 bnj937 pm2.43i ) ABEZCAFZGZABC
      HZIFZUHUHUJJZDUHDKZCLZUKDUGUMDMUFDCARNUMUFULAFZGZABULHZIFZJUKDABOUMUOUHUQ
      UJUMUNUGUFULCAPQUMUPUIIABULCSTUAUBUCUDUE $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.
    bnj1136.1 $e |- B = ( _pred ( X , A , R ) u. U_ y e. _trCl ( X , A , R )
        _trCl ( y , A , R ) ) $.
    bnj1136.2 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1136.3 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1136 $p |- ( ( R _FrSe A /\ X e. A ) -> _trCl ( X , A , R ) = B ) $=
      ( wcel c-bnj18 wss cvv ciun wral bnj893 syl2anc 3expia ralrimiv wa cv cun
      w-bnj15 biimpri w-bnj19 c-bnj14 bnj1148 w3a simp1 bnj1127 3ad2ant3 iunexg
      bnj1149 syl5eqel bnj1137 bnj931 a1i bnj1124 bnj906 bnj1125 ss2iun bnj1143
      syl3anbrc syl6ss syl unssd syl5eqss eqssd ) DFUDZGDKZUAZDFGLZEVLABVMEMAVL
      IUEVLENKDEFUFDFGUGZEMZBVLEVNCVMDFCUBZLZOZUCZNHVLVNVRDFGUHVLVMNKVQNKZCVMPV
      RNKDFGQVLVTCVMVJVKVPVMKZVTVJVKWAUIVJVPDKZVTVJVKWAUJWAVJWBVKDFGVPUKULDFVPQ
      RSTCVMVQNNUMRUNUOCDEFGHUPVOVLEVNVRHUQURJVDABDEFGIJUSRVLEVSVMHVLVNVRVMDFGU
      TVLVQVMMZCVMPZVRVMMVLWCCVMVJVKWAWCDFGVPVASTWDVRCVMVMOVMCVMVQVMVBCVMVMVCVE
      VFVGVHVI $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.  $d Y y $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1152 $p |- ( Y e. _pred ( X , A , R ) <-> ( Y e. A /\ Y R X ) ) $=
      ( vy cv wbr c-bnj14 breq1 df-bnj14 elrab2 ) EFZCBGDCBGEDAABCHLDCBIEABCJK
      $.
  $}

  ${
    $d A b x y $.  $d B b x y $.  $d R b x y $.
    $( Property of ` Fr ` .  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
       (New usage is discouraged.) $)
    bnj1154 $p |- ( ( R Fr A /\ B C_ A /\ B =/= (/) /\ B e. _V ) -> E. x e. B
        A. y e. B -. y R x ) $=
      ( vb wfr wss c0 wne cvv wcel w-bnj17 w3a cv wbr wn wral wrex wi bnj658 wa
      wceq wex elisset bnj708 wal df-fr biimpi 19.21bi 3impib sseq1 neeq1 raleq
      3anbi23d rexeqbi1dv imbi12d mpbii bnj593 bnj937 mpd ) CEGZDCHZDIJZDKLZMZV
      BVCVDNZBOAOEPQZBDRZADSZVBVCVDVEUAVFVGVJTZFVFFOZDUCZVKFVBVCVDVEVMFUDFDKUEU
      FVMVBVLCHZVLIJZNZVHBVLRZAVLSZTVKVBVNVOVRVBVNVOUBVRTZFVBVSFUGFABCEUHUIUJUK
      VMVPVGVRVJVMVNVCVOVDVBVLDCULVLDIUMUOVQVIAVLDVHBVLDUNUPUQURUSUTVA $.
  $}

  ${
    bnj1171.13 $e |- ( ( ph /\ ps ) -> B C_ A ) $.
    bnj1171.129 $e |- E. z A. w ( ( ph /\ ps ) -> ( z e. B /\ ( w e. A -> ( w R
        z -> -. w e. B ) ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1171 $p |- E. z A. w ( ( ph /\ ps ) -> ( z e. B /\ ( w e. B -> -. w R z
        ) ) ) $=
      ( wa cv wcel wbr wn wi wal wex sseld pm4.71rd imbi1d impexp syl6bb imbi2i
      con2b syl6bbr anbi2d pm5.74i albii exbii mpbir ) ABJZCKZFLZDKZFLZUNULGMZN
      ZOZJZOZDPZCQUKUMUNELZUPUONOZOZJZOZDPZCQIVAVGCUTVFDUKUSVEUKURVDUMUKURVBURO
      ZVDUKURVBUOJZUQOVHUKUOVIUQUKUOVBUKFEUNHRSTVBUOUQUAUBVCURVBUPUOUDUCUEUFUGU
      HUIUJ $.
  $}

  ${
    bnj1172.3 $e |- C = ( _trCl ( X , A , R ) i^i B ) $.
    bnj1172.96 $e |- E. z A. w ( ( ph /\ ps ) -> ( ( ph /\ ps /\ z e. C ) /\ (
        th -> ( w R z -> -. w e. B ) ) ) ) $.
    bnj1172.113 $e |- ( ( ph /\ ps /\ z e. C ) -> ( th <-> w e. A ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1172 $p |- E. z A. w ( ( ph /\ ps ) -> ( z e. B /\ ( w e. A -> ( w R z
        -> -. w e. B ) ) ) ) $=
      ( wa cv wcel w3a wi wal wex wbr wn imbi1d pm5.32i imbi2i albii exbii mpbi
      c-bnj18 cin simp3 syl6eleq elin simprbi syl anim1i imim2i alimi bnj101 )
      ABNZABDOZHPZQZEOZFPZVDVAIUAVDGPUBRZRZNZRZESZUTVAGPZVGNZRZESDUTVCCVFRZNZRZ
      ESZDTVJDTLVQVJDVPVIEVOVHUTVCVNVGVCCVEVFMUCUDUEUFUGUHVIVMEVHVLUTVCVKVGVCVA
      FIJUIZGUJZPZVKVCVAHVSABVBUKKULVTVAVRPVKVAVRGUMUNUOUPUQURUS $.
  $}

  ${
    bnj1173.3 $e |- C = ( _trCl ( X , A , R ) i^i B ) $.
    bnj1173.5 $e |- ( th <-> ( ( R _FrSe A /\ X e. A /\ z e. _trCl ( X , A , R
        ) ) /\ ( R _FrSe A /\ z e. A ) /\ w e. A ) ) $.
    bnj1173.9 $e |- ( ( ph /\ ps ) -> R _FrSe A ) $.
    bnj1173.17 $e |- ( ( ph /\ ps ) -> X e. A ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1173 $p |- ( ( ph /\ ps /\ z e. C ) -> ( th <-> w e. A ) ) $=
      ( cv wcel w3a w-bnj15 wa 3adant3 c-bnj18 3simpc cin elin simplbi 3ad2ant3
      wi eleq2s pm3.21 syl3anc bnj170 syl6ibr impbid2 bnj1147 bnj1213 biantrurd
      syl5bb jca bitr4d ) ABDOZHPZQZCFIRZUTFPZSZEOFPZSZVFCVCJFPZUTFIJUAZPZQZVEV
      FQZVBVGLVBVLVGVKVEVFUBVBVGVGVKSZVLVBVCVHVJVGVMUGABVCVAMTZABVHVANTVAAVJBVJ
      UTVIGUCZHUTVOPVJUTGPUTVIGUDUEKUHUFZVKVGUIUJVKVEVFUKULUMUQVBVEVFVBVCVDVNVB
      DVIFFIJUNVPUOURUPUS $.
  $}

  ${
    bnj1174.3 $e |- C = ( _trCl ( X , A , R ) i^i B ) $.
    bnj1174.59 $e |- E. z A. w ( ( ph /\ ps ) -> ( z e. C /\ ( th -> ( w R z ->
        -. w e. C ) ) ) ) $.
    bnj1174.74 $e |- ( th -> ( w R z -> w e. _trCl ( X , A , R ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1174 $p |- E. z A. w ( ( ph /\ ps ) -> ( ( ph /\ ps /\ z e. C ) /\ ( th
        -> ( w R z -> -. w e. B ) ) ) ) $=
      ( wa cv wcel wn wi wal wex wbr w-bnj17 w3a c-bnj18 eleq2i notbii wo ianor
      cin elin pm4.62 3bitr4i biimpi impcom sylan2b ex syl6 a2d biantru 3bitr2i
      df-3an 3anass imbi2i albii exbii pm3.35 anim2i imim2i alimi bnj101 bnj256
      mpbi imdi ancl syl6ibr df-bnj17 ) ABNZABDOZHPZCEOZVRIUAZVTGPZQZRZRZUBZRZE
      SZDTVQABVSUCWENZRZESZDTVQVSWENZRZESZWHDVQVSCWAVTHPZQZRZRZCWQWDRRZNZNZRZES
      ZWNDVQVSWRNZRZESZDTXCDTLXFXCDXEXBEXDXAVQXDXDWSNVSWRWSUCXAWSXDCWAWPWCCWAVT
      FIJUDZPZWPWCRMXHWPWCWPXHVTXGGUIZPZQZWCWOXJHXIVTKUEUFXKXHWCXKXHWCRZXHWBNZQ
      XHQWCUGXKXLXHWBUHXJXMVTXGGUJUFXHWBUKULUMUNUOUPUQURUSVSWRWSVAVSWRWSVBUTVCV
      DVEVLXBWMEXAWLVQWTWEVSWSWRWRWERWECWQWDVMWRWEVFUOVGVHVIVJWMWGEWMVQVQWLNWFV
      QWLVNABVSWEVKVOVIVJWHWKDWGWJEWFWIVQABVSWEVPVCVDVEVL $.
  $}

  ${
    bnj1175.3 $e |- C = ( _trCl ( X , A , R ) i^i B ) $.
    bnj1175.4 $e |- ( ch <-> ( ( R _FrSe A /\ X e. A /\ z e. _trCl ( X , A , R
        ) ) /\ ( R _FrSe A /\ z e. A ) /\ ( w e. A /\ w R z ) ) ) $.
    bnj1175.5 $e |- ( th <-> ( ( R _FrSe A /\ X e. A /\ z e. _trCl ( X , A , R
        ) ) /\ ( R _FrSe A /\ z e. A ) /\ w e. A ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1175 $p |- ( th -> ( w R z -> w e. _trCl ( X , A , R ) ) ) $=
      ( cv wbr c-bnj18 wcel wa w3a wss sseldd w-bnj15 w-bnj17 bnj255 3bitr2i ex
      anbi1i bitr4i bnj1125 bnj835 c-bnj14 bnj906 bnj836 bnj1152 biimpri bnj837
      df-bnj17 sylbir ) BDMZCMZHNZUREHIOZPZBUTQZAVBAEHUAZIEPUSVAPRZVDUSEPQZUREP
      ZRZUTQZVCAVEVFVGUTQZRVEVFVGUTUBVIKVEVFVGUTUCVEVFVGUTUPUDBVHUTLUFUGAEHUSOZ
      VAURVEVFVJVKVASAKEHIUSUHUIAEHUSUJZVKURVEVFVJVLVKSAKEHUSUKULVEVFVJURVLPZAK
      VMVJEHUSURUMUNUOTTUQUE $.
  $}

  ${
    $d C w $.  $d ph w z $.  $d ps w z $.
    bnj1176.51 $e |- ( ( ph /\ ps ) -> ( R Fr A /\ C C_ A /\ C =/= (/) /\ C e.
        _V ) ) $.
    bnj1176.52 $e |- ( ( R Fr A /\ C C_ A /\ C =/= (/) /\ C e. _V ) -> E. z e.
        C A. w e. C -. w R z ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1176 $p |- E. z A. w ( ( ph /\ ps ) -> ( z e. C /\ ( th -> ( w R z -> -.
        w e. C ) ) ) ) $=
      ( wa cv wcel wn wi wal wex wrex sylib exbii wbr wfr wss c0 wne cvv df-ral
      wral w-bnj17 rexbii df-rex 19.28v sylibr 19.37v mpbir 19.21v con2b anbi2i
      syl imbi2i albii mpbi ax-1 anim2i imim2i alimi bnj101 ) ABKZDLZGMZELZVIHU
      AZVKGMZNOZKZOZEPZVHVJCVNOZKZOZEPDVHVJVMVLNZOZKZOZEPZDQZVQDQWFVHWCEPZOZDQZ
      WIVHWGDQZOVHVJWBEPZKZDQZWJVHWKDGRZWMVHWAEGUHZDGRZWNVHFHUBGFUCGUDUEGUFMUIW
      PIJUSWOWKDGWAEGUGUJSWKDGUKSWGWLDVJWBEULTUMVHWGDUNUOWEWHDVHWCEUPTUOWEVQDWD
      VPEWCVOVHWBVNVJVMVLUQURUTVATVBVPVTEVOVSVHVNVRVJVNCVCVDVEVFVG $.
  $}

  ${
    bnj1177.2 $e |- ( ps <-> ( X e. B /\ y e. B /\ y R X ) ) $.
    bnj1177.3 $e |- C = ( _trCl ( X , A , R ) i^i B ) $.
    bnj1177.9 $e |- ( ( ph /\ ps ) -> R _FrSe A ) $.
    bnj1177.13 $e |- ( ( ph /\ ps ) -> B C_ A ) $.
    bnj1177.17 $e |- ( ( ph /\ ps ) -> X e. A ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1177 $p |- ( ( ph /\ ps ) -> ( R Fr A /\ C C_ A /\ C =/= (/) /\ C e. _V
        ) ) $=
      ( wss c0 wne cvv wcel syl cin wa w-bnj15 w-bnj13 df-bnj15 simplbi c-bnj18
      wfr bnj1147 ssinss1 ax-mp eqsstri a1i cv c-bnj14 bnj906 syl2anc ssrin wbr
      simp2bi adantl sseldd simp3bi bnj1152 sylanbrc bnj1153 ne0i neeq1i sylibr
      bnj893 inex1g syl5eqel bnj951 ) DGUGZFDNZFOPZFQRZABUAZVQDGUBZVMKVRVMDGUCD
      GUDUESVNVQFDGHUFZETZDJVSDNVTDNDGHUHVSEDUIUJUKULVQVTOPZVOVQCUMZVTRWAVQDGHU
      NZETZVTWBVQWCVSNZWDVTNVQVRHDRZWEKMDGHUOUPWCVSEUQSVQWCEWBVQWBDRWBHGURZWBWC
      RVQEDWBLBWBERZABHERZWHWGIUSUTZVABWGABWIWHWGIVBUTDGHWBVCVDWJVEVAVTWBVFSFVT
      OJVGVHVQVSQRZVPVQVRWFWKKMDGHVIUPWKFVTQJVSEQVJVKSVL $.
  $}

  ${
    $d B w $.  $d ph w z $.  $d ps w z $.
    bnj1186.1 $e |- E. z A. w ( ( ph /\ ps ) -> ( z e. B /\ ( w e. B -> -. w R
        z ) ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1186 $p |- ( ( ph /\ ps ) -> E. z e. B A. w e. B -. w R z ) $=
      ( wa cv wcel wbr wn wral wex wrex wi wal 19.21v exbii sylibr 19.28v sylib
      mpbi 19.37aiv df-ral anbi2i df-rex ) ABHZCIZEJZDIZUIFKLZDEMZHZCNZUMCEOUHU
      JUKEJULPZDQZHZCNZUOUHUJUPHZDQZCNUSUHVACUHUTPDQZCNUHVAPZCNGVBVCCUHUTDRSUCU
      DVAURCUJUPDUASUBUNURCUMUQUJULDEUEUFSTUMCEUGT $.
  $}

  ${
    $d B w x z v u $.  $d B x y z v u $.  $d R w x z v u $.  $d R x y z v u $.
    $d u v A $.  $d u v ph $.  $d u v ps $.
    bnj1190.1 $e |- ( ph <-> ( R _FrSe A /\ B C_ A /\ B =/= (/) ) ) $.
    bnj1190.2 $e |- ( ps <-> ( x e. B /\ y e. B /\ y R x ) ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1190 $p |- ( ( ph /\ ps ) -> E. w e. B A. z e. B -. z R w ) $=
      ( vu vv wa adantr cv wcel w3a simp1bi wbr wss w-bnj15 wne simp2bi c-bnj18
      c0 eqid ssel2 syl2an bnj1177 bnj1154 bnj1176 biid bnj1175 bnj1174 bnj1173
      cin bnj1172 bnj1171 bnj1186 bnj1185 ) ABNZFECDHIVBCDLMHIABLMHIABLMGHIAHGU
      AZBAGIUBZVCHUFUCZJUDZOZABVDCPZGQZLPZGIVHUEZQRZVDVJGQNZMPZGQZRZLMGHVKHUQZI
      VHVQUGZABVPLMGHVQIVHVRABVPLMGVQIABDGHVQIVHKVRAVDBAVDVCVEJSOZVGAVCVHHQZVIB
      VFBVTDPZHQWAVHITKSHGVHUHUIZUJLMGVQIUKULVLVMVOVNVJITNRZVPLMGHVQIVHVRWCUMVP
      UMZUNUOABVPLMGHVQIVHVRWDVSWBUPURUSUTVAVA $.
  $}

  ${
    $d B w x y z $.  $d R w x y z $.  $d ph x y $.
    bnj1189.1 $e |- ( ph <-> ( R _FrSe A /\ B C_ A /\ B =/= (/) ) ) $.
    bnj1189.2 $e |- ( ps <-> ( x e. B /\ y e. B /\ y R x ) ) $.
    bnj1189.3 $e |- ( ch <-> A. y e. B -. y R x ) $.
    $( Technical lemma for ~ bnj69 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1189 $p |- ( ph -> E. x e. B A. y e. B -. y R x ) $=
      ( vw vz cv wn wrex wex wa 19.42v w3a wbr wral wcel w-bnj15 wss wne biimpi
      c0 n0 bnj837 ancli sylibr wi 3simpc anbi2i sylib 19.8a df-rex 3comr simp1
      3expib simp2 rexnal bicomi xchnxbir notnot rexbii bitr4i bnj1196 3ad2ant3
      3anass exbii bitri sylanbrc bnj1198 bnj1190 bnj593 bnj937 bnj1185 pm2.61i
      syl nfre1 19.9 ) AENZDNZHUAZOZEGUBZDGPZDQWIAAWEGUCZRZWIDAAWJDQZRWKDQAWLFH
      UDGFUEGUHUFZWLAIWMWLDGUIUGUJUKAWJDSULCWKWIUMCAWJWIAWJCWIAWJCTZWJWHRZDQZWI
      WNWOWPWNWJCRWOAWJCUNCWHWJKUOUPWODUQWAWHDGURULUSVACOZAWJWIAWJWQWIAWJWQTZDE
      LMGHWRMNLNHUAOMGUBLGPZEWRABRZWSEWRABEQWTEQAWJWQUTWRWJWDGUCZWFTZEBWRWJXAWF
      RZEQZXBEQZAWJWQVBWQAXDWJWQWFEGWQWFEGPZWQWGOZEGPZXFWHXHCXHWHOWGEGVCVDKVEWF
      XGEGWFVFVGVHUGVIVJXEWJXCRZEQWJXDRXBXIEWJXAWFVKVLWJXCESVMVNJVOABESVNABDEML
      FGHIJVPVQVRVSUSVAVTVQWIDWHDGWBWCUP $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              The existence of a minimal element in certain classes
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y $.  $d B x y $.  $d R x y $.
    $( Existence of a minimal element in certain classes: if ` R ` is
       well-founded and set-like on ` A ` , then every non-empty subclass of
       ` A ` has a minimal element.  The proof has been taken from Chapter 4 of
       Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj69 $p |- ( ( R _FrSe A /\ B C_ A /\ B =/= (/) ) -> E. x e. B A. y e. B
        -. y R x ) $=
      ( w-bnj15 wss c0 wne w3a cv wcel wbr wn wral biid bnj1189 ) CEFDCGDHIJZAK
      ZDLBKZDLTSEMZJZUANBDOZABCDERPUBPUCPQ $.
  $}

  ${
    $d A y z $.  $d B w y z $.  $d R x y z $.  $d w x y z $.
    bnj1228.1 $e |- ( w e. B -> A. x w e. B ) $.
    $( Existence of a minimal element in certain classes: if ` R ` is
       well-founded and set-like on ` A ` , then every non-empty subclass of
       ` A ` has a minimal element.  The proof has been taken from Chapter 4 of
       Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1228 $p |- ( ( R _FrSe A /\ B C_ A /\ B =/= (/) ) -> E. x e. B A. y e. B
        -. y R x ) $=
      ( vz w-bnj15 wss cv wbr wn wral wrex wcel wa wex nfv df-rex wne w3a bnj69
      c0 nfcii nfcri nfral weq eleq1 breq2 notbid ralbidv anbi12d cbvex 3bitr4i
      nfan sylibr ) DFIEDJEUDUAUBBKZHKZFLZMZBENZHEOZURAKZFLZMZBENZAEOZHBDEFUCVD
      EPZVGQZARUSEPZVBQZHRVHVCVJVLAHVJHSVKVBAAHEACEGUEZUFVAABEVMVAASUGUPAHUHZVI
      VKVGVBVDUSEUIVNVFVABEVNVEUTVDUSURFUJUKULUMUNVGAETVBHETUOUQ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded induction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A x y z w $.  $d R x y z w $.  $d ph y z w $.
    bnj1204.1 $e |- ( ps <-> A. y e. A ( y R x -> [. y / x ]. ph ) ) $.
    $( Well-founded induction.  The proof has been taken from Chapter 4 of Don
       Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1204 $p |- ( ( R _FrSe A /\ A. x e. A ( ps -> ph ) )
        -> A. x e. A ph ) $=
      ( vz wi wral wa wn wrex w3a cv wcel simp1 simp3 sylibr wal w-bnj15 wbr c0
      crab wss wne ssrab2 a1i rabn0 nfrab1 bnj1228 syl3anc biid nfv nfra1 nfre1
      nfcrii nf3an nfri bnj1521 eqid bnj1212 bnj1211 con2b albii sylib simp2 sp
      wsbc sylc elrabsf cvv wb vex sbcng ax-mp anbi2i bitri notbii imnan bitr4i
      nfcv biimpi imp notnotrd syl2anc 3expa expcom exp3a 3ad2ant3 simp12 syl3c
      ralrimi rabid simprbi 3ad2ant2 bnj1304 bnj1224 dfral2 ) EFUAZBAIZCEJZKALZ
      CEMZLACEJWTXBXDWTXBXDNZXECOZXCCEUDZPZDOZXFFUBZLZDXGJZNZACXLXEXMCXGXEWTXGE
      UEZXGUCUFZXLCXGMWTXBXDQXNXEXCCEUGUHXEXDXOWTXBXDRXCCEUISCDHEXGFCHXGXCCEUJU
      QUKULXMUMZXECWTXBXDCWTCUNXACEUOXCCEUPURUSUTXMXFEPZBXBAXCXEXMXLCEXGXGVAXPV
      BXLXEBXHXLXJACXIVIZIZDEJBXLXSDEXKDXGUOXLXIEPZXJXRXTXJKXLXRXTXJXLXRXTXJXLN
      ZXIXGPZLZXTXRYAXJYCIZDTZXJYCYAYBXKIZDTYEYAXKDXGXTXJXLRVCYFYDDYBXJVDVEVFXT
      XJXLVGYDDVHVJXTXJXLQYCXTKXRYCXTXRLZLZYCXTYHIZYCXTYGKZLYIYBYJYBXTXCCXIVIZK
      YJXCCXIECEWBVKYKYGXTXIVLPYKYGVMDVNACXIVLVOVPVQVRVSXTYGVTWAWCWDWEWFWGWHWIW
      MGSWJWTXBXDXHXLWKXQBXBNZXQXAIZCTXQBAYLXACEXQBXBRVCXQBXBQXQBXBVGYMCVHWLULX
      HXEXCXLXHXQXCXCCEWNWOWPWQWRACEWSS $.
  $}

  ${
    $d B f g $.  $d G f g $.  $d Y g $.  $d Z f $.  $d d f g $.  $d f g x $.
    bnj1234.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1234.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1234.4 $e |- Z = <. x , ( g |` _pred ( x , A , R ) ) >. $.
    bnj1234.5 $e |- D = { g | E. d e. B ( g Fn d /\ A. x e. d ( g ` x ) = ( G `
        Z ) ) } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1234 $p |- C = D $=
      ( cv wfn cfv wceq wral wa wrex cab fneq1 fveq1 c-bnj14 cres reseq1 opeq2d
      cop 3eqtr4g fveq2d eqeq12d ralbidv anbi12d rexbidv cbvabv 3eqtr4i ) GQZLQ
      ZRZAQZUTSZJISZTZAVAUAZUBZLCUCZGUDHQZVARZVCVJSZKISZTZAVAUAZUBZLCUCZHUDDEVI
      VQGHUTVJTZVHVPLCVRVBVKVGVOVAUTVJUEVRVFVNAVAVRVDVLVEVMVCUTVJUFVRJKIVRVCUTB
      FVCUGZUHZUKVCVJVSUHZUKJKVRVTWAVCUTVJVSUIUJMOULUMUNUOUPUQURNPUS $.
  $}

  ${
    $d A d $.  $d B f h $.  $d G f h $.  $d Y h $.  $d Z f $.  $d d f h $.
    $d f h x $.
    bnj1245.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1245.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1245.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1245.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1245.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1245.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1245.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    bnj1245.8 $e |- Z = <. x , ( h |` _pred ( x , A , R ) ) >. $.
    bnj1245.9 $e |- K = { h | E. d e. B ( h Fn d /\ A. x e. d ( h ` x ) = ( G `
        Z ) ) } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1245 $p |- ( ph -> dom h C_ A ) $=
      ( cv wcel cdm wss w-bnj15 cres wne bnj1247 bnj1234 syl6eleq wfn wceq wral
      wa wrex abeq2i bnj1238 bnj1196 c-bnj14 simplbi fndm bnj1241 bnj593 bnj937
      cfv syl ) ALUHZOUIZVNUJZEUKZAVNGOAEIULKUHZGUIVNGUIVRHUMVNHUMUNUDUOCEFGOIJ
      LNPQRTUAUFUGUPUQVOVQRVORUHZFUIZVNVSURZVAVQRVOWARFVOWACUHZVNVLQNVLUSCVSUTZ
      RFWAWCVARFVBLOUGVCVDVEVTWAVSEVPVTVSEUKZEIWBVFVSUKCVSUTZWDWEVARFSVCVGVSVNV
      HVIVJVKVM $.
  $}

  ${
    $d A f $.  $d B f g $.  $d G f g $.  $d R f $.  $d Y g $.  $d d f g $.
    $d f g x $.
    bnj1256.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1256.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1256.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1256.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1256.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1256.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1256.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1256 $p |- ( ph -> E. d e. B g Fn d ) $=
      ( w-bnj15 cv wcel cres wne wfn wrex cfv c-bnj14 cop wceq wral wa cab abid
      bnj1238 eqid bnj1234 eleq2s bnj770 ) EIUDKUEZGUFLUEZGUFVDHUGVEHUGUHVDPUEZ
      UIZPFUJZAUBVHVDVGCUEZVDUKVIVDEIVIULUGUMZNUKUNCVFUOZUPPFUJZKUQZGVDVMUFVGVK
      PFVLKURUSCEFGVMIJKNOVJPRSVJUTVMUTVAVBVC $.
  $}

  ${
    $d A f $.  $d B f h $.  $d G f h $.  $d R f $.  $d Y h $.  $d d f h $.
    $d f h x $.
    bnj1259.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1259.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1259.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1259.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1259.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1259.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1259.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1259 $p |- ( ph -> E. d e. B h Fn d ) $=
      ( w-bnj15 cv wcel cres wne wfn wrex cfv c-bnj14 cop wceq wral wa cab abid
      bnj1238 eqid bnj1234 eleq2s bnj771 ) EIUDKUEZGUFLUEZGUFVDHUGVEHUGUHVEPUEZ
      UIZPFUJZAUBVHVEVGCUEZVEUKVIVEEIVIULUGUMZNUKUNCVFUOZUPPFUJZLUQZGVEVMUFVGVK
      PFVLLURUSCEFGVMIJLNOVJPRSVJUTVMUTVAVBVC $.
  $}

  ${
    $d A f $.  $d B f g $.  $d B f h $.  $d D d $.  $d D x $.  $d G f g $.
    $d G f h $.  $d R f $.  $d Y g $.  $d Y h $.  $d d f g $.  $d d f h $.
    $d f g x $.  $d h x $.
    bnj1253.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1253.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1253.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1253.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1253.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1253.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1253.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1253 $p |- ( ph -> E =/= (/) ) $=
      ( cv cfv wne wrex c0 cres w-bnj15 wcel bnj1254 wceq wi wal wn wral wfn wb
      bnj1256 wss cdm bnj1292 fndm syl5sseq fnssres mpdan bnj31 bnj1265 bnj1259
      bnj1293 wa ssid fvreseq mpan2 syl2anc residm eqeq12i df-ral 3bitr3g fvres
      eqeq12d pm5.74i albii syl6bb necon3abid df-rex pm4.61 df-ne anbi2i bitr4i
      wex exbii exnal 3bitr2ri mpbid crab neeq1i rabn0 bitri sylibr ) ACUDZKUDZ
      UEZXBLUDZUEZUFZCHUGZMUHUFZAXCHUIZXEHUIZUFZXHAEIUJXCGUKXEGUKXLUBULAXLXBHUK
      ZXDXFUMZUNZCUOZUPZXHAXPXJXKAXJXKUMZXMXBXJUEZXBXKUEZUMZUNZCUOZXPAXJHUIZXKH
      UIZUMZYACHUQZXRYCAXJHURZXKHURZYFYGUSZAYHPFAXCPUDZURZYHPFABCDEFGHIJKLMNOPQ
      RSTUAUBUCUTYLHYKVAZYHYLXCVBZHYKHYNXEVBZTVCYKXCVDVEYKHXCVFVGVHVIAYIPFAXEYK
      URZYIPFABCDEFGHIJKLMNOPQRSTUAUBUCVJYPYMYIYPYOHYKHYNYOTVKYKXEVDVEYKHXEVFVG
      VHVIYHYIVLHHVAYJHVMCHHXJXKVNVOVPYDXJYEXKXCHVQXEHVQVRYACHVSVTYBXOCXMYAXNXM
      XSXDXTXFXBHXCWAXBHXEWAWBWCWDWEWFXHXMXGVLZCWLXOUPZCWLXQXGCHWGYRYQCYRXMXNUP
      ZVLYQXMXNWHXGYSXMXDXFWIWJWKWMXOCWNWOWEWPXIXGCHWQZUHUFXHMYTUHUAWRXGCHWSWTX
      A $.
  $}

  ${
    $d A y $.  $d E y $.  $d R y $.  $d x y $.
    bnj1279.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1279.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1279.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1279.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1279.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1279.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1279.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1279 $p |- ( ( x e. E /\ A. y e. E -. y R x ) -> ( _pred ( x , A , R )
        i^i E ) = (/) ) $=
      ( cv wcel wbr wn wral wa c-bnj14 cin c0 wne wceq w3a wex elin exbii bitri
      n0 biimpi df-bnj14 bnj1538 anim1i bnj593 3ad2ant3 nfv nfra1 nf3an bnj1275
      nfri simp2 simp12 simp3 bnj1294 bnj1304 bnj1224 nne sylib ) CUDZMUEZDUDZV
      TIUFZUGZDMUHZUIEIVTUJZMUKZULUMZUGWGULUNWAWEWHWAWEWHUOZWIWCWBMUEZUOZWCDWIW
      CWJDWHWAWCWJUIZDUPWEWHWBWFUEZWJUIZWLDWHWNDUPZWHWBWGUEZDUPWODWGUTWPWNDWBWF
      MUQURUSVAWMWCWJWCDWFEDEIVTVBVCVDVEVFWIDWAWEWHDWADVGWDDMVHWHDVGVIVKVJWIWCW
      JVLWKWDDMWAWEWHWCWJVMWIWCWJVNVOVPVQWGULVRVS $.
  $}

  ${
    $d A d f $.  $d B f g $.  $d B f h $.  $d D x $.  $d G f g $.  $d G f h $.
    $d R d f $.  $d Y g $.  $d Y h $.  $d d f g x $.  $d d f h x $.
    bnj1286.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1286.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1286.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1286.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1286.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1286.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1286.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1286 $p |- ( ps -> _pred ( x , A , R ) C_ D ) $=
      ( cv c-bnj14 cdm cin wss wcel wbr wral wfn bnj1256 bnj1196 bnj1517 adantr
      wn wa wb wceq sseq2 raleqbi1dv syl adantl mpbird bnj593 bnj937 bnj835 cfv
      fndm wne bnj21 bnj1292 sstri sseli bnj836 bnj1294 bnj1259 ssind syl6sseqr
      bnj1293 ) BEICUDZUEZKUDZUFZLUDZUFZUGHBWCWEWGBWCWEUHZCWEAWBMUIZDUDWBIUJUQD
      MUKZWHCWEUKZBUCAWKPAPUDZFUIZWDWLULZURZWKPAWNPFABCDEFGHIJKLMNOPQRSTUAUBUCU
      MUNWOWKWCWLUHZCWLUKZWMWQWNWLEUHWQPFQUOZUPWNWKWQUSZWMWNWEWLUTWSWLWDVJWHWPC
      WEWLWEWLWCVAVBVCVDVEVFVGVHAWIWJWBWEUIBUCMWEWBMHWEWBWDVIWBWFVIVKCHMUAVLZHW
      EWGTVMVNVOVPVQBWCWGUHZCWGAWIWJXACWGUKZBUCAXBPAWMWFWLULZURZXBPAXCPFABCDEFG
      HIJKLMNOPQRSTUAUBUCVRUNXDXBWQWMWQXCWRUPXCXBWQUSZWMXCWGWLUTXEWLWFVJXAWPCWG
      WLWGWLWCVAVBVCVDVEVFVGVHAWIWJWBWGUIBUCMWGWBMHWGWTHWEWGTWAVNVOVPVQVSTVT $.
  $}

  ${
    $d A d f $.  $d A z $.  $d B f g $.  $d B f h $.  $d D d x $.  $d D x z $.
    $d E z $.  $d G f g $.  $d G f h $.  $d R d f $.  $d R z $.  $d Y g $.
    $d Y h $.  $d d f g x $.  $d d f h x $.  $d g x z $.  $d h x z $.
    $d ps z $.
    bnj1280.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1280.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1280.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1280.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1280.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1280.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1280.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    bnj1280.17 $e |- ( ps -> ( _pred ( x , A , R ) i^i E ) = (/) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1280 $p |- ( ps -> ( g |` _pred ( x , A , R ) ) = ( h |` _pred ( x , A ,
        R ) ) ) $=
      ( vz cv c-bnj14 cres wceq cfv wral wcel wa bnj1286 sseld wn wi cin c0 wal
      disj1 sylib 19.21bi wne fveq2 neeq12d elrab2 notbii imbi2i 3bitr2i syl6ib
      imnan nne mpdd imp fvres 3eqtr4d ralrimiva wss resabs1 syl eqeq12d wfn wb
      syl6 wbr bnj1256 bnj1292 fndm syl5sseq fnssres mpdan bnj31 bnj1265 bnj835
      cdm bnj1259 bnj1293 fvreseq syl21anc bitr3d mpbird ) BKUFZEICUFZUGZUHZLUF
      ZXEUHZUIZUEUFZXCHUHZUJZXJXGHUHZUJZUIZUEXEUKZBXOUEXEBXJXEULZUMXJXCUJZXJXGU
      JZXLXNBXQXRXSUIZBXQXJHULZXTBXEHXJABCDEFGHIJKLMNOPQRSTUAUBUCUNZUOZBXQXJMUL
      ZUPZYAXTUQZBXQYEUQZUEBXEMURUSUIYGUEUTUDUEXEMVAVBVCYEYAXRXSVDZUMZUPYAYHUPZ
      UQYFYDYIXDXCUJZXDXGUJZVDYHCXJHMXDXJUIYKXRYLXSXDXJXCVEXDXJXGVEVFUAVGVHYAYH
      VLYJXTYAXRXSVMVIVJVKVNVOBXQXLXRUIZBXQYAYMYCXJHXCVPWEVOBXQXNXSUIZBXQYAYNYC
      XJHXGVPWEVOVQVRBXKXEUHZXMXEUHZUIZXIXPBYOXFYPXHBXEHVSZYOXFUIYBXCXEHVTWABYR
      YPXHUIYBXGXEHVTWAWBBXKHWCZXMHWCZYRYQXPWDAXDMULZDUFXDIWFUPDMUKZYSBUCAYSPFA
      XCPUFZWCZYSPFABCDEFGHIJKLMNOPQRSTUAUBUCWGUUDHUUCVSZYSUUDXCWPZHUUCHUUFXGWP
      ZTWHUUCXCWIWJUUCHXCWKWLWMWNWOAUUAUUBYTBUCAYTPFAXGUUCWCZYTPFABCDEFGHIJKLMN
      OPQRSTUAUBUCWQUUHUUEYTUUHUUGHUUCHUUFUUGTWRUUCXGWIWJUUCHXGWKWLWMWNWOYBUEHX
      EXKXMWSWTXAXB $.
  $}

  ${
    $d B f g $.  $d B f h $.  $d D x $.  $d G d f g $.  $d G d f h $.
    $d W d f $.  $d Y g $.  $d Y h $.  $d Z d f $.  $d d f g x $.  $d h x $.
    bnj1296.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1296.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1296.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1296.4 $e |- D = ( dom g i^i dom h ) $.
    bnj1296.5 $e |- E = { x e. D | ( g ` x ) =/= ( h ` x ) } $.
    bnj1296.6 $e |- ( ph <-> ( R _FrSe A /\ g e. C /\ h e. C /\ ( g |` D ) =/=
        ( h |` D ) ) ) $.
    bnj1296.7 $e |- ( ps <-> ( ph /\ x e. E /\ A. y e. E -. y R x ) ) $.
    bnj1296.18 $e |- ( ps -> ( g |` _pred ( x , A , R ) ) = ( h |` _pred ( x ,
        A , R ) ) ) $.
    bnj1296.9 $e |- Z = <. x , ( g |` _pred ( x , A , R ) ) >. $.
    bnj1296.10 $e |- K = { g | E. d e. B ( g Fn d /\ A. x e. d ( g ` x ) = ( G
        ` Z ) ) } $.
    bnj1296.11 $e |- W = <. x , ( h |` _pred ( x , A , R ) ) >. $.
    bnj1296.12 $e |- L = { h | E. d e. B ( h Fn d /\ A. x e. d ( h ` x ) = ( G
        ` W ) ) } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1296 $p |- ( ps -> ( g ` x ) = ( h ` x ) ) $=
      ( cfv cv c-bnj14 cres cop opeq2d 3eqtr4g fveq2d wceq cdm wcel wbr wn wral
      w-bnj15 wne wa wrex bnj1436 fndm anim1i bnj31 raleq pm5.32i rexbii sylibr
      simpr bnj1265 bnj1234 eleq2s bnj770 bnj835 bnj1292 bnj1212 bnj1213 bnj771
      wfn bnj1294 bnj1293 3eqtr4d ) BSNUMZQNUMZCUNZKUNZUMZWOLUNZUMZBSQNBWOWPEIW
      OUOZUPZUQWOWRWTUPZUQSQBXAXBWOUHURUIUKUSUTBWQWMVAZCWPVBZAWOMVCZDUNWOIVDVED
      MVFZXCCXDVFZBUGEIVGZWPGVCZWRGVCZWPHUPWRHUPVHZXGAUFXGWPOGWPOVCZXGTFXLXDTUN
      ZVAZXGVIZXGTFXLXNXCCXMVFZVIZTFVJXOTFVJXLWPXMWIZXPVIZXQTFXSTFVJKOUJVKXRXNX
      PXMWPVLVMVNXOXQTFXNXGXPXCCXDXMVOVPVQVRXNXGVSVNVTCEFGOIJKNRSTUBUCUIUJWAWBW
      CWDBCHXDHXDWRVBZUDWEWQWSVHABXFCHMUEUGWFZWGWJBWSWNVAZCXTAXEXFYBCXTVFZBUGXH
      XIXJXKYCAUFYCWRPGWRPVCZYCTFYDXTXMVAZYCVIZYCTFYDYEYBCXMVFZVIZTFVJYFTFVJYDW
      RXMWIZYGVIZYHTFYJTFVJLPULVKYIYEYGXMWRVLVMVNYFYHTFYEYCYGYBCXTXMVOVPVQVRYEY
      CVSVNVTCEFGPIJLNRQTUBUCUKULWAWBWHWDBCHXTHXDXTUDWKYAWGWJWL $.
  $}

  ${
    $d A x $.  $d d x $.  $d w x $.
    bnj1309.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1309 $p |- ( w e. B -> A. x w e. B ) $=
      ( cv wss c-bnj14 wral wa cab hbra1 bnj1352 hbab hbxfreq ) ABDFHZCIZCEAHJR
      IZARKZLZFMGUBAFBSUAATARNOPQ $.
  $}

  ${
    $d B w $.  $d d w x $.  $d f x $.
    bnj1307.1 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1307.2 $e |- ( w e. B -> A. x w e. B ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1307 $p |- ( w e. C -> A. x w e. C ) $=
      ( cv wfn cfv wceq wral wa wrex cab nfcii nfv nfra1 nfan nfrex nfab nfcxfr
      nfcrii ) ABDADEKZHKZLZAKUGMGFMNZAUHOZPZHCQZERIUMAEULAHCABCJSUIUKAUIATUJAU
      HUAUBUCUDUEUF $.
  $}

  ${
    $d A d f x v w z $.  $d A x y $.  $d B f g v w z $.  $d B f h z $.
    $d D d x $.  $d D x y v w z $.  $d G d f g $.  $d G d f h $.  $d R d f x $.
    $d R x y $.  $d Y g $.  $d Y h $.  $d g x y $.  $d h x y $.  $d w v C $.
    bnj1311.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1311.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1311.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1311.4 $e |- D = ( dom g i^i dom h ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1311 $p |- ( ( R _FrSe A /\ g e. C /\ h e. C ) -> ( g |` D ) = ( h |` D
        ) ) $=
      ( vy cv wcel wceq vz vw w-bnj15 w3a cres wne wn w-bnj17 cfv crab wbr wral
      wa wss c0 wrex bnj1232 ssrab2 cdm cin wfn c-bnj14 cop cab bnj1235 bnj1234
      biid eqid syl6eleq abid bnj1238 bnj1196 abeq2i simplbi fndm bnj593 bnj937
      bnj1241 ssinss1 3syl syl5eqss syl5ss bnj1253 nfrab1 bnj1228 syl3anc ax-17
      nfcrii bnj1309 bnj1307 hblem bnj982 bnj1521 simp2 bnj1279 3adant1 bnj1280
      bnj1296 bnj1538 necon2bi syl bnj1304 df-bnj17 mtbi imnani nne sylib ) BFU
      CZHRZDSZIRZDSZUDZXIEUEZXKEUEZUFZUGXNXOTXMXPXHXJXLXPUHZXMXPUMXQXQARZXRXIUI
      ZXRXKUIZUFZAEUJZSZQRXRFUKUGQYBULZUDZYCAYDXQYEAYBXQXHYBBUNYBUOUFYDAYBUPXQX
      HXJXLXPXQVGZUQXQYBEBYAAEURXQEXIUSZXKUSZUTZBPXQXIXILRZVAZXSXRXIBFXRVBZUEVC
      ZJUITAYJULZUMLCUPZHVDZSZYGBUNZYIBUNXQXIDYPXQXHXJXLXPYFVEABCDYPFGHJKYMLNOY
      MVHZYPVHZVFVIYQYRLYQYJCSZYKUMYRLYQYKLCYQYKYNLCYOHVJVKVLUUAYKYJBYGUUAYJBUN
      ZYLYJUNAYJULZUUBUUCUMLCMVMVNYJXIVOVRVPVQYGYHBVSVTWAWBXQYEAQBCDEFGHIYBJKLM
      NOPYBVHZYFYEVGZWCAQUABYBFAUAYBYAAEWDWHWEWFUUEXHXJXLXPAXHAWGAUBHDAUBCDGJKL
      OAUBBCFLMWIWJZWKAUBIDUUFWKXPAWGWLWMXQYCYDWNYEXSXTTYCUGXQYEAQBCDEFGHIYBJYP
      XKYJVAXTXRXKYLUEVCZJUITAYJULUMLCUPIVDZUUGKYMLMNOPUUDYFUUEXQYEAQBCDEFGHIYB
      JKLMNOPUUDYFUUEYCYDYLYBUTUOTXQXQYEAQBCDEFGHIYBJKLMNOPUUDYFUUEWOWPWQYSYTUU
      GVHUUHVHWRYCXSXTYAAYBEUUDWSWTXAXBXHXJXLXPXCXDXEXNXOXFXG $.
  $}

  ${
    $d A f i n y z $.  $d R f i n y z $.  $d X f i n y z $.  $d Y f i n y z $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1318 $p |- ( X = Y -> _trCl ( X , A , R ) = _trCl ( Y , A , R ) ) $=
      ( vf vn vi vy vz wceq cv c0 cfv c-bnj14 ciun com w3a wrex biid eqid hbab1
      wfn csuc wcel wral csn cdif cab cdm c-bnj18 bnj602 eqeq2d 3anbi2d rexbidv
      wi abbidv bnj1316 syl bnj882 3eqtr4g ) CDJZEEKZFKZUBZLVBMZABCNZJZGKZUCZVC
      UDVIVBMHVHVBMZABHKNOJUOGPUEZQZFPLUFUGZRZEUHZGVBUIVJOZOZEVDVEABDNZJZVKQZFV
      MRZEUHZVPOZABCUJABDUJVAVOWBJVQWCJVAVNWAEVAVLVTFVMVAVGVSVDVKVAVFVRVEABCDUK
      ULUMUNUPEIVOWBVPVNEIUAWAEIUAUQURVGVKHAVOVMBEGFCVGSVKSZVMTZVOTUSVSVKHAWBVM
      BEGFDVSSWDWEWBTUSUT $.
  $}

  ${
    $d A d f p q x $.  $d B f p q $.  $d C p q $.  $d D q $.  $d G d f p q $.
    $d R d f p q x $.  $d Y p q $.  $d g p q $.  $d h q $.
    bnj1326.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1326.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1326.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1326.4 $e |- D = ( dom g i^i dom h ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1326 $p |- ( ( R _FrSe A /\ g e. C /\ h e. C ) -> ( g |` D ) = ( h |` D
        ) ) $=
      ( cv wcel cres wceq vq vp w-bnj15 w3a cdm wi eleq1 3anbi3d ineq2d reseq2d
      cin dmeq reseq2i syl6eqr reseq1 eqtrd eqeq12d imbi12d 3anbi2d ineq1d eqid
      bnj1311 chvarv ) BFUCZHQZDRZUAQZDRZUDZVEVEUEZVGUEZUKZSZVGVLSZTZUFZVDVFIQZ
      DRZUDZVEESZVQESZTZUFUAIVGVQTZVIVSVOWBWCVHVRVDVFVGVQDUGUHWCVMVTVNWAWCVMVEV
      JVQUEZUKZSVTWCVLWEVEWCVKWDVJVGVQULUIZUJEWEVEPUMUNWCVNVQWESZWAWCVNVGWESWGW
      CVLWEVGWFUJVGVQWEUOUPEWEVQPUMUNUQURVDUBQZDRZVHUDZWHWHUEZVKUKZSZVGWLSZTZUF
      VPUBHWHVETZWJVIWOVOWPWIVFVDVHWHVEDUGUSWPWMVMWNVNWPWMWHVLSVMWPWLVLWHWPWKVJ
      VKWHVEULUTZUJWHVEVLUOUPWPWLVLVGWQUJUQURABCDWLFGUBUAJKLMNOWLVAVBVCVC $.
  $}

  ${
    $d A d f g x z $.  $d B f g z $.  $d z C $.  $d G d f g z $.
    $d R d f g x $.  $d Y g z $.  $d g ta $.
    bnj1321.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1321.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1321.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1321.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1321 $p |- ( ( R _FrSe A /\ E. f ta ) -> E! f ta ) $=
      ( vg vz wa cv wceq cres w-bnj15 wex wsb wi wal weu simpr w3a cdm cin wcel
      simp1 csn c-bnj18 cun simplbi 3ad2ant2 wfn cfv wral wrex cab nfab1 nfcxfr
      nfcri nfan eleq1 dmeq eqeq1d anbi12d syl5bb sbie 3ad2ant3 bnj1326 syl3anc
      nfv eqid simprbi eqtr4d bnj1322 reseq2d syl wrel releq bnj66 vtoclga 3syl
      resdm eqtrd eqeq2 mpbid 3eqtr3d 3expib alrimivv adantr eu2 sylanbrc ) CFU
      AZAGUBZQWSAAGOUCZQGRZORZSZUDZOUEGUEZAGUFWRWSUGWRXEWSWRXDGOWRAWTXCWRAWTUHZ
      XAXAUIZXBUIZUJZTZXBXITZXAXBXFWRXAEUKZXBEUKZXJXKSWRAWTULAWRXLWTAXLXGBRZUMC
      FXNUNUOZSZNUPUQZWTWRXMAWTXMXHXOSZAXMXRQZGOXMXRGGOEGEXAJRZURXNXAUSIHUSSBXT
      UTQJDVAZGVBMYAGVCVDVEXRGVPVFAXLXPQXCXSNXCXLXMXPXRXAXBEVGXCXGXHXOXAXBVHVIV
      JVKVLZUPVMZBCDEXIFGGOHIJKLMXIVQVNVOXFXJXAXGTZXAXFXGXHSZXJYDSXFXGXOXHAWRXP
      WTAXLXPNVRUQWTWRXRAWTXMXRYBVRVMVSZYEXIXGXAXGXHVTZWAWBXFXLXAWCZYDXASXQPRZW
      CYHPXAEYIXAWDBCDEFGPHIJKLMWEWFXAWHWGWIXFXKXBXHTZXBXFYEXKYJSYFYEXIXHXBYEXI
      XGSXIXHSYGXGXHXIWJWKWAWBXFXMXBWCYJXBSYCBCDEFGOHIJKLMWEXBWHWGWIWLWMWNWOAGO
      AOVPWPWQ $.
  $}

  $( Property of ` _FrSe ` .  (Contributed by Jonathan Ben-Naim, 3-Jun-2011.)
     (New usage is discouraged.) $)
  bnj1364 $p |- ( R _FrSe A -> R _Se A ) $=
    ( w-bnj15 wfr w-bnj13 df-bnj15 simprbi ) ABCABDABEABFG $.

  ${
    $d d f $.  $d f y $.
    bnj1371.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1371.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1371.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1371.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1371.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1371.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1371.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1371.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1371.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1371.10 $e |- P = U. H $.
    bnj1371.11 $e |- ( ta' <-> ( f e. C /\ dom f = ( { y } u. _trCl ( y , A , R
        ) ) ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1371 $p |- ( f e. H -> Fun f ) $=
      ( cv wcel wfun cdm csn c-bnj18 cun wceq wa wex c-bnj14 wrex bnj1436 rexex
      syl exbii sylib exsimpl wfn cfv abeq2i bnj1238 fnfun bnj31 bnj1265 bnj593
      wral bnj937 ) LUIZNUJZVQUKZEVRVQHUJZVSEVRVTVQULEUIZUMFKWAUNUOUPZUQZEURZVT
      EURVRQEURZWDVRQEFKDUIZUSZUTZWEWHLNUFVAQEWGVBVCQWCEUHVDVEVTWBEVFVCVTVSPGVT
      VQPUIZVGZVSPGVTWJWFVQVHOMVHUPDWIVOZPGWJWKUQPGUTLHTVIVJWIVQVKVLVMVNVP $.
  $}

  ${
    $d A x $.  $d B f $.  $d R x $.  $d d f x $.  $d x y $.
    bnj1373.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1373.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1373.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1373.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1373.5 $e |- ( ta' <-> [. y / x ]. ta ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1373 $p |- ( ta'
        <-> ( f e. C /\ dom f = ( { y } u. _trCl ( y , A , R ) ) ) ) $=
      ( cv wcel csn wsbc cdm c-bnj18 cun wceq wa cvv wb bnj1309 bnj1307 bnj1351
      vex nfi weq sneq bnj1318 uneq12d eqeq2d anbi2d syl5bb sbciegf ax-mp bitri
      ) LABCRZUAZHRZFSZVFUBZVDTZDGVDUCZUDZUEZUFZQVDUGSVEVMUHCULAVMBVDUGVMBVGVLB
      BHEFHIJKOBHDEGKMUIUJUKUMAVGVHBRZTZDGVNUCZUDZUEZUFBCUNZVMPVSVRVLVGVSVQVKVH
      VSVOVIVPVJVNVDUODGVNVDUPUQURUSUTVAVBVC $.
  $}

  ${
    $d A x $.  $d B f $.  $d C y $.  $d R x $.  $d d f x $.  $d f x y $.
    bnj1374.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1374.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1374.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1374.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1374.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1374.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1374.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1374.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1374.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1374 $p |- ( f e. H -> f e. C ) $=
      ( cv wcel cdm csn c-bnj18 cun wceq wex c-bnj14 wrex bnj1436 rexex bnj1373
      wa syl exbii sylib exsimpl bnj937 ) KUFZMUGZVEHUGZEVFVGVEUHEUFZUIFJVHUJUK
      ULZUSZEUMZVGEUMVFPEUMZVKVFPEFJDUFUNZUOZVLVNKMUEUPPEVMUQUTPVJECDEFGHJKLNOP
      QRSTUDURVAVBVGVIEVCUTVD $.
  $}

  ${
    $d A d f x z $.  $d A f g $.  $d B f $.  $d C g $.  $d C y $.  $d G d f $.
    $d H g z $.  $d R d f x $.  $d R f g $.  $d f x y $.
    bnj1384.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1384.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1384.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1384.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1384.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1384.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1384.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1384.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1384.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1384.10 $e |- P = U. H $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1384 $p |- ( R _FrSe A -> Fun P ) $=
      ( vg vz w-bnj15 cuni wfun cv wral cdm cres wceq bnj1373 bnj1371 rgen wcel
      cin id bnj1374 wi c-bnj14 wrex cab nfab1 nfcxfr nfcri wfn wa nfim imbi12d
      cfv eleq1 chvar eqid bnj1326 syl3an 3expib ralrimivv biid bnj1317 bnj1386
      sylancr funeqi sylibr ) FKUJZNUKZULZJULWJLUMZULZLNUNZWMWMUOUHUMZUOVBZUPWP
      WQUPUQZUHNUNLNUNZWLWNLNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGCDEFGHKLMOPQRSTU
      AUEURUSUTWJWRLUHNNWJWMNVAZWPNVAZWRWJWJWTWMHVAZXAWPHVAZWRWJVCABCDEFGHIKLMN
      OPQRSTUAUBUCUDUEUFVDZWTXBVEXAXCVELUHXAXCLLUHNLNQEFKDUMZVFVGZLVHUFXFLVIVJV
      KLUHHLHWMPUMZVLXEWMVPOMVPUQDXGUNVMPGVGZLVHTXHLVIVJVKVNWMWPUQWTXAXBXCWMWPN
      VQWMWPHVQVOXDVRDFGHWQKLLUHMOPRSTWQVSZVTWAWBWCWOWOWSVMZUINWQLUHWOWDXIXJWDX
      FLUINUFWEWFWGJWKUGWHWI $.
  $}

  ${
    $d A x y z $.  $d B f $.  $d D y $.  $d R x y $.  $d d f x $.  $d f x y $.
    $d ps y $.  $d ta y $.
    bnj1388.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1388.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1388.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1388.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1388.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1388.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1388.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1388.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1388 $p |- ( ch -> A. y e. _pred ( x , A , R ) E. f ta' ) $=
      ( wex cv c-bnj14 wcel wbr wn w3a nfv nfra1 nf3an nfxfr wa bnj1152 simplbi
      wral adantl wi biimpi simprd simp3bi adantr wal df-ral con2b albii impcom
      sp sylan2b syl2anc crab eleq2i nfcv wsbc nfsbc1v nfex nfn sbceq1a syl6bbr
      bitri weq exbidv notbid elrabf sylnib iman sylibr mpd ex ralrimi ) BOKUDZ
      EFJDUEZUFZBAWNIUGZEUEZWNJUHZUIZEIURZUJEUBAWPWTEAEUKWPEUKWSEIULUMUNBWQWOUG
      ZWMBXAUOZWQFUGZWMXAXCBXAXCWRFJWNWQUPZUQUSXBXCWMUIZUOZUIXCWMUTXBWQIUGZXFXB
      WRWTXGUIZXBXCWRXAXCWRUOZBXAXIXDVAUSVBBWTXABAWPWTUBVCVDWTWRWRXHUTZEVEZXHWT
      XGWSUTZEVEXKWSEIVFXLXJEXGWRVGVHWBXKWRXHXJEVJVIVKVLXGWQCKUDZUIZDFVMZUGXFIX
      OWQTVNXNXEDWQFDWQVODFVOWMDODKOCDWQVPZDUCCDWQVQUNVRVSDEWCZXMWMXQCOKXQCXPOC
      DWQVTUCWAWDWEWFWBWGXCWMWHWIWJWKWL $.
  $}

  ${
    $d A f x y z $.  $d B f $.  $d C y $.  $d D w y $.  $d H w z $.
    $d P w z $.  $d R f x y z $.  $d ch z $.  $d d f x $.  $d f w x y z $.
    $d ps y $.  $d ta y $.
    bnj1398.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1398.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1398.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1398.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1398.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1398.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1398.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1398.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1398.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1398.10 $e |- P = U. H $.
    bnj1398.11 $e |- ( th <-> ( ch /\ z e. U_ y e. _pred ( x , A , R ) ( { y }
        u. _trCl ( y , A , R ) ) ) ) $.
    bnj1398.12 $e |- ( et <-> ( th /\ y e. _pred ( x , A , R ) /\ z e. ( { y }
        u. _trCl ( y , A , R ) ) ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1398 $p |- ( ch -> U_ y e. _pred ( x , A , R )
        ( { y } u. _trCl ( y , A , R ) ) = dom P ) $=
      ( vw c-bnj14 csn c-bnj18 cun ciun cdm wcel wrex df-iun bnj1436 bnj833 wbr
      cv wa wn wral w3a nfv nfra1 nf3an nfxfr nfiu1 nfcri nfan nfri bnj1521 wex
      w-bnj15 c0 wne crab nfe1 nfn nfcv nfrab nfcxfr nfne nfral simplbi simp2bi
      bnj835 wi bnj1388 rsp sylc bnj596 wceq bnj1373 adantl simprbi rspe syl2an
      abeq2i rexbii r19.42v 3bitri sylanbrc simp3bi adantr bnj593 df-rex sylibr
      syl eleqtrrd jca dmeqi bnj1317 bnj1400 eqtri eleq2i eliun bitri cab nfre1
      cuni nfab nfuni nfdm nfcrii bnj1397 sylbir ssrdv wss simpr eleq2 biimpac
      ex reximi syl2anc rexlimiva 3imtr4i ssriv a1i eqssd ) BGINFVFZUNZGVFZUOIN
      UUJUPUQZURZMUSZBHUULUUMBHVFZUULUTZUUNUUMUTZBUUOVGZCUUPUKCUUPGCEUUPGUUNUUK
      UTZCEGUUIBUUOUURGUUIVAZCUKUUSHUULGHUUIUUKVBVCVDULCGCUUQGUKBUUOGBAUUHLUTZU
      UJUUHNVEVHZGLVIZVJZGUGAUUTUVBGAGVKUUTGVKUVAGLVLVMVNGHUULGUUIUUKVOVPVQVNVR
      VSEUUNOVFZUSZUTZOQVAZUUPEUVDQUTZUVFVGZOVTUVGEETVGZUVIOETOEOECUUJUUIUTZUUR
      VJOULCUVKUUROCUUQOUKBUUOOBUVCOUGAUUTUVBOAINWAZLWBWCZVGOUFUVLUVMOUVLOVKOLW
      BOLDOVTZVHZFIWDUEUVOOFIUVNODOWEWFOIWGWHWIZOWBWGWJVQVNOFLUVPVPUVAOGLUVPUVA
      OVKWKVMVNUUOOVKVQVNUVKOVKUUROVKVMVNVREBUVKTOVTZCUVKUURBEULCBUUOUKWLWNECUV
      KUURULWMZBUVQGUUIVIUVKUVQWOABDFGIJKLNOPRSTUAUBUCUDUEUFUGUHWPUVQGUUIWQXPWR
      WSUVJUVHUVFUVJUVDKUTZUVEUUKWTZGUUIVAZUVHTUVSETUVSUVTDFGIJKNOPRSTUAUBUCUDU
      HXAZWLXBEUVKUVTUWATUVRTUVSUVTUWBXCZUVTGUUIXDXEUVHTGUUIVAZUVSUVTVGZGUUIVAU
      VSUWAVGUWDOQUIXFTUWEGUUIUWBXGUVSUVTGUUIXHXIZXJUVJUUNUUKUVEEUURTECUVKUURUL
      XKXLTUVTEUWCXBXQXRXMUVFOQXNXOUUPUUNOQUVEURZUTUVGUUMUWGUUNUUMQYHZUSUWGMUWH
      UJXSOUMQUWDOUMQUIXTYAYBYCOUUNQUVEYDYEZXOXMGHUUMGMGMUWHUJGQGQUWDOYFUIUWDGO
      TGUUIYGYIWIYJWIYKYLYMYNYTYOUUMUULYPBHUUMUULUVGUUSUUPUUOUVFUUSOQUVIUVFUWAU
      USUVHUVFYQUVHUWAUVFUVHUVSUWAUWFXCXLUVFUWAVGUVFUVTVGZGUUIVAUUSUVFUVTGUUIXH
      UWJUURGUUIUVTUVFUURUVEUUKUUNYRYSUUAYNUUBUUCUWIGUUNUUIUUKYDUUDUUEUUFUUG $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.
    bnj1413.1 $e |- B = ( _pred ( X , A , R ) u. U_ y e. _pred ( X , A , R )
        _trCl ( y , A , R ) ) $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1413 $p |- ( ( R _FrSe A /\ X e. A ) -> B e. _V ) $=
      ( w-bnj15 wcel wa c-bnj14 c-bnj18 cv ciun cun bnj1148 wral bnj893 syl2anc
      cvv wss w3a bnj1127 3ad2ant3 3expia ralrimiv iunexg bnj1149 bnj906 iunss1
      simp1 unss2 3syl syl5eqss ssexd ) BDGZEBHZIZCBDEJZABDEKZBDALZKZMZNZSUQURV
      BBDEOUQUSSHVASHZAUSPVBSHBDEQUQVDAUSUOUPUTUSHZVDUOUPVEUAUOUTBHZVDUOUPVEUJV
      EUOVFUPBDEUTUBUCBDUTQRUDUEAUSVASSUFRUGUQCURAURVAMZNZVCFUQURUSTVGVBTVHVCTB
      DEUHAURUSVAUIVGVBURUKULUMUN $.
  $}

  ${
    $d A y v z w $.  $d v w z B $.  $d R w y z $.  $d X y z $.
    bnj1408.1 $e |- B = ( _pred ( X , A , R ) u. U_ y e. _pred ( X , A , R )
        _trCl ( y , A , R ) ) $.
    bnj1408.2 $e |- C = ( _pred ( X , A , R ) u. U_ y e. _trCl ( X , A , R )
        _trCl ( y , A , R ) ) $.
    bnj1408.3 $e |- ( th <-> ( R _FrSe A /\ X e. A ) ) $.
    bnj1408.4 $e |- ( ta <-> ( B e. _V /\ _TrFo ( B , A , R ) /\ _pred ( X , A
        , R ) C_ B ) ) $.
    $( Technical lemma for ~ bnj1414 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1408 $p |- ( ( R _FrSe A /\ X e. A ) -> _trCl ( X , A , R ) = B ) $=
      ( vz wcel wa c-bnj18 wss syl2anc sstrd biid w-bnj15 biimpri cvv wral ciun
      w-bnj19 c-bnj14 bnj1413 cv simplll bnj213 sseli adantl bnj906 bnj1318 cun
      ssiun2s ssun4 syl6sseqr syl w3a simpr bnj1405 nfv nfcv nfiu1 nfcxfr nfcri
      nfun nfan nfri bnj1521 bnj1147 simp3 bnj1213 simp2 bnj1125 syl3anc ssiun2
      3ad2ant1 3ad2ant2 bnj593 nfss bnj1397 wo bnj1138 sylib mpjaodan ralrimiva
      df-bnj19 sylibr bnj931 a1i syl3anbrc bnj1124 iunss1 unss2 3sstr4g bnj1136
      3syl sseqtr4d eqssd ) DGUAZHDNZOZDGHPZEXEABXFEQAXEKUBXEEUCNDEGUFZDGHUGZEQ
      ZBCDEGHIUHXEDGMUIZUGZEQZMEUDXGXEXLMEXEXJENZOZXJXHNZXLXJCXHDGCUIZPZUEZNZXN
      XOOZXKDGXJPZEXTXCXJDNZXKYAQZXCXDXMXOUJXOYBXNXHDXJDGHUKZULUMDGXJUNZRXOYAEQ
      ZXNXOYAXRQZYFCXHXQXJYADGXPXJUOUQYGYAXHXRUPZEYAXRXHURIUSUTUMSXNXSOZXLCYIYI
      XPXHNZXJXQNZVAZXLCYKYIYLCXHYICXHXQXJXNXSVBVCYLTYICXNXSCXEXMCXECVDCMECEYHI
      CXHXRCXHVECXHXQVFZVIVGZVHVJCMXRYMVHVJVKVLYLXKXQEYLXKYAXQYLXCYBYCYIYJXCYKX
      CXDXMXSUJVTZYLMXQDDGXPVMYIYJYKVNZVOYERYLXCXPDNYKYAXQQYOYLCXHDYDYIYJYKVPVO
      YPDGXPXJVQVRSYLXQXRQZXQEQYJYIYQYKCXHXQVSWAYQXQYHEXQXRXHURIUSUTSWBXLCCXKEC
      XKVEYNWCVKWDXNXMXOXSWEXEXMVBEXHXRXJIWFWGWHWIMDEGWJWKXIXEEXHXRIWLWMLWNABDE
      GHKLWORXEEFXFXEYHXHCXFXQUEZUPZEFXEXHXFQXRYRQYHYSQDGHUNCXHXFXQWPXRYRXHWQWT
      IJWRXEFUCNDFGUFXHFQVAZCDFGHJXETYTTWSXAXB $.
  $}

  ${
    $d A y $.  $d R y $.  $d X y $.
    bnj1414.1 $e |- B = ( _pred ( X , A , R ) u. U_ y e. _pred ( X , A , R )
        _trCl ( y , A , R ) ) $.
    $( Property of ` _trCl ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1414 $p |- ( ( R _FrSe A /\ X e. A ) -> _trCl ( X , A , R ) = B ) $=
      ( w-bnj15 wcel wa cvv w-bnj19 c-bnj14 wss w3a c-bnj18 ciun cun eqid biid
      cv bnj1408 ) BDGEBHIZCJHBCDKBDELZCMNZABCUCABDEOBDATOPQZDEFUERUBSUDSUA $.
  $}

  ${
    $d A f x y z $.  $d B f $.  $d C y $.  $d D y $.  $d z H $.  $d z P $.
    $d R f x y z $.  $d d f x $.  $d ps y $.  $d ta y $.  $d z ch $.
    bnj1415.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1415.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1415.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1415.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1415.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1415.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1415.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1415.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1415.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1415.10 $e |- P = U. H $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1415 $p |- ( ch -> dom P = _trCl ( x , A , R ) ) $=
      ( vz cv c-bnj18 c-bnj14 ciun cun cdm w-bnj15 wcel wceq wbr wn wral c0 wne
      simplbi bnj835 wex bnj1212 eqid bnj1414 syl2anc csn iunun iunid uneq1i wa
      eqtri w3a biid bnj1398 syl5eqr eqtr2d ) BFKDUIZUJZFKWAUKZEWCFKEUIZUJZULZU
      MZJUNZBFKUOZWAFUPWBWGUQAWAIUPWDWAKURUSEIUTZWIBUDAWIIVAVBUCVCVDCLVEUSABWJD
      FIUBUDVFEFWGKWAWGVGVHVIBWGEWCWDVJZWEUMZULZWHWMEWCWKULZWFUMWGEWCWKWEVKWNWC
      WFEWCVLVMVOABBUHUIZWMUPVNZCWPWDWCUPWOWLUPVPZDEUHFGHIJKLMNOPQRSTUAUBUCUDUE
      UFUGWPVQWQVQVRVSVT $.
  $}

  ${
    bnj1416.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1416.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1416.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1416.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1416.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1416.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1416.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1416.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1416.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1416.10 $e |- P = U. H $.
    bnj1416.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1416.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1416.28 $e |- ( ch -> dom P = _trCl ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1416 $p |- ( ch -> dom Q = ( { x } u. _trCl ( x , A , R ) ) ) $=
      ( cdm csn cun c-bnj18 cfv cop dmeqi dmun fvex dmsnop uneq2i 3eqtri uneq1d
      cv uncom syl6eq syl5eq ) BKUMZJUMZDVFZUNZUOZVMFLVLUPZUOZVJJVLQNUQZURUNZUO
      ZUMVKVRUMZUOVNKVSUKUSJVRUTVTVMVKVLVQQNVAVBVCVDBVNVOVMUOVPBVKVOVMULVEVOVMV
      GVHVI $.
  $}

  ${
    $d A z $.  $d R z $.  $d x z $.  $d y z $.
    $( Property of ` _pred ` .  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1418 $p |- ( y e. _pred ( x , A , R ) -> y R x ) $=
      ( vz cv wbr c-bnj14 breq1 df-bnj14 bnj1538 vtoclga ) EFZAFZDGZBFZNDGEPCDN
      HZMPNDIOEQCECDNJKL $.
  $}

  ${
    $d A x y $.  $d R x y $.  $d ph x y $.  $d ps y $.
    bnj1417.1 $e |- ( ph <-> R _FrSe A ) $.
    bnj1417.2 $e |- ( ps <-> -. x e. _trCl ( x , A , R ) ) $.
    bnj1417.3 $e |- ( ch <-> A. y e. A ( y R x -> [. y / x ]. ps ) ) $.
    bnj1417.4 $e |- ( th <-> ( ph /\ x e. A /\ ch ) ) $.
    bnj1417.5 $e |- B = ( _pred ( x , A , R ) u. U_ y e. _pred ( x , A , R )
        _trCl ( y , A , R ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (Proof shortened by Mario Carneiro, 22-Dec-2016.)
       (New usage is discouraged.) $)
    bnj1417 $p |- ( ph -> A. x e. A -. x e. _trCl ( x , A , R ) ) $=
      ( wral cv wcel wn syl2anc sylib c-bnj18 w-bnj15 wi biimpi c-bnj14 ciun wo
      w3a wbr bnj1418 adantl bnj835 w-bnj13 df-bnj15 simplbi bnj213 sseli frirr
      wfr syl syl2an pm2.65da wrex nfv wsbc bnj1095 nfi nf3an nfxfr wa ad2antrr
      simplr sseldi simpr bnj1125 syl3anc bnj1147 bnj906 sseldd bnj837 ad2antlr
      wss rsp syl3c vex weq eleq1 bnj1318 eleq2d bitrd notbid syl5bb ex ralrimi
      sbcie ralnex eliun sylnibr sylanbrc simp2bi bnj1414 bnj1138 syl6bb mtbird
      ioran wceq sylibr sylbir 3exp ralrimiv bnj1204 ralbii ) ABEGOZEPZGIXNUAZQ
      ZRZEGOAGIUBZCBUCZEGOXMAXRJUDZAXSEGAXNGQZCBAYACUHZDBMDXQBDXPXNGIXNUEZQZXNF
      YCGIFPZUAZUFZQZUGZDYDRYHRYIRDYDXNXNIUIZYDYJDEEGIUJUKDGIUSZYAYJRYDDXRYKAYA
      CXRDMXTULZXRYKGIUMGIUNUOUTYCGXNGIXNUPZUQGXNIURVAVBDXNYFQZFYCVCZYHDYNRZFYC
      OYORDYPFYCDYBFMAYACFAFVDYAFVDCFCYEXNIUIZBEYEVEZUCZFGLVFVGVHVIDYEYCQZYPDYT
      VJZYNYEYFQZUUAYNVJZXOYFYEUUCXRYEGQZYNXOYFWBDXRYTYNYLVKZUUCYCGYEYMDYTYNVLZ
      VMZUUAYNVNZGIYEXNVOVPUUCYCXOYEUUCXRYAYCXOWBUUEUUCYFGXNGIYEVQUUHVMGIXNVRSU
      UFVSVSUUCYRUUBRZUUCYSFGOZUUDYQYRDUUJYTYNAYACUUJDMCUUJLUDVTVKUUGYTYQDYNEFG
      IUJWAYSFGWCWDBUUIEYEFWEBXQEFWFZUUIKUUKXPUUBUUKXPYEXOQUUBXNYEXOWGUUKXOYFYE
      GIXNYEWHWIWJWKWLWOTVBWMWNYNFYCWPTFXNYCYFWQWRYDYHXEWSDXPXNHQYIDXOHXNDXRYAX
      OHXFYLDAYACMWTFGHIXNNXASWIHYCYGXNNXBXCXDKXGXHXIXJBCEFGILXKSBXQEGKXLT $.
  $}

  ${
    $d A x z $.  $d R x z $.
    bnj1421.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1421.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1421.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1421.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1421.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1421.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1421.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1421.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1421.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1421.10 $e |- P = U. H $.
    bnj1421.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1421.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1421.13 $e |- ( ch -> Fun P ) $.
    bnj1421.14 $e |- ( ch -> dom Q = ( { x } u. _trCl ( x , A , R ) ) ) $.
    bnj1421.15 $e |- ( ch -> dom P = _trCl ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1421 $p |- ( ch -> Fun Q ) $=
      ( vz cv cfv cop csn cun wfun wa cdm cin wceq vex fvex funsn jctir c-bnj18
      c0 dmsnop a1i ineq12d w-bnj15 wral wcel wbr wn wne simplbi bnj835 wsbc wi
      w3a c-bnj14 ciun biid eqid bnj1417 disjsn ralbii sylibr syl bnj1212 eqtrd
      wex bnj1294 funun syl2anc funeqi ) BJDUPZQNUQZURUSZUTZVAZKVABJVAZXDVAZVBJ
      VCZXDVCZVDZVKVEXFBXGXHULXBXCDVFQNVGZVHVIBXKFLXBVJZXBUSZVDZVKBXIXMXJXNUNXJ
      XNVEBXBXCXLVLVMVNBXOVKVEZDFBFLVOZXPDFVPZAXBIVQEUPXBLVRVSEIVPZXQBUFAXQIVKV
      TUEWAWBXQXBXMVQVSZDFVPXRXQXTUOUPZXBLVRXTDYAWCWDUOFVPZXQXBFVQYBWEZDUOFFLXB
      WFZUOYDFLYAVJWGUTZLXQWHXTWHYBWHYCWHYEWIWJXPXTDFXMXBWKWLWMWNCMWQVSABXSDFIU
      DUFWOWRWPJXDWSWTKXEUKXAWM $.
  $}

  ${
    $d A y $.  $d D y $.  $d E y $.  $d H w $.  $d R y $.  $d f w y $.
    $d ps y $.  $d x y $.  $d y z $.
    bnj1444.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1444.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1444.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1444.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1444.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1444.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1444.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1444.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1444.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1444.10 $e |- P = U. H $.
    bnj1444.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1444.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1444.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1444.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1444.15 $e |- ( ch -> P Fn _trCl ( x , A , R ) ) $.
    bnj1444.16 $e |- ( ch -> Q Fn ( { x } u. _trCl ( x , A , R ) ) ) $.
    bnj1444.17 $e |- ( th <-> ( ch /\ z e. E ) ) $.
    bnj1444.18 $e |- ( et <-> ( th /\ z e. { x } ) ) $.
    bnj1444.19 $e |- ( ze <-> ( th /\ z e. _trCl ( x , A , R ) ) ) $.
    bnj1444.20 $e |- ( rh <-> ( ze /\ f e. H /\ z e. dom f ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1444 $p |- ( rh -> A. y rh ) $=
      ( cv wcel cdm w3a c-bnj18 wa wbr wral nfra1 nf3an nfxfr nfan c-bnj14 wrex
      wn nfv cab nfre1 nfab nfcxfr nfcri nfri ) GIGFRVGZUAVHZJVGZWIVIVHZVJIVFFW
      JWLIFCWKKQHVGZVKVHZVLIVECWNICBWKSVHZVLIVCBWOIBAWMNVHZIVGWMQVMWAZINVNZVJIU
      MAWPWRIAIWBWPIWBWQINVOVPVQWOIWBVRVQWNIWBVRVQIRUAIUAUFIKQWMVSZVTZRWCUOWTIR
      UFIWSWDWEWFWGWLIWBVPVQWH $.
  $}

  ${
    $d A d x $.  $d B f $.  $d C w $.  $d D w $.  $d E d $.  $d H w $.
    $d R d x $.  $d d f w x $.  $d d w x y $.  $d d z $.
    bnj1445.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1445.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1445.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1445.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1445.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1445.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1445.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1445.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1445.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1445.10 $e |- P = U. H $.
    bnj1445.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1445.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1445.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1445.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1445.15 $e |- ( ch -> P Fn _trCl ( x , A , R ) ) $.
    bnj1445.16 $e |- ( ch -> Q Fn ( { x } u. _trCl ( x , A , R ) ) ) $.
    bnj1445.17 $e |- ( th <-> ( ch /\ z e. E ) ) $.
    bnj1445.18 $e |- ( et <-> ( th /\ z e. { x } ) ) $.
    bnj1445.19 $e |- ( ze <-> ( th /\ z e. _trCl ( x , A , R ) ) ) $.
    bnj1445.20 $e |- ( rh <-> ( ze /\ f e. H /\ z e. dom f ) ) $.
    bnj1445.21 $e |- ( si <-> ( rh /\ y e. _pred ( x , A , R ) /\ f e. C /\ dom
        f = ( { y } u. _trCl ( y , A , R ) ) ) ) $.
    bnj1445.22 $e |- ( ph <-> ( si /\ d e. B /\ f Fn d /\ A. x e. d ( f ` x ) =
        ( G ` Y ) ) ) $.
    bnj1445.23 $e |- X = <. z , ( f |` _pred ( z , A , R ) ) >. $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1445 $p |- ( si -> A. d si ) $=
      ( cv c-bnj14 wcel cdm csn c-bnj18 cun wceq w-bnj17 w3a wa wn wral w-bnj15
      wbr c0 wne nfv wex crab wfn cfv wrex cab nfre1 nfab nfcri nfan nfxfr nfex
      nfcxfr nfn nfcv nfrab nfne nfral nf3an nfri bnj1351 nfi nfsbc nfrex ax-17
      wsbc bnj982 hbxfrbi ) HIKVMZMSJVMZVNZVOZTVMZOVOZYCVPZXSVQMSXSVRVSVTZWAUHV
      JIYBYDYFUHIUHIGYCUCVOZLVMZYEVOZWBUHVIGYGYIUHGDYHMSXTVRZVOZWCUHVHDYKUHDCYH
      UAVOZWCZUHVFYMUHCYLUHCUHCBXTPVOZXSXTSWGWDZKPWEZWBUHUPBYNYPUHBMSWFZPWHWIZW
      CUHUOYQYRUHYQUHWJUHPWHUHPETWKZWDZJMWLUNYTUHJMYSUHEUHTEYDYEXTVQYJVSVTZWCUH
      UMYDUUAUHUHTOUHOYCUHVMZWMXTYCWNUFUBWNVTJUUBWEWCZUHNWOZTWPULUUDUHTUUCUHNWQ
      WRXCWSZUUAUHWJWTXAZXBXDUHMXEXFXCZUHWHXEXGWTXAUHJPUUGWSYOUHKPUUGYOUHWJXHXI
      XAXJXKXLXAYKUHWJWTXAUHTUCUHUCUIKYAWOZTWPURUUHUHTUIUHKYAUHYAXEUIEJXSXPUHUQ
      EUHJXSUHXSXEUUFXMXAXNWRXCWSYIUHWJXIXAXJYBUHXOYDUHUUEXJYFUHXOXQXR $.
  $}

  ${
    $d A d w x $.  $d B f $.  $d C w $.  $d G d w $.  $d H w $.  $d P w $.
    $d Q w $.  $d R d w x $.  $d W w $.  $d Z w $.  $d d f w x $.  $d d x y $.
    $d d w z $.
    bnj1446.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1446.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1446.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1446.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1446.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1446.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1446.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1446.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1446.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1446.10 $e |- P = U. H $.
    bnj1446.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1446.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1446.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1446 $p |- ( ( Q ` z ) = ( G ` W ) -> A. d ( Q ` z ) = ( G ` W ) ) $=
      ( cv cfv wceq cop csn cun cuni c-bnj14 wrex cab nfcv wsbc wcel c-bnj18 wa
      cdm wfn wral nfre1 nfab nfcri nfv nfan nfxfr nfsbc nfrex nfuni cres nfres
      nfcxfr nfop nffv nfsn nfun nfeq nfri ) FUOZLUPZQOUPZUQTTWLWMTWKLTLKDUOZSO
      UPZURZUSZUTUMTKWQTKPVAUKTPTPUAEGMWNVBZVCZNVDUJWSTNUATEWRTWRVEZUACDEUOZVFT
      UICTDXATXAVECNUOZIVGZXBVJWNUSGMWNVHUTUQZVITUEXCXDTTNITIXBTUOZVKWNXBUPROUP
      UQDXEVLVIZTHVCZNVDUDXGTNXFTHVMVNWDVOXDTVPVQVRVSVRVTVNWDWAWDZTWPTWNWOTWNVE
      ZTSOTOVEZTSWNKWRWBZURULTWNXKXITKWRXHWTWCWEWDWFWEWGWHWDZTWKVEZWFTQOXJTQWKL
      GMWKVBZWBZURUNTWKXOXMTLXNXLTXNVEWCWEWDWFWIWJ $.
  $}

  ${
    $d A w y $.  $d G w y $.  $d H w $.  $d P w $.  $d Q w $.  $d R w y $.
    $d W w $.  $d Z w $.  $d w x y $.  $d w y z $.
    bnj1447.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1447.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1447.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1447.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1447.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1447.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1447.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1447.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1447.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1447.10 $e |- P = U. H $.
    bnj1447.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1447.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1447.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1447 $p |- ( ( Q ` z ) = ( G ` W ) -> A. y ( Q ` z ) = ( G ` W ) ) $=
      ( cfv wceq cop csn cun cuni c-bnj14 wrex cab nfre1 nfab nfcxfr nfuni nfcv
      cv cres nfres nfop nffv nfsn nfun nfeq nfri ) FVIZLUOZQOUOZUPEEVSVTEVRLEL
      KDVIZSOUOZUQZURZUSUMEKWDEKPUTUKEPEPUAEGMWAVAZVBZNVCUJWFENUAEWEVDVEVFVGVFZ
      EWCEWAWBEWAVHZESOEOVHZESWAKWEVJZUQULEWAWJWHEKWEWGEWEVHVKVLVFVMVLVNVOVFZEV
      RVHZVMEQOWIEQVRLGMVRVAZVJZUQUNEVRWNWLELWMWKEWMVHVKVLVFVMVPVQ $.
  $}

  ${
    $d A f w $.  $d G f w $.  $d H w $.  $d P w $.  $d Q w $.  $d R f w $.
    $d W w $.  $d Z w $.  $d f w x $.  $d f w z $.
    bnj1448.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1448.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1448.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1448.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1448.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1448.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1448.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1448.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1448.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1448.10 $e |- P = U. H $.
    bnj1448.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1448.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1448.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1448 $p |- ( ( Q ` z ) = ( G ` W ) -> A. f ( Q ` z ) = ( G ` W ) ) $=
      ( vw cv cfv wceq cop csn cun cuni c-bnj14 wrex bnj1317 nfcii nfuni nfcxfr
      nfcv cres nfres nfop nffv nfsn nfun nfeq nfri ) FUPZLUQZQOUQZURNNVSVTNVRL
      NLKDUPZSOUQZUSZUTZVAUMNKWDNKPVBUKNPNUOPUAEGMWAVCZVDNUOPUJVEVFVGVHZNWCNWAW
      BNWAVIZNSONOVIZNSWAKWEVJZUSULNWAWIWGNKWEWFNWEVIVKVLVHVMVLVNVOVHZNVRVIZVMN
      QOWHNQVRLGMVRVCZVJZUSUNNVRWMWKNLWLWJNWLVIVKVLVHVMVPVQ $.
  $}

  ${
    $d A f $.  $d D w $.  $d E f $.  $d R f $.  $d f w x $.  $d f w y $.
    $d f z $.
    bnj1449.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1449.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1449.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1449.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1449.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1449.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1449.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1449.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1449.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1449.10 $e |- P = U. H $.
    bnj1449.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1449.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1449.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1449.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1449.15 $e |- ( ch -> P Fn _trCl ( x , A , R ) ) $.
    bnj1449.16 $e |- ( ch -> Q Fn ( { x } u. _trCl ( x , A , R ) ) ) $.
    bnj1449.17 $e |- ( th <-> ( ch /\ z e. E ) ) $.
    bnj1449.18 $e |- ( et <-> ( th /\ z e. { x } ) ) $.
    bnj1449.19 $e |- ( ze <-> ( th /\ z e. _trCl ( x , A , R ) ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1449 $p |- ( ze -> A. f ze ) $=
      ( cv c-bnj18 wcel wa wbr wn wral w3a w-bnj15 c0 wne nfv wex crab nfe1 nfn
      nfcv nfrab nfcxfr nfne nfan nfxfr nfcri nfral nf3an nfri ) FQFCIVEZJPGVEZ
      VFVGZVHQVDCWMQCBWKRVGZVHQVBBWNQBAWLMVGZHVEWLPVIVJZHMVKZVLQULAWOWQQAJPVMZM
      VNVOZVHQUKWRWSQWRQVPQMVNQMDQVQZVJZGJVRUJXAQGJWTQDQVSVTQJWAWBWCZQVNWAWDWEW
      FQGMXBWGWPQHMXBWPQVPWHWIWFWNQVPWEWFWMQVPWEWFWJ $.
  $}

  ${
    $d A x $.
    bnj1442.1 $e |- B = { d | ( d C_ A
        /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1442.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1442.3 $e |- C = { f | E. d e. B
        ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1442.4 $e |- ( ta <-> ( f e. C
        /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1442.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1442.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1442.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1442.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1442.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1442.10 $e |- P = U. H $.
    bnj1442.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1442.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1442.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1442.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1442.15 $e |- ( ch -> P Fn _trCl ( x , A , R ) ) $.
    bnj1442.16 $e |- ( ch -> Q Fn ( { x } u. _trCl ( x , A , R ) ) ) $.
    bnj1442.17 $e |- ( th <-> ( ch /\ z e. E ) ) $.
    bnj1442.18 $e |- ( et <-> ( th /\ z e. { x } ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1442 $p |- ( et -> ( Q ` z ) = ( G ` W ) ) $=
      ( cfv csn wcel wceq wfun cop c-bnj18 cun bnj930 opex elun2 ax-mp eleqtrri
      cv snid funopfv ee10 bnj832 bnj833 fveq2d c-bnj14 cres bnj602 reseq2d syl
      elsni wss bnj931 a1i cdm w-bnj15 wbr wn c0 wne simplbi bnj835 wex bnj1212
      wral bnj906 syl2anc fndm sseqtr4d bnj1503 eqtrd opeq12d 3eqtr4g 3eqtr4d
      wfn ) EFVPZNVCZUBRVCZHVPZNVCTRVCCXPXMVDZVEZXNXOVFZEVBBXPQVEZXSCVABNVGXMXO
      VHZNVEXSBXQIOXMVIZVJNUTVKZYAMYAVDZVJZNYAYDVEYAYEVEYAXMXOVLVQYAYDMVMVNUPVO
      XMXONVRVSVTVTEXPXMNCXRXPXMVFZEVBXPXMWHWAZWBETUBREXPNIOXPWCZWDZVHXMMIOXMWC
      ZWDZVHTUBEXPXMYIYKYGEYINYJWDZYKEYFYIYLVFYGYFYHYJNIOXPXMWEWFWGCXRYLYKVFZEV
      BBXTYMCVABYJNMYCMNWIBNMYDUPWJWKBYJYBMWLZBIOWMZXMIVEYJYBWIAXMLVEGVPXMOWNWO
      GLXBZYOBUKAYOLWPWQUJWRWSDPWTWOABYPFILUIUKXAIOXMXCXDBMYBXLYNYBVFUSYBMXEWGX
      FXGVTVTXHXIUQUOXJWBXK $.
  $}

  ${
    $d A d f x y z $.  $d B f $.  $d D y $.  $d E d f y $.  $d G d f x y z $.
    $d H w $.  $d R d f x y z $.  $d X x $.  $d Y z $.  $d f w $.  $d ps y $.
    bnj1450.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1450.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1450.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1450.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1450.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1450.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1450.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1450.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1450.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1450.10 $e |- P = U. H $.
    bnj1450.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1450.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1450.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1450.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1450.15 $e |- ( ch -> P Fn _trCl ( x , A , R ) ) $.
    bnj1450.16 $e |- ( ch -> Q Fn ( { x } u. _trCl ( x , A , R ) ) ) $.
    bnj1450.17 $e |- ( th <-> ( ch /\ z e. E ) ) $.
    bnj1450.18 $e |- ( et <-> ( th /\ z e. { x } ) ) $.
    bnj1450.19 $e |- ( ze <-> ( th /\ z e. _trCl ( x , A , R ) ) ) $.
    bnj1450.20 $e |- ( rh <-> ( ze /\ f e. H /\ z e. dom f ) ) $.
    bnj1450.21 $e |- ( si <-> ( rh /\ y e. _pred ( x , A , R ) /\ f e. C /\ dom
        f = ( { y } u. _trCl ( y , A , R ) ) ) ) $.
    bnj1450.22 $e |- ( ph <-> ( si /\ d e. B /\ f Fn d /\ A. x e. d ( f ` x ) =
        ( G ` Y ) ) ) $.
    bnj1450.23 $e |- X = <. z , ( f |` _pred ( z , A , R ) ) >. $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1450 $p |- ( ze -> ( Q ` z ) = ( G ` W ) ) $=
      ( vw cv cfv wceq cdm wcel cuni ciun c-bnj18 simprbi wfn fndm syl eleqtrrd
      bnj832 dmeqi syl6eleq c-bnj14 bnj1317 bnj1400 bnj1405 bnj1449 bnj1521 csn
      wrex cun w3a bnj1436 bnj836 bnj1373 rexbii bnj1196 3anass bnj1198 w-bnj17
      sylib bnj252 bitri bnj1444 bnj1340 wral bnj771 bnj1445 bnj1254 fveq2 cres
      cop bnj602 reseq2d opeq12d 3eqtr4g fveq2d eqeq12d cbvralv simp3bi eleqtrd
      wa bnj769 bnj1294 wfun bnj930 bnj835 wss simp2bi syl6sseqr bnj593 bnj1397
      id elssuni bnj1502 bnj1517 bnj770 sseq1d sseqtr4d bnj1503 3eqtr4d bnj1446
      ssun3 3syl opeq2d bnj1447 bnj1448 ) GLVNZRVOZUDUBVOZVPZTGIUURTUUOTVNZVQZV
      RZGITUCGTUCUUTUUOGUUOUCVSZVQZTUCUUTVTGUUOQVQZUVCGUUOMSJVNZWAZUVDGDUUOUVFV
      RZVHWBDUVGUVDUVFVPZGVHCUUOUAVRZUVHDVFCQUVFWCUVHVDUVFQWDWEWGWGWFQUVBUSWHWI
      TVMUCUIKMSUVEWJZWQZTVMUCURWKWLWIWMVIBCDEFGJKLMNOPQRSTUAUBUCUDUFUGUHUIUJUK
      ULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHWNWOIUURKIHUURKIHKVNZUVJVRZUUSOVRZUUTUV
      LWPMSUVLWAWRVPZWSZKIUVMUVNUVOYIZYIKUVPIUVQKUVJIUVKUVQKUVJWQGUUSUCVRZUVAUV
      KIVIUVKTUCURWTXAUIUVQKUVJEJKMNOSTUBUFUHUIUJUKULUMUQXBXCXHXDUVMUVNUVOXEXFH
      IUVMUVNUVOXGIUVPYIVJIUVMUVNUVOXIXJBCDEFGIJKLMNOPQRSTUAUBUCUDUFUGUHUIUJUKU
      LUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIXKXLHUURUHHAUURUHHAUHVNZNVRZUUSUVSWCZU
      VEUUSVOZUFUBVOZVPZJUVSXMZWSZUHHUVTUWAUWEYIZYIUHUWFHUWGUHNIUVMUVNUVOUWGUHN
      WQZHVJUWHTOULWTXNXDUVTUWAUWEXEXFAHUVTUWAUWEXGHUWFYIVKHUVTUWAUWEXIXJABCDEF
      GHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIV
      JVKVLXOXLAUUOUUSVOZUEUBVOZUUPUUQAUWIUWJVPZLUVSAUWEUWKLUVSXMAHUVTUWAUWEVKX
      PUWDUWKJLUVSUVEUUOVPZUWBUWIUWCUWJUVEUUOUUSXQUWLUFUEUBUWLUVEUUSUVJXRZXSUUO
      UUSMSUUOWJZXRZXSZUFUEUWLUVEUUOUWMUWOUWLYTUWLUVJUWNUUSMSUVEUUOXTZYAYBUKVLY
      CYDYEYFXHAUUOUUTUVSHUVTUWAUWEUVAAVKIUVMUVNUVOUVAHVJIGUVRUVAVIYGYJYJZHUVTU
      WAUWEUUTUVSVPAVKUVSUUSWDXNZYHZYKAUUORUUSHUVTUWAUWERYLZAVKIUVMUVNUVOUXAHVJ
      GUVRUVAUXAIVIDUVGUXAGVHCUVIUXADVFCUVEWPUVFWRRVEYMWGWGYNYJYJZAUVRUUSQYOZUU
      SRYOHUVTUWAUWEUVRAVKIUVMUVNUVOUVRHVJIGUVRUVAVIYPYJYJUVRUUSUVBQUUSUCUUAUSY
      QUXCUUSQUVEUGUBVOXSWPZWRRUUSQUXDUUJVAYQUUKZUWRUUBAUDUEUBAUUORUWNXRZXSUWPU
      DUEAUXFUWOUUOAUWNRUUSUXBUXEAUWNUVSUUTAUWNUVSYOZLUVSAUVJUVSYOZJUVSXMZUXGLU
      VSXMHUVTUWAUWEUXIAVKUVSMYOUXIUHNUJUUCUUDUXHUXGJLUVSUWLUVJUWNUVSUWQUUEYFXH
      UWTYKUWSUUFUUGUULVBVLYCYDUUHYRBCEJKLMNOPQRSTUBUCUDUFUGUHUIUJUKULUMUNUOUPU
      QURUSUTVAVBUUIYSYRBCEJKLMNOPQRSTUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBU
      UMYSYRBCEJKLMNOPQRSTUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBUUNYS $.
  $}

  ${
    $d A d f x y z $.  $d B f $.  $d D y $.  $d E d f y $.  $d G d f x y z $.
    $d R d f x y z $.  $d Y z $.  $d ch z $.  $d ps y $.
    bnj1423.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1423.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1423.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1423.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1423.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1423.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1423.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1423.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1423.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1423.10 $e |- P = U. H $.
    bnj1423.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1423.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1423.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1423.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1423.15 $e |- ( ch -> P Fn _trCl ( x , A , R ) ) $.
    bnj1423.16 $e |- ( ch -> Q Fn ( { x } u. _trCl ( x , A , R ) ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1423 $p |- ( ch -> A. z e. E ( Q ` z ) = ( G ` W ) ) $=
      ( cv cfv wceq wcel wa csn c-bnj18 bnj1442 cdm w3a c-bnj14 cun w-bnj17 wfn
      biid wral cres cop eqid bnj1450 wo bnj1424 adantl mpjaodan ralrimiva ) BF
      USZLUTRPUTVAZFOBWDOVBZVCZWDDUSZVDZVBZWEWDGMWHVEZVBZABWGCWGWJVCZDEFGHIJKLM
      NOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURWGVMZWMVMZVFWGWLVCZNUSZQVBWDWQ
      VGZVBVHZEUSZGMWHVIVBWQIVBWRWTVDGMWTVEVJVAVKZUAUSZHVBWQXBVLWHWQUTSPUTVADXB
      VNVKZABWGCWMWPXAWSDEFGHIJKLMNOPQRWDWQGMWDVIVOVPZSTUAUBUCUDUEUFUGUHUIUJUKU
      LUMUNUOUPUQURWNWOWPVMWSVMXAVMXCVMXDVQVRWFWJWLVSBOWIWKWDUPVTWAWBWC $.
  $}

  ${
    $d A d x z $.  $d E d z $.  $d R d x z $.  $d ch z $.
    bnj1452.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1452.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1452.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1452.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1452.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1452.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1452.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1452.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1452.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1452.10 $e |- P = U. H $.
    bnj1452.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1452.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1452.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1452.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1452 $p |- ( ch -> E e. B ) $=
      ( wcel wss cv c-bnj14 wral csn c-bnj18 cun wex wn wbr bnj1212 bnj1147 a1i
      snssd unssd syl5eqss wa elsni adantl bnj602 syl w-bnj15 c0 simplbi bnj835
      wne bnj906 syl2anc ad2antrr eqsstrd ssun4 syl6sseqr simpr bnj1213 bnj1125
      wceq syl3anc sstrd wo bnj1424 mpjaodan ralrimiva wsbc cvv wb snex bnj1149
      bnj893 syl5eqel bnj1454 weq sseq1d cbvralv anbi2i sbcbii sseq1 raleqbi1dv
      syl6bb sseq2 anbi12d sbcieg bitrd mpbir2and ) BOHUQZOGURZGMFUSZUTZOURZFOV
      AZBODUSZVBZGMYGVCZVDZGUPBYHYIGBYGGCNVEVFABEUSYGMVGVFEJVAZDGJUGUIVHZVKYIGU
      RBGMYGVIZVJVLVMBYEFOBYCOUQZVNZYCYHUQZYEYCYIUQZYOYPVNZYDYIURZYEYRYDGMYGUTZ
      YIYRYCYGWMZYDYTWMYPUUAYOYCYGVOVPGMYCYGVQVRBYTYIURZYNYPBGMVSZYGGUQZUUBAYGJ
      UQYKUUCBUIAUUCJVTWCUHWAWBZYLGMYGWDWEWFWGYSYDYJOYDYIYHWHUPWIZVRYOYQVNZYSYE
      UUGYDGMYCVCZYIUUGUUCYCGUQYDUUHURBUUCYNYQUUEWFZUUGFYIGYMYOYQWJZWKGMYCWDWEU
      UGUUCUUDYQUUHYIURUUIBUUDYNYQYLWFUUJGMYGYCWLWNWOUUFVRYNYPYQWPBOYHYIYCUPWQV
      PWRWSBYAUAUSZGURZYDUUKURZFUUKVAZVNZUAOWTZYBYFVNZBYAUULYTUUKURZDUUKVAZVNZU
      AOWTZUUPBOXAUQZYAUVAXBBOYJXAUPBYHYIYHXAUQBYGXCVJBUUCUUDYIXAUQUUEYLGMYGXEW
      EXDXFZUUTUAHOUCXGVRUUTUUOUAOUUSUUNUULUURUUMDFUUKDFXHYTYDUUKGMYGYCVQXIXJXK
      XLXOBUVBUUPUUQXBUVCUUOUUQUAOXAUUKOWMUULYBUUNYFUUKOGXMUUMYEFUUKOUUKOYDXPXN
      XQXRVRXSXT $.
  $}

  ${
    $d A f w $.  $d G f w $.  $d H w $.  $d P w $.  $d R f w $.  $d Z w $.
    $d f w x $.
    bnj1466.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1466.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1466.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1466.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1466.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1466.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1466.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1466.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1466.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1466.10 $e |- P = U. H $.
    bnj1466.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1466.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1466 $p |- ( w e. Q -> A. f w e. Q ) $=
      ( cfv cop csn cun cuni c-bnj14 wrex bnj1317 nfcii nfuni nfcxfr nfcv nfres
      cv cres nfop nffv nfsn nfun nfcrii ) NFLNLKDVFZROUMZUNZUOZUPULNKVPNKPUQUJ
      NPNFPTEGMVMURZUSNFPUIUTVAVBVCZNVONVMVNNVMVDZNRONOVDNRVMKVQVGZUNUKNVMVTVSN
      KVQVRNVQVDVEVHVCVIVHVJVKVCVL $.
  $}

  ${
    $d A d w x $.  $d B f $.  $d C w $.  $d G d w $.  $d H w $.  $d P w $.
    $d R d w x $.  $d Z w $.  $d d f w x $.  $d d x y $.
    bnj1467.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1467.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1467.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1467.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1467.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1467.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1467.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1467.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1467.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1467.10 $e |- P = U. H $.
    bnj1467.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1467.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1467 $p |- ( w e. Q -> A. d w e. Q ) $=
      ( cv cfv cop csn cun cuni c-bnj14 wrex cab nfcv wsbc wcel c-bnj18 wceq wa
      cdm wfn wral nfre1 nfab nfcri nfv nfan nfxfr nfsbc nfrex nfuni cres nfres
      nfcxfr nfop nffv nfsn nfun nfcrii ) SFLSLKDUMZROUNZUOZUPZUQULSKWKSKPURUJS
      PSPTEGMWHUSZUTZNVAUIWMSNTSEWLSWLVBZTCDEUMZVCSUHCSDWOSWOVBCNUMZIVDZWPVHWHU
      PGMWHVEUQVFZVGSUDWQWRSSNISIWPSUMZVIWHWPUNQOUNVFDWSVJVGZSHUTZNVAUCXASNWTSH
      VKVLWBVMWRSVNVOVPVQVPVRVLWBVSWBZSWJSWHWISWHVBZSROSOVBSRWHKWLVTZUOUKSWHXDX
      CSKWLXBWNWAWCWBWDWCWEWFWBWG $.
  $}

  ${
    $d A d f w x $.  $d B f w $.  $d C w $.  $d E d w z $.  $d G d f w x z $.
    $d H w $.  $d P w $.  $d Q w z $.  $d R d f w x $.  $d W w $.  $d Y z $.
    $d Z w $.  $d d x y $.
    bnj1463.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1463.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1463.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1463.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1463.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1463.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1463.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1463.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1463.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1463.10 $e |- P = U. H $.
    bnj1463.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1463.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1463.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1463.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    bnj1463.15 $e |- ( ch -> Q e. _V ) $.
    bnj1463.16 $e |- ( ch -> A. z e. E ( Q ` z ) = ( G ` W ) ) $.
    bnj1463.17 $e |- ( ch -> Q Fn E ) $.
    bnj1463.18 $e |- ( ch -> E e. B ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1463 $p |- ( ch -> Q e. C ) $=
      ( vw wcel cv wfn cfv wceq wral wa wrex wsbc c-bnj14 cres cop wex cvv elex
      syl eleq1 fneq2 raleq anbi12d wss bnj1317 nfcii bnj1467 nfcv nffn bnj1446
      nfel2 nfi nfral nfan jca32 bnj1465 mpdan df-rex sylibr wb bnj1466 bnj1448
      nfri nfrex nfeq2 fneq1 fveq1 reseq1 opeq2d syl6eqr fveq2d eqeq12d ralbidv
      rexbid bnj1468 mpbird bnj602 reseq2d opeq12d syl5eq cbvralv anbi2i rexbii
      fveq2 id sbcbii bnj1454 ) BLIVBZNVCZUAVCZVDZDVCZYGVEZSPVEZVFZDYHVGZVHZUAH
      VIZNLVJZBYIFVCZYGVEZYRYGGMYRVKZVLZVMZPVEZVFZFYHVGZVHZUAHVIZNLVJZYQBUUHLYH
      VDZYRLVEZRPVEZVFZFYHVGZVHZUAHVIZBYHHVBZUUNVHZUAVNZUUOBOVOVBZUURBOHVBZUUSU
      TOHVPVQUUQUUTLOVDZUULFOVGZVHZVHZBUAOVOYHOVFZUUPUUTUUNUVCYHOHVRUVEUUIUVAUU
      MUVBYHOLVSUULFYHOVTWAWAUVDUAUUTUVCUAUAOHUAVAHYHGWBGMYJVKZYHWBDYHVGVHUAVAH
      UCWCWDWIUVAUVBUAUAOLUAVALABCDEVAGHIJKLMNPQSTUAUBUCUDUEUFUGUHUIUJUKULUMUNW
      EWDZUAOWFZWGUULUAFOUVHUULUAABCDEFGHIJKLMNPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMU
      NUOWHWJWKWLWLXABUUTUVAUVBUTUSURWMWNWOUUNUAHWPWQBLVOVBZUUHUUOWRUQUUGUUONVA
      LVOUUONUUNNUAHNHWFUUIUUMNNYHLNVALABCDEVAGHIJKLMNPQSTUAUBUCUDUEUFUGUHUIUJU
      KULUMUNWSZWDNYHWFZWGUULNFYHUVKUULNABCDEFGHIJKLMNPQRSTUAUBUCUDUEUFUGUHUIUJ
      UKULUMUNUOWTWJWKWLXBXAYGLVFZUUFUUNUAHUAYGLUVGXCUVLYIUUIUUEUUMYHYGLXDUVLUU
      DUULFYHUVLYSUUJUUCUUKYRYGLXEUVLUUBRPUVLUUBYRLYTVLZVMRUVLUUAUVMYRYGLYTXFXG
      UOXHXIXJXKWAXLUVJXMVQXNYPUUGNLYOUUFUAHYNUUEYIYMUUDDFYHYJYRVFZYKYSYLUUCYJY
      RYGYBUVNSUUBPUVNSYJYGUVFVLZVMUUBUDUVNYJYRUVOUUAUVNYCUVNUVFYTYGGMYJYRXOXPX
      QXRXIXJXSXTYAYDWQBUVIYFYQWRUQYPNILUEYEVQXN $.
  $}

  ${
    $d A d f x $.  $d A f x y $.  $d B f $.  $d D y $.  $d G d f $.
    $d R d f x $.  $d R f x y $.  $d ps y $.  $d ta y $.
    bnj1489.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1489.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1489.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1489.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1489.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1489.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1489.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1489.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1489.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1489.10 $e |- P = U. H $.
    bnj1489.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1489.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1489 $p |- ( ch -> Q e. _V ) $=
      ( cv cfv cop csn cun cvv cuni wcel c-bnj14 weu wral wrex cab wceq w-bnj15
      wbr wn wne w-bnj13 bnj1364 df-bnj13 bnj832 bnj835 wex bnj1212 bnj1294 w3a
      c0 sylib nfv nfra1 nf3an nfxfr wa simplbi adantr bnj1388 r19.21bi c-bnj18
      cdm wi wsbc nfsbc1v nfex nfan nfeu nfim weq bnj1318 uneq12d eqeq2d anbi2d
      sneq bnj1373 syl6bbr exbidv imbi12d biid bnj1321 chvar syl2anc ex ralrimi
      eubidv a1i bnj1366 syl3anc uniexg syl syl5eqel snex bnj1149 ) BKJDULZQNUM
      UNZUOZUPUQUKBJYFBJOURZUQUIBOUQUSZYGUQUSBFLYDUTZUQUSZSMVAZEYIVBZOSEYIVCMVD
      VEZYHBYJDFAYDIUSZEULZYDLVGVHZEIVBZYJDFVBZBUFFLVFZIVSVIZYRAUEYSFLVJYRFLVKD
      FLVLVTVMVNCMVOVHABYQDFIUDUFVPVQBYKEYIBAYNYQVREUFAYNYQEAEWAYNEWAYPEIWBWCWD
      BYOYIUSZYKBUUAWEYSSMVOZYKBYSUUAAYNYQYSBUFAYSYTUEWFVNWGBUUBEYIABCDEFGHILMN
      PRSTUAUBUCUDUEUFUGWHWIYSMULZHUSZUUCWKZYDUOZFLYDWJZUPZVEZWEZMVOZWEZUUJMVAZ
      WLYSUUBWEZYKWLDEUUNYKDYSUUBDYSDWASDMSCDYOWMDUGCDYOWNWDZWOWPSDMUUOWQWRDEWS
      ZUULUUNUUMYKUUPUUKUUBYSUUPUUJSMUUPUUJUUDUUEYOUOZFLYOWJZUPZVEZWESUUPUUIUUT
      UUDUUPUUHUUSUUEUUPUUFUUQUUGUURYDYOXDFLYDYOWTXAXBXCCDEFGHLMNPRSTUAUBUCUGXE
      XFZXGXCUUPUUJSMUVAXOXHUUJDFGHLMNPRTUAUBUUJXIXJXKXLXMXNYMBUHXPSYJYLYMVRZEM
      YIOUVBXIXQXROUQXSXTYAYFUQUSBYEYBXPYCYA $.
  $}

  ${
    $d A f w $.  $d C w $.  $d G f w $.  $d H w $.  $d P w $.  $d Q w $.
    $d R f w $.  $d Z w $.  $d f w x $.
    bnj1491.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1491.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1491.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1491.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1491.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1491.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1491.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1491.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1491.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1491.10 $e |- P = U. H $.
    bnj1491.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1491.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1491.13 $e |- ( ch -> ( Q e. C /\ dom Q = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1491 $p |- ( ( ch /\ Q e. _V ) -> E. f ( f e. C /\ dom f = ( { x } u.
        _trCl ( x , A , R ) ) ) ) $=
      ( vw wcel cdm cv csn c-bnj18 cun wceq cvv wex bnj1466 nfcii wfn wral wrex
      cfv bnj1317 nfel nfdm nfeq1 nfan eleq1 dmeq eqeq1d anbi12d spcegf mpan9
      wa ) BKHUNZKUOZDUPZUQFLWCURUSZUTZVTZKVAUNMUPZHUNZWGUOZWDUTZVTZMVBULWKWFMK
      VAMUMKABCDEUMFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVCVDZWAWEMMKHWLMUMHWGRU
      PZVEWCWGVHPNVHUTDWMVFVTRGVGMUMHUBVIVDVJMWBWDMKWLVKVLVMWGKUTZWHWAWJWEWGKHV
      NWNWIWBWDWGKVOVPVQVRVS $.
  $}

  ${
    $d A d f x y z $.  $d A v w x y $.  $d B f $.  $d C y $.  $d D w y v $.
    $d E d f y z $.  $d G d f x y z $.  $d Q z $.  $d R d f x y z $.
    $d R w x y $.  $d Y z $.  $d ch z $.  $d ps y $.  $d ta y $.
    bnj1312.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1312.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1312.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1312.4 $e |- ( ta <-> ( f e. C /\ dom f = ( { x } u. _trCl ( x , A , R )
        ) ) ) $.
    bnj1312.5 $e |- D = { x e. A | -. E. f ta } $.
    bnj1312.6 $e |- ( ps <-> ( R _FrSe A /\ D =/= (/) ) ) $.
    bnj1312.7 $e |- ( ch <-> ( ps /\ x e. D /\ A. y e. D -. y R x ) ) $.
    bnj1312.8 $e |- ( ta' <-> [. y / x ]. ta ) $.
    bnj1312.9 $e |- H = { f | E. y e. _pred ( x , A , R ) ta' } $.
    bnj1312.10 $e |- P = U. H $.
    bnj1312.11 $e |- Z = <. x , ( P |` _pred ( x , A , R ) ) >. $.
    bnj1312.12 $e |- Q = ( P u. { <. x , ( G ` Z ) >. } ) $.
    bnj1312.13 $e |- W = <. z , ( Q |` _pred ( z , A , R ) ) >. $.
    bnj1312.14 $e |- E = ( { x } u. _trCl ( x , A , R ) ) $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1312 $p |- ( R _FrSe A
        -> A. x e. A E. f e. C dom f = ( { x } u. _trCl ( x , A , R ) ) ) $=
      ( vw w-bnj15 wex wral cv cdm csn c-bnj18 cun wceq wrex c0 wcel wbr wn wss
      wne simplbi bnj21 a1i simprbi bnj1230 bnj1228 syl3anc nfv nfcii nfcv nfne
      wa nfan nfxfr nfri bnj1521 simp2bi bnj1538 cvv bnj1489 bnj835 bnj1384 syl
      bnj1415 bnj1422 bnj1416 bnj1421 bnj1423 wfn fneq2i sylibr bnj1452 bnj1463
      wfun jca bnj1491 mpdan bnj1198 nsyl3 bnj1304 bnj1541 bnj1476 exbii df-rex
      bitr4i ralbii sylib ) GMURZCNUSZDGUTNVAZVBDVAZVCGMYDVDZVEZVFZNIVGZDGUTYBY
      ADGJUGAYAJVHUHABYDJVIZDEVAYDMVJVKEJUTZABDJAYAJGVLZJVHVMZYJDJVGAYAYLUHVNZY
      KAYBVKZDGJUGVOVPAYAYLUHVQDEUQGJMYNDUQGJUGVRZVSVTUIADAYAYLWEDUHYAYLDYADWAD
      JVHDUQJYOWBDVHWCWDWFWGWHWIBAYIYJUIWJYIYBBYNDJGUGWKBYCIVIYGWEZNCBLWLVIYPNU
      SZABCDEGHIJKLMNPQSTUAUBUCUDUEUFUGUHUIUJUKULUMUNWMZABCDEGHIJKLMNPQSTUAUBUC
      UDUEUFUGUHUIUJUKULUMUNBLIVILVBYFVFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
      JUKULUMUNUOUPYRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPBKYEBY
      AKXGAYIYJYABUIYMWNABCDEGHIJKMNPQSUAUBUCUDUEUFUGUHUIUJUKULWOWPZABCDEGHIJKM
      NPQSUAUBUCUDUEUFUGUHUIUJUKULWQZWRBLYFABCDEGHIJKLMNPQSTUAUBUCUDUEUFUGUHUIU
      JUKULUMUNYSABCDEGHIJKLMNPQSTUAUBUCUDUEUFUGUHUIUJUKULUMUNYTWSZYTWTUUAWRZXA
      BLYFXBLOXBUUBOYFLUPXCXDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUO
      UPXEXFUUAXHXIXJUFXKXLXMXNXOYBYHDGYBYQYHCYPNUFXPYGNIXQXRXSXT $.
  $}

  ${
    $d A d f x y z $.  $d B f $.  $d C y z $.  $d G d f x y z $.
    $d R d f x y z $.  $d Y z $.
    bnj1493.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1493.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1493.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1493 $p |- ( R _FrSe A -> A. x e. A E. f e. C dom f = ( { x } u. _trCl (
        x , A , R ) ) ) $=
      ( vy vz cv wcel csn cop biid eqid w-bnj15 cdm c-bnj18 cun wceq wa wn crab
      wex c0 wne wbr wral w3a wsbc c-bnj14 wrex cab cuni cres cfv bnj1312 ) BEU
      AFOZDPVCUBAOZQBEVDUCUDZUEUFZFUIUGABUHZUJUKUFZVHVDVGPMOZVDEULUGMVGUMUNZVFA
      MNBCDVGVFAVIUOZMBEVDUPZUQFURZUSZVNVDVDVNVLUTRZGVARQUDZEFVEGVMNOZVPBEVQUPU
      TRZHVOIVKJKLVFSVGTVHSVJSVKSVMTVNTVOTVPTVRTVETVB $.
  $}

  ${
    $d C g $.  $d d f $.  $d f g $.
    bnj1497.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1497.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1497.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1497 $p |- A. g e. C Fun g $=
      ( cv wfun wcel wi wfn cfv wceq wral wrex bnj1317 nfi nfv nfim eleq1 funeq
      wa imbi12d bnj1436 bnj1299 fnfun bnj31 bnj1265 chvar rgen ) GNZOZGDFNZDPZ
      UTOZQURDPZUSQFGVCUSFVCFUTJNZRZANUTSIHSTAVDUAZUIJCUBZFGDMUCUDUSFUEUFUTURTV
      AVCVBUSUTURDUGUTURUHUJVAVBJCVAVEVBJCVAVEVFJCVGFDMUKULVDUTUMUNUOUPUQ $.
  $}

  ${
    $d A d f x t u v $.  $d A f z $.  $d B f t $.  $d C t u v w $.  $d F z $.
    $d G d f x $.  $d R d f x $.  $d f w $.
    bnj1498.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1498.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1498.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1498.4 $e |- F = U. C $.
    $( Technical lemma for ~ bnj60 .  This lemma may no longer be used or have
       become an indirect lemma of the theorem in question (i.e. a lemma of a
       lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1498 $p |- ( R _FrSe A -> dom F = A ) $=
      ( wss cv wcel wrex wa wral vz vw w-bnj15 cdm cuni ciun eliun wceq wfn cfv
      vt bnj1436 bnj1299 fndm bnj31 bnj1196 simpld anim1i bnj593 sseq1 biimparc
      c-bnj14 bnj937 sselda rexlimiva sylbi bnj1317 bnj1400 dmeqi ssriv a1i csn
      eleq2s c-bnj18 cun bnj1493 vex elun1 ax-mp eleq2 mpbiri reximi ralimi syl
      snid ralbii sylibr bnj1309 bnj1307 nfcii nfiun dfss3f syl6sseqr eqssd
      nfcv ) BEUCZGUDZBWQBOWPUAWQBUAPZBQZWRDUEZUDZWQWSWRFDFPZUDZUFZXAWRXDQWRXCQ
      ZFDRWSFWRDXCUGXEWSFDXBDQZXCBWRXFXCBOZJXFJPZBOZXCXHUHZSZXGJXFXHCQZXJSXKJXF
      XJJCXFXBXHUIZXJJCXFXMAPZXBUJIHUJUHAXHTZJCXMXOSJCRZFDMULUMXHXBUNUOUPXLXIXJ
      XLXIBEXNVBXHOAXHTZXIXQSJCKULUQURUSXJXGXIXCXHBUTVAUSVCVDVEVFFUBDXPFUBDMVGV
      HZVMGWTNVIZVMVJVKWPBXAWQWPBXDXAWPXNXDQZABTZBXDOWPXNXCQZFDRZABTZYAWPXCXNVL
      ZBEXNVNZVOZUHZFDRZABTYDABCDEFHIJKLMVPYIYCABYHYBFDYHYBXNYGQZXNYEQYJXNAVQWE
      XNYEYFVRVSXCYGXNVTWAWBWCWDXTYCABFXNDXCUGWFWGABXDABWOFADXCAUKDAUKCDFHIJMAU
      KBCEJKWHWIWJAXCWOWKWLWGXRWMXSWMWN $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded recursion, part 1 of 3
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A d f g h x $.  $d B f g h $.  $d C g h $.  $d G d f g h x $.
    $d R d f g h x $.  $d Y g h $.
    bnj60.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d ) }
        $.
    bnj60.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj60.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G ` Y
        ) ) } $.
    bnj60.4 $e |- F = U. C $.
    $( Well-founded recursion, part 1 of 3.  The proof has been taken from
       Chapter 4 of Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj60 $p |- ( R _FrSe A -> F Fn A ) $=
      ( vg vh wfun cv wral cdm w-bnj15 cuni cres wceq bnj1497 wcel eqid bnj1311
      cin 3expia ralrimiv ralrimiva biid bnj1383 sylancr funeqi bnj1498 bnj1422
      wa sylibr ) BEUAZGBVADUBZQZGQVAORZQODSZVDVDTPRZTUIZUCVFVGUCUDZPDSZODSZVCA
      BCDEFOHIJKLMUEVAVIODVAVDDUFZUSVHPDVAVKVFDUFVHABCDVGEFOPHIJKLMVGUGZUHUJUKU
      LVEVEVJUSZDVGOPVEUMVLVMUMUNUOGVBNUPUTABCDEFGHIJKLMNUQUR $.
  $}

  ${
    $d A x $.  $d G d $.  $d Y d $.  $d d f x $.
    bnj1514.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1514.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1514.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    $( Technical lemma for ~ bnj1500 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1514 $p |- ( f e. C -> A. x e. dom f ( f ` x ) = ( G ` Y ) ) $=
      ( cv wcel cfv wceq cdm wral wfn wa w3a bnj1436 df-rex 3anass bnj133 sylib
      wrex wex simp3 fndm 3ad2ant2 raleqdv mpbird bnj593 bnj937 ) FMZDNZAMUPOHG
      OPZAUPQZRZIUQIMZCNZUPVASZURAVARZUAZUTIUQVCVDTZICUGZVEIUHVGFDLUBVGVBVFTVEI
      VFICUCVBVCVDUDUEUFVEUTVDVBVCVDUIVEURAUSVAVCVBUSVAPVDVAUPUJUKULUMUNUO $.
  $}

  ${
    $d C w $.  $d d f w $.  $d d ph $.  $d d x $.
    bnj1518.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1518.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1518.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1518.4 $e |- F = U. C $.
    bnj1518.5 $e |- ( ph <-> ( R _FrSe A /\ x e. A ) ) $.
    bnj1518.6 $e |- ( ps <-> ( ph /\ f e. C /\ x e. dom f ) ) $.
    $( Technical lemma for ~ bnj1500 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1518 $p |- ( ps -> A. d ps ) $=
      ( cv wcel cdm w3a nfv wfn cfv wceq wral wrex cab nfre1 nfcxfr nfcri nf3an
      wa nfab nfxfr nfri ) BLBAHSZFTZCSZURUATZUBLRAUSVALALUCLHFLFURLSZUDUTURUEK
      JUEUFCVBUGUNZLEUHZHUIOVDLHVCLEUJUOUKULVALUCUMUPUQ $.
  $}

  ${
    $d A d w $.  $d C w $.  $d F w $.  $d G d w $.  $d R d w $.  $d d w x $.
    bnj1519.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1519.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1519.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1519.4 $e |- F = U. C $.
    $( Technical lemma for ~ bnj1500 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1519 $p |- ( ( F ` x ) = ( G ` <. x , ( F |` _pred ( x , A , R ) ) >. )
        -> A. d ( F ` x ) = ( G ` <. x , ( F |` _pred ( x , A , R ) ) >. ) ) $=
      ( cv cfv wceq nfcxfr nfcv nffv c-bnj14 cres cop cuni wfn wral wa wrex cab
      nfre1 nfab nfuni nfres nfop nfeq nfri ) AOZGPZUQGBEUQUAZUBZUCZHPZQJJURVBJ
      UQGJGDUDNJDJDFOZJOZUEUQVCPIHPQAVDUFUGZJCUHZFUIMVFJFVEJCUJUKRULRZJUQSZTJVA
      HJHSJUQUTVHJGUSVGJUSSUMUNTUOUP $.
  $}

  ${
    $d A f w $.  $d C w $.  $d F w $.  $d G f w $.  $d R f w $.  $d f w x $.
    bnj1520.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1520.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1520.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1520.4 $e |- F = U. C $.
    $( Technical lemma for ~ bnj1500 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1520 $p |- ( ( F ` x ) = ( G ` <. x , ( F |` _pred ( x , A , R ) ) >. )
        -> A. f ( F ` x ) = ( G ` <. x , ( F |` _pred ( x , A , R ) ) >. ) ) $=
      ( vw cv cfv wceq nfcv nffv c-bnj14 cres cop cuni wfn wral wa wrex bnj1317
      nfcii nfuni nfcxfr nfres nfop nfeq nfri ) APZGQZUQGBEUQUAZUBZUCZHQZRFFURV
      BFUQGFGDUDNFDFODFPZJPZUEUQVCQIHQRAVDUFUGJCUHFODMUIUJUKULZFUQSZTFVAHFHSFUQ
      UTVFFGUSVEFUSSUMUNTUOUP $.
  $}

  ${
    $d A d f x $.  $d B f $.  $d C w $.  $d G d f x $.  $d R d f x $.
    $d Y d $.  $d d f ph $.  $d f w $.
    bnj1501.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1501.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1501.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1501.4 $e |- F = U. C $.
    bnj1501.5 $e |- ( ph <-> ( R _FrSe A /\ x e. A ) ) $.
    bnj1501.6 $e |- ( ps <-> ( ph /\ f e. C /\ x e. dom f ) ) $.
    bnj1501.7 $e |- ( ch <-> ( ps /\ d e. B /\ dom f = d ) ) $.
    $( Technical lemma for ~ bnj1500 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1501 $p |- ( R _FrSe A -> A. x e. A ( F ` x ) = ( G ` <. x , ( F |`
        _pred ( x , A , R ) ) >. ) ) $=
      ( vw w-bnj15 cv cfv c-bnj14 cres cop wceq cdm wcel ciun simprbi wfn bnj60
      fndm syl bnj832 eleqtrrd cuni dmeqi wral wa wrex bnj1317 bnj1400 syl6eleq
      eqtri bnj1405 bnj1209 bnj1436 bnj1299 bnj31 bnj836 bnj1518 bnj1521 bnj930
      wfun bnj835 wss elssuni syl6sseqr simp3bi bnj1502 bnj1514 bnj1294 bnj1517
      eqtrd eleqtrd bnj1503 opeq2d syl6eqr fveq2d eqtr4d bnj593 bnj1519 bnj1397
      sseqtr4d bnj1520 bnj1459 ) EHUBZADUCZJUDZXAJEHXAUEZUFZUGZKUDZUHZDERAXGIAB
      XGIXAIUCZUIZUJZABIGAIGXIXAAXAJUIZIGXIUKZAXAEXKAWTXAEUJZRULWTXMXKEUHZARWTJ
      EUMXNDEFGHIJKLMNOPQUNZEJUOUPUQURXKGUSZUIXLJXPQUTIUAGXHMUCZUMZXAXHUDZLKUDZ
      UHZDXQVAZVBMFVCZIUAGPVDVEVGVFVHSVIBXGMBCXGMXIXQUHZBCMFAXHGUJZXJYDMFVCBSYE
      XRYDMFYEXRYBMFYCIGPVJVKXQXHUOVLVMTABDEFGHIJKLMNOPQRSVNVOCXBXTXFBXQFUJZYDX
      BXTUHCTBXBXSXTBXAJXHAYEXJJVQZBSWTXMYGARWTEJXOVPUQVRZAYEXJXHJVSZBSYEXHXPJX
      HGVTQWAVMZBAYEXJSWBZWCBYADXIAYEXJYADXIVABSDEFGHIKLMNOPWDVMYKWEWGVRCXELKCX
      EXAXHXCUFZUGLCXDYLXACXCJXHBYFYDYGCTYHVRBYFYDYICTYJVRCXCXQXICXCXQVSZDXQBYF
      YDYMDXQVAZCTXQEVSYNMFNWFVMCXAXIXQBYFYDXJCTYKVRCBYFYDTWBZWHWEYOWQWIWJOWKWL
      WMWNDEFGHIJKLMNOPQWOWPWNDEFGHIJKLMNOPQWRWPWS $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded recursion, part 2 of 3
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A d f x $.  $d B f $.  $d G d f x $.  $d R d f x $.  $d Y d $.
    bnj1500.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1500.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1500.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1500.4 $e |- F = U. C $.
    $( Well-founded recursion, part 2 of 3.  The proof has been taken from
       Chapter 4 of Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1500 $p |- ( R _FrSe A -> A. x e. A ( F ` x ) = ( G ` <. x , ( F |`
        _pred ( x , A , R ) ) >. ) ) $=
      ( w-bnj15 cv wcel wa w3a biid cdm wceq bnj1501 ) BEOAPZBQRZUEFPZDQUDUFUAZ
      QSZUHJPZCQUGUIUBSZABCDEFGHIJKLMNUETUHTUJTUC $.
  $}

  ${
    $d A x $.  $d B w $.  $d C w $.  $d F w $.  $d H w x $.  $d R x $.
    $d d w x $.  $d f x $.
    bnj1525.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1525.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1525.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1525.4 $e |- F = U. C $.
    bnj1525.5 $e |- ( ph <-> ( R _FrSe A /\ H Fn A /\ A. x e. A ( H ` x ) = ( G
        ` <. x , ( H |` _pred ( x , A , R ) ) >. ) ) ) $.
    bnj1525.6 $e |- ( ps <-> ( ph /\ F =/= H ) ) $.
    $( Technical lemma for ~ bnj1522 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1525 $p |- ( ps -> A. x ps ) $=
      ( vw wne wa w-bnj15 wfn cv cfv c-bnj14 cres cop wceq wral w3a nfra1 nf3an
      nfv nfxfr cuni bnj1309 bnj1307 nfcii nfuni nfcxfr nfcv nfne nfan nfri ) B
      CBAIKUAZUBCSAVGCADGUCZKDUDZCUEZKUFVJKDGVJUGUHUIJUFUJZCDUKZULCRVHVIVLCVHCU
      OVICUOVKCDUMUNUPCIKCIFUQQCFCTFCTEFHJLMPCTDEGMNURUSUTVAVBCKVCVDVEUPVF $.
  $}

  ${
    $d A w x y $.  $d F w y $.  $d G w x y $.  $d R w x y $.
    bnj1529.1 $e |- ( ch -> A. x e. A ( F ` x ) = ( G ` <. x , ( F |` _pred ( x
        , A , R ) ) >. ) ) $.
    bnj1529.2 $e |- ( w e. F -> A. x w e. F ) $.
    $( Technical lemma for ~ bnj1522 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1529 $p |- ( ch -> A. y e. A ( F ` y ) = ( G ` <. y , ( F |` _pred ( y ,
        A , R ) ) >. ) ) $=
      ( cv cfv c-bnj14 cres cop wceq wral nfv nfcv nffv nfcii nfres nfop bnj602
      nfeq fveq2 id reseq2d opeq12d fveq2d eqeq12d cbvral sylib ) ABKZGLZUNGEFU
      NMZNZOZHLZPZBEQCKZGLZVAGEFVAMZNZOZHLZPZCEQIUTVGBCEUTCRBVBVFBVAGBDGJUAZBVA
      SZTBVEHBHSBVAVDVIBGVCVHBVCSUBUCTUEUNVAPZUOVBUSVFUNVAGUFVJURVEHVJUNVAUQVDV
      JUGVJUPVCGEFUNVAUDUHUIUJUKULUM $.
  $}

  ${
    $d A d f v x $.  $d A d w x $.  $d A w x y z $.  $d B f $.  $d B w $.
    $d C w $.  $d D y z $.  $d F w y z $.  $d G d f v x $.  $d G d w x $.
    $d G w x y $.  $d H v w x y z $.  $d R d f x $.  $d R d w x $.
    $d R v w x y z $.  $d Y d $.  $d ch y $.
    bnj1523.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1523.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1523.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1523.4 $e |- F = U. C $.
    bnj1523.5 $e |- ( ph <-> ( R _FrSe A /\ H Fn A /\ A. x e. A ( H ` x ) = ( G
        ` <. x , ( H |` _pred ( x , A , R ) ) >. ) ) ) $.
    bnj1523.6 $e |- ( ps <-> ( ph /\ F =/= H ) ) $.
    bnj1523.7 $e |- ( ch <-> ( ps /\ x e. A /\ ( F ` x ) =/= ( H ` x ) ) ) $.
    bnj1523.8 $e |- D = { x e. A | ( F ` x ) =/= ( H ` x ) } $.
    bnj1523.9 $e |- ( th <-> ( ch /\ y e. D /\ A. z e. D -. z R y ) ) $.
    $( Technical lemma for ~ bnj1522 .  This lemma may no longer be used or
       have become an indirect lemma of the theorem in question (i.e. a lemma
       of a lemma... of the theorem).  (Contributed by Jonathan Ben-Naim,
       3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1523 $p |- ( ( R _FrSe A /\ H Fn A /\ A. x e. A ( H ` x ) = ( G ` <. x ,
        ( H |` _pred ( x , A , R ) ) >. ) ) -> F = H ) $=
      ( vw vv w-bnj15 wfn cv cfv c-bnj14 cres cop wceq wral w3a wex wcel wbr wn
      wne bnj60 bnj835 bnj832 simp2bi wss bnj213 a1i wi wal simp3bi con2b albii
      bnj1211 sylib bnj1418 imim1i alimi syl bnj1142 cuni bnj1309 bnj1307 nfcii
      nfuni nfcxfr nfcrii bnj1534 bnj1533 bnj1536 opeq2d fveq2d bnj1500 bnj1529
      bnj21 bnj1213 bnj1294 ax-17 3eqtr4d bnj1538 bnj836 neneqd pm2.65i c0 wrex
      nex simp1bi rabeq2i sylanbrc ne0i syl3anc bnj1209 simprbi bnj1542 bnj1525
      bnj69 mto bnj1521 bnj1541 sylbir ) HLUJZPHUKZEULZPUMZYFPHLYFUNZUOUPOUMUQE
      HURZUSANPUQUCBANPUDBCEUTCECDFUTDFDFULZNUMZYJPUMZUQDYJNHLYJUNZUOZUPZOUMZYJ
      PYMUOZUPZOUMZYKYLDYOYRODYNYQYJDGHYMNPCYJKVAZGULZYJLVBZVCZGKURZNHUKZDUGBYF
      HVAZYFNUMZYGVDZUUECUEANPVDZUUEBUDYDYEYIUUEAUCEHIJLMNOQRSTUAUBVEVFVGZVFVFC
      YTUUDYEDUGBUUFUUHYECUEAUUIYEBUDAYDYEYIUCVHVGZVFVFYMHVIDHLYJVJZVKDGHYMUUAN
      UMKUUAPUMDUUAKVAZVCZGYMDUUBUUNVLZGVMZUUAYMVAZUUNVLZGVMDUUMUUCVLZGVMUUPDUU
      CGKDCYTUUDUGVNVQUUSUUOGUUMUUBVOVPVRUUOUURGUUQUUBUUNFGHLVSVTWAWBWCUULEGUHH
      KNPUFEUHNENJWDUBEJEUHJEUHIJMOQRUAEUHHILRSWEWFWGWHWIWJZWKWLWMWNWODYKYPUQZF
      HCYTUUDUVAFHURDUGCEFUHHLNOBUUFUUHUUGYFNYHUOUPOUMUQEHURZCUEAUUIUVBBUDYDYEY
      IUVBAUCEHIJLMNOQRSTUAUBWPVFVGVFUUTWQVFDFKHUUHEHKUFWRZDCYTUUDUGVHWSZWTDYLY
      SUQZFHCYTUUDUVEFHURDUGCEFUIHLPOBUUFUUHYICUEAUUIYIBUDAYDYEYIUCVNVGVFUIULPV
      AEXAWQVFUVDWTXBDYKYLCYTUUDYKYLVDZDUGUVFFKHEFUHHKNPUFUUTWKXCXDXEXFXIUUDCDF
      KCYDKHVIZKXGVDZUUDFKXHBUUFUUHYDCUEAUUIYDBUDAYDYEYIUCXJVGVFUVGCUVCVKCYFKVA
      ZUVHCUUFUUHUVICBUUFUUHUEVHCBUUFUUHUEVNUUHEKHUFXKXLKYFXMWBFGHKLXSXNUGXOXTX
      IUUHBCEHBEUHHNPUUJUUKBAUUIUDXPUUTXQUEABEHIJLMNOPQRSTUAUBUCUDXRYAXTYBYC $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
              Well-founded recursion, part 3 of 3
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d A d f x $.  $d A x y z $.  $d B f $.  $d F y z $.  $d G d f x $.
    $d G x y $.  $d H x y z $.  $d R d f x $.  $d R x y z $.  $d Y d $.
    bnj1522.1 $e |- B = { d | ( d C_ A /\ A. x e. d _pred ( x , A , R ) C_ d )
        } $.
    bnj1522.2 $e |- Y = <. x , ( f |` _pred ( x , A , R ) ) >. $.
    bnj1522.3 $e |- C = { f | E. d e. B ( f Fn d /\ A. x e. d ( f ` x ) = ( G `
        Y ) ) } $.
    bnj1522.4 $e |- F = U. C $.
    $( Well-founded recursion, part 3 of 3.  The proof has been taken from
       Chapter 4 of Don Monk's notes on Set Theory.  See
       ~ http://euclid.colorado.edu/~~monkd/setth.pdf .  (Contributed by
       Jonathan Ben-Naim, 3-Jun-2011.)  (New usage is discouraged.) $)
    bnj1522 $p |- ( ( R _FrSe A /\ H Fn A /\ A. x e. A ( H ` x ) = ( G ` <. x ,
        ( H |` _pred ( x , A , R ) ) >. ) ) -> F = H ) $=
      ( vz cv cfv w3a biid w-bnj15 wfn c-bnj14 cres cop wceq wral wne wcel crab
      vy wa wbr wn eqid bnj1523 ) BEUAIBUBAQZIRZUQIBEUQUCUDUEHRUFABUGSZUSGIUHUL
      ZUTUQBUIUQGRURUHZSZVBUKQZVAABUJZUIPQVCEUMUNPVDUGSZAUKPBCDVDEFGHIJKLMNOUST
      UTTVBTVDUOVETUP $.
  $}

$( (End of Jonathan Ben-Naim's mathbox.) $)


$(
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#
                Mathbox for Norm Megill
#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

Note: A label suffixed with "N" (after the "Atoms..." section below), such as
~  lshpnel2N , means that the definition or theorem is not used for the
derivation of ~  hlathil .  This is a temporary renaming to assist cleaning up
the theorems needed by ~ hlathil .

Please inform me of any changes that might affect my mathbox, since I may be
working on it independently of the github commits.  - Norm 30-Nov-2015

$)


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                   Experiments to study ax-7 unbundling
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

This section reproduces all predicate calculus theorems through ~ sbal2
that depend on ~ ax-7 .  It is an experiment to see how much of
predicate calculus can be derived using the weaker (unbundled) ~ ax-7v .

The theorems in this section with suffix "NEW7" are direct replacements
for the existing ones without the suffix but have proofs that avoid
~ ax-7 in favor of ~ ax-7v .

Theorems with suffix "AUX7" are new theorems that do not appear in the
main predicate calculus section but assist the proofs of the "NEW7"
suffixed theorems.  They also use at most ~ ax-7v and not ~ ax-7 .

Theorems with suffix "OLD7" are the remaining predicate calculus
theorems (through ~ sbal2 ) that haven't been proved from ~ ax-7v . In
order to isolate them, they are derived from ~ ax-7OLD7 which replicates
~ ax-7 . Whenever a proof of a *OLD7 theorem is found from ~ ax-7v , the
suffix is changed to "NEW7" and the theorem is moved up to the "NEW7"
section.

Theorems with suffix "AUXOLD7" (currently just ~ nfsb4tw2AUXOLD7 ) are
results of an unsuccessful attempt to prove a helper theorem from
~ ax-7v , but still needs the help of ~ ax-7 .

Currently there are about 138 "NEW7" theorems (starting after ~ ax-7v )
and 90 "OLD7" theorems (starting after ~ ax-7OLD7 ).
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
           Theorems derived from ax-7v (suffixes NEW7 and AUX7)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  ${
    $d x y $.
    $( Experiment to see if ~ ax-7 can be unbundled i.e. can be derived from
       ~ ax-7v .  This axiom is temporary.  It will be replaced with a theorem
       derived from ~ ax-7 if we are successful, otherwise will be deleted.
       (Contributed by NM, 9-Oct-2017.) $)
    ax-7v $a |- ( A. x A. y ph -> A. y A. x ph ) $.


    $( A weaker version of ~ ax-7 with distinct variable restrictions.  In
       order to show that this weakening is adequate, this should be the only
       theorem referencing ~ ax-7 directly.

       (Right now we derive this from the temporary axiom ~ ax-7v for easier
       'show trace'.  If this project is successful, which is seeming more and
       more unlikely, we will derive this from ~ ax-7 just as we derive ~ ax9v
       from ~ ax-9 .)

       (Contributed by NM, 9-Oct-2017.) $)
    ax7vAUX7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
      ( ax-7v ) ABCD $.

    $( Weak version of ~ alcom not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    alcomwAUX7 $p |- ( A. x A. y ph <-> A. y A. x ph ) $=
      ( wal ax7vAUX7 impbii ) ACDBDABDCDABCEACBEF $.

  $}

  ${
    $d x y $.
    a7sw.1 $e |- ( A. x A. y ph -> ps ) $.
    $( Weak version of ~ a7s not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    a7swAUX7 $p |- ( A. y A. x ph -> ps ) $=
      ( wal ax7vAUX7 syl ) ACFDFADFCFBADCGEH $.
  $}

  ${
    $d x y $.
    cbv3hv.1NEW7 $e |- ( ph -> A. y ph ) $.
    cbv3hv.2NEW7 $e |- ( ps -> A. x ps ) $.
    cbv3hv.3NEW7 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Lemma for ~ ax10NEW7 .  Similar to ~ cbv3h .  Requires distinct
       variables but avoids ~ ax-12 .  (Contributed by NM, 25-Jul-2015.)
       (Revised by NM, 25-Nov-2017.)  Revised to prove from ~ ax-7v instead of
       ~ ax-7 . $)
    cbv3hvNEW7 $p |- ( A. x ph -> A. y ps ) $=
      ( wal alimi wi weq wn ax9v hba1 hbim hbn spsd con3i alrimih mt3 a7swAUX7
      syl ) ACHZADHZCHBDHZAUDCEIAUEDCUCBDUCBJZCDKZLZCHCDMUFLUHCUFCUCBCACNFOPUGU
      FUGABCGQRSTIUAUB $.
  $}

  ${
    $d x y $.
    hbalw2.1 $e |- ( ph -> A. x ph ) $.
    $( Weak version of ~ hbal not requiring ~ ax-7 .  (Contributed by NM,
       9-Oct-2017.) $)
    hbalw2AUX7 $p |- ( A. y ph -> A. x A. y ph ) $=
      ( wal alimi ax7vAUX7 syl ) ACEZABEZCEIBEAJCDFACBGH $.
  $}

  ${
    $d x y $.
    hbaldw.1 $e |- ( ph -> A. y ph ) $.
    hbaldw.2 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Weak version of ~ hbald not requiring ~ ax-7 .  (Contributed by NM,
       9-Oct-2017.) $)
    hbaldwAUX7 $p |- ( ph -> ( A. y ps -> A. x A. y ps ) ) $=
      ( wal alimdh ax7vAUX7 syl6 ) ABDGZBCGZDGKCGABLDEFHBDCIJ $.
  $}

  ${
    $d x y $.
    hbexw.1 $e |- ( ph -> A. x ph ) $.
    $( Weak version of ~ hbex not requiring ~ ax-7 .  (Contributed by NM,
       9-Oct-2017.) $)
    hbexwAUX7 $p |- ( E. y ph -> A. x E. y ph ) $=
      ( wex wn wal df-ex hbn hbalw2AUX7 hbxfrbi ) ACEAFZCGZFBACHMBLBCABDIJIK $.
  $}

  ${
    $d x y $.
    nfw.1 $e |- F/ x ph $.
    $( Weak version of ~ nfal not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    nfalwAUX7 $p |- F/ x A. y ph $=
      ( wal nfri hbalw2AUX7 nfi ) ACEBABCABDFGH $.

    $( Weak version of ~ nfex not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    nfexwAUX7 $p |- F/ x E. y ph $=
      ( wex wn wal df-ex nfn nfalwAUX7 nfxfr ) ACEAFZCGZFBACHMBLBCABDIJIK $.
  $}

  ${
    $d x y $.
    nfaldw.1 $e |- F/ y ph $.
    nfaldw.2 $e |- ( ph -> F/ x ps ) $.
    $( Weak version of ~ nfald not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    nfaldwAUX7 $p |- ( ph -> F/ x A. y ps ) $=
      ( wnf wal alrimi nfnf1 nfalwAUX7 nfr al2imi ax7vAUX7 syl6 nfd syl ) ABCGZ
      DHZBDHZCGARDEFISTCRCDBCJKSTBCHZDHTCHRBUADBCLMBDCNOPQ $.

    $( Weak version of ~ nfexd not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    nfexdwAUX7 $p |- ( ph -> F/ x E. y ps ) $=
      ( wex wn wal df-ex nfnd nfaldwAUX7 nfxfrd ) BDGBHZDIZHACBDJAOCANCDEABCFKL
      KM $.
  $}

  ${
    $d x y $.
    $( Weak version of ~ 19.12 not requiring ~ ax-7 .  (Contributed by NM,
       10-Oct-2017.) $)
    19.12vAUX7 $p |- ( E. x A. y ph -> A. y E. x ph ) $=
      ( wal wex hba1 hbexwAUX7 sp eximi alrimih ) ACDZBEABECKCBACFGKABACHIJ $.
  $}

  ${
    $d x z $.  $d y z $.
    dvelimhwNEW.1 $e |- ( ph -> A. x ph ) $.
    dvelimhwNEW.2 $e |- ( ps -> A. z ps ) $.
    dvelimhwNEW.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $(  dvelimhwNEW.4 $e |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $. $)
    dvelimhwNEW.4 $e |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $.
    $( Proof of ~ dvelimh without using ~ ax-12 but with additional distinct
       variable conditions.  (Contributed by Andrew Salmon, 21-Jul-2011.)
       (Revised by NM, 1-Aug-2017.) $)
    dvelimhwNEW7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi ax-17 hbn1 equcomi alimi syl56 a1i hbimd hbaldwAUX7 albii
      equsalhw 3imtr3g ) CDJZCKLZEDJZAMZEKZUICKBBCKUFUHCEUFENUFUGACUECOUGDEJZUF
      UJCKUGCKEDPIUJUGCDEPQRAACKMUFFSTUAABEDGHUCZUIBCUKUBUD $.
  $}

  ${
    $d w x z $.  $d w y $.
    ax12olem2w.1 $e |- ( -. x = y -> ( y = w -> A. x y = w ) ) $.
    $( Lemma for ~ ax12o .  Negate the equalities in ~ ax-12 , shown as the
       hypothesis.  (Contributed by NM, 10-Oct-2017.) $)
    ax12olem2wAUX7 $p |- ( -. x = y -> ( -. y = z -> A. x -. y = z ) ) $=
      ( weq wn wa wex anim1d ax-17 anim2i 19.26 sylibr syl6 eximdv ax12olem1OLD
      wal 19.12vAUX7 albii 3imtr3g ) ABFGZBDFZCDFGZHZDIZUFARZBCFGZUHARUBUFUEARZ
      DIUGUBUEUIDUBUEUCARZUDHZUIUBUCUJUDEJUKUJUDARZHUIUDULUJUDAKLUCUDAMNOPUEDAS
      OBCDQZUFUHAUMTUA $.
  $}

  $( Lemma for ~ ax12o .  Show the equivalence of an intermediate equivalent to
     ~ ax12o with the conjunction of ~ ax-12 and a variant with negated
     equalities.  (Contributed by NM, 29-Oct-2017.) $)
  ax12olem3aAUX7 $p |- ( ( ph -> ( -. A. x -. ps -> A. y ps ) )
  <-> ( ( ph -> ( ps -> A. y ps ) ) /\ ( ph -> ( -. ps -> A. x -. ps ) ) ) ) $=
    ( wn wal wi wa sp con2i imim1i imim2i con1d con1 imim1d com12 imim3i impbii
    jca imp ) ABEZCFZEZBDFZGZGZABUDGZGZAUAUBGZGZHUFUHUJUEUGABUCUDUBBUACIJKLUEUI
    AUEUBBUDBUCBDILMLSUHUJUFUGUIUEAUIUGUEUIUCBUDBUBNOPQTR $.

  ${
    $d w x z $.  $d w y z $.
    ax12olem4w.1 $e |- ( -. x = y -> ( y = z -> A. x y = z ) ) $.
    ax12olem4w.2 $e |- ( -. x = y -> ( y = w -> A. x y = w ) ) $.
    $( Lemma for ~ ax12o .  Construct an intermediate equivalent to ~ ax-12
       from two instances of ~ ax-12 .  (Contributed by NM, 10-Oct-2017.) $)
    ax12olem4wAUX7 $p |- ( -. x = y -> ( -. A. x -. y = z -> A. x y = z ) ) $=
      ( weq wn wal wi ax12olem2wAUX7 ax12olem3OLD mpbir2an ) ABGHZBCGZHZAIZHOAI
      ZJJNORJJNPQJJEABCDFKABCLM $.
  $}

  ${
    $d w x $.  $d w y $.  $d w z $.
    ax12olem6NEW.1 $e |- ( -. A. x x = z -> ( z = w -> A. x z = w ) ) $.
    ax12olem6NEW.2 $e |- ( -. A. x x = y -> ( y = w -> A. x y = w ) ) $.
    $( Lemma for ~ ax12o .  Derivation of ~ ax12o from the hypotheses, without
       using ~ ax12o .  (Contributed by Andrew Salmon, 21-Jul-2011.)  (Revised
       by NM, 24-Dec-2015.) $)
    ax12olem6NEW7 $p |- ( -. A. x x = y
      -> ( -. A. x x = z -> ( y = z -> A. x y = z ) ) ) $=
      ( weq wal wn wi hbn1 hbim1 ax-17 equcom syl5bb imbi2d dvelimhwNEW7 19.21h
      equequ1 syl6ib pm2.86d ) ABGAHIZACGZAHIZBCGZUEAHZUBUDUEJZUGAHUDUFJUDCDGZJ
      UGABDUDUHAUCAKZELUGDMDBGZUHUEUDUHDCGUJUECDNDBCSOPFQUDUEAUIRTUA $.
  $}

  ${
    $d w x $.  $d w y $.  $d w z $.
    ax12olem7NEW.1 $e |- ( -. x = z -> ( -. A. x -. z = w -> A. x z = w ) ) $.
    ax12olem7NEW.2 $e |- ( -. x = y -> ( -. A. x -. y = w -> A. x y = w ) ) $.
    $( Lemma for ~ ax12o .  Derivation of ~ ax12o from the hypotheses, without
       using ~ ax12o .  (Contributed by NM, 24-Dec-2015.) $)
    ax12olem7NEW7 $p |- ( -. A. x x = y
              -> ( -. A. x x = z -> ( y = z -> A. x y = z ) ) ) $=
      ( ax12olem5OLD ax12olem6NEW7 ) ABCDACDEGABDFGH $.
  $}

  ${
    $d x w v $.  $d y w v $.  $d z w v $.
    $( Derive set.mm's original ~ ax-12o from the shorter ~ ax-12 .
       (Contributed by NM, 29-Nov-2015.)  (Revised by NM, 24-Dec-2015.) $)
    ax12oNEW7 $p |- ( -. A. z z = x -> ( -. A. z z = y
              -> ( x = y -> A. z x = y ) ) ) $=
      ( vw vv ax12v ax12olem4wAUX7 ax12olem7NEW7 ) CABDCBDECBDFCBEFGCADECADFCAE
      FGH $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ps $.  $d x ph $.
    dvelimvNEW.1 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Similar to ~ dvelim with first hypothesis replaced by distinct variable
       condition.  (Contributed by NM, 25-Jul-2015.) $)
    dvelimvNEW7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi ax-17 alrimih a2i alimi syl ax10lem3OLD con3i hbn1 hban
      sp wa a1d syl5ibr ax12oNEW7 a17d hbimd hbaldwAUX7 biimpd ax9v con3 al2imi
      imp mtoi nsyl2 syl56 expcom ax-11 syl2im pm2.27 syld pm2.61d2 ) CDGZCHIZC
      EGZCHZBBCHZJZVEIZVCVGBEDGZAJZEHZVHVCUAZVKCHVFBVIBEHZJZEHVKBVNEBEKZBVMVIVO
      UBLVNVJEVIVMAVMAVIBBETFUCMNOVLVJCEVHVCEVHECGZEHZIZVHEHVQVEECPQVRVHEVPERVE
      VQCEPQLOVCEKSVLVIACVHVCCVDCRVBCRSVHVCVIVICHJEDCUDULVLACUEUFUGVKBCVKBIZEHZ
      BVKVIBJZEHZVTIVJWAEVIABVIABFUHMNWBVTVIIZEHEDUIWAVSWCEVIBUJUKUMOVSEKUNNUOU
      PVEBVDBJZCHZVFVEVDBVMWEVDCTVOBCEUQURVDWDBCVDBUSUKUTVA $.
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.)  (Revised by NM, 20-Jul-2015.) $)
    dveeq2NEW7 $p |- ( -. A. x x = y -> ( z = y -> A. x z = y ) ) $=
      ( vw weq equequ2 dvelimvNEW7 ) CDECBEABDDBCFG $.
  $}

  ${
    $d w z x $.  $d w y $.
    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.) $)
    dveeq1NEW7 $p |- ( -. A. x x = y -> ( y = z -> A. x y = z ) ) $=
      ( vw weq equequ1 dvelimvNEW7 ) DCEBCEABDDBCFG $.

    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.) $)
    dveel1NEW7 $p |- ( -. A. x x = y -> ( y e. z -> A. x y e. z ) ) $=
      ( vw wel elequ1 dvelimvNEW7 ) DCEBCEABDDBCFG $.

    $( Quantifier introduction when one pair of variables is distinct.
       (Contributed by NM, 2-Jan-2002.) $)
    dveel2NEW7 $p |- ( -. A. x x = y -> ( z e. y -> A. x z e. y ) ) $=
      ( vw wel elequ2 dvelimvNEW7 ) CDECBEABDDBCFG $.
  $}

  ${
    $d z ps $.  $d x z $.  $d y z $.
    dvelimw.1 $e |- ( ph -> A. x ph ) $.
    dvelimw.2 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Weaker version of ~ dvelim .  (Contributed by NM, 23-Nov-1994.) $)
    dvelimwAUX7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( ax-17 dveeq1NEW7 dvelimhwNEW7 ) ABCDEFBEHGCDEIJ $.
  $}

  ${
    $d x v z $.  $d y v z $.
    $( Theorem showing that ~ ax-9 follows from the weaker version ~ ax9v .
       (Even though this theorem depends on ~ ax-9 , all references of ~ ax-9
       are made via ~ ax9v .  An earlier version stated ~ ax9v as a separate
       axiom, but having two axioms caused some confusion.)

       This theorem should be referenced in place of ~ ax-9 so that all proofs
       can be traced back to ~ ax9v .  (Contributed by NM, 12-Nov-2013.)
       (Revised by NM, 25-Jul-2015.) $)
    ax9NEW7 $p |- -. A. x -. x = y $=
      ( vv weq wal wn sp nsyl3 wi ax9v dveeq2NEW7 hba1 wb equequ2 notbid albidh
      sps mtbii syl6com con3i alrimiv mt3 pm2.61i ) ABDZAEZUDFZAEZFZUGUDUEUFAGU
      DAGHUEFZUHIZCBDZFZCECBJUJFULCUKUJUIUKUKAEZUHABCKUMACDZFZAEUGACJUMUOUFAUKA
      LUMUNUDUKUNUDMACBANQOPRSTUAUBUC $.
  $}

  $( Show that the original axiom ~ ax-9o can be derived from ~ ax9 and
     others.  See ~ ax9from9o for the rederivation of ~ ax9 from ~ ax-9o .

     Normally, ~ ax9o should be used rather than ~ ax-9o , except by theorems
     specifically studying the latter's properties.  (Contributed by NM,
     5-Aug-1993.)  (Proof modification is discouraged.) $)
  ax9oNEW7 $p |- ( A. x ( x = y -> A. x ph ) -> ph ) $=
    ( weq wal wi wn ax9NEW7 con3 al2imi mtoi ax6o syl ) BCDZABEZFZBEZOGZBEZGAQS
    NGZBEBCHPRTBNOIJKABLM $.

  $( At least one individual exists.  This is not a theorem of free logic,
     which is sound in empty domains.  For such a logic, we would add this
     theorem as an axiom of set theory (Axiom 0 of [Kunen] p. 10).  In the
     system consisting of ~ ax-5 through ~ ax-14 and ~ ax-17 , all axioms other
     than ~ ax9 are believed to be theorems of free logic, although the system
     without ~ ax9 is probably not complete in free logic.  (Contributed by NM,
     5-Aug-1993.) $)
  a9eNEW7 $p |- E. x x = y $=
    ( weq wex wn wal ax9NEW7 df-ex mpbir ) ABCZADJEAFEABGJAHI $.

  ${
    $d w z x $.  $d w z y $.
    $( Lemma for ~ ax10 .  Change bound variable.  (Contributed by NM,
       8-Jul-2016.) $)
    ax10lem4NEW7 $p |- ( A. x x = w -> A. y y = x ) $=
      ( weq wal wn wi ax10lem1 dveeq1NEW7 hba1 wb equequ2 sps biimprd syl6 syl7
      albidh spsd pm2.43d com12 pm2.18d ) ACDZAEZBADZBEZUEFZUCUEUFUCUEUFUBUCUEG
      AUCBCDZBEZUFUBUEABCHUFUBUBBEZUHUEGBACIUIUEUHUIUDUGBUBBJUBUDUGKBACBLMQNOPR
      STUA $.
  $}

  ${
    $d w z $.  $d u v w $.  $d v x $.  $d v y $.
    $( Lemma for ~ ax10 .  Change free and bound variables.  (Contributed by
       NM, 22-Jul-2015.) $)
    ax10lem5NEW7 $p |- ( A. z z = w -> A. y y = x ) $=
      ( vv vu weq wal ax10lem1 ax10lem4NEW7 4syl ) CDGCHEDGEHFEGFHAEGAHBAGBHCED
      IEFDJFAEIABEJK $.
  $}

  ${
    $d x z $.  $d y z $.
    $( Derive set.mm's original ~ ax-10 from others.  (Contributed by NM,
       25-Jul-2015.)  (Revised by NM, 7-Nov-2015.) $)
    ax10NEW7 $p |- ( A. x x = y -> A. y y = x ) $=
      ( vz weq wal wn ax9v wex df-ex wi wa dveeq2NEW7 ax10o2 equcomi alimi syl6
      imp ax10lem5NEW7 syl56 exp3acom23 pm2.18 exlimdv syl5bir mpi ) ABDAEZCADZ
      FCEFZBADBEZCAGUGUFCHUEUHUFCIUEUFUHCUEUFUHFZUHJUHUEUIUFUHUIUFKUFBEZUEACDZA
      EZUHUIUFUJBACLQUEUJUFAEULUFBAMUFUKACANOPABACRSTUHUAPUBUCUD $.
  $}

  $( Commutation law for identical variable specifiers.  The antecedent and
     consequent are true when ` x ` and ` y ` are substituted with the same
     variable.  Lemma L12 in [Megill] p. 445 (p. 12 of the preprint).
     (Contributed by NM, 5-Aug-1993.) $)
  aecomNEW7 $p |- ( A. x x = y -> A. y y = x ) $=
    ( ax10NEW7 ) ABC $.

  ${
    alequcomsNEW.1 $e |- ( A. x x = y -> ph ) $.
    $( A commutation rule for identical variable specifiers.  (Contributed by
       NM, 5-Aug-1993.) $)
    aecomsNEW7 $p |- ( A. y y = x -> ph ) $=
      ( weq wal aecomNEW7 syl ) CBECFBCEBFACBGDH $.
  $}

  $( Show that ~ ax-10o can be derived from ~ ax-10 in the form of ~ ax10 .
     Normally, ~ ax10o should be used rather than ~ ax-10o , except by theorems
     specifically studying the latter's properties.  (Contributed by NM,
     16-May-2008.)  (Proof modification is discouraged.) $)
  ax10oNEW7 $p |- ( A. x x = y -> ( A. x ph -> A. y ph ) ) $=
    ( weq wal wi ax10NEW7 ax-11 equcoms sps pm2.27 al2imi sylsyld ) BCDZBECBDZC
    EABEZOAFZCEZACEBCGNPRFZBSCBACBHIJOQACOAKLM $.

  $( Special case of ~ hbae not requiring ~ ax-7 .  (Contributed by NM,
     12-Oct-2017.) $)
  hba1eAUX7 $p |- ( A. x x = y -> A. y A. x x = y ) $=
    ( weq wal ax10NEW7 a5i syl ) ABCADZBACZBDHBDABEIHBBAEFG $.

  ${
    $d x z $.
    $( Weak version of ~ hbae not requiring ~ ax-7 .  See ~ hbaew2AUX7 and
       ~ hbaew3AUX7 for versions with different distinct variable
       requirements.  (Contributed by NM, 10-Oct-2017.) $)
    hbaewAUX7 $p |- ( A. x x = y -> A. z A. x x = y ) $=
      ( weq wal wi wn ax12oNEW7 syl7 ax10oNEW7 aecomsNEW7 pm2.43i syl5 pm2.61ii
      sp a5i ax7vAUX7 syl ) ABDZAEZSCEZAETCESUAACADCEZCBDCEZTUAFZTSUBGUCGUASAOA
      BCHIUDACSACJKUDBCTSBEZBCDBEUATUESABJLSBCJMKNPSACQR $.
  $}

  ${
    $d y z $.
    $( Weak version of ~ hbae not requiring ~ ax-7 .  Different distinct
       variable requirements from ~ hbaewAUX7 .  (Contributed by NM,
       30-Oct-2017.) $)
    hbaew2AUX7 $p |- ( A. x x = y -> A. z A. x x = y ) $=
      ( weq wal aecomNEW7 hbaewAUX7 alrimih syl ) ABDAEZBADBEZJCEABFKJCBACGBAFH
      I $.
  $}

  ${
    $d x z $.
    $( Weak version of ~ nfae not requiring ~ ax-7 .  (Contributed by NM,
       10-Oct-2017.) $)
    nfaewAUX7 $p |- F/ z A. x x = y $=
      ( weq wal hbaewAUX7 nfi ) ABDAECABCFG $.

    $( Weak version of ~ hbnae not requiring ~ ax-7 .  (Contributed by NM,
       10-Oct-2017.) $)
    hbnaewAUX7 $p |- ( -. A. x x = y -> A. z -. A. x x = y ) $=
      ( weq wal hbaewAUX7 hbn ) ABDAECABCFG $.

    $( Weak version of ~ nfnae not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    nfnaewAUX7 $p |- F/ z -. A. x x = y $=
      ( weq wal nfaewAUX7 nfn ) ABDAECABCFG $.
  $}

  ${
    $d y z $.
    $( Weak version of ~ nfae not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    nfaew2AUX7 $p |- F/ z A. x x = y $=
      ( weq wal hbaew2AUX7 nfi ) ABDAECABCFG $.

    $( Weak version of ~ hbnae not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    hbnaew2AUX7 $p |- ( -. A. x x = y -> A. z -. A. x x = y ) $=
      ( weq wal hbaew2AUX7 hbn ) ABDAECABCFG $.

    $( Weak version of ~ nfnae not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    nfnaew2AUX7 $p |- F/ z -. A. x x = y $=
      ( weq wal nfaew2AUX7 nfn ) ABDAECABCFG $.
  $}

  $( A variable is effectively not free in an equality if it is not either of
     the involved variables. ` F/ ` version of ~ ax-12o .  (Contributed by
     Mario Carneiro, 6-Oct-2016.) $)
  nfeqfNEW7 $p |- ( ( -. A. z z = x /\ -. A. z z = y ) -> F/ z x = y ) $=
    ( weq wal wn wa nfa1 nfn nfan wi ax12oNEW7 imp nfd ) CADZCEZFZCBDZCEZFZGABD
    ZCQTCPCOCHISCRCHIJQTUAUACEKABCLMN $.

  ${
    equsalNEW.1 $e |- F/ x ps $.
    equsalNEW.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.)  (Proof shortened by Andrew Salmon, 12-Aug-2011.)  (Revised
       by Mario Carneiro, 3-Oct-2016.) $)
    equsalNEW7 $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( weq wi wal 19.3 syl6bbr pm5.74i albii a1d alrimi ax9oNEW7 impbii bitr4i
      nfri ) CDGZAHZCITBCIZHZCIZBUAUCCTAUBTABUBFBCEJKLMBUDBUCCEBUBTBCESNOBCDPQR
      $.
  $}

  ${
    equsalih.1 $e |- ( x = y -> ( ph -> A. x ps ) ) $.
    $( One direction of ~ equsalhNEW7 with weaker hypothesis.  TO DO:  Delete
       if not used.  (Contributed by NM, 13-Nov-2017.) $)
    equsalihAUX7 $p |- ( A. x ( x = y -> ph ) -> ps ) $=
      ( weq wi wal a2i alimi ax9oNEW7 syl ) CDFZAGZCHMBCHZGZCHBNPCMAOEIJBCDKL
      $.
  $}

  ${
    equsalhNEW.1 $e |- ( ps -> A. x ps ) $.
    equsalhNEW.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.) $)
    equsalhNEW7 $p |- ( A. x ( x = y -> ph ) <-> ps ) $=
      ( nfi equsalNEW7 ) ABCDBCEGFH $.
  $}

  ${
    equsex.1NEW $e |- F/ x ps $.
    equsex.2NEW $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.) $)
    equsexNEW7 $p |- ( E. x ( x = y /\ ph ) <-> ps ) $=
      ( weq wn wi wex wal wa exnal df-an nfn notbid equsalNEW7 con2bii 3bitr4i
      exbii ) CDGZAHZIZHZCJUCCKZHUAALZCJBUCCMUFUDCUAANTUEBUBBHCDBCEOUAABFPQRS
      $.
  $}

  ${
    equsexh.1NEW $e |- ( ps -> A. x ps ) $.
    equsexh.2NEW $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( A useful equivalence related to substitution.  (Contributed by NM,
       5-Aug-1993.) $)
    equsexhNEW7 $p |- ( E. x ( x = y /\ ph ) <-> ps ) $=
      ( nfi equsexNEW7 ) ABCDBCEGFH $.
  $}

  ${
    $d z x $.
    dvelimhv.1 $e |- ( ph -> A. x ph ) $.
    dvelimhv.2 $e |- ( ps -> A. z ps ) $.
    dvelimhv.3 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ dvelimh not requiring ~ ax-7 .  (Contributed by NM,
       10-Oct-2017.) $)
    dvelimhvAUX7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi hba1 ax10o2 syl5 a1d wa hbnaewAUX7 hban hbn1 ax12oNEW7 ex
      imp a1i hbimd hbaldwAUX7 pm2.61i equsalhNEW7 albii 3imtr3g ) CDIZCJKZEDIZ
      ALZEJZUOCJZBBCJCEIZCJZULUOUPLZLURUSULUOUOEJURUPUNEMUOECNOPURKZULUSUTULQZU
      NCEUTULECEERCDERSVAUMACUTULCUQCTUKCTSUTULUMUMCJLEDCUAUCAACJLVAFUDUEUFUBUG
      ABEDGHUHZUOBCVBUIUJ $.
  $}

  ${
    dral1NEW.1 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 24-Nov-1994.) $)
    dral1NEW7 $p |- ( A. x x = y -> ( A. x ph <-> A. y ps ) ) $=
      ( weq hba1 biimpd alimdh ax10oNEW7 syld hba1eAUX7 biimprd ax10o2 impbid
      wal ) CDFZCPZACPZBDPZRSBCPTRABCQCGRABEHIBCDJKRTADPSRBADCDLRABEMIADCNKO $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 27-Feb-2005.) $)
    drex1NEW7 $p |- ( A. x x = y -> ( E. x ph <-> E. y ps ) ) $=
      ( weq wal wn wex notbid dral1NEW7 df-ex 3bitr4g ) CDFCGZAHZCGZHBHZDGZHACI
      BDINPROQCDNABEJKJACLBDLM $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       (Contributed by Mario Carneiro, 4-Oct-2016.) $)
    drnf1NEW7 $p |- ( A. x x = y -> ( F/ x ph <-> F/ y ps ) ) $=
      ( weq wal wi wnf dral1NEW7 imbi12d df-nf 3bitr4g ) CDFCGZAACGZHZCGBBDGZHZ
      DGACIBDIPRCDNABOQEABCDEJKJACLBDLM $.

    ${
      $d x z $.
      $( Weak version of ~ dral2 not requiring ~ ax-7 .  (Contributed by NM,
         27-Oct-2017.) $)
      dral2wAUX7 $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
        ( weq wal hbaewAUX7 albidh ) CDGCHABECDEIFJ $.

      $( Weak version of ~ drex2 not requiring ~ ax-7 .  (Contributed by NM,
         27-Oct-2017.) $)
      drex2wAUX7 $p |- ( A. x x = y -> ( E. z ph <-> E. z ps ) ) $=
        ( weq wal hbaewAUX7 exbidh ) CDGCHABECDEIFJ $.

      $( Weak version of ~ drnf2 not requiring ~ ax-7 .  (Contributed by NM,
         27-Oct-2017.) $)
      drnf2wAUX7 $p |- ( A. x x = y -> ( F/ z ph <-> F/ z ps ) ) $=
        ( weq wal wi wnf dral2wAUX7 imbi12d df-nf 3bitr4g ) CDGCHZAAEHZIZEHBBEH
        ZIZEHAEJBEJQSCDEOABPRFABCDEFKLKAEMBEMN $.
    $}

    ${
      $d y z $.
      $( Weak version of ~ dral2 not requiring ~ ax-7 .  (Contributed by NM,
         25-Nov-2017.) $)
      dral2w2AUX7 $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
        ( weq wal hbaew2AUX7 albidh ) CDGCHABECDEIFJ $.

      $( Weak version of ~ drex2 not requiring ~ ax-7 .  (Contributed by NM,
         25-Nov-2017.) $)
      drex2w2AUX7 $p |- ( A. x x = y -> ( E. z ph <-> E. z ps ) ) $=
        ( weq wal hbaew2AUX7 exbidh ) CDGCHABECDEIFJ $.

      $( Weak version of ~ drnf2 not requiring ~ ax-7 .  (Contributed by NM,
         25-Nov-2017.) $)
      drnf2w2AUX7 $p |- ( A. x x = y -> ( F/ z ph <-> F/ z ps ) ) $=
        ( weq wal wi wnf dral2w2AUX7 imbi12d df-nf 3bitr4g ) CDGCHZAAEHZIZEHBBE
        HZIZEHAEJBEJQSCDEOABPRFABCDEFKLKAEMBEMN $.
    $}

    $( Weak version of ~ dral2 not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    dral2w3AUX7 $p |- ( A. x x = y -> ( A. x ph <-> A. x ps ) ) $=
      ( weq wal nfa1 albid ) CDFZCGABCJCHEI $.

    $( Weak version of ~ drex2 not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    drex2w3AUX7 $p |- ( A. x x = y -> ( E. x ph <-> E. x ps ) ) $=
      ( weq wal nfa1 exbid ) CDFZCGABCJCHEI $.

    $( Weak version of ~ drnf2 not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    drnf2w3AUX7 $p |- ( A. x x = y -> ( F/ x ph <-> F/ x ps ) ) $=
      ( weq wal wi wnf dral2w3AUX7 imbi12d df-nf 3bitr4g ) CDFCGZAACGZHZCGBBCGZ
      HZCGACIBCIPRCDNABOQEABCDEJKJACLBCLM $.
  $}

  ${
    exdistrf.1NEW7 $e |- ( -. A. x x = y -> F/ y ph ) $.
    $( Distribution of existential quantifiers, with a bound-variable
       hypothesis saying that ` y ` is not free in ` ph ` , but ` x ` can be
       free in ` ph ` (and there is no distinct variable condition on ` x ` and
       ` y ` ).  (Contributed by Mario Carneiro, 20-Mar-2013.)  (Revised by NM,
       25-Nov-2017.)  Revised to prove from ~ ax-7v instead of ~ ax-7 . $)
    exdistrfNEW7 $p |- ( E. x E. y ( ph /\ ps ) -> E. x ( ph /\ E. y ps ) ) $=
      ( weq wal wa wex nfa1 biidd drex1NEW7 exbid nfe1 19.8a anim2i eximi sylbi
      wi 19.9 syl6bir wn nfn 19.40 19.9d anim1d syl5 eximd pm2.61i ) CDFZCGZABH
      ZDIZCIZABDIZHZCIZSUKUNULCIZCIZUQUKURUMCUJCJZULULCDUKULKLMUSURUQURCULCNTUL
      UPCBUOABDOPQRUAUKUBZUMUPCUKCUTUCUMADIZUOHVAUPABDUDVAVBAUOAVADEUEUFUGUHUI
      $.
  $}

  $( Formula-building lemma for use with the Distinctor Reduction Theorem.
     Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  (Contributed
     by NM, 5-Aug-1993.) $)
  drsb1NEW7 $p |- ( A. x x = y -> ( [ z / x ] ph <-> [ z / y ] ph ) ) $=
    ( weq wal wi wa wex wsb equequ1 sps imbi1d anbi1d drex1NEW7 anbi12d 3bitr4g
    wb df-sb ) BCEZBFZBDEZAGZUBAHZBIZHCDEZAGZUFAHZCIZHABDJACDJUAUCUGUEUIUAUBUFA
    TUBUFRBBCDKLZMUDUHBCUAUBUFAUJNOPABDSACDSQ $.

  $( Closed theorem form of ~ spim .  (Contributed by NM, 15-Jan-2008.)
     (Revised by Mario Carneiro, 17-Oct-2016.) $)
  spimtNEW7 $p |- ( ( F/ x ps /\ A. x ( x = y -> ( ph -> ps ) ) ) ->
              ( A. x ph -> ps ) ) $=
    ( wnf weq wi wal wa nfnf1 nfa1 sp adantl nfr adantr embantd imim2d impancom
    nfan alimd ax9oNEW7 syl6 ) BCEZCDFZABGZGZCHZIACHZUDBCHZGZCHZBUCUHUGUKUCUHIZ
    UFUJCUCUHCBCJACKSULUEUIUDULABUIUHAUCACLMUCBUIGUHBCNOPQTRBCDUAUB $.

  ${
    spimNEW.1 $e |- F/ x ps $.
    spimNEW.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Specialization, using implicit substitution.  Compare Lemma 14 of
       [Tarski] p. 70.  The ~ spim series of theorems requires that only one
       direction of the substitution hypothesis hold.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 3-Oct-2016.) $)
    spimNEW7 $p |- ( A. x ph -> ps ) $=
      ( wnf weq wi wal ax-gen spimtNEW7 mp2an ) BCGCDHABIIZCJACJBIENCFKABCDLM
      $.
  $}

  ${
    spimeNEW.1 $e |- F/ x ph $.
    spimeNEW.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Existential introduction, using implicit substitution.  Compare Lemma 14
       of [Tarski] p. 70.  (Contributed by NM, 7-Aug-1994.)  (Revised by Mario
       Carneiro, 3-Oct-2016.) $)
    spimeNEW7 $p |- ( ph -> E. x ps ) $=
      ( wn wal wex nfn weq con3d spimNEW7 con2i df-ex sylibr ) ABGZCHZGBCIRAQAG
      CDACEJCDKABFLMNBCOP $.
  $}

  ${
    spimedNEW.1 $e |- ( ch -> F/ x ph ) $.
    spimedNEW.2 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Deduction version of ~ spime .  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 3-Oct-2016.) $)
    spimedNEW7 $p |- ( ch -> ( ph -> E. x ps ) ) $=
      ( wnf wex wi wa nfnf1 id nfan1 weq adantld spimeNEW7 ex syl ) CADHZABDIZJ
      FTAUATAKBDETADADLTMNDEOABTGPQRS $.
  $}


$( ----------------- $)
  ${
    $d x y $.
    cbv1h.1w $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv1h.2w $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv1h.3w $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Weak version of ~ cbv1h not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbv1hwAUX7 $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( wal wi sps al2imi ax7vAUX7 syl6 weq com23 syl6d ax9oNEW7 a7swAUX7 syld
      ) AEIZDIZBDIZUCEIZCEIZUBUCBEIZDIUDUABUFDABUFJEFKLBDEMNAUDUEJEDADIZUCCEUGU
      CDEOZCDIZJZDICABUJDABUHCUIAUHBCHPGQLCDERNLST $.
  $}

  ${
    $d x y $.
    cbv1.1w $e |- ( ph -> F/ y ps ) $.
    cbv1.2w $e |- ( ph -> F/ x ch ) $.
    cbv1.3w $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Weak version of ~ cbv1 not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbv1wAUX7 $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( nfrd cbv1hwAUX7 ) ABCDEABEFIACDGIHJ $.
  $}

  ${
    $d x y $.
    cbv2h.1w $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv2h.2w $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv2h.3w $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Weak version of ~ cbv2h not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbv2hwAUX7 $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal weq wb wi bi1 syl6 cbv1hwAUX7 equcomi bi2 syl56 a7swAUX7 impbid ) A
      EIDIBDIZCEIZABCDEFGADEJZBCKZBCLHBCMNOAUBUALEDACBEDGFEDJUCAUDCBLEDPHBCQROS
      T $.
  $}

  ${
    $d x y $.
    cbv2.1w $e |- ( ph -> F/ y ps ) $.
    cbv2.2w $e |- ( ph -> F/ x ch ) $.
    cbv2.3w $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Weak version of ~ cbv2 not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbv2wAUX7 $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      ( nfrd cbv2hwAUX7 ) ABCDEABEFIACDGIHJ $.
  $}

  ${
    $d x ph $.  $d x ch $.  $d x y $.
    cbvaldw.1AUX7 $e |- F/ y ph $.
    cbvaldw.2AUX7 $e |- ( ph -> F/ y ps ) $.
    cbvaldw.3AUX7 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Weak version of ~ cbvald not requiring ~ ax-7 .  (Contributed by NM,
       22-May-2018.) $)
    cbvaldwAUX7 $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal wb nfri alrimiv nfvd cbv2wAUX7 syl ) AAEIZDIBDICEIJAPDAEFKLABCDEGAC
      DMHNO $.
  $}

  ${
    $d x y $.
    cbv3d.a $e |- F/ x ph $.
    cbv3d.b $e |- F/ y ph $.
    cbv3d.1w $e |- ( ph -> F/ y ps ) $.
    cbv3d.2w $e |- ( ph -> F/ x ch ) $.
    cbv3d.3w $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Weak deduction version of ~ cbv3 not requiring ~ ax-7 .  (Contributed by
       NM, 22-May-2018.) $)
    cbv3dwAUX7 $p |- ( ph -> ( A. x ps -> A. y ch ) ) $=
      ( wal wi nfri alrimi cbv1wAUX7 syl ) AAEKZDKBDKCEKLAQDFAEGMNABCDEHIJOP $.
  $}

  ${
    $d x y $.
    cbv3.1w $e |- F/ y ph $.
    cbv3.2w $e |- F/ x ps $.
    cbv3.3w $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Weak version of ~ cbv3 not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbv3wAUX7 $p |- ( A. x ph -> A. y ps ) $=
      ( wtru wal wi wnf a1i weq cbv1wAUX7 tru ax-gen mpg ) HDIACIBDIJCHABCDADKH
      ELBCKHFLCDMABJJHGLNHDOPQ $.
  $}

  ${
    $d x y $.
    cbv3h.1w $e |- ( ph -> A. y ph ) $.
    cbv3h.2w $e |- ( ps -> A. x ps ) $.
    cbv3h.3w $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Weak version of ~ cbv3h not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbv3hwAUX7 $p |- ( A. x ph -> A. y ps ) $=
      ( cbv3hvNEW7 ) ABCDEFGH $.
  $}

  ${
    $d x y $.
    cbval.1w $e |- F/ y ph $.
    cbval.2w $e |- F/ x ps $.
    cbval.3w $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ cbval not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbvalwwAUX7 $p |- ( A. x ph <-> A. y ps ) $=
      ( wal weq biimpd cbv3wAUX7 wi biimprd equcoms impbii ) ACHBDHABCDEFCDIZAB
      GJKBADCFEBALCDPABGMNKO $.
  $}

  ${
    $d x y $.
    cbvex.1w $e |- F/ y ph $.
    cbvex.2w $e |- F/ x ps $.
    cbvex.3w $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Weak version of ~ cbvex not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    cbvexwAUX7 $p |- ( E. x ph <-> E. y ps ) $=
      ( wn wal wex nfn weq notbid cbvalwwAUX7 notbii df-ex 3bitr4i ) AHZCIZHBHZ
      DIZHACJBDJSUARTCDADEKBCFKCDLABGMNOACPBDPQ $.
  $}
$( ----------------- $)


  ${
    $d x ps $.
    spimv.1NEW $e |- ( x = y -> ( ph -> ps ) ) $.
    $( A version of ~ spim with a distinct variable requirement instead of a
       bound variable hypothesis.  (Contributed by NM, 5-Aug-1993.) $)
    spimvNEW7 $p |- ( A. x ph -> ps ) $=
      ( nfv spimNEW7 ) ABCDBCFEG $.
  $}

  ${
    $d t u v $.  $d t u x y $.  $d u w $.  $d x z $.
    $( Weak version of ~ aev not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    aevwAUX7 $p |- ( A. x x = y -> A. z w = v ) $=
      ( vu weq wal hbaewAUX7 ax10lem5NEW7 ax-8 spimvNEW7 syl alrimih ) ABGAHZDE
      GZCABCIOFEGZFHPEFABJQPFDFDEKLMN $.
  $}

  ${
    $d x y $.  $d x u $.  $d t u $.  $d z u $.
    $( A "distinctor elimination" lemma with no restrictions on variables in
       the consequent.  (Contributed by NM, 8-Nov-2006.) $)
    aevNEW7 $p |- ( A. x x = y -> A. z w = v ) $=
      ( vu vt weq wal aevwAUX7 syl ) ABHAIFGHFIDEHCIABFFGJFGCDEJK $.
  $}

  ${
    $d x y u v $.  $d z u v $.
    $( Weak version of ~ hbae not requiring ~ ax-7 .  Has different distinct
       variable requirements from ~ hbaewAUX7 .  (Contributed by NM,
       30-Oct-2017.) $)
    hbaew3AUX7 $p |- ( A. x x = y -> A. z A. x x = y ) $=
      ( vu vv weq wal aevNEW7 alrimiv syl ) ABFAGZDEFDGZKCGABDDEHLKCDEAABHIJ $.
  $}

  ${
    $d x y $.
    $( Weak version of ~ nfae not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    nfaew3AUX7 $p |- F/ z A. x x = y $=
      ( weq wal hbaew3AUX7 nfi ) ABDAECABCFG $.

    $( Weak version of ~ nfnae not requiring ~ ax-7 .  (Contributed by NM,
       25-Nov-2017.) $)
    nfnaew3AUX7 $p |- F/ z -. A. x x = y $=
      ( weq wal nfaew3AUX7 nfn ) ABDAECABCFG $.
  $}

  $( A variable introduction law for equality.  Lemma 15 of [Monk2] p. 109,
     however we do not require ` z ` to be distinct from ` x ` and ` y `
     (making the proof longer).  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 25-May-2011.) $)
  equviniNEW7 $p |- ( x = y -> E. z ( x = z /\ z = y ) ) $=
    ( weq wal wa wex wi equcomi alimi a9eNEW7 jctir a1d syl6 eximii a1ii anc2ri
    19.29 19.29r wn ioran nfeqfNEW7 ax-8 anc2li equcoms spimedNEW7 sylbi ecase3
    wo ) CADZCEZCBDZCEZABDZACDZULFZCGZHZUKUNUOCEZULCGZFZUQUKVAUNUKUSUTUJUOCCAIZ
    JCBKLMUOULCRNUMUNUOCGZUMFUQUMUNVCUMUNVCUJUOCCAKVBOPQUOULCSNUKUMUITUKTUMTFZU
    RUKUMUAUNUPVDCAABCUBUNUPHACUOUNULACBUCUDUEUFUGUH $.

  $( A variable elimination law for equality with no distinct variable
     requirements.  (Compare ~ equviniNEW7 .)  (Contributed by NM,
     1-Mar-2013.)  (Proof shortened by Mario Carneiro, 17-Oct-2016.)  (Revised
     by NM, 25-Nov-2017.)  Revised to prove from ~ ax-7v instead of ~ ax-7 . $)
  equveliNEW7 $p |- ( A. z ( z = x <-> z = y ) -> x = y ) $=
    ( weq wb wal wi wa albiim equequ1 imbi12d sps dral1NEW7 equid sp mpi syl6bi
    equcomi wn pm2.61i syl adantld dral2w3AUX7 a1bi biimpri a1d nfeqfNEW7 equtr
    wnf ax-8 imim12d mpii ax-gen spimtNEW7 sylancl ex adantrd sylbi ) CADZCBDZE
    CFUSUTGZCFZUTUSGZCFZHZABDZUSUTCIUTCFZVEVFGVGVDVFVBVGVDBBDZBADZGZBFZVFVCVJCB
    UTVCVJECUTUTVHUSVICBBJCBAJKLMVKVIVFVKVHVIBNVJBOPBARUAQUBVGSZVBVFVDUSCFZVLVB
    VFGZGVMVNVLVMVBAADZVFGZCFVFVAVPCAUSVAVPECUSUSVOUTVFCAAJCABJKLUCVPVFCVFVPVOV
    FANZUDUELQUFVMSZVLVNVRVLHVFCUIUSVAVFGGZCFVNABCUGVSCUSVAVOVFVQUSVOUSUTVFCAAU
    HCABUJUKULUMVAVFCAUNUOUPTUQTUR $.

  ${
    $d x z $.  $d y z $.
    $( A variable introduction law for equality.  Lemma 15 of [Monk2] p. 109.
       (Contributed by NM, 5-Aug-1993.) $)
    equvinNEW7 $p |- ( x = y <-> E. z ( x = z /\ z = y ) ) $=
      ( weq wa wex equviniNEW7 equtr imp exlimiv impbii ) ABDZACDZCBDZEZCFABCGO
      LCMNLACBHIJK $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11v2.1NEW $e |- ( x = z -> ( ph -> A. x ( x = z -> ph ) ) ) $.
    $( Recovery of ~ ax-11o from ~ ax11v .  This proof uses ~ ax-10 and
       ~ ax-11 .  TODO: figure out if this is useful, or if it should be
       simplified or eliminated.  (Contributed by NM, 2-Feb-2007.) $)
    ax11v2NEW7 $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( weq wal wn wex wi a9ev wa equequ2 adantl dveeq2NEW7 imp nfa1 imbi1d sps
      wb albid syl imbi2d imbi12d mpbii ex exlimdv mpi ) BCFZBGHZDCFZDIUIAUIAJZ
      BGZJZJZDCKUJUKUODUJUKUOUJUKLZBDFZAUQAJZBGZJZJUOEUPUQUIUTUNUKUQUITUJDCBMZN
      UPUSUMAUPUKBGZUSUMTUJUKVBBCDOPVBURULBUKBQUKURULTBUKUQUIAVARSUAUBUCUDUEUFU
      GUH $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    ax11a2.1NEW $e |- ( x = z -> ( A. z ph -> A. x ( x = z -> ph ) ) ) $.
    $( Derive ~ ax-11o from a hypothesis in the form of ~ ax-11 . ~ ax-10 and
       ~ ax-11 are used by the proof, but not ~ ax-10o or ~ ax-11o .  TODO:
       figure out if this is useful, or if it should be simplified or
       eliminated.  (Contributed by NM, 2-Feb-2007.) $)
    ax11a2NEW7 $p |- ( -. A. x x = y ->
                 ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( wal weq wi ax-17 syl5 ax11v2NEW7 ) ABCDAADFBDGZLAHBFADIEJK $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( Derivation of set.mm's original ~ ax-11o from ~ ax-10 and the shorter
       ~ ax-11 that has replaced it.

       An open problem is whether this theorem can be proved without relying on
       ~ ax-16 or ~ ax-17 (given all of the original and new versions of ~ sp
       through ~ ax-15 ).

       Another open problem is whether this theorem can be proved without
       relying on ~ ax12o .

       Theorem ~ ax11 shows the reverse derivation of ~ ax-11 from ~ ax-11o .

       Normally, ~ ax11o should be used rather than ~ ax-11o , except by
       theorems specifically studying the latter's properties.  (Contributed by
       NM, 3-Feb-2007.) $)
    ax11oNEW7 $p |- ( -. A. x x = y ->
               ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) ) $=
      ( vz ax-11 ax11a2NEW7 ) ABCDABDEF $.
  $}

  $( Lemma used in proofs of substitution properties.  (Contributed by NM,
     5-Aug-1993.)  (Proof shortened by Mario Carneiro, 20-May-2014.) $)
  equs4NEW7 $p |- ( A. x ( x = y -> ph ) -> E. x ( x = y /\ ph ) ) $=
    ( weq wi wal wa wex a9eNEW7 19.29 mpan2 ancl imp eximi syl ) BCDZAEZBFZQPGZ
    BHZPAGZBHRPBHTBCIQPBJKSUABQPUAPALMNO $.

  $( Lemma used in proofs of substitution properties.  (Contributed by NM,
     5-Aug-1993.) $)
  equs5NEW7 $p |- ( -. A. x x = y ->
             ( E. x ( x = y /\ ph ) -> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wa wi hbn1 hba1 ax11oNEW7 imp3a exlimdh ) BCDZBEFZNAGNAHZBEZBN
    BIPBJONAQABCKLM $.

  $( Lemma used in proofs of substitution properties.  (Contributed by NM,
     27-Oct-2017.) $)
  equs5bAUX7 $p |- ( -. A. x x = y ->
             ( E. x ( x = y /\ ph ) <-> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wa wex wi equs5NEW7 equs4NEW7 impbid1 ) BCDZBEFMAGBHMAIBEABCJA
    BCKL $.

  ${
    $d w y $.  $d w z $.  $d w x $.  $( ` w ` is dummy. $)
    $( Axiom ~ ax-15 is redundant if we assume ~ ax-17 .  Remark 9.6 in
       [Megill] p. 448 (p. 16 of the preprint), regarding axiom scheme C14'.

       Note that ` w ` is a dummy variable introduced in the proof.  On the web
       page, it is implicitly assumed to be distinct from all other variables.
       (This is made explicit in the database file set.mm).  Its purpose is to
       satisfy the distinct variable requirements of ~ dveel2 and ~ ax-17 .  By
       the end of the proof it has vanished, and the final theorem has no
       distinct variable requirements.  (Contributed by NM, 29-Jun-1995.) $)
    ax15NEW7 $p |- ( -. A. z z = x -> ( -. A. z z = y ->
              ( x e. y -> A. z x e. y ) ) ) $=
      ( vw weq wal wn wel wi hbn1 dveel2NEW7 elequ1 imbi2d dvelimwAUX7 nfa1 nfn
      hbim1 19.21 syl6ib pm2.86d ) CAECFGZCBEZCFZGZABHZUECFZUAUDUEIZUGCFUDUFIUD
      DBHZIUGCADUDUHCUBCJCBDKQDAEUHUEUDDABLMNUDUECUCCUBCOPRST $.
  $}

  $( One direction of a simplified definition of substitution.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb2NEW7 $p |- ( A. x ( x = y -> ph ) -> [ y / x ] ph ) $=
    ( weq wi wal wa wex wsb sp equs4NEW7 df-sb sylanbrc ) BCDZAEZBFONAGBHABCIOB
    JABCKABCLM $.

  $( Substitution applied to an atomic wff.  (Contributed by NM,
     5-Aug-1993.) $)
  equsb1NEW7 $p |- [ y / x ] x = y $=
    ( weq wi wsb sb2NEW7 id mpg ) ABCZIDIABEAIABFIGH $.

  $( Substitution applied to an atomic wff.  (Contributed by NM,
     5-Aug-1993.) $)
  equsb2NEW7 $p |- [ y / x ] y = x $=
    ( weq wi wsb sb2NEW7 equcomi mpg ) ABCBACZDIABEAIABFABGH $.

  ${
    sbiedNEW.1 $e |- F/ x ph $.
    sbiedNEW.2 $e |- ( ph -> F/ x ch ) $.
    sbiedNEW.3 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Conversion of implicit substitution to explicit substitution (deduction
       version of ~ sbie ).  (Contributed by NM, 30-Jun-1994.)  (Revised by
       Mario Carneiro, 4-Oct-2016.) $)
    sbiedNEW7 $p |- ( ph -> ( [ y / x ] ps <-> ch ) ) $=
      ( wsb wex weq wa sb1 wb wi bi1 syl6 imp3a syld wal eximd syl5 19.9d com23
      nfrd bi2 alimd sb2NEW7 impbid ) ABDEIZCAUJCDJZCUJDEKZBLZDJAUKBDEMAUMCDFAU
      LBCAULBCNZBCOHBCPQRUAUBCADGUCSACCDTZUJACDGUEAUOULBOZDTUJACUPDFAULCBAULUNC
      BOHBCUFQUDUGBDEUHQSUI $.
  $}

  ${
    sbieNEW.1 $e |- F/ x ps $.
    sbieNEW.2 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Conversion of implicit substitution to explicit substitution.
       (Contributed by NM, 30-Jun-1994.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sbieNEW7 $p |- ( [ y / x ] ph <-> ps ) $=
      ( wsb wb wtru nftru wnf a1i weq wi sbiedNEW7 trud ) ACDGBHIABCDCJBCKIELCD
      MABHNIFLOP $.
  $}

  $( Special case of a bound-variable hypothesis builder for substitution.
     (Contributed by NM, 2-Feb-2007.) $)
  hbsb2aNEW7 $p |- ( [ y / x ] A. y ph -> A. x [ y / x ] ph ) $=
    ( wal wsb weq wi sb4a sb2NEW7 a5i syl ) ACDBCEBCFAGZBDABCEZBDABCHLMBABCIJK
    $.

  $( Special case of a bound-variable hypothesis builder for substitution.
     (Contributed by NM, 2-Feb-2007.) $)
  hbsb2eNEW7 $p |- ( [ y / x ] ph -> A. x [ y / x ] E. y ph ) $=
    ( wsb weq wex wi wal sb4e sb2NEW7 a5i syl ) ABCDBCEACFZGZBHMBCDZBHABCINOBMB
    CJKL $.

  ${
    hbsb3.1NEW $e |- ( ph -> A. y ph ) $.
    $( If ` y ` is not free in ` ph ` , ` x ` is not free in
       ` [ y / x ] ph ` .  (Contributed by NM, 5-Aug-1993.) $)
    hbsb3NEW7 $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      ( wsb wal sbimi hbsb2aNEW7 syl ) ABCEZACFZBCEJBFAKBCDGABCHI $.
  $}

  ${
    nfs1.1NEW $e |- F/ y ph $.
    $( If ` y ` is not free in ` ph ` , ` x ` is not free in
       ` [ y / x ] ph ` .  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfs1NEW7 $p |- F/ x [ y / x ] ph $=
      ( wsb nfri hbsb3NEW7 nfi ) ABCEBABCACDFGH $.
  $}

  ${
    $d x y $.  $d w ph $.  $d w z $.
    $( Generalization of ~ ax16 .  (Contributed by NM, 25-Jul-2015.) $)
    a16gNEW7 $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      ( vw weq wex wal wi a9ev ax10lem5NEW7 wn hbn1 pm2.21 alrimih ax-1 equcomi
      ax-17 ja ax-11 syl2im ax-5 syl6 com23 syl5 exlimih mpsyl ) EDFZEGBCFBHUHE
      HZAADHZIZEDJDEBCKUHUIUKIZEUIUKULEHUILULEUHEMUIUKNOUKULEUKERUKUIPOSUIDEFZD
      HZUHUKEDEDKUHAUNUJUHAUMAIDHZUNUJIUHUMAAEHUOEDQAERADETUAUMADUBUCUDUEUFUG
      $.

    $( A generalization of axiom ~ ax-16 .  (Contributed by NM, 5-Aug-1993.) $)
    a16gbNEW7 $p |- ( A. x x = y -> ( ph <-> A. z ph ) ) $=
      ( weq wal a16gNEW7 sp impbid1 ) BCEBFAADFABCDGADHI $.

    $d x z $.
    $( Weak version of ~ a16nf not requiring ~ ax-7 .  (Contributed by NM,
       10-Oct-2017.) $)
    a16nfwAUX7 $p |- ( A. x x = y -> F/ z ph ) $=
      ( weq wal nfaewAUX7 a16gNEW7 nfd ) BCEBFADBCDGABCDHI $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Proof of older axiom ~ ax-16 .  (Contributed by NM, 8-Nov-2006.)
       (Revised by NM, 22-Sep-2017.) $)
    ax16NEW7 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( a16gNEW7 ) ABCBD $.
  $}

  ${
    $d x y $.  $d w z $.
    $( If ~ dtru is false, then there is only one element in the universe, so
       everything satisfies ` F/ ` .  (Contributed by Mario Carneiro,
       7-Oct-2016.)  (Revised by NM, 25-Nov-2017.)  Revised to prove from
       ~ ax-7v instead of ~ ax-7 . $)
    a16nfNEW7 $p |- ( A. x x = y -> F/ z ph ) $=
      ( vw weq wal wnf aevNEW7 nfa1 ax16NEW7 nfd syl ) BCFBGDEFZDGZADHBCDDEIOAD
      NDJADEKLM $.
  $}

  ${
    $d x y z $.  $d z ph $.
    ax16i.1NEW $e |- ( x = z -> ( ph <-> ps ) ) $.
    ax16i.2NEW $e |- ( ps -> A. x ps ) $.
    $( Inference with ~ ax16 as its conclusion.  (Contributed by NM,
       20-May-2008.)  (Proof modification is discouraged.) $)
    ax16iNEW7 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( weq wal wi nfv ax-8 cbv3wAUX7 spimvNEW7 equcomi syl syl5com mpcom alimi
      alimdv biimpcd nfi biimprd syl6com 3syl ) CDHZCIEDHZEIZCEHZEIZAACIZJUFUGC
      EUFEKUGCKCEDLMUHECHZEIZUJUFUHUMUGUFECECDLNUFUGULEUFDCHZUGULCDOUGDEHUNULJE
      DODECLPQTRULUIEECOZSPAUJBEIUKAUIBEUIABFUATBAECBCGUBAEKULUIBAJUOUIABFUCPMU
      DUE $.
  $}

  $( One direction of a simplified definition of substitution when variables
     are distinct.  (Contributed by NM, 5-Aug-1993.) $)
  sb4NEW7 $p |- ( -. A. x x = y
      -> ( [ y / x ] ph -> A. x ( x = y -> ph ) ) ) $=
    ( wsb weq wa wex wal wn wi sb1 equs5NEW7 syl5 ) ABCDBCEZAFBGNBHINAJBHABCKAB
    CLM $.

  $( Simplified definition of substitution when variables are distinct.
     (Contributed by NM, 27-May-1997.) $)
  sb4bNEW7 $p |- ( -. A. x x = y
      -> ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wsb wi sb4NEW7 sb2NEW7 impbid1 ) BCDZBEFABCGLAHBEABCIABCJK $.

  $( Bound-variable hypothesis builder for substitution.  (Contributed by NM,
     5-Aug-1993.) $)
  hbsb2NEW7 $p |- ( -. A. x x = y -> ( [ y / x ] ph -> A. x [ y / x ] ph ) ) $=
    ( weq wal wn wsb wi sb4NEW7 sb2NEW7 a5i syl6 ) BCDZBEFABCGZMAHZBENBEABCIONB
    ABCJKL $.

  $( The specialization axiom of standard predicate calculus.  It states that
     if a statement ` ph ` holds for all ` x ` , then it also holds for the
     specific case of ` y ` (properly) substituted for ` x ` .  Translated to
     traditional notation, it can be read:  " ` A. x ph ( x ) -> ph ( y ) ` ,
     provided that ` y ` is free for ` x ` in ` ph ( x ) ` ."  Axiom 4 of
     [Mendelson] p. 69.  See also ~ spsbc and ~ rspsbc .  (Contributed by NM,
     5-Aug-1993.) $)
  stdpc4NEW7 $p |- ( A. x ph -> [ y / x ] ph ) $=
    ( wal weq wi wsb ax-1 alimi sb2NEW7 syl ) ABDBCEZAFZBDABCGAMBALHIABCJK $.

  $( Substitution has no effect on a non-free variable.  (Contributed by NM,
     30-May-2009.)  (Revised by Mario Carneiro, 12-Oct-2016.) $)
  sbftNEW7 $p |- ( F/ x ph -> ( [ y / x ] ph <-> ph ) ) $=
    ( wnf wsb weq wa wex sb1 wal simpr ax-gen 19.23t mpbii syl5 stdpc4NEW7 syl6
    wi nfr impbid ) ABDZABCEZAUBBCFZAGZBHZUAAABCIUAUDARZBJUEARUFBUCAKLUDABMNOUA
    AABJUBABSABCPQT $.

  ${
    sbfNEW.1 $e |- F/ x ph $.
    $( Substitution for a variable not free in a wff does not affect it.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sbfNEW7 $p |- ( [ y / x ] ph <-> ph ) $=
      ( wnf wsb wb sbftNEW7 ax-mp ) ABEABCFAGDABCHI $.
  $}

  ${
    $d x z $.
    $( Weak version of ~ sbequ5 not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    sbequ5wAUX7 $p |- ( [ w / z ] A. x x = y <-> A. x x = y ) $=
      ( weq wal nfaewAUX7 sbfNEW7 ) ABEAFCDABCGH $.
  $}

  ${
    sbh.1NEW $e |- ( ph -> A. x ph ) $.
    $( Substitution for a variable not free in a wff does not affect it.
       (Contributed by NM, 5-Aug-1993.) $)
    sbhNEW7 $p |- ( [ y / x ] ph <-> ph ) $=
      ( nfi sbfNEW7 ) ABCABDEF $.
  $}

  $( Substitution has no effect on a bound variable.  (Contributed by NM,
     1-Jul-2005.) $)
  sbf2NEW7 $p |- ( [ y / x ] A. x ph <-> A. x ph ) $=
    ( wal nfa1 sbfNEW7 ) ABDBCABEF $.

  $( Bound-variable hypothesis builder for substitution.  (Contributed by Mario
     Carneiro, 4-Oct-2016.) $)
  nfsb2NEW7 $p |- ( -. A. x x = y -> F/ x [ y / x ] ph ) $=
    ( weq wal wn wsb nfa1 nfn hbsb2NEW7 nfd ) BCDZBEZFABCGBMBLBHIABCJK $.

  $( Negation inside and outside of substitution are equivalent.  (Contributed
     by NM, 5-Aug-1993.) $)
  sbnNEW7 $p |- ( [ y / x ] -. ph <-> -. [ y / x ] ph ) $=
    ( wn wsb weq wal wi sbequ2 nsyld sps sb4NEW7 wex sb1 equs3 sylib con2i syl6
    wa sylibr pm2.61i sbequ1 con3rr3 sb2NEW7 notnot sbbii con3i sylanbrc impbii
    df-sb ) ADZBCEZABCEZDZBCFZBGZULUNHZUOUQBUOULAUMUKBCIABCIJKUPDULUOUKHZBGZUNU
    KBCLUMUSUMUOASBMUSDABCNABCOPQRUAUNURUOUKSBMZULUOAUMABCUBUCUNUOUKDZHBGZDUTVB
    UMVBVABCEUMVABCUDAVABCAUEUFTUGUKBCOTUKBCUJUHUI $.

  $( Removal of implication from substitution.  (Contributed by NM,
     5-Aug-1993.) $)
  sbi1NEW7 $p |- ( [ y / x ] ( ph -> ps )
      -> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    ( weq wal wi wsb sbequ2 syl5d sbequ1 syl6d sps wn sb4NEW7 ax-2 sb2NEW7 syl6
    al2imi pm2.61i ) CDEZCFZABGZCDHZACDHZBCDHZGGZUAUGCUAUDUEBUFUAUEAUDBACDIUCCD
    IJBCDKLMUBNZUEUAAGZCFZUDUFACDOUHUDUAUCGZCFZUJUFGUCCDOULUJUABGZCFUFUKUIUMCUA
    ABPSBCDQRRJT $.

  $( Introduction of implication into substitution.  (Contributed by NM,
     5-Aug-1993.) $)
  sbi2NEW7 $p |- ( ( [ y / x ] ph -> [ y / x ] ps )
      -> [ y / x ] ( ph -> ps ) ) $=
    ( wsb wi wn sbnNEW7 pm2.21 sbimi sylbir ax-1 ja ) ACDEZBCDEABFZCDEZNGAGZCDE
    PACDHQOCDABIJKBOCDBALJM $.

  $( Implication inside and outside of substitution are equivalent.
     (Contributed by NM, 5-Aug-1993.) $)
  sbimNEW7 $p |- ( [ y / x ] ( ph -> ps )
      <-> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    ( wi wsb sbi1NEW7 sbi2NEW7 impbii ) ABECDFACDFBCDFEABCDGABCDHI $.

  $( Logical OR inside and outside of substitution are equivalent.
     (Contributed by NM, 29-Sep-2002.) $)
  sborNEW7 $p |- ( [ y / x ] ( ph \/ ps )
      <-> ( [ y / x ] ph \/ [ y / x ] ps ) ) $=
    ( wn wi wsb wo sbimNEW7 sbnNEW7 imbi1i bitri df-or sbbii 3bitr4i ) AEZBFZCD
    GZACDGZEZBCDGZFZABHZCDGSUAHRPCDGZUAFUBPBCDIUDTUAACDJKLUCQCDABMNSUAMO $.

  ${
    sbrimNEW.1 $e |- F/ x ph $.
    $( Substitution with a variable not free in antecedent affects only the
       consequent.  (Contributed by NM, 5-Aug-1993.)  (Revised by Mario
       Carneiro, 4-Oct-2016.) $)
    sbrimNEW7 $p |- ( [ y / x ] ( ph -> ps ) <-> ( ph -> [ y / x ] ps ) ) $=
      ( wi wsb sbimNEW7 sbfNEW7 imbi1i bitri ) ABFCDGACDGZBCDGZFAMFABCDHLAMACDE
      IJK $.
  $}

  ${
    sblim.1NEW $e |- F/ x ps $.
    $( Substitution with a variable not free in consequent affects only the
       antecedent.  (Contributed by NM, 14-Nov-2013.)  (Revised by Mario
       Carneiro, 4-Oct-2016.) $)
    sblimNEW7 $p |- ( [ y / x ] ( ph -> ps ) <-> ( [ y / x ] ph -> ps ) ) $=
      ( wi wsb sbimNEW7 sbfNEW7 imbi2i bitri ) ABFCDGACDGZBCDGZFLBFABCDHMBLBCDE
      IJK $.
  $}

  $( Conjunction inside and outside of a substitution are equivalent.
     (Contributed by NM, 5-Aug-1993.) $)
  sbanNEW7 $p |- ( [ y / x ] ( ph /\ ps )
      <-> ( [ y / x ] ph /\ [ y / x ] ps ) ) $=
    ( wn wi wsb wa sbnNEW7 sbimNEW7 imbi2i bitri xchbinx df-an sbbii 3bitr4i )
    ABEZFZEZCDGZACDGZBCDGZEZFZEABHZCDGUAUBHTRCDGZUDRCDIUFUAQCDGZFUDAQCDJUGUCUAB
    CDIKLMUESCDABNOUAUBNP $.

  $( Equivalence inside and outside of a substitution are equivalent.
     (Contributed by NM, 5-Aug-1993.) $)
  sbbiNEW7 $p |- ( [ y / x ] ( ph <-> ps )
     <-> ( [ y / x ] ph <-> [ y / x ] ps ) ) $=
    ( wb wsb wi wa dfbi2 sbbii sbimNEW7 anbi12i sbanNEW7 3bitr4i bitri ) ABEZCD
    FABGZBAGZHZCDFZACDFZBCDFZEZPSCDABIJQCDFZRCDFZHUAUBGZUBUAGZHTUCUDUFUEUGABCDK
    BACDKLQRCDMUAUBINO $.

  $( A specialization theorem.  (Contributed by NM, 5-Aug-1993.) $)
  spsbeNEW7 $p |- ( [ y / x ] ph -> E. x ph ) $=
    ( wsb wn wal wex stdpc4NEW7 sbnNEW7 sylib con2i df-ex sylibr ) ABCDZAEZBFZE
    ABGPNPOBCDNEOBCHABCIJKABLM $.

  $( Specialization of implication.  (Contributed by NM, 5-Aug-1993.)  (Proof
     shortened by Andrew Salmon, 25-May-2011.) $)
  spsbimNEW7 $p |- ( A. x ( ph -> ps ) -> ( [ y / x ] ph -> [ y / x ] ps ) ) $=
    ( wi wal wsb stdpc4NEW7 sbi1NEW7 syl ) ABEZCFKCDGACDGBCDGEKCDHABCDIJ $.

  $( Specialization of biconditional.  (Contributed by NM, 5-Aug-1993.) $)
  spsbbiNEW7 $p |- ( A. x ( ph <-> ps )
      -> ( [ y / x ] ph <-> [ y / x ] ps ) ) $=
    ( wb wal wsb stdpc4NEW7 sbbiNEW7 sylib ) ABEZCFKCDGACDGBCDGEKCDHABCDIJ $.

  ${
    sbbidNEW.1 $e |- F/ x ph $.
    sbbidNEW.2 $e |- ( ph -> ( ps <-> ch ) ) $.
    $( Deduction substituting both sides of a biconditional.  (Contributed by
       NM, 5-Aug-1993.) $)
    sbbidNEW7 $p |- ( ph -> ( [ y / x ] ps <-> [ y / x ] ch ) ) $=
      ( wb wal wsb alrimi spsbbiNEW7 syl ) ABCHZDIBDEJCDEJHANDFGKBCDELM $.
  $}

  $( Elimination of equality from antecedent after substitution.  (Contributed
     by NM, 5-Aug-1993.) $)
  sbequ8NEW7 $p |- ( [ y / x ] ph <-> [ y / x ] ( x = y -> ph ) ) $=
    ( wsb weq wi equsb1NEW7 a1bi sbimNEW7 bitr4i ) ABCDZBCEZBCDZKFLAFBCDMKBCGHL
    ABCIJ $.

  ${
    $d x z $.
    $( Weak version of ~ nfsb4t not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    nfsb4twAUX7 $p |- ( A. x F/ z ph ->
                   ( -. A. z z = y -> F/ z [ y / x ] ph ) ) $=
      ( wnf wal weq wn wsb wi wa sbequ12 sps drnf2wAUX7 biimpcd a1dd nfnaewAUX7
      wb nfa1 nfan nfeqfNEW7 adantl sp adantr nfimd nfaldwAUX7 ex nfbidf imbi2d
      sb4bNEW7 syl5ibrcom pm2.61d exp3a nfsb2NEW7 drsb1NEW7 aecomsNEW7 pm2.61d2
      bicomd syl5ib ) ADEZBFZDBGDFZDCGDFHZABCIZDEZJVAVBHZVCVEVABCGZBFZVFVCKZVEJ
      ZVAVHVEVIUTVHVEJBVHUTVEAVDBCDVGAVDRBABCLMNOMPVAVJVHHZVIVGAJZBFZDEZJVAVIVN
      VAVIKZVLDBVAVIBUTBSVFVCBDBBQDCBQTTVOVGADVIVGDEVABCDUAUBVAUTVIUTBUCUDUEUFU
      GVKVEVNVIVKVDVMDBCDQABCUJUHUIUKULUMVCADCIZDEZVBVEADCUNVQVERBDBDGBFVEVQVDV
      PBDDABDCUONURUPUSUQ $.

    ${
      nfsb4.1w $e |- F/ z ph $.
      $( Weak version of ~ nfsb4t not requiring ~ ax-7 .  (Contributed by NM,
         27-Oct-2017.) $)
      nfsb4wAUX7 $p |- ( -. A. z z = y -> F/ z [ y / x ] ph ) $=
        ( wnf weq wal wn wsb wi nfsb4twAUX7 mpg ) ADFDCGDHIABCJDFKBABCDLEM $.
    $}
  $}

  ${
    $d y z $.  $d x z $.
    nfsbd.1wAUX7 $e |- F/ x ph $.
    nfsbd.2WAUX7 $e |- ( ph -> F/ z ps ) $.
    $( Deduction version of ~ nfsbwAUX7 .  (Contributed by NM, 24-May-2018.) $)
    nfsbdwAUX7 $p |- ( ph -> F/ z [ y / x ] ps ) $=
      ( weq wal wsb wnf wn wi alrimi nfsb4twAUX7 syl a16nfNEW7 pm2.61d2 ) AEDHE
      IZBCDJZEKZABEKZCISLUAMAUBCFGNBCDEOPTEDEQR $.
  $}

  $( An equality theorem for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbequiNEW7 $p |- ( x = y -> ( [ x / z ] ph -> [ y / z ] ph ) ) $=
    ( weq wal wsb wi wn wex hbsb2NEW7 stdpc7 sbequ1 sylan9 sps adantr drsb1NEW7
    wa ex syld equviniNEW7 eximi 19.35 sylib nfsb2NEW7 19.9d syl9 com23 biimprd
    syl sbequ2 sylan9r biimpd pm2.61ii ) DBEZDFZDCEZDFZBCEZADBGZADCGZHZHUPIZUSU
    RIZVBVCUSVDVBHVCUSRUTVADJZVDVAVCUTUTDFZUSVEADBKUSVBDJZVFVEHUSBDEZUQRZDJVGBC
    DUAVIVBDVHUTAUQVAABDLADCMZNUBUJUTVADUCUDNVAVDDADCUEUFUGSUHUPUSVBUPUSRUTAVAU
    PUTAHZUSUOVKDADBUKOPUSAABCGZUPVAABCMUPVAVLADBCQUIULTSURUSVBURUSRUTAVAURUTAC
    BGZUSAURUTVMADCBQUMABCLNURAVAHZUSUQVNDVJOPTSUN $.

  $( An equality theorem for substitution.  Used in proof of Theorem 9.7 in
     [Megill] p. 449 (p. 16 of the preprint).  (Contributed by NM,
     5-Aug-1993.) $)
  sbequNEW7 $p |- ( x = y -> ( [ x / z ] ph <-> [ y / z ] ph ) ) $=
    ( weq wsb sbequiNEW7 wi equcoms impbid ) BCEADBFZADCFZABCDGLKHCBACBDGIJ $.

  $( Formula-building lemma for use with the Distinctor Reduction Theorem.
     Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).  (Contributed
     by NM, 27-Feb-2005.) $)
  drsb2NEW7 $p |- ( A. x x = y -> ( [ x / z ] ph <-> [ y / z ] ph ) ) $=
    ( weq wsb wb sbequNEW7 sps ) BCEADBFADCFGBABCDHI $.

  $( A composition law for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbcoNEW7 $p |- ( [ y / x ] [ x / y ] ph <-> [ y / x ] ph ) $=
    ( wsb wb weq equsb2NEW7 sbequ12 bicomd sbimi ax-mp sbbiNEW7 mpbi ) ACBDZAEZ
    BCDZNBCDABCDECBFZBCDPBCGQOBCQANACBHIJKNABCLM $.

  ${
    sbid2.1NEW $e |- F/ x ph $.
    $( An identity law for substitution.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sbid2NEW7 $p |- ( [ y / x ] [ x / y ] ph <-> ph ) $=
      ( wsb sbcoNEW7 sbfNEW7 bitri ) ACBEBCEABCEAABCFABCDGH $.
  $}

  $( An idempotent law for substitution.  (Contributed by NM, 30-Jun-1994.)
     (Proof shortened by Andrew Salmon, 25-May-2011.) $)
  sbidmNEW7 $p |- ( [ y / x ] [ y / x ] ph <-> [ y / x ] ph ) $=
    ( wsb wb weq equsb2NEW7 sbequ12r sbimi ax-mp sbbiNEW7 mpbi ) ABCDZAEZBCDZMB
    CDMECBFZBCDOBCGPNBCACBHIJMABCKL $.

  ${
    $d x z $.
    sbco2w.1 $e |- F/ z ph $.
    $( Weak version of ~ sbco2 not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    sbco2wAUX7 $p |- ( [ y / z ] [ z / x ] ph <-> [ y / x ] ph ) $=
      ( weq wal wsb wb sbid2NEW7 sbequNEW7 syl5bbr sbequ12 bitr3d nfa1 nfs1NEW7
      sps wn nfn nfsb4wAUX7 wi a1i sbiedNEW7 bicomd pm2.61i ) BCFZBGZABDHZDCHZA
      BCHZIZUFUKBUFAUIUJAUHDBHUFUIADBEJUHBCDKLZABCMNQUGRZUJUIUMAUIBCUGBUFBOSUHD
      CBABDEPTUFAUIIUAUMULUBUCUDUE $.
  $}

  ${
    $d x z $.
    sbco2dw.1 $e |- F/ x ph $.
    sbco2dw.2 $e |- F/ z ph $.
    sbco2dw.3 $e |- ( ph -> F/ z ps ) $.
    $( Weak version of ~ sbco2d not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    sbco2dwAUX7 $p |- ( ph -> ( [ y / z ] [ z / x ] ps <-> [ y / x ] ps ) ) $=
      ( wsb wi nfim1 sbco2wAUX7 sbrimNEW7 sbbii bitri 3bitr3i pm5.74ri ) ABCEIZ
      EDIZBCDIZABJZCEIZEDIZUACDIASJZATJUACDEABEGHKLUCARJZEDIUDUBUEEDABCEFMNARED
      GMOABCDFMPQ $.
  $}

  ${
    $d x y $.
    $( Weak version of ~ sbco3 not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    sbco3wAUX7 $p |- ( [ z / y ] [ y / x ] ph <-> [ z / x ] [ x / y ] ph ) $=
      ( weq wal wb drsb1NEW7 sbequ12a alimi spsbbiNEW7 bitr3d wn sbcoNEW7 sbbii
      wsb syl nfnaew3AUX7 nfsb2NEW7 sbco2dwAUX7 syl5rbbr pm2.61i ) BCEZBFZABCPZ
      CDPZACBPZBDPZGUDUEBDPZUFUHUEBCDHUDUEUGGZBFUIUHGUCUJBABCIJUEUGBDKQLUHUECBP
      ZBDPUDMZUFUKUGBDACBNOULUECDBBCCRBCBRABCSTUAUB $.
  $}

  ${
    $d x z $.
    $( Weak version of ~ sbcom not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    sbcomwAUX7 $p |- ( [ y / z ] [ y / x ] ph <-> [ y / x ] [ y / z ] ph ) $=
      ( weq wb wn wa drsb1NEW7 sbbidNEW7 bitr3d wi nfnaew3AUX7 nfnaewAUX7 albid
      wal wsb sb4bNEW7 sbequ12 sps nfa1 adantr wnf nfeqfNEW7 19.21t syl adantrr
      nfan alcomwAUX7 bi2.04 albii aecomNEW7 con3i syl5bb adantrl imbi2d adantl
      sylan sylan9bbr sylan9bb 3bitr4d pm2.61ian ex nfaewAUX7 pm2.61ii ) BCEZBP
      ZDCEZDPZABCQZDCQZADCQZBCQZFZVGGZVIGZVNBDEZBPZVOVPHZVNVRVNVSVRVJBCQVKVMVJB
      DCIVRVJVLBCVQBUAABDCIJKUBVRGZVSHZVHVFALZBPZLZDPZVFVHALZDPZLZBPZVKVMWAVHWB
      LZBPZDPZWEWIVTVOWLWEFVPVTVOHZWKWDDVTVODBDDMBCDNZUHWMVHBUCWKWDFDCBUDVHWBBU
      EUFOUGVTVPWLWIFVOWLWJDPZBPVTVPHZWIWJDBUIWPWOWHBVTVPBBDBMDCBNZUHWOVFWFLZDP
      ZWPWHWJWRDVHVFAUJUKWPVFDUCZWSWHFVTDBEDPZGVPWTXAVRDBULUMBCDUDURVFWFDUEUFUN
      OUNUOKVSVKWEFVTVPVKVHVJLZDPVOWEVJDCRVOXBWDDWNVOVJWCVHABCRUPOUSUQVSVMWIFVT
      VOVMVFVLLZBPVPWIVLBCRVPXCWHBWQVPVLWGVFADCRUPOUTUQVAVBVCVGVLVKVMVGAVJDCBCD
      VDVFAVJFBABCSTJVFVLVMFBVLBCSTKVIVJVKVMVHVJVKFDVJDCSTVIAVLBCDCBVDVHAVLFDAD
      CSTJKVE $.
  $}


$( ----------------- $)

  ${
    $d x y $.
    sb8i.1 $e |- ( -. A. x x = y -> F/ y ps ) $.
    $( Version of ~ sb8 not requiring ~ ax-7 .  (Contributed by NM,
       22-May-2018.) $)
    sb8iwAUX7 $p |- ( -. A. x x = y -> ( A. y [ y / x ] ps -> A. x ps ) ) $=
      ( weq wal wn wsb aecomNEW7 hba1 syl alimi nfi nfn nfsb2NEW7 wi stdpc7 a1i
      nfa1 cbv3dwAUX7 ) BCEZBFZGZABCHZACBUBCUBCUBCBEZCFZCFZUBCFUBUFUGBCIUECJKUF
      UBCCBILKMNUBBUABSNABCODUEUDAPPUCACBQRT $.
  $}

  ${
    $d x y $.
    sb8dwAUX7.aNEW $e |- F/ x ph $.
    sb8dwAUX7.bNEW $e |- F/ y ph $.
    sb8dwAUX7.1NEW $e |- ( ph -> F/ y ps ) $.
    $( Weak version of ~ sb8 not requiring ~ ax-7 .  (Contributed by NM,
       22-May-2018.) $)
    sb8dwAUX7 $p |- ( ph -> ( A. x ps <-> A. y [ y / x ] ps ) ) $=
      ( wal wsb nfaldwAUX7 wi stdpc4NEW7 a1i alrimdd nfrd alrimi sbimNEW7 sylib
      syl hbsb2aNEW7 syl6 nfd weq stdpc7 cbv3dwAUX7 impbid ) ABCHZBCDIZDHAUGUHD
      FABDCEGJUGUHKABCDLMNAUHBDCFEAUHCEAUHBDHZCDIZUHCHABUIKZCDIZUHUJKAUKCHULAUK
      CEABDGOPUKCDLSBUICDQRBCDTUAUBGDCUCUHBKKABDCUDMUEUF $.
  $}

  ${
    sb5rf.1NEW $e |- F/ y ph $.
    $( Reversed substitution.  (Contributed by NM, 3-Feb-2005.)  (Revised by
       Mario Carneiro, 6-Oct-2016.) $)
    sb5rfNEW7 $p |- ( ph <-> E. y ( y = x /\ [ y / x ] ph ) ) $=
      ( weq wsb wa wex sbid2NEW7 sb1 sylbir stdpc7 imp exlimi impbii ) ACBEZABC
      FZGZCHZAQCBFSACBDIQCBJKRACDPQAACBLMNO $.

    $( Reversed substitution.  (Contributed by NM, 5-Aug-1993.)  (Revised by
       Mario Carneiro, 6-Oct-2016.) $)
    sb6rfNEW7 $p |- ( ph <-> A. y ( y = x -> [ y / x ] ph ) ) $=
      ( weq wsb wal sbequ1 equcoms com12 alrimi sb2NEW7 sbid2NEW7 sylib impbii
      wi ) ACBEZABCFZPZCGZASCDQARARPBCABCHIJKTRCBFARCBLACBDMNO $.

    $d x y $.
    $( Weak version of ~ sb8 not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    sb8wAUX7 $p |- ( A. x ph <-> A. y [ y / x ] ph ) $=
      ( wal wsb nfalwAUX7 stdpc4NEW7 alrimi nfs1NEW7 stdpc7 cbv3wAUX7 impbii )
      ABEZABCFZCENOCACBDGABCHIOACBABCDJDACBKLM $.

    $( Weak version of ~ sb8e not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    sb8ewAUX7 $p |- ( E. x ph <-> E. y [ y / x ] ph ) $=
      ( wn wal wsb wex nfn sb8wAUX7 sbnNEW7 albii bitri notbii df-ex 3bitr4i )
      AEZBFZEABCGZEZCFZEABHSCHRUARQBCGZCFUAQBCACDIJUBTCABCKLMNABOSCOP $.
  $}

  ${
    $d x y $.
    $( This is a version of ~ ax-11o when the variables are distinct.  Axiom
       (C8) of [Monk2] p. 105.  See theorem ~ ax11v2 for the rederivation of
       ~ ax-11o from this theorem.  (Contributed by NM, 5-Aug-1993.) $)
    ax11vNEW7 $p |- ( x = y -> ( ph -> A. x ( x = y -> ph ) ) ) $=
      ( weq wal wi ax-1 ax16NEW7 syl5 a1d ax11oNEW7 pm2.61i ) BCDZBEZMAMAFZBEZF
      ZFNQMAONPAMGOBCHIJABCKL $.

    $( Two equivalent ways of expressing the proper substitution of ` y ` for
       ` x ` in ` ph ` , when ` x ` and ` y ` are distinct.  Theorem 6.2 of
       [Quine] p. 40.  The proof does not involve ~ df-sb .  (Contributed by
       NM, 14-Apr-2008.) $)
    sb56NEW7 $p |- ( E. x ( x = y /\ ph ) <-> A. x ( x = y -> ph ) ) $=
      ( weq wi wal nfa1 ax11vNEW7 sp com12 impbid equsexNEW7 ) ABCDZAEZBFZBCNBG
      MAOABCHOMANBIJKL $.

    $( Equivalence for substitution.  Compare Theorem 6.2 of [Quine] p. 40.
       Also proved as Lemmas 16 and 17 of [Tarski] p. 70.  (Contributed by NM,
       18-Aug-1993.) $)
    sb6NEW7 $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      ( weq wi wa wex wal wsb sb56NEW7 anbi2i df-sb sp pm4.71ri 3bitr4i ) BCDZA
      EZPAFBGZFQQBHZFABCISRSQABCJKABCLSQQBMNO $.

    $( Equivalence for substitution.  Similar to Theorem 6.1 of [Quine] p. 40.
       (Contributed by NM, 18-Aug-1993.) $)
    sb5NEW7 $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      ( wsb weq wi wal wa wex sb6NEW7 sb56NEW7 bitr4i ) ABCDBCEZAFBGMAHBIABCJAB
      CKL $.
  $}

  ${
    $d x y $.  $d y ph $.
    $( An equivalent expression for existence.  (Contributed by NM,
       2-Feb-2005.)  (Revised by NM, 28-Nov-2017.)  Revised to prove from
       ~ ax-7v instead of ~ ax-7 . $)
    exsbNEW7 $p |- ( E. x ph <-> E. y A. x ( x = y -> ph ) ) $=
      ( weq wi wal nfv nfa1 ax11vNEW7 sp com12 impbid cbvexwAUX7 ) ABCDZAEZBFZB
      CACGOBHNAPABCIPNAOBJKLM $.

    $( An equivalent expression for existence.  Obsolete as of 19-Jun-2017.
       (Contributed by NM, 2-Feb-2005.)  (New usage is discouraged.) $)
    exsbOLDNEW7 $p |- ( E. x ph <-> E. y A. x ( x = y -> ph ) ) $=
      ( wex wsb cv wceq wi wal nfv sb8ewAUX7 sb6NEW7 exbii bitri ) ABDABCEZCDBF
      CFGAHBIZCDABCACJKOPCABCLMN $.
  $}

  ${
    $d y z $.  $d x y $.
    $( Lemma for ~ equsb3 .  (Contributed by Raph Levien and FL, 4-Dec-2005.)
       (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
    equsb3lemNEW7 $p |- ( [ x / y ] y = z <-> x = z ) $=
      ( weq nfv equequ1 sbieNEW7 ) BCDACDZBAHBEBACFG $.
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic wff.  (Contributed by Raph Levien and
       FL, 4-Dec-2005.) $)
    equsb3NEW7 $p |- ( [ x / y ] y = z <-> x = z ) $=
      ( vw weq wsb equsb3lemNEW7 sbbii nfv sbco2wAUX7 3bitr3i ) BCEZBDFZDAFDCEZ
      DAFLBAFACEMNDADBCGHLBADLDIJADCGK $.
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic membership wff.  (Contributed by NM,
       7-Nov-2006.)  (Proof shortened by Andrew Salmon, 14-Jun-2011.) $)
    elsb3NEW7 $p |- ( [ x / y ] y e. z <-> x e. z ) $=
      ( vw wel wsb nfv sbco2wAUX7 elequ1 sbieNEW7 sbbii 3bitr3i ) DCEZDBFZBAFMD
      AFBCEZBAFACEZMDABMBGHNOBAMODBODGDBCIJKMPDAPDGDACIJL $.
  $}

  ${
    $d w y z $.  $d w x $.
    $( Substitution applied to an atomic membership wff.  (Contributed by
       Rodolfo Medina, 3-Apr-2010.)  (Proof shortened by Andrew Salmon,
       14-Jun-2011.) $)
    elsb4NEW7 $p |- ( [ x / y ] z e. y <-> z e. x ) $=
      ( vw wel wsb nfv sbco2wAUX7 elequ2 sbieNEW7 sbbii 3bitr3i ) CDEZDBFZBAFMD
      AFCBEZBAFCAEZMDABMBGHNOBAMODBODGDBCIJKMPDAPDGDACIJL $.
  $}

  ${
    $d x y $.
    $( ` x ` is not free in ` [ y / x ] ph ` when ` x ` and ` y ` are
       distinct.  (Contributed by NM, 5-Aug-1993.) $)
    hbs1NEW7 $p |- ( [ y / x ] ph -> A. x [ y / x ] ph ) $=
      ( weq wal wsb wi ax16NEW7 hbsb2NEW7 pm2.61i ) BCDBEABCFZKBEGKBCHABCIJ $.

    $( ` x ` is not free in ` [ y / x ] ph ` when ` x ` and ` y ` are
       distinct.  (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfs1vNEW7 $p |- F/ x [ y / x ] ph $=
      ( wsb hbs1NEW7 nfi ) ABCDBABCEF $.
  $}

  ${
    $d y ph $.  $d x y $.
    $( Weak version of ~ sbhb not requiring ~ ax-7 .  (Contributed by NM,
       28-Oct-2017.) $)
    sbhbwAUX7 $p |- ( ( ph -> A. x ph ) <-> A. y ( ph -> [ y / x ] ph ) ) $=
      ( wal wi wsb nfv sb8wAUX7 imbi2i 19.21v bitr4i ) AABDZEAABCFZCDZEAMECDLNA
      ABCACGHIAMCJK $.
  $}

  ${
    $d x y z $.  $d y z ph $.
    $( Two ways of expressing " ` x ` is (effectively) not free in ` ph ` ."
       (Contributed by G&eacute;rard Lang, 14-Nov-2013.)  (Revised by Mario
       Carneiro, 6-Oct-2016.) $)
    sbnf2NEW7 $p |- ( F/ x ph
       <-> A. y A. z ( [ y / x ] ph <-> [ z / x ] ph ) ) $=
      ( wsb wb wal wi wa wnf 2albiim sbhbwAUX7 albii alcomwAUX7 3bitri sb8wAUX7
      nfv nfs1vNEW7 sblimNEW7 bitri df-nf anbi12i anidm 3bitr2ri ) ABCEZABDEZFD
      GCGUEUFHZDGCGZUFUEHZDGZCGZIABJZULIULUEUFCDKULUHULUKULAUFHZBGZDGZUGCGZDGUH
      ULAABGHZBGZUMDGZBGUOABUAZUQUSBABDLMUMBDNOUNUPDUNUMBCEZCGUPUMBCUMCQPVAUGCA
      UFBCABDRSMTMUGDCNOULAUEHZBGZCGZUKULURVBCGZBGVDUTUQVEBABCLMVBBCNOVCUJCVCVB
      BDEZDGUJVBBDVBDQPVFUIDAUEBDABCRSMTMTUBULUCUD $.
  $}

  ${
    $d x y z $.  $d w y $.
    $( Equivalence for double substitution.  (Contributed by NM,
       3-Feb-2005.) $)
    2sb5NEW7 $p |- ( [ z / x ] [ w / y ] ph <->
               E. x E. y ( ( x = z /\ y = w ) /\ ph ) ) $=
      ( wsb weq wa wex sb5NEW7 19.42v anass exbii anbi2i 3bitr4ri bitri ) ACEFZ
      BDFBDGZQHZBIRCEGZHAHZCIZBIQBDJSUBBRTAHZHZCIRUCCIZHUBSRUCCKUAUDCRTALMQUERA
      CEJNOMP $.

    $( Equivalence for double substitution.  (Contributed by NM,
       3-Feb-2005.) $)
    2sb6NEW7 $p |- ( [ z / x ] [ w / y ] ph <->
               A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      ( wsb weq wi wal wa sb6NEW7 19.21v impexp albii imbi2i 3bitr4ri bitri ) A
      CEFZBDFBDGZRHZBISCEGZJAHZCIZBIRBDKTUCBSUAAHZHZCISUDCIZHUCTSUDCLUBUECSUAAM
      NRUFSACEKOPNQ $.
  $}

  ${
    $d x y $.
    $( Equivalence for substitution.  (Contributed by NM, 5-Aug-1993.) $)
    sb6aNEW7 $p |- ( [ y / x ] ph <-> A. x ( x = y -> [ x / y ] ph ) ) $=
      ( wsb weq wi wal sb6NEW7 wb sbequ12 equcoms pm5.74i albii bitri ) ABCDBCE
      ZAFZBGOACBDZFZBGABCHPRBOAQAQICBACBJKLMN $.
  $}

  ${
    $d x ph $.
    $( An identity law for substitution.  Used in proof of Theorem 9.7 of
       [Megill] p. 449 (p. 16 of the preprint).  (Contributed by NM,
       5-Aug-1993.) $)
    sbid2vNEW7 $p |- ( [ y / x ] [ x / y ] ph <-> ph ) $=
      ( nfv sbid2NEW7 ) ABCABDE $.
  $}

  ${
    $d x y $.  $d x ph $.
    $( Elimination of substitution.  (Contributed by NM, 5-Aug-1993.) $)
    sbelxNEW7 $p |- ( ph <-> E. x ( x = y /\ [ x / y ] ph ) ) $=
      ( wsb weq wa wex sbid2vNEW7 sb5NEW7 bitr3i ) AACBDZBCDBCEKFBGABCHKBCIJ $.
  $}

  ${
    $( Note:  A more general case could also be proved with
       "$d x z $.  $d y w $.  $d x ph $.  $d y ph $.", but with more
       difficulty. $)
    $d x y z $.  $d w y $.  $d x y ph $.
    $( Elimination of double substitution.  (Contributed by NM, 5-Aug-1993.) $)
    sbel2xNEW7 $p |- ( ph <-> E. x E. y ( ( x = z /\ y = w ) /\
                     [ y / w ] [ x / z ] ph ) ) $=
      ( weq wsb wex sbelxNEW7 anbi2i exbii exdistr 3bitr4i anass 2exbii bitr4i
      wa ) ABDFZCEFZADBGZECGZQZQZCHBHZRSQUAQZCHBHRTQZBHRUBCHZQZBHAUDUFUHBTUGRTC
      EIJKABDIRUBBCLMUEUCBCRSUANOP $.
  $}
$( ----------------- $)


  ${
    $d x y $.
    $( A theorem used in elimination of disjoint variable restriction on ` x `
       and ` y ` by replacing it with a distinctor ` -. A. x x = z ` .
       (Contributed by NM, 5-Aug-1993.) $)
    sbal1NEW7 $p |- ( -. A. x x = z ->
             ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) ) $=
      ( weq wal wn wsb wb wi sbequ12 sps dral2wAUX7 bitr3d nfa1 nfsb4wAUX7 syl6
      a1d wa hbnaewAUX7 nfrd sp sbimi adantl sb4NEW7 alimdh ax7vAUX7 dveeq2NEW7
      alimi alim syl9 al2imi sb2NEW7 syl sylan9 impbid ex pm2.61i ) CDEZCFZBDEB
      FGZABFZCDHZACDHZBFZIZJUTVFVAUTVBVCVEUSVBVCICVBCDKLAVDCDBUSAVDICACDKLMNRUT
      GZVAVFVGVASVCVEVAVCVEJVGVAVCVCBFVEVAVCBVBCDBABOPUAVCVDBVBACDABUBUCUIQUDVG
      VEUSAJZBFZCFZVAVCVGVEVHCFZBFVJVGVDVKBCDBTACDUEUFVHBCUGQVAVACFZVJVCJBDCTVL
      VJUSVBJZCFVCVAVIVMCVAUSUSBFVIVBBDCUHUSABUJUKULVBCDUMQUNUOUPUQUR $.
  $}

  ${
    $d x y $.  $d x z $.
    $( Move universal quantifier in and out of substitution.  (Contributed by
       NM, 5-Aug-1993.) $)
    sbalNEW7 $p |- ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) $=
      ( weq wal wsb a16gbNEW7 sbimi sbequ5wAUX7 sbbiNEW7 3imtr3i bitr3d pm2.61i
      wb sbal1NEW7 ) BDEBFZABFZCDGZACDGZBFZOQTSUAQCDGAROZCDGQTSOQUBCDABDBHIBDCD
      JARCDKLTBDBHMABCDPN $.
  $}

  ${
    $d x y $.  $d x z $.
    $( Move existential quantifier in and out of substitution.  (Contributed by
       NM, 27-Sep-2003.) $)
    sbexNEW7 $p |- ( [ z / y ] E. x ph <-> E. x [ z / y ] ph ) $=
      ( wn wal wsb wex sbnNEW7 sbalNEW7 albii bitri xchbinx df-ex sbbii 3bitr4i
      ) AEZBFZEZCDGZACDGZEZBFZEABHZCDGUABHTRCDGZUCRCDIUEQCDGZBFUCQBCDJUFUBBACDI
      KLMUDSCDABNOUABNP $.
  $}

  ${
    $d x z $.  $d y z $.
    sbalvNEW.1 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Quantify with new variable inside substitution.  (Contributed by NM,
       18-Aug-1993.) $)
    sbalvNEW7 $p |- ( [ y / x ] A. z ph <-> A. z ps ) $=
      ( wal wsb sbalNEW7 albii bitri ) AEGCDHACDHZEGBEGAECDILBEFJK $.
  $}

  ${
    nalequcoms.1NEW7 $e |- ( -. A. x x = y -> ph ) $.
    $( A commutation rule for distinct variable specifiers.  (Contributed by
       NM, 2-Jan-2002.) $)
    naecomsNEW7 $p |- ( -. A. y y = x -> ph ) $=
      ( weq wal aecomNEW7 nsyl4 con1i ) ACBECFZBCEBFJABCGDHI $.
  $}

  ${
    chvar.1NEW7 $e |- F/ x ps $.
    chvar.2NEW7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    chvar.3NEW7 $e |- ph $.
    $( Implicit substitution of ` y ` for ` x ` into a theorem.  (Contributed
       by Raph Levien, 9-Jul-2003.)  (Revised by Mario Carneiro,
       3-Oct-2016.) $)
    chvarNEW7 $p |- ps $=
      ( weq biimpd spimNEW7 mpg ) ABCABCDECDHABFIJGK $.
  $}

  ${
    equs45f.1NEW7 $e |- F/ y ph $.
    $( Two ways of expressing substitution when ` y ` is not free in ` ph ` .
       (Contributed by NM, 25-Apr-2008.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    equs45fNEW7 $p |- ( E. x ( x = y /\ ph ) <-> A. x ( x = y -> ph ) ) $=
      ( weq wa wex wi wal nfri anim2i eximi equs5a syl equs4NEW7 impbii ) BCEZA
      FZBGZQAHBIZSQACIZFZBGTRUBBAUAQACDJKLABCMNABCOP $.
  $}

  $( A bidirectional version of ~ ax11oNEW7 .  (Contributed by NM,
     30-Jun-2006.) $)
  ax11bNEW7 $p |- ( ( -. A. x x = y /\ x = y ) ->
              ( ph <-> A. x ( x = y -> ph ) ) ) $=
    ( weq wal wn wa wi ax11oNEW7 imp sp com12 adantl impbid ) BCDZBEFZOGAOAHZBE
    ZPOARHABCIJORAHPROAQBKLMN $.

  ${
    $d x ps $.
    spv.1NEW7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Specialization, using implicit substitution.  (Contributed by NM,
       30-Aug-1993.) $)
    spvNEW7 $p |- ( A. x ph -> ps ) $=
      ( weq biimpd spimvNEW7 ) ABCDCDFABEGH $.
  $}

  ${
    $d x ph $.
    spimev.1NEW7 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Distinct-variable version of ~ spimeNEW7 .  (Contributed by NM,
       5-Aug-1993.) $)
    spimevNEW7 $p |- ( ph -> E. x ps ) $=
      ( nfv spimeNEW7 ) ABCDACFEG $.
  $}

  ${
    $d x ps $.
    speiv.1NEW7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    speiv.2NEW7 $e |- ps $.
    $( Inference from existential specialization, using implicit substitution.
       (Contributed by NM, 19-Aug-1993.) $)
    speivNEW7 $p |- E. x ph $=
      ( wex weq biimprd spimevNEW7 ax-mp ) BACGFBACDCDHABEIJK $.
  $}

  ${
    $d x ps $.
    chv.1NEW7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    chv.2NEW7 $e |- ph $.
    $( Implicit substitution of ` y ` for ` x ` into a theorem.  (Contributed
       by NM, 20-Apr-1994.) $)
    chvarvNEW7 $p |- ps $=
      ( spvNEW7 mpg ) ABCABCDEGFH $.
  $}

  ${
    $d x z $.  $d y z $.
    $( When the class variables in definition ~ df-clel are replaced with set
       variables, this theorem of predicate calculus is the result.  This
       theorem provides part of the justification for the consistency of that
       definition, which "overloads" the set variables in ~ wel with the class
       variables in ~ wcel .  Note:  This proof is referenced on the Metamath
       Proof Explorer Home Page and shouldn't be changed.  (Contributed by NM,
       28-Jan-2004.)  (Proof modification is discouraged.) $)
    cleljustNEW7 $p |- ( x e. y <-> E. z ( z = x /\ z e. y ) ) $=
      ( weq wel wa wex ax-17 elequ1 equsexhNEW7 bicomi ) CADCBEZFCGABEZLMCAMCHC
      ABIJK $.
  $}

  ${
    $d x z $.  $d y z $.
    $( When the class variables in definition ~ df-clel are replaced with set
       variables, this theorem of predicate calculus is the result.  This
       theorem provides part of the justification for the consistency of that
       definition, which "overloads" the set variables in ~ wel with the class
       variables in ~ wcel .  (Contributed by NM, 28-Jan-2004.)  (Revised by
       Mario Carneiro, 21-Dec-2016.) $)
    cleljustALTNEW7 $p |- ( x e. y <-> E. z ( z = x /\ z e. y ) ) $=
      ( cleljustNEW7 ) ABCD $.
  $}

  ${
    sb6x.1NEW7 $e |- F/ x ph $.
    $( Equivalence involving substitution for a variable not free.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sb6xNEW7 $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      ( wsb weq wi wal sbfNEW7 biidd equsalNEW7 bitr4i ) ABCEABCFZAGBHABCDIAABC
      DMAJKL $.
  $}

  ${
    nfs1f.1NEW7 $e |- F/ x ph $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfs1fNEW7 $p |- F/ x [ y / x ] ph $=
      ( wsb sbfNEW7 nfxfr ) ABCEABABCDFDG $.
  $}

  ${
    sbt.1NEW7 $e |- ph $.
    $( A substitution into a theorem remains true.  (See ~ chvarNEW7 and
       ~ chvarvNEW7 for versions using implicit substitution.)  (Contributed by
       NM, 21-Jan-2004.)  (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    sbtNEW7 $p |- [ y / x ] ph $=
      ( wsb nfth sbfNEW7 mpbir ) ABCEADABCABDFGH $.
  $}

  ${
    $d x ph $.  $d x ch $.
    sbiedv.1NEW7 $e |- ( ( ph /\ x = y ) -> ( ps <-> ch ) ) $.
    $( Conversion of implicit substitution to explicit substitution (deduction
       version of ~ sbieNEW7 ).  (Contributed by NM, 7-Jan-2017.) $)
    sbiedvNEW7 $p |- ( ph -> ( [ y / x ] ps <-> ch ) ) $=
      ( nfv nfvd weq wb ex sbiedNEW7 ) ABCDEADGACDHADEIBCJFKL $.
  $}

  ${
    sb6f.1NEW7 $e |- F/ y ph $.
    $( Equivalence for substitution when ` y ` is not free in ` ph ` .
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sb6fNEW7 $p |- ( [ y / x ] ph <-> A. x ( x = y -> ph ) ) $=
      ( wsb weq wi wal nfri sbimi sb4a syl sb2NEW7 impbii ) ABCEZBCFAGBHZOACHZB
      CEPAQBCACDIJABCKLABCMN $.

    $( Equivalence for substitution when ` y ` is not free in ` ph ` .
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    sb5fNEW7 $p |- ( [ y / x ] ph <-> E. x ( x = y /\ ph ) ) $=
      ( wsb weq wi wal wa wex sb6fNEW7 equs45fNEW7 bitr4i ) ABCEBCFZAGBHNAIBJAB
      CDKABCDLM $.
  $}

  ${
    $d x y z $.  $d z ph $.
    $( Alternate proof of ~ ax16NEW7 .  (Contributed by NM, 17-May-2008.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax16ALTNEW7 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( vz wsb sbequ12 ax-17 hbsb3NEW7 ax16iNEW7 ) AABDEBCDABDFABDADGHI $.
  $}

  ${
    $d z ps $.  $d x z $.  $d y z $.
    dvelimALT.1NEW7 $e |- ( ph -> A. x ph ) $.
    dvelimALT.2NEW7 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelim that doesn't use ~ ax-10 .  (See ~ dvelimh for a
       version that doesn't use ~ ax-11 .)  (Contributed by NM, 17-May-2008.)
       (New usage is discouraged.)  (Proof modification is discouraged.) $)
    dvelimALTNEW7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi ax-17 ax16ALTNEW7 a1d wa hbn1 hban ax12oNEW7 imp a1i ex
      hbimd pm2.61i hbaldwAUX7 equsalhNEW7 albii 3imtr3g ) CDHZCIJZEDHZAKZEIZUL
      CIBBCIUIUKCEUIELCEHZCIZUIUKUKCIKZKUNUOUIUKCEMNUNJZUIUOUPUIOZUJACUPUICUMCP
      UHCPQUPUIUJUJCIKEDCRSAACIKUQFTUBUAUCUDABEDBELGUEZULBCURUFUG $.
  $}

  $( One direction of a simplified definition of substitution when variables
     are distinct.  (Contributed by NM, 5-Aug-1993.) $)
  sb3NEW7 $p |- ( -. A. x x = y
      -> ( E. x ( x = y /\ ph ) -> [ y / x ] ph ) ) $=
    ( weq wal wn wa wex wi wsb equs5NEW7 sb2NEW7 syl6 ) BCDZBEFNAGBHNAIBEABCJAB
    CKABCLM $.

  $( An alternate definition of proper substitution that, like ~ df-sb , mixes
     free and bound variables to avoid distinct variable requirements.
     (Contributed by NM, 17-Feb-2005.) $)
  dfsb2NEW7 $p |- ( [ y / x ] ph <->
              ( ( x = y /\ ph ) \/ A. x ( x = y -> ph ) ) ) $=
    ( wsb weq wa wi wal wo sp sbequ2 sps orc ee12an wn sb4NEW7 olc syl6 pm2.61i
    sbequ1 imp sb2NEW7 jaoi impbii ) ABCDZBCEZAFZUFAGBHZIZUFBHZUEUIGUJUFUEAUIUF
    BJUFUEAGBABCKLUGUHMNUJOUEUHUIABCPUHUGQRSUGUEUHUFAUEABCTUAABCUBUCUD $.

  $( An alternate definition of proper substitution ~ df-sb that uses only
     primitive connectives (no defined terms) on the right-hand side.
     (Contributed by NM, 6-Mar-2007.) $)
  dfsb3NEW7 $p |- ( [ y / x ] ph <->
              ( ( x = y -> -. ph ) -> A. x ( x = y -> ph ) ) ) $=
    ( weq wa wi wal wo wn wsb df-or dfsb2NEW7 imnan imbi1i 3bitr4i ) BCDZAEZPAF
    BGZHQIZRFABCJPAIFZRFQRKABCLTSRPAMNO $.

  $( Conjunction inside and outside of a substitution are equivalent.
     (Contributed by NM, 14-Dec-2006.) $)
  sb3anNEW7 $p |- ( [ y / x ] ( ph /\ ps /\ ch ) <->
              ( [ y / x ] ph /\ [ y / x ] ps /\ [ y / x ] ch ) ) $=
    ( w3a wsb wa df-3an sbbii sbanNEW7 anbi1i bitr4i 3bitri ) ABCFZDEGABHZCHZDE
    GPDEGZCDEGZHZADEGZBDEGZSFZOQDEABCIJPCDEKTUAUBHZSHUCRUDSABDEKLUAUBSIMN $.

  ${
    sblbis.1NEW7 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce left biconditional inside of a substitution.  (Contributed by
       NM, 19-Aug-1993.) $)
    sblbisNEW7 $p |- ( [ y / x ] ( ch <-> ph ) <-> ( [ y / x ] ch <-> ps ) ) $=
      ( wb wsb sbbiNEW7 bibi2i bitri ) CAGDEHCDEHZADEHZGLBGCADEIMBLFJK $.
  $}

  ${
    sbrbis.1NEW7 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce right biconditional inside of a substitution.  (Contributed by
       NM, 18-Aug-1993.) $)
    sbrbisNEW7 $p |- ( [ y / x ] ( ph <-> ch ) <-> ( ps <-> [ y / x ] ch ) ) $=
      ( wb wsb sbbiNEW7 bibi1i bitri ) ACGDEHADEHZCDEHZGBMGACDEILBMFJK $.
  $}

  ${
    sbrbif.1NEW7 $e |- F/ x ch $.
    sbrbif.2NEW7 $e |- ( [ y / x ] ph <-> ps ) $.
    $( Introduce right biconditional inside of a substitution.  (Contributed by
       NM, 18-Aug-1993.)  (Revised by Mario Carneiro, 4-Oct-2016.) $)
    sbrbifNEW7 $p |- ( [ y / x ] ( ph <-> ch ) <-> ( ps <-> ch ) ) $=
      ( wb wsb sbrbisNEW7 sbfNEW7 bibi2i bitri ) ACHDEIBCDEIZHBCHABCDEGJNCBCDEF
      KLM $.
  $}

  ${
    $d x z $.  $d x w $.  $d y z $.
    $( Commutativity law for substitution.  Used in proof of Theorem 9.7 of
       [Megill] p. 449 (p. 16 of the preprint).  (Contributed by NM,
       27-May-1997.) $)
    sbcom2NEW7 $p |- ( [ w / z ] [ y / x ] ph <-> [ y / x ] [ w / z ] ph ) $=
      ( weq wal wsb wb wn albii 19.21v sb4bNEW7 imbi2d albidv nfaewAUX7 sbequ12
      wi sps sbbidNEW7 wa alcomwAUX7 bi2.04 bitri 3bitr3i a1i sylan9bbr 3bitr4d
      sylan9bb ex bitr3d pm2.61ii ) BCFZBGZDEFZDGZABCHZDEHZADEHZBCHZIZUNJZUPJZV
      AVBVCUAZUOUMARZBGZRZDGZUMUOARZDGZRZBGZURUTVHVLIVDUMVIRZBGZDGVMDGZBGVHVLVM
      DBUBVNVGDVNUOVERZBGVGVMVPBUMUOAUCKUOVEBLUDKVOVKBUMVIDLKUEUFVCURUOUQRZDGVB
      VHUQDEMVBVQVGDVBUQVFUOABCMNOUGVBUTUMUSRZBGVCVLUSBCMVCVRVKBVCUSVJUMADEMNOU
      IUHUJUNUSURUTUNAUQDEBCDPUMAUQIBABCQSTUMUSUTIBUSBCQSUKUPUQURUTUOUQURIDUQDE
      QSUPAUSBCDEBPUOAUSIDADEQSTUKUL $.
  $}

  $( Weak version of ~ ax-7 not requiring ~ ax-7 .  (Contributed by NM,
     9-Oct-2017.) $)
  ax7w1AUX7 $p |- ( A. x x = y -> ( A. x A. y ph -> A. y A. x ph ) ) $=
    ( wal weq hba1 ax10oNEW7 sp 2alimi syl56 ) ACDZBDZLBDBCEBDLCDABDCDKBFLBCGKA
    CBACHIJ $.

  ${
    ax7w1h.1 $e |- ( A. x x = y -> ( ph -> A. x ph ) ) $.
    $( Weak version of ~ hbal not requiring ~ ax-7 .  (Contributed by NM,
       27-Oct-2017.) $)
    ax7w1hAUX7 $p |- ( A. x x = y -> ( A. y ph -> A. x A. y ph ) ) $=
      ( weq wal ax10NEW7 hba1eAUX7 alimdh ax7w1AUX7 sylsyld ) BCEBFZCBECFACFZAB
      FZCFMBFBCGLANCBCHDIACBJK $.
  $}

  $( Weak version of ~ hbae not requiring ~ ax-7 .  (Contributed by NM,
     29-Oct-2017.) $)
  hbaew0AUX7 $p |- ( A. x x = y -> A. z x = y ) $=
    ( weq wal wi wn ax12oNEW7 syl7 ax10oNEW7 aecomsNEW7 pm2.43i syl5 pm2.61ii
    sp ) CADCEZCBDCEZABDZAEZRCEZFZSRPGQGTRAOABCHIUAACRACJKUABCSRBEZBCDBETSUBRAB
    JLRBCJMKN $.

  $( Weak version of ~ hbae not requiring ~ ax-7 .  (Contributed by NM,
     30-Oct-2017.) $)
  hbaew4AUX7 $p |- ( A. x x = z -> ( A. x x = y -> A. z A. x x = y ) ) $=
    ( weq wal hbaew0AUX7 a5i ax7w1AUX7 syl5 ) ABDZAEZJCEZAEACDAEKCEJLAABCFGJACH
    I $.

  ${
    $d u v $.
    $( Weak version of ~ hbae not requiring ~ ax-7 .  (Contributed by NM,
       30-Oct-2017.) $)
    hbaew5AUX7 $p |- ( A. u u = v -> ( A. x x = y -> A. z A. x x = y ) ) $=
      ( weq wal a16gNEW7 ) ABFAGEDCH $.
  $}

  $( Special case of ~ ax-7 .  (Contributed by NM, 9-Oct-2017.) $)
  ax7w2AUX7 $p |- ( A. x A. y [ y / x ] ph -> A. y A. x [ y / x ] ph ) $=
    ( weq wal wsb wi ax7w1AUX7 wn hba1eAUX7 hbn hbsb2NEW7 alimdh spsd pm2.61i )
    BCDBEZABCFZCEZBEQBEZCEZGQBCHPIZRTBUAQSCPCBCJKABCLMNO $.

  $( Special case of ~ ax-7 .  (Contributed by NM, 12-Oct-2017.) $)
  ax7w3AUX7 $p |- ( A. x A. y x = y -> A. y A. x x = y ) $=
    ( weq wal equcomi alimi aecomNEW7 a5i syl sps ) ABCZBDZKADZBDZALBACZBDNKOBA
    BEFOMBBAGHIJ $.

  ${
    ax7w6.1 $e |- ( A. x A. y [ x / y ] ph -> A. y A. x [ x / y ] ph ) $.
    $( Version of ~ sb9i with the usage of ~ ax-7 broken out as a hypothesis.
       (Contributed by NM, 16-Oct-2017.) $)
    ax7w6AUX7 $p |- ( A. x [ x / y ] ph -> A. y [ y / x ] ph ) $=
      ( weq wal wsb wi drsb1NEW7 drsb2NEW7 bitr3d dral1NEW7 hba1eAUX7 hbsb2NEW7
      biimprd wn hbn alimdh stdpc4NEW7 sbcoNEW7 sylib alimi syl syl6 pm2.61i )
      CBECFZACBGZBFZABCGZCFZHUFUJUHUIUGCBUFACCGUIUGACBCIACBCJKLOUFPZUHUGCFZBFZU
      JUKUGULBUFBCBMQACBNRUMUHCFUJDUHUICUHUGBCGUIUGBCSABCTUAUBUCUDUE $.
  $}

  $( Special case of ~ ax-7 .  (Contributed by NM, 12-Oct-2017.) $)
  ax7w7AUX7 $p |- ( A. x A. y -. x = y -> A. y A. x -. x = y ) $=
    ( weq wn wal sp alimi ax9NEW7 pm2.21i syl ) ABCDZBEZAEKAEZMBEZLKAKBFGMNABHI
    J $.

  ${
    ax7w8.1 $e |- ( ph -> A. x ph ) $.
    $( Special case of ~ ax-7 .  (Contributed by NM, 13-Oct-2017.) $)
    ax7w8AUX7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
      ( wal alimi sps ) ACEABEZCEBAHCDFG $.
  $}

  ${
    ax7w8nf.1 $e |- F/ x ph $.
    $( Special case of ~ ax-7 .  (Contributed by NM, 23-Nov-2017.) $)
    ax7nfAUX7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
      ( nfri ax7w8AUX7 ) ABCABDEF $.
  $}

  ${
    $( Special case of ~ ax-7 .  (Contributed by NM, 23-Nov-2017.) $)
    ax7w7tAUX7 $p |- ( A. y ( ph -> A. x ph )
        -> ( A. x A. y ph -> A. y A. x ph ) ) $=
      ( wal wi ax-5 spsd ) AABDZECDACDHCDBAHCFG $.
  $}

  ${
    $( Special case of ~ ax-7 .  (Contributed by NM, 23-Nov-2017.) $)
    ax7wnftAUX7 $p |- ( A. y F/ x ph -> ( A. x A. y ph -> A. y A. x ph ) ) $=
      ( wnf wal wi nfr alimi ax7w7tAUX7 syl ) ABDZCEAABEZFZCEACEBELCEFKMCABGHAB
      CIJ $.
  $}

  ${
    ax7w4.1 $e |- ( A. x A. y A. y ph -> A. y A. x A. y ph ) $.
    $( Remove quantifier from ~ ax-7 .  (Contributed by NM, 12-Oct-2017.) $)
    ax7w4AUX7 $p |- ( A. x A. y ph -> A. y A. x ph ) $=
      ( wal hba1 alimi syl sp alrimih ) ACEZBEZABECLKCEZBELCEKMBACFGDHKABACIGJ
      $.
  $}

  ${
    ax7w5.1 $e |- ( ph -> A. x ph ) $.
    ax7w5.2 $e |- ( A. y A. x ph -> A. x A. y ph ) $.
    $( Same as ~ hbal with explicit ~ ax-7 hypothesis.  (Contributed by NM,
       12-Oct-2017.) $)
    ax7w5AUX7 $p |- ( A. y ph -> A. x A. y ph ) $=
      ( wal alimi syl ) ACFZABFZCFIBFAJCDGEH $.
  $}

  $( Special case of ~ ax-7 proved from ~ ax-7v .  (Contributed by NM,
     28-Nov-2017.) $)
  ax7w9AUX7 $p |- ( A. x A. y ( x = y /\ x = z )
        -> A. y A. x ( x = y /\ x = z ) ) $=
    ( weq wa wal equcomi adantr ax-8 imp jca alimi aecomNEW7 hbaew0AUX7 anim12i
    19.26 sylibr equtr imdistani syl sylbi a5i sps ) ABDZACDZEZBFZUFAFZBFAUFUHB
    UGBADZBCDZEZBFZUHUFUKBUFUIUJUDUIUEABGHUDUEUJABCIJKLULUIBFZUJBFZEZUHUIUJBPUO
    UDUJEZAFZUHUOUDAFZUJAFZEUQUMURUNUSBAMBCANOUDUJAPQUPUFAUDUJUEABCRSLTUATUBUC
    $.

  $( Special case of ~ alcom proved from ~ ax-7v .  (Contributed by NM,
     28-Nov-2017.) $)
  alcomw9bAUX7 $p |- ( A. x A. y ( x = y /\ x = z )
        <-> A. y A. x ( x = y /\ x = z ) ) $=
    ( weq wa wal ax7w9AUX7 equcomi adantr ax-8 imp jca 2alimi 3syl impbii ) ABD
    ZACDZEZBFAFZRAFBFZABCGTBADZBCDZEZAFBFUCBFAFSRUCBARUAUBPUAQABHIPQUBABCJKLMBA
    CGUCRABUCPQUAPUBBAHIUAUBQBACJKLMNO $.

  $( Special case of ~ ax-7 derived from ~ ax-7v .  (Contributed by NM,
     20-May-2018.) $)
  ax7w10AUX7 $p |- ( A. x A. y ( x = y /\ ph )
       -> A. y A. x ( x = y /\ ph ) ) $=
    ( weq wa wal 19.26 sp anim1i sylbi alimi biimpi ax7w1AUX7 imdistani biimpri
    hba1eAUX7 alanimi 3syl ) BCDZAEZCFZBFSACFZEZBFZSBFZUBBFZEZTBFZCFZUAUCBUASCF
    ZUBEUCSACGUJSUBSCHIJKUDUGSUBBGLUGUEABFZCFZEUECFZULEUIUEUFULABCMNUEUMULBCPIU
    EUKUHCUHUEUKESABGOQRR $.

  $( Special case of ~ ax-7 derived from ~ ax-7v .  (Contributed by NM,
     20-May-2018.) $)
  ax7w11AUX7 $p |- ( A. x A. y ( -. x = y /\ ph )
       -> A. y A. x ( -. x = y /\ ph ) ) $=
    ( weq wn wa wal sp alimi ax9NEW7 simpl mto pm2.21i syl ) BCDEZAFZCGZBGPBGZR
    CGZQPBPCHIRSROBGBCJPOBOAKILMN $.

  ${
    $d x z $.
    dvelimf.1wAUX7 $e |- F/ x ph $.
    dvelimf.2wAUX7 $e |- F/ z ps $.
    dvelimf.3wAUX7 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelimvNEW7 .  (Contributed by Mario Carneiro,
       6-Oct-2016.)  (Revised by NM, 22-May-2018.) $)
    dvelimfwAUX7 $p |- ( -. A. x x = y -> F/ x ps ) $=
      ( weq wal wn ax-6 nfri dvelimhvAUX7 nfdh ) CDIZCJKBCPCLABCDEACFMBEGMHNO
      $.
  $}

  ${
    $d y z $.  $d x z $.
    nfsb.1wAUX7 $e |- F/ z ph $.
    $( If ` z ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.)  (Revised by NM,
       22-May-2018.) $)
    nfsbwAUX7 $p |- F/ z [ y / x ] ph $=
      ( weq wal wsb wnf a16nfNEW7 nfsb4wAUX7 pm2.61i ) DCFDGABCHZDIMDCDJABCDEKL
      $.
  $}

  ${
    $d s t u v x $.  $d s t u v y $.  $d s t ph $.
    ax7w15l1AUX7.1 $e |- F/ x ph $.
    ax7w15l1AUX7.2 $e |- F/ y ph $.
    $( Lemma for ~ ax7w14AUX7 .  (Contributed by NM, 23-May-2018.) $)
    ax7w15lemxAUX7 $p |- ( -. A. x x = y -> ( A. x A. y [ x / u ] [ y / v ] ph
         -> A. s A. t [ s / u ] [ t / v ] ph ) ) $=
      ( weq wal wn wsb wi aevNEW7 con3i wnf syl nfv syl6ib nfa1 nfn naecomsNEW7
      wb sbal1NEW7 sb8iwAUX7 sb8wAUX7 alrimiv spsbimNEW7 sylbird alimd sbalNEW7
      a1i albii alcomwAUX7 bitri nfsbwAUX7 syld ) BCJZBKZLZADCMZEBMCKZBKZADFMZE
      BMZBKZFKZVEEGMZFKGKZVAVDVEFKZEBMZBKZVHVAVCVLBUTBUSBUAUBVAVCVBCKZEBMZVLVOV
      CUDCBVBCEBUEUCVAVNVKNZEKVOVLNVAVPEVAVNADKZVKVADCJDKZLZVNVQNVRUTDCBBCOPADC
      ACQVSIUMUFRADFAFSUGTUHVNVKEBUIRUJUKVMVFFKZBKVHVLVTBVEFEBULUNVFBFUOUPTVAVH
      VIGKZFKVJVAVGWAFVAFSVAVGVEEKZWAVAEBJEKZLZVGWBNWCUTEBBBCOPVEEBVEBQWDADFBHU
      QUMUFRVEEGVEGSUGTUKVIFGUOTUR $.
  $}

  ${
    $d s t u v x $.  $d s t u v y $.  $d s t ps $.  $d s t u v ph $.
    ax7w15AUX7.x $e |- F/ x ph $.
    ax7w15AUX7.y $e |- F/ y ph $.
    ax7w15AUX7.1 $e |- ( ph -> F/ x ps ) $.
    ax7w15AUX7.2 $e |- ( ph -> F/ y ps ) $.
    $( Lemma for ~ ax7w15AUX7 .  (Contributed by NM, 22-May-2018.) $)
    ax7w15lemAUX7 $p |- ( ( ph /\ -. A. x x = y )
        -> ( A. x A. y [ x / u ] [ y / v ] ps
         <-> A. s A. t [ s / u ] [ t / v ] ps ) ) $=
      ( wal wsb wb alcomwAUX7 a1i syl5bb nfv sb8dwAUX7 weq wn wa sbalNEW7 albii
      nfa1 nfn nfan sb8wAUX7 syl5bbr sbbidNEW7 adantr naecomsNEW7 adantl bitr2d
      sbal1NEW7 albid wnf nfsbdwAUX7 bitr3d 3bitr4d ) ACDUAZCMZUBZUCZBEGNZGMZFC
      NZCMZVFFCNZCMZGMZBEDNZFCNDMZCMVFFHNZGMHMZVIVJGMZCMZVEVLVHVQCVFGFCUDUEVRVL
      OVEVJCGPQRVEVNVHCAVDCIVCCVBCUFUGUHVEVHVMDMZFCNZVNAVHVTOVDAVGVSFCAFSZVGBEM
      AVSBEGBGSUIABEDAESZJLTUJUKULVDVTVNOZAWCDCVMDFCUPUMUNUOUQAVPVLOVDVPVOHMZGM
      AVLVOHGPAWDVKGAGSAVFFMWDVKAVFFHWAAHSVFHURAVFHSQTAVFFCWAIABEGCWBKUSTUTUQRU
      LVA $.

    $( Special case of ~ ax-7 derived from ~ ax-7v .  (Contributed by NM,
       22-May-2018.) $)
    ax7w15AUX7 $p |- ( ph -> ( A. x A. y [ x / u ] [ y / v ] ps
         -> A. y A. x [ x / u ] [ y / v ] ps ) ) $=
      ( vt vs weq wal wsb wn wb sbcom2NEW7 2albii ax7w15lemAUX7 wi wa bitri a1i
      alcomwAUX7 aecomNEW7 sylan2 syl5bb 3bitr4d biimpd ex ax7w1AUX7 pm2.61d2
      con3i ) ACDMCNZBEDOFCOZDNCNZUPCNDNZUAZAUOPZUSAUTUBZUQURVABEKOFLOZKNLNZBFL
      OEKOZLNKNZUQURVCVEQVAVCVBLNKNVEVBLKUEVBVDKLBEKFLRSUCUDABCDEFKLGHIJTURBFCO
      EDOZCNDNZVAVEUPVFDCBEDFCRSUTADCMDNZPVGVEQVHUODCUFUNABDCFELKHGJITUGUHUIUJU
      KUPCDULUM $.
  $}

  ${
    $d s t u v x $.  $d s t u v y $.  $d s t ph $.
    ax7w14AUX7.1 $e |- F/ x ph $.
    ax7w14AUX7.2 $e |- F/ y ph $.
    $( Lemma for ~ ax7w14AUX7 .  (Contributed by NM, 22-May-2018.) $)
    ax7w14lemAUX7 $p |- ( -. A. x x = y -> ( A. x A. y [ x / u ] [ y / v ] ph
         <-> A. s A. t [ s / u ] [ t / v ] ph ) ) $=
      ( weq wal wn wsb nfa1 nfv sb8wAUX7 bitr3i albii alcomwAUX7 bitri sbbii wb
      nfn sbal1NEW7 naecomsNEW7 syl5rbb albid sbalNEW7 syl6bb nfsbwAUX7 syl6bbr
      ) BCJZBKZLZADCMZEBMCKZBKZADFMZEBMZBKZFKZUREGMZFKGKZUNUQURFKZEBMZBKZVAUNUP
      VEBUMBULBNUCVEUOCKZEBMZUNUPVDVGEBVDADKVGADFAFOPADCIPQUAVHUPUBCBUOCEBUDUEU
      FUGVFUSFKZBKVAVEVIBURFEBUHRUSBFSTUIVCVBGKZFKVAVBGFSVJUTFVJUREKUTUREGURGOP
      UREBADFBHUJPQRTUK $.

    $( Special case of ~ ax-7 derived from ~ ax-7v .  (Contributed by NM,
       22-May-2018.) $)
    ax7w14AUX7 $p |- ( A. x A. y [ x / u ] [ y / v ] ph
         -> A. y A. x [ x / u ] [ y / v ] ph ) $=
      ( vt vs weq wi ax7w1AUX7 wn wb alcomwAUX7 sbcom2NEW7 2albii ax7w14lemAUX7
      wal wsb bitri a1i naecomsNEW7 syl5bb 3bitr4d biimpd pm2.61i ) BCJBSZADCTE
      BTZCSBSZUIBSCSZKUIBCLUHMZUJUKULADHTEITZHSISZAEITDHTZISHSZUJUKUNUPNULUNUMI
      SHSUPUMIHOUMUOHIADHEIPQUAUBABCDEHIFGRUKAEBTDCTZBSCSZULUPUIUQCBADCEBPQURUP
      NCBACBEDIHGFRUCUDUEUFUG $.
  $}

  ${
    $d u v x $.  $d s t u v y $.  $d s t x ph $.  $d y ph $.
    $( Special case of ~ ax-7 derived from ~ ax-7v .  (Contributed by NM,
       21-May-2018.) $)
    ax7w12AUX7 $p |- ( A. x A. y [ x / u ] [ y / v ] ph
         -> A. y A. x [ x / u ] [ y / v ] ph ) $=
      ( nfv ax7w14AUX7 ) ABCDEABFACFG $.
  $}

  ${
    $d u v $.  $d u y $.
    $( Substitution applied to an atomic membership wff.  (Contributed by NM,
       21-May-2018.) $)
    elsb34AUX7 $p |- ( [ x / u ] [ y / v ] u e. v <-> x e. y ) $=
      ( wel wsb elsb4NEW7 sbbii elsb3NEW7 bitri ) DCECBFZDAFDBEZDAFABEKLDABCDGH
      ADBIJ $.
  $}

  ${
    $d u v x $.  $d u v y $.
    $( Special case of ~ ax-7 derived from ~ ax-7v .  Example illustrating use
       of ~ ax7w12AUX7 .  (Contributed by NM, 21-May-2018.) $)
    ax7w13AUX7 $p |- ( A. x A. y x e. y -> A. y A. x x e. y ) $=
      ( vu vv wel wsb wal ax7w12AUX7 elsb34AUX7 2albii 3imtr3i ) CDEZDBFCAFZBGA
      GMAGBGABEZBGAGNAGBGLABDCHMNABABDCIZJMNBAOJK $.
  $}

  $( Special case of ~ ax-7 derived from ~ ax-7v .  This is the "easy"
     direction.  The other direction is still conjectured.  (Contributed by NM,
     24-May-2018.) $)
  ax7w16AUX7 $p |- ( A. z A. x x = y -> A. x A. z x = y ) $=
    ( weq wal hbaew0AUX7 a5i sps ) ABDZAEICEZAECIJAABCFGH $.

  ${
    $d u v y $.
    $( Lemma for ~ ax7w17lem2AUX7 .  (Contributed by NM, 24-May-2018.) $)
    ax7w17lem1AUX7 $p |- ( [ x / u ] [ z / v ] u = y <-> x = y ) $=
      ( weq wsb nfv sbf sbbii equsb3NEW7 bitri ) EBFZDCGZEAGMEAGABFNMEAMDCMDHIJ
      AEBKL $.
  $}

  ${
    $d u v ph $.  $d u v x $.  $d u v y $.  $d u v z $.
    ax7w17lem2AUX7.x $e |- F/ x ph $.
    ax7w17lem2AUX7.z $e |- F/ z ph $.
    ax7w17lem2AUX7.1 $e |- ( ph -> F/ x u = y ) $.
    ax7w17lem2AUX7.2 $e |- ( ph -> F/ z u = y ) $.
    $( Experimental lemma with the goal of deriving ~ hbae from ~ ax-7v .
       Looks like a dead end because we apparently need ~ hbae to eliminate the
       first 2 hypotheses for those ` ph ` that satisfy the 3rd and 4th
       hypotheses.  (Contributed by NM, 24-May-2018.) $)
    ax7w17lem2AUX7 $p |- ( ph -> ( A. x A. z x = y -> A. z A. x x = y ) ) $=
      ( vv weq wsb wal ax7w15AUX7 ax7w17lem1AUX7 2albii 3imtr3g ) AECKZJDLEBLZD
      MBMSBMDMBCKZDMBMTBMDMARBDJEFGHINSTBDBCDJEOZPSTDBUAPQ $.
  $}

  ${
    $d u v $.
    $( Weak version of ~ ax-7 not requiring ~ ax-7 .  (Contributed by NM,
       24-May-2018.) $)
    ax7w18AUX7 $p |- ( A. u u = v -> ( A. x A. y ph -> A. y A. x ph ) ) $=
      ( wal weq sp alimi a16gNEW7 syl5 ) ACFZBFABFZEDGEFMCFLABACHIMEDCJK $.
  $}

$(
  @{
    ax7w6.1 @e |- ( A. x A. y ph -> A. y A. x ph ) @.
    @( Propagate negation through ~ ax-7 , using only ~ ax7vAUX7 .
    (Contributed by NM, 12-Oct-2017.) @)
    ax7w6AUX7 @p |- ( A. x A. y -. ph -> A. y A. x -. ph ) @=
? @.
  @}

  @{
    ax7wcbv1h.1 @e |- ( ps -> A. y ps ) @.
    ax7wcbv1h.2 @e |- ( ch -> A. x ch ) @.
    ax7wcbv1h.3 @e |- ( x = y -> ( ps -> ch ) ) @.
    @( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) @)
    ax7wcbv1h @p |- ( A. x ps -> A. y ch ) @=
      ? @.
  @}

  @{
    ax7wxxx.1 @e |- F/ y ph @.
    @( One direction of ~ sb8 not requiring ~ ax-7 .
       (Contributed by NM, 10-Oct-2017.) @)
    ax7wxxx @p |- ( A. y [ y / x ] ph -> A. x ph ) @=
  ( wtru wal wsb wi nfs1 nfri sps a1i syl6 stdpc7 com23 wnf nfrd syl6d al2imi
  id ax9o syl syld tru ax-gen mpg ) ECFZABCGZCFZABFZHBUGBFZUI?UJUKUIUHBFZ?UIULH
  UKUHULCUHBABCDIJKL?MUKUK?UKTUG?ABUG??AE??CE??AACFE??A?EAC?NLOEACACPEDLQRSAC?U
  AMSUBUCECUDUEUF @.
  @}

  @( ax7vAUX7  @)
  ax7wxxx @p |- ( [ y / x ] A. x ph -> A. x [ y / x ] ph ) @=
      ? @.

  @( ax7vAUX7  @)
  ax7wxxx @p |- ( A. y [ y / x ] ph -> A. x [ y / x ] ph ) @=
      ? @.
$)

$(
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
            Theorems derived from ax-7 (suffix OLD7)
-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-.-
$)

  $( Axiom of Quantifier Commutation.  This axiom says universal quantifiers
     can be swapped.  One of the 4 axioms of pure predicate calculus.  Axiom
     scheme C6' in [Megill] p. 448 (p. 16 of the preprint).  Also appears as
     Lemma 12 of [Monk2] p. 109 and Axiom C5-3 of [Monk2] p. 113.  This axiom
     scheme is logically redundant (see ~ ax7w ) but is used as an auxiliary
     axiom to achieve metalogical completeness.  (Contributed by NM,
     5-Aug-1993.) $)
  ax-7OLD7 $a |- ( A. x A. y ph -> A. y A. x ph ) $.

  ${
    a7s.1OLD7 $e |- ( A. x A. y ph -> ps ) $.
    $( Swap quantifiers in an antecedent.  (Contributed by NM, 5-Aug-1993.) $)
    a7sOLD7 $p |- ( A. y A. x ph -> ps ) $=
      ( wal ax-7OLD7 syl ) ACFDFADFCFBADCGEH $.
  $}

  ${
    hbal.1OLD7 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` .
       (Contributed by NM, 5-Aug-1993.) $)
    hbalOLD7 $p |- ( A. y ph -> A. x A. y ph ) $=
      ( wal alimi ax-7OLD7 syl ) ACEZABEZCEIBEAJCDFACBGH $.
  $}

  $( Theorem 19.5 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.) $)
  alcomOLD7 $p |- ( A. x A. y ph <-> A. y A. x ph ) $=
    ( wal ax-7OLD7 impbii ) ACDBDABDCDABCEACBEF $.

  $( Theorem *11.21 in [WhiteheadRussell] p. 160.  (Contributed by Andrew
     Salmon, 24-May-2011.) $)
  alrot3OLD7 $p |- ( A. x A. y A. z ph <-> A. y A. z A. x ph ) $=
    ( wal alcomOLD7 albii bitri ) ADEZCEBEIBEZCEABEDEZCEIBCFJKCABDFGH $.

  $( Rotate 4 universal quantifiers twice.  (Contributed by NM, 2-Feb-2005.)
     (Proof shortened by Fan Zheng, 6-Jun-2016.) $)
  alrot4OLD7 $p |- ( A. x A. y A. z A. w ph <-> A. z A. w A. x A. y ph ) $=
    ( wal alrot3OLD7 albii bitri ) AEFDFCFZBFACFZEFDFZBFKBFEFDFJLBACDEGHKBDEGI
    $.

  ${
    hbald.1OLD7 $e |- ( ph -> A. y ph ) $.
    hbald.2OLD7 $e |- ( ph -> ( ps -> A. x ps ) ) $.
    $( Deduction form of bound-variable hypothesis builder ~ hbalOLD7 .
       (Contributed by NM, 2-Jan-2002.) $)
    hbaldOLD7 $p |- ( ph -> ( A. y ps -> A. x A. y ps ) ) $=
      ( wal alimdh ax-7OLD7 syl6 ) ABDGZBCGZDGKCGABLDEFHBDCIJ $.
  $}

  ${
    hbex.1OLD7 $e |- ( ph -> A. x ph ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` .
       (Contributed by NM, 5-Aug-1993.) $)
    hbexOLD7 $p |- ( E. y ph -> A. x E. y ph ) $=
      ( wex wn wal df-ex hbn hbalOLD7 hbxfrbi ) ACEAFZCGZFBACHMBLBCABDIJIK $.
  $}

  $( Theorem 19.12OLD7 of [Margaris] p. 89.  Assuming the converse is a mistake
     sometimes made by beginners!  But sometimes the converse does hold, as in
     ~ 19.12vvOLD7 and ~ r19.12sn .  (Contributed by NM, 5-Aug-1993.) $)
  19.12OLD7 $p |- ( E. x A. y ph -> A. y E. x ph ) $=
    ( wal wex hba1 hbexOLD7 sp eximi alrimih ) ACDZBEABECKCBACFGKABACHIJ $.

  ${
    nf.1OLD7 $e |- F/ x ph $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfalOLD7 $p |- F/ x A. y ph $=
      ( wal nfri hbalOLD7 nfi ) ACEBABCABDFGH $.

    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfexOLD7 $p |- F/ x E. y ph $=
      ( wex wn wal df-ex nfn nfalOLD7 nfxfr ) ACEAFZCGZFBACHMBLBCABDIJIK $.

    $( If ` x ` is not free in ` ph ` , it is not free in ` F/ y ph ` .
       (Contributed by Mario Carneiro, 11-Aug-2016.) $)
    nfnfOLD7 $p |- F/ x F/ y ph $=
      ( wnf wal wi df-nf wtru a1i nfalOLD7 nfimd trud nfxfr ) ACEAACFZGZCFBACHP
      BCPBEIAOBABEIDJOBEIABCDKJLMKN $.
  $}

  ${
    nfald.1OLD7 $e |- F/ y ph $.
    nfald.2OLD7 $e |- ( ph -> F/ x ps ) $.
    $( If ` x ` is not free in ` ph ` , it is not free in ` A. y ph ` .
       (Contributed by Mario Carneiro, 24-Sep-2016.) $)
    nfaldOLD7 $p |- ( ph -> F/ x A. y ps ) $=
      ( wnf wal alrimi nfnf1 nfalOLD7 nfr al2imi ax-7OLD7 syl6 nfd syl ) ABCGZD
      HZBDHZCGARDEFISTCRCDBCJKSTBCHZDHTCHRBUADBCLMBDCNOPQ $.

    $( If ` x ` is not free in ` ph ` , it is not free in ` E. y ph ` .
       (Contributed by Mario Carneiro, 24-Sep-2016.) $)
    nfexdOLD7 $p |- ( ph -> F/ x E. y ps ) $=
      ( wex wn wal df-ex nfnd nfaldOLD7 nfxfrd ) BDGBHZDIZHACBDJAOCANCDEABCFKLK
      M $.
  $}

  $( Lemma 24 of [Monk2] p. 114.  (Contributed by Mario Carneiro,
     24-Sep-2016.) $)
  nfa2OLD7 $p |- F/ x A. y A. x ph $=
    ( wal nfa1 nfalOLD7 ) ABDBCABEF $.

  $( One direction of Theorem 19.11 of [Margaris] p. 89.  (Contributed by NM,
     5-Aug-1993.)  (Revised by Mario Carneiro, 24-Sep-2016.) $)
  excomimOLD7 $p |- ( E. x E. y ph -> E. y E. x ph ) $=
    ( wex 19.8a 2eximi nfe1 nfexOLD7 19.9 sylib ) ACDBDABDZCDZBDLAKBCABEFLBKBCA
    BGHIJ $.

  $( Theorem 19.11 of [Margaris] p. 89.  (Contributed by NM, 5-Aug-1993.) $)
  excomOLD7 $p |- ( E. x E. y ph <-> E. y E. x ph ) $=
    ( wex excomimOLD7 impbii ) ACDBDABDCDABCEACBEF $.

  $( Swap 1st and 3rd existential quantifiers.  (Contributed by NM,
     9-Mar-1995.) $)
  excom13OLD7 $p |- ( E. x E. y E. z ph <-> E. z E. y E. x ph ) $=
    ( wex excomOLD7 exbii 3bitri ) ADEZCEBEIBEZCEABEZDEZCEKCEDEIBCFJLCABDFGKCDF
    H $.

  $( Rotate existential quantifiers.  (Contributed by NM, 17-Mar-1995.) $)
  exrot3OLD7 $p |- ( E. x E. y E. z ph <-> E. y E. z E. x ph ) $=
    ( wex excom13OLD7 excomOLD7 bitri ) ADECEBEABEZCEDEIDECEABCDFIDCGH $.

  $( Rotate existential quantifiers twice.  (Contributed by NM, 9-Mar-1995.) $)
  exrot4OLD7 $p |- ( E. x E. y E. z E. w ph <-> E. z E. w E. x E. y ph ) $=
    ( wex excom13OLD7 exbii bitri ) AEFDFCFZBFACFZDFEFZBFKBFEFDFJLBACDEGHKBEDGI
    $.

  ${
    aaan.1OLD7 $e |- F/ y ph $.
    aaan.2OLD7 $e |- F/ x ps $.
    $( Rearrange universal quantifiers.  (Contributed by NM, 12-Aug-1993.) $)
    aaanOLD7 $p |- ( A. x A. y ( ph /\ ps ) <-> ( A. x ph /\ A. y ps ) ) $=
      ( wa wal 19.28 albii nfalOLD7 19.27 bitri ) ABGDHZCHABDHZGZCHACHOGNPCABDE
      IJAOCBCDFKLM $.
  $}

  ${
    eeor.1OLD7 $e |- F/ y ph $.
    eeor.2OLD7 $e |- F/ x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 8-Aug-1994.) $)
    eeorOLD7 $p |- ( E. x E. y ( ph \/ ps ) <-> ( E. x ph \/ E. y ps ) ) $=
      ( wo wex 19.45 exbii nfexOLD7 19.44 bitri ) ABGDHZCHABDHZGZCHACHOGNPCABDE
      IJAOCBCDFKLM $.
  $}

  ${
    $d ph y $.  $d ps x $.
    $( Theorem *11.53 in [WhiteheadRussell] p. 164.  (Contributed by Andrew
       Salmon, 24-May-2011.) $)
    pm11.53OLD7 $p |- ( A. x A. y ( ph -> ps ) <-> ( E. x ph -> A. y ps ) ) $=
      ( wi wal wex 19.21v albii nfv nfalOLD7 19.23 bitri ) ABEDFZCFABDFZEZCFACG
      OENPCABDHIAOCBCDBCJKLM $.
  $}

  ${
    $d x ps $.  $d y ph $.
    $( Special case of ~ 19.12OLD7 where its converse holds.  (Contributed by
       NM, 18-Jul-2001.)  (Revised by Andrew Salmon, 11-Jul-2011.) $)
    19.12vvOLD7 $p |- ( E. x A. y ( ph -> ps ) <-> A. y E. x ( ph -> ps ) ) $=
      ( wi wal wex 19.21v exbii nfalOLD7 19.36 19.36v albii 19.21 bitr2i 3bitri
      nfv ) ABEZDFZCGABDFZEZCGACFZTEZRCGZDFZSUACABDHIATCBCDBCQJKUEUBBEZDFUCUDUF
      DABCLMUBBDADCADQJNOP $.
  $}

  ${
    eean.1OLD7 $e |- F/ y ph $.
    eean.2OLD7 $e |- F/ x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 27-Oct-2010.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    eeanOLD7 $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x ph /\ E. y ps ) ) $=
      ( wa wex 19.42 exbii nfexOLD7 19.41 bitri ) ABGDHZCHABDHZGZCHACHOGNPCABDE
      IJAOCBCDFKLM $.
  $}

  ${
    $d y ph $.  $d x ps $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 26-Jul-1995.) $)
    eeanvOLD7 $p |- ( E. x E. y ( ph /\ ps ) <-> ( E. x ph /\ E. y ps ) ) $=
      ( nfv eeanOLD7 ) ABCDADEBCEF $.
  $}

  ${
    $d y ph $.  $d z ph $.  $d x z ps $.  $d x y ch $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 26-Jul-1995.)
       (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    eeeanvOLD7 $p |- ( E. x E. y E. z ( ph /\ ps /\ ch ) <->
                 ( E. x ph /\ E. y ps /\ E. z ch ) ) $=
      ( w3a wex wa df-3an 3exbii eeanvOLD7 exbii anbi1i 19.41v 3bitr4i 3bitri )
      ABCGZFHEHDHABIZCIZFHEHZDHSEHZCFHZIZDHZADHZBEHZUCGZRTDEFABCJKUAUDDSCEFLMUB
      DHZUCIUFUGIZUCIUEUHUIUJUCABDELNUBUCDOUFUGUCJPQ $.
  $}

  ${
    $d z ph $.  $d w ph $.  $d x ps $.  $d y ps $.  $d y z $.  $d w x $.
    $( Rearrange existential quantifiers.  (Contributed by NM, 31-Jul-1995.) $)
    ee4anvOLD7 $p |- ( E. x E. y E. z E. w ( ph /\ ps ) <->
                  ( E. x E. y ph /\ E. z E. w ps ) ) $=
      ( wa wex excomOLD7 exbii eeanvOLD7 2exbii 3bitri ) ABGFHZEHDHZCHNDHZEHZCH
      ADHZBFHZGZEHCHRCHSEHGOQCNDEIJPTCEABDFKLRSCEKM $.
  $}

  ${
    $d w x z $.  $d w y $.
    ax12olem2.1OLD7 $e |- ( -. x = y -> ( y = w -> A. x y = w ) ) $.
    $( Lemma for ~ ax12oNEW7 .  Negate the equalities in ~ ax-12 , shown as the
       hypothesis.  (Contributed by NM, 24-Dec-2015.) $)
    ax12olem2OLD7 $p |- ( -. x = y -> ( -. y = z -> A. x -. y = z ) ) $=
      ( weq wn wa wex anim1d ax-17 anim2i 19.26 sylibr syl6 eximdv ax12olem1OLD
      wal 19.12OLD7 albii 3imtr3g ) ABFGZBDFZCDFGZHZDIZUFARZBCFGZUHARUBUFUEARZD
      IUGUBUEUIDUBUEUCARZUDHZUIUBUCUJUDEJUKUJUDARZHUIUDULUJUDAKLUCUDAMNOPUEDASO
      BCDQZUFUHAUMTUA $.
  $}

  ${
    $d w x z $.  $d w y z $.
    ax12olem4.1OLD7 $e |- ( -. x = y -> ( y = z -> A. x y = z ) ) $.
    ax12olem4.2OLD7 $e |- ( -. x = y -> ( y = w -> A. x y = w ) ) $.
    $( Lemma for ~ ax12oNEW7 .  Construct an intermediate equivalent to ~ ax-12
       from two instances of ~ ax-12 .  (Contributed by NM, 24-Dec-2015.) $)
    ax12olem4OLD7 $p |- ( -. x = y -> ( -. A. x -. y = z -> A. x y = z ) ) $=
      ( weq wn wal wi ax12olem2OLD7 ax12olem3OLD mpbir2an ) ABGHZBCGZHZAIZHOAIZ
      JJNORJJNPQJJEABCDFKABCLM $.
  $}

  $( All variables are effectively bound in an identical variable specifier.
     (Contributed by NM, 5-Aug-1993.) $)
  hbaeOLD7 $p |- ( A. x x = y -> A. z A. x x = y ) $=
    ( weq wal wi wn sp ax12oNEW7 syl7 ax10oNEW7 aecomsNEW7 pm2.43i pm2.61ii a5i
    syl5 ax-7OLD7 syl ) ABDZAEZSCEZAETCESUAACADCEZCBDCEZTUAFZTSUBGUCGUASAHABCIJ
    UDACSACKLUDBCTSBEZBCDBEUATUESABKMSBCKPLNOSACQR $.

  $( All variables are effectively bound in an identical variable specifier.
     (Contributed by Mario Carneiro, 11-Aug-2016.) $)
  nfaeOLD7 $p |- F/ z A. x x = y $=
    ( weq wal hbaeOLD7 nfi ) ABDAECABCFG $.

  $( All variables are effectively bound in a distinct variable specifier.
     Lemma L19 in [Megill] p. 446 (p. 14 of the preprint).  (Contributed by NM,
     5-Aug-1993.) $)
  hbnaeOLD7 $p |- ( -. A. x x = y -> A. z -. A. x x = y ) $=
    ( weq wal hbaeOLD7 hbn ) ABDAECABCFG $.

  $( All variables are effectively bound in a distinct variable specifier.
     (Contributed by Mario Carneiro, 11-Aug-2016.) $)
  nfnaeOLD7 $p |- F/ z -. A. x x = y $=
    ( weq wal nfaeOLD7 nfn ) ABDAECABCFG $.

  ${
    hbnalequs.1OLD7 $e |- ( A. z -. A. x x = y -> ph ) $.
    $( Rule that applies ~ hbnaeOLD7 to antecedent.  (Contributed by NM,
       5-Aug-1993.) $)
    hbnaesOLD7 $p |- ( -. A. x x = y -> ph ) $=
      ( weq wal wn hbnaeOLD7 syl ) BCFBGHZKDGABCDIEJ $.
  $}

  ${
    dvelimh.1OLD7 $e |- ( ph -> A. x ph ) $.
    dvelimh.2OLD7 $e |- ( ps -> A. z ps ) $.
    dvelimh.3OLD7 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelimOLD7 without any variable restrictions.  (Contributed
       by NM, 1-Oct-2002.) $)
    dvelimhOLD7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( weq wal wn wi hba1 ax10oNEW7 aecomsNEW7 syl5 a1d wa hbnaeOLD7 hban imp
      ax12oNEW7 a1i hbimd hbaldOLD7 ex pm2.61i equsalhNEW7 albii 3imtr3g ) CDIC
      JKZEDIZALZEJZUNCJZBBCJCEICJZUKUNUOLZLUPUQUKUNUNEJZUPUOUMEMURUOLECUNECNOPQ
      UPKZUKUQUSUKRZUMCEUSUKECEESCDESTUTULACUSUKCCECSCDCSTUSUKULULCJLEDCUBUAAAC
      JLUTFUCUDUEUFUGABEDGHUHZUNBCVAUIUJ $.
  $}

  ${
    dral1.1OLD7 $e |- ( A. x x = y -> ( ph <-> ps ) ) $.
    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 27-Feb-2005.) $)
    dral2OLD7 $p |- ( A. x x = y -> ( A. z ph <-> A. z ps ) ) $=
      ( weq wal hbaeOLD7 albidh ) CDGCHABECDEIFJ $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       Part of Theorem 9.4 of [Megill] p. 448 (p. 16 of preprint).
       (Contributed by NM, 27-Feb-2005.) $)
    drex2OLD7 $p |- ( A. x x = y -> ( E. z ph <-> E. z ps ) ) $=
      ( weq wal hbaeOLD7 exbidh ) CDGCHABECDEIFJ $.

    $( Formula-building lemma for use with the Distinctor Reduction Theorem.
       (Contributed by Mario Carneiro, 4-Oct-2016.) $)
    drnf2OLD7 $p |- ( A. x x = y -> ( F/ z ph <-> F/ z ps ) ) $=
      ( weq wal wi wnf dral2OLD7 imbi12d df-nf 3bitr4g ) CDGCHZAAEHZIZEHBBEHZIZ
      EHAEJBEJQSCDEOABPRFABCDEFKLKAEMBEMN $.
  $}

  ${
    nfald2.1OLD7 $e |- F/ y ph $.
    nfald2.2OLD7 $e |- ( ( ph /\ -. A. x x = y ) -> F/ x ps ) $.
    $( Variation on ~ nfaldOLD7 which adds the hypothesis that ` x ` and ` y `
       are distinct in the inner subproof.  (Contributed by Mario Carneiro,
       8-Oct-2016.) $)
    nfald2OLD7 $p |- ( ph -> F/ x A. y ps ) $=
      ( weq wal wn wa nfnaeOLD7 nfan nfaldOLD7 ex nfa1 biidd drnf1NEW7 pm2.61d2
      wnf mpbiri ) ACDGCHZBDHZCSZAUAIZUCAUDJBCDAUDDECDDKLFMNUAUCUBDSBDOUBUBCDUA
      UBPQTR $.

    $( Variation on ~ nfexdOLD7 which adds the hypothesis that ` x ` and ` y `
       are distinct in the inner subproof.  (Contributed by Mario Carneiro,
       8-Oct-2016.) $)
    nfexd2OLD7 $p |- ( ph -> F/ x E. y ps ) $=
      ( wex wn wal df-ex weq wa nfnd nfald2OLD7 nfxfrd ) BDGBHZDIZHACBDJAQCAPCD
      EACDKCIHLBCFMNMO $.
  $}

  ${
    cbv1h.1OLD7 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv1h.2OLD7 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv1h.3OLD7 $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbv1hOLD7 $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( wal wi sps al2imi ax-7OLD7 syl6 weq com23 syl6d ax9oNEW7 a7sOLD7 syld )
      AEIZDIZBDIZUCEIZCEIZUBUCBEIZDIUDUABUFDABUFJEFKLBDEMNAUDUEJEDADIZUCCEUGUCD
      EOZCDIZJZDICABUJDABUHCUIAUHBCHPGQLCDERNLST $.
  $}

  ${
    cbv1.1OLD7 $e |- ( ph -> F/ y ps ) $.
    cbv1.2OLD7 $e |- ( ph -> F/ x ch ) $.
    cbv1.3OLD7 $e |- ( ph -> ( x = y -> ( ps -> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       3-Oct-2016.) $)
    cbv1OLD7 $p |- ( A. x A. y ph -> ( A. x ps -> A. y ch ) ) $=
      ( nfrd cbv1hOLD7 ) ABCDEABEFIACDGIHJ $.
  $}

  ${
    cbv2h.1OLD7 $e |- ( ph -> ( ps -> A. y ps ) ) $.
    cbv2h.2OLD7 $e |- ( ph -> ( ch -> A. x ch ) ) $.
    cbv2h.3OLD7 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbv2hOLD7 $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal weq wb wi bi1 syl6 cbv1hOLD7 equcomi bi2 syl56 a7sOLD7 impbid ) AEI
      DIBDIZCEIZABCDEFGADEJZBCKZBCLHBCMNOAUBUALEDACBEDGFEDJUCAUDCBLEDPHBCQROST
      $.
  $}

  ${
    cbv2.1OLD7 $e |- ( ph -> F/ y ps ) $.
    cbv2.2OLD7 $e |- ( ph -> F/ x ch ) $.
    cbv2.3OLD7 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       3-Oct-2016.) $)
    cbv2OLD7 $p |- ( A. x A. y ph -> ( A. x ps <-> A. y ch ) ) $=
      ( nfrd cbv2hOLD7 ) ABCDEABEFIACDGIHJ $.
  $}

  ${
    cbv3.1OLD7 $e |- F/ y ph $.
    cbv3.2OLD7 $e |- F/ x ps $.
    cbv3.3OLD7 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution, that
       does not use ~ ax-12o .  (Contributed by NM, 5-Aug-1993.) $)
    cbv3OLD7 $p |- ( A. x ph -> A. y ps ) $=
      ( wtru wal wi wnf a1i weq cbv1OLD7 tru ax-gen mpg ) HDIACIBDIJCHABCDADKHE
      LBCKHFLCDMABJJHGLNHDOPQ $.
  $}

  ${
    cbv3h.1OLD7 $e |- ( ph -> A. y ph ) $.
    cbv3h.2OLD7 $e |- ( ps -> A. x ps ) $.
    cbv3h.3OLD7 $e |- ( x = y -> ( ph -> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Proof shortened by Andrew Salmon,
       25-May-2011.)  (Proof modification is discouraged.) $)
    cbv3hOLD7 $p |- ( A. x ph -> A. y ps ) $=
      ( weq wal wi a1i cbv1hOLD7 stdpc6 mpg ) DDHZDIACIBDIJCOABCDAADIJOEKBBCIJO
      FKCDHABJJOGKLDMN $.
  $}

  ${
    cbval.1OLD7 $e |- F/ y ph $.
    cbval.2OLD7 $e |- F/ x ps $.
    cbval.3OLD7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       3-Oct-2016.) $)
    cbvalOLD7 $p |- ( A. x ph <-> A. y ps ) $=
      ( wal weq biimpd cbv3OLD7 wi biimprd equcoms impbii ) ACHBDHABCDEFCDIZABG
      JKBADCFEBALCDPABGMNKO $.
  $}

  ${
    cbvex.1OLD7 $e |- F/ y ph $.
    cbvex.2OLD7 $e |- F/ x ps $.
    cbvex.3OLD7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbvexOLD7 $p |- ( E. x ph <-> E. y ps ) $=
      ( wn wal wex nfn weq notbid cbvalOLD7 notbii df-ex 3bitr4i ) AHZCIZHBHZDI
      ZHACJBDJSUARTCDADEKBCFKCDLABGMNOACPBDPQ $.
  $}

  ${
    dvelimf.1OLD7 $e |- F/ x ph $.
    dvelimf.2OLD7 $e |- F/ z ps $.
    dvelimf.3OLD7 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelimvNEW7 without any variable restrictions.
       (Contributed by NM, 1-Oct-2002.)  (Revised by Mario Carneiro,
       6-Oct-2016.) $)
    dvelimfOLD7 $p |- ( -. A. x x = y -> F/ x ps ) $=
      ( weq wi wal wn equsalNEW7 bicomi nfnaeOLD7 wa nfa1 nfn nfan ax12oNEW7
      impcom nfd wnf a1i nfimd nfald2OLD7 nfxfrd ) BEDIZAJZEKZCDIZCKZLZCUJBABED
      GHMNUMUICECDEOUMCEIZCKZLZPZUHACUQUHCUMUPCULCUKCQRUOCUNCQRSUPUMUHUHCKJEDCT
      UAUBACUCUQFUDUEUFUG $.
  $}

  ${
    $d y ph $.  $d x ps $.
    cbvalv.1OLD7 $e |- ( x = y -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbvalvOLD7 $p |- ( A. x ph <-> A. y ps ) $=
      ( nfv cbvalOLD7 ) ABCDADFBCFEG $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 5-Aug-1993.) $)
    cbvexvOLD7 $p |- ( E. x ph <-> E. y ps ) $=
      ( nfv cbvexOLD7 ) ABCDADFBCFEG $.
  $}

  ${
    $d y x $.  $d y z $.  $d w x $.  $d w z $.
    cbval2.1OLD7 $e |- F/ z ph $.
    cbval2.2OLD7 $e |- F/ w ph $.
    cbval2.3OLD7 $e |- F/ x ps $.
    cbval2.4OLD7 $e |- F/ y ps $.
    cbval2.5OLD7 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 22-Dec-2003.)  (Revised by Mario Carneiro,
       6-Oct-2016.) $)
    cbval2OLD7 $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      ( wal nfalOLD7 weq wb wa nfv nfan cbvalOLD7 19.28v expcom pm5.32d 3bitr3i
      wi pm5.32 mpbir ) ADLZBFLZCEAEDGMBCFIMCENZUGUHOUDUIUGPZUIUHPZOUIAPZDLUIBP
      ZFLUJUKULUMDFUIAFUIFQHRUIBDUIDQJRDFNZUIABUIUNABOKUAUBSUIADTUIBFTUCUIUGUHU
      EUFS $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 14-Sep-2003.)  (Revised by Mario Carneiro,
       6-Oct-2016.) $)
    cbvex2OLD7 $p |- ( E. x E. y ph <-> E. z E. w ps ) $=
      ( wex nfexOLD7 weq wb wa nfv nfan cbvexOLD7 19.42v expcom pm5.32d 3bitr3i
      wi pm5.32 mpbir ) ADLZBFLZCEAEDGMBCFIMCENZUGUHOUDUIUGPZUIUHPZOUIAPZDLUIBP
      ZFLUJUKULUMDFUIAFUIFQHRUIBDUIDQJRDFNZUIABUIUNABOKUAUBSUIADTUIBFTUCUIUGUHU
      EUFS $.
  $}

  ${
    $d z w ph $.  $d x y ps $.  $d x w $.  $d z y $.
    cbval2v.1OLD7 $e |- ( ( x = z /\ y = w ) -> ( ph <-> ps ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 4-Feb-2005.) $)
    cbval2vOLD7 $p |- ( A. x A. y ph <-> A. z A. w ps ) $=
      ( nfv cbval2OLD7 ) ABCDEFAEHAFHBCHBDHGI $.

    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 26-Jul-1995.) $)
    cbvex2vOLD7 $p |- ( E. x E. y ph <-> E. z E. w ps ) $=
      ( nfv cbvex2OLD7 ) ABCDEFAEHAFHBCHBDHGI $.
  $}

  ${
    $d x ph $.  $d x ch $.
    cbvald.1OLD7 $e |- F/ y ph $.
    cbvald.2OLD7 $e |- ( ph -> F/ y ps ) $.
    cbvald.3OLD7 $e |- ( ph -> ( x = y -> ( ps <-> ch ) ) ) $.
    $( Deduction used to change bound variables, using implicit substitution,
       particularly useful in conjunction with ~ dvelimOLD7 .  (Contributed by
       NM, 2-Jan-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    cbvaldOLD7 $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( wal wb nfri alrimiv nfvd cbv2OLD7 syl ) AAEIZDIBDICEIJAPDAEFKLABCDEGACD
      MHNO $.

    $( Deduction used to change bound variables, using implicit substitution,
       particularly useful in conjunction with ~ dvelimOLD7 .  (Contributed by
       NM, 2-Jan-2002.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    cbvexdOLD7 $p |- ( ph -> ( E. x ps <-> E. y ch ) ) $=
      ( wn wal wex nfnd weq wb notbi syl6ib cbvaldOLD7 notbid df-ex 3bitr4g ) A
      BIZDJZICIZEJZIBDKCEKAUBUDAUAUCDEFABEGLADEMBCNUAUCNHBCOPQRBDSCEST $.
  $}

  ${
    $d ps y $.  $d ch x $.  $d ph x $.  $d ph y $.
    cbvaldva.1OLD7 $e |- ( ( ph /\ x = y ) -> ( ps <-> ch ) ) $.
    $( Rule used to change the bound variable in a universal quantifier with
       implicit substitution.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    cbvaldvaOLD7 $p |- ( ph -> ( A. x ps <-> A. y ch ) ) $=
      ( nfv nfvd weq wb ex cbvaldOLD7 ) ABCDEAEGABEHADEIBCJFKL $.

    $( Rule used to change the bound variable in an existential quantifier with
       implicit substitution.  Deduction form.  (Contributed by David Moews,
       1-May-2017.) $)
    cbvexdvaOLD7 $p |- ( ph -> ( E. x ps <-> E. y ch ) ) $=
      ( nfv nfvd weq wb ex cbvexdOLD7 ) ABCDEAEGABEHADEIBCJFKL $.
  $}

  ${
    $( Define temporary individual variables. $)
    $(
    $v f $.
    $v g $.
    cbvex4v.vfOLD7 $f set f $.
    cbvex4v.vgOLD7 $f set g $.
    $)
    $d w z ch $.  $d u v ph $.  $d x y ps $.  $d f g ps $.  $d f w $.
    $d g z $.  $d u v w x y z $.
    cbvex4v.1OLD7 $e |- ( ( x = v /\ y = u ) -> ( ph <-> ps ) ) $.
    cbvex4v.2OLD7 $e |- ( ( z = f /\ w = g ) -> ( ps <-> ch ) ) $.
    $( Rule used to change bound variables, using implicit substitution.
       (Contributed by NM, 26-Jul-1995.) $)
    cbvex4vOLD7 $p |- ( E. x E. y E. z E. w ph <-> E. v E. u E. f E. g ch ) $=
      ( wex weq wa 2exbidv cbvex2vOLD7 2exbii bitri ) AGNFNZENDNBGNFNZINHNCKNJN
      ZINHNUAUBDEHIDHOEIOPABFGLQRUBUCHIBCFGJKMRST $.
  $}

  ${
    $d z ps $.
    dvelim.1OLD7 $e |- ( ph -> A. x ph ) $.
    dvelim.2OLD7 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( This theorem can be used to eliminate a distinct variable restriction on
       ` x ` and ` z ` and replace it with the "distinctor" ` -. A. x x = y `
       as an antecedent. ` ph ` normally has ` z ` free and can be read
       ` ph ( z ) ` , and ` ps ` substitutes ` y ` for ` z ` and can be read
       ` ph ( y ) ` .  We don't require that ` x ` and ` y ` be distinct: if
       they aren't, the distinctor will become false (in multiple-element
       domains of discourse) and "protect" the consequent.

       To obtain a closed-theorem form of this inference, prefix the hypotheses
       with ` A. x A. z ` , conjoin them, and apply ~ dvelimdfOLD7 .

       Other variants of this theorem are ~ dvelimhOLD7 (with no distinct
       variable restrictions), ~ dvelimhwNEW7 (that avoids ~ ax-12 ), and
       ~ dvelimALT (that avoids ~ ax-10 ).  (Contributed by NM,
       23-Nov-1994.) $)
    dvelimOLD7 $p |- ( -. A. x x = y -> ( ps -> A. x ps ) ) $=
      ( ax-17 dvelimhOLD7 ) ABCDEFBEHGI $.
  $}

  ${
    $d z ps $.
    dvelimnf.1OLD7 $e |- F/ x ph $.
    dvelimnf.2OLD7 $e |- ( z = y -> ( ph <-> ps ) ) $.
    $( Version of ~ dvelimOLD7 using "not free" notation.  (Contributed by
       Mario Carneiro, 9-Oct-2016.) $)
    dvelimnfOLD7 $p |- ( -. A. x x = y -> F/ x ps ) $=
      ( nfv dvelimfOLD7 ) ABCDEFBEHGI $.
  $}

  $( Substitution does not change an identical variable specifier.
     (Contributed by NM, 5-Aug-1993.) $)
  sbequ5OLD7 $p |- ( [ w / z ] A. x x = y <-> A. x x = y ) $=
    ( weq wal nfaeOLD7 sbfNEW7 ) ABEAFCDABCGH $.

  $( Substitution does not change a distinctor.  (Contributed by NM,
     5-Aug-1993.) $)
  sbequ6OLD7 $p |- ( [ w / z ] -. A. x x = y <-> -. A. x x = y ) $=
    ( weq wal wn nfnaeOLD7 sbfNEW7 ) ABEAFGCDABCHI $.

  ${
    $d x y $.  $d z ph $.
    $( Alternate proof of ~ ax16NEW7 .  (Contributed by NM, 8-Nov-2006.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    ax16ALT2OLD7 $p |- ( A. x x = y -> ( ph -> A. x ph ) ) $=
      ( weq wal aevNEW7 wsb sbequ12 biimpcd alimdv nfv nfs1NEW7 stdpc7 cbv3OLD7
      vz wi syl6com syl ) BCDBEBODZOEZAABEZPBCOBOFATABOGZOEUAASUBOSAUBABOHIJUBA
      OBABOAOKZLUCAOBMNQR $.
  $}

  ${
    $d x y $.
    $( A generalization of axiom ~ ax-16 .  Alternate proof of ~ a16gNEW7 that
       uses ~ df-sb .  (Contributed by NM, 5-Aug-1993.)  (Proof shortened by
       Andrew Salmon, 25-May-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    a16gALTOLD7 $p |- ( A. x x = y -> ( ph -> A. z ph ) ) $=
      ( weq wal aevNEW7 ax16ALT2OLD7 biidd dral1NEW7 biimprd sylsyld ) BCEBFDBE
      DFZAABFZADFZBCDDBGABCHMONAADBMAIJKL $.
  $}

  $( A variable not free remains so after substitution with a distinct variable
     (closed form of ~ nfsb4OLD7 ).  (Contributed by NM, 7-Apr-2004.)  (Revised
     by Mario Carneiro, 4-Oct-2016.) $)
  nfsb4tOLD7 $p |- ( A. x F/ z ph ->
                 ( -. A. z z = y -> F/ z [ y / x ] ph ) ) $=
    ( wnf wal weq wn wsb wi wa wb sbequ12 drnf2OLD7 biimpcd a1dd nfa1 nfnaeOLD7
    sps nfan nfeqfNEW7 adantl adantr nfimd nfaldOLD7 sb4bNEW7 nfbidf syl5ibrcom
    sp ex imbi2d pm2.61d exp3a nfsb2NEW7 drsb1NEW7 syl5ib pm2.61d2 ) ADEZBFZDBG
    DFZDCGDFHZABCIZDEZJUSUTHZVAVCUSBCGZBFZVDVAKZVCJZUSVFVCVGURVFVCJBVFURVCAVBBC
    DVEAVBLBABCMSNOSPUSVHVFHZVGVEAJZBFZDEZJUSVGVLUSVGKZVJDBUSVGBURBQVDVABDBBRDC
    BRTTVMVEADVGVEDEUSBCDUAUBUSURVGURBUIUCUDUEUJVIVCVLVGVIVBVKDBCDRABCUFUGUKUHU
    LUMVAADCIZDEUTVCADCUNVNVBDBDADBCUONUPUQ $.

  ${
    $d y z $.
    $( Weak version of ~ nfsb4t .  Still uses ~ ax-7OLD7 via ~ nfaldOLD7 .
       (Contributed by NM, 25-Nov-2017.) $)
    nfsb4tw2AUXOLD7 $p |- ( A. x F/ z ph ->
                   ( -. A. z z = y -> F/ z [ y / x ] ph ) ) $=
      ( wnf wal weq wn wsb wi wa sbequ12 sps drnf2w2AUX7 biimpcd a1dd aecomNEW7
      wb nfa1 nfan impbii nfbii mpbir nfn nfnaew3AUX7 nfeqfNEW7 adantl sp nfimd
      adantr nfaldOLD7 ex nfnaew2AUX7 sb4bNEW7 nfbidf imbi2d syl5ibrcom pm2.61d
      exp3a nfsb2NEW7 drsb1NEW7 drnf2w3AUX7 syl5ib pm2.61d2 ) ADEZBFZDBGDFZDCGD
      FHZABCIZDEZJVFVGHZVHVJVFBCGZBFZVKVHKZVJJZVFVMVJVNVEVMVJJBVMVEVJAVIBCDVLAV
      IRBABCLMNOMPVFVOVMHZVNVLAJZBFZDEZJVFVNVSVFVNKZVQDBVFVNBVEBSVKVHBVGBVGBEBD
      GZBFZBEWABSVGWBBVGWBDBQBDQUAUBUCUDDCBUETTVTVLADVNVLDEVFBCDUFUGVFVEVNVEBUH
      UJUIUKULVPVJVSVNVPVIVRDBCDUMABCUNUOUPUQURUSVHADCIZDEVGVJADCUTWCVIDBADBCVA
      VBVCVD $.
  $}

  ${
    nfsb4.1OLD7 $e |- F/ z ph $.
    $( A variable not free remains so after substitution with a distinct
       variable.  (Contributed by NM, 5-Aug-1993.)  (Revised by Mario Carneiro,
       4-Oct-2016.) $)
    nfsb4OLD7 $p |- ( -. A. z z = y -> F/ z [ y / x ] ph ) $=
      ( wnf weq wal wn wsb wi nfsb4tOLD7 mpg ) ADFDCGDHIABCJDFKBABCDLEM $.
  $}

  ${
    $d y z $.
    nfsb.1OLD7 $e |- F/ z ph $.
    $( If ` z ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` when
       ` y ` and ` z ` are distinct.  (Contributed by Mario Carneiro,
       11-Aug-2016.) $)
    nfsbOLD7 $p |- F/ z [ y / x ] ph $=
      ( weq wal wsb wnf a16nfNEW7 nfsb4OLD7 pm2.61i ) DCFDGABCHZDIMDCDJABCDEKL
      $.
  $}

  ${
    $d y z $.
    hbsb.1OLD7 $e |- ( ph -> A. z ph ) $.
    $( If ` z ` is not free in ` ph ` , it is not free in ` [ y / x ] ph ` when
       ` y ` and ` z ` are distinct.  (Contributed by NM, 12-Aug-1993.) $)
    hbsbOLD7 $p |- ( [ y / x ] ph -> A. z [ y / x ] ph ) $=
      ( wsb nfi nfsbOLD7 nfri ) ABCFDABCDADEGHI $.
  $}

  ${
    $d y z $.
    nfsbd.1OLD7 $e |- F/ x ph $.
    nfsbd.2OLD7 $e |- ( ph -> F/ z ps ) $.
    $( Deduction version of ~ nfsbOLD7 .  (Contributed by NM, 15-Feb-2013.) $)
    nfsbdOLD7 $p |- ( ph -> F/ z [ y / x ] ps ) $=
      ( weq wal wsb wnf wn wi alrimi nfsb4tOLD7 syl a16nfNEW7 pm2.61d2 ) AEDHEI
      ZBCDJZEKZABEKZCISLUAMAUBCFGNBCDEOPTEDEQR $.
  $}

  ${
    dvelimdf.1OLD7 $e |- F/ x ph $.
    dvelimdf.2OLD7 $e |- F/ z ph $.
    dvelimdf.3OLD7 $e |- ( ph -> F/ x ps ) $.
    dvelimdf.4OLD7 $e |- ( ph -> F/ z ch ) $.
    dvelimdf.5OLD7 $e |- ( ph -> ( z = y -> ( ps <-> ch ) ) ) $.
    $( Deduction form of ~ dvelimfOLD7 .  This version may be useful if we want
       to avoid ~ ax-17 and use ~ ax-16 instead.  (Contributed by NM,
       7-Apr-2004.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    dvelimdfOLD7 $p |- ( ph -> ( -. A. x x = y -> F/ x ch ) ) $=
      ( weq wal wn wnf wa wsb wi alrimi nfsb4tOLD7 syl imp nfa1 nfn nfan adantr
      wb sbiedNEW7 nfbidf mpbid ex ) ADELZDMZNZCDOZAUNPZBFEQZDOZUOAUNURABDOZFMU
      NURRAUSFHISBFEDTUAUBUPUQCDAUNDGUMDULDUCUDUEAUQCUGUNABCFEHJKUHUFUIUJUK $.
  $}

  ${
    sbco2.1OLD7 $e |- F/ z ph $.
    $( A composition law for substitution.  (Contributed by NM, 30-Jun-1994.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sbco2OLD7 $p |- ( [ y / z ] [ z / x ] ph <-> [ y / x ] ph ) $=
      ( weq wal wsb wb sbid2NEW7 sbequNEW7 syl5bbr sbequ12 bitr3d nfa1 nfs1NEW7
      sps wn nfn nfsb4OLD7 wi a1i sbiedNEW7 bicomd pm2.61i ) BCFZBGZABDHZDCHZAB
      CHZIZUFUKBUFAUIUJAUHDBHUFUIADBEJUHBCDKLZABCMNQUGRZUJUIUMAUIBCUGBUFBOSUHDC
      BABDEPTUFAUIIUAUMULUBUCUDUE $.
  $}

  ${
    sbco2d.1OLD7 $e |- F/ x ph $.
    sbco2d.2OLD7 $e |- F/ z ph $.
    sbco2d.3OLD7 $e |- ( ph -> F/ z ps ) $.
    $( A composition law for substitution.  (Contributed by NM, 5-Aug-1993.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sbco2dOLD7 $p |- ( ph -> ( [ y / z ] [ z / x ] ps <-> [ y / x ] ps ) ) $=
      ( wsb wi nfim1 sbco2OLD7 sbrimNEW7 sbbii bitri 3bitr3i pm5.74ri ) ABCEIZE
      DIZBCDIZABJZCEIZEDIZUACDIASJZATJUACDEABEGHKLUCARJZEDIUDUBUEEDABCEFMNAREDG
      MOABCDFMPQ $.
  $}

  $( A composition law for substitution.  (Contributed by NM, 5-Aug-1993.) $)
  sbco3OLD7 $p |- ( [ z / y ] [ y / x ] ph <-> [ z / x ] [ x / y ] ph ) $=
    ( weq wal wsb wb drsb1NEW7 sbequ12a alimi spsbbiNEW7 syl bitr3d wn sbcoNEW7
    sbbii nfnaeOLD7 nfsb2NEW7 sbco2dOLD7 syl5rbbr pm2.61i ) BCEZBFZABCGZCDGZACB
    GZBDGZHUDUEBDGZUFUHUEBCDIUDUEUGHZBFUIUHHUCUJBABCJKUEUGBDLMNUHUECBGZBDGUDOZU
    FUKUGBDACBPQULUECDBBCCRBCBRABCSTUAUB $.

  $( A commutativity law for substitution.  (Contributed by NM,
     27-May-1997.) $)
  sbcomOLD7 $p |- ( [ y / z ] [ y / x ] ph <-> [ y / x ] [ y / z ] ph ) $=
    ( weq wal wsb wb wn wa drsb1NEW7 nfa1 sbbidNEW7 bitr3d wi wnf albid sbequ12
    sb4bNEW7 sps adantr nfn aecomNEW7 impbii notbii nfbii mpbi nfnaeOLD7 19.21t
    nfan nfeqfNEW7 syl adantrr alcomOLD7 bi2.04 albii con3i sylan syl5bb imbi2d
    adantrl sylan9bbr adantl sylan9bb 3bitr4d pm2.61ian ex nfaeOLD7 pm2.61ii )
    BCEZBFZDCEZDFZABCGZDCGZADCGZBCGZHZVKIZVMIZVRBDEZBFZVSVTJZVRWBVRWCWBVNBCGVOV
    QVNBDCKWBVNVPBCWABLZABDCKMNUAWBIZWCJZVLVJAOZBFZOZDFZVJVLAOZDFZOZBFZVOVQWFVL
    WGOZBFZDFZWJWNWEVSWQWJHVTWEVSJZWPWIDWEVSDDBEZDFZIZDPWEDPWTDWSDLUBXAWEDWTWBW
    TWBDBUCZBDUCUDUEUFUGBCDUHZUJWRVLBPWPWIHDCBUKVLWGBUIULQUMWEVTWQWNHVSWQWODFZB
    FWEVTJZWNWODBUNXEXDWMBWEVTBWBBWDUBDCBUHZUJXDVJWKOZDFZXEWMWOXGDVLVJAUOUPXEVJ
    DPZXHWMHWEXAVTXIWTWBXBUQBCDUKURVJWKDUIULUSQUSVANWCVOWJHWEVTVOVLVNOZDFVSWJVN
    DCSVSXJWIDXCVSVNWHVLABCSUTQVBVCWCVQWNHWEVSVQVJVPOZBFVTWNVPBCSVTXKWMBXFVTVPW
    LVJADCSUTQVDVCVEVFVGVKVPVOVQVKAVNDCBCDVHVJAVNHBABCRTMVJVPVQHBVPBCRTNVMVNVOV
    QVLVNVOHDVNDCRTVMAVPBCDCBVHVLAVPHDADCRTMNVI $.

  ${
    sb5rf.1OLD7 $e |- F/ y ph $.
    $( Substitution of variable in universal quantifier.  (Contributed by NM,
       5-Aug-1993.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sb8OLD7 $p |- ( A. x ph <-> A. y [ y / x ] ph ) $=
      ( wal wsb nfalOLD7 stdpc4NEW7 alrimi nfs1NEW7 stdpc7 cbv3OLD7 impbii ) AB
      EZABCFZCENOCACBDGABCHIOACBABCDJDACBKLM $.

    $( Substitution of variable in existential quantifier.  (Contributed by NM,
       12-Aug-1993.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sb8eOLD7 $p |- ( E. x ph <-> E. y [ y / x ] ph ) $=
      ( wn wal wsb wex nfn sb8OLD7 sbnNEW7 albii bitri notbii df-ex 3bitr4i ) A
      EZBFZEABCGZEZCFZEABHSCHRUARQBCGZCFUAQBCACDIJUBTCABCKLMNABOSCOP $.
  $}

  $( Commutation of quantification and substitution variables.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb9iOLD7 $p |- ( A. x [ x / y ] ph -> A. y [ y / x ] ph ) $=
    ( weq wal wsb wi drsb1NEW7 drsb2NEW7 bitr3d dral1NEW7 biimprd wnf aecomNEW7
    wn nfa1 impbii nfbii mpbi nfn alimd stdpc4NEW7 sbcoNEW7 sylib alimi a7sOLD7
    hbsb2NEW7 syl6 pm2.61i ) CBDCEZACBFZBEZABCFZCEZGUJUNULUMUKCBUJACCFUMUKACBCH
    ACBCIJKLUJOZULUKCEZBEUNUOUKUPBUJBBCDZBEZBMUJBMUQBPURUJBURUJBCNCBNQRSTACBUGU
    AUKUNCBULUMCULUKBCFUMUKBCUBABCUCUDUEUFUHUI $.

  $( Commutation of quantification and substitution variables.  (Contributed by
     NM, 5-Aug-1993.) $)
  sb9OLD7 $p |- ( A. x [ x / y ] ph <-> A. y [ y / x ] ph ) $=
    ( wsb wal sb9iOLD7 impbii ) ACBDBEABCDCEABCFACBFG $.

  ${
    $d y ph $.
    $( Two ways of expressing " ` x ` is (effectively) not free in ` ph ` ."
       (Contributed by NM, 29-May-2009.) $)
    sbhbOLD7 $p |- ( ( ph -> A. x ph ) <-> A. y ( ph -> [ y / x ] ph ) ) $=
      ( wal wi wsb nfv sb8OLD7 imbi2i 19.21v bitr4i ) AABDZEAABCFZCDZEAMECDLNAA
      BCACGHIAMCJK $.
  $}

  ${
    $d x y $.  $d x w $.  $d y z $.  $d z w $.
    2sb5rf.1OLD7 $e |- F/ z ph $.
    2sb5rf.2OLD7 $e |- F/ w ph $.
    $( Reversed double substitution.  (Contributed by NM, 3-Feb-2005.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    2sb5rfOLD7 $p |- ( ph <->
                E. z E. w ( ( z = x /\ w = y ) /\ [ z / x ] [ w / y ] ph ) ) $=
      ( weq wa sb5rfNEW7 19.42v sbcom2NEW7 anbi2i anass bitri nfsbOLD7 3bitr4ri
      wsb wex exbii ) ADBHZABDRZIZDSUAECHZIZACERBDRZIZESZDSABDFJUCUHDUAUDUBCERZ
      IZIZESUAUJESZIUHUCUAUJEKUGUKEUGUEUIIUKUFUIUEACEBDLMUAUDUINOTUBULUAUBCEABD
      EGPJMQTO $.

    $( Reversed double substitution.  (Contributed by NM, 3-Feb-2005.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    2sb6rfOLD7 $p |- ( ph <->
                A. z A. w ( ( z = x /\ w = y ) -> [ z / x ] [ w / y ] ph ) ) $=
      ( weq wsb wi wal wa sb6rfNEW7 19.21v sbcom2NEW7 imbi2i impexp bitri albii
      nfsbOLD7 3bitr4ri ) ADBHZABDIZJZDKUBECHZLZACEIBDIZJZEKZDKABDFMUDUIDUBUEUC
      CEIZJZJZEKUBUKEKZJUIUDUBUKENUHULEUHUFUJJULUGUJUFACEBDOPUBUEUJQRSUCUMUBUCC
      EABDEGTMPUASR $.
  $}

  ${
    $d x z $.  $d y z $.  $d z ph $.
    $( An alternate definition of proper substitution ~ df-sb .  By introducing
       a dummy variable ` z ` in the definiens, we are able to eliminate any
       distinct variable restrictions among the variables ` x ` , ` y ` , and
       ` ph ` of the definiendum.  No distinct variable conflicts arise because
       ` z ` effectively insulates ` x ` from ` y ` .  To achieve this, we use
       a chain of two substitutions in the form of ~ sb5NEW7 , first ` z ` for
       ` x ` then ` y ` for ` z ` .  Compare Definition 2.1'' of [Quine] p. 17,
       which is obtained from this theorem by applying ~ df-clab .  Theorem
       ~ sb7hOLD7 provides a version where ` ph ` and ` z ` don't have to be
       distinct.  (Contributed by NM, 28-Jan-2004.) $)
    dfsb7OLD7 $p |- ( [ y / x ] ph
        <-> E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      ( wsb weq wa wex sb5NEW7 sbbii nfv sbco2OLD7 3bitr3i ) ABDEZDCEBDFAGBHZDC
      EABCEDCFOGDHNODCABDIJABCDADKLODCIM $.
  $}

  ${
    $d w x z $.  $d w y z $.  $d w ph $.
    sb7f.1OLD7 $e |- F/ z ph $.
    $( This version of ~ dfsb7OLD7 does not require that ` ph ` and ` z ` be
       distinct.  This permits it to be used as a definition for substitution
       in a formalization that omits the logically redundant axiom ~ ax-17 i.e.
       that doesn't have the concept of a variable not occurring in a wff.
       ( ~ df-sb is also suitable, but its mixing of free and bound variables
       is distasteful to some logicians.)  (Contributed by NM, 26-Jul-2006.)
       (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sb7fOLD7 $p |- ( [ y / x ] ph <->
               E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      ( wsb weq wa wex sb5NEW7 sbbii sbco2OLD7 3bitr3i ) ABDFZDCFBDGAHBIZDCFABC
      FDCGOHDINODCABDJKABCDELODCJM $.
  $}

  ${
    $d w x z $.  $d w y z $.  $d w ph $.
    sb7h.1OLD7 $e |- ( ph -> A. z ph ) $.
    $( This version of ~ dfsb7OLD7 does not require that ` ph ` and ` z ` be
       distinct.  This permits it to be used as a definition for substitution
       in a formalization that omits the logically redundant axiom ~ ax-17 i.e.
       that doesn't have the concept of a variable not occurring in a wff.
       ( ~ df-sb is also suitable, but its mixing of free and bound variables
       is distasteful to some logicians.)  (Contributed by NM, 26-Jul-2006.)
       (Proof shortened by Andrew Salmon, 25-May-2011.) $)
    sb7hOLD7 $p |- ( [ y / x ] ph <->
               E. z ( z = y /\ E. x ( x = z /\ ph ) ) ) $=
      ( nfi sb7fOLD7 ) ABCDADEFG $.
  $}

  ${
    $d x y $.
    sb10f.1OLD7 $e |- F/ x ph $.
    $( Hao Wang's identity axiom P6 in Irving Copi, _Symbolic Logic_ (5th ed.,
       1979), p. 328.  In traditional predicate calculus, this is a sole axiom
       for identity from which the usual ones can be derived.  (Contributed by
       NM, 9-May-2005.)  (Revised by Mario Carneiro, 6-Oct-2016.) $)
    sb10fOLD7 $p |- ( [ y / z ] ph <-> E. x ( x = y /\ [ x / z ] ph ) ) $=
      ( weq wsb wa wex nfsbOLD7 sbequNEW7 equsexNEW7 bicomi ) BCFADBGZHBIADCGZN
      OBCADCBEJABCDKLM $.
  $}

  ${
    $d x y z $.  $d y w $.  $d z w ph $.
    $( An equivalent expression for double existence.  (Contributed by NM,
       2-Feb-2005.) $)
    2exsbOLD7 $p |- ( E. x E. y ph <->
                  E. z E. w A. x A. y ( ( x = z /\ y = w ) -> ph ) ) $=
      ( wex weq wi wa exsbNEW7 exbii excomOLD7 bitri impexp albii 19.21v bitr2i
      wal ) ACFZBFZCEGZAHZCRZBFZEFZBDGZUAIAHZCRZBRZEFDFZTUCEFZBFUESUKBACEJKUCBE
      LMUEUIDFZEFUJUDULEUDUFUCHZBRZDFULUCBDJUNUIDUMUHBUHUFUBHZCRUMUGUOCUFUAANOU
      FUBCPQOKMKUIEDLMM $.
  $}

  ${
    $d z y $.  $d z x $.
    $( Move quantifier in and out of substitution.  (Contributed by NM,
       2-Jan-2002.) $)
    sbal2OLD7 $p |- ( -. A. x x = y ->
             ( [ z / y ] A. x ph <-> A. x [ z / y ] ph ) ) $=
      ( weq wal wn wi wsb alcomOLD7 nfnaeOLD7 wnf wb dveeq1NEW7 19.21t syl5rbbr
      nfd syl albid sb6NEW7 albii 3bitr4g ) BCEBFGZCDEZABFZHZCFZUDAHZCFZBFZUECD
      IACDIZBFUJUHBFZCFUCUGUHCBJUCULUFCBCCKUCUDBLULUFMUCUDBBCBKBCDNQUDABORSPUEC
      DTUKUIBACDTUAUB $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                                Miscellanea
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $( Recover the commutative law of addition for complex numbers from the
     Abelian group structure.  (Contributed by NM, 17-Mar-2013.)
     (Proof modification is discouraged.) $)
  cnaddcom $p |- ( ( A e. CC /\ B e. CC ) -> ( A + B ) = ( B + A ) ) $=
    ( cnx cbs cfv cc cop cplusg caddc cpr cabel wcel co wceq eqid cnaddabl cnex
    cvv grpbase ax-mp addex grpplusg ablcom mp3an1 ) CDEFGCHEIGJZKLAFLBFLABIMBA
    IMNUEUEOZPFIUEABFRLFUEDENQFIUERUFSTIRLIUEHENUAFIUERUFUBTUCUD $.

  ${
    $d g K $.
    toycom.1 $e |- C = { g e. Abel | ( Base ` g ) = CC } $.
    toycom.2 $e |- .+ = ( +g ` K ) $.
    $( Show the commutative law for an operation ` O ` on a toy structure class
       ` C ` of commuatitive operations on ` CC ` .  This illustrates how a
       structure class can be partially specialized.  In practice, we would
       ordinarily define a new constant such as "CAbel" in place of ` C ` .
       (Contributed by NM, 17-Mar-2013.)
       (Proof modification is discouraged.) $)
    toycom $p |- ( ( K e. C /\ A e. CC /\ B e. CC )
                    -> ( A .+ B ) = ( B .+ A ) ) $=
      ( wcel cc w3a cfv co cabel cbs wceq 3ad2ant1 eleqtrrd eqid oveqi cv sseli
      cplusg crab ssrab2 eqsstri simp2 fveq2 eqeq1d elrab2 simprbi simp3 ablcom
      syl3anc 3eqtr4g ) FCIZAJIZBJIZKZABFUCLZMZBAUTMZABDMBADMUSFNIZAFOLZIBVDIVA
      VBPUPUQVCURCNFCEUAZOLZJPZENUDNGVGENUEUFUBQUSAJVDUPUQURUGUPUQVDJPZURUPVCVH
      VGVHEFNCVEFPVFVDJVEFOUHUIGUJUKQZRUSBJVDUPUQURULVIRVDUTFABVDSUTSUMUNDUTABH
      TDUTBAHTUO $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Atoms, hyperplanes, and covering in a left vector space (or module)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LSAtoms $.
  $c LSHyp $.

  $( Extend class notation with all 1-dim subspaces (atoms) of a left module or
     left vector space. $)
  clsa $a class LSAtoms $.

  $( Extend class notation with all subspaces of a left module or left vector
     space that are hyperplanes. $)
  clsh $a class LSHyp $.

  ${
    $d s v w $.
    $( Define the set of all 1-dim subspaces (atoms) of a left module or left
       vector space.  (Contributed by NM, 9-Apr-2014.) $)
    df-lsatoms $a |- LSAtoms = ( w e. _V |-> ran ( v e. ( ( Base ` w ) \
                 { ( 0g ` w ) } ) |-> ( ( LSpan ` w ) ` { v } ) ) ) $.
  $}

  ${
    $d s v w $.
    $( Define the set of all hyperplanes of a left module or left vector
       space.  Also called co-atoms, these are subspaces that are one dimension
       less that the full space.  (Contributed by NM, 29-Jun-2014.) $)
    df-lshyp $a |- LSHyp = ( w e. _V |-> { s e. ( LSubSp ` w ) |
       ( s =/= ( Base ` w ) /\ E. v e. ( Base ` w )
           ( ( LSpan ` w ) ` ( s u. { v } ) ) = ( Base ` w ) ) } ) $.
  $}

  ${
    $d w N $.  $d s w S $.  $d v w V $.  $d s v w W $.
    lshpset.v $e |- V = ( Base ` W ) $.
    lshpset.n $e |- N = ( LSpan ` W ) $.
    lshpset.s $e |- S = ( LSubSp ` W ) $.
    lshpset.h $e |- H = ( LSHyp ` W ) $.
    $( The set of all hyperplanes of a left module or left vector space.  The
       vector ` v ` is called a generating vector for the hyperplane.
       (Contributed by NM, 29-Jun-2014.) $)
    lshpset $p |- ( W e. X -> H = { s e. S | ( s =/= V /\
                   E. v e. V ( N ` ( s u. { v } ) ) = V ) } ) $=
      ( vw cfv cv wceq cvv cbs clspn clss wcel clsh wne csn cun wrex crab fveq2
      wa elex syl6eqr neeq2d fveq1d eqeq12d rexeqbidv anbi12d rabeqbidv eqeltri
      df-lshyp fvex rabex fvmpt syl syl5eq ) FGUAZCFUBNZHOZEUCZVGAOUDUEZDNZEPZA
      EUFZUIZHBUGZLVEFQUAVFVNPFGUJMFVGMOZRNZUCZVIVOSNZNZVPPZAVPUFZUIZHVOTNZUGVN
      QUBVOFPZWBVMHWCBWDWCFTNZBVOFTUHKUKWDVQVHWAVLWDVPEVGWDVPFRNEVOFRUHIUKZULWD
      VTVKAVPEWFWDVSVJVPEWDVIVRDWDVRFSNDVOFSUHJUKUMWFUNUOUPUQMAHUSVMHBBWEQKFTUT
      URVAVBVCVD $.

    $d s N $.  $d s v U $.  $d s V $.
    $( The predicate "is a hyperplane" (of a left module or left vector
       space).  (Contributed by NM, 29-Jun-2014.) $)
    islshp $p |- ( W e. X -> ( U e. H <-> ( U e. S /\ U =/= V
        /\ E. v e. V ( N ` ( U u. { v } ) ) = V ) ) ) $=
      ( vs wcel cv wne cun cfv wceq wa csn wrex crab lshpset eleq2d neeq1 uneq1
      w3a fveq2d eqeq1d rexbidv anbi12d elrab 3anass bitr4i syl6bb ) GHNZCDNCMO
      ZFPZURAOUAZQZERZFSZAFUBZTZMBUCZNZCBNZCFPZCUTQZERZFSZAFUBZUHZUQDVFCABDEFGH
      MIJKLUDUEVGVHVIVMTZTVNVEVOMCBURCSZUSVIVDVMURCFUFVPVCVLAFVPVBVKFVPVAVJEURC
      UTUGUIUJUKULUMVHVIVMUNUOUP $.
  $}

  ${
    $d v S $.  $d v U $.  $d v V $.  $d v W $.  $d v ph $.
    islshpsm.v $e |- V = ( Base ` W ) $.
    islshpsm.n $e |- N = ( LSpan ` W ) $.
    islshpsm.s $e |- S = ( LSubSp ` W ) $.
    islshpsm.p $e |- .(+) = ( LSSum ` W ) $.
    islshpsm.h $e |- H = ( LSHyp ` W ) $.
    islshpsm.w $e |- ( ph -> W e. LMod ) $.
    $( Hyperplane properties expressed with subspace sum.  (Contributed by NM,
       3-Jul-2014.) $)
    islshpsm $p |- ( ph -> ( U e. H <-> ( U e. S /\ U =/= V /\
                   E. v e. V ( U .(+) ( N ` { v } ) ) = V ) ) ) $=
      ( wcel cun cfv wceq wa wne cv csn wrex w3a co clmod wb islshp syl simplrl
      ad2antrr lspid syl2anc uneq1d fveq2d wss lssss snssi adantl lspun syl3anc
      lspcl lsmsp 3eqtr4rd eqeq1d rexbidva pm5.32da bicomd df-3an 3bitr4g bitrd
      ) AEFPZEDPZEHUAZEBUBZUCZQGRZHSZBHUDZUEZVNVOEVQGRZCUFZHSZBHUDZUEZAIUGPZVMW
      AUHOBDEFGHIUGJKLNUIUJAVNVOTZVTTZWHWETZWAWFAWJWIAWHWEVTAWHTZWDVSBHWKVPHPZT
      ZWCVRHWMEGRZWBQZGRZEWBQZGRZVRWCWMWOWQGWMWNEWBWMWGVNWNESAWGWHWLOULZAVNVOWL
      UKZDEGILKUMUNUOUPWMWGEHUQZVQHUQZVRWPSWSWMVNXAWTDEHIJLURUJWLXBWKVPHUSUTZEV
      QGHIJKVAVBWMWGVNWBDPZWCWRSWSWTWMWGXBXDWSXCDVQGHIJLKVCUNCDEWBGILKMVDVBVEVF
      VGVHVIVNVOVTVJVNVOWEVJVKVL $.
  $}

  ${
    $d v U $.  $d v W $.
    lshplss.s $e |- S = ( LSubSp ` W ) $.
    lshplss.h $e |- H = ( LSHyp ` W ) $.
    lshplss.w $e |- ( ph -> W e. LMod ) $.
    lshplss.u $e |- ( ph -> U e. H ) $.
    $( A hyperplane is a subspace.  (Contributed by NM, 3-Jul-2014.) $)
    lshplss $p |- ( ph -> U e. S ) $=
      ( vv wcel cbs cfv wne cv csn cun clspn clmod eqid wceq wrex w3a wb islshp
      syl mpbid simp1d ) ACBKZCELMZNZCJOPQERMZMUJUAJUJUBZACDKZUIUKUMUCZIAESKUNU
      OUDHJBCDULUJESUJTULTFGUEUFUGUH $.
  $}

  ${
    $d v U $.  $d v V $.  $d v W $.
    lshpne.v $e |- V = ( Base ` W ) $.
    lshpne.h $e |- H = ( LSHyp ` W ) $.
    lshpne.w $e |- ( ph -> W e. LMod ) $.
    lshpne.u $e |- ( ph -> U e. H ) $.
    $( A hyperplane is not equal to the vector space.  (Contributed by NM,
       4-Jul-2014.) $)
    lshpne $p |- ( ph -> U =/= V ) $=
      ( vv clss cfv wcel wne cv csn cun clspn clmod eqid wceq w3a wb islshp syl
      wrex mpbid simp2d ) ABEKLZMZBDNZBJOPQERLZLDUAJDUFZABCMZUJUKUMUBZIAESMUNUO
      UCHJUIBCULDESFULTUITGUDUEUGUH $.
  $}

  ${
    $d v U $.  $d v V $.  $d v W $.  $d v ph $.
    lshpnel.v $e |- V = ( Base ` W ) $.
    lshpnel.n $e |- N = ( LSpan ` W ) $.
    lshpnel.p $e |- .(+) = ( LSSum ` W ) $.
    lshpnel.h $e |- H = ( LSHyp ` W ) $.
    lshpnel.w $e |- ( ph -> W e. LMod ) $.
    lshpnel.u $e |- ( ph -> U e. H ) $.
    lshpnel.x $e |- ( ph -> X e. V ) $.
    lshpnel.e $e |- ( ph -> ( U .(+) ( N ` { X } ) ) = V ) $.
    $( A hyperplane's generating vector does not belong to the hyperplane.
       (Contributed by NM, 3-Jul-2014.) $)
    lshpnel $p |- ( ph -> -. X e. U ) $=
      ( wcel wceq cfv adantr wne wn lshpne wa csn co csubg clss clmod lsssssubg
      wss eqid syl lshplss sseldd lspsncl syl2anc simpr lspsnel5a lsmss2 eqtr3d
      syl3anc ex necon3ad mpd ) ACFUAHCQZUBACDFGILMNUCAVFCFAVFCFRAVFUDZCHUEESZB
      UFZCFVGCGUGSZQVHVJQVHCUKVICRVGGUHSZVJCVGGUIQZVKVJUKAVLVFMTZVKGVKULZUJUMZA
      CVKQVFAVKCDGVNLMNUNTZUOVGVKVJVHVOVGVLHFQZVHVKQVMAVQVFOTVKEFGHIVNJUPUQUOVG
      VKCEGHVNJVMVPAVFURUSBCVHGKUTVBAVIFRVFPTVAVCVDVE $.
  $}

  ${
    $d v N $.  $d v .(+) $.  $d v U $.  $d v V $.  $d v W $.  $d v X $.
    $d v ph $.
    lshpnelb.v $e |- V = ( Base ` W ) $.
    lshpnelb.n $e |- N = ( LSpan ` W ) $.
    lshpnelb.p $e |- .(+) = ( LSSum ` W ) $.
    lshpnelb.h $e |- H = ( LSHyp ` W ) $.
    lshpnelb.w $e |- ( ph -> W e. LVec ) $.
    lshpnelb.u $e |- ( ph -> U e. H ) $.
    lshpnelb.x $e |- ( ph -> X e. V ) $.
    $( The subspace sum of a hyperplane and the span of an element equals the
       vector space iff the element is not in the hyperplane.  (Contributed by
       NM, 2-Oct-2014.) $)
    lshpnelb $p |- ( ph -> ( -. X e. U <-> ( U .(+) ( N ` { X } ) ) = V ) ) $=
      ( vv wcel cfv adantr wss wn csn co wceq wa wrex clss wne eqid clvec clmod
      cv w3a lveclmod syl islshpsm mpbid simp3d wpss simp1l simp2 csubg lshplss
      lsssssubg sseldd lspsncl syl2anc lsmub1 lsmub2 nelne1 sylan necomd df-pss
      lspsnid sylanbrc 3ad2ant1 lsmcl syl3anc lssss simpr adantlr 3adant2 lsmcv
      sseqtr4d syl211anc simp3 eqtrd rexlimdv3a mpd lshpnel impbida ) AHCQUAZCH
      UBERZBUCZFUDZAWLUEZCPULZUBERBUCZFUDZPFUFZWOAWTWLACGUGRZQZCFUHZWTACDQZXBXC
      WTUMNAPBXACDEFGIJXAUIZKLAGUJQZGUKQZMGUNUOZUPUQURSWPWSWOPFWPWQFQZWSUMZWNWR
      FXJAXICWNUSZWNWRTZWNWRUDAWLXIWSUTWPXIWSVAWPXIXKWSWPCWNTZCWNUHXKAXMWLACGVB
      RZQZWMXNQZXMAXAXNCAXGXAXNTXHXAGXEVDUOZAXACDGXELXHNVCZVEZAXAXNWMXQAXGHFQZW
      MXAQZXHOXAEFGHIXEJVFVGZVEZBCWMGKVHVGSWPWNCAHWNQWLWNCUHAWMWNHAXOXPWMWNTXSY
      CBCWMGKVIVGAXGXTHWMQXHOEFGHIJVNVGVEHWNCVJVKVLCWNVMVOVPWPWSXLXIAWSXLWLAWSU
      EWNFWRAWNFTZWSAWNXAQZYDAXGXBYAYEXHXRYBBXACWMGXEKVQVRZXAWNFGIXEVSUOSAWSVTW
      DWAWBAXIUEBXACWNEFGWQIXEJKAXFXIMSAXBXIXRSAYEXIYFSAXIVTWCWEWPXIWSWFWGWHWIA
      WOUEBCDEFGHIJKLAXGWOXHSAXDWONSAXTWOOSAWOVTWJWK $.
  $}

  ${
    $d v N $.  $d v U $.  $d v V $.  $d v W $.  $d v X $.
    lshpnel2.v $e |- V = ( Base ` W ) $.
    lshpnel2.s $e |- S = ( LSubSp ` W ) $.
    lshpnel2.n $e |- N = ( LSpan ` W ) $.
    lshpnel2.p $e |- .(+) = ( LSSum ` W ) $.
    lshpnel2.h $e |- H = ( LSHyp ` W ) $.
    lshpnel2.w $e |- ( ph -> W e. LVec ) $.
    lshpnel2.u $e |- ( ph -> U e. S ) $.
    lshpnel2.t $e |- ( ph -> U =/= V ) $.
    lshpnel2.x $e |- ( ph -> X e. V ) $.
    lshpnel2.e $e |- ( ph -> -. X e. U ) $.
    $( Condition that determines a hyperplane.  (Contributed by NM,
       3-Oct-2014.)  (New usage is discouraged.) $)
    lshpnel2N $p |- ( ph -> ( U e. H <-> ( U .(+) ( N ` { X } ) ) = V ) ) $=
      ( wcel vv csn cfv co wceq wa wn adantr clvec simpr lshpnelb mpbid wne cun
      wrex clmod lveclmod syl lspid syl2anc uneq1d fveq2d wss lssss snssd lspun
      cv syl3anc lspsncl lsmsp 3eqtr4rd eqeq1d biimpa sneq uneq2d rspcev w3a wb
      islshp mpbir3and impbida ) ADETZDIUBZFUCZBUDZGUEZAWBUFZIDTUGZWFAWHWBSUHWG
      BDEFGHIJLMNAHUITZWBOUHAWBUJAIGTZWBRUHUKULAWFUFZWBDCTZDGUMZDUAVGZUBZUNZFUC
      ZGUEZUAGUOZAWLWFPUHAWMWFQUHWKWJDWCUNZFUCZGUEZWSAWJWFRUHAWFXBAWEXAGADFUCZW
      DUNZFUCZDWDUNZFUCZXAWEAXDXFFAXCDWDAHUPTZWLXCDUEAWIXHOHUQURZPCDFHKLUSUTVAV
      BAXHDGVCZWCGVCXAXEUEXIAWLXJPCDGHJKVDURAIGRVEDWCFGHJLVFVHAXHWLWDCTZWEXGUEX
      IPAXHWJXKXIRCFGHIJKLVIUTBCDWDFHKLMVJVHVKVLVMWRXBUAIGWNIUEZWQXAGXLWPWTFXLW
      OWCDWNIVNVOVBVLVPUTWKWIWBWLWMWSVQVRAWIWFOUHUACDEFGHUIJLKNVSURVTWA $.
  $}

  ${
    lshpne0.v $e |- V = ( Base ` W ) $.
    lshpne0.n $e |- N = ( LSpan ` W ) $.
    lshpne0.p $e |- .(+) = ( LSSum ` W ) $.
    lshpne0.h $e |- H = ( LSHyp ` W ) $.
    lshpne0.o $e |- .0. = ( 0g ` W ) $.
    lshpne0.w $e |- ( ph -> W e. LMod ) $.
    lshpne0.u $e |- ( ph -> U e. H ) $.
    lshpne0.x $e |- ( ph -> X e. V ) $.
    lshpne0.e $e |- ( ph -> ( U .(+) ( N ` { X } ) ) = V ) $.
    $( The member of the span in the hyperplane definition does not belong to
       the hyperplane.  (Contributed by NM, 14-Jul-2014.) $)
    lshpne0 $p |- ( ph -> X =/= .0. ) $=
      ( wcel adantr wn wne lshpnel wa csn cdif clss eqid clmod lshplss lssneln0
      cfv simpr eldifsni syl mpdan ) AHCSUAZHIUBZABCDEFGHJKLMOPQRUCAUQUDZHFIUEU
      FSURUSGUGULZCFGHIJNUTUHZAGUISUQOTACUTSUQAUTCDGVAMOPUJTAHFSUQQTAUQUMUKHFIU
      NUOUP $.
  $}

  ${
    $d k v N $.  $d k v U $.  $d k V $.  $d k v X $.  $d k v .0. $.  $d k W $.
    $d k v ph $.
    lshpdisj.v $e |- V = ( Base ` W ) $.
    lshpdisj.o $e |- .0. = ( 0g ` W ) $.
    lshpdisj.n $e |- N = ( LSpan ` W ) $.
    lshpdisj.p $e |- .(+) = ( LSSum ` W ) $.
    lshpdisj.h $e |- H = ( LSHyp ` W ) $.
    lshpdisj.w $e |- ( ph -> W e. LVec ) $.
    lshpdisj.u $e |- ( ph -> U e. H ) $.
    lshpdisj.x $e |- ( ph -> X e. V ) $.
    lshpdisj.e $e |- ( ph -> ( U .(+) ( N ` { X } ) ) = V ) $.
    $( A hyperplane and the span in the hyperplane definition are disjoint.
       (Contributed by NM, 3-Jul-2014.) $)
    lshpdisj $p |- ( ph -> ( U i^i ( N ` { X } ) ) = { .0. } ) $=
      ( cfv wcel vv vk csn cin cv wa wceq cvsca co csca cbs wrex clmod wb clvec
      lveclmod syl adantr eqid lspsnel syl2anc wi lshpnel ad2antrr clss lshplss
      wne wn simpr lspsneli lspsnel4 mtbid ex necon4ad eleq1 imbi12d syl5ibrcom
      eqeq1 com23 com24 imp31 rexlimdva expimpd elin elsn 3imtr4g ssrdv lspsncl
      sylbid wss lssincl syl3anc lss0ss eqssd ) ACHUCESZUDZIUCZAUAWPWQAUAUEZCTZ
      WRWOTZUFWRIUGZWRWPTWRWQTAWSWTXAAWSUFZWTWRUBUEZHGUHSZUIZUGZUBGUJSZUKSZULZX
      AXBGUMTZHFTZWTXIUNAXJWSAGUOTZXJOGUPUQZURAXKWSQURXDWRUBXGXHEFGHXGUSZXHUSZJ
      XDUSZLUTVAXBXFXAUBXHAWSXCXHTZXFXAVBAXFXQWSXAAXQXFWSXAVBZAXQXFXRVBAXQUFZXR
      XFXECTZXEIUGZVBXSXTXEIXSXEIVGZXTVHXSYBUFZHCTZXTAYDVHXQYBABCDEFGHJLMNXMPQR
      VCVDYCGVESZCEFGHXEIJKYEUSZLAXLXQYBOVDACYETZXQYBAYECDGYFNXMPVFZVDAXKXQYBQV
      DXSXEWOTYBXSXCXDXGXHEFGHJXPXNXOLAXJXQXMURAXQVIAXKXQQURVJURXSYBVIVKVLVMVNX
      FWSXTXAYAWRXECVOWRXEIVRVPVQVMVSVTWAWBWIWCWRCWOWDUAIWEWFWGAXJWPYETZWQWPWJX
      MAXJYGWOYETZYIXMYHAXJXKYJXMQYEEFGHJYFLWHVAYECWOGYFWKWLYEGWPIKYFWMVAWN $.
  $}

  ${
    $d v T $.  $d v U $.  $d v W $.  $d v ph $.
    lshpcmp.h $e |- H = ( LSHyp ` W ) $.
    lshpcmp.w $e |- ( ph -> W e. LVec ) $.
    lshpcmp.t $e |- ( ph -> T e. H ) $.
    lshpcmp.u $e |- ( ph -> U e. H ) $.
    $( If two hyperplanes are comparable, they are equal.  (Contributed by NM,
       9-Oct-2014.) $)
    lshpcmp $p |- ( ph -> ( T C_ U <-> T = U ) ) $=
      ( vv wss wceq cfv wne eqid wcel syl lshplss wa adantr wpss wn clvec clmod
      cbs lveclmod lshpne clss lssss cv csn clspn clsm co wi w3a islshpsm mpbid
      wrex simp3d id adantrr simpr syl3an1 3expia simplrr sseq2d eqeq2d 3imtr3d
      lsmcv exp42 rexlimdv mpd necon3ad df-pss simplbi2 necon1bd syl5com eqimss
      mpid impbid1 ) ABCKZBCLZABCUAZUBZWBWCACEUEMZNWEACDWFEWFOZFAEUCPZEUDPGEUFQ
      ZIUGAWDCWFAWDCWFKZCWFLZACEUHMZPZWJAWLCDEWLOZFWIIRZWLCWFEWGWNUIQABJUJZUKEU
      LMZMEUMMZUNZWFLZJWFUSZWDWJWKUOZUOZABWLPZBWFNZXAABDPXDXEXAUPHAJWRWLBDWQWFE
      WGWQOZWNWROZFWIUQURUTAWTXCJWFAWPWFPZWTWDXBAXHWTSSZWDSZCWSKZCWSLZWJWKXIWDX
      KXLXIAXHSZWDXKXLAXHXMWTXMVAVBXMWRWLBCWQWFEWPWGWNXFXGAWHXHGTAXDXHAWLBDEWNF
      WIHRTAWMXHWOTAXHVCVJVDVEXJWSWFCAXHWTWDVFZVGXJWSWFCXNVHVIVKVLVMVTVNVMWBWDB
      CWDWBBCNBCVOVPVQVRBCVSWA $.
  $}

  ${
    lshpin.h $e |- H = ( LSHyp ` W ) $.
    lshpin.w $e |- ( ph -> W e. LVec ) $.
    lshpin.t $e |- ( ph -> T e. H ) $.
    lshpin.u $e |- ( ph -> U e. H ) $.
    $( The intersection of two different hyperplanes is not a hyperplane.
       (Contributed by NM, 29-Oct-2014.)  (New usage is discouraged.) $)
    lshpinN $p |- ( ph -> ( ( T i^i U ) e. H <-> T = U ) ) $=
      ( cin wcel wceq wa wss inss1 clvec adantr simpr lshpcmp mpbii inss2 inidm
      eqtr3d ex syl5eqel ineq2 eleq1d syl5ibcom impbid ) ABCJZDKZBCLZAUKULAUKMZ
      UJBCUMUJBNUJBLBCOUMUJBDEFAEPKUKGQZAUKRZABDKUKHQSTUMUJCNUJCLBCUAUMUJCDEFUN
      UOACDKUKIQSTUCUDABBJZDKULUKAUPBDBUBHUEULUPUJDBCBUFUGUHUI $.
  $}

  ${
    $d s v w N $.  $d s v w V $.  $d s v w x W $.  $d s v w .0. $.  $d v x X $.
    lsatset.v $e |- V = ( Base ` W ) $.
    lsatset.n $e |- N = ( LSpan ` W ) $.
    lsatset.z $e |- .0. = ( 0g ` W ) $.
    lsatset.a $e |- A = ( LSAtoms ` W ) $.
    $( The set of all 1-dim subspaces (atoms) of a left module or left vector
       space.  (Contributed by NM, 9-Apr-2014.)  (Revised by Mario Carneiro,
       22-Sep-2015.) $)
    lsatset $p |- ( W e. X ->
      A = ran ( v e. ( V \ { .0. } ) |-> ( N ` { v } ) ) ) $=
      ( vw wcel cfv csn crn cvv cbs c0g clspn clsa cdif cv cmpt wceq elex fveq2
      syl6eqr sneqd difeq12d fveq1d mpteq12dv rneqd df-lsatoms cun fvex eqeltri
      c0 rnex p0ex unex wf wss fvrn0 a1i fmpti frn ax-mp ssexi fvmpt syl syl5eq
      eqid ) EFMZBEUANZADGOZUBZAUCZOZCNZUDZPZKVNEQMVOWBUEEFUFLEALUCZRNZWCSNZOZU
      BZVSWCTNZNZUDZPWBQUAWCEUEZWJWAWKAWGWIVQVTWKWDDWFVPWKWDERNDWCERUGHUHWKWEGW
      KWEESNGWCESUGJUHUIUJWKVSWHCWKWHETNZCWCETUGIUHUKULUMLAUNWBCPZUROZUOZWMWNCC
      WLQIETUPUQUSUTVAVQWOWAVBWBWOVCAVQWOVTWAWAVMVTWOMVRVQMCVSVDVEVFVQWOWAVGVHV
      IVJVKVL $.

    $d s v U $.  $d v x N $.  $d x U $.  $d x V $.  $d x .0. $.
    $( The predicate "is a 1-dim subspace (atom)" (of a left module or left
       vector space).  (Contributed by NM, 9-Apr-2014.)  (Revised by Mario
       Carneiro, 24-Jun-2014.) $)
    islsat $p |- ( W e. X -> ( U e. A <-> E. x e. ( V \ { .0. } )
                  U = ( N ` { x } ) ) ) $=
      ( wcel csn cdif cv cfv cmpt crn wceq wrex lsatset eleq2d eqid fvex syl6bb
      elrnmpti ) FGMZCBMCAEHNOZAPNZDQZRZSZMCUKTAUIUAUHBUMCABDEFGHIJKLUBUCAUIUKC
      ULULUDUJDUEUGUF $.

    $( The span of a non-zero singleton is an atom.  TODO: make this obsolete
       and use ~ lsatlspsn instead?  (Contributed by NM, 9-Apr-2014.)  (Revised
       by Mario Carneiro, 24-Jun-2014.) $)
    lsatlspsn2 $p |- ( ( W e. LMod /\ X e. V /\ X =/= .0. )
           -> ( N ` { X } ) e. A ) $=
      ( vv clmod wcel wne w3a csn cfv cv wceq cdif wrex 3simpc sylibr eqid sneq
      wa eldifsn fveq2d eqeq2d rspcev sylancl wb islsat 3ad2ant1 mpbird ) DLMZE
      CMZEFNZOZEPZBQZAMZVAKRZPZBQZSZKCFPTZUAZUSEVGMZVAVASZVHUSUQURUFVIUPUQURUBE
      CFUGUCVAUDVFVJKEVGVCESZVEVAVAVKVDUTBVCEUEUHUIUJUKUPUQVBVHULURKAVABCDLFGHI
      JUMUNUO $.

    lsatlspsn.w $e |- ( ph -> W e. LMod ) $.
    lsatlspsn.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( The span of a non-zero singleton is an atom.  (Contributed by NM,
       16-Jan-2015.) $)
    lsatlspsn $p |- ( ph -> ( N ` { X } ) e. A ) $=
      ( vv csn cfv wcel cv wceq clmod cdif wrex eqid sneq fveq2d eqeq2d sylancl
      rspcev wb islsat syl mpbird ) AFOZCPZBQZUNNRZOZCPZSZNDGOUAZUBZAFUTQUNUNSZ
      VAMUNUCUSVBNFUTUPFSZURUNUNVCUQUMCUPFUDUEUFUHUGAETQUOVAUILNBUNCDETGHIJKUJU
      KUL $.
  $}

  ${
    $d v N $.  $d v U $.  $d v V $.  $d v W $.  $d v X $.
    islsati.v $e |- V = ( Base ` W ) $.
    islsati.n $e |- N = ( LSpan ` W ) $.
    islsati.a $e |- A = ( LSAtoms ` W ) $.
    $( A 1-dim subspace (atom) (of a left module or left vector space) equals
       the span of some vector.  (Contributed by NM, 1-Oct-2014.) $)
    islsati $p |- ( ( W e. X /\ U e. A ) -> E. v e. V U = ( N ` { v } ) ) $=
      ( c0g cfv csn cdif wss wcel wa cv wceq wrex difss islsat biimpa ssrexv
      eqid mpsyl ) EFKLZMZNZEOFGPZCBPZQCARMDLSZAUITZULAETEUHUAUJUKUMABCDEFGUGHI
      UGUEJUBUCULAUIEUDUF $.
  $}

  ${
    $d v U $.  $d v W $.  $d v .0. $.  $d v ph $.
    lsateln0.z $e |- .0. = ( 0g ` W ) $.
    lsateln0.a $e |- A = ( LSAtoms ` W ) $.
    lsateln0.w $e |- ( ph -> W e. LMod ) $.
    lsateln0.u $e |- ( ph -> U e. A ) $.
    $( A 1-dim subspace (atom) (of a left module or left vector space) contains
       a nonzero vector.  (Contributed by NM, 2-Jan-2015.) $)
    lsateln0 $p |- ( ph -> E. v e. U v =/= .0. ) $=
      ( cv wcel cbs cfv csn wrex clmod eqid syl wa cdif wne clspn wceq wb mpbid
      islsat eldifi lspsnid syl2an eleq2 syl5ibrcom reximdva mpd eldifsn anbi1i
      anass bitri simprbi ancomd reximi2 ) ABKZDLZBEMNZFOZUAZPZVBFUBZBDPADVBOEU
      CNZNZUDZBVFPZVGADCLZVLJAEQLZVMVLUEIBCDVIVDEQFVDRZVIRZGHUGSUFAVKVCBVFAVBVF
      LZTVCVKVBVJLZAVNVBVDLZVRVQIVBVDVEUHVIVDEVBVOVPUIUJDVJVBUKULUMUNVCVHBVFDVQ
      VCTZVHVCVTVSVHVCTZVTVSVHTZVCTVSWATVQWBVCVBVDFUOUPVSVHVCUQURUSUTVAS $.
  $}

  ${
    $d s v S $.  $d s v W $.
    lsatlss.s $e |- S = ( LSubSp ` W ) $.
    lsatlss.a $e |- A = ( LSAtoms ` W ) $.
    $( The set of 1-dim subspaces is a set of subspaces.  (Contributed by NM,
       9-Apr-2014.)  (Revised by Mario Carneiro, 24-Jun-2014.) $)
    lsatlss $p |- ( W e. LMod -> A C_ S ) $=
      ( vv clmod wcel cbs cfv c0g csn cdif cv clspn cmpt crn eqid lsatset wf
      wss eldifi lspsncl sylan2 fmptd frn syl eqsstrd ) CGHZAFCIJZCKJZLZMZFNZLC
      OJZJZPZQZBFAUOUJCGUKUJRZUORZUKRESUIUMBUQTURBUAUIFUMUPBUQUNUMHUIUNUJHUPBHU
      NUJULUBBUOUJCUNUSDUTUCUDUQRUEUMBUQUFUGUH $.

    lssatssel.w $e |- ( ph -> W e. LMod ) $.
    lssatssel.u $e |- ( ph -> U e. A ) $.
    $( An atom is a subspace.  (Contributed by NM, 25-Aug-2014.) $)
    lsatlssel $p |- ( ph -> U e. S ) $=
      ( clmod wcel wss lsatlss syl sseldd ) ABCDAEJKBCLHBCEFGMNIO $.
  $}

  ${
    lsatssv.v $e |- V = ( Base ` W ) $.
    lsatssv.a $e |- A = ( LSAtoms ` W ) $.
    lsatssv.w $e |- ( ph -> W e. LMod ) $.
    lsatssv.g $e |- ( ph -> Q e. A ) $.
    $( An atom is a set of vectors.  (Contributed by NM, 27-Feb-2015.) $)
    lsatssv $p |- ( ph -> Q C_ V ) $=
      ( clss cfv wcel wss eqid lsatlssel lssss syl ) ACEJKZLCDMABRCERNZGHIORCDE
      FSPQ $.
  $}

  ${
    $d v .0. $.  $d v U $.  $d v W $.  $d v ph $.
    lsatn0.o $e |- .0. = ( 0g ` W ) $.
    lsatn0.a $e |- A = ( LSAtoms ` W ) $.
    lsatn0.w $e |- ( ph -> W e. LMod ) $.
    lsatn0.u $e |- ( ph -> U e. A ) $.
    $( A 1-dim subspace (atom) of a left module or left vector space is
       nonzero.  ( ~ atne0 analog.)  (Contributed by NM, 25-Aug-2014.) $)
    lsatn0 $p |- ( ph -> U =/= { .0. } ) $=
      ( vv cv csn cfv wceq wne wcel clmod wb eqid wa clspn cbs cdif wrex islsat
      syl mpbid wi eldifsn lspsneq0 sylan biimpd necon3d expimpd neeq1 biimprcd
      syl5bi syl6 rexlimdv mpd ) ACJKZLDUAMZMZNZJDUBMZELZUCZUDZCVFOZACBPZVHIADQ
      PZVJVHRHJBCVBVEDQEVESZVBSZFGUEUFUGAVDVIJVGAVAVGPZVCVFOZVDVIUHVNVAVEPZVAEO
      ZTAVOVAVEEUIAVPVQVOAVPTZVCVFVAEVRVCVFNZVAENZAVKVPVSVTRHVBVEDVAEVLFVMUJUKU
      LUMUNUQVDVIVOCVCVFUOUPURUSUT $.
  $}

  ${
    lsatspn0.v $e |- V = ( Base ` W ) $.
    lsatspn0.n $e |- N = ( LSpan ` W ) $.
    lsatspn0.o $e |- .0. = ( 0g ` W ) $.
    lsatspn0.a $e |- A = ( LSAtoms ` W ) $.
    isateln0.w $e |- ( ph -> W e. LMod ) $.
    isateln0.x $e |- ( ph -> X e. V ) $.
    $( The span of a vector is an atom iff the vector is nonzero.  (Contributed
       by NM, 4-Feb-2015.) $)
    lsatspn0 $p |- ( ph -> ( ( N ` { X } ) e. A <-> X =/= .0. ) ) $=
      ( csn cfv wcel wne wa adantr wceq clmod simpr lsatn0 fveq2d adantl lspsn0
      sneq syl eqtrd ex necon3d mpd cdif eldifsn sylanbrc lsatlspsn impbida ) A
      FNZCOZBPZFGQZAUTRZUSGNZQVAVBBUSEGJKAEUAPZUTLSZAUTUBUCVBFGUSVCVBFGTZUSVCTV
      BVFRZUSVCCOZVCVFUSVHTVBVFURVCCFGUGUDUEVGVDVHVCTVBVDVFVESCEGJIUFUHUIUJUKUL
      AVARZBCDEFGHIJKAVDVALSVIFDPZVAFDVCUMPAVJVAMSAVAUBFDGUNUOUPUQ $.
  $}

  ${
    lsator0sp.v $e |- V = ( Base ` W ) $.
    lsator0sp.n $e |- N = ( LSpan ` W ) $.
    lsator0sp.o $e |- .0. = ( 0g ` W ) $.
    lsator0sp.a $e |- A = ( LSAtoms ` W ) $.
    isator0sp.w $e |- ( ph -> W e. LMod ) $.
    isator0sp.x $e |- ( ph -> X e. V ) $.
    $( The span of a vector is either an atom or the zero subspace.
       (Contributed by NM, 15-Mar-2015.) $)
    lsator0sp $p |- ( ph ->
         ( ( N ` { X } ) e. A \/ ( N ` { X } ) = { .0. } ) ) $=
      ( csn cfv wcel wceq wn wne lsatspn0 biimprd necon1bd syl2anc sylibrd orrd
      clmod wb lspsneq0 ) AFNCOZBPZUIGNQZAUJRFGQZUKAUJFGAUJFGSABCDEFGHIJKLMTUAU
      BAEUFPFDPUKULUGLMCDEFGHJIUHUCUDUE $.
  $}

  ${
    lsatssn0.o $e |- .0. = ( 0g ` W ) $.
    lsatssn0.a $e |- A = ( LSAtoms ` W ) $.
    lsatssn0.w $e |- ( ph -> W e. LMod ) $.
    lsatssn0.q $e |- ( ph -> Q e. A ) $.
    lsatssn0.u $e |- ( ph -> Q C_ U ) $.
    $( A subspace (or any class) including an atom is nonzero.  (Contributed by
       NM, 3-Feb-2015.) $)
    lsatssn0 $p |- ( ph -> U =/= { .0. } ) $=
      ( csn wss wne wpss clmod wcel clss cfv necomd eqid lss0ss lsatn0 sylanbrc
      lsatlssel syl2anc df-pss psssstrd pssned ) AFLZDAUJDAUJCDAUJCMZUJCNUJCOAE
      PQCERSZQUKIABULCEULUAZHIJUEULECFGUMUBUFACUJABCEFGHIJUCTUJCUGUDKUHUIT $.
  $}

  ${
    $d v T $.  $d v U $.  $d v W $.  $d v ph $.
    lsatcmp.a $e |- A = ( LSAtoms ` W ) $.
    lsatcmp.w $e |- ( ph -> W e. LVec ) $.
    lsatcmp.t $e |- ( ph -> T e. A ) $.
    lsatcmp.u $e |- ( ph -> U e. A ) $.
    $( If two atoms are comparable, they are equal.  ( ~ atsseq analog.)  TODO:
       can ~ lspsncmp shorten this?  (Contributed by NM, 25-Aug-2014.) $)
    lsatcmp $p |- ( ph -> ( T C_ U <-> T = U ) ) $=
      ( vv csn cfv wceq wss wb wcel clmod eqid wa ad2antrr cv cbs c0g cdif wrex
      clspn clvec lveclmod syl islsat mpbid wi eldifsn lsatn0 clss wo lsatlssel
      wne simplrl simpr lspsnat syl31anc ord necon1ad mpd eqimss impbid1 syl5bi
      ex sseq2 eqeq2 bibi12d biimprcd syl6 rexlimdv ) ADJUAZKEUFLZLZMZJEUBLZEUC
      LZKZUDZUEZCDNZCDMZOZADBPZWDIAEQPZWHWDOAEUGPZWIGEUHUIZJBDVQVTEQWAVTRZVQRZW
      ARZFUJUIUKAVSWGJWCAVPWCPZCVRNZCVRMZOZVSWGULWOVPVTPZVPWAURZSZAWRVPVTWAUMAX
      AWRAXASZWPWQXBWPWQXBWPSZCWBURZWQAXDXAWPABCEWAWNFWKHUNTXCWQCWBXCWQCWBMZXCW
      JCEUOLZPZWSWPWQXEUPAWJXAWPGTAXGXAWPABXFCEXFRZFWKHUQTAWSWTWPUSXBWPUTXFCVQV
      TEVPWAWLWNXHWMVAVBVCVDVEVICVRVFVGVIVHVSWGWRVSWEWPWFWQDVRCVJDVRCVKVLVMVNVO
      VE $.
  $}

  ${
    lsatcmp2.o $e |- .0. = ( 0g ` W ) $.
    lsatcmp2.a $e |- A = ( LSAtoms ` W ) $.
    lsatcmp2.w $e |- ( ph -> W e. LVec ) $.
    lsatcmp2.t $e |- ( ph -> T e. A ) $.
    lsatcmp2.u $e |- ( ph -> ( U e. A \/ U = { .0. } ) ) $.
    $( If an atom is included in at-most an atom, they are equal.  More general
       version of ~ lsatcmp .  TODO: can ~ lspsncmp shorten this?  (Contributed
       by NM, 3-Feb-2015.) $)
    lsatcmp2 $p |- ( ph -> ( T C_ U <-> T = U ) ) $=
      ( wss wceq wa simpr clvec wcel adantr csn wne clmod lveclmod syl lsatssn0
      wi ord necon1ad mpd lsatcmp mpbid ex eqimss impbid1 ) ACDLZCDMZAUNUOAUNNZ
      UNUOAUNOZUPBCDEHAEPQZUNIRACBQUNJRZUPDFSZTZDBQZUPBCDEFGHAEUAQZUNAURVCIEUBU
      CRUSUQUDAVAVBUEUNAVBDUTAVBDUTMKUFUGRUHUIUJUKCDULUM $.
  $}

  ${
    lsatel.o $e |- .0. = ( 0g ` W ) $.
    lsatel.n $e |- N = ( LSpan ` W ) $.
    lsatel.a $e |- A = ( LSAtoms ` W ) $.
    lsatel.w $e |- ( ph -> W e. LVec ) $.
    lsatel.u $e |- ( ph -> U e. A ) $.
    lsatel.x $e |- ( ph -> X e. U ) $.
    lsatel.e $e |- ( ph -> X =/= .0. ) $.
    $( A nonzero vector in an atom determines the atom.  (Contributed by NM,
       25-Aug-2014.) $)
    lsatel $p |- ( ph -> U = ( N ` { X } ) ) $=
      ( csn cfv wss wceq eqid wcel clvec clmod lveclmod syl lsatlssel lspsnel5a
      clss cbs wne lssel syl2anc lsatlspsn2 syl3anc lsatcmp mpbid eqcomd ) AFOD
      PZCAUQCQUQCRAEUGPZCDEFURSZIAEUATEUBTZKEUCUDZABURCEUSJVALUEZMUFABUQCEJKAUT
      FEUHPZTZFGUIUQBTVAACURTFCTVDVBMURCVCEFVCSZUSUJUKNBDVCEFGVEIHJULUMLUNUOUP
      $.
  $}

  ${
    lsatelb.v $e |- V = ( Base ` W ) $.
    lsatelb.o $e |- .0. = ( 0g ` W ) $.
    lsatelb.n $e |- N = ( LSpan ` W ) $.
    lsatelb.a $e |- A = ( LSAtoms ` W ) $.
    lsatelb.w $e |- ( ph -> W e. LVec ) $.
    lsatelb.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lsatelb.u $e |- ( ph -> U e. A ) $.
    $( A nonzero vector in an atom determines the atom.  (Contributed by NM,
       3-Feb-2015.)  (New usage is discouraged.) $)
    lsatelbN $p |- ( ph -> ( X e. U <-> U = ( N ` { X } ) ) ) $=
      ( wcel csn cfv wa adantr wceq clvec simpr wne eldifsn sylib simprd lsatel
      cdif wss eqimss2 adantl wb clss eqid clmod lveclmod syl lsatlssel eldifad
      lspsnel5 mpbird impbida ) AGCPZCGQDRZUAZAVDSBCDFGHJKLAFUBPZVDMTACBPVDOTAV
      DUCAGHUDZVDAGEPZVHAGEHQZUIPVIVHSNGEHUEUFUGTUHAVFSVDVECUJZVFVKAVECUKULAVDV
      KUMVFAFUNRZCDEFGIVLUOZKAVGFUPPMFUQURZABVLCFVMLVNOUSAGEVJNUTVATVBVC $.
  $}

  ${
    lsat2el.o $e |- .0. = ( 0g ` W ) $.
    lsat2el.a $e |- A = ( LSAtoms ` W ) $.
    lsat2el.w $e |- ( ph -> W e. LVec ) $.
    lsat2el.p $e |- ( ph -> P e. A ) $.
    lsat2el.q $e |- ( ph -> Q e. A ) $.
    lsat2el.x $e |- ( ph -> X =/= .0. ) $.
    lsat2el.x1 $e |- ( ph -> X e. P ) $.
    lsat2el.x2 $e |- ( ph -> X e. Q ) $.
    $( Two atoms sharing a nonzero vector are equal.  (Contributed by NM,
       8-Mar-2015.) $)
    lsat2el $p |- ( ph -> P = Q ) $=
      ( csn clspn cfv eqid lsatel eqtr4d ) ACFPEQRZRDABCUBEFGHUBSZIJKNMTABDUBEF
      GHUCIJLOMTUA $.
  $}

  ${
    $d p q r y z A $.  $d q r y z .0. $.  $d p q r y z .(+) $.  $d p r Q $.
    $d p q r y z T $.  $d p q r y z U $.  $d p q r y z W $.  $d q r y z ph $.
    lsmsat.o $e |- .0. = ( 0g ` W ) $.
    lsmsat.s $e |- S = ( LSubSp ` W ) $.
    lsmsat.p $e |- .(+) = ( LSSum ` W ) $.
    lsmsat.a $e |- A = ( LSAtoms ` W ) $.
    lsmsat.w $e |- ( ph -> W e. LMod ) $.
    lsmsat.t $e |- ( ph -> T e. S ) $.
    lsmsat.u $e |- ( ph -> U e. S ) $.
    lsmsat.q $e |- ( ph -> Q e. A ) $.
    lsmsat.n $e |- ( ph -> T =/= { .0. } ) $.
    lsmsat.l $e |- ( ph -> Q C_ ( T .(+) U ) ) $.
    $( Convert comparison of atom with sum of subspaces to a comparison to sum
       with atom.  ( ~ elpaddatiN analog.)  TODO: any way to shorten this?
       (Contributed by NM, 15-Jan-2015.) $)
    lsmsat $p |- ( ph -> E. p e. A ( p C_ T /\ Q C_ ( p .(+) U ) ) ) $=
      ( vr vy vz vq cv csn clspn cfv wceq cbs cdif wrex wss co wa wcel clmod wb
      eqid islsat syl mpbid cplusg simp3 3ad2ant1 eqsstr3d lsmcl syl3anc eldifi
      w3a 3ad2ant2 lspsnel5 mpbird lsssssubg sseldd lsmelval syl2anc wne lssne0
      csubg wi adantr simpr2 lssel simpr3 lspsnel5a simpl3 simpr1 oveq1d simp2r
      lsatlspsn2 lmod0vlid 3eqtrd sneqd fveq2d eqsstrd lsmub2 sstrd sseq1 oveq1
      lspsnsubg sseq2d anbi12d rspcev syl12anc 3exp2 imp rexlimdv mpd simpr cpr
      simp2l lspvadd sseqtrd lspsncl lsmless2 pm2.61dane 3exp rexlimdvv 3adant3
      lsmpr anbi2d rexbidv 3ad2ant3 ) ADUAUEZUFZHUGUHZUHZUIZUAHUJUHZIUFZUKZULZJ
      UEZFUMZDYNGCUNZUMZUOZJBULZADBUPZYMRAHUQUPZYTYMUROUABDYGYJHUQIYJUSZYGUSZKN
      UTVAVBAYIYSUAYLAYEYLUPZYIYSAUUDYIVJZYSYOYHYPUMZUOZJBULZUUEYEUBUEZUCUEZHVC
      UHZUNZUIZUCGULUBFULZUUHUUEYEFGCUNZUPZUUNUUEUUPYHUUOUMUUEYHDUUOAUUDYIVDAUU
      DDUUOUMYITVEVFUUEEUUOYGYJHYEUUBLUUCAUUDUUAYIOVEZAUUDUUOEUPZYIAUUAFEUPZGEU
      PZUUROPQCEFGHLMVGVHVEUUDAYEYJUPYIYEYJYKVIVKVLVMUUEFHVTUHZUPGUVAUPZUUPUUNU
      RUUEEUVAFUUEUUAEUVAUMZUUQEHLVNZVAZAUUDUUSYIPVEVOUUEEUVAGUVEAUUDUUTYIQVEVO
      UBUCUUKCFGHYEUUKUSZMVPVQVBAUUDUUNUUHWAYIAUUDUOZUUMUUHUBUCFGUVGUUIFUPZUUJG
      UPZUOZUUMUUHUVGUVJUUMVJZUUHUUIIUVKUUIIUIZUOZUDUEZIVRZUDFULZUUHUVKUVPUVLUV
      GUVJUVPUUMAUVPUUDAFYKVRZUVPSAUUSUVQUVPURPUDEHFIKLVSVAVBWBVEWBUVMUVOUUHUDF
      UVKUVLUVNFUPZUVOUUHWAWAUVKUVLUVRUVOUUHUVKUVLUVRUVOVJZUOZUVNUFYGUHZBUPZUWA
      FUMZYHUWAGCUNZUMZUUHUVTUUAUVNYJUPZUVOUWBUVKUUAUVSUVGUVJUUAUUMAUUAUUDOWBVE
      ZWBZUVTUUSUVRUWFUVKUUSUVSUVGUVJUUSUUMAUUSUUDPWBVEZWBZUVKUVLUVRUVOWCZEFYJH
      UVNUUBLWDVQZUVKUVLUVRUVOWEBYGYJHUVNIUUBUUCKNWKVHUVTEFYGHUVNLUUCUWHUWJUWKW
      FUVTYHGUWDUVTYHUUJUFZYGUHZGUVTYFUWMYGUVTYEUUJUVTYEUULIUUJUUKUNZUUJUVGUVJU
      UMUVSWGUVTUUIIUUJUUKUVKUVLUVRUVOWHWIUVTUUAUUJYJUPZUWOUUJUIUWHUVKUWPUVSUVK
      UUTUVIUWPUVGUVJUUTUUMAUUTUUDQWBVEZUVGUVHUVIUUMWJZEGYJHUUJUUBLWDVQZWBUUKYJ
      HUUJIUUBUVFKWLVQWMWNWOUVKUWNGUMZUVSUVKEGYGHUUJLUUCUWGUWQUWRWFZWBWPUVTUWAU
      VAUPZUVBGUWDUMUVTUUAUWFUXBUWHUWLYGYJHUVNUUBUUCXAVQUVTEUVAGUVTUUAUVCUWHUVD
      VAUVKUUTUVSUWQWBVOCUWAGHMWQVQWRUUGUWCUWEUOJUWABYNUWAUIZYOUWCUUFUWEYNUWAFW
      SUXCYPUWDYHYNUWAGCWTXBXCXDXEXFXGXHXIUVKUUIIVRZUOZUUIUFYGUHZBUPZUXFFUMZYHU
      XFGCUNZUMZUUHUXEUUAUUIYJUPZUXDUXGUVKUUAUXDUWGWBUVKUXKUXDUVKUUSUVHUXKUWIUV
      GUVHUVIUUMXLZEFYJHUUIUUBLWDVQZWBUVKUXDXJBYGYJHUUIIUUBUUCKNWKVHUVKUXHUXDUV
      KEFYGHUUILUUCUWGUWIUXLWFWBUVKUXJUXDUVKYHUXFUWNCUNZUXIUVKYHUUIUUJXKYGUHZUX
      NUVKYHUULUFZYGUHZUXOUVKYFUXPYGUVKYEUULUVGUVJUUMVDWNWOUVKUUAUXKUWPUXQUXOUM
      UWGUXMUWSUUKYGYJHUUIUUJUUBUVFUUCXMVHWPUVKCYGYJHUUIUUJUUBUUCMUWGUXMUWSYAXN
      UVKUXFUVAUPUVBUWTUXNUXIUMUVKEUVAUXFUVKUUAUVCUWGUVDVAZUVKUUAUXKUXFEUPUWGUX
      MEYGYJHUUIUUBLUUCXOVQVOUVKEUVAGUXRUWQVOUXACUXFUWNGHMXPVHWRWBUUGUXHUXJUOJU
      XFBYNUXFUIZYOUXHUUFUXJYNUXFFWSUXSYPUXIYHYNUXFGCWTXBXCXDXEXQXRXSXTXIYIAYSU
      UHURUUDYIYRUUGJBYIYQUUFYODYHYPWSYBYCYDVMXRXHXI $.
  $}

  ${
    $d w z N $.  $d w z .0. $.  $d w z .+ $.  $d w z ph $.  $d w z Q $.
    $d w z V $.  $d w z W $.  $d w z X $.  $d w z Y $.
    lsatfixed.v $e |- V = ( Base ` W ) $.
    lsatfixed.p $e |- .+ = ( +g ` W ) $.
    lsatfixed.o $e |- .0. = ( 0g ` W ) $.
    lsatfixed.n $e |- N = ( LSpan ` W ) $.
    lsatfixed.a $e |- A = ( LSAtoms ` W ) $.
    lsatfixed.w $e |- ( ph -> W e. LVec ) $.
    lsatfixed.q $e |- ( ph -> Q e. A ) $.
    lsatfixed.x $e |- ( ph -> X e. V ) $.
    lsatfixed.y $e |- ( ph -> Y e. V ) $.
    lsatfixed.e $e |- ( ph -> Q =/= ( N ` { X } ) ) $.
    lsatfixed.f $e |- ( ph -> Q =/= ( N ` { Y } ) ) $.
    lsatfixed.g $e |- ( ph -> Q C_ ( N ` { X , Y } ) ) $.
    $( Show equality with the span of the sum of two vectors, one of which
       ( ` X ` ) is fixed in advance.  Compare ~ lspfixed .  (Contributed by
       NM, 29-May-2015.)  (New usage is discouraged.) $)
    lsatfixedN $p |- ( ph
    -> E. z e. ( ( N ` { Y } ) \ { .0. } ) Q = ( N ` { ( X .+ z ) } ) ) $=
      ( vw cv csn cfv wceq cdif wrex co wcel clvec wb islsat syl mpbid 3ad2ant1
      w3a simp2 eldifad simp3 eqcomd wne eqnetrd lspsnne1 cpr eqsstrd clss eqid
      wss clmod lveclmod lspsnel5 mpbird lspfixed wa simpl1 simpl2 snssd lspssv
      lspprcl syl2anc ssdifssd sselda lmodvacl syl3anc lspsncmp simpl3 3bitr4rd
      lspsncl eqeq1d rexbidva rexlimdv3a mpd ) AEUDUEZUFFUGZUHZUDGKUFZUIZUJZEIB
      UEZDUKZUFFUGZUHZBJUFZFUGZWSUIZUJZAECULZXARAHUMULZXJXAUNQUDCEFGHUMKLONPUOU
      PUQAWRXIUDWTAWPWTULZWRUSZXIWPXDULZBXHUJXMBDFGHWPIKJLMNOAXLXKWRQURZXMWPGWS
      AXLWRUTZVAZAXLIGULZWRSURZAXLJGULWRTURZXMFGHWPIKLNOXOXPXSXMWQEIUFFUGZXMEWQ
      AXLWRVBVCZAXLEYAVDWRUAURVEVFXMFGHWPJKLNOXOXPXTXMWQEXGYBAXLEXGVDWRUBURVEVF
      XMWPIJVGFUGZULWQYCVKXMWQEYCYBAXLEYCVKWRUCURVHXMHVIUGZYCFGHWPLYDVJZOAXLHVL
      ULZWRAXKYFQHVMUPZURAXLYCYDULWRAYDFGHIJLYEOYGSTWBURXQVNVOVPXMXEXNBXHXMXBXH
      ULZVQZWQXDVKWQXDUHXNXEYIFGHWPXCKLNOYIAXKAXLWRYHVRZQUPAXLWRYHVSZYIYFXRXBGU
      LXCGULZYIAYFYJYGUPZYIAXRYJSUPXMXHGXBAXLXHGVKWRAXGGWSAYFXFGVKXGGVKYGAJGTVT
      XFFGHLOWAWCWDURWEDGHIXBLMWFWGZWHYIYDXDFGHWPLYEOYMYIYFYLXDYDULYMYNYDFGHXCL
      YEOWKWCYIWPGWSYKVAVNYIEWQXDAXLWRYHWIWLWJWMVOWNWO $.
  $}

  ${
    $d v .(+) $.  $d v Q $.  $d v T $.  $d v U $.  $d v W $.  $d v ph $.
    lsmsatcv.s $e |- S = ( LSubSp ` W ) $.
    lsmsatcv.p $e |- .(+) = ( LSSum ` W ) $.
    lsmsatcv.a $e |- A = ( LSAtoms ` W ) $.
    lsmsatcv.w $e |- ( ph -> W e. LVec ) $.
    lsmsatcv.t $e |- ( ph -> T e. S ) $.
    lsmsatcv.u $e |- ( ph -> U e. S ) $.
    lsmsatcv.x $e |- ( ph -> Q e. A ) $.
    $( Subspace sum has the covering property (using spans of singletons to
       represent atoms).  Similar to Exercise 5 of [Kalmbach] p. 153.
       ( ~ spansncvi analog.)  Explicit atom version of ~ lsmcv .  (Contributed
       by NM, 29-Oct-2014.) $)
    lsmsatcv $p |- ( ( ph /\ T C. U /\ U C_ ( T .(+) Q ) )
      -> U = ( T .(+) Q ) ) $=
      ( vv wceq cfv wa wcel wpss co wss cv csn clspn wrex wi clvec eqid islsati
      cbs syl2anc w3a adantr simpr lsmcv 3expib 3adant3 wb sseq2d anbi2d eqeq2d
      oveq2 imbi12d 3ad2ant3 mpbird rexlimdv3a mpd 3impib ) AFGUAZGFDCUBZUCZGVL
      QZADPUDZUEHUFRZRZQZPHULRZUGZVKVMSZVNUHZAHUITZDBTVTLOPBDVPVSHUIVSUJZVPUJZK
      UKUMAVRWBPVSAVOVSTZVRUNWBVKGFVQCUBZUCZSZGWGQZUHZAWFWKVRAWFSZVKWHWJWLCEFGV
      PVSHVOWDIWEJAWCWFLUOAFETWFMUOAGETWFNUOAWFUPUQURUSVRAWBWKUTWFVRWAWIVNWJVRV
      MWHVKVRVLWGGDVQFCVDZVAVBVRVLWGGWMVCVEVFVGVHVIVJ $.
  $}

  ${
    $d q x A $.  $d x .0. $.  $d q x U $.  $d q W $.  $d x ph $.
    lssatomic.s $e |- S = ( LSubSp ` W ) $.
    lssatomic.o $e |- .0. = ( 0g ` W ) $.
    lssatomic.a $e |- A = ( LSAtoms ` W ) $.
    lssatomic.w $e |- ( ph -> W e. LMod ) $.
    lssatomic.u $e |- ( ph -> U e. S ) $.
    lssatomic.n $e |- ( ph -> U =/= { .0. } ) $.
    $( The lattice of subspaces is atomic, i.e. any nonzero element is greater
       than or equal to some atom.  ( ~ shatomici analog.)  (Contributed by NM,
       10-Jan-2015.) $)
    lssatomic $p |- ( ph -> E. q e. A q C_ U ) $=
      ( vx cv wne wrex wss wcel cfv csn wb lssne0 syl mpbid w3a clspn clmod cbs
      3ad2ant1 simp2 eqid lssel syl2anc simp3 lsatlspsn2 lspsnel5a sseq1 rspcev
      syl3anc rexlimdv3a mpd ) ANOZFPZNDQZGOZDRZGBQZADFUAPZVEMADCSZVIVEUBLNCEDF
      IHUCUDUEAVDVHNDAVCDSZVDUFZVCUAEUGTZTZBSZVNDRZVHVLEUHSZVCEUITZSZVDVOAVKVQV
      DKUJZVLVJVKVSAVKVJVDLUJZAVKVDUKZCDVREVCVRULZHUMUNAVKVDUOBVMVREVCFWCVMULZI
      JUPUTVLCDVMEVCHWDVTWAWBUQVGVPGVNBVFVNDURUSUNVAVB $.
  $}

  ${
    $d x y A $.  $d x y N $.  $d x y S $.  $d x y U $.  $d y W $.
    lssats.s $e |- S = ( LSubSp ` W ) $.
    lssats.n $e |- N = ( LSpan ` W ) $.
    lssats.a $e |- A = ( LSAtoms ` W ) $.
    $( The lattice of subspaces is atomistic, i.e. any element is the supremum
       of its atoms.  Part of proof of Theorem 16.9 of [MaedaMaeda] p. 70.
       Hypothesis ( ~ shatomistici analog.)  (Contributed by NM,
       9-Apr-2014.) $)
    lssats $p |- ( ( W e. LMod /\ U e. S )
          -> U = ( N ` U. { x e. A | x C_ U } ) ) $=
      ( vy wcel wa cv wss crab cuni cfv wceq syl2anc syl3anc clmod eleq1 simplr
      c0g wne csn simplll cbs simpllr lssel lspsncl lspid lsatlss adantr rabss2
      eqid uniss 3syl unimax lssss eqsstrd adantl ad2antrr lsatlspsn2 lspsnel5a
      sstrd simpr sseq1 elrab sylanbrc elssuni syl lspss eqsstr3d sseldd simpll
      lspsnid lspcl syldan lss0cl pm2.61ne ex ssrdv simpl fveq2d eqtrd sseqtrd
      eqssd ) FUAKZDCKZLZDAMZDNZABOZPZEQZWKJDWPWKJMZDKZWQWPKZWKWRLZWSFUDQZWPKZW
      QXAWQXAWPUBWTWQXAUEZLZWQUFEQZWPWQXDXEXEEQZWPXDWIXECKZXFXERWIWJWRXCUGZXDWI
      WQFUHQZKZXGXHXDWJWRXJWIWJWRXCUIZWKWRXCUCZCDXIFWQXIUPZGUJSZCEXIFWQXMGHUKSC
      XEEFGHULSXDWIWOXINZXEWONZXFWPNXHWKXOWRXCWKWOWMACOZPZXIWKBCNZWNXQNWOXRNZWI
      XSWJBCFGIUMUNWMABCUOWNXQUQURZWJXRXINZWIWJXRDXIADCUSZCDXIFXMGUTVAVBZVFZVCX
      DXEWNKZXPXDXEBKZXEDNZYFXDWIXJXCYGXHXNWTXCVGBEXIFWQXAXMHXAUPZIVDTXDCDEFWQG
      HXHXKXLVEWMYHAXEBWLXEDVHVIVJXEWNVKVLXEWOEXIFXMHVMTVNXDWIXJWQXEKXHXNEXIFWQ
      XMHVQSVOWTWIWPCKZXBWIWJWRVPWKYJWRWIWJXOYJYECWOEXIFXMGHVRVSUNCWPFXAYIGVTSW
      AWBWCWKWPXREQZDWKWIYBXTWPYKNWIWJWDYDYAWOXREXIFXMHVMTWKYKDEQDWKXRDEWJXRDRW
      IYCVBWECDEFGHULWFWGWH $.
  $}

  ${
    $d q A $.  $d q S $.  $d q T $.  $d q U $.  $d q W $.
    lpssat.s $e |- S = ( LSubSp ` W ) $.
    lpssat.a $e |- A = ( LSAtoms ` W ) $.
    lpssat.w $e |- ( ph -> W e. LMod ) $.
    lpssat.t $e |- ( ph -> T e. S ) $.
    lpssat.u $e |- ( ph -> U e. S ) $.
    lpssat.l $e |- ( ph -> T C. U ) $.
    $( Two subspaces in a proper subset relationship imply the existence of an
       atom less than or equal to one but not the other.  ( ~ chpssati
       analog.)  (Contributed by NM, 11-Jan-2015.) $)
    lpssat $p |- ( ph -> E. q e. A ( q C_ U /\ -. q C_ T ) ) $=
      ( wss wn syl crab cuni cfv adantr cv wral wrex wpss dfpss3 simprbi ralbii
      wa iman ss2rab clspn clmod wcel cbs lsatlss rabss2 uniss 4syl wceq unimax
      wi eqid lssss eqsstrd sstrd adantl syl3anc lssats syl2anc 3sstr4d syl5bir
      lspss ex mtod dfrex2 sylibr ) AGUAZENZVQDNZOUHZOZGBUBZOVTGBUCAWBEDNZADEUD
      ZWCOZMWDDENWEDEUEUFPWBVRVSVAZGBUBZAWCWFWAGBVRVSUIUGWGVRGBQZVSGBQZNZAWCVRV
      SGBUJAWJWCAWJUHZWHRZFUKSZSZWIRZWMSZEDWKFULUMZWOFUNSZNZWLWONZWNWPNAWQWJJTA
      WSWJAWOVSGCQZRZWRAWQBCNWIXANWOXBNJBCFHIUOVSGBCUPWIXAUQURAXBDWRADCUMZXBDUS
      KGDCUTPAXCDWRNKCDWRFWRVBZHVCPVDVETWJWTAWHWIUQVFWLWOWMWRFXDWMVBZVLVGAEWNUS
      ZWJAWQECUMXFJLGBCEWMFHXEIVHVITADWPUSZWJAWQXCXGJKGBCDWMFHXEIVHVITVJVMVKVKV
      NVTGBVOVP $.
  $}

  ${
    $d q A $.  $d q S $.  $d q T $.  $d q U $.  $d q W $.  $d q ph $.
    lrelat.s $e |- S = ( LSubSp ` W ) $.
    lrelat.p $e |- .(+) = ( LSSum ` W ) $.
    lrelat.a $e |- A = ( LSAtoms ` W ) $.
    lrelat.w $e |- ( ph -> W e. LMod ) $.
    lrelat.t $e |- ( ph -> T e. S ) $.
    lrelat.u $e |- ( ph -> U e. S ) $.
    lrelat.l $e |- ( ph -> T C. U ) $.
    $( Subspaces are relatively atomic.  Remark 2 of [Kalmbach] p. 149.
       ( ~ chrelati analog.)  (Contributed by NM, 11-Jan-2015.) $)
    lrelat $p |- ( ph ->
        E. q e. A ( T C. ( T .(+) q ) /\ ( T .(+) q ) C_ U ) ) $=
      ( wss wa wcel adantr sseldd cv wn wrex co wpss lpssat ancom cfv lsssssubg
      csubg clmod syl simpr lsatlssel lssnle pssssd biantrurd wb lsmlub syl3anc
      bitrd anbi12d syl5bb rexbidva mpbid ) AHUAZFPZVFEPUBZQZHBUCEEVFCUDZUEZVJF
      PZQZHBUCABDEFGHIKLMNOUFAVIVMHBVIVHVGQAVFBRZQZVMVGVHUGVOVHVKVGVLVOCEVFGJVO
      DGUJUHZEVOGUKRZDVPPAVQVNLSZDGIUIULZAEDRVNMSTZVODVPVFVSVOBDVFGIKVRAVNUMUNT
      ZUOVOVGEFPZVGQZVLVOWBVGAWBVNAEFOUPSUQVOEVPRVFVPRFVPRWCVLURVTWAVODVPFVSAFD
      RVNNSTCEVFFGJUSUTVAVBVCVDVE $.
  $}

  ${
    $d p A $.  $d p S $.  $d p T $.  $d p U $.  $d p W $.
    lssatle.s $e |- S = ( LSubSp ` W ) $.
    lssatle.a $e |- A = ( LSAtoms ` W ) $.
    lssatle.w $e |- ( ph -> W e. LMod ) $.
    lssatle.t $e |- ( ph -> T e. S ) $.
    lssatle.u $e |- ( ph -> U e. S ) $.
    $( The ordering of two subspaces is determined by the atoms under them.
       ( ~ chrelat3 analog.)  (Contributed by NM, 29-Oct-2014.) $)
    lssatle $p |- ( ph
       -> ( T C_ U <-> A. p e. A ( p C_ T -> p C_ U ) ) ) $=
      ( wss crab cuni cfv wcel adantr uniss wceq cv wral expcom ralrimivw clspn
      wi sstr ss2rab wa clmod cbs lsatlss rabss2 4syl unimax eqid lssss eqsstrd
      syl sstrd adantl lspss syl3anc ex syl2anc sseq12d sylibrd syl5bir impbid2
      lssats ) ADEMZGUAZDMZVLEMZUFZGBUBZVKVOGBVMVKVNVLDEUGUCUDVPVMGBNZVNGBNZMZA
      VKVMVNGBUHAVSVQOZFUEPZPZVROZWAPZMZVKAVSWEAVSUIFUJQZWCFUKPZMZVTWCMZWEAWFVS
      JRAWHVSAWCVNGCNZOZWGAWFBCMVRWJMWCWKMJBCFHIULVNGBCUMVRWJSUNAWKEWGAECQZWKET
      LGECUOUSAWLEWGMLCEWGFWGUPZHUQUSURUTRVSWIAVQVRSVAVTWCWAWGFWMWAUPZVBVCVDADW
      BEWDAWFDCQDWBTJKGBCDWAFHWNIVJVEAWFWLEWDTJLGBCEWAFHWNIVJVEVFVGVHVI $.
  $}

  ${
    $d p A $.  $d p S $.  $d p U $.  $d p V $.  $d p W $.
    lssat.s $e |- S = ( LSubSp ` W ) $.
    lssat.a $e |- A = ( LSAtoms ` W ) $.
    $( Two subspaces in a proper subset relationship imply the existence of a
       1-dim subspace less than or equal to one but not the other.
       ( ~ chpssati analog.)  (Contributed by NM, 9-Apr-2014.) $)
    lssat $p |- ( ( ( W e. LMod /\ U e. S /\ V e. S ) /\ U C. V )
          -> E. p e. A ( p C_ V /\ -. p C_ U ) ) $=
      ( wcel wss wn wa wral crab cuni cfv uniss wceq syl eqid wpss clmod w3a cv
      wrex dfpss3 simprbi wi ss2rab iman ralbii bitr2i clspn cbs simpl1 lsatlss
      rabss2 4syl simpl2 unimax lssss eqsstrd sstrd adantl lspss syl3anc simpl3
      lssats syl2anc 3sstr4d ex syl5bi con3and dfrex2 sylibr sylan2 ) CDUAZEUBI
      ZCBIZDBIZUCZDCJZKZFUDZDJZWDCJZKLZFAUEZVQCDJWCCDUFUGWAWCLWGKZFAMZKWHWAWJWB
      WJWEFANZWFFANZJZWAWBWMWEWFUHZFAMWJWEWFFAUIWNWIFAWEWFUJUKULWAWMWBWAWMLZWKO
      ZEUMPZPZWLOZWQPZDCWOVRWSEUNPZJWPWSJZWRWTJVRVSVTWMUOZWOWSWFFBNZOZXAWOVRABJ
      WLXDJWSXEJXCABEGHUPWFFABUQWLXDQURWOXECXAWOVSXECRVRVSVTWMUSZFCBUTSWOVSCXAJ
      XFBCXAEXATZGVASVBVCWMXBWAWKWLQVDWPWSWQXAEXGWQTZVEVFWOVRVTDWRRXCVRVSVTWMVG
      FABDWQEGXHHVHVIWOVRVSCWTRXCXFFABCWQEGXHHVHVIVJVKVLVMWGFAVNVOVP $.
  $}

  ${
    $d q v .(+) $.  $d q v S $.  $d q v U $.  $d q v V $.  $d q v W $.
    $d q v ph $.
    islshpat.v $e |- V = ( Base ` W ) $.
    islshpat.s $e |- S = ( LSubSp ` W ) $.
    islshpat.p $e |- .(+) = ( LSSum ` W ) $.
    islshpat.h $e |- H = ( LSHyp ` W ) $.
    islshpat.a $e |- A = ( LSAtoms ` W ) $.
    islshpat.w $e |- ( ph -> W e. LMod ) $.
    $( Hyperplane properties expressed with subspace sum and an atom.  TODO:
       can proof be shortened?  Seems long for a simple variation of
       ~ islshpsm .  (Contributed by NM, 11-Jan-2015.) $)
    islshpat $p |- ( ph -> ( U e. H <-> ( U e. S /\ U =/= V /\
                   E. q e. A ( U .(+) q ) = V ) ) ) $=
      ( vv wcel wceq wrex wa wne cv csn clspn cfv w3a eqid islshpsm wex r19.42v
      co df-3an bitr4i c0g df-rex simpr sneqd fveq2d clmod ad3antrrr lspsn0 syl
      cdif eqtrd csubg simplrl lsssubg syl2anc lsm01 simplrr eqnetrd ex necon2d
      oveq2d pm4.71rd pm5.32da eldifsn anbi1i anass anbi2i bitr2i syl6bb exbidv
      an12 bitri syl5bb rexcom4b ancom rexbii exbii r19.41v oveq2 eqeq1d anbi2d
      fvex pm5.32i bitr3i syl6bbr wb islsat anbi1d bitr4d bitrd ) AEFQEDQZEGUAZ
      EPUBZUCZHUDUEZUEZCUKZGRZPGSZUFZXDXEEIUBZCUKZGRZIBSZUFZAPCDEFXHGHJXHUGZKLM
      OUHAXMXNBQZXDXETZXPTZTZIUIZXRXMYAXKTZPGSZAYDXMYAXLTYFXDXEXLULYAXKPGUJUMAY
      FXNXIRZPGHUNUEZUCZVCZSZYBTZIUIZYDAYFYGYETZPYJSZIUIZYMAYFXFYJQZYETZPUIZYPY
      FXFGQZYETZPUIAYSYEPGUOAUUAYRPAUUAYTYAXFYHUAZXKTZTZTZYRAYTYEUUDAYTTZYAXKUU
      CUUFYATZXKUUBUUGXFYHXJGUUGXFYHRZXJGUAUUGUUHTZXJEGUUIXJEYICUKZEUUIXIYIECUU
      IXIYIXHUEZYIUUIXGYIXHUUIXFYHUUGUUHUPUQURUUIHUSQZUUKYIRAUULYTYAUUHOUTZXHHY
      HYHUGZXSVAVBVDVNUUIEHVEUEQZUUJERUUIUULXDUUOUUMUUFXDXEUUHVFDEHKVGVHCHEYHUU
      NLVIVBVDUUFXDXEUUHVJVKVLVMVOVPVPYRYTUUBTZYETZUUEYQUUPYEXFGYHVQVRUUQYTUUBY
      ETZTUUEYTUUBYEVSUURUUDYTUUBYAXKWDVTWEWAWBWCWFYSYEYGTZPYJSZIUIZYPUVAYEPYJS
      YSYEIPYJXIXGXHWOWGYEPYJUOWAUUTYOIUUSYNPYJYEYGWHWIWJWEWBYLYOIYLYGYBTZPYJSY
      OYGYBPYJWKUVBYNPYJYGYBYEYGXPXKYAYGXOXJGXNXIECWLWMWNWPWIWQWJWRAYCYLIAXTYKY
      BAUULXTYKWSOPBXNXHGHUSYHJXSUUNNWTVBXAWCXBWFXRYAXQTZYDXDXEXQULUVCYBIBSYDYA
      XPIBUJYBIBUOWQWAWBXC $.
  $}

  $c <oL $.

  $( Extend class notation with the covering relation for a left module or left
     vector space. $)
  clcv $a class <oL $.

  ${
    $d s t u w $.
    $( Define the covering relation for subspaces of a left vector space.
       Similar to Definition 3.2.18 of [PtakPulmannova] p. 68.
       Ptak/Pulmannova's notation ` A ( <oL `` W ) B ` is read " ` B ` covers
       ` A ` " or " ` A ` is covered by ` B ` " , and it means that ` B ` is
       larger than ` A ` and there is nothing in between.  See ~ lcvbr for
       binary relation.  ( ~ df-cv analog.)  (Contributed by NM,
       7-Jan-2015.) $)
    df-lcv $a |- <oL = ( w e. _V |->
     { <. t , u >. | ( ( t e. ( LSubSp ` w ) /\ u e. ( LSubSp ` w ) ) /\
         ( t C. u /\ -. E. s e. ( LSubSp ` w ) ( t C. s /\ s C. u ) ) ) } ) $.
  $}

  ${
    $d s t u w S $.  $d s t u w W $.
    lcvfbr.s $e |- S = ( LSubSp ` W ) $.
    lcvfbr.c $e |- C = ( <oL ` W ) $.
    lcvfbr.w $e |- ( ph -> W e. X ) $.
    $( The covers relation for a left vector space (or a left module).
       (Contributed by NM, 7-Jan-2015.) $)
    lcvfbr $p |- ( ph -> C = { <. t , u >. | ( ( t e. S /\ u e. S ) /\
         ( t C. u /\ -. E. s e. S ( t C. s /\ s C. u ) ) ) } ) $=
      ( vw clcv cfv cv wcel wa wpss cvv clss wrex copab wceq elex fveq2 syl6eqr
      wn eleq2d anbi12d rexeqdv notbid anbi2d opabbidv df-lcv fvex eqeltri xpex
      cxp opabssxp ssexi fvmpt 3syl syl5eq ) ADFMNZCOZEPZBOZEPZQZVEVGRZVEHOZRVK
      VGRQZHEUAZUGZQZQZCBUBZJAFGPFSPVDVQUCKFGUDLFVELOZTNZPZVGVSPZQZVJVLHVSUAZUG
      ZQZQZCBUBVQSMVRFUCZWFVPCBWGWBVIWEVOWGVTVFWAVHWGVSEVEWGVSFTNZEVRFTUEIUFZUH
      WGVSEVGWIUHUIWGWDVNVJWGWCVMWGVLHVSEWIUJUKULUIUMLBCHUNVQEEUREEEWHSIFTUOUPZ
      WJUQVOCBEEUSUTVAVBVC $.

    $d s t u T $.  $d s t u U $.
    lcvfbr.t $e |- ( ph -> T e. S ) $.
    lcvfbr.u $e |- ( ph -> U e. S ) $.
    $( The covers relation for a left vector space (or a left module).
       ( ~ cvbr analog.)  (Contributed by NM, 9-Jan-2015.) $)
    lcvbr $p |- ( ph -> ( T C U
          <-> ( T C. U /\ -. E. s e. S ( T C. s /\ s C. U ) ) ) ) $=
      ( vt vu cv wcel wa wpss anbi12d wrex wn copab wb wceq eleq1 anbi1d psseq1
      wbr rexbidv notbid anbi2d psseq2 brabg syl2anc lcvfbr breqd jca biantrurd
      eqid 3bitr4d ) ADENPZCQZOPZCQZRZVBVDSZVBHPZSZVHVDSZRZHCUAZUBZRZRZNOUCZUIZ
      DCQZECQZRZDESZDVHSZVHESZRZHCUAZUBZRZRZDEBUIWGAVRVSVQWHUDLMVOVRVERZDVDSZWB
      VJRZHCUAZUBZRZRWHNODECCVPVBDUEZVFWIVNWNWOVCVRVEVBDCUFUGWOVGWJVMWMVBDVDUHW
      OVLWLWOVKWKHCWOVIWBVJVBDVHUHUGUJUKTTVDEUEZWIVTWNWGWPVEVSVRVDECUFULWPWJWAW
      MWFVDEDUMWPWLWEWPWKWDHCWPVJWCWBVDEVHUMULUJUKTTVPUTUNUOABVPDEAONBCFGHIJKUP
      UQAVTWGAVRVSLMURUSVA $.

    $( The covers relation for a left vector space (or a left module).
       ( ~ cvbr2 analog.)  (Contributed by NM, 9-Jan-2015.) $)
    lcvbr2 $p |- ( ph -> ( T C U
          <-> ( T C. U /\ A. s e. S ( ( T C. s /\ s C_ U ) -> s = U ) ) ) ) $=
      ( wbr wpss cv wa wn wral anbi2i wrex wss wceq wi lcvbr iman dfpss2 bitr4i
      anass xchbinx ralbii ralnex bitri syl6bbr ) ADEBNDEOZDHPZOZUPEOZQZHCUARZQ
      UOUQUPEUBZQZUPEUCZUDZHCSZQABCDEFGHIJKLMUEVEUTUOVEUSRZHCSUTVDVFHCVDVBVCRZQ
      ZUSVBVCUFVHUQVAVGQZQUSUQVAVGUIURVIUQUPEUGTUHUJUKUSHCULUMTUN $.

    $( The covers relation for a left vector space (or a left module).
       (Contributed by NM, 9-Jan-2015.) $)
    lcvbr3 $p |- ( ph -> ( T C U
          <-> ( T C. U /\ A. s e. S ( ( T C_ s /\ s C_ U )
                  -> ( s = T \/ s = U ) ) ) ) ) $=
      ( wpss wa wn wss wne anbi2i bitri wbr cv wrex wceq wo wi wral iman df-pss
      lcvbr necom anbi12i an4 neanior xchbinxr ralbii ralnex syl6bbr ) ADEBUADE
      NZDHUBZNZUTENZOZHCUCPZOUSDUTQZUTEQZOZUTDUDUTEUDUEZUFZHCUGZOABCDEFGHIJKLMU
      JVJVDUSVJVCPZHCUGVDVIVKHCVIVGVHPZOZVCVGVHUHVCVEUTDRZOZVFUTERZOZOZVMVAVOVB
      VQVAVEDUTRZOVODUTUIVSVNVEDUTUKSTUTEUIULVRVGVNVPOZOVMVEVNVFVPUMVTVLVGUTDUT
      EUNSTTUOUPVCHCUQTSUR $.

    lcvpss.d $e |- ( ph -> T C U ) $.
    $( The covers relation implies proper subset.  ( ~ cvpss analog.)
       (Contributed by NM, 7-Jan-2015.) $)
    lcvpss $p |- ( ph -> T C. U ) $=
      ( vs wpss cv wa wrex wn wbr lcvbr mpbid simpld ) ADEOZDNPZOUEEOQNCRSZADEB
      TUDUFQMABCDEFGNHIJKLUAUBUC $.
  $}

  ${
    $d u R $.  $d u S $.  $d u T $.  $d u U $.  $d u W $.
    lcvnbtwn.s $e |- S = ( LSubSp ` W ) $.
    lcvnbtwn.c $e |- C = ( <oL ` W ) $.
    lcvnbtwn.w $e |- ( ph -> W e. X ) $.
    lcvnbtwn.r $e |- ( ph -> R e. S ) $.
    lcvnbtwn.t $e |- ( ph -> T e. S ) $.
    lcvnbtwn.u $e |- ( ph -> U e. S ) $.
    lcvnbtwn.d $e |- ( ph -> R C T ) $.
    $( The covers relation implies no in-betweenness.  ( ~ cvnbtwn analog.)
       (Contributed by NM, 7-Jan-2015.) $)
    lcvnbtwn $p |- ( ph -> -. ( R C. U /\ U C. T ) ) $=
      ( vu wpss wa cv wrex wn wbr lcvbr mpbid simprd wcel psseq2 psseq1 anbi12d
      wceq rspcev sylan mtand ) ACFQZFEQZRZCPSZQZUQEQZRZPDTZACEQZVAUAZACEBUBVBV
      CROABDCEGHPIJKLMUCUDUEAFDUFUPVANUTUPPFDUQFUJURUNUSUOUQFCUGUQFEUHUIUKULUM
      $.

    ${
      lcvntr.p $e |- ( ph -> T C U ) $.
      $( The covers relation is not transitive.  ( ~ cvntr analog.)
         (Contributed by NM, 10-Jan-2015.) $)
      lcvntr $p |- ( ph -> -. R C U ) $=
        ( wpss wa wcel adantr wbr lcvpss jca wn simpr lcvnbtwn ex mt2d ) ACFBUA
        ZCEQZEFQZRZAUJUKABDCEGHIJKLMOUBABDEFGHIJKMNPUBUCAUIULUDAUIRBCDFEGHIJAGH
        SUIKTACDSUILTAFDSUINTAEDSUIMTAUIUEUFUGUH $.
    $}

    ${
      lcvnbtwn2.p $e |- ( ph -> R C. U ) $.
      lcvnbtwn2.q $e |- ( ph -> U C_ T ) $.
      $( The covers relation implies no in-betweenness.  ( ~ cvnbtwn2 analog.)
         (Contributed by NM, 7-Jan-2015.) $)
      lcvnbtwn2 $p |- ( ph -> U = T ) $=
        ( wpss wa wn wss wceq lcvnbtwn anass dfpss2 anbi2i bitr4i notbii bitr2i
        wi iman sylib mp2and ) ACFRZFEUAZFEUBZPQAUNFERZSZTZUNUOSZUPUJZABCDEFGHI
        JKLMNOUCVAUTUPTZSZTUSUTUPUKVCURVCUNUOVBSZSURUNUOVBUDUQVDUNFEUEUFUGUHUIU
        LUM $.
    $}

    ${
      lcvnbtwn3.p $e |- ( ph -> R C_ U ) $.
      lcvnbtwn3.q $e |- ( ph -> U C. T ) $.
      $( The covers relation implies no in-betweenness.  ( ~ cvnbtwn3 analog.)
         (Contributed by NM, 7-Jan-2015.) $)
      lcvnbtwn3 $p |- ( ph -> U = R ) $=
        ( wpss wa wn wss wceq wi lcvnbtwn iman eqcom imbi2i dfpss2 anbi1i bitri
        an32 notbii 3bitr4ri sylib mp2and ) ACFUAZFERZFCUBZPQACFRZUQSZTZUPUQSZU
        RUCZABCDEFGHIJKLMNOUDVBCFUBZUCVBVDTZSZTVCVAVBVDUEURVDVBFCUFUGUTVFUTUPVE
        SZUQSVFUSVGUQCFUHUIUPVEUQUKUJULUMUNUO $.
    $}
  $}

  ${
    $d x N $.  $d x .(+) $.  $d x S $.  $d x U $.  $d x W $.  $d x X $.
    $d x ph $.
    lsmcv2.v $e |- V = ( Base ` W ) $.
    lsmcv2.s $e |- S = ( LSubSp ` W ) $.
    lsmcv2.n $e |- N = ( LSpan ` W ) $.
    lsmcv2.p $e |- .(+) = ( LSSum ` W ) $.
    lsmcv2.c $e |- C = ( <oL ` W ) $.
    lsmcv2.w $e |- ( ph -> W e. LVec ) $.
    lsmcv2.u $e |- ( ph -> U e. S ) $.
    lsmcv2.x $e |- ( ph -> X e. V ) $.
    lsmcv2.l $e |- ( ph -> -. ( N ` { X } ) C_ U ) $.
    $( Subspace sum has the covering property (using spans of singletons to
       represent atoms).  Proposition 1(ii) of [Kalmbach] p. 153.
       ( ~ spansncv2 analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lsmcv2 $p |- ( ph -> U C ( U .(+) ( N ` { X } ) ) ) $=
      ( vx wcel csn cfv co wbr wpss cv wss wa wceq wi wral wn csubg clmod clvec
      lveclmod syl lsssssubg sseldd lspsncl syl2anc lssnle 3simpa simp3l simp3r
      mpbid w3a adantr simpr lsmcv syl3anc 3exp ralrimiv lsmcl lcvbr2 mpbir2and
      ) AEEIUAFUBZCUCZBUDEVRUEZESUFZUEZVTVRUGZUHZVTVRUIZUJZSDUKAVQEUGULVSRACEVQ
      HMADHUMUBZEAHUNTZDWFUGAHUOTZWGOHUPUQZDHKURUQZPUSADWFVQWJAWGIGTZVQDTZWIQDF
      GHIJKLUTVAZUSVBVFAWESDAVTDTZWCWDAWNWCVGAWNUHZWAWBWDAWNWCVCAWNWAWBVDAWNWAW
      BVEWOCDEVTFGHIJKLMAWHWNOVHAEDTZWNPVHAWNVIAWKWNQVHVJVKVLVMABDEVRHUOSKNOPAW
      GWPWLVRDTWIPWMCDEVQHKMVNVKVOVP $.
  $}

  ${
    $d q A $.  $d q S $.  $d q T $.  $d q U $.  $d q W $.  $d q ph $.
    lcvat.s $e |- S = ( LSubSp ` W ) $.
    lcvat.p $e |- .(+) = ( LSSum ` W ) $.
    lcvat.a $e |- A = ( LSAtoms ` W ) $.
    icvat.c $e |- C = ( <oL ` W ) $.
    lcvat.w $e |- ( ph -> W e. LMod ) $.
    lcvat.t $e |- ( ph -> T e. S ) $.
    lcvat.u $e |- ( ph -> U e. S ) $.
    lcvat.l $e |- ( ph -> T C U ) $.
    $( If a subspace covers another, it equals the other joined with some
       atom.  This is a consequence of relative atomicity.  ( ~ cvati analog.)
       (Contributed by NM, 11-Jan-2015.) $)
    lcvat $p |- ( ph -> E. q e. A ( T .(+) q ) = U ) $=
      ( clmod wcel 3ad2ant1 cv co wpss wss wa wrex wceq lcvpss lrelat w3a simp2
      lsatlssel lsmcl syl3anc wbr simp3l simp3r lcvnbtwn2 3exp reximdvai mpd )
      AFFIUAZDUBZUCZVCGUDZUEZIBUFVCGUGZIBUFABDEFGHIJKLNOPACEFGHRJMNOPQUHUIAVFVG
      IBAVBBSZVFVGAVHVFUJZCFEGVCHRJMAVHHRSZVFNTZAVHFESZVFOTZAVHGESVFPTVIVJVLVBE
      SVCESVKVMVIBEVBHJLVKAVHVFUKULDEFVBHJKUMUNAVHFGCUOVFQTAVHVDVEUPAVHVDVEUQUR
      USUTVA $.
  $}

  ${
    $d s x .0. $.  $d s x Q $.  $d s x W $.  $d s x ph $.
    lsatcv0.o $e |- .0. = ( 0g ` W ) $.
    lsatcv0.a $e |- A = ( LSAtoms ` W ) $.
    lsatcv0.c $e |- C = ( <oL ` W ) $.
    lsatcv0.w $e |- ( ph -> W e. LVec ) $.
    lsatcv0.q $e |- ( ph -> Q e. A ) $.
    $( An atom covers the zero subspace.  ( ~ atcv0 analog.)  (Contributed by
       NM, 7-Jan-2015.) $)
    lsatcv0 $p |- ( ph -> { .0. } C Q ) $=
      ( vs vx wpss wa cfv wrex wcel syl eqid csn wbr cv clss wn wss clmod clvec
      wne lveclmod lsatlssel lss0ss syl2anc lsatn0 necomd df-pss sylanbrc clspn
      wceq cbs wb islsat mpbid wi adantr eldifi adantl eldifsni lspsncv0 psseq2
      cdif ex anbi2d rexbidv notbid biimprcd syl6 rexlimdv mpd lsssn0 mpbir2and
      lcvbr ) AFUAZDCUBWCDNZWCLUCZNZWEDNZOZLEUDPZQZUEZAWCDUFZWCDUIWDAEUGRZDWIRW
      LAEUHRZWMJEUJSZABWIDEWITZHWOKUKZWIEDFGWPULUMADWCABDEFGHWOKUNUOWCDUPUQADMU
      CZUAEURPZPZUSZMEUTPZWCVKZQZWKADBRZXDKAWMXEXDVAWOMBDWSXBEUGFXBTZWSTZGHVBSV
      CAXAWKMXCAWRXCRZWFWEWTNZOZLWIQZUEZXAWKVDAXHXLAXHOLWIWSXBEWRFXFGWPXGAWNXHJ
      VEXHWRXBRAWRXBWCVFVGXHWRFUIAWRXBFVHVGVIVLXAWKXLXAWJXKXAWHXJLWIXAWGXIWFDWT
      WEVJVMVNVOVPVQVRVSACWIWCDEUHLWPIJAWMWCWIRWOWIEFGWPVTSWQWBWA $.
  $}

  ${
    lsatcveq0.o $e |- .0. = ( 0g ` W ) $.
    lsatcveq0.s $e |- S = ( LSubSp ` W ) $.
    lsatcveq0.a $e |- A = ( LSAtoms ` W ) $.
    lsatcveq0.c $e |- C = ( <oL ` W ) $.
    lsatcveq0.w $e |- ( ph -> W e. LVec ) $.
    lsatcveq0.u $e |- ( ph -> U e. S ) $.
    lsatcveq0.q $e |- ( ph -> Q e. A ) $.
    $( A subspace covered by an atom must be the zero subspace.  ( ~ atcveq0
       analog.)  (Contributed by NM, 7-Jan-2015.) $)
    lsatcveq0 $p |- ( ph -> ( U C Q <-> U = { .0. } ) ) $=
      ( wbr clvec wcel adantr 3ad2ant1 csn wceq wa clmod lveclmod syl lsatlssel
      wpss simpr lcvpss ex wi lsatcv0 w3a lsssn0 simp2 wss lss0ss syl2anc simp3
      lcvnbtwn3 3exp mpd syld breq1 syl5ibrcom impbid ) AFDCPZFHUAZUBZAVHFDUHZV
      JAVHVKAVHUCCEFDGQJLAGQRZVHMSAFERZVHNSADERZVHABEDGJKAVLGUDRZMGUEUFZOUGZSAV
      HUIUJUKAVIDCPZVKVJULABCDGHIKLMOUMZAVRVKVJAVRVKUNCVIEDFGQJLAVRVLVKMTAVRVIE
      RZVKAVOVTVPEGHIJUOUFTAVRVNVKVQTAVRVMVKNTAVRVKUPAVRVIFUQZVKAVOVMWAVPNEGFHI
      JURUSTAVRVKUTVAVBVCVDAVHVJVRVSFVIDCVEVFVG $.
  $}

  ${
    $d x C $.  $d s x .0. $.  $d s S $.  $d s x U $.  $d s x W $.  $d x ph $.
    lsat0cv.o $e |- .0. = ( 0g ` W ) $.
    lsat0cv.s $e |- S = ( LSubSp ` W ) $.
    lsat0cv.a $e |- A = ( LSAtoms ` W ) $.
    lsat0cv.c $e |- C = ( <oL ` W ) $.
    lsat0cv.w $e |- ( ph -> W e. LVec ) $.
    lsat0cv.u $e |- ( ph -> U e. S ) $.
    $( A subspace is an atom iff it covers the zero subspace.  This could serve
       as an alternate definition of an atom.  TODO: this is a quick-and-dirty
       proof that could probably be more efficient.  (Contributed by NM,
       14-Mar-2015.) $)
    lsat0cv $p |- ( ph -> ( U e. A <-> { .0. } C U ) ) $=
      ( vx wcel wa adantr wceq syl ad2antrr vs csn clvec simpr lsatcv0 cv clspn
      wbr cfv cbs cdif wrex wn wex wpss clmod lveclmod lsssn0 lcvpss pssnel wne
      simprl eqid lssel syl2anc biimpri necon3bi adantl eldifsn sylanbrc jca ex
      elsn eximdv df-rex syl6ibr mpd simpllr wi wb lcvbr2 eldifi lspsncl lss0ss
      wss wral eldifsni lspsneq0 necon3bid mpbird necomd df-pss lspsnel5a sseq1
      simplr psseq2 anbi12d eqeq1 imbi12d expimpd sylbid eqcomd reximdva islsat
      rspcv mpid impbida ) AEBOZGUBZECUHZAXHPBCEFGHJKAFUCOZXHLQAXHUDUEAXJPZXHEN
      UFZUBFUGUIZUIZRZNFUJUIZXIUKZULZXLXMEOZNXRULZXSXLXTXMXIOZUMZPZNUNZYAXLXIEU
      OZYEXLCDXIEFUPIKAFUPOZXJAXKYGLFUQSZQAXIDOZXJAYGYIYHDFGHIURSZQAEDOZXJMQAXJ
      UDUSNXIEUTSXLYEXMXROZXTPZNUNYAXLYDYMNXLYDYMXLYDPZYLXTYNXMXQOZXMGVAZYLYNYK
      XTYOAYKXJYDMTXLXTYCVBZDEXQFXMXQVCZIVDVEYDYPXLYCYPXTYBXMGYBXMGRZNGVMVFVGVH
      VHXMXQGVIVJYQVKVLVNXTNXRVOVPVQXLXTXPNXRXLYLPZXTXPYTXTPZXOEUUAXJXOERZAXJYL
      XTVRUUAXJYFXIUAUFZUOZUUCEWEZPZUUCERZVSZUADWFZPZUUBXLXJUUJVTZYLXTAUUKXJACD
      XIEFUCUAIKLYJMWAQTUUAYFUUIUUBUUAYFPZUUIXIXOUOZXOEWEZPZUUBUULUUMUUNUULXIXO
      WEZXIXOVAUUMUULYGXODOZUUPYTYGXTYFAYGXJYLYHTTZUULYGYOUUQUURYTYOXTYFYLYOXLX
      MXQXIWBVHTZDXNXQFXMYRIXNVCZWCVEZDFXOGHIWDVEUULXOXIUULXOXIVAYPYTYPXTYFYLYP
      XLXMXQGWGVHTUULXOXIXMGUULYGYOXOXIRYSVTUURUUSXNXQFXMGYRHUUTWHVEWIWJWKXIXOW
      LVJUULDEXNFXMIUUTUURYTYKXTYFAYKXJYLMTTYTXTYFWOWMVKUULUUQUUIUUOUUBVSZVSUVA
      UUHUVBUAXODUUCXORZUUFUUOUUGUUBUVCUUDUUMUUEUUNUUCXOXIWPUUCXOEWNWQUUCXOEWRW
      SXESXFWTXAVQXBVLXCVQXLXKXHXSVTAXKXJLQNBEXNXQFUCGYRUUTHJXDSWJXG $.
  $}

  ${
    $d r s .(+) $.  $d r s S $.  $d r s T $.  $d r s U $.  $d r s W $.
    $d r s ph $.
    lcvexch.s $e |- S = ( LSubSp ` W ) $.
    lcvexch.p $e |- .(+) = ( LSSum ` W ) $.
    lcvexch.c $e |- C = ( <oL ` W ) $.
    lcvexch.w $e |- ( ph -> W e. LMod ) $.
    lcvexch.t $e |- ( ph -> T e. S ) $.
    lcvexch.u $e |- ( ph -> U e. S ) $.
    $( Lemma for ~ lcvexch .  (Contributed by NM, 10-Jan-2015.) $)
    lcvexchlem1 $p |- ( ph -> ( T C. ( T .(+) U ) <-> ( T i^i U ) C. U ) ) $=
      ( wss wne wa wpss wcel sseldd wceq co cin csubg cfv lsssssubg syl syl2anc
      clmod lsmub1 inss2 a1i sseqin2 wb lsmss2b eqcom syl6bb syl5rbbr necon3bid
      2thd anbi12d df-pss 3bitr4g ) AEEFCUAZNZEVCOZPEFUBZFNZVFFOZPEVCQVFFQAVDVG
      VEVHAVDVGAEGUCUDZRZFVIRZVDADVIEAGUHRDVINKDGHUEUFZLSZADVIFVLMSZCEFGIUIUGVG
      AEFUJUKUSAEVCVFFVFFTFENZAEVCTZFEULAVOVCETZVPAVJVKVOVQUMVMVNCEFGIUNUGVCEUO
      UPUQURUTEVCVAVFFVAVB $.

    ${
      lcvexch.r $e |- ( ph -> R e. S ) $.
      lcvexch.a $e |- ( ph -> ( T i^i U ) C_ R ) $.
      lcvexch.b $e |- ( ph -> R C_ U ) $.
      $( Lemma for ~ lcvexch .  (Contributed by NM, 10-Jan-2015.) $)
      lcvexchlem2 $p |- ( ph -> ( ( R .(+) T ) i^i U ) = R ) $=
        ( wcel wss sseldd cin co csubg cfv wceq clmod lsssssubg lsmmod syl31anc
        syl lssincl syl3anc lsmss2 eqtr3d ) ADFGUAZCUBZDFCUBGUAZDADHUCUDZRZFURR
        GURRDGSUPUQUEAEURDAHUFRZEURSLEHIUGUJZOTZAEURFVAMTAEURGVANTQCDFGHJUHUIAU
        SUOURRUODSUPDUEVBAEURUOVAAUTFERGERUOERLMNEFGHIUKULTPCDUOHJUMULUN $.
    $}

    ${
      lcvexch.q $e |- ( ph -> R e. S ) $.
      lcvexch.d $e |- ( ph -> T C_ R ) $.
      lcvexch.e $e |- ( ph -> R C_ ( T .(+) U ) ) $.
      $( Lemma for ~ lcvexch .  (Contributed by NM, 10-Jan-2015.) $)
      lcvexchlem3 $p |- ( ph -> ( ( R i^i U ) .(+) T ) = R ) $=
        ( co wcel wss cin csubg cfv clmod lsssssubg syl sseldd lsmmod2 syl31anc
        wceq cabel lmodabl lsmcom syl3anc sseqtrd df-ss sylib eqtr3d ) ADGFCRZU
        AZDGUAFCRZDADHUBUCZSGVBSZFVBSZFDTUTVAUJAEVBDAHUDSZEVBTLEHIUEUFZOUGAEVBG
        VFNUGZAEVBFVFMUGZPCDGFHJUHUIADUSTUTDUJADFGCRZUSQAHUKSZVDVCVIUSUJAVEVJLH
        ULUFVHVGCFGHJUMUNUODUSUPUQUR $.
    $}

    ${
      lcvexch.f $e |- ( ph -> T C ( T .(+) U ) ) $.
      $( Lemma for ~ lcvexch .  (Contributed by NM, 10-Jan-2015.) $)
      lcvexchlem4 $p |- ( ph -> ( T i^i U ) C U ) $=
        ( wss wa wceq wi wcel syl3anc vs vr cin wbr wpss cv wo wral clmod lsmcl
        co lcvpss lcvexchlem1 mpbid w3a csubg cfv 3ad2ant1 lsssssubg syl sseldd
        simp2 lsmub2 syl2anc simp3r lsmless1 cabel lmodabl lsmcom lcvbr3 adantr
        sseqtr4d simpr sseq2 sseq1 anbi12d eqeq1 orbi12d imbi12d adantld sylbid
        wb rspcv 3adant3 mpd mp2and ineq1 simp3l lcvexchlem2 eqeq1d dfss1 sylib
        syl5ib eqeq12d orim12d 3exp ralrimiv lssincl mpbir2and ) AEFUCZFBUDWTFU
        EZWTUAUFZOZXBFOZPZXBWTQZXBFQZUGZRZUADUHAEEFCUKZUEZXAABDEXJGUIHJKLAGUISZ
        EDSZFDSZXJDSKLMCDEFGHIUJTZNULABCDEFGHIJKLMUMUNAXIUADAXBDSZXEXHAXPXEUOZX
        BECUKZEQZXRXJQZUGZXHXQEXROZXRXJOZYAXQXBGUPUQZSEYDSZYBXQDYDXBXQXLDYDOZAX
        PXLXEKURZDGHUSZUTZAXPXEVBZVAXQDYDEYIAXPXMXELURZVAZCXBEGIVCVDXQXRFECUKZX
        JXQFYDSZYEXDXRYMOXQDYDFYIAXPXNXEMURZVAZYLAXPXCXDVEZCXBFEGIVFTAXPXJYMQZX
        EAGVGSZYEYNYRAXLYSKGVHUTADYDEAXLYFKYHUTZLVAADYDFYTMVACEFGIVITURVLXQEXJB
        UDZYBYCPZYARZAXPUUAXENURAXPUUAUUCRXEAXPPZUUAXKEUBUFZOZUUEXJOZPZUUEEQZUU
        EXJQZUGZRZUBDUHZPZUUCAUUAUUNWBXPABDEXJGUIUBHJKLXOVJVKUUDUUMUUCXKUUDXRDS
        ZUUMUUCRUUDXLXPXMUUOAXLXPKVKAXPVMAXMXPLVKCDXBEGHIUJTUULUUCUBXRDUUEXRQZU
        UHUUBUUKYAUUPUUFYBUUGYCUUEXREVNUUEXRXJVOVPUUPUUIXSUUJXTUUEXREVQUUEXRXJV
        QVRVSWCUTVTWAWDWEWFXQXSXFXTXGXSXRFUCZWTQXQXFXREFWGXQUUQXBWTXQBCXBDEFGHI
        JYGYKYOYJAXPXCXDWHYQWIZWJWMXTUUQXJFUCZQXQXGXRXJFWGXQUUQXBUUSFUURXQFXJOZ
        UUSFQXQYEYNUUTYLYPCEFGIVCVDFXJWKWLWNWMWOWEWPWQABDWTFGUIUAHJKAXLXMXNWTDS
        KLMDEFGHWRTMVJWS $.
    $}

    ${
      lcvexch.g $e |- ( ph -> ( T i^i U ) C U ) $.
      $( Lemma for ~ lcvexch .  (Contributed by NM, 10-Jan-2015.) $)
      lcvexchlem5 $p |- ( ph -> T C ( T .(+) U ) ) $=
        ( wss wa wceq wi wcel 3ad2ant1 vs vr co wbr wpss cv wo wral cin lssincl
        clmod syl3anc lcvpss lcvexchlem1 mpbird w3a simp3l ssrin inss2 jctir wb
        syl lcvbr3 adantr simpr sseq2 sseq1 anbi12d eqeq1 orbi12d imbi12d rspcv
        adantld sylbid 3adant3 mpd oveq1 simp2 simp3r lcvexchlem3 cfv lsssssubg
        csubg sseldd inss1 a1i lsmss1 eqeq12d syl5ib cabel lmodabl orim12d 3exp
        lsmcom ralrimiv lsmcl mpbir2and ) AEEFCUCZBUDEWRUEZEUAUFZOZWTWROZPZWTEQ
        ZWTWRQZUGZRZUADUHAWSEFUIZFUEZABDXHFGUKHJKAGUKSZEDSZFDSZXHDSKLMDEFGHUJUL
        ZMNUMABCDEFGHIJKLMUNUOAXGUADAWTDSZXCXFAXNXCUPZWTFUIZXHQZXPFQZUGZXFXOXHX
        POZXPFOZPZXSXOXTYAXOXAXTAXNXAXBUQZEWTFURVBWTFUSUTXOXHFBUDZYBXSRZAXNYDXC
        NTAXNYDYERXCAXNPZYDXIXHUBUFZOZYGFOZPZYGXHQZYGFQZUGZRZUBDUHZPZYEAYDYPVAX
        NABDXHFGUKUBHJKXMMVCVDYFYOYEXIYFXPDSZYOYERYFXJXNXLYQAXJXNKVDAXNVEAXLXNM
        VDDWTFGHUJULYNYEUBXPDYGXPQZYJYBYMXSYRYHXTYIYAYGXPXHVFYGXPFVGVHYRYKXQYLX
        RYGXPXHVIYGXPFVIVJVKVLVBVMVNVOVPVPXOXQXDXRXEXQXPECUCZXHECUCZQXOXDXPXHEC
        VQXOYSWTYTEXOBCWTDEFGHIJAXNXJXCKTAXNXKXCLTAXNXLXCMTAXNXCVRYCAXNXAXBVSVT
        ZAXNYTEQZXCAXHGWCWAZSEUUCSZXHEOZUUBADUUCXHAXJDUUCOKDGHWBVBZXMWDADUUCEUU
        FLWDZUUEAEFWEWFCXHEGIWGULTWHWIXRYSFECUCZQXOXEXPFECVQXOYSWTUUHWRUUAAXNUU
        HWRQZXCAGWJSZFUUCSUUDUUIAXJUUJKGWKVBADUUCFUUFMWDUUGCFEGIWNULTWHWIWLVPWM
        WOABDEWRGUKUAHJKLAXJXKXLWRDSKLMCDEFGHIWPULVCWQ $.
    $}

    $( Subspaces satisfy the exchange axiom.  Lemma 7.5 of [MaedaMaeda] p. 31.
       ( ~ cvexchi analog.)  TODO: combine some lemmas.  (Contributed by NM,
       10-Jan-2015.) $)
    lcvexch $p |- ( ph -> ( ( T i^i U ) C U <-> T C ( T .(+) U ) ) ) $=
      ( cin wbr co wa wcel adantr simpr clmod lcvexchlem5 lcvexchlem4 impbida )
      AEFNFBOZEEFCPBOZAUEQBCDEFGHIJAGUARZUEKSAEDRZUELSAFDRZUEMSAUETUBAUFQBCDEFG
      HIJAUGUFKSAUHUFLSAUIUFMSAUFTUCUD $.
  $}


  ${
    lcvp.s $e |- S = ( LSubSp ` W ) $.
    lcvp.p $e |- .(+) = ( LSSum ` W ) $.
    lcvp.o $e |- .0. = ( 0g ` W ) $.
    lcvp.a $e |- A = ( LSAtoms ` W ) $.
    lcvp.c $e |- C = ( <oL ` W ) $.
    lcvp.w $e |- ( ph -> W e. LVec ) $.
    lcvp.u $e |- ( ph -> U e. S ) $.
    lcvp.q $e |- ( ph -> Q e. A ) $.
    $( Covering property of Definition 7.4 of [MaedaMaeda] p. 31 and its
       converse.  ( ~ cvp analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lcvp $p |- ( ph -> ( ( U i^i Q ) = { .0. } <-> U C ( U .(+) Q ) ) ) $=
      ( cin wbr wcel csn wceq co clmod clvec lveclmod lsatlssel lssincl syl3anc
      syl lsatcveq0 lcvexch bitr3d ) AGERZECSUNIUAUBGGEDUCCSABCEFUNHILJMNOAHUDT
      ZGFTEFTUNFTAHUETUOOHUFUJZPABFEHJMUPQUGZFGEHJUHUIQUKACDFGEHJKNUPPUQULUM $.
  $}

  ${
    $d x C $.  $d x .(+) $.  $d x Q $.  $d x U $.  $d x W $.  $d x ph $.
    lcv1.s $e |- S = ( LSubSp ` W ) $.
    lcv1.p $e |- .(+) = ( LSSum ` W ) $.
    lcv1.a $e |- A = ( LSAtoms ` W ) $.
    lcv1.c $e |- C = ( <oL ` W ) $.
    lcv1.w $e |- ( ph -> W e. LVec ) $.
    lcv1.u $e |- ( ph -> U e. S ) $.
    lcv1.q $e |- ( ph -> Q e. A ) $.
    $( Covering property of a subspace plus an atom.  ( ~ chcv1 analog.)
       (Contributed by NM, 10-Jan-2015.) $)
    lcv1 $p |- ( ph -> ( -. Q C_ U <-> U C ( U .(+) Q ) ) ) $=
      ( vx wss cfv wcel adantr wn co wbr wa cv csn clspn wceq cbs c0g cdif wrex
      clvec wb eqid islsat syl mpbid w3a 3ad2ant1 eldifi 3ad2ant2 simp1r sseq1d
      simp3 mtbid lsmcv2 oveq2d breqtrrd rexlimdv3a mpd wpss lveclmod lsatlssel
      clmod lsmcl syl3anc simpr lcvpss lsssssubg sseldd lssnle mpbird impbida
      csubg ) AEGQZUAZGGEDUBZCUCZAWGUDZEPUEZUFHUGRZRZUHZPHUIRZHUJRZUFZUKZULZWIA
      WSWGAEBSZWSOAHUMSZWTWSUNMPBEWLWOHUMWPWOUOZWLUOZWPUOKUPUQURTWJWNWIPWRWJWKW
      RSZWNUSZGGWMDUBWHCXECDFGWLWOHWKXBIXCJLWJXDXAWNAXAWGMTUTWJXDGFSZWNAXFWGNTU
      TXDWJWKWOSWNWKWOWQVAVBXEWFWMGQAWGXDWNVCXEEWMGWJXDWNVEZVDVFVGXEEWMGDXGVHVI
      VJVKAWIUDZWGGWHVLZXHCFGWHHUMILAXAWIMTAXFWINTAWHFSZWIAHVOSZXFEFSXJAXAXKMHV
      MUQZNABFEHIKXLOVNZDFGEHIJVPVQTAWIVRVSAWGXIUNWIADGEHJAFHWERZGAXKFXNQXLFHIV
      TUQZNWAAFXNEXOXMWAWBTWCWD $.
  $}

  ${
    lcv2.s $e |- S = ( LSubSp ` W ) $.
    lcv2.p $e |- .(+) = ( LSSum ` W ) $.
    lcv2.a $e |- A = ( LSAtoms ` W ) $.
    lcv2.c $e |- C = ( <oL ` W ) $.
    lcv2.w $e |- ( ph -> W e. LVec ) $.
    lcv2.u $e |- ( ph -> U e. S ) $.
    lcv2.q $e |- ( ph -> Q e. A ) $.
    $( Covering property of a subspace plus an atom.  ( ~ chcv2 analog.)
       (Contributed by NM, 10-Jan-2015.) $)
    lcv2 $p |- ( ph -> ( U C. ( U .(+) Q ) <-> U C ( U .(+) Q ) ) ) $=
      ( wss wn wcel syl sseldd co wpss wbr csubg clmod clvec lveclmod lsssssubg
      cfv lsatlssel lssnle lcv1 bitr3d ) AEGPQGGEDUAZUBGUNCUCADGEHJAFHUDUIZGAHU
      ERZFUOPAHUFRUPMHUGSZFHIUHSZNTAFUOEURABFEHIKUQOUJTUKABCDEFGHIJKLMNOULUM $.
  $}

  ${
    lsatexch.s $e |- S = ( LSubSp ` W ) $.
    lsatexch.p $e |- .(+) = ( LSSum ` W ) $.
    lsatexch.o $e |- .0. = ( 0g ` W ) $.
    lsatexch.a $e |- A = ( LSAtoms ` W ) $.
    lsatexch.w $e |- ( ph -> W e. LVec ) $.
    lsatexch.u $e |- ( ph -> U e. S ) $.
    lsatexch.q $e |- ( ph -> Q e. A ) $.
    lsatexch.r $e |- ( ph -> R e. A ) $.
    lsatexch.l $e |- ( ph -> Q C_ ( U .(+) R ) ) $.
    lsatexch.z $e |- ( ph -> ( U i^i Q ) = { .0. } ) $.
    $( The atom exchange property.  Proposition 1(i) of [Kalmbach] p. 140.  A
       version of this theorem was originally proved by Hermann Grassmann in
       1862.  ( ~ atexch analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lsatexch $p |- ( ph -> R C_ ( U .(+) Q ) ) $=
      ( wcel co csubg cfv wss clmod clvec syl lsssssubg sseldd lsatlssel lsmub2
      lveclmod syl2anc clcv eqid lsmcl syl3anc wpss wbr cin csn wceq lcvp mpbid
      lcvpss lsmub1 wa wb lsmlub mpbi2and psssstrd lcv2 lcvnbtwn2 sseqtr4d ) AE
      GECUAZGDCUAZAGHUBUCZTZEVQTZEVOUDAFVQGAHUETZFVQUDAHUFTVTNHULUGZFHJUHUGZOUI
      ZAFVQEWBABFEHJMWAQUJZUIZCGEHKUKUMAHUNUCZGFVOVPHUFJWFUOZNOAVTGFTZEFTVOFTWA
      OWDCFGEHJKUPUQZAVTWHDFTVPFTWAOABFDHJMWAPUJZCFGDHJKUPUQZAGVOURGVOWFUSAGVPV
      OAWFFGVPHUFJWGNOWKAGDUTIVAVBGVPWFUSSABWFCDFGHIJKLMWGNOPVCVDVEZAGVOUDZDVOU
      DZVPVOUDZAVRVSWMWCWECGEHKVFUMRAVRDVQTVOVQTWMWNVGWOVHWCAFVQDWBWJUIAFVQVOWB
      WIUICGDVOHKVIUQVJZVKABWFCEFGHJKMWGNOQVLVDWLWPVMVN $.
  $}

  ${
    lsatnle.o $e |- .0. = ( 0g ` W ) $.
    lsatnle.s $e |- S = ( LSubSp ` W ) $.
    lsatnle.a $e |- A = ( LSAtoms ` W ) $.
    lsatnle.w $e |- ( ph -> W e. LVec ) $.
    lsatnle.u $e |- ( ph -> U e. S ) $.
    lsatnle.q $e |- ( ph -> Q e. A ) $.
    $( The meet of a subspace and an incomparable atom is the zero subspace.
       ( ~ atnssm0 analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lsatnle $p |- ( ph -> ( -. Q C_ U <-> ( U i^i Q ) = { .0. } ) ) $=
      ( wss wn clsm cfv co clcv eqid wbr cin csn wceq lcv1 lcvp bitr4d ) ACENOE
      ECFPQZRFSQZUAECUBGUCUDABUIUHCDEFIUHTZJUITZKLMUEABUIUHCDEFGIUJHJUKKLMUFUG
      $.
  $}

  ${
    lsatnem0.o $e |- .0. = ( 0g ` W ) $.
    lsatnem0.a $e |- A = ( LSAtoms ` W ) $.
    lsatnem0.w $e |- ( ph -> W e. LVec ) $.
    lsatnem0.q $e |- ( ph -> Q e. A ) $.
    lsatnem0.r $e |- ( ph -> R e. A ) $.
    $( The meet of distinct atoms is the zero subspace.  ( ~ atnemeq0 analog.)
       (Contributed by NM, 10-Jan-2015.) $)
    lsatnem0 $p |- ( ph -> ( Q =/= R <-> ( Q i^i R ) = { .0. } ) ) $=
      ( wss wn wne cin csn wceq lsatcmp eqcom wcel syl6bb necon3bbid clss clvec
      cfv eqid clmod lveclmod syl lsatlssel lsatnle bitr3d ) ADCLZMCDNCDOFPQAUM
      CDAUMDCQCDQABDCEHIKJRDCSUAUBABDEUCUEZCEFGUNUFZHIABUNCEUOHAEUDTEUGTIEUHUIJ
      UJKUKUL $.
  $}

  ${
    lsatexch1.p $e |- .(+) = ( LSSum ` W ) $.
    lsatexch1.a $e |- A = ( LSAtoms ` W ) $.
    lsatexch1.w $e |- ( ph -> W e. LVec ) $.
    lsatexch1.u $e |- ( ph -> Q e. A ) $.
    lsatexch1.q $e |- ( ph -> R e. A ) $.
    lsatexch1.r $e |- ( ph -> S e. A ) $.
    lsatexch1.l $e |- ( ph -> Q C_ ( S .(+) R ) ) $.
    lsatexch1.z $e |- ( ph -> Q =/= S ) $.
    $( The atom exch1ange property.  ( ~ hlatexch1 analog.)  (Contributed by
       NM, 14-Jan-2015.) $)
    lsatexch1 $p |- ( ph -> R C_ ( S .(+) Q ) ) $=
      ( clss cfv c0g eqid wcel clvec lveclmod syl lsatlssel wne cin wceq necomd
      clmod csn lsatnem0 mpbid lsatexch ) ABCDEGPQZFGGRQZUNSZHUOSZIJABUNFGUPIAG
      UATGUITJGUBUCMUDKLNAFDUEFDUFUOUJUGADFOUHABFDGUOUQIJMKUKULUM $.
  $}

  ${
    lsatcv0eq.o $e |- .0. = ( 0g ` W ) $.
    lsatcv0eq.p $e |- .(+) = ( LSSum ` W ) $.
    lsatcv0eq.a $e |- A = ( LSAtoms ` W ) $.
    lsatcv0eq.c $e |- C = ( <oL ` W ) $.
    lsatcv0eq.w $e |- ( ph -> W e. LVec ) $.
    lsatcv0eq.q $e |- ( ph -> Q e. A ) $.
    lsatcv0eq.r $e |- ( ph -> R e. A ) $.
    $( If the sum of two atoms cover the zero subspace, they are equal.
       ( ~ atcv0eq analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lsatcv0eq $p |- ( ph -> ( { .0. } C ( Q .(+) R ) <-> Q = R ) ) $=
      ( wbr wceq wcel syl adantr csn co wne wa cin lsatnem0 clss cfv eqid clvec
      wn clmod lveclmod lsatlssel lsatcv0 biantrurd 3bitrd lsssn0 lsmcl syl3anc
      simprl simprr lcvntr ex sylbid necon4ad csubg wss lsssssubg sseldd lsmidm
      lcvp breqtrrd oveq2 breq2d syl5ibcom impbid ) AHUAZEFDUBZCPZEFQZAVTEFAEFU
      CZVRECPZEVSCPZUDZVTUKZAWBEFUEVRQWDWEABEFGHIKMNOUFABCDFGUGUHZEGHWGUIZJIKLM
      ABWGEGWHKAGUJRZGULRZMGUMSZNUNZOVLAWCWDABCEGHIKLMNUOZUPUQAWEWFAWEUDCVRWGEV
      SGUJWHLAWIWEMTAVRWGRZWEAWJWNWKWGGHIWHURSTAEWGRZWEWLTAVSWGRZWEAWJWOFWGRWPW
      KWLABWGFGWHKWKOUNDWGEFGWHJUSUTTAWCWDVAAWCWDVBVCVDVEVFAVREEDUBZCPWAVTAVREW
      QCWMAEGVGUHZRWQEQAWGWREAWJWGWRVHWKWGGWHVISWLVJDEGJVKSVMWAWQVSVRCEFEDVNVOV
      PVQ $.
  $}

  ${
    lsatcv1.o $e |- .0. = ( 0g ` W ) $.
    lsatcv1.p $e |- .(+) = ( LSSum ` W ) $.
    lsatcv1.s $e |- S = ( LSubSp ` W ) $.
    lsatcv1.a $e |- A = ( LSAtoms ` W ) $.
    lsatcv1.c $e |- C = ( <oL ` W ) $.
    lsatcv1.w $e |- ( ph -> W e. LVec ) $.
    lsatcv1.u $e |- ( ph -> U e. S ) $.
    lsatcv1.q $e |- ( ph -> Q e. A ) $.
    lsatcv1.r $e |- ( ph -> R e. A ) $.
    lsatcv1.l $e |- ( ph -> U C ( Q .(+) R ) ) $.
    $( Two atoms covering the zero subspace are equal.  ( ~ atcv1 analog.)
       (Contributed by NM, 10-Jan-2015.) $)
    lsatcv1 $p |- ( ph -> ( U = { .0. } <-> Q = R ) ) $=
      ( csn wceq co breq1 syl5ibcom lsatcv0eq sylibd wa adantr clvec wcel oveq1
      wbr csubg cfv clmod lveclmod syl lsatlssel lsssubg syl2anc lsmidm eqeltrd
      sylan9eqr lsatcveq0 mpbid ex impbid ) AHJUAZUBZEFUBZAVJVIEFDUCZCUMZVKAHVL
      CUMZVJVMTHVIVLCUDUEABCDEFIJKLNOPRSUFUGAVKVJAVKUHZVNVJAVNVKTUIVOBCVLGHIJKM
      NOAIUJUKZVKPUIAHGUKVKQUIVOVLFBVKAVLFFDUCZFEFFDULAFIUNUOUKZVQFUBAIUPUKZFGU
      KVRAVPVSPIUQURZABGFIMNVTSUSGFIMUTVADFILVBURVDAFBUKVKSUIVCVEVFVGVH $.
  $}

  ${
    lsatcvat.o $e |- .0. = ( 0g ` W ) $.
    lsatcvat.s $e |- S = ( LSubSp ` W ) $.
    lsatcvat.p $e |- .(+) = ( LSSum ` W ) $.
    lsatcvat.a $e |- A = ( LSAtoms ` W ) $.
    lsatcvat.w $e |- ( ph -> W e. LVec ) $.
    lsatcvat.u $e |- ( ph -> U e. S ) $.
    lsatcvat.q $e |- ( ph -> Q e. A ) $.
    lsatcvat.r $e |- ( ph -> R e. A ) $.
    lsatcvat.n $e |- ( ph -> U =/= { .0. } ) $.
    lsatcvat.l $e |- ( ph -> U C. ( Q .(+) R ) ) $.
    ${
      $d x A $.  $d x U $.  $d x W $.  $d x ph $.
      lsatcvat.m $e |- ( ph -> -. Q C_ U ) $.
      $( Lemma for ~ lsatcvat .  (Contributed by NM, 10-Jan-2015.) $)
      lsatcvatlem $p |- ( ph -> U e. A ) $=
        ( vx wss wrex wcel clvec clmod lveclmod syl lssatomic w3a clcv cfv eqid
        cv co 3ad2ant1 simp2 lsatlssel lsmcl syl3anc cin csn wceq wbr wne wn wi
        sseq1 biimpcd necon3bd 3ad2ant3 lsatnem0 mpbid lcvp cabel csubg lmodabl
        mpd lsssssubg sseldd lsmcom breqtrd simp3 wpss lsmub1 syl2anc lsatexch1
        pssssd sstrd wa lsmlub mpbi2and psssstrd lcvnbtwn3 eqeltrd rexlimdv3a
        wb ) AUAUNZGUBZUABUCGBUDZABFGHIUAKJMAHUEUDZHUFUDZNHUGUHZORUIAWSWTUABAWR
        BUDZWSUJZGWRBXEHUKULZWRFDWRCUOZGHUEKXFUMZAXDXAWSNUPZXEBFWRHKMAXDXBWSXCU
        PZAXDWSUQZURZXEXBDFUDZWRFUDXGFUDXJAXDXMWSABFDHKMXCPURUPZXLCFDWRHKLUSUTZ
        AXDGFUDWSOUPXEWRWRDCUOZXGXFXEWRDVAIVBVCZWRXPXFVDXEWRDVEZXQXEDGUBZVFZXRA
        XDXTWSTUPWSAXTXRVGXDWSXSWRDWRDVCWSXSWRDGVHVIVJVKVRZXEBWRDHIJMXIXKAXDDBU
        DWSPUPZVLVMXEBXFCDFWRHIKLJMXHXIXLYBVNVMXEHVOUDZWRHVPULZUDZDYDUDZXPXGVCX
        EXBYCXJHVQUHXEFYDWRXEXBFYDUBXJFHKVSUHZXLVTZXEFYDDYGXNVTZCWRDHLWAUTWBAXD
        WSWCZXEGDECUOZXGAXDGYKWDWSSUPXEDXGUBZEXGUBZYKXGUBZXEYFYEYLYIYHCDWRHLWEW
        FXEBCWREDHLMXIXKAXDEBUDWSQUPYBXEWRGYKYJAXDGYKUBWSAGYKSWHUPWIYAWGXEYFEYD
        UDXGYDUDYLYMWJYNWQYIXEFYDEYGAXDEFUDWSABFEHKMXCQURUPVTXEFYDXGYGXOVTCDEXG
        HLWKUTWLWMWNXKWOWPVR $.
    $}

    $( A nonzero subspace less than the sum of two atoms is an atom.
       ( ~ atcvati analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lsatcvat $p |- ( ph -> U e. A ) $=
      ( adantr wss wn wcel wa clvec csn wne co wpss simpr lsatcvatlem cabel cfv
      csubg wceq lveclmod syl lmodabl lsssssubg lsatlssel sseldd lsmcom syl3anc
      clmod psseq2d mpbid wo wb lsmlub ssnpss syl6bi con2d syl6ib mpd mpjaodan
      ianor ) ADGUAZUBZGBUCEGUAZUBZAVRUDBCDEFGHIJKLMAHUEUCZVRNTAGFUCZVROTADBUCZ
      VRPTAEBUCZVRQTAGIUFUGZVRRTAGDECUHZUIZVRSTAVRUJUKAVTUDBCEDFGHIJKLMAWAVTNTA
      WBVTOTAWDVTQTAWCVTPTAWEVTRTAGEDCUHZUIZVTAWGWISAWFWHGAHULUCZDHUNUMZUCZEWKU
      CZWFWHUOAHVDUCZWJAWAWNNHUPUQZHURUQAFWKDAWNFWKUAWOFHKUSUQZABFDHKMWOPUTVAZA
      FWKEWPABFEHKMWOQUTVAZCDEHLVBVCVEVFTAVTUJUKAWGVRVTVGZSAWGVQVSUDZUBWSAWTWGA
      WTWFGUAZWGUBAWLWMGWKUCWTXAVHWQWRAFWKGWPOVACDEGHLVIVCWFGVJVKVLVQVSVPVMVNVO
      $.
  $}

  ${
    lsatcvat2.s $e |- S = ( LSubSp ` W ) $.
    lsatcvat2.p $e |- .(+) = ( LSSum ` W ) $.
    lsatcvat2.a $e |- A = ( LSAtoms ` W ) $.
    lsatcvat2.c $e |- C = ( <oL ` W ) $.
    lsatcvat2.w $e |- ( ph -> W e. LVec ) $.
    lsatcvat2.u $e |- ( ph -> U e. S ) $.
    lsatcvat2.q $e |- ( ph -> Q e. A ) $.
    lsatcvat2.r $e |- ( ph -> R e. A ) $.
    lsatcvat2.n $e |- ( ph -> Q =/= R ) $.
    lsatcvat2.l $e |- ( ph -> U C ( Q .(+) R ) ) $.
    $( A subspace covered by the sum of two distinct atoms is an atom.
       ( ~ atcvat2i analog.)  (Contributed by NM, 10-Jan-2015.) $)
    lsatcvat2 $p |- ( ph -> U e. A ) $=
      ( wcel c0g cfv eqid csn wne lsatcv1 necon3bid mpbird clvec clmod lveclmod
      co syl lsatlssel lsmcl syl3anc lcvpss lsatcvat ) ABDEFGHIIUAUBZUSUCZJKLNO
      PQAHUSUDZUEEFUERAHVAEFABCDEFGHIUSUTKJLMNOPQSUFUGUHACGHEFDULZIUIJMNOAIUJTZ
      EGTFGTVBGTAIUITVCNIUKUMZABGEIJLVDPUNABGFIJLVDQUNDGEFIJKUOUPSUQUR $.
  $}

  ${
    lsatcvat3.s $e |- S = ( LSubSp ` W ) $.
    lsatcvat3.p $e |- .(+) = ( LSSum ` W ) $.
    lsatcvat3.a $e |- A = ( LSAtoms ` W ) $.
    lsatcvat3.w $e |- ( ph -> W e. LVec ) $.
    lsatcvat3.u $e |- ( ph -> U e. S ) $.
    lsatcvat3.q $e |- ( ph -> Q e. A ) $.
    lsatcvat3.r $e |- ( ph -> R e. A ) $.
    lsatcvat3.n $e |- ( ph -> Q =/= R ) $.
    lsatcvat3.m $e |- ( ph -> -. R C_ U ) $.
    lsatcvat3.l $e |- ( ph -> Q C_ ( U .(+) R ) ) $.
    $( A condition implying that a certain subspace is an atom.  Part of Lemma
       3.2.20 of [PtakPulmannova] p. 68.  ( ~ atcvat3i analog.)  (Contributed
       by NM, 11-Jan-2015.) $)
    lsatcvat3 $p |- ( ph -> ( U i^i ( Q .(+) R ) ) e. A ) $=
      ( co wcel clcv cfv cin clmod clvec lveclmod syl lsatlssel syl3anc lssincl
      eqid lsmcl wss wn wbr lcv1 mpbid cabel csubg wceq lsssssubg sseldd lsmcom
      lmodabl oveq2d lsmass eqtr4d lsmless2 eqsstrd lsmidm sseqtrd lsmub2 eqssd
      syl2anc breqtrrd lcvexchlem4 lsatcvat2 ) ABHUAUBZCDEFGDECSZUCZHIJKVRUKZLA
      HUDTZGFTZVSFTZVTFTAHUETWBLHUFUGZMAWBDFTEFTZWDWEABFDHIKWENUHZABFEHIKWEOUHZ
      CFDEHIJULUIZFGVSHIUJUINOPAVRCFGVSHIJWAWEMWIAGGECSZGVSCSZVRAEGUMUNGWJVRUOQ
      ABVRCEFGHIJKWALMOUPUQAWKWJAWKWJWJCSZWJAWKWJDCSZWLAWKGEDCSZCSZWMAVSWNGCAHU
      RTZDHUSUBZTZEWQTZVSWNUTAWBWPWEHVDUGAFWQDAWBFWQUMWEFHIVAUGZWGVBZAFWQEWTWHV
      BZCDEHJVCUIVEAGWQTZWSWRWMWOUTAFWQGWTMVBZXBXACGEDHJVFUIVGAWJWQTZXEDWJUMWMW
      LUMAFWQWJWTAWBWCWFWJFTWEMWHCFGEHIJULUIVBZXFRCWJDWJHJVHUIVIAXEWLWJUTXFCWJH
      JVJUGVKAXCVSWQTEVSUMZWJWKUMXDAFWQVSWTWIVBAWRWSXGXAXBCDEHJVLVNCGEVSHJVHUIV
      MVOVPVQ $.
  $}

  ${
    $d q C $.  $d q S $.  $d q U $.  $d q V $.  $d q W $.  $d q ph $.
    islshpcv.v $e |- V = ( Base ` W ) $.
    islshpcv.s $e |- S = ( LSubSp ` W ) $.
    islshpcv.h $e |- H = ( LSHyp ` W ) $.
    islshpcv.c $e |- C = ( <oL ` W ) $.
    islshpcv.w $e |- ( ph -> W e. LVec ) $.
    $( Hyperplane properties expressed with covers relation.  (Contributed by
       NM, 11-Jan-2015.) $)
    islshpcv $p |- ( ph -> ( U e. H <-> ( U e. S /\ U C V ) ) ) $=
      ( vq wcel cfv w3a wbr wa eqid syl wne cv clsm co wceq clsa clvec lveclmod
      wrex clmod islshpat wi simp12 wpss lssss simp13 df-pss sylanbrc wb psseq2
      wss 3ad2ant3 mpbird 3ad2ant1 simp2 lcv2 mpbid breqtrd jca rexlimdv3a 3exp
      simp3 3impd simprl adantr lss1 simprr lcvpss pssned lcvat ex impbid bitrd
      3jca ) ADENDCNZDFUAZDMUBZGUCOZUDZFUEZMGUFOZUIZPZWEDFBQZRZAWKWHCDEFGMHIWHS
      ZJWKSZAGUGNZGUJNZLGUHTZUKAWMWOAWEWFWLWOAWEWFWLWOULAWEWFPZWJWOMWKXAWGWKNZW
      JPZWEWNAWEWFXBWJUMZXCDWIFBXCDWIUNZDWIBQXCXEDFUNZXCDFVAZWFXFXCWEXGXDCDFGHI
      UOTAWEWFXBWJUPDFUQURWJXAXEXFUSXBWIFDUTVBVCXCWKBWHWGCDGIWPWQKXAXBWRWJAWEWR
      WFLVDVDXDXAXBWJVEVFVGXAXBWJVLVHVIVJVKVMAWOWMAWORZWEWFWLAWEWNVNZXHDFXHBCDF
      GUGIKAWRWOLVOXIXHWSFCNAWSWOWTVOZCFGHIVPTZAWEWNVQZVRVSXHWKBWHCDFGMIWPWQKXJ
      XIXKXLVTWDWAWBWC $.
  $}

  ${
    $d v .(+) $.  $d v Q $.  $d v U $.  $d v V $.  $d v W $.  $d v ph $.
    l1cvpat.v $e |- V = ( Base ` W ) $.
    l1cvpat.s $e |- S = ( LSubSp ` W ) $.
    l1cvpat.p $e |- .(+) = ( LSSum ` W ) $.
    l1cvpat.a $e |- A = ( LSAtoms ` W ) $.
    l1cvpat.c $e |- C = ( <oL ` W ) $.
    l1cvpat.w $e |- ( ph -> W e. LVec ) $.
    l1cvpat.u $e |- ( ph -> U e. S ) $.
    l1cvpat.q $e |- ( ph -> Q e. A ) $.
    l1cvpat.l $e |- ( ph -> U C V ) $.
    l1cvpat.m $e |- ( ph -> -. Q C_ U ) $.
    $( A subspace covered by the set of all vectors, when summed with an atom
       not under it, equals the set of all vectors.  ( ~ 1cvrjat analog.)
       (Contributed by NM, 11-Jan-2015.) $)
    l1cvpat $p |- ( ph -> ( U .(+) Q ) = V ) $=
      ( wcel vv cv csn clspn cfv wceq c0g cdif wrex wss wn co clvec eqid islsat
      wb syl mpbid wi eldifi clmod lveclmod 3ad2ant1 simp2 lspsnel5 notbid clsh
      w3a islshpcv mpbir2and lshpnelb biimpd sylbird sseq1 oveq2 eqeq1d imbi12d
      wbr 3ad2ant3 mpbird 3exp syl5 rexlimdv mp2d ) AEUAUBZUCIUDUEZUEZUFZUAHIUG
      UEZUCZUHZUIZEGUJZUKZGEDULZHUFZAEBTZWLQAIUMTZWQWLUPOUABEWFHIUMWIJWFUNZWIUN
      MUOUQURSAWHWNWPUSZUAWKWEWKTWEHTZAWHWTUSWEHWJUTAXAWHWTAXAWHVHZWTWGGUJZUKZG
      WGDULZHUFZUSZXBXDWEGTZUKZXFXBXHXCXBFGWFHIWEJKWSAXAIVATZWHAWRXJOIVBUQVCAXA
      GFTZWHPVCAXAWHVDZVEVFXBXIXFXBDGIVGUEZWFHIWEJWSLXMUNZAXAWRWHOVCAXAGXMTZWHA
      XOXKGHCVRPRACFGXMHIJKXNNOVIVJVCXLVKVLVMWHAWTXGUPXAWHWNXDWPXFWHWMXCEWGGVNV
      FWHWOXEHEWGGDVOVPVQVSVTWAWBWCWD $.
  $}

  ${
    l1cvat.v $e |- V = ( Base ` W ) $.
    l1cvat.s $e |- S = ( LSubSp ` W ) $.
    l1cvat.p $e |- .(+) = ( LSSum ` W ) $.
    l1cvat.a $e |- A = ( LSAtoms ` W ) $.
    l1cvat.c $e |- C = ( <oL ` W ) $.
    l1cvat.w $e |- ( ph -> W e. LVec ) $.
    l1cvat.u $e |- ( ph -> U e. S ) $.
    l1cvat.q $e |- ( ph -> Q e. A ) $.
    l1cvat.r $e |- ( ph -> R e. A ) $.
    l1cvat.n $e |- ( ph -> Q =/= R ) $.
    l1cvat.l $e |- ( ph -> U C V ) $.
    l1cvat.m $e |- ( ph -> -. Q C_ U ) $.
    $( Create an atom under an element covered by the lattice unit.  Part of
       proof of Lemma B in [Crawley] p. 112.  ( ~ 1cvrat analog.)  (Contributed
       by NM, 11-Jan-2015.) $)
    l1cvat $p |- ( ph -> ( ( Q .(+) R ) i^i U ) e. A ) $=
      ( co cin cabel wcel csubg cfv wceq clmod clvec lveclmod lmodabl lsssssubg
      syl lsatlssel sseldd lsmcom syl3anc ineq1d syl6eq necomd lsatssv sseqtr4d
      wss incom l1cvpat lsatcvat3 eqeltrd ) AEFDUCZHUDZHFEDUCZUDZBAVKVLHUDVMAVJ
      VLHAJUEUFZEJUGUHZUFFVOUFVJVLUIAJUJUFZVNAJUKUFVPPJULUOZJUMUOAGVOEAVPGVOVEV
      QGJLUNUOZABGEJLNVQRUPUQAGVOFVRABGFJLNVQSUPUQDEFJMURUSUTVLHVFVAABDFEGHJLMN
      PQSRAEFTVBUBAFIHEDUCABFIJKNVQSVCABCDEGHIJKLMNOPQRUAUBVGVDVHVI $.
  $}

  ${
    lshpat.s $e |- S = ( LSubSp ` W ) $.
    lshpat.p $e |- .(+) = ( LSSum ` W ) $.
    ishpat.h $e |- H = ( LSHyp ` W ) $.
    lshpat.a $e |- A = ( LSAtoms ` W ) $.
    lshpat.w $e |- ( ph -> W e. LVec ) $.
    lshpat.l $e |- ( ph -> U e. H ) $.
    lshpat.q $e |- ( ph -> Q e. A ) $.
    lshpat.r $e |- ( ph -> R e. A ) $.
    lshpat.n $e |- ( ph -> Q =/= R ) $.
    lshpat.m $e |- ( ph -> -. Q C_ U ) $.
    $( Create an atom under a hyperplane.  Part of proof of Lemma B in
       [Crawley] p. 112.  ( ~ lhpat analog.)  TODO:  This changes ` U C V ` in
       ~ l1cvpat and ~ l1cvat to ` U e. H ` , which in turn change ` U e. H `
       in ~ islshpcv to ` U C V ` , with a couple of conversions of span to
       atom.  Seems convoluted.  Would a direct proof be better?  (Contributed
       by NM, 11-Jan-2015.) $)
    lshpat $p |- ( ph -> ( ( Q .(+) R ) i^i U ) e. A ) $=
      ( cfv clcv cbs eqid wcel wbr wa islshpcv mpbid simpld simprd l1cvat ) ABI
      UATZCDEFGIUBTZIUMUCZJKMULUCZNAGFUDZGUMULUEZAGHUDUPUQUFOAULFGHUMIUNJLUONUG
      UHZUIPQRAUPUQURUJSUK $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Functionals and kernels of a left vector space (or module)
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LFnl $.

  $( Extend class notation with all linear functionals of a left module or left
     vector space. $)
  clfn $a class LFnl $.

  ${
    $d w x y r f $.
    $( Define the set of all linear functionals (maps from vectors to the ring)
       of a left module or left vector space.  (Contributed by NM,
       15-Apr-2014.) $)
    df-lfl $a |- LFnl = ( w e. _V |->
     { f e. ( ( Base ` ( Scalar ` w ) ) ^m ( Base ` w ) )
       | A. r e. ( Base ` ( Scalar ` w ) )
         A. x e. ( Base ` w ) A. y e. ( Base ` w )
          ( f ` ( ( r ( .s ` w ) x ) ( +g ` w ) y ) )
             = ( ( r ( .r ` ( Scalar ` w ) ) ( f ` x ) )
                 ( +g ` ( Scalar ` w ) ) ( f ` y ) ) } ) $.
  $}

  ${
    $d w .+^ $.  $d f r w K $.  $d f w x y V $.  $d f r w x y W $.  $d w .x. $.
    $d w .+ $.  $d w .X. $.
    lflset.v $e |- V = ( Base ` W ) $.
    lflset.a $e |- .+ = ( +g ` W ) $.
    lflset.d $e |- D = ( Scalar ` W ) $.
    lflset.s $e |- .x. = ( .s ` W ) $.
    lflset.k $e |- K = ( Base ` D ) $.
    lflset.p $e |- .+^ = ( +g ` D ) $.
    lflset.t $e |- .X. = ( .r ` D ) $.
    lflset.f $e |- F = ( LFnl ` W ) $.
    $( The set of linear functionals in a left module or left vector space.
       (Contributed by NM, 15-Apr-2014.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    lflset $p |- ( W e. X -> F = { f e. ( K ^m V )
       | A. r e. K A. x e. V A. y e. V ( f ` ( ( r .x. x ) .+ y ) )
             = ( ( r .X. ( f ` x ) ) .+^ ( f ` y ) ) } ) $=
      ( vw wcel cvv cv co wceq wral cmap crab elex clfn cvsca cplusg csca cmulr
      cfv fveq2 syl6eqr fveq2d oveq12d oveqd eqidd oveq123d raleqbidv rabeqbidv
      cbs eqeq12d df-lfl ovex rabex fvmpt syl5eq syl ) LMUDLUEUDZINUFZAUFZFUGZB
      UFZDUGZHUFZURZVQVRWBURZGUGZVTWBURZEUGZUHZBKUIZAKUIZNJUIZHJKUJUGZUKZUHLMUL
      VPILUMURWMUBUCLVQVRUCUFZUNURZUGZVTWNUOURZUGZWBURZVQWDWNUPURZUQURZUGZWFWTU
      OURZUGZUHZBWNVHURZUIZAXFUIZNWTVHURZUIZHXIXFUJUGZUKWMUEUMWNLUHZXJWKHXKWLXL
      XIJXFKUJXLXICVHURJXLWTCVHXLWTLUPURCWNLUPUSQUTZVASUTZXLXFLVHURKWNLVHUSOUTZ
      VBXLXHWJNXIJXNXLXGWIAXFKXOXLXEWHBXFKXOXLWSWCXDWGXLWRWAWBXLWPVSVTVTWQDXLWQ
      LUOURDWNLUOUSPUTXLWOFVQVRXLWOLUNURFWNLUNUSRUTVCXLVTVDVEVAXLXBWEWFWFXCEXLX
      CCUOUREXLWTCUOXMVATUTXLXAGVQWDXLXACUQURGXLWTCUQXMVAUAUTVCXLWFVDVEVIVFVFVF
      VGABUCHNVJWKHWLJKUJVKVLVMVNVO $.

    $d f .+ $.  $d f r x y G $.  $d f .+^ $.  $d f .x. $.  $d f .X. $.
    $( The predicate "is a linear functional".  (Contributed by NM,
       15-Apr-2014.) $)
    islfl $p |- ( W e. X -> ( G e. F <-> ( G : V --> K
      /\ A. r e. K A. x e. V A. y e. V
           ( G ` ( ( r .x. x ) .+ y ) )
             = ( ( r .X. ( G ` x ) ) .+^ ( G ` y ) ) ) ) ) $=
      ( vf wcel cv co cfv wceq wral cmap crab wf wa lflset eleq2d fveq1 oveq12d
      oveq2d eqeq12d 2ralbidv ralbidv elrab cbs fvex eqeltri elmap anbi1i bitri
      cvv syl6bb ) LMUDZIHUDINUEZAUEZFUFBUEZDUFZUCUEZUGZVLVMVPUGZGUFZVNVPUGZEUF
      ZUHZBKUIAKUIZNJUIZUCJKUJUFZUKZUDZKJIULZVOIUGZVLVMIUGZGUFZVNIUGZEUFZUHZBKU
      IAKUIZNJUIZUMZVKHWFIABCDEFGUCHJKLMNOPQRSTUAUBUNUOWGIWEUDZWPUMWQWDWPUCIWEV
      PIUHZWCWONJWSWBWNABKKWSVQWIWAWMVOVPIUPWSVSWKVTWLEWSVRWJVLGVMVPIUPURVNVPIU
      PUQUSUTVAVBWRWHWPJKIJCVCUGVISCVCVDVEKLVCUGVIOLVCVDVEVFVGVHVJ $.

    $d r x y .+^ $.  $d r x y R $.  $d r V $.  $d r x y .x. $.  $d r x y .X. $.
    $d r x y .+ $.  $d x y X $.  $d y Y $.
    $( Property of a linear functional.  ( ~ lnfnli analog.)  (Contributed by
       NM, 16-Apr-2014.) $)
    lfli $p |- ( ( W e. Z /\ G e. F /\ ( R e. K /\ X e. V /\ Y e. V ) ) ->
      ( G ` ( ( R .x. X ) .+ Y ) ) = ( ( R .X. ( G ` X ) ) .+^ ( G ` Y ) ) ) $=
      ( vr vx vy wcel w3a cv co cfv wceq wf islfl simplbda 3adant3 oveq1 oveq1d
      wral wi fveq2d eqeq12d oveq2 fveq2 oveq2d rspc3v 3ad2ant3 mpd ) KNUFZHGUF
      ZDIUFLJUFMJUFUGZUGUCUHZUDUHZEUIZUEUHZBUIZHUJZVKVLHUJZFUIZVNHUJZCUIZUKZUEJ
      URUDJURUCIURZDLEUIZMBUIZHUJZDLHUJZFUIZMHUJZCUIZUKZVHVIWBVJVHVIJIHULWBUDUE
      ABCEFGHIJKNUCOPQRSTUAUBUMUNUOVJVHWBWJUSVIWAWJDVLEUIZVNBUIZHUJZDVQFUIZVSCU
      IZUKWCVNBUIZHUJZWGVSCUIZUKUCUDUEDLMIJJVKDUKZVPWMVTWOWSVOWLHWSVMWKVNBVKDVL
      EUPUQUTWSVRWNVSCVKDVQFUPUQVAVLLUKZWMWQWOWRWTWLWPHWTWKWCVNBVLLDEVBUQUTWTWN
      WGVSCWTVQWFDFVLLHVCVDUQVAVNMUKZWQWEWRWIXAWPWDHVNMWCBVBUTXAVSWHWGCVNMHVCVD
      VAVEVFVG $.
  $}

  ${
    $d r x y G $.  $d r x y K $.  $d x y V $.  $d r x y W $.  $d r x y ph $.
    islfld.v $e |- ( ph -> V = ( Base ` W ) ) $.
    islfld.a $e |- ( ph -> .+ = ( +g ` W ) ) $.
    islfld.d $e |- ( ph -> D = ( Scalar ` W ) ) $.
    islfld.s $e |- ( ph -> .x. = ( .s ` W ) ) $.
    islfld.k $e |- ( ph -> K = ( Base ` D ) ) $.
    islfld.p $e |- ( ph -> .+^ = ( +g ` D ) ) $.
    islfld.t $e |- ( ph -> .X. = ( .r ` D ) ) $.
    islfld.f $e |- ( ph -> F = ( LFnl ` W ) ) $.
    islfld.u $e |- ( ph -> G : V --> K ) $.
    islfld.l $e |- ( ( ph /\ ( r e. K /\ x e. V /\ y e. V ) ) ->
      ( G ` ( ( r .x. x ) .+ y ) ) = ( ( r .X. ( G ` x ) ) .+^ ( G ` y ) ) ) $.
    islfld.w $e |- ( ph -> W e. X ) $.
    $( Properties that determine a linear functional.  TODO: use this in place
       of ~ islfl when it shortens the proof.  (Contributed by NM,
       19-Oct-2014.) $)
    islfld $p |- ( ph -> G e. F ) $=
      ( clfn cfv wcel cbs csca wf cv cvsca cplusg cmulr wceq wral fveq2d feq23d
      co eqtrd mpbid ralrimivvva oveqd eqidd oveq123d eqeq12d raleqbidv wa eqid
      islfl biimpar syl12anc eleqtrrd ) AJMUGUHZIAMNUIZMUJUHZMUKUHZUJUHZJULZOUM
      ZBUMZMUNUHZVAZCUMZMUOUHZVAZJUHZWBWCJUHZVSUPUHZVAZWFJUHZVSUOUHZVAZUQZCVRUR
      ZBVRURZOVTURZJVPUIZUFALKJULWAUDALKVRVTJPAKDUJUHVTTADVSUJRUSVBZUTVCAWBWCGV
      AZWFEVAZJUHZWBWJHVAZWMFVAZUQZCLURZBLURZOKURWSAXGOBCKLLUEVDAXIWROKVTXAAXHW
      QBLVRPAXGWPCLVRPAXDWIXFWOAXCWHJAXBWEWFWFEWGQAGWDWBWCSVEAWFVFVGUSAXEWLWMWM
      FWNAFDUOUHWNUAADVSUORUSVBAHWKWBWJAHDUPUHWKUBADVSUPRUSVBVEAWMVFVGVHVIVIVIV
      CVQWTWAWSVJBCVSWGWNWDWKVPJVTVRMNOVRVKWGVKVSVKWDVKVTVKWNVKWKVKVPVKVLVMVNUC
      VO $.
  $}

  ${
    $d r x y G $.  $d r K $.  $d x y V $.  $d r x y W $.
    lflf.d $e |- D = ( Scalar ` W ) $.
    lflf.k $e |- K = ( Base ` D ) $.
    lflf.v $e |- V = ( Base ` W ) $.
    lflf.f $e |- F = ( LFnl ` W ) $.
    $( A linear functional is a function from vectors to scalars.  ( ~ lnfnfi
       analog.)  (Contributed by NM, 15-Apr-2014.) $)
    lflf $p |- ( ( W e. X /\ G e. F ) -> G : V --> K ) $=
      ( vr vx vy wcel cv cfv co wral eqid wf cvsca cplusg cmulr islfl simprbda
      wceq ) FGOCBOEDCUALPZMPZFUBQZRNPZFUCQZRCQUHUICQAUDQZRUKCQAUCQZRUGNESMESLD
      SMNAULUNUJUMBCDEFGLJULTHUJTIUNTUMTKUEUF $.

    $( A linear functional value is a scalar.  (Contributed by NM,
       15-Apr-2014.) $)
    lflcl $p |- ( ( W e. Y /\ G e. F /\ X e. V ) -> ( G ` X ) e. K ) $=
      ( wcel w3a wf lflf 3adant3 simp3 ffvelrnd ) FHMZCBMZGEMZNEDGCTUAEDCOUBABC
      DEFHIJKLPQTUAUBRS $.
  $}

  ${
    lfl0.d $e |- D = ( Scalar ` W ) $.
    lfl0.o $e |- .0. = ( 0g ` D ) $.
    lfl0.z $e |- Z = ( 0g ` W ) $.
    lfl0.f $e |- F = ( LFnl ` W ) $.
    $( A linear functional is zero at the zero vector.  ( ~ lnfn0i analog.)
       (Contributed by NM, 16-Apr-2014.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    lfl0 $p |- ( ( W e. LMod /\ G e. F ) -> ( G ` Z ) = .0. ) $=
      ( clmod wcel cfv co cplusg cbs wceq eqid adantr syl3anc cvsca cmulr simpl
      wa csg cur simpr lmod1cl lmod0vcl lfli syl113anc lmod0vrid syldan lmodvs1
      lmodvscl eqtrd fveq2d lmodrng mpd3an3 rnglidm syl2anc oveq1d 3eqtr3d cgrp
      crg lflcl rnggrp syl grpsubid grppncan 3eqtr3rd ) DKLZCBLZUDZFCMZVOAUEMZN
      ZVOVOAOMZNZVOVPNZEVOVNVOVSVOVPVNAUFMZFDUAMZNZFDOMZNZCMZWAVOAUBMZNZVOVRNZV
      OVSVNVLVMWAAPMZLZFDPMZLZWMWFWIQVLVMUCZVLVMUGVLWKVMWAAWJDGWJRZWARZUHSZVLWM
      VMWLDFWLRZIUISZWSAWDVRWAWBWGBCWJWLDFFKWRWDRZGWBRZWOVRRZWGRZJUJUKVNWEFCVNW
      EWCFVLVMWCWLLZWEWCQVNVLWKWMXDWNWQWSWAWBAWJWLDFWRGXAWOUOTWDWLDWCFWRWTIULUM
      VLVMWMWCFQWSWBWAAWLDFWRGXAWPUNUMUPUQVNWHVOVOVRVNAVELZVOWJLZWHVOQVLXEVMADG
      URSZVLVMWMXFWSABCWJWLDFKGWOWRJVFUSZWJAWGWAVOWOXCWPUTVAVBVCVBVNAVDLZXFVQEQ
      VNXEXIXGAVGVHZXHWJAVPVOEWOHVPRZVIVAVNXIXFXFVTVOQXJXHXHWJVRAVPVOVOWOXBXKVJ
      TVK $.
  $}

  ${
    lfladd.d $e |- D = ( Scalar ` W ) $.
    lfladd.p $e |- .+^ = ( +g ` D ) $.
    lfladd.v $e |- V = ( Base ` W ) $.
    lfladd.a $e |- .+ = ( +g ` W ) $.
    lfladd.f $e |- F = ( LFnl ` W ) $.
    $( Property of a linear functional.  ( ~ lnfnaddi analog.)  (Contributed by
       NM, 18-Apr-2014.) $)
    lfladd $p |- ( ( W e. LMod /\ G e. F /\ ( X e. V /\ Y e. V ) )
      -> ( G ` ( X .+ Y ) ) = ( ( G ` X ) .+^ ( G ` Y ) ) ) $=
      ( clmod wcel cfv co wceq eqid w3a cur cvsca cmulr cbs simp1 simp2 lmod1cl
      wa 3ad2ant1 simp3l simp3r syl113anc lmodvs1 syl2anc oveq1d fveq2d lmodrng
      lfli crg lflcl 3adant3r rnglidm 3eqtr3d ) GOPZEDPZHFPZIFPZUIZUAZAUBQZHGUC
      QZRZIBRZEQZVKHEQZAUDQZRZIEQZCRZHIBRZEQVPVSCRVJVEVFVKAUEQZPZVGVHVOVTSVEVFV
      IUFZVEVFVIUGVEVFWCVIVKAWBGJWBTZVKTZUHUJVEVFVGVHUKZVEVFVGVHULABCVKVLVQDEWB
      FGHIOLMJVLTZWEKVQTZNUSUMVJVNWAEVJVMHIBVJVEVGVMHSWDWGVLVKAFGHLJWHWFUNUOUPU
      QVJVRVPVSCVJAUTPZVPWBPZVRVPSVEVFWJVIAGJURUJVEVFVGWKVHADEWBFGHOJWELNVAVBWB
      AVQVKVPWEWIWFVCUOUPVD $.
  $}

  ${
    lflsub.d $e |- D = ( Scalar ` W ) $.
    lflsub.m $e |- M = ( -g ` D ) $.
    lflsub.v $e |- V = ( Base ` W ) $.
    lflsub.a $e |- .- = ( -g ` W ) $.
    lflsub.f $e |- F = ( LFnl ` W ) $.
    $( Property of a linear functional.  ( ~ lnfnaddi analog.)  (Contributed by
       NM, 18-Apr-2014.) $)
    lflsub $p |- ( ( W e. LMod /\ G e. F /\ ( X e. V /\ Y e. V ) )
      -> ( G ` ( X .- Y ) ) = ( ( G ` X ) M ( G ` Y ) ) ) $=
      ( clmod wcel cfv co wceq eqid wa w3a cur cminusg cvsca cplusg cmulr simp1
      simp3l cbs cgrp crg lmodrng 3ad2ant1 rnggrp syl rngidcl grpinvcl lmodvscl
      syl2anc simp3r syl3anc lmodcom fveq2d simp2 lfli syl113anc lflcl 3adant3l
      rngnegl oveq1d cabel rngabl 3adant3r ablcom 3eqtrd lmodvsubval2 grpsubval
      eqtrd 3eqtr4d ) GOPZCBPZHFPZIFPZUAZUBZHAUCQZAUDQZQZIGUEQZRZGUFQZRZCQZHCQZ
      ICQZWHQZAUFQZRZHIERZCQWOWPDRZWFWNWKHWLRZCQZWIWPAUGQZRZWOWRRZWSWFWMXBCWFWA
      WCWKFPZWMXBSWAWBWEUHZWAWBWCWDUIZWFWAWIAUJQZPZWDXGXHWFAUKPZWGXJPZXKWFAULPZ
      XLWAWBXNWEAGJUMUNZAUOUPZWFXNXMXOXJAWGXJTZWGTZUQUPXJAWHWGXQWHTZURUTZWAWBWC
      WDVAZWIWJAXJFGILJWJTZXQUSVBWLFGHWKLWLTZVCVBVDWFWAWBXKWDWCXCXFSXHWAWBWEVEX
      TYAXIAWLWRWIWJXDBCXJFGIHOLYCJYBXQWRTZXDTZNVFVGWFXFWQWOWRRZWSWFXEWQWOWRWFX
      JAXDWGWHWPXQYEXRXSXOWAWBWDWPXJPZWCABCXJFGIOJXQLNVHVIZVJVKWFAVLPZWQXJPZWOX
      JPZYFWSSWFXNYIXOAVMUPWFXLYGYJXPYHXJAWHWPXQXSURUTWAWBWCYKWDABCXJFGHOJXQLNV
      HVNZXJWRAWQWOXQYDVOVBVSVPWFWTWMCWFWAWCWDWTWMSXHXIYAHIWLWJWGAEWHFGLYCMJYBX
      SXRVQVBVDWFYKYGXAWSSYLYHXJWRAWHDWOWPXQYDXSKVRUTVT $.
  $}

  ${
    lflmul.d $e |- D = ( Scalar ` W ) $.
    lflmul.k $e |- K = ( Base ` D ) $.
    lflmul.t $e |- .X. = ( .r ` D ) $.
    lflmul.v $e |- V = ( Base ` W ) $.
    lflmul.s $e |- .x. = ( .s ` W ) $.
    lflmul.f $e |- F = ( LFnl ` W ) $.
    $( Property of a linear functional.  ( ~ lnfnmuli analog.)  (Contributed by
       NM, 16-Apr-2014.) $)
    lflmul $p |- ( ( W e. LMod /\ G e. F /\ ( R e. K /\ X e. V ) )
      -> ( G ` ( R .x. X ) ) = ( R .X. ( G ` X ) ) ) $=
      ( wcel co cfv wceq clmod wa w3a c0g cplusg simp1 simp2 simp3l simp3r eqid
      lmod0vcl 3ad2ant1 lfli syl113anc syl3anc lmod0vrid syl2anc fveq2d 3adant3
      lmodvscl lfl0 oveq2d lmodfgrp lflcl 3adant3l lmodmcl grprid eqtrd 3eqtr3d
      cgrp ) IUAQZFEQZBGQZJHQZUBZUCZBJCRZIUDSZIUESZRZFSZBJFSZDRZVRFSZAUESZRZVQF
      SWCVPVKVLVMVNVRHQZWAWFTVKVLVOUFZVKVLVOUGVKVLVMVNUHZVKVLVMVNUIZVKVLWGVOHIV
      RNVRUJZUKULAVSWEBCDEFGHIJVRUANVSUJZKOLWEUJZMPUMUNVPVTVQFVPVKVQHQZVTVQTWHV
      PVKVMVNWNWHWIWJBCAGHIJNKOLUTUOVSHIVQVRNWLWKUPUQURVPWFWCAUDSZWERZWCVPWDWOW
      CWEVKVLWDWOTVOAEFIWOVRKWOUJZWKPVAUSVBVPAVJQZWCGQZWPWCTVKVLWRVOAIKVCULVPVK
      VMWBGQZWSWHWIVKVLVNWTVMAEFGHIJUAKLNPVDVEDAGIBWBKLMVFUOGWEAWCWOLWMWQVGUQVH
      VI $.
  $}

  ${
    $d r x y D $.  $d r x y .0. $.  $d r x y V $.  $d r x y W $.
    lfl0f.d $e |- D = ( Scalar ` W ) $.
    lfl0f.o $e |- .0. = ( 0g ` D ) $.
    lfl0f.v $e |- V = ( Base ` W ) $.
    lfl0f.f $e |- F = ( LFnl ` W ) $.
    $( The zero function is a functional.  (Contributed by NM, 16-Apr-2014.) $)
    lfl0f $p |- ( W e. LMod -> ( V X. { .0. } ) e. F ) $=
      ( vr vx vy wcel cfv cv co wceq wral eqid syl clmod csn cxp wf cvsca cmulr
      cbs cplusg wss c0g cvv fvex eqeltri fconst lmod0cl fss sylancr wa lmodrng
      snssd crg ad2antrr simplrl rngrz syl2anc oveq1d cgrp rnggrp grpidcl eqtrd
      grplid simplrr fvconst2 oveq2d oveq12d lmodvscl syl3anc lmodvacl 3eqtr4rd
      adantl simpll simpr ralrimiva ralrimivva islfl mpbir2and ) DUAMZCEUBZUCZB
      MCAUGNZWIUDZJOZKOZDUENZPZLOZDUHNZPZWINZWLWMWINZAUFNZPZWPWINZAUHNZPZQZLCRZ
      KCRJWJRWGCWHWIUDWHWJUIWKCEEAUJNUKGAUJULUMZUNWGEWJAWJDEFWJSZGUOUTCWHWJWIUP
      UQWGXGJKWJCWGWLWJMZWMCMZURZURZXFLCXMWPCMZURZWLEXAPZEXDPZEXEWSXOXQEEXDPZEX
      OXPEEXDXOAVAMZXJXPEQWGXSXLXNADFUSVBZWGXJXKXNVCZWJAXAWLEXIXASZGVDVEVFXOAVG
      MZEWJMZXREQXOXSYCXTAVHTZXOYCYDYEWJAEXIGVITWJXDAEEXIXDSZGVKVEVJXOXBXPXCEXD
      XOWTEWLXAXOXKWTEQWGXJXKXNVLZCEWMXHVMTVNXNXCEQXMCEWPXHVMVTVOXOWRCMZWSEQXOW
      GWOCMZXNYHWGXLXNWAZXOWGXJXKYIYJYAYGWLWNAWJCDWMHFWNSZXIVPVQXMXNWBWQCDWOWPH
      WQSZVRVQCEWRXHVMTVSWCWDKLAWQXDWNXABWIWJCDUAJHYLFYKXIYFYBIWEWF $.
  $}

  ${
    $d x D $.  $d z F $.  $d x z G $.  $d x z .1. $.  $d x z V $.  $d x z W $.
    $d z .0. $.
    lfl1.d $e |- D = ( Scalar ` W ) $.
    lfl1.o $e |- .0. = ( 0g ` D ) $.
    lfl1.u $e |- .1. = ( 1r ` D ) $.
    lfl1.v $e |- V = ( Base ` W ) $.
    lfl1.f $e |- F = ( LFnl ` W ) $.
    $( A non-zero functional has a value of 1 at some argument.  (Contributed
       by NM, 16-Apr-2014.) $)
    lfl1 $p |- ( ( W e. LVec /\ G e. F /\ G =/= ( V X. { .0. } ) )
        -> E. x e. V ( G ` x ) = .1. ) $=
      ( vz wcel cfv wceq eqid syl syl3anc clvec csn cxp wne w3a cv wrex wa wral
      wn nne ralbii wf wfn wi cbs ffn fconstfv simplbi2 c0g cvv eqeltri fconst2
      lflf fvex syl6ib syl5bi necon3ad dfrex2 syl6ibr 3impia cinvr cvsca simp1l
      co clmod lveclmod cdr lvecdrng simp1r simp2 lflcl simp3 drnginvrcl lflmul
      lmodvscl cmulr syl112anc drnginvrl eqtrd eqeq1d rspcev syl2anc rexlimdv3a
      fveq2 3adant3 mpd ) GUAOZEDOZEFHUBZUCZUDZUENUFZEPZHUDZNFUGZAUFZEPZCQZAFUG
      ZWRWSXBXFWRWSUHZXBXEUJZNFUIZUJXFXKXMEXAXMXDHQZNFUIZXKEXAQZXLXNNFXDHUKULXK
      XOFWTEUMZXPXKEFUNZXOXQUOXKFBUPPZEUMXRBDEXSFGUAIXSRZLMVDFXSEUQSXQXRXONFHEU
      RUSSFHEHBUTPVAJBUTVEVBVCVFVGVHXENFVIVJVKWRWSXFXJUOXBXKXEXJNFXKXCFOZXEUEZX
      DBVLPZPZXCGVMPZVOZFOZYFEPZCQZXJYBGVPOZYDXSOZYAYGYBWRYJWRWSYAXEVNZGVQSZYBB
      VROZXDXSOZXEYKYBWRYNYLBGIVSSZYBWRWSYAYOYLWRWSYAXEVTZXKYAXEWAZBDEXSFGXCUAI
      XTLMWBTZXKYAXEWCZXSBYCXDHXTJYCRZWDTZYRYDYEBXSFGXCLIYERZXTWFTYBYHYDXDBWGPZ
      VOZCYBYJWSYKYAYHUUEQYMYQUUBYRBYDYEUUDDEXSFGXCIXTUUDRZLUUCMWEWHYBYNYOXEUUE
      CQYPYSYTXSBUUDCYCXDHXTJUUFKUUAWITWJXIYIAYFFXGYFQXHYHCXGYFEWOWKWLWMWNWPWQ
      $.
  $}

  ${
    $d x y z G $.  $d x y z H $.  $d x y z .+ $.  $d x y z R $.  $d x y z W $.
    $d x y z ph $.
    lfladdcl.r $e |- R = ( Scalar ` W ) $.
    lfladdcl.p $e |- .+ = ( +g ` R ) $.
    lfladdcl.f $e |- F = ( LFnl ` W ) $.
    lfladdcl.w $e |- ( ph -> W e. LMod ) $.
    lfladdcl.g $e |- ( ph -> G e. F ) $.
    lfladdcl.h $e |- ( ph -> H e. F ) $.
    $( Closure of addition of two functionals.  (Contributed by NM,
       19-Oct-2014.) $)
    lfladdcl $p |- ( ph -> ( G oF .+ H ) e. F ) $=
      ( co wcel cfv wceq cvv clmod syl3anc vx vy vz cof wf cv cvsca cplusg wral
      cbs cmulr wa adantr simprl simprr eqid lmodacl lflf syl2anc a1i inidm off
      w3a simpr1 simpr2 lmodvscl simpr3 lmodvacl wfn ffn syl eqidd ofval syldan
      fvex oveq2d oveq12d lfladd syl112anc ccmn crg rngcmn lflcl cmn4 syl122anc
      lflmul rngdi syl13anc eqtr4d oveq1d 3eqtrd ralrimivvva wb islfl mpbir2and
      lmodrng ) AEFBUDNZDOZGUJPZCUJPZWQUEZUAUFZUBUFZGUGPZNZUCUFZGUHPZNZWQPZXBXC
      WQPZCUKPZNZXFWQPZBNZQZUCWSUIUBWSUIUAWTUIZAUAUBWSWSWSBWTWTWTEFRRAXBWTOZXCW
      TOZULZULGSOZXQXRXBXCBNWTOAXTXSKUMAXQXRUNAXQXRUOBCWTGXBXCHWTUPZIUQTAXTEDOZ
      WSWTEUEZKLCDEWTWSGSHYAWSUPZJURUSZAXTFDOZWSWTFUEZKMCDFWTWSGSHYAYDJURUSZWSR
      OAGUJVOUTZYIWSVAZVBAXOUAUBUCWTWSWSAXQXCWSOZXFWSOZVCZULZXIXHEPZXHFPZBNZXNA
      YMXHWSOZXIYQQYNXTXEWSOZYLYRAXTYMKUMZYNXTXQYKYSYTAXQYKYLVDZAXQYKYLVEZXBXDC
      WTWSGXCYDHXDUPZYAVFTZAXQYKYLVGZXGWSGXEXFYDXGUPZVHTAWSWSYOYPBWSEFRRXHAYCEW
      SVIYEWSWTEVJVKZAYGFWSVIYHWSWTFVJVKZYIYIYJAYRULZYOVLUUIYPVLVMVNYNXNXBXCEPZ
      XCFPZBNZXKNZXFEPZXFFPZBNZBNZYQYNXLUUMXMUUPBYNXJUULXBXKAYMYKXJUULQUUBAWSWS
      UUJUUKBWSEFRRXCUUGUUHYIYIYJAYKULZUUJVLUURUUKVLVMVNVPAYMYLXMUUPQUUEAWSWSUU
      NUUOBWSEFRRXFUUGUUHYIYIYJAYLULZUUNVLUUSUUOVLVMVNVQYNYQXEEPZUUNBNZXEFPZUUO
      BNZBNZUUTUVBBNZUUPBNZUUQYNYOUVAYPUVCBYNXTYBYSYLYOUVAQYTAYBYMLUMZUUDUUECXG
      BDEWSGXEXFHIYDUUFJVRVSYNXTYFYSYLYPUVCQYTAYFYMMUMZUUDUUECXGBDFWSGXEXFHIYDU
      UFJVRVSVQYNCVTOZUUTWTOZUUNWTOZUVBWTOZUUOWTOZUVDUVFQYNCWAOZUVIYNXTUVNYTCGH
      WPVKZCWBVKYNXTYBYSUVJYTUVGUUDCDEWTWSGXESHYAYDJWCTYNXTYBYLUVKYTUVGUUECDEWT
      WSGXFSHYAYDJWCTYNXTYFYSUVLYTUVHUUDCDFWTWSGXESHYAYDJWCTYNXTYFYLUVMYTUVHUUE
      CDFWTWSGXFSHYAYDJWCTWTBCUUOUUTUUNUVBYAIWDWEYNUVEUUMUUPBYNUVEXBUUJXKNZXBUU
      KXKNZBNZUUMYNUUTUVPUVBUVQBYNXTYBXQYKUUTUVPQYTUVGUUAUUBCXBXDXKDEWTWSGXCHYA
      XKUPZYDUUCJWFVSYNXTYFXQYKUVBUVQQYTUVHUUAUUBCXBXDXKDFWTWSGXCHYAUVSYDUUCJWF
      VSVQYNUVNXQUUJWTOZUUKWTOZUUMUVRQUVOUUAYNXTYBYKUVTYTUVGUUBCDEWTWSGXCSHYAYD
      JWCTYNXTYFYKUWAYTUVHUUBCDFWTWSGXCSHYAYDJWCTWTBCXKXBUUJUUKYAIUVSWGWHWIWJWK
      WIWIWLAXTWRXAXPULWMKUBUCCXGBXDXKDWQWTWSGSUAYDUUFHUUCYAIUVSJWNVKWO $.

    $( Commutativity of functional addition.  (Contributed by NM,
       19-Oct-2014.) $)
    lfladdcom $p |- ( ph -> ( G oF .+ H ) = ( H oF .+ G ) ) $=
      ( vx vy cbs cfv cvv wcel clmod fvex wf eqid lflf syl2anc cv wa cabel wceq
      a1i crg lmodrng rngabl 3syl adantr simprl simprr ablcom syl3anc caofcom
      co ) ANOGPQZBCPQZEFRVBRSAGPUAUJAGTSZEDSVBVCEUBKLCDEVCVBGTHVCUCZVBUCZJUDUE
      AVDFDSVBVCFUBKMCDFVCVBGTHVEVFJUDUEANUFZVCSZOUFZVCSZUGZUGCUHSZVHVJVGVIBVAV
      IVGBVAUIAVLVKAVDCUKSVLKCGHULCUMUNUOAVHVJUPAVHVJUQVCBCVGVIVEIURUSUT $.

    $d x y z I $.
    lfladdass.i $e |- ( ph -> I e. F ) $.
    $( Associativity of functional addition.  (Contributed by NM,
       19-Oct-2014.) $)
    lfladdass $p |- ( ph
        -> ( ( G oF .+ H ) oF .+ I ) = ( G oF .+ ( H oF .+ I ) ) ) $=
      ( cbs wcel clmod wf co vx vy vz cfv cvv fvex a1i eqid lflf syl2anc cv w3a
      cgrp wceq crg lmodrng rnggrp 3syl grpass sylan caofass ) AUAUBUCHPUDZBBCP
      UDZBEFGBUEVBUEQAHPUFUGAHRQZEDQVBVCESLMCDEVCVBHRIVCUHZVBUHZKUIUJAVDFDQVBVC
      FSLNCDFVCVBHRIVEVFKUIUJAVDGDQVBVCGSLOCDGVCVBHRIVEVFKUIUJACUMQZUAUKZVCQUBU
      KZVCQUCUKZVCQULVHVIBTVJBTVHVIVJBTBTUNAVDCUOQVGLCHIUPCUQURVCBCVHVIVJVEJUSU
      TVA $.

  $}

  ${
    $d k G $.  $d k .0. $.  $d k .+ $.  $d k R $.  $d k ph $.
    lfladd0l.v $e |- V = ( Base ` W ) $.
    lfladd0l.r $e |- R = ( Scalar ` W ) $.
    lfladd0l.p $e |- .+ = ( +g ` R ) $.
    lfladd0l.o $e |- .0. = ( 0g ` R ) $.
    lfladd0l.f $e |- F = ( LFnl ` W ) $.
    lfladd0l.w $e |- ( ph -> W e. LMod ) $.
    lfladd0l.g $e |- ( ph -> G e. F ) $.
    $( Functional addition with the zero functional.  (Contributed by NM,
       21-Oct-2014.) $)
    lfladd0l $p |- ( ph -> ( ( V X. { .0. } ) oF .+ G ) = G ) $=
      ( vk cbs cfv cvv wcel fvex eqeltri a1i clmod wf eqid lflf syl2anc cgrp cv
      c0g co wceq crg lmodrng rnggrp 3syl grplid sylan caofid0l ) APFHBCQRZESSF
      STAFGQRSIGQUAUBUCAGUDTZEDTFVAEUENOCDEVAFGUDJVAUFZIMUGUHHSTAHCUKRSLCUKUAUB
      UCACUITZPUJZVATHVEBULVEUMAVBCUNTVDNCGJUOCUPUQVABCVEHVCKLURUSUT $.
  $}

  ${
    $d x y G $.  $d x y I $.  $d k y z N $.  $d y .0. $.  $d y .+ $.
    $d k x y z R $.  $d x y z V $.  $d k x y z W $.  $d k x y z ph $.
    lflnegcl.v $e |- V = ( Base ` W ) $.
    lflnegcl.r $e |- R = ( Scalar ` W ) $.
    lflnegcl.i $e |- I = ( invg ` R ) $.
    lflnegcl.n $e |- N = ( x e. V |-> ( I ` ( G ` x ) ) ) $.
    lflnegcl.f $e |- F = ( LFnl ` W ) $.
    lflnegcl.w $e |- ( ph -> W e. LMod ) $.
    lflnegcl.g $e |- ( ph -> G e. F ) $.
    $( Closure of the negative of a functional.  (This is specialized for the
       purpose of proving ~ ldualgrp , and we do not define a general operation
       here.)  (Contributed by NM, 22-Oct-2014.) $)
    lflnegcl $p |- ( ph -> N e. F ) $=
      ( wcel cfv co wceq vk vy vz cbs wf cv cvsca cplusg cmulr wral wa cgrp crg
      clmod lmodrng syl rnggrp adantr simpr eqid lflcl syl3anc grpinvcl syl2anc
      fmptd w3a cabel rngabl simpr1 simpr2 rngcl simpr3 ablinvadd lfli rngmneg2
      syl113anc fveq2d oveq1d 3eqtr4d lmodvscl lmodvacl fveq2 fvex fvmpt oveq2d
      oveq12d ralrimivvva wb islfl mpbir2and ) AGDQZHCUDRZGUEZUAUFZUBUFZIUGRZSZ
      UCUFZIUHRZSZGRZWNWOGRZCUIRZSZWRGRZCUHRZSZTZUCHUJUBHUJUAWLUJZABHBUFZERZFRZ
      WLGAXJHQZUKZCULQZXKWLQZXLWLQAXOXMACUMQZXOAIUNQZXQOCIKUOUPZCUQUPURXNXREDQZ
      XMXPAXRXMOURAXTXMPURAXMUSCDEWLHIXJUNKWLUTZJNVAVBWLCFXKYALVCVDMVEAXHUAUBUC
      WLHHAWNWLQZWOHQZWRHQZVFZUKZWTERZFRZWNWOERZFRZXCSZWRERZFRZXFSZXAXGYFWNYIXC
      SZYLXFSZFRZYOFRZYMXFSZYHYNYFCVGQZYOWLQZYLWLQZYQYSTAYTYEAXQYTXSCVHUPURYFXQ
      YBYIWLQZUUAAXQYEXSURZAYBYCYDVIZYFXRXTYCUUCAXRYEOURZAXTYEPURZAYBYCYDVJZCDE
      WLHIWOUNKYAJNVAVBZWLCXCWNYIYAXCUTZVKVBYFXRXTYDUUBUUFUUGAYBYCYDVLZCDEWLHIW
      RUNKYAJNVAVBWLXFCFYOYLYAXFUTZLVMVBYFYGYPFYFXRXTYBYCYDYGYPTUUFUUGUUEUUHUUK
      CWSXFWNWPXCDEWLHIWOWRUNJWSUTZKWPUTZYAUULUUJNVNVPVQYFYKYRYMXFYFWLCXCFWNYIY
      AUUJLUUDUUEUUIVOVRVSYFWTHQZXAYHTYFXRWQHQZYDUUOUUFYFXRYBYCUUPUUFUUEUUHWNWP
      CWLHIWOJKUUNYAVTVBUUKWSHIWQWRJUUMWAVBBWTXLYHHGXJWTTXKYGFXJWTEWBVQMYGFWCWD
      UPYFXDYKXEYMXFYFXBYJWNXCYFYCXBYJTUUHBWOXLYJHGXJWOTXKYIFXJWOEWBVQMYIFWCWDU
      PWEYFYDXEYMTUUKBWRXLYMHGXJWRTXKYLFXJWREWBVQMYLFWCWDUPWFVSWGAXRWKWMXIUKWHO
      UBUCCWSXFWPXCDGWLHIUNUAJUUMKUUNYAUULUUJNWIUPWJ $.

    lflnegl.p $e |- .+ = ( +g ` R ) $.
    lflnegl.o $e |- .0. = ( 0g ` R ) $.
    $( A functional plus its negative is the zero functional.  (This is
       specialized for the purpose of proving ~ ldualgrp , and we do not define
       a general operation here.)  (Contributed by NM, 22-Oct-2014.) $)
    lflnegl $p |- ( ph -> ( N oF .+ G ) = ( V X. { .0. } ) ) $=
      ( vy cbs cfv cvv wcel fvex eqeltri a1i clmod wf eqid lflf syl2anc c0g crg
      wf1o cgrp lmodrng rnggrp 3syl grpinvf1o f1of syl cv cmpt co grplinv sylan
      wceq caofinvl ) AUABIKCDUBUCZFHGUDUDIUDUEAIJUBUCUDLJUBUFUGUHAJUIUEZFEUEIV
      KFUJQRDEFVKIJUIMVKUKZLPULUMKUDUEAKDUNUCUDTDUNUFUGUHAVKVKGUPVKVKGUJAVKDGVM
      NAVLDUOUEDUQUEZQDJMURDUSUTZVAVKVKGVBVCHBIBVDFUCGUCVEVIAOUHAVNUAVDZVKUEVPG
      UCVPCVFKVIVOVKCDGVPKVMSTNVGVHVJ $.
  $}

  ${
    $d r x y G $.  $d r x y K $.  $d r x y R $.  $d r x y .x. $.  $d r x y V $.
    $d r x y W $.  $d r x y ph $.
    lflsccl.v $e |- V = ( Base ` W ) $.
    lflsccl.d $e |- D = ( Scalar ` W ) $.
    lflsccl.k $e |- K = ( Base ` D ) $.
    lflsccl.t $e |- .x. = ( .r ` D ) $.
    lflsccl.f $e |- F = ( LFnl ` W ) $.
    lflsccl.w $e |- ( ph -> W e. LMod ) $.
    lflsccl.g $e |- ( ph -> G e. F ) $.
    lflsccl.r $e |- ( ph -> R e. K ) $.
    $( Closure of a scalar product with a functional.  Note that this is the
       scalar product for a right vector space with the scalar after the
       vector; reversing these fails closure.  (Contributed by NM,
       9-Oct-2014.)  (Revised by Mario Carneiro, 22-Apr-2015.) $)
    lflvscl $p |- ( ph -> ( G oF .x. ( V X. { R } ) ) e. F ) $=
      ( cfv co wcel vx vy vr cplusg cvsca csn cxp cof clmod cbs wceq eqidd csca
      a1i cmulr cvv crg cv wa lmodrng syl rngcl 3expb sylan wf syl2anc fconst6g
      clfn lflf fvex eqeltri off w3a adantr simpr1 simpr2 simpr3 eqid syl113anc
      inidm lfli oveq1d syl3anc rngdir syl13anc rngass 3eqtrd lmodvscl lmodvacl
      lflcl wfn ffn ofc2 syldan oveq2d oveq12d 3eqtr4d islfld ) AUAUBBIUDRZBUDR
      ZIUERZDEFHCUFUGZDUHSZGHIUIUCHIUJRZUKAJUNAWSULBIUMRUKAKUNAXAULGBUJRUKALUNA
      WTULDBUORUKAMUNEIVHRUKANUNAUAUBHHHDGGGFXBUPUPABUQTZUAURZGTZUBURZGTZUSXFXH
      DSGTZAIUITZXEOBIKUTVAZXEXGXIXJGBDXFXHLMVBVCVDAXKFETZHGFVEZOPBEFGHIUIKLJNV
      IVFZACGTZHGXBVEQHCGVGVAHUPTAHXDUPJIUJVJVKUNZXQHVTVLAUCURZGTZXFHTZXHHTZVMZ
      USZXRXFXASZXHWSSZFRZCDSZXRXFFRZCDSZDSZXHFRZCDSZWTSZYEXCRZXRXFXCRZDSZXHXCR
      ZWTSYCYGXRYHDSZYKWTSZCDSZYRCDSZYLWTSZYMYCYFYSCDYCXKXMXSXTYAYFYSUKAXKYBOVN
      ZAXMYBPVNZAXSXTYAVOZAXSXTYAVPZAXSXTYAVQZBWSWTXRXADEFGHIXFXHUIJWSVRZKXAVRZ
      LWTVRZMNWAVSWBYCXEYRGTZYKGTZXPYTUUBUKAXEYBXLVNZYCXEXSYHGTZUUKUUMUUEYCXKXM
      XTUUNUUCUUDUUFBEFGHIXFUIKLJNWJWCZGBDXRYHLMVBWCYCXKXMYAUULUUCUUDUUGBEFGHIX
      HUIKLJNWJWCAXPYBQVNZGWTBDYRYKCLUUJMWDWEYCUUAYJYLWTYCXEXSUUNXPUUAYJUKUUMUU
      EUUOUUPGBDXRYHCLMWFWEWBWGAYBYEHTZYNYGUKYCXKYDHTZYAUUQUUCYCXKXSXTUURUUCUUE
      UUFXRXABGHIXFJKUUILWHWCUUGWSHIYDXHJUUHWIWCAHCYFDFUPGYEXQQAXNFHWKXOHGFWLVA
      ZAUUQUSYFULWMWNYCYPYJYQYLWTYCYOYIXRDAYBXTYOYIUKUUFAHCYHDFUPGXFXQQUUSAXTUS
      YHULWMWNWOAYBYAYQYLUKUUGAHCYKDFUPGXHXQQUUSAYAUSYKULWMWNWPWQOWR $.
  $}

  ${
    $d x y z .+ $.  $d x y z G $.  $d x y z H $.  $d x y z K $.  $d x y z ph $.
    $d x y z V $.  $d x y z .x. $.  $d x y z X $.  $d x y z Y $.
    lfldi.v $e |- V = ( Base ` W ) $.
    lfldi.r $e |- R = ( Scalar ` W ) $.
    lfldi.k $e |- K = ( Base ` R ) $.
    lfldi.p $e |- .+ = ( +g ` R ) $.
    lfldi.t $e |- .x. = ( .r ` R ) $.
    lfldi.f $e |- F = ( LFnl ` W ) $.
    lfldi.w $e |- ( ph -> W e. LMod ) $.
    lfldi.x $e |- ( ph -> X e. K ) $.
    ${
      lfldi1.g $e |- ( ph -> G e. F ) $.
      lfldi1.h $e |- ( ph -> H e. F ) $.
      $( Distributive law for (right vector space) scalar product of
         functionals.  (Contributed by NM, 19-Oct-2014.) $)
      lflvsdi1 $p |- ( ph -> ( ( G oF .+ H ) oF .x. ( V X. { X } ) )
       = ( ( G oF .x. ( V X. { X } ) ) oF .+ ( H oF .x. ( V X. { X } ) ) ) ) $=
        ( vx vy vz csn cxp cvv wcel cbs cfv fvex eqeltri a1i fconst6g syl clmod
        wf lflf syl2anc crg cv w3a co wceq lmodrng rngdir sylan caofdir ) AUBUC
        UDIBHDIKUEUFZFGHBUGIUGUHAIJUIUJUGLJUIUKULUMAKHUHIHVIUQSIKHUNUOAJUPUHZFE
        UHIHFUQRTCEFHIJUPMNLQURUSAVJGEUHIHGUQRUACEGHIJUPMNLQURUSACUTUHZUBVAZHUH
        UCVAZHUHUDVAZHUHVBVLVMBVCVNDVCVLVNDVCVMVNDVCBVCVDAVJVKRCJMVEUOHBCDVLVMV
        NNOPVFVGVH $.
    $}

    ${
      lfldi2.y $e |- ( ph -> Y e. K ) $.
      lfldi2.g $e |- ( ph -> G e. F ) $.
      $( Reverse distributive law for (right vector space) scalar product of
         functionals.  (Contributed by NM, 19-Oct-2014.) $)
      lflvsdi2 $p |- ( ph
  -> ( G oF .x. ( ( V X. { X } ) oF .+ ( V X. { Y } ) ) )
       = ( ( G oF .x. ( V X. { X } ) ) oF .+ ( G oF .x. ( V X. { Y } ) ) ) ) $=
        ( vx vy vz csn cxp cvv wcel cbs cfv fvex eqeltri a1i clmod lflf syl2anc
        wf fconst6g syl crg cv w3a co wceq lmodrng rngdi sylan caofdi ) AUBUCUD
        HBGDFHJUEUFZHKUEUFZGBUGHUGUHAHIUIUJUGLIUIUKULUMAIUNUHZFEUHHGFUQRUACEFGH
        IUNMNLQUOUPAJGUHHGVIUQSHJGURUSAKGUHHGVJUQTHKGURUSACUTUHZUBVAZGUHUCVAZGU
        HUDVAZGUHVBVMVNVOBVCDVCVMVNDVCVMVODVCBVCVDAVKVLRCIMVEUSGBCDVMVNVONOPVFV
        GVH $.

      $( Reverse distributive law for (right vector space) scalar product of
         functionals.  (Contributed by NM, 21-Oct-2014.) $)
      lflvsdi2a $p |- ( ph
  -> ( G oF .x. ( V X. { ( X .+ Y ) } ) )
       = ( ( G oF .x. ( V X. { X } ) ) oF .+ ( G oF .x. ( V X. { Y } ) ) ) ) $=
        ( csn cxp cof co cvv wcel cbs fvex eqeltri ofc12 oveq2d lflvsdi2 eqtr3d
        cfv a1i ) AFHJUBUCZHKUBUCZBUDZUEZDUDZUEFHJKBUEUBUCZVAUEFUQVAUEFURVAUEUS
        UEAUTVBFVAAHJKBUFGGHUFUGAHIUHUOUFLIUHUIUJUPSTUKULABCDEFGHIJKLMNOPQRSTUA
        UMUN $.
    $}
  $}

  ${
    $d x y z G $.  $d x y z K $.  $d x y z .x. $.  $d x y z V $.  $d x y z X $.
    $d x y z Y $.  $d x y z ph $.
    lflass.v $e |- V = ( Base ` W ) $.
    lflass.r $e |- R = ( Scalar ` W ) $.
    lflass.k $e |- K = ( Base ` R ) $.
    lflass.t $e |- .x. = ( .r ` R ) $.
    lflass.f $e |- F = ( LFnl ` W ) $.
    lflass.w $e |- ( ph -> W e. LMod ) $.
    lflass.x $e |- ( ph -> X e. K ) $.
    lflass.y $e |- ( ph -> Y e. K ) $.
    lflass.g $e |- ( ph -> G e. F ) $.
    $( Associative law for (right vector space) scalar product of functionals.
       (Contributed by NM, 19-Oct-2014.) $)
    lflvsass $p |- ( ph
  -> ( G oF .x. ( V X. { ( X .x. Y ) } ) )
           = ( ( G oF .x. ( V X. { X } ) ) oF .x. ( V X. { Y } ) ) ) $=
      ( co vx vy vz csn cxp cof cvv wcel cbs cfv fvex eqeltri a1i clmod wf lflf
      syl2anc fconst6g syl crg cv w3a lmodrng rngass sylan caofass ofc12 oveq2d
      wceq eqtr2d ) AEGIUDUEZCUFZTGJUDUEZVLTEVKVMVLTZVLTEGIJCTUDUEZVLTAUAUBUCGC
      CFCEVKVMCUGGUGUHAGHUIUJUGKHUIUKULUMZAHUNUHZEDUHGFEUOPSBDEFGHUNLMKOUPUQAIF
      UHGFVKUOQGIFURUSAJFUHGFVMUORGJFURUSABUTUHZUAVAZFUHUBVAZFUHUCVAZFUHVBVSVTC
      TWACTVSVTWACTCTVIAVQVRPBHLVCUSFBCVSVTWAMNVDVEVFAVNVOEVLAGIJCUGFFVPQRVGVHV
      J $.
  $}

  ${
    $d k G $.  $d k K $.  $d k .0. $.  $d k .x. $.  $d k ph $.
    lfl0sc.v $e |- V = ( Base ` W ) $.
    lfl0sc.d $e |- D = ( Scalar ` W ) $.
    lfl0sc.f $e |- F = ( LFnl ` W ) $.
    lfl0sc.k $e |- K = ( Base ` D ) $.
    lfl0sc.t $e |- .x. = ( .r ` D ) $.
    lfl0sc.o $e |- .0. = ( 0g ` D ) $.
    lfl0sc.w $e |- ( ph -> W e. LMod ) $.
    lfl0sc.g $e |- ( ph -> G e. F ) $.
    $( The (right vector space) scalar product of a functional with zero is the
       zero functional.  Note that the first occurrence of ` ( V X. { .0. } ) `
       represents the zero scalar, and the second is the zero functional.
       (Contributed by NM, 7-Oct-2014.) $)
    lfl0sc $p |- ( ph
      -> ( G oF .x. ( V X. { .0. } ) ) = ( V X. { .0. } ) ) $=
      ( vk cvv wcel cbs cfv fvex eqeltri a1i clmod lflf syl2anc crg lmodrng syl
      wf rng0cl cv co wceq rngrz sylan caofid1 ) ARGIICFESFFGSTAGHUAUBSJHUAUCUD
      UEAHUFTZEDTGFEULPQBDEFGHUFKMJLUGUHABUITZIFTAUTVAPBHKUJUKZFBIMOUMUKZVCAVAR
      UNZFTVDICUOIUPVBFBCVDIMNOUQURUS $.
  $}

  ${
    lflsc0.v $e |- V = ( Base ` W ) $.
    lflsc0.d $e |- D = ( Scalar ` W ) $.
    lflsc0.k $e |- K = ( Base ` D ) $.
    lflsc0.t $e |- .x. = ( .r ` D ) $.
    lflsc0.o $e |- .0. = ( 0g ` D ) $.
    lflsc0.w $e |- ( ph -> W e. LMod ) $.
    lflsc0.x $e |- ( ph -> X e. K ) $.
    $( The scalar product with the zero functional is the zero functional.
       (Contributed by NM, 7-Oct-2014.)  (New usage is discouraged.) $)
    lflsc0N $p |- ( ph
      -> ( ( V X. { .0. } ) oF .x. ( V X. { X } ) ) = ( V X. { .0. } ) ) $=
      ( csn cxp co cvv wcel cof cbs cfv fvex eqeltri a1i crg lmodrng syl rng0cl
      clmod ofc12 wceq rnglz syl2anc sneqd xpeq2d eqtrd ) AEHPZQZEGPQCUAREHGCRZ
      PZQUTAEHGCSDDESTAEFUBUCSIFUBUDUEUFABUGTZHDTAFUKTVCNBFJUHUIZDBHKMUJUIOULAV
      BUSEAVAHAVCGDTVAHUMVDODBCGHKLMUNUOUPUQUR $.
  $}

  ${
    $d k G $.  $d k K $.  $d k .1. $.  $d k .x. $.  $d k ph $.
    lfl1sc.v $e |- V = ( Base ` W ) $.
    lfl1sc.d $e |- D = ( Scalar ` W ) $.
    lfl1sc.f $e |- F = ( LFnl ` W ) $.
    lfl1sc.k $e |- K = ( Base ` D ) $.
    lfl1sc.t $e |- .x. = ( .r ` D ) $.
    lfl1sc.i $e |- .1. = ( 1r ` D ) $.
    lfl1sc.w $e |- ( ph -> W e. LMod ) $.
    lfl1sc.g $e |- ( ph -> G e. F ) $.
    $( The (right vector space) scalar product of a functional with one is the
       functional.  (Contributed by NM, 21-Oct-2014.) $)
    lfl1sc $p |- ( ph
      -> ( G oF .x. ( V X. { .1. } ) ) = G ) $=
      ( vk cvv wcel cbs cfv fvex eqeltri a1i clmod wf lflf syl2anc cur crg wceq
      cv co lmodrng syl rngridm sylan caofid0r ) ARHDCGFSSHSTAHIUAUBSJIUAUCUDUE
      AIUFTZFETHGFUGPQBEFGHIUFKMJLUHUIDSTADBUJUBSOBUJUCUDUEABUKTZRUMZGTVBDCUNVB
      ULAUTVAPBIKUOUPGBCDVBMNOUQURUS $.
  $}

  $c LKer $.

  $( Extend class notation with the kernel of a functional (set of vectors
     whose functional value is zero) on a left module or left vector space. $)
  clk $a class LKer $.

  ${
    $d w f x $.
    $( Define the kernel of a functional (set of vectors whose functional value
       is zero) on a left module or left vector space.  (Contributed by NM,
       15-Apr-2014.) $)
    df-lkr $a |- LKer = ( w e. _V |-> ( f e. ( LFnl ` w )
      |-> ( `' f " { ( 0g ` ( Scalar ` w ) ) } ) ) ) $.
  $}

  ${
    $d f w F $.  $d w .0. $.  $d f w x W $.
    lkrfval.d $e |- D = ( Scalar ` W ) $.
    lkrfval.o $e |- .0. = ( 0g ` D ) $.
    lkrfval.f $e |- F = ( LFnl ` W ) $.
    lkrfval.k $e |- K = ( LKer ` W ) $.
    $( The kernel of a functional.  (Contributed by NM, 15-Apr-2014.)  (Revised
       by Mario Carneiro, 24-Jun-2014.) $)
    lkrfval $p |- ( W e. X -> K = ( f e. F |-> ( `' f " { .0. } ) ) ) $=
      ( vw wcel cvv cv cfv clfn csca c0g syl6eqr ccnv cima cmpt wceq elex fveq2
      csn fveq2d sneqd imaeq2d mpteq12dv df-lkr fvex eqeltri mptex fvmpt syl5eq
      clk syl ) EFMENMZDBCBOUAZGUGZUBZUCZUDEFUEUTDEURPVDKLEBLOZQPZVAVERPZSPZUGZ
      UBZUCVDNURVEEUDZBVFVJCVCVKVFEQPZCVEEQUFJTVKVIVBVAVKVHGVKVHASPGVKVGASVKVGE
      RPAVEERUFHTUHITUIUJUKLBULBCVCCVLNJEQUMUNUOUPUQUS $.

    $d f G $.  $d f .0. $.
    $( Value of the kernel of a functional.  (Contributed by NM,
       15-Apr-2014.) $)
    lkrval $p |- ( ( W e. X /\ G e. F )
            -> ( K ` G ) = ( `' G " { .0. } ) ) $=
      ( vf wcel cfv cv ccnv csn cima cvv wceq cmpt lkrfval fveq1d cnvexg imaexg
      syl cnveq imaeq1d eqid fvmptg mpdan sylan9eq ) EFMZCBMZCDNCLBLOZPZGQZRZUA
      ZNZCPZUQRZUMCDUSALBDEFGHIJKUBUCUNVBSMZUTVBTUNVASMVCCBUDVAUQSUEUFLCURVBBSU
      SUOCTUPVAUQUOCUGUHUSUIUJUKUL $.
  $}

  ${
    lkrfval2.v $e |- V = ( Base ` W ) $.
    lkrfval2.d $e |- D = ( Scalar ` W ) $.
    lkrfval2.o $e |- .0. = ( 0g ` D ) $.
    lkrfval2.f $e |- F = ( LFnl ` W ) $.
    lkrfval2.k $e |- K = ( LKer ` W ) $.
    $( Membership in the kernel of a functional.  ( ~ elnlfn analog.)
       (Contributed by NM, 16-Apr-2014.) $)
    ellkr $p |- ( ( W e. Y /\ G e. F )
       -> ( X e. ( K ` G ) <-> ( X e. V /\ ( G ` X ) = .0. ) ) ) $=
      ( wcel wa cfv ccnv csn cima wceq lkrval eleq2d cbs wfn eqid lflf elpreima
      wf wb ffn 3syl fvex elsnc anbi2i syl6bb bitrd ) FHOCBOPZGCDQZOGCRISZTZOZG
      EOZGCQZIUAZPZURUSVAGABCDFHIKLMNUBUCURVBVCVDUTOZPZVFUREAUDQZCUICEUEVBVHUJA
      BCVIEFHKVIUFJMUGEVICUKEGUTCUHULVGVEVCVDIGCUMUNUOUPUQ $.

    $d x F $.  $d x G $.  $d x K $.  $d x W $.
    $( Value of the kernel of a functional.  (Contributed by NM,
       15-Apr-2014.) $)
    lkrval2 $p |- ( ( W e. X /\ G e. F ) ->
             ( K ` G ) = { x e. V | ( G ` x ) = .0. } ) $=
      ( wcel cvv cfv cv wceq wa crab elex ellkr abbi2dv df-rab syl6eqr sylan
      cab ) GHOGPOZDCOZDEQZARZDQISZAFUAZSGHUBUIUJTZUKULFOUMTZAUHUNUOUPAUKBCDEFG
      ULPIJKLMNUCUDUMAFUEUFUG $.

    ellkr2.w $e |- ( ph -> W e. Y ) $.
    ellkr2.g $e |- ( ph -> G e. F ) $.
    ellkr2.x $e |- ( ph -> X e. V ) $.
    $( Membership in the kernel of a functional.  (Contributed by NM,
       12-Jan-2015.) $)
    ellkr2 $p |- ( ph -> ( X e. ( K ` G ) <-> ( G ` X ) = .0. ) ) $=
      ( cfv wcel wceq wa wb ellkr syl2anc biantrurd bitr4d ) AHDESTZHFTZHDSJUAZ
      UBZUJAGITDCTUHUKUCPQBCDEFGHIJKLMNOUDUEAUIUJRUFUG $.
  $}

  ${
    lkrcl.v $e |- V = ( Base ` W ) $.
    lkrcl.f $e |- F = ( LFnl ` W ) $.
    lkrcl.k $e |- K = ( LKer ` W ) $.
    $( A member of the kernel of a functional is a vector.  (Contributed by NM,
       16-Apr-2014.) $)
    lkrcl $p |- ( ( W e. Y /\ G e. F /\ X e. ( K ` G ) ) -> X e. V ) $=
      ( wcel cfv wa csca c0g wceq eqid ellkr simprbda 3impa ) EGKZBAKZFBCLKZFDK
      ZUAUBMUCUDFBLENLZOLZPUEABCDEFGUFHUEQUFQIJRST $.
  $}

  ${
    lkrf0.d $e |- D = ( Scalar ` W ) $.
    lkrf0.o $e |- .0. = ( 0g ` D ) $.
    lkrf0.f $e |- F = ( LFnl ` W ) $.
    lkrf0.k $e |- K = ( LKer ` W ) $.
    $( The value of a functional at a member of its kernel is zero.
       (Contributed by NM, 16-Apr-2014.) $)
    lkrf0 $p |- ( ( W e. Y /\ G e. F /\ X e. ( K ` G ) )
          -> ( G ` X ) = .0. ) $=
      ( wcel cfv wceq wa cbs eqid ellkr simplbda 3impa ) EGMZCBMZFCDNMZFCNHOZUB
      UCPUDFEQNZMUEABCDUFEFGHUFRIJKLSTUA $.
  $}

  ${
    lkr0f.d $e |- D = ( Scalar ` W ) $.
    lkr0f.o $e |- .0. = ( 0g ` D ) $.
    lkr0f.v $e |- V = ( Base ` W ) $.
    lkr0f.f $e |- F = ( LFnl ` W ) $.
    lkr0f.k $e |- K = ( LKer ` W ) $.
    $( The kernel of the zero functional is the set of all vectors.
       (Contributed by NM, 17-Apr-2014.) $)
    lkr0f $p |- ( ( W e. LMod /\ G e. F )
             -> ( ( K ` G ) = V <-> G = ( V X. { .0. } ) ) ) $=
      ( clmod wcel wa cfv wceq wf eqid adantr csn cxp wfn ccnv cima cbs ffn syl
      lflf lkrval eqeq1d biimpa c0g cvv eqeltri fconst2 fconst4 bitr3i sylanbrc
      fvex ex wi biimpi adantl clfn simpr lfl0f eqeltrd syldan sylbir biantrurd
      bitrd mpbird impbid ) FMNZCBNZOZCDPZEQZCEGUAZUBZQZVQVSWBVQVSOCEUCZCUDVTUE
      ZEQZWBVQWCVSVQEAUFPZCRWCABCWFEFMHWFSJKUIEWFCUGUHTVQVSWEVQVRWDEABCDFMGHIKL
      UJUKULWBEVTCRZWCWEOZEGCGAUMPUNIAUMUTUOUPZEGCUQURZUSVAVOWBVSVBVPVOWBVSVOWB
      OZVSWHWBWHVOWBWHWJVCVDWKVSWEWHWKVRWDEVOWBCFVEPZNVRWDQWKCWAWLVOWBVFVOWAWLN
      WBAWLEFGHIJWLSZVGTVHAWLCDFMGHIWMLUJVIUKWKWCWEWBWCVOWBWGWCWIEVTCUGVJVDVKVL
      VMVATVN $.
  $}

  ${
    $d r x y F $.  $d r x y G $.  $d r x y K $.  $d r x y W $.
    lkrlss.f $e |- F = ( LFnl ` W ) $.
    lkrlss.k $e |- K = ( LKer ` W ) $.
    lkrlss.s $e |- S = ( LSubSp ` W ) $.
    $( The kernel of a linear functional is a subspace.  ( ~ nlelshi analog.)
       (Contributed by NM, 16-Apr-2014.) $)
    lkrlss $p |- ( ( W e. LMod /\ G e. F ) -> ( K ` G ) e. S ) $=
      ( vr vx vy clmod wcel wa cfv co wceq eqid syl syl3anc cbs wss c0 cv cvsca
      wne cplusg wral csca c0g crab lkrval2 ssrab2 syl6eqss lmod0vcl lfl0 ellkr
      adantr mpbir2and ne0i simplll simplr simpllr simprl lkrcl lmodvscl simprr
      lmodvacl cmulr syl113anc lkrf0 oveq2d lmodrng rngrz syl2anc eqtrd oveq12d
      lfli cgrp lmodfgrp grpidcl grplid 3eqtrd wb ad2antrr ralrimivva ralrimiva
      crg islss syl3anbrc ) ELMZCBMZNZCDOZEUAOZUBWNUCUFZIUDZJUDZEUEOZPZKUDZEUGO
      ZPZWNMZKWNUHJWNUHZIEUIOZUAOZUHWNAMWMWNWRCOZXFUJOZQZJWOUKWOJXFBCDWOELXIWOR
      ZXFRZXIRZFGULXJJWOUMUNWMEUJOZWNMZWPWMXOXNWOMZXNCOXIQWKXPWLWOEXNXKXNRZUOUR
      XFBCEXIXNXLXMXQFUPXFBCDWOEXNLXIXKXLXMFGUQUSWNXNUTSWMXEIXGWMWQXGMZNZXDJKWN
      WNXSWRWNMZXAWNMZNZNZXDXCWOMZXCCOZXIQZYCWKWTWOMZXAWOMZYDWKWLXRYBVAZYCWKXRW
      RWOMZYGYIWMXRYBVBZYCWKWLXTYJYIWKWLXRYBVCZXSXTYAVDZBCDWOEWRLXKFGVETZWQWSXF
      XGWOEWRXKXLWSRZXGRZVFTYCWKWLYAYHYIYLXSXTYAVGZBCDWOEXALXKFGVETZXBWOEWTXAXK
      XBRZVHTYCYEWQXHXFVIOZPZXACOZXFUGOZPZXIXIUUCPZXIYCWKWLXRYJYHYEUUDQYIYLYKYN
      YRXFXBUUCWQWSYTBCXGWOEWRXALXKYSXLYOYPUUCRZYTRZFVRVJYCUUAXIUUBXIUUCYCUUAWQ
      XIYTPZXIYCXHXIWQYTYCWKWLXTXJYIYLYMXFBCDEWRLXIXLXMFGVKTVLYCXFWHMZXRUUHXIQY
      CWKUUIYIXFEXLVMSYKXGXFYTWQXIYPUUGXMVNVOVPYCWKWLYAUUBXIQYIYLYQXFBCDEXALXIX
      LXMFGVKTVQYCXFVSMZXIXGMZUUEXIQYCWKUUJYIXFEXLVTSZYCUUJUUKUULXGXFXIYPXMWASX
      GUUCXFXIXIYPUUFXMWBVOWCWMXDYDYFNWDXRYBXFBCDWOEXCLXIXKXLXMFGUQWEUSWFWGIXGX
      BAWSWNXFWOEJKXLYPXKYSYOHWIWJ $.
  $}

  ${
    lkrssv.v $e |- V = ( Base ` W ) $.
    lkrssv.f $e |- F = ( LFnl ` W ) $.
    lkrssv.k $e |- K = ( LKer ` W ) $.
    lkrssv.w $e |- ( ph -> W e. LMod ) $.
    lkrssv.g $e |- ( ph -> G e. F ) $.
    $( The kernel of a linear functional is a set of vectors.  (Contributed by
       NM, 1-Jan-2015.) $)
    lkrssv $p |- ( ph -> ( K ` G ) C_ V ) $=
      ( cfv clss wcel wss clmod eqid lkrlss syl2anc lssss syl ) ACDLZFMLZNZUBEO
      AFPNCBNUDJKUCBCDFHIUCQZRSUCUBEFGUETUA $.
  $}

  ${
    $d v G $.  $d v L $.  $d v R $.  $d v .x. $.  $d v V $.  $d v ph $.
    lkrsc.v $e |- V = ( Base ` W ) $.
    lkrsc.d $e |- D = ( Scalar ` W ) $.
    lkrsc.k $e |- K = ( Base ` D ) $.
    lkrsc.t $e |- .x. = ( .r ` D ) $.
    lkrsc.f $e |- F = ( LFnl ` W ) $.
    lkrsc.l $e |- L = ( LKer ` W ) $.
    lkrsc.w $e |- ( ph -> W e. LVec ) $.
    lkrsc.g $e |- ( ph -> G e. F ) $.
    lkrsc.r $e |- ( ph -> R e. K ) $.
    ${
      lkrsc.o $e |- .0. = ( 0g ` D ) $.
      lkrsc.e $e |- ( ph -> R =/= .0. ) $.
      $( The kernel of a non-zero scalar product of a functional equals the
         kernel of the functional.  (Contributed by NM, 9-Oct-2014.) $)
      lkrsc $p |- ( ph -> ( L ` ( G oF .x. ( V X. { R } ) ) ) = ( L ` G ) ) $=
        ( vv csn cxp cof co cfv cv wcel wceq wa cvv cbs fvex eqeltri a1i wf wfn
        clvec lflf syl2anc ffn syl eqidd eqeq1d cdr lvecdrng adantr simpr lflcl
        ofc2 syl3anc wne drngmuleq0 bitrd pm5.32da clmod lveclmod lflvscl ellkr
        wb 3bitr4d eqrdv ) AUCFICUDUEDUFUGZHUHZFHUHZAUCUIZIUJZWHWEUHZKUKZULZWIW
        HFUHZKUKZULZWHWFUJZWHWGUJZAWIWKWNAWIULZWKWMCDUGZKUKWNWRWJWSKAICWMDFUMGW
        HIUMUJAIJUNUHUMLJUNUOUPUQTAIGFURZFIUSAJUTUJZFEUJZWTRSBEFGIJUTMNLPVAVBIG
        FVCVDWRWMVEVLVFWRGBDWMCKNUAOABVGUJZWIAXAXCRBJMVHVDVIWRXAXBWIWMGUJAXAWIR
        VIAXBWISVIAWIVJBEFGIJWHUTMNLPVKVMACGUJWITVIACKVNWIUBVIVOVPVQAXAWEEUJWPW
        LWBRABCDEFGIJLMNOPAXAJVRUJRJVSVDSTVTBEWEHIJWHUTKLMUAPQWAVBAXAXBWQWOWBRS
        BEFHIJWHUTKLMUAPQWAVBWCWD $.
    $}

    $( The kernel of a scalar product of a functional includes the kernel of
       the functional.  (The inclusion is proper for the zero product and
       equality otherwise.)  (Contributed by NM, 9-Oct-2014.) $)
    lkrscss $p |- ( ph -> ( L ` G ) C_ ( L ` ( G oF .x. ( V X. { R } ) ) ) ) $=
      ( cfv csn cxp cof co wss c0g wceq wa clvec wcel clmod lveclmod syl lkrssv
      eqid lfl0sc fveq2d lfl0f syl2anc mpbiri eqtr2d sseqtrd adantr sneq xpeq2d
      wb lkr0f oveq2d adantl sseqtr4d wne simpr lkrsc eqimss2 pm2.61dane ) AFHT
      ZFICUAZUBZDUCZUDZHTZUEZCBUFTZACWCUGZUHVPFIWCUAZUBZVSUDZHTZWAAVPWHUEWDAVPI
      WHAEFHIJKOPAJUIUJZJUKUJZQJULUMZRUNAWHWFHTZIAWGWFHABDEFGIJWCKLOMNWCUOZWKRU
      PUQAWLIUGZWFWFUGZWFUOAWJWFEUJZWNWOVFWKAWJWPWKBEIJWCLWMKOURUMBEWFHIJWCLWMK
      OPVGUSUTVAVBVCWDWAWHUGAWDVTWGHWDVRWFFVSWDVQWEICWCVDVEVHUQVIVJACWCVKZUHZWA
      VPUGWBWRBCDEFGHIJWCKLMNOPAWIWQQVCAFEUJWQRVCACGUJWQSVCWMAWQVLVMVPWAVNUMVO
      $.
  $}

  ${
    $d r x z D $.  $d x z F $.  $d r x z G $.  $d r x z H $.  $d r x z V $.
    $d r z K $.  $d x z L $.  $d r z .x. $.  $d x z W $.
    eqlkr.d $e |- D = ( Scalar ` W ) $.
    eqlkr.k $e |- K = ( Base ` D ) $.
    eqlkr.t $e |- .x. = ( .r ` D ) $.
    eqlkr.v $e |- V = ( Base ` W ) $.
    eqlkr.f $e |- F = ( LFnl ` W ) $.
    eqlkr.l $e |- L = ( LKer ` W ) $.
    $( Two functionals with the same kernel are the same up to a constant.
       (Contributed by NM, 18-Apr-2014.) $)
    eqlkr $p |- ( ( W e. LVec /\ ( G e. F /\ H e. F )
           /\ ( L ` G ) = ( L ` H ) )
      -> E. r e. K A. x e. V ( H ` x ) = ( ( G ` x ) .x. r ) ) $=
      ( wcel cfv wceq vz clvec wa w3a cv co wral wrex c0g csn cxp cur crg clmod
      simpl1 lveclmod lmodrng eqid rngidcl simp11 simp12l simp3 syl3anc rngridm
      syl lflcl syl2anc simp2 simp13 wb lkr0f mpbird eqtr3d mpbid eqtr4d fveq1d
      simp12r eqtr2d 3expia ralrimiv oveq2 eqeq2d ralbidv rspcev wne simpr lfl1
      simpl2l wi simpl2r simpr2 csg cvsca simp22 lflmul syl112anc oveq2d lflsub
      lmodvscl lmodvsubcl simp23 cgrp lmodfgrp grpsubid ellkr mpbir2and eleqtrd
      3eqtrd simprd 3adant3 lmodmcl grpsubeq0 3exp2 imp rexlimdv mpd pm2.61dane
      ) JUBRZEDRZFDRZUCZEHSZFHSZTZUDZAUEZFSZYFESZKUEZCUFZTZAIUGZKGUHZEIBUISZUJU
      KZYEEYOTZUCZBULSZGRZYGYHYRCUFZTZAIUGZYMYQBUMRZYSYQXRUUCXRYAYDYPUOXRJUNRZU
      UCJUPZBJLUQVEZVEGBYRMYRURZUSVEYQUUAAIYEYPYFIRZUUAYEYPUUHUDZYTYHYGUUIUUCYH
      GRZYTYHTZUUIXRUUCXRYAYDYPUUHUTZUUFVEUUIXRXSUUHUUJUULXSXTXRYDYPUUHVAZYEYPU
      UHVBBDEGIJYFUBLMOPVFZVCGBCYRYHMNUUGVDZVGUUIYFEFUUIEYOFYEYPUUHVHZUUIYCITZF
      YOTZUUIYBYCIXRYAYDYPUUHVIUUIYBITZYPUUPUUIUUDXSUUSYPVJUUIXRUUDUULUUEVEZUUM
      BDEHIJYNLYNURZOPQVKVGVLVMUUIUUDXTUUQUURVJUUTXSXTXRYDYPUUHVQBDFHIJYNLUVAOP
      QVKVGVNVOVPVRVSVTYLUUBKYRGYIYRTZYKUUAAIUVBYJYTYGYIYRYHCWAWBWCWDVGYEEYOWEZ
      UCZUAUEZESZYRTZUAIUHZYMUVDXRXSUVCUVHXRYAYDUVCUOXSXTXRYDUVCWHYEUVCWFUABYRD
      EIJYNLUVAUUGOPWGVCUVDUVGYMUAIYEUVCUVEIRZUVGYMWIWIYEUVCUVIUVGYMYEUVCUVIUVG
      UDZUCZUVEFSZGRZYGYHUVLCUFZTZAIUGZYMUVKXRXTUVIUVMXRYAYDUVJUOXSXTXRYDUVJWJY
      EUVCUVIUVGWKBDFGIJUVEUBLMOPVFVCZUVKUVOAIYEUVJUUHUVOYEUVJUUHUDZYGUVNBWLSZU
      FZYNTZUVOUVRYGYHUVEJWMSZUFZFSZUVSUFZUVTYNUVRUWDUVNYGUVSUVRUUDXTUUJUVIUWDU
      VNTUVRXRUUDXRYAYDUVJUUHUTZUUEVEZXSXTXRYDUVJUUHVQZUVRUUDXSUUHUUJUWGXSXTXRY
      DUVJUUHVAZYEUVJUUHVBZBDEGIJYFUNLMOPVFVCZYEUVCUVIUVGUUHWNZBYHUWBCDFGIJUVEL
      MNOUWBURZPWOWPWQUVRYFUWCJWLSZUFZFSZUWEYNUVRUUDXTUUHUWCIRZUWPUWETUWGUWHUWJ
      UVRUUDUUJUVIUWQUWGUWKUWLYHUWBBGIJUVEOLUWMMWSVCZBDFUVSUWNIJYFUWCLUVSURZOUW
      NURZPWRWPUVRUWOIRZUWPYNTZUVRUWOYCRZUXAUXBUCZUVRUWOYBYCUVRUWOYBRZUXAUWOESZ
      YNTZUVRUUDUUHUWQUXAUWGUWJUWRUWNIJYFUWCOUWTWTVCUVRUXFYHUWCESZUVSUFZYHYHUVS
      UFZYNUVRUUDXSUUHUWQUXFUXITUWGUWIUWJUWRBDEUVSUWNIJYFUWCLUWSOUWTPWRWPUVRUXH
      YHYHUVSUVRUXHYHUVFCUFZYTYHUVRUUDXSUUJUVIUXHUXKTUWGUWIUVRXRXSUUHUUJUWFUWIU
      WJUUNVCZUWLBYHUWBCDEGIJUVELMNOUWMPWOWPUVRUVFYRYHCYEUVCUVIUVGUUHXAWQUVRUUC
      UUJUUKUVRXRUUCUWFUUFVEUXLUUOVGXHWQUVRBXBRZUUJUXJYNTUVRXRUXMUWFXRUUDUXMUUE
      BJLXCVEVEZUXLGBUVSYHYNMUVAUWSXDVGXHUVRXRXSUXEUXAUXGUCVJUWFUWIBDEHIJUWOUBY
      NOLUVAPQXEVGXFXRYAYDUVJUUHVIXGUVRXRXTUXCUXDVJUWFUWHBDFHIJUWOUBYNOLUVAPQXE
      VGVNXIVMVMUVRUXMYGGRZUVNGRZUWAUVOVJUXNUVRXRXTUUHUXOUWFUWHUWJBDFGIJYFUBLMO
      PVFVCUVRUUDUUJUVMUXPUWGUXLYEUVJUVMUUHUVQXJCBGJYHUVLLMNXKVCGBUVSYGUVNYNMUV
      AUWSXLVCVNVSVTYLUVPKUVLGYIUVLTZYKUVOAIUXQYJUVNYGYIUVLYHCWAWBWCWDVGXMXNXOX
      PXQ $.

    $d r F $.  $d x K $.  $d r L $.  $d x .x. $.  $d r W $.
    $( Two functionals with the same kernel are the same up to a constant.
       (Contributed by NM, 10-Oct-2014.) $)
    eqlkr2 $p |- ( ( W e. LVec /\ ( G e. F /\ H e. F )
           /\ ( L ` G ) = ( L ` H ) )
      -> E. r e. K H = ( G oF .x. ( V X. { r } ) ) ) $=
      ( vx wcel cfv cvv clvec wa wceq w3a cv csn cxp cof co wrex wral eqlkr cbs
      fvex eqeltri a1i wf wfn simpl1 simpl2l lflf syl2anc ffn syl fnconstg mp1i
      vex simpl2r eqidd fvconst2 adantl offveqb rexbidva mpbird ) IUARZDCRZECRZ
      UBZDGSEGSUCZUDZEDHJUEZUFUGZBUHUIUCZJFUJQUEZESWDDSZWABUIUCQHUKZJFUJQABCDEF
      GHIJKLMNOPULVTWCWFJFVTWAFRZUBZQHWEWABDWBETHTRWHHIUMSTNIUMUNUOUPWHHFDUQZDH
      URWHVOVPWIVOVRVSWGUSZVPVQVOVSWGUTACDFHIUAKLNOVAVBHFDVCVDWATRWBHURWHJVGZHW
      ATVEVFWHHFEUQZEHURWHVOVQWLWJVPVQVOVSWGVHACEFHIUAKLNOVAVBHFEVCVDWHWDHRZUBW
      EVIWMWDWBSWAUCWHHWAWDWKVJVKVLVMVN $.
  $}

  ${
    $d x F $.  $d r x G $.  $d r x H $.  $d x K $.  $d r R $.  $d r x S $.
    $d r x V $.  $d x W $.  $d x X $.  $d r x ph $.
    eqlkr3.v $e |- V = ( Base ` W ) $.
    eqlkr3.s $e |- S = ( Scalar ` W ) $.
    eqlkr3.r $e |- R = ( Base ` S ) $.
    eqlkr3.o $e |- .0. = ( 0g ` S ) $.
    eqlkr3.f $e |- F = ( LFnl ` W ) $.
    eqlkr3.k $e |- K = ( LKer ` W ) $.
    eqlkr3.w $e |- ( ph -> W e. LVec ) $.
    eqlkr3.x $e |- ( ph -> X e. V ) $.
    eqlkr3.g $e |- ( ph -> G e. F ) $.
    eqlkr3.h $e |- ( ph -> H e. F ) $.
    eqlkr3.e $e |- ( ph -> ( K ` G ) = ( K ` H ) ) $.
    eqlkr3.a $e |- ( ph -> ( G ` X ) = ( H ` X ) ) $.
    eqlkr3.n $e |- ( ph -> ( G ` X ) =/= .0. ) $.
    $( Two functionals with the same kernel are equal if they are equal at any
       nonzero value.  (Contributed by NM, 2-Jan-2015.) $)
    eqlkr3 $p |- ( ph -> G = H ) $=
      ( vx vr wf wfn clvec wcel lflf syl2anc ffn syl cv cfv cur cmulr wceq wral
      wa co wrex eqid eqlkr syl121anc wi adantr fveq2 eqeq12d rspcv cinvr simpr
      oveq1d eqtr2d cdr wne lvecdrng lflcl syl3anc drnginvrl crg clmod lveclmod
      oveq2d lmodrng drnginvrcl syl13anc rnglidm 3eqtr3d ex syld ancrd reximdva
      rngass mpd wb rngidcl oveq2 eqeq2d ralbidv ceqsrexv mpbid rngridm eqfnfvd
      r19.21bi ) AUEHEFAHBEUGZEHUHAIUIUJZEDUJZXGRTCDEBHIUIMNLPUKULHBEUMUNAHBFUG
      ZFHUHAXHFDUJZXJRUACDFBHIUIMNLPUKULHBFUMUNAUEUOZHUJZVAZXLFUPZXLEUPZCUQUPZC
      URUPZVBZXPAXOXSUSZUEHAUFUOZXQUSZXOXPYAXRVBZUSZUEHUTZVAZUFBVCZXTUEHUTZAYEU
      FBVCZYGAXHXIXKEGUPFGUPUSYIRTUAUBUECXRDEFBGHIUFMNXRVDZLPQVEVFAYEYFUFBAYABU
      JZVAZYEYBYLYEJFUPZJEUPZYAXRVBZUSZYBYLJHUJZYEYPVGAYQYKSVHYDYPUEJHXLJUSZXOY
      MYCYOXLJFVIYRXPYNYAXRXLJEVIVNVJVKUNYLYPYBYLYPVAZYNCVLUPZUPZYOXRVBZUUAYNXR
      VBZYAXQYSYOYNUUAXRYSYNYMYOYLYNYMUSZYPAUUDYKUCVHVHYLYPVMVOWEYLUUBYAUSYPYLU
      UCYAXRVBZXQYAXRVBZUUBYAYLUUCXQYAXRYLCVPUJZYNBUJZYNKVQZUUCXQUSZAUUGYKAXHUU
      GRCIMVRUNVHZAUUHYKAXHXIYQUUHRTSCDEBHIJUIMNLPVSVTVHZAUUIYKUDVHZBCXRXQYTYNK
      NOYJXQVDZYTVDZWAVTZVNYLCWBUJZUUABUJZUUHYKUUEUUBUSAUUQYKAIWCUJZUUQAXHUUSRI
      WDUNZCIMWFZUNZVHZYLUUGUUHUUIUURUUKUULUUMBCYTYNKNOUUOWGVTUULAYKVMZBCXRUUAY
      NYANYJWOWHYLUUQYKUUFYAUSUVCUVDBCXRXQYANYJUUNWIULWJVHYLUUJYPUUPVHWJWKWLWMW
      NWPAXQBUJZYGYHWQAUUQUVEUVBBCXQNUUNWRUNYEYHUFXQBYBYDXTUEHYBYCXSXOYAXQXPXRW
      SWTXAXBUNXCXFXNUUQXPBUJZXSXPUSXNUUSUUQAUUSXMUUTVHUVAUNXNXHXIXMUVFAXHXMRVH
      AXIXMTVHAXMVMCDEBHIXLUIMNLPVSVTBCXRXQXPNYJUUNXDULVOXE $.
  $}

  ${
    $d u F $.  $d u G $.  $d u K $.  $d u N $.  $d u V $.  $d u W $.  $d u X $.
    $d u .(+) $.  $d u .0. $.
    lkrlsp.d $e |- D = ( Scalar ` W ) $.
    lkrlsp.o $e |- .0. = ( 0g ` D ) $.
    lkrlsp.v $e |- V = ( Base ` W ) $.
    lkrlsp.n $e |- N = ( LSpan ` W ) $.
    lkrlsp.p $e |- .(+) = ( LSSum ` W ) $.
    lkrlsp.f $e |- F = ( LFnl ` W ) $.
    lkrlsp.k $e |- K = ( LKer ` W ) $.
    $( The subspace sum of a kernel and the span of a vector not in the kernel
       (by ~ ellkr ) is the whole vector space.  (Contributed by NM,
       19-Apr-2014.) $)
    lkrlsp $p |- ( ( W e. LVec /\ ( X e. V /\ G e. F )
        /\ ( G ` X ) =/= .0. ) -> ( ( K ` G ) .(+) ( N ` { X } ) ) = V ) $=
      ( wcel cfv co vu clvec wa wne w3a csn clss clmod lveclmod 3ad2ant1 simp2r
      wss eqid lkrlss syl2anc simp2l lspsncl lsmcl syl3anc lssss cv cinvr cmulr
      syl cvsca csg cplusg wceq simpl1 simpr cbs lmodrng simpl2r lflcl lvecdrng
      crg cdr simpl2l simpl3 drnginvrcl rngcl lmodvnpcan csubg lsssssubg adantr
      lmodvscl sseldd lmodvsubcl lflsub syl112anc lflmul syl13anc cur drnginvrl
      rngass oveq2d rngridm eqtrd 3eqtrd cgrp lmodfgrp grpsubid ellkr mpbir2and
      wb lspsneli lsmelvali syl22anc eqeltrrd ex ssrdv eqssd ) HUBRZIGRZDCRZUCZ
      IDSZJUDZUEZDESZIUFFSZBTZGXSYBHUGSZRZYBGULXSHUHRZXTYCRZYAYCRZYDXMXPYEXRHUI
      ZUJZXSYEXOYFYIXMXNXOXRUKYCCDEHPQYCUMZUNUOZXSYEXNYGYIXMXNXOXRUPYCFGHIMYJNU
      QUOZBYCXTYAHYJOURUSYCYBGHMYJUTVDXSUAGYBXSUAVAZGRZYMYBRXSYNUCZYMYMDSZXQAVB
      SZSZAVCSZTZIHVESZTZHVFSZTZUUBHVGSZTZYMYBYOYEYNUUBGRZUUFYMVHYOXMYEXMXPXRYN
      VIZYHVDZXSYNVJZYOYEYTAVKSZRZXNUUGUUIYOAVPRZYPUUKRZYRUUKRZUULYOYEUUMUUIAHK
      VLVDZYOXMXOYNUUNUUHXNXOXMXRYNVMZUUJACDUUKGHYMUBKUUKUMZMPVNUSZYOAVQRZXQUUK
      RZXRUUOYOXMUUTUUHAHKVOVDZYOXMXOXNUVAUUHUUQXNXOXMXRYNVRZACDUUKGHIUBKUURMPV
      NUSZXMXPXRYNVSZUUKAYQXQJUURLYQUMZVTUSZUUKAYSYPYRUURYSUMZWAUSZUVCYTUUAAUUK
      GHIMKUUAUMZUURWFUSZYMUUBUUEUUCGHMUUEUMZUUCUMZWBUSYOXTHWCSZRYAUVNRUUDXTRZU
      UBYARUUFYBRYOYCUVNXTYOYEYCUVNULUUIYCHYJWDVDZXSYFYNYKWEWGYOYCUVNYAUVPXSYGY
      NYLWEWGYOUVOUUDGRZUUDDSZJVHZYOYEYNUUGUVQUUIUUJUVKUUCGHYMUUBMUVMWHUSYOUVRY
      PUUBDSZAVFSZTZYPYPUWATZJYOYEXOYNUUGUVRUWBVHUUIUUQUUJUVKACDUWAUUCGHYMUUBKU
      WAUMZMUVMPWIWJYOUVTYPYPUWAYOUVTYTXQYSTZYPYRXQYSTZYSTZYPYOYEXOUULXNUVTUWEV
      HUUIUUQUVIUVCAYTUUAYSCDUUKGHIKUURUVHMUVJPWKWJYOUUMUUNUUOUVAUWEUWGVHUUPUUS
      UVGUVDUUKAYSYPYRXQUURUVHWOWLYOUWGYPAWMSZYSTZYPYOUWFUWHYPYSYOUUTUVAXRUWFUW
      HVHUVBUVDUVEUUKAYSUWHYQXQJUURLUVHUWHUMZUVFWNUSWPYOUUMUUNUWIYPVHUUPUUSUUKA
      YSUWHYPUURUVHUWJWQUOWRWSWPYOAWTRZUUNUWCJVHYOYEUWKUUIAHKXAVDUUSUUKAUWAYPJU
      URLUWDXBUOWSYOXMXOUVOUVQUVSUCXEUUHUUQACDEGHUUDUBJMKLPQXCUOXDYOYTUUAAUUKFG
      HIMUVJKUURNUUIUVIUVCXFUUEBXTYAHUUDUUBUVLOXGXHXIXJXKXL $.
  $}

  ${
    lkrlsp2.v $e |- V = ( Base ` W ) $.
    lkrlsp2.n $e |- N = ( LSpan ` W ) $.
    lkrlsp2.p $e |- .(+) = ( LSSum ` W ) $.
    lkrlsp2.f $e |- F = ( LFnl ` W ) $.
    lkrlsp2.k $e |- K = ( LKer ` W ) $.
    $( The subspace sum of a kernel and the span of a vector not in the kernel
       is the whole vector space.  (Contributed by NM, 12-May-2014.) $)
    lkrlsp2 $p |- ( ( W e. LVec /\ ( X e. V /\ G e. F )
        /\ -. X e. ( K ` G ) ) -> ( ( K ` G ) .(+) ( N ` { X } ) ) = V ) $=
      ( clvec wcel wa cfv wn wceq eqid c0g wne csn co w3a simp2l simp3 wb simp1
      simp2r ellkr syl2anc mpbir2and 3expia necon3bd 3impia lkrlsp syld3an3
      csca ) GNOZHFOZCBOZPZHCDQZOZRZHCQZGUSQZUAQZUBZVDHUCEQAUDFSUTVCVFVJUTVCPVE
      VGVIUTVCVGVISZVEUTVCVKUEZVEVAVKUTVAVBVKUFUTVCVKUGVLUTVBVEVAVKPUHUTVCVKUIU
      TVAVBVKUJVHBCDFGHNVIIVHTZVITZLMUKULUMUNUOUPVHABCDEFGHVIVMVNIJKLMUQUR $.
  $}

  ${
    lkrlsp3.v $e |- V = ( Base ` W ) $.
    lkrlsp3.n $e |- N = ( LSpan ` W ) $.
    lkrlsp3.f $e |- F = ( LFnl ` W ) $.
    lkrlsp3.k $e |- K = ( LKer ` W ) $.
    $( The subspace sum of a kernel and the span of a vector not in the kernel
       is the whole vector space.  (Contributed by NM, 29-Jun-2014.) $)
    lkrlsp3 $p |- ( ( W e. LVec /\ ( X e. V /\ G e. F )
        /\ -. X e. ( K ` G ) ) -> ( N ` ( ( K ` G ) u. { X } ) ) = V ) $=
      ( clvec wcel cfv cun wceq eqid syl2anc wss syl3anc wa wn w3a csn co clmod
      clsm clss lveclmod 3ad2ant1 simp2r lkrlss lspid uneq1d fveq2d snssd lspun
      lkrssv simp2l lspsncl lsmsp 3eqtr4d lkrlsp2 eqtrd ) FLMZGEMZBAMZUAZGBCNZM
      UBZUCZVIGUDZODNZVIVLDNZFUGNZUEZEVKVIDNZVNOZDNZVIVNOZDNZVMVPVKVRVTDVKVQVIV
      NVKFUFMZVIFUHNZMZVQVIPVEVHWBVJFUIUJZVKWBVGWDWEVEVFVGVJUKZWCABCFJKWCQZULRZ
      WCVIDFWGIUMRUNUOVKWBVIESVLESVMVSPWEVKABCEFHJKWEWFURVKGEVEVFVGVJUSZUPVIVLD
      EFHIUQTVKWBWDVNWCMZVPWAPWEWHVKWBVFWJWEWIWCDEFGHWGIUTRVOWCVIVNDFWGIVOQZVAT
      VBVOABCDEFGHIWKJKVCVD $.
  $}

  ${
    $d v .0. $.  $d v D $.  $d v F $.  $d v G $.  $d v K $.  $d v V $.
    $d v W $.
    lkrshp.v $e |- V = ( Base ` W ) $.
    lkrshp.d $e |- D = ( Scalar ` W ) $.
    lkrshp.z $e |- .0. = ( 0g ` D ) $.
    lkrshp.h $e |- H = ( LSHyp ` W ) $.
    lkrshp.f $e |- F = ( LFnl ` W ) $.
    lkrshp.k $e |- K = ( LKer ` W ) $.
    $( The kernel of a nonzero functional is a hyperplane.  (Contributed by NM,
       29-Jun-2014.) $)
    lkrshp $p |- ( ( W e. LVec /\ G e. F /\ G =/= ( V X. { .0. } ) )
          -> ( K ` G ) e. H ) $=
      ( vv clvec wcel wne cfv wceq csn cxp w3a clss cv cun clspn clmod lveclmod
      wrex 3ad2ant1 simp2 eqid lkrlss syl2anc simp3 lkr0f necon3bid mpbird lfl1
      wb cur wn simp11 simp12 cdr lvecdrng drngunz 3syl eqnetrd simpl11 simpl12
      simpr lkrf0 syl3anc necon3ad mpd lkrlsp3 syl121anc 3expia reximdva islshp
      wa ex mpbir3and ) GPQZCBQZCFHUAUBZRZUCZCESZDQZWKGUDSZQZWKFRZWKOUEZUAUFGUG
      SZSFTZOFUJZWJGUHQZWGWNWFWGWTWIGUIUKZWFWGWIULZWMBCEGMNWMUMZUNUOWJWOWIWFWGW
      IUPWJWKFCWHWJWTWGWKFTCWHTVAXAXBABCEFGHJKIMNUQUOURUSWJWPCSZAVBSZTZOFUJWSOA
      XEBCFGHJKXEUMZIMUTWJXFWROFWJWPFQZXFWRWJXHXFUCZWFXHWGWPWKQZVCZWRWFWGWIXHXF
      VDZWJXHXFULWFWGWIXHXFVEXIXDHRXKXIXDXEHWJXHXFUPXIWFAVFQXEHRXLAGJVGAXEHKXGV
      HVIVJXIXJXDHXIXJXDHTZXIXJWCWFWGXJXMWFWGWIXHXFXJVKWFWGWIXHXFXJVLXIXJVMABCE
      GWPPHJKMNVNVOWDVPVQBCEWQFGWPIWQUMZMNVRVSVTWAVQWFWGWLWNWOWSUCVAWIOWMWKDWQF
      GPIXNXCLWBUKWE $.
  $}

  ${
    lkrshp3.v $e |- V = ( Base ` W ) $.
    lkrshp3.d $e |- D = ( Scalar ` W ) $.
    lkrshp3.o $e |- .0. = ( 0g ` D ) $.
    lkrshp3.h $e |- H = ( LSHyp ` W ) $.
    lkrshp3.f $e |- F = ( LFnl ` W ) $.
    lkrshp3.k $e |- K = ( LKer ` W ) $.
    lkrshp3.w $e |- ( ph -> W e. LVec ) $.
    lkrshp3.g $e |- ( ph -> G e. F ) $.
    $( The kernels of nonzero functionals are hyperplanes.  (Contributed by NM,
       17-Jul-2014.) $)
    lkrshp3 $p |- ( ph -> ( ( K ` G ) e. H <-> G =/= ( V X. { .0. } ) ) ) $=
      ( wcel wne adantr cfv csn cxp wa clmod clvec lveclmod syl simpr lshpne wb
      wceq lkr0f syl2anc necon3bid mpbid lkrshp syl3anc impbida ) ADFUAZERZDGIU
      BUCZSZAVAUDZUTGSVCVDUTEGHJMAHUERZVAAHUFRZVEPHUGUHZTAVAUIUJVDUTGDVBAUTGULD
      VBULUKZVAAVEDCRZVHVGQBCDFGHIKLJNOUMUNTUOUPAVCUDVFVIVCVAAVFVCPTAVIVCQTAVCU
      IBCDEFGHIJKLMNOUQURUS $.
  $}

  ${
    lkrshpor.v $e |- V = ( Base ` W ) $.
    lkrshpor.h $e |- H = ( LSHyp ` W ) $.
    lkrshpor.f $e |- F = ( LFnl ` W ) $.
    lkrshpor.k $e |- K = ( LKer ` W ) $.
    lkrshpor.w $e |- ( ph -> W e. LVec ) $.
    lkrshpor.g $e |- ( ph -> G e. F ) $.
    $( The kernel of a functional is either a hyperplane or the full vector
       space.  (Contributed by NM, 7-Oct-2014.) $)
    lkrshpor $p |- ( ph -> ( ( K ` G ) e. H \/ ( K ` G ) = V ) ) $=
      ( cfv wcel wceq wo wa eqid adantr c0g csn cxp clmod wb clvec lveclmod syl
      csca lkr0f syl2anc biimpar olcd wne simpr lkrshp syl3anc orcd pm2.61dane
      ) ACENZDOZUTFPZQCFGUINZUANZUBUCZACVEPZRVBVAAVBVFAGUDOZCBOZVBVFUEAGUFOZVGL
      GUGUHMVCBCEFGVDVCSZVDSZHJKUJUKULUMACVEUNZRZVAVBVMVIVHVLVAAVIVLLTAVHVLMTAV
      LUOVCBCDEFGVDHVJVKIJKUPUQURUS $.
  $}

  ${
    lkrshp4.v $e |- V = ( Base ` W ) $.
    lkrshp4.h $e |- H = ( LSHyp ` W ) $.
    lkrshp4.f $e |- F = ( LFnl ` W ) $.
    lkrshp4.k $e |- K = ( LKer ` W ) $.
    lkrshp4.w $e |- ( ph -> W e. LVec ) $.
    lkrshp4.g $e |- ( ph -> G e. F ) $.
    $( A kernel is a hyperplane iff it doesn't contain all vectors.
       (Contributed by NM, 1-Nov-2014.) $)
    lkrshp4 $p |- ( ph -> ( ( K ` G ) =/= V <-> ( K ` G ) e. H ) ) $=
      ( cfv wne wcel wceq wo wi lkrshpor orcomd neor sylib clmod clvec lveclmod
      wa syl adantr simpr lshpne ex impbid ) ACENZFOZUNDPZAUNFQZUPRUOUPSAUPUQAB
      CDEFGHIJKLMTUAUPUNFUBUCAUPUOAUPUGUNDFGHIAGUDPZUPAGUEPURLGUFUHUIAUPUJUKULU
      M $.
  $}


  ${
    $d a b c k l y z .+ $.  $d b D $.  $d a b c k l z K $.  $d b c z N $.
    $d a b c k l y z .x. $.  $d a b c k l y z U $.  $d b V $.  $d b c z W $.
    $d a b c k l y z X $.  $d a b c k l y z Z $.  $d a b c l z ph $.
    lshpsmreu.v $e |- V = ( Base ` W ) $.
    lshpsmreu.a $e |- .+ = ( +g ` W ) $.
    lshpsmreu.n $e |- N = ( LSpan ` W ) $.
    lshpsmreu.p $e |- .(+) = ( LSSum ` W ) $.
    lshpsmreu.h $e |- H = ( LSHyp ` W ) $.
    lshpsmreu.w $e |- ( ph -> W e. LVec ) $.
    lshpsmreu.u $e |- ( ph -> U e. H ) $.
    lshpsmreu.z $e |- ( ph -> Z e. V ) $.
    lshpsmreu.x $e |- ( ph -> X e. V ) $.
    lshpsmreu.e $e |- ( ph -> ( U .(+) ( N ` { Z } ) ) = V ) $.
    lshpsmreu.d $e |- D = ( Scalar ` W ) $.
    lshpsmreu.k $e |- K = ( Base ` D ) $.
    lshpsmreu.t $e |- .x. = ( .s ` W ) $.
    $( Lemma for ~ lshpkrex .  Show uniqueness of ring multiplier ` k ` when a
       vector ` X ` is broken down into components, one in a hyperplane and the
       other outside of it .  TODO: do we need the ~ cbvrexv for ` a ` to
       ` c ` ?  (Contributed by NM, 4-Jan-2015.) $)
    lshpsmreu $p |- ( ph -> E! k e. K E. y e. U X = ( y .+ ( k .x. Z ) ) ) $=
      ( vc vb vl vz va cv co wceq wrex wreu wa weq wral csn wcel eleqtrrd csubg
      wi cfv wb clss clmod wss clvec lveclmod syl eqid lsssssubg lshplss sseldd
      lspsncl syl2anc lsmelval wex df-rex lspsnel anbi1d r19.41v syl6bbr exbidv
      mpbid rexcom4 ovex oveq2 eqeq2d ceqsexv rexbii bitr3i syl6bb syl5bb sylib
      rexbidv rexcom oveq1 cbvrexv w3a c0g ccntz simp11l lshpdisj cabel lmodabl
      cin ablcntzd simp12 simp2 simp1rl 3ad2ant1 lspsneli simp1rr simp13 eqtr3d
      simp3 subgdisj2 lvecvscan2 rexlimdv3a syl5bi imp3a ralrimivva oveq2d reu4
      lshpne0 sylanbrc cbvreuv reubii bitri ) ANUIUNZUJUNZOFUOZDUOZUPZUIGUQZUJJ
      URZNBUNZHUNZOFUOZDUOZUPZBGUQZHJURZAYTUJJUQZYTNYOUKUNZOFUOZDUOZUPZUIGUQZUS
      UJUKUTZVFZUKJVAUJJVAUUAAYSUJJUQZUIGUQZUUIANYOULUNZDUOZUPZULOVBKVGZUQZUIGU
      QZUURANGUVBEUOZVCZUVDANLUVEUDUEVDAGMVEVGZVCZUVBUVGVCZUVFUVDVHAMVIVGZUVGGA
      MVJVCZUVJUVGVKAMVLVCZUVKUAMVMZVNZUVJMUVJVOZVPVNZAUVJGIMUVOTUVNUBVQVRZAUVJ
      UVGUVBUVPAUVKOLVCZUVBUVJVCUVNUCUVJKLMOPUVORVSVTVRZUIULDEGUVBMNQSWAVTWIAUV
      CUUQUIGUVCUUSUVBVCZUVAUSZULWBZAUUQUVAULUVBWCAUWBUUSYQUPZUVAUSZUJJUQZULWBZ
      UUQAUWAUWEULAUWAUWCUJJUQZUVAUSUWEAUVTUWGUVAAUVKUVRUVTUWGVHUVNUCFUUSUJCJKL
      MOUFUGPUHRWDVTWEUWCUVAUJJWFWGWHUWFUWDULWBZUJJUQUUQUWDUJULJWJUWHYSUJJUVAYS
      ULYQYPOFWKUWCUUTYRNUUSYQYODWLWMWNWOWPWQWRWTWIYSUIUJGJXAWSAUUPUJUKJJAYPJVC
      ZUUJJVCZUSZUSZYTUUNUUOYTNUMUNZYQDUOZUPZUMGUQUWLUUNUUOVFZYSUWOUIUMGUIUMUTY
      RUWNNYOUWMYQDXBWMXCUWLUWOUWPUMGUWLUWMGVCZUWOXDZUUMUUOUIGUWRYOGVCZUUMXDZYQ
      UUKUPUUOUWTUWMYQYOUUKDGUVBMMXEVGZMXFVGZQUXAVOZUXBVOZUWTAUVHAUWKUWQUWOUWSU
      UMXGZUVQVNZUWTAUVIUXEUVSVNZUWTAGUVBXKUXAVBUPUXEAEGIKLMOUXAPUXCRSTUAUBUCUE
      XHVNUWTGUVBMUXBUXDUWTUVKMXIVCUWTUVLUVKUWTAUVLUXEUAVNZUVMVNZMXJVNUXFUXGXLU
      WLUWQUWOUWSUUMXMUWRUWSUUMXNUWTYPFCJKLMOPUHUFUGRUXIUWRUWSUWIUUMUWIUWJAUWQU
      WOXOXPZUWTAUVRUXEUCVNZXQUWTUUJFCJKLMOPUHUFUGRUXIUWRUWSUWJUUMUWIUWJAUWQUWO
      XRXPZUXKXQUWTNUWNUULUWLUWQUWOUWSUUMXSUWRUWSUUMYAXTYBUWTYPUUJFCJLMOUXAPUHU
      FUGUXCUXHUXJUXLUXKUWTEGIKLMOUXAPRSTUXCUXIUWTAGIVCUXEUBVNUXKUWTAUVELUPUXEU
      EVNYJYCWIYDYDYEYFYGYTUUNUJUKJUUOYSUUMUIGUUOYRUULNUUOYQUUKYODYPUUJOFXBYHWM
      WTYIYKUUANYOUUDDUOZUPZUIGUQZHJURUUHYTUXOUJHJUJHUTZYSUXNUIGUXPYRUXMNUXPYQU
      UDYODYPUUCOFXBYHWMWTYLUXOUUGHJUXNUUFUIBGUIBUTUXMUUENYOUUBUUDDXBWMXCYMYNWS
      $.
  $}


  ${
    $d b k w x y .+ $.  $d k w x K $.  $d b k w .0. $.  $d b k w x y .x. $.
    $d b k w x y U $.  $d x V $.  $d b k w x y X $.  $d b k w x y Z $.
    $d b ph $.
    lshpkrlem.v $e |- V = ( Base ` W ) $.
    lshpkrlem.a $e |- .+ = ( +g ` W ) $.
    lshpkrlem.n $e |- N = ( LSpan ` W ) $.
    lshpkrlem.p $e |- .(+) = ( LSSum ` W ) $.
    lshpkrlem.h $e |- H = ( LSHyp ` W ) $.
    lshpkrlem.w $e |- ( ph -> W e. LVec ) $.
    lshpkrlem.u $e |- ( ph -> U e. H ) $.
    lshpkrlem.z $e |- ( ph -> Z e. V ) $.
    lshpkrlem.x $e |- ( ph -> X e. V ) $.
    lshpkrlem.e $e |- ( ph -> ( U .(+) ( N ` { Z } ) ) = V ) $.
    lshpkrlem.d $e |- D = ( Scalar ` W ) $.
    lshpkrlem.k $e |- K = ( Base ` D ) $.
    lshpkrlem.t $e |- .x. = ( .s ` W ) $.
    lshpkrlem.o $e |- .0. = ( 0g ` D ) $.
    lshpkrlem.g $e |- G = ( x e. V |->
        ( iota_ k e. K E. y e. U x = ( y .+ ( k .x. Z ) ) ) ) $.
    $( Lemma for ~ lshpkrex .  The value of tentative functional ` G ` is zero
       iff its argument belongs to hyperplane ` U ` .  (Contributed by NM,
       14-Jul-2014.) $)
    lshpkrlem1 $p |- ( ph -> ( X e. U <-> ( G ` X ) = .0. ) ) $=
      ( vb cv co wceq wrex crio wcel wreu wb clmod cgrp clvec lveclmod lmodfgrp
      cfv syl grpidcl 3syl lshpsmreu oveq1 oveq2d eqeq2d rexbidv riota2 syl2anc
      wa simpr eqidd eqeq2 rspcev ex wi eleq1a a1i rexlimdv impbid eqid lmod0vs
      c0g adantr clss lshplss lssel sylan lmod0vrid eqtrd bicomd rexbidva bitrd
      eqeq1 riotabidv riotaex fvmpt cbvrexv riotabiia syl6eq eqeq1d 3bitr4d ) A
      PUNUOZQRGUPZEUPZUQZUNHURZPXLIUOZRGUPZEUPZUQZUNHURZILUSZQUQZPHUTZPJVHZQUQA
      QLUTZYAILVAXPYCVBAOVCUTZDVDUTYFAOVEUTZYGUDOVFZVIZDOUIVGLDQUJULVJVKAUNDEFG
      HIKLMNOPRSTUAUBUCUDUEUFUGUHUIUJUKVLYAXPILQXQQUQZXTXOUNHYKXSXNPYKXRXMXLEXQ
      QRGVMVNVOVPVQVRAYDPXLUQZUNHURZXPAYDYMAYDYMAYDVSZYDPPUQZYMAYDVTYNPWAYLYOUN
      PHXLPPWBWCVRWDAYLYDUNHXLHUTZYLYDWEWEAXLHPWFWGWHWIAYLXOUNHAYPVSZXOYLYQXNXL
      PYQXNXLOWLVHZEUPZXLYQXMYRXLEAXMYRUQZYPAYGRNUTYTYJUFGDQNORYRSUIUKULYRWJZWK
      VRWMVNYQYGXLNUTZYSXLUQYQYHYGAYHYPUDWMYIVIAHOWNVHZUTYPUUBAUUCHKOUUCWJZUCYJ
      UEWOUUCHNOXLSUUDWPWQENOXLYRSTUUAWRVRWSVOWTXAXBAYEYBQAPNUTZYEYBUQUGUUEYEPC
      UOZXREUPZUQZCHURZILUSZYBBPBUOZUUGUQZCHURZILUSUUJNJUUKPUQZUUMUUIILUUNUULUU
      HCHUUKPUUGXCVPXDUMUUIILXEXFUUIYAILUUIYAVBXQLUTUUHXTCUNHUUFXLUQUUGXSPUUFXL
      XREVMVOXGWGXHXIVIXJXK $.

    $( Lemma for ~ lshpkrex .  The value of tentative functional ` G ` is a
       scalar.  (Contributed by NM, 16-Jul-2014.) $)
    lshpkrlem2 $p |- ( ph -> ( G ` X ) e. K ) $=
      ( cfv cv co wceq wrex crio wcel eqeq1 rexbidv riotabidv riotaex fvmpt syl
      wreu lshpsmreu riotacl eqeltrd ) APJUNZPCUOIUORGUPEUPZUQZCHURZILUSZLAPNUT
      VKVOUQUGBPBUOZVLUQZCHURZILUSVONJVPPUQZVRVNILVSVQVMCHVPPVLVAVBVCUMVNILVDVE
      VFAVNILVGVOLUTACDEFGHIKLMNOPRSTUAUBUCUDUEUFUGUHUIUJUKVHVNILVIVFVJ $.

    $d l z .+ $.  $d l z G $.  $d l K $.  $d l z U $.  $d l z X $.  $d l z Z $.
    $d k l x y z $.  $d l z .x. $.
    $( Lemma for ~ lshpkrex .  Defining property of ` G `` X ` .  (Contributed
       by NM, 15-Jul-2014.) $)
    lshpkrlem3 $p |- ( ph -> E. z e. U X = ( z .+ ( ( G ` X ) .x. Z ) ) ) $=
      ( vl cv co wceq wrex cfv wsbc crio wreu lshpsmreu riotasbc syl wcel eqeq1
      rexbidv riotabidv cmpt weq oveq2d eqeq2d cbvrexv syl6bb cbvriotav mpteq2i
      wb oveq1 eqtri riotaex fvmpt dfsbcq 3syl mpbird fvex sbcie sylib ) AQDUPZ
      UOUPZSHUQZFUQZURZDIUSZUOQKUTZVAZQWJWPSHUQZFUQZURZDIUSZAWQWOUOWOUOMVBZVAZA
      WOUOMVCXCADEFGHIUOLMNOPQSTUAUBUCUDUEUFUGUHUIUJUKULVDWOUOMVEVFAQOVGWPXBURW
      QXCVSUHBQBUPZWMURZDIUSZUOMVBZXBOKXDQURZXFWOUOMXHXEWNDIXDQWMVHVIVJKBOXDCUP
      ZJUPZSHUQZFUQZURZCIUSZJMVBZVKBOXGVKUNBOXOXGXNXFJUOMJUOVLZXNXDXIWLFUQZURZC
      IUSXFXPXMXRCIXPXLXQXDXPXKWLXIFXJWKSHVTVMVNVIXRXECDICDVLXQWMXDXIWJWLFVTVNV
      OVPVQVRWAWOUOMWBWCWOUOWPXBWDWEWFWOXAUOWPQKWGWKWPURZWNWTDIXSWMWSQXSWLWRWJF
      WKWPSHVTVMVNVIWHWI $.

    $d k u v x y $.
    $( Lemma for ~ lshpkrex .  Part of showing linearity of ` G ` .
       (Contributed by NM, 16-Jul-2014.) $)
    lshpkrlem4 $p |- ( ( ( ph /\ l e. K /\ u e. V )
       /\ ( v e. V /\ r e. V /\ s e. V )
  /\ ( u = ( r .+ ( ( G ` u ) .x. Z ) ) /\ v = ( s .+ ( ( G ` v ) .x. Z ) ) ) )
    -> ( ( l .x. u ) .+ v ) = ( ( ( l .x. r ) .+ s )
        .+ ( ( ( l ( .r ` D ) ( G ` u ) ) ( +g ` D ) ( G ` v ) ) .x. Z ) ) ) $=
      ( cv wcel w3a cfv co wceq cmulr cplusg simp3l oveq2d simp3r oveq12d clmod
      wa clvec simpl1 lveclmod simpl2 simpr2 simpl3 adantr simpr csn lshpkrlem2
      3syl syl2anc syl lmodvscl syl3anc lmodvsdi syl13anc eqid lmodvsass eqtr4d
      oveq1d lmodmcl simpr3 simpr1 lmod4 syl122anc lmodvsdir eqtrd 3adant3 ) AU
      CUSZNUTZEUSZPUTZVAZDUSZPUTZUBUSZPUTZUAUSZPUTZVAZXDXIXDLVBZTIVCZGVCZVDZXGX
      KXGLVBZTIVCZGVCZVDZVLZVAZXBXDIVCZXGGVCXBXPIVCZXTGVCZXBXIIVCZXKGVCZXBXNFVE
      VBZVCZXRFVFVBZVCTIVCZGVCZYCYDYEXGXTGYCXDXPXBIXFXMXQYAVGVHXFXMXQYAVIVJXFXM
      YFYMVDYBXFXMVLZYFYGYJTIVCZGVCZXTGVCZYMYNYEYPXTGYNYEYGXBXOIVCZGVCZYPYNQVKU
      TZXCXJXOPUTZYEYSVDYNAQVMUTZYTAXCXEXMVNZUIQVOWCZAXCXEXMVPZXFXHXJXLVQZYNYTX
      NNUTZTPUTZUUAUUDYNAXEUUGUUCAXCXEXMVRAXEVLBCFGHIJKLMNOPQXDSTUDUEUFUGUHAUUB
      XEUIVSAJMUTZXEUJVSAUUHXEUKVSAXEVTAJTWAOVBHVCPVDZXEUMVSUNUOUPUQURWBWDZYNAU
      UHUUCUKWEZXNIFNPQTUDUNUPUOWFWGGXBIFNPQXIXOUDUEUNUPUOWHWIYNYOYRYGGYNYTXCUU
      GUUHYOYRVDUUDUUEUUKUULXBXNIYIFNPQTUDUNUPUOYIWJZWKWIVHWLWMYNYQYHYOXSGVCZGV
      CZYMYNYTYGPUTZYOPUTZXLXSPUTZYQUUOVDUUDYNYTXCXJUUPUUDUUEUUFXBIFNPQXIUDUNUP
      UOWFWGYNYTYJNUTZUUHUUQUUDYNYTXCUUGUUSUUDUUEUUKYIFNQXBXNUNUOUUMWNWGZUULYJI
      FNPQTUDUNUPUOWFWGXFXHXJXLWOYNYTXRNUTZUUHUURUUDYNAXHUVAUUCXFXHXJXLWPAXHVLB
      CFGHIJKLMNOPQXGSTUDUEUFUGUHAUUBXHUIVSAUUIXHUJVSAUUHXHUKVSAXHVTAUUJXHUMVSU
      NUOUPUQURWBWDZUULXRIFNPQTUDUNUPUOWFWGGXSPQYGYOXKUDUEWQWRYNYLUUNYHGYNYTUUS
      UVAUUHYLUUNVDUUDUUTUVBUULGYKYJXRIFNPQTUDUEUNUPUOYKWJWSWIVHWLWTXAWT $.

    $( Lemma for ~ lshpkrex .  Part of showing linearity of ` G ` .
       (Contributed by NM, 16-Jul-2014.) $)
    lshpkrlem5 $p |- ( ( ( ph /\ l e. K /\ u e. V )
       /\ ( v e. V /\ r e. U /\ ( s e. U /\ z e. U ) )
      /\ ( u = ( r .+ ( ( G ` u ) .x. Z ) ) /\ v = ( s .+ ( ( G ` v ) .x. Z ) )
          /\ ( ( l .x. u ) .+ v ) = ( z
              .+ ( ( G ` ( ( l .x. u ) .+ v ) ) .x. Z ) ) ) )
    -> ( G ` ( ( l .x. u ) .+ v ) )
           = ( ( l ( .r ` D ) ( G ` u ) ) ( +g ` D ) ( G ` v ) ) ) $=
      ( cv wcel w3a wa cfv co wceq cmulr cplusg csn ccntz eqid clss csubg clmod
      c0g wss clvec simp11 syl lveclmod lshplss sseldd lspsncl syl2anc lshpdisj
      lsssssubg lmodabl ablcntzd simp23r simp12 simp22 lssvscl syl22anc simp23l
      cin cabel lssvacl simp13 lmodvscl simp21 lmodvacl adantr simpr lshpkrlem2
      syl3anc lspsneli lmodmcl lmodacl simp33 simp1 simp31 lshpkrlem4 syl132anc
      lssel simp32 eqtr3d subgdisj2 wne lshpne0 lvecvscan2 mpbid ) AUDUTZOVAZFU
      TZQVAZVBZEUTZQVAZUCUTZKVAZUBUTZKVAZDUTZKVAZVCZVBZYDYIYDMVDZUAJVEHVEVFZYGY
      KYGMVDZUAJVEHVEVFZYBYDJVEZYGHVEZYMUUBMVDZUAJVEZHVEZVFZVBZVBZUUDYBYQGVGVDZ
      VEZYSGVHVDZVEZUAJVEZVFUUCUULVFUUHYMUUDYBYIJVEZYKHVEZUUMHKUAVIPVDZRRVOVDZR
      VJVDZUFUUQVKZUURVKZUUHRVLVDZRVMVDZKUUHRVNVAZUVAUVBVPUUHRVQVAZUVCUUHAUVDAY
      CYEYPUUGVRZUJVSZRVTZVSZUVARUVAVKZWFVSZUUHAKUVAVAZUVEAUVAKNRUVIUIAUVDUVCUJ
      UVGVSZUKWAVSZWBZUUHUVAUVBUUPUVJUUHUVCUAQVAZUUPUVAVAUVHUUHAUVOUVEULVSZUVAP
      QRUAUEUVIUGWCWDWBZUUHAKUUPWOUUQVIVFUVEAIKNPQRUAUUQUEUUSUGUHUIUJUKULUNWEVS
      UUHKUUPRUURUUTUUHUVCRWPVAUVHRWGVSUVNUVQWHYLYNYHYJYFUUGWIUUHUVCUVKUUNKVAZY
      LUUOKVAUVHUVMUUHUVCUVKYCYJUVRUVHUVMAYCYEYPUUGWJZYFYHYJYOUUGWKZOUVAJKGRYBY
      IUOUQUPUVIWLWMYLYNYHYJYFUUGWNZHUVAKRUUNYKUFUVIWQWMUUHUUCJGOPQRUAUEUQUOUPU
      GUVHUUHAUUBQVAZUUCOVAUVEUUHUVCUUAQVAZYHUWBUVHUUHUVCYCYEUWCUVHUVSAYCYEYPUU
      GWRZYBJGOQRYDUEUOUQUPWSXEYFYHYJYOUUGWTZHQRUUAYGUEUFXAXEAUWBVCBCGHIJKLMNOP
      QRUUBTUAUEUFUGUHUIAUVDUWBUJXBAKNVAZUWBUKXBAUVOUWBULXBAUWBXCAKUUPIVEQVFZUW
      BUNXBUOUPUQURUSXDWDZUVPXFUUHUULJGOPQRUAUEUQUOUPUGUVHUUHUVCUUJOVAZYSOVAZUU
      LOVAUVHUUHUVCYCYQOVAZUWIUVHUVSUUHAYEUWKUVEUWDAYEVCBCGHIJKLMNOPQRYDTUAUEUF
      UGUHUIAUVDYEUJXBAUWFYEUKXBAUVOYEULXBAYEXCAUWGYEUNXBUOUPUQURUSXDWDUUIGORYB
      YQUOUPUUIVKXGXEUUHAYHUWJUVEUWEAYHVCBCGHIJKLMNOPQRYGTUAUEUFUGUHUIAUVDYHUJX
      BAUWFYHUKXBAUVOYHULXBAYHXCAUWGYHUNXBUOUPUQURUSXDWDUUKGORUUJYSUOUPUUKVKXHX
      EZUVPXFUUHUUBUUEUUOUUMHVEZYFYPYRYTUUFXIUUHYFYHYIQVAZYKQVAZYRYTUUBUWMVFYFY
      PUUGXJUWEUUHUVKYJUWNUVMUVTUVAKQRYIUEUVIXNWDUUHUVKYLUWOUVMUWAUVAKQRYKUEUVI
      XNWDYFYPYRYTUUFXKYFYPYRYTUUFXOABCEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
      UMUNUOUPUQURUSXLXMXPXQUUHUUCUULJGOQRUAUUQUEUQUOUPUUSUVFUWHUWLUVPUUHAUAUUQ
      XRUVEAIKNPQRUAUUQUEUGUHUIUUSUVLUKULUNXSVSXTYA $.

    $d r s .+ $.  $d r s z D $.  $d r s G $.  $d r s z K $.  $d r s .x. $.
    $d r s U $.  $d r s z V $.  $d r s Z $.  $d r s z ph $.
    $d k l r s u v x y z $.
    $( Lemma for ~ lshpkrex .  Show linearlity of ` G ` .  (Contributed by NM,
       17-Jul-2014.) $)
    lshpkrlem6 $p |- ( ( ph /\ ( l e. K /\ u e. V /\ v e. V ) )
    -> ( G ` ( ( l .x. u ) .+ v ) )
           = ( ( l ( .r ` D ) ( G ` u ) ) ( +g ` D ) ( G ` v ) ) ) $=
      ( vr vs vz cv wcel w3a wa cfv co wceq wrex cmulr cplusg adantr simpr2 csn
      clvec lshpkrlem3 simpr3 lveclmod simpr1 lmodvscl syl3anc lmodvacl 3reeanv
      clmod syl wi simp1l simp1r1 simp1r2 simp1r3 simp2ll simp2lr simp2r simp31
      jca simp32 simp33 lshpkrlem5 syl333anc expdimp rexlimdv rexlimdvva mp3and
      3exp syl5bir ) AUAUTZNVAZEUTZPVAZDUTZPVAZVBZVCZXFUQUTZXFLVDZTIVEGVEVFZUQJ
      VGZXHURUTZXHLVDZTIVEGVEVFZURJVGZXDXFIVEZXHGVEZUSUTZYALVDZTIVEGVEVFZUSJVGZ
      YCXDXMFVHVDVEXQFVIVDVEVFZXKBCUQFGHIJKLMNOPQXFSTUBUCUDUEUFAQVMVAZXJUGVJZAJ
      MVAXJUHVJZATPVAXJUIVJZAXEXGXIVKZAJTVLOVDHVEPVFXJUKVJZULUMUNUOUPVNXKBCURFG
      HIJKLMNOPQXHSTUBUCUDUEUFYHYIYJAXEXGXIVOZYLULUMUNUOUPVNXKBCUSFGHIJKLMNOPQY
      ASTUBUCUDUEUFYHYIYJXKQWBVAZXTPVAZXIYAPVAXKYGYNYHQVPWCZXKYNXEXGYOYPAXEXGXI
      VQYKXDIFNPQXFUBULUNUMVRVSYMGPQXTXHUBUCVTVSYLULUMUNUOUPVNXOXSYEVBXNXRYDVBZ
      USJVGZURJVGUQJVGXKYFXNXRYDUQURUSJJJWAXKYRYFUQURJJXKXLJVAZXPJVAZVCZVCYQYFU
      SJXKUUAYBJVAZYQYFWDXKUUAUUBVCZYQYFXKUUCYQVBZAXEXGXIYSYTUUBVCXNXRYDYFAXJUU
      CYQWEXEXGXIAUUCYQWFXEXGXIAUUCYQWGXEXGXIAUUCYQWHYSYTUUBXKYQWIUUDYTUUBYSYTU
      UBXKYQWJXKUUAUUBYQWKWMXKUUCXNXRYDWLXKUUCXNXRYDWNXKUUCXNXRYDWOABCUSDEFGHIJ
      KLMNOPQTSTURUQUAUBUCUDUEUFUGUHUIUIUKULUMUNUOUPWPWQXBWRWSWTXCXA $.

  $}


  ${
    $d a k l x y .+ $.  $d l u v G $.  $d a k l u v x K $.  $d a k l v x y U $.
    $d u y $.  $d k D $.  $d l u v W $.  $d a k l x y .x. $.  $d a k l x y Z $.
    $d v L $.  $d a l u v ph $.  $d a u v x V $.
    lshpkr.v $e |- V = ( Base ` W ) $.
    lshpkr.a $e |- .+ = ( +g ` W ) $.
    lshpkr.n $e |- N = ( LSpan ` W ) $.
    lshpkr.p $e |- .(+) = ( LSSum ` W ) $.
    lshpkr.h $e |- H = ( LSHyp ` W ) $.
    lshpkr.w $e |- ( ph -> W e. LVec ) $.
    lshpkr.u $e |- ( ph -> U e. H ) $.
    lshpkr.z $e |- ( ph -> Z e. V ) $.
    lshpkr.e $e |- ( ph -> ( U .(+) ( N ` { Z } ) ) = V ) $.
    lshpkr.d $e |- D = ( Scalar ` W ) $.
    lshpkr.k $e |- K = ( Base ` D ) $.
    lshpkr.t $e |- .x. = ( .s ` W ) $.
    lshpkr.g $e |- G = ( x e. V |->
        ( iota_ k e. K E. y e. U x = ( y .+ ( k .x. Z ) ) ) ) $.
    ${
      lshpkr.f $e |- F = ( LFnl ` W ) $.
      $( The set ` G ` defined by hyperplane ` U ` is a linear functional.
         (Contributed by NM, 17-Jul-2014.) $)
      lshpkrcl $p |- ( ph -> G e. F ) $=
        ( vl vu vv va wcel wf cv co cmulr cplusg wceq wral wrex crio wreu clvec
        cfv adantr simpr csn lshpsmreu riotacl syl cmpt eqeq1 rexbidv riotabidv
        wa weq cbvmptv eqtri fmptd c0g eqid lshpkrlem6 ralrimivvva wb mpbir2and
        islfl ) AKJUPZOMKUQZULURZUMURZGUSUNURZEUSKVHWMWNKVHDUTVHZUSWOKVHDVAVHZU
        SVBZUNOVCUMOVCULMVCZAUOOUOURZCURIURQGUSEUSZVBZCHVDZIMVEZMKAWTOUPZVSZXCI
        MVFXDMUPXFCDEFGHILMNOPWTQRSTUAUBAPVGUPZXEUCVIAHLUPXEUDVIAQOUPXEUEVIAXEV
        JAHQVKNVHFUSOVBXEUFVIUGUHUIVLXCIMVMVNKBOBURZXAVBZCHVDZIMVEZVOUOOXDVOUJB
        UOOXKXDBUOVTZXJXCIMXLXIXBCHXHWTXAVPVQVRWAWBWCAWRULUMUNMOOABCUNUMDEFGHIK
        LMNOPQDWDVHZQULRSTUAUBUCUDUEUEUFUGUHUIXMWEUJWFWGAXGWKWLWSVSWHUCUMUNDEWQ
        GWPJKMOPVGULRSUGUIUHWQWEWPWEUKWJVNWI $.
    $}

    lshpkr.l $e |- L = ( LKer ` W ) $.
    $( The kernel of functional ` G ` is the hyperplane defining it.
       (Contributed by NM, 17-Jul-2014.) $)
    lshpkr $p |- ( ph -> ( L ` G ) = U ) $=
      ( vv cfv cv wcel clfn eqid clvec clmod lveclmod syl lshpkrcl lkrssv sseld
      clss lshplss lssel sylan ex wb wa c0g wceq ellkr syl2anc baibd adantr csn
      simpr co lshpkrlem1 bitr4d pm5.21ndd eqrdv ) AULJMUMZHAULUNZOUOZWFWEUOZWF
      HUOZAWEOWFAPUPUMZJMOPRWJUQZUKAPURUOZPUSUOUCPUTVAZABCDEFGHIWJJKLNOPQRSTUAU
      BUCUDUEUFUGUHUIUJWKVBZVCVDAWIWGAHPVEUMZUOWIWGAWOHKPWOUQZUBWMUDVFWOHOPWFRW
      PVGVHVIAWGWHWIVJAWGVKZWHWFJUMDVLUMZVMZWIAWHWGWSAWLJWJUOWHWGWSVKVJUCWNDWJJ
      MOPWFURWRRUGWRUQZWKUKVNVOVPWQBCDEFGHIJKLNOPWFWRQRSTUAUBAWLWGUCVQAHKUOWGUD
      VQAQOUOWGUEVQAWGVSAHQVRNUMFVTOVMWGUFVQUGUHUIWTUJWAWBVIWCWD $.
  $}

  ${
    $d g z F $.  $d z H $.  $d g z K $.  $d g k x y z U $.  $d g k x y z W $.
    lshpkrex.h $e |- H = ( LSHyp ` W ) $.
    lshpkrex.f $e |- F = ( LFnl ` W ) $.
    lshpkrex.k $e |- K = ( LKer ` W ) $.
    $( There exists a functional whose kernel equals a given hyperplane.  Part
       of Th. 1.27 of Barbu and Precupanu, _Convexity and Optimization in
       Banach Spaces_.  (Contributed by NM, 17-Jul-2014.) $)
    lshpkrex $p |- ( ( W e. LVec /\ U e. H ) -> E. g e. F ( K ` g ) = U ) $=
      ( vz vx vy vk wcel cv cfv co wceq wrex eqid clvec csn clspn clsm cbs clss
      wa wne w3a lveclmod islshpsm simp3 syl6bi imp cvsca cplusg csca crio cmpt
      simp1l simp1r simp2 lshpkrcl lshpkr eqeq1d rspcev syl2anc rexlimdv3a mpd
      fveq2 ) FUANZADNZUGZAJOZUBFUCPZPFUDPZQFUEPZRZJVQSZBOZEPZARZBCSZVKVLVSVKVL
      AFUFPZNZAVQUHZVSUIVSVKJVPWDADVOVQFVQTZVOTZWDTVPTZGFUJUKWEWFVSULUMUNVMVRWC
      JVQVMVNVQNZVRUIZKVQKOLOMOVNFUOPZQFUPPZQRLASMFUQPZUEPZURUSZCNWPEPZARZWCWKK
      LWNWMVPWLAMCWPDWOVOVQFVNWGWMTZWHWIGVKVLWJVRUTZVKVLWJVRVAZVMWJVRVBZVMWJVRU
      LZWNTZWOTZWLTZWPTZHVCWKKLWNWMVPWLAMWPDWOEVOVQFVNWGWSWHWIGWTXAXBXCXDXEXFXG
      IVDWBWRBWPCVTWPRWAWQAVTWPEVJVEVFVGVHVI $.
  $}

  ${
    $d g F $.  $d g s H $.  $d g v K $.  $d g v V $.  $d g s v W $.
    lshpset2.v $e |- V = ( Base ` W ) $.
    lshpset2.d $e |- D = ( Scalar ` W ) $.
    lshpset2.z $e |- .0. = ( 0g ` D ) $.
    lshpset2.h $e |- H = ( LSHyp ` W ) $.
    lshpset2.f $e |- F = ( LFnl ` W ) $.
    lshpset2.k $e |- K = ( LKer ` W ) $.
    $( The set of all hyperplanes of a left module or left vector space equals
       the set of all kernels of nonzero functionals.  (Contributed by NM,
       17-Jul-2014.)  (New usage is discouraged.) $)
    lshpset2N $p |- ( W e. LVec -> H = { s |
                   E. g e. F ( g =/= ( V X. { .0. } ) /\ s = ( K ` g ) ) } ) $=
      ( vv wcel cfv wceq wa clvec cv csn cxp wne wrex lshpkrex biimparc adantll
      eleq1 adantlr simplll simplr lkrshp3 mpbid ex wi eqimss2 eqimss eqssd a1i
      jcad reximdva mpd clss cun clspn w3a lkrshp 3adant3r eqid islshp 3ad2ant1
      wb neeq1 uneq1 fveq2d eqeq1d rexbidv 3anbi123d adantl 3ad2ant3 rexlimdv3a
      mpbird sylibrd impbid abbi2dv ) GUAQZBUBZFHUCUDUEZIUBZWIERZSZTZBCUFZIDWHW
      KDQZWOWHWPWOWHWPTZWLWKSZBCUFWOWKBCDEGMNOUGWQWRWNBCWQWICQZTZWRWJWMWTWRWJWT
      WRTZWLDQZWJWQWRXBWSWPWRXBWHWRXBWPWLWKDUJUHUIUKXAACWIDEFGHJKLMNOWHWPWSWRUL
      WQWSWRUMUNUOUPWRWMUQWTWRWKWLWKWLURWLWKUSUTVAVBVCVDUPWHWOWKGVERZQZWKFUEZWK
      PUBUCZVFZGVGRZRZFSZPFUFZVHZWPWHWNXLBCWHWSWNVHZXLWLXCQZWLFUEZWLXFVFZXHRZFS
      ZPFUFZVHZXMXBXTWHWSWJXBWMACWIDEFGHJKLMNOVIVJWHWSXBXTVNWNPXCWLDXHFGUAJXHVK
      ZXCVKZMVLVMUOWNWHXLXTVNZWSWMYCWJWMXDXNXEXOXKXSWKWLXCUJWKWLFVOWMXJXRPFWMXI
      XQFWMXGXPXHWKWLXFVPVQVRVSVTWAWBWDWCPXCWKDXHFGUAJYAYBMVLWEWFWG $.

    $d s F $.  $d s K $.  $d g s U $.  $d s V $.  $d s .0. $.
    $( The predicate "is a hyperplane" (of a left module or left vector
       space).  TODO: should it be ` U = ( K `` g ) ` or ` ( K `` g ) = U ` as
       in ~ lshpkrex ?  Both standards seem to be used randomly throughout
       set.mm; we should decide on a preferred one.  (Contributed by NM,
       7-Oct-2014.)  (New usage is discouraged.) $)
    islshpkrN $p |- ( W e. LVec -> ( U e. H
          <-> E. g e. F ( g =/= ( V X. { .0. } ) /\ U = ( K ` g ) ) ) ) $=
      ( vs wcel wceq cvv adantl clvec csn cxp wne cfv wrex cab lshpset2N eleq2d
      cv wa elex fvex eleq1 mpbiri rexlimivw eqeq1 rexbidv elabg pm5.21nd bitrd
      anbi2d ) HUAQZBEQBCUJZGIUBUCUDZPUJZVDFUEZRZUKZCDUFZPUGZQZVEBVGRZUKZCDUFZV
      CEVKBACDEFGHIPJKLMNOUHUIVCVLVOBSQZVLVPVCBVKULTVOVPVCVNVPCDVMVPVEVMVPVGSQV
      DFUMBVGSUNUOTUPTVJVOPBSVFBRZVIVNCDVQVHVMVEVFBVGUQVBURUSUTVA $.
  $}

  ${
    $d k D $.  $d k F $.  $d k G $.  $d k K $.  $d k L $.  $d k V $.  $d k W $.
    $d g k ph $.  $d k .x. $.
    lfl1dim.v $e |- V = ( Base ` W ) $.
    lfl1dim.d $e |- D = ( Scalar ` W ) $.
    lfl1dim.f $e |- F = ( LFnl ` W ) $.
    lfl1dim.l $e |- L = ( LKer ` W ) $.
    lfl1dim.k $e |- K = ( Base ` D ) $.
    lfl1dim.t $e |- .x. = ( .r ` D ) $.
    lfl1dim.w $e |- ( ph -> W e. LVec ) $.
    lfl1dim.g $e |- ( ph -> G e. F ) $.
    $( Equivalent expressions for a 1-dim subspace (ray) of functionals.
       (Contributed by NM, 24-Oct-2014.) $)
    lfl1dim $p |- ( ph -> { g e. F | ( L ` G ) C_ ( L ` g ) }
        = { g | E. k e. K g = ( G oF .x. ( V X. { k } ) ) } ) $=
      ( wa cfv cv wss crab wcel cab csn cxp cof co wceq wrex df-rab clmod clvec
      wi c0g lveclmod syl eqid lmod0cl ad2antrr simpr lfl0sc eqtr4d sneq xpeq2d
      oveq2d eqeq2d rspcev syl2anc a1d ad3antrrr simpllr lkrssv wb adantr lkr0f
      biimpar sseq1d biimpa eqssd mpbid ex wne clsh simprr lkrshp simplr simprl
      syl3anc lshpcmp eqlkr2 syl121anc sylbid pm2.61da2ne fveq2 sseq2d biimprcd
      lkrscss rexlimdv impbid pm5.32da lflvscl eleq1a pm4.71rd rexbidva r19.42v
      syl6 syl6rbb bitrd abbidv syl5eq ) AGIUAZDUBZIUAZUCZDFUDXOFUEZXQTZDUFXOGJ
      EUBZUGZUHZCUIZUJZUKZEHULZDUFXQDFUMAXSYFDAXSXRYFTZYFAXRXQYFAXRTZXQYFYHXQYF
      UPXOJBUQUAZUGZUHZGYKYHXOYKUKZTZYFXQYMYIHUEZXOGYKYCUJZUKZYFAYNXRYLAKUNUEZY
      NAKUOUEZYQRKURUSZBHKYIMPYIUTZVAUSZVBYMXOYKYOYHYLVCYMBCFGHJKYILMNPQYTAYQXR
      YLYSVBAGFUEZXRYLSVBVDVEYEYPEYIHXTYIUKZYDYOXOUUCYBYKGYCUUCYAYJJXTYIVFVGVHV
      IVJZVKVLYHGYKUKZTZXQYFUUFXQTZYNYPYFAYNXRUUEXQUUAVMUUGXOYKYOUUGXPJUKZYLUUG
      XPJUUGFXOIJKLNOAYQXRUUEXQYSVMZAXRUUEXQVNZVOUUFXQJXPUCUUFXNJXPYHXNJUKZUUEY
      HYQUUBUUKUUEVPAYQXRYSVQAUUBXRSVQBFGIJKYIMYTLNOVRVKVSVTWAWBUUGYQXRUUHYLVPU
      UIUUJBFXOIJKYIMYTLNOVRVKWCUUGBCFGHJKYILMNPQYTUUIAUUBXRUUEXQSVMVDVEUUDVKWD
      YHXOYKWEZGYKWEZTZTZXQXNXPUKZYFUUOXNXPKWFUAZKUUQUTZAYRXRUUNRVBZUUOYRUUBUUM
      XNUUQUEUUSAUUBXRUUNSVBYHUULUUMWGBFGUUQIJKYILMYTUURNOWHWKUUOYRXRUULXPUUQUE
      UUSAXRUUNWIYHUULUUMWJBFXOUUQIJKYILMYTUURNOWHWKWLUUOUUPYFUUOUUPTYRUUBXRUUP
      YFAYRXRUUNUUPRVMAUUBXRUUNUUPSVMAXRUUNUUPVNUUOUUPVCBCFGXOHIJKEMPQLNOWMWNWD
      WOWPYHYEXQEHYHXTHUEZXNYDIUAZUCZYEXQUPYHUUTUVBYHUUTTBXTCFGHIJKLMPQNOAYRXRU
      UTRVBAUUBXRUUTSVBYHUUTVCWTWDYEXQUVBYEXPUVAXNXOYDIWQWRWSXIXAXBXCAYFXRYETZE
      HULYGAYEUVCEHAUUTTZYEXRUVDYDFUEYEXRUPUVDBXTCFGHJKLMPQNAYQUUTYSVQAUUBUUTSV
      QAUUTVCXDYDFXOXEUSXFXGXRYEEHXHXJXKXLXM $.

    $( Equivalent expressions for a 1-dim subspace (ray) of functionals.  TODO:
       delete this if not useful; ~ lfl1dim may be more compatible with
       ~ lspsn .  (Contributed by NM, 24-Oct-2014.)
       (New usage is discouraged.) $)
    lfl1dim2N $p |- ( ph -> { g e. F | ( L ` G ) C_ ( L ` g ) }
        = { g e. F | E. k e. K g = ( G oF .x. ( V X. { k } ) ) } ) $=
      ( wceq cfv cv wss csn cxp cof co wrex wcel wa wi c0g clmod clvec lveclmod
      syl eqid lmod0cl ad2antrr simpr lfl0sc eqtr4d xpeq2d oveq2d eqeq2d rspcev
      sneq syl2anc a1d ad3antrrr simpllr lkrssv wb adantr biimpar sseq1d biimpa
      lkr0f eqssd mpbid ex wne clsh simprr lkrshp syl3anc simplr simprl lshpcmp
      eqlkr2 syl121anc sylbid pm2.61da2ne lkrscss sseq2d biimprcd syl6 rexlimdv
      fveq2 impbid rabbidva ) AGIUAZDUBZIUAZUCZXCGJEUBZUDZUEZCUFZUGZTZEHUHZDFAX
      CFUIZUJZXEXLXNXEXLUKXCJBULUAZUDZUEZGXQXNXCXQTZUJZXLXEXSXOHUIZXCGXQXIUGZTZ
      XLAXTXMXRAKUMUIZXTAKUNUIZYCRKUOUPZBHKXOMPXOUQZURUPZUSXSXCXQYAXNXRUTXSBCFG
      HJKXOLMNPQYFAYCXMXRYEUSAGFUIZXMXRSUSVAVBXKYBEXOHXFXOTZXJYAXCYIXHXQGXIYIXG
      XPJXFXOVGVCVDVEVFZVHVIXNGXQTZUJZXEXLYLXEUJZXTYBXLAXTXMYKXEYGVJYMXCXQYAYMX
      DJTZXRYMXDJYMFXCIJKLNOAYCXMYKXEYEVJZAXMYKXEVKZVLYLXEJXDUCYLXBJXDXNXBJTZYK
      XNYCYHYQYKVMAYCXMYEVNAYHXMSVNBFGIJKXOMYFLNOVRVHVOVPVQVSYMYCXMYNXRVMYOYPBF
      XCIJKXOMYFLNOVRVHVTYMBCFGHJKXOLMNPQYFYOAYHXMYKXESVJVAVBYJVHWAXNXCXQWBZGXQ
      WBZUJZUJZXEXBXDTZXLUUAXBXDKWCUAZKUUCUQZAYDXMYTRUSZUUAYDYHYSXBUUCUIUUEAYHX
      MYTSUSXNYRYSWDBFGUUCIJKXOLMYFUUDNOWEWFUUAYDXMYRXDUUCUIUUEAXMYTWGXNYRYSWHB
      FXCUUCIJKXOLMYFUUDNOWEWFWIUUAUUBXLUUAUUBUJYDYHXMUUBXLAYDXMYTUUBRVJAYHXMYT
      UUBSVJAXMYTUUBVKUUAUUBUTBCFGXCHIJKEMPQLNOWJWKWAWLWMXNXKXEEHXNXFHUIZXBXJIU
      AZUCZXKXEUKXNUUFUUHXNUUFUJBXFCFGHIJKLMPQNOAYDXMUUFRUSAYHXMUUFSUSXNUUFUTWN
      WAXKXEUUHXKXDUUGXBXCXJIWSWOWPWQWRWTXA $.
  $}

$(
  @c LSLat @.

  @( Extend class notation with lattice of subspaces of a left module
     or left vector space. @)
  clsl @a class LSLat @.

  @{
    @d w x y @.
    df-lsl @a |- LSLat = ( w e. _V |-> { <. ( Base ` ndx ) ,
        ( LSubSp ` w ) >. , <. ( le ` ndx ) ,
     { <. x , y >. | ( x e. ( LSubSp ` w ) /\ y e. ( LSubSp ` w )
        /\ x C_ y ) } >. } ) @.
  @}
$)

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Opposite rings and dual vector spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LDual $.

  $( Extend class notation with left dualvector space. $)
  cld $a class LDual $.

  ${
    $d v k f g $.
    $( Define the (left) dual of a left vector space (or module) in which the
       vectors are functionals.  In many texts, this is defined as a right
       vector space, but by reversing the multiplication we achieve a left
       vector space, as is done in definition of dual vector space in
       [Holland95] p. 218.  This allows us to reuse our existing collection of
       left vector space theorems.  The restriction on ` oF ( +g `` v ) `
       allows it to be a set; see ~ ofmres .  Note the operation reversal in
       the scalar product to allow us to use the original scalar ring instead
       of the ` oppR ` ring, for convenience.  (Contributed by NM,
       18-Oct-2014.) $)
    df-ldual $a |- LDual = ( v e. _V |->
      ( { <. ( Base ` ndx ) , ( LFnl ` v ) >. ,
          <. ( +g ` ndx ) , ( oF ( +g ` ( Scalar ` v ) )
                 |` ( ( LFnl ` v ) X. ( LFnl ` v ) ) ) >. ,
          <. ( Scalar ` ndx ) , ( oppR ` ( Scalar ` v ) ) >. } u. {
          <. ( .s ` ndx ) , ( k e. ( Base ` ( Scalar ` v ) ) ,
             f e. ( LFnl ` v ) |-> ( f oF ( .r ` ( Scalar ` v ) )
               ( ( Base ` v ) X. { k } ) ) ) >. } ) ) $.
  $}

  ${
    $d w F $.  $d w O $.  $d w .+b $.  $d w .xb $.  $d f k w W $.
    ldualset.v $e |- V = ( Base ` W ) $.
    ldualset.a $e |- .+ = ( +g ` R ) $.
    ldualset.p $e |- .+b = ( oF .+ |` ( F X. F ) ) $.
    ldualset.f $e |- F = ( LFnl ` W ) $.
    ldualset.d $e |- D = ( LDual ` W ) $.
    ldualset.r $e |- R = ( Scalar ` W ) $.
    ldualset.k $e |- K = ( Base ` R ) $.
    ldualset.t $e |- .x. = ( .r ` R ) $.
    ldualset.o $e |- O = ( oppR ` R ) $.
    ldualset.s $e |- .xb =
      ( k e. K , f e. F |-> ( f oF .x. ( V X. { k } ) ) ) $.
    ldualset.w $e |- ( ph -> W e. X ) $.
    $( Define the (left) dual of a left vector space (or module) in which the
       vectors are functionals.  In many texts, this is defined as a right
       vector space, but by reversing the multiplication we achieve a left
       vector space, as is done in definition of dual vector space in
       [Holland95] p. 218.  This allows us to reuse our existing collection of
       left vector space theorems.  Note the operation reversal in the scalar
       product to allow us to use the original scalar ring instead of the
       ` oppR ` ring, for convenience.  (Contributed by NM, 18-Oct-2014.) $)
    ldualset $p |- ( ph -> D = ( { <. ( Base ` ndx ) , F >. ,
         <. ( +g ` ndx ) , .+b >. , <. ( Scalar ` ndx ) , O >. }
       u. { <. ( .s ` ndx ) , .xb >. } ) ) $=
      ( vw wcel cvv cnx cbs cfv cop cplusg csca ctp cvsca csn cun wceq elex cld
      cv clfn cof cxp cres coppr cmulr co cmpt2 fveq2 syl6eqr opeq2d fveq2d syl
      xpeq12d reseq12d tpeq123d eqidd xpeq1d oveq123d mpt2eq123dv sneqd uneq12d
      ofeq df-ldual tpex snex unex fvmpt syl5eq 3syl ) ANOUHNUIUHZBUJUKULZJUMZU
      JUNULZDUMZUJUOULZLUMZUPZUJUQULZFUMZURZUSZUTUFNOVAWNBNVBULXETUGNWOUGVCZVDU
      LZUMZWQXFUOULZUNULZVEZXGXGVFZVGZUMZWSXIVHULZUMZUPZXBIHXIUKULZXGHVCZXFUKUL
      ZIVCURZVFZXIVIULZVEZVJZVKZUMZURZUSXEUIVBXFNUTZXQXAYHXDYIXHWPXNWRXPWTYIXGJ
      WOYIXGNVDULJXFNVDVLSVMZVNYIXMDWQYIXMCVEZJJVFZVGDYIXKYKXLYLYIXJCUTXKYKUTYI
      XJEUNULCYIXIEUNYIXINUOULEXFNUOVLUAVMZVOQVMXJCWFVPYIXGJXGJYJYJVQVRRVMVNYIX
      OLWSYIXOEVHULLYIXIEVHYMVOUDVMVNVSYIYGXCYIYFFXBYIYFIHKJXSMYAVFZGVEZVJZVKFY
      IIHXRXGYEKJYPYIXREUKULKYIXIEUKYMVOUBVMYJYIXSXSYBYNYDYOYIYCGUTYDYOUTYIYCEV
      IULGYIXIEVIYMVOUCVMYCGWFVPYIXSVTYIXTMYAYIXTNUKULMXFNUKVLPVMWAWBWCUEVMVNWD
      WEUGHIWGXAXDWPWRWTWHXCWIWJWKWLWM $.
  $}

  ${
    $d f k W $.
    ldualvbase.f $e |- F = ( LFnl ` W ) $.
    ldualvbase.d $e |- D = ( LDual ` W ) $.
    ldualvbase.v $e |- V = ( Base ` D ) $.
    ldualvbase.w $e |- ( ph -> W e. X ) $.
    $( The vectors of a dual space are functionals of the original space.
       (Contributed by NM, 18-Oct-2014.) $)
    ldualvbase $p |- ( ph -> V = F ) $=
      ( vk vf cbs cfv cnx cop cplusg csca eqid cvv cof cxp cres coppr ctp cvsca
      cv csn cmulr co cmpt2 cun ldualset fveq2d wcel wceq clfn eqeltri lmodbase
      fvex ax-mp 3eqtr4g ) ABMNOMNCPOQNERNZQNZUACCUBUCZPORNVCUDNZPUEOUFNKLVCMNZ
      CLUGEMNZKUGUHUBVCUINZUAUJUKZPUHULZMNZDCABVKMABVDVEVCVJVILKCVGVFVHEFVHSVDS
      VESGHVCSVGSVISVFSVJSJUMUNICTUOCVLUPCEUQNTGEUQUTURCVEVJVFVKTVKSUSVAVB $.
  $}

  ${
    $d f k W $.
    ldualelvbase.f $e |- F = ( LFnl ` W ) $.
    ldualelvbase.d $e |- D = ( LDual ` W ) $.
    ldualelvbase.v $e |- V = ( Base ` D ) $.
    ldualelvbase.w $e |- ( ph -> W e. X ) $.
    ldualelvbase.g $e |- ( ph -> G e. F ) $.
    $( Utility theorem for converting a functional to a vector of the dual
       space in order to use standard vector theorems.  (Contributed by NM,
       6-Jan-2015.) $)
    ldualelvbase $p |- ( ph -> G e. V ) $=
      ( ldualvbase eleqtrrd ) ADCELABCEFGHIJKMN $.
  $}

  ${
    $d f k W $.
    ldualvadd.f $e |- F = ( LFnl ` W ) $.
    ldualvadd.r $e |- R = ( Scalar ` W ) $.
    ldualvadd.a $e |- .+ = ( +g ` R ) $.
    ldualvadd.d $e |- D = ( LDual ` W ) $.
    ldualvadd.p $e |- .+b = ( +g ` D ) $.
    ldualvadd.w $e |- ( ph -> W e. X ) $.
    ${
      ldualfvadd.q $e |- .+^ = ( oF .+ |` ( F X. F ) ) $.
      $( Vector addition in the dual of a vector space.  (Contributed by NM,
         21-Oct-2014.) $)
      ldualfvadd $p |- ( ph -> .+b = .+^ ) $=
        ( cplusg cfv eqid cvv vk vf cnx cbs cop csca coppr ctp cvsca cv csn cxp
        cmulr cof co cmpt2 cun ldualset fveq2d wcel wceq cres clfn fvex eqeltri
        id ofmresex ax-mp lmodplusg 3eqtr4g ) ABQRUCUDRGUEUCQRDUEUCUFRFUGRZUEUH
        UCUIRUAUBFUDRZGUBUJHUDRZUAUJUKULFUMRZUNUOUPZUEUKUQZQRZEDABVPQABCDFVOVNU
        BUAGVLVKVMHIVMSLPJMKVLSVNSVKSVOSOURUSNDTUTDVQVADCUNGGULVBZTPGTUTZVRTUTG
        HVCRTJHVCVDVEVSGGCTTVSVFZVTVGVHVEGDVOVKVPTVPSVIVHVJ $.
    $}

    ldualvadd.g $e |- ( ph -> G e. F ) $.
    ldualvadd.h $e |- ( ph -> H e. F ) $.
    $( Vector addition in the dual of a vector space.  (Contributed by NM,
       21-Oct-2014.) $)
    ldualvadd $p |- ( ph -> ( G .+b H ) = ( G oF .+ H ) ) $=
      ( co cof cxp cres eqid ldualfvadd oveqd ofmresval eqtrd ) AGHDSGHCTZFFUAU
      BZSGHUHSADUIGHABCUIDEFIJKLMNOPUIUCUDUEAFFCGHQRUFUG $.
  $}

  ${
    ldualvaddcl.f $e |- F = ( LFnl ` W ) $.
    ldualvaddcl.d $e |- D = ( LDual ` W ) $.
    ldualvaddcl.p $e |- .+ = ( +g ` D ) $.
    ldualvaddcl.w $e |- ( ph -> W e. LMod ) $.
    ldualvaddcl.g $e |- ( ph -> G e. F ) $.
    ldualvaddcl.h $e |- ( ph -> H e. F ) $.
    $( The value of vector addition in the dual of a vector space is a
       functional.  (Contributed by NM, 21-Oct-2014.) $)
    ldualvaddcl $p |- ( ph -> ( G .+ H ) e. F ) $=
      ( co csca cfv cplusg cof clmod eqid ldualvadd lfladdcl eqeltrd ) AEFCNEFG
      OPZQPZRNDABUECUDDEFGSHUDTZUETZIJKLMUAAUEUDDEFGUFUGHKLMUBUC $.
  $}

  ${
    ldualvaddval.v $e |- V = ( Base ` W ) $.
    ldualvaddval.r $e |- R = ( Scalar ` W ) $.
    ldualvaddval.a $e |- .+ = ( +g ` R ) $.
    ldualvaddval.f $e |- F = ( LFnl ` W ) $.
    ldualvaddval.d $e |- D = ( LDual ` W ) $.
    ldualvaddval.p $e |- .+b = ( +g ` D ) $.
    ldualvaddval.w $e |- ( ph -> W e. LMod ) $.
    ldualvaddval.g $e |- ( ph -> G e. F ) $.
    ldualvaddval.h $e |- ( ph -> H e. F ) $.
    ldualvaddval.x $e |- ( ph -> X e. V ) $.
    $( The value of the value of vector addition in the dual of a vector
       space.  (Contributed by NM, 7-Jan-2015.) $)
    ldualvaddval $p |- ( ph
             -> ( ( G .+b H ) ` X ) = ( ( G ` X ) .+ ( H ` X ) ) ) $=
      ( co cfv cof clmod ldualvadd fveq1d wcel wceq cvv wfn wa cbs wf eqid lflf
      ffn syl syl2anc fvex eqeltri a1i inidm eqidd ofval mpdan eqtrd ) AKGHDUBZ
      UCKGHCUDUBZUCZKGUCZKHUCZCUBZAKVHVIABCDEFGHJUEOMNPQRSTUFUGAKIUHZVJVMUIUAAI
      IVKVLCIGHUJUJKAJUEUHZGFUHZGIUKZRSVOVPULIEUMUCZGUNVQEFGVRIJUEMVRUOZLOUPIVR
      GUQURUSAVOHFUHZHIUKZRTVOVTULIVRHUNWAEFHVRIJUEMVSLOUPIVRHUQURUSIUJUHAIJUMU
      CUJLJUMUTVAVBZWBIVCAVNULZVKVDWCVLVDVEVFVG $.
  $}

  ${
    $d f k W $.
    ldualsca.f $e |- F = ( Scalar ` W ) $.
    ldualsca.o $e |- O = ( oppR ` F ) $.
    ldualsca.d $e |- D = ( LDual ` W ) $.
    ldualsca.r $e |- R = ( Scalar ` D ) $.
    ldualsca.w $e |- ( ph -> W e. X ) $.
    $( The ring of scalars of the dual of a vector space.  (Contributed by NM,
       18-Oct-2014.) $)
    ldualsca $p |- ( ph -> R = O ) $=
      ( vk vf csca cfv cnx cbs cop eqid clfn cplusg cof cxp cres cvsca cv cmulr
      ctp csn co cmpt2 cun ldualset fveq2d wcel wceq coppr fvex eqeltri lmodsca
      cvv ax-mp 3eqtr4g ) ABOPQRPFUAPZSQUBPDUBPZUCVEVEUDUEZSQOPESUIQUFPMNDRPZVE
      NUGFRPZMUGUJUDDUHPZUCUKULZSUJUMZOPZCEABVLOABVFVGDVKVJNMVEVHEVIFGVITVFTVGT
      VETJHVHTVJTIVKTLUNUOKEVBUPEVMUQEDURPVBIDURUSUTVEVGVKEVLVBVLTVAVCVD $.
  $}

  ${
    ldualsbase.f $e |- F = ( Scalar ` W ) $.
    ldualsbase.l $e |- L = ( Base ` F ) $.
    ldualsbase.d $e |- D = ( LDual ` W ) $.
    ldualsbase.r $e |- R = ( Scalar ` D ) $.
    ldualsbase.k $e |- K = ( Base ` R ) $.
    ldualsbase.w $e |- ( ph -> W e. V ) $.
    $( Base set of scalar ring for the dual of a vector space.  (Contributed by
       NM, 24-Oct-2014.) $)
    ldualsbase $p |- ( ph -> K = L ) $=
      ( cbs cfv coppr eqid ldualsca fveq2d opprbas 3eqtr4g ) ACOPDQPZOPEFACUCOA
      BCDUCHGIUCRZKLNSTMFDUCUDJUAUB $.
  $}

  ${
    ldualsadd.f $e |- F = ( Scalar ` W ) $.
    ldualsadd.q $e |- .+ = ( +g ` F ) $.
    ldualsadd.d $e |- D = ( LDual ` W ) $.
    ldualsadd.r $e |- R = ( Scalar ` D ) $.
    ldualsadd.p $e |- .+b = ( +g ` R ) $.
    ldualsadd.w $e |- ( ph -> W e. V ) $.
    $( Scalar addition for the dual of a vector space.  (Contributed by NM,
       24-Oct-2014.)  (New usage is discouraged.) $)
    ldualsaddN $p |- ( ph -> .+b = .+ ) $=
      ( cplusg cfv coppr eqid ldualsca fveq2d oppradd 3eqtr4g ) AEOPFQPZOPDCAEU
      COABEFUCHGIUCRZKLNSTMCFUCUDJUAUB $.
  $}

  ${
    ldualsmul.f $e |- F = ( Scalar ` W ) $.
    ldualsmul.k $e |- K = ( Base ` F ) $.
    ldualsmul.t $e |- .x. = ( .r ` F ) $.
    ldualsmul.d $e |- D = ( LDual ` W ) $.
    ldualsmul.r $e |- R = ( Scalar ` D ) $.
    ldualsmul.m $e |- .xb = ( .r ` R ) $.
    ldualsmul.w $e |- ( ph -> W e. V ) $.
    ldualsmul.x $e |- ( ph -> X e. K ) $.
    ldualsmul.y $e |- ( ph -> Y e. K ) $.
    $( Scalar multiplication for the dual of a vector space.  (Contributed by
       NM, 19-Oct-2014.)  (Revised by Mario Carneiro, 22-Sep-2015.) $)
    ldualsmul $p |- ( ph -> ( X .xb Y ) = ( Y .x. X ) ) $=
      ( co coppr cfv cmulr eqid ldualsca fveq2d syl5eq oveqd opprmul syl6eq ) A
      JKDUAJKFUBUCZUDUCZUAKJEUAADUMJKADCUDUCUMQACULUDABCFULIHLULUEZOPRUFUGUHUIG
      FUMEULJKMNUNUMUEUJUK $.
  $}

  ${
    $d f k F $.  $d f k G $.  $d f k K $.  $d f k .X. $.  $d f k V $.
    $d f k W $.  $d f k X $.
    ldualfvs.f $e |- F = ( LFnl ` W ) $.
    ldualfvs.v $e |- V = ( Base ` W ) $.
    ldualfvs.r $e |- R = ( Scalar ` W ) $.
    ldualfvs.k $e |- K = ( Base ` R ) $.
    ldualfvs.t $e |- .X. = ( .r ` R ) $.
    ldualfvs.d $e |- D = ( LDual ` W ) $.
    ldualfvs.s $e |- .xb = ( .s ` D ) $.
    ldualfvs.w $e |- ( ph -> W e. Y ) $.
    ${
      ldualfvs.m $e |- .x.
           = ( k e. K , f e. F |-> ( f oF .X. ( V X. { k } ) ) ) $.
      $( Scalar product operation for the dual of a vector space.  (Contributed
         by NM, 18-Oct-2014.) $)
      ldualfvs $p |- ( ph -> .xb = .x. ) $=
        ( cvsca cfv cnx cbs cop cplusg cof cxp cres csca coppr ctp cv csn cmpt2
        co cun eqid ldualset fveq2d wcel wceq fvex eqeltri clfn mpt2ex lmodvsca
        cvv ax-mp eqtri 3eqtr4g ) ABUCUDUEUFUDIUGUEUHUDCUHUDZUIIIUJUKZUGUEULUDC
        UMUDZUGUNUEUCUDHGJIGUOKHUOUPUJFUIURZUQZUGUPUSZUCUDZDEABVSUCABVNVOCVRFGH
        IJVPKLMOVNUTVOUTNSPQRVPUTVRUTUAVAVBTEVRVTUBVRVJVCVRVTVDHGJIVQJCUFUDVJQC
        UFVEVFILVGUDVJNLVGVEVFVHIVOVRVPVSVJVSUTVIVKVLVM $.
    $}

    ldualvs.x $e |- ( ph -> X e. K ) $.
    ldualvs.g $e |- ( ph -> G e. F ) $.
    $( Scalar product operation value (which is a functional) for the dual of a
       vector space.  (Contributed by NM, 18-Oct-2014.) $)
    ldualvs $p |- ( ph -> ( X .xb G ) = ( G oF .X. ( V X. { X } ) ) ) $=
      ( vk vf co cv csn cxp cof cmpt2 eqid ldualfvs oveqd wcel wceq sneq xpeq2d
      oveq2d oveq1 ovex ovmpt2 syl2anc eqtrd ) AKGDUEKGUCUDHFUDUFZIUCUFZUGZUHZE
      UIZUEZUJZUEZGIKUGZUHZVHUEZADVJKGABCDVJEUDUCFHIJLMNOPQRSTVJUKZULUMAKHUNGFU
      NVKVNUOUAUBUCUDKGHFVIVNVJVDVMVHUEVEKUOZVGVMVDVHVPVFVLIVEKUPUQURVDGVMVHUSV
      OGVMVHUTVAVBVC $.

    ldualvs.a $e |- ( ph -> A e. V ) $.
    $( Value of scalar product operation value for the dual of a vector space.
       (Contributed by NM, 18-Oct-2014.) $)
    ldualvsval $p |- ( ph -> ( ( X .xb G ) ` A ) = ( ( G ` A ) .X. X ) ) $=
      ( co cfv csn cxp cof ldualvs fveq1d wcel wceq cvv cbs fvex eqeltri a1i wf
      wfn lflf syl2anc ffn syl wa eqidd ofc2 mpdan eqtrd ) ABLHEUEZUFBHJLUGUHFU
      IUEZUFZBHUFZLFUEZABVJVKACDEFGHIJKLMNOPQRSTUAUBUCUJUKABJULZVLVNUMUDAJLVMFH
      UNIBJUNULAJKUOUFUNOKUOUPUQURUBAJIHUSZHJUTAKMULHGULVPUAUCDGHIJKMPQONVAVBJI
      HVCVDAVOVEVMVFVGVHVI $.
  $}

  ${
    ldualvscl.f $e |- F = ( LFnl ` W ) $.
    ldualvscl.r $e |- R = ( Scalar ` W ) $.
    ldualvscl.k $e |- K = ( Base ` R ) $.
    ldualvscl.d $e |- D = ( LDual ` W ) $.
    ldualvscl.s $e |- .x. = ( .s ` D ) $.
    ldualvscl.w $e |- ( ph -> W e. LMod ) $.
    ldualvscl.x $e |- ( ph -> X e. K ) $.
    ldualvscl.g $e |- ( ph -> G e. F ) $.
    $( The scalar product operation value is a functional.  (Contributed by NM,
       18-Oct-2014.) $)
    ldualvscl $p |- ( ph -> ( X .x. G ) e. F ) $=
      ( co cfv eqid cbs csn cxp cmulr cof clmod ldualvs lflvscl eqeltrd ) AIFDR
      FHUASZIUBUCCUDSZUEREABCDUKEFGUJHIUFJUJTZKLUKTZMNOPQUGACIUKEFGUJHULKLUMJOQ
      PUHUI $.
  $}

  ${
    ldualvaddcom.f $e |- F = ( LFnl ` W ) $.
    ldualvaddcom.d $e |- D = ( LDual ` W ) $.
    ldualvaddcom.p $e |- .+ = ( +g ` D ) $.
    ldualvaddcom.w $e |- ( ph -> W e. LMod ) $.
    ldualvaddcom.x $e |- ( ph -> X e. F ) $.
    ldualvaddcom.y $e |- ( ph -> Y e. F ) $.
    $( Commutative law for vector (functional) addition.  (Contributed by NM,
       17-Jan-2015.) $)
    ldualvaddcom $p |- ( ph -> ( X .+ Y ) = ( Y .+ X ) ) $=
      ( csca cfv cplusg co eqid clmod ldualvadd cof lfladdcom 3eqtr4d ) AFGENOZ
      POZUAZQGFUFQFGCQGFCQAUEUDDFGEUDRZUERZHKLMUBABUECUDDFGESHUGUHIJKLMTABUECUD
      DGFESHUGUHIJKMLTUC $.
  $}

  ${
    ldualvsass.f $e |- F = ( LFnl ` W ) $.
    ldualvsass.r $e |- R = ( Scalar ` W ) $.
    ldualvsass.k $e |- K = ( Base ` R ) $.
    ldualvsass.t $e |- .X. = ( .r ` R ) $.
    ldualvsass.d $e |- D = ( LDual ` W ) $.
    ldualvsass.s $e |- .x. = ( .s ` D ) $.
    ldualvsass.w $e |- ( ph -> W e. LMod ) $.
    ldualvsass.x $e |- ( ph -> X e. K ) $.
    ldualvsass.y $e |- ( ph -> Y e. K ) $.
    ldualvsass.g $e |- ( ph -> G e. F ) $.
    $( Associative law for scalar product operation.  (Contributed by NM,
       20-Oct-2014.) $)
    ldualvsass $p |- ( ph -> ( ( Y .X. X ) .x. G ) = ( X .x. ( Y .x. G ) ) ) $=
      ( co cbs cfv csn cxp cof eqid lflvsass clmod crg wcel lmodrng syl syl3anc
      rngcl ldualvs lflvscl 3eqtr4d oveq2d eqtr4d ) AKJEUBZGDUBZJGIUCUDZKUEUFEU
      GZUBZDUBZJKGDUBZDUBAGVDVBUEUFVEUBVFVDJUEUFVEUBVCVGACEFGHVDIKJVDUHZMNOLRTS
      UAUIABCDEFGHVDIVBUJLVIMNOPQRACUKULZKHULJHULVBHULAIUJULVJRCIMUMUNTSHCEKJNO
      UPUOUAUQABCDEFVFHVDIJUJLVIMNOPQRSACKEFGHVDIVIMNOLRUATURUQUSAVHVFJDABCDEFG
      HVDIKUJLVIMNOPQRTUAUQUTVA $.
  $}

  ${
    ldualvsass2.f $e |- F = ( LFnl ` W ) $.
    ldualvsass2.r $e |- R = ( Scalar ` W ) $.
    ldualvsass2.k $e |- K = ( Base ` R ) $.
    ldualvsass2.d $e |- D = ( LDual ` W ) $.
    ldualvsass2.q $e |- Q = ( Scalar ` D ) $.
    ldualvsass2.t $e |- .X. = ( .r ` Q ) $.
    ldualvsass2.s $e |- .x. = ( .s ` D ) $.
    ldualvsass2.w $e |- ( ph -> W e. LMod ) $.
    ldualvsass2.x $e |- ( ph -> X e. K ) $.
    ldualvsass2.y $e |- ( ph -> Y e. K ) $.
    ldualvsass2.g $e |- ( ph -> G e. F ) $.
    $( Associative law for scalar product operation, using operations from the
       dual space.  (Contributed by NM, 20-Oct-2014.) $)
    ldualvsass2 $p |- ( ph ->
      ( ( X .X. Y ) .x. G ) = ( X .x. ( Y .x. G ) ) ) $=
      ( co cmulr cfv clmod eqid ldualsmul oveq1d ldualvsass eqtrd ) AKLFUDZHEUD
      LKDUEUFZUDZHEUDKLHEUDEUDAUMUOHEABCFUNDIUGJKLNOUNUHZPQRTUAUBUIUJABDEUNGHIJ
      KLMNOUPPSTUAUBUCUKUL $.
  $}

  ${
    ldualvsdi1.f $e |- F = ( LFnl ` W ) $.
    ldualvsdi1.r $e |- R = ( Scalar ` W ) $.
    ldualvsdi1.k $e |- K = ( Base ` R ) $.
    ldualvsdi1.d $e |- D = ( LDual ` W ) $.
    ldualvsdi1.p $e |- .+ = ( +g ` D ) $.
    ldualvsdi1.s $e |- .x. = ( .s ` D ) $.
    ldualvsdi1.w $e |- ( ph -> W e. LMod ) $.
    ldualvsdi1.x $e |- ( ph -> X e. K ) $.
    ldualvsdi1.g $e |- ( ph -> G e. F ) $.
    ldualvsdi1.h $e |- ( ph -> H e. F ) $.
    $( Distributive law for scalar product operation, using operations from the
       dual space.  (Contributed by NM, 21-Oct-2014.) $)
    ldualvsdi1 $p |- ( ph
        -> ( X .x. ( G .+ H ) ) = ( ( X .x. G ) .+ ( X .x. H ) ) ) $=
      ( cplusg cfv cof cbs csn cxp cmulr clmod eqid ldualvs ldualvscl ldualvadd
      co oveq12d ldualvaddcl oveq1d lflvsdi1 3eqtrd 3eqtr4rd ) AKGEUNZKHEUNZDUB
      UCZUDZUNGJUEUCZKUFUGZDUHUCZUDZUNZHVFVHUNZVDUNZVAVBCUNKGHCUNZEUNZAVAVIVBVJ
      VDABDEVGFGIVEJKUILVEUJZMNVGUJZOQRSTUKABDEVGFHIVEJKUILVNMNVOOQRSUAUKUOABVC
      CDFVAVBJUILMVCUJZOPRABDEFGIJKLMNOQRSTULABDEFHIJKLMNOQRSUAULUMAVMVLVFVHUNG
      HVDUNZVFVHUNVKABDEVGFVLIVEJKUILVNMNVOOQRSABCFGHJLOPRTUAUPUKAVLVQVFVHABVCC
      DFGHJUILMVPOPRTUAUMUQAVCDVGFGHIVEJKVNMNVPVOLRSTUAURUSUT $.
  $}

  ${
    ldualvsdi2.f $e |- F = ( LFnl ` W ) $.
    ldualvsdi2.r $e |- R = ( Scalar ` W ) $.
    ldualvsdi2.a $e |- .+ = ( +g ` R ) $.
    ldualvsdi2.k $e |- K = ( Base ` R ) $.
    ldualvsdi2.d $e |- D = ( LDual ` W ) $.
    ldualvsdi2.p $e |- .+b = ( +g ` D ) $.
    ldualvsdi2.s $e |- .x. = ( .s ` D ) $.
    ldualvsdi2.w $e |- ( ph -> W e. LMod ) $.
    ldualvsdi2.x $e |- ( ph -> X e. K ) $.
    ldualvsdi2.y $e |- ( ph -> Y e. K ) $.
    ldualvsdi2.g $e |- ( ph -> G e. F ) $.
    $( Reverse distributive law for scalar product operation, using operations
       from the dual space.  (Contributed by NM, 21-Oct-2014.) $)
    ldualvsdi2 $p |- ( ph
        -> ( ( X .+ Y ) .x. G ) = ( ( X .x. G ) .+b ( Y .x. G ) ) ) $=
      ( cbs cfv csn cxp cmulr clmod eqid wcel lmodacl syl3anc ldualvs lflvsdi2a
      co cof ldualvscl ldualvadd oveq12d eqtr2d 3eqtrd ) AKLCUPZHFUPHJUDUEZVCUF
      UGEUHUEZUQZUPHVDKUFUGVFUPZHVDLUFUGVFUPZCUQZUPZKHFUPZLHFUPZDUPZABEFVEGHIVD
      JVCUIMVDUJZNPVEUJZQSTAJUIUKKIUKLIUKVCIUKTUAUBCEIJKLNPOULUMUCUNACEVEGHIVDJ
      KLVNNPOVOMTUAUBUCUOAVMVKVLVIUPVJABCDEGVKVLJUIMNOQRTABEFGHIJKMNPQSTUAUCURA
      BEFGHIJLMNPQSTUBUCURUSAVKVGVLVHVIABEFVEGHIVDJKUIMVNNPVOQSTUAUCUNABEFVEGHI
      VDJLUIMVNNPVOQSTUBUCUNUTVAVB $.
  $}

  ${
    $d x y z D $.  $d x y z F $.  $d x y z ph $.  $d x y z R $.  $d x y z V $.
    $d z W $.
    ldualgrp.d $e |- D = ( LDual ` W ) $.
    ldualgrp.w $e |- ( ph -> W e. LMod ) $.
    ${
      ldualgrp.v $e |- V = ( Base ` W ) $.
      ldualgrp.p $e |- .+ = oF ( +g ` W ) $.
      ldualgrp.f $e |- F = ( LFnl ` W ) $.
      ldualgrp.r $e |- R = ( Scalar ` W ) $.
      ldualgrp.k $e |- K = ( Base ` R ) $.
      ldualgrp.t $e |- .X. = ( .r ` R ) $.
      ldualgrp.o $e |- O = ( oppR ` R ) $.
      ldualgrp.s $e |- .x. = ( .s ` D ) $.
      $( Lemma for ~ ldualgrp .  (Contributed by NM, 22-Oct-2014.) $)
      ldualgrplem $p |- ( ph -> D e. Grp ) $=
        ( vx vy vz cplusg cfv cv cminusg cmpt c0g csn cxp clmod eqid ldualvbase
        cbs eqcomd eqidd wcel w3a 3ad2ant1 simp2 simp3 ldualvaddcl wa co adantr
        cof simpr2 simpr3 ldualvadd oveq2d simpr1 oveq1d lfladdass 3eqtrd lfl0f
        3eqtr4rd syl simpr lfladd0l eqtrd lflnegcl lflnegl isgrpd ) AUBUCUDGBUE
        UFZBUDJUDUGZUBUGZUFDUHUFZUFUIZJDUJUFZUKULZABUPUFZGABGWMKUMPLWMUNMUOUQAW
        FURAWHGUSZUCUGZGUSZUTBWFGWHWOKPLWFUNZAWNKUMUSZWPMVAAWNWPVBAWNWPVCVDAWNW
        PWGGUSZUTZVEZWHWOWGWFVFZDUEUFZVHZVFWHWOWGXDVFZXDVFZWHXBWFVFWHWOWFVFZWGW
        FVFZXAXBXEWHXDXABXCWFDGWOWGKUMPQXCUNZLWQAWRWTMVGZAWNWPWSVIZAWNWPWSVJZVK
        VLXABXCWFDGWHXBKUMPQXILWQXJAWNWPWSVMZXABWFGWOWGKPLWQXJXKXLVDVKXAXHXGWGX
        DVFWHWOXDVFZWGXDVFXFXABXCWFDGXGWGKUMPQXILWQXJXABWFGWHWOKPLWQXJXMXKVDXLV
        KXAXGXNWGXDXABXCWFDGWHWOKUMPQXILWQXJXMXKVKVNXAXCDGWHWOWGKQXIPXJXMXKXLVO
        VPVRAWRWLGUSZMDGJKWKQWKUNZNPVQVSZAWNVEZWLWHWFVFWLWHXDVFWHXRBXCWFDGWLWHK
        UMPQXILWQAWRWNMVGZAXOWNXQVGAWNVTZVKXRXCDGWHJKWKNQXIXPPXSXTWAWBXRUDDGWHW
        IWJJKNQWIUNZWJUNZPXSXTWCZXRWJWHWFVFWJWHXDVFWLXRBXCWFDGWJWHKUMPQXILWQXSY
        CXTVKXRUDXCDGWHWIWJJKWKNQYAYBPXSXTXIXPWDWBWE $.
    $}

    $( The dual of a vector space is a group.  (Contributed by NM,
       21-Oct-2014.) $)
    ldualgrp $p |- ( ph -> D e. Grp ) $=
      ( cplusg cfv cof csca cvsca cmulr clfn cbs coppr eqid ldualgrplem ) ABCFG
      HZCIGZBJGZRKGZCLGZRMGZRNGZCMGZCDEUDOQOUAOROUBOTOUCOSOP $.
  $}

  ${
    ldual0.r $e |- R = ( Scalar ` W ) $.
    ldual0.z $e |- .0. = ( 0g ` R ) $.
    ldual0.d $e |- D = ( LDual ` W ) $.
    ldual0.s $e |- S = ( Scalar ` D ) $.
    ldual0.o $e |- O = ( 0g ` S ) $.
    ldual0.w $e |- ( ph -> W e. LMod ) $.
    $( The zero scalar of the dual of a vector space.  (Contributed by NM,
       28-Dec-2014.) $)
    ldual0 $p |- ( ph -> O = .0. ) $=
      ( c0g cfv coppr clmod eqid ldualsca fveq2d oppr0 3eqtr4g ) ADNOCPOZNOEGAD
      UCNABDCUCFQHUCRZJKMSTLCUCGUDIUAUB $.
  $}

  ${
    ldual1.r $e |- R = ( Scalar ` W ) $.
    ldual1.u $e |- .1. = ( 1r ` R ) $.
    ldual1.d $e |- D = ( LDual ` W ) $.
    ldual1.s $e |- S = ( Scalar ` D ) $.
    ldual1.i $e |- I = ( 1r ` S ) $.
    ldual1.w $e |- ( ph -> W e. LMod ) $.
    $( The unit scalar of the dual of a vector space.  (Contributed by NM,
       26-Feb-2015.) $)
    ldual1 $p |- ( ph -> I = .1. ) $=
      ( cur cfv coppr clmod eqid ldualsca fveq2d oppr1 3eqtr4g ) ADNOCPOZNOFEAD
      UCNABDCUCGQHUCRZJKMSTLCEUCUDIUAUB $.
  $}

  ${
    ldualneg.r $e |- R = ( Scalar ` W ) $.
    ldualneg.m $e |- M = ( invg ` R ) $.
    ldualneg.d $e |- D = ( LDual ` W ) $.
    ldualneg.s $e |- S = ( Scalar ` D ) $.
    ldualneg.n $e |- N = ( invg ` S ) $.
    ldualneg.w $e |- ( ph -> W e. LMod ) $.
    $( The negative of a scalar of the dual of a vector space.  (Contributed by
       NM, 26-Feb-2015.) $)
    ldualneg $p |- ( ph -> N = M ) $=
      ( cminusg cfv coppr clmod eqid ldualsca fveq2d opprneg 3eqtr4g ) ADNOCPOZ
      NOFEADUCNABDCUCGQHUCRZJKMSTLCEUCUDIUAUB $.
  $}

  ${
    ldualv0.v $e |- V = ( Base ` W ) $.
    ldualv0.r $e |- R = ( Scalar ` W ) $.
    ldualv0.z $e |- .0. = ( 0g ` R ) $.
    ldualv0.d $e |- D = ( LDual ` W ) $.
    ldualv0.o $e |- O = ( 0g ` D ) $.
    ldualv0.w $e |- ( ph -> W e. LMod ) $.
    $( The zero vector of the dual of a vector space.  (Contributed by NM,
       24-Oct-2014.) $)
    ldual0v $p |- ( ph -> O = ( V X. { .0. } ) ) $=
      ( cplusg cfv co wceq clmod eqid wcel csn cxp cof clfn lfl0f syl ldualvadd
      lfladd0l eqtrd cgrp cbs wb ldualgrp ldualelvbase grpid syl2anc mpbid ) AE
      GUAUBZURBNOZPZURQZDURQZAUTURURCNOZUCPURABVCUSCFUDOZURURFRVDSZIVCSZKUSSZMA
      FRTURVDTMCVDEFGIJHVEUEUFZVHUGAVCCVDUREFGHIVFJVEMVHUHUIABUJTURBUKOZTVAVBUL
      ABFKMUMABVDURVIFRVEKVISZMVHUNVIUSBURDVJVGLUOUPUQ $.
  $}

  ${
    ldualv0cl.f $e |- F = ( LFnl ` W ) $.
    ldualv0cl.d $e |- D = ( LDual ` W ) $.
    ldualv0cl.o $e |- .0. = ( 0g ` D ) $.
    ldualv0cl.w $e |- ( ph -> W e. LMod ) $.
    $( The dual zero vector is a functional.  (Contributed by NM,
       5-Mar-2015.) $)
    ldual0vcl $p |- ( ph -> .0. e. F ) $=
      ( cbs cfv csca c0g csn cxp eqid ldual0v clmod wcel lfl0f syl eqeltrd ) AE
      DJKZDLKZMKZNOZCABUDEUCDUEUCPZUDPZUEPZGHIQADRSUFCSIUDCUCDUEUHUIUGFTUAUB $.
  $}

  ${
    $d x y z D $.  $d x y z F $.  $d x y z K $.  $d x y z R $.  $d x y z .x. $.
    $d x y z ph $.
    lduallmod.d $e |- D = ( LDual ` W ) $.
    lduallmod.w $e |- ( ph -> W e. LMod ) $.
    ${
      lduallmod.v $e |- V = ( Base ` W ) $.
      lduallmod.p $e |- .+ = oF ( +g ` W ) $.
      lduallmod.f $e |- F = ( LFnl ` W ) $.
      lduallmod.r $e |- R = ( Scalar ` W ) $.
      lduallmod.k $e |- K = ( Base ` R ) $.
      lduallmod.t $e |- .X. = ( .r ` R ) $.
      lduallmod.o $e |- O = ( oppR ` R ) $.
      lduallmod.s $e |- .x. = ( .s ` D ) $.
      $( Lemma for ~ lduallmod .  (Contributed by NM, 22-Oct-2014.) $)
      lduallmodlem $p |- ( ph -> D e. LMod ) $=
        ( vx vy vz cplusg cfv csca cmulr cur clmod eqid ldualvbase eqcomd eqidd
        cbs ldualsca cvsca wceq a1i opprbas oppradd fveq2d wcel lmodrng opprrng
        oppr1 crg 3syl ldualgrp cv w3a 3ad2ant1 simp2 simp3 ldualvscl wa adantr
        simpr1 simpr2 simpr3 ldualvsdi1 ldualvsdi2 ldualvsass2 co csn cxp simpr
        cof rngidcl ldualvs lfl1sc eqtrd islmodd ) AUBUCUDHBUEUFZDUEUFZEBUGUFZU
        HUFZDUIUFZIGBABUOUFZGABGWSKUJPLWSUKMULUMAWNUNAWPIABWPDIKUJQTLWPUKZMUPZU
        MEBUQUFURAUAUSHIUOUFURAHDITRUTUSWOIUEUFURAWODITWOUKZVAUSAWPIUHXAVBWRIUI
        UFURADWRITWRUKZVFUSAKUJVCZDVGVCZIVGVCMDKQVDZDITVEVHABKLMVIAUBVJZHVCZUCV
        JZGVCZVKBDEGXIHKXGPQRLUAAXHXDXJMVLAXHXJVMAXHXJVNVOAXHXJUDVJZGVCZVKZVPBW
        NDEGXIXKHKXGPQRLWNUKZUAAXDXMMVQAXHXJXLVRAXHXJXLVSAXHXJXLVTWAAXHXIHVCZXL
        VKZVPZBWOWNDEGXKHKXGXIPQXBRLXNUAAXDXPMVQZAXHXOXLVRZAXHXOXLVSZAXHXOXLVTZ
        WBXQBWPDEWQGXKHKXGXIPQRLWTWQUKUAXRXSXTYAWCAXGGVCZVPZWRXGEWDXGJWRWEWFFWH
        WDXGYCBDEFGXGHJKWRUJPNQRSLUAAXDYBMVQZAWRHVCZYBAXDXEYEMXFHDWRRXCWIVHVQAY
        BWGZWJYCDFWRGXGHJKNQPRSXCYDYFWKWLWM $.
    $}

    $( The dual of a left module is also a left module.  (Contributed by NM,
       22-Oct-2014.) $)
    lduallmod $p |- ( ph -> D e. LMod ) $=
      ( cplusg cfv cof csca cvsca cmulr clfn cbs coppr eqid lduallmodlem ) ABCF
      GHZCIGZBJGZRKGZCLGZRMGZRNGZCMGZCDEUDOQOUAOROUBOTOUCOSOP $.
  $}

  ${
    $d x y z D $.  $d x y z F $.  $d x y z K $.  $d x y z R $.  $d x y z S $.
    $d x y z ph $.
    lduallvec.d $e |- D = ( LDual ` W ) $.
    lduallvec.w $e |- ( ph -> W e. LVec ) $.
    $( The dual of a left vector space is also a left vector space.  Note that
       scalar multiplication is reversed by ~ df-oppr ; otherwise, the dual
       would be a right vector space as is sometimes the case in the
       literature.  (Contributed by NM, 22-Oct-2014.) $)
    lduallvec $p |- ( ph -> D e. LVec ) $=
      ( clmod wcel cfv cdr clvec lveclmod syl lduallmod coppr ldualsca lvecdrng
      csca eqid opprdrng sylib eqeltrd islvec sylanbrc ) ABFGBQHZIGBJGABCDACJGZ
      CFGECKLMAUDCQHZNHZIABUDUFUGCJUFRZUGRZDUDRZEOAUFIGZUGIGAUEUKEUFCUHPLUFUGUI
      STUAUDBUJUBUC $.
  $}

  ${
    ldualvsub.r $e |- R = ( Scalar ` W ) $.
    ldualvsub.n $e |- N = ( invg ` R ) $.
    ldualvsub.u $e |- .1. = ( 1r ` R ) $.
    ldualvsub.f $e |- F = ( LFnl ` W ) $.
    ldualvsub.d $e |- D = ( LDual ` W ) $.
    ldualvsub.p $e |- .+ = ( +g ` D ) $.
    ldualvsub.t $e |- .x. = ( .s ` D ) $.
    ldualvsub.m $e |- .- = ( -g ` D ) $.
    ldualvsub.w $e |- ( ph -> W e. LMod ) $.
    ldualvsub.g $e |- ( ph -> G e. F ) $.
    ldualvsub.h $e |- ( ph -> H e. F ) $.
    $( The value of vector subtraction in the dual of a vector space.
       (Contributed by NM, 27-Feb-2015.) $)
    ldualvsub $p |- ( ph -> ( G .- H ) = ( G .+ ( ( N ` .1. ) .x. H ) ) ) $=
      ( co csca cfv cur cminusg clmod wcel cbs wceq lduallmod eqid ldualelvbase
      lmodvsubval2 syl3anc coppr ldualsca fveq2d opprneg syl6reqr oppr1 fveq12d
      oveq1d oveq2d eqtr4d ) AHIJUDZHBUEUFZUGUFZVIUHUFZUFZIEUDZCUDZHFKUFZIEUDZC
      UDABUIUJHBUKUFZUJIVQUJVHVNULABLQUAUMABGHVQLUIPQVQUNZUAUBUOABGIVQLUIPQVRUA
      UCUOHICEVJVIJVKVQBVRRTVIUNZSVKUNVJUNUPUQAVPVMHCAVOVLIEAFVJKVKAVKDURUFZUHU
      FKAVIVTUHABVIDVTLUIMVTUNZQVSUAUSZUTDKVTWANVAVBAVJVTUGUFFAVIVTUGWBUTDFVTWA
      OVCVBVDVEVFVG $.
  $}

  ${
    ldualvsubcl.f $e |- F = ( LFnl ` W ) $.
    ldualvsubcl.d $e |- D = ( LDual ` W ) $.
    ldualvsubcl.m $e |- .- = ( -g ` D ) $.
    ldualvsubcl.w $e |- ( ph -> W e. LMod ) $.
    ldualvsubcl.g $e |- ( ph -> G e. F ) $.
    ldualvsubcl.h $e |- ( ph -> H e. F ) $.
    $( Closure of vector subtraction in the dual of a vector space.
       (Contributed by NM, 27-Feb-2015.) $)
    ldualvsubcl $p |- ( ph -> ( G .- H ) e. F ) $=
      ( co csca cfv cur eqid wcel syl cminusg cvsca cplusg ldualvsub cgrp clmod
      cbs lmodrng rnggrp rngidcl grpinvcl syl2anc ldualvscl ldualvaddcl eqeltrd
      crg ) ADEFNDGOPZQPZUQUAPZPZEBUBPZNZBUCPZNCABVCUQVAURCDEFUSGUQRZUSRZURRZHI
      VCRZVARZJKLMUDABVCCDVBGHIVGKLABUQVACEUQUGPZGUTHVDVIRZIVHKAUQUESZURVISZUTV
      ISAUQUPSZVKAGUFSVMKUQGVDUHTZUQUITAVMVLVNVIUQURVJVFUJTVIUQUSURVJVEUKULMUMU
      NUO $.
  $}

  ${
    ldualvsubval.v $e |- V = ( Base ` W ) $.
    ldualvsubval.r $e |- R = ( Scalar ` W ) $.
    ldualvsubval.s $e |- S = ( -g ` R ) $.
    ldualvsubval.f $e |- F = ( LFnl ` W ) $.
    ldualvsubval.d $e |- D = ( LDual ` W ) $.
    ldualvsubval.m $e |- .- = ( -g ` D ) $.
    ldualvsubval.w $e |- ( ph -> W e. LMod ) $.
    ldualvsubval.g $e |- ( ph -> G e. F ) $.
    ldualvsubval.h $e |- ( ph -> H e. F ) $.
    ldualvsubval.x $e |- ( ph -> X e. V ) $.
    $( The value of the value of vector subtraction in the dual of a vector
       space.  TODO: shorten with ~ ldualvsub ?  (Requires ` D ` to ` oppR `
       conversion.)  (Contributed by NM, 26-Feb-2015.) $)
    ldualvsubval $p |- ( ph
             -> ( ( G .- H ) ` X ) = ( ( G ` X ) S ( H ` X ) ) ) $=
      ( co cfv csca cur cminusg cvsca cplusg clmod wcel cbs wceq lduallmod eqid
      ldualelvbase lmodvsubval2 syl3anc fveq1d lmodfgrp syl crg lmodrng rngidcl
      grpinvcl syl2anc ldualsbase eleqtrd ldualvscl ldualvaddval cmulr ldualneg
      cgrp ldual1 fveq12d oveq1d rnggrp lmod1cl ldualvsval lflcl rngnegr 3eqtrd
      oveq2d grpsubval eqtr4d ) AKFGHUBZUCKFBUDUCZUEUCZWFUFUCZUCZGBUGUCZUBZBUHU
      CZUBZUCKFUCZKWKUCZCUHUCZUBZWNKGUCZDUBZAKWEWMABUIUJZFBUKUCZUJGXAUJWEWMULAB
      JPRUMZABEFXAJUIOPXAUNZRSUOABEGXAJUIOPXCRTUOFGWLWJWGWFHWHXABXCWLUNZQWFUNZW
      JUNZWHUNZWGUNZUPUQURABWPWLCEFWKIJKLMWPUNZOPXDRSABCWJEGCUKUCZJWIOMXJUNZPXF
      RAWIWFUKUCZXJAWFVLUJZWGXLUJZWIXLUJAWTXMXBWFBXEUSUTAWFVAUJZXNAWTXOXBWFBXEV
      BUTXLWFWGXLUNZXHVCUTXLWFWHWGXPXGVDVEABWFCXLXJUIJMXKPXEXPRVFVGTVHUAVIAWQWN
      WRCUFUCZUCZWPUBZWSAWOXRWNWPAWOKCUEUCZXQUCZGWJUBZUCWRYACVJUCZUBXRAKWKYBAWI
      YAGWJAWGXTWHXQABCWFXQWHJMXQUNZPXEXGRVKABCWFXTWGJMXTUNZPXEXHRVMVNVOURAKBCW
      JYCEGXJIJYAUIOLMXKYCUNZPXFRACVLUJZXTXJUJZYAXJUJACVAUJZYGAJUIUJZYIRCJMVBUT
      ZCVPUTAYJYHRXTCXJJMXKYEVQUTXJCXQXTXKYDVDVETUAVRAXJCYCXTXQWRXKYFYEYDYKAYJG
      EUJKIUJZWRXJUJZRTUACEGXJIJKUIMXKLOVSUQZVTWAWBAWNXJUJZYMWSXSULAYJFEUJYLYOR
      SUACEFXJIJKUIMXKLOVSUQYNXJWPCXQDWNWRXKXIYDNWCVEWDWA $.
  $}

  ${
    ldualssvscl.r $e |- R = ( Scalar ` W ) $.
    ldualssvscl.k $e |- K = ( Base ` R ) $.
    ldualssvscl.d $e |- D = ( LDual ` W ) $.
    ldualssvscl.t $e |- .x. = ( .s ` D ) $.
    ldualssvscl.s $e |- S = ( LSubSp ` D ) $.
    ldualssvscl.w $e |- ( ph -> W e. LMod ) $.
    ldualssvscl.u $e |- ( ph -> U e. S ) $.
    ldualssvscl.x $e |- ( ph -> X e. K ) $.
    ldualssvscl.y $e |- ( ph -> Y e. U ) $.
    $( Closure of scalar product in a dual subspace.)  (Contributed by NM,
       5-Feb-2015.) $)
    ldualssvscl $p |- ( ph -> ( X .x. Y ) e. U ) $=
      ( wcel clmod csca cfv lduallmod eqid ldualsbase eleqtrrd lssvscl syl22anc
      cbs co ) ABUATFDTIBUBUCZUJUCZTJFTIJEUKFTABHMPUDQAIGUMRABULCUMGUAHKLMULUEZ
      UMUEZPUFUGSUMDEFULBIJUNNUOOUHUI $.
  $}

  ${
    ldualssvsubcl.d $e |- D = ( LDual ` W ) $.
    ldualssvsubcl.m $e |- .- = ( -g ` D ) $.
    ldualssvsubcl.s $e |- S = ( LSubSp ` D ) $.
    ldualssvsubcl.w $e |- ( ph -> W e. LMod ) $.
    ldualssvsubcl.u $e |- ( ph -> U e. S ) $.
    ldualssvsubcl.x $e |- ( ph -> X e. U ) $.
    ldualssvsubcl.y $e |- ( ph -> Y e. U ) $.
    $( Closure of vector subtraction in a dual subspace.)  (Contributed by NM,
       9-Mar-2015.) $)
    ldualssvsubcl $p |- ( ph -> ( X .- Y ) e. U ) $=
      ( clmod wcel co lduallmod lssvsubcl syl22anc ) ABPQDCQGDQHDQGHERDQABFILSM
      NOCDEBGHJKTUA $.
  $}

  ${
    ldual0vs.f $e |- F = ( LFnl ` W ) $.
    ldual0vs.r $e |- R = ( Scalar ` W ) $.
    ldual0vs.z $e |- .0. = ( 0g ` R ) $.
    ldual0vs.d $e |- D = ( LDual ` W ) $.
    ldual0vs.t $e |- .x. = ( .s ` D ) $.
    ldual0vs.o $e |- O = ( 0g ` D ) $.
    ldual0vs.w $e |- ( ph -> W e. LMod ) $.
    ldual0vs.g $e |- ( ph -> G e. F ) $.
    $( Scalar zero times a functional is the zero functional.  (Contributed by
       NM, 17-Feb-2015.) $)
    ldual0vs $p |- ( ph -> ( .0. .x. G ) = O ) $=
      ( cfv co eqid csca c0g ldual0 oveq1d wcel cbs wceq lduallmod ldualelvbase
      clmod lmod0vs syl2anc eqtr3d ) ABUARZUBRZFDSZIFDSGAUOIFDABCUNUOHIKLMUNTZU
      OTZPUCUDABUJUEFBUFRZUEUPGUGABHMPUHABEFUSHUJJMUSTZPQUIDUNUOUSBFGUTUQNUROUK
      ULUM $.
  $}

  ${
    lkr0f2.v $e |- V = ( Base ` W ) $.
    lkr0f2.f $e |- F = ( LFnl ` W ) $.
    lkr0f2.k $e |- K = ( LKer ` W ) $.
    lkr0f2.d $e |- D = ( LDual ` W ) $.
    lkr0f2.o $e |- .0. = ( 0g ` D ) $.
    lkr0f2.w $e |- ( ph -> W e. LMod ) $.
    lkr0f2.g $e |- ( ph -> G e. F ) $.
    $( The kernel of the zero functional is the set of all vectors.
       (Contributed by NM, 4-Feb-2015.) $)
    lkr0f2 $p |- ( ph -> ( ( K ` G ) = V <-> G = .0. ) ) $=
      ( cfv wceq csca wcel eqid c0g csn cxp clmod syl2anc ldual0v eqeq2d bitr4d
      wb lkr0f ) ADEPFQZDFGRPZUAPZUBUCZQZDHQAGUDSDCSUKUOUINOULCDEFGUMULTZUMTZIJ
      KUJUEAHUNDABULHFGUMIUPUQLMNUFUGUH $.
  $}

  ${
    lduallkr3.h $e |- H = ( LSHyp ` W ) $.
    lduallkr3.f $e |- F = ( LFnl ` W ) $.
    lduallkr3.k $e |- K = ( LKer ` W ) $.
    lduallkr3.d $e |- D = ( LDual ` W ) $.
    lduallkr3.o $e |- .0. = ( 0g ` D ) $.
    lduallkr3.w $e |- ( ph -> W e. LVec ) $.
    lduallkr3.g $e |- ( ph -> G e. F ) $.
    $( The kernels of nonzero functionals are hyperplanes.  (Contributed by NM,
       22-Feb-2015.) $)
    lduallkr3 $p |- ( ph -> ( ( K ` G ) e. H <-> G =/= .0. ) ) $=
      ( cfv wcel cbs wne eqid csca c0g csn cxp lkrshp3 clvec clmod lveclmod syl
      ldual0v neeq2d bitr4d ) ADFPEQDGRPZGUAPZUBPZUCUDZSDHSAUNCDEFUMGUOUMTZUNTZ
      UOTZIJKNOUEAHUPDABUNHUMGUOUQURUSLMAGUFQGUGQNGUHUIUJUKUL $.
  $}

  ${
    lkrpss.f $e |- F = ( LFnl ` W ) $.
    lkrpss.k $e |- K = ( LKer ` W ) $.
    lkrpss.d $e |- D = ( LDual ` W ) $.
    lkrpss.o $e |- .0. = ( 0g ` D ) $.
    lkrpss.w $e |- ( ph -> W e. LVec ) $.
    lkrpss.g $e |- ( ph -> G e. F ) $.
    lkrpss.h $e |- ( ph -> H e. F ) $.
    $( Proper subset relation between kernels.  (Contributed by NM,
       16-Feb-2015.)  (New usage is discouraged.) $)
    lkrpssN $p |- ( ph -> ( ( K ` G ) C. ( K ` H )
     <-> ( G =/= .0. /\ H = .0. ) ) ) $=
      ( cfv wne wceq wa simpr wpss cbs wss df-pss eqid clvec clmod lveclmod syl
      wcel lkrssv adantr psssstrd pssned sylan2br clsh simplr ad3antrrr simpllr
      wn ad2antrr eqsstr3d eqssd wb lkrshp4 necon1bbid mpbird pm2.21dd lkrshpor
      wo mpjaodan lshpcmp mpbid necon3ad impr jca simprr eqcomd sseqtrd neeqtrd
      ex simprl impbida syl5bb lkr0f2 necon3bid anbi12d bitrd ) ADFPZEFPZUAZWIG
      UBPZQZWJWLRZSZDHQZEHRZSWKWIWJUCZWIWJQZSZAWOWIWJUDZAWTWOAWTSZWMWNWTAWKWMXA
      AWKSZWIWLXCWIWJWLAWKTAWJWLUCZWKACEFWLGWLUEZIJAGUFUJZGUGUJMGUHUIZOUKZULUMU
      NUOXBWJGUPPZUJZUTZWNAWRWSXKAWRSZXJWIWJXLXJWIWJRZXLXJSZWRXMAWRXJUQXNWIWJXI
      GXIUEZAXFWRXJMVAXNWIXIUJZXPWIWLRZXNXPTXNXQSZXJXPXLXJXQUQXRXKWNXRWJWLAXDWR
      XJXQXHURXRWLWIWJXNXQTAWRXJXQUSVBVCXRXJWJWLAWJWLQXJVDWRXJXQACEXIFWLGXEXOIJ
      MOVEZURVFVGVHAXPXQVJWRXJACDXIFWLGXEXOIJMNVIVAVKXLXJTVLVMWAVNVOAXKWNVDWTAX
      JWJWLXSVFULVMVPAWOSZWRWSXTWIWLWJAWIWLUCWOACDFWLGXEIJXGNUKULXTWJWLAWMWNVQV
      RZVSXTWIWLWJAWMWNWBYAVTVPWCWDAWMWPWNWQAWIWLDHABCDFWLGHXEIJKLXGNWEWFABCEFW
      LGHXEIJKLXGOWEWGWH $.
  $}

  ${
    $d v G $.  $d v H $.  $d v K $.  $d v .+ $.  $d v ph $.
    lkrin.f $e |- F = ( LFnl ` W ) $.
    lkrin.k $e |- K = ( LKer ` W ) $.
    lkrin.d $e |- D = ( LDual ` W ) $.
    lkrin.p $e |- .+ = ( +g ` D ) $.
    lkrin.w $e |- ( ph -> W e. LMod ) $.
    lkrin.e $e |- ( ph -> G e. F ) $.
    lkrin.g $e |- ( ph -> H e. F ) $.
    $( Intersection of the kernels of 2 functionals is included in the kernel
       of their sum.  (Contributed by NM, 7-Jan-2015.) $)
    lkrin $p |- ( ph ->
             ( ( K ` G ) i^i ( K ` H ) ) C_ ( K ` ( G .+ H ) ) ) $=
      ( cfv wcel clmod adantr eqid vv cin co cv wa elin cbs csca c0g wceq lkrcl
      simprl syl3anc cplusg ldualvaddval simprr oveq12d cgrp crg lmodrng rnggrp
      lkrf0 syl grpidcl grplid syl2anc 3eqtrd wb ldualvaddcl ellkr mpbir2and ex
      syl5bi ssrdv ) AUAEGPZFGPZUBZEFCUCZGPZUAUDZVQQVTVOQZVTVPQZUEZAVTVSQZVTVOV
      PUFAWCWDAWCUEZWDVTHUGPZQZVTVRPZHUHPZUIPZUJZWEHRQZEDQZWAWGAWLWCMSZAWMWCNSZ
      AWAWBULZDEGWFHVTRWFTZIJUKUMZWEWHVTEPZVTFPZWIUNPZUCWJWJXAUCZWJWEBXACWIDEFW
      FHVTWQWITZXATZIKLWNWOAFDQZWCOSZWRUOWEWSWJWTWJXAWEWLWMWAWSWJUJWNWOWPWIDEGH
      VTRWJXCWJTZIJVBUMWEWLXEWBWTWJUJWNXFAWAWBUPWIDFGHVTRWJXCXGIJVBUMUQAXBWJUJZ
      WCAWIURQZWJWIUGPZQZXHAWIUSQZXIAWLXLMWIHXCUTVCWIVAVCZAXIXKXMXJWIWJXJTZXGVD
      VCXJXAWIWJWJXNXDXGVEVFSVGWEWLVRDQZWDWGWKUEVHWNAXOWCABCDEFHIKLMNOVISWIDVRG
      WFHVTRWJWQXCXGIJVJVFVKVLVMVN $.
  $}

  ${
    $d r F $.  $d r G $.  $d r H $.  $d r K $.  $d r R $.  $d r S $.  $d r W $.
    $d r ph $.
    eqlkr4.s $e |- S = ( Scalar ` W ) $.
    eqlkr4.r $e |- R = ( Base ` S ) $.
    eqlkr4.f $e |- F = ( LFnl ` W ) $.
    eqlkr4.k $e |- K = ( LKer ` W ) $.
    eqlkr4.d $e |- D = ( LDual ` W ) $.
    eqlkr4.t $e |- .x. = ( .s ` D ) $.
    eqlkr4.w $e |- ( ph -> W e. LVec ) $.
    eqlkr4.g $e |- ( ph -> G e. F ) $.
    eqlkr4.h $e |- ( ph -> H e. F ) $.
    eqlkr4.e $e |- ( ph -> ( K ` G ) = ( K ` H ) ) $.
    $( Two functionals with the same kernel are the same up to a constant.
       (Contributed by NM, 4-Feb-2015.) $)
    eqlkr4 $p |- ( ph -> E. r e. R H = ( r .x. G ) ) $=
      ( cv wceq wrex cbs cfv csn cxp cmulr cof clvec wcel eqid eqlkr2 syl121anc
      co wa adantr simpr ldualvs eqeq2d rexbidva mpbird ) AHKUBZGEUPZUCZKCUDHGJ
      UEUFZVDUGUHDUIUFZUJUPZUCZKCUDZAJUKULZGFULZHFULGIUFHIUFUCVKRSTUADVHFGHCIVG
      JKLMVHUMZVGUMZNOUNUOAVFVJKCAVDCULZUQZVEVIHVQBDEVHFGCVGJVDUKNVOLMVNPQAVLVP
      RURAVPUSAVMVPSURUTVAVBVC $.
  $}

  ${
    $d g k D $.  $d k F $.  $d g k G $.  $d k L $.  $d g k N $.  $d k W $.
    $d g k ph $.
    ldual1dim.f $e |- F = ( LFnl ` W ) $.
    ldual1dim.l $e |- L = ( LKer ` W ) $.
    ldual1dim.d $e |- D = ( LDual ` W ) $.
    ldual1dim.n $e |- N = ( LSpan ` D ) $.
    ldual1dim.w $e |- ( ph -> W e. LVec ) $.
    ldual1dim.g $e |- ( ph -> G e. F ) $.
    $( Equivalent expressions for a 1-dim subspace (ray) of functionals.
       (Contributed by NM, 24-Oct-2014.) $)
    ldual1dim $p |- ( ph -> ( N ` { G } )
        = { g e. F | ( L ` G ) C_ ( L ` g ) } ) $=
      ( vk cfv cbs wcel wa eqid cv cvsca co wceq csca cab csn cxp cmulr cof wss
      clvec ldualsbase eleq2d anbi1d adantr simpr ldualvs eqeq2d pm5.32da bitrd
      wrex crab rexbidv2 abbidv clmod lveclmod lduallmod syl ldualelvbase lspsn
      syl2anc lfl1dim 3eqtr4d ) ACUAZOUAZEBUBPZUCZUDZOBUEPZQPZVBZCUFZVOEHQPZVPU
      GUHHUEPZUIPZUJUCZUDZOWEQPZVBZCUFEUGGPZEFPVOFPUKCDVCAWBWJCAVSWHOWAWIAVPWAR
      ZVSSVPWIRZVSSWMWHSAWLWMVSAWAWIVPABVTWEWAWIULHWETZWITZKVTTZWATZMUMUNUOAWMV
      SWHAWMSZVRWGVOWRBWEVQWFDEWIWDHVPULIWDTZWNWOWFTZKVQTZAHULRZWMMUPAWMUQAEDRW
      MNUPURUSUTVAVDVEABVFRZEBQPZRWKWCUDAXBXCMXBBHKHVGVHVIABDEXDHULIKXDTZMNVJCV
      QOVTWAGXDBEWPWQXEXALVKVLAWEWFCODEWIFWDHWSWNIJWOWTMNVMVN $.
  $}

  ${
    ldualkrsc.r $e |- R = ( Scalar ` W ) $.
    ldualkrsc.k $e |- K = ( Base ` R ) $.
    ldualkrsc.o $e |- .0. = ( 0g ` R ) $.
    ldualkrsc.f $e |- F = ( LFnl ` W ) $.
    ldualkrsc.l $e |- L = ( LKer ` W ) $.
    ldualkrsc.d $e |- D = ( LDual ` W ) $.
    ldualkrsc.s $e |- .x. = ( .s ` D ) $.
    ldualkrsc.w $e |- ( ph -> W e. LVec ) $.
    ldualkrsc.g $e |- ( ph -> G e. F ) $.
    ldualkrsc.x $e |- ( ph -> X e. K ) $.
    ldualkrsc.e $e |- ( ph -> X =/= .0. ) $.
    $( The kernel of a non-zero scalar product of a functional equals the
       kernel of the functional.  (Contributed by NM, 28-Dec-2014.) $)
    ldualkrsc $p |- ( ph -> ( L ` ( X .x. G ) ) = ( L ` G ) ) $=
      ( co cfv cbs csn cxp cmulr cof clvec eqid ldualvs fveq2d lkrsc eqtrd ) AJ
      FDUCZHUDFIUEUDZJUFUGCUHUDZUIUCZHUDFHUDAUPUSHABCDUREFGUQIJUJOUQUKZLMURUKZQ
      RSUATULUMACJUREFGHUQIKUTLMVAOPSTUANUBUNUO $.
  $}

  ${
    lkrss.r $e |- R = ( Scalar ` W ) $.
    lkrss.k $e |- K = ( Base ` R ) $.
    lkrss.f $e |- F = ( LFnl ` W ) $.
    lkrss.l $e |- L = ( LKer ` W ) $.
    lkrss.d $e |- D = ( LDual ` W ) $.
    lkrss.s $e |- .x. = ( .s ` D ) $.
    lkrss.w $e |- ( ph -> W e. LVec ) $.
    lkrss.g $e |- ( ph -> G e. F ) $.
    lkrss.x $e |- ( ph -> X e. K ) $.
    $( The kernel of a scalar product of a functional includes the kernel of
       the functional.  (Contributed by NM, 27-Jan-2015.) $)
    lkrss $p |- ( ph -> ( L ` G ) C_ ( L ` ( X .x. G ) ) ) $=
      ( cfv cbs csn cxp cmulr cof co eqid lkrscss clvec ldualvs fveq2d sseqtr4d
      ) AFHTFIUATZJUBUCCUDTZUEUFZHTJFDUFZHTACJUNEFGHUMIUMUGZKLUNUGZMNQRSUHAUPUO
      HABCDUNEFGUMIJUIMUQKLUROPQSRUJUKUL $.
  $}

  ${
    $d r F $.  $d r G $.  $d r H $.  $d r K $.  $d r R $.  $d r S $.  $d r W $.
    $d r ph $.  $d r .x. $.
    lkrss2.s $e |- S = ( Scalar ` W ) $.
    lkrss2.r $e |- R = ( Base ` S ) $.
    lkrss2.f $e |- F = ( LFnl ` W ) $.
    lkrss2.k $e |- K = ( LKer ` W ) $.
    lkrss2.d $e |- D = ( LDual ` W ) $.
    lkrss2.t $e |- .x. = ( .s ` D ) $.
    lkrss2.w $e |- ( ph -> W e. LVec ) $.
    lkrss2.g $e |- ( ph -> G e. F ) $.
    lkrss2.h $e |- ( ph -> H e. F ) $.
    $( Two functionals with kernels in a subset relationship.  (Contributed by
       NM, 17-Feb-2015.)  (New usage is discouraged.) $)
    lkrss2N $p |- ( ph
         -> ( ( K ` G ) C_ ( K ` H ) <-> E. r e. R H = ( r .x. G ) ) ) $=
      ( cfv wss cv co wceq wrex wpss wo sspss c0g eqid lkrpssN wcel clmod clvec
      wne lveclmod syl lmod0cl adantr simpr ldual0vs eqtr4d oveq1 eqeq2d rspcev
      wa syl2anc ex adantld sylbid imp eqlkr4 jaodan sylan2b lkrss fveq2 sseq2d
      wi biimprcd syl6 rexlimdv impbida ) AGIUAZHIUAZUBZHKUCZGEUDZUEZKCUFZWFAWD
      WEUGZWDWEUEZUHWJWDWEUIAWKWJWLAWKWJAWKGBUJUAZUPZHWMUEZVGWJABFGHIJWMNOPWMUK
      ZRSTULAWOWJWNAWOWJAWOVGZDUJUAZCUMZHWRGEUDZUEZWJAWSWOAJUNUMZWSAJUOUMZXBRJU
      QURZDCJWRLMWRUKZUSURUTWQHWMWTAWOVAAWTWMUEWOABDEFGWMJWRNLXEPQWPXDSVBUTVCWI
      XAKWRCWGWRUEWHWTHWGWRGEVDVEVFVHVIVJVKVLAWLVGBCDEFGHIJKLMNOPQAXCWLRUTAGFUM
      ZWLSUTAHFUMWLTUTAWLVAVMVNVOAWJWFAWIWFKCAWGCUMZWDWHIUAZUBZWIWFVSAXGXIAXGVG
      BDEFGCIJWGLMNOPQAXCXGRUTAXFXGSUTAXGVAVPVIWIWFXIWIWEXHWDHWHIVQVRVTWAWBVLWC
      $.
  $}

  ${
    lkreq.s $e |- S = ( Scalar ` W ) $.
    lkreq.r $e |- R = ( Base ` S ) $.
    lkreq.o $e |- .0. = ( 0g ` S ) $.
    lkreq.f $e |- F = ( LFnl ` W ) $.
    lkreq.k $e |- K = ( LKer ` W ) $.
    lkreq.d $e |- D = ( LDual ` W ) $.
    lkreq.t $e |- .x. = ( .s ` D ) $.
    lkreq.w $e |- ( ph -> W e. LVec ) $.
    lkreq.a $e |- ( ph -> A e. ( R \ { .0. } ) ) $.
    lkreq.h $e |- ( ph -> H e. F ) $.
    lkreq.g $e |- ( ph -> G = ( A .x. H ) ) $.
    $( Proportional functionals have equal kernels.  (Contributed by NM,
       28-Mar-2015.)  (New usage is discouraged.) $)
    lkreqN $p |- ( ph -> ( K ` G ) = ( K ` H ) ) $=
      ( cfv wceq c0g wne wa wn wo co eqeq1d csca cbs eqid lduallvec csn eldifad
      clvec ldualsbase eleqtrrd ldualelvbase lvecvs0or wcel lveclmod syl ldual0
      clmod eqeq2d cdif eldifsni a1d necon4d sylbid idd jaod syl6ibr con3d orrd
      nne ianor sylibr wss wpss df-pss ldualvscl eqeltrd lkrpssN syl5rbbr lkrss
      fveq2d sseqtr4d biantrurd bitr4d necon2bbid mpbird eqcomd ) AIJUDZHJUDZAW
      RWSUEICUFUDZUGZHWTUEZUHZUIZAXAUIZXBUIZUJXDAXEXFAXBXEAXBIWTUEZXEAXBBIFUKZW
      TUEZXGAHXHWTUCULAXIBCUMUDZUFUDZUEZXGUJXGABFXJXJUNUDZXKCUNUDZCIWTXNUOZSXJU
      OZXMUOZXKUOZWTUOZACKRTUPABDXMABDLUQZUAURZACXJEXMDUSKMNRXPXQTUTVAACGIXNKUS
      PRXOTUBVBVCAXLXGXGAXLBLUEXGAXKLBACEXJXKKLMORXPXRAKUSVDKVHVDTKVEVFZVGVIAIW
      TBLABLUGZXAABDXTVJVDYCUABDLVKVFVLVMVNAXGVOVPVNVNIWTVTVQVRVSXAXBWAWBAXCWRW
      SAXCWRWSWCZWRWSUGZUHZYEYFWRWSWDAXCWRWSWEACGIHJKWTPQRXSTUBAHXHGUCACEFGIDKB
      PMNRSYBYAUBWFWGWHWIAYDYEAWRXHJUDWSACEFGIDJKBMNPQRSTUBYAWJAHXHJUCWKWLWMWNW
      OWPWQ $.
  $}

  ${
    $d k D $.  $d k G $.  $d k H $.  $d k L $.  $d k N $.  $d k W $.
    $d k ph $.
    lkrlspeq.f $e |- F = ( LFnl ` W ) $.
    lkrlspeq.l $e |- L = ( LKer ` W ) $.
    lkrlspeq.d $e |- D = ( LDual ` W ) $.
    lkrlspeq.o $e |- .0. = ( 0g ` D ) $.
    lkrlspeq.j $e |- N = ( LSpan ` D ) $.
    lkrlspeq.w $e |- ( ph -> W e. LVec ) $.
    lkrlspeq.h $e |- ( ph -> H e. F ) $.
    lkrlspeq.g $e |- ( ph -> G e. ( ( N ` { H } ) \ { .0. } ) ) $.
    $( Condition for colinear functionals to have equal kernels.  (Contributed
       by NM, 20-Mar-2015.)  (New usage is discouraged.) $)
    lkrlspeqN $p |- ( ph -> ( L ` G ) = ( L ` H ) ) $=
      ( cfv wceq wcel vk cv cvsca co csca cbs wrex eldifad clmod clvec lveclmod
      csn wb syl lduallmod eqid ldualelvbase lspsnel syl2anc ldualsbase rexeqdv
      mpbid w3a c0g 3ad2ant1 wne simp2 simp3 eldifsni eqnetrrd wo ldual0 eqeq2d
      cdif orc syl6bir lduallvec eleqtrrd lvecvs0or sylibrd necon3d mpd eldifsn
      sylanbrc lkreqN rexlimdv3a ) ADUAUBZEBUCRZUDZSZUAHUERZUFRZUGZDFREFRSZAWJU
      ABUERZUFRZUGZWMADEULGRZTZWQADWRIULZQUHABUITEBUFRZTZWSWQUMABHLAHUJTZHUITOH
      UKUNZUOABCEXAHUJJLXAUPZOPUQZWHDUAWOWPGXABEWOUPZWPUPZXEWHUPZNURUSVBAWJUAWP
      WLABWOWKWPWLUJHWKUPZWLUPZLXGXHOUTZVAVBAWJWNUAWLAWGWLTZWJVCZWGBWLWKWHCDEFH
      WKVDRZXJXKXOUPZJKLXIAXMXCWJOVEXNXMWGXOVFZWGWLXOULVNTAXMWJVGZXNWIIVFXQXNDW
      IIAXMWJVHZAXMDIVFZWJADWRWTVNTXTQDWRIVIUNVEVJXNWGXOWIIXNWGXOSZWGWOVDRZSZEI
      SZVKZWIISXNYAYCYEXNYBXOWGAXMYBXOSWJABWKWOYBHXOXJXPLXGYBUPZXDVLVEVMYCYDVOV
      PXNWGWHWOWPYBXABEIXEXIXGXHYFMAXMBUJTWJABHLOVQVEXNWGWLWPXRAXMWPWLSWJXLVEVR
      AXMXBWJXFVEVSVTWAWBWGWLXOWCWDAXMECTWJPVEXSWEWFWB $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Ortholattices and orthomodular lattices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c OP $.
  $c cm $.
  $c OL $.
  $c OML $.

  $( Extend class notation with orthoposets. $)
  cops $a class OP $.

  $( Extend class notation with the commutes relation. $)
  ccmtN $a class cm $.

  $( Extend class notation with orthlattices. $)
  col $a class OL $.

  $( Extend class notation with orthomodular lattices. $)
  coml $a class OML $.

  ${
    $d a b c p o $.
    $( Define the class of orthoposets.  (Contributed by NM, 20-Oct-2011.) $)
    df-oposet $a |- OP = { p e. Poset |
       ( ( ( 0. ` p ) e. ( Base ` p )
       /\ ( 1. ` p ) e. ( Base ` p ) )
        /\ E. o
           ( o = ( oc ` p )
          /\ A. a e. ( Base ` p ) A. b e. ( Base ` p )
               ( ( ( o ` a ) e. ( Base ` p ) /\ ( o ` ( o ` a ) ) = a
                /\ ( a ( le ` p ) b -> ( o ` b ) ( le ` p ) ( o ` a ) ) )
                /\ ( a ( join ` p ) ( o ` a ) ) = ( 1. ` p )
                   /\ ( a ( meet ` p ) ( o ` a ) ) = ( 0. ` p ) )
          ) ) } $.
  $}

  ${
    $d p x y $.
    $( Define the commutes relation for orthoposets.  Definition of commutes in
       [Kalmbach] p. 20.  (Contributed by NM, 6-Nov-2011.) $)
    df-cmtN $a |- cm = ( p e. _V |-> { <. x , y >. | ( x e. ( Base ` p )
             /\ y e. ( Base ` p )
             /\ x = ( ( x ( meet ` p ) y )
                ( join ` p ) ( x ( meet ` p ) ( ( oc ` p ) ` y ) ) ) ) } ) $.
  $}

  $( Define the class of ortholattices.  Definition from [Kalmbach] p. 16.
     (Contributed by NM, 18-Sep-2011.) $)
  df-ol $a |- OL = ( Lat i^i OP ) $.

  ${
    $d a b c l $.
    $( Define the class of orthomodular lattices.  Definition from [Kalmbach]
       p. 16.  (Contributed by NM, 18-Sep-2011.) $)
    df-oml $a |- OML = { l e. OL | A. a e. ( Base ` l ) A. b e. ( Base ` l )
       ( a ( le ` l ) b -> b = ( a ( join ` l ) ( b ( meet ` l )
          ( ( oc ` l ) ` a ) ) ) ) } $.
  $}

  ${
    $d n p .\/ $.  $d n p .<_ $.  $d n p ./\ $.  $d n p .0. $.  $d n p x y B $.
    $d n p x y ._|_ $.  $d n p .1. $.  $d n p x y K $.
    isopos.b $e |- B = ( Base ` K ) $.
    isopos.l $e |- .<_ = ( le ` K ) $.
    isopos.o $e |- ._|_ = ( oc ` K ) $.
    isopos.j $e |- .\/ = ( join ` K ) $.
    isopos.m $e |- ./\ = ( meet ` K ) $.
    isopos.f $e |- .0. = ( 0. ` K ) $.
    isopos.u $e |- .1. = ( 1. ` K ) $.
    $( The predicate "is an orthoposet."  (Contributed by NM, 20-Oct-2011.) $)
    isopos $p |- ( K e. OP <-> ( ( K e. Poset /\ .0. e. B /\ .1. e. B )
            /\ A. x e. B A. y e. B ( ( ( ._|_ ` x ) e. B
                 /\ ( ._|_ ` ( ._|_ ` x ) ) = x
                 /\ ( x .<_ y -> ( ._|_ ` y ) .<_ ( ._|_ ` x ) ) )
       /\ ( x .\/ ( ._|_ ` x ) ) = .1. /\ ( x ./\ ( ._|_ ` x ) ) = .0. ) ) ) $=
      ( wa wceq cfv vn vp cops wcel cpo cv wbr wi w3a wral wex cp0 cbs cp1 cple
      co coc cjn cmee fveq2 syl6eqr eleq12d anbi12d eqeq2d eleq2d breqd imbi12d
      3anbi13d oveqd eqeq12d 3anbi123d raleqbidv exbidv df-oposet elrab2 3anass
      anass bicomi cvv fvex eqeltri eleq1d fveq12d eqeq1d breq12d imbi2d oveq2d
      fveq1 id 2ralbidv ceqsexv anbi12i 3bitr2i ) FUCUDFUEUDZJCUDZDCUDZRZUAUFZI
      SZAUFZWRTZCUDZXAWRTZWTSZWTBUFZGUGZXEWRTZXAGUGZUHZUIZWTXAEUPZDSZWTXAHUPZJS
      ZUIZBCUJZACUJZRZUAUKZRZRWNWQRZXSRWNWOWPUIZWTITZCUDZYCITZWTSZXFXEITZYCGUGZ
      UHZUIZWTYCEUPZDSZWTYCHUPZJSZUIZBCUJACUJZRUBUFZULTZYQUMTZUDZYQUNTZYSUDZRZW
      RYQUQTZSZXAYSUDZXDWTXEYQUOTZUGZXGXAUUGUGZUHZUIZWTXAYQURTZUPZUUASZWTXAYQUS
      TZUPZYRSZUIZBYSUJZAYSUJZRZUAUKZRXTUBFUEUCYQFSZUUCWQUVBXSUVCYTWOUUBWPUVCYR
      JYSCUVCYRFULTJYQFULUTPVAZUVCYSFUMTCYQFUMUTKVAZVBUVCUUADYSCUVCUUAFUNTDYQFU
      NUTQVAZUVEVBVCUVCUVAXRUAUVCUUEWSUUTXQUVCUUDIWRUVCUUDFUQTZIYQFUQUTMVAVDUVC
      UUSXPAYSCUVEUVCUURXOBYSCUVEUVCUUKXJUUNXLUUQXNUVCUUFXBUUJXIXDUVCYSCXAUVEVE
      UVCUUHXFUUIXHUVCUUGGWTXEUVCUUGFUOTGYQFUOUTLVAZVFUVCUUGGXGXAUVHVFVGVHUVCUU
      MXKUUADUVCUULEWTXAUVCUULFURTEYQFURUTNVAVIUVFVJUVCUUPXMYRJUVCUUOHWTXAUVCUU
      OFUSTHYQFUSUTOVAVIUVDVJVKVLVLVCVMVCUAUBABVNVOWNWQXSVQYAYBXSYPYBYAWNWOWPVP
      VRXQYPUAIIUVGVSMFUQVTWAWSXOYOABCCWSXJYJXLYLXNYNWSXBYDXDYFXIYIWSXAYCCWTWRI
      WHZWBWSXCYEWTWSXAYCWRIWSWIUVIWCWDWSXHYHXFWSXGYGXAYCGXEWRIWHUVIWEWFVKWSXKY
      KDWSXAYCWTEUVIWGWDWSXMYMJWSXAYCWTHUVIWGWDVKWJWKWLWM $.
  $}

  ${
    $d p x y B $.  $d p .0. $.  $d p .\/ $.  $d p ./\ $.  $d p x y ._|_ $.
    $d p x y K $.  $d p .<_ $.  $d p .1. $.
    isopi.0 $e |- K e. Poset $.
    isopi.b $e |- B = ( Base ` K ) $.
    isopi.l $e |- .<_ = ( le ` K ) $.
    isopi.o $e |- ._|_ = ( oc ` K ) $.
    isopi.j $e |- .\/ = ( join ` K ) $.
    isopi.m $e |- ./\ = ( meet ` K ) $.
    isopi.z $e |- .0. = ( 0. ` K ) $.
    isopi.u $e |- .1. = ( 1. ` K ) $.
    isopi.8 $e |- .0. e. B $.
    isopi.9 $e |- .1. e. B $.
    isopi.9a $e |- ( x e. B -> ( ._|_ ` x ) e. B ) $.
    isopi.10 $e |- ( x e. B -> ( ._|_ ` ( ._|_ ` x ) ) = x ) $.
    isopi.11 $e |- ( ( x e. B /\ y e. B ) ->
                 ( x .<_ y -> ( ._|_ ` y ) .<_ ( ._|_ ` x ) ) ) $.
    isopi.12 $e |- ( x e. B -> ( x .\/ ( ._|_ ` x ) ) = .1. ) $.
    isopi.13 $e |- ( x e. B -> ( x ./\ ( ._|_ ` x ) ) = .0. ) $.
    $( Properties that determine an orthoposet (constructed structure
       version).  (Contributed by NM, 13-Sep-2011.)
       (New usage is discouraged.) $)
    isopiN $p |- K e. OP $=
      ( cops wcel cpo w3a cv cfv wceq wbr wi co wral 3pm3.2i adantr 3jca rgen2a
      wa isopos mpbir2an ) FUFUGFUHUGZJCUGZDCUGZUIAUJZIUKZCUGZVHIUKVGULZVGBUJZG
      UMVKIUKVHGUMUNZUIZVGVHEUODULZVGVHHUOJULZUIZBCUPACUPVDVEVFKSTUQVPABCVGCUGZ
      VKCUGZVAZVMVNVOVSVIVJVLVQVIVRUAURVQVJVRUBURUCUSVQVNVRUDURVQVOVRUEURUSUTAB
      CDEFGHIJLMNOPQRVBVC $.
  $}

  ${
    $d p x y K $.
    $( Every orthoposet is a poset.  (Contributed by NM, 12-Oct-2011.) $)
    opposet $p |- ( K e. OP -> K e. Poset ) $=
      ( vx vy cops wcel cpo cp0 cfv cbs cp1 w3a cv coc wceq cple wbr wi co wral
      eqid cjn cmee wa isopos simpl1 sylbi ) ADEAFEZAGHZAIHZEZAJHZUIEZKBLZAMHZH
      ZUIEUOUNHUMNUMCLZAOHZPUPUNHUOUQPQKUMUOAUAHZRUKNUMUOAUBHZRUHNKCUISBUISZUCU
      GBCUIUKURAUQUSUNUHUITUQTUNTURTUSTUHTUKTUDUGUJULUTUEUF $.
  $}

  ${
    $d p x y .\/ $.  $d p x y .<_ $.  $d p x y B $.  $d p x y K $.  $d x y X $.
    $d p x y ./\ $.  $d p x y ._|_ $.  $d p x y .0. $.  $d p x y .1. $.
    $d y Y $.
    oposlem.b $e |- B = ( Base ` K ) $.
    oposlem.l $e |- .<_ = ( le ` K ) $.
    oposlem.o $e |- ._|_ = ( oc ` K ) $.
    oposlem.j $e |- .\/ = ( join ` K ) $.
    oposlem.m $e |- ./\ = ( meet ` K ) $.
    oposlem.f $e |- .0. = ( 0. ` K ) $.
    oposlem.u $e |- .1. = ( 1. ` K ) $.
    $( Lemma for orthoposet properties.  (Contributed by NM, 20-Oct-2011.) $)
    oposlem $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( ( ( ._|_ ` X ) e. B /\ ( ._|_ ` ( ._|_ ` X ) ) = X
               /\ ( X .<_ Y -> ( ._|_ ` Y ) .<_ ( ._|_ ` X ) ) )
         /\ ( X .\/ ( ._|_ ` X ) ) = .1. /\ ( X ./\ ( ._|_ ` X ) ) = .0. ) ) $=
      ( wcel wceq w3a vx vy cops cfv wbr wi co cv wral cpo isopos simprbi fveq2
      wa eleq1d fveq2d id eqeq12d breq1 breq2d imbi12d 3anbi123d oveq12d eqeq1d
      breq2 breq1d 3anbi3d 3anbi1d rspc2v mpan9 3impb ) DUCRZHARZIARZHGUDZARZVO
      GUDZHSZHIEUEZIGUDZVOEUEZUFZTZHVOCUGZBSZHVOFUGZJSZTZVLUAUHZGUDZARZWJGUDZWI
      SZWIUBUHZEUEZWNGUDZWJEUEZUFZTZWIWJCUGZBSZWIWJFUGZJSZTZUBAUIUAAUIZVMVNUNWH
      VLDUJRJARBARTXEUAUBABCDEFGJKLMNOPQUKULXDWHVPVRHWNEUEZWPVOEUEZUFZTZWEWGTUA
      UBHIAAWIHSZWSXIXAWEXCWGXJWKVPWMVRWRXHXJWJVOAWIHGUMZUOXJWLVQWIHXJWJVOGXKUP
      XJUQZURXJWOXFWQXGWIHWNEUSXJWJVOWPEXKUTVAVBXJWTWDBXJWIHWJVOCXLXKVCVDXJXBWF
      JXJWIHWJVOFXLXKVCVDVBWNISZXIWCWEWGXMXHWBVPVRXMXFVSXGWAWNIHEVEXMWPVTVOEWNI
      GUMVFVAVGVHVIVJVK $.
  $}

  ${
    $d p x y B $.  $d p x y K $.  $d p .0. $.
    op0cl.b $e |- B = ( Base ` K ) $.
    op0cl.z $e |- .0. = ( 0. ` K ) $.
    $( An orthoposet has a zero element.  ( ~ h0elch analog.)  (Contributed by
       NM, 12-Oct-2011.) $)
    op0cl $p |- ( K e. OP -> .0. e. B ) $=
      ( vx vy cops wcel cpo cp1 cfv w3a cv coc wceq wbr co wral eqid cple wi wa
      cjn cmee isopos simpl2 sylbi ) BHIBJIZCAIZBKLZAIZMFNZBOLZLZAIUOUNLUMPUMGN
      ZBUALZQUPUNLUOUQQUBMUMUOBUDLZRUKPUMUOBUELZRCPMGASFASZUCUJFGAUKURBUQUSUNCD
      UQTUNTURTUSTEUKTUFUIUJULUTUGUH $.
  $}

  ${
    $d p x y B $.  $d p x y K $.  $d p .1. $.
    op1cl.b $e |- B = ( Base ` K ) $.
    op1cl.u $e |- .1. = ( 1. ` K ) $.
    $( An orthoposet has a unit element.  ( ~ helch analog.)  (Contributed by
       NM, 22-Oct-2011.) $)
    op1cl $p |- ( K e. OP -> .1. e. B ) $=
      ( vx vy cops wcel cpo cp0 cfv w3a cv coc wceq wbr co wral eqid cple wi wa
      cjn cmee isopos simpl3 sylbi ) CHICJIZCKLZAIZBAIZMFNZCOLZLZAIUOUNLUMPUMGN
      ZCUALZQUPUNLUOUQQUBMUMUOCUDLZRBPUMUOCUELZRUJPMGASFASZUCULFGABURCUQUSUNUJD
      UQTUNTURTUSTUJTEUFUIUKULUTUGUH $.
  $}

  ${
    op0le.b $e |- B = ( Base ` K ) $.
    op0le.l $e |- .<_ = ( le ` K ) $.
    op0le.z $e |- .0. = ( 0. ` K ) $.
    $( Orthoposet zero is less than or equal to any element.  ( ~ ch0le
       analog.)  (Contributed by NM, 12-Oct-2011.) $)
    op0le $p |- ( ( K e. OP /\ X e. B ) -> .0. .<_ X ) $=
      ( cops wcel wbr op0cl adantr cpo opposet p0le syl3an1 3com23 mpd3an3 ) BI
      JZDAJZEAJZEDCKZTUBUAABEFHLMTUBUAUCTBNJUBUAUCBOABCDEFGHPQRS $.

    $( An element less than or equal to zero equals zero.  ( ~ chle0 analog.)
       (Contributed by NM, 21-Oct-2011.) $)
    ople0 $p |- ( ( K e. OP /\ X e. B ) -> ( X .<_ .0. <-> X = .0. ) ) $=
      ( cops wcel wa wbr wceq op0le biantrud cpo wb opposet adantr simpr op0cl
      posasymb syl3anc bitrd ) BIJZDAJZKZDECLZUHEDCLZKZDEMZUGUIUHABCDEFGHNOUGBP
      JZUFEAJZUJUKQUEULUFBRSUEUFTUEUMUFABEFHUASABCDEFGUBUCUD $.

    $( An element not less than another is nonzero.  TODO:  Look for uses of
       ~ necon3bd and ~ op0le to see if this is useful elsewhere.  (Contributed
       by NM, 5-May-2013.) $)
    opnlen0 $p |- ( ( ( K e. OP /\ X e. B /\ Y e. B ) /\ -. X .<_ Y )
        -> X =/= .0. ) $=
      ( cops wcel w3a wbr wn wne wceq op0le 3adant2 breq1 syl5ibrcom necon3bd
      imp ) BJKZDAKZEAKZLZDECMZNDFOUFUGDFUFUGDFPFECMZUCUEUHUDABCEFGHIQRDFECSTUA
      UB $.

  $}

  ${
    $d x y z K $.  $d x z .0. $.
    lub0.u $e |- .1. = ( lub ` K ) $.
    lub0.z $e |- .0. = ( 0. ` K ) $.
    $( The least upper bound of the empty set is the zero element.
       (Contributed by NM, 15-Sep-2013.)  (New usage is discouraged.) $)
    lub0N $p |- ( K e. OP -> ( .1. ` (/) ) = .0. ) $=
      ( vy vx vz cops wcel c0 cfv cv wbr wral wi wa wceq eqid ral0 cple cbs wss
      crio 0ss lubval mpan2 op0cl a1bi ralbii biantrur bitri adantr breq2 rspcv
      syl ople0 sylibd op0le adantlr breq1 biimprcd syl6 com23 ralrimdv syl5bbr
      ex impbid riota5 eqtrd ) BIJZKALZFMZGMZBUALZNZFKOZVMHMZVONZFKOZVNVRVONZPZ
      HBUBLZOZQZGWCUDZCVKKWCUCVLWFRWCUEGFHIWCKABVOWCSZVOSZDUFUGVKWEGWCCWCBCWGEU
      HZWEWAHWCOZVKVNWCJZQZVNCRZWJWDWEWAWBHWCVTWAVSFTUIUJVQWDVPFTUKULWLWJWMWLWJ
      VNCVONZWMWLCWCJZWJWNPVKWOWKWIUMWAWNHCWCVRCVNVOUNUOUPWCBVOVNCWGWHEUQURWLWM
      WAHWCWLVRWCJZWMWAWLWPCVRVONZWMWAPWLWPWQVKWPWQWKWCBVOVRCWGWHEUSUTVGWMWAWQV
      NCVRVOVAVBVCVDVEVHVFVIVJ $.
  $}

  ${
    opltne0.b $e |- B = ( Base ` K ) $.
    opltne0.s $e |- .< = ( lt ` K ) $.
    opltne0.z $e |- .0. = ( 0. ` K ) $.
    $( A lattice element greater than zero is nonzero.  TODO: is this needed?
       (Contributed by NM, 1-Jun-2012.) $)
    opltn0 $p |- ( ( K e. OP /\ X e. B ) -> ( .0. .< X <-> X =/= .0. ) ) $=
      ( cops wcel wa wbr cple cfv wne wb simpl op0cl adantr simpr syl3anc necom
      eqid pltval op0le biantrurd syl5rbb bitrd ) CIJZDAJZKZEDBLZEDCMNZLZEDOZKZ
      DEOZUKUIEAJZUJULUPPUIUJQUIURUJACEFHRSUIUJTIAABCUMEDUMUCZGUDUAUQUOUKUPDEUB
      UKUNUOACUMDEFUSHUEUFUGUH $.
  $}

  ${
    ople1.b $e |- B = ( Base ` K ) $.
    ople1.l $e |- .<_ = ( le ` K ) $.
    ople1.u $e |- .1. = ( 1. ` K ) $.
    $( Any element is less than the orthoposet unit.  ( ~ chss analog.)
       (Contributed by NM, 23-Oct-2011.) $)
    ople1 $p |- ( ( K e. OP /\ X e. B ) -> X .<_ .1. ) $=
      ( cops wcel wbr op1cl adantr cpo opposet ple1 syl3an1 mpd3an3 ) CIJZEAJZB
      AJZEBDKZSUATABCFHLMSCNJTUAUBCOABCDEFGHPQR $.

    $( If the orthoposet unit is less than or equal to an element, the element
       equals the unit.  ( ~ chle0 analog.)  (Contributed by NM,
       5-Dec-2011.) $)
    op1le $p |- ( ( K e. OP /\ X e. B ) -> ( .1. .<_ X <-> X = .1. ) ) $=
      ( cops wcel wa wbr wceq ople1 biantrurd cpo wb opposet adantr simpr op1cl
      posasymb syl3anc bitrd ) CIJZEAJZKZBEDLZEBDLZUHKZEBMZUGUIUHABCDEFGHNOUGCP
      JZUFBAJZUJUKQUEULUFCRSUEUFTUEUMUFABCFHUASACDEBFGUBUCUD $.
  $}

  ${
    $d x y z K $.  $d x z .1. $.
    glb0.g $e |- G = ( glb ` K ) $.
    glb0.u $e |- .1. = ( 1. ` K ) $.
    $( The greatest lower bound of the empty set is the unit element.
       (Contributed by NM, 5-Dec-2011.)  (New usage is discouraged.) $)
    glb0N $p |- ( K e. OP -> ( G ` (/) ) = .1. ) $=
      ( vx vy vz cops wcel c0 cfv cv wbr wral wi wa wceq eqid ral0 cple cbs wss
      crio 0ss glbval mpan2 op1cl a1bi ralbii biantrur bitri adantr breq1 rspcv
      syl op1le sylibd ople1 adantlr breq2 biimprcd syl6 com23 ralrimdv syl5bbr
      ex impbid riota5 eqtrd ) CIJZKBLZFMZGMZCUALZNZGKOZHMZVNVONZGKOZVRVMVONZPZ
      HCUBLZOZQZFWCUDZAVKKWCUCVLWFRWCUEFGHIWCKBCVOWCSZVOSZDUFUGVKWEFWCAWCACWGEU
      HZWEWAHWCOZVKVMWCJZQZVMARZWJWDWEWAWBHWCVTWAVSGTUIUJVQWDVPGTUKULWLWJWMWLWJ
      AVMVONZWMWLAWCJZWJWNPVKWOWKWIUMWAWNHAWCVRAVMVOUNUOUPWCACVOVMWGWHEUQURWLWM
      WAHWCWLVRWCJZWMWAWLWPVRAVONZWMWAPWLWPWQVKWPWQWKWCACVOVRWGWHEUSUTVGWMWAWQV
      MAVRVOVAVBVCVDVEVHVFVIVJ $.
  $}

  ${
    opoccl.b $e |- B = ( Base ` K ) $.
    opoccl.o $e |- ._|_ = ( oc ` K ) $.
    $( Closure of orthocomplement operation.  ( ~ choccl analog.)  (Contributed
       by NM, 20-Oct-2011.) $)
    opoccl $p |- ( ( K e. OP /\ X e. B ) -> ( ._|_ ` X ) e. B ) $=
      ( cops wcel wa cfv wceq cple wbr wi w3a cjn co cp1 eqid simp1d cmee cp0
      oposlem 3anidm23 ) BGHZDAHZIZDCJZAHZUHCJDKZDDBLJZMUHUHUKMNZUGUIUJULOZDUHB
      PJZQBRJZKZDUHBUAJZQBUBJZKZUEUFUMUPUSOAUOUNBUKUQCDDUREUKSFUNSUQSURSUOSUCUD
      TT $.

    $( Double negative law for orthoposets.  ( ~ ococ analog.)  (Contributed by
       NM, 13-Sep-2011.) $)
    opococ $p |- ( ( K e. OP /\ X e. B ) -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $=
      ( cops wcel wa cfv wceq cple wbr wi w3a cjn co cp1 cmee eqid cp0 3anidm23
      oposlem simp1d simp2d ) BGHZDAHZIZDCJZAHZUICJDKZDDBLJZMUIUIULMNZUHUJUKUMO
      ZDUIBPJZQBRJZKZDUIBSJZQBUAJZKZUFUGUNUQUTOAUPUOBULURCDDUSEULTFUOTURTUSTUPT
      UCUBUDUE $.

    $( Contraposition law for orthoposets.  ( ~ chcon3i analog.)  (Contributed
       by NM, 8-Nov-2011.) $)
    opcon3b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( X = Y <-> ( ._|_ ` Y ) = ( ._|_ ` X ) ) ) $=
      ( cops wcel w3a wceq eqcoms opococ 3adant3 3adant2 eqeq12d syl5ib impbid2
      cfv fveq2 ) BHIZDAIZEAIZJZDEKZECSZDCSZKZUHEDEDCTLUHUGCSZUFCSZKZUDUEUKUGUF
      UGUFCTLUDUIDUJEUAUBUIDKUCABCDFGMNUAUCUJEKUBABCEFGMOPQR $.

    $( Orthocomplement contraposition law.  ( ~ negcon2 analog.)  (Contributed
       by NM, 16-Jan-2012.) $)
    opcon2b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
       -> ( X = ( ._|_ ` Y ) <-> Y = ( ._|_ ` X ) ) ) $=
      ( cops wcel w3a cfv wceq wb opoccl 3adant2 opcon3b syld3an3 opococ eqeq1d
      bitrd ) BHIZDAIZEAIZJZDECKZLZUECKZDCKZLZEUHLUAUBUCUEAIZUFUIMUAUCUJUBABCEF
      GNOABCDUEFGPQUDUGEUHUAUCUGELUBABCEFGROST $.

    $( Orthocomplement contraposition law.  ( ~ negcon1 analog.)  (Contributed
       by NM, 24-Jan-2012.) $)
    opcon1b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
       -> ( ( ._|_ ` X ) = Y <-> ( ._|_ ` Y ) = X ) ) $=
      ( cops wcel w3a cfv wceq opcon2b eqcom 3bitr4g bicomd ) BHIDAIEAIJZECKZDL
      ZDCKZELZQDRLETLSUAABCDEFGMRDNTENOP $.
  $}

  ${
    opcon3.b $e |- B = ( Base ` K ) $.
    opcon3.l $e |- .<_ = ( le ` K ) $.
    opcon3.o $e |- ._|_ = ( oc ` K ) $.
    $( Contraposition law for orthoposets.  (Contributed by NM,
       13-Sep-2011.) $)
    oplecon3 $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( X .<_ Y -> ( ._|_ ` Y ) .<_ ( ._|_ ` X ) ) ) $=
      ( cops wcel w3a cfv wceq wbr wi cjn co cp1 eqid cp0 oposlem simp1d simp3d
      cmee ) BJKEAKFAKLZEDMZAKZUGDMENZEFCOFDMUGCOPZUFUHUIUJLEUGBQMZRBSMZNEUGBUE
      MZRBUAMZNAULUKBCUMDEFUNGHIUKTUMTUNTULTUBUCUD $.

    $( Contraposition law for orthoposets.  ( ~ chsscon3 analog.)  (Contributed
       by NM, 4-Nov-2011.) $)
    oplecon3b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( X .<_ Y <-> ( ._|_ ` Y ) .<_ ( ._|_ ` X ) ) ) $=
      ( cops wcel w3a wbr cfv oplecon3 opoccl 3adant2 3adant3 wceq opococ simp1
      wi syl3anc breq12d sylibd impbid ) BJKZEAKZFAKZLZEFCMZFDNZEDNZCMZABCDEFGH
      IOUJUNUMDNZULDNZCMZUKUJUGULAKZUMAKZUNUQUBUGUHUIUAUGUIURUHABDFGIPQUGUHUSUI
      ABDEGIPRABCDULUMGHIOUCUJUOEUPFCUGUHUOESUIABDEGITRUGUIUPFSUHABDFGITQUDUEUF
      $.

    $( Contraposition law for strict ordering in orthoposets.  ( ~ chsscon1
       analog.)  (Contributed by NM, 6-Nov-2011.) $)
    oplecon1b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( ( ._|_ ` X ) .<_ Y <-> ( ._|_ ` Y ) .<_ X ) ) $=
      ( cops wcel w3a cfv wbr wb opoccl 3adant3 oplecon3b syld3an2 wceq opococ
      breq2d bitrd ) BJKZEAKZFAKZLZEDMZFCNZFDMZUHDMZCNZUJECNUDUHAKZUEUFUIULOUDU
      EUMUFABDEGIPQABCDUHFGHIRSUGUKEUJCUDUEUKETUFABDEGIUAQUBUC $.
  $}

  ${
    opoc1.z $e |- .0. = ( 0. ` K ) $.
    opoc1.u $e |- .1. = ( 1. ` K ) $.
    opoc1.o $e |- ._|_ = ( oc ` K ) $.
    $( Orthocomplement of orthoposet unit.  (Contributed by NM,
       24-Jan-2012.) $)
    opoc1 $p |- ( K e. OP -> ( ._|_ ` .1. ) = .0. ) $=
      ( cops wcel cfv cple wbr wceq cbs eqid op0cl opoccl mpdan ople1 wb mpbird
      op1cl oplecon1b mpd3an23 ople0 mpbid ) BHIZACJZDBKJZLZUHDMZUGUJDCJZAUILZU
      GULBNJZIZUMUGDUNIZUOUNBDUNOZEPZUNBCDUQGQRUNABUIULUQUIOZFSRUGAUNIZUPUJUMTU
      NABUQFUBZURUNBUICADUQUSGUCUDUAUGUHUNIZUJUKTUGUTVBVAUNBCAUQGQRUNBUIUHDUQUS
      EUERUF $.

    $( Orthocomplement of orthoposet zero.  (Contributed by NM,
       24-Jan-2012.) $)
    opoc0 $p |- ( K e. OP -> ( ._|_ ` .0. ) = .1. ) $=
      ( cops wcel cfv wceq opoc1 cbs wb eqid op1cl op0cl opcon1b mpd3an23 mpbid
      ) BHIZACJDKZDCJAKZABCDEFGLUAABMJZIDUDIUBUCNUDABUDOZFPUDBDUEEQUDBCADUEGRST
      $.
  $}

  ${
    opltcon3.b $e |- B = ( Base ` K ) $.
    opltcon3.s $e |- .< = ( lt ` K ) $.
    opltcon3.o $e |- ._|_ = ( oc ` K ) $.
    $( Contraposition law for strict ordering in orthoposets.  ( ~ chpsscon3
       analog.)  (Contributed by NM, 4-Nov-2011.) $)
    opltcon3b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( X .< Y <-> ( ._|_ ` Y ) .< ( ._|_ ` X ) ) ) $=
      ( cops wcel w3a cfv wbr wn wa oplecon3b wb pltval3 opoccl cple 3com23 cpo
      notbid anbi12d opposet syl3an1 3ad2ant1 3adant2 3adant3 syl3anc 3bitr4d
      eqid ) CJKZEAKZFAKZLZEFCUAMZNZFEURNZOZPZFDMZEDMZURNZVDVCURNZOZPZEFBNZVCVD
      BNZUQUSVEVAVGACURDEFGURUMZIQUQUTVFUNUPUOUTVFRACURDFEGVKIQUBUDUEUNCUCKZUOU
      PVIVBRCUFZABCUREFGVKHSUGUQVLVCAKZVDAKZVJVHRUNUOVLUPVMUHUNUPVNUOACDFGITUIU
      NUOVOUPACDEGITUJABCURVCVDGVKHSUKUL $.

    $( Contraposition law for strict ordering in orthoposets.  ( ~ chpsscon1
       analog.)  (Contributed by NM, 5-Nov-2011.) $)
    opltcon1b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( ( ._|_ ` X ) .< Y <-> ( ._|_ ` Y ) .< X ) ) $=
      ( cops wcel w3a cfv wbr wb opoccl 3adant3 opltcon3b syld3an2 wceq opococ
      breq2d bitrd ) CJKZEAKZFAKZLZEDMZFBNZFDMZUHDMZBNZUJEBNUDUHAKZUEUFUIULOUDU
      EUMUFACDEGIPQABCDUHFGHIRSUGUKEUJBUDUEUKETUFACDEGIUAQUBUC $.

    $( Contraposition law for strict ordering in orthoposets.  ( ~ chsscon2
       analog.)  (Contributed by NM, 5-Nov-2011.) $)
    opltcon2b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                -> ( X .< ( ._|_ ` Y ) <-> Y .< ( ._|_ ` X ) ) ) $=
      ( cops wcel w3a cfv wbr wb opoccl 3adant2 opltcon3b syld3an3 wceq opococ
      breq1d bitrd ) CJKZEAKZFAKZLZEFDMZBNZUHDMZEDMZBNZFUKBNUDUEUFUHAKZUIULOUDU
      FUMUEACDFGIPQABCDEUHGHIRSUGUJFUKBUDUFUJFTUEACDFGIUAQUBUC $.
  $}

  ${
    opexmid.b $e |- B = ( Base ` K ) $.
    opexmid.o $e |- ._|_ = ( oc ` K ) $.
    opexmid.j $e |- .\/ = ( join ` K ) $.
    opexmid.u $e |- .1. = ( 1. ` K ) $.
    $( Law of excluded middle for orthoposets.  ( ~ chjo analog.)  (Contributed
       by NM, 13-Sep-2011.) $)
    opexmid $p |- ( ( K e. OP /\ X e. B )
                -> ( X .\/ ( ._|_ ` X ) ) = .1. ) $=
      ( cops wcel wa cfv wceq cple wbr w3a co eqid wi cmee cp0 oposlem 3anidm23
      simp2d ) DKLZFALZMFENZALUIENFOFFDPNZQUIUIUJQUARZFUICSBOZFUIDUBNZSDUCNZOZU
      GUHUKULUORABCDUJUMEFFUNGUJTHIUMTUNTJUDUEUF $.
  $}

  ${
    opnoncon.b $e |- B = ( Base ` K ) $.
    opnoncon.o $e |- ._|_ = ( oc ` K ) $.
    opnoncon.m $e |- ./\ = ( meet ` K ) $.
    opnoncon.z $e |- .0. = ( 0. ` K ) $.
    $( Law of contradiction for orthoposets.  ( ~ chocin analog.)  (Contributed
       by NM, 13-Sep-2011.) $)
    opnoncon $p |- ( ( K e. OP /\ X e. B )
                -> ( X ./\ ( ._|_ ` X ) ) = .0. ) $=
      ( cops wcel wa cfv wceq cple wbr w3a co eqid wi cjn cp1 oposlem 3anidm23
      simp3d ) BKLZEALZMEDNZALUIDNEOEEBPNZQUIUIUJQUARZEUIBUBNZSBUCNZOZEUICSFOZU
      GUHUKUNUORAUMULBUJCDEEFGUJTHULTIJUMTUDUEUF $.
  $}

  ${
    $d x y z B $.  $d x y K $.  $d x y z ._|_ $.  $d y z ph $.  $d x z ps $.
    riotaoc.b $e |- B = ( Base ` K ) $.
    riotaoc.o $e |- ._|_ = ( oc ` K ) $.
    riotaoc.a $e |- ( x = ( ._|_ ` y ) -> ( ph <-> ps ) ) $.
    $( The orthocomplement of the unique poset element such that ` ps ` .
       ( ~ riotaneg analog.)  (Contributed by NM, 16-Jan-2012.)
       (New usage is discouraged.) $)
    riotaocN $p |- ( ( K e. OP /\ E! x e. B ph ) ->
             ( iota_ x e. B ph ) = ( ._|_ ` ( iota_ y e. B ps ) ) ) $=
      ( cops wcel cv cfv crio nfcv nfriota1 nffv opoccl fveq2 opcon2b riotaxfrd
      reuhypd ) FKLZABCDEDMZGNZBDEOZGNDUGGDGPBDEQREFGUEHISEFGUGHISJUEUGGTUDCDUF
      CMZGNEEFGUHHISEFGUHUEHIUAUCUB $.
  $}

  ${
    $d p x y B $.  $d p .\/ $.  $d p ./\ $.  $d p ._|_ $.  $d p x y K $.
    cmtfval.b $e |- B = ( Base ` K ) $.
    cmtfval.j $e |- .\/ = ( join ` K ) $.
    cmtfval.m $e |- ./\ = ( meet ` K ) $.
    cmtfval.o $e |- ._|_ = ( oc ` K ) $.
    cmtfval.c $e |- C = ( cm ` K ) $.
    $( Value of commutes relation.  (Contributed by NM, 6-Nov-2011.)
       (New usage is discouraged.) $)
    cmtfvalN $p |- ( K e. A -> C = { <. x , y >. | ( x e. B /\ y e. B
          /\ x = ( ( x ./\ y ) .\/ ( x ./\ ( ._|_ ` y ) ) ) ) } ) $=
      ( wcel cvv co cfv wceq cbs vp w3a copab elex ccmtN cmee coc fveq2 syl6eqr
      cv cjn eleq2d oveqd eqidd fveq1d oveq123d eqeq2d 3anbi123d df-cmtN df-3an
      opabbidv wa opabbii cxp fvex eqeltri xpex opabssxp ssexi fvmpt syl5eq syl
      ) GCOGPOZEAUJZDOZBUJZDOZVNVNVPHQZVNVPIRZHQZFQZSZUBZABUCZSGCUDVMEGUERWDNUA
      GVNUAUJZTRZOZVPWFOZVNVNVPWEUFRZQZVNVPWEUGRZRZWIQZWEUKRZQZSZUBZABUCWDPUEWE
      GSZWQWCABWRWGVOWHVQWPWBWRWFDVNWRWFGTRZDWEGTUHJUIZULWRWFDVPWTULWRWOWAVNWRW
      JVRWMVTWNFWRWNGUKRFWEGUKUHKUIWRWIHVNVPWRWIGUFRHWEGUFUHLUIZUMWRVNVNWLVSWIH
      XAWRVNUNWRVPWKIWRWKGUGRIWEGUGUHMUIUOUPUPUQURVAABUAUSWDVOVQVBWBVBZABUCZPWC
      XBABVOVQWBUTVCXCDDVDDDDWSPJGTVEVFZXDVGWBABDDVHVIVFVJVKVL $.

    $d x y .\/ $.  $d x y ./\ $.  $d x y ._|_ $.  $d x y X $.  $d x y Y $.
    $( Equivalence for commutes relation.  Definition of commutes in [Kalmbach]
       p. 20.  ( ~ cmbr analog.)  (Contributed by NM, 6-Nov-2011.)
       (New usage is discouraged.) $)
    cmtvalN $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X C Y <->
               X = ( ( X ./\ Y ) .\/ ( X ./\ ( ._|_ ` Y ) ) ) ) ) $=
      ( vx vy wcel wa co wceq w3a wbr cv copab wb cmtfvalN df-3an opabbii breqd
      cfv syl6eq 3ad2ant1 cop df-br id oveq1 oveq12d eqeq12d oveq2 fveq2 oveq2d
      eqeq2d opelopab2 syl5bb 3adant1 bitrd ) EAQZHBQZIBQZUAHICUBZHIOUCZBQZPUCZ
      BQZRVKVKVMFSZVKVMGUJZFSZDSZTZRZOPUDZUBZHHIFSZHIGUJZFSZDSZTZVGVHVJWBUEVIVG
      CWAHIVGCVLVNVSUAZOPUDWAOPABCDEFGJKLMNUFWHVTOPVLVNVSUGUHUKUIULVHVIWBWGUEVG
      WBHIUMWAQVHVIRWGHIWAUNVSHHVMFSZHVPFSZDSZTWGOPHIBBVKHTZVKHVRWKWLUOWLVOWIVQ
      WJDVKHVMFUPVKHVPFUPUQURVMITZWKWFHWMWIWCWJWEDVMIHFUSWMVPWDHFVMIGUTVAUQVBVC
      VDVEVF $.
  $}

  $( The predicate "is an ortholattice."  (Contributed by NM, 18-Sep-2011.) $)
  isolat $p |- ( K e. OL <-> ( K e. Lat /\ K e. OP ) ) $=
    ( clat cops col df-ol elin2 ) ABCDEF $.

  $( An ortholattice is a lattice.  (Contributed by NM, 18-Sep-2011.) $)
  ollat $p |- ( K e. OL -> K e. Lat ) $=
    ( col wcel clat cops isolat simplbi ) ABCADCAECAFG $.

  $( An ortholattice is an orthoposet.  (Contributed by NM, 18-Sep-2011.) $)
  olop $p |- ( K e. OL -> K e. OP ) $=
    ( col wcel clat cops isolat simprbi ) ABCADCAECAFG $.

  $( An ortholattice is a poset.  (Contributed by NM, 16-Oct-2011.)
     (New usage is discouraged.) $)
  olposN $p |- ( K e. OL -> K e. Poset ) $=
    ( col wcel cops cpo olop opposet syl ) ABCADCAECAFAGH $.

  ${
    isolati.1 $e |- K e. Lat $.
    isolati.2 $e |- K e. OP $.
    $( Properties that determine an ortholattice.  (Contributed by NM,
       18-Sep-2011.)  (New usage is discouraged.) $)
    isolatiN $p |- K e. OL $=
      ( col wcel clat cops isolat mpbir2an ) ADEAFEAGEBCAHI $.
  $}

  ${
    oldmm1.b $e |- B = ( Base ` K ) $.
    oldmm1.j $e |- .\/ = ( join ` K ) $.
    oldmm1.m $e |- ./\ = ( meet ` K ) $.
    oldmm1.o $e |- ._|_ = ( oc ` K ) $.
    $( De Morgan's law for meet in an ortholattice.  ( ~ chdmm1 analog.)
       (Contributed by NM, 6-Nov-2011.) $)
    oldmm1 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( X ./\ Y ) ) = ( ( ._|_ ` X ) .\/ ( ._|_ ` Y ) ) ) $=
      ( wcel cfv syl3an1 opoccl syl3anc wbr wb oplecon1b mpbid col cple co eqid
      clat ollat 3ad2ant1 cops olop latmcl syl2anc sylan 3adant3 3adant2 latjcl
      w3a latlej1 simp2 latlej2 wa latlem12 syl13anc mpbi2and latmle1 oplecon3b
      simp3 latmle2 latjle12 latasymd ) CUALZFALZGALZUPZACCUBMZFGDUCZEMZFEMZGEM
      ZBUCZHVNUDZVJVKCUELZVLCUFZUGZVMCUHLZVOALZVPALZVJVKWDVLCUIZUGZVJWAVKVLWEWB
      ACDFGHJUJNZACEVOHKOUKZVMWAVQALZVRALZVSALZWCVJVKWKVLVJWDVKWKWGACEFHKOULUMZ
      VJVLWLVKVJWDVLWLWGACEGHKOULUNZABCVQVRHIUOPZVMVSEMZVOVNQZVPVSVNQZVMWQFVNQZ
      WQGVNQZWRVMVQVSVNQZWTVMWAWKWLXBWCWNWOABCVNVQVRHVTIUQPVMWDVKWMXBWTRWHVJVKV
      LURZWPACVNEFVSHVTKSPTVMVRVSVNQZXAVMWAWKWLXDWCWNWOABCVNVQVRHVTIUSPVMWDVLWM
      XDXARWHVJVKVLVFZWPACVNEGVSHVTKSPTVMWAWQALZVKVLWTXAUTWRRWCVMWDWMXFWHWPACEV
      SHKOUKXCXEACVNDWQFGHVTJVAVBVCVMWDWMWEWRWSRWHWPWIACVNEVSVOHVTKSPTVMVQVPVNQ
      ZVRVPVNQZVSVPVNQZVMVOFVNQZXGVJWAVKVLXJWBACVNDFGHVTJVDNVMWDWEVKXJXGRWHWIXC
      ACVNEVOFHVTKVEPTVMVOGVNQZXHVJWAVKVLXKWBACVNDFGHVTJVGNVMWDWEVLXKXHRWHWIXEA
      CVNEVOGHVTKVEPTVMWAWKWLWFXGXHUTXIRWCWNWOWJABCVNVQVRVPHVTIVHVBVCVI $.

    $( De Morgan's law for meet in an ortholattice.  ( ~ chdmm2 analog.)
       (Contributed by NM, 6-Nov-2011.) $)
    oldmm2 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( ( ._|_ ` X ) ./\ Y ) ) = ( X .\/ ( ._|_ ` Y ) ) ) $=
      ( col wcel w3a cfv co wceq cops sylan 3adant3 olop opoccl oldmm1 syld3an2
      opococ oveq1d eqtrd ) CLMZFAMZGAMZNZFEOZGDPEOZULEOZGEOZBPZFUOBPUHULAMZUIU
      JUMUPQUHUIUQUJUHCRMZUIUQCUAZACEFHKUBSTABCDEULGHIJKUCUDUKUNFUOBUHUIUNFQZUJ
      UHURUIUTUSACEFHKUESTUFUG $.

    $( De Morgan's law for meet in an ortholattice.  ( ~ chdmm3 analog.)
       (Contributed by NM, 8-Nov-2011.)  (New usage is discouraged.) $)
    oldmm3N $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( X ./\ ( ._|_ ` Y ) ) ) = ( ( ._|_ ` X ) .\/ Y ) ) $=
      ( col wcel w3a cfv co wceq cops olop syl2anc 3ad2ant1 simp3 opoccl oldmm1
      syld3an3 opococ oveq2d eqtrd ) CLMZFAMZGAMZNZFGEOZDPEOZFEOZUMEOZBPZUOGBPU
      IUJUKUMAMZUNUQQULCRMZUKURUIUJUSUKCSUAZUIUJUKUBZACEGHKUCTABCDEFUMHIJKUDUEU
      LUPGUOBULUSUKUPGQUTVAACEGHKUFTUGUH $.

    $( De Morgan's law for meet in an ortholattice.  ( ~ chdmm4 analog.)
       (Contributed by NM, 6-Nov-2011.) $)
    oldmm4 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( ( ._|_ ` X ) ./\ ( ._|_ ` Y ) ) ) = ( X .\/ Y ) ) $=
      ( col wcel w3a cfv co wceq cops sylan 3adant2 olop opoccl oldmm2 syld3an3
      opococ oveq2d eqtrd ) CLMZFAMZGAMZNZFEOGEOZDPEOZFULEOZBPZFGBPUHUIUJULAMZU
      MUOQUHUJUPUIUHCRMZUJUPCUAZACEGHKUBSTABCDEFULHIJKUCUDUKUNGFBUHUJUNGQZUIUHU
      QUJUSURACEGHKUESTUFUG $.

    $( De Morgan's law for join in an ortholattice.  ( ~ chdmj1 analog.)
       (Contributed by NM, 6-Nov-2011.) $)
    oldmj1 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( X .\/ Y ) ) = ( ( ._|_ ` X ) ./\ ( ._|_ ` Y ) ) ) $=
      ( col wcel w3a cfv co oldmm4 3ad2ant1 opoccl sylan fveq2d cops wceq ollat
      olop clat 3adant3 3adant2 latmcl syl3anc opococ syl2anc eqtr3d ) CLMZFAMZ
      GAMZNZFEOZGEOZDPZEOZEOZFGBPZEOUTUQVAVCEABCDEFGHIJKQUAUQCUBMZUTAMZVBUTUCUN
      UOVDUPCUEZRUQCUFMZURAMZUSAMZVEUNUOVGUPCUDRUNUOVHUPUNVDUOVHVFACEFHKSTUGUNU
      PVIUOUNVDUPVIVFACEGHKSTUHACDURUSHJUIUJACEUTHKUKULUM $.

    $( De Morgan's law for join in an ortholattice.  ( ~ chdmj2 analog.)
       (Contributed by NM, 7-Nov-2011.) $)
    oldmj2 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( ( ._|_ ` X ) .\/ Y ) ) = ( X ./\ ( ._|_ ` Y ) ) ) $=
      ( col wcel w3a cfv co wceq cops sylan 3adant3 olop opoccl oldmj1 syld3an2
      opococ oveq1d eqtrd ) CLMZFAMZGAMZNZFEOZGBPEOZULEOZGEOZDPZFUODPUHULAMZUIU
      JUMUPQUHUIUQUJUHCRMZUIUQCUAZACEFHKUBSTABCDEULGHIJKUCUDUKUNFUODUHUIUNFQZUJ
      UHURUIUTUSACEFHKUESTUFUG $.

    $( De Morgan's law for join in an ortholattice.  ( ~ chdmj3 analog.)
       (Contributed by NM, 7-Nov-2011.) $)
    oldmj3 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( X .\/ ( ._|_ ` Y ) ) ) = ( ( ._|_ ` X ) ./\ Y ) ) $=
      ( col wcel w3a cfv co wceq cops olop syl2anc 3ad2ant1 simp3 opoccl oldmj1
      syld3an3 opococ oveq2d eqtrd ) CLMZFAMZGAMZNZFGEOZBPEOZFEOZUMEOZDPZUOGDPU
      IUJUKUMAMZUNUQQULCRMZUKURUIUJUSUKCSUAZUIUJUKUBZACEGHKUCTABCDEFUMHIJKUDUEU
      LUPGUODULUSUKUPGQUTVAACEGHKUFTUGUH $.

    $( De Morgan's law for join in an ortholattice.  ( ~ chdmj4 analog.)
       (Contributed by NM, 7-Nov-2011.) $)
    oldmj4 $p |- ( ( K e. OL /\ X e. B /\ Y e. B ) ->
         ( ._|_ ` ( ( ._|_ ` X ) .\/ ( ._|_ ` Y ) ) ) = ( X ./\ Y ) ) $=
      ( col wcel w3a cfv co wceq cops sylan 3adant2 olop opoccl oldmj2 syld3an3
      opococ oveq2d eqtrd ) CLMZFAMZGAMZNZFEOGEOZBPEOZFULEOZDPZFGDPUHUIUJULAMZU
      MUOQUHUJUPUIUHCRMZUJUPCUAZACEGHKUBSTABCDEFULHIJKUCUDUKUNGFDUHUJUNGQZUIUHU
      QUJUSURACEGHKUESTUFUG $.
  $}

  ${
    olj0.b $e |- B = ( Base ` K ) $.
    olj0.j $e |- .\/ = ( join ` K ) $.
    olj0.z $e |- .0. = ( 0. ` K ) $.
    $( An ortholattice element joined with zero equals itself.  ( ~ chj0
       analog.)  (Contributed by NM, 19-Oct-2011.) $)
    olj01 $p |- ( ( K e. OL /\ X e. B ) -> ( X .\/ .0. ) = X ) $=
      ( col wcel co wceq cops olop op0cl syl syl3an1 wbr sylan 3adant3 w3a cple
      adantr cfv eqid clat ollat 3ad2ant1 latjcl simp2 latref op0le wa wb simp3
      latjle12 syl13anc mpbi2and latlej1 latasymd mpd3an3 ) CIJZDAJZEAJZDEBKZDL
      VBVDVCVBCMJZVDCNZACEFHOPUCVBVCVDUAZACCUBUDZVEDFVIUEZVBVCCUFJZVDCUGZUHZVBV
      KVCVDVEAJVLABCDEFGUIQVBVCVDUJZVHDDVIRZEDVIRZVEDVIRZVBVCVOVDVBVKVCVOVLACVI
      DFVJUKSTVBVCVPVDVBVFVCVPVGACVIDEFVJHULSTVHVKVCVDVCVOVPUMVQUNVMVNVBVCVDUOV
      NABCVIDEDFVJGUPUQURVBVKVCVDDVEVIRVLABCVIDEFVJGUSQUTVA $.

    $( An ortholattice element joined with zero equals itself.  (Contributed by
       NM, 28-Jan-2012.) $)
    olj02 $p |- ( ( K e. OL /\ X e. B ) -> ( .0. .\/ X ) = X ) $=
      ( col wcel wa co clat wceq ollat adantr cops olop op0cl syl simpr latjcom
      syl3anc olj01 eqtrd ) CIJZDAJZKZEDBLZDEBLZDUHCMJZEAJZUGUIUJNUFUKUGCOPUFUL
      UGUFCQJULCRACEFHSTPUFUGUAABCEDFGUBUCABCDEFGHUDUE $.
  $}

  ${
    olm1.b $e |- B = ( Base ` K ) $.
    olm1.m $e |- ./\ = ( meet ` K ) $.
    olm1.u $e |- .1. = ( 1. ` K ) $.
    $( The meet of an ortholattice element with one equals itself.  ( ~ chm1i
       analog.)  (Contributed by NM, 22-May-2012.) $)
    olm11 $p |- ( ( K e. OL /\ X e. B ) -> ( X ./\ .1. ) = X ) $=
      ( col wcel wa coc cfv cjn co cp0 wceq eqid syl sylan adantr oveq2d opoccl
      cops opoc1 olj01 syldan eqtrd fveq2d op1cl oldmj4 mpd3an3 opococ 3eqtr3d
      olop ) CIJZEAJZKZECLMZMZBUSMZCNMZOZUSMZUTUSMZEBDOZEURVCUTUSURVCUTCPMZVBOZ
      UTURVAVGUTVBURCUDJZVAVGQUPVIUQCUOZUAZBCUSVGVGRZHUSRZUESUBUPUQUTAJZVHUTQUP
      VIUQVNVJACUSEFVMUCTAVBCUTVGFVBRZVLUFUGUHUIUPUQBAJZVDVFQURVIVPVKABCFHUJSAV
      BCDUSEBFVOGVMUKULUPVIUQVEEQVJACUSEFVMUMTUN $.

    $( The meet of an ortholattice element with one equals itself.
       (Contributed by NM, 22-May-2012.) $)
    olm12 $p |- ( ( K e. OL /\ X e. B ) -> ( .1. ./\ X ) = X ) $=
      ( col wcel wa co clat wceq ollat adantr cops olop op1cl syl simpr latmcom
      syl3anc olm11 eqtrd ) CIJZEAJZKZBEDLZEBDLZEUHCMJZBAJZUGUIUJNUFUKUGCOPUHCQ
      JZULUFUMUGCRPABCFHSTUFUGUAACDBEFGUBUCABCDEFGHUDUE $.
  $}

  ${
    olmass.b $e |- B = ( Base ` K ) $.
    olmass.m $e |- ./\ = ( meet ` K ) $.
    $( Ortholattice meet is associative.  (This can also be proved for lattices
       with a longer proof.)  ( ~ inass analog.)  (Contributed by NM,
       7-Nov-2011.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    latmassOLD $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X ./\ Y ) ./\ Z ) = ( X ./\ ( Y ./\ Z ) ) ) $=
      ( col wcel co cfv wceq adantr eqid opoccl syl2anc latjcl syl3anc oldmj4
      w3a wa coc simpl clat ollat cops olop simpr1 simpr2 simpr3 oldmj3 latjass
      syl13anc fveq2d 3adant3r3 oveq1d 3eqtr3rd oldmj2 3adant3r1 oveq2d 3eqtrd
      cjn ) BIJZDAJZEAJZFAJZUAZUBZDECKZFCKZDBUCLZLZEVLLZFVLLZBVCLZKZVPKZVLLZDVQ
      VLLZCKZDEFCKZCKVIVMVNVPKZVOVPKZVLLZWCVLLZFCKZVSVKVIVDWCAJZVGWEWGMVDVHUDZV
      IBUEJZVMAJZVNAJZWHVDWJVHBUFNZVIBUGJZVEWKVDWNVHBUHNZVDVEVFVGUIZABVLDGVLOZP
      QZVIWNVFWLWOVDVEVFVGUJABVLEGWQPQZAVPBVMVNGVPOZRSVDVEVFVGUKZAVPBCVLWCFGWTH
      WQULSVIWDVRVLVIWJWKWLVOAJZWDVRMWMWRWSVIWNVGXBWOXAABVLFGWQPQZAVPBVMVNVOGWT
      UMUNUOVIWFVJFCVDVEVFWFVJMVGAVPBCVLDEGWTHWQTUPUQURVIVDVEVQAJZVSWAMWIWPVIWJ
      WLXBXDWMWSXCAVPBVNVOGWTRSAVPBCVLDVQGWTHWQUSSVIVTWBDCVDVFVGVTWBMVEAVPBCVLE
      FGWTHWQTUTVAVB $.

    $( A rearrangement of lattice meet.  ( ~ in12 analog.)  (Contributed by NM,
       8-Nov-2011.) $)
    latm12 $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( X ./\ ( Y ./\ Z ) ) = ( Y ./\ ( X ./\ Z ) ) ) $=
      ( col wcel w3a wa co clat wceq ollat adantr simpr1 simpr2 latmassOLD 3jca
      latmcom syl3anc oveq1d simpr3 syldan 3eqtr3d ) BIJZDAJZEAJZFAJZKZLZDECMZF
      CMEDCMZFCMZDEFCMCMEDFCMCMZUMUNUOFCUMBNJZUIUJUNUOOUHURULBPQUHUIUJUKRZUHUIU
      JUKSZABCDEGHUBUCUDABCDEFGHTUHULUJUIUKKUPUQOUMUJUIUKUTUSUHUIUJUKUEUAABCEDF
      GHTUFUG $.

    $( A rearrangement of lattice meet.  ( ~ in12 analog.)  (Contributed by NM,
       13-Nov-2012.) $)
    latm32 $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X ./\ Y ) ./\ Z ) = ( ( X ./\ Z ) ./\ Y ) ) $=
      ( col wcel w3a wa co wceq clat ollat latmcom syl3an1 3adant3r1 latmassOLD
      oveq2d simpl simpr1 simpr3 simpr2 syl13anc 3eqtr4d ) BIJZDAJZEAJZFAJZKZLZ
      DEFCMZCMDFECMZCMZDECMFCMDFCMECMZUMUNUODCUHUJUKUNUONZUIUHBOJUJUKURBPABCEFG
      HQRSUAABCDEFGHTUMUHUIUKUJUQUPNUHULUBUHUIUJUKUCUHUIUJUKUDUHUIUJUKUEABCDFEG
      HTUFUG $.

    $( Rotate lattice meet of 3 classes.  (Contributed by NM, 9-Oct-2012.) $)
    latmrot $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X ./\ Y ) ./\ Z ) = ( ( Z ./\ X ) ./\ Y ) ) $=
      ( col wcel w3a wa co clat wceq ollat adantr simpr1 simpr2 syl3anc latmcom
      latmcl simpr3 simpl latmassOLD syl13anc eqtr4d ) BIJZDAJZEAJZFAJZKZLZDECM
      ZFCMZFUNCMZFDCMECMZUMBNJZUNAJZUKUOUPOUHURULBPQZUMURUIUJUSUTUHUIUJUKRZUHUI
      UJUKSZABCDEGHUBTUHUIUJUKUCZABCUNFGHUATUMUHUKUIUJUQUPOUHULUDVCVAVBABCFDEGH
      UEUFUG $.

    $( Rearrangement of lattice meet of 4 classes.  ( ~ in4 analog.)
       (Contributed by NM, 8-Nov-2011.) $)
    latm4 $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B ) /\ ( Z e. B /\ W e. B ) )
      -> ( ( X ./\ Y ) ./\ ( Z ./\ W ) )
           = ( ( X ./\ Z ) ./\ ( Y ./\ W ) ) ) $=
      ( col wcel wa w3a co wceq simp1 syl13anc latmcl syl3anc latmassOLD simp2r
      simp3l simp3r latm12 oveq2d simp2l clat ollat 3ad2ant1 3eqtr4d ) BJKZEAKZ
      FAKZLZGAKZDAKZLZMZEFGDCNZCNZCNZEGFDCNZCNZCNZEFCNUSCNZEGCNVBCNZURUTVCECURU
      KUMUOUPUTVCOUKUNUQPZUKULUMUQUAZUKUNUOUPUBZUKUNUOUPUCZABCFGDHIUDQUEURUKULU
      MUSAKZVEVAOVGUKULUMUQUFZVHURBUGKZUOUPVKUKUNVMUQBUHUIZVIVJABCGDHIRSABCEFUS
      HITQURUKULUOVBAKZVFVDOVGVLVIURVMUMUPVOVNVHVJABCFDHIRSABCEGVBHITQUJ $.

    $( Lattice meet distributes over itself.  ( ~ inindi analog.)  (Contributed
       by NM, 8-Nov-2011.)  (New usage is discouraged.) $)
    latmmdiN $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( X ./\ ( Y ./\ Z ) ) = ( ( X ./\ Y ) ./\ ( X ./\ Z ) ) ) $=
      ( col wcel w3a wa co clat wceq ollat adantr simpr1 latmidm syl2anc oveq1d
      simpl simpr2 simpr3 latm4 syl122anc eqtr3d ) BIJZDAJZEAJZFAJZKZLZDDCMZEFC
      MZCMZDUOCMDECMDFCMCMZUMUNDUOCUMBNJZUIUNDOUHURULBPQUHUIUJUKRZABCDGHSTUAUMU
      HUIUIUJUKUPUQOUHULUBUSUSUHUIUJUKUCUHUIUJUKUDABCFDDEGHUEUFUG $.

    $( Lattice meet distributes over itself.  ( ~ inindir analog.)
       (Contributed by NM, 6-Jun-2012.) $)
    latmmdir $p |- ( ( K e. OL /\ ( X e. B /\ Y e. B /\ Z e. B ) ) ->
             ( ( X ./\ Y ) ./\ Z ) = ( ( X ./\ Z ) ./\ ( Y ./\ Z ) ) ) $=
      ( col wcel w3a wa co clat wceq ollat adantr simpr3 latmidm syl2anc oveq2d
      simpl simpr1 simpr2 latm4 syl122anc eqtr3d ) BIJZDAJZEAJZFAJZKZLZDECMZFFC
      MZCMZUNFCMDFCMEFCMCMZUMUOFUNCUMBNJZUKUOFOUHURULBPQUHUIUJUKRZABCFGHSTUAUMU
      HUIUJUKUKUPUQOUHULUBUHUIUJUKUCUHUIUJUKUDUSUSABCFDEFGHUEUFUG $.
  $}

  ${
    olm0.b $e |- B = ( Base ` K ) $.
    olm0.m $e |- ./\ = ( meet ` K ) $.
    olm0.z $e |- .0. = ( 0. ` K ) $.
    $( Meet with lattice zero is zero.  ( ~ chm0 analog.)  (Contributed by NM,
       8-Nov-2011.) $)
    olm01 $p |- ( ( K e. OL /\ X e. B ) -> ( X ./\ .0. ) = .0. ) $=
      ( col wcel wa cple cfv co eqid clat ollat adantr syl3anc wbr simpr latmcl
      cops olop op0cl syl latmle2 op0le sylan latref latlem12 syl13anc mpbi2and
      syl2anc wb latasymd ) BIJZDAJZKZABBLMZDECNZEFUTOZUQBPJZURBQRZUSVCUREAJZVA
      AJVDUQURUAZUSBUCJZVEUQVGURBUDZRABEFHUEUFZABCDEFGUBSVIUSVCURVEVAEUTTVDVFVI
      ABUTCDEFVBGUGSUSEDUTTZEEUTTZEVAUTTZUQVGURVJVHABUTDEFVBHUHUIUSVCVEVKVDVIAB
      UTEFVBUJUNUSVCVEURVEVJVKKVLUOVDVIVFVIABUTCEDEFVBGUKULUMUP $.

    $( Meet with lattice zero is zero.  (Contributed by NM, 9-Oct-2012.) $)
    olm02 $p |- ( ( K e. OL /\ X e. B ) -> ( .0. ./\ X ) = .0. ) $=
      ( col wcel wa co clat wceq ollat adantr simpr cops olop op0cl syl latmcom
      syl3anc olm01 eqtr3d ) BIJZDAJZKZDECLZEDCLZEUHBMJZUGEAJZUIUJNUFUKUGBOPUFU
      GQUHBRJZULUFUMUGBSPABEFHTUAABCDEFGUBUCABCDEFGHUDUE $.
  $}

  ${
    $d k x y B $.  $d k .\/ $.  $d k x y K $.  $d k ./\ $.  $d k ._|_ $.
    $d k .<_ $.
    isoml.b $e |- B = ( Base ` K ) $.
    isoml.l $e |- .<_ = ( le ` K ) $.
    isoml.j $e |- .\/ = ( join ` K ) $.
    isoml.m $e |- ./\ = ( meet ` K ) $.
    isoml.o $e |- ._|_ = ( oc ` K ) $.
    $( The predicate "is an orthomodular lattice."  (Contributed by NM,
       18-Sep-2011.) $)
    isoml $p |- ( K e. OML <-> ( K e. OL /\ A. x e. B A. y e. B
       ( x .<_ y -> y = ( x .\/ ( y ./\ ( ._|_ ` x ) ) ) ) ) ) $=
      ( vk cv cfv co wral fveq2 syl6eqr cple wbr coc cmee cjn wceq cbs col coml
      wi breqd eqidd fveq1d oveq123d eqeq2d imbi12d raleqbidv df-oml elrab2 ) A
      OZBOZNOZUAPZUBZVAUTVAUTVBUCPZPZVBUDPZQZVBUEPZQZUFZUJZBVBUGPZRZAVMRUTVAFUB
      ZVAUTVAUTHPZGQZDQZUFZUJZBCRZACRNEUHUIVBEUFZVNWAAVMCWBVMEUGPCVBEUGSITZWBVL
      VTBVMCWCWBVDVOVKVSWBVCFUTVAWBVCEUAPFVBEUASJTUKWBVJVRVAWBUTUTVHVQVIDWBVIEU
      EPDVBEUESKTWBUTULWBVAVAVFVPVGGWBVGEUDPGVBEUDSLTWBVAULWBUTVEHWBVEEUCPHVBEU
      CSMTUMUNUNUOUPUQUQABNURUS $.
  $}

  ${
    $d x y B $.  $d x y K $.
    isomli.0 $e |- K e. OL $.
    isomli.b $e |- B = ( Base ` K ) $.
    isomli.l $e |- .<_ = ( le ` K ) $.
    isomli.j $e |- .\/ = ( join ` K ) $.
    isomli.m $e |- ./\ = ( meet ` K ) $.
    isomli.o $e |- ._|_ = ( oc ` K ) $.
    isomli.7 $e |- ( ( x e. B /\ y e. B ) ->
                      ( x .<_ y -> y = ( x .\/ ( y ./\ ( ._|_ ` x ) ) ) ) ) $.
    $( Properties that determine an orthomodular lattice.  (Contributed by NM,
       18-Sep-2011.)  (New usage is discouraged.) $)
    isomliN $p |- K e. OML $=
      ( coml wcel cv co wral col wbr cfv wceq wi rgen2a isoml mpbir2an ) EPQEUA
      QARZBRZFUBUJUIUJUIHUCGSDSUDUEZBCTACTIUKABCOUFABCDEFGHJKLMNUGUH $.
  $}

  ${
    $d x y K $.
    $( An orthomodular lattice is an ortholattice.  (Contributed by NM,
       18-Sep-2011.) $)
    omlol $p |- ( K e. OML -> K e. OL ) $=
      ( vx vy coml wcel col cv cple cfv wbr coc cmee co cjn wceq cbs wral isoml
      wi eqid simplbi ) ADEAFEBGZCGZAHIZJUCUBUCUBAKIZIALIZMANIZMOSCAPIZQBUHQBCU
      HUGAUDUFUEUHTUDTUGTUFTUETRUA $.
  $}

  $( An orthomodular lattice is an orthoposet.  (Contributed by NM,
     6-Nov-2011.) $)
  omlop $p |- ( K e. OML -> K e. OP ) $=
    ( coml wcel col cops omlol olop syl ) ABCADCAECAFAGH $.

  $( An orthomodular lattice is a lattice.  (Contributed by NM, 6-Nov-2011.) $)
  omllat $p |- ( K e. OML -> K e. Lat ) $=
    ( coml wcel col clat omlol ollat syl ) ABCADCAECAFAGH $.

  ${
    $d x y B $.  $d x y .\/ $.  $d x y K $.  $d x y ./\ $.  $d x y ._|_ $.
    $d x y .<_ $.  $d x y X $.  $d y Y $.
    omllaw.b $e |- B = ( Base ` K ) $.
    omllaw.l $e |- .<_ = ( le ` K ) $.
    omllaw.j $e |- .\/ = ( join ` K ) $.
    omllaw.m $e |- ./\ = ( meet ` K ) $.
    omllaw.o $e |- ._|_ = ( oc ` K ) $.
    $( The orthomodular law.  (Contributed by NM, 18-Sep-2011.) $)
    omllaw $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) ->
            ( X .<_ Y -> Y = ( X .\/ ( Y ./\ ( ._|_ ` X ) ) ) ) ) $=
      ( vx vy wcel wbr co wceq wi coml cfv cv wral wa isoml simprbi breq1 fveq2
      col id oveq2d oveq12d eqeq2d imbi12d breq2 eqeq12d rspc2v syl5com 3impib
      oveq1 ) CUAPZGAPZHAPZGHDQZHGHGFUBZERZBRZSZTZVBNUCZOUCZDQZVLVKVLVKFUBZERZB
      RZSZTZOAUDNAUDZVCVDUEVJVBCUJPVSNOABCDEFIJKLMUFUGVRVJGVLDQZVLGVLVFERZBRZSZ
      TNOGHAAVKGSZVMVTVQWCVKGVLDUHWDVPWBVLWDVKGVOWABWDUKWDVNVFVLEVKGFUIULUMUNUO
      VLHSZVTVEWCVIVLHGDUPWEVLHWBVHWEUKWEWAVGGBVLHVFEVAULUQUOURUSUT $.

    $( Variation of orthomodular law.  Definition of OML law in [Kalmbach]
       p. 22.  ( ~ pjoml2i analog.)  (Contributed by NM, 6-Nov-2011.)
       (New usage is discouraged.) $)
    omllaw2N $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) ->
            ( X .<_ Y -> ( X .\/ ( ( ._|_ ` X ) ./\ Y ) ) = Y ) ) $=
      ( coml wcel w3a wbr cfv co wceq omllaw eqcom omllat 3ad2ant1 omlop opoccl
      clat sylan 3adant3 simp3 latmcom syl3anc oveq2d eqeq2d syl5bb sylibrd
      cops ) CNOZGAOZHAOZPZGHDQHGHGFRZESZBSZTZGVBHESZBSZHTZABCDEFGHIJKLMUAVHHVG
      TVAVEVGHUBVAVGVDHVAVFVCGBVACUGOZVBAOZUTVFVCTURUSVIUTCUCUDURUSVJUTURCUQOUS
      VJCUEACFGIMUFUHUIURUSUTUJACEVBHILUKULUMUNUOUP $.
  $}

  ${
    omllaw3.b $e |- B = ( Base ` K ) $.
    omllaw3.l $e |- .<_ = ( le ` K ) $.
    omllaw3.m $e |- ./\ = ( meet ` K ) $.
    omllaw3.o $e |- ._|_ = ( oc ` K ) $.
    omllaw3.z $e |- .0. = ( 0. ` K ) $.
    $( Orthomodular law equivalent.  Theorem 2(ii) of [Kalmbach] p. 22.
       ( ~ pjoml analog.)  (Contributed by NM, 19-Oct-2011.) $)
    omllaw3 $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) ->
            ( ( X .<_ Y /\ ( Y ./\ ( ._|_ ` X ) ) = .0. ) -> X = Y ) ) $=
      ( coml wcel w3a cfv co wceq wa wbr cjn oveq2 adantl col omlol olj01 sylan
      eqid 3adant3 adantr eqtr2d adantrl omllaw imp adantrr eqtr4d ex ) BNOZFAO
      ZGAOZPZFGCUAZGFEQDRZHSZTZFGSVBVFTFFVDBUBQZRZGVBVEFVHSVCVBVETVHFHVGRZFVEVH
      VISVBVDHFVGUCUDVBVIFSZVEUSUTVJVAUSBUEOUTVJBUFAVGBFHIVGUIZMUGUHUJUKULUMVBV
      CGVHSZVEVBVCVLAVGBCDEFGIJVKKLUNUOUPUQUR $.
  $}

  ${
    omllaw4.b $e |- B = ( Base ` K ) $.
    omllaw4.l $e |- .<_ = ( le ` K ) $.
    omllaw4.m $e |- ./\ = ( meet ` K ) $.
    omllaw4.o $e |- ._|_ = ( oc ` K ) $.
    $( Orthomodular law equivalent.  Remark in [Holland95] p. 223.
       (Contributed by NM, 19-Oct-2011.) $)
    omllaw4 $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) ->
            ( X .<_ Y -> ( ( ._|_ ` ( ( ._|_ ` X ) ./\ Y ) ) ./\ Y ) = X ) ) $=
      ( wcel cfv wbr co wceq 3ad2ant1 opoccl syl2anc syl3anc coml w3a cjn simp1
      wi cops omlop simp3 simp2 eqid omllaw wb oplecon3b syl3an1 omllat opcon3b
      clat latmcl latjcom col omlol oldmm2 opococ oveq2d 3eqtr4d eqeq2d 3imtr4d
      bitrd ) BUALZFALZGALZUBZGEMZFEMZCNZVNVMVNVMEMZDOZBUCMZOZPZFGCNZVNGDOZEMZG
      DOZFPZVLVIVMALZVNALZVOVTUEVIVJVKUDVLBUFLZVKWFVIVJWHVKBUGZQZVIVJVKUHZABEGH
      KRSZVLWHVJWGWJVIVJVKUIZABEFHKRSZAVRBCDEVMVNHIVRUJZJKUKTVIWHVJVKWAVOULWIAB
      CEFGHIKUMUNVLWEVNWDEMZPZVTVLWHWDALZVJWEWQULWJVLBUQLZWCALZVKWRVIVJWSVKBUOQ
      ZVLWHWBALZWTWJVLWSWGVKXBXAWNWKABDVNGHJURTZABEWBHKRSWKABDWCGHJURTWMABEWDFH
      KUPTVLWPVSVNVLWBVMVROZVMWBVROZWPVSVLWSXBWFXDXEPXAXCWLAVRBWBVMHWOUSTVLBUTL
      ZXBVKWPXDPVIVJXFVKBVAQXCWKAVRBDEWBGHWOJKVBTVLVQWBVMVRVLVPGVNDVLWHVKVPGPWJ
      WKABEGHKVCSVDVDVEVFVHVG $.
  $}

  ${
    omllaw5.b $e |- B = ( Base ` K ) $.
    omllaw5.j $e |- .\/ = ( join ` K ) $.
    omllaw5.m $e |- ./\ = ( meet ` K ) $.
    omllaw5.o $e |- ._|_ = ( oc ` K ) $.
    $( The orthomodular law.  Remark in [Kalmbach] p. 22.  ( ~ pjoml5 analog.)
       (Contributed by NM, 14-Nov-2011.)  (New usage is discouraged.) $)
    omllaw5N $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) ->
            ( X .\/ ( ( ._|_ ` X ) ./\ ( X .\/ Y ) ) ) = ( X .\/ Y ) ) $=
      ( coml wcel w3a co cple cfv wbr wceq syl3an1 simp1 simp2 clat omllat 3jca
      latjcl eqid latlej1 omllaw2N sylc ) CLMZFAMZGAMZNZUKULFGBOZAMZNFUOCPQZRZF
      FEQUODOBOUOSUNUKULUPUKULUMUAUKULUMUBUKCUCMZULUMUPCUDZABCFGHIUFTUEUKUSULUM
      URUTABCUQFGHUQUGZIUHTABCUQDEFUOHVAIJKUIUJ $.
  $}

  ${
    cmtcom.b $e |- B = ( Base ` K ) $.
    cmtcom.c $e |- C = ( cm ` K ) $.
    $( Lemma for ~ cmtcomN .  ( ~ cmcmlem analog.)  (Contributed by NM,
       7-Nov-2011.)  (New usage is discouraged.) $)
    cmtcomlemN $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) -> ( X C Y ->
               Y C X ) ) $=
      ( coml wcel w3a cfv wceq wbr 3ad2ant1 eqid opoccl syl3anc syl3an1 adantr
      co cmee coc wa cple clat omllat cops omlop sylan 3adant3 simp3 latlej2 wb
      cjn latjcl latleeqm2 mpbid oveq2d omlol latmassOLD syl13anc oldmm1 oveq1d
      syl2anc 3eqtr4rd oldmj4 oldmj2 oveq12d eqeq2d biimpar fveq2d eqtr2d eqtrd
      simp1 latmcl 3jca latmle2 omllaw2N sylc latmcom 3eqtr3d ex cmtvalN 3com23
      col 3imtr4d ) CHIZDAIZEAIZJZDDECUAKZTZDECUBKZKZWKTZCUNKZTZLZEEDWKTZEDWMKZ
      WKTZWPTZLZDEBMEDBMZWJWRXCWJWRUCZWLWLWMKZEWKTZWPTZWLWTEWKTZWPTZEXBXEXGXIWL
      WPXEXGWTWNWPTZWTEWPTZWKTZEWKTZXIWJXGXNLWRWJXKXLEWKTZWKTZXKEWKTXNXGWJXOEXK
      WKWJEXLCUDKZMZXOELZWJCUEIZWTAIZWIXRWGWHXTWICUFZNZWGWHYAWIWGCUGIZWHYACUHZA
      CWMDFWMOZPUIUJZWGWHWIUKZAWPCXQWTEFXQOZWPOZULQWJXTWIXLAIZXRXSUMYCYHWJXTYAW
      IYKYCYGYHAWPCWTEFYJUOQZACXQWKEXLFYIWKOZUPQUQURWJCWEIZXKAIZYKWIXNXPLWGWHYN
      WICUSZNZWJXTYAWNAIZYOYCYGWJYDWIYRWGWHYDWIYENYHACWMEFYFPVDAWPCWTWNFYJUOQZY
      LYHACWKXKXLEFYMUTVAWJXFXKEWKWGYNWHWIXFXKLYPAWPCWKWMDEFYJYMYFVBRVCVESXEXMW
      TEWKXEWTXKWMKZXLWMKZWPTZWMKZXMXEDUUBWMWJDUUBLWRWJUUBWQDWJYTWLUUAWOWPWGYNW
      HWIYTWLLYPAWPCWKWMDEFYJYMYFVFRWGYNWHWIUUAWOLYPAWPCWKWMDEFYJYMYFVGRVHVIVJV
      KWJUUCXMLZWRWJYNYOYKUUDYQYSYLAWPCWKWMXKXLFYJYMYFVFQSVLVCVMURWJXHELZWRWJWG
      WLAIZWIJWLEXQMZUUEWJWGUUFWIWGWHWIVNWGXTWHWIUUFYBACWKDEFYMVORYHVPWGXTWHWIU
      UGYBACXQWKDEFYIYMVQRAWPCXQWKWMWLEFYIYJYMYFVRVSSWJXJXBLWRWJWLWSXIXAWPWGXTW
      HWIWLWSLYBACWKDEFYMVTRWJXTYAWIXIXALYCYGYHACWKWTEFYMVTQVHSWAWBHABWPCWKWMDE
      FYJYMYFGWCWGWIWHXDXCUMHABWPCWKWMEDFYJYMYFGWCWDWF $.

    $( Commutation is symmetric.  Theorem 2(v) in [Kalmbach] p. 22.  ( ~ cmcmi
       analog.)  (Contributed by NM, 7-Nov-2011.)
       (New usage is discouraged.) $)
    cmtcomN $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) -> ( X C Y <->
               Y C X ) ) $=
      ( coml wcel w3a wbr cmtcomlemN wi 3com23 impbid ) CHIZDAIZEAIZJDEBKZEDBKZ
      ABCDEFGLPRQTSMABCEDFGLNO $.
  $}

  ${
    cmt2.b $e |- B = ( Base ` K ) $.
    cmt2.o $e |- ._|_ = ( oc ` K ) $.
    cmt2.c $e |- C = ( cm ` K ) $.
    $( Commutation with orthocomplement.  Theorem 2.3(i) of [Beran] p. 39.
       ( ~ cmcm2i analog.)  (Contributed by NM, 8-Nov-2011.)
       (New usage is discouraged.) $)
    cmt2N $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) -> ( X C Y <->
               X C ( ._|_ ` Y ) ) ) $=
      ( coml wcel cfv co wceq wbr 3ad2ant1 eqid latmcl syl2anc syl3anc w3a cmee
      clat omllat syl3an1 simp2 omlop simp3 opoccl latjcom opococ oveq2d eqtr4d
      cjn cops eqeq2d cmtvalN wb syld3an3 3bitr4d ) CJKZEAKZFAKZUAZEEFCUBLZMZEF
      DLZVEMZCUNLZMZNEVHEVGDLZVEMZVIMZNZEFBOEVGBOZVDVJVMEVDVJVHVFVIMZVMVDCUCKZV
      FAKZVHAKZVJVPNVAVBVQVCCUDZPZVAVQVBVCVRVTACVEEFGVEQZRUEVDVQVBVGAKZVSWAVAVB
      VCUFVDCUOKZVCWCVAVBWDVCCUGPZVAVBVCUHZACDFGHUISZACVEEVGGWBRTAVICVFVHGVIQZU
      JTVDVLVFVHVIVDVKFEVEVDWDVCVKFNWEWFACDFGHUKSULULUMUPJABVICVEDEFGWHWBHIUQVA
      VBVCWCVOVNURWGJABVICVEDEVGGWHWBHIUQUSUT $.

    $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23.
       ( ~ cmcm4i analog.)  (Contributed by NM, 8-Nov-2011.)
       (New usage is discouraged.) $)
    cmt3N $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) -> ( X C Y <->
               ( ._|_ ` X ) C Y ) ) $=
      ( coml wcel w3a wbr cfv wb cmt2N 3com23 cmtcomN cops omlop 3ad2ant1 simp2
      opoccl syl2anc syld3an2 3bitr4d ) CJKZEAKZFAKZLZFEBMZFEDNZBMZEFBMULFBMZUG
      UIUHUKUMOABCDFEGHIPQABCEFGIRUGULAKZUHUIUNUMOUJCSKZUHUOUGUHUPUICTUAUGUHUIU
      BACDEGHUCUDABCULFGIRUEUF $.

    $( Commutation with orthocomplement.  Remark in [Kalmbach] p. 23.
       ( ~ cmcm4i analog.)  (Contributed by NM, 8-Nov-2011.)
       (New usage is discouraged.) $)
    cmt4N $p |- ( ( K e. OML /\ X e. B /\ Y e. B ) -> ( X C Y <->
               ( ._|_ ` X ) C ( ._|_ ` Y ) ) ) $=
      ( coml wcel w3a wbr cfv cmt2N wb cops omlop 3ad2ant1 simp3 opoccl syl2anc
      cmt3N syld3an3 bitrd ) CJKZEAKZFAKZLZEFBMEFDNZBMZEDNUJBMZABCDEFGHIOUFUGUH
      UJAKZUKULPUICQKZUHUMUFUGUNUHCRSUFUGUHTACDFGHUAUBABCDEUJGHIUCUDUE $.
  $}

  ${
    cmtbr2.b $e |- B = ( Base ` K ) $.
    cmtbr2.j $e |- .\/ = ( join ` K ) $.
    cmtbr2.m $e |- ./\ = ( meet ` K ) $.
    cmtbr2.o $e |- ._|_ = ( oc ` K ) $.
    cmtbr2.c $e |- C = ( cm ` K ) $.
    $( Alternate definition of the commutes relation.  Remark in [Kalmbach]
       p. 23.  ( ~ cmbr2i analog.)  (Contributed by NM, 8-Nov-2011.)
       (New usage is discouraged.) $)
    cmtbr2N $p |- ( ( K e. OML /\ X e. B /\ Y e. B )
     -> ( X C Y <-> X = ( ( X .\/ Y ) ./\ ( X .\/ ( ._|_ ` Y ) ) ) ) ) $=
      ( wcel cfv co wceq wb 3ad2ant1 syl3anc coml cmt4N simp1 cops omlop opoccl
      w3a wbr simp2 syl2anc simp3 cmtvalN a1i clat omllat latjcl syl3an1 latmcl
      eqcom opcon3b col omlol oldmm1 oldmj1 oveq12d eqtrd eqeq2d 3bitrrd 3bitrd
      ) DUANZGANZHANZUGZGHBUHGFOZHFOZBUHZVNVNVOEPZVNVOFOEPZCPZQZGGHCPZGVOCPZEPZ
      QZABDFGHILMUBVMVJVNANZVOANZVPVTRVJVKVLUCVMDUDNZVKWEVJVKWGVLDUESZVJVKVLUIZ
      ADFGILUFUJVMWGVLWFWHVJVKVLUKADFHILUFUJZUAABCDEFVNVOIJKLMULTVMWDWCGQZVNWCF
      OZQZVTWDWKRVMGWCUSUMVMWGWCANZVKWKWMRWHVMDUNNZWAANZWBANZWNVJVKWOVLDUOZSZVJ
      WOVKVLWPWRACDGHIJUPUQZVMWOVKWFWQWSWIWJACDGVOIJUPTZADEWAWBIKURTWIADFWCGILU
      TTVMWLVSVNVMWLWAFOZWBFOZCPZVSVMDVANZWPWQWLXDQVJVKXEVLDVBZSZWTXAACDEFWAWBI
      JKLVCTVMXBVQXCVRCVJXEVKVLXBVQQXFACDEFGHIJKLVDUQVMXEVKWFXCVRQXGWIWJACDEFGV
      OIJKLVDTVEVFVGVHVI $.

    $( Alternate definition for the commutes relation.  Lemma 3 of [Kalmbach]
       p. 23.  ( ~ cmbr3 analog.)  (Contributed by NM, 8-Nov-2011.)
       (New usage is discouraged.) $)
    cmtbr3N $p |- ( ( K e. OML /\ X e. B /\ Y e. B )
     -> ( X C Y <-> ( X ./\ ( ( ._|_ ` X ) .\/ Y ) ) = ( X ./\ Y ) ) ) $=
      ( wcel wbr cfv co wceq 3ad2ant1 syl3anc coml w3a cmtcomN wb cmtbr2N bitrd
      3com23 oveq2 adantl col omlol simp2 clat omllat simp3 latjcl omlop opoccl
      wa cops syl2anc latmassOLD syl13anc latjcom latabs2 syl3an1 eqtrd oveq12d
      oveq2d eqtr3d adantr eqtr2d ex sylbid cple simp1 latmcl 3jca eqid latmle1
      omllaw2N sylc oldmm3N latmcom eqeq1d oveq1 syl6bi cmtvalN sylibrd impbid
      imp ) DUANZGANZHANZUBZGHBOZGGFPZHCQZEQZGHEQZRZWOWPHHGCQZHWQCQZEQZRZXAWOWP
      HGBOZXEABDGHIMUCWLWNWMXFXEUDABCDEFHGIJKLMUEUGUFWOXEXAWOXEUSWTGXDEQZWSXEWT
      XGRWOHXDGEUHUIWOXGWSRXEWOGXBEQZXCEQZXGWSWODUJNZWMXBANZXCANZXIXGRWLWMXJWND
      UKZSWLWMWNULZWODUMNZWNWMXKWLWMXOWNDUNZSZWLWMWNUOZXNACDHGIJUPTWOXOWNWQANZX
      LXQXRWODUTNZWMXSWLWMXTWNDUQSZXNADFGILURVAZACDHWQIJUPTADEGXBXCIKVBVCWOXHGX
      CWREWOXHGGHCQZEQZGWOXBYCGEWOXOWNWMXBYCRXQXRXNACDHGIJVDTVIWLXOWMWNYDGRXPAC
      DEGHIJKVEVFVGWOXOWNXSXCWRRXQXRYBACDHWQIJVDTVHVJVKVLVMVNWOXAGWTGHFPZEQZCQZ
      RZWPWOXAYHWOXAUSGYFFPZGEQZYFCQZYGWOGYKRXAWOYFYJCQZGYKWOWLYFANZWMUBYFGDVOP
      ZOZYLGRWOWLYMWMWLWMWNVPWOXOWMYEANZYMXQXNWOXTWNYPYAXRADFHILURVAZADEGYEIKVQ
      TZXNVRWOXOWMYPYOXQXNYQADYNEGYEIYNVSZKVTTACDYNEFYFGIYSJKLWAWBWOXOYMYJANZYL
      YKRXQYRWOXOYIANZWMYTXQWOXTYMUUAYAYRADFYFILURVAZXNADEYIGIKVQTACDYFYJIJVDTV
      JVKWOXAYKYGRZWOXAYJWTRUUCWOWSYJWTWOGYIEQZWSYJWOYIWRGEWLXJWMWNYIWRRXMACDEF
      GHIJKLWCVFVIWOXOWMUUAUUDYJRXQXNUUBADEGYIIKWDTVJWEYJWTYFCWFWGWKVGVMUAABCDE
      FGHIJKLMWHWIWJ $.
  $}

  ${
    cmtbr4.b $e |- B = ( Base ` K ) $.
    cmtbr4.l $e |- .<_ = ( le ` K ) $.
    cmtbr4.j $e |- .\/ = ( join ` K ) $.
    cmtbr4.m $e |- ./\ = ( meet ` K ) $.
    cmtbr4.o $e |- ._|_ = ( oc ` K ) $.
    cmtbr4.c $e |- C = ( cm ` K ) $.
    $( Alternate definition for the commutes relation.  ( ~ cmbr4i analog.)
       (Contributed by NM, 10-Nov-2011.)  (New usage is discouraged.) $)
    cmtbr4N $p |- ( ( K e. OML /\ X e. B /\ Y e. B )
     -> ( X C Y <-> ( X ./\ ( ( ._|_ ` X ) .\/ Y ) ) .<_ Y ) ) $=
      ( wcel wbr co syl3an1 syl3anc coml w3a cfv wceq cmtbr3N clat omllat breq1
      latmle2 syl5ibrcom 3ad2ant1 simp2 cops omlop opoccl syl2anc simp3 latmle1
      wa latjcl anim1i ex wb latmcl latlem12 syl13anc sylibd wi latmlem2 jctird
      latlej2 mpd latasymb impbid bitrd ) DUAPZHAPZIAPZUBZHIBQHHGUCZICRZFRZHIFR
      ZUDZWBIEQZABCDFGHIJLMNOUEVSWDWEVSWEWDWCIEQZVPDUFPZVQVRWFDUGZADEFHIJKMUISW
      BWCIEUHUJVSWEWBWCEQZWCWBEQZUSZWDVSWEWIWJVSWEWBHEQZWEUSZWIVSWEWMVSWLWEVSWG
      VQWAAPZWLVPVQWGVRWHUKZVPVQVRULZVSWGVTAPZVRWNWOVSDUMPZVQWQVPVQWRVRDUNUKWPA
      DGHJNUOUPZVPVQVRUQZACDVTIJLUTTZADEFHWAJKMURTVAVBVSWGWBAPZVQVRWMWIVCWOVSWG
      VQWNXBWOWPXAADFHWAJMVDTZWPWTADEFWBHIJKMVEVFVGVSIWAEQZWJVSWGWQVRXDWOWSWTAC
      DEVTIJKLVKTVSWGVRWNVQXDWJVHWOWTXAWPADEFIWAHJKMVIVFVLVJVSWGXBWCAPZWKWDVCWO
      XCVPWGVQVRXEWHADFHIJMVDSADEWBWCJKVMTVGVNVO $.
  $}

  ${
    lecmt.b $e |- B = ( Base ` K ) $.
    lecmt.l $e |- .<_ = ( le ` K ) $.
    lecmt.c $e |- C = ( cm ` K ) $.
    $( Ordered elements commute.  ( ~ lecmi analog.)  (Contributed by NM,
       10-Nov-2011.)  (New usage is discouraged.) $)
    lecmtN $p |- ( ( K e. OML /\ X e. B /\ Y e. B )
     -> ( X .<_ Y -> X C Y ) ) $=
      ( coml wcel w3a wbr coc cfv cjn co 3ad2ant1 eqid syl3anc cmee clat omllat
      simp2 cops omlop opoccl syl2anc simp3 latjcl latmle1 wa wi lattr syl13anc
      latmcl mpand cmtbr4N sylibrd ) CJKZEAKZFAKZLZEFDMZEECNOZOZFCPOZQZCUAOZQZF
      DMZEFBMVCVJEDMZVDVKVCCUBKZVAVHAKZVLUTVAVMVBCUCRZUTVAVBUDZVCVMVFAKZVBVNVOV
      CCUEKZVAVQUTVAVRVBCUFRVPACVEEGVESZUGUHUTVAVBUIZAVGCVFFGVGSZUJTZACDVIEVHGH
      VISZUKTVCVMVJAKZVAVBVLVDULVKUMVOVCVMVAVNWDVOVPWBACVIEVHGWCUPTVPVTACDVJEFG
      HUNUOUQABVGCDVIVEEFGHWAWCVSIURUS $.
  $}

  ${
    cmtid.b $e |- B = ( Base ` K ) $.
    cmtid.c $e |- C = ( cm ` K ) $.
    $( Any element commutes with itself.  ( ~ cmidi analog.)  (Contributed by
       NM, 6-Dec-2013.)  (New usage is discouraged.) $)
    cmtidN $p |- ( ( K e. OML /\ X e. B ) -> X C X ) $=
      ( coml wcel wa cple cfv wbr clat omllat eqid latref sylan lecmtN 3anidm23
      wi mpd ) CGHZDAHZIDDCJKZLZDDBLZUBCMHUCUECNACUDDEUDOZPQUBUCUEUFTABCUDDDEUG
      FRSUA $.
  $}

  ${
    omlfh1.b $e |- B = ( Base ` K ) $.
    omlfh1.j $e |- .\/ = ( join ` K ) $.
    omlfh1.m $e |- ./\ = ( meet ` K ) $.
    omlfh1.c $e |- C = ( cm ` K ) $.
    $( Foulis-Holland Theorem, part 1.  If any 2 pairs in a triple of
       orthomodular lattice elements commute, the triple is distributive.  Part
       of Theorem 5 in [Kalmbach] p. 25.  ( ~ fh1 analog.)  (Contributed by NM,
       8-Nov-2011.)  (New usage is discouraged.) $)
    omlfh1N $p |- ( ( K e. OML /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
     ( X C Y /\ X C Z ) )
   -> ( X ./\ ( Y .\/ Z ) ) = ( ( X ./\ Y ) .\/ ( X ./\ Z ) ) ) $=
      ( wcel wbr co cfv wceq 3adant3 syl3anc latmcl coml w3a wa cple coc omllat
      cp0 clat eqid latledi sylan adantr simpr1 simpr2 simpr3 latmcom col omlol
      latjcl oldmj1 oldmm1 oveq12d eqtrd cops omlop syl2anc latmassOLD syl13anc
      opoccl cmt2N 3adant3r3 simpl cmtbr3N bitrd biimpa adantrr 3impa 3adant3r2
      wb adantrl latmmdiN 3eqtr4d oveq2d latm12 3eqtrd opnoncon eqtr3d olm01 wi
      omllaw3 mp2and eqcomd ) DUAMZFAMZGAMZHAMZUBZFGBNZFHBNZUCZUBZFGEOZFHEOZCOZ
      FGHCOZEOZXAXDXFDUDPZNZXFXDDUEPZPZEOZDUGPZQZXDXFQZWMWQXHWTWMDUHMZWQXHDUFZA
      CDXGEFGHIXGUIZJKUJUKRXAXKXEFEOZFXIPZGXIPZCOZXSHXIPZCOZEOZEOZFXEXTYBEOZEOZ
      EOZXLWMWQXKYEQWTWMWQUCZXFXRXJYDEYIXOWNXEAMZXFXRQWMXOWQXPULZWMWNWOWPUMZYIX
      OWOWPYJYKWMWNWOWPUNZWMWNWOWPUOZACDGHIJUSSZADEFXEIKUPSYIXJXBXIPZXCXIPZEOZY
      DYIDUQMZXBAMZXCAMZXJYRQWMYSWQDURULZYIXOWNWOYTYKYLYMADEFGIKTSZYIXOWNWPUUAY
      KYLYNADEFHIKTSZACDEXIXBXCIJKXIUIZUTSYIYPYAYQYCEYIYSWNWOYPYAQUUBYLYMACDEXI
      FGIJKUUEVASYIYSWNWPYQYCQUUBYLYNACDEXIFHIJKUUEVASVBVCVBRXAYEXEFYDEOZEOZXEF
      YFEOZEOZYHWMWQYEUUGQZWTYIYSYJWNYDAMZUUJUUBYOYLYIXOYAAMZYCAMZUUKYKYIXOXSAM
      ZXTAMZUULYKYIDVDMZWNUUNWMUUPWQDVEULZYLADXIFIUUEVIVFZYIUUPWOUUOUUQYMADXIGI
      UUEVIVFZACDXSXTIJUSSZYIXOUUNYBAMZUUMYKUURYIUUPWPUVAUUQYNADXIHIUUEVIVFZACD
      XSYBIJUSSZADEYAYCIKTSADEXEFYDIKVGVHRXAUUFUUHXEEXAFYAEOZFYCEOZEOZFXTEOZFYB
      EOZEOZUUFUUHXAUVDUVGUVEUVHEWMWQWTUVDUVGQZYIWRUVJWSYIWRUVJYIWRFXTBNZUVJWMW
      NWOWRUVKVSWPABDXIFGIUUELVJVKYIWMWNUUOUVKUVJVSWMWQVLZYLUUSABCDEXIFXTIJKUUE
      LVMSVNVOVPVQWMWQWTUVEUVHQZYIWSUVMWRYIWSUVMYIWSFYBBNZUVMWMWNWPWSUVNVSWOABD
      XIFHIUUELVJVRYIWMWNUVAUVNUVMVSUVLYLUVBABCDEXIFYBIJKUUELVMSVNVOVTVQVBWMWQU
      UFUVFQZWTYIYSWNUULUUMUVOUUBYLUUTUVCADEFYAYCIKWAVHRWMWQUUHUVIQZWTYIYSWNUUO
      UVAUVPUUBYLUUSUVBADEFXTYBIKWAVHRWBWCWMWQUUIYHQZWTYIYSYJWNYFAMZUVQUUBYOYLY
      IXOUUOUVAUVRYKUUSUVBADEXTYBIKTSADEXEFYFIKWDVHRWEWMWQYHXLQWTYIYHFXLEOZXLYI
      YGXLFEYIXEXEXIPZEOZYGXLYIUVTYFXEEYIYSWOWPUVTYFQUUBYMYNACDEXIGHIJKUUEUTSWC
      YIUUPYJUWAXLQUUQYOADEXIXEXLIUUEKXLUIZWFVFWGWCYIYSWNUVSXLQUUBYLADEFXLIKUWB
      WHVFVCRWEWMWQXHXMUCXNWIZWTYIWMXDAMZXFAMZUWCUVLYIXOYTUUAUWDYKUUCUUDACDXBXC
      IJUSSYIXOWNYJUWEYKYLYOADEFXEIKTSADXGEXIXDXFXLIXQKUUEUWBWJSRWKWL $.

    $( Foulis-Holland Theorem, part 3.  Dual of ~ omlfh1N .  (Contributed by
       NM, 8-Nov-2011.)  (New usage is discouraged.) $)
    omlfh3N $p |- ( ( K e. OML /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
     ( X C Y /\ X C Z ) )
         -> ( X .\/ ( Y ./\ Z ) ) = ( ( X .\/ Y ) ./\ ( X .\/ Z ) ) ) $=
      ( wcel w3a wbr wa cfv co wceq syl3anc coml eqid cmt4N 3adant3r3 3adant3r2
      wb anbi12d wi simpl cops omlop adantr simpr1 opoccl syl2anc simpr2 simpr3
      coc 3jca omlfh1N fveq2d 3exp sylbid 3impia col omlol omllat latjcl oldmm2
      sylc oldmj4 oveq2d eqtr2d 3adant3 latmcl oldmj1 oldmm4 oveq12d 3eqtr4d
      clat ) DUAMZFAMZGAMZHAMZNZFGBOZFHBOZPZNFDURQZQZGWIQZHWIQZCRZERZWIQZWJWKER
      ZWJWLERZCRZWIQZFGHERZCRZFGCRZFHCRZERZWAWEWHWOWSSZWAWEPZWHWJWKBOZWJWLBOZPZ
      XEXFWFXGWGXHWAWBWCWFXGUFWDABDWIFGIWIUBZLUCUDWAWBWDWGXHUFWCABDWIFHIXJLUCUE
      UGXFWAWJAMZWKAMZWLAMZNZXIXEUHWAWEUIXFXKXLXMXFDUJMZWBXKWAXOWEDUKULZWAWBWCW
      DUMZADWIFIXJUNUOZXFXOWCXLXPWAWBWCWDUPZADWIGIXJUNUOZXFXOWDXMXPWAWBWCWDUQZA
      DWIHIXJUNUOZUSWAXNXIXEWAXNXINWNWRWIABCDEWJWKWLIJKLUTVAVBVJVCVDWAWEXAWOSWH
      XFWOFWMWIQZCRZXAXFDVEMZWBWMAMZWOYDSWAYEWEDVFULZXQXFDVTMZXLXMYFWAYHWEDVGUL
      ZXTYBACDWKWLIJVHTACDEWIFWMIJKXJVITXFYCWTFCXFYEWCWDYCWTSYGXSYAACDEWIGHIJKX
      JVKTVLVMVNWAWEXDWSSWHXFWSWPWIQZWQWIQZERZXDXFYEWPAMZWQAMZWSYLSYGXFYHXKXLYM
      YIXRXTADEWJWKIKVOTXFYHXKXMYNYIXRYBADEWJWLIKVOTACDEWIWPWQIJKXJVPTXFYJXBYKX
      CEXFYEWBWCYJXBSYGXQXSACDEWIFGIJKXJVQTXFYEWBWDYKXCSYGXQYAACDEWIFHIJKXJVQTV
      RVMVNVS $.
  $}

  ${
    omlmod.b $e |- B = ( Base ` K ) $.
    omlmod.l $e |- .<_ = ( le ` K ) $.
    omlmod.j $e |- .\/ = ( join ` K ) $.
    omlmod.m $e |- ./\ = ( meet ` K ) $.
    omlmod.c $e |- C = ( cm ` K ) $.
    $( Analog of modular law ~ atmod1i2 that holds in any OML. (Contributed by
       NM, 6-Dec-2013.)  (New usage is discouraged.) $)
    omlmod1i2N $p |- ( ( K e. OML /\ ( X e. B /\ Y e. B /\ Z e. B )
           /\ ( X .<_ Z /\ Y C Z ) )
        -> ( X .\/ ( Y ./\ Z ) ) = ( ( X .\/ Y ) ./\ Z ) ) $=
      ( wcel wbr co wceq syl3anc wb w3a wa simp1 simp23 simp21 simp22 simp3l wi
      coml lecmtN mpd cmtcomN mpbid simp3r omlfh1N syl132anc clat omllat latjcl
      3ad2ant1 latmcom latleeqm2 oveq12d 3eqtr3rd ) DUIOZGAOZHAOZIAOZUAZGIEPZHI
      BPZUBZUAZIGHCQZFQZIGFQZIHFQZCQZVNIFQZGHIFQZCQVMVEVHVFVGIGBPZIHBPZVOVRRVEV
      IVLUCZVEVFVGVHVLUDZVEVFVGVHVLUEZVEVFVGVHVLUFZVMGIBPZWAVMVJWGVEVIVJVKUGZVM
      VEVFVHVJWGUHWCWEWDABDEGIJKNUJSUKVMVEVFVHWGWATWCWEWDABDGIJNULSUMVMVKWBVEVI
      VJVKUNVMVEVGVHVKWBTWCWFWDABDHIJNULSUMABCDFIGHJLMNUOUPVMDUQOZVHVNAOZVOVSRV
      EVIWIVLDURUTZWDVMWIVFVGWJWKWEWFACDGHJLUSSADFIVNJMVASVMVPGVQVTCVMVJVPGRZWH
      VMWIVFVHVJWLTWKWEWDADEFGIJKMVBSUMVMWIVHVGVQVTRWKWDWFADFIHJMVASVCVD $.
  $}

  ${
    omlspj.b $e |- B = ( Base ` K ) $.
    omlspj.l $e |- .<_ = ( le ` K ) $.
    omlspj.j $e |- .\/ = ( join ` K ) $.
    omlspj.m $e |- ./\ = ( meet ` K ) $.
    omlspj.o $e |- ._|_ = ( oc ` K ) $.
    $( Contraction of a Sasaki projection.  (Contributed by NM, 6-Dec-2013.)
       (New usage is discouraged.) $)
    omlspjN $p |- ( ( K e. OML /\ ( X e. B /\ Y e. B ) /\ X .<_ Y )
        -> ( ( X .\/ ( ._|_ ` Y ) ) ./\ Y ) = X ) $=
      ( wcel wbr cfv co wceq 3ad2ant1 syl2anc coml wa w3a cp0 clat omllat omlop
      cops simp2r opoccl latmcom syl3anc eqid opnoncon eqtrd oveq2d ccmtN simp1
      simp2l simp3 cmtidN wb cmt3N mpbid omlmod1i2N syl132anc col omlol 3eqtr3d
      olj01 ) CUANZGANZHANZUBZGHDOZUCZGHFPZHEQZBQZGCUDPZBQZGVQBQHEQZGVPVRVTGBVP
      VRHVQEQZVTVPCUENZVQANZVMVRWCRVKVNWDVOCUFSVPCUHNZVMWEVKVNWFVOCUGSZVKVLVMVO
      UIZACFHIMUJTZWHACEVQHILUKULVPWFVMWCVTRWGWHACEFHVTIMLVTUMZUNTUOUPVPVKVLWEV
      MVOVQHCUQPZOZVSWBRVKVNVOURZVKVLVMVOUSZWIWHVKVNVOUTVPHHWKOZWLVPVKVMWOWMWHA
      WKCHIWKUMZVATVPVKVMVMWOWLVBWMWHWHAWKCFHHIMWPVCULVDAWKBCDEGVQHIJKLWPVEVFVP
      CVGNZVLWAGRVKVNWQVOCVHSWNABCGVTIKWJVJTVI $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Atomic lattices with covering property
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c <o $.
  $c Atoms $.
  $c AtLat $.
  $(
  $c AtsLat $.
  $)
  $c CvLat $.

  $( Extend class notation with covers relation. $)
  ccvr $a class <o $.

  $( Extend class notation with atoms. $)
  catm $a class Atoms $.

  $( Extend class notation with atomic lattices. $)
  cal $a class AtLat $.

  $( Extend class notation with atomistic lattices. $)
  $(
  cas $a class AtsLat $.
  $)

  $( Extend class notation with lattices with the covering property. $)
  clc $a class CvLat $.

  ${
    $d p z a b $.
    $( Define the covers relation ("is covered by") for posets.  " ` a ` is
       covered by ` b ` " means that ` a ` is strictly less than ` b ` and
       there is nothing in between.  See ~ cvrval for the relation form.
       (Contributed by NM, 18-Sep-2011.) $)
    df-covers $a |- <o = ( p e. _V |-> { <. a , b >. | ( ( a e. ( Base ` p )
               /\ b e. ( Base ` p ) )
           /\ a ( lt ` p ) b /\ -. E. z e. ( Base ` p )
              ( a ( lt ` p ) z /\ z ( lt ` p ) b ) ) } ) $.

    $( Define the class of poset atoms.  (Contributed by NM, 18-Sep-2011.) $)
    df-ats $a |- Atoms = ( p e. _V |-> { a e. ( Base ` p ) |
                      ( 0. ` p ) ( <o ` p ) a } ) $.
  $}

  ${
    $d p x y z B $.  $d p x y z K $.  $d p .< $.
    cvrfval.b $e |- B = ( Base ` K ) $.
    cvrfval.s $e |- .< = ( lt ` K ) $.
    cvrfval.c $e |- C = ( <o ` K ) $.
    $( Value of covers relation "is covered by".  (Contributed by NM,
       18-Sep-2011.) $)
    cvrfval $p |- ( K e. A -> C = { <. x , y >. | ( ( x e. B /\ y e. B )
                  /\ x .< y /\ -. E. z e. B ( x .< z /\ z .< y ) ) } ) $=
      ( vp wcel cvv cv wa wbr copab cfv cbs wrex wn wceq elex ccvr cplt syl6eqr
      w3a fveq2 eleq2d anbi12d breqd rexeqbidv notbid 3anbi123d opabbidv 3anass
      df-covers opabbii cxp fvex eqeltri xpex opabssxp ssexi fvmpt syl5eq syl )
      HDMHNMZFAOZEMZBOZEMZPZVJVLGQZVJCOZGQZVPVLGQZPZCEUAZUBZUHZABRZUCHDUDVIFHUE
      SWCKLHVJLOZTSZMZVLWEMZPZVJVLWDUFSZQZVJVPWIQZVPVLWIQZPZCWEUAZUBZUHZABRWCNU
      EWDHUCZWPWBABWQWHVNWJVOWOWAWQWFVKWGVMWQWEEVJWQWEHTSZEWDHTUIIUGZUJWQWEEVLW
      SUJUKWQWIGVJVLWQWIHUFSGWDHUFUIJUGZULWQWNVTWQWMVSCWEEWSWQWKVQWLVRWQWIGVJVP
      WTULWQWIGVPVLWTULUKUMUNUOUPCLABURWCVNVOWAPZPZABRZNWBXBABVNVOWAUQUSXCEEUTE
      EEWRNIHTVAVBZXDVCXAABEEVDVEVBVFVGVH $.

    $d x y .< $.  $d x y z X $.  $d x y z Y $.
    $( Binary relation expressing ` B ` covers ` A ` , which means that ` B `
       is larger than ` A ` and there is nothing in between.  Definition 3.2.18
       of [PtakPulmannova] p. 68.  ( ~ cvbr analog.)  (Contributed by NM,
       18-Sep-2011.) $)
    cvrval $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X C Y <->
               ( X .< Y /\ -. E. z e. B ( X .< z /\ z .< Y ) ) ) ) $=
      ( vx vy wcel w3a wbr cv wa wrex wn copab wb cvrfval 3anass opabbii syl6eq
      breqd 3ad2ant1 cop df-br breq1 anbi1d rexbidv notbid anbi12d breq2 anbi2d
      wceq opelopab2 syl5bb 3adant1 bitrd ) FBNZGCNZHCNZOGHDPZGHLQZCNMQZCNRZVGV
      HEPZVGAQZEPZVKVHEPZRZACSZTZRZRZLMUAZPZGHEPZGVKEPZVKHEPZRZACSZTZRZVCVDVFVT
      UBVEVCDVSGHVCDVIVJVPOZLMUAVSLMABCDEFIJKUCWHVRLMVIVJVPUDUEUFUGUHVDVEVTWGUB
      VCVTGHUIVSNVDVERWGGHVSUJVQGVHEPZWBVMRZACSZTZRWGLMGHCCVGGURZVJWIVPWLVGGVHE
      UKWMVOWKWMVNWJACWMVLWBVMVGGVKEUKULUMUNUOVHHURZWIWAWLWFVHHGEUPWNWKWEWNWJWD
      ACWNVMWCWBVHHVKEUPUQUMUNUOUSUTVAVB $.

    $( The covers relation implies the less-than relation.  ( ~ cvpss analog.)
       (Contributed by NM, 8-Oct-2011.) $)
    cvrlt $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ X C Y ) -> X .< Y ) $=
      ( vz wcel w3a wbr cv wa wrex wn cvrval simprbda ) EALFBLGBLMFGCNFGDNFKOZD
      NUAGDNPKBQRKABCDEFGHIJST $.

    $d z .< $.  $d z Z $.
    $( There is no element between the two arguments of the covers relation.
       ( ~ cvnbtwn analog.)  (Contributed by NM, 18-Oct-2011.) $)
    cvrnbtwn $p |- ( ( K e. A /\ ( X e. B /\ Y e. B /\ Z e. B ) /\ X C Y )
             -> -. ( X .< Z /\ Z .< Y ) ) $=
      ( vz wcel w3a wbr wa wn cv wrex wb cvrval 3adant3r3 wi ralnex breq2 breq1
      wral anbi12d notbid rspcv syl5bir adantld 3ad2ant3 adantl sylbid 3impia
      wceq ) EAMZFBMZGBMZHBMZNZFGCOZFHDOZHGDOZPZQZURVBPVCFGDOZFLRZDOZVIGDOZPZLB
      SQZPZVGURUSUTVCVNTVALABCDEFGIJKUAUBVBVNVGUCZURVAUSVOUTVAVMVGVHVMVLQZLBUGV
      AVGVLLBUDVPVGLHBVIHUQZVLVFVQVJVDVKVEVIHFDUEVIHGDUFUHUIUJUKULUMUNUOUP $.
  $}

  ${
    ncvr1.b $e |- B = ( Base ` K ) $.
    ncvr1.u $e |- .1. = ( 1. ` K ) $.
    ncvr1.c $e |- C = ( <o ` K ) $.
    $( No element covers the lattice unit.  (Contributed by NM, 8-Jul-2013.) $)
    ncvr1 $p |- ( ( K e. OP /\ X e. B ) -> -. .1. C X ) $=
      ( cops wcel wa wbr cplt cfv cple eqid ad2antrr simplr simpr syl31anc mt2d
      ople1 wn cpo opposet op1cl pltnle ex simpll cvrlt mtand ) DIJZEAJZKZCEBLZ
      CEDMNZLZUNUQECDONZLZACDUREFURPZGUBUNUQUSUCZUNUQKDUDJZCAJZUMUQVAULVBUMUQDU
      EQULVCUMUQACDFGUFZQULUMUQRUNUQSAUPDURCEFUTUPPZUGTUHUAUNUOKULVCUMUOUQULUMU
      OUIULVCUMUOVDQULUMUORUNUOSIABUPDCEFVEHUJTUK $.
  $}

  ${
    cvrletr.b $e |- B = ( Base ` K ) $.
    cvrletr.l $e |- .<_ = ( le ` K ) $.
    cvrletr.s $e |- .< = ( lt ` K ) $.
    cvrletr.c $e |- C = ( <o ` K ) $.
    $( Property of an element above a covering.  (Contributed by NM,
       7-Dec-2012.)  (New usage is discouraged.) $)
    cvrletrN $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) )
               -> ( ( X C Y /\ Y .<_ Z ) -> X .< Z ) ) $=
      ( cpo wcel w3a wa wbr simpll simplr1 simplr2 simpr cvrlt syl31anc pltletr
      wi adantr mpand expimpd ) DMNZFANZGANZHANZOZPZFGBQZGHEQZFHCQZUNUOPZFGCQZU
      PUQURUIUJUKUOUSUIUMUORUJUKULUIUOSUJUKULUIUOTUNUOUAMABCDFGIKLUBUCUNUSUPPUQ
      UEUOACDEFGHIJKUDUFUGUH $.

    $d z A $.  $d z B $.  $d z K $.  $d z X $.  $d z Y $.
    $( Binary relation expressing ` Y ` covers ` X ` .  Definition of covers in
       [Kalmbach] p. 15.  ( ~ cvbr2 analog.)  (Contributed by NM,
       16-Nov-2011.) $)
    cvrval2 $p |- ( ( K e. A /\ X e. B /\ Y e. B ) -> ( X C Y <->
              ( X .< Y /\ A. z e. B ( ( X .< z /\ z .<_ Y ) -> z = Y ) ) ) ) $=
      ( wcel wbr wa wn wral wb anbi2d w3a cv wrex wceq wi cvrval wne iman df-ne
      anbi2i xchbinxr pltval 3com23 3expa anass syl6rbbr notbid syl5bb ralbidva
      ralnex syl6bb 3adant2 bitr4d ) FBNZHCNZICNZUAHIDOHIEOZHAUBZEOZVHIEOZPZACU
      CQZPZVGVIVHIGOZPZVHIUDZUEZACRZPZABCDEFHIJLMUFVDVFVSVMSVEVDVFPZVRVLVGVTVRV
      KQZACRVLVTVQWAACVQVOVHIUGZPZQVTVHCNZPZWAVQVOVPQZPWCVOVPUHWBWFVOVHIUIUJUKW
      EWCVKWEVKVIVNWBPZPWCWEVJWGVIVDVFWDVJWGSZVDWDVFWHBCCEFGVHIKLULUMUNTVIVNWBU
      OUPUQURUSVKACUTVATVBVC $.

    $( The covers relation implies no in-betweenness.  ( ~ cvnbtwn2 analog.)
       (Contributed by NM, 17-Nov-2011.) $)
    cvrnbtwn2 $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B )
                        /\ X C Y )
             -> ( ( X .< Z /\ Z .<_ Y ) <-> Z = Y ) ) $=
      ( cpo wcel w3a wbr wa wi wn 3impia wceq cvrnbtwn 3expia iman wne wb simpl
      simpr3 simpr2 pltval syl3anc anbi2i syl6bb anbi2d syl6rbbr notbid syl5rbb
      df-ne anass sylibd cvrlt ex 3adant3r3 syl5ibrcom posref 3ad2antr2 3adant3
      breq2 breq1 jcad impbid ) DMNZFANZGANZHANZOZFGBPZOZFHCPZHGEPZQZHGUAZVLVPV
      QWAWBRZVLVPQZVQVSHGCPZQZSZWCVLVPVQWGMABCDFGHIKLUBUCWCWAWBSZQZSWDWGWAWBUDW
      DWIWFWDWFVSVTWHQZQWIWDWEWJVSWDWEVTHGUEZQZWJWDVLVOVNWEWLUFVLVPUGVLVMVNVOUH
      VLVMVNVOUIMAACDEHGJKUJUKWKWHVTHGURULUMUNVSVTWHUSUOUPUQUTTVRWBVSVTVRVSWBFG
      CPZVLVPVQWMVLVMVNVQWMRVOVLVMVNOVQWMMABCDFGIKLVAVBVCTHGFCVHVDVLVPWBVTRVQWD
      VTWBGGEPZVLVMVNWNVOADEGIJVEVFHGGEVIVDVGVJVK $.

    $( The covers relation implies no in-betweenness.  ( ~ cvnbtwn3 analog.)
       (Contributed by NM, 4-Nov-2011.) $)
    cvrnbtwn3 $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B )
                        /\ X C Y )
             -> ( ( X .<_ Z /\ Z .< Y ) <-> X = Z ) ) $=
      ( cpo wcel w3a wbr wa wn wi 3adant3 wceq cvrnbtwn wne wb pltval 3adant3r2
      anbi1d notbid an32 df-ne anbi2i bitri notbii iman bitr4i syl6bb syl5ibcom
      mpbid posref breq2 3ad2antr1 simp1 simp21 simp3 cvrlt syl31anc breq1 jcad
      simp22 impbid ) DMNZFANZGANZHANZOZFGBPZOZFHEPZHGCPZQZFHUAZVQFHCPZVSQZRZVT
      WASZMABCDFGHIKLUBVQWDVRFHUCZQZVSQZRZWEVQWCWHVQWBWGVSVKVOWBWGUDZVPVKVLVNWJ
      VMMAACDEFHJKUEUFTUGUHWIVTWARZQZRWEWHWLWHVTWFQWLVRWFVSUIWFWKVTFHUJUKULUMVT
      WAUNUOUPURVQWAVRVSVKVOWAVRSZVPVKVMVLWMVNVKVLQFFEPWAVRADEFIJUSFHFEUTUQVATV
      QFGCPZWAVSVQVKVLVMVPWNVKVOVPVBVKVLVMVNVPVCVKVLVMVNVPVIVKVOVPVDMABCDFGIKLV
      EVFFHGCVGUQVHVJ $.
  $}

  ${
    $d x y B $.  $d x y ._|_ $.  $d x y K $.  $d x y X $.  $d x y Y $.
    cvrcon3b.b $e |- B = ( Base ` K ) $.
    cvrcon3b.o $e |- ._|_ = ( oc ` K ) $.
    cvrcon3b.c $e |- C = ( <o ` K ) $.
    $( Contraposition law for the covers relation.  ( ~ cvcon3 analog.)
       (Contributed by NM, 4-Nov-2011.) $)
    cvrcon3b $p |- ( ( K e. OP /\ X e. B /\ Y e. B )
                        -> ( X C Y <-> ( ._|_ ` Y ) C ( ._|_ ` X ) ) ) $=
      ( vx vy cops wcel cfv wbr wa wb syl3anc anbi12d opoccl w3a cplt wrex eqid
      cv wn opltcon3b simpl1 simpl2 simpr simpl3 wi 3ad2antl1 wceq breq2 rspcev
      breq1 ex ancomsd sylbid rexlimdva opltcon1b opltcon2b impbid notbid simp1
      syl cvrval 3adant2 3adant3 3bitr4d ) CLMZEAMZFAMZUAZEFCUBNZOZEJUEZVPOZVRF
      VPOZPZJAUCZUFZPFDNZEDNZVPOZWDKUEZVPOZWGWEVPOZPZKAUCZUFZPZEFBOWDWEBOZVOVQW
      FWCWLAVPCDEFGVPUDZHUGVOWBWKVOWBWKVOWAWKJAVOVRAMZPZWAVRDNZWEVPOZWDWRVPOZPW
      KWQVSWSVTWTWQVLVMWPVSWSQVLVMVNWPUHZVLVMVNWPUIVOWPUJZAVPCDEVRGWOHUGRWQVLWP
      VNVTWTQXAXBVLVMVNWPUKAVPCDVRFGWOHUGRSWQWTWSWKWQWRAMZWTWSPZWKULVLVMWPXCVNA
      CDVRGHTUMXCXDWKWJXDKWRAWGWRUNWHWTWIWSWGWRWDVPUOWGWRWEVPUQSUPURVGUSUTVAVOW
      JWBKAVOWGAMZPZWJWGDNZFVPOZEXGVPOZPWBXFWHXHWIXIXFVLVNXEWHXHQVLVMVNXEUHZVLV
      MVNXEUKVOXEUJZAVPCDFWGGWOHVBRXFVLXEVMWIXIQXJXKVLVMVNXEUIAVPCDWGEGWOHVCRSX
      FXIXHWBXFXGAMZXIXHPZWBULVLVMXEXLVNACDWGGHTUMXLXMWBWAXMJXGAVRXGUNVSXIVTXHV
      RXGEVPUOVRXGFVPUQSUPURVGUSUTVAVDVESJLABVPCEFGWOIVHVOVLWDAMZWEAMZWNWMQVLVM
      VNVFVLVNXNVMACDFGHTVIVLVMXOVNACDEGHTVJKLABVPCWDWEGWOIVHRVK $.
  $}

  ${
    cvrle.b $e |- B = ( Base ` K ) $.
    cvrle.l $e |- .<_ = ( le ` K ) $.
    cvrle.c $e |- C = ( <o ` K ) $.
    $( The covers relation implies the less-than-or-equal relation.
       (Contributed by NM, 12-Oct-2011.) $)
    cvrle $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ X C Y ) -> X .<_ Y ) $=
      ( wcel w3a wbr cplt cfv eqid cvrlt wne pltval simprbda syldan ) DAKFBKGBK
      LZFGCMFGDNOZMZFGEMZABCUCDFGHUCPZJQUBUDUEFGRABBUCDEFGIUFSTUA $.

    $( The covers relation implies no in-betweenness.  Part of proof of Lemma
       7.5.1 of [MaedaMaeda] p. 31.  ( ~ cvnbtwn4 analog.)  (Contributed by NM,
       18-Oct-2011.) $)
    cvrnbtwn4 $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B )
                        /\ X C Y )
             -> ( ( X .<_ Z /\ Z .<_ Y ) <-> ( X = Z \/ Z = Y ) ) ) $=
      ( cpo wcel w3a wbr wa wceq wn wi wb wne wo cplt eqid cvrnbtwn iman pltval
      cfv 3adant3r2 3com23 3adant3r1 anbi12d neanior anbi2i an4 bitr3i syl6rbbr
      notbid syl5rbb mpbid posref 3ad2antr3 breq1 syl5ibrcom cvrle ex 3adant3r3
      3adant3 3impia breq2 jaod syl5ibcom jcad impbid ) CKLZEALZFALZGALZMZEFBNZ
      MZEGDNZGFDNZOZEGPZGFPZUAZVTEGCUBUGZNZGFWGNZOZQZWCWFRZKABWGCEFGHWGUCZJUDVN
      VRWKWLSVSWLWCWFQZOZQVNVROZWKWCWFUEWPWOWJWPWJWAEGTZOZWBGFTZOZOZWOWPWHWRWIW
      TVNVOVQWHWRSVPKAAWGCDEGIWMUFUHVNVPVQWIWTSZVOVNVQVPXBKAAWGCDGFIWMUFUIUJUKW
      OWCWQWSOZOXAXCWNWCEGGFULUMWAWBWQWSUNUOUPUQURVGUSVTWFWAWBVTWDWAWEVTWAWDGGD
      NZVNVRXDVSVNVOVQXDVPACDGHIUTVAVGZEGGDVBVCVTWAWEEFDNZVNVRVSXFVNVOVPVSXFRVQ
      VNVOVPMVSXFKABCDEFHIJVDVEVFVHZGFEDVIVCVJVTWDWBWEVTXFWDWBXGEGFDVBVKVTXDWEW
      BXEGFGDVIVKVJVLVM $.

    $( The covers relation implies the negation of the reverse
       less-than-or-equal relation.  (Contributed by NM, 18-Oct-2011.) $)
    cvrnle $p |- ( ( ( K e. Poset /\ X e. B /\ Y e. B ) /\ X C Y )
                     -> -. Y .<_ X ) $=
      ( cpo wcel w3a wbr cplt cfv wn eqid cvrlt pltnle syldan ) CJKEAKFAKLEFBME
      FCNOZMFEDMPJABUACEFGUAQZIRAUACDEFGHUBST $.
  $}

  ${
    cvrne.b $e |- B = ( Base ` K ) $.
    cvrne.c $e |- C = ( <o ` K ) $.
    $( The covers relation implies inequality.  (Contributed by NM,
       13-Oct-2011.) $)
    cvrne $p |- ( ( ( K e. A /\ X e. B /\ Y e. B ) /\ X C Y ) -> X =/= Y ) $=
      ( wcel w3a wbr cplt cfv wne eqid cvrlt cple pltval simplbda syldan ) DAIE
      BIFBIJZEFCKEFDLMZKZEFNZABCUBDEFGUBOZHPUAUCEFDQMZKUDABBUBDUFEFUFOUERST $.

    $( The covers relation is not reflexive.  ( ~ cvnref analog.)  (Contributed
       by NM, 1-Nov-2012.)  (New usage is discouraged.) $)
    cvrnrefN $p |- ( ( K e. A /\ X e. B ) -> -. X C X ) $=
      ( wcel wa wceq wbr wn eqid wne simpll simplr simpr cvrne syl31anc ex mpi
      necon2bd ) DAHZEBHZIZEEJEECKZLEMUEUFEEUEUFEENZUEUFIUCUDUDUFUGUCUDUFOUCUDU
      FPZUHUEUFQABCDEEFGRSTUBUA $.
  $}

  ${
    cvrcmp.b $e |- B = ( Base ` K ) $.
    cvrcmp.l $e |- .<_ = ( le ` K ) $.
    cvrcmp.c $e |- C = ( <o ` K ) $.
    $( If two lattice elements that cover a third are comparable, then they are
       equal.  (Contributed by NM, 6-Feb-2012.) $)
    cvrcmp $p |- ( ( K e. Poset /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
          ( Z C X /\ Z C Y ) ) -> ( X .<_ Y <-> X = Y ) ) $=
      ( cpo wcel w3a wbr wa wceq wne simpl1 simpl23 syl31anc simpl21 simpl3l wo
      cvrne wi cvrle simpr wb simpl22 simpl3r cvrnbtwn4 syl131anc mpbi2and neor
      sylib mpd ex simp1 simp21 posref syl2anc breq2 syl5ibcom impbid ) CKLZEAL
      ZFALZGALZMZGEBNZGFBNZOZMZEFDNZEFPZVMVNVOVMVNOZGEQZVOVPVEVHVFVJVQVEVIVLVNR
      ZVFVGVHVEVLVNSZVFVGVHVEVLVNUAZVJVKVEVIVNUBZKABCGEHJUDTVPGEPVOUCZVQVOUEVPG
      EDNZVNWBVPVEVHVFVJWCVRVSVTWAKABCDGEHIJUFTVMVNUGVPVEVHVGVFVKWCVNOWBUHVRVSV
      FVGVHVEVLVNUIVTVJVKVEVIVNUJABCDGFEHIJUKULUMVOGEUNUOUPUQVMEEDNZVOVNVMVEVFW
      DVEVIVLURVEVFVGVHVLUSACDEHIUTVAEFEDVBVCVD $.

    $( If two lattice elements covered by a third are comparable, then they are
       equal.  (Contributed by NM, 20-Jun-2012.) $)
    cvrcmp2 $p |- ( ( K e. OP /\ ( X e. B /\ Y e. B /\ Z e. B ) /\
          ( X C Z /\ Y C Z ) ) -> ( X .<_ Y <-> X = Y ) ) $=
      ( wcel w3a wbr wa cfv wceq wb opoccl syl2anc cvrcon3b cops 3ad2ant1 simp1
      coc opposet simp22 eqid simp21 simp23 3adant3r2 3adant3r1 anbi12d biimp3a
      cpo ancomd cvrcmp syl131anc oplecon3b syl3anc opcon3b 3bitr4d ) CUAKZEAKZ
      FAKZGAKZLZEGBMZFGBMZNZLZFCUDOZOZEVKOZDMZVLVMPZEFDMZEFPZVJCUNKZVLAKZVMAKZG
      VKOZAKZWAVLBMZWAVMBMZNVNVOQVBVFVRVICUEUBVJVBVDVSVBVFVIUCZVBVCVDVEVIUFZACV
      KFHVKUGZRSVJVBVCVTWEVBVCVDVEVIUHZACVKEHWGRSVJVBVEWBWEVBVCVDVEVIUIACVKGHWG
      RSVJWDWCVBVFVIWDWCNVBVFNVGWDVHWCVBVCVEVGWDQVDABCVKEGHWGJTUJVBVDVEVHWCQVCA
      BCVKFGHWGJTUKULUMUOABCDVLVMWAHIJUPUQVJVBVCVDVPVNQWEWHWFACDVKEFHIWGURUSVJV
      BVCVDVQVOQWEWHWFACVKEFHWGUTUSVA $.
  $}

  ${
    $d p x B $.  $d p C $.  $d p x K $.  $d p .0. $.
    patoms.b $e |- B = ( Base ` K ) $.
    patoms.z $e |- .0. = ( 0. ` K ) $.
    patoms.c $e |- C = ( <o ` K ) $.
    patoms.a $e |- A = ( Atoms ` K ) $.
    $( The set of atoms in a poset.  (Contributed by NM, 18-Sep-2011.) $)
    pats $p |- ( K e. D -> A = { x e. B | .0. C x } ) $=
      ( vp cvv wbr cfv cp0 ccvr cbs fveq2 syl6eqr wcel cv crab wceq elex breq1d
      catm breqd bitrd rabeqbidv df-ats fvex eqeltri rabex fvmpt syl5eq syl ) F
      EUAFMUAZBGAUBZDNZACUCZUDFEUEURBFUGOVAKLFLUBZPOZUSVBQOZNZAVBROZUCVAMUGVBFU
      DZVEUTAVFCVGVFFROZCVBFRSHTVGVEVCUSDNUTVGVDDVCUSVGVDFQODVBFQSJTUHVGVCGUSDV
      GVCFPOGVBFPSITUFUIUJLAUKUTACCVHMHFRULUMUNUOUPUQ $.
  $}

  ${
    $d x B $.  $d x C $.  $d x K $.  $d x P $.  $d x .0. $.
    isatom.b $e |- B = ( Base ` K ) $.
    isatom.z $e |- .0. = ( 0. ` K ) $.
    isatom.c $e |- C = ( <o ` K ) $.
    isatom.a $e |- A = ( Atoms ` K ) $.
    $( The predicate "is an atom".  ( ~ ela analog.)  (Contributed by NM,
       18-Sep-2011.) $)
    isat $p |- ( K e. D -> ( P e. A <-> ( P e. B /\ .0. C P ) ) ) $=
      ( vx wcel cv wbr crab wa pats eleq2d breq2 elrab syl6bb ) FDMZEAMEGLNZCOZ
      LBPZMEBMGECOZQUCAUFELABCDFGHIJKRSUEUGLEBUDEGCTUAUB $.

    $( The predicate "is an atom".  ( ~ elatcv0 analog.)  (Contributed by NM,
       18-Jun-2012.) $)
    isat2 $p |- ( ( K e. D /\ P e. B ) -> ( P e. A <-> .0. C P ) ) $=
      ( wcel wbr isat baibd ) FDLEALEBLGECMABCDEFGHIJKNO $.
  $}

  ${
    atomcvr0.z $e |- .0. = ( 0. ` K ) $.
    atomcvr0.c $e |- C = ( <o ` K ) $.
    atomcvr0.a $e |- A = ( Atoms ` K ) $.
    $( An atom covers zero.  ( ~ atcv0 analog.)  (Contributed by NM,
       4-Nov-2011.) $)
    atcvr0 $p |- ( ( K e. D /\ P e. A ) -> .0. C P ) $=
      ( wcel cbs cfv wbr eqid isat simplbda ) ECJDAJDEKLZJFDBMAQBCDEFQNGHIOP $.
  $}

  ${
    atombase.b $e |- B = ( Base ` K ) $.
    atombase.a $e |- A = ( Atoms ` K ) $.
    $( An atom is a member of the lattice base set (i.e. a lattice element).
       ( ~ atelch analog.)  (Contributed by NM, 10-Oct-2011.) $)
    atbase $p |- ( P e. A -> P e. B ) $=
      ( cvv wcel catm cfv c0 wceq n0i eqeq1i sylnib fvprc nsyl2 cp0 ccvr eqid
      wbr isat simprbda mpancom ) DGHZCAHZCBHZUFDIJZKLZUEUFAKLUIACMAUHKFNODIPQU
      EUFUGDRJZCDSJZUAABUKGCDUJEUJTUKTFUBUCUD $.

    $d x A $.  $d x B $.
    $( The set of atoms is a subset of the base set.  ( ~ atssch analog.)
       (Contributed by NM, 21-Oct-2011.) $)
    atssbase $p |- A C_ B $=
      ( vx cv atbase ssriv ) FABABFGCDEHI $.
  $}

  ${
    0ltat.z $e |- .0. = ( 0. ` K ) $.
    0ltat.s $e |- .< = ( lt ` K ) $.
    0ltat.a $e |- A = ( Atoms ` K ) $.
    $( An atom is greater than zero.  (Contributed by NM, 4-Jul-2012.) $)
    0ltat $p |- ( ( K e. OP /\ P e. A ) -> .0. .< P ) $=
      ( cops wcel wa cbs cfv ccvr wbr simpl eqid op0cl adantr atbase syl31anc
      adantl atcvr0 cvrlt ) DIJZBAJZKUEEDLMZJZBUGJZEBDNMZOEBCOUEUFPUEUHUFUGDEUG
      QZFRSUFUIUEAUGBDUKHTUBAUJIBDEFUJQZHUCIUGUJCDEBUKGULUDUA $.
  $}

  ${
    leatom.b $e |- B = ( Base ` K ) $.
    leatom.l $e |- .<_ = ( le ` K ) $.
    leatom.z $e |- .0. = ( 0. ` K ) $.
    leatom.a $e |- A = ( Atoms ` K ) $.
    $( A poset element less than or equal to an atom equals either zero or the
       atom.  ( ~ atss analog.)  (Contributed by NM, 17-Nov-2011.) $)
    leatb $p |- ( ( K e. OP /\ X e. B /\ P e. A )
                      -> ( X .<_ P <-> ( X = P \/ X = .0. ) ) ) $=
      ( cops wcel w3a wbr wceq wo wa op0le syl6bb 3adant3 biantrurd cpo ccvr wb
      cfv opposet 3ad2ant1 op0cl atbase id 3anim123i 3com23 eqid atcvr0 3adant2
      cvrnbtwn4 syl3anc eqcom orbi1i bitrd orcom ) DLMZFBMZCAMZNZFCEOZFGPZFCPZQ
      ZVIVHQVFVGGFEOZVGRZVJVFVKVGVCVDVKVEBDEFGHIJSUAUBVFVLGFPZVIQZVJVFDUCMZGBMZ
      CBMZVDNZGCDUDUFZOZVLVNUEVCVDVOVEDUGUHVCVEVDVRVCVPVEVQVDVDBDGHJUIABCDHKUJV
      DUKULUMVCVEVTVDAVSLCDGJVSUNZKUOUPBVSDEGCFHIWAUQURVMVHVIGFUSUTTVAVHVIVBT
      $.

    $( A poset element less than or equal to an atom equals either zero or the
       atom.  (Contributed by NM, 15-Oct-2013.) $)
    leat $p |- ( ( ( K e. OP /\ X e. B /\ P e. A ) /\ X .<_ P )
                      -> ( X = P \/ X = .0. ) ) $=
      ( cops wcel w3a wbr wceq wo leatb biimpa ) DLMFBMCAMNFCEOFCPFGPQABCDEFGHI
      JKRS $.

    $( A nonzero poset element less than or equal to an atom equals the atom.
       (Contributed by NM, 6-Mar-2013.) $)
    leat2 $p |- ( ( ( K e. OP /\ X e. B /\ P e. A )
             /\ ( X =/= .0. /\ X .<_ P ) ) -> X = P ) $=
      ( cops wcel w3a wne wbr wceq wi wo leatb orcom bitri syl6bb biimpd com23
      neor imp32 ) DLMFBMCAMNZFGOZFCEPZFCQZUHUJUIUKUHUJUIUKRZUHUJUKFGQZSZULABCD
      EFGHIJKTUNUMUKSULUKUMUAUKFGUFUBUCUDUEUG $.

    $( A poset element less than or equal to an atom is either an atom or
       zero.  (Contributed by NM, 2-Dec-2012.) $)
    leat3 $p |- ( ( ( K e. OP /\ X e. B /\ P e. A ) /\ X .<_ P )
                      -> ( X e. A \/ X = .0. ) ) $=
      ( cops wcel w3a wbr wa wceq wo leat wi simpl3 eleq1a syl orim1d mpd ) DLM
      ZFBMZCAMZNFCEOZPZFCQZFGQZRFAMZULRABCDEFGHIJKSUJUKUMULUJUHUKUMTUFUGUHUIUAC
      AFUBUCUDUE $.
  $}

  ${
    m.b $e |- B = ( Base ` K ) $.
    m.m $e |- ./\ = ( meet ` K ) $.
    m.z $e |- .0. = ( 0. ` K ) $.
    m.a $e |- A = ( Atoms ` K ) $.
    $( The meet of any element with an atom is either the atom or zero.
       (Contributed by NM, 28-Aug-2012.) $)
    meetat $p |- ( ( K e. OL /\ X e. B /\ P e. A )
       -> ( ( X ./\ P ) = P \/ ( X ./\ P ) = .0. ) ) $=
      ( col wcel w3a co cple cfv wceq 3ad2ant1 syl3anc wbr wo ollat simp2 simp3
      clat atbase syl eqid latmle2 cops wb olop latmcl leatb mpbid ) DLMZFBMZCA
      MZNZFCEOZCDPQZUAZVACRVAGRUBZUTDUFMZURCBMZVCUQURVEUSDUCSZUQURUSUDZUTUSVFUQ
      URUSUEZABCDHKUGUHZBDVBEFCHVBUIZIUJTUTDUKMZVABMZUSVCVDULUQURVLUSDUMSUTVEUR
      VFVMVGVHVJBDEFCHIUNTVIABCDVBVAGHVKJKUOTUP $.

    $( The meet of any element with an atom is either the atom or zero.
       (Contributed by NM, 30-Aug-2012.) $)
    meetat2 $p |- ( ( K e. OL /\ X e. B /\ P e. A )
       -> ( ( X ./\ P ) e. A \/ ( X ./\ P ) = .0. ) ) $=
      ( col wcel w3a co wceq wo meetat wi eleq1a 3ad2ant3 orim1d mpd ) DLMZFBMZ
      CAMZNZFCEOZCPZUHGPZQUHAMZUJQABCDEFGHIJKRUGUIUKUJUFUDUIUKSUECAUHTUAUBUC $.
  $}

  ${
    $d k p x $.
    $( Define the class of atomic lattices, in which every nonzero element is
       greater than or equal to an atom. .  We also ensure the existence of a
       lattice zero, since a lattice by itself may not have a zero.
       (Contributed by NM, 18-Sep-2011.) $)
    df-atl $a |- AtLat = { k e. Lat | ( ( 0. ` k ) e. ( Base ` k )
      /\ A. x e. ( Base ` k ) ( x =/= ( 0. ` k )
       -> E. p e. ( Atoms ` k ) p ( le ` k ) x ) ) } $.

    $( Define the class of atomistic lattices.  Every non-zero element
       is the join of all atoms less than it.  If an
        orthomodular lattice is atomic, then it is also atomistic
      (Beltrametti_Cassinelli p. 98). $)
    $(
    df-atslat $a |- AtsLat = { l e. Lat | A. a e. ( Base ` l )
         a = ( ( lub ` l ) ` { p e. ( Atoms ` l ) | p ( le ` l ) a } ) } $.
    $)
  $}

  ${
    $d k y A $.  $d k x B $.  $d k x y K $.  $d k .<_ $.  $d k .0. $.
    isatlat.b $e |- B = ( Base ` K ) $.
    isatlat.l $e |- .<_ = ( le ` K ) $.
    isatlat.z $e |- .0. = ( 0. ` K ) $.
    isatlat.a $e |- A = ( Atoms ` K ) $.
    $( The predicate "is an atomic lattice."  Every nonzero element is less
       than or equal to an atom.  (Contributed by NM, 18-Sep-2011.) $)
    isatl $p |- ( K e. AtLat <-> ( K e. Lat /\ .0. e. B
        /\ A. x e. B ( x =/= .0. -> E. y e. A y .<_ x ) ) ) $=
      ( vk wcel cv wa cp0 cfv cbs fveq2 syl6eqr cal clat wne wbr wrex wral cple
      wi w3a catm wceq eleq12d neeq2d breqd rexeqbidv imbi12d raleqbidv anbi12d
      df-atl elrab2 3anass bitr4i ) EUAMEUBMZGDMZANZGUCZBNZVEFUDZBCUEZUHZADUFZO
      ZOVCVDVKUILNZPQZVMRQZMZVEVNUCZVGVEVMUGQZUDZBVMUJQZUEZUHZAVOUFZOVLLEUBUAVM
      EUKZVPVDWCVKWDVNGVODWDVNEPQGVMEPSJTZWDVOERQDVMERSHTZULWDWBVJAVODWFWDVQVFW
      AVIWDVNGVEWEUMWDVSVHBVTCWDVTEUJQCVMEUJSKTWDVRFVGVEWDVREUGQFVMEUGSITUNUOUP
      UQURALBUSUTVCVDVKVAVB $.
  $}

  ${
    $d x p K $.
    $( An atomic lattice is a lattice.  (Contributed by NM, 21-Oct-2011.) $)
    atllat $p |- ( K e. AtLat -> K e. Lat ) $=
      ( vx vp cal wcel clat cp0 cfv cbs cv wne cple wbr catm wrex wi wral isatl
      eqid simp1bi ) ADEAFEAGHZAIHZEBJZUAKCJUCALHZMCANHZOPBUBQBCUEUBAUDUAUBSUDS
      UASUESRT $.
  $}

  ${
    $d x p K $.
    $( An atomic lattice is a poset.  (Contributed by NM, 5-Nov-2012.) $)
    atlpos $p |- ( K e. AtLat -> K e. Poset ) $=
      ( cal wcel clat cpo atllat latpos syl ) ABCADCAECAFAGH $.
  $}

  ${
    $d y A $.  $d x B $.  $d x y K $.
    isatlati.1 $e |- K e. Lat $.
    isatlati.b $e |- B = ( Base ` K ) $.
    isatlati.l $e |- .<_ = ( le ` K ) $.
    isatlati.z $e |- .0. = ( 0. ` K ) $.
    isatlati.a $e |- A = ( Atoms ` K ) $.
    isatlati.6 $e |- .0. e. B $.
    isatlati.7 $e |- ( ( x e. B /\ x =/= .0. ) ->
                          E. y e. A y .<_ x ) $.
    $( Properties that determine an atomic lattice.  (Contributed by NM,
       18-Sep-2011.)  (New usage is discouraged.) $)
    isatliN $p |- K e. AtLat $=
      ( cal wcel clat cv wne wbr wrex wi wral ex rgen isatl mpbir3an ) EOPEQPGD
      PARZGSZBRUHFTBCUAZUBZADUCHMUKADUHDPUIUJNUDUEABCDEFGIJKLUFUG $.
  $}

  ${
    $d x B $.  $d p x K $.
    atl0cl.b $e |- B = ( Base ` K ) $.
    atl0cl.z $e |- .0. = ( 0. ` K ) $.
    $( An atomic lattice has a zero element.  We can use this in place of
       ~ op0cl for lattices without orthocomplements.  (Contributed by NM,
       5-Nov-2012.) $)
    atl0cl $p |- ( K e. AtLat -> .0. e. B ) $=
      ( vx vp cal wcel clat cv wne cple cfv wbr catm wrex wi wral eqid simp2bi
      isatl ) BHIBJICAIFKZCLGKUCBMNZOGBPNZQRFASFGUEABUDCDUDTEUETUBUA $.
  $}

  ${
    atl0le.b $e |- B = ( Base ` K ) $.
    atl0le.l $e |- .<_ = ( le ` K ) $.
    atl0le.z $e |- .0. = ( 0. ` K ) $.
    $( Orthoposet zero is less than or equal to any element.  ( ~ ch0le
       analog.)  (Contributed by NM, 12-Oct-2011.) $)
    atl0le $p |- ( ( K e. AtLat /\ X e. B ) -> .0. .<_ X ) $=
      ( cal wcel wbr atl0cl adantr cpo atlpos p0le syl3an1 3com23 mpd3an3 ) BIJ
      ZDAJZEAJZEDCKZTUBUAABEFHLMTUBUAUCTBNJUBUAUCBOABCDEFGHPQRS $.

    $( An element less than or equal to zero equals zero.  ( ~ chle0 analog.)
       (Contributed by NM, 21-Oct-2011.) $)
    atlle0 $p |- ( ( K e. AtLat /\ X e. B ) -> ( X .<_ .0. <-> X = .0. ) ) $=
      ( cal wcel wa wbr wceq atl0le biantrud cpo wb atlpos adantr simpr syl3anc
      atl0cl posasymb bitrd ) BIJZDAJZKZDECLZUHEDCLZKZDEMZUGUIUHABCDEFGHNOUGBPJ
      ZUFEAJZUJUKQUEULUFBRSUEUFTUEUMUFABEFHUBSABCDEFGUCUAUD $.
  $}

  ${
    atlltne0.b $e |- B = ( Base ` K ) $.
    atlltne0.s $e |- .< = ( lt ` K ) $.
    atlltne0.z $e |- .0. = ( 0. ` K ) $.
    $( A lattice element greater than zero is nonzero.  (Contributed by NM,
       1-Jun-2012.) $)
    atlltn0 $p |- ( ( K e. AtLat /\ X e. B ) -> ( .0. .< X <-> X =/= .0. ) ) $=
      ( cal wcel wa wbr cple cfv wne wb simpl atl0cl adantr simpr syl3anc necom
      eqid pltval atl0le biantrurd syl5rbb bitrd ) CIJZDAJZKZEDBLZEDCMNZLZEDOZK
      ZDEOZUKUIEAJZUJULUPPUIUJQUIURUJACEFHRSUIUJTIAABCUMEDUMUCZGUDUAUQUOUKUPDEU
      BUKUNUOACUMDEFUSHUEUFUGUH $.
  $}

  ${
    $d x B $.  $d x K $.  $d x P $.  $d x .0. $.
    isat3.b $e |- B = ( Base ` K ) $.
    isat3.l $e |- .<_ = ( le ` K ) $.
    isat3.z $e |- .0. = ( 0. ` K ) $.
    isat3.a $e |- A = ( Atoms ` K ) $.
    $( The predicate "is an atom".  ( ~ elat2 analog.)  (Contributed by NM,
       27-Apr-2014.) $)
    isat3 $p |- ( K e. AtLat -> ( P e. A <-> ( P e. B
        /\ P =/= .0. /\ A. x e. B ( x .<_ P -> ( x = P \/ x = .0. ) ) ) ) ) $=
      ( cal wcel wne wbr wceq wo wi wral wa cv w3a ccvr eqid isat cplt wb simpl
      atl0cl adantr cvrval2 syl3anc atlltn0 adantlr imbi1d imbi2d impexp bi2.04
      cfv simpr bitri orcom neor imbi2i 3bitr4g ralbidva bitr2d pm5.32da bitr4d
      anbi12d 3anass syl6bbr ) ELMZDBMZDCMZDGNZAUAZDFOZVQDPZVQGPZQZRZACSZTZTZVO
      VPWCUBVMVNVOGDEUCUSZOZTWEBCWFLDEGHJWFUDZKUEVMVOWDWGVMVOTZWGGDEUFUSZOZGVQW
      JOZVRTVSRZACSZTZWDWIVMGCMZVOWGWOUGVMVOUHVMWPVOCEGHJUIUJVMVOUTALCWFWJEFGDH
      IWJUDZWHUKULWIWKVPWNWCCWJEDGHWQJUMWIWMWBACWIVQCMZTZVRWLVSRZRZVRVQGNZVSRZR
      WMWBWSWTXCVRWSWLXBVSVMWRWLXBUGVOCWJEVQGHWQJUMUNUOUPWMWLVRVSRRXAWLVRVSUQWL
      VRVSURVAWAXCVRWAVTVSQXCVSVTVBVSVQGVCVAVDVEVFVJVGVHVIVOVPWCVKVL $.
  $}

  ${
    $d x K $.  $d x P $.  $d x .0. $.
    atne0.z $e |- .0. = ( 0. ` K ) $.
    atne0.a $e |- A = ( Atoms ` K ) $.
    $( An atom is not zero.  ( ~ atne0 analog.)  (Contributed by NM,
       5-Nov-2012.) $)
    atn0 $p |- ( ( K e. AtLat /\ P e. A ) -> P =/= .0. ) $=
      ( vx cal wcel wne cbs cfv cv cple wbr wceq wo wi wral eqid w3a syl6bi imp
      isat3 simp2 ) CHIZBAIZBDJZUFUGBCKLZIZUHGMZBCNLZOUKBPUKDPQRGUISZUAUHGAUIBC
      ULDUITULTEFUDUJUHUMUEUBUC $.
  $}

  ${
    atnle0.l $e |- .<_ = ( le ` K ) $.
    atnle0.z $e |- .0. = ( 0. ` K ) $.
    atnle0.a $e |- A = ( Atoms ` K ) $.
    $( An atom is not less than or equal to zero.  (Contributed by NM,
       17-Oct-2011.) $)
    atnle0 $p |- ( ( K e. AtLat /\ P e. A ) -> -. P .<_ .0. ) $=
      ( cal wcel wa cpo cbs cfv ccvr wbr wn atlpos adantr eqid atl0cl syl31anc
      atbase adantl atcvr0 cvrnle ) CIJZBAJZKCLJZECMNZJZBUJJZEBCONZPBEDPQUGUIUH
      CRSUGUKUHUJCEUJTZGUASUHULUGAUJBCUNHUCUDAUMIBCEGUMTZHUEUJUMCDEBUNFUOUFUB
      $.
  $}

  ${
    atlen0.b $e |- B = ( Base ` K ) $.
    atlen0.l $e |- .<_ = ( le ` K ) $.
    atlen0.z $e |- .0. = ( 0. ` K ) $.
    atlen0.a $e |- A = ( Atoms ` K ) $.
    $( A lattice element is nonzero if an atom is under it.  (Contributed by
       NM, 26-May-2012.) $)
    atlen0 $p |- ( ( ( K e. AtLat /\ X e. B /\ P e. A ) /\ P .<_ X )
            -> X =/= .0. ) $=
      ( cal wcel w3a wbr wa cplt cfv syl eqid simpl1 atl0cl simpl2 3jca syl2anc
      wne ccvr simpl3 atbase atcvr0 cvrlt syl31anc simpr cpo wi atlpos syl13anc
      pltletr mp2and pltne sylc necomd ) DLMZFBMZCAMZNZCFEOZPZGFVHVCGBMZVDNGFDQ
      RZOZGFUFVHVCVIVDVCVDVEVGUAZVHVCVIVLBDGHJUBSZVCVDVEVGUCZUDVHGCVJOZVGVKVHVC
      VICBMZGCDUGRZOZVOVLVMVHVEVPVCVDVEVGUHZABCDHKUISZVHVCVEVRVLVSAVQLCDGJVQTZK
      UJUELBVQVJDGCHVJTZWAUKULVFVGUMVHDUNMZVIVPVDVOVGPVKUOVHVCWCVLDUPSVMVTVNBVJ
      DEGCFHIWBURUQUSLBBVJDGFWBUTVAVB $.
  $}

  ${
    atcmp.l $e |- .<_ = ( le ` K ) $.
    atcmp.a $e |- A = ( Atoms ` K ) $.
    $( If two atoms are comparable, they are equal.  ( ~ atsseq analog.)
       (Contributed by NM, 13-Oct-2011.) $)
    atcmp $p |- ( ( K e. AtLat /\ P e. A /\ Q e. A )
        -> ( P .<_ Q <-> P = Q ) ) $=
      ( cal wcel w3a cpo cbs cfv cp0 ccvr wbr 3ad2ant1 eqid atbase atcvr0 wceq
      wb atlpos 3ad2ant2 3ad2ant3 atl0cl 3adant3 3adant2 cvrcmp syl132anc ) DHI
      ZBAIZCAIZJDKIZBDLMZIZCUOIZDNMZUOIZURBDOMZPZURCUTPZBCEPBCUAUBUKULUNUMDUCQU
      LUKUPUMAUOBDUORZGSUDUMUKUQULAUOCDVCGSUEUKULUSUMUODURVCURRZUFQUKULVAUMAUTH
      BDURVDUTRZGTUGUKUMVBULAUTHCDURVDVEGTUHUOUTDEBCURVCFVEUIUJ $.

    $( Frequently-used variation of ~ atcmp .  (Contributed by NM,
       29-Jun-2012.) $)
    atncmp $p |- ( ( K e. AtLat /\ P e. A /\ Q e. A )
             -> ( -. P .<_ Q <-> P =/= Q ) ) $=
      ( cal wcel w3a wbr atcmp necon3bbid ) DHIBAICAIJBCEKBCABCDEFGLM $.
  $}

  ${
    atnlt.s $e |- .< = ( lt ` K ) $.
    atnlt.a $e |- A = ( Atoms ` K ) $.
    $( Two atoms cannot satisfy the less than relation.  (Contributed by NM,
       7-Feb-2012.) $)
    atnlt $p |- ( ( K e. AtLat /\ P e. A /\ Q e. A ) -> -. P .< Q ) $=
      ( cal wcel w3a wbr wn wceq pltirr 3adant3 breq2 notbid syl5ibcom cple cfv
      eqid pltle atcmp sylibd necon3ad pm2.61dne ) EHIZBAIZCAIZJZBCDKZLZBCUJBBD
      KZLZBCMZULUGUHUNUIHADEBFNOUOUMUKBCBDPQRUJUKBCUJUKBCESTZKUOHAADEUPBCUPUAZF
      UBABCEUPUQGUCUDUEUF $.
  $}

  ${
    atcvreq0.b $e |- B = ( Base ` K ) $.
    atcvreq0.l $e |- .<_ = ( le ` K ) $.
    atcvreq0.z $e |- .0. = ( 0. ` K ) $.
    atcvreq0.c $e |- C = ( <o ` K ) $.
    atcvreq0.a $e |- A = ( Atoms ` K ) $.
    $( An element covered by an atom must be zero.  ( ~ atcveq0 analog.)
       (Contributed by NM, 4-Nov-2011.) $)
    atcvreq0 $p |- ( ( K e. AtLat /\ X e. B /\ P e. A )
      -> ( X C P <-> X = .0. ) ) $=
      ( cal wcel wbr wceq wa cfv adantr w3a cple cplt eqid atl0le 3adant3 cvrlt
      atbase syl3anl3 cpo atlpos 3ad2ant1 atl0cl 3ad2ant3 simpl2 atcvr0 3adant2
      wb cvrnbtwn3 syl131anc mpbi2and eqcomd ex breq1 syl5ibrcom impbid ) ENOZG
      BOZDAOZUAZGDCPZGHQZVJVKVLVJVKRZHGVMHGEUBSZPZGDEUCSZPZHGQZVJVOVKVGVHVOVIBE
      VNGHIVNUDZKUEUFTVIVGVHDBOZVKVQABDEIMUHZNBCVPEGDIVPUDZLUGUIVMEUJOZHBOZVTVH
      HDCPZVOVQRVRURVJWCVKVGVHWCVIEUKULTVJWDVKVGVHWDVIBEHIKUMULTVJVTVKVIVGVTVHW
      AUNTVGVHVIVKUOVJWEVKVGVIWEVHACNDEHKLMUPUQZTBCVPEVNHDGIVSWBLUSUTVAVBVCVJVK
      VLWEWFGHDCVDVEVF $.
  $}

  ${
    atncvr.c $e |- C = ( <o ` K ) $.
    atncvr.a $e |- A = ( Atoms ` K ) $.
    $( Two atoms cannot satisfy the covering relation.  (Contributed by NM,
       7-Feb-2012.)  (New usage is discouraged.) $)
    atncvrN $p |- ( ( K e. AtLat /\ P e. A /\ Q e. A ) -> -. P C Q ) $=
      ( cal wcel w3a wbr wn cp0 cfv wne eqid atn0 3adant3 cbs wceq cple syl3an2
      wb atbase atcvreq0 necon3bbid mpbird ) EHIZCAIZDAIZJZCDBKZLCEMNZOZUHUIUNU
      JACEUMUMPZGQRUKULCUMUIUHCESNZIUJULCUMTUCAUPCEUPPZGUDAUPBDEEUANZCUMUQURPUO
      FGUEUBUFUG $.
  $}

  ${
    $d x y A $.  $d x B $.  $d x y K $.  $d x .<_ $.  $d x y X $.  $d x .0. $.
    atlex.b $e |- B = ( Base ` K ) $.
    atlex.l $e |- .<_ = ( le ` K ) $.
    atlex.z $e |- .0. = ( 0. ` K ) $.
    atlex.a $e |- A = ( Atoms ` K ) $.
    $( Every nonzero element of an atomic lattice is greater than or equal to
       an atom.  ( ~ hatomic analog.)  (Contributed by NM, 21-Oct-2011.) $)
    atlex $p |- ( ( K e. AtLat /\ X e. B /\ X =/= .0. )
        -> E. y e. A y .<_ X ) $=
      ( vx cal wcel wne cv wbr wrex wi wral clat isatl simp3bi wceq neeq1 breq2
      rexbidv imbi12d rspccv syl 3imp ) DMNZFCNZFGOZAPZFEQZABRZULLPZGOZUOUREQZA
      BRZSZLCTZUMUNUQSZSULDUANGCNVCLABCDEGHIJKUBUCVBVDLFCURFUDZUSUNVAUQURFGUEVE
      UTUPABURFUOEUFUGUHUIUJUK $.
  $}

  ${
    $d y A $.  $d y B $.  $d y K $.  $d y .<_ $.  $d y ./\ $.  $d y P $.
    $d y X $.  $d y .0. $.
    atnle.b $e |- B = ( Base ` K ) $.
    atnle.l $e |- .<_ = ( le ` K ) $.
    atnle.m $e |- ./\ = ( meet ` K ) $.
    atnle.z $e |- .0. = ( 0. ` K ) $.
    atnle.a $e |- A = ( Atoms ` K ) $.
    $( Two ways of expressing "an atom is not less than or equal to a lattice
       element."  ( ~ atnssm0 analog.)  (Contributed by NM, 5-Nov-2012.) $)
    atnle $p |- ( ( K e. AtLat /\ P e. A /\ X e. B ) ->
         ( -. P .<_ X <-> ( P ./\ X ) = .0. ) ) $=
      ( vy wcel wbr wceq wa syl3anc wi cal w3a wn co cv wrex simpl1 clat atllat
      3ad2ant1 atbase 3ad2ant2 simp3 latmcl adantr simpr atlex wb adantl simpl2
      wne syl simpl3 latlem12 syl13anc atcmp breq1 biimpd imp3a sylbird adantlr
      syl6bi rexlimdva mpd necon1bd atn0 3adant3 latleeqm1 eqeq1 biimpcd sylbid
      ex necon3ad mpid impbid ) DUAOZCAOZGBOZUBZCGEPZUCZCGFUDZHQZWIWJWLHWIWLHVA
      ZWJWIWNRZNUEZWLEPZNAUFZWJWOWFWLBOZWNWRWFWGWHWNUGWIWSWNWIDUHOZCBOZWHWSWFWG
      WTWHDUIZUJZWGWFXAWHABCDIMUKZULZWFWGWHUMZBDFCGIKUNSUOWIWNUPNABDEWLHIJLMUQS
      WOWQWJNAWIWPAOZWQWJTWNWIXGRZWQWPCEPZWPGEPZRZWJXHWTWPBOZXAWHXKWQURXHWFWTWF
      WGWHXGUGZXBVBXGXLWIABWPDIMUKUSXHWGXAWFWGWHXGUTZXDVBWFWGWHXGVCBDEFWPCGIJKV
      DVEXHXIXJWJXHXIWPCQZXJWJTXHWFXGWGXIXOURXMWIXGUPXNAWPCDEJMVFSXOXJWJWPCGEVG
      VHVLVIVJVKVMVNWBVOWIWMCHVAZWKWFWGXPWHACDHLMVPVQWIWMXPWKTWIWMRZWJCHXQWJWLC
      QZCHQZWIWJXRURZWMWIWTXAWHXTXCXEXFBDEFCGIJKVRSUOWMXRXSTWIXRWMXSWLCHVSVTUSW
      AWCWBWDWE $.
  $}

  ${
    atnem0.m $e |- ./\ = ( meet ` K ) $.
    atnem0.z $e |- .0. = ( 0. ` K ) $.
    atnem0.a $e |- A = ( Atoms ` K ) $.
    $( The meet of distinct atoms is zero.  ( ~ atnemeq0 analog.)  (Contributed
       by NM, 5-Nov-2012.) $)
    atnem0 $p |- ( ( K e. AtLat /\ P e. A /\ Q e. A )
        -> ( P =/= Q <-> ( P ./\ Q ) = .0. ) ) $=
      ( cal wcel w3a cple cfv wbr wn wne co wceq eqid atncmp cbs atbase syl3an3
      wb atnle bitr3d ) DJKZBAKZCAKZLBCDMNZOPZBCQBCERFSZABCDUKUKTZIUAUJUHUICDUB
      NZKULUMUEAUOCDUOTZIUCAUOBDUKECFUPUNGHIUFUDUG $.
  $}

  ${
    $d x y .<_ $.  $d x .1. $.  $d x y A $.  $d x y B $.  $d x y X $.
    $d x K $.
    atlatmstc.b $e |- B = ( Base ` K ) $.
    atlatmstc.l $e |- .<_ = ( le ` K ) $.
    atlatmstc.u $e |- .1. = ( lub ` K ) $.
    atlatmstc.a $e |- A = ( Atoms ` K ) $.
    $( An atomic, complete, orthomodular lattice is atomistic i.e. every
       element is the join of the atoms under it.  See remark before
       Proposition 1 in [Kalmbach] p. 140; also remark in
       [BeltramettiCassinelli] p. 98.  ( ~ hatomistici analog.)  (Contributed
       by NM, 5-Nov-2012.) $)
    atlatmstc $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. AtLat ) /\ X e. B )
           -> ( .1. ` { y e. A | y .<_ X } ) = X ) $=
      ( vx wcel wa wbr cfv wceq wss adantr wb coml ccla cal w3a cv crab cmee co
      coc cp0 simpl2 ssrab2 atssbase rabss2 ax-mp lubss mp3an23 atlpos 3ad2ant3
      syl lubid sylan breqtrd wrex wn wi breq1 elrab simpll2 sstri lubel mp3an3
      cpo sylancom syl5bir expdimp wne simpll3 eqid simpl3 atllat atbase adantl
      ex atn0 clat clatlubcl sylancl cops simpl1 omlop opoccl latlem12 syl13anc
      syl2anc opnoncon breq2d ople0 syl2an 3bitrd biimpa expr necon3ad mpd syld
      imnan sylib simplr mtbid nrexdv simpr latmcl syl3anc atlex omllaw3 mp2and
      necon1bd ) EUAMZEUBMZEUCMZUDZGCMZNZAUEZGFOZABUFZDPZGFOZGYGEUIPZPZEUGPZUHZ
      EUJPZQZYGGQZYCYGYEACUFZDPZGFYCXSYGYQFOZXRXSXTYBUKZXSYPCRYFYPRZYRYEACULBCR
      YTBCEHKUMZYEABCUNUOCYFYPDEFHIJUPUQUTYAEVMMZYBYQGQXTXRUUBXSEURUSACDEFGHIJV
      AVBVCYCLUEZYLFOZLBVDZVEYNYCUUDLBYCUUCBMZNZUUCGFOZUUCYJFOZNZUUDUUGUUHUUIVE
      ZVFUUJVEUUGUUHUUCYGFOZUUKYCUUFUUHUULUUFUUHNUUCYFMZYCUULYEUUHAUUCBYDUUCGFV
      GVHYCUUMUULYCUUMXSUULXRXSXTYBUUMVIXSUUMYFCRZUULYFBCYEABULUUAVJZCYFDEFUUCH
      IJVKVLVNWDVOVPUUGUULUUKUUGUULNZUUCYMVQZUUKUUGUUQUULYCUUFXTUUQXRXSXTYBUUFV
      RBUUCEYMYMVSZKWEVNSUUPUUIUUCYMUUGUULUUIUUCYMQZUUGUULUUINZUUSUUGUUTUUCYGYJ
      YKUHZFOZUUCYMFOZUUSUUGEWFMZUUCCMZYGCMZYJCMZUUTUVBTYCUVDUUFYCXTUVDXRXSXTYB
      VTEWAUTZSZUUFUVEYCBCUUCEHKWBZWCZYCUVFUUFYCXSUUNUVFYSUUOCYFDEHJWGWHZSYCUVG
      UUFYCEWIMZUVFUVGYCXRUVMXRXSXTYBWJZEWKUTZUVLCEYIYGHYIVSZWLWOZSZCEFYKUUCYGY
      JHIYKVSZWMWNYCUVBUVCTUUFYCUVAYMUUCFYCUVMUVFUVAYMQUVOUVLCEYKYIYGYMHUVPUVSU
      URWPWOWQSYCUVMUVEUVCUUSTUUFUVOUVJCEFUUCYMHIUURWRWSWTXAXBXCXDWDXEUUHUUIXFX
      GUUGUVDUVEYBUVGUUJUUDTUVIUVKYAYBUUFXHUVRCEFYKUUCGYJHIUVSWMWNXIXJYCUUEYLYM
      YCYLYMVQZUUEYCUVTNXTYLCMZUVTUUEXRXSXTYBUVTVRYCUWAUVTYCUVDYBUVGUWAUVHYAYBX
      KZUVQCEYKGYJHUVSXLXMSYCUVTXKLBCEFYLYMHIUURKXNXMWDXQXDYCXRUVFYBYHYNNYOVFUV
      NUVLUWBCEFYKYIYGGYMHIUVSUVPUURXOXMXP $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    atlatle.b $e |- B = ( Base ` K ) $.
    atlatle.l $e |- .<_ = ( le ` K ) $.
    atlatle.a $e |- A = ( Atoms ` K ) $.
    $( The ordering of two Hilbert lattice elements is determined by the atoms
       under them.  ( ~ chrelat3 analog.)  (Contributed by NM, 5-Nov-2012.) $)
    atlatle $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. AtLat )
                /\ X e. B /\ Y e. B )
         -> ( X .<_ Y <-> A. p e. A ( p .<_ X -> p .<_ Y ) ) ) $=
      ( wcel w3a wbr wi wa crab wss cfv wceq atlatmstc coml ccla cal cv simpl13
      wral cpo atlpos syl atbase adantl simpl2 simpl3 postr syl13anc exp3acom23
      ralrimdva ss2rab club simpl12 ssrab2 atssbase sstri lubss mp3an2 sylancom
      eqid ex 3adant3 3adant2 breq12d sylibd syl5bir impbid ) CUAKZCUBKZCUCKZLZ
      EBKZFBKZLZEFDMZGUDZEDMZWCFDMZNZGAUFZWAWBWFGAWAWCAKZOZWDWBWEWICUGKZWCBKZVS
      VTWDWBOWENWIVQWJVOVPVQVSVTWHUECUHUIWHWKWAABWCCHJUJUKVRVSVTWHULVRVSVTWHUMB
      CDWCEFHIUNUOUPUQWGWDGAPZWEGAPZQZWAWBWDWEGAURWAWNWLCUSRZRZWMWORZDMZWBWAWNW
      RWAWNVPWRVOVPVQVSVTWNUTVPWMBQWNWRWMABWEGAVAABCHJVBVCBWLWMWOCDHIWOVGZVDVEV
      FVHWAWPEWQFDVRVSWPESVTGABWOCDEHIWSJTVIVRVTWQFSVSGABWOCDFHIWSJTVJVKVLVMVN
      $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    atlrelat1.b $e |- B = ( Base ` K ) $.
    atlrelat1.l $e |- .<_ = ( le ` K ) $.
    atlrelat1.s $e |- .< = ( lt ` K ) $.
    atlrelat1.a $e |- A = ( Atoms ` K ) $.
    $( An atomistic lattice with 0 is relatively atomic.  Part of Lemma 7.2 of
       [MaedaMaeda] p. 30.  ( ~ chpssati , with ` /\ ` swapped, analog.)
       (Contributed by NM, 4-Dec-2011.) $)
    atlrelat1 $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. AtLat ) /\ X e. B /\ Y
        e. B ) -> ( X .< Y
         -> E. p e. A ( -. p .<_ X /\ p .<_ Y ) ) ) $=
      ( coml wcel w3a wbr wn wa wi wral ccla cal cv cpo simp13 atlpos pltnle ex
      wrex syld3an1 iman ancom xchbinx ralbii wb atlatle 3com23 biimprd syl5bir
      syl con3d dfrex2 syl6ibr syld ) DMNZDUANZDUBNZOZFBNZGBNZOZFGCPZGFEPZQZHUC
      ZFEPZQZVOGEPZRZHAUIZDUDNZVIVHVJVLVNSVKVGWAVEVFVGVIVJUEDUFUTWAVIVJOVLVNBCD
      EFGIJKUGUHUJVKVNVSQZHATZQVTVKWCVMWCVRVPSZHATZVKVMWDWBHAWDVRVQRVSVRVPUKVRV
      QULUMUNVKVMWEVHVJVIVMWEUOABDEGFHIJLUPUQURUSVAVSHAVBVCVD $.
  $}

  ${
    $d k c a b $.
    $( Define the class of lattices with the covering property. $)
    $(
    df-cvlat $a |- CvLat = { l e. AtLat | A. a e. ( Base ` l )
       A. p e. ( Atoms ` l ) ( ( a ( meet ` l ) p ) = ( 0. ` l )
          -> a ( <o ` l ) ( a ( join ` l ) p ) ) } $.
    $)

    $( Define the class of atomic lattices with the covering property.  (This
       is actually the exchange property, but they are equivalent.  The
       literature usually uses the covering property terminology.)
       (Contributed by NM, 5-Nov-2012.) $)
    df-cvlat $a |- CvLat = { k e. AtLat |
      A. a e. ( Atoms ` k ) A. b e. ( Atoms ` k ) A. c e. ( Base ` k )
            ( ( -. a ( le ` k ) c /\ a ( le ` k ) ( c ( join ` k ) b ) )
          -> b ( le ` k ) ( c ( join ` k ) a ) ) } $.
  $}

  $(
  @{
    @d l y A @.  @d l x B @.  @d l C @.  @d l .\/ @.  @d l x y K @.
    @d l ./\ @.  @d l .0. @.
    iscvlat.1 @e |- B = ( Base ` K ) @.
    iscvlat.2 @e |- .\/ = ( join ` K ) @.
    iscvlat.3 @e |- ./\ = ( meet ` K ) @.
    iscvlat.4 @e |- .0. = ( 0. ` K ) @.
    iscvlat.5 @e |- C = ( <o ` K ) @.
    iscvlat.6 @e |- A = ( Atoms ` K ) @.
    @( The predicate "is a lattice with the covering property". @)
    iscvlat @p |- ( K e. CvLat <-> ( K e. AtLat
      /\ A. x e. B A. y e. A ( ( x ./\ y ) = .0. -> x C ( x .\/ y ) ) ) ) @=
      ( vl cv cmee cfv co cp0 wceq cjn ccvr wbr wi catm wral cbs cal clc fveq2
      syl6eqr oveqd eqeq12d wb breq syl breq2d bitrd imbi12d raleqbidv
      df-cvlat elrab2 ) AQZBQZPQZRSZTZVGUASZUBZVEVEVFVGUCSZTZVGUDSZUEZUFZBVGUGS
      ZUHZAVGUISZUHVEVFHTZIUBZVEVEVFFTZEUEZUFZBCUHZADUHPGUJUKVGGUBZVRWEAVSDWFVS
      GUISDVGGUIULJUMWFVPWDBVQCWFVQGUGSCVGGUGULOUMWFVKWAVOWCWFVIVTVJIWFVHHVEVFW
      FVHGRSHVGGRULLUMUNWFVJGUASIVGGUAULMUMUOWFVOVEVMEUEZWCWFVNEUBVOWGUPWFVNGUD
      SEVGGUDULNUMVEVMVNEUQURWFVMWBVEEWFVLFVEVFWFVLGUCSFVGGUCULKUMUNUSUTVAVBVBB
      APVCVD @.
      @( [18-Sep-2011] @)
  @}

  @{
    @d y A @.  @d x y B @.  @d x y K @.
    iscvlati.0 @e |- K e. AtLat @.
    iscvlati.1 @e |- B = ( Base ` K ) @.
    iscvlati.2 @e |- .\/ = ( join ` K ) @.
    iscvlati.3 @e |- ./\ = ( meet ` K ) @.
    iscvlati.4 @e |- .0. = ( 0. ` K ) @.
    iscvlati.5 @e |- C = ( <o ` K ) @.
    iscvlati.6 @e |- A = ( Atoms ` K ) @.
    iscvlati.7 @e |- ( ( x e. B /\ y e. A /\ ( x ./\ y ) = .0. )
                          -> x C ( x .\/ y ) ) @.
    @( Properties that a lattice with the covering property. @)
    iscvlati @p |- K e. CvLat @=
      ( clc wcel cal cv co wceq wbr wi wral iscvlat 3expia rgen2 mpbir2anOLD )
      GRS
      GTSAUAZBUAZHUBIUCZUKUKULFUBEUDZUEZBCUFADUFABCDEFGHIKLMNOPUGJUOABDCUKDSULC
      SUMUNQUHUIUJ @.
      @( [18-Sep-2011] @)
  @}
  $)

  ${
    $d k p q A $.  $d k x B $.  $d k .<_ $.  $d k .\/ $.  $d k p q x K $.
    iscvlat.b $e |- B = ( Base ` K ) $.
    iscvlat.l $e |- .<_ = ( le ` K ) $.
    iscvlat.j $e |- .\/ = ( join ` K ) $.
    iscvlat.a $e |- A = ( Atoms ` K ) $.
    $( The predicate "is an atomic lattice with the covering (or exchange)
       property".  (Contributed by NM, 5-Nov-2012.) $)
    iscvlat $p |- ( K e. CvLat
       <-> ( K e. AtLat /\ A. p e. A A. q e. A A. x e. B
       ( ( -. p .<_ x /\ p .<_ ( x .\/ q ) ) -> q .<_ ( x .\/ p ) ) ) ) $=
      ( vk cv cfv wbr co wral fveq2 syl6eqr cple wn cjn wa wi cbs catm cal wceq
      clc breqd notbid eqidd breq123d anbi12d imbi12d raleqbidv df-cvlat elrab2
      oveqd ) HNZANZMNZUAOZPZUBZVAVBGNZVCUCOZQZVDPZUDZVGVBVAVHQZVDPZUEZAVCUFOZR
      ZGVCUGOZRZHVQRVAVBFPZUBZVAVBVGDQZFPZUDZVGVBVADQZFPZUEZACRZGBRZHBRMEUHUJVC
      EUIZVRWHHVQBWIVQEUGOBVCEUGSLTZWIVPWGGVQBWJWIVNWFAVOCWIVOEUFOCVCEUFSITWIVK
      WCVMWEWIVFVTVJWBWIVEVSWIVDFVAVBWIVDEUAOFVCEUASJTZUKULWIVAVAVIWAVDFWIVAUMW
      KWIVHDVBVGWIVHEUCODVCEUCSKTZUTUNUOWIVGVGVLWDVDFWIVGUMWKWIVHDVBVAWLUTUNUPU
      QUQUQMHGAURUS $.
  $}

  ${
    $d p q x A $.  $d x B $.  $d p q x K $.
    iscvlat2.b $e |- B = ( Base ` K ) $.
    iscvlat2.l $e |- .<_ = ( le ` K ) $.
    iscvlat2.j $e |- .\/ = ( join ` K ) $.
    iscvlat2.m $e |- ./\ = ( meet ` K ) $.
    iscvlat2.z $e |- .0. = ( 0. ` K ) $.
    iscvlat2.a $e |- A = ( Atoms ` K ) $.
    $( The predicate "is an atomic lattice with the covering (or exchange)
       property".  (Contributed by NM, 5-Nov-2012.)
       (New usage is discouraged.) $)
    iscvlat2N $p |- ( K e. CvLat
        <-> ( K e. AtLat /\ A. p e. A A. q e. A A. x e. B
  ( ( ( p ./\ x ) = .0. /\ p .<_ ( x .\/ q ) ) -> q .<_ ( x .\/ p ) ) ) ) $=
      ( wcel cv wa wral clc cal wbr wn co wi wceq iscvlat wb simpll simpr atnle
      simplrl syl3anc anbi1d imbi1d ralbidva 2ralbidva pm5.32i bitri ) EUAQEUBQ
      ZJRZARZFUCUDZVBVCIRZDUEFUCZSZVEVCVBDUEFUCZUFZACTZIBTJBTZSVAVBVCGUEHUGZVFS
      ZVHUFZACTZIBTJBTZSABCDEFIJKLMPUHVAVKVPVAVJVOJIBBVAVBBQZVEBQZSZSZVIVNACVTV
      CCQZSZVGVMVHWBVDVLVFWBVAVQWAVDVLUIVAVSWAUJVAVQVRWAUMVTWAUKBCVBEFGVCHKLNOP
      ULUNUOUPUQURUSUT $.
  $}

  ${
    $d p q x K $.
    $( An atomic lattice with the covering property is an atomic lattice.
       (Contributed by NM, 5-Nov-2012.) $)
    cvlatl $p |- ( K e. CvLat -> K e. AtLat ) $=
      ( vp vx vq clc wcel cal cv cple cfv wbr wn cjn co wa cbs wral catm eqid
      wi iscvlat simplbi ) AEFAGFBHZCHZAIJZKLUCUDDHZAMJZNUEKOUFUDUCUGNUEKTCAPJZ
      QDARJZQBUIQCUIUHUGAUEDBUHSUESUGSUISUAUB $.
  $}

  $( An atomic lattice with the covering property is a lattice.  (Contributed
     by NM, 5-Nov-2012.) $)
  cvllat $p |- ( K e. CvLat -> K e. Lat ) $=
    ( clc wcel cal clat cvlatl atllat syl ) ABCADCAECAFAGH $.

  $( An atomic lattice with the covering property is a poset.  (Contributed by
     NM, 5-Nov-2012.)  (New usage is discouraged.) $)
  cvlposN $p |- ( K e. CvLat -> K e. Poset ) $=
    ( clc wcel clat cpo cvllat latpos syl ) ABCADCAECAFAGH $.

  ${
    $d p q A $.  $d p q x B $.  $d p q x .\/ $.  $d p q x K $.  $d p q x .<_ $.
    $d p q x P $.  $d q x Q $.  $d x X $.
    cvlexch.b $e |- B = ( Base ` K ) $.
    cvlexch.l $e |- .<_ = ( le ` K ) $.
    cvlexch.j $e |- .\/ = ( join ` K ) $.
    cvlexch.a $e |- A = ( Atoms ` K ) $.
    $( An atomic covering lattice has the exchange property.  (Contributed by
       NM, 6-Nov-2011.) $)
    cvlexch1 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ X e. B )
        /\ -. P .<_ X ) -> ( P .<_ ( X .\/ Q ) -> Q .<_ ( X .\/ P ) ) ) $=
      ( vp vx vq wcel wbr co wi wa clc w3a wn cv wral cal iscvlat simprbi breq1
      notbid anbi12d oveq2 breq2d imbi12d anbi2d breq2 oveq1 rspc3v mpan9 exp4b
      wceq 3imp ) FUAPZCAPDAPHBPUBZCHGQZUCZCHDERZGQZDHCERZGQZSVCVDVFVHVJVCMUDZN
      UDZGQZUCZVKVLOUDZERZGQZTZVOVLVKERZGQZSZNBUEOAUEMAUEZVDVFVHTZVJSZVCFUFPWBN
      ABEFGOMIJKLUGUHWAWDCVLGQZUCZCVPGQZTZVOVLCERZGQZSWFCVLDERZGQZTZDWIGQZSMONC
      DHAABVKCVAZVRWHVTWJWOVNWFVQWGWOVMWEVKCVLGUIUJVKCVPGUIUKWOVSWIVOGVKCVLEULU
      MUNVODVAZWHWMWJWNWPWGWLWFWPVPWKCGVODVLEULUMUOVODWIGUIUNVLHVAZWMWCWNVJWQWF
      VFWLVHWQWEVEVLHCGUPUJWQWKVGCGVLHDEUQUMUKWQWIVIDGVLHCEUQUMUNURUSUTVB $.

    $( An atomic covering lattice has the exchange property.  (Contributed by
       NM, 6-May-2012.) $)
    cvlexch2 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ X e. B )
        /\ -. P .<_ X ) -> ( P .<_ ( Q .\/ X ) -> Q .<_ ( P .\/ X ) ) ) $=
      ( wcel w3a wbr co wceq atbase syl latjcom clc wn cvlexch1 cvllat 3ad2ant1
      clat simp22 simp23 syl3anc breq2d simp21 3imtr4d ) FUAMZCAMZDAMZHBMZNZCHG
      OUBZNZCHDEPZGODHCEPZGOCDHEPZGODCHEPZGOABCDEFGHIJKLUCUSVBUTCGUSFUFMZDBMZUP
      VBUTQUMUQVDURFUDUEZUSUOVEUMUNUOUPURUGABDFILRSUMUNUOUPURUHZBEFDHIKTUIUJUSV
      CVADGUSVDCBMZUPVCVAQVFUSUNVHUMUNUOUPURUKABCFILRSVGBEFCHIKTUIUJUL $.

    $( An atomic covering lattice has the exchange property.  (Contributed by
       NM, 16-Nov-2011.) $)
    cvlexchb1 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ X e. B )
      /\ -. P .<_ X ) -> ( P .<_ ( X .\/ Q )
    <-> ( X .\/ P ) = ( X .\/ Q ) ) ) $=
      ( wcel wbr wa adantr syl3anc 3adant3 wb mpbi2and clc w3a wceq clat cvllat
      wn simpr3 simpr2 atbase syl latlej1 simpr simpr1 latjcl latjle12 syl13anc
      co cvlexch1 imp latasymb ex wi latlej2 breq2 syl5ibcom impbid ) FUAMZCAMZ
      DAMZHBMZUBZCHGNUFZUBZCHDEUQZGNZHCEUQZVNUCZVMVOVQVMVOOZVPVNGNZVNVPGNZVQVRH
      VNGNZVOVSVMWAVOVGVKWAVLVGVKOZFUDMZVJDBMZWAVGWCVKFUEPZVGVHVIVJUGZWBVIWDVGV
      HVIVJUHABDFILUIUJZBEFGHDIJKUKQRPVMVOULVMWAVOOVSSZVOVGVKWHVLWBWCVJCBMZVNBM
      ZWHWEWFWBVHWIVGVHVIVJUMABCFILUIUJZWBWCVJWDWJWEWFWGBEFHDIKUNQZBEFGHCVNIJKU
      OUPRPTVRHVPGNZDVPGNZVTVMWMVOVGVKWMVLWBWCVJWIWMWEWFWKBEFGHCIJKUKQRPVMVOWNA
      BCDEFGHIJKLURUSVMWMWNOVTSZVOVGVKWOVLWBWCVJWDVPBMZWOWEWFWGWBWCVJWIWPWEWFWK
      BEFHCIKUNQZBEFGHDVPIJKUOUPRPTVMVSVTOVQSZVOVGVKWRVLWBWCWPWJWRWEWQWLBFGVPVN
      IJUTQRPTVAVGVKVQVOVBVLWBCVPGNZVQVOWBWCVJWIWSWEWFWKBEFGHCIJKVCQVPVNCGVDVER
      VF $.

    $( An atomic covering lattice has the exchange property.  (Contributed by
       NM, 22-Jun-2012.) $)
    cvlexchb2 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ X e. B )
    /\ -. P .<_ X )
         -> ( P .<_ ( Q .\/ X ) <-> ( P .\/ X ) = ( Q .\/ X ) ) ) $=
      ( wcel w3a wbr co wceq atbase syl latjcom wn cvlexchb1 clat cvllat simp22
      clc 3ad2ant1 simp23 syl3anc breq2d simp21 eqeq12d 3bitr4d ) FUFMZCAMZDAMZ
      HBMZNZCHGOUAZNZCHDEPZGOHCEPZVAQCDHEPZGOCHEPZVCQABCDEFGHIJKLUBUTVCVACGUTFU
      CMZDBMZUQVCVAQUNURVEUSFUDUGZUTUPVFUNUOUPUQUSUEABDFILRSUNUOUPUQUSUHZBEFDHI
      KTUIZUJUTVDVBVCVAUTVECBMZUQVDVBQVGUTUOVJUNUOUPUQUSUKABCFILRSVHBEFCHIKTUIV
      IULUM $.
  $}

  ${
    cvlexch3.b $e |- B = ( Base ` K ) $.
    cvlexch3.l $e |- .<_ = ( le ` K ) $.
    cvlexch3.j $e |- .\/ = ( join ` K ) $.
    cvlexch3.m $e |- ./\ = ( meet ` K ) $.
    cvlexch3.z $e |- .0. = ( 0. ` K ) $.
    cvlexch3.a $e |- A = ( Atoms ` K ) $.
    $( An atomic covering lattice has the exchange property.  ( ~ atexch
       analog.)  (Contributed by NM, 5-Nov-2012.) $)
    cvlexch3 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ X e. B )
        /\ ( P ./\ X ) = .0. )
            -> ( P .<_ ( X .\/ Q ) -> Q .<_ ( X .\/ P ) ) ) $=
      ( clc wcel co wbr w3a wceq wi wa wn cal cvlatl adantr simpr1 simpr3 atnle
      wb syl3anc cvlexch1 3expia sylbird 3impia ) FQRZCARZDARZIBRZUAZCIHSJUBZCI
      DESGTDICESGTUCZURVBUDZVCCIGTUEZVDVEFUFRZUSVAVFVCULURVGVBFUGUHURUSUTVAUIUR
      USUTVAUJABCFGHIJKLNOPUKUMURVBVFVDABCDEFGIKLMPUNUOUPUQ $.

    $( An atomic covering lattice has the exchange property.  Part of
       Definition 7.8 of [MaedaMaeda] p. 32.  (Contributed by NM, 5-Nov-2012.)
       (New usage is discouraged.) $)
    cvlexch4N $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ X e. B )
        /\ ( P ./\ X ) = .0. )
    -> ( P .<_ ( X .\/ Q ) <-> ( X .\/ P ) = ( X .\/ Q ) ) ) $=
      ( wcel co wceq wbr clc w3a wb wa wn cal cvlatl adantr simpr1 simpr3 atnle
      syl3anc cvlexchb1 3expia sylbird 3impia ) FUAQZCAQZDAQZIBQZUBZCIHRJSZCIDE
      RZGTICERVCSUCZUQVAUDZVBCIGTUEZVDVEFUFQZURUTVFVBUCUQVGVAFUGUHUQURUSUTUIUQU
      RUSUTUJABCFGHIJKLNOPUKULUQVAVFVDABCDEFGIKLMPUMUNUOUP $.
  $}

  ${
    cvlatexch.l $e |- .<_ = ( le ` K ) $.
    cvlatexch.j $e |- .\/ = ( join ` K ) $.
    cvlatexch.a $e |- A = ( Atoms ` K ) $.
    $( A version of ~ cvlexchb1 for atoms.  (Contributed by NM, 5-Nov-2012.) $)
    cvlatexchb1 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ P =/= R ) -> ( P .<_ ( R .\/ Q )
         <-> ( R .\/ P ) = ( R .\/ Q ) ) ) $=
      ( clc wcel w3a wne co wbr wceq wb wa wn cal cvlatl adantr syl3anc cbs cfv
      simpr1 simpr3 atncmp eqid atbase cvlexchb1 3expia syl3anr3 sylbird 3impia
      wi ) FKLZBALZCALZDALZMZBDNZBDCEOZGPDBEOVDQRZURVBSZVCBDGPTZVEVFFUALZUSVAVG
      VCRURVHVBFUBUCURUSUTVAUGURUSUTVAUHABDFGHJUIUDVAUSURUTDFUEUFZLZVGVEUQAVIDF
      VIUJZJUKURUSUTVJMVGVEAVIBCEFGDVKHIJULUMUNUOUP $.

    $( A version of ~ cvlexchb2 for atoms.  (Contributed by NM, 5-Nov-2012.) $)
    cvlatexchb2 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ P =/= R ) -> ( P .<_ ( Q .\/ R )
         <-> ( P .\/ R ) = ( Q .\/ R ) ) ) $=
      ( clc wcel w3a co wbr wceq atbase syl latjcom syl3anc wne cvlatexchb1 cbs
      clat cfv cvllat 3ad2ant1 simp22 eqid simp23 breq2d simp21 eqeq12d 3bitr4d
      ) FKLZBALZCALZDALZMZBDUAZMZBDCENZGODBENZVBPBCDENZGOBDENZVDPABCDEFGHIJUBVA
      VDVBBGVAFUDLZCFUCUEZLZDVGLZVDVBPUOUSVFUTFUFUGZVAUQVHUOUPUQURUTUHAVGCFVGUI
      ZJQRVAURVIUOUPUQURUTUJAVGDFVKJQRZVGEFCDVKISTZUKVAVEVCVDVBVAVFBVGLZVIVEVCP
      VJVAUPVNUOUPUQURUTULAVGBFVKJQRVLVGEFBDVKISTVMUMUN $.

    $( Atom exchange property.  (Contributed by NM, 5-Nov-2012.) $)
    cvlatexch1 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ P =/= R ) -> ( P .<_ ( R .\/ Q ) -> Q .<_ ( R .\/ P ) ) ) $=
      ( clc wcel w3a wne co wbr wceq cvlatexchb1 atbase syl clat cbs cfv cvllat
      3ad2ant1 simp23 eqid simp22 latlej2 syl3anc breq2 syl5ibrcom sylbid ) FKL
      ZBALZCALZDALZMZBDNZMZBDCEOZGPDBEOZVAQZCVBGPZABCDEFGHIJRUTVDVCCVAGPZUTFUAL
      ZDFUBUCZLZCVGLZVEUNURVFUSFUDUEUTUQVHUNUOUPUQUSUFAVGDFVGUGZJSTUTUPVIUNUOUP
      UQUSUHAVGCFVJJSTVGEFGDCVJHIUIUJVBVACGUKULUM $.

    $( Atom exchange property.  (Contributed by NM, 5-Nov-2012.) $)
    cvlatexch2 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ P =/= R ) -> ( P .<_ ( Q .\/ R ) -> Q .<_ ( P .\/ R ) ) ) $=
      ( wcel w3a co wbr wceq atbase syl latjcom syl3anc breq2d clc wne clat cbs
      cvlatexch1 cfv cvllat 3ad2ant1 simp22 eqid simp23 simp21 3imtr4d ) FUAKZB
      AKZCAKZDAKZLZBDUBZLZBDCEMZGNCDBEMZGNBCDEMZGNCBDEMZGNABCDEFGHIJUEUTVCVABGU
      TFUCKZCFUDUFZKZDVFKZVCVAOUNURVEUSFUGUHZUTUPVGUNUOUPUQUSUIAVFCFVFUJZJPQUTU
      QVHUNUOUPUQUSUKAVFDFVJJPQZVFEFCDVJIRSTUTVDVBCGUTVEBVFKZVHVDVBOVIUTUOVLUNU
      OUPUQUSULAVFBFVJJPQVKVFEFBDVJIRSTUM $.

    $( Atom exchange property.  (Contributed by NM, 29-Nov-2012.) $)
    cvlatexch3 $p |- ( ( K e. CvLat /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( P =/= Q /\ P =/= R ) )
             -> ( P .<_ ( Q .\/ R ) -> ( P .\/ Q ) = ( P .\/ R ) ) ) $=
      ( wcel w3a wne wa co wceq wb biimpa syl atbase simp1 simp21 simp23 simp22
      clc wbr simp3l cvlatexchb1 syl131anc clat cbs simpl1 simpl21 eqid simpl22
      cfv cvllat latjcom syl3anc cvlatexchb2 3adant3l 3eqtr4d ex ) FUEKZBAKZCAK
      ZDAKZLZBCMZBDMZNZLZBCDEOZGUFZBCEOZBDEOZPVLVNNZCBEOZVMVOVPVLVNVRVMPZVLVDVE
      VGVFVIVNVSQVDVHVKUAVDVEVFVGVKUBVDVEVFVGVKUCVDVEVFVGVKUDVDVHVIVJUGABDCEFGH
      IJUHUIRVQFUJKZBFUKUPZKZCWAKZVOVRPVQVDVTVDVHVKVNULFUQSVQVEWBVEVFVGVDVKVNUM
      AWABFWAUNZJTSVQVFWCVEVFVGVDVKVNUOAWACFWDJTSWAEFBCWDIURUSVLVNVPVMPZVDVHVJV
      NWEQVIABCDEFGHIJUTVARVBVC $.
  $}

  ${
    $d q z A $.  $d q z B $.  $d q z .\/ $.  $d q z K $.  $d q z .<_ $.
    $d q z X $.  $d q z P $.
    cvlcvr1.b $e |- B = ( Base ` K ) $.
    cvlcvr1.l $e |- .<_ = ( le ` K ) $.
    cvlcvr1.j $e |- .\/ = ( join ` K ) $.
    cvlcvr1.c $e |- C = ( <o ` K ) $.
    cvlcvr1.a $e |- A = ( Atoms ` K ) $.
    $( The covering property.  Proposition 1(ii) in [Kalmbach] p. 140 (and its
       converse).  ( ~ chcv1 analog.)  (Contributed by NM, 5-Nov-2012.) $)
    cvlcvr1 $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. CvLat )
             /\ X e. B /\ P e. A )
      -> ( -. P .<_ X <-> X C ( X .\/ P ) ) ) $=
      ( vz wcel wbr wa wi syl3anc adantr vq coml ccla clc w3a wn co cplt cfv cv
      wceq wral clat simp13 cvllat syl simp2 atbase 3ad2ant3 eqid latnle biimpd
      simpl13 simprll simpl2 simpl3 latjcl simprrr wrex simprrl simpl11 simpl12
      cal cvlatl atlrelat1 syl311anc mpd ad2antrl lattrd simprl simpll3 simpll2
      cvlexch1 syl131anc simprlr mpbid pltle latjle12 syl13anc mpbi2and eqbrtrd
      wb cvlexchb1 rexlimddv latasymd exp44 imp ralrimdva cvrval2 sylibrd simpr
      jcad cvrlt syl31anc ex impbid ) FUBOZFUCOZFUDOZUEZHBOZDAOZUEZDHGPUFZHHDEU
      GZCPZXMXNHXOFUHUIZPZHNUJZXQPZXSXOGPZQZXSXOUKZRZNBULZQZXPXMXNXRYEXMXNXRXMF
      UMOZXKDBOZXNXRWLXMXIYGXGXHXIXKXLUNFUOZUPZXJXKXLUQZXLXJYHXKABDFIMURZUSZBXQ
      EFGHDIJXQUTZKVASZVBXMXNYDNBXMXSBOZXNYDRXMYPXNYBYCXMYPXNQZYBQZQZBFGXSXOIJY
      SXIYGXGXHXIXKXLYRVCZYIUPZXMYPXNYBVDZYSYGXKYHXOBOZUUAXJXKXLYRVEZYSXLYHXJXK
      XLYRVFYLUPBEFHDIKVGZSZXMYQXTYAVHZYSUAUJZHGPUFZUUHXSGPZQZXOXSGPUAAYSXTUUKU
      AAVIZXMYQXTYAVJZYSXGXHFVMOZXKYPXTUULRXGXHXIXKXLYRVKZXGXHXIXKXLYRVLYSXIUUN
      YTFVNUPUUDUUBABXQFGHXSUAIJYNMVOVPVQYSUUHAOZUUKQZQZXOHUUHEUGZXSGUURDUUSGPZ
      XOUUSUKZUURUUHXOGPZUUTUURBFGUUHXSXOIJYSYGUUQUUATZUUPUUHBOZYSUUKABUUHFIMUR
      VRZYSYPUUQUUBTZYSUUCUUQUUFTYSUUPUUIUUJVHZYSYAUUQUUGTVSUURXIUUPXLXKUUIUVBU
      UTRYSXIUUQYTTZYSUUPUUKVTZXJXKXLYRUUQWAZXJXKXLYRUUQWBZYSUUPUUIUUJVJABUUHDE
      FGHIJKMWCWDVQUURXIXLUUPXKXNUUTUVAWLUVHUVJUVIUVKYSXNUUQXMYPXNYBWETABDUUHEF
      GHIJKMWMWDWFUURHXSGPZUUJUUSXSGPZYSUVLUUQYSXTUVLUUMYSXGXKYPXTUVLRUUOUUDUUB
      UBBBXQFGHXSJYNWGSVQTUVGUURYGXKUVDYPUVLUUJQUVMWLUVCUVKUVEUVFBEFGHUUHXSIJKW
      HWIWJWKWNWOWPWQWRXBXMYGXKUUCXPYFWLYJYKXMYGXKYHUUCYJYKYMUUESZNUMBCXQFGHXOI
      JYNLWSSWTXMXPXRXNXMXPXRXMXPQYGXKUUCXPXRXMYGXPYJTXJXKXLXPVEXMUUCXPUVNTXMXP
      XAUMBCXQFHXOIYNLXCXDXEYOWTXF $.
  $}

  ${
    cvlcvrp.b $e |- B = ( Base ` K ) $.
    cvlcvrp.j $e |- .\/ = ( join ` K ) $.
    cvlcvrp.m $e |- ./\ = ( meet ` K ) $.
    cvlcvrp.z $e |- .0. = ( 0. ` K ) $.
    cvlcvrp.c $e |- C = ( <o ` K ) $.
    cvlcvrp.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice satisfies the covering property of Definition 7.4 of
       [MaedaMaeda] p. 31 and its converse.  ( ~ cvp analog.)  (Contributed by
       NM, 5-Nov-2012.) $)
    cvlcvrp $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. CvLat )
          /\ X e. B /\ P e. A )
     -> ( ( X ./\ P ) = .0. <-> X C ( X .\/ P ) ) ) $=
      ( wcel w3a co wceq wbr coml ccla clc cple cfv wn clat simp13 cvllat simp2
      syl atbase 3ad2ant3 latmcom syl3anc eqeq1d cal wb cvlatl simp3 eqid atnle
      cvlcvr1 3bitr2d ) FUAPZFUBPZFUCPZQZHBPZDAPZQZHDGRZISDHGRZISZDHFUDUEZTUFZH
      HDERCTVKVLVMIVKFUGPZVIDBPZVLVMSVKVGVQVEVFVGVIVJUHZFUIUKVHVIVJUJZVJVHVRVIA
      BDFJOULUMBFGHDJLUNUOUPVKFUQPZVJVIVPVNURVKVGWAVSFUSUKVHVIVJUTVTABDFVOGHIJV
      OVAZLMOVBUOABCDEFVOHJWBKNOVCVD $.
  $}

  ${
    cvlatcvr1.j $e |- .\/ = ( join ` K ) $.
    cvlatcvr1.c $e |- C = ( <o ` K ) $.
    cvlatcvr1.a $e |- A = ( Atoms ` K ) $.
    $( An atom is covered by its join with a different atom.  (Contributed by
       NM, 5-Nov-2012.) $)
    cvlatcvr1 $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. CvLat )
            /\ P e. A /\ Q e. A ) -> ( P =/= Q <-> P C ( P .\/ Q ) ) ) $=
      ( coml wcel ccla clc w3a wne cmee cfv co wb eqid cp0 simp13 cvlatl atnem0
      wceq wbr cal syl syld3an1 cbs atbase cvlcvrp syl3an2 bitrd ) FJKZFLKZFMKZ
      NZCAKZDAKZNZCDOZCDFPQZRFUAQZUEZCCDERBUFZFUGKZUSURUTVBVESVAUQVGUOUPUQUSUTU
      BFUCUHACDFVCVDVCTZVDTZIUDUIUSURCFUJQZKUTVEVFSAVJCFVJTZIUKAVJBDEFVCCVDVKGV
      HVIHIULUMUN $.

    $( An atom is covered by its join with a different atom.  (Contributed by
       NM, 5-Nov-2012.) $)
    cvlatcvr2 $p |- ( ( ( K e. OML /\ K e. CLat /\ K e. CvLat )
       /\ P e. A /\ Q e. A ) -> ( P =/= Q <-> P C ( Q .\/ P ) ) ) $=
      ( coml wcel ccla clc w3a wne co wbr cvlatcvr1 clat atbase cbs wceq simp13
      cfv cvllat syl eqid 3ad2ant2 3ad2ant3 latjcom syl3anc breq2d bitrd ) FJKZ
      FLKZFMKZNZCAKZDAKZNZCDOCCDEPZBQCDCEPZBQABCDEFGHIRUTVAVBCBUTFSKZCFUAUDZKZD
      VDKZVAVBUBUTUPVCUNUOUPURUSUCFUEUFURUQVEUSAVDCFVDUGZITUHUSUQVFURAVDDFVGITU
      IVDEFCDVGGUJUKULUM $.
  $}

  ${
    cvlsupr2.a $e |- A = ( Atoms ` K ) $.
    cvlsupr2.l $e |- .<_ = ( le ` K ) $.
    cvlsupr2.j $e |- .\/ = ( join ` K ) $.
    $( Two equivalent ways of expressing that ` R ` is a superposition of ` P `
       and ` Q ` .  (Contributed by NM, 5-Nov-2012.) $)
    cvlsupr2 $p |- ( ( K e. CvLat
              /\ ( P e. A /\ Q e. A /\ R e. A ) /\ P =/= Q )
      -> ( ( P .\/ R ) = ( Q .\/ R )
            <-> ( R =/= P /\ R =/= Q /\ R .<_ ( P .\/ Q ) ) ) ) $=
      ( wcel wne co wceq wbr wa wb oveq2 syl syl3anc simpl3 necomd simplr eqcom
      clc w3a eqeq12d syl6bb adantl mpbid clat cbs simpl1 cvllat simpl21 atbase
      cfv eqid latjidm syl2anc adantr eqtrd simpl22 latleeqj1 cal cvlatl bitr3d
      ex atcmp sylibd necon3d mpd simpl23 latlej1 breqtrrd cvlatexch1 syl131anc
      simpr 3jca simpr3 latjcom breq2d simpr2 simpr1 cvlatexchb2 sylbid impbida
      wi ) FUEKZBAKZCAKZDAKZUFZBCLZUFZBDEMZCDEMZNZDBLZDCLZDBCEMZGOZUFZWOWRPZWSW
      TXBXDCBLZWSXDBCWIWMWNWRUAZUBZXDDBCBXDDBNZCBEMZBNZCBNZXDXHXJXDXHPZXIBBEMZB
      XLWRXIXMNZWOWRXHUCXHWRXNQXDXHWRXMXINXNXHWPXMWQXIDBBERDBCERUGXMXIUDUHUIUJX
      DXMBNZXHXDFUKKZBFULUQZKZXOXDWIXPWIWMWNWRUMZFUNZSZXDWJXRWJWKWLWIWNWRUOZAXQ
      BFXQURZHUPZSZXQEFBYCJUSUTVAVBVHXDCBGOZXJXKXDXPCXQKZXRYFXJQYAXDWKYGWJWKWLW
      IWNWRVCZAXQCFYCHUPZSZYEXQEFGCBYCIJVDTXDFVEKZWKWJYFXKQXDWIYKXSFVFSZYHYBACB
      FGIHVITVGVJVKVLXDWNWTXFXDDCBCXDDCNZXACNZBCNZXDYMYNXDYMPZXACCEMZCYPWRXAYQN
      ZWOWRYMUCYMWRYRQXDYMWPXAWQYQDCBERDCCERUGUIUJXDYQCNZYMXDXPYGYSYAYJXQEFCYCJ
      USUTVAVBVHXDBCGOZYNYOXDXPXRYGYTYNQYAYEYJXQEFGBCYCIJVDTXDYKWJWKYTYOQYLYBYH
      ABCFGIHVITVGVJVKVLXDCWPGOZXBXDCWQWPGXDXPYGDXQKZCWQGOYAYJXDWLUUBWJWKWLWIWN
      WRVMZAXQDFYCHUPSXQEFGCDYCIJVNTWOWRVRVOXDWIWKWLWJXEUUAXBWHXSYHUUCYBXGACDBE
      FGIJHVPVQVLVSWOXCPZXBWRWOWSWTXBVTUUDXBDXIGOZWRUUDXAXIDGUUDXPXRYGXAXINUUDW
      IXPWIWMWNXCUMZXTSUUDWJXRWJWKWLWIWNXCUOZYDSUUDWKYGWJWKWLWIWNXCVCZYISXQEFBC
      YCJWATWBUUDUUEBWQGOZWRUUDWIWLWJWKWTUUEUUIWHUUFWJWKWLWIWNXCVMZUUGUUHWOWSWT
      XBWCADBCEFGIJHVPVQUUDWIWJWKWLBDLUUIWRQUUFUUGUUHUUJUUDDBWOWSWTXBWDUBABCDEF
      GIJHWEVQVJWFVLWG $.

    $( Two equivalent ways of expressing that ` R ` is a superposition of ` P `
       and ` Q ` , which can replace the superposition part of ~ ishlat1 ,
       ` ( x =/= y -> E. z e. A ( z =/= x /\ z =/= y /\ z .<_ ( x .\/ y ) ) `
       ` ) ` , with the simpler ` E. z e. A ( x .\/ z ) = ( y .\/ z ) ` as
       shown in ~ ishlat3N .  (Contributed by NM, 5-Nov-2012.) $)
    cvlsupr3 $p |- ( ( K e. CvLat
          /\ ( P e. A /\ Q e. A /\ R e. A ) )
    -> ( ( P .\/ R ) = ( Q .\/ R )
        <-> ( P =/= Q -> ( R =/= P /\ R =/= Q /\ R .<_ ( P .\/ Q ) ) ) ) ) $=
      ( co wceq wne wi clc wcel w3a wa wbr wn df-ne imbi1i oveq1 pm4.83 3bitrri
      biantrur wb cvlsupr2 3expia pm5.74d syl5bb ) BDEKCDEKLZBCMZULNZFOPZBAPCAP
      DAPQZRZUMDBMDCMDBCEKGSQZNUNBCLZTZULNZUSULNZVARULUMUTULBCUAUBVBVABCDEUCUFU
      SULUDUEUQUMULURUOUPUMULURUGABCDEFGHIJUHUIUJUK $.

    $( Consequence of superposition condition ` ( P .\/ R ) = ( Q .\/ R ) ` .
       (Contributed by NM, 9-Nov-2012.) $)
    cvlsupr4 $p |- ( ( K e. CvLat
              /\ ( P e. A /\ Q e. A /\ R e. A )
    /\ ( P =/= Q /\ ( P .\/ R ) = ( Q .\/ R ) ) ) -> R .<_ ( P .\/ Q ) ) $=
      ( clc wcel w3a wne co wceq wa wbr wi cvlsupr2 simp3 syl6bi 3exp imp4a
      3imp ) FKLZBALCALDALMZBCNZBDEOCDEOPZQDBCEOGRZUFUGUHUIUJUFUGUHUIUJSUFUGUHM
      UIDBNZDCNZUJMUJABCDEFGHIJTUKULUJUAUBUCUDUE $.
  $}

  ${
    cvlsupr5.a $e |- A = ( Atoms ` K ) $.
    cvlsupr5.j $e |- .\/ = ( join ` K ) $.
    $( Consequence of superposition condition ` ( P .\/ R ) = ( Q .\/ R ) ` .
       (Contributed by NM, 9-Nov-2012.) $)
    cvlsupr5 $p |- ( ( K e. CvLat
              /\ ( P e. A /\ Q e. A /\ R e. A )
              /\ ( P =/= Q /\ ( P .\/ R ) = ( Q .\/ R ) ) ) -> R =/= P ) $=
      ( clc wcel w3a wne co wceq wa wi cple cfv wbr eqid simp1 syl6bi 3exp 3imp
      cvlsupr2 imp4a ) FIJZBAJCAJDAJKZBCLZBDEMCDEMNZODBLZUGUHUIUJUKUGUHUIUJUKPU
      GUHUIKUJUKDCLZDBCEMFQRZSZKUKABCDEFUMGUMTHUEUKULUNUAUBUCUFUD $.

    $( Consequence of superposition condition ` ( P .\/ R ) = ( Q .\/ R ) ` .
       (Contributed by NM, 9-Nov-2012.) $)
    cvlsupr6 $p |- ( ( K e. CvLat
              /\ ( P e. A /\ Q e. A /\ R e. A )
              /\ ( P =/= Q /\ ( P .\/ R ) = ( Q .\/ R ) ) ) -> R =/= Q ) $=
      ( clc wcel w3a wne co wceq wa wi cple cfv wbr eqid simp2 syl6bi 3exp 3imp
      cvlsupr2 imp4a ) FIJZBAJCAJDAJKZBCLZBDEMCDEMNZODCLZUGUHUIUJUKUGUHUIUJUKPU
      GUHUIKUJDBLZUKDBCEMFQRZSZKUKABCDEFUMGUMTHUEULUKUNUAUBUCUFUD $.

    $( Consequence of superposition condition ` ( P .\/ R ) = ( Q .\/ R ) ` .
       (Contributed by NM, 24-Nov-2012.) $)
    cvlsupr7 $p |- ( ( K e. CvLat
              /\ ( P e. A /\ Q e. A /\ R e. A )
              /\ ( P =/= Q /\ ( P .\/ R ) = ( Q .\/ R ) ) )
                -> ( P .\/ Q ) = ( R .\/ Q ) ) $=
      ( clc wcel w3a co wceq cfv wbr eqid atbase syl syl3anc breqtrd wne wa cbs
      cple cvllat 3ad2ant1 simp21 simp23 latlej1 simp3r simp22 latjcom wb simp1
      clat simp3l cvlatexchb2 syl131anc mpbid ) FIJZBAJZCAJZDAJZKZBCUAZBDELZCDE
      LZMZUBZKZBDCELZFUDNZOZBCELVKMZVJBVGVKVLVJBVFVGVLVJFUOJZBFUCNZJZDVPJZBVFVL
      OUTVDVOVIFUEUFZVJVAVQUTVAVBVCVIUGZAVPBFVPPZGQRVJVCVRUTVAVBVCVIUHZAVPDFWAG
      QRZVPEFVLBDWAVLPZHUISUTVDVEVHUJTVJVOCVPJZVRVGVKMVSVJVBWEUTVAVBVCVIUKZAVPC
      FWAGQRWCVPEFCDWAHULSTVJUTVAVCVBVEVMVNUMUTVDVIUNVTWBWFUTVDVEVHUPABDCEFVLWD
      HGUQURUS $.

    $( Consequence of superposition condition ` ( P .\/ R ) = ( Q .\/ R ) ` .
       (Contributed by NM, 24-Nov-2012.) $)
    cvlsupr8 $p |- ( ( K e. CvLat
              /\ ( P e. A /\ Q e. A /\ R e. A )
              /\ ( P =/= Q /\ ( P .\/ R ) = ( Q .\/ R ) ) )
                -> ( P .\/ Q ) = ( P .\/ R ) ) $=
      ( clc wcel w3a wne co wceq wa clat cbs cfv atbase syl cvllat eqid latjcom
      3ad2ant1 simp22 simp23 syl3anc simp3r cvlsupr7 3eqtr4rd ) FIJZBAJZCAJZDAJ
      ZKZBCLZBDEMZCDEMZNZOZKZURDCEMZUQBCEMVAFPJZCFQRZJZDVDJZURVBNUKUOVCUTFUAUDV
      AUMVEUKULUMUNUTUEAVDCFVDUBZGSTVAUNVFUKULUMUNUTUFAVDDFVGGSTVDEFCDVGHUCUGUK
      UOUPUSUHABCDEFGHUIUJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
               Hilbert lattices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c HL $.

  $( Extend class notation with Hilbert lattices. $)
  chlt $a class HL $.

  ${
    $d l c a b $.
    $( Define the class of Hilbert lattices, which are complete, atomic
       lattices satisfying the superposition principle and minimum height.
       (Contributed by NM, 5-Nov-2012.) $)
    df-hlat $a |- HL = { l e. ( ( OML i^i CLat ) i^i CvLat ) |
      ( A. a e. ( Atoms ` l ) A. b e. ( Atoms ` l )
        ( a =/= b -> E. c e. ( Atoms ` l )
             ( c =/= a /\ c =/= b /\ c ( le ` l ) ( a ( join ` l ) b ) ) )
      /\ E. a e. ( Base ` l ) E. b e. ( Base ` l ) E. c e. ( Base ` l )
          ( ( ( 0. ` l ) ( lt ` l ) a /\ a ( lt ` l ) b )
        /\ ( b ( lt ` l ) c /\ c ( lt ` l ) ( 1. ` l ) ) ) ) } $.
  $}

  ${
    $d k x y z A $.  $d k x y z B $.  $d k .\/ $.  $d k x y z K $.  $d k .<_ $.
    $d k .< $.  $d k .1. $.  $d k .0. $.
    ishlat.b $e |- B = ( Base ` K ) $.
    ishlat.l $e |- .<_ = ( le ` K ) $.
    ishlat.s $e |- .< = ( lt ` K ) $.
    ishlat.j $e |- .\/ = ( join ` K ) $.
    ishlat.z $e |- .0. = ( 0. ` K ) $.
    ishlat.u $e |- .1. = ( 1. ` K ) $.
    ishlat.a $e |- A = ( Atoms ` K ) $.
    $( The predicate "is a Hilbert lattice," which is orthomodular
       ( ` K e. OML ` ), complete ( ` K e. CLat ` ), atomic and satisfying the
       exchange (or covering) property ( ` K e. CvLat ` ), satisfies the
       superposition principle, and has a minimum height of 4.  (Contributed by
       NM, 5-Nov-2012.) $)
    ishlat1 $p |- ( K e. HL <-> ( ( K e. OML /\ K e. CLat /\ K e. CvLat )
      /\ ( A. x e. A A. y e. A
         ( x =/= y -> E. z e. A ( z =/= x /\ z =/= y /\ z .<_ ( x .\/ y ) ) )
      /\ E. x e. B E. y e. B E. z e. B
            ( ( .0. .< x /\ x .< y ) /\ ( y .< z /\ z .< .1. ) ) ) ) ) $=
      ( wbr cfv vk chlt wcel coml ccla cin clc cv wne co w3a wrex wral cjn cple
      wi wa catm cp0 cplt cp1 cbs wceq fveq2 syl6eqr breqd oveqd breq2d 3anbi3d
      bitrd rexeqbidv imbi2d raleqbidv breq1d anbi12d elrab2 elin anbi1i df-3an
      df-hlat 3bitr4ri bitr4i ) IUBUCIUDUEUFZUGUFZUCZAUHZBUHZUIZCUHZWFUIZWIWGUI
      ZWIWFWGHUJZJSZUKZCDULZUPZBDUMZADUMZKWFFSZWFWGFSZUQZWGWIFSZWIGFSZUQZUQZCEU
      LZBEULZAEULZUQZUQIUDUCZIUEUCZIUGUCZUKZXIUQWHWJWKWIWFWGUAUHZUNTZUJZXNUOTZS
      ZUKZCXNURTZULZUPZBXTUMZAXTUMZXNUSTZWFXNUTTZSZWFWGYFSZUQZWGWIYFSZWIXNVATZY
      FSZUQZUQZCXNVBTZULZBYOULZAYOULZUQXIUAIWDUBXNIVCZYDWRYRXHYSYCWQAXTDYSXTIUR
      TDXNIURVDRVEZYSYBWPBXTDYTYSYAWOWHYSXSWNCXTDYTYSXRWMWJWKYSXRWIXPJSWMYSXQJW
      IXPYSXQIUOTJXNIUOVDMVEVFYSXPWLWIJYSXOHWFWGYSXOIUNTHXNIUNVDOVEVGVHVJVIVKVL
      VMVMYSYQXGAYOEYSYOIVBTEXNIVBVDLVEZYSYPXFBYOEUUAYSYNXECYOEUUAYSYIXAYMXDYSY
      GWSYHWTYSYGYEWFFSWSYSYFFYEWFYSYFIUTTFXNIUTVDNVEZVFYSYEKWFFYSYEIUSTKXNIUSV
      DPVEVNVJYSYFFWFWGUUBVFVOYSYJXBYLXCYSYFFWGWIUUBVFYSYLWIYKFSXCYSYFFWIYKUUBV
      FYSYKGWIFYSYKIVATGXNIVAVDQVEVHVJVOVOVKVKVKVOABCUAVTVPXMWEXIIWCUCZXLUQXJXK
      UQZXLUQWEXMUUCUUDXLIUDUEVQVRIWCUGVQXJXKXLVSWAVRWB $.

    $( The predicate "is a Hilbert lattice".  Here we replace ` K e. CvLat `
       with the weaker ` K e. AtLat ` and show the exchange property
       explicitly.  (Contributed by NM, 5-Nov-2012.) $)
    ishlat2 $p |- ( K e. HL <-> ( ( K e. OML /\ K e. CLat /\ K e. AtLat )
      /\ ( A. x e. A A. y e. A
       ( ( x =/= y -> E. z e. A ( z =/= x /\ z =/= y /\ z .<_ ( x .\/ y ) ) )
            /\ A. z e. B ( ( -. x .<_ z /\ x .<_ ( z .\/ y ) )
               -> y .<_ ( z .\/ x ) ) )
      /\ E. x e. B E. y e. B E. z e. B
            ( ( .0. .< x /\ x .< y ) /\ ( y .< z /\ z .< .1. ) ) ) ) ) $=
      ( wbr wa chlt wcel coml ccla clc w3a cv wne wrex wral cal ishlat1 iscvlat
      co wi wn 3anbi3i anass df-3an anbi1i 3bitr4ri bitri ancom r19.26-2 bitr4i
      bitr3i anbi2i 3bitri ) IUAUBIUCUBZIUDUBZIUEUBZUFZAUGZBUGZUHCUGZVMUHVOVNUH
      VOVMVNHUNJSUFCDUIUOZBDUJADUJZKVMFSVMVNFSTVNVOFSVOGFSTTCEUIBEUIAEUIZTZTVIV
      JIUKUBZUFZVMVOJSUPVMVOVNHUNJSTVNVOVMHUNJSUOCEUJZBDUJADUJZTZVSTZWAVPWBTBDU
      JADUJZVRTZTZABCDEFGHIJKLMNOPQRULVLWDVSVLVIVJVTWCTZUFZWDVKWIVIVJCDEHIJBALM
      ORUMUQVIVJTZVTTZWCTWKWITWDWJWKVTWCURWAWLWCVIVJVTUSUTVIVJWIUSVAVBUTWEWAWCV
      STZTWHWAWCVSURWMWGWAWMWCVQTZVRTWGWCVQVRURWNWFVRWNVQWCTWFWCVQVCVPWBABDDVDV
      EUTVFVGVBVH $.

    $( The predicate "is a Hilbert lattice".  Note that the superposition
       principle is expressed in the compact form
       ` E. z e. A ( x .\/ z ) = ( y .\/ z ) ` .  The exchange property and
       atomicity are provided by ` K e. CvLat ` , and "minimum height 4" is
       shown explicitly.  (Contributed by NM, 8-Nov-2012.)
       (New usage is discouraged.) $)
    ishlat3N $p |- ( K e. HL <-> ( ( K e. OML /\ K e. CLat /\ K e. CvLat )
      /\ ( A. x e. A A. y e. A E. z e. A ( x .\/ z ) = ( y .\/ z )
      /\ E. x e. B E. y e. B E. z e. B
            ( ( .0. .< x /\ x .< y ) /\ ( y .< z /\ z .< .1. ) ) ) ) ) $=
      ( wcel wa chlt coml ccla clc w3a cv wne co wrex wral wceq ishlat1 simpll3
      wbr wi simplrl simplrr simpr cvlsupr3 syl13anc rexbidva ad2antrl r19.37zv
      wb c0 ne0i syl bitr2d 2ralbidva anbi1d pm5.32i bitri ) IUASIUBSZIUCSZIUDS
      ZUEZAUFZBUFZUGZCUFZVQUGVTVRUGVTVQVRHUHJUNUEZCDUIUOZBDUJADUJZKVQFUNVQVRFUN
      TVRVTFUNVTGFUNTTCEUIBEUIAEUIZTZTVPVQVTHUHVRVTHUHUKZCDUIZBDUJADUJZWDTZTABC
      DEFGHIJKLMNOPQRULVPWEWIVPWCWHWDVPWBWGABDDVPVQDSZVRDSZTZTZWGVSWAUOZCDUIZWB
      WMWFWNCDWMVTDSZTVOWJWKWPWFWNVDVMVNVOWLWPUMVPWJWKWPUPVPWJWKWPUQWMWPURDVQVR
      VTHIJRMOUSUTVAWMDVEUGZWOWBVDWJWQVPWKDVQVFVBVSWACDVCVGVHVIVJVKVL $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y z K $.
    ishlati.1 $e |- K e. OML $.
    ishlati.2 $e |- K e. CLat $.
    ishlati.3 $e |- K e. AtLat $.
    ishlati.b $e |- B = ( Base ` K ) $.
    ishlati.l $e |- .<_ = ( le ` K ) $.
    ishlati.s $e |- .< = ( lt ` K ) $.
    ishlati.j $e |- .\/ = ( join ` K ) $.
    ishlati.z $e |- .0. = ( 0. ` K ) $.
    ishlati.u $e |- .1. = ( 1. ` K ) $.
    ishlati.a $e |- A = ( Atoms ` K ) $.
    ishlati.9 $e |- A. x e. A A. y e. A
       ( ( x =/= y -> E. z e. A ( z =/= x /\ z =/= y /\ z .<_ ( x .\/ y ) ) )
            /\ A. z e. B ( ( -. x .<_ z /\ x .<_ ( z .\/ y ) )
               -> y .<_ ( z .\/ x ) ) ) $.
    ishlati.10 $e |- E. x e. B E. y e. B E. z e. B
            ( ( .0. .< x /\ x .< y ) /\ ( y .< z /\ z .< .1. ) ) $.
    $( Properties that determine a Hilbert lattice.  (Contributed by NM,
       13-Nov-2011.)  (New usage is discouraged.) $)
    ishlatiN $p |- K e. HL $=
      ( chlt wcel coml ccla cal w3a cv wne co wrex wi wn wa wral 3pm3.2i pm3.2i
      wbr ishlat2 mpbir2an ) IUDUEIUFUEZIUGUEZIUHUEZUIAUJZBUJZUKCUJZVFUKVHVGUKV
      HVFVGHULJUTUICDUMUNVFVHJUTUOVFVHVGHULJUTUPVGVHVFHULJUTUNCEUQUPBDUQADUQZKV
      FFUTVFVGFUTUPVGVHFUTVHGFUTUPUPCEUMBEUMAEUMZUPVCVDVELMNURVIVJUBUCUSABCDEFG
      HIJKOPQRSTUAVAVB $.
  $}

  ${
    $d x y z K $.
    $( A Hilbert lattice is orthomodular, complete, and has the covering
       (exchange) property.  (Contributed by NM, 5-Nov-2012.) $)
    hlomcmcv $p |- ( K e. HL -> ( K e. OML /\ K e. CLat /\ K e. CvLat ) ) $=
      ( vx vy vz chlt wcel coml ccla clc w3a cv wne cjn cfv co wbr wrex wral wa
      eqid cple catm wi cp0 cplt cp1 cbs ishlat1 simplbi ) AEFAGFAHFAIFJBKZCKZL
      DKZUJLULUKLULUJUKAMNZOAUANZPJDAUBNZQUCCUORBUORAUDNZUJAUENZPUJUKUQPSUKULUQ
      PULAUFNZUQPSSDAUGNZQCUSQBUSQSBCDUOUSUQURUMAUNUPUSTUNTUQTUMTUPTURTUOTUHUI
      $.
  $}

  $( A Hilbert lattice is orthomodular.  (Contributed by NM, 20-Oct-2011.) $)
  hloml $p |- ( K e. HL -> K e. OML ) $=
    ( chlt wcel coml ccla clc hlomcmcv simp1d ) ABCADCAECAFCAGH $.

  $( A Hilbert lattice is complete.  (Contributed by NM, 20-Oct-2011.) $)
  hlclat $p |- ( K e. HL -> K e. CLat ) $=
    ( chlt wcel coml ccla clc hlomcmcv simp2d ) ABCADCAECAFCAGH $.

  $( A Hilbert lattice is an atomic lattice with the covering property.
     (Contributed by NM, 5-Nov-2012.) $)
  hlcvl $p |- ( K e. HL -> K e. CvLat ) $=
    ( chlt wcel coml ccla clc hlomcmcv simp3d ) ABCADCAECAFCAGH $.

  $( A Hilbert lattice is atomic.  (Contributed by NM, 20-Oct-2011.) $)
  hlatl $p |- ( K e. HL -> K e. AtLat ) $=
    ( chlt wcel clc cal hlcvl cvlatl syl ) ABCADCAECAFAGH $.

  $( A Hilbert lattice is an ortholattice.  (Contributed by NM,
     20-Oct-2011.) $)
  hlol $p |- ( K e. HL -> K e. OL ) $=
    ( chlt wcel coml col hloml omlol syl ) ABCADCAECAFAGH $.

  $( A Hilbert lattice is an orthoposet.  (Contributed by NM, 20-Oct-2011.) $)
  hlop $p |- ( K e. HL -> K e. OP ) $=
    ( chlt wcel col cops hlol olop syl ) ABCADCAECAFAGH $.

  $( A Hilbert lattice is a lattice.  (Contributed by NM, 20-Oct-2011.) $)
  hllat $p |- ( K e. HL -> K e. Lat ) $=
    ( chlt wcel cal clat hlatl atllat syl ) ABCADCAECAFAGH $.

  $( A Hilbert lattice is orthomodular, complete, and atomic.  (Contributed by
     NM, 5-Nov-2012.) $)
  hlomcmat $p |- ( K e. HL -> ( K e. OML /\ K e. CLat /\ K e. AtLat ) ) $=
    ( chlt wcel coml ccla cal hloml hlclat hlatl 3jca ) ABCADCAECAFCAGAHAIJ $.

  $( A Hilbert lattice is a poset.  (Contributed by NM, 20-Oct-2011.) $)
  hlpos $p |- ( K e. HL -> K e. Poset ) $=
    ( chlt wcel clat cpo hllat latpos syl ) ABCADCAECAFAGH $.

  ${
    hlatjcl.b $e |- B = ( Base ` K ) $.
    hlatjcl.j $e |- .\/ = ( join ` K ) $.
    hlatjcl.a $e |- A = ( Atoms ` K ) $.
    $( Closure of join operation.  Frequently-used special case of ~ latjcl for
       atoms.  (Contributed by NM, 15-Jun-2012.) $)
    hlatjcl $p |- ( ( K e. HL /\ X e. A /\ Y e. A ) -> ( X .\/ Y ) e. B ) $=
      ( chlt wcel clat co hllat atbase latjcl syl3an ) DJKDLKEAKEBKFAKFBKEFCMBK
      DNABEDGIOABFDGIOBCDEFGHPQ $.
  $}

  ${
    hlatjcom.j $e |- .\/ = ( join ` K ) $.
    hlatjcom.a $e |- A = ( Atoms ` K ) $.
    $( Commutatitivity of join operation.  Frequently-used special case of
       ~ latjcom for atoms.  (Contributed by NM, 15-Jun-2012.) $)
    hlatjcom $p |- ( ( K e. HL /\ X e. A /\ Y e. A )
               -> ( X .\/ Y ) = ( Y .\/ X ) ) $=
      ( chlt wcel clat cbs cfv co wceq hllat eqid atbase latjcom syl3an ) CHICJ
      IDAIDCKLZIEAIETIDEBMEDBMNCOATDCTPZGQATECUAGQTBCDEUAFRS $.

    $( TODO: Use in place of ~ latjcom when it shortens proofs $)
    $( Idempotence of join operation.  Frequently-used special case of
       ~ latjcom for atoms.  (Contributed by NM, 15-Jul-2012.) $)
    hlatjidm $p |- ( ( K e. HL /\ X e. A ) -> ( X .\/ X ) = X ) $=
      ( chlt wcel clat cbs cfv co wceq hllat eqid atbase latjidm syl2an ) CGHCI
      HDCJKZHDDBLDMDAHCNASDCSOZFPSBCDTEQR $.

    $( Lattice join is associative.  Frequently-used special case of ~ latjass
       for atoms.  (Contributed by NM, 27-Jul-2012.) $)
    hlatjass $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) ) ->
             ( ( P .\/ Q ) .\/ R ) = ( P .\/ ( Q .\/ R ) ) ) $=
      ( chlt wcel w3a wa clat cbs cfv co wceq hllat atbase syl latjass syl13anc
      adantr simpr1 eqid simpr2 simpr3 ) FIJZBAJZCAJZDAJZKZLZFMJZBFNOZJZCUOJZDU
      OJZBCEPDEPBCDEPEPQUHUNULFRUCUMUIUPUHUIUJUKUDAUOBFUOUEZHSTUMUJUQUHUIUJUKUF
      AUOCFUSHSTUMUKURUHUIUJUKUGAUODFUSHSTUOEFBCDUSGUAUB $.

    $( Swap 1st and 2nd members of lattice join.  Frequently-used special case
       of ~ latj32 for atoms.  (Contributed by NM, 4-Jun-2012.) $)
    hlatj12 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) ) ->
             ( P .\/ ( Q .\/ R ) ) = ( Q .\/ ( P .\/ R ) ) ) $=
      ( chlt wcel w3a wa wceq hlatjcom 3adant3r3 oveq1d hlatjass simpl simpr2
      co simpr1 simpr3 syl13anc 3eqtr3d ) FIJZBAJZCAJZDAJZKZLZBCETZDETCBETZDETZ
      BCDETETCBDETETZUJUKULDEUEUFUGUKULMUHAEFBCGHNOPABCDEFGHQUJUEUGUFUHUMUNMUEU
      IRUEUFUGUHSUEUFUGUHUAUEUFUGUHUBACBDEFGHQUCUD $.

    $( Swap 2nd and 3rd members of lattice join.  Frequently-used special case
       of ~ latj32 for atoms.  (Contributed by NM, 21-Jul-2012.) $)
    hlatj32 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) ) ->
             ( ( P .\/ Q ) .\/ R ) = ( ( P .\/ R ) .\/ Q ) ) $=
      ( chlt wcel w3a wa clat cbs cfv co wceq hllat atbase syl adantr syl13anc
      simpr1 eqid simpr2 simpr3 latj32 ) FIJZBAJZCAJZDAJZKZLZFMJZBFNOZJZCUOJZDU
      OJZBCEPDEPBDEPCEPQUHUNULFRUAUMUIUPUHUIUJUKUCAUOBFUOUDZHSTUMUJUQUHUIUJUKUE
      AUOCFUSHSTUMUKURUHUIUJUKUFAUODFUSHSTUOEFBCDUSGUGUB $.

    $( Rotate lattice join of 3 classes.  Frequently-used special case of
       ~ latjrot for atoms.  (Contributed by NM, 2-Aug-2012.) $)
    hlatjrot $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) ) ->
             ( ( P .\/ Q ) .\/ R ) = ( ( R .\/ P ) .\/ Q ) ) $=
      ( chlt wcel w3a wa co hlatj32 wceq hlatjcom 3adant3r2 oveq1d eqtrd ) FIJZ
      BAJZCAJZDAJZKLZBCEMDEMBDEMZCEMDBEMZCEMABCDEFGHNUDUEUFCETUAUCUEUFOUBAEFBDG
      HPQRS $.

    $( Rearrangement of lattice join of 4 classes.  Frequently-used special
       case of ~ latj4 for atoms.  (Contributed by NM, 9-Aug-2012.) $)
    hlatj4 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A )
               /\ ( R e. A /\ S e. A ) )
      -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
         = ( ( P .\/ R ) .\/ ( Q .\/ S ) ) ) $=
      ( chlt wcel wa w3a clat cbs cfv co wceq atbase syl 3ad2ant1 simp2l simp2r
      hllat eqid simp3l simp3r latj4 syl122anc ) GJKZBAKZCAKZLZDAKZEAKZLZMZGNKZ
      BGOPZKZCUSKZDUSKZEUSKZBCFQDEFQFQBDFQCEFQFQRUJUMURUPGUDUAUQUKUTUJUKULUPUBA
      USBGUSUEZISTUQULVAUJUKULUPUCAUSCGVDISTUQUNVBUJUMUNUOUFAUSDGVDISTUQUOVCUJU
      MUNUOUGAUSEGVDISTUSFGEBCDVDHUHUI $.
  $}

  ${
    hlatlej.l $e |- .<_ = ( le ` K ) $.
    hlatlej.j $e |- .\/ = ( join ` K ) $.
    hlatlej.a $e |- A = ( Atoms ` K ) $.
    $( A join's first argument is less than or equal to the join.  Special case
       of ~ latlej1 to show an atom is on a line.  (Contributed by NM,
       15-May-2013.) $)
    hlatlej1 $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
            -> P .<_ ( P .\/ Q ) ) $=
      ( chlt wcel clat cbs cfv co wbr hllat eqid atbase latlej1 syl3an ) EJKELK
      BAKBEMNZKCAKCUBKBBCDOFPEQAUBBEUBRZISAUBCEUCISUBDEFBCUCGHTUA $.

    $( A join's second argument is less than or equal to the join.  Special
       case of ~ latlej2 to show an atom is on a line.  (Contributed by NM,
       15-May-2013.) $)
    hlatlej2 $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
            -> Q .<_ ( P .\/ Q ) ) $=
      ( chlt wcel w3a co wbr hlatlej1 3com23 hlatjcom breqtrrd ) EJKZBAKZCAKZLC
      CBDMZBCDMFSUATCUBFNACBDEFGHIOPADEBCHIQR $.

  $}

  ${
    $d t u v w x y z B $.  $d t u v w y z K $.  $d t u v w x y z ._|_ $.
    $d t u v w x y z S $.
    glbcon.b $e |- B = ( Base ` K ) $.
    glbcon.u $e |- U = ( lub ` K ) $.
    glbcon.g $e |- G = ( glb ` K ) $.
    glbcon.o $e |- ._|_ = ( oc ` K ) $.
    $( De Morgan's law for GLB and LUB. This holds in any complete
       ortholattice, although we assume ` HL ` for convenience.  (Contributed
       by NM, 17-Jan-2012.)  (New usage is discouraged.) $)
    glbconN $p |- ( ( K e. HL /\ S C_ B )
        -> ( G ` S ) = ( ._|_ ` ( U ` { x e. B | ( ._|_ ` x ) e. S } ) ) ) $=
      ( vz vu wcel cfv wceq wbr wral wi wa vy vw vv vt wss chlt cv crab sseqin2
      dfin5 biimpi syl5reqr fveq2d cple crio ssrab2 eqid glbval mpan2 cops wreu
      cin hlop ccla hlclat clatglbcl sylancl eqeltrrd cbs fvex eqeltri riotaclb
      cvv sylibr breq1 ralbidv breq2 anbi12d riotaocN syl2anc ad2antrr sylancom
      imbi2d opoccl wrex opococ eqcomd fveq2 eqeq2d rspcev eleq1 imbi12d adantl
      ralxfrd simpr simplr oplecon3b syl3anc ralbidva bitr4d ralrab weq 3bitr4g
      wb eleq1d ad3antrrr riotabidva lubval eqtr4d 3eqtrd sylan9eqr ) CBUEZFUFN
      ZCEOAUGZCNZABUHZEOZXNGOZCNZABUHZDOZGOZXLCXPEXLXPBCVBZCABCUJXLYCCPCBUIUKUL
      UMXMXQUAUGZLUGZFUNOZQZLXPRZUBUGZYEYFQZLXPRZYIYDYFQZSZUBBRZTZUABUOZUCUGZGO
      ZYEYFQZLXPRZYKYIYRYFQZSZUBBRZTZUCBUOZGOZYBXMXPBUEZXQYPPXOABUPZUALUBUFBXPE
      FYFHYFUQZJURUSZXMFUTNZYOUABVAZYPUUFPFVCZXMYPBNUULXMXQYPBUUJXMFVDNUUGXQBNF
      VEUUHBXPEFHJVFVGVHYOUABBFVIOVMHFVIVJVKVLVNYOUUDUAUCBFGHKYDYRPZYHYTYNUUCUU
      NYGYSLXPYDYRYEYFVOVPUUNYMUUBUBBUUNYLUUAYKYDYRYIYFVQWCVPVRVSVTXMUUEYAGXMUU
      EMUGZYQYFQZMXTRZUUOUDUGZYFQZMXTRZYQUURYFQZSZUDBRZTZUCBUOZYAXMUUDUVDUCBXMY
      QBNZTZYTUUQUUCUVCUVGYECNZYSSZLBRZUUOGOZCNZUUPSZMBRZYTUUQUVGUVJUVLYRUVKYFQ
      ZSZMBRUVNUVGUVIUVPLMUVKBBUVGUUOBNZUUKUVKBNZXMUUKUVFUVQUUMWAZBFGUUOHKWDZWB
      UVGYEBNZTZYEGOZBNZYEUWCGOZPZYEUVKPZMBWEZUVGUWAUUKUWDXMUUKUVFUWAUUMWAZBFGY
      EHKWDZWBUWBUWEYEUVGUWAUUKUWEYEPZUWIBFGYEHKWFZWBWGUWGUWFMUWCBUUOUWCPUVKUWE
      YEUUOUWCGWHWIWJZVTUWGUVIUVPXDUVGUWGUVHUVLYSUVOYEUVKCWKZYEUVKYRYFVQWLWMWNU
      VGUVMUVPMBUVGUVQTZUUPUVOUVLUWOUUKUVQUVFUUPUVOXDUVSUVGUVQWOXMUVFUVQWPBFYFG
      UUOYQHUUIKWQWRWCWSWTXOUVHYSLABXNYECWKZXAXSUVLUUPMABAMXBXRUVKCXNUUOGWHXEZX
      AXCUVGUUCUURGOZYEYFQZLXPRZUWRYRYFQZSZUDBRUVCUVGUUBUXBUBUDUWRBBUVGUURBNZUU
      KUWRBNXMUUKUVFUXCUUMWAZBFGUURHKWDWBUVGYIBNZTZYIGOZBNZYIUXGGOZPZYIUWRPZUDB
      WEUVGUXEUUKUXHXMUUKUVFUXEUUMWAZBFGYIHKWDWBUXFUXIYIUVGUXEUUKUXIYIPUXLBFGYI
      HKWFWBWGUXKUXJUDUXGBUURUXGPUWRUXIYIUURUXGGWHWIWJVTUXKUUBUXBXDUVGUXKYKUWTU
      UAUXAUXKYJUWSLXPYIUWRYEYFVOVPYIUWRYRYFVOWLWMWNUVGUVBUXBUDBUVGUXCTZUUTUWTU
      VAUXAUXMUVLUUSSZMBRZUVHUWSSZLBRZUUTUWTUXMUXOUVLUWRUVKYFQZSZMBRUXQUXMUXNUX
      SMBUXMUVQTZUUSUXRUVLUXTUUKUVQUXCUUSUXRXDXMUUKUVFUXCUVQUUMXFZUXMUVQWOUVGUX
      CUVQWPBFYFGUUOUURHUUIKWQWRWCWSUXMUXPUXSLMUVKBBUXMUVQUUKUVRUYAUVTWBUXMUWAT
      ZUWDUWFUWHUXMUWAUUKUWDXMUUKUVFUXCUWAUUMXFZUWJWBUYBUWEYEUXMUWAUUKUWKUYCUWL
      WBWGUWMVTUWGUXPUXSXDUXMUWGUVHUVLUWSUXRUWNYEUVKUWRYFVQWLWMWNWTXSUVLUUSMABU
      WQXAXOUVHUWSLABUWPXAXCUXMUUKUVFUXCUVAUXAXDUXDXMUVFUXCWPUVGUXCWOBFYFGYQUUR
      HUUIKWQWRWLWSWTVRXGXMXTBUEYAUVEPXSABUPUCMUDUFBXTDFYFHUUIIXHUSXIUMXJXK $.

    $d i B $.  $d x y I $.  $d i K $.  $d i ._|_ $.  $d i x y $.
    $( De Morgan's law for GLB and LUB. Index-set version of ~ glbconN , where
       we read ` S ` as ` S ( i ) ` .  (Contributed by NM, 17-Jan-2012.)
       (New usage is discouraged.) $)
    glbconxN $p |- ( ( K e. HL /\ A. i e. I S e. B )
        -> ( G ` { x | E. i e. I x = S } )
            = ( ._|_ ` ( U ` { x | E. i e. I x = ( ._|_ ` S ) } ) ) ) $=
      ( vy wcel wa wceq wrex cab cfv chlt wral crab wss vex eqeq1 rexbidv nfra1
      cv elab nfv wi rsp eleq1a syl6 rexlimd syl5bi ssrdv glbconN sylan2 wb a1i
      fvex rabbiia df-rab eqtri nfan imp cops opoccl sylan syl pm4.71rd opcon2b
      hlop eqcom syl3an1 3expa syl5rbbr pm5.32da anassrs rexbida r19.42v abbidv
      bitrd syl6rbb cbvabv syl6eq syl5eq fveq2d eqtrd ) HUAOZCBOZEGUBZPZAUIZCQZ
      EGRZASZFTZNUIZITZWSOZNBUCZDTZITZWPCITZQZEGRZASZDTZITWNWLWSBUDWTXFQWNNWSBX
      AWSOXACQZEGRZWNXABOZWRXMAXANUEWPXAQWQXLEGWPXACUFUGUJWNXLXNEGWMEGUHZXNEUKW
      NEUIGOZWMXLXNULWMEGUMZCBXAUNUOUPUQURNBWSDFHIJKLMUSUTWOXEXKIWOXDXJDWOXDXNX
      BCQZEGRZPZNSZXJXDXSNBUCYAXCXSNBXCXSVAXNWRXSAXBXAIVCWPXBQWQXREGWPXBCUFUGUJ
      VBVDXSNBVEVFWOYAXAXGQZEGRZNSXJWOXTYCNWOYCXNXRPZEGRXTWOYBYDEGWLWNEWLEUKXOV
      GWLWNXPYBYDVAZWNXPPWLWMYEWNXPWMXQVHWLWMPZYBXNYBPYDYFYBXNYFXGBOZYBXNULWLHV
      IOZWMYGHVOZBHICJMVJVKXGBXAUNVLVMYFXNYBXRXRCXBQZYFXNPYBCXBVPWLWMXNYJYBVAZW
      LYHWMXNYKYIBHICXAJMVNVQVRVSVTWEUTWAWBXNXREGWCWFWDYCXINAXAWPQYBXHEGXAWPXGU
      FUGWGWHWIWJWJWK $.
  $}

  ${
    atnlej.l $e |- .<_ = ( le ` K ) $.
    atnlej.j $e |- .\/ = ( join ` K ) $.
    atnlej.a $e |- A = ( Atoms ` K ) $.
    $( If an atom is not less than or equal to the join of two others, it is
       not equal to either.  (This also holds for non-atoms, but in this form
       it is convenient.)  (Contributed by NM, 8-Jan-2012.) $)
    atnlej1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
                    /\ -. P .<_ ( Q .\/ R ) ) -> P =/= Q ) $=
      ( chlt wcel w3a co wbr wn clat cbs atbase syl cfv wne hllat 3ad2ant1 eqid
      simp21 simp22 simp23 simp3 latnlej1l syl131anc ) FKLZBALZCALZDALZMZBCDENG
      OPZMZFQLZBFRUAZLZCUTLZDUTLZUQBCUBULUPUSUQFUCUDURUMVAULUMUNUOUQUFAUTBFUTUE
      ZJSTURUNVBULUMUNUOUQUGAUTCFVDJSTURUOVCULUMUNUOUQUHAUTDFVDJSTULUPUQUIUTEFG
      BCDVDHIUJUK $.

    $( If an atom is not less than or equal to the join of two others, it is
       not equal to either.  (This also holds for non-atoms, but in this form
       it is convenient.)  (Contributed by NM, 8-Jan-2012.) $)
    atnlej2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
                    /\ -. P .<_ ( Q .\/ R ) ) -> P =/= R ) $=
      ( chlt wcel w3a co wbr wn clat cbs atbase syl cfv wne hllat 3ad2ant1 eqid
      simp21 simp22 simp23 simp3 latnlej1r syl131anc ) FKLZBALZCALZDALZMZBCDENG
      OPZMZFQLZBFRUAZLZCUTLZDUTLZUQBDUBULUPUSUQFUCUDURUMVAULUMUNUOUQUFAUTBFUTUE
      ZJSTURUNVBULUMUNUOUQUGAUTCFVDJSTURUOVCULUMUNUOUQUHAUTDFVDJSTULUPUQUIUTEFG
      BCDVDHIUJUK $.
  $}

  ${
    $d x y z A $.  $d x y z B $.  $d x y .\/ $.  $d x y z K $.  $d x y .<_ $.
    $d x y z P $.  $d y z Q $.
    hlsuprexch.b $e |- B = ( Base ` K ) $.
    hlsuprexch.l $e |- .<_ = ( le ` K ) $.
    hlsuprexch.j $e |- .\/ = ( join ` K ) $.
    hlsuprexch.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice has the superposition and exchange properties.
       (Contributed by NM, 13-Nov-2011.) $)
    hlsuprexch $p |- ( ( K e. HL /\ P e. A /\ Q e. A ) ->
       ( ( P =/= Q -> E. z e. A ( z =/= P /\ z =/= Q /\ z .<_ ( P .\/ Q ) ) )
            /\ A. z e. B ( ( -. P .<_ z /\ P .<_ ( z .\/ Q ) )
               -> Q .<_ ( z .\/ P ) ) ) ) $=
      ( vx wcel wne co wbr wrex wi wa vy chlt cv w3a wral coml ccla cal cp0 cfv
      cplt cp1 eqid ishlat2 simprl sylbi wceq neeq1 neeq2 oveq1 breq2d 3anbi13d
      rexbidv imbi12d breq1 notbid anbi12d oveq2 ralbidv 3anbi23d anbi2d rspc2v
      wn mpan9 3impb ) GUBNZDBNZEBNZDEOZAUCZDOZVTEOZVTDEFPZHQZUDZABRZSZDVTHQZVM
      ZDVTEFPZHQZTZEVTDFPZHQZSZACUEZTZVPMUCZUAUCZOZVTWROZVTWSOZVTWRWSFPZHQZUDZA
      BRZSZWRVTHQZVMZWRVTWSFPZHQZTZWSVTWRFPZHQZSZACUEZTZUABUEMBUEZVQVRTWQVPGUFN
      GUGNGUHNUDZXRGUIUJZWRGUKUJZQWRWSYAQTWSVTYAQVTGULUJZYAQTTACRUACRMCRZTTXRMU
      AABCYAYBFGHXTIJYAUMKXTUMYBUMLUNXSXRYCUOUPXQWQDWSOZWAXBVTDWSFPZHQZUDZABRZS
      ZWIDXJHQZTZWSWMHQZSZACUEZTMUADEBBWRDUQZXGYIXPYNYOWTYDXFYHWRDWSURYOXEYGABY
      OXAWAXDYFXBWRDVTUSYOXCYEVTHWRDWSFUTVAVBVCVDYOXOYMACYOXLYKXNYLYOXIWIXKYJYO
      XHWHWRDVTHVEVFWRDXJHVEVGYOXMWMWSHWRDVTFVHVAVDVIVGWSEUQZYIWGYNWPYPYDVSYHWF
      WSEDUSYPYGWEABYPXBWBYFWDWAWSEVTUSYPYEWCVTHWSEDFVHVAVJVCVDYPYMWOACYPYKWLYL
      WNYPYJWKWIYPXJWJDHWSEVTFVHVAVKWSEWMHVEVDVIVGVLVNVO $.

    $d z .\/ $.  $d z .<_ $.  $d z X $.
    $( A Hilbert lattice has the exchange property.  (Contributed by NM,
       13-Nov-2011.) $)
    hlexch1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
           /\ -. P .<_ X )
       -> ( P .<_ ( X .\/ Q ) -> Q .<_ ( X .\/ P ) ) ) $=
      ( chlt wcel clc w3a wbr wn co wi hlcvl cvlexch1 syl3an1 ) FMNFONCANDANHBN
      PCHGQRCHDESGQDHCESGQTFUAABCDEFGHIJKLUBUC $.

    $( A Hilbert lattice has the exchange property.  (Contributed by NM,
       6-May-2012.) $)
    hlexch2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
          /\ -. P .<_ X )
       -> ( P .<_ ( Q .\/ X ) -> Q .<_ ( P .\/ X ) ) ) $=
      ( chlt wcel clc w3a wbr wn co wi hlcvl cvlexch2 syl3an1 ) FMNFONCANDANHBN
      PCHGQRCDHESGQDCHESGQTFUAABCDEFGHIJKLUBUC $.

    $( A Hilbert lattice has the exchange property.  (Contributed by NM,
       16-Nov-2011.) $)
    hlexchb1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
    /\ -. P .<_ X )
          -> ( P .<_ ( X .\/ Q ) <-> ( X .\/ P ) = ( X .\/ Q ) ) ) $=
      ( chlt wcel clc w3a wbr wn co wceq wb hlcvl cvlexchb1 syl3an1 ) FMNFONCAN
      DANHBNPCHGQRCHDESZGQHCESUETUAFUBABCDEFGHIJKLUCUD $.

    $( A Hilbert lattice has the exchange property.  (Contributed by NM,
       22-Jun-2012.) $)
    hlexchb2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
    /\ -. P .<_ X )
        -> ( P .<_ ( Q .\/ X ) <-> ( P .\/ X ) = ( Q .\/ X ) ) ) $=
      ( chlt wcel clc w3a wbr wn co wceq wb hlcvl cvlexchb2 syl3an1 ) FMNFONCAN
      DANHBNPCHGQRCDHESZGQCHESUETUAFUBABCDEFGHIJKLUCUD $.
  $}

  ${
    $d r A $.  $d r K $.  $d r P $.  $d r Q $.
    hlsupr.l $e |- .<_ = ( le ` K ) $.
    hlsupr.j $e |- .\/ = ( join ` K ) $.
    hlsupr.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice has the superposition property.  Theorem 13.2 in
       [Crawley] p. 107.  (Contributed by NM, 30-Jan-2012.) $)
    hlsupr $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ P =/= Q )
      -> E. r e. A ( r =/= P /\ r =/= Q /\ r .<_ ( P .\/ Q ) ) ) $=
      ( chlt wcel w3a wne cv co wbr wrex wi wn cbs cfv wral eqid hlsuprexch imp
      wa simpld ) EKLBALCALMZBCNZGOZBNUKCNUKBCDPFQMGARZUIUJULSBUKFQTBUKCDPFQUGC
      UKBDPFQSGEUAUBZUCGAUMBCDEFUMUDHIJUEUHUF $.
  $}

  ${
    $d r A $.  $d r K $.  $d r P $.  $d r Q $.
    hlsupr2.j $e |- .\/ = ( join ` K ) $.
    hlsupr2.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice has the superposition property.  (Contributed by NM,
       25-Nov-2012.) $)
    hlsupr2 $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
      -> E. r e. A ( P .\/ r ) = ( Q .\/ r ) ) $=
      ( chlt wcel w3a cv co wceq wrex wne cple wi wb syl cfv wbr eqid hlsupr ex
      wa clc simpl1 hlcvl simpl2 simpr cvlsupr3 syl13anc rexbidva ne0i 3ad2ant2
      simpl3 c0 r19.37zv bitrd mpbird ) EIJZBAJZCAJZKZBFLZDMCVFDMNZFAOZBCPZVFBP
      VFCPVFBCDMEQUAZUBKZFAOZRZVEVIVLABCDEVJFVJUCZGHUDUEVEVHVIVKRZFAOZVMVEVGVOF
      AVEVFAJZUFZEUGJZVCVDVQVGVOSVRVBVSVBVCVDVQUHEUITVBVCVDVQUJVBVCVDVQUQVEVQUK
      ABCVFDEVJHVNGULUMUNVEAURPZVPVMSVCVBVTVDABUOUPVIVKFAUSTUTVA $.
  $}

  ${
    $d x y z B $.  $d x y z K $.
    hlhgt4.b $e |- B = ( Base ` K ) $.
    hlhgt4.s $e |- .< = ( lt ` K ) $.
    hlhgt4.z $e |- .0. = ( 0. ` K ) $.
    hlhgt4.u $e |- .1. = ( 1. ` K ) $.
    $( A Hilbert lattice has a height of at least 4.  (Contributed by NM,
       4-Dec-2011.) $)
    hlhgt4 $p |- ( K e. HL -> E. x e. B E. y e. B E. z e. B
            ( ( .0. .< x /\ x .< y ) /\ ( y .< z /\ z .< .1. ) ) ) $=
      ( wcel cv wne cfv co wbr wrex wa chlt coml ccla cal w3a cple catm wi wral
      cjn wn eqid ishlat2 simprr sylbi ) GUAMGUBMGUCMGUDMUEZANZBNZOCNZUQOUSUROU
      SUQURGUJPZQGUFPZRUECGUGPZSUHUQUSVARUKUQUSURUTQVARTURUSUQUTQVARUHCDUITBVBU
      IAVBUIZHUQERUQURERTURUSERUSFERTTCDSBDSADSZTTVDABCVBDEFUTGVAHIVAULJUTULKLV
      BULUMUPVCVDUNUO $.

    $d y z .< $.  $d y z .1. $.  $d y z .0. $.
    $( A Hilbert lattice has a height of at least 2.  (Contributed by NM,
       4-Dec-2011.) $)
    hlhgt2 $p |- ( K e. HL -> E. x e. B ( .0. .< x /\ x .< .1. ) ) $=
      ( vy vz wcel cv wbr wa wrex wi ad3antrrr syl chlt hlhgt4 hlpos cops op0cl
      hlop simpllr simplr plttr syl13anc simpr op1cl anim12d rexlimdva reximdva
      cpo mpd ) EUAMZFKNZCOUSANZCOPZUTLNZCOVBDCOPZPZLBQZABQZKBQFUTCOZUTDCOZPZAB
      QZKALBCDEFGHIJUBURVFVJKBURUSBMZPZVEVIABVLUTBMZPZVDVILBVNVBBMZPZVAVGVCVHVP
      EUPMZFBMZVKVMVAVGRURVQVKVMVOEUCSZVPEUDMZVRURVTVKVMVOEUFSZBEFGIUETURVKVMVO
      UGVLVMVOUHZBCEFUSUTGHUIUJVPVQVMVODBMZVCVHRVSWBVNVOUKVPVTWCWABDEGJULTBCEUT
      VBDGHUIUJUMUNUOUNUQ $.
  $}

  ${
    $d x K $.  $d x .< $.  $d x .1. $.  $d x .0. $.
    hl0lt1.s $e |- .< = ( lt ` K ) $.
    hl0lt1.z $e |- .0. = ( 0. ` K ) $.
    hl0lt1.u $e |- .1. = ( 1. ` K ) $.
    $( Lattice 0 is less than lattice 1 in a Hilbert lattice.  (Contributed by
       NM, 4-Dec-2011.)  (New usage is discouraged.) $)
    hl0lt1N $p |- ( K e. HL -> .0. .< .1. ) $=
      ( vx chlt wcel cv wbr wa cbs cfv wrex eqid hlhgt2 adantr syl cpo wi hlpos
      cops hlop op0cl simpr op1cl plttr syl13anc rexlimdva mpd ) CIJZDHKZALUNBA
      LMZHCNOZPDBALZHUPABCDUPQZEFGRUMUOUQHUPUMUNUPJZMZCUAJZDUPJZUSBUPJZUOUQUBUM
      VAUSCUCSUTCUDJZVBUMVDUSCUESZUPCDURFUFTUMUSUGUTVDVCVEUPBCURGUHTUPACDUNBURE
      UIUJUKUL $.
  $}

  ${
    hlexch3.b $e |- B = ( Base ` K ) $.
    hlexch3.l $e |- .<_ = ( le ` K ) $.
    hlexch3.j $e |- .\/ = ( join ` K ) $.
    hlexch3.m $e |- ./\ = ( meet ` K ) $.
    hlexch3.z $e |- .0. = ( 0. ` K ) $.
    hlexch3.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice has the exchange property.  ( ~ atexch analog.)
       (Contributed by NM, 15-Nov-2011.) $)
    hlexch3 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
        /\ ( P ./\ X ) = .0. )
           -> ( P .<_ ( X .\/ Q ) -> Q .<_ ( X .\/ P ) ) ) $=
      ( chlt wcel co wbr clc w3a wceq wi hlcvl cvlexch3 syl3an1 ) FQRFUARCARDAR
      IBRUBCIHSJUCCIDESGTDICESGTUDFUEABCDEFGHIJKLMNOPUFUG $.

    $( A Hilbert lattice has the exchange property.  Part of Definition 7.8 of
       [MaedaMaeda] p. 32.  (Contributed by NM, 15-Nov-2011.)
       (New usage is discouraged.) $)
    hlexch4N $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
       /\ ( P ./\ X ) = .0. )
    -> ( P .<_ ( X .\/ Q ) <-> ( X .\/ P ) = ( X .\/ Q ) ) ) $=
      ( chlt wcel co wceq clc w3a wbr wb hlcvl cvlexch4N syl3an1 ) FQRFUARCARDA
      RIBRUBCIHSJTCIDESZGUCICESUHTUDFUEABCDEFGHIJKLMNOPUFUG $.
  $}

  ${
    hlatexchb.l $e |- .<_ = ( le ` K ) $.
    hlatexchb.j $e |- .\/ = ( join ` K ) $.
    hlatexchb.a $e |- A = ( Atoms ` K ) $.
    $( A version of ~ hlexchb1 for atoms.  (Contributed by NM, 15-Nov-2011.) $)
    hlatexchb1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) /\ P =/= R )
       -> ( P .<_ ( R .\/ Q ) <-> ( R .\/ P ) = ( R .\/ Q ) ) ) $=
      ( chlt wcel clc w3a wne co wbr wceq wb hlcvl cvlatexchb1 syl3an1 ) FKLFML
      BALCALDALNBDOBDCEPZGQDBEPUCRSFTABCDEFGHIJUAUB $.

    $( A version of ~ hlexchb2 for atoms.  (Contributed by NM, 7-Feb-2012.) $)
    hlatexchb2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ P =/= R )
         -> ( P .<_ ( Q .\/ R ) <-> ( P .\/ R ) = ( Q .\/ R ) ) ) $=
      ( chlt wcel clc w3a wne co wbr wceq wb hlcvl cvlatexchb2 syl3an1 ) FKLFML
      BALCALDALNBDOBCDEPZGQBDEPUCRSFTABCDEFGHIJUAUB $.

    $( Atom exchange property.  (Contributed by NM, 7-Jan-2012.) $)
    hlatexch1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ P =/= R ) -> ( P .<_ ( R .\/ Q ) -> Q .<_ ( R .\/ P ) ) ) $=
      ( chlt wcel clc w3a wne co wbr wi hlcvl cvlatexch1 syl3an1 ) FKLFMLBALCAL
      DALNBDOBDCEPGQCDBEPGQRFSABCDEFGHIJTUA $.

    $( Atom exchange property.  (Contributed by NM, 8-Jan-2012.) $)
    hlatexch2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ P =/= R ) -> ( P .<_ ( Q .\/ R ) -> Q .<_ ( P .\/ R ) ) ) $=
      ( chlt wcel clc w3a wne co wbr wi hlcvl cvlatexch2 syl3an1 ) FKLFMLBALCAL
      DALNBDOBCDEPGQCBDEPGQRFSABCDEFGHIJTUA $.
  $}

  ${
    $d x y A $.  $d x y B $.  $d x K $.  $d x y .<_ $.  $d x U $.  $d x y X $.
    hlatmstc.b $e |- B = ( Base ` K ) $.
    hlatmstc.l $e |- .<_ = ( le ` K ) $.
    hlatmstc.u $e |- U = ( lub ` K ) $.
    hlatmstc.a $e |- A = ( Atoms ` K ) $.
    $( An atomic, complete, orthomodular lattice is atomistic i.e. every
       element is the join of the atoms under it.  See remark before
       Proposition 1 in [Kalmbach] p. 140; also remark in
       [BeltramettiCassinelli] p. 98.  ( ~ hatomistici analog.)  (Contributed
       by NM, 21-Oct-2011.)  (New usage is discouraged.) $)
    hlatmstcOLDN $p |- ( ( K e. HL /\ X e. B )
           -> ( U ` { y e. A | y .<_ X } ) = X ) $=
      ( chlt wcel coml ccla cal w3a cv wbr crab wceq hlomcmat atlatmstc sylan
      cfv ) ELMENMEOMEPMQGCMARGFSABTDUEGUAEUBABCDEFGHIJKUCUD $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    hlatle.b $e |- B = ( Base ` K ) $.
    hlatle.l $e |- .<_ = ( le ` K ) $.
    hlatle.a $e |- A = ( Atoms ` K ) $.
    $( The ordering of two Hilbert lattice elements is determined by the atoms
       under them.  ( ~ chrelat3 analog.)  (Contributed by NM, 4-Nov-2011.) $)
    hlatle $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
             -> ( X .<_ Y <-> A. p e. A ( p .<_ X -> p .<_ Y ) ) ) $=
      ( chlt wcel coml ccla cal w3a wbr cv wi wral wb hlomcmat atlatle syl3an1
      ) CKLCMLCNLCOLPEBLFBLEFDQGRZEDQUEFDQSGATUACUBABCDEFGHIJUCUD $.

    $( The equality of two Hilbert lattice elements is determined by the atoms
       under them.  ( ~ chrelat4i analog.)  (Contributed by NM,
       24-May-2012.) $)
    hlateq $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
             -> ( A. p e. A ( p .<_ X <-> p .<_ Y ) <-> X = Y ) ) $=
      ( chlt wcel w3a cv wbr wb wral wa wi hlatle wceq anbi12d ralbiim syl6rbbr
      3com23 clat hllat latasymb syl3an1 bitrd ) CKLZEBLZFBLZMZGNZEDOZUOFDOZPGA
      QZEFDOZFEDOZRZEFUAZUNVAUPUQSGAQZUQUPSGAQZRURUNUSVCUTVDABCDEFGHIJTUKUMULUT
      VDPABCDFEGHIJTUEUBUPUQGAUCUDUKCUFLULUMVAVBPCUGBCDEFHIUHUIUJ $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    hlrelat1.b $e |- B = ( Base ` K ) $.
    hlrelat1.l $e |- .<_ = ( le ` K ) $.
    hlrelat1.s $e |- .< = ( lt ` K ) $.
    hlrelat1.a $e |- A = ( Atoms ` K ) $.
    $( An atomistic lattice with 0 is relatively atomic.  Part of Lemma 7.2 of
       [MaedaMaeda] p. 30.  ( ~ chpssati , with ` /\ ` swapped, analog.)
       (Contributed by NM, 4-Dec-2011.) $)
    hlrelat1 $p |- ( ( K e. HL /\ X e. B /\ Y e. B ) -> ( X .< Y
         -> E. p e. A ( -. p .<_ X /\ p .<_ Y ) ) ) $=
      ( chlt wcel coml ccla cal w3a wbr cv wn wa wi hlomcmat atlrelat1 syl3an1
      wrex ) DMNDONDPNDQNRFBNGBNFGCSHTZFESUAUHGESUBHAUGUCDUDABCDEFGHIJKLUEUF $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    hlrelat5.b $e |- B = ( Base ` K ) $.
    hlrelat5.l $e |- .<_ = ( le ` K ) $.
    hlrelat5.s $e |- .< = ( lt ` K ) $.
    hlrelat5.j $e |- .\/ = ( join ` K ) $.
    hlrelat5.a $e |- A = ( Atoms ` K ) $.
    $( An atomistic lattice with 0 is relatively atomic, using the definition
       in Remark 2 of [Kalmbach] p. 149.  (Contributed by NM, 21-Oct-2011.)
       (New usage is discouraged.) $)
    hlrelat5N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X .< Y )
         -> E. p e. A ( X .< ( X .\/ p ) /\ p .<_ Y ) ) $=
      ( wcel w3a wbr wa wb bitr4d chlt cv co wrex wn hlrelat1 imp clat hllat id
      atbase wne cvv ovex a1i pltval syl3an3 latlej1 biantrurd latleeqj1 3com23
      wceq latjcom eqeq1d notbid necom df-ne bitri syl3an 3expa anbi1d rexbidva
      syl6bbr 3adant3 adantr mpbird ) EUAOZGBOZHBOZPZGHCQZRGGIUBZDUCZCQZWBHFQZR
      ZIAUDZWBGFQZUEZWERZIAUDZVTWAWKABCEFGHIJKLNUFUGVTWGWKSZWAVQVRWLVSVQVRRZWFW
      JIAWMWBAOZRWDWIWEVQVRWNWDWISZVQEUHOZVRVRWNWBBOZWOEUIVRUJABWBEJNUKWPVRWQPZ
      WDGWCULZWIWRWDGWCFQZWSRZWSWQWPVRWCUMOZWDXASXBWQGWBDUNUOUHBUMCEFGWCKLUPUQW
      RWTWSBDEFGWBJKMURUSTWRWIWCGVBZUEZWSWRWHXCWRWHWBGDUCZGVBZXCWPWQVRWHXFSBDEF
      WBGJKMUTVAWRWCXEGBDEGWBJMVCVDTVEWSWCGULXDGWCVFWCGVGVHVMTVIVJVKVLVNVOVP $.

    $d p .< $.
    $( A Hilbert lattice is relatively atomic.  Remark 2 of [Kalmbach] p. 149.
       ( ~ chrelati analog.)  (Contributed by NM, 4-Feb-2012.) $)
    hlrelat $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X .< Y )
         -> E. p e. A ( X .< ( X .\/ p ) /\ ( X .\/ p ) .<_ Y ) ) $=
      ( chlt wcel wbr wa wrex imp w3a cv wn co hlrelat1 clat wb simpll1 simpll2
      hllat syl atbase adantl latnle syl3anc adantr biantrurd latjle12 syl13anc
      pltle simpll3 bitrd anbi12d rexbidva mpbid ) EOPZGBPZHBPZUAZGHCQZRZIUBZGF
      QUCZVLHFQZRZIASZGGVLDUDZCQZVQHFQZRZIASVIVJVPABCEFGHIJKLNUETVKVOVTIAVKVLAP
      ZRZVMVRVNVSWBEUFPZVGVLBPZVMVRUGWBVFWCVFVGVHVJWAUHEUJUKZVFVGVHVJWAUIZWAWDV
      KABVLEJNULUMZBCDEFGVLJKLMUNUOWBVNGHFQZVNRZVSWBWHVNVKWHWAVIVJWHOBBCEFGHKLU
      TTUPUQWBWCVGWDVHWIVSUGWEWFWGVFVGVHVJWAVABDEFGVLHJKMURUSVBVCVDVE $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    hlrelat2.b $e |- B = ( Base ` K ) $.
    hlrelat2.l $e |- .<_ = ( le ` K ) $.
    hlrelat2.a $e |- A = ( Atoms ` K ) $.
    $( A consequence of relative atomicity.  ( ~ chrelat2i analog.)
       (Contributed by NM, 5-Feb-2012.) $)
    hlrelat2 $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
            -> ( -. X .<_ Y <-> E. p e. A ( p .<_ X /\ -. p .<_ Y ) ) ) $=
      ( wcel w3a wbr wn wa cfv wb eqid wi syl13anc chlt cv wrex cmee cplt hllat
      co latnlemlt syl3an1 cjn simp1 latmcl simp2 hlrelat ex syl3anc simpl1 syl
      clat adantr atbase adantl simpl2 latjle12 syl6bir adantld simpl3 latlem12
      simpr notbid latnle bitrd anbi12d pm3.21 orcom pm4.55 imor 3bitr4ri sylib
      wo con2i adantrl jcad reximdva syld wral lattr exp4b com34 com23 ralrimdv
      sylbid iman ralbii ralnex bitri syl6ib con2d impbid ) CUAKZEBKZFBKZLZEFDM
      ZNZGUBZEDMZXFFDMZNZOZGAUCZXCXEEFCUDPZUGZECUEPZMZXKWTCUSKZXAXBXEXOQCUFZBXN
      CDXLEFHIXNRZXLRZUHUIXCXOXMXMXFCUJPZUGZXNMZYAEDMZOZGAUCZXKXCWTXMBKZXAXOYES
      WTXAXBUKWTXPXAXBYFXQBCXLEFHXSULUIZWTXAXBUMWTYFXALXOYEABXNXTCDXMEGHIXRXTRZ
      JUNUOUPXCYDXJGAXCXFAKZOZYDXGXIYJYCXGYBYJYCXMEDMZXGOZXGYJXPYFXFBKZXAYLYCQY
      JWTXPWTXAXBYIUQXQURZXCYFYIYGUTZYIYMXCABXFCHJVAVBZWTXAXBYIVCZBXTCDXMXFEHIY
      HVDTZYKXGVIVEVFYJYDXGXHOZNZYLOXIYJYTYBYLYCYJYTXFXMDMZNZYBYJYSUUAYJXPYMXAX
      BYSUUAQYNYPYQWTXAXBYIVGZBCDXLXFEFHIXSVHTVJYJXPYFYMUUBYBQYNYOYPBXNXTCDXMXF
      HIXRYHVKUPVLYRVMYTXGXIYKXHYTXGOZXHXGYSSZUUDNZXHXGVNYSXGNZVTUUGYSVTUUFUUEY
      SUUGVOYSXGVPXGYSVQVRVSWAWBVEWCWDWEWLXCXDXKXCXDXGXHSZGAWFZXKNZXCXDUUHGAXCY
      IXDUUHXCYIXGXDXHXCYIXGXDXHYJXPYMXAXBXGXDOXHSYNYPYQUUCBCDXFEFHIWGTWHWIWJWK
      UUIXJNZGAWFUUJUUHUUKGAXGXHWMWNXJGAWOWPWQWRWS $.
  $}

  ${
    atomle.b $e |- B = ( Base ` K ) $.
    atomle.l $e |- .<_ = ( le ` K ) $.
    atomle.j $e |- .\/ = ( join ` K ) $.
    atomle.a $e |- A = ( Atoms ` K ) $.
    $( A condition for an atom to be less than or equal to a lattice element.
       Part of proof of Lemma A in [Crawley] p. 112.  (Contributed by NM,
       28-Apr-2012.)  (New usage is discouraged.) $)
    exatleN $p |- ( ( ( K e. HL /\ X e. B ) /\ ( P e. A /\ Q e. A /\ R e. A )
     /\ ( P .<_ X /\ -. Q .<_ X /\ R .<_ ( P .\/ Q ) ) )
  -> ( R .<_ X <-> R = P ) ) $=
      ( wcel wa w3a wbr wn syl atbase chlt co wceq simpl32 clat simp11l simp122
      hllat simp121 simp123 latjcl syl3anc simp11r 3jca simp2 simp133 hlatexch1
      wne sylc simp131 simp3 wb latjle12 syl13anc mpbi2and lattrd mtod necon4ad
      3expia ex simp31 breq1 syl5ibrcom impbid ) GUANZIBNZOZCANZDANZEANZPZCIHQZ
      DIHQZRZECDFUBHQZPZPZEIHQZECUCZWGWHECWGECURZWHRWGWJOWHWCWBWDWEVQWAWJUDWGWJ
      WHWCWGWJWHPZBGHDCEFUBZIJKWKVOGUENZVOVPWAWFWJWHUFZGUHSZWKVSDBNVRVSVTVQWFWJ
      WHUGZABDGJMTSWKWMCBNZEBNZWLBNWOWKVRWQVRVSVTVQWFWJWHUIZABCGJMTSZWKVTWRVRVS
      VTVQWFWJWHUJZABEGJMTSZBFGCEJLUKULVOVPWAWFWJWHUMZWKVOVTVSVRPZWJPWEDWLHQWKV
      OXDWJWNWKVTVSVRXAWPWSUNWGWJWHUOUNWBWDWEVQWAWJWHUPAEDCFGHKLMUQUSWKWBWHWLIH
      QZWBWDWEVQWAWJWHUTWGWJWHVAWKWMWQWRVPWBWHOXEVBWOWTXBXCBFGHCEIJKLVCVDVEVFVI
      VGVJVHWGWHWIWBVQWAWBWDWEVKECIHVLVMVN $.
  $}

  ${
    $d p q x A $.  $d p q x K $.
    hl2atom.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice has at least 2 atoms.  (Contributed by NM,
       5-Dec-2011.) $)
    hl2at $p |- ( K e. HL -> E. p e. A E. q e. A p =/= q ) $=
      ( vx chlt wcel cp0 cfv cv wbr wa wrex eqid wn wi syl hlrelat1 reximi cplt
      cp1 cbs wne hlhgt2 cple simpl cops hlop op0cl simpr syl3anc op1cl mpd3an3
      adantr anim12d reeanv nbrne2 ad2ant2lr sylbir syl6 rexlimdva mpd ) BGHZBI
      JZFKZBUAJZLZVFBUBJZVGLZMZFBUCJZNDKZCKZUDZCANZDANZFVLVGVIBVEVLOZVGOZVEOZVI
      OZUEVDVKVQFVLVDVFVLHZMZVKVMVEBUFJZLPZVMVFWDLZMZDANZVNVFWDLPZVNVIWDLZMZCAN
      ZMZVQWCVHWHVJWLWCVDVEVLHZWBVHWHQVDWBUGWCBUHHZWNVDWOWBBUIUOZVLBVEVRVTUJRVD
      WBUKAVLVGBWDVEVFDVRWDOZVSESULVDWBVIVLHZVJWLQWCWOWRWPVLVIBVRWAUMRAVLVGBWDV
      FVICVRWQVSESUNUPWMWGWKMZCANZDANVQWGWKDCAAUQWTVPDAWSVOCAWFWIVOWEWJVMVNVFWD
      URUSTTUTVAVBVC $.
  $}

  ${
    $d p q A $.  $d p q K $.
    atex.1 $e |- A = ( Atoms ` K ) $.
    $( At least one atom exists.  (Contributed by NM, 15-Jul-2012.) $)
    atex $p |- ( K e. HL -> A =/= (/) ) $=
      ( vp vq chlt wcel cv wex c0 wne wrex hl2at wa df-rex exsimpl sylbi syl n0
      sylibr ) BFGZDHZAGZDIZAJKUAUBEHKEALZDALZUDABEDCMUFUCUENDIUDUEDAOUCUEDPQRD
      AST $.
  $}

  ${
    intnat.b $e |- B = ( Base ` K ) $.
    intnat.l $e |- .<_ = ( le ` K ) $.
    intnat.m $e |- ./\ = ( meet ` K ) $.
    intnat.a $e |- A = ( Atoms ` K ) $.
    $( If the intersection with a non-majorizing element is an atom, the
       intersecting element is not an atom.  (Contributed by NM, 26-Jun-2012.)
       (New usage is discouraged.) $)
    intnatN $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
        /\ ( -. Y .<_ X /\ ( X ./\ Y ) e. A ) ) -> -. Y e. A ) $=
      ( chlt wcel wn co wa ex wceq syl syl3anc w3a wbr cp0 cfv wne cal 3ad2ant1
      hlatl ad2antrr eqid sylancom simpll1 hllat simpll2 simpll3 latmcom simplr
      atn0 clat wb simpr atnle mpbid eqtrd necon3ad syld impr ) CLMZFBMZGBMZUAZ
      GFDUBNZFGEOZAMZGAMZNZVKVLPZVNVMCUCUDZUEZVPVQVNVSVQVNCUFMZVSVKVTVLVNVHVIVT
      VJCUHZUGUIAVMCVRVRUJZKURUKQVQVOVMVRVQVOVMVRRVQVOPZVMGFEOZVRWCCUSMZVIVJVMW
      DRWCVHWEVHVIVJVLVOULZCUMSVHVIVJVLVOUNZVHVIVJVLVOUOBCEFGHJUPTWCVLWDVRRZVKV
      LVOUQWCVTVOVIVLWHUTWCVHVTWFWASVQVOVAWGABGCDEFVRHIJWBKVBTVCVDQVEVFVG $.
  $}

  ${
    2lnne.l $e |- .<_ = ( le ` K ) $.
    2lnne.j $e |- .\/ = ( join ` K ) $.
    2lnne.a $e |- A = ( Atoms ` K ) $.
    $( Condition implying that two intersecting lines are different.
       (Contributed by NM, 13-Jun-2012.)  (New usage is discouraged.) $)
    2llnne2N $p |- ( ( K e. HL /\ ( P e. A /\ R e. A ) /\
       -. P .<_ ( R .\/ Q ) ) -> ( R .\/ P ) =/= ( R .\/ Q ) ) $=
      ( chlt wcel wa co wbr wn wne wceq simpl simprr hlatlej2 syl3anc syl5ibcom
      simprl breq2 necon3bd 3impia ) FKLZBALZDALZMZBDCENZGOZPDBENZULQUHUKMZUMUN
      ULUOBUNGOZUNULRUMUOUHUJUIUPUHUKSUHUIUJTUHUIUJUDADBEFGHIJUAUBUNULBGUEUCUFU
      G $.

    $( Condition implying that two intersecting lines are different.
       (Contributed by NM, 29-May-2012.)  (New usage is discouraged.) $)
    2llnneN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) /\
  ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> ( R .\/ P ) =/= ( R .\/ Q ) ) $=
      ( chlt wcel w3a wne co wbr wn simp21 simp23 wi simp1 simp22 3jca syld3an2
      wa hlatexch2 con3d 3exp imp4a 3imp 2llnne2N syl121anc ) FKLZBALZCALZDALZM
      ZBCNZDBCEOGPZQZUEZMUMUNUPBDCEOZGPZQZDBEOVBNUMUQVAUAUMUNUOUPVARUMUNUOUPVAS
      UMUQVAVDUMUQURUTVDUMUQURUTVDTUMUQURMZVCUSUMUNUPUOMUQURVCUSTVEUNUPUOUMUNUO
      UPURRUMUNUOUPURSUMUNUOUPURUBUCABDCEFGHIJUFUDUGUHUIUJABCDEFGHIJUKUL $.
  $}

  ${
    $d q z A $.  $d q z B $.  $d q z .\/ $.  $d q z K $.  $d q z .<_ $.
    $d q z X $.  $d q z P $.
    cvr1.b $e |- B = ( Base ` K ) $.
    cvr1.l $e |- .<_ = ( le ` K ) $.
    cvr1.j $e |- .\/ = ( join ` K ) $.
    cvr1.c $e |- C = ( <o ` K ) $.
    cvr1.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice has the covering property.  Proposition 1(ii) in
       [Kalmbach] p. 140 (and its converse).  ( ~ chcv1 analog.)  (Contributed
       by NM, 17-Nov-2011.) $)
    cvr1 $p |- ( ( K e. HL /\ X e. B /\ P e. A )
      -> ( -. P .<_ X <-> X C ( X .\/ P ) ) ) $=
      ( chlt wcel coml ccla clc w3a wbr wn co wb hlomcmcv cvlcvr1 syl3an1 ) FNO
      FPOFQOFROSHBODAODHGTUAHHDEUBCTUCFUDABCDEFGHIJKLMUEUF $.
  $}

  ${
    cvr2.b $e |- B = ( Base ` K ) $.
    cvr2.s $e |- .< = ( lt ` K ) $.
    cvr2.j $e |- .\/ = ( join ` K ) $.
    cvr2.c $e |- C = ( <o ` K ) $.
    cvr2.a $e |- A = ( Atoms ` K ) $.
    $( Less-than and covers equivalence in a Hilbert lattice.  ( ~ chcv2
       analog.)  (Contributed by NM, 7-Feb-2012.)
       (New usage is discouraged.) $)
    cvr2N $p |- ( ( K e. HL /\ X e. B /\ P e. A )
      -> ( X .< ( X .\/ P ) <-> X C ( X .\/ P ) ) ) $=
      ( chlt wcel w3a cple cfv wbr wn co clat wb hllat 3ad2ant1 atbase 3ad2ant3
      simp2 eqid latnle syl3anc cvr1 bitr3d ) GNOZHBOZDAOZPZDHGQRZSTZHHDFUAZESZ
      HUTCSUQGUBOZUODBOZUSVAUCUNUOVBUPGUDUEUNUOUPUHUPUNVCUOABDGIMUFUGBEFGURHDIU
      RUIZJKUJUKABCDFGURHIVDKLMULUM $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p .< $.  $d p X $.
    $d p Y $.
    hlrelat3.b $e |- B = ( Base ` K ) $.
    hlrelat3.l $e |- .<_ = ( le ` K ) $.
    hlrelat3.s $e |- .< = ( lt ` K ) $.
    hlrelat3.j $e |- .\/ = ( join ` K ) $.
    hlrelat3.c $e |- C = ( <o ` K ) $.
    hlrelat3.a $e |- A = ( Atoms ` K ) $.
    $( The Hilbert lattice is relatively atomic.  Stronger version of
       ~ hlrelat .  (Contributed by NM, 2-May-2012.) $)
    hlrelat3 $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X .< Y )
         -> E. p e. A ( X C ( X .\/ p ) /\ ( X .\/ p ) .<_ Y ) ) $=
      ( chlt wcel wbr wa w3a cv wn wrex co hlrelat1 imp simp3l wb simp1l1 simp2
      simp1l2 cvr1 syl3anc mpbid simp1l simp1r pltle sylc simp3r clat hllat syl
      atbase simp1l3 latjle12 syl13anc mpbi2and jca 3exp reximdvai mpd ) FQRZHB
      RZIBRZUAZHIDSZTZJUBZHGSUCZVSIGSZTZJAUDZHHVSEUEZCSZWDIGSZTZJAUDVPVQWCABDFG
      HIJKLMPUFUGVRWBWGJAVRVSARZWBWGVRWHWBUAZWEWFWIVTWEVRWHVTWAUHWIVMVNWHVTWEUI
      VMVNVOVQWHWBUJZVMVNVOVQWHWBULZVRWHWBUKZABCVSEFGHKLNOPUMUNUOWIHIGSZWAWFWIV
      PVQWMVPVQWHWBUPVPVQWHWBUQQBBDFGHILMURUSVRWHVTWAUTWIFVARZVNVSBRZVOWMWATWFU
      IWIVMWNWJFVBVCWKWIWHWOWLABVSFKPVDVCVMVNVOVQWHWBVEBEFGHVSIKLNVFVGVHVIVJVKV
      L $.
  $}

  ${
    $d p A $.  $d p B $.  $d p C $.  $d p K $.  $d p .<_ $.  $d p X $.
    $d p Y $.
    cvrval3.b $e |- B = ( Base ` K ) $.
    cvrval3.l $e |- .<_ = ( le ` K ) $.
    cvrval3.j $e |- .\/ = ( join ` K ) $.
    cvrval3.c $e |- C = ( <o ` K ) $.
    cvrval3.a $e |- A = ( Atoms ` K ) $.
    $( Binary relation expressing ` Y ` covers ` X ` .  (Contributed by NM,
       16-Jun-2012.) $)
    cvrval3 $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
     -> ( X C Y <-> E. p e. A ( -. p .<_ X /\ ( X .\/ p ) = Y ) ) ) $=
      ( chlt wcel w3a wbr wa syl3anc cv wn co wceq wrex cplt cfv cvrlt hlrelat3
      eqid syldan simp3l wb simp1l1 simp1l2 simp2 cvr1 mpbird clat hllat atbase
      syl 3ad2ant2 latjcl syl31anc simp3r cpo hlpos simp1l3 cvrnbtwn2 syl131anc
      simp1r mpbi2and jca 3exp reximdvai mpd ex simp11 mpbid breqtrd rexlimdv3a
      simp12 impbid ) EOPZGBPZHBPZQZGHCRZIUAZGFRUBZGWJDUCZHUDZSZIAUEZWHWIWOWHWI
      SZGWLCRZWLHFRZSZIAUEZWOWHWIGHEUFUGZRWTOBCXAEGHJXAUJZMUHABCXADEFGHIJKXBLMN
      UIUKWPWSWNIAWPWJAPZWSWNWPXCWSQZWKWMXDWKWQWPXCWQWRULZXDWEWFXCWKWQUMZWEWFWG
      WIXCWSUNZWEWFWGWIXCWSUOZWPXCWSUPABCWJDEFGJKLMNUQZTURXDGWLXARZWRWMXDWEWFWL
      BPZWQXJXGXHXDEUSPZWFWJBPZXKXDWEXLXGEUTVBXHXCWPXMWSABWJEJNVAVCBDEGWJJLVDTZ
      XEOBCXAEGWLJXBMUHVEWPXCWQWRVFXDEVGPZWFWGXKWIXJWRSWMUMXDWEXOXGEVHVBXHWEWFW
      GWIXCWSVIXNWHWIXCWSVLBCXAEFGHWLJKXBMVJVKVMVNVOVPVQVRWHWNWIIAWHXCWNQZGWLHC
      XPWKWQWHXCWKWMULXPWEWFXCXFWEWFWGXCWNVSWEWFWGXCWNWCWHXCWNUPXITVTWHXCWKWMVF
      WAWBWD $.
  $}

  ${
    $d p .< $.  $d p A $.  $d p B $.  $d p C $.  $d p K $.  $d p X $.
    $d p Y $.
    cvrval4.b $e |- B = ( Base ` K ) $.
    cvrval4.s $e |- .< = ( lt ` K ) $.
    cvrval4.j $e |- .\/ = ( join ` K ) $.
    cvrval4.c $e |- C = ( <o ` K ) $.
    cvrval4.a $e |- A = ( Atoms ` K ) $.
    $( Binary relation expressing ` Y ` covers ` X ` .  (Contributed by NM,
       16-Jun-2012.)  (New usage is discouraged.) $)
    cvrval4N $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
     -> ( X C Y <-> ( X .< Y /\ E. p e. A ( X .\/ p ) = Y ) ) ) $=
      ( chlt wcel w3a wbr wrex wa cv co wceq cvrlt cple cfv eqid cvrval3 reximi
      wn simpr syl6bi imp jca ex simp1r simp3 breqtrrd wb simp1l1 simp1l2 simp2
      cvr1 syl3anc cvr2N bitr4d mpbird 3exp reximdvai expimpd sylibrd impbid )
      FOPZGBPZHBPZQZGHCRZGHDRZGIUAZEUBZHUCZIASZTZVPVQWCVPVQTVRWBOBCDFGHJKMUDVPV
      QWBVPVQVSGFUEUFZRUJZWATZIASZWBABCEFWDGHIJWDUGZLMNUHZWFWAIAWEWAUKUIULUMUNU
      OVPWCWGVQVPVRWBWGVPVRTZWAWFIAWJVSAPZWAWFWJWKWAQZWEWAWLWEGVTDRZWLGHVTDVPVR
      WKWAUPWJWKWAUQZURWLWEGVTCRZWMWLVMVNWKWEWOUSVMVNVOVRWKWAUTZVMVNVOVRWKWAVAZ
      WJWKWAVBZABCVSEFWDGJWHLMNVCVDWLVMVNWKWMWOUSWPWQWRABCVSDEFGJKLMNVEVDVFVGWN
      UNVHVIVJWIVKVL $.
  $}

  ${
    $d p A $.  $d p B $.  $d p C $.  $d p K $.  $d p .<_ $.  $d p ./\ $.
    $d p X $.  $d p Y $.
    cvrval5.b $e |- B = ( Base ` K ) $.
    cvrval5.l $e |- .<_ = ( le ` K ) $.
    cvrval5.j $e |- .\/ = ( join ` K ) $.
    cvrval5.m $e |- ./\ = ( meet ` K ) $.
    cvrval5.c $e |- C = ( <o ` K ) $.
    cvrval5.a $e |- A = ( Atoms ` K ) $.
    $( Binary relation expressing ` X ` covers ` X ./\ Y ` .  (Contributed by
       NM, 7-Dec-2012.) $)
    cvrval5 $p |- ( ( K e. HL /\ X e. B /\ Y e. B ) -> ( ( X ./\ Y ) C X
         <-> E. p e. A ( -. p .<_ Y /\ ( p .\/ ( X ./\ Y ) ) = X ) ) ) $=
      ( wcel co wbr wa chlt w3a cv wn wceq wrex simp1 clat hllat latmcl syl3an1
      wb simp2 cvrval3 syl3anc 3ad2ant1 ad2antrr ad2antlr latlej2 simpr breqtrd
      atbase biantrurd simpll2 simpll3 latlem12 syl13anc bitr2d notbid pm5.32rd
      ex adantr adantl latjcom eqeq1d anbi2d bitrd rexbidva ) EUAQZHBQZIBQZUBZH
      IGRZHCSZJUCZWCFSZUDZWCWEDRZHUEZTZJAUFZWEIFSZUDZWEWCDRZHUEZTZJAUFWBVSWCBQZ
      VTWDWKULVSVTWAUGVSEUHQZVTWAWQEUIZBEGHIKNUJUKZVSVTWAUMABCDEFWCHJKLMOPUNUOW
      BWJWPJAWBWEAQZTZWJWMWITWPXBWIWGWMXBWIWGWMULXBWITZWFWLXCWLWEHFSZWLTZWFXCXD
      WLXCWEWHHFXCWRWQWEBQZWEWHFSWBWRXAWIVSVTWRWAWSUPZUQZWBWQXAWIWTUQXAXFWBWIAB
      WEEKPVBZURZBDEFWCWEKLMUSUOXBWIUTVAVCXCWRXFVTWAXEWFULXHXJVSVTWAXAWIVDVSVTW
      AXAWIVEBEFGWEHIKLNVFVGVHVIVKVJXBWIWOWMXBWHWNHXBWRWQXFWHWNUEWBWRXAXGVLWBWQ
      XAWTVLXAXFWBXIVMBDEWCWEKMVNUOVOVPVQVRVQ $.
  $}

  ${
    cvrp.b $e |- B = ( Base ` K ) $.
    cvrp.j $e |- .\/ = ( join ` K ) $.
    cvrp.m $e |- ./\ = ( meet ` K ) $.
    cvrp.z $e |- .0. = ( 0. ` K ) $.
    cvrp.c $e |- C = ( <o ` K ) $.
    cvrp.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice satisfies the covering property of Definition 7.4 of
       [MaedaMaeda] p. 31 and its converse.  ( ~ cvp analog.)  (Contributed by
       NM, 18-Nov-2011.) $)
    cvrp $p |- ( ( K e. HL /\ X e. B /\ P e. A )
      -> ( ( X ./\ P ) = .0. <-> X C ( X .\/ P ) ) ) $=
      ( chlt wcel coml ccla co clc w3a wceq wbr wb hlomcmcv cvlcvrp syl3an1 ) F
      PQFRQFSQFUAQUBHBQDAQHDGTIUCHHDETCUDUEFUFABCDEFGHIJKLMNOUGUH $.
  $}

  ${
    atcvr1.j $e |- .\/ = ( join ` K ) $.
    atcvr1.c $e |- C = ( <o ` K ) $.
    atcvr1.a $e |- A = ( Atoms ` K ) $.
    $( An atom is covered by its join with a different atom.  (Contributed by
       NM, 7-Feb-2012.) $)
    atcvr1 $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
      -> ( P =/= Q <-> P C ( P .\/ Q ) ) ) $=
      ( chlt wcel coml ccla clc w3a wne co wbr wb hlomcmcv cvlatcvr1 syl3an1 )
      FJKFLKFMKFNKOCAKDAKCDPCCDEQBRSFTABCDEFGHIUAUB $.

    $( An atom is covered by its join with a different atom.  (Contributed by
       NM, 7-Feb-2012.) $)
    atcvr2 $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
      -> ( P =/= Q <-> P C ( Q .\/ P ) ) ) $=
      ( chlt wcel coml ccla clc w3a wne co wbr wb hlomcmcv cvlatcvr2 syl3an1 )
      FJKFLKFMKFNKOCAKDAKCDPCDCEQBRSFTABCDEFGHIUAUB $.
  $}

  ${
    $d p B $.  $d p C $.  $d p .\/ $.  $d p K $.  $d p ./\ $.  $d p X $.
    $d p Y $.
    cvrexch.b $e |- B = ( Base ` K ) $.
    cvrexch.j $e |- .\/ = ( join ` K ) $.
    cvrexch.m $e |- ./\ = ( meet ` K ) $.
    cvrexch.c $e |- C = ( <o ` K ) $.
    $( Lemma for ~ cvrexch .  ( ~ cvexchlem analog.)  (Contributed by NM,
       18-Nov-2011.) $)
    cvrexchlem $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
               -> ( ( X ./\ Y ) C Y -> X C ( X .\/ Y ) ) ) $=
      ( vp wcel w3a co wbr wa wi syl3anc wceq chlt cple cfv catm wrex cplt clat
      cv wn hllat latmcl syl3an1 eqid cvrlt ex syld3an2 hlrelat1 syld wb simpl1
      atbase adantl simpl2 simpl3 latlem12 syl13anc biimpd exp3acom23 con3 syl6
      imp syl com23 a1d imp4d simpr sylibd latjass latabs1 adantr oveq1d eqtr3d
      cvr1 latnle latmle2 biantrurd latjle12 bitrd anbi12d cpo latjcl cvrnbtwn2
      hlpos 3jca 3exp sylc sylbid imp32 oveq2d sylanl2 expr an32s rexlimdva mpd
      breqtrd ) DUAMZFAMZGAMZNZFGEOZGBPZFFGCOZBPZXIXKQZLUHZXJDUBUCZPZUIZXOGXPPZ
      QZLDUDUCZUEZXMXIXKYBXIXKXJGDUFUCZPZYBXFXJAMZXGXHXKYDRXFDUGMZXGXHYEDUJZADE
      FGHJUKZULZXFYEXHNXKYDUAABYCDXJGHYCUMZKUNUOUPXFYEXGXHYDYBRYIYAAYCDXPXJGLHX
      PUMZYJYAUMZUQUPURVKXNXTXMLYAXIXOYAMZXKXTXMRXIYMQZXKXTXMYNXKXTQZQFFXOCOZXL
      BYNYOFYPBPZYNYOXOFXPPZUIZYQYNXKXRXSYSYNXRXSYSRRXKYNXSXRYSYNXSYRXQRXRYSRYN
      YRXSXQYNYRXSQZXQYNYFXOAMZXGXHYTXQUSYNXFYFXFXGXHYMUTZYGVLYMUUAXIYAAXODHYLV
      AZVBXFXGXHYMVCZXFXGXHYMVDADXPEXOFGHYKJVEVFVGVHYRXQVIVJVMVNVOYNXFXGYMYSYQU
      SUUBUUDXIYMVPYAABXOCDXPFHYKIKYLWCSVQVKYMXIUUAYOYPXLTUUCXIUUAQZYOQZFXJXOCO
      ZCOZYPXLUUEUUHYPTYOUUEFXJCOZXOCOZUUHYPUUEYFXGYEUUAUUJUUHTUUEXFYFXFXGXHUUA
      UTZYGVLZXFXGXHUUAVCZUUEYFXGXHYEUULUUMXFXGXHUUAVDZYHSZXIUUAVPZACDFXJXOHIVR
      VFUUEUUIFXOCXIUUIFTZUUAXFYFXGXHUUQYGACDEFGHIJVSULVTWAWBVTUUFUUGGFCUUEXKXT
      UUGGTZUUEXTXKUURUUEXTXJUUGYCPZUUGGXPPZQZXKUURRUUEXRUUSXSUUTUUEYFYEUUAXRUU
      SUSUULUUOUUPAYCCDXPXJXOHYKYJIWDSUUEXSXJGXPPZXSQZUUTUUEUVBXSUUEYFXGXHUVBUU
      LUUMUUNADXPEFGHYKJWESWFUUEYFYEUUAXHUVCUUTUSUULUUOUUPUUNACDXPXJXOGHYKIWGVF
      WHWIUUEXKUVAUURUUEDWJMZYEXHUUGAMZNZXKUVAUURRZRUUEXFUVDUUKDWMVLUUEYEXHUVEU
      UOUUNUUEYFYEUUAUVEUULUUOUUPACDXJXOHIWKSWNUVDUVFXKUVGUVDUVFXKNUVAUURABYCDX
      PXJGUUGHYKYJKWLVGWOWPVMWQVMWRWSWBWTXEXAXBXCXDUO $.

    $( A Hilbert lattice satisfies the exchange axiom.  Proposition 1(iii) of
       [Kalmbach] p. 140 and its converse.  Originally proved by Garrett
       Birkhoff in 1933.  ( ~ cvexchi analog.)  (Contributed by NM,
       18-Nov-2011.) $)
    cvrexch $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
               -> ( ( X ./\ Y ) C Y <-> X C ( X .\/ Y ) ) ) $=
      ( wcel co wbr cvrexchlem cfv 3ad2ant1 syl3anc wceq syl3an1 chlt w3a simp1
      coc wi cops hlop simp3 eqid opoccl syl2anc simp2 hlol oldmj1 clat latmcom
      col hllat eqtrd breq1d oldmm1 latjcom breq2d 3imtr4d latjcl latmcl impbid
      wb cvrcon3b ) DUALZFALZGALZUBZFGEMZGBNZFFGCMZBNZABCDEFGHIJKOVMVPDUDPZPZFV
      RPZBNZGVRPZVNVRPZBNZVQVOVMWBVTEMZVTBNZWBWBVTCMZBNZWAWDVMVJWBALZVTALZWFWHU
      EVJVKVLUCVMDUFLZVLWIVJVKWKVLDUGQZVJVKVLUHZADVRGHVRUIZUJUKZVMWKVKWJWLVJVKV
      LULZADVRFHWNUJUKZABCDEWBVTHIJKORVMVSWEVTBVMVSVTWBEMZWEVJDUQLZVKVLVSWRSDUM
      ZACDEVRFGHIJWNUNTVMDUOLZWJWIWRWESVJVKXAVLDURZQZWQWOADEVTWBHJUPRUSUTVMWCWG
      WBBVMWCVTWBCMZWGVJWSVKVLWCXDSWTACDEVRFGHIJWNVATVMXAWJWIXDWGSXCWQWOACDVTWB
      HIVBRUSVCVDVMWKVKVPALZVQWAVHWLWPVJXAVKVLXEXBACDFGHIVETABDVRFVPHWNKVIRVMWK
      VNALZVLVOWDVHWLVJXAVKVLXFXBADEFGHJVFTWMABDVRVNGHWNKVIRVDVG $.
  $}

  ${
    $d r A $.  $d r B $.  $d r .\/ $.  $d r K $.  $d r P $.  $d r Q $.
    $d r .< $.  $d r X $.
    cvrat.b $e |- B = ( Base ` K ) $.
    cvrat.s $e |- .< = ( lt ` K ) $.
    cvrat.j $e |- .\/ = ( join ` K ) $.
    cvrat.z $e |- .0. = ( 0. ` K ) $.
    cvrat.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for ~ cvrat .  ( ~ atcvatlem analog.)  (Contributed by NM,
       22-Nov-2011.) $)
    cvratlem $p |- ( ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A ) )
       /\ ( X =/= .0. /\ X .< ( P .\/ Q ) ) ) -> ( -. P ( le ` K ) X
        -> X e. A ) ) $=
      ( wcel wa wbr wi adantr syl3anc vr chlt w3a wne co cple cfv wn wrex hlatl
      cv cal simpr1 eqid atlex 3expia syl2anc ccvr wceq wb 3ad2ant1 simp3 atcmp
      simp22 breq1 biimprd syl6bi com23 con3 imp3a simp1 atbase 3ad2ant3 sylibd
      syl6 cvr1 imp clat hllat latjcom breqtrrd adantrrl hlatlej1 biimpd simprl
      syl imp32 simp21 simp23 3jca pltle sylan adantrl cpo hlpos postr syl13anc
      latjcl adantrrr hlexch1 latjle12 mpbi2and latasymb breq2 biimpcd ad2antll
      mp2and mpd cvrnbtwn3 exp4a imp4b adantrr simpl3 eqeltrrd exp45 3expa syld
      rexlimdva ) GUBOZHBOZCAOZDAOZUCZPZHIUDZHCDFUEZEQZCHGUFUGZQZUHZHAOZRZYDYEU
      AUKZHYHQZUAAUIZYGYLRZYDGULOZXTYEYORXSYQYCGUJZSXSXTYAYBUMYQXTYEYOUAABGYHHI
      JYHUNZMNUOUPUQYDYNYPUAAXSYCYMAOZYNYPRXSYCYTUCZYNYGYJYKUUAYNYGYJPZPZPZYMHA
      UUDYMCYMFUEZGURUGZQZHUUEEQZYMHUSZUUAYNYJUUGYGUUAYNYJPZPYMYMCFUEZUUEUUFUUA
      UUJYMUUKUUFQZUUAUUJCYMYHQZUHZUULUUAYNYJUUNUUAYNUUMYIRYJUUNRUUAUUMYNYIUUAU
      UMCYMUSZYNYIRZUUAYQYAYTUUMUUOUTXSYCYQYTYRVAZXSXTYAYBYTVDZXSYCYTVBZACYMGYH
      YSNVCTUUOYIYNCYMHYHVEVFVGVHUUMYIVIVOVJUUAXSYMBOZYAUUNUULUTXSYCYTVKZYTXSUU
      TYCABYMGJNVLVMZUURABUUFCFGYHYMJYSLUUFUNZNVPTVNVQUUAUUEUUKUSZUUJUUAGVROZCB
      OZUUTUVDXSYCUVEYTGVSVAZUUAYAUVFUURABCGJNVLWFZUVBBFGCYMJLVTTSWAWBUUDYFUUEU
      SZUUHUUDYFUUEYHQZUUEYFYHQZUVIUUDCUUEYHQZDUUEYHQZUVJUUAUVLUUCUUAXSYAYTUVLU
      VAUURUUSACYMFGYHYSLNWCTSUUDYMCYHQZUHZYMYFYHQZUVMUUAYNYJUVOYGUUAYNYJUVOUUA
      YNUVNYIRYJUVORUUAUVNYNYIUUAUVNYMCUSZUUPUUAYQYTYAUVNUVQUTUUQUUSUURAYMCGYHY
      SNVCTUVQYNYIYMCHYHVEWDVGVHUVNYIVIVOWGWBUUAYNYGUVPYJUUAYNYGPZPYNHYFYHQZUVP
      UUAYNYGWEUUAYGUVSYNUUAXSXTYFBOZUCZYGUVSUUAXSXTUVTUVAXSXTYAYBYTWHZUUAUVEUV
      FDBOZUVTUVGUVHUUAYBUWCXSXTYAYBYTWIZABDGJNVLWFZBFGCDJLWRTZWJUWAYGUVSUBBBEG
      YHHYFYSKWKVQWLWMUUAYNUVSPUVPRZUVRUUAGWNOZUUTXTUVTUWGXSYCUWHYTGWOVAZUVBUWB
      UWFBGYHYMHYFJYSWPWQSXGWSZUUAUVOUVPPUVMRZUUCUUAXSYTYBUVFUWKUVAUUSUWDUVHXSY
      TYBUVFUCZPUVOUVPUVMXSUWLUVOUVPUVMRABYMDFGYHCJYSLNWTUPVJWQSXGUUAUVLUVMPUVJ
      UTZUUCUUAUVEUVFUWCUUEBOZUWMUVGUVHUWEUUAUVEUVFUUTUWNUVGUVHUVBBFGCYMJLWRTZB
      FGYHCDUUEJYSLXAWQSXBUUDCYFYHQZUVPUVKUUAUWPUUCUUAXSYAYBUWPUVAUURUWDACDFGYH
      YSLNWCTSUWJUUAUWPUVPPUVKUTZUUCUUAUVEUVFUUTUVTUWQUVGUVHUVBUWFBFGYHCYMYFJYS
      LXAWQSXBUUDUVEUVTUWNUCZUVJUVKPUVIUTUUAUWRUUCUUAUVEUVTUWNUVGUWFUWOWJSBGYHY
      FUUEJYSXCWFXBUUBUVIUUHRZUUAYNYGUWSYJUVIYGUUHYFUUEHEXDXESXFXHUUAYNUUGUUHPU
      UIRUUBUUAYNUUGUUHUUIUUAUUGYNUUHUUIRUUAUUGYNUUHUUIUUAUWHUUTUWNXTUUGYNUUHPZ
      UUIRZRUWIUVBUWOUWBUWHUUTUWNXTUCZUUGUXAUWHUXBUUGUCUWTUUIBUUFEGYHYMUUEHJYSK
      UVCXIWDUPWQXJVHXKXLXGXSYCYTUUCXMXNXOXPXRXQWG $.

    $( A nonzero Hilbert lattice element less than the join of two atoms is an
       atom.  ( ~ atcvati analog.)  (Contributed by NM, 22-Nov-2011.) $)
    cvrat $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A ) )
       -> ( ( X =/= .0. /\ X .< ( P .\/ Q ) ) -> X e. A ) ) $=
      ( wcel w3a wa wbr wn wi chlt wne cple cfv cvratlem clat wceq hllat adantr
      co simpr2 atbase syl simpr3 latjcom syl3anc breq2d anbi2d simpl simpr1 ex
      syl13anc sylbid imp wo cpo hlpos latjcl eqid pltnle latjle12 biimpd nsyld
      wb ianor syl6ib adantrl mpjaod ) GUAOZHBOZCAOZDAOZPZQZHIUBZHCDFUJZERZQZHA
      OZWDWHQCHGUCUDZRZSZWIDHWJRZSZABCDEFGHIJKLMNUEWDWHWNWITZWDWHWEHDCFUJZERZQZ
      WOWDWGWQWEWDWFWPHEWDGUFOZCBOZDBOZWFWPUGVSWSWCGUHUIZWDWAWTVSVTWAWBUKZABCGJ
      NULUMZWDWBXAVSVTWAWBUNZABDGJNULUMZBFGCDJLUOUPUQURWDVSVTWBWAWRWOTVSWCUSVSV
      TWAWBUTZXEXCVSVTWBWAPQWRWOABDCEFGHIJKLMNUEVAVBVCVDWDWGWLWNVEZWEWDWGXHWDWG
      WKWMQZSXHWDWGWFHWJRZXIWDGVFOZVTWFBOZWGXJSZTVSXKWCGVGUIXGWDWSWTXAXLXBXDXFB
      FGCDJLVHUPXKVTXLPWGXMBEGWJHWFJWJVIZKVJVAUPWDXIXJWDWSWTXAVTXIXJVNXBXDXFXGB
      FGWJCDHJXNLVKVBVLVMWKWMVOVPVDVQVRVA $.
  $}

  ${
    ltltncvr.b $e |- B = ( Base ` K ) $.
    ltltncvr.s $e |- .< = ( lt ` K ) $.
    ltltncvr.c $e |- C = ( <o ` K ) $.
    $( A chained strong ordering is not a covers relation.  (Contributed by NM,
       18-Jun-2012.) $)
    ltltncvr $p |- ( ( K e. A /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                 -> ( ( X .< Y /\ Y .< Z ) -> -. X C Z ) ) $=
      ( wcel w3a wa wbr wn simpll simplr1 simplr3 simplr2 cvrnbtwn syl131anc ex
      simpr con2d ) EALZFBLZGBLZHBLZMZNZFHCOZFGDOGHDONZUKULUMPZUKULNUFUGUIUHULU
      NUFUJULQUGUHUIUFULRUGUHUIUFULSUGUHUIUFULTUKULUDABCDEFHGIJKUAUBUCUE $.

    $( Non-transitive condition for the covers relation.  (Contributed by NM,
       18-Jun-2012.) $)
    ltcvrntr $p |- ( ( K e. A /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                 -> ( ( X .< Y /\ Y C Z ) -> -. X C Z ) ) $=
      ( wcel w3a wa wbr wn wi cvrlt ex 3adant3r1 ltltncvr sylan2d ) EALZFBLZGBL
      ZHBLZMNGHCOZGHDOZFGDOFHCOPUCUEUFUGUHQUDUCUEUFMUGUHABCDEGHIJKRSTABCDEFGHIJ
      KUAUB $.
  $}

  ${
    cvrntr.b $e |- B = ( Base ` K ) $.
    cvrntr.c $e |- C = ( <o ` K ) $.
    $( The covers relation is not transitive.  ( ~ cvntr analog.)  (Contributed
       by NM, 18-Jun-2012.) $)
    cvrntr $p |- ( ( K e. A /\ ( X e. B /\ Y e. B /\ Z e. B ) )
                 -> ( ( X C Y /\ Y C Z ) -> -. X C Z ) ) $=
      ( wcel w3a wa wbr cplt cfv wn wi eqid cvrlt ex 3adant3r3 ltcvrntr syland
      ) DAJZEBJZFBJZGBJZKLEFCMZEFDNOZMZFGCMEGCMPUDUEUFUHUJQUGUDUEUFKUHUJABCUIDE
      FHUIRZISTUAABCUIDEFGHUKIUBUC $.
  $}

  ${
    atcvr0eq.j $e |- .\/ = ( join ` K ) $.
    atcvr0eq.z $e |- .0. = ( 0. ` K ) $.
    atcvr0eq.c $e |- C = ( <o ` K ) $.
    atcvr0eq.a $e |- A = ( Atoms ` K ) $.
    $( The covers relation is not transitive.  ( ~ atcv0eq analog.)
       (Contributed by NM, 29-Nov-2011.) $)
    atcvr0eq $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
        -> ( .0. C ( P .\/ Q ) <-> P = Q ) ) $=
      ( chlt wcel w3a co wbr wceq wne wa 3adant3 wn atcvr1 atcvr0 biantrurd cbs
      bitrd cfv simp1 cops hlop 3ad2ant1 eqid op0cl syl atbase 3ad2ant2 hlatjcl
      cvrntr syl13anc sylbid necon4ad hlatjidm breqtrrd breq2d syl5ibcom impbid
      wi oveq2 ) FLMZCAMZDAMZNZGCDEOZBPZCDQZVLVNCDVLCDRZGCBPZCVMBPZSZVNUAZVLVPV
      RVSABCDEFHJKUBVLVQVRVIVJVQVKABLCFGIJKUCTZUDUFVLVIGFUEUGZMZCWBMZVMWBMVSVTV
      GVIVJVKUHVLFUIMZWCVIVJWEVKFUJUKWBFGWBULZIUMUNVJVIWDVKAWBCFWFKUOUPAWBEFCDW
      FHKUQLWBBFGCVMWFJURUSUTVAVLGCCEOZBPVOVNVLGCWGBWAVIVJWGCQVKAEFCHKVBTVCVOWG
      VMGBCDCEVHVDVEVF $.
  $}

  ${
    lnnat.j $e |- .\/ = ( join ` K ) $.
    lnnat.a $e |- A = ( Atoms ` K ) $.
    $( A line (the join of two distinct atoms) is not an atom.  (Contributed by
       NM, 14-Jun-2012.) $)
    lnnat $p |- ( ( K e. HL /\ P e. A /\ Q e. A ) ->
        ( P =/= Q <-> -. ( P .\/ Q ) e. A ) ) $=
      ( chlt wcel w3a co wn wa cfv wbr eqid atcvr0 atbase syl wceq wne cp0 ccvr
      simpl1 simpl2 syl2anc atcvr1 biimpa cbs cops hlop op0cl 3syl hllat simpl3
      wi clat latjcl syl3anc cvrntr syl13anc simpll1 sylancom mtand ex hlatjidm
      mp2and 3adant3 simp2 eqeltrd oveq2 eleq1d syl5ibcom necon3bd impbid ) EHI
      ZBAIZCAIZJZBCUAZBCDKZAIZLZVSVTWCVSVTMZWBEUBNZWAEUCNZOZWDWEBWFOZBWAWFOZWGL
      ZWDVPVQWHVPVQVRVTUDZVPVQVRVTUEZAWFHBEWEWEPZWFPZGQUFVSVTWIAWFBCDEFWNGUGUHW
      DVPWEEUINZIZBWOIZWAWOIZWHWIMWJUPWKWDVPEUJIWPWKEUKWOEWEWOPZWMULUMWDVQWQWLA
      WOBEWSGRSZWDEUQIZWQCWOIZWRWDVPXAWKEUNSWTWDVRXBVPVQVRVTUOAWOCEWSGRSWODEBCW
      SFURUSHWOWFEWEBWAWSWNUTVAVGWDWBVPWGVPVQVRVTWBVBAWFHWAEWEWMWNGQVCVDVEVSWBB
      CVSBBDKZAIBCTZWBVSXCBAVPVQXCBTVRADEBFGVFVHVPVQVRVIVJXDXCWAABCBDVKVLVMVNVO
      $.
  $}

  ${
    atcvrj0.b $e |- B = ( Base ` K ) $.
    atcvrj0.j $e |- .\/ = ( join ` K ) $.
    atcvrj0.z $e |- .0. = ( 0. ` K ) $.
    atcvrj0.c $e |- C = ( <o ` K ) $.
    atcvrj0.a $e |- A = ( Atoms ` K ) $.
    $( Two atoms covering the zero subspace are equal.  ( ~ atcv1 analog.)
       (Contributed by NM, 29-Nov-2011.) $)
    atcvrj0 $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A )
       /\ X C ( P .\/ Q ) ) -> ( X = .0. <-> P = Q ) ) $=
      ( wcel w3a wbr wceq wi wa chlt co breq1 biimpd adantl wb 3adant3r1 adantr
      atcvr0eq sylibd ex com23 3impia breq2d biimpac simpr3 hlatjidm syldan cal
      oveq1 hlatl simpr1 cple eqid atcvreq0 syl3anc sylbid syl5 exp3a impbid
      cfv ) GUAOZHBOZDAOZEAOZPZHDEFUBZCQZPHIRZDERZVLVPVRVSVTSVLVPTZVSVRVTWAVSVR
      VTSWAVSTVRIVQCQZVTVSVRWBSWAVSVRWBHIVQCUCUDUEWAWBVTUFZVSVLVNVOWCVMACDEFGIK
      LMNUIUGUHUJUKULUMVLVPVRVTVSSWAVRVTVSVRVTTHEEFUBZCQZWAVSVTVRWEVTVQWDHCDEEF
      UTUNUOWAWEHECQZVSWAWDEHCVLVPVOWDERVLVMVNVOUPZAFGEKNUQURUNWAWFVSWAGUSOZVMV
      OWFVSUFVLWHVPGVAUHVLVMVNVOVBWGABCEGGVCVKZHIJWIVDLMNVEVFUDVGVHVIUMVJ $.
  $}

  ${
    cvrat2.b $e |- B = ( Base ` K ) $.
    cvrat2.j $e |- .\/ = ( join ` K ) $.
    cvrat2.c $e |- C = ( <o ` K ) $.
    cvrat2.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice element covered by the join of two distinct atoms is
       an atom.  ( ~ atcvat2i analog.)  (Contributed by NM, 30-Nov-2011.) $)
    cvrat2 $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A ) /\
         ( P =/= Q /\ X C ( P .\/ Q ) ) ) -> X e. A ) $=
      ( chlt wcel w3a wne wbr wa wi cfv co wceq wb eqid atcvrj0 3expa necon3bid
      cp0 cplt simpl simpr1 clat adantr simpr2 atbase syl simpr3 latjcl syl3anc
      hllat cvrlt ex cvrat exp3acom23 syld imp sylbird com23 imp3a 3impia ) GMN
      ZHBNZDANZEANZOZDEPZHDEFUAZCQZRHANZVKVORZVPVRVSVTVRVPVSVTVRVPVSSVTVRRZVPHG
      UHTZPZVSWAHWBDEVKVOVRHWBUBDEUBUCABCDEFGHWBIJWBUDZKLUEUFUGVTVRWCVSSZVTVRHV
      QGUITZQZWEVTVKVLVQBNZVRWGSVKVOUJVKVLVMVNUKVTGULNZDBNZEBNZWHVKWIVOGUTUMVTV
      MWJVKVLVMVNUNABDGILUOUPVTVNWKVKVLVMVNUQABEGILUOUPBFGDEIJURUSVKVLWHOVRWGMB
      CWFGHVQIWFUDZKVAVBUSVTWCWGVSABDEWFFGHWBIWLJWDLVCVDVEVFVGVBVHVIVJ $.
  $}

  ${
    atcvrne.j $e |- .\/ = ( join ` K ) $.
    atcvrne.c $e |- C = ( <o ` K ) $.
    atcvrne.a $e |- A = ( Atoms ` K ) $.
    $( Inequality derived from atom condition.  (Contributed by NM,
       7-Feb-2012.)  (New usage is discouraged.) $)
    atcvrneN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
           /\ P C ( Q .\/ R ) ) -> Q =/= R ) $=
      ( chlt wcel w3a co wbr cp0 cfv wne eqid wceq 3ad2ant1 simp21 atn0 syl2anc
      cal hlatl cbs wb simp1 atbase syl simp22 simp23 simp3 syl131anc necon3bid
      atcvrj0 mpbid ) GKLZCALZDALZEALZMZCDEFNBOZMZCGPQZRZDERVEGUELZUTVGUSVCVHVD
      GUFUAUSUTVAVBVDUBZACGVFVFSZJUCUDVECVFDEVEUSCGUGQZLZVAVBVDCVFTDETUHUSVCVDU
      IVEUTVLVIAVKCGVKSZJUJUKUSUTVAVBVDULUSUTVAVBVDUMUSVCVDUNAVKBDEFGCVFVMHVJIJ
      UQUOUPUR $.
  $}

  ${
    atcvrj1x.l $e |- .<_ = ( le ` K ) $.
    atcvrj1x.j $e |- .\/ = ( join ` K ) $.
    atcvrj1x.c $e |- C = ( <o ` K ) $.
    atcvrj1x.a $e |- A = ( Atoms ` K ) $.
    $( Condition for an atom to be covered by the join of two others.
       (Contributed by NM, 7-Feb-2012.) $)
    atcvrj1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( P =/= R /\ P .<_ ( Q .\/ R ) ) ) -> P C ( Q .\/ R ) ) $=
      ( wcel w3a co wbr cfv wb eqid mpbid chlt wne wa cmee cp0 simp3l cal hlatl
      wceq 3ad2ant1 simp21 simp23 atnem0 syl3anc cbs atbase syl cvrp hlatexchb2
      simp1 simp3r 3adant3r breqtrd ) GUAMZCAMZDAMZEAMZNZCEUBZCDEFOZHPZUCZNZCCE
      FOZVJBVMCEGUDQZOGUEQZUIZCVNBPZVMVIVQVDVHVIVKUFVMGUGMZVEVGVIVQRVDVHVSVLGUH
      UJVDVEVFVGVLUKZVDVEVFVGVLULZACEGVOVPVOSZVPSZLUMUNTVMVDCGUOQZMZVGVQVRRVDVH
      VLUTVMVEWEVTAWDCGWDSZLUPUQWAAWDBEFGVOCVPWFJWBWCKLURUNTVMVKVNVJUIZVDVHVIVK
      VAVDVHVIVKWGRVKACDEFGHIJLUSVBTVC $.

    $( Condition for an atom to be covered by the join of two others.
       (Contributed by NM, 7-Feb-2012.) $)
    atcvrj2b $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) )
        -> ( ( Q =/= R /\ P .<_ ( Q .\/ R ) ) <-> P C ( Q .\/ R ) ) ) $=
      ( wcel w3a wa wne wbr wceq wb atbase chlt co simpl3l necomd simpl1 atcvr2
      simpl23 simpl22 syl3anc mpbid breq1 adantl mpbird simpr simpl3r syl112anc
      simpl2 atcvrj1 pm2.61dane 3expia cp0 cfv hlatl ad2antrr simplr1 eqid atn0
      cal syl2anc cbs simpll syl simplr2 simplr3 syl131anc necon3bid clat hllat
      atcvrj0 latjcl 3jca cvrle sylancom jca ex impbid ) GUAMZCAMZDAMZEAMZNZOZD
      EPZCDEFUBZHQZOZCWNBQZWGWKWPWQWGWKWPNZWQCEWRCERZOZWQEWNBQZWTEDPZXAWTDEWMWO
      WGWKWSUCUDWTWGWJWIXBXASWGWKWPWSUEWHWIWJWGWPWSUGWHWIWJWGWPWSUHABEDFGJKLUFU
      IUJWSWQXASWRCEWNBUKULUMWRCEPZOWGWKXCWOWQWGWKWPXCUEWGWKWPXCUQWRXCUNWMWOWGW
      KXCUOABCDEFGHIJKLURUPUSUTWLWQWPWLWQOZWMWOXDCGVAVBZPZWMXDGVHMZWHXFWGXGWKWQ
      GVCVDWHWIWJWGWQVEZACGXEXEVFZLVGVIXDCXEDEXDWGCGVJVBZMZWIWJWQCXERDERSWGWKWQ
      VKZXDWHXKXHAXJCGXJVFZLTVLZWHWIWJWGWQVMZWHWIWJWGWQVNZWLWQUNAXJBDEFGCXEXMJX
      IKLVSVOVPUJWLWQWGXKWNXJMZNWOXDWGXKXQXLXNXDGVQMZDXJMZEXJMZXQWGXRWKWQGVRVDX
      DWIXSXOAXJDGXMLTVLXDWJXTXPAXJEGXMLTVLXJFGDEXMJVTUIWAUAXJBGHCWNXMIKWBWCWDW
      EWF $.

    $( Condition for an atom to be covered by the join of two others.
       (Contributed by NM, 7-Feb-2012.) $)
    atcvrj2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( Q =/= R /\ P .<_ ( Q .\/ R ) ) ) -> P C ( Q .\/ R ) ) $=
      ( chlt wcel w3a wne co wbr wa atcvrj2b biimp3a ) GMNCANDANEANODEPCDEFQZHR
      SCUBBRABCDEFGHIJKLTUA $.

  $}

  ${
    atlene.l $e |- .<_ = ( le ` K ) $.
    atlene.j $e |- .\/ = ( join ` K ) $.
    atlene.a $e |- A = ( Atoms ` K ) $.
    $( Inequality derived from atom condition.  (Contributed by NM,
       7-Feb-2012.)  (New usage is discouraged.) $)
    atleneN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( P =/= R /\ P .<_ ( Q .\/ R ) ) ) -> Q =/= R ) $=
      ( chlt wcel w3a wne co wbr wa ccvr cfv eqid atcvrj1 atcvrneN syld3an3 ) F
      KLBALCALDALMBDNBCDEOZGPQBUDFRSZPCDNAUEBCDEFGHIUETZJUAAUEBCDEFIUFJUBUC $.
  $}

  ${
    atltcvr.s $e |- .< = ( lt ` K ) $.
    atltcvr.j $e |- .\/ = ( join ` K ) $.
    atltcvr.a $e |- A = ( Atoms ` K ) $.
    atltcvr.c $e |- C = ( <o ` K ) $.
    $( An equivalence of less-than ordering and covers relation.  (Contributed
       by NM, 7-Feb-2012.) $)
    atltcvr $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) )
           -> ( P .< ( Q .\/ R ) <-> P C ( Q .\/ R ) ) ) $=
      ( chlt wcel wa wbr wi adantr syl3anc syl w3a oveq1 simpr3 hlatjidm syldan
      co wceq sylan9eqr breq2d cal wn hlatl simpr1 atnlt pm2.21d sylbid wne cfv
      cple simpl clat hllat simpr2 eqid atbase latjcl pltle simpll simplr simpr
      cbs 3jca anassrs atcvrj2 ex syld pm2.61dane cvrlt impbid ) HMNZCANZDANZEA
      NZUAZOZCDEGUFZFPZCWFBPZWEWGWHQDEWEDEUGZOZWGCEFPZWHWJWFECFWIWEWFEEGUFZEDEE
      GUBVTWDWCWLEUGVTWAWBWCUCZAGHEJKUDUEUHUIWEWKWHQWIWEWKWHWEHUJNZWAWCWKUKVTWN
      WDHULRVTWAWBWCUMZWMACEFHIKUNSUORUPWEDEUQZOZWGCWFHUSURZPZWHWEWGWSQZWPWEVTW
      AWFHVKURZNZWTVTWDUTZWOWEHVANZDXANZEXANZXBVTXDWDHVBRWEWBXEVTWAWBWCVCAXADHX
      AVDZKVETWEWCXFWMAXAEHXGKVETXAGHDEXGJVFSZMAXAFHWRCWFWRVDZIVGSRWQWSWHWQWSOV
      TWDWPWSOZUAZWHWEWPWSXKWEXJOVTWDXJVTWDXJVHVTWDXJVIWEXJVJVLVMABCDEGHWRXIJLK
      VNTVOVPVQWEVTCXANZXBWHWGQXCWEWAXLWOAXACHXGKVETXHVTXLXBUAWHWGMXABFHCWFXGIL
      VRVOSVS $.
  $}

  ${
    $d p A $.  $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p .0. $.
    atle.b $e |- B = ( Base ` K ) $.
    atle.l $e |- .<_ = ( le ` K ) $.
    atle.z $e |- .0. = ( 0. ` K ) $.
    atle.a $e |- A = ( Atoms ` K ) $.
    $( Any non-zero element has an atom under it.  (Contributed by NM,
       28-Jun-2012.) $)
    atle $p |- ( ( K e. HL /\ X e. B /\ X =/= .0. ) -> E. p e. A p .<_ X ) $=
      ( chlt wcel cfv wbr wa wrex syl eqid syl2anc wne w3a cv cjn co cplt simp1
      cops hlop 3ad2ant1 op0cl simp2 wb opltn0 mpbird hlrelat syl31anc col wceq
      simp3 simpl1 hlol atbase adantl olj02 breq1d biimpd adantld reximdva mpd
      ) CLMZEBMZEFUAZUBZFFGUCZCUDNZUEZCUFNZOZVQEDOZPZGAQZVOEDOZGAQVNVKFBMZVLFEV
      ROZWBVKVLVMUGVNCUHMZWDVKVLWFVMCUIUJZBCFHJUKRVKVLVMULZVNWEVMVKVLVMUTVNWFVL
      WEVMUMWGWHBVRCEFHVRSZJUNTUOABVRVPCDFEGHIWIVPSZKUPUQVNWAWCGAVNVOAMZPZVTWCV
      SWLVTWCWLVQVOEDWLCURMZVOBMZVQVOUSWLVKWMVKVLVMWKVACVBRWKWNVNABVOCHKVCVDBVP
      CVOFHWJJVETVFVGVHVIVJ $.
  $}

  ${
    atlt.s $e |- .< = ( lt ` K ) $.
    atlt.j $e |- .\/ = ( join ` K ) $.
    atlt.a $e |- A = ( Atoms ` K ) $.
    $( Two atoms are unequal iff their join is greater than one of them.
       (Contributed by NM, 6-May-2012.) $)
    atlt $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
        -> ( P .< ( P .\/ Q ) <-> P =/= Q ) ) $=
      ( chlt wcel w3a co wbr ccvr cfv wne wb simp1 simp2 simp3 atltcvr syl13anc
      eqid atcvr1 bitr4d ) FJKZBAKZCAKZLZBBCEMZDNZBUKFOPZNZBCQUJUGUHUHUIULUNRUG
      UHUISUGUHUITZUOUGUHUIUAAUMBBCDEFGHIUMUDZUBUCAUMBCEFHUPIUEUF $.
  $}

  ${
    atlelt.b $e |- B = ( Base ` K ) $.
    atlelt.l $e |- .<_ = ( le ` K ) $.
    atlelt.s $e |- .< = ( lt ` K ) $.
    atlelt.a $e |- A = ( Atoms ` K ) $.
    $( Transfer less-than relation from one atom to another.  (Contributed by
       NM, 7-May-2012.) $)
    atlelt $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
        /\ ( P .<_ X /\ Q .< X ) ) -> P .< X ) $=
      ( chlt wcel w3a wbr wa wb syl3anc 3ad2ant1 wceq simp3r syl5ibrcom wne cjn
      breq1 co simp1 simp21 simp22 eqid atlt simp3l simp23 3jca pltle sylc clat
      cfv hllat atbase syl latjle12 syl13anc mpbi2and cpo latjcl pltletr mpan2d
      wi hlpos sylbird pm2.61dne ) FMNZCANZDANZHBNZOZCHGPZDHEPZQZOZCHEPZCDWBWCC
      DUAVTVNVRVSVTUBZCDHEUFUCWBCDUDZCCDFUEUSZUGZEPZWCWBVNVOVPWHWERVNVRWAUHZVNV
      OVPVQWAUIZVNVOVPVQWAUJZACDEWFFKWFUKZLULSWBWHWGHGPZWCWBVSDHGPZWMVNVRVSVTUM
      WBVNVPVQOVTWNWBVNVPVQWIWKVNVOVPVQWAUNZUOWDMABEFGDHJKUPUQWBFURNZCBNZDBNZVQ
      VSWNQWMRVNVRWPWAFUTTZWBVOWQWJABCFILVAVBZWBVPWRWKABDFILVAVBZWOBWFFGCDHIJWL
      VCVDVEWBFVFNZWQWGBNZVQWHWMQWCVJVNVRXBWAFVKTWTWBWPWQWRXCWSWTXABWFFCDIWLVGS
      WOBEFGCWGHIJKVHVDVIVLVM $.
  $}

  ${
    $d q A $.  $d q B $.  $d q K $.  $d q P $.  $d q .< $.  $d q X $.
    2atomslt.b $e |- B = ( Base ` K ) $.
    2atomslt.s $e |- .< = ( lt ` K ) $.
    2atomslt.a $e |- A = ( Atoms ` K ) $.
    $( Given an atom less than an element, there is another atom less than the
       element.  (Contributed by NM, 6-May-2012.) $)
    2atlt $p |- ( ( ( K e. HL /\ P e. A /\ X e. B ) /\ P .< X )
      -> E. q e. A ( q =/= P /\ q .< X ) ) $=
      ( wcel w3a wbr wa cfv co eqid wb syl3anc syl chlt cv cjn cple wrex atbase
      hlrelat syl3anl2 ccvr simp3l simp1l1 simp1l2 simp2 atltcvr syl13anc mpbid
      wne atcvr1 mpbird necomd atlt clat hllat 3ad2ant2 latjcom breqtrrd simp3r
      wceq cpo wi hlpos latjcl simp1l3 pltletr mp2and jca 3exp reximdvai mpd )
      EUAKZCAKZFBKZLCFDMZNZCCGUBZEUCOZPZDMZWGFEUDOZMZNZGAUEZWECUQZWEFDMZNZGAUEW
      AVTCBKZWBWCWLABCEHJUFZABDWFEWICFGHWIQZIWFQZJUGUHWDWKWOGAWDWEAKZWKWOWDWTWK
      LZWMWNXACWEXACWEUQZCWGEUIOZMZXAWHXDWDWTWHWJUJXAVTWAWAWTWHXDRVTWAWBWCWTWKU
      KZVTWAWBWCWTWKULZXFWDWTWKUMZAXCCCWEDWFEIWSJXCQZUNUOUPXAVTWAWTXBXDRXEXFXGA
      XCCWEWFEWSXHJURSUSUTZXAWEWGDMZWJWNXAWEWECWFPZWGDXAWEXKDMZWMXIXAVTWTWAXLWM
      RXEXGXFAWECDWFEIWSJVASUSXAEVBKZWPWEBKZWGXKVHXAVTXMXEEVCTZXAWAWPXFWQTZWTWD
      XNWKABWEEHJUFVDZBWFECWEHWSVESVFWDWTWHWJVGXAEVIKZXNWGBKZWBXJWJNWNVJXAVTXRX
      EEVKTXQXAXMWPXNXSXOXPXQBWFECWEHWSVLSVTWAWBWCWTWKVMBDEWIWEWGFHWRIVNUOVOVPV
      QVRVS $.
  $}

  ${
    atexchcvr.j $e |- .\/ = ( join ` K ) $.
    atexchcvr.a $e |- A = ( Atoms ` K ) $.
    atexchcvr.c $e |- C = ( <o ` K ) $.
    $( Atom exchange property.  Version of ~ hlatexch2 with covers relation.
       (Contributed by NM, 7-Feb-2012.)  (New usage is discouraged.) $)
    atexchcvrN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) /\ P =/= R )
           -> ( P C ( Q .\/ R ) -> Q C ( P .\/ R ) ) ) $=
      ( chlt wcel w3a co wbr cfv wa simpl1 atbase syl wne cple cbs simpl21 eqid
      clat hllat simpl22 simpl23 latjcl syl3anc cvrle sylancom hlatexch2 simpl3
      3jca ex simpr atcvrj2 syl132anc 3syld ) GKLZCALZDALZEALZMZCEUAZMZCDEFNZBO
      ZCVIGUBPZOZDCEFNZVKOZDVMBOZVHVJVLVHVJVBCGUCPZLZVIVPLZMVLVHVJQZVBVQVRVBVFV
      GVJRZVSVCVQVCVDVEVBVGVJUDAVPCGVPUEZISTVSGUFLZDVPLZEVPLZVRVSVBWBVTGUGTVSVD
      WCVCVDVEVBVGVJUHAVPDGWAISTVSVEWDVCVDVEVBVGVJUIAVPEGWAISTVPFGDEWAHUJUKUPKV
      PBGVKCVIWAVKUEZJULUMUQACDEFGVKWEHIUNVHVNVOVHVNQVBVDVCVEVGVNVOVBVFVGVNRVCV
      DVEVBVGVNUHVCVDVEVBVGVNUDVCVDVEVBVGVNUIVBVFVGVNUOVHVNURABDCEFGVKWEHJIUSUT
      UQVA $.
  $}

  ${
    atexchlt.s $e |- .< = ( lt ` K ) $.
    atexchlt.j $e |- .\/ = ( join ` K ) $.
    atexchlt.a $e |- A = ( Atoms ` K ) $.
    $( Atom exchange property.  Version of ~ hlatexch2 with less-than
       ordering.  (Contributed by NM, 7-Feb-2012.)
       (New usage is discouraged.) $)
    atexchltN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) /\ P =/= R )
           -> ( P .< ( Q .\/ R ) -> Q .< ( P .\/ R ) ) ) $=
      ( chlt wcel w3a wne co ccvr wbr wb atltcvr 3adant3 cfv eqid atexchcvrN wa
      simpl simpr2 simpr1 simpr3 syl13anc 3imtr4d ) GKLZBALZCALZDALZMZBDNZMBCDF
      OZGPUAZQZCBDFOZURQZBUQEQZCUTEQZAURBCDFGIJURUBZUCUKUOVBUSRUPAURBCDEFGHIJVD
      STUKUOVCVARZUPUKUOUDUKUMULUNVEUKUOUEUKULUMUNUFUKULUMUNUGUKULUMUNUHAURCBDE
      FGHIJVDSUITUJ $.
  $}

  ${
    cvrat3.b $e |- B = ( Base ` K ) $.
    cvrat3.l $e |- .<_ = ( le ` K ) $.
    cvrat3.j $e |- .\/ = ( join ` K ) $.
    cvrat3.m $e |- ./\ = ( meet ` K ) $.
    cvrat3.a $e |- A = ( Atoms ` K ) $.
    $( A condition implying that a certain lattice element is an atom.  Part of
       Lemma 3.2.20 of [PtakPulmannova] p. 68.  ( ~ atcvat3i analog.)
       (Contributed by NM, 30-Nov-2011.) $)
    cvrat3 $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A ) )
       -> ( ( P =/= Q /\ -. Q .<_ X /\ P .<_ ( X .\/ Q ) )
      -> ( X ./\ ( P .\/ Q ) ) e. A ) ) $=
      ( wcel wa wbr co adantr syl3anc chlt w3a wne wn ccvr wi wb eqid 3adant3r2
      cfv cvr1 biimpa adantrr wceq clat simpr2 atbase syl simpr3 latjcom oveq2d
      hllat simpr1 latjass syl13anc eqtr4d latjlej2 imp eqbrtrd latjidm syl2anc
      latjcl breqtrd simpl hlatlej2 mpd latasymb mpbi2and breq2d adantrl mpbird
      ex cvrexch sylibrd latmcl cvrat2 3expia expdimp syld exp4b 3impd ) FUAOZI
      BOZCAOZDAOZUBZPZCDUCZDIGQUDZCIDERZGQZICDERZHRZAOZWQWRWSXAXDWQWRPWSXAPZXCX
      BFUEUJZQZXDWQXEXGUFWRWQXEIIXBERZXFQZXGWQXEXIWQXEPXIIWTXFQZWQWSXJXAWQWSXJW
      LWMWOWSXJUGWNABXFDEFGIJKLXFUHZNUKUIULUMWQXAXIXJUGWSWQXAPZXHWTIXFXLXHWTGQZ
      WTXHGQZXHWTUNZXLXHWTWTERZWTGXLXHWTCERZXPGWQXHXQUNXAWQXHIDCERZERZXQWQXBXRI
      EWQFUOOZCBOZDBOZXBXRUNWLXTWPFVBSZWQWNYAWLWMWNWOUPZABCFJNUQURZWQWOYBWLWMWN
      WOUSZABDFJNUQURZBEFCDJLUTTVAWQXTWMYBYAXQXSUNYCWLWMWNWOVCZYGYEBEFIDCJLVDVE
      VFSWQXAXQXPGQZWQXTYAWTBOZYJXAYIUFYCYEWQXTWMYBYJYCYHYGBEFIDJLVLTZYKBEFGCWT
      WTJKLVGVEVHVIWQXPWTUNZXAWQXTYJYLYCYKBEFWTJLVJVKSVMWQXNXAWQDXBGQZXNWQWLWNW
      OYMWLWPVNZYDYFACDEFGKLNVOTWQXTYBXBBOZWMYMXNUFYCYGWQXTYAYBYOYCYEYGBEFCDJLV
      LTZYHBEFGDXBIJKLVGVEVPSWQXMXNPXOUGZXAWQXTXHBOZYJYQYCWQXTWMYOYRYCYHYPBEFIX
      BJLVLTYKBFGXHWTJKVQTSVRVSVTWAWBWQWLWMYOXGXIUGYNYHYPBXFEFHIXBJLMXKWCTWDSWQ
      WRXGXDWQWLXCBOZWNWOWRXGPZXDUFYNWQXTWMYOYSYCYHYPBFHIXBJMWETYDYFWLYSWNWOUBY
      TXDABXFCDEFXCJLXKNWFWGVEWHWIWJWK $.
  $}

  ${
    $d r A $.  $d r B $.  $d r .\/ $.  $d r K $.  $d r .<_ $.  $d r P $.
    $d r Q $.  $d r X $.
    cvrat4.b $e |- B = ( Base ` K ) $.
    cvrat4.l $e |- .<_ = ( le ` K ) $.
    cvrat4.j $e |- .\/ = ( join ` K ) $.
    cvrat4.z $e |- .0. = ( 0. ` K ) $.
    cvrat4.a $e |- A = ( Atoms ` K ) $.
    $( TODO Change ( X .\/ Q ) to ( Q .\/ X ) to match books $)
    $( A condition implying existence of an atom with the properties shown.
       Lemma 3.2.20 in [PtakPulmannova] p. 68.  Also Lemma 9.2(delta) in
       [MaedaMaeda] p. 41.  ( ~ atcvat4i analog.)  (Contributed by NM,
       30-Nov-2011.) $)
    cvrat4 $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A ) )
       -> ( ( X =/= .0. /\ P .<_ ( X .\/ Q ) )
      -> E. r e. A ( r .<_ X /\ P .<_ ( Q .\/ r ) ) ) ) $=
      ( wcel wa wceq wbr syl3anc chlt w3a wne co cv wrex wi hlatl adantr simpr1
      atlex 3exp sylc simpll simplr3 simpr hlatlej1 breq1 syl5ibr impcom anim2d
      cal exp3a exp3acom23 reximdvai syld ex a1i com4l imp4a clat simpr3 atbase
      wb hllat latleeqj2 biimpa breq2d expl simpl simpr2 hlatlej2 jctird jctild
      syl impl oveq2 anbi12d rspcev adantrl exp31 wo wn ioran df-ne anbi1i cmee
      bitr4i cfv eqid cvrat3 3expd imp4c latjcl latmle1 imp44 simplr2 jca atnle
      3jca latmcom eqeq1d bitrd latmcl latmlem2 breq2 syl5ibcom cops hlop ople0
      breqtrd syl2anc sylibd sylbid adantrr latmle2 latjcom hlexch3 3expia jcad
      imp syl3c syl6 syl5bi syl7 ecase3d ) FUAPZHBPZCAPZDAPZUBZQZCDRZDHGSZHIUCZ
      CHDEUDZGSZQZJUEZHGSZCDUUIEUDZGSZQZJAUFZUGUUBUUCUUEUUGUUNUUGUUBUUCUUEUUNUU
      BUUCUUEUUNUGZUGUGUUGUUBUUCUUOUUBUUCQZUUEUUJJAUFZUUNUUBUUEUUQUGZUUCUUBFVBP
      ZYRUURYQUUSUUAFUHUIZYQYRYSYTUJZUUSYRUUEUUQJABFGHIKLNOUKULUMUIUUPUUJUUMJAU
      UPUUJUUIAPZUUMUUPUVBUULUUJUUCUUBUVBUULUGUUCUUBUVBUULUUBUVBQZUULUUCDUUKGSZ
      UVCYQYTUVBUVDYQUUAUVBUNYRYSYTYQUVBUOUUBUVBUPADUUIEFGLMOUQTCDUUKGURUSVCUTV
      AVDVEVFVGVHVIVJUUBUUDUUHUUNUUBUUDQZUUGUUNUUEUVEUUGQYSCHGSZCDCEUDZGSZQZQZU
      UNUUBUUDUUGUVJUUBUUDUUGQZUVIYSUUBUVKUVFUVHUUBUUDUUGUVFUVEUUGUVFUVEUUFHCGU
      UBUUDUUFHRZUUBFVKPZDBPZYRUUDUVLVNYQUVMUUAFVOZUIZUUBYTUVNYQYRYSYTVLZABDFKO
      VMWEZUVABEFGDHKLMVPTVQVRVQVSUUBYQYTYSUVHYQUUAVTUVQYQYRYSYTWAZADCEFGLMOWBT
      WCUVSWDWFUUMUVIJCAUUICRZUUJUVFUULUVHUUICHGURUVTUUKUVGCGUUICDEWGVRWHWIWEWJ
      WKUUHUUGUUBUUCUUDWLWMZUUNUUEUUGUPUWACDUCZUUDWMZQZUUBUUGUUNUGUWAUUCWMZUWCQ
      UWDUUCUUDWNUWBUWEUWCCDWOWPWRUUBUWDUUGUUNUUBUWDUUGQZHCDEUDZFWQWSZUDZAPZUWI
      HGSZCDUWIEUDZGSZQZQUUNUUBUWFUWJUWNUUBUWBUWCUUGUWJUUBUWBUWCUUGUWJABCDEFGUW
      HHKLMUWHWTZOXAXBZXCUUBUWFUWNUUBUWFQZUWKUWMUUBUWKUWFUUBUVMYRUWGBPZUWKUVPUV
      AUUBUVMCBPZUVNUWRUVPUUBYSUWSUVSABCFKOVMWEZUVRBEFCDKMXDTZBFGUWHHUWGKLUWOXE
      TZUIUWQYQUWJYSUVNUBZQZDUWIUWHUDZIRZUWIUVGGSZUWMUWQYQUXCYQUUAUWFUNUWQUWJYS
      UVNUUBUWBUWCUUGUWJUWPXFYRYSYTYQUWFXGUUBUVNUWFUVRUIXJXHUUBUWDUXFUUGUUBUWCU
      XFUWBUUBUWCUXFUUBUWCHDUWHUDZIRZUXFUUBUWCDHUWHUDZIRZUXIUUBUUSYTYRUWCUXKVNU
      UTUVQUVAABDFGUWHHIKLUWONOXITUUBUXJUXHIUUBUVMUVNYRUXJUXHRUVPUVRUVABFUWHDHK
      UWOXKTZXLXMUUBUXIUXEIGSZUXFUUBUXEUXHGSUXIUXMUUBUXEUXJUXHGUUBUVMUWIBPZYRUV
      NUBZQUWKUXEUXJGSUUBUVMUXOUVPUUBUXNYRUVNUUBUVMYRUWRUXNUVPUVAUXABFUWHHUWGKU
      WOXNTZUVAUVRXJXHUXBBFGUWHUWIHDKLUWOXOUMUXLYAUXHIUXEGXPXQUUBFXRPZUXEBPZUXM
      UXFVNYQUXQUUAFXSUIUUBUVMUVNUXNUXRUVPUVRUXPBFUWHDUWIKUWOXNTBFGUXEIKLNXTYBY
      CYDYKWJYEUUBUXGUWFUUBUWIUWGUVGGUUBUVMYRUWRUWIUWGGSUVPUVAUXABFGUWHHUWGKLUW
      OYFTUUBUVMUWSUVNUWGUVGRUVPUWTUVRBEFCDKMYGTYAUIUXDUXFUWIDUWHUDZIRZUXGUWMUG
      ZUXDUXEUXSIUXDUVMUVNUXNUXEUXSRYQUVMUXCUVOUIYQUWJYSUVNVLUXDUWJUXNYQUWJYSUV
      NUJABUWIFKOVMWEBFUWHDUWIKUWOXKTXLYQUXCUXTUYAABUWICEFGUWHDIKLMUWONOYHYIYDY
      LXHVGYJUUMUWNJUWIAUUIUWIRZUUJUWKUULUWMUUIUWIHGURUYBUUKUWLCGUUIUWIDEWGVRWH
      WIYMVCYNYOYP $.

    $( Commuted version of ~ cvrat4 .  (Contributed by NM, 28-Jan-2012.) $)
    cvrat42 $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A ) )
       -> ( ( X =/= .0. /\ P .<_ ( X .\/ Q ) )
      -> E. r e. A ( r .<_ X /\ P .<_ ( r .\/ Q ) ) ) ) $=
      ( wcel wa co wbr wrex chlt w3a cv cvrat4 clat wceq hllat ad2antrr simplr3
      wne atbase syl adantl latjcom syl3anc breq2d anbi2d rexbidva sylibd ) FUA
      PZHBPZCAPZDAPZUBZQZHIUJCHDERGSQJUCZHGSZCDVFERZGSZQZJATVGCVFDERZGSZQZJATAB
      CDEFGHIJKLMNOUDVEVJVMJAVEVFAPZQZVIVLVGVOVHVKCGVOFUEPZDBPZVFBPZVHVKUFUTVPV
      DVNFUGUHVOVCVQVAVBVCUTVNUIABDFKOUKULVNVRVEABVFFKOUKUMBEFDVFKMUNUOUPUQURUS
      $.
  $}

  ${
    2atjm.b $e |- B = ( Base ` K ) $.
    2atjm.l $e |- .<_ = ( le ` K ) $.
    2atjm.j $e |- .\/ = ( join ` K ) $.
    2atjm.m $e |- ./\ = ( meet ` K ) $.
    2atjm.a $e |- A = ( Atoms ` K ) $.
    $( The meet of a line (expressed with 2 atoms) and a lattice element.
       (Contributed by NM, 30-Jul-2012.) $)
    2atjm $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B ) /\
      ( P .<_ X /\ -. Q .<_ X ) ) -> ( ( P .\/ Q ) ./\ X ) = P ) $=
      ( wcel w3a wbr wa co syl3anc chlt wn wceq clat 3ad2ant1 simp21 atbase syl
      hllat simp22 latlej1 simp3l wb simp1 hlatjcl simp23 latlem12 syl13anc cal
      mpbi2and latmcom wne 3jca nbrne2 3ad2ant3 simp3r latjcl lattrd cvrat3 imp
      hlatl syl23anc eqeltrd atcmp mpbid eqcomd ) FUAOZCAOZDAOZIBOZPZCIGQZDIGQU
      BZRZPZCCDESZIHSZWECWGGQZCWGUCZWECWFGQZWBWHWEFUDOZCBOZDBOZWJVQWAWKWDFUIUEZ
      WEVRWLVQVRVSVTWDUFZABCFJNUGUHZWEVSWMVQVRVSVTWDUJZABDFJNUGUHZBEFGCDJKLUKTV
      QWAWBWCULZWEWKWLWFBOZVTWJWBRWHUMWNWPWEVQVRVSWTVQWAWDUNZWOWQABEFCDJLNUOTZV
      QVRVSVTWDUPZBFGHCWFIJKMUQURUTWEFUSOZVRWGAOWHWIUMVQWAXDWDFVKUEWOWEWGIWFHSZ
      AWEWKWTVTWGXEUCWNXBXCBFHWFIJMVATWEVQVTVRVSPZCDVBZWCCIDESZGQZXEAOZXAWEVTVR
      VSXCWOWQVCWDVQXGWACDIGVDVEVQWAWBWCVFWEBFGCIXHJKWNWPXCWEWKVTWMXHBOWNXCWRBE
      FIDJLVGTWSWEWKVTWMIXHGQWNXCWRBEFGIDJKLUKTVHVQXFRXGWCXIPXJABCDEFGHIJKLMNVI
      VJVLVMACWGFGKNVNTVOVP $.
  $}

  ${
    atbtwn.b $e |- B = ( Base ` K ) $.
    atbtwn.l $e |- .<_ = ( le ` K ) $.
    atbtwn.j $e |- .\/ = ( join ` K ) $.
    atbtwn.a $e |- A = ( Atoms ` K ) $.
    $( Property of a 3rd atom ` R ` on a line ` P .\/ Q ` intersecting element
       ` X ` at ` P ` .  (Contributed by NM, 30-Jul-2012.) $)
    atbtwn $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A /\ X e. B ) /\
      ( P .<_ X /\ -. Q .<_ X /\ R .<_ ( P .\/ Q ) ) )
   -> ( R =/= P <-> -. R .<_ X ) ) $=
      ( wcel w3a wa wbr wn co syl chlt wne wceq cmee simpl33 simpr clat simpl11
      cfv wb hllat simpl2l atbase simpl1 hlatjcl simpl2r eqid latlem12 syl13anc
      simpl12 simpl13 simpl31 simpl32 2atjm syl132anc breqtrd cal hlatl syl3anc
      mpbi2and atcmp mpbid ex necon3ad wi simp31 nbrne2 necomd impbid ) GUANZCA
      NZDANZOZEANZIBNZPZCIHQZDIHQRZECDFSZHQZOZOZECUBZEIHQZRZWLWNECWLWNECUCZWLWN
      PZECHQZWPWQEWIIGUDUIZSZCHWQWJWNEWTHQZWGWHWJWCWFWNUEWLWNUFWQGUGNZEBNZWIBNZ
      WEWJWNPXAUJWQVTXBVTWAWBWFWKWNUHZGUKTWQWDXCWDWEWCWKWNULZABEGJMUMTWQWCXDWCW
      FWKWNUNABFGCDJLMUOTWDWEWCWKWNUPZBGHWSEWIIJKWSUQZURUSVJWQVTWAWBWEWGWHWTCUC
      XEVTWAWBWFWKWNUTZVTWAWBWFWKWNVAXGWGWHWJWCWFWNVBWGWHWJWCWFWNVCABCDFGHWSIJK
      LXHMVDVEVFWQGVGNZWDWAWRWPUJWQVTXJXEGVHTXFXIAECGHKMVKVIVLVMVNWLWGWOWMVOWCW
      FWGWHWJVPWGWOWMWGWOPCECEIHVQVRVMTVS $.

    $d r A $.  $d r B $.  $d r K $.  $d r .<_ $.  $d r P $.  $d r Q $.
    $d r X $.
    $( There exists a 3rd atom ` r ` on a line ` P .\/ Q ` intersecting element
       ` X ` at ` P ` , such that ` r ` is different from ` Q ` and not in
       ` X ` .  (Contributed by NM, 30-Jul-2012.)
       (New usage is discouraged.) $)
    atbtwnexOLDN $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
        /\ ( X e. B /\ P .<_ X /\ -. Q .<_ X ) )
    -> E. r e. A ( r =/= Q /\ -. r .<_ X /\ r .<_ ( P .\/ Q ) ) ) $=
      ( chlt wcel w3a wbr wn wne wrex wa cv simpr2 simpr3 nbrne2 syl2anc hlsupr
      co syldan simp32 simp31 wb simp1l simp2 simp1r1 simp1r2 simp1r3 syl123anc
      simp33 atbtwn mpbid 3jca 3exp reximdvai mpd ) FNOCAODAOPZHBOZCHGQZDHGQRZP
      ZUAZIUBZCSZVLDSZVLCDEUHGQZPZIATZVNVLHGQRZVOPZIATVFVJCDSZVQVKVHVIVTVFVGVHV
      IUCVFVGVHVIUDCDHGUEUFACDEFGIKLMUGUIVKVPVSIAVKVLAOZVPVSVKWAVPPZVNVRVOVKWAV
      MVNVOUJWBVMVRVKWAVMVNVOUKWBVFWAVGVHVIVOVMVRULVFVJWAVPUMVKWAVPUNVGVHVIVFWA
      VPUOVGVHVIVFWAVPUPVGVHVIVFWAVPUQVKWAVMVNVOUSZABCDVLEFGHJKLMUTURVAWCVBVCVD
      VE $.

    $( Given atoms ` P ` in ` X ` and ` Q ` not in ` X ` , there exists an atom
       ` r ` not in ` X ` such that the line ` Q .\/ r ` intersects ` X ` at
       ` P ` .  (Contributed by NM, 1-Aug-2012.) $)
    atbtwnex $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
        /\ ( X e. B /\ P .<_ X /\ -. Q .<_ X ) )
    -> E. r e. A ( r =/= Q /\ -. r .<_ X /\ P .<_ ( Q .\/ r ) ) ) $=
      ( wcel w3a wbr wn wne co wrex chlt wa simpr2 simpr3 nbrne2 syl2anc hlsupr
      cv syldan simp32 simp31 wb simp1l simp2 simp1r1 simp1r2 simp1r3 syl123anc
      simp33 atbtwn wi simp1l1 simp1l2 simp1l3 hlatexch2 syl131anc mpd hlatjcom
      mpbid wceq syl3anc breqtrrd 3jca 3exp reximdvai ) FUANZCANZDANZOZHBNZCHGP
      ZDHGPQZOZUBZIUHZCRZWEDRZWECDESGPZOZIATZWGWEHGPQZCDWEESZGPZOZIATVSWCCDRZWJ
      WDWAWBWOVSVTWAWBUCVSVTWAWBUDCDHGUEUFACDEFGIKLMUGUIWDWIWNIAWDWEANZWIWNWDWP
      WIOZWGWKWMWDWPWFWGWHUJZWQWFWKWDWPWFWGWHUKWQVSWPVTWAWBWHWFWKULVSWCWPWIUMWD
      WPWIUNZVTWAWBVSWPWIUOVTWAWBVSWPWIUPVTWAWBVSWPWIUQWDWPWFWGWHUSZABCDWEEFGHJ
      KLMUTURVIWQCWEDESZWLGWQWHCXAGPZWTWQVPWPVQVRWGWHXBVAVPVQVRWCWPWIVBZWSVPVQV
      RWCWPWIVCVPVQVRWCWPWIVDZWRAWECDEFGKLMVEVFVGWQVPVRWPWLXAVJXCXDWSAEFDWELMVH
      VKVLVMVNVOVG $.
  $}

  ${
    3noncol.l $e |- .<_ = ( le ` K ) $.
    3noncol.j $e |- .\/ = ( join ` K ) $.
    3noncol.a $e |- A = ( Atoms ` K ) $.
    $( Two ways to express 3 non-colinear atoms (rotated right 2 places).
       (Contributed by NM, 12-Jul-2012.) $)
    3noncolr2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
  /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
  -> ( Q =/= R /\ -. P .<_ ( Q .\/ R ) ) ) $=
      ( chlt wcel w3a wne co wbr wn atbase syl syl131anc wa clat hllat 3ad2ant1
      cbs cfv simp23 eqid simp21 simp22 simp3r latnlej1r necomd wi simp1 simp3l
      hlatexch1 wceq hlatjcom syl3anc breq2d sylibrd mtod jca ) FKLZBALZCALZDAL
      ZMZBCNZDBCEOZGPZQZUAZMZCDNBCDEOGPZQVODCVOFUBLZDFUEUFZLZBVRLZCVRLZVMDCNVEV
      IVQVNFUCUDVOVHVSVEVFVGVHVNUGZAVRDFVRUHZJRSVOVFVTVEVFVGVHVNUIZAVRBFWCJRSVO
      VGWAVEVFVGVHVNUJZAVRCFWCJRSVEVIVJVMUKZVREFGDBCWCHIULTUMVOVPVLWFVOVPDCBEOZ
      GPZVLVOVEVFVHVGVJVPWHUNVEVIVNUOZWDWBWEVEVIVJVMUPABDCEFGHIJUQTVOVKWGDGVOVE
      VFVGVKWGURWIWDWEAEFBCIJUSUTVAVBVCVD $.

    $( Two ways to express 3 non-colinear atoms (rotated right 1 place).
       (Contributed by NM, 12-Jul-2012.)  (New usage is discouraged.) $)
    3noncolr1N $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
  /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
  -> ( R =/= P /\ -. Q .<_ ( R .\/ P ) ) ) $=
      ( chlt wcel w3a wne co wbr wn wa simp1 3noncolr2 simp22 simp23 syl131anc
      simp21 ) FKLZBALZCALZDALZMZBCNDBCEOGPQRZMUEUGUHUFCDNBCDEOGPQRDBNCDBEOGPQR
      UEUIUJSUEUFUGUHUJUAUEUFUGUHUJUBUEUFUGUHUJUDABCDEFGHIJTACDBEFGHIJTUC $.

    $( TODO: replace with ~ 3noncolr2 ? $)
    $( Atom exchange combined with contraposition.  (Contributed by NM,
       13-Jun-2012.) $)
    hlatcon3 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
      /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> -. P .<_ ( Q .\/ R ) ) $=
      ( chlt wcel w3a wne co wbr wn wa 3noncolr2 simprd ) FKLBALCALDALMBCNDBCEO
      GPQRMCDNBCDEOGPQABCDEFGHIJST $.

    $( Atom exchange combined with contraposition.  (Contributed by NM,
       13-Jun-2012.) $)
    hlatcon2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
      /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> -. P .<_ ( R .\/ Q ) ) $=
      ( chlt wcel w3a wne co wbr wn wa hlatcon3 wceq simp1 simp22 simp23 breq2d
      hlatjcom syl3anc mtbid ) FKLZBALZCALZDALZMZBCNDBCEOGPQRZMZBCDEOZGPBDCEOZG
      PABCDEFGHIJSUNUOUPBGUNUHUJUKUOUPTUHULUMUAUHUIUJUKUMUBUHUIUJUKUMUCAEFCDIJU
      EUFUDUG $.

    $( A way to express 4 non-colinear atoms (rotated right 3 places).
       (Contributed by NM, 11-Jul-2012.) $)
    4noncolr3 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
      /\ ( R e. A /\ S e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
          /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
  -> ( Q =/= R /\ -. S .<_ ( Q .\/ R )
         /\ -. P .<_ ( ( Q .\/ R ) .\/ S ) ) ) $=
      ( wcel w3a co wbr wn syl atbase syl131anc wceq chlt wa wne cbs cfv simp11
      clat simp2l eqid simp12 simp13 simp32 necomd simp2r latjcl syl3anc simp33
      hllat latnlej1r hlatjass syl13anc breq2d mtbid latnlej2r simp31 hlatexch1
      wi latjcom sylibrd mtod hlexch1 oveq1d latj31 eqtrd sylibd 3jca ) GUALZBA
      LZCALZMZDALZEALZUBZBCUCZDBCFNZHOZPZEWEDFNZHOZPZMZMZCDUCECDFNZHOPZBWMEFNHO
      ZPWLDCWLGUGLZDGUDUEZLZBWQLZCWQLZWGDCUCWLVQWPVQVRVSWCWKUFZGURQZWLWAWRVTWAW
      BWKUHZAWQDGWQUIZKRQZWLVRWSVQVRVSWCWKUJZAWQBGXDKRQZWLVSWTVQVRVSWCWKUKZAWQC
      GXDKRQZVTWCWDWGWJULZWQFGHDBCXDIJUSSUMWLWPEWQLZWSWMWQLZEBWMFNZHOZPWNXBWLWB
      XKVTWAWBWKUNZAWQEGXDKRQXGWLWPWTWRXLXBXIXEWQFGCDXDJUOUPZWLWIXNVTWCWDWGWJUQ
      ZWLWHXMEHWLVQVRVSWAWHXMTXAXFXHXCABCDFGJKUTVAVBVCWQFGHEBWMXDIJVDSWLWOWIXQW
      LWOEWMBFNZHOZWIWLVQVRWBXLBWMHOZPWOXSVGXAXFXOXPWLXTWFXJWLXTDCBFNZHOZWFWLVQ
      VRWAVSWDXTYBVGXAXFXCXHVTWCWDWGWJVEABDCFGHIJKVFSWLWEYADHWLWPWSWTWEYATXBXGX
      IWQFGBCXDJVHUPVBVIVJAWQBEFGHWMXDIJKVKSWLXRWHEHWLXRDCFNZBFNZWHWLWMYCBFWLWP
      WTWRWMYCTXBXIXEWQFGCDXDJVHUPVLWLWPWRWTWSYDWHTXBXEXIXGWQFGDCBXDJVMVAVNVBVO
      VJVP $.

    $( A way to express 4 non-colinear atoms (rotated right 2 places).
       (Contributed by NM, 11-Jul-2012.) $)
    4noncolr2 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
      /\ ( R e. A /\ S e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
        /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
  -> ( R =/= S /\ -. P .<_ ( R .\/ S )
        /\ -. Q .<_ ( ( R .\/ S ) .\/ P ) ) ) $=
      ( chlt wcel w3a wa wne co wbr wn 4noncolr3 simp11 simp13 simp2l syl321anc
      simp2r simp12 ) GLMZBAMZCAMZNZDAMZEAMZOZBCPDBCFQZHRSEUNDFQHRSNZNUGUIUKULU
      HCDPECDFQZHRSBUPEFQHRSNDEPBDEFQZHRSCUQBFQHRSNUGUHUIUMUOUAUGUHUIUMUOUBUJUK
      ULUOUCUJUKULUOUEUGUHUIUMUOUFABCDEFGHIJKTACDEBFGHIJKTUD $.

    $( A way to express 4 non-colinear atoms (rotated right 1 places).
       (Contributed by NM, 11-Jul-2012.) $)
    4noncolr1 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
      /\ ( R e. A /\ S e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
        /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
  -> ( S =/= P /\ -. Q .<_ ( S .\/ P )
          /\ -. R .<_ ( ( S .\/ P ) .\/ Q ) ) ) $=
      ( chlt wcel w3a wa wne co wbr wn simp11 simp13 simp2l 4noncolr3 4noncolr2
      simp2r simp12 syl321anc ) GLMZBAMZCAMZNZDAMZEAMZOZBCPDBCFQZHRSEUODFQHRSNZ
      NUHUJULUMUICDPECDFQZHRSBUQEFQHRSNEBPCEBFQZHRSDURCFQHRSNUHUIUJUNUPTUHUIUJU
      NUPUAUKULUMUPUBUKULUMUPUEUHUIUJUNUPUFABCDEFGHIJKUCACDEBFGHIJKUDUG $.
  $}

  ${
    $d p q r s x y z A $.  $d x y z C $.  $d r s x y z .\/ $.
    $d p q r s x y z K $.
    athgt.j $e |- .\/ = ( join ` K ) $.
    athgt.c $e |- C = ( <o ` K ) $.
    athgt.a $e |- A = ( Atoms ` K ) $.
    $( A Hilbert lattice, whose height is at least 4, has a chain of 4
       successively covering atom joins.  (Contributed by NM, 3-May-2012.) $)
    athgt $p |- ( K e. HL -> E. p e. A E. q e. A
        ( p C ( p .\/ q )
           /\ E. r e. A ( ( p .\/ q ) C ( ( p .\/ q ) .\/ r ) /\
     E. s e. A
          ( ( p .\/ q ) .\/ r ) C ( ( ( p .\/ q ) .\/ r ) .\/ s ) ) ) ) $=
      ( wcel cfv cv wbr wa wrex wi w3a syl vx vy vz chlt cp0 cplt cp1 co hlhgt4
      cbs eqid cple simpl1 cops hlop op0cl simpl2l simprll hlrelat3 syl31anc wb
      3syl simp11 simp3 atcvr0 syl2anc wceq hlol atbase 3ad2ant3 olj02 breqtrrd
      col biantrurd breq1d bitr3d 3expa rexbidva mpbid 3adant3r simp12r simp2lr
      simp3r hlpos simp12l plelttr syl13anc mp2and hllat simp3ll simp3lr latjcl
      cpo clat syl3anc simp13 simp2l simp12 simp1ll simp2ll simp3l op1cl simp1r
      simp1lr simpl reximi 3exp exp4a 3adant2 3imp 3adant2l imp anim2d reximdva
      ex mpd 3imp1 3expia exp3a reximdvai 3exp1 rexlimdv rexlimdvva ) DUDLZDUEM
      ZUANZDUFMZOZYFUBNZYGOZPZYIUCNZYGOZYLDUGMZYGOZPZPZUCDUJMZQZUBYRQUAYRQHNZYT
      GNZCUHZBOZUUBUUBFNZCUHZBOZUUEUUEENCUHZBOZEAQZPZFAQZPZGAQZHAQZUAUBUCYRYGYN
      DYEYRUKZYGUKZYEUKZYNUKZUIYDYSUUNUAUBYRYRYDYFYRLZYIYRLZPZPYQUUNUCYRYDUVAYL
      YRLZYQUUNRRYDUVAUVBYQUUNYDUVAUVBSZYQPZYTYFDULMZOZHAQZUUNUVDYEYEYTCUHZBOZU
      VHYFUVEOZPZHAQZUVGUVDYDYEYRLZUUSYHUVLYDUVAUVBYQUMZUVDYDDUNLZUVMUVNDUOZYRD
      YEUUOUUQUPVBUUSUUTYDUVBYQUQUVCYHYJYPURAYRBYGCDUVEYEYFHUUOUVEUKZUUPIJKUSUT
      UVDUVKUVFHAUVCYQYTALZUVKUVFVAUVCYQUVRSZUVJUVKUVFUVSUVIUVJUVSYEYTUVHBUVSYD
      UVRYEYTBOYDUVAUVBYQUVRVCZUVCYQUVRVDABUDYTDYEUUQJKVEVFUVSDVMLZYTYRLZUVHYTV
      GUVSYDUWAUVTDVHTUVRUVCUWBYQAYRYTDUUOKVIZVJZYRCDYTYEUUOIUUQVKVFZVLVNUVSUVH
      YTYFUVEUWEVOVPVQVRVSUVDUVFUUMHAUVDUVRUVFUUMUVCYQUVRUVFPZUUMUVCYQUWFSZUUCU
      UBYIUVEOZPZGAQZUUMUWGYDUWBUUTYTYIYGOZUWJYDUVAUVBYQUWFVCZUVCYQUVRUWBUVFUWD
      VTZUUSUUTYDUVBYQUWFWAZUWGUVFYJUWKUVCYQUVRUVFWCYHYJYPUVCUWFWBUWGDWMLZUWBUU
      SUUTUVFYJPUWKRUWGYDUWOUWLDWDZTUWMUUSUUTYDUVBYQUWFWEUWNYRYGDUVEYTYFYIUUOUV
      QUUPWFWGWHAYRBYGCDUVEYTYIGUUOUVQUUPIJKUSUTUVCYQUVRUWJUUMRZUVFUVCYPUVRUWQY
      KUVCYPUVRSZUWIUULGAUWRUUAALZPUWHUUKUUCUVCYPUVRUWSUWHUUKRZYDUUTUVBYPUVRUWS
      UWTRRRUUSYDUUTUVBSZYPUVRUWSUWTUXAYPUVRUWSPZUWHUUKUXAYPUXBUWHPZUUKUXAYPUXC
      SZUUFUUEYLUVEOZPZFAQZUUKUXDYDUUBYRLZUVBUUBYLYGOZUXGYDUUTUVBYPUXCVCZUXDDWN
      LZUWBUUAYRLZUXHUXDYDUXKUXJDWIZTUXDUVRUWBUVRUWSUWHUXAYPWJUWCTUXDUWSUXLUVRU
      WSUWHUXAYPWKAYRUUADUUOKVIZTYRCDYTUUAUUOIWLZWOZYDUUTUVBYPUXCWPZUXDUWHYMUXI
      UXAYPUXBUWHWCUXAYMYOUXCWQUXDUWOUXHUUTUVBUWHYMPUXIRUXDYDUWOUXJUWPTUXPYDUUT
      UVBYPUXCWRUXQYRYGDUVEUUBYIYLUUOUVQUUPWFWGWHAYRBYGCDUVEUUBYLFUUOUVQUUPIJKU
      SUTUXDUXFUUJFAUXDUUDALZPUXEUUIUUFUXDUXRUXEUUIRZUXAYOUXCUXRUXSRZYMUXAYOUXC
      UXTYDUVBYOUXCUXTRZRUUTYDUVBPZYOUYAUYBYOPZUXCUXRUXEUUIUYCUXCUXRUXEPZUUIUYC
      UXCUYDSZUUHUUGYNUVEOZPZEAQZUUIUYEYDUUEYRLZYNYRLZUUEYNYGOZUYHYDUVBYOUXCUYD
      WSZUYEUXKUXHUUDYRLZUYIUYEYDUXKUYLUXMTZUYEUXKUWBUXLUXHUYNUYEUVRUWBUVRUWSUW
      HUYCUYDWTUWCTUYEUWSUXLUVRUWSUWHUYCUYDWBUXNTUXOWOUYEUXRUYMUYCUXCUXRUXEXAAY
      RUUDDUUOKVITYRCDUUBUUDUUOIWLWOZUYEYDUVOUYJUYLUVPYRYNDUUOUURXBVBZUYEUXEYOU
      YKUYCUXCUXRUXEWCUYBYOUXCUYDXCUYEUWOUYIUVBUYJUXEYOPUYKRUYEYDUWOUYLUWPTUYOY
      DUVBYOUXCUYDXDUYPYRYGDUVEUUEYLYNUUOUVQUUPWFWGWHAYRBYGCDUVEUUEYNEUUOUVQUUP
      IJKUSUTUYGUUHEAUUHUYFXEXFTXGXHXOXIXJXKXLXMXNXPXGXHXHXKXQXMXNXKVTXPXRXSXTX
      PYAXLYBYCXP $.
  $}

  ${
    $d p q r s A $.  $d r s .\/ $.
    3dim0.j $e |- .\/ = ( join ` K ) $.
    3dim0.l $e |- .<_ = ( le ` K ) $.
    3dim0.a $e |- A = ( Atoms ` K ) $.
    ${
      $d p q r s K $.
      $( There exists a 3-dimensional (height-4) element i.e. a volume.
         (Contributed by NM, 25-Jul-2012.) $)
      3dim0 $p |- ( K e. HL -> E. p e. A E. q e. A E. r e. A E. s e. A
     ( p =/= q /\ -. r .<_ ( p .\/ q )
             /\ -. s .<_ ( ( p .\/ q ) .\/ r ) ) ) $=
        ( wcel cv co wbr wn wrex wa wb syl3anc chlt wne w3a ccvr cfv eqid athgt
        df-3an cbs simpll1 hlatjcl ad2antrr simplr cvr1 anbi2d hllat syl atbase
        clat ad2antlr latjcl simpr anbi12d syl5bb rexbidva r19.42v anass syl6bb
        bitri atcvr1 anbi1d bitrd 3expb 2rexbidva mpbird ) CUALZHMZGMZUBZFMZVQV
        RBNZDOPZEMZWAVTBNZDOPZUCZEAQZFAQZGAQHAQVQWACUDUEZOZWAWDWIOZWDWDWCBNWIOZ
        EAQZRZFAQZRZGAQHAQAWIBCEFGHIWIUFZKUGVPWHWPHGAAVPVQALZVRALZWHWPSVPWRWSUC
        ZWHVSWORZWPWTWHVSWNRZFAQXAWTWGXBFAWTVTALZRZWGVSWKRZWLRZEAQZXBXDWFXFEAWF
        VSWBRZWERXDWCALZRZXFVSWBWEUHXJXHXEWEWLXJWBWKVSXJVPWACUIUEZLZXCWBWKSVPWR
        WSXCXIUJZWTXLXCXIAXKBCVQVRXKUFZIKUKULZWTXCXIUMAXKWIVTBCDWAXNJIWQKUNTUOX
        JVPWDXKLZXIWEWLSXMXJCUSLZXLVTXKLZXPXJVPXQXMCUPUQXOXCXRWTXIAXKVTCXNKURUT
        XKBCWAVTXNIVATXDXIVBAXKWIWCBCDWDXNJIWQKUNTVCVDVEXGXEWMRXBXEWLEAVFVSWKWM
        VGVIVHVEVSWNFAVFVHWTVSWJWOAWIVQVRBCIWQKVJVKVLVMVNVO $.
    $}

    $( Lemma for ~ 3dim1 .  (Contributed by NM, 25-Jul-2012.) $)
    3dimlem1 $p |- ( ( ( Q =/= R /\ -. S .<_ ( Q .\/ R ) /\ -. T .<_ ( (
   Q .\/ R ) .\/ S ) ) /\ P = Q )
  -> ( P =/= R /\ -. S .<_ ( P .\/ R )
         /\ -. T .<_ ( ( P .\/ R ) .\/ S ) ) ) $=
      ( wceq wne co wbr wn w3a breq2d notbid neeq1 oveq1d 3anbi123d biimparc
      oveq1 ) BCMZBDNZEBDGOZIPZQZFUHEGOZIPZQZRCDNZECDGOZIPZQZFUOEGOZIPZQZRUFUGU
      NUJUQUMUTBCDUAUFUIUPUFUHUOEIBCDGUEZSTUFULUSUFUKURFIUFUHUOEGVAUBSTUCUD $.

    $( Lemma for ~ 3dim1 .  (Contributed by NM, 25-Jul-2012.) $)
    3dimlem2 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\
  ( R e. A /\ -. S .<_ ( Q .\/ R ) /\ -. T .<_ ( ( Q .\/ R ) .\/ S ) )
  /\ ( P =/= Q /\ P .<_ ( Q .\/ R ) ) )
  -> ( P =/= Q /\ -. S .<_ ( P .\/ Q )
         /\ -. T .<_ ( ( P .\/ Q ) .\/ S ) ) ) $=
      ( wcel w3a co wbr wn wceq breq2d mtbird chlt wne simp3l hlatjcom 3ad2ant1
      wa simp22 simp3r wb simp11 simp12 simp21 hlatexchb1 syl131anc mpbid eqtrd
      simp13 simp23 oveq1d 3jca ) HUAMZBAMZCAMZNZDAMZECDGOZIPZQZFVFEGOZIPZQZNZB
      CUBZBVFIPZUFZNZVMEBCGOZIPZQFVQEGOZIPZQVDVLVMVNUCZVPVRVGVDVEVHVKVOUGVPVQVF
      EIVPVQCBGOZVFVDVLVQWBRVOAGHBCJLUDUEVPVNWBVFRZVDVLVMVNUHVPVAVBVEVCVMVNWCUI
      VAVBVCVLVOUJVAVBVCVLVOUKVDVEVHVKVOULVAVBVCVLVOUQWAABDCGHIKJLUMUNUOUPZSTVP
      VTVJVDVEVHVKVOURVPVSVIFIVPVQVFEGWDUSSTUT $.

    $( TODO - check if it is more efficient to eliminate this and
       use ~ 3dimlem3OLDN $)
    $( Lemma for ~ 3dim3 .  (Contributed by NM, 27-Jul-2012.) $)
    3dimlem3a $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
           /\ ( R e. A /\ S e. A )
           /\ ( -. T .<_ ( ( Q .\/ R ) .\/ S )
             /\ -. P .<_ ( Q .\/ R ) /\ P .<_ ( ( Q .\/ R ) .\/ S ) ) )
     -> -. T .<_ ( ( P .\/ Q ) .\/ R ) ) $=
      ( wcel w3a co wbr wn wceq syl atbase chlt wa simp31 clat cbs simp11 hllat
      cfv simp13 simp2l simp12 latjrot syl13anc simp33 wb simp2r hlatjcl simp32
      eqid syl3anc hlexchb1 syl131anc mpbid eqtr3d breq2d mtbird ) HUAMZBAMZCAM
      ZNZDAMZEAMZUBZFCDGOZEGOZIPZQZBVNIPQZBVOIPZNZNZFBCGODGOZIPVPVJVMVQVRVSUCWA
      WBVOFIWAVNBGOZWBVOWAHUDMZCHUEUHZMZDWEMZBWEMZWCWBRWAVGWDVGVHVIVMVTUFZHUGSW
      AVIWFVGVHVIVMVTUIZAWECHWEUSZLTSWAVKWGVJVKVLVTUJZAWEDHWKLTSWAVHWHVGVHVIVMV
      TUKZAWEBHWKLTSWEGHCDBWKJULUMWAVSWCVORZVJVMVQVRVSUNWAVGVHVLVNWEMZVRVSWNUOW
      IWMVJVKVLVTUPWAVGVIVKWOWIWJWLAWEGHCDWKJLUQUTVJVMVQVRVSURAWEBEGHIVNWKKJLVA
      VBVCVDVEVF $.

    $( Lemma for ~ 3dim1 .  (Contributed by NM, 25-Jul-2012.) $)
    3dimlem3 $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
           /\ ( R e. A /\ S e. A )
           /\ ( Q =/= R /\ -. T .<_ ( ( Q .\/ R ) .\/ S ) ) )
       /\ ( P =/= Q /\ -. P .<_ ( Q .\/ R )
          /\ P .<_ ( ( Q .\/ R ) .\/ S ) ) )
  -> ( P =/= Q /\ -. R .<_ ( P .\/ Q )
        /\ -. T .<_ ( ( P .\/ Q ) .\/ R ) ) ) $=
      ( chlt wcel w3a wa wne co wbr wn simpr1 simpr2 wi simpl11 simpl2l simpl12
      simpl13 simpl3l necomd hlatexch2 syl131anc hlatjcom syl3anc breq2d simpl1
      wceq sylibrd mtod simpl2 simpl3r simpr3 3dimlem3a syl113anc 3jca ) HMNZBA
      NZCANZOZDANZEANZPZCDQZFCDGRZEGRZISTZPZOZBCQZBVMISZTZBVNISZOZPZVRDBCGRZISZ
      TFWDDGRISTZVQVRVTWAUAWCWEVSVQVRVTWAUBZWCWEBDCGRZISZVSWCVEVIVFVGDCQWEWIUCV
      EVFVGVKVPWBUDZVIVJVHVPWBUEZVEVFVGVKVPWBUFVEVFVGVKVPWBUGZWCCDVLVOVHVKWBUHU
      IADBCGHIKJLUJUKWCVMWHBIWCVEVGVIVMWHUPWJWLWKAGHCDJLULUMUNUQURWCVHVKVOVTWAW
      FVHVKVPWBUOVHVKVPWBUSVLVOVHVKWBUTWGVQVRVTWAVAABCDEFGHIJKLVBVCVD $.

    $( See TODO above $)
    $( Lemma for ~ 3dim1 .  (Contributed by NM, 25-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    3dimlem3OLDN $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
           /\ ( R e. A /\ S e. A )
           /\ ( Q =/= R /\ -. T .<_ ( ( Q .\/ R ) .\/ S ) ) )
       /\ ( P =/= Q /\ -. P .<_ ( Q .\/ R )
           /\ P .<_ ( ( Q .\/ R ) .\/ S ) ) )
  -> ( P =/= Q /\ -. R .<_ ( P .\/ Q )
          /\ -. T .<_ ( ( P .\/ Q ) .\/ R ) ) ) $=
      ( wcel w3a wa wne co wbr wn syl simpr1 wi simpl11 simpl2l simpl12 simpl13
      simpr2 simpl3l necomd hlatexch2 syl131anc hlatjcom syl3anc breq2d sylibrd
      chlt wceq mtod simpl3r clat cbs hllat eqid atbase latjrot syl13anc simpr3
      cfv wb simpl2r hlatjcl hlexchb1 mpbid eqtr3d mtbird 3jca ) HUPMZBAMZCAMZN
      ZDAMZEAMZOZCDPZFCDGQZEGQZIRZSZOZNZBCPZBWEIRZSZBWFIRZNZOZWKDBCGQZIRZSFWQDG
      QZIRZSWJWKWMWNUAWPWRWLWJWKWMWNUGZWPWRBDCGQZIRZWLWPVQWAVRVSDCPWRXCUBVQVRVS
      WCWIWOUCZWAWBVTWIWOUDZVQVRVSWCWIWOUEZVQVRVSWCWIWOUFZWPCDWDWHVTWCWOUHUIADB
      CGHIKJLUJUKWPWEXBBIWPVQVSWAWEXBUQXDXGXEAGHCDJLULUMUNUOURWPWTWGWDWHVTWCWOU
      SWPWSWFFIWPWEBGQZWSWFWPHUTMZCHVAVHZMZDXJMZBXJMZXHWSUQWPVQXIXDHVBTWPVSXKXG
      AXJCHXJVCZLVDTWPWAXLXEAXJDHXNLVDTWPVRXMXFAXJBHXNLVDTXJGHCDBXNJVEVFWPWNXHW
      FUQZWJWKWMWNVGWPVQVRWBWEXJMZWMWNXOVIXDXFWAWBVTWIWOVJWPVQVSWAXPXDXGXEAXJGH
      CDXNJLVKUMXAAXJBEGHIWEXNKJLVLUKVMVNUNVOVP $.

    $( TODO - check if it is more efficient to eliminate this and
       use ~ 3dimlem4OLDN $)
    $( Lemma for ~ 3dim3 .  (Contributed by NM, 27-Jul-2012.) $)
    3dimlem4a $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
      /\ ( R e. A /\ S e. A ) /\ ( -. S .<_ ( Q .\/ R )
           /\ -. P .<_ ( Q .\/ R ) /\ -. P .<_ ( ( Q .\/ R ) .\/ S ) ) )
   -> -. S .<_ ( ( P .\/ Q ) .\/ R ) ) $=
      ( chlt wcel w3a wa co wbr wn syl atbase simp33 clat cbs wceq simp11 hllat
      cfv simp13 simp2l simp12 latjrot syl13anc breq2d wi simp2r latjcl syl3anc
      eqid simp31 hlexch1 syl131anc sylbird mtod ) GLMZBAMZCAMZNZDAMZEAMZOZECDF
      PZHQRZBVKHQRZBVKEFPHQZRZNZNZEBCFPDFPZHQZVNVGVJVLVMVOUAVQVSEVKBFPZHQZVNVQV
      TVREHVQGUBMZCGUCUGZMZDWCMZBWCMZVTVRUDVQVDWBVDVEVFVJVPUEZGUFSZVQVFWDVDVEVF
      VJVPUHAWCCGWCURZKTSZVQVHWEVGVHVIVPUIAWCDGWIKTSZVQVEWFVDVEVFVJVPUJZAWCBGWI
      KTSWCFGCDBWIIUKULUMVQVDVIVEVKWCMZVLWAVNUNWGVGVHVIVPUOWLVQWBWDWEWMWHWJWKWC
      FGCDWIIUPUQVGVJVLVMVOUSAWCEBFGHVKWIJIKUTVAVBVC $.

    $( Lemma for ~ 3dim1 .  (Contributed by NM, 25-Jul-2012.) $)
    3dimlem4 $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
       /\ ( R e. A /\ S e. A )
       /\ ( Q =/= R /\ -. S .<_ ( Q .\/ R ) ) )
     /\ ( P =/= Q /\ -. P .<_ ( Q .\/ R ) )
        /\ -. P .<_ ( ( Q .\/ R ) .\/ S ) )
  -> ( P =/= Q /\ -. R .<_ ( P .\/ Q )
         /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) ) $=
      ( wcel w3a wa wne co wbr wn simp2l wi chlt simp2r simp11 simp12 hlatexch2
      simp13 simp3l necomd syl131anc wceq hlatjcom syl3anc breq2d 3ad2ant1 mtod
      sylibrd simp13r simp3 3dimlem4a syl113anc 3jca ) GUALZBALZCALZMZDALZEALZN
      ZCDOZECDFPZHQRZNZMZBCOZBVJHQZRZNZBVJEFPHQRZMZVNDBCFPZHQZREVTDFPHQRZVMVNVP
      VRSVSWAVOVMVNVPVRUBZVMVQWAVOTVRVMWABDCFPZHQZVOVMVBVFVCVDDCOWAWETVBVCVDVHV
      LUCZVEVFVGVLSZVBVCVDVHVLUDVBVCVDVHVLUFZVMCDVEVHVIVKUGUHADBCFGHJIKUEUIVMVJ
      WDBHVMVBVDVFVJWDUJWFWHWGAFGCDIKUKULUMUPUNUOVSVEVHVKVPVRWBVEVHVLVQVRUCVEVH
      VLVQVRUDVIVKVEVHVQVRUQWCVMVQVRURABCDEFGHIJKUSUTVA $.

    $( See TODO above $)
    $( Lemma for ~ 3dim1 .  (Contributed by NM, 25-Jul-2012.)
       (Proof modification is discouraged.)  (New usage is discouraged.) $)
    3dimlem4OLDN $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
       /\ ( R e. A /\ S e. A )
       /\ ( Q =/= R /\ -. S .<_ ( Q .\/ R ) ) )
     /\ ( P =/= Q /\ -. P .<_ ( Q .\/ R ) )
        /\ -. P .<_ ( ( Q .\/ R ) .\/ S ) )
  -> ( P =/= Q /\ -. R .<_ ( P .\/ Q )
         /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) ) $=
      ( wcel w3a wa wne co wbr wn wi syl chlt simp2l simp2r hlatexch2 syl131anc
      simp11 simp12 simp13 simp3l necomd wceq hlatjcom syl3anc sylibrd 3ad2ant1
      breq2d mtod simp3 clat cbs cfv hllat eqid atbase latjrot syl13anc hlatjcl
      simp3r hlexch1 sylbird 3jca ) GUALZBALZCALZMZDALZEALZNZCDOZECDFPZHQRZNZMZ
      BCOZBVTHQZRZNZBVTEFPHQZRZMZWDDBCFPZHQZREWKDFPZHQZRWCWDWFWIUBWJWLWEWCWDWFW
      IUCWCWGWLWESWIWCWLBDCFPZHQZWEWCVLVPVMVNDCOWLWPSVLVMVNVRWBUFZVOVPVQWBUBZVL
      VMVNVRWBUGZVLVMVNVRWBUHZWCCDVOVRVSWAUIUJADBCFGHJIKUDUEWCVTWOBHWCVLVNVPVTW
      OUKWQWTWRAFGCDIKULUMUPUNUOUQWJWNWHWCWGWIURWCWGWNWHSWIWCWNEVTBFPZHQZWHWCXA
      WMEHWCGUSLZCGUTVAZLZDXDLZBXDLZXAWMUKWCVLXCWQGVBTWCVNXEWTAXDCGXDVCZKVDTWCV
      PXFWRAXDDGXHKVDTWCVMXGWSAXDBGXHKVDTXDFGCDBXHIVEVFUPWCVLVQVMVTXDLZWAXBWHSW
      QVOVPVQWBUCWSWCVLVNVPXIWQWTWRAXDFGCDXHIKVGUMVOVRVSWAVHAXDEBFGHVTXHJIKVIUE
      VJUOUQVK $.

    $d t u v w A $.  $d q t u v w .\/ $.  $d t u v w K $.
    $d q r s t u v w .<_ $.  $d q r s t u v w P $.
    $( Lemma for ~ 3dim1 .  (Contributed by NM, 26-Jul-2012.) $)
    3dim1lem5 $p |- ( ( ( u e. A /\ v e. A /\ w e. A )
     /\ ( P =/= u /\ -. v .<_ ( P .\/ u )
         /\ -. w .<_ ( ( P .\/ u ) .\/ v ) ) )
   -> E. q e. A E. r e. A E. s e. A
     ( P =/= q /\ -. r .<_ ( P .\/ q )
           /\ -. s .<_ ( ( P .\/ q ) .\/ r ) ) ) $=
      ( cv co wbr wn w3a notbid wne neeq2 oveq2 breq2d 3anbi123d breq1 3anbi23d
      weq oveq1d 3anbi3d rspc3ev ) EKOZUAZJOZEULFPZHQZRZIOZUOUNFPZHQZRZSECOZUAZ
      BOZEVBFPZHQZRZAOZVEVDFPZHQZRZSVCUNVEHQZRZURVEUNFPZHQZRZSVCVGURVIHQZRZSKJI
      VBVDVHDDDKCUHZUMVCUQVMVAVPULVBEUBVSUPVLVSUOVEUNHULVBEFUCZUDTVSUTVOVSUSVNU
      RHVSUOVEUNFVTUIUDTUEJBUHZVMVGVPVRVCWAVLVFUNVDVEHUFTWAVOVQWAVNVIURHUNVDVEF
      UCUDTUGIAUHZVRVKVCVGWBVQVJURVHVIHUFTUJUK $.

    $( Construct a 3-dimensional volume (height-4 element) on top of a given
       atom ` P ` .  (Contributed by NM, 25-Jul-2012.) $)
    3dim1 $p |- ( ( K e. HL /\ P e. A ) -> E. q e. A E. r e. A E. s e. A
     ( P =/= q /\ -. r .<_ ( P .\/ q )
          /\ -. s .<_ ( ( P .\/ q ) .\/ r ) ) ) $=
      ( vt vu vv vw wa co wbr wn w3a chlt wcel cv wne wrex 3dim0 adantr wi wceq
      simpl2 3dimlem1 3ad2antl3 3dim1lem5 syl2anc simp13 simp22 simp23 ad2antrr
      simpll1 simp21 simp32 simp33 simplr simpr 3dimlem2 syl112anc simp1 simp31
      3jca jca simplrl simplrr 3dimlem3 syl13anc simpl1 simpl21 simpl22 simpl31
      simpl32 3dimlem4 syl3anc pm2.61dan pm2.61dane 3expd imp43 imp3a rexlimdvv
      anassrs 3exp rexlimdvva mpd ) DUAUBZBAUBZPZLUCZMUCZUDZNUCZWOWPCQZERSZOUCZ
      WSWRCQZERSZTZOAUENAUEZMAUELAUEZBHUCZUDGUCZBXGCQZERSFUCXIXHCQERSTFAUEGAUEH
      AUEZWLXFWMACDEONMLIJKUFUGWNXEXJLMAAWNWOAUBZWPAUBZPPZXDXJNOAAXMWRAUBZXAAUB
      ZXDXJUHZWLWMXKXLXNXOXPUHUHZWLWMXKXLXQUHWLWMXKTZXLXNXOXPXRXLXNXOTZXDXJXRXS
      XDTZXJBWOXTBWOUIZPXSBWPUDWRBWPCQZERSXAYBWRCQERSTZXJXRXSXDYAUJXDXRYAYCXSAB
      WOWPWRXACDEIJKUKULONMABCDEFGHIJKUMUNXTBWOUDZPZBWSERZXJYEYFPZXKXNXOTZYDWRB
      WOCQZERSXAYIWRCQERSTZXJXTYHYDYFXTXKXNXOWLWMXKXSXDUOZXRXLXNXOXDUPZXRXLXNXO
      XDUQZVIURYGXRXLWTXCTZYDYFYJXRXSXDYDYFUSXTYNYDYFXTXLWTXCXRXLXNXOXDUTZXRXSW
      QWTXCVAXRXSWQWTXCVBZVIURXTYDYFVCYEYFVDABWOWPWRXACDEIJKVEVFONLABCDEFGHIJKU
      MUNXTYDYFSZXJXTYDYQPZPZBXBERZXJYSYTPZXKXLXOTZYDWPYIERSZXAYIWPCQZERSTZXJXT
      UUBYRYTXTXKXLXOYKYOYMVIURUUAXRXLXNPZWQXCPZTZYDYQYTUUEXTUUHYRYTXTXRUUFUUGX
      RXSXDVGXTXLXNYOYLVJXTWQXCXRXSWQWTXCVHYPVJVIURXTYDYQYTVKXTYDYQYTVLYSYTVDAB
      WOWPWRXACDEIJKVMVNOMLABCDEFGHIJKUMUNYSYTSZPZXKXLXNTZYDUUCWRUUDERSTZXJXTUU
      KYRUUIXTXKXLXNYKYOYLVIURUUJXRUUFWQWTPZTZYRUUIUULYSUUNUUIYSXRUUFUUMXRXSXDY
      RVOYSXLXNXLXNXOXRXDYRVPXLXNXOXRXDYRVQVJYSWQWTWQWTXCXRXSYRVRWQWTXCXRXSYRVS
      VJVIUGXTYRUUIVCYSUUIVDABWOWPWRCDEIJKVTWANMLABCDEFGHIJKUMUNWBWHWBWCWIWDWIW
      EWFWGWJWK $.

    $d r s u v w Q $.
    $( Construct 2 new layers on top of 2 given atoms.  (Contributed by NM,
       27-Jul-2012.) $)
    3dim2 $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
       -> E. r e. A E. s e. A
          ( -. r .<_ ( P .\/ Q ) /\ -. s .<_ ( ( P .\/ Q ) .\/ r ) ) ) $=
      ( wcel w3a cv co wbr wn wa wceq notbid vu vv vw chlt wne 3dim1 3adant2 wi
      simpl21 simpl22 simp31 necomd adantr oveq1 simp11 simp13 hlatjidm syl2anc
      wrex sylan9eqr breq2d wb cal hlatl syl simp21 atncmp syl3anc bitrd mpbird
      simpl32 oveq1d mtbird breq1 oveq2 anbi12d anbi2d rspc2ev syl112anc simp22
      simp23 jca ad2antrr simp32 simp33 3jca simplr simpr 3dimlem2 3simpc 3expa
      simpll1 ad3antrrr simpllr 3dimlem3 syl13anc 3dimlem4 syl121anc pm2.61dane
      simp1 pm2.61dan 3exp 3expd imp32 rexlimdv rexlimdvva mpd ) EUDLZBALZCALZM
      ZCUANZUEZUBNZCXLDOZFPZQZUCNZXOXNDOZFPQZMZUCAUSZUBAUSUAAUSZHNZBCDOZFPZQZGN
      ZYEYDDOZFPZQZRZGAUSHAUSZXHXJYCXIACDEFUCUBUAIJKUFUGXKYBYMUAUBAAXKXLALZXNAL
      ZRZRYAYMUCAXKYNYOXRALZYAYMUHZUHXKYNYOYQYRXKYNYOYQMZYAYMXKYSYAMZYMBCYTBCSZ
      RZYNYOXLYEFPZQZXNYEXLDOZFPZQZYMYNYOYQXKYAUUAUIYNYOYQXKYAUUAUJUUBUUDXLCUEZ
      YTUUHUUAYTCXLXKYSXMXQXTUKZULUMUUBUUDXLCFPZQZUUHUUBUUCUUJUUBYECXLFUUAYTYEC
      CDOZCBCCDUNYTXHXJUULCSXHXIXJYSYAUOZXHXIXJYSYAUPZADECIKUQURUTZVATYTUUKUUHV
      BZUUAYTEVCLZYNXJUUPYTXHUUQUUMEVDVEXKYNYOYQYAVFZUUNAXLCEFJKVGVHUMVIVJUUBUU
      FXPXMXQXTXKYSUUAVKUUBUUEXOXNFUUBYECXLDUUOVLVAVMYLUUDUUGRZUUDYHUUEFPZQZRZH
      GXLXNAAYDXLSZYGUUDYKUVAUVCYFUUCYDXLYEFVNTUVCYJUUTUVCYIUUEYHFYDXLYEDVOVATV
      PZYHXNSZUVAUUGUUDUVEUUTUUFYHXNUUEFVNTVQVRZVSYTBCUEZRZBXOFPZYMUVHUVIRZYOYQ
      RZXNYEFPZQZXRYEXNDOZFPZQZRZYMYTUVKUVGUVIYTYOYQXKYNYOYQYAVTZXKYNYOYQYAWAZW
      BWCUVJUVGUVMUVPMZUVQUVJXKYNXQXTMZUVGUVIUVTXKYSYAUVGUVIWLYTUWAUVGUVIYTYNXQ
      XTUURXKYSXMXQXTWDZXKYSXMXQXTWEZWFWCYTUVGUVIWGUVHUVIWHABCXLXNXRDEFIJKWIVSU
      VGUVMUVPWJVEYOYQUVQYMYLUVQUVMYHUVNFPZQZRHGXNXRAAYDXNSZYGUVMYKUWEUWFYFUVLY
      DXNYEFVNTUWFYJUWDUWFYIUVNYHFYDXNYEDVOVATVPYHXRSZUWEUVPUVMUWGUWDUVOYHXRUVN
      FVNTVQVRWKURUVHUVIQZRZBXSFPZYMUWIUWJRZYNYQRZUUDXRUUEFPZQZRZYMYTUWLUVGUWHU
      WJYTYNYQUURUVSWBWMUWKUVGUUDUWNMZUWOUWKXKYPXMXTRZMZUVGUWHUWJUWPYTUWRUVGUWH
      UWJYTXKYPUWQXKYSYAWTZYTYNYOUURUVRWBZYTXMXTUUIUWCWBWFWMYTUVGUWHUWJWNUVHUWH
      UWJWGUWIUWJWHABCXLXNXRDEFIJKWOWPUVGUUDUWNWJVEYNYQUWOYMYLUWOUVBHGXLXRAAUVD
      UWGUVAUWNUUDUWGUUTUWMYHXRUUEFVNTVQVRWKURUWIUWJQZRZYPUUSYMYTYPUVGUWHUXAUWT
      WMUXBUVGUUDUUGMZUUSUXBXKYPXMXQRZMZUVGUWHUXAUXCYTUXEUVGUWHUXAYTXKYPUXDUWSU
      WTYTXMXQUUIUWBWBWFWMYTUVGUWHUXAWNUVHUWHUXAWGUWIUXAWHABCXLXNDEFIJKWQWRUVGU
      UDUUGWJVEYNYOUUSYMUVFWKURXAXAWSXBXCXDXEXFXG $.

    $d s v w R $.
    $( Construct a new layer on top of 3 given atoms.  (Contributed by NM,
       27-Jul-2012.) $)
    3dim3 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) )
       -> E. s e. A -. s .<_ ( ( P .\/ Q ) .\/ R ) ) $=
      ( vv wcel wa co wbr wn wceq syl2anc ad2antrr vw chlt wrex 3dim2 3adant3r1
      w3a cv simpl2l simp3l simp1l simp1r2 hlatjidm oveq1d breq2d mtbird notbid
      oveq1 biimparc sylan breq1 rspcev wne simp2l hlatjass 3ad2ant1 cbs cfv wb
      clat hllat syl simp1r1 eqid atbase simp1r3 hlatjcl syl3anc 3jca latleeqj1
      adantr biimpa eqtrd simpl2r ad3antrrr jca simpl3r simpr 3dimlem3a simpl3l
      simplr syl113anc 3dimlem4a pm2.61dan pm2.61dane 3exp rexlimdvv mpd ) FUBM
      ZBAMZCAMZDAMZUFZNZLUGZCDEOZGPZQZUAUGZXEXDEOZGPQZNZUAAUCLAUCZHUGZBCEOZDEOZ
      GPZQZHAUCZWRWTXAXLWSACDEFGUALIJKUDUEXCXKXRLUAAAXCXDAMZXHAMZNZXKXRXCYAXKUF
      ZXRBCYBBCRZNXSXDXOGPZQZXRXSXTXCXKYCUHYBXDCCEOZDEOZGPZQZYCYEYBYHXFXCYAXGXJ
      UIZYBYGXEXDGYBYFCDEYBWRWTYFCRWRXBYAXKUJZWSWTXAWRYAXKUKZAEFCIKULSUMUNUOYCY
      EYIYCYDYHYCXOYGXDGYCXNYFDEBCCEUQUMUNUPURUSXQYEHXDAXMXDRXPYDXMXDXOGUTUPVAZ
      SYBBCVBZNZBXEGPZXRYOYPNZXSYEXRYBXSYNYPXCXSXTXKVCZTYQYDXFYBXGYNYPYJTYQXOXE
      XDGYQXOBXEEOZXEYBXOYSRZYNYPXCYAYTXKABCDEFIKVDVETYOYPYSXERZYOFVIMZBFVFVGZM
      ZXEUUCMZUFZYPUUAVHYBUUFYNYBUUBUUDUUEYBWRUUBYKFVJVKYBWSUUDWSWTXAWRYAXKVLZA
      UUCBFUUCVMZKVNVKYBWRWTXAUUEYKYLWSWTXAWRYAXKVOZAUUCEFCDUUHIKVPVQVRVTUUCEFG
      BXEUUHJIVSVKWAWBUNUOYMSYOYPQZNZBXIGPZXRUUKUULNZXTXHXOGPZQZXRYOXTUUJUULXSX
      TXCXKYNWCTUUMWRWSWTUFZXAXSNZXJUUJUULUUOYBUUPYNUUJUULYBWRWSWTYKUUGYLVRZWDY
      BUUQYNUUJUULYBXAXSUUIYRWEZWDYOXJUUJUULXGXJXCYAYNWFTYOUUJUULWJUUKUULWGABCD
      XDXHEFGIJKWHWKXQUUOHXHAXMXHRXPUUNXMXHXOGUTUPVASUUKUULQZNZXSYEXRYOXSUUJUUT
      XSXTXCXKYNUHTUVAUUPUUQXGUUJUUTYEYBUUPYNUUJUUTUURWDYBUUQYNUUJUUTUUSWDYOXGU
      UJUUTXGXJXCYAYNWITYOUUJUUTWJUUKUUTWGABCDXDEFGIJKWLWKYMSWMWMWNWOWPWQ $.
  $}

  ${
    $d q r s A $.  $d q r s .\/ $.  $d q r s K $.  $d q r s P $.
    2dim.j $e |- .\/ = ( join ` K ) $.
    2dim.c $e |- C = ( <o ` K ) $.
    2dim.a $e |- A = ( Atoms ` K ) $.
    $( Generate a height-3 element (2-dimensional plane) from an atom.
       (Contributed by NM, 3-May-2012.) $)
    2dim $p |- ( ( K e. HL /\ P e. A ) -> E. q e. A E. r e. A
         ( P C ( P .\/ q ) /\ ( P .\/ q ) C ( ( P .\/ q ) .\/ r ) ) ) $=
      ( vs wcel wa cv wne wbr wn wrex wb syl3anc chlt cple cfv w3a 3dim1 df-3an
      co eqid rexbii r19.42v bitri simplbi cal simplll hlatl syl simplr simpllr
      atncmp necom syl6rbb cbs atbase cvr1 bitrd hlatjcl simpr anbi12d reximdva
      syl5ib mpd ) EUALZCALZMZCGNZOZFNZCVODUGZEUBUCZPQZKNVRVQDUGZVSPQZUDZKARZFA
      RZGARCVRBPZVRWABPZMZFARZGARACDEVSKFGHVSUHZJUEVNWEWIGAVNVOALZMZWDWHFAWDVPV
      TMZWLVQALZMZWHWDWMWBKARZWDWMWBMZKARWMWPMWCWQKAVPVTWBUFUIWMWBKAUJUKULWOVPW
      FVTWGWOVPVOCVSPQZWFWOWRVOCOZVPWOEUMLZWKVMWRWSSWOVLWTVLVMWKWNUNZEUOUPVNWKW
      NUQZVLVMWKWNURZAVOCEVSWJJUSTVOCUTVAWOVLCEVBUCZLZWKWRWFSXAWOVMXEXCAXDCEXDU
      HZJVCUPXBAXDBVODEVSCXFWJHIJVDTVEWOVLVRXDLZWNVTWGSXAWOVLVMWKXGXAXCXBAXDDEC
      VOXFHJVFTWLWNVGAXDBVQDEVSVRXFWJHIJVDTVHVJVIVIVK $.

    $d r C $.
    $( An atom is covered by a height-2 element (1-dimensional line).
       (Contributed by NM, 3-May-2012.)  (New usage is discouraged.) $)
    1dimN $p |- ( ( K e. HL /\ P e. A ) -> E. q e. A P C ( P .\/ q ) ) $=
      ( vr chlt wcel wa cv co wbr wrex 2dim r19.42v simplbi reximi syl ) EKLCAL
      MCCFNDOZBPZUCUCJNDOBPZMJAQZFAQUDFAQABCDEJFGHIRUFUDFAUFUDUEJAQUDUEJASTUAUB
      $.
  $}

  ${
    1cvrco.b $e |- B = ( Base ` K ) $.
    1cvrco.u $e |- .1. = ( 1. ` K ) $.
    1cvrco.o $e |- ._|_ = ( oc ` K ) $.
    1cvrco.c $e |- C = ( <o ` K ) $.
    1cvrco.a $e |- A = ( Atoms ` K ) $.
    $( The orthocomplement of an element covered by 1 is an atom.  (Contributed
       by NM, 7-May-2012.) $)
    1cvrco $p |- ( ( K e. HL /\ X e. B ) ->
      ( X C .1. <-> ( ._|_ ` X ) e. A ) ) $=
      ( chlt wcel wa wbr cfv wb adantr syl cp0 cops hlop simpr cvrcon3b syl3anc
      op1cl wceq eqid opoc1 breq1d opoccl sylan biantrurd 3bitrd isat bitr4d )
      EMNZGBNZOZGDCPZGFQZBNZEUAQZVBCPZOZVBANZUTVADFQZVBCPZVEVFUTEUBNZUSDBNZVAVI
      RURVJUSEUCZSZURUSUDUTVJVKVMBDEHIUGTBCEFGDHJKUEUFUTVHVDVBCUTVJVHVDUHVMDEFV
      DVDUIZIJUJTUKUTVCVEURVJUSVCVLBEFGHJULUMUNUOURVGVFRUSABCMVBEVDHVNKLUPSUQ
      $.
  $}

  ${
    $d p q r A $.  $d p q r B $.  $d p q r C $.  $d p q r K $.  $d p q r .< $.
    $d p q r .1. $.  $d p q r X $.
    1cvratex.b $e |- B = ( Base ` K ) $.
    1cvratex.s $e |- .< = ( lt ` K ) $.
    1cvratex.u $e |- .1. = ( 1. ` K ) $.
    1cvratex.c $e |- C = ( <o ` K ) $.
    1cvratex.a $e |- A = ( Atoms ` K ) $.
    $( There exists an atom less than an element covered by 1.  (Contributed by
       NM, 7-May-2012.)  (Revised by Mario Carneiro, 13-Jun-2014.) $)
    1cvratex $p |- ( ( K e. HL /\ X e. B /\ X C .1. ) -> E. p e. A p .< X ) $=
      ( wcel wbr cfv wa syl2anc syl syl3anc vq vr chlt w3a coc cv co wrex simp1
      cjn eqid 1cvrco biimp3a 2dim cple cp0 simp11 cops hlop clat simp12 opoccl
      hllat simp2l atbase latjcl simp2r op0le cvrlt syl31anc wb opltcon3b mpbid
      wne simp3r cpo wi hlpos op0cl plelttr syl13anc mp2and pltne necomd simp3l
      atle wceq opococ breqtrd adantr simpl11 adantl simpl12 reximdva rexlimdvv
      mpd mpan2d 3exp ) FUCNZGBNZGECOZUDZGFUEPZPZXDUAUFZFUJPZUGZCOZXGXGUBUFZXFU
      GZCOZQZUBAUHUAAUHZHUFZGDOZHAUHZXBWSXDANZXMWSWTXAUIWSWTXAXQABCEFXCGIKXCUKZ
      LMULUMACXDXFFUBUAXFUKZLMUNRXBXLXPUAUBAAXBXEANZXIANZQZXLXPXBYBXLUDZXNXGXCP
      ZFUOPZOZHAUHZXPYCWSYDBNZYDFUPPZVNYGWSWTXAYBXLUQZYCFURNZXGBNZYHYCWSYKYJFUS
      SZYCFUTNZXDBNZXEBNZYLYCWSYNYJFVCSZYCYKWTYOYMWSWTXAYBXLVAZBFXCGIXRVBRZYCXT
      YPXBXTYAXLVDABXEFIMVESBXFFXDXEIXSVFTZBFXCXGIXRVBRZYCYIYDYCYIYDDOZYIYDVNZY
      CYIXJXCPZYEOZUUDYDDOZUUBYCYKUUDBNZUUEYMYCYKXJBNZUUGYMYCYNYLXIBNZUUHYQYTYC
      YAUUIXBXTYAXLVGABXIFIMVESBXFFXGXIIXSVFTZBFXCXJIXRVBRZBFYEUUDYIIYEUKZYIUKZ
      VHRYCXGXJDOZUUFYCWSYLUUHXKUUNYJYTUUJXBYBXHXKVOUCBCDFXGXJIJLVIVJYCYKYLUUHU
      UNUUFVKYMYTUUJBDFXCXGXJIJXRVLTVMYCFVPNZYIBNZUUGYHUUEUUFQUUBVQYCWSUUOYJFVR
      ZSYCYKUUPYMBFYIIUUMVSSZUUKUUABDFYEYIUUDYDIUULJVTWAWBYCWSUUPYHUUBUUCVQYJUU
      RUUAUCBBDFYIYDJWCTWPWDABFYEYDYIHIUULUUMMWFTYCYFXOHAYCXNANZQZYFYDGDOZXOYCU
      VAUUSYCYDXDXCPZGDYCXDXGDOZYDUVBDOZYCWSYOYLXHUVCYJYSYTXBYBXHXKWEUCBCDFXDXG
      IJLVIVJYCYKYOYLUVCUVDVKYMYSYTBDFXCXDXGIJXRVLTVMYCYKWTUVBGWGYMYRBFXCGIXRWH
      RWIWJUUTUUOXNBNZYHWTYFUVAQXOVQUUTWSUUOWSWTXAYBXLUUSWKUUQSUUSUVEYCABXNFIMV
      EWLYCYHUUSUUAWJWSWTXAYBXLUUSWMBDFYEXNYDGIUULJVTWAWQWNWPWRWOWP $.
  $}

  ${
    $d q A $.  $d q B $.  $d q C $.  $d q K $.  $d q .<_ $.  $d q P $.
    $d q .< $.  $d q .1. $.  $d q X $.
    1cvratlt.b $e |- B = ( Base ` K ) $.
    1cvratlt.l $e |- .<_ = ( le ` K ) $.
    1cvratlt.s $e |- .< = ( lt ` K ) $.
    1cvratlt.u $e |- .1. = ( 1. ` K ) $.
    1cvratlt.c $e |- C = ( <o ` K ) $.
    1cvratlt.a $e |- A = ( Atoms ` K ) $.
    $( An atom less than or equal to an element covered by 1 is less than the
       element.  (Contributed by NM, 7-May-2012.) $)
    1cvratlt $p |- ( ( ( K e. HL /\ P e. A /\ X e. B )
      /\ ( X C .1. /\ P .<_ X ) ) -> P .< X ) $=
      ( vq wcel w3a wbr wa chlt cv simpl1 simpl3 simprl syl3anc simp1l1 simp1l2
      wrex 1cvratex simp2 simp1l3 simp1rr simp3 atlelt syl132anc rexlimdv3a mpd
      ) GUAQZDAQZIBQZRZIFCSZDIHSZTZTZPUBZIESZPAUIZDIESZVFUSVAVCVIUSUTVAVEUCUSUT
      VAVEUDVBVCVDUEABCEFGIPJLMNOUJUFVFVHVJPAVFVGAQZVHRUSUTVKVAVDVHVJUSUTVAVEVK
      VHUGUSUTVAVEVKVHUHVFVKVHUKUSUTVAVEVKVHULVCVDVBVKVHUMVFVKVHUNABDVGEGHIJKLO
      UOUPUQUR $.
  $}

  ${
    1cvrjat.b $e |- B = ( Base ` K ) $.
    1cvrjat.l $e |- .<_ = ( le ` K ) $.
    1cvrjat.j $e |- .\/ = ( join ` K ) $.
    1cvrjat.u $e |- .1. = ( 1. ` K ) $.
    1cvrjat.c $e |- C = ( <o ` K ) $.
    1cvrjat.a $e |- A = ( Atoms ` K ) $.
    $( An element covered by the lattice unit, when joined with an atom not
       under it, equals the lattice unit.  (Contributed by NM, 30-Apr-2012.) $)
    1cvrjat $p |- ( ( ( K e. HL /\ X e. B /\ P e. A )
        /\ ( X C .1. /\ -. P .<_ X ) ) -> ( X .\/ P ) = .1. ) $=
      ( wcel wbr cfv wb syl chlt w3a wn wa co coc wceq simprr cvr1 adantr mpbid
      cp0 cops simpl1 hlop simpl2 clat hllat simpl3 atbase latjcl eqid cvrcon3b
      syl3anc cal hlatl opoccl syl2anc opoc1 3syl op1cl eqbrtrrd isat mpbir2and
      simprl atcvreq0 fveq2d opococ opoc0 3eqtr3d ) GUAPZIBPZDAPZUBZIECQZDIHQUC
      ZUDZUDZIDFUEZGUFRZRZWJRZGULRZWJRZWIEWHWKWMWJWHWKIWJRZCQZWKWMUGZWHIWICQZWP
      WHWFWRWDWEWFUHWDWFWRSWGABCDFGHIJKLNOUIUJUKWHGUMPZWBWIBPZWRWPSWHWAWSWAWBWC
      WGUNZGUOZTZWAWBWCWGUPZWHGUQPZWBDBPZWTWHWAXEXAGURTXDWHWCXFWAWBWCWGUSABDGJO
      UTTBFGIDJLVAVDZBCGWJIWIJWJVBZNVCVDUKWHGVEPZWKBPZWOAPZWPWQSWHWAXIXAGVFTWHW
      SWTXJXCXGBGWJWIJXHVGVHWHXKWOBPZWMWOCQZWHWSWBXLXCXDBGWJIJXHVGVHWHEWJRZWMWO
      CWHWAWSXNWMUGXAXBEGWJWMWMVBZMXHVIVJWHWEXNWOCQZWDWEWFVOWHWSWBEBPZWEXPSXCXD
      WHWAWSXQXAXBBEGJMVKVJBCGWJIEJXHNVCVDUKVLWHWAXKXLXMUDSXAABCUAWOGWMJXONOVMT
      VNABCWOGHWKWMJKXONOVPVDUKVQWHWSWTWLWIUGXCXGBGWJWIJXHVRVHWHWAWSWNEUGXAXBEG
      WJWMXOMXHVSVJVT $.
  $}

  ${
    1cvrat.b $e |- B = ( Base ` K ) $.
    1cvrat.l $e |- .<_ = ( le ` K ) $.
    1cvrat.j $e |- .\/ = ( join ` K ) $.
    1cvrat.m $e |- ./\ = ( meet ` K ) $.
    1cvrat.u $e |- .1. = ( 1. ` K ) $.
    1cvrat.c $e |- C = ( <o ` K ) $.
    1cvrat.a $e |- A = ( Atoms ` K ) $.
    $( Create an atom under an element covered by the lattice unit.  Part of
       proof of Lemma B in [Crawley] p. 112.  (Contributed by NM,
       30-Apr-2012.) $)
    1cvrat $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ X e. B )
  /\ ( P =/= Q /\ X C .1. /\ -. P .<_ X ) ) -> ( ( P .\/ Q ) ./\ X ) e. A ) $=
      ( wcel co chlt w3a wne wbr wn clat wceq 3ad2ant1 simp21 atbase syl simp22
      hllat latjcom syl3anc oveq1d latjcl simp23 eqtrd simp1 3jca simp31 necomd
      latmcom simp33 cops ople1 syl2anc simp32 1cvrjat syl32anc breqtrrd cvrat3
      hlop wa imp syl23anc eqeltrd ) HUASZDASZEASZKBSZUBZDEUCZKFCUDZDKIUDUEZUBZ
      UBZDEGTZKJTZKEDGTZJTZAWHWJWKKJTZWLWHWIWKKJWHHUFSZDBSZEBSZWIWKUGVSWCWNWGHU
      MUHZWHVTWOVSVTWAWBWGUIZABDHLRUJUKZWHWAWPVSVTWAWBWGULZABEHLRUJUKZBGHDELNUN
      UOUPWHWNWKBSZWBWMWLUGWQWHWNWPWOXBWQXAWSBGHEDLNUQUOVSVTWAWBWGURZBHJWKKLOVD
      UOUSWHVSWBWAVTUBZEDUCZWFEKDGTZIUDZWLASZVSWCWGUTZWHWBWAVTXCWTWRVAWHDEVSWCW
      DWEWFVBVCVSWCWDWEWFVEZWHEFXFIWHHVFSZWPEFIUDVSWCXKWGHVNUHXABFHIELMPVGVHWHV
      SWBVTWEWFXFFUGXIXCWRVSWCWDWEWFVIXJABCDFGHIKLMNPQRVJVKVLVSXDVOXEWFXGUBXHAB
      EDGHIJKLMNORVMVPVQVR $.
  $}

  ${
    ps1.l $e |- .<_ = ( le ` K ) $.
    ps1.j $e |- .\/ = ( join ` K ) $.
    ps1.a $e |- A = ( Atoms ` K ) $.
    $( The join of two atoms ` R .\/ S ` (specifying a projective geometry
       line) is determined uniquely by any two atoms (specifying two points)
       less than or equal to that join.  Part of Lemma 16.4 of [MaedaMaeda]
       p. 69, showing projective space postulate PS1 in [MaedaMaeda] p. 67.
       (Contributed by NM, 15-Nov-2011.) $)
    ps-1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ P =/= Q )
            /\ ( R e. A /\ S e. A ) )
     -> ( ( P .\/ Q ) .<_ ( R .\/ S ) <-> ( P .\/ Q ) = ( R .\/ S ) ) ) $=
      ( wcel wa co wbr wceq wi wb syl3anc hlatjcl chlt wne oveq1 breq2d imbi12d
      w3a eqeq2d eqcoms simp3 simp1 simp21 hlatjcom 3ad2ant1 clat cbs cfv hllat
      simp3l eqid atbase syl simp22 simp3r latjle12 simpl syl6bir adantr simpl1
      syl13anc simpl21 simpl3r simpl3l simpr hlatexchb1 syl131anc sylibd 3impia
      breqtrrd 3expia simp23 necomd syl5ib sylbird syld pm2.61ne latref syl2anc
      eqtrd breq2 syl5ibcom impbid ) GUALZBALZCALZBCUBZUFZDALZEALZMZUFZBCFNZDEF
      NZHOZXAXBPZWTXCXDQZXABEFNZHOZXAXFPZQZBDXEXIRDBDBPZXCXGXDXHXJXBXFXAHDBEFUC
      ZUDXJXBXFXAXKUGUEUHWTBDUBZXCXDWTXLXCUFZXABDFNZXBWTXLXCXAXNPZWTXLMZXCXAXNH
      OZXOWTXLXCXQXMXAXBXNHWTXLXCUIXMXNDBFNZXBWTXLXNXRPZXCWTWLWMWQXSWLWPWSUJZWL
      WMWNWOWSUKZWLWPWQWRURZAFGBDJKULSUMWTXLXCXRXBPZXPXCBXBHOZYCWTXCYDQXLWTXCYD
      CXBHOZMZYDWTGUNLZBGUOUPZLZCYHLZXBYHLZYFXCRWLWPYGWSGUQUMZWTWMYIYAAYHBGYHUS
      ZKUTVAZWTWNYJWLWMWNWOWSVBZAYHCGYMKUTVAZWTWLWQWRYKXTYBWLWPWQWRVCZAYHFGDEYM
      JKTSYHFGHBCXBYMIJVDVIYDYEVEVFVGXPWLWMWRWQXLYDYCRWLWPWSXLVHWMWNWOWLWSXLVJW
      QWRWLWPXLVKWQWRWLWPXLVLWTXLVMABEDFGHIJKVNVOVPVQWHZVRVSWTXQXOQXLWTXQBXNHOZ
      CXNHOZMZXOWTYGYIYJXNYHLZUUAXQRYLYNYPWTWLWMWQUUBXTYAYBAYHFGBDYMJKTSYHFGHBC
      XNYMIJVDVIUUAYTWTXOYSYTVMWTWLWNWQWMCBUBZYTXORXTYOYBYAWTBCWLWMWNWOWSVTWAZA
      CDBFGHIJKVNVOWBWCVGWDVQYRWHVSWTXGCXFHOZXHWTXGBXFHOZUUEMZUUEWTYGYIYJXFYHLZ
      UUGXGRYLYNYPWTWLWMWRUUHXTYAYQAYHFGBEYMJKTSYHFGHBCXFYMIJVDVIUUFUUEVMVFWTWL
      WNWRWMUUCUUEXHRXTYOYQYAUUDACEBFGHIJKVNVOVPWEWTXAXAHOZXDXCWTYGXAYHLZUUIYLW
      TWLWMWNUUJXTYAYOAYHFGBCYMJKTSYHGHXAYMIWFWGXAXBXAHWIWJWK $.

    $d u A $.  $d u .\/ $.  $d u K $.  $d u .<_ $.  $d u P $.  $d u Q $.
    $d u R $.  $d u S $.  $d u T $.
    $( Lattice analog for the projective geometry axiom, "if a line intersects
       two sides of a triangle at different points then it also intersects the
       third side."  Projective space condition PS2 in [MaedaMaeda] p. 68 and
       part of Theorem 16.4 in [MaedaMaeda] p. 69.  (Contributed by NM,
       1-Dec-2011.) $)
    ps-2 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
           /\ ( S e. A /\ T e. A ) ) /\ ( ( -. P .<_ ( Q .\/ R ) /\ S =/= T )
           /\ ( S .<_ ( P .\/ Q ) /\ T .<_ ( Q .\/ R ) ) ) )
        -> E. u e. A ( u .<_ ( P .\/ R ) /\ u .<_ ( S .\/ T ) ) ) $=
      ( wcel wa co wbr wi syl3anc syl13anc chlt w3a wn wne cv wrex wceq simpl21
      simp1 simp21 simp23 hlatlej1 adantr simp3r oveq1 syl5ibrcom breq1 anbi12d
      breq2d imp rspcev syl12anc a1d cp0 cfv cplt ccvr cops hlop 3ad2ant1 op0cl
      cbs eqid syl atbase atcvr0 syl2anc cvrlt syl31anc hlpos clat hllat latjcl
      cpo pltletr mp2and pltne mpd necomd wb hlatl simp3l atncmp simp22 hlexch1
      cal 3expia sylbird imp32 latjlej1 lattr expdimp adantrl hlatj32 mpbid jca
      adantrrr adantrrl ex cvrat4 syld impl adantrlr necom syl6bb simpl3r simpr
      simpl1 an32s anim2d reximdva ad2ant2rl adantrr pm2.61dane ) IUANZCBNZDBNZ
      EBNZUBZFBNZGBNZOZUBZCDEHPZJQUCZFGUDZOZFCDHPJQZGYNJQZOZOZAUEZCEHPZJQZUUBFG
      HPZJQZOZABUFZYMUUAUUHRFCYMFCUGZOZUUHUUAUUJYFCUUCJQZCUUEJQZUUHYFYGYHYEYLUU
      IUHYMUUKUUIYMYEYFYHUUKYEYIYLUIZYEYFYGYHYLUJZYEYFYGYHYLUKZBCEHIJKLMULSZUMY
      MUUIUULYMUULUUICCGHPZJQZYMYEYFYKUURUUMUUNYEYIYJYKUNZBCGHIJKLMULSUUIUUEUUQ
      CJFCGHUOUSUPUTUUGUUKUULOACBUUBCUGUUDUUKUUFUULUUBCUUCJUQUUBCUUEJUQURVAVBVC
      YMFCUDZOZUUAUUHUVAUUAOUUDGFUUBHPJQZOZABUFZUUHUVAYOYTUVDYPYMUUTYOYTOZUVDYM
      UUTUVEOZUUCIVDVEZUDZGUUCFHPZJQZOZUVDYMUVFUVKYMUUTYTUVKYOYMUUTYTOZOZUVHUVJ
      YMUVHUVLYMUVGUUCYMUVGUUCIVFVEZQZUVGUUCUDZYMUVGCUVNQZUUKUVOYMYEUVGIVLVEZNZ
      CUVRNZUVGCIVGVEZQZUVQUUMYMIVHNZUVSYEYIUWCYLIVIVJUVRIUVGUVRVMZUVGVMZVKVNZY
      MYFUVTUUNBUVRCIUWDMVOVNZYMYEYFUWBUUMUUNBUWAUACIUVGUWEUWAVMZMVPVQUAUVRUWAU
      VNIUVGCUWDUVNVMZUWHVRVSUUPYMIWDNZUVSUVTUUCUVRNZUVQUUKOUVORYEYIUWJYLIVTVJU
      WFUWGYMIWANZUVTEUVRNZUWKYEYIUWLYLIWBVJZUWGYMYHUWMUUOBUVREIUWDMVOVNZUVRHIC
      EUWDLWCSZUVRUVNIJUVGCUUCUWDKUWIWETWFYMYEUVSUWKUVOUVPRUUMUWFUWPUAUVRUVRUVN
      IUVGUUCUWIWGSWHWIUMUVMGCFHPZEHPZJQZUVJUVMYNUWRJQZUWSYMUUTYRUWTYSYMUUTYROZ
      ODUWQJQZUWTYMUUTYRUXBYMUUTFCJQUCZYRUXBRZYMIWPNZYJYFUXCUUTWJYEYIUXEYLIWKVJ
      ZYEYIYJYKWLZUUNBFCIJKMWMSYMYEYJYGUVTUXCUXDRUUMUXGYEYFYGYHYLWNZUWGYEYJYGUV
      TUBUXCUXDBUVRFDHIJCUWDKLMWOWQTWRWSYMUXBUWTRZUXAYMUWLDUVRNZUWQUVRNZUWMUXIU
      WNYMYGUXJUXHBUVRDIUWDMVOVNZYMUWLUVTFUVRNZUXKUWNUWGYMYJUXMUXGBUVRFIUWDMVOV
      NZUVRHICFUWDLWCSZUWOUVRHIJDUWQEUWDKLWTTUMWHXGYMYTUWTUWSRZUUTYMYSUXPYRYMYS
      UWTUWSYMUWLGUVRNZYNUVRNZUWRUVRNZYSUWTOUWSRUWNYMYKUXQUUSBUVRGIUWDMVOVNYMUW
      LUXJUWMUXRUWNUXLUWOUVRHIDEUWDLWCSYMUWLUXKUWMUXSUWNUXOUWOUVRHIUWQEUWDLWCSU
      VRIJGYNUWRUWDKXATXBXCXCWHYMUWSUVJWJUVLYMUWRUVIGJYMYEYFYJYHUWRUVIUGUUMUUNU
      XGUUOBCFEHILMXDTUSUMXEXFXHXIYMYEUWKYKYJUVKUVDRUUMUWPUUSUXGBUVRGFHIJUUCUVG
      AUWDKLUWEMXJTXKXLXMUVAYQUVDUUHRZYTYMYPUXTUUTYOYMYPOZUVCUUGABUYAUUBBNZOUVB
      UUFUUDYMUYBYPUVBUUFRZYMUYBOZYPUYCUYDYPGFJQUCZUYCYMUYEYPWJUYBYMUYEGFUDZYPY
      MUXEYKYJUYEUYFWJUXFUUSUXGBGFIJKMWMSGFXNXOUMUYDYEYKUYBUXMUYEUYCRYEYIYLUYBX
      RYJYKYEYIUYBXPYMUYBXQYMUXMUYBUXNUMYEYKUYBUXMUBUYEUYCBUVRGUUBHIJFUWDKLMWOW
      QTWRUTXSXTYAYBYCWHXIYDUT $.

    $( Two atoms are different if their join majorizes the join of two
       different atoms.  (Contributed by NM, 4-Jun-2013.) $)
    2atjlej $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ P =/= Q )
            /\ ( R e. A /\ S e. A /\ ( P .\/ Q ) .<_ ( R .\/ S ) ) )
      -> R =/= S ) $=
      ( wcel wne w3a co wn wb mpbid lnnat syl3anc chlt wceq simp33 simp1 simp21
      wbr simp22 simp23 simp31 simp32 ps-1 syl132anc eqneltrrd mpbird ) GUALZBA
      LZCALZBCMZNZDALZEALZBCFOZDEFOZHUFZNZNZDEMZVCALPZVFVBVCAVFVDVBVCUBZUOUSUTV
      AVDUCVFUOUPUQURUTVAVDVIQUOUSVEUDZUOUPUQURVEUEZUOUPUQURVEUGZUOUPUQURVEUHZU
      OUSUTVAVDUIZUOUSUTVAVDUJZABCDEFGHIJKUKULRVFURVBALPZVMVFUOUPUQURVPQVJVKVLA
      BCFGJKSTRUMVFUOUTVAVGVHQVJVNVOADEFGJKSTUN $.
  $}

  ${
    hlatexch4.j $e |- .\/ = ( join ` K ) $.
    hlatexch4.a $e |- A = ( Atoms ` K ) $.
    $( Rearrange join of atoms in an equality.  (Contributed by NM,
       29-Jul-2013.)  (New usage is discouraged.) $)
    hlatexch3N $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
            /\ ( Q =/= R /\ ( P .\/ Q ) = ( P .\/ R ) ) )
      -> ( P .\/ Q ) = ( Q .\/ R ) ) $=
      ( wcel w3a co wceq wa cfv wbr eqid hlatlej2 syl3anc wb atbase chlt simp21
      wne cple simp1 simp22 simp23 breqtrrd clat cbs hllat 3ad2ant1 syl hlatjcl
      simp3r latjle12 syl13anc mpbi2and simp3l ps-1 syl132anc mpbid eqcomd ) FU
      AIZBAIZCAIZDAIZJZCDUCZBCEKZBDEKZLZMZJZCDEKZVJVNVOVJFUDNZOZVOVJLZVNCVJVPOZ
      DVJVPOZVQVNVDVEVFVSVDVHVMUEZVDVEVFVGVMUBZVDVEVFVGVMUFZABCEFVPVPPZGHQRVNDV
      KVJVPVNVDVEVGDVKVPOWAWBVDVEVFVGVMUGZABDEFVPWDGHQRVDVHVIVLUOUHVNFUIIZCFUJN
      ZIZDWGIZVJWGIZVSVTMVQSVDVHWFVMFUKULVNVFWHWCAWGCFWGPZHTUMVNVGWIWEAWGDFWKHT
      UMVNVDVEVFWJWAWBWCAWGEFBCWKGHUNRWGEFVPCDVJWKWDGUPUQURVNVDVFVGVIVEVFVQVRSW
      AWCWEVDVHVIVLUSWBWCACDBCEFVPWDGHUTVAVBVC $.

    $( Exchange 2 atoms.  (Contributed by NM, 13-May-2013.) $)
    hlatexch4 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
         /\ ( R e. A /\ S e. A )
         /\ ( P =/= R /\ Q =/= S /\ ( P .\/ Q ) = ( R .\/ S ) ) )
                  -> ( P .\/ R ) = ( Q .\/ S ) ) $=
      ( wcel w3a wa wne co wceq cfv wbr eqid syl3anc syl simp11 simp2l hlatlej2
      chlt cple simp2r simp33 breqtrrd wi simp12 simp13 simp32 necomd hlatexch2
      syl131anc mpd hlatjcom breqtrd clat cbs wb hllat atbase latjle12 syl13anc
      hlatjcl mpbi2and simp31 ps-1 syl132anc mpbid ) GUDJZBAJZCAJZKZDAJZEAJZLZB
      DMZCEMZBCFNZDEFNZOZKZKZBDFNZCEFNZGUEPZQZWFWGOZWEBWGWHQZDWGWHQZWIWEBECFNZW
      GWHWEEWAWHQZBWMWHQZWEEWBWAWHWEVLVPVQEWBWHQVLVMVNVRWDUAZVOVPVQWDUBZVOVPVQW
      DUFZADEFGWHWHRZHIUCSVOVRVSVTWCUGZUHWEVLVQVMVNECMWNWOUIWPWRVLVMVNVRWDUJZVL
      VMVNVRWDUKZWECEVOVRVSVTWCULZUMAEBCFGWHWSHIUNUOUPWEVLVQVNWMWGOWPWRXBAFGECH
      IUQSURWECWBWHQZWLWECWAWBWHWEVLVMVNCWAWHQWPXAXBABCFGWHWSHIUCSWTURWEVLVNVPV
      QVTXDWLUIWPXBWQWRXCACDEFGWHWSHIUNUOUPWEGUSJZBGUTPZJZDXFJZWGXFJZWKWLLWIVAW
      EVLXEWPGVBTWEVMXGXAAXFBGXFRZIVCTWEVPXHWQAXFDGXJIVCTWEVLVNVQXIWPXBWRAXFFGC
      EXJHIVFSXFFGWHBDWGXJWSHVDVEVGWEVLVMVPVSVNVQWIWJVAWPXAWQVOVRVSVTWCVHXBWRAB
      DCEFGWHWSHIVIVJVK $.
  $}

  ${
    $d u A $.  $d u .\/ $.  $d u K $.  $d u .<_ $.  $d u ./\ $.  $d u P $.
    $d u Q $.  $d u R $.  $d u S $.  $d u T $.  $d u .0. $.
    ps-2b.l $e |- .<_ = ( le ` K ) $.
    ps-2b.j $e |- .\/ = ( join ` K ) $.
    ps-2b.m $e |- ./\ = ( meet ` K ) $.
    ps-2b.z $e |- .0. = ( 0. ` K ) $.
    ps-2b.a $e |- A = ( Atoms ` K ) $.
    $( Variation of projective geometry axiom ~ ps-2 .  (Contributed by NM,
       3-Jul-2012.) $)
    ps-2b $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
         /\ ( R e. A /\ S e. A /\ T e. A )
         /\ ( -. P .<_ ( Q .\/ R ) /\ S =/= T
              /\ ( S .<_ ( P .\/ Q ) /\ T .<_ ( Q .\/ R ) ) ) )
  -> ( ( P .\/ R ) ./\ ( S .\/ T ) ) =/= .0. ) $=
      ( wcel w3a co wbr vu chlt wn wne wa wrex simp11 simp12 simp13 simp21 3jca
      cv simp22 simp23 jca simp31 simp32 simp33 ps-2 syl32anc cal cbs cfv hlatl
      simp111 clat hllat simp112 simp121 hlatjcl syl3anc simp122 simp123 latmcl
      syl simp2 simp3 atbase latlem12 syl13anc mpbid atlen0 syl31anc rexlimdv3a
      eqid wb mpd ) HUBQZBAQZCAQZRZDAQZEAQZFAQZRZBCDGSZITUCZEFUDZEBCGSITFWPITUE
      ZRZRZUAULZBDGSZITXBEFGSZITUEZUAAUFZXCXDJSZKUDZXAWHWIWJWLRWMWNUEWQWRUEWSXF
      WHWIWJWOWTUGXAWIWJWLWHWIWJWOWTUHWHWIWJWOWTUIWKWLWMWNWTUJUKXAWMWNWKWLWMWNW
      TUMWKWLWMWNWTUNUOXAWQWRWKWOWQWRWSUPWKWOWQWRWSUQUOWKWOWQWRWSURUAABCDEFGHIL
      MPUSUTXAXEXHUAAXAXBAQZXERZHVAQZXGHVBVCZQZXIXBXGITZXHXJWHXKWHWIWJWOWTXIXEV
      EZHVDVOXJHVFQZXCXLQZXDXLQZXMXJWHXPXOHVGVOZXJWHWIWLXQXOWHWIWJWOWTXIXEVHWLW
      MWNWKWTXIXEVIAXLGHBDXLWEZMPVJVKZXJWHWMWNXRXOWLWMWNWKWTXIXEVLWLWMWNWKWTXIX
      EVMAXLGHEFXTMPVJVKZXLHJXCXDXTNVNVKXAXIXEVPZXJXEXNXAXIXEVQXJXPXBXLQZXQXRXE
      XNWFXSXJXIYDYCAXLXBHXTPVRVOYAYBXLHIJXBXCXDXTLNVSVTWAAXLXBHIXGKXTLOPWBWCWD
      WG $.
  $}

  ${
    3at.l $e |- .<_ = ( le ` K ) $.
    3at.j $e |- .\/ = ( join ` K ) $.
    3at.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for ~ 3at .  (Contributed by NM, 22-Jun-2012.) $)
    3atlem1 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
   /\ ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
   /\ -. P .<_ ( T .\/ U ) /\ -. Q .<_ ( P .\/ U ) )
    /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
          -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( wcel co wbr wceq syl13anc wb syl3anc chlt w3a wn simp11 simp131 simp132
      simp133 hlatjass wa simp121 simp122 simp123 simp3 eqbrtrrd clat cbs hllat
      cfv syl eqid atbase hlatjcl latjcl latjle12 mpbird simpld simp22 hlexchb2
      breqtrd mpbid hlatj12 3eqtr2d 3brtr3d simp23 latj13 simprd simp21 latjcom
      syl131anc 3eqtr2rd ) IUANZBANZCANZDANZUBZEANZFANZGANZUBZUBZDBCHOZJPUCZBFG
      HOZJPUCZCBGHOZJPUCZUBZWKDHOZEFHOZGHOZJPZUBZWTGWKHOZDWKHOZWRXBWTFWOHOZCWOH
      OZXCXBWTEWMHOZBWMHOZXEXBWAWFWGWHWTXGQWAWEWIWQXAUDZWFWGWHWAWEWQXAUEZWFWGWH
      WAWEWQXAUFZWFWGWHWAWEWQXAUGZAEFGHILMUHRZXBBXGJPZXHXGQZXBBWTXGJXBBWTJPZCDH
      OZWTJPZXBXPXRUIZBXQHOZWTJPZXBWRXTWTJXBWAWBWCWDWRXTQXIWBWCWDWAWIWQXAUJZWBW
      CWDWAWIWQXAUKZWBWCWDWAWIWQXAULZABCDHILMUHRWJWQXAUMZUNZXBIUONZBIUPURZNZXQY
      HNZWTYHNZXSYASXBWAYGXIIUQUSZXBWBYIYBAYHBIYHUTZMVAUSZXBWAWCWDYJXIYCYDAYHHI
      CDYMLMVBTXBYGWSYHNZGYHNZYKYLXBWAWFWGYOXIXJXKAYHHIEFYMLMVBTXBWHYPXLAYHGIYM
      MVAUSZYHHIWSGYMLVCTZYHHIJBXQWTYMKLVDRVEVFXMVIXBWAWBWFWMYHNZWNXNXOSXIYBXJX
      BWAWGWHYSXIXKXLAYHHIFGYMLMVBTWJWLWNWPXAVGAYHBEHIJWMYMKLMVHVSVJXBWAWBWGWHX
      HXEQXIYBXKXLABFGHILMVKRVLZXBCXEJPZXFXEQZXBUUABDHOZXEJPZXBUUAUUDUIZCUUCHOZ
      XEJPZXBXTWTUUFXEJYFXBWAWBWCWDXTUUFQXIYBYCYDABCDHILMVKRYTVMXBYGCYHNZUUCYHN
      ZXEYHNZUUEUUGSYLXBWCUUHYCAYHCIYMMVAUSZXBWAWBWDUUIXIYBYDAYHHIBDYMLMVBTXBYG
      FYHNZWOYHNZUUJYLXBWGUULXKAYHFIYMMVAUSXBWAWBWHUUMXIYBXLAYHHIBGYMLMVBTZYHHI
      FWOYMLVCTYHHIJCUUCXEYMKLVDRVEVFXBWAWCWGUUMWPUUAUUBSXIYCXKUUNWJWLWNWPXAVNA
      YHCFHIJWOYMKLMVHVSVJXBYGUUHYIYPXFXCQYLUUKYNYQYHHICBGYMLVORVLZXBDXCJPZXDXC
      QZXBDWTXCJXBWKWTJPZDWTJPZXBUURUUSUIZXAYEXBYGWKYHNZDYHNZYKUUTXASYLXBWAWBWC
      UVAXIYBYCAYHHIBCYMLMVBTZXBWDUVBYDAYHDIYMMVAUSZYRYHHIJWKDWTYMKLVDRVEVPUUOV
      IXBWAWDWHUVAWLUUPUUQSXIYDXLUVCWJWLWNWPXAVQAYHDGHIJWKYMKLMVHVSVJXBYGUVBUVA
      XDWRQYLUVDUVCYHHIDWKYMLVRTVT $.

    $( Lemma for ~ 3at .  (Contributed by NM, 22-Jun-2012.) $)
    3atlem2 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
            /\ ( P =/= U /\ P .<_ ( T .\/ U ) ) /\ -. Q .<_ ( P .\/ U ) )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
      -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( wcel w3a co wbr wceq syl3anc syl13anc chlt wn wne wa simp3 clat cbs cfv
      wb simp11 syl simp121 simp122 eqid hlatjcl simp123 atbase simp131 simp132
      simp133 latjcl latjle12 mpbird simprd hlatjass simp22r simp22l hlatexchb2
      hllat syl131anc mpbid oveq2d eqtr4d hlatj12 hlatj32 3brtr3d simp23 3eqtrd
      breqtrrd hlexchb2 breqtrd simp21 hlexchb1 ) IUANZBANZCANZDANZOZEANZFANZGA
      NZOZOZDBCHPZJQUBZBGUCZBFGHPZJQZUDZCBGHPZJQUBZOZWNDHPZEFHPZGHPZJQZOZXCWNGH
      PZXEXGDXHJQZXCXHRZXGDXEXHJXGWNXEJQZDXEJQZXGXKXLUDZXFWMXBXFUEZXGIUFNZWNIUG
      UHZNZDXPNZXEXPNZXMXFUIXGWDXOWDWHWLXBXFUJZIVIUKZXGWDWEWFXQXTWEWFWGWDWLXBXF
      ULZWEWFWGWDWLXBXFUMZAXPHIBCXPUNZLMUOSZXGWGXRWEWFWGWDWLXBXFUPZAXPDIYDMUQUK
      XGXOXDXPNZGXPNZXSYAXGWDWIWJYGXTWIWJWKWDWHXBXFURZWIWJWKWDWHXBXFUSZAXPHIEFY
      DLMUOSXGWKYHWIWJWKWDWHXBXFUTZAXPGIYDMUQUKXPHIXDGYDLVASXPHIJWNDXEYDKLVBTVC
      VDXGXEEWTHPZXHXGXEEWQHPZYLXGWDWIWJWKXEYMRXTYIYJYKAEFGHILMVETZXGWTWQEHXGWR
      WTWQRZWPWRWOXAWMXFVFXGWDWEWJWKWPWRYOUIXTYBYJYKWPWRWOXAWMXFVGABFGHIJKLMVHV
      JVKVLZVMXGXHBCGHPHPZCWTHPZYLXGWDWEWFWKXHYQRXTYBYCYKABCGHILMVETXGWDWEWFWKY
      QYRRXTYBYCYKABCGHILMVNTXGCYLJQZYRYLRZXGCYMYLJXGBDHPZYMJQZCYMJQZXGUUBUUCUD
      ZUUACHPZYMJQZXGXCXEUUEYMJXNXGWDWEWFWGXCUUERXTYBYCYFABCDHILMVOTYNVPXGXOUUA
      XPNZCXPNZYMXPNZUUDUUFUIYAXGWDWEWGUUGXTYBYFAXPHIBDYDLMUOSXGWFUUHYCAXPCIYDM
      UQUKXGXOEXPNZWQXPNZUUIYAXGWIUUJYIAXPEIYDMUQUKXGWDWJWKUUKXTYJYKAXPHIFGYDLM
      UOSXPHIEWQYDLVASXPHIJUUACYMYDKLVBTVCVDYPVSXGWDWFWIWTXPNZXAYSYTUIXTYCYIXGW
      DWEWKUULXTYBYKAXPHIBGYDLMUOSWMWOWSXAXFVQAXPCEHIJWTYDKLMVTVJVKVRVMZWAXGWDW
      GWKXQWOXIXJUIXTYFYKYEWMWOWSXAXFWBAXPDGHIJWNYDKLMWCVJVKUUMVM $.

    $( Lemma for ~ 3at .  (Contributed by NM, 23-Jun-2012.) $)
    3atlem3 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
            /\ P =/= U /\ -. Q .<_ ( P .\/ U ) )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
      -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( wcel w3a co wbr wn wa simpl1 chlt wne simpl21 simpl22 simpr jca simpl23
      wceq simpl3 3atlem2 syl131anc 3atlem1 pm2.61dan ) IUANBANCANDANOEANFANGAN
      OOZDBCHPZJQRZBGUBZCBGHPJQRZOZUODHPZEFHPGHPZJQZOZBFGHPJQZUTVAUHZVCVDSZUNUP
      UQVDSURVBVEUNUSVBVDTUPUQURUNVBVDUCVFUQVDUPUQURUNVBVDUDVCVDUEUFUPUQURUNVBV
      DUGUNUSVBVDUIABCDEFGHIJKLMUJUKVCVDRZSUNUPVGURVBVEUNUSVBVGTUPUQURUNVBVGUCV
      CVGUEUPUQURUNVBVGUGUNUSVBVGUIABCDEFGHIJKLMULUKUM $.

    $( Lemma for ~ 3at .  (Contributed by NM, 23-Jun-2012.) $)
    3atlem4 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( S e. A /\ T e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
            /\ P =/= Q )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ R ) )
      -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ R ) ) $=
      ( wcel w3a wa co wbr wne syl atbase chlt wn simp11 simp12 simp13l simp13r
      wceq simp123 3jca simp2l clat cbs cfv simp121 simp122 latnlej1l syl131anc
      hllat eqid necomd wi simp2r hlatexch1 mtod simp3 3atlem3 syl331anc ) HUAM
      ZBAMZCAMZDAMZNZEAMZFAMZOZNZDBCGPZIQZUBZBCRZOZVQDGPZEFGPDGPZIQZNZVHVLVMVNV
      KNVSBDRCBDGPIQZUBWDWBWCUGVHVLVOWAWDUCZVHVLVOWAWDUDWEVMVNVKVMVNVHVLWAWDUEV
      MVNVHVLWAWDUFVIVJVKVHVOWAWDUHZUIVPVSVTWDUJZWEDBWEHUKMZDHULUMZMZBWKMZCWKMZ
      VSDBRWEVHWJWGHURSWEVKWLWHAWKDHWKUSZLTSWEVIWMVIVJVKVHVOWAWDUNZAWKBHWOLTSWE
      VJWNVIVJVKVHVOWAWDUOZAWKCHWOLTSWIWKGHIDBCWOJKUPUQUTWEWFVRWIWEVHVJVKVICBRW
      FVRVAWGWQWHWPWEBCVPVSVTWDVBUTACDBGHIJKLVCUQVDVPWAWDVEABCDEFDGHIJKLVFVG $.

    $( Lemma for ~ 3at .  (Contributed by NM, 23-Jun-2012.) $)
    3atlem5 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
            /\ P =/= Q /\ -. Q .<_ ( P .\/ U ) )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
      -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( wcel w3a co wbr wn wceq syl chlt wne wa wi eqcoms breq2d eqeq2d imbi12d
      oveq2 simp1l simp1r1 simp2 simp1r3 simp3 3atlem3 syl131anc 3expia simp123
      simp11 simp122 simp121 3jca simp131 jca simp21 simp22 hlatexch2 mtod clat
      simp132 cbs hllat eqid atbase latnlej1r 3atlem4 syl321anc simpl21 simpl22
      cfv simpl1 simpl23 latj31 syl13anc breq1d eqeq1d 3imtr4d pm2.61ne 3impia
      ) IUANZBANZCANZDANZOZEANZFANZGANZOZOZDBCHPZJQZRZBCUBZCBGHPJQRZOZWTDHPZEFH
      PZGHPZJQZXFXHSZWSXEUCZXIXJUDXFXGBHPZJQZXFXLSZUDBGBGSZXIXMXJXNXOXHXLXFJXHX
      LSGBGBXGHUIUEZUFXOXHXLXFXPUGUHXKBGUBZXIXJXKXQXIOWSXBXQXDXIXJWSXEXQXIUJXBX
      CXDWSXQXIUKXKXQXIULXBXCXDWSXQXIUMXKXQXIUNABCDEFGHIJKLMUOUPUQXKDCHPZBHPZXL
      JQZXSXLSZXMXNWSXEXTYAWSXEXTOZWJWMWLWKOWOWPUCBXRJQZRDCUBZXTYAWJWNWRXEXTUSZ
      YBWMWLWKWKWLWMWJWRXEXTURZWKWLWMWJWRXEXTUTZWKWLWMWJWRXEXTVAZVBYBWOWPWOWPWQ
      WJWNXEXTVCWOWPWQWJWNXEXTVJVDYBYCXAWSXBXCXDXTVEZYBWJWKWMWLXCYCXAUDYEYHYFYG
      WSXBXCXDXTVFABDCHIJKLMVGUPVHYBIVINZDIVKVTZNZBYKNZCYKNZXBYDYBWJYJYEIVLZTYB
      WMYLYFAYKDIYKVMZMVNZTYBWKYMYHAYKBIYPMVNZTYBWLYNYGAYKCIYPMVNZTYIYKHIJDBCYP
      KLVOUPWSXEXTUNADCBEFHIJKLMVPVQUQXKXFXSXLJXKYJYMYNYLXFXSSXKWJYJWJWNWRXEWAY
      OTXKWKYMWKWLWMWJWRXEVRYRTXKWLYNWKWLWMWJWRXEVSYSTXKWMYLWKWLWMWJWRXEWBYQTYK
      HIBCDYPLWCWDZWEXKXFXSXLYTWFWGWHWI $.

    $( Lemma for ~ 3at .  (Contributed by NM, 23-Jun-2012.) $)
    3atlem6 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
            /\ P =/= Q /\ Q .<_ ( P .\/ U ) )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
      -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( wcel w3a co wbr wn wne syl chlt simp11 simp121 simp122 simp123 syl13anc
      wceq hlatj32 3jca simp13 simp21 wi simp22 necomd hlatexch1 syl131anc mtod
      clat cbs cfv hllat eqid atbase latnlej1l simp23 simp133 hlatexchb1 breq2d
      wb mpbid mtbid simp3 eqbrtrrd 3atlem5 syl331anc eqtrd ) IUANZBANZCANZDANZ
      OZEANZFANZGANZOZOZDBCHPZJQZRZBCSZCBGHPZJQZOZWGDHPZEFHPGHPZJQZOZWNBDHPZCHP
      ZWOWQVQVRVSVTWNWSUGVQWAWEWMWPUBZVRVSVTVQWEWMWPUCZVRVSVTVQWEWMWPUDZVRVSVTV
      QWEWMWPUEZABCDHILMUHUFZWQVQVRVTVSOWECWRJQZRBDSZDWKJQZRWSWOJQWSWOUGWTWQVRV
      TVSXAXCXBUIVQWAWEWMWPUJWQXEWHWFWIWJWLWPUKZWQVQVSVTVRCBSZXEWHULWTXBXCXAWQB
      CWFWIWJWLWPUMUNZACDBHIJKLMUOUPUQWQIURNZDIUSUTZNZBXLNZCXLNZWIXFWQVQXKWTIVA
      TWQVTXMXCAXLDIXLVBZMVCTWQVRXNXAAXLBIXPMVCTWQVSXOXBAXLCIXPMVCTXHXKXMXNXOOW
      IODBXLHIJDBCXPKLVDUNUPWQWHXGXHWQWGWKDJWQWLWGWKUGZWFWIWJWLWPVEWQVQVSWDVRXI
      WLXQVIWTXBWBWCWDVQWAWMWPVFXAXJACGBHIJKLMVGUPVJVHVKWQWNWSWOJXDWFWMWPVLVMAB
      DCEFGHIJKLMVNVOVP $.

    $( Lemma for ~ 3at .  (Contributed by NM, 23-Jun-2012.) $)
    3atlem7 $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
            /\ P =/= Q )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
      -> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( wcel w3a co wbr wn wa simpl1 chlt wne wceq simpl2l simpl2r simpr simpl3
      3atlem6 syl131anc 3atlem5 pm2.61dan ) IUANBANCANDANOEANFANGANOOZDBCHPZJQR
      ZBCUBZSZUMDHPZEFHPGHPZJQZOZCBGHPJQZUQURUCZUTVASULUNUOVAUSVBULUPUSVATUNUOU
      LUSVAUDUNUOULUSVAUEUTVAUFULUPUSVAUGABCDEFGHIJKLMUHUIUTVARZSULUNUOVCUSVBUL
      UPUSVCTUNUOULUSVCUDUNUOULUSVCUEUTVCUFULUPUSVCUGABCDEFGHIJKLMUJUIUK $.

    $( Any three non-colinear atoms in a (lattice) plane determine the plane
       uniquely.  This is the 2-dimensional analog of ~ ps-1 for lines and
       ~ 4at for volumes.  I could not find this proof in the literature on
       projective geometry (where it is either given as an axiom or stated as
       an unproved fact), but it is similar to Theorem 15 of Veblen, "The
       Foundations of Geometry" (1911), p. 18, which uses different axioms.
       This proof was written before I became aware of Veblen's, and it is
       possible that a shorter proof could be obtained by using Veblen's proof
       for hints.  (Contributed by NM, 23-Jun-2012.) $)
    3at $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) /\
    ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q ) /\ P =/= Q ) )
   -> ( ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U )
          <-> ( ( P .\/ Q ) .\/ R ) = ( ( S .\/ T ) .\/ U ) ) ) $=
      ( wcel w3a co wbr wa atbase syl chlt wn wceq 3atlem7 3expia wi clat hllat
      wne cbs cfv simpl simpr1 simpr2 latjcl syl3anc simpr3 latref syldan breq2
      eqid syl5ibcom sylan 3adant3 adantr impbid ) IUANZBANZCANZDANZOZEANFANGAN
      OZOZDBCHPZJQUBBCUIRZRVNDHPZEFHPGHPZJQZVPVQUCZVMVOVRVSABCDEFGHIJKLMUDUEVMV
      SVRUFZVOVGVKVTVLVGIUGNZVKVTIUHWAVKRZVPVPJQZVSVRWAVKVPIUJUKZNZWCWBWAVNWDNZ
      DWDNZWEWAVKULZWBWABWDNZCWDNZWFWHWBVHWIWAVHVIVJUMAWDBIWDVAZMSTWBVIWJWAVHVI
      VJUNAWDCIWKMSTWDHIBCWKLUOUPWBVJWGWAVHVIVJUQAWDDIWKMSTWDHIVNDWKLUOUPWDIJVP
      WKKURUSVPVQVPJUTVBVCVDVEVF $.

$(
    @( If the join three non-colinear atoms is less than or equal to three
       others, then the others are also non-colinear. @)
    3atne @p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) /\
     ( S e. A /\ T e. A /\ U e. A ) ) /\ ( -. R .<_ ( P .\/ Q ) /\ P =/= Q )
        /\ ( ( P .\/ Q ) .\/ R ) .<_ ( ( S .\/ T ) .\/ U ) )
     -> ( S =/= T /\ -. U .<_ ( S .\/ T ) ) ) @=
      ? @.
      @( [23-Jun-2012] @)
$)
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
             Projective geometries based on Hilbert lattices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

$(


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                     Additional set theory definitions
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c fcard @.
  @c idsumf @.
  @c idsum @.

  @( Extend class notation with finite cardinality (member of ` NN0 ` ). @)
  cfc @a class fcard @.

  @( Extend class notation with finite idempotent sum. @)
  cidsumf @a class idsumf @.

  @( Extend class notation with idempotent sum. @)
  cidsum @a class idsum @.

  @{
    @d f n p s t u x y @.
    @( Define finite cardinality. @)
    df-fcard @a |- fcard = ( x e. _V |-> if ( x e. Fin , ( iota n ( n e. NN
          /\ E. f f : x -1-1-onto-> ( 1 ... n ) ) ) , ( Undef ` NN0 ) ) ) @.

    @( Define finite idempotent sum. @)
    df-idsumf @a |- idsumf = ( p e. _V , s e. _V |->
    ( iota t A. f ( f : ( 1 ... ( fcard ` s ) ) -1-1-onto-> s
         -> t = ( ( p ser f ) ` ( fcard ` s ) ) ) ) ) @.
    df-idsumf @a |- idsumf = ( p e. _V , s e. _V |->
    ( iota t A. f ( f : ( 1 ... ( fcard ` s ) ) -1-1-onto-> s
         -> t = ( ( p ser f ) ` ( fcard ` s ) ) ) ) ) @.
( ( P seq1 F ) ` N )

    @( Define idempotent sum. @)
    df-idsum @a |- idsum = ( p e. _V , s e. _V |->
        U. { u | E. t ( u = ( p idsumf t ) /\ t C_ s /\ t e. Fin ) } ) @.
  @}          U. { a | E. t C_ s E. n e. NN0 E. f
          ( f : ( 1 ... n ) -1-1-onto-> t /\ a = ( ( p seq f ) ` n ) ) } ) $.
    df-idsum @a |- idsum = ( p e. _V , f e. _V |->
                U. { a | E. t E. g
       ( t e. Fin /\ t C_ f )
     /\ ( g : ( 1 ... ( # ` t ) ) -1-1-onto-> dom t
     /\ A. x e. dom g A. y e. dom g ( x < y -> ( g ` x ) < ( g ` y ) )
     /\ a = ( ( p seq1 ( f o. g ) ) ` ( # ` t ) ) ) ) }

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                      Posets and lattices; Hilbert lattices
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    From groups to Hilbert spaces
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c -vNEW @.
  @c RVecNEW @.
  @c SubSpNEW @.
  @c spanNEW @.
  @c o+ @.
  @c Ev @.
  @c /v @.
  @c normv @.

  @( Extend class notation with vector subtraction. @)
  cminusv @a class -vNEW @.

  @( Extend class notation with class of all right vector spaces. @)
  crvec @a class RVecNEW @.

  @( Extend class notation with set of all subspaces in a vector space. @)
  cssp @a class SubSpNEW @.

  @( Extend class notation with span of a set of vectors. @)
  cspan @a class spanNEW @.

  @( Extend class notation with direct sum. @)
  coplus @a class o+ @.

  @( Extend class notation with vector equivalence classes. @)
  cev @a class Ev @.

  @( Extend class notation with quotient space. @)
  cqv @a class /v @.

  @( Extend class notation with norm of a vector. @)
  cnormv @a class normv @.

  @{
    @d a b c e f g h i k m p q r s t u v w x y z @.
    @( Define vector subtraction. @)
    df-minusv @a |- -vNEW = ( v e. _V |-> ( x e. ( Base ` v ) ,
         y e. ( Base ` v ) |-> ( x ( +g ` v )
 ( ( invg ` { <. 1 , ( Base ` v ) >. ,
         <. 2 , ( +g ` v ) >. } ) ` y ) ) ) ) @.

    @( Define class of all right vector spaces. @)
    df-rvec @a |- RVecNEW = Struct ( 6 , f , ( f e. DivRingOLD  /\
      E. k E. p E. t E. v E. a E. s (
         ( k = ( Base ` f ) /\ p = ( +g ` f ) /\ t = ( .r ` f ) )
      /\ ( v = ( vbase ` f ) /\ a = ( vadd ` f ) /\ s = ( .s ` f ) )
          /\ ( { <. 1 , v >. , <. 2 , a >. } e. AbelOLD
             /\ A. q e. k A. r e. k A. x e. v A. w e. v
               ( ( ( w s r ) e. v
                 /\ ( ( w a x ) s r ) = ( ( w s r ) a ( x s r ) )
                 /\ ( w s ( q p r ) ) = ( ( w s q ) a ( w s r ) )
               ) /\ ( ( ( w s q ) s r ) = ( w s ( q t r ) )
                 /\ ( w s ( 1r ` f ) ) = w ) ) ) ) ) ) @.

    @( Define set of all subspaces of left vector space ` v ` . @)
    df-sbsp @a |- SubSpNEW = ( v e. _V |-> { s e. ~P ( vbase ` v )
     | ( ( 0v ` v ) e. s /\ A. x e. s A. y e. s ( x ( vadd ` v ) y ) e. s
        /\ A. x e. ( Base ` v ) A. y e. s ( x ( .s ` v ) y ) e. s ) } ) @.

    @( Define span of a set of vectors. @)
    df-vspan @a |- spanNEW = ( v e. _V |-> ( m e. ~P ( vbase ` v ) |->
       |^| { s e. ( SubSpNEW ` v ) | m C_ s } ) ) @.

    @( Define direct sum of two left vector spaces. @)
    df-oplus @a |- o+ = ( v e. _V , w e. _V |-> ( { <. 1 , ( Base ` v ) >. ,
       <. 2 , ( +g ` v ) >. , <. 3 , ( .r ` v ) >. } u. {
       <. 4 , ( ( vbase ` v ) X. ( vbase ` w ) ) >. ,
       <. 5 , ( x e. ( ( vbase ` v ) X. ( vbase ` w ) ) ,
                y e. ( ( vbase ` v ) X. ( vbase ` w ) ) |->
                  <. ( ( 1st ` x ) ( vadd ` v ) ( 1st ` y ) ) ,
                     ( ( 2nd ` x ) ( vadd ` w ) ( 2nd ` y ) ) >. ) >. ,
       <. 6 , ( k e. ( Base ` v ) ,
                x e. ( ( vbase ` v ) X. ( vbase ` w ) ) |->
                  <. ( k ( .s ` v ) ( 1st ` x ) ) ,
                     ( k ( .s ` w ) ( 2nd ` x ) ) >. ) >. } ) ) @.

    @( Define vector equivalence mod ` m ` . @)
    df-ev @a |- Ev = ( v e. _V , m e. _V |-> { <. x , y >. |
       ( x e. ( vbase ` v ) /\ y e. ( vbase ` v ) /\
       ( x ( -vNEW ` v ) y ) e. ( vbase ` m ) ) } ) @.

    @( Define quotient space. @)
    df-quov @a |- /v = ( v e. _V , m e. _V |-> ( { <. 1 , ( Base ` v ) >. ,
       <. 2 , ( +g ` v ) >. , <. 3 , ( .r ` v ) >. } u. {
       <. 4 , ( ( vbase ` v ) /. ( v Ev m ) ) >. ,
       <. 5 , { <. <. a , b >. , c >. | E. x e. ( vbase ` v )
          E. y e. ( vbase ` v ) ( a = [ x ] ( v Ev m )
            /\ b = [ y ] ( v Ev m )
            /\ c = [ ( x ( vadd ` v ) y ) ] ( v Ev m ) ) } >. ,
       <. 6 , { <. <. a , b >. , c >. | ( a e. ( Base ` v ) /\
          E. y e. ( vbase ` v ) ( b = [ y ] ( v Ev m )
            /\ c = [ ( x ( .s ` v ) y ) ] ( v Ev m ) ) ) } >. } ) ) @.

    @( Define norm of a vector. @)
    df-normv @a |- normv = ( h e. _V |-> ( v ( .i ` h ) v ) ) @.
  @}


@(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
                    Hilbert space reconstruction
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
@)

  @c sumP @.
  @c Indep @.
  @c BasesP @.
  @c rankP @.
  @c PHyp @.
  @c ww @.
  @c WAtoms @.
  @c PAut @.
  @c Dil @.
  @c Trn @.
  @c trP @.
  @c DVecA @.
  @c GrpEndo @.
  @c DVecAEndo @.
  @c ERing @.
  @c TPEndo @.
  @c DRing @.
  @c DVecA @.
  @c DVIsoPre @.
  @c DVecB @.
  @c DVecH @.
  @c ee @.
  @c DVIsoA @.
  @c qtr @.
  @c DVIsoB @.
  @c DVIsoC @.
  @c DVIsoH @.
  @c S_|_ @.
  @c Ropp @.
  @c Vldual @.
  @c vecdom @.
  @c ker @.
  @c mapd @.
  @c eimage @.
  @c hmap @.
  @c gmap @.
  @c HLtoHil @.

  @( Extend class notation with projective subspace sum. @)
  csump @a class sumP @.

  @( Extend class notation with set of all sets of independent points. @)
  cindep @a class Indep @.

  @( Extend class notation with all bases for projective subspaces. @)
  cbasesp @a class BasesP @.

  @( Extend class notation with rank of projective subspace @m@. @)
  crankp @a class rankP @.

  @( Extend class notation with set of all (projective) hyperplanes. @)
  cphyp @a class PHyp @.

  @( Extend class notation with fiducial hyperplane. @)
  cww @a class ww @.

  @( Extend class notation with W points. @)
  cwpointsN @a class WAtoms @.

  @( Extend class notation with set of all projective automorphisms. @)
  cpautN @a class PAut @.

  @( Extend class notation with set of all dilations. @)
  cdilN @a class Dil @.

  @( Extend class notation with set of all translations. @)
  ctrnN @a class Trn @.

  @( Extend class notation with trace of a translation @f@. @)
  ctrp @a class trP @.

  @( Extend class notation with translation group. @)
  ctgrp @a class TGrp @.

  @( Extend class notation with group endomorphisms of @G@. @)
  cgrpendo @a class GrpEndo @.

  @( Extend class notation with translation group endomorphisms. @)
  ctgrpendo @a class TGrpEndo @.

  @( Extend class notation with endomorphism ring. @)
  cering @a class ERing @.

  @( Extend class notation with trace-preserving endomorphisms. @)
  ctpendo @a class TPEndo @.

  @( Extend class notation with @\Delta@-ring. @)
  cdring @a class DRing @.

  @( Extend class notation with constructed vector space A. @)
  cdveca @a class DVecA @.

  @( Extend class notation with preliminary projective subspace isomorphism. @)
  cdvisopre @a class DVIsoPre @.

  @( Extend class notation with constructed vector space B. @)
  cdvecb @a class DVecB @.

  @( Extend class notation with constructed vector space. @)
  cdvech @a class DVecH @.

  @( Extend class notation with e vector. @)
  cee @a class ee @.

  @( Extend class notation with projective subspace isomorphism A. @)
  cdvisoa @a class DVIsoA @.

  @( Extend class notation with q-translation. @)
  cqtr @a class qtr @.

  @( Extend class notation with projective subspace isomorphism B. @)
  cdvisob @a class DVIsoB @.

  @( Extend class notation with projective subspace isomorphism C. @)
  cdvisoc @a class DVIsoC @.

  @( Extend class notation with projective subspace isomorphism. @)
  cdvisoh @a class DVIsoH @.

  @( Extend class notation with constructed orthocomplement. @)
  csoc @a class S_|_ @.

  @( Extend class notation with opposite ring. @)
  cropp @a class Ropp @.

  @( Extend class notation with left dualvector space. @)
  cvldual @a class Vldual @.

  @( Extend class notation with vector domain. @)
  cvecdom @a class vecdom @.

  @( Extend class notation with kernel of a functional. @)
  cker @a class ker @.

  @( Extend class notation with one-dimensional subspace map. @)
  cmapd @a class mapd @.

  @( Extend class notation with e vector image. @)
  ceimage @a class eimage @.

  @( Extend class notation with h map. @)
  chmap @a class hmap @.

  @( Extend class notation with g map. @)
  cgmap @a class gmap @.

  @( Extend class notation with Hilbert space constructed from Hilbert
     lattice. @)
  chltohil @a class HLtoHil @.

  @{
    @d a b d e f g h k l m n p q r s t u v w x y z @.
    @( Define projective sum of a set of subspaces. @)
    df-sump @a |- sumP = ( l e. _V |-> ( s e. ~P ( PSubSp ` l ) |->
       ( ( +P ` l ) idsumf s ) ) ) @.

    @( Define set of all sets of independent points. @)
    df-indep @a |- Indep = ( l e. _V |-> { s e. ~P ( Points ` l )
    | A. a A. b ( ( ( a u. b ) = s /\ ( a i^i b ) = (/) ) ->
      ( ( ( sumP ` l ) ` a ) i^i ( ( sumP ` l ) ` b ) ) = (/) ) } ) @.

    @( Define all bases for projective subspace @m@. @)
    df-basesp @a |- BasesP = ( l e. _V , m e. _V |-> { s e. ( Indep ` l )
      | ( ( sumP ` l ) ` s ) = m } ) @.

    @( Define rank of projective subspace @m@. @)
    df-rankp @a |- rankP = ( l e. _V , m e. _V |-> ( iota r
    A. b e. ( l TopBases m ) r = ( card ` b ) ) ) @.

    @( Define set of all (projective) hyperplanes. @)
    df-phyp @a |- PHyp = ( l e. _V |-> { h | E. p e. ( Points ` l )
        h = ( ( _|_P ` l ) ` p ) } ) @.

    @( Define fiducial hyperplane. @)
    df-ww @a |- ww = ( l e. _V , p e. _V |-> ( ( _|_P ` l ) ` { p } ) ) @.

    @( Define W points. @)
    df-wpoints @a |- WAtoms = ( l e. _V , p e. _V |-> { x e. ( Points ` l )
      | -. x C_ ( l ww p ) } ) @.

    @( Define set of all projective automorphisms. @)
    df-pautN @a |- PAut = ( l e. _V |-> { f | ( f : ( PSubSp ` l ) -1-1-onto->
      ( PSubSp ` l ) /\ A. x e. ( PSubSp ` l ) A. y e. ( PSubSp ` l )
        ( x C_ y <-> ( f ` x ) C_ ( f ` y ) ) ) } ) @.

    @( Define set of all dilations. @)
    df-dilN @a |- Dil = ( l e. _V , p e. _V |-> { f e. ( PAut ` l )
     | A. x e. ( PSubSp ` l ) ( x C_ ( l ww p ) -> ( f ` x ) = x ) } ) @.

    @( Define set of all translations. @)
    df-trnN @a |- Trn = ( l e. _V , p e. _V |-> { f e. ( l Dil p )
     | A. q e. ( l WAtoms p ) A. r e. ( l WAtoms p )
        ( ( q ( +P ` l ) ( f ` q ) ) i^i ( l ww p ) )
      = ( ( r ( +P ` l ) ( f ` r ) ) i^i ( l ww p ) ) } ) @.

    @( Define trace of a translation ` f ` . @)
    df-trp @a |- trP = ( l e. _V , p e. _V |-> ( f e. ( l Trn p ) |->
     ( iota x ( x e. ( PSubSp ` l ) /\ A. q e. ( l WAtoms p )
        x = ( ( q ( +P ` l ) ( f ` q ) ) i^i ( l ww p ) ) ) ) ) ) @.

    @( Define translation group. @)
    df-tgrp @a |- TGrp = ( l e. _V , p e. _V |-> { <. 1 , ( l Trn p ) >. ,
       <. 2 , ( f e. ( l Trn p ) , g e. ( l Trn p ) |-> ( f o. g ) ) >. } ) @.

    @( Define group endomorphisms of @G@. @)
    df-grpendo @a |- GrpEndo = ( g e. _V |-> { f |
   ( f : ( Base ` g ) --> ( Base ` g )
      /\ A. x e. ( Base ` g ) A. y e. ( Base ` g )
       ( x ( +g ` g ) y ) = ( ( f ` x ) ( +g ` g ) ( f ` y ) ) ) } ) @.

    @( Define translation group endomorphisms. @)
    df-tgrpendo @a |- TGrpEndo = ( l e. _V , p e. _V |->
      ( GrpEndo ` ( l TGrp p ) ) ) @.

    @( Define endomorphism ring. @)
    df-ering @a |- ERing = ( l e. _V , p e. _V |-> { <. 1 , ( l TGrpEndo p ) >.
        ,
       <. 2 , ( s e. ( l TGrpEndo p ) , t e. ( l TGrpEndo p ) |->
           ( f e. ( l Trn p ) |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. 3 , ( s e. ( l TGrpEndo p ) , t e. ( l TGrpEndo p ) |->
           ( f e. ( l Trn p ) |-> ( t ` ( s ` f ) ) ) ) >. } ) @.

    @( Define trace-preserving endomorphisms. @)
    df-tpendo @a |- TPEndo = ( l e. _V , p e. _V |-> { s e. ( l TGrpEndo p ) |
     A. f e. ( Base ` ( l TGrp p ) )
         ( ( l trP p ) ` ( s ` f ) ) C_ ( ( l trP p ) ` f ) } ) @.

    @( Define delta ring. @)
    df-dring @a |- DRing = ( l e. _V , p e. _V |->
     { <. 1 , ( l TPEndo p ) >. ,
       <. 2 , ( +g ` ( l ERing p ) ) >. ,
       <. 3 , ( .r ` ( l ERing p ) ) >. } ) @.

    @( Define constructed partial vector space A. @)
    df-dveca @a |- DVecA = ( l e. _V , p e. _V |-> ( ( l DRing p )
    u. { <. 4 , ( Base ` ( l TGrp p ) ) >. ,
         <. 5 , ( +g ` ( l TGrp p ) ) >. ,
         <. 6 , ( s e. ( l TGrpEndo p ) , f e. ( l Trn p ) |->
                ( s ` f ) ) >. } ) ) @.

    @( Define preliminary projective subspace isomorphism. @)
    df-dvisopre @a |- DVIsoPre = ( l e. _V , p e. _V |->
     ( x e. { y e. ( PSubSp ` l ) | y C_ ( l ww p ) } |-> { f e. ( l Trn p ) |
     ( ( l trP p ) ` f ) C_ x } ) ) @.

    @( Define constructed partial vector space B. @)
    df-dvecb @a |- DVecB = ( l e. _V , p e. _V |-> ( ( l DRing p )
    u. { <. 4 , ( Base ` ( l DRing p ) ) >. ,
         <. 5 , ( +g ` ( l DRing p ) ) >. ,
         <. 6 , ( .r ` ( l DRing p ) ) >. } ) ) @.

    @( Define constructed vector space. @)
    df-dvechOLD @a |- DVecH = ( l e. _V , p e. _V |->
        ( ( l DVecA p ) o+ ( l DVecB p ) ) ) @.

    @( Define e vector. @)
    df-ee @a |- ee = ( l e. _V , p e. _V |->
      <. ( 0v ` ( l DVecA p ) ) , ( 1r ` ( l DRing p ) ) >. ) @.

    @( Define projective subspace isomorphism A. @)
    df-dvisoa @a |- DVIsoA = ( l e. _V , p e. _V |->
     ( x e. { y e. ( PSubSp ` l ) | y C_ ( l ww p ) } |->
      <. ( ( l DVIsoPre p ) ` x ) , ( 0v ` ( l DVecB p ) ) >. ) ) @.

    @( Define q-translation. @)
    df-qtr @a |- qtr = ( l e. _V , p e. _V |->
    ( q e. ( l WAtoms p ) |->
      <. ( iota f ( f e. ( l Trn p ) /\ ( f ` { p } ) = q ) ) ,
          ( 0v ` ( l DVecA p ) ) >. ) ) @.

    @( Define projective subspace isomorphism B. @)
    df-dvisob @a |- DVIsoB = ( l e. _V , p e. _V |->
    ( q e. ( l WAtoms p ) |-> { v e. ( l DVecH p ) | E. s e. ( l DRing p )
       v = ( s ( .s ` ( l DVecH p ) )
   ( ( l ee p ) ( vadd ` ( l DVecH p ) ) ( ( l qtr p ) ` q ) ) ) } ) ) @.

    @( Define projective subspace isomorphism C. @)
    df-dvisoc @a |- DVIsoC = ( l e. _V , p e. _V |->
     ( x e. { y e. ( PSubSp ` l ) | -. y C_ ( l ww p ) } |->
        ( iota z A. q e. ( l WAtoms p ) z = ( ( ( l DVIsoB p ) ` q )
              ( +g ` ( l DVecH p ) )
           ( ( l DVIsoA p ) ` ( x i^i ( l ww p ) ) ) ) ) ) ) @.

    @( Define projective subspace isomorphism. @)
    df-dvisoh @a |- DVIsoH = ( l e. _V , p e. _V |->
          ( ( l DVIsoA p ) u. ( l DVIsoC p ) ) ) @.

    @( Define constructed orthocomplement. @)
    df-soc @a |- S_|_ = ( l e. _V , p e. _V |->
        ( s e. ( SubSpNEW ` ( l DVecH p ) ) |->
          ( ( _|_P ` l ) ` ( `' ( l DVIsoH p ) ` s ) ) ) ) @.

    @( Define the opposite of a ring with multiplication reversed. @)
    df-ropp @a |- Ropp = ( r e. _V |-> ( ( r |` ( _V \ { 3 } ) ) u.
      { <. 3 , ( x e. ( Base ` r ) , y e. ( Base ` r ) |->
          ( y ( .r ` r ) x ) ) >. } ) ) @.

    @( Define the left dual of a vector space. @)
    df-vldual @a |- Vldual = ( v e. _V |-> ( ( v |` ( _V \ ( 3 ... 6 ) ) ) u.
      { a | E. l E. k E. t E. u E. w (
          ( k = ( Base ` v )
            /\ t = ( .r ` ( Ropp ` v ) )
            /\ u = ( vbase ` v ) )
        /\ ( w = { g | ( g : u --> k /\ A. r e. k A. x e. u
                  ( g ` ( r ( .s ` v ) x ) ) = ( ( g ` x ) t r ) ) }
             /\ a e. ( { <. 3 , t >. , <. 4 , w >. } u.
                  { <. 5 , ( g e. v , h e. v |-> ( x e. u |->
                      ( ( g ` x ) ( +g ` v ) ( h ` x ) ) ) ) >. ,
                    <. 6 , ( r e. k , g e. v |-> ( x e. u |->
                      ( r t ( g ` x ) ) ) ) >. } ) ) ) } ) ) @.

    @( Define vector domain. @)
    df-vecdom @a |- vecdom = ( w e. _V |->
             ( iota d A. f e. ( vbase ` w ) d = dom f ) ) @.

    @( Define kernel of a functional. @)
    df-ker @a |- ker = ( w e. _V |-> ( f e. ( vbase ` w ) |->
       { x e. ( vecdom ` w ) | ( f ` x ) = ( 0g ` w ) } ) ) @.

    @( Define one-dimensional subspace map. @)
    df-mapd @a |- mapd = ( l e. _V , p e. _V |-> { a | E. v E. w
     ( v = ( l DVecH p ) /\ w = ( Vldual ` v )
       /\ a e. ( s e. { r | E. x e. ( vbase ` v )
          r = ( ( span ` v ) ` { x } ) } |->
               ( iota t A. x e. s A. f e. ( vbase ` w )
   ( ( ( ker ` w ) ` f ) = s /\ t = ( ( span ` w ) ` { f } ) ) ) ) ) } ) @.

    @( Define e vector image. @)
    df-eimage @a |- eimage = ( l e. _V , p e. _V |-> { a | E. v E. w E. e
        ( ( v = ( l DVecH p ) /\ w = ( Vldual ` v )
          /\ e = ( l ee p ) )
           /\ a e. ( iota f ( f e. ( ( l mapd p ) ` ( ( spanNEW ` v ) ` { e } )
                ) /\ ( f ` e ) = ( 1r ` w ) ) ) ) } ) @.

    @( Define h map. @)
    df-hmap @a |- hmap = ( l e. _V , p e. _V |-> { a | E. v E. w E. e E. f
   ( ( v = ( l DVecH p ) /\ w = ( Vldual ` v ) /\ e = ( l ee p ) )
     /\ ( f = ( l eimage p )
          /\ a e. ( y e. ( vbase ` v ) |-> if ( y = ( 0v ` v ) ,
              ( 0v ` w ) , if ( y e. ( ( spanNEW ` v ) ` { e } ) ,
   ( iota u ( u e. ( ( spanNEW ` w ) ` { f } ) /\ ( u ` e ) = ( f ` y ) ) ) ,
       ( iota u ( u e. ( vbase ` w )
            /\ ( ( l mapd p ) ` ( ( spanNEW ` v ) ` { y } ) )
                = ( ( spanNEW ` w ) ` { v } )
            /\ ( ( l mapd v ) ` ( ( span ` v ) ` { ( e ( -vNEW ` v ) y ) } ) )
            = ( ( span ` w ) ` { ( f ( -vNEW ` w ) u ) } ) ) ) ) ) ) ) ) } ) @.

    @( Define g map. @)
    df-gmap @a |- gmap = ( l e. _V , p e. _V |-> { a | E. v E. w E. e E. f
   ( v = ( l DVecH p ) /\ w = ( Vldual ` v ) /\ a e. ( f e. ( vbase ` v )
   |-> ( iota g ( g e. ( Base ` w ) /\ A. x e. ( vbase ` v )
          ( ( l hmap p ) ` ( f ( .s ` v ) x ) )
              = ( g ( .s ` w ) ( ( l hmap l ) ` x ) ) ) ) ) ) } ) @.

    @( Define Hilbert space constructed from Hilbert lattice. @)
    df-hltohil @a |- HLtoHil = ( l e. _V , p e. _V |->
       ( ( l DVecH p ) u.
         { <. 7 , ( l gmap p ) >. ,
           <. 8 , ( a e. ( vbase ` ( l DVecH p ) ) , b e.
 ( vbase ` ( l DVecH p ) ) |-> ( ( ( l hmap p ) ` b ) ` a ) ) >. } ) ) @.
  @}
$)

  $c LLines $.
  $c LPlanes $.
  $c LVols $.
  $c Lines $.
  $c Points $.
  $c PSubSp $.
  $c pmap $.

  $( Extend class notation with set of all "lattice lines" (lattice elements
     which cover an atom) in a Hilbert lattice. $)
  clln $a class LLines $.

  $( Extend class notation with set of all "lattice planes" (lattice elements
     which cover a line) in a Hilbert lattice. $)
  clpl $a class LPlanes $.

  $( Extend class notation with set of all 3-dimensional "lattice volumes"
     (lattice elements which cover a plane) in a Hilbert lattice. $)
  clvol $a class LVols $.

  $( Extend class notation with set of all projective lines for a Hilbert
     lattice. $)
  clines $a class Lines $.

  $( Extend class notation with set of all projective points. $)
  cpointsN $a class Points $.

  $( Extend class notation with set of all projective subspaces. $)
  cpsubsp $a class PSubSp $.

  $( Extend class notation with projective map. $)
  cpmap $a class pmap $.

  ${
    $d a k p q r s x $.
    $( Define the set of all "lattice lines" (lattice elements which cover an
       atom) in a Hilbert lattice ` k ` , in other words all elements of height
       2 (or lattice dimension 2 or projective dimension 1).  (Contributed by
       NM, 16-Jun-2012.) $)
    df-llines $a |- LLines = ( k e. _V |-> { x e. ( Base ` k ) |
          E. p e. ( Atoms ` k ) p ( <o ` k ) x } ) $.

    $( Define the set of all "lattice planes" (lattice elements which cover a
       line) in a Hilbert lattice ` k ` , in other words all elements of height
       3 (or lattice dimension 3 or projective dimension 2).  (Contributed by
       NM, 16-Jun-2012.) $)
    df-lplanes $a |- LPlanes = ( k e. _V |-> { x e. ( Base ` k ) |
          E. p e. ( LLines ` k ) p ( <o ` k ) x } ) $.

    $( Define the set of all 3-dimensional "lattice volumes" (lattice elements
       which cover a plane) in a Hilbert lattice ` k ` , in other words all
       elements of height 4 (or lattice dimension 4 or projective dimension
       3).  (Contributed by NM, 1-Jul-2012.) $)
    df-lvols $a |- LVols = ( k e. _V |-> { x e. ( Base ` k ) |
          E. p e. ( LPlanes ` k ) p ( <o ` k ) x } ) $.

    $( Define set of all projective lines for a Hilbert lattice (actually in
       any set at all, for simplicity).  The join of two distinct atoms equals
       a line.  Definition of lines in item 1 of [Holland95] p. 222.
       (Contributed by NM, 19-Sep-2011.) $)
    df-lines $a |- Lines = ( k e. _V |-> { s | E. q e. ( Atoms ` k )
     E. r e. ( Atoms ` k ) ( q =/= r /\
     s = { p e. ( Atoms ` k ) | p ( le ` k ) ( q ( join ` k ) r ) } ) } ) $.

    $( Define set of all projective points in a Hilbert lattice (actually in
       any set at all, for simplicity).  A projective point is the singleton of
       a lattice atom.  Definition 15.1 of [MaedaMaeda] p. 61.  Note that item
       1 in [Holland95] p. 222 defines a point as the atom itself, but this
       leads to a complicated subspace ordering that may be either membership
       or inclusion based on its arguments.  (Contributed by NM,
       2-Oct-2011.) $)
    df-pointsN $a |- Points = ( k e. _V |-> { q |
                   E. p e. ( Atoms ` k ) q = { p } } ) $.

    $( Define set of all projective subspaces.  Based on definition of subspace
       in [Holland95] p. 212.  (Contributed by NM, 2-Oct-2011.) $)
    df-psubsp $a |- PSubSp = ( k e. _V |-> { s | ( s C_ ( Atoms ` k )
      /\ A. p e. s A. q e. s A. r e. ( Atoms ` k )
        ( r ( le ` k ) ( p ( join ` k ) q ) -> r e. s ) ) } ) $.

    $( Define projective map for ` k ` at ` a ` .  Definition in Theorem 15.5
       of [MaedaMaeda] p. 62.  (Contributed by NM, 2-Oct-2011.) $)
    df-pmap $a |- pmap = ( k e. _V |-> ( a e. ( Base ` k ) |->
               { p e. ( Atoms ` k ) | p ( le ` k ) a } ) ) $.
  $}

  ${
    $d k p A $.  $d k x B $.  $d k C $.  $d k p x K $.
    llnset.b $e |- B = ( Base ` K ) $.
    llnset.c $e |- C = ( <o ` K ) $.
    llnset.a $e |- A = ( Atoms ` K ) $.
    llnset.n $e |- N = ( LLines ` K ) $.
    $( The set of lattice lines in a Hilbert lattice.  (Contributed by NM,
       16-Jun-2012.) $)
    llnset $p |- ( K e. D -> N = { x e. B | E. p e. A p C x } ) $=
      ( vk cvv cv cfv ccvr catm cbs fveq2 wcel wrex crab wceq elex clln syl6eqr
      wbr breqd rexeqbidv rabeqbidv df-llines fvex eqeltri rabex fvmpt syl5eq
      syl ) FEUAFNUAZGHOZAOZDUHZHBUBZACUCZUDFEUEUSGFUFPVDLMFUTVAMOZQPZUHZHVERPZ
      UBZAVESPZUCVDNUFVEFUDZVIVCAVJCVKVJFSPZCVEFSTIUGVKVGVBHVHBVKVHFRPBVEFRTKUG
      VKVFDUTVAVKVFFQPDVEFQTJUGUIUJUKAMHULVCACCVLNIFSUMUNUOUPUQUR $.

    $d x A $.  $d x C $.  $d p x X $.
    $( The predicate "is a lattice line".  (Contributed by NM, 16-Jun-2012.) $)
    islln $p |- ( K e. D -> ( X e. N <-> ( X e. B /\ E. p e. A p C X ) ) ) $=
      ( vx wcel cv wbr wrex crab wa llnset eleq2d breq2 rexbidv elrab syl6bb
      wceq ) EDNZGFNGHOZMOZCPZHAQZMBRZNGBNUHGCPZHAQZSUGFULGMABCDEFHIJKLTUAUKUNM
      GBUIGUFUJUMHAUIGUHCUBUCUDUE $.

    $( The predicate "is a lattice line".  (Contributed by NM, 16-Jun-2012.) $)
    islln4 $p |- ( ( K e. D /\ X e. B )
       -> ( X e. N <-> E. p e. A p C X ) ) $=
      ( wcel cv wbr wrex islln baibd ) EDMGFMGBMHNGCOHAPABCDEFGHIJKLQR $.

    $d p C $.  $d p P $.
    $( Condition implying a lattice line.  (Contributed by NM, 17-Jun-2012.) $)
    llni $p |- ( ( ( K e. D /\ X e. B /\ P e. A ) /\ P C X ) -> X e. N ) $=
      ( vp wcel w3a wbr wa cv wrex simpl2 rspcev 3ad2antl3 simpl1 syl mpbir2and
      breq1 wb islln ) FDNZHBNZEANZOEHCPZQZHGNZUJMRZHCPZMASZUIUJUKULTUKUIULUQUJ
      UPULMEAUOEHCUFUAUBUMUIUNUJUQQUGUIUJUKULUCABCDFGHMIJKLUHUDUE $.
  $}

  ${
    $d p K $.  $d p X $.
    llnbase.b $e |- B = ( Base ` K ) $.
    llnbase.n $e |- N = ( LLines ` K ) $.
    $( A lattice line is a lattice element.  (Contributed by NM,
       16-Jun-2012.) $)
    llnbase $p |- ( X e. N -> X e. B ) $=
      ( vp cvv wcel clln cfv c0 wceq n0i eqeq1i sylnib fvprc nsyl2 cv eqid ccvr
      wbr catm wrex islln simprbda mpancom ) BHIZDCIZDAIZUIBJKZLMZUHUICLMULCDNC
      UKLFOPBJQRUHUIUJGSDBUAKZUBGBUCKZUDUNAUMHBCDGEUMTUNTFUEUFUG $.
  $}

  ${
    $d p q A $.  $d p q B $.  $d p q K $.  $d p q X $.
    islln3.b $e |- B = ( Base ` K ) $.
    islln3.j $e |- .\/ = ( join ` K ) $.
    islln3.a $e |- A = ( Atoms ` K ) $.
    islln3.n $e |- N = ( LLines ` K ) $.
    $( The predicate "is a lattice line".  (Contributed by NM, 17-Jun-2012.) $)
    islln3 $p |- ( ( K e. HL /\ X e. B )
     -> ( X e. N <-> E. p e. A E. q e. A ( p =/= q /\ X = ( p .\/ q ) ) ) ) $=
      ( chlt wcel wa cv cfv wbr wrex wb ccvr co wceq eqid islln4 cple wn simpll
      wne atbase adantl simplr cvrval3 syl3anc cal hlatl ad3antrrr simpr atncmp
      necom syl6bb eqcom a1i anbi12d rexbidva bitrd ) DMNZFBNZOZFENHPZFDUAQZRZH
      ASVJGPZUIZFVJVMCUBZUCZOZGASZHASABVKMDEFHIVKUDZKLUEVIVLVRHAVIVJANZOZVLVMVJ
      DUFQZRUGZVOFUCZOZGASZVRWAVGVJBNZVHVLWFTVGVHVTUHVTWGVIABVJDIKUJUKVGVHVTULA
      BVKCDWBVJFGIWBUDZJVSKUMUNWAWEVQGAWAVMANZOZWCVNWDVPWJWCVMVJUIZVNWJDUONZWIV
      TWCWKTVGWLVHVTWIDUPUQWAWIURVIVTWIULAVMVJDWBWHKUSUNVMVJUTVAWDVPTWJVOFVBVCV
      DVEVFVEVF $.

    $( The predicate "is a lattice line".  (Contributed by NM, 23-Jun-2012.) $)
    islln2 $p |- ( K e. HL -> ( X e. N
   <-> ( X e. B /\ E. p e. A E. q e. A ( p =/= q /\ X = ( p .\/ q ) ) ) ) ) $=
      ( wcel wa chlt cv wne co wceq wrex llnbase pm4.71ri islln3 pm5.32da
      syl5bb ) FEMZFBMZUFNDOMZUGHPZGPZQFUIUJCRSNGATHATZNUFUGBDEFILUAUBUHUGUFUKA
      BCDEFGHIJKLUCUDUE $.
  $}

  ${
    $d r s A $.  $d r s .\/ $.  $d r s K $.  $d r s P $.  $d r s Q $.
    llni2.j $e |- .\/ = ( join ` K ) $.
    llni2.a $e |- A = ( Atoms ` K ) $.
    llni2.n $e |- N = ( LLines ` K ) $.
    $( The join of two different atoms is a lattice line.  (Contributed by NM,
       26-Jun-2012.) $)
    llni2 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ P =/= Q )
         -> ( P .\/ Q ) e. N ) $=
      ( vr vs wcel wne wa co cv wceq wrex eqeq2d anbi12d chlt w3a simpl2 simpl3
      simpr eqidd neeq1 oveq1 neeq2 oveq2 rspc2ev syl112anc cbs cfv simpl1 eqid
      wb hlatjcl adantr islln3 syl2anc mpbird ) EUALZBALZCALZUBZBCMZNZBCDOZFLZJ
      PZKPZMZVIVKVLDOZQZNZKARJARZVHVDVEVGVIVIQZVQVCVDVEVGUCVCVDVEVGUDVFVGUEVHVI
      UFVPVGVRNBVLMZVIBVLDOZQZNJKBCAAVKBQZVMVSVOWAVKBVLUGWBVNVTVIVKBVLDUHSTVLCQ
      ZVSVGWAVRVLCBUIWCVTVIVIVLCBDUJSTUKULVHVCVIEUMUNZLZVJVQUQVCVDVEVGUOVFWEVGA
      WDDEBCWDUPZGHURUSAWDDEFVIKJWFGHIUTVAVB $.
  $}

  ${
    $d q A $.  $d q K $.  $d q .<_ $.  $d q N $.  $d q X $.  $d q P $.
    llnnleat.l $e |- .<_ = ( le ` K ) $.
    llnnleat.a $e |- A = ( Atoms ` K ) $.
    llnnleat.n $e |- N = ( LLines ` K ) $.
    $( An atom cannot majorize a lattice line.  (Contributed by NM,
       8-Jul-2012.) $)
    llnnleat $p |- ( ( K e. HL /\ X e. N /\ P e. A ) -> -. X .<_ P ) $=
      ( vq chlt wcel w3a cfv wbr wn wa simp2 eqid syl cv ccvr wrex cbs wb islln
      3ad2ant1 mpbid simprd cplt cal simp11 hlatl simp13 atnlt syl3anc 3ad2ant2
      atbase simp12 llnbase simp3 cvrlt syl31anc wi hlpos pltletr syl13anc mtod
      cpo mpand rexlimdv3a mpd ) CKLZFELZBALZMZJUAZFCUBNZOZJAUCZFBDOZPZVPFCUDNZ
      LZVTVPVNWDVTQZVMVNVORVMVNVNWEUEVOAWCVRKCEFJWCSZVRSZHIUFUGUHUIVPVSWBJAVPVQ
      ALZVSMZWAVQBCUJNZOZWICUKLZWHVOWKPWIVMWLVMVNVOWHVSULZCUMTVPWHVSRVMVNVOWHVS
      UNZAVQBWJCWJSZHUOUPWIVQFWJOZWAWKWIVMVQWCLZWDVSWPWMWHVPWQVSAWCVQCWFHURUQZW
      IVNWDVMVNVOWHVSUSWCCEFWFIUTTZVPWHVSVAKWCVRWJCVQFWFWOWGVBVCWICVILZWQWDBWCL
      ZWPWAQWKVDWIVMWTWMCVETWRWSWIVOXAWNAWCBCWFHURTWCWJCDVQFBWFGWOVFVGVJVHVKVL
      $.
  $}

  ${
    llnneat.a $e |- A = ( Atoms ` K ) $.
    llnneat.n $e |- N = ( LLines ` K ) $.
    $( A lattice line is not an atom.  (Contributed by NM, 19-Jun-2012.) $)
    llnneat $p |- ( ( K e. HL /\ X e. N ) -> -. X e. A ) $=
      ( chlt wcel wa cple cfv wbr clat cbs hllat eqid llnbase latref syl2an wn
      llnnleat 3expia mt2d ) BGHZDCHZIDAHZDDBJKZLZUDBMHDBNKZHUHUEBOUIBCDUIPZFQU
      IBUGDUJUGPZRSUDUEUFUHTADBUGCDUKEFUAUBUC $.
  $}

  ${
    2atneat.j $e |- .\/ = ( join ` K ) $.
    2atneat.a $e |- A = ( Atoms ` K ) $.
    $( The join of two distinct atoms is not an atom.  (Contributed by NM,
       12-Oct-2012.) $)
    2atneat $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ P =/= Q ) )
         -> -. ( P .\/ Q ) e. A ) $=
      ( chlt wcel wne w3a co clln cfv wn wa simpl simpr1 simpr2 simpr3 syl31anc
      eqid llni2 llnneat syldan ) EHIZBAIZCAIZBCJZKZBCDLZEMNZIZUKAIOUFUJPUFUGUH
      UIUMUFUJQUFUGUHUIRUFUGUHUISUFUGUHUITABCDEULFGULUBZUCUAAEULUKGUNUDUE $.
  $}

  ${
    $d p K $.  $d p N $.  $d p X $.  $d p .0. $.
    llnn0.z $e |- .0. = ( 0. ` K ) $.
    llnn0.n $e |- N = ( LLines ` K ) $.
    $( A lattice line is non-zero.  (Contributed by NM, 15-Jul-2012.) $)
    llnn0 $p |- ( ( K e. HL /\ X e. N ) -> X =/= .0. ) $=
      ( vp chlt wcel wa cv catm cfv wne wex c0 eqid atex n0 wbr sylib adantr wn
      cple llnnleat 3expa wceq cops cbs hlop ad2antrr atbase adantl op0le breq1
      syl2anc syl5ibrcom necon3bd mpd exlimddv ) AHIZCBIZJZGKZALMZIZCDNZGVAVFGO
      ZVBVAVEPNVHVEAVEQZRGVESUAUBVCVFJZCVDAUDMZTZUCZVGVAVBVFVMVEVDAVKBCVKQZVIFU
      EUFVJVLCDVJVLCDUGDVDVKTZVJAUHIZVDAUIMZIZVOVAVPVBVFAUJUKVFVRVCVEVQVDAVQQZV
      IULUMVQAVKVDDVSVNEUNUPCDVDVKUOUQURUSUT $.
  $}

  ${
    islln2a.j $e |- .\/ = ( join ` K ) $.
    islln2a.a $e |- A = ( Atoms ` K ) $.
    islln2a.n $e |- N = ( LLines ` K ) $.
    $( The predicate "is a lattice line" in terms of atoms.  (Contributed by
       NM, 15-Jul-2012.) $)
    islln2a $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
        -> ( ( P .\/ Q ) e. N <-> P =/= Q ) ) $=
      ( chlt wcel w3a co wne wceq wn wa oveq1 hlatjidm ex 3adant2 llnneat con2d
      sylan9eqr adantlr 3impia adantr eqneltrd necon2ad llni2 impbid ) EJKZBAKZ
      CAKZLZBCDMZFKZBCNZUOUQBCUOBCOZUQPUOUSQUPCFUSUOUPCCDMZCBCCDRULUNUTCOUMADEC
      GHSUAUDUOCFKZPZUSULUMUNVBULUMQZVAUNVCVAUNPZULVAVDUMAEFCHIUBUETUCUFUGUHTUI
      UOURUQABCDEFGHIUJTUK $.
  $}

  ${
    $d p q A $.  $d p q B $.  $d p q y K $.  $d p q y .<_ $.  $d p q y N $.
    $d p q y X $.  $d p q .0. $.
    llnle.b $e |- B = ( Base ` K ) $.
    llnle.l $e |- .<_ = ( le ` K ) $.
    llnle.z $e |- .0. = ( 0. ` K ) $.
    llnle.a $e |- A = ( Atoms ` K ) $.
    llnle.n $e |- N = ( LLines ` K ) $.
    $( Any element greater than 0 and not an atom majorizes a lattice line.
       (Contributed by NM, 28-Jun-2012.) $)
    llnle $p |- ( ( ( K e. HL /\ X e. B ) /\ ( X =/= .0. /\ -. X e. A ) )
               -> E. y e. N y .<_ X ) $=
      ( vp vq chlt wcel wa cv wbr wne wn wrex simpll simplr simprl atle syl3anc
      w3a cjn cfv ccvr cplt simp1ll atbase 3ad2ant2 simp1lr simp3 simp2 simp1rr
      co nelne2 syl2anc wb pltval mpbir2and hlrelat3 syl31anc wi simp21 hlatjcl
      eqid simp23 simp3l llni simp3r breq1 rspcev 3exp 3expd 3imp rexlimdv mpd
      ) DPQZGCQZRZGHUAZGBQUBZRZRZNSZGETZNBUCZASZGETZAFUCZWJWDWEWGWMWDWEWIUDWDWE
      WIUEWFWGWHUFBCDEGHNIJKLUGUHWJWLWPNBWJWKBQZWLWPWJWQWLUIZWKWKOSZDUJUKZVAZDU
      LUKZTZXAGETZRZOBUCZWPWRWDWKCQZWEWKGDUMUKZTZXFWDWEWIWQWLUNZWQWJXGWLBCWKDIL
      UOUPWDWEWIWQWLUQZWRXIWLWKGUAZWJWQWLURWRWQWHXLWJWQWLUSZWGWHWFWQWLUTWKGBVBV
      CWRWDWQWEXIWLXLRVDXJXMXKPBCXHDEWKGJXHVLZVEUHVFBCXBXHWTDEWKGOIJXNWTVLZXBVL
      ZLVGVHWRXEWPOBWJWQWLWSBQZXEWPVIZVIWJWQWLXQXRWJWQWLXQUIZXEWPWJXSXEUIZXAFQZ
      XDWPXTWDXACQZWQXCYAWDWEWIXSXEUNZXTWDWQXQYBYCWJWQWLXQXEVJZWJWQWLXQXEVMBCWT
      DWKWSIXOLVKUHYDWJXSXCXDVNBCXBPWKDFXAIXPLMVOVHWJXSXCXDVPWOXDAXAFWNXAGEVQVR
      VCVSVTWAWBWCVSWBWC $.
  $}

  ${
    $d q r A $.  $d q r C $.  $d q r K $.  $d q r .<_ $.  $d q r N $.
    $d q r P $.  $d q r X $.
    atcvrlln2.l $e |- .<_ = ( le ` K ) $.
    atcvrlln2.c $e |- C = ( <o ` K ) $.
    atcvrlln2.a $e |- A = ( Atoms ` K ) $.
    atcvrlln2.n $e |- N = ( LLines ` K ) $.
    $( An atom under a line is covered by it.  (Contributed by NM,
       2-Jul-2012.) $)
    atcvrlln2 $p |- ( ( ( K e. HL /\ P e. A /\ X e. N ) /\ P .<_ X )
        -> P C X ) $=
      ( vq vr wcel w3a wbr wa cv cfv wrex chlt wne cjn co wceq simpl3 wb simpl1
      cbs llnbase syl islln3 syl2anc mpbid simp1l1 simp1l2 simp2l simp2r simp3l
      eqid simp1r simp3r breqtrd atcvrj2 syl132anc breqtrrd 3exp rexlimdvv mpd
      ) DUANZCANZGFNZOZCGEPZQZLRZMRZUBZGVPVQDUCSZUDZUEZQZMATLATZCGBPZVOVLWCVJVK
      VLVNUFZVOVJGDUISZNZVLWCUGVJVKVLVNUHVOVLWGWEWFDFGWFUTZKUJUKAWFVSDFGMLWHVSU
      TZJKULUMUNVOWBWDLMAAVOVPANZVQANZQZWBWDVOWLWBOZCVTGBWMVJVKWJWKVRCVTEPCVTBP
      VJVKVLVNWLWBUOVJVKVLVNWLWBUPVOWJWKWBUQVOWJWKWBURVOWLVRWAUSWMCGVTEVMVNWLWB
      VAVOWLVRWAVBZVCABCVPVQVSDEHWIIJVDVEWNVFVGVHVI $.
  $}

  ${
    $d p q A $.  $d p q B $.  $d p q C $.  $d p q K $.  $d p q X $.
    $d p q Y $.
    atcvrlln.b $e |- B = ( Base ` K ) $.
    atcvrlln.c $e |- C = ( <o ` K ) $.
    atcvrlln.a $e |- A = ( Atoms ` K ) $.
    atcvrlln.n $e |- N = ( LLines ` K ) $.
    $( An element covering an atom is a lattice line and vice-versa.
       (Contributed by NM, 18-Jun-2012.) $)
    atcvrlln $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X C Y )
        -> ( X e. A <-> Y e. N ) ) $=
      ( vp vq chlt wcel w3a wbr wa simpll1 simpll3 simpr simplr syl31anc cv wne
      llni cjn cfv co wceq wrex wb eqid islln3 syl2anc mpbid wi simp1l1 simp1l2
      simp2l simp2r simp3l simp1r simp3r cvrat2 syl132anc 3exp rexlimdvv adantr
      breqtrd mpd impbida ) DNOZFBOZGBOZPZFGCQZRZFAOZGEOZVRVSRVMVOVSVQVTVMVNVOV
      QVSSVMVNVOVQVSTVRVSUAVPVQVSUBABCNFDEGHIJKUFUCVRVTRZLUDZMUDZUEZGWBWCDUGUHZ
      UIZUJZRZMAUKLAUKZVSWAVTWIVRVTUAWAVMVOVTWIULVMVNVOVQVTSVMVNVOVQVTTABWEDEGM
      LHWEUMZJKUNUOUPVRWIVSUQVTVRWHVSLMAAVRWBAOZWCAOZRZWHVSVRWMWHPZVMVNWKWLWDFW
      FCQVSVMVNVOVQWMWHURVMVNVOVQWMWHUSVRWKWLWHUTVRWKWLWHVAVRWMWDWGVBWNFGWFCVPV
      QWMWHVCVRWMWDWGVDVJABCWBWCWEDFHWJIJVEVFVGVHVIVKVL $.
  $}

  ${
    $d q A $.  $d q K $.  $d q .<_ $.  $d q N $.  $d q P $.  $d q X $.
    llnexat.l $e |- .<_ = ( le ` K ) $.
    llnexat.j $e |- .\/ = ( join ` K ) $.
    llnexat.a $e |- A = ( Atoms ` K ) $.
    llnexat.n $e |- N = ( LLines ` K ) $.
    $( Given an atom on a line, there is another atom whose join equals the
       line.  (Contributed by NM, 26-Jun-2012.)  (New usage is discouraged.) $)
    llnexatN $p |- ( ( ( K e. HL /\ X e. N /\ P e. A ) /\ P .<_ X )
      -> E. q e. A ( P =/= q /\ X = ( P .\/ q ) ) ) $=
      ( wcel w3a wbr wa cfv wne wceq syl chlt ccvr cv co wrex simp1 simp3 simp2
      3jca eqid atcvrlln2 sylan cbs simpl1 simpl3 atbase simpl2 llnbase cvrval3
      wn wb syl3anc cal simpll1 hlatl simpr simpll3 atncmp anbi1d necom anbi12i
      eqcom syl6bb rexbidva bitrd mpbid ) DUAMZGFMZBAMZNZBGEOZPZBGDUBQZOZBHUCZR
      ZGBWECUDZSZPZHAUEZVTVQVSVRNWAWDVTVQVSVRVQVRVSUFVQVRVSUGVQVRVSUHUIAWCBDEFG
      IWCUJZKLUKULWBWDWEBEOUTZWGGSZPZHAUEZWJWBVQBDUMQZMZGWPMZWDWOVAVQVRVSWAUNWB
      VSWQVQVRVSWAUOAWPBDWPUJZKUPTWBVRWRVQVRVSWAUQWPDFGWSLURTAWPWCCDEBGHWSIJWKK
      USVBWBWNWIHAWBWEAMZPZWNWEBRZWMPWIXAWLXBWMXADVCMZWTVSWLXBVAXAVQXCVQVRVSWAW
      TVDDVETWBWTVFVQVRVSWAWTVGAWEBDEIKVHVBVIXBWFWMWHWEBVJWGGVLVKVMVNVOVP $.
  $}

  ${
    $d p K $.  $d p .<_ $.  $d p N $.  $d p X $.  $d p Y $.
    llncmp.l $e |- .<_ = ( le ` K ) $.
    llncmp.n $e |- N = ( LLines ` K ) $.
    $( If two lattice lines are comparable, they are equal.  (Contributed by
       NM, 19-Jun-2012.) $)
    llncmp $p |- ( ( K e. HL /\ X e. N /\ Y e. N )
                -> ( X .<_ Y <-> X = Y ) ) $=
      ( vp chlt wcel w3a wbr cfv wi wb eqid llnbase syl2anc mpbid wa wceq simp2
      ccvr catm wrex cbs simp1 3ad2ant2 islln4 simpr3 cpo hlpos 3ad2ant1 adantr
      cv simpl3 syl simpr1 atbase simpr2 simpl1 cvrle syl31anc mp2and atcvrlln2
      postr syl13anc cvrcmp syl132anc 3exp2 rexlimdv mpd posref breq2 syl5ibcom
      impbid ) AIJZDCJZECJZKZDEBLZDEUAZVTHUOZDAUCMZLZHAUDMZUEZWAWBNZVTVRWGVQVRV
      SUBVTVQDAUFMZJZVRWGOVQVRVSUGVRVQWJVSWIACDWIPZGQUHZWFWIWDIACDHWKWDPZWFPZGU
      IRSVTWEWHHWFVTWCWFJZWEWAWBVTWOWEWAKZTZWAWBVTWOWEWAUJZWQAUKJZWJEWIJZWCWIJZ
      WEWCEWDLZWAWBOVTWSWPVQVRWSVSAULUMZUNZVTWJWPWLUNZWQVSWTVQVRVSWPUPZWIACEWKG
      QUQZWQWOXAVTWOWEWAURZWFWIWCAWKWNUSUQZVTWOWEWAUTZWQVQWOVSWCEBLZXBVQVRVSWPV
      AZXHXFWQWCDBLZWAXKWQVQXAWJWEXMXLXIXEXJIWIWDABWCDWKFWMVBVCWRWQWSXAWJWTXMWA
      TXKNXDXIXEXGWIABWCDEWKFVFVGVDWFWDWCABCEFWMWNGVEVCWIWDABDEWCWKFWMVHVISVJVK
      VLVTDDBLZWBWAVTWSWJXNXCWLWIABDWKFVMRDEDBVNVOVP $.
  $}

  ${
    llnnlt.s $e |- .< = ( lt ` K ) $.
    llnnlt.n $e |- N = ( LLines ` K ) $.
    $( Two lattice lines cannot satisfy the less than relation.  (Contributed
       by NM, 26-Jun-2012.) $)
    llnnlt $p |- ( ( K e. HL /\ X e. N /\ Y e. N ) -> -. X .< Y ) $=
      ( chlt wcel w3a wbr wceq pltirr 3adant3 breq2 notbid syl5ibcom cple cfv
      wn eqid pltle llncmp sylibd necon3ad pm2.61dne ) BHIZDCIZECIZJZDEAKZTZDEU
      JDDAKZTZDELZULUGUHUNUIHCABDFMNUOUMUKDEDAOPQUJUKDEUJUKDEBRSZKUOHCCABUPDEUP
      UAZFUBBUPCDEUQGUCUDUEUF $.
  $}

  ${
    $d p A $.  $d p K $.  $d p ./\ $.  $d p N $.  $d p X $.  $d p Y $.
    $d p .0. $.
    2llnmat.m $e |- ./\ = ( meet ` K ) $.
    2llnmat.z $e |- .0. = ( 0. ` K ) $.
    2llnmat.a $e |- A = ( Atoms ` K ) $.
    2llnmat.n $e |- N = ( LLines ` K ) $.
    $( Two intersecting lines intersect at an atom.  (Contributed by NM,
       30-Apr-2012.) $)
    2llnmat $p |- ( ( ( K e. HL /\ X e. N /\ Y e. N )
        /\ ( X =/= Y /\ ( X ./\ Y ) =/= .0. ) ) -> ( X ./\ Y ) e. A ) $=
      ( vp wcel wne wa wceq cfv wbr syl syl3anc chlt w3a co cv wrex cple simpl1
      cal cbs hlatl clat hllat simpl2 eqid llnbase simpl3 latmcl simprr simp1rl
      atlex wb simp1l llncmp simp1l1 simp1l2 simp1l3 latleeqm1 bitr3d necon3bid
      mpbid wo wi simp3 latmle1 cpo ccvr hlpos atbase 3ad2ant2 lattrd atcvrlln2
      simp2 syl31anc cvrnbtwn4 syl131anc mpbi2and neor sylib mpd 3exp reximdvai
      necon1d risset sylibr ) BUAMZEDMZFDMZUBZEFNZEFCUCZGNZOZOZLUDZWTPZLAUEZWTA
      MXCXDWTBUFQZRZLAUEZXFXCBUHMZWTBUIQZMZXAXIXCWOXJWOWPWQXBUGZBUJSXCBUKMZEXKM
      ZFXKMZXLXCWOXNXMBULZSXCWPXOWOWPWQXBUMXKBDEXKUNZKUOZSXCWQXPWOWPWQXBUPXKBDF
      XRKUOZSXKBCEFXRHUQZTWRWSXAURLAXKBXGWTGXRXGUNZIJUTTXCXHXELAXCXDAMZXHXEXCYC
      XHUBZWTENZXEYDWSYEWSXAWRYCXHUSYDEFWTEYDEFXGRZEFPZWTEPZYDWRYFYGVAWRXBYCXHV
      BBXGDEFYBKVCSYDXNXOXPYFYHVAYDWOXNWOWPWQXBYCXHVDZXQSZYDWPXOWOWPWQXBYCXHVEZ
      XSSZYDWQXPWOWPWQXBYCXHVFXTSZXKBXGCEFXRYBHVGTVHVIVJYDXDWTWTEYDXEYHVKZXDWTN
      YHVLYDXHWTEXGRZYNXCYCXHVMZYDXNXOXPYOYJYLYMXKBXGCEFXRYBHVNTZYDBVOMZXDXKMZX
      OXLXDEBVPQZRZXHYOOYNVAYDWOYRYIBVQSYCXCYSXHAXKXDBXRJVRVSZYLYDXNXOXPXLYJYLY
      MYATZYDWOYCWPXDEXGRUUAYIXCYCXHWBYKYDXKBXGXDWTEXRYBYJUUBUUCYLYPYQVTAYTXDBX
      GDEYBYTUNZJKWAWCXKYTBXGXDEWTXRYBUUDWDWEWFYHXDWTWGWHWLWIWJWKWILWTAWMWN $.
  $}

  ${
    2atmatz.j $e |- .\/ = ( join ` K ) $.
    2atmatz.m $e |- ./\ = ( meet ` K ) $.
    2atmatz.z $e |- .0. = ( 0. ` K ) $.
    2atmatz.a $e |- A = ( Atoms ` K ) $.
    $( Special case of ~ 2atmat0 where one atom could be zero.  (Contributed by
       NM, 30-May-2013.) $)
    2at0mat0 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
    /\ ( R e. A /\ ( S e. A \/ S = .0. ) /\ ( P .\/ Q ) =/= ( R .\/ S ) ) )
    -> ( ( ( P .\/ Q ) ./\ ( R .\/ S ) ) e. A
         \/ ( ( P .\/ Q ) ./\ ( R .\/ S ) ) = .0. ) ) $=
      ( wcel wceq wo co wa syl adantr chlt w3a wne simpll simplr1 simpr simplr3
      col cbs cfv simpl1 hlol simpr1 simpr2 eqid hlatjcl syl3anc simpl3 meetat2
      oveq1 hlatjidm syl2anc sylan9eqr oveq1d hllat atbase latmcom eqtrd eleq1d
      clat eqeq1d orbi12d mpbird oveq2d adantlr wn clln simpll1 simpll2 simpll3
      df-ne wi llni2 syl31anc simplr2 2llnmat syl32anc 3exp2 imp31 syl5bir orrd
      simpr3 orcomd pm2.61dane syl13anc oveq2 olj01 mpjaodan ) GUANZBANZCANZUBZ
      DANZEANZEIOZPZBCFQZDEFQZUCZUBZRZXDXGXHHQZANZXLIOZPZXEXKXDRXBXCXDXIXOXBXJX
      DUDXCXFXIXBXDUEXKXDUFXCXFXIXBXDUGXBXCXDXIUBZRZXOBCXQBCOZRZXOXHCHQZANZXTIO
      ZPZXQYCXRXQGUHNZXHGUIUJZNZXAYCXQWSYDWSWTXAXPUKZGULZSZXQWSXCXDYFYGXBXCXDXI
      UMXBXCXDXIUNZAYEFGDEYEUOZJMUPUQZWSWTXAXPURZAYECGHXHIYKKLMUSUQTXSXMYAXNYBX
      SXLXTAXSXLCXHHQZXTXSXGCXHHXRXQXGCCFQZCBCCFUTXQWSXAYOCOYGYMAFGCJMVAVBVCVDX
      QYNXTOZXRXQGVJNZCYENZYFYPXQWSYQYGGVESXQXAYRYMAYECGYKMVFSYLYEGHCXHYKKVGUQT
      VHZVIXSXLXTIYSVKVLVMXQBCUCZRZXODEXQDEOZXOYTXQUUBRZXOXGEHQZANZUUDIOZPZXQUU
      GUUBXQYDXGYENZXDUUGYIXBUUHXPAYEFGBCYKJMUPZTYJAYEEGHXGIYKKLMUSUQTUUCXMUUEX
      NUUFUUCXLUUDAUUCXHEXGHUUBXQXHEEFQZEDEEFUTXQWSXDUUJEOYGYJAFGEJMVAVBVCVNZVI
      UUCXLUUDIUUKVKVLVMVOUUADEUCZRZXNXMUUMXNXMXNVPXLIUCZUUMXMXLIWAXQYTUULUUNXM
      WBXQYTUULUUNXMXQYTUULUUNUBZRZWSXGGVQUJZNZXHUUQNZXIUUNXMWSWTXAXPUUOVRZUUPW
      SWTXAYTUURUUTWSWTXAXPUUOVSWSWTXAXPUUOVTXQYTUULUUNUMABCFGUUQJMUUQUOZWCWDUU
      PWSXCXDUULUUSUUTXCXDXIXBUUOUEXCXDXIXBUUOWEXQYTUULUUNUNADEFGUUQJMUVAWCWDXC
      XDXIXBUUOUGXQYTUULUUNWLAGHUUQXGXHIKLMUVAWFWGWHWIWJWKWMWNWNWOXKXERZXOXGDHQ
      ZANZUVCIOZPZXKUVFXEXKYDUUHXCUVFXKWSYDWSWTXAXJUKYHSZXBUUHXJUUITXBXCXFXIUMZ
      AYEDGHXGIYKKLMUSUQTUVBXMUVDXNUVEUVBXLUVCAUVBXHDXGHXEXKXHDIFQZDEIDFWPXKYDD
      YENZUVIDOUVGXKXCUVJUVHAYEDGYKMVFSYEFGDIYKJLWQVBVCVNZVIUVBXLUVCIUVKVKVLVMX
      BXCXFXIUNWR $.

    $( The meet of two unequal lines (expressed as joins of atoms) is an atom
       or zero.  (Contributed by NM, 2-Dec-2012.) $)
    2atmat0 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
    /\ ( R e. A /\ S e. A /\ ( P .\/ Q ) =/= ( R .\/ S ) ) )
    -> ( ( ( P .\/ Q ) ./\ ( R .\/ S ) ) e. A
          \/ ( ( P .\/ Q ) ./\ ( R .\/ S ) ) = .0. ) ) $=
      ( chlt wcel w3a co wne wceq wo simpl simpr1 simpr2 orcd 2at0mat0 syl13anc
      wa simpr3 ) GNOBAOCAOPZDAOZEAOZBCFQZDEFQZRZPZUGZUIUJUKEISZTUNULUMHQZAOURI
      STUIUOUAUIUJUKUNUBUPUKUQUIUJUKUNUCUDUIUJUKUNUHABCDEFGHIJKLMUEUF $.
  $}

  ${
    2atm.l $e |- .<_ = ( le ` K ) $.
    2atm.j $e |- .\/ = ( join ` K ) $.
    2atm.m $e |- ./\ = ( meet ` K ) $.
    2atm.a $e |- A = ( Atoms ` K ) $.
    $( An atom majorized by two different atom joins (which could be atoms or
       lines) is equal to their intersection.  (Contributed by NM,
       30-Jun-2013.) $)
    2atm $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
    /\ ( R e. A /\ S e. A /\ T e. A )
    /\ ( T .<_ ( P .\/ Q ) /\ T .<_ ( R .\/ S )
        /\ ( P .\/ Q ) =/= ( R .\/ S ) ) )
    -> T = ( ( P .\/ Q ) ./\ ( R .\/ S ) ) ) $=
      ( wcel w3a co wbr syl syl3anc chlt wne wceq simp31 simp32 clat cbs cfv wa
      wb simp11 hllat simp23 atbase simp12 simp13 latjcl simp21 simp22 latlem12
      eqid hlatjcl syl13anc mpbi2and cal hlatl latmcl atlen0 syl31anc neneqd wo
      cp0 simp33 2atmat0 syl33anc ord mt3d atcmp mpbid ) HUAOZBAOZCAOZPZDAOZEAO
      ZFAOZPZFBCGQZIRZFDEGQZIRZWHWJUBZPZPZFWHWJJQZIRZFWOUCZWNWIWKWPWCWGWIWKWLUD
      WCWGWIWKWLUEWNHUFOZFHUGUHZOZWHWSOZWJWSOZWIWKUIWPUJWNVTWRVTWAWBWGWMUKZHULS
      ZWNWFWTWCWDWEWFWMUMZAWSFHWSVAZNUNSWNWRBWSOZCWSOZXAXDWNWAXGVTWAWBWGWMUOZAW
      SBHXFNUNSWNWBXHVTWAWBWGWMUPZAWSCHXFNUNSWSGHBCXFLUQTZWNVTWDWEXBXCWCWDWEWFW
      MURZWCWDWEWFWMUSZAWSGHDEXFLNVBTZWSHIJFWHWJXFKMUTVCVDZWNHVEOZWFWOAOZWPWQUJ
      WNVTXPXCHVFSZXEWNXQWOHVLUHZUCZWNWOXSWNXPWOWSOZWFWPWOXSUBXRWNWRXAXBYAXDXKX
      NWSHJWHWJXFMVGTXEXOAWSFHIWOXSXFKXSVAZNVHVIVJWNXQXTWNVTWAWBWDWEWLXQXTVKXCX
      IXJXLXMWCWGWIWKWLVMABCDEGHJXSLMYBNVNVOVPVQAFWOHIKNVRTVS $.

    $( Variation of projective geometry axiom ~ ps-2 .  (Contributed by NM,
       3-Jul-2012.) $)
    ps-2c $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
        /\ ( R e. A /\ S e. A /\ T e. A )
        /\ ( ( -. P .<_ ( Q .\/ R ) /\ S =/= T )
           /\ ( P .\/ R ) =/= ( S .\/ T )
           /\ ( S .<_ ( P .\/ Q ) /\ T .<_ ( Q .\/ R ) ) ) )
  -> ( ( P .\/ R ) ./\ ( S .\/ T ) ) e. A ) $=
      ( wcel w3a co wbr wne syl chlt clln cfv cp0 simp11 simp12 simp21 clat cbs
      wn wa hllat eqid atbase simp13 simp31l latnlej1r syl131anc llni2 syl31anc
      simp22 simp23 simp31r simp32 simp33 ps-2b syl333anc 2llnmat syl32anc ) HU
      AOZBAOZCAOZPZDAOZEAOZFAOZPZBCDGQZIRUJZEFSZUKZBDGQZEFGQZSZEBCGQIRFVRIRUKZP
      ZPZVJWBHUBUCZOZWCWHOZWDWBWCJQZHUDUCZSZWKAOVJVKVLVQWFUEZWGVJVKVNBDSZWIWNVJ
      VKVLVQWFUFZVMVNVOVPWFUGZWGHUHOZBHUIUCZOZCWSOZDWSOZVSWOWGVJWRWNHULTWGVKWTW
      PAWSBHWSUMZNUNTWGVLXAVJVKVLVQWFUOZAWSCHXCNUNTWGVNXBWQAWSDHXCNUNTVSVTWDWEV
      MVQUPZWSGHIBCDXCKLUQURABDGHWHLNWHUMZUSUTWGVJVOVPVTWJWNVMVNVOVPWFVAZVMVNVO
      VPWFVBZVSVTWDWEVMVQVCZAEFGHWHLNXFUSUTVMVQWAWDWEVDWGVJVKVLVNVOVPVSVTWEWMWN
      WPXDWQXGXHXEXIVMVQWAWDWEVEABCDEFGHIJWLKLMWLUMZNVFVGAHJWHWBWCWLMXJNXFVHVI
      $.
  $}

  ${
    $d k y N $.  $d k x B $.  $d k C $.  $d k y x K $.
    lplnset.b $e |- B = ( Base ` K ) $.
    lplnset.c $e |- C = ( <o ` K ) $.
    lplnset.n $e |- N = ( LLines ` K ) $.
    lplnset.p $e |- P = ( LPlanes ` K ) $.
    $( The set of lattice planes in a Hilbert lattice.  (Contributed by NM,
       16-Jun-2012.) $)
    lplnset $p |- ( K e. A -> P = { x e. B | E. y e. N y C x } ) $=
      ( vk cvv cv cfv ccvr clln cbs fveq2 wcel wrex crab wceq elex clpl syl6eqr
      wbr breqd rexeqbidv rabeqbidv df-lplanes fvex eqeltri rabex fvmpt syl5eq
      syl ) GCUAGNUAZFBOZAOZEUHZBHUBZADUCZUDGCUEUSFGUFPVDLMGUTVAMOZQPZUHZBVERPZ
      UBZAVESPZUCVDNUFVEGUDZVIVCAVJDVKVJGSPZDVEGSTIUGVKVGVBBVHHVKVHGRPHVEGRTKUG
      VKVFEUTVAVKVFGQPEVEGQTJUGUIUJUKAMBULVCADDVLNIGSUMUNUOUPUQUR $.

    $d x N $.  $d x C $.  $d y x X $.
    $( The predicate "is a lattice plane".  (Contributed by NM,
       16-Jun-2012.) $)
    islpln $p |- ( K e. A -> ( X e. P <-> ( X e. B /\ E. y e. N y C X ) ) ) $=
      ( vx wcel cv wbr wrex crab wa lplnset eleq2d breq2 rexbidv elrab syl6bb
      wceq ) FBNZHENHAOZMOZDPZAGQZMCRZNHCNUHHDPZAGQZSUGEULHMABCDEFGIJKLTUAUKUNM
      HCUIHUFUJUMAGUIHUHDUBUCUDUE $.

    $( The predicate "is a lattice plane".  (Contributed by NM,
       17-Jun-2012.) $)
    islpln4 $p |- ( ( K e. A /\ X e. B )
       -> ( X e. P <-> E. y e. N y C X ) ) $=
      ( wcel cv wbr wrex islpln baibd ) FBMHEMHCMANHDOAGPABCDEFGHIJKLQR $.

    $d x Y $.
    $( Condition implying a lattice plane.  (Contributed by NM,
       20-Jun-2012.) $)
    lplni $p |- ( ( ( K e. D /\ Y e. B /\ X e. N ) /\ X C Y ) -> Y e. P ) $=
      ( vx wcel w3a wbr wa cv wrex simpl2 rspcev 3ad2antl3 wb simpl1 islpln syl
      breq1 mpbir2and ) ECNZHANZGFNZOGHBPZQZHDNZUJMRZHBPZMFSZUIUJUKULTUKUIULUQU
      JUPULMGFUOGHBUGUAUBUMUIUNUJUQQUCUIUJUKULUDMCABDEFHIJKLUEUFUH $.
  $}

  ${
    $d p A $.  $d p y B $.  $d p y K $.  $d p .<_ $.  $d p y N $.  $d p y X $.
    islpln3.b $e |- B = ( Base ` K ) $.
    islpln3.l $e |- .<_ = ( le ` K ) $.
    islpln3.j $e |- .\/ = ( join ` K ) $.
    islpln3.a $e |- A = ( Atoms ` K ) $.
    islpln3.n $e |- N = ( LLines ` K ) $.
    islpln3.p $e |- P = ( LPlanes ` K ) $.
    $( The predicate "is a lattice plane".  (Contributed by NM,
       17-Jun-2012.) $)
    islpln3 $p |- ( ( K e. HL /\ X e. B )
   -> ( X e. P
          <-> E. y e. N E. p e. A ( -. p .<_ y /\ X = ( y .\/ p ) ) ) ) $=
      ( chlt wcel wa wrex cv ccvr cfv wn co wceq eqid islpln4 wb simpll llnbase
      wbr adantl simplr cvrval3 syl3anc eqcom a1i anbi2d rexbidva bitrd ) FQRZI
      CRZSZIDRAUAZIFUBUCZULZAHTJUAZVEGULUDZIVEVHEUEZUFZSZJBTZAHTAQCVFDFHIKVFUGZ
      OPUHVDVGVMAHVDVEHRZSZVGVIVJIUFZSZJBTZVMVPVBVECRZVCVGVSUIVBVCVOUJVOVTVDCFH
      VEKOUKUMVBVCVOUNBCVFEFGVEIJKLMVNNUOUPVPVRVLJBVPVHBRSZVQVKVIVQVKUIWAVJIUQU
      RUSUTVAUTVA $.
  $}

  ${
    $d x K $.  $d x X $.
    lplnbase.b $e |- B = ( Base ` K ) $.
    lplnbase.p $e |- P = ( LPlanes ` K ) $.
    $( A lattice plane is a lattice element.  (Contributed by NM,
       17-Jun-2012.) $)
    lplnbase $p |- ( X e. P -> X e. B ) $=
      ( vx cvv wcel clpl cfv c0 wceq n0i eqeq1i sylnib fvprc nsyl2 cv eqid ccvr
      wbr clln wrex islpln simprbda mpancom ) CHIZDBIZDAIZUICJKZLMZUHUIBLMULBDN
      BUKLFOPCJQRUHUIUJGSDCUAKZUBGCUCKZUDGHAUMBCUNDEUMTUNTFUEUFUG $.
  $}

  ${
    $d p q r y A $.  $d p q r y B $.  $d p q r y .\/ $.  $d p q r y K $.
    $d p q r y .<_ $.  $d p q r y X $.
    islpln5.b $e |- B = ( Base ` K ) $.
    islpln5.l $e |- .<_ = ( le ` K ) $.
    islpln5.j $e |- .\/ = ( join ` K ) $.
    islpln5.a $e |- A = ( Atoms ` K ) $.
    islpln5.p $e |- P = ( LPlanes ` K ) $.
    $( The predicate "is a lattice plane" in terms of atoms.  (Contributed by
       NM, 24-Jun-2012.) $)
    islpln5 $p |- ( ( K e. HL /\ X e. B )
      -> ( X e. P <-> E. p e. A E. q e. A E. r e. A
    ( p =/= q /\ -. r .<_ ( p .\/ q ) /\ X = ( ( p .\/ q ) .\/ r ) ) ) ) $=
      ( vy wcel wa wrex wex chlt cv wbr wn co wceq clln cfv wne islpln3 rexcom4
      w3a eqid rexbii bitri simpll simprl simprr hlatjcl syl3anc biantrurd an13
      r19.41v exbii ovex eleq1 breq2 notbid oveq1 eqeq2d anbi12d anbi2d syl6bbr
      3anass syl5bb rexbidv r19.42v 3bitr3g ceqsexv syl6rbbr 2rexbidva syl5rbbr
      an12 islln2 adantr anbi1d an32 3bitr4ri syl6bb rexcom exbidv bitrd df-rex
      wb ) EUAQZGBQZRZGCQHUBZPUBZFUCZUDZGWSWRDUEZUFZRZHASZPEUGUHZSZJUBZIUBZUIZW
      RXHXIDUEZFUCZUDZGXKWRDUEZUFZULZHASZIASJASZPABCDEFXFGHKLMNXFUMZOUJWQXRWSXF
      QZXERZPTZXGWQXRWSBQZXDRZXJWSXKUFZRZRZHASZIASZJASZPTZYBYKYHPTZIASZJASZWQXR
      YNYIPTZJASYKYMYOJAYHIPAUKUNYIJPAUKUOWQYLXQJIAAWQXHAQZXIAQZRZRZXQXKBQZXQRZ
      YLYSYTXQYSWOYPYQYTWOWPYRUPWQYPYQUQWQYPYQURABDEXHXIKMNUSUTVAYLYEXJYDHASZRZ
      RZPTUUAYHUUDPYHUUBYFRUUDYDYFHAVCUUBXJYEVBUOVDUUCUUAPXKXHXIDVEYEXJYDRZHASY
      TXPRZHASUUCUUAYEUUEUUFHAUUEYCXJXDRZRYEUUFXJYCXDWCYEYCYTUUGXPWSXKBVFYEUUGX
      JXMXORZRXPYEXDUUHXJYEXAXMXCXOYEWTXLWSXKWRFVGVHYEXBXNGWSXKWRDVIVJVKVLXJXMX
      OVNVMVKVOVPXJYDHAVQYTXPHAVQVRVSUOVTWAWBWQYJYAPWQYJXTXDRZHASZYAWQUUJYGIASZ
      JASZHASZYJWQUUIUULHAWQUUIYCYFIASZJASZRZXDRZUULWQXTUUPXDWOXTUUPWNWPABDEXFW
      SIJKMNXSWDWEWFYDUUNRZJASYDUUORUULUUQYDUUNJAVQUUKUURJAYDYFIAVQUNYCUUOXDWGW
      HWIVPYJUUKHASZJASUUMYIUUSJAYGIHAAWJUNUUKJHAAWJUOVTXTXDHAVQWIWKWLXEPXFWMVT
      WL $.

    $( The predicate "is a lattice plane" in terms of atoms.  (Contributed by
       NM, 25-Jun-2012.) $)
    islpln2 $p |- ( K e. HL
      -> ( X e. P <-> ( X e. B /\ E. p e. A E. q e. A E. r e. A
  ( p =/= q /\ -. r .<_ ( p .\/ q ) /\ X = ( ( p .\/ q ) .\/ r ) ) ) ) ) $=
      ( wcel wa cv co wrex chlt wne wbr wceq lplnbase pm4.71ri islpln5 pm5.32da
      wn w3a syl5bb ) GCPZGBPZULQEUAPZUMJRZIRZUBHRZUOUPDSZFUCUIGURUQDSUDUJHATIA
      TJATZQULUMBCEGKOUEUFUNUMULUSABCDEFGHIJKLMNOUGUHUK $.
  $}

  ${
    $d q r s A $.  $d q r s .\/ $.  $d q r s K $.  $d q r s .<_ $.
    $d q r s Q $.  $d q r s R $.  $d q r s S $.
    lplni2.l $e |- .<_ = ( le ` K ) $.
    lplni2.j $e |- .\/ = ( join ` K ) $.
    lplni2.a $e |- A = ( Atoms ` K ) $.
    lplni2.p $e |- P = ( LPlanes ` K ) $.
    $( The join of 3 different atoms is a lattice plane.  (Contributed by NM,
       4-Jul-2012.) $)
    lplni2 $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ ( Q =/= R
          /\ -. S .<_ ( Q .\/ R ) ) ) -> ( ( Q .\/ R ) .\/ S ) e. P ) $=
      ( vq vr vs wcel w3a co wbr wceq chlt wne wn wa cv wrex simp2 simp3l eqidd
      simp3r neeq1 oveq1 breq2d notbid oveq1d eqeq2d neeq2 oveq2 breq1 3anbi23d
      3anbi123d rspc3ev syl13anc cbs wb simp1 clat hllat 3ad2ant1 simp21 simp22
      cfv eqid hlatjcl syl3anc simp23 atbase syl latjcl islpln5 syl2anc mpbird
      ) GUAPZCAPZDAPZEAPZQZCDUBZECDFRZHSZUCZUDZQZWIEFRZBPZMUEZNUEZUBZOUEZWPWQFR
      ZHSZUCZWNWTWSFRZTZQZOAUFNAUFMAUFZWMWGWHWKWNWNTZXFWCWGWLUGWCWGWHWKUHWCWGWH
      WKUJWMWNUIXEWHWKXGQCWQUBZWSCWQFRZHSZUCZWNXIWSFRZTZQWHWSWIHSZUCZWNWIWSFRZT
      ZQMNOCDEAAAWPCTZWRXHXBXKXDXMWPCWQUKXRXAXJXRWTXIWSHWPCWQFULZUMUNXRXCXLWNXR
      WTXIWSFXSUOUPVAWQDTZXHWHXKXOXMXQWQDCUQXTXJXNXTXIWIWSHWQDCFURZUMUNXTXLXPWN
      XTXIWIWSFYAUOUPVAWSETZXOWKXQXGWHYBXNWJWSEWIHUSUNYBXPWNWNWSEWIFURUPUTVBVCW
      MWCWNGVDVLZPZWOXFVEWCWGWLVFZWMGVGPZWIYCPZEYCPZYDWCWGYFWLGVHVIWMWCWDWEYGYE
      WCWDWEWFWLVJWCWDWEWFWLVKAYCFGCDYCVMZJKVNVOWMWFYHWCWDWEWFWLVPAYCEGYIKVQVRY
      CFGWIEYIJVSVOAYCBFGHWNONMYIIJKLVTWAWB $.
  $}

  ${
    $d q r s t A $.  $d q r s t K $.  $d q r s t .<_ $.  $d q r s t X $.
    lvolex3.l $e |- .<_ = ( le ` K ) $.
    lvolex3.a $e |- A = ( Atoms ` K ) $.
    lvolex3.p $e |- P = ( LPlanes ` K ) $.
    $( There is an atom outside of a lattice plane i.e. a 3-dimensional lattice
       volume exists.  (Contributed by NM, 28-Jul-2012.)
       (New usage is discouraged.) $)
    lvolex3N $p |- ( ( K e. HL /\ X e. P ) -> E. q e. A -. q .<_ X ) $=
      ( vr vs vt wcel cv wbr wn wrex cfv co wa chlt cbs wne cjn wceq w3a simp1l
      eqid islpln2 simp1rl simp1rr simp2 3dim3 syl13anc wb simp33 breq2 rexbidv
      notbid syl mpbird rexlimdv3a rexlimdvva adantld sylbid imp ) CUAMZEBMZFNZ
      EDOZPZFAQZVGVHECUBRZMZJNZKNZUCZLNZVOVPCUDRZSZDOPZEVTVRVSSZUEZUFZLAQZKAQJA
      QZTVLAVMBVSCDELKJVMUHGVSUHZHIUIVGWFVLVNVGWEVLJKAAVGVOAMZVPAMZTZTZWDVLLAWK
      VRAMZWDUFZVLVIWBDOZPZFAQZWMVGWHWIWLWPVGWJWLWDUGWHWIVGWLWDUJWHWIVGWLWDUKWK
      WLWDULAVOVPVRVSCDFWGGHUMUNWMWCVLWPUOWKWLVQWAWCUPWCVKWOFAWCVJWNEWBVIDUQUSU
      RUTVAVBVCVDVEVF $.
  $}

  ${
    $d u A $.  $d u K $.  $d u .<_ $.  $d u ./\ $.  $d u N $.  $d u P $.
    $d u X $.  $d u Y $.  $d u .0. $.
    llnmlpln.l $e |- .<_ = ( le ` K ) $.
    llnmlpln.m $e |- ./\ = ( meet ` K ) $.
    llnmlpln.z $e |- .0. = ( 0. ` K ) $.
    llnmlpln.a $e |- A = ( Atoms ` K ) $.
    llnmlpln.n $e |- N = ( LLines ` K ) $.
    llnmlpln.p $e |- P = ( LPlanes ` K ) $.
    $( The intersection of a line with a plane not containing it is an atom.
       (Contributed by NM, 29-Jun-2012.)  (New usage is discouraged.) $)
    llnmlplnN $p |- ( ( ( K e. HL /\ X e. N /\ Y e. P ) /\
      ( -. X .<_ Y /\ ( X ./\ Y ) =/= .0. ) ) -> ( X ./\ Y ) e. A ) $=
      ( vu wcel wbr wa syl3anc chlt w3a wn co wne simprl wceq cv cbs cfv simp11
      wrex clat hllat syl simp12 eqid simp13 lplnbase latmcl simp2r simp3 llnle
      llnbase syl22anc adantr latmle1 ad2antrl simprr lattrd wb simpl11 simpl12
      llncmp mpbid eqbrtrrd latasymd rexlimddv latleeqm1 mpbird 3expia mt3d ) C
      UAQZGFQZHBQZUBZGHDRZUCZGHEUDZIUEZSZSWIAQZWGWFWHWJUFWFWKWLUCZWGWFWKWMUBZWG
      WIGUGZWNPUHZWIDRZWOPFWNWCWICUIUJZQZWJWMWQPFULWCWDWEWKWMUKZWNCUMQZGWRQZHWR
      QZWSWNWCXAWTCUNUOZWNWDXBWCWDWEWKWMUPWRCFGWRUQZNVDUOZWNWEXCWCWDWEWKWMURWRB
      CHXEOUSUOZWRCEGHXEKUTTZWFWHWJWMVAWFWKWMVBPAWRCDFWIIXEJLMNVCVEWNWPFQZWQSZS
      ZWRCDWIGXEJWNXAXJXDVFZWNWSXJXHVFZWNXBXJXFVFZWNWIGDRZXJWNXAXBXCXOXDXFXGWRC
      DEGHXEJKVGTVFZXKWPGWIDXKWPGDRZWPGUGZXKWRCDWPWIGXEJXLXIWPWRQWNWQWRCFWPXENV
      DVHXMXNWNXIWQVIZXPVJXKWCXIWDXQXRVKWCWDWEWKWMXJVLWNXIWQUFWCWDWEWKWMXJVMCDF
      WPGJNVNTVOXSVPVQVRWNXAXBXCWGWOVKXDXFXGWRCDEGHXEJKVSTVTWAWB $.
  $}

  ${
    $d p z A $.  $d p z B $.  $d p y z K $.  $d p y z .<_ $.  $d p z N $.
    $d p y z P $.  $d p y z X $.  $d p z .0. $.
    lplnle.b $e |- B = ( Base ` K ) $.
    lplnle.l $e |- .<_ = ( le ` K ) $.
    lplnle.z $e |- .0. = ( 0. ` K ) $.
    lplnle.a $e |- A = ( Atoms ` K ) $.
    lplnle.n $e |- N = ( LLines ` K ) $.
    lplnle.p $e |- P = ( LPlanes ` K ) $.
    $( Any element greater than 0 and not an atom and not a lattice line
       majorizes a lattice plane.  (Contributed by NM, 28-Jun-2012.) $)
    lplnle $p |- ( ( ( K e. HL /\ X e. B )
       /\ ( X =/= .0. /\ -. X e. A /\ -. X e. N ) ) -> E. y e. P y .<_ X ) $=
      ( vz vp wcel wa wbr chlt wne wn w3a wrex llnle 3adantr3 cjn cfv ccvr cplt
      cv co simp1ll llnbase 3ad2ant2 simp1lr simp3 simp2 simp1r3 nelne2 syl2anc
      wb eqid pltval syl3anc mpbir2and hlrelat3 syl31anc wi hllat simp21 simp23
      clat syl atbase latjcl simp3l lplni simp3r breq1 3exp 3expd 3imp rexlimdv
      rspcev mpd ) EUARZHCRZSZHIUBZHBRUCZHGRUCZUDZSZPULZHFTZPGUEZAULZHFTZADUEZW
      JWKWLWRWMPBCEFGHIJKLMNUFUGWOWQXAPGWOWPGRZWQXAWOXBWQUDZWPWPQULZEUHUIZUMZEU
      JUIZTZXFHFTZSZQBUEZXAXCWHWPCRZWIWPHEUKUIZTZXKWHWIWNXBWQUNZXBWOXLWQCEGWPJN
      UOZUPWHWIWNXBWQUQZXCXNWQWPHUBZWOXBWQURXCXBWMXRWOXBWQUSZWKWLWMWJXBWQUTWPHG
      VAVBXCWHXBWIXNWQXRSVCXOXSXQUAGCXMEFWPHKXMVDZVEVFVGBCXGXMXEEFWPHQJKXTXEVDZ
      XGVDZMVHVIXCXJXAQBWOXBWQXDBRZXJXAVJZVJWOXBWQYCYDWOXBWQYCUDZXJXAWOYEXJUDZX
      FDRZXIXAYFWHXFCRZXBXHYGWHWIWNYEXJUNZYFEVNRZXLXDCRZYHYFWHYJYIEVKVOYFXBXLWO
      XBWQYCXJVLZXPVOYFYCYKWOXBWQYCXJVMBCXDEJMVPVOCXEEWPXDJYAVQVFYLWOYEXHXIVRCX
      GUADEGWPXFJYBNOVSVIWOYEXHXIVTWTXIAXFDWSXFHFWAWFVBWBWCWDWEWGWBWEWG $.
  $}

  ${
    $d y A $.  $d y .\/ $.  $d y K $.  $d y .<_ $.  $d y P $.  $d y Q $.
    $d y R $.  $d y X $.
    lplnnle2at.l $e |- .<_ = ( le ` K ) $.
    lplnnle2at.j $e |- .\/ = ( join ` K ) $.
    lplnnle2at.a $e |- A = ( Atoms ` K ) $.
    lplnnle2at.p $e |- P = ( LPlanes ` K ) $.
    $( A lattice line (or atom) cannot majorize a lattice plane.  (Contributed
       by NM, 8-Jul-2012.) $)
    lplnnle2at $p |- ( ( K e. HL /\ ( X e. P /\ Q e. A /\ R e. A ) )
         -> -. X .<_ ( Q .\/ R ) ) $=
      ( vy chlt wcel wa cfv wbr wi syl w3a cv ccvr clln wrex co cbs simpr1 eqid
      wn wb islpln adantr mpbid simprd wceq oveq1 breq2d notbid wne cplt simpl1
      simpl3l simpl22 simpl23 syl31anc syl3anc llnbase simpl21 lplnbase simpl3r
      simpr llni2 llnnlt cvrlt hlpos hlatjcl pltletr syl13anc mpand mtod simp3l
      simp1 simp23 llnnleat simp21 simp3r 3ad2ant1 atbase syld hlatjidm syl2anc
      cpo pltle mtbird pm2.61ne 3exp exp4a imp rexlimdv mpd ) FNOZHBOZCAOZDAOZU
      AZPZMUBZHFUCQZRZMFUDQZUEZHCDEUFZGRZUJZXGHFUGQZOZXLXGXCXQXLPZXBXCXDXEUHXBX
      CXRUKXFMNXPXIBFXKHXPUIZXIUIZXKUIZLULUMUNUOXGXJXOMXKXBXFXHXKOZXJXOSSXBXFYB
      XJXOXBXFYBXJPZXOXBXFYCUAZXOHDDEUFZGRZUJCDCDUPZXNYFYGXMYEHGCDDEUQURUSYDCDU
      TZPZXNXHXMFVAQZRZYIXBYBXMXKOZYKUJXBXFYCYHVBZYBXJXBXFYHVCZYIXBXDXEYHYLYMXC
      XDXEXBYCYHVDZXCXDXEXBYCYHVEZYDYHVLACDEFXKJKYAVMVFYJFXKXHXMYJUIZYAVNVGYIXH
      HYJRZXNYKYIXBXHXPOZXQXJYRYMYIYBYSYNXPFXKXHXSYAVHZTZYIXCXQXCXDXEXBYCYHVIXP
      BFHXSLVJZTZYBXJXBXFYHVKNXPXIYJFXHHXSYQXTVOZVFYIFWMOZYSXQXMXPOZYRXNPYKSYIX
      BUUEYMFVPZTUUAUUCYIXBXDXEUUFYMYOYPAXPEFCDXSJKVQVGXPYJFGXHHXMXSIYQVRVSVTWA
      YDYFHDGRZYDUUHXHDGRZYDXBYBXEUUIUJXBXFYCWCZXBXFYBXJWBZXBXCXDXEYCWDZADFGXKX
      HIKYAWEVGYDUUHXHDYJRZUUIYDYRUUHUUMYDXBYSXQXJYRUUJYDYBYSUUKYTTZYDXCXQXBXCX
      DXEYCWFUUBTZXBXFYBXJWGUUDVFYDUUEYSXQDXPOZYRUUHPUUMSXBXFUUEYCUUGWHUUNUUOYD
      XEUUPUULAXPDFXSKWITXPYJFGXHHDXSIYQVRVSVTYDXBYBXEUUMUUISUUJUUKUULNXKAYJFGX
      HDIYQWNVGWJWAYDYEDHGYDXBXEYEDUPUUJUULAEFDJKWKWLURWOWPWQWRWSWTXA $.
  $}

  ${
    lplnnleat.l $e |- .<_ = ( le ` K ) $.
    lplnnleat.a $e |- A = ( Atoms ` K ) $.
    lplnnleat.p $e |- P = ( LPlanes ` K ) $.
    $( A lattice plane cannot majorize an atom.  (Contributed by NM,
       14-Jul-2012.) $)
    lplnnleat $p |- ( ( K e. HL /\ X e. P /\ Q e. A ) -> -. X .<_ Q ) $=
      ( chlt wcel w3a cjn cfv co wbr wn simp1 simp2 simp3 eqid syl13anc 3adant2
      lplnnle2at wceq hlatjidm breq2d mtbid ) DJKZFBKZCAKZLZFCCDMNZOZEPZFCEPULU
      IUJUKUKUOQUIUJUKRUIUJUKSUIUJUKTZUPABCCUMDEFGUMUAZHIUDUBULUNCFEUIUKUNCUEUJ
      AUMDCUQHUFUCUGUH $.
  $}

  ${
    $d q r K $.  $d q r .<_ $.  $d q r N $.  $d q r P $.  $d q r X $.
    $d q r Y $.
    lplnnlelln.l $e |- .<_ = ( le ` K ) $.
    lplnnlelln.n $e |- N = ( LLines ` K ) $.
    lplnnlelln.p $e |- P = ( LPlanes ` K ) $.
    $( A lattice plane is not less than or equal to a lattice line.
       (Contributed by NM, 14-Jul-2012.) $)
    lplnnlelln $p |- ( ( K e. HL /\ X e. P /\ Y e. N ) -> -. X .<_ Y ) $=
      ( vq vr wcel w3a cfv cv wa wrex wbr wn eqid chlt cbs wne cjn co wceq catm
      simp3 islln2 3ad2ant1 mpbid simp11 simp12 simp2l simp2r lplnnle2at simp3r
      wb syl13anc breq2d mtbird 3exp rexlimdvv adantld mpd ) BUALZEALZFDLZMZFBU
      BNZLZJOZKOZUCZFVLVMBUDNZUEZUFZPZKBUGNZQJVSQZPZEFCRZSZVIVHWAVFVGVHUHVFVGVH
      WAURVHVSVJVOBDFKJVJTVOTZVSTZHUIUJUKVIVTWCVKVIVRWCJKVSVSVIVLVSLZVMVSLZPZVR
      WCVIWHVRMZWBEVPCRZWIVFVGWFWGWJSVFVGVHWHVRULVFVGVHWHVRUMVIWFWGVRUNVIWFWGVR
      UOVSAVLVMVOBCEGWDWEIUPUSWIFVPECVIWHVNVQUQUTVAVBVCVDVE $.
  $}

  ${
    2atnelpln.j $e |- .\/ = ( join ` K ) $.
    2atnelpln.a $e |- A = ( Atoms ` K ) $.
    2atnelpln.p $e |- P = ( LPlanes ` K ) $.
    $( The join of two atoms is not a lattice plane.  (Contributed by NM,
       16-Jul-2012.) $)
    2atnelpln $p |- ( ( K e. HL /\ Q e. A /\ R e. A )
         -> -. ( Q .\/ R ) e. P ) $=
      ( chlt wcel w3a co cple cfv wbr clat cbs hllat eqid 3ad2ant1 latref wn wa
      hlatjcl syl2anc simpl1 simpr simpl2 simpl3 lplnnle2at syl13anc ex mt2d )
      FJKZCAKZDAKZLZCDEMZBKZUSUSFNOZPZURFQKZUSFROZKVBUOUPVCUQFSUAAVDEFCDVDTZGHU
      EVDFVAUSVEVATZUBUFURUTVBUCZURUTUDUOUTUPUQVGUOUPUQUTUGURUTUHUOUPUQUTUIUOUP
      UQUTUJABCDEFVAUSVFGHIUKULUMUN $.
  $}

  ${
    lplnneat.a $e |- A = ( Atoms ` K ) $.
    lplnneat.p $e |- P = ( LPlanes ` K ) $.
    $( No lattice plane is an atom.  (Contributed by NM, 15-Jul-2012.) $)
    lplnneat $p |- ( ( K e. HL /\ X e. P ) -> -. X e. A ) $=
      ( chlt wcel wa cple cfv wbr clat cbs hllat eqid lplnbase latref syl2an wn
      lplnnleat 3expia mt2d ) CGHZDBHZIDAHZDDCJKZLZUDCMHDCNKZHUHUECOUIBCDUIPZFQ
      UICUGDUJUGPZRSUDUEUFUHTABDCUGDUKEFUAUBUC $.
  $}

  ${
    lplnnelln.n $e |- N = ( LLines ` K ) $.
    lplnnelln.p $e |- P = ( LPlanes ` K ) $.
    $( No lattice plane is a lattice line.  (Contributed by NM,
       19-Jun-2012.) $)
    lplnnelln $p |- ( ( K e. HL /\ X e. P ) -> -. X e. N ) $=
      ( chlt wcel wa cple cfv wbr clat cbs hllat eqid lplnbase latref syl2an wn
      lplnnlelln 3expia mt2d ) BGHZDAHZIDCHZDDBJKZLZUDBMHDBNKZHUHUEBOUIABDUIPZF
      QUIBUGDUJUGPZRSUDUEUFUHTABUGCDDUKEFUAUBUC $.
  $}

  ${
    $d p K $.  $d p P $.  $d p X $.  $d p .0. $.
    lplnn0.z $e |- .0. = ( 0. ` K ) $.
    lplnn0.p $e |- P = ( LPlanes ` K ) $.
    $( A lattice plane is non-zero.  (Contributed by NM, 15-Jul-2012.)
       (New usage is discouraged.) $)
    lplnn0N $p |- ( ( K e. HL /\ X e. P ) -> X =/= .0. ) $=
      ( vp chlt wcel wa cv catm cfv wne wex c0 eqid atex n0 wbr sylib adantr wn
      cple lplnnleat 3expa wceq cops cbs hlop atbase adantl op0le syl2anc breq1
      ad2antrr syl5ibrcom necon3bd mpd exlimddv ) BHIZCAIZJZGKZBLMZIZCDNZGVAVFG
      OZVBVAVEPNVHVEBVEQZRGVESUAUBVCVFJZCVDBUDMZTZUCZVGVAVBVFVMVEAVDBVKCVKQZVIF
      UEUFVJVLCDVJVLCDUGDVDVKTZVJBUHIZVDBUIMZIZVOVAVPVBVFBUJUPVFVRVCVEVQVDBVQQZ
      VIUKULVQBVKVDDVSVNEUMUNCDVDVKUOUQURUSUT $.
  $}

  ${
    islpln2a.l $e |- .<_ = ( le ` K ) $.
    islpln2a.j $e |- .\/ = ( join ` K ) $.
    islpln2a.a $e |- A = ( Atoms ` K ) $.
    islpln2a.p $e |- P = ( LPlanes ` K ) $.
    $( The predicate "is a lattice plane" for join of atoms.  (Contributed by
       NM, 16-Jul-2012.) $)
    islpln2a $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) )
 -> ( ( ( Q .\/ R ) .\/ S ) e. P
        <-> ( Q =/= R /\ -. S .<_ ( Q .\/ R ) ) ) ) $=
      ( wcel wa co wn wceq 2atnelpln syl3anc 3adant3r3 chlt w3a oveq1 3ad2antr2
      wne hlatjidm sylan9eqr oveq1d simpll simplr2 simplr3 eqneltrd ex necon2ad
      wbr clat cbs cfv wb hllat adantr simpr3 eqid atbase syl hlatjcl latleeqj2
      eleq1 notbid syl5ibrcom sylbid con2d jcad lplni2 3expia impbid ) GUAMZCAM
      ZDAMZEAMZUBZNZCDFOZEFOZBMZCDUEZEWCHUOZPZNZWBWEWFWHWBWECDWBCDQZWEPZWBWJNZW
      DDEFOZBWLWCDEFWJWBWCDDFOZDCDDFUCVQVRVSWNDQVTAFGDJKUFUDUGUHWLVQVSVTWMBMPVQ
      WAWJUIVRVSVTVQWJUJVRVSVTVQWJUKABDEFGJKLRSULUMUNWBWGWEWBWGWDWCQZWKWBGUPMZE
      GUQURZMZWCWQMZWGWOUSVQWPWAGUTVAWBVTWRVQVRVSVTVBAWQEGWQVCZKVDVEVQVRVSWSVTA
      WQFGCDWTJKVFTWQFGHEWCWTIJVGSWBWKWOWCBMZPZVQVRVSXBVTABCDFGJKLRTWOWEXAWDWCB
      VHVIVJVKVLVMVQWAWIWEABCDEFGHIJKLVNVOVP $.

    islpln2a.y $e |- Y = ( ( Q .\/ R ) .\/ S ) $.
    $( The predicate "is a lattice plane" for join of atoms.  Version of
       ~ islpln2a expressed with an abbreviation hypothesis.  (Contributed by
       NM, 30-Jul-2012.) $)
    islpln2ah $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) )
      -> ( Y e. P <-> ( Q =/= R /\ -. S .<_ ( Q .\/ R ) ) ) ) $=
      ( wcel co chlt w3a wa wne wbr wn eleq1i islpln2a syl5bb ) IBOCDFPZEFPZBOG
      QOCAODAOEAORSCDTEUFHUAUBSIUGBNUCABCDEFGHJKLMUDUE $.

    $( Property of a lattice plane expressed as the join of 3 atoms.
       (Contributed by NM, 30-Jul-2012.)  (New usage is discouraged.) $)
    lplnriaN $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
         -> -. Q .<_ ( R .\/ S ) ) $=
      ( chlt wcel co wbr wn wa w3a wne islpln2ah hlatcon3 3expia sylbid 3impia
      ) GOPZCAPDAPEAPUAZIBPZCDEFQHRSZUHUITUJCDUBECDFQHRSTZUKABCDEFGHIJKLMNUCUHU
      IULUKACDEFGHJKLUDUEUFUG $.

    $( Property of a lattice plane expressed as the join of 3 atoms.
       (Contributed by NM, 30-Jul-2012.)  (New usage is discouraged.) $)
    lplnribN $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
         -> -. R .<_ ( Q .\/ S ) ) $=
      ( wcel w3a co wbr wn wa chlt 3noncolr1N simprd 3expia islpln2ah 3adant3r2
      wne wceq hlatjcom breq2d notbid 3imtr4d 3impia ) GUAOZCAOZDAOZEAOZPZIBOZD
      CEFQZHRZSZUNURTZCDUGECDFQHRSTZDECFQZHRZSZUSVBUNURVDVGUNURVDPECUGVGACDEFGH
      JKLUBUCUDABCDEFGHIJKLMNUEVCVAVFVCUTVEDHUNUOUQUTVEUHUPAFGCEKLUIUFUJUKULUM
      $.

    $( Property of a lattice plane expressed as the join of 3 atoms.
       (Contributed by NM, 30-Jul-2012.) $)
    lplnric $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
        -> -. S .<_ ( Q .\/ R ) ) $=
      ( chlt wcel w3a wne co wbr wn wa islpln2ah biimp3a simprd ) GOPZCAPDAPEAP
      QZIBPZQCDRZECDFSHTUAZUFUGUHUIUJUBABCDEFGHIJKLMNUCUDUE $.
  $}

  ${
    lplnri1.j $e |- .\/ = ( join ` K ) $.
    lplnri1.a $e |- A = ( Atoms ` K ) $.
    lplnri1.p $e |- P = ( LPlanes ` K ) $.
    lplnri1.y $e |- Y = ( ( Q .\/ R ) .\/ S ) $.
    $( Property of a lattice plane expressed as the join of 3 atoms.
       (Contributed by NM, 30-Jul-2012.) $)
    lplnri1 $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
           -> Q =/= R ) $=
      ( chlt wcel w3a wne co cple cfv wbr wn wa eqid islpln2ah biimp3a simpld )
      GMNZCANDANEANOZHBNZOCDPZECDFQGRSZTUAZUGUHUIUJULUBABCDEFGUKHUKUCIJKLUDUEUF
      $.

    $( Property of a lattice plane expressed as the join of 3 atoms.
       (Contributed by NM, 30-Jul-2012.)  (New usage is discouraged.) $)
    lplnri2N $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
           -> Q =/= S ) $=
      ( chlt wcel w3a co cple cfv wbr wn wne eqid lplnriaN atnlej2 syld3an3 ) G
      MNCANDANEANOHBNCDEFPGQRZSTCEUAABCDEFGUFHUFUBZIJKLUCACDEFGUFUGIJUDUE $.

    $( Property of a lattice plane expressed as the join of 3 atoms.
       (Contributed by NM, 30-Jul-2012.)  (New usage is discouraged.) $)
    lplnri3N $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
           -> R =/= S ) $=
      ( chlt wcel w3a co cple cfv wbr wn wne simp22 simp21 simp23 eqid lplnribN
      simp1 atnlej2 syl131anc ) GMNZCANZDANZEANZOZHBNZOUJULUKUMDCEFPGQRZSTDEUAU
      JUNUOUGUJUKULUMUOUBUJUKULUMUOUCUJUKULUMUOUDABCDEFGUPHUPUEZIJKLUFADCEFGUPU
      QIJUHUI $.

    $( Two lattice lines defined by atoms defining a lattice plane are not
       equal.  (Contributed by NM, 9-Oct-2012.)  (New usage is discouraged.) $)
    lplnllnneN $p |- ( ( K e. HL /\ ( Q e. A /\ R e. A /\ S e. A ) /\ Y e. P )
           -> ( Q .\/ S ) =/= ( R .\/ S ) ) $=
      ( chlt wcel w3a co cple cfv wbr wn wne eqid lplnriaN wceq simpl21 simpl23
      wa simpl1 hlatlej1 syl3anc simpr breqtrd ex necon3bd mpd ) GMNZCANZDANZEA
      NZOZHBNZOZCDEFPZGQRZSZTCEFPZVCUAABCDEFGVDHVDUBZIJKLUCVBVEVFVCVBVFVCUDZVEV
      BVHUGZCVFVCVDVIUPUQUSCVFVDSUPUTVAVHUHUQURUSUPVAVHUEUQURUSUPVAVHUFACEFGVDV
      GIJUIUJVBVHUKULUMUNUO $.
  $}

  ${
    $d p q r s t u C $.  $d p q r s t u K $.  $d p q r s t u .<_ $.
    $d r s t u N $.  $d r P $.  $d p q r s t u X $.  $d p q r s t u Y $.
    llncvrlpln2.l $e |- .<_ = ( le ` K ) $.
    llncvrlpln2.c $e |- C = ( <o ` K ) $.
    llncvrlpln2.n $e |- N = ( LLines ` K ) $.
    llncvrlpln2.p $e |- P = ( LPlanes ` K ) $.
    $( A lattice line under a lattice plane is covered by it.  (Contributed by
       NM, 24-Jun-2012.) $)
    llncvrlpln2 $p |- ( ( ( K e. HL /\ X e. N /\ Y e. P ) /\ X .<_ Y )
         -> X C Y ) $=
      ( vr wcel w3a wbr wa cv co wrex wi vs vt vu vp vq chlt cplt cfv wne simpr
      wn simpl1 simpl3 lplnnelln syl2anc simpl2 eleq1 syl5ibcom necon3bd mpd wb
      wceq eqid pltval adantr mpbir2and cjn catm cbs lplnbase hlrelat3 syl31anc
      llnbase islpln2 simp3 islln2 simp3l simp3r simp12r oveq1d 3brtr3d simp111
      simp22 simp112 simp113 simp23 3jca simp13l simp13r simp21 hlatjcl syl3anc
      syl cvr1 mpbird simp12l 3at syl32anc mpbid 3eqtr4d breqtrd 3exp rexlimdvv
      3expd 3expib adantld sylbid imp31 syl7 rexlimdv rexlimdvva 3impia syldan
      imp ) CUFMZFEMZGBMZNZFGDOZFGCUGUHZOZFGAOZXRXSPZYAXSFGUIZXRXSUJYCGEMZUKZYD
      YCXOXQYFXOXPXQXSULXOXPXQXSUMBCEGJKUNUOYCYEFGYCXPFGVBYEXOXPXQXSUPFGEUQURUS
      UTXRYAXSYDPVAXSUFEBXTCDFGHXTVCZVDVEVFXRYAFFLQZCVGUHZRZAOZYJGDOZPZLCVHUHZS
      ZYBXRYAPZXOFCVIUHZMZGYQMZYAYOXOXPXQYAULYPXPYRXOXPXQYAUPYQCEFYQVCZJVMWMYPX
      QYSXOXPXQYAUMYQBCGYTKVJWMXRYAUJYNYQAXTYICDFGLYTHYGYIVCZIYNVCZVKVLXRYOYBXR
      YMYBLYNXOXPXQYHYNMZYMYBTZTZXOXPPZXQYSUAQZUBQZUIZUCQZUUGUUHYIRZDOUKZGUUKUU
      JYIRZVBZNZUCYNSZUBYNSUAYNSZPZUUEXOXQUURVAXPYNYQBYICDGUCUBUAYTHUUAUUBKVNVE
      UUFUUQUUEYSUUFUUPUUEUAUBYNYNUUFUUGYNMZUUHYNMZPZPZUUOUUEUCYNUUOUUNUVBUUJYN
      MZUUEUUIUULUUNVOXOXPUVAUVCUUNUUETTZXOXPYRUDQZUEQZUIZFUVEUVFYIRZVBZPZUEYNS
      UDYNSZPUVAUVDTZYNYQYICEFUEUDYTUUAUUBJVPXOUVKUVLYRXOUVJUVLUDUEYNYNXOUVEYNM
      ZUVFYNMZUVJUVLTXOUVMUVNNZUVJUVAUVDUVOUVJUVANZUVCUUNUUCUUDUVPUVCUUNUUCNZYM
      YBUVPUVQYMNZFYJGAUVPUVQYKYLVQZUVRUVHYHYIRZUUMYJGUVRUVTUUMDOZUVTUUMVBZUVRY
      JGUVTUUMDUVPUVQYKYLVRUVRFUVHYHYIUVGUVIUVOUVAUVQYMVSZVTZUVPUVCUUNUUCYMWCZW
      AUVRXOUVMUVNUUCNUUSUUTUVCNYHUVHDOUKZUVGUWAUWBVAXOUVMUVNUVJUVAUVQYMWBZUVRU
      VMUVNUUCXOUVMUVNUVJUVAUVQYMWDZXOUVMUVNUVJUVAUVQYMWEZUVPUVCUUNUUCYMWFZWGUV
      RUUSUUTUVCUUSUUTUVOUVJUVQYMWHUUSUUTUVOUVJUVQYMWIUVPUVCUUNUUCYMWJWGUVRUWFU
      VHUVTAOZUVRFYJUVHUVTAUVSUWCUWDWAUVRXOUVHYQMZUUCUWFUWKVAUWGUVRXOUVMUVNUWLU
      WGUWHUWIYNYQYICUVEUVFYTUUAUUBWKWLUWJYNYQAYHYICDUVHYTHUUAIUUBWNWLWOUVGUVIU
      VOUVAUVQYMWPYNUVEUVFYHUUGUUHUUJYICDHUUAUUBWQWRWSUWDUWEWTXAXBXDXBXEXCXFXGX
      HXIXJXKXFXGXLXJXNXMXM $.
  $}

  ${
    $d z B $.  $d z C $.  $d z K $.  $d z N $.  $d z P $.  $d z X $.  $d z Y $.
    llncvrlpln.b $e |- B = ( Base ` K ) $.
    llncvrlpln.c $e |- C = ( <o ` K ) $.
    llncvrlpln.n $e |- N = ( LLines ` K ) $.
    llncvrlpln.p $e |- P = ( LPlanes ` K ) $.
    $( An element covering a lattice line is a lattice plane and vice-versa.
       (Contributed by NM, 26-Jun-2012.) $)
    llncvrlpln $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X C Y )
        -> ( X e. N <-> Y e. P ) ) $=
      ( vz chlt wcel wbr wa simpll1 simpll3 simplr cfv w3a simpr lplni syl31anc
      cv cple wrex cp0 catm simpll2 eqid lplnneat sylancom wceq breq1 syl5ibcom
      wne wn wb isat2 syl2anc sylibrd necon3bd lplnnelln atcvrlln adantr mtbird
      mpd llnle syl22anc simpr3 cops hlop syl simpr2 llnbase simpr1 cvrle hlpos
      wi cpo postr syl13anc mp2and llncvrlpln2 cvrcmp2 syl132anc mpbid eqeltrrd
      3exp2 imp rexlimdv impbida ) DMNZFANZGANZUAZFGBOZPZFENZGCNZWSWTPWNWPWTWRX
      AWNWOWPWRWTQWNWOWPWRWTRWSWTUBWQWRWTSABMCDEFGHIJKUCUDWSXAPZLUEZFDUFTZOZLEU
      GZWTXBWNWOFDUHTZUQZFDUITZNZURXFWNWOWPWRXAQZWNWOWPWRXAUJXBGXINZURZXHWSXAWN
      XMXKXICDGXIUKZKULUMXBXLFXGXBFXGUNZXGGBOZXLXBWRXOXPWQWRXASFXGGBUOUPXBWNWPX
      LXPUSXKWNWOWPWRXARXIABMGDXGHXGUKZIXNUTVAVBVCVHXBXJGENZWSXAWNXRURXKCDEGJKV
      DUMWSXJXRUSXAXIABDEFGHIXNJVEVFVGLXIADXDEFXGHXDUKZXQXNJVIVJXBXEWTLEWSXAXCE
      NZXEWTVTVTWSXAXTXEWTWSXAXTXEUAZPZXCFEYBXEXCFUNZWSXAXTXEVKZYBDVLNZXCANZWOW
      PXCGBOZWRXEYCUSYBWNYEWNWOWPWRYAQZDVMVNYBXTYFWSXAXTXEVOZADEXCHJVPVNZWNWOWP
      WRYAUJZWNWOWPWRYARZYBWNXTXAXCGXDOZYGYHYIWSXAXTXEVQYBXEFGXDOZYMYDWSYNYAMAB
      DXDFGHXSIVRVFYBDWANZYFWOWPXEYNPYMVTYBWNYOYHDVSVNYJYKYLADXDXCFGHXSWBWCWDBC
      DXDEXCGXSIJKWEUDWQWRYASABDXDXCFGHXSIWFWGWHYIWIWJWKWLVHWM $.
  $}

  ${
    2lplnm.j $e |- .\/ = ( join ` K ) $.
    2lplnm.m $e |- ./\ = ( meet ` K ) $.
    2lplnm.c $e |- C = ( <o ` K ) $.
    2lplnm.n $e |- N = ( LLines ` K ) $.
    2lplnm.p $e |- P = ( LPlanes ` K ) $.
    $( If the join of two lattice planes covers one of them, their meet is a
       lattice line.  (Contributed by NM, 30-Jun-2012.)
       (New usage is discouraged.) $)
    2lplnmN $p |- ( ( ( K e. HL /\ X e. P /\ Y e. P ) /\ X C ( X .\/ Y ) )
          -> ( X ./\ Y ) e. N ) $=
      ( chlt wcel co wbr wb lplnbase adantr w3a wa simpl3 cbs simpl1 clat hllat
      cfv eqid latmcl syl3an 3ad2ant3 simp1 3ad2ant2 cvrexch syl3anc llncvrlpln
      biimpar syl31anc mpbird ) DNOZGBOZHBOZUAZGGHCPAQZUBZGHEPZFOZVCVAVBVCVEUCV
      FVAVGDUDUHZOZHVIOZVGHAQZVHVCRVAVBVCVEUEVDVJVEVADUFOVBGVIOZVCVKVJDUGVIBDGV
      IUIZMSZVIBDHVNMSZVIDEGHVNJUJUKTVDVKVEVCVAVKVBVPULZTVDVLVEVDVAVMVKVLVERVAV
      BVCUMVBVAVMVCVOUNVQVIACDEGHVNIJKUOUPURVIABDFVGHVNKLMUQUSUT $.
  $}

  ${
    2llnmj.j $e |- .\/ = ( join ` K ) $.
    2llnmj.m $e |- ./\ = ( meet ` K ) $.
    2llnmj.a $e |- A = ( Atoms ` K ) $.
    2llnmj.n $e |- N = ( LLines ` K ) $.
    2llnmj.p $e |- P = ( LPlanes ` K ) $.
    $( The meet of two lattice lines is an atom iff their join is a lattice
       plane.  (Contributed by NM, 27-Jun-2012.) $)
    2llnmj $p |- ( ( K e. HL /\ X e. N /\ Y e. N )
      -> ( ( X ./\ Y ) e. A <-> ( X .\/ Y ) e. P ) ) $=
      ( wcel w3a cfv wbr wb wa syl3an chlt ccvr cbs simp1 eqid llnbase 3ad2ant2
      co 3ad2ant3 cvrexch syl3anc cple simpl1 simpr simpl3 hllat latmle2 adantr
      clat atcvrlln2 syl31anc latmcl 3jca atcvrlln sylan mpbird impbida latlej1
      simpl2 llncvrlpln2 latjcl llncvrlpln mpbid 3bitr4d ) DUANZGFNZHFNZOZGHEUH
      ZHDUBPZQZGGHCUHZVTQZVSANZWBBNZVRVOGDUCPZNZHWFNZWAWCRVOVPVQUDZVPVOWGVQWFDF
      GWFUEZLUFZUGZVQVOWHVPWFDFHWJLUFZUIZWFVTCDEGHWJIJVTUEZUJUKVRWDWAVRWDSVOWDV
      QVSHDULPZQZWAVOVPVQWDUMVRWDUNVOVPVQWDUOVRWQWDVODUSNZVPWGVQWHWQDUPZWKWMWFD
      WPEGHWJWPUEZJUQTURAVTVSDWPFHWTWOKLUTVAVRWASWDVQVOVPVQWAUOVRVOVSWFNZWHOWAW
      DVQRVRVOXAWHWIVOWRVPWGVQWHXAWSWKWMWFDEGHWJJVBTWNVCAWFVTDFVSHWJWOKLVDVEVFV
      GVRWEWCVRWESVOVPWEGWBWPQZWCVOVPVQWEUMVOVPVQWEVIVRWEUNVRXBWEVOWRVPWGVQWHXB
      WSWKWMWFCDWPGHWJWTIVHTURVTBDWPFGWBWTWOLMVJVAVRWCSVPWEVOVPVQWCVIVRVOWGWBWF
      NZOWCVPWERVRVOWGXCWIWLVOWRVPWGVQWHXCWSWKWMWFCDGHWJIVKTVCWFVTBDFGWBWJWOLMV
      LVEVMVGVN $.
  $}

  ${
    2atmat.l $e |- .<_ = ( le ` K ) $.
    2atmat.j $e |- .\/ = ( join ` K ) $.
    2atmat.m $e |- ./\ = ( meet ` K ) $.
    2atmat.a $e |- A = ( Atoms ` K ) $.
    $( The meet of two intersecting lines (expressed as joins of atoms) is an
       atom.  (Contributed by NM, 21-Nov-2012.) $)
    2atmat $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
   /\ ( R e. A /\ S e. A /\ P =/= Q )
   /\ ( R =/= S /\ -. R .<_ ( P .\/ Q ) /\ S .<_ ( ( P .\/ Q ) .\/ R ) ) )
         -> ( ( P .\/ Q ) ./\ ( R .\/ S ) ) e. A ) $=
      ( wcel w3a co cfv syl eqid wb chlt wne wbr wn clpl clat wceq simp11 hllat
      cbs hlatjcl 3ad2ant1 simp21 atbase simp22 latjass syl13anc simp33 syl3anc
      latjcl latleeqj2 eqtr3d simp23 simp32 wa simp12 simp13 islpln2a mpbir2and
      mpbid eqeltrd clln llni2 syl31anc simp31 2llnmj mpbird ) GUANZBANZCANZOZD
      ANZEANZBCUBZOZDEUBZDBCFPZHUCUDZEWGDFPZHUCZOZOZWGDEFPZIPANZWGWMFPZGUEQZNZW
      LWOWIWPWLWIEFPZWOWIWLGUFNZWGGUJQZNZDWTNZEWTNZWRWOUGWLVRWSVRVSVTWEWKUHZGUI
      RZWAWEXAWKAWTFGBCWTSZKMUKULZWLWBXBWAWBWCWDWKUMZAWTDGXFMUNRZWLWCXCWAWBWCWD
      WKUOZAWTEGXFMUNRZWTFGWGDEXFKUPUQWLWJWRWIUGZWAWEWFWHWJURWLWSXCWIWTNZWJXLTX
      EXKWLWSXAXBXMXEXGXIWTFGWGDXFKUTUSWTFGHEWIXFJKVAUSVJVBWLWIWPNZWDWHWAWBWCWD
      WKVCZWAWEWFWHWJVDWLVRVSVTWBXNWDWHVETXDVRVSVTWEWKVFZVRVSVTWEWKVGZXHAWPBCDF
      GHJKMWPSZVHUQVIVKWLVRWGGVLQZNZWMXSNZWNWQTXDWLVRVSVTWDXTXDXPXQXOABCFGXSKMX
      SSZVMVNWLVRWBWCWFYAXDXHXJWAWEWFWHWJVOADEFGXSKMYBVMVNAWPFGIXSWGWMKLMYBXRVP
      USVQ $.
  $}

  ${
    $d z K $.  $d z .<_ $.  $d z P $.  $d z X $.  $d z Y $.
    lplncmp.l $e |- .<_ = ( le ` K ) $.
    lplncmp.p $e |- P = ( LPlanes ` K ) $.
    $( If two lattice planes are comparable, they are equal.  (Contributed by
       NM, 24-Jun-2012.) $)
    lplncmp $p |- ( ( K e. HL /\ X e. P /\ Y e. P )
                -> ( X .<_ Y <-> X = Y ) ) $=
      ( vz chlt wcel w3a wbr cfv wi wb eqid lplnbase syl2anc mpbid wa wceq ccvr
      cv clln simp2 cbs simp1 3ad2ant2 islpln4 simpr3 cpo hlpos 3ad2ant1 adantr
      wrex simpl3 syl simpr1 simpr2 simpl1 cvrle syl31anc postr syl13anc mp2and
      llnbase llncvrlpln2 cvrcmp syl132anc rexlimdv mpd posref syl5ibcom impbid
      3exp2 breq2 ) BIJZDAJZEAJZKZDECLZDEUAZVTHUCZDBUBMZLZHBUDMZUOZWAWBNZVTVRWG
      VQVRVSUEVTVQDBUFMZJZVRWGOVQVRVSUGVRVQWJVSWIABDWIPZGQUHZHIWIWDABWFDWKWDPZW
      FPZGUIRSVTWEWHHWFVTWCWFJZWEWAWBVTWOWEWAKZTZWAWBVTWOWEWAUJZWQBUKJZWJEWIJZW
      CWIJZWEWCEWDLZWAWBOVTWSWPVQVRWSVSBULUMZUNZVTWJWPWLUNZWQVSWTVQVRVSWPUPZWIA
      BEWKGQUQZWQWOXAVTWOWEWAURZWIBWFWCWKWNVFUQZVTWOWEWAUSZWQVQWOVSWCECLZXBVQVR
      VSWPUTZXHXFWQWCDCLZWAXKWQVQXAWJWEXMXLXIXEXJIWIWDBCWCDWKFWMVAVBWRWQWSXAWJW
      TXMWATXKNXDXIXEXGWIBCWCDEWKFVCVDVEWDABCWFWCEFWMWNGVGVBWIWDBCDEWCWKFWMVHVI
      SVOVJVKVTDDCLZWBWAVTWSWJXNXCWLWIBCDWKFVLRDEDCVPVMVN $.
  $}

  ${
    $d q A $.  $d q K $.  $d q .<_ $.  $d q Y $.  $d q X $.
    lplnexat.l $e |- .<_ = ( le ` K ) $.
    lplnexat.j $e |- .\/ = ( join ` K ) $.
    lplnexat.a $e |- A = ( Atoms ` K ) $.
    lplnexat.n $e |- N = ( LLines ` K ) $.
    lplnexat.p $e |- P = ( LPlanes ` K ) $.
    $( Given a lattice line on a lattice plane, there is an atom whose join
       with the line equals the plane.  (Contributed by NM, 29-Jun-2012.)
       (New usage is discouraged.) $)
    lplnexatN $p |- ( ( ( K e. HL /\ X e. P /\ Y e. N ) /\ Y .<_ X )
      -> E. q e. A ( -. q .<_ Y /\ X = ( Y .\/ q ) ) ) $=
      ( wcel w3a wbr wa cfv wceq chlt ccvr cv wn co wrex simp1 simp3 simp2 3jca
      eqid llncvrlpln2 cbs wb simpl1 simpl3 llnbase syl simpl2 lplnbase cvrval3
      sylan syl3anc eqcom anbi2i rexbii syl6bb mpbid ) DUAOZGBOZHFOZPZHGEQZRZHG
      DUBSZQZIUCZHEQUDZGHVQCUEZTZRZIAUFZVLVIVKVJPVMVPVLVIVKVJVIVJVKUGVIVJVKUHVI
      VJVKUIUJVOBDEFHGJVOUKZMNULVBVNVPVRVSGTZRZIAUFZWBVNVIHDUMSZOZGWGOZVPWFUNVI
      VJVKVMUOVNVKWHVIVJVKVMUPWGDFHWGUKZMUQURVNVJWIVIVJVKVMUSWGBDGWJNUTURAWGVOC
      DEHGIWJJKWCLVAVCWEWAIAWDVTVRVSGVDVEVFVGVH $.

    $d r s z A $.  $d r s y z .\/ $.  $d r s z K $.  $d r s y z .<_ $.
    $d r s y z N $.  $d r s z P $.  $d r s y z Q $.  $d r s y z X $.
    $( Given an atom on a lattice plane, there is a lattice line whose join
       with the atom equals the plane.  (Contributed by NM, 26-Jun-2012.)
       (New usage is discouraged.) $)
    lplnexllnN $p |- ( ( ( K e. HL /\ X e. P /\ Q e. A ) /\ Q .<_ X )
      -> E. y e. N ( -. Q .<_ y /\ X = ( y .\/ Q ) ) ) $=
      ( wcel wbr wa co wceq syl vr vz vs chlt w3a cv wrex simpl2 cbs cfv simpl1
      wn eqid lplnbase islpln3 syl2anc mpbid wne simpll1 simpr2l simpll3 simpr1
      wb llnexatN syl31anc simp1l1 simp22r simp3l simp1l3 simp23l simp3rr mtbid
      wi breq2d atnlej2 syl131anc llni2 simp3rl hlatcon2 syl132anc simp23r clat
      oveq1d hllat atbase latj31 syl13anc 3eqtrd notbid eqeq2d anbi12d syl12anc
      breq2 oveq1 rspcev 3expia exp3a mpd 3exp2 llnbase simpr2r latlej1 syl3anc
      rexlimdv simpr3r breqtrrd simplr latjle12 mpbi2and ccvr latjcl cvr1 lplni
      simpll2 lplncmp eqcomd weq pm2.61d rexlimdvv ) FUDOZICOZDBOZUEZDIGPZQZUAU
      FZUBUFZGPZULZIYGYFERZSZQZUABUGUBHUGZDAUFZGPZULZIYNDERZSZQZAHUGZYEYAYMXTYA
      YBYDUHZYEXTIFUIUJZOZYAYMVCXTYAYBYDUKYEYAUUCUUAUUBCFIUUBUMZNUNZTUBBUUBCEFG
      HIUAUUDJKLMNUOUPUQYEYLYTUBUAHBYEDYGGPZYGHOZYFBOZQZYLYTVMVMYEUUFUUIYLYTYEU
      UFUUIYLUEZQZDUCUFZURZYGDUULERZSZQZUCBUGZYTUUKXTUUGYBUUFUUQXTYAYBYDUUJUSUU
      GUUHUUFYLYEUTXTYAYBYDUUJVAYEUUFUUIYLVBBDEFGHYGUCJKLMVDVEUUKUUPYTUCBUUKUUL
      BOZUUPYTYEUUJUURUUPQZYTYEUUJUUSUEZYFUULERZHOZDUVAGPZULZIUVADERZSZYTUUTXTU
      UHUURYFUULURZUVBXTYAYBYDUUJUUSVFZUUGUUHUUFYLYEUUSVGZYEUUJUURUUPVHZUUTXTUU
      HYBUURYFUUNGPZULZUVGUVHUVIXTYAYBYDUUJUUSVIZUVJUUTYHUVKYIYKUUFUUIYEUUSVJUU
      TYGUUNYFGUUMUUOUURYEUUJVKZVNVLZBYFDUULEFGJKLVOVPBYFUULEFHKLMVQVEUUTXTYBUU
      RUUHUUMUVLUVDUVHUVMUVJUVIUUMUUOUURYEUUJVRUVOBDUULYFEFGJKLVSVTUUTIYJUUNYFE
      RZUVEYIYKUUFUUIYEUUSWAUUTYGUUNYFEUVNWCUUTFWBOZDUUBOZUULUUBOZYFUUBOZUVPUVE
      SUUTXTUVQUVHFWDZTUUTYBUVRUVMBUUBDFUUDLWEZTUUTUURUVSUVJBUUBUULFUUDLWETUUTU
      UHUVTUVIBUUBYFFUUDLWEZTUUBEFDUULYFUUDKWFWGWHYSUVDUVFQAUVAHYNUVASZYPUVDYRU
      VFUWDYOUVCYNUVADGWMWIUWDYQUVEIYNUVADEWNWJWKWOWLWPWQXDWRWSYEUUFULZUUIYLYTY
      EUWEUUIYLUEZQZUUGUWEIYGDERZSZYTUUGUUHUWEYLYEUTZYEUWEUUIYLVBZUWGUWHIUWGUWH
      IGPZUWHISZUWGYGIGPZYDUWLUWGYGYJIGUWGUVQYGUUBOZUVTYGYJGPUWGXTUVQXTYAYBYDUW
      FUSZUWATZUWGUUGUWOUWJUUBFHYGUUDMWTTZUWGUUHUVTUUGUUHUWEYLYEXAUWCTUUBEFGYGY
      FUUDJKXBXCYIYKUWEUUIYEXEXFYCYDUWFXGUWGUVQUWOUVRUUCUWNYDQUWLVCUWQUWRUWGYBU
      VRXTYAYBYDUWFVAZUWBTZUWGYAUUCXTYAYBYDUWFXNZUUETUUBEFGYGDIUUDJKXHWGXIUWGXT
      UWHCOZYAUWLUWMVCUWPUWGXTUWHUUBOZUUGYGUWHFXJUJZPZUXBUWPUWGUVQUWOUVRUXCUWQU
      WRUWTUUBEFYGDUUDKXKXCUWJUWGUWEUXEUWKUWGXTUWOYBUWEUXEVCUWPUWRUWSBUUBUXDDEF
      GYGUUDJKUXDUMZLXLXCUQUUBUXDUDCFHYGUWHUUDUXFMNXMVEUXACFGUWHIJNXOXCUQXPYSUW
      EUWIQAYGHAUBXQZYPUWEYRUWIUXGYOUUFYNYGDGWMWIUXGYQUWHIYNYGDEWNWJWKWOWLWSXRX
      SWR $.
  $}

  ${
    lplnnlt.s $e |- .< = ( lt ` K ) $.
    lplnnlt.p $e |- P = ( LPlanes ` K ) $.
    $( Two lattice planes cannot satisfy the less than relation.  (Contributed
       by NM, 7-Jul-2012.) $)
    lplnnlt $p |- ( ( K e. HL /\ X e. P /\ Y e. P ) -> -. X .< Y ) $=
      ( chlt wcel w3a wbr wceq pltirr 3adant3 breq2 notbid syl5ibcom cple cfv
      wn eqid pltle lplncmp sylibd necon3ad pm2.61dne ) CHIZDAIZEAIZJZDEBKZTZDE
      UJDDBKZTZDELZULUGUHUNUIHABCDFMNUOUMUKDEDBOPQUJUKDEUJUKDECRSZKUOHAABCUPDEU
      PUAZFUBACUPDEUQGUCUDUEUF $.
  $}

  ${
    2llnja.l $e |- .<_ = ( le ` K ) $.
    2llnja.j $e |- .\/ = ( join ` K ) $.
    2llnja.a $e |- A = ( Atoms ` K ) $.
    2llnja.n $e |- N = ( LLines ` K ) $.
    2llnja.p $e |- P = ( LPlanes ` K ) $.
    $( The join of two different lattice lines in a lattice plane equals the
       plane (version of ~ 2llnjN in terms of atoms).  (Contributed by NM,
       5-Jul-2012.)  (New usage is discouraged.) $)
    2llnjaN $p |- ( ( ( ( K e. HL /\ W e. P ) /\ ( Q e. A /\ R e. A /\ Q =/= R
        )
      /\ ( S e. A /\ T e. A /\ S =/= T ) )
           /\ ( ( Q .\/ R ) .<_ W /\ ( S .\/ T ) .<_ W
         /\ ( Q .\/ R ) =/= ( S .\/ T ) ) )
  -> ( ( Q .\/ R ) .\/ ( S .\/ T ) ) = W ) $=
      ( wcel w3a wbr syl3anc chlt wa wne co cbs cfv eqid clat simpl1l hllat syl
      simpl21 simpl22 hlatjcl simpl31 simpl32 latjcl simpl1r lplnbase simpr1 wb
      simpr2 latjle12 syl13anc mpbi2and wceq atbase latlej2 latjlej2 mpd lattrd
      wi 3adant3 simp11l wn simp121 simp122 simp132 simp123 simp23 simpl3 simpr
      adantr ps-1 syl112anc eqcomd ex necon3ad lplni2 syl132anc simp11r lplncmp
      mpbid eqbrtrrd 3expia latlej1 simp131 simp3 pm2.61d latasymd ) HUAQZKBQZU
      BZCAQZDAQZCDUCZRZEAQZFAQZEFUCZRZRZCDGUDZKISZEFGUDZKISZXMXOUCZRZUBZHUEUFZH
      IXMXOGUDZKXTUGZLXSXAHUHQZXAXBXGXKXRUIZHUJUKZXSYCXMXTQZXOXTQZYAXTQYEXSXAXD
      XEYFYDXDXEXFXCXKXRULZXDXEXFXCXKXRUMZAXTGHCDYBMNUNTZXSXAXHXIYGYDXHXIXJXCXG
      XRUOZXHXIXJXCXGXRUPZAXTGHEFYBMNUNTZXTGHXMXOYBMUQTZXSXBKXTQZXAXBXGXKXRURXT
      BHKYBPUSUKZXSXNXPYAKISZXLXNXPXQUTXLXNXPXQVBXSYCYFYGYOXNXPUBYQVAYEYJYMYPXT
      GHIXMXOKYBLMVCVDVEZXSEXMISZKYAISZXLXRYSYTXLXRYSRZXMFGUDZKYAIUUAUUBKISZUUB
      KVFZXLXRUUCYSXSXTHIUUBYAKYBLYEXSYCYFFXTQZUUBXTQYEYJXSXIUUEYLAXTFHYBNVGUKZ
      XTGHXMFYBMUQTYNYPXSFXOISZUUBYAISZXSYCEXTQZUUEUUGYEXSXHUUIYKAXTEHYBNVGUKZU
      UFXTGHIEFYBLMVHTXSYCUUEYGYFUUGUUHVLYEUUFYMYJXTGHIFXOXMYBLMVIVDVJZYRVKVMUU
      AXAUUBBQZXBUUCUUDVAXAXBXGXKXRYSVNZUUAXAXDXEXIXFFXMISZVOZUULUUMXDXEXFXCXKX
      RYSVPXDXEXFXCXKXRYSVQXHXIXJXCXGXRYSVRXDXEXFXCXKXRYSVSUUAXQUUOXLXNXPXQYSVT
      UUAUUNXMXOUUAUUNXMXOVFUUAUUNUBZXOXMUUPXOXMISZXOXMVFZUUPYSUUNUUQXLXRYSUUNW
      AUUAUUNWBUUAYSUUNUBUUQVAZUUNXLXRUUSYSXSYCUUIUUEYFUUSYEUUJUUFYJXTGHIEFXMYB
      LMVCVDVMWCVEUUAUUQUURVAZUUNXLXRUUTYSXSXAXKXDXEUUTYDXCXGXKXRWAYHYIAEFCDGHI
      LMNWDWEVMWCWMWFWGWHVJABCDFGHILMNPWIWJXAXBXGXKXRYSWKBHIUUBKLPWLTWMXLXRUUHY
      SUUKVMWNWOXLXRYSVOZYTXLXRUVARZXMEGUDZKYAIUVBUVCKISZUVCKVFZXLXRUVDUVAXSXTH
      IUVCYAKYBLYEXSYCYFUUIUVCXTQYEYJUUJXTGHXMEYBMUQTYNYPXSEXOISZUVCYAISZXSYCUU
      IUUEUVFYEUUJUUFXTGHIEFYBLMWPTXSYCUUIYGYFUVFUVGVLYEUUJYMYJXTGHIEXOXMYBLMVI
      VDVJZYRVKVMUVBXAUVCBQZXBUVDUVEVAXAXBXGXKXRUVAVNZUVBXAXDXEXHXFUVAUVIUVJXDX
      EXFXCXKXRUVAVPXDXEXFXCXKXRUVAVQXHXIXJXCXGXRUVAWQXDXEXFXCXKXRUVAVSXLXRUVAW
      RABCDEGHILMNPWIWJXAXBXGXKXRUVAWKBHIUVCKLPWLTWMXLXRUVGUVAUVHVMWNWOWSWT $.
  $}

  ${
    $d q r s t .\/ $.  $d q r s t K $.  $d q r s t .<_ $.  $d q r s t N $.
    $d q r s t P $.  $d q r s t X $.  $d q r s t Y $.  $d q r s t W $.
    2llnj.l $e |- .<_ = ( le ` K ) $.
    2llnj.j $e |- .\/ = ( join ` K ) $.
    2llnj.n $e |- N = ( LLines ` K ) $.
    2llnj.p $e |- P = ( LPlanes ` K ) $.
    $( The join of two different lattice lines in a lattice plane equals the
       plane.  (Contributed by NM, 4-Jul-2012.)  (New usage is discouraged.) $)
    2llnjN $p |- ( ( K e. HL /\ ( X e. N /\ Y e. N /\ W e. P )
       /\ ( X .<_ W /\ Y .<_ W /\ X =/= Y ) ) -> ( X .\/ Y ) = W ) $=
      ( vq vr vs vt wcel w3a wne wa chlt wbr wceq catm cfv wrex cbs eqid islln2
      cv co simpr syl6bi anim12d imp 3adantr3 3adant3 wi simp2rr simp3rr simp13
      oveq12d breq1 neeq1 3anbi13d neeq2 3anbi23d sylan9bb syl2anc mpbid simp11
      simp123 simp2ll simp2lr simp2rl simp3ll simp3lr simp3rl 2llnjaN syl233anc
      wb ex mpd eqtrd 3exp 3impib exp3a rexlimdvv imp3a ) CUAQZGEQZHEQZFAQZRZGF
      DUBZHFDUBZGHSZRZRZMUJZNUJZSZGWTXABUKZUCZTZNCUDUEZUFMXFUFZOUJZPUJZSZHXHXIB
      UKZUCZTZPXFUFOXFUFZTZGHBUKZFUCZWJWNXOWRWJWKWLXOWMWJWKWLTXOWJWKXGWLXNWJWKG
      CUGUEZQZXGTXGXFXRBCEGNMXRUHZJXFUHZKUIXSXGULUMWJWLHXRQZXNTXNXFXRBCEHPOXTJY
      AKUIYBXNULUMUNUOUPUQWSXGXNXQWSXEXNXQURZMNXFXFWSWTXFQZXAXFQZTZXEYCWSYFXERZ
      XMXQOPXFXFYGXHXFQZXIXFQZTZXMXQWSYFXEYJXMTZXQURWSYFXETZYKXQWSYLYKRZXPXCXKB
      UKZFYMGXCHXKBXBXDYFWSYKUSZXJXLYJWSYLUTZVBYMXCFDUBZXKFDUBZXCXKSZRZYNFUCZYM
      WRYTWJWNWRYLYKVAYMXDXLWRYTWAYOYPXDWRYQWPXCHSZRXLYTXDWOYQWQUUBWPGXCFDVCGXC
      HVDVEXLWPYRUUBYSYQHXKFDVCHXKXCVFVGVHVIVJYMWJWMYDYEXBYHYIXJYTUUAURWJWNWRYL
      YKVKWKWLWMWJWRYLYKVLYDYEXEWSYKVMYDYEXEWSYKVNXBXDYFWSYKVOYHYIXMWSYLVPYHYIX
      MWSYLVQXJXLYJWSYLVRWJWMTYDYEXBRYHYIXJRRYTUUAXFAWTXAXHXIBCDEFIJYAKLVSWBVTW
      CWDWEWFWGWHWEWHWIWC $.
  $}

  ${
    2llnm2.l $e |- .<_ = ( le ` K ) $.
    2llnm2.m $e |- ./\ = ( meet ` K ) $.
    2llnm2.a $e |- A = ( Atoms ` K ) $.
    2llnm2.n $e |- N = ( LLines ` K ) $.
    2llnm2.p $e |- P = ( LPlanes ` K ) $.
    $( The meet of two different lattice lines in a lattice plane is an atom.
       (Contributed by NM, 5-Jul-2012.)  (New usage is discouraged.) $)
    2llnm2N $p |- ( ( K e. HL /\ ( X e. N /\ Y e. N /\ W e. P )
       /\ ( X .<_ W /\ Y .<_ W /\ X =/= Y ) ) -> ( X ./\ Y ) e. A ) $=
      ( wcel w3a wbr cfv eqid syl3anc chlt wne co simp22 cbs ccvr wb simp1 clat
      3ad2ant1 simp21 llnbase syl latmcl cjn 2llnjN eqeltrd latlej1 llncvrlpln2
      hllat simp23 syl31anc cvrexch mpbird atcvrlln ) CUAOZHFOZIFOZGBOZPZHGDQIG
      DQHIUBPZPZHIEUCZAOZVHVFVGVHVIVKUDZVLVFVMCUERZOZIVPOZVMICUFRZQZVNVHUGVFVJV
      KUHZVLCUIOZHVPOZVRVQVFVJWBVKCUTUJZVLVGWCVFVGVHVIVKUKZVPCFHVPSZMULUMZVLVHV
      RVOVPCFIWFMULUMZVPCEHIWFKUNTWHVLVTHHICUORZUCZVSQZVLVFVGWJBOHWJDQZWKWAWEVL
      WJGBBWICDFGHIJWISZMNUPVFVGVHVIVKVAUQVLWBWCVRWLWDWGWHVPWICDHIWFJWMURTVSBCD
      FHWJJVSSZMNUSVBVLVFWCVRVTWKUGWAWGWHVPVSWICEHIWFWMKWNVCTVDAVPVSCFVMIWFWNLM
      VEVBVD $.
  $}

  ${
    2llnm3.l $e |- .<_ = ( le ` K ) $.
    2llnm3.m $e |- ./\ = ( meet ` K ) $.
    2llnm3.z $e |- .0. = ( 0. ` K ) $.
    2llnm3.n $e |- N = ( LLines ` K ) $.
    2llnm3.p $e |- P = ( LPlanes ` K ) $.
    $( Two lattice lines in a lattice plane always meet.  (Contributed by NM,
       5-Jul-2012.)  (New usage is discouraged.) $)
    2llnm3N $p |- ( ( K e. HL /\ ( X e. N /\ Y e. N /\ W e. P )
       /\ ( X .<_ W /\ Y .<_ W ) ) -> ( X ./\ Y ) =/= .0. ) $=
      ( wcel w3a wbr wa wne syl2anc chlt co wceq oveq1 neeq1d catm simpl1 hlatl
      cal cfv syl simpl2 simpl3l simpl3r simpr eqid 2llnm2N syl113anc atn0 clat
      cbs hllat 3ad2ant1 simp22 llnbase latmidm simp1 llnn0 eqnetrd pm2.61ne )
      BUAOZGEOZHEOZFAOZPZGFCQZHFCQZRZPZGHDUBZISZHHDUBZISGHGHUCVTWBIGHHDUDUEVSGH
      SZRZBUIOZVTBUFUJZOZWAWDVKWEVKVOVRWCUGZBUHUKWDVKVOVPVQWCWGWHVKVOVRWCULVPVQ
      VKVOWCUMVPVQVKVOWCUNVSWCUOWFABCDEFGHJKWFUPZMNUQURWFVTBILWIUSTVSWBHIVSBUTO
      ZHBVAUJZOZWBHUCVKVOWJVRBVBVCVSVMWLVKVLVMVNVRVDZWKBEHWKUPZMVEUKWKBDHWNKVFT
      VSVKVMHISVKVOVRVGWMBEHILMVHTVIVJ $.
  $}

  ${
    2llnm4.l $e |- .<_ = ( le ` K ) $.
    2llnm4.m $e |- ./\ = ( meet ` K ) $.
    2llnm4.z $e |- .0. = ( 0. ` K ) $.
    2llnm4.a $e |- A = ( Atoms ` K ) $.
    2llnm4.n $e |- N = ( LLines ` K ) $.
    $( Two lattice lines that majorize the same atom always meet.  (Contributed
       by NM, 20-Jul-2012.) $)
    2llnm4 $p |- ( ( K e. HL /\ ( P e. A /\ X e. N /\ Y e. N )
       /\ ( P .<_ X /\ P .<_ Y ) ) -> ( X ./\ Y ) =/= .0. ) $=
      ( wcel w3a wbr 3ad2ant1 llnbase syl chlt wa cal co cbs cfv wne hlatl clat
      hllat simp22 eqid simp23 latmcl syl3anc simp21 simp3 wb latlem12 syl13anc
      atbase mpbid atlen0 syl31anc ) CUAOZBAOZGFOZHFOZPZBGDQBHDQUBZPZCUCOZGHEUD
      ZCUEUFZOZVFBVMDQZVMIUGVEVIVLVJCUHRVKCUIOZGVNOZHVNOZVOVEVIVQVJCUJRZVKVGVRV
      EVFVGVHVJUKVNCFGVNULZNSTZVKVHVSVEVFVGVHVJUMVNCFHWANSTZVNCEGHWAKUNUOVEVFVG
      VHVJUPZVKVJVPVEVIVJUQVKVQBVNOZVRVSVJVPURVTVKVFWEWDAVNBCWAMVATWBWCVNCDEBGH
      WAJKUSUTVBAVNBCDVMIWAJLMVCVD $.
  $}

  ${
    2llnmeqat.l $e |- .<_ = ( le ` K ) $.
    2llnmeqat.m $e |- ./\ = ( meet ` K ) $.
    2llnmeqat.a $e |- A = ( Atoms ` K ) $.
    2llnmeqat.n $e |- N = ( LLines ` K ) $.
    $( An atom equals the intersection of two majorizing lines.  (Contributed
       by NM, 3-Apr-2013.) $)
    2llnmeqat $p |- ( ( K e. HL /\ ( X e. N /\ Y e. N /\ P e. A )
        /\ ( X =/= Y /\ P .<_ ( X ./\ Y ) ) ) -> P = ( X ./\ Y ) ) $=
      ( wcel w3a wne wbr wa wb 3ad2ant1 syl chlt co simp3r cal hlatl simp23 cp0
      wceq cfv simp1 simp21 simp22 simp3l clat cbs eqid atbase llnbase latlem12
      hllat syl13anc mpbird 2llnm4 syl131anc 2llnmat syl32anc atcmp syl3anc
      mpbid ) CUAMZGFMZHFMZBAMZNZGHOZBGHEUBZDPZQZNZVQBVPUHZVJVNVOVQUCZVSCUDMZVM
      VPAMZVQVTRVJVNWBVRCUESVJVKVLVMVRUFZVSVJVKVLVOVPCUGUIZOZWCVJVNVRUJZVJVKVLV
      MVRUKZVJVKVLVMVRULZVJVNVOVQUMVSVJVMVKVLBGDPBHDPQZWFWGWDWHWIVSWJVQWAVSCUNM
      ZBCUOUIZMZGWLMZHWLMZWJVQRVJVNWKVRCUTSVSVMWMWDAWLBCWLUPZKUQTVSVKWNWHWLCFGW
      PLURTVSVLWOWIWLCFHWPLURTWLCDEBGHWPIJUSVAVBABCDEFGHWEIJWEUPZKLVCVDACEFGHWE
      JWQKLVEVFABVPCDIKVGVHVI $.
  $}

  ${
    $d k y P $.  $d k x B $.  $d k C $.  $d k y x K $.
    lvolset.b $e |- B = ( Base ` K ) $.
    lvolset.c $e |- C = ( <o ` K ) $.
    lvolset.p $e |- P = ( LPlanes ` K ) $.
    lvolset.v $e |- V = ( LVols ` K ) $.
    $( The set of 3-dim lattice volumes in a Hilbert lattice.  (Contributed by
       NM, 1-Jul-2012.) $)
    lvolset $p |- ( K e. A -> V = { x e. B | E. y e. P y C x } ) $=
      ( vk cvv cv cfv ccvr clpl cbs fveq2 wcel wbr wrex crab wceq clvol syl6eqr
      elex breqd rexeqbidv rabeqbidv df-lvols fvex eqeltri rabex fvmpt syl5eq
      syl ) GCUAGNUAZHBOZAOZEUBZBFUCZADUDZUEGCUHUSHGUFPVDLMGUTVAMOZQPZUBZBVERPZ
      UCZAVESPZUDVDNUFVEGUEZVIVCAVJDVKVJGSPZDVEGSTIUGVKVGVBBVHFVKVHGRPFVEGRTKUG
      VKVFEUTVAVKVFGQPEVEGQTJUGUIUJUKAMBULVCADDVLNIGSUMUNUOUPUQUR $.

    $d x P $.  $d x C $.  $d y x X $.
    $( The predicate "is a 3-dim lattice volume".  (Contributed by NM,
       1-Jul-2012.) $)
    islvol $p |- ( K e. A -> ( X e. V <-> ( X e. B /\ E. y e. P y C X ) ) ) $=
      ( vx wcel cv wbr wrex crab wa lvolset eleq2d breq2 rexbidv elrab syl6bb
      wceq ) FBNZHGNHAOZMOZDPZAEQZMCRZNHCNUHHDPZAEQZSUGGULHMABCDEFGIJKLTUAUKUNM
      HCUIHUFUJUMAEUIHUHDUBUCUDUE $.

    $( The predicate "is a 3-dim lattice volume".  (Contributed by NM,
       1-Jul-2012.) $)
    islvol4 $p |- ( ( K e. A /\ X e. B )
       -> ( X e. V <-> E. y e. P y C X ) ) $=
      ( wcel cv wbr wrex islvol baibd ) FBMHGMHCMANHDOAEPABCDEFGHIJKLQR $.

    $d x Y $.
    $( Condition implying a 3-dim lattice volume.  (Contributed by NM,
       1-Jul-2012.) $)
    lvoli $p |- ( ( ( K e. D /\ Y e. B /\ X e. P ) /\ X C Y ) -> Y e. V ) $=
      ( vx wcel w3a wbr wa cv wrex simpl2 rspcev 3ad2antl3 wb simpl1 islvol syl
      breq1 mpbir2and ) ECNZHANZGDNZOGHBPZQZHFNZUJMRZHBPZMDSZUIUJUKULTUKUIULUQU
      JUPULMGDUOGHBUGUAUBUMUIUNUJUQQUCUIUJUKULUDMCABDEFHIJKLUEUFUH $.
  $}

  ${
    $d p A $.  $d p y B $.  $d p y K $.  $d p .<_ $.  $d p y P $.  $d p y X $.
    islvol3.b $e |- B = ( Base ` K ) $.
    islvol3.l $e |- .<_ = ( le ` K ) $.
    islvol3.j $e |- .\/ = ( join ` K ) $.
    islvol3.a $e |- A = ( Atoms ` K ) $.
    islvol3.p $e |- P = ( LPlanes ` K ) $.
    islvol3.v $e |- V = ( LVols ` K ) $.
    $( The predicate "is a 3-dim lattice volume".  (Contributed by NM,
       1-Jul-2012.) $)
    islvol3 $p |- ( ( K e. HL /\ X e. B ) -> ( X e. V
         <-> E. y e. P E. p e. A ( -. p .<_ y /\ X = ( y .\/ p ) ) ) ) $=
      ( chlt wcel wa wrex cv ccvr cfv wbr wn co wceq islvol4 wb simpll lplnbase
      eqid adantl simplr cvrval3 syl3anc eqcom a1i anbi2d rexbidva bitrd ) FQRZ
      ICRZSZIHRAUAZIFUBUCZUDZADTJUAZVEGUDUEZIVEVHEUFZUGZSZJBTZADTAQCVFDFHIKVFUL
      ZOPUHVDVGVMADVDVEDRZSZVGVIVJIUGZSZJBTZVMVPVBVECRZVCVGVSUIVBVCVOUJVOVTVDCD
      FVEKOUKUMVBVCVOUNBCVFEFGVEIJKLMVNNUOUPVPVRVLJBVPVHBRSZVQVKVIVQVKUIWAVJIUQ
      URUSUTVAUTVA $.
  $}

  ${
    $d r y A $.  $d r y .\/ $.  $d r y K $.  $d r y .<_ $.  $d r y P $.
    $d r y Q $.  $d r y X $.
    lvoli3.l $e |- .<_ = ( le ` K ) $.
    lvoli3.j $e |- .\/ = ( join ` K ) $.
    lvoli3.a $e |- A = ( Atoms ` K ) $.
    lvoli3.p $e |- P = ( LPlanes ` K ) $.
    lvoli3.v $e |- V = ( LVols ` K ) $.
    $( Condition implying a 3-dim lattice volume.  (Contributed by NM,
       2-Aug-2012.) $)
    lvoli3 $p |- ( ( ( K e. HL /\ X e. P /\ Q e. A ) /\ -. Q .<_ X )
         -> ( X .\/ Q ) e. V ) $=
      ( vr vy wcel wbr wn wa wceq chlt w3a co cv wrex simpl2 simpl3 simpr eqidd
      breq2 notbid oveq1 eqeq2d anbi12d breq1 oveq2 rspc2ev syl112anc wb simpl1
      cbs cfv clat hllat syl eqid lplnbase atbase latjcl syl3anc islvol3 mpbird
      syl2anc ) EUAPZHBPZCAPZUBZCHFQZRZSZHCDUCZGPZNUDZOUDZFQZRZWAWDWCDUCZTZSZNA
      UEOBUEZVTVOVPVSWAWATZWJVNVOVPVSUFZVNVOVPVSUGZVQVSUHVTWAUIWIVSWKSWCHFQZRZW
      AHWCDUCZTZSONHCBAWDHTZWFWOWHWQWRWEWNWDHWCFUJUKWRWGWPWAWDHWCDULUMUNWCCTZWO
      VSWQWKWSWNVRWCCHFUOUKWSWPWAWAWCCHDUPUMUNUQURVTVNWAEVAVBZPZWBWJUSVNVOVPVSU
      TZVTEVCPZHWTPZCWTPZXAVTVNXCXBEVDVEVTVOXDWLWTBEHWTVFZLVGVEVTVPXEWMAWTCEXFK
      VHVEWTDEHCXFJVIVJOAWTBDEFGWANXFIJKLMVKVMVL $.
  $}

  ${
    $d x K $.  $d x X $.
    lvolbase.b $e |- B = ( Base ` K ) $.
    lvolbase.v $e |- V = ( LVols ` K ) $.
    $( A 3-dim lattice volume is a lattice element.  (Contributed by NM,
       1-Jul-2012.) $)
    lvolbase $p |- ( X e. V -> X e. B ) $=
      ( vx cvv wcel clvol cfv c0 wceq n0i eqeq1i sylnib fvprc nsyl2 cv eqid wbr
      ccvr clpl wrex islvol simprbda mpancom ) BHIZDCIZDAIZUIBJKZLMZUHUICLMULCD
      NCUKLFOPBJQRUHUIUJGSDBUBKZUAGBUCKZUDGHAUMUNBCDEUMTUNTFUEUFUG $.
  $}

  ${
    $d p q r s y A $.  $d p q r s y B $.  $d p q r s y .\/ $.
    $d p q r s y K $.  $d p q r s y .<_ $.  $d p q r s y X $.
    islvol5.b $e |- B = ( Base ` K ) $.
    islvol5.l $e |- .<_ = ( le ` K ) $.
    islvol5.j $e |- .\/ = ( join ` K ) $.
    islvol5.a $e |- A = ( Atoms ` K ) $.
    islvol5.v $e |- V = ( LVols ` K ) $.
    $( The predicate "is a 3-dim lattice volume" in terms of atoms.
       (Contributed by NM, 1-Jul-2012.) $)
    islvol5 $p |- ( ( K e. HL /\ X e. B )
      -> ( X e. V <-> E. p e. A E. q e. A E. r e. A E. s e. A
   ( ( p =/= q /\ -. r .<_ ( p .\/ q ) /\ -. s .<_ ( ( p .\/ q ) .\/ r ) )
            /\ X = ( ( ( p .\/ q ) .\/ r ) .\/ s ) ) ) ) $=
      ( vy wcel wa wrex chlt cv wbr wn co wceq clpl cfv wne w3a islvol3 rexcom4
      eqid rexbii bitri hllat ad3antrrr simplll simplrl simplrr hlatjcl syl3anc
      clat atbase adantl latjcl biantrurd r19.41v df-3an anbi2i an13 exbii ovex
      eleq1 breq2 notbid oveq1 eqeq2d anbi12d anbi2d anass bicomi anbi1i bitr3i
      wex an12 syl6bb syl5bb rexbidv r19.42v 3bitr3g ceqsexv syl6rbbr 2rexbidva
      rexbidva syl5rbbr islpln2 adantr anbi1d an32 3bitr4ri rexcom exbidv bitrd
      wb df-rex ) DUARZGBRZSZGFRHUBZQUBZEUCZUDZGXKXJCUEZUFZSZHATZQDUGUHZTZKUBZJ
      UBZUIZIUBZXTYACUEZEUCUDZXJYDYCCUEZEUCZUDZUJZGYFXJCUEZUFZSZHATZIATZJATKATZ
      QABXRCDEFGHLMNOXRUMZPUKXIYOXKXRRZXQSZQWEZXSXIYOXKBRZXPSZYBYEXKYFUFZUJZSZH
      ATZIATZJATZKATZQWEZYSUUIUUEQWEZIATZJATZKATZXIYOUUMUUGQWEZKATUUIUULUUNKAUU
      LUUFQWEZJATUUNUUKUUOJAUUEIQAULUNUUFJQAULUOUNUUGKQAULUOXIUUKYNKJAAXIXTARZY
      AARZSZSZUUJYMIAUUSYCARZSZYMYFBRZYMSZUUJUVAUVBYMUVADVCRZYDBRZYCBRZUVBXGUVD
      XHUURUUTDUPUQUVAXGUUPUUQUVEXGXHUURUUTURXIUUPUUQUUTUSXIUUPUUQUUTUTABCDXTYA
      LNOVAVBUUTUVFUUSABYCDLOVDVEBCDYDYCLNVFVBVGUUJUUBYBYESZUUAHATZSZSZQWEUVCUU
      EUVJQUUEUVHUUCSZUVJUUAUUCHAVHUVKUVHUVGUUBSZSUVJUUCUVLUVHYBYEUUBVIVJUVHUVG
      UUBVKUOUOVLUVIUVCQYFYDYCCVMUUBUVGUUASZHATUVBYLSZHATUVIUVCUUBUVMUVNHAUVMYT
      UVGXPSZSUUBUVNUVGYTXPWFUUBYTUVBUVOYLXKYFBVNUUBUVOUVGYHYKSZSZYLUUBXPUVPUVG
      UUBXMYHXOYKUUBXLYGXKYFXJEVOVPUUBXNYJGXKYFXJCVQVRVSVTUVQUVGYHSZYKSYLUVGYHY
      KWAUVRYIYKYIUVRYBYEYHVIWBWCWDWGVSWHWIUVGUUAHAWJUVBYLHAWJWKWLUOWMWOWNWPXIU
      UHYRQXIUUHYQXPSZHATZYRXIUVTUUDIATZJATZKATZHATZUUHXIUVSUWCHAXIUVSYTUUCIATZ
      JATZKATZSZXPSZUWCXIYQUWHXPXGYQUWHXEXHABXRCDEXKIJKLMNOYPWQWRWSUUAUWFSZKATU
      UAUWGSUWCUWIUUAUWFKAWJUWBUWJKAUWBUUAUWESZJATUWJUWAUWKJAUUAUUCIAWJUNUUAUWE
      JAWJUOUNYTUWGXPWTXAWGWIUUHUWBHATZKATUWDUUGUWLKAUUGUWAHATZJATUWLUUFUWMJAUU
      DIHAAXBUNUWAJHAAXBUOUNUWBKHAAXBUOWMYQXPHAWJWGXCXDXQQXRXFWMXD $.

    $( The predicate "is a 3-dim lattice volume" in terms of atoms.
       (Contributed by NM, 1-Jul-2012.) $)
    islvol2 $p |- ( K e. HL
      -> ( X e. V <-> ( X e. B /\ E. p e. A E. q e. A E. r e. A E. s e. A
   ( ( p =/= q /\ -. r .<_ ( p .\/ q ) /\ -. s .<_ ( ( p .\/ q ) .\/ r ) )
            /\ X = ( ( ( p .\/ q ) .\/ r ) .\/ s ) ) ) ) ) $=
      ( wcel wa cv wrex chlt wne co wbr wceq lvolbase pm4.71ri islvol5 pm5.32da
      wn w3a syl5bb ) GFQZGBQZUMRDUAQZUNKSZJSZUBISZUPUQCUCZEUDUJHSZUSURCUCZEUDU
      JUKGVAUTCUCUERHATIATJATKATZRUMUNBDFGLPUFUGUOUNUMVBABCDEFGHIJKLMNOPUHUIUL
      $.
  $}

  ${
    $d p q r s A $.  $d p q r s .\/ $.  $d p q r s K $.  $d p q r s .<_ $.
    $d p q r s P $.  $d p q r s Q $.  $d p q r s R $.  $d p q r s S $.
    lvoli2.l $e |- .<_ = ( le ` K ) $.
    lvoli2.j $e |- .\/ = ( join ` K ) $.
    lvoli2.a $e |- A = ( Atoms ` K ) $.
    lvoli2.v $e |- V = ( LVols ` K ) $.
    $( The join of 4 different atoms is a lattice volume.  (Contributed by NM,
       8-Jul-2012.) $)
    lvoli2 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A /\ S e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
         /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
    -> ( ( ( P .\/ Q ) .\/ R ) .\/ S ) e. V ) $=
      ( wcel w3a wa co wbr wn wceq vp vq vr vs chlt cv wrex simp12 simp13 simp3
      wne eqidd neeq1 oveq1 breq2d notbid oveq1d 3anbi123d eqeq2d anbi12d neeq2
      oveq2 rspc2ev syl112anc 3exp simplrl simplrr simpr breq1 3anbi23d 3anbi3d
      wi syl3anc ex reximdv syldd 3imp cbs cfv wb simp11 clat hllat syl hlatjcl
      eqid 3ad2ant1 simp2l atbase latjcl simp2r islvol5 syl2anc mpbird ) GUENZB
      ANZCANZOZDANZEANZPZBCUKZDBCFQZHRZSZEXCDFQZHRZSZOZOZXFEFQZINZUAUFZUBUFZUKZ
      UCUFZXMXNFQZHRZSZUDUFZXQXPFQZHRZSZOZXKYAXTFQZTZPZUDAUGUCAUGZUBAUGZUAAUGZW
      RXAXIYJWRXAXIXODXQHRZSZEXQDFQZHRZSZOZXKYMEFQZTZPZUBAUGZUAAUGZYJWRXAXIUUAX
      JWPWQXIXKXKTZUUAWOWPWQXAXIUHWOWPWQXAXIUIWRXAXIUJXJXKULYSXIUUBPBXNUKZDBXNF
      QZHRZSZEUUDDFQZHRZSZOZXKUUGEFQZTZPUAUBBCAAXMBTZYPUUJYRUULUUMXOUUCYLUUFYOU
      UIXMBXNUMUUMYKUUEUUMXQUUDDHXMBXNFUNZUOUPUUMYNUUHUUMYMUUGEHUUMXQUUDDFUUNUQ
      ZUOUPURUUMYQUUKXKUUMYMUUGEFUUOUQUSUTXNCTZUUJXIUULUUBUUPUUCXBUUFXEUUIXHXNC
      BVAUUPUUEXDUUPUUDXCDHXNCBFVBZUOUPUUPUUHXGUUPUUGXFEHUUPUUDXCDFUUQUQZUOUPUR
      UUPUUKXKXKUUPUUGXFEFUURUQUSUTVCVDVEWRXAUUAYJVLWRXAPZYTYIUAAUUSYSYHUBAUUSY
      SYHUUSYSPWSWTYSYHWRWSWTYSVFWRWSWTYSVGUUSYSVHYGYSXOYLXTYMHRZSZOZXKYMXTFQZT
      ZPUCUDDEAAXPDTZYDUVBYFUVDUVEXSYLYCUVAXOUVEXRYKXPDXQHVIUPUVEYBUUTUVEYAYMXT
      HXPDXQFVBZUOUPVJUVEYEUVCXKUVEYAYMXTFUVFUQUSUTXTETZUVBYPUVDYRUVGUVAYOXOYLU
      VGUUTYNXTEYMHVIUPVKUVGUVCYQXKXTEYMFVBUSUTVCVMVNVOVOVNVPVQXJWOXKGVRVSZNZXL
      YJVTWOWPWQXAXIWAZXJGWBNZXFUVHNZEUVHNZUVIXJWOUVKUVJGWCWDZXJUVKXCUVHNZDUVHN
      ZUVLUVNWRXAUVOXIAUVHFGBCUVHWFZKLWEWGXJWSUVPWRWSWTXIWHAUVHDGUVQLWIWDUVHFGX
      CDUVQKWJVMXJWTUVMWRWSWTXIWKAUVHEGUVQLWIWDUVHFGXFEUVQKWJVMAUVHFGHIXKUDUCUB
      UAUVQJKLMWLWMWN $.
  $}

  ${
    $d y A $.  $d y .\/ $.  $d y K $.  $d y .<_ $.  $d y P $.  $d y Q $.
    $d y R $.  $d y V $.  $d y X $.
    lvolnle3at.l $e |- .<_ = ( le ` K ) $.
    lvolnle3at.j $e |- .\/ = ( join ` K ) $.
    lvolnle3at.a $e |- A = ( Atoms ` K ) $.
    lvolnle3at.v $e |- V = ( LVols ` K ) $.
    $( A lattice plane (or lattice line or atom) cannot majorize a lattice
       volume.  (Contributed by NM, 8-Jul-2012.) $)
    lvolnle3at $p |- ( ( ( K e. HL /\ X e. V )
          /\ ( P e. A /\ Q e. A /\ R e. A ) )
        -> -. X .<_ ( ( P .\/ Q ) .\/ R ) ) $=
      ( chlt wcel wa wbr wn wi syl3anc vy w3a cv ccvr cfv clpl co cbs simplr wb
      wrex eqid islvol ad2antrr mpbid simprd oveq1d breq2d notbid simp1l simp3l
      wceq oveq1 wne simp21 simp22 lplnnle2at syl13anc cplt lplnbase syl simp1r
      lvolbase simp3r cvrlt syl31anc cpo hlpos hlatjcl pltletr mpand pltle syld
      mtod adantr simprr simp23 atbase latleeqj2 mtbird anassrs simpl1l simpl3l
      clat hllat simpl2 simpr lplni2 lplnnlt latjcl pm2.61dan hlatjidm pm2.61ne
      cple syl2anc 3expia exp3a rexlimdv mpd ) FNOZIHOZPZBAOZCAOZDAOZUBZPZUAUCZ
      IFUDUEZQZUAFUFUEZUKZIBCEUGZDEUGZGQZRZXQIFUHUEZOZYBXQXKYHYBPZXJXKXPUIXJXKY
      IUJXKXPUANYGXSYAFHIYGULZXSULZYAULZMUMUNUOUPXQXTYFUAYAXQXRYAOZXTYFXLXPYMXT
      PZYFXLXPYNUBZYFICCEUGZDEUGZGQZRBCBCVBZYEYRYSYDYQIGYSYCYPDEBCCEVCUQURUSYOB
      CVDZPDYCGQZYFYOYTUUAYFYOYTUUAPZPZYEIYCGQZYOUUDRUUBYOUUDXRYCGQZYOXJYMXMXNU
      UERXJXKXPYNUTZXLXPYMXTVAZXLXMXNXOYNVEZXLXMXNXOYNVFZAYABCEFGXRJKLYLVGVHYOU
      UDXRYCFVIUEZQZUUEYOXRIUUJQZUUDUUKYOXJXRYGOZYHXTUULUUFYOYMUUMUUGYGYAFXRYJY
      LVJVKZYOXKYHXJXKXPYNVLYGFHIYJMVMVKZXLXPYMXTVNNYGXSUUJFXRIYJUUJULZYKVOVPZY
      OFVQOZUUMYHYCYGOZUULUUDPUUKSYOXJUURUUFFVRVKZUUNUUOYOXJXMXNUUSUUFUUHUUIAYG
      EFBCYJKLVSTZYGUUJFGXRIYCYJJUUPVTVHWAYOXJYMUUSUUKUUESUUFUUGUVANYAYGUUJFGXR
      YCJUUPWBTWCWDWEUUCYDYCIGUUCUUAYDYCVBZYOYTUUAWFYOUUAUVBUJZUUBYOFWNOZDYGOZU
      USUVCYOXJUVDUUFFWOVKZYOXOUVEXLXMXNXOYNWGZAYGDFYJLWHVKZUVAYGEFGDYCYJJKWITW
      EUOURWJWKYOYTUUARZYFYOYTUVIPZPZYEXRYDUUJQZUVKXJYMYDYAOZUVLRXJXKXPYNUVJWLZ
      YMXTXLXPUVJWMUVKXJXPUVJUVMUVNXLXPYNUVJWPYOUVJWQAYABCDEFGJKLYLWRTYAUUJFXRY
      DUUPYLWSTYOYEUVLSUVJYOUULYEUVLUUQYOUURUUMYHYDYGOZUULYEPUVLSUUTUUNUUOYOUVD
      UUSUVEUVOUVFUVAUVHYGEFYCDYJKWTTYGUUJFGXRIYDYJJUUPVTVHWAWEWDWKXAYOYRICDEUG
      ZGQZYOUVQXRUVPFXDUEZQZYOXJYMXNXOUVSRUUFUUGUUIUVGAYACDEFUVRXRUVRULZKLYLVGV
      HYOUVQXRUVPUUJQZUVSYOUULUVQUWAUUQYOUURUUMYHUVPYGOZUULUVQPUWASUUTUUNUUOYOX
      JXNXOUWBUUFUUIUVGAYGEFCDYJKLVSTZYGUUJFGXRIUVPYJJUUPVTVHWAYOXJYMUWBUWAUVSS
      UUFUUGUWCNYAYGUUJFUVRXRUVPUVTUUPWBTWCWDYOYQUVPIGYOYPCDEYOXJXNYPCVBUUFUUIA
      EFCKLXBXEUQURWJXCXFXGXHXI $.
  $}

  ${
    lvolnleat.l $e |- .<_ = ( le ` K ) $.
    lvolnleat.a $e |- A = ( Atoms ` K ) $.
    lvolnleat.v $e |- V = ( LVols ` K ) $.
    $( An atom cannot majorize a lattice volume.  (Contributed by NM,
       14-Jul-2012.) $)
    lvolnleat $p |- ( ( K e. HL /\ X e. V /\ P e. A ) -> -. X .<_ P ) $=
      ( chlt wcel w3a cjn cfv co wbr wa wn 3simpa simp3 eqid lvolnle3at 3adant2
      syl13anc wceq hlatjidm oveq1d eqtrd breq2d mtbid ) CJKZFEKZBAKZLZFBBCMNZO
      ZBUOOZDPZFBDPUNUKULQUMUMUMURRUKULUMSUKULUMTZUSUSABBBUOCDEFGUOUAZHIUBUDUNU
      QBFDUNUQUPBUNUPBBUOUKUMUPBUEULAUOCBUTHUFUCZUGVAUHUIUJ $.
  $}

  ${
    $d p q K $.  $d p q .<_ $.  $d p q N $.  $d p q V $.  $d p q X $.
    $d p q Y $.
    lvolnlelln.l $e |- .<_ = ( le ` K ) $.
    lvolnlelln.n $e |- N = ( LLines ` K ) $.
    lvolnlelln.v $e |- V = ( LVols ` K ) $.
    $( A lattice line cannot majorize a lattice volume.  (Contributed by NM,
       14-Jul-2012.) $)
    lvolnlelln $p |- ( ( K e. HL /\ X e. V /\ Y e. N ) -> -. X .<_ Y ) $=
      ( vp vq wcel w3a cfv cv co wceq wa wrex eqid chlt cbs wne cjn catm wbr wn
      simp3 islln2 3ad2ant1 mpbid simp11 simp12 simp2l simp2r lvolnle3at simp3r
      wb syl23anc hlatjidm syl2anc oveq1d eqtr4d breq2d mtbird 3exp adantld mpd
      rexlimdvv ) AUALZEDLZFCLZMZFAUBNZLZJOZKOZUCZFVPVQAUDNZPZQZRZKAUENZSJWCSZR
      ZEFBUFZUGZVMVLWEVJVKVLUHVJVKVLWEURVLWCVNVSACFKJVNTVSTZWCTZHUIUJUKVMWDWGVO
      VMWBWGJKWCWCVMVPWCLZVQWCLZRZWBWGVMWLWBMZWFEVPVPVSPZVQVSPZBUFZWMVJVKWJWJWK
      WPUGVJVKVLWLWBULZVJVKVLWLWBUMVMWJWKWBUNZWRVMWJWKWBUOWCVPVPVQVSABDEGWHWIIU
      PUSWMFWOEBWMFVTWOVMWLVRWAUQWMWNVPVQVSWMVJWJWNVPQWQWRWCVSAVPWHWIUTVAVBVCVD
      VEVFVIVGVH $.
  $}

  ${
    $d q r s K $.  $d q r s .<_ $.  $d q r s P $.  $d q r s V $.  $d q r s X $.
    $d q r s Y $.
    lvolnlelpln.l $e |- .<_ = ( le ` K ) $.
    lvolnlelpln.p $e |- P = ( LPlanes ` K ) $.
    lvolnlelpln.v $e |- V = ( LVols ` K ) $.
    $( A lattice plane cannot majorize a lattice volume.  (Contributed by NM,
       14-Jul-2012.) $)
    lvolnlelpln $p |- ( ( K e. HL /\ X e. V /\ Y e. P ) -> -. X .<_ Y ) $=
      ( vq vr vs wcel w3a cfv cv wbr wn wrex wa chlt cbs wne co wceq catm simp3
      cjn eqid islpln2 3ad2ant1 simp1l1 simp1l2 simp1r simp2l simp2r lvolnle3at
      mpbid syl23anc simp33 breq2d mtbird 3exp rexlimdvv rexlimdva adantld mpd
      wb ) BUAMZEDMZFAMZNZFBUBOZMZJPZKPZUCZLPZVOVPBUHOZUDZCQRZFVTVRVSUDZUEZNZLB
      UFOZSKWESZJWESZTZEFCQZRZVLVKWHVIVJVKUGVIVJVKWHVHVKWEVMAVSBCFLKJVMUIGVSUIZ
      WEUIZHUJUKURVLWGWJVNVLWFWJJWEVLVOWEMZTZWDWJKLWEWEWNVPWEMZVRWEMZTZWDWJWNWQ
      WDNZWIEWBCQZWRVIVJWMWOWPWSRVIVJVKWMWQWDULVIVJVKWMWQWDUMVLWMWQWDUNWNWOWPWD
      UOWNWOWPWDUPWEVOVPVRVSBCDEGWKWLIUQUSWRFWBECWNWQVQWAWCUTVAVBVCVDVEVFVG $.
  $}

  ${
    3atnelvol.j $e |- .\/ = ( join ` K ) $.
    3atnelvol.a $e |- A = ( Atoms ` K ) $.
    3atnelvol.v $e |- V = ( LVols ` K ) $.
    $( The join of 3 atoms is not a lattice volume.  (Contributed by NM,
       17-Jul-2012.)  (New usage is discouraged.) $)
    3atnelvolN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) )
         -> -. ( ( P .\/ Q ) .\/ R ) e. V ) $=
      ( chlt wcel w3a wa co cple cfv wbr clat eqid cbs adantr hlatjcl 3adant3r3
      hllat simpr3 atbase syl latjcl syl3anc latref syl2anc wn lvolnle3at an32s
      ex mt2d ) FKLZBALZCALZDALZMZNZBCEOZDEOZGLZVEVEFPQZRZVCFSLZVEFUAQZLZVHURVI
      VBFUEUBZVCVIVDVJLZDVJLZVKVLURUSUTVMVAAVJEFBCVJTZHIUCUDVCVAVNURUSUTVAUFAVJ
      DFVOIUGUHVJEFVDDVOHUIUJVJFVGVEVOVGTZUKULVCVFVHUMZURVFVBVQABCDEFVGGVEVPHIJ
      UNUOUPUQ $.

    $( The join of two atoms is not a lattice volume.  (Contributed by NM,
       17-Jul-2012.)  (New usage is discouraged.) $)
    2atnelvolN $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
         -> -. ( P .\/ Q ) e. V ) $=
      ( chlt wcel w3a co wceq hlatjidm 3adant3 oveq1d wn simp1 simp2 3atnelvolN
      simp3 syl13anc eqneltrrd ) EJKZBAKZCAKZLZBBDMZCDMZBCDMFUHUIBCDUEUFUIBNUGA
      DEBGHOPQUHUEUFUFUGUJFKRUEUFUGSUEUFUGTZUKUEUFUGUBABBCDEFGHIUAUCUD $.
  $}

  ${
    lvolneat.a $e |- A = ( Atoms ` K ) $.
    lvolneat.v $e |- V = ( LVols ` K ) $.
    $( No lattice volume is an atom.  (Contributed by NM, 15-Jul-2012.)
       (New usage is discouraged.) $)
    lvolneatN $p |- ( ( K e. HL /\ X e. V ) -> -. X e. A ) $=
      ( chlt wcel wa cple cfv wbr clat cbs hllat eqid lvolbase latref syl2an wn
      lvolnleat 3expia mt2d ) BGHZDCHZIDAHZDDBJKZLZUDBMHDBNKZHUHUEBOUIBCDUIPZFQ
      UIBUGDUJUGPZRSUDUEUFUHTADBUGCDUKEFUAUBUC $.
  $}

  ${
    lvolnelln.l $e |- N = ( LLines ` K ) $.
    lvolnelln.v $e |- V = ( LVols ` K ) $.
    $( No lattice volume is a lattice line.  (Contributed by NM,
       15-Jul-2012.) $)
    lvolnelln $p |- ( ( K e. HL /\ X e. V ) -> -. X e. N ) $=
      ( chlt wcel wa cple cfv wbr clat cbs hllat eqid lvolbase latref syl2an wn
      lvolnlelln 3expia mt2d ) AGHZDCHZIDBHZDDAJKZLZUDAMHDANKZHUHUEAOUIACDUIPZF
      QUIAUGDUJUGPZRSUDUEUFUHTAUGBCDDUKEFUAUBUC $.
  $}

  ${
    lvolnelpln.p $e |- P = ( LPlanes ` K ) $.
    lvolnelpln.v $e |- V = ( LVols ` K ) $.
    $( No lattice volume is a lattice plane.  (Contributed by NM,
       19-Jun-2012.) $)
    lvolnelpln $p |- ( ( K e. HL /\ X e. V ) -> -. X e. P ) $=
      ( chlt wcel wa cple cfv wbr clat cbs hllat eqid lvolbase latref syl2an wn
      lvolnlelpln 3expia mt2d ) BGHZDCHZIDAHZDDBJKZLZUDBMHDBNKZHUHUEBOUIBCDUIPZ
      FQUIBUGDUJUGPZRSUDUEUFUHTABUGCDDUKEFUAUBUC $.
  $}

  ${
    $d p K $.  $d p V $.  $d p X $.  $d p .0. $.
    lvoln0.z $e |- .0. = ( 0. ` K ) $.
    lvoln0.v $e |- V = ( LVols ` K ) $.
    $( A lattice volume is non-zero.  (Contributed by NM, 17-Jul-2012.)
       (New usage is discouraged.) $)
    lvoln0N $p |- ( ( K e. HL /\ X e. V ) -> X =/= .0. ) $=
      ( vp chlt wcel wa cv catm cfv wne wex c0 eqid atex n0 wbr sylib adantr wn
      cple lvolnleat 3expa wceq cops cbs hlop atbase adantl op0le syl2anc breq1
      ad2antrr syl5ibrcom necon3bd mpd exlimddv ) AHIZCBIZJZGKZALMZIZCDNZGVAVFG
      OZVBVAVEPNVHVEAVEQZRGVESUAUBVCVFJZCVDAUDMZTZUCZVGVAVBVFVMVEVDAVKBCVKQZVIF
      UEUFVJVLCDVJVLCDUGDVDVKTZVJAUHIZVDAUIMZIZVOVAVPVBVFAUJUPVFVRVCVEVQVDAVQQZ
      VIUKULVQAVKVDDVSVNEUMUNCDVDVKUOUQURUSUT $.
  $}

  ${
    islvol2a.l $e |- .<_ = ( le ` K ) $.
    islvol2a.j $e |- .\/ = ( join ` K ) $.
    islvol2a.a $e |- A = ( Atoms ` K ) $.
    islvol2a.v $e |- V = ( LVols ` K ) $.
    $( The predicate "is a lattice volume".  (Contributed by NM, 16-Jul-2012.)
       (New usage is discouraged.) $)
    islvol2aN $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
          /\ ( R e. A /\ S e. A ) )
    -> ( ( ( ( P .\/ Q ) .\/ R ) .\/ S ) e. V
        <-> ( P =/= Q /\ -. R .<_ ( P .\/ Q )
            /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) ) ) $=
      ( wcel wa co wn wceq 3atnelvolN syl13anc chlt w3a wne oveq1 simpl1 simpl3
      wbr hlatjidm sylan9eqr oveq1d simprl simprr adantr eqneltrd necon2ad clat
      syl2anc ex cbs cfv wb hllat syl atbase ad2antrl hlatjcl latleeqj2 syl3anc
      simpl2 eleq1d notbid syl5ibrcom sylbid con2d ad2antll latjcl eleq1 lvoli2
      eqid 3jcad 3expia impbid ) GUANZBANZCANZUBZDANZEANZOZOZBCFPZDFPZEFPZINZBC
      UCZDWKHUGZQZEWLHUGZQZUBZWJWNWOWQWSWJWNBCWJBCRZWNQZWJXAOZWMCDFPZEFPZIXCWLX
      DEFXCWKCDFXAWJWKCCFPZCBCCFUDWJWCWEXFCRWCWDWEWIUEZWCWDWEWIUFZAFGCKLUHUQUIU
      JUJWJXEINQZXAWJWCWEWGWHXIXGXHWFWGWHUKZWFWGWHULZACDEFGIKLMSTUMUNURUOWJWPWN
      WJWPWLWKRZXBWJGUPNZDGUSUTZNZWKXNNZWPXLVAWJWCXMXGGVBVCZWGXOWFWHAXNDGXNVSZL
      VDVEZWFXPWIAXNFGBCXRKLVFUMZXNFGHDWKXRJKVGVHWJXBXLWKEFPZINZQZWJWCWDWEWHYCX
      GWCWDWEWIVIZXHXKABCEFGIKLMSTXLWNYBXLWMYAIWLWKEFUDVJVKVLVMVNWJWRWNWJWRWMWL
      RZXBWJXMEXNNZWLXNNZWRYEVAXQWHYFWFWGAXNEGXRLVDVOWJXMXPXOYGXQXTXSXNFGWKDXRK
      VPVHXNFGHEWLXRJKVGVHWJXBYEWLINZQZWJWCWDWEWGYIXGYDXHXJABCDFGIKLMSTYEWNYHWM
      WLIVQVKVLVMVNVTWFWIWTWNABCDEFGHIJKLMVRWAWB $.
  $}

  ${
    4at.l $e |- .<_ = ( le ` K ) $.
    4at.j $e |- .\/ = ( join ` K ) $.
    4at.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for ~ 4at .  (Contributed by NM, 10-Jul-2012.) $)
    4atlem0a $p |- ( ( ( K e. HL /\ ( P e. A /\ Q e. A ) /\ ( R e. A
         /\ S e. A ) ) /\ ( -. R .<_ ( P .\/ Q )
       /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
     -> -. R .<_ ( ( P .\/ Q ) .\/ S ) ) $=
      ( chlt wcel wa w3a co wbr wn simprr cbs wi simpl1 simpl3l simpl3r simpl2l
      cfv simpl2r eqid hlatjcl syl3anc simprl hlexch1 syl131anc mtod ) GLMZBAMZ
      CAMZNZDAMZEAMZNZOZDBCFPZHQRZEVCDFPHQZRZNZNZDVCEFPHQZVEVBVDVFSVHUOUSUTVCGT
      UFZMZVDVIVEUAUOURVAVGUBZUSUTUOURVGUCUSUTUOURVGUDVHUOUPUQVKVLUPUQUOVAVGUEU
      PUQUOVAVGUGAVJFGBCVJUHZJKUIUJVBVDVFUKAVJDEFGHVCVMIJKULUMUN $.

    $( Lemma for ~ 4at .  (Contributed by NM, 10-Jul-2012.) $)
    4atlem0ae $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
           /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
         -> -. Q .<_ ( P .\/ R ) ) $=
      ( chlt wcel w3a wne co wbr wn wa simp3r wi simp22 simp23 simp21 hlatexch1
      simp1 simp3l necomd syl131anc mtod ) FKLZBALZCALZDALZMZBCNZDBCEOGPZQZRZMZ
      CBDEOGPZUPUJUNUOUQSUSUJULUMUKCBNUTUPTUJUNURUEUJUKULUMURUAUJUKULUMURUBUJUK
      ULUMURUCUSBCUJUNUOUQUFUGACDBEFGHIJUDUHUI $.

    $( Lemma for ~ 4at .  (Contributed by NM, 10-Jul-2012.) $)
    4atlem0be $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
            /\ -. R .<_ ( P .\/ Q ) ) -> P =/= R ) $=
      ( chlt wcel w3a co wbr wn wne simp1 simp23 simp21 simp3 atnlej1 syl131anc
      simp22 necomd ) FKLZBALZCALZDALZMZDBCENGOPZMUFUIUGUHUKBDQUFUJUKRUFUGUHUIU
      KSUFUGUHUIUKTUFUGUHUIUKUDUFUJUKUAUFUIUGUHMUKMDBADBCEFGHIJUBUEUC $.

    $( Lemma for ~ 4at .  Break inequality into 4 cases.  (Contributed by NM,
       8-Jul-2012.) $)
    4atlem3 $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
                /\ ( R e. A /\ S e. A /\ T e. A ) /\ ( U e. A /\ V e. A ) )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
         /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
  -> ( ( -. P .<_ ( ( T .\/ U ) .\/ V )
        \/ -. Q .<_ ( ( T .\/ U ) .\/ V ) )
        \/ ( -. R .<_ ( ( T .\/ U ) .\/ V )
        \/ -. S .<_ ( ( T .\/ U ) .\/ V ) ) ) ) $=
      ( wcel wa co wbr wn syl chlt w3a wne wo clvol cfv simpl11 simpl21 simpl22
      simpl1 simpr lvoli2 syl121anc simpl23 simpl3l simpl3r lvolnle3at syl23anc
      eqid cbs wb hllat hlatjcl syl3anc atbase latjcl latjle12 syl13anc simpl12
      clat simpl13 anbi12d wceq latjass breq1d 3bitr4d mtbird ianor bitri sylib
      orbi12i ) IUAOZBAOZCAOZUBZDAOZEAOZFAOZUBZGAOZKAOZPZUBZBCUCDBCHQZJRSEWNDHQ
      ZJRSUBZPZBFGHQZKHQZJRZCWSJRZPZDWSJRZEWSJRZPZPZSZWTSXASUDZXCSXDSUDZUDZWQXF
      WOEHQZWSJRZWQWBXKIUEUFZOZWHWJWKXLSWBWCWDWIWLWPUGZWQWEWFWGWPXNWEWIWLWPUJZW
      FWGWHWEWLWPUHZWFWGWHWEWLWPUIZWMWPUKABCDEHIJXMLMNXMUSZULUMWFWGWHWEWLWPUNZW
      JWKWEWIWPUOZWJWKWEWIWPUPZAFGKHIJXMXKLMNXSUQURWQWNWSJRZDEHQZWSJRZPZWNYDHQZ
      WSJRZXFXLWQIVJOZWNIUTUFZOZYDYJOZWSYJOZYFYHVAWQWBYIXOIVBTZWQWEYKXPAYJHIBCY
      JUSZMNVCTZWQWBWFWGYLXOXQXRAYJHIDEYOMNVCVDWQYIWRYJOZKYJOZYMYNWQWBWHWJYQXOX
      TYAAYJHIFGYOMNVCVDWQWKYRYBAYJKIYONVETYJHIWRKYOMVFVDZYJHIJWNYDWSYOLMVGVHWQ
      XBYCXEYEWQYIBYJOZCYJOZYMXBYCVAYNWQWCYTWBWCWDWIWLWPVIAYJBIYONVETWQWDUUAWBW
      CWDWIWLWPVKAYJCIYONVETYSYJHIJBCWSYOLMVGVHWQYIDYJOZEYJOZYMXEYEVAYNWQWFUUBX
      QAYJDIYONVETZWQWGUUCXRAYJEIYONVETZYSYJHIJDEWSYOLMVGVHVLWQXKYGWSJWQYIYKUUB
      UUCXKYGVMYNYPUUDUUEYJHIWNDEYOMVNVHVOVPVQXGXBSZXESZUDXJXBXEVRUUFXHUUGXIWTX
      AVRXCXDVRWAVSVT $.

    $( Lemma for ~ 4at .  Break inequality into 3 cases.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem3a $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
                /\ ( R e. A /\ S e. A ) /\ ( U e. A /\ V e. A ) )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
     /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
  -> ( -. Q .<_ ( ( P .\/ U ) .\/ V )
     \/ -. R .<_ ( ( P .\/ U ) .\/ V )
     \/ -. S .<_ ( ( P .\/ U ) .\/ V ) ) ) $=
      ( wcel w3a co wbr wn wo syl chlt wa wne w3o simpl1 simpl2l simpl2r simpl3
      simpl12 3jca simpr 4atlem3 syl31anc wb clat cbs simpl11 hllat eqid atbase
      cfv simpl3l simpl3r hlatjcl syl3anc latlej1 wceq syl13anc breqtrrd biortn
      latjass orbi1d mpbird 3orass sylibr ) HUANZBANZCANZOZDANZEANZUBZFANZJANZU
      BZOZBCUCDBCGPZIQREWGDGPIQROZUBZCBFGPJGPZIQRZDWJIQRZEWJIQRZSZSZWKWLWMUDWIW
      OBWJIQZRWKSZWNSZWIVSVTWAVQOWEWHWRVSWBWEWHUEWIVTWAVQVTWAVSWEWHUFVTWAVSWEWH
      UGVPVQVRWBWEWHUIZUJVSWBWEWHUHWFWHUKABCDEBFGHIJKLMULUMWIWKWQWNWIWPWKWQUNWI
      BBFJGPZGPZWJIWIHUONZBHUPVAZNZWTXCNZBXAIQWIVPXBVPVQVRWBWEWHUQZHURTZWIVQXDW
      SAXCBHXCUSZMUTTZWIVPWCWDXEXFWCWDVSWBWHVBZWCWDVSWBWHVCZAXCGHFJXHLMVDVEXCGH
      IBWTXHKLVFVEWIXBXDFXCNZJXCNZWJXAVGXGXIWIWCXLXJAXCFHXHMUTTWIWDXMXKAXCJHXHM
      UTTXCGHBFJXHLVKVHVIWPWKVJTVLVMWKWLWMVNVO $.

    $( Lemma for ~ 4at .  Break inequality into 2 cases.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem3b $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
                /\ ( R e. A /\ S e. A /\ V e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
         /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
   -> ( -. R .<_ ( ( P .\/ Q ) .\/ V )
         \/ -. S .<_ ( ( P .\/ Q ) .\/ V ) ) ) $=
      ( wcel w3a co wbr wn wo wa syl chlt wne simp1 simp21 simp22 simp13 simp23
      w3o jca simp3 4atlem3a syl31anc 3orass sylib wb clat cbs cfv simp11 hllat
      simp12 eqid hlatjcl syl3anc atbase latlej2 hlatj32 syl13anc biortn mpbird
      wceq breqtrd ) GUAMZBAMZCAMZNZDAMZEAMZIAMZNZBCUBDBCFOZHPQEWADFOHPQNZNZDWA
      IFOZHPQZEWDHPQZRZCWDHPZQZWGRZWCWIWEWFUHZWJWCVPVQVRSVOVSSWBWKVPVTWBUCWCVQV
      RVPVQVRVSWBUDVPVQVRVSWBUEUIWCVOVSVMVNVOVTWBUFZVPVQVRVSWBUGZUIVPVTWBUJABCD
      ECFGHIJKLUKULWIWEWFUMUNWCWHWGWJUOWCCBIFOZCFOZWDHWCGUPMZWNGUQURZMZCWQMZCWO
      HPWCVMWPVMVNVOVTWBUSZGUTTWCVMVNVSWRWTVMVNVOVTWBVAZWMAWQFGBIWQVBZKLVCVDWCV
      OWSWLAWQCGXBLVETWQFGHWNCXBJKVFVDWCVMVNVSVOWOWDVKWTXAWMWLABICFGKLVGVHVLWHW
      GVITVJ $.

    $( Lemma for ~ 4at .  Frequently used associative law.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem4a $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
            /\ ( R e. A /\ S e. A ) )
     -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
        = ( P .\/ ( ( Q .\/ R ) .\/ S ) ) ) $=
      ( chlt wcel w3a wa co wceq syl atbase syl13anc clat cbs cfv simpl1 simpl2
      hllat simpl3 simprl simprr hlatjcl syl3anc latjass hlatjass oveq2d eqtr4d
      eqid ) GLMZBAMZCAMZNZDAMZEAMZOZOZBCFPDEFPZFPZBCVEFPZFPZBCDFPEFPZFPVDGUAMZ
      BGUBUCZMZCVKMZVEVKMZVFVHQVDUQVJUQURUSVCUDZGUFRVDURVLUQURUSVCUEAVKBGVKUPZK
      SRVDUSVMUQURUSVCUGZAVKCGVPKSRVDUQVAVBVNVOUTVAVBUHZUTVAVBUIZAVKFGDEVPJKUJU
      KVKFGBCVEVPJULTVDVIVGBFVDUQUSVAVBVIVGQVOVQVRVSACDEFGJKUMTUNUO $.

    $( Lemma for ~ 4at .  Frequently used associative law.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem4b $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
            /\ ( R e. A /\ S e. A ) )
      -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
          = ( Q .\/ ( ( P .\/ R ) .\/ S ) ) ) $=
      ( chlt wcel w3a wa co wceq simpl1 syl atbase simpl2 simpl3 syl122anc clat
      simprl simprr hlatj4 cbs cfv hllat eqid hlatjcl syl3anc ad2antll syl13anc
      latj12 eqtrd ) GLMZBAMZCAMZNZDAMZEAMZOZOZBCFPDEFPFPZBDFPZCEFPFPZCVGEFPFPZ
      VEURUSUTVBVCVFVHQURUSUTVDRZURUSUTVDUAZURUSUTVDUBZVAVBVCUEZVAVBVCUFABCDEFG
      JKUGUCVEGUDMZVGGUHUIZMZCVOMZEVOMZVHVIQVEURVNVJGUJSVEURUSVBVPVJVKVMAVOFGBD
      VOUKZJKULUMVEUTVQVLAVOCGVSKTSVCVRVAVBAVOEGVSKTUNVOFGVGCEVSJUPUOUQ $.

    $( Lemma for ~ 4at .  Frequently used associative law.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem4c $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
            /\ ( R e. A /\ S e. A ) )
      -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
            = ( R .\/ ( ( P .\/ Q ) .\/ S ) ) ) $=
      ( chlt wcel w3a wa clat co cbs cfv atbase simpl1 hllat syl hlatjcl adantr
      wceq eqid ad2antrl ad2antll latj12 syl13anc ) GLMZBAMZCAMZNZDAMZEAMZOZOZG
      PMZBCFQZGRSZMZDVBMZEVBMZVADEFQFQDVAEFQFQUFUSULUTULUMUNURUAGUBUCUOVCURAVBF
      GBCVBUGZJKUDUEUPVDUOUQAVBDGVFKTUHUQVEUOUPAVBEGVFKTUIVBFGVADEVFJUJUK $.

    $( Lemma for ~ 4at .  Frequently used associative law.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem4d $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
            /\ ( R e. A /\ S e. A ) )
      -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
             = ( S .\/ ( ( P .\/ Q ) .\/ R ) ) ) $=
      ( chlt wcel w3a wa co clat wceq atbase syl3anc cbs cfv simpl1 syl hlatjcl
      hllat adantr ad2antrl ad2antll latjass syl13anc latjcl latjcom eqtr3d
      eqid ) GLMZBAMZCAMZNZDAMZEAMZOZOZBCFPZDFPZEFPZVDDEFPFPZEVEFPZVCGQMZVDGUAU
      BZMZDVJMZEVJMZVFVGRVCUPVIUPUQURVBUCGUFUDZUSVKVBAVJFGBCVJUOZJKUEUGZUTVLUSV
      AAVJDGVOKSUHZVAVMUSUTAVJEGVOKSUIZVJFGVDDEVOJUJUKVCVIVEVJMZVMVFVHRVNVCVIVK
      VLVSVNVPVQVJFGVDDVOJULTVRVJFGVEEVOJUMTUN $.

    $( Lemma for ~ 4at .  Substitute ` W ` for ` S ` .  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem9 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A
         /\ S e. A /\ W e. A ) /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) )
  -> ( S .<_ ( ( P .\/ Q ) .\/ ( R .\/ W ) )
   <-> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
             = ( ( P .\/ Q ) .\/ ( R .\/ W ) ) ) ) $=
      ( wcel w3a co wbr wceq syl 4atlem4d syl12anc chlt wn cbs wb simp11 simp22
      cfv simp23 clat hllat simp1 hlatjcl simp21 atbase latjcl syl3anc hlexchb2
      eqid simp3 syl131anc breq2d eqeq12d 3bitr4d ) GUAMZBAMZCAMZNZDAMZEAMZIAMZ
      NZEBCFOZDFOZHPUBZNZEIVMFOZHPZEVMFOZVPQZEVLDIFOFOZHPVLDEFOFOZVTQVOVDVIVJVM
      GUCUGZMZVNVQVSUDVDVEVFVKVNUEZVGVHVIVJVNUFZVGVHVIVJVNUHZVOGUIMZVLWBMZDWBMZ
      WCVOVDWGWDGUJRVOVGWHVGVKVNUKZAWBFGBCWBURZKLULRVOVHWIVGVHVIVJVNUMZAWBDGWKL
      UNRWBFGVLDWKKUOUPVGVKVNUSAWBEIFGHVMWKJKLUQUTVOVTVPEHVOVGVHVJVTVPQWJWLWFAB
      CDIFGHJKLSTZVAVOWAVRVTVPVOVGVHVIWAVRQWJWLWEABCDEFGHJKLSTWMVBVC $.

    $( Lemma for ~ 4at .  Substitute ` V ` for ` R ` .  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem10a $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
         /\ ( R e. A /\ V e. A /\ W e. A )
         /\ -. R .<_ ( ( P .\/ Q ) .\/ W ) )
 -> ( R .<_ ( ( P .\/ Q ) .\/ ( V .\/ W ) )
   <-> ( ( P .\/ Q ) .\/ ( R .\/ W ) )
          = ( ( P .\/ Q ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a co wbr wceq syl 4atlem4c syl12anc chlt wn cbs wb simp11 simp21
      cfv simp22 clat hllat simp1 hlatjcl simp23 atbase latjcl syl3anc hlexchb2
      eqid simp3 syl131anc breq2d eqeq12d 3bitr4d ) FUAMZBAMZCAMZNZDAMZHAMZIAMZ
      NZDBCEOZIEOZGPUBZNZDHVMEOZGPZDVMEOZVPQZDVLHIEOEOZGPVLDIEOEOZVTQVOVDVHVIVM
      FUCUGZMZVNVQVSUDVDVEVFVKVNUEZVGVHVIVJVNUFZVGVHVIVJVNUHZVOFUIMZVLWBMZIWBMZ
      WCVOVDWGWDFUJRVOVGWHVGVKVNUKZAWBEFBCWBURZKLULRVOVJWIVGVHVIVJVNUMZAWBIFWKL
      UNRWBEFVLIWKKUOUPVGVKVNUSAWBDHEFGVMWKJKLUQUTVOVTVPDGVOVGVIVJVTVPQWJWFWLAB
      CHIEFGJKLSTZVAVOWAVRVTVPVOVGVHVJWAVRQWJWEWLABCDIEFGJKLSTWMVBVC $.

    $( Lemma for ~ 4at .  Substitute ` V ` for ` R ` (cont.).  (Contributed by
       NM, 10-Jul-2012.) $)
    4atlem10b $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
        /\ ( R e. A /\ S e. A /\ V e. A )
        /\ ( W e. A /\ -. R .<_ ( ( P .\/ Q ) .\/ W )
          /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
        /\ ( R .<_ ( ( P .\/ Q ) .\/ ( V .\/ W ) )
          /\ S .<_ ( ( P .\/ Q ) .\/ ( V .\/ W ) ) ) )
     -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
            = ( ( P .\/ Q ) .\/ ( V .\/ W ) ) ) $=
      ( wcel w3a co wbr wn wa wceq chlt simprr simprl wb simpl1 simpl21 simpl23
      simpl31 simpl32 4atlem10a syl131anc mpbid breqtrrd simpl22 simpl33 eqtrd
      4atlem9 ) GUANBANCANOZDANZEANZIANZOZJANZDBCFPZJFPHQRZEVDDFPHQRZOZOZDVDIJF
      PFPZHQZEVIHQZSZSZVDDEFPFPZVDDJFPFPZVIVMEVOHQZVNVOTZVMEVIVOHVHVJVKUBVMVJVO
      VITZVHVJVKUCVMURUSVAVCVEVJVRUDURVBVGVLUEZUSUTVAURVGVLUFZUSUTVAURVGVLUGVCV
      EVFURVBVLUHZVCVEVFURVBVLUIABCDFGHIJKLMUJUKULZUMVMURUSUTVCVFVPVQUDVSVTUSUT
      VAURVGVLUNWAVCVEVFURVBVLUOABCDEFGHJKLMUQUKULWBUP $.

    $( Lemma for ~ 4at .  Combine both possible cases.  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem10 $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( ( R e. A
         /\ S e. A ) /\ V e. A /\ W e. A )
          /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
             /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
     -> ( ( R .\/ S ) .<_ ( ( P .\/ Q ) .\/ ( V .\/ W ) )
   -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
          = ( ( P .\/ Q ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a wa co wbr wn 3ad2ant1 chlt wne wceq clat cbs cfv wb simp11 syl
      simp21l eqid atbase simp21r hlatjcl simp22 simp23 syl3anc latjcl latjle12
      hllat syl13anc 3jca simp2 simp33 simp3 4atlem10b syl31anc hlatjcom oveq2d
      wi simp12 simp13 jca simp21 simp32 4atlem0a syl32anc simprr simprl eqtr3d
      3exp 3adant2 wo simp1 4atlem3b syl131anc mpjaod sylbird ) GUANZBANZCANZOZ
      DANZEANZPZIANZJANZOZBCUBZDBCFQZHRSZEWTDFQHRSZOZOZDEFQZWTIJFQZFQZHRZDXGHRZ
      EXGHRZPZWTXEFQZXGUCZXDGUDNZDGUEUFZNZEXONZXGXONZXKXHUGXDWIXNWIWJWKWRXCUHZG
      UTUIZXDWMXPWMWNWPWQWLXCUJZAXODGXOUKZMULUIXDWNXQWMWNWPWQWLXCUMZAXOEGYBMULU
      IXDXNWTXONZXFXONZXRXTWLWRYDXCAXOFGBCYBLMUNTXDWIWPWQYEXSWLWOWPWQXCUOZWLWOW
      PWQXCUPZAXOFGIJYBLMUNUQXOFGWTXFYBLURUQXOFGHDEXGYBKLUSVAXDDWTJFQZHRSZXKXMV
      JEYHHRSZXDYIXKXMXDYIXKOZWLWMWNWPOZWQYIXBOXKXMWLWRXCYIXKUHXDYIYLXKXDWMWNWP
      YAYCYFVBTYKWQYIXBXDYIWQXKYGTXDYIXKVCXDYIXBXKWLWRWSXAXBVDZTVBXDYIXKVEABCDE
      FGHIJKLMVFVGWAXDYJXKXMXDYJXKOZWTEDFQZFQZXLXGXDYJYPXLUCXKXDYOXEWTFXDWIWNWM
      YOXEUCXSYCYAAFGEDLMVHUQVITYNWLWNWMWPOZWQYJDWTEFQHRSZOXJXIPZYPXGUCWLWRXCYJ
      XKUHXDYJYQXKXDWNWMWPYCYAYFVBTYNWQYJYRXDYJWQXKYGTXDYJXKVCXDYJYRXKXDWIWJWKP
      WOXAXBYRXSXDWJWKWIWJWKWRXCVKWIWJWKWRXCVLVMWLWOWPWQXCVNWLWRWSXAXBVOYMABCDE
      FGHKLMVPVQTVBXDXKYSYJXDXKPXJXIXDXIXJVRXDXIXJVSVMWBABCEDFGHIJKLMVFVGVTWAXD
      WLWMWNWQXCYIYJWCWLWRXCWDYAYCYGWLWRXCVEABCDEFGHJKLMWEWFWGWH $.

    $( Lemma for ~ 4at .  Substitute ` U ` for ` Q ` .  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem11a $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
       /\ ( U e. A /\ V e. A /\ W e. A ) /\ -. Q .<_ ( ( P .\/ V ) .\/ W ) )
  -> ( Q .<_ ( ( P .\/ U ) .\/ ( V .\/ W ) )
   <-> ( ( P .\/ Q ) .\/ ( V .\/ W ) )
         = ( ( P .\/ U ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a co wbr wceq syl syl3anc 4atlem4b chlt wn cbs cfv simp11 simp13
      simp21 clat hllat simp12 simp22 eqid hlatjcl simp23 atbase simp3 hlexchb2
      wb latjcl syl131anc syl32anc breq2d eqeq12d 3bitr4d ) FUAMZBAMZCAMZNZDAMZ
      HAMZIAMZNZCBHEOZIEOZGPUBZNZCDVNEOZGPZCVNEOZVQQZCBDEOHIEOZEOZGPBCEOWAEOZWB
      QVPVEVGVIVNFUCUDZMZVOVRVTURVEVFVGVLVOUEZVEVFVGVLVOUFZVHVIVJVKVOUGZVPFUHMZ
      VMWDMZIWDMZWEVPVEWIWFFUIRVPVEVFVJWJWFVEVFVGVLVOUJZVHVIVJVKVOUKZAWDEFBHWDU
      LZKLUMSVPVKWKVHVIVJVKVOUNZAWDIFWNLUORWDEFVMIWNKUSSVHVLVOUPAWDCDEFGVNWNJKL
      UQUTVPWBVQCGVPVEVFVIVJVKWBVQQWFWLWHWMWOABDHIEFGJKLTVAZVBVPWCVSWBVQVPVEVFV
      GVJVKWCVSQWFWLWGWMWOABCHIEFGJKLTVAWPVCVD $.

    $( Lemma for ~ 4at .  Substitute ` U ` for ` Q ` (cont.).  (Contributed by
       NM, 10-Jul-2012.) $)
    4atlem11b $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
        /\ ( R e. A /\ S e. A ) /\ ( U e. A /\ V e. A /\ W e. A ) )
     /\ ( ( P =/= Q
     /\ -. R .<_ ( P .\/ Q ) /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) )
        /\ -. Q .<_ ( ( P .\/ V ) .\/ W ) )
     /\ ( Q .<_ ( ( P .\/ U ) .\/ ( V .\/ W ) )
        /\ R .<_ ( ( P .\/ U ) .\/ ( V .\/ W ) )
        /\ S .<_ ( ( P .\/ U ) .\/ ( V .\/ W ) ) ) )
   -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
         = ( ( P .\/ U ) .\/ ( V .\/ W ) ) ) $=
      ( wcel w3a wa co wbr syl3anc chlt wne wn wceq simp11 simp132 simp133 3jca
      simp12 simp2l simp32 simp33 clat cbs cfv simp111 hllat syl simp12l atbase
      wb eqid simp12r simp112 simp131 hlatjcl latjcl latjle12 syl13anc mpbi2and
      simp31 simp13 simp2r 4atlem11a mpbid breqtrrd 4atlem10 sylc eqtrd ) HUAOZ
      BAOZCAOZPZDAOZEAOZQZFAOZJAOZKAOZPZPZBCUBDBCGRZISUCEWLDGRISUCPZCBJGRKGRISU
      CZQZCBFGRZJKGRZGRZISZDWRISZEWRISZPZPZWLDEGRZGRZWLWQGRZWRXCWCWFWHWIPZWMPXD
      XFISXEXFUDXCWCXGWMWCWFWJWOXBUEZXCWFWHWIWCWFWJWOXBUIWGWHWIWCWFWOXBUFZWGWHW
      IWCWFWOXBUGZUHWKWMWNXBUJUHXCXDWRXFIXCWTXAXDWRISZWKWOWSWTXAUKWKWOWSWTXAULX
      CHUMOZDHUNUOZOZEXMOZWRXMOZWTXAQXKVAXCVTXLVTWAWBWFWJWOXBUPZHUQURZXCWDXNWDW
      EWCWJWOXBUSAXMDHXMVBZNUTURXCWEXOWDWEWCWJWOXBVCAXMEHXSNUTURXCXLWPXMOZWQXMO
      ZXPXRXCVTWAWGXTXQVTWAWBWFWJWOXBVDWGWHWIWCWFWOXBVEAXMGHBFXSMNVFTXCVTWHWIYA
      XQXIXJAXMGHJKXSMNVFTXMGHWPWQXSMVGTXMGHIDEWRXSLMVHVIVJXCWSXFWRUDZWKWOWSWTX
      AVKXCWCWJWNWSYBVAXHWCWFWJWOXBVLWKWMWNXBVMABCFGHIJKLMNVNTVOZVPABCDEGHIJKLM
      NVQVRYCVS $.

    $( Lemma for ~ 4at .  Combine all three possible cases.  (Contributed by
       NM, 10-Jul-2012.) $)
    4atlem11 $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A
    /\ S e. A ) /\ ( U e. A /\ V e. A /\ W e. A ) )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
         /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
 -> ( ( Q .\/ ( R .\/ S ) )
        .<_ ( ( P .\/ U ) .\/ ( V .\/ W ) )
    -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
          = ( ( P .\/ U ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a wa co wbr wn chlt wne wceq 3anass cbs cfv wb simpl11 hllat syl
      clat simpl2l eqid simpl2r simpl12 simpl31 hlatjcl syl3anc simpl32 simpl33
      atbase latjcl latjle12 syl13anc anbi2d syl5bb simpl13 bitrd w3o wi simpl1
      simpl2 jca simpr 4atlem3a syl31anc simp1l simp2 simp3 4atlem11b syl121anc
      simp1r 3exp 3ad2ant1 hlatj4 syl122anc simp1l3 simp1r2 4atlem0be syl131anc
      simp1r1 4atlem0ae syl132anc simp1r3 hlatj32 breq2d mtbid simp32 syl323anc
      3jca simp31 simp33 eqtrd latj4rot hlatjcom oveq1d simpl3 4noncolr1 notbid
      necom a1i 3anbi123d mpbid simpr3 simpr1 simpr2 3adant2 3jaod mpd sylbird
      ) HUAOZBAOZCAOZPZDAOZEAOZQZFAOZJAOZKAOZPZPZBCUBZDBCGRZISTZEYNDGRZISZTZPZQ
      ZCDEGRZGRBFGRZJKGRZGRZISZCUUDISZDUUDISZEUUDISZPZYNUUAGRZUUDUCZYTUUIUUFUUA
      UUDISZQZUUEUUIUUFUUGUUHQZQYTUUMUUFUUGUUHUDYTUUNUULUUFYTHUKOZDHUEUFZOZEUUP
      OZUUDUUPOZUUNUULUGYTYAUUOYAYBYCYGYKYSUHZHUIUJZYTYEUUQYEYFYDYKYSULZAUUPDHU
      UPUMZNVAUJZYTYFUURYEYFYDYKYSUNZAUUPEHUVCNVAUJZYTUUOUUBUUPOZUUCUUPOZUUSUVA
      YTYAYBYHUVGUUTYAYBYCYGYKYSUOZYHYIYJYDYGYSUPAUUPGHBFUVCMNUQURYTYAYIYJUVHUU
      TYHYIYJYDYGYSUSZYHYIYJYDYGYSUTZAUUPGHJKUVCMNUQURUUPGHUUBUUCUVCMVBURZUUPGH
      IDEUUDUVCLMVCVDVEVFYTUUOCUUPOZUUAUUPOZUUSUUMUUEUGUVAYTYCUVMYAYBYCYGYKYSVG
      ZAUUPCHUVCNVAUJZYTYAYEYFUVNUUTUVBUVEAUUPGHDEUVCMNUQURUVLUUPGHICUUAUUDUVCL
      MVCVDVHYTCBJGRKGRZISTZDUVQISTZEUVQISTZVIZUUIUUKVJZYTYDYGYIYJQYSUWAYDYGYKY
      SVKZYDYGYKYSVLZYTYIYJUVJUVKVMYLYSVNZABCDEJGHIKLMNVOVPYTUVRUWBUVSUVTYTUVRU
      UIUUKYTUVRUUIPYLYSUVRUUIUUKYLYSUVRUUIVQYLYSUVRUUIWBYTUVRUUIVRYTUVRUUIVSAB
      CDEFGHIJKLMNVTWAWCYTUVSUUIUUKYTUVSUUIPZUUJBDGRZCEGRGRZUUDUWFYAYBYCYEYFUUJ
      UWHUCYTUVSYAUUIUUTWDZYTUVSYBUUIUVIWDZYTUVSYCUUIUVOWDZYTUVSYEUUIUVBWDZYTUV
      SYFUUIUVEWDZABCDEGHMNWEWFUWFYAYBYEPYCYFQYKBDUBZCUWGISTZEUWGCGRZISZTZPUVSU
      UGUUFUUHUWHUUDUCUWFYAYBYEUWIUWJUWLWTUWFYCYFUWKUWMVMYDYGYKYSUVSUUIWGUWFUWN
      UWOUWRUWFYAYBYCYEYOUWNUWIUWJUWKUWLYMYOYRYLUVSUUIWHZABCDGHILMNWIWJUWFYAYBY
      CYEYMYOUWOUWIUWJUWKUWLYMYOYRYLUVSUUIWKUWSABCDGHILMNWLWMUWFYQUWQYMYOYRYLUV
      SUUIWNUWFYPUWPEIUWFYAYBYCYEYPUWPUCUWIUWJUWKUWLABCDGHMNWOVDWPWQWTYTUVSUUIV
      RYTUVSUUFUUGUUHWRYTUVSUUFUUGUUHXAYTUVSUUFUUGUUHXBABDCEFGHIJKLMNVTWSXCWCYT
      UVTUUIUUKYTUVTUUIPZUUJBEGRZCDGRZGRZUUDYTUVTUUJUXCUCUUIYTUUJEBGRZUXBGRZUXC
      YTUUOBUUPOZUVMUUQUURUUJUXEUCUVAYTYBUXFUVIAUUPBHUVCNVAUJUVPUVDUVFUUPGHEBCD
      UVCMXDWFYTUXDUXAUXBGYTYAYFYBUXDUXAUCUUTUVEUVIAGHEBMNXEURZXFXCWDUWTYAYBYFP
      ZYCYEQZYKPZBEUBZCUXAISZTZDUXACGRZISZTZPZUVTUUHUUFUUGPZUXCUUDUCYTUVTUXJUUI
      YTUXHUXIYKYTYAYBYFUUTUVIUVEWTYTYCYEUVOUVBVMYDYGYKYSXGWTWDYTUVTUXQUUIYTEBU
      BZCUXDISZTZDUXDCGRZISZTZPZUXQYTYDYGYSUYEUWCUWDUWEABCDEGHILMNXHURYTUXSUXKU
      YAUXMUYDUXPUXSUXKUGYTEBXJXKYTUXTUXLYTUXDUXACIUXGWPXIYTUYCUXOYTUYBUXNDIYTU
      XDUXACGUXGXFWPXIXLXMWDYTUVTUUIVRYTUUIUXRUVTYTUUIQUUHUUFUUGYTUUFUUGUUHXNYT
      UUFUUGUUHXOYTUUFUUGUUHXPWTXQABECDFGHIJKLMNVTWAXCWCXRXSXT $.

    $( Lemma for ~ 4at .  Substitute ` T ` for ` P ` .  (Contributed by NM,
       9-Jul-2012.) $)
    4atlem12a $p |- ( ( ( K e. HL /\ P e. A /\ T e. A )
       /\ ( U e. A /\ V e. A /\ W e. A ) /\ -. P .<_ ( ( U .\/ V ) .\/ W ) )
  -> ( P .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) )
   <-> ( ( P .\/ U ) .\/ ( V .\/ W ) )
        = ( ( T .\/ U ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a co wbr wceq syl syl3anc 4atlem4a chlt wn cbs cfv simp11 simp12
      simp13 clat hllat simp21 simp22 eqid hlatjcl simp23 atbase simp3 hlexchb2
      wb latjcl syl131anc syl32anc breq2d eqeq12d 3bitr4d ) FUAMZBAMZCAMZNZDAMZ
      HAMZIAMZNZBDHEOZIEOZGPUBZNZBCVNEOZGPZBVNEOZVQQZBCDEOHIEOZEOZGPBDEOWAEOZWB
      QVPVEVFVGVNFUCUDZMZVOVRVTURVEVFVGVLVOUEZVEVFVGVLVOUFZVEVFVGVLVOUGZVPFUHMZ
      VMWDMZIWDMZWEVPVEWIWFFUIRVPVEVIVJWJWFVHVIVJVKVOUJZVHVIVJVKVOUKZAWDEFDHWDU
      LZKLUMSVPVKWKVHVIVJVKVOUNZAWDIFWNLUORWDEFVMIWNKUSSVHVLVOUPAWDBCEFGVNWNJKL
      UQUTVPWBVQBGVPVEVGVIVJVKWBVQQWFWHWLWMWOACDHIEFGJKLTVAZVBVPWCVSWBVQVPVEVFV
      IVJVKWCVSQWFWGWLWMWOABDHIEFGJKLTVAWPVCVD $.

    $( Lemma for ~ 4at .  Substitute ` T ` for ` P ` (cont.).  (Contributed by
       NM, 11-Jul-2012.) $)
    4atlem12b $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
      /\ ( R e. A /\ S e. A /\ T e. A ) /\ ( U e. A /\ V e. A /\ W e. A ) )
   /\ ( ( P =/= Q /\ -. R .<_ ( P .\/ Q )
      /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) )
      /\ -. P .<_ ( ( U .\/ V ) .\/ W ) )
   /\ ( ( P .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) )
          /\ Q .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) ) )
      /\ ( R .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) )
          /\ S .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) ) ) ) )
   -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
          = ( ( T .\/ U ) .\/ ( V .\/ W ) ) ) $=
      ( wcel w3a co wbr wa chlt wne wceq simp11 simp121 simp122 jca simp13 3jca
      wn simp2l simp3lr simp3rl simp3rr clat cbs cfv wb simp111 syl eqid atbase
      simp123 simp131 hlatjcl syl3anc simp132 latjcl latjle12 syl13anc mpbi2and
      hllat simp133 simp113 simp3ll simp112 simp2r 4atlem12a syl311anc breqtrrd
      mpbid 4atlem11 sylc eqtrd ) IUAPZBAPZCAPZQZDAPZEAPZFAPZQZGAPZKAPZLAPZQZQZ
      BCUBDBCHRZJSUJEWRDHRJSUJQZBGKHRLHRJSUJZTZBFGHRZKLHRZHRZJSZCXDJSZTZDXDJSZE
      XDJSZTZTZQZWRDEHRZHRZBGHRXCHRZXDXLWHWIWJTZWPQZWSTCXMHRZXOJSXNXOUCXLXQWSXL
      WHXPWPWHWLWPXAXKUDXLWIWJWIWJWKWHWPXAXKUEZWIWJWKWHWPXAXKUFZUGWHWLWPXAXKUHZ
      UIWQWSWTXKUKUGXLXRXDXOJXLXFXMXDJSZXRXDJSZXEXFXJWQXAULXLXHXIYBXHXIXGWQXAUM
      XHXIXGWQXAUNXLIUOPZDIUPUQZPZEYEPZXDYEPZXJYBURXLWEYDWEWFWGWLWPXAXKUSZIVLUT
      ZXLWIYFXSAYEDIYEVAZOVBUTXLWJYGXTAYEEIYKOVBUTXLYDXBYEPZXCYEPZYHYJXLWEWKWMY
      LYIWIWJWKWHWPXAXKVCZWMWNWOWHWLXAXKVDAYEHIFGYKNOVEVFXLWEWNWOYMYIWMWNWOWHWL
      XAXKVGWMWNWOWHWLXAXKVMAYEHIKLYKNOVEVFYEHIXBXCYKNVHVFZYEHIJDEXDYKMNVIVJVKX
      LYDCYEPZXMYEPZYHXFYBTYCURYJXLWGYPWEWFWGWLWPXAXKVNAYECIYKOVBUTXLWEWIWJYQYI
      XSXTAYEHIDEYKNOVEVFYOYEHIJCXMXDYKMNVIVJVKXLXEXOXDUCZXEXFXJWQXAVOXLWEWFWKW
      PWTXEYRURYIWEWFWGWLWPXAXKVPYNYAWQWSWTXKVQABFGHIJKLMNOVRVSWAZVTABCDEGHIJKL
      MNOWBWCYSWD $.

    $( Lemma for ~ 4at .  Combine all four possible cases.  (Contributed by NM,
       11-Jul-2012.) $)
    4atlem12 $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A
    /\ S e. A /\ T e. A ) /\ ( U e. A /\ V e. A /\ W e. A ) )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
     /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
 -> ( ( ( P .\/ Q ) .\/ ( R .\/ S ) )
        .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) )
    -> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
           = ( ( T .\/ U ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a co wbr wn chlt wne wa wceq clat cbs cfv wb simpl11 syl simpl12
      hllat eqid atbase simpl13 simpl23 simpl31 hlatjcl syl3anc simpl32 simpl33
      latjcl latjle12 syl13anc simpl21 simpl22 simpl1 bitrd wo wi simp1l simp1r
      anbi12d simp2 4atlem12b syl121anc 3exp latj4rot syl122anc 3ad2ant1 simpl3
      simp3 3jca simpr 4noncolr3 simprlr simprrl simprrr simprll 3adant2 eqtr3d
      jca jca32 jaod latjcom 4noncolr2 simprr simprl 4noncolr1 4atlem3 syl31anc
      eqtrd mpjaod sylbird ) IUAPZBAPZCAPZQZDAPZEAPZFAPZQZGAPZKAPZLAPZQZQZBCUBD
      BCHRZJSTEXRDHRJSTQZUCZXRDEHRZHRZFGHRZKLHRZHRZJSZBYEJSZCYEJSZUCZDYEJSZEYEJ
      SZUCZUCZYBYEUDZXTYMXRYEJSZYAYEJSZUCZYFXTYIYOYLYPXTIUEPZBIUFUGZPZCYSPZYEYS
      PZYIYOUHXTXEYRXEXFXGXLXPXSUIZIULUJZXTXFYTXEXFXGXLXPXSUKZAYSBIYSUMZOUNUJZX
      TXGUUAXEXFXGXLXPXSUOZAYSCIUUFOUNUJZXTYRYCYSPZYDYSPZUUBUUDXTXEXKXMUUJUUCXI
      XJXKXHXPXSUPZXMXNXOXHXLXSUQZAYSHIFGUUFNOURUSXTXEXNXOUUKUUCXMXNXOXHXLXSUTZ
      XMXNXOXHXLXSVAZAYSHIKLUUFNOURUSYSHIYCYDUUFNVBUSZYSHIJBCYEUUFMNVCVDXTYRDYS
      PZEYSPZUUBYLYPUHUUDXTXIUUQXIXJXKXHXPXSVEZAYSDIUUFOUNUJZXTXJUURXIXJXKXHXPX
      SVFZAYSEIUUFOUNUJZUUPYSHIJDEYEUUFMNVCVDVMXTYRXRYSPZYAYSPZUUBYQYFUHUUDXTXH
      UVCXHXLXPXSVGZAYSHIBCUUFNOURUJZXTXEXIXJUVDUUCUUSUVAAYSHIDEUUFNOURUSZUUPYS
      HIJXRYAYEUUFMNVCVDVHXTBGKHRLHRZJSTZCUVHJSTZVIZYMYNVJZDUVHJSTZEUVHJSTZVIZX
      TUVIUVLUVJXTUVIYMYNXTUVIYMQXQXSUVIYMYNXQXSUVIYMVKXQXSUVIYMVLXTUVIYMVNXTUV
      IYMWBABCDEFGHIJKLMNOVOVPVQXTUVJYMYNXTUVJYMQZCDHRZEBHRZHRZYBYEXTUVJUVSYBUD
      ZYMXTYRUUAUUQUURYTUVTUUDUUIUUTUVBUUGYSHIBCDEUUFNVRVSVTUVPXEXGXIQZXJXFXKQZ
      XPQZCDUBEUVQJSTBUVQEHRJSTQZUVJYHYJUCZYKYGUCZUCZUVSYEUDXTUVJUWCYMXTUWAUWBX
      PXTXEXGXIUUCUUHUUSWCXTXJXFXKUVAUUEUULWCXHXLXPXSWAZWCVTXTUVJUWDYMXTXHXIXJX
      SUWDUVEUUSUVAXQXSWDZABCDEHIJMNOWEVPVTXTUVJYMVNXTYMUWGUVJXTYMUCZUWEYKYGUWJ
      YHYJXTYGYHYLWFZXTYIYJYKWGZWLXTYIYJYKWHZXTYGYHYLWIZWMWJACDEBFGHIJKLMNOVOVP
      WKVQWNXTUVMUVLUVNXTUVMYMYNXTUVMYMQZYBYAXRHRZYEXTUVMYBUWPUDZYMXTYRUVCUVDUW
      QUUDUVFUVGYSHIXRYAUUFNWOUSVTUWOXEXIXJQZXFXGXKQZXPQZDEUBBYAJSTCYABHRJSTQZU
      VMYLYIUCZUWPYEUDXTUVMUWTYMXTUWRUWSXPXTXEXIXJUUCUUSUVAWCXTXFXGXKUUEUUHUULW
      CUWHWCVTXTUVMUXAYMXTXHXIXJXSUXAUVEUUSUVAUWIABCDEHIJMNOWPVPVTXTUVMYMVNXTYM
      UXBUVMUWJYLYIXTYIYLWQXTYIYLWRWLWJADEBCFGHIJKLMNOVOVPXBVQXTUVNYMYNXTUVNYMQ
      ZYBUVRUVQHRZYEXTUVNYBUXDUDZYMXTYRYTUUAUUQUURUXEUUDUUGUUIUUTUVBYSHIEBCDUUF
      NVRVSVTUXCXEXJXFQZXGXIXKQZXPQZEBUBCUVRJSTDUVRCHRJSTQZUVNUWFUWEUCZUXDYEUDX
      TUVNUXHYMXTUXFUXGXPXTXEXJXFUUCUVAUUEWCXTXGXIXKUUHUUSUULWCUWHWCVTXTUVNUXIY
      MXTXHXIXJXSUXIUVEUUSUVAUWIABCDEHIJMNOWSVPVTXTUVNYMVNXTYMUXJUVNUWJUWFYHYJU
      WJYKYGUWMUWNWLUWKUWLWMWJAEBCDFGHIJKLMNOVOVPXBVQWNXTXHXIXJXMQXNXOUCXSUVKUV
      OVIUVEXTXIXJXMUUSUVAUUMWCXTXNXOUUNUUOWLUWIABCDEGKHIJLMNOWTXAXCXD $.

    $( Four atoms determine a lattice volume uniquely.  Three-dimensional
       analog of ~ ps-1 and ~ 3at .  (Contributed by NM, 11-Jul-2012.) $)
    4at $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A
         /\ S e. A /\ T e. A ) /\ ( U e. A /\ V e. A /\ W e. A ) )
          /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
              /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
 -> ( ( ( P .\/ Q ) .\/ ( R .\/ S ) )
        .<_ ( ( T .\/ U ) .\/ ( V .\/ W ) )
    <-> ( ( P .\/ Q ) .\/ ( R .\/ S ) )
        = ( ( T .\/ U ) .\/ ( V .\/ W ) ) ) ) $=
      ( wcel w3a co wbr syl3anc chlt wne wn wa wceq 4atlem12 wi clat cbs simp11
      cfv hllat simp23 simp31 hlatjcl simp32 simp33 latjcl latref syl2anc breq1
      syl eqid syl5ibrcom adantr impbid ) IUAPZBAPZCAPZQZDAPZEAPZFAPZQZGAPZKAPZ
      LAPZQZQZBCUBDBCHRZJSUCEVTDHRJSUCQZUDVTDEHRHRZFGHRZKLHRZHRZJSZWBWEUEZABCDE
      FGHIJKLMNOUFVSWGWFUGWAVSWFWGWEWEJSZVSIUHPZWEIUIUKZPZWHVSVGWIVGVHVIVNVRUJZ
      IULVBZVSWIWCWJPZWDWJPZWKWMVSVGVMVOWNWLVJVKVLVMVRUMVJVNVOVPVQUNAWJHIFGWJVC
      ZNOUOTVSVGVPVQWOWLVJVNVOVPVQUPVJVNVOVPVQUQAWJHIKLWPNOUOTWJHIWCWDWPNURTWJI
      JWEWPMUSUTWBWEWEJVAVDVEVF $.

    $( Four atoms determine a lattice volume uniquely.  (Contributed by NM,
       11-Jul-2012.) $)
    4at2 $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( R e. A
   /\ S e. A /\ T e. A ) /\ ( U e. A /\ V e. A /\ W e. A ) )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q )
      /\ -. S .<_ ( ( P .\/ Q ) .\/ R ) ) )
  -> ( ( ( ( P .\/ Q ) .\/ R ) .\/ S )
          .<_ ( ( ( T .\/ U ) .\/ V ) .\/ W )
   <-> ( ( ( P .\/ Q ) .\/ R ) .\/ S )
             = ( ( ( T .\/ U ) .\/ V ) .\/ W ) ) ) $=
      ( wcel w3a co wbr syl chlt wne wn wa wceq 4at wb clat cbs cfv simp11 eqid
      hllat hlatjcl 3ad2ant1 simp21 atbase simp22 latjass simp23 simp31 syl3anc
      syl13anc simp32 simp33 breq12d adantr eqeq12d 3bitr4d ) IUAPZBAPZCAPZQZDA
      PZEAPZFAPZQZGAPZKAPZLAPZQZQZBCUBDBCHRZJSUCEWCDHRZJSUCQZUDWCDEHRHRZFGHRZKL
      HRHRZJSZWFWHUEZWDEHRZWGKHRLHRZJSZWKWLUEZABCDEFGHIJKLMNOUFWBWMWIUGWEWBWKWF
      WLWHJWBIUHPZWCIUIUJZPZDWPPZEWPPZWKWFUEWBVJWOVJVKVLVQWAUKZIUMTZVMVQWQWAAWP
      HIBCWPULZNOUNUOWBVNWRVMVNVOVPWAUPAWPDIXBOUQTWBVOWSVMVNVOVPWAURAWPEIXBOUQT
      WPHIWCDEXBNUSVCZWBWOWGWPPZKWPPZLWPPZWLWHUEXAWBVJVPVRXDWTVMVNVOVPWAUTVMVQV
      RVSVTVAAWPHIFGXBNOUNVBWBVSXEVMVQVRVSVTVDAWPKIXBOUQTWBVTXFVMVQVRVSVTVEAWPL
      IXBOUQTWPHIWGKLXBNUSVCZVFVGWBWNWJUGWEWBWKWFWLWHXCXGVHVGVI $.
  $}

  ${
    $d p q r s t u v w C $.  $d p q r s t u v w K $.  $d p q r s t u v w .<_ $.
    $d s t u v w P $.  $d s V $.  $d p q r s t u v w X $.
    $d p q r s t u v w Y $.
    lplncvrlvol2.l $e |- .<_ = ( le ` K ) $.
    lplncvrlvol2.c $e |- C = ( <o ` K ) $.
    lplncvrlvol2.p $e |- P = ( LPlanes ` K ) $.
    lplncvrlvol2.v $e |- V = ( LVols ` K ) $.
    $( A lattice line under a lattice plane is covered by it.  (Contributed by
       NM, 12-Jul-2012.) $)
    lplncvrlvol2 $p |- ( ( ( K e. HL /\ X e. P /\ Y e. V ) /\ X .<_ Y )
         -> X C Y ) $=
      ( wcel w3a wbr wa wn cv co wrex wi vs vt vu vv vw vp vq chlt cplt cfv wne
      vr simpr simpl1 simpl3 lvolnelpln syl2anc simpl2 eleq1 syl5ibcom necon3bd
      wceq mpd eqid pltval adantr mpbir2and cjn catm lplnbase lvolbase hlrelat3
      wb cbs syl syl31anc islvol2 islpln2 simp3rl simp3rr simp133 oveq1d simp23
      3brtr3d simp11 simp12 simp3l simp21l 3jca simp21r simp22l simp22r simp131
      simp132 simp111 clat hllat hlatjcl atbase latjcl syl3anc cvr1 mpbird 4at2
      syl33anc mpbid 3eqtr4d breqtrd 3exp exp4a 3expd rexlimdv3a 3expib adantld
      rexlimdvv sylbid imp31 syl7 rexlimdvva 3impia rexlimdv imp syldan ) CUHLZ
      FBLZGELZMZFGDNZFGCUIUJZNZFGANZYGYHOZYJYHFGUKZYGYHUMYLGBLZPZYMYLYDYFYOYDYE
      YFYHUNYDYEYFYHUOBCEGJKUPUQYLYNFGYLYEFGVBYNYDYEYFYHURFGBUSUTVAVCYGYJYHYMOV
      MYHUHBEYICDFGHYIVDZVEVFVGYGYJFFUAQZCVHUJZRZANZYSGDNZOZUACVIUJZSZYKYGYJOZY
      DFCVNUJZLZGUUFLZYJUUDYDYEYFYJUNUUEYEUUGYDYEYFYJURUUFBCFUUFVDZJVJVOUUEYFUU
      HYDYEYFYJUOUUFCEGUUIKVKVOYGYJUMUUCUUFAYIYRCDFGUAUUIHYPYRVDZIUUCVDZVLVPYGU
      UDYKYGUUBYKUAUUCYDYEYFYQUUCLZUUBYKTTZYDYEOZYFUUHUBQZUCQZUKUDQZUUOUUPYRRZD
      NPUEQZUURUUQYRRZDNPMZGUUTUUSYRRZVBZOZUEUUCSUDUUCSZUCUUCSUBUUCSZOZUUMYDYFU
      VGVMYEUUCUUFYRCDEGUEUDUCUBUUIHUUJUUKKVQVFUUNUVFUUMUUHUUNUVEUUMUBUCUUCUUCU
      UNUUOUUCLZUUPUUCLZOZOZUVDUUMUDUEUUCUUCUVDUVCUVKUUQUUCLZUUSUUCLZOZUUMUVAUV
      CUMYDYEUVJUVNUVCUUMTTZYDYEUUGUFQZUGQZUKZULQZUVPUVQYRRZDNPZFUVTUVSYRRZVBZM
      ZULUUCSZUGUUCSUFUUCSZOUVJUVOTZUUCUUFBYRCDFULUGUFUUIHUUJUUKJVRYDUWFUWGUUGY
      DUWEUWGUFUGUUCUUCYDUVPUUCLZUVQUUCLZUWEUWGTYDUWHUWIMZUWDUWGULUUCUWJUVSUUCL
      ZUWDMZUVJUVNUVCUUMUWLUVJUVNUVCMZUULUUBYKUWLUWMUULUUBOZYKUWLUWMUWNMZFYSGAY
      TUUAUULUWLUWMVSZUWOUWBYQYRRZUVBYSGUWOUWQUVBDNZUWQUVBVBZUWOYSGUWQUVBDYTUUA
      UULUWLUWMVTUWOFUWBYQYRUVRUWAUWCUWJUWKUWMUWNWAZWBZUWLUVJUVNUVCUWNWCZWDUWOU
      WJUWKUULUVHMUVIUVLUVMMUVRUWAYQUWBDNPZUWRUWSVMUWJUWKUWDUWMUWNWEZUWOUWKUULU
      VHUWJUWKUWDUWMUWNWFZUWLUWMUULUUBWGZUVHUVIUVNUVCUWLUWNWHWIUWOUVIUVLUVMUVHU
      VIUVNUVCUWLUWNWJUVLUVMUVJUVCUWLUWNWKUVLUVMUVJUVCUWLUWNWLWIUVRUWAUWCUWJUWK
      UWMUWNWMUVRUWAUWCUWJUWKUWMUWNWNUWOUXCUWBUWQANZUWOFYSUWBUWQAUWPUWTUXAWDUWO
      YDUWBUUFLZUULUXCUXGVMYDUWHUWIUWKUWDUWMUWNWOZUWOCWPLZUVTUUFLZUVSUUFLZUXHUW
      OYDUXJUXICWQVOUWOUWJUXKUXDUUCUUFYRCUVPUVQUUIUUJUUKWRVOUWOUWKUXLUXEUUCUUFU
      VSCUUIUUKWSVOUUFYRCUVTUVSUUIUUJWTXAUXFUUCUUFAYQYRCDUWBUUIHUUJIUUKXBXAXCUU
      CUVPUVQUVSYQUUOUUPYRCDUUQUUSHUUJUUKXDXEXFUXAUXBXGXHXIXJXKXLXMXOXNXPXQXRXO
      XSXNXPXTYAYBYCYC $.
  $}

  ${
    $d p z B $.  $d p z C $.  $d p z K $.  $d z P $.  $d p z V $.  $d p z X $.
    $d p z Y $.
    lplncvrlvol.b $e |- B = ( Base ` K ) $.
    lplncvrlvol.c $e |- C = ( <o ` K ) $.
    lplncvrlvol.p $e |- P = ( LPlanes ` K ) $.
    lplncvrlvol.v $e |- V = ( LVols ` K ) $.
    $( An element covering a lattice plane is a lattice volume and vice-versa.
       (Contributed by NM, 15-Jul-2012.) $)
    lplncvrlvol $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X C Y )
        -> ( X e. P <-> Y e. V ) ) $=
      ( vz chlt wcel wbr wa simplr cfv wn adantr simpll1 simpll3 simpr syl31anc
      w3a lvoli cple wrex cp0 wne catm clln simpll2 clat hllat syl eqid syl2anc
      cv latref lvolnleat syl3anc ex mt2d wceq breq1 syl5ibcom wb isat2 sylibrd
      necon3bd mpd lvolnelln sylancom simpllr llni lvolnelpln llncvrlpln mtbird
      mtand lplnle syl23anc simpr3 cops hlop simpr2 lplnbase simpr1 cvrle hlpos
      wi cpo postr syl13anc lplncvrlvol2 cvrcmp2 syl132anc mpbid eqeltrrd 3exp2
      mp2and imp rexlimdv impbida ) DMNZFANZGANZUEZFGBOZPZFCNZGENZXJXKPXEXGXKXI
      XLXEXFXGXIXKUAXEXFXGXIXKUBXJXKUCXHXIXKQABMCDEFGHIJKUFUDXJXLPZLUSZFDUGRZOZ
      LCUHZXKXMXEXFFDUIRZUJZFDUKRZNZSFDULRZNZSXQXEXFXGXIXLUAZXEXFXGXIXLUMXMGXTN
      ZSXSXMYEGGXOOZXMDUNNZXGYFXMXEYGYDDUOUPXEXFXGXIXLUBZADXOGHXOUQZUTURXMYEYFS
      ZXMYEPXEXLYEYJXMXEYEYDTXJXLYEQXMYEUCXTGDXOEGYIXTUQZKVAVBVCVDXMYEFXRXMFXRV
      EZXRGBOZYEXMXIYLYMXHXIXLQFXRGBVFVGXMXEXGYEYMVHYDYHXTABMGDXRHXRUQZIYKVIURV
      JVKVLXMYAGYBNZXJXLXEYOSYDDYBEGYBUQZKVMVNXMYAPXEXGYAXIYOXMXEYAYDTXMXGYAYHT
      XMYAUCXHXIXLYAVOXTABMFDYBGHIYKYPVPUDVTXMYCGCNZXJXLXEYQSYDCDEGJKVQVNXJYCYQ
      VHXLABCDYBFGHIYPJVRTVSLXTACDXOYBFXRHYIYNYKYPJWAWBXMXPXKLCXJXLXNCNZXPXKWKW
      KXJXLYRXPXKXJXLYRXPUEZPZXNFCYTXPXNFVEZXJXLYRXPWCZYTDWDNZXNANZXFXGXNGBOZXI
      XPUUAVHYTXEUUCXEXFXGXIYSUAZDWEUPYTYRUUDXJXLYRXPWFZACDXNHJWGUPZXEXFXGXIYSU
      MZXEXFXGXIYSUBZYTXEYRXLXNGXOOZUUEUUFUUGXJXLYRXPWHYTXPFGXOOZUUKUUBXJUULYSM
      ABDXOFGHYIIWITYTDWLNZUUDXFXGXPUULPUUKWKYTXEUUMUUFDWJUPUUHUUIUUJADXOXNFGHY
      IWMWNXABCDXOEXNGYIIJKWOUDXHXIYSQABDXOXNFGHYIIWPWQWRUUGWSWTXBXCVLXD $.
  $}

  ${
    $d z K $.  $d z .<_ $.  $d z V $.  $d z X $.  $d z Y $.
    lvolcmp.l $e |- .<_ = ( le ` K ) $.
    lvolcmp.v $e |- V = ( LVols ` K ) $.
    $( If two lattice planes are comparable, they are equal.  (Contributed by
       NM, 12-Jul-2012.) $)
    lvolcmp $p |- ( ( K e. HL /\ X e. V /\ Y e. V )
                -> ( X .<_ Y <-> X = Y ) ) $=
      ( vz chlt wcel w3a wbr cfv wi wb eqid lvolbase syl2anc mpbid wa wceq ccvr
      cv clpl simp2 cbs simp1 3ad2ant2 islvol4 simpr3 cpo hlpos 3ad2ant1 adantr
      wrex simpl3 syl simpr1 lplnbase simpr2 simpl1 cvrle syl31anc postr mp2and
      syl13anc lplncvrlvol2 cvrcmp syl132anc 3exp2 rexlimdv mpd breq2 syl5ibcom
      posref impbid ) AIJZDCJZECJZKZDEBLZDEUAZVTHUCZDAUBMZLZHAUDMZUOZWAWBNZVTVR
      WGVQVRVSUEVTVQDAUFMZJZVRWGOVQVRVSUGVRVQWJVSWIACDWIPZGQUHZHIWIWDWFACDWKWDP
      ZWFPZGUIRSVTWEWHHWFVTWCWFJZWEWAWBVTWOWEWAKZTZWAWBVTWOWEWAUJZWQAUKJZWJEWIJ
      ZWCWIJZWEWCEWDLZWAWBOVTWSWPVQVRWSVSAULUMZUNZVTWJWPWLUNZWQVSWTVQVRVSWPUPZW
      IACEWKGQUQZWQWOXAVTWOWEWAURZWIWFAWCWKWNUSUQZVTWOWEWAUTZWQVQWOVSWCEBLZXBVQ
      VRVSWPVAZXHXFWQWCDBLZWAXKWQVQXAWJWEXMXLXIXEXJIWIWDABWCDWKFWMVBVCWRWQWSXAW
      JWTXMWATXKNXDXIXEXGWIABWCDEWKFVDVFVEWDWFABCWCEFWMWNGVGVCWIWDABDEWCWKFWMVH
      VISVJVKVLVTDDBLZWBWAVTWSWJXNXCWLWIABDWKFVORDEDBVMVNVP $.
  $}

  ${
    lvolnlt.s $e |- .< = ( lt ` K ) $.
    lvolnlt.v $e |- V = ( LVols ` K ) $.
    $( Two lattice volumes cannot satisfy the less than relation.  (Contributed
       by NM, 12-Jul-2012.)  (New usage is discouraged.) $)
    lvolnltN $p |- ( ( K e. HL /\ X e. V /\ Y e. V ) -> -. X .< Y ) $=
      ( chlt wcel w3a wbr wceq pltirr 3adant3 breq2 notbid syl5ibcom cple cfv
      wn eqid pltle lvolcmp sylibd necon3ad pm2.61dne ) BHIZDCIZECIZJZDEAKZTZDE
      UJDDAKZTZDELZULUGUHUNUIHCABDFMNUOUMUKDEDAOPQUJUKDEUJUKDEBRSZKUOHCCABUPDEU
      PUAZFUBBUPCDEUQGUCUDUEUF $.
  $}

  ${
    2lplnja.l $e |- .<_ = ( le ` K ) $.
    2lplnja.j $e |- .\/ = ( join ` K ) $.
    2lplnja.a $e |- A = ( Atoms ` K ) $.
    2lplnja.v $e |- V = ( LVols ` K ) $.
    $( The join of two different lattice planes in a lattice volume equals the
       volume (version of ~ 2lplnj in terms of atoms).  (Contributed by NM,
       12-Jul-2012.) $)
    2lplnja $p |- ( ( ( ( K e. HL /\ W e. V )
     /\ ( P e. A /\ Q e. A /\ R e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
   /\ ( ( S e. A /\ T e. A /\ U e. A )
     /\ ( S =/= T /\ -. U .<_ ( S .\/ T ) ) )
     /\ ( ( ( P .\/ Q ) .\/ R ) .<_ W /\ ( ( S .\/ T ) .\/ U ) .<_ W
         /\ ( ( P .\/ Q ) .\/ R ) =/= ( ( S .\/ T ) .\/ U ) ) )
  -> ( ( ( P .\/ Q ) .\/ R ) .\/ ( ( S .\/ T ) .\/ U ) ) = W ) $=
      ( wcel wa wbr ad2antrr chlt w3a wne co wn cbs cfv eqid clat simp11l hllat
      syl simp121 simp122 hlatjcl syl3anc simp123 atbase latjcl simp2l1 simp2l2
      simp2l3 simp11r lvolbase simp31 simp32 wb latjle12 syl13anc mpbi2and wceq
      latlej2 lattrd 3jca jca simp13l simp13r simp33 simplr simpr adantr simp2l
      ad3antrrr simp12 simp2rr simp2rl syl32anc mpbid eqcomd ex necon3ad lvoli2
      3at mpd syl113anc lvolcmp wi latjlej2 eqbrtrrd hlatj32 breqtrrd pm2.61dan
      latlej1 latjass latasymd ) IUAQZLKQZRZBAQZCAQZDAQZUBZBCUCZDBCHUDZJSUEZRZU
      BZEAQZFAQZGAQZUBZEFUCZGEFHUDZJSUEZRZRZXNDHUDZLJSZYCGHUDZLJSZYGYIUCZUBZUBZ
      IUFUGZIJYGYIHUDZLYNUHZMYMXFIUIQZXFXGXLXPYFYLUJZIUKULZYMYQYGYNQZYIYNQZYOYN
      QYSYMYQXNYNQZDYNQZYTYSYMXFXIXJUUBYRXIXJXKXHXPYFYLUMZXIXJXKXHXPYFYLUNZAYNH
      IBCYPNOUOUPYMXKUUCXIXJXKXHXPYFYLUQZAYNDIYPOURULYNHIXNDYPNUSUPZYMYQYCYNQZG
      YNQZUUAYSYMXFXRXSUUHYRXRXSXTYEXQYLUTZXRXSXTYEXQYLVAZAYNHIEFYPNOUOUPZYMXTU
      UIXRXSXTYEXQYLVBZAYNGIYPOURULZYNHIYCGYPNUSUPZYNHIYGYIYPNUSUPYMXGLYNQZXFXG
      XLXPYFYLVCZYNIKLYPPVDULZYMYHYJYOLJSZXQYFYHYJYKVEZXQYFYHYJYKVFZYMYQYTUUAUU
      PYHYJRUUSVGYSUUGUUOUURYNHIJYGYILYPMNVHVIVJYMEYGJSZLYOJSZYMUVBRZFYGJSZUVCU
      VDUVERZYGGHUDZLYOJUVFUVGLJSZUVGLVKZYMUVHUVBUVEYMYHGLJSZUVHUUTYMYNIJGYILYP
      MYSUUNUUOUURYMYQUUHUUIGYIJSZYSUULUUNYNHIJYCGYPMNVLUPZUVAVMYMYQYTUUIUUPYHU
      VJRUVHVGYSUUGUUNUURYNHIJYGGLYPMNVHVIVJTUVFXFUVGKQZXGUVHUVIVGYMXFUVBUVEYRT
      UVFXFXIXJUBZXKXTRZXMXOGYGJSZUEZUVMYMUVNUVBUVEYMXFXIXJYRUUDUUEVNZTYMUVOUVB
      UVEYMXKXTUUFUUMVOTYMXMUVBUVEXMXOXHXLYFYLVPZTYMXOUVBUVEXMXOXHXLYFYLVQZTUVF
      YKUVQYMYKUVBUVEXQYFYHYJYKVRTUVFUVPYGYIUVFUVPYGYIVKUVFUVPRZYIYGUWAYIYGJSZY
      IYGVKZUWAYCYGJSZUVPUWBUVFUWDUVPUVFUVBUVEUWDYMUVBUVEVSUVDUVEVTYMUVBUVERUWD
      VGZUVBUVEYMYQEYNQZFYNQZYTUWEYSYMXRUWFUUJAYNEIYPOURULZYMXSUWGUUKAYNFIYPOUR
      ULZUUGYNHIJEFYGYPMNVHVITVJWAUVFUVPVTYMUWDUVPRUWBVGZUVBUVEUVPYMYQUUHUUIYTU
      WJYSUULUUNUUGYNHIJYCGYGYPMNVHVIWCVJYMUWBUWCVGZUVBUVEUVPYMXFYAXLYDYBUWKYRX
      QYAYEYLWBXHXLXPYFYLWDYBYDYAXQYLWEYBYDYAXQYLWFAEFGBCDHIJMNOWMWGWCWHWIWJWKW
      NABCDGHIJKMNOPWLWOYMXGUVBUVEUUQTIJKUVGLMPWPUPWHYMUVGYOJSZUVBUVEYMUVKUWLUV
      LYMYQUUIUUAYTUVKUWLWQYSUUNUUOUUGYNHIJGYIYGYPMNWRVIWNTWSUVDUVEUEZRZYGFHUDZ
      LYOJUWNUWOLJSZUWOLVKZYMUWPUVBUWMYMYHFLJSZUWPUUTYMYNIJFYILYPMYSUWIUUOUURYM
      FEGHUDZFHUDZYIJYMYQUWSYNQZUWGFUWTJSYSYMXFXRXTUXAYRUUJUUMAYNHIEGYPNOUOUPUW
      IYNHIJUWSFYPMNVLUPYMXFXRXSXTYIUWTVKYRUUJUUKUUMAEFGHINOWTVIXAZUVAVMYMYQYTU
      WGUUPYHUWRRUWPVGYSUUGUWIUURYNHIJYGFLYPMNVHVIVJTUWNXFUWOKQZXGUWPUWQVGYMXFU
      VBUWMYRTUWNUVNXKXSRZXMXOUWMUXCYMUVNUVBUWMUVRTYMUXDUVBUWMYMXKXSUUFUUKVOTYM
      XMUVBUWMUVSTYMXOUVBUWMUVTTUVDUWMVTABCDFHIJKMNOPWLWOYMXGUVBUWMUUQTIJKUWOLM
      PWPUPWHYMUWOYOJSZUVBUWMYMFYIJSZUXEUXBYMYQUWGUUAYTUXFUXEWQYSUWIUUOUUGYNHIJ
      FYIYGYPMNWRVIWNTWSXBYMUVBUEZRZYGEHUDZLYOJUXHUXILJSZUXILVKZYMUXJUXGYMYHELJ
      SZUXJUUTYMYNIJEYILYPMYSUWHUUOUURYMEEFGHUDZHUDZYIJYMYQUWFUXMYNQZEUXNJSYSUW
      HYMXFXSXTUXOYRUUKUUMAYNHIFGYPNOUOUPYNHIJEUXMYPMNXCUPYMYQUWFUWGUUIYIUXNVKY
      SUWHUWIUUNYNHIEFGYPNXDVIXAZUVAVMYMYQYTUWFUUPYHUXLRUXJVGYSUUGUWHUURYNHIJYG
      ELYPMNVHVIVJWAUXHXFUXIKQZXGUXJUXKVGYMXFUXGYRWAUXHUVNXKXRRZXMXOUXGUXQYMUVN
      UXGUVRWAYMUXRUXGYMXKXRUUFUUJVOWAYMXMUXGUVSWAYMXOUXGUVTWAYMUXGVTABCDEHIJKM
      NOPWLWOYMXGUXGUUQWAIJKUXILMPWPUPWHYMUXIYOJSZUXGYMEYIJSZUXSUXPYMYQUWFUUAYT
      UXTUXSWQYSUWHUUOUUGYNHIJEYIYGYPMNWRVIWNWAWSXBXE $.
  $}

  ${
    $d q r s t u v .\/ $.  $d q r s t u v K $.  $d q r s t u v .<_ $.
    $d q r s t u v V $.  $d q r s t u v P $.  $d q r s t u v X $.
    $d q r s t u v Y $.  $d q r s t u v W $.
    2lplnj.l $e |- .<_ = ( le ` K ) $.
    2lplnj.j $e |- .\/ = ( join ` K ) $.
    2lplnj.p $e |- P = ( LPlanes ` K ) $.
    2lplnj.v $e |- V = ( LVols ` K ) $.
    $( The join of two different lattice planes in a (3-dimensional) lattice
       volume equals the volume.  (Contributed by NM, 12-Jul-2012.) $)
    2lplnj $p |- ( ( K e. HL /\ ( X e. P /\ Y e. P /\ W e. V )
       /\ ( X .<_ W /\ Y .<_ W /\ X =/= Y ) ) -> ( X .\/ Y ) = W ) $=
      ( wcel w3a wbr cv co wrex wa 3ad2ant1 vq vr vs vt vu vv chlt wn wceq catm
      wne cfv cbs eqid islpln2 simpr syl6bi anim12d 3adantr3 3adant3 wi simpl33
      imp simp33 oveq12d simp11 simp123 jca adantr simp2rl simp2rr 3jca simpl31
      simp2l simpl32 simp1r simp2r simp31 simpl13 wb breq1 neeq1 3anbi13d neeq2
      simp32 3anbi23d syl2anc mpbid 2lplnja syl321anc eqtrd rexlimdvv rexlimdva
      sylan9bb 3exp expdimp imp3a mpd ) CUGMZGAMZHAMZFEMZNZGFDOZHFDOZGHUKZNZNZU
      APZUBPZUKZUCPZXIXJBQZDOUHZGXMXLBQZUIZNZUCCUJULZRUBXRRZUAXRRZUDPZUEPZUKZUF
      PZYAYBBQZDOUHZHYEYDBQZUIZNZUFXRRUEXRRZUDXRRZSZGHBQZFUIZWSXCYLXGWSWTXAYLXB
      WSWTXASYLWSWTXTXAYKWSWTGCUMULZMZXTSXTXRYOABCDGUCUBUAYOUNZIJXRUNZKUOYPXTUP
      UQWSXAHYOMZYKSYKXRYOABCDHUFUEUDYQIJYRKUOYSYKUPUQURVCUSUTXHXTYKYNXHXSYKYNV
      AZUAXRXHXIXRMZSXQYTUBUCXRXRXHUUAXJXRMZXLXRMZSZXQYTVAXHUUAUUDSZXQYTXHUUEXQ
      NZYJYNUDXRUUFYAXRMZSZYIYNUEUFXRXRUUHYBXRMZYDXRMZSZYIYNUUHUUKYINZYMXOYGBQZ
      FUULGXOHYGBUUHUUKXPYIXKXNXPXHUUEUUGVBTZUUHUUKYCYFYHVDZVEUULWSXBSZUUAUUBUU
      CNZXKXNSUUGUUIUUJNYCYFSXOFDOZYGFDOZXOYGUKZNZUUMFUIUUHUUKUUPYIUUFUUPUUGUUF
      WSXBWSXCXGUUEXQVFWTXAXBWSXGUUEXQVGVHVITUUHUUKUUQYIUUFUUQUUGUUFUUAUUBUUCXH
      UUAUUDXQVNUUBUUCUUAXHXQVJUUBUUCUUAXHXQVKVLVITUULXKXNUUHUUKXKYIXKXNXPXHUUE
      UUGVMTUUHUUKXNYIXKXNXPXHUUEUUGVOTVHUULUUGUUIUUJUUFUUGUUKYIVPUUHUUIUUJYIVN
      UUHUUIUUJYIVQVLUULYCYFUUHUUKYCYFYHVRUUHUUKYCYFYHWEVHUULXGUVAUUHUUKXGYIWSX
      CXGUUEXQUUGVSTUULXPYHXGUVAVTUUNUUOXPXGUURXEXOHUKZNYHUVAXPXDUURXFUVBXEGXOF
      DWAGXOHWBWCYHXEUUSUVBUUTUURHYGFDWAHYGXOWDWFWNWGWHXRXIXJXLYAYBYDBCDEFIJYRL
      WIWJWKWOWLWMWOWPWLWMWQWR $.
  $}

  ${
    2lplnm2.l $e |- .<_ = ( le ` K ) $.
    2lplnm2.m $e |- ./\ = ( meet ` K ) $.
    2lplnm2.a $e |- N = ( LLines ` K ) $.
    2lplnm2.p $e |- P = ( LPlanes ` K ) $.
    2lplnm2.v $e |- V = ( LVols ` K ) $.
    $( The meet of two different lattice planes in a lattice volume is a
       lattice line.  (Contributed by NM, 12-Jul-2012.)
       (New usage is discouraged.) $)
    2lplnm2N $p |- ( ( K e. HL /\ ( X e. P /\ Y e. P /\ W e. V )
       /\ ( X .<_ W /\ Y .<_ W /\ X =/= Y ) ) -> ( X ./\ Y ) e. N ) $=
      ( wcel w3a wbr cfv eqid syl3anc chlt wne co simp22 cbs ccvr wb simp1 clat
      hllat 3ad2ant1 simp21 lplnbase syl latmcl cjn 2lplnj eqeltrd lplncvrlvol2
      simp23 latlej1 syl31anc cvrexch mpbird llncvrlpln ) BUAOZHAOZIAOZGFOZPZHG
      CQIGCQHIUBPZPZHIDUCZEOZVHVFVGVHVIVKUDZVLVFVMBUERZOZIVPOZVMIBUFRZQZVNVHUGV
      FVJVKUHZVLBUIOZHVPOZVRVQVFVJWBVKBUJUKZVLVGWCVFVGVHVIVKULZVPABHVPSZMUMUNZV
      LVHVRVOVPABIWFMUMUNZVPBDHIWFKUOTWHVLVTHHIBUPRZUCZVSQZVLVFVGWJFOHWJCQZWKWA
      WEVLWJGFAWIBCFGHIJWISZMNUQVFVGVHVIVKUTURVLWBWCVRWLWDWGWHVPWIBCHIWFJWMVATV
      SABCFHWJJVSSZMNUSVBVLVFWCVRVTWKUGWAWGWHVPVSWIBDHIWFWMKWNVCTVDVPVSABEVMIWF
      WNLMVEVBVD $.
  $}

  ${
    2lplnmj.j $e |- .\/ = ( join ` K ) $.
    2lplnmj.m $e |- ./\ = ( meet ` K ) $.
    2lplnmj.n $e |- N = ( LLines ` K ) $.
    2lplnmj.p $e |- P = ( LPlanes ` K ) $.
    2lplnmj.v $e |- V = ( LVols ` K ) $.
    $( The meet of two lattice planes is a lattice line iff their join is a
       lattice volume.  (Contributed by NM, 13-Jul-2012.) $)
    2lplnmj $p |- ( ( K e. HL /\ X e. P /\ Y e. P )
      -> ( ( X ./\ Y ) e. N <-> ( X .\/ Y ) e. V ) ) $=
      ( wcel w3a cfv wbr wb wa syl3an chlt co ccvr simp1 eqid lplnbase 3ad2ant2
      cbs 3ad2ant3 cvrexch syl3anc cple simpl1 simpr simpl3 clat latmle2 adantr
      hllat llncvrlpln2 syl31anc latmcl llncvrlpln sylan mpbird impbida latlej1
      3jca simpl2 lplncvrlvol2 latjcl lplncvrlvol mpbid 3bitr4d ) CUANZGANZHANZ
      OZGHDUBZHCUCPZQZGGHBUBZVTQZVSENZWBFNZVRVOGCUHPZNZHWFNZWAWCRVOVPVQUDZVPVOW
      GVQWFACGWFUEZLUFZUGZVQVOWHVPWFACHWJLUFZUIZWFVTBCDGHWJIJVTUEZUJUKVRWDWAVRW
      DSVOWDVQVSHCULPZQZWAVOVPVQWDUMVRWDUNVOVPVQWDUOVRWQWDVOCUPNZVPWGVQWHWQCUSZ
      WKWMWFCWPDGHWJWPUEZJUQTURVTACWPEVSHWTWOKLUTVAVRWASWDVQVOVPVQWAUOVRVOVSWFN
      ZWHOWAWDVQRVRVOXAWHWIVOWRVPWGVQWHXAWSWKWMWFCDGHWJJVBTWNVHWFVTACEVSHWJWOKL
      VCVDVEVFVRWEWCVRWESVOVPWEGWBWPQZWCVOVPVQWEUMVOVPVQWEVIVRWEUNVRXBWEVOWRVPW
      GVQWHXBWSWKWMWFBCWPGHWJWTIVGTURVTACWPFGWBWTWOLMVJVAVRWCSVPWEVOVPVQWCVIVRV
      OWGWBWFNZOWCVPWERVRVOWGXCWIWLVOWRVPWGVQWHXCWSWKWMWFBCGHWJIVKTVHWFVTACFGWB
      WJWOLMVLVDVMVFVN $.
  $}

  ${
    dalema.ph $e |- ( ph <-> ( ( ( K e. HL /\ C e. ( Base ` K ) )
    /\ ( P e. A /\ Q e. A /\ R e. A )
    /\ ( S e. A /\ T e. A /\ U e. A ) )
 /\ ( Y e. O /\ Z e. O )
 /\ ( ( -. C .<_ ( P .\/ Q ) /\ -. C .<_ ( Q .\/ R )
         /\ -. C .<_ ( R .\/ P ) )
    /\ ( -. C .<_ ( S .\/ T ) /\ -. C .<_ ( T .\/ U )
          /\ -. C .<_ ( U .\/ S ) )
    /\ ( C .<_ ( P .\/ S ) /\ C .<_ ( Q .\/ T )
          /\ C .<_ ( R .\/ U ) ) ) ) ) $.
    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemkehl $p |- ( ph -> K e. HL ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp11l sylbi ) AKUAQZCKUBUCQZUDDBQE
      BQFBQRZGBQHBQIBQRZRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLTU
      ECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUHPUHUIUJUKULUMUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemkelat $p |- ( ph -> K e. Lat ) $=
      ( chlt wcel clat dalemkehl hllat syl ) AKQRKSRABCDEFGHIJKLMNOPTKUAUB $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemkeop $p |- ( ph -> K e. OP ) $=
      ( chlt wcel cops dalemkehl hlop syl ) AKQRKSRABCDEFGHIJKLMNOPTKUAUB $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalempea $p |- ( ph -> P e. A ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp121 sylbi ) AKUAQCKUBUCQUDZDBQZE
      BQZFBQZRGBQHBQIBQRZRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLT
      UECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUIPUIUJUKUHULUMUNUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemqea $p |- ( ph -> Q e. A ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp122 sylbi ) AKUAQCKUBUCQUDZDBQZE
      BQZFBQZRGBQHBQIBQRZRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLT
      UECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUJPUIUJUKUHULUMUNUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemrea $p |- ( ph -> R e. A ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp123 sylbi ) AKUAQCKUBUCQUDZDBQZE
      BQZFBQZRGBQHBQIBQRZRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLT
      UECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUKPUIUJUKUHULUMUNUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemsea $p |- ( ph -> S e. A ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp131 sylbi ) AKUAQCKUBUCQUDZDBQEB
      QFBQRZGBQZHBQZIBQZRRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLT
      UECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUJPUJUKULUHUIUMUNUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemtea $p |- ( ph -> T e. A ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp132 sylbi ) AKUAQCKUBUCQUDZDBQEB
      QFBQRZGBQZHBQZIBQZRRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLT
      UECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUKPUJUKULUHUIUMUNUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemuea $p |- ( ph -> U e. A ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp133 sylbi ) AKUAQCKUBUCQUDZDBQEB
      QFBQRZGBQZHBQZIBQZRRNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLT
      UECIGJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRULPUJUKULUHUIUMUNUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemyeo $p |- ( ph -> Y e. O ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp2l sylbi ) AKUAQCKUBUCQUDDBQEBQF
      BQRGBQHBQIBQRRZNMQZOMQZUDCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLTUECI
      GJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUIPUHUIUJUKUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemzeo $p |- ( ph -> Z e. O ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp2r sylbi ) AKUAQCKUBUCQUDDBQEBQF
      BQRGBQHBQIBQRRZNMQZOMQZUDCDEJSLTUECEFJSLTUECFDJSLTUERCGHJSLTUECHIJSLTUECI
      GJSLTUERCDGJSLTCEHJSLTCFIJSLTRRZRUJPUHUIUJUKUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemclpjs $p |- ( ph -> C .<_ ( P .\/ S ) ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp331 sylbi ) AKUAQCKUBUCQUDDBQEBQ
      FBQRGBQHBQIBQRRZNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERZCGHJSLTUECHIJSLTUEC
      IGJSLTUERZCDGJSLTZCEHJSLTZCFIJSLTZRRRULPULUMUNUJUKUHUIUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemclqjt $p |- ( ph -> C .<_ ( Q .\/ T ) ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp332 sylbi ) AKUAQCKUBUCQUDDBQEBQ
      FBQRGBQHBQIBQRRZNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERZCGHJSLTUECHIJSLTUEC
      IGJSLTUERZCDGJSLTZCEHJSLTZCFIJSLTZRRRUMPULUMUNUJUKUHUIUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemclrju $p |- ( ph -> C .<_ ( R .\/ U ) ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp333 sylbi ) AKUAQCKUBUCQUDDBQEBQ
      FBQRGBQHBQIBQRRZNMQOMQUDZCDEJSLTUECEFJSLTUECFDJSLTUERZCGHJSLTUECHIJSLTUEC
      IGJSLTUERZCDGJSLTZCEHJSLTZCFIJSLTZRRRUNPULUMUNUJUKUHUIUFUG $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalem-clpjq $p |- ( ph -> -. C .<_ ( P .\/ Q ) ) $=
      ( wcel w3a co wbr chlt cbs cfv wa wn simp311 sylbi ) AKUAQCKUBUCQUDDBQEBQ
      FBQRGBQHBQIBQRRZNMQOMQUDZCDEJSLTUEZCEFJSLTUEZCFDJSLTUEZRCGHJSLTUECHIJSLTU
      ECIGJSLTUERZCDGJSLTCEHJSLTCFIJSLTRZRRUJPUJUKULUMUNUHUIUFUG $.

    ${
      dalema.a $e |- A = ( Atoms ` K ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemceb $p |- ( ph -> C e. ( Base ` K ) ) $=
        ( wcel co wbr chlt cbs cfv wa w3a wn simp11r sylbi ) AKUARZCKUBUCRZUDDB
        REBRFBRUEZGBRHBRIBRUEZUENMROMRUDZCDEJSLTUFCEFJSLTUFCFDJSLTUFUECGHJSLTUF
        CHIJSLTUFCIGJSLTUFUECDGJSLTCEHJSLTCFIJSLTUEUEZUEUJPUIUJUKULUMUNUGUH $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalempeb $p |- ( ph -> P e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalempea eqid atbase syl ) ADBRDKSTZRABCDEFGHIJKLMNOPUAB
        UEDKUEUBQUCUD $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemqeb $p |- ( ph -> Q e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalemqea eqid atbase syl ) AEBREKSTZRABCDEFGHIJKLMNOPUAB
        UEEKUEUBQUCUD $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemreb $p |- ( ph -> R e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalemrea eqid atbase syl ) AFBRFKSTZRABCDEFGHIJKLMNOPUAB
        UEFKUEUBQUCUD $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemseb $p |- ( ph -> S e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalemsea eqid atbase syl ) AGBRGKSTZRABCDEFGHIJKLMNOPUAB
        UEGKUEUBQUCUD $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemteb $p |- ( ph -> T e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalemtea eqid atbase syl ) AHBRHKSTZRABCDEFGHIJKLMNOPUAB
        UEHKUEUBQUCUD $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemueb $p |- ( ph -> U e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalemuea eqid atbase syl ) AIBRIKSTZRABCDEFGHIJKLMNOPUAB
        UEIKUEUBQUCUD $.
    $}

    ${
      dalemb.j $e |- .\/ = ( join ` K ) $.
      dalemb.a $e |- A = ( Atoms ` K ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalempjqeb $p |- ( ph -> ( P .\/ Q ) e. ( Base ` K ) ) $=
        ( chlt wcel co cbs cfv dalemkehl dalempea dalemqea eqid hlatjcl syl3anc
        ) AKSTDBTEBTDEJUAKUBUCZTABCDEFGHIJKLMNOPUDABCDEFGHIJKLMNOPUEABCDEFGHIJK
        LMNOPUFBUJJKDEUJUGQRUHUI $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemsjteb $p |- ( ph -> ( S .\/ T ) e. ( Base ` K ) ) $=
        ( chlt wcel co cbs cfv dalemkehl dalemsea dalemtea eqid hlatjcl syl3anc
        ) AKSTGBTHBTGHJUAKUBUCZTABCDEFGHIJKLMNOPUDABCDEFGHIJKLMNOPUEABCDEFGHIJK
        LMNOPUFBUJJKGHUJUGQRUHUI $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemtjueb $p |- ( ph -> ( T .\/ U ) e. ( Base ` K ) ) $=
        ( chlt wcel co cbs cfv dalemkehl dalemtea dalemuea eqid hlatjcl syl3anc
        ) AKSTHBTIBTHIJUAKUBUCZTABCDEFGHIJKLMNOPUDABCDEFGHIJKLMNOPUEABCDEFGHIJK
        LMNOPUFBUJJKHIUJUGQRUHUI $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemqrprot $p |- ( ph
  -> ( ( Q .\/ R ) .\/ P ) = ( ( P .\/ Q ) .\/ R ) ) $=
        ( wcel co chlt dalemkehl dalemqea dalemrea dalempea hlatjrot syl13anc
        wceq ) AKUASEBSFBSDBSEFJTDJTDEJTFJTUHABCDEFGHIJKLMNOPUBABCDEFGHIJKLMNOP
        UCABCDEFGHIJKLMNOPUDABCDEFGHIJKLMNOPUEBEFDJKQRUFUG $.
    $}

    ${
      dalemyeb.o $e |- O = ( LPlanes ` K ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemyeb $p |- ( ph -> Y e. ( Base ` K ) ) $=
        ( wcel cbs cfv dalemyeo eqid lplnbase syl ) ANMRNKSTZRABCDEFGHIJKLMNOPU
        AUEMKNUEUBQUCUD $.
    $}

    dalemc.l $e |- .<_ = ( le ` K ) $.
    dalemc.j $e |- .\/ = ( join ` K ) $.
    dalemc.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       13-Aug-2012.) $)
    dalemcnes $p |- ( ph -> C =/= S ) $=
      ( wcel clat cbs cfv co wbr wne dalemkelat dalemceb dalemseb dalemteb chlt
      wn wa w3a simp321 sylbi eqid latnlej1l syl131anc ) AKUATCKUBUCZTZGUTTHUTT
      CGHJUDLUEULZCGUFABCDEFGHIJKLMNOPUGABCDEFGHIJKLMNOPSUHABCDEFGHIJKLMNOPSUIA
      BCDEFGHIJKLMNOPSUJAKUKTVAUMDBTEBTFBTUNGBTHBTIBTUNUNZNMTOMTUMZCDEJUDLUEULC
      EFJUDLUEULCFDJUDLUEULUNZVBCHIJUDLUEULZCIGJUDLUEULZUNCDGJUDLUECEHJUDLUECFI
      JUDLUEUNZUNUNVBPVBVFVGVEVHVCVDUOUPUTJKLCGHUTUQQRURUS $.

    ${
      dalempnes.o $e |- O = ( LPlanes ` K ) $.
      dalempnes.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalempnes $p |- ( ph -> P =/= S ) $=
        ( wbr wn wne clat wcel cbs cfv co dalemkelat dalemceb dalemseb dalemteb
        chlt w3a simp321 sylbi eqid latnlej2l syl131anc dalemclpjs oveq1 breq2d
        wceq syl5ibcom dalemkehl dalemsea hlatjidm syl2anc sylibd necon3bd mpd
        wa ) ACGLUBZUCZDGUDAKUEUFCKUGUHZUFZGVPUFHVPUFCGHJUILUBUCZVOABCDEFGHIJKL
        MNOPUJABCDEFGHIJKLMNOPSUKABCDEFGHIJKLMNOPSULABCDEFGHIJKLMNOPSUMAKUNUFZV
        QVMDBUFEBUFFBUFUOGBUFZHBUFIBUFUOUOZNMUFOMUFVMZCDEJUILUBUCCEFJUILUBUCCFD
        JUILUBUCUOZVRCHIJUILUBUCZCIGJUILUBUCZUOCDGJUIZLUBZCEHJUILUBCFIJUILUBUOZ
        UOUOVRPVRWDWEWCWHWAWBUPUQVPJKLCGHVPURQRUSUTAVNDGADGVDZCGGJUIZLUBZVNAWGW
        IWKABCDEFGHIJKLMNOPVAWIWFWJCLDGGJVBVCVEAWJGCLAVSVTWJGVDABCDEFGHIJKLMNOP
        VFABCDEFGHIJKLMNOPVGBJKGRSVHVIVCVJVKVL $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemqnet $p |- ( ph -> Q =/= T ) $=
        ( wbr wn wne clat wcel cbs cfv co dalemkelat dalemceb dalemteb dalemueb
        chlt w3a simp322 sylbi eqid latnlej2l syl131anc dalemclqjt oveq1 breq2d
        wceq syl5ibcom dalemkehl dalemtea hlatjidm syl2anc sylibd necon3bd mpd
        wa ) ACHLUBZUCZEHUDAKUEUFCKUGUHZUFZHVPUFIVPUFCHIJUILUBUCZVOABCDEFGHIJKL
        MNOPUJABCDEFGHIJKLMNOPSUKABCDEFGHIJKLMNOPSULABCDEFGHIJKLMNOPSUMAKUNUFZV
        QVMDBUFEBUFFBUFUOGBUFHBUFZIBUFUOUOZNMUFOMUFVMZCDEJUILUBUCCEFJUILUBUCCFD
        JUILUBUCUOZCGHJUILUBUCZVRCIGJUILUBUCZUOCDGJUILUBCEHJUIZLUBZCFIJUILUBUOZ
        UOUOVRPWDVRWEWCWHWAWBUPUQVPJKLCHIVPURQRUSUTAVNEHAEHVDZCHHJUIZLUBZVNAWGW
        IWKABCDEFGHIJKLMNOPVAWIWFWJCLEHHJVBVCVEAWJHCLAVSVTWJHVDABCDEFGHIJKLMNOP
        VFABCDEFGHIJKLMNOPVGBJKHRSVHVIVCVJVKVL $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalempjsen $p |- ( ph -> ( P .\/ S ) e. ( LLines ` K ) ) $=
        ( chlt wcel wne co clln cfv dalemkehl dalempea dalemsea dalempnes llni2
        eqid syl31anc ) AKUBUCDBUCGBUCDGUDDGJUEKUFUGZUCABCDEFGHIJKLMNOPUHABCDEF
        GHIJKLMNOPUIABCDEFGHIJKLMNOPUJABCDEFGHIJKLMNOPQRSTUAUKBDGJKUORSUOUMULUN
        $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 13-Aug-2012.) $)
      dalemply $p |- ( ph -> P .<_ Y ) $=
        ( clat wcel cbs cfv wbr dalemkelat dalempeb dalemkehl dalemqea dalemrea
        chlt eqid hlatjcl syl3anc dalempea hlatjass syl13anc breqtrrd syl6breqr
        co latlej1 wceq ) ADDEJVAFJVAZNLADDEFJVAZJVAZVDLAKUBUCDKUDUEZUCVEVGUCZD
        VFLUFABCDEFGHIJKLMNOPUGABCDEFGHIJKLMNOPSUHAKULUCZEBUCZFBUCZVHABCDEFGHIJ
        KLMNOPUIZABCDEFGHIJKLMNOPUJZABCDEFGHIJKLMNOPUKZBVGJKEFVGUMZRSUNUOVGJKLD
        VEVOQRVBUOAVIDBUCVJVKVDVFVCVLABCDEFGHIJKLMNOPUPVMVNBDEFJKRSUQURUSUAUT
        $.
    $}

    ${
      dalemsly.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 15-Aug-2012.) $)
      dalemsly $p |- ( ( ph /\ Y = Z ) -> S .<_ Y ) $=
        ( wceq wa wbr clat wcel cbs dalemkelat dalemseb dalemtjueb eqid latlej1
        cfv syl3anc chlt dalemkehl dalemsea dalemtea dalemuea hlatjass syl13anc
        co breqtrrd syl6breqr adantr simpr ) ANOUAZUBGONLAGOLUCVFAGGHJVAIJVAZOL
        AGGHIJVAZJVAZVGLAKUDUEGKUFULZUEVHVJUEGVILUCABCDEFGHIJKLMNOPUGABCDEFGHIJ
        KLMNOPSUHABCDEFGHIJKLMNOPRSUIVJJKLGVHVJUJQRUKUMAKUNUEGBUEHBUEIBUEVGVIUA
        ABCDEFGHIJKLMNOPUOABCDEFGHIJKLMNOPUPABCDEFGHIJKLMNOPUQABCDEFGHIJKLMNOPU
        RBGHIJKRSUSUTVBTVCVDAVFVEVB $.
    $}

    $( Lemma for ~ dath .  Swap the role of planes ` Y ` and ` Z ` to allow
       reuse of analogous proofs.  (Contributed by NM, 14-Aug-2012.) $)
    dalemswapyz $p |- ( ph -> ( ( ( K e. HL /\ C e. ( Base ` K ) )
  /\ ( S e. A /\ T e. A /\ U e. A ) /\ ( P e. A /\ Q e. A /\ R e. A ) )
 /\ ( Z e. O /\ Y e. O ) /\ ( ( -. C .<_ ( S .\/ T )
       /\ -. C .<_ ( T .\/ U )
    /\ -. C .<_ ( U .\/ S ) ) /\ ( -. C .<_ ( P .\/ Q )
        /\ -. C .<_ ( Q .\/ R )
    /\ -. C .<_ ( R .\/ P ) ) /\ ( C .<_ ( S .\/ P )
    /\ C .<_ ( T .\/ Q ) /\ C .<_ ( U .\/ R ) ) ) ) ) $=
      ( w3a chlt wcel cbs cfv wa co wbr simp11 simp13 simp12 3jca ancomd simp32
      simp2 simp31 dalemclpjs wceq dalemkehl dalempea dalemsea hlatjcom syl3anc
      wn dalemclqjt dalemqea dalemtea dalemclrju dalemrea dalemuea sylbir sylbi
      breqtrd ) AKUAUBZCKUCUDUBUEZDBUBZEBUBZFBUBZTZGBUBZHBUBZIBUBZTZTZNMUBZOMUB
      ZUEZCDEJUFLUGVCCEFJUFLUGVCCFDJUFLUGVCTZCGHJUFLUGVCCHIJUFLUGVCCIGJUFLUGVCT
      ZCDGJUFZLUGCEHJUFZLUGCFIJUFZLUGTZTZTZVNWBVRTZWEWDUEZWHWGCGDJUFZLUGZCHEJUF
      ZLUGZCIFJUFZLUGZTZTZTPWNWOWPXDWNVNWBVRVNVRWBWFWMUHVNVRWBWFWMUIVNVRWBWFWMU
      JUKWNWDWEWCWFWMUNULWNWHWGXCWCWFWGWHWLUMWCWFWGWHWLUOWNAXCPAWRWTXBACWIWQLAB
      CDEFGHIJKLMNOPUPAVMVOVSWIWQUQABCDEFGHIJKLMNOPURZABCDEFGHIJKLMNOPUSABCDEFG
      HIJKLMNOPUTBJKDGRSVAVBVLACWJWSLABCDEFGHIJKLMNOPVDAVMVPVTWJWSUQXEABCDEFGHI
      JKLMNOPVEABCDEFGHIJKLMNOPVFBJKEHRSVAVBVLACWKXALABCDEFGHIJKLMNOPVGAVMVQWAW
      KXAUQXEABCDEFGHIJKLMNOPVHABCDEFGHIJKLMNOPVIBJKFIRSVAVBVLUKVJUKUKVK $.

    ${
      dalemrot.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalemrot.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  Rotate triangles ` Y = P Q R ` and ` Z = S T U `
         to allow reuse of analogous proofs.  (Contributed by NM,
         14-Aug-2012.) $)
      dalemrot $p |- ( ph -> ( ( ( K e. HL /\ C e. ( Base ` K ) )
    /\ ( Q e. A /\ R e. A /\ P e. A ) /\ ( T e. A /\ U e. A /\ S e. A ) )
  /\ ( ( ( Q .\/ R ) .\/ P ) e. O /\ ( ( T .\/ U ) .\/ S ) e. O )
  /\ ( ( -. C .<_ ( Q .\/ R ) /\ -. C .<_ ( R .\/ P )
       /\ -. C .<_ ( P .\/ Q ) )
    /\ ( -. C .<_ ( T .\/ U ) /\ -. C .<_ ( U .\/ S )
        /\ -. C .<_ ( S .\/ T ) )
    /\ ( C .<_ ( Q .\/ T ) /\ C .<_ ( R .\/ U )
        /\ C .<_ ( P .\/ S ) ) ) ) ) $=
        ( chlt wcel cbs cfv wa w3a wbr dalemkehl dalemceb jca dalemqea dalemrea
        dalempea 3jca dalemtea dalemuea dalemsea dalemqrprot dalemyeo syl5eqelr
        co wn eqeltrd wceq hlatjrot syl13anc dalemzeo simp312 sylbi dalem-clpjq
        simp313 simp322 simp323 simp321 dalemclqjt dalemclrju dalemclpjs ) AKUB
        UCZCKUDUEUCZUFZEBUCZFBUCZDBUCZUGZHBUCZIBUCZGBUCZUGZUGEFJVBZDJVBZMUCZHIJ
        VBZGJVBZMUCZUFCWJLUHVCZCFDJVBLUHVCZCDEJVBZLUHVCZUGZCWMLUHVCZCIGJVBLUHVC
        ZCGHJVBZLUHVCZUGZCEHJVBLUHZCFIJVBLUHZCDGJVBLUHZUGZUGAWAWEWIAVSVTABCDEFG
        HIJKLMNOPUIZABCDEFGHIJKLMNOPSUJUKAWBWCWDABCDEFGHIJKLMNOPULABCDEFGHIJKLM
        NOPUMABCDEFGHIJKLMNOPUNUOAWFWGWHABCDEFGHIJKLMNOPUPZABCDEFGHIJKLMNOPUQZA
        BCDEFGHIJKLMNOPURZUOUOAWLWOAWKWRFJVBZMABCDEFGHIJKLMNOPRSUSAXNNMTABCDEFG
        HIJKLMNOPUTVAVDAWNXCIJVBZMAVSWFWGWHWNXOVEXJXKXLXMBHIGJKRSVFVGAXOOMUAABC
        DEFGHIJKLMNOPVHVAVDUKAWTXEXIAWPWQWSAWAWDWBWCUGWHWFWGUGUGZNMUCOMUCUFZWSW
        PWQUGZXDXAXBUGZXHXFXGUGZUGUGZWPPWSWPWQXSXTXPXQVIVJAYAWQPWSWPWQXSXTXPXQV
        LVJABCDEFGHIJKLMNOPVKUOAXAXBXDAYAXAPXDXAXBXRXTXPXQVMVJAYAXBPXDXAXBXRXTX
        PXQVNVJAYAXDPXDXAXBXRXTXPXQVOVJUOAXFXGXHABCDEFGHIJKLMNOPVPABCDEFGHIJKLM
        NOPVQABCDEFGHIJKLMNOPVRUOUOUO $.

      $( Lemma for ~ dath .  Rotate triangles ` Y = P Q R ` and ` Z = S T U `
         to allow reuse of analogous proofs.  (Contributed by NM,
         19-Aug-2012.) $)
      dalemrotyz $p |- ( ( ph /\ Y = Z )
            -> ( ( Q .\/ R ) .\/ P ) = ( ( T .\/ U ) .\/ S ) ) $=
        ( wceq wa simpr dalemqrprot syl6reqr adantr chlt wcel dalemtea dalemuea
        co dalemkehl dalemsea hlatjrot syl13anc 3eqtr3d ) ANOUBZUCNOEFJULDJULZH
        IJULGJULZAURUDANUSUBURAUSDEJULFJULNABCDEFGHIJKLMNOPRSUETUFUGAOUTUBURAUT
        GHJULIJULZOAKUHUIHBUIIBUIGBUIUTVAUBABCDEFGHIJKLMNOPUMABCDEFGHIJKLMNOPUJ
        ABCDEFGHIJKLMNOPUKABCDEFGHIJKLMNOPUNBHIGJKRSUOUPUAUFUGUQ $.
    $}

    ${
      dalem1.o $e |- O = ( LPlanes ` K ) $.
      dalem1.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      $( Lemma for ~ dath .  Show the lines ` P S ` and ` Q T ` are different.
         (Contributed by NM, 9-Aug-2012.) $)
      dalem1 $p |- ( ph -> ( P .\/ S ) =/= ( Q .\/ T ) ) $=
        ( co wbr wne dalemclpjs wceq dalem-clpjq adantr chlt dalemkehl dalempea
        wn wcel dalemsea hlatlej1 syl3anc dalemqea dalemtea simpr breqtrrd clat
        wa cbs cfv dalemkelat dalempeb dalemqeb eqid latjle12 syl13anc mpbi2and
        hlatjcl dalemrea dalemyeo lplnri1 syl131anc ps-1 syl132anc mpbid breq2d
        wb mtbid ex necon2ad mpd ) ACDGJUBZLUCZWFEHJUBZUDABCDEFGHIJKLMNOPUEAWGW
        FWHAWFWHUFZWGULAWIVBZCDEJUBZLUCZWGAWLULWIABCDEFGHIJKLMNOPUGUHWJWKWFCLWJ
        WKWFLUCZWKWFUFZWJDWFLUCZEWFLUCZWMAWOWIAKUIUMZDBUMZGBUMZWOABCDEFGHIJKLMN
        OPUJZABCDEFGHIJKLMNOPUKZABCDEFGHIJKLMNOPUNZBDGJKLQRSUOUPUHWJEWHWFLAEWHL
        UCZWIAWQEBUMZHBUMXCWTABCDEFGHIJKLMNOPUQZABCDEFGHIJKLMNOPURBEHJKLQRSUOUP
        UHAWIUSUTAWOWPVBWMWAZWIAKVAUMDKVCVDZUMEXGUMWFXGUMZXFABCDEFGHIJKLMNOPVEA
        BCDEFGHIJKLMNOPSVFABCDEFGHIJKLMNOPSVGAWQWRWSXHWTXAXBBXGJKDGXGVHZRSVLUPX
        GJKLDEWFXIQRVIVJUHVKAWMWNWAZWIAWQWRXDDEUDZWRWSXJWTXAXEAWQWRXDFBUMNMUMXK
        WTXAXEABCDEFGHIJKLMNOPVMABCDEFGHIJKLMNOPVNBMDEFJKNRSTUAVOVPXAXBBDEDGJKL
        QRSVQVRUHVSVTWBWCWDWE $.

      $( Lemma for ~ dath .  Frequently-used utility lemma.  Here we show that
         ` C ` must be an atom.  This is an assumption in most presentations of
         Desargue's theorem; instead, we assume only the ` C ` is a lattice
         element, in order to make later substitutions for ` C ` easier.
         (Contributed by NM, 23-Sep-2012.) $)
      dalemcea $p |- ( ph -> C e. A ) $=
        ( cmee cfv cops wcel cbs cp0 wne wceq dalemkeop dalemceb chlt dalemkehl
        co wbr clln dalempjsen dalemqea dalemtea dalemqnet eqid syl31anc dalem1
        llni2 wn dalem-clpjq dalempjqeb op0le syl2anc breq1 syl5ibrcom necon3bd
        cplt wb opltn0 mpbird dalemclpjs dalemclqjt clat wa dalemkelat dalempea
        mpd dalemsea hlatjcl syl3anc latlem12 syl13anc mpbi2and cpo opposet syl
        wi op0cl latmcl pltletr mp2and mpbid 2llnmat syl32anc leat2 eqeltrd ) A
        CDGJUNZEHJUNZKUBUCZUNZBAKUDUEZCKUFUCZUEZXFBUEZCKUGUCZUHZCXFLUOZCXFUIABC
        DEFGHIJKLMNOPUJZABCDEFGHIJKLMNOPSUKZAKULUEZXCKUPUCZUEXDXQUEZXCXDUHXFXKU
        HZXJABCDEFGHIJKLMNOPUMZABCDEFGHIJKLMNOPQRSTUAUQAXPEBUEZHBUEZEHUHXRXTABC
        DEFGHIJKLMNOPURZABCDEFGHIJKLMNOPUSZABCDEFGHIJKLMNOPQRSTUAUTBEHJKXQRSXQV
        AZVDVBABCDEFGHIJKLMNOPQRSTUAVCAXKXFKVMUCZUOZXSAXKCYFUOZXMYGAYHXLACDEJUN
        ZLUOZVEXLABCDEFGHIJKLMNOPVFAYJCXKAYJCXKUIXKYILUOZAXGYIXHUEYKXNABCDEFGHI
        JKLMNOPRSVGXHKLYIXKXHVAZQXKVAZVHVICXKYILVJVKVLWCZAXGXIYHXLVNXNXOXHYFKCX
        KYLYFVAZYMVOVIVPACXCLUOZCXDLUOZXMABCDEFGHIJKLMNOPVQABCDEFGHIJKLMNOPVRAK
        VSUEZXIXCXHUEZXDXHUEZYPYQVTXMVNABCDEFGHIJKLMNOPWAZXOAXPDBUEGBUEYSXTABCD
        EFGHIJKLMNOPWBABCDEFGHIJKLMNOPWDBXHJKDGYLRSWEWFZAXPYAYBYTXTYCYDBXHJKEHY
        LRSWEWFZXHKLXECXCXDYLQXEVAZWGWHWIZAKWJUEZXKXHUEZXIXFXHUEZYHXMVTYGWMAXGU
        UFXNKWKWLAXGUUGXNXHKXKYLYMWNWLXOAYRYSYTUUHUUAUUBUUCXHKXEXCXDYLUUDWOWFZX
        HYFKLXKCXFYLQYOWPWHWQAXGUUHYGXSVNXNUUIXHYFKXFXKYLYOYMVOVIWRBKXEXQXCXDXK
        UUDYMSYEWSWTZYNUUEBXHXFKLCXKYLQYMSXAWTUUJXB $.

      $( Lemma for ~ dath .  Show the lines ` P Q ` and ` S T ` form a plane.
         (Contributed by NM, 11-Aug-2012.) $)
      dalem2 $p |- ( ph -> ( ( P .\/ Q ) .\/ ( S .\/ T ) ) e. O ) $=
        ( co chlt wcel wceq dalemkehl dalempea dalemqea dalemsea syl122anc cmee
        dalemtea hlatj4 cfv clln wne cp0 dalempjsen dalemqnet eqid llni2 dalem1
        syl31anc wbr dalemcea dalemclpjs dalemclqjt 2llnm4 syl132anc 2llnmat wb
        syl32anc 2llnmj syl3anc mpbid eqeltrd ) ADEJUBGHJUBJUBZDGJUBZEHJUBZJUBZ
        MAKUCUDZDBUDEBUDZGBUDHBUDZVQVTUEABCDEFGHIJKLMNOPUFZABCDEFGHIJKLMNOPUGAB
        CDEFGHIJKLMNOPUHZABCDEFGHIJKLMNOPUIABCDEFGHIJKLMNOPULZBDEGHJKRSUMUJAVRV
        SKUKUNZUBZBUDZVTMUDZAWAVRKUOUNZUDZVSWKUDZVRVSUPWHKUQUNZUPZWIWDABCDEFGHI
        JKLMNOPQRSTUAURZAWAWBWCEHUPWMWDWEWFABCDEFGHIJKLMNOPQRSTUAUSBEHJKWKRSWKU
        TZVAVCZABCDEFGHIJKLMNOPQRSTUAVBAWACBUDWLWMCVRLVDCVSLVDWOWDABCDEFGHIJKLM
        NOPQRSTUAVEWPWRABCDEFGHIJKLMNOPVFABCDEFGHIJKLMNOPVGBCKLWGWKVRVSWNQWGUTZ
        WNUTZSWQVHVIBKWGWKVRVSWNWSWTSWQVJVLAWAWLWMWIWJVKWDWPWRBMJKWGWKVRVSRWSSW
        QTVMVNVOVP $.
    $}

    ${
      dalemdea.m $e |- ./\ = ( meet ` K ) $.
      dalemdea.o $e |- O = ( LPlanes ` K ) $.
      dalemdea.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalemdea.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalemdea.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 11-Aug-2012.) $)
      dalemdea $p |- ( ph -> D e. A ) $=
        ( co wcel dalem2 chlt clln cfv dalemkehl wne dalempea dalemqea dalemrea
        wb dalemyeo lplnri1 syl131anc llni2 syl31anc dalemsea dalemtea dalemuea
        eqid dalemzeo 2llnmj syl3anc mpbird syl5eqel ) ADEFKUGZHIKUGZNUGZBUFAVO
        BUHZVMVNKUGOUHZABCEFGHIJKLMOPQRSTUAUCUDUIALUJUHZVMLUKULZUHZVNVSUHZVPVQU
        RABCEFGHIJKLMOPQRUMZAVREBUHZFBUHZEFUNZVTWBABCEFGHIJKLMOPQRUOZABCEFGHIJK
        LMOPQRUPZAVRWCWDGBUHPOUHWEWBWFWGABCEFGHIJKLMOPQRUQABCEFGHIJKLMOPQRUSBOE
        FGKLPTUAUCUDUTVABEFKLVSTUAVSVGZVBVCAVRHBUHZIBUHZHIUNZWAWBABCEFGHIJKLMOP
        QRVDZABCEFGHIJKLMOPQRVEZAVRWIWJJBUHQOUHWKWBWLWMABCEFGHIJKLMOPQRVFABCEFG
        HIJKLMOPQRVHBOHIJKLQTUAUCUEUTVABHIKLVSTUAWHVBVCBOKLNVSVMVNTUBUAWHUCVIVJ
        VKVL $.
    $}

    ${
      dalemeea.m $e |- ./\ = ( meet ` K ) $.
      dalemeea.o $e |- O = ( LPlanes ` K ) $.
      dalemeea.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalemeea.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalemeea.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 11-Aug-2012.) $)
      dalemeea $p |- ( ph -> E e. A ) $=
        ( chlt wcel cbs cfv wa w3a co wbr wn dalemrot biid eqid dalemdea syl )
        ALUGUHCLUIUJUHUKEBUHFBUHDBUHULHBUHIBUHGBUHULULEFKUMZDKUMZOUHHIKUMZGKUMZ
        OUHUKCVAMUNUOCFDKUMMUNUOCDEKUMMUNUOULCVCMUNUOCIGKUMMUNUOCGHKUMMUNUOULCE
        HKUMMUNCFIKUMMUNCDGKUMMUNULULULZJBUHABCDEFGHIKLMOPQRSTUAUDUEUPVEBCJEFDH
        IGKLMNOVBVDVEUQSTUAUBUCVBURVDURUFUSUT $.
    $}

    ${
      dalem3.m $e |- ./\ = ( meet ` K ) $.
      dalem3.o $e |- O = ( LPlanes ` K ) $.
      dalem3.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem3.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem3.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      dalem3.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      $( Lemma for ~ dalemdnee .  (Contributed by NM, 10-Aug-2012.) $)
      dalem3 $p |- ( ( ph /\ D =/= Q ) -> D =/= E ) $=
        ( wne wa co wbr chlt wcel dalemkehl dalempea dalemqea dalemrea dalemyeo
        wn lplnric syl131anc adantr wceq wi clat cbs dalemkelat hlatjcl syl3anc
        cfv eqid dalemtjueb latmle1 syl5eqbr breq1 syl5ibrcom dalemdea hlatlej2
        simpr hlatexch1 dalempjqeb dalemsjteb dalemqeb atbase latjle12 syl13anc
        wb syl mpbi2and dalemreb lattr mpan2d 3syld necon3bd mpd ) ADFUIZUJZGEF
        LUKZNULZUTZDKUIAXAWQAMUMUNZEBUNZFBUNZGBUNZQPUNXAABCEFGHIJLMNPQRSUOZABCE
        FGHIJLMNPQRSUPZABCEFGHIJLMNPQRSUQZABCEFGHIJLMNPQRSURZABCEFGHIJLMNPQRSUS
        BPEFGLMNQTUAUBUDUEVAVBVCWRWTDKWRDKVDZDFGLUKZNULZGFDLUKZNULZWTAXJXLVEWQA
        XLXJKXKNULAKXKIJLUKZOUKZXKNUHAMVFUNZXKMVGVKZUNZXOXRUNXPXKNULABCEFGHIJLM
        NPQRSVHZAXBXDXEXSXFXHXIBXRLMFGXRVLZUAUBVIVJABCEFGHIJLMNPQRSUAUBVMXRMNOX
        KXOYATUCVNVJVODKXKNVPVQVCWRXBDBUNZXEXDWQXLXNVEAXBWQXFVCAYBWQABCDEFGHIJL
        MNOPQRSTUAUBUCUDUEUFUGVRZVCAXEWQXIVCAXDWQXHVCAWQVTBDGFLMNTUAUBWAVBAXNWT
        VEWQAXNXMWSNULZWTAFWSNULZDWSNULZYDAXBXCXDYEXFXGXHBEFLMNTUAUBVSVJADWSHIL
        UKZOUKZWSNUGAXQWSXRUNZYGXRUNYHWSNULXTABCEFGHIJLMNPQRSUAUBWBZABCEFGHIJLM
        NPQRSUAUBWCXRMNOWSYGYATUCVNVJVOAXQFXRUNDXRUNZYIYEYFUJYDWHXTABCEFGHIJLMN
        PQRSUBWDAYBYKYCBXRDMYAUBWEWIYJXRLMNFDWSYATUAWFWGWJAXQGXRUNXMXRUNZYIXNYD
        UJWTVEXTABCEFGHIJLMNPQRSUBWKAXBXDYBYLXFXHYCBXRLMFDYAUAUBVIVJYJXRMNGXMWS
        YATWLWGWMVCWNWOWP $.

      $( Lemma for ~ dalemdnee .  (Contributed by NM, 10-Aug-2012.) $)
      dalem4 $p |- ( ( ph /\ D =/= T ) -> D =/= E ) $=
        ( wne wa co chlt wcel cbs cfv w3a wn dalemswapyz adantr clat dalemkelat
        wbr wceq dalempjqeb dalemsjteb eqid latmcom syl5eq neeq1d biimpa dalem3
        syl3anc syl2anc dalemkehl dalemqea dalemrea hlatjcl dalemtjueb 3netr4d
        biid ) ADIUIZUJZHILUKZEFLUKZOUKZIJLUKZFGLUKZOUKZDKWBMULUMZCMUNUOZUMUJHB
        UMIBUMJBUMUPEBUMFBUMZGBUMZUPUPRPUMQPUMUJCWCNVBUQCWFNVBUQCJHLUKNVBUQUPCW
        DNVBUQCWGNVBUQCGELUKNVBUQUPCHELUKNVBCIFLUKNVBCJGLUKNVBUPUPUPZWEIUIZWEWH
        UIAWMWAABCEFGHIJLMNPQRSTUAUBURUSAWAWNADWEIADWDWCOUKZWEUGAMUTUMZWDWJUMWC
        WJUMWOWEVCABCEFGHIJLMNPQRSVAZABCEFGHIJLMNPQRSUAUBVDABCEFGHIJLMNPQRSUAUB
        VEWJMOWDWCWJVFZUCVGVLVHZVIVJWMBCWEHIJEFGWHLMNOPRQWMVTTUAUBUCUDUFUEWEVFW
        HVFVKVMADWEVCWAWSUSAKWHVCWAAKWGWFOUKZWHUHAWPWGWJUMZWFWJUMWTWHVCWQAWIWKW
        LXAABCEFGHIJLMNPQRSVNABCEFGHIJLMNPQRSVOABCEFGHIJLMNPQRSVPBWJLMFGWRUAUBV
        QVLABCEFGHIJLMNPQRSUAUBVRWJMOWGWFWRUCVGVLVHUSVS $.

      $( Lemma for ~ dath .  Axis of perspectivity points ` D ` and ` E ` are
         different.  (Contributed by NM, 10-Aug-2012.) $)
      dalemdnee $p |- ( ph -> D =/= E ) $=
        ( wne wa simpr dalemqnet adantr eqnetrd dalem4 syldan dalem3 pm2.61dane
        wceq ) ADKUIZDFADFUSZDIUIUTAVAUJDFIAVAUKAFIUIVAABCEFGHIJLMNPQRSTUAUBUDU
        EULUMUNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUOUPABCDEFGHIJKLMNOPQRSTUAUB
        UCUDUEUFUGUHUQUR $.
    $}

    ${
      dalem5.o $e |- O = ( LPlanes ` K ) $.
      dalem5.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem5.w $e |- W = ( Y .\/ C ) $.
      $( Lemma for ~ dath .  Atom ` U ` (in plane ` Z = S T U ` ) belongs to
         the 3-dimensional volume formed by ` Y ` and ` C ` .  (Contributed by
         NM, 21-Jul-2012.) $)
      dalem5 $p |- ( ph -> U .<_ W ) $=
        ( cbs co eqid dalemkelat dalemueb chlt wcel dalemkehl dalemrea dalemcea
        cfv hlatjcl syl3anc dalemyeb dalemceb latjcl syl5eqel wbr dalemclrju wi
        clat wne dalemuea wn dalempea simp313 sylbi atnlej1 syl131anc hlatexch1
        w3a mpd dalempjqeb dalemreb latlej2 syl6breqr latjlej1 syl13anc lattrd
        wa ) AKUDUNZKLIFCJUEZNWDUFZRABCDEFGHIJKLMOPQUGZABCDEFGHIJKLMOPQTUHAKUIU
        JZFBUJZCBUJZWEWDUJABCDEFGHIJKLMOPQUKZABCDEFGHIJKLMOPQULZABCDEFGHIJKLMOP
        QRSTUAUBUMZBWDJKFCWFSTUOUPANOCJUEZWDUCAKVDUJZOWDUJZCWDUJZWNWDUJWGABCDEF
        GHIJKLMOPQUAUQZABCDEFGHIJKLMOPQTURZWDJKOCWFSUSUPUTACFIJUELVAZIWELVAZABC
        DEFGHIJKLMOPQVBAWHWJIBUJZWICFVEZWTXAVCWKWMABCDEFGHIJKLMOPQVFWLAWHWJWIDB
        UJZCFDJUELVAVGZXCWKWMWLABCDEFGHIJKLMOPQVHAWHWQWCXDEBUJWIVNGBUJHBUJXBVNV
        NZOMUJPMUJWCZCDEJUEZLVAVGZCEFJUELVAVGZXEVNCGHJUELVAVGCHIJUELVAVGCIGJUEL
        VAVGVNZCDGJUELVACEHJUELVAWTVNZVNVNXEQXIXJXEXKXLXFXGVIVJBCFDJKLRSTVKVLBC
        IFJKLRSTVMVLVOAWEWNNLAFOLVAZWEWNLVAZAFXHFJUEZOLAWOXHWDUJFWDUJZFXOLVAWGA
        BCDEFGHIJKLMOPQSTVPABCDEFGHIJKLMOPQTVQZWDJKLXHFWFRSVRUPUBVSAWOXPWPWQXMX
        NVCWGXQWRWSWDJKLFOCWFRSVTWAVOUCVSWB $.
    $}

    ${
      dalem6.o $e |- O = ( LPlanes ` K ) $.
      dalem6.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem6.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem6.w $e |- W = ( Y .\/ C ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem5 for ` S ` .  (Contributed by
         NM, 21-Jul-2012.) $)
      dalem6 $p |- ( ph -> S .<_ W ) $=
        ( co chlt wcel cbs cfv wa w3a wbr dalemrot biid eqid dalem5 dalemqrprot
        wn syl syl6reqr oveq1d syl5eq breqtrrd ) AGEFJUEZDJUEZCJUEZNLAKUFUGCKUH
        UIUGUJEBUGFBUGDBUGUKHBUGIBUGGBUGUKUKVEMUGHIJUEZGJUEZMUGUJCVDLULURCFDJUE
        LULURCDEJUEZLULURUKCVGLULURCIGJUELULURCGHJUELULURUKCEHJUELULCFIJUELULCD
        GJUELULUKUKUKZGVFLULABCDEFGHIJKLMOPQRSTUBUCUMVJBCEFDHIGJKLMVFVEVHVJUNRS
        TUAVEUOVFUOUPUSANOCJUEVFUDAOVECJAVEVIFJUEOABCDEFGHIJKLMOPQSTUQUBUTVAVBV
        C $.

      $( Lemma for ~ dath .  Analog of ~ dalem5 for ` T ` .  (Contributed by
         NM, 21-Jul-2012.) $)
      dalem7 $p |- ( ph -> T .<_ W ) $=
        ( co chlt wcel cbs cfv wa w3a wbr dalemrot biid eqid dalem6 dalemqrprot
        wn syl syl6reqr oveq1d syl5eq breqtrrd ) AHEFJUEZDJUEZCJUEZNLAKUFUGCKUH
        UIUGUJEBUGFBUGDBUGUKHBUGIBUGGBUGUKUKVEMUGHIJUEZGJUEZMUGUJCVDLULURCFDJUE
        LULURCDEJUEZLULURUKCVGLULURCIGJUELULURCGHJUELULURUKCEHJUELULCFIJUELULCD
        GJUELULUKUKUKZHVFLULABCDEFGHIJKLMOPQRSTUBUCUMVJBCEFDHIGJKLMVFVEVHVJUNRS
        TUAVEUOVHUOVFUOUPUSANOCJUEVFUDAOVECJAVEVIFJUEOABCDEFGHIJKLMOPQSTUQUBUTV
        AVBVC $.

      $( Lemma for ~ dath .  Plane ` Z ` belongs to the 3-dimensional space.
         (Contributed by NM, 21-Jul-2012.) $)
      dalem8 $p |- ( ph -> Z .<_ W ) $=
        ( co wbr dalem6 dalem7 clat wcel cbs wa wb dalemkelat dalemseb dalemteb
        dalemyeb dalemceb eqid latjcl syl3anc syl5eqel latjle12 syl13anc dalem5
        cfv mpbi2and dalemsjteb dalemueb syl5eqbr ) APGHJUEZIJUEZNLUCAVKNLUFZIN
        LUFZVLNLUFZAGNLUFZHNLUFZVMABCDEFGHIJKLMNOPQRSTUAUBUCUDUGABCDEFGHIJKLMNO
        PQRSTUAUBUCUDUHAKUIUJZGKUKVFZUJHVSUJNVSUJZVPVQULVMUMABCDEFGHIJKLMOPQUNZ
        ABCDEFGHIJKLMOPQTUOABCDEFGHIJKLMOPQTUPANOCJUEZVSUDAVROVSUJCVSUJWBVSUJWA
        ABCDEFGHIJKLMOPQUAUQABCDEFGHIJKLMOPQTURVSJKOCVSUSZSUTVAVBZVSJKLGHNWCRSV
        CVDVGABCDEFGHIJKLMNOPQRSTUAUBUDVEAVRVKVSUJIVSUJVTVMVNULVOUMWAABCDEFGHIJ
        KLMOPQSTVHABCDEFGHIJKLMOPQTVIWDVSJKLVKINWCRSVCVDVGVJ $.
    $}

    ${
      dalem-cly.o $e |- O = ( LPlanes ` K ) $.
      dalem-cly.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem-cly.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dalem9 .  Center of perspectivity ` C ` is not in plane
         ` Y ` (when ` Y ` and ` Z ` are different planes).  (Contributed by
         NM, 13-Aug-2012.) $)
      dalem-cly $p |- ( ( ph /\ Y =/= Z ) -> -. C .<_ Y ) $=
        ( wne wbr wn wceq co clat wcel cbs wb dalemkelat dalemceb dalemyeb eqid
        cfv latleeqj1 syl3anc dalemclpjs wi dalemcea dalemsea dalempea dalemqea
        dalemkehl dalem-clpjq atnlej1 syl131anc hlatexch1 mpd hlatjcom breqtrrd
        chlt dalemclqjt dalemtea dalemrea wa w3a simp312 sylbi dalemseb hlatjcl
        dalemteb latjlej12 mp2and dalempeb dalemqeb latjjdi syl13anc dalemclrju
        syl122anc dalemuea simp313 dalemsjteb dalempjqeb latjcl dalemueb oveq2i
        dalemreb 3brtr4g breq2 syl5ibcom sylbid dalemzeo dalemyeo lplncmp eqcom
        syl6bb sylibd necon3ad imp ) ANOUCCNLUDZUEAXLNOAXLONLUDZNOUFZAXLCNJUGZN
        UFZXMAKUHUIZCKUJUPZUIZNXRUIXLXPUKABCDEFGHIJKLMNOPULZABCDEFGHIJKLMNOPSUM
        ZABCDEFGHIJKLMNOPTUNXRJKLCNXRUOZQRUQURAOXOLUDXPXMAGHJUGZIJUGZCDEJUGZFJU
        GZJUGZOXOLAYDCYEJUGZCFJUGZJUGZYGLAYCYHLUDZIYILUDZYDYJLUDZAYCCDJUGZCEJUG
        ZJUGZYHLAGYNLUDZHYOLUDZYCYPLUDZAGDCJUGZYNLACDGJUGLUDZGYTLUDZABCDEFGHIJK
        LMNOPUSAKVMUIZCBUIZGBUIZDBUIZCDUCZUUAUUBUTABCDEFGHIJKLMNOPVEZABCDEFGHIJ
        KLMNOPQRSTUAVAZABCDEFGHIJKLMNOPVBABCDEFGHIJKLMNOPVCZAUUCUUDUUFEBUIZCYEL
        UDUEZUUGUUHUUIUUJABCDEFGHIJKLMNOPVDZABCDEFGHIJKLMNOPVFBCDEJKLQRSVGVHBCG
        DJKLQRSVIVHVJAUUCUUDUUFYNYTUFUUHUUIUUJBJKCDRSVKURVLAHECJUGZYOLACEHJUGLU
        DZHUUNLUDZABCDEFGHIJKLMNOPVNAUUCUUDHBUIZUUKCEUCZUUOUUPUTUUHUUIABCDEFGHI
        JKLMNOPVOUUMAUUCUUDUUKFBUIZCEFJUGLUDUEZUURUUHUUIUUMABCDEFGHIJKLMNOPVPZA
        UUCXSVQUUFUUKUUSVRUUEUUQIBUIZVRVRZNMUIZOMUIZVQZUULUUTCFDJUGLUDUEZVRCYCL
        UDUECHIJUGLUDUECIGJUGLUDUEVRZUUAUUOCFIJUGLUDZVRZVRVRZUUTPUULUUTUVGUVHUV
        JUVCUVFVSVTBCEFJKLQRSVGVHBCHEJKLQRSVIVHVJAUUCUUDUUKYOUUNUFUUHUUIUUMBJKC
        ERSVKURVLAXQGXRUIYNXRUIZHXRUIYOXRUIZYQYRVQYSUTXTABCDEFGHIJKLMNOPSWAAUUC
        UUDUUFUVLUUHUUIUUJBXRJKCDYBRSWBURABCDEFGHIJKLMNOPSWCAUUCUUDUUKUVMUUHUUI
        UUMBXRJKCEYBRSWBURXRJKLYOGYNHYBQRWDWKWEAXQXSDXRUIEXRUIYHYPUFXTYAABCDEFG
        HIJKLMNOPSWFABCDEFGHIJKLMNOPSWGXRJKCDEYBRWHWIVLAIFCJUGZYILAUVIIUVNLUDZA
        BCDEFGHIJKLMNOPWJAUUCUUDUVBUUSCFUCZUVIUVOUTUUHUUIABCDEFGHIJKLMNOPWLUVAA
        UUCUUDUUSUUFUVGUVPUUHUUIUVAUUJAUVKUVGPUULUUTUVGUVHUVJUVCUVFWMVTBCFDJKLQ
        RSVGVHBCIFJKLQRSVIVHVJAUUCUUDUUSYIUVNUFUUHUUIUVABJKCFRSVKURVLAXQYCXRUIY
        HXRUIZIXRUIYIXRUIZYKYLVQYMUTXTABCDEFGHIJKLMNOPRSWNAXQXSYEXRUIZUVQXTYAAB
        CDEFGHIJKLMNOPRSWOZXRJKCYEYBRWPURABCDEFGHIJKLMNOPSWQAUUCUUDUUSUVRUUHUUI
        UVABXRJKCFYBRSWBURXRJKLYIYCYHIYBQRWDWKWEAXQXSUVSFXRUIYGYJUFXTYAUVTABCDE
        FGHIJKLMNOPSWSXRJKCYEFYBRWHWIVLUBNYFCJUAWRWTXONOLXAXBXCAXMONUFZXNAUUCUV
        EUVDXMUWAUKUUHABCDEFGHIJKLMNOPXDABCDEFGHIJKLMNOPXEMKLONQTXFURONXGXHXIXJ
        XK $.
    $}

    ${
      dalem9.o $e |- O = ( LPlanes ` K ) $.
      dalem9.v $e |- V = ( LVols ` K ) $.
      dalem9.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem9.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem9.w $e |- W = ( Y .\/ C ) $.
      $( Lemma for ~ dath .  Since ` -. C .<_ Y ` , the join ` Y .\/ C ` forms
         a 3-dimensional space.  (Contributed by NM, 20-Jul-2012.) $)
      dalem9 $p |- ( ( ph /\ Y =/= Z ) -> W e. V ) $=
        ( wne wa co chlt wcel wbr wn dalemkehl adantr dalemyeo dalem-cly lvoli3
        dalemcea syl31anc syl5eqel ) APQUGZUHZOPCJUIZNUFVCKUJUKZPMUKZCBUKZCPLUL
        UMVDNUKAVEVBABCDEFGHIJKLMPQRUNUOAVFVBABCDEFGHIJKLMPQRUPUOAVGVBABCDEFGHI
        JKLMPQRSTUAUBUDUSUOABCDEFGHIJKLMPQRSTUAUBUDUEUQBMCJKLNPSTUAUBUCURUTVA
        $.
    $}

    ${
      dalem10.m $e |- ./\ = ( meet ` K ) $.
      dalem10.o $e |- O = ( LPlanes ` K ) $.
      dalem10.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem10.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem10.x $e |- X = ( Y ./\ Z ) $.
      dalem10.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      $( Lemma for ~ dath .  Atom ` D ` belongs to the axis of perspectivity
         ` X ` .  (Contributed by NM, 19-Jul-2012.) $)
      dalem10 $p |- ( ph -> D .<_ X ) $=
        ( wbr clat wcel cbs dalemkelat dalempjqeb dalemreb eqid latlej1 syl3anc
        co cfv dalemsjteb dalemueb wa dalemyeb syl5eqelr dalemzeo syl latmlem12
        wi lplnbase syl122anc mp2and oveq12i eqtri 3brtr4g ) AEFKUSZHIKUSZNUSZV
        PGKUSZVQJKUSZNUSZDPMAVPVSMUIZVQVTMUIZVRWAMUIZALUJUKZVPLULUTZUKZGWFUKWBA
        BCEFGHIJKLMOQRSUMZABCEFGHIJKLMOQRSUAUBUNZABCEFGHIJKLMOQRSUBUOWFKLMVPGWF
        UPZTUAUQURAWEVQWFUKZJWFUKWCWHABCEFGHIJKLMOQRSUAUBVAZABCEFGHIJKLMOQRSUBV
        BWFKLMVQJWJTUAUQURAWEWGVSWFUKWKVTWFUKWBWCVCWDVIWHWIAVSQWFUEABCEFGHIJKLM
        OQRSUDVDVEWLAVTRWFUFAROUKRWFUKABCEFGHIJKLMOQRSVFWFOLRWJUDVJVGVEWFLMNVTV
        PVSVQWJTUCVHVKVLUHPQRNUSWAUGQVSRVTNUEUFVMVNVO $.
    $}

    ${
      dalem11.m $e |- ./\ = ( meet ` K ) $.
      dalem11.o $e |- O = ( LPlanes ` K ) $.
      dalem11.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem11.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem11.x $e |- X = ( Y ./\ Z ) $.
      dalem11.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem10 for ` E ` .  (Contributed by
         NM, 23-Jul-2012.) $)
      dalem11 $p |- ( ph -> E .<_ X ) $=
        ( co chlt wcel cbs cfv wa w3a wn dalemrot biid eqid dalem10 dalemqrprot
        wbr syl syl6reqr dalemkehl dalemtea dalemuea dalemsea hlatjrot syl13anc
        wceq oveq12d syl5eq breqtrrd ) AJEFKUIZDKUIZHIKUIZGKUIZNUIZPMALUJUKZCLU
        LUMUKUNEBUKFBUKDBUKUOHBUKZIBUKZGBUKZUOUOVPOUKVROUKUNCVOMVBUPCFDKUIMVBUP
        CDEKUIZMVBUPUOCVQMVBUPCIGKUIMVBUPCGHKUIZMVBUPUOCEHKUIMVBCFIKUIMVBCDGKUI
        MVBUOUOUOZJVSMVBABCDEFGHIKLMOQRSTUAUBUEUFUQWFBCJEFDHIGKLMNOVSVPVRWFURTU
        AUBUCUDVPUSVRUSVSUSUHUTVCAPQRNUIVSUGAQVPRVRNAVPWDFKUIQABCDEFGHIKLMOQRSU
        AUBVAUEVDAVRWEIKUIZRAVTWAWBWCVRWGVKABCDEFGHIKLMOQRSVEABCDEFGHIKLMOQRSVF
        ABCDEFGHIKLMOQRSVGABCDEFGHIKLMOQRSVHBHIGKLUAUBVIVJUFVDVLVMVN $.
    $}

    ${
      dalem12.m $e |- ./\ = ( meet ` K ) $.
      dalem12.o $e |- O = ( LPlanes ` K ) $.
      dalem12.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem12.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem12.x $e |- X = ( Y ./\ Z ) $.
      dalem12.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem10 for ` F ` .  (Contributed by
         NM, 11-Aug-2012.) $)
      dalem12 $p |- ( ph -> F .<_ X ) $=
        ( co chlt wcel cbs cfv wa w3a wn dalemrot biid eqid dalem11 dalemqrprot
        wbr syl syl6reqr dalemkehl dalemtea dalemuea dalemsea hlatjrot syl13anc
        wceq oveq12d syl5eq breqtrrd ) AJEFKUIZDKUIZHIKUIZGKUIZNUIZPMALUJUKZCLU
        LUMUKUNEBUKFBUKDBUKUOHBUKZIBUKZGBUKZUOUOVPOUKVROUKUNCVOMVBUPCFDKUIMVBUP
        CDEKUIZMVBUPUOCVQMVBUPCIGKUIMVBUPCGHKUIZMVBUPUOCEHKUIMVBCFIKUIMVBCDGKUI
        MVBUOUOUOZJVSMVBABCDEFGHIKLMOQRSTUAUBUEUFUQWFBCEFDHIGJKLMNOVSVPVRWFURTU
        AUBUCUDVPUSVRUSVSUSUHUTVCAPQRNUIVSUGAQVPRVRNAVPWDFKUIQABCDEFGHIKLMOQRSU
        AUBVAUEVDAVRWEIKUIZRAVTWAWBWCVRWGVKABCDEFGHIKLMOQRSVEABCDEFGHIKLMOQRSVF
        ABCDEFGHIKLMOQRSVGABCDEFGHIKLMOQRSVHBHIGKLUAUBVIVJUFVDVLVMVN $.
    $}

    ${
      dalem13.o $e |- O = ( LPlanes ` K ) $.
      dalem13.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem13.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem13.w $e |- W = ( Y .\/ C ) $.
      $( Lemma for ~ dalem14 .  (Contributed by NM, 21-Jul-2012.) $)
      dalem13 $p |- ( ( ph /\ Y =/= Z ) -> ( Y .\/ Z ) = W ) $=
        ( wne wa chlt wcel clvol cfv co wceq dalemkehl adantr dalemyeo dalemzeo
        wbr eqid dalem9 clat cbs dalemkelat dalemyeb dalemceb latlej1 syl6breqr
        syl3anc dalem8 simpr 2lplnj syl133anc ) AOPUEZUFKUGUHZOMUHZPMUHZNKUIUJZ
        UHONLUQZPNLUQZVLOPJUKNULAVMVLABCDEFGHIJKLMOPQUMUNAVNVLABCDEFGHIJKLMOPQU
        OUNAVOVLABCDEFGHIJKLMOPQUPUNABCDEFGHIJKLMVPNOPQRSTUAVPURZUBUCUDUSAVQVLA
        OOCJUKZNLAKUTUHOKVAUJZUHCWAUHOVTLUQABCDEFGHIJKLMOPQVBABCDEFGHIJKLMOPQUA
        VCABCDEFGHIJKLMOPQTVDWAJKLOCWAURRSVEVGUDVFUNAVRVLABCDEFGHIJKLMNOPQRSTUA
        UBUCUDVHUNAVLVIMJKLVPNOPRSUAVSVJVK $.
    $}

    ${
      dalem14.o $e |- O = ( LPlanes ` K ) $.
      dalem14.v $e |- V = ( LVols ` K ) $.
      dalem14.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem14.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem14.w $e |- W = ( Y .\/ C ) $.
      $( Lemma for ~ dath .  Planes ` Y ` and ` Z ` form a 3-dimensional space
         (when they are different).  (Contributed by NM, 22-Jul-2012.) $)
      dalem14 $p |- ( ( ph /\ Y =/= Z ) -> ( Y .\/ Z ) e. V ) $=
        ( wne wa co dalem13 dalem9 eqeltrd ) APQUGUHPQJUIONABCDEFGHIJKLMOPQRSTU
        AUBUDUEUFUJABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUKUL $.
    $}

    ${
      dalem15.m $e |- ./\ = ( meet ` K ) $.
      dalem15.n $e |- N = ( LLines ` K ) $.
      dalem15.o $e |- O = ( LPlanes ` K ) $.
      dalem15.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem15.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem15.x $e |- X = ( Y ./\ Z ) $.
      $( Lemma for ~ dath .  The axis of perspectivity ` X ` is a line.
         (Contributed by NM, 21-Jul-2012.) $)
      dalem15 $p |- ( ( ph /\ Y =/= Z ) -> X e. N ) $=
        ( wne wa co wcel clvol eqid dalem14 wb chlt dalemkehl dalemyeo dalemzeo
        cfv 2lplnmj syl3anc adantr mpbird syl5eqel ) AQRUIZUJZPQRMUKZNUHVHVINUL
        ZQRJUKKUMVAZULZABCDEFGHIJKLOVKQCJUKZQRSTUAUBUEVKUNZUFUGVMUNUOAVJVLUPZVG
        AKUQULQOULROULVOABCDEFGHIJKLOQRSURABCDEFGHIJKLOQRSUSABCDEFGHIJKLOQRSUTO
        JKMNVKQRUAUCUDUEVNVBVCVDVEVF $.
    $}

    ${
      dalem16.m $e |- ./\ = ( meet ` K ) $.
      dalem16.o $e |- O = ( LPlanes ` K ) $.
      dalem16.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem16.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem16.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      dalem16.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      dalem16.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
      $( Lemma for ~ dath .  The atoms ` D ` , ` E ` , and ` F ` form a line of
         perspectivity.  This is Desargue's Theorem for the special case where
         planes ` Y ` and ` Z ` are different.  (Contributed by NM,
         7-Aug-2012.) $)
      dalem16 $p |- ( ( ph /\ Y =/= Z ) -> F .<_ ( D .\/ E ) ) $=
        ( wne wa wbr eqid dalem12 adantr wceq dalem10 dalem11 clat wcel cbs cfv
        co wb dalemkelat dalemdea atbase syl dalemeea dalemyeb dalemzeo syl3anc
        lplnbase latjle12 syl13anc mpbi2and chlt clln dalemkehl dalemdnee llni2
        latmcl syl31anc dalem15 llncmp mpbid breqtrrd ) ARSUKZULZLRSPVDZDKMVDZO
        ALWKOUMWIABCEFGHIJLMNOPQWKRSTUAUBUCUDUEUFUGWKUNZUJUOUPWJWLWKOUMZWLWKUQZ
        AWNWIADWKOUMZKWKOUMZWNABCDEFGHIJMNOPQWKRSTUAUBUCUDUEUFUGWMUHURABCEFGHIJ
        KMNOPQWKRSTUAUBUCUDUEUFUGWMUIUSANUTVAZDNVBVCZVAZKWSVAZWKWSVAZWPWQULWNVE
        ABCEFGHIJMNOQRSTVFZADBVAZWTABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHVGZBWSDNWS
        UNZUCVHVIAKBVAZXAABCEFGHIJKMNOPQRSTUAUBUCUDUEUFUGUIVJZBWSKNXFUCVHVIAWRR
        WSVASWSVAZXBXCABCEFGHIJMNOQRSTUEVKASQVAXIABCEFGHIJMNOQRSTVLWSQNSXFUEVNV
        IWSNPRSXFUDWCVMWSMNODKWKXFUAUBVOVPVQUPWJNVRVAZWLNVSVCZVAZWKXKVAWNWOVEAX
        JWIABCEFGHIJMNOQRSTVTZUPAXLWIAXJXDXGDKUKXLXMXEXHABCDEFGHIJKMNOPQRSTUAUB
        UCUDUEUFUGUHUIWABDKMNXKUBUCXKUNZWBWDUPABCEFGHIJMNOPXKQWKRSTUAUBUCUDXNUE
        UFUGWMWENOXKWLWKUAXNWFVMWGWH $.
    $}

    ${
      dalem17.o $e |- O = ( LPlanes ` K ) $.
      dalem17.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem17.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  When planes ` Y ` and ` Z ` are equal, the center
         of perspectivity ` C ` is in ` Y ` .  (Contributed by NM,
         1-Aug-2012.) $)
      dalem17 $p |- ( ( ph /\ Y = Z ) -> C .<_ Y ) $=
        ( wceq wa wbr dalemclrju adantr clat wcel cbs cfv dalemkelat dalempjqeb
        co dalemreb eqid latlej2 syl3anc syl6breqr dalemsjteb dalemueb breqtrrd
        simpr wb dalemyeb latjle12 syl13anc mpbi2and wi dalemceb chlt dalemkehl
        dalemrea dalemuea hlatjcl lattr mp2and ) ANOUCZUDZCFIJUNZLUEZVTNLUEZCNL
        UEZAWAVRABCDEFGHIJKLMNOPUFUGVSFNLUEZINLUEZWBAWDVRAFDEJUNZFJUNZNLAKUHUIZ
        WFKUJUKZUIFWIUIZFWGLUEABCDEFGHIJKLMNOPULZABCDEFGHIJKLMNOPRSUMABCDEFGHIJ
        KLMNOPSUOZWIJKLWFFWIUPZQRUQURUAUSUGVSIONLAIOLUEVRAIGHJUNZIJUNZOLAWHWNWI
        UIIWIUIZIWOLUEWKABCDEFGHIJKLMNOPRSUTABCDEFGHIJKLMNOPSVAZWIJKLWNIWMQRUQU
        RUBUSUGAVRVCVBAWDWEUDWBVDZVRAWHWJWPNWIUIZWRWKWLWQABCDEFGHIJKLMNOPTVEZWI
        JKLFINWMQRVFVGUGVHAWAWBUDWCVIZVRAWHCWIUIVTWIUIZWSXAWKABCDEFGHIJKLMNOPSV
        JAKVKUIFBUIIBUIXBABCDEFGHIJKLMNOPVLABCDEFGHIJKLMNOPVMABCDEFGHIJKLMNOPVN
        BWIJKFIWMRSVOURWTWIKLCVTNWMQVPVGUGVQ $.
    $}

    ${
      $d c A $.  $d c .\/ $.  $d c .<_ $.  $d c P $.  $d c Q $.  $d c R $.
      dalem18.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      $( Lemma for ~ dath .  Show that a dummy atom ` c ` exists outside of the
         ` Y ` and ` Z ` planes (when those planes are equal).  This requires
         that the projective space be 3-dimensional.  (Desargue's theorem
         doesn't always hold in 2 dimensions.)  (Contributed by NM,
         29-Jul-2012.) $)
      dalem18 $p |- ( ph -> E. c e. A -. c .<_ Y ) $=
        ( cv co wn wrex chlt wcel dalemkehl dalempea dalemqea dalemrea syl13anc
        wbr 3dim3 breq2i notbii rexbii sylibr ) APUBZDEJUCFJUCZLUMZUDZPBUEZUSNL
        UMZUDZPBUEAKUFUGDBUGEBUGFBUGVCABCDEFGHIJKLMNOQUHABCDEFGHIJKLMNOQUIABCDE
        FGHIJKLMNOQUJABCDEFGHIJKLMNOQUKBDEFJKLPSRTUNULVEVBPBVDVANUTUSLUAUOUPUQU
        R $.
    $}

    ${
      $d d c $.  $d d A $.  $d d C $.  $d d K $.  $d d .<_ $.  $d d Y $.
      dalem19.o $e |- O = ( LPlanes ` K ) $.
      dalem19.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem19.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  Show that a second dummy atom ` d ` exists outside
         of the ` Y ` and ` Z ` planes (when those planes are equal).
         (Contributed by NM, 15-Aug-2012.) $)
      dalem19 $p |- ( ( ( ( ph /\ Y = Z ) /\ c e. A ) /\ -.
     c .<_ Y ) -> E. d e. A ( d =/= c
          /\ -. d .<_ Y /\ C .<_ ( c .\/ d ) ) ) $=
        ( wceq wa cv wcel wbr chlt cbs cfv wne w3a dalemkehl ad3antrrr dalemcea
        wn wrex simplr dalemyeb dalem17 ad2antrr simpr eqid atbtwnex syl33anc
        co ) ANOUEZUFZPUGZBUHZUFZVKNLUIURZUFKUJUHZCBUHZVLNKUKULZUHZCNLUIZVNQUGZ
        VKUMVTNLUIURCVKVTJVHLUIUNQBUSAVOVIVLVNABCDEFGHIJKLMNORUOUPAVPVIVLVNABCD
        EFGHIJKLMNORSTUAUBUCUQUPVJVLVNUTAVRVIVLVNABCDEFGHIJKLMNORUBVAUPVJVSVLVN
        ABCDEFGHIJKLMNORSTUAUBUCUDVBVCVMVNVDBVQCVKJKLNQVQVESTUAVFVG $.
    $}
  $}

  ${
    da.ps0 $e |- ( ps <-> ( ( c e. A /\ d e. A ) /\ -. c .<_ Y /\
       ( d =/= c /\ -. d .<_ Y /\ C .<_ ( c .\/ d ) ) ) ) $.
    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       15-Aug-2012.) $)
    dalemccea $p |- ( ps -> c e. A ) $=
      ( cv wcel wa wbr wn wne co w3a simp1l sylbi ) AGJZBKZHJZBKZLTFEMNZUBTOUBF
      EMNCTUBDPEMQZQUAIUAUCUDUERS $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       15-Aug-2012.) $)
    dalemddea $p |- ( ps -> d e. A ) $=
      ( cv wcel wa wbr wn wne co w3a simp1r sylbi ) AGJZBKZHJZBKZLTFEMNZUBTOUBF
      EMNCTUBDPEMQZQUCIUAUCUDUERS $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       15-Aug-2012.) $)
    dalem-ccly $p |- ( ps -> -. c .<_ Y ) $=
      ( cv wcel wa wbr wn wne co w3a simp2bi ) AGJZBKHJZBKLSFEMNTSOTFEMNCSTDPEM
      QIR $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       15-Aug-2012.) $)
    dalem-ddly $p |- ( ps -> -. d .<_ Y ) $=
      ( cv wcel wa wbr wn wne co w3a simp32 sylbi ) AGJZBKHJZBKLZTFEMNZUATOZUAF
      EMNZCTUADPEMZQQUEIUBUCUDUEUFRS $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       15-Aug-2012.) $)
    dalemccnedd $p |- ( ps -> c =/= d ) $=
      ( cv wcel wa wbr wn wne co w3a simp31 sylbi necomd ) AHJZGJZAUBBKUABKLZUB
      FEMNZUAUBOZUAFEMNZCUBUADPEMZQQUEIUCUDUEUFUGRST $.

    $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by NM,
       15-Aug-2012.) $)
    dalemclccjdd $p |- ( ps -> C .<_ ( c .\/ d ) ) $=
      ( cv wcel wa wbr wn wne co w3a simp33 sylbi ) AGJZBKHJZBKLZTFEMNZUATOZUAF
      EMNZCTUADPEMZQQUFIUBUCUDUEUFRS $.

    ${
      da.a1 $e |- A = ( Atoms ` K ) $.
      $( Lemma for ~ dath .  Frequently-used utility lemma.  (Contributed by
         NM, 15-Aug-2012.) $)
      dalemcceb $p |- ( ps -> c e. ( Base ` K ) ) $=
        ( cv wcel cbs cfv dalemccea eqid atbase syl ) AHLZBMTENOZMABCDFGHIJPBUA
        TEUAQKRS $.
    $}
  $}

  ${
    dalem.ph $e |- ( ph <-> ( ( ( K e. HL /\ C e. ( Base ` K ) )
    /\ ( P e. A /\ Q e. A /\ R e. A )
    /\ ( S e. A /\ T e. A /\ U e. A ) )
 /\ ( Y e. O /\ Z e. O )
 /\ ( ( -. C .<_ ( P .\/ Q ) /\ -. C .<_ ( Q .\/ R )
    /\ -. C .<_ ( R .\/ P ) )
    /\ ( -. C .<_ ( S .\/ T ) /\ -. C .<_ ( T .\/ U )
    /\ -. C .<_ ( U .\/ S ) )
    /\ ( C .<_ ( P .\/ S ) /\ C .<_ ( Q .\/ T )
    /\ C .<_ ( R .\/ U ) ) ) ) ) $.
    dalem.l $e |- .<_ = ( le ` K ) $.
    dalem.j $e |- .\/ = ( join ` K ) $.
    dalem.a $e |- A = ( Atoms ` K ) $.
    dalem.ps $e |- ( ps <-> ( ( c e. A /\ d e. A ) /\ -. c .<_ Y /\
       ( d =/= c /\ -. d .<_ Y /\ C .<_ ( c .\/ d ) ) ) ) $.
    $( Lemma for ~ dath .  Swap the ` Y ` and ` Z ` planes, along with dummy
       concurrency (center of perspectivity) atoms ` c ` and ` d ` , to allow
       reuse of analogous proofs.  (Contributed by NM, 17-Aug-2012.) $)
    dalemswapyzps $p |- ( ( ph /\ Y = Z /\ ps )
       -> ( ( d e. A /\ c e. A ) /\ -. d .<_ Z /\
       ( c =/= d /\ -. c .<_ Z /\ C .<_ ( d .\/ c ) ) ) ) $=
      ( wceq w3a cv wcel wa wbr wne dalemddea dalemccea jca 3ad2ant3 dalem-ddly
      wn co simp2 breq2d dalemccnedd dalem-ccly dalemclccjdd dalemkehl 3ad2ant1
      mtbid chlt hlatjcom syl3anc breqtrd 3jca ) AOPUDZBUEZRUFZCUGZQUFZCUGZUHZV
      MPMUIZUPVOVMUJZVOPMUIZUPZDVMVOKUQZMUIZUEBAVQVKBVNVPBCDKMOQRUCUKZBCDKMOQRU
      CULZUMUNVLVMOMUIZVRBAWFUPVKBCDKMOQRUCUOUNVLOPVMMAVKBURZUSVEVLVSWAWCBAVSVK
      BCDKMOQRUCUTUNVLVOOMUIZVTBAWHUPVKBCDKMOQRUCVAUNVLOPVOMWGUSVEVLDVOVMKUQZWB
      MBADWIMUIVKBCDKMOQRUCVBUNVLLVFUGZVPVNWIWBUDAVKWJBACDEFGHIJKLMNOPSVCVDBAVP
      VKWEUNBAVNVKWDUNCKLVOVMUAUBVGVHVIVJVJ $.

    ${
      dalemrotps.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      $( Lemma for ~ dath .  Rotate triangles ` Y = P Q R ` and ` Z = S T U `
         to allow reuse of analogous proofs.  (Contributed by NM,
         15-Aug-2012.) $)
      dalemrotps $p |- ( ( ph /\ ps ) -> ( ( c e. A /\ d e. A )
  /\ -. c .<_ ( ( Q .\/ R ) .\/ P )
  /\ ( d =/= c /\ -. d .<_ ( ( Q .\/ R ) .\/ P )
  /\ C .<_ ( c .\/ d ) ) ) ) $=
        ( wa cv wcel co wbr wn wne w3a dalemccea dalemddea adantl dalem-ccly wb
        jca dalemqrprot breq2d adantr mtbid dalemccnedd dalem-ddly dalemclccjdd
        syl6reqr necomd 3jca ) ABUEZQUFZCUGZRUFZCUGZUEZVJFGKUHEKUHZMUIZUJVLVJUK
        ZVLVOMUIZUJZDVJVLKUHMUIZULBVNABVKVMBCDKMOQRUCUMBCDKMOQRUCUNURUOVIVJOMUI
        ZVPBWAUJABCDKMOQRUCUPUOAWAVPUQBAOVOVJMAVOEFKUHGKUHOACDEFGHIJKLMNOPSUAUB
        USUDVFZUTVAVBVIVQVSVTBVQABVJVLBCDKMOQRUCVCVGUOVIVLOMUIZVRBWCUJABCDKMOQR
        UCVDUOAWCVRUQBAOVOVLMWBUTVAVBBVTABCDKMOQRUCVEUOVHVH $.
    $}

    $( Lemma for ~ dath .  Show that the dummy atoms form a line.  (Contributed
       by NM, 15-Aug-2012.) $)
    dalemcjden $p |- ( ( ph /\ ps ) -> ( c .\/ d ) e. ( LLines ` K ) ) $=
      ( wa chlt wcel cv wne co clln dalemkehl adantr dalemccea adantl dalemddea
      cfv dalemccnedd eqid llni2 syl31anc ) ABUDLUEUFZQUGZCUFZRUGZCUFZVBVDUHZVB
      VDKUILUJUPZUFAVABACDEFGHIJKLMNOPSUKULBVCABCDKMOQRUCUMUNBVEABCDKMOQRUCUOUN
      BVFABCDKMOQRUCUQUNCVBVDKLVGUAUBVGURUSUT $.

    ${
      $d c d A $.  $d d C $.  $d d K $.  $d c d .<_ $.  $d c d Y $.
      $d c .\/ $.  $d c P $.  $d c Q $.  $d c R $.  $d c Z $.  $d c ph $.
      dalem20.o $e |- O = ( LPlanes ` K ) $.
      dalem20.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem20.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  Show that a second dummy atom ` d ` exists outside
         of the ` Y ` and ` Z ` planes (when those planes are equal).
         (Contributed by NM, 14-Aug-2012.) $)
      dalem20 $p |- ( ( ph /\ Y = Z ) -> E. c E. d ps ) $=
        ( wceq wa cv wbr wn wne co w3a wrex wex dalem18 adantr dalem19 ex ancld
        wcel reximdva 3anass bitri 2exbii r2ex r19.42v rexbii 3bitr2ri sylib
        mpd ) AOPUGZUHZQUIZOMUJUKZRUIZVOULVQOMUJUKDVOVQKUMMUJUNZRCUOZUHZQCUOZBR
        UPQUPZVNVPQCUOZWAAWCVMACDEFGHIJKLMNOPQSTUAUBUEUQURVNVPVTQCVNVOCVBZUHZVP
        VSWEVPVSACDEFGHIJKLMNOPQRSTUAUBUDUEUFUSUTVAVCVLWBWDVQCVBUHZVPVRUHZUHZRU
        PQUPWGRCUOZQCUOWABWHQRBWFVPVRUNWHUCWFVPVRVDVEVFWGQRCCVGWIVTQCVPVRRCVHVI
        VJVK $.
    $}

    ${
      dalem21.m $e |- ./\ = ( meet ` K ) $.
      dalem21.o $e |- O = ( LPlanes ` K ) $.
      dalem21.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem21.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  Show that lines ` c d ` and ` P S ` intersect at
         an atom.  (Contributed by NM, 2-Aug-2012.) $)
      dalem21 $p |- ( ( ph /\ Y = Z /\ ps )
            -> ( ( c .\/ d ) ./\ ( P .\/ S ) ) e. A ) $=
        ( wceq w3a chlt wcel cv co clln cfv wne cp0 3ad2ant1 dalemcjden 3adant2
        dalemkehl dalempjsen wbr wn wa dalemply adantr dalemsly clat dalemkelat
        wb cbs dalempeb dalemseb dalemyeb latjle12 syl13anc mpbi2and dalem-ccly
        eqid 3adant3 adantl dalemcceb dalemddea atbase latlej1 syl3anc wi lattr
        syl llnbase mpand mtod nbrne2 syl2anc necomd cal hlatl dalempea hlatjcl
        dalemsea latmcl dalemcea dalemclccjdd dalemceb latlem12 atlen0 syl31anc
        dalemclpjs 2llnmat syl32anc ) APQUIZBUJZLUKULZRUMZSUMZKUNZLUOUPZULZEHKU
        NZXSULZXRYAUQXRYANUNZLURUPZUQZYCCULAXMXOBACDEFGHIJKLMOPQTVBZUSABXTXMABC
        DEFGHIJKLMOPQRSTUAUBUCUDUTZVAAXMYBBACDEFGHIJKLMOPQTUAUBUCUFUGVCUSXNYAXR
        XNYAPMVDZXRPMVDZVEZYAXRUQAXMYHBAXMVFEPMVDZHPMVDZYHAYKXMACDEFGHIJKLMOPQT
        UAUBUCUFUGVGVHACDEFGHIJKLMOPQTUAUBUCUHVIAYKYLVFYHVLZXMALVJULZELVMUPZULH
        YOULPYOULZYMACDEFGHIJKLMOPQTVKZACDEFGHIJKLMOPQTUCVNACDEFGHIJKLMOPQTUCVO
        ACDEFGHIJKLMOPQTUFVPZYOKLMEHPYOWAZUAUBVQVRVHVSWBABYJXMABVFZYIXPPMVDZBUU
        AVEABCDKMPRSUDVTWCYTXPXRMVDZYIUUAYTYNXPYOULZXQYOULZUUBAYNBYQVHZBUUCABCD
        KLMPRSUDUCWDWCZBUUDABXQCULUUDBCDKMPRSUDWECYOXQLYSUCWFWKWCYOKLMXPXQYSUAU
        BWGWHYTYNUUCXRYOULZYPUUBYIVFUUAWIUUEUUFYTXTUUGYGYOLXSXRYSXSWAZWLWKZAYPB
        YRVHYOLMXPXRPYSUAWJVRWMWNVAYAXRPMWOWPWQABYEXMYTLWRULZYCYOULZDCULZDYCMVD
        ZYEAUUJBAXOUUJYFLWSWKVHYTYNUUGYAYOULZUUKUUEUUIAUUNBAXOECULHCULUUNYFACDE
        FGHIJKLMOPQTWTACDEFGHIJKLMOPQTXBCYOKLEHYSUBUCXAWHVHZYOLNXRYAYSUEXCWHAUU
        LBACDEFGHIJKLMOPQTUAUBUCUFUGXDVHYTDXRMVDZDYAMVDZUUMBUUPABCDKMPRSUDXEWCA
        UUQBACDEFGHIJKLMOPQTXJVHYTYNDYOULZUUGUUNUUPUUQVFUUMVLUUEAUURBACDEFGHIJK
        LMOPQTUCXFVHUUIUUOYOLMNDXRYAYSUAUEXGVRVSCYODLMYCYDYSUAYDWAZUCXHXIVACLNX
        SXRYAYDUEUUSUCUUHXKXL $.
    $}

    ${
      dalem22.o $e |- O = ( LPlanes ` K ) $.
      dalem22.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem22.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      $( Lemma for ~ dath .  Show that lines ` c d ` and ` P S ` determine a
         plane.  (Contributed by NM, 2-Aug-2012.) $)
      dalem22 $p |- ( ( ph /\ Y = Z /\ ps )
        -> ( ( c .\/ d ) .\/ ( P .\/ S ) ) e. O ) $=
        ( wceq w3a cv co cmee cfv wcel eqid dalem21 wb wa chlt dalemkehl adantr
        clln dalemcjden dalempjsen 2llnmj syl3anc 3adant2 mpbid ) AOPUGZBUHQUIR
        UIKUJZEHKUJZLUKULZUJCUMZVIVJKUJNUMZABCDEFGHIJKLMVKNOPQRSTUAUBUCVKUNZUDU
        EUFUOABVLVMUPZVHABUQLURUMZVILVAULZUMVJVQUMZVOAVPBACDEFGHIJKLMNOPSUSUTAB
        CDEFGHIJKLMNOPQRSTUAUBUCVBAVRBACDEFGHIJKLMNOPSTUAUBUDUEVCUTCNKLVKVQVIVJ
        UAVNUBVQUNUDVDVEVFVG $.
    $}

    ${
      dalem23.m $e |- ./\ = ( meet ` K ) $.
      dalem23.o $e |- O = ( LPlanes ` K ) $.
      dalem23.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem23.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem23.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      $( Lemma for ~ dath .  Show that auxiliary atom ` G ` is an atom.
         (Contributed by NM, 2-Aug-2012.) $)
      dalem23 $p |- ( ( ph /\ Y = Z /\ ps ) -> G e. A ) $=
        ( wceq cv co wcel wa chlt dalemkehl adantr dalemccea dalempea dalemddea
        w3a adantl dalemsea syl122anc 3adant2 dalem22 eqeltrd clln cfv 3ad2ant1
        hlatj4 wb wne wn dalemply dalem-ccly nbrne2 syl2an necomd eqid syl31anc
        wbr llni2 3ad2ant3 dalemsly 3adant3 dalem-ddly syl2anc syl3anc syl5eqel
        2llnmj mpbird ) AQRUKZBVBZKSULZELUMZTULZHLUMZOUMZCUJWOWTCUNZWQWSLUMZPUN
        ZWOXBWPWRLUMEHLUMLUMZPABXBXDUKZWNABUOZMUPUNZWPCUNZECUNZWRCUNZHCUNZXEAXG
        BACDEFGHIJLMNPQRUAUQZURZBXHABCDLNQSTUEUSVCZAXIBACDEFGHIJLMNPQRUAUTURZBX
        JABCDLNQSTUEVAZVCAXKBACDEFGHIJLMNPQRUAVDZURCWPEWRHLMUCUDVLVEVFABCDEFGHI
        JLMNPQRSTUAUBUCUDUEUGUHUIVGVHWOXGWQMVIVJZUNZWSXRUNZXAXCVMAWNXGBXLVKZABX
        SWNXFXGXHXIWPEVNXSXMXNXOXFEWPAEQNWCWPQNWCVOEWPVNBACDEFGHIJLMNPQRUAUBUCU
        DUGUHVPBCDLNQSTUEVQEWPQNVRVSVTCWPELMXRUCUDXRWAZWDWBVFWOXGXJXKWRHVNXTYAB
        AXJWNXPWEAWNXKBXQVKWOHWRWOHQNWCZWRQNWCVOZHWRVNAWNYCBACDEFGHIJLMNPQRUAUB
        UCUDUIWFWGBAYDWNBCDLNQSTUEWHWEHWRQNVRWIVTCWRHLMXRUCUDYBWDWBCPLMOXRWQWSU
        CUFUDYBUGWLWJWMWK $.

      $( Lemma for ~ dath .  Show that auxiliary atom ` G ` is outside of plane
         ` Y ` .  (Contributed by NM, 2-Aug-2012.) $)
      dalem24 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. G .<_ Y ) $=
        ( wceq w3a wbr wn co cp0 cfv cv oveq1i col wcel cbs chlt dalemkehl hlol
        syl 3ad2ant1 dalemccea 3ad2ant3 dalempea eqid hlatjcl syl3anc dalemddea
        dalemsea dalemyeb latmmdir syl13anc syl5eq hlatjcom dalemply dalem-ccly
        2atjm syl132anc eqtrd dalemsly 3adant3 dalem-ddly oveq12d wne dalempnes
        oveq1d cal wb hlatl atnem0 mpbid 3eqtrd dalem23 atnle mpbird ) AQRUKZBU
        LZKQNUMUNZKQOUOZMUPUQZUKZXCXESURZELUOZQOUOZTURZHLUOZQOUOZOUOZEHOUOZXFXC
        XEXIXLOUOZQOUOZXNKXPQOUJUSXCMUTVAZXIMVBUQZVAZXLXSVAZQXSVAZXQXNUKAXBXRBA
        MVCVAZXRACDEFGHIJLMNPQRUAVDZMVEVFVGXCYCXHCVAZECVAZXTAXBYCBYDVGZBAYEXBBC
        DLNQSTUEVHVIZAXBYFBACDEFGHIJLMNPQRUAVJZVGZCXSLMXHEXSVKZUCUDVLVMXCYCXKCV
        AZHCVAZYAYGBAYLXBBCDLNQSTUEVNVIZAXBYMBACDEFGHIJLMNPQRUAVOZVGZCXSLMXKHYK
        UCUDVLVMAXBYBBACDEFGHIJLMNPQRUAUGVPVGZXSMOXIXLQYKUFVQVRVSXCXJEXMHOXCXJE
        XHLUOZQOUOZEXCXIYRQOXCYCYEYFXIYRUKYGYHYJCLMXHEUCUDVTVMWLXCYCYFYEYBEQNUM
        ZXHQNUMUNZYSEUKYGYJYHYQAXBYTBACDEFGHIJLMNPQRUAUBUCUDUGUHWAVGBAUUAXBBCDL
        NQSTUEWBVICXSEXHLMNOQYKUBUCUFUDWCWDWEXCXMHXKLUOZQOUOZHXCXLUUBQOXCYCYLYM
        XLUUBUKYGYNYPCLMXKHUCUDVTVMWLXCYCYMYLYBHQNUMZXKQNUMUNZUUCHUKYGYPYNYQAXB
        UUDBACDEFGHIJLMNPQRUAUBUCUDUIWFWGBAUUEXBBCDLNQSTUEWHVICXSHXKLMNOQYKUBUC
        UFUDWCWDWEWIAXBXOXFUKZBAEHWJZUUFACDEFGHIJLMNPQRUAUBUCUDUGUHWKAMWMVAZYFY
        MUUGUUFWNAYCUUHYDMWOVFZYIYOCEHMOXFUFXFVKZUDWPVMWQVGWRXCUUHKCVAYBXDXGWNA
        XBUUHBUUIVGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJWSYQCXSKMNOQXFYKUBUF
        UUJUDWTVMXA $.

      $( Lemma for ~ dath .  Show that the dummy center of perspectivity ` c `
         is different from auxiliary atom ` G ` .  (Contributed by NM,
         3-Aug-2012.) $)
      dalem25 $p |- ( ( ph /\ Y = Z /\ ps ) -> c =/= G ) $=
        ( wceq w3a wne cv dalemcnes 3ad2ant1 wa co dalemclccjdd 3ad2ant3 adantr
        wbr clat wcel cbs cfv dalemkelat chlt dalemkehl dalemccea dalempea eqid
        hlatjcl syl3anc dalemddea dalemsea latmle2 syl5eqbr hlatjcom breqtrd wb
        simpr hlatlej2 dalemcceb atbase syl latjle12 syl13anc mpbi2and dalemceb
        eqbrtrd wi lattr mp2and dalemyeb latmlem1 mpd dalem17 3adant3 latleeqm1
        mpbid wn dalemsly dalem-ddly 2atjm syl132anc 3brtr3d cal hlatl dalemcea
        atcmp ex necon3d ) AQRUKZBULZDHUMZSUNZKUMAXNXPBACDEFGHIJLMNPQRUAUBUCUDU
        OUPXOXQKDHXOXQKUKZDHUKZXOXRUQZDHNVBZXSXTDQOURZHTUNZLURZQOURZDHNXTDYDNVB
        ZYBYENVBZXTDXQYCLURZNVBZYHYDNVBZYFXOYIXRBAYIXNBCDLNQSTUEUSUTVAXTXQYDNVB
        ZYCYDNVBZYJXTXQKYDNXOXRWBXOKYDNVBXRXOKYCHLURZYDNXOKXQELURZYMOURZYMNUJXO
        MVCVDZYNMVEVFZVDZYMYQVDZYOYMNVBAXNYPBACDEFGHIJLMNPQRUAVGUPZXOMVHVDZXQCV
        DZECVDZYRAXNUUABACDEFGHIJLMNPQRUAVIZUPZBAUUBXNBCDLNQSTUEVJUTZAXNUUCBACD
        EFGHIJLMNPQRUAVKUPCYQLMXQEYQVLZUCUDVMVNXOUUAYCCVDZHCVDZYSUUEBAUUHXNBCDL
        NQSTUEVOZUTZAXNUUIBACDEFGHIJLMNPQRUAVPZUPZCYQLMYCHUUGUCUDVMVNYQMNOYNYMU
        UGUBUFVQVNVRXOUUAUUHUUIYMYDUKUUEUUKUUMCLMYCHUCUDVSVNVTVAWKXOYLXRXOUUAUU
        IUUHYLUUEUUMUUKCHYCLMNUBUCUDWCVNVAXOYKYLUQYJWAZXRXOYPXQYQVDZYCYQVDZYDYQ
        VDZUUNYTBAUUOXNBCDLMNQSTUEUDWDUTBAUUPXNBUUHUUPUUJCYQYCMUUGUDWEWFUTXOUUA
        UUIUUHUUQUUEUUMUUKCYQLMHYCUUGUCUDVMVNZYQLMNXQYCYDUUGUBUCWGWHVAWIXOYIYJU
        QYFWLZXRXOYPDYQVDZYHYQVDZUUQUUSYTAXNUUTBACDEFGHIJLMNPQRUAUDWJUPZXOUUAUU
        BUUHUVAUUEUUFUUKCYQLMXQYCUUGUCUDVMVNUURYQMNDYHYDUUGUBWMWHVAWNXOYFYGWLZX
        RXOYPUUTUUQQYQVDZUVCYTUVBUURAXNUVDBACDEFGHIJLMNPQRUAUGWOUPZYQMNODYDQUUG
        UBUFWPWHVAWQXOYBDUKZXRXODQNVBZUVFAXNUVGBACDEFGHIJLMNPQRUAUBUCUDUGUHUIWR
        WSXOYPUUTUVDUVGUVFWAYTUVBUVEYQMNODQUUGUBUFWTVNXAVAXOYEHUKZXRXOUUAUUIUUH
        UVDHQNVBZYCQNVBXBZUVHUUEUUMUUKUVEAXNUVIBACDEFGHIJLMNPQRUAUBUCUDUIXCWSBA
        UVJXNBCDLNQSTUEXDUTCYQHYCLMNOQUUGUBUCUFUDXEXFVAXGXOYAXSWAZXRAXNUVKBAMXH
        VDZDCVDUUIUVKAUUAUVLUUDMXIWFACDEFGHIJLMNPQRUAUBUCUDUGUHXJUULCDHMNUBUDXK
        VNUPVAXAXLXMWQ $.

      $( Lemma for ~ dath .  Show that the line ` G P ` intersects the dummy
         center of perspectivity ` c ` .  (Contributed by NM, 8-Aug-2012.) $)
      dalem27 $p |- ( ( ph /\ Y = Z /\ ps ) -> c .<_ ( G .\/ P ) ) $=
        ( wceq w3a cv wbr clat wcel cbs dalemkelat 3ad2ant1 dalemkehl dalemccea
        chlt 3ad2ant3 dalempea eqid hlatjcl syl3anc dalemddea dalemsea syl5eqbr
        co cfv latmle1 wne wi dalem23 wn dalemply dalem24 nbrne2 necomd syl2anc
        wa hlatexch2 syl131anc mpd ) AQRUKZBULZKSUMZELVKZNUNZWIKELVKNUNZWHKWJTU
        MZHLVKZOVKZWJNUJWHMUOUPZWJMUQVLZUPZWNWQUPZWOWJNUNAWGWPBACDEFGHIJLMNPQRU
        AURUSWHMVBUPZWICUPZECUPZWRAWGWTBACDEFGHIJLMNPQRUAUTUSZBAXAWGBCDLNQSTUEV
        AVCZAWGXBBACDEFGHIJLMNPQRUAVDUSZCWQLMWIEWQVEZUCUDVFVGWHWTWMCUPZHCUPZWSX
        CBAXGWGBCDLNQSTUEVHVCAWGXHBACDEFGHIJLMNPQRUAVIUSCWQLMWMHXFUCUDVFVGWQMNO
        WJWNXFUBUFVMVGVJWHWTKCUPXAXBKEVNZWKWLVOXCABCDEFGHIJKLMNOPQRSTUAUBUCUDUE
        UFUGUHUIUJVPXDXEWHEQNUNZKQNUNVQZXIAWGXJBACDEFGHIJLMNPQRUAUBUCUDUGUHVRUS
        ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVSXJXKWCEKEKQNVTWAWBCKWIELMNUBU
        CUDWDWEWF $.

      $( Lemma for ~ dath .  Lemma ~ dalem27 expressed differently.
         (Contributed by NM, 4-Aug-2012.) $)
      dalem28 $p |- ( ( ph /\ Y = Z /\ ps ) -> P .<_ ( G .\/ c ) ) $=
        ( wceq w3a cv co wbr dalem27 chlt wcel wne dalemkehl 3ad2ant1 dalemccea
        wi 3ad2ant3 dalempea dalem23 dalem25 hlatexch1 syl131anc mpd ) AQRUKZBU
        LZSUMZKELUNNUOZEKVMLUNNUOZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUPVLM
        UQURZVMCURZECURZKCURVMKUSVNVOVCAVKVPBACDEFGHIJLMNPQRUAUTVABAVQVKBCDLNQS
        TUEVBVDAVKVRBACDEFGHIJLMNPQRUAVEVAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
        IUJVFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVGCVMEKLMNUBUCUDVHVIVJ $.
    $}

    ${
      dalem29.m $e |- ./\ = ( meet ` K ) $.
      dalem29.o $e |- O = ( LPlanes ` K ) $.
      dalem29.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem29.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem29.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem23 for ` H ` .  (Contributed by
         NM, 2-Aug-2012.) $)
      dalem29 $p |- ( ( ph /\ Y = Z /\ ps ) -> H e. A ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem23 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZKCUNAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAVMVSBAC
        DEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUHVGVHVR
        WBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.

      $( Lemma for ~ dath .  Analog of ~ dalem24 for ` H ` .  (Contributed by
         NM, 3-Aug-2012.) $)
      dalem30 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. H .<_ Y ) $=
        ( wceq w3a wbr co chlt wcel cbs cfv wa wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem24 dalemqrprot syl6reqr
        syl3anc wb breq2d mtbird ) AQRUKZBULZKQNUMZKFGLUNZELUNZNUMZVSMUOUPDMUQU
        RUPUSFCUPGCUPECUPULICUPJCUPHCUPULULWBPUPIJLUNZHLUNZPUPUSDWANUMVDDGELUNN
        UMVDDEFLUNZNUMVDULDWDNUMVDDJHLUNNUMVDDHILUNNUMVDULDFILUNNUMDGJLUNNUMDEH
        LUNNUMULULULZWBWEUKZSVEZCUPTVEZCUPUSWIWBNUMVDWJWIUTWJWBNUMVDDWIWJLUNNUM
        ULULZWCVDAVRWGBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAVRWHBACDEFGHIJLMNPQRUAUB
        UCUDUHUIVCVFABWKVRABCDEFGHIJLMNPQRSTUAUBUCUDUEUHVGVHWGWKCDFGEIJHKLMNOPW
        BWESTWGVIUBUCUDWKVIUFUGWBVJWEVJUJVKVNAVRVTWCVOBAQWBKNAWBWFGLUNQACDEFGHI
        JLMNPQRUAUCUDVLUHVMVPVBVQ $.

      $( Lemma for ~ dath .  Analog of ~ dalem25 for ` H ` .  (Contributed by
         NM, 4-Aug-2012.)  (New usage is discouraged.) $)
      dalem31N $p |- ( ( ph /\ Y = Z /\ ps ) -> c =/= H ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem25 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZVTKUTAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAVMVSBA
        CDEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUHVGVHV
        RWBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.

      $( Lemma for ~ dath .  Analog of ~ dalem27 for ` H ` .  (Contributed by
         NM, 8-Aug-2012.) $)
      dalem32 $p |- ( ( ph /\ Y = Z /\ ps ) -> c .<_ ( H .\/ Q ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem27 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZVTKFLURNUSAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAV
        MVSBACDEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUH
        VGVHVRWBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.

      $( Lemma for ~ dath .  Analog of ~ dalem28 for ` H ` .  (Contributed by
         NM, 4-Aug-2012.) $)
      dalem33 $p |- ( ( ph /\ Y = Z /\ ps ) -> Q .<_ ( H .\/ c ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem28 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZFKVTLURNUSAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAV
        MVSBACDEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUH
        VGVHVRWBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.
    $}

    ${
      dalem34.m $e |- ./\ = ( meet ` K ) $.
      dalem34.o $e |- O = ( LPlanes ` K ) $.
      dalem34.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem34.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem34.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem23 for ` I ` .  (Contributed by
         NM, 2-Aug-2012.) $)
      dalem34 $p |- ( ( ph /\ Y = Z /\ ps ) -> I e. A ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem29 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZKCUNAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAVMVSBAC
        DEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUHVGVHVR
        WBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.

      $( Lemma for ~ dath .  Analog of ~ dalem24 for ` I ` .  (Contributed by
         NM, 3-Aug-2012.) $)
      dalem35 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. I .<_ Y ) $=
        ( wceq w3a wbr co chlt wcel cbs cfv wa wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem30 dalemqrprot syl6reqr
        syl3anc wb breq2d mtbird ) AQRUKZBULZKQNUMZKFGLUNZELUNZNUMZVSMUOUPDMUQU
        RUPUSFCUPGCUPECUPULICUPJCUPHCUPULULWBPUPIJLUNZHLUNZPUPUSDWANUMVDDGELUNN
        UMVDDEFLUNZNUMVDULDWDNUMVDDJHLUNNUMVDDHILUNNUMVDULDFILUNNUMDGJLUNNUMDEH
        LUNNUMULULULZWBWEUKZSVEZCUPTVEZCUPUSWIWBNUMVDWJWIUTWJWBNUMVDDWIWJLUNNUM
        ULULZWCVDAVRWGBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAVRWHBACDEFGHIJLMNPQRUAUB
        UCUDUHUIVCVFABWKVRABCDEFGHIJLMNPQRSTUAUBUCUDUEUHVGVHWGWKCDFGEIJHKLMNOPW
        BWESTWGVIUBUCUDWKVIUFUGWBVJWEVJUJVKVNAVRVTWCVOBAQWBKNAWBWFGLUNQACDEFGHI
        JLMNPQRUAUCUDVLUHVMVPVBVQ $.

      $( Lemma for ~ dath .  Analog of ~ dalem27 for ` I ` .  (Contributed by
         NM, 8-Aug-2012.) $)
      dalem36 $p |- ( ( ph /\ Y = Z /\ ps ) -> c .<_ ( I .\/ R ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem32 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZVTKGLURNUSAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAV
        MVSBACDEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUH
        VGVHVRWBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.

      $( Lemma for ~ dath .  Analog of ~ dalem28 for ` I ` .  (Contributed by
         NM, 4-Aug-2012.) $)
      dalem37 $p |- ( ( ph /\ Y = Z /\ ps ) -> R .<_ ( I .\/ c ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem33 syl3anc ) AQRUKZBULM
        UMUNDMUOUPUNUQFCUNGCUNECUNULICUNJCUNHCUNULULFGLURZELURZPUNIJLURZHLURZPU
        NUQDVNNUSVDDGELURNUSVDDEFLURNUSVDULDVPNUSVDDJHLURNUSVDDHILURNUSVDULDFIL
        URNUSDGJLURNUSDEHLURNUSULULULZVOVQUKZSVEZCUNTVEZCUNUQVTVONUSVDWAVTUTWAV
        ONUSVDDVTWALURNUSULULZGKVTLURNUSAVMVRBACDEFGHIJLMNPQRUAUBUCUDUHUIVAVBAV
        MVSBACDEFGHIJLMNPQRUAUBUCUDUHUIVCVFABWBVMABCDEFGHIJLMNPQRSTUAUBUCUDUEUH
        VGVHVRWBCDFGEIJHKLMNOPVOVQSTVRVIUBUCUDWBVIUFUGVOVJVQVJUJVKVL $.
    $}

    ${
      dalem38.m $e |- ./\ = ( meet ` K ) $.
      dalem38.o $e |- O = ( LPlanes ` K ) $.
      dalem38.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem38.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem38.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem38.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem38.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      $( Lemma for ~ dath .  Plane ` Y ` belongs to the 3-dimensional volume
         ` G H I c ` .  (Contributed by NM, 5-Aug-2012.) $)
      dalem38 $p |- ( ( ph /\ Y = Z /\ ps )
    -> Y .<_ ( ( ( G .\/ H ) .\/ I ) .\/ c ) ) $=
        ( wceq w3a co cv wbr dalem28 dalem33 clat wcel cbs cfv wa wi dalemkelat
        3ad2ant1 dalempeb chlt dalemkehl dalem23 dalemccea eqid hlatjcl syl3anc
        3ad2ant3 dalemqeb dalem29 latjlej12 syl122anc mp2and dalemcceb latjjdir
        atbase syl syl13anc breqtrrd dalem37 dalempjqeb latjcl dalemreb dalem34
        syl5eqbr ) ASTUOZBUPZSEFNUQZGNUQZKLNUQZMNUQUAURZNUQZPUJWQWSWTXANUQZMXAN
        UQZNUQZXBPWQWRXCPUSZGXDPUSZWSXEPUSZWQWRKXANUQZLXANUQZNUQZXCPWQEXIPUSZFX
        JPUSZWRXKPUSZABCDEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUTABCDEFGHIJLNOP
        QRSTUAUBUCUDUEUFUGUHUIUJUKUMVAWQOVBVCZEOVDVEZVCZXIXPVCZFXPVCZXJXPVCZXLX
        MVFXNVGAWPXOBACDEFGHIJNOPRSTUCVHVIZAWPXQBACDEFGHIJNOPRSTUCUFVJVIWQOVKVC
        ZKCVCZXACVCZXRAWPYBBACDEFGHIJNOPRSTUCVLVIZABCDEFGHIJKNOPQRSTUAUBUCUDUEU
        FUGUHUIUJUKULVMZBAYDWPBCDNPSUAUBUGVNVRZCXPNOKXAXPVOZUEUFVPVQAWPXSBACDEF
        GHIJNOPRSTUCUFVSVIWQYBLCVCZYDXTYEABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJ
        UKUMVTZYGCXPNOLXAYHUEUFVPVQXPNOPXJEXIFYHUDUEWAWBWCWQXOKXPVCZLXPVCZXAXPV
        CZXCXKUOYAWQYCYKYFCXPKOYHUFWFWGWQYIYLYJCXPLOYHUFWFWGBAYMWPBCDNOPSUAUBUG
        UFWDVRZXPNOKLXAYHUEWEWHWIABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNWJWQ
        XOWRXPVCZXCXPVCZGXPVCZXDXPVCZXFXGVFXHVGYAAWPYOBACDEFGHIJNOPRSTUCUEUFWKV
        IWQXOWTXPVCZYMYPYAWQYBYCYIYSYEYFYJCXPNOKLYHUEUFVPVQZYNXPNOWTXAYHUEWLVQA
        WPYQBACDEFGHIJNOPRSTUCUFWMVIWQYBMCVCZYDYRYEABCDEFGHIJMNOPQRSTUAUBUCUDUE
        UFUGUHUIUJUKUNWNZYGCXPNOMXAYHUEUFVPVQXPNOPXDWRXCGYHUDUEWAWBWCWQXOYSMXPV
        CZYMXBXEUOYAYTWQUUAUUCUUBCXPMOYHUFWFWGYNXPNOWTMXAYHUEWEWHWIWO $.

      $( Lemma for ~ dath .  Auxiliary atoms ` G ` , ` H ` , and ` I ` are not
         colinear.  (Contributed by NM, 4-Aug-2012.) $)
      dalem39 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. H .<_ ( I .\/ G ) ) $=
        ( wceq w3a co wbr cv chlt wcel clvol cfv wn dalemkehl 3ad2ant1 dalemyeo
        dalemccea 3ad2ant3 dalem-ccly eqid syl31anc dalem34 lvolnle3at syl23anc
        lvoli3 dalem23 wa dalem38 cbs dalemkelat dalem29 hlatjcl syl3anc atbase
        clat syl dalemcceb latlej2 dalemyeb latjle12 syl13anc mpbi2and hlatjrot
        latjcl wb oveq1d breqtrd adantr latleeqj2 biimpa mtand ) ASTUOZBUPZLMKN
        UQZPURZSUAUSZNUQZXEXGNUQZPURZXDOUTVAZXHOVBVCZVAZMCVAZKCVAZXGCVAZXJVDAXC
        XKBACDEFGHIJNOPRSTUCVEVFZXDXKSRVAZXPXGSPURVDZXMXQAXCXRBACDEFGHIJNOPRSTU
        CVGVFBAXPXCBCDNPSUAUBUGVHVIZBAXSXCBCDNPSUAUBUGVJVICRXGNOPXLSUDUEUFUIXLV
        KZVPVLABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVMZABCDEFGHIJKNOPQRSTUA
        UBUCUDUEUFUGUHUIUJUKULVQZXTCMKXGNOPXLXHUDUEUFYAVNVOXDXFVRZXHXELNUQZXGNU
        QZXIPXDXHYFPURXFXDXHKLNUQZMNUQZXGNUQZYFPXDSYIPURZXGYIPURZXHYIPURZABCDEF
        GHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVSXDOWFVAZYHOVTVCZVAZXGYNVAZY
        KAXCYMBACDEFGHIJNOPRSTUCWAVFZXDYMYGYNVAZMYNVAZYOYQXDXKXOLCVAZYRXQYCABCD
        EFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMWBZCYNNOKLYNVKZUEUFWCWDXDXNYSYBCY
        NMOUUBUFWEWGYNNOYGMUUBUEWOWDZBAYPXCBCDNOPSUAUBUGUFWHVIZYNNOPYHXGUUBUDUE
        WIWDXDYMSYNVAZYPYIYNVAZYJYKVRYLWPYQAXCUUEBACDEFGHIJNOPRSTUCUIWJVFUUDXDY
        MYOYPUUFYQUUCUUDYNNOYHXGUUBUEWOWDYNNOPSXGYIUUBUDUEWKWLWMXDYHYEXGNXDXKXO
        YTXNYHYEUOXQYCUUAYBCKLMNOUEUFWNWLWQWRWSYDYEXEXGNXDXFYEXEUOZXDYMLYNVAZXE
        YNVAZXFUUGWPYQXDYTUUHUUACYNLOUUBUFWEWGXDXKXNXOUUIXQYBYCCYNNOMKUUBUEUFWC
        WDYNNOPLXEUUBUDUEWTWDXAWQWRXB $.

      $( Lemma for ~ dath .  Analog of ~ dalem39 for ` I ` .  (Contributed by
         NM, 4-Aug-2012.) $)
      dalem40 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. I .<_ ( G .\/ H ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem39 syl3anc ) ASTUOZBUPO
        UQURDOUSUTURVAFCURGCURECURUPICURJCURHCURUPUPFGNVBZENVBZRURIJNVBZHNVBZRU
        RVADVRPVCVHDGENVBPVCVHDEFNVBPVCVHUPDVTPVCVHDJHNVBPVCVHDHINVBPVCVHUPDFIN
        VBPVCDGJNVBPVCDEHNVBPVCUPUPUPZVSWAUOZUAVIZCURUBVIZCURVAWDVSPVCVHWEWDVDW
        EVSPVCVHDWDWENVBPVCUPUPZMKLNVBPVCVHAVQWBBACDEFGHIJNOPRSTUCUDUEUFUJUKVEV
        FAVQWCBACDEFGHIJNOPRSTUCUDUEUFUJUKVGVJABWFVQABCDEFGHIJNOPRSTUAUBUCUDUEU
        FUGUJVKVLWBWFCDFGEIJHLMKNOPQRVSWAUAUBWBVMUDUEUFWFVMUHUIVSVNWAVNUMUNULVO
        VP $.

      $( Lemma for ~ dath .  (Contributed by NM, 4-Aug-2012.) $)
      dalem41 $p |- ( ( ph /\ Y = Z /\ ps ) -> G =/= H ) $=
        ( wceq w3a chlt wcel wbr wne dalemkehl 3ad2ant1 dalem29 dalem34 dalem23
        co wn dalem39 atnlej2 syl131anc necomd ) ASTUOZBUPZLKVMOUQURZLCURMCURKC
        URLMKNVFPUSVGLKUTAVLVNBACDEFGHIJNOPRSTUCVAVBABCDEFGHIJLNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKUMVCABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVDABCDEFGHIJ
        KNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVEABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
        IUJUKULUMUNVHCLMKNOPUDUEUFVIVJVK $.

      $( Lemma for ~ dath .  Auxiliary atoms ` G H I ` form a plane.
         (Contributed by NM, 4-Aug-2012.) $)
      dalem42 $p |- ( ( ph /\ Y = Z /\ ps )
            -> ( ( G .\/ H ) .\/ I ) e. O ) $=
        ( wceq w3a chlt wcel wne wbr dalemkehl 3ad2ant1 dalem23 dalem29 dalem34
        co wn dalem41 dalem40 lplni2 syl132anc ) ASTUOZBUPOUQURZKCURLCURMCURKLU
        SMKLNVFZPUTVGVNMNVFRURAVLVMBACDEFGHIJNOPRSTUCVAVBABCDEFGHIJKNOPQRSTUAUB
        UCUDUEUFUGUHUIUJUKULVCABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMVDABCDE
        FGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVEABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUF
        UGUHUIUJUKULUMUNVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVICRK
        LMNOPUDUEUFUIVJVK $.

      $( Lemma for ~ dath .  Planes ` G H I ` and ` Y ` are different.
         (Contributed by NM, 8-Aug-2012.) $)
      dalem43 $p |- ( ( ph /\ Y = Z /\ ps )
             -> ( ( G .\/ H ) .\/ I ) =/= Y ) $=
        ( wceq w3a wbr wne clat wcel cbs cfv dalemkelat 3ad2ant1 chlt dalemkehl
        dalem23 dalem29 eqid hlatjcl syl3anc dalem34 atbase syl latlej2 dalem35
        co wn nbrne1 syl2anc ) ASTUOZBUPZMKLNVQZMNVQZPUQZMSPUQVRWDSURWBOUSUTZWC
        OVAVBZUTZMWGUTZWEAWAWFBACDEFGHIJNOPRSTUCVCVDWBOVEUTZKCUTLCUTWHAWAWJBACD
        EFGHIJNOPRSTUCVFVDABCDEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVGABCDEFGHI
        JLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMVHCWGNOKLWGVIZUEUFVJVKWBMCUTWIABCDEFGH
        IJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVLCWGMOWKUFVMVNWGNOPWCMWKUDUEVOVKABCD
        EFGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVPMWDSPVSVT $.
    $}

    ${
      dalem44.m $e |- ./\ = ( meet ` K ) $.
      dalem44.o $e |- O = ( LPlanes ` K ) $.
      dalem44.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem44.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem44.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem44.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem44.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      $( Todo: do we need this for other than -. c .<_ ( G .\/ H )? $)
      $( Lemma for ~ dath .  Dummy center of perspectivity ` c ` lies outside
         of plane ` G H I ` .  (Contributed by NM, 16-Aug-2012.) $)
      dalem44 $p |- ( ( ph /\ Y = Z /\ ps )
   -> -. c .<_ ( ( G .\/ H ) .\/ I ) ) $=
        ( wceq w3a co wne cv wbr wn dalem43 necomd clat wcel cbs cfv dalemkelat
        3ad2ant1 dalemcceb 3ad2ant3 dalem42 eqid lplnbase syl latleeqj1 syl3anc
        wb dalem28 chlt dalemkehl dalemccea dalem23 hlatjcom dalem33 dalem29 wa
        breqtrrd wi dalempeb hlatjcl dalemqeb latjlej12 syl122anc mp2and atbase
        latjjdi syl13anc dalem37 dalem34 dalempjqeb dalemreb syl5eqbr syl5ibcom
        latjcl breq2 sylbid dalemyeo lplncmp sylibd necon3ad mpd ) ASTUOZBUPZSK
        LNUQZMNUQZURUAUSZXPPUTZVAXNXPSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
        KULUMUNVBVCXNXRSXPXNXRSXPPUTZSXPUOZXNXRXQXPNUQZXPUOZXSXNOVDVEZXQOVFVGZV
        EZXPYDVEZXRYBVRAXMYCBACDEFGHIJNOPRSTUCVHVIZBAYEXMBCDNOPSUAUBUGUFVJVKZXN
        XPRVEZYFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVLZYDROXPYDVMZU
        IVNVOYDNOPXQXPYKUDUEVPVQXNSYAPUTYBXSXNSEFNUQZGNUQZYAPUJXNYMXQXONUQZXQMN
        UQZNUQZYAPXNYLYNPUTZGYOPUTZYMYPPUTZXNYLXQKNUQZXQLNUQZNUQZYNPXNEYTPUTZFU
        UAPUTZYLUUBPUTZXNEKXQNUQZYTPABCDEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULV
        SXNOVTVEZXQCVEZKCVEZYTUUFUOAXMUUGBACDEFGHIJNOPRSTUCWAVIZBAUUHXMBCDNPSUA
        UBUGWBVKZABCDEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWCZCNOXQKUEUFWDVQWHX
        NFLXQNUQZUUAPABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMWEXNUUGUUHLCVEZU
        UAUUMUOUUJUUKABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMWFZCNOXQLUEUFWDV
        QWHXNYCEYDVEZYTYDVEZFYDVEZUUAYDVEZUUCUUDWGUUEWIYGAXMUUPBACDEFGHIJNOPRST
        UCUFWJVIXNUUGUUHUUIUUQUUJUUKUULCYDNOXQKYKUEUFWKVQAXMUURBACDEFGHIJNOPRST
        UCUFWLVIXNUUGUUHUUNUUSUUJUUKUUOCYDNOXQLYKUEUFWKVQYDNOPUUAEYTFYKUDUEWMWN
        WOXNYCYEKYDVEZLYDVEZYNUUBUOYGYHXNUUIUUTUULCYDKOYKUFWPVOXNUUNUVAUUOCYDLO
        YKUFWPVOYDNOXQKLYKUEWQWRWHXNGMXQNUQZYOPABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUG
        UHUIUJUKUNWSXNUUGUUHMCVEZYOUVBUOUUJUUKABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGU
        HUIUJUKUNWTZCNOXQMUEUFWDVQWHXNYCYLYDVEZYNYDVEZGYDVEZYOYDVEZYQYRWGYSWIYG
        AXMUVEBACDEFGHIJNOPRSTUCUEUFXAVIXNYCYEXOYDVEZUVFYGYHXNUUGUUIUUNUVIUUJUU
        LUUOCYDNOKLYKUEUFWKVQZYDNOXQXOYKUEXEVQAXMUVGBACDEFGHIJNOPRSTUCUFXBVIXNU
        UGUUHUVCUVHUUJUUKUVDCYDNOXQMYKUEUFWKVQYDNOPYOYLYNGYKUDUEWMWNWOXNYCYEUVI
        MYDVEZYAYPUOYGYHUVJXNUVCUVKUVDCYDMOYKUFWPVOYDNOXQXOMYKUEWQWRWHXCYAXPSPX
        FXDXGXNUUGSRVEZYIXSXTVRUUJAXMUVLBACDEFGHIJNOPRSTUCXHVIYJROPSXPUDUIXIVQX
        JXKXL $.

      $( Lemma for ~ dath .  Dummy center of perspectivity ` c ` is not on the
         line ` G H ` .  (Contributed by NM, 16-Aug-2012.) $)
      dalem45 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. c .<_ ( G .\/ H ) ) $=
        ( wceq w3a clat wcel cv cbs cfv co wbr wn dalemkelat 3ad2ant1 dalemcceb
        3ad2ant3 chlt dalemkehl dalem23 dalem29 eqid hlatjcl syl3anc atbase syl
        dalem34 dalem44 latnlej2l syl131anc ) ASTUOZBUPZOUQURZUAUSZOUTVAZURZKLN
        VBZWFURZMWFURZWEWHMNVBPVCVDWEWHPVCVDAWBWDBACDEFGHIJNOPRSTUCVEVFBAWGWBBC
        DNOPSUAUBUGUFVGVHWCOVIURZKCURLCURWIAWBWKBACDEFGHIJNOPRSTUCVJVFABCDEFGHI
        JKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVKABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUI
        UJUKUMVLCWFNOKLWFVMZUEUFVNVOWCMCURWJABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHU
        IUJUKUNVRCWFMOWLUFVPVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNV
        SWFNOPWEWHMWLUDUEVTWA $.

      $( Lemma for ~ dath .  Analog of ~ dalem45 for ` H I ` .  (Contributed by
         NM, 16-Aug-2012.) $)
      dalem46 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. c .<_ ( H .\/ I ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem45 syl3anc ) ASTUOZBUPO
        UQURDOUSUTURVAFCURGCURECURUPICURJCURHCURUPUPFGNVBZENVBZRURIJNVBZHNVBZRU
        RVADVRPVCVHDGENVBPVCVHDEFNVBPVCVHUPDVTPVCVHDJHNVBPVCVHDHINVBPVCVHUPDFIN
        VBPVCDGJNVBPVCDEHNVBPVCUPUPUPZVSWAUOZUAVIZCURUBVIZCURVAWDVSPVCVHWEWDVDW
        EVSPVCVHDWDWENVBPVCUPUPZWDLMNVBPVCVHAVQWBBACDEFGHIJNOPRSTUCUDUEUFUJUKVE
        VFAVQWCBACDEFGHIJNOPRSTUCUDUEUFUJUKVGVJABWFVQABCDEFGHIJNOPRSTUAUBUCUDUE
        UFUGUJVKVLWBWFCDFGEIJHLMKNOPQRVSWAUAUBWBVMUDUEUFWFVMUHUIVSVNWAVNUMUNULV
        OVP $.

      $( Lemma for ~ dath .  Analog of ~ dalem45 for ` I G ` .  (Contributed by
         NM, 16-Aug-2012.) $)
      dalem47 $p |- ( ( ph /\ Y = Z /\ ps ) -> -. c .<_ ( I .\/ G ) ) $=
        ( wceq w3a chlt wcel cbs cfv wa co wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid eqid dalem46 syl3anc ) ASTUOZBUPO
        UQURDOUSUTURVAFCURGCURECURUPICURJCURHCURUPUPFGNVBZENVBZRURIJNVBZHNVBZRU
        RVADVRPVCVHDGENVBPVCVHDEFNVBPVCVHUPDVTPVCVHDJHNVBPVCVHDHINVBPVCVHUPDFIN
        VBPVCDGJNVBPVCDEHNVBPVCUPUPUPZVSWAUOZUAVIZCURUBVIZCURVAWDVSPVCVHWEWDVDW
        EVSPVCVHDWDWENVBPVCUPUPZWDMKNVBPVCVHAVQWBBACDEFGHIJNOPRSTUCUDUEUFUJUKVE
        VFAVQWCBACDEFGHIJNOPRSTUCUDUEUFUJUKVGVJABWFVQABCDEFGHIJNOPRSTUAUBUCUDUE
        UFUGUJVKVLWBWFCDFGEIJHLMKNOPQRVSWAUAUBWBVMUDUEUFWFVMUHUIVSVNWAVNUMUNULV
        OVP $.

      $( Lemma for ~ dath .  Analog of ~ dalem45 for ` P Q ` .  (Contributed by
         NM, 16-Aug-2012.) $)
      dalem48 $p |- ( ( ph /\ ps ) -> -. c .<_ ( P .\/ Q ) ) $=
        ( wa clat wcel cv cbs cfv co wbr dalemkelat adantr dalemcceb dalempjqeb
        wn adantl dalemreb dalem-ccly breq2i sylnib eqid latnlej2l syl131anc )
        ABUOOUPUQZUAURZOUSUTZUQZEFNVAZVRUQZGVRUQZVQVTGNVAZPVBZVGZVQVTPVBVGAVPBA
        CDEFGHIJNOPRSTUCVCVDBVSABCDNOPSUAUBUGUFVEVHAWABACDEFGHIJNOPRSTUCUEUFVFV
        DAWBBACDEFGHIJNOPRSTUCUFVIVDBWEABVQSPVBWDBCDNPSUAUBUGVJSWCVQPUJVKVLVHVR
        NOPVQVTGVRVMUDUEVNVO $.

      $( Lemma for ~ dath .  Analog of ~ dalem45 for ` Q R ` .  (Contributed by
         NM, 16-Aug-2012.) $)
      dalem49 $p |- ( ( ph /\ ps ) -> -. c .<_ ( Q .\/ R ) ) $=
        ( wa chlt wcel cbs cfv w3a co wbr wn cv dalemrot adantr dalemrotps biid
        wne eqid dalem48 syl2anc ) ABUOOUPUQDOURUSUQUOFCUQGCUQECUQUTICUQJCUQHCU
        QUTUTFGNVAZENVAZRUQIJNVAZHNVAZRUQUODVMPVBVCDGENVAPVBVCDEFNVAPVBVCUTDVOP
        VBVCDJHNVAPVBVCDHINVAPVBVCUTDFINVAPVBDGJNVAPVBDEHNVAPVBUTUTUTZUAVDZCUQU
        BVDZCUQUOVRVNPVBVCVSVRVIVSVNPVBVCDVRVSNVAPVBUTUTZVRVMPVBVCAVQBACDEFGHIJ
        NOPRSTUCUDUEUFUJUKVEVFABCDEFGHIJNOPRSTUAUBUCUDUEUFUGUJVGVQVTCDFGEIJHLMK
        NOPQRVNVPUAUBVQVHUDUEUFVTVHUHUIVNVJVPVJUMUNULVKVL $.

      $( Lemma for ~ dath .  Analog of ~ dalem45 for ` R P ` .  (Contributed by
         NM, 16-Aug-2012.) $)
      dalem50 $p |- ( ( ph /\ ps ) -> -. c .<_ ( R .\/ P ) ) $=
        ( wa chlt wcel cbs cfv w3a co wbr wn cv dalemrot adantr dalemrotps biid
        wne eqid dalem49 syl2anc ) ABUOOUPUQDOURUSUQUOFCUQGCUQECUQUTICUQJCUQHCU
        QUTUTFGNVAZENVAZRUQIJNVAZHNVAZRUQUODVMPVBVCDGENVAZPVBVCDEFNVAPVBVCUTDVO
        PVBVCDJHNVAPVBVCDHINVAPVBVCUTDFINVAPVBDGJNVAPVBDEHNVAPVBUTUTUTZUAVDZCUQ
        UBVDZCUQUOVSVNPVBVCVTVSVIVTVNPVBVCDVSVTNVAPVBUTUTZVSVQPVBVCAVRBACDEFGHI
        JNOPRSTUCUDUEUFUJUKVEVFABCDEFGHIJNOPRSTUAUBUCUDUEUFUGUJVGVRWACDFGEIJHLM
        KNOPQRVNVPUAUBVRVHUDUEUFWAVHUHUIVNVJVPVJUMUNULVKVL $.

      $( Lemma for ~ dath .  Construct the condition ` ph ` with ` c ` ,
         ` G H I ` , and ` Y ` in place of ` C ` , ` Y ` , and ` Z `
         respectively.  This lets us reuse the special case of Desargues'
         Theorem where ` Y =/= Z ` , to eventually prove the case where
         ` Y = Z ` .  (Contributed by NM, 16-Aug-2012.) $)
      dalem51 $p |- ( ( ph /\ Y = Z /\ ps )
  -> ( ( ( ( K e. HL /\ c e. A )
      /\ ( G e. A /\ H e. A /\ I e. A )
      /\ ( P e. A /\ Q e. A /\ R e. A ) )
  /\ ( ( ( G .\/ H ) .\/ I ) e. O /\ Y e. O )
  /\ ( ( -. c .<_ ( G .\/ H ) /\ -. c .<_ ( H .\/ I )
    /\ -. c .<_ ( I .\/ G ) )
    /\ ( -. c .<_ ( P .\/ Q ) /\ -. c .<_ ( Q .\/ R )
     /\ -. c .<_ ( R .\/ P ) )
    /\ ( c .<_ ( G .\/ P ) /\ c .<_ ( H .\/ Q )
       /\ c .<_ ( I .\/ R ) ) ) )
 /\ ( ( G .\/ H ) .\/ I ) =/= Y ) ) $=
        ( wceq w3a chlt wcel cv wa co wbr dalemkehl 3ad2ant1 dalemccea 3ad2ant3
        wne jca dalem23 dalem29 dalem34 3jca dalempea dalemqea dalemrea dalem42
        dalem45 dalem46 dalem47 dalem48 dalem49 dalem50 3adant2 dalem27 dalem32
        wn dalemyeo dalem36 dalem43 ) ASTUOZBUPZOUQURZUAUSZCURZUTZKCURZLCURZMCU
        RZUPZECURZFCURZGCURZUPZUPZKLNVAZMNVAZRURZSRURZUTZWMXEPVBWFZWMLMNVAPVBWF
        ZWMMKNVAPVBWFZUPZWMEFNVAPVBWFZWMFGNVAPVBWFZWMGENVAPVBWFZUPZWMKENVAPVBZW
        MLFNVAPVBZWMMGNVAPVBZUPZUPZUPXFSVGWKXDXIYBWKWOWSXCWKWLWNAWJWLBACDEFGHIJ
        NOPRSTUCVCVDBAWNWJBCDNPSUAUBUGVEVFVHWKWPWQWRABCDEFGHIJKNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULVIABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMVJABCDEFGHIJ
        MNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVKVLAWJXCBAWTXAXBACDEFGHIJNOPRSTUCVMACD
        EFGHIJNOPRSTUCVNACDEFGHIJNOPRSTUCVOVLVDVLWKXGXHABCDEFGHIJKLMNOPQRSTUAUB
        UCUDUEUFUGUHUIUJUKULUMUNVPAWJXHBACDEFGHIJNOPRSTUCWGVDVHWKXMXQYAWKXJXKXL
        ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVQABCDEFGHIJKLMNOPQRSTU
        AUBUCUDUEUFUGUHUIUJUKULUMUNVRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUK
        ULUMUNVSVLABXQWJABUTXNXOXPABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULU
        MUNVTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNWAABCDEFGHIJKLMNOP
        QRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNWBVLWCWKXRXSXTABCDEFGHIJKNOPQRSTUAUBUCU
        DUEUFUGUHUIUJUKULWDABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMWEABCDEFGH
        IJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNWHVLVLVLABCDEFGHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNWIVH $.

      $( Lemma for ~ dath .  Lines ` G H ` and ` P Q ` intersect at an atom.
         (Contributed by NM, 8-Aug-2012.) $)
      dalem52 $p |- ( ( ph /\ Y = Z /\ ps )
             -> ( ( G .\/ H ) ./\ ( P .\/ Q ) ) e. A ) $=
        ( wceq w3a chlt wcel cv cbs wa co dalemkehl 3ad2ant1 dalemcceb 3ad2ant3
        cfv wbr dalem23 dalem29 dalem34 3jca dalempea dalemqea dalemrea dalem42
        wn jca dalemyeo dalem45 dalem46 dalem47 dalem48 dalem49 dalem50 3adant2
        dalem27 dalem32 dalem36 biid eqid dalemdea syl323anc ) ASTUOZBUPZOUQURZ
        UAUSZOUTVGURZVAZKCURZLCURZMCURZUPZECURZFCURZGCURZUPZKLNVBZMNVBZRURZSRUR
        ZWQXHPVHVQZWQLMNVBPVHVQZWQMKNVBPVHVQZUPZWQEFNVBZPVHVQZWQFGNVBPVHVQZWQGE
        NVBPVHVQZUPZWQKENVBPVHZWQLFNVBPVHZWQMGNVBPVHZUPZXHXPQVBZCURWOWPWRAWNWPB
        ACDEFGHIJNOPRSTUCVCVDBAWRWNBCDNOPSUAUBUGUFVEVFVRWOWTXAXBABCDEFGHIJKNOPQ
        RSTUAUBUCUDUEUFUGUHUIUJUKULVIABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUM
        VJABCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVKVLAWNXGBAXDXEXFACDEFGHIJN
        OPRSTUCVMACDEFGHIJNOPRSTUCVNACDEFGHIJNOPRSTUCVOVLVDABCDEFGHIJKLMNOPQRST
        UAUBUCUDUEUFUGUHUIUJUKULUMUNVPAWNXKBACDEFGHIJNOPRSTUCVSVDWOXLXMXNABCDEF
        GHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVTABCDEFGHIJKLMNOPQRSTUAUBUCU
        DUEUFUGUHUIUJUKULUMUNWAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
        WBVLABXTWNABVAXQXRXSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNWCA
        BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNWDABCDEFGHIJKLMNOPQRSTUA
        UBUCUDUEUFUGUHUIUJUKULUMUNWEVLWFWOYAYBYCABCDEFGHIJKNOPQRSTUAUBUCUDUEUFU
        GUHUIUJUKULWGABCDEFGHIJLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUMWHABCDEFGHIJMNOP
        QRSTUAUBUCUDUEUFUGUHUIUJUKUNWIVLWSXCXGUPXJXKVAXOXTYDUPUPZCWQYEKLMEFGNOP
        QRXISYFWJUDUEUFUHUIXIWKUJYEWKWLWM $.
    $}

    ${
      dalem53.m $e |- ./\ = ( meet ` K ) $.
      dalem53.n $e |- N = ( LLines ` K ) $.
      dalem53.o $e |- O = ( LPlanes ` K ) $.
      dalem53.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem53.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem53.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem53.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem53.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      dalem53.b1 $e |- B = ( ( ( G .\/ H ) .\/ I ) ./\ Y ) $.
      $( Lemma for ~ dath .  The auxliary axis of perspectivity ` B ` is a line
         (analogous to the actual axis of perspectivity ` X ` in ~ dalem15 .
         (Contributed by NM, 8-Aug-2012.) $)
      dalem53 $p |- ( ( ph /\ Y = Z /\ ps ) -> B e. N ) $=
        ( wceq w3a chlt wcel cv wa co wbr wn wne dalem51 cbs eqid atbase anim2i
        cfv 3anim1i biid dalem15 syl3anl1 syl ) AUAUBUSBUTPVAVBZUCVCZCVBZVDZLCV
        BMCVBNCVBUTZFCVBGCVBHCVBUTZUTZLMOVEZNOVEZTVBUATVBVDZWAWGQVFVGWAMNOVEQVF
        VGWANLOVEQVFVGUTWAFGOVEQVFVGWAGHOVEQVFVGWAHFOVEQVFVGUTWALFOVEQVFWAMGOVE
        QVFWANHOVEQVFUTUTZUTWHUAVHZVDDSVBZABCEFGHIJKLMNOPQRTUAUBUCUDUEUFUGUHUIU
        JULUMUNUOUPUQVIWFVTWAPVJVNZVBZVDZWDWEUTZWIWJWKWLWCWOWDWEWBWNVTCWMWAPWMV
        KUHVLVMVOWPWIWJUTZCWALMNFGHOPQRSTDWHUAWQVPUFUGUHUJUKULWHVKUMURVQVRVS $.
    $}

    ${
      dalem54.m $e |- ./\ = ( meet ` K ) $.
      dalem54.o $e |- O = ( LPlanes ` K ) $.
      dalem54.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem54.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem54.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem54.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem54.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      dalem54.b1 $e |- B = ( ( ( G .\/ H ) .\/ I ) ./\ Y ) $.
      $( Todo:  can this be done more directly via darot2xx conversions? $)
      $( Lemma for ~ dath .  Line ` G H ` intersects the auxiliary axis of
         perspectivity ` B ` .  (Contributed by NM, 8-Aug-2012.) $)
      dalem54 $p |- ( ( ph /\ Y = Z /\ ps )
                -> ( ( G .\/ H ) ./\ B ) e. A ) $=
        ( wceq w3a chlt wcel co clln cfv wne dalemkehl 3ad2ant1 dalem23 dalem29
        cp0 dalem41 eqid llni2 syl31anc dalem53 wbr clat cbs dalemkelat llnbase
        wn syl dalem34 atbase latjcl syl3anc dalemyeb latmle2 syl5eqbr latjle12
        dalem24 wa syl13anc simpl syl6bir mtod nbrne2 syl2anc necomd cal latmcl
        wb hlatl dalem52 dalempjqeb latmle1 dalem51 simpld 3anim1i biid dalem10
        cv anim2i syl3an1 latlem12 mpbi2and atlen0 2llnmat syl32anc ) ATUAUQZBU
        RZPUSUTZLMOVAZPVBVCZUTZDYCUTZYBDVDYBDRVAZPVIVCZVDZYFCUTAXSYABACEFGHIJKO
        PQSTUAUDVEVFZXTYALCUTZMCUTZLMVDYDYIABCEFGHIJKLOPQRSTUAUBUCUDUEUFUGUHUIU
        JUKULUMVGZABCEFGHIJKMOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUNVHZABCEFGHIJKLMNOP
        QRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVJCLMOPYCUFUGYCVKZVLVMZABCDEFGHIJKLMN
        OPQRYCSTUAUBUCUDUEUFUGUHUIYNUJUKULUMUNUOUPVNZXTDYBXTDTQVOYBTQVOZVTDYBVD
        XTDYBNOVAZTRVAZTQUPXTPVPUTZYRPVQVCZUTZTUUAUTZYSTQVOAXSYTBACEFGHIJKOPQST
        UAUDVRVFZXTYTYBUUAUTZNUUAUTZUUBUUDXTYDUUEYOUUAPYCYBUUAVKZYNVSWAZXTNCUTZ
        UUFABCEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUOWBCUUANPUUGUGWCWAUUAOPYBN
        UUGUFWDWEAXSUUCBACEFGHIJKOPQSTUAUDUJWFVFZUUAPQRYRTUUGUEUIWGWEWHXTYQLTQV
        OZABCEFGHIJKLOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMWJXTYQUUKMTQVOZWKZUUKXTYTL
        UUAUTZMUUAUTZUUCUUMYQXAUUDXTYJUUNYLCUUALPUUGUGWCWAXTYKUUOYMCUUAMPUUGUGW
        CWAUUJUUAOPQLMTUUGUEUFWIWLUUKUULWMWNWODYBTQWPWQWRXTPWSUTZYFUUAUTZYBFGOV
        AZRVAZCUTUUSYFQVOZYHXTYAUUPYIPXBWAXTYTUUEDUUAUTZUUQUUDUUHXTYEUVAYPUUAPY
        CDUUGYNVSWAZUUAPRYBDUUGUIWTWEABCEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKU
        LUMUNUOXCXTUUSYBQVOZUUSDQVOZUUTXTYTUUEUURUUAUTZUVCUUDUUHAXSUVEBACEFGHIJ
        KOPQSTUAUDUFUGXDVFZUUAPQRYBUURUUGUEUIXEWEXTYAUBXKZCUTZWKZYJYKUUIURZFCUT
        GCUTHCUTURZURZYRSUTTSUTWKZUVGYBQVOVTUVGMNOVAQVOVTUVGNLOVAQVOVTURUVGUURQ
        VOVTUVGGHOVAQVOVTUVGHFOVAQVOVTURUVGLFOVAQVOUVGMGOVAQVOUVGNHOVAQVOURURZU
        RZUVDXTUVOYRTVDABCEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOXFXGUVL
        YAUVGUUAUTZWKZUVJUVKURZUVMUVNUVDUVIUVQUVJUVKUVHUVPYACUUAUVGPUUGUGWCXLXH
        UVRUVMUVNURZCUVGUUSLMNFGHOPQRSDYRTUVSXIUEUFUGUIUJYRVKUKUPUUSVKXJXMWAXTY
        TUUSUUAUTZUUEUVAUVCUVDWKUUTXAUUDXTYTUUEUVEUVTUUDUUHUVFUUAPRYBUURUUGUIWT
        WEUUHUVBUUAPQRUUSYBDUUGUEUIXNWLXOCUUAUUSPQYFYGUUGUEYGVKZUGXPVMCPRYCYBDY
        GUIUWAUGYNXQXR $.

      $( Lemma for ~ dath .  Lines ` G H ` and ` P Q ` intersect at the
         auxiliary line ` B ` (later shown to be an axis of perspectivity; see
         ~ dalem60 ).  (Contributed by NM, 8-Aug-2012.) $)
      dalem55 $p |- ( ( ph /\ Y = Z /\ ps )
          -> ( ( G .\/ H ) ./\ ( P .\/ Q ) ) = ( ( G .\/ H ) ./\ B ) ) $=
        ( wceq w3a wbr clat wcel cbs dalemkelat 3ad2ant1 chlt dalemkehl dalem23
        cfv dalem29 eqid hlatjcl syl3anc dalempjqeb latmle1 dalem34 syl latlej1
        co atbase dalemreb syl6breqr wa wi dalem42 lplnbase latmlem12 syl122anc
        dalemyeb mp2and wb latmcl clln dalem53 latlem12 syl13anc mpbi2and hlatl
        llnbase cal dalem52 dalem54 atcmp mpbid ) ATUAUQZBURZLMOVRZFGOVRZRVRZXF
        DRVRZQUSZXHXIUQZXEXHXFQUSZXHDQUSZXJXEPUTVAZXFPVBVHZVAZXGXOVAZXLAXDXNBAC
        EFGHIJKOPQSTUAUDVCZVDZXEPVEVAZLCVAMCVAXPAXDXTBACEFGHIJKOPQSTUAUDVFVDZAB
        CEFGHIJKLOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVGABCEFGHIJKMOPQRSTUAUBUCUDUEU
        FUGUHUIUJUKULUNVICXOOPLMXOVJZUFUGVKVLZAXDXQBACEFGHIJKOPQSTUAUDUFUGVMZVD
        ZXOPQRXFXGYBUEUIVNVLXEXHXFNOVRZTRVRZDQXEXFYFQUSZXGTQUSZXHYGQUSZXEXNXPNX
        OVAZYHXSYCXENCVAYKABCEFGHIJKNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUOVOCXONPYBU
        GVSVPXOOPQXFNYBUEUFVQVLAXDYIBAXGXGHOVRZTQAXNXQHXOVAXGYLQUSXRYDACEFGHIJK
        OPQSTUAUDUGVTXOOPQXGHYBUEUFVQVLUKWAVDXEXNXPYFXOVAZXQTXOVAZYHYIWBYJWCXSY
        CXEYFSVAYMABCEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOWDXOSPYFYBUJ
        WEVPYEAXDYNBACEFGHIJKOPQSTUAUDUJWHVDXOPQRTXFYFXGYBUEUIWFWGWIUPWAXEXNXHX
        OVAZXPDXOVAZXLXMWBXJWJXSXEXNXPXQYOXSYCYEXOPRXFXGYBUIWKVLYCXEDPWLVHZVAYP
        ABCDEFGHIJKLMNOPQRYQSTUAUBUCUDUEUFUGUHUIYQVJZUJUKULUMUNUOUPWMXOPYQDYBYR
        WRVPXOPQRXHXFDYBUEUIWNWOWPXEPWSVAZXHCVAXICVAXJXKWJXEXTYSYAPWQVPABCEFGHI
        JKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOWTABCDEFGHIJKLMNOPQRSTUAUBUCUD
        UEUFUGUHUIUJUKULUMUNUOUPXACXHXIPQUEUGXBVLXC $.

      $( Lemma for ~ dath .  Analog of ~ dalem55 for line ` S T ` .
         (Contributed by NM, 8-Aug-2012.) $)
      dalem56 $p |- ( ( ph /\ Y = Z /\ ps )
           -> ( ( G .\/ H ) ./\ ( S .\/ T ) ) = ( ( G .\/ H ) ./\ B ) ) $=
        ( wceq w3a cv co chlt wcel cbs cfv wa wbr wn dalemswapyz 3ad2ant1 simp2
        wne eqcomd dalemswapyzps biid eqid dalem55 syl3anc dalemkelat dalemkehl
        dalemccea 3ad2ant3 dalempea hlatjcl dalemddea dalemsea latmcom dalemqea
        clat syl5eq dalemtea oveq12d oveq1d dalemrea dalemuea 3eqtr4d ) ATUAUQZ
        BURZUCUSZIOUTZUBUSZFOUTZRUTZWRJOUTZWTGOUTZRUTZOUTZIJOUTZRUTZXFXFWRKOUTZ
        WTHOUTZRUTZOUTZUARUTZRUTZLMOUTZXGRUTXODRUTWQPVAVBZEPVCVDZVBVEICVBZJCVBZ
        KCVBZURFCVBZGCVBZHCVBZURURUASVBTSVBVEEXGQVFVGEJKOUTQVFVGEKIOUTQVFVGUREF
        GOUTQVFVGEGHOUTQVFVGEHFOUTQVFVGUREIFOUTQVFEJGOUTQVFEKHOUTQVFURURURZUATU
        QWRCVBZWTCVBZVEWRUAQVFVGWTWRVKWTUAQVFVGEWRWTOUTQVFURURZXHXNUQAWPYDBACEF
        GHIJKOPQSTUAUDUEUFUGVHVIWQTUAAWPBVJZVLABCEFGHIJKOPQSTUAUBUCUDUEUFUGUHVM
        YDYGCXMEIJKFGHXBXEXKOPQRSUATUCUBYDVNUEUFUGYGVNUIUJULUKXBVOXEVOXKVOXMVOV
        PVQWQXOXFXGRWQLXBMXEOWQLXAWSRUTZXBUMWQPWHVBZXAXQVBZWSXQVBZYIXBUQAWPYJBA
        CEFGHIJKOPQSTUAUDVRVIZWQXPYFYAYKAWPXPBACEFGHIJKOPQSTUAUDVSVIZBAYFWPBCEO
        QTUBUCUHVTWAZAWPYABACEFGHIJKOPQSTUAUDWBVICXQOPWTFXQVOZUFUGWCVQWQXPYEXRY
        LYNBAYEWPBCEOQTUBUCUHWDWAZAWPXRBACEFGHIJKOPQSTUAUDWEVICXQOPWRIYPUFUGWCV
        QXQPRXAWSYPUIWFVQWIWQMXDXCRUTZXEUNWQYJXDXQVBZXCXQVBZYRXEUQYMWQXPYFYBYSY
        NYOAWPYBBACEFGHIJKOPQSTUAUDWGVICXQOPWTGYPUFUGWCVQWQXPYEXSYTYNYQAWPXSBAC
        EFGHIJKOPQSTUAUDWJVICXQOPWRJYPUFUGWCVQXQPRXDXCYPUIWFVQWIWKZWLWQXOXFDXMR
        UUAWQDXONOUTZTRUTXMUPWQUUBXLTUARWQXOXFNXKOUUAWQNXJXIRUTZXKUOWQYJXJXQVBZ
        XIXQVBZUUCXKUQYMWQXPYFYCUUDYNYOAWPYCBACEFGHIJKOPQSTUAUDWMVICXQOPWTHYPUF
        UGWCVQWQXPYEXTUUEYNYQAWPXTBACEFGHIJKOPQSTUAUDWNVICXQOPWRKYPUFUGWCVQXQPR
        XJXIYPUIWFVQWIWKYHWKWIWKWO $.
    $}

    ${
      dalem57.m $e |- ./\ = ( meet ` K ) $.
      dalem57.o $e |- O = ( LPlanes ` K ) $.
      dalem57.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem57.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem57.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      dalem57.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem57.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem57.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      dalem57.b1 $e |- B = ( ( ( G .\/ H ) .\/ I ) ./\ Y ) $.
      $( Lemma for ~ dath .  Axis of perspectivity point ` D ` is on the
         auxiliary line ` B ` .  (Contributed by NM, 9-Aug-2012.) $)
      dalem57 $p |- ( ( ph /\ Y = Z /\ ps ) -> D .<_ B ) $=
        ( wceq w3a wbr dalem55 clat wcel cbs dalemkelat 3ad2ant1 chlt dalemkehl
        co cfv dalem23 dalem29 eqid hlatjcl syl3anc dalempjqeb latmle2 eqbrtrrd
        dalem56 dalemsjteb wa wb dalem54 atbase syl latlem12 syl13anc syl6breqr
        mpbi2and cal hlatl dalemdea atcmp mpbid clln dalem53 llnbase ) AUAUBUSZ
        BUTZMNPVJZDSVJZFDRWTXBFRVAZXBFUSZWTXBGHPVJZJKPVJZSVJZFRWTXBXERVAZXBXFRV
        AZXBXGRVAZWTXAXESVJZXBXERABCDEGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMU
        OUPUQURVBWTQVCVDZXAQVEVKZVDZXEXMVDZXKXERVAAWSXLBACEGHIJKLPQRTUAUBUEVFVG
        ZWTQVHVDZMCVDNCVDXNAWSXQBACEGHIJKLPQRTUAUBUEVIVGZABCEGHIJKLMPQRSTUAUBUC
        UDUEUFUGUHUIUJUKULUMUOVLABCEGHIJKLNPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUPVMC
        XMPQMNXMVNZUGUHVOVPZAWSXOBACEGHIJKLPQRTUAUBUEUGUHVQVGZXMQRSXAXEXSUFUJVR
        VPVSWTXAXFSVJZXBXFRABCDEGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUOUPUQU
        RVTWTXLXNXFXMVDZYBXFRVAXPXTAWSYCBACEGHIJKLPQRTUAUBUEUGUHWAVGZXMQRSXAXFX
        SUFUJVRVPVSWTXLXBXMVDZXOYCXHXIWBXJWCXPWTXBCVDZYEABCDEGHIJKLMNOPQRSTUAUB
        UCUDUEUFUGUHUIUJUKULUMUOUPUQURWDZCXMXBQXSUHWEWFYAYDXMQRSXBXEXFXSUFUJWGW
        HWJUNWIWTQWKVDZYFFCVDZXCXDWCWTXQYHXRQWLWFYGAWSYIBACEFGHIJKLPQRSTUAUBUEU
        FUGUHUJUKULUMUNWMVGCXBFQRUFUHWNVPWOWTXLXNDXMVDZXBDRVAXPXTWTDQWPVKZVDYJA
        BCDEGHIJKLMNOPQRSYKTUAUBUCUDUEUFUGUHUIUJYKVNZUKULUMUOUPUQURWQXMQYKDXSYL
        WRWFXMQRSXADXSUFUJVRVPVS $.
    $}

    ${
      dalem58.m $e |- ./\ = ( meet ` K ) $.
      dalem58.o $e |- O = ( LPlanes ` K ) $.
      dalem58.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem58.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem58.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      dalem58.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem58.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem58.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      dalem58.b1 $e |- B = ( ( ( G .\/ H ) .\/ I ) ./\ Y ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem57 for ` E ` .  (Contributed by
         NM, 10-Aug-2012.) $)
      dalem58 $p |- ( ( ph /\ Y = Z /\ ps ) -> E .<_ B ) $=
        ( wceq w3a co chlt wcel cbs cfv wa wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid dalem57 syl3anc dalemkehl dalem29
        dalem34 dalem23 hlatjrot syl13anc dalemqrprot syl6eqr oveq12d breqtrd
        eqid ) AUAUBUSZBUTZLNOPVAMPVAZGHPVAZFPVAZSVAZDRWLQVBVCZEQVDVEVCVFGCVCHC
        VCFCVCUTJCVCKCVCICVCUTUTWOTVCJKPVAZIPVAZTVCVFEWNRVGVLEHFPVARVGVLEFGPVAZ
        RVGVLUTEWRRVGVLEKIPVARVGVLEIJPVARVGVLUTEGJPVARVGEHKPVARVGEFIPVARVGUTUTU
        TZWOWSUSZUCVMZCVCUDVMZCVCVFXCWORVGVLXDXCVHXDWORVGVLEXCXDPVARVGUTUTZLWPR
        VGAWKXABACEFGHIJKPQRTUAUBUEUFUGUHULUMVIVJAWKXBBACEFGHIJKPQRTUAUBUEUFUGU
        HULUMVKVNABXEWKABCEFGHIJKPQRTUAUBUCUDUEUFUGUHUIULVOVPXAXECWPELGHFJKINOM
        PQRSTWOWSUCUDXAVQUFUGUHXEVQUJUKWOWJWSWJUNUPUQUOWPWJVRVSWLWPMNPVAOPVAZUA
        SVADWLWMXFWOUASWLWQNCVCOCVCMCVCWMXFUSAWKWQBACEFGHIJKPQRTUAUBUEVTVJABCEF
        GHIJKNPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUPWAABCEFGHIJKOPQRSTUAUBUCUDUEUFUG
        UHUIUJUKULUMUQWBABCEFGHIJKMPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUOWCCNOMPQUGU
        HWDWEAWKWOUAUSBAWOWTHPVAUAACEFGHIJKPQRTUAUBUEUGUHWFULWGVJWHURWGWI $.
    $}

    ${
      dalem59.m $e |- ./\ = ( meet ` K ) $.
      dalem59.o $e |- O = ( LPlanes ` K ) $.
      dalem59.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem59.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem59.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
      dalem59.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem59.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem59.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      dalem59.b1 $e |- B = ( ( ( G .\/ H ) .\/ I ) ./\ Y ) $.
      $( Lemma for ~ dath .  Analog of ~ dalem57 for ` F ` .  (Contributed by
         NM, 10-Aug-2012.) $)
      dalem59 $p |- ( ( ph /\ Y = Z /\ ps ) -> F .<_ B ) $=
        ( wceq w3a co chlt wcel cbs cfv wa wbr wne dalemrot 3ad2ant1 dalemrotyz
        wn cv 3adant3 dalemrotps 3adant2 biid dalem58 syl3anc dalemkehl dalem29
        dalem34 dalem23 hlatjrot syl13anc dalemqrprot syl6eqr oveq12d breqtrd
        eqid ) AUAUBUSZBUTZLNOPVAMPVAZGHPVAZFPVAZSVAZDRWLQVBVCZEQVDVEVCVFGCVCHC
        VCFCVCUTJCVCKCVCICVCUTUTWOTVCJKPVAZIPVAZTVCVFEWNRVGVLEHFPVARVGVLEFGPVAZ
        RVGVLUTEWRRVGVLEKIPVARVGVLEIJPVARVGVLUTEGJPVARVGEHKPVARVGEFIPVARVGUTUTU
        TZWOWSUSZUCVMZCVCUDVMZCVCVFXCWORVGVLXDXCVHXDWORVGVLEXCXDPVARVGUTUTZLWPR
        VGAWKXABACEFGHIJKPQRTUAUBUEUFUGUHULUMVIVJAWKXBBACEFGHIJKPQRTUAUBUEUFUGU
        HULUMVKVNABXEWKABCEFGHIJKPQRTUAUBUCUDUEUFUGUHUIULVOVPXAXECWPEGHFJKILNOM
        PQRSTWOWSUCUDXAVQUFUGUHXEVQUJUKWOWJWSWJUNUPUQUOWPWJVRVSWLWPMNPVAOPVAZUA
        SVADWLWMXFWOUASWLWQNCVCOCVCMCVCWMXFUSAWKWQBACEFGHIJKPQRTUAUBUEVTVJABCEF
        GHIJKNPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUPWAABCEFGHIJKOPQRSTUAUBUCUDUEUFUG
        UHUIUJUKULUMUQWBABCEFGHIJKMPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUOWCCNOMPQUGU
        HWDWEAWKWOUAUSBAWOWTHPVAUAACEFGHIJKPQRTUAUBUEUGUHWFULWGVJWHURWGWI $.
    $}

    ${
      dalem60.m $e |- ./\ = ( meet ` K ) $.
      dalem60.o $e |- O = ( LPlanes ` K ) $.
      dalem60.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem60.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem60.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      dalem60.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      dalem60.g $e |- G = ( ( c .\/ P ) ./\ ( d .\/ S ) ) $.
      dalem60.h $e |- H = ( ( c .\/ Q ) ./\ ( d .\/ T ) ) $.
      dalem60.i $e |- I = ( ( c .\/ R ) ./\ ( d .\/ U ) ) $.
      dalem60.b1 $e |- B = ( ( ( G .\/ H ) .\/ I ) ./\ Y ) $.
      $( Lemma for ~ dath . ` B ` is an axis of perspectivity (almost).
         (Contributed by NM, 11-Aug-2012.) $)
      dalem60 $p |- ( ( ph /\ Y = Z /\ ps ) -> ( D .\/ E ) = B ) $=
        ( wceq w3a co wbr dalem57 dalem58 clat wcel cbs cfv dalemkelat 3ad2ant1
        wa dalemdea eqid atbase dalemeea clln dalem53 llnbase latjle12 syl13anc
        syl mpbi2and chlt dalemkehl wne dalemdnee llni2 syl31anc llncmp syl3anc
        wb mpbid ) AUBUCVAZBVBZFMQVCZDSVDZWQDVAZWPFDSVDZMDSVDZWRABCDEFGHIJKLNOP
        QRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUQURUSUTVEABCDEGHIJKLMNOPQRSTUAUBUCUD
        UEUFUGUHUIUJUKULUMUNUPUQURUSUTVFWPRVGVHZFRVIVJZVHZMXCVHZDXCVHZWTXAVMWRW
        MAWOXBBACEGHIJKLQRSUAUBUCUFVKVLAWOXDBAFCVHZXDACEFGHIJKLQRSTUAUBUCUFUGUH
        UIUKULUMUNUOVNZCXCFRXCVOZUIVPWCVLAWOXEBAMCVHZXEACEGHIJKLMQRSTUAUBUCUFUG
        UHUIUKULUMUNUPVQZCXCMRXIUIVPWCVLWPDRVRVJZVHZXFABCDEGHIJKLNOPQRSTXLUAUBU
        CUDUEUFUGUHUIUJUKXLVOZULUMUNUQURUSUTVSZXCRXLDXIXNVTWCXCQRSFMDXIUGUHWAWB
        WDWPRWEVHZWQXLVHZXMWRWSWMAWOXPBACEGHIJKLQRSUAUBUCUFWFZVLAWOXQBAXPXGXJFM
        WGXQXRXHXKACEFGHIJKLMQRSTUAUBUCUFUGUHUIUKULUMUNUOUPWHCFMQRXLUHUIXNWIWJV
        LXORSXLWQDUGXNWKWLWN $.
    $}

    ${
      dalem61.m $e |- ./\ = ( meet ` K ) $.
      dalem61.o $e |- O = ( LPlanes ` K ) $.
      dalem61.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
      dalem61.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
      dalem61.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
      dalem61.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
      dalem61.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
      $( Lemma for ~ dath .  Show that atoms ` D ` , ` E ` , and ` F ` lie on
         the same line (axis of perspectivity).  Eliminate hypotheses
         containing dummy atoms ` c ` and ` d ` .  (Contributed by NM,
         11-Aug-2012.) $)
      dalem61 $p |- ( ( ph /\ Y = Z /\ ps ) -> F .<_ ( D .\/ E ) ) $=
        ( wceq w3a cv co eqid dalem59 dalem60 breqtrrd ) ASTUOBUPMUAUQZFNURUBUQ
        ZINURQURZVCGNURVDJNURQURZNURVCHNURVDKNURQURZNURSQURZELNURPABCVHDFGHIJKM
        VEVFVGNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUNVEUSZVFUSZVGUSZVHUSZUTABCVHDEFGHIJ
        KLVEVFVGNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVIVJVKVLVAVB $.
    $}
  $}

  ${
    $d c d A $.  $d d C $.  $d c d D $.  $d c d E $.  $d c d F $.
    $d c d .\/ $.  $d c d K $.  $d c d .<_ $.  $d c P $.  $d c Q $.  $d c R $.
    $d c d Y $.  $d c d Z $.  $d c d ph $.
    dalem62.ph $e |- ( ph <-> ( ( ( K e. HL /\ C e. ( Base ` K ) )
    /\ ( P e. A /\ Q e. A /\ R e. A )
    /\ ( S e. A /\ T e. A /\ U e. A ) )
 /\ ( Y e. O /\ Z e. O )
 /\ ( ( -. C .<_ ( P .\/ Q ) /\ -. C .<_ ( Q .\/ R )
     /\ -. C .<_ ( R .\/ P ) )
    /\ ( -. C .<_ ( S .\/ T ) /\ -. C .<_ ( T .\/ U )
       /\ -. C .<_ ( U .\/ S ) )
    /\ ( C .<_ ( P .\/ S ) /\ C .<_ ( Q .\/ T )
       /\ C .<_ ( R .\/ U ) ) ) ) ) $.
    dalem62.l $e |- .<_ = ( le ` K ) $.
    dalem62.j $e |- .\/ = ( join ` K ) $.
    dalem62.a $e |- A = ( Atoms ` K ) $.
    dalem62.m $e |- ./\ = ( meet ` K ) $.
    dalem62.o $e |- O = ( LPlanes ` K ) $.
    dalem62.y $e |- Y = ( ( P .\/ Q ) .\/ R ) $.
    dalem62.z $e |- Z = ( ( S .\/ T ) .\/ U ) $.
    dalem62.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
    dalem62.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
    dalem62.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
    $( Lemma for ~ dath .  Eliminate the condition ` ps ` containing dummy
       variables ` c ` and ` d ` .  (Contributed by NM, 11-Aug-2012.) $)
    dalem62 $p |- ( ( ph /\ Y = Z ) -> F .<_ ( D .\/ E ) ) $=
      ( vc vd wceq wa cv wcel wbr wn wne co w3a wex biid dalem20 dalem61 3expia
      exlimdvv mpd ) ARSUMZUNZUKUOZBUPULUOZBUPUNVKROUQURVLVKUSVLROUQURCVKVLMUTO
      UQVAVAZULVBUKVBLDKMUTOUQZAVMBCEFGHIJMNOQRSUKULTUAUBUCVMVCZUEUFUGVDVJVMVNU
      KULAVIVMVNAVMBCDEFGHIJKLMNOPQRSUKULTUAUBUCVOUDUEUFUGUHUIUJVEVFVGVH $.

    $( Lemma for ~ dath .  Combine the cases where ` Y ` and ` Z ` are
       different planes with the case where ` Y ` and ` Z ` are the same
       plane.  (Contributed by NM, 11-Aug-2012.) $)
    dalem63 $p |- ( ph -> F .<_ ( D .\/ E ) ) $=
      ( co wbr dalem62 dalem16 pm2.61dane ) ALDKMUKOULRSABCDEFGHIJKLMNOPQRSTUAU
      BUCUDUEUFUGUHUIUJUMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUNUO $.
  $}

  ${
    dath.b $e |- B = ( Base ` K ) $.
    dath.l $e |- .<_ = ( le ` K ) $.
    dath.j $e |- .\/ = ( join ` K ) $.
    dath.a $e |- A = ( Atoms ` K ) $.
    dath.m $e |- ./\ = ( meet ` K ) $.
    dath.o $e |- O = ( LPlanes ` K ) $.
    dath.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
    dath.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
    dath.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
    $( Desargues' Theorem of projective geometry (proved for a Hilbert
       lattice).  Assume each triple of atoms (points) ` P Q R ` and ` S T U `
       forms a triangle (i.e. determines a plane).  Assume that lines ` P S ` ,
       ` Q T ` , and ` R U ` meet at a "center of perspectivity" ` C ` .  (We
       also assume that ` C ` is not on any of the 6 lines forming the two
       triangles.)  Then the atoms ` D = ( P .\/ Q ) ./\ ( S .\/ T ) ` ,
       ` E = ( Q .\/ R ) ./\ ( T .\/ U ) ` ,
       ` F = ( R .\/ P ) ./\ ( U .\/ S ) ` are colinear, forming an "axis of
       perspectivity".

       Our proof roughly follows Theorem 2.7.1, p. 78 in Beutelspacher and
       Rosenbaum, _Projective Geometry:  From Foundations to Applications_,
       Cambridge University Press (1988).  Unlike them, we don't assume ` C `
       is an atom to make this theorem slightly more general for easier future
       use.  However, we prove that ` C ` must be an atom in ~ dalemcea .

       For a visual demonstration, see the "Desargue's Theorem" applet at
       ~ http://www.dynamicgeometry.com/JavaSketchpad/Gallery.html .  The
       points I, J, and K there define the axis of perspectivity.

       See theorem ~ dalaw for Desargues Law, which eliminates all of the
       preconditions on the atoms except for central perspectivity.
       (Contributed by NM, 20-Aug-2012.) $)
    dath $p |- ( ( ( ( K e. HL /\ C e. B )
    /\ ( P e. A /\ Q e. A /\ R e. A )
    /\ ( S e. A /\ T e. A /\ U e. A ) )
 /\ ( ( ( P .\/ Q ) .\/ R ) e. O /\ ( ( S .\/ T ) .\/ U ) e. O )
 /\ ( ( -. C .<_ ( P .\/ Q ) /\ -. C .<_ ( Q .\/ R )
    /\ -. C .<_ ( R .\/ P ) )
    /\ ( -. C .<_ ( S .\/ T ) /\ -. C .<_ ( T .\/ U )
    /\ -. C .<_ ( U .\/ S ) )
    /\ ( C .<_ ( P .\/ S ) /\ C .<_ ( Q .\/ T )
     /\ C .<_ ( R .\/ U ) ) ) )
      -> F .<_ ( D .\/ E ) ) $=
      ( chlt wcel wa w3a co wbr wn cbs cfv eleq2i anbi2i 3anbi1i eqid dalem63 )
      NUGUHZCBUHZUIZEAUHFAUHGAUHUJZHAUHIAUHJAUHUJZUJZEFMUKZGMUKZQUHHIMUKZJMUKZQ
      UHUIZCVGOULUMCFGMUKOULUMCGEMUKOULUMUJCVIOULUMCIJMUKOULUMCJHMUKOULUMUJCEHM
      UKOULCFIMUKOULCGJMUKOULUJUJZUJACDEFGHIJKLMNOPQVHVJVFVACNUNUOZUHZUIZVDVEUJ
      VKVLVCVOVDVEVBVNVABVMCRUPUQURURSTUAUBUCVHUSVJUSUDUEUFUT $.
  $}

  ${
    dathb.b $e |- B = ( Base ` K ) $.
    dathb.l $e |- .<_ = ( le ` K ) $.
    dathb.j $e |- .\/ = ( join ` K ) $.
    dathb.a $e |- A = ( Atoms ` K ) $.
    dathb.m $e |- ./\ = ( meet ` K ) $.
    dathb.o $e |- O = ( LPlanes ` K ) $.
    dathb.d $e |- D = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
    dathb.e $e |- E = ( ( Q .\/ R ) ./\ ( T .\/ U ) ) $.
    dathb.f $e |- F = ( ( R .\/ P ) ./\ ( U .\/ S ) ) $.
    $( Version of Desargues' Theorem ~ dath with a different variable
       ordering.  (Contributed by NM, 7-Oct-2012.) $)
    dath2 $p |- ( ( ( ( K e. HL /\ C e. B )
    /\ ( P e. A /\ Q e. A /\ R e. A )
    /\ ( S e. A /\ T e. A /\ U e. A ) )
 /\ ( ( ( P .\/ Q ) .\/ R ) e. O /\ ( ( S .\/ T ) .\/ U ) e. O )
 /\ ( ( -. C .<_ ( P .\/ Q ) /\ -. C .<_ ( Q .\/ R )
      /\ -. C .<_ ( R .\/ P ) )
    /\ ( -. C .<_ ( S .\/ T ) /\ -. C .<_ ( T .\/ U )
        /\ -. C .<_ ( U .\/ S ) )
    /\ ( C .<_ ( P .\/ S ) /\ C .<_ ( Q .\/ T )
        /\ C .<_ ( R .\/ U ) ) ) )
      -> D .<_ ( E .\/ F ) ) $=
      ( chlt wcel wa w3a co wbr wn simp122 simp123 simp121 3jca simp132 simp133
      simp11 simp131 wceq simp11l simp2l eqeltrd simp2r simp312 simp313 simp311
      hlatjrot syl13anc simp322 simp323 simp321 simp332 simp333 dath syl323anc
      simp331 ) NUGUHZCBUHZUIZEAUHZFAUHZGAUHZUJZHAUHZIAUHZJAUHZUJZUJZEFMUKZGMUK
      ZQUHZHIMUKZJMUKZQUHZUIZCWLOULUMZCFGMUKZOULUMZCGEMUKOULUMZUJZCWOOULUMZCIJM
      UKZOULUMZCJHMUKOULUMZUJZCEHMUKOULZCFIMUKOULZCGJMUKOULZUJZUJZUJZWBWDWEWCUJ
      WHWIWGUJWTEMUKZQUHXEHMUKZQUHXAXBWSUJXFXGXDUJXJXKXIUJDKLMUKOULWBWFWJWRXMUT
      XNWDWEWCWCWDWEWBWJWRXMUNZWCWDWEWBWJWRXMUOZWCWDWEWBWJWRXMUPZUQXNWHWIWGWGWH
      WIWBWFWRXMURZWGWHWIWBWFWRXMUSZWGWHWIWBWFWRXMVAZUQXNXOWMQXNVTWDWEWCXOWMVBV
      TWAWFWJWRXMVCZXQXRXSAFGEMNTUAVJVKWKWNWQXMVDVEXNXPWPQXNVTWHWIWGXPWPVBYCXTY
      AYBAIJHMNTUAVJVKWKWNWQXMVFVEXNXAXBWSWSXAXBXHXLWKWRVGWSXAXBXHXLWKWRVHWSXAX
      BXHXLWKWRVIUQXNXFXGXDXDXFXGXCXLWKWRVLXDXFXGXCXLWKWRVMXDXFXGXCXLWKWRVNUQXN
      XJXKXIXIXJXKXCXHWKWRVOXIXJXKXCXHWKWRVPXIXJXKXCXHWKWRVSUQABCKFGEIJHLDMNOPQ
      RSTUAUBUCUEUFUDVQVR $.
  $}

  ${
    $d k p q r s A $.  $d k p q r s K $.  $d k s .\/ $.  $d k s .<_ $.
    lineset.l $e |- .<_ = ( le ` K ) $.
    lineset.j $e |- .\/ = ( join ` K ) $.
    lineset.a $e |- A = ( Atoms ` K ) $.
    lineset.n $e |- N = ( Lines ` K ) $.
    $( The set of lines in a Hilbert lattice.  (Contributed by NM,
       19-Sep-2011.) $)
    lineset $p |- ( K e. B -> N = { s | E. q e. A E. r e. A ( q =/= r /\
                      s = { p e. A | p .<_ ( q .\/ r ) } ) } ) $=
      ( cvv cv wceq wrex cab cfv vk wcel wne wbr crab elex clines cjn cple catm
      co wa fveq2 syl6eqr breqd breq2d rabeqbidv eqeq2d anbi2d rexeqbidv abbidv
      oveqd bitrd df-lines fvex eqeltri csn df-sn snex eqeltrri simpr ab2rexex2
      ss2abi ssexi fvmpt syl5eq syl ) DBUBDOUBZFIPZHPZUCZGPZJPZVSVTCUKZEUDZJAUE
      ZQZULZHARZIARZGSZQDBUFVRFDUGTWKNUADWAWBWCVSVTUAPZUHTZUKZWLUITZUDZJWLUJTZU
      EZQZULZHWQRZIWQRZGSWKOUGWLDQZXBWJGXCXAWIIWQAXCWQDUJTZAWLDUJUMMUNZXCWTWHHW
      QAXEXCWSWGWAXCWRWFWBXCWPWEJWQAXEXCWPWCWNEUDWEXCWOEWCWNXCWODUITEWLDUIUMKUN
      UOXCWNWDWCEXCWMCVSVTXCWMDUHTCWLDUHUMLUNVBUPVCUQURUSUTUTVAUAGHIJVDWHIHGAAA
      XDOMDUJVEVFZXFWHGSWGGSZWFVGXGOGWFVHWFVIVJWHWGGWAWGVKVMVNVLVOVPVQ $.
  $}

  ${
    $d p q r x A $.  $d p q r x K $.  $d x .\/ $.  $d x .<_ $.  $d q r x X $.
    isline.l $e |- .<_ = ( le ` K ) $.
    isline.j $e |- .\/ = ( join ` K ) $.
    isline.a $e |- A = ( Atoms ` K ) $.
    isline.n $e |- N = ( Lines ` K ) $.
    $( The predicate "is a line".  (Contributed by NM, 19-Sep-2011.) $)
    isline $p |- ( K e. D -> ( X e. N <-> E. q e. A E. r e. A ( q =/= r /\
                      X = { p e. A | p .<_ ( q .\/ r ) } ) ) ) $=
      ( vx wcel cv wceq wrex cvv wne co wbr crab wa cab lineset eleq2d catm cfv
      wi fvex eqeltri rabex eleq1 mpbiri adantl rexlimivv eqeq1 anbi2d 2rexbidv
      a1i elab3 syl6bb ) DBPZGFPGIQZHQZUAZOQZJQVFVGCUBEUCZJAUDZRZUEZHASIASZOUFZ
      PVHGVKRZUEZHASIASZVEFVOGABCDEFOHIJKLMNUGUHVNVROGVQGTPZIHAAVQVSUKVFAPVGAPU
      EVPVSVHVPVSVKTPVJJAADUIUJTMDUIULUMUNGVKTUOUPUQVBURVIGRZVMVQIHAAVTVLVPVHVI
      GVKUSUTVAVCVD $.

    $d q r .\/ $.  $d q r .<_ $.  $d p q r Q $.  $d p r R $.
    $( Condition implying "is a line".  (Contributed by NM, 3-Feb-2012.) $)
    islinei $p |- ( ( ( K e. D /\ Q e. A /\ R e. A ) /\ ( Q =/= R /\
      X = { p e. A | p .<_ ( Q .\/ R ) } ) ) -> X e. N ) $=
      ( vq vr wcel wne wceq wa w3a cv co wbr crab wrex simpl2 simpr neeq1 oveq1
      simpl3 breq2d rabbidv eqeq2d anbi12d neeq2 oveq2 rspc2ev wb simpl1 isline
      syl3anc syl mpbird ) FBQZCAQZDAQZUAZCDRZIJUBZCDEUCZGUDZJAUEZSZTZTZIHQZOUB
      ZPUBZRZIVJVRVSEUCZGUDZJAUEZSZTZPAUFOAUFZVPVFVGVOWFVEVFVGVOUGVEVFVGVOUKVHV
      OUHWEVOCVSRZIVJCVSEUCZGUDZJAUEZSZTOPCDAAVRCSZVTWGWDWKVRCVSUIWLWCWJIWLWBWI
      JAWLWAWHVJGVRCVSEUJULUMUNUOVSDSZWGVIWKVNVSDCUPWMWJVMIWMWIVLJAWMWHVKVJGVSD
      CEUQULUMUNUOURVBVPVEVQWFUSVEVFVGVOUTABEFGHIPOJKLMNVAVCVD $.
  $}

  ${
    $d a k p A $.  $d k p K $.
    pointset.a $e |- A = ( Atoms ` K ) $.
    pointset.p $e |- P = ( Points ` K ) $.
    $( The set of points in a Hilbert lattice.  (Contributed by NM,
       2-Oct-2011.)  (New usage is discouraged.) $)
    pointsetN $p |- ( K e. B -> P = { p | E. a e. A p = { a } } ) $=
      ( vk wcel cvv cv csn wceq wrex cab elex cpointsN cfv catm syl6eqr rexeqdv
      fveq2 abbidv df-pointsN fvex eqeltri abrexex fvmpt syl5eq syl ) DBJDKJZCE
      LFLMZNZFAOZEPZNDBQULCDRSUPHIDUNFILZTSZOZEPUPKRUQDNZUSUOEUTUNFURAUTURDTSZA
      UQDTUCGUAUBUDIEFUEFEAUMAVAKGDTUFUGUHUIUJUK $.
  $}

  ${
    $d a x A $.  $d x K $.  $d a x X $.
    ispoint.a $e |- A = ( Atoms ` K ) $.
    ispoint.p $e |- P = ( Points ` K ) $.
    $( The predicate "is a point".  (Contributed by NM, 2-Oct-2011.)
       (New usage is discouraged.) $)
    ispointN $p |- ( K e. D -> ( X e. P <-> E. a e. A X = { a } ) ) $=
      ( vx wcel cv csn wceq wrex cab pointsetN eleq2d cvv snex eleq1 rexlimivw
      mpbiri eqeq1 rexbidv elab3 syl6bb ) DBJZECJEIKZFKZLZMZFANZIOZJEUJMZFANZUG
      CUMEABCDIFGHPQULUOIEUNERJZFAUNUPUJRJUISEUJRTUBUAUHEMUKUNFAUHEUJUCUDUEUF
      $.

    $( The singleton of an atom is a point.  (Contributed by NM, 14-Jan-2012.)
       (New usage is discouraged.) $)
    atpointN $p |- ( ( K e. D /\ X e. A ) -> { X } e. P ) $=
      ( vx wcel wa csn cv wceq wrex eqid sneq eqeq2d rspcev mpan2 adantl adantr
      wb ispointN mpbird ) DBIZEAIZJEKZCIZUGHLZKZMZHANZUFULUEUFUGUGMZULUGOUKUMH
      EAUIEMUJUGUGUIEPQRSTUEUHULUBUFABCDUGHFGUCUAUD $.
  $}

  ${
    $d k r s A $.  $d k p q r s K $.  $d k .\/ $.  $d k .<_ $.
    psubspset.l $e |- .<_ = ( le ` K ) $.
    psubspset.j $e |- .\/ = ( join ` K ) $.
    psubspset.a $e |- A = ( Atoms ` K ) $.
    psubspset.s $e |- S = ( PSubSp ` K ) $.
    $( The set of projective subspaces in a Hilbert lattice.  (Contributed by
       NM, 2-Oct-2011.) $)
    psubspset $p |- ( K e. B -> S = { s | ( s C_ A
    /\ A. p e. s A. q e. s A. r e. A ( r .<_ ( p .\/ q ) -> r e. s ) ) } ) $=
      ( vk wcel cv wral cfv catm cvv wss co wbr wi wa cab wceq elex cpsubsp cjn
      fveq2 syl6eqr sseq2d oveqd breq2d breqd imbi1d raleqbidv 2ralbidv anbi12d
      cple bitrd abbidv df-psubsp cpw fvex pwex df-pw abeq2i anbi1i abbii ssab2
      eqeltri eqsstr3i ssexi fvmpt syl5eq syl ) EBPEUAPZCGQZAUBZHQZJQZIQZDUCZFU
      DZWCWAPZUEZHARZIWARJWARZUFZGUGZUHEBUIVTCEUJSWMNOEWAOQZTSZUBZWCWDWEWNUKSZU
      CZWNVBSZUDZWHUEZHWORZIWARJWARZUFZGUGWMUAUJWNEUHZXDWLGXEWPWBXCWKXEWOAWAXEW
      OETSZAWNETULMUMZUNXEXBWJJIWAWAXEXAWIHWOAXGXEWTWGWHXEWTWCWFWSUDWGXEWRWFWCW
      SXEWQDWDWEXEWQEUKSDWNEUKULLUMUOUPXEWSFWCWFXEWSEVBSFWNEVBULKUMUQVCURUSUTVA
      VDOGHIJVEWMAVFZAAXFUAMETVGVNVHWMWAXHPZWKUFZGUGXHXJWLGXIWBWKWBGXHGAVIVJVKV
      LWKGXHVMVOVPVQVRVS $.

    $d x A $.  $d x K $.  $d x .\/ $.  $d x .<_ $.  $d p q r x X $.
    $( The predicate "is a projective subspace".  (Contributed by NM,
       2-Oct-2011.) $)
    ispsubsp $p |- ( K e. D -> ( X e. S <-> ( X C_ A
    /\ A. p e. X A. q e. X A. r e. A ( r .<_ ( p .\/ q ) -> r e. X ) ) ) ) $=
      ( vx wcel cv wss wi wral co wbr wa cab psubspset eleq2d cvv catm cfv fvex
      eqeltri adantr sseq1 eleq2 imbi2d ralbidv raleqbi1dv anbi12d elab3 syl6bb
      ssex wceq ) EBPZGCPGOQZARZHQZJQIQDUAFUBZVFVDPZSZHATZIVDTZJVDTZUCZOUDZPGAR
      ZVGVFGPZSZHATZIGTZJGTZUCZVCCVNGABCDEFOHIJKLMNUEUFVMWAOGVOGUGPVTGAAEUHUIUG
      MEUHUJUKVAULVDGVBZVEVOVLVTVDGAUMVKVSJVDGVJVRIVDGWBVIVQHAWBVHVPVGVDGVFUNUO
      UPUQUQURUSUT $.

    $d p q A $.
    $( The predicate "is a projective subspace".  (Contributed by NM,
       13-Jan-2012.) $)
    ispsubsp2 $p |- ( K e. D -> ( X e. S <-> ( X C_ A
    /\ A. p e. A ( E. q e. X E. r e. X p .<_ ( q .\/ r ) -> p e. X ) ) ) ) $=
      ( wcel cv wi wral ralbii bitri wss co wbr wa wrex ispsubsp ralcom r19.23v
      wb a1i anbi2d bitrd ) EBOZGCOGAUAZJPZIPHPDUBFUCZUOGOZQZJARHGRZIGRZUDUNUPH
      GUEZIGUEUQQZJARZUDABCDEFGJHIKLMNUFUMUTVCUNUTVCUIUMUTVAUQQZJARZIGRZVCUSVEI
      GUSURHGRZJARVEURHJGAUGVGVDJAUPUQHGUHSTSVFVDIGRZJARVCVDIJGAUGVHVBJAVAUQIGU
      HSTTUJUKUL $.

    $d p .\/ $.  $d p .<_ $.  $d p q r P $.
    $( Property of a projective subspace.  (Contributed by NM, 13-Jan-2012.) $)
    psubspi $p |- ( ( ( K e. D /\ X e. S /\ P e. A ) /\
         E. q e. X E. r e. X P .<_ ( q .\/ r ) ) -> P e. X ) $=
      ( vp wcel cv wbr wrex wi co wral wss ispsubsp2 simplbda ex breq1 2rexbidv
      wceq eleq1 imbi12d rspccv syl6 3imp1 ) FBPZHDPZCAPZCJQIQEUAZGRZIHSJHSZCHP
      ZUOUPOQZURGRZIHSJHSZVBHPZTZOAUBZUQUTVATZTUOUPVGUOUPHAUCVGABDEFGHIJOKLMNUD
      UEUFVFVHOCAVBCUIZVDUTVEVAVIVCUSJIHHVBCURGUGUHVBCHUJUKULUMUN $.

    $d q r .\/ $.  $d q r .<_ $.  $d q r Q $.  $d r R $.
    $( Property of a projective subspace.  (Contributed by NM, 13-Jan-2012.)
       (New usage is discouraged.) $)
    psubspi2N $p |- ( ( ( K e. D /\ X e. S /\ P e. A )
       /\ ( Q e. X /\ R e. X /\ P .<_ ( Q .\/ R ) ) ) -> P e. X ) $=
      ( vq vr wcel co wbr w3a cv wrex oveq1 breq2d oveq2 rspc2ev psubspi sylan2
      wceq ) DJQEJQCDEGRZISZTHBQJFQCAQTCOUAZPUAZGRZISZPJUBOJUBCJQUOUKCDUMGRZISO
      PDEJJULDUIUNUPCIULDUMGUCUDUMEUIUPUJCIUMEDGUEUDUFABCFGHIJPOKLMNUGUH $.
  $}

  ${
    $d p q r K $.
    0psub.s $e |- S = ( PSubSp ` K ) $.
    $( The empty set is a projective subspace.  Remark below Definition 15.1 of
       [MaedaMaeda] p. 61.  (Contributed by NM, 13-Oct-2011.)
       (New usage is discouraged.) $)
    0psubN $p |- ( K e. V -> (/) e. S ) $=
      ( vr vp vq wcel c0 catm cfv wss cv cjn co cple wbr wi wral eqid wa pm3.2i
      0ss ral0 ispsubsp mpbiri ) BCHIAHIBJKZLZEMZFMGMBNKZOBPKZQUIIHREUGSGISZFIS
      ZUAUHUMUGUCULFUDUBUGCAUJBUKIEGFUKTUJTUGTDUEUF $.
  $}

  ${
    $d p q r A $.  $d p q r K $.  $d p q r P $.
    snpsub.a $e |- A = ( Atoms ` K ) $.
    snpsub.s $e |- S = ( PSubSp ` K ) $.
    $( The singleton of an atom is a projective subspace.  (Contributed by NM,
       9-Sep-2013.)  (New usage is discouraged.) $)
    snatpsubN $p |- ( ( K e. AtLat /\ P e. A ) -> { P } e. S ) $=
      ( vr vp vq cal wcel cv cfv co wbr wral wa wceq eqid elsn csn wss cjn cple
      wi snssi adantl clat cbs atllat atbase latjidm syl2an adantr breq2d atcmp
      wb 3com23 3expa biimpd sylbid adantld anbi12i anbi1i oveq12 pm5.32i bitri
      3imtr4g exp4b com23 ralrimdv ralrimivv jca ex ispsubsp sylibrd imp ) DJKZ
      BAKZBUAZCKZVRVSVTAUBZGLZHLZILZDUCMZNZDUDMZOZWCVTKZUEZGAPZIVTPHVTPZQZWAVRV
      SWNVRVSQZWBWMVSWBVRBAUFUGWOWLHIVTVTWOWDVTKZWEVTKZQZWKGAWOWCAKZWRWKWOWSWRW
      IWJWOWSQZWDBRZWEBRZQZWCBBWFNZWHOZQZWCBRZWRWIQZWJWTXEXGXCWTXEWCBWHOZXGWTXD
      BWCWHWOXDBRZWSVRDUHKBDUIMZKXJVSDUJAXKBDXKSZEUKXKWFDBXLWFSZULUMUNUOWTXIXGV
      RVSWSXIXGUQZVRWSVSXNAWCBDWHWHSZEUPURUSUTVAVBXHXCWIQXFWRXCWIWPXAWQXBHBTIBT
      VCVDXCWIXEXCWGXDWCWHWDBWEBWFVEUOVFVGGBTVHVIVJVKVLVMVNAJCWFDWHVTGIHXOXMEFV
      OVPVQ $.
  $}

  ${
    $d q K $.  $d q S $.  $d q X $.
    pointpsub.p $e |- P = ( Points ` K ) $.
    pointpsub.s $e |- S = ( PSubSp ` K ) $.
    $( A point (singleton of an atom) is a projective subspace.  Remark below
       Definition 15.1 of [MaedaMaeda] p. 61.  (Contributed by NM,
       13-Oct-2011.)  (New usage is discouraged.) $)
    pointpsubN $p |- ( ( K e. AtLat /\ X e. P ) -> X e. S ) $=
      ( vq cal wcel cv csn wceq catm cfv wrex eqid ispointN wi snatpsubN ex imp
      eleq1a syl6 rexlimdv sylbid ) CHIZDAIZDBIZUFUGDGJZKZLZGCMNZOUHULHACDGULPZ
      EQUFUKUHGULUFUIULIZUJBIZUKUHRUFUNUOULUIBCUMFSTUJBDUBUCUDUEUA $.
  $}

  ${
    $d a b c p q r K $.  $d a b c p q r X $.
    linepsub.n $e |- N = ( Lines ` K ) $.
    linepsub.s $e |- S = ( PSubSp ` K ) $.
    $( A line is a projective subspace.  (Contributed by NM, 16-Oct-2011.)
       (New usage is discouraged.) $)
    linepsubN $p |- ( ( K e. Lat /\ X e. N ) -> X e. S ) $=
      ( va vb vc vr vp vq wcel cv cfv wbr wa wi eqid atbase clat cple catm crab
      wne cjn co wceq wrex wss ssrab2 sseq1 mpbiri a1i cbs anim12i latjcl 3expb
      wral sylan2 eleq2 breq1 elrab anim1i syl6bi anim12d an4 syl6ib imp anim2i
      sylbi anassrs latjle12 biimpd 3exp2 imp3a com23 imp43 adantr 3expib lattr
      w3a com24 syl5d imp41 adantlrr mpan2d syl2an simpr jctild syl6bb ad3antlr
      wb sylibrd ralrimiva ralrimivva ex syldan jcad rexlimdvva isline ispsubsp
      adantld 3imtr4d ) BUAMZDCMZDAMZXEGNZHNZUEZDINZXHXIBUFOZUGZBUBOZPZIBUCOZUD
      ZUHZQZHXPUIGXPUIDXPUJZJNZKNZLNZXLUGZXNPZYADMZRZJXPUSZLDUSKDUSZQZXFXGXEXSY
      JGHXPXPXEXHXPMZXIXPMZQZQZXRYJXJYNXRXTYIXRXTRYNXRXTXQXPUJXOIXPUKDXQXPULUMU
      NXEYMXMBUOOZMZXRYIRYMXEXHYOMZXIYOMZQYPYKYQYLYRXPYOXHBYOSZXPSZTXPYOXIBYSYT
      TUPXEYQYRYPYOXLBXHXIYSXLSZUQURUTXEYPQZXRYIUUBXRQZYHKLDDUUCYBDMZYCDMZQZQZY
      GJXPUUGYAXPMZQZYEUUHYAXMXNPZQZYFUUIYEUUJUUHUUGUUBYBYOMZYCYOMZQZYBXMXNPZYC
      XMXNPZQZQZQZYAYOMZYEUUJRUUHUUBXRUUFUUSXRUUFQUURUUBXRUUFUURXRUUFUULUUOQZUU
      MUUPQZQUURXRUUDUVAUUEUVBXRUUDYBXQMZUVADXQYBVAUVCYBXPMZUUOQUVAXOUUOIYBXPXK
      YBXMXNVBVCUVDUULUUOXPYOYBBYSYTTVDVKVEXRUUEYCXQMZUVBDXQYCVAUVEYCXPMZUUPQUV
      BXOUUPIYCXPXKYCXMXNVBVCUVFUUMUUPXPYOYCBYSYTTVDVKVEVFUULUUOUUMUUPVGVHVIVJV
      LXPYOYABYSYTTUUSUUTQYEYDXMXNPZUUJUUSUVGUUTXEYPUUNUUQUVGXEUUNYPUUQUVGRZXEU
      ULUUMYPUVHRXEUULUUMYPUVHXEUULUUMYPWBQUUQUVGYOXLBXNYBYCXMYSXNSZUUAVMVNVOVP
      VQVRVSUUBUUNUUTYEUVGQUUJRZUUQXEYPUUNUUTUVJXEUUNYDYOMZYPUUTUVJRXEUULUUMUVK
      YOXLBYBYCYSUUAUQVTXEUUTUVKYPUVJXEUUTUVKYPUVJYOBXNYAYDXMYSUVIWAVOWCWDWEWFW
      GWHUUGUUHWIWJXRYFUUKWMUUBUUFUUHXRYFYAXQMUUKDXQYAVAXOUUJIYAXPXKYAXMXNVBVCW
      KWLWNWOWPWQWRWSXCWTXPUAXLBXNCDHGIUVIUUAYTEXAXPUAAXLBXNDJLKUVIUUAYTFXBXDVI
      $.
  $}

  ${
    $d p q r A $.  $d p q r K $.  $d p q r X $.
    atpsub.a $e |- A = ( Atoms ` K ) $.
    atpsub.s $e |- S = ( PSubSp ` K ) $.
    $( The set of all atoms is a projective subspace.  Remark below Definition
       15.1 of [MaedaMaeda] p. 61.  (Contributed by NM, 13-Oct-2011.)
       (New usage is discouraged.) $)
    atpsubN $p |- ( K e. V -> A e. S ) $=
      ( vr vp vq wcel wss cv cjn cfv co cple wbr wi wral eqid wa ssid ax-1 rgen
      rgen2w pm3.2i ispsubsp mpbiri ) CDJABJAAKZGLZHLILCMNZOCPNZQZUJAJZRZGASZIA
      SHASZUAUIUQAUBUPHIAAUOGAUNUMUCUDUEUFADBUKCULAGIHULTUKTEFUGUH $.

    $( A projective subspace consists of atoms.  (Contributed by NM,
       4-Nov-2011.) $)
    psubssat $p |- ( ( K e. B /\ X e. S ) -> X C_ A ) $=
      ( vr vp vq wcel wss cv cjn cfv co cple wbr wral eqid wi ispsubsp simprbda
      ) DBKECKEALHMZIMJMDNOZPDQOZRUDEKUAHASJESIESABCUEDUFEHJIUFTUETFGUBUC $.

    $( A member of a projective subspace is an atom.  (Contributed by NM,
       4-Nov-2011.)  (New usage is discouraged.) $)
    psubatN $p |- ( ( K e. B /\ X e. S /\ Y e. X ) -> Y e. A ) $=
      ( wcel wa psubssat sseld 3impia ) DBIZECIZFEIFAINOJEAFABCDEGHKLM $.
  $}

  ${
    $d a k A $.  $d k x B $.  $d a k x K $.  $d k .<_ $.
    pmapfval.b $e |- B = ( Base ` K ) $.
    pmapfval.l $e |- .<_ = ( le ` K ) $.
    pmapfval.a $e |- A = ( Atoms ` K ) $.
    pmapfval.m $e |- M = ( pmap ` K ) $.
    $( The projective map of a Hilbert lattice.  (Contributed by NM,
       2-Oct-2011.) $)
    pmapfval $p |- ( K e. C -> M = ( x e. B |-> { a e. A | a .<_ x } ) ) $=
      ( vk cvv cv cfv cbs cple catm fveq2 wcel wbr crab cmpt wceq cpmap syl6eqr
      elex breqd rabeqbidv mpteq12dv df-pmap fvex eqeltri mptex fvmpt syl5eq
      syl ) EDUAENUAZGACHOZAOZFUBZHBUCZUDZUEEDUHUSGEUFPVDLMEAMOZQPZUTVAVERPZUBZ
      HVESPZUCZUDVDNUFVEEUEZAVFVJCVCVKVFEQPZCVEEQTIUGVKVHVBHVIBVKVIESPBVEESTKUG
      VKVGFUTVAVKVGERPFVEERTJUGUIUJUKMHAULACVCCVLNIEQUMUNUOUPUQUR $.

    $d x A $.  $d x .<_ $.  $d a x X $.  $d x P $.
    $( Value of the projective map of a Hilbert lattice.  Definition in Theorem
       15.5 of [MaedaMaeda] p. 62.  (Contributed by NM, 2-Oct-2011.) $)
    pmapval $p |- ( ( K e. C /\ X e. B )
   -> ( M ` X ) = { a e. A | a .<_ X } ) $=
      ( vx wcel cfv cv wbr crab cmpt catm pmapfval fveq1d wceq rabbidv eqid cvv
      breq2 fvex eqeltri rabex fvmpt sylan9eq ) DCNZGBNGFOGMBHPZMPZEQZHARZSZOUN
      GEQZHARZUMGFURMABCDEFHIJKLUAUBMGUQUTBURUOGUCUPUSHAUOGUNEUGUDURUEUSHAADTOU
      FKDTUHUIUJUKUL $.

    $( Member of a projective map.  (Contributed by NM, 27-Jan-2012.) $)
    elpmap $p |- ( ( K e. C /\ X e. B ) -> ( P e. ( M ` X ) <->
          ( P e. A /\ P .<_ X ) ) ) $=
      ( vx wcel wa cfv cv wbr crab pmapval eleq2d breq1 elrab syl6bb ) ECNHBNOZ
      DHGPZNDMQZHFRZMASZNDANDHFRZOUEUFUIDABCEFGHMIJKLTUAUHUJMDAUGDHFUBUCUD $.
  $}

  ${
    $d p A $.  $d p K $.  $d p X $.
    pmapssat.b $e |- B = ( Base ` K ) $.
    pmapssat.a $e |- A = ( Atoms ` K ) $.
    pmapssat.m $e |- M = ( pmap ` K ) $.
    $( The projective map of a Hilbert lattice is a set of atoms.  (Contributed
       by NM, 14-Jan-2012.) $)
    pmapssat $p |- ( ( K e. C /\ X e. B ) -> ( M ` X ) C_ A ) $=
      ( vp wcel wa cfv cv cple wbr crab eqid pmapval ssrab2 syl6eqss ) DCKFBKLF
      EMJNFDOMZPZJAQAABCDUBEFJGUBRHISUCJATUA $.
  $}

  ${
    pmapssba.b $e |- B = ( Base ` K ) $.
    pmapssba.m $e |- M = ( pmap ` K ) $.
    $( A weakening of ~ pmapssat to shorten some proofs.  (Contributed by NM,
       7-Mar-2012.)  (New usage is discouraged.) $)
    pmapssbaN $p |- ( ( K e. C /\ X e. B ) -> ( M ` X ) C_ B ) $=
      ( wcel wa cfv catm eqid pmapssat atssbase syl6ss ) CBHEAHIEDJCKJZAPABCDEF
      PLZGMPACFQNO $.
  $}

  ${
    $d p B $.  $d p K $.  $d p .<_ $.  $d p X $.  $d p Y $.
    pmaple.b $e |- B = ( Base ` K ) $.
    pmaple.l $e |- .<_ = ( le ` K ) $.
    pmaple.m $e |- M = ( pmap ` K ) $.
    $( The projective map of a Hilbert lattice preserves ordering.  Part of
       Theorem 15.5 of [MaedaMaeda] p. 62.  (Contributed by NM,
       22-Oct-2011.) $)
    pmaple $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
                   -> ( X .<_ Y <-> ( M ` X ) C_ ( M ` Y ) ) ) $=
      ( vp chlt wcel w3a wbr cfv crab wss wi eqid wceq cv catm cpo hlpos atbase
      wral postr exp4b 3expd com23 com34 3imp syl5 ralrimdv syl3an1 ss2rab club
      syl6ibr ccla hlclat ssrab2 atssbase sstri mp3an2 ex syl 3ad2ant1 coml cal
      lubss simp2 atlatmstc syl2anc simp3 breq12d sylibd impbid pmapval 3adant3
      hlomcmat 3adant2 sseq12d bitr4d ) BKLZEALZFALZMZEFCNZJUAZECNZJBUBOZPZWIFC
      NZJWKPZQZEDOZFDOZQWGWHWOWGWHWJWMRZJWKUFZWOWDBUCLZWEWFWHWSRBUDWTWEWFMZWHWR
      JWKXAWIWKLZWHWRXAXBWJWHWMXBWIALZXAWJWHWMRRZWKAWIBGWKSZUEWTWEWFXCXDRWTWEXC
      WFXDWTXCWEWFXDRWTXCWEWFXDWTXCWEWFMWJWHWMABCWIEFGHUGUHUIUJUKULUMUKUJUNUOWJ
      WMJWKUPURWGWOWLBUQOZOZWNXFOZCNZWHWDWEWOXIRZWFWDBUSLZXJBUTXKWOXIXKWNAQWOXI
      WNWKAWMJWKVAWKABGXEVBVCAWLWNXFBCGHXFSZVJVDVEVFVGWGXGEXHFCWGBVHLXKBVILMZWE
      XGETWDWEXMWFBVTVGZWDWEWFVKJWKAXFBCEGHXLXEVLVMWGXMWFXHFTXNWDWEWFVNJWKAXFBC
      FGHXLXEVLVMVOVPVQWGWPWLWQWNWDWEWPWLTWFWKAKBCDEJGHXEIVRVSWDWFWQWNTWEWKAKBC
      DFJGHXEIVRWAWBWC $.
  $}

  ${
    pmap11.b $e |- B = ( Base ` K ) $.
    pmap11.m $e |- M = ( pmap ` K ) $.
    $( The projective map of a Hilbert lattice is one-to-one.  Part of Theorem
       15.5 of [MaedaMaeda] p. 62.  (Contributed by NM, 22-Oct-2011.) $)
    pmap11 $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
                   -> ( ( M ` X ) = ( M ` Y ) <-> X = Y ) ) $=
      ( chlt wcel w3a wceq cfv wss wa cple wbr clat wb hllat pmaple eqid 3com23
      latasymb syl3an1 anbi12d bitr3d eqss syl6rbbr ) BHIZDAIZEAIZJZDEKZDCLZECL
      ZMZUOUNMZNZUNUOKULDEBOLZPZEDUSPZNZUMURUIBQIUJUKVBUMRBSABUSDEFUSUAZUCUDULU
      TUPVAUQABUSCDEFVCGTUIUKUJVAUQRABUSCEDFVCGTUBUEUFUNUOUGUH $.
  $}

  ${
    $d q A $.  $d q K $.  $d q P $.
    pmapat.a $e |- A = ( Atoms ` K ) $.
    pmapat.m $e |- M = ( pmap ` K ) $.
    $( The projective map of an atom.  (Contributed by NM, 25-Jan-2012.) $)
    pmapat $p |- ( ( K e. HL /\ P e. A ) -> ( M ` P ) = { P } ) $=
      ( vq chlt wcel wa cfv cv cple wbr crab wceq csn cbs eqid atbase sylan2 wb
      pmapval cal hlatl ad2antrr simpr simplr atcmp syl3anc rabsn adantl 3eqtrd
      rabbidva ) CHIZBAIZJZBDKZGLZBCMKZNZGAOZUSBPZGAOZBQZUPUOBCRKZIURVBPAVFBCVF
      SZETAVFHCUTDBGVGUTSZEFUCUAUQVAVCGAUQUSAIZJCUDIZVIUPVAVCUBUOVJUPVICUEUFUQV
      IUGUOUPVIUHAUSBCUTVHEUIUJUNUPVDVEPUOGABUKULUM $.

    $( Member of the projective map of an atom.  (Contributed by NM,
       27-Jan-2012.) $)
    elpmapat $p |- ( ( K e. HL /\ P e. A )
   -> ( X e. ( M ` P ) <-> X = P ) ) $=
      ( chlt wcel wa cfv csn wceq pmapat eleq2d wb elsnc2g adantl bitrd ) CHIZB
      AIZJZEBDKZIEBLZIZEBMZUBUCUDEABCDFGNOUAUEUFPTEBAQRS $.
  $}

  ${
    $d a K $.  $d a .0. $.
    pmap0.z $e |- .0. = ( 0. ` K ) $.
    pmap0.m $e |- M = ( pmap ` K ) $.
    $( Value of the projective map of a Hilbert lattice at lattice zero.  Part
       of Theorem 15.5.1 of [MaedaMaeda] p. 62.  (Contributed by NM,
       17-Oct-2011.) $)
    pmap0 $p |- ( K e. AtLat -> ( M ` .0. ) = (/) ) $=
      ( va cal wcel cfv cv cple wbr catm crab c0 cbs wceq eqid atl0cl pmapval
      mpdan wne wn wrex atnle0 nrexdv rabn0 sylnibr nne sylib eqtrd ) AGHZCBIZF
      JZCAKIZLZFAMIZNZOULCAPIZHUMURQUSACUSRZDSUQUSGAUOBCFUTUORZUQRZETUAULUROUBZ
      UCUROQULUPFUQUDVCULUPFUQUQUNAUOCVADVBUEUFUPFUQUGUHUROUIUJUK $.
  $}

  ${
    $d a K $.  $d a .0. $.
    pmapeq0.b $e |- B = ( Base ` K ) $.
    pmapeq0.z $e |- .0. = ( 0. ` K ) $.
    pmapeq0.m $e |- M = ( pmap ` K ) $.
    $( A projective map value is zero iff its argument is lattice zero.
       (Contributed by NM, 27-Jan-2012.) $)
    pmapeq0 $p |- ( ( K e. HL /\ X e. B )
   -> ( ( M ` X ) = (/) <-> X = .0. ) ) $=
      ( chlt wcel wa cfv wceq c0 cal hlatl adantr pmap0 syl eqeq2d wb cops hlop
      op0cl pmap11 mpd3an3 bitr3d ) BIJZDAJZKZDCLZECLZMZUKNMDEMZUJULNUKUJBOJZUL
      NMUHUOUIBPQBCEGHRSTUHUIEAJZUMUNUAUJBUBJZUPUHUQUIBUCQABEFGUDSABCDEFHUEUFUG
      $.
  $}

  ${
    $d p A $.  $d p K $.  $d p .1. $.
    pmap1.u $e |- .1. = ( 1. ` K ) $.
    pmap1.a $e |- A = ( Atoms ` K ) $.
    pmap1.m $e |- M = ( pmap ` K ) $.
    $( Value of the projective map of a Hilbert lattice at lattice unit.  Part
       of Theorem 15.5.1 of [MaedaMaeda] p. 62.  (Contributed by NM,
       22-Oct-2011.)  (New usage is discouraged.) $)
    pmap1N $p |- ( K e. OP -> ( M ` .1. ) = A ) $=
      ( vp cops wcel cfv cv cple wbr crab cbs wceq eqid op1cl pmapval ralrimiva
      mpdan wral atbase ople1 sylan2 rabid2 sylibr eqtr4d ) CIJZBDKZHLZBCMKZNZH
      AOZAUJBCPKZJUKUOQUPBCUPRZESAUPICUMDBHUQUMRZFGTUBUJUNHAUCAUOQUJUNHAULAJUJU
      LUPJUNAUPULCUQFUDUPBCUMULUQUREUEUFUAUNHAUGUHUI $.
  $}

  ${
    $d p q r B $.  $d c p q r K $.  $d c p q r X $.
    pmapsub.b $e |- B = ( Base ` K ) $.
    pmapsub.s $e |- S = ( PSubSp ` K ) $.
    pmapsub.m $e |- M = ( pmap ` K ) $.
    $( The projective map of a Hilbert lattice maps to projective subspaces.
       Part of Theorem 15.5 of [MaedaMaeda] p. 62.  (Contributed by NM,
       17-Oct-2011.) $)
    pmapsub $p |- ( ( K e. Lat /\ X e. B ) -> ( M ` X ) e. S ) $=
      ( vc vr vp vq clat wcel wa cfv cv wbr eqid wi cple catm crab pmapval wral
      wss cjn breq1 elrab atbase anim1i sylbi anim12i an4 sylib anim2i latjle12
      w3a biimpd 3exp2 imp3a com23 imp43 adantr latjcl 3expib lattr com24 syl5d
      co imp41 adantlrr mpan2d syl2an simpr jctild syl6ibr ralrimiva ralrimivva
      ssrab2 jctil wb ispsubsp mpbird eqeltrd ) CMNZEANZOZEDPIQZECUAPZRZICUBPZU
      CZBWLAMCWJDEIFWJSZWLSZHUDWHWMBNZWMWLUFZJQZKQZLQZCUGPZVJZWJRZWRWMNZTZJWLUE
      ZLWMUEKWMUEZOZWHXGWQWHXFKLWMWMWHWSWMNZWTWMNZOZOZXEJWLXLWRWLNZOZXCXMWREWJR
      ZOXDXNXCXOXMXLWHWSANZWTANZOZWSEWJRZWTEWJRZOZOZOZWRANZXCXOTXMXKYBWHXKXPXSO
      ZXQXTOZOYBXIYEXJYFXIWSWLNZXSOYEWKXSIWSWLWIWSEWJUHUIYGXPXSWLAWSCFWOUJUKULX
      JWTWLNZXTOYFWKXTIWTWLWIWTEWJUHUIYHXQXTWLAWTCFWOUJUKULUMXPXSXQXTUNUOUPWLAW
      RCFWOUJYCYDOXCXBEWJRZXOYCYIYDWFWGXRYAYIWFXRWGYAYITZWFXPXQWGYJTWFXPXQWGYJW
      FXPXQWGUROYAYIAXACWJWSWTEFWNXASZUQUSUTVAVBVCVDWHXRYDXCYIOXOTZYAWFWGXRYDYL
      WFXRXBANZWGYDYLTWFXPXQYMAXACWSWTFYKVEVFWFYDYMWGYLWFYDYMWGYLACWJWRXBEFWNVG
      UTVHVIVKVLVMVNXLXMVOVPWKXOIWRWLWIWREWJUHUIVQVRVSWKIWLVTWAWFWPXHWBWGWLMBXA
      CWJWMJLKWNYKWOGWCVDWDWE $.
  $}

  ${
    $d i p x y z B $.  $d p z G $.  $d i p y z I $.  $d i p x y z K $.
    $d p x y z S $.
    pmapglb.b $e |- B = ( Base ` K ) $.
    pmapglb.g $e |- G = ( glb ` K ) $.
    pmapglb.m $e |- M = ( pmap ` K ) $.
    $( The projective map of the GLB of a set of lattice elements.  Index-set
       version of ~ pmapglb , where we read ` S ` as ` S ( i ) ` .  Theorem
       15.5.2 of [MaedaMaeda] p. 62.  (Contributed by NM, 5-Dec-2011.) $)
    pmapglbx $p |- ( ( K e. HL /\ A. i e. I S e. B /\ I =/= (/) )
    -> ( M ` ( G ` { y | E. i e. I y = S } ) ) = |^|_ i e. I ( M ` S ) ) $=
      ( vp vz wcel wral cv wceq cfv wa wb chlt wne w3a wrex cple catm crab ciin
      c0 cab wbr ccla wss hlclat ad2antrr atbase adantl r19.29 eleq1a rexlimivw
      eqid wi imp syl ex ad2antlr abssdv clatleglb syl3anc wal vex rexbidv elab
      eqeq1 imbi1i r19.23v bitr4i albii df-ral ralcom4 3bitr4i nfv breq2 ralimi
      ceqsalg ralbi syl5bb bitrd 3adant3 simp1 clatglbcl syl2an pmapval syl2anc
      rabbidva iinrab 3ad2ant3 3eqtr4d nfra1 nf3an simpl1 rsp 3ad2antl2 iineq2d
      eqtr4d ) GUANZCBNZDFOZFUIUBZUCZAPZCQZDFUDZAUJZERZHRZDFLPZCGUERZUKZLGUFRZU
      GZUHZDFCHRZUHXJXQXOXRUKZLXTUGZXSDFOZLXTUGZXPYBXFXHYEYGQXIXFXHSZYDYFLXTYHX
      QXTNZSZYDXQMPZXRUKZMXNOZYFYJGULNZXQBNZXNBUMZYDYMTXFYNXHYIGUNZUOYIYOYHXTBX
      QGIXTVAZUPUQYJXMABXHXMXKBNZVBXFYIXHXMYSXHXMSXGXLSZDFUDYSXGXLDFURYTYSDFXGX
      LYSCBXKUSVCUTVDVEZVFVGMBXNEGXRXQIXRVAZJVHVIXHYMYFTXFYIYMYKCQZYLVBZMVJZDFO
      ZXHYFYKXNNZYLVBZMVJUUDDFOZMVJYMUUFUUHUUIMUUHUUCDFUDZYLVBUUIUUGUUJYLXMUUJA
      YKMVKXKYKQXLUUCDFXKYKCVNVLVMVOUUCYLDFVPVQVRYLMXNVSUUDDMFVTWAXHUUEXSTZDFOU
      UFYFTXGUUKDFYLXSMCBXSMWBYKCXQXRWCWEWDUUEXSDFWFVDWGVFWHWOWIXJXFXOBNZXPYEQX
      FXHXIWJXFXHUULXIXFYNYPUULXHYQXHXMABUUAVGBXNEGIJWKWLWIXTBUAGXRHXOLIUUBYRKW
      MWNXIXFYBYGQXHXSDLFXTWPWQWRXJDFYCYAXFXHXIDXFDWBXGDFWSXIDWBWTXJDPFNZSXFXGY
      CYAQXFXHXIUUMXAXHXFUUMXGXIXHUUMXGXGDFXBVCXCXTBUAGXRHCLIUUBYRKWMWNXDXE $.

    $( The projective map of the GLB of a set of lattice elements ` S ` .
       Variant of Theorem 15.5.2 of [MaedaMaeda] p. 62.  (Contributed by NM,
       5-Dec-2011.) $)
    pmapglb $p |- ( ( K e. HL /\ S C_ B /\ S =/= (/) )
        -> ( M ` ( G ` S ) ) = |^|_ x e. S ( M ` x ) ) $=
      ( vy chlt wcel cfv weq cab cv wa wex bitri fveq2i wss wne w3a wrex df-rex
      c0 ciin equcom anbi2i ancom exbii vex eleq1 ceqsexv abbii abid2 wral wceq
      eqtr2i dfss3 pmapglbx syl3an2b syl5eq ) EKLZCBUAZCUFUBZUCCDMZFMJANZACUDZJ
      OZDMZFMZACAPZFMUGZVGVKFCVJDVJJPZCLZJOCVIVPJVIVMCLZVHQZARZVPVHACUEVSAJNZVQ
      QZARVPVRWAAVRVQVTQWAVHVTVQJAUHUIVQVTUJSUKVQVPAVOJULVMVOCUMUNSSUOJCUPUSTTV
      EVDVMBLACUQVFVLVNURACBUTJBVMADCEFGHIVAVBVC $.
  $}

  ${
    $d i x A $.  $d i x y B $.  $d i y I $.  $d i x y K $.  $d x y S $.
    pmapglb2.b $e |- B = ( Base ` K ) $.
    pmapglb2.g $e |- G = ( glb ` K ) $.
    pmapglb2.a $e |- A = ( Atoms ` K ) $.
    pmapglb2.m $e |- M = ( pmap ` K ) $.
    $( The projective map of the GLB of a set of lattice elements ` S ` .
       Variant of Theorem 15.5.2 of [MaedaMaeda] p. 62.  Allows ` S = (/) ` .
       (Contributed by NM, 21-Jan-2012.)  (New usage is discouraged.) $)
    pmapglb2N $p |- ( ( K e. HL /\ S C_ B )
        -> ( M ` ( G ` S ) ) = ( A i^i |^|_ x e. S ( M ` x ) ) ) $=
      ( chlt wcel wss wa cfv wceq c0 fveq2d syl cv ciin cin cops hlop cp1 glb0N
      wi eqid pmap1N eqtrd fveq2 eqeq12d syl5ibrcom adantr wne w3a pmapglb wrex
      riin0 wex simpr simpll ssel2 adantll pmapssat syl2anc ex eximdv n0 df-rex
      jca 3imtr4g 3impia iinss sseqin2 sylib eqtr4d 3expia pm2.61dne ) FLMZDCNZ
      OZDEPZGPZBADAUAZGPZUBZUCZQZDRWADRQZWJUHWBWAWJWKREPZGPZBQZWAFUDMZWNFUEWOWM
      FUFPZGPBWOWLWPGWPEFIWPUIZUGSBWPFGWQJKUJUKTWKWEWMWIBWKWDWLGDREULSABWGDUTUM
      UNUOWAWBDRUPZWJWAWBWRUQZWEWHWIACDEFGHIKURWSWHBNZWIWHQWSWGBNZADUSZWTWAWBWR
      XBWCWFDMZAVAXCXAOZAVAWRXBWCXCXDAWCXCXDWCXCOZXCXAWCXCVBXEWAWFCMZXAWAWBXCVC
      WBXCXFWADCWFVDVEBCLFGWFHJKVFVGVLVHVIADVJXAADVKVMVNADWGBVOTWHBVPVQVRVSVT
      $.

    $( The projective map of the GLB of a set of lattice elements.  Index-set
       version of ~ pmapglb2N , where we read ` S ` as ` S ( i ) ` .  Extension
       of Theorem 15.5.2 of [MaedaMaeda] p. 62 that allows ` I = (/) ` .
       (Contributed by NM, 21-Jan-2012.)  (New usage is discouraged.) $)
    pmapglb2xN $p |- ( ( K e. HL /\ A. i e. I S e. B ) ->
 ( M ` ( G ` { y | E. i e. I y = S } ) )
   = ( A i^i |^|_ i e. I ( M ` S ) ) ) $=
      ( wcel wa wceq wrex cfv c0 fveq2d chlt wral cv cab ciin cin cops hlop cp1
      wi eqid glb0N pmap1N eqtrd syl rexeq abbidv rex0 abf syl6eq riin0 eqeq12d
      syl5ibrcom adantr wne w3a pmapglbx wss wex nfv nfra1 simpr simpll rsp imp
      nfan adantll pmapssat syl2anc jca ex eximd n0 df-rex 3imtr4g 3impia iinss
      sseqin2 sylib eqtr4d 3expia pm2.61dne ) HUANZDCNZEGUBZOZAUCDPZEGQZAUDZFRZ
      IRZBEGDIRZUEZUFZPZGSWMGSPZXEUJWOWMXEXFSFRZIRZBPZWMHUGNZXIHUHXJXHHUIRZIRBX
      JXGXKIXKFHKXKUKZULTBXKHIXLLMUMUNUOXFXAXHXDBXFWTXGIXFWSSFXFWSWQESQZAUDSXFW
      RXMAWQEGSUPUQXMAWQEURUSUTTTEBXBGVAVBVCVDWMWOGSVEZXEWMWOXNVFZXAXCXDACDEFGH
      IJKMVGXOXCBVHZXDXCPXOXBBVHZEGQZXPWMWOXNXRWPEUCGNZEVIXSXQOZEVIXNXRWPXSXTEW
      MWOEWMEVJWNEGVKVPWPXSXTWPXSOZXSXQWPXSVLYAWMWNXQWMWOXSVMWOXSWNWMWOXSWNWNEG
      VNVOVQBCUAHIDJLMVRVSVTWAWBEGWCXQEGWDWEWFEGXBBWGUOXCBWHWIWJWKWL $.
  $}

  ${
    $d x B $.  $d x K $.  $d x P $.  $d x X $.  $d x Y $.
    pmapmeet.b $e |- B = ( Base ` K ) $.
    pmapmeet.m $e |- ./\ = ( meet ` K ) $.
    pmapmeet.a $e |- A = ( Atoms ` K ) $.
    pmapmeet.p $e |- P = ( pmap ` K ) $.
    $( The projective map of a meet.  (Contributed by NM, 25-Jan-2012.) $)
    pmapmeet $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
      -> ( P ` ( X ./\ Y ) ) = ( ( P ` X ) i^i ( P ` Y ) ) ) $=
      ( vx chlt wcel w3a co cfv wceq 3adant1 fveq2 cpr cglb cv ciin cin meetval
      eqid fveq2d wss c0 wne simp1 prssi prnzg 3ad2ant2 pmapglb syl3anc iinxprg
      3eqtrd ) DMNZFBNZGBNZOZFGEPZCQFGUAZDUBQZQZCQZLVELUCZCQZUDZFCQZGCQZUEZVCVD
      VGCMBVFDEFGHVFUGZIUFUHVCUTVEBUIZVEUJUKZVHVKRUTVAVBULVAVBVPUTFGBUMSVAUTVQV
      BFGBUNUOLBVEVFDCHVOKUPUQVAVBVKVNRUTLFGVJVLVMBBVIFCTVIGCTURSUS $.
  $}

  ${
    $d p q r A $.  $d r .\/ $.  $d p q r K $.  $d p q X $.
    isline2.j $e |- .\/ = ( join ` K ) $.
    isline2.a $e |- A = ( Atoms ` K ) $.
    isline2.n $e |- N = ( Lines ` K ) $.
    isline2.m $e |- M = ( pmap ` K ) $.
    $( Definition of line in terms of projective map.  (Contributed by NM,
       25-Jan-2012.) $)
    isline2 $p |- ( K e. Lat -> ( X e. N
        <-> E. p e. A E. q e. A ( p =/= q /\ X = ( M ` ( p .\/ q ) ) ) ) ) $=
      ( vr clat wcel cv cfv wceq wa wrex wne co cple wbr crab eqid isline simpl
      cbs atbase ad2antrl latjcl syl3anc pmapval syldan eqeq2d anbi2d 2rexbidva
      ad2antll bitr4d ) CNOZFEOHPZGPZUAZFMPVBVCBUBZCUCQZUDMAUEZRZSZGATHATVDFVED
      QZRZSZGATHATANBCVFEFGHMVFUFZIJKUGVAVLVIHGAAVAVBAOZVCAOZSZSZVKVHVDVQVJVGFV
      AVPVECUIQZOZVJVGRVQVAVBVROZVCVROZVSVAVPUHVNVTVAVOAVRVBCVRUFZJUJUKVOWAVAVN
      AVRVCCWBJUJUSVRBCVBVCWBIULUMAVRNCVFDVEMWBVMJLUNUOUPUQURUT $.

    $d r P $.  $d r Q $.
    $( A line described with a projective map.  (Contributed by NM,
       3-Feb-2012.) $)
    linepmap $p |- ( ( ( K e. Lat /\ P e. A /\ Q e. A ) /\ P =/= Q )
        -> ( M ` ( P .\/ Q ) ) e. N ) $=
      ( vr clat wcel w3a cfv wceq eqid atbase syl wne wa co cv cple crab simpl1
      wbr simpl2 simpl3 latjcl syl3anc pmapval syl2anc islinei mpanr2 eqeltrd
      cbs ) EMNZBANZCANZOZBCUAZUBZBCDUCZFPZLUDVEEUEPZUHLAUFZGVDUSVEEURPZNZVFVHQ
      USUTVAVCUGZVDUSBVINZCVINZVJVKVDUTVLUSUTVAVCUIAVIBEVIRZISTVDVAVMUSUTVAVCUJ
      AVICEVNISTVIDEBCVNHUKULAVIMEVGFVELVNVGRZIKUMUNVBVCVHVHQVHGNVHRAMBCDEVGGVH
      LVOHIJUOUPUQ $.
  $}

  ${
    $d p q B $.  $d p q A $.  $d p q K $.  $d p q M $.  $d p q X $.
    isline3.b $e |- B = ( Base ` K ) $.
    isline3.j $e |- .\/ = ( join ` K ) $.
    isline3.a $e |- A = ( Atoms ` K ) $.
    isline3.n $e |- N = ( Lines ` K ) $.
    isline3.m $e |- M = ( pmap ` K ) $.
    $( Definition of line in terms of original lattice elements.  (Contributed
       by NM, 29-Apr-2012.) $)
    isline3 $p |- ( ( K e. HL /\ X e. B ) -> ( ( M ` X ) e. N
         <-> E. p e. A E. q e. A ( p =/= q /\ X = ( p .\/ q ) ) ) ) $=
      ( wcel wa cfv cv wceq wrex chlt wne co wb hllat adantr isline2 syl simpll
      clat simplr ad2antrr atbase ad2antrl ad2antll latjcl syl3anc pmap11 bitrd
      anbi2d 2rexbidva ) DUAOZGBOZPZGEQZFOZIRZHRZUBZVEVGVHCUCZEQSZPZHATIATZVIGV
      JSZPZHATIATVDDUJOZVFVMUDVBVPVCDUEZUFACDEFVEHIKLMNUGUHVDVLVOIHAAVDVGAOZVHA
      OZPZPZVKVNVIWAVBVCVJBOZVKVNUDVBVCVTUIVBVCVTUKWAVPVGBOZVHBOZWBVBVPVCVTVQUL
      VRWCVDVSABVGDJLUMUNVSWDVDVRABVHDJLUMUOBCDVGVHJKUPUQBDEGVJJNURUQUTVAUS $.
  $}

  ${
    $d p q A $.  $d p q B $.  $d q C $.  $d p q K $.  $d p q M $.  $d p q X $.
    isline4.b $e |- B = ( Base ` K ) $.
    isline4.c $e |- C = ( <o ` K ) $.
    isline4.a $e |- A = ( Atoms ` K ) $.
    isline4.n $e |- N = ( Lines ` K ) $.
    isline4.m $e |- M = ( pmap ` K ) $.
    $( Definition of line in terms of original lattice elements.  (Contributed
       by NM, 16-Jun-2012.)  (New usage is discouraged.) $)
    isline4N $p |- ( ( K e. HL /\ X e. B ) -> ( ( M ` X ) e. N
         <-> E. p e. A p C X ) ) $=
      ( vq wcel wa cfv cv wrex wb chlt wne cjn co wceq wbr eqid isline3 cple wn
      simpll atbase adantl simplr cvrval3 syl3anc hlatl ad3antrrr atncmp syl6bb
      cal simpr necom eqcom a1i anbi12d rexbidva bitrd bitr4d ) DUAOZGBOZPZGEQF
      OHRZNRZUBZGVMVNDUCQZUDZUEZPZNASZHASVMGCUFZHASABVPDEFGNHIVPUGZKLMUHVLWAVTH
      AVLVMAOZPZWAVNVMDUIQZUFUJZVQGUEZPZNASZVTWDVJVMBOZVKWAWITVJVKWCUKWCWJVLABV
      MDIKULUMVJVKWCUNABCVPDWEVMGNIWEUGZWBJKUOUPWDWHVSNAWDVNAOZPZWFVOWGVRWMWFVN
      VMUBZVOWMDVAOZWLWCWFWNTVJWOVKWCWLDUQURWDWLVBVLWCWLUNAVNVMDWEWKKUSUPVNVMVC
      UTWGVRTWMVQGVDVEVFVGVHVGVI $.
  $}

  ${
    $d r s A $.  $d r s B $.  $d r s .\/ $.  $d r s K $.  $d r s .<_ $.
    $d r s M $.  $d r s N $.  $d r s P $.  $d r s Q $.  $d r s X $.
    lneq2at.b $e |- B = ( Base ` K ) $.
    lneq2at.l $e |- .<_ = ( le ` K ) $.
    lneq2at.j $e |- .\/ = ( join ` K ) $.
    lneq2at.a $e |- A = ( Atoms ` K ) $.
    lneq2at.n $e |- N = ( Lines ` K ) $.
    lneq2at.m $e |- M = ( pmap ` K ) $.
    $( A line equals the join of any two of its distinct points (atoms).
       (Contributed by NM, 29-Apr-2012.) $)
    lneq2at $p |- ( ( ( K e. HL /\ X e. B /\ ( M ` X ) e. N )
      /\ ( P e. A /\ Q e. A /\ P =/= Q ) /\ ( P .<_ X /\ Q .<_ X ) )
                 -> X = ( P .\/ Q ) ) $=
      ( vr wcel w3a wa vs chlt cfv wne wbr cv co wceq wrex simp11 simp12 simp13
      jca isline3 biimpd sylc simp3r simp111 simp121 simp122 simp2 3jca simp123
      clat hllat simp21 atbase simp22 simp3 latjle12 3ad2ant1 breqtrd wb simpl1
      syl simpl2l simpl2r simpr simpl3 ps-1 syl131anc eqtr4d 3exp rexlimdvv mpd
      ) FUBRZJBRZJHUCIRZSZCARZDARZCDUDZSZCJGUEDJGUETZSZQUFZUAUFZUDZJWPWQEUGZUHZ
      TZUAAUIQAUIZJCDEUGZUHZWOWFWGTZWHXBWOWFWGWFWGWHWMWNUJZWFWGWHWMWNUKZUMWFWGW
      HWMWNULXEWHXBABEFHIJUAQKMNOPUNUOUPWOXAXDQUAAAWOWPARWQARTZXAXDWOXHXASZJWSX
      CWOXHWRWTUQZXIWFWJWKTZXHSZWLTZXCWSGUEZXCWSUHZXIXLWLXIWFXKXHWFWGWHWMWNXHXA
      URXIWJWKWJWKWLWIWNXHXAUSWJWKWLWIWNXHXAUTUMWOXHXAVAVBWJWKWLWIWNXHXAVCUMXIX
      CJWSGWOXHXCJGUEZXAWOFVDRZCBRZDBRZWGSZTZWNXPWOXQXTWOWFXQXFFVEVOWOXRXSWGWOW
      JXRWIWJWKWLWNVFABCFKNVGVOWOWKXSWIWJWKWLWNVHABDFKNVGVOXGVBUMWIWMWNVIYAWNXP
      BEFGCDJKLMVJUOUPVKXJVLXMXNXOXMWFWJWKWLXHXNXOVMWFXKXHWLVNWJWKWFXHWLVPWJWKW
      FXHWLVQXLWLVRWFXKXHWLVSACDWPWQEFGLMNVTWAUOUPWBWCWDWE $.
  $}

  ${
    $d q r s A $.  $d r s B $.  $d r s K $.  $d q r s .<_ $.  $d r s M $.
    $d r s N $.  $d q r s P $.  $d q r s X $.
    lnatex.b $e |- B = ( Base ` K ) $.
    lnatex.l $e |- .<_ = ( le ` K ) $.
    lnatex.a $e |- A = ( Atoms ` K ) $.
    lnatex.n $e |- N = ( Lines ` K ) $.
    lnatex.m $e |- M = ( pmap ` K ) $.
    $( There is an atom in a line different from any other.  (Contributed by
       NM, 30-Apr-2012.)  (New usage is discouraged.) $)
    lnatexN $p |- ( ( K e. HL /\ X e. B /\ ( M ` X ) e. N )
         -> E. q e. A ( q =/= P /\ q .<_ X ) ) $=
      ( vr vs wcel wne wa wbr chlt cfv w3a cv co wceq wrex eqid isline3 biimp3a
      cjn simpl2r simpl3l necomd simpr neeqtrd simpl11 simpl2l hlatlej2 syl3anc
      simpl3r breqtrrd weq neeq1 breq1 rspcev syl12anc hlatlej1 pm2.61dane 3exp
      anbi12d rexlimdvv mpd ) DUAQZHBQZHFUBGQZUCZOUDZPUDZRZHVRVSDUKUBZUEZUFZSZP
      AUGOAUGZIUDZCRZWFHETZSZIAUGZVNVOVPWEABWADFGHPOJWAUHZLMNUIUJVQWDWJOPAAVQVR
      AQZVSAQZSZWDWJVQWNWDUCZWJVRCWOVRCUFZSZWMVSCRZVSHETZWJWLWMVQWDWPULZWQVSVRC
      WQVRVSVTWCVQWNWPUMUNWOWPUOUPWQVSWBHEWQVNWLWMVSWBETVNVOVPWNWDWPUQWLWMVQWDW
      PURWTAVRVSWADEKWKLUSUTVTWCVQWNWPVAVBWIWRWSSIVSAIPVCWGWRWHWSWFVSCVDWFVSHEV
      EVKVFVGWOVRCRZSZWLXAVRHETZWJWLWMVQWDXAURZWOXAUOXBVRWBHEXBVNWLWMVRWBETVNVO
      VPWNWDXAUQXDWLWMVQWDXAULAVRVSWADEKWKLVHUTVTWCVQWNXAVAVBWIXAXCSIVRAIOVCWGX
      AWHXCWFVRCVDWFVRHEVEVKVFVGVIVJVLVM $.
  $}

  ${
    $d q A $.  $d q B $.  $d q K $.  $d q .<_ $.  $d q M $.  $d q N $.
    $d q N $.  $d q P $.  $d q X $.
    lnjat.b $e |- B = ( Base ` K ) $.
    lnjat.l $e |- .<_ = ( le ` K ) $.
    lnjat.j $e |- .\/ = ( join ` K ) $.
    lnjat.a $e |- A = ( Atoms ` K ) $.
    lnjat.n $e |- N = ( Lines ` K ) $.
    lnjat.m $e |- M = ( pmap ` K ) $.
    $( Given an atom in a line, there is another atom which when joined equals
       the line.  (Contributed by NM, 30-Apr-2012.)
       (New usage is discouraged.) $)
    lnjatN $p |- ( ( ( K e. HL /\ X e. B /\ P e. A ) /\ ( ( M ` X ) e. N
       /\ P .<_ X ) ) -> E. q e. A ( q =/= P /\ X = ( P .\/ q ) ) ) $=
      ( wcel w3a wbr wa chlt cfv cv wne wrex wceq simpl1 simpl2 lnatexN syl3anc
      simprl simp3l simp1l1 simp1l2 simp1rl simp1l3 simp2 necomd simp1rr simp3r
      co lneq2at syl332anc jca 3exp reximdvai mpd ) EUAQZIBQZCAQZRZIGUBHQZCIFSZ
      TZTZJUCZCUDZVPIFSZTZJAUEZVQICVPDVAUFZTZJAUEVOVHVIVLVTVHVIVJVNUGVHVIVJVNUH
      VKVLVMUKABCEFGHIJKLNOPUIUJVOVSWBJAVOVPAQZVSWBVOWCVSRZVQWAVOWCVQVRULZWDVHV
      IVLVJWCCVPUDVMVRWAVHVIVJVNWCVSUMVHVIVJVNWCVSUNVLVMVKWCVSUOVHVIVJVNWCVSUPV
      OWCVSUQWDVPCWEURVLVMVKWCVSUSVOWCVQVRUTABCVPDEFGHIKLMNOPVBVCVDVEVFVG $.
  $}

  ${
    $d q r A $.  $d q r B $.  $d q r C $.  $d q r K $.  $d q r M $.
    $d q r P $.  $d q r X $.
    lncvrelat.b $e |- B = ( Base ` K ) $.
    lncvrelat.c $e |- C = ( <o ` K ) $.
    lncvrelat.a $e |- A = ( Atoms ` K ) $.
    lncvrelat.n $e |- N = ( Lines ` K ) $.
    lncvrelat.m $e |- M = ( pmap ` K ) $.
    $( A lattice element covered by a line is an atom.  (Contributed by NM,
       28-Apr-2012.)  (New usage is discouraged.) $)
    lncvrelatN $p |- ( ( ( K e. HL /\ X e. B /\ P e. B )
        /\ ( ( M ` X ) e. N /\ P C X ) ) -> P e. A ) $=
      ( vq vr wcel w3a cfv wa syl chlt wbr cv wne co wceq wrex wi clat wb hllat
      cjn 3ad2ant1 isline2 simpll1 simpll2 simplrl atbase simplrr latjcl pmap11
      eqid syl3anc breq2 biimpd adantr simpll3 simplr simpr cvrat2 syl112anc ex
      3jca syl9r sylbid expimpd rexlimdvva imp32 ) EUAPZHBPZDBPZQZHFRZGPZDHCUBZ
      DAPZWBWDNUCZOUCZUDZWCWGWHEULRZUEZFRUFZSZOAUGNAUGZWEWFUHZWBEUIPZWDWNUJVSVT
      WPWAEUKZUMAWJEFGWCONWJVBZKLMUNTWBWMWONOAAWBWGAPZWHAPZSZSZWIWLWOXBWISZWLHW
      KUFZWOXCVSVTWKBPZWLXDUJVSVTWAXAWIUOZVSVTWAXAWIUPXCWPWGBPZWHBPZXEXCVSWPXFW
      QTXCWSXGWBWSWTWIUQZABWGEIKURTXCWTXHWBWSWTWIUSZABWHEIKURTBWJEWGWHIWRUTVCBE
      FHWKIMVAVCXDWEDWKCUBZXCWFXDWEXKHWKDCVDVEXCXKWFXCXKSVSWAWSWTQZWIXKWFXCVSXK
      XFVFXCXLXKXCWAWSWTVSVTWAXAWIVGXIXJVMVFXBWIXKVHXCXKVIABCWGWHWJEDIWRJKVJVKV
      LVNVOVPVQVOVR $.
  $}

  ${
    $d q r A $.  $d q r B $.  $d q r C $.  $d q r K $.  $d q r .<_ $.
    $d q r M $.  $d q r N $.  $d q r P $.  $d q r X $.
    lncvrat.b $e |- B = ( Base ` K ) $.
    lncvrat.l $e |- .<_ = ( le ` K ) $.
    lncvrat.c $e |- C = ( <o ` K ) $.
    lncvrat.a $e |- A = ( Atoms ` K ) $.
    lncvrat.n $e |- N = ( Lines ` K ) $.
    lncvrat.m $e |- M = ( pmap ` K ) $.
    $( A line covers the atoms it contains.  (Contributed by NM,
       30-Apr-2012.) $)
    lncvrat $p |- ( ( ( K e. HL /\ X e. B /\ P e. A )
        /\ ( ( M ` X ) e. N /\ P .<_ X ) ) -> P C X ) $=
      ( vq vr wcel wbr wa chlt w3a cfv cv wne cjn co wceq wrex simprl wb simpl1
      simpl2 isline3 syl2anc mpbid simp1l1 simp1l3 simp2l simp2r simp3l simp1rr
      eqid simp3r breqtrd atcvrj2 syl132anc breqtrrd 3exp rexlimdvv mpd ) EUARZ
      IBRZDARZUBZIGUCHRZDIFSZTZTZPUDZQUDZUEZIVTWAEUFUCZUGZUHZTZQAUIPAUIZDICSZVS
      VPWGVOVPVQUJVSVLVMVPWGUKVLVMVNVRULVLVMVNVRUMABWCEGHIQPJWCVCZMNOUNUOUPVSWF
      WHPQAAVSVTARZWAARZTZWFWHVSWLWFUBZDWDICWMVLVNWJWKWBDWDFSDWDCSVLVMVNVRWLWFU
      QVLVMVNVRWLWFURVSWJWKWFUSVSWJWKWFUTVSWLWBWEVAWMDIWDFVPVQVOWLWFVBVSWLWBWEV
      DZVEACDVTWAWCEFKWILMVFVGWNVHVIVJVK $.
  $}

  ${
    $d p q B $.  $d p q K $.  $d p q .<_ $.  $d p q M $.  $d p q N $.
    $d p q X $.  $d p q Y $.
    lncmp.b $e |- B = ( Base ` K ) $.
    lncmp.l $e |- .<_ = ( le ` K ) $.
    lncmp.n $e |- N = ( Lines ` K ) $.
    lncmp.m $e |- M = ( pmap ` K ) $.
    $( If two lines are comparable, they are equal.  (Contributed by NM,
       30-Apr-2012.) $)
    lncmp $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ ( ( M ` X ) e. N
                  /\ ( M ` Y ) e. N ) ) -> ( X .<_ Y <-> X = Y ) ) $=
      ( vp vq wcel w3a cfv wa wbr wceq syl chlt cv wne cjn co catm wrex simplrl
      simpll1 simpll2 eqid isline3 syl2anc simp3rr simp1l1 simp1l3 simp1rr clat
      wb mpbid simp3ll simp3lr simp3rl atbase simp1l2 hlatlej1 syl3anc breqtrrd
      hllat simp2 lattrd hlatlej2 lneq2at syl332anc eqtr4d 3expia rexlimdvv mpd
      exp3a ex simpl1 simpl2 latref breq2 syl5ibcom impbid ) BUANZFANZGANZOZFDP
      ENZGDPENZQZQZFGCRZFGSZWNWOWPWNWOQZLUBZMUBZUCZFWRWSBUDPZUEZSZQZMBUFPZUGLXE
      UGZWPWQWKXFWJWKWLWOUHWQWGWHWKXFUSWGWHWIWMWOUIWGWHWIWMWOUJXEAXABDEFMLHXAUK
      ZXEUKZJKULUMUTWQXDWPLMXEXEWQWRXENZWSXENZQZXDWPWNWOXKXDQZWPWNWOXLOZFXBGWTX
      CXKWNWOUNZXMWGWIWLXIXJWTWRGCRWSGCRGXBSWGWHWIWMWOXLUOZWGWHWIWMWOXLUPZWKWLW
      JWOXLUQXIXJXDWNWOVAZXIXJXDWNWOVBZWTXCXKWNWOVCXMABCWRFGHIXMWGBURNZXOBVIZTZ
      XMXIWRANXQXEAWRBHXHVDTWGWHWIWMWOXLVEZXPXMWRXBFCXMWGXIXJWRXBCRXOXQXRXEWRWS
      XABCIXGXHVFVGXNVHWNWOXLVJZVKXMABCWSFGHIYAXMXJWSANXRXEAWSBHXHVDTYBXPXMWSXB
      FCXMWGXIXJWSXBCRXOXQXRXEWRWSXABCIXGXHVLVGXNVHYCVKXEAWRWSXABCDEGHIXGXHJKVM
      VNVOVPVSVQVRVTWNFFCRZWPWOWNXSWHYDWNWGXSWGWHWIWMWAXTTWGWHWIWMWBABCFHIWCUMF
      GFCWDWEWF $.
  $}

  ${
    $d p A $.  $d p B $.  $d p F $.  $d p K $.  $d p ./\ $.  $d p N $.
    $d p X $.  $d p Y $.  $d p .0. $.
    2lnat.b $e |- B = ( Base ` K ) $.
    2lnat.m $e |- ./\ = ( meet ` K ) $.
    2lnat.z $e |- .0. = ( 0. ` K ) $.
    2lnat.a $e |- A = ( Atoms ` K ) $.
    2lnat.n $e |- N = ( Lines ` K ) $.
    2lnat.f $e |- F = ( pmap ` K ) $.
    $( Two intersecting lines intersect at an atom.  (Contributed by NM,
       30-Apr-2012.) $)
    2lnat $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ ( ( F ` X ) e. N
                  /\ ( F ` Y ) e. N ) /\ ( X =/= Y /\ ( X ./\ Y ) =/= .0. ) )
                -> ( X ./\ Y ) e. A ) $=
      ( vp wcel cfv wbr syl3anc chlt w3a wa wne co cv wceq wrex cple cal simp11
      hlatl syl clat hllat simp12 simp13 latmcl simp3r atlex simp13l wb simp12l
      simp12r lncmp syl12anc simp111 simp112 simp113 latleeqm1 bitr3d necon3bid
      eqid mpbid wo simp3 latmle1 cpo ccvr hlpos atbase 3ad2ant2 lattrd lncvrat
      wi simp2 syl32anc cvrnbtwn4 syl131anc mpbi2and neor necon1d mpd reximdvai
      sylib 3exp risset sylibr ) DUAQZGBQZHBQZUBZGCRFQZHCRFQZUCZGHUDZGHEUEZIUDZ
      UCZUBZPUFZXGUGZPAUHZXGAQXJXKXGDUIRZSZPAUHZXMXJDUJQZXGBQZXHXPXJWSXQWSWTXAX
      EXIUKZDULUMXJDUNQZWTXAXRXJWSXTXSDUOZUMWSWTXAXEXIUPWSWTXAXEXIUQBDEGHJKURZT
      XBXEXFXHUSPABDXNXGIJXNVMZLMUTTXJXOXLPAXJXKAQZXOXLXJYDXOUBZXGGUDZXLYEXFYFX
      FXHXBXEYDXOVAYEGHXGGYEGHXNSZGHUGZXGGUGZYEXBXCXDYGYHVBXBXEXIYDXOUKXCXDXBXI
      YDXOVCZXCXDXBXIYDXOVDBDXNCFGHJYCNOVEVFYEXTWTXAYGYIVBYEWSXTWSWTXAXEXIYDXOV
      GZYAUMZWSWTXAXEXIYDXOVHZWSWTXAXEXIYDXOVIZBDXNEGHJYCKVJTVKVLVNYEXKXGXGGYEX
      LYIVOZXKXGUDYIWEYEXOXGGXNSZYOXJYDXOVPZYEXTWTXAYPYLYMYNBDXNEGHJYCKVQTZYEDV
      RQZXKBQZWTXRXKGDVSRZSZXOYPUCYOVBYEWSYSYKDVTUMYDXJYTXOABXKDJMWAWBZYMYEXTWT
      XAXRYLYMYNYBTZYEWSWTYDXCXKGXNSUUBYKYMXJYDXOWFYJYEBDXNXKXGGJYCYLUUCUUDYMYQ
      YRWCABUUAXKDXNCFGJYCUUAVMZMNOWDWGBUUADXNXKGXGJYCUUEWHWIWJYIXKXGWKWOWLWMWP
      WNWMPXGAWQWR $.
  $}

  ${
    2atm2at.j $e |- .\/ = ( join ` K ) $.
    2atm2at.m $e |- ./\ = ( meet ` K ) $.
    2atm2at.z $e |- .0. = ( 0. ` K ) $.
    2atm2at.a $e |- A = ( Atoms ` K ) $.
    $( Two joins with a common atom have a nonzero meet.  (Contributed by NM,
       4-Jul-2012.)  (New usage is discouraged.) $)
    2atm2atN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A ) )
                -> ( ( R .\/ P ) ./\ ( R .\/ Q ) ) =/= .0. ) $=
      ( wcel wa co cfv wbr adantr eqid syl3anc chlt w3a cplt wne cple cops hlop
      simpr3 0ltat syl2anc simpl simpr1 hlatlej1 simpr2 cbs wb hllat atbase syl
      clat hlatjcl latlem12 syl13anc mpbi2and cpo wi hlpos op0cl latmcl pltletr
      mp2and opltn0 mpbid ) FUAMZBAMZCAMZDAMZUBZNZHDBEOZDCEOZGOZFUCPZQZWBHUDZVS
      HDWCQZDWBFUEPZQZWDVSFUFMZVQWFVNWIVRFUGRZVNVOVPVQUHZADWCFHKWCSZLUIUJVSDVTW
      GQZDWAWGQZWHVSVNVQVOWMVNVRUKZWKVNVOVPVQULZADBEFWGWGSZILUMTVSVNVQVPWNWOWKV
      NVOVPVQUNZADCEFWGWQILUMTVSFUTMZDFUOPZMZVTWTMZWAWTMZWMWNNWHUPVNWSVRFUQRZVS
      VQXAWKAWTDFWTSZLURUSZVSVNVQVOXBWOWKWPAWTEFDBXEILVATZVSVNVQVPXCWOWKWRAWTEF
      DCXEILVATZWTFWGGDVTWAXEWQJVBVCVDVSFVEMZHWTMZXAWBWTMZWFWHNWDVFVNXIVRFVGRVS
      WIXJWJWTFHXEKVHUSXFVSWSXBXCXKXDXGXHWTFGVTWAXEJVITZWTWCFWGHDWBXEWQWLVJVCVK
      VSWIXKWDWEUPWJXLWTWCFWBHXEWLKVLUJVM $.
  $}

  ${
    2llnma1b.b $e |- B = ( Base ` K ) $.
    2llnma1b.l $e |- .<_ = ( le ` K ) $.
    2llnma1b.j $e |- .\/ = ( join ` K ) $.
    2llnma1b.m $e |- ./\ = ( meet ` K ) $.
    2llnma1b.a $e |- A = ( Atoms ` K ) $.
    $( Generalization of ~ 2llnma1 .  (Contributed by NM, 26-Apr-2013.) $)
    2llnma1b $p |- ( ( K e. HL /\ ( X e. B /\ P e. A /\ Q e. A )
     /\ -. Q .<_ ( P .\/ X ) ) -> ( ( P .\/ X ) ./\ ( P .\/ Q ) ) = P ) $=
      ( wcel w3a co wbr latlej1 syl3anc chlt wn wceq clat hllat 3ad2ant1 simp22
      atbase syl simp21 simp23 wa wb latjcl simp1 hlatjcl latlem12 syl13anc cal
      hlatl wne simp3 nbrne2 syl2anc lattrd cvrat3 3impia syl133anc atcmp mpbid
      mpbi2and eqcomd ) FUAOZIBOZCAOZDAOZPZDCIEQZGRUBZPZCVRCDEQZHQZVTCWBGRZCWBU
      CZVTCVRGRZCWAGRZWCVTFUDOZCBOZVNWEVMVQWGVSFUEUFZVTVOWHVMVNVOVPVSUGZABCFJNU
      HUIZVMVNVOVPVSUJZBEFGCIJKLSTZVTWGWHDBOZWFWIWKVTVPWNVMVNVOVPVSUKZABDFJNUHU
      IZBEFGCDJKLSTVTWGWHVRBOZWABOZWEWFULWCUMWIWKVTWGWHVNWQWIWKWLBEFCIJLUNTZVTV
      MVOVPWRVMVQVSUOZWJWOABEFCDJLNUPTBFGHCVRWAJKMUQURVKVTFUSOZVOWBAOZWCWDUMVMV
      QXAVSFUTUFWJVTVMWQVOVPCDVAZVSCVRDEQZGRZXBWTWSWJWOVTWEVSXCWMVMVQVSVBZCDVRG
      VCVDXFVTBFGCVRXDJKWIWKWSVTWGWQWNXDBOWIWSWPBEFVRDJLUNTWMVTWGWQWNVRXDGRWIWS
      WPBEFGVRDJKLSTVEVMWQVOVPPXCVSXEPXBABCDEFGHVRJKLMNVFVGVHACWBFGKNVITVJVL $.
  $}

  ${
    2llnm.l $e |- .<_ = ( le ` K ) $.
    2llnm.j $e |- .\/ = ( join ` K ) $.
    2llnm.m $e |- ./\ = ( meet ` K ) $.
    2llnm.a $e |- A = ( Atoms ` K ) $.
    $( Two different intersecting lines (expressed in terms of atoms) meet at
       their common point (atom).  (Contributed by NM, 11-Oct-2012.) $)
    2llnma1 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
     /\ -. R .<_ ( P .\/ Q ) ) -> ( ( Q .\/ P ) ./\ ( Q .\/ R ) ) = Q ) $=
      ( chlt wcel w3a co wbr wn cbs wceq simp1 simp21 eqid atbase simp22 simp23
      cfv syl simp3 hlatjcom syl3anc breq2d mtbid 2llnma1b syl131anc ) FMNZBANZ
      CANZDANZOZDBCEPZGQZRZOZUPBFSUGZNZURUSDCBEPZGQZRVGCDEPHPCTUPUTVCUAZVDUQVFU
      PUQURUSVCUBZAVEBFVEUCZLUDUHUPUQURUSVCUEZUPUQURUSVCUFVDVBVHUPUTVCUIVDVAVGD
      GVDUPUQURVAVGTVIVJVLAEFBCJLUJUKULUMAVECDEFGHBVKIJKLUNUO $.

    $( Two different intersecting lines (expressed in terms of atoms) meet at
       their common point (atom).  (Contributed by NM, 30-Apr-2013.) $)
    2llnma3r $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
   /\ ( P .\/ R ) =/= ( Q .\/ R ) )
         -> ( ( P .\/ R ) ./\ ( Q .\/ R ) ) = R ) $=
      ( wcel co wceq syl3anc wa eqtrd wbr wb chlt w3a wne simp1 simp21 hlatjcom
      simp23 simp22 oveq12d simpr oveq2d simpl23 hlatjidm syl2anc hlatlej1 clat
      simpl1 cbs cfv hllat 3ad2ant1 eqid atbase syl hlatjcl latleeqm2 adantr wn
      mpbid simpl21 simpl22 simpl3 wi hlatlej2 latjle12 biimpd mpan2d syl132anc
      syl13anc ps-1 eqcom syl6ib syld necon3ad mpd 2llnma1 syl131anc pm2.61dane
      ) FUAMZBAMZCAMZDAMZUBZBDENZCDENZUCZUBZWNWOHNDBENZDCENZHNZDWQWNWRWOWSHWQWI
      WJWLWNWROWIWMWPUDZWIWJWKWLWPUEZWIWJWKWLWPUGZAEFBDJLUFPWQWIWKWLWOWSOXAWIWJ
      WKWLWPUHZXCAEFCDJLUFPUIWQWTDOZCDWQCDOZQZWTWRDHNZDXGWSDWRHXGWSDDENZDXGCDDE
      WQXFUJUKXGWIWLXIDOWIWMWPXFUQWJWKWLWIWPXFULAEFDJLUMUNRUKWQXHDOZXFWQDWRGSZX
      JWQWIWLWJXKXAXCXBADBEFGIJLUOPWQFUPMZDFURUSZMZWRXMMZXKXJTWIWMXLWPFUTVAZWQW
      LXNXCAXMDFXMVBZLVCVDZWQWIWLWJXOXAXCXBAXMEFDBXQJLVEPXMFGHDWRXQIKVFPVIVGRWQ
      CDUCZQZWIWJWLWKCWNGSZVHZXEWIWMWPXSUQZWJWKWLWIWPXSVJZWJWKWLWIWPXSULZWJWKWL
      WIWPXSVKZXTWPYBWIWMWPXSVLXTYAWNWOXTYAWOWNGSZWNWOOZWQYAYGVMXSWQYADWNGSZYGW
      QWIWJWLYIXAXBXCABDEFGIJLVNPWQYAYIQZYGWQXLCXMMZXNWNXMMZYJYGTXPWQWKYKXDAXMC
      FXQLVCVDXRWQWIWJWLYLXAXBXCAXMEFBDXQJLVEPXMEFGCDWNXQIJVOVSVPVQVGXTYGWOWNOZ
      YHXTYGYMXTWIWKWLXSWJWLYGYMTYCYFYEWQXSUJYDYEACDBDEFGIJLVTVRVPWOWNWAWBWCWDW
      EABDCEFGHIJKLWFWGWHR $.

    $( Two different intersecting lines (expressed in terms of atoms) meet at
       their common point (atom).  (Contributed by NM, 28-May-2012.) $)
    2llnma2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
  -> ( ( R .\/ P ) ./\ ( R .\/ Q ) ) = R ) $=
      ( chlt wcel w3a wne co wbr wn wa simp21 simp23 simp22 4atlem0ae syl131anc
      wceq simp1 2llnma1 ) FMNZBANZCANZDANZOZBCPDBCEQGRSTZOUIUJULUKCBDEQGRSDBEQ
      DCEQHQDUFUIUMUNUGUIUJUKULUNUAUIUJUKULUNUBUIUJUKULUNUCABCDEFGIJLUDABDCEFGH
      IJKLUHUE $.

    $( Two different intersecting lines (expressed in terms of atoms) meet at
       their common point (atom).  (Contributed by NM, 2-May-2013.)
       (New usage is discouraged.) $)
    2llnma2rN $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
  -> ( ( P .\/ R ) ./\ ( Q .\/ R ) ) = R ) $=
      ( chlt wcel w3a wne co wceq hlatjcom syl3anc wbr wn simp21 simp23 oveq12d
      wa simp1 simp22 2llnma2 eqtrd ) FMNZBANZCANZDANZOZBCPDBCEQGUAUBUFZOZBDEQZ
      CDEQZHQDBEQZDCEQZHQDUQURUTUSVAHUQUKULUNURUTRUKUOUPUGZUKULUMUNUPUCUKULUMUN
      UPUDZAEFBDJLSTUQUKUMUNUSVARVBUKULUMUNUPUHVCAEFCDJLSTUEABCDEFGHIJKLUIUJ $.
  $}

$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Construction of a vector space from a Hilbert lattice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  ${
    $d r s A $.  $d r s B $.  $d r s .\/ $.  $d r s K $.  $d r s .<_ $.
    $d r s ./\ $.  $d r s N $.  $d r s P $.  $d r s Q $.  $d r s X $.
    cdlema1.b $e |- B = ( Base ` K ) $.
    cdlema1.l $e |- .<_ = ( le ` K ) $.
    cdlema1.j $e |- .\/ = ( join ` K ) $.
    cdlema1.m $e |- ./\ = ( meet ` K ) $.
    cdlema1.a $e |- A = ( Atoms ` K ) $.
    cdlema1.n $e |- N = ( Lines ` K ) $.
    cdlema1.f $e |- F = ( pmap ` K ) $.
    $( A condition for required for proof of Lemma A in [Crawley] p. 112.
       (Contributed by NM, 29-Apr-2012.)  (New usage is discouraged.) $)
    cdlema1N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ ( P e. A /\ Q e. A
     /\ R e. A ) /\ ( ( R =/= P /\ R .<_ ( P .\/ Q ) )
          /\ ( P .<_ X /\ Q .<_ Y )
         /\ ( ( F ` Y ) e. N /\ ( X ./\ Y ) e. A /\ -. Q .<_ X ) ) )
              -> ( X .\/ R ) = ( X .\/ Y ) ) $=
      ( chlt wcel w3a wne co wbr wa cfv wn clat simp11 syl simp12 simp23 atbase
      hllat latjcl syl3anc simp13 latlej1 simp21 simp22 simp31r simp32l simp32r
      latjlej12 syl122anc mp2and lattrd latjle12 syl13anc mpbi2and wceq simp331
      wi wb simp332 simp333 latmle1 breq1 syl5ibrcom necon3bd latmle2 syl332anc
      mpd lneq2at 3jca simp31l hlatexch1 sylc latjlej1 latmlej11 latmcl eqbrtrd
      jca latasymd ) HUAUBZLBUBZMBUBZUCZCAUBZDAUBZEAUBZUCZECUDZECDGUEZIUFZUGZCL
      IUFZDMIUFZUGZMFUHKUBZLMJUEZAUBZDLIUFZUIZUCZUCZUCZBHILEGUEZLMGUEZNOXSWQHUJ
      UBZWQWRWSXDXRUKZHUPULZXSYBWREBUBZXTBUBZYDWQWRWSXDXRUMZXSXCYEWTXAXBXCXRUNZ
      ABEHNRUOULZBGHLENPUQURZXSYBWRWSYABUBZYDYGWQWRWSXDXRUSZBGHLMNPUQURZXSLYAIU
      FZEYAIUFZXTYAIUFZXSYBWRWSYNYDYGYLBGHILMNOPUTURXSBHIEXFYANOYDYIXSYBCBUBZDB
      UBZXFBUBYDXSXAYQWTXAXBXCXRVAZABCHNRUOULZXSXBYRWTXAXBXCXRVBZABDHNRUOULZBGH
      CDNPUQURYMXEXGXKXQWTXDVCZXSXIXJXFYAIUFZXIXJXHXQWTXDVDZXIXJXHXQWTXDVEZXSYB
      YQWRYRWSXKUUDVOYDYTYGUUBYLBGHIMCLDNOPVFVGVHVIXSYBWRYEYKYNYOUGYPVPYDYGYIYM
      BGHILEYANOPVJVKVLXSLXTIUFZMXTIUFZYAXTIUFZXSYBWRYEUUGYDYGYIBGHILENOPUTURXS
      MDXMGUEZXTIXSWQWSXLXBXNDXMUDZXJXMMIUFZMUUJVMYCYLXLXNXPXHXKWTXDVNUUAXLXNXP
      XHXKWTXDVQXSXPUUKXLXNXPXHXKWTXDVRXSXODXMXSXODXMVMXMLIUFZXSYBWRWSUUMYDYGYL
      BHIJLMNOQVSURDXMLIVTWAWBWEUUFXSYBWRWSUULYDYGYLBHIJLMNOQWCURABDXMGHIFKMNOP
      RSTWFWDXSDXTIUFZXMXTIUFZUUJXTIUFZXSBHIDCEGUEZXTNOYDUUBXSYBYQYEUUQBUBYDYTY
      IBGHCENPUQURYJXSWQXCXBXAUCZXEUCXGDUUQIUFXSWQUURXEYCXSXCXBXAYHUUAYSWGXEXGX
      KXQWTXDWHWGUUCAEDCGHIOPRWIWJXSYBYQWRYEUCZUGXIUUQXTIUFXSYBUUSYDXSYQWRYEYTY
      GYIWGWOUUEBGHICLENOPWKWJVIXSYBWRWSYEUUOYDYGYLYIBGHIJLMENOPQWLVKXSYBYRXMBU
      BZYFUUNUUOUGUUPVPYDUUBXSYBWRWSUUTYDYGYLBHJLMNQWMURYJBGHIDXMXTNOPVJVKVLWNX
      SYBWRWSYFUUGUUHUGUUIVPYDYGYLYJBGHILMXTNOPVJVKVLWP $.
  $}

  ${
    cdlema2.b $e |- B = ( Base ` K ) $.
    cdlema2.l $e |- .<_ = ( le ` K ) $.
    cdlema2.j $e |- .\/ = ( join ` K ) $.
    cdlema2.m $e |- ./\ = ( meet ` K ) $.
    cdlema2.z $e |- .0. = ( 0. ` K ) $.
    cdlema2.a $e |- A = ( Atoms ` K ) $.
    $( A condition for required for proof of Lemma A in [Crawley] p. 112.
       (Contributed by NM, 9-May-2012.)  (New usage is discouraged.) $)
    cdlema2N $p |- ( ( ( K e. HL /\ X e. B ) /\ ( P e. A /\ Q e. A
 /\ R e. A ) /\ ( ( R =/= P /\ R .<_ ( P .\/ Q ) )
     /\ ( P .<_ X /\ -. Q .<_ X ) ) ) -> ( R ./\ X ) = .0. ) $=
      ( wcel wa wbr chlt w3a co wn wceq simp3ll wb simp3rl simp3rr simp3lr 3jca
      wne exatleN syld3an3 necon3bbid mpbird cal simp1l hlatl syl simp23 simp1r
      atnle syl3anc mpbid ) GUARZJBRZSZCARZDARZEARZUBZECULZECDFUCHTZSZCJHTZDJHT
      UDZSZSZUBZEJHTZUDZEJIUCKUEZVTWBVMVMVNVRVHVLUFVTWAECVHVLVSVPVQVNUBWAECUEUG
      VTVPVQVNVPVQVOVHVLUHVPVQVOVHVLUIVMVNVRVHVLUJUKABCDEFGHJLMNQUMUNUOUPVTGUQR
      ZVKVGWBWCUGVTVFWDVFVGVLVSURGUSUTVHVIVJVKVSVAVFVGVLVSVBABEGHIJKLMOPQVCVDVE
      $.
  $}

  ${
    cdlemb.b $e |- B = ( Base ` K ) $.
    cdlemb.l $e |- .<_ = ( le ` K ) $.
    cdlemb.j $e |- .\/ = ( join ` K ) $.
    cdlemb.u $e |- .1. = ( 1. ` K ) $.
    cdlemb.c $e |- C = ( <o ` K ) $.
    cdlemb.a $e |- A = ( Atoms ` K ) $.
    ${
      cdlemblem.s $e |- .< = ( lt ` K ) $.
      cdlemblem.m $e |- ./\ = ( meet ` K ) $.
      cdlemblem.v $e |- V = ( ( P .\/ Q ) ./\ X ) $.
      $( Lemma for ~ cdlemb .  (Contributed by NM, 8-May-2012.) $)
      cdlemblem $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A )
           /\ ( X e. B /\ P =/= Q ) /\ ( X C .1.
             /\ -. P .<_ X /\ -. Q .<_ X ) )
        /\ ( u e. A /\ ( u =/= V /\ u .< X ) )
        /\ ( r e. A /\ ( r =/= P /\ r =/= u /\ r .<_ ( P .\/ u ) ) ) )
      -> ( -. r .<_ X /\ -. r .<_ ( P .\/ Q ) ) ) $=
        ( chlt wcel w3a wne wa wbr wn cv co simp132 simp111 simp2l simp12l 3jca
        simp2rr pltle sylc clat wb hllat simp3l atbase latjle12 syl13anc biimpd
        syl mpan2d simp112 simp3r2 simp3r3 hlatexch2 latjcl syl3anc lattr mpand
        wi syld mtod simp2rl wceq simp113 simp3r1 syl131anc hlatexch1 syl5ibcom
        hlatexchb1 breq2 sylbid jctird latlem12 breq2i syl6bbr sylibd cal hlatl
        simp12r simp131 1cvrat syl133anc syl5eqel atcmp necon3ad mpd jca ) JUEU
        FZEBUFZFBUFZUGZNCUFZEFUHZUIZNHDUJZENKUJZUKZFNKUJUKZUGZUGZAULZBUFZYBMUHZ
        YBNGUJZUIZUIZOULZBUFZYHEUHZYHYBUHZYHEYBIUMKUJZUGZUIZUGZYHNKUJZUKYHEFIUM
        ZKUJZUKZYOYPXQXPXRXSXLXOYGYNUNZYOYPYHYBIUMZNKUJZXQYOYPYBNKUJZUUBYOXIYCX
        MUGYEUUCYOXIYCXMXIXJXKXOXTYGYNUOZYAYCYFYNUPZXMXNXLXTYGYNUQZURYDYEYCYAYN
        USUEBCGJKYBNQUBUTVAZYOYPUUCUIZUUBYOJVBUFZYHCUFZYBCUFZXMUUHUUBVCYOXIUUIU
        UDJVDVJZYOYIUUJYAYGYIYMVEZBCYHJPUAVFVJZYOYCUUKUUEBCYBJPUAVFVJZUUFCIJKYH
        YBNPQRVGVHVIVKYOEUUAKUJZUUBXQYOXIYIXJYCUGZYKUGYLUUPYOXIUUQYKUUDYOYIXJYC
        UUMXIXJXKXOXTYGYNVLZUUEURYJYKYLYIYAYGVMURYJYKYLYIYAYGVNZBYHEYBIJKQRUAVO
        VAYOUUIECUFZUUACUFZXMUUPUUBUIXQVTUULYOXJUUTUURBCEJPUAVFVJZYOUUIUUJUUKUV
        AUULUUNUUOCIJYHYBPRVPVQUUFCJKEUUANPQVRVHVSWAWBYOYDYSYDYEYCYAYNWCYOYRYBM
        YOYRYBMKUJZYBMWDZYOYRYBYQKUJZUUCUIZUVCYOYRUVEUUCYOYREYHIUMZYQWDZUVEYOXI
        YIXKXJYJYRUVHVCUUDUUMXIXJXKXOXTYGYNWEZUURYJYKYLYIYAYGWFZBYHFEIJKQRUAWJW
        GYOYBUVGKUJZUVHUVEYOXIYIYCXJUGZYJUGYLUVKYOXIUVLYJUUDYOYIYCXJUUMUUEUURUR
        UVJURUUSBYHYBEIJKQRUAWHVAUVGYQYBKWKWIWLUUGWMYOUVFYBYQNLUMZKUJZUVCYOUUIU
        UKYQCUFZXMUVFUVNVCUULUUOYOUUIUUTFCUFZUVOUULUVBYOXKUVPUVIBCFJPUAVFVJCIJE
        FPRVPVQUUFCJKLYBYQNPQUCWNVHMUVMYBKUDWOWPWQYOJWRUFZYCMBUFUVCUVDVCYOXIUVQ
        UUDJWSVJUUEYOMUVMBUDYOXIXJXKXMXNXPXRUVMBUFUUDUURUVIUUFXMXNXLXTYGYNWTXPX
        RXSXLXOYGYNXAYTBCDEFHIJKLNPQRUCSTUAXBXCXDBYBMJKQUAXEVQWQXFXGXH $.
    $}

    $d r u A $.  $d r u B $.  $d r u C $.  $d r u .\/ $.  $d r u K $.
    $d r u .<_ $.  $d r u P $.  $d r u Q $.  $d r u .1. $.  $d r u X $.
    $( Given two atoms not less than or equal to an element covered by 1, there
       is a third.  Lemma B in [Crawley] p. 112.  (Contributed by NM,
       8-May-2012.) $)
    cdlemb $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( X e. B /\ P =/= Q )
          /\ ( X C .1. /\ -. P .<_ X /\ -. Q .<_ X ) )
      -> E. r e. A ( -. r .<_ X /\ -. r .<_ ( P .\/ Q ) ) ) $=
      ( wcel wa wbr vu chlt w3a wne wn cv co cmee cfv cplt simp11 simp12 simp13
      wrex simp2l simp2r simp31 simp32 eqid 1cvrat syl133anc clat atbase latjcl
      hllat syl syl3anc latmle2 1cvratlt syl32anc 2atlt syl31anc simpl11 simprl
      simpl12 simpl32 wceq simprrr wi simpl2l pltle mpd breq1 syl5ibrcom hlsupr
      necon3bd cdlemblem 3exp exp4a imp reximdvai rexlimddv ) HUBRZDARZEARZUCZJ
      BRZDEUDZSZJFCTZDJITZUEZEJITUEZUCZUCZUAUFZDEGUGZJHUHUIZUGZUDZXFJHUJUIZTZSZ
      KUFZJITUEXNXGITUESZKAUNZUAAXEWMXIARZWQXIJXKTZXMUAAUNWMWNWOWSXDUKZXEWMWNWO
      WQWRWTXBXQXSWMWNWOWSXDULZWMWNWOWSXDUMZWPWQWRXDUOZWPWQWRXDUPWPWSWTXBXCUQZW
      PWSWTXBXCURABCDEFGHIXHJLMNXHUSZOPQUTVAZYBXEWMXQWQWTXIJITZXRXSYEYBYCXEHVBR
      ZXGBRZWQYFXEWMYGXSHVEVFZXEYGDBRZEBRZYHYIXEWNYJXTABDHLQVCVFXEWOYKYAABEHLQV
      CVFBGHDELNVDVGYBBHIXHXGJLMYDVHVGABCXIXKFHIJLMXKUSZOPQVIVJABXIXKHJUALYLQVK
      VLXEXFARZXMSZSZXNDUDXNXFUDXNDXFGUGITUCZKAUNZXPYOWMWNYMDXFUDZYQWMWNWOWSXDY
      NVMZWMWNWOWSXDYNVOXEYMXMVNZYOXBYRWTXBXCWPWSYNVPYOXADXFYOXADXFVQXFJITZYOXL
      UUAXEYMXJXLVRYOWMYMWQXLUUAVSYSYTWQWRWPXDYNVTUBABXKHIXFJMYLWAVGWBDXFJIWCWD
      WFWBADXFGHIKMNQWEVLYOYPXOKAXEYNXNARZYPXOVSVSXEYNUUBYPXOXEYNUUBYPSXOUAABCD
      EXKFGHIXHXIJKLMNOPQYLYDXIUSWGWHWIWJWKWBWL $.
  $}

  $c +P $.

  $( Extend class notation with projective subspace sum. $)
  cpadd $a class +P $.

  ${
    $d l m n p q r $.
    $( Define projective sum of two subspaces (or more generally two sets of
       atoms), which is the union of all lines generated by pairs of atoms from
       each subspace.  Lemma 16.2 of [MaedaMaeda] p. 68.  For convenience, our
       definition is generalized to apply to empty sets.  (Contributed by NM,
       29-Dec-2011.) $)
    df-padd $a |- +P = ( l e. _V
        |-> ( m e. ~P ( Atoms ` l ) , n e. ~P ( Atoms ` l )
           |-> ( ( m u. n ) u. { p e. ( Atoms ` l )
             | E. q e. m E. r e. n p ( le ` l ) ( q ( join ` l ) r ) } ) ) ) $.
  $}

  ${
    $d h m n p s A $.  $d h .\/ $.  $d h m n p q r s K $.  $d h .<_ $.
    paddfval.l $e |- .<_ = ( le ` K ) $.
    paddfval.j $e |- .\/ = ( join ` K ) $.
    paddfval.a $e |- A = ( Atoms ` K ) $.
    paddfval.p $e |- .+ = ( +P ` K ) $.
    $( Projective subspace sum operation.  (Contributed by NM, 29-Dec-2011.) $)
    paddfval $p |- ( K e. B -> .+ = ( m e. ~P A , n e. ~P A
             |-> ( ( m u. n ) u. { p e. A
               | E. q e. m E. r e. n p .<_ ( q .\/ r ) } ) ) ) $=
      ( vh cv wrex cfv catm wcel cvv cpw cun wbr crab cmpt2 wceq elex cpadd cjn
      co cple fveq2 syl6eqr pweqd eqidd breq123d 2rexbidv rabeqbidv mpt2eq123dv
      oveqd uneq2d df-padd fvex eqeltri pwex mpt2ex fvmpt syl5eq syl ) GBUAGUBU
      AZCDEAUCZVMDQZEQZUDZKQZJQZIQZFULZHUEZIVORJVNRZKAUFZUDZUGZUHGBUIVLCGUJSWEO
      PGDEPQZTSZUCZWHVPVQVRVSWFUKSZULZWFUMSZUEZIVORJVNRZKWGUFZUDZUGWEUBUJWFGUHZ
      DEWHWHWOVMVMWDWPWGAWPWGGTSZAWFGTUNNUOZUPZWSWPWNWCVPWPWMWBKWGAWRWPWLWAJIVN
      VOWPVQVQWJVTWKHWPVQUQWPWKGUMSHWFGUMUNLUOWPWIFVRVSWPWIGUKSFWFGUKUNMUOVBURU
      SUTVCVADEIJKPVDDEVMVMWDAAWQUBNGTVEVFVGZWTVHVIVJVK $.

    $d m n s .\/ $.  $d m n s .<_ $.  $d m n p q s X $.  $d m n p q r s Y $.
    $( Projective subspace sum operation value.  (Contributed by NM,
       29-Dec-2011.) $)
    paddval $p |- ( ( K e. B /\ X C_ A /\ Y C_ A )
   -> ( X .+ Y ) = ( ( X u. Y )
         u. { p e. A | E. q e. X E. r e. Y p .<_ ( q .\/ r ) } ) ) $=
      ( wcel cun cv wrex cvv vm vn wss cpw wbr crab wceq biid catm fvex eqeltri
      co cfv elpw2 w3a cmpt2 paddfval oveqd 3ad2ant1 wa simpl simpr unexg rabex
      sylancl 3jca 3adant1 uneq1 rexeq rabbidv uneq12d rexbidv eqid ovmpt2g syl
      uneq2 eqtrd syl3anbr ) EBPZVSGAUCGAUDZPZHAUCHVTPZGHCULZGHQZKRJRIRDULFUEZI
      HSZJGSZKAUFZQZUGVSUHGAAEUIUMTNEUIUJUKZUNHAWJUNVSWAWBUOZWCGHUAUBVTVTUARZUB
      RZQZWEIWMSZJWLSZKAUFZQZUPZULZWIVSWAWCWTUGWBVSCWSGHABCUAUBDEFIJKLMNOUQURUS
      WKWAWBWITPZUOZWTWIUGWAWBXBVSWAWBUTZWAWBXAWAWBVAWAWBVBXCWDTPWHTPXAGHVTVTVC
      WGKAWJVDWDWHTTVCVEVFVGUAUBGHVTVTWRWIWSGWMQZWOJGSZKAUFZQTWLGUGZWNXDWQXFWLG
      WMVHXGWPXEKAWOJWLGVIVJVKWMHUGZXDWDXFWHWMHGVPXHXEWGKAXHWOWFJGWEIWMHVIVLVJV
      KWSVMVNVOVQVR $.

    $d p .\/ $.  $d p .<_ $.  $d p q r S $.
    $( Member of a projective subspace sum.  (Contributed by NM,
       29-Dec-2011.) $)
    elpadd $p |- ( ( K e. B /\ X C_ A /\ Y C_ A ) -> ( S e. ( X .+ Y ) <->
        ( ( S e. X \/ S e. Y ) \/ ( S e. A
             /\ E. q e. X E. r e. Y S .<_ ( q .\/ r ) ) ) ) ) $=
      ( vp wcel cv wrex wo wss w3a co cun wbr crab wa paddval eleq2d elun breq1
      wceq 2rexbidv elrab orbi12i bitri syl6bb ) FBQHAUAIAUAUBZDHICUCZQDHIUDZPR
      ZKRJREUCZGUEZJISKHSZPAUFZUDZQZDHQDIQTZDAQDVBGUEZJISKHSZUGZTZURUSVFDABCEFG
      HIJKPLMNOUHUIVGDUTQZDVEQZTVLDUTVEUJVMVHVNVKDHIUJVDVJPDAVADULVCVIKJHIVADVB
      GUKUMUNUOUPUQ $.

    $d q r A $.  $d q r .\/ $.  $d q r .<_ $.  $d s .+ $.  $d r X $.
    $( Member of projective subspace sum of non-empty sets.  (Contributed by
       NM, 3-Jan-2012.) $)
    elpaddn0 $p |- ( ( ( K e. Lat /\ X C_ A /\ Y C_ A )
               /\ ( X =/= (/) /\ Y =/= (/) ) ) -> ( S e. ( X .+ Y ) <->
         ( S e. A /\ E. q e. X E. r e. Y S .<_ ( q .\/ r ) ) ) ) $=
      ( wcel wa co wbr wi syl clat wss w3a c0 wne wo cv wb elpadd adantr simpl2
      wrex sseld cbs simpll1 ssel2 3ad2antl2 eqid atbase simpl3 latlej1 syl3anc
      cfv sselda reximdva0 exp31 com23 imp ancld wceq oveq1 breq2d rexbidv syl6
      rspcev adantrl jcad wex latlej2 ex impancom eximdv df-rex 3imtr4g adantrr
      oveq2 n0 jaod pm4.72 sylib bitr4d ) EUAOZGAUBZHAUBZUCZGUDUEZHUDUEZPZPZCGH
      BQOZCGOZCHOZUFZCAOZCJUGZIUGZDQZFRZIHULZJGULZPZUFZXKWOWTXLUHWRAUABCDEFGHIJ
      KLMNUIUJWSXCXKSXKXLUHWSXAXKXBWSXAXDXJWSGACWLWMWNWRUKUMWOWQXAXJSWPWOWQPZXA
      XACCXFDQZFRZIHULZPXJXMXAXPWOWQXAXPSWOXAWQXPWOXAWQXPWOXAPZXOIHXQXFHOZPZWLC
      EUNVCZOZXFXTOZXOWLWMWNXAXRUOXSXDYAXQXDXRWMWLXAXDWNGACUPUQUJAXTCEXTURZMUSZ
      TXSXFAOYBXQHAXFWLWMWNXAUTVDAXTXFEYCMUSTXTDEFCXFYCKLVAVBVEVFVGVHVIXIXPJCGX
      ECVJZXHXOIHYEXGXNCFXECXFDVKVLVMVOVNVPVQWSXBXDXJWSHACWLWMWNWRUTUMWOWPXBXJS
      WQWOXBWPXJWOXBPZXEGOZJVRYGXIPZJVRWPXJYFYGYHJYFYGXIWOYGXBXIWOYGPZXBXBCXECD
      QZFRZPXIYIXBYKYIXBYKYIXBPZWLXEXTOZYAYKWLWMWNYGXBUOYLXEAOZYMYIYNXBWMWLYGYN
      WNGAXEUPUQUJAXTXEEYCMUSTYLXDYAYIHACWLWMWNYGUTVDYDTXTDEFXECYCKLVSVBVTVIXHY
      KICHXFCVJXGYJCFXFCXEDWFVLVOVNWAVIWBJGWGXIJGWCWDWAWEVQWHXCXKWIWJWK $.

    $( Projective subspace sum operation value for non-empty sets.
       (Contributed by NM, 27-Jan-2012.)  (New usage is discouraged.) $)
    paddvaln0N $p |- ( ( ( K e. Lat /\ X C_ A /\ Y C_ A )
                /\ ( X =/= (/) /\ Y =/= (/) ) )
     -> ( X .+ Y ) = { p e. A | E. q e. X E. r e. Y p .<_ ( q .\/ r ) } ) $=
      ( vs wcel wss wa cv wrex clat w3a c0 wne wbr crab elpaddn0 breq1 2rexbidv
      co weq elrab syl6bbr eqrdv ) DUAPFAQGAQUBFUCUDGUCUDRRZOFGBUJZJSZISHSCUJZE
      UEZHGTIFTZJAUFZUOOSZUPPVBAPVBUREUEZHGTIFTZRVBVAPABVBCDEFGHIKLMNUGUTVDJVBA
      JOUKUSVCIHFGUQVBUREUHUIULUMUN $.

    $d q r Q $.  $d r R $.
    $( Condition implying membership in a projective subspace sum.
       (Contributed by NM, 8-Jan-2012.) $)
    elpaddri $p |- ( ( ( K e. Lat /\ X C_ A /\ Y C_ A ) /\
       ( Q e. X /\ R e. Y ) /\ ( S e. A /\ S .<_ ( Q .\/ R ) ) ) ->
           S e. ( X .+ Y ) ) $=
      ( vq vr wcel wa co wbr clat wss w3a wrex simp3l simp2l simp2r simp3r wceq
      cv oveq1 breq2d oveq2 rspc2ev syl3anc c0 wne ne0i anim12i anim2i elpaddn0
      wb 3adant3 syl mpbir2and ) GUAQIAUBJAUBUCZCIQZDJQZRZEAQZECDFSZHTZRZUCZEIJ
      BSQZVJEOUJZPUJZFSZHTZPJUDOIUDZVFVIVJVLUEVNVGVHVLVTVFVGVHVMUFVFVGVHVMUGVFV
      IVJVLUHVSVLECVQFSZHTOPCDIJVPCUIVRWAEHVPCVQFUKULVQDUIWAVKEHVQDCFUMULUNUOVN
      VFIUPUQZJUPUQZRZRZVOVJVTRVBVFVIWEVMVIWDVFVGWBVHWCICURJDURUSUTVCABEFGHIJPO
      KLMNVAVDVE $.

    $( Condition implying membership in a projective subspace sum with a
       point.  (Contributed by NM, 1-Feb-2012.)  (New usage is discouraged.) $)
    elpaddatriN $p |- ( ( ( K e. Lat /\ X C_ A /\ Q e. A ) /\
       ( R e. X /\ S e. A /\ S .<_ ( R .\/ Q ) ) ) ->
           S e. ( X .+ { Q } ) ) $=
      ( clat wcel wss w3a co wbr wa csn simpl1 simpl2 simpl3 snssd simpr1 snidg
      syl simpr2 simpr3 elpaddri syl322anc ) GNOZIAPZCAOZQZDIOZEAOZEDCFRHSZQZTZ
      UMUNCUAZAPUQCVBOZURUSEIVBBROUMUNUOUTUBUMUNUOUTUCVACAUMUNUOUTUDZUEUPUQURUS
      UFVAUOVCVDCAUGUHUPUQURUSUIUPUQURUSUJABDCEFGHIVBJKLMUKUL $.

    $d p Q $.
    $( Membership in a projective subspace sum with a point.  (Contributed by
       NM, 29-Jan-2012.) $)
    elpaddat $p |- ( ( ( K e. Lat /\ X C_ A /\ Q e. A ) /\ X =/= (/) )
  -> ( S e. ( X .+ { Q } )
        <-> ( S e. A /\ E. p e. X S .<_ ( p .\/ Q ) ) ) ) $=
      ( vr wcel wss c0 wa co wrex w3a wne csn cv wbr simpl1 simpl2 simpl3 snssd
      clat wb simpr snnzg syl elpaddn0 syl32anc wceq oveq2 breq2d rexsng anbi2d
      rexbidv bitrd ) FUJOZHAPZCAOZUAZHQUBZRZDHCUCZBSOZDAOZDIUDZNUDZESZGUEZNVJT
      ZIHTZRZVLDVMCESZGUEZIHTZRVIVDVEVJAPVHVJQUBZVKVSUKVDVEVFVHUFVDVEVFVHUGVICA
      VDVEVFVHUHZUIVGVHULVIVFWCWDCAUMUNABDEFGHVJNIJKLMUOUPVIVRWBVLVIVQWAIHVIVFV
      QWAUKWDVPWANCAVNCUQVOVTDGVNCVMEURUSUTUNVBVAVC $.

    $d p R $.
    $( Consequence of membership in a projective subspace sum with a point.
       (Contributed by NM, 2-Feb-2012.)  (New usage is discouraged.) $)
    elpaddatiN $p |- ( ( ( K e. Lat /\ X C_ A /\ Q e. A ) /\ ( X =/= (/)
      /\ R e. ( X .+ { Q } ) ) ) -> E. p e. X R .<_ ( p .\/ Q ) ) $=
      ( clat wcel wss w3a c0 co wa wne csn wbr wrex elpaddat simpr syl6bi impr
      cv ) FNOHAPCAOQZHRUAZDHCUBBSOZDIUICESGUCIHUDZUJUKTULDAOZUMTUMABCDEFGHIJKL
      MUEUNUMUFUGUH $.

    $( Membership in a projective subspace sum of two points.  (Contributed by
       NM, 29-Jan-2012.) $)
    elpadd2at $p |- ( ( K e. Lat /\ Q e. A /\ R e. A )
   -> ( S e. ( { Q } .+ { R } ) <-> ( S e. A /\ S .<_ ( Q .\/ R ) ) ) ) $=
      ( vr wcel csn co wbr wa wb 3ad2ant2 clat w3a cv wrex c0 simp1 simp2 snssd
      wss simp3 snnzg elpaddat syl31anc wceq oveq1 breq2d rexsng anbi2d bitrd
      wne ) GUANZCANZDANZUBZECOZDOBPNZEANZEMUCZDFPZHQZMVEUDZRZVGECDFPZHQZRVDVAV
      EAUIVCVEUEUTZVFVLSVAVBVCUFVDCAVAVBVCUGUHVAVBVCUJVBVAVOVCCAUKTABDEFGHVEMIJ
      KLULUMVDVKVNVGVBVAVKVNSVCVJVNMCAVHCUNVIVMEHVHCDFUOUPUQTURUS $.

    $( Membership in a projective subspace sum of two points.  (Contributed by
       NM, 8-Mar-2012.) $)
    elpadd2at2 $p |- ( ( K e. Lat /\ ( Q e. A /\ R e. A /\ S e. A ) )
   -> ( S e. ( { Q } .+ { R } ) <-> S .<_ ( Q .\/ R ) ) ) $=
      ( clat wcel w3a wa csn co wbr wb elpadd2at 3adant3r3 simpr3 biantrurd
      bitr4d ) GMNZCANZDANZEANZOPZECQDQBRNZUIECDFRHSZPZULUFUGUHUKUMTUIABCDEFGHI
      JKLUAUBUJUIULUFUGUHUIUCUDUE $.
  $}

  ${
    $d p q r A $.  $d q B $.  $d p q r K $.  $d q .+ $.  $d q r S $.
    $d p q r X $.  $d p q r Y $.
    padd0.a $e |- A = ( Atoms ` K ) $.
    padd0.p $e |- .+ = ( +P ` K ) $.
    $( Projective subspace sum includes the set union of its arguments.
       (Contributed by NM, 12-Jan-2012.)  (New usage is discouraged.) $)
    paddunssN $p |- ( ( K e. B /\ X C_ A /\ Y C_ A )
          -> ( X u. Y ) C_ ( X .+ Y ) ) $=
      ( vp vq vr wcel wss w3a cun cv cfv co wrex eqid cjn cple wbr crab paddval
      ssun1 syl5sseqr ) DBLEAMFAMNEFOZIPJPKPDUAQZRDUBQZUCKFSJESIAUDZOUHEFCRUHUK
      UFABCUIDUJEFKJIUJTUITGHUEUG $.

    $( Member of projective subspace sum with at least one empty set.
       (Contributed by NM, 29-Dec-2011.) $)
    elpadd0 $p |- ( ( ( K e. B /\ X C_ A /\ Y C_ A )
               /\ -. ( X =/= (/) /\ Y =/= (/) ) ) -> ( S e. ( X .+ Y ) <->
         ( S e. X \/ S e. Y ) ) ) $=
      ( vq vr c0 wne wa wn wcel wss wceq wo wrex w3a neanior bicomi con1bii cjn
      co wb cv cfv cple wbr eqid elpadd rex0 rexeq mtbiri a1i nrex rexbidv jaoi
      intnand biorf syl orcom syl6rbb sylan9bb sylan2b ) FLMGLMNZOEBPFAQGAQUAZF
      LRZGLRZSZDFGCUFPZDFPDGPSZUGVLVHVHVLOFLGLUBUCUDVIVMVNDAPZDJUHZKUHEUEUIZUFE
      UJUIZUKZKGTZJFTZNZSZVLVNABCDVQEVRFGKJVRULVQULHIUMVLVNWBVNSZWCVLWBOVNWDUGV
      LWAVOVJWAOVKVJWAVTJLTVTJUNVTJFLUOUPVKWAVSKLTZJFTWEJFWEOVPFPVSKUNUQURVKVTW
      EJFVSKGLUOUSUPUTVAWBVNVBVCWBVNVDVEVFVG $.

    $( Projective subspace sum with at least one empty set.  (Contributed by
       NM, 11-Jan-2012.) $)
    paddval0 $p |- ( ( ( K e. B /\ X C_ A /\ Y C_ A )
           /\ -. ( X =/= (/) /\ Y =/= (/) ) ) -> ( X .+ Y ) = ( X u. Y ) ) $=
      ( vq wcel wss w3a c0 wne wa wn co cun cv wo elpadd0 elun syl6bbr eqrdv )
      DBJEAKFAKLEMNFMNOPOZIEFCQZEFRZUEISZUFJUHEJUHFJTUHUGJABCUHDEFGHUAUHEFUBUCU
      D $.

    $( Projective subspace sum with an empty set.  (Contributed by NM,
       11-Jan-2012.) $)
    padd01 $p |- ( ( K e. B /\ X C_ A ) -> ( X .+ (/) ) = X ) $=
      ( wcel wss wa c0 co cun w3a wne wn wceq simpl simpr 0ss 3jca neirr intnan
      a1i paddval0 sylancl un0 syl6eq ) DBHZEAIZJZEKCLZEKMZEUKUIUJKAIZNEKOZKKOZ
      JPULUMQUKUIUJUNUIUJRUIUJSUNUKATUDUAUPUOKUBUCABCDEKFGUEUFEUGUH $.

    $( Projective subspace sum with an empty set.  (Contributed by NM,
       11-Jan-2012.) $)
    padd02 $p |- ( ( K e. B /\ X C_ A ) -> ( (/) .+ X ) = X ) $=
      ( wcel wss wa c0 co cun w3a wne wn wceq simpl 0ss a1i simpr neirr intnanr
      3jca paddval0 sylancl uncom un0 eqtri syl6eq ) DBHZEAIZJZKECLZKEMZEUMUKKA
      IZULNKKOZEKOZJPUNUOQUMUKUPULUKULRUPUMASTUKULUAUDUQURKUBUCABCDKEFGUEUFUOEK
      MEKEUGEUHUIUJ $.

    $( Projective subspace sum commutes.  (Contributed by NM, 3-Jan-2012.) $)
    paddcom $p |- ( ( K e. Lat /\ X C_ A /\ Y C_ A )
          -> ( X .+ Y ) = ( Y .+ X ) ) $=
      ( vp vq vr clat wcel wss cun cv cfv co wrex wceq eqid w3a cple crab uncom
      cjn wbr a1i wa cbs simpl1 simpl2 simprl sseldd atbase syl latjcom syl3anc
      simpl3 simprr breq2d rexcom syl6bb rabbidv uneq12d paddval 3com23 3eqtr4d
      2rexbidva ) CKLZDAMZEAMZUAZDENZHOZIOZJOZCUEPZQZCUBPZUFZJERIDRZHAUCZNEDNZV
      NVPVOVQQZVSUFZIDRJERZHAUCZNZDEBQEDBQZVLVMWCWBWGVMWCSVLDEUDUGVLWAWFHAVLWAW
      EJERIDRWFVLVTWEIJDEVLVODLZVPELZUHZUHZVRWDVNVSWMVIVOCUIPZLZVPWNLZVRWDSVIVJ
      VKWLUJWMVOALWOWMDAVOVIVJVKWLUKVLWJWKULUMAWNVOCWNTZFUNUOWMVPALWPWMEAVPVIVJ
      VKWLURVLWJWKUSUMAWNVPCWQFUNUOWNVQCVOVPWQVQTZUPUQUTVHWEIJDEVAVBVCVDAKBVQCV
      SDEJIHVSTZWRFGVEVIVKVJWIWHSAKBVQCVSEDIJHWSWRFGVEVFVG $.

    $( A projective subspace sum is a set of atoms.  (Contributed by NM,
       3-Jan-2012.) $)
    paddssat $p |- ( ( K e. B /\ X C_ A /\ Y C_ A ) -> ( X .+ Y ) C_ A ) $=
      ( vp vq vr wss co cun cv cfv wrex eqid wa unss wcel w3a cjn cple wbr crab
      paddval biimpi ssrab2 jctir sylib 3adant1 eqsstrd ) DBUAZEALZFALZUBEFCMEF
      NZIOJOKODUCPZMDUDPZUEKFQJEQZIAUFZNZAABCURDUSEFKJIUSRURRGHUGUOUPVBALZUNUOU
      PSZUQALZVAALZSVCVDVEVFVDVEEFATUHUTIAUIUJUQVAATUKULUM $.

    $( A projective subspace sum is a superset of its first summand.  ( ~ ssun1
       analog.)  (Contributed by NM, 3-Jan-2012.) $)
    sspadd1 $p |- ( ( K e. B /\ X C_ A /\ Y C_ A ) -> X C_ ( X .+ Y ) ) $=
      ( vp vq vr wcel wss cun cv cfv co wrex ssun1 eqid w3a cjn cple crab sstri
      wbr paddval syl5sseqr ) DBLEAMFAMUAEFNZIOJOKODUBPZQDUCPZUFKFRJERIAUDZNZEE
      FCQEUIUMEFSUIULSUEABCUJDUKEFKJIUKTUJTGHUGUH $.

    $( A projective subspace sum is a superset of its second summand.
       ( ~ ssun2 analog.)  (Contributed by NM, 3-Jan-2012.) $)
    sspadd2 $p |- ( ( K e. B /\ X C_ A /\ Y C_ A ) -> X C_ ( Y .+ X ) ) $=
      ( vp vq vr wcel wss w3a cun cv cfv co wrex eqid cjn cple crab ssun2 ssun1
      wbr sstri wceq paddval 3com23 syl5sseqr ) DBLZEAMZFAMZNFEOZIPJPKPDUAQZRDU
      BQZUFKESJFSIAUCZOZEFECRZEUOUSEFUDUOURUEUGULUNUMUTUSUHABCUPDUQFEKJIUQTUPTG
      HUIUJUK $.

    $d p B $.  $d p .+ $.  $d p q r Z $.
    $( Subset law for projective subspace sum.  ( ~ unss1 analog.)
       (Contributed by NM, 7-Mar-2012.) $)
    paddss1 $p |- ( ( K e. B /\ Y C_ A /\ Z C_ A )
              -> ( X C_ Y -> ( X .+ Z ) C_ ( Y .+ Z ) ) ) $=
      ( vp vq vr wcel wss co wa cv wo cfv wrex w3a cjn wbr orim1d ssrexv anim2d
      cple wi ssel orim12d adantl wb simpl1 sstr 3ad2antr2 ancoms simpl3 elpadd
      eqid syl3anc adantr 3imtr4d ssrdv ex ) DBMZFANZGANZUAZEFNZEGCOZFGCOZNVHVI
      PZJVJVKVLJQZEMZVMGMZRZVMAMZVMKQLQDUBSZODUGSZUCLGTZKETZPZRZVMFMZVORZVQVTKF
      TZPZRZVMVJMZVMVKMZVIWCWHUHVHVIVPWEWBWGVIVNWDVOEFVMUIUDVIWAWFVQVTKEFUEUFUJ
      UKVLVEEANZVGWIWCULVEVFVGVIUMVIVHWKVIVEVFWKVGEFAUNUOUPVEVFVGVIUQABCVMVRDVS
      EGLKVSUSZVRUSZHIURUTVHWJWHULVIABCVMVRDVSFGLKWLWMHIURVAVBVCVD $.

    $( Subset law for projective subspace sum.  ( ~ unss2 analog.)
       (Contributed by NM, 7-Mar-2012.) $)
    paddss2 $p |- ( ( K e. B /\ Y C_ A /\ Z C_ A )
              -> ( X C_ Y -> ( Z .+ X ) C_ ( Z .+ Y ) ) ) $=
      ( vp vq vr wcel wss co wa cv wo cfv wrex w3a cjn cple wbr wi ssel reximdv
      orim2d ssrexv anim2d orim12d adantl simpl1 simpl3 3ad2antr2 ancoms elpadd
      wb sstr eqid syl3anc simpl2 3imtr4d ssrdv ex ) DBMZFANZGANZUAZEFNZGECOZGF
      COZNVIVJPZJVKVLVMJQZGMZVNEMZRZVNAMZVNKQLQDUBSZODUCSZUDZLETZKGTZPZRZVOVNFM
      ZRZVRWALFTZKGTZPZRZVNVKMZVNVLMZVJWEWKUEVIVJVQWGWDWJVJVPWFVOEFVNUFUHVJWCWI
      VRVJWBWHKGWALEFUIUGUJUKULVMVFVHEANZWLWEURVFVGVHVJUMZVFVGVHVJUNZVJVIWNVJVF
      VGWNVHEFAUSUOUPABCVNVSDVTGELKVTUTZVSUTZHIUQVAVMVFVHVGWMWKURWOWPVFVGVHVJVB
      ABCVNVSDVTGFLKWQWRHIUQVAVCVDVE $.

    $( Subset law for projective subspace sum.  ( ~ unss12 analog.)
       (Contributed by NM, 7-Mar-2012.) $)
    paddss12 $p |- ( ( K e. B /\ Y C_ A /\ W C_ A )
              -> ( ( X C_ Y /\ Z C_ W ) -> ( X .+ Z ) C_ ( Y .+ W ) ) ) $=
      ( wcel wss w3a wa co simpl1 simpl2 sstr ancoms ad2ant2l 3jca paddss1 sylc
      3adantl1 simprl wi paddss2 3com23 imp adantrl sstrd ex ) DBKZGALZEALZMZFG
      LZHELZNZFHCOZGECOZLUPUSNZUTGHCOZVAVBUMUNHALZMUQUTVCLVBUMUNVDUMUNUOUSPUMUN
      UOUSQUNUOUSVDUMUOURVDUNUQURUOVDHEARSTUDUAUPUQURUEABCDFGHIJUBUCUPURVCVALZU
      QUPURVEUMUOUNURVEUFABCDHEGIJUGUHUIUJUKUL $.
  $}

  ${
    paddasslem.l $e |- .<_ = ( le ` K ) $.
    paddasslem.j $e |- .\/ = ( join ` K ) $.
    paddasslem.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for ~ paddass .  (Contributed by NM, 8-Jan-2012.) $)
    paddasslem1 $p |- ( ( ( K e. HL /\ ( x e. A /\ r e. A /\ y e. A )
        /\ x =/= y ) /\ -. r .<_ ( x .\/ y ) ) -> -. x .<_ ( r .\/ y ) ) $=
      ( chlt wcel cv w3a wne co wbr hlatexch2 con3and ) EKLAMZCLGMZCLBMZCLNTUBO
      NTUAUBDPFQUATUBDPFQCTUAUBDEFHIJRS $.

    $( Lemma for ~ paddass .  (Contributed by NM, 8-Jan-2012.) $)
    paddasslem2 $p |- ( ( ( K e. HL /\ r e. A )
   /\ ( x e. A /\ y e. A /\ z e. A )
   /\ ( -. r .<_ ( x .\/ y ) /\ r .<_ ( y .\/ z ) ) )
 -> z .<_ ( r .\/ y ) ) $=
      ( wcel cv wa w3a co wbr 3jca syl atbase chlt wn wne simp1l simp1r atnlej2
      simp23 simp22 simp21 simp3l syl131anc simp3r hlatexch1 sylc clat cbs wceq
      cfv hllat eqid latjcom syl3anc breqtrrd ) FUALZHMZDLZNZAMZDLZBMZDLZCMZDLZ
      OZVEVHVJEPGQUBZVEVJVLEPGQZNZOZVLVJVEEPZVEVJEPZGVRVDVFVMVKOZVEVJUCZOVPVLVS
      GQVRVDWAWBVDVFVNVQUDZVRVFVMVKVDVFVNVQUEZVGVIVKVMVQUGVGVIVKVMVQUHZRVRVDVFV
      IVKVOWBWCWDVGVIVKVMVQUIWEVGVNVOVPUJDVEVHVJEFGIJKUFUKRVGVNVOVPULDVEVLVJEFG
      IJKUMUNVRFUOLZVEFUPURZLZVJWGLZVTVSUQVRVDWFWCFUSSVRVFWHWDDWGVEFWGUTZKTSVRV
      KWIWEDWGVJFWJKTSWGEFVEVJWJJVAVBVC $.

    ${
      $d s A $.  $d s .\/ $.  $d s K $.  $d s .<_ $.  $d s p $.  $d s r $.
      $d s x $.  $d s y $.  $d s z $.
      $( Lemma for ~ paddass .  Restate projective space axiom ~ ps-2 .
         (Contributed by NM, 8-Jan-2012.) $)
      paddasslem3 $p |- ( ( K e. HL /\ ( x e. A /\ r e. A /\ y e. A )
             /\ ( p e. A /\ z e. A ) ) -> (
     ( ( -. x .<_ ( r .\/ y ) /\ p =/= z )
          /\ ( p .<_ ( x .\/ r ) /\ z .<_ ( r .\/ y ) ) )
   -> E. s e. A ( s .<_ ( x .\/ y ) /\ s .<_ ( p .\/ z ) ) ) ) $=
        ( chlt wcel cv w3a wa co wbr wn wne wrex ps-2 ex ) FNOAPZDOIPZDOBPZDOQJ
        PZDOCPZDORQUFUGUHESZGTUAUIUJUBRUIUFUGESGTUJUKGTRRHPZUFUHESGTULUIUJESGTR
        HDUCHDUFUGUHUIUJEFGKLMUDUE $.

      $( Lemma for ~ paddass .  Combine ~ paddasslem1 , ~ paddasslem2 , and
         ~ paddasslem3 .  (Contributed by NM, 8-Jan-2012.) $)
      paddasslem4 $p |- ( ( ( ( K e. HL /\ p e. A /\ r e. A )
             /\ ( x e. A /\ y e. A /\ z e. A )
             /\ ( p =/= z /\ x =/= y /\ -. r .<_ ( x .\/ y ) ) )
         /\ ( p .<_ ( x .\/ r ) /\ r .<_ ( y .\/ z ) ) )
              -> E. s e. A ( s .<_ ( x .\/ y ) /\ s .<_ ( p .\/ z ) ) ) $=
        ( wcel cv w3a wne co wbr wa chlt wn simpl11 simpl21 simpl13 simpl22 jca
        wrex simpl12 simpl23 simpl32 simpl33 paddasslem1 syl31anc simprl simpl2
        3jca simpl31 simprr paddasslem2 syl212anc jca31 paddasslem3 sylc ) FUAN
        ZJOZDNZIOZDNZPZAOZDNZBOZDNZCOZDNZPZVFVOQZVKVMQZVHVKVMERZGSUBZPZPZVFVKVH
        ERGSZVHVMVOERGSZTZTZVEVLVIVNPZVGVPTZPVKVHVMERZGSUBZVRTWDVOWJGSZTZTHOZVT
        GSWNVFVOERGSTHDUHWGVEWHWIVEVGVIVQWBWFUCZWGVLVIVNVLVNVPVJWBWFUDVEVGVIVQW
        BWFUEZVLVNVPVJWBWFUFUQZWGVGVPVEVGVIVQWBWFUIVLVNVPVJWBWFUJUGUQWGWKVRWMWG
        VEWHVSWAWKWOWQVRVSWAVJVQWFUKVRVSWAVJVQWFULZABDEFGIKLMUMUNVRVSWAVJVQWFUR
        WGWDWLWCWDWEUOWGVEVIVQWAWEWLWOWPVJVQWBWFUPWRWCWDWEUSABCDEFGIKLMUTVAUGVB
        ABCDEFGHIJKLMVCVD $.
    $}

    $( Lemma for ~ paddass .  Show ` s =/= z ` by contradiction.  (Contributed
       by NM, 8-Jan-2012.) $)
    paddasslem5 $p |- ( ( ( K e. HL /\ r e. A /\
    ( x e. A /\ y e. A /\ z e. A ) )
  /\ ( -. r .<_ ( x .\/ y ) /\ r .<_ ( y .\/ z ) /\ s .<_ ( x .\/ y ) ) )
           -> s =/= z ) $=
      ( wcel cv w3a wbr wa syl atbase ad2antrr chlt co wn wne weq breq1 biimpac
      wi cbs cfv eqid simpll1 hllat simpll2 simp32 simp33 latjcl syl3anc simp31
      clat simplr hlatlej2 simpr latjle12 biimpd syl13anc mp2and lattrd ex syl5
      expdimp necon3bd exp31 com23 com24 3imp2 ) FUAMZINZDMZANZDMZBNZDMZCNZDMZO
      ZOZVRVTWBEUBZGPZUCZVRWBWDEUBZGPZHNZWHGPZWMWDUDZWGWNWLWJWOWGWLWNWJWOUHZWGW
      LWNWPWGWLQZWNQWIWMWDWQWNHCUEZWIWNWRQWDWHGPZWQWIWRWNWSWMWDWHGUFUGWQWSWIWQW
      SQZFUIUJZFGVRWKWHXAUKZJWTVQFUTMZVQVSWFWLWSULZFUMRZWTVSVRXAMVQVSWFWLWSUNDX
      AVRFXBLSRWTXCWBXAMZWDXAMZWKXAMXEWTWCXFWGWCWLWSVQVSWAWCWEUOTZDXAWBFXBLSRZW
      TWEXGWGWEWLWSVQVSWAWCWEUPTDXAWDFXBLSRZXAEFWBWDXBKUQURWTXCVTXAMZXFWHXAMZXE
      WTWAXKWGWAWLWSVQVSWAWCWEUSTZDXAVTFXBLSRXIXAEFVTWBXBKUQURZWGWLWSVAWTWBWHGP
      ZWSWKWHGPZWTVQWAWCXOXDXMXHDVTWBEFGJKLVBURWQWSVCWTXCXFXGXLXOWSQZXPUHXEXIXJ
      XNXCXFXGXLOQXQXPXAEFGWBWDWHXBJKVDVEVFVGVHVIVJVKVLVMVNVOVP $.

    $( Lemma for ~ paddass .  (Contributed by NM, 8-Jan-2012.) $)
    paddasslem6 $p |- ( ( ( K e. HL /\ ( p e. A /\ s e. A ) /\
   z e. A ) /\ ( s =/= z /\ s .<_ ( p .\/ z ) ) ) -> p .<_ ( s .\/ z ) ) $=
      ( chlt wcel cv wa w3a wne co wbr simpl1 3jca simpl2r simpl3 simprl simprr
      simpl2l hlatexch2 sylc ) DKLZGMZBLZFMZBLZNZAMZBLZOZUKUNPZUKUIUNCQERZNZNZU
      HULUJUOOZUQOURUIUKUNCQERUTUHVAUQUHUMUOUSSUTULUJUOUJULUHUOUSUAUJULUHUOUSUE
      UHUMUOUSUBTUPUQURUCTUPUQURUDBUKUIUNCDEHIJUFUG $.

    $( Lemma for ~ paddass .  Combine ~ paddasslem5 and ~ paddasslem6 .
       (Contributed by NM, 9-Jan-2012.) $)
    paddasslem7 $p |- ( ( ( K e. HL /\ ( p e. A /\ r e. A /\ s e. A ) /\
     ( x e. A /\ y e. A /\ z e. A ) )
  /\ ( ( -. r .<_ ( x .\/ y ) /\ r .<_ ( y .\/ z ) /\ s .<_ ( x .\/ y ) )
           /\ s .<_ ( p .\/ z ) ) ) -> p .<_ ( s .\/ z ) ) $=
      ( chlt wcel cv w3a co wbr wa wn wne simpl1 simpl21 simpl23 simpl33 simpl3
      jca simpl22 simprl paddasslem5 syl31anc simprr paddasslem6 syl32anc ) FNO
      ZJPZDOZIPZDOZHPZDOZQZAPZDOZBPZDOZCPZDOZQZQZUSVDVFERZGSUAUSVFVHERGSVAVLGSQ
      ZVAUQVHERGSZTZTZUPURVBTVIVAVHUBZVNUQVAVHERGSUPVCVJVOUCZVPURVBURUTVBUPVJVO
      UDURUTVBUPVJVOUEUHVEVGVIUPVCVOUFVPUPUTVJVMVQVRURUTVBUPVJVOUIUPVCVJVOUGVKV
      MVNUJABCDEFGHIKLMUKULVKVMVNUMCDEFGHJKLMUNUO $.

    paddasslem.p $e |- .+ = ( +P ` K ) $.
    $( Lemma for ~ paddass .  (Contributed by NM, 8-Jan-2012.) $)
    paddasslem8 $p |- ( ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A )
  /\ ( p e. A /\ s e. A ) )
    /\ ( ( x e. X /\ y e. Y /\ z e. Z )
         /\ s .<_ ( x .\/ y ) /\ p .<_ ( s .\/ z ) ) )
  -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( wcel wss cv chlt w3a wa co wbr clat simpl1 syl simpl21 simpl22 paddssat
      syl3anc simpl23 simpr11 simpr12 simpl3r simpr2 elpaddri syl322anc simpr13
      hllat simpl3l simpr3 ) GUARZIDSZJDSZKDSZUBZMTZDRZLTZDRZUCZUBZATZIRZBTZJRZ
      CTZKRZUBZVKVOVQFUDHUEZVIVKVSFUDHUEZUBZUCZGUFRZIJEUDZDSZVGVKWGRZVTVJWCVIWG
      KEUDRWEVDWFVDVHVMWDUGZGVAUHZWEVDVEVFWHWJVEVFVGVDVMWDUIZVEVFVGVDVMWDUJZDUA
      EGIJPQUKULVEVFVGVDVMWDUMWEWFVEVFVPVRVLWBWIWKWLWMVPVRVTWBWCVNUNVPVRVTWBWCV
      NUOVJVLVDVHWDUPVNWAWBWCUQDEVOVQVKFGHIJNOPQURUSVPVRVTWBWCVNUTVJVLVDVHWDVBV
      NWAWBWCVCDEVKVSVIFGHWGKNOPQURUS $.

    $( Lemma for ~ paddass .  Combine ~ paddasslem7 and ~ paddasslem8 .
       (Contributed by NM, 9-Jan-2012.) $)
    paddasslem9 $p |- ( ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A )
                           /\ ( p e. A /\ r e. A ) )
    /\ ( ( x e. X /\ y e. Y /\ z e. Z )
           /\ ( -. r .<_ ( x .\/ y ) /\ r .<_ ( y .\/ z ) )
    /\ ( s e. A /\ s .<_ ( x .\/ y ) /\ s .<_ ( p .\/ z ) ) ) )
           -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( wcel w3a chlt wss cv wa co wbr simpl1 simpl2 simpl3l simpr31 jca simpr1
      wn simpr32 simpl3r 3jca ssel2 3anim123i sylbi 3ad2antl2 3ad2antr1 simpr2l
      an6 simpr2r simpr33 paddasslem7 syl32anc paddasslem8 syl33anc ) GUASZIDUB
      ZJDUBZKDUBZTZNUCZDSZMUCZDSZUDZTZAUCZISZBUCZJSZCUCZKSZTZVQWAWCFUEZHUFUMZVQ
      WCWEFUEHUFZUDZLUCZDSZWLWHHUFZWLVOWEFUEHUFZTZTZUDZVJVNVPWMUDWGWNVOWLWEFUEH
      UFZVOIJEUEKEUESVJVNVSWQUGZVJVNVSWQUHWRVPWMVPVRVJVNWQUIZWMWNWOWGWKVTUJZUKV
      TWGWKWPULWMWNWOWGWKVTUNZWRVJVPVRWMTWADSZWCDSZWEDSZTZWIWJWNTWOWSWTWRVPVRWM
      XAVPVRVJVNWQUOXBUPVTWKWGXGWPVNVJWGXGVSVNWGUDVKWBUDZVLWDUDZVMWFUDZTXGVKVLV
      MWBWDWFVCXHXDXIXEXJXFIDWAUQJDWCUQKDWEUQURUSUTVAWRWIWJWNWIWJWGWPVTVBWIWJWG
      WPVTVDXCUPWMWNWOWGWKVTVEABCDFGHLMNOPQVFVGABCDEFGHIJKLNOPQRVHVI $.

    $d s A $.  $d s .\/ $.  $d s K $.  $d s .<_ $.  $d s .+ $.  $d s X $.
    $d s Y $.  $d s Z $.  $d s p $.  $d s r $.  $d s x $.  $d s y $.  $d s z $.
    $( Lemma for ~ paddass .  Use ~ paddasslem4 to eliminate ` s ` from
       ~ paddasslem9 .  (Contributed by NM, 9-Jan-2012.) $)
    paddasslem10 $p |- ( ( ( ( K e. HL /\ p =/= z /\ x =/= y )
     /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) /\ ( p e. A /\ r e. A ) )
 /\ ( ( x e. X /\ y e. Y /\ z e. Z )
     /\ ( -. r .<_ ( x .\/ y ) /\ p .<_ ( x .\/ r )
        /\ r .<_ ( y .\/ z ) ) ) )
  -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( wcel w3a wa vs chlt cv wne wss co wbr wrex simpl11 simpl3l simpl3r 3jca
      an6 ssel2 3anim123i sylbi adantrr simpl12 simpl13 simprr1 simprr2 simprr3
      wn 3ad2antl2 paddasslem4 syl32anc simpl2 simpl3 adantr simplrl jca simprl
      simprrl simprrr paddasslem9 syl13anc rexlimddv ) GUBRZMUCZCUCZUDZAUCZBUCZ
      UDZSZIDUEZJDUEZKDUEZSZVSDRZLUCZDRZTZSZWBIRZWCJRZVTKRZSZWKWBWCFUFZHUGVCZVS
      WBWKFUFHUGZWKWCVTFUFHUGZSZTZTZUAUCZWSHUGZXFVSVTFUFHUGZTZVSIJEUFKEUFRZUADX
      EVRWJWLSWBDRZWCDRZVTDRZSZWAWDWTSXAXBXIUADUHXEVRWJWLVRWAWDWIWMXDUIZWJWLWEW
      IXDUJWJWLWEWIXDUKULWNWRXNXCWIWEWRXNWMWIWRTWFWOTZWGWPTZWHWQTZSXNWFWGWHWOWP
      WQUMXPXKXQXLXRXMIDWBUNJDWCUNKDVTUNUOUPVDUQXEWAWDWTVRWAWDWIWMXDURVRWAWDWIW
      MXDUSWTXAXBWRWNUTZULWTXAXBWRWNVAWTXAXBWRWNVBZABCDFGHUALMNOPVEVFXEXFDRZXIT
      ZTZVRWIWMSZWRWTXBTZYAXGXHSXJXEYDYBXEVRWIWMXOWEWIWMXDVGWEWIWMXDVHULVIWNWRX
      CYBVJXEYEYBXEWTXBXSXTVKVIYCYAXGXHXEYAXIVLXEYAXGXHVMXEYAXGXHVNULABCDEFGHIJ
      KUALMNOPQVOVPVQ $.

    $( Lemma for ~ paddass .  The case when ` p = z ` .  (Contributed by NM,
       11-Jan-2012.) $)
    paddasslem11 $p |- ( ( ( ( K e. HL /\ p = z )
           /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) ) /\ z e. Z )
           -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( chlt wcel wa wss cv co weq w3a simplll simplr3 simplr1 simplr2 paddssat
      syl3anc sspadd2 simpllr simpr eqeltrd sseldd ) EOPZJAUAZQZGBRZHBRZIBRZUBZ
      QZASZIPZQZIGHCTZICTZJSZVDUNUSVEBRZIVFRUNUOUTVCUCZUQURUSUPVCUDVDUNUQURVHVI
      UQURUSUPVCUEUQURUSUPVCUFBOCEGHMNUGUHBOCEIVEMNUIUHVDVGVBIUNUOUTVCUJVAVCUKU
      LUM $.

    $( Lemma for ~ paddass .  The case when ` x = y ` .  (Contributed by NM,
       11-Jan-2012.) $)
    paddasslem12 $p |- ( ( ( ( K e. HL /\ x = y )
       /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) /\ ( p e. A /\ r e. A ) )
   /\ ( ( y e. Y /\ z e. Z ) /\ ( p .<_ ( x .\/ r )
          /\ r .<_ ( y .\/ z ) ) ) )
       -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( wcel wa wss chlt weq w3a cv co simpl1l simpl21 simpl22 paddssat syl3anc
      wbr simpl23 3jca sspadd2 paddss1 sylc syl simprll simprlr simpl3l cbs cfv
      clat hllat eqid atbase sseldd simpl3r latjcl simpl1r simprrl oveq1 breq2d
      biimpa syl2anc latlej1 simprrr latjle12 syl13anc mpbi2and lattrd elpaddri
      wb syl322anc ) GUARZABUBZSZIDTZJDTZKDTZUCZMUDZDRZLUDZDRZSZUCZBUDZJRZCUDZK
      RZSZWLAUDZWNFUEZHUKZWNWRWTFUEZHUKZSZSZSZJKEUEZIJEUEZKEUEZWLXJWEXLDTZWJUCJ
      XLTZXKXMTXJWEXNWJWEWFWKWPXIUFZXJWEWHWIXNXPWHWIWJWGWPXIUGZWHWIWJWGWPXIUHZD
      UAEGIJPQUIUJWHWIWJWGWPXIULZUMXJWEWIWHXOXPXRXQDUAEGJIPQUNUJDUAEGJXLKPQUOUP
      XJGVCRZWIWJWSXAWMWLXFHUKWLXKRXJWEXTXPGVDUQZXRXSWQWSXAXHURZWQWSXAXHUSZWMWO
      WGWKXIUTZXJGVAVBZGHWLWRWNFUEZXFYEVEZNYAXJWMWLYERYDDYEWLGYGPVFUQXJXTWRYERZ
      WNYERZYFYERYAXJWRDRYHXJJDWRXRYBVGDYEWRGYGPVFUQZXJWOYIWMWOWGWKXIVHDYEWNGYG
      PVFUQZYEFGWRWNYGOVIUJXJXTYHWTYERZXFYERZYAYJXJWTDRYLXJKDWTXSYCVGDYEWTGYGPV
      FUQZYEFGWRWTYGOVIUJZXJWFXEWLYFHUKZWEWFWKWPXIVJWQXBXEXGVKWFXEYPWFXDYFWLHXC
      WRWNFVLVMVNVOXJWRXFHUKZXGYFXFHUKZXJXTYHYLYQYAYJYNYEFGHWRWTYGNOVPUJWQXBXEX
      GVQXJXTYHYIYMYQXGSYRWCYAYJYKYOYEFGHWRWNXFYGNOVRVSVTWADEWRWTWLFGHJKNOPQWBW
      DVG $.

    $( Lemma for ~ paddass .  The case when ` r .<_ ( x .\/ y ) ` .  (Unlike
       the proof in Maeda and Maeda, we don't need ` x =/= y ` .)  (Contributed
       by NM, 11-Jan-2012.) $)
    paddasslem13 $p |- ( ( ( ( K e. HL /\ p =/= z )
       /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) /\ ( p e. A /\ r e. A ) )
   /\ ( ( x e. X /\ y e. Y ) /\ ( r .<_ ( x .\/ y )
           /\ p .<_ ( x .\/ r ) ) ) )
       -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( wcel cv wa chlt wne wss w3a co simpl1l simpl21 simpl22 paddssat syl3anc
      wbr simpl23 sspadd1 clat hllat syl simprll simprlr simpl3l cbs cfv atbase
      eqid sseldd simpl3r simprrr latlej1 simprrl wb latjle12 syl13anc mpbi2and
      latjcl lattrd elpaddri syl322anc ) GUARZMSZCSUBZTZIDUCZJDUCZKDUCZUDZVRDRZ
      LSZDRZTZUDZASZIRZBSZJRZTZWFWJWLFUEZHUKZVRWJWFFUEZHUKZTZTZTZIJEUEZXBKEUEZV
      RXAVQXBDUCZWCXBXCUCVQVSWDWHWTUFZXAVQWAWBXDXEWAWBWCVTWHWTUGZWAWBWCVTWHWTUH
      ZDUAEGIJPQUIUJWAWBWCVTWHWTULDUAEGXBKPQUMUJXAGUNRZWAWBWKWMWEVRWOHUKVRXBRXA
      VQXHXEGUOUPZXFXGWIWKWMWSUQZWIWKWMWSURZWEWGVTWDWTUSZXAGUTVAZGHVRWQWOXMVCZN
      XIXAWEVRXMRXLDXMVRGXNPVBUPXAXHWJXMRZWFXMRZWQXMRXIXAWJDRXOXAIDWJXFXJVDDXMW
      JGXNPVBUPZXAWGXPWEWGVTWDWTVEDXMWFGXNPVBUPZXMFGWJWFXNOVMUJXAXHXOWLXMRZWOXM
      RZXIXQXAWLDRXSXAJDWLXGXKVDDXMWLGXNPVBUPZXMFGWJWLXNOVMUJZWIWNWPWRVFXAWJWOH
      UKZWPWQWOHUKZXAXHXOXSYCXIXQYAXMFGHWJWLXNNOVGUJWIWNWPWRVHXAXHXOXPXTYCWPTYD
      VIXIXQXRYBXMFGHWJWFWOXNNOVJVKVLVNDEWJWLVRFGHIJNOPQVOVPVD $.

    $( Lemma for ~ paddass .  Remove ` p =/= z ` , ` x =/= y ` , and
       ` -. r .<_ ( x .\/ y ) ` from antecedent of ~ paddasslem10 , using
       ~ paddasslem11 , ~ paddasslem12 , and ~ paddasslem13 .  (Contributed by
       NM, 11-Jan-2012.) $)
    paddasslem14 $p |- ( ( ( K e. HL
           /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) /\ ( p e. A /\ r e. A ) )
    /\ ( ( x e. X /\ y e. Y /\ z e. Z )
       /\ ( p .<_ ( x .\/ r ) /\ r .<_ ( y .\/ z ) ) ) )
  -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( wcel w3a wa chlt wss cv co wbr wi weq paddasslem11 3ad2antr3 ex adantrd
      a1d exp31 3simpb 3anim1i 3simpc anim1i paddasslem12 syl2an 3expia anim12i
      wne 3exp1 3simpa paddasslem13 3expd wn paddasslem10 pm2.61d imp3a expimpd
      expr 3exp pm2.61dne 3imp1 ) GUARZIDUBJDUBKDUBSZMUCZDRLUCZDRTZAUCZIRZBUCZJ
      RZCUCZKRZSZVRWAVSFUDHUEZVSWCWEFUDHUEZTZTZVRIJEUDKEUDRZVPVQVTWKWLUFZUFZUFZ
      VRWEVPMCUGZVQWNVPWPTVQTZWMVTWQWGWLWJWQWGWLWQWBWFWLWDCDEFGHIJKMNOPQUHUIUJU
      KULUMVPVRWEVBZWOVPWRTZWOWAWCVPWRABUGZWOVPWRWTSZVQVTWKWLXAVQVTSVPWTTZVQVTS
      WDWFTZWJTWLWKXAXBVQVTVPWRWTUNUOWGXCWJWBWDWFUPUQABCDEFGHIJKLMNOPQURUSVCUTV
      PWRWAWCVBZWOVPWRXDSZVQVTWMXEVQVTSZWGWJWLXFWGTZWHWIWLXGVSWAWCFUDHUEZWHWIWL
      UFUFXGXHWHWIWLXFWGXHWHWISZWLXFWSVQVTSWBWDTZXHWHTZTWLWGXITXEWSVQVTVPWRXDVD
      UOWGXJXIXKWBWDWFVDXHWHWIVDVAABCDEFGHIJKLMNOPQVEUSVLVFXGXHVGZWHWIWLXFWGXLW
      HWISWLABCDEFGHIJKLMNOPQVHVLVFVIVJVKVMUTVNUJVNVO $.

    $d y z A $.  $d y z .\/ $.  $d y z K $.  $d y z .<_ $.  $d y z .+ $.
    $d y z X $.  $d y z Y $.  $d y z Z $.  $d y z p $.  $d y z r $.
    $d y z x $.
    $( Lemma for ~ paddass .  Use ~ elpaddn0 to eliminate ` y ` and ` z ` from
       ~ paddasslem14 .  (Contributed by NM, 11-Jan-2012.) $)
    paddasslem15 $p |- ( ( ( K e. HL
           /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) /\ ( Y =/= (/) /\ Z =/= (/) ) )
      /\ ( p e. A /\ ( x e. X /\ r e. ( Y .+ Z ) ) /\ p .<_ ( x .\/ r ) ) )
           -> p e. ( ( X .+ Y ) .+ Z ) ) $=
      ( vy vz wcel w3a wa chlt wss c0 wne cv co wbr wrex simpr2r clat wb simpl1
      hllat syl simpl22 simpl23 simpl3 elpaddn0 syl31anc mpbid wi simp11 simp12
      simp21 simp31 jca simp22l simp32l simp32r 3jca simp23 simp33 paddasslem14
      syl32anc 3expia 3expd imp rexlimdvv expimpd mpd ) EUARZGBUBZHBUBZIBUBZSZH
      UCUDIUCUDTZSZKUEZBRZAUEZGRZJUEZHICUFRZTZWHWJWLDUFFUGZSZTZWLBRZWLPUEZQUEZD
      UFFUGZQIUHPHUHZTZWHGHCUFICUFRZWQWMXCWKWMWIWOWGUIWQEUJRZWCWDWFWMXCUKWQWAXE
      WAWEWFWPULEUMUNWBWCWDWAWFWPUOWBWCWDWAWFWPUPWAWEWFWPUQBCWLDEFHIQPLMNOURUSU
      TWQWRXBXDWQWRTXAXDPQHIWQWRWSHRZWTIRZTZXAXDVAVAWQWRXHXAXDWGWPWRXHXASZXDWGW
      PXISZWAWEWIWRTWKXFXGSWOXATXDWAWEWFWPXIVBWAWEWFWPXIVCXJWIWRWGWIWNWOXIVDWGW
      PWRXHXAVEVFXJWKXFXGWKWMWIWOWGXIVGXFXGWRXAWGWPVHXFXGWRXAWGWPVIVJXJWOXAWGWI
      WNWOXIVKWGWPWRXHXAVLVFAPQBCDEFGHIJKLMNOVMVNVOVPVQVRVSVT $.

    $d p r x A $.  $d r x .\/ $.  $d p r x K $.  $d r x .<_ $.  $d p r x .+ $.
    $d p r x X $.  $d p r x Y $.  $d p r x Z $.  $d r x p $.
    $( Lemma for ~ paddass .  Use ~ elpaddn0 to eliminate ` x ` and ` r ` from
       ~ paddasslem15 .  (Contributed by NM, 11-Jan-2012.) $)
    paddasslem16 $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A )
     /\ ( ( X =/= (/) /\ ( Y .+ Z ) =/= (/) )
         /\ ( Y =/= (/) /\ Z =/= (/) ) ) )
       -> ( X .+ ( Y .+ Z ) ) C_ ( ( X .+ Y ) .+ Z ) ) $=
      ( vx vr wcel wss c0 wne co wa vp chlt w3a cv wbr wrex clat hllat 3ad2ant1
      wb simp21 simp1 simp22 simp23 paddssat syl3anc elpaddn0 syl31anc wi simpr
      simp3l paddasslem15 syl3anl3 3exp2 imp rexlimdvv expimpd sylbid ssrdv ) D
      UBOZFAPZGAPZHAPZUCZFQRGHBSZQRTZGQRHQRTZTZUCZUAFVOBSZFGBSHBSZVSUAUDZVTOZWB
      AOZWBMUDZNUDZCSEUEZNVOUFMFUFZTZWBWAOZVSDUGOZVKVOAPZVPWCWIUJVJVNWKVRDUHUIV
      JVKVLVMVRUKVSVJVLVMWLVJVNVRULVJVKVLVMVRUMVJVKVLVMVRUNAUBBDGHKLUOUPVJVNVPV
      QVAABWBCDEFVONMIJKLUQURVSWDWHWJVSWDTWGWJMNFVOVSWDWEFOWFVOOTZWGWJUSUSVSWDW
      MWGWJVRVJVNVQWDWMWGUCWJVPVQUTMABCDEFGHNUAIJKLVBVCVDVEVFVGVHVI $.
  $}

  ${
    $d p q r A $.  $d p q r K $.  $d p q r .+ $.  $d p q r X $.  $d p q r Y $.
    $d p q r Z $.
    paddass.a $e |- A = ( Atoms ` K ) $.
    paddass.p $e |- .+ = ( +P ` K ) $.
    $( Lemma for ~ paddass .  The case when at least one sum argument is
       empty.  (Contributed by NM, 12-Jan-2012.) $)
    paddasslem17 $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A )
  /\ -. ( ( X =/= (/) /\ ( Y .+ Z ) =/= (/) )
           /\ ( Y =/= (/) /\ Z =/= (/) ) ) )
       -> ( X .+ ( Y .+ Z ) ) C_ ( ( X .+ Y ) .+ Z ) ) $=
      ( chlt wss c0 wne co wa wn wceq wo nne oveq1d syl5ibrcom wcel w3a orbi12i
      ianor bitri 3adant3r1 padd02 syldan 3ad2antr2 eqtr4d oveq1 eqeq12d eqimss
      paddssat syl6 padd01 3ad2antr1 sspadd1 simpl simpr3 syl3anc sstrd eqsstrd
      3adant3r3 oveq2 sseq1d jaod 3ad2antr3 oveq2d syl5bi 3impia ) CIUAZDAJZEAJ
      ZFAJZUBZDKLZEFBMZKLZNZEKLZFKLZNZNOZDVRBMZDEBMZFBMZJZWDDKPZVRKPZQZEKPZFKPZ
      QZQZVLVPNZWHWDVTOZWCOZQWOVTWCUDWQWKWRWNWQVQOZVSOZQWKVQVSUDWSWIWTWJDKRVRKR
      UCUEWRWAOZWBOZQWNWAWBUDXAWLXBWMEKRFKRUCUEUCUEWPWKWHWNWPWIWHWJWPWIWEWGPZWH
      WPXCWIKVRBMZKEBMZFBMZPWPXDVRXFVLVPVRAJZXDVRPVLVNVOXGVMAIBCEFGHUNUFAIBCVRG
      HUGUHWPXEEFBVLVMVNXEEPVOAIBCEGHUGUISUJWIWEXDWGXFDKVRBUKWIWFXEFBDKEBUKSULT
      WEWGUMZUOWPWHWJDKBMZWGJWPXIDWGVLVNVMXIDPVOAIBCDGHUPUQZWPDWFWGVLVMVNDWFJVO
      AIBCDEGHURVDWPVLWFAJZVOWFWGJVLVPUSVLVMVNXKVOAIBCDEGHUNVDZVLVMVNVOUTAIBCWF
      FGHURVAVBVCWJWEXIWGVRKDBVEVFTVGWPWNXCWHWPWLXCWMWPXCWLDKFBMZBMZXIFBMZPWPXN
      DFBMXOWPXMFDBVLVMVOXMFPVNAIBCFGHUGVHVIWPXIDFBXJSUJWLWEXNWGXOWLVRXMDBEKFBU
      KVIWLWFXIFBEKDBVESULTWPXCWMDEKBMZBMZWFKBMZPWPXQWFXRWPXPEDBVLVMVNXPEPVOAIB
      CEGHUPUIVIVLVPXKXRWFPXLAIBCWFGHUPUHUJWMWEXQWGXRWMVRXPDBFKEBVEVIFKWFBVEULT
      VGXHUOVGVJVK $.

    $( Lemma for ~ paddass .  Combine ~ paddasslem16 and ~ paddasslem17 .
       (Contributed by NM, 12-Jan-2012.) $)
    paddasslem18 $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) )
          -> ( X .+ ( Y .+ Z ) ) C_ ( ( X .+ Y ) .+ Z ) ) $=
      ( chlt wcel wss w3a wa c0 wne co cjn cfv eqid 3expa cple paddasslem16 wn
      paddasslem17 pm2.61dan ) CIJZDAKEAKFAKLZMDNOEFBPZNOMENOFNOMMZDUHBPDEBPFBP
      KZUFUGUIUJABCQRZCCUARZDEFULSUKSGHUBTUFUGUIUCUJABCDEFGHUDTUE $.

    $( Projective subspace sum is associative.  Equation 16.2.1 of [MaedaMaeda]
       p. 68.  In our version, the subspaces do not have to be non-empty.
       (Contributed by NM, 29-Dec-2011.) $)
    paddass $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) )
          -> ( ( X .+ Y ) .+ Z ) = ( X .+ ( Y .+ Z ) ) ) $=
      ( chlt wcel wss w3a co paddasslem18 wceq paddcom syl3an1 paddssat syl3anc
      eqtrd simpl simpr3 simpr2 simpr1 syl13anc clat 3adant3r3 oveq1d 3adant3r1
      wa hllat oveq2d 3sstr4d eqssd ) CIJZDAKZEAKZFAKZLZUJZDEBMZFBMZDEFBMZBMZUT
      FEDBMZBMZFEBMZDBMZVBVDUTUOURUQUPVFVHKUOUSUAZUOUPUQURUBZUOUPUQURUCZUOUPUQU
      RUDZABCFEDGHNUEUTVBVEFBMZVFUTVAVEFBUOUPUQVAVEOZURUOCUFJZUPUQVNCUKZABCDEGH
      PQUGUHUTUOVEAKZURVMVFOZVIUTUOUQUPVQVIVKVLAIBCEDGHRSVJUOVOVQURVRVPABCVEFGH
      PQSTUTVDDVGBMZVHUTVCVGDBUOUQURVCVGOZUPUOVOUQURVTVPABCEFGHPQUIULUTUOUPVGAK
      ZVSVHOZVIVLUTUOURUQWAVIVJVKAIBCFEGHRSUOVOUPWAWBVPABCDVGGHPQSTUMABCDEFGHNU
      N $.

    $( Commutative/associative law for projective subspace sum.  (Contributed
       by NM, 14-Jan-2012.)  (New usage is discouraged.) $)
    padd12N $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) )
          -> ( X .+ ( Y .+ Z ) ) = ( Y .+ ( X .+ Z ) ) ) $=
      ( chlt wcel wss w3a wa co clat wceq hllat adantr simpr1 paddass syl13anc
      simpr2 paddcom syl3anc oveq1d simpl simpr3 3eqtr3d ) CIJZDAKZEAKZFAKZLZMZ
      DEBNZFBNEDBNZFBNZDEFBNBNEDFBNBNZUNUOUPFBUNCOJZUJUKUOUPPUIUSUMCQRUIUJUKULS
      ZUIUJUKULUBZABCDEGHUCUDUEABCDEFGHTUNUIUKUJULUQURPUIUMUFVAUTUIUJUKULUGABCE
      DFGHTUAUH $.

    $( Rearrangement of 4 terms in a projective subspace sum.  (Contributed by
       NM, 14-Jan-2012.)  (New usage is discouraged.) $)
    padd4N $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A ) /\ ( Z C_ A /\ W C_ A ) )
          -> ( ( X .+ Y ) .+ ( Z .+ W ) )
         = ( ( X .+ Z ) .+ ( Y .+ W ) ) ) $=
      ( chlt wcel wss wa w3a co wceq syl13anc paddssat syl3anc paddass padd12N
      simp1 simp2r simp3l simp3r oveq2d simp2l 3eqtr4d ) CJKZEALZFALZMZGALZDALZ
      MZNZEFGDBOZBOZBOZEGFDBOZBOZBOZEFBOUQBOZEGBOUTBOZUPURVAEBUPUIUKUMUNURVAPUI
      ULUOUBZUIUJUKUOUCZUIULUMUNUDZUIULUMUNUEZABCFGDHIUAQUFUPUIUJUKUQALZVCUSPVE
      UIUJUKUOUGZVFUPUIUMUNVIVEVGVHAJBCGDHIRSABCEFUQHITQUPUIUJUMUTALZVDVBPVEVJV
      GUPUIUKUNVKVEVFVHAJBCFDHIRSABCEGUTHITQUH $.
  $}

  ${
    $d p B $.  $d p q r K $.  $d p q r .+ $.  $d p S $.  $d p q r X $.
    $d p q r Y $.
    paddidm.s $e |- S = ( PSubSp ` K ) $.
    paddidm.p $e |- .+ = ( +P ` K ) $.
    $( Projective subspace sum is idempotent.  Part of Lemma 16.2 of
       [MaedaMaeda] p. 68.  (Contributed by NM, 13-Jan-2012.) $)
    paddidm $p |- ( ( K e. B /\ X e. S ) -> ( X .+ X ) = X ) $=
      ( vp vq vr wcel wa co cv wo cfv wrex wss eqid syl3anc catm cjn cple simpl
      wbr wb psubssat elpadd wi pm1.2 a1i psubspi 3exp1 imp4b jaod sylbid ssrdv
      sspadd1 eqssd ) DAKZECKZLZEEBMZEVBHVCEVBHNZVCKZVDEKZVFOZVDDUAPZKZVDINJNDU
      BPZMDUCPZUEJEQIEQZLZOZVFVBUTEVHRZVOVEVNUFUTVAUDZVHACDEVHSZFUGZVRVHABVDVJD
      VKEEJIVKSZVJSZVQGUHTVBVGVFVMVGVFUIVBVFUJUKUTVAVIVLVFUTVAVIVLVFVHAVDCVJDVK
      EJIVSVTVQFULUMUNUOUPUQVBUTVOVOEVCRVPVRVRVHABDEEVQGURTUS $.

    $( The projective sum of two subspaces is a subspace.  Part of Lemma 16.2
       of [MaedaMaeda] p. 68.  (Contributed by NM, 14-Jan-2012.)
       (New usage is discouraged.) $)
    paddclN $p |- ( ( K e. HL /\ X e. S /\ Y e. S ) -> ( X .+ Y ) e. S ) $=
      ( vp vq vr chlt wcel co cfv wss cv wrex eqid psubssat wceq w3a cjn wbr wi
      catm cple wral simp1 3adant3 3adant2 paddssat syl3anc wa wo olc wb elpadd
      padd4N paddidm oveq12d eqtrd eleq2d bitr3d syl5ib exp3a ralrimiv 3ad2ant1
      syl122anc ispsubsp2 mpbir2and ) CKLZDBLZEBLZUAZDEAMZBLZVOCUENZOZHPZIPJPCU
      BNZMCUFNZUCJVOQIVOQZVSVOLZUDZHVQUGZVNVKDVQOZEVQOZVRVKVLVMUHZVKVLWFVMVQKBC
      DVQRZFSUIZVKVMWGVLVQKBCEWIFSUJZVQKACDEWIGUKULZVNWDHVQVNVSVQLZWBWCWMWBUMZW
      CWCUNZWNUNZVNWCWNWOUOVNVSVOVOAMZLZWPWCVNVKVRVRWRWPUPWHWLWLVQKAVSVTCWAVOVO
      JIWARZVTRZWIGUQULVNWQVOVSVNWQDDAMZEEAMZAMZVOVNVKWFWGWFWGWQXCTWHWJWKWJWKVQ
      ACEDEDWIGURVHVNXADXBEAVKVLXADTVMKABCDFGUSUIVKVMXBETVLKABCEFGUSUJUTVAVBVCV
      DVEVFVKVLVPVRWEUMUPVMVQKBVTCWAVOJIHWSWTWIFVIVGVJ $.
  $}

  ${
    paddssw.a $e |- A = ( Atoms ` K ) $.
    paddssw.p $e |- .+ = ( +P ` K ) $.
    $( Subset law for projective subspace sum valid for all subsets of atoms.
       (Contributed by NM, 14-Mar-2012.) $)
    paddssw1 $p |- ( ( K e. B /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) )
              -> ( ( X C_ Z /\ Y C_ Z ) -> ( X .+ Y ) C_ ( Z .+ Z ) ) ) $=
      ( wcel wss w3a wa co wi simpl simpr3 paddss12 syl3anc ) DBJZEAKZFAKZGAKZL
      ZMTUCUCEGKFGKMEFCNGGCNKOTUDPTUAUBUCQZUEABCDGEGFHIRS $.

    $( Subset law for projective subspace sum valid for all subsets of atoms.
       (Contributed by NM, 14-Mar-2012.) $)
    paddssw2 $p |- ( ( K e. B /\ ( X C_ A /\ Y C_ A /\ Z C_ A ) )
              -> ( ( X .+ Y ) C_ Z -> ( X C_ Z /\ Y C_ Z ) ) ) $=
      ( wcel wss w3a wa co sspadd1 3adant3r3 sstr sylan ex simpl simpr2 sspadd2
      simpr1 syl3anc jcad ) DBJZEAKZFAKZGAKZLZMZEFCNZGKZEGKZFGKZUKUMUNUKEULKZUM
      UNUFUGUHUPUIABCDEFHIOPEULGQRSUKUMUOUKFULKZUMUOUKUFUHUGUQUFUJTUFUGUHUIUAUF
      UGUHUIUCABCDFEHIUBUDFULGQRSUE $.
  $}

  ${
    paddss.a $e |- A = ( Atoms ` K ) $.
    paddss.s $e |- S = ( PSubSp ` K ) $.
    paddss.p $e |- .+ = ( +P ` K ) $.
    $( Subset law for projective subspace sum.  ( ~ unss analog.)  (Contributed
       by NM, 7-Mar-2012.) $)
    paddss $p |- ( ( K e. B /\ ( X C_ A /\ Y C_ A /\ Z e. S ) )
              -> ( ( X C_ Z /\ Y C_ Z ) <-> ( X .+ Y ) C_ Z ) ) $=
      ( wcel wss w3a wa co wi simpl 3ad2antr3 syl13anc simpr1 psubssat paddssw1
      simpr2 wceq paddidm sseq2d sylibd paddssw2 impbid ) EBLZFAMZGAMZHDLZNZOZF
      HMGHMOZFGCPZHMZUPUQURHHCPZMZUSUPUKULUMHAMZUQVAQUKUORZUKULUMUNUAZUKULUMUNU
      DZUKULUNVBUMABDEHIJUBSZABCEFGHIKUCTUPUTHURUKULUNUTHUEUMBCDEHJKUFSUGUHUPUK
      ULUMVBUSUQQVCVDVEVFABCEFGHIKUITUJ $.
  $}

  ${
    $d p q r A $.  $d q r .\/ $.  $d p q r K $.  $d q r .<_ $.  $d p q r .+ $.
    $d p q r S $.  $d p q r X $.  $d p q r Y $.  $d p q r Z $.  $d p q r $.
    pmodlem.l $e |- .<_ = ( le ` K ) $.
    pmodlem.j $e |- .\/ = ( join ` K ) $.
    pmodlem.a $e |- A = ( Atoms ` K ) $.
    pmodlem.s $e |- S = ( PSubSp ` K ) $.
    pmodlem.p $e |- .+ = ( +P ` K ) $.
    $( Lemma for ~ pmod1i .  (Contributed by NM, 9-Mar-2012.) $)
    pmodlem1 $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A ) /\ ( Z e. S /\
          X C_ Z /\ p e. Z ) /\ ( q e. X /\ r e. Y /\
         p .<_ ( q .\/ r ) ) ) -> p e. ( X .+ ( Y i^i Z ) ) ) $=
      ( wcel wss w3a chlt cv co wbr cin weq simpl11 simpl12 simpl13 ssinss1 syl
      wa sspadd1 syl3anc simpr simpl31 eqeltrd sseldd wne hllat simpl32 simpl21
      clat simpl22 simpl23 psubssat syl2anc 3jca simpl33 hlatexch1 imp syl31anc
      csn simp31 snssd simp22 sstrd simp23 simp11 simp12 simp21 paddss syl13anc
      wb mpbi2and simp33 simp13 simp32 elpadd2at2 mpbird elin sylanbrc elpaddri
      syl333anc syl322anc pm2.61dane ) EUARZGASZHASZTZICRZGISZLUBZIRZTZKUBZGRZJ
      UBZHRZXCXFXHDUCFUDZTZTZXCGHIUEZBUCZRZXCXFXLLKUFZULZGXNXCXQWQWRXMASZGXNSWQ
      WRWSXEXKXPUGWQWRWSXEXKXPUHXQWSXRWQWRWSXEXKXPUIHIAUJZUKAUABEGXMOQUMUNXQXCX
      FGXLXPUOXGXIXJWTXEXPUPUQURXLXCXFUSZULZEVCRZWRXRXGXHXMRZXCARZXJXOYAWQYBWQW
      RWSXEXKXTUGZEUTZUKWQWRWSXEXKXTUHZYAWSXRWQWRWSXEXKXTUIZXSUKXGXIXJWTXEXTUPZ
      YAXIXHIRZYCXGXIXJWTXEXTVAZYAWQWRWSXAXBXDXGXIXHXFXCDUCFUDZYJYEYGYHXAXBXDWT
      XKXTVBZXAXBXDWTXKXTVDXAXBXDWTXKXTVEZYIYKYAWQYDXHARZXFARZTZXTXJYLYEYAYDYOY
      PYAIAXCYAWQXAIASZYEYMAUACEIOPVFZVGYNURZYAHAXHYHYKURYAGAXFYGYIURVHXLXTUOXG
      XIXJWTXEXTVIZWQYQXTTXJYLAXCXHXFDEFMNOVJVKVLWTXEXGXIYLTZTZXFVMZXCVMZBUCZIX
      HUUCUUDISZUUEISZUUFISZUUCUUDGIUUCXFGWTXEXGXIYLVNZVOWTXAXBXDUUBVPVQUUCXCIW
      TXAXBXDUUBVRZVOUUCWQUUDASUUEASXAUUGUUHULUUIWDWQWRWSXEUUBVSZUUCXFAUUCGAXFW
      QWRWSXEUUBVTUUJURZVOUUCXCAUUCIAXCUUCWQXAYRUULWTXAXBXDUUBWAZYSVGUUKURZVOUU
      NAUABCEUUDUUEIOPQWBWCWEUUCXHUUFRZYLWTXEXGXIYLWFUUCYBYPYDYOUUPYLWDUUCWQYBU
      ULYFUKUUMUUOUUCHAXHWQWRWSXEUUBWGWTXEXGXIYLWHURABXFXCXHDEFMNOQWIWCWJURWNXH
      HIWKWLYTUUAABXFXHXCDEFGXMMNOQWMWOWP $.

    $( Lemma for ~ pmod1i .  (Contributed by NM, 9-Mar-2012.) $)
    pmodlem2 $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z e. S ) /\ X C_ Z )
          -> ( ( X .+ Y ) i^i Z ) C_ ( X .+ ( Y i^i Z ) ) ) $=
      ( vq vr wcel wss c0 wa vp chlt w3a co cin wceq simpr oveq1d simpl1 padd02
      simpl22 syl2anc eqtrd ssinss1 simpl21 sspadd2 syl3anc eqsstrd oveq2 simp1
      ineq1d syl simp21 padd01 sylan9eqr inss1 sspadd1 syl5ss wne elin wbr wrex
      cv wi clat wb hllat simprl elpaddn0 simpl23 simpl3 simpr1 simpr2l simpr2r
      syl31anc simpr3 pmodlem1 syl333anc 3exp2 rexlimdvv adantld adantrl sylbid
      imp exp32 com34 imp4b syl5bi ssrdv pm2.61da2ne ) EUBQZGARZHARZICQZUCZGIRZ
      UCZGHBUDZIUEZGHIUEZBUDZRGSHSXGGSUFZTZXIXJXKXMXHHIXMXHSHBUDZHXMGSHBXGXLUGU
      HXMXAXCXNHUFXAXEXFXLUIZXBXCXDXAXFXLUKZAUBBEHLNUJULUMVAXMXAXJARZXBXJXKRXOX
      MXCXQXPHIAUNZVBXBXCXDXAXFXLUOAUBBEXJGLNUPUQURXGHSUFZTZXIGIUEZXKXTXHGIXSXG
      XHGSBUDZGHSGBUSXGXAXBYBGUFXAXEXFUTXAXBXCXDXFVCAUBBEGLNVDULVEVAXTYAGXKGIVF
      XTXAXBXQGXKRXAXEXFXSUIXBXCXDXAXFXSUOXTXCXQXBXCXDXAXFXSUKXRVBAUBBEGXJLNVGU
      QVHURXGGSVIHSVITZTZUAXIXKUAVMZXIQYEXHQZYEIQZTYDYEXKQZYEXHIVJXGYCYFYGYHXGY
      CYGYFYHXGYCYGYFYHVNXGYCYGTZTZYFYEAQZYEOVMZPVMZDUDFVKZPHVLOGVLZTZYHYJEVOQZ
      XBXCYCYFYPVPYJXAYQXAXEXFYIUIEVQVBXBXCXDXAXFYIUOXBXCXDXAXFYIUKXGYCYGVRABYE
      DEFGHPOJKLNVSWEXGYGYPYHVNYCXGYGTZYOYHYKYRYNYHOPGHXGYGYLGQZYMHQZTZYNYHVNVN
      XGYGUUAYNYHXGYGUUAYNUCZTXAXBXCXDXFYGYSYTYNYHXAXEXFUUBUIXBXCXDXAXFUUBUOXBX
      CXDXAXFUUBUKXBXCXDXAXFUUBVTXAXEXFUUBWAXGYGUUAYNWBYSYTYGYNXGWCYSYTYGYNXGWD
      XGYGUUAYNWFABCDEFGHIPOUAJKLMNWGWHWIWNWJWKWLWMWOWPWQWRWSWT $.
  $}

  ${
    pmod.a $e |- A = ( Atoms ` K ) $.
    pmod.s $e |- S = ( PSubSp ` K ) $.
    pmod.p $e |- .+ = ( +P ` K ) $.
    $( The modular law holds in a projective subspace.  (Contributed by NM,
       10-Mar-2012.) $)
    pmod1i $p |- ( ( K e. HL /\ ( X C_ A /\ Y C_ A /\ Z e. S ) ) ->
        ( X C_ Z -> ( ( X .+ Y ) i^i Z ) = ( X .+ ( Y i^i Z ) ) ) ) $=
      ( chlt wcel wss w3a wa co cin wceq cfv syl3anc cjn cple pmodlem2 3expa wi
      eqid inss1 simpll simplr2 simplr1 paddss2 simpl psubssat 3ad2antr3 simpr2
      mpi ssinss1 syl paddss1 simplr3 syl2anc inss2 paddidm sseqtrd sstrd ssind
      imp eqssd ex ) DKLZEAMZFAMZGCLZNZOZEGMZEFBPZGQZEFGQZBPZRVOVPOZVRVTVJVNVPV
      RVTMABCDUASZDDUBSZEFGWCUFWBUFHIJUCUDWAVTVQGWAVSFMZVTVQMZFGUGWAVJVLVKWDWEU
      EVJVNVPUHZVKVLVMVJVPUIVKVLVMVJVPUJAKBDVSFEHJUKTUPWAVTGVSBPZGVOVPVTWGMZVOV
      JGAMZVSAMZVPWHUEVJVNULVJVKVMWIVLAKCDGHIUMZUNVOVLWJVJVKVLVMUOFGAUQURAKBDEG
      VSHJUSTVGWAWGGGBPZGWAVJWIWIWGWLMZWFWAVJVMWIWFVKVLVMVJVPUTZWKVAZWOVJWIWINV
      SGMWMFGVBAKBDVSGGHJUKUPTWAVJVMWLGRWFWNKBCDGIJVCVAVDVEVFVHVI $.

    $( Dual of the modular law.  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pmod2iN $p |- ( ( K e. HL /\ ( X e. S /\ Y C_ A /\ Z C_ A ) ) ->
        ( Z C_ X -> ( ( X i^i Y ) .+ Z ) = ( X i^i ( Y .+ Z ) ) ) ) $=
      ( chlt wcel wss w3a cin co wceq incom paddcom syl3anc clat hllat 3ad2ant1
      oveq1i simp22 syl simp23 syl5eq simp21 3jca pmod1i 3impia syld3an2 ineq1d
      ssinss1 3eqtr2d syl6eq 3expia ) DKLZECLZFAMZGAMZNZGEMZEFOZGBPZEFGBPZOZQUS
      VCVDNZVFVGEOZVHVIVFGFEOZBPZGFBPZEOZVJVIVFVKGBPZVLVEVKGBEFRUDVIDUALZVKAMZV
      BVOVLQUSVCVPVDDUBUCZVIVAVQUSUTVAVBVDUEZFEAUOUFUSUTVAVBVDUGZABDVKGHJSTUHUS
      VBVAUTNZVCVDVNVLQZVIVBVAUTVTVSUSUTVAVBVDUIUJUSWAVDWBABCDGFEHIJUKULUMVIVMV
      GEVIVPVBVAVMVGQVRVTVSABDGFHJSTUNUPVGERUQUR $.

    $( The modular law for projective subspaces.  (Contributed by NM,
       26-Mar-2012.)  (New usage is discouraged.) $)
    pmodN $p |- ( ( K e. HL /\ ( X e. S /\ Y C_ A /\ Z C_ A ) ) ->
        ( X i^i ( Y .+ ( X i^i Z ) ) ) = ( ( X i^i Y ) .+ ( X i^i Z ) ) ) $=
      ( wcel wss w3a wa cin co incom wceq inss2 syl5ss chlt hllat adantr simpr2
      clat simpr3 paddcom syl3anc ineq2d oveq2i simpr1 3jca inss1 pmod1i syldan
      mpi 3eqtr4a ) DUAKZECKZFALZGALZMZNZEEGOZFBPZOVEEOZEFVDBPZOEFOZVDBPZEVEQVC
      VGVEEVCDUEKZUTVDALZVGVERURVJVBDUBUCZURUSUTVAUDZVCVDGAEGSURUSUTVAUFTZABDFV
      DHJUGUHUIVCVDVHBPZVDFEOZBPZVIVFVHVPVDBEFQUJVCVJVHALVKVIVORVLVCVHFAEFSVMTV
      NABDVHVDHJUGUHURVBVKUTUSMZVFVQRZVCVKUTUSVNVMURUSUTVAUKULURVRNVDELVSEGUMAB
      CDVDFEHIJUNUPUOUQUQ $.
  $}

  ${
    pmodl42.s $e |- S = ( PSubSp ` K ) $.
    pmodl42.p $e |- .+ = ( +P ` K ) $.
    $( Lemma derived from modular law.  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pmodl42N $p |- ( ( ( K e. HL /\ X e. S /\ Y e. S ) /\ ( Z e. S /\ W e. S )
        )
       -> ( ( ( X .+ Y ) .+ Z ) i^i ( ( X .+ Y ) .+ W ) )
               = ( ( X .+ Y ) .+ ( ( X .+ Z ) i^i ( Y .+ W ) ) ) ) $=
      ( chlt wcel w3a co cin wss wceq psubssat syl2anc syl3anc syl13anc wa catm
      incom cfv simpl1 simpl3 eqid simpl2 simprl paddssat simprr paddclN pmod1i
      sspadd1 3impia syl131anc oveq2d ssinss1 syl paddass padd12N eqtrd ineq12d
      syl5reqr syl6eq sspadd2 sstrd 3eqtr4rd ) CJKZEBKZFBKZLZGBKZDBKZUAZUAZEFEG
      AMZFDAMZNZAMZAMZEVRFVQAMZNZAMZEFAMZVSAMZWEGAMZWEDAMZNZVPVTWCEAVPWCWBVRNZV
      TWBVRUCVPVIFCUBUDZOZVQWKOZVRBKZFVROZWJVTPZVIVJVKVOUEZVPVIVKWLWQVIVJVKVOUF
      ZWKJBCFWKUGZHQRZVPVIEWKOZGWKOZWMWQVPVIVJXAWQVIVJVKVOUHZWKJBCEWSHQRZVPVIVM
      XBWQVLVMVNUIZWKJBCGWSHQRZWKJACEGWSIUJSZVPVIVKVNWNWQWRVLVMVNUKZABCFDHIULSZ
      VPVIWLDWKOZWOWQWTVPVIVNXJWQXHWKJBCDWSHQRZWKJACFDWSIUNSVIWLWMWNLWOWPWKABCF
      VQVRWSHIUMUOUPVDUQVPVIXAWLVSWKOZWFWAPWQXDWTVPWMXLXGVQVRWKURUSWKACEFVSWSIU
      TTVPWIEVRAMZWBNZWDVPWIWBXMNXNVPWGWBWHXMVPWGEFGAMAMZWBVPVIXAWLXBWGXOPWQXDW
      TXFWKACEFGWSIUTTVPVIXAWLXBXOWBPWQXDWTXFWKACEFGWSIVATVBVPVIXAWLXJWHXMPWQXD
      WTXKWKACEFDWSIUTTVCWBXMUCVEVPVIXAVRWKOZWBBKZEWBOZXNWDPZWQXDVPVIWNXPWQXIWK
      JBCVRWSHQRVPVIVKVQBKZXQWQWRVPVIVJVMXTWQXCXEABCEGHIULSABCFVQHIULSVPEVQWBVP
      VIXAXBEVQOWQXDXFWKJACEGWSIUNSVPVIWMWLVQWBOWQXGWTWKJACVQFWSIVFSVGVIXAXPXQL
      XRXSWKABCEVRWBWSHIUMUOUPVBVH $.
  $}

  ${
    $d p q r B $.  $d p q r .\/ $.  $d p q r K $.  $d p q r M $.  $d p .+ $.
    $d p q r X $.  $d p q r Y $.
    pmapjoin.b $e |- B = ( Base ` K ) $.
    pmapjoin.j $e |- .\/ = ( join ` K ) $.
    pmapjoin.m $e |- M = ( pmap ` K ) $.
    pmapjoin.p $e |- .+ = ( +P ` K ) $.
    $( The projective map of the join of two lattice elements.  Part of
       Equation 15.5.3 of [MaedaMaeda] p. 63.  (Contributed by NM,
       27-Jan-2012.) $)
    pmapjoin $p |- ( ( K e. Lat /\ X e. B /\ Y e. B )
          -> ( ( M ` X ) .+ ( M ` Y ) ) C_ ( M ` ( X .\/ Y ) ) ) $=
      ( vq clat wcel cfv wbr wa wi wb elpmap vp vr w3a co cv catm cple wo simpl
      wrex eqid atbase latlej1 adantr simpl1 simpr simpl2 latjcl lattr syl13anc
      a1i mpan2d expimpd sylani jcad latlej2 simpl3 3adant3 3adant2 anbi12d an4
      syl6bb anim12i simpll1 simprl simpll2 simpll3 latjlej12 syl122anc syl3anc
      jaod simprr simplr ad2antrr exp3acom23 syld sylbid rexlimdvv wss pmapssat
      simp1 elpadd orbi12d orbi1d bitrd syl2anc 3imtr4d ssrdv ) DMNZFANZGANZUCZ
      UAFEOZGEOZBUDZFGCUDZEOZXBUAUEZDUFOZNZXHFDUGOZPZQZXJXHGXKPZQZUHZXJXHLUEZUB
      UEZCUDZXKPZUBXDUJLXCUJZQZUHZXJXHXFXKPZQZXHXENZXHXGNZXBXPYEYBXBXMYEXOXBXMX
      JYDXMXJRXBXJXLUIVAXJXBXHANZXLYDXIAXHDHXIUKZULZXBYHXLYDXBYHQZXLFXFXKPZYDXB
      YLYHACDXKFGHXKUKZIUMUNYKWSYHWTXFANZXLYLQYDRWSWTXAYHUOZXBYHUPZWSWTXAYHUQXB
      YNYHACDFGHIURZUNZADXKXHFXFHYMUSUTVBVCVDVEXBXOXJYDXOXJRXBXJXNUIVAXJXBYHXNY
      DYJXBYHXNYDYKXNGXFXKPZYDXBYSYHACDXKFGHYMIVFUNYKWSYHXAYNXNYSQYDRYOYPWSWTXA
      YHVGYRADXKXHGXFHYMUSUTVBVCVDVEWAXBYBXJYDYBXJRXBXJYAUIVAXJXBYHYAYDYJXBYHYA
      YDYKXTYDLUBXCXDYKXQXCNZXRXDNZQZXQXINZXRXINZQZXQFXKPZXRGXKPZQZQZXTYDRZXBUU
      BUUISYHXBUUBUUCUUFQZUUDUUGQZQUUIXBYTUUKUUAUULWSWTYTUUKSXAXIAMXQDXKEFHYMYI
      JTVHWSXAUUAUULSWTXIAMXRDXKEGHYMYIJTVIVJUUCUUFUUDUUGVKVLUNUUEYKXQANZXRANZQ
      ZUUHUUJUUCUUMUUDUUNXIAXQDHYIULXIAXRDHYIULVMYKUUOUUHUUJYKUUOQZUUHXSXFXKPZU
      UJUUPWSUUMWTUUNXAUUHUUQRWSWTXAYHUUOVNZYKUUMUUNVOZWSWTXAYHUUOVPYKUUMUUNWBZ
      WSWTXAYHUUOVQACDXKGXQFXRHYMIVRVSUUPXTUUQYDUUPWSYHXSANZYNXTUUQQYDRUURXBYHU
      UOWCUUPWSUUMUUNUVAUURUUSUUTACDXQXRHIURVTXBYNYHUUOYQWDADXKXHXSXFHYMUSUTWEW
      FVCVDWGWHVCVDVEWAXBYFXHXCNZXHXDNZUHZYBUHZYCXBWSXCXIWIZXDXIWIZYFUVESWSWTXA
      WKZWSWTUVFXAXIAMDEFHYIJWJVHWSXAUVGWTXIAMDEGHYIJWJVIXIMBXHCDXKXCXDUBLYMIYI
      KWLVTXBUVDXPYBXBUVBXMUVCXOWSWTUVBXMSXAXIAMXHDXKEFHYMYIJTVHWSXAUVCXOSWTXIA
      MXHDXKEGHYMYIJTVIWMWNWOXBWSYNYGYESUVHYQXIAMXHDXKEXFHYMYIJTWPWQWR $.
  $}

  ${
    $d q p r A $.  $d q p r B $.  $d p q r .\/ $.  $d p q r K $.  $d p q r M $.
    $d p .+ $.  $d p q r Q $.  $d p q r X $.
    pmapjat.b $e |- B = ( Base ` K ) $.
    pmapjat.j $e |- .\/ = ( join ` K ) $.
    pmapjat.a $e |- A = ( Atoms ` K ) $.
    pmapjat.m $e |- M = ( pmap ` K ) $.
    pmapjat.p $e |- .+ = ( +P ` K ) $.
    $( The projective map of the join of a lattice element and an atom.
       (Contributed by NM, 28-Jan-2012.) $)
    pmapjat1 $p |- ( ( K e. HL /\ X e. B /\ Q e. A )
          -> ( M ` ( X .\/ Q ) ) = ( ( M ` X ) .+ ( M ` Q ) ) ) $=
      ( vr wcel wceq wa c0 adantr wb vp vq chlt w3a co cfv cp0 wss simp1 atbase
      3ad2ant3 pmapssat syl2anc padd02 fveq2 cal hlatl 3ad2ant1 pmap0 sylan9eqr
      eqid syl oveq1d oveq1 col hlol olj02 fveq2d 3eqtr4rd wne cv cple wbr wrex
      simpll1 simpll2 simplr simpll3 3jca simpllr simpr cvrat42 imp syl22anc ex
      elpmap 3adant3 df-rex elpmapat 3adant2 anbi1d exbidv syl5rbb oveq2 breq2d
      ceqsexgv bitr3d anbi12d anass syl6bb rexbidv2 ad2antrr sylibrd imdistanda
      wex clat hllat simp2 latjcl syl3anc pmapeq0 necon3bid biimpar atn0 mpbird
      simp3 elpaddn0 syl12anc 3imtr4d ssrdv pmapjoin eqssd pm2.61dane ) FUCOZHB
      OZDAOZUDZHDEUEZGUFZHGUFZDGUFZCUEZPHFUGUFZYGHYMPZQZRYKCUEZYKYLYIYGYPYKPZYN
      YGYDYKAUHZYQYDYEYFUIZYGYDDBOZYRYSYFYDYTYEABDFIKUJUKZABUCFGDIKLULUMZAUCCFY
      KKMUNUMSYOYJRYKCYNYGYJYMGUFZRHYMGUOYGFUPOZUUCRPYDYEUUDYFFUQURZFGYMYMVAZLU
      SVBUTVCYOYHDGYNYGYHYMDEUEZDHYMDEVDYGFVEOZYTUUGDPYDYEUUHYFFVFURUUABEFDYMIJ
      UUFVGUMUTVHVIYGHYMVJZQZYIYLUUJUAYIYLUUJUAVKZAOZUUKYHFVLUFZVMZQZUULUUKUBVK
      ZNVKZEUEZUUMVMZNYKVNZUBYJVNZQZUUKYIOZUUKYLOZUUJUULUUNUVAUUJUULQZUUNUUPHUU
      MVMZUUKUUPDEUEZUUMVMZQZUBAVNZUVAUVEUUNUVJUVEUUNQZYDYEUULYFUDZUUIUUNUVJUVE
      YDUUNYDYEYFUUIUULVOSUVKYEUULYFUVEYEUUNYDYEYFUUIUULVPSUUJUULUUNVQUVEYFUUNY
      DYEYFUUIUULVRSVSYGUUIUULUUNVTUVEUUNWAYDUVLQUUIUUNQUVJABUUKDEFUUMHYMUBIUUM
      VAZJUUFKWBWCWDWEYGUVAUVJTUUIUULYGUUTUVIUBYJAYGUUPYJOZUUTQUUPAOZUVFQZUVHQU
      VOUVIQYGUVNUVPUUTUVHYDYEUVNUVPTYFABUCUUPFUUMGHIUVMKLWFWGYGUUQDPZUUSQZNXEZ
      UUTUVHUUTUUQYKOZUUSQZNXEYGUVSUUSNYKWHYGUWAUVRNYGUVTUVQUUSYDYFUVTUVQTYEADF
      GUUQKLWIWJWKWLWMYFYDUVSUVHTYEUUSUVHNDAUVQUURUVGUUKUUMUUQDUUPEWNWOWPUKWQWR
      UVOUVFUVHWSWTXAXBXCXDYGUVCUUOTZUUIYGYDYHBOZUWBYSYGFXFOZYEYTUWCYDYEUWDYFFX
      GURZYDYEYFXHZUUABEFHDIJXIXJABUCUUKFUUMGYHIUVMKLWFUMSUUJUWDYJAUHZYRUDZYJRV
      JZYKRVJZUVDUVBTYGUWHUUIYGUWDUWGYRUWEYDYEUWGYFABUCFGHIKLULWGUUBVSSYGUWIUUI
      YGYJRHYMYDYEYJRPYNTYFBFGHYMIUUFLXKWGXLXMYGUWJUUIYGUWJDYMVJZYGUUDYFUWKUUEY
      DYEYFXPADFYMUUFKXNUMYGYKRDYMYGYDYTYKRPDYMPTYSUUABFGDYMIUUFLXKUMXLXOSACUUK
      EFUUMYJYKNUBUVMJKMXQXRXSXTYGYLYIUHZUUIYGUWDYEYTUWLUWEUWFUUABCEFGHDIJLMYAX
      JSYBYC $.

    $( The projective map of the join of an atom with a lattice element.
       (Contributed by NM, 12-May-2012.) $)
    pmapjat2 $p |- ( ( K e. HL /\ X e. B /\ Q e. A )
          -> ( M ` ( Q .\/ X ) ) = ( ( M ` Q ) .+ ( M ` X ) ) ) $=
      ( chlt wcel co cfv wceq syl3anc wss pmapjat1 clat hllat 3ad2ant1 3ad2ant3
      w3a atbase simp2 latjcom fveq2d pmapssat syl2anc 3adant3 paddcom 3eqtr4d
      simp1 ) FNOZHBOZDAOZUFZHDEPZGQHGQZDGQZCPZDHEPZGQVCVBCPZABCDEFGHIJKLMUAUTV
      EVAGUTFUBOZDBOZURVEVARUQURVGUSFUCUDZUSUQVHURABDFIKUGUEZUQURUSUHBEFDHIJUIS
      UJUTVGVCATZVBATZVFVDRVIUTUQVHVKUQURUSUPVJABNFGDIKLUKULUQURVLUSABNFGHIKLUK
      UMACFVCVBKMUNSUO $.

    $( The projective map of the join of a lattice element and a lattice line
       (expressed as the join ` Q .\/ R ` of two atoms).  (Contributed by NM,
       16-Sep-2012.) $)
    pmapjlln1 $p |- ( ( K e. HL /\ ( X e. B /\ Q e. A /\ R e. A ) )
          -> ( M ` ( X .\/ ( Q .\/ R ) ) )
             = ( ( M ` X ) .+ ( M ` ( Q .\/ R ) ) ) ) $=
      ( chlt wcel cfv co wss wceq w3a wa simpl pmapssat 3ad2antr1 simpr2 atbase
      syldan simpr3 paddass syl13anc clat adantr simpr1 latjcl syl3anc pmapjat1
      syl hllat latjass fveq2d 3adant3r3 oveq1d 3eqtr3d oveq2d 3eqtr4d ) GOPZIB
      PZDAPZEAPZUAZUBZIHQZDHQZCRZEHQZCRZVMVNVPCRZCRZIDEFRZFRZHQZVMVTHQZCRVLVGVM
      ASZVNASZVPASZVQVSTVGVKUCZVGVIVHWDVJABOGHIJLMUDUEVGVKDBPZWEVLVIWHVGVHVIVJU
      FABDGJLUGURZABOGHDJLMUDUHVGVKEBPZWFVLVJWJVGVHVIVJUIZABEGJLUGURZABOGHEJLMU
      DUHACGVMVNVPLNUJUKVLIDFRZEFRZHQZWMHQZVPCRZWBVQVLVGWMBPZVJWOWQTWGVLGULPZVH
      WHWRVGWSVKGUSUMZVGVHVIVJUNZWIBFGIDJKUOUPWKABCEFGHWMJKLMNUQUPVLWNWAHVLWSVH
      WHWJWNWATWTXAWIWLBFGIDEJKUTUKVAVLWPVOVPCVGVHVIWPVOTVJABCDFGHIJKLMNUQVBVCV
      DVLWCVRVMCVLVGWHVJWCVRTWGWIWKABCEFGHDJKLMNUQUPVEVF $.
  $}

  ${
    hlmod.b $e |- B = ( Base ` K ) $.
    hlmod.l $e |- .<_ = ( le ` K ) $.
    hlmod.j $e |- .\/ = ( join ` K ) $.
    hlmod.m $e |- ./\ = ( meet ` K ) $.
    hlmod.f $e |- F = ( pmap ` K ) $.
    hlmod.p $e |- .+ = ( +P ` K ) $.
    $( A version of the modular law ~ pmod1i that holds in a Hilbert lattice.
       (Contributed by NM, 13-May-2012.) $)
    hlmod1i $p |- ( ( K e. HL /\ ( X e. B /\ Y e. B /\ Z e. B ) )
        -> ( ( X .<_ Z /\ ( F ` ( X .\/ Y ) ) = ( ( F ` X ) .+ ( F ` Y ) ) )
           -> ( ( X .\/ Y ) ./\ Z ) = ( X .\/ ( Y ./\ Z ) ) ) ) $=
      ( wcel co cfv syl3anc chlt w3a wbr wceq clat hllat 3ad2ant1 simp21 simp22
      latjcl simp23 latmcl wss catm cpsubsp simp1 eqid pmapssat syl2anc pmapsub
      wa cin simp3l pmaple mpbid pmod1i 3impia syl131anc pmapmeet simp3r ineq1d
      wb eqtrd oveq2d 3eqtr4d pmapjoin eqsstrd mpbird mod1ile latasymd 3expia )
      EUAQZHAQZIAQZJAQZUBZHJFUCZHIDRZCSZHCSZICSZBRZUDZVAZWHJGRZHIJGRZDRZUDWBWFW
      NUBZAEFWOWQKLWBWFEUEQZWNEUFUGZWRWSWHAQZWEWOAQZWTWRWSWCWDXAWTWBWCWDWEWNUHZ
      WBWCWDWEWNUIZADEHIKMUJTZWBWCWDWEWNUKZAEGWHJKNULTZWRWSWCWPAQZWQAQZWTXCWRWS
      WDWEXHWTXDXFAEGIJKNULTZADEHWPKMUJTZWRWOWQFUCZWOCSZWQCSZUMZWRXMWJWPCSZBRZX
      NWRWLJCSZVBZWJWKXRVBZBRZXMXQWRWBWJEUNSZUMZWKYBUMZXREUOSZQZWJXRUMZXSYAUDZW
      BWFWNUPZWRWBWCYCYIXCYBAUAECHKYBUQZOURUSWRWBWDYDYIXDYBAUAECIKYJOURUSWRWSWE
      YFWTXFAYEECJKYEUQZOUTUSWRWGYGWBWFWGWMVCZWRWBWCWEWGYGVLYIXCXFAEFCHJKLOVDTV
      EWBYCYDYFUBYGYHYBBYEEWJWKXRYJYKPVFVGVHWRXMWIXRVBZXSWRWBXAWEXMYMUDYIXEXFYB
      ACEGWHJKNYJOVITWRWIWLXRWBWFWGWMVJVKVMWRXPXTWJBWRWBWDWEXPXTUDYIXDXFYBACEGI
      JKNYJOVITVNVOWRWSWCXHXQXNUMWTXCXJABDECHWPKMOPVPTVQWRWBXBXIXLXOVLYIXGXKAEF
      CWOWQKLOVDTVRWRWSWCWDWEWGWQWOFUCZWTXCXDXFYLWSWFWGYNADEFGHIJKLMNVSVGVHVTWA
      $.
  $}

  ${
    atmod.b $e |- B = ( Base ` K ) $.
    atmod.l $e |- .<_ = ( le ` K ) $.
    atmod.j $e |- .\/ = ( join ` K ) $.
    atmod.m $e |- ./\ = ( meet ` K ) $.
    atmod.a $e |- A = ( Atoms ` K ) $.
    $( Version of modular law ~ pmod1i that holds in a Hilbert lattice, when
       one element is an atom.  (Contributed by NM, 11-May-2012.)  (Revised by
       Mario Carneiro, 10-May-2013.) $)
    atmod1i1 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ P .<_ Y )
        -> ( P .\/ ( X ./\ Y ) ) = ( ( P .\/ X ) ./\ Y ) ) $=
      ( wcel w3a co wceq wa cfv chlt wbr cpmap cpadd simpl simpr2 eqid pmapjat2
      simpr1 syl3anc wi atbase hlmod1i syl3anr1 mpan2d 3impia eqcomd ) EUAOZCAO
      ZHBOZIBOZPZCIFUBZPCHDQZIGQZCHIGQDQZURVBVCVEVFRZURVBSZVCVDEUCTZTCVITHVITEU
      DTZQRZVGVHURUTUSVKURVBUEURUSUTVAUFURUSUTVAUIABVJCDEVIHJLNVIUGZVJUGZUHUJUS
      CBOURUTVAVCVKSVGUKABCEJNULBVJVIDEFGCHIJKLMVLVMUMUNUOUPUQ $.

    $( Version of modular law ~ pmod1i that holds in a Hilbert lattice, when an
       element meets an atom.  (Contributed by NM, 2-Sep-2012.)  (Revised by
       Mario Carneiro, 10-May-2013.) $)
    atmod1i1m $p |- ( ( ( K e. HL /\ P e. A ) /\ ( X e. B /\ Y e. B /\ Z e. B )
    /\ ( X ./\ P ) .<_ Z )
      -> ( ( X ./\ P ) .\/ ( Y ./\ Z ) )
           = ( ( ( X ./\ P ) .\/ Y ) ./\ Z ) ) $=
      ( wcel wa w3a co wceq chlt wbr cp0 simpl1l simpr simpl22 simpl23 atmod1i1
      cfv simpl3 syl131anc col simp1l hlol syl adantr clat hllat latmcl syl3anc
      olj02 syl2anc oveq1 adantl eqtrd oveq1d 3eqtr4d wo simp21 simp1r mpjaodan
      eqid meetat2 ) EUAPZCAPZQZHBPZIBPZJBPZRZHCGSZJFUBZRZWAAPZWAIJGSZDSZWAIDSZ
      JGSZTZWAEUCUIZTZWCWDQVNWDVRVSWBWIVNVOVTWBWDUDWCWDUEVQVRVSVPWBWDUFVQVRVSVP
      WBWDUGVPVTWBWDUJABWADEFGIJKLMNOUHUKWCWKQZWJWEDSZWEWFWHWLEULPZWEBPZWMWETWC
      WNWKWCVNWNVNVOVTWBUMZEUNUOZUPZWLEUQPZVRVSWOWCWSWKWCVNWSWPEURUOUPVQVRVSVPW
      BWKUFZVQVRVSVPWBWKUGBEGIJKNUSUTBDEWEWJKMWJVLZVAVBWKWFWMTWCWAWJWEDVCVDWLWG
      IJGWLWGWJIDSZIWKWGXBTWCWAWJIDVCVDWLWNVRXBITWRWTBDEIWJKMXAVAVBVEVFVGWCWNVQ
      VOWDWKVHWQVPVQVRVSWBVIVNVOVTWBVJABCEGHWJKNXAOVMUTVK $.

    $( Version of modular law ~ pmod1i that holds in a Hilbert lattice, when
       one element is an atom.  (Contributed by NM, 14-May-2012.)  (Revised by
       Mario Carneiro, 10-May-2013.) $)
    atmod1i2 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ X .<_ Y )
        -> ( X .\/ ( P ./\ Y ) ) = ( ( X .\/ P ) ./\ Y ) ) $=
      ( wcel w3a co wceq wa cfv chlt wbr cpmap cpadd simpl simpr2 eqid pmapjat1
      simpr1 syl3anc wi atbase syl simpr3 hlmod1i syl13anc mpan2d 3impia eqcomd
      ) EUAOZCAOZHBOZIBOZPZHIFUBZPHCDQZIGQZHCIGQDQZUTVDVEVGVHRZUTVDSZVEVFEUCTZT
      HVKTCVKTEUDTZQRZVIVJUTVBVAVMUTVDUEZUTVAVBVCUFZUTVAVBVCUIZABVLCDEVKHJLNVKU
      GZVLUGZUHUJVJUTVBCBOZVCVEVMSVIUKVNVOVJVAVSVPABCEJNULUMUTVAVBVCUNBVLVKDEFG
      HCIJKLMVQVRUOUPUQURUS $.

    $( Version of modular law ~ pmod1i that holds in a Hilbert lattice, when
       one element is a lattice line (expressed as the join ` P .\/ Q ` ).
       (Contributed by NM, 16-Sep-2012.)  (Revised by Mario Carneiro,
       10-May-2013.) $)
    llnmod1i2 $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
   /\ ( P e. A /\ Q e. A ) /\ X .<_ Y )
      -> ( X .\/ ( ( P .\/ Q ) ./\ Y ) )
       = ( ( X .\/ ( P .\/ Q ) ) ./\ Y ) ) $=
      ( wcel wa co cfv syl chlt w3a wbr cpmap cpadd simpl1 simpl2 simprl simprr
      wceq eqid pmapjlln1 syl13anc wi clat atbase latjcl syl3anc simpl3 hlmod1i
      hllat mpan2d 3impia eqcomd ) FUAPZIBPZJBPZUBZCAPZDAPZQZIJGUCZUBICDERZERZJ
      HRZIVMJHRERZVHVKVLVOVPUJZVHVKQZVLVNFUDSZSIVSSVMVSSFUESZRUJZVQVRVEVFVIVJWA
      VEVFVGVKUFZVEVFVGVKUGZVHVIVJUHZVHVIVJUIZABVTCDEFVSIKMOVSUKZVTUKZULUMVRVEV
      FVMBPZVGVLWAQVQUNWBWCVRFUOPZCBPZDBPZWHVRVEWIWBFVATVRVIWJWDABCFKOUPTVRVJWK
      WEABDFKOUPTBEFCDKMUQURVEVFVGVKUSBVTVSEFGHIVMJKLMNWFWGUTUMVBVCVD $.

    $( Version of modular law ~ pmod2iN that holds in a Hilbert lattice, when
       one element is an atom.  (Contributed by NM, 14-May-2012.)  (Revised by
       Mario Carneiro, 10-May-2013.) $)
    atmod2i1 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ P .<_ X )
         -> ( ( X ./\ Y ) .\/ P ) = ( X ./\ ( Y .\/ P ) ) ) $=
      ( wcel w3a co wceq latmcom syl3anc chlt clat hllat 3ad2ant1 simp22 simp23
      wbr oveq2d simp21 atbase syl latmcl latjcl simp1 simp3 atmod1i1 syl131anc
      latjcom 3eqtr4d 3eqtr3d ) EUAOZCAOZHBOZIBOZPZCHFUGZPZCHIGQZDQZCIHGQZDQZVH
      CDQZHICDQZGQZVGVHVJCDVGEUBOZVCVDVHVJRVAVEVOVFEUCUDZVAVBVCVDVFUEZVAVBVCVDV
      FUFZBEGHIJMSTUHVGVOCBOZVHBOZVIVLRVPVGVBVSVAVBVCVDVFUIZABCEJNUJUKZVGVOVCVD
      VTVPVQVRBEGHIJMULTBDECVHJLURTVGCIDQZHGQZHWCGQZVKVNVGVOWCBOZVCWDWERVPVGVOV
      SVDWFVPWBVRBDECIJLUMTVQBEGWCHJMSTVGVAVBVDVCVFVKWDRVAVEVFUNWAVRVQVAVEVFUOA
      BCDEFGIHJKLMNUPUQVGVMWCHGVGVOVDVSVMWCRVPVRWBBDEICJLURTUHUSUT $.

    $( Version of modular law ~ pmod2iN that holds in a Hilbert lattice, when
       one element is an atom.  (Contributed by NM, 14-May-2012.)  (Revised by
       Mario Carneiro, 10-May-2013.) $)
    atmod2i2 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ Y .<_ X )
         -> ( ( X ./\ P ) .\/ Y ) = ( X ./\ ( P .\/ Y ) ) ) $=
      ( wcel w3a co wceq latjcom syl3anc chlt clat hllat 3ad2ant1 simp21 atbase
      wbr syl simp23 oveq1d simp22 latjcl latmcom simp1 simp3 syl131anc 3eqtr4d
      atmod1i2 latmcl 3eqtrrd ) EUAOZCAOZHBOZIBOZPZIHFUGZPZHCIDQZGQZICHGQZDQZVJ
      IDQZHCGQZIDQVGVHHGQZICDQZHGQZVIVKVGVHVOHGVGEUBOZCBOZVDVHVORVAVEVQVFEUCUDZ
      VGVBVRVAVBVCVDVFUEZABCEJNUFUHZVAVBVCVDVFUIZBDECIJLSTUJVGVQVCVHBOZVIVNRVSV
      AVBVCVDVFUKZVGVQVRVDWCVSWAWBBDECIJLULTBEGHVHJMUMTVGVAVBVDVCVFVKVPRVAVEVFU
      NVTWBWDVAVEVFUOABCDEFGIHJKLMNURUPUQVGVQVDVJBOZVKVLRVSWBVGVQVRVCWEVSWAWDBE
      GCHJMUSTBDEIVJJLSTVGVJVMIDVGVQVRVCVJVMRVSWAWDBEGCHJMUMTUJUT $.

    $( Version of modular law ~ pmod1i that holds in a Hilbert lattice, when
       one element is a lattice line (expressed as the join ` P .\/ Q ` ).
       (Contributed by NM, 16-Sep-2012.)  (Revised by Mario Carneiro,
       10-May-2013.) $)
    llnmod2i2 $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
   /\ ( P e. A /\ Q e. A ) /\ Y .<_ X )
      -> ( ( X ./\ ( P .\/ Q ) ) .\/ Y )
        = ( X ./\ ( ( P .\/ Q ) .\/ Y ) ) ) $=
      ( wcel w3a co wceq syl3anc chlt wa clat simp11 hllat simp13 simp2l simp2r
      wbr hlatjcl simp12 latmcl latjcom latjcl oveq2d simp3 llnmod1i2 syl321anc
      syl latmcom 3eqtr4d oveq1d 3eqtr4rd ) FUAPZIBPZJBPZQZCAPZDAPZUBZJIGUIZQZJ
      CDERZIHRZERZVNJERZIVMJERZHRZIVMHRZJERVLFUCPZVFVNBPZVOVPSVLVDVTVDVEVFVJVKU
      DZFUEUSZVDVEVFVJVKUFZVLVTVMBPZVEWAWCVLVDVHVIWEWBVGVHVIVKUGZVGVHVIVKUHZABE
      FCDKMOUJTZVDVEVFVJVKUKZBFHVMIKNULTBEFJVNKMUMTVLIJVMERZHRZWJIHRZVRVOVLVTVE
      WJBPZWKWLSWCWIVLVTVFWEWMWCWDWHBEFJVMKMUNTBFHIWJKNUTTVLVQWJIHVLVTWEVFVQWJS
      WCWHWDBEFVMJKMUMTUOVLVDVFVEVHVIVKVOWLSWBWDWIWFWGVGVJVKUPABCDEFGHJIKLMNOUQ
      URVAVLVSVNJEVLVTVEWEVSVNSWCWIWHBFHIVMKNUTTVBVC $.

    $( Version of modular law that holds in a Hilbert lattice, when one element
       is an atom.  (Contributed by NM, 4-Jun-2012.)  (Revised by Mario
       Carneiro, 10-May-2013.) $)
    atmod3i1 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ P .<_ X )
         -> ( P .\/ ( X ./\ Y ) ) = ( X ./\ ( P .\/ Y ) ) ) $=
      ( wcel w3a co wceq latmcom syl3anc chlt wbr simp21 simp23 simp22 atmod1i1
      simp1 simp3 syl131anc clat hllat 3ad2ant1 oveq2d atbase latjcl 3eqtr4d
      syl ) EUAOZCAOZHBOZIBOZPZCHFUBZPZCIHGQZDQZCIDQZHGQZCHIGQZDQHVGGQZVDURUSVA
      UTVCVFVHRURVBVCUGURUSUTVAVCUCZURUSUTVAVCUDZURUSUTVAVCUEZURVBVCUHABCDEFGIH
      JKLMNUFUIVDVIVECDVDEUJOZUTVAVIVERURVBVNVCEUKULZVMVLBEGHIJMSTUMVDVNUTVGBOZ
      VJVHRVOVMVDVNCBOZVAVPVOVDUSVQVKABCEJNUNUQVLBDECIJLUOTBEGHVGJMSTUP $.

    $( Version of modular law that holds in a Hilbert lattice, when one element
       is an atom.  (Contributed by NM, 10-Jun-2012.)  (Revised by Mario
       Carneiro, 10-May-2013.) $)
    atmod3i2 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ X .<_ Y )
         -> ( X .\/ ( Y ./\ P ) ) = ( Y ./\ ( X .\/ P ) ) ) $=
      ( wcel w3a co wceq syl3anc latmcom chlt clat hllat 3ad2ant1 simp23 simp22
      wbr simp21 atbase syl latjcl atmod1i2 oveq2d 3eqtr2rd ) EUAOZCAOZHBOZIBOZ
      PZHIFUGZPZIHCDQZGQZVBIGQZHCIGQZDQHICGQZDQVAEUBOZURVBBOZVCVDRUOUSVGUTEUCUD
      ZUOUPUQURUTUEZVAVGUQCBOZVHVIUOUPUQURUTUFVAUPVKUOUPUQURUTUHABCEJNUIUJZBDEH
      CJLUKSBEGIVBJMTSABCDEFGHIJKLMNULVAVEVFHDVAVGVKURVEVFRVIVLVJBEGCIJMTSUMUN
      $.

    $( Version of modular law that holds in a Hilbert lattice, when one element
       is an atom.  (Contributed by NM, 10-Jun-2012.)  (Revised by Mario
       Carneiro, 10-May-2013.) $)
    atmod4i1 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ P .<_ Y )
         -> ( ( X ./\ Y ) .\/ P ) = ( ( X .\/ P ) ./\ Y ) ) $=
      ( wcel w3a co wceq syl3anc latjcom chlt clat hllat 3ad2ant1 simp22 simp23
      wbr latmcl simp21 atbase syl atmod1i1 oveq1d 3eqtrd ) EUAOZCAOZHBOZIBOZPZ
      CIFUGZPZHIGQZCDQZCVBDQZCHDQZIGQHCDQZIGQVAEUBOZVBBOZCBOZVCVDRUOUSVGUTEUCUD
      ZVAVGUQURVHVJUOUPUQURUTUEZUOUPUQURUTUFBEGHIJMUHSVAUPVIUOUPUQURUTUIABCEJNU
      JUKZBDEVBCJLTSABCDEFGHIJKLMNULVAVEVFIGVAVGVIUQVEVFRVJVLVKBDECHJLTSUMUN $.

    $( Version of modular law that holds in a Hilbert lattice, when one element
       is an atom.  (Contributed by NM, 4-Jun-2012.)  (Revised by Mario
       Carneiro, 10-Mar-2013.) $)
    atmod4i2 $p |- ( ( K e. HL /\ ( P e. A /\ X e. B /\ Y e. B ) /\ X .<_ Y )
         -> ( ( P ./\ Y ) .\/ X ) = ( ( P .\/ X ) ./\ Y ) ) $=
      ( wcel w3a co wceq syl3anc latjcom chlt clat hllat 3ad2ant1 simp21 atbase
      wbr syl simp23 latmcl simp22 atmod1i2 oveq1d 3eqtrd ) EUAOZCAOZHBOZIBOZPZ
      HIFUGZPZCIGQZHDQZHVBDQZHCDQZIGQCHDQZIGQVAEUBOZVBBOZUQVCVDRUOUSVGUTEUCUDZV
      AVGCBOZURVHVIVAUPVJUOUPUQURUTUEABCEJNUFUHZUOUPUQURUTUIBEGCIJMUJSUOUPUQURU
      TUKZBDEVBHJLTSABCDEFGHIJKLMNULVAVEVFIGVAVGUQVJVEVFRVIVLVKBDEHCJLTSUMUN $.
  $}

  ${
    llnexch.l $e |- .<_ = ( le ` K ) $.
    llnexch.j $e |- .\/ = ( join ` K ) $.
    llnexch.m $e |- ./\ = ( meet ` K ) $.
    llnexch.a $e |- A = ( Atoms ` K ) $.
    llnexch.n $e |- N = ( LLines ` K ) $.
    $( Lemma for ~ llnexchb2 .  (Contributed by NM, 17-Nov-2012.) $)
    llnexchb2lem $p |- ( ( ( K e. HL /\ X e. N /\ Y e. N ) /\
       ( P e. A /\ Q e. A /\ -. P .<_ X ) /\ ( X ./\ Y ) e. A )
           -> ( ( X ./\ Y ) .<_ ( P .\/ Q )
             <-> ( X ./\ Y ) = ( X ./\ ( P .\/ Q ) ) ) ) $=
      ( wcel co wceq syl syl3anc chlt w3a wbr wn wa cp0 cfv cbs simpl11 simpl21
      simpl12 eqid llnbase clat hllat simpl13 latmcl latmle1 atmod2i2 syl131anc
      atbase latmcom simpl23 cal hlatl atnle mpbid eqtrd oveq1d simpr clc hlcvl
      wb wne simpl3 simpl22 breq1 syl5ibrcom necon3bd necomd cvlatexchb1 oveq2d
      mpd 3eqtr3rd col hlol olj02 syl2anc eqtr2d ex simp11 simp12 simp21 simp22
      hlatjcl latmle2 impbid ) EUAPZIHPZJHPZUBZBAPZCAPZBIFUCZUDZUBZIJGQZAPZUBZX
      GBCDQZFUCZXGIXJGQZRZXIXKXMXIXKUEZXLEUFUGZXGDQZXGXNIBGQZXGDQZIBXGDQZGQZXPX
      LXNWRXBIEUHUGZPZXGYAPZXGIFUCZXRXTRWRWSWTXFXHXKUIZXBXCXEXAXHXKUJZXNWSYBWRW
      SWTXFXHXKUKYAEHIYAULZOUMZSZXNEUNPZYBJYAPZYCXNWRYJYEEUOZSZYIXNWTYKWRWSWTXF
      XHXKUPYAEHJYGOUMSZYAEGIJYGMUQTZXNYJYBYKYDYMYIYNYAEFGIJYGKMURTZAYABDEFGIXG
      YGKLMNUSUTXNXQXOXGDXNXQBIGQZXOXNYJYBBYAPZXQYQRYMYIXNXBYRYFAYABEYGNVASYAEG
      IBYGMVBTXNXEYQXORZXBXCXEXAXHXKVCZXNEVDPZXBYBXEYSVMXNWRUUAYEEVESYFYIAYABEF
      GIXOYGKMXOULZNVFTVGVHVIXNXSXJIGXNXKXSXJRZXIXKVJXNEVKPZXHXCXBXGBVNXKUUCVMX
      NWRUUDYEEVLSXAXFXHXKVOXBXCXEXAXHXKVPYFXNBXGXNXEBXGVNYTXNXDBXGXNXDBXGRYDYP
      BXGIFVQVRVSWCVTAXGCBDEFKLNWAUTVGWBWDXNEWEPZYCXPXGRXNWRUUEYEEWFSYOYADEXGXO
      YGLUUBWGWHWIWJXIXKXMXLXJFUCZXIYJYBXJYAPZUUFXIWRYJWRWSWTXFXHWKZYLSXIWSYBWR
      WSWTXFXHWLYHSXIWRXBXCUUGUUHXAXBXCXEXHWMXAXBXCXEXHWNAYADEBCYGLNWOTYAEFGIXJ
      YGKMWPTXGXLXJFVQVRWQ $.

    $d p q A $.  $d p q K $.  $d p q .<_ $.  $d p q ./\ $.  $d p q N $.
    $d p q X $.  $d p q Y $.  $d p q Z $.
    $( Line exchange property (compare ~ cvlatexchb2 for atoms).  (Contributed
       by NM, 17-Nov-2012.) $)
    llnexchb2 $p |- ( ( K e. HL /\ ( X e. N /\ Y e. N /\ Z e. N )
       /\ ( ( X ./\ Y ) e. A /\ X =/= Z ) )
           -> ( ( X ./\ Y ) .<_ Z <-> ( X ./\ Y ) = ( X ./\ Z ) ) ) $=
      ( wcel co wa wceq wbr wb vp vq chlt w3a wne cv wrex simp23 cbs simp1 eqid
      cfv llnbase islln3 syl2anc mpbid simp3r necomd wi wn wo clat simp11 hllat
      syl simp2l atbase simp2r simp121 latjle12 syl13anc simp3 syl31anc syl3anc
      llni2 llncmp bitr2d necon3abid ianor syl6bb simpl11 simp122 simpl2l simpr
      adantr simpl2r simp13l llnexchb2lem hlatjcom breq2d oveq2d eqeq2d 3bitr4d
      syl331anc ex jaod neeq1 breq2 oveq2 bibi12d imbi12d syl5ibrcom 3exp imp4a
      sylbid rexlimdvv mp2d ) CUCOZGFOZHFOZIFOZUDZGHEPZAOZGIUEZQZUDZUAUFZUBUFZU
      EZIXRXSBPZRZQZUBAUGUAAUGZIGUEZXMIDSZXMGIEPZRZTZXQXKYDXHXIXJXKXPUHZXQXHICU
      IULZOZXKYDTXHXLXPUJXQXKYLYJYKCFIYKUKZNUMVEAYKBCFIUBUAYMKMNUNUOUPXQGIXHXLX
      NXOUQURXQYCYEYIUSZUAUBAAXQXRAOZXSAOZQZXTYBYNXQYQXTYBYNUSXQYQXTUDZYNYBYAGU
      EZXMYADSZXMGYAEPZRZTZUSYRYSXRGDSZUTZXSGDSZUTZVAZUUCYRYSUUDUUFQZUTUUHYRUUI
      YAGYRUUIYAGDSZYAGRZYRCVBOZXRYKOZXSYKOZGYKOZUUIUUJTYRXHUULXHXLXPYQXTVCZCVD
      VEYRYOUUMXQYOYPXTVFZAYKXRCYMMVGVEYRYPUUNXQYOYPXTVHZAYKXSCYMMVGVEYRXIUUOXI
      XJXKXHXPYQXTVIZYKCFGYMNUMVEYKBCDXRXSGYMJKVJVKYRXHYAFOZXIUUJUUKTUUPYRXHYOY
      PXTUUTUUPUUQUURXQYQXTVLAXRXSBCFKMNVOVMUUSCDFYAGJNVPVNVQVRUUDUUFVSVTYRUUEU
      UCUUGYRUUEUUCYRUUEQXHXIXJYOYPUUEXNUUCXHXLXPYQXTUUEWAYRXIUUEUUSWEYRXJUUEXI
      XJXKXHXPYQXTWBZWEYOYPXQXTUUEWCYOYPXQXTUUEWFYRUUEWDYRXNUUEXNXOXHXLYQXTWGZW
      EAXRXSBCDEFGHJKLMNWHWNWOYRUUGUUCYRUUGQZXMXSXRBPZDSZXMGUVDEPZRZYTUUBUVCXHX
      IXJYPYOUUGXNUVEUVGTXHXLXPYQXTUUGWAZYRXIUUGUUSWEYRXJUUGUVAWEYOYPXQXTUUGWFZ
      YOYPXQXTUUGWCZYRUUGWDYRXNUUGUVBWEAXSXRBCDEFGHJKLMNWHWNUVCYAUVDXMDUVCXHYOY
      PYAUVDRUVHUVJUVIABCXRXSKMWIVNZWJUVCUUAUVFXMUVCYAUVDGEUVKWKWLWMWOWPXEYBYEY
      SYIUUCIYAGWQYBYFYTYHUUBIYAXMDWRYBYGUUAXMIYAGEWSWLWTXAXBXCXDXFXG $.

    $( Line exchange property (compare ~ cvlatexch2 for atoms).  (Contributed
       by NM, 18-Nov-2012.)  (New usage is discouraged.) $)
    llnexch2N $p |- ( ( K e. HL /\ ( X e. N /\ Y e. N /\ Z e. N )
       /\ ( ( X ./\ Y ) e. A /\ X =/= Z ) )
           -> ( ( X ./\ Y ) .<_ Z -> ( X ./\ Z ) .<_ Y ) ) $=
      ( wcel w3a co wbr llnbase syl chlt wne wa wceq llnexchb2 cbs cfv 3ad2ant1
      clat hllat simp21 eqid simp22 latmle2 syl3anc breq1 syl5ibcom sylbid ) CU
      AOZGFOZHFOZIFOZPZGHEQZAOGIUBUCZPZVDIDRVDGIEQZUDZVGHDRZABCDEFGHIJKLMNUEVFV
      DHDRZVHVIVFCUIOZGCUFUGZOZHVLOZVJUSVCVKVECUJUHVFUTVMUSUTVAVBVEUKVLCFGVLULZ
      NSTVFVAVNUSUTVAVBVEUMVLCFHVONSTVLCDEGHVOJLUNUOVDVGHDUPUQUR $.
  $}

  ${
    dalawlem.l $e |- .<_ = ( le ` K ) $.
    dalawlem.j $e |- .\/ = ( join ` K ) $.
    dalawlem.m $e |- ./\ = ( meet ` K ) $.
    dalawlem.a $e |- A = ( Atoms ` K ) $.
    ${
      dalawlem.o $e |- O = ( LPlanes ` K ) $.
      $( Lemma for ~ dalaw .  Special case of ~ dath2 , where ` C ` is replaced
         by ` ( ( P .\/ S ) ./\ ( Q .\/ T ) ) ` .  The remaining lemmas will
         eliminate the conditions on the atoms imposed by ~ dath2 .
         (Contributed by NM, 6-Oct-2012.) $)
      dalawlem1 $p |- ( ( ( K e. HL
           /\ ( P e. A /\ Q e. A /\ R e. A )
         /\ ( S e. A /\ T e. A /\ U e. A ) )
      /\ ( ( ( P .\/ Q ) .\/ R ) e. O /\ ( ( S .\/ T ) .\/ U ) e. O )
      /\ ( ( -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( P .\/ Q )
             /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( Q .\/ R )
             /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ P ) )
         /\ ( -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( S .\/ T )
             /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( T .\/ U )
             /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( U .\/ S ) )
         /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) ) )
           -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                     .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
        ( wcel co wbr chlt w3a wa cbs cfv simp11 clat hllat syl simp121 simp131
        wn eqid hlatjcl syl3anc simp122 simp132 latmcl jca simp12 simp13 simp2l
        simp2r simp31 simp32 latmle1 latmle2 simp33 3jca dath2 syl323anc ) IUAR
        ZBARZCARZDARZUBZEARZFARZGARZUBZUBZBCHSZDHSLRZEFHSZGHSLRZUCZBEHSZCFHSZKS
        ZWBJTULWICDHSZJTULWIDBHSZJTULUBZWIWDJTULWIFGHSZJTULWIGEHSZJTULUBZWIDGHS
        JTZUBZUBZVLWIIUDUEZRZUCVPVTWCWEWLWOWIWGJTZWIWHJTZWPUBWBWDKSZWJWMKSZWKWN
        KSZHSJTWRVLWTVLVPVTWFWQUFZWRIUGRZWGWSRZWHWSRZWTWRVLXGXFIUHUIZWRVLVMVQXH
        XFVMVNVOVLVTWFWQUJVQVRVSVLVPWFWQUKAWSHIBEWSUMZNPUNUOZWRVLVNVRXIXFVMVNVO
        VLVTWFWQUPVQVRVSVLVPWFWQUQAWSHICFXKNPUNUOZWSIKWGWHXKOURUOUSVLVPVTWFWQUT
        VLVPVTWFWQVAWAWCWEWQVBWAWCWEWQVCWAWFWLWOWPVDWAWFWLWOWPVEWRXAXBWPWRXGXHX
        IXAXJXLXMWSIJKWGWHXKMOVFUOWRXGXHXIXBXJXLXMWSIJKWGWHXKMOVGUOWAWFWLWOWPVH
        VIAWSWIXCBCDEFGXDXEHIJKLXKMNPOQXCUMXDUMXEUMVJVK $.
    $}

    $( Lemma for ~ dalaw .  Utility lemma that breaks
       ` ( ( P .\/ Q ) ./\ ( S .\/ T ) ) ` into a join of two pieces.
       (Contributed by NM, 6-Oct-2012.) $)
    dalawlem2 $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A )
         /\ ( S e. A /\ T e. A ) )
     -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
             .<_ ( ( ( ( P .\/ Q ) .\/ T ) ./\ S )
                 .\/ ( ( ( P .\/ Q ) .\/ S ) ./\ T ) ) ) $=
      ( wcel wa co wbr syl syl3anc syl13anc chlt w3a cbs cfv simp1 hllat simp2l
      clat simp2r hlatjcl simp3r atbase latlej1 simp3l latjcl latlem12 mpbi2and
      eqid latmcl latmlem1 mpd wceq latlej2 atmod3i1 syl131anc oveq2d latmlej22
      wb wi atmod2i2 col hlol latmassOLD 3eqtr4rd breqtrd ) GUANZBANZCANZOZDANZ
      EANZOZUBZBCFPZDEFPZIPZWDEFPZWDDFPZIPZWEIPZWGDIPWHEIPZFPZHWCWDWIHQZWFWJHQZ
      WCWDWGHQZWDWHHQZWMWCGUHNZWDGUCUDZNZEWRNZWOWCVPWQVPVSWBUEZGUFRZWCVPVQVRWSX
      AVPVQVRWBUGVPVQVRWBUIAWRFGBCWRURZKMUJSZWCWAWTVPVSVTWAUKZAWREGXCMULRZWRFGH
      WDEXCJKUMSWCWQWSDWRNZWPXBXDWCVTXGVPVSVTWAUNZAWRDGXCMULRZWRFGHWDDXCJKUMSWC
      WQWSWGWRNZWHWRNZWOWPOWMVHXBXDWCWQWSWTXJXBXDXFWRFGWDEXCKUOSZWCWQWSXGXKXBXD
      XIWRFGWDDXCKUOSZWRGHIWDWGWHXCJLUPTUQWCWQWSWIWRNZWEWRNZWMWNVIXBXDWCWQXJXKX
      NXBXLXMWRGIWGWHXCLUSSWCVPVTWAXOXAXHXEAWRFGDEXCKMUJSZWRGHIWDWIWEXCJLUTTVAW
      CWGDWKFPZIPZWGWHWEIPZIPZWLWJWCXQXSWGIWCVPVTXKWTDWHHQZXQXSVBXAXHXMXFWCWQWS
      XGYAXBXDXIWRFGHWDDXCJKVCSAWRDFGHIWHEXCJKLMVDVEVFWCVPVTXJWKWRNZWKWGHQZWLXR
      VBXAXHXLWCWQXKWTYBXBXMXFWRGIWHEXCLUSSWCWQWTXKWSYCXBXFXMXDWRFGHIEWHWDXCJKL
      VGTAWRDFGHIWGWKXCJKLMVJVEWCGVKNZXJXKXOWJXTVBWCVPYDXAGVLRXLXMXPWRGIWGWHWEX
      CLVMTVNVO $.

    $( Lemma for ~ dalaw .  First piece of ~ dalawlem5 .  (Contributed by NM,
       4-Oct-2012.) $)
    dalawlem3 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
               .<_ ( P .\/ Q )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( ( Q .\/ T ) .\/ P ) ./\ S )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                   .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr syl3anc syl13anc chlt w3a cbs eqid clat simp11 hllat simp22
      cfv syl simp32 simp21 atbase latjcl simp31 latmcl simp23 simp33 latmlej22
      hlatjcl latjass breqtrd hlatlej2 latmlem2 mpd hlatlej1 atmod4i1 syl131anc
      wceq wi breqtrrd latmcom simp12 eqbrtrd latjle12 mpbi2and lattrd latlem12
      wa wb atmod3i1 latmlej12 atmod1i1m syl231anc 3eqtr3rd latmlem12 syl122anc
      oveq2d latj12 simp13 latmle2 atmod2i2 atmod3i2 3brtr4d latjlej2 latmlej21
      mp2and latj13 latjlej1 ) IUAPZBEHQZCFHQZKQZBCHQZJRZXCDGHQZJRZUBZBAPZCAPZD
      APZUBZEAPZFAPZGAPZUBZUBZIUCUIZIJXBBHQZEKQZCDHQZGKQZDBHQZGEHQZKQZHQZYAFGHQ
      ZKQZYEHQZXRUDZLXQWTIUEPZWTXEXGXLXPUFZIUGUJZXQYKXSXRPZEXRPZXTXRPZYMXQYKXBX
      RPZBXRPZYNYMXQWTXJXNYQYLXHXIXJXKXPUHZXHXLXMXNXOUKZAXRHICFYJMOUTSZXQXIYRXH
      XIXJXKXPULZAXRBIYJOUMUJZXRHIXBBYJMUNSZXQXMYOXHXLXMXNXOUOZAXREIYJOUMUJZXRI
      KXSEYJNUPSZXQYKYBXRPZYEXRPZYFXRPYMXQYKYAXRPZGXRPZUUHYMXQWTXJXKUUJYLYSXHXI
      XJXKXPUQZAXRHICDYJMOUTSZXQXOUUKXHXLXMXNXOURZAXRGIYJOUMUJZXRIKYAGYJNUPSZXQ
      YKYCXRPZYDXRPZUUIYMXQWTXKXIUUQYLUULUUBAXRHIDBYJMOUTSZXQWTXOXMUURYLUUNUUEA
      XRHIGEYJMOUTSZXRIKYCYDYJNUPSZXRHIYBYEYJMUNSXQYKYHXRPZUUIYIXRPYMXQYKUUJYGX
      RPZUVBYMUUMXQWTXNXOUVCYLYTUUNAXRHIFGYJMOUTSZXRIKYAYGYJNUPSZUVAXRHIYHYEYJM
      UNSXQXTYBYCHQZYDKQZYFJXQXTUVFJRZXTYDJRZXTUVGJRZXQXTBDYBHQZHQZUVFJXQXRIJXT
      BCGKQZXACKQZHQZHQZUVLYJLYMUUGXQYKYRUVOXRPZUVPXRPYMUUCXQYKUVMXRPZUVNXRPZUV
      QYMXQYKCXRPZUUKUVRYMXQXJUVTYSAXRCIYJOUMUJZUUOXRIKCGYJNUPSZXQYKXAXRPZUVTUV
      SYMXQWTXIXMUWCYLUUBUUEAXRHIBEYJMOUTSZUWAXRIKXACYJNUPSZXRHIUVMUVNYJMUNSZXR
      HIBUVOYJMUNSXQYKYRUVKXRPZUVLXRPYMUUCXQYKDXRPZUUHUWGYMXQXKUWHUULAXRDIYJOUM
      UJZUUPXRHIDYBYJMUNSZXRHIBUVKYJMUNSXQXTUVMXAHQZXDKQZUVPJXQXTUWKJRZXTXDJRZX
      TUWLJRZXQXTUVMBHQZEHQZUWKJXQYKYOYNUWPXRPZXTUWQJRYMUUFUUDXQYKUVRYRUWRYMUWB
      UUCXRHIUVMBYJMUNSXRHIJKEXSUWPYJLMNUSTXQYKUVRYRYOUWQUWKVIYMUWBUUCUUFXRHIUV
      MBEYJMVATVBXQXRIJXTXBXAKQZBHQZXDYJLYMUUGXQYKUWSXRPZYRUWTXRPYMXQYKYQUWCUXA
      YMUUAUWDXRIKXBXAYJNUPSZUUCXRHIUWSBYJMUNSXQWTXIXJXDXRPZYLUUBYSAXRHIBCYJMOU
      TSZXQXTXSXAKQZUWTJXQEXAJRZXTUXEJRZXQWTXIXMUXFYLUUBUUEABEHIJLMOVCSXQYKYOUW
      CYNUXFUXGVJYMUUFUWDUUDXRIJKEXAXSYJLNVDTVEXQWTXIYQUWCBXAJRZUWTUXEVIYLUUBUU
      AUWDXQWTXIXMUXHYLUUBUUEABEHIJLMOVFSZAXRBHIJKXBXAYJLMNOVGVHVKXQUWSXDJRZBXD
      JRZUWTXDJRZXQUWSXCXDJXQYKYQUWCUWSXCVIYMUUAUWDXRIKXBXAYJNVLSWTXEXGXLXPVMVN
      XQWTXIXJUXKYLUUBYSABCHIJLMOVFSXQYKUXAYRUXCUXJUXKVSUXLVTYMUXBUUCUXDXRHIJUW
      SBXDYJLMVOTVPVQXQYKYPUWKXRPZUXCUWMUWNVSUWOVTYMUUGXQYKUVRUWCUXMYMUWBUWDXRH
      IUVMXAYJMUNSUXDXRIJKXTUWKXDYJLNVRTVPXQUVMBUVNHQZHQZUVMXAXDKQZHQZUVPUWLXQU
      XNUXPUVMHXQWTXIUWCUVTUXHUXNUXPVIYLUUBUWDUWAUXIAXRBHIJKXACYJLMNOWAVHWHXQYK
      UVRYRUVSUXOUVPVIYMUWBUUCUWEXRHIUVMBUVNYJMWITXQWTXOUVTUWCUXCUVMXDJRZUXQUWL
      VIYLUUNUWAUWDUXDXQYKUVTUUKYRUXRYMUWAUUOUUCXRHIJKCGBYJLMNWBTAXRGHIJKCXAXDY
      JLMNOWCWDWEVBXQUVOUVKJRZUVPUVLJRZXQCGUVNHQZKQZYAXFKQZUVOUVKJXQCYAJRZUYAXF
      JRZUYBUYCJRZXQWTXJXKUYDYLYSUULACDHIJLMOVFSXQGXFJRZUVNXFJRZUYEXQWTXKXOUYGY
      LUULUUNADGHIJLMOVCSXQXRIJUVNXCXFYJLYMUWEXQYKUWCYQXCXRPYMUWDUUAXRIKXAXBYJN
      UPSXQWTXKXOXFXRPZYLUULUUNAXRHIDGYJMOUTSZXQCXBJRZUVNXCJRZXQWTXJXNUYKYLYSYT
      ACFHIJLMOVFSXQYKUVTYQUWCUYKUYLVJYMUWAUUAUWDXRIJKCXBXAYJLNVDTVEWTXEXGXLXPW
      JVQXQYKUUKUVSUYIUYGUYHVSUYEVTYMUUOUWEUYJXRHIJGUVNXFYJLMVOTVPXQYKUVTUUJUYA
      XRPZUYIUYDUYEVSUYFVJYMUWAUUMXQYKUUKUVSUYMYMUUOUWEXRHIGUVNYJMUNSUYJXRIJKXF
      CYAUYAYJLNWFWGWQXQWTXOUVTUVSUVNCJRZUVOUYBVIYLUUNUWAUWEXQYKUWCUVTUYNYMUWDU
      WAXRIJKXACYJLNWKSAXRGHIJKCUVNYJLMNOWLVHXQWTXOUWHUUJDYAJRZUVKUYCVIYLUUNUWI
      UUMXQWTXJXKUYOYLYSUULACDHIJLMOVCSAXRGHIJKDYAYJLMNOWMVHWNXQYKUVQUWGYRUXSUX
      TVJYMUWFUWJUUCXRHIJUVOUVKBYJLMWOTVEVQXQYKYRUWHUUHUVLUVFVIYMUUCUWIUUPXRHIB
      DYBYJMWRTVBXQYKYOYNUUKUVIYMUUFUUDUUOXRHIJKEXSGYJLMNUSTXQYKYPUVFXRPZUURUVH
      UVIVSUVJVTYMUUGXQYKUUHUUQUYPYMUUPUUSXRHIYBYCYJMUNSUUTXRIJKXTUVFYDYJLNVRTV
      PXQWTXOUUJUUQUURYBYDJRZYFUVGVIYLUUNUUMUUSUUTXQYKUUKUUJYOUYQYMUUOUUMUUFXRH
      IJKGYAEYJLMNWPTAXRGHIJKYAYCYDYJLMNOWCWDVKXQYBYHJRZYFYIJRZXQGYGJRZUYRXQWTX
      NXOUYTYLYTUUNAFGHIJLMOVCSXQYKUUKUVCUUJUYTUYRVJYMUUOUVDUUMXRIJKGYGYAYJLNVD
      TVEXQYKUUHUVBUUIUYRUYSVJYMUUPUVEUVAXRHIJYBYHYEYJLMWSTVEVQ $.

    $( Lemma for ~ dalaw .  Second piece of ~ dalawlem5 .  (Contributed by NM,
       4-Oct-2012.) $)
    dalawlem4 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
                .<_ ( P .\/ Q )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( ( P .\/ S ) .\/ Q ) ./\ T )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                    .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wceq hlatjcl syl3anc chlt wbr w3a simp11 clat cbs cfv hllat syl
      simp12 simp22 simp32 simp21 simp31 latmcom hlatjcom 3brtr4d simp13 simp23
      eqbrtrd simp33 dalawlem3 syl333anc oveq12d latmcl latjcom eqtrd breqtrd
      eqid ) IUAPZBEHQZCFHQZKQZBCHQZJUBZVMDGHQZJUBZUCZBAPZCAPZDAPZUCZEAPZFAPZGA
      PZUCZUCZVKCHQFKQZBDHQZEGHQZKQZDCHQZGFHQZKQZHQZCDHQZFGHQZKQZDBHQZGEHQZKQZH
      QZJWGVJVLVKKQZCBHQZJUBXCVPJUBVTVSWAWDWCWEWHWOJUBVJVOVQWBWFUDZWGVMVNXCXDJV
      JVOVQWBWFUJWGIUEPZVLIUFUGZPZVKXGPZXCVMRWGVJXFXEIUHUIZWGVJVTWDXHXEVRVSVTWA
      WFUKZVRWBWCWDWEULZAXGHICFXGVIZMOSTWGVJVSWCXIXEVRVSVTWAWFUMZVRWBWCWDWEUNZA
      XGHIBEXMMOSTXGIKVLVKXMNUOTZWGVJVTVSXDVNRXEXKXNAHICBMOUPTUQWGXCVMVPJXPVJVO
      VQWBWFURUTXKXNVRVSVTWAWFUSZXLXOVRWBWCWDWEVAZACBDFEGHIJKLMNOVBVCWGWOXAWRHQ
      ZXBWGWKXAWNWRHWGWIWSWJWTKWGVJVSWAWIWSRXEXNXQAHIBDMOUPTWGVJWCWEWJWTRXEXOXR
      AHIEGMOUPTVDWGWLWPWMWQKWGVJWAVTWLWPRXEXQXKAHIDCMOUPTWGVJWEWDWMWQRXEXRXLAH
      IGFMOUPTVDVDWGXFXAXGPZWRXGPZXSXBRXJWGXFWSXGPZWTXGPZXTXJWGVJWAVSYBXEXQXNAX
      GHIDBXMMOSTWGVJWEWCYCXEXRXOAXGHIGEXMMOSTXGIKWSWTXMNVETWGXFWPXGPZWQXGPZYAX
      JWGVJVTWAYDXEXKXQAXGHICDXMMOSTWGVJWDWEYEXEXLXRAXGHIFGXMMOSTXGIKWPWQXMNVET
      XGHIXAWRXMMVFTVGVH $.

    $( Lemma for ~ dalaw .  Special case to eliminate the requirement
       ` -. ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( P .\/ Q ) ` in ~ dalawlem1 .
       (Contributed by NM, 4-Oct-2012.) $)
    dalawlem5 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
              .<_ ( P .\/ Q )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                    .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr hlatjcl syl3anc chlt w3a cbs cfv eqid clat simp11 hllat syl
      simp21 simp22 simp31 simp32 latmcl atbase latjcl dalawlem2 syl122anc wceq
      simp23 simp33 hlatjcom hlatj32 syl13anc eqtrd dalawlem3 eqbrtrd dalawlem4
      oveq1d wa wb latjle12 mpbi2and lattrd ) IUAPZBEHQZCFHQZKQZBCHQZJRZVRDGHQJ
      RZUBZBAPZCAPZDAPZUBZEAPZFAPZGAPZUBZUBZIUCUDZIJVSEFHQZKQZVSFHQZEKQZVSEHQZF
      KQZHQZCDHQZFGHQZKQZDBHQZGEHQZKQZHQZWLUEZLWKVOIUFPZVOVTWAWFWJUGZIUHUIZWKXH
      VSWLPZWMWLPZWNWLPXJWKVOWCWDXKXIWBWCWDWEWJUJZWBWCWDWEWJUKZAWLHIBCXGMOSTZWK
      VOWGWHXLXIWBWFWGWHWIULZWBWFWGWHWIUMZAWLHIEFXGMOSTWLIKVSWMXGNUNTWKXHWPWLPZ
      WRWLPZWSWLPXJWKXHWOWLPZEWLPZXRXJWKXHXKFWLPZXTXJXOWKWHYBXQAWLFIXGOUOUIZWLH
      IVSFXGMUPTWKWGYAXPAWLEIXGOUOUIZWLIKWOEXGNUNTZWKXHWQWLPZYBXSXJWKXHXKYAYFXJ
      XOYDWLHIVSEXGMUPTYCWLIKWQFXGNUNTZWLHIWPWRXGMUPTWKXHXBWLPZXEWLPZXFWLPZXJWK
      XHWTWLPZXAWLPZYHXJWKVOWDWEYKXIXNWBWCWDWEWJUTZAWLHICDXGMOSTWKVOWHWIYLXIXQW
      BWFWGWHWIVAZAWLHIFGXGMOSTWLIKWTXAXGNUNTWKXHXCWLPZXDWLPZYIXJWKVOWEWCYOXIYM
      XMAWLHIDBXGMOSTWKVOWIWGYPXIYNXPAWLHIGEXGMOSTWLIKXCXDXGNUNTWLHIXBXEXGMUPTZ
      WKVOWCWDWGWHWNWSJRXIXMXNXPXQABCEFHIJKLMNOUQURWKWPXFJRZWRXFJRZWSXFJRZWKWPV
      QBHQZEKQXFJWKWOUUAEKWKWOCBHQZFHQZUUAWKVSUUBFHWKVOWCWDVSUUBUSXIXMXNAHIBCMO
      VBTVIWKVOWDWCWHUUCUUAUSXIXNXMXQACBFHIMOVCVDVEVIABCDEFGHIJKLMNOVFVGWKWRVPC
      HQZFKQXFJWKWQUUDFKWKVOWCWDWGWQUUDUSXIXMXNXPABCEHIMOVCVDVIABCDEFGHIJKLMNOV
      HVGWKXHXRXSYJYRYSVJYTVKXJYEYGYQWLHIJWPWRXFXGLMVLVDVMVN $.

    $( Lemma for ~ dalaw .  First piece of ~ dalawlem8 .  (Contributed by NM,
       6-Oct-2012.) $)
    dalawlem6 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
               .<_ ( Q .\/ R )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( ( P .\/ Q ) .\/ T ) ./\ S )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                    .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr syl3anc syl13anc chlt w3a cbs eqid clat simp11 hllat simp21
      cfv syl simp22 simp32 atbase latjcl simp31 latmcl simp23 simp33 latmlej22
      hlatjcl hlatlej2 latmlem2 mpd hlatjass oveq1d hlatlej1 atmod1i1 syl131anc
      wi wceq 3brtr4d latmcom simp12 eqbrtrd latmle1 latlem12 mpbi2and latjlej2
      wa wb lattrd atmod3i1 breqtrrd simp13 col latm12 latj13 breqtrd latmlej21
      hlol atmod1i1m syl231anc latjlej1 ) IUAPZBEHQZCFHQZKQZCDHQZJRZWQDGHQZJRZU
      BZBAPZCAPZDAPZUBZEAPZFAPZGAPZUBZUBZIUCUIZIJBCHQZFHQZEKQZWRGKQZDBHQZGEHQZK
      QZHQZWRFGHQZKQZXSHQZXLUDZLXKWNIUEPZWNWSXAXFXJUFZIUGUJZXKYEXNXLPZEXLPZXOXL
      PZYGXKYEXMXLPZFXLPZYHYGXKWNXCXDYKYFXBXCXDXEXJUHZXBXCXDXEXJUKZAXLHIBCYDMOU
      TSXKXHYLXBXFXGXHXIULZAXLFIYDOUMUJXLHIXMFYDMUNSZXKXGYIXBXFXGXHXIUOZAXLEIYD
      OUMUJZXLIKXNEYDNUPSZXKYEXPXLPZXSXLPZXTXLPYGXKYEWRXLPZGXLPZYTYGXKWNXDXEUUB
      YFYNXBXCXDXEXJUQZAXLHICDYDMOUTSZXKXIUUCXBXFXGXHXIURZAXLGIYDOUMUJZXLIKWRGY
      DNUPSZXKYEXQXLPZXRXLPZUUAYGXKWNXEXCUUIYFUUDYMAXLHIDBYDMOUTSZXKWNXIXGUUJYF
      UUFYQAXLHIGEYDMOUTSZXLIKXQXRYDNUPSZXLHIXPXSYDMUNSXKYEYBXLPZUUAYCXLPYGXKYE
      UUBYAXLPZUUNYGUUEXKWNXHXIUUOYFYOUUFAXLHIFGYDMOUTSZXLIKWRYAYDNUPSZUUMXLHIY
      BXSYDMUNSXKXOXPXQHQZXRKQZXTJXKXOUURJRZXOXRJRZXOUUSJRZXKXOBDXPHQZHQZUURJXK
      XLIJXOBWOWRWPKQZKQZHQZUVDYDLYGYSXKYEBXLPZUVFXLPZUVGXLPYGXKXCUVHYMAXLBIYDO
      UMUJZXKYEWOXLPZUVEXLPZUVIYGXKWNXCXGUVKYFYMYQAXLHIBEYDMOUTSZXKYEUUBWPXLPZU
      VLYGUUEXKWNXDXHUVNYFYNYOAXLHICFYDMOUTSZXLIKWRWPYDNUPSZXLIKWOUVEYDNUPSZXLH
      IBUVFYDMUNSXKYEUVHUVCXLPZUVDXLPYGUVJXKYEDXLPZYTUVRYGXKXEUVSUUDAXLDIYDOUMU
      JZUUHXLHIDXPYDMUNSZXLHIBUVCYDMUNSXKXOWOBUVEHQZKQZUVGJXKXOWOJRZXOUWBJRZXOU
      WCJRZXKYEYIYHUVHUWDYGYRYPUVJXLHIJKEXNBYDLMNUSTXKXLIJXOBWPWOKQZHQZUWBYDLYG
      YSXKYEUVHUWGXLPZUWHXLPYGUVJXKYEUVNUVKUWIYGUVOUVMXLIKWPWOYDNUPSZXLHIBUWGYD
      MUNSXKYEUVHUVLUWBXLPZYGUVJUVPXLHIBUVEYDMUNSZXKBWPHQZEKQZUWMWOKQZXOUWHJXKE
      WOJRZUWNUWOJRZXKWNXCXGUWPYFYMYQABEHIJLMOVASXKYEYIUVKUWMXLPZUWPUWQVIYGYRUV
      MXKYEUVHUVNUWRYGUVJUVOXLHIBWPYDMUNSXLIJKEWOUWMYDLNVBTVCXKXNUWMEKXKWNXCXDX
      HXNUWMVJYFYMYNYOABCFHIMOVDTVEXKWNXCUVNUVKBWOJRZUWHUWOVJYFYMUVOUVMXKWNXCXG
      UWSYFYMYQABEHIJLMOVFSZAXLBHIJKWPWOYDLMNOVGVHVKXKUWGUVEJRZUWHUWBJRZXKUWGWR
      JRZUWGWPJRZUXAXKUWGWQWRJXKYEUVNUVKUWGWQVJYGUVOUVMXLIKWPWOYDNVLSWNWSXAXFXJ
      VMVNXKYEUVNUVKUXDYGUVOUVMXLIJKWPWOYDLNVOSXKYEUWIUUBUVNUXCUXDVSUXAVTYGUWJU
      UEUVOXLIJKUWGWRWPYDLNVPTVQXKYEUWIUVLUVHUXAUXBVIYGUWJUVPUVJXLHIJUWGUVEBYDL
      MVRTVCWAXKYEYJUVKUWKUWDUWEVSUWFVTYGYSUVMUWLXLIJKXOWOUWBYDLNVPTVQXKWNXCUVK
      UVLUWSUVGUWCVJYFYMUVMUVPUWTAXLBHIJKWOUVEYDLMNOWBVHWCXKUVFUVCJRZUVGUVDJRZX
      KWRWQKQZWRWTKQZUVFUVCJXKXAUXGUXHJRZWNWSXAXFXJWDXKYEWQXLPZWTXLPZUUBXAUXIVI
      YGXKYEUVKUVNUXJYGUVMUVOXLIKWOWPYDNUPSXKWNXEXIUXKYFUUDUUFAXLHIDGYDMOUTSUUE
      XLIJKWQWTWRYDLNVBTVCXKIWEPZUVKUUBUVNUVFUXGVJXKWNUXLYFIWJUJUVMUUEUVOXLIKWO
      WRWPYDNWFTXKWNXEUUBUUCDWRJRZUVCUXHVJYFUUDUUEUUGXKWNXDXEUXMYFYNUUDACDHIJLM
      OVASAXLDHIJKWRGYDLMNOWBVHVKXKYEUVIUVRUVHUXEUXFVIYGUVQUWAUVJXLHIJUVFUVCBYD
      LMVRTVCWAXKYEUVHUVSYTUVDUURVJYGUVJUVTUUHXLHIBDXPYDMWGTWHXKYEYIYHUUCUVAYGY
      RYPUUGXLHIJKEXNGYDLMNUSTXKYEYJUURXLPZUUJUUTUVAVSUVBVTYGYSXKYEYTUUIUXNYGUU
      HUUKXLHIXPXQYDMUNSUULXLIJKXOUURXRYDLNVPTVQXKWNXIUUBUUIUUJXPXRJRZXTUUSVJYF
      UUFUUEUUKUULXKYEUUCUUBYIUXOYGUUGUUEYRXLHIJKGWREYDLMNWITAXLGHIJKWRXQXRYDLM
      NOWKWLWCXKXPYBJRZXTYCJRZXKGYAJRZUXPXKWNXHXIUXRYFYOUUFAFGHIJLMOVASXKYEUUCU
      UOUUBUXRUXPVIYGUUGUUPUUEXLIJKGYAWRYDLNVBTVCXKYEYTUUNUUAUXPUXQVIYGUUHUUQUU
      MXLHIJXPYBXSYDLMWMTVCWA $.

    $( Lemma for ~ dalaw .  Second piece of ~ dalawlem8 .  (Contributed by NM,
       6-Oct-2012.) $)
    dalawlem7 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
                 .<_ ( Q .\/ R )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( ( P .\/ Q ) .\/ S ) ./\ T )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                     .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr hlatjcl syl3anc chlt w3a cbs cfv eqid clat simp11 hllat syl
      simp21 simp22 simp31 atbase latjcl simp32 latmcl simp23 simp33 latmassOLD
      col wceq hlol syl13anc hlatj32 hlatlej2 wb latleeqm2 mpbid oveq12d eqtr2d
      simp12 wi latjlej1 mpd hlatlej1 atmod4i1 syl131anc latjidm syl2anc oveq1d
      eqtrd 3brtr3d wa latmlem12 syl122anc mp2and eqbrtrd latlej1 lattrd ) IUAP
      ZBEHQZCFHQZKQZCDHQZJRZWMDGHQJRZUBZBAPZCAPZDAPZUBZEAPZFAPZGAPZUBZUBZIUCUDZ
      IJBCHQZEHQZFKQZWNFGHQZKQZXLDBHQZGEHQZKQZHQZXGUEZLXFWJIUFPZWJWOWPXAXEUGZIU
      HUIZXFXRXIXGPZFXGPZXJXGPXTXFXRXHXGPZEXGPZYAXTXFWJWRWSYCXSWQWRWSWTXEUJZWQW
      RWSWTXEUKZAXGHIBCXQMOSTXFXBYDWQXAXBXCXDULZAXGEIXQOUMUIXGHIXHEXQMUNTXFXCYB
      WQXAXBXCXDUOZAXGFIXQOUMUIZXGIKXIFXQNUPTXFXRWNXGPZXKXGPZXLXGPZXTXFWJWSWTYJ
      XSYFWQWRWSWTXEUQZAXGHICDXQMOSTZXFWJXCXDYKXSYHWQXAXBXCXDURZAXGHIFGXQMOSTZX
      GIKWNXKXQNUPTZXFXRYLXOXGPZXPXGPXTYQXFXRXMXGPZXNXGPZYRXTXFWJWTWRYSXSYMYEAX
      GHIDBXQMOSTXFWJXDXBYTXSYOYGAXGHIGEXQMOSTXGIKXMXNXQNUPTZXGHIXLXOXQMUNTXFXJ
      WKCHQZWLKQZFKQZXLJXFUUDUUBWLFKQZKQZXJXFIUTPZUUBXGPZWLXGPZYBUUDUUFVAXFWJUU
      GXSIVBUIXFXRWKXGPZCXGPZUUHXTXFWJWRXBUUJXSYEYGAXGHIBEXQMOSTZXFWSUUKYFAXGCI
      XQOUMUIZXGHIWKCXQMUNTZXFWJWSXCUUIXSYFYHAXGHICFXQMOSTZYIXGIKUUBWLFXQNUSVCX
      FUUBXIUUEFKXFWJWRXBWSUUBXIVAXSYEYGYFABECHIMOVDVCXFFWLJRZUUEFVAZXFWJWSXCUU
      PXSYFYHACFHIJLMOVETXFXRYBUUIUUPUUQVFXTYIUUOXGIJKFWLXQLNVGTVHVIVJXFUUCWNJR
      ZFXKJRZUUDXLJRZXFWMCHQZWNCHQZUUCWNJXFWOUVAUVBJRZWJWOWPXAXEVKXFXRWMXGPZYJU
      UKWOUVCVLXTXFXRUUJUUIUVDXTUULUUOXGIKWKWLXQNUPTYNUUMXGHIJWMWNCXQLMVMVCVNXF
      WJWSUUJUUICWLJRZUVAUUCVAXSYFUULUUOXFWJWSXCUVEXSYFYHACFHIJLMOVOTAXGCHIJKWK
      WLXQLMNOVPVQXFUVBCCHQZDHQZWNXFWJWSWTWSUVBUVGVAXSYFYMYFACDCHIMOVDVCXFUVFCD
      HXFXRUUKUVFCVAXTUUMXGHICXQMVRVSVTWAWBXFWJXCXDUUSXSYHYOAFGHIJLMOVOTXFXRUUC
      XGPZYJYBYKUURUUSWCUUTVLXTXFXRUUHUUIUVHXTUUNUUOXGIKUUBWLXQNUPTYNYIYPXGIJKX
      KUUCWNFXQLNWDWEWFWGXFXRYLYRXLXPJRXTYQUUAXGHIJXLXOXQLMWHTWI $.

    $( Lemma for ~ dalaw .  Special case to eliminate the requirement
       ` -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( Q .\/ R ) ` in ~ dalawlem1 .
       (Contributed by NM, 6-Oct-2012.) $)
    dalawlem8 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
               .<_ ( Q .\/ R )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                     .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr hlatjcl syl3anc chlt w3a cbs cfv eqid clat simp11 hllat syl
      simp21 simp22 simp31 simp32 dalawlem2 syl122anc dalawlem6 dalawlem7 wa wb
      latmcl atbase latjcl simp23 simp33 latjle12 syl13anc mpbi2and lattrd ) IU
      APZBEHQCFHQKQZCDHQZJRZVJDGHQJRZUBZBAPZCAPZDAPZUBZEAPZFAPZGAPZUBZUBZIUCUDZ
      IJBCHQZEFHQZKQZWEFHQZEKQZWEEHQZFKQZHQZVKFGHQZKQZDBHQZGEHQZKQZHQZWDUEZLWCV
      IIUFPZVIVLVMVRWBUGZIUHUIZWCWTWEWDPZWFWDPZWGWDPXBWCVIVOVPXCXAVNVOVPVQWBUJZ
      VNVOVPVQWBUKZAWDHIBCWSMOSTZWCVIVSVTXDXAVNVRVSVTWAULZVNVRVSVTWAUMZAWDHIEFW
      SMOSTWDIKWEWFWSNUTTWCWTWIWDPZWKWDPZWLWDPXBWCWTWHWDPZEWDPZXJXBWCWTXCFWDPZX
      LXBXGWCVTXNXIAWDFIWSOVAUIZWDHIWEFWSMVBTWCVSXMXHAWDEIWSOVAUIZWDIKWHEWSNUTT
      ZWCWTWJWDPZXNXKXBWCWTXCXMXRXBXGXPWDHIWEEWSMVBTXOWDIKWJFWSNUTTZWDHIWIWKWSM
      VBTWCWTWNWDPZWQWDPZWRWDPZXBWCWTVKWDPZWMWDPZXTXBWCVIVPVQYCXAXFVNVOVPVQWBVC
      ZAWDHICDWSMOSTWCVIVTWAYDXAXIVNVRVSVTWAVDZAWDHIFGWSMOSTWDIKVKWMWSNUTTWCWTW
      OWDPZWPWDPZYAXBWCVIVQVOYGXAYEXEAWDHIDBWSMOSTWCVIWAVSYHXAYFXHAWDHIGEWSMOST
      WDIKWOWPWSNUTTWDHIWNWQWSMVBTZWCVIVOVPVSVTWGWLJRXAXEXFXHXIABCEFHIJKLMNOUNU
      OWCWIWRJRZWKWRJRZWLWRJRZABCDEFGHIJKLMNOUPABCDEFGHIJKLMNOUQWCWTXJXKYBYJYKU
      RYLUSXBXQXSYIWDHIJWIWKWRWSLMVEVFVGVH $.

    $( Lemma for ~ dalaw .  Special case to eliminate the requirement
       ` -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ P ) ` in ~ dalawlem1 .
       (Contributed by NM, 6-Oct-2012.) $)
    dalawlem9 $p |- ( ( ( K e. HL /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) )
              .<_ ( R .\/ P )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                     .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wceq hlatjcl syl3anc chlt wbr w3a simp11 clat cbs cfv hllat syl
      simp22 simp32 simp21 simp31 latmcom simp12 simp23 hlatjcom breqtrd simp13
      eqbrtrd simp33 dalawlem8 syl333anc oveq12d latmcl latjcom eqtrd 3brtr4d
      eqid ) IUAPZBEHQZCFHQZKQZDBHQZJUBZVMDGHQZJUBZUCZBAPZCAPZDAPZUCZEAPZFAPZGA
      PZUCZUCZCBHQZFEHQZKQZBDHQZEGHQZKQZDCHQZGFHQZKQZHQZBCHQZEFHQZKQCDHQZFGHQZK
      QZVNGEHQZKQZHQZJWGVJVLVKKQZWKJUBXFVPJUBVTVSWAWDWCWEWJWQJUBVJVOVQWBWFUDZWG
      XFVMWKJWGIUEPZVLIUFUGZPZVKXIPZXFVMRWGVJXHXGIUHUIZWGVJVTWDXJXGVRVSVTWAWFUJ
      ZVRWBWCWDWEUKZAXIHICFXIVIZMOSTWGVJVSWCXKXGVRVSVTWAWFULZVRWBWCWDWEUMZAXIHI
      BEXOMOSTXIIKVLVKXONUNTZWGVMVNWKJVJVOVQWBWFUOWGVJWAVSVNWKRXGVRVSVTWAWFUPZX
      PAHIDBMOUQTZURUTWGXFVMVPJXRVJVOVQWBWFUSUTXMXPXSXNXQVRWBWCWDWEVAZACBDFEGHI
      JKLMNOVBVCWGWRWHWSWIKWGVJVSVTWRWHRXGXPXMAHIBCMOUQTWGVJWCWDWSWIRXGXQXNAHIE
      FMOUQTVDWGXEXDXBHQZWQWGXHXBXIPZXDXIPZXEYBRXLWGXHWTXIPZXAXIPZYCXLWGVJVTWAY
      EXGXMXSAXIHICDXOMOSTWGVJWDWEYFXGXNYAAXIHIFGXOMOSTXIIKWTXAXONVETWGXHVNXIPZ
      XCXIPZYDXLWGVJWAVSYGXGXSXPAXIHIDBXOMOSTWGVJWEWCYHXGYAXQAXIHIGEXOMOSTXIIKV
      NXCXONVETXIHIXBXDXOMVFTWGXDWMXBWPHWGVNWKXCWLKXTWGVJWEWCXCWLRXGYAXQAHIGEMO
      UQTVDWGWTWNXAWOKWGVJVTWAWTWNRXGXMXSAHICDMOUQTWGVJWDWEXAWORXGXNYAAHIFGMOUQ
      TVDVDVGVH $.

    $( Lemma for ~ dalaw .  Combine ~ dalawlem5 , ~ dalawlem8 , and
       dalawlem9 .  (Contributed by NM, 6-Oct-2012.) $)
    dalawlem10 $p |- ( ( ( K e. HL /\
             -. ( -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( P .\/ Q )
               /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( Q .\/ R )
               /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ P ) )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) ) .\/ ( ( R .\/ P )
                   ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr wn w3a w3o simp11 simp12 3oran sylibr simp13 simp2 simp3 wa
      chlt wi dalawlem5 3expib 3exp dalawlem8 dalawlem9 3jaod 3impib syl311anc
      3imp ) IUJPZBEHQCFHQKQZBCHQZJRZSVBCDHQZJRZSVBDBHQZJRZSTSZVBDGHQJRZTZBAPCA
      PDAPTZEAPFAPGAPTZTZVAVDVFVHUAZVJVLVMVCEFHQKQVEFGHQKQVGGEHQKQHQJRZVAVIVJVL
      VMUBVNVIVOVAVIVJVLVMUCVDVFVHUDUEVAVIVJVLVMUFVKVLVMUGVKVLVMUHVAVOVJTVLVMVP
      VAVOVJVLVMUIVPUKZVAVDVJVQUKVFVHVAVDVJVQVAVDVJTVLVMVPABCDEFGHIJKLMNOULUMUN
      VAVFVJVQVAVFVJTVLVMVPABCDEFGHIJKLMNOUOUMUNVAVHVJVQVAVHVJTVLVMVPABCDEFGHIJ
      KLMNOUPUMUNUQUTURUS $.

    $( Lemma for ~ dalaw .  First part of ~ dalawlem13 .  (Contributed by NM,
       17-Sep-2012.) $)
    dalawlem11 $p |- ( ( ( K e. HL /\ P .<_ ( Q .\/ R )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                    .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wbr syl3anc wceq chlt w3a cbs cfv eqid clat simp11 hllat simp21
      simp22 hlatjcl simp31 simp32 latmcl simp23 latmle1 simp12 atbase latjle12
      syl latlej1 wa wb syl13anc mpbi2and lattrd latjcl simp33 latmlem1 latlej2
      mpd atmod2i2 syl131anc latmcom simp13 latjlej2 atmod1i1 hlatjass hlatjcom
      wi eqbrtrd oveq1d eqtr3d latmlem12 syl122anc mp2and col latmassOLD eqcomd
      3brtr3d latleeqm2 mpbid oveq12d eqtr2d atmod4i1 3brtr4d latjlej1 eqbrtrrd
      hlol latj31 breqtrd latlem12 llnmod2i2 syl321anc breqtrrd ) IUAPZBCDHQZJR
      ZBEHQZCFHQZKQZDGHQZJRZUBZBAPZCAPZDAPZUBZEAPZFAPZGAPZUBZUBZBCHQZEFHQZKQZXG
      FGHQZDBHQZGEHQZKQZHQZKQZXGYGKQYJHQZJYCYFXGJRZYFYKJRZYFYLJRZYCIUCUDZIJYFYD
      XGYQUEZLYCXFIUFPZXFXHXMXRYBUGZIUHUTZYCYSYDYQPZYEYQPZYFYQPZUUAYCXFXOXPUUBY
      TXNXOXPXQYBUIZXNXOXPXQYBUJZAYQHIBCYRMOUKSZYCXFXSXTUUCYTXNXRXSXTYAULZXNXRX
      SXTYAUMZAYQHIEFYRMOUKSZYQIKYDYEYRNUNSZUUGYCXFXPXQXGYQPZYTUUFXNXOXPXQYBUOZ
      AYQHICDYRMOUKSZYCYSUUBUUCYFYDJRUUAUUGUUJYQIJKYDYEYRLNUPSYCXHCXGJRZYDXGJRZ
      XFXHXMXRYBUQZYCYSCYQPZDYQPZUUOUUAYCXPUURUUFAYQCIYROURUTZYCXQUUSUUMAYQDIYR
      OURUTZYQHIJCDYRLMVASYCYSBYQPZUURUULXHUUOVBUUPVCUUAYCXOUVBUUEAYQBIYROURUTZ
      UUTUUNYQHIJBCXGYRLMUSVDVEVFYCYFYJGHQZFHQZYKJYCYQIJYFYDFHQZYEKQZUVEYRLUUAU
      UKYCYSUVFYQPZUUCUVGYQPUUAYCYSUUBFYQPZUVHUUAUUGYCXTUVIUUIAYQFIYROURUTZYQHI
      YDFYRMVGSZUUJYQIKUVFYEYRNUNSYCYSUVDYQPZUVIUVEYQPUUAYCYSYJYQPZGYQPZUVLUUAY
      CYSYHYQPZYIYQPZUVMUUAYCXFXQXOUVOYTUUMUUEAYQHIDBYRMOUKSZYCXFYAXSUVPYTXNXRX
      SXTYAVHZUUHAYQHIGEYRMOUKSZYQIKYHYIYRNUNSZYCYAUVNUVRAYQGIYROURUTZYQHIYJGYR
      MVGSZUVJYQHIUVDFYRMVGSYCYDUVFJRZYFUVGJRZYCYSUUBUVIUWCUUAUUGUVJYQHIJYDFYRL
      MVASYCYSUUBUVHUUCUWCUWDVTUUAUUGUVKUUJYQIJKYDUVFYEYRLNVIVDVKYCUVFEKQZFHQZU
      VGUVEJYCXFXSUVHUVIFUVFJRZUWFUVGTYTUUHUVKUVJYCYSUUBUVIUWGUUAUUGUVJYQHIJYDF
      YRLMVJSAYQEHIJKUVFFYRLMNOVLVMYCUWEUVDJRZUWFUVEJRZYCBXJHQZXIKQZEKQZYHGHQZY
      IKQZUWEUVDJYCUWKUWMJRZEYIJRZUWLUWNJRZYCBXJXIKQZHQZBXLHQZUWKUWMJYCUWRXLJRZ
      UWSUWTJRZYCUWRXKXLJYCYSXJYQPZXIYQPZUWRXKTUUAYCXFXPXTUXCYTUUFUUIAYQHICFYRM
      OUKSZYCXFXOXSUXDYTUUEUUHAYQHIBEYRMOUKSZYQIKXJXIYRNVNSXFXHXMXRYBVOWAYCYSUW
      RYQPZXLYQPZUVBUXAUXBVTUUAYCYSUXCUXDUXGUUAUXEUXFYQIKXJXIYRNUNSYCXFXQYAUXHY
      TUUMUVRAYQHIDGYRMOUKSUVCYQHIJUWRXLBYRLMVPVDVKYCXFXOUXCUXDBXIJRZUWSUWKTYTU
      UEUXEUXFYCYSUVBEYQPZUXIUUAUVCYCXSUXJUUHAYQEIYROURUTZYQHIJBEYRLMVASAYQBHIJ
      KXJXIYRLMNOVQVMYCBDHQZGHQZUWTUWMYCXFXOXQYAUXMUWTTYTUUEUUMUVRABDGHIMOVRVDY
      CUXLYHGHYCXFXOXQUXLYHTYTUUEUUMAHIBDMOVSSWBWCWJYCYSUVNUXJUWPUUAUWAUXKYQHIJ
      GEYRLMVJSYCYSUWKYQPZUWMYQPZUXJUVPUWOUWPVBUWQVTUUAYCYSUWJYQPZUXDUXNUUAYCYS
      UVBUXCUXPUUAUVCUXEYQHIBXJYRMVGSZUXFYQIKUWJXIYRNUNSYCYSUVOUVNUXOUUAUVQUWAY
      QHIYHGYRMVGSUXKUVSYQIJKYIUWKUWMEYRLNWDWEWFYCUWLUWJXIEKQZKQZUWEYCIWGPZUXPU
      XDUXJUWLUXSTYCXFUXTYTIWSUTUXQUXFUXKYQIKUWJXIEYRNWHVDYCUWJUVFUXREKYCUVFUWJ
      YCXFXOXPXTUVFUWJTYTUUEUUFUUIABCFHIMOVRVDWIYCEXIJRZUXRETZYCYSUVBUXJUYAUUAU
      VCUXKYQHIJBEYRLMVJSYCYSUXJUXDUYAUYBVCUUAUXKUXFYQIJKEXIYRLNWKSWLWMWNYCXFYA
      UVOUVPGYIJRZUVDUWNTYTUVRUVQUVSYCYSUVNUXJUYCUUAUWAUXKYQHIJGEYRLMVASAYQGHIJ
      KYHYIYRLMNOWOVMWPYCYSUWEYQPZUVLUVIUWHUWIVTUUAYCYSUVHUXJUYDUUAUVKUXKYQIKUV
      FEYRNUNSUWBUVJYQHIJUWEUVDFYRLMWQVDVKWRVFYCYSUVMUVNUVIUVEYKTUUAUVTUWAUVJYQ
      HIYJGFYRMWTVDXAYCYSUUDUULYKYQPZYNYOVBYPVCUUAUUKUUNYCYSYGYQPZUVMUYEUUAYCXF
      XTYAUYFYTUUIUVRAYQHIFGYRMOUKSUVTYQHIYGYJYRMVGSYQIJKYFXGYKYRLNXBVDVEYCXFUU
      LUVMXTYAYJXGJRYMYLTYTUUNUVTUUIUVRYCYQIJYJYHXGYRLUUAUVTUVQUUNYCYSUVOUVPYJY
      HJRUUAUVQUVSYQIJKYHYIYRLNUPSYCDXGJRZXHYHXGJRZYCYSUURUUSUYGUUAUUTUVAYQHIJC
      DYRLMVJSUUQYCYSUUSUVBUULUYGXHVBUYHVCUUAUVAUVCUUNYQHIJDBXGYRLMUSVDVEVFAYQF
      GHIJKXGYJYRLMNOXCXDXE $.

    $( Lemma for ~ dalaw .  Second part of ~ dalawlem13 .  (Contributed by NM,
       17-Sep-2012.) $)
    dalawlem12 $p |- ( ( ( K e. HL /\ Q = R
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                   .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel wceq co wbr syl3anc chlt w3a cbs cfv eqid clat simp11 hllat simp21
      simp22 hlatjcl simp31 simp32 latmcl atbase latjcl simp33 latlej1 latmlem1
      syl wi syl13anc mpd hlatjcom oveq2d latlej2 atmod2i2 syl131anc latmassOLD
      3brtr4d col hlol hlatjass hlatj12 eqtr2d hlatlej2 latleeqm2 mpbid oveq12d
      hlatlej1 atmod1i1 simp13 simp12 oveq1d breqtrd latjle12 mpbi2and eqbrtrrd
      eqtr3d latmlem12 syl122anc mp2and eqbrtrd latjcom latjlej1 latjass lattrd
      wb wa latmle1 latlem12 latmlej12 llnmod1i2 hlatjidm syl2anc latmcom eqtrd
      syl321anc ) IUAPZCDQZBEHRZCFHRZKRZDGHRZJSZUBZBAPZCAPZDAPZUBZEAPZFAPZGAPZU
      BZUBZBCHRZEFHRZKRZCFGHRZKRZGEHRZHRZYFKRZCDHRZYIKRZDBHRZYKKRZHRZJYEYHYLJSZ
      YHYFJSZYHYMJSZYEIUCUDZIJYHYFEHRZFKRZEHRZYLUUBUEZLYEXIIUFPZXIXJXOXTYDUGZIU
      HUTZYEUUGYFUUBPZYGUUBPZYHUUBPZUUIYEXIXQXRUUJUUHXPXQXRXSYDUIZXPXQXRXSYDUJZ
      AUUBHIBCUUFMOUKTZYEXIYAYBUUKUUHXPXTYAYBYCULZXPXTYAYBYCUMZAUUBHIEFUUFMOUKT
      ZUUBIKYFYGUUFNUNTZYEUUGUUDUUBPZEUUBPZUUEUUBPUUIYEUUGUUCUUBPZFUUBPZUUTUUIY
      EUUGUUJUVAUVBUUIUUOYEYAUVAUUPAUUBEIUUFOUOUTZUUBHIYFEUUFMUPTZYEYBUVCUUQAUU
      BFIUUFOUOUTZUUBIKUUCFUUFNUNTZUVDUUBHIUUDEUUFMUPTYEUUGYJUUBPZYKUUBPZYLUUBP
      ZUUIYEUUGCUUBPZYIUUBPZUVHUUIYEXRUVKUUNAUUBCIUUFOUOUTZYEXIYBYCUVLUUHUUQXPX
      TYAYBYCUQZAUUBHIFGUUFMOUKTZUUBIKCYIUUFNUNTZYEXIYCYAUVIUUHUVNUUPAUUBHIGEUU
      FMOUKTZUUBHIYJYKUUFMUPTZYEYFFEHRZKRZUUCUVSKRZYHUUEJYEYFUUCJSZUVTUWAJSZYEU
      UGUUJUVAUWBUUIUUOUVDUUBHIJYFEUUFLMURTYEUUGUUJUVBUVSUUBPZUWBUWCVAUUIUUOUVE
      YEXIYBYAUWDUUHUUQUUPAUUBHIFEUUFMOUKTUUBIJKYFUUCUVSUUFLNUSVBVCYEYGUVSYFKYE
      XIYAYBYGUVSQUUHUUPUUQAHIEFMOVDTVEYEXIYBUVBUVAEUUCJSZUUEUWAQUUHUUQUVEUVDYE
      UUGUUJUVAUWEUUIUUOUVDUUBHIJYFEUUFLMVFTAUUBFHIJKUUCEUUFLMNOVGVHVJYEUUEYJGH
      RZEHRZYLJYEUUDUWFJSZUUEUWGJSZYEUUDGCHRZYIKRZUWFJYEUUDCXKHRZXLKRZFKRZUWKJY
      EUWNUWLXLFKRZKRZUUDYEIVKPZUWLUUBPZXLUUBPZUVCUWNUWPQYEXIUWQUUHIVLUTYEUUGUV
      KXKUUBPZUWRUUIUVMYEXIXQYAUWTUUHUUMUUPAUUBHIBEUUFMOUKTZUUBHICXKUUFMUPTZYEX
      IXRYBUWSUUHUUNUUQAUUBHICFUUFMOUKTZUVFUUBIKUWLXLFUUFNVIVBYEUWLUUCUWOFKYEUU
      CBCEHRHRZUWLYEXIXQXRYAUUCUXDQUUHUUMUUNUUPABCEHIMOVMVBYEXIXQXRYAUXDUWLQUUH
      UUMUUNUUPABCEHIMOVNVBVOYEFXLJSZUWOFQZYEXIXRYBUXEUUHUUNUUQACFHIJLMOVPTYEUU
      GUVCUWSUXEUXFWRUUIUVFUXCUUBIJKFXLUUFLNVQTVRVSVOYEUWMUWJJSZFYIJSZUWNUWKJSZ
      YECXMHRZUWMUWJJYEXIXRUWTUWSCXLJSZUXJUWMQUUHUUNUXAUXCYEXIXRYBUXKUUHUUNUUQA
      CFHIJLMOVTTAUUBCHIJKXKXLUUFLMNOWAVHYECUWJJSZXMUWJJSZUXJUWJJSZYEXIYCXRUXLU
      UHUVNUUNAGCHIJLMOVPTYEXMXNUWJJXIXJXOXTYDWBYECGHRZXNUWJYECDGHXIXJXOXTYDWCZ
      WDYEXIXRYCUXOUWJQUUHUUNUVNAHICGMOVDTWIWEYEUUGUVKXMUUBPZUWJUUBPZUXLUXMWSUX
      NWRUUIUVMYEUUGUWTUWSUXQUUIUXAUXCUUBIKXKXLUUFNUNTYEXIYCXRUXRUUHUVNUUNAUUBH
      IGCUUFMOUKTZUUBHIJCXMUWJUUFLMWFVBWGWHYEXIYBYCUXHUUHUUQUVNAFGHIJLMOVTTYEUU
      GUWMUUBPZUXRUVCUVLUXGUXHWSUXIVAUUIYEUUGUWRUWSUXTUUIUXBUXCUUBIKUWLXLUUFNUN
      TUXSUVFUVOUUBIJKYIUWMUWJFUUFLNWJWKWLWMYEGYJHRZUWKUWFYEXIYCUVKUVLGYIJSZUYA
      UWKQUUHUVNUVMUVOYEXIYBYCUYBUUHUUQUVNAFGHIJLMOVPTAUUBGHIJKCYIUUFLMNOWAVHYE
      UUGGUUBPZUVHUYAUWFQUUIYEYCUYCUVNAUUBGIUUFOUOUTZUVPUUBHIGYJUUFMWNTWIWEYEUU
      GUUTUWFUUBPZUVAUWHUWIVAUUIUVGYEUUGUVHUYCUYEUUIUVPUYDUUBHIYJGUUFMUPTUVDUUB
      HIJUUDUWFEUUFLMWOVBVCYEUUGUVHUYCUVAUWGYLQUUIUVPUYDUVDUUBHIYJGEUUFMWPVBWEW
      QYEUUGUUJUUKYTUUIUUOUURUUBIJKYFYGUUFLNWTTYEUUGUULUVJUUJYSYTWSUUAWRUUIUUSU
      VRUUOUUBIJKYHYLYFUUFLNXAVBWGYEYJYKYFKRZHRZYMYRYEXIUVHUUJYCYAYJYFJSZUYGYMQ
      UUHUVPUUOUVNUUPYEUUGUVKUVLBUUBPZUYHUUIUVMUVOYEXQUYIUUMAUUBBIUUFOUOUTUUBHI
      JKCYIBUUFLMNXBVBAUUBGEHIJKYJYFUUFLMNOXCXHYEYJYOUYFYQHYECYNYIKYECCHRZCYNYE
      XIXRUYJCQUUHUUNAHICMOXDXEYECDCHUXPVEWIWDYEUYFYFYKKRZYQYEUUGUVIUUJUYFUYKQU
      UIUVQUUOUUBIKYKYFUUFNXFTYEYFYPYKKYEYFCBHRZYPYEXIXQXRYFUYLQUUHUUMUUNAHIBCM
      OVDTYECDBHUXPWDXGWDXGVSWIWE $.

    dalawlem2.o $e |- O = ( LPlanes ` K ) $.
    $( Lemma for ~ dalaw .  Special case to eliminate the requirement
       ` ( ( P .\/ Q ) .\/ R ) e. O ` in ~ dalawlem1 .  (Contributed by NM,
       6-Oct-2012.) $)
    dalawlem13 $p |- ( ( ( K e. HL /\ -. ( ( P .\/ Q ) .\/ R ) e. O
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                     .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co w3a chlt wn wbr wo simp11 simp12 wne wa wb simp22 simp23 simp21
      islpln2a syl13anc df-ne anbi1i pm4.56 bitri syl6rbb hlatjrot eleq1d bitrd
      wceq con1bid mpbid simp13 simp2 wi dalawlem12 3expib 3exp dalawlem11 jaod
      simp3 3imp 3impib syl311anc ) IUARZBCHSZDHSZLRZUBZBEHSCFHSKSDGHSJUCZTZBAR
      ZCARZDARZTZEARFARGARTZTZVRCDVCZBCDHSZJUCZUDZWCWHWIVSEFHSKSWLFGHSKSDBHSGEH
      SKSHSJUCZVRWBWCWHWIUEZWJWBWNVRWBWCWHWIUFWJWNWAWJWNUBZWLBHSZLRZWAWJWSCDUGZ
      WMUBZUHZWQWJVRWFWGWEWSXBUIWPWDWEWFWGWIUJZWDWEWFWGWIUKZWDWEWFWGWIULZALCDBH
      IJMNPQUMUNXBWKUBZXAUHWQWTXFXACDUOUPWKWMUQURUSWJWRVTLWJVRWFWGWEWRVTVCWPXCX
      DXEACDBHINPUTUNVAVBVDVEVRWBWCWHWIVFWDWHWIVGWDWHWIVNVRWNWCTWHWIWOVRWNWCWHW
      IUHWOVHZVRWKWCXGVHWMVRWKWCXGVRWKWCTWHWIWOABCDEFGHIJKMNOPVIVJVKVRWMWCXGVRW
      MWCTWHWIWOABCDEFGHIJKMNOPVLVJVKVMVOVPVQ $.

    $( Lemma for ~ dalaw .  Combine ~ dalawlem10 and ~ dalawlem13 .
       (Contributed by NM, 6-Oct-2012.) $)
    dalawlem14 $p |- ( ( ( K e. HL /\
             -. ( ( ( P .\/ Q ) .\/ R ) e. O
               /\ ( -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( P .\/ Q )
               /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( Q .\/ R )
               /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ P ) ) )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                   .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co wn chlt wbr w3a wa wi wo dalawlem13 3expib 3exp dalawlem10 jaod
      ianor syl5bi 3imp 3impib ) IUARZBCHSZDHSLRZBEHSCFHSKSZUQJUBTUSCDHSZJUBTUS
      DBHSZJUBTUCZUDTZUSDGHSJUBZUCBARCARDARUCZEARFARGARUCZUQEFHSKSUTFGHSKSVAGEH
      SKSHSJUBZUPVCVDVEVFUDVGUEZVCURTZVBTZUFUPVDVHUEZURVBULUPVIVKVJUPVIVDVHUPVI
      VDUCVEVFVGABCDEFGHIJKLMNOPQUGUHUIUPVJVDVHUPVJVDUCVEVFVGABCDEFGHIJKMNOPUJU
      HUIUKUMUNUO $.

    $( Lemma for ~ dalaw .  Swap variable triples ` P Q R ` and ` S T U ` in
       ~ dalawlem14 , to obtain the elimination of the remaining conditions in
       ~ dalawlem1 .  (Contributed by NM, 6-Oct-2012.) $)
    dalawlem15 $p |- ( ( ( K e. HL /\
             -. ( ( ( S .\/ T ) .\/ U ) e. O
               /\ ( -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( S .\/ T )
               /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( T .\/ U )
               /\ -. ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( U .\/ S ) ) )
            /\ ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) )
       /\ ( P e. A /\ Q e. A /\ R e. A )
       /\ ( S e. A /\ T e. A /\ U e. A ) )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
               .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                     .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) $=
      ( wcel co syl3anc chlt wbr wn w3a wa simp11 simp12 simp21 simp31 hlatjcom
      simp22 simp32 oveq12d breq1d notbid 3anbi123d anbi2d simp13 simp33 simp23
      wceq mtbid 3brtr4d simp3 simp2 dalawlem14 syl311anc clat cbs cfv syl eqid
      hllat hlatjcl latmcom ) IUARZEFHSZGHSLRZBEHSZCFHSZKSZVQJUBZUCZWAFGHSZJUBZ
      UCZWAGEHSZJUBZUCZUDZUEZUCZWADGHSZJUBZUDZBARZCARZDARZUDZEARZFARZGARZUDZUDZ
      VQBCHSZKSZWDCDHSZKSZWGDBHSZKSZHSZXEVQKSZXGWDKSZXIWGKSZHSJXDVPVREBHSZFCHSZ
      KSZVQJUBZUCZXQWDJUBZUCZXQWGJUBZUCZUDZUEZUCXQGDHSZJUBXCWSXFXKJUBVPWLWNWSXC
      UFZXDWKYEVPWLWNWSXCUGXDWJYDVRXDWCXSWFYAWIYCXDWBXRXDWAXQVQJXDVSXOVTXPKXDVP
      WPWTVSXOVAYGWOWPWQWRXCUHZWOWSWTXAXBUIZAHIBENPUJTXDVPWQXAVTXPVAYGWOWPWQWRX
      CUKZWOWSWTXAXBULZAHICFNPUJTUMZUNUOXDWEXTXDWAXQWDJYLUNUOXDWHYBXDWAXQWGJYLU
      NUOUPUQVBXDWAWMXQYFJVPWLWNWSXCURXDXOVSXPVTKXDVPWTWPXOVSVAYGYIYHAHIEBNPUJT
      XDVPXAWQXPVTVAYGYKYJAHIFCNPUJTUMXDVPXBWRYFWMVAYGWOWSWTXAXBUSZWOWPWQWRXCUT
      ZAHIGDNPUJTVCWOWSXCVDWOWSXCVEAEFGBCDHIJKLMNOPQVFVGXDIVHRZXEIVIVJZRZVQYPRZ
      XLXFVAXDVPYOYGIVMVKZXDVPWPWQYQYGYHYJAYPHIBCYPVLZNPVNTXDVPWTXAYRYGYIYKAYPH
      IEFYTNPVNTYPIKXEVQYTOVOTXDXMXHXNXJHXDYOXGYPRZWDYPRZXMXHVAYSXDVPWQWRUUAYGY
      JYNAYPHICDYTNPVNTXDVPXAXBUUBYGYKYMAYPHIFGYTNPVNTYPIKXGWDYTOVOTXDYOXIYPRZW
      GYPRZXNXJVAYSXDVPWRWPUUCYGYNYHAYPHIDBYTNPVNTXDVPXBWTUUDYGYMYIAYPHIGEYTNPV
      NTYPIKXIWGYTOVOTUMVC $.
  $}

  ${
    dalaw.l $e |- .<_ = ( le ` K ) $.
    dalaw.j $e |- .\/ = ( join ` K ) $.
    dalaw.m $e |- ./\ = ( meet ` K ) $.
    dalaw.a $e |- A = ( Atoms ` K ) $.
    $( Desargues' law, derived from Desargues' theorem ~ dath and with no
       conditions on the atoms.  If triples ` <. P , Q , R >. ` and
       ` <. S , T , U >. ` are centrally perspective, i.e.
       ` ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U ) ` , then they are
       axially perspective.  Theorem 13.3 of [Crawley] p. 110.  (Contributed by
       NM, 7-Oct-2012.) $)
    dalaw $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
                /\ ( S e. A /\ T e. A /\ U e. A ) )
       -> ( ( ( P .\/ S ) ./\ ( Q .\/ T ) ) .<_ ( R .\/ U )
         -> ( ( P .\/ Q ) ./\ ( S .\/ T ) )
             .<_ ( ( ( Q .\/ R ) ./\ ( T .\/ U ) )
                 .\/ ( ( R .\/ P ) ./\ ( U .\/ S ) ) ) ) ) $=
      ( wcel w3a co wbr wn chlt clpl cfv eqid dalawlem14 3expib 3exp dalawlem15
      wi wa simp11 simp2 simp3 simp2ll simp2rl simp2lr simp2rr simp13 dalawlem1
      3ad2ant1 syl323anc ecased exp4a com34 com24 3imp ) IUAPZBAPCAPDAPQZEAPFAP
      GAPQZBEHRCFHRKRZDGHRJSZBCHRZEFHRZKRCDHRZFGHRZKRDBHRZGEHRZKRHRJSZUIVGVKVIV
      HVRVGVKVHVIVRVGVKVHVIVRVGVLDHRIUBUCZPZVJVLJSTVJVNJSTVJVPJSTQZUJZVMGHRVSPZ
      VJVMJSTVJVOJSTVJVQJSTQZUJZVKVHVIUJVRUIZUIVGWBTZVKWFVGWGVKQVHVIVRABCDEFGHI
      JKVSLMNOVSUDZUEUFUGVGWETZVKWFVGWIVKQVHVIVRABCDEFGHIJKVSLMNOWHUHUFUGVGWBWE
      UJZVKWFVGWJVKQZVHVIVRWKVHVIQVGVHVIVTWCWAWDVKVRVGWJVKVHVIUKWKVHVIULWKVHVIU
      MWKVHVTVIVTWAWEVGVKUNUTWKVHWCVIWCWDWBVGVKUOUTWKVHWAVIVTWAWEVGVKUPUTWKVHWD
      VIWCWDWBVGVKUQUTVGWJVKVHVIURABCDEFGHIJKVSLMNOWHUSVAUFUGVBVCVDVEVF $.
  $}

  $c PCl $.

  $( Extend class notation with projective subspace closure. $)
  cpclN $a class PCl $.

  ${
    $d k x y $.
    $( Projective subspace closure, which is the smallest projective subspace
       containing an arbitrary set of atoms.  The subspace closure of the union
       of a set of projective subspaces is their supremum in ` PSubSp ` .
       Related to an analogous definition of closure used in Lemma 3.1.4 of
       [PtakPulmannova] p. 68.  (Note that this closure is not necessarily one
       of the closed projective subspaces ` PSubCl ` of ~ df-psubclN .)
       (Contributed by NM, 7-Sep-2013.) $)
    df-pclN $a |- PCl = ( k e. _V |-> ( x e. ~P ( Atoms ` k )
           |-> |^| { y e. ( PSubSp ` k ) | x C_ y } ) ) $.
  $}

  ${
    $d k x y A $.  $d k x y K $.  $d k x y S $.  $d x y X $.
    pclfval.a $e |- A = ( Atoms ` K ) $.
    pclfval.s $e |- S = ( PSubSp ` K ) $.
    pclfval.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure function.  (Contributed by NM,
       7-Sep-2013.)  (New usage is discouraged.) $)
    pclfvalN $p |- ( K e. V -> U = ( x e. ~P A |->
                |^| { y e. S | x C_ y } ) ) $=
      ( vk wcel cvv cpw cv crab cint cfv catm cpsubsp wss cmpt wceq cpclN fveq2
      elex syl6eqr pweqd biidd rabeqbidv inteqd mpteq12dv df-pclN eqeltri mptex
      fvex pwex fvmpt syl5eq syl ) FGLFMLZEACNZAOBOUAZBDPZQZUBZUCFGUFVAEFUDRVFJ
      KFAKOZSRZNZVCBVGTRZPZQZUBVFMUDVGFUCZAVIVLVBVEVMVHCVMVHFSRZCVGFSUEHUGUHVMV
      KVDVMVCVCBVJDVMVJFTRDVGFTUEIUGVMVCUIUJUKULABKUMAVBVECCVNMHFSUPUNUQUOURUSU
      T $.

    $( Value of the projective subspace closure function.  (Contributed by NM,
       7-Sep-2013.)  (New usage is discouraged.) $)
    pclvalN $p |- ( ( K e. V /\ X C_ A ) ->
             ( U ` X ) = |^| { y e. S | X C_ y } ) $=
      ( vx wss wcel cfv cv crab cint wceq catm cvv cpw fvex eqeltri wa pclfvalN
      elpw2 fveq1d adantr simpr c0 wne elpwi adantl wb atpsubN sseq2 elrab3 syl
      cmpt mpbird ne0i intex sylib sseq1 rabbidv inteqd fvmptg syl2anc sylan2br
      eqid eqtrd ) GBLZEFMZGBUAZMZGDNZGAOZLZACPZQZRGBBESNTHESUBUCUFVMVOUDZVPGKV
      NKOZVQLZACPZQZUSZNZVTVMVPWGRVOVMGDWFKABCDEFHIJUEUGUHWAVOVTTMZWGVTRVMVOUIW
      AVSUJUKZWHWABVSMZWIWAWJVLVOVLVMGBULUMWABCMZWJVLUNVMWKVOBCEFHIUOUHVRVLABCV
      QBGUPUQURUTVSBVAURVSVBVCKGWEVTVNTWFWBGRZWDVSWLWCVRACWBGVQVDVEVFWFVJVGVHVK
      VI $.

    $d p q r A $.  $d p q r K $.  $d p q r S $.  $d p q r X $.  $d p q r y V $.
    $( Closure of the projective subspace closure function.  (Contributed by
       NM, 8-Sep-2013.)  (New usage is discouraged.) $)
    pclclN $p |- ( ( K e. V /\ X C_ A ) -> ( U ` X ) e. S ) $=
      ( vy vr vp vq wcel wss wa cfv cv wi wral crab cint pclvalN cjn co atpsubN
      cple wbr sseq2 intminss sylan r19.26 ralbii vex elintrab anbi12i 3bitr4ri
      jcab simpll1 simplr simpll3 simprl simprr simpll2 eqid psubspi2N syl33anc
      ex imim2d ralimdva syl6ibr 3exp com24 syl5bi ralrimdv ralrimivv adantr wb
      w3a ispsubsp mpbir2and eqeltrd ) DENZFAOZPZFCQFJRZOZJBUAUBZBJABCDEFGHIUCW
      EWHBNZWHAOZKRZLRZMRZDUDQZUEDUGQZUHZWKWHNZSZKATZMWHTLWHTZWCABNWDWJABDEGHUF
      WGWDJABWFAFUIUJUKWCWTWDWCWSLMWHWHWCWLWHNZWMWHNZPZWRKAXCWGWLWFNZWMWFNZPZSZ
      JBTZWCWKANZWRSWGXDSZWGXESZPZJBTXJJBTZXKJBTZPXHXCXJXKJBULXGXLJBWGXDXEURUMX
      AXMXBXNWGJWLBLUNUOWGJWMBMUNUOUPUQWCWPXIXHWQWCWPXIXHWQSWCWPXIVSZXHWGWKWFNZ
      SZJBTWQXOXGXQJBXOWFBNZPZXFXPWGXSXFXPXSXFPWCXRXIXDXEWPXPWCWPXIXRXFUSXOXRXF
      UTWCWPXIXRXFVAXSXDXEVBXSXDXEVCWCWPXIXRXFVDAEWKWLWMBWNDWOWFWOVEZWNVEZGHVFV
      GVHVIVJWGJWKBKUNUOVKVLVMVNVOVPVQWCWIWJWTPVRWDAEBWNDWOWHKMLXTYAGHVTVQWAWB
      $.

    $d y Q $.
    elpcl.q $e |- Q e. _V $.
    $( Membership in the projective subspace closure function.  (Contributed by
       NM, 13-Sep-2013.)  (New usage is discouraged.) $)
    elpclN $p |- ( ( K e. V /\ X C_ A ) ->
             ( Q e. ( U ` X ) <-> A. y e. S ( X C_ y -> Q e. y ) ) ) $=
      ( wcel wss wa cfv cv crab cint wi wral pclvalN eleq2d elintrab syl6bb ) F
      GMHBNOZCHEPZMCHAQZNZADRSZMUICUHMTADUAUFUGUJCABDEFGHIJKUBUCUIACDLUDUE $.
  $}

  ${
    $d z K $.  $d z Q $.  $d z S $.  $d z X $.  $d z Y $.
    elpcli.s $e |- S = ( PSubSp ` K ) $.
    elpcli.c $e |- U = ( PCl ` K ) $.
    $( Implication of membership in the projective subspace closure function.
       (Contributed by NM, 13-Sep-2013.)  (New usage is discouraged.) $)
    elpcliN $p |- ( ( ( K e. V /\ X C_ Y /\ Y e. S ) /\ Q e. ( U ` X ) )
         -> Q e. Y ) $=
      ( vz wcel wss w3a cfv cv wi wral crab wceq imp cint catm simp1 simp2 eqid
      psubssat 3adant2 sstrd pclvalN syl2anc eleq2d elintrabg ibi sseq2 imbi12d
      syl6bi eleq2 rspccv com13 3adant1 syld ) DEKZFGLZGBKZMZAFCNZKZAGKZVEVGFJO
      ZLZAVIKZPZJBQZVHVEVGAVJJBRUAZKZVMVEVFVNAVEVBFDUBNZLVFVNSVBVCVDUCVEFGVPVBV
      CVDUDVBVDGVPLVCVPEBDGVPUEZHUFUGUHJVPBCDEFVQHIUIUJUKVOVMVJJABVNULUMUPVCVDV
      MVHPZVBVCVDVRVMVDVCVHVLVCVHPJGBVIGSVJVCVKVHVIGFUNVIGAUQUOURUSTUTVAT $.
  $}

  ${
    $d y A $.  $d y K $.  $d y V $.  $d y X $.  $d y Y $.
    pclss.a $e |- A = ( Atoms ` K ) $.
    pclss.c $e |- U = ( PCl ` K ) $.
    $( Ordering is preserved by subspace closure.  (Contributed by NM,
       8-Sep-2013.)  (New usage is discouraged.) $)
    pclssN $p |- ( ( K e. V /\ X C_ Y /\ Y C_ A )
           -> ( U ` X ) C_ ( U ` Y ) ) $=
      ( vy wcel wss w3a cv cpsubsp cfv crab cint wi wceq pclvalN sstr2 3ad2ant2
      adantr ss2rabdv intss syl simp1 sstr 3adant1 eqid syl2anc 3adant2 3sstr4d
      ) CDJZEFKZFAKZLZEIMZKZICNOZPZQZFURKZIUTPZQZEBOZFBOZUQVDVAKVBVEKUQVCUSIUTU
      QVCUSRZURUTJUOUNVHUPEFURUAUBUCUDVDVAUEUFUQUNEAKZVFVBSUNUOUPUGUOUPVIUNEFAU
      HUIIAUTBCDEGUTUJZHTUKUNUPVGVESUOIAUTBCDFGVJHTULUM $.

    $( A set of atoms is included in its projective subspace closure.
       (Contributed by NM, 12-Sep-2013.)  (New usage is discouraged.) $)
    pclssidN $p |- ( ( K e. V /\ X C_ A ) -> X C_ ( U ` X ) ) $=
      ( vy wcel wss wa cv cpsubsp cfv crab cint ssintub eqid pclvalN syl5sseqr
      ) CDIEAJKEHLJHCMNZOPEEBNHEUAQHAUABCDEFUARGST $.
  $}

  ${
    $d y K $.  $d y S $.  $d y X $.
    pclid.s $e |- S = ( PSubSp ` K ) $.
    pclid.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure of a projective subspace is itself.
       (Contributed by NM, 8-Sep-2013.)  (New usage is discouraged.) $)
    pclidN $p |- ( ( K e. V /\ X e. S ) -> ( U ` X ) = X ) $=
      ( vy wcel wa cfv cv wss crab cint catm wceq eqid psubssat pclvalN syldan
      intmin adantl eqtrd ) CDIZEAIZJEBKZEHLMHANOZEUEUFECPKZMUGUHQUIDACEUIRZFSH
      UIABCDEUJFGTUAUFUHEQUEHEAUBUCUD $.

    $( A projective subspace sandwiched between a set of atoms and the set's
       projective subspace closure equals the closure.  (Contributed by NM,
       8-Sep-2013.)  (New usage is discouraged.) $)
    pclbtwnN $p |- ( ( ( K e. V /\ X e. S ) /\ ( Y C_ X /\ X C_ ( U ` Y ) ) )
            -> X = ( U ` Y ) ) $=
      ( wcel wa wss cfv simprr catm simpll simprl eqid psubssat adantr pclssN
      syl3anc wceq pclidN sseqtrd eqssd ) CDIZEAIZJZFEKZEFBLZKZJZJZEUJUHUIUKMUM
      UJEBLZEUMUFUIECNLZKZUJUNKUFUGULOUHUIUKPUHUPULUODACEUOQZGRSUOBCDFEUQHTUAUH
      UNEUBULABCDEGHUCSUDUE $.
  $}

  ${
    pclun.a $e |- A = ( Atoms ` K ) $.
    pclun.p $e |- .+ = ( +P ` K ) $.
    pclun.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure of the union of two sets of atoms equals
       the closure of their projective sum.  (Contributed by NM, 12-Sep-2013.)
       (New usage is discouraged.) $)
    pclunN $p |- ( ( K e. V /\ X C_ A /\ Y C_ A )
                   -> ( U ` ( X u. Y ) ) = ( U ` ( X .+ Y ) ) ) $=
      ( wcel wss w3a cun cfv pclssN syl3anc wa unss syl2anc co paddunssN biimpi
      simp1 paddssat 3adant1 pclssidN sylibr cpsubsp wb simp2 simp3 eqid pclclN
      paddss syl13anc mpbid psubssat wceq pclidN sseqtrd eqssd ) DEKZFALZGALZMZ
      FGNZCOZFGBUAZCOZVFVCVGVILVIALVHVJLVCVDVEUDZAEBDFGHIUBAEBDFGHIUEACDEVGVIHJ
      PQVFVJVHCOZVHVFVCVIVHLZVHALZVJVLLVKVFFVHLGVHLRZVMVFVGVHLZVOVFVCVGALZVPVKV
      DVEVQVCVDVERVQFGASUCUFZACDEVGHJUGTFGVHSUHVFVCVDVEVHDUIOZKZVOVMUJVKVCVDVEU
      KVCVDVEULVFVCVQVTVKVRAVSCDEVGHVSUMZJUNTZAEBVSDFGVHHWAIUOUPUQVFVCVTVNVKWBA
      EVSDVHHWAURTACDEVIVHHJPQVFVCVTVLVHUSVKWBVSCDEVHWAJUTTVAVB $.
  $}

  ${
    pclun2.s $e |- S = ( PSubSp ` K ) $.
    pclun2.p $e |- .+ = ( +P ` K ) $.
    pclun2.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure of the union of two subspaces equals
       their projective sum.  (Contributed by NM, 12-Sep-2013.)
       (New usage is discouraged.) $)
    pclun2N $p |- ( ( K e. HL /\ X e. S /\ Y e. S )
                   -> ( U ` ( X u. Y ) ) = ( X .+ Y ) ) $=
      ( chlt wcel w3a cun cfv co catm wss wceq simp1 psubssat eqid pclunN eqtrd
      3adant3 3adant2 syl3anc paddclN pclidN syl2anc ) DJKZEBKZFBKZLZEFMCNZEFAO
      ZCNZUOUMUJEDPNZQZFUQQZUNUPRUJUKULSZUJUKURULUQJBDEUQUAZGTUDUJULUSUKUQJBDFV
      AGTUEUQACDJEFVAHIUBUFUMUJUOBKUPUORUTABDEFGHUGBCDJUOGIUHUIUC $.
  $}

  ${
    pclfin.a $e |- A = ( Atoms ` K ) $.
    pclfin.c $e |- U = ( PCl ` K ) $.
    $d p q r v w y A $.  $d p q r v w y U $.  $d p q r v w y K $.
    $d p q r v w y X $.
    $( The projective subspace closure of a set equals the union of the
       closures of its finite subsets.  Analogous to Lemma 3.3.6 of
       [PtakPulmannova] p. 72.  Compare the closed subspace version
       ~ pclfinclN .  (Contributed by NM, 10-Sep-2013.)
       (New usage is discouraged.) $)
    pclfinN $p |- ( ( K e. AtLat /\ X C_ A )
      -> ( U ` X ) = U_ y e. ( Fin i^i ~P X ) ( U ` y ) ) $=
      ( vw vv cal wcel wss wa cfn cv cfv wceq wi syl2anc wrex vr vp vq cpw ciun
      cin cpsubsp simpl cjn cple wbr wral elin elpwi adantl sylbi simpll ancoms
      co sstr adantll eqid pclclN psubssat ex ralrimiv iunss sylibr eliun fveq2
      syl5 eleq2d cbvrexv bitri anbi12i anim2i w3a simp2rl simp12l unfi simp2rr
      cun simp12r unssd vex unex elpw sylanbrc simp11l simp11r sstrd simp3l a1i
      ssun1 pclssN syl3anc simp2l sseldd ssun2 simp13 simp3r psubspi2N syl33anc
      rspcev 3exp exp5c rexlimdv com24 imp3a syl5bi ralrimdv ralrimivv ispsubsp
      adantr mpbir2and csn snfi snelpwi snid snatpsubN pclidN syl5eleqr syl6ibr
      wb ssel2 ssrdv simpr simplr sseld pclbtwnN syl22anc eqcomd ) DJKZEBLZMZAN
      EUDZUFZAOZCPZUEZECPZYOYMYTDUGPZKZEYTLYTUUALYTUUAQYMYNUHYOUUCYTBLZUAOZUBOZ
      UCOZDUIPZUSDUJPZUKZUUEYTKZRZUABULZUCYTULUBYTULZYOYSBLZAYQULUUDYOUUOAYQYRY
      QKZYRELZYOUUOUUPYRNKZYRYPKZMUUQYRNYPUMUUSUUQUURYREUNUOUPZYOUUQUUOYOUUQMZY
      MYSUUBKZUUOYMYNUUQUQZUVAYMYRBLZUVBUVCYNUUQUVDYMUUQYNUVDYREBUTURVABUUBCDJY
      RFUUBVBZGVCSBJUUBDYSFUVEVDSVEVKVFAYQYSBVGVHYOUUMUBUCYTYTYOUUFYTKZUUGYTKZM
      ZUULUABUVHUUFHOZCPZKZHYQTZUUGIOZCPZKZIYQTZMYOUUEBKZUULRZUVFUVLUVGUVPUVFUU
      FYSKZAYQTUVLAUUFYQYSVIUVSUVKAHYQYRUVIQYSUVJUUFYRUVICVJVLVMVNUVGUUGYSKZAYQ
      TUVPAUUGYQYSVIUVTUVOAIYQYRUVMQYSUVNUUGYRUVMCVJVLVMVNVOYOUVLUVPUVRYOUVKUVP
      UVRRZHYQUVIYQKZUVINKZUVIELZMZYOUVKUWARUWBUWCUVIYPKZMUWEUVINYPUMUWFUWDUWCU
      VIEUNVPUPYOUVPUVKUWEUVRYOUVOUVKUWEUVRRRZIYQUVMYQKZUVMNKZUVMELZMZYOUVOUWGR
      UWHUWIUVMYPKZMUWKUVMNYPUMUWLUWJUWIUVMEUNVPUPYOUWKUVOUWGYOUWKUVOVQZUVKUWEU
      VQUUJUUKUWMUVKUWEMZUVQUUJMZUUKUWMUWNUWOVQZUUEYSKZAYQTZUUKUWPUVIUVMWBZYQKZ
      UUEUWSCPZKZUWRUWPUWSNKZUWSYPKZUWTUWPUWCUWIUXCUWCUWDUVKUWMUWOVRUWIUWJYOUVO
      UWNUWOVSUVIUVMVTSUWPUWSELUXDUWPUVIUVMEUWCUWDUVKUWMUWOWAZUWIUWJYOUVOUWNUWO
      WCZWDUWSEUVIUVMHWEZIWEWFWGVHUWSNYPUMWHUWPYMUXAUUBKZUVQUUFUXAKUUGUXAKUUJUX
      BYMYNUWKUVOUWNUWOWIZUWPYMUWSBLZUXHUXIUWPUVIUVMBUWPUVIEBUXEYMYNUWKUVOUWNUW
      OWJZWKUWPUVMEBUXFUXKWKWDZBUUBCDJUWSFUVEGVCSUWMUWNUVQUUJWLUWPUVJUXAUUFUWPY
      MUVIUWSLZUXJUVJUXALUXIUXMUWPUVIUVMWNWMUXLBCDJUVIUWSFGWOWPUWMUVKUWEUWOWQWR
      UWPUVNUXAUUGUWPYMUVMUWSLZUXJUVNUXALUXIUXNUWPUVMUVIWSWMUXLBCDJUVMUWSFGWOWP
      YOUWKUVOUWNUWOWTWRUWMUWNUVQUUJXABJUUEUUFUUGUUBUUHDUUIUXAUUIVBZUUHVBZFUVEX
      BXCUWQUXBAUWSYQYRUWSQYSUXAUUEYRUWSCVJVLXDSAUUEYQYSVIVHXEXFXEVKXGXHVKXGXIX
      JXKXLYMUUCUUDUUNMYDYNBJUUBUUHDUUIYTUAUCUBUXOUXPFUVEXMXNXOYOHEYTYOUVIEKZUV
      IYSKZAYQTZUVIYTKZYOUXQUXSYOUXQMZUVIXPZYQKZUVIUYBCPZKZUXSUYAUYBNKZUYBYPKZU
      YCUYFUYAUVIXQWMUXQUYGYOUVIEXRUOUYBNYPUMWHUYAUVIUYBUYDUVIUXGXSUYAYMUYBUUBK
      ZUYDUYBQYMYNUXQUQZUYAYMUVIBKZUYHUYIYNUXQUYJYMEBUVIYEVABUVIUUBDFUVEXTSUUBC
      DJUYBUVEGYASYBUXRUYEAUYBYQYRUYBQYSUYDUVIYRUYBCVJVLXDSVEAUVIYQYSVIZYCYFYOH
      YTUUAUXTUXSYOUVIUUAKZUYKYOUXRUYLAYQUUPUUQYOUXRUYLRZUUTYOUUQUYMUVAYSUUAUVI
      UVAYMUUQYNYSUUALUVCYOUUQYGYMYNUUQYHBCDJYREFGWOWPYIVEVKXGXJYFUUBCDJYTEUVEG
      YJYKYL $.

    $d y P $.
    $( The set of projective subspaces is compactly atomistic: if an atom is in
       the projective subspace closure of a set of atoms, it also belongs to
       the projective subspace closure of a finite subset of that set.
       Analogous to Lemma 3.3.10 of [PtakPulmannova] p. 74.  (Contributed by
       NM, 10-Sep-2013.)  (New usage is discouraged.) $)
    pclcmpatN $p |- ( ( K e. AtLat /\ X C_ A /\ P e. ( U ` X ) )
      -> E. y e. Fin ( y C_ X /\ P e. ( U ` y ) ) ) $=
      ( cal wcel wss cfv cv wa cfn wrex cpw cin ciun pclfinN eleq2d syl6bb elin
      eliun elpwi anim2i sylbi anim1i anass sylib reximi2 syl6bi 3impia ) EIJZF
      BKZCFDLZJZAMZFKZCURDLZJZNZAOPZUNUONZUQVAAOFQZRZPZVCVDUQCAVFUTSZJVGVDUPVHC
      ABDEFGHTUAACVFUTUDUBVAVBAVFOURVFJZVANUROJZUSNZVANVJVBNVIVKVAVIVJURVEJZNVK
      UROVEUCVLUSVJURFUEUFUGUHVJUSVAUIUJUKULUM $.
  $}

  $c _|_P $.

  $( Extend class notation with polarity of projective subspace $m$. $)
  cpolN $a class _|_P $.

  ${
    $d l m w p $.
    $( Define polarity of projective subspace, which is a kind of complement of
       the subspace.  Item 2 in [Holland95] p. 222 bottom.  For more
       generality, we define it for all subsets of atoms, not just projective
       subspaces.  The intersection with ` Atoms `` l ` ensures it is defined
       when ` m = (/) ` .  (Contributed by NM, 23-Oct-2011.) $)
    df-polarityN $a |- _|_P = ( l e. _V |-> ( m e. ~P ( Atoms ` l ) |->
          ( ( Atoms ` l )
             i^i |^|_ p e. m ( ( pmap ` l ) ` ( ( oc ` l ) ` p ) ) ) ) ) $.
  $}

  ${
    $d h m A $.  $d h m p K $.  $d h M $.  $d h ._|_ $.
    polfval.o $e |- ._|_ = ( oc ` K ) $.
    polfval.a $e |- A = ( Atoms ` K ) $.
    polfval.m $e |- M = ( pmap ` K ) $.
    polfval.p $e |- P = ( _|_P ` K ) $.
    $( The projective subspace polarity function.  (Contributed by NM,
       23-Oct-2011.)  (New usage is discouraged.) $)
    polfvalN $p |- ( K e. B -> P = ( m e. ~P A |->
                ( A i^i |^|_ p e. m ( M ` ( ._|_ ` p ) ) ) ) ) $=
      ( vh wcel cvv cv cfv wceq catm coc cpw ciin cmpt elex cpolN cpmap syl6eqr
      fveq2 pweqd fveq1d fveq12d adantr iineq2dv ineq12d mpteq12dv df-polarityN
      cin fvex eqeltri pwex mptex fvmpt syl5eq syl ) EBNEONZCDAUAZAHDPZHPZGQZFQ
      ZUBZUQZUCZREBUDVECEUEQVMLMEDMPZSQZUAZVOHVGVHVNTQZQZVNUFQZQZUBZUQZUCVMOUEV
      NERZDVPWBVFVLWCVOAWCVOESQZAVNESUHJUGZUIWCVOAWAVKWEWCHVGVTVJWCVTVJRVHVGNWC
      VRVIVSFWCVSEUFQFVNEUFUHKUGWCVHVQGWCVQETQGVNETUHIUGUJUKULUMUNUODHMUPDVFVLA
      AWDOJESURUSUTVAVBVCVD $.

    $d m M $.  $d m ._|_ $.  $d m p X $.
    $( Value of the projective subspace polarity function.  (Contributed by NM,
       23-Oct-2011.)  (New usage is discouraged.) $)
    polvalN $p |- ( ( K e. B /\ X C_ A ) ->
             ( P ` X ) = ( A i^i |^|_ p e. X ( M ` ( ._|_ ` p ) ) ) ) $=
      ( vm wcel cfv cv ciin cin wceq catm wss cpw cvv fvex eqeltri elpw2 fveq1d
      cmpt polfvalN iineq1 ineq2d eqid inex1 fvmpt sylan9eq sylan2br ) GAUADBNZ
      GAUBZNZGCOZAHGHPFOEOZQZRZSGAADTOUCJDTUDUEZUFUQUSUTGMURAHMPZVAQZRZUHZOVCUQ
      GCVHABCMDEFHIJKLUIUGMGVGVCURVHVEGSVFVBAHVEGVAUJUKVHULAVBVDUMUNUOUP $.
  $}

  ${
    $d p x A $.  $d p x K $.  $d p x ._|_ $.  $d p x X $.
    polval2.u $e |- U = ( lub ` K ) $.
    polval2.o $e |- ._|_ = ( oc ` K ) $.
    polval2.a $e |- A = ( Atoms ` K ) $.
    polval2.m $e |- M = ( pmap ` K ) $.
    polval2.p $e |- P = ( _|_P ` K ) $.
    $( Alternate expression for value of the projective subspace polarity
       function.  Equation for polarity in [Holland95] p. 223.  (Contributed by
       NM, 22-Jan-2012.)  (New usage is discouraged.) $)
    polval2N $p |- ( ( K e. HL /\ X C_ A ) ->
             ( P ` X ) = ( M ` ( ._|_ ` ( U ` X ) ) ) ) $=
      ( vp vx wcel wa cfv wceq wrex cab chlt wss ciin cin cglb polvalN cbs wral
      cops hlop ad2antrr ssel2 adantll eqid atbase syl opoccl syl2anc ralrimiva
      cv pmapglb2xN syldan glbconxN opococ eqeq2d rexbidva abbidv df-rex equcom
      weq wex anbi2i ancom bitri exbii eleq1 ceqsexv 3bitri abbii syl6eq fveq2d
      vex abid2 eqtri eqtrd 3eqtr2d ) DUAOZGAUBZPZGBQAMGMUTZFQZEQUCUDZNUTZWKRMG
      SNTDUEQZQZEQZGCQZFQZEQAUABDEFGMIJKLUFWGWHWKDUGQZOZMGUHZWPWLRWIWTMGWIWJGOZ
      PZDUIOZWJWSOZWTWGXDWHXBDUJUKZXCWJAOZXEWHXBXGWGGAWJULUMAWSWJDWSUNZJUOUPZWS
      DFWJXHIUQURUSZNAWSWKMWNGDEXHWNUNZJKVAVBWIWOWREWIWOWMWKFQZRZMGSZNTZCQZFQZW
      RWGWHXAWOXQRXJNWSWKCMWNGDFXHHXKIVCVBWIXPWQFWIXOGCWIXONMVJZMGSZNTZGWIXNXSN
      WIXMXRMGXCXLWJWMXCXDXEXLWJRXFXIWSDFWJXHIVDURVEVFVGXTWMGOZNTGXSYANXSXBXRPZ
      MVKMNVJZXBPZMVKYAXRMGVHYBYDMYBXBYCPYDXRYCXBNMVIVLXBYCVMVNVOXBYAMWMNWBWJWM
      GVPVQVRVSNGWCWDVTWAWAWEWAWF $.
  $}

  ${
    polsubsp.a $e |- A = ( Atoms ` K ) $.
    polsubsp.s $e |- S = ( PSubSp ` K ) $.
    polsubsp.p $e |- ._|_ = ( _|_P ` K ) $.
    $( The polarity of a set of atoms is a projective subspace.  (Contributed
       by NM, 23-Jan-2012.)  (New usage is discouraged.) $)
    polsubN $p |- ( ( K e. HL /\ X C_ A ) -> ( ._|_ ` X ) e. S ) $=
      ( chlt wcel wss wa cfv club coc cpmap eqid polval2N adantr syl2anc hlclat
      clat cbs hllat cops hlop ccla atssbase sstr mpan2 clatlubcl syl2an opoccl
      pmapsub eqeltrd ) CIJZEAKZLZEDMECNMZMZCOMZMZCPMZMZBADUSCVCVAEUSQZVAQZFVCQ
      ZHRURCUBJZVBCUCMZJZVDBJUPVHUQCUDSURCUEJZUTVIJZVJUPVKUQCUFSUPCUGJEVIKZVLUQ
      CUAUQAVIKVMAVICVIQZFUHEAVIUIUJVIEUSCVNVEUKULVICVAUTVNVFUMTVIBCVCVBVNGVGUN
      TUO $.
  $}

  ${
    $d p A $.  $d p K $.
    polssat.a $e |- A = ( Atoms ` K ) $.
    polssat.p $e |- ._|_ = ( _|_P ` K ) $.
    $( The polarity of a set of atoms is a set of atoms.  (Contributed by NM,
       24-Jan-2012.)  (New usage is discouraged.) $)
    polssatN $p |- ( ( K e. HL /\ X C_ A ) -> ( ._|_ ` X ) C_ A ) $=
      ( chlt wcel wss cfv cpsubsp eqid polsubN psubssat syldan ) BGHDAIDCJZBKJZ
      HPAIAQBCDEQLZFMAGQBPERNO $.

    $( The polarity of the empty projective subspace is the whole space.
       (Contributed by NM, 29-Oct-2011.)  (New usage is discouraged.) $)
    pol0N $p |- ( K e. B -> ( ._|_ ` (/) ) = A ) $=
      ( vp wcel c0 cfv cv coc cpmap ciin cin wss wceq 0ss eqid cvv polvalN 0iin
      mpan2 ineq2i inv1 eqtri syl6eq ) CBHZIDJZAGIGKCLJZJCMJZJZNZOZAUHIAPUIUNQA
      RABDCUKUJIGUJSEUKSFUAUCUNATOAUMTAGULUBUDAUEUFUG $.

    $( The polarity of the whole projective subspace is the empty space.
       Remark in [Holland95] p. 223.  (Contributed by NM, 24-Jan-2012.)
       (New usage is discouraged.) $)
    pol1N $p |- ( K e. HL -> ( ._|_ ` A ) = (/) ) $=
      ( vp chlt wcel cfv club coc cpmap cp0 c0 wss wceq ssid eqid fveq2d syl cv
      polval2N mpan2 cp1 cple crab wral cops hlop atbase ople1 syl2an ralrimiva
      wbr cbs rabid2 sylibr coml ccla cal w3a hlomcmat atlatmstc syl2anc eqtr2d
      op1cl opoc1 eqtr3d hlatl pmap0 3eqtrd ) BGHZACIZABJIZIZBKIZIZBLIZIZBMIZVR
      IZNVLAAOVMVSPAQACVNBVRVPAVNRZVPRZDVRRZEUBUCVLVQVTVRVLBUDIZVPIZVQVTVLWEVOV
      PVLVOFUAZWEBUEIZUNZFAUFZVNIZWEVLAWJVNVLWIFAUGAWJPVLWIFAVLBUHHZWGBUOIZHWIW
      GAHBUIZAWMWGBWMRZDUJWMWEBWHWGWOWHRZWERZUKULUMWIFAUPUQSVLBURHBUSHBUTHZVAWE
      WMHZWKWEPBVBVLWLWSWNWMWEBWOWQVFTFAWMVNBWHWEWOWPWBDVCVDVESVLWLWFVTPWNWEBVP
      VTVTRZWQWCVGTVHSVLWRWANPBVIBVRVTWTWDVJTVK $.
  $}

  ${
    2pol0.o $e |- ._|_ = ( _|_P ` K ) $.
    $( The closed subspace closure of the empty set.  (Contributed by NM,
       12-Sep-2013.)  (New usage is discouraged.) $)
    2pol0N $p |- ( K e. HL -> ( ._|_ ` ( ._|_ ` (/) ) ) = (/) ) $=
      ( chlt wcel c0 cfv catm eqid pol0N fveq2d pol1N eqtrd ) ADEZFBGZBGAHGZBGF
      NOPBPDABPIZCJKPABQCLM $.
  $}

  ${
    $d p B $.  $d p K $.  $d p X $.
    polpmap.b $e |- B = ( Base ` K ) $.
    polpmap.o $e |- ._|_ = ( oc ` K ) $.
    polpmap.m $e |- M = ( pmap ` K ) $.
    polpmap.p $e |- P = ( _|_P ` K ) $.
    $( The polarity of a projective map.  (Contributed by NM, 24-Jan-2012.)
       (New usage is discouraged.) $)
    polpmapN $p |- ( ( K e. HL /\ X e. B )
       -> ( P ` ( M ` X ) ) = ( M ` ( ._|_ ` X ) ) ) $=
      ( vp chlt wcel wa cfv club wceq eqid fveq2d eqtrd catm pmapssat syldan cv
      wss polval2N cple wbr crab pmapval coml ccla cal hlomcmat atlatmstc sylan
      w3a ) CLMZFAMZNZFDOZBOZVACPOZOZEOZDOZFEOZDOURUSVACUAOZUEVBVFQVHALCDFGVHRZ
      IUBVHBVCCDEVAVCRZHVIIJUFUCUTVEVGDUTVDFEUTVDKUDFCUGOZUHKVHUIZVCOZFUTVAVLVC
      VHALCVKDFKGVKRZVIIUJSURCUKMCULMCUMMUQUSVMFQCUNKVHAVCCVKFGVNVJVIUOUPTSST
      $.
  $}

  ${
    2polpmap.b $e |- B = ( Base ` K ) $.
    2polpmap.m $e |- M = ( pmap ` K ) $.
    2polpmap.p $e |- ._|_ = ( _|_P ` K ) $.
    $( Double polarity of a projective map.  (Contributed by NM, 24-Jan-2012.)
       (New usage is discouraged.) $)
    2polpmapN $p |- ( ( K e. HL /\ X e. B )
       -> ( ._|_ ` ( ._|_ ` ( M ` X ) ) ) = ( M ` X ) ) $=
      ( chlt wcel wa cfv coc eqid polpmapN fveq2d wceq cops hlop sylan opoccl
      syldan opococ 3eqtrd ) BIJZEAJZKZECLZDLZDLEBMLZLZCLZDLZUKUJLZCLZUHUGUIULD
      ADBCUJEFUJNZGHOPUEUFUKAJZUMUOQUEBRJZUFUQBSZABUJEFUPUATADBCUJUKFUPGHOUBUGU
      NECUEURUFUNEQUSABUJEFUPUCTPUD $.
  $}

  ${
    2polval.u $e |- U = ( lub ` K ) $.
    2polval.a $e |- A = ( Atoms ` K ) $.
    2polval.m $e |- M = ( pmap ` K ) $.
    2polval.p $e |- ._|_ = ( _|_P ` K ) $.
    $( Value of double polarity.  (Contributed by NM, 25-Jan-2012.)
       (New usage is discouraged.) $)
    2polvalN $p |- ( ( K e. HL /\ X C_ A )
     -> ( ._|_ ` ( ._|_ ` X ) ) = ( M ` ( U ` X ) ) ) $=
      ( chlt wcel wss wa cfv coc eqid fveq2d wceq syl2anc cops hlop adantr ccla
      polval2N cbs hlclat atssbase sstr clatlubcl syl2an opoccl polpmapN syldan
      mpan2 opococ 3eqtrd ) CKLZFAMZNZFEOZEOFBOZCPOZOZDOZEOZVDVCOZDOZVBDOUTVAVE
      EAEBCDVCFGVCQZHIJUERURUSVDCUFOZLZVFVHSUTCUALZVBVJLZVKURVLUSCUBUCZURCUDLFV
      JMZVMUSCUGUSAVJMVOAVJCVJQZHUHFAVJUIUOVJFBCVPGUJUKZVJCVCVBVPVIULTVJECDVCVD
      VPVIIJUMUNUTVGVBDUTVLVMVGVBSVNVQVJCVCVBVPVIUPTRUQ $.
  $}

  ${
    $d p A $.  $d p K $.  $d p X $.  $d p Y $.
    2polss.a $e |- A = ( Atoms ` K ) $.
    2polss.p $e |- ._|_ = ( _|_P ` K ) $.
    $( A set of atoms is a subset of its double polarity.  (Contributed by NM,
       29-Jan-2012.)  (New usage is discouraged.) $)
    2polssN $p |- ( ( K e. HL /\ X C_ A ) -> X C_ ( ._|_ ` ( ._|_ ` X ) ) ) $=
      ( vp chlt wcel wss wa cv crab club cfv cple wbr ccla eqid wceq cbs hlclat
      ad3antrrr simpr simpllr atssbase syl6ss lubel syl3anc ex ss2rabdv sseqin2
      cin dfin5 biimpi adantl syl5reqr cpmap 2polvalN sstr mpan2 syl2an pmapval
      clatlubcl syldan eqtrd 3sstr4d ) BHIZDAJZKZGLZDIZGAMZVKDBNOZOZBPOZQZGAMZD
      DCOCOZVJVLVQGAVJVKAIZKZVLVQWAVLKZBRIZVLDBUAOZJZVQVHWCVIVTVLBUBZUCWAVLUDWB
      DAWDVHVIVTVLUEAWDBWDSZEUFZUGWDDVNBVPVKWGVPSZVNSZUHUIUJUKVJVMADUMZDGADUNVI
      WKDTZVHVIWLDAULUOUPUQVJVSVOBUROZOZVRAVNBWMCDWJEWMSZFUSVHVIVOWDIZWNVRTVHWC
      WEWPVIWFVIAWDJWEWHDAWDUTVAWDDVNBWGWJVDVBAWDHBVPWMVOGWGWIEWOVCVEVFVG $.

    $( Triple polarity cancels to a single polarity.  (Contributed by NM,
       6-Mar-2012.)  (New usage is discouraged.) $)
    3polN $p |- ( ( K e. HL /\ S C_ A )
                  -> ( ._|_ ` ( ._|_ ` ( ._|_ ` S ) ) ) = ( ._|_ ` S ) ) $=
      ( chlt wcel wss wa club cfv cpmap coc cbs wceq ccla hlclat eqid atssbase
      mpan2 clatlubcl syl2an polpmapN syldan 2polvalN fveq2d polval2N 3eqtr4d
      sstr ) CGHZBAIZJZBCKLZLZCMLZLZDLZUOCNLZLUPLZBDLZDLZDLVAUKULUOCOLZHZURUTPU
      KCQHBVCIZVDULCRULAVCIVEAVCCVCSZETBAVCUJUAVCBUNCVFUNSZUBUCVCDCUPUSUOVFUSSZ
      UPSZFUDUEUMVBUQDAUNCUPDBVGEVIFUFUGADUNCUPUSBVGVHEVIFUHUI $.

    $( Contraposition law for polarity.  Remark in [Holland95] p. 223.
       (Contributed by NM, 23-Mar-2012.)  (New usage is discouraged.) $)
    polcon3N $p |- ( ( K e. HL /\ Y C_ A /\ X C_ Y )
      -> ( ._|_ ` Y ) C_ ( ._|_ ` X ) ) $=
      ( vp chlt wcel wss w3a cv coc cfv ciin cin wceq eqid polvalN cpmap iinss1
      simp3 sslin 3syl 3adant3 simp1 simp2 sstrd syl2anc 3sstr4d ) BIJZEAKZDEKZ
      LZAHEHMBNOZOBUAOZOZPZQZAHDURPZQZECOZDCOZUOUNUSVAKUTVBKULUMUNUCZHDEURUBUSV
      AAUDUEULUMVCUTRUNAICBUQUPEHUPSZFUQSZGTUFUOULDAKVDVBRULUMUNUGUODEAVEULUMUN
      UHUIAICBUQUPDHVFFVGGTUJUK $.

    $( Contraposition law for polarity.  (Contributed by NM, 6-Mar-2012.)
       (New usage is discouraged.) $)
    2polcon4bN $p |- ( ( K e. HL /\ X C_ A /\ Y C_ A ) ->
      ( ( ._|_ ` ( ._|_ ` X ) ) C_ ( ._|_ ` ( ._|_ ` Y ) ) <->
        ( ._|_ ` Y ) C_ ( ._|_ ` X ) ) ) $=
      ( wss wa simpl1 polssatN 3adant2 adantr simpr polcon3N syl3anc wceq 3polN
      cfv ex chlt wcel w3a simp1 syl2anc 3adant3 sseq12d sylibd impbid ) BUAUBZ
      DAHZEAHZUCZDCSZCSZECSZCSZHZUPUNHZUMURUQCSZUOCSZHZUSUMURVBUMURIUJUQAHZURVB
      UJUKULURJUMVCURUMUJUPAHZVCUJUKULUDUJULVDUKABCEFGKLABCUPFGKUEMUMURNABCUOUQ
      FGOPTUMUTUPVAUNUJULUTUPQUKAEBCFGRLUJUKVAUNQULADBCFGRUFUGUHUMUSURUMUSIUJUN
      AHZUSURUJUKULUSJUMVEUSUJUKVEULABCDFGKUFMUMUSNABCUPUNFGOPTUI $.

    $( Contraposition law for polarity.  (Contributed by NM, 23-Mar-2012.)
       (New usage is discouraged.) $)
    polcon2N $p |- ( ( K e. HL /\ Y C_ A /\ X C_ ( ._|_ ` Y ) )
          -> Y C_ ( ._|_ ` X ) ) $=
      ( chlt wcel wss cfv w3a 2polssN 3adant3 polssatN polcon3N syld3an2 sstrd
      ) BHIZEAJZDECKZJZLEUACKZDCKZSTEUCJUBABCEFGMNSUAAJZTUBUCUDJSTUEUBABCEFGONA
      BCDUAFGPQR $.

    $( Contraposition law for polarity.  (Contributed by NM, 23-Mar-2012.)
       (New usage is discouraged.) $)
    polcon2bN $p |- ( ( K e. HL /\ X C_ A /\ Y C_ A )
       -> ( X C_ ( ._|_ ` Y ) <-> Y C_ ( ._|_ ` X ) ) ) $=
      ( chlt wss w3a cfv wa simpl1 simpl3 simpr polcon2N syl3anc simpl2 impbida
      wcel ) BHTZDAIZEAIZJZDECKIZEDCKIZUDUELUAUCUEUFUAUBUCUEMUAUBUCUENUDUEOABCD
      EFGPQUDUFLUAUBUFUEUAUBUCUFMUAUBUCUFRUDUFOABCEDFGPQS $.
  $}

  ${
    pclss2pol.a $e |- A = ( Atoms ` K ) $.
    pclss2pol.o $e |- ._|_ = ( _|_P ` K ) $.
    pclss2pol.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure is a subset of closed subspace closure.
       (Contributed by NM, 12-Sep-2013.)  (New usage is discouraged.) $)
    pclss2polN $p |- ( ( K e. HL /\ X C_ A )
            -> ( U ` X ) C_ ( ._|_ ` ( ._|_ ` X ) ) ) $=
      ( chlt wcel wss cfv simpl 2polssN polssatN syldan pclssN syl3anc cpsubsp
      wa wceq eqid polsubN pclidN sseqtrd ) CIJZEAKZTZEBLZEDLZDLZBLZUKUHUFEUKKU
      KAKZUIULKUFUGMACDEFGNUFUGUJAKZUMACDEFGOZACDUJFGOPABCIEUKFHQRUFUGUKCSLZJZU
      LUKUAUFUGUNUQUOAUPCDUJFUPUBZGUCPUPBCIUKURHUDPUE $.
  $}

  ${
    pcl0.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure of the empty subspace.  (Contributed by
       NM, 12-Sep-2013.)  (New usage is discouraged.) $)
    pcl0N $p |- ( K e. HL -> ( U ` (/) ) = (/) ) $=
      ( chlt wcel c0 cfv wss wceq cpolN catm 0ss eqid pclss2polN 2pol0N sseqtrd
      mpan2 ss0 syl ) BDEZFAGZFHUAFITUAFBJGZGUBGZFTFBKGZHUAUCHUDLUDABUBFUDMUBMZ
      CNQBUBUEOPUARS $.
  $}

  ${
    pcl0b.a $e |- A = ( Atoms ` K ) $.
    pcl0b.c $e |- U = ( PCl ` K ) $.
    $( The projective subspace closure of the empty subspace.  (Contributed by
       NM, 13-Sep-2013.)  (New usage is discouraged.) $)
    pcl0bN $p |- ( ( K e. HL /\ P C_ A ) -> ( ( U ` P ) = (/) <-> P = (/) ) )
        $=
      ( chlt wcel wss wa cfv wceq pclssidN eqimss sylan9ss ss0 syl fveq2 pcl0N
      c0 sylan9eqr adantlr impbida ) DGHZBAIZJZBCKZTLZBTLZUFUHJBTIUIUFUHBUGTACD
      GBEFMUGTNOBPQUDUIUHUEUIUDUGTCKTBTCRCDFSUAUBUC $.
  $}

  ${
    $d p B $.  $d p K $.  $d p X $.
    pmaplub.b $e |- B = ( Base ` K ) $.
    pmaplub.u $e |- U = ( lub ` K ) $.
    pmaplub.m $e |- M = ( pmap ` K ) $.
    $( The LUB of a projective map is the projective map's argument.
       (Contributed by NM, 13-Mar-2012.)  (New usage is discouraged.) $)
    pmaplubN $p |- ( ( K e. HL /\ X e. B ) -> ( U ` ( M ` X ) ) = X ) $=
      ( vp chlt wcel wa cfv cv cple wbr catm crab eqid pmapval fveq2d coml ccla
      cal w3a wceq hlomcmat atlatmstc sylan eqtrd ) CJKZEAKZLZEDMZBMINECOMZPICQ
      MZRZBMZEUMUNUQBUPAJCUODEIFUOSZUPSZHTUAUKCUBKCUCKCUDKUEULUREUFCUGIUPABCUOE
      FUSGUTUHUIUJ $.
  $}

  ${
    sspmaplub.u $e |- U = ( lub ` K ) $.
    sspmaplub.a $e |- A = ( Atoms ` K ) $.
    sspmaplub.m $e |- M = ( pmap ` K ) $.
    $( A set of atoms is a subset of the projective map of its LUB.
       (Contributed by NM, 6-Mar-2012.)  (New usage is discouraged.) $)
    sspmaplubN $p |- ( ( K e. HL /\ S C_ A ) -> S C_ ( M ` ( U ` S ) ) ) $=
      ( chlt wcel wss wa cpolN cfv eqid 2polssN 2polvalN sseqtrd ) DIJBAKLBBDMN
      ZNSNBCNENADSBGSOZPACDESBFGHTQR $.

    $( Double projective map of an LUB. (Contributed by NM, 6-Mar-2012.)
       (New usage is discouraged.) $)
    2pmaplubN $p |- ( ( K e. HL /\ S C_ A )
         -> ( M ` ( U ` ( M ` ( U ` S ) ) ) ) = ( M ` ( U ` S ) ) ) $=
      ( chlt wcel wss wa cpolN cfv eqid 2polvalN fveq2d wceq syldan eqtr3d ccla
      polssatN 3polN cbs hlclat atssbase sstr mpan2 clatlubcl syl2an pmapssat )
      DIJZBAKZLZBDMNZNZUONZBCNZENZCNENZUSUNUSUONZUONZUQUTUNUQUONZUONZVBUQUNVCVA
      UOUNUQUSUOACDEUOBFGHUOOZPZQQULUMUPAKVDUQRADUOBGVEUBAUPDUOGVEUCSTULUMUSAKZ
      VBUTRULUMURDUDNZJZVGULDUAJBVHKZVIUMDUEUMAVHKVJAVHDVHOZGUFBAVHUGUHVHBCDVKF
      UIUJAVHIDEURVKGHUKSACDEUOUSFGHVEPSTVFT $.
  $}

  ${
    paddun.a $e |- A = ( Atoms ` K ) $.
    paddun.p $e |- .+ = ( +P ` K ) $.
    paddun.o $e |- ._|_ = ( _|_P ` K ) $.
    $( The closure of the projective sum of two sets of atoms is the same as
       the closure of their union.  (Closure is actually double polarity, which
       can be trivially inferred from this theorem using ~ fveq2d .)
       (Contributed by NM, 6-Mar-2012.)  (New usage is discouraged.) $)
    paddunN $p |- ( ( K e. HL /\ S C_ A /\ T C_ A )
         -> ( ._|_ ` ( S .+ T ) ) = ( ._|_ ` ( S u. T ) ) ) $=
      ( chlt wcel wss co cfv syl3anc eqid syl6ss clatlubcl syl2anc wceq w3a cun
      simp1 paddssat paddunssN polcon3N club cpmap cple wbr cbs hlclat 3ad2ant1
      ccla unss biimpi 3adant1 atssbase pmapssbaN polssatN 3adant3 3adant2 3jca
      cjn 2polssN paddss12 sylc 2polvalN oveq12d sseqtrd clat hllat simp2 simp3
      wa jca pmapjoin sstrd lubun fveq2d sseqtr4d lubss pmaple 2pmaplubN eqtr4d
      wb mpbid 3sstr4d 2polcon4bN eqssd ) EJKZCALZDALZUAZCDBMZFNZCDUBZFNZWNWKWO
      ALZWQWOLWPWRLWKWLWMUCZAJBECDGHUDZAJBECDGHUEAEFWQWOGIUFOWNWPFNZWRFNZLZWRWP
      LZWNWOEUGNZNZEUHNZNZWQXFNZXHNZXFNZXHNZXBXCWNXGXLEUINZUJZXIXMLZWNEUNKZXKEU
      KNZLZWOXKLXOWKWLXQWMEULUMZWNWKXJXRKZXSWTWNXQWQXRLYAXTWNWQAXRWLWMWQALZWKWL
      WMVOYBCDAUOUPUQZAXREXRPZGURZQXRWQXFEYDXFPZRSXRJEXHXJYDXHPZUSSZWNWOCXFNZDX
      FNZEVDNZMZXHNZXKWNWOYIXHNZYJXHNZBMZYMWNWOCFNZFNZDFNZFNZBMZYPWNWKYRALZYTAL
      ZUACYRLZDYTLZVOWOUUALWNWKUUBUUCWTWNWKYQALZUUBWTWKWLUUFWMAEFCGIUTVAAEFYQGI
      UTSWNWKYSALZUUCWTWKWMUUGWLAEFDGIUTVBAEFYSGIUTSVCWNUUDUUEWKWLUUDWMAEFCGIVE
      VAWKWMUUEWLAEFDGIVEVBVPAJBEYTCYRDGHVFVGWNYRYNYTYOBWKWLYRYNTWMAXFEXHFCYFGY
      GIVHVAWKWMYTYOTWLAXFEXHFDYFGYGIVHVBVIVJWNEVKKZYIXRKZYJXRKZYPYMLWKWLUUHWME
      VLUMWNXQCXRLZUUIXTWNCAXRWKWLWMVMYEQZXRCXFEYDYFRSWNXQDXRLZUUJXTWNDAXRWKWLW
      MVNYEQZXRDXFEYDYFRSXRBYKEXHYIYJYDYKPZYGHVQOVRWNXJYLXHWNXQUUKUUMXJYLTXTUUL
      UUNXRCDXFYKEYDUUOYFVSOVTWAXRWOXKXFEXNYDXNPZYFWBOWNWKXGXRKZXLXRKZXOXPWFWTW
      NXQWOXRLUUQXTWNWOAXRXAYEQXRWOXFEYDYFRSWNXQXSUURXTYHXRXKXFEYDYFRSXREXNXHXG
      XLYDUUPYGWCOWGWNWKWSXBXITWTXAAXFEXHFWOYFGYGIVHSWNXCXKXMWNWKYBXCXKTWTYCAXF
      EXHFWQYFGYGIVHSWNWKYBXMXKTWTYCAWQXFEXHYFGYGWDSWEWHWNWKWSYBXDXEWFWTXAYCAEF
      WOWQGIWIOWGWJ $.

    $( De Morgan's law for polarity of projective sum.  ( ~ oldmj1 analog.)
       (Contributed by NM, 7-Mar-2012.)  (New usage is discouraged.) $)
    poldmj1N $p |- ( ( K e. HL /\ S C_ A /\ T C_ A )
         -> ( ._|_ ` ( S .+ T ) ) = ( ( ._|_ ` S ) i^i ( ._|_ ` T ) ) ) $=
      ( wcel wss co cfv cin wceq eqid polval2N syl2anc 3ad2ant1 syl3anc w3a cun
      chlt club coc cpmap paddunN simp1 unss biimpi 3adant1 cmee cops hlop ccla
      wa cbs hlclat simp2 atssbase syl6ss clatlubcl opoccl simp3 pmapmeet lubun
      cjn fveq2d col hlol oldmj1 eqtrd 3adant3 3adant2 ineq12d 3eqtr4d 3eqtrd )
      EUCJZCAKZDAKZUAZCDBLFMCDUBZFMZWBEUDMZMZEUEMZMZEUFMZMZCFMZDFMZNZABCDEFGHIU
      GWAVRWBAKZWCWIOVRVSVTUHZVSVTWMVRVSVTUPWMCDAUIUJUKAFWDEWHWFWBWDPZWFPZGWHPZ
      IQRWACWDMZWFMZDWDMZWFMZEULMZLZWHMZWSWHMZXAWHMZNZWIWLWAVRWSEUQMZJZXAXHJZXD
      XGOWNWAEUMJZWRXHJZXIVRVSXKVTEUNSZWAEUOJZCXHKZXLVRVSXNVTEURSZWACAXHVRVSVTU
      SAXHEXHPZGUTZVAZXHCWDEXQWOVBRZXHEWFWRXQWPVCRWAXKWTXHJZXJXMWAXNDXHKZYAXPWA
      DAXHVRVSVTVDXRVAZXHDWDEXQWOVBRZXHEWFWTXQWPVCRAXHWHEXBWSXAXQXBPZGWQVETWAWG
      XCWHWAWGWRWTEVGMZLZWFMZXCWAWEYGWFWAXNXOYBWEYGOXPXSYCXHCDWDYFEXQYFPZWOVFTV
      HWAEVIJZXLYAYHXCOVRVSYJVTEVJSXTYDXHYFEXBWFWRWTXQYIYEWPVKTVLVHWAWJXEWKXFVR
      VSWJXEOVTAFWDEWHWFCWOWPGWQIQVMVRVTWKXFOVSAFWDEWHWFDWOWPGWQIQVNVOVPVQ $.
  $}

  ${
    pmapj2.b $e |- B = ( Base ` K ) $.
    pmapj2.j $e |- .\/ = ( join ` K ) $.
    pmapj2.m $e |- M = ( pmap ` K ) $.
    pmapj2.p $e |- .+ = ( +P ` K ) $.
    pmapj2.o $e |- ._|_ = ( _|_P ` K ) $.
    $( The projective map of the join of two lattice elements.  (Contributed by
       NM, 14-Mar-2012.)  (New usage is discouraged.) $)
    pmapj2N $p |- ( ( K e. HL /\ X e. B /\ Y e. B ) -> ( M ` ( X .\/ Y ) ) =
      ( ._|_ ` ( ._|_ ` ( ( M ` X ) .+ ( M ` Y ) ) ) ) ) $=
      ( chlt wcel cfv co wceq eqid syl2anc w3a coc cmee clat 3ad2ant1 cops hlop
      simp1 hllat simp2 opoccl simp3 latmcl syl3anc cin 3adant3 3adant2 ineq12d
      polpmapN catm wss pmapssat poldmj1N pmapmeet 3eqtr4rd fveq2d hlol syl3an1
      col oldmm4 3eqtr3rd ) DNOZGAOZHAOZUAZGDUBPZPZHVPPZDUCPZQZEPZFPZVTVPPZEPZG
      EPZHEPZBQFPZFPGHCQZEPVOVLVTAOZWBWDRVLVMVNUHZVODUDOZVQAOZVRAOZWIVLVMWKVNDU
      IUEVODUFOZVMWLVLVMWNVNDUGUEZVLVMVNUJADVPGIVPSZUKTZVOWNVNWMWOVLVMVNULADVPH
      IWPUKTZADVSVQVRIVSSZUMUNAFDEVPVTIWPKMUSTVOWAWGFVOWEFPZWFFPZUOZVQEPZVREPZU
      OZWGWAVOWTXCXAXDVLVMWTXCRVNAFDEVPGIWPKMUSUPVLVNXAXDRVMAFDEVPHIWPKMUSUQURV
      OVLWEDUTPZVAZWFXFVAZWGXBRWJVLVMXGVNXFANDEGIXFSZKVBUPVLVNXHVMXFANDEHIXIKVB
      UQXFBWEWFDFXILMVCUNVOVLWLWMWAXERWJWQWRXFAEDVSVQVRIWSXIKVDUNVEVFVOWCWHEVLD
      VIOVMVNWCWHRDVGACDVSVPGHIJWSWPVJVHVFVK $.
  $}

  ${
    pmapocj.b $e |- B = ( Base ` K ) $.
    pmapocj.j $e |- .\/ = ( join ` K ) $.
    pmapocj.m $e |- ./\ = ( meet ` K ) $.
    pmapocj.o $e |- ._|_ = ( oc ` K ) $.
    pmapocj.f $e |- F = ( pmap ` K ) $.
    pmapocj.p $e |- .+ = ( +P ` K ) $.
    pmapocj.r $e |- N = ( _|_P ` K ) $.
    $( The projective map of the orthocomplement of the join of two lattice
       elements.  (Contributed by NM, 14-Mar-2012.)
       (New usage is discouraged.) $)
    pmapocjN $p |- ( ( K e. HL /\ X e. B /\ Y e. B )
    -> ( F ` ( ._|_ ` ( X .\/ Y ) ) ) = ( N ` ( ( F ` X ) .+ ( F ` Y ) ) ) ) $=
      ( chlt wcel cfv w3a pmapj2N fveq2d wceq simp1 clat hllat syl3an1 polpmapN
      co latjcl syl2anc catm wss eqid pmapssat 3adant3 3adant2 paddssat syl3anc
      3polN 3eqtr3d ) ERSZIASZJASZUAZIJDUJZCTZGTZICTZJCTZBUJZGTZGTZGTZVGHTCTZVM
      VFVHVNGABDECGIJKLOPQUBUCVFVCVGASZVIVPUDVCVDVEUEZVCEUFSVDVEVQEUGADEIJKLUKU
      HAGECHVGKNOQUIULVFVCVLEUMTZUNZVOVMUDVRVFVCVJVSUNZVKVSUNZVTVRVCVDWAVEVSARE
      CIKVSUOZOUPUQVCVEWBVDVSARECJKWCOUPURVSRBEVJVKWCPUSUTVSVLEGWCQVAULVB $.
  $}

  ${
    $d p A $.  $d p K $.  $d p M $.  $d p ._|_ $.  $d p Q $.
    polat.o $e |- ._|_ = ( oc ` K ) $.
    polat.a $e |- A = ( Atoms ` K ) $.
    polat.m $e |- M = ( pmap ` K ) $.
    polat.p $e |- P = ( _|_P ` K ) $.
    $( The polarity of the singleton of an atom (i.e. a point).  (Contributed
       by NM, 14-Jan-2012.)  (New usage is discouraged.) $)
    polatN $p |- ( ( K e. OL /\ Q e. A )
                  -> ( P ` { Q } ) = ( M ` ( ._|_ ` Q ) ) ) $=
      ( vp col wcel wa csn cfv cv cin wss wceq ciin snssi polvalN sylan2 fveq2d
      fveq2 iinxsng adantl ineq2d cbs cops atbase opoccl syl2an pmapssat syldan
      olop eqid sseqin2 sylib 3eqtrd ) DLMZCAMZNZCOZBPZAKVEKQZFPZEPZUAZRZACFPZE
      PZRZVMVCVBVEASVFVKTCAUBALBDEFVEKGHIJUCUDVDVJVMAVCVJVMTVBKCVIVMAVGCTVHVLEV
      GCFUFUEUGUHUIVDVMASZVNVMTVBVCVLDUJPZMZVOVBDUKMCVPMVQVCDUQAVPCDVPURZHULVPD
      FCVRGUMUNAVPLDEVLVRHIUOUPVMAUSUTVA $.
  $}

  ${
    2polat.a $e |- A = ( Atoms ` K ) $.
    2polat.p $e |- P = ( _|_P ` K ) $.
    $( Double polarity of the singleton of an atom (i.e. a point).
       (Contributed by NM, 25-Jan-2012.)  (New usage is discouraged.) $)
    2polatN $p |- ( ( K e. HL /\ Q e. A )
                  -> ( P ` ( P ` { Q } ) ) = { Q } ) $=
      ( chlt wcel wa csn cfv coc cpmap col wceq hlol eqid fveq2d syl2an eqtrd
      polatN sylan cbs cops hlop atbase opoccl polpmapN syldan opococ pmapat )
      DGHZCAHZIZCJZBKZBKCDLKZKZDMKZKZBKZUOUNUPUTBULDNHUMUPUTODPABCDUSUQUQQZEUSQ
      ZFUAUBRUNVAURUQKZUSKZUOULUMURDUCKZHZVAVEOULDUDHZCVFHZVGUMDUEZAVFCDVFQZEUF
      ZVFDUQCVKVBUGSVFBDUSUQURVKVBVCFUHUIUNVECUSKUOUNVDCUSULVHVIVDCOUMVJVLVFDUQ
      CVKVBUJSRACDUSEVCUKTTT $.

    $( The intersection of a set of atoms and its polarity is empty.
       Definition of nonsingular in [Holland95] p. 214.  (Contributed by NM,
       29-Jan-2012.)  (New usage is discouraged.) $)
    pnonsingN $p |- ( ( K e. HL /\ X C_ A ) -> ( X i^i ( P ` X ) ) = (/) ) $=
      ( chlt wcel wss wa cfv cin c0 wceq 2polssN ssrin syl eqid adantr syl2anc
      club cpmap coc 2polvalN polval2N ineq12d cmee co cp0 cops cbs hlop hlclat
      ccla atssbase sstr mpan2 clatlubcl syl2an opnoncon fveq2d opoccl pmapmeet
      simpl syl3anc cal hlatl pmap0 3eqtr3d eqtrd sseqtrd ss0b sylib ) CGHZDAIZ
      JZDDBKZLZMIVRMNVPVRVQBKZVQLZMVPDVSIVRVTIACBDEFODVSVQPQVPVTDCUAKZKZCUBKZKZ
      WBCUCKZKZWCKZLZMVPVSWDVQWGAWACWCBDWARZEWCRZFUDABWACWCWEDWIWERZEWJFUEUFVPW
      BWFCUGKZUHZWCKZCUIKZWCKZWHMVPWMWOWCVPCUJHZWBCUKKZHZWMWONVNWQVOCULSZVNCUNH
      DWRIZWSVOCUMVOAWRIXAAWRCWRRZEUODAWRUPUQWRDWACXBWIURUSZWRCWLWEWBWOXBWKWLRZ
      WORZUTTVAVPVNWSWFWRHZWNWHNVNVOVDXCVPWQWSXFWTXCWRCWEWBXBWKVBTAWRWCCWLWBWFX
      BXDEWJVCVEVPCVFHZWPMNVNXGVOCVGSCWCWOXEWJVHQVIVJVKVRVLVM $.
  $}

  $c PSubCl $.

  $( Extend class notation with set of all closed projective subspaces for a
     Hilbert lattice. $)
  cpscN $a class PSubCl $.

  ${
    $d k s l $.
    $( Define set of all closed projective subspaces, which are those sets of
       atoms that equal their double polarity.  Based on definition in
       [Holland95] p. 223.  (Contributed by NM, 23-Jan-2012.) $)
    df-psubclN $a |- PSubCl = ( k e. _V |-> { s | ( s C_ ( Atoms ` k )
       /\ ( ( _|_P ` k ) ` ( ( _|_P ` k ) ` s ) ) = s ) } ) $.
  $}

  ${
    $d k s A $.  $d k s K $.  $d k ._|_ $.
    psubclset.a $e |- A = ( Atoms ` K ) $.
    psubclset.p $e |- ._|_ = ( _|_P ` K ) $.
    psubclset.c $e |- C = ( PSubCl ` K ) $.
    $( The set of closed projective subspaces in a Hilbert lattice.
       (Contributed by NM, 23-Jan-2012.)  (New usage is discouraged.) $)
    psubclsetN $p |- ( K e. B -> C = { s | ( s C_ A /\
         ( ._|_ ` ( ._|_ ` s ) ) = s ) } ) $=
      ( vk wcel cvv cv wss cfv wceq wa cab catm cpolN elex cpscN syl6eqr sseq2d
      fveq2 fveq1d fveq12d eqeq1d anbi12d abbidv df-psubclN cpw fvex pwex df-pw
      eqeltri abeq2i anbi1i abbii ssab2 eqsstr3i ssexi fvmpt syl5eq syl ) DBKDL
      KZCFMZANZVGEOZEOZVGPZQZFRZPDBUAVFCDUBOVMIJDVGJMZSOZNZVGVNTOZOZVQOZVGPZQZF
      RVMLUBVNDPZWAVLFWBVPVHVTVKWBVOAVGWBVODSOZAVNDSUEGUCUDWBVSVJVGWBVRVIVQEWBV
      QDTOEVNDTUEHUCZWBVGVQEWDUFUGUHUIUJJFUKVMAULZAAWCLGDSUMUPUNVMVGWEKZVKQZFRW
      EWGVLFWFVHVKVHFWEFAUOUQURUSVKFWEUTVAVBVCVDVE $.

    $d x A $.  $d x K $.  $d x ._|_ $.  $d x X $.
    $( The predicate "is a closed projective subspace".  (Contributed by NM,
       23-Jan-2012.)  (New usage is discouraged.) $)
    ispsubclN $p |- ( K e. D -> ( X e. C <-> ( X C_ A
         /\ ( ._|_ ` ( ._|_ ` X ) ) = X ) ) ) $=
      ( vx wcel cv wss cfv wceq wa cab psubclsetN cvv catm eleq2d eqeltri sseq1
      fvex ssex adantr fveq2 fveq2d id eqeq12d anbi12d elab3 syl6bb ) DCKZFBKFJ
      LZAMZUOENZENZUOOZPZJQZKFAMZFENZENZFOZPZUNBVAFACBDEJGHIRUAUTVFJFVBFSKVEFAA
      DTNSGDTUDUBUEUFUOFOZUPVBUSVEUOFAUCVGURVDUOFVGUQVCEUOFEUGUHVGUIUJUKULUM $.

    $( Property of a closed projective subspace.  (Contributed by NM,
       23-Jan-2012.)  (New usage is discouraged.) $)
    psubcliN $p |- ( ( K e. D /\ X e. C )
         -> ( X C_ A /\ ( ._|_ ` ( ._|_ ` X ) ) = X ) ) $=
      ( wcel wss cfv wceq wa ispsubclN biimpa ) DCJFBJFAKFELELFMNABCDEFGHIOP $.
  $}

  ${
    psubcli2.p $e |- ._|_ = ( _|_P ` K ) $.
    psubcli2.c $e |- C = ( PSubCl ` K ) $.
    $( Property of a closed projective subspace.  (Contributed by NM,
       23-Jan-2012.)  (New usage is discouraged.) $)
    psubcli2N $p |- ( ( K e. D /\ X e. C ) -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $=
      ( wcel catm cfv wss wceq eqid ispsubclN simplbda ) CBHEAHECIJZKEDJDJELPAB
      CDEPMFGNO $.
  $}

  ${
    psubclsub.s $e |- S = ( PSubSp ` K ) $.
    psubclsub.c $e |- C = ( PSubCl ` K ) $.
    $( A closed projective subspace is a projective subspace.  (Contributed by
       NM, 23-Jan-2012.)  (New usage is discouraged.) $)
    psubclsubN $p |- ( ( K e. HL /\ X e. C ) -> X e. S ) $=
      ( chlt wcel wa cpolN cfv eqid psubcli2N catm wceq psubcliN simpld polsubN
      wss syldan psubssat eqeltrrd ) CGHZDAHZIZDCJKZKZUFKZDBAGCUFDUFLZFMUCUDUGC
      NKZSZUHBHUCUDUGBHZUKUCUDDUJSZULUEUMUHDOUJAGCUFDUJLZUIFPQUJBCUFDUNEUIRTUJG
      BCUGUNEUATUJBCUFUGUNEUIRTUB $.
  $}

  ${
    psubclssat.a $e |- A = ( Atoms ` K ) $.
    psubclssat.c $e |- C = ( PSubCl ` K ) $.
    $( A closed projective subspace is a set of atoms.  (Contributed by NM,
       25-Jan-2012.)  (New usage is discouraged.) $)
    psubclssatN $p |- ( ( K e. D /\ X e. C ) -> X C_ A ) $=
      ( wcel wa wss cpolN cfv wceq eqid psubcliN simpld ) DCHEBHIEAJEDKLZLQLEMA
      BCDQEFQNGOP $.
  $}

  ${
    pmapidcl.u $e |- U = ( lub ` K ) $.
    pmapidcl.m $e |- M = ( pmap ` K ) $.
    pmapidcl.c $e |- C = ( PSubCl ` K ) $.
    $( Projective map of the LUB of a closed subspace.  (Contributed by NM,
       3-Feb-2012.)  (New usage is discouraged.) $)
    pmapidclN $p |- ( ( K e. HL /\ X e. C ) -> ( M ` ( U ` X ) ) = X ) $=
      ( chlt wcel wa cpolN cfv catm wss wceq eqid psubclssatN 2polvalN syldan
      psubcli2N eqtr3d ) CIJZEAJZKECLMZMUEMZEBMDMZEUCUDECNMZOUFUGPUHAICEUHQZHRU
      HBCDUEEFUIGUEQZSTAICUEEUJHUAUB $.
  $}

  ${
    0psubcl.c $e |- C = ( PSubCl ` K ) $.
    $( The empty set is a closed projective subspace.  (Contributed by NM,
       25-Jan-2012.)  (New usage is discouraged.) $)
    0psubclN $p |- ( K e. HL -> (/) e. C ) $=
      ( chlt wcel c0 catm cfv wss cpolN wceq 0ss a1i 2pol0N ispsubclN mpbir2and
      eqid ) BDEZFAEFBGHZIZFBJHZHUAHFKTRSLMBUAUAQZNSADBUAFSQUBCOP $.
  $}

  ${
    1psubcl.a $e |- A = ( Atoms ` K ) $.
    1psubcl.c $e |- C = ( PSubCl ` K ) $.
    $( The set of all atoms is a closed projective subspace.  (Contributed by
       NM, 25-Jan-2012.)  (New usage is discouraged.) $)
    1psubclN $p |- ( K e. HL -> A e. C ) $=
      ( chlt wcel wss cpolN cfv wceq ssid a1i eqid pol1N fveq2d pol0N ispsubclN
      c0 eqtrd mpbir2and ) CFGZABGAAHZACIJZJZUDJZAKUCUBALMUBUFSUDJAUBUESUDACUDD
      UDNZOPAFCUDDUGQTABFCUDADUGERUA $.

    $( A point (singleton of an atom) is a closed projective subspace.
       (Contributed by NM, 25-Jan-2012.)  (New usage is discouraged.) $)
    atpsubclN $p |- ( ( K e. HL /\ Q e. A ) -> { Q } e. C ) $=
      ( chlt wcel wa csn wss cpolN cfv wceq snssi adantl eqid 2polatN ispsubclN
      wb adantr mpbir2and ) DGHZCAHZICJZBHZUEAKZUEDLMZMUHMUENZUDUGUCCAOPAUHCDEU
      HQZRUCUFUGUIITUDABGDUHUEEUJFSUAUB $.
  $}

  ${
    pmapsubcl.b $e |- B = ( Base ` K ) $.
    pmapsubcl.m $e |- M = ( pmap ` K ) $.
    pmapsubcl.c $e |- C = ( PSubCl ` K ) $.
    $( A projective map value is a closed projective subspace.  (Contributed by
       NM, 24-Jan-2012.)  (New usage is discouraged.) $)
    pmapsubclN $p |- ( ( K e. HL /\ X e. B ) -> ( M ` X ) e. C ) $=
      ( chlt wcel wa cfv catm wss cpolN wceq eqid pmapssat 2polpmapN wb adantr
      ispsubclN mpbir2and ) CIJZEAJZKEDLZBJZUFCMLZNZUFCOLZLUJLUFPZUHAICDEFUHQZG
      RACDUJEFGUJQZSUDUGUIUKKTUEUHBICUJUFULUMHUBUAUC $.

    $d y B $.  $d y K $.  $d y M $.  $d y X $.
    $( Alternate predicate for "is a closed projective subspace".  Remark in
       [Holland95] p. 223.  (Contributed by NM, 24-Jan-2012.)
       (New usage is discouraged.) $)
    ispsubcl2N $p |- ( K e. HL -> ( X e. C <-> E. y e. B X = ( M ` y ) ) ) $=
      ( chlt wcel cfv wss wceq wa eqid adantr syl2anc ex wi catm wrex ispsubclN
      cpolN club coc cops hlop hlclat polssatN atssbase syl6ss clatlubcl opoccl
      ccla adantrd polval2N syldan eqeq1 biimpcd syl6 imp3a fveq2 eqeq2d rspcev
      cv jcad pmapssat 2polpmapN sseq1 fveq2d eqeq12d biimprcd rexlimdva impbid
      id anbi12d bitrd ) DJKZFCKFDUALZMZFDUDLZLZWBLZFNZOZFAVFZELZNZABUBZVTCJDWB
      FVTPZWBPZIUCVSWFWJVSWFWCDUELZLZDUFLZLZBKZFWPELZNZOWJVSWFWQWSVSWAWQWEVSWAW
      QVSWAOZDUGKZWNBKZWQVSXAWADUHQWTDUOKZWCBMXBVSXCWADUIQWTWCVTBVTDWBFWKWLUJZV
      TBDGWKUKULBWCWMDGWMPZUMRBDWOWNGWOPZUNRSUPVSWAWEWSVSWAWDWRNZWEWSTVSWAXGVSW
      AWCVTMXGXDVTWBWMDEWOWCXEXFWKHWLUQURSWEXGWSWDFWRUSUTVAVBVGWIWSAWPBWGWPNWHW
      RFWGWPEVCVDVEVAVSWIWFABVSWGBKOWHVTMZWHWBLZWBLZWHNZWIWFTVTBJDEWGGWKHVHBDEW
      BWGGHWLVIWIWFXHXKOWIWAXHWEXKFWHVTVJWIWDXJFWHWIWCXIWBFWHWBVCVKWIVPVLVQVMRV
      NVOVR $.
  $}

  ${
    psubclin.c $e |- C = ( PSubCl ` K ) $.
    $( The intersection of two closed subspaces is closed.  (Contributed by NM,
       25-Mar-2012.)  (New usage is discouraged.) $)
    psubclinN $p |- ( ( K e. HL /\ X e. C /\ Y e. C ) -> ( X i^i Y ) e. C ) $=
      ( chlt wcel cfv cin wceq 3ad2ant1 eqid psubclssatN 3adant3 syl6ss syl2anc
      wss clatlubcl 3adant2 syl3anc w3a club cmee co cpmap cbs ccla hlclat catm
      simp1 atssbase pmapmeet pmapidclN ineq12d eqtrd hllat pmapsubclN eqeltrrd
      clat latmcl ) BFGZCAGZDAGZUAZCBUBHZHZDVEHZBUCHZUDZBUEHZHZCDIZAVDVKVFVJHZV
      GVJHZIZVLVDVAVFBUFHZGZVGVPGZVKVOJVAVBVCUJZVDBUGGZCVPQVQVAVBVTVCBUHKZVDCBU
      IHZVPVAVBCWBQVCWBAFBCWBLZEMNWBVPBVPLZWCUKZOVPCVEBWDVELZRPZVDVTDVPQVRWAVDD
      WBVPVAVCDWBQVBWBAFBDWCEMSWEOVPDVEBWDWFRPZWBVPVJBVHVFVGWDVHLZWCVJLZULTVDVM
      CVNDVAVBVMCJVCAVEBVJCWFWJEUMNVAVCVNDJVBAVEBVJDWFWJEUMSUNUOVDVAVIVPGZVKAGV
      SVDBUSGZVQVRWKVAVBWLVCBUPKWGWHVPBVHVFVGWDWIUTTVPABVJVIWDWJEUQPUR $.
  $}

  ${
    paddatcl.a $e |- A = ( Atoms ` K ) $.
    paddatcl.p $e |- .+ = ( +P ` K ) $.
    paddatcl.c $e |- C = ( PSubCl ` K ) $.
    $( The projective sum of a closed subspace and an atom is a closed
       projective subspace.  (Contributed by NM, 3-Feb-2012.)
       (New usage is discouraged.) $)
    paddatclN $p |- ( ( K e. HL /\ X e. C /\ Q e. A )
     -> ( X .+ { Q } ) e. C ) $=
      ( chlt wcel w3a csn co cfv wceq 3ad2ant1 eqid 3adant3 syl2anc cjn cbs wss
      club cpmap hlclat psubclssatN atssbase syl6ss clatlubcl pmapjat1 syld3an2
      ccla wa pmapidclN pmapat 3adant2 oveq12d eqtr2d simp1 clat hllat 3ad2ant3
      atbase latjcl syl3anc pmapsubclN eqeltrd ) EJKZFBKZDAKZLZFDMZCNZFEUDOZOZD
      EUAOZNZEUEOZOZBVLVTVPVSOZDVSOZCNZVNVIVPEUBOZKZVJVKVTWCPVLEUMKZFWDUCZWEVIV
      JWFVKEUFQVIVJWGVKVIVJUNFAWDABJEFGIUGAWDEWDRZGUHUISWDFVOEWHVORZUJTZAWDCDVQ
      EVSVPWHVQRZGVSRZHUKULVLWAFWBVMCVIVJWAFPVKBVOEVSFWIWLIUOSVIVKWBVMPVJADEVSG
      WLUPUQURUSVLVIVRWDKZVTBKVIVJVKUTVLEVAKZWEDWDKZWMVIVJWNVKEVBQWJVKVIWOVJAWD
      DEWHGVDVCWDVQEVPDWHWKVEVFWDBEVSVRWHWLIVGTVH $.
  $}

  ${
    $d p q w x y z A $.  $d p q w x y z U $.  $d p q w x y z K $.
    $d p q w x y z S $.  $d x y z X $.
    pclfincl.a $e |- A = ( Atoms ` K ) $.
    pclfincl.c $e |- U = ( PCl ` K ) $.
    pclfincl.s $e |- S = ( PSubCl ` K ) $.
    $( The projective subspace closure of a finite set of atoms is a closed
       subspace.  Compare the (non-closed) subspace version ~ pclfinN and also
       ~ pclcmpatN .  (Contributed by NM, 13-Sep-2013.)
       (New usage is discouraged.) $)
    pclfinclN $p |- ( ( K e. HL /\ X C_ A /\ X e. Fin ) -> ( U ` X ) e. S ) $=
      ( vw vp wcel chlt wss cfv cv wa wi c0 wceq syl2anc vx vy vz cfn csn sseq1
      vq cun anbi2d fveq2 eleq1d imbi12d pcl0N 0psubclN eqeltrd adantr vex snss
      anass anbi2i unss bitri bitr2i simpllr uneq1d uncom syl6eq fveq2d cpsubsp
      un0 eqtri simplrl cal hlatl simprr snatpsubN pclidN eqtrd atpsubclN exp43
      syl eqid wne cpadd co pclssidN ad2antlr unss1 simprl psubclssatN ad2antll
      snssi paddunssN syl3anc paddssat pclssN paddatclN psubclsubN sseqtrd wral
      sstrd wel cjn cple wbr wrex clat hllat pcl0bN necon3bid elpaddat syl31anc
      wb mpbird w3a simp1rl 3ad2ant1 simpl13 simpl sylbir simpl2 elpcliN adantl
      biimpri simpl3 psubspi2N syl33anc exp520 rexlimdv 3expia ralrimdv simplrr
      imp3a sylbid jca sylib elpclN sylibrd ssrdv eqssd pm2.61dane imp4b syl5bi
      a2d ex findcard2 3impib 3coml ) EUDKZDLKZEAMZECNZBKZUUIUUJUUKUUMUUJUAOZAM
      ZPZUUNCNZBKZQUUJRAMZPZRCNZBKZQUUJUBOZAMZPZUVCCNZBKZQZUUJUVCUCOZUEZUHZAMZP
      ZUVKCNZBKZQZUUJUUKPZUUMQUAUBUCEUUNRSZUUPUUTUURUVBUVRUUOUUSUUJUUNRAUFUIUVR
      UUQUVABUUNRCUJUKULUUNUVCSZUUPUVEUURUVGUVSUUOUVDUUJUUNUVCAUFUIUVSUUQUVFBUU
      NUVCCUJUKULUUNUVKSZUUPUVMUURUVOUVTUUOUVLUUJUUNUVKAUFUIUVTUUQUVNBUUNUVKCUJ
      UKULUUNESZUUPUVQUURUUMUWAUUOUUKUUJUUNEAUFUIUWAUUQUULBUUNECUJUKULUUJUVBUUS
      UUJUVARBCDGUMBDHUNUOUPUVCUDKZUVHUVPUVMUVEUVIAKZPZUWBUVHPUVOUWDUUJUVDUWCPZ
      PUVMUUJUVDUWCUSUWEUVLUUJUWEUVDUVJAMZPUVLUWCUWFUVDUVIAUCUQZURUTUVCUVJAVAVB
      ZUTVCUWBUVHUVEUWCUVOUWBUVEUVGUWCUVOQZUWBUVEUVGUWIQQUVCRUWBUVCRSZPZUVEUVGU
      WCUVOUWKUVEPZUVGUWCPZPZUVNUVJBUWNUVNUVJCNZUVJUWNUVKUVJCUWNUVKRUVJUHZUVJUW
      NUVCRUVJUWBUWJUVEUWMVDVEUWPUVJRUHUVJRUVJVFUVJVJVKVGVHUWNUUJUVJDVINZKZUWOU
      VJSUWKUUJUVDUWMVLZUWNDVMKZUWCUWRUWNUUJUWTUWSDVNWAUWLUVGUWCVOZAUVIUWQDFUWQ
      WBZVPTUWQCDLUVJUXBGVQTVRUWNUUJUWCUVJBKUWSUXAABUVIDFHVSTUOVTUWBUVCRWCZPZUV
      EUVGUWCUVOUXDUVEPZUWMPZUVNUVFUVJDWDNZWEZBUXFUVNUXHUXFUVNUXHCNZUXHUXFUUJUV
      KUXHMUXHAMZUVNUXIMUXDUUJUVDUWMVLZUXFUVKUVFUVJUHZUXHUXFUVCUVFMZUVKUXLMUVEU
      XMUXDUWMACDLUVCFGWFWGUVCUVFUVJWHWAUXFUUJUVFAMZUWFUXLUXHMUXKUXFUUJUVGUXNUX
      KUXEUVGUWCWIZABLDUVFFHWJTZUWCUWFUXEUVGUVIAWLWKZALUXGDUVFUVJFUXGWBZWMWNXAU
      XFUUJUXNUWFUXJUXKUXPUXQALUXGDUVFUVJFUXRWOWNACDLUVKUXHFGWPWNUXFUUJUXHUWQKZ
      UXIUXHSUXKUXFUUJUXHBKZUXSUXKUXFUUJUVGUWCUXTUXKUXOUXEUVGUWCVOZABUXGUVIDUVF
      FUXRHWQWNZBUWQDUXHUXBHWRTUWQCDLUXHUXBGVQTWSUXFUGUXHUVNUXFUGOZUXHKZUVKIOZM
      ZUGIXBZQZIUWQWTZUYCUVNKZUXFUYDUYHIUWQUXFUYDUYCAKZUYCJOZUVIDXCNZWEDXDNZXEZ
      JUVFXFZPZUYEUWQKZUYHQZUXFDXGKZUXNUWCUVFRWCZUYDUYQXMUXFUUJUYTUXKDXHWAUXPUY
      AUXFVUAUXCUWBUXCUVEUWMVDUXFUVFRUVCRUVEUVFRSUWJXMUXDUWMAUVCCDFGXIWGXJXNAUX
      GUVIUYCUYMDUYNUVFJUYNWBZUYMWBZFUXRXKXLUXFUYKUYPUYSUXEUWMUYKUYPUYSQUXEUWMU
      YKXOZUYOUYSJUVFVUDUYLUVFKZUYOUYRUYFUYGVUDVUEUYOXOZUYRUYFPZPZUUJUYRUYKJIXB
      ZUCIXBZUYOUYGVUFUUJVUGVUDVUEUUJUYOUUJUVDUXDUWMUYKXPXQUPZVUFUYRUYFWIZUXEUW
      MUYKVUEUYOVUGXRVUHUUJUVCUYEMZUYRVUEVUIVUKUYFVUMVUFUYRUYFVUMUVJUYEMZPZVUMU
      VCUVJUYEVAZVUMVUNXSXTWKVULVUDVUEUYOVUGYAUYLUWQCDLUVCUYEUXBGYBXLUYFVUJVUFU
      YRUYFVUOVUJVUPVUNVUJVUMVUJVUNUVIUYEUWGURYDYCXTWKVUDVUEUYOVUGYEALUYCUYLUVI
      UWQUYMDUYNUYEVUBVUCFUXBYFYGYHYIYJYMYNYKUXFUUJUVLUYJUYIXMUXKUXFUWEUVLUXFUV
      DUWCUXDUUJUVDUWMYLUYAYOUWHYPIAUYCUWQCDLUVKFUXBGUGUQYQTYRYSYTUYBUOVTUUAUUD
      UUBUUCUUEUUFUUGUUH $.
  $}

  ${
    $d p q C $.  $d p q K $.  $d p q X $.
    linepsubcl.n $e |- N = ( Lines ` K ) $.
    linepsubcl.c $e |- C = ( PSubCl ` K ) $.
    $( A line is a closed projective subspace.  (Contributed by NM,
       25-Jan-2012.)  (New usage is discouraged.) $)
    linepsubclN $p |- ( ( K e. HL /\ X e. N ) -> X e. C ) $=
      ( vp vq chlt wcel cv wne cjn cfv co wa wrex eqid syl atbase cpmap wceq wb
      catm clat hllat isline2 wi cbs adantr ad2antrl ad2antll latjcl pmapsubclN
      syl3anc syldan eleq1a adantld rexlimdvva sylbid imp ) BIJZDCJZDAJZVBVCGKZ
      HKZLZDVEVFBMNZOZBUANZNZUBZPZHBUDNZQGVNQZVDVBBUEJZVCVOUCBUFZVNVHBVJCDHGVHR
      ZVNRZEVJRZUGSVBVMVDGHVNVNVBVEVNJZVFVNJZPZPZVLVDVGWDVKAJZVLVDUHVBWCVIBUINZ
      JZWEWDVPVEWFJZVFWFJZWGVBVPWCVQUJWAWHVBWBVNWFVEBWFRZVSTUKWBWIVBWAVNWFVFBWJ
      VSTULWFVHBVEVFWJVRUMUOWFABVJVIWJVTFUNUPVKADUQSURUSUTVA $.
  $}

  ${
    polsubcl.a $e |- A = ( Atoms ` K ) $.
    polsubcl.p $e |- ._|_ = ( _|_P ` K ) $.
    polsubcl.c $e |- C = ( PSubCl ` K ) $.
    $( A polarity is a closed projective subspace.  (Contributed by NM,
       24-Jan-2012.)  (New usage is discouraged.) $)
    polsubclN $p |- ( ( K e. HL /\ X C_ A ) -> ( ._|_ ` X ) e. C ) $=
      ( chlt wcel wss wa cfv club coc cpmap eqid polval2N cbs cops adantr mpan2
      hlop ccla hlclat atssbase sstr clatlubcl syl2an opoccl syl2anc pmapsubclN
      syldan eqeltrd ) CIJZEAKZLZEDMECNMZMZCOMZMZCPMZMZBADURCVBUTEURQZUTQZFVBQZ
      GRUOUPVACSMZJZVCBJUQCTJZUSVGJZVHUOVIUPCUCUAUOCUDJEVGKZVJUPCUEUPAVGKVKAVGC
      VGQZFUFEAVGUGUBVGEURCVLVDUHUIVGCUTUSVLVEUJUKVGBCVBVAVLVFHULUMUN $.
  $}

  ${
    poml4.a $e |- A = ( Atoms ` K ) $.
    poml4.p $e |- ._|_ = ( _|_P ` K ) $.
    $( Orthomodular law for projective lattices.  Lemma 3.3(1) in [Holland95]
       p. 215.  (Contributed by NM, 25-Jan-2012.)
       (New usage is discouraged.) $)
    poml4N $p |- ( ( K e. HL /\ X C_ A /\ Y C_ A ) ->
      ( ( X C_ Y /\ ( ._|_ ` ( ._|_ ` Y ) ) = Y ) ->
   ( ( ._|_ ` ( ( ._|_ ` X ) i^i Y ) ) i^i Y ) = ( ._|_ ` ( ._|_ ` X ) ) ) ) $=
      ( wcel wss w3a cfv wceq cin eqid 2polvalN wa co syl syl2anc syl3anc cpmap
      chlt club eqcom 3adant2 eqeq2d biimpd syl5bi coc cmee coml cbs wbr simpl1
      cple hloml ccla hlclat simpl2 atssbase syl6ss clatlubcl simpl3 3jca lubss
      simprl omllaw4 sylc fveq2d polval2N simprr ineq12d opoccl pmapmeet eqtr4d
      cops hlop clat hllat latmcl polpmapN eqtrd 3eqtr4d ex sylan2d ) BUBHZDAIZ
      EAIZJZECKCKZELZEEBUCKZKZBUAKZKZLZDEIZDCKZEMZCKZEMZWRCKZLZWKEWJLZWIWPWJEUD
      WIXDWPWIWJWOEWFWHWJWOLWGAWLBWNCEWLNZFWNNZGOUEUFUGUHWIWQWPPZXCWIXGPZDWLKZB
      UIKZKZWMBUJKZQZXJKZWMXLQZWNKZXIWNKZXAXBXHXOXIWNXHBUKHZXIBULKZHZWMXSHZJXIW
      MBUOKZUMZXOXILXHXRXTYAXHWFXRWFWGWHXGUNZBUPRXHBUQHZDXSIXTXHWFYEYDBURRZXHDA
      XSWFWGWHXGUSZAXSBXSNZFUTZVAXSDWLBYHXEVBSZXHYEEXSIZYAYFXHEAXSWFWGWHXGVCYIV
      AZXSEWLBYHXEVBSZVDXHYEYKWQYCYFYLWIWQWPVFXSDEWLBYBYHYBNZXEVETXSBYBXLXJXIWM
      YHYNXLNZXJNZVGVHVIXHXAXNWNKZWOMZXPXHWTYQEWOXHWTXMWNKZCKZYQXHWSYSCXHWSXKWN
      KZWOMZYSXHWRUUAEWOXHWFWGWRUUALYDYGACWLBWNXJDXEYPFXFGVJSWIWQWPVKZVLXHWFXKX
      SHZYAYSUUBLYDXHBVPHZXTUUDXHWFUUEYDBVQRZYJXSBXJXIYHYPVMSZYMAXSWNBXLXKWMYHY
      OFXFVNTVOVIXHWFXMXSHZYTYQLYDXHBVRHZUUDYAUUHXHWFUUIYDBVSRUUGYMXSBXLXKWMYHY
      OVTTZXSCBWNXJXMYHYPXFGWASWBUUCVLXHWFXNXSHZYAXPYRLYDXHUUEUUHUUKUUFUUJXSBXJ
      XMYHYPVMSYMAXSWNBXLXNWMYHYOFXFVNTVOXHWFWGXBXQLYDYGAWLBWNCDXEFXFGOSWCWDWE
      $.

    $( Orthomodular law for projective lattices.  (Contributed by NM,
       23-Mar-2012.)  (New usage is discouraged.) $)
    poml5N $p |- ( ( K e. HL /\ Y C_ A /\ X C_ ( ._|_ ` Y ) )
           -> ( ( ._|_ ` ( ( ._|_ ` X ) i^i ( ._|_ ` Y ) ) ) i^i ( ._|_ ` Y ) )
                = ( ._|_ ` ( ._|_ ` X ) ) ) $=
      ( chlt wcel wss cfv w3a wceq wa cin simp1 simp3 polssatN 3adant3 sstrd
      3jca 3polN jca poml4N sylc ) BHIZEAJZDECKZJZLZUFDAJZUHAJZLUIUHCKCKUHMZNDC
      KZUHOCKUHOUNCKMUJUFUKULUFUGUIPUJDUHAUFUGUIQZUFUGULUIABCEFGRSZTUPUAUJUIUMU
      OUFUGUMUIAEBCFGUBSUCABCDUHFGUDUE $.
  $}

  ${
    poml6.c $e |- C = ( PSubCl ` K ) $.
    poml6.p $e |- ._|_ = ( _|_P ` K ) $.
    $( Orthomodular law for projective lattices.  (Contributed by NM,
       25-Mar-2012.)  (New usage is discouraged.) $)
    poml6N $p |- ( ( ( K e. HL /\ X e. C /\ Y e. C ) /\ X C_ Y )
            -> ( ( ._|_ ` ( ( ._|_ ` X ) i^i Y ) ) i^i Y ) = X ) $=
      ( chlt wcel w3a wss wa cfv catm wceq simpl1 psubclssatN syl2anc psubcli2N
      cin simpl2 eqid simpl3 simpr poml4N imp syl32anc eqtrd ) BHIZDAIZEAIZJZDE
      KZLZDCMZETCMETZUOCMZDUNUIDBNMZKZEURKZUMECMCMEOZUPUQOZUIUJUKUMPZUNUIUJUSVC
      UIUJUKUMUAZURAHBDURUBZFQRUNUIUKUTVCUIUJUKUMUCZURAHBEVEFQRULUMUDUNUIUKVAVC
      VFAHBCEGFSRUIUSUTJUMVALVBURBCDEVEGUEUFUGUNUIUJUQDOVCVDAHBCDGFSRUH $.
  $}

  ${
    osumcllem.l $e |- .<_ = ( le ` K ) $.
    osumcllem.j $e |- .\/ = ( join ` K ) $.
    osumcllem.a $e |- A = ( Atoms ` K ) $.
    osumcllem.p $e |- .+ = ( +P ` K ) $.
    osumcllem.o $e |- ._|_ = ( _|_P ` K ) $.
    osumcllem.c $e |- C = ( PSubCl ` K ) $.
    osumcllem.m $e |- M = ( X .+ { p } ) $.
    osumcllem.u $e |- U = ( ._|_ ` ( ._|_ ` ( X .+ Y ) ) ) $.
    $( Lemma for ~ osumclN .  (Contributed by NM, 25-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem1N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A ) /\ p e. U ) ->
          ( U i^i M ) = M ) $=
      ( chlt wcel wss w3a cv wa cin wceq csn sspadd1 adantr cfv simpl1 paddssat
      co 2polssN syl2anc syl6sseqr sstrd simpr snssd cpsubsp wb simpl2 polssatN
      syl5eqss eqid polsubN syl5eqel paddss syl13anc mpbi2and sseqin2 sylib ) F
      UAUBZJAUCZKAUCZUDZLUEZDUBZUFZHDUCDHUGHUHWAHJVSUIZCUOZDSWAJDUCZWBDUCZWCDUC
      ZWAJJKCUOZDVRJWGUCVTAUACFJKOPUJUKWAWGWGIULZIULZDWAVOWGAUCZWGWIUCVOVPVQVTU
      MZVRWJVTAUACFJKOPUNUKZAFIWGOQUPUQTURUSWAVSDVRVTUTVAZWAVOVPWBAUCDFVBULZUBW
      DWEUFWFVCWKVOVPVQVTVDWAWBDAWMWADWIATWAVOWHAUCZWIAUCWKWAVOWJWOWKWLAFIWGOQV
      EUQZAFIWHOQVEUQVFUSWADWIWNTWAVOWOWIWNUBWKWPAWNFIWHOWNVGZQVHUQVIAUACWNFJWB
      DOWQPVJVKVLVFHDVMVN $.

    $( Lemma for ~ osumclN .  (Contributed by NM, 25-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem2N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A ) /\ p e. U ) ->
          X C_ ( U i^i M ) ) $=
      ( chlt wcel wss w3a cv wa cin csn co simpl1 simpl2 simpr snssd cfv adantr
      paddssat polssatN syl2anc syl5eqss sspadd1 syl6sseqr osumcllem1N sseqtr4d
      sstrd syl3anc ) FUAUBZJAUCZKAUCZUDZLUEZDUBZUFZJHDHUGVLJJVJUHZCUIZHVLVFVGV
      MAUCJVNUCVFVGVHVKUJZVFVGVHVKUKVLVMDAVLVJDVIVKULUMVLDJKCUIZIUNZIUNZATVLVFV
      QAUCZVRAUCVOVLVFVPAUCZVSVOVIVTVKAUACFJKOPUPUOAFIVPOQUQURAFIVQOQUQURUSVDAU
      ACFJVMOPUTVESVAABCDEFGHIJKLMNOPQRSTVBVC $.

    $( Lemma for ~ osumclN .  (Contributed by NM, 23-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem3N $p |- ( ( K e. HL /\ Y e. C /\ X C_ ( ._|_ ` Y ) ) ->
          ( ( ._|_ ` X ) i^i U ) = Y ) $=
      ( chlt wcel cfv wss w3a cin incom co wceq simp1 simp3 psubclssatN 3adant3
      polssatN syl2anc poldmj1N syl3anc syl6eq fveq2d syl5eq polcon2N psubcli2N
      sstrd ineq1d syld3an2 poml5N 3eqtrd ) FUAUBZKBUBZJKIUCZUDZUEZJIUCZDUFDVMU
      FZKVMDUGVLVNVJVMUFZIUCZVMUFZVJIUCZKVLDVPVMVLDJKCUHIUCZIUCVPTVLVSVOIVLVSVM
      VJUFZVOVLVHJAUDZKAUDZVSVTUIVHVIVKUJZVLJVJAVHVIVKUKVLVHWBVJAUDWCVHVIWBVKAB
      UAFKORULUMZAFIKOQUNUOVCZWDACJKFIOPQUPUQVMVJUGURUSUTVDVLVHWAKVMUDZVQVRUIWC
      WEVHWBVIVKWFWDAFIJKOQVAVEAFIKJOQVFUQVHVIVRKUIVKBUAFIKQRVBUMVGUT $.

    $( Lemma for ~ osumclN .  (Contributed by NM, 24-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem4N $p |- ( ( ( K e. HL /\ Y C_ A /\ X C_ ( ._|_ ` Y ) ) /\
 ( r e. X /\ q e. Y ) ) -> q =/= r ) $=
      ( chlt wcel wss cfv w3a cv wa cin wn wne c0 wceq n0i incom sslin 3ad2ant3
      syl5eqss pnonsingN 3adant3 ss0b sylib adantr nsyl3 simprr eleq1 syl5ibcom
      sseqtrd simprl jctild elin syl6ibr necon3bd mpd ) FUCUDZKAUEZJKIUFZUEZUGZ
      LUHZJUDZMUHZKUDZUIZUIZWAJKUJZUDZUKWCWAULWHWGUMUNZWFWGWAUOVTWIWEVTWGUMUEWI
      VTWGKVRUJZUMVTWGKJUJZWJJKUPVSVPWKWJUEVQJVRKUQURUSVPVQWJUMUNVSAIFKQSUTVAVI
      WGVBVCVDVEWFWHWCWAWFWCWAUNZWBWAKUDZUIWHWFWLWMWBWFWDWLWMVTWBWDVFWCWAKVGVHV
      TWBWDVJVKWAJKVLVMVNVO $.

    $( Lemma for ~ osumclN .  (Contributed by NM, 24-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem5N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A ) /\ p e. A
    /\ ( r e. X /\ q e. Y /\ p .<_ ( r .\/ q ) ) ) -> p e. ( X .+ Y ) ) $=
      ( chlt wcel wss w3a cv co wbr clat simp11 syl simp12 simp13 simp31 simp32
      hllat simp2 simp33 elpaddri syl322anc ) FUCUDZJAUEZKAUEZUFZNUGZAUDZLUGZJU
      DZMUGZKUDZVFVHVJEUHGUIZUFZUFZFUJUDZVCVDVIVKVGVLVFJKCUHUDVNVBVOVBVCVDVGVMU
      KFUQULVBVCVDVGVMUMVBVCVDVGVMUNVEVGVIVKVLUOVEVGVIVKVLUPVEVGVMURVEVGVIVKVLU
      SACVHVJVFEFGJKOPQRUTVA $.

    $( Lemma for ~ osumclN .  Use atom exchange ~ hlatexch1 to swap ` p ` and
       ` q ` .  (Contributed by NM, 24-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem6N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A )
          /\ ( X C_ ( ._|_ ` Y ) /\ p e. A )
          /\ ( r e. X /\ q e. Y /\ q .<_ ( r .\/ p ) ) )
        -> p e. ( X .+ Y ) ) $=
      ( chlt wss w3a cfv cv wa co wbr simp11 simp12 simp13 simp2r simp31 simp32
      wcel sseldd 3jca simp2l osumcllem4N syl32anc simp33 hlatexch1 osumcllem5N
      wne sylc syl313anc ) FUCUQZJAUDZKAUDZUEZJKIUFUDZNUGZAUQZUHZLUGZJUQZMUGZKU
      QZVSVQVNEUIGUJZUEZUEZVIVJVKVOVRVTVNVQVSEUIGUJZVNJKCUIUQVIVJVKVPWBUKZVIVJV
      KVPWBULZVIVJVKVPWBUMZVLVMVOWBUNZVLVPVRVTWAUOZVLVPVRVTWAUPZWCVIVSAUQZVOVQA
      UQZUEZVSVQVFZUEWAWDWCVIWMWNWEWCWKVOWLWCKAVSWGWJURWHWCJAVQWFWIURUSWCVIVKVM
      VRVTWNWEWGVLVMVOWBUTWIWJABCDEFGHIJKLMNOPQRSTUAUBVAVBUSVLVPVRVTWAVCAVSVNVQ
      EFGOPQVDVGABCDEFGHIJKLMNOPQRSTUAUBVEVH $.

    $d q r A $.  $d r .\/ $.  $d q r K $.  $d r .<_ $.  $d q r M $.
    $d q r ._|_ $.  $d q r .+ $.  $d q r X $.  $d q r Y $.  $d p q r $.
    $( Lemma for ~ osumclN .  (Contributed by NM, 24-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem7N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A )
          /\ ( X C_ ( ._|_ ` Y ) /\ X =/= (/) /\ p e. A )
          /\ q e. ( Y i^i M ) ) -> p e. ( X .+ Y ) ) $=
      ( vr chlt wcel wss w3a cfv c0 wne cv cin co wbr wrex csn simp11 hllat syl
      clat simp12 simp23 simp22 inss2 sseli 3ad2ant3 elpaddatiN simp121 simp123
      syl6eleq simp2 inss1 simp13 sseldi simp3 osumcllem6N syl123anc rexlimdv3a
      syl32anc mpd ) FUCUDZJAUEZKAUEZUFZJKIUGUEZJUHUIZMUJZAUDZUFZLUJZKHUKZUDZUF
      ZWIUBUJZWFEULGUMZUBJUNZWFJKCULUDZWLFUSUDZWAWGWEWIJWFUOCULZUDWOWLVTWQVTWAW
      BWHWKUPFUQURVTWAWBWHWKUTWCWDWEWGWKVAWCWDWEWGWKVBWLWIHWRWKWCWIHUDWHWJHWIKH
      VCVDVETVIACWFWIEFGJUBNOPQVFVRWLWNWPUBJWLWMJUDZWNUFZWCWDWGWSWIKUDWNWPWCWHW
      KWSWNUPWDWEWGWCWKWSWNVGWDWEWGWCWKWSWNVHWLWSWNVJWTWJKWIKHVKWCWHWKWSWNVLVMW
      LWSWNVNABCDEFGHIJKUBLMNOPQRSTUAVOVPVQVS $.

    $( Lemma for ~ osumclN .  (Contributed by NM, 24-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem8N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A )
          /\ ( X C_ ( ._|_ ` Y ) /\ X =/= (/) /\ p e. A )
          /\ -. p e. ( X .+ Y ) ) -> ( Y i^i M ) = (/) ) $=
      ( vq chlt wcel wss w3a cfv c0 wne cv co wn cin wceq wa wex n0 osumcllem7N
      3expia exlimdv syl5bi necon1bd 3impia ) FUBUCJAUDKAUDUEZJKIUFUDJUGUHLUIZA
      UCUEZVDJKCUJUCZUKKHULZUGUMVCVEUNZVFVGUGVGUGUHUAUIVGUCZUAUOVHVFUAVGUPVHVIV
      FUAVCVEVIVFABCDEFGHIJKUALMNOPQRSTUQURUSUTVAVB $.

    $( Lemma for ~ osumclN .  (Contributed by NM, 24-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem9N $p |- ( ( ( K e. HL /\ X e. C /\ Y e. C )
          /\ ( X C_ ( ._|_ ` Y ) /\ X =/= (/) /\ p e. U )
          /\ -. p e. ( X .+ Y ) ) -> M = X ) $=
      ( chlt wcel w3a cfv wss c0 wne cv co wn cin inass wceq simp11 osumcllem3N
      simp13 simp21 syl3anc ineq1d syl5eqr simp12 psubclssatN paddssat polssatN
      syl2anc simp22 simp23 sseldd simp3 osumcllem8N syl331anc eqtrd fveq2d syl
      syl5eqss pol0N osumcllem1N syl31anc ineq12d polsubclN paddatclN psubclinN
      syl5eqel csn osumcllem2N poml6N snssd sseqin2 sylib 3eqtr3rd ) FUAUBZJBUB
      ZKBUBZUCZJKIUDUEZJUFUGZLUHZDUBZUCZWQJKCUIZUBUJZUCZJIUDZDHUKZUKZIUDZXDUKZA
      HUKZJHXBXFAXDHXBXFUFIUDZAXBXEUFIXBXEKHUKZUFXBXEXCDUKZHUKXJXCDHULXBXKKHXBW
      KWMWOXKKUMWKWLWMWSXAUNZWKWLWMWSXAUPZWNWOWPWRXAUQZABCDEFGHIJKLMNOPQRSTUOUR
      USUTXBWKJAUEZKAUEZWOWPWQAUBZXAXJUFUMXLXBWKWLXOXLWKWLWMWSXAVAZABUAFJORVBVE
      ZXBWKWMXPXLXMABUAFKORVBVEZXNWNWOWPWRXAVFXBDAWQXBDWTIUDZIUDZATXBWKYAAUEZYB
      AUEXLXBWKWTAUEZYCXLXBWKXOXPYDXLXSXTAUACFJKOPVCURAFIWTOQVDVEZAFIYAOQVDVEVO
      WNWOWPWRXAVGZVHZWNWSXAVIABCDEFGHIJKLMNOPQRSTVJVKVLVMXBWKXIAUMXLAUAFIOQVPV
      NVLXBWKXOXPWRXDHUMXLXSXTYFABCDEFGHIJKLMNOPQRSTVQVRVSXBWKWLXDBUBZJXDUEZXGJ
      UMXLXRXBWKDBUBHBUBYHXLXBDYBBTXBWKYCYBBUBXLYEABFIYAOQRVTVEWCXBHJWQWDZCUIZB
      SXBWKWLXQYKBUBXLXRYGABCWQFJOPRWAURWCBFDHRWBURXBWKXOXPWRYIXLXSXTYFABCDEFGH
      IJKLMNOPQRSTWEVRBFIJXDRQWFVRXBHAUEXHHUMXBHYKASXBWKXOYJAUEYKAUEXLXSXBWQAYG
      WGAUACFJYJOPVCURVOHAWHWIWJ $.

    $( Lemma for ~ osumclN .  Contradict ~ osumcllem9N .  (Contributed by NM,
       25-Mar-2012.)  (New usage is discouraged.) $)
    osumcllem10N $p |- ( ( ( K e. HL /\ X C_ A /\ Y C_ A )
          /\ p e. A
          /\ -. p e. ( X .+ Y ) ) -> M =/= X ) $=
      ( chlt wss w3a cv co wn wne csn simp11 simp2 snssd simp12 sspadd2 syl3anc
      wcel snss sylibr syl6eleqr sspadd1 3ad2ant1 simp3 ssneldd nelne1 syl2anc
      vex ) FUAUOZJAUBZKAUBZUCZLUDZAUOZVJJKCUEZUOUFZUCZVJHUOVJJUOUFHJUGVNVJJVJU
      HZCUEZHVNVOVPUBZVJVPUOVNVFVOAUBVGVQVFVGVHVKVMUIVNVJAVIVKVMUJUKVFVGVHVKVMU
      LAUACFVOJOPUMUNVJVPLVEUPUQSURVNJVLVJVIVKJVLUBVMAUACFJKOPUSUTVIVKVMVAVBVJH
      JVCVD $.
  $}

  ${
    $d p C $.  $d p K $.  $d p ._|_ $.  $d p .+ $.  $d p X $.  $d p Y $.
    osumcl.p $e |- .+ = ( +P ` K ) $.
    osumcl.o $e |- ._|_ = ( _|_P ` K ) $.
    osumcl.c $e |- C = ( PSubCl ` K ) $.
    $( Lemma for ~ osumclN .  (Contributed by NM, 25-Mar-2012.)
       (New usage is discouraged.) $)
    osumcllem11N $p |- ( ( ( K e. HL /\ X e. C /\ Y e. C )
          /\ ( X C_ ( ._|_ ` Y ) /\ X =/= (/) ) )
                -> ( X .+ Y ) = ( ._|_ ` ( ._|_ ` ( X .+ Y ) ) ) ) $=
      ( vp chlt wcel w3a cfv wss wne wa wceq eqid syl2anc c0 wn nonconne simpl1
      co catm simpl2 psubclssatN simpl3 paddssat syl3anc 2polssN cv wrex df-pss
      wex wpss pssnel sylbir df-rex sylibr wi csn cjn osumcllem9N simp11 simp12
      cple simp13 3adantr3 3adant3 polssatN simp23 simp3 osumcllem10N syl311anc
      sseldd pm2.21ddne 3exp 3expd imp32 rexlimdv syl5 mpand necon1bd mpi ) CKL
      ZEALZFALZMZEFDNOZEUAPZQZQZEEREEPQZUBEFBUEZWPDNZDNZREEUCWNWOWPWRWNWPWROZWP
      WRPZWOWNWGWPCUFNZOZWSWGWHWIWMUDZWNWGEXAOZFXAOZXBXCWNWGWHXDXCWGWHWIWMUGXAA
      KCEXASZIUHZTWNWGWIXEXCWGWHWIWMUIXAAKCFXFIUHZTXAKBCEFXFGUJUKZXACDWPXFHULTW
      SWTQZJUMZWPLUBZJWRUNZWNWOXJXKWRLZXLQJUPZXMXJWPWRUQXOWPWRUOJWPWRURUSXLJWRU
      TVAWNXLWOJWRWJWKWLXNXLWOVBZVBWJWKWLXNXPWJWKWLXNMZXLWOWJXQXLMZWOEXKVCBUEZE
      XAABWRCVDNZCCVHNZXSDEFJYASZXTSZXFGHIXSSZWRSZVEXRWGXDXEXKXALXLXSEPWGWHWIXQ
      XLVFZXRWGWHXDYFWGWHWIXQXLVGXGTXRWGWIXEYFWGWHWIXQXLVIXHTXRWRXAXKXRWGWQXAOZ
      WRXAOYFXRWGXBYGYFWJXQXBXLWJWKWLXBXNXIVJVKXACDWPXFHVLTXACDWQXFHVLTWJWKWLXN
      XLVMVQWJXQXLVNXAABWRXTCYAXSDEFJYBYCXFGHIYDYEVOVPVRVSVTWAWBWCWDWEWF $.

    $( Closure of orthogonal sum.  If ` X ` and ` Y ` are orthogonal closed
       projective subspaces, then their sum is closed.  (Contributed by NM,
       25-Mar-2012.)  (New usage is discouraged.) $)
    osumclN $p |- ( ( ( K e. HL /\ X e. C /\ Y e. C ) /\ X C_ ( ._|_ ` Y ) )
         -> ( X .+ Y ) e. C ) $=
      ( chlt wcel w3a cfv wss wa co wceq psubclssatN syl2anc c0 simpl1 paddssat
      catm simpl2 simpl3 syl3anc simpll1 oveq1 padd02 sylan9eqr simpll3 eqeltrd
      eqid psubcli2N osumcllem11N anassrs eqcomd pm2.61dane ispsubclN mpbir2and
      wne wb syl ) CJKZEAKZFAKZLZEFDMNZOZEFBPZAKZVJCUCMZNZVJDMDMZVJQZVIVDEVLNZF
      VLNZVMVDVEVFVHUAZVIVDVEVPVRVDVEVFVHUDVLAJCEVLUMZIRSVIVDVFVQVRVDVEVFVHUEVL
      AJCFVSIRSZVLJBCEFVSGUBUFVIVOETVIETQZOZVDVKVOVDVEVFVHWAUGWBVJFAWAVIVJTFBPZ
      FETFBUHVIVDVQWCFQVRVTVLJBCFVSGUISUJVDVEVFVHWAUKULAJCDVJHIUNSVIETVAZOVJVNV
      GVHWDVJVNQABCDEFGHIUOUPUQURVIVDVKVMVOOVBVRVLAJCDVJVSHIUSVCUT $.
  $}

  ${
    pmapojoin.b $e |- B = ( Base ` K ) $.
    pmapojoin.l $e |- .<_ = ( le ` K ) $.
    pmapojoin.j $e |- .\/ = ( join ` K ) $.
    pmapojoin.m $e |- M = ( pmap ` K ) $.
    pmapojoin.o $e |- ._|_ = ( oc ` K ) $.
    pmapojoin.p $e |- .+ = ( +P ` K ) $.
    $( For orthogonal elements, projective map of join equals projective sum.
       Compare ~ pmapjoin where only one direction holds.  (Contributed by NM,
       11-Apr-2012.)  (New usage is discouraged.) $)
    pmapojoinN $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\
  X .<_ ( ._|_ ` Y ) ) -> ( M ` ( X .\/ Y ) ) = ( ( M ` X ) .+ ( M ` Y ) ) ) $=
      ( chlt wcel cfv wceq syl2anc w3a wbr wa co cpolN eqid adantr cpscN simpl1
      pmapj2N wss simpl2 pmapsubclN simpl3 wb cops 3ad2ant1 simp3 opoccl pmaple
      hlop syld3an3 biimpa polpmapN sseqtr4d osumclN syl31anc psubcli2N eqtrd )
      DPQZHAQZIAQZUAZHIGRZEUBZUCZHICUDFRZHFRZIFRZBUDZDUERZRWARZVTVMVQWBSVOABCDF
      WAHIJLMOWAUFZUJUGVPVJVTDUHRZQZWBVTSVJVKVLVOUIZVPVJVRWDQZVSWDQZVRVSWARZUKW
      EWFVPVJVKWGWFVJVKVLVOULAWDDFHJMWDUFZUMTVPVJVLWHWFVJVKVLVOUNZAWDDFIJMWJUMT
      VPVRVNFRZWIVMVOVRWLUKZVJVKVLVNAQZVOWMUOVMDUPQZVLWNVJVKWOVLDVAUQVJVKVLURAD
      GIJNUSTADEFHVNJKMUTVBVCVPVJVLWIWLSWFWKAWADFGIJNMWCVDTVEWDBDWAVRVSOWCWJVFV
      GWDPDWAVTWCWJVHTVI $.
  $}

  ${
    pexmid.a $e |- A = ( Atoms ` K ) $.
    pexmid.p $e |- .+ = ( +P ` K ) $.
    pexmid.o $e |- ._|_ = ( _|_P ` K ) $.
    $( Excluded middle law for closed projective subspaces, which can be shown
       to be equivalent to (and derivable from) the orthomodular law
       ~ poml4N .  Lemma 3.3(2) in [Holland95] p. 215, which we prove as a
       special case of ~ osumclN .  (Contributed by NM, 25-Mar-2012.)
       (New usage is discouraged.) $)
    pexmidN $p |- ( ( ( K e. HL /\ X C_ A ) /\ ( ._|_ ` ( ._|_ ` X ) ) = X )
         -> ( X .+ ( ._|_ ` X ) ) = A ) $=
      ( chlt wcel wss wa cfv wceq co c0 cin adantr syl2anc ad2antrr eqtrd cpscN
      simpll simplr polssatN poldmj1N syl3anc pnonsingN simpr wb eqid ispsubclN
      fveq2d mpbir2and polsubclN 2polssN osumclN syl31anc psubcli2N 3eqtr3d
      pol0N ) CIJZEAKZLZEDMZDMZENZLZEVEBOZDMZDMZPDMZVIAVHVJPDVHVJVEVFQZPVHVBVCV
      EAKZVJVMNVBVCVGUCZVBVCVGUDZVDVNVGACDEFHUERZABEVECDFGHUFUGVHVBVNVMPNVOVQAD
      CVEFHUHSUAUMVHVBVICUBMZJZVKVINVOVHVBEVRJZVEVRJZEVFKZVSVOVHVTVCVGVPVDVGUIV
      BVTVCVGLUJVCVGAVRICDEFHVRUKZULTUNVDWAVGAVRCDEFHWCUORVDWBVGACDEFHUPRVRBCDE
      VEGHWCUQURVRICDVIHWCUSSVBVLANVCVGAICDFHVATUT $.
  $}

  ${
    pexmidlem.l $e |- .<_ = ( le ` K ) $.
    pexmidlem.j $e |- .\/ = ( join ` K ) $.
    pexmidlem.a $e |- A = ( Atoms ` K ) $.
    pexmidlem.p $e |- .+ = ( +P ` K ) $.
    pexmidlem.o $e |- ._|_ = ( _|_P ` K ) $.
    pexmidlem.m $e |- M = ( X .+ { p } ) $.
    $( Lemma for ~ pexmidN .  Holland's proof implicitly requires ` q =/= r ` ,
       which we prove here.  (Contributed by NM, 2-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidlem1N $p |- ( ( ( K e. HL /\ X C_ A ) /\
 ( r e. X /\ q e. ( ._|_ ` X ) ) ) -> q =/= r ) $=
      ( wcel wa cv chlt wss cfv cin wn wne c0 n0i pnonsingN adantr nsyl3 simprr
      wceq weq eleq1 syl5ibcom simprl jctild elin syl6ibr necon3bd mpd ) DUARHA
      UBSZITZHRZJTZHGUCZRZSZSZVDHVGUDZRZUEVFVDUFVLVKUGUMZVJVKVDUHVCVMVIAGDHNPUI
      UJUKVJVLVFVDVJJIUNZVEVDVGRZSVLVJVNVOVEVJVHVNVOVCVEVHULVFVDVGUOUPVCVEVHUQU
      RVDHVGUSUTVAVB $.

    $( Lemma for ~ pexmidN .  (Contributed by NM, 2-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidlem2N $p |- ( ( ( K e. HL /\ X C_ A /\ p e. A )
       /\ ( r e. X /\ q e. ( ._|_ ` X ) /\ p .<_ ( r .\/ q ) ) )
     -> p e. ( X .+ ( ._|_ ` X ) ) ) $=
      ( wcel wss cv chlt w3a cfv co wbr wa clat simpl1 hllat syl simpl2 syl2anc
      polssatN simpr1 simpr2 simpl3 simpr3 elpaddri syl322anc ) DUARZHASZKTZARZ
      UBZITZHRZJTZHGUCZRZVBVEVGCUDEUEZUBZUFZDUGRZVAVHASZVFVIVCVJVBHVHBUDRVLUTVM
      UTVAVCVKUHZDUIUJUTVAVCVKUKZVLUTVAVNVOVPADGHNPUMULVDVFVIVJUNVDVFVIVJUOUTVA
      VCVKUPVDVFVIVJUQABVEVGVBCDEHVHLMNOURUS $.

    $( Lemma for ~ pexmidN .  Use atom exchange ~ hlatexch1 to swap ` p ` and
       ` q ` .  (Contributed by NM, 2-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidlem3N $p |- ( ( ( K e. HL /\ X C_ A /\ p e. A ) /\ ( r e. X
          /\ q e. ( ._|_ ` X ) ) /\ q .<_ ( r .\/ p ) )
        -> p e. ( X .+ ( ._|_ ` X ) ) ) $=
      ( wcel cv co chlt wss w3a cfv wa wbr simp1 simp2l simp2r wi simpl1 simpl2
      wne polssatN syl2anc simprr sseldd simpl3 pexmidlem1N hlatexch1 syl131anc
      simprl 3adantl3 3impia pexmidlem2N syl13anc ) DUARZHAUBZKSZARZUCZISZHRZJS
      ZHGUDZRZUEZVNVLVICTEUFZUCVKVMVPVIVLVNCTEUFZVIHVOBTRVKVQVRUGVKVMVPVRUHVKVM
      VPVRUIVKVQVRVSVKVQUEZVGVNARVJVLARVNVLUMZVRVSUJVGVHVJVQUKZVTVOAVNVTVGVHVOA
      UBWBVGVHVJVQULZADGHNPUNUOVKVMVPUPUQVGVHVJVQURVTHAVLWCVKVMVPVBUQVGVHVQWAVJ
      ABCDEFGHIJKLMNOPQUSVCAVNVIVLCDELMNUTVAVDABCDEFGHIJKLMNOPQVEVF $.

    $d q r A $.  $d r .\/ $.  $d q r K $.  $d r .<_ $.  $d q r M $.
    $d q r ._|_ $.  $d q r .+ $.  $d q r X $.  $d p q r $.
    $( Lemma for ~ pexmidN .  (Contributed by NM, 2-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidlem4N $p |- ( ( ( K e. HL /\ X C_ A /\ p e. A ) /\ ( X =/= (/) /\
           q e. ( ( ._|_ ` X ) i^i M ) ) ) -> p e. ( X .+ ( ._|_ ` X ) ) ) $=
      ( vr wcel cv wa chlt wss w3a c0 wne cfv cin co wbr wrex clat simpl1 hllat
      csn syl simpl2 simpl3 simprl inss2 sseli syl6eleq ad2antll syl32anc simp1
      elpaddatiN simp3l inss1 simp2r sseldi simp3r pexmidlem3N syl121anc 3expia
      exp3a rexlimdv mpd ) DUARZHAUBZJSZARZUCZHUDUEZISZHGUFZFUGZRZTZTZWCQSZVSCU
      HEUIZQHUJZVSHWDBUHRZWHDUKRZVRVTWBWCHVSUNBUHZRZWKWHVQWMVQVRVTWGULDUMUOVQVR
      VTWGUPVQVRVTWGUQWAWBWFURWFWOWAWBWFWCFWNWEFWCWDFUSUTPVAVBABVSWCCDEHQKLMNVE
      VCWHWJWLQHWHWIHRZWJWLWAWGWPWJTZWLWAWGWQUCZWAWPWCWDRWJWLWAWGWQVDWAWGWPWJVF
      WRWEWDWCWDFVGWAWBWFWQVHVIWAWGWPWJVJABCDEFGHQIJKLMNOPVKVLVMVNVOVP $.

    $( Lemma for ~ pexmidN .  (Contributed by NM, 2-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidlem5N $p |- ( ( ( K e. HL /\ X C_ A /\ p e. A ) /\ ( X =/= (/) /\
         -. p e. ( X .+ ( ._|_ ` X ) ) ) ) -> ( ( ._|_ ` X ) i^i M ) = (/) ) $=
      ( vq wcel cv c0 wne chlt wss w3a cfv co wn cin wceq wa wex n0 pexmidlem4N
      expr exlimdv syl5bi necon1bd impr ) DUAQHAUBIRZAQUCZHSTZURHHGUDZBUEQZUFVA
      FUGZSUHUSUTUIZVBVCSVCSTPRVCQZPUJVDVBPVCUKVDVEVBPUSUTVEVBABCDEFGHPIJKLMNOU
      LUMUNUOUPUQ $.

    $( Lemma for ~ pexmidN .  (Contributed by NM, 3-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidlem6N $p |- ( ( ( K e. HL /\ X C_ A /\ p e. A )
      /\ ( ( ._|_ ` ( ._|_ ` X ) ) = X /\ X =/= (/) /\
   -. p e. ( X .+ ( ._|_ ` X ) ) ) ) -> M = X ) $=
      ( chlt wcel wss cfv wceq cv w3a c0 wne co cin pexmidlem5N 3adantr1 fveq2d
      wn simpl1 pol0N syl eqtrd ineq1d simpl2 csn simpl3 snssd paddssat syl3anc
      wa syl5eqss 3jca sspadd1 syl6sseqr cpscN wb ispsubclN mpbir2and paddatclN
      simpr1 eqid syl5eqel psubcli2N syl2anc poml4N sylc sseqin2 sylib 3eqtr3rd
      jca ) DPQZHARZIUAZAQZUBZHGSZGSZHTZHUCUDZWEHWHBUEQUJZUBZVBZFWIHWNWHFUFZGSZ
      FUFZAFUFZWIFWNWPAFWNWPUCGSZAWNWOUCGWGWKWLWOUCTWJABCDEFGHIJKLMNOUGUHUIWNWC
      WSATWCWDWFWMUKZAPDGLNULUMUNUOWNWCWDFARZUBHFRZFGSGSFTZVBWQWITWNWCWDXAWTWCW
      DWFWMUPZWNFHWEUQZBUEZAOWNWCWDXEARZXFARWTXDWNWEAWCWDWFWMURZUSZAPBDHXELMUTV
      AVCZVDWNXBXCWNHXFFWNWCWDXGHXFRWTXDXIAPBDHXELMVEVAOVFWNWCFDVGSZQXCWTWNFXFX
      KOWNWCHXKQZWFXFXKQWTWNXLWDWJXDWGWJWKWLVLZWNWCXLWDWJVBVHWTAXKPDGHLNXKVMZVI
      UMVJXHAXKBWEDHLMXNVKVAVNXKPDGFNXNVOVPWBADGHFLNVQVRWNXAWRFTXJFAVSVTWAXMUN
      $.

    $( Lemma for ~ pexmidN .  Contradict ~ pexmidlem6N .  (Contributed by NM,
       3-Feb-2012.)  (New usage is discouraged.) $)
    pexmidlem7N $p |- ( ( ( K e. HL /\ X C_ A /\ p e. A )
      /\ ( ( ._|_ ` ( ._|_ ` X ) ) = X /\ X =/= (/) /\
   -. p e. ( X .+ ( ._|_ ` X ) ) ) ) -> M =/= X ) $=
      ( chlt wcel wss w3a cfv cv c0 wne co wn wa csn simpl1 simpl3 snssd simpl2
      wceq sspadd2 syl3anc vex sylibr syl6eleqr polssatN syl2anc sspadd1 simpr3
      snss ssneldd nelne1 ) DPQZHARZIUAZAQZSZHGTZGTHULZHUBUCZVGHVJBUDZQUEZSZUFZ
      VGFQVGHQUEFHUCVPVGHVGUGZBUDZFVPVQVRRZVGVRQVPVEVQARVFVSVEVFVHVOUHZVPVGAVEV
      FVHVOUIUJVEVFVHVOUKZAPBDVQHLMUMUNVGVRIUOVBUPOUQVPHVMVGVPVEVFVJARZHVMRVTWA
      VPVEVFWBVTWAADGHLNURUSAPBDHVJLMUTUNVIVKVLVNVAVCVGFHVDUS $.
  $}

  ${
    pexmidALT.a $e |- A = ( Atoms ` K ) $.
    pexmidALT.p $e |- .+ = ( +P ` K ) $.
    pexmidALT.o $e |- ._|_ = ( _|_P ` K ) $.
    $d p A $.  $d p K $.  $d p ._|_ $.  $d p .+ $.  $d p X $.
    $( Lemma for ~ pexmidN .  The contradiction of ~ pexmidlem6N and
       ~ pexmidlem7N shows that there can be no atom ` p ` that is not in
       ` X .+ ( ._|_ `` X ) ` , which is therefore the whole atom space.
       (Contributed by NM, 3-Feb-2012.)  (New usage is discouraged.) $)
    pexmidlem8N $p |- ( ( ( K e. HL /\ X C_ A )
      /\ ( ( ._|_ ` ( ._|_ ` X ) ) = X /\ X =/= (/) ) )
        -> ( X .+ ( ._|_ ` X ) ) = A ) $=
      ( vp chlt wcel wss wa cfv wceq wne wn co nonconne eqid c0 simpll polssatN
      simplr adantr paddssat syl3anc cv wrex df-pss pssnel sylbir df-rex sylibr
      wex csn simplll simpllr simprl simplrl simplrr simprr w3a cjn pexmidlem6N
      wpss cple pexmidlem7N jca syl33anc 2false sylib rexlimdvaa mpand necon1bd
      syl5 mpi ) CJKZEALZMZEDNZDNEOZEUAPZMZMZEEOEEPMZQEWABRZAOEESZWEWFWGAWEWGAL
      ZWGAPZWFWEVRVSWAALZWIVRVSWDUBVRVSWDUDVTWKWDACDEFHUCUEAJBCEWAFGUFUGWIWJMZI
      UHZWGKQZIAUIZWEWFWLWMAKZWNMZIUOZWOWLWGAVFWRWGAUJIWGAUKULWNIAUMUNWEWNWFIAW
      EWQMZEWMUPBRZEOZWTEPZMZWFWSVRVSWPWBWCWNXCVRVSWDWQUQVRVSWDWQURWEWPWNUSVTWB
      WCWQUTVTWBWCWQVAWEWPWNVBVRVSWPVCWBWCWNVCMXAXBABCVDNZCCVGNZWTDEIXETZXDTZFG
      HWTTZVEABXDCXEWTDEIXFXGFGHXHVHVIVJXCWFWTESWHVKVLVMVPVNVOVQ $.

    $( Excluded middle law for closed projective subspaces, which is equivalent
       to (and derived from) the orthomodular law ~ poml4N .  Lemma 3.3(2) in
       [Holland95] p. 215.  In our proof, we use the variables ` X ` , ` M ` ,
       ` p ` , ` q ` , ` r ` in place of Hollands' l, m, P, Q, L respectively.
       TODO: should we make this obsolete?  (Contributed by NM, 3-Feb-2012.)
       (New usage is discouraged.) $)
    pexmidALTN $p |- ( ( ( K e. HL /\ X C_ A ) /\ ( ._|_ ` ( ._|_ ` X ) ) = X )
         -> ( X .+ ( ._|_ ` X ) ) = A ) $=
      ( chlt wcel wss wa cfv wceq co c0 id fveq2 oveq12d pol0N eqimss syl mpdan
      padd02 eqtrd ad2antrr sylan9eqr wne pexmidlem8N anassrs pm2.61dane ) CIJZ
      EAKZLZEDMZDMENZLZEUOBOZANZEPEPNZUQURPPDMZBOZAUTEPUOVABUTQEPDRSULVBANUMUPU
      LVBVAAULVAAKZVBVANULVAANVCAICDFHTZVAAUAUBAIBCVAFGUDUCVDUEUFUGUNUPEPUHUSAB
      CDEFGHUIUJUK $.
  $}

  ${
    pl42lem.b $e |- B = ( Base ` K ) $.
    pl42lem.l $e |- .<_ = ( le ` K ) $.
    pl42lem.j $e |- .\/ = ( join ` K ) $.
    pl42lem.m $e |- ./\ = ( meet ` K ) $.
    pl42lem.o $e |- ._|_ = ( oc ` K ) $.
    pl42lem.f $e |- F = ( pmap ` K ) $.
    pl42lem.p $e |- .+ = ( +P ` K ) $.
    $( Lemma for ~ pl42N .  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pl42lem1N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
           /\ ( Z e. B /\ W e. B /\ V e. B ) ) ->
     ( ( X .<_ ( ._|_ ` Y ) /\ Z .<_ ( ._|_ ` W ) ) ->
       ( F ` ( ( ( ( X .\/ Y ) ./\ Z ) .\/ W ) ./\ V ) )
          = ( ( ( ( ( F ` X ) .+ ( F ` Y ) ) i^i ( F ` Z ) ) .+ ( F ` W ) )
           i^i ( F ` V ) ) ) ) $=
      ( chlt wcel w3a cfv wbr wa co wceq simp11 clat hllat simp12 simp13 latjcl
      cin syl syl3anc simp21 latmcl simp22 catm eqid pmapmeet cops hlop syl2anc
      simp23 opoccl latmle2 simp3r lattrd pmapojoinN simp3l ineq1d eqtrd oveq1d
      syl31anc 3expia ) EUAUBZKAUBZLAUBZUCZMAUBZJAUBZIAUBZUCZKLHUDFUEZMJHUDZFUE
      ZUFZKLDUGZMGUGZJDUGZIGUGCUDZKCUDLCUDBUGZMCUDZUOZJCUDZBUGZICUDZUOZUHWBWFWJ
      UCZWNWMCUDZWTUOZXAXBVSWMAUBZWEWNXDUHVSVTWAWFWJUIZXBEUJUBZWLAUBZWDXEXBVSXG
      XFEUKUPZXBXGWKAUBZWCXHXIXBXGVTWAXJXIVSVTWAWFWJULZVSVTWAWFWJUMZADEKLNPUNUQ
      ZWBWCWDWEWJURZAEGWKMNQUSUQZWBWCWDWEWJUTZADEWLJNPUNUQWBWCWDWEWJVGEVAUDZACE
      GWMINQXQVBZSVCUQXBXCWSWTXBXCWLCUDZWRBUGZWSXBVSXHWDWLWHFUEXCXTUHXFXOXPXBAE
      FWLMWHNOXIXOXNXBEVDUBZWDWHAUBXBVSYAXFEVEUPXPAEHJNRVHVFXBXGXJWCWLMFUEXIXMX
      NAEFGWKMNOQVIUQWBWFWGWIVJVKABDEFCHWLJNOPSRTVLVQXBXSWQWRBXBXSWKCUDZWPUOZWQ
      XBVSXJWCXSYCUHXFXMXNXQACEGWKMNQXRSVCUQXBYBWOWPXBVSVTWAWGYBWOUHXFXKXLWBWFW
      GWIVMABDEFCHKLNOPSRTVLVQVNVOVPVOVNVOVR $.

    $( Lemma for ~ pl42N .  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pl42lem2N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
           /\ ( Z e. B /\ W e. B /\ V e. B ) ) ->
      ( ( ( F ` X ) .+ ( F ` Y ) )
          .+ ( ( ( F ` X ) .+ ( F ` W ) ) i^i ( ( F ` Y ) .+ ( F ` V ) ) ) )
       C_ ( F ` ( ( X .\/ Y ) .\/ ( ( X .\/ W ) ./\ ( Y .\/ V ) ) ) ) ) $=
      ( chlt wcel w3a wa cfv co cin catm simpl1 clat hllat simpl2 simpl3 latjcl
      wss syl syl3anc eqid pmapssat syl2anc simpr2 simpr3 latmcl pmapjoin ss2in
      3jca wceq pmapmeet sseqtr4d jca paddss12 sylc sstrd ) EUAUBZKAUBZLAUBZUCZ
      MAUBZJAUBZIAUBZUCZUDZKCUEZLCUEZBUFZWCJCUEBUFZWDICUEBUFZUGZBUFZKLDUFZCUEZK
      JDUFZLIDUFZGUFZCUEZBUFZWJWNDUFCUEZWBVNWKEUHUEZUOZWOWRUOZUCWEWKUOZWHWOUOZU
      DWIWPUOWBVNWSWTVNVOVPWAUIZWBVNWJAUBZWSXCWBEUJUBZVOVPXDWBVNXEXCEUKUPZVNVOV
      PWAULZVNVOVPWAUMZADEKLNPUNUQZWRAUAECWJNWRURZSUSUTWBVNWNAUBZWTXCWBXEWLAUBZ
      WMAUBZXKXFWBXEVOVSXLXFXGVQVRVSVTVAZADEKJNPUNUQZWBXEVPVTXMXFXHVQVRVSVTVBZA
      DELINPUNUQZAEGWLWMNQVCUQZWRAUAECWNNXJSUSUTVFWBXAXBWBXEVOVPXAXFXGXHABDECKL
      NPSTVDUQWBWHWLCUEZWMCUEZUGZWOWBWFXSUOZWGXTUOZWHYAUOWBXEVOVSYBXFXGXNABDECK
      JNPSTVDUQWBXEVPVTYCXFXHXPABDECLINPSTVDUQWFXSWGXTVEUTWBVNXLXMWOYAVGXCXOXQW
      RACEGWLWMNQXJSVHUQVIVJWRUABEWOWEWKWHXJTVKVLWBXEXDXKWPWQUOXFXIXRABDECWJWNN
      PSTVDUQVM $.

    $( Lemma for ~ pl42N .  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pl42lem3N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
           /\ ( Z e. B /\ W e. B /\ V e. B ) )
        -> ( ( ( ( ( F ` X ) .+ ( F ` Y ) ) i^i ( F ` Z ) ) .+ ( F ` W ) )
           i^i ( F ` V ) ) C_ ( ( ( ( F ` X ) .+ ( F ` Y ) ) .+ ( F ` W ) )
            i^i ( ( ( F ` X ) .+ ( F ` Y ) ) .+ ( F ` V ) ) ) ) $=
      ( chlt wcel w3a wa cfv co cin wss catm simpl1 simpl2 eqid pmapssat simpl3
      syl2anc paddssat syl3anc simpr2 inss1 paddss1 mpi simpr3 sspadd2 ss2in )
      EUAUBZKAUBZLAUBZUCZMAUBZJAUBZIAUBZUCZUDZKCUEZLCUEZBUFZMCUEZUGZJCUEZBUFZVP
      VSBUFZUHZICUEZVPWCBUFZUHZVTWCUGWAWDUGUHVMVEVPEUIUEZUHZVSWFUHZWBVEVFVGVLUJ
      ZVMVEVNWFUHZVOWFUHZWGWIVMVEVFWJWIVEVFVGVLUKWFAUAECKNWFULZSUMUOVMVEVGWKWIV
      EVFVGVLUNWFAUAECLNWLSUMUOWFUABEVNVOWLTUPUQZVMVEVJWHWIVHVIVJVKURWFAUAECJNW
      LSUMUOVEWGWHUCVRVPUHWBVPVQUSWFUABEVRVPVSWLTUTVAUQVMVEWCWFUHZWGWEWIVMVEVKW
      NWIVHVIVJVKVBWFAUAECINWLSUMUOWMWFUABEWCVPWLTVCUQVTWAWCWDVDUO $.

    $( Lemma for ~ pl42N .  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pl42lem4N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
           /\ ( Z e. B /\ W e. B /\ V e. B ) )
     -> ( ( X .<_ ( ._|_ ` Y ) /\ Z .<_ ( ._|_ ` W ) )
        -> ( F ` ( ( ( ( X .\/ Y ) ./\ Z ) .\/ W ) ./\ V ) )
          C_ ( F ` ( ( X .\/ Y )
              .\/ ( ( X .\/ W ) ./\ ( Y .\/ V ) ) ) ) ) ) $=
      ( chlt wcel w3a cfv wbr wa co wss wceq pl42lem1N 3impia pl42lem3N cpsubsp
      cin simpl1 hllat syl simpl2 pmapsub syl2anc simpl3 simpr2 simpr3 pmodl42N
      clat eqid syl32anc pl42lem2N eqsstrd sstrd 3adant3 3expia ) EUAUBZKAUBZLA
      UBZUCZMAUBZJAUBZIAUBZUCZKLHUDFUEMJHUDFUEUFZKLDUGZMGUGJDUGIGUGCUDZWBKJDUGL
      IDUGGUGDUGCUDZUHVPVTWAUCWCKCUDZLCUDZBUGZMCUDUNJCUDZBUGICUDZUNZWDVPVTWAWCW
      JUIABCDEFGHIJKLMNOPQRSTUJUKVPVTWJWDUHWAVPVTUFZWJWGWHBUGWGWIBUGUNZWDABCDEF
      GHIJKLMNOPQRSTULWKWLWGWEWHBUGWFWIBUGUNBUGZWDWKVMWEEUMUDZUBZWFWNUBZWHWNUBZ
      WIWNUBZWLWMUIVMVNVOVTUOZWKEVEUBZVNWOWKVMWTWSEUPUQZVMVNVOVTURAWNECKNWNVFZS
      USUTWKWTVOWPXAVMVNVOVTVAAWNECLNXBSUSUTWKWTVRWQXAVPVQVRVSVBAWNECJNXBSUSUTW
      KWTVSWRXAVPVQVRVSVCAWNECINXBSUSUTBWNEWIWEWFWHXBTVDVGABCDEFGHIJKLMNOPQRSTV
      HVIVJVKVIVL $.
  $}

  ${
    pl42.b $e |- B = ( Base ` K ) $.
    pl42.l $e |- .<_ = ( le ` K ) $.
    pl42.j $e |- .\/ = ( join ` K ) $.
    pl42.m $e |- ./\ = ( meet ` K ) $.
    pl42.o $e |- ._|_ = ( oc ` K ) $.
    $( Law holding in a Hilbert lattice that fails in orthomodular lattice L42
       (Figure 7 in [MegPav2000] p. 2366).  (Contributed by NM, 8-Apr-2012.)
       (New usage is discouraged.) $)
    pl42N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
           /\ ( Z e. B /\ W e. B /\ V e. B ) )
     -> ( ( X .<_ ( ._|_ ` Y ) /\ Z .<_ ( ._|_ ` W ) )
        -> ( ( ( ( X .\/ Y ) ./\ Z ) .\/ W ) ./\ V )
           .<_ ( ( X .\/ Y ) .\/ ( ( X .\/ W ) ./\ ( Y .\/ V ) ) ) ) ) $=
      ( wcel cfv co syl3anc chlt w3a wa wbr cpmap wss cpadd pl42lem4N wb simpl1
      eqid clat simpl2 simpl3 latjcl simpr1 latmcl simpr2 simpr3 pmaple sylibrd
      hllat syl ) CUAQZIAQZJAQZUBZKAQZHAQZGAQZUBZUCZIJFRDUDKHFRDUDUCIJBSZKESZHB
      SZGESZCUERZRVMIHBSZJGBSZESZBSZVQRUFZVPWADUDZACUGRZVQBCDEFGHIJKLMNOPVQUKZW
      DUKUHVLVDVPAQZWAAQZWCWBUIVDVEVFVKUJZVLCULQZVOAQZVJWFVLVDWIWHCVBVCZVLWIVNA
      QZVIWJWKVLWIVMAQZVHWLWKVLWIVEVFWMWKVDVEVFVKUMZVDVEVFVKUNZABCIJLNUOTZVGVHV
      IVJUPACEVMKLOUQTVGVHVIVJURZABCVNHLNUOTVGVHVIVJUSZACEVOGLOUQTVLWIWMVTAQZWG
      WKWPVLWIVRAQZVSAQZWSWKVLWIVEVIWTWKWNWQABCIHLNUOTVLWIVFVJXAWKWOWRABCJGLNUO
      TACEVRVSLOUQTABCVMVTLNUOTACDVQVPWALMWEUTTVA $.
  $}

  $c LHyp $.
  $c LAut $.
  $c WAtoms $.
  $c PAut $.

  $( Extend class notation with set of all co-atoms (lattice hyperplanes). $)
  clh $a class LHyp $.

  $( Extend class notation with set of all lattice automorphisms. $)
  claut $a class LAut $.

  $( Extend class notation with W points. $)
  cwpointsN $a class WAtoms $.

  $( Extend class notation with set of all projective automorphisms. $)
  cpautN $a class PAut $.

  ${
    $d k f d x y $.
    $( Define the set of lattice hyperplanes, which are all lattice elements
       covered by 1 (i.e. all co-atoms).  We call them "hyperplanes" instead of
       "co-atoms" in analogy with projective geometry hyperplanes.
       (Contributed by NM, 11-May-2012.) $)
    df-lhyp $a |- LHyp = ( k e. _V
         |-> { x e. ( Base ` k ) | x ( <o ` k ) ( 1. ` k ) } ) $.

    $( Define set of lattice autoisomorphisms.  (Contributed by NM,
       11-May-2012.) $)
    df-laut $a |- LAut = ( k e. _V |-> { f | ( f : ( Base ` k ) -1-1-onto->
      ( Base ` k ) /\ A. x e. ( Base ` k ) A. y e. ( Base ` k )
        ( x ( le ` k ) y <-> ( f ` x ) ( le ` k ) ( f ` y ) ) ) } ) $.

    $( Define W-atoms corresponding to an arbitrary "fiducial (i.e. reference)
       atom" ` d ` .  These are all atoms not in the polarity of ` { d } ) ` ,
       which is the hyperplane determined by ` d ` .  Definition of set W in
       [Crawley] p. 111.  (Contributed by NM, 26-Jan-2012.) $)
    df-watsN $a |- WAtoms = ( k e. _V |-> ( d e. ( Atoms ` k )
         |-> ( ( Atoms ` k ) \ ( ( _|_P ` k ) ` { d } ) ) ) ) $.

    $( Define the set of hyperplanes, i.e. polarities of atoms,
        on the projective space of a lattice ` k ` . $)
    $(
    df-hyp $a |- PHyp = ( k e. _V |-> { h | E. d e. ( Atoms ` k )
         h = ( ( _|_P ` k ) ` { d } ) ) ) $.
    $)

    $( Define set of all projective automorphisms.  This is the intended
       definition of automorphism in [Crawley] p. 112.  (Contributed by NM,
       26-Jan-2012.) $)
    df-pautN $a |- PAut = ( k e. _V |-> { f | ( f : ( PSubSp ` k ) -1-1-onto->
      ( PSubSp ` k ) /\ A. x e. ( PSubSp ` k ) A. y e. ( PSubSp ` k )
        ( x C_ y <-> ( f ` x ) C_ ( f ` y ) ) ) } ) $.
  $}

  ${
    $d d k A $.  $d d D $.  $d d k K $.
    watomfval.a $e |- A = ( Atoms ` K ) $.
    watomfval.p $e |- P = ( _|_P ` K ) $.
    watomfval.w $e |- W = ( WAtoms ` K ) $.
    $( The W atoms function.  (Contributed by NM, 26-Jan-2012.)
       (New usage is discouraged.) $)
    watfvalN $p |- ( K e. B -> W = ( d e. A
         |-> ( A \ ( ( _|_P ` K ) ` { d } ) ) ) ) $=
      ( vk wcel cvv cv cpolN cfv cdif cmpt wceq cwpointsN catm csn elex syl6eqr
      fveq2 fveq1d difeq12d mpteq12dv df-watsN fvex eqeltri mptex fvmpt syl5eq
      syl ) DBKDLKZEFAAFMUAZDNOZOZPZQZRDBUBUOEDSOUTIJDFJMZTOZVBUPVANOZOZPZQUTLS
      VADRZFVBVEAUSVFVBDTOZAVADTUDGUCZVFVBAVDURVHVFUPVCUQVADNUDUEUFUGJFUHFAUSAV
      GLGDTUIUJUKULUMUN $.

    $( Value of the W atoms function.  (Contributed by NM, 26-Jan-2012.)
       (New usage is discouraged.) $)
    watvalN $p |- ( ( K e. B /\ D e. A )
       -> ( W ` D ) = ( A \ ( ( _|_P ` K ) ` { D } ) ) ) $=
      ( vd wcel cfv cv csn cpolN cdif cmpt watfvalN cvv catm fveq1d wceq fveq2d
      sneq difeq2d eqid fvex eqeltri difexg ax-mp fvmpt sylan9eq ) EBKZCAKCFLCJ
      AAJMZNZEOLZLZPZQZLACNZUPLZPZUMCFUSABDEFJGHIRUAJCURVBAUSUNCUBZUQVAAVCUOUTU
      PUNCUDUCUEUSUFASKVBSKAETLSGETUGUHAVASUIUJUKUL $.

    $( The predicate "is a W atom" (corresponding to fiducial atom ` D ` ).
       (Contributed by NM, 26-Jan-2012.)  (New usage is discouraged.) $)
    iswatN $p |- ( ( K e. B /\ D e. A ) -> ( P e. ( W ` D )
       <-> ( P e. A /\ -. P e. ( ( _|_P ` K ) ` { D } ) ) ) ) $=
      ( wcel wa cfv csn cpolN cdif wn watvalN eleq2d eldif syl6bb ) EBJCAJKZDCF
      LZJDACMENLLZOZJDAJDUCJPKUAUBUDDABCDEFGHIQRDAUCST $.
  $}

  ${
    $d k w B $.  $d k w C $.  $d k w K $.  $d k w .1. $.  $d w W $.
    lhpset.b $e |- B = ( Base ` K ) $.
    lhpset.u $e |- .1. = ( 1. ` K ) $.
    lhpset.c $e |- C = ( <o ` K ) $.
    lhpset.h $e |- H = ( LHyp ` K ) $.
    $( The set of co-atoms (lattice hyperplanes).  (Contributed by NM,
       11-May-2012.) $)
    lhpset $p |- ( K e. A -> H = { w e. B | w C .1. } ) $=
      ( vk wcel cvv cfv cp1 ccvr cbs fveq2 syl6eqr wbr crab wceq elex clh eqidd
      cv breq123d rabeqbidv df-lhyp fvex eqeltri rabex fvmpt syl5eq syl ) GBMGN
      MZFAUGZEDUAZACUBZUCGBUDUQFGUEOUTKLGURLUGZPOZVAQOZUAZAVAROZUBUTNUEVAGUCZVD
      USAVECVFVEGROZCVAGRSHTVFURURVBEVCDVFURUFVFVCGQODVAGQSJTVFVBGPOEVAGPSITUHU
      IALUJUSACCVGNHGRUKULUMUNUOUP $.

    $( The predicate "is a co-atom (lattice hyperplane)."  (Contributed by NM,
       11-May-2012.) $)
    islhp $p |- ( K e. A -> ( W e. H <-> ( W e. B /\ W C .1. ) ) ) $=
      ( vw wcel cv wbr crab wa lhpset eleq2d breq1 elrab syl6bb ) FAMZGEMGLNZDC
      OZLBPZMGBMGDCOZQUCEUFGLABCDEFHIJKRSUEUGLGBUDGDCTUAUB $.

    $( The predicate "is a co-atom (lattice hyperplane)."  (Contributed by NM,
       18-May-2012.) $)
    islhp2 $p |- ( ( K e. A /\ W e. B ) -> ( W e. H <-> W C .1. ) ) $=
      ( wcel wbr islhp baibd ) FALGELGBLGDCMABCDEFGHIJKNO $.
  $}

  ${
    lhpbase.b $e |- B = ( Base ` K ) $.
    lhpbase.h $e |- H = ( LHyp ` K ) $.
    $( A co-atom is a member of the lattice base set (i.e. a lattice element).
       (Contributed by NM, 18-May-2012.) $)
    lhpbase $p |- ( W e. H -> W e. B ) $=
      ( cvv wcel clh cfv c0 wceq n0i eqeq1i sylnib fvprc nsyl2 cp1 ccvr eqid
      wbr islhp simprbda mpancom ) CGHZDBHZDAHZUFCIJZKLZUEUFBKLUIBDMBUHKFNOCIPQ
      UEUFUGDCRJZCSJZUAGAUKUJBCDEUJTUKTFUBUCUD $.
  $}

  ${
    lhp1cvr.u $e |- .1. = ( 1. ` K ) $.
    lhp1cvr.c $e |- C = ( <o ` K ) $.
    lhp1cvr.h $e |- H = ( LHyp ` K ) $.
    $( The lattice unit covers a co-atom (lattice hyperplane).  (Contributed by
       NM, 18-May-2012.) $)
    lhp1cvr $p |- ( ( K e. A /\ W e. H ) -> W C .1. ) $=
      ( wcel cbs cfv wbr eqid islhp simplbda ) EAJFDJFEKLZJFCBMAQBCDEFQNGHIOP
      $.

  $}

  ${
    lhplt.l $e |- .<_ = ( le ` K ) $.
    lhplt.s $e |- .< = ( lt ` K ) $.
    lhplt.a $e |- A = ( Atoms ` K ) $.
    lhplt.h $e |- H = ( LHyp ` K ) $.
    $( An atom under a co-atom is strictly less than it.  TODO: is this
       needed?  (Contributed by NM, 1-Jun-2012.) $)
    lhplt $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ P .<_ W ) )
       -> P .< W ) $=
      ( chlt wcel wa wbr cbs cfv cp1 ccvr eqid simpll lhpbase ad2antlr 1cvratlt
      simprl lhp1cvr adantr simprr syl32anc ) ELMZGDMZNZBAMZBGFOZNZNUJUMGEPQZMZ
      GERQZESQZOZUNBGCOUJUKUOUAULUMUNUEUKUQUJUOUPDEGUPTZKUBUCULUTUOLUSURDEGURTZ
      USTZKUFUGULUMUNUHAUPUSBCUREFGVAHIVBVCJUDUI $.
  $}

  ${
    $d r s .<_ $.  $d r s .\/ $.  $d r s A $.  $d r s H $.  $d r s K $.
    $d r s P $.  $d r s Q $.  $d r s W $.
    lhp2lt.l $e |- .<_ = ( le ` K ) $.
    lhp2lt.s $e |- .< = ( lt ` K ) $.
    lhp2lt.j $e |- .\/ = ( join ` K ) $.
    lhp2lt.a $e |- A = ( Atoms ` K ) $.
    lhp2lt.h $e |- H = ( LHyp ` K ) $.
    $( The join of two atoms under a co-atom is strictly less than it.
       (Contributed by NM, 8-Jul-2013.) $)
    lhp2lt $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ P .<_ W )
          /\ ( Q e. A /\ Q .<_ W ) )
       -> ( P .\/ Q ) .< W ) $=
      ( wcel wa wbr wb syl syl3anc vr vs chlt w3a co wne simp2r simp3r clat cbs
      simp1l hllat simp2l eqid atbase simp3l lhpbase latjle12 syl13anc mpbi2and
      cfv simp1r cv wn wrex 3dim2 cp1 ccvr cops simp11l simp12l simp13l hlatjcl
      hlop latjcl ncvr1 syl2anc wceq wi cpo simpl1l hlpos simpl2l simpl3l op1cl
      simpr1l ple1 simpr2l cvr1 simpr3 simpl1r lhp1cvr eqbrtrd cvrcmp syl132anc
      mpbid simpr2r simpr1r eqbrtrrd 3imp necon3bd mpd 3exp rexlimdvv mpbir2and
      3exp2 pltval ) GUCOZIEOZPZBAOZBIHQZPZCAOZCIHQZPZUDZBCFUEZIDQZXRIHQZXRIUFZ
      XQXLXOXTXJXKXLXPUGXJXMXNXOUHXQGUIOZBGUJVAZOZCYCOZIYCOZXLXOPXTRXQXHYBXHXIX
      MXPUKZGULZSXQXKYDXJXKXLXPUMZAYCBGYCUNZMUOSXQXNYEXJXMXNXOUPZAYCCGYJMUOSXQX
      IYFXHXIXMXPVBZYCEGIYJNUQSYCFGHBCIYJJLURUSUTXQUAVCZXRHQVDZUBVCZXRYMFUEZHQV
      DZPZUBAVEUAAVEZYAXQXHXKXNYSYGYIYKABCFGHUBUALJMVFTXQYRYAUAUBAAXQYMAOZYOAOZ
      PZYRYAXQUUBYRUDZGVGVAZYPYOFUEZGVHVAZQZVDZYAUUCGVIOZUUEYCOZUUHUUCXHUUIXHXI
      XMXPUUBYRVJZGVNZSUUCYBYPYCOZYOYCOZUUJUUCXHYBUUKYHSZUUCYBXRYCOZYMYCOZUUMUU
      OUUCXHXKXNUUPUUKXKXLXJXPUUBYRVKXNXOXJXMUUBYRVLAYCFGBCYJLMVMZTUUCYTUUQXQYT
      UUAYRUMAYCYMGYJMUOZSYCFGXRYMYJLVOZTUUCUUAUUNXQYTUUAYRUGAYCYOGYJMUOSYCFGYP
      YOYJLVOTYCUUFUUDGUUEYJUUDUNZUUFUNZVPVQUUCUUGXRIXQUUBYRXRIVRZUUGVSXQUUBYRU
      VCUUGXQUUBYRUVCUDZPZYPUUDUUEUUFUVEYPUUDHQZYPUUDVRZUVEGVTOZUUMUUDYCOZUVFUV
      EXHUVHXHXIXMXPUVDWAZGWBSZUVEYBUUPUUQUUMUVEXHYBUVJYHSUVEXHXKXNUUPUVJXKXLXJ
      XPUVDWCXNXOXJXMUVDWDUURTZUVEYTUUQYTUUAYRUVCXQWFZUUSSUUTTZUVEUUIUVIUVEXHUU
      IUVJUULSYCUUDGYJUVAWESZYCUUDGHYPYJJUVAWGTUVEUVHUUMUVIUUPXRYPUUFQZXRUUDUUF
      QUVFUVGRUVKUVNUVOUVLUVEYNUVPYNYQUUBUVCXQWHUVEXHUUPYTYNUVPRUVJUVLUVMAYCUUF
      YMFGHXRYJJLUVBMWITWPUVEXRIUUDUUFXQUUBYRUVCWJUVEXHXIIUUDUUFQUVJXHXIXMXPUVD
      WKUCUUFUUDEGIUVAUVBNWLVQWMYCUUFGHYPUUDXRYJJUVBWNWOWPUVEYQYPUUEUUFQZYNYQUU
      BUVCXQWQUVEXHUUMUUAYQUVQRUVJUVNYTUUAYRUVCXQWRAYCUUFYOFGHYPYJJLUVBMWITWPWS
      XFWTXAXBXCXDXBXQXHUUPXIXSXTYAPRYGXQXHXKXNUUPYGYIYKUURTYLUCYCEDGHXRIJKXGTX
      E $.
  $}

  ${
    $d p A $.  $d p K $.  $d p .< $.  $d p W $.
    lhpatltex.s $e |- .< = ( lt ` K ) $.
    lhpatltex.a $e |- A = ( Atoms ` K ) $.
    lhpatltex.h $e |- H = ( LHyp ` K ) $.
    $( There exists an atom less than a co-atom.  TODO: is this needed?
       (Contributed by NM, 1-Jun-2012.) $)
    lhpexlt $p |- ( ( K e. HL /\ W e. H ) -> E. p e. A p .< W ) $=
      ( chlt wcel wa cbs cfv cp1 ccvr wbr cv wrex eqid lhpbase lhp1cvr 1cvratex
      simpl adantl syl3anc ) DJKZECKZLUGEDMNZKZEDONZDPNZQFREBQFASUGUHUDUHUJUGUI
      CDEUITZIUAUEJULUKCDEUKTZULTZIUBAUIULBUKDEFUMGUNUOHUCUF $.
  $}

  ${
    $d p H $.  $d p K $.  $d p .< $.  $d p W $.  $d p .0. $.
    lhp0lt.s $e |- .< = ( lt ` K ) $.
    lhp0lt.z $e |- .0. = ( 0. ` K ) $.
    lhp0lt.h $e |- H = ( LHyp ` K ) $.
    $( A co-atom is greater than zero.  TODO: is this needed?  (Contributed by
       NM, 1-Jun-2012.) $)
    lhp0lt $p |- ( ( K e. HL /\ W e. H ) -> .0. .< W ) $=
      ( vp chlt wcel wa cv wbr catm cfv wrex eqid lhpexlt syl w3a cbs ccvr cops
      simp1l hlop op0cl 3syl atbase 3ad2ant2 simp2 syl2anc cvrlt syl31anc simp3
      atcvr0 cpo wi hlpos simp1r lhpbase plttr syl13anc mp2and rexlimdv3a mpd )
      CJKZDBKZLZIMZDANZICOPZQEDANZVLABCDIFVLRZHSVIVKVMIVLVIVJVLKZVKUAZEVJANZVKV
      MVPVGECUBPZKZVJVRKZEVJCUCPZNZVQVGVHVOVKUEZVPVGCUDKVSWCCUFVRCEVRRZGUGUHZVO
      VIVTVKVLVRVJCWDVNUIUJZVPVGVOWBWCVIVOVKUKVLWAJVJCEGWARZVNUPULJVRWAACEVJWDF
      WGUMUNVIVOVKUOVPCUQKZVSVTDVRKZVQVKLVMURVPVGWHWCCUSTWEWFVPVHWIVGVHVOVKUTVR
      BCDWDHVATVRACEVJDWDFVBVCVDVEVF $.
  $}

  ${
    lhpne0.z $e |- .0. = ( 0. ` K ) $.
    lhpne0.h $e |- H = ( LHyp ` K ) $.
    $( A co-atom is nonzero.  TODO: is this needed?  (Contributed by NM,
       26-Apr-2013.) $)
    lhpn0 $p |- ( ( K e. HL /\ W e. H ) -> W =/= .0. ) $=
      ( chlt wcel wa cplt cfv wbr wne eqid lhp0lt cbs wi simpl cops hlop adantr
      op0cl syl simpr pltne syl3anc mpd necomd ) BGHZCAHZIZDCUKDCBJKZLZDCMZULAB
      CDULNZEFOUKUIDBPKZHZUJUMUNQUIUJRUIUQUJUIBSHUQBTUPBDUPNEUBUCUAUIUJUDGUPAUL
      BDCUOUEUFUGUH $.
  $}

  ${
    $d p q A $.  $d p q H $.  $d p q K $.  $d p q .<_ $.  $d q P $.
    $d p q W $.
    lhp2a.l $e |- .<_ = ( le ` K ) $.
    lhp2a.a $e |- A = ( Atoms ` K ) $.
    lhp2a.h $e |- H = ( LHyp ` K ) $.
    $( There exists an atom under a co-atom.  (Contributed by NM,
       26-Apr-2013.) $)
    lhpexle $p |- ( ( K e. HL /\ W e. H ) -> E. p e. A p .<_ W ) $=
      ( chlt wcel wa cbs cfv cp0 wne cv wbr wrex eqid simpl lhpbase adantl atle
      lhpn0 syl3anc ) CJKZEBKZLUGECMNZKZECONZPFQEDRFASUGUHUAUHUJUGUIBCEUITZIUBU
      CBCEUKUKTZIUEAUICDEUKFULGUMHUDUF $.

    $( There exists an atom not under a co-atom.  (Contributed by NM,
       12-Apr-2013.) $)
    lhpexnle $p |- ( ( K e. HL /\ W e. H ) -> E. p e. A -. p .<_ W ) $=
      ( chlt wcel wa cv wbr wn cfv wrex eqid simpl syl cjn co wceq ccvr lhp1cvr
      cp1 wb lhpbase adantl cops hlop op1cl adantr cvrval3 syl3anc mpbid reximi
      cbs ) CJKZEBKZLZFMZEDNOZEVBCUAPZUBCUFPZUCZLZFAQZVCFAQVAEVECUDPZNZVHJVIVEB
      CEVERZVIRZIUEVAUSECURPZKZVEVMKZVJVHUGUSUTSUTVNUSVMBCEVMRZIUHUIUSVOUTUSCUJ
      KVOCUKVMVECVPVKULTUMAVMVIVDCDEVEFVPGVDRVLHUNUOUPVGVCFAVCVFSUQT $.
  $}

  ${
    $d p .<_ $.  $d p A $.  $d p W $.  $d p X $.  $d p ph $.
    lhpexle1lem.1 $e |- ( ph -> E. p e. A ( p .<_ W /\ ps ) ) $.
    lhpexle1lem.2 $e |- ( ( ph /\ ( X e. A /\ X .<_ W ) )
       -> E. p e. A ( p .<_ W /\ ps /\ p =/= X ) ) $.
    $( Lemma for ~ lhpexle1 and others that eliminates restrictions on ` X ` .
       (Contributed by NM, 24-Jul-2013.) $)
    lhpexle1lem $p |- ( ph -> E. p e. A ( p .<_ W /\ ps /\ p =/= X ) ) $=
      ( wcel wbr wrex wn wa adantr simprl simprr simplr syl2anc 3jca cv wne w3a
      simpllr nelne2 ex reximdva mpd nbrne2 reximdv pm2.61dda ) AFCJZFEDKZGUAZE
      DKZBUNFUBZUCZGCLZAULMZNZUOBNZGCLZURAVBUSHOUTVAUQGCUTUNCJZNZVAUQVDVANZUOBU
      PVDUOBPVDUOBQVEVCUSUPUTVCVARAUSVCVAUDUNFCUESTUFUGUHAUMMZNZVBURAVBVFHOVGVA
      UQGCVGVAUQVGVANZUOBUPVGUOBPZVGUOBQVHUOVFUPVIAVFVARUNFEDUISTUFUJUHIUK $.
  $}

  ${
    $d p .<_ $.  $d p A $.  $d p H $.  $d p K $.  $d p W $.  $d p X $.
    $d p Y $.  $d p Z $.
    lhpex1.l $e |- .<_ = ( le ` K ) $.
    lhpex1.a $e |- A = ( Atoms ` K ) $.
    lhpex1.h $e |- H = ( LHyp ` K ) $.
    $( There exists an atom under a co-atom different from any given element.
       (Contributed by NM, 24-Jul-2013.) $)
    lhpexle1 $p |- ( ( K e. HL /\ W e. H )
       -> E. p e. A ( p .<_ W /\ p =/= X ) ) $=
      ( chlt wcel wa wbr wtru w3a wrex reximi syl cfv wne lhpexle tru jctr cplt
      cv cbs simpll simprl eqid lhpbase ad2antlr lhplt 2atlt syl31anc simp3r wi
      simp1ll simp2 simp1lr pltle syl3anc mpd a1tru simp3l 3jca 3expia reximdva
      lhpexle1lem 3simpb ) CKLZEBLZMZGUFZEDNZOVNFUAZPZGAQZVOVPMZGAQVMOADEFGVMVO
      GAQVOOMZGAQABCDEGHIJUBVOVTGAVOOUCUDRSVMFALZFEDNZMZMZVPVNECUETZNZMZGAQZVRW
      DVKWAECUGTZLZFEWENWHVKVLWCUHVMWAWBUIVLWJVKWCWIBCEWIUJZJUKULAFWEBCDEHWEUJZ
      IJUMAWIFWECEGWKWLIUNUOWDWGVQGAWDVNALZWGVQWDWMWGPZVOOVPWNWFVOWDWMVPWFUPWNV
      KWMVLWFVOUQVKVLWCWMWGURWDWMWGUSVKVLWCWMWGUTKABWECDVNEHWLVAVBVCWNVDWDWMVPW
      FVEVFVGVHVCVIVQVSGAVOOVPVJRS $.

    $( Lemma for ~ lhpexle2 .  (Contributed by NM, 19-Jun-2013.) $)
    lhpexle2lem $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( X e. A /\ X .<_ W ) /\ ( Y e. A /\ Y .<_ W ) )
       -> E. p e. A ( p .<_ W /\ p =/= X /\ p =/= Y ) ) $=
      ( wcel wa wbr w3a wne wrex syl 3jca atbase chlt cv simpl1 lhpexle1 simp3l
      wceq simp3r neeqtrd 3expia reximdv mpd cjn cfv co simpl1l simpl2l simpl3l
      simp2 simpr eqid hlsupr syl31anc cbs clat simprlr hlatjcl syl3anc simpl1r
      wi hllat lhpbase simprr3 simpl2r simpl3r latjle12 syl13anc lattrd simprr1
      wb mpbi2and simprr2 exp44 imp31 reximdva pm2.61dane ) CUALZEBLZMZFALZFEDN
      ZMZGALZGEDNZMZOZHUBZEDNZWPFPZWPGPZOZHAQZFGWOFGUFZMZWQWRMZHAQZXAXCWHXEWHWK
      WNXBUCABCDEFHIJKUDRXCXDWTHAWOXBXDWTWOXBXDOZWQWRWSWOXBWQWRUEWOXBWQWRUGZXFW
      PFGXGWOXBXDURUHSUIUJUKWOFGPZMZWRWSWPFGCULUMZUNZDNZOZHAQZXAXIWFWIWLXHXNWFW
      GWKWNXHUOWIWJWHWNXHUPWLWMWHWKXHUQWOXHUSAFGXJCDHIXJUTZJVAVBXIXMWTHAWOXHWPA
      LZXMWTVIWOXHXPXMWTWOXHXPMZXMMZMZWQWRWSXSCVCUMZCDWPXKEXTUTZIXSWFCVDLZWFWGW
      KWNXRUOZCVJRZXSXPWPXTLWOXHXPXMVEAXTWPCYAJTRXSWFWIWLXKXTLYCWIWJWHWNXRUPZWL
      WMWHWKXRUQZAXTXJCFGYAXOJVFVGXSWGEXTLZWFWGWKWNXRVHXTBCEYAKVKRZWRWSXLXQWOVL
      XSWJWMXKEDNZWIWJWHWNXRVMWLWMWHWKXRVNXSYBFXTLZGXTLZYGWJWMMYIVSYDXSWIYJYEAX
      TFCYAJTRXSWLYKYFAXTGCYAJTRYHXTXJCDFGEYAIXOVOVPVTVQWRWSXLXQWOVRWRWSXLXQWOW
      ASWBWCWDUKWE $.

    $( There exists atom under a co-atom different from any two other
       elements.  (Contributed by NM, 24-Jul-2013.) $)
    lhpexle2 $p |- ( ( K e. HL /\ W e. H )
       -> E. p e. A ( p .<_ W /\ p =/= X /\ p =/= Y ) ) $=
      ( chlt wcel wa wne lhpexle1 wbr w3a wrex lhpexle1lem cv lhpexle2lem 3expa
      adantr 3ancomb rexbii sylib ) CLMEBMNZHUAZFOZADEGHABCDEFHIJKPUHGAMGEDQNZN
      ZUIEDQZUIGOZUJRZHASZUMUJUNRZHASULUNADEFHUHUMUNNHASUKABCDEGHIJKPUDUHUKFAMF
      EDQNUPABCDEGFHIJKUBUCTUOUQHAUMUNUJUEUFUGT $.

    $( There exists atom under a co-atom different from any 3 other atoms.
       TODO: study if adant*,simp* usage can be improved.  (Contributed by NM,
       9-Jul-2013.) $)
    lhpexle3lem $p |- ( ( ( K e. HL /\ W e. H )
              /\ ( X e. A /\ Y e. A /\ Z e. A )
              /\ ( X .<_ W /\ Y .<_ W /\ Z .<_ W ) )
       -> E. p e. A ( p .<_ W /\ ( p =/= X /\ p =/= Y /\ p =/= Z ) ) ) $=
      ( wcel wa w3a wbr wne wrex syl adantr chlt cv wceq simpl1 lhpexle2 simp31
      simp32 simp1r neeqtrd simp33 3jca jca 3exp reximdvai mpd cjn co wn simp11
      cfv cplt simp121 simp131 simp122 simp132 eqid lhp2lt syl122anc wi simp11l
      cbs hlatjcl syl3anc simp11r lhpbase hlrelat1 simprrr clat atbase ad2antrl
      hllat simprrl latnlej1l syl131anc simpl3 nbrne2 syl2anc exp32 3expa simp2
      latnlej1r necomd hlsupr syl31anc simprr3 latjle12 syl13anc lattrd simprr1
      wb mpbi2and simprr2 pm2.61dan pm2.61dane ) CUAMZEBMZNZFAMZGAMZHAMZOZFEDPZ
      GEDPZHEDPZOZOZIUBZEDPZXQFQZXQGQZXQHQZOZNZIARZFGXPFGUCZNZXRXSYAOZIARZYDYFX
      GYHXGXKXOYEUDABCDEFHIJKLUESYFYGYCIAYFXQAMZYGYCYFYIYGOZXRYBYFYIXRXSYAUFYJX
      SXTYAYFYIXRXSYAUGZYJXQFGYKXPYEYIYGUHUIYFYIXRXSYAUJUKULUMUNUOXPFGQZNHFGCUP
      UTZUQZDPZYDXPYLYOYDXPYLYOOZXQYNDPZURZXRNZIARZYDYPYNECVAUTZPZYTYPXGXHXLXIX
      MUUBXGXKXOYLYOUSXHXIXJXGXOYLYOVBZXLXMXNXGXKYLYOVCXHXIXJXGXOYLYOVDZXLXMXNX
      GXKYLYOVEAFGUUABYMCDEJUUAVFZYMVFZKLVGVHYPXEYNCVKUTZMZEUUGMZUUBYTVIXEXFXKX
      OYLYOVJZYPXEXHXIUUHUUJUUCUUDAUUGYMCFGUUGVFZUUFKVLZVMYPXFUUIXEXFXKXOYLYOVN
      UUGBCEUUKLVOZSAUUGUUACDYNEIUUKJUUEKVPVMUOYPYSYCIAYPYIYSYCYPYIYSNZNZXRYBYP
      YIYRXRVQUUOXSXTYAUUOCVRMZXQUUGMZFUUGMZGUUGMZYRXSUUOXEUUPYPXEUUNUUJTCWAZSZ
      YIUUQYPYSAUUGXQCUUKKVSZVTZUUOXHUURYPXHUUNUUCTAUUGFCUUKKVSZSZUUOXIUUSYPXIU
      UNUUDTAUUGGCUUKKVSZSZYPYIYRXRWBZUUGYMCDXQFGUUKJUUFWCWDUUOUUPUUQUURUUSYRXT
      UVAUVCUVEUVGUVHUUGYMCDXQFGUUKJUUFWKWDUUOYOYRYAXPYLYOUUNWEUVHYOYRNHXQHXQYN
      DWFWLWGUKULWHUNUOWIXPYLYOURZYDXPYLUVIOZXSXTYQOZIARZYDUVJXEXHXIYLUVLXEXFXK
      XOYLUVIVJZXHXIXJXGXOYLUVIVBZXHXIXJXGXOYLUVIVDZXPYLUVIWJAFGYMCDIJUUFKWMWNU
      VJUVKYCIAUVJYIUVKYCUVJYIUVKNZNZXRYBUVQUUGCDXQYNEUUKJUVQXEUUPUVJXEUVPUVMTZ
      UUTSZYIUUQUVJUVKUVBVTUVQXEXHXIUUHUVRUVJXHUVPUVNTZUVJXIUVPUVOTZUULVMUVQXFU
      UIUVJXFUVPXEXFXKXOYLUVIVNTUUMSZXSXTYQYIUVJWOZUVQXLXMYNEDPZUVJXLUVPXLXMXNX
      GXKYLUVIVCTUVJXMUVPXLXMXNXGXKYLUVIVETUVQUUPUURUUSUUIXLXMNUWDWTUVSUVQXHUUR
      UVTUVDSUVQXIUUSUWAUVFSUWBUUGYMCDFGEUUKJUUFWPWQXAWRUVQXSXTYAXSXTYQYIUVJWSX
      SXTYQYIUVJXBUVQYQUVIYAUWCXPYLUVIUVPWEXQHYNDWFWGUKULWHUNUOWIXCXD $.

    $( There exists atom under a co-atom different from any three other
       elements.  (Contributed by NM, 24-Jul-2013.) $)
    lhpexle3 $p |- ( ( K e. HL /\ W e. H )
       -> E. p e. A ( p .<_ W /\ ( p =/= X /\ p =/= Y /\ p =/= Z ) ) ) $=
      ( wcel wa wbr w3a wrex 3anass rexbii sylib chlt cv lhpexle2 adantr simpl1
      wne 3ad2ant1 simpl3l simpl2l simprl simpl3r simpl2r lhpexle3lem syl133anc
      simprr df-3an anbi2i bitr4i lhpexle1lem an31 3bitr4i 3expa an32 ) CUAMEBM
      NZIUBZEDOZVEFUFZVEGUFZNZVEHUFZPZIAQZVFVGVHVJPZNZIAQVDVIADEHIVDVFVGVHPZIAQ
      VFVINZIAQABCDEFGIJKLUCVOVPIAVFVGVHRSTVDHAMZHEDOZNZNZVFVGVJNZVHPZIAQZVLVTW
      AADEGIVTVFVGVJPZIAQZVFWANZIAQVDWEVSABCDEFHIJKLUCUDWDWFIAVFVGVJRSTVDVSGAMZ
      GEDOZNZWCVDVSWIPZVFVHVJNZVGPZIAQZWCWJWKADEFIVDVSVFWKNZIAQZWIVDVFVHVJPZIAQ
      WOABCDEGHIJKLUCWPWNIAVFVHVJRSTUGWJFAMZFEDOZNZNZVFVHVJVGPZNZIAQZWMWTVDWGVQ
      WQWHVRWRXCVDVSWIWSUEWGWHVDVSWSUHVQVRVDWIWSUIWJWQWRUJWGWHVDVSWSUKVQVRVDWIW
      SULWJWQWRUOABCDEGHFIJKLUMUNXBWLIAXBVFWKVGNZNZWLXAXDVFVHVJVGUPUQVFWKVGRZUR
      STUSWLWBIAXEVFWAVHNZNZWLWBXDXGVFVHVJVGUTUQXFVFWAVHRZVASTVBUSWBVKIAXHVFVIV
      JNZNZWBVKXGXJVFVGVJVHVCUQXIVFVIVJRZVASTUSVKVNIAVKXKVNXLVMXJVFVGVHVJUPUQUR
      ST $.
  $}

  ${
    $d p q A $.  $d p q H $.  $d p q K $.  $d p q .<_ $.  $d q P $.
    $d p q W $.
    lhp2at.l $e |- .<_ = ( le ` K ) $.
    lhp2at.a $e |- A = ( Atoms ` K ) $.
    lhp2at.h $e |- H = ( LHyp ` K ) $.
    $( There exist at least two different atoms under a co-atom.  This allows
       us to create a line under the co-atom.  TODO: is this needed?
       (Contributed by NM, 1-Jun-2012.)  (New usage is discouraged.) $)
    lhpex2leN $p |- ( ( K e. HL /\ W e. H )
       -> E. p e. A E. q e. A ( p .<_ W /\ q .<_ W /\ p =/= q ) ) $=
      ( chlt wcel wa cv wbr wrex wne w3a lhpexle simprr lhpexle1 adantr 3anbi3i
      jca necom 3anass bitri rexbii r19.42v bitr2i sylib exp32 reximdvai mpd )
      CKLEBLMZGNZEDOZGAPUQFNZEDOZUPURQZRZFAPZGAPABCDEGHIJSUOUQVBGAUOUPALZUQVBUO
      VCUQMZMZUQUSURUPQZMZFAPZMZVBVEUQVHUOVCUQTUOVHVDABCDEUPFHIJUAUBUDVBUQVGMZF
      APVIVAVJFAVAUQUSVFRVJUTVFUQUSUPURUEUCUQUSVFUFUGUHUQVGFAUIUJUKULUMUN $.
  $}

  ${
    lhpoc.b $e |- B = ( Base ` K ) $.
    lhpoc.o $e |- ._|_ = ( oc ` K ) $.
    lhpoc.a $e |- A = ( Atoms ` K ) $.
    lhpoc.h $e |- H = ( LHyp ` K ) $.
    $( The orthocomplement of a co-atom (lattice hyperplane) is an atom.
       (Contributed by NM, 18-May-2012.) $)
    lhpoc $p |- ( ( K e. HL /\ W e. B ) ->
      ( W e. H <-> ( ._|_ ` W ) e. A ) ) $=
      ( chlt wcel wa cp1 cfv ccvr wbr eqid islhp2 1cvrco bitrd ) DKLFBLMFCLFDNO
      ZDPOZQFEOALKBUCUBCDFGUBRZUCRZJSABUCUBDEFGUDHUEITUA $.

    $( The orthocomplement of an atom is a co-atom (lattice hyperplane).
       (Contributed by NM, 20-Jun-2012.)  (New usage is discouraged.) $)
    lhpoc2N $p |- ( ( K e. HL /\ W e. B ) ->
      ( W e. A <-> ( ._|_ ` W ) e. H ) ) $=
      ( chlt wcel wa cfv wb cops hlop opoccl sylan lhpoc syldan opococ eleq1d
      wceq bitr2d ) DKLZFBLZMZFENZCLZUIENZALZFALUFUGUIBLZUJULOUFDPLZUGUMDQZBDEF
      GHRSABCDEUIGHIJTUAUHUKFAUFUNUGUKFUDUOBDEFGHUBSUCUE $.
  $}

  ${
    lhpocnle.l $e |- .<_ = ( le ` K ) $.
    lhpocnle.o $e |- ._|_ = ( oc ` K ) $.
    lhpocnle.h $e |- H = ( LHyp ` K ) $.
    $( The orthocomplement of a co-atom is not under it.  (Contributed by NM,
       22-May-2012.) $)
    lhpocnle $p |- ( ( K e. HL /\ W e. H ) -> -. ( ._|_ ` W ) .<_ W ) $=
      ( chlt wcel wa cfv wbr wceq simpr wb eqid mpbid syl2anc ad2antrr cp0 catm
      cal wne hlatl adantr cbs lhpbase lhpoc sylan2 atn0 neneqd cmee clat hllat
      cops hlop ad2antlr opoccl latref latlem12 syl13anc mpbi2and breqtrd ople0
      co opnoncon mtand ) BIJZEAJZKZEDLZECMZVLBUALZNZVKVLVNVKBUCJZVLBUBLZJZVLVN
      UDVIVPVJBUEUFVKVJVRVIVJOVJVIEBUGLZJZVJVRPVSABEVSQZHUHZVQVSABDEWAGVQQZHUIU
      JRVQVLBVNVNQZWCUKSULVKVMKZVLVNCMZVOWEVLEVLBUMLZVFZVNCWEVMVLVLCMZVLWHCMZVK
      VMOWEBUNJZVLVSJZWIVIWKVJVMBUOTZWEBUPJZVTWLVIWNVJVMBUQTZVJVTVIVMWBURZVSBDE
      WAGUSSZVSBCVLWAFUTSWEWKWLVTWLVMWIKWJPWMWQWPWQVSBCWGVLEVLWAFWGQZVAVBVCWEWN
      VTWHVNNWOWPVSBWGDEVNWAGWRWDVGSVDWEWNWLWFVOPWOWQVSBCVLVNWAFWDVESRVH $.
  $}

  ${
    lhpocat.o $e |- ._|_ = ( oc ` K ) $.
    lhpocat.a $e |- A = ( Atoms ` K ) $.
    lhpocat.h $e |- H = ( LHyp ` K ) $.
    $( The orthocomplement of a co-atom is an atom.  (Contributed by NM,
       9-Feb-2013.) $)
    lhpocat $p |- ( ( K e. HL /\ W e. H ) -> ( ._|_ ` W ) e. A ) $=
      ( chlt wcel wa cfv simpr cbs wb eqid lhpbase lhpoc sylan2 mpbid ) CIJZEBJ
      ZKUBEDLAJZUAUBMUBUAECNLZJUBUCOUDBCEUDPZHQAUDBCDEUEFGHRST $.
  $}

  ${
    lhpocnel.l $e |- .<_ = ( le ` K ) $.
    lhpocnel.o $e |- ._|_ = ( oc ` K ) $.
    lhpocnel.a $e |- A = ( Atoms ` K ) $.
    lhpocnel.h $e |- H = ( LHyp ` K ) $.
    $( The orthocomplement of a co-atom is an atom not under it.  Provides a
       convenient construction when we need the existence of any object with
       this property.  (Contributed by NM, 25-May-2012.) $)
    lhpocnel $p |- ( ( K e. HL /\ W e. H )
           -> ( ( ._|_ ` W ) e. A /\ -. ( ._|_ ` W ) .<_ W ) ) $=
      ( chlt wcel wa cfv wbr wn lhpocat lhpocnle jca ) CKLFBLMFENZALTFDOPABCEFH
      IJQBCDEFGHJRS $.
  $}

  ${
    lhpocnel2.l $e |- .<_ = ( le ` K ) $.
    lhpocnel2.a $e |- A = ( Atoms ` K ) $.
    lhpocnel2.h $e |- H = ( LHyp ` K ) $.
    lhpocnel2.p $e |- P = ( ( oc ` K ) ` W ) $.
    $( The orthocomplement of a co-atom is an atom not under it.  Provides a
       convenient construction when we need the existence of any object with
       this property.  (Contributed by NM, 20-Feb-2014.) $)
    lhpocnel2 $p |- ( ( K e. HL /\ W e. H )
           -> ( P e. A /\ -. P .<_ W ) ) $=
      ( chlt wcel wa coc cfv wbr wn eqid lhpocnel eleq1i breq1i notbii anbi12i
      sylibr ) DKLFCLMFDNOZOZALZUFFEPZQZMBALZBFEPZQZMACDEUEFGUERHISUJUGULUIBUFA
      JTUKUHBUFFEJUAUBUCUD $.
  $}

  ${
    lhpjat.l $e |- .<_ = ( le ` K ) $.
    lhpjat.j $e |- .\/ = ( join ` K ) $.
    lhpjat.u $e |- .1. = ( 1. ` K ) $.
    lhpjat.a $e |- A = ( Atoms ` K ) $.
    lhpjat.h $e |- H = ( LHyp ` K ) $.
    $( The join of a co-atom (hyperplane) and an atom not under it is the
       lattice unit.  (Contributed by NM, 18-May-2012.) $)
    lhpjat1 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W ) )
      -> ( W .\/ P ) = .1. ) $=
      ( chlt wcel wa wbr wn cfv eqid cbs ccvr co simpll lhpbase ad2antlr simprl
      wceq lhp1cvr adantr simprr 1cvrjat syl32anc ) FNOZHDOZPZBAOZBHGQRZPZPUNHF
      UASZOZUQHCFUBSZQZURHBEUCCUHUNUOUSUDUOVAUNUSUTDFHUTTZMUEUFUPUQURUGUPVCUSNV
      BCDFHKVBTZMUIUJUPUQURUKAUTVBBCEFGHVDIJKVELULUM $.

    $( The join of a co-atom (hyperplane) and an atom not under it is the
       lattice unit.  (Contributed by NM, 4-Jun-2012.) $)
    lhpjat2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W ) )
      -> ( P .\/ W ) = .1. ) $=
      ( chlt wcel wa wbr wn co clat cbs cfv wceq hllat ad2antrr atbase ad2antrl
      eqid lhpbase ad2antlr latjcom syl3anc lhpjat1 eqtrd ) FNOZHDOZPZBAOZBHGQR
      ZPZPZBHESZHBESZCVAFTOZBFUAUBZOZHVEOZVBVCUCUOVDUPUTFUDUEURVFUQUSAVEBFVEUHZ
      LUFUGUPVGUOUTVEDFHVHMUIUJVEEFBHVHJUKULABCDEFGHIJKLMUMUN $.
  $}

  ${
    $d p B $.  $d p H $.  $d p .\/ $.  $d p K $.  $d p .<_ $.  $d p .1. $.
    $d p W $.  $d p X $.
    lhpj1.b $e |- B = ( Base ` K ) $.
    lhpj1.l $e |- .<_ = ( le ` K ) $.
    lhpj1.j $e |- .\/ = ( join ` K ) $.
    lhpj1.u $e |- .1. = ( 1. ` K ) $.
    lhpj1.h $e |- H = ( LHyp ` K ) $.
    $( The join of a co-atom (hyperplane) and an element not under it is the
       lattice unit.  (Contributed by NM, 7-Dec-2012.) $)
    lhpj1 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W ) )
          -> ( W .\/ X ) = .1. ) $=
      ( vp wcel wa wbr wn co wceq chlt cv catm cfv wrex wb simpll simpr lhpbase
      ad2antlr hlrelat2 syl3anc w3a simp1l simp2 simp3r lhpjat1 syl12anc simp3l
      eqid clat wi simp1ll hllat syl atbase 3ad2ant2 3ad2ant1 latjlej2 syl13anc
      simp1r mpd eqbrtrrd cops hlop latjcl op1le syl2anc rexlimdv3a sylbid impr
      mpbid ) EUAOZGCOZPZHAOZHGFQRZGHDSZBTZWEWFPZWGNUBZHFQZWKGFQRZPZNEUCUDZUEZW
      IWJWCWFGAOZWGWPUFWCWDWFUGWEWFUHWDWQWCWFACEGIMUIUJZWOAEFHGNIJWOUTZUKULWJWN
      WINWOWJWKWOOZWNUMZBWHFQZWIXAGWKDSZBWHFXAWEWTWMXCBTWEWFWTWNUNWJWTWNUOWJWTW
      LWMUPWOWKBCDEFGJKLWSMUQURXAWLXCWHFQZWJWTWLWMUSXAEVAOZWKAOZWFWQWLXDVBXAWCX
      EWCWDWFWTWNVCZEVDVEZWTWJXFWNWOAWKEIWSVFVGWEWFWTWNVKZWJWTWQWNWRVHZADEFWKHG
      IJKVIVJVLVMXAEVNOZWHAOZXBWIUFXAWCXKXGEVOVEXAXEWQWFXLXHXJXIADEGHIKVPULABEF
      WHIJLVQVRWBVSVTWA $.
  $}

  ${
    lhpmcvr.b $e |- B = ( Base ` K ) $.
    lhpmcvr.l $e |- .<_ = ( le ` K ) $.
    lhpmcvr.m $e |- ./\ = ( meet ` K ) $.
    lhpmcvr.c $e |- C = ( <o ` K ) $.
    lhpmcvr.h $e |- H = ( LHyp ` K ) $.
    $( The meet of a lattice hyperplane with an element not under it is covered
       by the element.  (Contributed by NM, 7-Dec-2012.) $)
    lhpmcvr $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W ) )
          -> ( X ./\ W ) C X ) $=
      ( chlt wcel wa wbr co syl3anc cfv clat wceq hllat ad2antrr simprl lhpbase
      wn ad2antlr latmcom cjn cp1 eqid lhp1cvr adantr lhpj1 breqtrrd wb cvrexch
      simpll mpbird eqbrtrd ) DNOZGCOZPZHAOZHGEQUGZPZPZHGFRZGHFRZHBVHDUAOZVEGAO
      ZVIVJUBVBVKVCVGDUCUDVDVEVFUEZVCVLVBVGACDGIMUFUHZADFHGIKUISVHVJHBQZGGHDUJT
      ZRZBQZVHGDUKTZVQBVDGVSBQVGNBVSCDGVSULZLMUMUNAVSCVPDEGHIJVPULZVTMUOUPVHVBV
      LVEVOVRUQVBVCVGUSVNVMABVPDFGHIWAKLURSUTVA $.
  $}

  ${
    $d p A $.  $d p B $.  $d p C $.  $d p K $.  $d p .<_ $.  $d p ./\ $.
    $d p X $.  $d p W $.
    lhpmcvr2.b $e |- B = ( Base ` K ) $.
    lhpmcvr2.l $e |- .<_ = ( le ` K ) $.
    lhpmcvr2.j $e |- .\/ = ( join ` K ) $.
    lhpmcvr2.m $e |- ./\ = ( meet ` K ) $.
    lhpmcvr2.a $e |- A = ( Atoms ` K ) $.
    lhpmcvr2.h $e |- H = ( LHyp ` K ) $.
    $( Alternate way to express that the meet of a lattice hyperplane with an
       element not under it is covered by the element.  (Contributed by NM,
       9-Apr-2013.) $)
    lhpmcvr2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W ) )
          -> E. p e. A ( -. p .<_ W /\ ( p .\/ ( X ./\ W ) ) = X ) ) $=
      ( wcel wa wbr wn chlt co ccvr cfv cv wceq wrex eqid lhpmcvr simpll simprl
      wb lhpbase ad2antlr cvrval5 syl3anc mpbid ) EUAQZHCQZRZIBQZIHFSTZRZRZIHGU
      BZIEUCUDZSZJUEZHFSTVHVEDUBIUFRJAUGZBVFCEFGHIKLNVFUHZPUIVDURVAHBQZVGVIULUR
      USVCUJUTVAVBUKUSVKURVCBCEHKPUMUNABVFDEFGIHJKLMNVJOUOUPUQ $.

    $( Specialization of ~ lhpmcvr2 .  TODO:  Use this to simplify many uses of
       ` ( P .\/ ( X ./\ W ) ) = X ` to become ` P .<_ X ` .  (Contributed by
       NM, 6-Apr-2014.) $)
    lhpmcvr3 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
         /\ ( P e. A /\ -. P .<_ W ) )
      -> ( P .<_ X <-> ( P .\/ ( X ./\ W ) ) = X ) ) $=
      ( wcel wa co syl chlt wbr wn w3a wceq cp1 simpl1l simpl3l simpl2l simpl1r
      cfv lhpbase simpr atmod3i1 syl131anc simpl1 simpl3 lhpjat2 syl2anc oveq2d
      eqid hlol olm11 3eqtrd clat atbase latmcl syl3anc latlej1 breqtrd impbida
      col hllat ) FUAQZIDQZRZJBQZJIGUBUCZRZCAQZCIGUBUCZRZUDZCJGUBZCJIHSZESZJUEZ
      WCWDRZWFJCIESZHSZJFUFUKZHSZJWHVNVTVQIBQZWDWFWJUEVNVOVSWBWDUGZVTWAVPVSWDUH
      VQVRVPWBWDUIZWHVOWMVNVOVSWBWDUJBDFIKPULZTWCWDUMABCEFGHJIKLMNOUNUOWHWIWKJH
      WHVPWBWIWKUEVPVSWBWDUPVPVSWBWDUQACWKDEFGILMWKVAZOPURUSUTWHFVLQZVQWLJUEWHV
      NWRWNFVBTWOBWKFHJKNWQVCUSVDWCWGRZCWFJGWSFVEQZCBQZWEBQZCWFGUBWSVNWTVNVOVSW
      BWGUGFVMTZWSVTXAVTWAVPVSWGUHABCFKOVFTWSWTVQWMXBXCVQVRVPWBWGUIWSVOWMVNVOVS
      WBWGUJWPTBFHJIKNVGVHBEFGCWEKLMVIVHWCWGUMVJVK $.

    $( Specialization of ~ lhpmcvr2 .  (Contributed by NM, 6-Apr-2014.)
       (New usage is discouraged.) $)
    lhpmcvr4N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( X e. B /\ -. X .<_ W )
         /\ ( P e. A /\ -. P .<_ W ) )
         /\ ( Y e. B /\ ( X ./\ Y ) .<_ W /\ P .<_ X ) ) -> -. P .<_ Y ) $=
      ( wcel wa wbr chlt wn co w3a simp2rr simp33 clat simp1l hllat syl simp2rl
      wb atbase simp2ll simp31 latlem12 syl13anc biimpd mpand simp32 wi syl3anc
      latmcl simp1r lhpbase lattr mpan2d syld mtod ) FUARZIDRZSZJBRZJIGTUBZSZCA
      RZCIGTZUBZSZSZKBRZJKHUCZIGTZCJGTZUDZUDZCKGTZVQVPVRVOVLWEUEWFWGCWBGTZVQWFW
      DWGWHVLVTWAWCWDUFWFWDWGSZWHWFFUGRZCBRZVMWAWIWHULWFVJWJVJVKVTWEUHFUIUJZWFV
      PWKVPVRVOVLWEUKABCFLPUMUJZVMVNVSVLWEUNZVLVTWAWCWDUOZBFGHCJKLMOUPUQURUSWFW
      HWCVQVLVTWAWCWDUTWFWJWKWBBRZIBRZWHWCSVQVAWLWMWFWJVMWAWPWLWNWOBFHJKLOVCVBW
      FVKWQVJVKVTWEVDBDFILQVEUJBFGCWBILMVFUQVGVHVI $.

    $d p H $.  $d p Y $.
    $( Specialization of ~ lhpmcvr2 .  (Contributed by NM, 6-Apr-2014.)
       (New usage is discouraged.) $)
    lhpmcvr5N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
         /\ ( Y e. B /\ ( X ./\ Y ) .<_ W ) )
          -> E. p e. A ( -. p .<_ W /\ -. p .<_ Y /\
               ( p .\/ ( X ./\ W ) ) = X ) ) $=
      ( wcel wa wbr chlt wn w3a wceq wrex lhpmcvr2 3adant3 simp3l simp11 simp12
      co cv simp2 jca simp13l simp13r simp11l hllat syl atbase 3ad2ant2 simp12l
      simp11r lhpbase latmcl syl3anc latlej1 simp3r breqtrd lhpmcvr4N syl123anc
      clat 3jca 3expia reximdva mpd ) EUARZHCRZSZIBRZIHFTUBZSZJBRZIJGUKHFTZSZUC
      ZKULZHFTUBZWGIHGUKZDUKZIUDZSZKAUEZWHWGJFTUBZWKUCZKAUEVSWBWMWEABCDEFGHIKLM
      NOPQUFUGWFWLWOKAWFWGARZWLWOWFWPWLUCZWHWNWKWFWPWHWKUHZWQVSWBWPWHSWCWDWGIFT
      WNVSWBWEWPWLUIVSWBWEWPWLUJWQWPWHWFWPWLUMWRUNWCWDVSWBWPWLUOWCWDVSWBWPWLUPW
      QWGWJIFWQEVLRZWGBRZWIBRZWGWJFTWQVQWSVQVRWBWEWPWLUQEURUSZWPWFWTWLABWGELPUT
      VAWQWSVTHBRZXAXBVTWAVSWEWPWLVBWQVRXCVQVRWBWEWPWLVCBCEHLQVDUSBEGIHLOVEVFBD
      EFWGWILMNVGVFWFWPWHWKVHZVIABWGCDEFGHIJLMNOPQVJVKXDVMVNVOVP $.

    $( Specialization of ~ lhpmcvr2 .  (Contributed by NM, 6-Apr-2014.)
       (New usage is discouraged.) $)
    lhpmcvr6N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
         /\ ( Y e. B /\ ( X ./\ Y ) .<_ W ) )
          -> E. p e. A ( -. p .<_ W /\ -. p .<_ Y /\
               p .<_ X ) ) $=
      ( wcel wbr w3a chlt wa wn co cv wceq wrex lhpmcvr5N simp31 simp32 simp11l
      clat hllat atbase 3ad2ant2 simp12l simp11r lhpbase latmcl syl3anc latlej1
      syl simp33 breqtrd 3jca 3expia reximdva mpd ) EUARZHCRZUBZIBRZIHFSUCZUBZJ
      BRIJGUDHFSUBZTZKUEZHFSUCZVQJFSUCZVQIHGUDZDUDZIUFZTZKAUGVRVSVQIFSZTZKAUGAB
      CDEFGHIJKLMNOPQUHVPWCWEKAVPVQARZWCWEVPWFWCTZVRVSWDVPWFVRVSWBUIVPWFVRVSWBU
      JWGVQWAIFWGEULRZVQBRZVTBRZVQWAFSWGVIWHVIVJVNVOWFWCUKEUMVBZWFVPWIWCABVQELP
      UNUOWGWHVLHBRZWJWKVLVMVKVOWFWCUPWGVJWLVIVJVNVOWFWCUQBCEHLQURVBBEGIHLOUSUT
      BDEFVQVTLMNVAUTVPWFVRVSWBVCVDVEVFVGVH $.
  $}

  ${
    lhpm0at.b $e |- B = ( Base ` K ) $.
    lhpm0at.m $e |- ./\ = ( meet ` K ) $.
    lhpm0at.o $e |- .0. = ( 0. ` K ) $.
    lhpm0at.a $e |- A = ( Atoms ` K ) $.
    lhpm0at.h $e |- H = ( LHyp ` K ) $.
    $( If the meet of a lattice hyperplane with a nonzero element is zero, the
       element is an atom.  (Contributed by NM, 28-Apr-2014.)
       (New usage is discouraged.) $)
    lhpm0atN $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( X e. B /\ X =/= .0. /\ ( X ./\ W ) = .0. ) ) -> X e. A ) $=
      ( chlt wcel wa wceq cfv wbr wb wne co w3a ccvr simpr3 simpl simpr1 simpr2
      cple wn clat hllat ad2antrr lhpbase eqid latleeqm1 syl3anc biimpa simplr3
      ad2antlr eqtr3d ex necon3ad lhpmcvr syl12anc eqbrtrrd simpll isat2 mpbird
      mpd syl2anc ) DNOZFCOZPZGBOZGHUAZGFEUBZHQZUCZPZGAOZHGDUDRZSZVTVQHGWBVNVOV
      PVRUEVTVNVOGFDUIRZSZUJZVQGWBSVNVSUFVNVOVPVRUGZVTVPWFVNVOVPVRUHVTWEGHVTWEG
      HQVTWEPVQGHVTWEVQGQZVTDUKOZVOFBOZWEWHTVLWIVMVSDULUMWGVMWJVLVSBCDFIMUNUTBD
      WDEGFIWDUOZJUPUQURVOVPVRVNWEUSVAVBVCVJBWBCDWDEFGIWKJWBUOZMVDVEVFVTVLVOWAW
      CTVLVMVSVGWGABWBNGDHIKWLLVHVKVI $.
  $}

  ${
    lhpmat.l $e |- .<_ = ( le ` K ) $.
    lhpmat.m $e |- ./\ = ( meet ` K ) $.
    lhpmat.z $e |- .0. = ( 0. ` K ) $.
    lhpmat.a $e |- A = ( Atoms ` K ) $.
    lhpmat.h $e |- H = ( LHyp ` K ) $.
    $( An element covered by the lattice unit, when conjoined with an atom not
       under it, equals the lattice zero.  (Contributed by NM, 6-Jun-2012.) $)
    lhpmat $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W ) )
          -> ( P ./\ W ) = .0. ) $=
      ( chlt wcel wa wbr wn co wceq simprr cal cbs cfv wb hlatl ad2antrr simprl
      eqid lhpbase ad2antlr atnle syl3anc mpbid ) DNOZGCOZPZBAOZBGEQRZPZPZUSBGF
      SHTZUQURUSUAVADUBOZURGDUCUDZOZUSVBUEUOVCUPUTDUFUGUQURUSUHUPVEUOUTVDCDGVDU
      IZMUJUKAVDBDEFGHVFIJKLULUMUN $.

    $( An element covered by the lattice unit, when conjoined with an atom,
       equals zero iff the atom is not under it.  (Contributed by NM,
       15-Jun-2013.) $)
    lhpmatb $p |- ( ( ( K e. HL /\ W e. H ) /\ P e. A )
          -> ( -. P .<_ W <-> ( P ./\ W ) = .0. ) ) $=
      ( wcel wa wceq wne ad3antrrr wb mpbird wbr wn co lhpmat anassrs cal hlatl
      chlt simplr atn0 necomd syl2anc neeq1 adantl clat cbs cfv eqid atbase syl
      hllat lhpbase ad3antlr latleeqm1 syl3anc necon3bbid impbida ) DUHNZGCNZOZ
      BANZOZBGEUAZUBZBGFUCZHPZVJVKVNVPABCDEFGHIJKLMUDUEVLVPOZVNVOBQZVQVRHBQZVQD
      UFNZVKVSVHVTVIVKVPDUGRVJVKVPUIZVTVKOBHABDHKLUJUKULVPVRVSSVLVOHBUMUNTVQVMV
      OBVQDUONZBDUPUQZNZGWCNZVMVOBPSVHWBVIVKVPDVARVQVKWDWAAWCBDWCURZLUSUTVIWEVH
      VKVPWCCDGWFMVBVCWCDEFBGWFIJVDVEVFTVG $.
  $}

  ${
    lhp2at0.l $e |- .<_ = ( le ` K ) $.
    lhp2at0.j $e |- .\/ = ( join ` K ) $.
    lhp2at0.m $e |- ./\ = ( meet ` K ) $.
    lhp2at0.z $e |- .0. = ( 0. ` K ) $.
    lhp2at0.a $e |- A = ( Atoms ` K ) $.
    lhp2at0.h $e |- H = ( LHyp ` K ) $.
    $( Join and meet with different atoms under co-atom ` W ` .  (Contributed
       by NM, 15-Jun-2013.) $)
    lhp2at0 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ U =/= V ) /\ ( U e. A /\ U .<_ W ) /\ ( V e. A /\ V .<_ W ) )
          -> ( ( P .\/ U ) ./\ V ) = .0. ) $=
      ( wcel co wceq chlt wa wbr wn wne w3a col cbs cfv simp11l hlol syl simp2l
      simp12l hlatjcl syl3anc simp11r lhpbase simp3l atbase latmassOLD syl13anc
      eqid lhpmat 3adant3 3ad2ant1 oveq1d simp2r atmod4i2 olj02 syl2anc 3eqtr3d
      syl131anc eqtr3d simp3r clat wb hllat latleeqm2 mpbid oveq2d simp13 hlatl
      cal atnem0 ) FUARZJDRZUBZBARZBJGUCUDZUBZCIUEZUFZCARZCJGUCZUBZIARZIJGUCZUB
      ZUFZBCESZJIHSZHSZCIHSZXAIHSKWTXAJHSZIHSZXCXDWTFUGRZXAFUHUIZRZJXHRZIXHRZXF
      XCTWTWFXGWFWGWKWLWPWSUJZFUKULZWTWFWIWNXIXLWIWJWHWLWPWSUNZWMWNWOWSUMZAXHEF
      BCXHVCZMPUOUPWTWGXJWFWGWKWLWPWSUQXHDFJXPQURULZWTWQXKWMWPWQWRUSZAXHIFXPPUT
      ULZXHFHXAJIXPNVAVBWTXECIHWTBJHSZCESZKCESZXECWTXTKCEWMWPXTKTZWSWHWKYCWLABD
      FGHJKLNOPQVDVEVFVGWTWFWICXHRZXJWOYAXETXLXNWTWNYDXOAXHCFXPPUTULZXQWMWNWOWS
      VHAXHBEFGHCJXPLMNPVIVMWTXGYDYBCTXMYEXHEFCKXPMOVJVKVLVGVNWTXBIXAHWTWRXBITZ
      WMWPWQWRVOWTFVPRZXKXJWRYFVQWTWFYGXLFVRULXSXQXHFGHIJXPLNVSUPVTWAWTWLXDKTZW
      HWKWLWPWSWBWTFWDRZWNWQWLYHVQWTWFYIXLFWCULXOXRACIFHKNOPWEUPVTVL $.
  $}

  ${
    lhp2atnle.l $e |- .<_ = ( le ` K ) $.
    lhp2atnle.j $e |- .\/ = ( join ` K ) $.
    lhp2atnle.a $e |- A = ( Atoms ` K ) $.
    lhp2atnle.h $e |- H = ( LHyp ` K ) $.
    $( Inequality for 2 different atoms under co-atom ` W ` .  (Contributed by
       NM, 17-Jun-2013.) $)
    lhp2atnle $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ U =/= V ) /\ ( U e. A /\ U .<_ W ) /\ ( V e. A /\ V .<_ W ) )
          -> -. V .<_ ( P .\/ U ) ) $=
      ( wcel wa wbr cfv syl eqid wceq chlt wn wne w3a cp0 co cal simp11l simp3l
      hlatl atn0 syl2anc cmee clat cbs wb atbase simp12l simp2l hlatjcl syl3anc
      hllat latleeqm2 lhp2at0 eqeq1 syl5ibcom sylbid necon3ad mpd ) FUANZIDNZOZ
      BANZBIGPUBZOZCHUCZUDZCANZCIGPZOZHANZHIGPZOZUDZHFUEQZUCZHBCEUFZGPZUBWDFUGN
      ZWAWFWDVJWIVJVKVOVPVTWCUHZFUJRVQVTWAWBUIZAHFWEWESZLUKULWDWHHWEWDWHWGHFUMQ
      ZUFZHTZHWETZWDFUNNZHFUOQZNZWGWRNZWHWOUPWDVJWQWJFVBRWDWAWSWKAWRHFWRSZLUQRW
      DVJVMVRWTWJVMVNVLVPVTWCURVQVRVSWCUSAWREFBCXAKLUTVAWRFGWMHWGXAJWMSZVCVAWDW
      NWETWOWPABCDEFGWMHIWEJKXBWLLMVDWNHWEVEVFVGVHVI $.

    $( Inequality for joins with 2 different atoms under co-atom ` W ` .
       (Contributed by NM, 22-Jul-2013.) $)
    lhp2atne $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
                /\ Q e. A )
        /\ ( ( U e. A /\ U .<_ W ) /\ ( V e. A /\ V .<_ W ) )
        /\ U =/= V ) -> ( P .\/ U ) =/= ( Q .\/ V ) ) $=
      ( wcel wa wbr wn w3a wne chlt simp11 simp12 simp3 simp2l simp2r lhp2atnle
      co syl311anc wceq simp11l simp13 simp2rl hlatlej2 syl3anc adantr breqtrrd
      simpr ex necon3bd mpd ) GUAOZJEOZPZBAOBJHQRPZCAOZSZDAODJHQPZIAOZIJHQZPZPZ
      DITZSZIBDFUHZHQZRZVOCIFUHZTVNVDVEVMVHVKVQVDVEVFVLVMUBVDVEVFVLVMUCVGVLVMUD
      VGVHVKVMUEVGVHVKVMUFABDEFGHIJKLMNUGUIVNVPVOVRVNVOVRUJZVPVNVSPIVRVOHVNIVRH
      QZVSVNVBVFVIVTVBVCVEVFVLVMUKVDVEVFVLVMULVIVJVHVGVMUMACIFGHKLMUNUOUPVNVSUR
      UQUSUTVA $.
  $}

  ${
    lhp2at0nle.l $e |- .<_ = ( le ` K ) $.
    lhp2at0nle.j $e |- .\/ = ( join ` K ) $.
    lhp2at0nle.z $e |- .0. = ( 0. ` K ) $.
    lhp2at0nle.a $e |- A = ( Atoms ` K ) $.
    lhp2at0nle.h $e |- H = ( LHyp ` K ) $.
    $( Inequality for 2 different atoms (or an atom and zero) under co-atom
       ` W ` .  (Contributed by NM, 28-Jul-2013.) $)
    lhp2at0nle $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ U =/= V ) /\ ( ( U e. A \/ U = .0. ) /\ U .<_ W )
        /\ ( V e. A /\ V .<_ W ) )
          -> -. V .<_ ( P .\/ U ) ) $=
      ( wcel wa wbr wn wceq wne w3a wo co simpl1 simpr simpl2r simpl3 lhp2atnle
      chlt syl121anc simp3r simp12r nbrne2 syl2anc neneqd cal simp11l hlatl syl
      wb simp3l simp12l atcmp syl3anc mtbird adantr oveq2 col cbs cfv hlol eqid
      atbase olj01 sylan9eqr breq2d simp2l mpjaodan ) FUJPZIDPZQZBAPZBIGRSZQZCH
      UAZUBZCAPZCJTZUCZCIGRZQZHAPZHIGRZQZUBZWHHBCEUDZGRZSZWIWPWHQWGWHWKWOWSWGWL
      WOWHUEWPWHUFWJWKWGWOWHUGWGWLWOWHUHABCDEFGHIKLNOUIUKWPWIQZWRHBGRZWPXASWIWP
      XAHBTZWPHBWPWNWDHBUAWGWLWMWNULWCWDWBWFWLWOUMHBIGUNUOUPWPFUQPZWMWCXAXBVAWP
      VTXCVTWAWEWFWLWOURZFUSUTWGWLWMWNVBWCWDWBWFWLWOVCZAHBFGKNVDVEVFVGWTWQBHGWI
      WPWQBJEUDZBCJBEVHWPFVIPZBFVJVKZPZXFBTWPVTXGXDFVLUTWPWCXIXEAXHBFXHVMZNVNUT
      XHEFBJXJLMVOUOVPVQVFWGWJWKWOVRVS $.

    $( Inequality for joins with 2 different atoms (or an atom and zero) under
       co-atom ` W ` .  (Contributed by NM, 28-Jul-2013.) $)
    lhp2at0ne $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
                /\ Q e. A )
        /\ ( ( ( U e. A \/ U = .0. ) /\ U .<_ W ) /\ ( V e. A /\ V .<_ W ) )
        /\ U =/= V ) -> ( P .\/ U ) =/= ( Q .\/ V ) ) $=
      ( wcel wa wbr wn chlt w3a wo wne co simp11 simp12 simp3 simp2l lhp2at0nle
      wceq simp2r simp11l simp13 simp2rl hlatlej2 syl3anc adantr simpr breqtrrd
      syl311anc ex necon3bd mpd ) GUAQZJEQZRZBAQBJHSTRZCAQZUBZDAQDKUKUCDJHSRZIA
      QZIJHSZRZRZDIUDZUBZIBDFUEZHSZTZVRCIFUEZUDVQVGVHVPVKVNVTVGVHVIVOVPUFVGVHVI
      VOVPUGVJVOVPUHVJVKVNVPUIVJVKVNVPULABDEFGHIJKLMNOPUJVAVQVSVRWAVQVRWAUKZVSV
      QWBRIWAVRHVQIWAHSZWBVQVEVIVLWCVEVFVHVIVOVPUMVGVHVIVOVPUNVLVMVKVJVPUOACIFG
      HLMOUPUQURVQWBUSUTVBVCVD $.
  $}

  ${
    lhpelim.b $e |- B = ( Base ` K ) $.
    lhpelim.l $e |- .<_ = ( le ` K ) $.
    lhpelim.j $e |- .\/ = ( join ` K ) $.
    lhpelim.m $e |- ./\ = ( meet ` K ) $.
    lhpelim.a $e |- A = ( Atoms ` K ) $.
    lhpelim.h $e |- H = ( LHyp ` K ) $.
    $( Eliminate an atom not under a lattice hyperplane.  TODO:  Look at proofs
       using ~ lhpmat to see if this can be used to shorten them.  (Contributed
       by NM, 27-Apr-2013.) $)
    lhpelim $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
     /\ X e. B ) -> ( ( P .\/ ( X ./\ W ) ) ./\ W ) = ( X ./\ W ) ) $=
      ( wcel co wceq syl chlt wbr w3a cp0 cfv eqid lhpmat 3adant3 oveq1d simp1l
      wa simp2l clat hllat simp3 simp1r lhpbase latmcl syl3anc latmle2 atmod4i2
      wn syl131anc col hlol olj02 syl2anc 3eqtr3d ) FUAQZIDQZUKZCAQZCIGUBVBZUKZ
      JBQZUCZCIHRZJIHRZERZFUDUEZVRERZCVRERIHRZVRVPVQVTVREVKVNVQVTSVOACDFGHIVTLN
      VTUFZOPUGUHUIVPVIVLVRBQZIBQZVRIGUBZVSWBSVIVJVNVOUJZVKVLVMVOULVPFUMQZVOWEW
      DVPVIWHWGFUNTZVKVNVOUOZVPVJWEVIVJVNVOUPBDFIKPUQTZBFHJIKNURUSZWKVPWHVOWEWF
      WIWJWKBFGHJIKLNUTUSABCEFGHVRIKLMNOVAVCVPFVDQZWDWAVRSVPVIWMWGFVETWLBEFVRVT
      KMWCVFVGVH $.
  $}

  ${
    lhpmod.b $e |- B = ( Base ` K ) $.
    lhpmod.l $e |- .<_ = ( le ` K ) $.
    lhpmod.j $e |- .\/ = ( join ` K ) $.
    lhpmod.m $e |- ./\ = ( meet ` K ) $.
    lhpmod.h $e |- H = ( LHyp ` K ) $.
    $( Modular law for hyperplanes analogous to ~ atmod2i2 for atoms.
       (Contributed by NM, 9-Feb-2013.) $)
    lhpmod2i2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B )
        /\ Y .<_ X ) -> ( ( X ./\ W ) .\/ Y ) = ( X ./\ ( W .\/ Y ) ) ) $=
      ( wcel co wceq cfv syl syl3anc chlt wa wbr w3a catm simp1l simp1r lhpocat
      coc eqid syl2anc cops simp2l opoccl simp2r simp3 oplecon3b mpbid atmod1i2
      hlop syl131anc clat hllat lhpbase latmcl latjcl opcon3b col oldmm1 oldmj1
      wb hlol oveq2d eqtrd oveq1d eqeq12d bitrd mpbird ) DUAOZGBOZUBZHAOZIAOZUB
      ZIHEUCZUDZHGFPZICPZHGICPZFPZQZHDUIRZRZGWLRZIWLRZFPZCPZWMWNCPZWOFPZQZWFVSW
      NDUERZOZWMAOZWOAOZWMWOEUCZWTVSVTWDWEUFZWFVSVTXBXFVSVTWDWEUGZXABDWLGWLUJZX
      AUJZNUHUKWFDULOZWBXCWFVSXJXFDUTSZWAWBWCWEUMZADWLHJXHUNUKWFXJWCXDXKWAWBWCW
      EUOZADWLIJXHUNUKWFWEXEWAWDWEUPWFXJWCWBWEXEVKXKXMXLADEWLIHJKXHUQTURXAAWNCD
      EFWMWOJKLMXIUSVAWFWKWJWLRZWHWLRZQZWTWFXJWHAOZWJAOZWKXPVKXKWFDVBOZWGAOZWCX
      QWFVSXSXFDVCSZWFXSWBGAOZXTYAXLWFVTYBXGABDGJNVDSZADFHGJMVETZXMACDWGIJLVFTW
      FXSWBWIAOZXRYAXLWFXSYBWCYEYAYCXMACDGIJLVFTZADFHWIJMVETADWLWHWJJXHVGTWFXNW
      QXOWSWFXNWMWIWLRZCPZWQWFDVHOZWBYEXNYHQWFVSYIXFDVLSZXLYFACDFWLHWIJLMXHVITW
      FYGWPWMCWFYIYBWCYGWPQYJYCXMACDFWLGIJLMXHVJTVMVNWFXOWGWLRZWOFPZWSWFYIXTWCX
      OYLQYJYDXMACDFWLWGIJLMXHVJTWFYKWRWOFWFYIWBYBYKWRQYJXLYCACDFWLHGJLMXHVITVO
      VNVPVQVR $.

    $( Modular law for hyperplanes analogous to complement of ~ atmod2i1 for
       atoms.  (Contributed by NM, 1-Jun-2013.) $)
    lhpmod6i1 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B )
        /\ X .<_ W ) -> ( X .\/ ( Y ./\ W ) ) = ( ( X .\/ Y ) ./\ W ) ) $=
      ( wcel co wceq cfv syl syl3anc chlt wa wbr w3a catm simp1l simp1r lhpocat
      eqid syl2anc cops hlop simp2l opoccl simp2r simp3 lhpbase oplecon3b mpbid
      coc atmod2i1 syl131anc clat hllat latmcl latjcl opcon3b col oldmm1 oldmj1
      wb hlol oveq1d eqtrd oveq2d eqeq12d bitrd mpbird ) DUAOZGBOZUBZHAOZIAOZUB
      ZHGEUCZUDZHIGFPZCPZHICPZGFPZQZHDUTRZRZIWLRZFPZGWLRZCPZWMWNWPCPZFPZQZWFVSW
      PDUERZOZWMAOZWNAOZWPWMEUCZWTVSVTWDWEUFZWFVSVTXBXFVSVTWDWEUGZXABDWLGWLUIZX
      AUIZNUHUJWFDUKOZWBXCWFVSXJXFDULSZWAWBWCWEUMZADWLHJXHUNUJWFXJWCXDXKWAWBWCW
      EUOZADWLIJXHUNUJWFWEXEWAWDWEUPWFXJWBGAOZWEXEVKXKXLWFVTXNXGABDGJNUQSZADEWL
      HGJKXHURTUSXAAWPCDEFWMWNJKLMXIVAVBWFWKWJWLRZWHWLRZQZWTWFXJWHAOZWJAOZWKXRV
      KXKWFDVCOZWBWGAOZXSWFVSYAXFDVDSZXLWFYAWCXNYBYCXMXOADFIGJMVETZACDHWGJLVFTW
      FYAWIAOZXNXTYCWFYAWBWCYEYCXLXMACDHIJLVFTZXOADFWIGJMVETADWLWHWJJXHVGTWFXPW
      QXQWSWFXPWIWLRZWPCPZWQWFDVHOZYEXNXPYHQWFVSYIXFDVLSZYFXOACDFWLWIGJLMXHVITW
      FYGWOWPCWFYIWBWCYGWOQYJXLXMACDFWLHIJLMXHVJTVMVNWFXQWMWGWLRZFPZWSWFYIWBYBX
      QYLQYJXLYDACDFWLHWGJLMXHVJTWFYKWRWMFWFYIWCXNYKWRQYJXMXOACDFWLIGJLMXHVITVO
      VNVPVQVR $.
  $}

  ${
    $d p B $.  $d p w C $.  $d p w H $.  $d p w K $.  $d p w .<_ $.
    $d p w ./\ $.  $d p .< $.  $d p w X $.  $d p w Y $.
    lhprelat3.b $e |- B = ( Base ` K ) $.
    lhprelat3.l $e |- .<_ = ( le ` K ) $.
    lhprelat3.s $e |- .< = ( lt ` K ) $.
    lhprelat3.m $e |- ./\ = ( meet ` K ) $.
    lhprelat3.c $e |- C = ( <o ` K ) $.
    lhprelat3.h $e |- H = ( LHyp ` K ) $.
    $( The Hilbert lattice is relatively atomic with respect to co-atoms
       (lattice hyperplanes).  Dual version of ~ hlrelat3 .  (Contributed by
       NM, 20-Jun-2012.)  (New usage is discouraged.) $)
    lhprelat3N $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B ) /\ X .< Y )
         -> E. w e. H ( X .<_ ( Y ./\ w ) /\ ( Y ./\ w ) C Y ) ) $=
      ( wcel wbr wa cfv vp chlt w3a coc cv co catm wrex simpl1 cops hlop simpl3
      cjn syl eqid opoccl syl2anc simpl2 simpr opltcon3b syl3anc mpbid hlrelat3
      syl31anc simpll1 atbase adantl lhpoc2N adantr clat hllat simpll3 cvrcon3b
      wb latmcl col wceq oldmm3N breq2d bitr2d simpll2 oplecon3b breq1d anbi12d
      hlol biimpa ancomd oveq2 rspcev exp31 rexlimdv mpd ) FUBQZIBQZJBQZUCZIJDR
      ZSZJFUDTZTZWTUAUEZFUMTZUFZCRZXCIWSTZGRZSZUAFUGTZUHZIJAUEZHUFZGRZXKJCRZSZA
      EUHZWRWMWTBQZXEBQZWTXEDRZXIWMWNWOWQUIZWRFUJQZWOXPWRWMXTXSFUKZUNZWMWNWOWQU
      LZBFWSJKWSUOZUPUQWRXTWNXQYBWMWNWOWQURZBFWSIKYDUPUQWRWQXRWPWQUSWRXTWNWOWQX
      RVNYBYEYCBDFWSIJKMYDUTVAVBXHBCDXBFGWTXEUAKLMXBUOZOXHUOZVCVDWRXGXOUAXHWRXA
      XHQZXGXOWRYHSZXGSZXAWSTZEQZIJYKHUFZGRZYMJCRZSZXOYIYLXGYIYHYLWRYHUSYIWMXAB
      QZYHYLVNWMWNWOWQYHVEZYHYQWRXHBXAFKYGVFVGZXHBEFWSXAKYDYGPVHUQVBVIYJYOYNYIX
      GYOYNSYIXDYOXFYNYIYOWTYMWSTZCRZXDYIXTYMBQZWOYOUUAVNYIWMXTYRYAUNZYIFVJQZWO
      YKBQZUUBYIWMUUDYRFVKUNWMWNWOWQYHVLZYIXTYQUUEUUCYSBFWSXAKYDUPUQBFHJYKKNVOV
      AZUUFBCFWSYMJKYDOVMVAYIYTXCWTCYIFVPQZWOYQYTXCVQYIWMUUHYRFWEUNUUFYSBXBFHWS
      JXAKYFNYDVRVAZVSVTYIYNYTXEGRZXFYIXTWNUUBYNUUJVNUUCWMWNWOWQYHWAUUGBFGWSIYM
      KLYDWBVAYIYTXCXEGUUIWCVTWDWFWGXNYPAYKEXJYKVQZXLYNXMYOUUKXKYMIGXJYKJHWHZVS
      UUKXKYMJCUULWCWDWIUQWJWKWL $.
  $}

  ${
    $d r A $.  $d r .\/ $.  $d r K $.  $d r .<_ $.  $d r P $.  $d r Q $.
    $d r W $.
    cdlemb2.l $e |- .<_ = ( le ` K ) $.
    cdlemb2.j $e |- .\/ = ( join ` K ) $.
    cdlemb2.a $e |- A = ( Atoms ` K ) $.
    cdlemb2.h $e |- H = ( LHyp ` K ) $.
    $( Todo: derive directly instead of via ~ cdlemb . $)
    $( Given two atoms not under the fiducial (reference) co-atom ` W ` , there
       is a third.  Lemma B in [Crawley] p. 112.  (Contributed by NM,
       30-May-2012.) $)
    cdlemb2 $p |- ( ( ( K e. HL /\ W e. H ) /\
          ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ P =/= Q )
      -> E. r e. A ( -. r .<_ W /\ -. r .<_ ( P .\/ Q ) ) ) $=
      ( chlt wcel wa wbr wn cfv eqid wne w3a cbs ccvr cv co wrex simp1l simp2ll
      cp1 simp2rl simp1r lhpbase syl lhp1cvr 3ad2ant1 simp2lr simp2rr syl323anc
      simp3 cdlemb ) FNOZHDOZPZBAOZBHGQRZPZCAOZCHGQRZPZPZBCUAZUBZVBVEVHHFUCSZOZ
      VLHFUJSZFUDSZQZVFVIIUEZHGQRVSBCEUFGQRPIAUGVBVCVKVLUHVEVFVJVDVLUIVHVIVGVDV
      LUKVMVCVOVBVCVKVLULVNDFHVNTZMUMUNVDVKVLUTVDVKVRVLNVQVPDFHVPTZVQTZMUOUPVEV
      FVJVDVLUQVHVIVGVDVLURAVNVQBCVPEFGHIVTJKWAWBLVAUS $.
  $}

  ${
    lhple.b $e |- B = ( Base ` K ) $.
    lhple.l $e |- .<_ = ( le ` K ) $.
    lhple.j $e |- .\/ = ( join ` K ) $.
    lhple.m $e |- ./\ = ( meet ` K ) $.
    lhple.a $e |- A = ( Atoms ` K ) $.
    lhple.h $e |- H = ( LHyp ` K ) $.
    $( Property of a lattice element under a co-atom.  (Contributed by NM,
       28-Feb-2014.) $)
    lhple $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( X e. B /\ X .<_ W ) ) -> ( ( P .\/ X ) ./\ W ) = X ) $=
      ( wcel wa co wceq chlt wbr w3a clat simp1l hllat syl simp2l atbase simp3l
      wn latjcom syl3anc oveq1d simp1 simp3r lhpmod6i1 syl121anc cp0 cfv lhpmat
      eqid 3adant3 oveq2d col hlol olj01 syl2anc eqtrd 3eqtr2d ) FUAQZIDQZRZCAQ
      ZCIGUBUKZRZJBQZJIGUBZRZUCZCJESZIHSJCESZIHSZJCIHSZESZJVTWAWBIHVTFUDQZCBQZV
      QWAWBTVTVKWFVKVLVPVSUEZFUFUGVTVNWGVMVNVOVSUHABCFKOUIUGZVMVPVQVRUJZBEFCJKM
      ULUMUNVTVMVQWGVRWEWCTVMVPVSUOWJWIVMVPVQVRUPBDEFGHIJCKLMNPUQURVTWEJFUSUTZE
      SZJVTWDWKJEVMVPWDWKTVSACDFGHIWKLNWKVBZOPVAVCVDVTFVEQZVQWLJTVTVKWNWHFVFUGW
      JBEFJWKKMWMVGVHVIVJ $.
  $}

  ${
    lhpat.l $e |- .<_ = ( le ` K ) $.
    lhpat.j $e |- .\/ = ( join ` K ) $.
    lhpat.m $e |- ./\ = ( meet ` K ) $.
    lhpat.a $e |- A = ( Atoms ` K ) $.
    lhpat.h $e |- H = ( LHyp ` K ) $.
    $( Create an atom under a co-atom.  Part of proof of Lemma B in [Crawley]
       p. 112.  (Contributed by NM, 23-May-2012.) $)
    lhpat $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ P =/= Q ) ) -> ( ( P .\/ Q ) ./\ W ) e. A ) $=
      ( chlt wcel wa wbr cfv eqid wn wne w3a cbs co simp1l simp2l simp3l simp1r
      cp1 ccvr lhpbase syl simp3r lhp1cvr 3ad2ant1 simp2r 1cvrat syl133anc ) FO
      PZIDPZQZBAPZBIGRUAZQZCAPZBCUBZQZUCZUTVCVFIFUDSZPZVGIFUJSZFUKSZRZVDBCEUEIH
      UEAPUTVAVEVHUFVBVCVDVHUGVBVEVFVGUHVIVAVKUTVAVEVHUIVJDFIVJTZNULUMVBVEVFVGU
      NVBVEVNVHOVMVLDFIVLTZVMTZNUOUPVBVCVDVHUQAVJVMBCVLEFGHIVOJKLVPVQMURUS $.

    $( Property of an atom under a co-atom.  (Contributed by NM, 24-Nov-2013.)
       (New usage is discouraged.) $)
    lhpat4N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( U e. A /\ U .<_ W ) ) -> ( ( P .\/ U ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn co w3a cbs cfv wceq simp1 simp3l eqid atbase simp3r
      simp2 syl lhple syl112anc ) FOPIDPQZBAPBIGRSQZCAPZCIGRZQZUAZUNUOCFUBUCZPZ
      UQBCETIHTCUDUNUOURUEUNUOURUJUSUPVAUNUOUPUQUFAUTCFUTUGZMUHUKUNUOUPUQUIAUTB
      DEFGHICVBJKLMNULUM $.

    lhpat2.r $e |- R = ( ( P .\/ Q ) ./\ W ) $.
    $( Create an atom under a co-atom.  Part of proof of Lemma B in [Crawley]
       p. 112.  (Contributed by NM, 21-Nov-2012.) $)
    lhpat2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ P =/= Q ) ) -> R e. A ) $=
      ( chlt wcel wa co wbr wn wne w3a lhpat syl5eqel ) GQRJERSBARBJHUAUBSCARBC
      UCSUDDBCFTJITAPABCEFGHIJKLMNOUEUF $.

    $( There is only one atom under both ` P .\/ Q ` and co-atom ` W ` .
       (Contributed by NM, 21-Nov-2012.) $)
    lhpat3 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W ) )
         /\ ( Q e. A /\ S e. A ) /\ ( P =/= Q /\ S .<_ ( P .\/ Q ) ) )
           -> ( -. S .<_ W <-> S =/= R ) ) $=
      ( wcel wa wbr chlt wn wne co w3a wceq simpl3r simpr wb clat cbs cfv hllat
      simp1ll simp2r eqid atbase simp1rl simp2l hlatjcl syl3anc simp1lr lhpbase
      syl latlem12 syl13anc adantr mpbi2and syl6breqr cal hlatl simpl2r simpl1l
      simpl1r simpl2l simpl3l syl112anc atcmp mpbid latmle2 syl5eqbr syl5ibrcom
      lhpat2 ex breq1 impbid necon3bbid ) HUARZKFRZSZBARZBKITUBZSZSZCARZEARZSZB
      CUCZEBCGUDZITZSZUEZEKITZEDXBXCEDUFZXBXCXDXBXCSZEDITZXDXEEWSKJUDZDIXEWTXCE
      XGITZWRWTWNWQXCUGXBXCUHXBWTXCSXHUIZXCXBHUJRZEHUKULZRZWSXKRZKXKRZXIXBWHXJW
      HWIWMWQXAUNZHUMVDZXBWPXLWNWOWPXAUOAXKEHXKUPZOUQVDXBWHWKWOXMXOWKWLWJWQXAUR
      WNWOWPXAUSAXKGHBCXQMOUTVAZXBWIXNWHWIWMWQXAVBXKFHKXQPVCVDZXKHIJEWSKXQLNVEV
      FVGVHQVIXEHVJRZWPDARZXFXDUIXEWHXTXBWHXCXOVGHVKVDWOWPWNXAXCVLXEWJWMWOWRYAW
      JWMWQXAXCVMWJWMWQXAXCVNWOWPWNXAXCVOWRWTWNWQXCVPABCDFGHIJKLMNOPQWCVQAEDHIL
      OVRVAVSWDXBXCXDDKITXBDXGKIQXBXJXMXNXGKITXPXRXSXKHIJWSKXQLNVTVAWAEDKIWEWBW
      FWG $.
  $}

  ${
    4thatlem.ph $e |- ( ph <-> ( ( ( K e. HL /\ W e. H )
                /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
            /\ ( S e. A
                /\ ( R e. A /\ -. R .<_ W /\ ( P .\/ R ) = ( Q .\/ R ) )
                /\ ( T e. A /\ ( U .\/ T ) = ( V .\/ T ) ) )
            /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) ) ) $.
    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemk $p |- ( ph -> K e. HL ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp11l sylbi ) AKUAPZNIPZQCBPCNLRS
      QZDBPDNLRSQZUBFBPEBPENLRSCEJTDEJTUCUBGBPHGJTMGJTUCQUBZCDUDFCDJTLRSQZUBUGO
      UGUHUIUJUKULUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemw $p |- ( ph -> W e. H ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp11r sylbi ) AKUAPZNIPZQCBPCNLRS
      QZDBPDNLRSQZUBFBPEBPENLRSCEJTDEJTUCUBGBPHGJTMGJTUCQUBZCDUDFCDJTLRSQZUBUHO
      UGUHUIUJUKULUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlempw $p |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp12 sylbi ) AKUAPNIPQZCBPCNLRSQZ
      DBPDNLRSQZUBFBPEBPENLRSCEJTDEJTUCUBGBPHGJTMGJTUCQUBZCDUDFCDJTLRSQZUBUHOUG
      UHUIUJUKUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemp $p |- ( ph -> P e. A ) $=
      ( wcel wbr wn 4atexlempw simpld ) ACBPCNLQRABCDEFGHIJKLMNOST $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemq $p |- ( ph -> Q e. A ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp13l sylbi ) AKUAPNIPQZCBPCNLRSQ
      ZDBPZDNLRSZQUBFBPEBPENLRSCEJTDEJTUCUBGBPHGJTMGJTUCQUBZCDUDFCDJTLRSQZUBUIO
      UIUJUGUHUKULUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlems $p |- ( ph -> S e. A ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp21 sylbi ) AKUAPNIPQCBPCNLRSQDB
      PDNLRSQUBZFBPZEBPENLRSCEJTDEJTUCUBZGBPHGJTMGJTUCQZUBCDUDFCDJTLRSQZUBUHOUG
      UHUIUJUKUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemt $p |- ( ph -> T e. A ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp23l sylbi ) AKUAPNIPQCBPCNLRSQD
      BPDNLRSQUBZFBPZEBPENLRSCEJTDEJTUCUBZGBPZHGJTMGJTUCZQUBCDUDFCDJTLRSQZUBUJO
      UJUKUHUIUGULUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemutvt $p |- ( ph -> ( U .\/ T ) = ( V .\/ T ) ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp23r sylbi ) AKUAPNIPQCBPCNLRSQD
      BPDNLRSQUBZFBPZEBPENLRSCEJTDEJTUCUBZGBPZHGJTMGJTUCZQUBCDUDFCDJTLRSQZUBUKO
      UJUKUHUIUGULUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlempnq $p |- ( ph -> P =/= Q ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp3l sylbi ) AKUAPNIPQCBPCNLRSQDB
      PDNLRSQUBZFBPEBPENLRSCEJTDEJTUCUBGBPHGJTMGJTUCQUBZCDUDZFCDJTLRSZQUBUIOUGU
      HUIUJUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemnslpq $p |- ( ph -> -. S .<_ ( P .\/ Q ) ) $=
      ( wcel wa wbr wn co chlt w3a wceq wne simp3r sylbi ) AKUAPNIPQCBPCNLRSQDB
      PDNLRSQUBZFBPEBPENLRSCEJTDEJTUCUBGBPHGJTMGJTUCQUBZCDUDZFCDJTLRSZQUBUJOUGU
      HUIUJUEUF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemkl $p |- ( ph -> K e. Lat ) $=
      ( chlt wcel clat 4atexlemk hllat syl ) AKPQKRQABCDEFGHIJKLMNOSKTUA $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemkc $p |- ( ph -> K e. CvLat ) $=
      ( chlt wcel clc 4atexlemk hlcvl syl ) AKPQKRQABCDEFGHIJKLMNOSKTUA $.

    ${
      4thatlemmwb.h $e |- H = ( LHyp ` K ) $.
      $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
      4atexlemwb $p |- ( ph -> W e. ( Base ` K ) ) $=
        ( wcel cbs cfv 4atexlemw eqid lhpbase syl ) ANIQNKRSZQABCDEFGHIJKLMNOTU
        DIKNUDUAPUBUC $.
    $}

    ${
      4thatlempqb.j $e |- .\/ = ( join ` K ) $.
      4thatlempqb.a $e |- A = ( Atoms ` K ) $.
      $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
      4atexlempsb $p |- ( ph -> ( P .\/ S ) e. ( Base ` K ) ) $=
        ( chlt wcel co cbs 4atexlemk 4atexlemp 4atexlems eqid hlatjcl syl3anc
        cfv ) AKRSCBSFBSCFJTKUAUHZSABCDEFGHIJKLMNOUBABCDEFGHIJKLMNOUCABCDEFGHIJ
        KLMNOUDBUIJKCFUIUEPQUFUG $.

      $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 24-Nov-2012.) $)
      4atexlemqtb $p |- ( ph -> ( Q .\/ T ) e. ( Base ` K ) ) $=
        ( chlt wcel co cbs 4atexlemk 4atexlemq 4atexlemt eqid hlatjcl syl3anc
        cfv ) AKRSDBSGBSDGJTKUAUHZSABCDEFGHIJKLMNOUBABCDEFGHIJKLMNOUCABCDEFGHIJ
        KLMNOUDBUIJKDGUIUEPQUFUG $.
    $}

    ${
      4thatlemslps.l $e |- .<_ = ( le ` K ) $.
      4thatlemslps.j $e |- .\/ = ( join ` K ) $.
      4thatlemslps.a $e |- A = ( Atoms ` K ) $.
      $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
      4atexlempns $p |- ( ph -> P =/= S ) $=
        ( chlt wcel co wn 4atexlemk 4atexlemp 4atexlemq 4atexlems 4atexlemnslpq
        wbr wne 4atlem0be syl131anc ) AKSTCBTDBTFBTFCDJUALUHUBCFUIABCDEFGHIJKLM
        NOUCABCDEFGHIJKLMNOUDABCDEFGHIJKLMNOUEABCDEFGHIJKLMNOUFABCDEFGHIJKLMNOU
        GBCDFJKLPQRUJUK $.

      4thatlemsw.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( Lemma for ~ 4atexlem7 .  Swap ` Q ` and ` R ` , so that theorems
         involving ` C ` can be reused for ` D ` .  Note that ` U ` must be
         expanded because it involves ` Q ` .  (Contributed by NM,
         25-Nov-2012.) $)
      4atexlemswapqr $p |- ( ph -> ( ( ( K e. HL /\ W e. H )
               /\ ( P e. A /\ -. P .<_ W ) /\ ( R e. A /\ -. R .<_ W ) )
           /\ ( S e. A
               /\ ( Q e. A /\ -. Q .<_ W /\ ( P .\/ Q ) = ( R .\/ Q ) )
               /\ ( T e. A
                   /\ ( ( ( P .\/ R ) ./\ W ) .\/ T ) = ( V .\/ T ) ) )
           /\ ( P =/= R /\ -. S .<_ ( P .\/ R ) ) ) ) $=
        ( chlt wcel wa wbr wn w3a co wceq simp11 sylbi 4atexlempw simp22 3simpa
        wne 4atexlems 4atexlemq simp13r 4atexlemkc 4atexlemp simpld 4atexlempnq
        syl 3jca clc simp223 cvlsupr7 syl132anc 4atexlemt cvlsupr8 4atexlemutvt
        oveq1d syl5eq eqtr3d cvlsupr5 necomd 4atexlemnslpq eqcomd breq2d mtbird
        jca ) AKUAUBOIUBUCZCBUBZCOLUDUEUCZEBUBZEOLUDUEZUCZUFFBUBZDBUBZDOLUDUEZC
        DJUGZEDJUGUHZUFZGBUBZCEJUGZOMUGZGJUGZNGJUGZUHZUCZUFCEUNZFWNLUDZUEZUCAWA
        WCWFAWAWCWHWIUCZUFZWGWDWEWNDEJUGUHZUFZWMHGJUGZWQUHUCZUFZCDUNZFWJLUDZUEU
        CZUFZWAPWAWCXCXIXLUIUJABCDEFGHIJKLNOPUKAXMWFPXMXFWFXDWGXFXHXLULWDWEXEUM
        VBUJZVCAWGWLWSABCDEFGHIJKLNOPUOAWHWIWKABCDEFGHIJKLNOPUPZAXMWIPWHWIWAWCX
        IXLUQUJAKVDUBZWBWHWDXJXEWKABCDEFGHIJKLNOPURZABCDEFGHIJKLNOPUSZXOAWDWEXN
        UTZABCDEFGHIJKLNOPVAZAXMXEPWDWEXEWGXHXDXLVEUJZBCDEJKSRVFVGVCAWMWRABCDEF
        GHIJKLNOPVHAXGWPWQAHWOGJAHWJOMUGWOTAWJWNOMAXPWBWHWDXJXEWJWNUHXQXRXOXSXT
        YABCDEJKSRVIVGZVKVLVKABCDEFGHIJKLNOPVJVMVTVCAWTXBAXPWBWHWDXJXEWTXQXRXOX
        SXTYAXPWBWHWDUFXJXEUCUFECBCDEJKSRVNVOVGAXAXKABCDEFGHIJKLNOPVPAWNWJFLAWJ
        WNYBVQVRVSVTVC $.
    $}

    4thatlem0.l $e |- .<_ = ( le ` K ) $.
    4thatlem0.j $e |- .\/ = ( join ` K ) $.
    4thatlem0.m $e |- ./\ = ( meet ` K ) $.
    4thatlem0.a $e |- A = ( Atoms ` K ) $.
    4thatlem0.h $e |- H = ( LHyp ` K ) $.
    4thatlem0.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemu $p |- ( ph -> U e. A ) $=
      ( chlt wbr wn wa wne 4atexlemk 4atexlemw 4atexlempw 4atexlemq 4atexlempnq
      wcel lhpat2 syl212anc ) AKUCUMOIUMCBUMCOLUDUEUFDBUMCDUGHBUMABCDEFGHIJKLNO
      PUHABCDEFGHIJKLNOPUIABCDEFGHIJKLNOPUJABCDEFGHIJKLNOPUKABCDEFGHIJKLNOPULBC
      DHIJKLMOQRSTUAUBUNUO $.

    4thatlem0.v $e |- V = ( ( P .\/ S ) ./\ W ) $.
    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 23-Nov-2012.) $)
    4atexlemv $p |- ( ph -> V e. A ) $=
      ( chlt wbr wn wa wne 4atexlemk 4atexlemw 4atexlempw 4atexlems 4atexlempns
      wcel lhpat2 syl212anc ) AKUDUNOIUNCBUNCOLUEUFUGFBUNCFUHNBUNABCDEFGHIJKLNO
      PUIABCDEFGHIJKLNOPUJABCDEFGHIJKLNOPUKABCDEFGHIJKLNOPULABCDEFGHIJKLNOPQRTU
      MBCFNIJKLMOQRSTUAUCUOUP $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 21-Nov-2012.) $)
    4atexlemunv $p |- ( ph -> U =/= V ) $=
      ( co wbr wn 4atexlemnslpq wceq wa chlt wcel 4atexlemk 4atexlemp 4atexlems
      wne hlatlej2 syl3anc adantr cbs 4atexlemkl 4atexlempsb 4atexlemwb latmle1
      clat cfv eqid syl5eqbr clc 4atexlemkc 4atexlemv latmle2 4atexlempw simprd
      nbrne2 syl2anc cvlatexchb1 syl131anc mpbid oveq2 eqcomd 4atexlemq hlatjcl
      wb 4atexlemu sylan9eqr eqtr3d breqtrd ex necon3bd mpd ) AFCDJUDZLUEZUFHNU
      OABCDEFGHIJKLNOPUGAWLHNAHNUHZWLAWMUIZFCFJUDZWKLAFWOLUEZWMAKUJUKZCBUKZFBUK
      ZWPABCDEFGHIJKLNOPULZABCDEFGHIJKLNOPUMZABCDEFGHIJKLNOPUNZBCFJKLQRTUPUQURW
      NCNJUDZWOWKAXCWOUHZWMANWOLUEZXDANWOOMUDZWOLUCAKVDUKZWOKUSVEZUKZOXHUKZXFWO
      LUEABCDEFGHIJKLNOPUTZABCDEFGHIJKLNOPRTVAZABCDEFGHIJKLNOPUAVBZXHKLMWOOXHVF
      ZQSVCUQVGAKVHUKZNBUKWSWRNCUOZXEXDWCABCDEFGHIJKLNOPVIZABCDEFGHIJKLMNOPQRST
      UAUBUCVJXBXAANOLUECOLUEUFZXPANXFOLUCAXGXIXJXFOLUEXKXLXMXHKLMWOOXNQSVKUQVG
      AWRXRABCDEFGHIJKLNOPVLVMZNCOLVNVOBNFCJKLQRTVPVQVRURWMAXCCHJUDZWKWMXTXCHNC
      JVSVTAHWKLUEZXTWKUHZAHWKOMUDZWKLUBAXGWKXHUKZXJYCWKLUEXKAWQWRDBUKZYDWTXAAB
      CDEFGHIJKLNOPWAZBXHJKCDXNRTWBUQZXMXHKLMWKOXNQSVCUQVGAXOHBUKYEWRHCUOZYAYBW
      CXQABCDEFGHIJKLMNOPQRSTUAUBWDYFXAAHOLUEXRYHAHYCOLUBAXGYDXJYCOLUEXKYGXMXHK
      LMWKOXNQSVKUQVGXSHCOLVNVOBHDCJKLQRTVPVQVRWEWFWGWHWIWJ $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 24-Nov-2012.) $)
    4atexlemtlw $p |- ( ph -> T .<_ W ) $=
      ( cbs cfv co eqid 4atexlemkl wcel 4atexlemt 4atexlemk 4atexlemu 4atexlemv
      atbase syl chlt hlatjcl syl3anc 4atexlemwb clc wne 4atexlemkc 4atexlemunv
      wceq wbr 4atexlemutvt cvlsupr4 syl132anc clat 4atexlemp 4atexlemq latmle2
      syl5eqbr 4atexlempsb wa wb latjle12 syl13anc mpbi2and lattrd ) AKUDUEZKLG
      HNJUFZOWAUGZQABCDEFGHIJKLNOPUHZAGBUIZGWAUIABCDEFGHIJKLNOPUJZBWAGKWCTUNUOA
      KUPUIZHBUIZNBUIZWBWAUIABCDEFGHIJKLNOPUKZABCDEFGHIJKLMNOPQRSTUAUBULZABCDEF
      GHIJKLMNOPQRSTUAUBUCUMZBWAJKHNWCRTUQURABCDEFGHIJKLNOPUAUSZAKUTUIWHWIWEHNV
      AHGJUFNGJUFVDGWBLVEABCDEFGHIJKLNOPVBWKWLWFABCDEFGHIJKLMNOPQRSTUAUBUCVCABC
      DEFGHIJKLNOPVFBHNGJKLTQRVGVHAHOLVEZNOLVEZWBOLVEZAHCDJUFZOMUFZOLUBAKVIUIZW
      QWAUIZOWAUIZWROLVEWDAWGCBUIDBUIWTWJABCDEFGHIJKLNOPVJABCDEFGHIJKLNOPVKBWAJ
      KCDWCRTUQURWMWAKLMWQOWCQSVLURVMANCFJUFZOMUFZOLUCAWSXBWAUIXAXCOLVEWDABCDEF
      GHIJKLNOPRTVNWMWAKLMXBOWCQSVLURVMAWSHWAUIZNWAUIZXAWNWOVOWPVPWDAWHXDWKBWAH
      KWCTUNUOAWIXEWLBWANKWCTUNUOWMWAJKLHNOWCQRVQVRVSVT $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 24-Nov-2012.) $)
    4atexlemntlpq $p |- ( ph -> -. T .<_ ( P .\/ Q ) ) $=
      ( co wbr 4atexlemtlw wn wne wcel 4atexlemkc 4atexlemu 4atexlemv 4atexlemt
      wa wceq 4atexlemunv 4atexlemutvt cvlsupr5 syl132anc adantr chlt 4atexlemk
      clc 4atexlemw jca 4atexlempw 4atexlemq 4atexlempnq simpr lhpat3 syl222anc
      wb mpbird ex mt2d ) AGCDJUDLUEZGOLUEZABCDEFGHIJKLMNOPQRSTUAUBUCUFAVPVQUGZ
      AVPUNZVRGHUHZAVTVPAKVCUIHBUINBUIGBUIZHNUHHGJUDNGJUDUOVTABCDEFGHIJKLNOPUJA
      BCDEFGHIJKLMNOPQRSTUAUBUKABCDEFGHIJKLMNOPQRSTUAUBUCULABCDEFGHIJKLNOPUMZAB
      CDEFGHIJKLMNOPQRSTUAUBUCUPABCDEFGHIJKLNOPUQBHNGJKTRURUSUTVSKVAUIZOIUIZUNZ
      CBUICOLUEUGUNZDBUIZWACDUHZVPVRVTVLAWEVPAWCWDABCDEFGHIJKLNOPVBABCDEFGHIJKL
      NOPVDVEUTAWFVPABCDEFGHIJKLNOPVFUTAWGVPABCDEFGHIJKLNOPVGUTAWAVPWBUTAWHVPAB
      CDEFGHIJKLNOPVHUTAVPVIBCDHGIJKLMOQRSTUAUBVJVKVMVNVO $.

    4thatlem0.c $e |- C = ( ( Q .\/ T ) ./\ ( P .\/ S ) ) $.
    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 24-Nov-2012.) $)
    4atexlemc $p |- ( ph -> C e. A ) $=
      ( co clat wcel cbs cfv 4atexlemkl 4atexlemqtb 4atexlempsb latmcom syl3anc
      wceq eqid syl5eq wne wn 4atexlemk 4atexlemp 4atexlems 4atexlemq 4atexlemt
      chlt wbr 4atexlempns 4atexlemntlpq atnlej2 necomd syl131anc 4atexlemnslpq
      w3a 4atexlempnq 4atlem0ae syl132anc atbase syl 4atexlemu 4atexlemv latjcl
      hlatjcl clc 4atexlemkc 4atexlemunv 4atexlemutvt cvlsupr4 latmle1 syl5eqbr
      4atexlemwb wa latjlej12 syl122anc mp2and hlatjass syl13anc latj32 latjjdi
      wi 3eqtr3rd breqtrd lattrd 2atmat syl333anc eqeltrd ) ACDGKUFZEHKUFZNUFZB
      ACXHXGNUFZXIUEALUGUHZXHLUIUJZUHXGXLUHZXJXIUPABDEFGHIJKLMOPQUKZABDEFGHIJKL
      MOPQSUAULABDEFGHIJKLMOPQSUAUMZXLLNXHXGXLUQZTUNUOURALVFUHZDBUHZGBUHZEBUHZH
      BUHZDGUSEHUSZEXGMVGUTZHXGEKUFZMVGXIBUHABDEFGHIJKLMOPQVAZABDEFGHIJKLMOPQVB
      ZABDEFGHIJKLMOPQVCZABDEFGHIJKLMOPQVDZABDEFGHIJKLMOPQVEZABDEFGHIJKLMOPQRSU
      AVHAXQYAXRXTHDEKUFZMVGUTZYBYEYIYFYHABDEFGHIJKLMNOPQRSTUAUBUCUDVIXQYAXRXTV
      NYKVNHEBHDEKLMRSUAVJVKVLAXQXRXTXSDEUSGYJMVGUTYCYEYFYHYGABDEFGHIJKLMOPQVOA
      BDEFGHIJKLMOPQVMBDEGKLMRSUAVPVQAXLLMHIOKUFZYDXPRXNAYAHXLUHYIBXLHLXPUAVRVS
      AXQIBUHZOBUHZYLXLUHYEABDEFGHIJKLMNOPQRSTUAUBUCVTZABDEFGHIJKLMNOPQRSTUAUBU
      CUDWAZBXLKLIOXPSUAWCUOAXKXMEXLUHZYDXLUHXNXOAXTYQYHBXLELXPUAVRVSZXLKLXGEXP
      SWBUOALWDUHYMYNYAIOUSIHKUFOHKUFUPHYLMVGABDEFGHIJKLMOPQWEYOYPYIABDEFGHIJKL
      MNOPQRSTUAUBUCUDWFABDEFGHIJKLMOPQWGBIOHKLMUARSWHVQAYLYJXGKUFZYDMAIYJMVGZO
      XGMVGZYLYSMVGZAIYJPNUFZYJMUCAXKYJXLUHZPXLUHZUUCYJMVGXNAXQXRXTUUDYEYFYHBXL
      KLDEXPSUAWCUOZABDEFGHIJKLMOPQUBWKZXLLMNYJPXPRTWIUOWJAOXGPNUFZXGMUDAXKXMUU
      EUUHXGMVGXNXOUUGXLLMNXGPXPRTWIUOWJAXKIXLUHZUUDOXLUHZXMYTUUAWLUUBWTXNAYMUU
      IYOBXLILXPUAVRVSUUFAYNUUJYPBXLOLXPUAVRVSXOXLKLMXGIYJOXPRSWMWNWOAYJGKUFZDE
      GKUFKUFZYDYSAXQXRXTXSUUKUULUPYEYFYHYGBDEGKLSUAWPWQAXKDXLUHZYQGXLUHZUUKYDU
      PXNAXRUUMYFBXLDLXPUAVRVSZYRAXSUUNYGBXLGLXPUAVRVSZXLKLDEGXPSWRWQAXKUUMYQUU
      NUULYSUPXNUUOYRUUPXLKLDEGXPSWSWQXAXBXCBDGEHKLMNRSTUAXDXEXF $.

    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 24-Nov-2012.) $)
    4atexlemnclw $p |- ( ph -> -. C .<_ W ) $=
      ( wbr wn wne co clat wcel cbs cfv 4atexlemkl 4atexlemqtb 4atexlempsb eqid
      latmle1 syl3anc syl5eqbr chlt wa w3a wceq simp13r sylbi clc wi 4atexlemkc
      4atexlemv 4atexlemq 4atexlemt 4atexlemu 4atexlemunv 4atexlemutvt cvlsupr6
      syl132anc cvlatexch2 syl131anc 4atexlemwb latmle2 4atexlemtlw wb latjle12
      necomd atbase syl syl13anc mpbi2and 4atexlemk hlatjcl lattr mpan2d nbrne2
      syld mtod 4atexlemw jca 4atexlempw 4atexlems 4atexlemc 4atexlempns lhpat3
      syl2anc syl222anc mpbird ) ACPMUFUGZCOUHZACEHKUIZMUFOXIMUFZUGXHACXIDGKUIZ
      NUIZXIMUEALUJUKZXILULUMZUKZXKXNUKZXLXIMUFABDEFGHIJKLMOPQUNZABDEFGHIJKLMOP
      QSUAUOZABDEFGHIJKLMOPQSUAUPZXNLMNXIXKXNUQZRTURUSUTAXJEPMUFZALVAUKZPJUKZVB
      ZDBUKDPMUFUGVBZEBUKZYAUGZVBVCGBUKZFBUKFPMUFUGDFKUIEFKUIVDVCHBUKZIHKUIOHKU
      IZVDZVBVCZDEUHGDEKUIMUFUGVBZVCYGQYFYGYDYEYLYMVEVFAXJEYJMUFZYAALVGUKZOBUKZ
      YFYIOHUHZXJYNVHABDEFGHIJKLMOPQVIZABDEFGHIJKLMNOPQRSTUAUBUCUDVJZABDEFGHIJK
      LMOPQVKZABDEFGHIJKLMOPQVLZAYOIBUKZYPYIIOUHZYKYQYRABDEFGHIJKLMNOPQRSTUAUBU
      CVMYSUUAABDEFGHIJKLMNOPQRSTUAUBUCUDVNABDEFGHIJKLMOPQVOYOUUBYPYIVCUUCYKVBV
      CHOBIOHKLUASVPWEVQBOEHKLMRSUAVRVSAYNYJPMUFZYAAOPMUFZHPMUFZUUDAOXKPNUIZPMU
      DAXMXPPXNUKZUUGPMUFXQXSABDEFGHIJKLMOPQUBVTZXNLMNXKPXTRTWAUSUTABDEFGHIJKLM
      NOPQRSTUAUBUCUDWBAXMOXNUKZHXNUKZUUHUUEUUFVBUUDWCXQAYPUUJYSBXNOLXTUAWFWGAY
      IUUKUUABXNHLXTUAWFWGUUIXNKLMOHPXTRSWDWHWIAXMEXNUKZYJXNUKZUUHYNUUDVBYAVHXQ
      AYFUULYTBXNELXTUAWFWGAYBYPYIUUMABDEFGHIJKLMOPQWJZYSUUABXNKLOHXTSUAWKUSUUI
      XNLMEYJPXTRWLWHWMWOWPCOXIMWNXDAYDYEYHCBUKDGUHCXKMUFXGXHWCAYBYCUUNABDEFGHI
      JKLMOPQWQWRABDEFGHIJKLMOPQWSABDEFGHIJKLMOPQWTABCDEFGHIJKLMNOPQRSTUAUBUCUD
      UEXAABDEFGHIJKLMOPQRSUAXBACXLXKMUEAXMXOXPXLXKMUFXQXRXSXNLMNXIXKXTRTWAUSUT
      BDGOCJKLMNPRSTUAUBUDXCXEXF $.

    $d z A $.  $d z C $.  $d z .\/ $.  $d z .<_ $.  $d z P $.  $d z S $.
    $d z W $.
    $( Lemma for ~ 4atexlem7 .  Show that when ` C =/= S ` , ` C ` satisfies
       the existence condition of the consequent.  (Contributed by NM,
       25-Nov-2012.) $)
    4atexlemex2 $p |- ( ( ph /\ C =/= S )
        -> E. z e. A ( -. z .<_ W /\ ( P .\/ z ) = ( S .\/ z ) ) ) $=
      ( wne wa wcel wbr wn co wceq cv wrex 4atexlemc 4atexlemnclw 4atexlemntlpq
      adantr id syl5eqr adantl clat cbs 4atexlemkl 4atexlemqtb 4atexlempsb eqid
      cfv latmle1 syl3anc chlt 4atexlemk 4atexlemq hlatjcom breqtrd eqbrtrrd wi
      4atexlemt clc 4atexlemkc 4atexlemp 4atexlempnq cvlatexch2 mpd ex necon3bd
      syl131anc simpr latmle2 syl5eqbr 4atexlems 4atexlempns cvlsupr2 mpbir3and
      w3a wb breq1 notbid oveq2 eqeq12d anbi12d rspcev syl12anc ) ADHUGZUHZDCUI
      ZDQNUJZUKZEDLULZHDLULZUMZBUNZQNUJZUKZEXMLULZHXMLULZUMZUHZBCUOAXGXEACDEFGH
      IJKLMNOPQRSTUAUBUCUDUEUFUPZUSAXIXEACDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUQUSXFXL
      DEUGZXEDEHLULZNUJZAYAXEAIEFLULNUJZUKYAACEFGHIJKLMNOPQRSTUAUBUCUDUEURAYDDE
      ADEUMZYDAYEUHZEIFLULZNUJZYDYFFILULZYBOULZEYGNYEYJEUMAYEYJDEUFYEUTVAVBAYJY
      GNUJYEAYJYIYGNAMVCUIZYIMVDVIZUIZYBYLUIZYJYINUJACEFGHIJKLMNPQRVEZACEFGHIJK
      LMNPQRTUBVFZACEFGHIJKLMNPQRTUBVGZYLMNOYIYBYLVHZSUAVJVKAMVLUIFCUIZICUIZYIY
      GUMACEFGHIJKLMNPQRVMACEFGHIJKLMNPQRVNZACEFGHIJKLMNPQRVSZCLMFITUBVOVKVPUSV
      QAYHYDVRZYEAMVTUIZECUIZYTYSEFUGUUCACEFGHIJKLMNPQRWAZACEFGHIJKLMNPQRWBZUUB
      UUAACEFGHIJKLMNPQRWCCEIFLMNSTUBWDWHUSWEWFWGWEUSAXEWIAYCXEADYJYBNUFAYKYMYN
      YJYBNUJYOYPYQYLMNOYIYBYRSUAWJVKWKUSAXLYAXEYCWPWQZXEAUUDUUEHCUIXGEHUGUUHUU
      FUUGACEFGHIJKLMNPQRWLXTACEFGHIJKLMNPQRSTUBWMCEHDLMNUBSTWNWHUSWOXSXIXLUHBD
      CXMDUMZXOXIXRXLUUIXNXHXMDQNWRWSUUIXPXJXQXKXMDELWTXMDHLWTXAXBXCXD $.

    4thatlem0.d $e |- D = ( ( R .\/ T ) ./\ ( P .\/ S ) ) $.
    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 24-Nov-2012.) $)
    4atexlemcnd $p |- ( ph -> C =/= D ) $=
      ( wne wbr wn 4atexlemtlw 4atexlemnclw nbrne2 syl2anc wceq wa co chlt wcel
      4atexlemk 4atexlemq 4atexlemt hlatjcom syl3anc simp221 oveq12d 4atexlemkc
      w3a sylbi clc 4atexlemp 4atexlempnq simp223 cvlsupr6 necomd 4atexlemntlpq
      syl132anc cvlsupr7 eqtr4d breq2d mtbid 2llnma2 eqtr2d adantr clat cbs cfv
      4atexlemkl 4atexlemqtb 4atexlempsb latmle1 syl5eqbr simpr hlatjcl eqbrtrd
      eqid 4atexlemc atbase syl latlem12 syl13anc mpbi2and hlatl eqeltrrd atcmp
      wb cal mpbid ex necon3d mpd ) AICUHZCDUHAIQNUICQNUIUJXLABEFGHIJKLMNOPQRST
      UAUBUCUDUEUKABCEFGHIJKLMNOPQRSTUAUBUCUDUEUFULICQNUMUNACDICACDUOZICUOAXMUP
      ZIFILUQZGILUQZOUQZCAIXQUOXMAXQIFLUQZIGLUQZOUQZIAXOXRXPXSOAMURUSZFBUSZIBUS
      ZXOXRUOABEFGHIJKLMNPQRUTZABEFGHIJKLMNPQRVAZABEFGHIJKLMNPQRVBZBLMFITUBVCVD
      AYAGBUSZYCXPXSUOYDAYAQKUSUPEBUSZEQNUIUJUPYBFQNUIUJUPVHZHBUSZYGGQNUIUJZEGL
      UQFGLUQZUOZVHYCJILUQPILUQUOUPZVHEFUHZHEFLUQZNUIUJUPZVHZYGRYGYKYMYJYNYIYQV
      EVIZYFBLMGITUBVCVDVFAYAYBYGYCFGUHZIYLNUIZUJXTIUOYDYEYSYFAMVJUSZYHYBYGYOYM
      YTABEFGHIJKLMNPQRVGZABEFGHIJKLMNPQRVKZYEYSABEFGHIJKLMNPQRVLZAYRYMRYGYKYMY
      JYNYIYQVMVIZUUBYHYBYGVHYOYMUPVHGFBEFGLMUBTVNVOVQAIYPNUIUUAABEFGHIJKLMNOPQ
      RSTUAUBUCUDUEVPAYPYLINAYPGFLUQZYLAUUBYHYBYGYOYMYPUUGUOUUCUUDYEYSUUEUUFBEF
      GLMUBTVRVQAYAYBYGYLUUGUOYDYEYSBLMFGTUBVCVDVSVTWABFGILMNOSTUAUBWBVQWCZWDXN
      CXQNUIZCXQUOZXNCXONUIZCXPNUIZUUIAUUKXMACXOEHLUQZOUQZXONUFAMWEUSZXOMWFWGZU
      SZUUMUUPUSZUUNXONUIABEFGHIJKLMNPQRWHZABEFGHIJKLMNPQRTUBWIZABEFGHIJKLMNPQR
      TUBWJZUUPMNOXOUUMUUPWPZSUAWKVDWLWDXNCDXPNAXMWMADXPNUIXMADXPUUMOUQZXPNUGAU
      UOXPUUPUSZUURUVCXPNUIUUSAYAYGYCUVDYDYSYFBUUPLMGIUVBTUBWNVDZUVAUUPMNOXPUUM
      UVBSUAWKVDWLWDWOAUUKUULUPUUIXFZXMAUUOCUUPUSZUUQUVDUVFUUSACBUSZUVGABCEFGHI
      JKLMNOPQRSTUAUBUCUDUEUFWQZBUUPCMUVBUBWRWSUUTUVEUUPMNOCXOXPUVBSUAWTXAWDXBA
      UUIUUJXFZXMAMXGUSZUVHXQBUSUVJAYAUVKYDMXCWSUVIAIXQBUUHYFXDBCXQMNSUBXEVDWDX
      HVSXIXJXK $.

    $d z D $.
    $( Lemma for ~ 4atexlem7 .  Show that when ` C = S ` , ` D ` satisfies the
       existence condition of the consequent.  (Contributed by NM,
       26-Nov-2012.) $)
    4atexlemex4 $p |- ( ( ph /\ C = S )
        -> E. z e. A ( -. z .<_ W /\ ( P .\/ z ) = ( S .\/ z ) ) ) $=
      ( wceq cv wbr wn co wrex chlt wcel w3a 4atexlemswapqr 4atexlemcnd pm13.18
      wa wne wi necomd expcom syl biid eqid 4atexlemex2 ee12an imp ) ADIUIZBUJZ
      ROUKULFVMMUMIVMMUMUIVABCUNZANUOUPRLUPVAFCUPFROUKULVAHCUPHROUKULVAUQICUPGC
      UPGROUKULFGMUMHGMUMUIUQJCUPFHMUMZRPUMZJMUMQJMUMUIVAUQFHVBIVOOUKULVAUQZVLE
      IVBZVNACFGHIJKLMNOPQRSTUAUCUEURADEVBZVLVRVCACDEFGHIJKLMNOPQRSTUAUBUCUDUEU
      FUGUHUSVLVSVRVLVSVAIEDIEUTVDVEVFVQBCEFHGIJVPLMNOPQRVQVGTUAUBUCUDVPVHUFUHV
      IVJVK $.
  $}

  ${
    $d t z A $.  $d t H $.  $d t z .\/ $.  $d t K $.  $d t z .<_ $.
    $d t z ./\ $.  $d t z P $.  $d t z Q $.  $d t z R $.  $d t z S $.
    $d t z W $.
    4thatleme.l $e |- .<_ = ( le ` K ) $.
    4thatleme.j $e |- .\/ = ( join ` K ) $.
    4thatleme.m $e |- ./\ = ( meet ` K ) $.
    4thatleme.a $e |- A = ( Atoms ` K ) $.
    4thatleme.h $e |- H = ( LHyp ` K ) $.
    $( Lemma for ~ 4atexlem7 .  (Contributed by NM, 25-Nov-2012.) $)
    4atexlemex6 $p |- ( ( ( ( K e. HL /\ W e. H )
                /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
            /\ ( ( R e. A /\ -. R .<_ W ) /\ S e. A )
            /\ ( ( P .\/ R ) = ( Q .\/ R )
                /\ P =/= Q /\ -. S .<_ ( P .\/ Q ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( P .\/ z ) = ( S .\/ z ) ) ) $=
      ( wcel wa co vt chlt wbr wn w3a wceq wne cv simp11l simp11 simp12 simp13l
      wrex simp32 lhpat syl112anc simp2r simp12l simp33 atnlej1 hlsupr2 syl3anc
      syl131anc necomd simp111 simp112 simp113 simp12r simp2ll 3ad2ant1 simp2lr
      simp131 3jca simp132 simp133 biid eqid 4atexlemex4 4atexlemex2 pm2.61dane
      3simpc syl332anc rexlimdv3a mpd ) IUBRZLGRZSZCBRZCLJUCUDZSZDBRZDLJUCUDZSZ
      UEZEBRZELJUCUDZSZFBRZSZCEHTDEHTUFZCDUGZFCDHTZJUCUDZUEZUEZXBLKTZUAUHZHTCFH
      TZLKTZXGHTUFZUABUMZAUHZLJUCUDCXLHTFXLHTUFSABUMZXEWEXFBRZXIBRZXKWEWFWJWMWS
      XDUIZXEWGWJWKXAXNWGWJWMWSXDUJZWGWJWMWSXDUKZWKWLWGWJWSXDULZWNWSWTXAXCUNBCD
      GHIJKLMNOPQUOUPXEWGWJWRCFUGXOXQXRWNWQWRXDUQZXEFCXEWEWRWHWKXCFCUGXPXTWHWIW
      GWMWSXDURXSWNWSWTXAXCUSBFCDHIJMNPUTVCVDBCFGHIJKLMNOPQUOUPBXFXIHIUANPVAVBX
      EXJXMUABXEXGBRZXJUEZWGWJWMWRWOWPWTUEZYAXJSZXAXCXMWGWJWMWSXDYAXJVEWGWJWMWS
      XDYAXJVFWGWJWMWSXDYAXJVGWQWRWNXDYAXJVHYBWOWPWTXEYAWOXJWOWPWRWNXDVIVJXEYAW
      PXJWOWPWRWNXDVKVJWTXAXCWNWSYAXJVLVMXEYAXJWAWTXAXCWNWSYAXJVNWTXAXCWNWSYAXJ
      VOWNWRYCYDUEXAXCSUEZXMDXGHTXHKTZFYEABYFEXGHTXHKTZCDEFXGXFGHIJKXILYEVPZMNO
      PQXFVQZXIVQZYFVQZYGVQVRYEABYFCDEFXGXFGHIJKXILYHMNOPQYIYJYKVSVTWBWCWD $.
  $}

  ${
    $d r z A $.  $d r H $.  $d r z .\/ $.  $d r z K $.  $d r z .<_ $.
    $d r z P $.  $d r z Q $.  $d r z S $.  $d r z W $.
    4that.l $e |- .<_ = ( le ` K ) $.
    4that.j $e |- .\/ = ( join ` K ) $.
    4that.a $e |- A = ( Atoms ` K ) $.
    4that.h $e |- H = ( LHyp ` K ) $.
    $( Whenever there are at least 4 atoms under ` P .\/ Q ` (specifically,
       ` P ` , ` Q ` , ` r ` , and ` ( P .\/ Q ) ./\ W ` ), there are also at
       least 4 atoms under ` P .\/ S ` .  This proves the statement in Lemma E
       of [Crawley] p. 114, last line, "...p ` \/ ` q/0 and hence p ` \/ ` s/0
       contains at least four atoms..."  Note that by ~ cvlsupr2 , our
       ` ( P .\/ r ) = ( Q .\/ r ) ` is a shorter way to express
       ` r =/= P /\ r =/= Q /\ r .<_ ( P .\/ Q ) ` .  With a longer proof, the
       condition ` -. S .<_ ( P .\/ Q ) ` could be eliminated (see ~ 4atex ),
       although for some purposes this more restricted lemma may be adequate.
       (Contributed by NM, 25-Nov-2012.) $)
    4atexlem7 $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ S e. A )
            /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q )
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( P .\/ z ) = ( S .\/ z ) ) ) $=
      ( wcel wa wbr wn co chlt w3a wne cv wceq wrex wi simp11l simp1r1 3ad2ant1
      simp1r2 simp3l jca simp1r3 simp3r simp12 simp13 cmee cfv eqid 4atexlemex6
      simp2 syl323anc rexlimdv3a 3exp 3impd 3impia ) HUAPJFPQZCBPCJIRSQZDBPDJIR
      SQZEBPZUBZCDUCZECDGTIRSZKUDZJIRSZCVOGTDVOGTUEZQZKBUFZUBAUDZJIRSCVTGTEVTGT
      UEQABUFZVHVLQZVMVNVSWAWBVMVNVSWAUGWBVMVNUBZVRWAKBWCVOBPZVRUBZVHVIVJWDVPQV
      KVQVMVNWAVHVLVMVNWDVRUHWCWDVIVRVIVJVKVHVMVNUIUJWCWDVJVRVIVJVKVHVMVNUKUJWE
      WDVPWCWDVRVBWCWDVPVQULUMWCWDVKVRVIVJVKVHVMVNUNUJWCWDVPVQUOWBVMVNWDVRUPWBV
      MVNWDVRUQABCDVOEFGHIHURUSZJLMWFUTNOVAVCVDVEVFVG $.

    $( Whenever there are at least 4 atoms under ` P .\/ Q ` (specifically,
       ` P ` , ` Q ` , ` r ` , and ` ( P .\/ Q ) ./\ W ` ), there are also at
       least 4 atoms under ` P .\/ S ` .  This proves the statement in Lemma E
       of [Crawley] p. 114, last line, "...p ` \/ ` q/0 and hence p ` \/ ` s/0
       contains at least four atoms..."  Note that by ~ cvlsupr2 , our
       ` ( P .\/ r ) = ( Q .\/ r ) ` is a shorter way to express
       ` r =/= P /\ r =/= Q /\ r .<_ ( P .\/ Q ) ` .  (Contributed by NM,
       27-May-2013.) $)
    4atex $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ S e. A )
            /\ ( P =/= Q
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( P .\/ z ) = ( S .\/ z ) ) ) $=
      ( wcel wa wbr co wceq chlt wn w3a wne wrex simp21l ad2antrr simp21r oveq1
      cv eqcoms adantl breq1 notbid oveq2 eqeq12d anbi12d rspcev simpl3r eqeq2d
      syl12anc anbi2d rexbidv cbvrexv syl6rbbr simp22l ad3antrrr simp22r simp3l
      wb mpbid necomd simpr simpllr clc wi simp1l hlcvl simp23 simplr syl131anc
      syl cvlatexch1 mpd cvlsupr2 mpbir3and pm2.61dane simpl1 simpl3l 4atexlem7
      simpl2 syl113anc pm2.61dan ) HUAPZJFPZQZCBPZCJIRZUBZQZDBPZDJIRZUBZQZEBPZU
      CZCDUDZKUJZJIRZUBZCXHGSZDXHGSZTZQZKBUEZQZUCZECDGSZIRZAUJZJIRZUBZCXTGSZEXT
      GSZTZQZABUEZXQXSQZYGECYHECTZQWQWSCCGSZECGSZTZYGXQWQXSYIWQWSXDXEWPXPUFZUGX
      QWSXSYIWQWSXDXEWPXPUHUGYIYLYHYLCECECGUIUKULYFWSYLQACBXTCTZYBWSYEYLYNYAWRX
      TCJIUMUNYNYCYJYDYKXTCCGUOXTCEGUOUPUQURVAYHECUDZQZYGEDYPEDTZQXOYGYHXOYOYQX
      GXOWPXFXSUSUGYQXOYGVJYPYQYGYBYCDXTGSZTZQZABUEXOYQYFYTABYQYEYSYBYQYDYRYCED
      XTGUIUTVBVCXNYTKABXHXTTZXJYBXMYSUUAXIYAXHXTJIUMUNUUAXKYCXLYRXHXTCGUOXHXTD
      GUOUPUQVDVEULVKYPEDUDZQZXAXCXREDGSZTZYGXQXAXSYOUUBXAXCWTXEWPXPVFVGZXQXCXS
      YOUUBXAXCWTXEWPXPVHVGUUCUUEDCUDZDEUDZDCEGSIRZXQUUGXSYOUUBXQCDWPXFXGXOVIVL
      VGUUCEDYPUUBVMVLUUCXSUUIXQXSYOUUBVNUUCHVOPZXEXAWQYOXSUUIVPXQUUJXSYOUUBXQW
      NUUJWNWOXFXPVQHVRWBVGZXQXEXSYOUUBWPWTXDXEXPVSVGZUUFXQWQXSYOUUBYMVGZYHYOUU
      BVTZBEDCGHILMNWCWAWDUUCUUJWQXEXACEUDUUEUUGUUHUUIUCVJUUKUUMUULUUFUUCECUUNV
      LBCEDGHINLMWEWAWFYFXCUUEQADBXTDTZYBXCYEUUEUUOYAXBXTDJIUMUNUUOYCXRYDUUDXTD
      CGUOXTDEGUOUPUQURVAWGWGXQXSUBZQWPXFXGUUPXOYGWPXFXPUUPWHWPXFXPUUPWKXGXOWPX
      FUUPWIXQUUPVMXGXOWPXFUUPUSABCDEFGHIJKLMNOWJWLWM $.

    $d y A $.  $d y H $.  $d y .\/ $.  $d y K $.  $d y .<_ $.  $d y P $.
    $d y Q $.  $d y S $.  $d r y z T $.  $d y W $.
    $( More general version of ~ 4atex for a line ` S .\/ T ` not necessarily
       connected to ` P .\/ Q ` .  (Contributed by NM, 27-May-2013.) $)
    4atex2 $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ ( S e. A /\ -. S .<_ W ) )
            /\ ( P =/= Q /\ T e. A
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( S .\/ z ) = ( T .\/ z ) ) ) $=
      ( vy wcel wa co chlt wbr wn w3a wne wceq wrex oveq1 eqeq1d anbi2d rexbidv
      simpl1 simpl23 simpl21 simpl32 simpr simpl22 simp23l adantr simpl31 4atex
      cv simpl33 syl132anc eqcom anbi2i rexbii sylib simp1 simp21 simp22 simp32
      simp31 simp33 pm2.61ne ) IUARKGRSZCBRCKJUBUCSZDBRDKJUBUCSZEBRZEKJUBUCZSZU
      DZCDUEZFBRZLVBZKJUBUCCWEHTDWEHTUFSLBUGZUDZUDZAVBZKJUBUCZEWIHTZFWIHTZUFZSZ
      ABUGZWJCWIHTZWLUFZSZABUGZECECUFZWNWRABWTWMWQWJWTWKWPWLECWIHUHUIUJUKWHECUE
      ZSZVPWAVQWDXAQVBZKJUBUCZEXCHTZCXCHTZUFZSZQBUGZWOVPWBWGXAULZVQVRWAVPWGXAUM
      VQVRWAVPWGXAUNZWCWDWFVPWBXAUOWHXAUPXBXDXFXEUFZSZQBUGZXIXBVPVQVRVSWCWFXNXJ
      XKVQVRWAVPWGXAUQWHVSXAVSVTVQVRVPWGURUSWCWDWFVPWBXAUTWCWDWFVPWBXAVCQBCDEGH
      IJKLMNOPVAVDXMXHQBXLXGXDXFXEVEVFVGVHABECFGHIJKQMNOPVAVDWHVPVQVRWDWCWFWSVP
      WBWGVIVPVQVRWAWGVJVPVQVRWAWGVKVPWBWCWDWFVLVPWBWCWDWFVMVPWBWCWDWFVNABCDFGH
      IJKLMNOPVAVDVO $.

    $( Same as ~ 4atex2 except that ` S ` is zero.  (Contributed by NM,
       27-May-2013.)  (New usage is discouraged.) $)
    4atex2-0aOLDN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ S = ( 0. ` K ) )
            /\ ( P =/= Q /\ ( T e. A /\ -. T .<_ W )
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( S .\/ z ) = ( T .\/ z ) ) ) $=
      ( wcel wa wceq co chlt wbr wn cp0 cfv w3a wne cv wrex simp32l simp32r col
      cbs simp1l hlol syl eqid atbase olj02 syl2anc simp23 oveq1d 3eqtr4d breq1
      hlatjidm notbid oveq2 eqeq12d anbi12d rspcev syl12anc ) IUAQZKGQZRZCBQCKJ
      UBUCRZDBQDKJUBUCRZEIUDUEZSZUFZCDUGZFBQZFKJUBZUCZRLUHZKJUBUCCWDHTDWDHTSRLB
      UIZUFZUFZWAWCEFHTZFFHTZSZAUHZKJUBZUCZEWKHTZFWKHTZSZRZABUIWAWCVTWEVNVSUJZW
      AWCVTWEVNVSUKWGVQFHTZFWHWIWGIULQZFIUMUEZQZWSFSWGVLWTVLVMVSWFUNZIUOUPWGWAX
      BWRBXAFIXAUQZOURUPXAHIFVQXDNVQUQUSUTWGEVQFHVNVOVPVRWFVAVBWGVLWAWIFSXCWRBH
      IFNOVEUTVCWQWCWJRAFBWKFSZWMWCWPWJXEWLWBWKFKJVDVFXEWNWHWOWIWKFEHVGWKFFHVGV
      HVIVJVK $.

    $( Same as ~ 4atex2 except that ` T ` is zero.  (Contributed by NM,
       27-May-2013.)  (New usage is discouraged.) $)
    4atex2-0bOLDN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ ( S e. A /\ -. S .<_ W ) )
            /\ ( P =/= Q /\ T = ( 0. ` K )
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( S .\/ z ) = ( T .\/ z ) ) ) $=
      ( wcel wa wbr wn chlt w3a wne cp0 cfv wceq cv co wrex simp1 simp21 simp22
      simp32 simp31 simp23 simp33 4atex2-0aOLDN syl133anc anbi2i rexbii sylibr
      eqcom ) IUAQKGQRZCBQCKJSTRZDBQDKJSTRZEBQEKJSTRZUBZCDUCZFIUDUEUFZLUGZKJSTC
      VJHUHDVJHUHUFRLBUIZUBZUBZAUGZKJSTZFVNHUHZEVNHUHZUFZRZABUIZVOVQVPUFZRZABUI
      VMVCVDVEVIVHVFVKVTVCVGVLUJVCVDVEVFVLUKVCVDVEVFVLULVCVGVHVIVKUMVCVGVHVIVKU
      NVCVDVEVFVLUOVCVGVHVIVKUPABCDFEGHIJKLMNOPUQURWBVSABWAVRVOVQVPVBUSUTVA $.

    $d z H $.
    $( Same as ~ 4atex2 except that ` S ` and ` T ` are zero.  TODO: do we need
       this one or ~ 4atex2-0aOLDN or ~ 4atex2-0bOLDN ?  (Contributed by NM,
       27-May-2013.)  (New usage is discouraged.) $)
    4atex2-0cOLDN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ S = ( 0. ` K ) )
            /\ ( P =/= Q /\ T = ( 0. ` K )
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        -> E. z e. A ( -. z .<_ W /\ ( S .\/ z ) = ( T .\/ z ) ) ) $=
      ( wcel wa wceq co chlt wbr wn cp0 cfv w3a wne wrex simp21l simp21r simp23
      oveq1d simp32 eqtr4d breq1 notbid oveq2 eqeq12d anbi12d rspcev syl12anc
      cv ) IUAQKGQRZCBQZCKJUBZUCZRZDBQDKJUBUCRZEIUDUEZSZUFZCDUGZFVISZLVBZKJUBUC
      CVNHTDVNHTSRLBUHZUFZUFZVDVFECHTZFCHTZSZAVBZKJUBZUCZEWAHTZFWAHTZSZRZABUHVD
      VFVHVJVCVPUIVDVFVHVJVCVPUJVQVRVICHTVSVQEVICHVCVGVHVJVPUKULVQFVICHVCVKVLVM
      VOUMULUNWGVFVTRACBWACSZWCVFWFVTWHWBVEWACKJUOUPWHWDVRWEVSWACEHUQWACFHUQURU
      SUTVA $.

    $( More general version of ~ 4atex for a line ` S .\/ T ` not necessarily
       connected to ` P .\/ Q ` .  (Contributed by NM, 29-May-2013.) $)
    4atex3 $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                /\ ( S e. A /\ -. S .<_ W ) )
            /\ ( P =/= Q /\ ( T e. A /\ S =/= T )
                /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> E. z e. A ( -. z .<_ W
        /\ ( z =/= S /\ z =/= T /\ z .<_ ( S .\/ T ) ) ) ) $=
      ( wcel wa wbr wn chlt w3a wne cv co wceq wrex simp1 simp31 simp32l simp33
      simp2 4atex2 syl113anc clc simp1l hlcvl syl adantr simp23l simpr cvlsupr2
      wb simp32r syl131anc anbi2d rexbidva mpbid ) IUAQZKGQZRZCBQCKJSTRZDBQDKJS
      TRZEBQZEKJSTZRUBZCDUCZFBQZEFUCZRZLUDZKJSTCWAHUEDWAHUEUFRLBUGZUBZUBZAUDZKJ
      STZEWEHUEFWEHUEUFZRZABUGZWFWEEUCWEFUCWEEFHUEJSUBZRZABUGWDVKVPVQVRWBWIVKVP
      WCUHVKVPWCULVKVPVQVTWBUIVRVSVQWBVKVPUJZVKVPVQVTWBUKABCDEFGHIJKLMNOPUMUNWD
      WHWKABWDWEBQZRZWGWJWFWNIUOQZVNVRWMVSWGWJVCWDWOWMWDVIWOVIVJVPWCUPIUQURUSWD
      VNWMVNVOVLVMVKWCUTUSWDVRWMWLUSWDWMVAWDVSWMVRVSVQWBVKVPVDUSBEFWEHIJOMNVBVE
      VFVGVH $.
  $}

  ${
    $d f k x y B $.  $d f x y F $.  $d f k x y K $.  $d f k .<_ $.
    lautset.b $e |- B = ( Base ` K ) $.
    lautset.l $e |- .<_ = ( le ` K ) $.
    lautset.i $e |- I = ( LAut ` K ) $.
    $( The set of lattice automorphisms.  (Contributed by NM, 11-May-2012.) $)
    lautset $p |- ( K e. A -> I = { f | ( f : B -1-1-onto->
      B /\ A. x e. B A. y e. B ( x .<_ y
 <-> ( f ` x ) .<_ ( f ` y ) ) ) } ) $=
      ( vk cvv cv wbr cfv wb wral cab cbs wcel wf1o wa wceq claut fveq2 syl6eqr
      elex cple f1oeq2 syl f1oeq3 bitrd breqd bibi12d raleqbidv anbi12d df-laut
      abbidv wf cmap fvex eqeltri mapval ovex eqeltrri ss2abi ssexi simpl fvmpt
      co f1of syl5eq ) GCUAGMUAZFDDENZUBZANZBNZHOZVQVOPZVRVOPZHOZQZBDRZADRZUCZE
      SZUDGCUHVNFGUEPWGKLGLNZTPZWIVOUBZVQVRWHUIPZOZVTWAWKOZQZBWIRZAWIRZUCZESWGM
      UEWHGUDZWQWFEWRWJVPWPWEWRWJDWIVOUBZVPWRWIDUDZWJWSQWRWIGTPZDWHGTUFIUGZWIDW
      IVOUJUKWRWTWSVPQXBWIDDVOULUKUMWRWOWDAWIDXBWRWNWCBWIDXBWRWLVSWMWBWRWKHVQVR
      WRWKGUIPHWHGUIUFJUGZUNWRWKHVTWAXCUNUOUPUPUQUSABELURWGVPESZXDDDVOUTZESZDDV
      AVKXFMDDEDXAMIGTVBVCZXGVDDDVAVEVFVPXEEDDVOVLVGVHWFVPEVPWEVIVGVHVJVMUK $.

    $( The predictate "is a lattice automorphism."  (Contributed by NM,
       11-May-2012.) $)
    islaut $p |- ( K e. A -> ( F e. I <-> ( F : B -1-1-onto->
      B /\ A. x e. B A. y e. B ( x .<_ y
    <-> ( F ` x ) .<_ ( F ` y ) ) ) ) ) $=
      ( vf wcel cv wf1o wbr cfv wb wral cvv wa cab lautset eleq2d f1of cbs fvex
      wf eqeltri fex sylancl adantr wceq f1oeq1 breq12d bibi2d 2ralbidv anbi12d
      fveq1 elab3 syl6bb ) GCMZEFMEDDLNZOZANZBNZHPZVEVCQZVFVCQZHPZRZBDSADSZUAZL
      UBZMDDEOZVGVEEQZVFEQZHPZRZBDSADSZUAZVBFVNEABCDLFGHIJKUCUDVMWALEVOETMZVTVO
      DDEUHDTMWBDDEUEDGUFQTIGUFUGUIDDTEUJUKULVCEUMZVDVOVLVTDDVCEUNWCVKVSABDDWCV
      JVRVGWCVHVPVIVQHVEVCEUSVFVCEUSUOUPUQURUTVA $.

    $d x y .<_ $.  $d x y X $.  $d y Y $.
    $( Less-than or equal property of a lattice automorphism.  (Contributed by
       NM, 19-May-2012.) $)
    lautle $p |- ( ( ( K e. V /\ F e. I ) /\ ( X e. B /\ Y e. B ) )
       -> ( X .<_ Y <-> ( F ` X ) .<_ ( F ` Y ) ) ) $=
      ( vx vy wcel wa cv wbr cfv wb wral wf1o islaut simplbda wceq breq1 breq1d
      fveq2 bibi12d breq2 breq2d rspc2v mpan9 ) DFNZBCNZOLPZMPZEQZUOBRZUPBRZEQZ
      SZMATLATZGANHANOGHEQZGBRZHBRZEQZSZUMUNAABUAVBLMFABCDEIJKUBUCVAVGGUPEQZVDU
      SEQZSLMGHAAUOGUDZUQVHUTVIUOGUPEUEVJURVDUSEUOGBUGUFUHUPHUDZVHVCVIVFUPHGEUI
      VKUSVEVDEUPHBUGUJUHUKUL $.
  $}

  ${
    $d x y B $.  $d x y F $.  $d x y K $.
    laut1o.b $e |- B = ( Base ` K ) $.
    laut1o.i $e |- I = ( LAut ` K ) $.
    $( A lattice automorphism is one-to-one and onto.  (Contributed by NM,
       19-May-2012.) $)
    laut1o $p |- ( ( K e. A /\ F e. I ) -> F : B -1-1-onto-> B ) $=
      ( vx vy wcel wf1o cv cple cfv wbr wb wral eqid islaut simprbda ) EAJCDJBB
      CKHLZILZEMNZOUACNUBCNUCOPIBQHBQHIABCDEUCFUCRGST $.

    $( One-to-one property of a lattice automorphism.  (Contributed by NM,
       20-May-2012.) $)
    laut11 $p |- ( ( ( K e. V /\ F e. I ) /\ ( X e. B /\ Y e. B ) )
       -> ( ( F ` X ) = ( F ` Y ) <-> X = Y ) ) $=
      ( wcel wa wf1 cfv wceq wb wf1o laut1o f1of1 syl f1fveq sylan ) DEJBCJKZAA
      BLZFAJGAJKFBMGBMNFGNOUBAABPUCEABCDHIQAABRSAAFGBTUA $.

    $( A lattice automorphism value belongs to the base set.  (Contributed by
       NM, 20-May-2012.) $)
    lautcl $p |- ( ( ( K e. V /\ F e. I ) /\ X e. B ) -> ( F ` X ) e. B ) $=
      ( wcel wa wf1o wf laut1o f1of syl ffvelrnda ) DEIBCIJZAAFBQAABKAABLEABCDG
      HMAABNOP $.

    $( Reverse closure of a lattice automorphism.  (Contributed by NM,
       25-May-2012.)  (New usage is discouraged.) $)
    lautcnvclN $p |- ( ( ( K e. V /\ F e. I ) /\ X e. B )
              -> ( `' F ` X ) e. B ) $=
      ( wcel wa wf1o ccnv cfv laut1o f1ocnvdm sylan ) DEIBCIJAABKFAIFBLMAIEABCD
      GHNAAFBOP $.
  $}

  ${
    lautcnvle.b $e |- B = ( Base ` K ) $.
    lautcnvle.l $e |- .<_ = ( le ` K ) $.
    lautcnvle.i $e |- I = ( LAut ` K ) $.
    $( Less-than or equal property of lattice automorphism converse.
       (Contributed by NM, 19-May-2012.) $)
    lautcnvle $p |- ( ( ( K e. V /\ F e. I ) /\ ( X e. B /\ Y e. B ) )
       -> ( X .<_ Y <-> ( `' F ` X ) .<_ ( `' F ` Y ) ) ) $=
      ( wcel wa ccnv cfv wbr f1ocnvdm syl2anc wceq f1ocnvfv2 wf1o laut1o adantr
      wb simpl simprl simprr lautle syl12anc breq12d bitr2d ) DFLBCLMZGALZHALZM
      ZMZGBNZOZHUQOZEPZURBOZUSBOZEPZGHEPUPULURALZUSALZUTVCUDULUOUEUPAABUAZUMVDU
      LVFUOFABCDIKUBUCZULUMUNUFZAAGBQRUPVFUNVEVGULUMUNUGZAAHBQRABCDEFURUSIJKUHU
      IUPVAGVBHEUPVFUMVAGSVGVHAAGBTRUPVFUNVBHSVGVIAAHBTRUJUK $.
  $}

  ${
    $d x y F $.  $d x y I $.  $d x y K $.  $d x y V $.
    lautcnv.i $e |- I = ( LAut ` K ) $.
    $( The converse of a lattice automorphism is a lattice automorphism.
       (Contributed by NM, 10-May-2013.) $)
    lautcnv $p |- ( ( K e. V /\ F e. I ) -> `' F e. I ) $=
      ( vx vy wcel wa ccnv cbs cfv wf1o cv cple wbr wb wral eqid laut1o f1ocnv
      syl lautcnvle ralrimivva islaut adantr mpbir2and ) CDHZABHZIZAJZBHZCKLZUM
      UKMZFNZGNZCOLZPUOUKLUPUKLUQPQZGUMRFUMRZUJUMUMAMUNDUMABCUMSZETUMUMAUAUBUJU
      RFGUMUMUMABCUQDUOUPUTUQSZEUCUDUHULUNUSIQUIFGDUMUKBCUQUTVAEUEUFUG $.
  $}

  ${
    lautlt.b $e |- B = ( Base ` K ) $.
    lautlt.s $e |- .< = ( lt ` K ) $.
    lautlt.i $e |- I = ( LAut ` K ) $.
    $( Less-than property of a lattice automorphism.  (Contributed by NM,
       20-May-2012.) $)
    lautlt $p |- ( ( K e. A /\ ( F e. I /\ X e. B /\ Y e. B ) )
       -> ( X .< Y <-> ( F ` X ) .< ( F ` Y ) ) ) $=
      ( wcel wa cfv wbr wne wb syl22anc wceq pltval w3a cple simpr1 simpr2 eqid
      simpr3 lautle laut11 necon3bid anbi12d 3adant3r1 syl21anc syl3anc 3bitr4d
      simpl bicomd lautcl ) FALZDELZGBLZHBLZUAZMZGHFUBNZOZGHPZMZGDNZHDNZVDOZVHV
      IPZMZGHCOZVHVICOZVCVEVJVFVKVCURUSUTVAVEVJQURVBUOZURUSUTVAUCZURUSUTVAUDZUR
      USUTVAUFZBDEFVDAGHIVDUEZKUGRVCGHVHVIVCVHVISZGHSZVCURUSUTVAVTWAQVOVPVQVRBD
      EFAGHIKUHRUPUIUJURUTVAVMVGQUSABBCFVDGHVSJTUKVCURVHBLZVIBLZVNVLQVOVCURUSUT
      WBVOVPVQBDEFAGIKUQULVCURUSVAWCVOVPVRBDEFAHIKUQULABBCFVDVHVIVSJTUMUN $.
  $}

  ${
    $d w z A $.  $d w z B $.  $d w z F $.  $d w z I $.  $d w z K $.
    $d w z X $.  $d w z Y $.
    lautcvr.b $e |- B = ( Base ` K ) $.
    lautcvr.c $e |- C = ( <o ` K ) $.
    lautcvr.i $e |- I = ( LAut ` K ) $.
    $( Covering property of a lattice automorphism.  (Contributed by NM,
       20-May-2012.) $)
    lautcvr $p |- ( ( K e. A /\ ( F e. I /\ X e. B /\ Y e. B ) )
       -> ( X C Y <-> ( F ` X ) C ( F ` Y ) ) ) $=
      ( vw vz wcel wa cfv wbr lautlt wb anbi12d w3a cplt cv wrex wn eqid simpll
      simplr1 simplr2 simpr syl13anc simplr3 lautcl syl21anc breq2 breq1 rspcev
      wi wceq syl sylbid rexlimdva ccnv wf1o laut1o f1ocnvdm sylancom f1ocnvfv2
      syl2anc breq2d bitr2d breq1d impbid notbid cvrval 3adant3r1 simpr1 simpr2
      ex simpl simpr3 syl3anc 3bitr4d ) FANZDENZGBNZHBNZUAZOZGHFUBPZQZGLUCZWJQZ
      WLHWJQZOZLBUDZUEZOZGDPZHDPZWJQZWSMUCZWJQZXBWTWJQZOZMBUDZUEZOZGHCQZWSWTCQZ
      WIWKXAWQXGABWJDEFGHIWJUFZKRWIWPXFWIWPXFWIWOXFLBWIWLBNZOZWOWSWLDPZWJQZXNWT
      WJQZOZXFXMWMXOWNXPXMWDWEWFXLWMXOSWDWHXLUGZWEWFWGWDXLUHZWEWFWGWDXLUIWIXLUJ
      ZABWJDEFGWLIXKKRUKXMWDWEXLWGWNXPSXRXSXTWEWFWGWDXLULABWJDEFWLHIXKKRUKTXMXN
      BNZXQXFURXMWDWEXLYAXRXSXTBDEFAWLIKUMUNYAXQXFXEXQMXNBXBXNUSXCXOXDXPXBXNWSW
      JUOXBXNWTWJUPTUQVSUTVAVBWIXEWPMBWIXBBNZOZXEGXBDVCPZWJQZYDHWJQZOZWPYCXCYEX
      DYFYCYEWSYDDPZWJQZXCYCWDWEWFYDBNZYEYISWDWHYBUGZWEWFWGWDYBUHZWEWFWGWDYBUIW
      IYBBBDVDZYJYCWDWEYMYKYLABDEFIKVEVIZBBXBDVFVGZABWJDEFGYDIXKKRUKYCYHXBWSWJW
      IYBYMYHXBUSYNBBXBDVHVGZVJVKYCYFYHWTWJQZXDYCWDWEYJWGYFYQSYKYLYOWEWFWGWDYBU
      LABWJDEFYDHIXKKRUKYCYHXBWTWJYPVLVKTYCYJYGWPURYOYJYGWPWOYGLYDBWLYDUSWMYEWN
      YFWLYDGWJUOWLYDHWJUPTUQVSUTVAVBVMVNTWDWFWGXIWRSWELABCWJFGHIXKJVOVPWIWDWSB
      NZWTBNZXJXHSWDWHVTZWIWDWEWFYRYTWDWEWFWGVQZWDWEWFWGVRBDEFAGIKUMUNWIWDWEWGY
      SYTUUAWDWEWFWGWABDEFAHIKUMUNMABCWJFWSWTIXKJVOWBWC $.
  $}

  ${
    lautj.b $e |- B = ( Base ` K ) $.
    lautj.j $e |- .\/ = ( join ` K ) $.
    lautj.i $e |- I = ( LAut ` K ) $.
    $( Meet property of a lattice automorphism.  (Contributed by NM,
       25-May-2012.) $)
    lautj $p |- ( ( K e. Lat /\ ( F e. I /\ X e. B /\ Y e. B ) )
       -> ( F ` ( X .\/ Y ) ) = ( ( F ` X ) .\/ ( F ` Y ) ) ) $=
      ( clat wcel wa cfv 3adant3r1 syl2anc wbr wb lautle syl12anc w3a cple eqid
      co simpl simpr1 latjcl lautcl simpr2 simpr3 syl3anc ccnv wf1o wceq laut1o
      jca 3ad2antr1 f1ocnvfv1 latlej1 breqtrrd f1ocnvdm mpbird latlej2 latjle12
      f1ocnvfv2 syl13anc mpbi2and eqbrtrd lautcnvle mpbid latasymd ) EKLZBCLZFA
      LZGALZUAZMZAEEUBNZFGDUDZBNZFBNZGBNZDUDZHVRUCZVLVPUEZVQVLVMMZVSALZVTALZVQV
      LVMWEVLVMVNVOUFUPZVLVNVOWGVMADEFGHIUGOZABCEKVSHJUHPZVQVLWAALZWBALZWCALZWE
      VQWFVNWLWIVLVMVNVOUIZABCEKFHJUHPZVQWFVOWMWIVLVMVNVOUJZABCEKGHJUHPZADEWAWB
      HIUGUKZVQVTWCVRQZVTBULZNZWCXANZVRQZVQXBVSXCVRVQAABUMZWGXBVSUNVLVNVMXEVOKA
      BCEHJUOUQZWJAAVSBURPVQFXCVRQZGXCVRQZVSXCVRQZVQXGWAXCBNZVRQZVQWAWCXJVRVQVL
      WLWMWAWCVRQWEWPWRADEVRWAWBHWDIUSUKVQXEWNXJWCUNXFWSAAWCBVEPZUTVQWFVNXCALZX
      GXKRWIWOVQXEWNXMXFWSAAWCBVAPZABCEVRKFXCHWDJSTVBVQXHWBXJVRQZVQWBWCXJVRVQVL
      WLWMWBWCVRQWEWPWRADEVRWAWBHWDIVCUKXLUTVQWFVOXMXHXORWIWQXNABCEVRKGXCHWDJST
      VBVQVLVNVOXMXGXHMXIRWEWOWQXNADEVRFGXCHWDIVDVFVGVHVQWFWHWNWTXDRWIWKWSABCEV
      RKVTWCHWDJVITVBVQWAVTVRQZWBVTVRQZWCVTVRQZVQFVSVRQZXPVLVNVOXSVMADEVRFGHWDI
      USOVQWFVNWGXSXPRWIWOWJABCEVRKFVSHWDJSTVJVQGVSVRQZXQVLVNVOXTVMADEVRFGHWDIV
      COVQWFVOWGXTXQRWIWQWJABCEVRKGVSHWDJSTVJVQVLWLWMWHXPXQMXRRWEWPWRWKADEVRWAW
      BVTHWDIVDVFVGVK $.
  $}

  ${
    lautm.b $e |- B = ( Base ` K ) $.
    lautm.m $e |- ./\ = ( meet ` K ) $.
    lautm.i $e |- I = ( LAut ` K ) $.
    $( Meet property of a lattice automorphism.  (Contributed by NM,
       19-May-2012.) $)
    lautm $p |- ( ( K e. Lat /\ ( F e. I /\ X e. B /\ Y e. B ) )
       -> ( F ` ( X ./\ Y ) ) = ( ( F ` X ) ./\ ( F ` Y ) ) ) $=
      ( clat wcel wa cfv 3adant3r1 syl2anc wbr wb syl12anc mpbid w3a cple simpl
      co eqid simpr1 latmcl lautcl simpr2 simpr3 syl3anc latmle1 lautle latmle2
      latlem12 syl13anc mpbi2and ccnv wf1o laut1o 3ad2antr1 f1ocnvfv2 lautcnvle
      jca wceq f1ocnvfv1 breqtrd f1ocnvdm eqbrtrrd latasymd ) DKLZBCLZFALZGALZU
      AZMZADDUBNZFGEUDZBNZFBNZGBNZEUDZHVQUEZVKVOUCZVPVKVLMZVRALZVSALZVPVKVLWDVK
      VLVMVNUFVDZVKVMVNWFVLADEFGHIUGOZABCDKVRHJUHPZVPVKVTALZWAALZWBALZWDVPWEVMW
      KWHVKVLVMVNUIZABCDKFHJUHPZVPWEVNWLWHVKVLVMVNUJZABCDKGHJUHPZADEVTWAHIUGUKZ
      VPVSVTVQQZVSWAVQQZVSWBVQQZVPVRFVQQZWSVKVMVNXBVLADVQEFGHWCIULOVPWEWFVMXBWS
      RWHWIWNABCDVQKVRFHWCJUMSTVPVRGVQQZWTVKVMVNXCVLADVQEFGHWCIUNOVPWEWFVNXCWTR
      WHWIWPABCDVQKVRGHWCJUMSTVPVKWGWKWLWSWTMXARWDWJWOWQADVQEVSVTWAHWCIUOUPUQVP
      WBBURZNZBNZWBVSVQVPAABUSZWMXFWBVEVKVMVLXGVNKABCDHJUTVAZWRAAWBBVBPVPXEVRVQ
      QZXFVSVQQZVPXEFVQQZXEGVQQZXIVPXEVTXDNZFVQVPWBVTVQQZXEXMVQQZVPVKWKWLXNWDWO
      WQADVQEVTWAHWCIULUKVPWEWMWKXNXORWHWRWOABCDVQKWBVTHWCJVCSTVPXGVMXMFVEXHWNA
      AFBVFPVGVPXEWAXDNZGVQVPWBWAVQQZXEXPVQQZVPVKWKWLXQWDWOWQADVQEVTWAHWCIUNUKV
      PWEWMWLXQXRRWHWRWQABCDVQKWBWAHWCJVCSTVPXGVNXPGVEXHWPAAGBVFPVGVPVKXEALZVMV
      NXKXLMXIRWDVPXGWMXSXHWRAAWBBVHPZWNWPADVQEXEFGHWCIUOUPUQVPWEXSWFXIXJRWHXTW
      IABCDVQKXEVRHWCJUMSTVIVJ $.
  $}

  ${
    $d p A $.  $d p B $.  $d p F $.  $d p I $.  $d p K $.  $d p X $.
    lauteq.b $e |- B = ( Base ` K ) $.
    lauteq.a $e |- A = ( Atoms ` K ) $.
    lauteq.i $e |- I = ( LAut ` K ) $.
    $( A lattice automorphism argument is equal to its value if all atoms are
       equal to their values.  (Contributed by NM, 24-May-2012.) $)
    lauteq $p |- ( ( ( K e. HL /\ F e. I /\ X e. B )
          /\ A. p e. A ( F ` p ) = p ) -> ( F ` X ) = X ) $=
      ( chlt wcel cfv wceq wral wa wbr wb simpl1 simpl2 cv atbase adantl simpl3
      w3a cple eqid lautle syl22anc breq1 sylan9bb bicomd ralimdva imp syl21anc
      ex lautcl hlateq syl3anc mpbid ) EKLZCDLZFBLZUEZGUAZCMZVENZGAOZPZVEFCMZEU
      FMZQZVEFVKQZRZGAOZVJFNZVDVHVOVDVGVNGAVDVEALZPZVGVNVRVGPVMVLVRVMVFVJVKQZVG
      VLVRVAVBVEBLZVCVMVSRVAVBVCVQSVAVBVCVQTVQVTVDABVEEHIUBUCVAVBVCVQUDBCDEVKKV
      EFHVKUGZJUHUIVFVEVJVKUJUKULUPUMUNVIVAVJBLZVCVOVPRVAVBVCVHSZVIVAVBVCWBWCVA
      VBVCVHTVAVBVCVHUDZBCDEKFHJUQUOWDABEVKVJFGHWAIURUSUT $.
  $}

  ${
    $d x y B $.  $d x y K $.
    idlaut.b $e |- B = ( Base ` K ) $.
    idlaut.i $e |- I = ( LAut ` K ) $.
    $( The identity function is a lattice automorphism.  (Contributed by NM,
       18-May-2012.) $)
    idlaut $p |- ( K e. A -> ( _I |` B ) e. I ) $=
      ( vx vy wcel cid cres wf1o cv cple cfv wbr wb wral a1i fvresi f1oi bicomd
      wa breqan12d rgen2a eqid islaut mpbir2and ) DAIZJBKZCIBBUJLZGMZHMZDNOZPZU
      LUJOZUMUJOZUNPZQZHBRGBRZUKUIBUASUTUIUSGHBULBIZUMBIZUCURUOVAVBUPULUQUMUNBU
      LTBUMTUDUBUESGHABUJCDUNEUNUFFUGUH $.
  $}

  ${
    $d x y F $.  $d x y G $.  $d x y I $.  $d x y K $.  $d x y V $.
    lautco.i $e |- I = ( LAut ` K ) $.
    $( The composition of two lattice automorphisms is a lattice automorphism.
       (Contributed by NM, 19-Apr-2013.) $)
    lautco $p |- ( ( K e. V /\ F e. I /\ G e. I ) -> ( F o. G ) e. I ) $=
      ( vx vy wcel cfv wf1o cv wbr wb wral eqid laut1o wa lautcl syl21anc f1oco
      w3a cbs 3adant3 3adant2 syl2anc simpl1 simpl2 simpl3 simprl simprr lautle
      ccom cple syl22anc 3adantl2 wf wceq f1of simpl fvco3 syl2an simpr breq12d
      syl 3bitr4d ralrimivva islaut 3ad2ant1 mpbir2and ) DEIZACIZBCIZUBZABUMZCI
      ZDUCJZVQVOKZGLZHLZDUNJZMZVSVOJZVTVOJZWAMZNZHVQOGVQOZVNVQVQAKZVQVQBKZVRVKV
      LWHVMEVQACDVQPZFQUDVKVMWIVLEVQBCDWJFQUEZVQVQVQABUAUFVNWFGHVQVQVNVSVQIZVTV
      QIZRZRZVSBJZVTBJZWAMZWPAJZWQAJZWAMZWBWEWOVKVLWPVQIZWQVQIZWRXANVKVLVMWNUGZ
      VKVLVMWNUHWOVKVMWLXBXDVKVLVMWNUIZVNWLWMUJVQBCDEVSWJFSTWOVKVMWMXCXDXEVNWLW
      MUKVQBCDEVTWJFSTVQACDWAEWPWQWJWAPZFULUOVKVMWNWBWRNVLVQBCDWAEVSVTWJXFFULUP
      WOWCWSWDWTWAVNVQVQBUQZWLWCWSURWNVNWIXGWKVQVQBUSVEZWLWMUTVQVQVSABVAVBVNXGW
      MWDWTURWNXHWLWMVCVQVQVTABVAVBVDVFVGVKVLVPVRWGRNVMGHEVQVOCDWAWJXFFVHVIVJ
      $.
  $}

  ${
    $d f x y F $.  $d f k x K $.  $d f k x y S $.
    pautset.s $e |- S = ( PSubSp ` K ) $.
    pautset.m $e |- M = ( PAut ` K ) $.
    $( The set of projective automorphisms.  (Contributed by NM, 26-Jan-2012.)
       (New usage is discouraged.) $)
    pautsetN $p |- ( K e. B -> M = { f | ( f : S -1-1-onto->
      S /\ A. x e. S A. y e. S ( x C_ y <-> ( f ` x ) C_ ( f ` y ) ) ) } ) $=
      ( vk cvv cv wf1o cfv wb wral cab wceq cpsubsp syl wcel wss wa elex cpautN
      fveq2 syl6eqr f1oeq2 f1oeq3 bitrd raleqdv raleqbidv anbi12d df-pautN cmap
      abbidv wf fvex eqeltri mapval ovex eqeltrri f1of ss2abi ssexi simpl fvmpt
      co syl5eq ) FCUAFKUAZGDDELZMZALZBLZUBVMVKNVNVKNUBOZBDPZADPZUCZEQZRFCUDVJG
      FUENVSIJFJLZSNZWAVKMZVOBWAPZAWAPZUCZEQVSKUEVTFRZWEVREWFWBVLWDVQWFWBDWAVKM
      ZVLWFWADRZWBWGOWFWAFSNZDVTFSUFHUGZWADWAVKUHTWFWHWGVLOWJWADDVKUITUJWFWCVPA
      WADWJWFVOBWADWJUKULUMUPABEJUNVSVLEQZWKDDVKUQZEQZDDUOVHWMKDDEDWIKHFSURUSZW
      NUTDDUOVAVBVLWLEDDVKVCVDVEVRVLEVLVQVFVDVEVGVIT $.

    $( The predictate "is a projective automorphism."  (Contributed by NM,
       26-Jan-2012.)  (New usage is discouraged.) $)
    ispautN $p |- ( K e. B -> ( F e. M <-> ( F : S -1-1-onto->
      S /\ A. x e. S A. y e. S ( x C_ y <-> ( F ` x ) C_ ( F ` y ) ) ) ) ) $=
      ( vf wcel cv wf1o wss cfv wb wral wa cvv cpsubsp cab pautsetN eleq2d f1of
      fvex eqeltri fex sylancl adantr wceq f1oeq1 fveq1 sseq12d bibi2d 2ralbidv
      wf anbi12d elab3 syl6bb ) FCKZEGKEDDJLZMZALZBLZNZVCVAOZVDVAOZNZPZBDQADQZR
      ZJUAZKDDEMZVEVCEOZVDEOZNZPZBDQADQZRZUTGVLEABCDJFGHIUBUCVKVSJEVMESKZVRVMDD
      EUPDSKVTDDEUDDFTOSHFTUEUFDDSEUGUHUIVAEUJZVBVMVJVRDDVAEUKWAVIVQABDDWAVHVPV
      EWAVFVNVGVOVCVAEULVDVAEULUMUNUOUQURUS $.
  $}

  $c LDil $.
  $c LTrn $.
  $c Dil $.
  $c Trn $.

  $( Extend class notation with set of all lattice dilations. $)
  cldil $a class LDil $.

  $( Extend class notation with set of all lattice translations. $)
  cltrn $a class LTrn $.

  $( Extend class notation with set of all dilations. $)
  cdilN $a class Dil $.

  $( Extend class notation with set of all translations. $)
  ctrnN $a class Trn $.

  ${
    $d k w f x y p q $.
    $( Define set of all lattice dilations.  Similar to definition of dilation
       in [Crawley] p. 111.  (Contributed by NM, 11-May-2012.) $)
    df-ldil $a |- LDil = ( k e. _V |-> ( w e. ( LHyp ` k )
       |-> { f e. ( LAut ` k ) | A. x e. ( Base ` k )
               ( x ( le ` k ) w -> ( f ` x ) = x ) } ) ) $.

    $( Define set of all lattice translations.  Similar to definition of
       translation in [Crawley] p. 111.  (Contributed by NM, 11-May-2012.) $)
    df-ltrn $a |- LTrn = ( k e. _V |-> ( w e. ( LHyp ` k )
   |-> { f e. ( ( LDil ` k ) ` w ) |
     A. p e. ( Atoms ` k ) A. q e. ( Atoms ` k )
      ( ( -. p ( le ` k ) w /\ -. q ( le ` k ) w ) ->
           ( ( p ( join ` k ) ( f ` p ) ) ( meet ` k ) w )
        = ( ( q ( join ` k ) ( f ` q ) ) ( meet ` k ) w ) ) } ) ) $.
  $}

  ${
    $d k d f x q r $.
    $( Define set of all dilations.  Definition of dilation in [Crawley]
       p. 111.  (Contributed by NM, 30-Jan-2012.) $)
    df-dilN $a |- Dil = ( k e. _V |-> ( d e. ( Atoms ` k )
       |-> { f e. ( PAut ` k ) | A. x e. ( PSubSp ` k )
               ( x C_ ( ( WAtoms ` k ) ` d ) -> ( f ` x ) = x ) } ) ) $.

    $( Define set of all translations.  Definition of translation in [Crawley]
       p. 111.  (Contributed by NM, 4-Feb-2012.) $)
    df-trnN $a |- Trn = ( k e. _V |-> ( d e. ( Atoms ` k )
   |-> { f e. ( ( Dil ` k ) ` d )
      | A. q e. ( ( WAtoms ` k ) ` d ) A. r e. ( ( WAtoms ` k ) ` d )
           ( ( q ( +P ` k ) ( f ` q ) ) i^i ( ( _|_P ` k ) ` { d } ) )
         = ( ( r ( +P ` k ) ( f ` r ) ) i^i ( ( _|_P ` k ) ` { d } ) ) } ) ) $.
  $}

  ${
    $d k x B $.  $d k w H $.  $d f k I $.  $d f k w x K $.  $d k .<_ $.
    ldilset.b $e |- B = ( Base ` K ) $.
    ldilset.l $e |- .<_ = ( le ` K ) $.
    ldilset.h $e |- H = ( LHyp ` K ) $.
    ldilset.i $e |- I = ( LAut ` K ) $.
    $( The mapping from fiducial co-atom ` w ` to its set of lattice
       dilations.  (Contributed by NM, 11-May-2012.) $)
    ldilfset $p |- ( K e. C -> ( LDil ` K )
           = ( w e. H |-> { f e. I | A. x e. B
               ( x .<_ w -> ( f ` x ) = x ) } ) ) $=
      ( vk cvv cfv cv clh fveq2 syl6eqr wcel cldil wbr wceq wral crab cmpt elex
      wi cple cbs claut breqd imbi1d raleqbidv rabeqbidv mpteq12dv df-ldil fvex
      eqeltri mptex fvmpt syl ) HDUAHOUAHUBPBFAQZBQZIUCZVDEQPVDUDZUIZACUEZEGUFZ
      UGZUDHDUHNHBNQZRPZVDVEVLUJPZUCZVGUIZAVLUKPZUEZEVLULPZUFZUGVKOUBVLHUDZBVMV
      TFVJWAVMHRPZFVLHRSLTWAVRVIEVSGWAVSHULPGVLHULSMTWAVPVHAVQCWAVQHUKPCVLHUKSJ
      TWAVOVFVGWAVNIVDVEWAVNHUJPIVLHUJSKTUMUNUOUPUQABENURBFVJFWBOLHRUSUTVAVBVC
      $.

    $d w B $.  $d w I $.  $d w .<_ $.  $d f w x W $.
    ldilset.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( The set of lattice dilations for a fiducial co-atom ` W ` .
       (Contributed by NM, 11-May-2012.) $)
    ldilset $p |- ( ( K e. C /\ W e. H ) -> D = { f e. I | A. x e. B
               ( x .<_ W -> ( f ` x ) = x ) } ) $=
      ( vw wcel cfv cv wbr wa cldil wceq wral crab ldilfset fveq1d breq2 imbi1d
      wi cmpt ralbidv rabbidv eqid claut cvv fvex eqeltri rabex sylan9eq syl5eq
      fvmpt ) HCQZJFQZUADJHUBRZRZASZJITZVGESRVGUCZUJZABUDZEGUEZOVCVDVFJPFVGPSZI
      TZVIUJZABUDZEGUEZUKZRVLVCJVEVRAPBCEFGHIKLMNUFUGPJVQVLFVRVMJUCZVPVKEGVSVOV
      JABVSVNVHVIVMJVGIUHUIULUMVRUNVKEGGHUORUPNHUOUQURUSVBUTVA $.

    $d f B $.  $d f x F $.  $d f .<_ $.
    $( The predicate "is a lattice dilation".  Similar to definition of
       dilation in [Crawley] p. 111.  (Contributed by NM, 11-May-2012.) $)
    isldil $p |- ( ( K e. C /\ W e. H ) -> ( F e. D
      <-> ( F e. I /\ A. x e. B ( x .<_ W -> ( F ` x ) = x ) ) ) ) $=
      ( vf wcel wa cv wceq wbr cfv wral crab ldilset eleq2d fveq1 eqeq1d imbi2d
      wi ralbidv elrab syl6bb ) HCQJFQRZEDQEASZJIUAZUOPSZUBZUOTZUJZABUCZPGUDZQE
      GQUPUOEUBZUOTZUJZABUCZRUNDVBEABCDPFGHIJKLMNOUEUFVAVFPEGUQETZUTVEABVGUSVDU
      PVGURVCUOUOUQEUGUHUIUKULUM $.
  $}

  ${
    $d x F $.  $d x K $.  $d x W $.
    ldillaut.h $e |- H = ( LHyp ` K ) $.
    ldillaut.i $e |- I = ( LAut ` K ) $.
    ldillaut.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( A lattice dilation is an automorphism.  (Contributed by NM,
       20-May-2012.) $)
    ldillaut $p |- ( ( ( K e. V /\ W e. H ) /\ F e. D ) -> F e. I ) $=
      ( vx wcel wa cv cple cfv wbr wceq wi eqid cbs wral isldil simprbda ) EFLG
      CLMBALBDLKNZGEOPZQUEBPUERSKEUAPZUBKUGFABCDEUFGUGTUFTHIJUCUD $.
  $}

  ${
    ldil1o.b $e |- B = ( Base ` K ) $.
    ldil1o.h $e |- H = ( LHyp ` K ) $.
    ldil1o.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( A lattice dilation is a one-to-one onto function.  (Contributed by NM,
       19-Apr-2013.) $)
    ldil1o $p |- ( ( ( K e. V /\ W e. H ) /\ F e. D )
      -> F : B -1-1-onto-> B ) $=
      ( wcel wa claut cfv wf1o simpll eqid ldillaut laut1o syl2anc ) EFKZGDKZLC
      BKZLUACEMNZKAACOUAUBUCPBCDUDEFGIUDQZJRFACUDEHUEST $.
  $}

  ${
    $d x B $.  $d x F $.  $d x K $.  $d x .<_ $.  $d x W $.  $d x X $.
    ldilval.b $e |- B = ( Base ` K ) $.
    ldilval.l $e |- .<_ = ( le ` K ) $.
    ldilval.h $e |- H = ( LHyp ` K ) $.
    ldilval.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( Value of a lattice dilation under its co-atom.  (Contributed by NM,
       20-May-2012.) $)
    ldilval $p |- ( ( ( K e. V /\ W e. H ) /\ F e. D
        /\ ( X e. B /\ X .<_ W ) ) -> ( F ` X ) = X ) $=
      ( vx wcel wa wbr cfv wceq wi cv wral claut eqid isldil simpr syl6bi breq1
      fveq2 id eqeq12d imbi12d rspccv imp3a syl6 3imp ) EGOHDOPZCBOZIAOZIHFQZPZ
      ICRZISZUQURNUAZHFQZVDCRZVDSZTZNAUBZVAVCTUQURCEUCRZOZVIPVINAGBCDVJEFHJKLVJ
      UDMUEVKVIUFUGVIUSUTVCVHUTVCTNIAVDISZVEUTVGVCVDIHFUHVLVFVBVDIVDICUIVLUJUKU
      LUMUNUOUP $.
  $}

  ${
    $d x B $.  $d x K $.  $d x W $.
    idldil.b $e |- B = ( Base ` K ) $.
    idldil.h $e |- H = ( LHyp ` K ) $.
    idldil.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( The identity function is a lattice dilation.  (Contributed by NM,
       18-May-2012.) $)
    idldil $p |- ( ( K e. A /\ W e. H ) -> ( _I |` B ) e. D ) $=
      ( vx wcel wa cid cres claut cfv cv cple wbr eqid idlaut adantr fvresi a1d
      wceq wi wral rgen a1i isldil mpbir2and ) EAKZFDKZLZMBNZCKUOEOPZKZJQZFERPZ
      SZURUOPURUEZUFZJBUGZULUQUMABUPEGUPTZUAUBVCUNVBJBURBKVAUTBURUCUDUHUIJBACUO
      DUPEUSFGUSTHVDIUJUK $.
  $}

  ${
    $d x D $.  $d x F $.  $d x H $.  $d x K $.  $d x W $.
    ldilcnv.h $e |- H = ( LHyp ` K ) $.
    ldilcnv.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( The converse of a lattice dilation is a lattice dilation.  (Contributed
       by NM, 10-May-2013.) $)
    ldilcnv $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. D )
      -> `' F e. D ) $=
      ( vx chlt wcel wa ccnv claut cfv cv cple wbr wceq eqid syl2anc cbs simpll
      wral ldillaut lautcnv w3a ldilval 3expa 3impb fveq2d wf1o ldil1o 3ad2ant1
      wi simp2 f1ocnvfv1 eqtr3d 3exp ralrimiv wb isldil adantr mpbir2and ) DIJZ
      ECJZKZBAJZKZBLZAJZVIDMNZJZHOZEDPNZQZVMVINZVMRZUNZHDUANZUCZVHVDBVKJVLVDVEV
      GUBABCVKDIEFVKSZGUDBVKDIWAUETVHVRHVSVHVMVSJZVOVQVHWBVOUFZVMBNZVINZVPVMWCW
      DVMVIVHWBVOWDVMRZVFVGWBVOKWFVSABCDVNIEVMVSSZVNSZFGUGUHUIUJWCVSVSBUKZWBWEV
      MRVHWBWIVOVSABCDIEWGFGULUMVHWBVOUOVSVSVMBUPTUQURUSVFVJVLVTKUTVGHVSIAVICVK
      DVNEWGWHFWAGVAVBVC $.
  $}

  ${
    $d x D $.  $d x F $.  $d x G $.  $d x H $.  $d x K $.  $d x V $.  $d x W $.
    ldilco.h $e |- H = ( LHyp ` K ) $.
    ldilco.d $e |- D = ( ( LDil ` K ) ` W ) $.
    $( The composition of two lattice automorphisms is a lattice automorphism.
       (Contributed by NM, 19-Apr-2013.) $)
    ldilco $p |- ( ( ( K e. V /\ W e. H )
          /\ F e. D /\ G e. D ) -> ( F o. G ) e. D ) $=
      ( vx wcel wa w3a cfv wceq eqid ldillaut syl2anc ldilval syl112anc ccom cv
      claut cple wbr cbs wral simp1l 3adant3 3adant2 lautco syl3anc wf1o simp11
      wi simp13 ldil1o f1of syl simp2 fvco3 simp3 fveq2d simp12 3eqtrd ralrimiv
      wf 3exp wb isldil 3ad2ant1 mpbir2and ) EFKZGDKZLZBAKZCAKZMZBCUAZAKZVSEUCN
      ZKZJUBZGEUDNZUEZWCVSNZWCOZUOZJEUFNZUGZVRVMBWAKZCWAKZWBVMVNVPVQUHVOVPWKVQA
      BDWAEFGHWAPZIQUIVOVQWLVPACDWAEFGHWMIQUJBCWAEFWMUKULVRWHJWIVRWCWIKZWEWGVRW
      NWEMZWFWCCNZBNZWCBNZWCWOWIWICVGZWNWFWQOWOWIWICUMZWSWOVOVQWTVOVPVQWNWEUNZV
      OVPVQWNWEUPZWIACDEFGWIPZHIUQRWIWICURUSVRWNWEUTZWIWIWCBCVARWOWPWCBWOVOVQWN
      WEWPWCOXAXBXDVRWNWEVBZWIACDEWDFGWCXCWDPZHISTVCWOVOVPWNWEWRWCOXAVOVPVQWNWE
      VDXDXEWIABDEWDFGWCXCXFHISTVEVHVFVOVPVTWBWJLVIVQJWIFAVSDWAEWDGXCXFHWMIVJVK
      VL $.
  $}

  ${
    $d k p q A $.  $d f k D $.  $d k w H $.  $d k .\/ $.  $d f k p q w K $.
    $d k .<_ $.  $d k ./\ $.
    ltrnset.l $e |- .<_ = ( le ` K ) $.
    ltrnset.j $e |- .\/ = ( join ` K ) $.
    ltrnset.m $e |- ./\ = ( meet ` K ) $.
    ltrnset.a $e |- A = ( Atoms ` K ) $.
    ltrnset.h $e |- H = ( LHyp ` K ) $.
    $( The set of all lattice translations for a lattice ` K ` .  (Contributed
       by NM, 11-May-2012.) $)
    ltrnfset $p |- ( K e. C -> ( LTrn ` K ) = ( w e. H
 |-> { f e. ( ( LDil ` K ) ` w ) | A. p e. A A. q e. A ( ( -. p .<_ w /\ -. q
        .<_ w )
   -> ( ( p .\/ ( f ` p ) ) ./\ w )
       = ( ( q .\/ ( f ` q ) ) ./\ w ) ) } ) ) $=
      ( cfv cv co fveq2 vk wcel cvv cltrn wbr wn wa wceq wi wral crab cmpt elex
      cldil clh cple cjn cmee catm syl6eqr fveq1d breqd notbid anbi12d oveq123d
      oveqd eqidd eqeq12d imbi12d raleqbidv rabeqbidv mpteq12dv df-ltrn eqeltri
      fvex mptex fvmpt syl ) GCUBGUCUBGUDQAEKRZARZHUEZUFZJRZVTHUEZUFZUGZVSVSDRZ
      QZFSZVTISZWCWCWGQZFSZVTISZUHZUIZJBUJZKBUJZDVTGUNQZQZUKZULZUHGCUMUAGAUARZU
      OQZVSVTXBUPQZUEZUFZWCVTXDUEZUFZUGZVSWHXBUQQZSZVTXBURQZSZWCWKXJSZVTXLSZUHZ
      UIZJXBUSQZUJZKXRUJZDVTXBUNQZQZUKZULXAUCUDXBGUHZAXCYCEWTYDXCGUOQZEXBGUOTPU
      TYDXTWQDYBWSYDVTYAWRXBGUNTVAYDXSWPKXRBYDXRGUSQBXBGUSTOUTZYDXQWOJXRBYFYDXI
      WFXPWNYDXFWBXHWEYDXEWAYDXDHVSVTYDXDGUPQHXBGUPTLUTZVBVCYDXGWDYDXDHWCVTYGVB
      VCVDYDXMWJXOWMYDXKWIVTVTXLIYDXLGURQIXBGURTNUTZYDXJFVSWHYDXJGUQQFXBGUQTMUT
      ZVFYDVTVGZVEYDXNWLVTVTXLIYHYDXJFWCWKYIVFYJVEVHVIVJVJVKVLADUAJKVMAEWTEYEUC
      PGUOVOVNVPVQVR $.

    ltrnset.d $e |- D = ( ( LDil ` K ) ` W ) $.
    ltrnset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $d w A $.  $d w D $.  $d w .\/ $.  $d w .<_ $.  $d w ./\ $.
    $d f p q w W $.
    $( The set of lattice translations for a fiducial co-atom ` W ` .
       (Contributed by NM, 11-May-2012.) $)
    ltrnset $p |- ( ( K e. B /\ W e. H ) -> T
  = { f e. D | A. p e. A A. q e. A ( ( -. p .<_ W /\ -. q .<_ W )
      -> ( ( p .\/ ( f ` p ) ) ./\ W )
           = ( ( q .\/ ( f ` q ) ) ./\ W ) ) } ) $=
      ( vw wcel cv wbr wn wa cfv co wceq wi wral cldil crab cmpt cltrn ltrnfset
      fveq1d syl5eq fveq2 syl6eqr breq2 notbid anbi12d eqeq12d imbi12d 2ralbidv
      oveq2 rabeqbidv eqid cvv fvex eqeltri rabex fvmpt sylan9eq ) HBUBZKFUBDKU
      AFMUCZUAUCZIUDZUEZLUCZVRIUDZUEZUFZVQVQEUCZUGGUHZVRJUHZWAWAWEUGGUHZVRJUHZU
      IZUJZLAUKMAUKZEVRHULUGZUGZUMZUNZUGZVQKIUDZUEZWAKIUDZUEZUFZWFKJUHZWHKJUHZU
      IZUJZLAUKMAUKZECUMZVPDKHUOUGZUGWQTVPKXIWPUAABEFGHIJLMNOPQRUPUQURUAKWOXHFW
      PVRKUIZWLXGEWNCXJWNKWMUGZCVRKWMUSSUTXJWKXFMLAAXJWDXBWJXEXJVTWSWCXAXJVSWRV
      RKVQIVAVBXJWBWTVRKWAIVAVBVCXJWGXCWIXDVRKWFJVGVRKWHJVGVDVEVFVHWPVIXGECCXKV
      JSKWMVKVLVMVNVO $.

    $d f A $.  $d f p q F $.  $d f .\/ $.  $d f .<_ $.  $d f ./\ $.
    $( The predicate "is a lattice translation".  Similar to definition of
       translation in [Crawley] p. 111.  (Contributed by NM, 11-May-2012.) $)
    isltrn $p |- ( ( K e. B /\ W e. H ) -> ( F e. T
 <-> ( F e. D /\ A. p e. A A. q e. A ( ( -. p .<_ W /\ -. q .<_ W )
    -> ( ( p .\/ ( F ` p ) ) ./\ W )
         = ( ( q .\/ ( F ` q ) ) ./\ W ) ) ) ) ) $=
      ( vf wcel wa cv wbr wn cfv co wceq wral crab ltrnset eleq2d oveq2d oveq1d
      wi fveq1 eqeq12d imbi2d 2ralbidv elrab syl6bb ) HBUBKFUBUCZEDUBEMUDZKIUEU
      FLUDZKIUEUFUCZVDVDUAUDZUGZGUHZKJUHZVEVEVGUGZGUHZKJUHZUIZUPZLAUJMAUJZUACUK
      ZUBECUBVFVDVDEUGZGUHZKJUHZVEVEEUGZGUHZKJUHZUIZUPZLAUJMAUJZUCVCDVQEABCDUAF
      GHIJKLMNOPQRSTULUMVPWFUAECVGEUIZVOWEMLAAWGVNWDVFWGVJVTVMWCWGVIVSKJWGVHVRV
      DGVDVGEUQUNUOWGVLWBKJWGVKWAVEGVEVGEUQUNUOURUSUTVAVB $.

    $( The predicate "is a lattice translation".  Version of ~ isltrn that
       considers only different ` p ` and ` q ` .  TODO:  Can this eliminate
       some separate proofs for the ` p = q ` case?  (Contributed by NM,
       22-Apr-2013.)  (New usage is discouraged.) $)
    isltrn2N $p |- ( ( K e. B /\ W e. H ) -> ( F e. T
 <-> ( F e. D /\ A. p e. A A. q e. A (
    ( -. p .<_ W /\ -. q .<_ W /\ p =/= q )
    -> ( ( p .\/ ( F ` p ) ) ./\ W )
         = ( ( q .\/ ( F ` q ) ) ./\ W ) ) ) ) ) $=
      ( wcel wa cv wbr wn cfv co wceq wi wne isltrn 3simpa imim1i 3anass 3anrot
      wral w3a df-ne anbi1i 3bitr3i imbi1i impexp bitri id fveq2 oveq12d oveq1d
      a1d pm2.61 ax-mp sylbi impbii 2ralbii anbi2i syl6bb ) HBUAKFUAUBEDUAECUAZ
      MUCZKIUDUEZLUCZKIUDUEZUBZVQVQEUFZGUGZKJUGVSVSEUFZGUGZKJUGUHZUIZLAUPMAUPZU
      BVPVRVTVQVSUJZUQZWFUIZLAUPMAUPZUBABCDEFGHIJKLMNOPQRSTUKWHWLVPWGWKMLAAWGWK
      WJWAWFVRVTWIULUMWKVQVSUHZUEZWGUIZWGWKWNWAUBZWFUIWOWJWPWFWIVRVTUQWIWAUBWJW
      PWIVRVTUNWIVRVTUOWIWNWAVQVSURUSUTVAWNWAWFVBVCWMWGUIWOWGUIWMWFWAWMWCWEKJWM
      VQVSWBWDGWMVDVQVSEVEVFVGVHWMWGVIVJVKVLVMVNVO $.
  $}

  ${
    $d p q A $.  $d p q F $.  $d p q .\/ $.  $d p q K $.  $d p q .<_ $.
    $d p q ./\ $.  $d p q P $.  $d q Q $.  $d p q W $.
    ltrnu.l $e |- .<_ = ( le ` K ) $.
    ltrnu.j $e |- .\/ = ( join ` K ) $.
    ltrnu.m $e |- ./\ = ( meet ` K ) $.
    ltrnu.a $e |- A = ( Atoms ` K ) $.
    ltrnu.h $e |- H = ( LHyp ` K ) $.
    ltrnu.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Uniqueness property of a lattice translation value for atoms not under
       the fiducial co-atom ` W ` .  Similar to definition of translation in
       [Crawley] p. 111.  (Contributed by NM, 20-May-2012.) $)
    ltrnu $p |- ( ( ( ( K e. V /\ W e. H ) /\ F e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
         -> ( ( P .\/ ( F ` P ) ) ./\ W )
              = ( ( Q .\/ ( F ` Q ) ) ./\ W ) ) $=
      ( wa co vp vq wcel wbr wn cfv wceq an4 cv wi wral simpr simplr cldil eqid
      wb isltrn ad2antrr syl6bi mpd breq1 notbid anbi1d id fveq2 oveq12d oveq1d
      eqeq1d imbi12d anbi2d eqeq2d rspc2v sylc impr sylan2b 3impb ) HKUCLFUCSZE
      DUCZSZBAUCZBLIUDZUEZSZCAUCZCLIUDZUEZSZBBEUFZGTZLJTZCCEUFZGTZLJTZUGZWCWGSV
      SVTWDSZWBWFSZSWNVTWBWDWFUHVSWOWPWNVSWOSZWOUAUIZLIUDZUEZUBUIZLIUDZUEZSZWRW
      REUFZGTZLJTZXAXAEUFZGTZLJTZUGZUJZUBAUKUAAUKZWPWNUJZVSWOULWQVRXMVQVRWOUMWQ
      VRELHUNUFUFZUCZXMSZXMVQVRXQUPVRWOAKXODEFGHIJLUBUAMNOPQXOUORUQURXPXMULUSUT
      XLXNWBXCSZWJXJUGZUJUAUBBCAAWRBUGZXDXRXKXSXTWTWBXCXTWSWAWRBLIVAVBVCXTXGWJX
      JXTXFWILJXTWRBXEWHGXTVDWRBEVEVFVGVHVIXACUGZXRWPXSWNYAXCWFWBYAXBWEXACLIVAV
      BVJYAXJWMWJYAXIWLLJYAXACXHWKGYAVDXACEVEVFVGVKVIVLVMVNVOVP $.
  $}

  ${
    $d p q F $.  $d p q K $.  $d p q W $.
    ltrnldil.h $e |- H = ( LHyp ` K ) $.
    ltrnldil.d $e |- D = ( ( LDil ` K ) ` W ) $.
    ltrnldil.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( A lattice translation is a lattice dilation.  (Contributed by NM,
       20-May-2012.) $)
    ltrnldil $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T )
      -> F e. D ) $=
      ( vp vq wcel wa cv cfv wbr wn co eqid cple cjn cmee wceq catm wral isltrn
      wi simprbda ) EFMGDMNCBMCAMKOZGEUAPZQRLOZGUKQRNUJUJCPEUBPZSGEUCPZSULULCPU
      MSGUNSUDUHLEUEPZUFKUOUFUOFABCDUMEUKUNGLKUKTUMTUNTUOTHIJUGUI $.
  $}

  ${
    ltrnlaut.h $e |- H = ( LHyp ` K ) $.
    ltrnlaut.i $e |- I = ( LAut ` K ) $.
    ltrnlaut.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( A lattice translation is a lattice automorphism.  (Contributed by NM,
       20-May-2012.) $)
    ltrnlaut $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T )
      -> F e. I ) $=
      ( wcel wa cldil cfv eqid ltrnldil ldillaut syldan ) EFKGCKLBAKBGEMNNZKBDK
      SABCEFGHSOZJPSBCDEFGHITQR $.
  $}

  ${
    ltrn1o.b $e |- B = ( Base ` K ) $.
    ltrn1o.h $e |- H = ( LHyp ` K ) $.
    ltrn1o.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( A lattice translation is a one-to-one onto function.  (Contributed by
       NM, 20-May-2012.) $)
    ltrn1o $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T )
      -> F : B -1-1-onto-> B ) $=
      ( wcel wa claut cfv wf1o simpll eqid ltrnlaut laut1o syl2anc ) EFKZGDKZLC
      BKZLUACEMNZKAACOUAUBUCPBCDUDEFGIUDQZJRFACUDEHUEST $.

    $( Closure of a lattice translation.  (Contributed by NM, 20-May-2012.) $)
    ltrncl $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T /\ X e. B )
      -> ( F ` X ) e. B ) $=
      ( wcel wa w3a claut cfv simp1l eqid ltrnlaut 3adant3 lautcl syl21anc
      simp3 ) EFLZGDLZMZCBLZHALZNUDCEOPZLZUHHCPALUDUEUGUHQUFUGUJUHBCDUIEFGJUIRZ
      KSTUFUGUHUCACUIEFHIUKUAUB $.

    $( One-to-one property of a lattice translation.  (Contributed by NM,
       20-May-2012.) $)
    ltrn11 $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T
       /\ ( X e. B /\ Y e. B ) ) -> ( ( F ` X ) = ( F ` Y ) <-> X = Y ) ) $=
      ( wcel wa w3a claut cfv wceq wb simp1l eqid ltrnlaut simp3l simp3r laut11
      3adant3 syl22anc ) EFMZGDMZNZCBMZHAMZIAMZNZOUHCEPQZMZULUMHCQICQRHIRSUHUIU
      KUNTUJUKUPUNBCDUOEFGKUOUAZLUBUFUJUKULUMUCUJUKULUMUDACUOEFHIJUQUEUG $.

    $( If a translation is different from the identity, so is its converse.
       (Contributed by NM, 17-Jun-2013.) $)
    ltrncnvnid $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
         /\ F =/= ( _I |` B ) ) -> `' F =/= ( _I |` B ) ) $=
      ( chlt wcel wa cid cres wne w3a ccnv simp3 wceq wrel ltrn1o f1orel dfrel2
      wf1o 3adant3 syl sylib cnveq sylan9req cnvresid syl6eq ex necon3d mpd ) E
      JKFDKLZCBKZCMANZOZPZURCQZUQOUOUPURRUSUTUQCUQUSUTUQSZCUQSUSVALCUQQZUQUSVAC
      UTQZVBUSCTZVCCSUSAACUDZVDUOUPVEURABCDEJFGHIUAUEAACUBUFCUCUGUTUQUHUIAUJUKU
      LUMUN $.

    $( Two translations are equal if the composition of one with the converse
       of the other is the zero translation.  This is an analog of vector
       subtraction.  (Contributed by NM, 7-Apr-2014.)
       (New usage is discouraged.) $)
    ltrncoidN $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
    -> ( ( F o. `' G ) = ( _I |` B ) <-> F = G ) ) $=
      ( chlt wcel wa ccom wceq wf1o simpl1 simpl3 syl2anc eqtrd w3a ccnv ltrn1o
      cid cres f1ococnv1 syl coeq2d simpl2 f1of fcoi1 3syl eqtr2d coass syl6eqr
      wf simpr coeq1d fcoi2 f1ococnv2 impbida ) FKLGELMZCBLZDBLZUAZCDUBZNZUDAUE
      ZOZCDOZVEVIMZCVGDNZDVKCCVFDNZNZVLVKVNCVHNZCVKVMVHCVKAADPZVMVHOVKVBVDVPVBV
      CVDVIQZVBVCVDVIRABDEFKGHIJUCZSZAADUFUGUHVKAACPZAACUPVOCOVKVBVCVTVQVBVCVDV
      IUIABCEFKGHIJUCSAACUJAACUKULUMCVFDUNUOVKVLVHDNZDVKVGVHDVEVIUQURVKVPAADUPW
      ADOVSAADUJAADUSULTTVEVJMZVGDVFNZVHWBCDVFVEVJUQURWBVPWCVHOWBVBVDVPVBVCVDVJ
      QVBVCVDVJRVRSAADUTUGTVA $.
  $}

  ${
    ltrnle.b $e |- B = ( Base ` K ) $.
    ltrnle.l $e |- .<_ = ( le ` K ) $.
    ltrnle.h $e |- H = ( LHyp ` K ) $.
    ltrnle.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Less-than or equal property of a lattice translation.  (Contributed by
       NM, 20-May-2012.) $)
    ltrnle $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T
      /\ ( X e. B /\ Y e. B ) ) -> ( X .<_ Y
         <-> ( F ` X ) .<_ ( F ` Y ) ) ) $=
      ( wcel wa w3a claut cfv wbr wb simp1l eqid ltrnlaut 3adant3 simp3l simp3r
      lautle syl22anc ) EGOZHDOZPZCBOZIAOZJAOZPZQUJCERSZOZUNUOIJFTICSJCSFTUAUJU
      KUMUPUBULUMURUPBCDUQEGHMUQUCZNUDUEULUMUNUOUFULUMUNUOUGACUQEFGIJKLUSUHUI
      $.

    $( Less-than or equal property of lattice translation converse.
       (Contributed by NM, 10-May-2013.)  (New usage is discouraged.) $)
    ltrncnvleN $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T
   /\ ( X e. B /\ Y e. B ) )
 -> ( X .<_ Y <-> ( `' F ` X ) .<_ ( `' F ` Y ) ) ) $=
      ( wcel wa w3a claut cfv wbr ccnv wb eqid ltrnlaut 3adant3 simp3 lautcnvle
      simp1l syl21anc ) EGOZHDOZPZCBOZIAOJAOPZQUJCERSZOZUNIJFTICUAZSJUQSFTUBUJU
      KUMUNUHULUMUPUNBCDUOEGHMUOUCZNUDUEULUMUNUFACUOEFGIJKLURUGUI $.
  $}

  ${
    ltrnm.b $e |- B = ( Base ` K ) $.
    ltrnm.m $e |- ./\ = ( meet ` K ) $.
    ltrnm.h $e |- H = ( LHyp ` K ) $.
    ltrnm.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Lattice translation of a meet.  (Contributed by NM, 20-May-2012.) $)
    ltrnm $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ ( X e. B /\ Y e. B ) )
     -> ( F ` ( X ./\ Y ) ) = ( ( F ` X ) ./\ ( F ` Y ) ) ) $=
      ( chlt wcel wa w3a clat cfv co claut wceq hllat syl eqid ltrnlaut 3adant3
      simp1l simp3l simp3r lautm syl13anc ) ENOZGDOZPZCBOZHAOZIAOZPZQZEROZCEUAS
      ZOZUQURHIFTCSHCSICSFTUBUTUMVAUMUNUPUSUHEUCUDUOUPVCUSBCDVBENGLVBUEZMUFUGUO
      UPUQURUIUOUPUQURUJACVBEFHIJKVDUKUL $.
  $}

  ${
    ltrnj.b $e |- B = ( Base ` K ) $.
    ltrnj.j $e |- .\/ = ( join ` K ) $.
    ltrnj.h $e |- H = ( LHyp ` K ) $.
    ltrnj.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Lattice translation of a meet.  TODO: change antecedent to ` K e. HL `
       (Contributed by NM, 25-May-2012.) $)
    ltrnj $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ ( X e. B /\ Y e. B ) )
     -> ( F ` ( X .\/ Y ) ) = ( ( F ` X ) .\/ ( F ` Y ) ) ) $=
      ( chlt wcel wa w3a clat cfv co claut wceq hllat syl eqid ltrnlaut 3adant3
      simp1l simp3l simp3r lautj syl13anc ) FNOZGDOZPZCBOZHAOZIAOZPZQZFROZCFUAS
      ZOZUQURHIETCSHCSICSETUBUTUMVAUMUNUPUSUHFUCUDUOUPVCUSBCDVBFNGLVBUEZMUFUGUO
      UPUQURUIUOUPUQURUJACVBEFHIJKVDUKUL $.
  $}

  ${
    ltrncvr.b $e |- B = ( Base ` K ) $.
    ltrncvr.c $e |- C = ( <o ` K ) $.
    ltrncvr.h $e |- H = ( LHyp ` K ) $.
    ltrncvr.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Covering property of a lattice translation.  (Contributed by NM,
       20-May-2012.) $)
    ltrncvr $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T
       /\ ( X e. B /\ Y e. B ) ) -> ( X C Y <-> ( F ` X ) C ( F ` Y ) ) ) $=
      ( wcel wa w3a claut cfv wbr wb simp1l eqid ltrnlaut 3adant3 simp3l simp3r
      lautcvr syl13anc ) FGOZHEOZPZDCOZIAOZJAOZPZQUJDFRSZOZUNUOIJBTIDSJDSBTUAUJ
      UKUMUPUBULUMURUPCDEUQFGHMUQUCZNUDUEULUMUNUOUFULUMUNUOUGGABDUQFIJKLUSUHUI
      $.
  $}

  ${
    ltrnval1.b $e |- B = ( Base ` K ) $.
    ltrnval1.l $e |- .<_ = ( le ` K ) $.
    ltrnval1.h $e |- H = ( LHyp ` K ) $.
    ltrnval1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Value of a lattice translation under its co-atom.  (Contributed by NM,
       20-May-2012.) $)
    ltrnval1 $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T
        /\ ( X e. B /\ X .<_ W ) ) -> ( F ` X ) = X ) $=
      ( wcel wa cldil cfv wbr wceq eqid ltrnldil 3adant3 ldilval syld3an2 ) EGN
      HDNOZCHEPQQZNZCBNZIANIHFROZICQISUEUHUGUIUFBCDEGHLUFTZMUAUBAUFCDEFGHIJKLUJ
      UCUD $.
  $}

  ${
    $d p x A $.  $d p x B $.  $d p x F $.  $d p x H $.  $d p x K $.
    $d x .<_ $.  $d p x T $.  $d p x W $.  $d p X $.
    ltrneq.b $e |- B = ( Base ` K ) $.
    ltrneq.l $e |- .<_ = ( le ` K ) $.
    ltrneq.a $e |- A = ( Atoms ` K ) $.
    ltrneq.h $e |- H = ( LHyp ` K ) $.
    ltrneq.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( A lattice translation is the identity function iff all atoms not under
       the fiducial co-atom ` W ` are equal to their values.  (Contributed by
       NM, 24-May-2012.) $)
    ltrnid $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( A. p e. A ( -. p .<_ W
           -> ( F ` p ) = p ) <-> F = ( _I |` B ) ) ) $=
      ( vx chlt wcel wa cfv wceq cv wbr wn wral cid cres claut simp-4l ltrnlaut
      wi eqid ad2antrr simpr simplll simpllr atbase ad2antlr ltrnval1 syl112anc
      ex pm2.61 syl ralimdva imp adantr lauteq syl31anc fvresi adantl ralrimiva
      eqtr4d wfn wb wf1o ltrn1o f1ofn fnresi eqfnfv sylancl mpbird fveq1 eqeq1d
      syl5ibrcom a1dd ralrimdva impbid ) FPQZHEQZRZDCQZRZIUAZHGUBZUCZWLDSZWLTZU
      JZIAUDZDUEBUFZTZWKWRWTWKWRRZWTOUAZDSZXBWSSZTZOBUDZXAXEOBXAXBBQZRZXCXBXDXH
      WGDFUGSZQZXGWPIAUDZXCXBTWGWHWJWRXGUHWKXJWRXGCDEXIFPHMXIUKZNUIULXAXGUMXAXK
      XGWKWRXKWKWQWPIAWKWLAQZRZWMWPUJWQWPUJXNWMWPXNWMRWIWJWLBQZWMWPWIWJXMWMUNWI
      WJXMWMUOXMXOWKWMABWLFJLUPZUQXNWMUMBCDEFGPHWLJKMNURUSUTWMWPVAVBVCVDVEABDXI
      FXBIJLXLVFVGXGXDXBTXABXBVHVIVKVJXADBVLZWSBVLWTXFVMXABBDVNZXQWKXRWRBCDEFPH
      JMNVOVEBBDVPVBBVQOBDWSVRVSVTUTWKWTWQIAXNWTWPWNXNWPWTWLWSSZWLTZXNXOXTXMXOW
      KXPVIBWLVHVBWTWOXSWLWLDWSWAWBWCWDWEWF $.

    $( If a lattice translation is not the identity, then there is an atom not
       under the fiducial co-atom ` W ` and not equal to its translation.
       (Contributed by NM, 24-May-2012.) $)
    ltrnnid $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ F =/= ( _I |` B ) )
  -> E. p e. A ( -. p .<_ W /\ ( F ` p ) =/= p ) ) $=
      ( wcel wa wne wn wceq wi chlt cid cres cv wbr cfv wrex wral biimpi imim2i
      ralinexa nne ralimi sylbir ltrnid syl5ib necon1ad 3impia ) FUAOHEOPZDCOZD
      UBBUCZQIUDZHGUERZVBDUFZVBQZPIAUGZUSUTPZVFDVAVFRZVCVDVBSZTZIAUHZVGDVASVHVC
      VERZTZIAUHVKVCVEIAUKVMVJIAVLVIVCVLVIVDVBULUIUJUMUNABCDEFGHIJKLMNUOUPUQUR
      $.
  $}

  ${
    ltrnatb.b $e |- B = ( Base ` K ) $.
    ltrnatb.a $e |- A = ( Atoms ` K ) $.
    ltrnatb.h $e |- H = ( LHyp ` K ) $.
    ltrnatb.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( The lattice translation of an atom is an atom.  (Contributed by NM,
       20-May-2012.) $)
    ltrnatb $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ P e. B )
        -> ( P e. A <-> ( F ` P ) e. A ) ) $=
      ( chlt wcel wa cfv wbr wb eqid syl w3a ccvr simp3 ltrncl 2thd simp1 simp2
      cp0 cops simp1l hlop op0cl 3syl ltrncvr syl112anc cple wceq lhpbase op0le
      simp1r syl2anc ltrnval1 breq1d bitrd anbi12d isat 3bitr4d ) GMNZHFNZOZEDN
      ZCBNZUAZVLGUHPZCGUBPZQZOZCEPZBNZVNVRVOQZOZCANZVRANZVMVLVSVPVTVMVLVSVJVKVL
      UCZBDEFGMHCIKLUDUEVMVPVNEPZVRVOQZVTVMVJVKVNBNZVLVPWFRVJVKVLUFZVJVKVLUGZVM
      VHGUINZWGVHVIVKVLUJZGUKZBGVNIVNSZULUMZWDBVODEFGMHVNCIVOSZKLUNUOVMWEVNVRVO
      VMVJVKWGVNHGUPPZQZWEVNUQWHWIWNVMWJHBNZWQVMVHWJWKWLTVMVIWRVHVIVKVLUTBFGHIK
      URTBGWPHVNIWPSZWMUSVABDEFGWPMHVNIWSKLVBUOVCVDVEVMVHWBVQRWKABVOMCGVNIWMWOJ
      VFTVMVHWCWARWKABVOMVRGVNIWMWOJVFTVG $.

    $( The converse of the lattice translation of an atom is an atom.
       (Contributed by NM, 2-Jun-2012.) $)
    ltrncnvatb $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ P e. B )
         -> ( P e. A <-> ( `' F ` P ) e. A ) ) $=
      ( chlt wcel wa w3a ccnv cfv wb syl2anc wf1o ltrn1o 3adant3 simp3 f1ocnvdm
      ltrnatb syld3an3 wceq f1ocnvfv2 eleq1d bitr2d ) GMNHFNOZEDNZCBNZPZCEQRZAN
      ZUPERZANZCANULUMUNUPBNZUQUSSUOBBEUAZUNUTULUMVAUNBDEFGMHIKLUBUCZULUMUNUDZB
      BCEUETABUPDEFGHIJKLUFUGUOURCAUOVAUNURCUHVBVCBBCEUITUJUK $.
  $}

  ${
    ltrnel.l $e |- .<_ = ( le ` K ) $.
    ltrnel.a $e |- A = ( Atoms ` K ) $.
    ltrnel.h $e |- H = ( LHyp ` K ) $.
    ltrnel.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( The lattice translation of an atom not under the fiducial co-atom is
       also an atom not under the fiducial co-atom.  Remark below Lemma B in
       [Crawley] p. 112.  (Contributed by NM, 22-May-2012.) $)
    ltrnel $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
              /\ ( P e. A /\ -. P .<_ W ) )
         -> ( ( F ` P ) e. A /\ -. ( F ` P ) .<_ W ) ) $=
      ( chlt wcel wa wbr wn cfv wb syl w3a simp3l atbase adantr ltrnatb syl3an3
      eqid mpbid simp3r simp1 simp2 simp1r lhpbase ltrnle syl112anc wceq simp1l
      cbs clat hllat latref syl2anc ltrnval1 breq2d bitrd mtbid jca ) FMNZHENZO
      ZDCNZBANZBHGPZQZOZUAZBDRZANZVQHGPZQVPVLVRVJVKVLVNUBZVOVJVKBFURRZNZVLVRSVL
      WBVNAWABFWAUGZJUCZUDAWABCDEFHWCJKLUEUFUHVPVMVSVJVKVLVNUIVPVMVQHDRZGPZVSVP
      VJVKWBHWANZVMWFSVJVKVOUJZVJVKVOUKZVPVLWBVTWDTVPVIWGVHVIVKVOULWAEFHWCKUMTZ
      WACDEFGMHBHWCIKLUNUOVPWEHVQGVPVJVKWGHHGPZWEHUPWHWIWJVPFUSNZWGWKVPVHWLVHVI
      VKVOUQFUTTWJWAFGHWCIVAVBWACDEFGMHHWCIKLVCUOVDVEVFVG $.

    $( The lattice translation of an atom is also an atom.  TODO:  See if this
       can shorten some ~ ltrnel uses.  (Contributed by NM, 25-May-2012.) $)
    ltrnat $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ P e. A )
         -> ( F ` P ) e. A ) $=
      ( chlt wcel wa w3a cfv simp3 cbs wb eqid atbase ltrnatb syl3an3 mpbid ) F
      MNHENOZDCNZBANZPUHBDQANZUFUGUHRUHUFUGBFSQZNUHUITAUJBFUJUAZJUBAUJBCDEFHUKJ
      KLUCUDUE $.

    $( The converse of the lattice translation of an atom is an atom.
       (Contributed by NM, 9-May-2013.) $)
    ltrncnvat $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ P e. A )
            -> ( `' F ` P ) e. A ) $=
      ( chlt wcel wa w3a ccnv cfv simp3 cbs wb atbase ltrncnvatb syl3an3 mpbid
      eqid ) FMNHENOZDCNZBANZPUIBDQRANZUGUHUISUIUGUHBFTRZNUIUJUAAUKBFUKUFZJUBAU
      KBCDEFHULJKLUCUDUE $.

    $( The converse of the lattice translation of an atom not under the
       fiducial co-atom.  (Contributed by NM, 10-May-2013.) $)
    ltrncnvel $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
              /\ ( P e. A /\ -. P .<_ W ) )
         -> ( ( `' F ` P ) e. A /\ -. ( `' F ` P ) .<_ W ) ) $=
      ( chlt wcel wa wbr wn cfv atbase syl w3a ltrncnvat 3adant3r simp3r cbs wb
      ccnv simp1 simp2 eqid simp1r lhpbase ltrnle syl112anc wf1o ltrn1o 3adant3
      wceq simp3l f1ocnvfv2 syl2anc simp1l hllat latref ltrnval1 breq12d mtbird
      clat bitrd jca ) FMNZHENZOZDCNZBANZBHGPZQZOZUAZBDUGRZANZVTHGPZQVMVNVOWAVQ
      ABCDEFGHIJKLUBUCZVSWBVPVMVNVOVQUDVSWBVTDRZHDRZGPZVPVSVMVNVTFUERZNZHWGNZWB
      WFUFVMVNVRUHZVMVNVRUIZVSWAWHWCAWGVTFWGUJZJSTVSVLWIVKVLVNVRUKWGEFHWLKULTZW
      GCDEFGMHVTHWLIKLUMUNVSWDBWEHGVSWGWGDUOZBWGNZWDBURVMVNWNVRWGCDEFMHWLKLUPUQ
      VSVOWOVMVNVOVQUSAWGBFWLJSTWGWGBDUTVAVSVMVNWIHHGPZWEHURWJWKWMVSFVHNZWIWPVS
      VKWQVKVLVNVRVBFVCTWMWGFGHWLIVDVAWGCDEFGMHHWLIKLVEUNVFVIVGVJ $.

    $( Composition of lattice translations of an atom.  TODO:  See if this can
       shorten some ~ ltrnel uses.  (Contributed by NM, 1-May-2013.)
       (New usage is discouraged.) $)
    ltrncoelN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
           /\ ( P e. A /\ -. P .<_ W ) )
         -> ( ( F ` ( G ` P ) ) e. A /\ -. ( F ` ( G ` P ) ) .<_ W ) ) $=
      ( chlt wcel wa wbr wn cfv ltrnel w3a simp1 simp2l 3adant2l syl3anc ) GNOI
      FOPZDCOZECOZPZBAOBIHQRPZUAUFUGBESZAOUKIHQRPZUKDSZAOUMIHQRPUFUIUJUBUFUGUHU
      JUCUFUHUJULUGABCEFGHIJKLMTUDAUKCDFGHIJKLMTUE $.

    $( Composition of lattice translations of an atom.  TODO:  See if this can
       shorten some ~ ltrnel , ~ ltrnat uses.  (Contributed by NM,
       1-May-2013.) $)
    ltrncoat $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
           /\ P e. A ) -> ( F ` ( G ` P ) ) e. A ) $=
      ( chlt wcel wa w3a cfv simp1 ltrnat simp2l 3adant2l syl3anc ) GNOIFOPZDCO
      ZECOZPZBAOZQUDUEBERZAOZUIDRAOUDUGUHSUDUEUFUHUAUDUFUHUJUEABCEFGHIJKLMTUBAU
      ICDFGHIJKLMTUC $.

    $( Two ways to express value of translation composition.  (Contributed by
       NM, 31-May-2013.) $)
    ltrncoval $p |- ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ G e. T ) /\ P e. A )
    -> ( ( F o. G ) ` P ) = ( F ` ( G ` P ) ) ) $=
      ( chlt wcel wa w3a cbs cfv syl2anc ccom wceq wf1o simp2r eqid ltrn1o f1of
      wf simp1 syl atbase 3ad2ant3 fvco3 ) GNOIFOPZDCOZECOZPZBAOZQZGRSZUTEUHZBU
      TOZBDEUASBESDSUBUSUTUTEUCZVAUSUNUPVCUNUQURUIUNUOUPURUDUTCEFGNIUTUEZLMUFTU
      TUTEUGUJURUNVBUQAUTBGVDKUKULUTUTBDEUMT $.
  $}

  ${
    $d p q F $.  $d p q H $.  $d p q K $.  $d p q T $.  $d p q W $.
    ltrncnv.h $e |- H = ( LHyp ` K ) $.
    ltrncnv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( The converse of a lattice translation is a lattice translation.
       (Contributed by NM, 10-May-2013.) $)
    ltrncnv $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
        -> `' F e. T ) $=
      ( vp vq chlt wcel wa cfv cv wbr wn co wceq eqid syl3anc ccnv cldil cjn wi
      cple cmee catm wral ltrnldil syldan w3a simp1 simp1l simp1r simp2l simp3l
      ldilcnv ltrncnvel syl112anc simp2r simp3r cbs wf1o ltrn1o 3ad2ant1 atbase
      ltrnu syl f1ocnvfv2 syl2anc oveq2d simp1ll ltrncnvat eqtrd oveq1d 3eqtr3d
      hlatjcom 3exp ralrimivv wb isltrn adantr mpbir2and ) DJKZECKZLZBAKZLZBUAZ
      AKZWIEDUBMMZKZHNZEDUEMZOPZINZEWNOPZLZWMWMWIMZDUCMZQZEDUFMZQZWPWPWIMZWTQZE
      XBQZRZUDZIDUGMZUHHXIUHZWFWGBWKKWLWKABCDJEFWKSZGUIWKBCDEFXKUQUJWHXHHIXIXIW
      HWMXIKZWPXIKZLZWRXGWHXNWRUKZWSWSBMZWTQZEXBQZXDXDBMZWTQZEXBQZXCXFXOWHWSXIK
      ZWSEWNOPLZXDXIKZXDEWNOPLZXRYARWHXNWRULXOWFWGXLWOYCWFWGXNWRUMZWFWGXNWRUNZW
      HXLXMWRUOZWHXNWOWQUPXIWMABCDWNEWNSZXISZFGURUSXOWFWGXMWQYEYFYGWHXLXMWRUTZW
      HXNWOWQVAXIWPABCDWNEYIYJFGURUSXIWSXDABCWTDWNXBJEYIWTSZXBSZYJFGVGTXOXQXAEX
      BXOXQWSWMWTQZXAXOXPWMWSWTXODVBMZYOBVCZWMYOKZXPWMRWHXNYPWRYOABCDJEYOSZFGVD
      VEZXOXLYQYHXIYOWMDYRYJVFVHYOYOWMBVIVJVKXOWDYBXLYNXARWDWEWGXNWRVLZXOWFWGXL
      YBYFYGYHXIWMABCDWNEYIYJFGVMTYHXIWTDWSWMYLYJVQTVNVOXOXTXEEXBXOXTXDWPWTQZXE
      XOXSWPXDWTXOYPWPYOKZXSWPRYSXOXMUUBYKXIYOWPDYRYJVFVHYOYOWPBVIVJVKXOWDYDXMU
      UAXERYTXOWFWGXMYDYFYGYKXIWPABCDWNEYIYJFGVMTYKXIWTDXDWPYLYJVQTVNVOVPVRVSWF
      WJWLXJLVTWGXIJWKAWICWTDWNXBEIHYIYLYMYJFXKGWAWBWC $.
  $}

  ${
    $d p q x A $.  $d p q x F $.  $d p q x G $.  $d q x H $.  $d q x K $.
    $d q x T $.  $d q x W $.
    ltrneq2.a $e |- A = ( Atoms ` K ) $.
    ltrneq2.h $e |- H = ( LHyp ` K ) $.
    ltrneq2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Frequently used one-to-one property of lattice translation atoms.
       (Contributed by NM, 5-May-2013.) $)
    ltrn11at $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
       /\ ( P e. A /\ Q e. A /\ P =/= Q ) ) -> ( F ` P ) =/= ( F ` Q ) ) $=
      ( chlt wcel wa wne w3a cfv wceq atbase syl simp33 cbs wb simp1 simp2 eqid
      simp31 simp32 ltrn11 syl112anc necon3bid mpbird ) GLMHFMNZEDMZBAMZCAMZBCO
      ZPZPZBEQZCEQZOUQUMUNUOUPUQUAUSUTVABCUSUMUNBGUBQZMZCVBMZUTVARBCRUCUMUNURUD
      UMUNURUEUSUOVCUMUNUOUPUQUGAVBBGVBUFZISTUSUPVDUMUNUOUPUQUHAVBCGVEISTVBDEFG
      LHBCVEJKUIUJUKUL $.

    $( The equality of two translations is determined by their equality at
       atoms.  (Contributed by NM, 2-Mar-2014.) $)
    ltrneq2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
         -> ( A. p e. A ( F ` p ) = ( G ` p ) <-> F = G ) ) $=
      ( vx chlt wcel cfv wceq wbr wb syl2anc syl3anc vq wa w3a cv wral cbs cple
      wi ccnv wf1o simpl1 simpl3 eqid ltrn1o simpl2 simpr3 ltrncnvat atbase syl
      f1ocnvfv1 simpr2 fveq2 eqeq12d sylc f1ocnvfv2 eqtr3d fveq2d breq1d simpr1
      rspcv breq2d 3bitr4d claut simpl1l ltrnlaut ltrncl lautcnvle syl22anc imp
      3exp2 ralrimdv simpr hlateq sylibd ralrimdva 3adant3 f1ofn 3adant2 eqfnfv
      wfn sylibrd fveq1 ralrimivw impbid1 ) FMNZGENZUBZCBNZDBNZUCZHUDZCOZXADOZP
      ZHAUEZCDPZWTXELUDZCOZXGDOZPZLFUFOZUEZXFWTXEXJLXKWTXGXKNZUBZXEUAUDZXHFUGOZ
      QZXOXIXPQZRZUAAUEZXJXNXEXSUAAWTXMXEXOANZXSUHUHWTXMXEYAXSWTXMXEYAUCZUBZXOC
      UIZOZXHYDOZXPQZXODUIZOZXIYHOZXPQZXQXRYCYEXGXPQYIXGXPQYGYKYCYEYIXGXPYCYEDO
      ZYHOZYEYIYCXKXKDUJZYEXKNZYMYEPYCWQWSYNWQWRWSYBUKZWQWRWSYBULZXKBDEFMGXKUMZ
      JKUNZSZYCYEANZYOYCWQWRYAUUAYPWQWRWSYBUOZWTXMXEYAUPZAXOBCEFXPGXPUMZIJKUQTZ
      AXKYEFYRIURUSXKXKYEDUTSYCYLXOYHYCYECOZYLXOYCUUAXEUUFYLPZUUEWTXMXEYAVAXDUU
      GHYEAXAYEPXBUUFXCYLXAYECVBXAYEDVBVCVJVDYCXKXKCUJZXOXKNZUUFXOPYCWQWRUUHYPU
      UBXKBCEFMGYRJKUNZSZYCYAUUIUUCAXKXOFYRIURUSZXKXKXOCVESVFVGVFVHYCYFXGYEXPYC
      UUHXMYFXGPUUKWTXMXEYAVIZXKXKXGCUTSVKYCYJXGYIXPYCYNXMYJXGPYTUUMXKXKXGDUTSV
      KVLYCWOCFVMOZNZUUIXHXKNZXQYGRWOWPWRWSYBVNZYCWQWRUUOYPUUBBCEUUNFMGJUUNUMZK
      VOSUULYCWQWRXMUUPYPUUBUUMXKBCEFMGXGYRJKVPZTXKCUUNFXPMXOXHYRUUDUURVQVRYCWO
      DUUNNZUUIXIXKNZXRYKRUUQYCWQWSUUTYPYQBDEUUNFMGJUURKVOSUULYCWQWSXMUVAYPYQUU
      MXKBDEFMGXGYRJKVPZTXKDUUNFXPMXOXIYRUUDUURVQVRVLVTVSWAXNWOUUPUVAXTXJRWOWPW
      RWSXMVNXNWQWRXMUUPWQWRWSXMUKZWQWRWSXMUOWTXMWBZUUSTXNWQWSXMUVAUVCWQWRWSXMU
      LUVDUVBTAXKFXPXHXIUAYRUUDIWCTWDWEWTCXKWJZDXKWJZXFXLRWTUUHUVEWQWRUUHWSUUJW
      FXKXKCWGUSWTYNUVFWQWSYNWRYSWHXKXKDWGUSLXKCDWISWKXFXDHAXACDWLWMWN $.
  $}

  ${
    $d p A $.  $d p F $.  $d p G $.  $d p H $.  $d p K $.  $d p T $.  $d p W $.
    ltrne.l $e |- .<_ = ( le ` K ) $.
    ltrne.a $e |- A = ( Atoms ` K ) $.
    ltrne.h $e |- H = ( LHyp ` K ) $.
    ltrne.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( The equality of two translations is determined by their equality at
       atoms not under co-atom ` W ` .  (Contributed by NM, 20-Jun-2013.) $)
    ltrneq $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       -> ( A. p e. A ( -. p .<_ W -> ( F ` p ) = ( G ` p ) ) <-> F = G ) ) $=
      ( chlt wcel wa w3a cfv wceq wi cv wbr wn wral simp11 simp12 eqid 3ad2ant2
      cbs atbase ltrnval1 syl112anc simp13 eqtr4d 3expia pm2.61 re1tbw2 impbid1
      simp3 syl ralbidva ltrneq2 bitrd ) FNOHEOPZCBOZDBOZQZIUAZHGUBZUCZVHCRZVHD
      RZSZTZIAUDVMIAUDCDSVGVNVMIAVGVHAOZPZVNVMVPVIVMTVNVMTVGVOVIVMVGVOVIQZVKVHV
      LVQVDVEVHFUIRZOZVIVKVHSVDVEVFVOVIUEZVDVEVFVOVIUFVOVGVSVIAVRVHFVRUGZKUJUHZ
      VGVOVIUSZVRBCEFGNHVHWAJLMUKULVQVDVFVSVIVLVHSVTVDVEVFVOVIUMWBWCVRBDEFGNHVH
      WAJLMUKULUNUOVIVMUPUTVMVJUQURVAABCDEFHIKLMVBVC $.
  $}

  ${
    $d p q B $.  $d p q H $.  $d p q K $.  $d p q W $.
    idltrn.b $e |- B = ( Base ` K ) $.
    idltrn.h $e |- H = ( LHyp ` K ) $.
    idltrn.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( The identity function is a lattice translation.  Remark below Lemma B in
       [Crawley] p. 112.  (Contributed by NM, 18-May-2012.) $)
    idltrn $p |- ( ( K e. HL /\ W e. H ) -> ( _I |` B ) e. T ) $=
      ( vp vq chlt wcel wa cfv cv wbr co wceq eqid eqtrd cid cres cldil cple wn
      cjn cmee wi catm wral idldil simpll simplrr simprr lhpmat syl12anc atbase
      cp0 fvresi oveq2d simplll hlatjidm syl2anc oveq1d simplrl simprl 3eqtr4rd
      3syl ex ralrimivva isltrn mpbir2and ) DKLZECLZMZUAAUBZBLVPEDUCNNZLIOZEDUD
      NZPUEZJOZEVSPUEZMZVRVRVPNZDUFNZQZEDUGNZQZWAWAVPNZWEQZEWGQZRZUHZJDUINZUJIW
      NUJKAVQCDEFGVQSZUKVOWMIJWNWNVOVRWNLZWAWNLZMZMZWCWLWSWCMZWAEWGQZDURNZWKWHW
      TVOWQWBXAXBRVOWRWCULZVOWPWQWCUMZWSVTWBUNWNWACDVSWGEXBVSSZWGSZXBSZWNSZGUOU
      PWTWJWAEWGWTWJWAWAWEQZWAWTWIWAWAWEWTWQWAALWIWARXDWNAWADFXHUQAWAUSVHUTWTVM
      WQXIWARVMVNWRWCVAZXDWNWEDWAWESZXHVBVCTVDWTWHVREWGQZXBWTWFVREWGWTWFVRVRWEQ
      ZVRWTWDVRVRWEWTWPVRALWDVRRVOWPWQWCVEZWNAVRDFXHUQAVRUSVHUTWTVMWPXMVRRXJXNW
      NWEDVRXKXHVBVCTVDWTVOWPVTXLXBRXCXNWSVTWBVFWNVRCDVSWGEXBXEXFXGXHGUOUPTVGVI
      VJWNKVQBVPCWEDVSWGEJIXEXKXFXHGWOHVKVL $.
  $}

  ${
    ltrnmw.l $e |- .<_ = ( le ` K ) $.
    ltrnmw.m $e |- ./\ = ( meet ` K ) $.
    ltrnmw.z $e |- .0. = ( 0. ` K ) $.
    ltrnmw.a $e |- A = ( Atoms ` K ) $.
    ltrnmw.h $e |- H = ( LHyp ` K ) $.
    ltrnmw.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Property of lattice translation value.  Remark below Lemma B in
       [Crawley] p. 112.  TODO:  Can this be used in more places?  (Contributed
       by NM, 20-May-2012.) $)
    ltrnmw $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
         /\ ( P e. A /\ -. P .<_ W ) ) -> ( ( F ` P ) ./\ W ) = .0. ) $=
      ( wcel cfv wceq syl chlt wa wbr wn w3a cbs simp1 simp2 simp3l eqid atbase
      co simp1r lhpbase ltrnm syl112anc simp3r cal wb hlatl atnle syl3anc mpbid
      simp1l fveq2d eqtr3d clat hllat latref syl2anc ltrnval1 oveq2d cops op0cl
      hlop op0le 3eqtr3d ) FUAQZIEQZUBZDCQZBAQZBIGUCUDZUBZUEZBDRZIDRZHULZJDRZWF
      IHULJWEBIHULZDRZWHWIWEVTWABFUFRZQZIWLQZWKWHSVTWAWDUGZVTWAWDUHZWEWBWMVTWAW
      BWCUIZAWLBFWLUJZNUKTWEVSWNVRVSWAWDUMWLEFIWROUNTZWLCDEFHIBIWRLOPUOUPWEWJJD
      WEWCWJJSZVTWAWBWCUQWEFURQZWBWNWCWTUSWEVRXAVRVSWAWDVDZFUTTWQWSAWLBFGHIJWRK
      LMNVAVBVCVEVFWEWGIWFHWEVTWAWNIIGUCZWGISWOWPWSWEFVGQZWNXCWEVRXDXBFVHTWSWLF
      GIWRKVIVJWLCDEFGUAIIWRKOPVKUPVLWEVTWAJWLQZJIGUCZWIJSWOWPWEFVMQZXEWEVRXGXB
      FVOTZWLFJWRMVNTWEXGWNXFXHWSWLFGIJWRKMVPVJWLCDEFGUAIJWRKOPVKUPVQ $.
  $}

  ${
    $d k d A $.  $d d f k x K $.  $d f k M $.  $d k x S $.  $d k W $.
    dilset.a $e |- A = ( Atoms ` K ) $.
    dilset.s $e |- S = ( PSubSp ` K ) $.
    dilset.w $e |- W = ( WAtoms ` K ) $.
    dilset.m $e |- M = ( PAut ` K ) $.
    dilset.l $e |- L = ( Dil ` K ) $.
    $( The mapping from fiducial atom to set of dilations.  (Contributed by NM,
       30-Jan-2012.)  (New usage is discouraged.) $)
    dilfsetN $p |- ( K e. B -> L = ( d e. A |-> { f e. M | A. x e. S
               ( x C_ ( W ` d ) -> ( f ` x ) = x ) } ) ) $=
      ( cv cfv catm fveq2 syl6eqr vk wcel cvv wceq wi wral crab cmpt elex cdilN
      cwpointsN cpsubsp cpautN fveq1d sseq2d imbi1d raleqbidv rabeqbidv df-dilN
      wss mpteq12dv fvex eqeltri mptex fvmpt syl5eq syl ) FCUBFUCUBZGJBAPZJPZIQ
      ZUTZVIEPQVIUDZUEZADUFZEHUGZUHZUDFCUIVHGFUJQVQOUAFJUAPZRQZVIVJVRUKQZQZUTZV
      MUEZAVRULQZUFZEVRUMQZUGZUHVQUCUJVRFUDZJVSWGBVPWHVSFRQZBVRFRSKTWHWEVOEWFHW
      HWFFUMQHVRFUMSNTWHWCVNAWDDWHWDFULQDVRFULSLTWHWBVLVMWHWAVKVIWHVJVTIWHVTFUK
      QIVRFUKSMTUNUOUPUQURVAAEUAJUSJBVPBWIUCKFRVBVCVDVEVFVG $.

    $d d f x D $.  $d d M $.  $d d S $.  $d d W $.
    $( The set of dilations for a fiducial atom ` D ` .  (Contributed by NM,
       4-Feb-2012.)  (New usage is discouraged.) $)
    dilsetN $p |- ( ( K e. B /\ D e. A ) -> ( L ` D ) = { f e. M | A. x e. S
               ( x C_ ( W ` D ) -> ( f ` x ) = x ) } ) $=
      ( vd wcel cfv cv wss wceq wi wral crab cmpt dilfsetN fveq1d sseq2d imbi1d
      fveq2 ralbidv rabbidv eqid cpautN cvv fvex eqeltri rabex fvmpt sylan9eq )
      GCQZDBQDHRDPBASZPSZJRZTZVBFSRVBUAZUBZAEUCZFIUDZUEZRVBDJRZTZVFUBZAEUCZFIUD
      ZVADHVJABCEFGHIJPKLMNOUFUGPDVIVOBVJVCDUAZVHVNFIVPVGVMAEVPVEVLVFVPVDVKVBVC
      DJUJUHUIUKULVJUMVNFIIGUNRUONGUNUPUQURUSUT $.

    $d f x F $.  $d f S $.  $d f W $.
    $( The predicate "is a dilation".  (Contributed by NM, 4-Feb-2012.)
       (New usage is discouraged.) $)
    isdilN $p |- ( ( K e. B /\ D e. A ) -> ( F e. ( L ` D )
      <-> ( F e. M /\ A. x e. S ( x C_ ( W ` D ) -> ( F ` x ) = x ) ) ) ) $=
      ( vf wcel wa cfv wceq cv wss wral crab dilsetN eleq2d fveq1 eqeq1d imbi2d
      wi ralbidv elrab syl6bb ) GCQDBQRZFDHSZQFAUAZDJSUBZUPPUAZSZUPTZUJZAEUCZPI
      UDZQFIQUQUPFSZUPTZUJZAEUCZRUNUOVCFABCDEPGHIJKLMNOUEUFVBVGPFIURFTZVAVFAEVH
      UTVEUQVHUSVDUPUPURFUGUHUIUKULUM $.
  $}

  ${
    trnset.a $e |- A = ( Atoms ` K ) $.
    trnset.s $e |- S = ( PSubSp ` K ) $.
    trnset.p $e |- .+ = ( +P ` K ) $.
    trnset.o $e |- ._|_ = ( _|_P ` K ) $.
    trnset.w $e |- W = ( WAtoms ` K ) $.
    trnset.m $e |- M = ( PAut ` K ) $.
    trnset.l $e |- L = ( Dil ` K ) $.
    trnset.t $e |- T = ( Trn ` K ) $.
    $d d k A $.  $d d f k q r K $.  $d f k L $.  $d k ._|_ $.  $d k .+ $.
    $d k q r W $.
    $( The mapping from fiducial atom to set of translations.  (Contributed by
       NM, 4-Feb-2012.)  (New usage is discouraged.) $)
    trnfsetN $p |- ( K e. C -> T = ( d e. A
   |-> { f e. ( L ` d ) | A. q e. ( W ` d ) A. r e. ( W ` d )
           ( ( q .+ ( f ` q ) ) i^i ( ._|_ ` { d } ) )
         = ( ( r .+ ( f ` r ) ) i^i ( ._|_ ` { d } ) ) } ) ) $=
      ( vk wcel cvv cv cfv co csn cin wceq wral crab cmpt elex ctrnN catm cpadd
      cpolN cwpointsN cdilN fveq2 syl6eqr ineq12d raleqbidv rabeqbidv mpteq12dv
      fveq1d oveqd eqeq12d df-trnN fvex eqeltri mptex fvmpt syl5eq syl ) GBUDGU
      EUDZENAMUFZVSFUFZUGZCUHZNUFZUIZJUGZUJZLUFZWGVTUGZCUHZWEUJZUKZLWCKUGZULZMW
      LULZFWCHUGZUMZUNZUKGBUOVREGUPUGWQUBUCGNUCUFZUQUGZVSWAWRURUGZUHZWDWRUSUGZU
      GZUJZWGWHWTUHZXCUJZUKZLWCWRUTUGZUGZULZMXIULZFWCWRVAUGZUGZUMZUNWQUEUPWRGUK
      ZNWSXNAWPXOWSGUQUGZAWRGUQVBOVCXOXKWNFXMWOXOWCXLHXOXLGVAUGHWRGVAVBUAVCVHXO
      XJWMMXIWLXOWCXHKXOXHGUTUGKWRGUTVBSVCVHZXOXGWKLXIWLXQXOXDWFXFWJXOXAWBXCWEX
      OWTCVSWAXOWTGURUGCWRGURVBQVCZVIXOWDXBJXOXBGUSUGJWRGUSVBRVCVHZVDXOXEWIXCWE
      XOWTCWGWHXRVIXSVDVJVEVEVFVGFUCLMNVKNAWPAXPUEOGUQVLVMVNVOVPVQ $.

    $d d f q r D $.  $d d L $.  $d d ._|_ $.  $d d .+ $.  $d d W $.
    $( The set of translations for a fiducial atom ` D ` .  (Contributed by NM,
       4-Feb-2012.)  (New usage is discouraged.) $)
    trnsetN $p |- ( ( K e. B /\ D e. A ) -> ( T ` D ) =
      { f e. ( L ` D ) | A. q e. ( W ` D ) A. r e. ( W ` D )
           ( ( q .+ ( f ` q ) ) i^i ( ._|_ ` { D } ) )
         = ( ( r .+ ( f ` r ) ) i^i ( ._|_ ` { D } ) ) } ) $=
      ( vd wcel cfv cv csn cin wceq wral crab cmpt trnfsetN fveq1d fveq2 fveq2d
      co sneq ineq2d eqeq12d raleqbidv rabeqbidv eqid fvex rabex fvmpt sylan9eq
      ) HBUDZCAUDCFUECUCANUFZVIGUFZUEDUQZUCUFZUGZKUEZUHZMUFZVPVJUEDUQZVNUHZUIZM
      VLLUEZUJZNVTUJZGVLIUEZUKZULZUEVKCUGZKUEZUHZVQWGUHZUIZMCLUEZUJZNWKUJZGCIUE
      ZUKZVHCFWEABDEFGHIJKLMNUCOPQRSTUAUBUMUNUCCWDWOAWEVLCUIZWBWMGWCWNVLCIUOWPW
      AWLNVTWKVLCLUOZWPVSWJMVTWKWQWPVOWHVRWIWPVNWGVKWPVMWFKVLCURUPZUSWPVNWGVQWR
      USUTVAVAVBWEVCWMGWNCIVDVEVFVG $.

    $d f q r F $.  $d f ._|_ $.  $d f .+ $.  $d f W $.
    $( The predicate "is a translation".  (Contributed by NM, 4-Feb-2012.)
       (New usage is discouraged.) $)
    istrnN $p |- ( ( K e. B /\ D e. A ) -> ( F e. ( T ` D ) <->
      ( F e. ( L ` D ) /\ A. q e. ( W ` D ) A. r e. ( W ` D )
           ( ( q .+ ( F ` q ) ) i^i ( ._|_ ` { D } ) )
         = ( ( r .+ ( F ` r ) ) i^i ( ._|_ ` { D } ) ) ) ) ) $=
      ( vf wcel wa cfv cv co csn cin wceq wral crab trnsetN eleq2d fveq1 oveq2d
      ineq1d eqeq12d 2ralbidv elrab syl6bb ) HBUDCAUDUEZGCFUFZUDGNUGZVEUCUGZUFZ
      DUHZCUIKUFZUJZMUGZVKVFUFZDUHZVIUJZUKZMCLUFZULNVPULZUCCIUFZUMZUDGVRUDVEVEG
      UFZDUHZVIUJZVKVKGUFZDUHZVIUJZUKZMVPULNVPULZUEVCVDVSGABCDEFUCHIJKLMNOPQRST
      UAUBUNUOVQWGUCGVRVFGUKZVOWFNMVPVPWHVJWBVNWEWHVHWAVIWHVGVTVEDVEVFGUPUQURWH
      VMWDVIWHVLWCVKDVKVFGUPUQURUSUTVAVB $.
  $}

  $c trL $.

  $( Extend class notation with set of all traces of lattice translations. $)
  ctrl $a class trL $.

  ${
    $d k w f x p $.
    $( Define trace of a lattice translation.  (Contributed by NM,
       20-May-2012.) $)
    df-trl $a |- trL = ( k e. _V |-> ( w e. ( LHyp ` k )
     |-> ( f e. ( ( LTrn ` k ) ` w ) |-> ( iota_ x e. ( Base ` k )
        A. p e. ( Atoms ` k ) ( -. p ( le ` k ) w ->
         x = ( ( p ( join ` k ) ( f ` p ) ) ( meet ` k ) w ) ) ) ) ) ) $.
  $}

  ${
    $d k p A $.  $d k x B $.  $d k w H $.  $d k .\/ $.  $d f k p w x K $.
    $d k .<_ $.  $d k ./\ $.  $d k T $.
    trlset.b $e |- B = ( Base ` K ) $.
    trlset.l $e |- .<_ = ( le ` K ) $.
    trlset.j $e |- .\/ = ( join ` K ) $.
    trlset.m $e |- ./\ = ( meet ` K ) $.
    trlset.a $e |- A = ( Atoms ` K ) $.
    trlset.h $e |- H = ( LHyp ` K ) $.
    $( The set of all traces of lattice translations for a lattice ` K ` .
       (Contributed by NM, 20-May-2012.) $)
    trlfset $p |- ( K e. C -> ( trL ` K ) = ( w e. H
     |-> ( f e. ( ( LTrn ` K ) ` w ) |-> ( iota_ x e. B
    A. p e. A ( -. p .<_ w -> x = ( ( p .\/ ( f ` p ) ) ./\ w ) ) ) ) ) ) $=
      ( cfv fveq2 vk wcel cvv ctrl cv cltrn wbr wn wceq wral crio cmpt elex clh
      co wi cple cjn cmee catm syl6eqr fveq1d breqd notbid oveqd eqidd oveq123d
      eqeq2d imbi12d raleqbidv riotaeqbidv mpteq12dv df-trl eqeltri mptex fvmpt
      cbs fvex syl ) IEUBIUCUBIUDSBGFBUEZIUFSZSZLUEZVTJUGZUHZAUEZWCWCFUESZHUOZV
      TKUOZUIZUPZLCUJZADUKZULZULZUIIEUMUAIBUAUEZUNSZFVTWPUFSZSZWCVTWPUQSZUGZUHZ
      WFWCWGWPURSZUOZVTWPUSSZUOZUIZUPZLWPUTSZUJZAWPVQSZUKZULZULWOUCUDWPIUIZBWQX
      MGWNXNWQIUNSZGWPIUNTRVAXNFWSXLWBWMXNVTWRWAWPIUFTVBXNXJWLAXKDXNXKIVQSDWPIV
      QTMVAXNXHWKLXICXNXIIUTSCWPIUTTQVAXNXBWEXGWJXNXAWDXNWTJWCVTXNWTIUQSJWPIUQT
      NVAVCVDXNXFWIWFXNXDWHVTVTXEKXNXEIUSSKWPIUSTPVAXNXCHWCWGXNXCIURSHWPIURTOVA
      VEXNVTVFVGVHVIVJVKVLVLABFUALVMBGWNGXOUCRIUNVRVNVOVPVS $.

    $d w A $.  $d w B $.  $d w .\/ $.  $d w .<_ $.  $d w ./\ $.  $d f w T $.
    $d f p w x W $.
    trlset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlset.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The set of traces of lattice translations for a fiducial co-atom
       ` W ` .  (Contributed by NM, 20-May-2012.) $)
    trlset $p |- ( ( K e. C /\ W e. H ) -> R
       = ( f e. T |-> ( iota_ x e. B
     A. p e. A ( -. p .<_ W -> x = ( ( p .\/ ( f ` p ) ) ./\ W ) ) ) ) ) $=
      ( vw wcel cv cltrn cfv wn co wceq wi wral crio cmpt trlfset fveq1d syl5eq
      wbr ctrl fveq2 breq2 notbid oveq2 eqeq2d imbi12d riotabidv mpteq12dv eqid
      ralbidv fvex mptex fvmpt mpteq12i syl6eqr sylan9eq ) JDUDZMHUDZEMUCHGUCUE
      ZJUFUGZUGZNUEZVRKURZUHZAUEZWAWAGUEUGIUIZVRLUIZUJZUKZNBULZACUMZUNZUNZUGZGF
      WAMKURZUHZWDWEMLUIZUJZUKZNBULZACUMZUNZVPEMJUSUGZUGWMUBVPMXBWLAUCBCDGHIJKL
      NOPQRSTUOUPUQVQWMGMVSUGZWTUNZXAUCMWKXDHWLVRMUJZGVTWJXCWTVRMVSUTXEWIWSACXE
      WHWRNBXEWCWOWGWQXEWBWNVRMWAKVAVBXEWFWPWDVRMWELVCVDVEVIVFVGWLVHGXCWTMVSVJV
      KVLGFWTXCWTUAWTVHVMVNVO $.

    $d f A $.  $d f B $.  $d f p x F $.  $d f .\/ $.  $d f .<_ $.  $d f ./\ $.
    $( The value of the trace of a lattice translation.  (Contributed by NM,
       20-May-2012.) $)
    trlval $p |- ( ( ( K e. V /\ W e. H ) /\ F e. T )
       -> ( R ` F ) = ( iota_ x e. B
        A. p e. A ( -. p .<_ W -> x = ( ( p .\/ ( F ` p ) ) ./\ W ) ) ) ) $=
      ( vf wcel wa cfv cv wbr wn co wceq wi wral crio cmpt trlset fveq1d oveq2d
      fveq1 oveq1d eqeq2d imbi2d ralbidv riotabidv eqid riotaex fvmpt sylan9eq
      ) ILUDMGUDUEZFEUDFDUFFUCENUGZMJUHUIZAUGZVJVJUCUGZUFZHUJZMKUJZUKZULZNBUMZA
      CUNZUOZUFVKVLVJVJFUFZHUJZMKUJZUKZULZNBUMZACUNZVIFDWAABCLDEUCGHIJKMNOPQRST
      UAUBUPUQUCFVTWHEWAVMFUKZVSWGACWIVRWFNBWIVQWEVKWIVPWDVLWIVOWCMKWIVNWBVJHVJ
      VMFUSURUTVAVBVCVDWAVEWGACVFVGVH $.
  $}

  ${
    $d q x A $.  $d q x F $.  $d q x H $.  $d q x .\/ $.  $d q x K $.
    $d q x .<_ $.  $d q x ./\ $.  $d q x P $.  $d q x T $.  $d q x W $.
    trlval2.l $e |- .<_ = ( le ` K ) $.
    trlval2.j $e |- .\/ = ( join ` K ) $.
    trlval2.m $e |- ./\ = ( meet ` K ) $.
    trlval2.a $e |- A = ( Atoms ` K ) $.
    trlval2.h $e |- H = ( LHyp ` K ) $.
    trlval2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlval2.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The value of the trace of a lattice translation, given any atom ` P `
       not under the fiducial co-atom ` W ` .  Note: this requires only the
       weaker assumption ` K e. Lat ` ; we use ` K e. HL ` for convenience.
       (Contributed by NM, 20-May-2012.) $)
    trlval2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( R ` F ) = ( ( P .\/ ( F ` P ) ) ./\ W ) ) $=
      ( wcel wceq vq vx chlt wa clat wbr wn cfv co hllat anim1i w3a cv wral cbs
      crio eqid trlval 3adant3 simp1l simp3l atbase syl ltrncl syld3an3 syl3anc
      wi latjcl simp1r lhpbase latmcl simpl3l simpl3r breq1 notbid fveq2 oveq1d
      id oveq12d eqeq2d imbi12d rspcv com23 simp11 simp12 simp13l simp13r simp3
      sylc simp2 ltrnu syl222anc eqeq2 biimpd 3exp com24 ralrimdv adantr impbid
      riota5 eqtrd syl3an1 ) HUCSZKFSZUDHUESZXDUDZEDSZBASZBKIUFZUGZUDZECUHZBBEU
      HZGUIZKJUIZTXCXEXDHUJUKXFXGXKULZXLUAUMZKIUFZUGZUBUMZXQXQEUHZGUIZKJUIZTZVG
      ZUAAUNZUBHUOUHZUPZXOXFXGXLYHTXKUBAYGCDEFGHIJUEKUAYGUQZLMNOPQRURUSXPYFUBYG
      XOXPXEXNYGSZKYGSZXOYGSXEXDXGXKUTZXPXEBYGSZXMYGSZYJYLXPXHYMXFXGXHXJVAAYGBH
      YIOVBVCZXFXGXKYMYNYOYGDEFHUEKBYIPQVDVEYGGHBXMYIMVHVFXPXDYKXEXDXGXKVIYGFHK
      YIPVJVCYGHJXNKYINVKVFXPXTYGSZUDZYFXTXOTZYQXHXJYFYRVGXHXJXFXGYPVLXHXJXFXGY
      PVMXHYFXJYRYEXJYRVGUABAXQBTZXSXJYDYRYSXRXIXQBKIVNVOYSYCXOXTYSYBXNKJYSXQBY
      AXMGYSVRXQBEVPVSVQVTWAWBWCWIXPYRYFVGYPXPYRYEUAAXPXSXQASZYRYDXPXSYTYRYDVGZ
      XPXSYTULZXOYCTZUUAUUBXFXGXHXJYTXSUUCXFXGXKXSYTWDXFXGXKXSYTWEXHXJXFXGXSYTW
      FXHXJXFXGXSYTWGXPXSYTWHXPXSYTWJABXQDEFGHIJUEKLMNOPQWKWLUUCYRYDXOYCXTWMWNV
      CWOWPWQWRWSWTXAXB $.
  $}

  ${
    trlcl.b $e |- B = ( Base ` K ) $.
    trlcl.h $e |- H = ( LHyp ` K ) $.
    trlcl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlcl.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Closure of the trace of a lattice translation.  (Contributed by NM,
       22-May-2012.) $)
    trlcl $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
                       -> ( R ` F ) e. B ) $=
      ( chlt wcel wa cfv co eqid mpd3an3 ad2antrr syl3anc coc cjn cmee catm wbr
      cple wn wceq lhpocnel adantr trlval2 clat hllat cops hlop ad2antlr opoccl
      lhpbase syl2anc ltrncl latjcl latmcl eqeltrd ) FLMZGEMZNZDCMZNZDBOZGFUAOZ
      OZVKDOZFUBOZPZGFUCOZPZAVFVGVKFUDOZMVKGFUFOZUEUGNZVIVPUHVFVSVGVQEFVRVJGVRQ
      ZVJQZVQQZIUIUJVQVKBCDEVMFVRVOGVTVMQZVOQZWBIJKUKRVHFULMZVNAMZGAMZVPAMVDWEV
      EVGFUMSZVHWEVKAMZVLAMZWFWHVHFUNMZWGWIVDWKVEVGFUOSVEWGVDVGAEFGHIURUPZAFVJG
      HWAUQUSZVFVGWIWJWMACDEFLGVKHIJUTRAVMFVKVLHWCVATWLAFVOVNGHWDVBTVC $.
  $}

  ${
    $d p F $.  $d p H $.  $d p K $.  $d p R $.  $d p T $.  $d p W $.
    trlcnv.h $e |- H = ( LHyp ` K ) $.
    trlcnv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlcnv.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of the converse of a lattice translation.  (Contributed by NM,
       10-May-2013.) $)
    trlcnv $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
                       -> ( R ` `' F ) = ( R ` F ) ) $=
      ( vp chlt wcel wa cfv wbr wn wceq eqid co 3adant3 cple ccnv catm lhpexnle
      cv wrex adantr w3a cjn cmee cbs ltrn1o simp3l atbase syl f1ocnvfv1 oveq2d
      wf1o syl2anc simp1l ltrnat 3adant3r hlatjcom syl3anc eqtrd oveq1d ltrncnv
      simp1 ltrnel trlval2 3eqtr4d 3expa rexlimddv ) EKLZFDLZMZCBLZMJUEZFEUANZO
      PZCUBZANZCANZQZJEUCNZVPVTJWEUFVQWEDEVSFJVSRZWERZGUDUGVPVQVRWELZVTMZWDVPVQ
      WIUHZVRCNZWKWANZEUINZSZFEUJNZSZVRWKWMSZFWOSWBWCWJWNWQFWOWJWNWKVRWMSZWQWJW
      LVRWKWMWJEUKNZWSCURZVRWSLZWLVRQVPVQWTWIWSBCDEKFWSRZGHULTWJWHXAVPVQWHVTUMZ
      WEWSVREXBWGUNUOWSWSVRCUPUSUQWJVNWKWELZWHWRWQQVNVOVQWIUTVPVQWHXDVTWEVRBCDE
      VSFWFWGGHVAVBXCWEWMEWKVRWMRZWGVCVDVEVFWJVPWABLZXDWKFVSOPMWBWPQVPVQWIVHVPV
      QXFWIBCDEFGHVGTWEVRBCDEVSFWFWGGHVIWEWKABWADWMEVSWOFWFXEWORZWGGHIVJVDWEVRA
      BCDWMEVSWOFWFXEXGWGGHIVJVKVLVM $.
  $}

  ${
    trljat.l $e |- .<_ = ( le ` K ) $.
    trljat.j $e |- .\/ = ( join ` K ) $.
    trljat.a $e |- A = ( Atoms ` K ) $.
    trljat.h $e |- H = ( LHyp ` K ) $.
    trljat.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trljat.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The value of a translation of an atom ` P ` not under the fiducial
       co-atom ` W ` , joined with trace.  Equation above Lemma C in [Crawley]
       p. 112.  Todo: shorten with ~ atmod3i1 ?  (Contributed by NM,
       22-May-2012.) $)
    trljat1 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( P .\/ ( R ` F ) ) = ( P .\/ ( F ` P ) ) ) $=
      ( wcel cfv co wceq chlt wa wbr wn w3a cmee eqid trlval2 oveq1d cbs simp1l
      hllat syl simp3l atbase trlcl 3adant3 latjcom syl3anc cp1 ltrncl syld3an3
      clat latjcl simp1r lhpbase latlej1 atmod2i1 syl131anc lhpjat1 3adant2 col
      oveq2d hlol olm11 syl2anc 3eqtrrd 3eqtr4d ) HUAQZJFQZUBZEDQZBAQZBJIUCUDZU
      BZUEZECRZBGSZBBERZGSZJHUFRZSZBGSZBWGGSZWJWFWGWLBGABCDEFGHIWKJKLWKUGZMNOPU
      HUIWFHVCQZBHUJRZQZWGWQQZWNWHTWFVSWPVSVTWBWEUKZHULUMZWFWCWRWAWBWCWDUNZAWQB
      HWQUGZMUOUMZWAWBWSWEWQCDEFHJXCNOPUPUQWQGHBWGXCLURUSWFWMWJJBGSZWKSZWJHUTRZ
      WKSZWJWFVSWCWJWQQZJWQQZBWJIUCZWMXFTWTXBWFWPWRWIWQQZXIXAXDWAWBWEWRXLXDWQDE
      FHUAJBXCNOVAVBZWQGHBWIXCLVDUSZWFVTXJVSVTWBWEVEWQFHJXCNVFUMWFWPWRXLXKXAXDX
      MWQGHIBWIXCKLVGUSAWQBGHIWKWJJXCKLWOMVHVIWFXEXGWJWKWAWEXEXGTWBABXGFGHIJKLX
      GUGZMNVJVKVMWFHVLQZXIXHWJTWFVSXPWTHVNUMXNWQXGHWKWJXCWOXOVOVPVQVR $.

    $( The value of a translation of an atom ` P ` not under the fiducial
       co-atom ` W ` , joined with trace.  Equation above Lemma C in [Crawley]
       p. 112.  (Contributed by NM, 25-May-2012.) $)
    trljat2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( ( F ` P ) .\/ ( R ` F ) ) = ( P .\/ ( F ` P ) ) ) $=
      ( wcel cfv co wceq chlt wa wbr wn w3a cmee cp1 cbs simp1l ltrnat 3adant3r
      clat hllat simp3l atbase simp1 simp2 ltrncl syl3anc latjcl simp1r lhpbase
      eqid latlej2 atmod2i1 syl131anc ltrnel lhpjat1 syl21anc oveq2d hlol olm11
      syl col syl2anc 3eqtrrd trlval2 oveq1d trlcl latjcom 3eqtr2rd ) HUAQZJFQZ
      UBZEDQZBAQZBJIUCUDZUBZUEZBBERZGSZWKJHUFRZSZWJGSZECRZWJGSZWJWOGSZWIWNWKJWJ
      GSZWLSZWKHUGRZWLSZWKWIWBWJAQZWKHUHRZQZJXCQZWJWKIUCZWNWSTWBWCWEWHUIZWDWEWF
      XBWGABDEFHIJKMNOUJUKWIHULQZBXCQZWJXCQZXDWIWBXHXGHUMVMZWIWFXIWDWEWFWGUNAXC
      BHXCVCZMUOVMZWIWDWEXIXJWDWEWHUPZWDWEWHUQZXMXCDEFHUAJBXLNOURUSZXCGHBWJXLLU
      TUSZWIWCXEWBWCWEWHVAZXCFHJXLNVBVMWIXHXIXJXFXKXMXPXCGHIBWJXLKLVDUSAXCWJGHI
      WLWKJXLKLWLVCZMVEVFWIWRWTWKWLWIWBWCXBWJJIUCUDUBWRWTTXGXRABDEFHIJKMNOVGAWJ
      WTFGHIJKLWTVCZMNVHVIVJWIHVNQZXDXAWKTWIWBYAXGHVKVMXQXCWTHWLWKXLXSXTVLVOVPW
      IWOWMWJGABCDEFGHIWLJKLXSMNOPVQVRWIXHWOXCQZXJWPWQTXKWIWDWEYBXNXOXCCDEFHJXL
      NOPVSVOXPXCGHWOWJXLLVTUSWA $.

    $( The value of a translation of an atom ` P ` not under the fiducial
       co-atom ` W ` , joined with trace.  Equation above Lemma C in [Crawley]
       p. 112.  (Contributed by NM, 22-May-2012.) $)
    trljat3 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( P .\/ ( R ` F ) ) = ( ( F ` P ) .\/ ( R ` F ) ) ) $=
      ( wcel wa cfv co chlt wbr wn w3a trljat1 trljat2 eqtr4d ) HUAQJFQREDQBAQB
      JIUBUCRUDBECSZGTBBESZGTUIUHGTABCDEFGHIJKLMNOPUEABCDEFGHIJKLMNOPUFUG $.
  $}

  ${
    trlat.l $e |- .<_ = ( le ` K ) $.
    trlat.a $e |- A = ( Atoms ` K ) $.
    trlat.h $e |- H = ( LHyp ` K ) $.
    trlat.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlat.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( If an atom differs from its translation, the trace is an atom.  Equation
       above Lemma C in [Crawley] p. 112.  (Contributed by NM, 23-May-2012.) $)
    trlat $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
       /\ ( F e. T /\ ( F ` P ) =/= P ) ) -> ( R ` F ) e. A ) $=
      ( wcel wa cfv wne co eqid chlt wbr w3a cjn cmee wceq simp1 simp3l trlval2
      wn simp2 syl3anc simp2l ltrnat simp3r necomd lhpat syl112anc eqeltrd ) GU
      AOIFOPZBAOZBIHUBUJZPZEDOZBEQZBRZPZUCZECQZBVEGUDQZSIGUEQZSZAVHUTVDVCVIVLUF
      UTVCVGUGZUTVCVDVFUHZUTVCVGUKZABCDEFVJGHVKIJVJTZVKTZKLMNUIULVHUTVCVEAOZBVE
      RVLAOVMVOVHUTVDVAVRVMVNUTVAVBVGUMABDEFGHIJKLMUNULVHVEBUTVCVDVFUOUPABVEFVJ
      GHVKIJVPVQKLUQURUS $.
  $}

  ${
    trl0.l $e |- .<_ = ( le ` K ) $.
    trl0.z $e |- .0. = ( 0. ` K ) $.
    trl0.a $e |- A = ( Atoms ` K ) $.
    trl0.h $e |- H = ( LHyp ` K ) $.
    trl0.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trl0.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( If an atom not under the fiducial co-atom ` W ` equals its lattice
       translation, the trace of the translation is zero.  (Contributed by NM,
       24-May-2012.) $)
    trl0 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
       /\ ( F e. T /\ ( F ` P ) = P ) ) -> ( R ` F ) = .0. ) $=
      ( wcel cfv wceq co chlt wa wbr wn w3a cjn cmee simp1 simp3l simp2 trlval2
      syl3anc simp3r oveq2d simp1l simp2l hlatjidm syl2anc oveq1d lhpmat 3eqtrd
      eqid eqtrd ) GUAQZIFQZUBZBAQZBIHUCUDZUBZEDQZBERZBSZUBZUEZECRZBVKGUFRZTZIG
      UGRZTZBIVRTZJVNVFVJVIVOVSSVFVIVMUHZVFVIVJVLUIVFVIVMUJZABCDEFVPGHVRIKVPVBZ
      VRVBZMNOPUKULVNVQBIVRVNVQBBVPTZBVNVKBBVPVFVIVJVLUMUNVNVDVGWEBSVDVEVIVMUOV
      FVGVHVMUPAVPGBWCMUQURVCUSVNVFVIVTJSWAWBABFGHVRIJKWDLMNUTURVA $.
  $}

  ${
    $d p A $.  $d p F $.  $d p H $.  $d p K $.  $d p R $.  $d p T $.  $d p W $.
    $d p .0. $.
    trl0a.z $e |- .0. = ( 0. ` K ) $.
    trl0a.a $e |- A = ( Atoms ` K ) $.
    trl0a.h $e |- H = ( LHyp ` K ) $.
    trl0a.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trl0a.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of a lattice translation is an atom or zero.  (Contributed by
       NM, 5-May-2013.) $)
    trlator0 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
              -> ( ( R ` F ) e. A \/ ( R ` F ) = .0. ) ) $=
      ( vp wcel wa cfv wceq wn wne chlt cv cple wbr wrex eqid lhpexnle ad2antrr
      df-ne simplll simpr simpllr simplr adantr trl0 syl112anc ex necon3d trlat
      mpd rexlimddv syl5bir orrd orcomd ) FUAOGEOPZDCOZPZDBQZHRZVHAOZVGVIVJVISV
      HHTZVGVJVHHUIVGVKVJVGVKPZNUBZGFUCQZUDSZVJNAVEVONAUEVFVKAEFVNGNVNUFZJKUGUH
      VLVMAOVOPZPZVEVQVFVMDQZVMTZVJVEVFVKVQUJZVLVQUKVEVFVKVQULZVRVKVTVGVKVQUMVR
      VSVMVHHVRVSVMRZVIVRWCPVEVQVFWCVIVRVEWCWAUNVLVQWCUMVRVFWCWBUNVRWCUKAVMBCDE
      FVNGHVPIJKLMUOUPUQURUTAVMBCDEFVNGVPJKLMUSUPVAUQVBVCVD $.

    $( The trace of a lattice translation is an atom iff it is nonzero.
       (Contributed by NM, 14-Jun-2013.) $)
    trlatn0 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
              -> ( ( R ` F ) e. A <-> ( R ` F ) =/= .0. ) ) $=
      ( chlt wcel wa cfv wne cal hlatl ad3antrrr atn0 sylancom ex wceq trlator0
      ord necon1ad impbid ) FNOZGEOZPDCOZPZDBQZAOZUNHRZUMUOUPUMUOFSOZUPUJUQUKUL
      UOFTUAAUNFHIJUBUCUDUMUOUNHUMUOUNHUEABCDEFGHIJKLMUFUGUHUI $.
  $}

  ${
    $d p A $.  $d p B $.  $d p F $.  $d p H $.  $d p K $.  $d p R $.  $d p T $.
    $d p W $.
    trlnidat.b $e |- B = ( Base ` K ) $.
    trlnidat.a $e |- A = ( Atoms ` K ) $.
    trlnidat.h $e |- H = ( LHyp ` K ) $.
    trlnidat.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlnidat.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of a lattice translation other than the identity is an atom.
       Remark above Lemma C in [Crawley] p. 112.  (Contributed by NM,
       23-May-2012.) $)
    trlnidat $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ F =/= ( _I |` B ) ) -> ( R ` F ) e. A ) $=
      ( vp chlt wcel wa wne w3a cfv cid cres cv cple wbr wn wrex ltrnnid simp11
      eqid simp2 simp3l simp12 simp3r trlat syl122anc rexlimdv3a mpd ) GOPHFPQZ
      EDPZEUABUBRZSZNUCZHGUDTZUEUFZVCETVCRZQZNAUGECTAPZABDEFGVDHNIVDUJZJKLUHVBV
      GVHNAVBVCAPZVGSUSVJVEUTVFVHUSUTVAVJVGUIVBVJVGUKVBVJVEVFULUSUTVAVJVGUMVBVJ
      VEVFUNAVCCDEFGVDHVIJKLMUOUPUQUR $.
  $}

  ${
    ltrnnidn.b $e |- B = ( Base ` K ) $.
    ltrnnidn.l $e |- .<_ = ( le ` K ) $.
    ltrnnidn.a $e |- A = ( Atoms ` K ) $.
    ltrnnidn.h $e |- H = ( LHyp ` K ) $.
    ltrnnidn.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( If a lattice translation is not the identity, then the translation of
       any atom not under the fiducial co-atom ` W ` is different from the
       atom.  Remark above Lemma C in [Crawley] p. 112.  (Contributed by NM,
       24-May-2012.) $)
    ltrnnidn $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ F =/= ( _I |` B ) )
         /\ ( P e. A /\ -. P .<_ W ) ) -> ( F ` P ) =/= P ) $=
      ( wcel wa wne cfv eqid wceq chlt cid cres wbr wn w3a cp0 cal simp1l hlatl
      ctrl syl simp1 simp2l simp2r trlnidat syl3anc atn0 syl2anc simpl1 simpl2l
      simpl3 simpr trl0 syl112anc ex necon3d mpd ) GUAOZIFOZPZEDOZEUBBUCQZPZCAO
      CIHUDUEPZUFZEIGUKRRZRZGUGRZQZCERZCQVPGUHOZVRAOZVTVPVIWBVIVJVNVOUIGUJULVPV
      KVLVMWCVKVNVOUMVKVLVMVOUNVKVLVMVOUOABVQDEFGIJLMNVQSZUPUQAVRGVSVSSZLURUSVP
      WACVRVSVPWACTZVRVSTZVPWFPVKVOVLWFWGVKVNVOWFUTVKVNVOWFVBVLVMVKVOWFVAVPWFVC
      ACVQDEFGHIVSKWELMNWDVDVEVFVGVH $.

    $( Property of the identity lattice translation.  (Contributed by NM,
       27-May-2012.) $)
    ltrnideq $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
   /\ ( P e. A /\ -. P .<_ W ) ) -> ( F = ( _I |` B ) <-> ( F ` P ) = P ) ) $=
      ( wcel wa wceq cfv simpr ex chlt wbr wn w3a cid cres fveq1d atbase fvresi
      simpl3l 3syl eqtrd simpl1 simpl2 simpl3 ltrnnidn syl121anc necon4d impbid
      wne ) GUAOIFOPZEDOZCAOZCIHUBUCZPZUDZEUEBUFZQZCERZCQZVFVHVJVFVHPZVICVGRZCV
      KCEVGVFVHSUGVKVCCBOVLCQVCVDVAVBVHUJABCGJLUHBCUIUKULTVFEVGVICVFEVGUTZVICUT
      ZVFVMPVAVBVMVEVNVAVBVEVMUMVAVBVEVMUNVFVMSVAVBVEVMUOABCDEFGHIJKLMNUPUQTURU
      S $.
  $}

  ${
    $d p B $.  $d p H $.  $d p K $.  $d p R $.  $d p W $.  $d p .0. $.
    trlid0.b $e |- B = ( Base ` K ) $.
    trlid0.z $e |- .0. = ( 0. ` K ) $.
    trlid0.h $e |- H = ( LHyp ` K ) $.
    trlid0.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of the identity translation is zero.  (Contributed by NM,
       11-Jun-2013.) $)
    trlid0 $p |- ( ( K e. HL /\ W e. H )
             -> ( R ` ( _I |` B ) ) = .0. ) $=
      ( vp chlt wcel wa cv cple cfv wbr wceq eqid cid cres lhpexnle cltrn simpl
      wn catm simpr idltrn adantr wb ltrnideq syl3anc mpbii syl112anc rexlimddv
      trl0 ) DLMECMNZKOZEDPQZRUFZUAAUBZBQFSZKDUGQZVDCDUTEKUTTZVDTZIUCURUSVDMVAN
      ZNZURVGVBEDUDQQZMZUSVBQUSSZVCURVGUEZURVGUHZURVJVGAVICDEGIVITZUIUJZVHVBVBS
      ZVKVBTVHURVJVGVPVKUKVLVOVMVDAUSVIVBCDUTEGVEVFIVNULUMUNVDUSBVIVBCDUTEFVEHV
      FIVNJUQUOUP $.
  $}

  ${
    $d p A $.  $d p B $.  $d p F $.  $d p H $.  $d p K $.  $d p R $.  $d p T $.
    $d p W $.
    trlnidatb.b $e |- B = ( Base ` K ) $.
    trlnidatb.a $e |- A = ( Atoms ` K ) $.
    trlnidatb.h $e |- H = ( LHyp ` K ) $.
    trlnidatb.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlnidatb.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( A lattice translation is not the identity iff its trace is an atom.
       TODO:  Can proofs be reorganized so this goes with ~ trlnidat ?  Why do
       both this and ~ ltrnideq need ~ trlnidat ?  (Contributed by NM,
       4-Jun-2013.) $)
    trlnidatb $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
        -> ( F =/= ( _I |` B ) <-> ( R ` F ) e. A ) ) $=
      ( vp wcel wa wne cfv 3expia wceq chlt cid cres trlnidat cv cple wbr wn wi
      wrex eqid lhpexnle adantr wb ltrnideq 3expa cp0 simp1l simp2 simp1r simp3
      w3a trl0 syl112anc cal simplll hlatl atn0 ex 3syl necon2bd syld rexlimddv
      sylbid necon2ad impbid ) GUAOZHFOZPZEDOZPZEUBBUCZQZECRZAOZVSVTWCWEABCDEFG
      HIJKLMUDSWAWEEWBWANUEZHGUFRZUGUHZEWBTZWEUHZUINAVSWHNAUJVTAFGWGHNWGUKZJKUL
      UMWAWFAOWHPZPZWIWFERWFTZWJVSVTWLWIWNUNABWFDEFGWGHIWKJKLUOUPWMWNWDGUQRZTZW
      JWAWLWNWPWAWLWNVBVSWLVTWNWPVSVTWLWNURWAWLWNUSVSVTWLWNUTWAWLWNVAAWFCDEFGWG
      HWOWKWOUKZJKLMVCVDSWMWEWDWOWMVQGVEOZWEWDWOQZUIVQVRVTWLVFGVGWRWEWSAWDGWOWQ
      JVHVIVJVKVLVNVMVOVP $.
  $}

  ${
    trlid0b.b $e |- B = ( Base ` K ) $.
    trlid0b.z $e |- .0. = ( 0. ` K ) $.
    trlid0b.h $e |- H = ( LHyp ` K ) $.
    trlid0b.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlid0b.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( A lattice translation is the identity iff its trace is zero.
       (Contributed by NM, 14-Jun-2013.) $)
    trlid0b $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
        -> ( F = ( _I |` B ) <-> ( R ` F ) = .0. ) ) $=
      ( chlt wcel wa cid cres cfv wne catm trlnidatb trlatn0 bitrd necon4bid
      eqid ) FNOGEOPDCOPZDQARZDBSZHUGDUHTUIFUASZOUIHTUJABCDEFGIUJUFZKLMUBUJBCDE
      FGHJUKKLMUCUDUE $.
  $}

  ${
    trlnid.b $e |- B = ( Base ` K ) $.
    trlnid.h $e |- H = ( LHyp ` K ) $.
    trlnid.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlnid.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Different translations with the same trace cannot be the identity.
       (Contributed by NM, 26-Jul-2013.) $)
    trlnid $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
        /\ ( F =/= G /\ ( R ` F ) = ( R ` G ) ) )
        -> F =/= ( _I |` B ) ) $=
      ( wcel wa wne cfv wceq wb trlid0b syl2anc chlt w3a cid cres simp3l simp2l
      cp0 eqid biimpar simp3r eqeq1d biimpa simpl1 simpl2r mpbird eqtr4d sylbid
      simp1 ex necon3d mpd ) GUAMHFMNZDCMZECMZNZDEOZDBPZEBPZQZNZUBZVFDUCAUDZOVB
      VEVFVIUEVKDVLDEVKDVLQZVGGUGPZQZDEQZVKVBVCVMVORVBVEVJURVBVCVDVJUFABCDFGHVN
      IVNUHZJKLSTZVKVOVPVKVONZDVLEVKVMVOVRUIVSEVLQZVHVNQZVKVOWAVKVGVHVNVBVEVFVI
      UJUKULVSVBVDVTWARVBVEVJVOUMVCVDVBVJVOUNABCEFGHVNIVQJKLSTUOUPUSUQUTVA $.
  $}

  ${
    ltrn2eq.l $e |- .<_ = ( le ` K ) $.
    ltrn2eq.a $e |- A = ( Atoms ` K ) $.
    ltrn2eq.h $e |- H = ( LHyp ` K ) $.
    ltrn2eq.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Property of the equality of a lattice translation with its value.
       (Contributed by NM, 27-May-2012.) $)
    ltrn2ateq $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
    /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) ) )
        -> ( ( F ` P ) = P <-> ( F ` Q ) = Q ) ) $=
      ( wcel wa wbr wn cfv wceq wb chlt w3a cres eqid ltrnideq 3adant3r3 bitr3d
      cid cbs 3adant3r2 ) GUANIFNOZEDNZBANBIHPQOZCANCIHPQOZUBOEUHGUIRZUCSZBERBS
      ZCERCSZUKULUMUPUQTUNAUOBDEFGHIUOUDZJKLMUEUFUKULUNUPURTUMAUOCDEFGHIUSJKLMU
      EUJUG $.

    $( If any atom (under ` W ` ) is not equal to its translation, so is any
       other atom.  (Contributed by NM, 6-May-2013.) $)
    ltrnateq $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
    /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F ` P ) = P ) -> ( F ` Q ) = Q ) $=
      ( chlt wcel wa wbr wn cfv wceq w3a ltrn2ateq biimp3a ) GNOIFOPEDOBAOBIHQR
      PCAOCIHQRPUABESBTCESCTABCDEFGHIJKLMUBUC $.

    $( If any atom (under ` W ` ) is not equal to its translation, so is any
       other atom.  TODO: ` -. P .<_ W ` isn't needed to prove this.  Will
       removing it shorten (and not lengthen) proofs using it?  (Contributed by
       NM, 6-May-2013.) $)
    ltrnatneq $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
    /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F ` P ) =/= P ) -> ( F ` Q ) =/= Q ) $=
      ( chlt wcel wa wbr wn cfv wne w3a ltrn2ateq necon3bid biimp3a ) GNOIFOPZE
      DOBAOBIHQRPCAOCIHQRPUAZBESZBTCESZCTUEUFPUGBUHCABCDEFGHIJKLMUBUCUD $.

    $( If the value of an atom equals the atom in a non-identity translation,
       the atom is under the fiducial hyperplane.  (Contributed by NM,
       15-May-2013.) $)
    ltrnatlw $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
    /\ ( P e. A /\ -. P .<_ W ) /\ Q e. A )
    /\ ( ( F ` P ) =/= P /\ ( F ` Q ) = Q ) ) -> Q .<_ W ) $=
      ( wcel wa wbr wn w3a cfv wne chlt wceq simp3r simpl21 simpl22 simpl23 jca
      simpl1 simpr simpl3l ltrnatneq syl131anc ex necon4bd mpd ) GUANIFNOZEDNZB
      ANBIHPQOZCANZRZBESBTZCESZCUBZOZRZVCCIHPZUPUTVAVCUCVEVFVBCVEVFQZVBCTZVEVGO
      ZUPUQURUSVGOVAVHUPUTVDVGUHUQURUSUPVDVGUDUQURUSUPVDVGUEVIUSVGUQURUSUPVDVGU
      FVEVGUIUGVAVCUPUTVGUJABCDEFGHIJKLMUKULUMUNUO $.
  $}

  ${
    trlle.l $e |- .<_ = ( le ` K ) $.
    trlle.h $e |- H = ( LHyp ` K ) $.
    trlle.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlle.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of a lattice translation is less than the fiducial co-atom
       ` W ` .  (Contributed by NM, 25-May-2012.) $)
    trlle $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
         -> ( R ` F ) .<_ W ) $=
      ( chlt wcel wa cfv co wbr eqid mpd3an3 ad2antrr coc cjn cmee catm wn wceq
      lhpocnel adantr trlval2 clat cbs hllat cops hlop lhpbase ad2antlr syl2anc
      opoccl ltrncl latjcl syl3anc latmle2 eqbrtrd ) ELMZGDMZNZCBMZNZCAOZGEUAOZ
      OZVKCOZEUBOZPZGEUCOZPZGFVFVGVKEUDOZMVKGFQUENZVIVPUFVFVRVGVQDEFVJGHVJRZVQR
      ZIUGUHVQVKABCDVMEFVOGHVMRZVORZVTIJKUISVHEUJMZVNEUKOZMZGWDMZVPGFQVDWCVEVGE
      ULTZVHWCVKWDMZVLWDMZWEWGVHEUMMZWFWHVDWJVEVGEUNTVEWFVDVGWDDEGWDRZIUOUPZWDE
      VJGWKVSURUQZVFVGWHWIWMWDBCDELGVKWKIJUSSWDVMEVKVLWKWAUTVAWLWDEFVOVNGWKHWBV
      BVAVC $.
  $}

  ${
    trlne.l $e |- .<_ = ( le ` K ) $.
    trlne.a $e |- A = ( Atoms ` K ) $.
    trlne.h $e |- H = ( LHyp ` K ) $.
    trlne.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlne.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of a lattice translation is not equal to any atom not under
       the fiducial co-atom ` W ` .  Part of proof of Lemma C in [Crawley]
       p. 112.  (Contributed by NM, 25-May-2012.) $)
    trlne $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ ( P e. A /\ -. P .<_ W ) ) -> P =/= ( R ` F ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wne simp3r wceq 3adant3 syl5ibrcom necon3bd
      trlle breq1 mpd ) GOPIFPQZEDPZBAPZBIHRZSZQZTZUOBECUAZUBUKULUMUOUCUQUNBURU
      QUNBURUDURIHRZUKULUSUPCDEFGHIJLMNUHUEBURIHUIUFUGUJ $.

    $( The atom not under the fiducial co-atom ` W ` is not less than the trace
       of a lattice translation.  Part of proof of Lemma C in [Crawley]
       p. 112.  (Contributed by NM, 26-May-2012.) $)
    trlnle $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
        /\ ( P e. A /\ -. P .<_ W ) ) -> -. P .<_ ( R ` F ) ) $=
      ( wcel wa wbr wn cfv wceq chlt w3a cp0 cal simpl1l hlatl syl simpl3l eqid
      atnle0 syl2anc simpl1 simpl3 simpl2 simpr trl0 syl112anc breq2d wne trlne
      mtbird adantr wb trlat atncmp syl3anc mpbird pm2.61dane ) GUAOZIFOZPZEDOZ
      BAOZBIHQRZPZUBZBECSZHQZRZBESZBVPVTBTZPZVRBGUCSZHQZWBGUDOZVMWDRWBVIWEVIVJV
      LVOWAUEGUFZUGVMVNVKVLWAUHABGHWCJWCUIZKUJUKWBVQWCBHWBVKVOVLWAVQWCTVKVLVOWA
      ULVKVLVOWAUMVKVLVOWAUNVPWAUOABCDEFGHIWCJWGKLMNUPUQURVAVPVTBUSZPZVSBVQUSZV
      PWJWHABCDEFGHIJKLMNUTVBWIWEVMVQAOZVSWJVCWIVIWEVIVJVLVOWHUEWFUGVMVNVKVLWHU
      HWIVKVOVLWHWKVKVLVOWHULVKVLVOWHUMVKVLVOWHUNVPWHUOABCDEFGHIJKLMNVDUQABVQGH
      JKVEVFVGVH $.
  $}

  ${
    trlval3.l $e |- .<_ = ( le ` K ) $.
    trlval3.j $e |- .\/ = ( join ` K ) $.
    trlval3.m $e |- ./\ = ( meet ` K ) $.
    trlval3.a $e |- A = ( Atoms ` K ) $.
    trlval3.h $e |- H = ( LHyp ` K ) $.
    trlval3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlval3.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The value of the trace of a lattice translation in terms of 2 atoms.
       TODO:  Try to shorten proof.  (Contributed by NM, 3-May-2013.) $)
    trlval3 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
       /\ ( P .\/ ( F ` P ) ) =/= ( Q .\/ ( F ` Q ) ) ) )
    -> ( R ` F ) = ( ( P .\/ ( F ` P ) ) ./\ ( Q .\/ ( F ` Q ) ) ) ) $=
      ( wcel chlt wa wbr wn cfv co wne w3a wceq cp0 simpl1 simpl31 simpl2 simpr
      eqid trl0 syl112anc simpl33 cal simpl1l hlatl syl oveq2d simp31l hlatjidm
      adantr syl2anc eqtrd eqeltrd simp1 simp2 simp31 simp32 ltrn2ateq syl13anc
      biimpa simp32l atnem0 syl3anc mpbid eqtr4d trlval2 clat cbs hllat hlatjcl
      wb ltrnat simpl1r lhpbase latmle1 eqbrtrd simpl32 trlcl latlem12 mpbi2and
      trlat latmcl atlen0 syl31anc neneqd 2atmat0 syl33anc ord atcmp pm2.61dane
      wo mt3d ) IUATZLGTZUBZFETZBATZBLJUCUDZUBZCATZCLJUCUDZUBZBBFUEZHUFZCCFUEZH
      UFZUGZUHZUHZFDUEZXTYBKUFZUIZXSBYEXSBUIZUBZYFIUJUEZYGYJXKXOXLYIYFYKUIXKXLY
      DYIUKXOXRYCXKXLYIULXKXLYDYIUMYEYIUNZABDEFGIJLYKMYKUOZPQRSUPUQYJYCYGYKUIZX
      OXRYCXKXLYIURYJIUSTZXTATYBATYCYNWGYJXIYOXIXJXLYDYIUTZIVAZVBYJXTBAYJXTBBHU
      FZBYJXSBBHYLVCYJXIXMYRBUIYPYEXMYIXMXNXRYCXKXLVDZVFZAHIBNPVEVGVHYTVIYJYBCA
      YJYBCCHUFZCYJYACCHYEYIYACUIZYEXKXLXOXRYIUUBWGXKXLYDVJXKXLYDVKXKXLXOXRYCVL
      XKXLXOXRYCVMABCEFGIJLMPQRVNVOVPVCYJXIXPUUACUIYPYEXPYIXPXQXOYCXKXLVQZVFZAH
      ICNPVEVGVHUUDVIAXTYBIKYKOYMPVRVSVTWAYEXSBUGZUBZYFYGJUCZYHUUFYFXTJUCZYFYBJ
      UCZUUGUUFYFXTLKUFZXTJUUFXKXLXOYFUUJUIXKXLYDUUEUKZXKXLYDUUEUMZXOXRYCXKXLUU
      EULZABDEFGHIJKLMNOPQRSWBVSUUFIWCTZXTIWDUEZTZLUUOTZUUJXTJUCUUFXIUUNXIXJXLY
      DUUEUTZIWEVBZUUFXIXMXSATZUUPUURYEXMUUEYSVFZUUFXKXLXMUUTUUKUULUVAABEFGIJLM
      PQRWHVSZAUUOHIBXSUUOUOZNPWFVSZUUFXJUUQXIXJXLYDUUEWIUUOGILUVCQWJVBZUUOIJKX
      TLUVCMOWKVSWLUUFYFYBLKUFZYBJUUFXKXLXRYFUVFUIUUKUULXOXRYCXKXLUUEWMACDEFGHI
      JKLMNOPQRSWBVSUUFUUNYBUUOTZUUQUVFYBJUCUUSUUFXIXPYAATZUVGUURYEXPUUEUUCVFZU
      UFXKXLXPUVHUUKUULUVIACEFGIJLMPQRWHVSZAUUOHICYAUVCNPWFVSZUVEUUOIJKYBLUVCMO
      WKVSWLUUFUUNYFUUOTZUUPUVGUUHUUIUBUUGWGUUSUUFXKXLUVLUUKUULUUODEFGILUVCQRSW
      NVGUVDUVKUUOIJKYFXTYBUVCMOWOVOWPZUUFYOYFATZYGATZUUGYHWGUUFXIYOUURYQVBZUUF
      XKXOXLUUEUVNUUKUUMUULYEUUEUNABDEFGIJLMPQRSWQUQZUUFUVOYNUUFYGYKUUFYOYGUUOT
      ZUVNUUGYGYKUGUVPUUFUUNUUPUVGUVRUUSUVDUVKUUOIKXTYBUVCOWRVSUVQUVMAUUOYFIJYG
      YKUVCMYMPWSWTXAUUFUVOYNUUFXIXMUUTXPUVHYCUVOYNXGUURUVAUVBUVIUVJXOXRYCXKXLU
      UEURABXSCYAHIKYKNOYMPXBXCXDXHAYFYGIJMPXEVSVTXF $.

    $( The value of the trace of a lattice translation in terms of 2 atoms.
       (Contributed by NM, 3-May-2013.) $)
    trlval4 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
       /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ -. ( R ` F ) .<_ ( P .\/ Q ) ) )
    -> ( R ` F ) = ( ( P .\/ ( F ` P ) ) ./\ ( Q .\/ ( F ` Q ) ) ) ) $=
      ( wcel chlt wa wbr wn w3a wne cfv wceq simp1 simp21 simp22 simp23 simpl1l
      simp3r simp23l adantr simpl1 simpl21 ltrnat syl3anc simpl22 trljat1 simpr
      co hlatlej1 eqtrd breqtrrd wi simpl3r cp0 simpll1 eqid trl0 syl112anc cal
      cbs hlatl syl simp22l hlatjcl atl0le syl2anc eqbrtrd necon3bd mpd simpl3l
      ex trlat necomd hlatexch1 syl131anc trlval3 syl113anc ) IUATZLGTZUBZFETZB
      ATZBLJUCUDZUBZCATZCLJUCUDZUBZUEZBCUFZFDUGZBCHVDZJUCZUDZUBZUEZWPWQWTXCBBFU
      GZHVDZCCFUGZHVDZUFZXFXMXOKVDUHWPXDXJUIWPWQWTXCXJUJWPWQWTXCXJUKWPWQWTXCXJU
      LXKXIXPWPXDXEXIUNXKXHXMXOXKXMXOUHZXHXKXQUBZCBXFHVDZJUCZXHXRCXOXSJXRWNXAXN
      ATZCXOJUCWNWOXDXJXQUMZXKXAXQXAXBWQWTWPXJUOUPZXRWPWQXAYAWPXDXJXQUQZWQWTXCW
      PXJXQURZYCACEFGIJLMPQRUSUTACXNHIJMNPVEUTXRXSXMXOXRWPWQWTXSXMUHYDYEWQWTXCW
      PXJXQVAZABDEFGHIJLMNPQRSVBUTXKXQVCVFVGXRWNXAXFATZWRCBUFXTXHVHYBYCXRWPWTWQ
      XLBUFZYGYDYFYEXRXIYHXEXIWPXDXQVIXRXHXLBXRXLBUHZXHXRYIUBZXFIVJUGZXGJYJWPWT
      WQYIXFYKUHWPXDXJXQYIVKXRWTYIYFUPXRWQYIYEUPXRYIVCABDEFGIJLYKMYKVLZPQRSVMVN
      XRYKXGJUCZYIXRIVOTZXGIVPUGZTZYMXRWNYNYBIVQVRXRWNWRXAYPYBXKWRXQWRWSWQXCWPX
      JVSUPZYCAYOHIBCYOVLZNPVTUTYOIJXGYKYRMYLWAWBUPWCWGWDWEABDEFGIJLMPQRSWHVNYQ
      XRBCXEXIWPXDXQWFWIACXFBHIJMNPWJWKWEWGWDWEABCDEFGHIJKLMNOPQRSWLWM $.

    $( The value of the trace of a lattice translation in terms of itself.
       (Contributed by NM, 19-Jul-2013.) $)
    trlval5 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
       /\ ( P e. A /\ -. P .<_ W ) )
    -> ( R ` F ) = ( ( P .\/ ( R ` F ) ) ./\ W ) ) $=
      ( wcel co chlt wa wbr wn w3a cfv trlval2 trljat1 oveq1d eqtr4d ) HUASKFSU
      BEDSBASBKIUCUDUBUEZECUFZBBEUFGTZKJTBULGTZKJTABCDEFGHIJKLMNOPQRUGUKUNUMKJA
      BCDEFGHIKLMOPQRUHUIUJ $.
  $}

  ${
    arglem1.j $e |- .\/ = ( join ` K ) $.
    arglem1.m $e |- ./\ = ( meet ` K ) $.
    arglem1.a $e |- A = ( Atoms ` K ) $.
    arglem1.f $e |- F = ( ( P .\/ Q ) ./\ ( S .\/ T ) ) $.
    arglem1.g $e |- G = ( ( P .\/ S ) ./\ ( Q .\/ T ) ) $.
    $( Lemma for Desargues' law.  Theorem 13.3 of [Crawley] p. 110, 3rd and 4th
       lines from bottom.  In these lemmas, ` P ` , ` Q ` , ` R ` , ` S ` ,
       ` T ` , ` U ` , ` C ` , ` D ` , ` E ` , ` F ` , and ` G ` represent
       Crawley's a_0, a_1, a_2, b_0, b_1, b_2, c, z_0, z_1, z_2, and p
       respectively.  (Contributed by NM, 28-Jun-2012.)
       (New usage is discouraged.) $)
    arglem1N $p |- ( ( ( ( K e. HL /\ P e. A /\ Q e. A ) /\ ( S e. A /\ T e. A
         /\ P =/= Q ) /\ ( P =/= S /\ Q =/= T /\ S =/= T ) ) /\ G e. A )
            -> F e. A ) $=
      ( wcel w3a wne co syl chlt wa clpl cfv clat cbs wceq simpl11 simpl12 eqid
      hllat atbase simpl13 simpl21 simpl22 latj4 syl122anc simpr syl5eqelr clln
      wb simpl31 syl31anc simpl32 2llnmj syl3anc eqeltrd simpl23 simpl33 mpbird
      llni2 mpbid syl5eqel ) IUAPZBAPZCAPZQZDAPZEAPZBCRZQZBDRZCERZDERZQZQZGAPZU
      BZFBCHSZDEHSZJSZANWHWKAPZWIWJHSZIUCUDZPZWHWMBDHSZCEHSZHSZWNWHIUEPZBIUFUDZ
      PZCWTPZDWTPZEWTPZWMWRUGWHVNWSVNVOVPWAWEWGUHZIUKTWHVOXAVNVOVPWAWEWGUIZAWTB
      IWTUJZMULTWHVPXBVNVOVPWAWEWGUMZAWTCIXGMULTWHVRXCVRVSVTVQWEWGUNZAWTDIXGMUL
      TWHVSXDVRVSVTVQWEWGUOZAWTEIXGMULTWTHIEBCDXGKUPUQWHWPWQJSZAPZWRWNPZWHXKGAO
      WFWGURUSWHVNWPIUTUDZPZWQXNPZXLXMVAXEWHVNVOVRWBXOXEXFXIWBWCWDVQWAWGVBABDHI
      XNKMXNUJZVKVCWHVNVPVSWCXPXEXHXJWBWCWDVQWAWGVDACEHIXNKMXQVKVCAWNHIJXNWPWQK
      LMXQWNUJZVEVFVLVGWHVNWIXNPZWJXNPZWLWOVAXEWHVNVOVPVTXSXEXFXHVRVSVTVQWEWGVH
      ABCHIXNKMXQVKVCWHVNVRVSWDXTXEXIXJWBWCWDVQWAWGVIADEHIXNKMXQVKVCAWNHIJXNWIW
      JKLMXQXRVEVFVJVM $.
  $}

  ${
    cdlemc1.b $e |- B = ( Base ` K ) $.
    cdlemc1.l $e |- .<_ = ( le ` K ) $.
    cdlemc1.j $e |- .\/ = ( join ` K ) $.
    cdlemc1.m $e |- ./\ = ( meet ` K ) $.
    cdlemc1.a $e |- A = ( Atoms ` K ) $.
    cdlemc1.h $e |- H = ( LHyp ` K ) $.
    $( Part of proof of Lemma C in [Crawley] p. 112.  TODO: shorten with
       ~ atmod3i1 ?  (Contributed by NM, 29-May-2012.) $)
    cdlemc1 $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B
          /\ ( P e. A /\ -. P .<_ W ) )
        -> ( P .\/ ( ( P .\/ X ) ./\ W ) ) = ( P .\/ X ) ) $=
      ( wcel co wceq syl chlt wa wbr w3a clat simp1l hllat simp3l atbase latjcl
      wn simp2 syl3anc simp1r lhpbase latmcl latjcom latlej1 atmod2i1 syl131anc
      cp1 cfv eqid lhpjat1 3adant2 oveq2d col hlol olm11 syl2anc eqtrd 3eqtrd )
      FUAQZIDQZUBZJBQZCAQZCIGUCUKZUBZUDZCCJERZIHRZERZWBCERZWAICERZHRZWAVTFUEQZC
      BQZWBBQZWCWDSVTVMWGVMVNVPVSUFZFUGTZVTVQWHVOVPVQVRUHZABCFKOUITZVTWGWABQZIB
      QZWIWKVTWGWHVPWNWKWMVOVPVSULZBEFCJKMUJUMZVTVNWOVMVNVPVSUNBDFIKPUOTZBFHWAI
      KNUPUMBEFCWBKMUQUMVTVMVQWNWOCWAGUCZWDWFSWJWLWQWRVTWGWHVPWSWKWMWPBEFGCJKLM
      URUMABCEFGHWAIKLMNOUSUTVTWFWAFVAVBZHRZWAVTWEWTWAHVOVSWEWTSVPACWTDEFGILMWT
      VCZOPVDVEVFVTFVGQZWNXAWASVTVMXCWJFVHTWQBWTFHWAKNXBVIVJVKVL $.
  $}

  ${
    cdlemc2.l $e |- .<_ = ( le ` K ) $.
    cdlemc2.j $e |- .\/ = ( join ` K ) $.
    cdlemc2.m $e |- ./\ = ( meet ` K ) $.
    cdlemc2.a $e |- A = ( Atoms ` K ) $.
    cdlemc2.h $e |- H = ( LHyp ` K ) $.
    cdlemc2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Part of proof of Lemma C in [Crawley] p. 112.  (Contributed by NM,
       25-May-2012.) $)
    cdlemc2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) ) )
        -> ( F ` Q ) .<_ ( ( F ` P ) .\/ ( ( P .\/ Q ) ./\ W ) ) ) $=
      ( wcel wbr syl3anc chlt wa wn w3a cfv simp1l simp3ll simp3rl hlatlej2 cbs
      co wceq simp1 eqid atbase syl simp3l cdlemc1 breqtrrd wb simp2 clat hllat
      latjcl simp1r lhpbase latmcl ltrnle syl112anc mpbid ltrnj ltrnval1 oveq2d
      latmle2 eqtrd breqtrd ) HUARZKFRZUBZEDRZBARZBKISUCZUBZCARZCKISUCZUBZUBZUD
      ZCEUEZBBCGUKZKJUKZGUKZEUEZBEUEZWKGUKZIWHCWLISZWIWMISZWHCWJWLIWHVQWAWDCWJI
      SVQVRVTWGUFZWAWBWFVSVTUGZWDWEWCVSVTUHZABCGHILMOUITWHVSCHUJUEZRZWCWLWJULVS
      VTWGUMZWHWDXBWTAXACHXAUNZOUOUPZVSVTWCWFUQAXABFGHIJKCXDLMNOPURTUSWHVSVTXBW
      LXARZWPWQUTXCVSVTWGVAZXEWHHVBRZBXARZWKXARZXFWHVQXHWRHVCUPZWHWAXIWSAXABHXD
      OUOUPZWHXHWJXARZKXARZXJXKWHXHXIXBXMXKXLXEXAGHBCXDMVDTZWHVRXNVQVRVTWGVEXAF
      HKXDPVFUPZXAHJWJKXDNVGTZXAGHBWKXDMVDTXADEFHIUAKCWLXDLPQVHVIVJWHWMWNWKEUEZ
      GUKZWOWHVSVTXIXJWMXSULXCXGXLXQXADEFGHKBWKXDMPQVKVIWHXRWKWNGWHVSVTXJWKKISZ
      XRWKULXCXGXQWHXHXMXNXTXKXOXPXAHIJWJKXDLNVNTXADEFHIUAKWKXDLPQVLVIVMVOVP $.
  $}

  ${
    cdlemc3.l $e |- .<_ = ( le ` K ) $.
    cdlemc3.j $e |- .\/ = ( join ` K ) $.
    cdlemc3.m $e |- ./\ = ( meet ` K ) $.
    cdlemc3.a $e |- A = ( Atoms ` K ) $.
    cdlemc3.h $e |- H = ( LHyp ` K ) $.
    cdlemc3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemc3.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Part of proof of Lemma C in [Crawley] p. 113.  (Contributed by NM,
       26-May-2012.) $)
    cdlemc3 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) ) )
        -> ( ( F ` P ) .<_ ( Q .\/ ( R ` F ) )
          -> Q .<_ ( P .\/ ( F ` P ) ) ) ) $=
      ( wcel chlt wa wbr wn w3a cfv co cbs simpll simpr1 simpr2l ltrnat syl3anc
      simpl simpr3l eqid trlcl syldan ltrnel 3adant3r3 trlnle hlexch2 syl131anc
      wi wceq trljat2 breq2d sylibd ) IUATZLGTZUBZFETZBATZBLJUCUDZUBZCATZCLJUCU
      DZUBZUEZUBZBFUFZCFDUFZHUGJUCZCWAWBHUGZJUCZCBWAHUGZJUCVTVIWAATZVPWBIUHUFZT
      ZWAWBJUCUDZWCWEVDVIVJVSUIVTVKVLVMWGVKVSUNZVKVLVOVRUJZVMVNVLVRVKUKABEFGIJL
      MPQRULUMVPVQVLVOVKUOVKVSVLWIWLWHDEFGILWHUPZQRSUQURVTVKVLWGWALJUCUDUBZWJWK
      WLVKVLVOWNVRABEFGIJLMPQRUSUTAWADEFGIJLMPQRSVAUMAWHWACHIJWBWMMNPVBVCVTWDWF
      CJVKVLVOWDWFVEVRABDEFGHIJLMNPQRSVFUTVGVH $.

    $( Part of proof of Lemma C in [Crawley] p. 113.  (Contributed by NM,
       26-May-2012.) $)
    cdlemc4 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
             /\ -. Q .<_ ( P .\/ ( F ` P ) ) )
        -> ( Q .\/ ( R ` F ) )
               =/= ( ( F ` P ) .\/ ( ( P .\/ Q ) ./\ W ) ) ) $=
      ( wcel chlt wa wbr wn w3a cfv co wne wceq clat cbs simpll hllat syl simpl
      simpr1 simpr2l eqid atbase ltrncl syl3anc simpr3l hlatjcl ad2antlr latmcl
      lhpbase latlej1 breq2 syl5ibrcom cdlemc3 syld necon3bd 3impia ) IUATZLGTZ
      UBZFETZBATZBLJUCUDZUBZCATZCLJUCUDZUBZUEZCBBFUFZHUGJUCZUDCFDUFHUGZWEBCHUGZ
      LKUGZHUGZUHVPWDUBZWFWGWJWKWGWJUIZWEWGJUCZWFWKWMWLWEWJJUCZWKIUJTZWEIUKUFZT
      ZWIWPTZWNWKVNWOVNVOWDULZIUMUNZWKVPVQBWPTZWQVPWDUOVPVQVTWCUPWKVRXAVRVSVQWC
      VPUQZAWPBIWPURZPUSUNWPEFGIUALBXCQRUTVAWKWOWHWPTZLWPTZWRWTWKVNVRWAXDWSXBWA
      WBVQVTVPVBAWPHIBCXCNPVCVAVOXEVNWDWPGILXCQVFVDWPIKWHLXCOVEVAWPHIJWEWIXCMNV
      GVAWGWJWEJVHVIABCDEFGHIJKLMNOPQRSVJVKVLVM $.

    $( Lemma for ~ cdlemc .  (Contributed by NM, 26-May-2012.) $)
    cdlemc5 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
             /\ ( -. Q .<_ ( P .\/ ( F ` P ) ) /\ ( F ` P ) =/= P ) )
  -> ( F ` Q ) = ( ( Q .\/ ( R ` F ) )
         ./\ ( ( F ` P ) .\/ ( ( P .\/ Q ) ./\ W ) ) ) ) $=
      ( wcel chlt wa wbr wn w3a cfv wne wceq simp1l simp23l simp1 simp21 ltrnat
      co syl3anc hlatlej2 simp23 trljat1 breqtrrd simp22 cdlemc2 syl112anc clat
      cbs wb hllat syl eqid atbase ltrncl syl2anc latjcl simp22l hlatjcl simp1r
      trlcl lhpbase latmcl latlem12 syl13anc mpbi2and cal hlatl clln cp0 simp3r
      trlat trlle simp23r nbrne2 necomd syl31anc hlatlej1 simp3l latmle2 ltrnel
      llni2 lhpat simprd cdlemc4 3adant3r atlen0 2llnmat syl32anc atcmp mpbid )
      IUATZLGTZUBZFETZBATZBLJUCUDZUBZCATZCLJUCUDZUBZUEZCBBFUFZHUNZJUCUDZXRBUGZU
      BZUEZCFUFZCFDUFZHUNZXRBCHUNZLKUNZHUNZKUNZJUCZYDYJUHZYCYDYFJUCZYDYIJUCZYKY
      CYDCYDHUNZYFJYCXGXNYDATZYDYOJUCXGXHXQYBUIZXNXOXJXMXIYBUJZYCXIXJXNYPXIXQYB
      UKZXIXJXMXPYBULZYRACEFGIJLMPQRUMUOZACYDHIJMNPUPUOYCXIXJXPYFYOUHYSYTXIXJXM
      XPYBUQZACDEFGHIJLMNPQRSURUOUSYCXIXJXMXPYNYSYTXIXJXMXPYBUTZUUBABCEFGHIJKLM
      NOPQRVAVBYCIVCTZYDIVDUFZTZYFUUETZYIUUETZYMYNUBYKVEYCXGUUDYQIVFVGZYCXIXJCU
      UETZUUFYSYTYCXNUUJYRAUUECIUUEVHZPVIVGZUUEEFGIUALCUUKQRVJUOYCUUDUUJYEUUETZ
      UUGUUIUULYCXIXJUUMYSYTUUEDEFGILUUKQRSVPVKUUEHICYEUUKNVLUOZYCUUDXRUUETZYHU
      UETZUUHUUIYCXIXJBUUETZUUOYSYTYCXKUUQXKXLXJXPXIYBVMZAUUEBIUUKPVIVGUUEEFGIU
      ALBUUKQRVJUOYCUUDYGUUETZLUUETZUUPUUIYCXGXKXNUUSYQUURYRAUUEHIBCUUKNPVNUOZY
      CXHUUTXGXHXQYBVOUUEGILUUKQVQVGZUUEIKYGLUUKOVRUOUUEHIXRYHUUKNVLUOZUUEIJKYD
      YFYIUUKMOVSVTWAZYCIWBTZYPYJATZYKYLVEYCXGUVEYQIWCVGZUUAYCXGYFIWDUFZTZYIUVH
      TZYFYIUGZYJIWEUFZUGZUVFYQYCXGXNYEATZCYEUGZUVIYQYRYCXIXMXJYAUVNYSUUCYTXIXQ
      XTYAWFABDEFGIJLMPQRSWGVBYCYELJUCZXOUVOYCXIXJUVPYSYTDEFGIJLMQRSWHVKXNXOXJX
      MXIYBWIUVPXOUBYECYECLJWJWKVKACYEHIUVHNPUVHVHZWQWLYCXGXRATZYHATZXRYHUGZUVJ
      YQYCXIXJXKUVRYSYTUURABEFGIJLMPQRUMUOZYCXIXMXNBCUGZUVSYSUUCYRYCBXSJUCZXTUW
      BYCXGXKUVRUWCYQUURUWAABXRHIJMNPWMUOXIXQXTYAWNBCXSJWJVKABCGHIJKLMNOPQWRVBY
      CYHLJUCZXRLJUCUDZUVTYCUUDUUSUUTUWDUUIUVAUVBUUEIJKYGLUUKMOWOUOYCXIXJXMUWEY
      SYTUUCXIXJXMUEUVRUWEABEFGIJLMPQRWPWSUOUWDUWEUBYHXRYHXRLJWJWKVKAXRYHHIUVHN
      PUVQWQWLXIXQXTUVKYAABCDEFGHIJKLMNOPQRSWTXAYCUVEYJUUETZYPYKUVMUVGYCUUDUUGU
      UHUWFUUIUUNUVCUUEIKYFYIUUKOVRUOUUAUVDAUUEYDIJYJUVLUUKMUVLVHZPXBWLAIKUVHYF
      YIUVLOUWGPUVQXCXDAYDYJIJMPXEUOXF $.

    $( Lemma for ~ cdlemc .  (Contributed by NM, 26-May-2012.) $)
    cdlemc6 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
             /\ ( F ` P ) = P )
  -> ( F ` Q ) = ( ( Q .\/ ( R ` F ) )
         ./\ ( ( F ` P ) .\/ ( ( P .\/ Q ) ./\ W ) ) ) ) $=
      ( co chlt wcel wa wbr wn w3a wceq simp1l simp22l simp23l hlatjcom syl3anc
      cfv oveq2d clat cbs hllat syl eqid atbase latabs2 eqtrd cp0 simp22 simp21
      simp1 simp3 trl0 syl112anc col hlol syl2anc oveq1d hlatjcl simp1r lhpbase
      olj01 latmcl latjcom cp1 hlatlej1 atmod2i1 syl131anc lhpjat1 olm11 3eqtrd
      syl21anc oveq12d ltrnateq 3eqtr4rd ) IUAUBZLGUBZUCZFEUBZBAUBZBLJUDUEZUCZC
      AUBZCLJUDUEZUCZUFZBFUMZBUGZUFZCBCHTZKTZCCFDUMZHTZXBXELKTZHTZKTCFUMXDXFCCB
      HTZKTZCXDXEXKCKXDWKWOWRXEXKUGWKWLXAXCUHZWOWPWNWTWMXCUIZWRWSWNWQWMXCUJZAHI
      BCNPUKULUNXDIUOUBZCIUPUMZUBZBXQUBZXLCUGXDWKXPXMIUQURZXDWRXRXOAXQCIXQUSZPU
      TURZXDWOXSXNAXQBIYAPUTURZXQHIKCBYANOVAULVBXDXHCXJXEKXDXHCIVCUMZHTZCXDXGYD
      CHXDWMWQWNXCXGYDUGWMXAXCVFWMWNWQWTXCVDZWMWNWQWTXCVEWMXAXCVGZABDEFGIJLYDMY
      DUSZPQRSVHVIUNXDIVJUBZXRYECUGXDWKYIXMIVKURZYBXQHICYDYANYHVQVLVBXDXJBXIHTZ
      XIBHTZXEXDXBBXIHYGVMXDXPXSXIXQUBZYKYLUGXTYCXDXPXEXQUBZLXQUBZYMXTXDWKWOWRY
      NXMXNXOAXQHIBCYANPVNULZXDWLYOWKWLXAXCVOZXQGILYAQVPURZXQIKXELYAOVRULXQHIBX
      IYANVSULXDYLXELBHTZKTZXEIVTUMZKTZXEXDWKWOYNYOBXEJUDZYLYTUGXMXNYPYRXDWKWOW
      RUUCXMXNXOABCHIJMNPWAULAXQBHIJKXELYAMNOPWBWCXDYSUUAXEKXDWKWLWQYSUUAUGXMYQ
      YFABUUAGHIJLMNUUAUSZPQWDWGUNXDYIYNUUBXEUGYJYPXQUUAIKXEYAOUUDWEVLWFWFWHABC
      EFGIJLMPQRWIWJ $.

    $( Lemma C in [Crawley] p. 113.  (Contributed by NM, 26-May-2012.) $)
    cdlemc $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
             /\ -. Q .<_ ( P .\/ ( F ` P ) ) )
   -> ( F ` Q ) = ( ( Q .\/ ( R ` F ) )
       ./\ ( ( F ` P ) .\/ ( ( P .\/ Q ) ./\ W ) ) ) ) $=
      ( co chlt wcel wa wbr wn w3a cfv wceq simpl1 simpl2 simpr cdlemc6 syl3anc
      wne simpl3 cdlemc5 syl112anc pm2.61dane ) IUAUBLGUBUCZFEUBBAUBBLJUDUEUCCA
      UBCLJUDUEUCUFZCBBFUGZHTJUDUEZUFZCFUGCFDUGHTVABCHTLKTHTKTUHZVABVCVABUHZUCU
      SUTVEVDUSUTVBVEUIUSUTVBVEUJVCVEUKABCDEFGHIJKLMNOPQRSULUMVCVABUNZUCUSUTVBV
      FVDUSUTVBVFUIUSUTVBVFUJUSUTVBVFUOVCVFUKABCDEFGHIJKLMNOPQRSUPUQUR $.
  $}

  ${
    cdlemd1.l $e |- .<_ = ( le ` K ) $.
    cdlemd1.j $e |- .\/ = ( join ` K ) $.
    cdlemd1.m $e |- ./\ = ( meet ` K ) $.
    cdlemd1.a $e |- A = ( Atoms ` K ) $.
    cdlemd1.h $e |- H = ( LHyp ` K ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       29-May-2012.) $)
    cdlemd1 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                 /\ ( R e. A /\ P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) )
        -> R = ( ( P .\/ ( ( P .\/ R ) ./\ W ) )
             ./\ ( Q .\/ ( ( Q .\/ R ) ./\ W ) ) ) ) $=
      ( wcel wa co wceq syl3anc chlt wbr wne w3a simpll simpr1l simpr2l simpr31
      simpr32 simpr33 2llnma2 syl132anc clat cbs cfv hllat ad2antrr eqid atbase
      wn syl latjcom simpl simpr1 cdlemc1 eqtr4d simpr2 oveq12d eqtr3d ) GUAPZJ
      EPZQZBAPZBJHUBUTZQZCAPZCJHUBUTZQZDAPZBCUCZDBCFRHUBUTZUDZUDZQZDBFRZDCFRZIR
      ZDBBDFRZJIRFRZCCDFRZJIRFRZIRWDVJVMVPVSVTWAWGDSVJVKWCUEVMVNVRWBVLUFZVPVQVO
      WBVLUGZVSVTWAVOVRVLUHZVSVTWAVOVRVLUIVSVTWAVOVRVLUJABCDFGHIKLMNUKULWDWEWIW
      FWKIWDWEWHWIWDGUMPZDGUNUOZPZBWPPZWEWHSVJWOVKWCGUPUQZWDVSWQWNAWPDGWPURZNUS
      VAZWDVMWRWLAWPBGWTNUSVAWPFGDBWTLVBTWDVLWQVOWIWHSVLWCVCZXAVLVOVRWBVDAWPBEF
      GHIJDWTKLMNOVETVFWDWFWJWKWDWOWQCWPPZWFWJSWSXAWDVPXCWMAWPCGWTNUSVAWPFGDCWT
      LVBTWDVLWQVRWKWJSXBXAVLVOVRWBVGAWPCEFGHIJDWTKLMNOVETVFVHVI $.
  $}

  ${
    cdlemd2.l $e |- .<_ = ( le ` K ) $.
    cdlemd2.j $e |- .\/ = ( join ` K ) $.
    cdlemd2.a $e |- A = ( Atoms ` K ) $.
    cdlemd2.h $e |- H = ( LHyp ` K ) $.
    cdlemd2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       29-May-2012.) $)
    cdlemd2 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) /\ R e. A )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                 /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) )
          /\ ( ( F ` P ) = ( G ` P ) /\ ( F ` Q ) = ( G ` Q ) ) )
        -> ( F ` R ) = ( G ` R ) ) $=
      ( wcel co cfv chlt wa w3a wbr wn wne wceq cmee simp3l simp11 simp12l clat
      cbs simp11l hllat syl simp21l simp13 eqid hlatjcl syl3anc simp11r lhpbase
      latmcl latmle2 simp12r eqtr4d oveq12d atbase ltrnj 3eqtr4d simp3r simp22l
      ltrnval1 latjcl ltrnm simp21 simp22 simp23l simp23r 3jca cdlemd1 syl13anc
      syl112anc fveq2d ) JUARZLHRZUBZFERZGERZUBZDARZUCZBARZBLKUDUEZUBZCARZCLKUD
      UEZUBZBCUFZDBCISKUDUEZUBZUCZBFTZBGTZUGZCFTZCGTZUGZUBZUCZBBDISZLJUHTZSZISZ
      CCDISZLXMSZISZXMSZFTZXSGTZDFTDGTXKXOFTZXRFTZXMSZXOGTZXRGTZXMSZXTYAXKYBYEY
      CYFXMXKXDXNFTZISZXEXNGTZISZYBYEXKXDXEYHYJIWMXCXFXIUIXKYHXNYJXKWHWIXNJUMTZ
      RZXNLKUDZYHXNUGWHWKWLXCXJUJZWIWJWHWLXCXJUKZXKJULRZXLYLRZLYLRZYMXKWFYQWFWG
      WKWLXCXJUNZJUOUPZXKWFWNWLYRYTWNWOWSXBWMXJUQZWHWKWLXCXJURZAYLIJBDYLUSZNOUT
      VAZXKWGYSWFWGWKWLXCXJVBYLHJLUUDPVCUPZYLJXMXLLUUDXMUSZVDVAZXKYQYRYSYNUUAUU
      EUUFYLJKXMXLLUUDMUUGVEVAZYLEFHJKUALXNUUDMPQVNWDXKWHWJYMYNYJXNUGYOWIWJWHWL
      XCXJVFZUUHUUIYLEGHJKUALXNUUDMPQVNWDVGVHXKWHWIBYLRZYMYBYIUGYOYPXKWNUUKUUBA
      YLBJUUDOVIUPZUUHYLEFHIJLBXNUUDNPQVJWDXKWHWJUUKYMYEYKUGYOUUJUULUUHYLEGHIJL
      BXNUUDNPQVJWDVKXKXGXQFTZISZXHXQGTZISZYCYFXKXGXHUUMUUOIWMXCXFXIVLXKUUMXQUU
      OXKWHWIXQYLRZXQLKUDZUUMXQUGYOYPXKYQXPYLRZYSUUQUUAXKWFWQWLUUSYTWQWRWPXBWMX
      JVMZUUCAYLIJCDUUDNOUTVAZUUFYLJXMXPLUUDUUGVDVAZXKYQUUSYSUURUUAUVAUUFYLJKXM
      XPLUUDMUUGVEVAZYLEFHJKUALXQUUDMPQVNWDXKWHWJUUQUURUUOXQUGYOUUJUVBUVCYLEGHJ
      KUALXQUUDMPQVNWDVGVHXKWHWICYLRZUUQYCUUNUGYOYPXKWQUVDUUTAYLCJUUDOVIUPZUVBY
      LEFHIJLCXQUUDNPQVJWDXKWHWJUVDUUQYFUUPUGYOUUJUVEUVBYLEGHIJLCXQUUDNPQVJWDVK
      VHXKWHWIXOYLRZXRYLRZXTYDUGYOYPXKYQUUKYMUVFUUAUULUUHYLIJBXNUUDNVOVAZXKYQUV
      DUUQUVGUUAUVEUVBYLIJCXQUUDNVOVAZYLEFHJXMLXOXRUUDUUGPQVPWDXKWHWJUVFUVGYAYG
      UGYOUUJUVHUVIYLEGHJXMLXOXRUUDUUGPQVPWDVKXKDXSFXKWHWPWSWLWTXAUCDXSUGYOWMWP
      WSXBXJVQWMWPWSXBXJVRXKWLWTXAUUCWTXAWPWSWMXJVSWTXAWPWSWMXJVTWAABCDHIJKXMLM
      NUUGOPWBWCZWEXKDXSGUVJWEVK $.
  $}

  ${
    cdlemd3.l $e |- .<_ = ( le ` K ) $.
    cdlemd3.j $e |- .\/ = ( join ` K ) $.
    cdlemd3.a $e |- A = ( Atoms ` K ) $.
    cdlemd3.h $e |- H = ( LHyp ` K ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  The ` R =/= P `
       requirement is not mentioned in their proof.  (Contributed by NM,
       29-May-2012.) $)
    cdlemd3 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                 /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ R =/= P ) )
          /\ ( R e. A /\ S e. A /\ -. S .<_ ( P .\/ Q ) ) )
              -> -. R .<_ ( P .\/ S ) ) $=
      ( wcel wa wbr w3a syl atbase chlt wne simp33 simp1l simp31 simp32 simp21l
      wn co wi simp233 hlatexch1 syl131anc simp22l hlatlej1 syl3anc simp232 cbs
      clat cfv wb hllat eqid latjcl latjle12 syl13anc mpbi2and mpan2d syld mtod
      lattr ) HUAOZJFOZPZBAOZBJIQUHZPZCAOZCJIQUHZPZBCUBZDBCGUIZIQZDBUBZRZRZDAOZ
      EAOZEWBIQZUHZRZRZDBEGUIIQZWIVNWFWGWHWJUCWLWMEBDGUIZIQZWIWLVLWGWHVOWDWMWOU
      JVLVMWFWKUDZVNWFWGWHWJUEZVNWFWGWHWJUFZVOVPVTWEVNWKUGZWAWCWDVQVTVNWKUKADEB
      GHIKLMULUMWLWOWNWBIQZWIWLBWBIQZWCWTWLVLVOVRXAWPWSVRVSVQWEVNWKUNZABCGHIKLM
      UOUPWAWCWDVQVTVNWKUQWLHUSOZBHURUTZOZDXDOZWBXDOZXAWCPWTVAWLVLXCWPHVBSZWLVO
      XEWSAXDBHXDVCZMTSZWLWGXFWQAXDDHXIMTSZWLXCXECXDOZXGXHXJWLVRXLXBAXDCHXIMTSX
      DGHBCXILVDUPZXDGHIBDWBXIKLVEVFVGWLXCEXDOZWNXDOZXGWOWTPWIUJXHWLWHXNWRAXDEH
      XIMTSWLXCXEXFXOXHXJXKXDGHBDXILVDUPXMXDHIEWNWBXIKVKVFVHVIVJ $.
  $}

  ${
    $d s A $.  $d s F $.  $d s G $.  $d s H $.  $d s .\/ $.  $d s K $.
    $d s .<_ $.  $d s P $.  $d s Q $.  $d s R $.  $d s T $.  $d s W $.
    cdlemd4.l $e |- .<_ = ( le ` K ) $.
    cdlemd4.j $e |- .\/ = ( join ` K ) $.
    cdlemd4.a $e |- A = ( Atoms ` K ) $.
    cdlemd4.h $e |- H = ( LHyp ` K ) $.
    cdlemd4.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       30-May-2012.) $)
    cdlemd4 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) /\ R e. A )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                 /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ R =/= P ) )
          /\ ( ( F ` P ) = ( G ` P ) /\ ( F ` Q ) = ( G ` Q ) ) )
        -> ( F ` R ) = ( G ` R ) ) $=
      ( wcel wa cfv vs chlt w3a wbr wn co wceq cv simp11l simp11r simp21 simp22
      wne wrex simp231 cdlemb2 syl221anc simpl11 simpl12 simpl13 simpl21 simprl
      simprrl jca clat cbs hllat syl adantr eqid atbase simp21l simp22l simprrr
      latnlej1l necomd syl131anc simpl22 simpl23 cdlemd3 simpl3l simpl3 cdlemd2
      ad2antrl syl133anc syl331anc syl332anc rexlimddv ) JUBRZLHRZSZFERGERSZDAR
      ZUCZBARZBLKUDUEZSZCARZCLKUDUEZSZBCUMZDBCIUFZKUDZDBUMZUCZUCZBFTBGTUGZCFTCG
      TUGZSZUCZUAUHZLKUDUEZXKXBKUDUEZSZDFTDGTUGZUAAXJWIWJWQWTXAXNUAAUNWIWJWLWMX
      FXIUIZWIWJWLWMXFXIUJWNWQWTXEXIUKWNWQWTXEXIULXAXCXDWQWTWNXIUOZABCHIJKLUAMN
      OPUPUQXJXKARZXNSZSZWKWLWMWQXRXLSBXKUMZDBXKIUFKUDUEZSXGXKFTXKGTUGZXOWKWLWM
      XFXIXSURZWKWLWMXFXIXSUSZWKWLWMXFXIXSUTZWQWTXEWNXIXSVAZXTXRXLXJXRXNVBZXJXR
      XLXMVCVDXTYAYBXTJVERZXKJVFTZRZBYJRZCYJRZXMYAXJYIXSXJWIYIXPJVGVHVIXRYKXJXN
      AYJXKJYJVJZOVKWDXJYLXSXJWOYLWOWPWTXEWNXIVLAYJBJYNOVKVHVIXJYMXSXJWRYMWRWSW
      QXEWNXIVMAYJCJYNOVKVHVIXJXRXLXMVNZYIYKYLYMUCXMUCXKBYJIJKXKBCYNMNVOVPVQXTW
      KWQWTXEWMXRXMYBYDYGWQWTXEWNXIXSVRZWQWTXEWNXIXSVSYFYHYOABCDXKHIJKLMNOPVTWE
      VDXGXHWNXFXSWAXTWKWLXRWQWTXAXMSXIYCYDYEYHYGYPXTXAXMXJXAXSXQVIYOVDWNXFXIXS
      WBABCXKEFGHIJKLMNOPQWCWFABXKDEFGHIJKLMNOPQWCWGWH $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       30-May-2012.) $)
    cdlemd5 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) /\ R e. A )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                 /\ P =/= Q )
          /\ ( ( F ` P ) = ( G ` P ) /\ ( F ` Q ) = ( G ` Q ) ) )
        -> ( F ` R ) = ( G ` R ) ) $=
      ( wcel wa cfv chlt w3a wbr wn wne co fveq2 eqeq12d simpll1 simpl21 adantr
      wceq simpl22 simp23 ad2antrr simpr 3jca simpll3 cdlemd4 syl131anc simpl3l
      simplr pm2.61ne simpl1 simpl23 jca simpl3 cdlemd2 pm2.61dan ) JUARLHRSFER
      GERSDARUBZBARBLKUCUDSZCARCLKUCUDSZBCUEZUBZBFTZBGTZULZCFTCGTULZSZUBZDBCIUF
      KUCZDFTZDGTZULZVTWASZWDVQDBDBULWBVOWCVPDBFUGDBGUGUHWEDBUEZSZVJVKVLVMWAWFU
      BVSWDVJVNVSWAWFUIWEVKWFVKVLVMVJVSWAUJUKWEVLWFVKVLVMVJVSWAUMUKWGVMWAWFVTVM
      WAWFVJVKVLVMVSUNUOVTWAWFVBWEWFUPUQVJVNVSWAWFURABCDEFGHIJKLMNOPQUSUTVQVRVJ
      VNWAVAVCVTWAUDZSZVJVKVLVMWHSVSWDVJVNVSWHVDVKVLVMVJVSWHUJVKVLVMVJVSWHUMWIV
      MWHVKVLVMVJVSWHVEVTWHUPVFVJVNVSWHVGABCDEFGHIJKLMNOPQVHUTVI $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       31-May-2012.) $)
    cdlemd6 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
                 /\ -. Q .<_ ( P .\/ ( F ` P ) ) )
          /\ ( F ` P ) = ( G ` P ) ) -> ( F ` Q ) = ( G ` Q ) ) $=
      ( wcel wa cfv co chlt wbr w3a wceq ctrl cmee oveq2d oveq1d simp1l simp1rl
      wn simp3 simp21 eqid trlval2 syl3anc simp1rr 3eqtr4d simp22 simp23 cdlemc
      oveq12d syl131anc oveq2 breq2d notbid biimpd sylc ) IUAQKGQRZEDQZFDQZRZRZ
      BAQBKJUBUKRZCAQCKJUBUKRZCBBESZHTZJUBZUKZUCZVPBFSZUDZUCZCEKIUESSZSZHTZVPBC
      HTKIUFSZTZHTZWGTZCFWDSZHTZWAWHHTZWGTZCESZCFSZWCWFWLWIWMWGWCWEWKCHWCVQKWGT
      ZBWAHTZKWGTZWEWKWCVQWRKWGWCVPWABHVMVTWBULZUGUHWCVIVJVNWEWQUDVIVLVTWBUIZVJ
      VKVIVTWBUJZVMVNVOVSWBUMZABWDDEGHIJWGKLMWGUNZNOPWDUNZUOUPWCVIVKVNWKWSUDXAV
      JVKVIVTWBUQZXCABWDDFGHIJWGKLMXDNOPXEUOUPURUGWCVPWAWHHWTUHVBWCVIVJVNVOVSWO
      WJUDXAXBXCVMVNVOVSWBUSZVMVNVOVSWBUTZABCWDDEGHIJWGKLMXDNOPXEVAVCWCVIVKVNVO
      CWRJUBZUKZWPWNUDXAXFXCXGWCWBVSXJWTXHWBVSXJWBVRXIWBVQWRCJVPWABHVDVEVFVGVHA
      BCWDDFGHIJWGKLMXDNOPXEVAVCUR $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       1-Jun-2012.) $)
    cdlemd7 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) /\ R e. A )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( ( F ` P ) = ( G ` P ) /\ -. Q .<_ ( P .\/ ( F ` P ) ) ) )
        -> ( F ` R ) = ( G ` R ) ) $=
      ( wcel wa cfv chlt w3a wbr wn wceq co wne simp1 simp2l simp2r cbs simp11l
      clat syl simp2rl eqid atbase simp2ll simp11 simp12l ltrncl syl3anc simp3r
      hllat latnlej1l necomd syl131anc simp3l simp12 cdlemd6 syl231anc cdlemd5
      syl132anc ) JUARZLHRZSZFERZGERZSZDARZUBZBARZBLKUCUDZSZCARZCLKUCUDZSZSZBFT
      ZBGTUEZCBWIIUFKUCUDZSZUBZWAWDWGBCUGZWJCFTCGTUEZDFTDGTUEWAWHWLUHWAWDWGWLUI
      ZWAWDWGWLUJZWMJUMRZCJUKTZRZBWSRZWIWSRZWKWNWMVNWRVNVOVSVTWHWLULJVDUNWMWEWT
      WEWFWDWAWLUOAWSCJWSUPZOUQUNWMWBXAWBWCWGWAWLURAWSBJXCOUQUNZWMVPVQXAXBVPVSV
      TWHWLUSZVQVRVPVTWHWLUTXDWSEFHJUALBXCPQVAVBWAWHWJWKVCZWRWTXAXBUBWKUBCBWSIJ
      KCBWIXCMNVEVFVGWAWHWJWKVHZWMVPVSWDWGWKWJWOXEVPVSVTWHWLVIWPWQXFXGABCEFGHIJ
      KLMNOPQVJVKABCDEFGHIJKLMNOPQVLVM $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       1-Jun-2012.) $)
    cdlemd8 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) /\ R e. A )
          /\ ( P e. A /\ -. P .<_ W )
          /\ ( ( F ` P ) = ( G ` P ) /\ ( F ` P ) = P ) )
        -> ( F ` R ) = ( G ` R ) ) $=
      ( wcel wa cfv wceq chlt w3a wbr wn cid cbs simp3r wb simp11 simp12l simp2
      cres eqid ltrnideq syl3anc mpbird fveq1d simp3l eqtr3d simp12r eqtr4d ) I
      UAQKGQRZEDQZFDQZRZCAQZUBZBAQBKJUCUDRZBESZBFSZTZVIBTZRZUBZCESCUEIUFSZULZSC
      FSVNCEVPVNEVPTZVLVGVHVKVLUGZVNVBVCVHVQVLUHVBVEVFVHVMUIZVCVDVBVFVHVMUJVGVH
      VMUKZAVOBDEGIJKVOUMZLNOPUNUOUPUQVNCFVPVNFVPTZVJBTZVNVIVJBVGVHVKVLURVRUSVN
      VBVDVHWBWCUHVSVCVDVBVFVHVMUTVTAVOBDFGIJKWALNOPUNUOUPUQVA $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       2-Jun-2012.) $)
    cdlemd9 $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ ( F e. T /\ G e. T ) /\ R e. A )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( F ` P ) = ( G ` P ) )
        -> ( F ` R ) = ( G ` R ) ) $=
      ( vs wcel wa wbr chlt w3a cfv wceq simpl1 simpl2 simpl3 cdlemd8 syl112anc
      wn simpr wne cv wrex simpl11 simp12l adantr ltrnel syl3anc necomd cdlemb2
      co syl121anc simp1l1 simp1l2 simp3l jca simp1l3 simp3r cdlemd7 rexlimdv3a
      simp2 syl122anc mpd pm2.61dane ) IUARKGRSZEDRZFDRZSZCARZUBZBARBKJTUJSZBEU
      CZBFUCUDZUBZCEUCCFUCUDZWCBWEWCBUDZSWAWBWDWGWFWAWBWDWGUEWAWBWDWGUFWAWBWDWG
      UGWEWGUKABCDEFGHIJKLMNOPUHUIWEWCBULZSZQUMZKJTUJZWJBWCHVBJTUJZSZQAUNZWFWIV
      PWBWCARWCKJTUJSZBWCULWNVPVSVTWBWDWHUOZWAWBWDWHUFZWIVPVQWBWOWPWEVQWHVQVRVP
      VTWBWDUPUQWQABDEGIJKLNOPURUSWIWCBWEWHUKUTABWCGHIJKQLMNOVAVCWIWMWFQAWIWJAR
      ZWMUBZWAWBWRWKSWDWLWFWAWBWDWHWRWMVDWAWBWDWHWRWMVEWSWRWKWIWRWMVLWIWRWKWLVF
      VGWAWBWDWHWRWMVHWIWRWKWLVIABWJCDEFGHIJKLMNOPVJVMVKVNVO $.
  $}

  ${
    $d q A $.  $d q F $.  $d q G $.  $d q H $.  $d q K $.  $d q .<_ $.
    $d q P $.  $d q T $.  $d q W $.
    cdlemd.l $e |- .<_ = ( le ` K ) $.
    cdlemd.a $e |- A = ( Atoms ` K ) $.
    cdlemd.h $e |- H = ( LHyp ` K ) $.
    cdlemd.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( If two translations agree at any atom not under the fiducial co-atom
       ` W ` , then they are equal.  Lemma D in [Crawley] p. 113.  (Contributed
       by NM, 2-Jun-2012.) $)
    cdlemd $p |- ( ( ( ( K e. HL /\ W e. H )
                         /\ F e. T /\ G e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( F ` P ) = ( G ` P ) ) -> F = G ) $=
      ( vq chlt wcel wa w3a cfv wceq wbr wn cv wral simpl11 simpl12 simpl13 jca
      simpr simpl2 simpl3 cjn eqid cdlemd9 syl311anc ralrimiva ltrneq2 3ad2ant1
      wb mpbid ) GOPIFPQZDCPZECPZRZBAPBIHUAUBQZBDSBESTZRZNUCZDSVHESTZNAUDZDETZV
      GVINAVGVHAPZQZVAVBVCQVLVEVFVIVAVBVCVEVFVLUEVMVBVCVAVBVCVEVFVLUFVAVBVCVEVF
      VLUGUHVGVLUIVDVEVFVLUJVDVEVFVLUKABVHCDEFGULSZGHIJVNUMKLMUNUOUPVDVEVJVKUSV
      FACDEFGINKLMUQURUT $.

    $( Two translations agree at any atom not under the fiducial co-atom ` W `
       iff they are equal.  (Contributed by NM, 25-Jul-2013.) $)
    ltrneq3 $p |- ( ( ( K e. HL /\ W e. H )
                  /\ ( F e. T /\ G e. T )
                  /\ ( P e. A /\ -. P .<_ W ) )
   -> ( ( F ` P ) = ( G ` P ) <-> F = G ) ) $=
      ( chlt wcel wa wbr wn cfv wceq simpl1 simpl2l simpl2r simpl3 simpr cdlemd
      w3a syl311anc fveq1 adantl impbida ) GNOIFOPZDCOZECOZPZBAOBIHQRPZUGZBDSBE
      STZDETZUQURPULUMUNUPURUSULUOUPURUAUMUNULUPURUBUMUNULUPURUCULUOUPURUDUQURU
      EABCDEFGHIJKLMUFUHUSURUQBDEUIUJUK $.
  $}

  ${
    cdleme0.l $e |- .<_ = ( le ` K ) $.
    cdleme0.j $e |- .\/ = ( join ` K ) $.
    cdleme0.m $e |- ./\ = ( meet ` K ) $.
    cdleme0.a $e |- A = ( Atoms ` K ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       14-Jun-2012.) $)
    cdleme00a $p |- ( ( K e. HL /\ ( P e. A /\ Q e. A /\ R e. A )
        /\ -. R .<_ ( P .\/ Q ) ) -> R =/= P ) $=
      ( chlt wcel w3a co wbr wn wne simp1 simp23 simp21 simp3 atnlej1 syl131anc
      simp22 ) FMNZBANZCANZDANZOZDBCEPGQRZOUGUJUHUIULDBSUGUKULTUGUHUIUJULUAUGUH
      UIUJULUBUGUHUIUJULUFUGUKULUCADBCEFGIJLUDUE $.

    cdleme0.h $e |- H = ( LHyp ` K ) $.
    cdleme0.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    ${
      cdleme0.b $e |- B = ( Base ` K ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         14-Jun-2012.) $)
      cdleme0aa $p |- ( ( ( K e. HL /\ W e. H ) /\ P e. A /\ Q e. A )
            -> U e. B ) $=
        ( wcel co chlt wa w3a clat simp1l hllat atbase 3ad2ant2 3ad2ant3 latjcl
        syl syl3anc simp1r lhpbase latmcl syl5eqel ) HUASZKFSZUBZCASZDASZUCZECD
        GTZKJTZBQVBHUDSZVCBSZKBSZVDBSVBUQVEUQURUTVAUEHUFUKZVBVECBSZDBSZVFVHUTUS
        VIVAABCHROUGUHVAUSVJUTABDHROUGUIBGHCDRMUJULVBURVGUQURUTVAUMBFHKRPUNUKBH
        JVCKRNUOULUP $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       12-Jun-2012.) $)
    cdleme0a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ P =/= Q ) ) -> U e. A ) $=
      ( lhpat2 ) ABCDEFGHIJKLMNOPQ $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       13-Jun-2012.) $)
    cdleme0b $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
      /\ Q e. A ) -> U =/= P ) $=
      ( wcel wa wbr syl chlt wn w3a wne clat cbs cfv simp1l hllat simp2l atbase
      co 3ad2ant3 latjcl syl3anc simp1r lhpbase latmle2 syl5eqbr simp2r syl2anc
      eqid nbrne2 ) GUAQZJEQZRZBAQZBJHSUBZRZCAQZUCZDJHSVHDBUDVKDBCFULZJIULZJHPV
      KGUEQZVLGUFUGZQZJVOQZVMJHSVKVDVNVDVEVIVJUHGUITZVKVNBVOQZCVOQZVPVRVKVGVSVF
      VGVHVJUJAVOBGVOVBZNUKTVJVFVTVIAVOCGWANUKUMVOFGBCWALUNUOVKVEVQVDVEVIVJUPVO
      EGJWAOUQTVOGHIVLJWAKMURUOUSVFVGVHVJUTDBJHVCVA $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       12-Jun-2012.) $)
    cdleme0c $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A )
         /\ ( R e. A /\ -. R .<_ W ) ) -> U =/= R ) $=
      ( wcel wa syl chlt wbr wn w3a wne clat cbs cfv simp1l hllat simp2l atbase
      eqid simp2r latjcl syl3anc simp1r lhpbase latmle2 syl5eqbr simp3r syl2anc
      co nbrne2 ) HUARZKFRZSZBARZCARZSZDARZDKIUBUCZSZUDZEKIUBVLEDUEVNEBCGVCZKJV
      CZKIQVNHUFRZVOHUGUHZRZKVRRZVPKIUBVNVEVQVEVFVJVMUIHUJTZVNVQBVRRZCVRRZVSWAV
      NVHWBVGVHVIVMUKAVRBHVRUMZOULTVNVIWCVGVHVIVMUNAVRCHWDOULTVRGHBCWDMUOUPVNVF
      VTVEVFVJVMUQVRFHKWDPURTVRHIJVOKWDLNUSUPUTVGVJVKVLVAEDKIVDVB $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  Reformat as in
       ~ cdlemg3a - swap consequent equality; make antecedent use ~ df-3an .
       (Contributed by NM, 13-Jun-2012.) $)
    cdleme0cp $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A ) )
             -> ( P .\/ U ) = ( P .\/ Q ) ) $=
      ( wcel wa co wceq chlt wbr wn oveq2i cp1 cfv simpll simprll clat ad2antrr
      cbs hllat eqid atbase syl simprr latjcl syl3anc lhpbase ad2antlr hlatlej1
      atmod3i1 syl131anc lhpjat2 adantrr oveq2d col olm11 syl2anc 3eqtrd syl5eq
      hlol ) GUAQZJEQZRZBAQZBJHUBUCZRZCAQZRZRZBDFSBBCFSZJISZFSZWBDWCBFPUDWAWDWB
      BJFSZISZWBGUEUFZISZWBWAVMVPWBGUKUFZQZJWIQZBWBHUBZWDWFTVMVNVTUGZVOVPVQVSUH
      ZWAGUIQZBWIQZCWIQZWJVMWOVNVTGULUJWAVPWPWNAWIBGWIUMZNUNUOWAVSWQVOVRVSUPZAW
      ICGWRNUNUOWIFGBCWRLUQURZVNWKVMVTWIEGJWROUSUTWAVMVPVSWLWMWNWSABCFGHKLNVAUR
      AWIBFGHIWBJWRKLMNVBVCWAWEWGWBIVOVRWEWGTVSABWGEFGHJKLWGUMZNOVDVEVFWAGVGQZW
      JWHWBTVMXBVNVTGVLUJWTWIWGGIWBWRMXAVHVIVJVK $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       25-Apr-2013.) $)
    cdleme0cq $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( P e. A /\ ( Q e. A /\ -. Q .<_ W ) ) )
             -> ( Q .\/ U ) = ( P .\/ Q ) ) $=
      ( wcel wa co wceq chlt wbr wn oveq2i cp1 cfv simpll simprrl clat ad2antrr
      cbs eqid atbase ad2antrl latjcl syl3anc lhpbase ad2antlr latlej2 atmod3i1
      hllat syl syl131anc lhpjat2 adantrl oveq2d col hlol syl2anc 3eqtrd syl5eq
      olm11 ) GUAQZJEQZRZBAQZCAQZCJHUBUCZRZRZRZCDFSCBCFSZJISZFSZWBDWCCFPUDWAWDW
      BCJFSZISZWBGUEUFZISZWBWAVMVQWBGUKUFZQZJWIQZCWBHUBZWDWFTVMVNVTUGVOVPVQVRUH
      ZWAGUIQZBWIQZCWIQZWJVMWNVNVTGVAUJZVPWOVOVSAWIBGWIULZNUMUNZWAVQWPWMAWICGWR
      NUMVBZWIFGBCWRLUOUPZVNWKVMVTWIEGJWROUQURWAWNWOWPWLWQWSWTWIFGHBCWRKLUSUPAW
      ICFGHIWBJWRKLMNUTVCWAWEWGWBIVOVSWEWGTVPACWGEFGHJKLWGULZNOVDVEVFWAGVGQZWJW
      HWBTVMXCVNVTGVHUJXAWIWGGIWBWRMXBVLVIVJVK $.

    ${
      cdleme0c.3 $e |- V = ( ( P .\/ R ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         13-Jun-2012.)  (New usage is discouraged.) $)
      cdleme0dN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( R e. A /\ P =/= R ) ) -> V e. A ) $=
        ( lhpat2 ) ABDKFGHIJLMNOPQST $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         13-Jun-2012.) $)
      cdleme0e $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( ( P e. A /\ -. P .<_ W )
             /\ Q e. A /\ ( R e. A /\ -. R .<_ W ) )
          /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> U =/= V ) $=
        ( wcel chlt wa wbr w3a wne cp0 cfv wceq oveq12i col cbs simp1l hlol syl
        wn simp21l simp22 eqid hlatjcl syl3anc simp23l simp1r latmmdir syl13anc
        co lhpbase clat hllat atbase simp3r latnlej1r necomd syl131anc hlatcon3
        simp3 2llnma2 syl132anc oveq1d eqtr3d syl5eq simp1 simp21 syl2anc eqtrd
        lhpmat cal wb hlatl simp3l lhpat2 syl112anc latnlej1l atnem0 mpbird ) H
        UATZLFTZUBZBATZBLIUCUOZUBZCATZDATZDLIUCUOZUBZUDZBCUEZDBCGVEZIUCUOZUBZUD
        ZEKUEZEKJVEZHUFUGZUHZXJXLBLJVEZXMXJXLXGLJVEZBDGVEZLJVEZJVEZXOEXPKXRJRSU
        IXJXGXQJVEZLJVEZXSXOXJHUJTZXGHUKUGZTZXQYCTZLYCTZYAXSUHXJWOYBWOWPXEXIULZ
        HUMUNXJWOWRXAYDYGWRWSXAXDWQXIUPZWQWTXAXDXIUQZAYCGHBCYCURZNPUSUTXJWOWRXB
        YEYGYHXBXCWTXAWQXIVAZAYCGHBDYJNPUSUTXJWPYFWOWPXEXIVBYCFHLYJQVFUNYCHJXGX
        QLYJOVCVDXJXTBLJXJWOXAXBWRCDUEZBCDGVEIUCUOZXTBUHYGYIYKYHXJHVGTZDYCTZBYC
        TZCYCTZXHYLXJWOYNYGHVHUNZXJXBYOYKAYCDHYJPVIUNZXJWRYPYHAYCBHYJPVIUNZXJXA
        YQYIAYCCHYJPVIUNZWQXEXFXHVJZYNYOYPYQUDXHUDZDCYCGHIDBCYJMNVKVLVMXJWOWRXA
        XBXIYMYGYHYIYKWQXEXIVOABCDGHIMNPVNVMACDBGHIJMNOPVPVQVRVSVTXJWQWTXOXMUHW
        QXEXIWAZWQWTXAXDXIWBZABFHIJLXMMOXMURZPQWEWCWDXJHWFTZEATZKATZXKXNWGXJWOU
        UGYGHWHUNXJWQWTXAXFUUHUUDUUEYIWQXEXFXHWIABCEFGHIJLMNOPQRWJWKXJWQWTXBBDU
        EZUUIUUDUUEYKXJYNYOYPYQXHUUJYRYSYTUUAUUBUUCDBYCGHIDBCYJMNWLVLVMABDKFGHI
        JLMNOPQSWJWKAEKHJXMOUUFPWMUTWN $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         14-Jun-2012.)  (New usage is discouraged.) $)
      cdleme0fN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ R e. A ) ) -> V =/= P ) $=
        ( wcel chlt wa wbr wn w3a wne clat cbs cfv simp1l hllat syl simp2l eqid
        co atbase simp3r latjcl syl3anc simp1r lhpbase latmle2 syl5eqbr syl2anc
        simp2r nbrne2 ) HUATZLFTZUBZBATZBLIUCUDZUBZCATZDATZUBZUEZKLIUCVKKBUFVPK
        BDGUOZLJUOZLISVPHUGTZVQHUHUIZTZLVTTZVRLIUCVPVGVSVGVHVLVOUJHUKULZVPVSBVT
        TZDVTTZWAWCVPVJWDVIVJVKVOUMAVTBHVTUNZPUPULVPVNWEVIVLVMVNUQAVTDHWFPUPULV
        TGHBDWFNURUSVPVHWBVGVHVLVOUTVTFHLWFQVAULVTHIJVQLWFMOVBUSVCVIVJVKVOVEKBL
        IVFVD $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         14-Jun-2012.)  (New usage is discouraged.) $)
      cdleme0gN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ R e. A )
           /\ ( Q e. A /\ -. Q .<_ W ) ) -> V =/= Q ) $=
        ( cdleme0c ) ABDCKFGHIJLMNOPQST $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       5-Dec-2012.) $)
    cdlemeulpq $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A ) )
               -> U .<_ ( P .\/ Q ) ) $=
      ( wcel wa co syl3anc chlt clat cbs cfv wbr simpll hllat syl simprl simprr
      eqid hlatjcl lhpbase ad2antlr latmle1 syl5eqbr ) GUAQZJEQZRZBAQZCAQZRZRZD
      BCFSZJISZVDHPVCGUBQZVDGUCUDZQZJVGQZVEVDHUEVCUQVFUQURVBUFZGUGUHVCUQUTVAVHV
      JUSUTVAUIUSUTVAUJAVGFGBCVGUKZLNULTURVIUQVBVGEGJVKOUMUNVGGHIVDJVKKMUOTUP
      $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       5-Nov-2012.)  (New usage is discouraged.) $)
    cdleme01N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) ) /\ P =/= Q )
          -> ( ( U =/= P /\ U =/= Q /\ U .<_ ( P .\/ Q ) ) /\ U .<_ W ) ) $=
      ( wcel wa wbr wne chlt wn w3a co cbs cfv simp1l hllat syl simp2ll simp2rl
      clat eqid hlatjcl syl3anc simp1r lhpbase latmle2 syl5eqbr simp2lr syl2anc
      nbrne2 simp2rr simp1 cdlemeulpq syl12anc 3jca jca ) GUAQZJEQZRZBAQZBJHSUB
      ZRZCAQZCJHSUBZRZRZBCTZUCZDBTZDCTZDBCFUDZHSZUCDJHSZVTWAWBWDVTWEVMWAVTDWCJI
      UDZJHPVTGULQZWCGUEUFZQZJWHQZWFJHSVTVIWGVIVJVRVSUGZGUHUIVTVIVLVOWIWKVLVMVQ
      VKVSUJZVOVPVNVKVSUKZAWHFGBCWHUMZLNUNUOVTVJWJVIVJVRVSUPWHEGJWNOUQUIWHGHIWC
      JWNKMURUOUSZVLVMVQVKVSUTDBJHVBVAVTWEVPWBWOVOVPVNVKVSVCDCJHVBVAVTVKVLVOWDV
      KVRVSVDWLWMABCDEFGHIJKLMNOPVEVFVGWOVH $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       9-Nov-2012.)  (New usage is discouraged.) $)
    cdleme02N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) ) /\ P =/= Q )
            -> ( ( P .\/ U ) = ( Q .\/ U ) /\ U .<_ W ) ) $=
      ( wcel wa wbr wne chlt wn w3a co wceq cdleme01N clc wb simp1l syl simp2ll
      hlcvl simp2rl simp1 simp2l simp3 lhpat2 syl112anc syl131anc anbi1d mpbird
      cvlsupr2 ) GUAQZJEQZRZBAQZBJHSUBZRZCAQZCJHSUBZRZRZBCTZUCZBDFUDCDFUDUEZDJH
      SZRDBTDCTDBCFUDHSUCZVPRABCDEFGHIJKLMNOPUFVNVOVQVPVNGUGQZVFVIDAQZVMVOVQUHV
      NVCVRVCVDVLVMUIGULUJVFVGVKVEVMUKVIVJVHVEVMUMZVNVEVHVIVMVSVEVLVMUNVEVHVKVM
      UOVTVEVLVMUPZABCDEFGHIJKLMNOPUQURWAABCDFGHNKLVBUSUTVA $.

    $d u A $.  $d u .\/ $.  $d u .<_ $.  $d u P $.  $d u Q $.  $d u U $.
    $d u W $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       9-Nov-2012.)  (New usage is discouraged.) $)
    cdleme0ex1N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ Q e. A ) /\ P =/= Q ) ->
           E. u e. A ( u .<_ ( P .\/ Q ) /\ u .<_ W ) ) $=
      ( wcel wa wbr chlt wn wne w3a co cv wrex simp1 simp2l simp2r simp3 lhpat2
      syl112anc simp2ll cdlemeulpq syl12anc clat cbs cfv hllat syl eqid hlatjcl
      simp1l syl3anc simp1r lhpbase latmle2 syl5eqbr wceq breq1 anbi12d rspcev
      ) HUARZKFRZSZCBRZCKITUBZSZDBRZSZCDUCZUDZEBRZECDGUEZITZEKITZAUFZWEITZWHKIT
      ZSZABUGWCVPVSVTWBWDVPWAWBUHZVPVSVTWBUIVPVSVTWBUJZVPWAWBUKBCDEFGHIJKLMNOPQ
      ULUMWCVPVQVTWFWLVQVRVTVPWBUNZWMBCDEFGHIJKLMNOPQUOUPWCEWEKJUEZKIQWCHUQRZWE
      HURUSZRZKWQRZWOKITWCVNWPVNVOWAWBVDZHUTVAWCVNVQVTWRWTWNWMBWQGHCDWQVBZMOVCV
      EWCVOWSVNVOWAWBVFWQFHKXAPVGVAWQHIJWEKXALNVHVEVIWKWFWGSAEBWHEVJWIWFWJWGWHE
      WEIVKWHEKIVKVLVMUP $.

    $d u H $.  $d u K $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Note that
       ` ( P .\/ u ) = ( Q .\/ u ) ` is a shorter way to express
       ` u =/= P /\ u =/= Q /\ u .<_ ( P .\/ Q ) ` .  (Contributed by NM,
       9-Nov-2012.)  (New usage is discouraged.) $)
    cdleme0ex2N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) ) /\ P =/= Q ) ->
           E. u e. A ( ( P .\/ u ) = ( Q .\/ u ) /\ u .<_ W ) ) $=
      ( wcel wa wbr chlt wn wne w3a cv co wceq simp1 simp2l simp2rl cdleme0ex1N
      wrex simp3 syl121anc wb clc simp11l hlcvl simp2ll 3ad2ant1 simp2 cvlsupr2
      simp13 syl131anc simp2lr nbrne2 syl2anc simp2rr biantrurd df-3an syl6rbbr
      syl jca bitrd 3expia pm5.32rd rexbidva mpbird ) HUARZKFRZSZCBRZCKITUBZSZD
      BRZDKITUBZSZSZCDUCZUDZCAUEZGUFDWKGUFUGZWKKITZSZABULWKCDGUFITZWMSZABULZWJW
      AWDWEWIWQWAWHWIUHWAWDWGWIUIWEWFWDWAWIUJZWAWHWIUMABCDEFGHIJKLMNOPQUKUNWJWN
      WPABWJWKBRZSWMWLWOWJWSWMWLWOUOWJWSWMUDZWLWKCUCZWKDUCZWOUDZWOWTHUPRZWBWEWS
      WIWLXCUOWTVSXDVSVTWHWIWSWMUQHURVLWJWSWBWMWBWCWGWAWIUSUTWJWSWEWMWRUTWJWSWM
      VAWAWHWIWSWMVCBCDWKGHIOLMVBVDWTWOXAXBSZWOSXCWTXEWOWTXAXBWTWMWCXAWJWSWMUMZ
      WJWSWCWMWBWCWGWAWIVEUTWKCKIVFVGWTWMWFXBXFWJWSWFWMWEWFWDWAWIVHUTWKDKIVFVGV
      MVIXAXBWOVJVKVNVOVPVQVR $.

    $d r A $.  $d r .\/ $.  $d r P $.  $d r Q $.  $d r R $.  $d r U $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       9-Nov-2012.)  (New usage is discouraged.) $)
    cdleme0moN $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
         /\ ( R e. A /\ -. R .<_ W ) )
     /\ ( P =/= Q /\ R .<_ ( P .\/ Q )
         /\ E* r ( r e. A /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> ( R = P \/ R = Q ) ) $=
      ( wcel wa chlt wbr wn w3a wne co wceq wmo simp23r neanior simpl33 simp23l
      cv wo adantr simprl simprr simpl32 clc wb simpl1l simp21l simp22l simpl31
      hlcvl cvlsupr2 syl131anc mpbir3and simp1l simp1r simp21r simp31 syl222anc
      syl lhpat2 simpl1 simpl21 simpl22 cdleme02N simpld syl121anc df-rmo oveq2
      wrmo eqeq12d rmoi syl3an1br syl122anc simprd eqbrtrd ex syl5bir mt3d ) HU
      ASZKFSZTZBASZBKIUBUCZTZCASZCKIUBUCZTZDASZDKIUBZUCZTZUDZBCUEZDBCGUFIUBZLUM
      ZASBXJGUFZCXJGUFZUGZTLUHZUDZUDZDBUGDCUGUNZXDXCXEWSXBWPXOUIXQUCDBUEZDCUEZT
      ZXPXDDBDCUJXPXTXDXPXTTZDEKIYAXNXCBDGUFZCDGUFZUGZEASZBEGUFZCEGUFZUGZDEUGZX
      HXIXNWPXGXTUKXPXCXTXCXEWSXBWPXOULUOZYAYDXRXSXIXPXRXSUPXPXRXSUQXHXIXNWPXGX
      TURYAHUSSZWQWTXCXHYDXRXSXIUDUTYAWNYKWNWOXGXOXTVAHVEVNXPWQXTWQWRXBXFWPXOVB
      ZUOXPWTXTWTXAWSXFWPXOVCZUOYJXHXIXNWPXGXTVDZABCDGHIPMNVFVGVHXPYEXTXPWNWOWQ
      WRWTXHYEWNWOXGXOVIWNWOXGXOVJYLWQWRXBXFWPXOVKYMWPXGXHXIXNVLABCEFGHIJKMNOPQ
      RVOVMUOYAWPWSXBXHYHWPXGXOXTVPZWSXBXFWPXOXTVQZWSXBXFWPXOXTVRZYNWPWSXBTXHUD
      ZYHEKIUBZABCEFGHIJKMNOPQRVSZVTWAXNXMLAWDXCYDTYEYHTYIXMLAWBXMYDYHLADEXJDUG
      XKYBXLYCXJDBGWCXJDCGWCWEXJEUGXKYFXLYGXJEBGWCXJECGWCWEWFWGWHYAWPWSXBXHYSYO
      YPYQYNYRYHYSYTWIWAWJWKWLWM $.
  $}

  ${
    cdleme1.l $e |- .<_ = ( le ` K ) $.
    cdleme1.j $e |- .\/ = ( join ` K ) $.
    cdleme1.m $e |- ./\ = ( meet ` K ) $.
    cdleme1.a $e |- A = ( Atoms ` K ) $.
    cdleme1.h $e |- H = ( LHyp ` K ) $.
    cdleme1.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme1.f $e |- F
          = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $.
    ${
      cdleme1.b $e |- B = ( Base ` K ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma showing
         ` F ` is a lattice element. ` F ` represents their f(r).  (Contributed
         by NM, 6-Jun-2012.) $)
      cdleme1b $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( P e. A /\ Q e. A /\ R e. A ) ) -> F e. B ) $=
        ( chlt wcel wa co clat hllat ad2antrr simpr3 atbase cdleme0aa 3adant3r3
        w3a syl latjcl syl3anc simpr2 simpr1 lhpbase ad2antlr latmcl syl5eqel )
        JUBUCZMHUCZUDZCAUCZDAUCZEAUCZUMZUDZGEFIUEZDCEIUEZMLUEZIUEZLUEZBTVJJUFUC
        ZVKBUCZVNBUCZVOBUCVCVPVDVIJUGUHZVJVPEBUCZFBUCZVQVSVJVHVTVEVFVGVHUIABEJU
        AQUJUNZVEVFVGWAVHABCDFHIJKLMNOPQRSUAUKULBIJEFUAOUOUPVJVPDBUCZVMBUCZVRVS
        VJVGWCVEVFVGVHUQABDJUAQUJUNVJVPVLBUCZMBUCZWDVSVJVPCBUCZVTWEVSVJVFWGVEVF
        VGVHURABCJUAQUJUNWBBIJCEUAOUOUPVDWFVCVIBHJMUARUSUTBJLVLMUAPVAUPBIJDVMUA
        OUOUPBJLVKVNUAPVAUPVB $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113. ` F ` represents their
       f(r).  Here we show r ` \/ ` f(r) = r ` \/ ` u (7th through 5th lines
       from bottom on p. 113).  (Contributed by NM, 4-Jun-2012.) $)
    cdleme1 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A
           /\ ( R e. A /\ -. R .<_ W ) ) ) -> ( R .\/ F ) = ( R .\/ U ) ) $=
      ( wcel chlt wa wbr wn w3a cbs cfv wceq simpll simpr3l clat hllat ad2antrr
      co eqid atbase syl simpr1 simpr2 latjcl syl3anc lhpbase ad2antlr syl5eqel
      latmcl latlej1 atmod3i1 syl131anc cp1 latlej2 lhpjat2 3ad2antr3 col olm11
      oveq2d syl2anc 3eqtrd latj12 syl13anc latj13 3eqtr3rd cdlemeulpq 3adantr3
      hlol wi latjlej2 mpd wb latleeqm1 mpbid 3eqtr2rd oveq2i syl6reqr ) IUATZL
      GTZUBZBATZCATZDATZDLJUCUDZUBZUEZUBZDEHUNZDXDCBDHUNZLKUNZHUNZKUNZHUNZDFHUN
      XCXIXDDXGHUNZKUNZXDDBCHUNZHUNZKUNZXDXCWNWSXDIUFUGZTZXGXOTZDXDJUCZXIXKUHWN
      WOXBUIZWSWTWQWRWPUJZXCIUKTZDXOTZEXOTZXPWNYAWOXBIULUMZXCWSYBXTAXODIXOUOZPU
      PUQZXCEXLLKUNZXORXCYAXLXOTZLXOTZYGXOTYDXCYABXOTZCXOTZYHYDXCWQYJWPWQWRXAUR
      AXOBIYEPUPUQZXCWRYKWPWQWRXAUSAXOCIYEPUPUQZXOHIBCYENUTVAZWOYIWNXBXOGILYEQV
      BVCZXOIKXLLYEOVEVAVDZXOHIDEYENUTVAZXCYAYKXFXOTZXQYDYMXCYAXEXOTZYIYRYDXCYA
      YJYBYSYDYLYFXOHIBDYENUTVAZYOXOIKXELYEOVEVAZXOHICXFYENUTVAXCYAYBYCXRYDYFYP
      XOHIJDEYEMNVFVAAXODHIJKXDXGYEMNOPVGVHXCXMXJXDKXCCDXFHUNZHUNZCXEHUNZXJXMXC
      UUBXECHXCUUBXEDLHUNZKUNZXEIVIUGZKUNZXEXCWNWSYSYIDXEJUCZUUBUUFUHXSXTYTYOXC
      YAYJYBUUIYDYLYFXOHIJBDYEMNVJVAAXODHIJKXELYEMNOPVGVHXCUUEUUGXEKWPWQXAUUEUU
      GUHWRADUUGGHIJLMNUUGUOZPQVKVLVOXCIVMTZYSUUHXEUHWNUUKWOXBIWDUMYTXOUUGIKXEY
      EOUUJVNVPVQVOXCYAYKYBYRUUCXJUHYDYMYFUUAXOHICDXFYENVRVSXCYAYKYJYBUUDXMUHYD
      YMYLYFXOHICBDYENVTVSWAVOXCXDXMJUCZXNXDUHZXCEXLJUCZUULWPWQWRUUNXAABCEGHIJK
      LMNOPQRWBWCXCYAYCYHYBUUNUULWEYDYPYNYFXOHIJEXLDYEMNWFVSWGXCYAXPXMXOTZUULUU
      MWHYDYQXCYAYBYHUUOYDYFYNXOHIDXLYENUTVAXOIJKXDXMYEMOWIVAWJWKFXHDHSWLWM $.

    $( Part of proof of Lemma E in [Crawley] p. 113. . ` F ` represents f(r).
       ` W ` is the fiducial co-atom (hyperplane) w.  Here we show that (r
       ` \/ ` f(r)) ` /\ ` w = u in their notation (4th line from bottom on
       p. 113).  (Contributed by NM, 5-Jun-2012.) $)
    cdleme2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A
           /\ ( R e. A /\ -. R .<_ W ) ) ) -> ( ( R .\/ F ) ./\ W ) = U ) $=
      ( wcel chlt wa wbr wn w3a cdleme1 oveq1d cbs cfv wceq simpll simpr3l clat
      co ad2antrr simpr1 eqid atbase syl simpr2 latjcl syl3anc lhpbase ad2antlr
      hllat latmcl syl5eqel latmle2 syl5eqbr syl131anc cp0 lhpmat 3ad2antr3 col
      atmod4i2 hlol olj02 syl2anc eqtrd 3eqtr2d ) IUATZLGTZUBZBATZCATZDATZDLJUC
      UDZUBZUEZUBZDFHUNZLKUNDEHUNZLKUNZDLKUNZEHUNZEWJWKWLLKABCDEFGHIJKLMNOPQRSU
      FUGWJWAWFEIUHUIZTZLWPTZELJUCWOWMUJWAWBWIUKWFWGWDWEWCULWJEBCHUNZLKUNZWPRWJ
      IUMTZWSWPTZWRWTWPTWAXAWBWIIVEUOZWJXABWPTZCWPTZXBXCWJWDXDWCWDWEWHUPAWPBIWP
      UQZPURUSWJWEXEWCWDWEWHUTAWPCIXFPURUSWPHIBCXFNVAVBZWBWRWAWIWPGILXFQVCVDZWP
      IKWSLXFOVFVBVGZXHWJEWTLJRWJXAXBWRWTLJUCXCXGXHWPIJKWSLXFMOVHVBVIAWPDHIJKEL
      XFMNOPVOVJWJWOIVKUIZEHUNZEWJWNXJEHWCWDWHWNXJUJWEADGIJKLXJMOXJUQZPQVLVMUGW
      JIVNTZWQXKEUJWAXMWBWIIVPUOXIWPHIEXJXFNXLVQVRVSVT $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme3fa and ~ cdleme3 .  (Contributed by NM, 6-Jun-2012.) $)
    cdleme3b $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
      /\ ( Q e. A /\ P =/= Q ) /\ ( R e. A /\ -. R .<_ W ) ) ) -> F =/= R ) $=
      ( wcel chlt wa wbr wn wne w3a cbs cfv ccvr simpll simpr3l eqid atbase syl
      co hllat ad2antrr lhpat2 3adant3r3 latjcl syl3anc simpr2l simpr1l lhpbase
      ad2antlr latmcl syl5eqel latmle2 syl5eqbr simpr3r nbrne2 necomd wb atcvr1
      clat syl2anc mpbid wceq simpr3 3jca cdleme1 breqtrrd cvrne syl31anc oveq2
      syldan adantl hlatjidm adantr eqtr2d ex necon3d mpd ) IUATZLGTZUBZBATZBLJ
      UCUDZUBZCATZBCUEZUBZDATZDLJUCUDZUBZUFZUBZDDFHUOZUEZFDUEXGWNDIUGUHZTZXHXJT
      ZDXHIUIUHZUCXIWNWOXFUJZXGXCXKXCXDWSXBWPUKZAXJDIXJULZPUMUNZXGIVOTZXKFXJTXL
      WNXRWOXFIUPUQZXQXGFDEHUOZCBDHUOZLKUOZHUOZKUOZXJSXGXRXTXJTZYCXJTZYDXJTXSXG
      XRXKEXJTZYEXSXQXGEATZYGWPWSXBYHXEABCEGHIJKLMNOPQRURUSZAXJEIXPPUMUNXJHIDEX
      PNUTVAXGXRCXJTZYBXJTZYFXSXGWTYJWTXAWSXEWPVBZAXJCIXPPUMUNZXGXRYAXJTZLXJTZY
      KXSXGXRBXJTZXKYNXSXGWQYPWQWRXBXEWPVCZAXJBIXPPUMUNZXQXJHIBDXPNUTVAWOYOWNXF
      XJGILXPQVDVEZXJIKYALXPOVFVAXJHICYBXPNUTVAXJIKXTYCXPOVFVAVGXJHIDFXPNUTVAXG
      DXTXHXMXGDEUEZDXTXMUCZXGEDXGELJUCXDEDUEXGEBCHUOZLKUOZLJRXGXRUUBXJTZYOUUCL
      JUCXSXGXRYPYJUUDXSYRYMXJHIBCXPNUTVAYSXJIJKUUBLXPMOVHVAVIXCXDWSXBWPVJEDLJV
      KVPVLXGWNXCYHYTUUAVMXNXOYIAXMDEHINXMULZPVNVAVQWPXFWQWTXEUFXHXTVRXGWQWTXEY
      QYLWPWSXBXEVSVTABCDEFGHIJKLMNOPQRSWAWFWBUAXJXMIDXHXPUUEWCWDXGFDDXHXGFDVRZ
      DXHVRXGUUFUBXHDDHUOZDUUFXHUUGVRXGFDDHWEWGXGUUGDVRZUUFXGWNXCUUHXNXOAHIDNPW
      HVPWIWJWKWLWM $.

    ${
      cdleme3c.z $e |- .0. = ( 0. ` K ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme3fa and ~ cdleme3 .  (Contributed by NM, 6-Jun-2012.) $)
      cdleme3c $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ P =/= Q ) /\ ( R e. A /\ -. R .<_ W ) ) )
                -> F =/= .0. ) $=
        ( chlt wcel wa wbr wn wne w3a co cbs cfv ccvr simpll clat hllat simpr3l
        ad2antrr eqid atbase syl cops hlop op0cl latjcl syl3anc simpr1l simpr2l
        simpl cdleme1b syl13anc lhpbase ad2antlr latmle2 simpr3r nbrne2 syl2anc
        syl5eqbr necomd wb lhpat2 3adant3r3 atcvr1 mpbid wceq hlol olj01 simpr3
        col cdleme1 3brtr4d cvrne syl31anc oveq2 necon3i ) IUBUCZLGUCZUDZBAUCZB
        LJUEUFZUDZCAUCZBCUGZUDZDAUCZDLJUEUFZUDZUHZUDZMFXHDMHUIZDFHUIZUGZMFUGXHW
        OXIIUJUKZUCZXJXLUCZXIXJIULUKZUEXKWOWPXGUMZXHIUNUCZDXLUCZMXLUCZXMWOXQWPX
        GIUOUQZXHXDXRXDXEWTXCWQUPZAXLDIXLURZQUSUTZXHIVAUCZXSWOYDWPXGIVBUQXLIMYB
        UAVCUTXLHIDMYBOVDVEXHXQXRFXLUCZXNXTYCXHWQWRXAXDYEWQXGVHZWRWSXCXFWQVFZXA
        XBWTXFWQVGZYAAXLBCDEFGHIJKLNOPQRSTYBVIVJXLHIDFYBOVDVEXHDDEHUIZXIXJXOXHD
        EUGZDYIXOUEZXHEDXHELJUEXEEDUGXHEBCHUIZLKUIZLJSXHXQYLXLUCZLXLUCZYMLJUEXT
        XHXQBXLUCZCXLUCZYNXTXHWRYPYGAXLBIYBQUSUTXHXAYQYHAXLCIYBQUSUTXLHIBCYBOVD
        VEWPYOWOXGXLGILYBRVKVLXLIJKYLLYBNPVMVEVQXDXEWTXCWQVNEDLJVOVPVRXHWOXDEAU
        CZYJYKVSXPYAWQWTXCYRXFABCEGHIJKLNOPQRSVTWAAXODEHIOXOURZQWBVEWCXHIWHUCZX
        RXIDWDWOYTWPXGIWEUQYCXLHIDMYBOUAWFVPXHWQWRXAXFXJYIWDYFYGYHWQWTXCXFWGABC
        DEFGHIJKLNOPQRSTWIVJWJUBXLXOIXIXJYBYSWKWLMFXIXJMFDHWMWNUTVR $.
    $}

    ${
      cdleme3.3 $e |- V = ( ( P .\/ R ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme3fa and ~ cdleme3 .  (Contributed by NM, 6-Jun-2012.) $)
      cdleme3d $p |- F = ( ( R .\/ U ) ./\ ( Q .\/ V ) ) $=
        ( co oveq2i eqtr4i ) FDEHUBZCBDHUBMKUBZHUBZKUBUECLHUBZKUBTUHUGUEKLUFCHU
        AUCUCUD $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme3fa and ~ cdleme3 .  (Contributed by NM, 6-Jun-2012.) $)
      cdleme3e $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
        /\ Q e. A /\ ( R e. A /\ -. R .<_ ( P .\/ Q ) ) ) ) -> V e. A ) $=
        ( chlt wcel wa wbr wn co w3a wne simpl simpr1 simpr3l clat cbs ad2antrr
        cfv hllat eqid atbase simpr1l simpr2 simpr3r latnlej1l syl131anc necomd
        syl lhpat syl112anc syl5eqel ) IUBUCZMGUCZUDZBAUCZBMJUEUFZUDZCAUCZDAUCZ
        DBCHUGJUEUFZUDZUHZUDZLBDHUGMKUGZAUAWAVLVOVQBDUIWBAUCVLVTUJVLVOVPVSUKVQV
        RVOVPVLULZWADBWAIUMUCZDIUNUPZUCZBWEUCZCWEUCZVRDBUIVJWDVKVTIUQUOWAVQWFWC
        AWEDIWEURZQUSVFWAVMWGVMVNVPVSVLUTAWEBIWIQUSVFWAVPWHVLVOVPVSVAAWECIWIQUS
        VFVQVRVOVPVLVBWEHIJDBCWINOVCVDVEABDGHIJKMNOPQRVGVHVI $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme3fa and ~ cdleme3 .  TODO:  Delete - duplicates ~ cdleme0e .
         (Contributed by NM, 6-Jun-2012.)  (New usage is discouraged.) $)
      cdleme3fN $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ ( R e. A /\ -. R .<_ W ) )
       /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> U =/= V ) $=
        ( cdleme0e ) ABCDEGHIJKLMNOPQRSUAUB $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme3fa and ~ cdleme3 .  (Contributed by NM, 7-Jun-2012.) $)
      cdleme3g $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) /\ ( R e. A /\ -. R .<_ W ) )
              /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> F =/= U ) $=
        ( chlt wcel wa wbr wn w3a wne co cdleme3d clat cbs cfv simp1l hllat syl
        simp23l simp21 simp22l simp3l lhpat2 syl112anc eqid hlatjcl syl3anc jca
        simp1 simp3r cdleme3e syl13anc latmle2 syl5eqbr simp22r wi simp23 simp3
        cdleme0e syl131anc hlatexch2 simp21l simp1r wb atbase latjle12 mpbi2and
        lhpbase lattr mpan2d syld mtod nbrne2 syl2anc ) IUBUCZMGUCZUDZBAUCZBMJU
        EUFZUDZCAUCZCMJUEZUFZUDZDAUCZDMJUEUFZUDZUGZBCUHZDBCHUIZJUEUFZUDZUGZFCLH
        UIZJUEEXLJUEZUFFEUHXKFDEHUIZXLKUIZXLJABCDEFGHIJKLMNOPQRSTUAUJXKIUKUCZXN
        IULUMZUCZXLXQUCZXOXLJUEXKWMXPWMWNXFXJUNZIUOUPZXKWMXCEAUCZXRXTXCXDWRXBWO
        XJUQZXKWOWRWSXGYBWOXFXJVGZWOWRXBXEXJURZWSXAWRXEWOXJUSZWOXFXGXIUTABCEGHI
        JKMNOPQRSVAVBZAXQHIDEXQVCZOQVDVEXKWMWSLAUCZXSXTYFXKWOWRWSXCXIUDYIYDYEYF
        XKXCXIYCWOXFXGXIVHVFABCDEFGHIJKLMNOPQRSTUAVIVJZAXQHICLYHOQVDVEXQIJKXNXL
        YHNPVKVEVLXKXMWTWSXAWRXEWOXJVMXKXMCELHUIZJUEZWTXKWMYBWSYIELUHZXMYLVNXTY
        GYFYJXKWOWRWSXEXJYMYDYEYFWOWRXBXEXJVOWOXFXJVPABCDEGHIJKLMNOPQRSUAVQVRAE
        CLHIJNOQVSVRXKYLYKMJUEZWTXKEMJUEZLMJUEZYNXKEXHMKUIZMJSXKXPXHXQUCZMXQUCZ
        YQMJUEYAXKWMWPWSYRXTWPWQXBXEWOXJVTZYFAXQHIBCYHOQVDVEXKWNYSWMWNXFXJWAXQG
        IMYHRWFUPZXQIJKXHMYHNPVKVEVLXKLBDHUIZMKUIZMJUAXKXPUUBXQUCZYSUUCMJUEYAXK
        WMWPXCUUDXTYTYCAXQHIBDYHOQVDVEUUAXQIJKUUBMYHNPVKVEVLXKXPEXQUCZLXQUCZYSY
        OYPUDYNWBYAXKYBUUEYGAXQEIYHQWCUPXKYIUUFYJAXQLIYHQWCUPUUAXQHIJELMYHNOWDV
        JWEXKXPCXQUCZYKXQUCZYSYLYNUDWTVNYAXKWSUUGYFAXQCIYHQWCUPXKWMYBYIUUHXTYGY
        JAXQHIELYHOQVDVEUUAXQIJCYKMYHNWGVJWHWIWJFEXLJWKWL $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme3fa and ~ cdleme3 .  (Contributed by NM, 6-Jun-2012.) $)
      cdleme3h $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) /\ ( R e. A /\ -. R .<_ W ) )
           /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> F e. A ) $=
        ( chlt wcel wa wbr wn w3a wne cdleme3d cbs cfv cpmap clines cp0 simp23l
        simp1l simp1 simp21 simp22l simp3l lhpat2 syl112anc eqid hlatjcl simp3r
        co syl3anc jca cdleme3e syl13anc clat hllat syl simp21l lhpbase latmle2
        simp1r syl5eqbr simp23r nbrne2 syl2anc necomd linepmap syl31anc simp22r
        hlatlej1 wi hlatexch2 syl131anc oveq2i hlatlej2 latmle1 atbase latjle12
        wb latmcl mpbi2and lattr mpan2d hlatexch1 3syld nbrne1 simp23 syl5eqner
        mtod cdleme3c 2lnat syl322anc syl5eqel ) IUBUCZMGUCZUDZBAUCZBMJUEUFZUDZ
        CAUCZCMJUEUFZUDZDAUCZDMJUEUFZUDZUGZBCUHZDBCHVFZJUEZUFZUDZUGZFDEHVFZCLHV
        FZKVFZAABCDEFGHIJKLMNOPQRSTUAUIZYHXJYIIUJUKZUCZYJYMUCZYIIULUKZUKIUMUKZU
        CZYJYPUKYQUCZYIYJUHZYKIUNUKZUHYKAUCXJXKYBYGUPZYHXJXSEAUCZYNUUBXSXTXOXRX
        LYGUOZYHXLXOXPYCUUCXLYBYGUQZXLXOXRYAYGURZXPXQXOYAXLYGUSZXLYBYCYFUTZABCE
        GHIJKMNOPQRSVAVBZAYMHIDEYMVCZOQVDVGYHXJXPLAUCZYOUUBUUGYHXLXOXPXSYFUDUUK
        UUEUUFUUGYHXSYFUUDXLYBYCYFVEZVHABCDEFGHIJKLMNOPQRSTUAVIVJZAYMHICLUUJOQV
        DVGYHIVKUCZXSUUCDEUHYRYHXJUUNUUBIVLVMZUUDUUIYHEDYHEMJUEXTEDUHYHEYDMKVFZ
        MJSYHUUNYDYMUCZMYMUCZUUPMJUEUUOYHXJXMXPUUQUUBXMXNXRYAXLYGVNZUUGAYMHIBCU
        UJOQVDVGYHXKUURXJXKYBYGVQYMGIMUUJRVOVMZYMIJKYDMUUJNPVPVGVRXSXTXOXRXLYGV
        SZEDMJVTWAWBADEHIYPYQOQYQVCZYPVCZWCWDYHUUNXPUUKCLUHYSUUOUUGUUMYHLCYHLMJ
        UEZXQLCUHYHLBDHVFZMKVFZMJUAYHUUNUVEYMUCZUURUVFMJUEUUOYHXJXMXSUVGUUBUUSU
        UDAYMHIBDUUJOQVDVGZUUTYMIJKUVEMUUJNPVPVGVRZXPXQXOYAXLYGWELCMJVTWAWBACLH
        IYPYQOQUVBUVCWCWDYHDYIJUEZDYJJUEZUFYTYHXJXSUUCUVJUUBUUDUUIADEHIJNOQWFVG
        YHUVKYEUULYHUVKCDLHVFZJUEZCUVEJUEZYEYHXJXSXPUUKDLUHUVKUVMWGUUBUUDUUGUUM
        YHLDYHUVDXTLDUHUVIUVALDMJVTWAWBADCLHIJNOQWHWIYHUVMUVLUVEJUEZUVNYHUVLDUV
        FHVFZUVEJLUVFDHUAWJYHDUVEJUEZUVFUVEJUEZUVPUVEJUEZYHXJXMXSUVQUUBUUSUUDAB
        DHIJNOQWKVGYHUUNUVGUURUVRUUOUVHUUTYMIJKUVEMUUJNPWLVGYHUUNDYMUCZUVFYMUCZ
        UVGUVQUVRUDUVSWOUUOYHXSUVTUUDAYMDIUUJQWMVMYHUUNUVGUURUWAUUOUVHUUTYMIKUV
        EMUUJPWPVGUVHYMHIJDUVFUVEUUJNOWNVJWQVRYHUUNCYMUCZUVLYMUCZUVGUVMUVOUDUVN
        WGUUOYHXPUWBUUGAYMCIUUJQWMVMYHXJXSUUKUWCUUBUUDUUMAYMHIDLUUJOQVDVGUVHYMI
        JCUVLUVEUUJNWRVJWSYHXJXPXSXMCBUHUVNYEWGUUBUUGUUDUUSYHBCUUHWBACDBHIJNOQW
        TWIXAXEDYIYJJXBWAYHYKFUUAYLYHXLXOXPYCUDYAFUUAUHUUEUUFYHXPYCUUGUUHVHXLXO
        XRYAYGXCABCDEFGHIJKMUUANOPQRSTUUAVCZXFVJXDAYMYPIKYQYIYJUUAUUJPUWDQUVBUV
        CXGXHXI $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113.  See ~ cdleme3 .
       (Contributed by NM, 6-Oct-2012.) $)
    cdleme3fa $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) /\ ( R e. A /\ -. R .<_ W ) )
           /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> F e. A ) $=
      ( co eqid cdleme3h ) ABCDEFGHIJKBDHTLKTZLMNOPQRSUCUAUB $.

    $( Part of proof of Lemma E in [Crawley] p. 113. ` F ` represents f(r).
       ` W ` is the fiducial co-atom (hyperplane) w.  Here and in ~ cdleme3fa
       above, we show that f(r) ` e. ` W (4th line from bottom on p. 113),
       meaning it is an atom and not under w, which in our notation is
       expressed as ` F e. A /\ -. F .<_ W ` .  Their proof provides no details
       of our lemmas ~ cdleme3b through ~ cdleme3 , so there may be a simpler
       proof that we have overlooked.  (Contributed by NM, 7-Jun-2012.) $)
    cdleme3 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) /\ ( R e. A /\ -. R .<_ W ) )
     /\ ( P =/= Q /\ -. R .<_ ( P .\/ Q ) ) ) -> -. F .<_ W ) $=
      ( wcel chlt wa wbr wn w3a wne co eqid cdleme3g wceq clat cbs simp1l hllat
      cfv syl simp23l atbase cdleme3fa latlej2 syl3anc biantrurd hlatjcl simp1r
      lhpbase latlem12 syl13anc simp1 simp21l simp22l simp23 cdleme2 breq2d cal
      bitrd hlatl simp21 simp3l lhpat2 syl112anc atcmp 3bitrd necon3bbid mpbird
      wb ) IUATZLGTZUBZBATZBLJUCUDZUBZCATZCLJUCUDZUBZDATZDLJUCUDZUBZUEZBCUFZDBC
      HUGJUCUDZUBZUEZFLJUCZUDFEUFABCDEFGHIJKBDHUGLKUGZLMNOPQRSXDUHUIXBXCFEXBXCF
      DFHUGZJUCZXCUBZFEJUCZFEUJZXBXFXCXBIUKTZDIULUOZTZFXKTZXFXBWFXJWFWGWRXAUMZI
      UNUPZXBWOXLWOWPWKWNWHXAUQZAXKDIXKUHZPURUPXBFATZXMABCDEFGHIJKLMNOPQRSUSZAX
      KFIXQPURUPZXKHIJDFXQMNUTVAVBXBXGFXELKUGZJUCZXHXBXJXMXEXKTZLXKTZXGYBWEXOXT
      XBWFWOXRYCXNXPXSAXKHIDFXQNPVCVAXBWGYDWFWGWRXAVDXKGILXQQVEUPXKIJKFXELXQMOV
      FVGXBYAEFJXBWHWIWLWQYAEUJWHWRXAVHZWIWJWNWQWHXAVIWLWMWKWQWHXAVJZWHWKWNWQXA
      VKABCDEFGHIJKLMNOPQRSVLVGVMVOXBIVNTZXREATZXHXIWEXBWFYGXNIVPUPXSXBWHWKWLWS
      YHYEWHWKWNWQXAVQYFWHWRWSWTVRABCEGHIJKLMNOPQRVSVTAFEIJMPWAVAWBWCWD $.
  $}

  ${
    cdleme4.l $e |- .<_ = ( le ` K ) $.
    cdleme4.j $e |- .\/ = ( join ` K ) $.
    cdleme4.m $e |- ./\ = ( meet ` K ) $.
    cdleme4.a $e |- A = ( Atoms ` K ) $.
    cdleme4.h $e |- H = ( LHyp ` K ) $.
    cdleme4.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113. ` F ` and ` G ` represent
       f(s) and f_s(r).  Here show p ` \/ ` q = r ` \/ ` u at the top of
       p. 114.  (Contributed by NM, 7-Jun-2012.) $)
    cdleme4 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A
   /\ ( R e. A /\ -. R .<_ W ) ) /\ R .<_ ( P .\/ Q ) )
  -> ( P .\/ Q ) = ( R .\/ U ) ) $=
      ( wcel co wceq chlt wa wbr wn w3a oveq2i cp1 cfv cbs simp1l simp21 simp22
      simp23l hlatjcl syl3anc simp1r lhpbase syl simp3 atmod3i1 syl131anc simp1
      eqid simp23 lhpjat2 syl2anc oveq2d col hlol olm11 3eqtrd syl5req ) HUARZK
      FRZUBZBARZCARZDARZDKIUCUDZUBZUEZDBCGSZIUCZUEZDEGSDWBKJSZGSZWBEWEDGQUFWDWF
      WBDKGSZJSZWBHUGUHZJSZWBWDVMVRWBHUIUHZRZKWKRZWCWFWHTVMVNWAWCUJZVRVSVPVQVOW
      CUMWDVMVPVQWLWNVOVPVQVTWCUKVOVPVQVTWCULAWKGHBCWKVCZMOUNUOZWDVNWMVMVNWAWCU
      PWKFHKWOPUQURVOWAWCUSAWKDGHIJWBKWOLMNOUTVAWDWGWIWBJWDVOVTWGWITVOWAWCVBVOV
      PVQVTWCVDADWIFGHIKLMWIVCZOPVEVFVGWDHVHRZWLWJWBTWDVMWRWNHVIURWPWKWIHJWBWON
      WQVJVFVKVL $.

    cdleme4.f $e |- F
      = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme4.g $e |- G
      = ( ( P .\/ Q ) ./\ ( F .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 114 top. ` G ` represents
       f_s(r).  Auxiliary lemma derived from ~ cdleme5 .  We show f_s(r) ` <_ `
       p ` \/ ` q.  (Contributed by NM, 10-Nov-2012.) $)
    cdleme4a $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( P e. A /\ Q e. A /\ R e. A ) /\ S e. A ) -> G .<_ ( P .\/ Q ) ) $=
      ( chlt wcel wa w3a co clat cbs cfv wbr simp1l hllat simp21 simp22 hlatjcl
      eqid syl3anc simp1r simp3 cdleme1b syl23anc simp23 lhpbase latmcl latmle1
      syl latjcl syl5eqbr ) KUCUDZNIUDZUEZBAUDZCAUDZDAUDZUFZEAUDZUFZHBCJUGZGDEJ
      UGZNMUGZJUGZMUGZVSLUBVRKUHUDZVSKUIUJZUDZWBWEUDZWCVSLUKVRVJWDVJVKVPVQULZKU
      MVGZVRVJVMVNWFWHVLVMVNVOVQUNZVLVMVNVOVQUOZAWEJKBCWEUQZPRUPURVRWDGWEUDZWAW
      EUDZWGWIVRVJVKVMVNVQWMWHVJVKVPVQUSZWJWKVLVPVQUTZAWEBCEFGIJKLMNOPQRSTUAWLV
      AVBVRWDVTWEUDZNWEUDZWNWIVRVJVOVQWQWHVLVMVNVOVQVCWPAWEJKDEWLPRUPURVRVKWRWO
      WEIKNWLSVDVGWEKMVTNWLQVEURWEJKGWAWLPVHURWEKLMVSWBWLOQVFURVI $.

    $( Part of proof of Lemma E in [Crawley] p. 113. ` G ` represents f_s(r).
       We show r ` \/ ` f_s(r)) = p ` \/ ` q at the top of p. 114.
       (Contributed by NM, 7-Jun-2012.) $)
    cdleme5 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ Q e. A /\ ( R e. A /\ -. R .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ R .<_ ( P .\/ Q ) ) )
                -> ( R .\/ G ) = ( P .\/ Q ) ) $=
      ( chlt wcel wa wbr wn w3a co oveq2i cbs wceq simp1l simp23l simp21 simp22
      cfv eqid hlatjcl syl3anc hllat syl simp1 simp3ll cdleme1b syl13anc simp1r
      clat lhpbase latmcl latjcl simp3r syl131anc atbase latlej2 latj12 cdleme4
      atmod3i1 cdleme0aa 3adant3l oveq2d latjcom cdleme1 eqtrd 3eqtr4d hlatlej1
      simp3l cp1 simp23r lhpjat2 syl12anc col hlol syl2anc breqtrd wb latleeqm1
      olm11 mpbid syl5eq ) KUCUDZNIUDZUEZBAUDZCAUDZDAUDZDNLUFUGZUEZUHZEAUDZENLU
      FUGZUEZDBCJUIZLUFZUEZUHZDHJUIDXMGDEJUIZNMUIZJUIZMUIZJUIZXMHXTDJUBUJXPYAXM
      DXSJUIZMUIZXMXPXAXFXMKUKUQZUDZXSYDUDZXNYAYCULXAXBXIXOUMZXFXGXDXEXCXOUNZXP
      XAXDXEYEYGXCXDXEXHXOUOZXCXDXEXHXOUPZAYDJKBCYDURZPRUSUTZXPKVHUDZGYDUDZXRYD
      UDZYFXPXAYMYGKVAVBZXPXCXDXEXJYNXCXIXOVCZYIYJXJXKXNXCXIVDZAYDBCEFGIJKLMNOP
      QRSTUAYKVEVFZXPYMXQYDUDZNYDUDZYOYPXPXAXFXJYTYGYHYRAYDJKDEYKPRUSUTZXPXBUUA
      XAXBXIXOVGYDIKNYKSVIVBZYDKMXQNYKQVJUTZYDJKGXRYKPVKUTZXCXIXLXNVLAYDDJKLMXM
      XSYKOPQRVRVMXPXMYBLUFZYCXMULZXPXMEXMJUIZYBLXPYMEYDUDZYEXMUUHLUFYPXPXJUUIY
      RAYDEKYKRVNVBZYLYDJKLEXMYKOPVOUTXPUUHGDXRJUIZJUIZYBXPDGEJUIZJUIZGXQJUIZUU
      HUULXPYMDYDUDZYNUUIUUNUUOULYPXPXFUUPYHAYDDKYKRVNVBZYSUUJYDJKDGEYKPVPVFXPE
      DFJUIZJUIZDEFJUIZJUIZUUHUUNXPYMUUIUUPFYDUDZUUSUVAULYPUUJUUQXPXCXDXEUVBYQY
      IYJAYDBCFIJKLMNOPQRSTYKVSUTYDJKEDFYKPVPVFXPXMUUREJXCXIXNXMUURULXLABCDFIJK
      LMNOPQRSTVQVTWAXPUUMUUTDJXPUUMEGJUIZUUTXPYMYNUUIUUMUVCULYPYSUUJYDJKGEYKPW
      BUTXPXCXDXEXLUVCUUTULYQYIYJXCXIXLXNWGABCEFGIJKLMNOPQRSTUAWCVFWDWAWEXPUUKX
      QGJXPUUKXQDNJUIZMUIZXQXPXAXFYTUUADXQLUFZUUKUVEULYGYHUUBUUCXPXAXFXJUVFYGYH
      YRADEJKLOPRWFUTAYDDJKLMXQNYKOPQRVRVMXPUVEXQKWHUQZMUIZXQXPUVDUVGXQMXPXCXFX
      GUVDUVGULYQYHXFXGXDXEXCXOWIADUVGIJKLNOPUVGURZRSWJWKWAXPKWLUDZYTUVHXQULXPX
      AUVJYGKWMVBUUBYDUVGKMXQYKQUVIWRWNWDWDWAWEXPYMYNUUPYOUULYBULYPYSUUQUUDYDJK
      GDXRYKPVPVFWDWOXPYMYEYBYDUDZUUFUUGWPYPYLXPYMUUPYFUVKYPUUQUUEYDJKDXSYKPVKU
      TYDKLMXMYBYKOQWQUTWSWDWT $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  This expresses (r ` \/ `
       f_s(r)) ` /\ ` w = u at the top of p. 114.  (Contributed by NM,
       7-Jun-2012.) $)
    cdleme6 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ Q e. A /\ ( R e. A /\ -. R .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ R .<_ ( P .\/ Q ) ) )
                -> ( ( R .\/ G ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn w3a co cdleme5 oveq1d syl6eqr ) KUCUDNIUDUEBAUDCAUD
      DAUDDNLUFUGUEUHEAUDENLUFUGUEDBCJUIZLUFUEUHZDHJUIZNMUIUMNMUIFUNUOUMNMABCDE
      FGHIJKLMNOPQRSTUAUBUJUKTUL $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme7ga and ~ cdleme7 .  (Contributed by NM, 7-Jun-2012.) $)
    cdleme7aa $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ Q e. A )
       /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
                -> -. R .<_ ( U .\/ S ) ) $=
      ( chlt wcel wa wbr wn w3a wne co simp33 wi simp11l simp2ll simp2rl simp11
      simp12 simp13 simp31 lhpat2 syl112anc clat cbs cfv hllat syl simp12l eqid
      hlatjcl syl3anc simp11r lhpbase latmle2 syl5eqbr simp2lr nbrne2 hlatexch1
      necomd syl2anc syl131anc wceq simp2l simp32 cdleme4 hlatjcom eqtrd breq2d
      sylibrd mtod ) KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZUHZDAUDZDNLUFUGZUEZEAUD
      ZENLUFUGZUEZUEZBCUIZDBCJUJZLUFZEXFLUFZUGZUHZUHZDFEJUJLUFZXHWQXDXEXGXIUKXK
      XLEFDJUJZLUFZXHXKWJWRXAFAUDZDFUIZXLXNULWJWKWOWPXDXJUMZWRWSXCWQXJUNZXAXBWT
      WQXJUOXKWLWOWPXEXOWLWOWPXDXJUPZWLWOWPXDXJUQWLWOWPXDXJURZWQXDXEXGXIUSABCFI
      JKLMNOPQRSTUTVAZXKFNLUFZWSXPXKFXFNMUJZNLTXKKVBUDZXFKVCVDZUDZNYEUDZYCNLUFX
      KWJYDXQKVEVFXKWJWMWPYFXQWMWNWLWPXDXJVGZXTAYEJKBCYEVHZPRVIVJXKWKYGWJWKWOWP
      XDXJVKYEIKNYISVLVFYEKLMXFNYIOQVMVJVNWRWSXCWQXJVOYBWSUEFDFDNLVPVRVSADEFJKL
      OPRVQVTXKXFXMELXKXFDFJUJZXMXKWLWMWPWTXGXFYJWAXSYHXTWQWTXCXJWBWQXDXEXGXIWC
      ABCDFIJKLMNOPQRSTWDVTXKWJWRXOYJXMWAXQXRYAAJKDFPRWEVJWFWGWHWI $.

    ${
      cdleme7.v $e |- V = ( ( R .\/ S ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme7ga and ~ cdleme7 .  (Contributed by NM, 7-Jun-2012.) $)
      cdleme7a $p |- G = ( ( P .\/ Q ) ./\ ( F .\/ V ) ) $=
        ( co oveq2i eqtr4i ) HBCJUEZGDEJUEOMUEZJUEZMUEUHGNJUEZMUEUCUKUJUHMNUIGJ
        UDUFUFUG $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme7ga and ~ cdleme7 .  (Contributed by NM, 7-Jun-2012.) $)
      cdleme7b $p |- ( ( ( K e. HL /\ W e. H ) /\ ( R e. A /\ -. R .<_ W )
            /\ ( S e. A /\ -. S .<_ ( P .\/ Q ) /\ R .<_ ( P .\/ Q ) ) )
          -> V e. A ) $=
        ( chlt wcel wa wbr wn w3a wne simp1 simp31 simp33 simp32 nbrne2 syl2anc
        co simp2 lhpat syl112anc syl5eqel ) KUEUFOIUFUGZDAUFDOLUHUIUGZEAUFZEBCJ
        URZLUHUIZDVFLUHZUJZUJZNDEJUROMURZAUDVJVCVDVEDEUKZVKAUFVCVDVIULVCVDVIUSV
        CVDVEVGVHUMVJVHVGVLVCVDVEVGVHUNVCVDVEVGVHUODEVFLUPUQADEIJKLMOPQRSTUTVAV
        B $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme7ga and ~ cdleme7 .  (Contributed by NM, 7-Jun-2012.) $)
      cdleme7c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ Q e. A )
       /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> U =/= V ) $=
        ( chlt wcel wa wbr wn w3a wne co cp0 wceq oveq12i simp11 simp12l simp13
        cfv simp2l simp32 cdleme4 syl131anc oveq1d simp11l simp12 simp31 lhpat2
        syl112anc simp2rl simp2ll cbs hllat syl hlatjcl syl3anc simp11r lhpbase
        clat latmle2 syl5eqbr simp2rr syl2anc cdleme7aa 2llnma2 syl132anc eqtrd
        eqid nbrne2 col hlol latmmdir syl13anc lhpmat 3eqtr3d syl5eq cal simp33
        wb hlatl cdleme7b syl113anc atnem0 mpbird ) KUEUFZOIUFZUGZBAUFZBOLUHUIZ
        UGZCAUFZUJZDAUFZDOLUHUIZUGZEAUFZEOLUHUIZUGZUGZBCUKZDBCJULZLUHZEYALUHUIZ
        UJZUJZFNUKZFNMULZKUMUSZUNZYEYGYAOMULZDEJULZOMULZMULZYHFYJNYLMUAUDUOYEYA
        YKMULZOMULZDOMULZYMYHYEYNDOMYEYNDFJULZYKMULZDYEYAYQYKMYEXGXHXKXOYBYAYQU
        NXGXJXKXSYDUPZXHXIXGXKXSYDUQZXGXJXKXSYDURZXLXOXRYDUTZXLXSXTYBYCVAZABCDF
        IJKLMOPQRSTUAVBVCVDYEXEFAUFZXPXMFEUKZDFEJULLUHUIYRDUNXEXFXJXKXSYDVEZYEX
        GXJXKXTUUDYSXGXJXKXSYDVFUUAXLXSXTYBYCVGABCFIJKLMOPQRSTUAVHVIZXPXQXOXLYD
        VJZXMXNXRXLYDVKZYEFOLUHXQUUEYEFYJOLUAYEKVSUFZYAKVLUSZUFZOUUKUFZYJOLUHYE
        XEUUJUUFKVMVNYEXEXHXKUULUUFYTUUAAUUKJKBCUUKWHZQSVOVPZYEXFUUMXEXFXJXKXSY
        DVQUUKIKOUUNTVRVNZUUKKLMYAOUUNPRVTVPWAXPXQXOXLYDWBFEOLWIWCABCDEFGHIJKLM
        OPQRSTUAUBUCWDAFEDJKLMPQRSWEWFWGVDYEKWJUFZUULYKUUKUFZUUMYOYMUNYEXEUUQUU
        FKWKVNUUOYEXEXMXPUURUUFUUIUUHAUUKJKDEUUNQSVOVPUUPUUKKMYAYKOUUNRWLWMYEXG
        XOYPYHUNYSUUBADIKLMOYHPRYHWHZSTWNWCWOWPYEKWQUFZUUDNAUFZYFYIWSYEXEUUTUUF
        KWTVNUUGYEXGXOXPYCYBUVAYSUUBUUHXLXSXTYBYCWRUUCABCDEFGHIJKLMNOPQRSTUAUBU
        CUDXAXBAFNKMYHRUUSSXCVPXD $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme7ga and ~ cdleme7 .  (Contributed by NM, 8-Jun-2012.) $)
      cdleme7d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
                -> G =/= U ) $=
        ( chlt wcel wa wbr wn w3a wne co cdleme7a cbs cfv simp11l hllat simp12l
        clat syl simp13l eqid hlatjcl simp11 simp12 simp13 simp2r simp31 simp33
        syl3anc cdleme3fa syl132anc simp2rl cdleme7b syl113anc latmle2 syl5eqbr
        simp2l simp32 lhpat2 syl112anc simp2 simp3 cdleme7c syl311anc hlatexch2
        cdleme3 wi syl131anc simp11r lhpbase simp2ll latjle12 syl13anc mpbi2and
        wb atbase lattr mpan2d syld mtod nbrne2 syl2anc ) KUEUFZOIUFZUGZBAUFZBO
        LUHUIZUGZCAUFZCOLUHUIZUGZUJZDAUFZDOLUHUIZUGZEAUFZEOLUHUIZUGZUGZBCUKZDBC
        JULZLUHZEYBLUHUIZUJZUJZHGNJULZLUHFYGLUHZUIHFUKYFHYBYGMULZYGLABCDEFGHIJK
        LMNOPQRSTUAUBUCUDUMYFKUSUFZYBKUNUOZUFZYGYKUFZYIYGLUHYFXDYJXDXEXIXLXTYEU
        PZKUQUTZYFXDXGXJYLYNXGXHXFXLXTYEURXJXKXFXIXTYEVAZAYKJKBCYKVBZQSVCVJZYFX
        DGAUFZNAUFZYMYNYFXFXIXLXSYAYDYSXFXIXLXTYEVDZXFXIXLXTYEVEZXFXIXLXTYEVFZX
        MXPXSYEVGZXMXTYAYCYDVHZXMXTYAYCYDVIZABCEFGIJKLMOPQRSTUAUBVKVLZYFXFXPXQY
        DYCYTUUAXMXPXSYEVRXQXRXPXMYEVMZUUFXMXTYAYCYDVSABCDEFGHIJKLMNOPQRSTUAUBU
        CUDVNVOZAYKJKGNYQQSVCVJYKKLMYBYGYQPRVPVJVQYFYHGOLUHZYFXFXIXLXSYAYDUUJUI
        UUAUUBUUCUUDUUEUUFABCEFGIJKLMOPQRSTUAUBWGVLYFYHGFNJULZLUHZUUJYFXDFAUFZY
        SYTFNUKZYHUULWHYNYFXFXIXJYAUUMUUAUUBYPUUEABCFIJKLMOPQRSTUAVTWAZUUGUUIYF
        XFXIXJXTYEUUNUUAUUBYPXMXTYEWBXMXTYEWCABCDEFGHIJKLMNOPQRSTUAUBUCUDWDWEAF
        GNJKLPQSWFWIYFUULUUKOLUHZUUJYFFOLUHZNOLUHZUUPYFFYBOMULZOLUAYFYJYLOYKUFZ
        UUSOLUHYOYRYFXEUUTXDXEXIXLXTYEWJYKIKOYQTWKUTZYKKLMYBOYQPRVPVJVQYFNDEJUL
        ZOMULZOLUDYFYJUVBYKUFZUUTUVCOLUHYOYFXDXNXQUVDYNXNXOXSXMYEWLUUHAYKJKDEYQ
        QSVCVJUVAYKKLMUVBOYQPRVPVJVQYFYJFYKUFZNYKUFZUUTUUQUURUGUUPWPYOYFUUMUVEU
        UOAYKFKYQSWQUTYFYTUVFUUIAYKNKYQSWQUTUVAYKJKLFNOYQPQWMWNWOYFYJGYKUFZUUKY
        KUFZUUTUULUUPUGUUJWHYOYFYSUVGUUGAYKGKYQSWQUTYFXDUUMYTUVHYNUUOUUIAYKJKFN
        YQQSVCVJUVAYKKLGUUKOYQPWRWNWSWTXAHFYGLXBXC $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
         ~ cdleme7ga and ~ cdleme7 .  (Contributed by NM, 8-Jun-2012.) $)
      cdleme7e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> G =/= ( 0. ` K ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cp0 cfv cbs ccvr simp11l hllat simp2ll
        clat eqid atbase cops hlop op0cl latjcl syl3anc simp12l simp13l hlatjcl
        3syl simp11 simp2rl cdleme1b syl13anc simp11r lhpbase syl5eqel syl5eqbr
        latmcl latmle2 simp2lr nbrne2 necomd syl2anc wb simp12 simp31 syl112anc
        syl lhpat2 atcvr1 mpbid wceq hlol olj01 simp2l simp2r cdleme5 syl132anc
        col simp32 cdleme4 syl131anc eqtrd 3brtr4d cvrne syl31anc oveq2 necon3i
        ) KUEUFZOIUFZUGZBAUFZBOLUHUIZUGZCAUFZCOLUHUIZUGZUJZDAUFZDOLUHUIZUGZEAUF
        ZEOLUHUIZUGZUGZBCUKZDBCJULZLUHZEYILUHUIZUJZUJZKUMUNZHYMDYNJULZDHJULZUKZ
        YNHUKYMXKYOKUOUNZUFZYPYRUFZYOYPKUPUNZUHYQXKXLXPXSYGYLUQZYMKUTUFZDYRUFZY
        NYRUFZYSYMXKUUCUUBKURWJZYMYAUUDYAYBYFXTYLUSZAYRDKYRVAZSVBWJZYMXKKVCUFUU
        EUUBKVDYRKYNUUHYNVAZVEVKYRJKDYNUUHQVFVGYMUUCUUDHYRUFYTUUFUUIYMHYIGDEJUL
        ZOMULZJULZMULZYRUCYMUUCYIYRUFZUUMYRUFZUUNYRUFUUFYMXKXNXQUUOUUBXNXOXMXSY
        GYLVHZXQXRXMXPYGYLVIZAYRJKBCUUHQSVJVGZYMUUCGYRUFZUULYRUFZUUPUUFYMXMXNXQ
        YDUUTXMXPXSYGYLVLZUUQUURYDYEYCXTYLVMZAYRBCEFGIJKLMOPQRSTUAUBUUHVNVOYMUU
        CUUKYRUFZOYRUFZUVAUUFYMXKYAYDUVDUUBUUGUVCAYRJKDEUUHQSVJVGYMXLUVEXKXLXPX
        SYGYLVPYRIKOUUHTVQWJZYRKMUUKOUUHRVTVGYRJKGUULUUHQVFVGYRKMYIUUMUUHRVTVGV
        RYRJKDHUUHQVFVGYMDDFJULZYOYPUUAYMDFUKZDUVGUUAUHZYMFOLUHZYBUVHYMFYIOMULZ
        OLUAYMUUCUUOUVEUVKOLUHUUFUUSUVFYRKLMYIOUUHPRWAVGVSYAYBYFXTYLWBUVJYBUGFD
        FDOLWCWDWEYMXKYAFAUFZUVHUVIWFUUBUUGYMXMXPXQYHUVLUVBXMXPXSYGYLWGUURXTYGY
        HYJYKWHABCFIJKLMOPQRSTUAWKWIAUUADFJKQUUAVAZSWLVGWMYMKXAUFZUUDYODWNYMXKU
        VNUUBKWOWJUUIYRJKDYNUUHQUUJWPWEYMYPYIUVGYMXMXNXQYCYFYJYPYIWNUVBUUQUURXT
        YCYFYLWQZXTYCYFYLWRXTYGYHYJYKXBZABCDEFGHIJKLMOPQRSTUAUBUCWSWTYMXMXNXQYC
        YJYIUVGWNUVBUUQUURUVOUVPABCDFIJKLMOPQRSTUAXCXDXEXFUEYRUUAKYOYPUUHUVMXGX
        HYNHYOYPYNHDJXIXJWJWD $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113.  See ~ cdleme7 .
       (Contributed by NM, 8-Jun-2012.) $)
    cdleme7ga $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> G e. A ) $=
      ( chlt wcel wa wbr wn w3a wne co cbs cfv cpmap clines cp0 simp11l simp12l
      simp13l eqid hlatjcl syl3anc simp11 simp12 simp13 simp2r simp31 cdleme3fa
      simp33 syl132anc simp2l simp32 cdleme7b syl113anc clat hllat syl linepmap
      simp2rl syl31anc simp2ll simp11r lhpbase latmle2 cdleme3 syl2anc cdleme7c
      nbrne2 necomd atbase latmcl latlej2 syl323anc cal lhpat2 syl112anc atncmp
      hlatl mpbird latlem12 syl13anc biimpd mpan2d breq2i syl6ibr mtod cdleme7e
      wb nbrne1 syl5eqner 2lnat syl322anc syl5eqel ) KUCUDZNIUDZUEZBAUDZBNLUFUG
      ZUEZCAUDZCNLUFUGZUEZUHZDAUDZDNLUFUGZUEZEAUDZENLUFUGZUEZUEZBCUIZDBCJUJZLUF
      ZEYKLUFUGZUHZUHZHYKGDEJUJZNMUJZJUJZMUJZAUBYOXMYKKUKULZUDZYRYTUDZYKKUMULZU
      LKUNULZUDZYRUUCULUUDUDZYKYRUIZYSKUOULZUIYSAUDXMXNXRYAYIYNUPZYOXMXPXSUUAUU
      IXPXQXOYAYIYNUQZXSXTXOXRYIYNURZAYTJKBCYTUSZPRUTVAZYOXMGAUDZYQAUDZUUBUUIYO
      XOXRYAYHYJYMUUNXOXRYAYIYNVBZXOXRYAYIYNVCZXOXRYAYIYNVDZYBYEYHYNVEZYBYIYJYL
      YMVFZYBYIYJYLYMVHZABCEFGIJKLMNOPQRSTUAVGVIZYOXOYEYFYMYLUUOUUPYBYEYHYNVJZY
      FYGYEYBYNVRZUVAYBYIYJYLYMVKZABCDEFGHIJKLMYQNOPQRSTUAUBYQUSZVLVMZAYTJKGYQU
      ULPRUTVAYOKVNUDZXPXSYJUUEYOXMUVHUUIKVOVPZUUJUUKUUTABCJKUUCUUDPRUUDUSZUUCU
      SZVQVSYOUVHUUNUUOGYQUIZUUFUVIUVBUVGYOYQNLUFZGNLUFUGZUVLYOUVHYPYTUDZNYTUDZ
      UVMUVIYOXMYCYFUVOUUIYCYDYHYBYNVTUVDAYTJKDEUULPRUTVAZYOXNUVPXMXNXRYAYIYNWA
      YTIKNUULSWBVPZYTKLMYPNUULOQWCVAZYOXOXRYAYHYJYMUVNUUPUUQUURUUSUUTUVAABCEFG
      IJKLMNOPQRSTUAWDVIUVMUVNUEYQGYQGNLWGWHWEAGYQJKUUCUUDPRUVJUVKVQVSYOYQYRLUF
      ZYQYKLUFZUGZUUGYOUVHGYTUDZYQYTUDZUVTUVIYOUUNUWCUVBAYTGKUULRWIVPYOUVHUVOUV
      PUWDUVIUVQUVRYTKMYPNUULQWJVAZYTJKLGYQUULOPWKVAYOUWAYQFLUFZYOUWFUGZYQFUIZY
      OFYQYOXOXRXSYEYHYJYLYMFYQUIUUPUUQUUKUVCUUSUUTUVEUVAABCDEFGHIJKLMYQNOPQRST
      UAUBUVFWFWLWHYOKWMUDZUUOFAUDZUWGUWHXGYOXMUWIUUIKWQVPUVGYOXOXRXSYJUWJUUPUU
      QUUKUUTABCFIJKLMNOPQRSTWNWOAYQFKLORWPVAWRYOUWAYQYKNMUJZLUFZUWFYOUWAUVMUWL
      UVSYOUWAUVMUEZUWLYOUVHUWDUUAUVPUWMUWLXGUVIUWEUUMUVRYTKLMYQYKNUULOQWSWTXAX
      BFUWKYQLTXCXDXEUVTUWBUEYRYKYQYRYKLXHWHWEYOYSHUUHUBABCDEFGHIJKLMYQNOPQRSTU
      AUBUVFXFXIAYTUUCKMUUDYKYRUUHUULQUUHUSRUVJUVKXJXKXL $.

    $( Part of proof of Lemma E in [Crawley] p. 113. ` G ` and ` F ` represent
       f_s(r) and f(s) respectively. ` W ` is the fiducial co-atom (hyperplane)
       that they call w.  Here and in ~ cdleme7ga above, we show that f_s(r)
       ` e. ` W (top of p. 114), meaning it is an atom and not under w, which
       in our notation is expressed as ` G e. A /\ -. G .<_ W ` .  (Note that
       we do not have a symbol for their W.) Their proof provides no details of
       our ~ cdleme7aa through ~ cdleme7 , so there may be a simpler proof that
       we have overlooked.  (Contributed by NM, 9-Jun-2012.) $)
    cdleme7 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
     -> -. G .<_ W ) $=
      ( chlt wcel wa wbr wn w3a co eqid cdleme7d wceq simp11l simp2ll cdleme7ga
      wne hlatlej2 syl3anc biantrurd clat cbs cfv wb syl atbase hlatjcl simp11r
      lhpbase latlem12 syl13anc simp11 simp12l simp13l simp2l cdleme6 syl132anc
      hllat simp2r simp32 breq2d bitrd cal hlatl simp12 simp31 lhpat2 syl112anc
      atcmp 3bitrd necon3bbid mpbird ) KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZCNLUF
      UGZUEZUHZDAUDZDNLUFUGZUEZEAUDENLUFUGUEZUEZBCUPZDBCJUIZLUFZEXHLUFUGZUHZUHZ
      HNLUFZUGHFUPABCDEFGHIJKLMDEJUINMUIZNOPQRSTUAUBXNUJUKXLXMHFXLXMHDHJUIZLUFZ
      XMUEZHFLUFZHFULZXLXPXMXLWLXBHAUDZXPWLWMWQWTXFXKUMZXBXCXEXAXKUNZABCDEFGHIJ
      KLMNOPQRSTUAUBUOZADHJKLOPRUQURUSXLXQHXONMUIZLUFZXRXLKUTUDZHKVAVBZUDZXOYGU
      DZNYGUDZXQYEVCXLWLYFYAKVQVDXLXTYHYCAYGHKYGUJZRVEVDXLWLXBXTYIYAYBYCAYGJKDH
      YKPRVFURXLWMYJWLWMWQWTXFXKVGYGIKNYKSVHVDYGKLMHXONYKOQVIVJXLYDFHLXLWNWOWRX
      DXEXIYDFULWNWQWTXFXKVKZWOWPWNWTXFXKVLWRWSWNWQXFXKVMZXAXDXEXKVNXAXDXEXKVRX
      AXFXGXIXJVSABCDEFGHIJKLMNOPQRSTUAUBVOVPVTWAXLKWBUDZXTFAUDZXRXSVCXLWLYNYAK
      WCVDYCXLWNWQWRXGYOYLWNWQWTXFXKWDYMXAXFXGXIXJWEABCFIJKLMNOPQRSTWFWGAHFKLOR
      WHURWIWJWK $.
  $}

  ${
    cdleme8.l $e |- .<_ = ( le ` K ) $.
    cdleme8.j $e |- .\/ = ( join ` K ) $.
    cdleme8.m $e |- ./\ = ( meet ` K ) $.
    cdleme8.a $e |- A = ( Atoms ` K ) $.
    cdleme8.h $e |- H = ( LHyp ` K ) $.
    cdleme8.4 $e |- C = ( ( P .\/ S ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 2nd paragraph on p. 114.
       ` C ` represents s_1.  In their notation, we prove p ` \/ ` s_1 = p
       ` \/ ` s.  (Contributed by NM, 9-Jun-2012.) $)
    cdleme8 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ S e. A ) -> ( P .\/ C ) = ( P .\/ S ) ) $=
      ( wcel co wceq syl chlt wa wbr w3a oveq2i cp1 cfv cbs simp1l simp2l hllat
      clat eqid atbase 3ad2ant3 latjcl syl3anc simp1r lhpbase latlej1 syl131anc
      wn atmod3i1 lhpjat2 3adant3 oveq2d col hlol olm11 syl2anc 3eqtrd syl5eq )
      GUAQZJEQZUBZCAQZCJHUCVBZUBZDAQZUDZCBFRCCDFRZJIRZFRZWABWBCFPUEVTWCWACJFRZI
      RZWAGUFUGZIRZWAVTVMVPWAGUHUGZQZJWHQZCWAHUCZWCWESVMVNVRVSUIZVOVPVQVSUJZVTG
      ULQZCWHQZDWHQZWIVTVMWNWLGUKTZVTVPWOWMAWHCGWHUMZNUNTZVSVOWPVRAWHDGWRNUNUOZ
      WHFGCDWRLUPUQZVTVNWJVMVNVRVSURWHEGJWROUSTVTWNWOWPWKWQWSWTWHFGHCDWRKLUTUQA
      WHCFGHIWAJWRKLMNVCVAVTWDWFWAIVOVRWDWFSVSACWFEFGHJKLWFUMZNOVDVEVFVTGVGQZWI
      WGWASVTVMXCWLGVHTXAWHWFGIWAWRMXBVIVJVKVL $.

    $( Part of proof of Lemma E in [Crawley] p. 113. ` C ` represents s_1,
       which we prove is an atom.  (Contributed by NM, 10-Jun-2012.) $)
    cdleme9a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( S e. A /\ P =/= S ) ) -> C e. A ) $=
      ( lhpat2 ) ACDBEFGHIJKLMNOPQ $.
  $}

  ${
    cdleme9b.b $e |- B = ( Base ` K ) $.
    cdleme9b.j $e |- .\/ = ( join ` K ) $.
    cdleme9b.m $e |- ./\ = ( meet ` K ) $.
    cdleme9b.a $e |- A = ( Atoms ` K ) $.
    cdleme9b.h $e |- H = ( LHyp ` K ) $.
    cdleme9b.c $e |- C = ( ( P .\/ S ) ./\ W ) $.
    $( Utility lemma for Lemma E in [Crawley] p. 113.  (Contributed by NM,
       9-Oct-2012.) $)
    cdleme9b $p |- ( ( K e. HL /\ ( P e. A /\ S e. A /\ W e. H ) ) ->
       C e. B ) $=
      ( chlt wcel w3a co clat hllat adantr hlatjcl 3adant3r3 simpr3 lhpbase syl
      wa latmcl syl3anc syl5eqel ) HQRZDARZEARZJFRZSZUIZCDEGTZJITZBPURHUARZUSBR
      ZJBRZUTBRUMVAUQHUBUCUMUNUOVBUPABGHDEKLNUDUEURUPVCUMUNUOUPUFBFHJKOUGUHBHIU
      SJKMUJUKUL $.
  $}

  ${
    cdleme9.l $e |- .<_ = ( le ` K ) $.
    cdleme9.j $e |- .\/ = ( join ` K ) $.
    cdleme9.m $e |- ./\ = ( meet ` K ) $.
    cdleme9.a $e |- A = ( Atoms ` K ) $.
    cdleme9.h $e |- H = ( LHyp ` K ) $.
    cdleme9.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme9.f $e |- F
      = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme9.c $e |- C = ( ( P .\/ S ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 2nd paragraph on p. 114.
       ` C ` and ` F ` represent s_1 and f(s) respectively.  In their notation,
       we prove f(s) ` \/ ` s_1 = q ` \/ ` s_1.  (Contributed by NM,
       10-Jun-2012.) $)
    cdleme9 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ Q e. A /\ ( S e. A /\ -. S .<_ W ) ) /\ -. S .<_ ( P .\/ Q ) )
             -> ( F .\/ C ) = ( Q .\/ C ) ) $=
      ( chlt wcel wa wbr wn w3a co cdleme3d oveq1i cbs wceq simp1l simp1 simp21
      cfv wne simp23l clat hllat syl eqid atbase simp21l simp22 simp3 latnlej1l
      necomd syl131anc cdleme9a syl112anc cdleme0aa syl3anc latjcl hlatlej2 cp1
      hlatjcl atmod4i1 simp1r lhpbase atmod3i1 simp23r syl12anc oveq2d col hlol
      lhpjat2 syl2anc 3eqtrrd oveq2i syl6reqr syl13anc hlatj32 latjcom hlatlej1
      olm11 oveq1d latj32 3eqtrd syl5eq 3eqtr4d eqtrd latmle1 syl5eqbr latjlej2
      wi mpd wb latleeqm2 mpbid ) JUBUCZMHUCZUDZCAUCZCMKUEUFZUDZDAUCZEAUCZEMKUE
      UFZUDZUGZECDIUHZKUEUFZUGZGBIUHEFIUHZDBIUHZLUHZBIUHZYFGYGBIACDEFGHIJKLBMNO
      PQRSTUAUIUJYDYHYEBIUHZYFLUHZDCEIUHZIUHZYFLUHZYFYDXKBAUCZYEJUKUPZUCZYFYOUC
      ZBYFKUEZYHYJULXKXLYAYCUMZYDXMXPXRCEUQZYNXMYAYCUNZXMXPXQXTYCUOZXRXSXPXQXMY
      CURZYDJUSUCZEYOUCZCYOUCZDYOUCZYCYTYDXKUUDYSJUTVAZYDXRUUEUUCAYOEJYOVBZQVCV
      AZYDXNUUFXNXOXQXTXMYCVDZAYOCJUUIQVCVAZYDXQUUGXMXPXQXTYCVEZAYODJUUIQVCVAZX
      MYAYCVFUUDUUEUUFUUGUGYCUGECYOIJKECDUUINOVGVHVIABCEHIJKLMNOPQRUAVJVKZYDUUD
      UUEFYOUCZYPUUHUUJYDXMXNXQUUPUUAUUKUUMAYOCDFHIJKLMNOPQRSUUIVLVMZYOIJEFUUIO
      VNVMYDXKXQYNYQYSUUMUUOAYOIJDBUUIOQVQVMZYDXKXQYNYRYSUUMUUOADBIJKNOQVOVMAYO
      BIJKLYEYFUUINOPQVRVIYDYIYLYFLYDEBIUHZFIUHZYKFIUHZYIYLYDUUSYKFIYDYKEYKMLUH
      ZIUHZUUSYDUVCYKEMIUHZLUHZYKJVPUPZLUHZYKYDXKXRYKYOUCZMYOUCZEYKKUEZUVCUVEUL
      YSUUCYDXKXNXRUVHYSUUKUUCAYOIJCEUUIOQVQVMZYDXLUVIXKXLYAYCVSYOHJMUUIRVTVAZY
      DXKXNXRUVJYSUUKUUCACEIJKNOQVOVMAYOEIJKLYKMUUINOPQWAVIYDUVDUVFYKLYDXMXRXSU
      VDUVFULUUAUUCXRXSXPXQXMYCWBAEUVFHIJKMNOUVFVBZQRWGWCWDYDJWEUCZUVHUVGYKULYD
      XKUVNYSJWFVAZUVKYOUVFJLYKUUIPUVMWPWHWIBUVBEIUAWJWKWQYDUUDUUEUUPBYOUCZYIUU
      TULUUHUUJUUQYDYNUVPUUOAYOBJUUIQVCVAZYOIJEFBUUIOWRWLYDYLCFIUHZEIUHZUVAYDYK
      DIUHZYBEIUHZYLUVSYDXKXNXRXQUVTUWAULYSUUKUUCUUMACEDIJOQWMWLYDUUDUUGUVHYLUV
      TULUUHUUNUVKYOIJDYKUUIOWNVMYDUVRYBEIYDUVRCYBMLUHZIUHZYBFUWBCISWJYDUWCYBCM
      IUHZLUHZYBUVFLUHZYBYDXKXNYBYOUCZUVICYBKUEZUWCUWEULYSUUKYDXKXNXQUWGYSUUKUU
      MAYOIJCDUUIOQVQVMZUVLYDXKXNXQUWHYSUUKUUMACDIJKNOQWOVMAYOCIJKLYBMUUINOPQWA
      VIYDUWDUVFYBLYDXMXPUWDUVFULUUAUUBACUVFHIJKMNOUVMQRWGWHWDYDUVNUWGUWFYBULUV
      OUWIYOUVFJLYBUUIPUVMWPWHWSWTWQXAYDUUDUUFUUPUUEUVSUVAULUUHUULUUQUUJYOIJCFE
      UUIOWRWLXBXAWQYDYFYLKUEZYMYFULZYDBYKKUEZUWJYDBUVBYKKUAYDUUDUVHUVIUVBYKKUE
      UUHUVKUVLYOJKLYKMUUINPXCVMXDYDUUDUVPUVHUUGUWLUWJXFUUHUVQUVKUUNYOIJKBYKDUU
      INOXEWLXGYDUUDYQYLYOUCZUWJUWKXHUUHUURYDUUDUUGUVHUWMUUHUUNUVKYOIJDYKUUIOVN
      VMYOJKLYFYLUUINPXIVMXJWSWT $.
  $}

  ${
    cdleme10.l $e |- .<_ = ( le ` K ) $.
    cdleme10.j $e |- .\/ = ( join ` K ) $.
    cdleme10.m $e |- ./\ = ( meet ` K ) $.
    cdleme10.a $e |- A = ( Atoms ` K ) $.
    cdleme10.h $e |- H = ( LHyp ` K ) $.
    cdleme10.d $e |- D = ( ( R .\/ S ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 2nd paragraph on p. 114.
       ` D ` represents s_2.  In their notation, we prove s ` \/ ` s_2 = s
       ` \/ ` r.  (Contributed by NM, 9-Jun-2012.) $)
    cdleme10 $p |- ( ( ( K e. HL /\ W e. H ) /\ R e. A
         /\ ( S e. A /\ -. S .<_ W ) ) -> ( S .\/ D ) = ( S .\/ R ) ) $=
      ( wcel co wceq syl3anc chlt wa wbr wn w3a oveq2i cp1 cfv cbs simp1l simp2
      simp3l eqid hlatjcl simp1r lhpbase syl clat hllat atbase 3ad2ant2 latlej2
      atmod3i1 syl131anc latjcom lhpjat2 3adant2 oveq12d col hlol olm11 syl2anc
      latjcl 3eqtrd syl5eq ) GUAQZJEQZUBZCAQZDAQZDJHUCUDZUBZUEZDBFRDCDFRZJIRZFR
      ZDCFRZBWEDFPUFWCWFWDDJFRZIRZWGGUGUHZIRZWGWCVPVTWDGUIUHZQZJWLQZDWDHUCZWFWI
      SVPVQVSWBUJZVRVSVTWAULZWCVPVSVTWMWPVRVSWBUKWQAWLFGCDWLUMZLNUNTWCVQWNVPVQV
      SWBUOWLEGJWROUPUQWCGURQZCWLQZDWLQZWOWCVPWSWPGUSUQZVSVRWTWBAWLCGWRNUTVAZWC
      VTXAWQAWLDGWRNUTUQZWLFGHCDWRKLVBTAWLDFGHIWDJWRKLMNVCVDWCWDWGWHWJIWCWSWTXA
      WDWGSXBXCXDWLFGCDWRLVETVRWBWHWJSVSADWJEFGHJKLWJUMZNOVFVGVHWCGVIQZWGWLQZWK
      WGSWCVPXFWPGVJUQWCWSXAWTXGXBXDXCWLFGDCWRLVMTWLWJGIWGWRMXEVKVLVNVO $.
  $}

  ${
    cdleme8t.l $e |- .<_ = ( le ` K ) $.
    cdleme8t.j $e |- .\/ = ( join ` K ) $.
    cdleme8t.m $e |- ./\ = ( meet ` K ) $.
    cdleme8t.a $e |- A = ( Atoms ` K ) $.
    cdleme8t.h $e |- H = ( LHyp ` K ) $.
    cdleme8t.x $e |- X = ( ( P .\/ T ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 2nd paragraph on p. 114.
       ` X ` represents t_1.  In their notation, we prove p ` \/ ` t_1 = p
       ` \/ ` t.  (Contributed by NM, 8-Oct-2012.)
       (New usage is discouraged.) $)
    cdleme8tN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ T e. A ) -> ( P .\/ X ) = ( P .\/ T ) ) $=
      ( cdleme8 ) AJBCDEFGHIKLMNOPQ $.

    $( Part of proof of Lemma E in [Crawley] p. 113. ` X ` represents t_1,
       which we prove is an atom.  (Contributed by NM, 8-Oct-2012.)
       (New usage is discouraged.) $)
    cdleme9taN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( T e. A /\ P =/= T ) ) -> X e. A ) $=
      ( cdleme9a ) AJBCDEFGHIKLMNOPQ $.
  $}

  ${
    cdleme9t.l $e |- .<_ = ( le ` K ) $.
    cdleme9t.j $e |- .\/ = ( join ` K ) $.
    cdleme9t.m $e |- ./\ = ( meet ` K ) $.
    cdleme9t.a $e |- A = ( Atoms ` K ) $.
    cdleme9t.h $e |- H = ( LHyp ` K ) $.
    cdleme9t.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme9t.g $e |- F
        = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
    cdleme9t.x $e |- X = ( ( P .\/ T ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 2nd paragraph on p. 114.
       ` X ` and ` F ` represent t_1 and f(t) respectively.  In their notation,
       we prove f(t) ` \/ ` t_1 = q ` \/ ` t_1.  (Contributed by NM,
       8-Oct-2012.)  (New usage is discouraged.) $)
    cdleme9tN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
         /\ Q e. A /\ ( T e. A /\ -. T .<_ W ) ) /\ -. T .<_ ( P .\/ Q ) )
             -> ( F .\/ X ) = ( Q .\/ X ) ) $=
      ( cdleme9 ) AMBCDEFGHIJKLNOPQRSTUAUB $.
  $}

  ${
    cdleme10t.l $e |- .<_ = ( le ` K ) $.
    cdleme10t.j $e |- .\/ = ( join ` K ) $.
    cdleme10t.m $e |- ./\ = ( meet ` K ) $.
    cdleme10t.a $e |- A = ( Atoms ` K ) $.
    cdleme10t.h $e |- H = ( LHyp ` K ) $.
    cdleme10t.y $e |- Y = ( ( R .\/ T ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 2nd paragraph on p. 114.
       ` Y ` represents t_2.  In their notation, we prove t ` \/ ` t_2 = t
       ` \/ ` r.  (Contributed by NM, 8-Oct-2012.)
       (New usage is discouraged.) $)
    cdleme10tN $p |- ( ( ( K e. HL /\ W e. H ) /\ R e. A
         /\ ( T e. A /\ -. T .<_ W ) ) -> ( T .\/ Y ) = ( T .\/ R ) ) $=
      ( cdleme10 ) AJBCDEFGHIKLMNOPQ $.
  $}

  ${
    cdleme11.l $e |- .<_ = ( le ` K ) $.
    cdleme11.j $e |- .\/ = ( join ` K ) $.
    cdleme11.m $e |- ./\ = ( meet ` K ) $.
    cdleme11.a $e |- A = ( Atoms ` K ) $.
    cdleme11.h $e |- H = ( LHyp ` K ) $.
    cdleme11.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       showing, in their notation, s ` \/ ` u ` =/= ` t ` \/ ` u.  (Contributed
       by NM, 9-Oct-2012.)  (New usage is discouraged.) $)
    cdleme16aN $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W ) )
    /\ ( Q e. A /\ S e. A /\ T e. A )
    /\ ( P =/= Q /\ S =/= T /\ -. U .<_ ( S .\/ T ) ) )
        -> ( S .\/ U ) =/= ( T .\/ U ) ) $=
      ( wcel co chlt wa wbr wn w3a wne clpl simp1ll simp22 simp23 simp1l simp1r
      cfv simp21 simp31 lhpat2 syl112anc simp32 simp33 eqid syl132anc syl131anc
      lplni2 lplnllnneN ) IUASZLGSZUBZBASBLJUCUDUBZUBZCASZDASZEASZUEZBCUFZDEUFZ
      FDEHTZJUCUDZUEZUEZVEVKVLFASZVPFHTZIUGUMZSZDFHTEFHTUFVEVFVHVMVRUHZVIVJVKVL
      VRUIZVIVJVKVLVRUJZVSVGVHVJVNVTVGVHVMVRUKVGVHVMVRULVIVJVKVLVRUNVIVMVNVOVQU
      OABCFGHIJKLMNOPQRUPUQZVSVEVKVLVTVOVQWCWDWEWFWGVIVMVNVOVQURVIVMVNVOVQUSAWB
      DEFHIJMNPWBUTZVCVAAWBDEFHIWANPWHWAUTVDVB $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 12-Jun-2012.) $)
    cdleme11a $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ P =/= Q ) )
     /\ ( ( S e. A /\ -. S .<_ W )
   /\ ( T e. A /\ U .<_ ( S .\/ T ) ) ) ) -> ( S .\/ U ) = ( S .\/ T ) ) $=
      ( wcel wa chlt wbr wn wne co w3a wceq simp3rr simp1l simp2l simp2r lhpat2
      simp1 syl3anc simp3rl simp3ll simp2ll simp2rl simp3l syl121anc hlatexchb1
      wb cdleme0c syl131anc mpbid ) IUASZLGSZTZBASZBLJUBUCZTZCASZBCUDZTZTZDASZD
      LJUBUCZTZEASZFDEHUEZJUBZTZTZUFZWADFHUEVTUGZVSWAVRVHVOUHWDVFFASZVSVPFDUDZW
      AWEVBVFVGVOWCUIWDVHVKVNWFVHVOWCUMZVHVKVNWCUJVHVKVNWCUKABCFGHIJKLMNOPQRULU
      NVSWAVRVHVOUOVPVQWBVHVOUPWDVHVIVLVRWGWHVIVJVNVHWCUQVLVMVKVHWCURVHVOVRWBUS
      ABCDFGHIJKLMNOPQRVCUTAFEDHIJMNPVAVDVE $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 13-Jun-2012.) $)
    cdleme11c $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ -. P .<_ W ) /\ Q e. A )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ T e. A /\ P =/= Q )
      /\ ( -. S .<_ ( P .\/ Q ) /\ U .<_ ( S .\/ T ) ) )
      -> -. P .<_ ( S .\/ T ) ) $=
      ( wcel wbr chlt wa wn w3a wne simp3l simp11l simp12l simp11 simp12 simp13
      co simp23 lhpat2 syl112anc hlatlej1 syl3anc adantr wceq jca simp21 simp22
      simp3r cdleme11a syl122anc breq2d wi simp21l cdleme0b hlatexch2 syl131anc
      necomd sylbird imp hlatlej2 cdleme0cp syl12anc breqtrrd wb clat cbs hllat
      cfv syl eqid hlatjcl latjle12 syl13anc mpbi2and latnlej1r syl132anc mpbid
      atbase ps-1 ex syld mtod ) IUASZLGSZUBZBASZBLJTUCZUBZCASZUDZDASZDLJTUCZUB
      ZEASZBCUEZUDZDBCHULZJTZUCZFDEHULZJTZUBZUDZBXOJTZXMXEXKXNXPUFZXRXSBDCHULZJ
      TZXMXRXSYBXRXSUBZBBFHULZYAJXRBYDJTZXSXRWRXAFASZYEWRWSXCXDXKXQUGZXAXBWTXDX
      KXQUHZXRWTXCXDXJYFWTXCXDXKXQUIZWTXCXDXKXQUJZWTXCXDXKXQUKZXEXHXIXJXQUMZABC
      FGHIJKLMNOPQRUNUOZABFHIJMNPUPUQURYCYAYDJTZYAYDUSZYCDYDJTZCYDJTZYNXRXSYPXR
      XSBDFHULZJTZYPXRYRXOBJXRWTXCXDXJUBXHXIXPUBYRXOUSYIYJXRXDXJYKYLUTXEXHXIXJX
      QVAXRXIXPXEXHXIXJXQVBXEXKXNXPVCUTABCDEFGHIJKLMNOPQRVDVEVFXRWRXAXFYFBFUEYS
      YPVGYGYHXFXGXIXJXEXQVHZYMXRFBXRWTXCXDFBUEYIYJYKABCFGHIJKLMNOPQRVIUQVLABDF
      HIJMNPVJVKVMVNXRYQXSXRCXLYDJXRWRXAXDCXLJTYGYHYKABCHIJMNPVOUQXRWTXCXDYDXLU
      SYIYJYKABCFGHIJKLMNOPQRVPVQVRURXRYPYQUBYNVSZXSXRIVTSZDIWAWCZSZCUUCSZYDUUC
      SZUUAXRWRUUBYGIWBWDZXRXFUUDYTAUUCDIUUCWEZPWMWDZXRXDUUEYKAUUCCIUUHPWMWDZXR
      WRXAYFUUFYGYHYMAUUCHIBFUUHNPWFUQUUCHIJDCYDUUHMNWGWHURWIXRYNYOVSZXSXRWRXFX
      DDCUEZXAYFUUKYGYTYKXRUUBUUDBUUCSZUUEXNUULUUGUUIXRXAUUMYHAUUCBIUUHPWMWDUUJ
      XTUUCHIJDBCUUHMNWJVKYHYMADCBFHIJMNPWNWKURWLVRWOXRWRXAXFXDXJYBXMVGYGYHYTYK
      YLABDCHIJMNPVJVKWPWQ $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 13-Jun-2012.)
       (New usage is discouraged.) $)
    cdleme11dN $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ -. P .<_ W ) /\ Q e. A )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ T e. A /\ P =/= Q )
      /\ ( S =/= T /\ -. S .<_ ( P .\/ Q ) /\ U .<_ ( S .\/ T ) ) )
        -> ( P .\/ S ) =/= ( P .\/ T ) ) $=
      ( wcel wbr wa wn w3a wne co simp1 simp2 simp32 simp33 cdleme11c syl112anc
      chlt wceq simp11l simp12l simp21l hlatlej2 syl3anc breq2 syl5ibcom simp22
      wi simp31 hlatexch2 syl131anc syld necon3bd mpd ) IULSZLGSZUAZBASZBLJTUBZ
      UAZCASZUCZDASZDLJTUBZUAZEASZBCUDZUCZDEUDZDBCHUEJTUBZFDEHUEZJTZUCZUCZBWEJT
      ZUBZBDHUEZBEHUEZUDWHVPWBWDWFWJVPWBWGUFVPWBWGUGVPWBWCWDWFUHVPWBWCWDWFUIABC
      DEFGHIJKLMNOPQRUJUKWHWIWKWLWHWKWLUMZDWLJTZWIWHDWKJTZWMWNWHVIVLVQWOVIVJVNV
      OWBWGUNZVLVMVKVOWBWGUOZVQVRVTWAVPWGUPZABDHIJMNPUQURWKWLDJUSUTWHVIVQVLVTWC
      WNWIVBWPWRWQVPVSVTWAWGVAVPWBWCWDWFVCADBEHIJMNPVDVEVFVGVH $.

    cdleme11.c $e |- C = ( ( P .\/ S ) ./\ W ) $.
    cdleme11.d $e |- D = ( ( P .\/ T ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 13-Jun-2012.) $)
    cdleme11e $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ -. P .<_ W ) /\ Q e. A )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ T e. A /\ P =/= Q )
      /\ ( S =/= T /\ -. S .<_ ( P .\/ Q ) /\ U .<_ ( S .\/ T ) ) )
   -> C =/= D ) $=
      ( chlt wcel wa wbr wn w3a wne co simp11 simp12 simp22 simp21 clat cbs cfv
      simp11l hllat syl simp12l eqid atbase simp1 simp2 simp32 simp33 cdleme11c
      simp21l syl112anc latnlej1r syl131anc simp31 hlatcon2 syl132anc cdleme0e
      necomd ) KUCUDZNIUDZUEZDAUDZDNLUFUGZUEZEAUDZUHZFAUDZFNLUFUGZUEZGAUDZDEUIZ
      UHZFGUIZFDEJUJLUFUGZHFGJUJZLUFZUHZUHZCBWQVTWCWIWHDGUIZFDGJUJLUFUGZCBUIVTW
      CWDWKWPUKVTWCWDWKWPULWEWHWIWJWPUMZWEWHWIWJWPUNWQKUOUDZDKUPUQZUDZFXBUDZGXB
      UDZDWNLUFUGZWRWQVRXAVRVSWCWDWKWPURZKUSUTWQWAXCWAWBVTWDWKWPVAZAXBDKXBVBZRV
      CUTWQWFXDWFWGWIWJWEWPVIZAXBFKXIRVCUTWQWIXEWTAXBGKXIRVCUTWQWEWKWMWOXFWEWKW
      PVDWEWKWPVEWEWKWLWMWOVFWEWKWLWMWOVGADEFGHIJKLMNOPQRSTVHVJZXBJKLDFGXIOPVKV
      LWQVRWFWIWAWLXFWSXGXJWTXHWEWKWLWMWOVMXKAFGDJKLOPRVNVOADGFCIJKLMBNOPQRSUBU
      AVPVOVQ $.

    cdleme11.f $e |- F
           = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 14-Jun-2012.)
       (New usage is discouraged.) $)
    cdleme11fN $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
           /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) ) -> F =/= C ) $=
      ( chlt wcel wa wbr wn w3a wne co clat cbs cfv simp1l hllat simp21l atbase
      syl simp23l latjcl syl3anc simp1r lhpbase latmle2 syl5eqbr cdleme3 nbrne2
      eqid necomd syl2anc ) LUEUFZOJUFZUGZDAUFZDOMUHUIZUGZEAUFEOMUHUIUGZFAUFZFO
      MUHUIZUGZUJZDEUKFDEKULMUHUIUGZUJZBOMUHZIOMUHUIZIBUKWEBDFKULZONULZOMUBWELU
      MUFZWHLUNUOZUFZOWKUFZWIOMUHWEVMWJVMVNWCWDUPLUQUTZWEWJDWKUFZFWKUFZWLWNWEVP
      WOVPVQVSWBVOWDURAWKDLWKVJZSUSUTWEVTWPVTWAVRVSVOWDVAAWKFLWQSUSUTWKKLDFWQQV
      BVCWEVNWMVMVNWCWDVDWKJLOWQTVEUTWKLMNWHOWQPRVFVCVGADEFHIJKLMNOPQRSTUAUDVHW
      FWGUGBIBIOMVIVKVL $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 14-Jun-2012.) $)
    cdleme11g $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ ( Q e. A /\ -. Q .<_ W ) /\ S e. A )
        /\ P =/= Q ) -> ( Q .\/ F ) = ( Q .\/ C ) ) $=
      ( chlt wcel wa wbr wn w3a wne co oveq2i cbs cfv wceq simp1l simp22l hllat
      clat syl simp23 eqid atbase simp1 simp21 cdleme0aa syl3anc latjcl lhpbase
      simp1r latmcl latlej1 atmod1i1 syl131anc syl5eq simp22 cdleme0cq syl12anc
      oveq2d latj12 syl13anc latj13 3eqtr4d oveq1d wi latjlej2 mpd wb latleeqm2
      latmle1 mpbid syl6eqr 3eqtrd ) LUEUFZOJUFZUGZDAUFZEAUFZEOMUHUIZUGZFAUFZUJ
      ZDEUKZUJZEIKULZEFHKULZKULZEDFKULZONULZKULZNULZEXIKULZXKNULZEBKULZXEXFEXGX
      KNULZKULZXLIXPEKUDUMXEWOWSXGLUNUOZUFZXKXRUFZEXKMUHZXQXLUPWOWPXCXDUQZWSWTW
      RXBWQXDURZXELUTUFZFXRUFZHXRUFZXSXEWOYDYBLUSVAZXEXBYEWQWRXAXBXDVBAXRFLXRVC
      ZSVDVAZXEWQWRWSYFWQXCXDVEZWQWRXAXBXDVFZYCAXRDEHJKLMNOPQRSTUAYHVGVHZXRKLFH
      YHQVIVHXEYDEXRUFZXJXRUFZXTYGXEWSYMYCAXRELYHSVDVAZXEYDXIXRUFZOXRUFZYNYGXEY
      DDXRUFZYEYPYGXEWRYRYKAXRDLYHSVDVAZYIXRKLDFYHQVIVHZXEWPYQWOWPXCXDVKXRJLOYH
      TVJVAZXRLNXIOYHRVLVHZXRKLEXJYHQVIVHZXEYDYMYNYAYGYOUUBXRKLMEXJYHPQVMVHAXRE
      KLMNXGXKYHPQRSVNVOVPXEXHXMXKNXEFEHKULZKULZFDEKULZKULZXHXMXEUUDUUFFKXEWQWR
      XAUUDUUFUPYJYKWQWRXAXBXDVQADEHJKLMNOPQRSTUAVRVSVTXEYDYMYEYFXHUUEUPYGYOYIY
      LXRKLEFHYHQWAWBXEYDYMYRYEXMUUGUPYGYOYSYIXRKLEDFYHQWCWBWDWEXEXNXKXOXEXKXMM
      UHZXNXKUPZXEXJXIMUHZUUHXEYDYPYQUUJYGYTUUAXRLMNXIOYHPRWKVHXEYDYNYPYMUUJUUH
      WFYGUUBYTYOXRKLMXJXIEYHPQWGWBWHXEYDXTXMXRUFZUUHUUIWIYGUUCXEYDYMYPUUKYGYOY
      TXRKLEXIYHQVIVHXRLMNXKXMYHPRWJVHWLBXJEKUBUMWMWN $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 14-Jun-2012.) $)
    cdleme11h $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ S e. A )
        /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) ) -> F =/= Q ) $=
      ( chlt wa wbr wn w3a wne co simp1 simp21l simp23 simp22l simp22r cdleme0c
      wcel syl122anc necomd wb simp1l simp21 cdleme00a syl131anc cdleme9a lnnat
      simp3r syl112anc syl3anc mpbid wceq hlatjidm syl2anc eqeltrd oveq2 eleq1d
      syl5ibrcom simp22 simp3l cdleme11g sylibd necon3bd mpd ) LUEURZOJURZUFZDA
      URZDOMUGUHZUFZEAURZEOMUGUHZUFZFAURZUIZDEUJZFDEKUKMUGUHZUFZUIZEBKUKZAURZUH
      ZIEUJWSEBUJZXBWSBEWSWGWHWNWKWLBEUJWGWOWRULZWHWIWMWNWGWRUMZWGWJWMWNWRUNZWK
      WLWJWNWGWRUOZWKWLWJWNWGWRUPADFEBJKLMNOPQRSTUBUQUSUTWSWEWKBAURZXCXBVAWEWFW
      OWRVBZXGWSWGWJWNDFUJXHXDWGWJWMWNWRVCXFWSFDWSWEWHWKWNWQFDUJXIXEXGXFWGWOWPW
      QVHADEFKLMNPQRSVDVEUTABDFJKLMNOPQRSTUBVFVIAEBKLQSVGVJVKWSXAIEWSIEVLZEIKUK
      ZAURZXAWSXLXJEEKUKZAURWSXMEAWSWEWKXMEVLXIXGAKLEQSVMVNXGVOXJXKXMAIEEKVPVQV
      RWSXKWTAWSWGWHWMWNWPXKWTVLXDXEWGWJWMWNWRVSXFWGWOWPWQVTABHDEFEHIJKLMNOPQRS
      TUAUBUAUDWAVEVQWBWCWD $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 14-Jun-2012.) $)
    cdleme11j $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
           /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) ) -> C .<_ ( Q .\/ F ) ) $=
      ( chlt wcel wa wbr w3a wne simp1l simp22l cdleme3fa hlatlej2 syl3anc wceq
      wn simp1 simp21l simp22 simp23l simp3l cdleme11g syl131anc breqtrd simp21
      co wi simp3r cdleme00a necomd cdleme9a syl112anc cdleme11h hlatexch1 mpd
      simp3 ) LUEUFZOJUFZUGZDAUFZDOMUHUQZUGZEAUFZEOMUHUQZUGZFAUFZFOMUHUQZUGZUIZ
      DEUJZFDEKVGMUHUQZUGZUIZIEBKVGZMUHZBEIKVGZMUHZWNIWQWOMWNVRWDIAUFZIWQMUHVRV
      SWJWMUKZWDWEWCWIVTWMULZADEFHIJKLMNOPQRSTUAUDUMZAEIKLMPQSUNUOWNVTWAWFWGWKW
      QWOUPVTWJWMURZWAWBWFWIVTWMUSZVTWCWFWIWMUTZWGWHWCWFVTWMVAZVTWJWKWLVBABHDEF
      EHIJKLMNOPQRSTUAUBUAUDVCVDVEWNVRWSBAUFZWDIEUJZWPWRVHWTXBWNVTWCWGDFUJXGXCV
      TWCWFWIWMVFZXFWNFDWNVRWAWDWGWLFDUJWTXDXAXFVTWJWKWLVIADEFKLMNPQRSVJVDVKABD
      FJKLMNOPQRSTUBVLVMXAWNVTWCWFWGWMXHXCXIXEXFVTWJWMVQABHDEFEHIJKLMNOPQRSTUAU
      BUAUDVNVDAIBEKLMPQSVOVDVP $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 15-Jun-2012.) $)
    cdleme11k $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
           /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) )
           -> C = ( ( Q .\/ F ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cdleme11j clat cbs cfv simp1l hllat
      syl simp21l atbase simp23l latjcl syl3anc simp1r lhpbase latmle2 syl5eqbr
      eqid wb simp1 simp21 simp3r cdleme00a syl131anc necomd cdleme9a syl112anc
      simp22l cdleme3fa latlem12 syl13anc mpbi2and hlatl simp22 simp3 cdleme11h
      cal lhpat atcmp mpbid ) LUEUFZOJUFZUGZDAUFZDOMUHUIZUGZEAUFZEOMUHUIZUGZFAU
      FZFOMUHUIZUGZUJZDEUKZFDEKULMUHUIZUGZUJZBEIKULZONULZMUHZBXKUMZXIBXJMUHZBOM
      UHZXLABHDEFEHIJKLMNOPQRSTUAUBUAUDUNXIBDFKULZONULZOMUBXILUOUFZXPLUPUQZUFZO
      XSUFZXQOMUHXIWMXRWMWNXEXHURZLUSUTZXIXRDXSUFZFXSUFZXTYCXIWPYDWPWQXAXDWOXHV
      AZAXSDLXSVJZSVBUTXIXBYEXBXCWRXAWOXHVCZAXSFLYGSVBUTXSKLDFYGQVDVEXIWNYAWMWN
      XEXHVFXSJLOYGTVGUTZXSLMNXPOYGPRVHVEVIXIXRBXSUFZXJXSUFZYAXNXOUGXLVKYCXIBAU
      FZYJXIWOWRXBDFUKYLWOXEXHVLZWOWRXAXDXHVMZYHXIFDXIWMWPWSXBXGFDUKYBYFWSWTWRX
      DWOXHVTZYHWOXEXFXGVNADEFKLMNPQRSVOVPVQABDFJKLMNOPQRSTUBVRVSZAXSBLYGSVBUTX
      IXREXSUFZIXSUFZYKYCXIWSYQYOAXSELYGSVBUTXIIAUFZYRADEFHIJKLMNOPQRSTUAUDWAZA
      XSILYGSVBUTXSKLEIYGQVDVEYIXSLMNBXJOYGPRWBWCWDXILWIUFZYLXKAUFZXLXMVKXIWMUU
      AYBLWEUTYPXIWOXAYSEIUKUUBYMWOWRXAXDXHWFZYTXIIEXIWOWRXAXBXHIEUKYMYNUUCYHWO
      XEXHWGABHDEFEHIJKLMNOPQRSTUAUBUAUDWHVPVQAEIJKLMNOPQRSTWJVSABXKLMPSWKVEWL
      $.
  $}

  ${
    cdleme12.l $e |- .<_ = ( le ` K ) $.
    cdleme12.j $e |- .\/ = ( join ` K ) $.
    cdleme12.m $e |- ./\ = ( meet ` K ) $.
    cdleme12.a $e |- A = ( Atoms ` K ) $.
    cdleme12.h $e |- H = ( LHyp ` K ) $.
    cdleme12.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme12.f $e |- F
        = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme12.g $e |- G
        = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Lemma leading to
       ~ cdleme11 .  (Contributed by NM, 15-Jun-2012.) $)
    cdleme11l $p |- ( ( ( ( K e. HL /\ W e. H )
    /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
 /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
    /\ ( P =/= Q /\ S =/= T ) )
 /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
  /\ U .<_ ( S .\/ T ) ) )
           -> F =/= G ) $=
      ( chlt wcel wa wbr wn w3a co simp11 simp12 simp13l simp21 simp22l simp23l
      simp23r simp31 simp33 eqid cdleme11e syl333anc oveq2 oveq1d adantl simp13
      wne wceq cdleme11k syl132anc adantr simp22 simp32 3eqtr4d ex necon3d mpd
      ) KUCUDNIUDUEZBAUDBNLUFUGUEZCAUDZCNLUFUGZUEZUHZDAUDDNLUFUGUEZEAUDZENLUFUG
      ZUEZBCVFZDEVFZUEZUHZDBCJUIZLUFUGZEWKLUFUGZFDEJUILUFZUHZUHZBDJUINMUIZBEJUI
      NMUIZVFZGHVFWPVQVRVSWCWDWGWHWLWNWSVQVRWAWJWOUJZVQVRWAWJWOUKZVSVTVQVRWJWOU
      LWBWCWFWIWOUMZWDWEWCWIWBWOUNWGWHWCWFWBWOUOZWGWHWCWFWBWOUPWBWJWLWMWNUQZWBW
      JWLWMWNURAWQWRBCDEFIJKLMNOPQRSTWQUSZWRUSZUTVAWPGHWQWRWPGHVGZWQWRVGWPXGUEC
      GJUIZNMUIZCHJUIZNMUIZWQWRXGXIXKVGWPXGXHXJNMGHCJVBVCVDWPWQXIVGZXGWPVQVRWAW
      CWGWLXLWTXAVQVRWAWJWOVEZXBXCXDAWQFBCDCFGIJKLMNOPQRSTXETUAVHVIVJWPWRXKVGZX
      GWPVQVRWAWFWGWMXNWTXAXMWBWCWFWIWOVKXCWBWJWLWMWNVLAWRFBCECFHIJKLMNOPQRSTXF
      TUBVHVIVJVMVNVOVP $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 1st sentence of 3rd
       paragraph on p. 114. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  Their proof provides no details of our ~ cdleme11a
       through ~ cdleme11 , so there may be a simpler proof that we have
       overlooked.  (Contributed by NM, 15-Jun-2012.) $)
    cdleme11 $p |- ( ( ( ( K e. HL /\ W e. H )
    /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
 /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
    /\ ( P =/= Q /\ S =/= T ) )
 /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
      /\ U .<_ ( S .\/ T ) ) )
           -> ( F .\/ G ) = ( S .\/ T ) ) $=
      ( chlt wcel wa wbr wn w3a wne wceq clat cbs cfv simp11l hllat syl simp12l
      co simp11 simp13l eqid cdleme0aa syl3anc latjidm syl2anc oveq2d simp33 wb
      simp21l atbase simp22l latjcl mpbid eqtr2d simp21 cdleme1 syl13anc simp22
      latleeqj2 oveq12d latj4 syl122anc eqtr4d cdleme1b mpbird simp12 cdleme3fa
      simp13 simp23l simp31 syl132anc simp32 cdleme11l ps-1 ) KUCUDZNIUDZUEZBAU
      DZBNLUFUGZUEZCAUDZCNLUFUGZUEZUHZDAUDZDNLUFUGZUEZEAUDZENLUFUGZUEZBCUIZDEUI
      ZUEZUHZDBCJURZLUFUGZEXOLUFUGZFDEJURZLUFZUHZUHZGHJURZXRLUFZYBXRUJZYAYCXRYB
      JURZXRUJZYAXRDGJURZEHJURZJURZYEYAXRXRFFJURZJURZYIYAYKXRFJURZXRYAYJFXRJYAK
      UKUDZFKULUMZUDZYJFUJYAWOYMWOWPWTXCXNXTUNZKUOUPZYAWQWRXAYOWQWTXCXNXTUSZWRW
      SWQXCXNXTUQZXAXBWQWTXNXTUTZAYNBCFIJKLMNOPQRSTYNVAZVBVCZYNJKFUUAPVDVEVFYAX
      SYLXRUJZXDXNXPXQXSVGYAYMYOXRYNUDZXSUUCVHYQUUBYAYMDYNUDZEYNUDZUUDYQYAXEUUE
      XEXFXJXMXDXTVIZAYNDKUUARVJUPZYAXHUUFXHXIXGXMXDXTVKZAYNEKUUARVJUPZYNJKDEUU
      APVLVCZYNJKLFXRUUAOPVSVCVMVNYAYIDFJURZEFJURZJURZYKYAYGUULYHUUMJYAWQWRXAXG
      YGUULUJYRYSYTXDXGXJXMXTVOZABCDFGIJKLMNOPQRSTUAVPVQYAWQWRXAXJYHUUMUJYRYSYT
      XDXGXJXMXTVRZABCEFHIJKLMNOPQRSTUBVPVQVTYAYMUUEUUFYOYOYKUUNUJYQUUHUUJUUBUU
      BYNJKFDEFUUAPWAWBWCWCYAYMUUEGYNUDZUUFHYNUDZYIYEUJYQUUHYAWQWRXAXEUUQYRYSYT
      UUGAYNBCDFGIJKLMNOPQRSTUAUUAWDVQZUUJYAWQWRXAXHUURYRYSYTUUIAYNBCEFHIJKLMNO
      PQRSTUBUUAWDVQZYNJKHDGEUUAPWAWBVNYAYMYBYNUDZUUDYCYFVHYQYAYMUUQUURUVAYQUUS
      UUTYNJKGHUUAPVLVCUUKYNJKLYBXRUUAOPVSVCWEYAWOGAUDZHAUDZGHUIXEXHYCYDVHYPYAW
      QWTXCXGXKXPUVBYRWQWTXCXNXTWFZWQWTXCXNXTWHZUUOXKXLXGXJXDXTWIZXDXNXPXQXSWJA
      BCDFGIJKLMNOPQRSTUAWGWKYAWQWTXCXJXKXQUVCYRUVDUVEUUPUVFXDXNXPXQXSWLABCEFHI
      JKLMNOPQRSTUBWGWKABCDEFGHIJKLMNOPQRSTUAUBWMUUGUUIAGHDEJKLOPRWNWKVM $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       first part of 3rd sentence. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  (Contributed by NM, 16-Jun-2012.) $)
    cdleme12 $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ P =/= Q )
    /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
       /\ ( S =/= T /\ -. U .<_ ( S .\/ T ) ) ) )
           -> ( ( S .\/ F ) ./\ ( T .\/ G ) ) = U ) $=
      ( chlt wcel wa wbr wn wne w3a co wceq simp1 simp21l simp22 simp31 cdleme1
      syl13anc simp1l simp21 syl112anc simp31l hlatjcom syl3anc simp32l oveq12d
      simp23 lhpat2 eqtr4d simp32 simp33 2llnma2 syl131anc eqtrd ) KUCUDZNIUDZU
      EZBAUDZBNLUFUGZUEZCAUDZBCUHZUIZDAUDZDNLUFUGZUEZEAUDZENLUFUGZUEZDEUHFDEJUJ
      LUFUGUEZUIZUIZDGJUJZEHJUJZMUJFDJUJZFEJUJZMUJZFWKWLWNWMWOMWKWLDFJUJZWNWKVP
      VQVTWEWLWQUKVPWBWJULZVQVRVTWAVPWJUMZVPVSVTWAWJUNZVPWBWEWHWIUOABCDFGIJKLMN
      OPQRSTUAUPUQWKVNFAUDZWCWNWQUKVNVOWBWJURZWKVPVSVTWAXAWRVPVSVTWAWJUSWTVPVSV
      TWAWJVFABCFIJKLMNOPQRSTVGUTZWCWDWHWIVPWBVAZAJKFDPRVBVCVHWKWMEFJUJZWOWKVPV
      QVTWHWMXEUKWRWSWTVPWBWEWHWIVIABCEFHIJKLMNOPQRSTUBUPUQWKVNXAWFWOXEUKXBXCWF
      WGWEWIVPWBVDZAJKFEPRVBVCVHVEWKVNWCWFXAWIWPFUKXBXDXFXCVPWBWEWHWIVJADEFJKLM
      OPQRVKVLVM $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       "<s,t,p> and <f(s),f(t),q> are centrally perspective." ` F ` and ` G `
       represent f(s) and f(t) respectively.  (Contributed by NM,
       7-Oct-2012.) $)
    cdleme13 $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ P =/= Q )
    /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
       /\ ( S =/= T /\ -. U .<_ ( S .\/ T ) ) ) )
           -> ( ( S .\/ F ) ./\ ( T .\/ G ) ) .<_ ( P .\/ Q ) ) $=
      ( chlt wcel wa wbr wn wne w3a co cdleme12 syl6eq cbs cfv simp1l hllat syl
      clat simp21l simp22 eqid hlatjcl syl3anc simp1r lhpbase latmle1 eqbrtrd )
      KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZBCUHZUIZDAUDDNLUFUGUEEAUDENLUFUGUEDEUH
      FDEJUJLUFUGUEUIZUIZDGJUJEHJUJMUJZBCJUJZNMUJZVTLVRVSFWAABCDEFGHIJKLMNOPQRS
      TUAUBUKTULVRKURUDZVTKUMUNZUDZNWCUDZWAVTLUFVRVHWBVHVIVPVQUOZKUPUQVRVHVKVNW
      DWFVKVLVNVOVJVQUSVJVMVNVOVQUTAWCJKBCWCVAZPRVBVCVRVIWEVHVIVPVQVDWCIKNWGSVE
      UQWCKLMVTNWGOQVFVCVG $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       "<s,t,p> and <f(s),f(t),q> ... are axially perspective."  We apply
       ~ dalaw to ~ cdleme13 . ` F ` and ` G ` represent f(s) and f(t)
       respectively.  (Contributed by NM, 8-Oct-2012.) $)
    cdleme14 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> ( ( S .\/ T ) ./\ ( F .\/ G ) )
      .<_ ( ( ( T .\/ P ) ./\ ( G .\/ Q ) )
             .\/ ( ( P .\/ S ) ./\ ( Q .\/ F ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne simp11 simp12 simp13l simp23l simp21 simp22
      co simp23r simp33 jca syl133anc wi simp11l simp21l simp22l simp12l simp13
      cdleme13 simp31 cdleme3fa syl132anc simp32 dalaw mpd ) KUCUDZNIUDZUEZBAUD
      ZBNLUFUGZUEZCAUDZCNLUFUGZUEZUHZDAUDZDNLUFUGZUEZEAUDZENLUFUGZUEZBCUIZDEUIZ
      UEZUHZDBCJUPZLUFUGZEWNLUFUGZFDEJUPZLUFUGZUHZUHZDGJUPEHJUPMUPWNLUFZWQGHJUP
      MUPEBJUPHCJUPMUPBDJUPCGJUPMUPJUPLUFZWTVPVSVTWJWFWIWKWRUEXAVPVSWBWMWSUJZVP
      VSWBWMWSUKZVTWAVPVSWMWSULZWJWKWFWIWCWSUMZWCWFWIWLWSUNZWCWFWIWLWSUOZWTWKWR
      WJWKWFWIWCWSUQWCWMWOWPWRURUSABCDEFGHIJKLMNOPQRSTUAUBVGUTWTVNWDWGVQGAUDZHA
      UDZVTXAXBVAVNVOVSWBWMWSVBWDWEWIWLWCWSVCWGWHWFWLWCWSVDVQVRVPWBWMWSVEWTVPVS
      WBWFWJWOXIXCXDVPVSWBWMWSVFZXGXFWCWMWOWPWRVHABCDFGIJKLMNOPQRSTUAVIVJWTVPVS
      WBWIWJWPXJXCXDXKXHXFWCWMWOWPWRVKABCEFHIJKLMNOPQRSTUBVIVJXEADEBGHCJKLMOPQR
      VLUTVM $.

    ${
      cdleme15.c $e |- C = ( ( P .\/ S ) ./\ W ) $.
      cdleme15.x $e |- X = ( ( P .\/ T ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
         showing, in their notation, ((s ` \/ ` p) ` /\ ` (f(s) ` \/ ` q))
         ` \/ ` ((t ` \/ ` p) ` /\ ` (f(t) ` \/ ` q))=((p ` \/ ` s_1) ` /\ ` (q
         ` \/ ` s_1)) ` \/ ` ((p ` \/ ` t_1) ` /\ ` (q ` \/ ` t_1)).  We
         represent f(s), f(t), s_1, and t_1 with ` F ` , ` G ` , ` C ` , and
         ` X ` respectively.  The order of our operations is slightly
         different.  (Contributed by NM, 9-Oct-2012.) $)
      cdleme15a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ S =/= T ) )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
         /\ -. U .<_ ( S .\/ T ) ) )
   -> ( ( ( T .\/ P ) ./\ ( G .\/ Q ) )
        .\/ ( ( P .\/ S ) ./\ ( Q .\/ F ) ) )
              = ( ( ( P .\/ X ) ./\ ( Q .\/ X ) )
                .\/ ( ( P .\/ C ) ./\ ( Q .\/ C ) ) ) ) $=
        ( chlt wcel wa wbr w3a wne wceq simp11l simp11r simp12l simp12r simp22l
        wn cdleme8 syl221anc syl3anc eqtr2d simp11 simp12 simp13 simp22 simp23l
        hlatjcom simp32 cdleme3fa syl132anc simp13l cdleme11g syl131anc oveq12d
        co eqtrd simp21l eqcomd ) LUGUHZOJUHZUIZCAUHZCOMUJUSZUIZDAUHZDOMUJUSZUI
        ZUKZEAUHZEOMUJUSZUIZFAUHZFOMUJUSZUIZCDULZEFULZUIZUKZECDKVQZMUJUSZFXAMUJ
        USZGEFKVQMUJUSZUKZUKZFCKVQZIDKVQZNVQCPKVQZDPKVQZNVQCEKVQZDHKVQZNVQCBKVQ
        ZDBKVQZNVQKXFXGXIXHXJNXFXICFKVQZXGXFWAWBWDWEWNXIXOUMWAWBWFWIWTXEUNZWAWB
        WFWIWTXEUOZWDWEWCWIWTXEUPZWDWEWCWIWTXEUQZWNWOWMWSWJXEURZAPCFJKLMNOQRSTU
        AUFUTVAXFWAWDWNXOXGUMXPXRXTAKLCFRTVIVBVCXFXHDIKVQZXJXFWAIAUHZWGXHYAUMXP
        XFWCWFWIWPWQXCYBWCWFWIWTXEVDZWCWFWIWTXEVEWCWFWIWTXEVFZWJWMWPWSXEVGWQWRW
        MWPWJXEVHZWJWTXBXCXDVJACDFGIJKLMNOQRSTUAUBUDVKVLWGWHWCWFWTXEVMAKLIDRTVI
        VBXFWCWDWIWNWQYAXJUMYCXRYDXTYEAPGCDFDGIJKLMNOQRSTUAUBUFUBUDVNVOVRVPXFXK
        XMXLXNNXFXMXKXFWAWBWDWEWKXMXKUMXPXQXRXSWKWLWPWSWJXEVSZABCEJKLMNOQRSTUAU
        EUTVAVTXFWCWDWIWKWQXLXNUMYCXRYDYFYEABGCDEDGHJKLMNOQRSTUAUBUEUBUCVNVOVPV
        P $.

      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
         showing, in their notation, (p ` \/ ` s_1) ` /\ ` (q ` \/ ` s_1)=s_1.
         We represent s_1 with ` C ` .  (Contributed by NM, 10-Oct-2012.) $)
      cdleme15b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ S =/= T ) )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
         /\ -. U .<_ ( S .\/ T ) ) )
    -> ( ( P .\/ C ) ./\ ( Q .\/ C ) ) = C ) $=
        ( chlt wcel wa wbr wn w3a wne co cp0 cfv oveq2i simp11l simp12l simp21l
        cbs wceq eqid hlatjcl syl3anc simp11r lhpbase hlatlej1 syl131anc syl5eq
        syl atmod3i1 oveq1d col hlol clat hllat atbase simp13l latmrot syl13anc
        latjcl simp31 wi simp23l necomd hlatexch1 mtod cal wb hlatl atnle mpbid
        olm02 syl2anc 3eqtrrd eqtr4d cdleme9b latlej2 atmod2i2 olj02 3eqtr3d )
        LUGUHZOJUHZUIZCAUHZCOMUJUKZUIZDAUHZDOMUJUKZUIZULZEAUHZEOMUJUKZUIZFAUHFO
        MUJUKUIZCDUMZEFUMZUIZULZECDKUNZMUJZUKZFYAMUJUKZGEFKUNMUJUKZULZULZCBKUNZ
        DNUNZBKUNZLUOUPZBKUNZYHDBKUNNUNZBYGYIYKBKYGYICEKUNZCOKUNZNUNZDNUNZYKYGY
        HYPDNYGYHCYNONUNZKUNZYPBYRCKUEUQYGXCXFYNLVAUPZUHZOYTUHZCYNMUJZYSYPVBXCX
        DXHXKXTYFURZXFXGXEXKXTYFUSZYGXCXFXMUUAUUDUUEXMXNXPXSXLYFUTZAYTKLCEYTVCZ
        RTVDVEZYGXDUUBXCXDXHXKXTYFVFZYTJLOUUGUAVGVKZYGXCXFXMUUCUUDUUEUUFACEKLMQ
        RTVHVEAYTCKLMNYNOUUGQRSTVLVIVJVMYGYQDYNNUNZYONUNZYKYONUNZYKYGLVNUHZUUAY
        OYTUHZDYTUHZYQUULVBYGXCUUNUUDLVOVKZUUHYGLVPUHZCYTUHZUUBUUOYGXCUURUUDLVQ
        VKZYGXFUUSUUEAYTCLUUGTVRVKZUUJYTKLCOUUGRWBVEZYGXIUUPXIXJXEXHXTYFVSZAYTD
        LUUGTVRVKYTLNYNYODUUGSVTWAYGUUKYKYONYGDYNMUJZUKZUUKYKVBZYGUVDYBXLXTYCYD
        YEWCYGXCXIXMXFDCUMUVDYBWDUUDUVCUUFUUEYGCDXQXRXOXPXLYFWEWFADECKLMQRTWGVI
        WHYGLWIUHZXIUUAUVEUVFWJYGXCUVGUUDLWKVKUVCUUHAYTDLMNYNYKUUGQSYKVCZTWLVEW
        MVMYGUUNUUOUUMYKVBUUQUVBYTLNYOYKUUGSUVHWNWOWPWQVMYGXCXIYHYTUHZBYTUHZBYH
        MUJZYJYMVBUUDUVCYGUURUUSUVJUVIUUTUVAYGXCXFXMXDUVJUUDUUEUUFUUIAYTBCEJKLN
        OUUGRSTUAUEWRWAZYTKLCBUUGRWBVEUVLYGUURUUSUVJUVKUUTUVAUVLYTKLMCBUUGQRWSV
        EAYTDKLMNYHBUUGQRSTWTVIYGUUNUVJYLBVBUUQUVLYTKLBYKUUGRUVHXAWOXB $.

      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
         showing, in their notation, ((p ` \/ ` s_1) ` /\ ` (q ` \/ ` s_1))
         ` \/ ` ((p ` \/ ` t_1) ` /\ ` (q ` \/ ` t_1))=s_1 ` \/ ` t_1. ` C `
         and ` X ` represent s_1 and t_1 respectively.  The order of our
         operations is slightly different.  (Contributed by NM,
         10-Oct-2012.) $)
      cdleme15c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ S =/= T ) )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
         /\ -. U .<_ ( S .\/ T ) ) )
    -> ( ( ( P .\/ X ) ./\ ( Q .\/ X ) )
        .\/ ( ( P .\/ C ) ./\ ( Q .\/ C ) ) ) = ( X .\/ C ) ) $=
        ( chlt wcel wa wbr wn w3a co simp11 simp12 simp13 simp22 simp21 simp23l
        wne simp23r necomd simp32 simp31 simp33 simp11l simp21l simp22l syl3anc
        wceq jca hlatjcom breq2d mtbid cdleme15b syl333anc oveq12d ) LUGUHZOJUH
        ZUIZCAUHCOMUJUKUIZDAUHDOMUJUKUIZULZEAUHZEOMUJUKZUIZFAUHZFOMUJUKZUIZCDUT
        ZEFUTZUIZULZECDKUMZMUJUKZFWNMUJUKZGEFKUMZMUJZUKZULZULZCPKUMDPKUMNUMZPCB
        KUMDBKUMNUMBKXAVTWAWBWIWFWJFEUTZUIWPWOGFEKUMZMUJZUKXBPVJVTWAWBWMWTUNVTW
        AWBWMWTUOVTWAWBWMWTUPWCWFWIWLWTUQWCWFWIWLWTURXAWJXCWJWKWFWIWCWTUSXAEFWJ
        WKWFWIWCWTVAVBVKWCWMWOWPWSVCWCWMWOWPWSVDXAWRXEWCWMWOWPWSVEXAWQXDGMXAVRW
        DWGWQXDVJVRVSWAWBWMWTVFWDWEWIWLWCWTVGWGWHWFWLWCWTVHAKLEFRTVLVIVMVNAPCDF
        EGIHJKLMNOBQRSTUAUBUDUCUFUEVOVPABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFVOVQ $.

      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
         showing, in their notation, s_1 ` \/ ` t_1 ` <_ ` w. ` C ` and ` X `
         represent s_1 and t_1 respectively.  The order of our operations is
         slightly different.  (Contributed by NM, 10-Oct-2012.) $)
      cdleme15d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ S =/= T ) )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
     /\ -. U .<_ ( S .\/ T ) ) )
         -> ( X .\/ C ) .<_ W ) $=
        ( chlt wcel wa wbr wn w3a wne co clat cbs cfv simp11l hllat syl simp12l
        simp22l hlatjcl syl3anc simp11r lhpbase latmle2 syl5eqbr simp21l latmcl
        eqid wb syl5eqel latjle12 syl13anc mpbi2and ) LUGUHZOJUHZUIZCAUHZCOMUJU
        KZUIZDAUHDOMUJUKUIZULZEAUHZEOMUJUKZUIZFAUHZFOMUJUKZUIZCDUMEFUMUIZULZECD
        KUNZMUJUKFWMMUJUKGEFKUNMUJUKULZULZPOMUJZBOMUJZPBKUNOMUJZWOPCFKUNZONUNZO
        MUFWOLUOUHZWSLUPUQZUHZOXBUHZWTOMUJWOVQXAVQVRWBWCWLWNURZLUSUTZWOVQVTWHXC
        XEVTWAVSWCWLWNVAZWHWIWGWKWDWNVBAXBKLCFXBVKZRTVCVDZWOVRXDVQVRWBWCWLWNVEX
        BJLOXHUAVFUTZXBLMNWSOXHQSVGVDVHWOBCEKUNZONUNZOMUEWOXAXKXBUHZXDXLOMUJXFW
        OVQVTWEXMXEXGWEWFWJWKWDWNVIAXBKLCEXHRTVCVDZXJXBLMNXKOXHQSVGVDVHWOXAPXBU
        HBXBUHXDWPWQUIWRVLXFWOPWTXBUFWOXAXCXDWTXBUHXFXIXJXBLNWSOXHSVJVDVMWOBXLX
        BUEWOXAXMXDXLXBUHXFXNXJXBLNXKOXHSVJVDVMXJXBKLMPBOXHQRVNVOVP $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       showing, in their notation, (s ` \/ ` t) ` /\ ` (f(s) ` \/ ` f(t))
       ` <_ ` w.  We use ` F ` , ` G ` for f(s), f(t) respectively.
       (Contributed by NM, 10-Oct-2012.) $)
    cdleme15 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
        -> ( ( S .\/ T ) ./\ ( F .\/ G ) ) .<_ W ) $=
      ( chlt wcel wa wbr wn w3a wne cbs cfv eqid clat simp11l hllat syl simp21l
      co simp22l hlatjcl syl3anc simp11r simp12l simp13l cdleme1b latjcl latmcl
      syl23anc atbase lhpbase cdleme14 cdleme15a cdleme15c eqtrd eqbrtrd lattrd
      cdleme15d ) KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZCNLUFUGZUEZUHZDAUDZDNLUFUG
      ZUEZEAUDZENLUFUGZUEZBCUIDEUIUEZUHZDBCJURZLUFUGEWPLUFUGFDEJURZLUFUGUHZUHZK
      UJUKZKLWQGHJURZMURZEBJURZHCJURZMURZBDJURZCGJURZMURZJURZNWTULZOWSVRKUMUDZV
      RVSWCWFWOWRUNZKUOUPZWSXKWQWTUDZXAWTUDZXBWTUDXMWSVRWHWKXNXLWHWIWMWNWGWRUQZ
      WKWLWJWNWGWRUSZAWTJKDEXJPRUTVAWSXKGWTUDZHWTUDZXOXMWSVRVSWAWDWHXRXLVRVSWCW
      FWOWRVBZWAWBVTWFWOWRVCZWDWEVTWCWOWRVDZXPAWTBCDFGIJKLMNOPQRSTUAXJVEVHZWSVR
      VSWAWDWKXSXLXTYAYBXQAWTBCEFHIJKLMNOPQRSTUBXJVEVHZWTJKGHXJPVFVAWTKMWQXAXJQ
      VGVAWSXKXEWTUDZXHWTUDZXIWTUDXMWSXKXCWTUDZXDWTUDZYEXMWSVRWKWAYGXLXQYAAWTJK
      EBXJPRUTVAWSXKXSCWTUDZYHXMYDWSWDYIYBAWTCKXJRVIUPZWTJKHCXJPVFVAWTKMXCXDXJQ
      VGVAWSXKXFWTUDZXGWTUDZYFXMWSVRWAWHYKXLYAXPAWTJKBDXJPRUTVAWSXKYIXRYLXMYJYC
      WTJKCGXJPVFVAWTKMXFXGXJQVGVAWTJKXEXHXJPVFVAWSVSNWTUDXTWTIKNXJSVJUPABCDEFG
      HIJKLMNOPQRSTUAUBVKWSXIBEJURNMURZXFNMURZJURZNLWSXIBYMJURCYMJURMURBYNJURCY
      NJURMURJURYOAYNBCDEFGHIJKLMNYMOPQRSTUAUBYNULZYMULZVLAYNBCDEFGHIJKLMNYMOPQ
      RSTUAUBYPYQVMVNAYNBCDEFGHIJKLMNYMOPQRSTUAUBYPYQVQVOVP $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       first part of 3rd sentence. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  It is unclear how this follows from s ` \/ ` u ` =/= ` t
       ` \/ ` u, as the authors state, and we used a different proof.  (Note:
       the antecedent ` -. T .<_ ( P .\/ Q ) ` is not used.)  (Contributed by
       NM, 11-Oct-2012.) $)
    cdleme16b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> F =/= G ) $=
      ( chlt wcel wa wbr wn w3a wne co simp11 simp12 simp13 simp21 simp23l eqid
      simp31 cdleme3g syl132anc wceq clat cbs cfv simp11l syl simp21l cdleme3fa
      hlatjcl syl3anc simp22l atbase latmcl latlej2 hlatlej2 atmod2i1 syl131anc
      hllat adantr oveq2 oveq2d sylan9eq simp11r simp13l simp22 simp33 cdleme12
      simp23r jca syl233anc eqtrd breqtrd ex wb hlatl simp12l simp12r syl222anc
      cal lhpat2 atcmp sylibd necon3d mpd ) KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZ
      CNLUFUGZUEZUHZDAUDZDNLUFUGZUEZEAUDZENLUFUGZUEZBCUIZDEUIZUEZUHZDBCJUJZLUFU
      GZEYDLUFUGZFDEJUJLUFUGZUHZUHZGFUIZGHUIYIXFXIXLXPXTYEYJXFXIXLYCYHUKZXFXIXL
      YCYHULZXFXIXLYCYHUMZXMXPXSYBYHUNZXTYAXPXSXMYHUOZXMYCYEYFYGUQZABCDFGIJKLMB
      DJUJNMUJZNOPQRSTUAYQUPURUSYIGHGFYIGHUTZGFLUFZGFUTZYIYRYSYIYRUEZGDGJUJZEMU
      JZGJUJZFLYIGUUDLUFZYRYIKVAUDZUUCKVBVCZUDZGUUGUDZUUEYIXDUUFXDXEXIXLYCYHVDZ
      KVQVEZYIUUFUUBUUGUDZEUUGUDZUUHUUKYIXDXNGAUDZUULUUJXNXOXSYBXMYHVFZYIXFXIXL
      XPXTYEUUNYKYLYMYNYOYPABCDFGIJKLMNOPQRSTUAVGUSZAUUGJKDGUUGUPZPRVHVIZYIXQUU
      MXQXRXPYBXMYHVJAUUGEKUUQRVKVEZUUGKMUUBEUUQQVLVIYIUUNUUIUUPAUUGGKUUQRVKVEU
      UGJKLUUCGUUQOPVMVIVRUUAUUDUUBEHJUJZMUJZFYIYRUUDUUBEGJUJZMUJZUVAYIXDUUNUUL
      UUMGUUBLUFZUUDUVCUTUUJUUPUURUUSYIXDXNUUNUVDUUJUUOUUPADGJKLOPRVNVIAUUGGJKL
      MUUBEUUQOPQRVOVPYRUVBUUTUUBMGHEJVSVTWAYIUVAFUTZYRYIXDXEXIXJXTXPXSYAYGUEUV
      EUUJXDXEXIXLYCYHWBZYLXJXKXFXIYCYHWCZYOYNXMXPXSYBYHWDYIYAYGXTYAXPXSXMYHWGX
      MYCYEYFYGWEWHABCDEFGHIJKLMNOPQRSTUAUBWFWIVRWJWKWLYIKWRUDZUUNFAUDZYSYTWMYI
      XDUVHUUJKWNVEUUPYIXDXEXGXHXJXTUVIUUJUVFXGXHXFXLYCYHWOXGXHXFXLYCYHWPUVGYOA
      BCFIJKLMNOPQRSTWSWQAGFKLORWTVIXAXBXC $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       2nd part of 3rd sentence. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  We show, in their notation, s ` \/ ` t ` \/ ` f(s) ` \/ `
       f(t)=s ` \/ ` t ` \/ ` u.  (Contributed by NM, 11-Oct-2012.) $)
    cdleme16c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> ( ( S .\/ T ) .\/ ( F .\/ G ) ) = ( ( S .\/ T ) .\/ U ) ) $=
      ( chlt wcel wa wbr wn w3a wne wceq simp11l simp11r simp12l simp13l simp21
      co cdleme1 syl23anc simp22 oveq12d simp21l simp11 simp12 simp13 cdleme3fa
      simp22l simp23l simp31 syl132anc simp32 hlatj4 syl122anc lhpat2 syl222anc
      simp12r hlatjidm syl2anc oveq2d eqtr3d 3eqtr4d ) KUCUDZNIUDZUEZBAUDZBNLUF
      UGZUEZCAUDZCNLUFUGZUEZUHZDAUDZDNLUFUGZUEZEAUDZENLUFUGZUEZBCUIZDEUIZUEZUHZ
      DBCJUPZLUFUGZEXALUFUGZFDEJUPZLUFUGZUHZUHZDGJUPZEHJUPZJUPZDFJUPZEFJUPZJUPZ
      XDGHJUPJUPZXDFJUPZXGXHXKXIXLJXGWAWBWDWGWMXHXKUJWAWBWFWIWTXFUKZWAWBWFWIWTX
      FULZWDWEWCWIWTXFUMZWGWHWCWFWTXFUNZWJWMWPWSXFUOZABCDFGIJKLMNOPQRSTUAUQURXG
      WAWBWDWGWPXIXLUJXPXQXRXSWJWMWPWSXFUSZABCEFHIJKLMNOPQRSTUBUQURUTXGWAWKWNGA
      UDZHAUDZXNXJUJXPWKWLWPWSWJXFVAZWNWOWMWSWJXFVFZXGWCWFWIWMWQXBYBWCWFWIWTXFV
      BZWCWFWIWTXFVCZWCWFWIWTXFVDZXTWQWRWMWPWJXFVGZWJWTXBXCXEVHABCDFGIJKLMNOPQR
      STUAVEVIXGWCWFWIWPWQXCYCYFYGYHYAYIWJWTXBXCXEVJABCEFHIJKLMNOPQRSTUBVEVIADE
      GHJKPRVKVLXGXDFFJUPZJUPZXOXMXGYJFXDJXGWAFAUDZYJFUJXPXGWAWBWDWEWGWQYLXPXQX
      RWDWEWCWIWTXFVOXSYIABCFIJKLMNOPQRSTVMVNZAJKFPRVPVQVRXGWAWKWNYLYLYKXMUJXPY
      DYEYMYMADEFFJKPRVKVLVSVT $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       3rd part of 3rd sentence. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  We show, in their notation, (s ` \/ ` t) ` /\ ` (f(s)
       ` \/ ` f(t)) is an atom.  (Contributed by NM, 11-Oct-2012.) $)
    cdleme16d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> ( ( S .\/ T ) ./\ ( F .\/ G ) ) e. A ) $=
      ( chlt wcel wa wbr wn w3a wne co clpl cdleme16c simp23r simp33 wb simp11l
      cfv simp21l simp22l simp11r simp12l simp12r simp13l lhpat2 syl222anc eqid
      simp23l islpln2a syl13anc mpbir2and eqeltrd clln islln2a mpbird cdleme16b
      syl3anc simp11 simp12 simp13 simp21 simp31 cdleme3fa simp22 simp32 2llnmj
      syl132anc ) KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZCNLUFUGZUEZUHZDAUDZDNLUFUG
      ZUEZEAUDZENLUFUGZUEZBCUIZDEUIZUEZUHZDBCJUJZLUFUGZEXGLUFUGZFDEJUJZLUFUGZUH
      ZUHZXJGHJUJZMUJAUDZXJXNJUJZKUKUQZUDZXMXPXJFJUJZXQABCDEFGHIJKLMNOPQRSTUAUB
      ULXMXSXQUDZXDXKXCXDWSXBWPXLUMZWPXFXHXIXKUNXMWGWQWTFAUDZXTXDXKUEUOWGWHWLWO
      XFXLUPZWQWRXBXEWPXLURZWTXAWSXEWPXLUSZXMWGWHWJWKWMXCYBYCWGWHWLWOXFXLUTWJWK
      WIWOXFXLVAWJWKWIWOXFXLVBWMWNWIWLXFXLVCXCXDWSXBWPXLVGZABCFIJKLMNOPQRSTVDVE
      AXQDEFJKLOPRXQVFZVHVIVJVKXMWGXJKVLUQZUDZXNYHUDZXOXRUOYCXMYIXDYAXMWGWQWTYI
      XDUOYCYDYEADEJKYHPRYHVFZVMVPVNXMYJGHUIZABCDEFGHIJKLMNOPQRSTUAUBVOXMWGGAUD
      ZHAUDZYJYLUOYCXMWIWLWOWSXCXHYMWIWLWOXFXLVQZWIWLWOXFXLVRZWIWLWOXFXLVSZWPWS
      XBXEXLVTYFWPXFXHXIXKWAABCDFGIJKLMNOPQRSTUAWBWFXMWIWLWOXBXCXIYNYOYPYQWPWSX
      BXEXLWCYFWPXFXHXIXKWDABCEFHIJKLMNOPQRSTUBWBWFAGHJKYHPRYKVMVPVNAXQJKMYHXJX
      NPQRYKYGWEVPVN $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       3rd part of 3rd sentence. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  We show, in their notation, (s ` \/ ` t) ` /\ ` (f(s)
       ` \/ ` f(t))=(s ` \/ ` t) ` /\ ` w.  (Contributed by NM,
       11-Oct-2012.) $)
    cdleme16e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> ( ( S .\/ T ) ./\ ( F .\/ G ) ) = ( ( S .\/ T ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne wceq clat cbs cfv simp11l hllat syl simp21l
      simp22l eqid hlatjcl syl3anc simp11 simp12 simp13 simp21 simp31 cdleme3fa
      simp23l syl132anc simp22 simp32 latmle1 cdleme15 simp11r lhpbase latlem12
      co latmcl syl13anc mpbi2and cal hlatl cdleme16d simp21r simp23r syl222anc
      wb lhpat atcmp mpbid ) KUCUDZNIUDZUEZBAUDBNLUFUGUEZCAUDCNLUFUGUEZUHZDAUDZ
      DNLUFUGZUEZEAUDZENLUFUGZUEZBCUIZDEUIZUEZUHZDBCJVQZLUFUGZEXGLUFUGZFDEJVQZL
      UFUGZUHZUHZXJGHJVQZMVQZXJNMVQZLUFZXOXPUJZXMXOXJLUFZXONLUFZXQXMKUKUDZXJKUL
      UMZUDZXNYBUDZXSXMWKYAWKWLWNWOXFXLUNZKUOUPZXMWKWQWTYCYEWQWRXBXEWPXLUQZWTXA
      WSXEWPXLURZAYBJKDEYBUSZPRUTVAZXMWKGAUDZHAUDZYDYEXMWMWNWOWSXCXHYKWMWNWOXFX
      LVBZWMWNWOXFXLVCZWMWNWOXFXLVDZWPWSXBXEXLVEXCXDWSXBWPXLVHZWPXFXHXIXKVFABCD
      FGIJKLMNOPQRSTUAVGVIXMWMWNWOXBXCXIYLYMYNYOWPWSXBXEXLVJYPWPXFXHXIXKVKABCEF
      HIJKLMNOPQRSTUBVGVIAYBJKGHYIPRUTVAZYBKLMXJXNYIOQVLVAABCDEFGHIJKLMNOPQRSTU
      AUBVMXMYAXOYBUDZYCNYBUDZXSXTUEXQWGYFXMYAYCYDYRYFYJYQYBKMXJXNYIQVRVAYJXMWL
      YSWKWLWNWOXFXLVNZYBIKNYISVOUPYBKLMXOXJNYIOQVPVSVTXMKWAUDZXOAUDXPAUDZXQXRW
      GXMWKUUAYEKWBUPABCDEFGHIJKLMNOPQRSTUAUBWCXMWKWLWQWRWTXDUUBYEYTYGWQWRXBXEW
      PXLWDYHXCXDWSXBWPXLWEADEIJKLMNOPQRSWHWFAXOXPKLORWIVAWJ $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       3rd part of 3rd sentence. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  We show, in their notation, (s ` \/ ` t) ` /\ ` (f(s)
       ` \/ ` f(t))=(f(s) ` \/ ` f(t)) ` /\ ` w.  (Contributed by NM,
       11-Oct-2012.) $)
    cdleme16f $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> ( ( S .\/ T ) ./\ ( F .\/ G ) ) = ( ( F .\/ G ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne wceq clat cbs cfv simp11l hllat syl simp21l
      simp22l eqid hlatjcl syl3anc simp11 simp12 simp13 simp21 simp31 cdleme3fa
      simp23l syl132anc simp22 simp32 latmle2 cdleme15 simp11r lhpbase latlem12
      co latmcl syl13anc mpbi2and cal hlatl cdleme16d cdleme16b lhpat syl122anc
      wb cdleme3 atcmp mpbid ) KUCUDZNIUDZUEZBAUDBNLUFUGUEZCAUDCNLUFUGUEZUHZDAU
      DZDNLUFUGZUEZEAUDZENLUFUGZUEZBCUIZDEUIZUEZUHZDBCJVQZLUFUGZEXGLUFUGZFDEJVQ
      ZLUFUGZUHZUHZXJGHJVQZMVQZXNNMVQZLUFZXOXPUJZXMXOXNLUFZXONLUFZXQXMKUKUDZXJK
      ULUMZUDZXNYBUDZXSXMWKYAWKWLWNWOXFXLUNZKUOUPZXMWKWQWTYCYEWQWRXBXEWPXLUQWTX
      AWSXEWPXLURAYBJKDEYBUSZPRUTVAZXMWKGAUDZHAUDZYDYEXMWMWNWOWSXCXHYIWMWNWOXFX
      LVBZWMWNWOXFXLVCZWMWNWOXFXLVDZWPWSXBXEXLVEZXCXDWSXBWPXLVHZWPXFXHXIXKVFZAB
      CDFGIJKLMNOPQRSTUAVGVIZXMWMWNWOXBXCXIYJYKYLYMWPWSXBXEXLVJYOWPXFXHXIXKVKAB
      CEFHIJKLMNOPQRSTUBVGVIZAYBJKGHYGPRUTVAZYBKLMXJXNYGOQVLVAABCDEFGHIJKLMNOPQ
      RSTUAUBVMXMYAXOYBUDZYDNYBUDZXSXTUEXQWGYFXMYAYCYDYTYFYHYSYBKMXJXNYGQVRVAYS
      XMWLUUAWKWLWNWOXFXLVNYBIKNYGSVOUPYBKLMXOXNNYGOQVPVSVTXMKWAUDZXOAUDXPAUDZX
      QXRWGXMWKUUBYEKWBUPABCDEFGHIJKLMNOPQRSTUAUBWCXMWMYIGNLUFUGZYJGHUIUUCYKYQX
      MWMWNWOWSXCXHUUDYKYLYMYNYOYPABCDFGIJKLMNOPQRSTUAWHVIYRABCDEFGHIJKLMNOPQRS
      TUAUBWDAGHIJKLMNOPQRSWEWFAXOXPKLORWIVAWJ $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph on p. 114,
       Eq.  (1). ` F ` and ` G ` represent f(s) and f(t) respectively.  We
       show, in their notation, (s ` \/ ` t) ` /\ ` w=(f(s) ` \/ ` f(t)) ` /\ `
       w.  (Contributed by NM, 11-Oct-2012.) $)
    cdleme16g $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> ( ( S .\/ T ) ./\ W ) = ( ( F .\/ G ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cdleme16e cdleme16f eqtr3d ) KUCUDNIUDUE
      BAUDBNLUFUGUECAUDCNLUFUGUEUHDAUDDNLUFUGUEEAUDENLUFUGUEBCUIDEUIUEUHDBCJUJZ
      LUFUGEUNLUFUGFDEJUJZLUFUGUHUHUOGHJUJZMUJUONMUJUPNMUJABCDEFGHIJKLMNOPQRSTU
      AUBUKABCDEFGHIJKLMNOPQRSTUAUBULUM $.

    $( Part of proof of Lemma E in [Crawley] p. 113, conclusion of 3rd
       paragraph on p. 114. ` F ` and ` G ` represent f(s) and f(t)
       respectively.  We show, in their notation, (s ` \/ ` t) ` /\ ` w=(f(s)
       ` \/ ` f(t)) ` /\ ` w, whether or not u ` <_ ` s ` \/ ` t.  (Contributed
       by NM, 11-Oct-2012.) $)
    cdleme16 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
        /\ ( P =/= Q /\ S =/= T ) )
     /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) ) )
           -> ( ( S .\/ T ) ./\ W ) = ( ( F .\/ G ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq simpl11 simpl12 simpl13 simpl21 simpl22
      wne simpl23 simpl3l simpl3r cdleme11 syl333anc eqcomd cdleme16g pm2.61dan
      simpr oveq1d ) KUCUDNIUDUEZBAUDBNLUFUGUEZCAUDCNLUFUGUEZUHZDAUDDNLUFUGUEZE
      AUDENLUFUGUEZBCUPDEUPUEZUHZDBCJUIZLUFUGZEVOLUFUGZUEZUHZFDEJUIZLUFZVTNMUIG
      HJUIZNMUIUJZVSWAUEZVTWBNMWDWBVTWDVGVHVIVKVLVMVPVQWAWBVTUJVGVHVIVNVRWAUKVG
      VHVIVNVRWAULVGVHVIVNVRWAUMVKVLVMVJVRWAUNVKVLVMVJVRWAUOVKVLVMVJVRWAUQVPVQV
      JVNWAURVPVQVJVNWAUSVSWAVEABCDEFGHIJKLMNOPQRSTUAUBUTVAVBVFVSWAUGZUEVGVHVIV
      KVLVMVPVQWEWCVGVHVIVNVRWEUKVGVHVIVNVRWEULVGVHVIVNVRWEUMVKVLVMVJVRWEUNVKVL
      VMVJVRWEUOVKVLVMVJVRWEUQVPVQVJVNWEURVPVQVJVNWEUSVSWEVEABCDEFGHIJKLMNOPQRS
      TUAUBVCVAVD $.
  $}

  ${
    cdleme17.l $e |- .<_ = ( le ` K ) $.
    cdleme17.j $e |- .\/ = ( join ` K ) $.
    cdleme17.m $e |- ./\ = ( meet ` K ) $.
    cdleme17.a $e |- A = ( Atoms ` K ) $.
    cdleme17.h $e |- H = ( LHyp ` K ) $.
    cdleme17.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme17.f $e |- F
        = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme17.g $e |- G
        = ( ( P .\/ Q ) ./\ ( F .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    ${
      cdleme17.c $e |- C = ( ( P .\/ S ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 114, first part of 4th
         paragraph. ` F ` , ` G ` , and ` C ` represent f(s), f_s(p), and s_1
         respectively.  We show, in their notation, f_s(p)=(p ` \/ ` q) ` /\ `
         (q ` \/ ` s_1).  (Contributed by NM, 11-Oct-2012.) $)
      cdleme17a $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ ( S e. A /\ -. S .<_ W ) )
    /\ -. S .<_ ( P .\/ Q ) )
              -> G = ( ( P .\/ Q ) ./\ ( Q .\/ C ) ) ) $=
        ( chlt wcel wa wbr wn w3a co cdleme7a cdleme9 oveq2d syl5eq ) KUDUENIUE
        UFCAUECNLUGUHUFDAUEEAUEENLUGUHUFUIECDJUJZLUGUHUIZHUOGBJUJZMUJUODBJUJZMU
        JACDCEFGHIJKLMBNOPQRSTUAUBUCUKUPUQURUOMABCDEFGIJKLMNOPQRSTUAUCULUMUN $.

      $( Lemma leading to ~ cdleme17c .  (Contributed by NM, 11-Oct-2012.) $)
      cdleme17b $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
                    /\ ( Q e. A /\ S e. A /\ -. S .<_ ( P .\/ Q ) ) )
              -> -. C .<_ ( P .\/ Q ) ) $=
        ( chlt wcel wa wbr wn co w3a simp33 cbs cfv eqid clat simpl1l hllat syl
        simpl32 atbase simpl2l hlatjcl syl3anc simpl31 hlatlej2 simpl1r simpl2r
        cdleme8 syl221anc hlatlej1 simpr wb cdleme9b syl13anc latjle12 mpbi2and
        wceq eqbrtrrd lattrd mtand ) KUDUEZNIUEZUFZCAUEZCNLUGUHZUFZDAUEZEAUEZEC
        DJUIZLUGZUHZUJZUJZBWILUGZWJWCWFWGWHWKUKWMWNUFZKULUMZKLECEJUIZWIWPUNZOWO
        WAKUOUEZWAWBWFWLWNUPZKUQURZWOWHEWPUEWGWHWKWCWFWNUSZAWPEKWRRUTURWOWAWDWH
        WQWPUEWTWDWEWCWLWNVAZXBAWPJKCEWRPRVBVCWOWAWDWGWIWPUEZWTXCWGWHWKWCWFWNVD
        ZAWPJKCDWRPRVBVCZWOWAWDWHEWQLUGWTXCXBACEJKLOPRVEVCWOCBJUIZWQWILWOWAWBWD
        WEWHXGWQVQWTWAWBWFWLWNVFZXCWDWEWCWLWNVGXBABCEIJKLMNOPQRSUCVHVIWOCWILUGZ
        WNXGWILUGZWOWAWDWGXIWTXCXEACDJKLOPRVJVCWMWNVKWOWSCWPUEZBWPUEZXDXIWNUFXJ
        VLXAWOWDXKXCAWPCKWRRUTURWOWAWDWHWBXLWTXCXBXHAWPBCEIJKMNWRPQRSUCVMVNXFWP
        JKLCBWIWROPVOVNVPVRVSVT $.

      $( Part of proof of Lemma E in [Crawley] p. 114, first part of 4th
         paragraph. ` C ` represents s_1.  We show, in their notation, (p
         ` \/ ` q) ` /\ ` (q ` \/ ` s_1)=q.  (Contributed by NM,
         11-Oct-2012.) $)
      cdleme17c $p |- ( ( ( K e. HL /\ W e. H )
                    /\ ( P e. A /\ -. P .<_ W )
                    /\ ( Q e. A /\ S e. A /\ -. S .<_ ( P .\/ Q ) ) )
              -> ( ( P .\/ Q ) ./\ ( Q .\/ C ) ) = Q ) $=
        ( chlt wcel wa wbr wn co w3a wceq simp1l simp2l simp31 hlatjcom syl3anc
        oveq1d wne simp1r simp2r simp32 clat cbs cfv hllat syl atbase latnlej1l
        eqid simp33 necomd syl131anc cdleme9a syl222anc cdleme17b 2llnma1 eqtrd
        ) KUDUEZNIUEZUFZCAUEZCNLUGUHZUFZDAUEZEAUEZECDJUIZLUGUHZUJZUJZWFDBJUIZMU
        IDCJUIZWJMUIZDWIWFWKWJMWIVRWAWDWFWKUKVRVSWCWHULZVTWAWBWHUMZVTWCWDWEWGUN
        ZAJKCDPRUOUPUQWIVRWAWDBAUEZBWFLUGUHWLDUKWMWNWOWIVRVSWAWBWECEURZWPWMVRVS
        WCWHUSWNVTWAWBWHUTVTWCWDWEWGVAZWIKVBUEZEKVCVDZUEZCWTUEZDWTUEZWGWQWIVRWS
        WMKVEVFWIWEXAWRAWTEKWTVIZRVGVFWIWAXBWNAWTCKXDRVGVFWIWDXCWOAWTDKXDRVGVFV
        TWCWDWEWGVJWSXAXBXCUJWGUJECWTJKLECDXDOPVHVKVLABCEIJKLMNOPQRSUCVMVNABCDE
        FGHIJKLMNOPQRSTUAUBUCVOACDBJKLMOPQRVPVLVQ $.
    $}
    $( Part of proof of Lemma E in [Crawley] p. 114, first part of 4th
       paragraph. ` F ` , ` G ` represent f(s), f_s(p) respectively.  We show,
       in their notation, f_s(p)=q.  (Contributed by NM, 11-Oct-2012.) $)
    cdleme17d1 $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ ( S e. A /\ -. S .<_ W ) )
    /\ -. S .<_ ( P .\/ Q ) )
            -> G = Q ) $=
      ( chlt wcel wa wbr wn w3a co eqid cdleme17a simp1l simp1r simp21l simp21r
      wceq simp22 simp23l simp3 cdleme17c syl223anc eqtrd ) JUBUCZMHUCZUDZBAUCZ
      BMKUEUFZUDZCAUCZDAUCZDMKUEUFZUDZUGZDBCIUHZKUEUFZUGZGVMCBDIUHMLUHZIUHLUHZC
      AVPBCDEFGHIJKLMNOPQRSTUAVPUIZUJVOVBVCVEVFVHVIVNVQCUOVBVCVLVNUKVBVCVLVNULV
      EVFVHVKVDVNUMVEVFVHVKVDVNUNVDVGVHVKVNUPVIVJVGVHVDVNUQVDVLVNURAVPBCDEFGHIJ
      KLMNOPQRSTUAVRUSUTVA $.
  $}

  ${
    $d r A $.  $d r .\/ $.  $d r .<_ $.  $d r P $.  $d r Q $.  $d r R $.
    $d r W $.
    cdleme0nex.l $e |- .<_ = ( le ` K ) $.
    cdleme0nex.j $e |- .\/ = ( join ` K ) $.
    cdleme0nex.a $e |- A = ( Atoms ` K ) $.
    $( Part of proof of Lemma E in [Crawley] p. 114, 4th line of 4th
       paragraph.  Whenever (in their terminology) p ` \/ ` q/0 (i.e. the
       sublattice from 0 to p ` \/ ` q) contains precisely three atoms, any
       atom not under w must equal either p or q.  (In case of 3 atoms, one of
       them must be u - see ~ cdleme0a - which is under w, so the only 2 left
       not under w are p and q themselves.)  Note that by ~ cvlsupr2 , our
       ` ( P .\/ r ) = ( Q .\/ r ) ` is a shorter way to express
       ` r =/= P /\ r =/= Q /\ r .<_ ( P .\/ Q ) ` .  Thus, the negated
       existential condition states there are no atoms different from p or q
       that are also not under w.  (Contributed by NM, 12-Nov-2012.) $)
    cdleme0nex $p |- ( ( ( K e. HL /\ R .<_ ( P .\/ Q )
         /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) )
     /\ ( P e. A /\ Q e. A /\ P =/= Q )
     /\ ( R e. A /\ -. R .<_ W ) )
             -> ( R = P \/ R = Q ) ) $=
      ( wcel co wbr wn wceq wa w3a wne chlt cv wrex wo simp3r simp12 jca simp3l
      wi simp13 ralnex sylibr breq1 notbid oveq2 eqeq12d anbi12d rspcva syl2anc
      wral wb simp11 hlcvl simp21 simp22 simp23 cvlsupr2 syl131anc anbi2d mtbid
      clc ianor df-3an anbi2i an12 bitri notbii pm4.62 3bitr4ri neanior con2bii
      syl mt2d ) FUAMZDBCENGOZIUBZHGOZPZBWFENZCWFENZQZRZIAUCPZSZBAMZCAMZBCTZSZD
      AMZDHGOZPZRZSZDBTZDCTZRZPZDBQDCQUDZXCXFXAWERZXCXAWEWNWRWSXAUEWDWEWMWRXBUF
      UGXCXAXDXEWESZRZPZXFXIPZUIZXCXABDENZCDENZQZRZXKXCWSWLPZIAUTZXRPZWNWRWSXAU
      HZXCWMXTWDWEWMWRXBUJWLIAUKULXSYAIDAWFDQZWLXRYCWHXAWKXQYCWGWTWFDHGUMUNYCWI
      XOWJXPWFDBEUOWFDCEUOUPUQUNURUSXCXQXJXAXCFVKMZWOWPWSWQXQXJVAXCWDYDWDWEWMWR
      XBVBFVCWBWNWOWPWQXBVDWNWOWPWQXBVEYBWNWOWPWQXBVFABCDEFGLJKVGVHVIVJXFXIRZPX
      GXMUDXLXNXFXIVLXKYEXKXAXFWERZRYEXJYFXAXDXEWEVMVNXAXFWEVOVPVQXFXIVRVSULWCX
      FXHDBDCVTWAUL $.
  $}

  ${
    cdleme18.l $e |- .<_ = ( le ` K ) $.
    cdleme18.j $e |- .\/ = ( join ` K ) $.
    cdleme18.m $e |- ./\ = ( meet ` K ) $.
    cdleme18.a $e |- A = ( Atoms ` K ) $.
    cdleme18.h $e |- H = ( LHyp ` K ) $.
    cdleme18.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme18.f $e |- F
        = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme18.g $e |- G
         = ( ( P .\/ Q ) ./\ ( F .\/ ( ( Q .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 114, 2nd sentence of 4th
       paragraph. ` F ` , ` G ` represent f(s), f_s(q) respectively.  We show
       ` -. ` f_s(q) ` <_ ` w.  (Contributed by NM, 12-Oct-2012.) $)
    cdleme18a $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
      /\ ( S e. A /\ -. S .<_ W ) )
    /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) )
            -> -. G .<_ W ) $=
      ( chlt wcel wa wbr wn w3a wne co simp1 simp21 simp22 simp23 simp3l simp1l
      simp21l simp22l hlatlej2 syl3anc simp3r cdleme7 syl323anc ) JUBUCZMHUCZUD
      ZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZDAUCDMKUEUFUDZUGZBCUHZDBCIUIZKUEUFZUDZUG
      ZVEVHVKVKVLVNCVOKUEZVPGMKUEUFVEVMVQUJVEVHVKVLVQUKVEVHVKVLVQULZVTVEVHVKVLV
      QUMVEVMVNVPUNVRVCVFVIVSVCVDVMVQUOVFVGVKVLVEVQUPVIVJVHVLVEVQUQABCIJKNOQURU
      SVEVMVNVPUTABCCDEFGHIJKLMNOPQRSTUAVAVB $.

    $( Part of proof of Lemma E in [Crawley] p. 114, 2nd sentence of 4th
       paragraph. ` F ` , ` G ` represent f(s), f_s(q) respectively.  We show
       ` -. ` f_s(q) ` =/= ` q.  (Contributed by NM, 12-Oct-2012.) $)
    cdleme18b $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
      /\ ( S e. A /\ -. S .<_ W ) )
    /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) ) )
            -> G =/= Q ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq eqid oveq2 simp22l hlatjidm syl2anc
      simp1l sylan9eqr simp21l simp22 simp23 hlatlej2 syl3anc cdleme5 syl132anc
      simp1 adantr eqtr3d simp3l 2atneat syl13anc nelne2 necomd eqnetrd necon2d
      ex mpi ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZDAUCDMKUEUFUDZUGZB
      CUHZDBCIUIZKUEUFZUDZUGZCCUJGCUHCUKWLGCCCWLGCUJZCCUHWLWMUDZCWICWNCGIUIZCWI
      WMWLWOCCIUIZCGCCIULWLVQWCWPCUJVQVRWGWKUPZWCWDWBWFVSWKUMZAIJCOQUNUOUQWLWOW
      IUJZWMWLVSVTWCWEWFCWIKUEZWSVSWGWKVEVTWAWEWFVSWKURZWRVSWBWEWFWKUSVSWBWEWFW
      KUTWLVQVTWCWTWQXAWRABCIJKNOQVAVBABCCDEFGHIJKLMNOPQRSTUAVCVDVFVGWLWICUHZWM
      WLWCWIAUCUFZXBWRWLVQVTWCWHXCWQXAWRVSWGWHWJVHABCIJOQVIVJWCXCUDCWICWIAVKVLU
      OVFVMVOVNVP $.

    $d r A $.  $d r G $.  $d r .\/ $.  $d r .<_ $.  $d r P $.  $d r Q $.
    $d r W $.
    $( Part of proof of Lemma E in [Crawley] p. 114, 2nd sentence of 4th
       paragraph. ` F ` , ` G ` represent f(s), f_s(q) respectively.  We show
       ` -. ` f_s(q) = p whenever p ` \/ ` q has three atoms under it (implied
       by the negated existential condition).  (Contributed by NM,
       10-Nov-2012.) $)
    cdleme18c $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
         /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q )
             /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
            -> G = P ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex simp31 simp32 jca cdleme18b
      syld3an3 neneqd wo simp1l simp1r simp21l simp22l simp23l syl231anc simp33
      cdleme4a simp1 simp21 simp22 simp23 syl3anc cdleme7ga syl323anc cdleme18a
      hlatlej2 cdleme0nex syl332anc ord mt3d ) JUCUDZMHUDZUEZBAUDZBMKUFUGZUEZCA
      UDZCMKUFUGZUEZDAUDZDMKUFUGZUEZUHZBCUIZDBCIUJZKUFUGZNUKZMKUFUGBWRIUJCWRIUJ
      ULUENAUMUGZUHZUHZGBULZGCULZXAGCWDWNWTWOWQUEZGCUIXAWOWQWDWNWOWQWSUNZWDWNWO
      WQWSUOZUPZABCDEFGHIJKLMOPQRSTUAUBUQURUSXAXBXCXAWBGWPKUFZWSWEWHWOGAUDZGMKU
      FUGZXBXCUTWBWCWNWTVAZXAWBWCWEWHWHWKXHXKWBWCWNWTVBWEWFWJWMWDWTVCZWHWIWGWMW
      DWTVDZXMWKWLWGWJWDWTVEABCCDEFGHIJKLMOPQRSTUAUBVHVFWDWNWOWQWSVGXLXMXEXAWDW
      GWJWJWMWOCWPKUFZWQXIWDWNWTVIWDWGWJWMWTVJWDWGWJWMWTVKZXOWDWGWJWMWTVLXEXAWB
      WEWHXNXKXLXMABCIJKOPRVQVMXFABCCDEFGHIJKLMOPQRSTUAUBVNVOWDWNWTXDXJXGABCDEF
      GHIJKLMOPQRSTUAUBVPURABCGIJKMNOPRVRVSVTWA $.
  $}

  ${
    $d r A $.  $d r D $.  $d r F $.  $d r .\/ $.  $d r .<_ $.  $d r ./\ $.
    $d r P $.  $d r Q $.  $d r R $.  $d r S $.  $d r T $.  $d r W $.
    cdleme18d.l $e |- .<_ = ( le ` K ) $.
    cdleme18d.j $e |- .\/ = ( join ` K ) $.
    cdleme18d.m $e |- ./\ = ( meet ` K ) $.
    cdleme18d.a $e |- A = ( Atoms ` K ) $.
    cdleme18d.h $e |- H = ( LHyp ` K ) $.
    cdleme18d.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme18d.f $e |- F
       = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme18d.g $e |- G
       = ( ( P .\/ Q ) ./\ ( F .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
    ${
      cdleme22.b $e |- B = ( Base ` K ) $.
      $( Utility lemma for Lemma E in [Crawley] p. 115.  (Contributed by NM,
         5-Dec-2012.) $)
      cdleme22gb $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ Q e. A ) /\ ( R e. A /\ S e. A ) ) -> G e. B ) $=
        ( chlt wcel wa w3a co clat simp1l hllat syl simp2l simp2r hlatjcl simp1
        syl3anc simp3r cdleme1b syl13anc simp3l simp1r lhpbase latmcl syl5eqel
        latjcl ) LUEUFZOJUFZUGZCAUFZDAUFZUGZEAUFZFAUFZUGZUHZICDKUIZHEFKUIZONUIZ
        KUIZNUIZBUCVQLUJUFZVRBUFZWABUFZWBBUFVQVHWCVHVIVMVPUKZLULUMZVQVHVKVLWDWF
        VJVKVLVPUNZVJVKVLVPUOZABKLCDUDQSUPURVQWCHBUFZVTBUFZWEWGVQVJVKVLVOWJVJVM
        VPUQWHWIVJVMVNVOUSZABCDFGHJKLMNOPQRSTUAUBUDUTVAVQWCVSBUFZOBUFZWKWGVQVHV
        NVOWMWFVJVMVNVOVBWLABKLEFUDQSUPURVQVIWNVHVIVMVPVCBJLOUDTVDUMBLNVSOUDRVE
        URBKLHVTUDQVGURBLNVRWAUDRVEURVF $.
    $}

    cdleme18d.d $e |- D
       = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
    cdleme18d.e $e |- E
       = ( ( P .\/ Q ) ./\ ( D .\/ ( ( R .\/ T ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 114, 4th sentence of 4th
       paragraph. ` F ` , ` G ` , ` D ` , ` E ` represent f(s), f_s(r), f(t),
       f_t(r) respectively.  We show f_s(r)=f_t(r) for all possible r (which
       must equal p or q in the case of exactly 3 atoms in p ` \/ ` q/0 i.e.
       when ` -. E. r e. A ` ...).  (Contributed by NM, 12-Nov-2012.) $)
    cdleme18d $p |- ( ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
         /\ ( T e. A /\ -. T .<_ W ) )
     /\ ( P =/= Q
       /\ ( R .<_ ( P .\/ Q )
           /\ -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
            -> G = E ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex eleq1 breq1 anbi12d 3anbi1d
      notbid 3anbi2d simp11 simp21 simp13l simp22 simp322 eqid syl131anc simp23
      cdleme17d1 simp323 eqtr4d syl6bi eqeq12i oveq1 oveq1d oveq2d syl5bb com12
      eqeq12d sylibrd 3anbi23d simp11l simp12 simp31 simp33 cdleme18c syl233anc
      simp11r wo simp321 simp12l simp21l simp21r cdleme0nex syl332anc mpjaod )
      NUIUJZQLUJZUKZCAUJZCQOULZUMZUKZDAUJZDQOULZUMZUKZUNZEAUJZEQOULZUMZUKZFAUJF
      QOULUMUKZGAUJGQOULUMUKZUNZCDUOZECDMUPZOULZFYBOULUMZGYBOULUMZUNZRUQZQOULUM
      CYGMUPDYGMUPURUKRAUSUMZUNZUNZECURZKIURZEDURZYKYJYLYKYJYBJCFMUPZQPUPZMUPZP
      UPZYBBCGMUPZQPUPZMUPZPUPZURZYLYKYJXMXHXRXSUNZYIUNZUUBYKXTUUCXMYIYKXQXHXRX
      SYKXNXEXPXGECAUTYKXOXFECQOVAVDVBVCVEUUDYQDUUAUUDXDXHXIXRYDYQDURXDXHXLUUCY
      IVFZXMXHXRXSYIVGZXIXKXDXHUUCYIVHZXMXHXRXSYIVIYCYDYEYAYHXMUUCVJACDFHJYQLMN
      OPQSTUAUBUCUDUEYQVKVNVLUUDXDXHXIXSYEUUADURUUEUUFUUGXMXHXRXSYIVMYCYDYEYAYH
      XMUUCVOACDGHBUUALMNOPQSTUAUBUCUDUGUUAVKVNVLVPVQYLYBJEFMUPZQPUPZMUPZPUPZYB
      BEGMUPZQPUPZMUPZPUPZURZYKUUBKUUKIUUOUFUHVRZYKUUKYQUUOUUAYKUUJYPYBPYKUUIYO
      JMYKUUHYNQPECFMVSVTWAWAYKUUNYTYBPYKUUMYSBMYKUULYRQPECGMVSVTWAWAWDWBWEWCYM
      YJYLYMYJYBJDFMUPZQPUPZMUPZPUPZYBBDGMUPZQPUPZMUPZPUPZURZYLYMYJXMXLXRXSUNZY
      ADYBOULZYDYEUNZYHUNZUNZUVFYMXTUVGYIUVJXMYMXQXLXRXSYMXNXIXPXKEDAUTYMXOXJED
      QOVAVDVBVCYMYFUVIYAYHYMYCUVHYDYEEDYBOVAVCVEWFUVKUVACUVEUVKXBXCXHXLXRYAYDY
      HUVACURXBXCXHXLUVGUVJWGZXBXCXHXLUVGUVJWMZXDXHXLUVGUVJWHZXMXLXRXSUVJVGZXMX
      LXRXSUVJVIXMUVGYAUVIYHWIZUVHYDYEYAYHXMUVGVJXMUVGYAUVIYHWJZACDFHJUVALMNOPQ
      RSTUAUBUCUDUEUVAVKWKWLUVKXBXCXHXLXSYAYEYHUVECURUVLUVMUVNUVOXMXLXRXSUVJVMU
      VPUVHYDYEYAYHXMUVGVOUVQACDGHBUVELMNOPQRSTUAUBUCUDUGUVEVKWKWLVPVQYLUUPYMUV
      FUUQYMUUKUVAUUOUVEYMUUJUUTYBPYMUUIUUSJMYMUUHUURQPEDFMVSVTWAWAYMUUNUVDYBPY
      MUUMUVCBMYMUULUVBQPEDGMVSVTWAWAWDWBWEWCYJXBYCYHXEXIYAXNXPYKYMWNXBXCXHXLXT
      YIWGYCYDYEYAYHXMXTWOXMXTYAYFYHWJXEXGXDXLXTYIWPXIXKXDXHXTYIVHXMXTYAYFYHWIX
      NXPXRXSXMYIWQXNXPXRXSXMYIWRACDEMNOQRSTUBWSWTXA $.
  $}

  ${
    cdlemesner.l $e |- .<_ = ( le ` K ) $.
    cdlemesner.j $e |- .\/ = ( join ` K ) $.
    cdlemesner.a $e |- A = ( Atoms ` K ) $.
    cdlemesner.h $e |- H = ( LHyp ` K ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma.
       (Contributed by NM, 13-Nov-2012.) $)
    cdlemesner $p |- ( ( K e. HL /\ ( R e. A /\ S e. A )
         /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) ) -> S =/= R ) $=
      ( chlt wcel wa co wbr wn w3a wne nbrne2 3ad2ant3 necomd ) HNOZDAOEAOPZDBC
      GQZIREUGIRSPZTDEUHUEDEUAUFDEUGIUBUCUD $.
  $}

  ${
    cdlemeda.l $e |- .<_ = ( le ` K ) $.
    cdlemeda.j $e |- .\/ = ( join ` K ) $.
    cdlemeda.m $e |- ./\ = ( meet ` K ) $.
    cdlemeda.a $e |- A = ( Atoms ` K ) $.
    cdlemeda.h $e |- H = ( LHyp ` K ) $.
    cdlemeda.d $e |- D = ( ( R .\/ S ) ./\ W ) $.
    ${
      cdlemedb.b $e |- B = ( Base ` K ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma. ` D `
         represents s_2.  (Contributed by NM, 20-Nov-2012.) $)
      cdlemedb $p |- ( ( ( K e. HL /\ W e. H ) /\ ( R e. A /\ S e. A ) )
           -> D e. B ) $=
        ( wcel wa chlt clat hllat ad2antrr simpll simprl simprr hlatjcl syl3anc
        co lhpbase ad2antlr latmcl syl5eqel ) HUASZKFSZTZDASZEASZTZTZCDEGUJZKJU
        JZBQVAHUBSZVBBSZKBSZVCBSUOVDUPUTHUCUDVAUOURUSVEUOUPUTUEUQURUSUFUQURUSUG
        ABGHDERMOUHUIUPVFUOUTBFHKRPUKULBHJVBKRNUMUIUN $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma. ` D `
       represents s_2.  (Contributed by NM, 13-Nov-2012.) $)
    cdlemeda $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S e. A /\ -. S .<_ W )
       /\ ( R e. A /\ R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
  -> D e. A ) $=
      ( wcel co chlt wa wbr wn w3a simp1l simp31 simp2l hlatjcom syl3anc oveq1d
      wceq wne simp1r simp2r simp32 simp33 cdlemesner syl122anc lhpat syl222anc
      eqeltrd syl5eqel ) IUASZLGSZUBZFASZFLJUCUDZUBZEASZECDHTZJUCZFVKJUCUDZUEZU
      EZBEFHTZLKTZARVOVQFEHTZLKTZAVOVPVRLKVOVDVJVGVPVRULVDVEVIVNUFZVFVIVJVLVMUG
      ZVFVGVHVNUHZAHIEFNPUIUJUKVOVDVEVGVHVJFEUMZVSASVTVDVEVIVNUNWBVFVGVHVNUOWAV
      OVDVJVGVLVMWCVTWAWBVFVIVJVLVMUPVFVIVJVLVMUQACDEFGHIJMNPQURUSAFEGHIJKLMNOP
      QUTVAVBVC $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma. ` D `
       represents s_2.  (Contributed by NM, 18-Nov-2012.) $)
    cdlemednpq $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ Q e. A /\ ( R e. A /\ -. R .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ R .<_ ( P .\/ Q )
        /\ -. S .<_ ( P .\/ Q ) ) )
  -> -. D .<_ ( P .\/ Q ) ) $=
      ( wcel wbr chlt wa wn w3a co wne cbs cfv simp1l hllat syl simp23l simp31l
      clat eqid hlatjcl syl3anc simp1r lhpbase latmle2 syl5eqbr simp23r syl2anc
      nbrne2 wceq adantr latmle1 simpr simp31r simp32 simp33 cdlemeda syl223anc
      atbase simp21 simp22 latlem12 syl13anc mpbi2and cp0 cal hlatl atnle mpbid
      wb oveq2d atmod1i1 syl131anc hlol olj01 3eqtr3d breqtrd ex atcmp necon3ad
      col sylibd mpd ) IUASZLGSZUBZCASZDASZEASZELJTUCZUBZUDZFASZFLJTUCZUBZECDHU
      EZJTZFXKJTUCZUDZUDZBEUFZBXKJTZUCXOBLJTXEXPXOBEFHUEZLKUEZLJRXOIUNSZXRIUGUH
      ZSZLYASZXSLJTXOWSXTWSWTXGXNUIZIUJUKZXOWSXDXHYBYDXDXEXBXCXAXNULZXHXIXLXMXA
      XGUMZAYAHIEFYAUOZNPUPUQZXOWTYCWSWTXGXNURZYAGILYHQUSUKZYAIJKXRLYHMOUTUQVAX
      DXEXBXCXAXNVBBELJVDVCXOXQBEXOXQBEJTZBEVEZXOXQYLXOXQUBZBXRXKKUEZEJYNBXRJTZ
      XQBYOJTZYNBXSXRJRYNXTYBYCXSXRJTXOXTXQYEVFZXOYBXQYIVFZXOYCXQYKVFYAIJKXRLYH
      MOVGUQVAXOXQVHYNXTBYASZYBXKYASZYPXQUBYQWEYRXOYTXQXOBASZYTXOWSWTXHXIXDXLXM
      UUBYDYJYGXHXIXLXMXAXGVIYFXAXGXJXLXMVJZXAXGXJXLXMVKZABCDEFGHIJKLMNOPQRVLVM
      ZAYABIYHPVNUKVFYSXOUUAXQXOWSXBXCUUAYDXAXBXCXFXNVOXAXBXCXFXNVPAYAHICDYHNPU
      PUQZVFYAIJKBXRXKYHMOVQVRVSXOYOEVEXQXOEFXKKUEZHUEZEIVTUHZHUEZYOEXOUUGUUIEH
      XOXMUUGUUIVEZUUDXOIWASZXHUUAXMUUKWEXOWSUULYDIWBUKZYGUUFAYAFIJKXKUUIYHMOUU
      IUOZPWCUQWDWFXOWSXDFYASZUUAXLUUHYOVEYDYFXOXHUUOYGAYAFIYHPVNUKUUFUUCAYAEHI
      JKFXKYHMNOPWGWHXOIWPSZEYASZUUJEVEXOWSUUPYDIWIUKXOXDUUQYFAYAEIYHPVNUKYAHIE
      UUIYHNUUNWJVCWKVFWLWMXOUULUUBXDYLYMWEUUMUUEYFABEIJMPWNUQWQWOWR $.

    cdlemednu.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma. ` D `
       represents s_2.  (Contributed by NM, 18-Nov-2012.)
       (New usage is discouraged.) $)
    cdlemednuN $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ Q e. A /\ ( R e. A /\ -. R .<_ W ) )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ R .<_ ( P .\/ Q )
        /\ -. S .<_ ( P .\/ Q ) ) ) -> D =/= U ) $=
      ( chlt wcel wa wbr wn w3a wne cdlemednpq wceq simp1l simp1r simp21 simp22
      co cdlemeulpq syl22anc breq1 syl5ibrcom necon3bd mpd ) JUAUBZMHUBZUCZCAUB
      ZDAUBZEAUBEMKUDUEUCZUFZFAUBFMKUDUEUCECDIUNZKUDFVHKUDUEUFZUFZBVHKUDZUEBGUG
      ABCDEFHIJKLMNOPQRSUHVJVKBGVJVKBGUIGVHKUDZVJVAVBVDVEVLVAVBVGVIUJVAVBVGVIUK
      VCVDVEVFVIULVCVDVEVFVIUMACDGHIJKLMNOPQRTUOUPBGVHKUQURUSUT $.
  $}

  ${
    cdleme20z.l $e |- .<_ = ( le ` K ) $.
    cdleme20z.j $e |- .\/ = ( join ` K ) $.
    cdleme20z.m $e |- ./\ = ( meet ` K ) $.
    cdleme20z.a $e |- A = ( Atoms ` K ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma.
       (Contributed by NM, 17-Nov-2012.)  (New usage is discouraged.) $)
    cdleme20zN $p |- ( ( K e. HL /\ ( R e. A /\ S e. A /\ T e. A )
                /\ ( S =/= T /\ -. R .<_ ( S .\/ T ) ) )
               -> ( ( S .\/ R ) ./\ T ) = ( 0. ` K ) ) $=
      ( wcel w3a wne co wbr wn 3ad2ant1 syl3anc chlt wa cp0 cfv clat wceq hllat
      cbs simp1 simp22 simp21 eqid hlatjcl simp23 atbase syl latmcom simp3r clc
      wi hlcvl simp3l necomd cvlatexch1 syl131anc mtod cal wb hlatl atnle mpbid
      eqtrd ) FUAMZBAMZCAMZDAMZNZCDOZBCDEPGQZRZUBZNZCBEPZDHPZDWCHPZFUCUDZWBFUEM
      ZWCFUHUDZMZDWHMZWDWEUFVMVQWGWAFUGSWBVMVOVNWIVMVQWAUIVMVNVOVPWAUJZVMVNVOVP
      WAUKZAWHEFCBWHULZJLUMTZWBVPWJVMVNVOVPWAUNZAWHDFWMLUOUPWHFHWCDWMKUQTWBDWCG
      QZRZWEWFUFZWBWPVSVMVQVRVTURWBFUSMZVPVNVODCOWPVSUTVMVQWSWAFVASWOWLWKWBCDVM
      VQVRVTVBVCADBCEFGIJLVDVEVFWBFVGMZVPWIWQWRVHVMVQWTWAFVISWOWNAWHDFGHWCWFWMI
      KWFULLVJTVKVL $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Utility lemma.
       (Contributed by NM, 17-Nov-2012.) $)
    cdleme20y $p |- ( ( K e. HL /\ ( R e. A /\ S e. A /\ T e. A )
                /\ ( S =/= T /\ -. R .<_ ( S .\/ T ) ) )
               -> ( ( S .\/ R ) ./\ ( T .\/ R ) ) = R ) $=
      ( wcel w3a co wbr wn wceq syl3anc 3ad2ant1 chlt wne cp0 cfv simp3r simp22
      simp1 simp23 hlatjcom breq2d mtbid clc simp21 simp3l cvlatexch1 syl131anc
      wa wi hlcvl mtod cal cbs hlatl eqid hlatjcl atnle mpbid oveq1d atbase syl
      wb hlatlej2 atmod4i2 col hlol olj02 syl2anc 3eqtr3d ) FUAMZBAMZCAMZDAMZNZ
      CDUBZBCDEOZGPZQZUQZNZCDBEOZHOZBEOZFUCUDZBEOZCBEOWJHOZBWIWKWMBEWICWJGPZQZW
      KWMRZWIWPBDCEOZGPZWIWFWTVSWCWDWGUEWIWEWSBGWIVSWAWBWEWSRVSWCWHUGZVSVTWAWBW
      HUFZVSVTWAWBWHUHZAEFCDJLUISUJUKWIFULMZWAVTWBWDWPWTURVSWCXDWHFUSTXBVSVTWAW
      BWHUMZXCVSWCWDWGUNACBDEFGIJLUOUPUTWIFVAMZWAWJFVBUDZMZWQWRVKVSWCXFWHFVCTXB
      WIVSWBVTXHXAXCXEAXGEFDBXGVDZJLVESZAXGCFGHWJWMXIIKWMVDZLVFSVGVHWIVSWABXGMZ
      XHBWJGPZWLWORXAXBWIVTXLXEAXGBFXILVIVJZXJWIVSWBVTXMXAXCXEADBEFGIJLVLSAXGCE
      FGHBWJXIIJKLVMUPWIFVNMZXLWNBRVSWCXOWHFVOTXNXGEFBWMXIJXKVPVQVR $.
  $}

  ${
    cdleme19.l $e |- .<_ = ( le ` K ) $.
    cdleme19.j $e |- .\/ = ( join ` K ) $.
    cdleme19.m $e |- ./\ = ( meet ` K ) $.
    cdleme19.a $e |- A = ( Atoms ` K ) $.
    cdleme19.h $e |- H = ( LHyp ` K ) $.
    cdleme19.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme19.f $e |- F
        = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme19.g $e |- G
        = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
    cdleme19.d $e |- D = ( ( R .\/ S ) ./\ W ) $.
    cdleme19.y $e |- Y = ( ( R .\/ T ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, 5th paragraph on p. 114,
       1st line. ` D ` represents s_2.  In their notation, we prove that if r
       ` <_ ` s ` \/ ` t, then s_2=(s ` \/ ` t) ` /\ ` w.  (Contributed by NM,
       13-Nov-2012.) $)
    cdleme19a $p |- ( ( K e. HL /\ ( R e. A /\ S e. A /\ T e. A )
        /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q )
        /\ R .<_ ( S .\/ T ) ) )
     -> D = ( ( S .\/ T ) ./\ W ) ) $=
      ( chlt wcel w3a co wbr wn cbs cfv eqid hllat 3ad2ant1 simp1 simp21 simp22
      hlatjcl syl3anc simp23 simp33 hlatlej1 wa wb atbase syl latjle12 syl13anc
      clat mpbi2and hlatlej2 clc wne wi simp31 simp32 nbrne2 syl2anc cvlatexch1
      hlcvl syl131anc mpd wceq hlatjcom breqtrrd latasymd oveq1d syl5eq ) MUHUI
      ZEAUIZFAUIZGAUIZUJZECDLUKZNULZFWRNULUMZEFGLUKZNULZUJZUJZBEFLUKZPOUKXAPOUK
      UFXDXEXAPOXDMUNUOZMNXEXAXFUPZRWMWQMVMUIZXCMUQURZXDWMWNWOXEXFUIZWMWQXCUSZW
      MWNWOWPXCUTZWMWNWOWPXCVAZAXFLMEFXGSUAVBVCZXDWMWOWPXAXFUIZXKXMWMWNWOWPXCVD
      ZAXFLMFGXGSUAVBVCZXDXBFXANULZXEXANULZWMWQWSWTXBVEZXDWMWOWPXRXKXMXPAFGLMNR
      SUAVFVCXDXHEXFUIZFXFUIZXOXBXRVGXSVHXIXDWNYAXLAXFEMXGUAVIVJXDWOYBXMAXFFMXG
      UAVIVJZXQXFLMNEFXAXGRSVKVLVNXDFXENULZGXENULZXAXENULZXDWMWNWOYDXKXLXMAEFLM
      NRSUAVOVCXDGFELUKZXENXDXBGYGNULZXTXDMVPUIZWNWPWOEFVQZXBYHVRWMWQYIXCMWDURX
      LXPXMXDWSWTYJWMWQWSWTXBVSWMWQWSWTXBVTEFWRNWAWBAEGFLMNRSUAWCWEWFXDWMWNWOXE
      YGWGXKXLXMALMEFSUAWHVCWIXDXHYBGXFUIZXJYDYEVGYFVHXIYCXDWPYKXPAXFGMXGUAVIVJ
      XNXFLMNFGXEXGRSVKVLVNWJWKWL $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 5th paragraph on p. 114,
       1st line. ` D ` , ` F ` , ` G ` represent s_2, f(s), f(t).  In their
       notation, we prove that if r ` <_ ` s ` \/ ` t, then s_2 ` <_ ` f(s)
       ` \/ ` f(t).  (Contributed by NM, 13-Nov-2012.) $)
    cdleme19b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) /\ R e. A )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
        /\ ( R .<_ ( P .\/ Q ) /\ R .<_ ( S .\/ T ) ) ) )
             -> D .<_ ( F .\/ G ) ) $=
      ( chlt wcel wa wbr wn w3a wne wceq simp11l simp23 simp21l simp22l simp33l
      co simp32l simp33r cdleme19a syl133anc simp11 simp12 simp13 simp21 simp22
      simp31 simp32r cdleme16 syl332anc eqtrd cbs cfv hllat syl simp11r simp12l
      clat simp13l cdleme1b syl23anc latjcl syl3anc lhpbase latmle1 eqbrtrd
      eqid ) MUHUIZPKUIZUJZCAUIZCPNUKULZUJZDAUIZDPNUKULZUJZUMZFAUIZFPNUKULZUJZG
      AUIZGPNUKULZUJZEAUIZUMZCDUNFGUNUJZFCDLVAZNUKULZGXKNUKULZUJZEXKNUKZEFGLVAZ
      NUKZUJZUMZUMZBIJLVAZPOVAZYANXTBXPPOVAZYBXTWLXHXBXEXOXLXQBYCUOWLWMWQWTXIXS
      UPZXAXDXGXHXSUQXBXCXGXHXAXSURZXEXFXDXHXAXSUSZXOXQXJXNXAXIUTXLXMXJXRXAXIVB
      ZXOXQXJXNXAXIVCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGVDVEXTWNWQWTXDXGXJXLXMYC
      YBUOWNWQWTXIXSVFWNWQWTXIXSVGWNWQWTXIXSVHXAXDXGXHXSVIXAXDXGXHXSVJXAXIXJXNX
      RVKYGXLXMXJXRXAXIVLACDFGHIJKLMNOPRSTUAUBUCUDUEVMVNVOXTMWBUIZYAMVPVQZUIZPY
      IUIZYBYANUKXTWLYHYDMVRVSZXTYHIYIUIZJYIUIZYJYLXTWLWMWOWRXBYMYDWLWMWQWTXIXS
      VTZWOWPWNWTXIXSWAZWRWSWNWQXIXSWCZYEAYICDFHIKLMNOPRSTUAUBUCUDYIWKZWDWEXTWL
      WMWOWRXEYNYDYOYPYQYFAYICDGHJKLMNOPRSTUAUBUCUEYRWDWEYILMIJYRSWFWGXTWMYKYOY
      IKMPYRUBWHVSYIMNOYAPYRRTWIWGWJ $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 5th paragraph on p. 114,
       1st line. ` D ` , ` F ` represent s_2, f(s).  We prove f(s) ` =/= `
       s_2.  (Contributed by NM, 13-Nov-2012.) $)
    cdleme19c $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
      /\ ( R e. A /\ P =/= Q /\ -. S .<_ ( P .\/ Q ) ) )
             -> F =/= D ) $=
      ( chlt wcel wa wbr wn w3a wne co clat cbs cfv simp1l hllat simp31 simp23l
      syl hlatjcl syl3anc simp1r lhpbase latmle2 syl5eqbr simp32 simp33 cdleme3
      eqid jca syld3an3 nbrne2 syl2anc necomd ) MUHUIZPKUIZUJZCAUICPNUKULUJZDAU
      IDPNUKULUJZFAUIZFPNUKULZUJUMZEAUIZCDUNZFCDLUONUKULZUMZUMZBIWKBPNUKIPNUKUL
      ZBIUNWKBEFLUOZPOUOZPNUFWKMUPUIZWMMUQURZUIZPWPUIZWNPNUKWKVSWOVSVTWFWJUSZMU
      TVCWKVSWGWDWQWSWAWFWGWHWIVAWDWEWBWCWAWJVBAWPLMEFWPVMZSUAVDVEWKVTWRVSVTWFW
      JVFWPKMPWTUBVGVCWPMNOWMPWTRTVHVEVIWAWFWJWHWIUJWLWKWHWIWAWFWGWHWIVJWAWFWGW
      HWIVKVNACDFHIKLMNOPRSTUAUBUCUDVLVOBIPNVPVQVR $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 5th paragraph on p. 114.
       ` D ` , ` F ` , ` G ` represent s_2, f(s), f(t).  We prove f(s) ` \/ `
       s_2 = f(s) ` \/ ` f(t).  (Contributed by NM, 14-Nov-2012.) $)
    cdleme19d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) /\ R e. A )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
        /\ ( R .<_ ( P .\/ Q ) /\ R .<_ ( S .\/ T ) ) ) )
             -> ( F .\/ D ) = ( F .\/ G ) ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cdleme19b clc simp11l hlcvl simp11r
      syl simp21l simp21r simp23 simp33l simp32l syl223anc simp11 simp12 simp13
      wb cdlemeda simp22 simp31l cdleme3fa syl132anc simp21 cdleme19c syl233anc
      simp32r necomd cvlatexchb1 syl131anc mpbid ) MUHUIZPKUIZUJZCAUICPNUKULUJZ
      DAUIDPNUKULUJZUMZFAUIZFPNUKULZUJZGAUIGPNUKULUJZEAUIZUMZCDUNZFGUNZUJZFCDLU
      OZNUKULZGXANUKULZUJZEXANUKZEFGLUONUKZUJZUMZUMZBIJLUOZNUKZIBLUOXJUPZABCDEF
      GHIJKLMNOPQRSTUAUBUCUDUEUFUGUQXIMURUIZBAUIZJAUIZIAUIZBIUNXKXLVLXIWFXMWFWG
      WIWJWQXHUSZMUTVBXIWFWGWLWMWPXEXBXNXQWFWGWIWJWQXHVAZWLWMWOWPWKXHVCWLWMWOWP
      WKXHVDWKWNWOWPXHVEZXEXFWTXDWKWQVFXBXCWTXGWKWQVGZABCDEFKLMNOPRSTUAUBUFVMVH
      XIWHWIWJWOWRXCXOWHWIWJWQXHVIZWHWIWJWQXHVJZWHWIWJWQXHVKZWKWNWOWPXHVNWRWSXD
      XGWKWQVOZXBXCWTXGWKWQWAACDGHJKLMNOPRSTUAUBUCUEVPVQXIWHWIWJWNWRXBXPYAYBYCW
      KWNWOWPXHVRZYDXTACDFHIKLMNOPRSTUAUBUCUDVPVQXIIBXIWFWGWIWJWNWPWRXBIBUNXQXR
      YBYCYEXSYDXTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGVSVTWBABJILMNRSUAWCWDWE $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 5th paragraph on p. 114,
       line 2. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2, f(t).
       We prove f(s) ` \/ ` s_2=f(t) ` \/ ` t_2.  (Contributed by NM,
       14-Nov-2012.) $)
    cdleme19e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) /\ R e. A )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
        /\ ( R .<_ ( P .\/ Q ) /\ R .<_ ( S .\/ T ) ) ) )
             -> ( F .\/ D ) = ( G .\/ Y ) ) $=
      ( chlt wcel wa wbr wn w3a wne clat cbs cfv wceq simp11l hllat syl simp11r
      co simp12l simp13l simp21l eqid cdleme1b syl23anc simp22l latjcom syl3anc
      simp11 simp12 simp13 simp22 simp21 simp23 simp31l simp31r simp32r simp32l
      cdleme19d necomd jca simp33l simp33r hlatjcom breqtrd syl333anc 3eqtr4d )
      MUHUIZPKUIZUJZCAUIZCPNUKULZUJZDAUIZDPNUKULZUJZUMZFAUIZFPNUKULZUJZGAUIZGPN
      UKULZUJZEAUIZUMZCDUNZFGUNZUJZFCDLVCZNUKULZGXMNUKULZUJZEXMNUKZEFGLVCZNUKZU
      JZUMZUMZIJLVCZJILVCZIBLVCJQLVCZYBMUOUIZIMUPUQZUIZJYGUIZYCYDURYBWLYFWLWMWQ
      WTXIYAUSZMUTVAYBWLWMWOWRXBYHYJWLWMWQWTXIYAVBZWOWPWNWTXIYAVDZWRWSWNWQXIYAV
      EZXBXCXGXHXAYAVFZAYGCDFHIKLMNOPRSTUAUBUCUDYGVGZVHVIYBWLWMWOWRXEYIYJYKYLYM
      XEXFXDXHXAYAVJZAYGCDGHJKLMNOPRSTUAUBUCUEYOVHVIYGLMIJYOSVKVLABCDEFGHIJKLMN
      OPQRSTUAUBUCUDUEUFUGWCYBWNWQWTXGXDXHXJGFUNZUJXOXNUJXQEGFLVCZNUKZUJYEYDURW
      NWQWTXIYAVMWNWQWTXIYAVNWNWQWTXIYAVOXAXDXGXHYAVPXAXDXGXHYAVQXAXDXGXHYAVRYB
      XJYQXJXKXPXTXAXIVSYBFGXJXKXPXTXAXIVTWDWEYBXOXNXNXOXLXTXAXIWAXNXOXLXTXAXIW
      BWEYBXQYSXQXSXLXPXAXIWFYBEXRYRNXQXSXLXPXAXIWGYBWLXBXEXRYRURYJYNYPALMFGSUA
      WHVLWIWEAQCDEGFHJIKLMNOPBRSTUAUBUCUEUDUGUFWCWJWK $.

    ${
      cdleme19.n $e |- N = ( ( P .\/ Q ) ./\ ( F .\/ D ) ) $.
      cdleme19.o $e |- O = ( ( P .\/ Q ) ./\ ( G .\/ Y ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 5th paragraph on p. 114,
         line 3. ` D ` , ` F ` , ` N ` , ` Y ` , ` G ` , ` O ` represent s_2,
         f(s), f_s(r), t_2, f(t), f_t(r).  We prove that if r ` <_ ` s ` \/ `
         t, then f_t(r) = f_t(r).  (Contributed by NM, 14-Nov-2012.) $)
      cdleme19f $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) /\ R e. A )
        /\ ( ( P =/= Q /\ S =/= T )
           /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
          /\ ( R .<_ ( P .\/ Q ) /\ R .<_ ( S .\/ T ) ) ) )
               -> N = O ) $=
        ( chlt wcel wa wbr wn w3a wne co cdleme19e oveq2d 3eqtr4g ) MULUMRKUMUN
        CAUMCRNUOUPUNDAUMDRNUOUPUNUQFAUMFRNUOUPUNGAUMGRNUOUPUNEAUMUQCDURFGURUNF
        CDLUSZNUOUPGVCNUOUPUNEVCNUOEFGLUSNUOUNUQUQZVCIBLUSZOUSVCJSLUSZOUSPQVDVE
        VFVCOABCDEFGHIJKLMNORSTUAUBUCUDUEUFUGUHUIUTVAUJUKVB $.
    $}

    cdleme20.v $e |- V = ( ( S .\/ T ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114.
       ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2, f(t).
       (Contributed by NM, 14-Nov-2012.)  (New usage is discouraged.) $)
    cdleme20aN $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( R e. A /\ S e. A /\ -. S .<_ W )
          /\ ( T e. A /\ -. S .<_ ( P .\/ Q ) /\ R .<_ ( P .\/ Q ) ) )
               -> ( V .\/ D ) = ( ( ( S .\/ R ) .\/ T ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a oveq1i cbs cfv wceq simp1l simp1r simp22 simp23
      co simp21 simp33 simp32 cdlemeda syl223anc simp31 hlatjcl syl3anc lhpbase
      eqid syl clat hllat syl5eqbr atmod4i1 syl131anc cdleme10 syl212anc oveq1d
      latmle2 hlatj32 syl13anc eqtr3d eqtr4d syl5eq ) MUJUKZQKUKZULZEAUKZFAUKZF
      QNUMUNZUOZGAUKZFCDLVDZNUMUNZEWRNUMZUOZUOZPBLVDFGLVDZQOVDZBLVDZFELVDZGLVDZ
      QOVDZPXDBLUIUPXBXEXCBLVDZQOVDZXHXBWJBAUKZXCMUQURZUKZQXLUKZBQNUMXEXJUSWJWK
      WPXAUTZXBWJWKWNWOWMWTWSXKXOWJWKWPXAVAZWLWMWNWOXAVBZWLWMWNWOXAVCZWLWMWNWOX
      AVEZWLWPWQWSWTVFWLWPWQWSWTVGABCDEFKLMNOQSTUAUBUCUGVHVIZXBWJWNWQXMXOXQWLWP
      WQWSWTVJZAXLLMFGXLVNZTUBVKVLXBWKXNXPXLKMQYBUCVMVOZXBBEFLVDZQOVDZQNUGXBMVP
      UKZYDXLUKZXNYEQNUMXBWJYFXOMVQVOXBWJWMWNYGXOXSXQAXLLMEFYBTUBVKVLYCXLMNOYDQ
      YBSUAWDVLVRAXLBLMNOXCQYBSTUAUBVSVTXBXGXIQOXBFBLVDZGLVDZXGXIXBYHXFGLXBWJWK
      WMWNWOYHXFUSXOXPXSXQXRABEFKLMNOQSTUAUBUCUGWAWBWCXBWJWNXKWQYIXIUSXOXQXTYAA
      FBGLMTUBWEWFWGWCWHWI $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       second line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2,
       f(t).  We show v ` \/ ` s_2 = v ` \/ ` t_2.  (Contributed by NM,
       15-Nov-2012.)  (New usage is discouraged.) $)
    cdleme20bN $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( R e. A /\ ( S e. A /\ -. S .<_ W )
          /\ ( T e. A /\ -. T .<_ W ) )
          /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
            /\ R .<_ ( P .\/ Q ) ) )
       -> ( V .\/ D ) = ( V .\/ Y ) ) $=
      ( chlt wcel wa wbr wn w3a clat cbs cfv wceq simp1l hllat syl simp22l eqid
      atbase simp21 simp23l latj31 syl13anc oveq1d simp1r simp22r simp31 simp33
      cdleme20aN syl233anc hlatjcom syl3anc syl5eq simp23r simp32 eqtrd 3eqtr4d
      co ) MUJUKZQKUKZULZEAUKZFAUKZFQNUMUNZULZGAUKZGQNUMUNZULZUOZFCDLWDZNUMUNZG
      WPNUMUNZEWPNUMZUOZUOZFELWDGLWDZQOWDZGELWDFLWDZQOWDZPBLWDZPRLWDZXAXBXDQOXA
      MUPUKZFMUQURZUKZEXIUKZGXIUKZXBXDUSXAWEXHWEWFWOWTUTZMVAVBXAWIXJWIWJWHWNWGW
      TVCZAXIFMXIVDZUBVEVBXAWHXKWGWHWKWNWTVFZAXIEMXOUBVEVBXAWLXLWLWMWHWKWGWTVGZ
      AXIGMXOUBVEVBXILMFEGXOTVHVIVJXAWEWFWHWIWJWLWQWSXFXCUSXMWEWFWOWTVKZXPXNWIW
      JWHWNWGWTVLXQWGWOWQWRWSVMWGWOWQWRWSVNZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGU
      HUIVOVPXAXGGFLWDZQOWDZRLWDZXEXAPYARLXAPFGLWDZQOWDYAUIXAYCXTQOXAWEWIWLYCXT
      USXMXNXQALMFGTUBVQVRVJVSVJXAWEWFWHWLWMWIWRWSYBXEUSXMXRXPXQWLWMWHWKWGWTVTX
      NWGWOWQWRWSWAXSARCDEGFHJIKLMNOYAQBSTUAUBUCUDUFUEUHUGYAVDVOVPWBWC $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       second line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2,
       f(t).  (Contributed by NM, 15-Nov-2012.) $)
    cdleme20c $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
                /\ T e. A )
          /\ ( -. S .<_ ( P .\/ Q ) /\ R .<_ ( P .\/ Q ) ) )
               -> ( D .\/ Y ) = ( ( ( R .\/ S ) .\/ T ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a co cp1 cfv cbs wceq simp1l simp21l simp22l eqid
      hlatjcl syl3anc simp1r lhpbase hlatlej1 atmod2i1 syl131anc simp21 lhpjat1
      syl syl21anc oveq2d col hlol syl2anc 3eqtrrd oveq1d simp22r simp3r simp3l
      olm11 cdlemeda simp23 hlatjass syl13anc eqtrd clat hllat latmle2 atmod1i1
      syl223anc eqtr4d oveq12i syl6reqr ) MUJUKZQKUKZULZEAUKZEQNUMUNZULZFAUKZFQ
      NUMUNZULZGAUKZUOZFCDLUPZNUMUNZEXJNUMZULZUOZEFLUPZGLUPZQOUPZXOQOUPZEGLUPZQ
      OUPZLUPZBRLUPXNXQXRXSLUPZQOUPZYAXNXPYBQOXNXPXRELUPZGLUPZYBXNXOYDGLXNYDXOQ
      ELUPZOUPZXOMUQURZOUPZXOXNWSXBXOMUSURZUKZQYJUKZEXONUMZYDYGUTWSWTXIXMVAZXBX
      CXGXHXAXMVBZXNWSXBXEYKYNYOXEXFXDXHXAXMVCZAYJLMEFYJVDZTUBVEVFZXNWTYLWSWTXI
      XMVGZYJKMQYQUCVHVNZXNWSXBXEYMYNYOYPAEFLMNSTUBVIVFAYJELMNOXOQYQSTUAUBVJVKX
      NYFYHXOOXNWSWTXDYFYHUTYNYSXAXDXGXHXMVLAEYHKLMNQSTYHVDZUBUCVMVOVPXNMVQUKZY
      KYIXOUTXNWSUUBYNMVRVNYRYJYHMOXOYQUAUUAWEVSVTWAXNWSXRAUKZXBXHYEYBUTYNXNWSW
      TXEXFXBXLXKUUCYNYSYPXEXFXDXHXAXMWBYOXAXIXKXLWCXAXIXKXLWDAXRCDEFKLMNOQSTUA
      UBUCXRVDWFWOZYOXAXDXGXHXMWGZAXREGLMTUBWHWIWJWAXNWSUUCXSYJUKZYLXRQNUMZYAYC
      UTYNUUDXNWSXBXHUUFYNYOUUEAYJLMEGYQTUBVEVFYTXNMWKUKZYKYLUUGXNWSUUHYNMWLVNY
      RYTYJMNOXOQYQSUAWMVFAYJXRLMNOXSQYQSTUAUBWNVKWPBXRRXTLUGUHWQWR $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       second line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2,
       f(t).  (Contributed by NM, 17-Nov-2012.) $)
    cdleme20d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
         /\ ( R e. A /\ -. R .<_ W ) )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
         /\ R .<_ ( P .\/ Q ) ) )
               -> ( ( F .\/ G ) ./\ ( D .\/ Y ) ) = V ) $=
      ( chlt wcel wa wbr wn w3a wne co col cbs cfv wceq simp11l hlol clat hllat
      syl simp11r simp12l simp13l simp21l eqid cdleme1b syl23anc simp22l latjcl
      syl3anc lhpbase simp23l hlatjcl latmassOLD syl13anc hlatlej2 latjlej1 mpd
      atbase wi wb latleeqm1 mpbid oveq1d syl6reqr latm32 simp21 simp22 simp32l
      simp1 simp31 simp32r cdleme16 syl132anc simp23 simp33 cdleme20c syl232anc
      eqtrd latmcom oveq2d 3eqtr4rd ) MUJUKZQKUKZULZCAUKZCQNUMUNZULZDAUKZDQNUMU
      NZULZUOZFAUKZFQNUMUNZULZGAUKZGQNUMUNZULZEAUKZEQNUMUNZULZUOZCDUPFGUPULZFCD
      LUQZNUMUNZGYJNUMUNZULZEYJNUMZUOZUOZIJLUQZQOUQZEFLUQZGLUQZOUQZYQQYTOUQZOUQ
      ZPYQBRLUQZOUQYPMURUKZYQMUSUTZUKZQUUFUKZYTUUFUKZUUAUUCVAYPXIUUEXIXJXNXQYHY
      OVBZMVCVFZYPMVDUKZIUUFUKZJUUFUKZUUGYPXIUULUUJMVEVFZYPXIXJXLXOXSUUMUUJXIXJ
      XNXQYHYOVGZXLXMXKXQYHYOVHZXOXPXKXNYHYOVIZXSXTYDYGXRYOVJZAUUFCDFHIKLMNOQST
      UAUBUCUDUEUUFVKZVLVMYPXIXJXLXOYBUUNUUJUUPUUQUURYBYCYAYGXRYOVNZAUUFCDGHJKL
      MNOQSTUAUBUCUDUFUUTVLVMUUFLMIJUUTTVOVPYPXJUUHUUPUUFKMQUUTUCVQVFZYPUULYSUU
      FUKZGUUFUKZUUIUUOYPXIYEXSUVCUUJYEYFYAYDXRYOVRZUUSAUUFLMEFUUTTUBVSVPZYPYBU
      VDUVAAUUFGMUUTUBWEVFZUUFLMYSGUUTTVOVPZUUFMOYQQYTUUTUAVTWAYPPFGLUQZYTOUQZQ
      OUQZUUAYPUVKUVIQOUQZPYPUVJUVIQOYPUVIYTNUMZUVJUVIVAZYPFYSNUMZUVMYPXIYEXSUV
      OUUJUVEUUSAEFLMNSTUBWBVPYPUULFUUFUKZUVCUVDUVOUVMWFUUOYPXSUVPUUSAUUFFMUUTU
      BWEVFUVFUVGUUFLMNFYSGUUTSTWCWAWDYPUULUVIUUFUKZUUIUVMUVNWGUUOYPXIXSYBUVQUU
      JUUSUVAAUUFLMFGUUTTUBVSVPZUVHUUFMNOUVIYTUUTSUAWHVPWIWJUIWKYPUVKUVLYTOUQZU
      UAYPUUEUVQUUIUUHUVKUVSVAUUKUVRUVHUVBUUFMOUVIYTQUUTUAWLWAYPUVLYRYTOYPXRYAY
      DYIYKYLUVLYRVAXRYHYOWPXRYAYDYGYOWMZXRYAYDYGYOWNXRYHYIYMYNWQYKYLYIYNXRYHWO
      ZYKYLYIYNXRYHWRACDFGHIJKLMNOQSTUAUBUCUDUEUFWSWTWJXEXEYPUUDUUBYQOYPUUDYTQO
      UQZUUBYPXIXJYGYAYBYKYNUUDUWBVAUUJUUPXRYAYDYGYOXAUVTUVAUWAXRYHYIYMYNXBABCD
      EFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIXCXDYPUULUUIUUHUWBUUBVAUUOUVHUVBUUFMOYT
      QUUTUAXFVPXEXGXH $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       4th line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2, f(t).
       We show <f(s),s_2,s> and <f(t),t_2,t> are centrally perspective.
       (Contributed by NM, 17-Nov-2012.) $)
    cdleme20e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
         /\ ( R e. A /\ -. R .<_ W ) )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
         /\ R .<_ ( P .\/ Q ) ) )
               -> ( ( F .\/ G ) ./\ ( D .\/ Y ) ) .<_ ( S .\/ T ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cdleme20d clat cbs cfv simp11l hllat syl
      simp21l simp22l hlatjcl syl3anc simp11r lhpbase latmle1 syl5eqbr eqbrtrd
      eqid ) MUJUKZQKUKZULCAUKCQNUMUNULZDAUKDQNUMUNULZUOZFAUKZFQNUMUNZULZGAUKZG
      QNUMUNZULZEAUKEQNUMUNULZUOZCDUPFGUPULFCDLUQZNUMUNGWHNUMUNULEWHNUMUOZUOZIJ
      LUQBRLUQOUQPFGLUQZNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIURWJPWKQOUQZWKNU
      IWJMUSUKZWKMUTVAZUKZQWNUKZWLWKNUMWJVOWMVOVPVQVRWGWIVBZMVCVDWJVOVTWCWOWQVT
      WAWEWFVSWIVEWCWDWBWFVSWIVFAWNLMFGWNVNZTUBVGVHWJVPWPVOVPVQVRWGWIVIWNKMQWRU
      CVJVDWNMNOWKQWRSUAVKVHVLVM $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       4th line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2, f(t).
       We show <f(s),s_2,s> and <f(t),t_2,t> are axially perspective.
       (Contributed by NM, 17-Nov-2012.) $)
    cdleme20f $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
         /\ ( R e. A /\ -. R .<_ W ) )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
         /\ R .<_ ( P .\/ Q ) ) )
               -> ( ( F .\/ D ) ./\ ( G .\/ Y ) )
          .<_ ( ( ( D .\/ S ) ./\ ( Y .\/ T ) )
               .\/ ( ( S .\/ F ) ./\ ( T .\/ G ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cdleme20e wi simp11 simp12 simp13 simp21
      simp11l simp31l simp32l cdleme3fa simp11r simp21l simp21r simp33 cdlemeda
      syl132anc simp23l syl223anc simp22 simp32r simp22l simp22r syl133anc mpd
      dalaw ) MUJUKZQKUKZULZCAUKCQNUMUNULZDAUKDQNUMUNULZUOZFAUKZFQNUMUNZULZGAUK
      ZGQNUMUNZULZEAUKZEQNUMUNZULZUOZCDUPZFGUPZULZFCDLUQZNUMUNZGXBNUMUNZULZEXBN
      UMZUOZUOZIJLUQBRLUQOUQFGLUQNUMZIBLUQJRLUQOUQBFLUQRGLUQOUQFILUQGJLUQOUQLUQ
      NUMZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIURXHWCIAUKZBAUKZWIJAUKZRAUKZWLX
      IXJUSWCWDWFWGWRXGVDZXHWEWFWGWKWSXCXKWEWFWGWRXGUTZWEWFWGWRXGVAZWEWFWGWRXGV
      BZWHWKWNWQXGVCWSWTXEXFWHWRVEZXCXDXAXFWHWRVFZACDFHIKLMNOQSTUAUBUCUDUEVGVMX
      HWCWDWIWJWOXFXCXLXOWCWDWFWGWRXGVHZWIWJWNWQWHXGVIZWIWJWNWQWHXGVJWOWPWKWNWH
      XGVNZWHWRXAXEXFVKZXTABCDEFKLMNOQSTUAUBUCUGVLVOYBXHWEWFWGWNWSXDXMXPXQXRWHW
      KWNWQXGVPXSXCXDXAXFWHWRVQZACDGHJKLMNOQSTUAUBUCUDUFVGVMXHWCWDWLWMWOXFXDXNX
      OYAWLWMWKWQWHXGVRZWLWMWKWQWHXGVSYCYDYEARCDEGKLMNOQSTUAUBUCUHVLVOYFAIBFJRG
      LMNOSTUAUBWBVTWA $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       antepenultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t).  (Contributed by NM, 18-Nov-2012.) $)
    cdleme20g $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
         /\ ( R e. A /\ -. R .<_ W ) )
      /\ ( ( P =/= Q /\ S =/= T )
         /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) )
         /\ R .<_ ( P .\/ Q ) ) )
               -> ( ( ( D .\/ S ) ./\ ( Y .\/ T ) )
                  .\/ ( ( S .\/ F ) ./\ ( T .\/ G ) ) )
          = ( ( ( S .\/ R ) ./\ ( T .\/ R ) )
                  .\/ ( ( S .\/ U ) ./\ ( T .\/ U ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq simp11l simp11r simp21l simp21r simp23l
      wne simp33 simp32l cdlemeda syl223anc hlatjcom syl3anc cdleme10 syl212anc
      simp22l simp22r simp32r oveq12d simp12l simp13l simp21 cdleme1 syl23anc
      eqtrd simp22 ) MUJUKZQKUKZULZCAUKZCQNUMUNZULZDAUKZDQNUMUNZULZUOZFAUKZFQNU
      MUNZULZGAUKZGQNUMUNZULZEAUKZEQNUMUNZULZUOZCDVCFGVCULZFCDLUPZNUMUNZGXDNUMU
      NZULZEXDNUMZUOZUOZBFLUPZRGLUPZOUPFELUPZGELUPZOUPFILUPZGJLUPZOUPFHLUPZGHLU
      PZOUPLXJXKXMXLXNOXJXKFBLUPZXMXJWCBAUKZWMXKXSUQWCWDWHWKXBXIURZXJWCWDWMWNWS
      XHXEXTYAWCWDWHWKXBXIUSZWMWNWRXAWLXIUTZWMWNWRXAWLXIVAZWSWTWOWRWLXIVBZWLXBX
      CXGXHVDZXEXFXCXHWLXBVEABCDEFKLMNOQSTUAUBUCUGVFVGYCALMBFTUBVHVIXJWCWDWSWMW
      NXSXMUQYAYBYEYCYDABEFKLMNOQSTUAUBUCUGVJVKWAXJXLGRLUPZXNXJWCRAUKZWPXLYGUQY
      AXJWCWDWPWQWSXHXFYHYAYBWPWQWOXAWLXIVLZWPWQWOXAWLXIVMZYEYFXEXFXCXHWLXBVNAR
      CDEGKLMNOQSTUAUBUCUHVFVGYIALMRGTUBVHVIXJWCWDWSWPWQYGXNUQYAYBYEYIYJAREGKLM
      NOQSTUAUBUCUHVJVKWAVOXJXOXQXPXROXJWCWDWFWIWOXOXQUQYAYBWFWGWEWKXBXIVPZWIWJ
      WEWHXBXIVQZWLWOWRXAXIVRACDFHIKLMNOQSTUAUBUCUDUEVSVTXJWCWDWFWIWRXPXRUQYAYB
      YKYLWLWOWRXAXIWBACDGHJKLMNOQSTUAUBUCUDUFVSVTVOVO $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       antepenultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t).  (Contributed by NM, 18-Nov-2012.) $)
    cdleme20h $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
           /\ ( T e. A /\ -. T .<_ W ) )
        /\ ( ( P =/= Q /\ S =/= T )
           /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
              /\ R .<_ ( P .\/ Q ) )
           /\ ( -. R .<_ ( S .\/ T ) /\ -. U .<_ ( S .\/ T ) ) ) )
     -> ( ( ( S .\/ R ) ./\ ( T .\/ R ) )
         .\/ ( ( S .\/ U ) ./\ ( T .\/ U ) ) ) = ( R .\/ U ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq simp11l simp21l simp22l simp23l simp31r
      wne simp33l cdleme20y syl132anc simp11r simp12l simp12r simp13l syl222anc
      simp31l lhpat2 simp33r oveq12d ) MUJUKZQKUKZULZCAUKZCQNUMUNZULZDAUKZDQNUM
      UNZULZUOZEAUKZEQNUMUNZULZFAUKZFQNUMUNZULZGAUKZGQNUMUNZULZUOZCDVCZFGVCZULZ
      FCDLUPZNUMUNGWSNUMUNEWSNUMUOZEFGLUPZNUMUNZHXANUMUNZULZUOZUOZFELUPGELUPOUP
      ZEFHLUPGHLUPOUPZHLXFVPWFWIWLWQXBXGEUQVPVQWAWDWOXEURZWFWGWKWNWEXEUSWIWJWHW
      NWEXEUTZWLWMWHWKWEXEVAZWPWQWTXDWEWOVBZXBXCWRWTWEWOVDAEFGLMNOSTUAUBVEVFXFV
      PHAUKZWIWLWQXCXHHUQXIXFVPVQVSVTWBWPXMXIVPVQWAWDWOXEVGVSVTVRWDWOXEVHVSVTVR
      WDWOXEVIWBWCVRWAWOXEVJWPWQWTXDWEWOVLACDHKLMNOQSTUAUBUCUDVMVKXJXKXLXBXCWRW
      TWEWOVNAHFGLMNOSTUAUBVEVFVO $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       antepenultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t).  We show (f(s) ` \/ ` s_2) ` /\ ` (f(t) ` \/ ` t_2) ` <_ ` p
       ` \/ ` q.  (Contributed by NM, 18-Nov-2012.) $)
    cdleme20i $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
           /\ ( T e. A /\ -. T .<_ W ) )
        /\ ( ( P =/= Q /\ S =/= T )
           /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
             /\ R .<_ ( P .\/ Q ) )
           /\ ( -. R .<_ ( S .\/ T ) /\ -. U .<_ ( S .\/ T ) ) ) )
               -> ( ( F .\/ D ) ./\ ( G .\/ Y ) ) .<_ ( P .\/ Q ) ) $=
      ( chlt wcel wa wbr wn w3a wne simp22 simp23 simp21 simp31 simp321 simp322
      co simp1 simp323 3jca cdleme20f syl131anc cdleme20h wceq cdleme20g simp11
      jca simp12l simp13l cdleme4 3eqtr4d breqtrd ) MUJUKQKUKULZCAUKZCQNUMUNZUL
      ZDAUKZDQNUMUNZULZUOZEAUKEQNUMUNULZFAUKFQNUMUNULZGAUKGQNUMUNULZUOZCDUPFGUP
      ULZFCDLVCZNUMUNZGWLNUMUNZEWLNUMZUOZEFGLVCZNUMUNHWQNUMUNULZUOZUOZIBLVCJRLV
      COVCZBFLVCRGLVCOVCFILVCGJLVCOVCLVCZWLNWTWFWHWIWGWKWMWNULZWOUOZXAXBNUMWFWJ
      WSVDZWFWGWHWIWSUQZWFWGWHWIWSURZWFWGWHWIWSUSZWTWKXCWOWFWJWKWPWRUTWTWMWNWMW
      NWOWKWRWFWJVAWMWNWOWKWRWFWJVBVMWMWNWOWKWRWFWJVEZVFZABCDEFGHIJKLMNOPQRSTUA
      UBUCUDUEUFUGUHUIVGVHWTFELVCGELVCOVCFHLVCGHLVCOVCLVCZEHLVCZXBWLABCDEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIVIWTWFWHWIWGXDXBXKVJXEXFXGXHXJABCDEFGHIJKLMNOP
      QRSTUAUBUCUDUEUFUGUHUIVKVHWTVSVTWCWGWOWLXLVJVSWBWEWJWSVLVTWAVSWEWJWSVNWCW
      DVSWBWJWSVOXHXIACDEHKLMNOQSTUAUBUCUDVPVHVQVR $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114.
       ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s), t_2, f(t).  We show
       s_2 ` =/= ` t_2.  (Contributed by NM, 18-Nov-2012.) $)
    cdleme20j $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
       /\ ( T e. A /\ -. T .<_ W ) )
    /\ ( ( P =/= Q /\ S =/= T )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
        /\ R .<_ ( P .\/ Q ) )
       /\ -. R .<_ ( S .\/ T ) ) )
           -> D =/= Y ) $=
      ( chlt wcel wa wbr wn w3a wne simp33 wceq cp1 cfv simp11l simp22l simp21l
      co cbs eqid hlatjcl syl3anc simp11r lhpbase syl hlatlej2 syl131anc simp22
      atmod2i1 lhpjat1 syl21anc oveq2d olm11 syl2anc 3eqtrd adantr simp1 simp23
      col hlol simp21 simp31 simp321 simp322 jca cdleme20d syl133anc clat hllat
      simp323 simp12l simp13l cdleme1b syl23anc simp23l latjcl simp22r cdlemeda
      syl223anc simp23r eqbrtrrd hlatjidm oveq2 sylan9req breqtrrd wb cal hlatl
      latmle2 simp31r syl222anc atcmp syl5reqr syl5eqr latmle1 eqbrtrd hlatlej1
      lhpat2 latmcl atbase latjle12 syl13anc mpbi2and mpbird simpld ex necon3bd
      mpbid mpd ) MUJUKZQKUKZULZCAUKZCQNUMUNZULZDAUKZDQNUMUNZULZUOZEAUKZEQNUMUN
      ZULZFAUKZFQNUMUNZULZGAUKZGQNUMUNZULZUOZCDUPZFGUPZULZFCDLVDZNUMUNZGUUSNUMU
      NZEUUSNUMZUOZEFGLVDZNUMZUNZUOZUOZUVFBRUPUUEUUOUURUVCUVFUQUVHUVEBRUVHBRURZ
      UVEUVHUVIULZUVEFUVDNUMZUVJUVEUVKULZEFLVDZUVDNUMZUVJUVMQOVDZFLVDZUVMUVDNUV
      HUVPUVMURUVIUVHUVPUVMQFLVDZOVDZUVMMUSUTZOVDZUVMUVHYPUUIUVMMVEUTZUKZQUWAUK
      ZFUVMNUMZUVPUVRURYPYQUUAUUDUUOUVGVAZUUIUUJUUHUUNUUEUVGVBZUVHYPUUFUUIUWBUW
      EUUFUUGUUKUUNUUEUVGVCZUWFAUWALMEFUWAVFZTUBVGVHZUVHYQUWCYPYQUUAUUDUUOUVGVI
      ZUWAKMQUWHUCVJVKZUVHYPUUFUUIUWDUWEUWGUWFAEFLMNSTUBVLVHAUWAFLMNOUVMQUWHSTU
      AUBVOVMUVHUVQUVSUVMOUVHYPYQUUKUVQUVSURUWEUWJUUEUUHUUKUUNUVGVNZAFUVSKLMNQS
      TUVSVFZUBUCVPVQVRUVHMWEUKZUWBUVTUVMURUVHYPUWNUWEMWFVKUWIUWAUVSMOUVMUWHUAU
      WMVSVTWAWBUVJUVOUVDNUMZUVKUVPUVDNUMZUVJUVOUVDQOVDZUVDNUVJUVOBUWQUGUVJUWQP
      BUIUVJPBNUMZPBURZUVJPBRLVDZBNUVHPUWTNUMUVIUVHIJLVDZUWTOVDZPUWTNUVHUUEUUKU
      UNUUHUURUUTUVAULUVBUXBPURUUEUUOUVGWCUWLUUEUUHUUKUUNUVGWDUUEUUHUUKUUNUVGWG
      UUEUUOUURUVCUVFWHUVHUUTUVAUUTUVAUVBUURUVFUUEUUOWIZUUTUVAUVBUURUVFUUEUUOWJ
      ZWKUUTUVAUVBUURUVFUUEUUOWPZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIWLWMUVHM
      WNUKZUXAUWAUKZUWTUWAUKZUXBUWTNUMUVHYPUXFUWEMWOVKZUVHUXFIUWAUKZJUWAUKZUXGU
      XIUVHYPYQYSUUBUUIUXJUWEUWJYSYTYRUUDUUOUVGWQZUUBUUCYRUUAUUOUVGWRZUWFAUWACD
      FHIKLMNOQSTUAUBUCUDUEUWHWSWTUVHYPYQYSUUBUULUXKUWEUWJUXLUXMUULUUMUUHUUKUUE
      UVGXAZAUWACDGHJKLMNOQSTUAUBUCUDUFUWHWSWTUWALMIJUWHTXBVHUVHYPBAUKZRAUKZUXH
      UWEUVHYPYQUUIUUJUUFUVBUUTUXOUWEUWJUWFUUIUUJUUHUUNUUEUVGXCZUWGUXEUXCABCDEF
      KLMNOQSTUAUBUCUGXDXEZUVHYPYQUULUUMUUFUVBUVAUXPUWEUWJUXNUULUUMUUHUUKUUEUVG
      XFUWGUXEUXDARCDEGKLMNOQSTUAUBUCUHXDXEAUWALMBRUWHTUBVGVHUWAMNOUXAUWTUWHSUA
      XOVHXGWBUVHUVIBBBLVDZUWTUVHYPUXOUXSBURUWEUXRALMBTUBXHVTBRBLXIXJXKUVHUWRUW
      SXLZUVIUVHMXMUKZPAUKZUXOUXTUVHYPUYAUWEMXNVKUVHYPYQUUIUUJUULUUQUYBUWEUWJUW
      FUXQUXNUUPUUQUVCUVFUUEUUOXPAFGPKLMNOQSTUAUBUCUIYDXQUXRAPBMNSUBXRVHWBYNXSX
      TUVHUWQUVDNUMZUVIUVHUXFUVDUWAUKZUWCUYCUXIUVHYPUUIUULUYDUWEUWFUXNAUWALMFGU
      WHTUBVGVHZUWKUWAMNOUVDQUWHSUAYAVHWBYBUVHUVKUVIUVHYPUUIUULUVKUWEUWFUXNAFGL
      MNSTUBYCVHWBUVHUWOUVKULUWPXLZUVIUVHUXFUVOUWAUKZFUWAUKZUYDUYFUXIUVHUXFUWBU
      WCUYGUXIUWIUWKUWAMOUVMQUWHUAYEVHUVHUUIUYHUWFAUWAFMUWHUBYFVKZUYEUWALMNUVOF
      UVDUWHSTYGYHWBYIXGUVHUVLUVNXLZUVIUVHUXFEUWAUKZUYHUYDUYJUXIUVHUUFUYKUWGAUW
      AEMUWHUBYFVKUYIUYEUWALMNEFUVDUWHSTYGYHWBYJYKYLYMYO $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       antepenultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t).  (Contributed by NM, 20-Nov-2012.) $)
    cdleme20k $p |- ( ( ( ( K e. HL /\ W e. H ) /\ P e. A
         /\ Q e. A )
      /\ ( ( S e. A /\ -. S .<_ W )
         /\ ( R e. A /\ -. R .<_ W ) )
      /\ ( -. S .<_ ( P .\/ Q )
         /\ R .<_ ( P .\/ Q ) ) )
              -> ( F .\/ D ) =/= ( P .\/ Q ) ) $=
      ( chlt wcel wa w3a wn co simp11 simp12 simp13 simp2r simp2l simp3r simp3l
      wbr wne cdlemednpq syl133anc wceq clat cbs cfv simp11l hllat simp11r eqid
      simp2ll cdleme1b syl23anc simp2rl cdlemedb syl22anc latlej2 syl3anc breq2
      syl syl5ibcom necon3bd mpd ) MUJUKZQKUKZULZCAUKZDAUKZUMZFAUKZFQNVCUNZULZE
      AUKZEQNVCUNZULZULZFCDLUOZNVCUNZEXANVCZULZUMZBXANVCZUNZIBLUOZXAVDXEWJWKWLW
      SWPXCXBXGWJWKWLWTXDUPWJWKWLWTXDUQZWJWKWLWTXDURZWMWPWSXDUSWMWPWSXDUTWMWTXB
      XCVAWMWTXBXCVBABCDEFKLMNOQSTUAUBUCUGVEVFXEXFXHXAXEBXHNVCZXHXAVGXFXEMVHUKZ
      IMVIVJZUKZBXMUKZXKXEWHXLWHWIWKWLWTXDVKZMVLWDXEWHWIWKWLWNXNXPWHWIWKWLWTXDV
      MZXIXJWNWOWSWMXDVOZAXMCDFHIKLMNOQSTUAUBUCUDUEXMVNZVPVQXEWHWIWQWNXOXPXQWQW
      RWPWMXDVRXRAXMBEFKLMNOQSTUAUBUCUGXSVSVTXMLMNIBXSSTWAWBXHXABNWCWEWFWG $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       penultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t) respectively.  (Contributed by NM, 20-Nov-2012.) $)
    cdleme20l1 $p |- ( ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( R e. A /\ S e. A /\ -. S .<_ W )
      /\ ( P =/= Q
         /\ -. S .<_ ( P .\/ Q ) /\ R .<_ ( P .\/ Q ) ) )
           -> ( F .\/ D ) e. ( LLines ` K ) ) $=
      ( chlt wcel wa wbr wn w3a wne co clln simp11l simp11 simp12 simp13 simp22
      cfv simp23 jca simp31 simp32 cdleme3fa syl132anc simp11r simp21 syl223anc
      simp33 cdlemeda cdleme19c syl233anc eqid llni2 syl31anc ) MUJUKZQKUKZULZC
      AUKCQNUMUNULZDAUKDQNUMUNULZUOZEAUKZFAUKZFQNUMUNZUOZCDUPZFCDLUQZNUMUNZEWLN
      UMZUOZUOZWAIAUKZBAUKZIBUPZIBLUQMURVDZUKWAWBWDWEWJWOUSZWPWCWDWEWHWIULZWKWM
      WQWCWDWEWJWOUTWCWDWEWJWOVAZWCWDWEWJWOVBZWPWHWIWFWGWHWIWOVCZWFWGWHWIWOVEZV
      FZWFWJWKWMWNVGZWFWJWKWMWNVHZACDFHIKLMNOQSTUAUBUCUDUEVIVJWPWAWBWHWIWGWNWMW
      RXAWAWBWDWEWJWOVKZXEXFWFWGWHWIWOVLZWFWJWKWMWNVNXIABCDEFKLMNOQSTUAUBUCUGVO
      VMWPWAWBWDWEXBWGWKWMWSXAXJXCXDXGXKXHXIABCDEFFHIIKLMNOQBSTUAUBUCUDUEUEUGUG
      VPVQAIBLMWTTUBWTVRVSVT $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       penultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t) respectively.  (Contributed by NM, 20-Nov-2012.) $)
    cdleme20l2 $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
       /\ ( T e. A /\ -. T .<_ W ) )
    /\ ( ( P =/= Q /\ S =/= T )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
       /\ R .<_ ( P .\/ Q ) )
       /\ ( -. R .<_ ( S .\/ T ) /\ -. U .<_ ( S .\/ T ) ) ) )
         -> ( ( F .\/ D ) ./\ ( G .\/ Y ) ) e. A ) $=
      ( chlt wcel wa wbr wn w3a wne co clpl cfv clat cbs wceq simp11l hllat syl
      simp11r simp12l simp13l simp22l cdleme1b syl23anc cdlemedb syl22anc latj4
      eqid simp21l simp23l syl122anc simp1 simp22 simp23 simp21 simp321 simp322
      simp31 simp323 cdleme20d syl133anc simp22r simp31r syl222anc eqeltrd clln
      jca lhpat2 wb simp11 simp12 simp31l cdleme3fa syl132anc simp33r cdleme16b
      simp13 llni2 syl31anc cdlemeda syl223anc simp23r simp32 simp33l cdleme20j
      syl333anc 2llnmj syl3anc mpbid cdleme20l1 mpbird ) MUJUKZQKUKZULZCAUKZCQN
      UMUNZULZDAUKZDQNUMUNZULZUOZEAUKZEQNUMUNZULZFAUKZFQNUMUNZULZGAUKZGQNUMUNZU
      LZUOZCDUPZFGUPZULZFCDLUQZNUMUNZGUUBNUMUNZEUUBNUMZUOZEFGLUQZNUMUNZHUUGNUMU
      NZULZUOZUOZIBLUQZJRLUQZOUQAUKZUUMUUNLUQZMURUSZUKZUULUUPIJLUQZBRLUQZLUQZUU
      QUULMUTUKZIMVAUSZUKZBUVCUKZJUVCUKZRUVCUKZUUPUVAVBUULXSUVBXSXTYDYGYRUUKVCZ
      MVDVEUULXSXTYBYEYLUVDUVHXSXTYDYGYRUUKVFZYBYCYAYGYRUUKVGZYEYFYAYDYRUUKVHZY
      LYMYKYQYHUUKVIZAUVCCDFHIKLMNOQSTUAUBUCUDUEUVCVOZVJVKUULXSXTYIYLUVEUVHUVIY
      IYJYNYQYHUUKVPZUVLAUVCBEFKLMNOQSTUAUBUCUGUVMVLVMUULXSXTYBYEYOUVFUVHUVIUVJ
      UVKYOYPYKYNYHUUKVQZAUVCCDGHJKLMNOQSTUAUBUCUDUFUVMVJVKUULXSXTYIYOUVGUVHUVI
      UVNUVOAUVCREGKLMNOQSTUAUBUCUHUVMVLVMUVCLMRIBJUVMTVNVRUULUUSUUTOUQZAUKZUVA
      UUQUKZUULUVPPAUULYHYNYQYKUUAUUCUUDULUUEUVPPVBYHYRUUKVSZYHYKYNYQUUKVTZYHYK
      YNYQUUKWAZYHYKYNYQUUKWBZYHYRUUAUUFUUJWEZUULUUCUUDUUCUUDUUEUUAUUJYHYRWCZUU
      CUUDUUEUUAUUJYHYRWDZWNUUCUUDUUEUUAUUJYHYRWFZABCDEFGHIJKLMNOPQRSTUAUBUCUDU
      EUFUGUHUIWGWHUULXSXTYLYMYOYTPAUKUVHUVIUVLYLYMYKYQYHUUKWIZUVOYSYTUUFUUJYHY
      RWJAFGPKLMNOQSTUAUBUCUIWOWKWLUULXSUUSMWMUSZUKZUUTUWHUKZUVQUVRWPUVHUULXSIA
      UKZJAUKZIJUPZUWIUVHUULYAYDYGYNYSUUCUWKYAYDYGYRUUKWQZYAYDYGYRUUKWRZYAYDYGY
      RUUKXDZUVTYSYTUUFUUJYHYRWSZUWDACDFHIKLMNOQSTUAUBUCUDUEWTXAUULYAYDYGYQYSUU
      DUWLUWNUWOUWPUWAUWQUWEACDGHJKLMNOQSTUAUBUCUDUFWTXAUULYHYNYQUUAUUCUUDUUIUW
      MUVSUVTUWAUWCUWDUWEUUHUUIUUAUUFYHYRXBACDFGHIJKLMNOQSTUAUBUCUDUEUFXCWHAIJL
      MUWHTUBUWHVOZXEXFUULXSBAUKZRAUKZBRUPZUWJUVHUULXSXTYLYMYIUUEUUCUWSUVHUVIUV
      LUWGUVNUWFUWDABCDEFKLMNOQSTUAUBUCUGXGXHUULXSXTYOYPYIUUEUUDUWTUVHUVIUVOYOY
      PYKYNYHUUKXIZUVNUWFUWEARCDEGKLMNOQSTUAUBUCUHXGXHUULYAYDYGYKYNYQUUAUUFUUHU
      XAUWNUWOUWPUWBUVTUWAUWCYHYRUUAUUFUUJXJUUHUUIUUAUUFYHYRXKABCDEFGHIJKLMNOPQ
      RSTUAUBUCUDUEUFUGUHUIXLXMABRLMUWHTUBUWRXEXFAUUQLMOUWHUUSUUTTUAUBUWRUUQVOZ
      XNXOXPWLUULXSUUMUWHUKZUUNUWHUKZUUOUURWPUVHUULYAYDYGYIYLYMYSUUCUUEUXDUWNUW
      OUWPUVNUVLUWGUWQUWDUWFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIXQXMUULYAYDYG
      YIYOYPYSUUDUUEUXEUWNUWOUWPUVNUVOUXBUWQUWEUWFARCDEGFHJIKLMNOGFLUQQOUQZQBST
      UAUBUCUDUFUEUHUGUXFVOXQXMAUUQLMOUWHUUMUUNTUAUBUWRUXCXNXOXR $.

    $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on p. 114,
       penultimate line. ` D ` , ` F ` , ` Y ` , ` G ` represent s_2, f(s),
       t_2, f(t) respectively.  (Contributed by NM, 20-Nov-2012.) $)
    cdleme20l $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
       /\ ( T e. A /\ -. T .<_ W ) )
    /\ ( ( P =/= Q /\ S =/= T )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
        /\ R .<_ ( P .\/ Q ) )
       /\ ( -. R .<_ ( S .\/ T ) /\ -. U .<_ ( S .\/ T ) ) ) )
   -> ( ( F .\/ D ) ./\ ( G .\/ Y ) )
         = ( ( P .\/ Q ) ./\ ( F .\/ D ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cdleme20i clln cfv wb simp11 simp12
      simp11l simp13 simp21l simp22l simp22r simp31l simp321 simp323 cdleme20l1
      syl333anc simp23l simp23r simp322 simp12l simp13l llni2 cdleme20l2 simp22
      eqid syl31anc simp21 cdleme20k syl322anc llnexchb2 syl132anc clat cbs syl
      mpbid hlatjcl syl3anc simp11r cdleme1b syl23anc cdlemedb syl22anc latmcom
      hllat latjcl eqtr4d ) MUJUKZQKUKZULZCAUKZCQNUMUNZULZDAUKZDQNUMUNZULZUOZEA
      UKZEQNUMUNZULZFAUKZFQNUMUNZULZGAUKZGQNUMUNZULZUOZCDUPZFGUPZULZFCDLUQZNUMU
      NZGYHNUMUNZEYHNUMZUOZEFGLUQZNUMUNHYMNUMUNULZUOZUOZIBLUQZJRLUQZOUQZYQYHOUQ
      ZYHYQOUQZYPYSYHNUMZYSYTURZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUSYPXEYQM
      UTVAZUKZYRUUDUKZYHUUDUKZYSAUKYQYHUPZUUBUUCVBXEXFXJXMYDYOVEZYPXGXJXMXOXRXS
      YEYIYKUUEXGXJXMYDYOVCZXGXJXMYDYOVDZXGXJXMYDYOVFZXOXPXTYCXNYOVGZXRXSXQYCXN
      YOVHZXRXSXQYCXNYOVIYEYFYLYNXNYDVJZYIYJYKYGYNXNYDVKZYIYJYKYGYNXNYDVLZABCDE
      FGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIVMVNYPXGXJXMXOYAYBYEYJYKUUFUUJUUKUULUUMY
      AYBXQXTXNYOVOYAYBXQXTXNYOVPUUOYIYJYKYGYNXNYDVQUUQARCDEGFHJIKLMNOGFLUQQOUQ
      ZQBSTUAUBUCUDUFUEUHUGUURWCVMVNYPXEXHXKYEUUGUUIXHXIXGXMYDYOVRZXKXLXGXJYDYO
      VSZUUOACDLMUUDTUBUUDWCZVTWDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIWAYPXGXH
      XKXTXQYIYKUUHUUJUUSUUTXNXQXTYCYOWBXNXQXTYCYOWEUUPUUQABCDEFGHIJKLMNOPQRSTU
      AUBUCUDUEUFUGUHUIWFWGALMNOUUDYQYRYHSTUAUBUVAWHWIWMYPMWJUKZYHMWKVAZUKZYQUV
      CUKZUUAYTURYPXEUVBUUIMXBWLZYPXEXHXKUVDUUIUUSUUTAUVCLMCDUVCWCZTUBWNWOYPUVB
      IUVCUKZBUVCUKZUVEUVFYPXEXFXHXKXRUVHUUIXEXFXJXMYDYOWPZUUSUUTUUNAUVCCDFHIKL
      MNOQSTUAUBUCUDUEUVGWQWRYPXEXFXOXRUVIUUIUVJUUMUUNAUVCBEFKLMNOQSTUAUBUCUGUV
      GWSWTUVCLMIBUVGTXCWOUVCMOYHYQUVGUAXAWOXD $.

    ${
      cdleme20.n $e |- N = ( ( P .\/ Q ) ./\ ( F .\/ D ) ) $.
      cdleme20.o $e |- O = ( ( P .\/ Q ) ./\ ( G .\/ Y ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on
         p. 114, penultimate line. ` D ` , ` F ` , ` N ` , ` Y ` , ` G ` ,
         ` O ` represent s_2, f(s), f_s(r), t_2, f(t), f_t(r) respectively.  We
         prove that if ` -. ` r ` <_ ` s ` \/ ` t and ` -. ` u ` <_ ` s ` \/ `
         t, then f_s(r) = f_t(r).  (Contributed by NM, 20-Nov-2012.) $)
      cdleme20m $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
       /\ ( T e. A /\ -. T .<_ W ) )
    /\ ( ( P =/= Q /\ S =/= T )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
        /\ R .<_ ( P .\/ Q ) )
       /\ ( -. R .<_ ( S .\/ T ) /\ -. U .<_ ( S .\/ T ) ) ) )
           -> N = O ) $=
        ( chlt wcel wa wbr wn w3a wne co clat cbs cfv simp11l hllat syl simp11r
        wceq simp12l simp13l simp22l cdleme1b syl23anc cdlemedb syl22anc latjcl
        eqid simp21l syl3anc simp23l latmcom simp11 simp12 simp13 simp21 simp23
        cdleme20l simp22 simp31l simp31r necomd simp322 simp321 simp323 simp33l
        jca 3jca hlatjcom breq2d mtbid simp33r syl333anc 3eqtr3d 3eqtr4g ) MUNU
        OZSKUOZUPZCAUOZCSNUQURZUPZDAUOZDSNUQURZUPZUSZEAUOZESNUQURZUPZFAUOZFSNUQ
        URZUPZGAUOZGSNUQURZUPZUSZCDUTZFGUTZUPZFCDLVAZNUQURZGYINUQURZEYINUQZUSZE
        FGLVAZNUQZURZHYNNUQZURZUPZUSZUSZYIIBLVAZOVAZYIJTLVAZOVAZPQUUAUUBUUDOVAZ
        UUDUUBOVAZUUCUUEUUAMVBUOZUUBMVCVDZUOZUUDUUIUOZUUFUUGVIUUAXFUUHXFXGXKXNY
        EYTVEZMVFVGZUUAUUHIUUIUOZBUUIUOZUUJUUMUUAXFXGXIXLXSUUNUULXFXGXKXNYEYTVH
        ZXIXJXHXNYEYTVJZXLXMXHXKYEYTVKZXSXTXRYDXOYTVLZAUUICDFHIKLMNOSUAUBUCUDUE
        UFUGUUIVRZVMVNUUAXFXGXPXSUUOUULUUPXPXQYAYDXOYTVSZUUSAUUIBEFKLMNOSUAUBUC
        UDUEUIUUTVOVPUUILMIBUUTUBVQVTUUAUUHJUUIUOZTUUIUOZUUKUUMUUAXFXGXIXLYBUVB
        UULUUPUUQUURYBYCXRYAXOYTWAZAUUICDGHJKLMNOSUAUBUCUDUEUFUHUUTVMVNUUAXFXGX
        PYBUVCUULUUPUVAUVDAUUITEGKLMNOSUAUBUCUDUEUJUUTVOVPUUILMJTUUTUBVQVTUUIMO
        UUBUUDUUTUCWBVTABCDEFGHIJKLMNORSTUAUBUCUDUEUFUGUHUIUJUKWHUUAXHXKXNXRYDY
        AYFGFUTZUPYKYJYLUSEGFLVAZNUQZURZHUVFNUQZURZUPUUGUUEVIXHXKXNYEYTWCXHXKXN
        YEYTWDXHXKXNYEYTWEXOXRYAYDYTWFXOXRYAYDYTWGXOXRYAYDYTWIUUAYFUVEYFYGYMYSX
        OYEWJUUAFGYFYGYMYSXOYEWKWLWQUUAYKYJYLYJYKYLYHYSXOYEWMYJYKYLYHYSXOYEWNYJ
        YKYLYHYSXOYEWOWRUUAUVHUVJUUAYOUVGYPYRYHYMXOYEWPUUAYNUVFENUUAXFXSYBYNUVF
        VIUULUUSUVDALMFGUBUDWSVTZWTXAUUAYQUVIYPYRYHYMXOYEXBUUAYNUVFHNUVKWTXAWQA
        TCDEGFHJIKLMNOUVFSOVAZSBUAUBUCUDUEUFUHUGUJUIUVLVRWHXCXDULUMXE $.

      $( Combine ~ cdleme19f and ~ cdleme20m to eliminate
         ` -. R .<_ ( S .\/ T ) ` condition.  (Contributed by NM,
         28-Nov-2012.) $)
      cdleme20 $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
       /\ ( T e. A /\ -. T .<_ W ) )
    /\ ( ( P =/= Q /\ S =/= T )
       /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
           /\ R .<_ ( P .\/ Q ) )
       /\ -. U .<_ ( S .\/ T ) ) )
           -> N = O ) $=
        ( chlt wcel wa wbr wn w3a co wceq simpl1 simpl22 simpl23 simp21l adantr
        wne simpl31 simp321 simp322 simp323 cdleme19f syl133anc simpl11 simpl12
        jca simpl13 simpl21 simpl32 simpr simpl33 cdleme20m syl333anc pm2.61dan
        anim1i ) MUNUOSKUOUPZCAUOCSNUQURUPZDAUODSNUQURUPZUSZEAUOZESNUQURZUPZFAU
        OFSNUQURUPZGAUOGSNUQURUPZUSZCDVGFGVGUPZFCDLUTZNUQURZGWQNUQURZEWQNUQZUSZ
        HFGLUTZNUQURZUSZUSZEXBNUQZPQVAZXEXFUPZWIWMWNWJWPWRWSUPWTXFUPXGWIWOXDXFV
        BWLWMWNWIXDXFVCWLWMWNWIXDXFVDXEWJXFWJWKWMWNWIXDVEVFWPXAXCWIWOXFVHXHWRWS
        XEWRXFWRWSWTWPXCWIWOVIVFXEWSXFWRWSWTWPXCWIWOVJVFVPXEWTXFWRWSWTWPXCWIWOV
        KWEABCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGUHUIUJULUMVLVMXEXFURZUPZWFWGWHWLWMW
        NWPXAXIXCUPXGWFWGWHWOXDXIVNWFWGWHWOXDXIVOWFWGWHWOXDXIVQWLWMWNWIXDXIVRWL
        WMWNWIXDXIVCWLWMWNWIXDXIVDWPXAXCWIWOXIVHWPXAXCWIWOXIVSXJXIXCXEXIVTWPXAX
        CWIWOXIWAVPABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMWBWCWD $.
    $}
  $}

  ${
    cdleme21a.l $e |- .<_ = ( le ` K ) $.
    cdleme21a.j $e |- .\/ = ( join ` K ) $.
    cdleme21a.a $e |- A = ( Atoms ` K ) $.
    $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
       28-Nov-2012.) $)
    cdleme21a $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
    /\ ( S e. A /\ -. S .<_ ( P .\/ Q ) )
    /\ ( z e. A /\ ( P .\/ z ) = ( S .\/ z ) ) )
             -> S =/= z ) $=
      ( chlt wcel w3a co wbr wn wa wne necomd cv clc simp11 hlcvl simp12 simp2l
      wceq syl simp3l simp13 simp2r atnlej1 syl131anc simp3r cvlsupr6 syl132anc
      ) GLMZCBMZDBMZNZEBMZECDFOHPQZRZAUAZBMZCVDFOEVDFOUGZRZNZGUBMZURVAVECESZVFE
      VDSVHUQVIUQURUSVCVGUCZGUDUHUQURUSVCVGUEZUTVAVBVGUFZUTVCVEVFUIVHUQVAURUSVB
      VJVKVMVLUQURUSVCVGUJUTVAVBVGUKUQVAURUSNVBNECBECDFGHIJKULTUMUTVCVEVFUNVIUR
      VAVENVJVFRNVDEBCEVDFGKJUOTUP $.

    $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
       28-Nov-2012.) $)
    cdleme21b $p |- ( ( ( K e. HL /\ P e. A /\ Q e. A )
    /\ ( S e. A /\ P =/= Q /\ -. S .<_ ( P .\/ Q ) )
    /\ ( z e. A /\ ( P .\/ z ) = ( S .\/ z ) ) )
             -> -. z .<_ ( P .\/ Q ) ) $=
      ( wcel w3a wne co wbr wceq wi necomd syl131anc wn cv wa simp23 clc simp11
      chlt hlcvl simp3l simp13 simp12 simp21 atnlej1 simp3r cvlsupr5 cvlatexch1
      syl syl132anc cvlsupr8 breq2d sylibrd simp22 syld mtod ) GUGLZCBLZDBLZMZE
      BLZCDNZECDFOZHPZUAZMZAUBZBLZCVOFOZEVOFOQZUCZMZVOVKHPZVLVHVIVJVMVSUDZVTWAD
      CEFOZHPZVLVTWADVQHPZWDVTGUELZVPVGVFVOCNZWAWERVTVEWFVEVFVGVNVSUFZGUHUQZVHV
      NVPVRUIZVEVFVGVNVSUJZVEVFVGVNVSUKZVTWFVFVIVPCENZVRWGWIWLVHVIVJVMVSULZWJVT
      VEVIVFVGVMWMWHWNWLWKWBVEVIVFVGMVMMECBECDFGHIJKUMSTZVHVNVPVRUNZBCEVOFGKJUO
      URBVODCFGHIJKUPTVTWCVQDHVTWFVFVIVPWMVRWCVQQWIWLWNWJWOWPBCEVOFGKJUSURUTVAV
      TWFVGVIVFDCNWDVLRWIWKWNWLVTCDVHVIVJVMVSVBSBDECFGHIJKUPTVCVD $.
  $}

  ${
    cdleme21.l $e |- .<_ = ( le ` K ) $.
    cdleme21.j $e |- .\/ = ( join ` K ) $.
    cdleme21.m $e |- ./\ = ( meet ` K ) $.
    cdleme21.a $e |- A = ( Atoms ` K ) $.
    cdleme21.h $e |- H = ( LHyp ` K ) $.
    cdleme21.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
       28-Nov-2012.) $)
    cdleme21c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
          /\ Q e. A )
    /\ ( S e. A /\ P =/= Q /\ -. S .<_ ( P .\/ Q ) )
    /\ ( z e. A /\ ( P .\/ z ) = ( S .\/ z ) ) )
             -> -. U .<_ ( S .\/ z ) ) $=
      ( wcel wbr chlt wa wn w3a wne co cv wceq simp23 clc simp11l hlcvl simp12l
      simp21 simp3l simp13 atnlej1 necomd syl131anc cvlsupr7 syl132anc hlatjcom
      syl simp3r syl3anc eqtrd breq2d simp11r simp12r simp22 cdleme0a syl222anc
      wi clat cbs hllat eqid hlatjcl lhpbase latmle2 syl5eqbr nbrne2 cvlatexch1
      syl2anc hlatlej1 cdlemeulpq syl22anc wb atbase latjle12 syl13anc mpbi2and
      cfv lattr mpan2d syld sylbird mtod ) IUASZLGSZUBZCBSZCLJTUCZUBZDBSZUDZEBS
      ZCDUEZECDHUFZJTZUCZUDZAUGZBSZCXMHUFEXMHUFZUHZUBZUDZFXOJTZXJXFXGXHXKXQUIZX
      RXSFCEHUFZJTZXJXRYAXOFJXRYAXMEHUFZXOXRIUJSZXBXGXNCEUEZXPYAYCUHXRWSYDWSWTX
      DXEXLXQUKZIULVCZXBXCXAXEXLXQUMZXFXGXHXKXQUNZXFXLXNXPUOZXRWSXGXBXEXKYEYFYI
      YHXAXDXEXLXQUPZXTWSXGXBXEUDXKUDECBECDHIJMNPUQURUSXFXLXNXPVDBCEXMHIPNUTVAX
      RWSXNXGYCXOUHYFYJYIBHIXMENPVBVEVFVGXRYBECFHUFZJTZXJXRYDFBSZXGXBFCUEZYBYMV
      MYGXRWSWTXBXCXEXHYNYFWSWTXDXEXLXQVHZYHXBXCXAXEXLXQVIZYKXFXGXHXKXQVJBCDFGH
      IJKLMNOPQRVKVLZYIYHXRFLJTXCYOXRFXILKUFZLJRXRIVNSZXIIVOWMZSZLUUASZYSLJTXRW
      SYTYFIVPVCZXRWSXBXEUUBYFYHYKBUUAHICDUUAVQZNPVRVEZXRWTUUCYPUUAGILUUEQVSVCU
      UAIJKXILUUEMOVTVEWAYQFCLJWBWDBFECHIJMNPWCUSXRYMYLXIJTZXJXRCXIJTZFXIJTZUUG
      XRWSXBXEUUHYFYHYKBCDHIJMNPWEVEXRWSWTXBXEUUIYFYPYHYKBCDFGHIJKLMNOPQRWFWGXR
      YTCUUASZFUUASZUUBUUHUUIUBUUGWHUUDXRXBUUJYHBUUACIUUEPWIVCXRYNUUKYRBUUAFIUU
      EPWIVCUUFUUAHIJCFXIUUEMNWJWKWLXRYTEUUASZYLUUASZUUBYMUUGUBXJVMUUDXRXGUULYI
      BUUAEIUUEPWIVCXRWSXBYNUUMYFYHYRBUUAHICFUUENPVRVEUUFUUAIJEYLXIUUEMWNWKWOWP
      WQWR $.

    $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
       29-Nov-2012.) $)
    cdleme21at $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ Q e. A )
    /\ ( ( S e. A /\ P =/= Q /\ -. S .<_ ( P .\/ Q ) )
       /\ U .<_ ( S .\/ T ) )
    /\ ( z e. A /\ ( P .\/ z ) = ( S .\/ z ) ) )
             -> T =/= z ) $=
      ( wcel chlt wa wbr wn w3a wne co cv wceq cdleme21c 3adant2r simp2r breq2d
      oveq2 syl5ibcom necon3bd mpd ) JUATMHTUBCBTCMKUCUDUBDBTUEZEBTCDUFECDIUGKU
      CUDUEZGEFIUGZKUCZUBAUHZBTCVBIUGEVBIUGZUIUBZUEZGVCKUCZUDZFVBUFURUSVDVGVAAB
      CDEGHIJKLMNOPQRSUJUKVEVFFVBVEVAFVBUIZVFURUSVAVDULVHUTVCGKFVBEIUNUMUOUPUQ
      $.

    $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
       29-Nov-2012.) $)
    cdleme21ct $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ Q e. A )
    /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) /\ U .<_ ( S .\/ T ) ) )
    /\ ( ( z e. A /\ -. z .<_ W ) /\ ( P .\/ z ) = ( S .\/ z ) ) )
             -> -. U .<_ ( T .\/ z ) ) $=
      ( wcel chlt wa wbr wn w3a co cv wceq simp11 simp12 simp13 simp21l simp231
      wne simp232 simp3ll simp3r cdleme21c syl332anc simp233 clc wi simp11l syl
      hlcvl simp11r simp12l simp12r cdleme0a syl222anc simp22l clat cbs hlatjcl
      cfv hllat syl3anc lhpbase latmle2 syl5eqbr simp21r nbrne2 syl2anc simp22r
      eqid cvlatexch3 syl132anc mpd adantr simp3lr imp eqtrd hlatlej2 syl5ibcom
      ex breq2 cdleme21a syl322anc cvlatexch2 syl131anc 3syld mtod ) JUATZMHTZU
      BZCBTZCMKUCUDZUBZDBTZUEZEBTZEMKUCUDZUBZFBTZFMKUCUDZUBZCDUNZECDIUFZKUCUDZG
      EFIUFKUCZUEZUEZAUGZBTZYCMKUCUDZUBZCYCIUFEYCIUFZUHZUBZUEZGFYCIUFKUCZGYGKUC
      ZYJXEXHXIXKXQXSYDYHYLUDXEXHXIYBYIUIXEXHXIYBYIUJXEXHXIYBYIUKZXKXLXPYAXJYIU
      LZXQXSXTXMXPXJYIUMZXQXSXTXMXPXJYIUOZYDYEYHXJYBUPZXJYBYFYHUQZABCDEGHIJKLMN
      OPQRSURUSYJYKGEIUFZGYCIUFZUHZEYTKUCZYLYJYKUUAYJYKUBYSGFIUFZYTYJYSUUCUHZYK
      YJXTUUDXQXSXTXMXPXJYIUTYJJVATZGBTZXKXNGEUNZGFUNZXTUUDVBYJXCUUEXCXDXHXIYBY
      IVCZJVEVDZYJXCXDXFXGXIXQUUFUUIXCXDXHXIYBYIVFZXFXGXEXIYBYIVGZXFXGXEXIYBYIV
      HYMYOBCDGHIJKLMNOPQRSVIVJZYNXNXOXMYAXJYIVKZYJGMKUCZXLUUGYJGXRMLUFZMKSYJJV
      LTZXRJVMVOZTZMUURTZUUPMKUCYJXCUUQUUIJVPVDYJXCXFXIUUSUUIUULYMBUURIJCDUURWE
      ZOQVNVQYJXDUUTUUKUURHJMUVARVRVDUURJKLXRMUVANPVSVQVTZXKXLXPYAXJYIWAGEMKWBW
      CYJUUOXOUUHUVBXNXOXMYAXJYIWDGFMKWBWCZBGEFIJKNOQWFWGWHWIYJYKUUCYTUHZYJUUEU
      UFXNYDUUHGYCUNZYKUVDVBUUJUUMUUNYQUVCYJUUOYEUVEUVBYDYEYHXJYBWJGYCMKWBWCBGF
      YCIJKNOQWFWGWKWLWOYJEYSKUCZUUAUUBYJXCUUFXKUVFUUIUUMYNBGEIJKNOQWMVQYSYTEKW
      PWNYJUUEXKUUFYDEYCUNZUUBYLVBUUJYNUUMYQYJXCXFXIXKXSYDYHUVGUUIUULYMYNYPYQYR
      ABCDEIJKNOQWQWRBEGYCIJKNOQWSWTXAXB $.

    cdleme21.f $e |- F
          = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    ${
      cdleme21.b $e |- B
         = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
      cdleme21.d $e |- D = ( ( R .\/ S ) ./\ W ) $.
      cdleme21.e $e |- E = ( ( R .\/ z ) ./\ W ) $.
      cdleme21d.n $e |- N = ( ( P .\/ Q ) ./\ ( F .\/ D ) ) $.
      cdleme21d.z $e |- Z = ( ( P .\/ Q ) ./\ ( B .\/ E ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on
         p. 115, 3rd line. ` D ` , ` F ` , ` N ` , ` E ` , ` B ` , ` Z `
         represent s_2, f(s), f_s(r), z_2, f(z), f_z(r) respectively.  We prove
         f_s(r) = f_z(r).  (Contributed by NM, 29-Nov-2012.) $)
      cdleme21d $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( P =/= Q
           /\ ( -. S .<_ ( P .\/ Q ) /\ R .<_ ( P .\/ Q ) )
           /\ ( ( z e. A /\ -. z .<_ W ) /\ ( P .\/ z ) = ( S .\/ z ) ) ) )
               -> N = Z ) $=
        ( chlt wcel wa wbr wn w3a co cv wceq simp11 simp12 simp13 simp2l simp2r
        simp33l simp31 simp11l simp12l simp13l simp2rl simp32l simpld cdleme21a
        wne simp33r syl322anc cdleme21b syl332anc 3jca cdleme21c eqid syl333anc
        jca simp32r cdleme20 ) NULUMZRLUMZUNZEBUMZEROUOUPZUNZFBUMZFROUOUPZUNZUQ
        ZGBUMGROUOUPUNZHBUMZHROUOUPZUNZUNZEFVOZHEFMURZOUOUPZGXCOUOZUNZAUSZBUMZX
        GROUOUPZUNZEXGMURHXGMURZUTZUNZUQZUQZWIWLWOWQWTXJXBHXGVOZUNXDXGXCOUOUPZX
        EUQIXKOUOUPZQSUTWIWLWOXAXNVAZWIWLWOXAXNVBZWIWLWOXAXNVCWPWQWTXNVDWPWQWTX
        NVEXJXLXBXFWPXAVFZXOXBXPWPXAXBXFXMVGZXOWGWJWMWRXDXHXLXPWGWHWLWOXAXNVHZW
        JWKWIWOXAXNVIZWMWNWIWLXAXNVJZWRWSWQWPXNVKZXDXEXBXMWPXAVLZXOXHXIYAVMZXJX
        LXBXFWPXAVPZABEFHMNOTUAUCVNVQWDXOXDXQXEYGXOWGWJWMWRXBXDXHXLXQYCYDYEYFYB
        YGYHYIABEFHMNOTUAUCVRVSXDXEXBXMWPXAWEVTXOWIWLWMWRXBXDXHXLXRXSXTYEYFYBYG
        YHYIABEFHILMNOPRTUAUBUCUDUEWAVSBDEFGHXGIKCLMNOPQSXKRPURZRJTUAUBUCUDUEUF
        UGUHUIYJWBUJUKWFWC $.

      cdleme21.g $e |- G
         = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
      cdleme21.y $e |- Y = ( ( R .\/ T ) ./\ W ) $.
      cdleme21.o $e |- O = ( ( P .\/ Q ) ./\ ( G .\/ Y ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, last paragraph on
         p. 115, 3rd line. ` Y ` , ` G ` , ` O ` , ` E ` , ` B ` , ` Z `
         represent s_2, f(s), f_s(r), z_2, f(z), f_z(r) respectively.  We prove
         that if u ` <_ ` s ` \/ ` z, then f_t(r) = f_z(r).  (Contributed by
         NM, 29-Nov-2012.) $)
      cdleme21e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( R .<_ ( P .\/ Q )
       /\ U .<_ ( S .\/ T ) )
          /\ ( ( z e. A /\ -. z .<_ W ) /\ ( P .\/ z ) = ( S .\/ z ) ) ) )
               -> O = Z ) $=
        ( chlt wcel wa wbr wn w3a co cv wceq simp11 simp12 simp13 simp31 simp22
        wne simp33l simp231 simp13l simp21l simp232 3jca simp32r simpld simp33r
        cdleme21at syl322anc simp233 simp11l simp12l cdleme21b syl332anc simp21
        jca simp32l cdleme21ct eqid cdleme20 syl333anc ) PUSUTZUANUTZVAZEBUTZEU
        AQVBVCZVAZFBUTZFUAQVBVCZVAZVDZHBUTZHUAQVBVCZVAZIBUTIUAQVBVCVAZEFVMZHEFO
        VEZQVBVCZIXLQVBVCZVDZVDZGBUTGUAQVBVCVAZGXLQVBZJHIOVEQVBZVAZAVFZBUTZYAUA
        QVBVCZVAZEYAOVEHYAOVEVGZVAZVDZVDZWSXBXEXQXJYDXKIYAVMZVAXNYAXLQVBVCZXRVD
        JIYAOVEZQVBVCZTUCVGWSXBXEXPYGVHZWSXBXEXPYGVIZWSXBXEXPYGVJXFXPXQXTYFVKXF
        XIXJXOYGVLZYDYEXQXTXFXPVNZYHXKYIXKXMXNXIXJXFYGVOZYHWSXBXCXGXKXMVDXSYBYE
        YIYMYNXCXDWSXBXPYGVPZYHXGXKXMXGXHXJXOXFYGVQZYQXKXMXNXIXJXFYGVRZVSXRXSXQ
        YFXFXPVTZYHYBYCYPWAZYDYEXQXTXFXPWBZABEFHIJNOPQRUAUDUEUFUGUHUIWCWDWKYHXN
        YJXRXKXMXNXIXJXFYGWEYHWQWTXCXGXKXMYBYEYJWQWRXBXEXPYGWFWTXAWSXEXPYGWGYRY
        SYQYTUUBUUCABEFHOPQUDUEUGWHWIXRXSXQYFXFXPWLVSYHWSXBXCXIXJXKXMXSVDYDYEYL
        YMYNYRXFXIXJXOYGWJYOYHXKXMXSYQYTUUAVSYPUUCABEFHIJNOPQRUAUDUEUFUGUHUIWMW
        IBUBEFGIYAJMCNOPQRTUCYKUARVEZUAKUDUEUFUGUHUIUPUKUQUMUUDWNURUOWOWP $.

      $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
         29-Nov-2012.) $)
      cdleme21f $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( R .<_ ( P .\/ Q )
           /\ U .<_ ( S .\/ T ) )
          /\ ( ( z e. A /\ -. z .<_ W ) /\ ( P .\/ z ) = ( S .\/ z ) ) ) )
               -> N = O ) $=
        ( chlt wcel wa wbr wn w3a co cv wceq simp11 simp12 simp13 simp31 simp21
        wne simp231 simp232 simp32l simp33 cdleme21d syl323anc cdleme21e eqtr4d
        jca ) PUSUTUANUTVAZEBUTEUAQVBVCVAZFBUTFUAQVBVCVAZVDZHBUTHUAQVBVCVAZIBUT
        IUAQVBVCVAZEFVMZHEFOVEZQVBVCZIWJQVBVCZVDZVDZGBUTGUAQVBVCVAZGWJQVBZJHIOV
        EQVBZVAZAVFZBUTWSUAQVBVCVAEWSOVEHWSOVEVGVAZVDZVDZSUCTXBWCWDWEWOWGWIWKWP
        VAWTSUCVGWCWDWEWNXAVHWCWDWEWNXAVIWCWDWEWNXAVJWFWNWOWRWTVKWFWGWHWMXAVLWI
        WKWLWGWHWFXAVNXBWKWPWIWKWLWGWHWFXAVOWPWQWOWTWFWNVPWBWFWNWOWRWTVQABCDEFG
        HJKLNOPQRSUAUCUDUEUFUGUHUIUJUKULUMUNUOVRVSABCDEFGHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUPUQURVTWA $.
    $}

    cdleme21g.g $e |- G
       = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
    cdleme21g.d $e |- D = ( ( R .\/ S ) ./\ W ) $.
    cdleme21g.y $e |- Y = ( ( R .\/ T ) ./\ W ) $.
    ${
      cdleme21g.n $e |- N = ( ( P .\/ Q ) ./\ ( F .\/ D ) ) $.
      cdleme21g.o $e |- O = ( ( P .\/ Q ) ./\ ( G .\/ Y ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
         29-Nov-2012.) $)
      cdleme21g $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
          /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q ) ) )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( R .<_ ( P .\/ Q )
      /\ U .<_ ( S .\/ T ) )
          /\ ( ( z e. A /\ -. z .<_ W ) /\ ( P .\/ z ) = ( S .\/ z ) ) ) )
               -> N = O ) $=
        ( cv co eqid cdleme21f ) ABAUMZIMUNEDUQMUNSPUNMUNPUNZCDEFGHIFUQMUNSPUNZ
        JKLMNOPQRSTDEMUNURUSMUNPUNZUAUBUCUDUEUFUGURUOUIUSUOUKUTUOUHUJULUP $.

      $d r z A $.  $d r F $.  $d r G $.  $d r z H $.  $d r z .\/ $.
      $d r z K $.  $d r z .<_ $.  $d r ./\ $.  $d z N $.  $d z O $.
      $d r z P $.  $d r z Q $.  $d r z R $.  $d r z S $.  $d r z T $.
      $d z U $.  $d r z W $.
      $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
         29-Nov-2012.) $)
      cdleme21h $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
            /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q )
              /\ -. T .<_ ( P .\/ Q ) ) )
       /\ ( ( R e. A /\ -. R .<_ W )
            /\ ( R .<_ ( P .\/ Q ) /\ U .<_ ( S .\/ T ) ) ) )
  -> ( E. z e. A ( -. z .<_ W /\ ( P .\/ z ) = ( S .\/ z ) ) -> N = O ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cv simp11 simp12 simp13l simp13r simp2
        wceq simp3l simp3r jca31 cdleme21g syl113anc rexlimdv3a ) NUMUNSLUNUODB
        UNDSOUPUQUOEBUNESOUPUQUOURZGBUNGSOUPUQUOHBUNHSOUPUQUODEUSGDEMUTZOUPUQHV
        OOUPUQURURZFBUNFSOUPUQUOZFVOOUPIGHMUTOUPUOZUOZURZAVAZSOUPUQZDWAMUTGWAMU
        TVGZUOZQRVGZABVTWABUNZWDURZVNVPVQVRWFWBUOWCUOWEVNVPVSWFWDVBVNVPVSWFWDVC
        VQVRVNVPWFWDVDVQVRVNVPWFWDVEWGWFWBWCVTWFWDVFVTWFWBWCVHVTWFWBWCVIVJABCDE
        FGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVKVLVM $.

      $( Part of proof of Lemma E in [Crawley] p. 115.  (Contributed by NM,
         29-Nov-2012.) $)
      cdleme21i $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
            /\ ( P =/= Q /\ -. S .<_ ( P .\/ Q )
             /\ -. T .<_ ( P .\/ Q ) ) )
       /\ ( ( R e. A /\ -. R .<_ W )
            /\ ( R .<_ ( P .\/ Q ) /\ U .<_ ( S .\/ T ) ) ) )
  -> ( E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) -> N = O ) ) $=
        ( vz chlt wcel wa wbr wn w3a wne co cv wceq wrex simpl11 simp12 simp21l
        simp13 3jca simp231 simp232 simpr 4atexlem7 syl113anc ex cdleme21h syld
        adantr ) MUNUORKUOUPZCAUOCRNUQURUPZDAUODRNUQURUPZUSZFAUOZFRNUQURZUPZGAU
        OGRNUQURUPZCDUTZFCDLVAZNUQURZGWHNUQURZUSZUSZEAUOERNUQURUPEWHNUQHFGLVANU
        QUPUPZUSZTVBZRNUQURCWOLVADWOLVAVCUPTAVDZUMVBZRNUQURCWQLVAFWQLVAVCUPUMAV
        DZPQVCWNWPWRWNWPUPVSVTWAWCUSZWGWIWPWRVSVTWAWLWMWPVEWNWSWPWNVTWAWCVSVTWA
        WLWMVFVSVTWAWLWMVHWCWDWFWKWBWMVGVIVRWNWGWPWGWIWJWEWFWBWMVJVRWNWIWPWGWIW
        JWEWFWBWMVKVRWNWPVLUMACDFKLMNRTUAUBUDUEVMVNVOUMABCDEFGHIJKLMNOPQRSUAUBU
        CUDUEUFUGUHUIUJUKULVPVQ $.

      $( Combine ~ cdleme20 and ~ cdleme21i to eliminate ` U .<_ ( S .\/ T ) `
         condition.  (Contributed by NM, 29-Nov-2012.) $)
      cdleme21j $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
           /\ ( T e. A /\ -. T .<_ W ) )
        /\ ( ( P =/= Q /\ S =/= T )
           /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
           /\ R .<_ ( P .\/ Q ) )
           /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
               -> N = O ) $=
        ( chlt wcel wa wbr wn w3a wne co wceq wrex simpl33 simpl1 simp22 simp23
        cv simp31l simp321 simp322 3jca adantr simpl21 simp323 anim1i cdleme21i
        syl112anc mpd simpl2 simpl31 simpl32 simpr cdleme20 syl113anc pm2.61dan
        wi eqid ) MUMUNRKUNUOCAUNCRNUPUQUODAUNDRNUPUQUOURZEAUNERNUPUQUOZFAUNFRN
        UPUQUOZGAUNGRNUPUQUOZURZCDUSZFGUSZUOZFCDLUTZNUPUQZGWPNUPUQZEWPNUPZURZTV
        GZRNUPUQCXALUTDXALUTVAUOTAVBZURZURZHFGLUTZNUPZPQVAZXDXFUOZXBXGWOWTXBWHW
        LXFVCXHWHWJWKWMWQWRURZURZWIWSXFUOXBXGWFWHWLXCXFVDXDXJXFXDWJWKXIWHWIWJWK
        XCVEWHWIWJWKXCVFXDWMWQWRWMWNWTXBWHWLVHWQWRWSWOXBWHWLVIWQWRWSWOXBWHWLVJV
        KVKVLWIWJWKWHXCXFVMXDWSXFWQWRWSWOXBWHWLVNVOABCDEFGHIJKLMNOPQRSTUAUBUCUD
        UEUFUGUHUIUJUKULVPVQVRXDXFUQZUOWHWLWOWTXKXGWHWLXCXKVDWHWLXCXKVSWOWTXBWH
        WLXKVTWOWTXBWHWLXKWAXDXKWBABCDEFGHIJKLMNOPQXEROUTZRSUAUBUCUDUEUFUGUHUIU
        JXLWGUKULWCWDWE $.

      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd line on p. 115.
         ` D ` , ` F ` , ` N ` , ` Y ` , ` G ` , ` O ` represent s_2, f(s),
         f_s(r), t_2, f(t), f_t(r) respectively.  Combine ~ cdleme18d and
         ~ cdleme21j to eliminate existence condition, proving f_s(r) = f_t(r)
         with fewer conditions.  (Contributed by NM, 29-Nov-2012.) $)
      cdleme21 $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
           /\ ( T e. A /\ -. T .<_ W ) )
        /\ ( ( P =/= Q /\ S =/= T )
           /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
           /\ R .<_ ( P .\/ Q ) ) ) )
               -> N = O ) $=
        ( vr chlt wcel wa wbr wn w3a wne co cv wceq wrex simpl1 simpl3l simpl3r
        simpl2 simpr cdleme21j syl113anc simp3ll adantr simp3r3 simp3r1 simp3r2
        3jca oveq2i eqtri cdleme18d pm2.61dan ) MUMUNRKUNUOCAUNCRNUPUQUODAUNDRN
        UPUQUOURZEAUNERNUPUQUOFAUNFRNUPUQUOGAUNGRNUPUQUOURZCDUSZFGUSZUOZFCDLUTZ
        NUPUQZGWFNUPUQZEWFNUPZURZUOZURZULVAZRNUPUQCWMLUTDWMLUTVBUOULAVCZPQVBZWL
        WNUOWAWBWEWJWNWOWAWBWKWNVDWAWBWKWNVGWEWJWAWBWNVEWEWJWAWBWNVFWLWNVHABCDE
        FGHIJKLMNOPQRSULTUAUBUCUDUEUFUGUHUIUJUKVIVJWLWNUQZUOWAWBWCWIWGWHURZWPWO
        WAWBWKWPVDWAWBWKWPVGWLWCWPWCWDWJWAWBVKVLWLWQWPWLWIWGWHWGWHWIWEWAWBVMWGW
        HWIWEWAWBVNWGWHWIWEWAWBVOVPVLWLWPVHAJCDEFGHQIPKLMNORULTUAUBUCUDUEUFPWFI
        BLUTZOUTWFIEFLUTROUTZLUTZOUTUJWRWTWFOBWSILUHVQVQVRUGQWFJSLUTZOUTWFJEGLU
        TROUTZLUTZOUTUKXAXCWFOSXBJLUIVQVQVRVSVJVT $.

      $( Eliminate ` S =/= T ` condition in ~ cdleme21 .  (Contributed by NM,
         26-Dec-2012.) $)
      cdleme21k $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W )
           /\ ( T e. A /\ -. T .<_ W ) )
        /\ ( P =/= Q
           /\ ( -. S .<_ ( P .\/ Q ) /\ -. T .<_ ( P .\/ Q )
           /\ R .<_ ( P .\/ Q ) ) ) )
               -> N = O ) $=
        ( chlt wcel wa wbr wn w3a wne co wceq oveq1 oveq2 oveq1d oveq2d oveq12d
        3eqtr4g simpl11 simpl12 simpl13 simpl21 simpl22 simpl23 simpl3l simpl3r
        eqeq1d simpr jca cdleme21 syl332anc eqidd pm2.61ne ) MULUMRKUMUNZCAUMCR
        NUOUPUNZDAUMDRNUOUPUNZUQZEAUMERNUOUPUNZFAUMFRNUOUPUNZGAUMGRNUOUPUNZUQZC
        DURZFCDLUSZNUOUPGWKNUOUPEWKNUOUQZUNZUQZPQUTZQQUTFGFGUTZPQQWPWKIBLUSZOUS
        WKJSLUSZOUSPQWPWQWRWKOWPIJBSLWPFHLUSZDCFLUSZROUSZLUSZOUSGHLUSZDCGLUSZRO
        USZLUSZOUSIJWPWSXCXBXFOFGHLVAWPXAXEDLWPWTXDROFGCLVBVCVDVEUFUGVFWPEFLUSZ
        ROUSEGLUSZROUSBSWPXGXHROFGELVBVCUHUIVFVEVDUJUKVFVOWNFGURZUNZWBWCWDWFWGW
        HWJXIUNWLWOWBWCWDWIWMXIVGWBWCWDWIWMXIVHWBWCWDWIWMXIVIWFWGWHWEWMXIVJWFWG
        WHWEWMXIVKWFWGWHWEWMXIVLXJWJXIWJWLWEWIXIVMWNXIVPVQWJWLWEWIXIVNABCDEFGHI
        JKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVRVSWNQVTWA $.
    $}
  $}

  ${
    cdleme22.l $e |- .<_ = ( le ` K ) $.
    cdleme22.j $e |- .\/ = ( join ` K ) $.
    cdleme22.m $e |- ./\ = ( meet ` K ) $.
    cdleme22.a $e |- A = ( Atoms ` K ) $.
    cdleme22.h $e |- H = ( LHyp ` K ) $.
    ${
      cdleme22.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 3rd line
         on p. 115.  Show that t ` \/ ` v = p ` \/ ` q implies v = u.
         (Contributed by NM, 2-Dec-2012.) $)
      cdleme22aa $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ P =/= Q )
           /\ ( V e. A /\ V .<_ W /\ V .<_ ( P .\/ Q ) ) ) -> V = U ) $=
        ( wcel wbr syl chlt wa wn wne w3a co wceq simp33 simp32 clat cbs cfv wb
        simp1l simp31 eqid atbase simp21l simp22 hlatjcl syl3anc simp1r lhpbase
        hllat latlem12 syl13anc mpbi2and syl6breqr cal simp21r simp23 syl222anc
        hlatl cdleme0a atcmp mpbid ) GUARZKERZUBZBARZBKHSUCZUBZCARZBCUDZUEZJARZ
        JKHSZJBCFUFZHSZUEZUEZJDHSZJDUGZWKJWHKIUFZDHWKWIWGJWNHSZVSWEWFWGWIUHVSWE
        WFWGWIUIWKGUJRZJGUKULZRZWHWQRZKWQRZWIWGUBWOUMWKVQWPVQVRWEWJUNZGVDTWKWFW
        RVSWEWFWGWIUOZAWQJGWQUPZOUQTWKVQVTWCWSXAVTWAWCWDVSWJURZVSWBWCWDWJUSZAWQ
        FGBCXCMOUTVAWKVRWTVQVRWEWJVBZWQEGKXCPVCTWQGHIJWHKXCLNVEVFVGQVHWKGVIRZWF
        DARZWLWMUMWKVQXGXAGVMTXBWKVQVRVTWAWCWDXHXAXFXDVTWAWCWDVSWJVJXEVSWBWCWDW
        JVKABCDEFGHIKLMNOPQVNVLAJDGHLOVOVAVP $.

      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 3rd line
         on p. 115.  Show that t ` \/ ` v = p ` \/ ` q implies v = u.
         (Contributed by NM, 30-Nov-2012.) $)
      cdleme22a $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ T e. A )
         /\ ( ( V e. A /\ V .<_ W ) /\ P =/= Q
           /\ ( T .\/ V ) = ( P .\/ Q ) ) )
     -> V = U ) $=
        ( wcel wbr chlt wa wn w3a wne wceq simp21 simp22 simp32 simp31l simp31r
        co simp1l simp23 hlatlej2 syl3anc simp33 breqtrd cdleme22aa syl133anc
        simp1 ) HUASZLFSZUBZBASBLITUCUBZCASZDASZUDZKASZKLITZUBZBCUEZDKGULZBCGUL
        ZUFZUDZUDZVDVEVFVLVIVJKVNITKEUFVDVHVPVAVDVEVFVGVPUGVDVEVFVGVPUHVDVHVKVL
        VOUIVIVJVLVOVDVHUJZVIVJVLVOVDVHUKVQKVMVNIVQVBVGVIKVMITVBVCVHVPUMVDVEVFV
        GVPUNVRADKGHIMNPUOUPVDVHVKVLVOUQURABCEFGHIJKLMNOPQRUSUT $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 5th line on
       p. 115.  Show that t ` \/ ` v =/= p ` \/ ` q and s ` <_ ` p ` \/ ` q
       implies ` -. ` t ` <_ ` p ` \/ ` q.  (Contributed by NM, 2-Dec-2012.) $)
    cdleme22b $p |- ( ( ( K e. HL
           /\ ( S e. A /\ T e. A /\ S =/= T ) )
       /\ ( P e. A /\ Q e. A /\ P =/= Q )
       /\ ( V e. A
           /\ ( ( T .\/ V ) =/= ( P .\/ Q ) /\ S .<_ ( T .\/ V )
           /\ S .<_ ( P .\/ Q ) ) ) )
    -> -. T .<_ ( P .\/ Q ) ) $=
      ( wcel wa wbr adantr chlt wne w3a co cp0 cfv wceq wo clln simp1r1 simp1r2
      simp1l simp1r3 eqid llni2 syl31anc llnneat syl2anc llnn0 jca df-ne anbi2i
      wn pm4.56 bitri sylib simp3r2 simp3l hlatlej1 syl3anc cbs wb hllat atbase
      clat syl hlatjcl latjle12 syl13anc mpbi2and simp3r3 simpr simp21 latlem12
      simp22 ex wi cops simprl simprr leat3 exp32 breq2 biimpa ople0 syl5ib imp
      hlop olcd simp3r1 2atmat0 syl33anc mpjaod syld mtod ) HUAQZDAQZEAQZDEUBZU
      CZRZBAQZCAQZBCUBZUCZKAQZEKGUDZBCGUDZUBZDXQISZDXRISZUCZRZUCZEXRISZDEGUDZAQ
      ZYFHUEUFZUGZUHZYDYGVCZYFYHUBZRZYJVCZYDYKYLYDXFYFHUIUFZQZYKXFXJXOYCULZYDXF
      XGXHXIYPYQXGXHXIXFXOYCUJZXGXHXIXFXOYCUKZXGXHXIXFXOYCUMADEGHYOMOYOUNZUOUPZ
      AHYOYFOYTUQURYDXFYPYLYQUUAHYOYFYHYHUNZYTUSURUTYMYKYIVCZRYNYLUUCYKYFYHVAVB
      YGYIVDVEVFYDYEYFXQXRJUDZISZYJYDYEUUEYDYERZYFXQISZYFXRISZUUEYDUUGYEYDXTEXQ
      ISZUUGXSXTYAXPXKXOVGYDXFXHXPUUIYQYSXKXOXPYBVHZAEKGHILMOVIVJYDHVOQZDHVKUFZ
      QZEUULQZXQUULQZXTUUIRUUGVLYDXFUUKYQHVMVPZYDXGUUMYRAUULDHUULUNZOVNVPZYDXHU
      UNYSAUULEHUUQOVNVPZYDXFXHXPUUOYQYSUUJAUULGHEKUUQMOVQVJZUULGHIDEXQUUQLMVRV
      SVTTUUFYAYEUUHYDYAYEXSXTYAXPXKXOWATYDYEWBYDYAYERUUHVLZYEYDUUKUUMUUNXRUULQ
      ZUVAUUPUURUUSYDXFXLXMUVBYQXKXLXMXNYCWCZXKXLXMXNYCWEZAUULGHBCUUQMOVQVJZUUL
      GHIDEXRUUQLMVRVSTVTYDUUGUUHRUUEVLZYEYDUUKYFUULQZUUOUVBUVFUUPYDXFXGXHUVGYQ
      YRYSAUULGHDEUUQMOVQVJZUUTUVEUULHIJYFXQXRUUQLNWDVSTVTWFYDUUDAQZUUEYJWGUUDY
      HUGZYDUVIUUEYJYDUVIUUERZRHWHQZUVGUVIUUEYJYDUVLUVKYDXFUVLYQHWRVPZTYDUVGUVK
      UVHTYDUVIUUEWIYDUVIUUEWJAUULUUDHIYFYHUUQLUUBOWKUPWLYDUVJUUEYJYDUVJUUERZRY
      IYGYDUVNYIUVNYFYHISZYDYIUVJUUEUVOUUDYHYFIWMWNYDUVLUVGUVOYIVLUVMUVHUULHIYF
      YHUUQLUUBWOURWPWQWSWLYDXFXHXPXLXMXSUVIUVJUHYQYSUUJUVCUVDXSXTYAXPXKXOWTAEK
      BCGHJYHMNUUBOXAXBXCXDXE $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 5th line on
       p. 115.  Show that t ` \/ ` v =/= p ` \/ ` q and s ` <_ ` p ` \/ ` q
       implies ` -. ` v ` <_ ` p ` \/ ` q.  (Contributed by NM, 3-Dec-2012.)
       (New usage is discouraged.) $)
    cdleme22cN $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ -. P .<_ W ) /\ Q e. A )
     /\ ( ( S e. A /\ -. S .<_ W ) /\ T e. A /\ ( V e. A /\ V .<_ W ) )
     /\ ( ( P =/= Q /\ S =/= T )
        /\ ( S .<_ ( T .\/ V ) /\ S .<_ ( P .\/ Q ) )
        /\ ( T .\/ V ) =/= ( P .\/ Q ) ) )
       -> -. V .<_ ( P .\/ Q ) ) $=
      ( wcel wbr adantr chlt wa wn w3a wne co cbs cfv simp11l hllat syl simp12l
      clat eqid hlatjcl syl3anc simp11r lhpbase latmle2 simp21r syl2anc simp32l
      simp13 simpl12 simpl13 simp31l simp23l simp23r simpr cdleme22aa syl233anc
      nbrne2 wceq oveq2d breqtrd simp32r wb simp21l atbase simp22 simp12r lhpat
      syl222anc latlem12 syl13anc mpbi2and cp0 simp31r 3jca cdleme22b syl232anc
      simp33 cal hlatl atnle mpbid oveq1d latmle1 atmod4i1 syl131anc col latmcl
      hlol olj02 3eqtr3d atcmp eqcomd ex necon3ad mpd ) HUARZLFRZUBZBARZBLISUCZ
      UBZCARZUDZDARZDLISUCZUBZEARZKARZKLISZUBZUDZBCUEZDEUEZUBZDEKGUFZISZDBCGUFZ
      ISZUBZYJYLUEZUDZUDZYLLJUFZDUEZKYLISZUCYQYRLISZXTYSYQHUMRZYLHUGUHZRZLUUCRZ
      UUAYQXKUUBXKXLXPXQYFYPUIZHUJUKZYQXKXNXQUUDUUFXNXOXMXQYFYPULZXMXPXQYFYPVCZ
      AUUCGHBCUUCUNZNPUOUPZYQXLUUEXKXLXPXQYFYPUQZUUCFHLUUJQURUKZUUCHIJYLLUUJMOU
      SUPXSXTYBYEXRYPUTYRDLIVLVAYQYTYRDYQYTYRDVMYQYTUBZDYRUUNDYRISZDYRVMZUUNDEY
      RGUFZYLJUFZYRIUUNDUUQISZYMDUURISZUUNDYJUUQIYQYKYTYKYMYIYOXRYFVBZTUUNKYREG
      UUNXKXLXPXQYGYCYDYTKYRVMYQXKYTUUFTYQXLYTUULTXMXPXQYFYPYTVDXMXPXQYFYPYTVEY
      QYGYTYGYHYNYOXRYFVFZTYQYCYTYCYDYAYBXRYPVGZTYQYDYTYCYDYAYBXRYPVHTYQYTVIABC
      YRFGHIJKLMNOPQYRUNVJVKVNVOYQYMYTYKYMYIYOXRYFVPZTYQUUSYMUBUUTVQZYTYQUUBDUU
      CRZUUQUUCRZUUDUVEUUGYQXSUVFXSXTYBYEXRYPVRZAUUCDHUUJPVSUKYQXKYBYRARZUVGUUF
      XRYAYBYEYPVTZYQXKXLXNXOXQYGUVIUUFUULUUHXNXOXMXQYFYPWAUUIUVBABCFGHIJLMNOPQ
      WBWCZAUUCGHEYRUUJNPUOUPUUKUUCHIJDUUQYLUUJMOWDWETWFYQUURYRVMYTYQEYLJUFZYRG
      UFZHWGUHZYRGUFZUURYRYQUVLUVNYRGYQEYLISUCZUVLUVNVMZYQXKXSYBYHUDXNXQYGYCYOY
      KYMUDUVPUUFYQXSYBYHUVHUVJYGYHYNYOXRYFWHWIUUHUUIUVBUVCYQYOYKYMXRYFYIYNYOWL
      UVAUVDWIABCDEFGHIJKMNOPQWJWKYQHWMRZYBUUDUVPUVQVQYQXKUVRUUFHWNUKZUVJUUKAUU
      CEHIJYLUVNUUJMOUVNUNZPWOUPWPWQYQXKUVIEUUCRZUUDYRYLISZUVMUURVMUUFUVKYQYBUW
      AUVJAUUCEHUUJPVSUKUUKYQUUBUUDUUEUWBUUGUUKUUMUUCHIJYLLUUJMOWRUPAUUCYRGHIJE
      YLUUJMNOPWSWTYQHXARZYRUUCRZUVOYRVMYQXKUWCUUFHXCUKYQUUBUUDUUEUWDUUGUUKUUMU
      UCHJYLLUUJOXBUPUUCGHYRUVNUUJNUVTXDVAXETVOYQUUOUUPVQZYTYQUVRXSUVIUWEUVSUVH
      UVKADYRHIMPXFUPTWPXGXHXIXJ $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 9th line on
       p. 115.  (Contributed by NM, 4-Dec-2012.) $)
    cdleme22d $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
         /\ ( V e. A /\ V .<_ W ) )
    /\ ( S =/= T /\ S .<_ ( T .\/ V ) ) ) -> V = ( ( S .\/ T ) ./\ W ) ) $=
      ( wcel wa wbr co syl chlt wn w3a wne wceq simp3r simp22l simp23l hlatlej1
      simp1l syl3anc clat cbs cfv wb hllat simp21l eqid atbase hlatjcl latjle12
      syl13anc mpbi2and wi simp1r lhpbase latmlem1 mpd cp0 simp1 simp22 syl2anc
      lhpmat oveq1d simp23r atmod4i1 syl131anc hlol olj02 3eqtr3d breqtrd hlatl
      col cal simp21r simp3l lhpat syl222anc atcmp mpbid eqcomd ) FUAPZJDPZQZBA
      PZBJGRUBZQZCAPZCJGRUBZQZIAPZIJGRZQZUCZBCUDZBCIESZGRZQZUCZBCESZJHSZIXIXKIG
      RZXKIUEZXIXKXFJHSZIGXIXJXFGRZXKXNGRZXIXGCXFGRZXOWNXDXEXGUFXIWLWRXAXQWLWMX
      DXHUJZWRWSWQXCWNXHUGZXAXBWQWTWNXHUHZACIEFGKLNUIUKXIFULPZBFUMUNZPZCYBPZXFY
      BPZXGXQQXOUOXIWLYAXRFUPTZXIWOYCWOWPWTXCWNXHUQZAYBBFYBURZNUSTXIWRYDXSAYBCF
      YHNUSTZXIWLWRXAYEXRXSXTAYBEFCIYHLNUTUKZYBEFGBCXFYHKLVAVBVCXIYAXJYBPZYEJYB
      PZXOXPVDYFXIWLWOWRYKXRYGXSAYBEFBCYHLNUTUKYJXIWMYLWLWMXDXHVEZYBDFJYHOVFTZY
      BFGHXJXFJYHKMVGVBVHXICJHSZIESZFVIUNZIESZXNIXIYOYQIEXIWNWTYOYQUEWNXDXHVJWN
      WQWTXCXHVKACDFGHJYQKMYQURZNOVMVLVNXIWLXAYDYLXBYPXNUEXRXTYIYNXAXBWQWTWNXHV
      OAYBIEFGHCJYHKLMNVPVQXIFWCPZIYBPZYRIUEXIWLYTXRFVRTXIXAUUAXTAYBIFYHNUSTYBE
      FIYQYHLYSVSVLVTWAXIFWDPZXKAPZXAXLXMUOXIWLUUBXRFWBTXIWLWMWOWPWRXEUUCXRYMYG
      WOWPWTXCWNXHWEXSWNXDXEXGWFABCDEFGHJKLMNOWGWHXTAXKIFGKNWIUKWJWK $.

    ${
      cdleme22e.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme22e.f $e |- F
          = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
      cdleme22e.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( S .\/ z ) ./\ W ) ) ) $.
      cdleme22e.o $e |- O
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( T .\/ z ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 4th line
         on p. 115. ` F ` , ` N ` , ` O ` represent f(z), f_z(s), f_z(t)
         respectively.  When t ` \/ ` v = p ` \/ ` q, f_z(s) ` <_ ` f_z(t)
         ` \/ ` v.  (Contributed by NM, 6-Dec-2012.) $)
      cdleme22e $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
            /\ ( S e. A /\ T e. A ) )
         /\ ( ( V e. A /\ V .<_ W ) /\ ( P =/= Q
          /\ ( T .\/ V ) = ( P .\/ Q ) )
             /\ ( z e. A /\ -. z .<_ W ) ) )
          -> N .<_ ( O .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne co wceq clat cbs cfv simp1l hllat simp21l
        cv syl simp22l hlatjcl syl3anc simp1r simp33l cdleme1b syl23anc simp23l
        eqid lhpbase latmcl latjcl latmle1 syl5eqbr simp1 simp21 simp23r simp31
        simp32l simp32r cdleme22a syl133anc oveq2d simp21r syl222anc cdlemeulpq
        oveq1i cdleme0a syl22anc syl131anc syl5req eqtr4d eqtr3d atbase latlej1
        atmod2i1 hlatj32 syl13anc latj32 cp1 hlatlej1 atmod3i1 lhpjat2 syl21anc
        hlol olm11 syl2anc 3eqtrd oveq1d oveq2i hlatlej2 syl5eq simp22 3eqtr4rd
        col eqtrd latlej2 atmod1i1 lattrd latleeqm1 mpbid simp33 eqtr2d breqtrd
        wb eqbrtrd ) KUGUHZQIUHZUIZCBUHZCQLUJUKZUIZDBUHZDQLUJUKZUIZEBUHZFBUHZUI
        ZULZPBUHPQLUJUIZCDUMZFPJUNZCDJUNZUOZUIZAVBZBUHZUUIQLUJUKZUIZULZULZNUUFO
        PJUNZLUUNNUUFHEUUIJUNZQMUNZJUNZMUNZUUFLUEUUNKUPUHZUUFKUQURZUHZUURUVAUHZ
        UUSUUFLUJUUNYJUUTYJYKUUBUUMUSZKUTVCZUUNYJYMYPUVBUVDYMYNYRUUAYLUUMVAZYPY
        QYOUUAYLUUMVDZBUVAJKCDUVAVLZSUAVEVFZUUNUUTHUVAUHZUUQUVAUHZUVCUVEUUNYJYK
        YMYPUUJUVJUVDYJYKUUBUUMVGZUVFUVGUUJUUKUUCUUHYLUUBVHZBUVACDUUIGHIJKLMQRS
        TUAUBUCUDUVHVIVJZUUNUUTUUPUVAUHZQUVAUHZUVKUVEUUNYJYSUUJUVOUVDYSYTYOYRYL
        UUMVKUVMBUVAJKEUUIUVHSUAVEVFUUNYKUVPUVLUVAIKQUVHUBVMVCZUVAKMUUPQUVHTVNV
        FUVAJKHUUQUVHSVOVFUVAKLMUUFUURUVHRTVPVFVQUUNUUOUUFHFUUIJUNZQMUNZJUNZGJU
        NZMUNZUUFUUNUUOOGJUNZUWBUUNPGOJUUNYLYOYPYTUUCUUDUUGPGUOYLUUBUUMVRYLYOYR
        UUAUUMVSZUVGYSYTYOYRYLUUMVTZYLUUBUUCUUHUULWAUUDUUGUUCUULYLUUBWBZUUDUUGU
        UCUULYLUUBWCZBCDFGIJKLMPQRSTUAUBUCWDWEZWFUUNUWCUUFUVTMUNZGJUNZUWBOUWIGJ
        UFWJUUNYJGBUHZUVBUVTUVAUHZGUUFLUJZUWJUWBUOUVDUUNYJYKYMYNYPUUDUWKUVDUVLU
        VFYMYNYRUUAYLUUMWGUVGUWFBCDGIJKLMQRSTUAUBUCWKWHZUVIUUNUUTUVJUVSUVAUHZUW
        LUVEUVNUUNUUTUVRUVAUHZUVPUWOUVEUUNYJYTUUJUWPUVDUWEUVMBUVAJKFUUIUVHSUAVE
        VFZUVQUVAKMUVRQUVHTVNVFZUVAJKHUVSUVHSVOVFZUUNYJYKYMYPUWMUVDUVLUVFUVGBCD
        GIJKLMQRSTUAUBUCWIWLZBUVAGJKLMUUFUVTUVHRSTUAWSWMWNWOUUNUUFUWALUJZUWBUUF
        UOZUUNUUFFGJUNZUWALUUNUUEUUFUXCUWGUUNPGFJUWHWFWPUUNUXCUXCUUIJUNZUWALUUN
        UUTUXCUVAUHZUUIUVAUHZUXCUXDLUJUVEUUNYJYTUWKUXEUVDUWEUWNBUVAJKFGUVHSUAVE
        VFUUNUUJUXFUVMBUVAUUIKUVHUAWQVCZUVAJKLUXCUUIUVHRSWRVFUUNUXDUVRGJUNZUWAU
        UNYJYTUWKUUJUXDUXHUOUVDUWEUWNUVMBFGUUIJKSUAWTXAUUNUUIGJUNZUVSJUNZUUIUVS
        JUNZGJUNZUWAUXHUUNUUTUXFGUVAUHZUWOUXJUXLUOUVEUXGUUNUWKUXMUWNBUVAGKUVHUA
        WQVCZUWRUVAJKUUIGUVSUVHSXBXAUUNUWAHGJUNZUVSJUNZUXJUUNUUTUVJUWOUXMUWAUXP
        UOUVEUVNUWRUXNUVAJKHUVSGUVHSXBXAUUNUXOUXIUVSJUUNUXOUUIGUUFUUIJUNZMUNZJU
        NZUXIUUNUXIUXQMUNZUXIDCUUIJUNZQMUNZJUNZGJUNZMUNZUXSUXOUUNUXQUYDUXIMUUNU
        XQDGJUNZUYBJUNZUYDUUNCUYBJUNZDJUNZUYADJUNZUYGUXQUUNUYHUYADJUUNUYHUYACQJ
        UNZMUNZUYAKXCURZMUNZUYAUUNYJYMUYAUVAUHZUVPCUYALUJZUYHUYLUOUVDUVFUUNYJYM
        UUJUYOUVDUVFUVMBUVAJKCUUIUVHSUAVEVFZUVQUUNYJYMUUJUYPUVDUVFUVMBCUUIJKLRS
        UAXDVFBUVACJKLMUYAQUVHRSTUAXEWMUUNUYKUYMUYAMUUNYJYKYOUYKUYMUOUVDUVLUWDB
        CUYMIJKLQRSUYMVLZUAUBXFXGWFUUNKXRUHZUYOUYNUYAUOUUNYJUYSUVDKXHVCZUYQUVAU
        YMKMUYAUVHTUYRXIXJXKXLUUNUYGUUFUYBJUNZUYIUUNUYFUUFUYBJUUNUYFUUFDQJUNZMU
        NZUUFUYMMUNZUUFUUNUYFDUUFQMUNZJUNZVUCGVUEDJUCXMUUNYJYPUVBUVPDUUFLUJZVUF
        VUCUOUVDUVGUVIUVQUUNYJYMYPVUGUVDUVFUVGBCDJKLRSUAXNVFBUVADJKLMUUFQUVHRST
        UAXEWMXOUUNVUBUYMUUFMUUNYJYKYRVUBUYMUOUVDUVLYLYOYRUUAUUMXPBDUYMIJKLQRSU
        YRUAUBXFXGWFUUNUYSUVBVUDUUFUOUYTUVIUVAUYMKMUUFUVHTUYRXIXJXKXLUUNUUTCUVA
        UHZUYBUVAUHZDUVAUHZUYIVUAUOUVEUUNYMVUHUVFBUVACKUVHUAWQVCUUNUUTUYOUVPVUI
        UVEUYQUVQUVAKMUYAQUVHTVNVFZUUNYPVUJUVGBUVADKUVHUAWQVCZUVAJKCUYBDUVHSXBX
        AWOUUNYJYMYPUUJUXQUYJUOUVDUVFUVGUVMBCDUUIJKSUAWTXAXQUUNUUTVUJUXMVUIUYGU
        YDUOUVEVULUXNVUKUVAJKDGUYBUVHSXBXAXSWFUUNYJUUJUXMUXQUVAUHZUUIUXQLUJZUXS
        UXTUOUVDUVMUXNUUNUUTUVBUXFVUMUVEUVIUXGUVAJKUUFUUIUVHSVOVFZUUNUUTUVBUXFV
        UNUVEUVIUXGUVAJKLUUFUUIUVHRSXTVFBUVAUUIJKLMGUXQUVHRSTUAYAWMUUNUXOUXIUYC
        MUNZGJUNZUYEHVUPGJUDWJUUNYJUWKUXIUVAUHZUYCUVAUHZGUXILUJZVUQUYEUOUVDUWNU
        UNYJUUJUWKVURUVDUVMUWNBUVAJKUUIGUVHSUAVEVFUUNUUTVUJVUIVUSUVEVULVUKUVAJK
        DUYBUVHSVOVFUUNYJUUJUWKVUTUVDUVMUWNBUUIGJKLRSUAXNVFBUVAGJKLMUXIUYCUVHRS
        TUAWSWMXOXQUUNUXRGUUIJUUNGUXQLUJZUXRGUOZUUNUVAKLGUUFUXQUVHRUVEUXNUVIVUO
        UWTUUNUUTUVBUXFUUFUXQLUJUVEUVIUXGUVAJKLUUFUUIUVHRSWRVFYBUUNUUTUXMVUMVVA
        VVBYHUVEUXNVUOUVAKLMGUXQUVHRTYCVFYDWFXSXLXSUUNUVRUXKGJUUNUXKUVRUYMMUNZU
        VRUUNUXKUVRUUIQJUNZMUNZVVCUUNYJUUJUWPUVPUUIUVRLUJZUXKVVEUOUVDUVMUWQUVQU
        UNYJYTUUJVVFUVDUWEUVMBFUUIJKLRSUAXNVFBUVAUUIJKLMUVRQUVHRSTUAXEWMUUNVVDU
        YMUVRMUUNYJYKUULVVDUYMUOUVDUVLYLUUBUUCUUHUULYEBUUIUYMIJKLQRSUYRUAUBXFXG
        WFXSUUNUYSUWPVVCUVRUOUYTUWQUVAUYMKMUVRUVHTUYRXIXJYFXLXQXSYGYIUUNUUTUVBU
        WAUVAUHZUXAUXBYHUVEUVIUUNUUTUWLUXMVVGUVEUWSUXNUVAJKUVTGUVHSVOVFUVAKLMUU
        FUWAUVHRTYCVFYDYFYG $.
    $}

    ${
      cdleme22eALT.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme22eALT.f $e |- F
          = ( ( y .\/ U ) ./\ ( Q .\/ ( ( P .\/ y ) ./\ W ) ) ) $.
      cdleme22eALT.g $e |- G
          = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
      cdleme22eALT.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( S .\/ y ) ./\ W ) ) ) $.
      cdleme22eALT.o $e |- O
          = ( ( P .\/ Q ) ./\ ( G .\/ ( ( T .\/ z ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 4th line
         on p. 115. ` F ` , ` N ` , ` O ` represent f(z), f_z(s), f_z(t)
         respectively.  When t ` \/ ` v = p ` \/ ` q, f_z(s) ` <_ ` f_z(t)
         ` \/ ` v.  (Contributed by NM, 6-Dec-2012.)
         (New usage is discouraged.) $)
      cdleme22eALTN $p |- ( ( ( K e. HL /\ W e. H /\ T e. A )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ P =/= Q ) /\ ( S e. A
             /\ ( V e. A /\ V .<_ W /\ ( T .\/ V ) = ( P .\/ Q ) )
             /\ ( ( y e. A /\ -. y .<_ W ) /\ ( z e. A /\ -. z .<_ W ) ) ) )
          -> N .<_ ( O .\/ V ) ) $=
        ( chlt wcel w3a wbr wn wa wne co wceq clat cbs cfv simp11 hllat simp21l
        cv simp22l eqid hlatjcl syl3anc simp12 simp3ll 3ad2ant3 cdleme1b simp31
        syl syl23anc lhpbase latmcl latjcl latmle1 syl5eqbr simp321 simp322 jca
        simp21 simp13 simp23 simp323 cdleme22a syl233anc oveq2d oveq1i cdleme0a
        simp21r syl222anc simp3rl cdlemeulpq syl22anc atmod2i1 syl131anc eqtr3d
        syl5req latlej1 hlatj32 syl13anc cp1 hlatlej1 atmod3i1 lhpjat2 syl21anc
        atbase latj32 col hlol olm11 syl2anc 3eqtrd oveq1d oveq2i syl5eq simp22
        hlatlej2 eqtr4d 3eqtr4rd eqtrd latlej2 atmod1i1 lattrd wb mpbid simp33r
        latleeqm1 3eqtrrd breqtrd eqbrtrd 3eqtr2rd ) MUJUKZSKUKZGCUKZULZDCUKZDS
        NUMUNZUOZECUKZESNUMUNZUOZDEUPZULZFCUKZRCUKZRSNUMZGRLUQZDELUQZURZULZAVEZ
        CUKZUUPSNUMUNZUOZBVEZCUKZUUTSNUMUNZUOZUOZULZULZPUUMQRLUQZNUVFPUUMIFUUPL
        UQZSOUQZLUQZOUQZUUMNUHUVFMUSUKZUUMMUTVAZUKZUVJUVMUKZUVKUUMNUMUVFYQUVLYQ
        YRYSUUHUVEVBZMVCVOZUVFYQUUAUUDUVNUVPUUAUUBUUFUUGYTUVEVDZUUDUUEUUCUUGYTU
        VEVFZCUVMLMDEUVMVGZUAUCVHVIZUVFUVLIUVMUKZUVIUVMUKZUVOUVQUVFYQYRUUAUUDUU
        QUWBUVPYQYRYSUUHUVEVJZUVRUVSUVEYTUUQUUHUUQUURUVCUUIUUOVKVLZCUVMDEUUPHIK
        LMNOSTUAUBUCUDUEUFUVTVMVPUVFUVLUVHUVMUKZSUVMUKZUWCUVQUVFYQUUIUUQUWFUVPY
        TUUHUUIUUOUVDVNUWECUVMLMFUUPUVTUAUCVHVIUVFYRUWGUWDUVMKMSUVTUDVQVOZUVMMO
        UVHSUVTUBVRVIUVMLMIUVIUVTUAVSVIUVMMNOUUMUVJUVTTUBVTVIWAUVFUVGQHLUQZUUMJ
        GUUTLUQZSOUQZLUQZHLUQZOUQZUUMUVFRHQLUVFYQYRUUCUUDYSUUJUUKUOUUGUUNRHURUV
        PUWDYTUUCUUFUUGUVEWEZUVSYQYRYSUUHUVEWFZUVFUUJUUKUUJUUKUUNUUIUVDYTUUHWBU
        UJUUKUUNUUIUVDYTUUHWCWDYTUUCUUFUUGUVEWGZUUJUUKUUNUUIUVDYTUUHWHZCDEGHKLM
        NORSTUAUBUCUDUEWIWJZWKUVFUWIUUMUWLOUQZHLUQZUWNQUWTHLUIWLUVFYQHCUKZUVNUW
        LUVMUKZHUUMNUMZUXAUWNURUVPUVFYQYRUUAUUBUUDUUGUXBUVPUWDUVRUUAUUBUUFUUGYT
        UVEWNUVSUWQCDEHKLMNOSTUAUBUCUDUEWMWOZUWAUVFUVLJUVMUKZUWKUVMUKZUXCUVQUVF
        YQYRUUAUUDUVAUXFUVPUWDUVRUVSUVEYTUVAUUHUVAUVBUUSUUIUUOWPVLZCUVMDEUUTHJK
        LMNOSTUAUBUCUDUEUGUVTVMVPZUVFUVLUWJUVMUKZUWGUXGUVQUVFYQYSUVAUXJUVPUWPUX
        HCUVMLMGUUTUVTUAUCVHVIZUWHUVMMOUWJSUVTUBVRVIZUVMLMJUWKUVTUAVSVIZUVFYQYR
        UUAUUDUXDUVPUWDUVRUVSCDEHKLMNOSTUAUBUCUDUEWQWRZCUVMHLMNOUUMUWLUVTTUAUBU
        CWSWTXBUVFUUMUWMNUMZUWNUUMURZUVFUUMGHLUQZUWMNUVFUULUUMUXQUWRUVFRHGLUWSW
        KXAUVFUXQUXQUUTLUQZUWMNUVFUVLUXQUVMUKZUUTUVMUKZUXQUXRNUMUVQUVFYQYSUXBUX
        SUVPUWPUXECUVMLMGHUVTUAUCVHVIUVFUVAUXTUXHCUVMUUTMUVTUCXKVOZUVMLMNUXQUUT
        UVTTUAXCVIUVFUXRUWJHLUQZUWMUVFYQYSUXBUVAUXRUYBURUVPUWPUXEUXHCGHUUTLMUAU
        CXDXEUVFUUTHLUQZUWKLUQZUUTUWKLUQZHLUQZUWMUYBUVFUVLUXTHUVMUKZUXGUYDUYFUR
        UVQUYAUVFUXBUYGUXECUVMHMUVTUCXKVOZUXLUVMLMUUTHUWKUVTUAXLXEUVFUWMJHLUQZU
        WKLUQZUYDUVFUVLUXFUXGUYGUWMUYJURUVQUXIUXLUYHUVMLMJUWKHUVTUAXLXEUVFUYIUY
        CUWKLUVFUYIUUTHUUMUUTLUQZOUQZLUQZUYCUVFUYCUYKOUQZUYCEDUUTLUQZSOUQZLUQZH
        LUQZOUQZUYMUYIUVFUYKUYRUYCOUVFUYKEHLUQZUYPLUQZUYRUVFDUYPLUQZELUQZUYOELU
        QZVUAUYKUVFVUBUYOELUVFVUBUYODSLUQZOUQZUYOMXFVAZOUQZUYOUVFYQUUAUYOUVMUKZ
        UWGDUYONUMZVUBVUFURUVPUVRUVFYQUUAUVAVUIUVPUVRUXHCUVMLMDUUTUVTUAUCVHVIZU
        WHUVFYQUUAUVAVUJUVPUVRUXHCDUUTLMNTUAUCXGVICUVMDLMNOUYOSUVTTUAUBUCXHWTUV
        FVUEVUGUYOOUVFYQYRUUCVUEVUGURUVPUWDUWOCDVUGKLMNSTUAVUGVGZUCUDXIXJWKUVFM
        XMUKZVUIVUHUYOURUVFYQVUMUVPMXNVOZVUKUVMVUGMOUYOUVTUBVULXOXPXQXRUVFVUAUU
        MUYPLUQZVUCUVFUYTUUMUYPLUVFUYTUUMESLUQZOUQZUUMVUGOUQZUUMUVFUYTEUUMSOUQZ
        LUQZVUQHVUSELUEXSUVFYQUUDUVNUWGEUUMNUMZVUTVUQURUVPUVSUWAUWHUVFYQUUAUUDV
        VAUVPUVRUVSCDELMNTUAUCYBVICUVMELMNOUUMSUVTTUAUBUCXHWTXTUVFVUPVUGUUMOUVF
        YQYRUUFVUPVUGURUVPUWDYTUUCUUFUUGUVEYACEVUGKLMNSTUAVULUCUDXIXJWKUVFVUMUV
        NVURUUMURVUNUWAUVMVUGMOUUMUVTUBVULXOXPXQXRUVFUVLDUVMUKZUYPUVMUKZEUVMUKZ
        VUCVUOURUVQUVFUUAVVBUVRCUVMDMUVTUCXKVOUVFUVLVUIUWGVVCUVQVUKUWHUVMMOUYOS
        UVTUBVRVIZUVFUUDVVDUVSCUVMEMUVTUCXKVOZUVMLMDUYPEUVTUAXLXEYCUVFYQUUAUUDU
        VAUYKVUDURUVPUVRUVSUXHCDEUUTLMUAUCXDXEYDUVFUVLVVDUYGVVCVUAUYRURUVQVVFUY
        HVVEUVMLMEHUYPUVTUAXLXEYEWKUVFYQUVAUYGUYKUVMUKZUUTUYKNUMZUYMUYNURUVPUXH
        UYHUVFUVLUVNUXTVVGUVQUWAUYAUVMLMUUMUUTUVTUAVSVIZUVFUVLUVNUXTVVHUVQUWAUY
        AUVMLMNUUMUUTUVTTUAYFVICUVMUUTLMNOHUYKUVTTUAUBUCYGWTUVFUYIUYCUYQOUQZHLU
        QZUYSJVVJHLUGWLUVFYQUXBUYCUVMUKZUYQUVMUKZHUYCNUMZVVKUYSURUVPUXEUVFYQUVA
        UXBVVLUVPUXHUXECUVMLMUUTHUVTUAUCVHVIUVFUVLVVDVVCVVMUVQVVFVVEUVMLMEUYPUV
        TUAVSVIUVFYQUVAUXBVVNUVPUXHUXECUUTHLMNTUAUCYBVICUVMHLMNOUYCUYQUVTTUAUBU
        CWSWTXTYDUVFUYLHUUTLUVFHUYKNUMZUYLHURZUVFUVMMNHUUMUYKUVTTUVQUYHUWAVVIUX
        NUVFUVLUVNUXTUUMUYKNUMUVQUWAUYAUVMLMNUUMUUTUVTTUAXCVIYHUVFUVLUYGVVGVVOV
        VPYIUVQUYHVVIUVMMNOHUYKUVTTUBYLVIYJWKYEXRYEUVFUWJUYEHLUVFUYEUWJUUTSLUQZ
        OUQZUWJVUGOUQZUWJUVFYQUVAUXJUWGUUTUWJNUMZUYEVVRURUVPUXHUXKUWHUVFYQYSUVA
        VVTUVPUWPUXHCGUUTLMNTUAUCYBVICUVMUUTLMNOUWJSUVTTUAUBUCXHWTUVFVVQVUGUWJO
        UVFYQYRUVCVVQVUGURUVPUWDUUSUVCUUIUUOYTUUHYKCUUTVUGKLMNSTUAVULUCUDXIXJWK
        UVFVUMUXJVVSUWJURVUNUXKUVMVUGMOUWJUVTUBVULXOXPYMXRYDYEYNYOUVFUVLUVNUWMU
        VMUKZUXOUXPYIUVQUWAUVFUVLUXCUYGVWAUVQUXMUYHUVMLMUWLHUVTUAVSVIUVMMNOUUMU
        WMUVTTUBYLVIYJYPYN $.
    $}

    ${
      cdleme22f.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme22f.f $e |- F
          = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
      cdleme22f.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( S .\/ T ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 6th and
         7th lines on p. 115. ` F ` , ` N ` represent f(t), f_t(s)
         respectively.  If s ` <_ ` t ` \/ ` v, then f_t(s) ` <_ ` f(t) ` \/ `
         v.  (Contributed by NM, 6-Dec-2012.) $)
      cdleme22f $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( S e. A /\ -. S .<_ W ) /\ T e. A /\ ( V e. A /\ V .<_ W ) )
        /\ ( S =/= T /\ S .<_ ( T .\/ V ) ) )
            -> N .<_ ( F .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne co clat cbs cfv simp11l hllat syl simp12l
        simp13l hlatjcl syl3anc simp11r simp22 cdleme1b syl23anc simp21l latmcl
        eqid lhpbase latjcl latmle2 wceq simp21 simp3l simp23l simp23r hlatjcom
        simp3r breqtrd clc cvlatexch2 syl131anc mpd cdleme22aa syl233anc oveq2d
        wi hlcvl breqtrrd syl5eqbr ) JUDUEZOHUEZUFZBAUEZBOKUGUHZUFZCAUEZCOKUGUH
        ZUFZUIZDAUEZDOKUGUHZUFZEAUEZNAUEZNOKUGZUFZUIZDEUJZDENIUKZKUGZUFZUIZMBCI
        UKZGDEIUKZOLUKZIUKZLUKZGNIUKZKUCXMXRXQXSKXMJULUEZXNJUMUNZUEZXQYAUEZXRXQ
        KUGXMWKXTWKWLWPWSXHXLUOZJUPUQZXMWKWNWQYBYDWNWOWMWSXHXLURZWQWRWMWPXHXLUS
        ZAYAIJBCYAVHZQSUTVAXMXTGYAUEZXPYAUEZYCYEXMWKWLWNWQXDYIYDWKWLWPWSXHXLVBZ
        YFYGWTXCXDXGXLVCZAYABCEFGHIJKLOPQRSTUAUBYHVDVEXMXTXOYAUEZOYAUEZYJYEXMWK
        XAXDYMYDXAXBXDXGWTXLVFZYLAYAIJDEYHQSUTVAXMWLYNYKYAHJOYHTVIUQYAJLXOOYHRV
        GVAYAIJGXPYHQVJVAYAJKLXNXQYHPRVKVAXMNXPGIXMWKWLXCXDXIXEXFNXOKUGZNXPVLYD
        YKWTXCXDXGXLVMYLWTXHXIXKVNZXEXFXCXDWTXLVOZXEXFXCXDWTXLVPXMDNEIUKZKUGZYP
        XMDXJYSKWTXHXIXKVRXMWKXDXEXJYSVLYDYLYRAIJENQSVQVAVSXMJVTUEZXAXEXDXIYTYP
        WGXMWKUUAYDJWHUQYOYRYLYQADNEIJKPQSWAWBWCADEXPHIJKLNOPQRSTXPVHWDWEWFWIWJ
        $.
    $}

    ${
      cdleme22f2.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme22f2.f $e |- F
          = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
      cdleme22f2.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( T .\/ S ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113. ~ cdleme22f with s and t
         swapped (this case is not mentioned by them).  If s ` <_ ` t ` \/ ` v,
         then f(s) ` <_ ` f_s(t) ` \/ ` v.  (Contributed by NM, 7-Dec-2012.) $)
      cdleme22f2 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( T e. A /\ -. T .<_ W )
              /\ ( -. S .<_ ( P .\/ Q ) /\ T .<_ ( P .\/ Q ) /\ P =/= Q ) )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S =/= T /\ S .<_ ( T .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> F .<_ ( N .\/ V ) ) $=
        ( chlt wcel wa wbr wn co wne simp11 simp2l simp2r simp12 simp31l simp33
        w3a simp32l necomd simp32r clc wi simp11l hlcvl simp12l simp33l simp33r
        syl simp31r nbrne2 syl2anc cvlatexch2 syl131anc mpd cdleme22f syl132anc
        simp31 simp133 simp132 simp131 cdleme7ga syl123anc cdleme3fa cdleme7
        3jca ) JUDUEZOHUEZUFZEAUEZEOKUGUHZUFZDBCIUIZKUGUHZEWLKUGZBCUJZUQZUQZBAU
        EBOKUGUHUFZCAUECOKUGUHUFZUFZDAUEZDOKUGUHZUFZDEUJZDENIUIKUGZUFZNAUEZNOKU
        GZUFZUQZUQZMGNIUIKUGZGMNIUIKUGZXKWHWRWSUQZWKXAXIEDUJEDNIUIKUGZXLXKWHWRW
        SWHWKWPWTXJUKZWQWRWSXJULZWQWRWSXJUMZWEZWHWKWPWTXJUNZXAXBXFXIWQWTUOZWQWT
        XCXFXIUPXKDEXDXEXCXIWQWTURUSXKXEXOXDXEXCXIWQWTUTXKJVAUEZXAWIXGDNUJZXEXO
        VBXKWFYBWFWGWKWPWTXJVCJVDVHZYAWIWJWHWPWTXJVEXGXHXCXFWQWTVFZXKXHXBYCXGXH
        XCXFWQWTVGZXAXBXFXIWQWTVIXHXBUFNDNDOKVJUSVKADENIJKPQSVLVMVNABCEDFGHIJKL
        MNOPQRSTUAUBUCVOVPXKYBMAUEZGAUEZXGMNUJZXLXMVBYDXKXNWKXCWOWNWMYGXSXTWQWT
        XCXFXIVQZWMWNWOWHWKWTXJVRZWMWNWOWHWKWTXJVSZWMWNWOWHWKWTXJVTZABCEDFGMHIJ
        KLOPQRSTUAUBUCWAWBXKWHWRWSXCWOWMYHXPXQXRYJYKYMABCDFGHIJKLOPQRSTUAUBWCVP
        YEXKXHMOKUGUHZYIYFXKXNWKXCWOWNWMYNXSXTYJYKYLYMABCEDFGMHIJKLOPQRSTUAUBUC
        WDWBXHYNUFNMNMOKVJUSVKAMGNIJKPQSVLVMVN $.
    $}

    ${
      cdleme22g.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme22g.f $e |- F
          = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
      cdleme22g.g $e |- G
          = ( ( T .\/ U ) ./\ ( Q .\/ ( ( P .\/ T ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 6th and
         7th lines on p. 115. ` F ` , ` G ` represent f(s), f(t) respectively.
         If s ` <_ ` t ` \/ ` v and ` -. ` s ` <_ ` p ` \/ ` q, then f(s)
         ` <_ ` f(t) ` \/ ` v.  (Contributed by NM, 6-Dec-2012.) $)
      cdleme22g $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( T e. A /\ -. T .<_ W )
           /\ ( -. T .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) /\ P =/= Q ) )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S =/= T /\ S .<_ ( T .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> F .<_ ( G .\/ V ) ) $=
        ( chlt wcel wa wbr wn co wne w3a clat cbs cfv simp11l syl simp11 simp2l
        hllat simp2r simp31 simp133 simp132 cdleme3fa syl132anc simp131 hlatjcl
        simp12 eqid syl3anc simp11r lhpbase latmle1 cdleme22d syl131anc simp32l
        wceq simp33 simp32 jca cdleme16 syl332anc eqtr2d hlatjcom 3brtr3d hlcvl
        clc wi simp33l simp33r cdleme3 nbrne2 syl2anc cvlatexch1 mpd ) KUDUEZOI
        UEZUFZEAUEEOLUGUHUFZEBCJUIZLUGUHZDWTLUGUHZBCUJZUKZUKZBAUEBOLUGUHUFZCAUE
        COLUGUHUFZUFZDAUEDOLUGUHUFZDEUJZDENJUILUGZUFZNAUEZNOLUGZUFZUKZUKZNHGJUI
        ZLUGZGHNJUILUGZXQGHJUIZOMUIZYANXRLXQKULUEZYAKUMUNZUEZOYDUEZYBYALUGXQWPY
        CWPWQWSXDXHXPUOZKUSUPXQWPGAUEZHAUEZYEYGXQWRXFXGXIXCXBYHWRWSXDXHXPUQZXEX
        FXGXPURZXEXFXGXPUTZXEXHXIXLXOVAZXAXBXCWRWSXHXPVBZXAXBXCWRWSXHXPVCZABCDF
        GIJKLMOPQRSTUAUBVDVEZXQWRXFXGWSXCXAYIYJYKYLWRWSXDXHXPVHZYNXAXBXCWRWSXHX
        PVFZABCEFHIJKLMOPQRSTUAUCVDVEZAYDJKGHYDVIZQSVGVJXQWQYFWPWQWSXDXHXPVKYDI
        KOYTTVLUPYDKLMYAOYTPRVMVJXQNDEJUIOMUIZYBXQWRXIWSXOXLNUUAVQYJYMYQXEXHXIX
        LXOVRXEXHXIXLXOVSADEIJKLMNOPQRSTVNVOXQWRXFXGXIWSXCXJUFXBXAUUAYBVQYJYKYL
        YMYQXQXCXJYNXJXKXIXOXEXHVPVTYOYRABCDEFGHIJKLMOPQRSTUAUBUCWAWBWCXQWPYHYI
        YAXRVQYGYPYSAJKGHQSWDVJWEXQKWGUEZXMYHYINHUJZXSXTWHXQWPUUBYGKWFUPXMXNXIX
        LXEXHWIYPYSXQXNHOLUGUHZUUCXMXNXIXLXEXHWJXQWRXFXGWSXCXAUUDYJYKYLYQYNYRAB
        CEFHIJKLMOPQRSTUAUCWKVENHOLWLWMANGHJKLPQSWNVOWO $.
    $}
  $}

  ${
    cdleme23.b $e |- B = ( Base ` K ) $.
    cdleme23.l $e |- .<_ = ( le ` K ) $.
    cdleme23.j $e |- .\/ = ( join ` K ) $.
    cdleme23.m $e |- ./\ = ( meet ` K ) $.
    cdleme23.a $e |- A = ( Atoms ` K ) $.
    cdleme23.h $e |- H = ( LHyp ` K ) $.
    cdleme23.v $e |- V = ( ( S .\/ T ) ./\ ( X ./\ W ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       8-Dec-2012.) $)
    cdleme23a $p |- ( ( ( ( K e. HL /\ W e. H )
         /\ ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) )
      /\ ( X e. B /\ -. X .<_ W )
      /\ ( S =/= T /\ ( S .\/ ( X ./\ W ) ) = X
         /\ ( T .\/ ( X ./\ W ) ) = X ) )
            -> V .<_ W ) $=
      ( wcel chlt wa wbr wn w3a wne wceq clat simp11l hllat syl simp12l simp13l
      co hlatjcl syl3anc simp2l simp11r lhpbase latmcl latmle2 lattrd syl5eqbr
      ) GUATZKETZUBZCATZCKHUCUDZUBZDATZDKHUCUDZUBZUEZLBTZLKHUCUDZUBZCDUFCLKIUNZ
      FUNLUGDVQFUNLUGUEZUEZJCDFUNZVQIUNZKHSVSBGHWAVQKMNVSVDGUHTZVDVEVIVLVPVRUIZ
      GUJUKZVSWBVTBTZVQBTZWABTWDVSVDVGVJWEWCVGVHVFVLVPVRULVJVKVFVIVPVRUMABFGCDM
      OQUOUPZVSWBVNKBTZWFWDVMVNVOVRUQZVSVEWHVDVEVIVLVPVRURBEGKMRUSUKZBGILKMPUTU
      PZBGIVTVQMPUTUPWKWJVSWBWEWFWAVQHUCWDWGWKBGHIVTVQMNPVAUPVSWBVNWHVQKHUCWDWI
      WJBGHILKMNPVAUPVBVC $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 4th paragraph, 6th line on
       p. 115.  (Contributed by NM, 8-Dec-2012.) $)
    cdleme23b $p |- ( ( ( ( K e. HL /\ W e. H )
         /\ ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) )
      /\ ( X e. B /\ -. X .<_ W )
      /\ ( S =/= T /\ ( S .\/ ( X ./\ W ) ) = X
         /\ ( T .\/ ( X ./\ W ) ) = X ) )
            -> V e. A ) $=
      ( wcel chlt wa wbr wn w3a wne co wceq col simp11l simp12l simp13l hlatjcl
      hlol syl syl3anc clat hllat simp2l simp11r lhpbase latmcl latjcl syl13anc
      latmassOLD latlej1 wb latleeqm1 mpbid oveq1d atbase simp32 simp33 oveq12d
      latjjdir latjidm syl2anc 3eqtrd oveq2d 3eqtr3d simp12r syl222anc eqeltrrd
      simp31 lhpat syl5eqel ) GUATZKETZUBZCATZCKHUCUDZUBZDATZDKHUCUDZUBZUEZLBTZ
      LKHUCUDZUBZCDUFZCLKIUGZFUGZLUHZDXAFUGZLUHZUEZUEZJCDFUGZXAIUGZASXGXHKIUGZX
      IAXGXHXHXAFUGZIUGZKIUGZXHXKKIUGZIUGZXJXIXGGUITZXHBTZXKBTZKBTZXMXOUHXGWGXP
      WGWHWLWOWSXFUJZGUNUOXGWGWJWMXQXTWJWKWIWOWSXFUKZWMWNWIWLWSXFULZABFGCDMOQUM
      UPZXGGUQTZXQXABTZXRXGWGYDXTGURUOZYCXGYDWQXSYEYFWPWQWRXFUSZXGWHXSWGWHWLWOW
      SXFUTZBEGKMRVAUOZBGILKMPVBUPZBFGXHXAMOVCUPZYIBGIXHXKKMPVEVDXGXLXHKIXGXHXK
      HUCZXLXHUHZXGYDXQYEYLYFYCYJBFGHXHXAMNOVFUPXGYDXQXRYLYMVGYFYCYKBGHIXHXKMNP
      VHUPVIVJXGXNXAXHIXGXKLKIXGXKXBXDFUGZLLFUGZLXGYDCBTZDBTZYEXKYNUHYFXGWJYPYA
      ABCGMQVKUOXGWMYQYBABDGMQVKUOYJBFGCDXAMOVOVDXGXBLXDLFWPWSWTXCXEVLWPWSWTXCX
      EVMVNXGYDWQYOLUHYFYGBFGLMOVPVQVRVJVSVTXGWGWHWJWKWMWTXJATXTYHYAWJWKWIWOWSX
      FWAYBWPWSWTXCXEWDACDEFGHIKNOPQRWEWBWCWF $.

    $( Part of proof of Lemma E in [Crawley] p. 113, 4th paragraph, 6th line on
       p. 115.  (Contributed by NM, 8-Dec-2012.) $)
    cdleme23c $p |- ( ( ( ( K e. HL /\ W e. H )
         /\ ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W ) )
      /\ ( X e. B /\ -. X .<_ W )
      /\ ( S =/= T /\ ( S .\/ ( X ./\ W ) ) = X
         /\ ( T .\/ ( X ./\ W ) ) = X ) )
            -> S .<_ ( T .\/ V ) ) $=
      ( wcel chlt wa wbr wn w3a wne wceq clat simp11l hllat syl simp12l simp13l
      atbase latlej1 syl3anc simp2l simp11r lhpbase latmcl simp32 simp33 eqtr4d
      breqtrd hlatjcl latjcl latlem12 syl13anc mpbi2and oveq2i latlej2 atmod3i1
      co wb syl131anc syl5eq breqtrrd ) GUATZKETZUBZCATZCKHUCUDZUBZDATZDKHUCUDZ
      UBZUEZLBTZLKHUCUDZUBZCDUFZCLKIVMZFVMZLUGZDWLFVMZLUGZUEZUEZCCDFVMZWOIVMZDJ
      FVMZHWRCWSHUCZCWOHUCZCWTHUCZWRGUHTZCBTZDBTZXBWRVRXEVRVSWCWFWJWQUIZGUJUKZW
      RWAXFWAWBVTWFWJWQULZABCGMQUNUKZWRWDXGWDWEVTWCWJWQUMZABDGMQUNUKZBFGHCDMNOU
      OUPWRCWMWOHWRXEXFWLBTZCWMHUCXIXKWRXEWHKBTZXNXIWGWHWIWQUQWRVSXOVRVSWCWFWJW
      QURBEGKMRUSUKBGILKMPUTUPZBFGHCWLMNOUOUPWRWMLWOWGWJWKWNWPVAWGWJWKWNWPVBVCV
      DWRXEXFWSBTZWOBTZXBXCUBXDVNXIXKWRVRWAWDXQXHXJXLABFGCDMOQVEUPZWRXEXGXNXRXI
      XMXPBFGDWLMOVFUPBGHICWSWOMNPVGVHVIWRXADWSWLIVMZFVMZWTJXTDFSVJWRVRWDXQXNDW
      SHUCZYAWTUGXHXLXSXPWRXEXFXGYBXIXKXMBFGHCDMNOVKUPABDFGHIWSWLMNOPQVLVOVPVQ
      $.
  $}

  ${
    $d s t u A $.  $d s t u B $.  $d s t H $.  $d s t u .\/ $.  $d s t K $.
    $d s t u .<_ $.  $d s u ./\ $.  $d s t u P $.  $d s t u Q $.  $d s t u R $.
    $d s t u W $.
    cdleme24.b $e |- B = ( Base ` K ) $.
    cdleme24.l $e |- .<_ = ( le ` K ) $.
    cdleme24.j $e |- .\/ = ( join ` K ) $.
    cdleme24.m $e |- ./\ = ( meet ` K ) $.
    cdleme24.a $e |- A = ( Atoms ` K ) $.
    cdleme24.h $e |- H = ( LHyp ` K ) $.
    cdleme24.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme24.f $e |- F
       = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme24.n $e |- N
        = ( ( P .\/ Q ) ./\ ( F .\/ ( ( R .\/ s ) ./\ W ) ) ) $.
    ${
      cdleme24.g $e |- G
          = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
      cdleme24.o $e |- O
          = ( ( P .\/ Q ) ./\ ( G .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
      $( Quantified version of ~ cdleme21k .  (Contributed by NM,
         26-Dec-2012.) $)
      cdleme24 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( R e. A /\ -. R .<_ W )
          /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) ) )
    -> A. s e. A A. t e. A ( ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) )
          /\ ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) ) -> N = O ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cv wceq simp111 simp112 simp113 simp12
        wi simp2l simp3ll jca simp3rl simp13l simp3lr simp3rr simp13r 3jca eqid
        simp2r cdleme21k syl332anc 3exp ralrimivv ) LUJUKQJUKULZDBUKDQMUMUNULZE
        BUKEQMUMUNULZUOZFBUKFQMUMUNULZDEUPZFDEKUQZMUMZULZUOZRURZQMUMUNZWJWFMUMU
        NZULZAURZQMUMUNZWNWFMUMUNZULZULZOPUSZVDRABBWIWJBUKZWNBUKZULZWRWSWIXBWRU
        OZVTWAWBWDWTWKULXAWOULWEWLWPWGUOWSVTWAWBWDWHXBWRUTVTWAWBWDWHXBWRVAVTWAW
        BWDWHXBWRVBWCWDWHXBWRVCXCWTWKWIWTXAWRVEWKWLWQWIXBVFVGXCXAWOWIWTXAWRVOWO
        WPWMWIXBVHVGWEWGWCWDXBWRVIXCWLWPWGWKWLWQWIXBVJWOWPWMWIXBVKWEWGWCWDXBWRV
        LVMBFWJKUQQNUQZDEFWJWNGHIJKLMNOPQFWNKUQQNUQZTUAUBUCUDUEUFUHXDVNXEVNUGUI
        VPVQVRVS $.
    $}

    $( Lemma for ~ cdleme25b .  (Contributed by NM, 1-Jan-2013.) $)
    cdleme25a $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( R e. A /\ -. R .<_ W )
        /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) ) )
  -> E. s e. A ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) ) /\ N e. B ) ) $=
      ( chlt wcel wa wbr wn w3a co cv wrex simp11l simp11r simp12 simp13 simp3l
      wne cdlemb2 syl221anc adantr simp12l simp13l simpl2l cdleme22gb syl222anc
      simpr a1d ancld reximdva mpd ) JUEUFZNHUFZUGZCAUFZCNKUHUIZUGZDAUFZDNKUHUI
      ZUGZUJZEAUFZENKUHUIZUGZCDUSZECDIUKZKUHZUGZUJZOULZNKUHUIWKWGKUHUIUGZOAUMZW
      LMBUFZUGZOAUMWJVMVNVRWAWFWMVMVNVRWAWEWIUNZVMVNVRWAWEWIUOZVOVRWAWEWIUPVOVR
      WAWEWIUQWBWEWFWHURACDHIJKNOQRTUAUTVAWJWLWOOAWJWKAUFZUGZWLWNWSWNWLWSVMVNVP
      VSWCWRWNWJVMWRWPVBWJVNWRWQVBWJVPWRVPVQVOWAWEWIVCVBWJVSWRVSVTVOVRWEWIVDVBW
      CWDWBWIWRVEWJWRVHABCDEWKFGMHIJKLNQRSTUAUBUCUDPVFVGVIVJVKVL $.

    ${
      $d t u N $.  $d s u U $.
      $( Transform ~ cdleme24 .  TODO get rid of $d's on ` U ` , ` N `
         (Contributed by NM, 1-Jan-2013.) $)
      cdleme25b $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( R e. A /\ -. R .<_ W )
        /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) ) )
  -> E. u e. B A. s e. A ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) )
           -> u = N ) ) $=
        ( vt chlt wcel wa wbr wn w3a wne co cv wrex wceq wi wral cdleme25a eqid
        cdleme24 breq1 notbid anbi12d oveq1 oveq1d oveq2d oveq12d syl5eq reusv3
        oveq2 biimpd sylc ) KUGUHOIUHUIDBUHDOLUJUKUIEBUHEOLUJUKUIULFBUHFOLUJUKU
        IDEUMFDEJUNZLUJUIULPUOZOLUJZUKZVPVOLUJZUKZUIZNCUHUIPBUPZWAUFUOZOLUJZUKZ
        WCVOLUJZUKZUIZUINVOWCGJUNZEDWCJUNZOMUNZJUNZMUNZFWCJUNZOMUNZJUNZMUNZUQUR
        UFBUSPBUSZWAAUONUQURPBUSACUPZBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUTUFBCDEFGHWM
        IJKLMNWQOPQRSTUAUBUCUDUEWMVAWQVAVBWBWRWSWAWHAPUFCBNWQVPWCUQZVRWEVTWGWTV
        QWDVPWCOLVCVDWTVSWFVPWCVOLVCVDVEWTNVOHFVPJUNZOMUNZJUNZMUNWQUEWTXCWPVOMW
        THWMXBWOJWTHVPGJUNZEDVPJUNZOMUNZJUNZMUNWMUDWTXDWIXGWLMVPWCGJVFWTXFWKEJW
        TXEWJOMVPWCDJVLVGVHVIVJWTXAWNOMVPWCFJVLVGVIVHVJVKVMVN $.

      $( Transform ~ cdleme25b .  (Contributed by NM, 1-Jan-2013.) $)
      cdleme25c $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( R e. A /\ -. R .<_ W )
        /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) ) )
  -> E! u e. B A. s e. A ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) )
               -> u = N ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cv wceq wi wral wreu wrex cdleme25b wb
        simp11l simp11r simp12 simp13 simp3l cdlemb2 syl221anc reusv1 mpbird
        syl ) KUFUGZOIUGZUHZDBUGDOLUIUJUHZEBUGEOLUIUJUHZUKZFBUGFOLUIUJUHZDEULZF
        DEJUMZLUIZUHZUKZPUNZOLUIUJWDVTLUIUJUHZAUNNUOUPPBUQZACURZWFACUSZABCDEFGH
        IJKLMNOPQRSTUAUBUCUDUEUTWCWEPBUSZWGWHVAWCVLVMVOVPVSWIVLVMVOVPVRWBVBVLVM
        VOVPVRWBVCVNVOVPVRWBVDVNVOVPVRWBVEVQVRVSWAVFBDEIJKLOPRSUAUBVGVHWEAPCBNV
        IVKVJ $.

      $( Transform ~ cdleme25c .  (Contributed by NM, 19-Jan-2013.)
         (New usage is discouraged.) $)
      cdleme25dN $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( R e. A /\ -. R .<_ W )
        /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) ) )
  -> E! u e. B E. s e. A ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) )
               /\ u = N ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cv wceq wrex wreu wi wral cdleme25c wb
        simp11l simp11r simp12l simp13l simpl2l simpr cdleme22gb syl222anc a1dd
        adantr ex ralrimiv simp12 simp13 simp3l cdlemb2 syl221anc reusv2 mpbird
        syl2anc ) KUFUGZOIUGZUHZDBUGZDOLUIUJZUHZEBUGZEOLUIUJZUHZUKZFBUGZFOLUIUJ
        ZUHZDEULZFDEJUMZLUIZUHZUKZPUNZOLUIUJWTWPLUIUJUHZAUNNUOZUHPBUPACUQZXAXBU
        RPBUSACUQZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUTWSXANCUGZURZPBUSXAPBUPZXCXDVA
        WSXFPBWSWTBUGZXEXAWSXHXEWSXHUHWBWCWEWHWLXHXEWSWBXHWBWCWGWJWNWRVBZVKWSWC
        XHWBWCWGWJWNWRVCZVKWSWEXHWEWFWDWJWNWRVDVKWSWHXHWHWIWDWGWNWRVEVKWLWMWKWR
        XHVFWSXHVGBCDEFWTGHNIJKLMORSTUAUBUCUDUEQVHVIVLVJVMWSWBWCWGWJWOXGXIXJWDW
        GWJWNWRVNWDWGWJWNWRVOWKWNWOWQVPBDEIJKLOPRSUAUBVQVRXAAPCBNVSWAVT $.

      cdleme25cl.i $e |- I = ( iota_ u e. B A. s e. A
       ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) ) -> u = N ) ) $.
      $( Show closure of the unique element in ~ cdleme25c .  (Contributed by
         NM, 2-Feb-2013.) $)
      cdleme25cl $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( R e. A /\ -. R .<_ W )
        /\ ( P =/= Q /\ R .<_ ( P .\/ Q ) ) ) -> I e. B ) $=
        ( chlt wcel wa wbr wn w3a wne co cv wceq wi wral crio cdleme25c cbs cfv
        wreu cvv fvex eqeltri riotaclb sylib syl5eqel ) LUHUIPIUIUJDBUIDPMUKULU
        JEBUIEPMUKULUJUMFBUIFPMUKULUJDEUNFDEKUOZMUKUJUMZJQUPZPMUKULVMVKMUKULUJA
        UPOUQURQBUSZACUTZCUGVLVNACVDVOCUIABCDEFGHIKLMNOPQRSTUAUBUCUDUEUFVAVNACC
        LVBVCVERLVBVFVGVHVIVJ $.
    $}
  $}

  ${
    $d s z A $.  $d s z .\/ $.  $d s z .<_ $.  $d s z ./\ $.  $d s z P $.
    $d s z Q $.  $d s z R $.  $d s z U $.  $d s z W $.  $d s z u $.
    cdleme25cv.f $e |- F
        = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme25cv.n $e |- N
        = ( ( P .\/ Q ) ./\ ( F .\/ ( ( R .\/ s ) ./\ W ) ) ) $.
    cdleme25cv.g $e |- G
        = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
    cdleme25cv.o $e |- O
        = ( ( P .\/ Q ) ./\ ( G .\/ ( ( R .\/ z ) ./\ W ) ) ) $.
    cdleme25cv.i $e |- I = ( iota_ u e. B A. s e. A
       ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) ) -> u = N ) ) $.
    cdleme25cv.e $e |- E = ( iota_ u e. B A. z e. A
       ( ( -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) -> u = O ) ) $.
    $( Change bound variables in ~ cdleme25c .  (Contributed by NM,
       2-Feb-2013.) $)
    cdleme25cv $p |- I = E $=
      ( cv wbr wn co wa wceq wi wral crio wcel breq1 notbid anbi12d oveq1 oveq2
      wb oveq1d oveq2d oveq12d eqeq2d imbi12d oveq1i oveq2i eqtri eqeq2i imbi2i
      cbvralv ralbii 3bitr4i a1i riotabiia 3eqtr4i ) SUFZRNUGZUHZVREFMUIZNUGZUH
      ZUJZBUFZPUKZULZSCUMZBDUNAUFZRNUGZUHZWIWANUGZUHZUJZWEQUKZULZACUMZBDUNLIWHW
      QBDWHWQVAWEDUOWDWEWAVRHMUIZFEVRMUIZROUIZMUIZOUIZGVRMUIZROUIZMUIZOUIZUKZUL
      ZSCUMWNWEWAWIHMUIZFEWIMUIZROUIZMUIZOUIZGWIMUIZROUIZMUIZOUIZUKZULZACUMWHWQ
      XHXSSACVRWIUKZWDWNXGXRXTVTWKWCWMXTVSWJVRWIRNUPUQXTWBWLVRWIWANUPUQURXTXFXQ
      WEXTXEXPWAOXTXBXMXDXOMXTWRXIXAXLOVRWIHMUSXTWTXKFMXTWSXJROVRWIEMUTVBVCVDXT
      XCXNROVRWIGMUTVBVDVCVEVFVLWGXHSCWFXGWDPXFWEPWAJXDMUIZOUIXFUAYAXEWAOJXBXDM
      TVGVHVIVJVKVMWPXSACWOXRWNQXQWEQWAKXOMUIZOUIXQUCYBXPWAOKXMXOMUBVGVHVIVJVKV
      MVNVOVPUDUEVQ $.
  $}

  ${
    cdleme26.b $e |- B = ( Base ` K ) $.
    cdleme26.l $e |- .<_ = ( le ` K ) $.
    cdleme26.j $e |- .\/ = ( join ` K ) $.
    cdleme26.m $e |- ./\ = ( meet ` K ) $.
    cdleme26.a $e |- A = ( Atoms ` K ) $.
    cdleme26.h $e |- H = ( LHyp ` K ) $.
    ${
      cdleme26e.u $e |- U
          = ( ( P .\/ Q ) ./\ W ) $.
      cdleme26e.f $e |- F
          = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
      cdleme26e.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( S .\/ z ) ./\ W ) ) ) $.
      cdleme26e.o $e |- O
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( T .\/ z ) ./\ W ) ) ) $.
      cdleme26e.i $e |- I = ( iota_ u e. B A. z e. A
       ( ( -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) -> u = N ) ) $.
      cdleme26e.e $e |- E = ( iota_ u e. B A. z e. A
       ( ( -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) -> u = O ) ) $.
      $d w z u A $.  $d w z u B $.  $d w E $.  $d w I $.  $d z H $.
      $d w z u .\/ $.  $d z K $.  $d w z u .<_ $.  $d z u ./\ $.  $d w u N $.
      $d w u O $.  $d w z u P $.  $d w z u Q $.  $d z u S $.  $d z u T $.
      $d z u U $.  $d w z u W $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 4th line
         on p. 115. ` F ` , ` N ` , ` O ` represent f(z), f_z(s), f_z(t)
         respectively.  When t ` \/ ` v = p ` \/ ` q, f_z(s) ` <_ ` f_z(t)
         ` \/ ` v.  TODO:  FIX COMMENT. (Contributed by NM, 2-Feb-2013.) $)
      cdleme26e $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
              /\ ( V e. A /\ V .<_ W ) )
           /\ ( ( P =/= Q /\ S .<_ ( P .\/ Q ) /\ T .<_ ( P .\/ Q ) )
              /\ ( ( T .\/ V ) = ( P .\/ Q ) /\ -. z .<_ ( P .\/ Q ) )
              /\ ( z e. A /\ -. z .<_ W ) ) )
            -> I .<_ ( E .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne wceq simp11 simp12 simp13 simp21l simp22l
        co cv simp23 simp311 simp32l simp33 cdleme22e syl133anc simp21r simp312
        jca cdleme25cl simp33l simp33r simp32r cbs cfv cvv fvex eqeltri riotasv
        syl322anc syl3anc simp22r simp313 oveq1d 3brtr4d ) OUNUOUALUOUPZECUOEUA
        PUQURUPZFCUOFUAPUQURUPZUSZGCUOZGUAPUQURZUPZHCUOZHUAPUQURZUPZTCUOTUAPUQU
        PZUSZEFUTZGEFNVGZPUQZHXGPUQZUSZHTNVGXGVAZAVHZXGPUQURZUPZXLCUOZXLUAPUQUR
        ZUPZUSZUSZRSTNVGZMJTNVGPXSWNWOWPWRXAUPXDXFXKUPXQRXTPUQWNWOWPXEXRVBZWNWO
        WPXEXRVCZWNWOWPXEXRVDZXSWRXAWRWSXCXDWQXRVEZXAXBWTXDWQXRVFZVQWQWTXCXDXRV
        IXSXFXKXFXHXIXNXQWQXEVJZXKXMXJXQWQXEVKVQWQXEXJXNXQVLACEFGHIKLNOPQRSTUAU
        CUDUEUFUGUHUIUJUKVMVNXSMDUOZXOXPXMUPZMRVAXSWNWOWPWRWSXFXHYGYAYBYCYDWRWS
        XCXDWQXRVOYFXFXHXIXNXQWQXEVPBCDEFGIKLMNOPQRUAAUBUCUDUEUFUGUHUIUJULVRWHX
        OXPXJXNWQXEVSZXSXPXMXOXPXJXNWQXEVTXKXMXJXQWQXEWAVQZYHBADCRMDOWBWCWDUBOW
        BWEWFZULWGWIXSJSTNXSJDUOZXOYHJSVAXSWNWOWPXAXBXFXIYLYAYBYCYEXAXBWTXDWQXR
        WJYFXFXHXIXNXQWQXEWKBCDEFHIKLJNOPQSUAAUBUCUDUEUFUGUHUIUKUMVRWHYIYJYHBAD
        CSJYKUMWGWIWLWM $.

      $d w z V $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 4th line
         on p. 115. ` F ` , ` N ` , ` O ` represent f(z), f_z(s), f_z(t)
         respectively.  When t ` \/ ` v = p ` \/ ` q, f_z(s) ` <_ ` f_z(t)
         ` \/ ` v.  TODO:  FIX COMMENT. (Contributed by NM, 2-Feb-2013.) $)
      cdleme26ee $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( T e. A /\ -. T .<_ W )
              /\ ( V e. A /\ V .<_ W ) )
           /\ ( ( P =/= Q /\ S .<_ ( P .\/ Q ) /\ T .<_ ( P .\/ Q ) )
              /\ ( T .\/ V ) = ( P .\/ Q ) ) )
            -> I .<_ ( E .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a co wceq cv wrex simp11l simp11r simp12 simp13
        wne simp3l1 cdlemb2 syl221anc nfv wi wral crio nfcv nfriota nfcxfr nfov
        nfbr simp111 simp112 simp113 simp121 simp122 simp123 simp13l simp3r jca
        nfra1 simp13r simp2 simp3l cdleme26e syl333anc 3exp rexlimd mpd ) OUNUO
        ZUALUOZUPZECUOEUAPUQURUPZFCUOFUAPUQURUPZUSZGCUOGUAPUQURUPZHCUOHUAPUQURU
        PZTCUOTUAPUQUPZUSZEFVHZGEFNUTZPUQZHXJPUQZUSZHTNUTXJVAZUPZUSZAVBZUAPUQUR
        ZXQXJPUQURZUPZACVCZMJTNUTZPUQZXPWSWTXBXCXIYAWSWTXBXCXHXOVDWSWTXBXCXHXOV
        EXAXBXCXHXOVFXAXBXCXHXOVGXIXKXLXNXDXHVICEFLNOPUAAUCUDUFUGVJVKXPXTYCACXP
        AVLAMYBPAMXTBVBZRVAVMZACVNZBDVOULYFABDYEACWJADVPZVQVRAPVPAJTNAJXTYDSVAV
        MZACVNZBDVOUMYIABDYHACWJYGVQVRANVPATVPVSVTXPXQCUOZXTYCXPYJXTUSZXAXBXCXE
        XFXGXMXNXSUPYJXRUPYCXAXBXCXHXOYJXTWAXAXBXCXHXOYJXTWBXAXBXCXHXOYJXTWCXEX
        FXGXDXOYJXTWDXEXFXGXDXOYJXTWEXEXFXGXDXOYJXTWFXMXNXDXHYJXTWGYKXNXSXMXNXD
        XHYJXTWKXPYJXRXSWHWIYKYJXRXPYJXTWLXPYJXRXSWMWIABCDEFGHIJKLMNOPQRSTUAUBU
        CUDUEUFUGUHUIUJUKULUMWNWOWPWQWR $.
    $}

    ${
      cdleme26eALT.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme26eALT.f $e |- F
          = ( ( y .\/ U ) ./\ ( Q .\/ ( ( P .\/ y ) ./\ W ) ) ) $.
      cdleme26eALT.g $e |- G
          = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
      cdleme26eALT.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( S .\/ y ) ./\ W ) ) ) $.
      cdleme26eALT.o $e |- O
          = ( ( P .\/ Q ) ./\ ( G .\/ ( ( T .\/ z ) ./\ W ) ) ) $.
      cdleme26eALT.i $e |- I = ( iota_ u e. B A. y e. A
       ( ( -. y .<_ W /\ -. y .<_ ( P .\/ Q ) ) -> u = N ) ) $.
      cdleme26eALT.e $e |- E = ( iota_ u e. B A. z e. A
       ( ( -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) -> u = O ) ) $.
      $d y z u A $.  $d y z u B $.  $d y z H $.  $d y z u .\/ $.  $d y z K $.
      $d y z u .<_ $.  $d y z u ./\ $.  $d u N $.  $d u O $.  $d y z u P $.
      $d y z u Q $.  $d y u S $.  $d z u T $.  $d y z u U $.  $d y z u W $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 4th line
         on p. 115. ` F ` , ` N ` , ` O ` represent f(z), f_z(s), f_z(t)
         respectively.  When t ` \/ ` v = p ` \/ ` q, f_z(s) ` <_ ` f_z(t)
         ` \/ ` v.  TODO:  FIX COMMENT. (Contributed by NM, 1-Feb-2013.)
         (New usage is discouraged.) $)
      cdleme26eALTN $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q
              /\ ( S e. A /\ -. S .<_ W /\ S .<_ ( P .\/ Q ) )
              /\ ( T e. A /\ -. T .<_ W /\ T .<_ ( P .\/ Q ) ) )
           /\ ( ( V e. A /\ V .<_ W /\ ( T .\/ V ) = ( P .\/ Q ) )
               /\ ( y e. A /\ -. y .<_ W /\ -. y .<_ ( P .\/ Q ) )
               /\ ( z e. A /\ -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) ) )
            -> I .<_ ( E .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne co wceq cv simp11l simp11r simp231 simp12
        simp13 simp21 simp221 simp31 3ad2ant3 simp322 simp332 jca cdleme22eALTN
        jca31 syl333anc simp11 simp222 simp223 cdleme25cl syl322anc simp323 cbs
        cfv cvv fvex eqeltri riotasv syl112anc simp232 simp233 simp333 3brtr4d
        oveq1d ) QUQURZUCNURZUSZFDURFUCRUTVAUSZGDURGUCRUTVAUSZVBZFGVCZHDURZHUCR
        UTVAZHFGPVDZRUTZVBZIDURZIUCRUTVAZIXIRUTZVBZVBZUBDURUBUCRUTIUBPVDXIVEVBZ
        AVFZDURZXRUCRUTVAZXRXIRUTVAZVBZBVFZDURZYCUCRUTVAZYCXIRUTVAZVBZVBZVBZTUA
        UBPVDZOKUBPVDRYIWTXAXLXCXDXFXGXQXSXTUSYDYEUSZUSTYJRUTWTXAXCXDXPYHVGWTXA
        XCXDXPYHVHXLXMXNXFXKXEYHVIZXBXCXDXPYHVJZXBXCXDXPYHVKZXEXFXKXOYHVLZXGXHX
        JXFXOXEYHVMZXEXPXQYBYGVNYIXSXTYKYHXEXSXPXQXSXTYAYGVLVOZXSXTYAXQYGXEXPVP
        ZYIYDYEYHXEYDXPXQYBYDYEYFVNVOZYDYEYFXQYBXEXPVQZVRVTABDFGHIJLMNPQRSTUAUB
        UCUEUFUGUHUIUJUKULUMUNVSWAYIOEURZXSXTYAOTVEYIXBXCXDXGXHXFXJUUAXBXCXDXPY
        HWBZYMYNYPXGXHXJXFXOXEYHWCYOXGXHXJXFXOXEYHWDCDEFGHJLNOPQRSTUCAUDUEUFUGU
        HUIUJUKUMUOWEWFYQYRXSXTYAXQYGXEXPWGXTYAUSCAEDTOEQWHWIWJUDQWHWKWLZUOWMWN
        YIKUAUBPYIKEURZYDYEYFKUAVEYIXBXCXDXLXMXFXNUUDUUBYMYNYLXLXMXNXFXKXEYHWOY
        OXLXMXNXFXKXEYHWPCDEFGIJMNKPQRSUAUCBUDUEUFUGUHUIUJULUNUPWEWFYSYTYDYEYFX
        QYBXEXPWQYEYFUSCBEDUAKUUCUPWMWNWSWR $.
    $}

    ${
      $d t u A $.  $d t u B $.  $d t H $.  $d t u .\/ $.  $d t K $.
      $d t u .<_ $.  $d t u ./\ $.  $d u N $.  $d t u P $.  $d t u Q $.
      $d t u S $.  $d t u U $.  $d t u W $.
      cdleme26f.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme26f.f $e |- F
          = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
      cdleme26f.n $e |- N
          = ( ( P .\/ Q ) ./\ ( F .\/ ( ( S .\/ t ) ./\ W ) ) ) $.
      cdleme26f.i $e |- I = ( iota_ u e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> u = N ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 6th and
         7th lines on p. 115. ` F ` , ` N ` represent f(t), f_t(s)
         respectively.  If t ` <_ ` t ` \/ ` v, then f_t(s) ` <_ ` f(t) ` \/ `
         v.  TODO:  FIX COMMENT. (Contributed by NM, 1-Feb-2013.)
         (New usage is discouraged.) $)
      cdleme26fALTN $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P =/= Q /\ S .<_ ( P .\/ Q ) )
              /\ ( t e. A /\ -. t .<_ W ) )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
              /\ ( S e. A /\ -. S .<_ W ) )
           /\ ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) )
               /\ ( S =/= t /\ S .<_ ( t .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> I .<_ ( F .\/ V ) ) $=
        ( chlt wcel wa wne co wbr w3a wceq simp11 simp21 simp22 simp23l simp23r
        cv simp12l simp12r cdleme25cl syl322anc simp13l simp31 cbs cfv cvv fvex
        wn eqeltri riotasv syl3anc simp23 simp33 cdleme22f syl331anc eqbrtrd
        simp32 ) MUIUJRJUJUKZEFULZGEFLUMZNUNZUKZBVBZCUJZWHRNUNVMZUKZUOZECUJERNU
        NVMUKZFCUJFRNUNVMUKZGCUJZGRNUNVMZUKZUOZWJWHWENUNVMUKZGWHULGWHQLUMNUNUKZ
        QCUJQRNUNUKZUOZUOZKPIQLUMZNXCKDUJZWIWSKPUPXCWCWMWNWOWPWDWFXEWCWGWKWRXBU
        QZWLWMWNWQXBURZWLWMWNWQXBUSZWOWPWMWNWLXBUTWOWPWMWNWLXBVAWDWFWCWKWRXBVCW
        DWFWCWKWRXBVDACDEFGHIJKLMNOPRBSTUAUBUCUDUEUFUGUHVEVFWIWJWCWGWRXBVGZWLWR
        WSWTXAVHWSABDCPKDMVIVJVKSMVIVLVNUHVOVPXCWCWMWNWQWIXAWTPXDNUNXFXGXHWLWMW
        NWQXBVQXIWLWRWSWTXAVRWLWRWSWTXAWBCEFGWHHIJLMNOPQRTUAUBUCUDUEUFUGVSVTWA
        $.

      $( Part of proof of Lemma E in [Crawley] p. 113, 3rd paragraph, 6th and
         7th lines on p. 115. ` F ` , ` N ` represent f(t), f_t(s)
         respectively.  If t ` <_ ` t ` \/ ` v, then f_t(s) ` <_ ` f(t) ` \/ `
         v.  TODO:  FIX COMMENT. (Contributed by NM, 1-Feb-2013.) $)
      cdleme26f $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P =/= Q /\ S .<_ ( P .\/ Q ) )
              /\ ( t e. A /\ -. t .<_ W ) )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
              /\ ( S e. A /\ -. S .<_ W ) )
           /\ ( -. t .<_ ( P .\/ Q )
               /\ ( S =/= t /\ S .<_ ( t .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> I .<_ ( F .\/ V ) ) $=
        ( chlt wcel wa wne co wbr w3a wceq simp11 simp21 simp22 simp23l simp23r
        simp12l simp12r cdleme25cl syl322anc simp13l simp13r simp31 cbs cfv cvv
        fvex eqeltri riotasv syl112anc simp23 simp33 simp32 cdleme22f syl331anc
        cv wn eqbrtrd ) MUIUJRJUJUKZEFULZGEFLUMZNUNZUKZBWAZCUJZWIRNUNWBZUKZUOZE
        CUJERNUNWBUKZFCUJFRNUNWBUKZGCUJZGRNUNWBZUKZUOZWIWFNUNWBZGWIULGWIQLUMNUN
        UKZQCUJQRNUNUKZUOZUOZKPIQLUMZNXDKDUJZWJWKWTKPUPXDWDWNWOWPWQWEWGXFWDWHWL
        WSXCUQZWMWNWOWRXCURZWMWNWOWRXCUSZWPWQWNWOWMXCUTWPWQWNWOWMXCVAWEWGWDWLWS
        XCVBWEWGWDWLWSXCVCACDEFGHIJKLMNOPRBSTUAUBUCUDUEUFUGUHVDVEWJWKWDWHWSXCVF
        ZWJWKWDWHWSXCVGWMWSWTXAXBVHWKWTUKABDCPKDMVIVJVKSMVIVLVMUHVNVOXDWDWNWOWR
        WJXBXAPXENUNXGXHXIWMWNWOWRXCVPXJWMWSWTXAXBVQWMWSWTXAXBVRCEFGWIHIJLMNOPQ
        RTUAUBUCUDUEUFUGVSVTWC $.
    $}

    ${
      $d s u A $.  $d s u B $.  $d s H $.  $d s u .\/ $.  $d s K $.
      $d s u .<_ $.  $d s u ./\ $.  $d u O $.  $d s u P $.  $d s u Q $.
      $d s u T $.  $d s u U $.  $d s u W $.
      cdleme26f2.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      cdleme26f2.f $e |- G
          = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
      cdleme26f2.n $e |- O
          = ( ( P .\/ Q ) ./\ ( G .\/ ( ( T .\/ s ) ./\ W ) ) ) $.
      cdleme26f2.e $e |- E = ( iota_ u e. B A. s e. A
       ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) ) -> u = O ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113. ~ cdleme26fALTN with s
         and t swapped (this case is not mentioned by them).  If s ` <_ ` t
         ` \/ ` v, then f(s) ` <_ ` f_s(t) ` \/ ` v.  TODO:  FIX COMMENT.
         (Contributed by NM, 1-Feb-2013.)  (New usage is discouraged.) $)
      cdleme26f2ALTN $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P =/= Q /\ T .<_ ( P .\/ Q ) )
              /\ ( s e. A /\ -. s .<_ W ) )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
              /\ ( T e. A /\ -. T .<_ W ) )
           /\ ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) )
               /\ ( s =/= T /\ s .<_ ( T .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> G .<_ ( E .\/ V ) ) $=
        ( chlt wcel wa wne co wbr cv wn w3a simp11 simp31r simp12r simp12l 3jca
        simp23 simp21 simp22 simp13 simp32 cdleme22f2 syl323anc simp23l simp23r
        simp33 wceq cdleme25cl syl322anc simp13l simp31 cbs cfv eqeltri riotasv
        cvv fvex syl3anc oveq1d breqtrrd ) LUIUJQJUJUKZDEULZFDEKUMZMUNZUKZRUOZB
        UJZWLQMUNUPZUKZUQZDBUJDQMUNUPUKZEBUJEQMUNUPUKZFBUJZFQMUNUPZUKZUQZWNWLWI
        MUNUPZUKZWLFULWLFPKUMMUNUKZPBUJPQMUNUKZUQZUQZIOPKUMZHPKUMMXHWGXAXCWJWHU
        QWQWRWOXEXFIXIMUNWGWKWOXBXGURZWPWQWRXAXGVCXHXCWJWHWNXCXEXFWPXBUSWHWJWGW
        OXBXGUTZWHWJWGWOXBXGVAZVBWPWQWRXAXGVDZWPWQWRXAXGVEZWGWKWOXBXGVFWPXBXDXE
        XFVGWPXBXDXEXFVLBDEWLFGIJKLMNOPQTUAUBUCUDUEUFUGVHVIXHHOPKXHHCUJZWMXDHOV
        MXHWGWQWRWSWTWHWJXOXJXMXNWSWTWQWRWPXGVJWSWTWQWRWPXGVKXLXKABCDEFGIJHKLMN
        OQRSTUAUBUCUDUEUFUGUHVNVOWMWNWGWKXBXGVPWPXBXDXEXFVQXDARCBOHCLVRVSWBSLVR
        WCVTUHWAWDWEWF $.

      $( Part of proof of Lemma E in [Crawley] p. 113. ~ cdleme26fALTN with s
         and t swapped (this case is not mentioned by them).  If s ` <_ ` t
         ` \/ ` v, then f(s) ` <_ ` f_s(t) ` \/ ` v.  TODO:  FIX COMMENT.
         (Contributed by NM, 1-Feb-2013.) $)
      cdleme26f2 $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P =/= Q /\ T .<_ ( P .\/ Q ) )
              /\ ( s e. A /\ -. s .<_ W ) )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
              /\ ( T e. A /\ -. T .<_ W ) )
           /\ ( -. s .<_ ( P .\/ Q )
               /\ ( s =/= T /\ s .<_ ( T .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> G .<_ ( E .\/ V ) ) $=
        ( chlt wcel wa wne co wbr w3a simp11 simp23 simp31 simp12r simp12l 3jca
        cv simp21 simp22 simp13 simp32 simp33 cdleme22f2 syl323anc wceq simp23l
        wn simp23r cdleme25cl syl322anc simp13l simp13r cbs cfv eqeltri riotasv
        cvv fvex syl112anc oveq1d breqtrrd ) LUIUJQJUJUKZDEULZFDEKUMZMUNZUKZRVB
        ZBUJZWLQMUNVLZUKZUOZDBUJDQMUNVLUKZEBUJEQMUNVLUKZFBUJZFQMUNVLZUKZUOZWLWI
        MUNVLZWLFULWLFPKUMMUNUKZPBUJPQMUNUKZUOZUOZIOPKUMZHPKUMMXGWGXAXCWJWHUOWQ
        WRWOXDXEIXHMUNWGWKWOXBXFUPZWPWQWRXAXFUQXGXCWJWHWPXBXCXDXEURZWHWJWGWOXBX
        FUSZWHWJWGWOXBXFUTZVAWPWQWRXAXFVCZWPWQWRXAXFVDZWGWKWOXBXFVEWPXBXCXDXEVF
        WPXBXCXDXEVGBDEWLFGIJKLMNOPQTUAUBUCUDUEUFUGVHVIXGHOPKXGHCUJZWMWNXCHOVJX
        GWGWQWRWSWTWHWJXOXIXMXNWSWTWQWRWPXFVKWSWTWQWRWPXFVMXLXKABCDEFGIJHKLMNOQ
        RSTUAUBUCUDUEUFUGUHVNVOWMWNWGWKXBXFVPWMWNWGWKXBXFVQXJWNXCUKARCBOHCLVRVS
        WBSLVRWCVTUHWAWDWEWF $.
    $}

    $d s t u z A $.  $d s t u z B $.  $d u F $.  $d u G $.  $d s t z H $.
    $d s t u z .\/ $.  $d s t z K $.  $d s t u z .<_ $.  $d s t u z ./\ $.
    $d t u N $.  $d s u O $.  $d s t u z P $.  $d s t u z Q $.  $d s t u z U $.
    $d z V $.  $d s t u z W $.
    cdleme27.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme27.f $e |- F
     = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme27.z $e |- Z
     = ( ( z .\/ U ) ./\ ( Q .\/ ( ( P .\/ z ) ./\ W ) ) ) $.
    cdleme27.n $e |- N
     = ( ( P .\/ Q ) ./\ ( Z .\/ ( ( s .\/ z ) ./\ W ) ) ) $.
    cdleme27.d $e |- D = ( iota_ u e. B A. z e. A
       ( ( -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) -> u = N ) ) $.
    cdleme27.c $e |- C = if ( s .<_ ( P .\/ Q ) , D , F ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Closure of ` C ` .
       (Contributed by NM, 6-Feb-2013.) $)
    cdleme27cl $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( ( s e. A /\ -. s .<_ W ) /\ P =/= Q ) ) -> C e. B ) $=
      ( chlt wa wbr wn cv wne w3a co cif simpl1 simpl2l simpl2r simpl3l simpl3r
      simpr cdleme25cl syl312anc simp1l simp1r simp2ll simp2rl simp3ll cdleme1b
      wcel syl23anc adantr ifclda syl5eqel ) MULVOZQKVOZUMZGCVOZGQNUNUOZUMZHCVO
      ZHQNUNUOZUMZUMZSUPZCVOZWJQNUNUOZUMZGHUQZUMZURZEWJGHLUSNUNZFJUTDUKWPWQFJDW
      PWQUMWBWEWHWMWNWQFDVOWBWIWOWQVAWEWHWBWOWQVBWEWHWBWOWQVCWMWNWBWIWQVDWMWNWB
      WIWQVEWPWQVFBCDGHWJIRKFLMNOPQATUAUBUCUDUEUFUHUIUJVGVHWPJDVOZWQUOWPVTWAWCW
      FWKWRVTWAWIWOVIVTWAWIWOVJWCWDWHWBWOVKWFWGWEWBWOVLWKWLWNWBWIVMCDGHWJIJKLMN
      OQUAUBUCUDUEUFUGTVNVPVQVRVS $.

    $d s X $.

    ${
      cdleme27.g $e |- G
          = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
      cdleme27.o $e |- O
          = ( ( P .\/ Q ) ./\ ( Z .\/ ( ( t .\/ z ) ./\ W ) ) ) $.
      cdleme27.e $e |- E = ( iota_ u e. B A. z e. A
       ( ( -. z .<_ W /\ -. z .<_ ( P .\/ Q ) ) -> u = O ) ) $.
      cdleme27.y $e |- Y = if ( t .<_ ( P .\/ Q ) , E , G ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113. ~ cdleme26f with s and t
         swapped (this case is not mentioned by them).  If s ` <_ ` t ` \/ ` v,
         then f(s) ` <_ ` f_s(t) ` \/ ` v.  TODO:  FIX COMMENT. (Contributed by
         NM, 3-Feb-2013.) $)
      cdleme27a $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ P =/= Q
              /\ ( s e. A /\ -. s .<_ W ) )
           /\ ( ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W )
              /\ ( t e. A /\ -. t .<_ W ) )
           /\ ( ( s =/= t /\ s .<_ ( t .\/ V ) )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> C .<_ ( Y .\/ V ) ) $=
        ( cv co wbr chlt wcel wa wne wn wi wceq simp211 simp221 simp222 simp213
        simp223 simp23r simp212 simp1l simp1r simp3 cdleme26ee syl332anc 3expia
        3jca simp11l 3ad2ant2 simp13l simp23l simp3ll simp21l simp22l cdleme22b
        w3a simp3rl simp3lr syl232anc pm2.21dd pm2.61dne iftrue syl5eq ad2antrr
        cif oveq1d ad2antlr 3brtr4d simpr11 simpr12 jca simpr23 simpr21 simpr22
        ex simpll simpr13 simplr simpr3l simpr3r eqid wral cdleme25cv cdleme26f
        crio syl333anc iffalse cdleme26f2 cdleme22g syl323anc 4cases ) UEVBZHIO
        VCZQVDZCVBZYKQVDZPVEVFZUBNVFZVGZHIVHZYJDVFZYJUBQVDVIZVGZWNZHDVFZHUBQVDV
        IZVGZIDVFZIUBQVDVIZVGZYMDVFZYMUBQVDVIZVGZWNZYJYMVHZYJYMUAOVCZQVDZVGZUAD
        VFZUAUBQVDZVGZVGZWNZFUCUAOVCZQVDZVJYLYNVGZUVAUVCUVDUVAVGZGKUAOVCZFUVBQU
        VEGUVFQVDZUUNYKUVDUVAUUNYKVKZUVGUVDUVAUVHWNZYQUUEUUHUUAUUKUUSYRYLYNWNUV
        HUVGYQYRUUAUULUUTUVDUVHVLUUEUUHUUKUUBUUTUVDUVHVMUUEUUHUUKUUBUUTUVDUVHVN
        YQYRUUAUULUUTUVDUVHVOUUEUUHUUKUUBUUTUVDUVHVPUUPUUSUUBUULUVDUVHVQUVIYRYL
        YNYQYRUUAUULUUTUVDUVHVRYLYNUVAUVHVSYLYNUVAUVHVTWEUVDUVAUVHWAABDEHIYJYMJ
        KUDNGOPQRSTUAUBUFUGUHUIUJUKULUNUOUSUPUTWBWCWDUVDUVAUUNYKVHZUVGUVDUVAUVJ
        WNZYNUVGYLYNUVAUVJVTUVKYOYSUUIUUMWNUUCUUFYRUUQUVJUUOYLWNYNVIZUVAUVDYOUV
        JYOYPYRUUAUULUUTWFWGUVKYSUUIUUMUVAUVDYSUVJYSYTYQYRUULUUTWHWGUVAUVDUUIUV
        JUUIUUJUUEUUHUUBUUTWIWGUVAUVDUUMUVJUUMUUOUUSUUBUULWJWGWEUVAUVDUUCUVJUUC
        UUDUUHUUKUUBUUTWKWGUVAUVDUUFUVJUUFUUGUUEUUKUUBUUTWLWGYQYRUUAUULUUTUVDUV
        JVRUVAUVDUUQUVJUUQUURUUPUUBUULWOWGUVKUVJUUOYLUVDUVAUVJWAUVAUVDUUOUVJUUM
        UUOUUSUUBUULWPWGYLYNUVAUVJVSWEDHIYJYMNOPQRUAUGUHUIUJUKWMWQWRWDWSYLFGVKZ
        YNUVAYLFYLGLXCZGUQYLGLWTXAZXBYNUVBUVFVKZYLUVAYNUCKUAOYNUCYNKMXCZKVAYNKM
        WTXAXDZXEXFXMYLUVLVGZUVAUVCUVSUVAVGZGMUAOVCZFUVBQUVTYQYRYLVGUUKUUEUUHUU
        AUVLUUPUUSGUWAQVDYQYRUUAUULUUTUVSXGUVTYRYLYQYRUUAUULUUTUVSXHYLUVLUVAXNX
        IUUEUUHUUKUUBUUTUVSXJUUEUUHUUKUUBUUTUVSXKUUEUUHUUKUUBUUTUVSXLYQYRUUAUUL
        UUTUVSXOYLUVLUVAXPUUPUUSUUBUULUVSXQUUPUUSUUBUULUVSXRBCDEHIYJJMNGOPQRYKM
        YJYMOVCUBRVCOVCRVCZUAUBUFUGUHUIUJUKULURUWBXSZCBDEHIYJJUUJUVLVGBVBZUWBVK
        VJCDXTBEYCZUDMGOQRSUWBUBAUNUOURUWCUPUWEXSYAYBYDYLUVMUVLUVAUVOXBUVLUVBUW
        AVKZYLUVAUVLUCMUAOUVLUCUVQMVAYNKMYEXAXDZXEXFXMYLVIZYNVGZUVAUVCUWIUVAVGZ
        LUVFFUVBQUWJYQYRYNVGUUAUUEUUHUUKUWHUUPUUSLUVFQVDYQYRUUAUULUUTUWIXGUWJYR
        YNYQYRUUAUULUUTUWIXHUWHYNUVAXPXIYQYRUUAUULUUTUWIXOUUEUUHUUKUUBUUTUWIXKU
        UEUUHUUKUUBUUTUWIXLUUEUUHUUKUUBUUTUWIXJUWHYNUVAXNUUPUUSUUBUULUWIXQUUPUU
        SUUBUULUWIXRBDEHIYMJKLNOPQRYKLYMYJOVCUBRVCOVCRVCZUAUBUEUFUGUHUIUJUKULUM
        UWKXSZUEBDEHIYMJYTUWHVGUWDUWKVKVJUEDXTBEYCZUDLKOQRTUWKUBAUNUSUMUWLUTUWM
        XSYAYFYDUWHFLVKZYNUVAUWHFUVNLUQYLGLYEXAZXBYNUVPUWHUVAUVRXEXFXMUWHUVLVGZ
        UVAUVCUWPUVAVGZLUWAFUVBQUWQYQUUKUVLUWHYRWNUUEUUHUUAUUPUUSLUWAQVDYQYRUUA
        UULUUTUWPXGUUEUUHUUKUUBUUTUWPXJUWQUVLUWHYRUWHUVLUVAXPUWHUVLUVAXNYQYRUUA
        UULUUTUWPXHWEUUEUUHUUKUUBUUTUWPXKUUEUUHUUKUUBUUTUWPXLYQYRUUAUULUUTUWPXO
        UUPUUSUUBUULUWPXQUUPUUSUUBUULUWPXRDHIYJYMJLMNOPQRUAUBUGUHUIUJUKULUMURYG
        YHUWHUWNUVLUVAUWOXBUVLUWFUWHUVAUWGXEXFXMYI $.

      $( Lemma for ~ cdleme27N .  (Contributed by NM, 3-Feb-2013.) $)
      cdleme27b $p |- ( s = t -> C = Y ) $=
        ( cv wceq co wbr cif breq1 wn wa wral crio oveq1d oveq2d 3eqtr4g eqeq2d
        wi oveq1 imbi2d ralbidv riotabidv oveq2 oveq12d ifbieq12d ) UDVAZCVAZVB
        ZWCHIOVCZQVDZGLVEWDWFQVDZKMVEFUBWEWGWHGLKMWCWDWFQVFWEAVAZUAQVDVGWIWFQVD
        VGVHZBVAZSVBZVOZADVIZBEVJWJWKTVBZVOZADVIZBEVJGKWEWNWQBEWEWMWPADWEWLWOWJ
        WESTWKWEWFUCWCWIOVCZUARVCZOVCZRVCWFUCWDWIOVCZUARVCZOVCZRVCSTWEWTXCWFRWE
        WSXBUCOWEWRXAUARWCWDWIOVPVKVLVLUNURVMVNVQVRVSUOUSVMWEWCJOVCZIHWCOVCZUAR
        VCZOVCZRVCWDJOVCZIHWDOVCZUARVCZOVCZRVCLMWEXDXHXGXKRWCWDJOVPWEXFXJIOWEXE
        XIUARWCWDHOVTVKVLWAULUQVMWBUPUTVM $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Eliminate the
         ` s =/= t ` antecedent in ~ cdleme27a .  (Contributed by NM,
         3-Feb-2013.)  (New usage is discouraged.) $)
      cdleme27N $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ P =/= Q
              /\ ( s e. A /\ -. s .<_ W ) )
           /\ ( ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W )
              /\ ( t e. A /\ -. t .<_ W ) )
           /\ ( s .<_ ( t .\/ V )
               /\ ( V e. A /\ V .<_ W ) ) )
            -> C .<_ ( Y .\/ V ) ) $=
        ( chlt wcel wa wne cv wbr wn w3a co wceq cdleme27b adantl simp11l hllat
        simp11r simp21 simp22 simp23 simp12 cdleme27cl syl222anc simp3rl atbase
        clat syl latlej1 syl3anc adantr eqbrtrd simpl11 simpl12 simpl13 simpl21
        simpl22 simpl23 simpr simpl3l simpl3r cdleme27a syl332anc pm2.61dane
        jca ) PVBVCZUBNVCZVDZHIVEZUEVFZDVCXHUBQVGVHVDZVIZHDVCHUBQVGVHVDZIDVCIUB
        QVGVHVDZCVFZDVCXMUBQVGVHVDZVIZXHXMUAOVJQVGZUADVCZUAUBQVGZVDZVDZVIZFUCUA
        OVJZQVGZXHXMYAXHXMVKZVDFUCYBQYDFUCVKYAABCDEFGHIJKLMNOPQRSTUBUCUDUEUFUGU
        HUIUJUKULUMUNUOUPUQURUSUTVAVLVMYAUCYBQVGZYDYAPWEVCZUCEVCZUAEVCZYEYAXDYF
        XDXEXGXIXOXTVNZPVOWFYAXDXEXKXLXNXGYGYIXDXEXGXIXOXTVPXJXKXLXNXTVQXJXKXLX
        NXTVRXJXKXLXNXTVSXFXGXIXOXTVTABDEUCKHIJMNOPQRTUBUDCUFUGUHUIUJUKULURUNUS
        UTVAWAWBYAXQYHXQXRXPXJXOWCDEUAPUFUJWDWFEOPQUCUAUFUGUHWGWHWIWJYAXHXMVEZV
        DZXFXGXIXKXLXNYJXPVDXSYCXFXGXIXOXTYJWKXFXGXIXOXTYJWLXFXGXIXOXTYJWMXKXLX
        NXJXTYJWNXKXLXNXJXTYJWOXKXLXNXJXTYJWPYKYJXPYAYJWQXPXSXJXOYJWRXCXPXSXJXO
        YJWSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAWTXAX
        B $.

      ${
        cdleme28a.v $e |- V = ( ( s .\/ t ) ./\ ( X ./\ W ) ) $.
        $( Lemma for ~ cdleme25b .  TODO:  FIX COMMENT (Contributed by NM,
           4-Feb-2013.) $)
        cdleme28a $p |- ( ( ( ( K e. HL /\ W e. H )
                /\ ( P e. A /\ -. P .<_ W )
                /\ ( Q e. A /\ -. Q .<_ W ) )
             /\ ( P =/= Q
                /\ ( s e. A /\ -. s .<_ W )
                /\ ( t e. A /\ -. t .<_ W ) )
             /\ ( s =/= t
                /\ ( ( s .\/ ( X ./\ W ) ) = X
                 /\ ( t .\/ ( X ./\ W ) ) = X )
                /\ ( X e. B /\ -. X .<_ W ) ) )
              -> ( C .\/ ( X ./\ W ) ) .<_ ( Y .\/ ( X ./\ W ) ) ) $=
          ( chlt wcel wa wbr wn w3a wne cv co wceq simp11l hllat simp11r simp12
          clat syl simp13 simp22 simp21 cdleme27cl syl222anc simp23 simp11 3jca
          simp33 simp31 simp32l simp32r cdleme23b syl3anc atbase latjcl simp33l
          lhpbase cdleme23c cdleme23a cdleme27a simp22l simp23l hlatjcl latmle2
          latmcl jca syl332anc syl5eqbr wi latjlej2 syl13anc mpd lattrd latlej2
          wb latjle12 mpbi2and ) PVDVEZUBNVEZVFZHDVEHUBQVGVHVFZIDVEIUBQVGVHVFZV
          IZHIVJZUFVKZDVEZYEUBQVGVHZVFZCVKZDVEZYIUBQVGVHZVFZVIZYEYIVJZYEUCUBRVL
          ZOVLUCVMZYIYOOVLUCVMZVFZUCEVEZUCUBQVGVHZVFZVIZVIZFUDYOOVLZQVGZYOUUDQV
          GZFYOOVLUUDQVGZUUCEPQFUDUAOVLZUUDUGUHUUCXRPVRVEZXRXSYAYBYMUUBVNZPVOVS
          ZUUCXRXSYAYBYHYDFEVEZUUJXRXSYAYBYMUUBVPZXTYAYBYMUUBVQZXTYAYBYMUUBVTZY
          CYDYHYLUUBWAZYCYDYHYLUUBWBZABDEFGHIJLNOPQRSUBUEUFUGUHUIUJUKULUMUNUOUP
          UQURWCWDZUUCUUIUDEVEZUAEVEZUUHEVEUUKUUCXRXSYAYBYLYDUUSUUJUUMUUNUUOYCY
          DYHYLUUBWEZUUQABDEUDKHIJMNOPQRTUBUECUGUHUIUJUKULUMUSUOUTVAVBWCWDZUUCU
          ADVEZUUTUUCXTYHYLVIZUUAYNYPYQVIZUVCUUCXTYHYLXTYAYBYMUUBWFZUUPUVAWGZYC
          YMYNYRUUAWHZUUCYNYPYQYCYMYNYRUUAWIZYPYQYNUUAYCYMWJYPYQYNUUAYCYMWKWGZD
          EYEYINOPQRUAUBUCUGUHUIUJUKULVCWLWMZDEUAPUGUKWNVSZEOPUDUAUGUIWOWMUUCUU
          IUUSYOEVEZUUDEVEZUUKUVBUUCUUIYSUBEVEZUVMUUKYSYTYNYRYCYMWPUUCXSUVOUUME
          NPUBUGULWQVSEPRUCUBUGUJXEWMZEOPUDYOUGUIWOWMZUUCXTYDYHYAYBYLYNYEYIUAOV
          LQVGZVFUVCUAUBQVGZVFFUUHQVGUVFUUQUUPUUNUUOUVAUUCYNUVRUVIUUCUVDUUAUVEU
          VRUVGUVHUVJDEYEYINOPQRUAUBUCUGUHUIUJUKULVCWRWMXFUUCUVCUVSUVKUUCUVDUUA
          UVEUVSUVGUVHUVJDEYEYINOPQRUAUBUCUGUHUIUJUKULVCWSWMXFABCDEFGHIJKLMNOPQ
          RSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBWTXGUUCUAYOQVGZUUHUUDQVG
          ZUUCUAYEYIOVLZYORVLZYOQVCUUCUUIUWBEVEZUVMUWCYOQVGUUKUUCXRYFYJUWDUUJYF
          YGYDYLYCUUBXAYJYKYDYHYCUUBXBDEOPYEYIUGUIUKXCWMUVPEPQRUWBYOUGUHUJXDWMX
          HUUCUUIUUTUVMUUSUVTUWAXIUUKUVLUVPUVBEOPQUAYOUDUGUHUIXJXKXLXMUUCUUIUUS
          UVMUUFUUKUVBUVPEOPQUDYOUGUHUIXNWMUUCUUIUULUVMUVNUUEUUFVFUUGXOUUKUURUV
          PUVQEOPQFYOUUDUGUHUIXPXKXQ $.
      $}

      $d X z $.  $d X t $.
      $( Lemma for ~ cdleme25b .  TODO:  FIX COMMENT (Contributed by NM,
         6-Feb-2013.) $)
      cdleme28b $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q
              /\ ( s e. A /\ -. s .<_ W )
              /\ ( t e. A /\ -. t .<_ W ) )
           /\ ( s =/= t
              /\ ( ( s .\/ ( X ./\ W ) ) = X
               /\ ( t .\/ ( X ./\ W ) ) = X )
              /\ ( X e. B /\ -. X .<_ W ) ) )
            -> ( C .\/ ( X ./\ W ) ) = ( Y .\/ ( X ./\ W ) ) ) $=
        ( chlt wcel wa wbr wn w3a wne cv co wceq clat simp11l hllat syl simp11r
        simp12 simp13 simp22 simp21 cdleme27cl syl222anc simp33l lhpbase latmcl
        syl3anc latjcl simp23 eqid cdleme28a simp11 simp31 necomd simp32 ancomd
        simp33 syl333anc latasymd ) PVBVCZUANVCZVDZHDVCHUAQVEVFVDZIDVCIUAQVEVFV
        DZVGZHIVHZUEVIZDVCXFUAQVEVFVDZCVIZDVCXHUAQVEVFVDZVGZXFXHVHZXFUBUARVJZOV
        JUBVKZXHXLOVJUBVKZVDZUBEVCZUBUAQVEVFZVDZVGZVGZEPQFXLOVJZUCXLOVJZUFUGXTW
        SPVLVCZWSWTXBXCXJXSVMZPVNVOZXTYCFEVCZXLEVCZYAEVCYEXTWSWTXBXCXGXEYFYDWSW
        TXBXCXJXSVPZXAXBXCXJXSVQZXAXBXCXJXSVRZXDXEXGXIXSVSZXDXEXGXIXSVTZABDEFGH
        IJLNOPQRSUAUDUEUFUGUHUIUJUKULUMUNUOUPUQWAWBXTYCXPUAEVCZYGYEXPXQXKXOXDXJ
        WCXTWTYMYHENPUAUFUKWDVOEPRUBUAUFUIWEWFZEOPFXLUFUHWGWFXTYCUCEVCZYGYBEVCY
        EXTWSWTXBXCXIXEYOYDYHYIYJXDXEXGXIXSWHZYLABDEUCKHIJMNOPQRTUAUDCUFUGUHUIU
        JUKULURUNUSUTVAWAWBYNEOPUCXLUFUHWGWFABCDEFGHIJKLMNOPQRSTXFXHOVJXLRVJZUA
        UBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAYQWIWJXTXAXBXCXEXIXGXHXFVHXNXMV
        DXRYBYAQVEXAXBXCXJXSWKYIYJYLYPYKXTXFXHXDXJXKXOXRWLWMXTXMXNXDXJXKXOXRWNW
        OXDXJXKXOXRWPABUEDEUCKHIJGMLNOPQRTSXHXFOVJXLRVJZUAUBFUDCUFUGUHUIUJUKULU
        RUNUSUTVAUMUOUPUQYRWIWJWQWR $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Eliminate the
         ` s =/= t ` antecedent in ~ cdleme28b .  TODO:  FIX COMMENT
         (Contributed by NM, 6-Feb-2013.) $)
      cdleme28c $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q
              /\ ( s e. A /\ -. s .<_ W )
              /\ ( t e. A /\ -. t .<_ W ) )
           /\ ( ( s .\/ ( X ./\ W ) ) = X /\ ( t .\/ ( X ./\ W ) ) = X
              /\ ( X e. B /\ -. X .<_ W ) ) )
            -> ( C .\/ ( X ./\ W ) ) = ( Y .\/ ( X ./\ W ) ) ) $=
        ( chlt wcel wa wbr wn w3a cv co cdleme27b oveq1d adantl simpl11 simpl12
        wne simpl13 simpl21 simpl22 simpl23 simpr simpl31 simpl32 jca cdleme28b
        wceq simpl33 syl333anc pm2.61dane ) PVBVCUANVCVDZHDVCHUAQVEVFVDZIDVCIUA
        QVEVFVDZVGZHIVOZUEVHZDVCWNUAQVEVFVDZCVHZDVCWPUAQVEVFVDZVGZWNUBUARVIZOVI
        UBWEZWPWSOVIUBWEZUBEVCUBUAQVEVFVDZVGZVGZFWSOVIUCWSOVIWEZWNWPWNWPWEZXEXD
        XFFUCWSOABCDEFGHIJKLMNOPQRSTUAUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVJV
        KVLXDWNWPVOZVDZWIWJWKWMWOWQXGWTXAVDXBXEWIWJWKWRXCXGVMWIWJWKWRXCXGVNWIWJ
        WKWRXCXGVPWMWOWQWLXCXGVQWMWOWQWLXCXGVRWMWOWQWLXCXGVSXDXGVTXHWTXAWTXAXBW
        LWRXGWAWTXAXBWLWRXGWBWCWTXAXBWLWRXGWFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUG
        UHUIUJUKULUMUNUOUPUQURUSUTVAWDWGWH $.

      $( Quantified version of ~ cdleme28c .  (Compare ~ cdleme24 .)
         (Contributed by NM, 7-Feb-2013.) $)
      cdleme28 $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( P e. A /\ -. P .<_ W )
              /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ P =/= Q
           /\ ( X e. B /\ -. X .<_ W ) )
    -> A. s e. A A. t e. A ( ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
          /\ ( -. t .<_ W /\ ( t .\/ ( X ./\ W ) ) = X ) )
              -> ( C .\/ ( X ./\ W ) ) = ( Y .\/ ( X ./\ W ) ) ) ) $=
        ( chlt wcel wa wbr wn w3a wne cv co wi simp11 simp12 simp2l simp3ll jca
        wceq simp2r simp3rl simp3lr simp3rr cdleme28c syl133anc 3exp ralrimivv
        simp13 ) PVBVCUANVCVDHDVCHUAQVEVFVDIDVCIUAQVEVFVDVGZHIVHZUBEVCUBUAQVEVF
        VDZVGZUEVIZUAQVEVFZWKUBUARVJZOVJUBVQZVDZCVIZUAQVEVFZWPWMOVJUBVQZVDZVDZF
        WMOVJUCWMOVJVQZVKUECDDWJWKDVCZWPDVCZVDZWTXAWJXDWTVGZWGWHXBWLVDXCWQVDWNW
        RWIXAWGWHWIXDWTVLWGWHWIXDWTVMXEXBWLWJXBXCWTVNWLWNWSWJXDVOVPXEXCWQWJXBXC
        WTVRWQWRWOWJXDVSVPWLWNWSWJXDVTWQWRWOWJXDWAWGWHWIXDWTWFABCDEFGHIJKLMNOPQ
        RSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAWBWCWDWE $.
    $}

    $( Lemma for ~ cdleme29b .  (Compare ~ cdleme25a .)  TODO:  FIX COMMENT
       (Contributed by NM, 7-Feb-2013.) $)
    cdleme29ex $p |- ( ( ( ( K e. HL /\ W e. H )
      /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
   /\ P =/= Q
   /\ ( X e. B /\ -. X .<_ W ) ) -> E. s e. A ( ( -. s .<_ W
        /\ ( s .\/ ( X ./\ W ) ) = X ) /\ ( C .\/ ( X ./\ W ) ) e. B ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wrex simp3 lhpmcvr2 syl2anc clat
      simp11 simp11l adantr hllat syl simp11r simpl12 simpl13 simpl2 cdleme27cl
      simpr syl222anc simpl3l lhpbase latmcl syl3anc latjcl expr ancld reximdva
      adantrd mpd ) MUMUNZQKUNZUOZGCUNGQNUPUQUOZHCUNHQNUPUQUOZURZGHUSZRDUNZRQNU
      PUQZUOZURZTUTZQNUPUQZXARQOVAZLVARVBZUOZTCVCZXEEXCLVADUNZUOZTCVCWTWLWSXFWL
      WMWNWPWSVHWOWPWSVDCDKLMNOQRTUAUBUCUDUEUFVEVFWTXEXHTCWTXACUNZUOZXEXGXJXBXG
      XDWTXIXBXGWTXIXBUOZUOZMVGUNZEDUNZXCDUNZXGXLWJXMWTWJXKWJWKWMWNWPWSVIVJZMVK
      VLZXLWJWKWMWNXKWPXNXPWTWKXKWJWKWMWNWPWSVMVJZWLWMWNWPWSXKVNWLWMWNWPWSXKVOW
      TXKVRWOWPWSXKVPABCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGUHUIUJUKULVQVSXLXMWQQDUNZ
      XOXQWQWRWOWPXKVTXLWKXSXRDKMQUAUFWAVLDMORQUAUDWBWCDLMEXCUAUCWDWCWEWHWFWGWI
      $.

    $d v A $.  $d v B $.  $d v .\/ $.  $d v .<_ $.  $d v ./\ $.  $d v P $.
    $d v Q $.  $d v U $.  $d v W $.  $d t v C $.  $d s u v Z $.  $d t v z X $.
    $( Transform ~ cdleme28 .  (Compare ~ cdleme25b .)  TODO:  FIX COMMENT
       (Contributed by NM, 7-Feb-2013.) $)
    cdleme29b $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ P =/= Q
           /\ ( X e. B /\ -. X .<_ W ) )
      -> E. v e. B A. s e. A ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
              -> v = ( C .\/ ( X ./\ W ) ) ) ) $=
      ( vt chlt wcel wa wbr wn w3a wne cv co wceq wrex wral crio cif cdleme29ex
      wi cdleme28 breq1 notbid oveq1 eqeq1d anbi12d oveq1i oveq1d oveq2d syl5eq
      eqid eqeq2d imbi2d ralbidv riotabidv oveq12d ifbieq12d reusv3 biimpd sylc
      oveq2 ) NUOUPRLUPUQHDUPHROURUSUQIDUPIROURUSUQUTHIVASEUPSROURUSUQUTUAVBZRO
      URZUSZWLSRPVCZMVCZSVDZUQZFWOMVCZEUPUQUADVEZWRUNVBZROURZUSZXAWOMVCZSVDZUQZ
      UQWSXAHIMVCZOURZAVBZROURUSXIXGOURUSUQZCVBZXGTXAXIMVCZRPVCZMVCZPVCZVDZVJZA
      DVFZCEVGZXAJMVCZIHXAMVCZRPVCZMVCZPVCZVHZWOMVCZVDVJUNDVFUADVFZWRBVBWSVDVJU
      ADVFBEVEZACDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVIACUNDEFGHIJXSKYDL
      MNOPQXORSYETUAUBUCUDUEUFUGUHUIUJUKULUMYDWAXOWAXSWAYEWAVKWTYGYHWRXFBUAUNED
      WSYFWLXAVDZWNXCWQXEYIWMXBWLXAROVLVMYIWPXDSWLXAWOMVNVOVPYIWSWLXGOURZGKVHZW
      OMVCYFFYKWOMUMVQYIYKYEWOMYIYJXHGKXSYDWLXAXGOVLYIGXJXKQVDZVJZADVFZCEVGXSUL
      YIYNXRCEYIYMXQADYIYLXPXJYIQXOXKYIQXGTWLXIMVCZRPVCZMVCZPVCXOUKYIYQXNXGPYIY
      PXMTMYIYOXLRPWLXAXIMVNVRVSVSVTWBWCWDWEVTYIKWLJMVCZIHWLMVCZRPVCZMVCZPVCYDU
      IYIYRXTUUAYCPWLXAJMVNYIYTYBIMYIYSYARPWLXAHMWKVRVSWFVTWGVRVTWHWIWJ $.

    $( Transform ~ cdleme28b .  (Compare ~ cdleme25c .)  TODO:  FIX COMMENT
       (Contributed by NM, 8-Feb-2013.) $)
    cdleme29c $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ P =/= Q
           /\ ( X e. B /\ -. X .<_ W ) )
      -> E! v e. B A. s e. A ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
              -> v = ( C .\/ ( X ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral wreu cdleme29b wb simp11
      wrex simp3 lhpmcvr2 syl2anc reusv1 syl mpbird ) NUNUORLUOUPZHDUOHROUQURUP
      ZIDUOIROUQURUPZUSZHIUTZSEUOSROUQURUPZUSZUAVAZROUQURWDSRPVBZMVBSVCUPZBVAFW
      EMVBZVCVDUADVEZBEVFZWHBEVJZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
      VGWCWFUADVJZWIWJVHWCVQWBWKVQVRVSWAWBVIVTWAWBVKDELMNOPRSUAUBUCUDUEUFUGVLVM
      WFBUAEDWGVNVOVP $.

    cdleme29cl.i $e |- I = ( iota_ v e. B A. s e. A
         ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
              -> v = ( C .\/ ( X ./\ W ) ) ) ) $.
    $( Show closure of the unique element in ~ cdleme28c .  (Contributed by NM,
       8-Feb-2013.) $)
    cdleme29cl $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ P =/= Q
           /\ ( X e. B /\ -. X .<_ W ) ) -> I e. B ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wral crio wreu cdleme29c cbs cfv
      wi cvv fvex eqeltri riotaclb sylib syl5eqel ) OUPUQSLUQURHDUQHSPUSUTURIDU
      QISPUSUTURVAHIVBTEUQTSPUSUTURVAZMUBVCZSPUSUTVTTSQVDZNVDTVEURBVCFWANVDVEVL
      UBDVFZBEVGZEUOVSWBBEVHWCEUQABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMU
      NVIWBBEEOVJVKVMUCOVJVNVOVPVQVR $.
  $}

  ${
    cdleme30.b $e |- B = ( Base ` K ) $.
    cdleme30.l $e |- .<_ = ( le ` K ) $.
    cdleme30.j $e |- .\/ = ( join ` K ) $.
    cdleme30.m $e |- ./\ = ( meet ` K ) $.
    cdleme30.a $e |- A = ( Atoms ` K ) $.
    cdleme30.h $e |- H = ( LHyp ` K ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       9-Feb-2013.) $)
    cdleme30a $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( s e. A
          /\ ( X e. B /\ -. X .<_ W )
          /\ Y e. B )
        /\ ( ( s .\/ ( X ./\ W ) ) = X
          /\ X .<_ Y ) )
       -> ( s .\/ ( Y ./\ W ) ) = Y ) $=
      ( wcel wbr co chlt wa cv wn w3a wceq clat simp1l syl simp21 atbase simp23
      simp1r lhpbase latmcl syl3anc simp22l latjass syl13anc simp3l wi latmlem1
      hllat simp3r mpd latjlej2 eqbrtrrd latjcl latleeqj2 mpbid simp1 lhpmod2i2
      syl121anc oveq2d cp1 cfv simp22 eqid lhpj1 syl2anc col hlol olm11 latlej1
      wb eqtrd breqtrd lattrd latleeqj1 3eqtrd 3eqtr3d ) EUARZHCRZUBZKUCZARZIBR
      ZIHFSUDZUBZJBRZUEZWOIHGTZDTZIUFZIJFSZUBZUEZWOJHGTZDTZIDTZWOXHIDTZDTZXIJXG
      EUGRZWOBRZXHBRZWQXJXLUFXGWLXMWLWMXAXFUHZEVCUIZXGWPXNWNWPWSWTXFUJABWOELPUK
      UIZXGXMWTHBRZXOXQWNWPWSWTXFULZXGWMXSWLWMXAXFUMBCEHLQUNUIZBEGJHLOUOUPZWQWR
      WPWTWNXFUQZBDEWOXHILNURUSXGIXIFSZXJXIUFZXGXCIXIFWNXAXDXEUTZXGXBXHFSZXCXIF
      SZXGXEYGWNXAXDXEVDZXGXMWQWTXSXEYGVAXQYCXTYABEFGIJHLMOVBUSVEXGXMXBBRZXOXNY
      GYHVAXQXGXMWQXSYJXQYCYABEGIHLOUOUPZYBXRBDEFXBXHWOLMNVFUSVEVGXGXMWQXIBRZYD
      YEWEXQYCXGXMXNXOYLXQXRYBBDEWOXHLNVHUPBDEFIXILMNVIUPVJXGXLWOJHIDTZGTZDTWOJ
      DTZJXGXKYNWODXGWNWTWQXEXKYNUFWNXAXFVKZXTYCYIBCDEFGHJILMNOQVLVMVNXGYNJWODX
      GYNJEVOVPZGTZJXGYMYQJGXGWNWSYMYQUFYPWNWPWSWTXFVQBYQCDEFHILMNYQVRZQVSVTVNX
      GEWARZWTYRJUFXGWLYTXPEWBUIXTBYQEGJLOYSWCVTWFVNXGWOJFSZYOJUFZXGBEFWOIJLMXQ
      XRYCXTXGWOXCIFXGXMXNYJWOXCFSXQXRYKBDEFWOXBLMNWDUPYFWGYIWHXGXMXNWTUUAUUBWE
      XQXRXTBDEFWOJLMNWIUPVJWJWK $.
  $}

  ${
    $d x w A $.  $d w x B $.  $d w x .\/ $.  $d w x .<_ $.  $d w x ./\ $.
    $d w x N $.  $d s w x z X $.  $d w x W $.  $d s w x z X $.
    cdleme31so.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
  -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    cdleme31so.c $e |- C = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
  -> z = ( N .\/ ( X ./\ W ) ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       25-Feb-2013.) $)
    cdleme31so $p |- ( X e. B -> [_ X / x ]_ O = C ) $=
      ( cv co wceq wa wi wcel wbr wn wral crio csb nfcvd oveq1 oveq2d id anbi2d
      eqeq12d eqeq2d imbi12d ralbidv riotabidv csbiegf csbeq2i 3eqtr4g ) LDUAZA
      LMPZKGUBUCZVAAPZKHQZFQZVCRZSZBPZIVDFQZRZTZMCUDZBDUEZUFVBVALKHQZFQZLRZSZVH
      IVNFQZRZTZMCUDZBDUEZALJUFEALVMWBDUTAWBUGVCLRZVLWABDWCVKVTMCWCVGVQVJVSWCVF
      VPVBWCVEVOVCLWCVDVNVAFVCLKHUHZUIWCUJULUKWCVIVRVHWCVDVNIFWDUIUMUNUOUPUQALJ
      VMNUROUS $.
  $}

  ${
    $d s w A $.  $d w D $.  $d w I $.  $d s w .\/ $.  $d s w .<_ $.
    $d s w P $.  $d s w Q $.  $d s w R $.
    cdleme31sn.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    cdleme31sn.c $e |- C = if ( R .<_ ( P .\/ Q ) , [_ R / s ]_ I ,
        [_ R / s ]_ D ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       26-Feb-2013.) $)
    cdleme31sn $p |- ( R e. A -> [_ R / s ]_ N = C ) $=
      ( wcel cv wbr cif csb nfcsb1v csbeq1a co wnfc nfv nfif a1i wceq ifbieq12d
      breq1 csbiegf csbeq2i 3eqtr4g ) FANZKFKOZDEHUAZIPZGCQZRFUNIPZKFGRZKFCRZQZ
      KFJRBKFUPUTAKUTUBULUQKURUSUQKUCKFGSKFCSUDUEUMFUFUOUQGCURUSUMFUNIUHKFGTKFC
      TUGUIKFJUPLUJMUK $.
  $}

  ${
    $d s t w y A $.  $d s w B $.  $d w G $.  $d s w .\/ $.  $d s w .<_ $.
    $d s w P $.  $d s w Q $.  $d s t w y R $.  $d s w W $.
    cdleme31sn1sv.i $e |- I = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = G ) ) $.
    cdleme31sn1sv.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113. $)
$(
    cdleme31sn1sv $p |- ( ( ( R e. A /\ -. R .<_ W ) /\ R .<_ ( P .\/ Q ) )
            -> [_ R / s ]_ N = [_ R / s ]_ G ) $=
      ? $.
$)
  $}

  ${
    $d s t w y A $.  $d s w B $.  $d w G $.  $d s w .\/ $.  $d s w .<_ $.
    $d s w P $.  $d s w Q $.  $d s t w y R $.  $d s w W $.
    cdleme31sn1.i $e |- I = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = G ) ) $.
    cdleme31sn1.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    cdleme31sn1.c $e |- C = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = [_ R / s ]_ G ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       26-Feb-2013.) $)
    cdleme31sn1 $p |- ( ( R e. A /\ R .<_ ( P .\/ Q ) )
            -> [_ R / s ]_ N = C ) $=
      ( csb wcel co wbr wa cif wceq eqid cdleme31sn adantr cv wn wi wral iftrue
      crio csbeq2i syl6eq wnfc nfcv nfv nfcsb1v nfeq2 nfral nfriota a1i csbeq1a
      nfim eqeq2d imbi2d ralbidv riotabidv csbiegf sylan9eqr syl6eqr eqtrd ) IC
      UAZIGHLUBZMUCZUDZPINTZVRPIKTZPIFTZUEZEVPVTWCUFVRCWCFGHIKLMNPRWCUGUHUIVSWC
      BUJZOMUCUKWDVQMUCUKUDZAUJZPIJTZUFZULZBCUMZADUOZEVRVPWCPIWEWFJUFZULZBCUMZA
      DUOZTZWKVRWCWAWPVRWAWBUNPIKWOQUPUQPIWOWKCPWKURVPWJPADWIPBCPCUSWEWHPWEPUTP
      WFWGPIJVAVBVGVCPDUSVDVEPUJIUFZWNWJADWQWMWIBCWQWLWHWEWQJWGWFPIJVFVHVIVJVKV
      LVMSVNVO $.
  $}

  ${
    $d s w A $.  $d s w D $.  $d s w .\/ $.  $d s w ./\ $.  $d s w P $.
    $d s w Q $.  $d s w R $.  $d s w W $.  $d s T w $.
    cdleme31se.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ T ) ./\ W ) ) ) $.
    cdleme31se.y $e |- Y
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( R .\/ T ) ./\ W ) ) ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       26-Feb-2013.) $)
    cdleme31se $p |- ( R e. A
            -> [_ R / s ]_ E = Y ) $=
      ( wcel co cv csb nfcvd oveq2d wceq oveq1 oveq1d csbiegf csbeq2i 3eqtr4g )
      EAOZLECDHPZBLQZFHPZJIPZHPZIPZRUHBEFHPZJIPZHPZIPZLEGRKLEUMUQAUGLUQSUIEUAZU
      LUPUHIURUKUOBHURUJUNJIUIEFHUBUCTTUDLEGUMMUENUF $.
  $}

  ${
    $d t w A $.  $d w D $.  $d t w .\/ $.  $d t w ./\ $.  $d t w P $.
    $d t w Q $.  $d t w R $.  $d t w S $.  $d t w W $.
    cdleme31se2.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
    cdleme31se2.y $e |- Y
      = ( ( P .\/ Q ) ./\ ( [_ S / t ]_ D .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       3-Apr-2013.) $)
    cdleme31se2 $p |- ( S e. A
            -> [_ S / t ]_ E = Y ) $=
      ( wcel co cv csb nfcv nfov wnfc nfcsb1v wceq csbeq1a oveq2 oveq1d oveq12d
      a1i oveq2d csbiegf csbeq2i 3eqtr4g ) GBOZAGDEIPZCFAQZIPZKJPZIPZJPZRUNAGCR
      ZFGIPZKJPZIPZJPZAGHRLAGUSVDBAVDUAUMAUNVCJAUNSAJSAUTVBIAGCUBAISAVBSTTUHUOG
      UCZURVCUNJVECUTUQVBIAGCUDVEUPVAKJUOGFIUEUFUGUIUJAGHUSMUKNUL $.
  $}

  ${
    $d s w A $.  $d s w .\/ $.  $d s w ./\ $.  $d s w P $.  $d s w Q $.
    $d s w R $.  $d s w U $.  $d s w W $.
    cdleme31sc.c $e |- C
        = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme31sc.x $e |- X
        = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       31-Mar-2013.) $)
    cdleme31sc $p |- ( R e. A -> [_ R / s ]_ C = X ) $=
      ( wcel cv co csb nfcvd wceq oveq1 oveq1d oveq12d csbiegf csbeq2i 3eqtr4g
      oveq2 oveq2d ) EANZKEKOZFGPZDCUIGPZIHPZGPZHPZQEFGPZDCEGPZIHPZGPZHPZKEBQJK
      EUNUSAUHKUSRUIESZUJUOUMURHUIEFGTUTULUQDGUTUKUPIHUIECGUFUAUGUBUCKEBUNLUDMU
      E $.
  $}

  ${
    $d s t w A $.  $d s t w .\/ $.  $d s t w ./\ $.  $d s t w P $.
    $d s t w Q $.  $d s R $.  $d s t w S $.  $d s t w W $.  $d s t w Y $.
    cdleme31sde.c $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme31sde.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdleme31sde.x $e |- Y
        = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme31sde.z $e |- Z
        = ( ( P .\/ Q ) ./\ ( Y .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       31-Mar-2013.) $)
    cdleme31sde $p |- ( ( R e. A /\ S e. A )
            -> [_ R / s ]_ [_ S / t ]_ E = Z ) $=
      ( co wcel cv csbeq2i nfcvd wceq oveq1 oveq2 oveq1d oveq2d oveq12d 3eqtr4g
      csb csbiegf syl5eq csbeq2dv eqid cdleme31se sylan9eqr ) GBUAZFBUAOFAGIULZ
      ULOFDEJTZMOUBZGJTZLKTZJTZKTZULNUSOFUTVFUSUTAGVACVBAUBZJTZLKTZJTZKTZULVFAG
      IVKQUCAGVKVFBUSAVFUDVGGUEZVJVEVAKVLCMVIVDJVLVGHJTZEDVGJTZLKTZJTZKTGHJTZED
      GJTZLKTZJTZKTCMVLVMVQVPVTKVGGHJUFVLVOVSEJVLVNVRLKVGGDJUGUHUIUJPRUKVLVHVCL
      KVGGVBJUGUHUJUIUMUNUOBMDEFGVFJKLNOVFUPSUQUR $.
  $}

  ${
    $d v A $.  $d v D $.  $d t v .\/ $.  $d t v ./\ $.  $d t O $.  $d t v P $.
    $d t v Q $.  $d v S $.  $d t v U $.  $d v V $.  $d t v W $.
    cdleme31snd.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme31snd.n $e |- N
        = ( ( v .\/ V ) ./\ ( P .\/ ( ( Q .\/ v ) ./\ W ) ) ) $.
    cdleme31snd.e $e |- E
        = ( ( O .\/ U ) ./\ ( Q .\/ ( ( P .\/ O ) ./\ W ) ) ) $.
    cdleme31snd.o $e |- O
        = ( ( S .\/ V ) ./\ ( P .\/ ( ( Q .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       1-Apr-2013.) $)
    cdleme31snd $p |- ( S e. A
            -> [_ S / v ]_ [_ N / t ]_ D = E ) $=
      ( csb wcel csbnestg cdleme31sc csbeq1d cvv wceq ovex eqeltri ax-mp syl6eq
      co eqtrd ) GCUAZAGBLDTTBAGLTZDTZIABGLDCUBUMUOBMDTZIUMBUNMDCLFEGNJKOMAQSUC
      UDMUEUAUPIUFMGNJUKZEFGJUKOKUKJUKZKUKUESUQURKUGUHUEDEFMHJKOIBPRUCUIUJUL $.
  $}

  ${
    $d t .\/ $.  $d t ./\ $.  $d t P $.  $d t Q $.  $d t U $.  $d t W $.
    $d s t $.
    cdleme31sdn.c $e |- C
        = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme31sdn.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme31sdn.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , C ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       31-Mar-2013.)  (New usage is discouraged.) $)
    cdleme31sdnN $p |- N = if ( s .<_ ( P .\/ Q ) , I , [_ s / t ]_ D ) $=
      ( cv co cif cvv wbr csb biid wcel wceq cdleme31sc ax-mp ifbieq2i eqtr4i
      vex ) KMQZDEHRIUAZGBSULGAUKCUBZSPULULUMBGULUCUKTUDUMBUEMUJTCDEUKFHJLBAONU
      FUGUHUI $.
  $}

  ${
    $d s t y A $.  $d s B $.  $d s E $.  $d s t y .\/ $.  $d s t y .<_ $.
    $d s ./\ $.  $d s t y P $.  $d s t y Q $.  $d s t y R $.  $d s W $.
    cdleme31sn1c.g $e |- G
        = ( ( P .\/ Q ) ./\ ( E .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdleme31sn1c.i $e |- I = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = G ) ) $.
    cdleme31sn1c.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    $( Local substitution instances $)
    cdleme31sn1c.y $e |- Y
        = ( ( P .\/ Q ) ./\ ( E .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
    cdleme31sn1c.c $e |- C = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = Y ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       1-Mar-2013.) $)
    cdleme31sn1c $p |- ( ( R e. A /\ R .<_ ( P .\/ Q ) )
            -> [_ R / s ]_ N = C ) $=
      ( wcel co wbr wa csb cv wceq wral crio eqid cdleme31sn1 cdleme31se adantr
      wn wi eqeq2d imbi2d ralbidv riotabidv syl6eqr eqtrd ) ICUEZIGHMUFZNUGZUHZ
      SIPUIBUJZQNUGURVJVGNUGURUHZAUJZSIKUIZUKZUSZBCULZADUMZEABCDVQFGHIKLMNPQSUA
      UBVQUNUOVIVQVKVLRUKZUSZBCULZADUMEVIVPVTADVIVOVSBCVIVNVRVKVIVMRVLVFVMRUKVH
      CJGHIVJKMOQRSTUCUPUQUTVAVBVCUDVDVE $.
  $}

  ${
    $d s w A $.  $d s w .\/ $.  $d s .<_ $.  $d s w ./\ $.  $d s w P $.
    $d s w Q $.  $d s w R $.  $d s w U $.  $d s w W $.
    cdleme32sn2.d $e |- D
        = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme31sn2.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    cdleme31sn2.c $e |- C
        = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       26-Feb-2013.) $)
    cdleme31sn2 $p |- ( ( R e. A /\ -. R .<_ ( P .\/ Q ) )
            -> [_ R / s ]_ N = C ) $=
      ( co csb wceq wcel wbr wn wa cif eqid cdleme31sn adantr cv iffalse syl6eq
      csbeq2i nfcvd oveq1 oveq2 oveq1d oveq2d oveq12d csbiegf sylan9eqr syl6eqr
      eqtrd ) FAUAZFDEIRJUBZUCZUDZNFLSZFGIRZEDFIRZMKRZIRZKRZBVFVGVDNFHSZNFCSZUE
      ZVLVCVGVOTVEAVOCDEFHIJLNPVOUFUGUHVEVCVONFNUIZGIRZEDVPIRZMKRZIRZKRZSZVLVEV
      OVNWBVDVMVNUJNFCWAOULUKNFWAVLAVCNVLUMVPFTZVQVHVTVKKVPFGIUNWCVSVJEIWCVRVIM
      KVPFDIUOUPUQURUSUTVBQVA $.
  $}

  ${
    $d x B $.  $d x C $.  $d x .<_ $.  $d x P $.  $d x Q $.  $d x W $.
    $d s x z X $.
    cdleme31.o $e |- O = ( iota_ z e. B A. s e. A
        ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
         -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    cdleme31.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    ${
      cdleme31.c $e |- C = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
           -> z = ( N .\/ ( X ./\ W ) ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         10-Feb-2013.) $)
      cdleme31fv $p |- ( X e. B
          -> ( F ` X ) = if ( ( P =/= Q /\ -. X .<_ W ) , C , X ) ) $=
        ( wceq wcel wne wbr wn wa cif cvv cv co wral crio riotaex eqeltri ifexg
        cfv wi mpan breq1 notbid anbi2d oveq1 oveq2d id eqeq12d imbi12d ralbidv
        eqeq2d riotabidv 3eqtr4g ifbieq12d fvmptg mpdan ) ODUAZFGUBZONJUCZUDZUE
        ZEOUFZUGUAZOHUOVRTEUGUAVMVSEPUHZNJUCUDZVTONKUIZIUIZOTZUEZBUHZLWBIUIZTZU
        PZPCUJZBDUKZUGSWJBDULUMVQEOUGDUNUQAOVNAUHZNJUCZUDZUEZMWLUFVRDUGHWLOTZWO
        VQMWLEOWPWNVPVNWPWMVOWLONJURUSUTWPWAVTWLNKUIZIUIZWLTZUEZWFLWQIUIZTZUPZP
        CUJZBDUKWKMEWPXDWJBDWPXCWIPCWPWTWEXBWHWPWSWDWAWPWRWCWLOWPWQWBVTIWLONKVA
        ZVBWPVCZVDUTWPXAWGWFWPWQWBLIXEVBVGVEVFVHQSVIXFVJRVKVL $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         10-Feb-2013.) $)
      cdleme31fv1 $p |- ( ( X e. B /\ ( P =/= Q /\ -. X .<_ W ) )
          -> ( F ` X ) = C ) $=
        ( wcel wne wbr wn wa cfv cif cdleme31fv iftrue sylan9eq ) ODTFGUAONJUBU
        CUDZOHUEUJEOUFEABCDEFGHIJKLMNOPQRSUGUJEOUHUI $.
    $}

    $d x A $.  $d s z B $.  $d x .\/ $.  $d x ./\ $.  $d x N $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       25-Feb-2013.) $)
    cdleme31fv1s $p |- ( ( X e. B /\ ( P =/= Q /\ -. X .<_ W ) )
          -> ( F ` X ) = [_ X / x ]_ O ) $=
      ( wa co wceq wcel wne wbr wn cfv cv wral crio eqid cdleme31fv1 cdleme31so
      wi csb adantr eqtr4d ) NDUAZEFUBNMIUCUDRZRNGUEOUFZMIUCUDURNMJSZHSNTRBUFKU
      SHSTULOCUGBDUHZANLUMZABCDUTEFGHIJKLMNOPQUTUIZUJUPVAUTTUQABCDUTHIJKLMNOPVB
      UKUNUO $.
  $}

  ${
    $d x B $.  $d x .<_ $.  $d x P $.  $d x Q $.  $d x W $.  $d x X $.
    cdleme31fv2.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       23-Feb-2013.) $)
    cdleme31fv2 $p |- ( ( X e. B /\ -. ( P =/= Q /\ -. X .<_ W ) )
        -> ( F ` X ) = X ) $=
      ( wcel wne wbr wn wa cv cif cmpt wceq notbid breq1 anbi2d adantll iffalse
      a1i biimparc syl simpr eqtrd simpl fvmptd ) IBKZCDLZIHFMZNZOZNZOZAIUMAPZH
      FMZNZOZGUSQZIBEBEABVCRSURJUEURUSISZOZVCUSIVEVBNZVCUSSUQVDVFULVDVFUQVDVBUP
      VDVAUOUMVDUTUNUSIHFUATUBTUFUCVBGUSUDUGURVDUHUIULUQUJZVGUK $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       18-Apr-2013.) $)
    cdleme31id $p |- ( ( X e. B /\ P = Q )
        -> ( F ` X ) = X ) $=
      ( wceq wcel wne wbr wn wa cfv simpl necon2bi cdleme31fv2 sylan2 ) CDKIBLC
      DMZIHFNOZPZOIEQIKUDCDUBUCRSABCDEFGHIJTUA $.
  $}

  ${
    cdlemefrs29.b $e |- B = ( Base ` K ) $.
    cdlemefrs29.l $e |- .<_ = ( le ` K ) $.
    cdlemefrs29.j $e |- .\/ = ( join ` K ) $.
    cdlemefrs29.m $e |- ./\ = ( meet ` K ) $.
    cdlemefrs29.a $e |- A = ( Atoms ` K ) $.
    cdlemefrs29.h $e |- H = ( LHyp ` K ) $.
    cdlemefrs29.eq $e |- ( s = R -> ( ph <-> ps ) ) $.
    $( ***START OF VALUE AT ATOM STUFF TO REPLACE ONES BELOW*** FIX COMMENT.
       TODO: see if this is the optimal utility theorem using ~ lhpmat .
       (Contributed by NM, 29-Mar-2013.) $)
    cdlemefrs29pre00 $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( R e. A /\ -. R .<_ W ) /\ ps ) /\ s e. A ) ->
     ( ( ( -. s .<_ W /\ ph ) /\ ( s .\/ ( R ./\ W ) ) = R )
        <-> ( -. s .<_ W /\ ( s .\/ ( R ./\ W ) ) = R ) ) ) $=
      ( wa chlt wcel wbr wn w3a cv co wceq wb simpl3 pm5.32ri baibr syl cp0 cfv
      eqid lhpmat 3adant3 adantr oveq2d col simpl1l atbase adantl olj01 syl2anc
      hlol eqtrd eqeq1d anbi2d 3bitr4d anass syl6rbbr ) HUAUBZKFUBZTZECUBEKIUCU
      DTZBUEZLUFZCUBZTZVSKIUCUDZVSEKJUGZGUGZEUHZTWBAWETZTWBATWETWAWEWFWBWAVSEUH
      ZAWGTZWEWFWABWGWHUIVPVQBVTUJWHBWGWGABSUKULUMWAWDVSEWAWDVSHUNUOZGUGZVSWAWC
      WIVSGVRWCWIUHZVTVPVQWKBCEFHIJKWINPWIUPZQRUQURUSUTWAHVAUBZVSDUBZWJVSUHWAVN
      WMVNVOVQBVTVBHVGUMVTWNVRCDVSHMQVCVDDGHVSWIMOWLVEVFVHVIZWAWEWGAWOVJVKVJWBA
      WEVLVM $.
  $}

  ${
    $d s w z $.  $d s A $.  $d s H $.  $d s .\/ $.  $d s K $.  $d s .<_ $.
    $d s P $.  $d s Q $.  $d s R $.  $d s W $.  $d s ps $.
    cdlemefrs27.b $e |- B = ( Base ` K ) $.
    cdlemefrs27.l $e |- .<_ = ( le ` K ) $.
    cdlemefrs27.j $e |- .\/ = ( join ` K ) $.
    cdlemefrs27.m $e |- ./\ = ( meet ` K ) $.
    cdlemefrs27.a $e |- A = ( Atoms ` K ) $.
    cdlemefrs27.h $e |- H = ( LHyp ` K ) $.
    cdlemefrs27.eq $e |- ( s = R -> ( ph <-> ps ) ) $.
    cdlemefrs27.nb $e |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
   /\ P =/= Q
   /\ ( s e. A /\ ( -. s .<_ W /\ ph ) ) ) -> N e. B ) $.
    $( TODO fix comment.  (Contributed by NM, 29-Mar-2013.) $)
    cdlemefrs29bpre0 $p |- ( ( ( ( K e. HL /\ W e. H ) /\
     ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
  /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
  /\ ps )
  -> ( A. s e. A ( ( ( -. s .<_ W /\ ph )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) )
      <-> z = [_ R / s ]_ N ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wral wal csb df-ral anass imbi1i
      wi impexp 3bitr3ri cp0 cfv simpl11 simpl2r eqid lhpmat syl2anc oveq2d col
      simp11l syl adantr simprl atbase olj01 eqtrd eqeq1d simpl1 simpl2l simprr
      hlol syl112anc eqeq2d imbi12d pm5.74da eqcom imbi2i simp2rl simp2rr simp3
      eleq1 breq1 notbid anbi12d biimprcd syl12anc pm4.71rd imbi1d bitrd syl5bb
      syl5rbbr syl5bbr albidv wb nfcv csbiebg syl6bb ) KUEUFZOIUFZUGZFDUFFOLUHU
      IUGZGDUFGOLUHUIUGZUJZFGUKZHDUFZHOLUHZUIZUGZUGZBUJZPULZOLUHZUIZAUGZYDHOMUM
      ZJUMZHUNZUGZCULZNYHJUMZUNZVAZPDUOZYDHUNZNYLUNZVAZPUPZYLPHNUQZUNZYPYDDUFZY
      OVAZPUPYCYTYOPDURYCUUDYSPUUDUUCYGUGZYJYNVAZVAZYCYSUUEYJUGZYNVAUUCYKUGZYNV
      AUUGUUDUUHUUIYNUUCYGYJUSUTUUEYJYNVBUUCYKYNVBVCYCUUGUUEYQYLNUNZVAZVAZYSYCU
      UEUUFUUKYCUUEUGZYJYQYNUUJUUMYIYDHUUMYIYDKVDVEZJUMZYDUUMYHUUNYDJUUMXMYAYHU
      UNUNXMXNXOYBBUUEVFXQYAXPBUUEVGDHIKLMOUUNRTUUNVHZUAUBVIVJZVKUUMKVLUFZYDEUF
      ZUUOYDUNYCUURUUEYCXKUURXKXLXNXOYBBVMKWDVNVOZUUMUUCUUSYCUUCYGVPZDEYDKQUAVQ
      VNEJKYDUUNQSUUPVRVJVSVTUUMYMNYLUUMYMNUUNJUMZNUUMYHUUNNJUUQVKUUMUURNEUFZUV
      BNUNUUTUUMXPXQUUCYGUVCXPYBBUUEWAXQYAXPBUUEWBUVAYCUUCYGWCUDWEEJKNUUNQSUUPV
      RVJVSWFWGWHUULUUEYQUGZUUJVAZYCYSUUEYQUUJVBYSUUKYCUVEUUJYRYQYLNWIWJYCYQUVD
      UUJYCYQUUEYCXRXTBYQUUEVAXRXTXQXPBWKZXRXTXQXPBWLXPYBBWMYQUUEXRXTBUGZUGYQUU
      CXRYGUVGYDHDWNYQYFXTABYQYEXSYDHOLWOWPUCWQWQWRWSWTXAXDXEXBXCXFXCYCYTUUAYLU
      NZUUBYCXRYTUVHXGUVFPHNYLDPYLXHXIVNUUAYLWIXJXB $.

    cdlemefrs27.rnb $e |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) ) /\ ps )
      -> [_ R / s ]_ N e. B ) $.
    $d z A $.  $d z B $.  $d z H $.  $d z K $.  $d z .<_ $.  $d z N $.
    $d z P $.  $d z Q $.  $d z R $.  $d z W $.  $d z ps $.
    $( TODO FIX COMMENT (Contributed by NM, 29-Mar-2013.) $)
    cdlemefrs29bpre1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\
     ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
  /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
  /\ ps )
 -> E. z e. B A. s e. A ( ( ( -. s .<_ W /\ ph )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral cdlemefrs29bpre0 rexbidv
      wrex csb risset syl6bbr mpbird ) KUFUGOIUGUHFDUGFOLUIUJUHGDUGGOLUIUJUHUKF
      GULHDUGHOLUIUJUHUHBUKZPUMZOLUIUJAUHVFHOMUNZJUNHUOUHCUMZNVGJUNUOUPPDUQZCEU
      TZPHNVAZEUGZUEVEVJVHVKUOZCEUTVLVEVIVMCEABCDEFGHIJKLMNOPQRSTUAUBUCUDURUSCV
      KEVBVCVD $.

    $d B s $.  $d .\/ z $.  $d ./\ s z $.  $d ph z $.
    $( TODO FIX COMMENT (Contributed by NM, 29-Mar-2013.) $)
    cdlemefrs29cpre1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\
        ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
     /\ ps )
   -> E! z e. B A. s e. A ( ( ( -. s .<_ W /\ ph )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral wreu cdlemefrs29bpre1 wb
      simp11 simp2rl atbase syl simp2rr lhpmcvr2 syl12anc simpl3 pm5.32ri baibr
      wrex cp0 cfv simp2r eqid lhpmat syl2anc adantr oveq2d simp11l hlol syl2an
      col olj01 eqtrd eqeq1d anbi2d 3bitr4d anass syl6bbr rexbidva mpbid reusv1
      mpbird ) KUFUGZOIUGZUHZFDUGFOLUIUJUHZGDUGGOLUIUJUHZUKZFGULZHDUGZHOLUIUJZU
      HZUHZBUKZPUMZOLUIUJZAUHXGHOMUNZJUNZHUOZUHZCUMNXIJUNZUOUPPDUQZCEURZXNCEVKZ
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUSXFXLPDVKZXOXPUTXFXHXKUHZPDVKZXQXFWQHEUGZX
      CXSWQWRWSXEBVAZXFXBXTXBXCXAWTBVBDEHKQUAVCVDXBXCXAWTBVEDEIJKLMOHPQRSTUAUBV
      FVGXFXRXLPDXFXGDUGZUHZXRXHAXKUHZUHXLYCXKYDXHYCXGHUOZAYEUHZXKYDYCBYEYFUTWT
      XEBYBVHYFBYEYEABUCVIVJVDYCXJXGHYCXJXGKVLVMZJUNZXGYCXIYGXGJXFXIYGUOZYBXFWQ
      XDYIYAWTXAXDBVNDHIKLMOYGRTYGVOZUAUBVPVQVRVSXFKWCUGZXGEUGYHXGUOYBXFWOYKWOW
      PWRWSXEBVTKWAVDDEXGKQUAVCEJKXGYGQSYJWDWBWEWFZYCXKYEAYLWGWHWGXHAXKWIWJWKWL
      XLCPEDXMWMVDWN $.

    ${
      cdlemefrs29cl.o $e |- O = ( iota_ z e. B A. s e. A
           ( ( -. s .<_ W /\ ( s .\/ ( R ./\ W ) ) = R )
                -> z = ( N .\/ ( R ./\ W ) ) ) ) $.
      $( TODO:  NOT USED?  Show closure of the unique element in
         ~ cdlemefrs29cpre1 .  (Contributed by NM, 29-Mar-2013.)
         (New usage is discouraged.) $)
      cdlemefrs29clN $p |- ( ( ( ( K e. HL /\ W e. H ) /\
       ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
    /\ ps ) -> O e. B ) $=
        ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral crio wb simpl11 simpl3
        simpr cdlemefrs29pre00 syl31anc imbi1d ralbidva riotabidv syl6reqr wreu
        simpl2r cdlemefrs29cpre1 cbs cfv fvex eqeltri riotaclb sylib eqeltrd
        cvv ) KUHUIPIUIUJZFDUIFPLUKULUJZGDUIGPLUKULUJZUMZFGUNZHDUIHPLUKULUJZUJZ
        BUMZOQUOZPLUKULZAUJWJHPMUPZJUPHUQZUJZCUONWLJUPUQZURZQDUSZCEUTZEWIWRWKWM
        UJZWOURZQDUSZCEUTOWIWQXACEWIWPWTQDWIWJDUIZUJZWNWSWOXCWBWGBXBWNWSVAWBWCW
        DWHBXBVBWFWGWEBXBVLWEWHBXBVCWIXBVDABDEHIJKLMPQRSTUAUBUCUDVEVFVGVHVIUGVJ
        WIWQCEVKWREUIABCDEFGHIJKLMNPQRSTUAUBUCUDUEUFVMWQCEEKVNVOWARKVNVPVQVRVSV
        T $.
    $}

    cdleme29frs.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
         -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    $d w x z A $.  $d x z B $.  $d t C $.  $d s y z D $.  $d s z H $.
    $d x z .\/ $.  $d s z K $.  $d z x .<_ $.  $d x z ./\ $.  $d x w z N $.
    $d z P $.  $d z Q $.  $d s x w z R $.  $d s z S $.  $d s z U $.
    $d x z W $.  $d t z $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Value of ` F ` at an atom
       not under ` W ` .  TODO:  FIX COMMENT TODO: consolidate uses of ~ lhpmat
       here and elsewhere, and presence/absence of ` s .<_ ( P .\/ Q ) ` term.
       Also, why can proof be shortened with ~ cdleme29cl ?  What is difference
       from ~ cdlemefs27cl ?  (Contributed by NM, 29-Mar-2013.) $)
    cdlemefrs32fva $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ ps )
               -> [_ R / x ]_ O = [_ R / s ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral crio simp2rl atbase eqid
      csb cdleme31so 3syl wss wrex wreu ssid a1i simpll simpr jca imim1i ralimi
      rgenw cdlemefrs29bpre1 wb simpl11 simpl3 cdlemefrs29pre00 syl31anc imbi1d
      simpl2r ralbidva rexbidv mpbid cdlemefrs29cpre1 riotass2 cdlemefrs29bpre0
      syl22anc adantr riota5 3eqtrd ) LUIUJQJUJUKZGEUJGQMULUMUKZHEUJHQMULUMUKZU
      NZGHUOZIEUJZIQMULUMZUKZUKZBUNZCIPVEZRUPZQMULUMZXHIQNUQZKUQIURZUKZDUPZOXJK
      UQURZUSZREUTZDFVAZXIAUKZXKUKZXNUSZREUTZDFVAZRIOVEZXFXBIFUJXGXQURXBXCXAWTB
      VBEFILSUCVCCDEFXQKMNOPQIRUHXQVDVFVGXFFFVHZXPYAUSZDFUTZXPDFVIZYADFVJXQYBUR
      YDXFFVKVLYFXFYEDFXOXTREXSXLXNXSXIXKXIAXKVMXRXKVNVOVPVQVRVLXFYADFVIYGABDEF
      GHIJKLMNOQRSTUAUBUCUDUEUFUGVSXFYAXPDFXFXTXOREXFXHEUJZUKZXSXLXNYIWQXDBYHXS
      XLVTWQWRWSXEBYHWAXAXDWTBYHWFWTXEBYHWBXFYHVNABEFIJKLMNQRSTUAUBUCUDUEWCWDWE
      WGWHWIABDEFGHIJKLMNOQRSTUAUBUCUDUEUFUGWJXPYADFFWKWMXFYADFYCUGXFYAXMYCURVT
      XMFUJABDEFGHIJKLMNOQRSTUAUBUCUDUEUFWLWNWOWP $.

    cdleme29frs.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    $d z H $.  $d z K $.  $d x P $.  $d x Q $.  $d x z R $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 29-Mar-2013.) $)
    cdlemefrs32fva1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ ps )
       -> ( F ` R ) = [_ R / s ]_ N ) $=
      ( chlt wcel wa wbr w3a wne cfv csb wceq simp2rl atbase syl simp2l simp2rr
      wn cdleme31fv1s syl12anc cdlemefrs32fva eqtrd ) MUKULRKULUMGEULGRNUNVEUMH
      EULHRNUNVEUMUOZGHUPZIEULZIRNUNVEZUMZUMBUOZIJUQZCIQURZSIPURVOIFULZVKVMVPVQ
      USVOVLVRVLVMVKVJBUTEFIMTUDVAVBVJVKVNBVCVLVMVKVJBVDCDEFGHJLNOPQRISUIUJVFVG
      ABCDEFGHIKLMNOPQRSTUAUBUCUDUEUFUGUHUIVHVI $.
  $}

  ${
    cdlemefr29.b $e |- B = ( Base ` K ) $.
    cdlemefr29.l $e |- .<_ = ( le ` K ) $.
    cdlemefr29.j $e |- .\/ = ( join ` K ) $.
    cdlemefr29.m $e |- ./\ = ( meet ` K ) $.
    cdlemefr29.a $e |- A = ( Atoms ` K ) $.
    cdlemefr29.h $e |- H = ( LHyp ` K ) $.
    $d s A $.  $d s B $.  $d s H $.  $d s K $.  $d s .<_ $.  $d s ./\ $.
    $d s P $.  $d s Q $.  $d s W $.  $d s X $.
    $( Lemma for ~ cdlemefs29bpre1N .  (Compare ~ cdleme25a .)  TODO:  FIX
       COMMENT TODO:  IS THIS NEEDED?  (Contributed by NM, 28-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefr29exN $p |- ( ( ( ( K e. HL /\ W e. H )
      /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
   /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) )
   /\ A. s e. A C e. B ) -> E. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( X ./\ W ) ) = X )
          /\ ( C .\/ ( X ./\ W ) ) e. B ) ) $=
      ( wcel chlt wa wbr wn w3a wne wral cv co wceq wrex simp11 simp2r lhpmcvr2
      syl2anc nfv nfra1 nf3an wi clat simp11l adantr syl simpl3 simprl rsp sylc
      hllat simp2rl simp11r lhpbase latmcl syl3anc latjcl expr adantrd ancld ex
      reximdai mpd ) HUATZKFTZUBZDATDKIUCUDUBZEATEKIUCUDUBZUEZDEUFZLBTZLKIUCUDZ
      UBZUBZCBTZMAUGZUEZMUHZKIUCUDZWOLKJUIZGUILUJZUBZMAUKZWSCWQGUIBTZUBZMAUKWNW
      CWJWTWCWDWEWKWMULWFWGWJWMUMABFGHIJKLMNOPQRSUNUOWNWSXBMAWFWKWMMWFMUPWKMUPW
      LMAUQURWNWOATZWSXBUSWNXCUBZWSXAXDWPXAWRWNXCWPXAWNXCWPUBZUBZHUTTZWLWQBTZXA
      XFWAXGWNWAXEWAWBWDWEWKWMVAZVBHVHZVCXFWMXCWLWFWKWMXEVDWNXCWPVEWLMAVFVGWNXH
      XEWNXGWHKBTZXHWNWAXGXIXJVCWHWIWGWFWMVIWNWBXKWAWBWDWEWKWMVJBFHKNSVKVCBHJLK
      NQVLVMVBBGHCWQNPVNVMVOVPVQVRVSVT $.
  $}

  ${
    cdlemefr27.b $e |- B = ( Base ` K ) $.
    cdlemefr27.l $e |- .<_ = ( le ` K ) $.
    cdlemefr27.j $e |- .\/ = ( join ` K ) $.
    cdlemefr27.m $e |- ./\ = ( meet ` K ) $.
    cdlemefr27.a $e |- A = ( Atoms ` K ) $.
    cdlemefr27.h $e |- H = ( LHyp ` K ) $.
    cdlemefr27.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdlemefr27.c $e |- C
        = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdlemefr27.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , C ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Closure of ` N ` .
       (Contributed by NM, 23-Mar-2013.) $)
    cdlemefr27cl $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ P e. A
            /\ Q e. A )
          /\ ( s e. A /\ -. s .<_ ( P .\/ Q )
              /\ P =/= Q ) ) -> N e. B ) $=
      ( chlt wcel wa w3a cv co wbr wn wne cif simpr2 iffalse syl syl5eq simpl1l
      wceq simpl1r simpl2 simpl3 simpr1 cdleme1b syl23anc eqeltrd ) JUEUFZNGUFZ
      UGZDAUFZEAUFZUHZOUIZAUFZVNDEIUJKUKZULZDEUMZUHZUGZMCBVTMVPHCUNZCUDVTVQWACU
      TVMVOVQVRUOVPHCUPUQURVTVHVIVKVLVOCBUFVHVIVKVLVSUSVHVIVKVLVSVAVJVKVLVSVBVJ
      VKVLVSVCVMVOVQVRVDABDEVNFCGIJKLNQRSTUAUBUCPVEVFVG $.

    $d s A $.  $d s .\/ $.  $d s .<_ $.  $d s ./\ $.  $d s P $.  $d s Q $.
    $d s R $.  $d s U $.  $d s W $.
    $( Show that ` [_ R / s ]_ N ` is an atom not under ` W ` when
       ` -. R .<_ ( P .\/ Q ) ` .  (Contributed by NM, 28-Mar-2013.) $)
    cdlemefr32sn2aw $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
            -> ( [_ R / s ]_ N e. A /\ -. [_ R / s ]_ N .<_ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co simp11 simp12 simp13 simp2r simp2l simp3
      csb eqid cdleme3fa cdleme3 jca syl132anc wceq simp2rl cdleme31sn2 syl2anc
      eleq1d breq1d notbid anbi12d mpbird ) KUFUGOHUGUHZDAUGDOLUIUJUHZEAUGEOLUI
      UJUHZUKZDEULZFAUGZFOLUIUJZUHZUHZFDEJUMLUIUJZUKZPFNUTZAUGZWFOLUIZUJZUHFGJU
      MEDFJUMOMUMJUMMUMZAUGZWJOLUIZUJZUHZWEVOVPVQWBVSWDWNVOVPVQWCWDUNVOVPVQWCWD
      UOVOVPVQWCWDUPVRVSWBWDUQVRVSWBWDURVRWCWDUSZVOVPVQWBUKVSWDUHUKWKWMADEFGWJH
      JKLMORSTUAUBUCWJVAZVBADEFGWJHJKLMORSTUAUBUCWPVCVDVEWEWGWKWIWMWEWFWJAWEVTW
      DWFWJVFVTWAVSVRWDVGWOAWJCDEFGIJLMNOPUDUEWPVHVIZVJWEWHWLWEWFWJOLWQVKVLVMVN
      $.

    $( Show closure of ` [_ R / s ]_ N ` .  (Contributed by NM,
       28-Mar-2013.) $)
    cdlemefr32snb $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
            -> [_ R / s ]_ N e. B ) $=
      ( chlt wcel wa wbr wn w3a wne co csb cdlemefr32sn2aw simpld atbase syl )
      KUFUGOHUGUHDAUGDOLUIUJUHEAUGEOLUIUJUHUKDEULFAUGFOLUIUJUHUHFDEJUMLUIUJUKZP
      FNUNZAUGZUTBUGUSVAUTOLUIUJABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUOUPABUTKQUAUQUR
      $.

    $d s w z $.  $d s A $.  $d s H $.  $d s .\/ $.  $d s K $.  $d s .<_ $.
    $d s P $.  $d s Q $.  $d s R $.  $d s W $.
    $( TODO fix comment.  (Contributed by NM, 28-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefr29bpre0N $p |- ( ( ( ( K e. HL /\ W e. H ) /\
     ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
  /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
  /\ -. R .<_ ( P .\/ Q ) )
  -> ( A. s e. A ( ( ( -. s .<_ W /\ -. s .<_ ( P .\/ Q ) )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) )
      <-> z = [_ R / s ]_ N ) ) $=
      ( cv co wbr wn wceq breq1 notbid chlt wcel w3a wne simp11 simp12l simp13l
      wa simp3l simp3rr simp2 cdlemefr27cl syl33anc cdlemefrs29bpre0 ) QUGZEFKU
      HZMUIZUJZGVIMUIZUJABCEFGIKLMNOPQRSTUAUBUCVHGUKVJVLVHGVIMULUMLUNUOPIUOVAZE
      BUOZEPMUIUJZVAZFBUOZFPMUIUJZVAZUPZEFUQZVHBUOZVHPMUIUJZVKVAZVAZUPVMVNVQWBV
      KWAOCUOVMVPVSWAWEURVNVOVMVSWAWEUSVQVRVMVPWAWEUTVTWAWBWDVBWCVKWBVTWAVCVTWA
      WEVDBCDEFHIJKLMNOPQRSTUAUBUCUDUEUFVEVFVG $.

    $d x z A $.  $d s x z B $.  $d z H $.  $d x z .\/ $.  $d z K $.
    $d x z .<_ $.  $d x z ./\ $.  $d x z N $.  $d z P $.  $d z Q $.
    $d x z R $.  $d x z W $.
    ${
      cdlemefr29cl.o $e |- O = ( iota_ z e. B A. s e. A
           ( ( -. s .<_ W /\ ( s .\/ ( R ./\ W ) ) = R )
                -> z = ( N .\/ ( R ./\ W ) ) ) ) $.
      $( Show closure of the unique element in ~ cdleme29c .  TODO fix
         comment.  TODO Not needed?  (Contributed by NM, 29-Mar-2013.)
         (New usage is discouraged.) $)
      cdlemefr29clN $p |- ( ( ( ( K e. HL /\ W e. H ) /\
       ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
    /\ -. R .<_ ( P .\/ Q ) ) -> O e. B ) $=
        ( cv co wbr wn wceq breq1 notbid chlt wa w3a wne simp11 simp12l simp13l
        simp3l simp3rr simp2 cdlemefr27cl syl33anc cdlemefr32snb cdlemefrs29clN
        wcel ) RUIZEFKUJZMUKZULZGVLMUKZULABCEFGIKLMNOPQRSTUAUBUCUDVKGUMVMVOVKGV
        LMUNUOLUPVJQIVJUQZEBVJZEQMUKULZUQZFBVJZFQMUKULZUQZURZEFUSZVKBVJZVKQMUKU
        LZVNUQZUQZURVPVQVTWEVNWDOCVJVPVSWBWDWHUTVQVRVPWBWDWHVAVTWAVPVSWDWHVBWCW
        DWEWGVCWFVNWEWCWDVDWCWDWHVEBCDEFHIJKLMNOQRSTUAUBUCUDUEUFUGVFVGBCDEFGHIJ
        KLMNOQRSTUAUBUCUDUEUFUGVHUHVI $.
    $}

    $d w ./\ $.  $d w R $.  $d t w y S $.  $d w U $.  $d w X $.
    ${
      cdleme43fr.x $e |- X
          = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $.
      $d w y V $.
      $( Value of ` [_ R / s ]_ N ` when ` -. R .<_ ( P .\/ Q ) ` .
         (Contributed by NM, 30-Mar-2013.)  (New usage is discouraged.) $)
      cdleme43frv1snN $p |- ( ( R e. A /\ -. R .<_ ( P .\/ Q ) )
                -> [_ R / s ]_ N = X ) $=
        ( cdleme31sn2 ) APCDEFGIJLMNOQUEUFUGUH $.
    $}

    cdleme29fr.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
         -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Value of ` F ` at an atom
       not under ` W ` .  TODO:  FIX COMMENT (Contributed by NM, 29-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefr32fvaN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
               -> [_ R / x ]_ O = [_ R / s ]_ N ) $=
      ( cv co wbr wn wceq breq1 notbid chlt wcel w3a wne simp11 simp12l simp13l
      simp3l simp3rr simp2 cdlemefr27cl syl33anc cdlemefr32snb cdlemefrs32fva
      wa ) SUJZFGLUKZNULZUMZHVMNULZUMABCDFGHJLMNOPQRSTUAUBUCUDUEVLHUNVNVPVLHVMN
      UOUPMUQURRJURVKZFCURZFRNULUMZVKZGCURZGRNULUMZVKZUSZFGUTZVLCURZVLRNULUMZVO
      VKZVKZUSVQVRWAWFVOWEPDURVQVTWCWEWIVAVRVSVQWCWEWIVBWAWBVQVTWEWIVCWDWEWFWHV
      DWGVOWFWDWEVEWDWEWIVFCDEFGIJKLMNOPRSTUAUBUCUDUEUFUGUHVGVHCDEFGHIJKLMNOPRS
      TUAUBUCUDUEUFUGUHVIUIVJ $.

    cdleme29fr.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    $d z H $.  $d z K $.  $d x P $.  $d x Q $.  $d x z R $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 29-Mar-2013.) $)
    cdlemefr32fva1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
       -> ( F ` R ) = [_ R / s ]_ N ) $=
      ( cv co wbr wn wceq breq1 notbid chlt wcel w3a wne simp11 simp12l simp13l
      simp3l simp3rr simp2 cdlemefr27cl syl33anc cdlemefr32snb cdlemefrs32fva1
      wa ) TULZFGMUMZOUNZUOZHVOOUNZUOABCDFGHJKMNOPQRSTUAUBUCUDUEUFVNHUPVPVRVNHV
      OOUQURNUSUTSKUTVMZFCUTZFSOUNUOZVMZGCUTZGSOUNUOZVMZVAZFGVBZVNCUTZVNSOUNUOZ
      VQVMZVMZVAVSVTWCWHVQWGQDUTVSWBWEWGWKVCVTWAVSWEWGWKVDWCWDVSWBWGWKVEWFWGWHW
      JVFWIVQWHWFWGVGWFWGWKVHCDEFGIKLMNOPQSTUAUBUCUDUEUFUGUHUIVIVJCDEFGHIKLMNOP
      QSTUAUBUCUDUEUFUGUHUIVKUJUKVL $.

    cdleme43frv.x $e |- X
        = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $.
    $( Value of ` ( F `` R ) ` when ` -. R .<_ ( P .\/ Q ) ` .  TODO This may
       be useful for shortening others that now use ~ riotasv 3d .  TODO:  FIX
       COMMENT (Contributed by NM, 30-Mar-2013.) $)
    cdlemefr31fv1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
              -> ( F ` R ) = X ) $=
      ( chlt wcel wa wbr wn w3a wne cfv cdlemefr32fva1 wceq simp2rl cdleme31sn2
      co csb simp3 syl2anc eqtrd ) NUNUOSKUOUPFCUOFSOUQURUPGCUOGSOUQURUPUSZFGUT
      ZHCUOZHSOUQURZUPUPZHFGMVFOUQURZUSZHJVAUAHQVGZTABCDEFGHIJKLMNOPQRSUAUBUCUD
      UEUFUGUHUIUJUKULVBVQVMVPVRTVCVMVNVLVKVPVDVKVOVPVHCTEFGHILMOPQSUAUIUJUMVEV
      IVJ $.
  $}

  ${
    cdlemefs29.b $e |- B = ( Base ` K ) $.
    cdlemefs29.l $e |- .<_ = ( le ` K ) $.
    cdlemefs29.j $e |- .\/ = ( join ` K ) $.
    cdlemefs29.m $e |- ./\ = ( meet ` K ) $.
    cdlemefs29.a $e |- A = ( Atoms ` K ) $.
    cdlemefs29.h $e |- H = ( LHyp ` K ) $.
    $( FIX COMMENT. TODO: see if this is the optimal utility theorem using
       ~ lhpmat .  (Contributed by NM, 27-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefs29pre00N $p |- ( ( ( ( K e. HL /\ W e. H )
       /\ ( R e. A /\ -. R .<_ W ) /\ R .<_ ( P .\/ Q ) ) /\ s e. A ) ->
    ( ( ( -. s .<_ W /\ s .<_ ( P .\/ Q ) ) /\ ( s .\/ ( R ./\ W ) ) = R )
        <-> ( -. s .<_ W /\ ( s .\/ ( R ./\ W ) ) = R ) ) ) $=
      ( cv wbr co breq1 cdlemefrs29pre00 ) LSZCDGUAZITEUEITABEFGHIJKLMNOPQRUDEU
      EIUBUC $.
  $}

  ${
    cdlemefs26.b $e |- B = ( Base ` K ) $.
    cdlemefs26.l $e |- .<_ = ( le ` K ) $.
    cdlemefs26.j $e |- .\/ = ( join ` K ) $.
    cdlemefs26.m $e |- ./\ = ( meet ` K ) $.
    cdlemefs26.a $e |- A = ( Atoms ` K ) $.
    cdlemefs26.h $e |- H = ( LHyp ` K ) $.
    cdlemefs27.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdlemefs27.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdlemefs27.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdlemefs27.i $e |- I = ( iota_ u e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> u = E ) ) $.
    cdlemefs27.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , C ) $.
    $d t u A $.  $d t u B $.  $d u E $.  $d t H $.  $d t u .\/ $.  $d t K $.
    $d t u .<_ $.  $d t u ./\ $.  $d t u P $.  $d t u Q $.  $d t u U $.
    $d t u W $.  $d t u s $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Closure of ` N ` .  TODO
       FIX COMMENT This is the start of a re-proof of ~ cdleme27cl etc. with
       the ` s .<_ ( P .\/ Q ) ` condition (so as to not have the ` C `
       hypothesis).  (Contributed by NM, 24-Mar-2013.) $)
    cdlemefs27cl $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( ( s e. A /\ -. s .<_ W ) /\ s .<_ ( P .\/ Q )
              /\ P =/= Q ) ) -> N e. B ) $=
      ( chlt wcel wa wbr wn w3a cv wne cif wceq simpr2 iftrue syl simpl1 simpl2
      co simpl3 simpr1 simpr3 cdleme25cl syl312anc eqeltrd syl5eqel ) NUKULRKUL
      UMZGCULGROUNUOUMZHCULHROUNUOUMZUPZSUQZCULVRROUNUOUMZVRGHMVFOUNZGHURZUPZUM
      ZQVTLEUSZDUJWCWDLDWCVTWDLUTVQVSVTWAVAZVTLEVBVCWCVNVOVPVSWAVTLDULVNVOVPWBV
      DVNVOVPWBVEVNVOVPWBVGVQVSVTWAVHVQVSVTWAVIWEACDGHVRIFKLMNOPJRBTUAUBUCUDUEU
      FUGUHUIVJVKVLVM $.
  $}

  ${
    $d s t w x y z A $.  $d s t w x y z B $.  $d y D $.  $d y E $.
    $d s t y H $.  $d s t w x y z .\/ $.  $d s t y K $.  $d s t w x y z .<_ $.
    $d s t x y z ./\ $.  $d x z N $.  $d s t w y z P $.  $d s t w y z Q $.
    $d s t y R $.  $d t y U $.  $d s t w x y z W $.  $d w y Y $.  $d w Z $.
    cdlemefs32.b $e |- B = ( Base ` K ) $.
    cdlemefs32.l $e |- .<_ = ( le ` K ) $.
    cdlemefs32.j $e |- .\/ = ( join ` K ) $.
    cdlemefs32.m $e |- ./\ = ( meet ` K ) $.
    cdlemefs32.a $e |- A = ( Atoms ` K ) $.
    cdlemefs32.h $e |- H = ( LHyp ` K ) $.
    cdlemefs32.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdlemefs32.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdlemefs32.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdlemefs32.i $e |- I = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = E ) ) $.
    cdlemefs32.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , C ) $.
    ${
      $d w Z $.  $d s D $.
      $( Local substitution instances.  Maybe change these to ~ equid . $)
      cdlemefs32a1.y $e |- Y
          = ( ( P .\/ Q ) ./\ ( D .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
      cdlemefs32a1.z $e |- Z = ( iota_ y e. B A. t e. A
         ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = Y ) ) $.
      $( Show that ` [_ R / s ]_ N ` is an atom not under ` W ` when
         ` R .<_ ( P .\/ Q ) ` .  (Contributed by NM, 24-Mar-2013.) $)
      cdlemefs32sn1aw $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) )
              -> ( [_ R / s ]_ N e. A /\ -. [_ R / s ]_ N .<_ W ) ) $=
        ( chlt wcel wa wbr wn w3a wne csb cvv cbs cfv fvex eqeltri nfv wnf wceq
        co cv wi wral crio nfra1 nfcv nfriota nfcxfr nfel1 nfbr nfn nfan a1i wb
        eleq1 breq1 notbid anbi12d adantl simpl1 simpl2r simprl simprrl simpl2l
        jca simpl3 simprrr cdleme7ga cdleme7 syl123anc ex simp1 simp2rl simp2rr
        simp2l cdleme25cl syl122anc wrex simp11 simp12 simp13 cdlemb2 syl121anc
        simp3 riotasv3d mpan2 cdleme31sn1c syl2anc eleq1d breq1d mpbird ) OUPUQ
        SLUQURZGCUQGSPUSUTURZHCUQHSPUSUTURZVAZGHVBZICUQZISPUSUTZURZURZIGHNVLZPU
        SZVAZUBIRVCZCUQZYPSPUSZUTZURUACUQZUASPUSZUTZURZYODVDUQUUCDOVEVFVDUCOVEV
        GVHYOBVMZSPUSUTZUUDYMPUSUTZURZTCUQZTSPUSZUTZURZUUCABDCTUAVDYOBVIUUCBVJY
        OYTUUBBBUACBUAUUGAVMTVKVNZBCVOZADVPZUOUUMBADUULBCVQBDVRVSVTZWAUUABBUASP
        UUOBPVRBSVRWBWCWDWEUAUUNVKYOUOWETUAVKZUUKUUCWFYOUUPUUHYTUUJUUBTUACWGUUP
        UUIUUATUASPWHWIWJWKYOUUDCUQZUUGURZUUKYOUURURZYGYKUUQUUEURZYHYNUUFUUKYGY
        LYNUURWLYHYKYGYNUURWMUUSUUQUUEYOUUQUUGWNYOUUQUUEUUFWOWQYHYKYGYNUURWPYGY
        LYNUURWRYOUUQUUEUUFWSYGYKUUTURYHYNUUFVAVAUUHUUJCGHIUUDJFTLNOPQSUDUEUFUG
        UHUIUJUNWTCGHIUUDJFTLNOPQSUDUEUFUGUHUIUJUNXAWQXBXCYOYGYIYJYHYNUADUQYGYL
        YNXDYIYJYHYGYNXEZYIYJYHYGYNXFYGYHYKYNXGZYGYLYNXPZACDGHIJFLUANOPQTSBUCUD
        UEUFUGUHUIUJUNUOXHXIYOYDYEYFYHUUGBCXJYDYEYFYLYNXKYDYEYFYLYNXLYDYEYFYLYN
        XMUVBCGHLNOPSBUDUEUGUHXNXOXQXRYOYQYTYSUUBYOYPUACYOYIYNYPUAVKUVAUVCABCDU
        AEGHIFKMNPQRSTUBUKULUMUNUOXSXTZYAYOYRUUAYOYPUASPUVDYBWIWJYC $.
    $}

    $d s D $.
    $( Show closure of ` [_ R / s ]_ N ` .  (Contributed by NM,
       24-Mar-2013.) $)
    cdlemefs32snb $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) )
            -> [_ R / s ]_ N e. B ) $=
      ( chlt wcel wa wbr wn w3a wne co csb cv wceq wi wral crio cdlemefs32sn1aw
      eqid simpld atbase syl ) OULUMSLUMUNGCUMGSPUOUPUNHCUMHSPUOUPUNUQGHURICUMI
      SPUOUPUNUNIGHNUSZPUOUQZTIRUTZCUMZVMDUMVLVNVMSPUOUPABCDEFGHIJKLMNOPQRSVKFI
      BVAZNUSSQUSNUSQUSZVOSPUOUPVOVKPUOUPUNAVAVPVBVCBCVDADVEZTUAUBUCUDUEUFUGUHU
      IUJUKVPVGVQVGVFVHCDVMOUAUEVIVJ $.

    $d s w z $.
    $( TODO FIX COMMENT (Contributed by NM, 26-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefs29bpre0N $p |- ( ( ( ( K e. HL /\ W e. H ) /\
     ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
  /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
  /\ R .<_ ( P .\/ Q ) )
  -> ( A. s e. A ( ( ( -. s .<_ W /\ s .<_ ( P .\/ Q ) )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) )
      <-> z = [_ R / s ]_ N ) ) $=
      ( cv co wbr breq1 chlt wcel wa w3a wne simp1 simp3l simp3rl simp3rr simp2
      wn jca cdlemefs27cl syl13anc cdlemefrs29bpre0 ) UAUMZHIOUNZQUOZJVMQUOBDEH
      IJMOPQRSTUAUBUCUDUEUFUGVLJVMQUPPUQURTMURUSHDURHTQUOVGUSIDURITQUOVGUSUTZHI
      VAZVLDURZVLTQUOVGZVNUSZUSZUTZVOVQVRUSVNVPSEURVOVPVTVBWAVQVRVOVPVQVSVCVRVN
      VQVOVPVDVHVRVNVQVOVPVEVOVPVTVFACDEFGHIKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULV
      IVJVK $.

    $d z H $.  $d z K $.  $d z R $.
    $( TODO FIX COMMENT (Contributed by NM, 27-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefs29bpre1N $p |- ( ( ( ( K e. HL /\ W e. H ) /\
     ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
  /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
  /\ R .<_ ( P .\/ Q ) )
 -> E. z e. B A. s e. A ( ( ( -. s .<_ W /\ s .<_ ( P .\/ Q ) )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) ) ) $=
      ( cv co wbr breq1 chlt wcel wa w3a wne simp1 simp3l simp3rl simp3rr simp2
      wn jca cdlemefs27cl syl13anc cdlemefs32snb cdlemefrs29bpre1 ) UAUMZHIOUNZ
      QUOZJVNQUOBDEHIJMOPQRSTUAUBUCUDUEUFUGVMJVNQUPPUQURTMURUSHDURHTQUOVGUSIDUR
      ITQUOVGUSUTZHIVAZVMDURZVMTQUOVGZVOUSZUSZUTZVPVRVSUSVOVQSEURVPVQWAVBWBVRVS
      VPVQVRVTVCVSVOVRVPVQVDVHVSVOVRVPVQVEVPVQWAVFACDEFGHIKLMNOPQRSTUAUBUCUDUEU
      FUGUHUIUJUKULVIVJACDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVKVL $.

    $( TODO FIX COMMENT (Contributed by NM, 26-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefs29cpre1N $p |- ( ( ( ( K e. HL /\ W e. H ) /\
        ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
     /\ R .<_ ( P .\/ Q ) )
   -> E! z e. B A. s e. A ( ( ( -. s .<_ W /\ s .<_ ( P .\/ Q ) )
         /\ ( s .\/ ( R ./\ W ) ) = R ) -> z = ( N .\/ ( R ./\ W ) ) ) ) $=
      ( cv co wbr breq1 chlt wcel wa w3a wne simp1 simp3l simp3rl simp3rr simp2
      wn jca cdlemefs27cl syl13anc cdlemefs32snb cdlemefrs29cpre1 ) UAUMZHIOUNZ
      QUOZJVNQUOBDEHIJMOPQRSTUAUBUCUDUEUFUGVMJVNQUPPUQURTMURUSHDURHTQUOVGUSIDUR
      ITQUOVGUSUTZHIVAZVMDURZVMTQUOVGZVOUSZUSZUTZVPVRVSUSVOVQSEURVPVQWAVBWBVRVS
      VPVQVRVTVCVSVOVRVPVQVDVHVSVOVRVPVQVEVPVQWAVFACDEFGHIKLMNOPQRSTUAUBUCUDUEU
      FUGUHUIUJUKULVIVJACDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVKVL $.

    ${
      cdlemefs29cl.o $e |- O = ( iota_ z e. B A. s e. A
           ( ( -. s .<_ W /\ ( s .\/ ( R ./\ W ) ) = R )
                -> z = ( N .\/ ( R ./\ W ) ) ) ) $.
      $( Show closure of the unique element in ~ cdleme29c .  (Contributed by
         NM, 27-Mar-2013.)  (New usage is discouraged.) $)
      cdlemefs29clN $p |- ( ( ( ( K e. HL /\ W e. H ) /\
       ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
    /\ R .<_ ( P .\/ Q ) ) -> O e. B ) $=
        ( cv co wbr breq1 chlt wcel wa w3a wne simp1 simp3l simp3rl jca simp3rr
        wn simp2 cdlemefs27cl syl13anc cdlemefs32snb cdlemefrs29clN ) UBUOZHIOU
        PZQUQZJVPQUQBDEHIJMOPQRSTUAUBUCUDUEUFUGUHVOJVPQURPUSUTUAMUTVAHDUTHUAQUQ
        VIVAIDUTIUAQUQVIVAVBZHIVCZVODUTZVOUAQUQVIZVQVAZVAZVBZVRVTWAVAVQVSSEUTVR
        VSWCVDWDVTWAVRVSVTWBVEWAVQVTVRVSVFVGWAVQVTVRVSVHVRVSWCVJACDEFGHIKLMNOPQ
        RSUAUBUCUDUEUFUGUHUIUJUKULUMVKVLACDEFGHIJKLMNOPQRSUAUBUCUDUEUFUGUHUIUJU
        KULUMVMUNVN $.
    $}

    $d w ./\ $.  $d w R $.  $d t w y S $.  $d w U $.  $d w X $.  $d t Z $.
    ${
      cdleme43fs.y $e |- Y
          = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
      cdleme43fs.z $e |- Z
          = ( ( P .\/ Q ) ./\ ( Y .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
      ${
        $d w y V $.
        cdleme43fsa1.v $e |- V
            = ( ( P .\/ Q ) ./\ ( D .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
        cdleme43fsa1.x $e |- X = ( iota_ y e. B A. t e. A
           ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = V ) ) $.
        $( Value of ` [_ R / s ]_ N ` when ` R .<_ ( P .\/ Q ) ` .
           (Contributed by NM, 30-Mar-2013.) $)
        cdleme43fsv1snlem $p |- ( ( ( ( K e. HL /\ W e. H )
               /\ ( P e. A /\ -. P .<_ W )
               /\ ( Q e. A /\ -. Q .<_ W ) )
            /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
               /\ ( S e. A /\ -. S .<_ W ) )
            /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
                -> [_ R / s ]_ N = Z ) $=
          ( chlt wcel wa wbr wn w3a wne co csb wceq simp22l simp3l cdleme31sn1c
          syl2anc cvv cbs cfv fvex eqeltri cv nfv wnf wi wral crio nfcv nfriota
          nfra1 nfcxfr nfeq1 a1i eqeq1 adantl simpl1 simpl22 simprl simprrl jca
          simpl23 simpl21 simprrr simpl3r simpl3l 3jca eqid cdleme21k syl132anc
          wb ex simp1 simp22r simp21 cdleme25cl syl122anc simp11 simp12 cdlemb2
          wrex simp13 syl121anc riotasv3d mpan2 eqtrd ) PVAVBUAMVBVCZGCVBGUAQVD
          VEVCZHCVBHUAQVDVEVCZVFZGHVGZICVBZIUAQVDVEZVCZJCVBJUAQVDVEVCZVFZIGHOVH
          ZQVDZJYNQVDVEZVCZVFZUEISVIZUBUDYRYIYOYSUBVJYIYJYHYLYGYQVKZYGYMYOYPVLZ
          ABCDUBEGHIFLNOQRSUATUEUNUOUPUSUTVMVNYRDVOVBUBUDVJZDPVPVQVOUFPVPVRVSYR
          BVTZUAQVDVEZUUCYNQVDVEZVCZTUDVJZUUBABDCTUBVOYRBWAUUBBWBYRBUBUDBUBUUFA
          VTTVJWCZBCWDZADWEZUTUUIBADUUHBCWHBDWFWGWIWJWKUBUUJVJYRUTWKTUBVJUUGUUB
          XHYRTUBUDWLWMYRUUCCVBZUUFVCZUUGYRUULVCZYGYKUUKUUDVCYLYHUUEYPYOVFUUGYG
          YMYQUULWNYHYKYLYGYQUULWOUUMUUKUUDYRUUKUUFWPYRUUKUUDUUEWQWRYHYKYLYGYQU
          ULWSYHYKYLYGYQUULWTUUMUUEYPYOYRUUKUUDUUEXAYOYPYGYMUULXBYOYPYGYMUULXCX
          DCIUUCOVHUARVHZGHIUUCJKFUCMOPQRTUDUAIJOVHUARVHZUGUHUIUJUKULUMUQUUNXEU
          UOXEUSURXFXGXIYRYGYIYJYHYOUBDVBYGYMYQXJYTYIYJYHYLYGYQXKYGYHYKYLYQXLZU
          UAACDGHIKFMUBOPQRTUABUFUGUHUIUJUKULUMUSUTXMXNYRYDYEYFYHUUFBCXRYDYEYFY
          MYQXOYDYEYFYMYQXPYDYEYFYMYQXSUUPCGHMOPQUABUGUHUJUKXQXTYAYBYC $.
      $}

      $( Value of ` [_ R / s ]_ N ` when ` R .<_ ( P .\/ Q ) ` .  (Contributed
         by NM, 30-Mar-2013.) $)
      cdleme43fsv1sn $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
            -> [_ R / s ]_ N = Z ) $=
        ( co cv wbr wn wa wceq wi wral crio eqid cdleme43fsv1snlem ) ABCDEFGHIJ
        KLMNOPQRSGHOUQZFIBURZOUQTRUQOUQRUQZTVITQUSUTVIVHQUSUTVAAURVJVBVCBCVDADV
        EZUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVJVFVKVFVG $.
    $}

    cdleme29fs.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
         -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    $d x R $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Value of ` F ` at an atom
       not under ` W ` .  TODO:  FIX COMMENT TODO: consolidate uses of ~ lhpmat
       here and elsewhere, and presence/absence of ` s .<_ ( P .\/ Q ) ` term.
       Also, why can proof be shortened with ~ cdleme27cl ?  What is difference
       from ~ cdlemefs27cl ?  (Contributed by NM, 29-Mar-2013.)
       (New usage is discouraged.) $)
    cdlemefs32fvaN $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
         /\ R .<_ ( P .\/ Q ) )
              -> [_ R / x ]_ O = [_ R / s ]_ N ) $=
      ( cv co wbr breq1 chlt wcel wa w3a wne simp1 simp3l simp3rl simp3rr simp2
      wn jca cdlemefs27cl syl13anc cdlemefs32snb cdlemefrs32fva ) UCUPZIJPUQZRU
      RZKVQRURACEFIJKNPQRSTUAUBUCUDUEUFUGUHUIVPKVQRUSQUTVAUBNVAVBIEVAIUBRURVJVB
      JEVAJUBRURVJVBVCZIJVDZVPEVAZVPUBRURVJZVRVBZVBZVCZVSWAWBVBVRVTTFVAVSVTWDVE
      WEWAWBVSVTWAWCVFWBVRWAVSVTVGVKWBVRWAVSVTVHVSVTWDVIBDEFGHIJLMNOPQRSTUBUCUD
      UEUFUGUHUIUJUKULUMUNVLVMBDEFGHIJKLMNOPQRSTUBUCUDUEUFUGUHUIUJUKULUMUNVNUOV
      O $.

    cdleme29fs.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    $d z H $.  $d z K $.  $d x P $.  $d x Q $.  $d x z R $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 29-Mar-2013.) $)
    cdlemefs32fva1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) )
       -> ( F ` R ) = [_ R / s ]_ N ) $=
      ( cv co wbr breq1 chlt wcel wa w3a wne simp1 simp3l simp3rl simp3rr simp2
      wn jca cdlemefs27cl syl13anc cdlemefs32snb cdlemefrs32fva1 ) UDURZIJQUSZS
      UTZKVSSUTACEFIJKNOQRSTUAUBUCUDUEUFUGUHUIUJVRKVSSVARVBVCUCOVCVDIEVCIUCSUTV
      LVDJEVCJUCSUTVLVDVEZIJVFZVREVCZVRUCSUTVLZVTVDZVDZVEZWAWCWDVDVTWBUAFVCWAWB
      WFVGWGWCWDWAWBWCWEVHWDVTWCWAWBVIVMWDVTWCWAWBVJWAWBWFVKBDEFGHIJLMOPQRSTUAU
      CUDUEUFUGUHUIUJUKULUMUNUOVNVOBDEFGHIJKLMOPQRSTUAUCUDUEUFUGUHUIUJUKULUMUNU
      OVPUPUQVQ $.

    cdleme43fsv.y $e |- Y
        = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    cdleme43fsv.z $e |- Z
        = ( ( P .\/ Q ) ./\ ( Y .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
    $( Value of ` ( F `` R ) ` when ` R .<_ ( P .\/ Q ) ` .
       TODO This may be useful for shortening others that now use ~ riotasv
       3d . TODO: FIX COMMENT.
       ***END OF VALUE AT ATOM STUFF TO REPLACE
       ONES BELOW***
       <HTML><PRE>
       "cdleme3xsn1aw" decreased using "cdlemefs32sn1aw"
       "cdleme32sn1aw" decreased from 3302 to 36 using "cdlemefs32sn1aw".
       "cdleme32sn2aw" decreased from 1687 to 26 using "cdlemefr32sn2aw".
       "cdleme32snaw" decreased from 376 to 375 using "cdlemefs32sn1aw".
       "cdleme32snaw" decreased from 375 to 368 using "cdlemefr32sn2aw".
       "cdleme35sn3a" decreased from 547 to 523 using "cdleme43frv1sn".
       </PRE></HTML> (Contributed by NM, 27-Mar-2013.)  $)
    cdlemefs31fv1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
             /\ ( S e. A /\ -. S .<_ W ) )
          /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
              -> ( F ` R ) = Z ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv csb wceq simp1 simp21 cdlemefs32fva1
      simp22 simp3l syl121anc cdleme43fsv1sn eqtrd ) SVCVDUDPVDVEIEVDIUDTVFVGVE
      JEVDJUDTVFVGVEVHZIJVIZKEVDKUDTVFVGVEZLEVDLUDTVFVGVEZVHZKIJRVJZTVFZLWGTVFV
      GZVEZVHZKOVKZUGKUBVLZUFWKWBWCWDWHWLWMVMWBWFWJVNWBWCWDWEWJVOWBWCWDWEWJVQWB
      WFWHWIVRABCDEFGHIJKMNOPQRSTUAUBUCUDUGUHUIUJUKULUMUNUOUPUQURUSUTVPVSBDEFGH
      IJKLMNPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQURVAVBVTWA $.
  $}

  ${
    $d s t w x y z A $.  $d s t w x y z B $.  $d x y z D $.  $d y E $.
    $d s t x y z H $.  $d x z I $.  $d s t w x y z .\/ $.  $d s t x y z K $.
    $d s t w x y z .<_ $.  $d s t x y z ./\ $.  $d x z N $.
    $d s t w x y z P $.  $d s t w x y z Q $.  $d s t x y z R $.
    $d s t x y z U $.  $d s t w x y z W $.  $d w y Y $.  $d w Z $.
    cdlemef44.b $e |- B = ( Base ` K ) $.
    cdlemef44.l $e |- .<_ = ( le ` K ) $.
    cdlemef44.j $e |- .\/ = ( join ` K ) $.
    cdlemef44.m $e |- ./\ = ( meet ` K ) $.
    cdlemef44.a $e |- A = ( Atoms ` K ) $.
    cdlemef44.h $e |- H = ( LHyp ` K ) $.
    cdlemef44.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdlemef44.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdlemef44.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
         -> z = ( if ( s .<_ ( P .\/ Q ) , I ,
               [_ s / t ]_ D ) .\/ ( x ./\ W ) ) ) ) $.
    cdlemef44.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    $( Value of f(r) when r is an atom not under pq, using more compact
       hypotheses.  TODO: eliminate and use cdlemefr45 instead?  TODO FIX
       COMMENT (Contributed by NM, 31-Mar-2013.) $)
    cdlemefr44 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
      -> ( F ` R ) = [_ R / t ]_ D ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv csb cv cif eqid biid wceq cdleme31sc
      cvv vex ax-mp ifbieq2i cdlemefr31fv1 simp2rl syl eqtr4d ) OUKULSLULUMGDUL
      GSPUNUOUMHDULHSPUNUOUMUPZGHUQZIDULZISPUNUOZUMUMIGHNURZPUNUOZUPZIKUSIJNURH
      GINURSQURNURQURZCIFUTZABDETVAZJNURHGWDNURSQURNURQURZGHIJKLMNOPQWDVSPUNZMC
      WDFUTZVBRSWBTUAUBUCUDUEUFUGWEVCZWFWFWGWEMWFVDWDVGULWGWEVETVHVGFGHWDJNQSWE
      CUHWHVFVIVJUIUJWBVCZVKWAVQWCWBVEVQVRVPVOVTVLDFGHIJNQSWBCUHWIVFVMVN $.

    $d s D $.  $d s t y S $.
    cdlemefs44.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdlemefs44.i $e |- I = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) )
          -> y = E ) ) $.
    $( Value of f_s(r) when r is an atom under pq and s is any atom not under
       pq, using more compact hypotheses.  TODO: eliminate and use ~ cdlemefs45
       instead TODO FIX COMMENT (Contributed by NM, 31-Mar-2013.) $)
    cdlemefs44 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
          /\ ( S e. A /\ -. S .<_ W ) )
         /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
     -> ( F ` R ) = [_ R / s ]_ [_ S / t ]_ E ) $=
      ( chlt wcel wa wbr wn w3a wne cfv csb cif eqid cdlemefs31fv1 wceq simp22l
      co cv simp23l cdleme31sde syl2anc eqtr4d ) RUPUQUBOUQURHEUQHUBSUSUTURIEUQ
      IUBSUSUTURVAZHIVBZJEUQZJUBSUSUTZURZKEUQZKUBSUSUTZURZVAJHIQVJZSUSKWDSUSUTU
      RZVAZJNVCWDKLQVJIHKQVJUBTVJQVJTVJZJKQVJUBTVJQVJTVJZUCJDKMVDVDZABCDEFDUCVK
      ZGVDZGHIJKLMNOPQRSTWJWDSUSPWKVEZUAUBWGWHUCUDUEUFUGUHUIUJUKUNUOWLVFULUMWGV
      FZWHVFZVGWFVRWAWIWHVHVRVSVQWCVPWEVIWAWBVQVTVPWEVLDEGHIJKLMQTUBWGWHUCUKUNW
      MWNVMVNVO $.
  $}

  ${
    $d s t x y z A $.  $d s t x y z B $.  $d s x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t x y z R $.  $d s t x y z U $.  $d s t x y z W $.
    $d s t x y z A $.  $d s t x y z B $.  $d x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t x y z R $.  $d s t y S $.  $d s t x y z U $.
    $d s t x y z W $.
    cdlemef45.b $e |- B = ( Base ` K ) $.
    cdlemef45.l $e |- .<_ = ( le ` K ) $.
    cdlemef45.j $e |- .\/ = ( join ` K ) $.
    cdlemef45.m $e |- ./\ = ( meet ` K ) $.
    cdlemef45.a $e |- A = ( Atoms ` K ) $.
    cdlemef45.h $e |- H = ( LHyp ` K ) $.
    cdlemef45.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
    cdlemef45.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdlemef45.f $e |- F = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                            ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.
    $( Value of f(r) when r is an atom not under pq, using very compact
       hypotheses.  TODO FIX COMMENT (Contributed by NM, 1-Apr-2013.) $)
    cdlemefr45 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
      -> ( F ` R ) = [_ R / t ]_ D ) $=
      ( cv wbr wn co wa wceq wi wral crio csb cif eqid cdlemefr44 ) ACDEFGHIJKM
      NDUJZSQUKULVCHIOUMZQUKULUNBUJLUOUPDEUQBFURZOPQRTUJZSQUKULVFAUJZSRUMZOUMVG
      UOUNCUJVFVDQUKVEDVFGUSUTVHOUMUOUPTEUQCFURZSTUAUBUCUDUEUFUGUHVIVAUIVB $.

    $( Explicit expansion of ~ cdlemefr45 .  TODO: use to shorten ~ cdlemefr45
       uses?  TODO FIX COMMENT (Contributed by NM, 10-Apr-2013.) $)
    cdlemefr45e $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
   -> ( F ` R ) = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv cdlemefr45 wceq simp2rl eqid cdleme31sc
      co csb syl eqtrd ) PUJUKSNUKULHEUKHSQUMUNULIEUKISQUMUNULUOZHIUPZJEUKZJSQU
      MUNZULULJHIOVCQUMUNZUOZJMUQDJGVDZJKOVCIHJOVCSRVCOVCRVCZABCDEFGHIJKLMNOPQR
      STUAUBUCUDUEUFUGUHUIURVLVIVMVNUSVIVJVHVGVKUTEGHIJKORSVNDUHVNVAVBVEVF $.

    $( f_t(s), s ` <_ ` p ` \/ ` q $)
    cdlemefs45.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    $( Value of f_s(r) when r is an atom under pq and s is any atom not under
       pq, using very compact hypotheses.  TODO FIX COMMENT (Contributed by NM,
       1-Apr-2013.) $)
    cdlemefs45 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
             /\ ( S e. A /\ -. S .<_ W ) )
          /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
      -> ( F ` R ) = [_ R / s ]_ [_ S / t ]_ E ) $=
      ( cv wbr wn co wa wceq wi wral crio csb cif eqid cdlemefs44 ) ABCDEFGHIJK
      LMNODULZTRUMUNVEHIPUOZRUMUNUPBULMUQURDEUSBFUTZPQRSUAULZTRUMUNVHAULZTSUOZP
      UOVIUQUPCULVHVFRUMVGDVHGVAVBVJPUOUQURUAEUSCFUTZTUAUBUCUDUEUFUGUHUIVKVCUJU
      KVGVCVD $.

    $d x z S $.
    $( Explicit expansion of ~ cdlemefs45 .  TODO: use to shorten ~ cdlemefs45
       uses?  Should ` ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) ` be
       assigned to a hypothesis letter?  TODO FIX COMMENT (Contributed by NM,
       10-Apr-2013.) $)
    cdlemefs45ee $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
          /\ ( S e. A /\ -. S .<_ W ) )
         /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
     -> ( F ` R ) = ( ( P .\/ Q ) ./\ (
           ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) )
        .\/ ( ( R .\/ S ) ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv cdlemefs45 wceq simp22l simp23l eqid
      csb cdleme31sde syl2anc eqtrd ) QULUMTOUMUNHEUMHTRUOUPUNIEUMITRUOUPUNUQZH
      IURZJEUMZJTRUOUPZUNZKEUMZKTRUOUPZUNZUQJHIPUSZRUOKVRRUOUPUNZUQZJNUTUAJDKMV
      FVFZVRKLPUSIHKPUSTSUSPUSSUSZJKPUSTSUSPUSSUSZABCDEFGHIJKLMNOPQRSTUAUBUCUDU
      EUFUGUHUIUJUKVAVTVLVOWAWCVBVLVMVKVQVJVSVCVOVPVKVNVJVSVDDEGHIJKLMPSTWBWCUA
      UIUKWBVEWCVEVGVHVI $.

    $( Explicit expansion of ~ cdlemefs45 .  TODO: use to shorten ~ cdlemefs45
       uses?  TODO FIX COMMENT (Contributed by NM, 10-Apr-2013.)
       (New usage is discouraged.) $)
    cdlemefs45eN $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
   -> ( F ` R )
        = ( ( P .\/ Q ) ./\ ( ( F ` S ) .\/ ( ( R .\/ S ) ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv cdlemefs45ee simp1 simp21 simp23 simp3r
      co wceq cdlemefr45e syl121anc oveq1d oveq2d eqtr4d ) QULUMTOUMUNHEUMHTRUO
      UPUNIEUMITRUOUPUNUQZHIURZJEUMJTRUOUPUNZKEUMKTRUOUPUNZUQZJHIPVEZRUOZKVQRUO
      UPZUNZUQZJNUSVQKLPVEIHKPVETSVEPVESVEZJKPVETSVEZPVEZSVEVQKNUSZWCPVEZSVEABC
      DEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUTWAWFWDVQSWAWEWBWCPWAVLVMVOVSWEWB
      VFVLVPVTVAVLVMVNVOVTVBVLVMVNVOVTVCVLVPVRVSVDABCDEFGHIKLMNOPQRSTUAUBUCUDUE
      UFUGUHUIUJVGVHVIVJVK $.
  $}

  ${
    $d s t x y z A $.  $d s t x y z B $.  $d y C $.  $d s y z D $.  $d y E $.
    $d s t H $.  $d s t x y z .\/ $.  $d s t K $.  $d s t x y z .<_ $.
    $d s t x y z ./\ $.  $d x z N $.  $d s t x y z P $.  $d s t x y z Q $.
    $d s t x y z U $.  $d s t x y z W $.  $d s t x z X $.
    cdleme32.b $e |- B = ( Base ` K ) $.
    cdleme32.l $e |- .<_ = ( le ` K ) $.
    cdleme32.j $e |- .\/ = ( join ` K ) $.
    cdleme32.m $e |- ./\ = ( meet ` K ) $.
    cdleme32.a $e |- A = ( Atoms ` K ) $.
    cdleme32.h $e |- H = ( LHyp ` K ) $.
    cdleme32.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme32.c $e |- C
      = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme32.d $e |- D
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme32.e $e |- E
      = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdleme32.i $e |- I = ( iota_ y e. B A. t e. A
       ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = E ) ) $.
    cdleme32.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , C ) $.
    $d s t y R $.  $d y H $.  $d y K $.  $d y Y $.  $d w A $.  $d w B $.
    $d w .\/ $.  $d w .<_ $.  $d w P $.  $d w Q $.  $d w t y $.  $d w W $.
    $d w Y $.
    ${
      $d w Z $.
      $( Local substitution instances.  Maybe change these to ~ equid . $)
      cdleme32a1.y $e |- Y
          = ( ( P .\/ Q ) ./\ ( D .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
      cdleme32a1.z $e |- Z = ( iota_ y e. B A. t e. A
         ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y = Y ) ) $.
      $( Show that ` [_ R / s ]_ N ` is an atom not under ` W ` when
         ` R .<_ ( P .\/ Q ) ` .  (Contributed by NM, 6-Mar-2013.)
         (New usage is discouraged.) $)
      cdleme32sn1awN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) )
              -> ( [_ R / s ]_ N e. A /\ -. [_ R / s ]_ N .<_ W ) ) $=
        ( cdlemefs32sn1aw ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUKULUMUNUOUPU
        Q $.

      $( Show that ` [_ R / s ]_ N ` is under ` P .\/ Q ` when
         ` R .<_ ( P .\/ Q ) ` .  (Contributed by NM, 19-Mar-2013.) $)
      cdleme41sn3a $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) )
              -> [_ R / s ]_ N .<_ ( P .\/ Q ) ) $=
        ( chlt wcel wa wbr wn w3a wne co csb simp2rl simp3 cdleme31sn1c syl2anc
        wceq cvv cbs cfv fvex eqeltri cv nfv wnf wi wral crio nfra1 nfcv nfcxfr
        nfriota nfbr a1i wb breq1 adantl simpl11 simp12l adantr simprl cdleme4a
        simp13l syl131anc simp1 simp2rr simp2l cdleme25cl syl122anc wrex simp11
        ex simp12 simp13 cdlemb2 syl121anc riotasv3d mpan2 eqbrtrd ) OUQURSLURU
        SZGCURZGSPUTVAZUSZHCURZHSPUTVAZUSZVBZGHVCZICURZISPUTVAZUSZUSZIGHNVDZPUT
        ZVBZUBIRVEZUAYFPYHYBYGYIUAVJYBYCYAXTYGVFZXTYEYGVGZABCDUAEGHIFKMNPQRSTUB
        ULUMUNUOUPVHVIYHDVKURUAYFPUTZDOVLVMVKUCOVLVNVOYHBVPZSPUTVAYMYFPUTVAUSZT
        YFPUTZYLABDCTUAVKYHBVQYLBVRYHBUAYFPBUAYNAVPTVJVSZBCVTZADWAZUPYQBADYPBCW
        BBDWCWEWDBPWCBYFWCWFWGUAYRVJYHUPWGTUAVJYOYLWHYHTUAYFPWIWJYHYMCURZYNUSZY
        OYHYTUSXMXNXQYBYSYOXMXPXSYEYGYTWKYHXNYTXNXOXMXSYEYGWLWMYHXQYTXQXRXMXPYE
        YGWPWMYHYBYTYJWMYHYSYNWNCGHIYMJFTLNOPQSUDUEUFUGUHUIUKUOWOWQXEYHXTYBYCYA
        YGUADURXTYEYGWRYJYBYCYAXTYGWSXTYAYDYGWTZYKACDGHIJFLUANOPQTSBUCUDUEUFUGU
        HUIUKUOUPXAXBYHXMXPXSYAYNBCXCXMXPXSYEYGXDXMXPXSYEYGXFXMXPXSYEYGXGUUACGH
        LNOPSBUDUEUGUHXHXIXJXKXL $.
    $}

    $( Show that ` [_ R / s ]_ N ` is an atom not under ` W ` when
       ` -. R .<_ ( P .\/ Q ) ` .  (Contributed by NM, 6-Mar-2013.)
       (New usage is discouraged.) $)
    cdleme32sn2awN $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
              -> ( [_ R / s ]_ N e. A /\ -. [_ R / s ]_ N .<_ W ) ) $=
      ( cdlemefr32sn2aw ) CDEGHIJLMNOPQRSTUAUBUCUDUEUFUGUHULUM $.

    $( Show that ` [_ R / s ]_ N ` is an atom not under ` W ` .  (Contributed
       by NM, 6-Mar-2013.) $)
    cdleme32snaw $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) ) )
              -> ( [_ R / s ]_ N e. A /\ -. [_ R / s ]_ N .<_ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co csb cv wceq wi wral crio cdlemefs32sn1aw
      eqid 3expa cdlemefr32sn2aw pm2.61dan ) OUMUNSLUNUOGCUNGSPUPUQUOHCUNHSPUPU
      QUOURZGHUSICUNISPUPUQUOUOZUOIGHNUTZPUPZTIRVAZCUNVPSPUPUQUOZVLVMVOVQABCDEF
      GHIJKLMNOPQRSVNFIBVBZNUTSQUTNUTQUTZVRSPUPUQVRVNPUPUQUOAVBVSVCVDBCVEADVFZT
      UAUBUCUDUEUFUGUIUJUKULVSVHVTVHVGVIVLVMVOUQVQCDEGHIJLMNOPQRSTUAUBUCUDUEUFU
      GUHULVJVIVK $.

    $( Show closure of ` [_ R / s ]_ N ` .  (Contributed by NM, 1-Mar-2013.) $)
    cdleme32snb $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) ) ) -> [_ R / s ]_ N e. B ) $=
      ( chlt wcel wa wbr wn w3a wne csb cdleme32snaw simpld atbase syl ) OUMUNS
      LUNUOGCUNGSPUPUQUOHCUNHSPUPUQUOURGHUSICUNISPUPUQUOUOUOZTIRUTZCUNZVFDUNVEV
      GVFSPUPUQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVAVBCDVFOUAUEVCVD $.

    cdleme32.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
          -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    cdleme32.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.

    $d w A $.  $d w N $.  $d s x w z R $.  $d z H $.  $d z K $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  Value of ` F ` at an atom
       not under ` W ` .  (Contributed by NM, 2-Mar-2013.) $)
    cdleme32fva $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( R e. A /\ -. R .<_ W )
         /\ P =/= Q ) -> [_ R / x ]_ O = [_ R / s ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne csb cv co wceq wral crio simp2l atbase eqid
      syl cdleme31so simp1 simp3 simp2 cdleme32snb syl12anc wnf wal nfv nfcsb1v
      wi nfeq2 nfim breq1 notbid csbeq1a eqeq2d imbi12d ax-gen ceqsralt mp3an12
      adantr 3ad2ant2 cp0 cfv simp11 lhpmat syl2anc oveq2d col simp11l ad2antrl
      wb hlol olj01 eqtrd eqeq1d simpl11 simpl12 simpl13 simpr simpl3 syl122anc
      cdleme27cl expr pm5.74d impexp bi2.04 3bitr4g simp2r biimt 3bitr4d riota5
      ralbidva ) RUSUTZUCOUTZVAZIEUTIUCSVBVCVAZJEUTJUCSVBVCVAZVDZKEUTZKUCSVBZVC
      ZVAZIJVEZVDZAKUBVFZUDVGZUCSVBZVCZUUCKUCTVHZQVHZKVIZVACVGZUAUUFQVHZVIZWFZU
      DEVJZCFVKZUDKUAVFZUUAKFUTZUUBUUNVIUUAYPUUPYOYPYRYTVLEFKRUEUIVMVOACEFUUNQS
      TUAUBUCKUDUQUUNVNVPVOUUAUUMCFUUOUUAYOYTYSUUOFUTYOYSYTVQYOYSYTVRYOYSYTVSZB
      DEFGHIJKLMOPQRSTUAUCUDUEUFUGUHUIUJUKULUMUNUOUPVTWAUUAUUMUUIUUOVIZXHUUIFUT
      UUAUUCKVIZUUEUUIUAVIZWFZWFZUDEVJZYRUURWFZUUMUURYSYOUVCUVDXHZYTYPUVEYRUVDU
      DWBUUSUVAUVDXHWFZUDWCYPUVEYRUURUDYRUDWDUDUUIUUOUDKUAWEWGWHUVFUDUUSUUEYRUU
      TUURUUSUUDYQUUCKUCSWIWJUUSUAUUOUUIUDKUAWKWLWMWNUVAUVDUDKEWOWPWQWRUUAUULUV
      BUDEUUAUUCEUTZVAZUUEUUHUUKWFZWFUUEUUSUUTWFZWFUULUVBUVHUUEUVIUVJUUAUVGUUEU
      VIUVJXHUUAUVGUUEVAZVAZUUHUUSUUKUUTUVLUUGUUCKUVLUUGUUCRWSWTZQVHZUUCUVLUUFU
      VMUUCQUUAUUFUVMVIZUVKUUAYLYSUVOYLYMYNYSYTXAUUQEKORSTUCUVMUFUHUVMVNZUIUJXB
      XCWQZXDUVLRXEUTZUUCFUTZUVNUUCVIUVLYJUVRUUAYJUVKYJYKYMYNYSYTXFWQRXIVOZUVGU
      VSUUAUUEEFUUCRUEUIVMXGFQRUUCUVMUEUGUVPXJXCXKXLUVLUUJUAUUIUVLUUJUAUVMQVHZU
      AUVLUUFUVMUAQUVQXDUVLUVRUAFUTZUWAUAVIUVTUVLYLYMYNUVKYTUWBYLYMYNYSYTUVKXMY
      LYMYNYSYTUVKXNYLYMYNYSYTUVKXOUUAUVKXPYOYSYTUVKXQDBEFUAPIJLGOQRSTMUCHUDUEU
      FUGUHUIUJUKULUMUNUOUPXSXRFQRUAUVMUEUGUVPXJXCXKWLWMXTYAUUEUUHUUKYBUUSUUEUU
      TYCYDYIUUAYRUURUVDXHYOYPYRYTYEYRUURYFVOYGWQYHXK $.

    $d z H $.  $d z K $.  $d x z R $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       2-Mar-2013.) $)
    cdleme32fva1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( R e. A /\ -. R .<_ W )
           /\ P =/= Q )
    -> ( F ` R ) = [_ R / s ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne cfv csb wceq simp2l atbase syl simp3 simp2r
      cdleme31fv1s syl12anc cdleme32fva eqtrd ) RUSUTUCOUTVAIEUTIUCSVBVCVAJEUTJ
      UCSVBVCVAVDZKEUTZKUCSVBVCZVAZIJVEZVDZKNVFZAKUBVGZUDKUAVGWCKFUTZWBVTWDWEVH
      WCVSWFVRVSVTWBVIEFKRUEUIVJVKVRWAWBVLVRVSVTWBVMACEFIJNQSTUAUBUCKUDUQURVNVO
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURVPVQ $.

    $( Show that ` ( F `` R ) ` is an atom not under ` W ` when ` R ` is an
       atom not under ` W ` .  (Contributed by NM, 18-Apr-2013.) $)
    cdleme32fvaw $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( R e. A /\ -. R .<_ W ) )
              -> ( ( F ` R ) e. A /\ -. ( F ` R ) .<_ W ) ) $=
      ( chlt wcel wa wbr w3a cfv simplr atbase ad2antrl cdleme31id sylan eleq1d
      wn breq1d notbid anbi12d mpbird wne csb simp1 simp3 cdleme32snaw syl12anc
      wceq simp2 cdleme32fva1 3expa pm2.61dane ) RUSUTUCOUTVAIEUTIUCSVBVKVAJEUT
      JUCSVBVKVAVCZKEUTZKUCSVBZVKZVAZVAZKNVDZEUTZWMUCSVBZVKZVAZIJWLIJWBZVAZWQWK
      WGWKWRVEWSWNWHWPWJWSWMKEWLKFUTZWRWMKWBWHWTWGWJEFKRUEUIVFVGAFIJNSUBUCKURVH
      VIZVJWSWOWIWSWMKUCSXAVLVMVNVOWGWKIJVPZWQWGWKXBVCZWQUDKUAVQZEUTZXDUCSVBZVK
      ZVAZXCWGXBWKXHWGWKXBVRWGWKXBVSWGWKXBWCBDEFGHIJKLMOPQRSTUAUCUDUEUFUGUHUIUJ
      UKULUMUNUOUPVTWAXCWNXEWPXGXCWMXDEABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJ
      UKULUMUNUOUPUQURWDZVJXCWOXFXCWMXDUCSXIVLVMVNVOWEWF $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  Closure of the function
       ` F ` .  (Contributed by NM, 10-Feb-2013.) $)
    cdleme32fvcl $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ X e. B ) -> ( F ` X ) e. B ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral crio cdleme31fv1 adantll
      simpll1 simpll2 simpll3 simprl simplr simprr cdleme29cl syl312anc eqeltrd
      cfv eqid cdleme31fv2 simpl pm2.61dan ) QUSUTUBNUTVAZIEUTIUBRVBVCVAZJEUTJU
      BRVBVCVAZVDZUCFUTZVAZIJVEZUCUBRVBVCZVAZUCMWCZFUTZWMWPVAZWQUDVFZUBRVBVCWTU
      CUBSVGZPVGUCVHVACVFTXAPVGVHVIUDEVJCFVKZFWLWPWQXBVHWKACEFXBIJMPRSTUAUBUCUD
      UQURXBWDZVLVMWSWHWIWJWNWLWOXBFUTWHWIWJWLWPVNWHWIWJWLWPVOWHWIWJWLWPVPWMWNW
      OVQWKWLWPVRWMWNWOVSDCBEFTOIJKGNXBPQRSLUBUCHUDUEUFUGUHUIUJUKULUMUNUOUPXCVT
      WAWBWLWPVCZWRWKWLXDVAWQUCFAFIJMRUAUBUCURWEWLXDWFWBVMWG $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       19-Feb-2013.) $)
    cdleme32a $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ ( P =/= Q /\ -. X .<_ W ) )
           /\ ( ( s e. A /\ -. s .<_ W ) /\ ( s .\/ ( X ./\ W ) ) = X ) )
       -> ( F ` X ) = ( N .\/ ( X ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq cfv cvv wi cbs fvex eqeltri wral
      anass crio cdleme31fv1 adantl cdleme32fvcl adantrr riotasvd syl5bi 3impia
      eqid mpan2 ) QUSUTUBNUTVAIEUTIUBRVBVCVAJEUTJUBRVBVCVAVDZUCFUTZIJVEUCUBRVB
      VCVAZVAZUDVFZEUTZWKUBRVBVCZVAWKUCUBSVGZPVGUCVHZVAZUCMVIZTWNPVGZVHZWGWJVAZ
      FVJUTZWPWSVKFQVLVIVJUEQVLVMVNWPWLWMWOVAZVAWTXAVAWSWLWMWOVPWTXBCUDFEWRWQVJ
      WJWQXBCVFWRVHVKUDEVOCFVQZVHWGACEFXCIJMPRSTUAUBUCUDUQURXCWEVRVSWGWHWQFUTWI
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURVTWAWBWCWFWD $.

    $d s t x z Y $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       19-Feb-2013.) $)
    cdleme32b $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B /\ ( P =/= Q /\ -. X .<_ W ) )
           /\ ( ( s e. A /\ -. s .<_ W ) /\ ( s .\/ ( X ./\ W ) ) = X
             /\ X .<_ Y ) )
       -> ( F ` Y ) = ( N .\/ ( Y ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq cfv simp1 simp22 simp23l simp23r
      simp33 clat simp11l hllat syl simp21 simp11r lhpbase lattr syl13anc mpand
      wi mtod jca simp31 simp11 simp31l cdleme30a syl132anc cdleme32a syl122anc
      simp32 ) QUTVAZUBNVAZVBZIEVAIUBRVCVDVBZJEVAJUBRVCVDVBZVEZUCFVAZUDFVAZIJVF
      ZUCUBRVCZVDZVBZVEZUEVGZEVAZXJUBRVCVDZVBZXJUCUBSVHPVHUCVIZUCUDRVCZVEZVEZXB
      XDXEUDUBRVCZVDZVBXMXJUDUBSVHZPVHUDVIZUDMVJTXTPVHVIXBXIXPVKXBXCXDXHXPVLZXQ
      XEXSXEXGXCXDXBXPVMXQXRXFXEXGXCXDXBXPVNZXQXOXRXFXBXIXMXNXOVOZXQQVPVAZXCXDU
      BFVAZXOXRVBXFWFXQWQYEWQWRWTXAXIXPVQQVRVSXBXCXDXHXPVTZYBXQWRYFWQWRWTXAXIXP
      WAFNQUBUFUKWBVSFQRUCUDUBUFUGWCWDWEWGWHXBXIXMXNXOWIXQWSXKXCXGVBXDXNXOYAWSW
      TXAXIXPWJXKXLXNXOXBXIWKXQXCXGYGYCWHYBXBXIXMXNXOWPYDEFNPQRSUBUCUDUEUFUGUHU
      IUJUKWLWMABCDEFGHIJKLMNOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSWNWO $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       19-Feb-2013.) $)
    cdleme32c $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B /\ ( P =/= Q /\ -. X .<_ W ) )
           /\ ( ( s e. A /\ -. s .<_ W ) /\ ( s .\/ ( X ./\ W ) ) = X
             /\ X .<_ Y ) )
       -> ( F ` X ) .<_ ( F ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq cfv simp33 clat wi simp11l hllat
      syl simp21 simp22 simp11r lhpbase latmlem1 syl13anc latmcl syl3anc simp12
      simp13 simp31 cdleme27cl syl222anc latjlej2 simp1 simp23 simp32 cdleme32a
      mpd simp23l syl122anc cdleme32b 3brtr4d ) QUTVAZUBNVAZVBZIEVAIUBRVCVDVBZJ
      EVAJUBRVCVDVBZVEZUCFVAZUDFVAZIJVFZUCUBRVCVDZVBZVEZUEVGZEVAXLUBRVCVDVBZXLU
      CUBSVHZPVHUCVIZUCUDRVCZVEZVEZTXNPVHZTUDUBSVHZPVHZUCMVJZUDMVJRXRXNXTRVCZXS
      YARVCZXRXPYCXEXKXMXOXPVKXRQVLVAZXFXGUBFVAZXPYCVMXRWTYEWTXAXCXDXKXQVNZQVOV
      PZXEXFXGXJXQVQZXEXFXGXJXQVRZXRXAYFWTXAXCXDXKXQVSZFNQUBUFUKVTVPZFQRSUCUDUB
      UFUGUIWAWBWOXRYEXNFVAZXTFVAZTFVAZYCYDVMYHXRYEXFYFYMYHYIYLFQSUCUBUFUIWCWDX
      RYEXGYFYNYHYJYLFQSUDUBUFUIWCWDXRWTXAXCXDXMXHYOYGYKXBXCXDXKXQWEXBXCXDXKXQW
      FXEXKXMXOXPWGZXHXIXFXGXEXQWPDBEFTOIJKGNPQRSLUBHUEUFUGUHUIUJUKULUMUNUOUPUQ
      WHWIFPQRXNXTTUFUGUHWJWBWOXRXEXFXJXMXOYBXSVIXEXKXQWKYIXEXFXGXJXQWLYPXEXKXM
      XOXPWMABCDEFGHIJKLMNOPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSWNWQABCDEFG
      HIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSWRWS $.

    $d a A $.  $d a B $.  $d a F $.  $d a .\/ $.  $d a .<_ $.  $d a ./\ $.
    $d a N $.  $d a O $.  $d a P $.  $d a Q $.  $d a W $.  $d a X $.  $d a Y $.
    $d s a $.  $d x a $.  $d z a $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       20-Feb-2013.) $)
    cdleme32d $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B /\ ( P =/= Q /\ -. X .<_ W ) )
           /\ X .<_ Y )
       -> ( F ` X ) .<_ ( F ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wrex cfv simp11 simp23r lhpmcvr2
      simp21 syl12anc nfv cif cmpt nfcv wi wral crio nfra1 nfriota nfcxfr nfmpt
      nfif nffv simpl1 simpl2 simprl simprrl simprrr simpl3 cdleme32c syl113anc
      nfbr jca exp32 rexlimd mpd ) QUTVAUBNVAVBZIEVAIUBRVCVDVBZJEVAJUBRVCVDVBZV
      EZUCFVAZUDFVAZIJVFZUCUBRVCVDZVBZVEZUCUDRVCZVEZUEVGZUBRVCVDZXOUCUBSVHPVHUC
      VIZVBZUEEVJZUCMVKZUDMVKZRVCZXNXCXGXJXSXCXDXEXLXMVLXFXGXHXKXMVOXIXJXGXHXFX
      MVMEFNPQRSUBUCUEUFUGUHUIUJUKVNVPXNXRYBUEEXNUEVQUEXTYARUEUCMUEMAFXIAVGZUBR
      VCVDVBZUAYCVRZVSUSUEAFYEUEFVTZYDUEUAYCYDUEVQUEUAXPXOYCUBSVHZPVHYCVIVBCVGT
      YGPVHVIWAZUEEWBZCFWCURYIUECFYHUEEWDYFWEWFUEYCVTWHWGWFZUEUCVTWIUERVTUEUDMY
      JUEUDVTWIWRXNXOEVAZXRYBXNYKXRVBZVBZXFXLYKXPVBXQXMYBXFXLXMYLWJXFXLXMYLWKYM
      YKXPXNYKXRWLXNYKXPXQWMWSXNYKXPXQWNXFXLXMYLWOABCDEFGHIJKLMNOPQRSTUAUBUCUDU
      EUFUGUHUIUJUKULUMUNUOUPUQURUSWPWQWTXAXB $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       20-Feb-2013.) $)
    cdleme32e $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( X e. B /\ Y e. B )
             /\ -. ( P =/= Q /\ -. X .<_ W )
             /\ ( P =/= Q /\ -. Y .<_ W ) )
           /\ ( ( s e. A /\ -. s .<_ W ) /\ ( s .\/ ( Y ./\ W ) ) = Y
             /\ X .<_ Y ) )
       -> ( F ` X ) .<_ ( F ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq cfv simp23l pm2.24d clat simp11l
      hllat syl simp21l simp11r lhpbase latleeqm1 syl3anc latmcl simp21r simp11
      simp12 simp13 simp31 cdleme27cl syl122anc latjcl simp33 latmlem1 syl13anc
      wb wi latlej2 lattrd breq1 syl5ibcom sylbid wo simp22 pm4.53 sylib mpjaod
      mpd cdleme31fv2 syl2anc simp1 simp23 simp32 cdleme32a 3brtr4d ) QUTVAZUBN
      VAZVBZIEVAIUBRVCVDVBZJEVAJUBRVCVDVBZVEZUCFVAZUDFVAZVBZIJVFZUCUBRVCZVDVBVD
      ZYCUDUBRVCVDZVBZVEZUEVGZEVAYIUBRVCVDVBZYIUDUBSVHZPVHUDVIZUCUDRVCZVEZVEZUC
      TYKPVHZUCMVJZUDMVJZRYOYCVDZUCYPRVCZYDYOYCYTYCYFYBYEXSYNVKZVLYOYDUCUBSVHZU
      CVIZYTYOQVMVAZXTUBFVAZYDUUCWNYOXNUUDXNXOXQXRYHYNVNQVOVPZXTYAYEYGXSYNVQZYO
      XOUUEXNXOXQXRYHYNVRFNQUBUFUKVSVPZFQRSUCUBUFUGUIVTWAYOUUBYPRVCUUCYTYOFQRUU
      BYKYPUFUGUUFYOUUDXTUUEUUBFVAUUFUUGUUHFQSUCUBUFUIWBWAYOUUDYAUUEYKFVAZUUFXT
      YAYEYGXSYNWCZUUHFQSUDUBUFUIWBWAZYOUUDTFVAZUUIYPFVAUUFYOXPXQXRYJYCUULXPXQX
      RYHYNWDXPXQXRYHYNWEXPXQXRYHYNWFXSYHYJYLYMWGZUUADBEFTOIJKGNPQRSLUBHUEUFUGU
      HUIUJUKULUMUNUOUPUQWHWIZUUKFPQTYKUFUHWJWAYOYMUUBYKRVCZXSYHYJYLYMWKYOUUDXT
      YAUUEYMUUOWOUUFUUGUUJUUHFQRSUCUDUBUFUGUIWLWMXFYOUUDUULUUIYKYPRVCUUFUUNUUK
      FPQRTYKUFUGUHWPWAWQUUBUCYPRWRWSWTYOYEYSYDXAXSYBYEYGYNXBZYCYDXCXDXEYOXTYEY
      QUCVIUUGUUPAFIJMRUAUBUCUSXGXHYOXSYAYGYJYLYRYPVIXSYHYNXIUUJXSYBYEYGYNXJUUM
      XSYHYJYLYMXKABCDEFGHIJKLMNOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSXLWIX
      M $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       20-Feb-2013.) $)
    cdleme32f $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( X e. B /\ Y e. B )
             /\ -. ( P =/= Q /\ -. X .<_ W )
             /\ ( P =/= Q /\ -. Y .<_ W ) )
           /\ X .<_ Y )
       -> ( F ` X ) .<_ ( F ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wrex cfv simp11 simp21r lhpmcvr2
      simp23r syl12anc nfv cif cmpt nfcv wi wral crio nfra1 nfriota nfcxfr nfif
      nfmpt nffv nfbr simpl1 simpl2 simprl simprrl jca simprrr simpl3 cdleme32e
      syl113anc exp32 rexlimd mpd ) QUTVAUBNVAVBZIEVAIUBRVCVDVBZJEVAJUBRVCVDVBZ
      VEZUCFVAZUDFVAZVBZIJVFZUCUBRVCVDVBVDZXJUDUBRVCVDZVBZVEZUCUDRVCZVEZUEVGZUB
      RVCVDZXQUDUBSVHPVHUDVIZVBZUEEVJZUCMVKZUDMVKZRVCZXPXCXHXLYAXCXDXEXNXOVLXGX
      HXKXMXFXOVMXJXLXIXKXFXOVOEFNPQRSUBUDUEUFUGUHUIUJUKVNVPXPXTYDUEEXPUEVQUEYB
      YCRUEUCMUEMAFXJAVGZUBRVCVDVBZUAYEVRZVSUSUEAFYGUEFVTZYFUEUAYEYFUEVQUEUAXRX
      QYEUBSVHZPVHYEVIVBCVGTYIPVHVIWAZUEEWBZCFWCURYKUECFYJUEEWDYHWEWFUEYEVTWGWH
      WFZUEUCVTWIUERVTUEUDMYLUEUDVTWIWJXPXQEVAZXTYDXPYMXTVBZVBZXFXNYMXRVBXSXOYD
      XFXNXOYNWKXFXNXOYNWLYOYMXRXPYMXTWMXPYMXRXSWNWOXPYMXRXSWPXFXNXOYNWQABCDEFG
      HIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSWRWSWTXAXB $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       20-Feb-2013.) $)
    cdleme32le $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B )
           /\ X .<_ Y ) -> ( F ` X ) .<_ ( F ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv simpl1 simpl2l simpl2r simpl3 cdleme32d
      simpr syl131anc wi simp11 simp12 simp3 simp13 cdleme32f 3exp wceq simp12l
      simp2 cdleme31fv2 syl2anc simp12r 3brtr4d pm2.61d imp pm2.61dan ) QUTVAUB
      NVAVBIEVAIUBRVCVDVBJEVAJUBRVCVDVBVEZUCFVAZUDFVAZVBZUCUDRVCZVEZIJVFZUCUBRV
      CVDVBZUCMVGZUDMVGZRVCZWQWSVBWLWMWNWSWPXBWLWOWPWSVHWMWNWLWPWSVIWMWNWLWPWSV
      JWQWSVMWLWOWPWSVKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQUR
      USVLVNWQWSVDZXBWQWRUDUBRVCVDVBZXCXBVOWQXDXCXBWQXDXCVEWLWOXCXDWPXBWLWOWPXD
      XCVPWLWOWPXDXCVQWQXDXCVRWQXDXCWDWLWOWPXDXCVSABCDEFGHIJKLMNOPQRSTUAUBUCUDU
      EUFUGUHUIUJUKULUMUNUOUPUQURUSVTVNWAWQXDVDZXCXBWQXEXCVEZUCUDWTXARWLWOWPXEX
      CVSXFWMXCWTUCWBWMWNWLWPXEXCWCWQXEXCVRAFIJMRUAUBUCUSWEWFXFWNXEXAUDWBWMWNWL
      WPXEXCWGWQXEXCWDAFIJMRUAUBUDUSWEWFWHWAWIWJWK $.
  $}

  ${
    cdleme35.l $e |- .<_ = ( le ` K ) $.
    cdleme35.j $e |- .\/ = ( join ` K ) $.
    cdleme35.m $e |- ./\ = ( meet ` K ) $.
    cdleme35.a $e |- A = ( Atoms ` K ) $.
    cdleme35.h $e |- H = ( LHyp ` K ) $.
    cdleme35.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme35.f $e |- F
      = ( ( R .\/ U ) ./\ ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35a $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) ) -> ( F .\/ U ) = ( R .\/ U ) ) $=
      ( wcel chlt wa wbr wn w3a wne wceq clat cbs cfv simp11l hllat syl simp2rl
      co eqid atbase simp11 simp12 simp13 simp2r simp2l simp3 cdleme3fa latlej2
      syl132anc syl3anc simp12l simp13l syl13anc cdleme0a syl112anc wb latjle12
      cdleme1 breqtrd hlatjcl mpbi2and cdleme3g ps-1 mpbid ) IUATZLGTZUBZBATZBL
      JUCUDZUBZCATZCLJUCUDZUBZUEZBCUFZDATZDLJUCUDZUBZUBZDBCHUOJUCUDZUEZFEHUOZDE
      HUOZJUCZWSWTUGZWRFWTJUCZEWTJUCZXAWRFDFHUOZWTJWRIUHTZDIUIUJZTZFXGTZFXEJUCW
      RWBXFWBWCWGWJWPWQUKZIULUMZWRWMXHWMWNWLWKWQUNZAXGDIXGUPZPUQUMZWRFATZXIWRWD
      WGWJWOWLWQXOWDWGWJWPWQURZWDWGWJWPWQUSZWDWGWJWPWQUTZWKWLWOWQVAZWKWLWOWQVBZ
      WKWPWQVCZABCDEFGHIJKLMNOPQRSVDVFZAXGFIXMPUQUMZXGHIJDFXMMNVEVGWRWDWEWHWOXE
      WTUGXPWEWFWDWJWPWQVHWHWIWDWGWPWQVIZXSABCDEFGHIJKLMNOPQRSVOVJVPWRXFXHEXGTZ
      XDXKXNWREATZYEWRWDWGWHWLYFXPXQYDXTABCEGHIJKLMNOPQRVKVLZAXGEIXMPUQUMZXGHIJ
      DEXMMNVEVGWRXFXIYEWTXGTZXCXDUBXAVMXKYCYHWRWBWMYFYIXJXLYGAXGHIDEXMNPVQVGXG
      HIJFEWTXMMNVNVJVRWRWBXOYFFEUFZWMYFXAXBVMXJYBYGWRWDWGWJWOWLWQYJXPXQXRXSXTY
      AABCDEFGHIJKBDHUOLKUOZLMNOPQRSYKUPVSVFXLYGAFEDEHIJMNPVTVFWA $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 19-Mar-2013.) $)
    cdleme35fnpq $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) ) -> -. F .<_ ( P .\/ Q ) ) $=
      ( wcel chlt wa wbr wn w3a wne co simp3 simp11 simp12l cdlemeulpq syl12anc
      simp13l clat cbs cfv wb simp11l hllat syl simp2rl eqid cdleme1b cdleme0aa
      syl13anc syl3anc hlatjcl latjle12 biimpd mpan2d atbase cdleme35a breqtrrd
      latlej1 wi latjcl lattr mpand syld mtod ) IUATZLGTZUBZBATZBLJUCUDZUBZCATZ
      CLJUCUDZUBZUEZBCUFZDATZDLJUCUDZUBUBZDBCHUGZJUCZUDZUEZFWOJUCZWPWJWNWQUHWRW
      SFEHUGZWOJUCZWPWRWSEWOJUCZXAWRWCWDWGXBWCWFWIWNWQUIZWDWEWCWIWNWQUJZWGWHWCW
      FWNWQUMZABCEGHIJKLMNOPQRUKULWRWSXBUBZXAWRIUNTZFIUOUPZTZEXHTZWOXHTZXFXAUQW
      RWAXGWAWBWFWIWNWQURZIUSUTZWRWCWDWGWLXIXCXDXEWLWMWKWJWQVAZAXHBCDEFGHIJKLMN
      OPQRSXHVBZVCVEZWRWCWDWGXJXCXDXEAXHBCEGHIJKLMNOPQRXOVDVFZWRWAWDWGXKXLXDXEA
      XHHIBCXONPVGVFZXHHIJFEWOXOMNVHVEVIVJWRDWTJUCZXAWPWRDDEHUGZWTJWRXGDXHTZXJD
      XTJUCXMWRWLYAXNAXHDIXOPVKUTZXQXHHIJDEXOMNVNVFABCDEFGHIJKLMNOPQRSVLVMWRXGY
      AWTXHTZXKXSXAUBWPVOXMYBWRXGXIXJYCXMXPXQXHHIFEXONVPVFXRXHIJDWTWOXOMVQVEVRV
      SVT $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35b $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
       /\ -. R .<_ ( P .\/ Q ) )
     -> ( Q .\/ ( ( P .\/ R ) ./\ W ) ) .<_ ( Q .\/ ( R .\/ U ) ) ) $=
      ( wcel chlt wa wbr wn w3a wne clat cbs cfv simp11l hllat syl simp13l eqid
      co atbase simp2rl simp11 simp12 simp2l cdleme0a syl112anc hlatjcl syl3anc
      latlej1 simp12l latjcl simp11r lhpbase latmcl latmle1 lattrd cp1 hlatlej2
      oveq2i wceq atmod3i1 syl131anc simp13 lhpjat2 syl2anc oveq2d olm11 3eqtrd
      col hlol syl5eq hlatj12 syl13anc hlatjcom hlatjass eqtrd 3eqtr4rd breqtrd
      oveq1d wb latjle12 mpbi2and ) IUATZLGTZUBZBATZBLJUCUDZUBZCATZCLJUCUDZUBZU
      EZBCUFZDATZDLJUCUDZUBZUBZDBCHUOZJUCUDZUEZCCDEHUOZHUOZJUCZBDHUOZLKUOZXRJUC
      ZCYAHUOXRJUCZXPIUGTZCIUHUIZTZXQYETZXSXPWSYDWSWTXDXGXMXOUJZIUKULZXPXEYFXEX
      FXAXDXMXOUMZAYECIYEUNZPUPULZXPWSXJEATZYGYHXJXKXIXHXOUQZXPXAXDXEXIYMXAXDXG
      XMXOURZXAXDXGXMXOUSYJXHXIXLXOUTABCEGHIJKLMNOPQRVAVBZAYEHIDEYKNPVCVDZYEHIJ
      CXQYKMNVEVDXPYAXTCHUOZXRJXPYEIJYAXTYRYKMYIXPYDXTYETZLYETZYAYETZYIXPYDBYET
      ZDYETZYSYIXPXBUUBXBXCXAXGXMXOVFZAYEBIYKPUPULXPXJUUCYNAYEDIYKPUPULYEHIBDYK
      NVGVDZXPWTYTWSWTXDXGXMXOVHYEGILYKQVIULZYEIKXTLYKOVJVDZUUEXPYDYSYFYRYETYIU
      UEYLYEHIXTCYKNVGVDXPYDYSYTYAXTJUCYIUUEUUFYEIJKXTLYKMOVKVDXPYDYSYFXTYRJUCY
      IUUEYLYEHIJXTCYKMNVEVDVLXPDCEHUOZHUOZDXNHUOZXRYRXPUUHXNDHXPUUHCXNLKUOZHUO
      ZXNEUUKCHRVOXPUULXNCLHUOZKUOZXNIVMUIZKUOZXNXPWSXEXNYETZYTCXNJUCZUULUUNVPY
      HYJXPWSXBXEUUQYHUUDYJAYEHIBCYKNPVCVDZUUFXPWSXBXEUURYHUUDYJABCHIJMNPVNVDAY
      ECHIJKXNLYKMNOPVQVRXPUUMUUOXNKXPXAXGUUMUUOVPYOXAXDXGXMXOVSACUUOGHIJLMNUUO
      UNZPQVTWAWBXPIWETZUUQUUPXNVPXPWSUVAYHIWFULUUSYEUUOIKXNYKOUUTWCWAWDWGWBXPW
      SXEXJYMXRUUIVPYHYJYNYPACDEHINPWHWIXPYRDBHUOZCHUOZUUJXPXTUVBCHXPWSXBXJXTUV
      BVPYHUUDYNAHIBDNPWJVDWOXPWSXJXBXEUVCUUJVPYHYNUUDYJADBCHINPWKWIWLWMWNXPYDY
      FUUAXRYETZXSYBUBYCWPYIYLUUGXPYDYFYGUVDYIYLYQYEHICXQYKNVGVDYEHIJCYAXRYKMNW
      QWIWR $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35c $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
               -> ( Q .\/ F ) = ( Q .\/ ( ( P .\/ R ) ./\ W ) ) ) $=
      ( wcel chlt wa wbr wn w3a wne oveq2i cbs cfv wceq simp11l simp13l simp2rl
      co simp11 simp12 simp2l cdleme0a syl112anc eqid hlatjcl syl3anc hllat syl
      atbase simp12l simp11r lhpbase latmcl latjcl atmod1i1 syl131anc cdleme35b
      clat latlej1 wb latleeqm2 mpbid eqtrd syl5eq ) IUATZLGTZUBZBATZBLJUCUDZUB
      ZCATZCLJUCUDZUBZUEZBCUFZDATZDLJUCUDZUBZUBZDBCHUNJUCUDZUEZCFHUNCDEHUNZCBDH
      UNZLKUNZHUNZKUNZHUNZXAFXBCHSUGWQXCCWRHUNZXAKUNZXAWQWAWGWRIUHUIZTZXAXFTZCX
      AJUCZXCXEUJWAWBWFWIWOWPUKZWGWHWCWFWOWPULZWQWAWLEATZXGXJWLWMWKWJWPUMZWQWCW
      FWGWKXLWCWFWIWOWPUOWCWFWIWOWPUPXKWJWKWNWPUQABCEGHIJKLMNOPQRURUSAXFHIDEXFU
      TZNPVAVBZWQIVNTZCXFTZWTXFTZXHWQWAXPXJIVCVDZWQWGXQXKAXFCIXNPVEVDZWQXPWSXFT
      ZLXFTZXRXSWQWAWDWLYAXJWDWEWCWIWOWPVFXMAXFHIBDXNNPVAVBWQWBYBWAWBWFWIWOWPVG
      XFGILXNQVHVDXFIKWSLXNOVIVBZXFHICWTXNNVJVBZWQXPXQXRXIXSXTYCXFHIJCWTXNMNVOV
      BAXFCHIJKWRXAXNMNOPVKVLWQXAXDJUCZXEXAUJZABCDEFGHIJKLMNOPQRSVMWQXPXHXDXFTZ
      YEYFVPXSYDWQXPXQXGYGXSXTXOXFHICWRXNNVJVBXFIJKXAXDXNMOVQVBVRVSVT $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35d $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
               -> ( ( Q .\/ F ) ./\ W ) = ( ( P .\/ R ) ./\ W ) ) $=
      ( wcel chlt wa wbr wn w3a wne co cdleme35c oveq1d cbs cfv simp11l simp13l
      wceq clat syl simp12l simp2rl eqid hlatjcl syl3anc simp11r lhpbase latmcl
      hllat latmle2 atmod4i2 syl131anc cp0 simp11 simp13 syl2anc col hlol olj02
      lhpmat eqtrd 3eqtr2d ) IUATZLGTZUBZBATZBLJUCUDZUBZCATZCLJUCUDZUBZUEZBCUFZ
      DATZDLJUCUDZUBUBZDBCHUGJUCUDZUEZCFHUGZLKUGCBDHUGZLKUGZHUGZLKUGZCLKUGZWQHU
      GZWQWNWOWRLKABCDEFGHIJKLMNOPQRSUHUIWNVSWEWQIUJUKZTZLXBTZWQLJUCZXAWSUNVSVT
      WDWGWLWMULZWEWFWAWDWLWMUMWNIUOTZWPXBTZXDXCWNVSXGXFIVEUPZWNVSWBWJXHXFWBWCW
      AWGWLWMUQWJWKWIWHWMURAXBHIBDXBUSZNPUTVAZWNVTXDVSVTWDWGWLWMVBXBGILXJQVCUPZ
      XBIKWPLXJOVDVAZXLWNXGXHXDXEXIXKXLXBIJKWPLXJMOVFVAAXBCHIJKWQLXJMNOPVGVHWNX
      AIVIUKZWQHUGZWQWNWTXNWQHWNWAWGWTXNUNWAWDWGWLWMVJWAWDWGWLWMVKACGIJKLXNMOXN
      USZPQVPVLUIWNIVMTZXCXOWQUNWNVSXQXFIVNUPXMXBHIWQXNXJNXPVOVLVQVR $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35e $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
               -> ( P .\/ ( ( Q .\/ F ) ./\ W ) ) = ( P .\/ R ) ) $=
      ( co chlt wcel wa wbr wn w3a wne cdleme35d oveq2d cbs cfv simp11l simp12l
      wceq simp2rl eqid hlatjcl syl3anc simp11r syl hlatlej1 atmod3i1 syl131anc
      lhpbase cp1 simp11 simp12 lhpjat2 syl2anc col hlol olm11 eqtrd 3eqtrd ) I
      UAUBZLGUBZUCZBAUBZBLJUDUEZUCZCAUBCLJUDUEUCZUFZBCUGZDAUBZDLJUDUEZUCUCZDBCH
      TJUDUEZUFZBCFHTLKTZHTBBDHTZLKTZHTZWJBLHTZKTZWJWHWIWKBHABCDEFGHIJKLMNOPQRS
      UHUIWHVOVRWJIUJUKZUBZLWOUBZBWJJUDZWLWNUNVOVPVTWAWFWGULZVRVSVQWAWFWGUMZWHV
      OVRWDWPWSWTWDWEWCWBWGUOZAWOHIBDWOUPZNPUQURZWHVPWQVOVPVTWAWFWGUSWOGILXBQVD
      UTWHVOVRWDWRWSWTXAABDHIJMNPVAURAWOBHIJKWJLXBMNOPVBVCWHWNWJIVEUKZKTZWJWHWM
      XDWJKWHVQVTWMXDUNVQVTWAWFWGVFVQVTWAWFWGVGABXDGHIJLMNXDUPZPQVHVIUIWHIVJUBZ
      WPXEWJUNWHVOXGWSIVKUTXCWOXDIKWJXBOXFVLVIVMVN $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35f $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
               -> ( ( R .\/ U ) ./\ ( P .\/ R ) ) = R ) $=
      ( wcel chlt wa wbr wn w3a wne co simp11l simp12l simp2rl hlatjcom syl3anc
      wceq oveq2d simp11 simp12 simp13l cdleme0a syl112anc simp12r clat cbs cfv
      simp2l hllat syl hlatjcl simp11r lhpbase latmle2 syl5eqbr breq1 syl5ibcom
      eqid necon3bd simp3 latmle1 hlatlej1 wb atbase latjle12 syl13anc mpbi2and
      mpd wi lattr mpan2d mtod 2llnma2 syl132anc eqtrd ) IUATZLGTZUBZBATZBLJUCZ
      UDZUBZCATZCLJUCUDZUBZUEZBCUFZDATZDLJUCUDZUBZUBZDBCHUGZJUCZUDZUEZDEHUGZBDH
      UGZKUGXLDBHUGZKUGZDXKXMXNXLKXKWLWOXDXMXNUMWLWMWRXAXGXJUHZWOWQWNXAXGXJUIZX
      DXEXCXBXJUJZAHIBDNPUKULUNXKWLEATZWOXDEBUFZDEBHUGZJUCZUDXODUMXPXKWNWRWSXCX
      SWNWRXAXGXJUOWNWRXAXGXJUPWSWTWNWRXGXJUQZXBXCXFXJVDABCEGHIJKLMNOPQRURUSZXQ
      XRXKWQXTWOWQWNXAXGXJUTXKWPEBXKELJUCEBUMWPXKEXHLKUGZLJRXKIVATZXHIVBVCZTZLY
      GTZYELJUCXKWLYFXPIVEVFZXKWLWOWSYHXPXQYCAYGHIBCYGVNZNPVGULZXKWMYIWLWMWRXAX
      GXJVHYGGILYKQVIVFZYGIJKXHLYKMOVJULVKEBLJVLVMVOWDXKYBXIXBXGXJVPXKYBYAXHJUC
      ZXIXKEXHJUCZBXHJUCZYNXKEYEXHJRXKYFYHYIYEXHJUCYJYLYMYGIJKXHLYKMOVQULVKXKWL
      WOWSYPXPXQYCABCHIJMNPVRULXKYFEYGTZBYGTZYHYOYPUBYNVSYJXKXSYQYDAYGEIYKPVTVF
      XKWOYRXQAYGBIYKPVTVFYLYGHIJEBXHYKMNWAWBWCXKYFDYGTZYAYGTZYHYBYNUBXIWEYJXKX
      DYSXRAYGDIYKPVTVFXKWLXSWOYTXPYDXQAYGHIEBYKNPVGULYLYGIJDYAXHYKMWFWBWGWHAEB
      DHIJKMNOPWIWJWK $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 10-Mar-2013.) $)
    cdleme35g $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
           -> ( ( F .\/ U ) ./\ ( P .\/ ( ( Q .\/ F ) ./\ W ) ) ) = R ) $=
      ( co chlt wcel wa wbr w3a wne cdleme35a cdleme35e oveq12d cdleme35f eqtrd
      wn ) IUAUBLGUBUCBAUBBLJUDULUCCAUBCLJUDULUCUEBCUFDAUBDLJUDULUCUCDBCHTJUDUL
      UEZFEHTZBCFHTLKTHTZKTDEHTZBDHTZKTDUMUNUPUOUQKABCDEFGHIJKLMNOPQRSUGABCDEFG
      HIJKLMNOPQRSUHUIABCDEFGHIJKLMNOPQRSUJUK $.

    ${
      cdleme35.g $e |- G
          = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
         one-to-one outside of ` P .\/ Q ` line.  TODO:  FIX COMMENT
         (Contributed by NM, 11-Mar-2013.) $)
      cdleme35h $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
          /\ ( S e. A /\ -. S .<_ W ) )
         /\ ( -. R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) /\ F = G ) )
                -> R = S ) $=
        ( chlt wcel wa wbr wn w3a wne co wceq oveq1 oveq2 oveq1d oveq2d oveq12d
        3ad2ant3 simp21 simp22 simp31 cdleme35g syl121anc simp23 simp32 3eqtr3d
        simp1 ) KUCUDNIUDUEBAUDBNLUFUGUECAUDCNLUFUGUEUHZBCUIZDAUDDNLUFUGUEZEAUD
        ENLUFUGUEZUHZDBCJUJZLUFUGZEVLLUFUGZGHUKZUHZUHZGFJUJZBCGJUJZNMUJZJUJZMUJ
        ZHFJUJZBCHJUJZNMUJZJUJZMUJZDEVPVGWBWGUKZVKVOVMWHVNVOVRWCWAWFMGHFJULVOVT
        WEBJVOVSWDNMGHCJUMUNUOUPUQUQVQVGVHVIVMWBDUKVGVKVPVFZVGVHVIVJVPURZVGVHVI
        VJVPUSVGVKVMVNVOUTABCDFGIJKLMNOPQRSTUAVAVBVQVGVHVJVNWGEUKWIWJVGVHVIVJVP
        VCVGVKVMVNVOVDABCEFHIJKLMNOPQRSTUBVAVBVE $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
         one-to-one outside of ` P .\/ Q ` line.  TODO:  FIX COMMENT
         (Contributed by NM, 18-Mar-2013.) $)
      cdleme35h2 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
            /\ ( S e. A /\ -. S .<_ W ) )
         /\ ( -. R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) /\ R =/= S ) )
                -> F =/= G ) $=
        ( chlt wcel wa wbr wn w3a wne simp33 wceq simpl1 simpl2 simpl31 simpl32
        co simpr cdleme35h syl113anc ex necon3d mpd ) KUCUDNIUDUEBAUDBNLUFUGUEC
        AUDCNLUFUGUEUHZBCUIDAUDDNLUFUGUEEAUDENLUFUGUEUHZDBCJUPZLUFUGZEVELUFUGZD
        EUIZUHZUHZVHGHUIVCVDVFVGVHUJVJGHDEVJGHUKZDEUKZVJVKUEVCVDVFVGVKVLVCVDVIV
        KULVCVDVIVKUMVFVGVHVCVDVKUNVFVGVHVCVDVKUOVJVKUQABCDEFGHIJKLMNOPQRSTUAUB
        URUSUTVAVB $.
    $}
  $}

  ${
    cdleme32s.b $e |- B = ( Base ` K ) $.
    cdleme32s.l $e |- .<_ = ( le ` K ) $.
    cdleme32s.j $e |- .\/ = ( join ` K ) $.
    cdleme32s.m $e |- ./\ = ( meet ` K ) $.
    cdleme32s.a $e |- A = ( Atoms ` K ) $.
    cdleme32s.h $e |- H = ( LHyp ` K ) $.
    cdleme32s.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme32s.d $e |- D
        = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme32s.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    $d s A $.  $d s B $.  $d s H $.  $d s .\/ $.  $d s K $.  $d s .<_ $.
    $d s ./\ $.  $d s P $.  $d s Q $.  $d s R $.  $d s S $.  $d s U $.
    $d s W $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
       one-to-one outside of ` P .\/ Q ` line case; compare ~ cdleme32sn2awN .
       TODO:  FIX COMMENT (Contributed by NM, 18-Mar-2013.) $)
    cdleme35sn2aw $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
            /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( -. R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) /\ R =/= S ) )
               -> [_ R / s ]_ N =/= [_ S / s ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne co eqid cdleme35h2 wceq simp22l cdleme31sn2
      csb simp31 syl2anc simp23l simp32 3netr4d ) LUGUHPIUHUIDAUHDPMUJUKUIEAUHE
      PMUJUKUIULZDEUMZFAUHZFPMUJUKZUIZGAUHZGPMUJUKZUIZULZFDEKUNZMUJUKZGVOMUJUKZ
      FGUMZULZULZFHKUNEDFKUNPNUNKUNNUNZGHKUNEDGKUNPNUNKUNNUNZQFOUTZQGOUTZADEFGH
      WAWBIKLMNPSTUAUBUCUDWAUOZWBUOZUPVTVHVPWCWAUQVHVIVGVMVFVSURVFVNVPVQVRVAAWA
      CDEFHJKMNOPQUEUFWEUSVBVTVKVQWDWBUQVKVLVGVJVFVSVCVFVNVPVQVRVDAWBCDEGHJKMNO
      PQUEUFWFUSVBVE $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 19-Mar-2013.) $)
    cdleme35sn3a $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
        /\ -. R .<_ ( P .\/ Q ) )
               -> -. [_ R / s ]_ N .<_ ( P .\/ Q ) ) $=
      ( chlt wcel wa wbr wn w3a wne co csb eqid cdleme35fnpq wceq simp2rl simp3
      cdleme31sn2 syl2anc breq1d mtbird ) KUFUGOHUGUHDAUGDOLUIUJUHEAUGEOLUIUJUH
      UKZDEULZFAUGZFOLUIUJZUHUHZFDEJUMZLUIUJZUKZPFNUNZVILUIFGJUMEDFJUMOMUMJUMMU
      MZVILUIADEFGVMHJKLMORSTUAUBUCVMUOZUPVKVLVMVILVKVFVJVLVMUQVFVGVEVDVJURVDVH
      VJUSAVMCDEFGIJLMNOPUDUEVNUTVAVBVC $.
  $}

  ${
    cdleme36.b $e |- B = ( Base ` K ) $.
    cdleme36.l $e |- .<_ = ( le ` K ) $.
    cdleme36.j $e |- .\/ = ( join ` K ) $.
    cdleme36.m $e |- ./\ = ( meet ` K ) $.
    cdleme36.a $e |- A = ( Atoms ` K ) $.
    cdleme36.h $e |- H = ( LHyp ` K ) $.
    cdleme36.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme36.e $e |- E
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT
       (Contributed by NM, 11-Mar-2013.) $)
    cdleme36a $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ Q e. A )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ R .<_ ( P .\/ Q ) )
        /\ ( ( t e. A /\ -. t .<_ W ) /\ -. t .<_ ( P .\/ Q ) ) )
               -> -. R .<_ ( t .\/ E ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cv simp3r simp11l simp22l simp3ll simp11
      simp12 simp13 simp21 cdleme0a syl112anc simp12l simp22 cdleme0c syl121anc
      wi necomd hlatexch2 syl131anc wceq simp3l cdleme1 syl13anc breq2d cdleme4
      simp23 3imtr4d mtod ) KUCUDZNIUDZUEZDBUDZDNLUFUGZUEZEBUDZUHZDEUIZFBUDZFNL
      UFUGZUEZFDEJUJZLUFZUHZAUKZBUDZWNNLUFUGZUEZWNWKLUFZUGZUEZUHZFWNHJUJZLUFZWR
      WFWMWQWSULXAFWNGJUJZLUFZWNFGJUJZLUFZXCWRXAVSWHWOGBUDZFGUIXEXGVFVSVTWDWEWM
      WTUMWHWIWGWLWFWTUNWOWPWSWFWMUOXAWAWDWEWGXHWAWDWEWMWTUPZWAWDWEWMWTUQWAWDWE
      WMWTURZWFWGWJWLWTUSBDEGIJKLMNPQRSTUAUTVAXAGFXAWAWBWEWJGFUIXIWBWCWAWEWMWTV
      BZXJWFWGWJWLWTVCZBDEFGIJKLMNPQRSTUAVDVEVGBFWNGJKLPQSVHVIXAXBXDFLXAWAWBWEW
      QXBXDVJXIXKXJWFWMWQWSVKBDEWNGHIJKLMNPQRSTUAUBVLVMVNXAWKXFWNLXAWAWBWEWJWLW
      KXFVJXIXKXJXLWFWGWJWLWTVPBDEFGIJKLMNPQRSTUAVOVIVNVQVR $.

    $( ` t ` , ` E ` serve as ` P ` , ` Q ` $)
    cdleme36.v $e |- V = ( ( t .\/ E ) ./\ W ) $.
    cdleme36.f $e |- F
     = ( ( R .\/ V ) ./\ ( E .\/ ( ( t .\/ R ) ./\ W ) ) ) $.
    cdleme36.c $e |- C
     = ( ( S .\/ V ) ./\ ( E .\/ ( ( t .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
       one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT (Contributed by NM,
       11-Mar-2013.) $)
    cdleme36m $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
         /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ F = C )
                /\ ( ( t e. A /\ -. t .<_ W ) /\ -. t .<_ ( P .\/ Q ) ) ) )
               -> R = S ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq simp11 simp3rl simp12 simp13 simp21
      cv simp3rr cdleme3fa syl132anc cdleme3 jca simp13l cdleme3b necomd simp22
      syl13anc simp3l1 cdleme36a syl331anc simp3l2 simp3l3 cdleme35h syl333anc
      simp23 simp3r ) NUJUKRLUKULZEBUKEROUMUNULZFBUKZFROUMUNZULZUOZEFUPZGBUKGRO
      UMUNULZHBUKHROUMUNULZUOZGEFMUQZOUMZHWNOUMZKDURZUOZAVDZBUKWSROUMUNULZWSWNO
      UMUNZULZULZUOZWDWTJBUKZJROUMUNZULWSJUPWKWLGWSJMUQZOUMUNZHXGOUMUNZWQGHURWD
      WEWHWMXCUSZWTXAWRWIWMUTZXDXEXFXDWDWEWHWTWJXAXEXJWDWEWHWMXCVAZWDWEWHWMXCVB
      ZXKWIWJWKWLXCVCZWTXAWRWIWMVEZBEFWSIJLMNOPRTUAUBUCUDUEUFVFVGXDWDWEWHWTWJXA
      XFXJXLXMXKXNXOBEFWSIJLMNOPRTUAUBUCUDUEUFVHVGVIXDJWSXDWDWEWFWJULWTJWSUPXJX
      LXDWFWJWFWGWDWEWMXCVJZXNVIXKBEFWSIJLMNOPRTUAUBUCUDUEUFVKVNVLWIWJWKWLXCVMZ
      WIWJWKWLXCWBZXDWDWEWFWJWKWOXBXHXJXLXPXNXQWOWPWQXBWIWMVOWIWMWRXBWCZABCEFGI
      JLMNOPRSTUAUBUCUDUEUFVPVQXDWDWEWFWJWLWPXBXIXJXLXPXNXRWOWPWQXBWIWMVRXSABCE
      FHIJLMNOPRSTUAUBUCUDUEUFVPVQWOWPWQXBWIWMVSBWSJGHQKDLMNOPRTUAUBUCUDUGUHUIV
      TWA $.
  $}

  ${
    cdleme37.l $e |- .<_ = ( le ` K ) $.
    cdleme37.j $e |- .\/ = ( join ` K ) $.
    cdleme37.m $e |- ./\ = ( meet ` K ) $.
    cdleme37.a $e |- A = ( Atoms ` K ) $.
    cdleme37.h $e |- H = ( LHyp ` K ) $.
    cdleme37.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( ` t ` , ` E ` , ` V ` serve as ` P ` , ` Q ` , ` U ` for ` C ` . $)
    cdleme37.e $e |- E
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    $( ` u ` , ` D ` , ` X ` serve as ` P ` , ` Q ` , ` U ` for ` G ` . $)
    cdleme37.d $e |- D
      = ( ( u .\/ U ) ./\ ( Q .\/ ( ( P .\/ u ) ./\ W ) ) ) $.
    cdleme37.v $e |- V = ( ( t .\/ E ) ./\ W ) $.
    cdleme37.x $e |- X = ( ( u .\/ D ) ./\ W ) $.
    cdleme37.c $e |- C
      = ( ( S .\/ V ) ./\ ( E .\/ ( ( t .\/ S ) ./\ W ) ) ) $.
    cdleme37.g $e |- G
      = ( ( S .\/ X ) ./\ ( D .\/ ( ( u .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
       one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT (Contributed by NM,
       13-Mar-2013.) $)
    cdleme37m $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
         /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) )
                /\ ( ( t e. A /\ -. t .<_ W ) /\ -. t .<_ ( P .\/ Q ) )
                /\ ( ( u e. A /\ -. u .<_ W ) /\ -. u .<_ ( P .\/ Q ) ) ) )
               -> C = G ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq simp1 simp23 simp32l simp33l simp21
      cv simp32r simp33r simp31r 3jca eqid cdleme21k syl132anc simp11 syl131anc
      simp12l simp13l cdleme4 cdleme2 syl13anc simp11l simp23l hlatjcom syl3anc
      syl5eq oveq2d eqtr4d simpld oveq1d oveq12d syl6reqr 3eqtr4d ) OUMUNZSMUNZ
      UOZFCUNZFSPUPUQZUOZGCUNZGSPUPUQZUOZURZFGUSZHCUNHSPUPUQUOZICUNZISPUPUQZUOZ
      URZHFGNUTZPUPZIXJPUPZUOZBVGZCUNZXNSPUPUQZUOZXNXJPUPUQZUOZAVGZCUNZXTSPUPUQ
      ZUOZXTXJPUPUQZUOZURZURZXJKIXNNUTZSQUTZNUTZQUTZXJEIXTNUTZSQUTZNUTZQUTZDLYG
      XCXHXQYCXDXRYDXLURYKYOVAXCXIYFVBXCXDXEXHYFVCZXQXRXMYEXCXIVDZYCYDXMXSXCXIV
      EZXCXDXEXHYFVFYGXRYDXLXQXRXMYEXCXIVHYCYDXMXSXCXIVIXKXLXSYEXCXIVJZVKCYIFGI
      XNXTJKEMNOPQYKYOSYMUAUBUCUDUEUFUGUHYIVLYMVLYKVLYOVLVMVNYGYKIRNUTZKXNINUTZ
      SQUTZNUTZQUTDYGXJYTYJUUCQYGXJIJNUTZYTYGWPWQWTXHXLXJUUDVAWPWSXBXIYFVOZWQWR
      WPXBXIYFVQZWTXAWPWSXIYFVRZYPYSCFGIJMNOPQSUAUBUCUDUEUFVSVPZYGRJINYGRXNKNUT
      SQUTZJUIYGWPWQWTXQUUIJVAUUEUUFUUGYQCFGXNJKMNOPQSUAUBUCUDUEUFUGVTWAWFWGWHY
      GYIUUBKNYGYHUUASQYGWNXFXOYHUUAVAWNWOWSXBXIYFWBZXFXGXDXEXCYFWCZYGXOXPYQWIC
      NOIXNUBUDWDWEWJWGWKUKWLYGYOITNUTZEXTINUTZSQUTZNUTZQUTLYGXJUULYNUUOQYGXJUU
      DUULUUHYGTJINYGTXTENUTSQUTZJUJYGWPWQWTYCUUPJVAUUEUUFUUGYRCFGXTJEMNOPQSUAU
      BUCUDUEUFUHVTWAWFWGWHYGYMUUNENYGYLUUMSQYGWNXFYAYLUUMVAUUJUUKYGYAYBYRWICNO
      IXTUBUDWDWEWJWGWKULWLWM $.
  $}

  ${
    cdleme38.l $e |- .<_ = ( le ` K ) $.
    cdleme38.j $e |- .\/ = ( join ` K ) $.
    cdleme38.m $e |- ./\ = ( meet ` K ) $.
    cdleme38.a $e |- A = ( Atoms ` K ) $.
    cdleme38.h $e |- H = ( LHyp ` K ) $.
    cdleme38.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( ` t ` , ` E ` , ` V ` serve as ` P ` , ` Q ` , ` U ` for ` F ` . $)
    cdleme38.e $e |- E
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    $( ` u ` , ` D ` , ` X ` serve as ` P ` , ` Q ` , ` U ` for ` G ` . $)
    cdleme38.d $e |- D
      = ( ( u .\/ U ) ./\ ( Q .\/ ( ( P .\/ u ) ./\ W ) ) ) $.
    cdleme38.v $e |- V = ( ( t .\/ E ) ./\ W ) $.
    cdleme38.x $e |- X = ( ( u .\/ D ) ./\ W ) $.
    cdleme38.f $e |- F
      = ( ( R .\/ V ) ./\ ( E .\/ ( ( t .\/ R ) ./\ W ) ) ) $.
    cdleme38.g $e |- G
      = ( ( S .\/ X ) ./\ ( D .\/ ( ( u .\/ S ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
       one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT (Contributed by NM,
       13-Mar-2013.) $)
    cdleme38m $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
           /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ F = G )
                /\ ( ( t e. A /\ -. t .<_ W ) /\ -. t .<_ ( P .\/ Q ) )
                /\ ( ( u e. A /\ -. u .<_ W ) /\ -. u .<_ ( P .\/ Q ) ) ) )
               -> R = S ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq simp1 simp2 simp311 simp312 simp313
      cv simp32 simp33 eqid cdleme37m syl113anc eqtr4d 3jca cdleme36m syl112anc
      jca cbs cfv ) OUMUNSMUNUOECUNESPUPUQUOFCUNFSPUPUQUOURZEFUSGCUNGSPUPUQUOHC
      UNHSPUPUQUOURZGEFNUTZPUPZHWBPUPZKLVAZURZBVGZCUNWGSPUPUQUOWGWBPUPUQUOZAVGZ
      CUNWISPUPUQUOWIWBPUPUQUOZURZURZVTWAWCWDKHRNUTJWGHNUTSQUTNUTQUTZVAZURWHGHV
      AVTWAWKVBZVTWAWKVCZWLWCWDWNWCWDWEWHWJVTWAVDZWCWDWEWHWJVTWAVEZWLKLWMWCWDWE
      WHWJVTWAVFWLVTWAWCWDUOWHWJWMLVAWOWPWLWCWDWQWRVQVTWAWFWHWJVHZVTWAWFWHWJVIA
      BCWMDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJWMVJZULVKVLVMVNWSBCOVRVSZWMEFGHIJ
      KMNOPQRSXAVJUAUBUCUDUEUFUGUIUKWTVOVP $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
       one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT TODO shorter if
       proved directly from ~ cdleme36m and ~ cdleme37m ?  (Contributed by NM,
       14-Mar-2013.) $)
    cdleme38n $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
          /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ R =/= S )
                /\ ( ( t e. A /\ -. t .<_ W ) /\ -. t .<_ ( P .\/ Q ) )
                /\ ( ( u e. A /\ -. u .<_ W ) /\ -. u .<_ ( P .\/ Q ) ) ) )
               -> F =/= G ) $=
      ( chlt wcel wa wbr wn w3a wne simp313 wceq simpl1 simpl21 simpl22 simpl23
      co cv simp311 adantr simp312 simpr simpl32 simpl33 cdleme38m syl133anc ex
      3jca necon3d mpd ) OUMUNSMUNUOECUNESPUPUQUOFCUNFSPUPUQUOURZEFUSZGCUNGSPUP
      UQUOZHCUNHSPUPUQUOZURZGEFNVFZPUPZHWEPUPZGHUSZURZBVGZCUNWJSPUPUQUOWJWEPUPU
      QUOZAVGZCUNWLSPUPUQUOWLWEPUPUQUOZURZURZWHKLUSWFWGWHWKWMVTWDUTWOKLGHWOKLVA
      ZGHVAZWOWPUOZVTWAWBWCWFWGWPURWKWMWQVTWDWNWPVBWAWBWCVTWNWPVCWAWBWCVTWNWPVD
      WAWBWCVTWNWPVEWRWFWGWPWOWFWPWFWGWHWKWMVTWDVHVIWOWGWPWFWGWHWKWMVTWDVJVIWOW
      PVKVQWIWKWMVTWDWPVLWIWKWMVTWDWPVMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJ
      UKULVNVOVPVRVS $.
  $}

  ${
    cdleme39.l $e |- .<_ = ( le ` K ) $.
    cdleme39.j $e |- .\/ = ( join ` K ) $.
    cdleme39.m $e |- ./\ = ( meet ` K ) $.
    cdleme39.a $e |- A = ( Atoms ` K ) $.
    cdleme39.h $e |- H = ( LHyp ` K ) $.
    cdleme39.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme39.e $e |- E
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme39.g $e |- G
      = ( ( P .\/ Q ) ./\ ( E .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
    ${
      cdleme39a.v $e |- V = ( ( t .\/ E ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
         one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT. ` E ` , ` Y ` ,
         ` G ` , ` Z ` serve as f(t), f(u), f_t( ` R ` ), f_t( ` S ` ).  Put
         hypotheses of ~ cdleme38n in convention of ~ cdleme32sn1awN .  TODO
         see if this hypothesis conversion would be better if done earlier.
         (Contributed by NM, 15-Mar-2013.) $)
      cdleme39a $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ P e. A
           /\ Q e. A )
        /\ ( R e. A /\ -. R .<_ W )
        /\ ( R .<_ ( P .\/ Q )
           /\ ( t e. A /\ -. t .<_ W ) ) )
    -> G = ( ( R .\/ V ) ./\ ( E .\/ ( ( t .\/ R ) ./\ W ) ) ) ) $=
        ( chlt wcel wa w3a wbr wn co cv wceq simp11 simp12 simp13 simp2 cdleme4
        simp3l syl131anc simp3r cdleme2 syl13anc syl5eq oveq2d simp11l hlatjcom
        eqtr4d simp2l simp3rl syl3anc oveq1d oveq12d ) KUEUFZOIUFZUGZCBUFZDBUFZ
        UHZEBUFZEOLUIUJZUGZECDJUKZLUIZAULZBUFZWEOLUIUJZUGZUGZUHZHWCGEWEJUKZOMUK
        ZJUKZMUKENJUKZGWEEJUKZOMUKZJUKZMUKUCWJWCWNWMWQMWJWCEFJUKZWNWJVPVQVRWBWD
        WCWRUMVPVQVRWBWIUNZVPVQVRWBWIUOZVPVQVRWBWIUPZVSWBWIUQVSWBWDWHUSBCDEFIJK
        LMOPQRSTUAURUTWJNFEJWJNWEGJUKOMUKZFUDWJVPVQVRWHXBFUMWSWTXAVSWBWDWHVABCD
        WEFGIJKLMOPQRSTUAUBVBVCVDVEVHWJWLWPGJWJWKWOOMWJVNVTWFWKWOUMVNVOVQVRWBWI
        VFVSVTWAWIVIWFWGWDVSWBVJBJKEWEQSVGVKVLVEVMVD $.
    $}

    cdleme39.y $e |- Y
       = ( ( u .\/ U ) ./\ ( Q .\/ ( ( P .\/ u ) ./\ W ) ) ) $.
    cdleme39.z $e |- Z
       = ( ( P .\/ Q ) ./\ ( Y .\/ ( ( S .\/ u ) ./\ W ) ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
       one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT. ` E ` , ` Y ` ,
       ` G ` , ` Z ` serve as f(t), f(u), f_t( ` R ` ), f_t( ` S ` ).  Put
       hypotheses of ~ cdleme38n in convention of ~ cdleme32sn1awN .  TODO see
       if this hypothesis conversion would be better if done earlier.
       (Contributed by NM, 15-Mar-2013.) $)
    cdleme39n $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
         /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ R =/= S )
                /\ ( ( t e. A /\ -. t .<_ W ) /\ -. t .<_ ( P .\/ Q ) )
                /\ ( ( u e. A /\ -. u .<_ W ) /\ -. u .<_ ( P .\/ Q ) ) ) )
               -> G =/= Z ) $=
      ( chlt wcel wa wbr wn w3a wne co cv eqid cdleme38n simp11 simp12l simp13l
      simp22l simp22r simp311 simp32l cdleme39a simp23l simp23r simp312 simp33l
      wceq syl322anc 3netr4d ) MUIUJPKUJUKZDCUJZDPNULUMZUKZECUJZEPNULUMZUKZUNZD
      EUOZFCUJZFPNULUMZUKZGCUJZGPNULUMZUKZUNZFDELUPZNULZGWKNULZFGUOZUNZBUQZCUJW
      PPNULUMUKZWPWKNULUMZUKZAUQZCUJWTPNULUMUKZWTWKNULUMZUKZUNZUNZFWPILUPPOUPZL
      UPIWPFLUPPOUPLUPOUPZGWTQLUPPOUPZLUPQWTGLUPPOUPLUPOUPZJRABCQDEFGHIXGXIKLMN
      OXFPXHSTUAUBUCUDUEUGXFURZXHURZXGURXIURUSXEVOVPVSWDWEWLWQJXGVLVOVRWAWJXDUT
      ZVPVQVOWAWJXDVAZVSVTVOVRWJXDVBZWDWEWCWIWBXDVCWDWEWCWIWBXDVDWLWMWNWSXCWBWJ
      VEWQWRWOXCWBWJVFBCDEFHIJKLMNOXFPSTUAUBUCUDUEUFXJVGVMXEVOVPVSWGWHWMXARXIVL
      XLXMXNWGWHWCWFWBXDVHWGWHWCWFWBXDVIWLWMWNWSXCWBWJVJXAXBWOWSWBWJVKACDEGHQRK
      LMNOXHPSTUAUBUCUDUGUHXKVGVMVN $.
  $}

  ${
    $d u v z A $.  $d u v z B $.  $d z F $.  $d v z H $.  $d u v z .\/ $.
    $d v z K $.  $d u v z .<_ $.  $d u v z ./\ $.  $d u v z P $.  $d u v z Q $.
    $d v z R $.  $d u z S $.  $d u T $.  $d v z U $.  $d u v z W $.  $d v s $.
    $d s t w y A $.  $d s t w y B $.  $d w C $.  $d s E $.  $d t w F $.
    $d t y H $.  $d s t w y .\/ $.  $d t y K $.  $d s t w y .<_ $.
    $d s t y ./\ $.  $d s t w y P $.  $d s t w y Q $.  $d s t y R $.
    $d t y U $.  $d s t w y W $.  $d w y Y $.  $d t S v y $.  $d s t w y T $.
    cdleme40.b $e |- B = ( Base ` K ) $.
    cdleme40.l $e |- .<_ = ( le ` K ) $.
    cdleme40.j $e |- .\/ = ( join ` K ) $.
    cdleme40.m $e |- ./\ = ( meet ` K ) $.
    cdleme40.a $e |- A = ( Atoms ` K ) $.
    cdleme40.h $e |- H = ( LHyp ` K ) $.
    cdleme40.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( ` R ` part $)
    cdleme40.e $e |- E
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme40.g $e |- G
      = ( ( P .\/ Q ) ./\ ( E .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdleme40.i $e |- I = ( iota_ y e. B A. t e. A ( ( -. t .<_ W
      /\ -. t .<_ ( P .\/ Q ) ) -> y = G ) ) $.
    cdleme40.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.

    ${
      cdleme40a1.y $e |- Y
          = ( ( P .\/ Q ) ./\ ( E .\/ ( ( R .\/ t ) ./\ W ) ) ) $.
      cdleme40a1.c $e |- C
          = ( iota_ y e. B A. t e. A ( ( -. t .<_ W /\ -. t .<_ (
             P .\/ Q ) ) -> y = Y ) ) $.
      $( ` S ` part $)
      cdleme40.t $e |- T
          = ( ( v .\/ U ) ./\ ( Q .\/ ( ( P .\/ v ) ./\ W ) ) ) $.
      cdleme40.f $e |- F
          = ( ( P .\/ Q ) ./\ ( T .\/ ( ( S .\/ v ) ./\ W ) ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
         one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT Use proof idea
         from ~ cdleme32sn1awN .  (Contributed by NM, 18-Mar-2013.) $)
      cdleme40m $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W )
          /\ ( S e. A /\ -. S .<_ W ) )
        /\ ( ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ R =/= S )
                /\ ( v e. A /\ -. v .<_ W /\ -. v .<_ ( P .\/ Q ) ) ) )
               -> [_ R / s ]_ N =/= F ) $=
        ( chlt wa wbr wn w3a wne co cv csb simp22l simp3l1 cdleme31sn1c syl2anc
        wcel wceq cvv cbs cfv fvex eqeltri nfv wnf wral crio nfra1 nfcv nfriota
        wi nfcxfr nfne a1i wb neeq1 adantl simpl1 simpl2 simpl3l simprl simprrl
        simprrr jca31 simp3r1 simp3r2 simp3r3 cdleme39n syl113anc simp1 simp22r
        adantr ex simp21 cdleme25cl syl122anc wrex simp11 simp12 simp13 cdlemb2
        syl121anc riotasv3d mpan2 eqnetrd ) TVBVOUDQVOVCZHDVOHUDUAVDVEVCZIDVOIU
        DUAVDVEVCZVFZHIVGZJDVOZJUDUAVDVEZVCZKDVOKUDUAVDVEVCZVFZJHISVHZUAVDZKYNU
        AVDZJKVGZVFZBVIZDVOZYSUDUAVDVEZYSYNUAVDVEZVFZVCZVFZUFJUCVJZFOUUEYIYOUUF
        FVPYIYJYHYLYGUUDVKZYOYPYQUUCYGYMVLZACDEFGHIJNPRSUAUBUCUDUEUFUOUPUQURUSV
        MVNUUEEVQVOFOVGZETVRVSVQUGTVRVTWAUUECVIZUDUAVDVEZUUJYNUAVDVEZVCZUEOVGZU
        UIACEDUEFVQUUECWBUUICWCUUECFOCFUUMAVIUEVPWIZCDWDZAEWEZUSUUPCAEUUOCDWFCE
        WGWHWJCOWGWKWLFUUQVPUUEUSWLUEFVPUUNUUIWMUUEUEFOWNWOUUEUUJDVOZUUMVCZUUNU
        UEUUSVCZYGYMYRUURUUKVCUULVCYTUUAVCUUBVCZUUNYGYMUUDUUSWPYGYMUUDUUSWQYRUU
        CYGYMUUSWRUUTUURUUKUULUUEUURUUMWSUUEUURUUKUULWTUUEUURUUKUULXAXBUUEUVAUU
        SUUEYTUUAUUBYTUUAUUBYRYGYMXCYTUUAUUBYRYGYMXDYTUUAUUBYRYGYMXEXBXJBCDHIJK
        MNUEQSTUAUBUDLOUHUIUJUKULUMUNURUTVAXFXGXKUUEYGYIYJYHYOFEVOYGYMUUDXHUUGY
        IYJYHYLYGUUDXIYGYHYKYLUUDXLZUUHADEHIJMNQFSTUAUBUEUDCUGUHUIUJUKULUMUNURU
        SXMXNUUEYDYEYFYHUUMCDXOYDYEYFYMUUDXPYDYEYFYMUUDXQYDYEYFYMUUDXRUVBDHIQST
        UAUDCUHUIUKULXSXTYAYBYC $.

      cdleme40a1.x $e |- X
          = ( ( P .\/ Q ) ./\ ( T .\/ ( ( u .\/ v ) ./\ W ) ) ) $.
      cdleme40.o $e |- O
       = ( iota_ z e. B A. v e. A ( ( -. v .<_ W /\ -. v .<_ ( P .\/ Q ) )
                -> z = X ) ) $.
      cdleme40.v $e |- V = if ( u .<_ ( P .\/ Q ) , O , .< ) $.
      cdleme40a1.z $e |- Z
        = ( iota_ z e. B A. v e. A ( ( -. v .<_ W /\ -. v .<_ ( P .\/ Q ) )
           -> z = F ) ) $.
      $d v D $.  $d v I $.  $d v w N $.  $d w R $.  $d w Z $.  $d w z $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(x) is
         one-to-one on ` P .\/ Q ` line.  TODO:  FIX COMMENT TODO get rid
         of '.<' class?  (Contributed by NM, 18-Mar-2013.) $)
      cdleme40n $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ R =/= S ) )
               -> [_ R / s ]_ N =/= [_ S / u ]_ V ) $=
        ( chlt wcel wa wbr wn w3a wne csb cvv cbs cfv fvex eqeltri nfv wnf nfcv
        co cv wceq wi wral crio nfra1 nfriota nfcxfr nfne a1i wb adantl simpl11
        simpl12 simpl13 simpl21 simpl22 simpl23 simpl3 simprl simprrl cdleme40m
        neeq2 simprrr 3jca syl332anc ex simp1 simp23l simp23r simp21 cdleme25cl
        simp32 syl122anc simp11 simp12 simp13 cdlemb2 syl121anc riotasv3d mpan2
        wrex cdleme31sn1c syl2anc neeqtrrd ) UCVMVNUITVNVOZJFVNJUIUDVPVQVOZKFVN
        KUIUDVPVQVOZVRZJKVSZLFVNLUIUDVPVQVOZMFVNZMUIUDVPVQZVOZVRZLJKUBWIZUDVPZM
        UUEUDVPZLMVSZVRZVRZUMLUFVTZULDMUHVTZUUJGWAVNUUKULVSZGUCWBWCWAUNUCWBWDWE
        UUJCWJZUIUDVPVQZUUNUUEUDVPVQZVOZUUKRVSZUUMBCGFRULWAUUJCWFUUMCWGUUJCUUKU
        LCUUKWHCULUUQBWJRWKWLZCFWMZBGWNZVLUUTCBGUUSCFWOCGWHWPWQWRWSULUVAWKUUJVL
        WSRULWKUURUUMWTUUJRULUUKXLXAUUJUUNFVNZUUQVOZUURUUJUVCVOZYOYPYQYSYTUUCUU
        IUVBUUOUUPVRUURYOYPYQUUDUUIUVCXBYOYPYQUUDUUIUVCXCYOYPYQUUDUUIUVCXDYSYTU
        UCYRUUIUVCXEYSYTUUCYRUUIUVCXFYSYTUUCYRUUIUVCXGYRUUDUUIUVCXHUVDUVBUUOUUP
        UUJUVBUUQXIUUJUVBUUOUUPXJUUJUVBUUOUUPXMXNACEFGHIJKLMOPQRSTUAUBUCUDUEUFU
        IUKUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHXKXOXPUUJYRUUAUUBYSUUGULGVNYRUUDUUIX
        QUUAUUBYSYTYRUUIXRZUUAUUBYSYTYRUUIXSYRYSYTUUCUUIXTZYRUUDUUFUUGUUHYBZBFG
        JKMPOTULUBUCUDUERUICUNUOUPUQURUSUTVGVHVLYAYCUUJYOYPYQYSUUQCFYKYOYPYQUUD
        UUIYDYOYPYQUUDUUIYEYOYPYQUUDUUIYFUVFFJKTUBUCUDUICUOUPURUSYGYHYIYJUUJUUA
        UUGUULULWKUVEUVGBCFGULNJKMOUJUGUBUDUEUHUIRDVIVJVKVHVLYLYMYN $.
    $}

    cdleme40.d $e |- D
      = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme40r.y $e |- Y
        = ( ( u .\/ U ) ./\ ( Q .\/ ( ( P .\/ u ) ./\ W ) ) ) $.
    ${
      $d v z E $.  $d u v N $.  $d u R $.  $d s V $.  $d t y X $.
      $d s t u y z $.
      $( ` R ` part with different bound variables $)
      cdleme40r.t $e |- T
          = ( ( v .\/ U ) ./\ ( Q .\/ ( ( P .\/ v ) ./\ W ) ) ) $.
      cdleme40r.x $e |- X
          = ( ( P .\/ Q ) ./\ ( T .\/ ( ( u .\/ v ) ./\ W ) ) ) $.
      cdleme40r.o $e |- O
          = ( iota_ z e. B A. v e. A ( ( -. v .<_ W /\ -. v .<_ ( P
         .\/ Q ) ) -> z = X ) ) $.
      cdleme40r.v $e |- V = if ( u .<_ ( P .\/ Q ) , O , Y ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Change bound variables
         in ` [_ S / u ]_ V ` (but we use ` [_ R / u ]_ V ` for convenience
         since we have its hypotheses available) .  (Contributed by NM,
         18-Mar-2013.) $)
      cdleme40v $p |- ( R e. A -> [_ R / s ]_ N = [_ R / u ]_ V ) $=
        ( csb wceq wcel cv co wbr cif breq1 wn wa wral crio oveq1 oveq1d oveq2d
        wi syl5eq eqeq2d imbi2d ralbidv riotabidv eqeq1 anbi12d oveq12d 3eqtr4g
        notbid oveq2 syl6eqr imbi12d cbvralv syl6bb cbvriotav ifbieq12d cbvcsbv
        syl6eq a1i ) UHKUBVFDKUDVFVGKFVHUHDKUBUDUHVIZDVIZVGZXBIJRVJZTVKZQHVLXCX
        ETVKZUCUGVLUBUDXDXFXGQHUCUGXBXCXETVMXDEVIZUETVKZVNZXHXETVKZVNZVOZAVIZOV
        GZWAZEFVPZAGVQZCVIZUETVKZVNZXSXETVKZVNZVOZBVIZUFVGZWAZCFVPZBGVQZQUCXDXR
        XMXNXENXCXHRVJZUEUAVJZRVJZUAVJZVGZWAZEFVPZAGVQYIXDXQYPAGXDXPYOEFXDXOYNX
        MXDOYMXNXDOXENXBXHRVJZUEUAVJZRVJZUAVJYMUQXDYSYLXEUAXDYRYKNRXDYQYJUEUAXB
        XCXHRVRVSVTVTWBWCWDWEWFYPYHABGXNYEVGZYPXMYEYMVGZWAZEFVPYHYTYOUUBEFYTYNU
        UAXMXNYEYMWGWDWEUUBYGECFXHXSVGZXMYDUUAYFUUCXJYAXLYCUUCXIXTXHXSUETVMWKUU
        CXKYBXHXSXETVMWKWHUUCYMUFYEUUCYMXELXCXSRVJZUEUAVJZRVJZUAVJUFUUCYLUUFXEU
        AUUCNLYKUUERUUCXHMRVJZJIXHRVJZUEUAVJZRVJZUAVJXSMRVJZJIXSRVJZUEUAVJZRVJZ
        UAVJNLUUCUUGUUKUUJUUNUAXHXSMRVRUUCUUIUUMJRUUCUUHUULUEUAXHXSIRWLVSVTWIUP
        VBWJUUCYJUUDUEUAXHXSXCRWLVSWIVTVCWMWCWNWOWPWQWTURVDWJXDXBMRVJZJIXBRVJZU
        EUAVJZRVJZUAVJXCMRVJZJIXCRVJZUEUAVJZRVJZUAVJHUGXDUUOUUSUURUVBUAXBXCMRVR
        XDUUQUVAJRXDUUPUUTUEUAXBXCIRWLVSVTWIUTVAWJWRUSVEWJWSXA $.
    $}

    $d v D $.  $d v y z E $.  $d v I $.  $d u v N $.  $d s S $.  $d s u U $.
    $d s t u z y $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Apply ~ cdleme40v bound
       variable change to ` [_ S / u ]_ V ` .  TODO:  FIX COMMENT (Contributed
       by NM, 19-Mar-2013.) $)
    cdleme40w $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ R =/= S ) )
               -> [_ R / s ]_ N =/= [_ S / s ]_ N ) $=
      ( vv vz chlt wcel wa wbr wn w3a wne co csb cv wceq wi wral crio cdleme40n
      cif eqid simp23l cdleme40v syl neeqtrrd ) QUSUTUANUTVAGDUTGUARVBVCVAHDUTH
      UARVBVCVAVDZGHVEZIDUTIUARVBVCVAZJDUTZJUARVBVCZVAVDIGHPVFZRVBJWERVBIJVEVDZ
      VDZUCITVGBJBVHZWERVBUQVHZUARVBVCWIWERVBVCVAZURVHZWEWIKPVFHGWIPVFUASVFPVFS
      VFZWHWIPVFUASVFPVFSVFZVIVJUQDVKUREVLZWHKPVFHGWHPVFUASVFPVFSVFZVNZVGZUCJTV
      GZAURUQBCDECVHZUARVBVCWSWERVBVCVAAVHWELIWSPVFUASVFPVFSVFZVIVJCDVKAEVLZFGH
      IJWOWLKLWEWLJWIPVFUASVFPVFSVFZMNOPQRSTWNWPUAWMWTWJWKXBVIVJUQDVKUREVLZUCUD
      UEUFUGUHUIUJUKULUMUNWTVOXAVOWLVOZXBVOWMVOZWNVOZWPVOZXCVOVMWGWCWRWQVIWCWDW
      AWBVTWFVPAURUQBCDEFGHJWLKLMNOPQRSTWNWPUAWMWOUCUDUEUFUGUHUIUJUKULUMUNUOWOV
      OXDXEXFXGVQVRVS $.
  $}

  ${
    cdleme42.b $e |- B = ( Base ` K ) $.
    cdleme42.l $e |- .<_ = ( le ` K ) $.
    cdleme42.j $e |- .\/ = ( join ` K ) $.
    cdleme42.m $e |- ./\ = ( meet ` K ) $.
    cdleme42.a $e |- A = ( Atoms ` K ) $.
    cdleme42.h $e |- H = ( LHyp ` K ) $.
    cdleme42.v $e |- V = ( ( R .\/ S ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       3-Mar-2013.) $)
    cdleme42a $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( R e. A /\ -. R .<_ W )
             /\ ( S e. A /\ -. S .<_ W ) ) -> ( R .\/ S ) = ( R .\/ V ) ) $=
      ( wcel co chlt wa wbr w3a cp1 cfv wceq eqid lhpjat2 3adant3 oveq2d oveq2i
      simp1l simp2l simp3l hlatjcl syl3anc simp1r lhpbase syl hlatlej1 atmod3i1
      wn syl131anc syl5req col hlol olm11 syl2anc 3eqtr3rd ) GUASZKESZUBZCASZCK
      HUCVCZUBZDASZDKHUCVCZUBZUDZCDFTZCKFTZITZWAGUEUFZITZCJFTZWAVTWBWDWAIVMVPWB
      WDUGVSACWDEFGHKMNWDUHZPQUIUJUKVTWFCWAKITZFTZWCJWHCFRULVTVKVNWABSZKBSZCWAH
      UCZWIWCUGVKVLVPVSUMZVMVNVOVSUNZVTVKVNVQWJWMWNVMVPVQVRUOZABFGCDLNPUPUQZVTV
      LWKVKVLVPVSURBEGKLQUSUTVTVKVNVQWLWMWNWOACDFGHMNPVAUQABCFGHIWAKLMNOPVBVDVE
      VTGVFSZWJWEWAUGVTVKWQWMGVGUTWPBWDGIWALOWGVHVIVJ $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Match ` -. x .<_ W ` .
       (Contributed by NM, 6-Mar-2013.) $)
    cdleme42c $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( R e. A /\ -. R .<_ W )
             /\ ( S e. A /\ -. S .<_ W ) )
               -> -. ( R .\/ V ) .<_ W ) $=
      ( wcel wa chlt wbr wn co simp2r clat wb simp1l hllat simp2l atbase simp3l
      w3a syl hlatjcl syl3anc simp1r lhpbase syl5eqel latjle12 syl13anc syl6bir
      latmcl simpl mtod ) GUASZKESZTZCASZCKHUBZUCZTZDASZDKHUBUCZTZUMZCJFUDKHUBZ
      VJVHVIVKVOUEVPVQVJJKHUBZTZVJVPGUFSZCBSZJBSKBSZVSVQUGVPVFVTVFVGVLVOUHZGUIU
      NZVPVIWAVHVIVKVOUJZABCGLPUKUNVPJCDFUDZKIUDZBRVPVTWFBSZWBWGBSWDVPVFVIVMWHW
      CWEVHVLVMVNULABFGCDLNPUOUPVPVGWBVFVGVLVOUQBEGKLQURUNZBGIWFKLOVCUPUSWIBFGH
      CJKLMNUTVAVJVRVDVBVE $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Match
       ` ( s .\/ ( x ./\ W ) ) = x ` .  (Contributed by NM, 6-Mar-2013.) $)
    cdleme42d $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( R e. A /\ -. R .<_ W )
             /\ ( S e. A /\ -. S .<_ W ) )
               -> ( R .\/ ( ( R .\/ V ) ./\ W ) ) = ( R .\/ V ) ) $=
      ( wcel co chlt wa wbr wn w3a oveq2i cdleme42a oveq1d oveq2d syl5req ) GUA
      SKESUBCASCKHUCUDUBDASDKHUCUDUBUEZCJFTZCCDFTZKITZFTCULKITZFTJUNCFRUFUKUNUO
      CFUKUMULKIABCDEFGHIJKLMNOPQRUGUHUIUJ $.
  $}

  ${
    cdleme41.b $e |- B = ( Base ` K ) $.
    cdleme41.l $e |- .<_ = ( le ` K ) $.
    cdleme41.j $e |- .\/ = ( join ` K ) $.
    cdleme41.m $e |- ./\ = ( meet ` K ) $.
    cdleme41.a $e |- A = ( Atoms ` K ) $.
    cdleme41.h $e |- H = ( LHyp ` K ) $.
    cdleme41.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme41.d $e |- D
      = ( ( s .\/ U ) ./\ ( Q .\/ ( ( P .\/ s ) ./\ W ) ) ) $.
    cdleme41.e $e |- E
      = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    cdleme41.g $e |- G
      = ( ( P .\/ Q ) ./\ ( E .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdleme41.i $e |- I
       = ( iota_ y e. B A. t e. A ( ( -. t .<_ W /\ -. t .<_ ( P
      .\/ Q ) ) -> y = G ) ) $.
    cdleme41.n $e |- N = if ( s .<_ ( P .\/ Q ) , I , D ) $.
    $( TODO consolidate $ds $)
    $d s u A $.  $d s u .\/ $.  $d s u .<_ $.  $d s u ./\ $.  $d u N $.
    $d s u P $.  $d s u Q $.  $d s R $.  $d s u S $.  $d s u U $.  $d s W $.
    $d t y A $.  $d s t y u B $.  $d y D $.  $d y G $.  $d s y E $.
    $d s t y H $.  $d t y .\/ $.  $d s t y K $.  $d t y .<_ $.  $d t y ./\ $.
    $d t y P $.  $d t y Q $.  $d t y R $.  $d t y S $.  $d t y U $.
    $d t y u W $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(r) is
       different on and off the ` P .\/ Q ` line.  TODO:  FIX COMMENT
       (Contributed by NM, 18-Mar-2013.) $)
    cdleme41sn3aw $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) /\ R =/= S ) )
               -> [_ R / s ]_ N =/= [_ S / s ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne co csb simp1 simp21 simp22 simp31 wceq wral
      cv wi crio eqid cdleme41sn3a syl121anc simp23 simp32 cdleme35sn3a syl2anc
      nbrne2 ) PUNUOTMUOUPFCUOFTQUQURUPGCUOGTQUQURUPUSZFGUTZHCUOHTQUQURUPZICUOI
      TQUQURUPZUSZHFGOVAZQUQZIWEQUQURZHIUTZUSZUSZUAHSVBZWEQUQZUAISVBZWEQUQURZWK
      WMUTWJVTWAWBWFWLVTWDWIVCZVTWAWBWCWIVDZVTWAWBWCWIVEVTWDWFWGWHVFABCDEKFGHJL
      MNOPQRSTWEKHBVIZOVATRVAOVARVAZWQTQUQURWQWEQUQURUPAVIWRVGVJBCVHADVKZUAUBUC
      UDUEUFUGUHUIUJUKULUMWRVLWSVLVMVNWJVTWAWCWGWNWOWPVTWAWBWCWIVOVTWDWFWGWHVPC
      DEFGIJMNOPQRSTUAUBUCUDUEUFUGUHUIUMVQVNWKWMWEQVSVR $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(r) is for on
       and off ` P .\/ Q ` line.  TODO:  FIX COMMENT (Contributed by NM,
       19-Mar-2013.) $)
    cdleme41sn4aw $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( -. R .<_ ( P .\/ Q ) /\ S .<_ ( P .\/ Q ) /\ R =/= S ) )
               -> [_ R / s ]_ N =/= [_ S / s ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne co simp1 simp21 simp23 simp22 simp32 simp31
      csb simp33 necomd cdleme41sn3aw syl133anc ) PUNUOTMUOUPFCUOFTQUQURUPGCUOG
      TQUQURUPUSZFGUTZHCUOHTQUQURUPZICUOITQUQURUPZUSZHFGOVAZQUQURZIVRQUQZHIUTZU
      SZUSZUAISVHZUAHSVHZWCVMVNVPVOVTVSIHUTWDWEUTVMVQWBVBVMVNVOVPWBVCVMVNVOVPWB
      VDVMVNVOVPWBVEVMVQVSVTWAVFVMVQVSVTWAVGWCHIVMVQVSVTWAVIVJABCDEFGIHJKLMNOPQ
      RSTUAUBUCUDUEUFUGUHUIUJUKULUMVKVLVJ $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(r) is for
       combined cases; compare ~ cdleme32snaw .  TODO:  FIX COMMENT
       (Contributed by NM, 18-Mar-2013.) $)
    cdleme41snaw $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ R =/= S )
               -> [_ R / s ]_ N =/= [_ S / s ]_ N ) $=
      ( vu chlt wcel wa wbr wn w3a wne co simpl1 simpl21 simpl22 simpl23 simprl
      csb simprr simpl3 cv eqid cdleme40w syl133anc cdleme41sn3aw cdleme41sn4aw
      cdleme35sn2aw 4casesdan ) PUOUPTMUPUQFCUPFTQURUSUQGCUPGTQURUSUQUTZFGVAZHC
      UPHTQURUSUQZICUPITQURUSUQZUTZHIVAZUTZHFGOVBZQURZIWFQURZUAHSVHUAISVHVAZWEW
      GWHUQZUQVSVTWAWBWGWHWDWIVSWCWDWJVCVTWAWBVSWDWJVDVTWAWBVSWDWJVEVTWAWBVSWDW
      JVFWEWGWHVGWEWGWHVIVSWCWDWJVJAUNBCDEFGHIJKLMNOPQRSTUNVKZJOVBGFWKOVBTRVBOV
      BRVBZUAUBUCUDUEUFUGUHUJUKULUMUIWLVLVMVNWEWGWHUSZUQZUQVSVTWAWBWGWMWDWIVSWC
      WDWNVCVTWAWBVSWDWNVDVTWAWBVSWDWNVEVTWAWBVSWDWNVFWEWGWMVGWEWGWMVIVSWCWDWNV
      JABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVOVNWEWGUSZWHUQZUQVSVTWAWB
      WOWHWDWIVSWCWDWPVCVTWAWBVSWDWPVDVTWAWBVSWDWPVEVTWAWBVSWDWPVFWEWOWHVGWEWOW
      HVIVSWCWDWPVJABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVPVNWEWOWMUQZU
      QVSVTWAWBWOWMWDWIVSWCWDWQVCVTWAWBVSWDWQVDVTWAWBVSWDWQVEVTWAWBVSWDWQVFWEWO
      WMVGWEWOWMVIVSWCWDWQVJCDEFGHIJMNOPQRSTUAUBUCUDUEUFUGUHUIUMVQVNVR $.

    $d x z A $.  $d x z B $.  $d y D $.  $d z E $.  $d y G $.  $d s z H $.
    $d x z .\/ $.  $d s z K $.  $d x z .<_ $.  $d x z ./\ $.  $d x z N $.
    $d x z P $.  $d x z Q $.  $d x z R $.  $d x z S $.  $d x z U $.
    $d x z W $.  $d s t x y z $.
    cdleme41.o $e |- O = ( iota_ z e. B A. s e. A
       ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x )
         -> z = ( N .\/ ( x ./\ W ) ) ) ) $.
    cdleme41.f $e |- F = ( x e. B
                         |-> if ( ( P =/= Q /\ -. x .<_ W ) , O , x ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  Show that f(r) is
       one-to-one for r in W (r an atom not under w).  TODO:  FIX COMMENT
       (Contributed by NM, 19-Mar-2013.) $)
    cdleme41fva11 $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ R =/= S )
    -> ( F ` R ) =/= ( F ` S ) ) $=
      ( chlt wcel wa wbr w3a wne csb cfv cdleme41snaw simp1 simp22 cdleme32fva1
      wn wceq simp21 syl3anc simp23 3netr4d ) SUTVAUDPVAVBHEVAHUDTVCVLVBIEVAIUD
      TVCVLVBVDZHIVEZJEVAJUDTVCVLVBZKEVAKUDTVCVLVBZVDZJKVEZVDZUEJUBVFZUEKUBVFZJ
      NVGZKNVGZBDEFGHIJKLMOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQVHWDVRVTVSWGWEV
      MVRWBWCVIZVRVSVTWAWCVJVRVSVTWAWCVNZABCDEFGMHIJLONPQRSTUAUBUCUDUEUFUGUHUIU
      JUKULUMUNUOUPUQURUSVKVOWDVRWAVSWHWFVMWIVRVSVTWAWCVPWJABCDEFGMHIKLONPQRSTU
      AUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSVKVOVQ $.

    $d w F $.  $d w ./\ $.  $d w X $.  $d w H $.  $d w K $.  $d w A $.
    $d w B $.  $d w .\/ $.  $d w .<_ $.  $d w N $.  $d w P $.  $d w Q $.
    $d w R $.  $d w W $.  $d s t x z X $.  $d s w z $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
       6-Mar-2013.) $)
    cdleme42b $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ ( P =/= Q /\ -. X .<_ W ) )
           /\ ( ( R e. A /\ -. R .<_ W ) /\ ( R .\/ ( X ./\ W ) ) = X ) )
       -> ( F ` X ) = ( [_ R / s ]_ N .\/ ( X ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cvv cfv csb cbs fvex eqeltri cv nfv
      wnfc nfcsb1v nfcv nfov a1i nfvd wi wral crio eqid cdleme31fv1 3ad2ant2 wb
      breq1 notbid oveq1 eqeq1d anbi12d adantl oveq1d simp1 simp2l cdleme32fvcl
      csbeq1a syl2anc simp3ll simp3lr simp3r jca riotasv2d mpan2 ) RUTVAUCOVAVB
      HEVAHUCSVCVDVBIEVAIUCSVCVDVBVEZUDFVAZHIVFUDUCSVCVDVBZVBZJEVAZJUCSVCZVDZVB
      ZJUDUCTVGZQVGZUDVHZVBZVEZFVIVAUDMVJZUEJUAVKZXPQVGZVHFRVLVJVIUFRVLVMVNXTUE
      VOZUCSVCZVDZYDXPQVGZUDVHZVBZXNXRVBZCUEFEUAXPQVGZYAJYCVIXTUEVPUEYCVQXTUEYB
      XPQUEJUAVRUEQVSUEXPVSVTWAXTYJUEWBXKXHYAYICVOYKVHWCUEEWDCFWEZVHXSACEFYLHIM
      QSTUAUBUCUDUEURUSYLWFWGWHYDJVHZYIYJWIXTYMYFXNYHXRYMYEXMYDJUCSWJWKYMYGXQUD
      YDJXPQWLWMWNWOYMYKYCVHXTYMUAYBXPQUEJUAWTWPWOXTXHXIYAFVAXHXKXSWQXHXIXJXSWR
      ABCDEFGLHIKNMOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSWSXAXLXNXRXHXKXB
      XTXNXRXLXNXRXHXKXCXHXKXOXRXDXEXFXG $.

    ${
      $d s V $.  $d t V $.  $d x V $.  $d z V $.
      cdleme34e.v $e |- V = ( ( R .\/ S ) ./\ W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         8-Mar-2013.) $)
      cdleme42e $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
           /\ P =/= Q )
            -> ( F ` ( R .\/ V ) )
                 = ( [_ R / s ]_ N .\/ ( ( R .\/ V ) ./\ W ) ) ) $=
        ( chlt wcel wa wbr wn w3a wne wceq cfv csb simp1 clat simp11l hllat syl
        co simp2ll atbase simp11 simp2rl cdleme0aa syl3anc latjcl simp2l simp2r
        simp3 cdleme42c jca cdleme42d cdleme42b syl122anc ) SVBVCZUEPVCZVDZHEVC
        HUETVEVFVDZIEVCIUETVEVFVDZVGZJEVCZJUETVEVFZVDZKEVCZKUETVEVFZVDZVDZHIVHZ
        VGZWRJUDRVQZFVCZXFXHUETVEVFZVDXAJXHUEUAVQZRVQXHVIZXHNVJUFJUBVKXKRVQVIWR
        XEXFVLXGSVMVCZJFVCZUDFVCZXIXGWMXMWMWNWPWQXEXFVNSVOVPXGWSXNWSWTXDWRXFVRZ
        EFJSUGUKVSVPXGWOWSXBXOWOWPWQXEXFVTZXPXBXCXAWRXFWAEFJKUDPRSTUAUEUHUIUJUK
        ULVAUGWBWCFRSJUDUGUIWDWCXGXFXJWRXEXFWGXGWOXAXDXJXQWRXAXDXFWEZWRXAXDXFWF
        ZEFJKPRSTUAUDUEUGUHUIUJUKULVAWHWCWIXRXGWOXAXDXLXQXRXSEFJKPRSTUAUDUEUGUH
        UIUJUKULVAWJWCABCDEFGHIJLMNOPQRSTUAUBUCUEXHUFUGUHUIUJUKULUMUNUOUPUQURUS
        UTWKWL $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         8-Mar-2013.) $)
      cdleme42f $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
           /\ P =/= Q )
              -> ( F ` ( R .\/ V ) ) = ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr w3a wne cfv csb cdleme42e wceq cdleme32fva1 3adant2r
        wn simp11 simp2l simp2r cdleme42a syl3anc oveq1d syl5eq oveq12d eqtr4d
        co ) SVBVCUEPVCVDZHEVCHUETVEVNVDZIEVCIUETVEVNVDZVFZJEVCJUETVEVNVDZKEVCK
        UETVEVNVDZVDZHIVGZVFZJUDRWDZNVHUFJUBVIZWNUEUAWDZRWDJNVHZUDRWDABCDEFGHIJ
        KLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVJWMWQWOUDWPRWHWIWL
        WQWOVKWJABCDEFGMHIJLONPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVLVMWM
        UDJKRWDZUEUAWDWPVAWMWRWNUEUAWMWEWIWJWRWNVKWEWFWGWKWLVOWHWIWJWLVPWHWIWJW
        LVQEFJKPRSTUAUDUEUGUHUIUJUKULVAVRVSVTWAWBWC $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         8-Mar-2013.) $)
      cdleme42g $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
           /\ P =/= Q )
              -> ( F ` ( R .\/ S ) ) = ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne co simp11 simp2l simp2r cdleme42a syl3anc
        cfv wceq fveq2d cdleme42f eqtrd ) SVBVCUEPVCVDZHEVCHUETVEVFVDZIEVCIUETV
        EVFVDZVGZJEVCJUETVEVFVDZKEVCKUETVEVFVDZVDZHIVHZVGZJKRVIZNVOJUDRVIZNVOJN
        VOUDRVIWHWIWJNWHVTWDWEWIWJVPVTWAWBWFWGVJWCWDWEWGVKWCWDWEWGVLEFJKPRSTUAU
        DUEUGUHUIUJUKULVAVMVNVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
        UOUPUQURUSUTVAVRVS $.

      $d s t x y z S $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         8-Mar-2013.) $)
      cdleme42h $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
           /\ P =/= Q )
              -> ( F ` S ) .<_ ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv clat simp11l hllat syl simp2rl atbase
        co cdleme32fvcl syl2anc simp2ll hlatjcl syl3anc simp11r latmcl syl5eqel
        simp1 lhpbase latlej1 hlatjcom oveq1d syl5eq oveq2d simp2r simp2l simp3
        wceq eqid cdleme42g syl121anc eqtr4d fveq2d 3eqtr2d breqtrd ) SVBVCZUEP
        VCZVDHEVCHUETVEVFVDZIEVCIUETVEVFVDZVGZJEVCZJUETVEVFZVDZKEVCZKUETVEVFZVD
        ZVDZHIVHZVGZKNVIZXQUDRVPZJNVIUDRVPZTXPSVJVCZXQFVCZUDFVCXQXRTVEXPXCXTXCX
        DXEXFXNXOVKZSVLVMZXPXGKFVCZYAXGXNXOWEZXPXKYDXKXLXJXGXOVNZEFKSUGUKVOVMAB
        CDEFGMHILONPQRSTUAUBUCUEKUFUGUHUIUJUKULUMUNUOUPUQURUSUTVQVRXPUDJKRVPZUE
        UAVPZFVAXPXTYGFVCZUEFVCZYHFVCYCXPXCXHXKYIYBXHXIXMXGXOVSZYFEFRSJKUGUIUKV
        TWAXPXDYJXCXDXEXFXNXOWBFPSUEUGULWFVMFSUAYGUEUGUJWCWAWDFRSTXQUDUGUHUIWGW
        AXPXRKJRVPZNVIZYGNVIXSXPXRXQYLUEUAVPZRVPZYMXPUDYNXQRXPUDYHYNVAXPYGYLUEU
        AXPXCXHXKYGYLWOYBYKYFERSJKUIUKWHWAZWIWJWKXPXGXMXJXOYMYOWOYEXGXJXMXOWLXG
        XJXMXOWMXGXNXOWNABCDEFGHIKJLMNOPQRSTUAUBUCYNUEUFUGUHUIUJUKULUMUNUOUPUQU
        RUSUTYNWPWQWRWSXPYGYLNYPWTABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULU
        MUNUOUPUQURUSUTVAWQXAXB $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  (Contributed by NM,
         8-Mar-2013.) $)
      cdleme42i $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
           /\ P =/= Q )
              -> ( ( F ` R ) .\/ ( F ` S ) ) .<_ ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv clat simp11l hllat syl simp2ll atbase
        co cdleme32fvcl syl2anc simp2rl hlatjcl syl3anc simp11r latmcl syl5eqel
        simp1 lhpbase latlej1 cdleme42h wb latjcl latjle12 syl13anc mpbi2and )
        SVBVCZUEPVCZVDHEVCHUETVEVFVDZIEVCIUETVEVFVDZVGZJEVCZJUETVEVFZVDZKEVCZKU
        ETVEVFZVDZVDZHIVHZVGZJNVIZXHUDRVPZTVEZKNVIZXITVEZXHXKRVPXITVEZXGSVJVCZX
        HFVCZUDFVCZXJXGWNXNWNWOWPWQXEXFVKZSVLVMZXGWRJFVCZXOWRXEXFWEZXGWSXSWSWTX
        DWRXFVNZEFJSUGUKVOVMABCDEFGMHILONPQRSTUAUBUCUEJUFUGUHUIUJUKULUMUNUOUPUQ
        URUSUTVQVRZXGUDJKRVPZUEUAVPZFVAXGXNYCFVCZUEFVCZYDFVCXRXGWNWSXBYEXQYAXBX
        CXAWRXFVSZEFRSJKUGUIUKVTWAXGWOYFWNWOWPWQXEXFWBFPSUEUGULWFVMFSUAYCUEUGUJ
        WCWAWDZFRSTXHUDUGUHUIWGWAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
        UNUOUPUQURUSUTVAWHXGXNXOXKFVCZXIFVCZXJXLVDXMWIXRYBXGWRKFVCZYIXTXGXBYKYG
        EFKSUGUKVOVMABCDEFGMHILONPQRSTUAUBUCUEKUFUGUHUIUJUKULUMUNUOUPUQURUSUTVQ
        VRXGXNXOXPYJXRYBYHFRSXHUDUGUIWJWAFRSTXHXKXIUGUHUIWKWLWM $.

      $d s t x z V $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  Since F ' S =/= F'R
         when S =/= R (i.e. 1-1); then ( ( F ' R ) .\/ ( F ' S ) ) is 2-dim
         therefore = ( ( F ' R ) .\/ V ) by ~ cdleme42i and ~ ps-1 TODO:  FIX
         COMMENT (Contributed by NM, 20-Mar-2013.) $)
      cdleme42k $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ R =/= S )
             -> ( ( F ` R ) .\/ ( F ` S ) ) = ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv co wceq simp1 simp22 simp23 cdleme42i
        simp21 syl121anc wb simp11l cdleme32fvaw simpld syl2anc simp11r simp22l
        cdleme41fva11 simp22r simp23l simp3 cdleme0a syl222anc syl132anc mpbid
        ps-1 ) SVBVCZUEPVCZVDHEVCHUETVEVFVDZIEVCIUETVEVFVDZVGZHIVHZJEVCZJUETVEV
        FZVDZKEVCZKUETVEVFZVDZVGZJKVHZVGZJNVIZKNVIZRVJZXIUDRVJZTVEZXKXLVKZXHWRX
        BXEWSXMWRXFXGVLZWRWSXBXEXGVMZWRWSXBXEXGVNZWRWSXBXEXGVPABCDEFGHIJKLMNOPQ
        RSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVOVQXHWNXIEVCZXJEVCZXIXJVH
        XRUDEVCZXMXNVRWNWOWPWQXFXGVSZXHWRXBXRXOXPWRXBVDXRXIUETVEVFABCDEFGMHIJLO
        NPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVTWAWBZXHWRXEXSXOXQWRXEVDXS
        XJUETVEVFABCDEFGMHIKLONPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVTWAW
        BABCDEFGHIJKLMNOPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTWEYBXHWNWOWT
        XAXCXGXTYAWNWOWPWQXFXGWCWTXAWSXEWRXGWDWTXAWSXEWRXGWFXCXDWSXBWRXGWGWRXFX
        GWHEJKUDPRSTUAUEUHUIUJUKULVAWIWJEXIXJXIUDRSTUHUIUKWMWKWL $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Remove ` R =/= S `
         condition.  TODO:  FIX COMMENT (Contributed by NM, 2-Apr-2013.) $)
      cdleme42ke $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) ) )
            -> ( ( F ` R ) .\/ ( F ` S ) ) = ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv co simpl1l simpr2 cdleme32fvaw syldan
        wceq simpld hlatjidm syl2anc oveq2d sylan9req cp0 simpr2l oveq1d simpl1
        fveq2 eqid lhpmat eqtrd col atbase olj01 oveq2 syl6eqr eqtr3d cdleme42k
        hlol syl 3expa pm2.61dane ) SVBVCZUEPVCZVDZHEVCHUETVEVFVDZIEVCIUETVEVFV
        DZVGZHIVHZJEVCZJUETVEVFZVDZKEVCKUETVEVFVDZVGZVDZJNVIZKNVIZRVJZXMUDRVJZV
        OZJKXLJKVOZVDXMXOXPXLXRXMXMXMRVJZXOXLWTXMEVCZXSXMVOWTXAXCXDXKVKZXLXTXMU
        ETVEVFZXEXKXIXTYBVDXEXFXIXJVLZABCDEFGMHIJLONPQRSTUAUBUCUEUFUGUHUIUJUKUL
        UMUNUOUPUQURUSUTVMVNVPZERSXMUIUKVQVRXRXMXNXMRJKNWEVSVTXLXRXMXMJJRVJZUEU
        AVJZRVJZXPXLYGXMSWAVIZRVJZXMXLYFYHXMRXLYFJUEUAVJZYHXLYEJUEUAXLWTXGYEJVO
        YAXGXHXFXJXEWBERSJUIUKVQVRWCXLXBXIYJYHVOXBXCXDXKWDYCEJPSTUAUEYHUHUJYHWF
        ZUKULWGVRWHVSXLSWIVCZXMFVCZYIXMVOXLWTYLYASWPWQXLXTYMYDEFXMSUGUKWJWQFRSX
        MYHUGUIYKWKVRWHXRYFUDXMRXRYFJKRVJZUEUAVJUDXRYEYNUEUAJKJRWLWCVAWMVSVTWNX
        EXKJKVHXQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVA
        WOWRWS $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  Remove ` P =/= Q `
         condition.  TODO:  FIX COMMENT TODO:  Use instead of ~ cdleme42ke and
         even combine with it?  (Contributed by NM, 22-Apr-2013.) $)
      cdleme42keg $p |- ( ( ( ( K e. HL /\ W e. H )
               /\ ( P e. A /\ -. P .<_ W )
               /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) ) )
                -> ( ( F ` R ) .\/ ( F ` S ) ) = ( ( F ` R ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn w3a cfv co wceq simpll1 simplrl simplrr cdleme42a
        syl3anc simprll atbase syl cdleme31id sylan simprrl oveq12d 3eqtr4d wne
        oveq1d simpll simpr cdleme42ke syl13anc pm2.61dane ) SVBVCUEPVCVDZHEVCH
        UETVEVFVDZIEVCIUETVEVFVDZVGZJEVCZJUETVEVFZVDZKEVCZKUETVEVFZVDZVDZVDZJNV
        HZKNVHZRVIZXCUDRVIZVJZHIXBHIVJZVDZJKRVIZJUDRVIZXEXFXIWKWQWTXJXKVJWKWLWM
        XAXHVKWNWQWTXHVLWNWQWTXHVMEFJKPRSTUAUDUEUGUHUIUJUKULVAVNVOXIXCJXDKRXBJF
        VCZXHXCJVJXBWOXLWNWOWPWTVPEFJSUGUKVQVRAFHINTUCUEJUTVSVTZXBKFVCZXHXDKVJX
        BWRXNWNWQWRWSWAEFKSUGUKVQVRAFHINTUCUEKUTVSVTWBXIXCJUDRXMWEWCXBHIWDZVDWN
        XOWQWTXGWNXAXOWFXBXOWGWNWQWTXOVLWNWQWTXOVMABCDEFGHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAWHWIWJ $.
    $}

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT . f
       preserves join: f(r ` \/ ` s) = f(r) ` \/ ` s, p. 115 10th line from
       bottom.  (Contributed by NM, 20-Mar-2013.)
       (New usage is discouraged.) $)
    cdleme42mN $p |- ( ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) ) )
          -> ( F ` ( R .\/ S ) ) = ( ( F ` R ) .\/ ( F ` S ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv wceq simpl simpr2 simpr3 simpr1 eqid
      cdleme42g syl121anc cdleme42ke eqtr4d ) SUTVAUDPVAVBHEVAHUDTVCVDVBIEVAIUD
      TVCVDVBVEZHIVFZJEVAJUDTVCVDVBZKEVAKUDTVCVDVBZVEZVBZJKRVGZNVHZJNVHZWEUDUAV
      GZRVGZWGKNVHRVGWDVSWAWBVTWFWIVIVSWCVJVSVTWAWBVKVSVTWAWBVLVSVTWAWBVMABCDEF
      GHIJKLMNOPQRSTUAUBUCWHUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSWHVNZVOVPABCDEFGHIJ
      KLMNOPQRSTUAUBUCWHUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSWJVQVR $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT . f
       preserves join: f(r ` \/ ` s) = f(r) ` \/ ` s, p. 115 10th line from
       bottom.  TODO:  Use instead of ~ cdleme42mN ?  Combine with
       ~ cdleme42mN ?  (Contributed by NM, 20-Mar-2013.)
       (New usage is discouraged.) $)
    cdleme42mgN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) ) )
              -> ( F ` ( R .\/ S ) ) = ( ( F ` R ) .\/ ( F ` S ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wceq clat simpl1l hllat syl simprll simprrl
      co atbase 3jca latjcl cdleme31id sylan 3ad2antl2 3ad2antl3 oveq12d eqtr4d
      wne simpll simpr simplrl simplrr cdleme42mN syl13anc pm2.61dane ) SUTVAZU
      DPVAZVBHEVAHUDTVCVDVBZIEVAIUDTVCVDVBZVEZJEVAZJUDTVCVDZVBZKEVAZKUDTVCVDZVB
      ZVBZVBZJKRVNZNVFZJNVFZKNVFZRVNZVGZHIXDSVHVAZJFVAZKFVAZVEZHIVGZXJXDXKXLXMX
      DWLXKWLWMWNWOXCVISVJVKXDWQXLWPWQWRXBVLEFJSUFUJVOVKXDWTXMWPWSWTXAVMEFKSUFU
      JVOVKVPXNXOVBZXFXEXIXNXEFVAXOXFXEVGFRSJKUFUHVQAFHINTUCUDXEUSVRVSXPXGJXHKR
      XLXKXOXGJVGXMAFHINTUCUDJUSVRVTXMXKXOXHKVGXLAFHINTUCUDKUSVRWAWBWCVSXDHIWDZ
      VBWPXQWSXBXJWPXCXQWEXDXQWFWPWSXBXQWGWPWSXBXQWHABCDEFGHIJKLMNOPQRSTUAUBUCU
      DUEUFUGUHUIUJUKULUMUNUOUPUQURUSWIWJWK $.
  $}

  ${
    cdleme43.b $e |- B = ( Base ` K ) $.
    cdleme43.l $e |- .<_ = ( le ` K ) $.
    cdleme43.j $e |- .\/ = ( join ` K ) $.
    cdleme43.m $e |- ./\ = ( meet ` K ) $.
    cdleme43.a $e |- A = ( Atoms ` K ) $.
    cdleme43.h $e |- H = ( LHyp ` K ) $.
    cdleme43.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    cdleme43.x $e |- X = ( ( Q .\/ P ) ./\ W ) $.
    $( ` C ` is f(s) $)
    cdleme43.c $e |- C
      = ( ( S .\/ U ) ./\ ( Q .\/ ( ( P .\/ S ) ./\ W ) ) ) $.
    $( ` Z ` is f(r)=f_s(r) $)
    cdleme43.f $e |- Z
      = ( ( P .\/ Q ) ./\ ( C .\/ ( ( R .\/ S ) ./\ W ) ) ) $.
    $( ` D ` is g(s) $)
    cdleme43.d $e |- D
      = ( ( S .\/ X ) ./\ ( P .\/ ( ( Q .\/ S ) ./\ W ) ) ) $.
    $( ` G ` is g(f(r))=g_s(f_s(r)) $)
    cdleme43.g $e |- G
      = ( ( Q .\/ P ) ./\ ( D .\/ ( ( Z .\/ S ) ./\ W ) ) ) $.
    $( ` E ` is f(g(s)) $)
    cdleme43.e $e |- E
      = ( ( D .\/ U ) ./\ ( Q .\/ ( ( P .\/ D ) ./\ W ) ) ) $.
    $( ` V ` is v_1 $)
    cdleme43.v $e |- V = ( ( Z .\/ S ) ./\ W ) $.
    $( ` Y ` is v_2 $)
    cdleme43.y $e |- Y = ( ( R .\/ D ) ./\ W ) $.
    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT p. 115
       penultimate line: g(f(r)) = (p v q) ^ (g(s) v v_1) (Contributed by NM,
       20-Mar-2013.)  (New usage is discouraged.) $)
    cdleme43aN $p |- ( ( K e. HL /\ P e. A /\ Q e. A )
              -> G = ( ( P .\/ Q ) ./\ ( D .\/ V ) ) ) $=
      ( chlt wcel w3a co hlatjcom wceq oveq2i a1i oveq12d syl6reqr ) NUQUREAURF
      AURUSZEFMUTZDQMUTZPUTFEMUTZDUAHMUTRPUTZMUTZPUTKVGVHVJVIVLPAMNEFUDUFVAVIVL
      VBVGQVKDMUOVCVDVEUMVF $.

    $( Lemma for Lemma E in [Crawley] p. 113. g(s) is an atom not under w.
       (Contributed by NM, 20-Mar-2013.)  (New usage is discouraged.) $)
    cdleme43bN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
        /\ -. S .<_ ( P .\/ Q ) )
       -> ( D e. A /\ -. D .<_ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co simp11 simp13 simp12 simp2r simp2l simp3
      necomd simp11l simp12l simp13l hlatjcom syl3anc mtbid cdleme3fa syl132anc
      wceq breq2d cdleme3 jca ) NUQURZRLURZUSZEAURZEROUTVAZUSZFAURZFROUTVAZUSZV
      BZEFVCZHAURHROUTVAUSZUSZHEFMVDZOUTZVAZVBZDAURZDROUTVAZWTWFWLWIWOFEVCZHFEM
      VDZOUTZVAZXAWFWIWLWPWSVEZWFWIWLWPWSVFZWFWIWLWPWSVGZWMWNWOWSVHZWTEFWMWNWOW
      SVIVKZWTWRXEWMWPWSVJWTWQXDHOWTWDWGWJWQXDVTWDWEWIWLWPWSVLWGWHWFWLWPWSVMWJW
      KWFWIWPWSVNAMNEFUDUFVOVPWAVQZAFEHSDLMNOPRUCUDUEUFUGUIULVRVSWTWFWLWIWOXCXF
      XBXGXHXIXJXKXLAFEHSDLMNOPRUCUDUEUFUGUIULWBVSWC $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT p. 115
       last line: r v g(s) = r v v_2 (Contributed by NM, 20-Mar-2013.)
       (New usage is discouraged.) $)
    cdleme43cN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ -. S .<_ ( P .\/ Q ) )
              -> ( R .\/ D ) = ( R .\/ Y ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq simp11 simp22 simp1 simp21 simp23 simp3
      wne cdleme43bN syl121anc cdleme42a syl3anc ) NUQURRLURUSZEAUREROUTVAUSZFA
      URFROUTVAUSZVBZEFVKZGAURGROUTVAUSZHAURHROUTVAUSZVBZHEFMVCOUTVAZVBZVPWADAU
      RDROUTVAUSZGDMVCGTMVCVDVPVQVRWCWDVEVSVTWAWBWDVFWEVSVTWBWDWFVSWCWDVGVSVTWA
      WBWDVHVSVTWAWBWDVIVSWCWDVJABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMU
      NUOUPVLVMABGDLMNOPTRUBUCUDUEUFUGUPVNVO $.

    $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT p. 116
       2nd line: f(r) v s = f(r) v f(g(s)) (Contributed by NM, 20-Mar-2013.)
       (New usage is discouraged.) $)
    cdleme43dN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
              -> ( Z .\/ S ) = ( Z .\/ E ) ) $=
      ( chlt wcel wa wbr wn w3a wne co simp11l simp12l simp13l hlatjcom syl3anc
      wceq oveq1d oveq2d simp11 simp13 simp12 simp21 necomd simp23 simp3r mtbid
      3eqtr4g breq2d cdleme35g syl321anc eqtrd syl5eq eqcomd ) NUQURZRLURZUSZEA
      URZEROUTVAZUSZFAURZFROUTVAZUSZVBZEFVCZGAURGROUTVAUSZHAURHROUTVAUSZVBZGEFM
      VDZOUTZHXBOUTZVAZUSZVBZUAJMVDUAHMVDXGJHUAMXGJDIMVDZFEDMVDRPVDMVDZPVDZHUNX
      GXJDSMVDZXIPVDZHXGXHXKXIPXGISDMXGXBRPVDFEMVDZRPVDISXGXBXMRPXGWHWKWNXBXMVJ
      WHWIWMWPXAXFVEWKWLWJWPXAXFVFWNWOWJWMXAXFVGAMNEFUDUFVHVIZVKUHUIWAVLVKXGWJW
      PWMFEVCWTHXMOUTZVAXLHVJWJWMWPXAXFVMWJWMWPXAXFVNWJWMWPXAXFVOXGEFWQWRWSWTXF
      VPVQWQWRWSWTXFVRXGXDXOWQXAXCXEVSXGXBXMHOXNWBVTAFEHSDLMNOPRUCUDUEUFUGUIULW
      CWDWEWFVLWG $.
  $}

  ${
    cdleme46fg.j $e |- .\/ = ( join ` K ) $.
    cdleme46fg.a $e |- A = ( Atoms ` K ) $.
    $( Conversion for ` G ` to reuse ` F ` theorems.  TODO FIX COMMENT TODO
       What other conversion theorems would be reused? e.g. ~ cdlemeg46nlpq ?
       Find other ~ hlatjcom uses giving ` Q .\/ P ` .  (Contributed by NM,
       1-Apr-2013.) $)
    cdleme46f2g2 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) )
   -> ( ( ( K e. HL /\ W e. H )
             /\ ( Q e. A /\ -. Q .<_ W )
             /\ ( P e. A /\ -. P .<_ W ) )
          /\ ( Q =/= P /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( Q .\/ P ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co 3jca simp11 simp13 simp12 simp2l simpl1l
      necomd simp2r wceq simpl2l simpl3l hlatjcom syl3anc breq2d notbid biimp3a
      jca ) GLMZIEMZNZBAMZBIHOPZNZCAMZCIHOPZNZQZBCRZDAMDIHOPNZNZDBCFSZHOZPZQZUS
      VEVBQCBRZVHNDCBFSZHOZPZVMUSVEVBUSVBVEVIVLUAUSVBVEVIVLUBUSVBVEVIVLUCTVMVNV
      HVMBCVFVGVHVLUDUFVFVGVHVLUGUPVFVIVLVQVFVINZVKVPVRVJVODHVRUQUTVCVJVOUHUQUR
      VBVEVIUEUTVAUSVEVIUIVCVDUSVBVIUJAFGBCJKUKULUMUNUOT $.

    $( Conversion for ` G ` to reuse ` F ` theorems.  TODO FIX COMMENT
       (Contributed by NM, 1-Apr-2013.) $)
    cdleme46f2g1 $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
  -> ( ( ( K e. HL /\ W e. H )
           /\ ( Q e. A /\ -. Q .<_ W )
           /\ ( P e. A /\ -. P .<_ W ) )
       /\ ( Q =/= P /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( Q .\/ P ) /\ -. S .<_ ( Q .\/ P ) ) ) ) $=
      ( wcel wa wbr wn w3a wne co 3jca chlt simp11 simp13 simp12 simp21 simpl1l
      necomd simp22 simp23 wceq simpl2l simpl3l hlatjcom syl3anc breq2d anbi12d
      notbid biimp3a ) HUAMZJFMZNZBAMZBJIOPZNZCAMZCJIOPZNZQZBCRZDAMDJIOPNZEAMEJ
      IOPNZQZDBCGSZIOZEVMIOZPZNZQZVAVGVDQCBRZVJVKQDCBGSZIOZEVTIOZPZNZVRVAVGVDVA
      VDVGVLVQUBVAVDVGVLVQUCVAVDVGVLVQUDTVRVSVJVKVRBCVHVIVJVKVQUEUGVHVIVJVKVQUH
      VHVIVJVKVQUITVHVLVQWDVHVLNZVNWAVPWCWEVMVTDIWEUSVBVEVMVTUJUSUTVDVGVLUFVBVC
      VAVGVLUKVEVFVAVDVLULAGHBCKLUMUNZUOWEVOWBWEVMVTEIWFUOUQUPURT $.
  $}

  ${
    $( TODO fix $d's $)
    $d s t x y z A $.  $d s t x y z B $.  $d s x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t x y z R $.  $d s t x y z U $.  $d s t x y z W $.
    $d s t x y z A $.  $d s t x y z B $.  $d x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t y R $.  $d s t x y z S $.  $d s t x y z U $.
    $d s t x y z W $.
    cdlemef46.b $e |- B = ( Base ` K ) $.
    cdlemef46.l $e |- .<_ = ( le ` K ) $.
    cdlemef46.j $e |- .\/ = ( join ` K ) $.
    cdlemef46.m $e |- ./\ = ( meet ` K ) $.
    cdlemef46.a $e |- A = ( Atoms ` K ) $.
    cdlemef46.h $e |- H = ( LHyp ` K ) $.
    cdlemef46.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
    cdlemef46.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    $( f_t(s), s ` <_ ` p ` \/ ` q $)
    cdlemefs46.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdlemef46.f $e |- F = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.
    $( Part of proof of Lemma E in [Crawley] p. 114, first part of 4th
       paragraph. ` F ` , ` G ` represent f(s), f_s(p) respectively.  We show,
       in their notation, f_s(p)=q.  TODO FIX COMMENT (Contributed by NM,
       5-Apr-2013.) $)
    cdleme17d2 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) )
      -> ( F ` P ) = Q ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv csb wceq simp1 simp2l simp12 simp11l
      simp2r simp12l simp13l hlatlej1 syl3anc cdlemefs45 syl132anc simp2rl eqid
      simp3 cdleme31sde syl2anc simp11 cdleme17d1 syl131anc 3eqtrd ) PUKULZSNUL
      ZUMZHEULZHSQUNUOZUMZIEULZISQUNUOZUMZUPZHIUQZJEULZJSQUNUOZUMZUMZJHIOURZQUN
      UOZUPZHMUSZTHDJLUTUTZWQJKOURIHJOURSRURZOURRURZXBOURRURZIWSWKWLWGWOHWQQUNZ
      WRWTXAVAWKWPWRVBWKWLWOWRVCWDWGWJWPWRVDZWKWLWOWRVFZWSWBWEWHXEWBWCWGWJWPWRV
      EWEWFWDWJWPWRVGZWHWIWDWGWPWRVHZEHIOPQUBUCUEVIVJWKWPWRVOZABCDEFGHIHJKLMNOP
      QRSTUAUBUCUDUEUFUGUHUJUIVKVLWSWEWMXAXDVAXHWMWNWLWKWRVMDEGHIHJKLORSXCXDTUH
      UIXCVNZXDVNZVPVQWSWDWGWHWOWRXDIVAWDWGWJWPWRVRXFXIXGXJEHIJKXCXDNOPQRSUBUCU
      DUEUFUGXKXLVSVTWA $.

    $d e A $.  $d e F $.  $d e H $.  $d e .\/ $.  $d e K $.  $d e .<_ $.
    $d e P $.  $d e Q $.  $d e W $.  $d e s t x y z $.
    $( TODO FIX COMMENT (Contributed by NM, 5-Apr-2013.) $)
    cdleme17d3 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ P =/= Q ) -> ( F ` P ) = Q ) $=
      ( ve chlt wcel wa wbr wn w3a wne cv co wrex cfv wceq simpl1 simpl2 simpl3
      simpr cdlemb2 syl121anc simp1 simp2 simp3l simp3rl jca simp3rr cdleme17d2
      3expia exp3a rexlimdv mpd ) OUKULRMULUMZHEULHRPUNUOUMZIEULIRPUNUOUMZUPZHI
      UQZUMZUJURZRPUNUOZWFHINUSPUNUOZUMZUJEUTZHLVAIVBZWEVTWAWBWDWJVTWAWBWDVCVTW
      AWBWDVDVTWAWBWDVEWCWDVFEHIMNOPRUJUAUBUDUEVGVHWEWIWKUJEWEWFEULZWIWKWCWDWLW
      IUMZWKWCWDWMUPZWCWDWLWGUMWHWKWCWDWMVIWCWDWMVJWNWLWGWCWDWLWIVKWGWHWLWCWDVL
      VMWGWHWLWCWDVNABCDEFGHIWFJKLMNOPQRSTUAUBUCUDUEUFUGUHUIVOVHVPVQVRVS $.

    $( TODO FIX COMMENT (Contributed by NM, 11-Apr-2013.) $)
    cdleme17d4 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ P = Q ) -> ( F ` P ) = Q ) $=
      ( chlt wcel wa wbr wn w3a wceq cfv simp2l atbase syl cv wral crio csb cif
      co wi cdleme31id sylan simpr eqtrd ) OUJUKRMUKULZHEUKZHRPUMUNZULIEUKIRPUM
      UNULZUOZHIUPZULHLUQZHIVPHFUKZVQVRHUPVPVMVSVLVMVNVOUREFHOTUDUSUTAFHILPSVAZ
      RPUMUNVTAVAZRQVFZNVFWAUPULCVAVTHINVFZPUMDVAZRPUMUNWDWCPUMUNULBVAKUPVGDEVB
      BFVCDVTGVDVEWBNVFUPVGSEVBCFVCRHUIVHVIVPVQVJVK $.

    $( Part of proof of Lemma E in [Crawley] p. 114, first part of 4th
       paragraph.  We show, in their notation, f_s(p)=q.  TODO FIX COMMENT
       (Contributed by NM, 11-Apr-2013.) $)
    cdleme17d $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) ) -> ( F ` P ) = Q ) $=
      ( chlt wcel wa wbr wn w3a cfv wceq cdleme17d4 cdleme17d3 pm2.61dane ) OUJ
      UKRMUKULHEUKHRPUMUNULIEUKIRPUMUNULUOHLUPIUQHIABCDEFGHIJKLMNOPQRSTUAUBUCUD
      UEUFUGUHUIURABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUSUT $.

    $d s t x z X $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO:  Can this replace
       uses of ~ cdleme32a ?  TODO:  Can this be used to help prove the ` R `
       or ` S ` case where ` X ` is an atom?  (Contributed by NM,
       8-Apr-2013.) $)
    cdleme48fv $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S .\/ ( X ./\ W ) ) = X ) )
       -> ( F ` X ) = ( ( F ` S ) .\/ ( X ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cfv cv wi wral crio csb cif simp2rl
      simp2l simp2rr jca32 eqid biid cvv vex cdleme31sc ax-mp ifbieq2i syld3an2
      cdleme42b simp1 simp3l cdleme32fva1 syl3anc oveq1d eqtr4d ) PULUMSNUMUNHE
      UMHSQUOUPUNIEUMISQUOUPUNUQZHIURZTFUMZTSQUOUPZUNZUNZJEUMJSQUOUPUNZJTSRUSZO
      USTUTZUNZUQZTMVAZUAJUAVBZHIOUSZQUOZDVBZSQUOUPXBWTQUOUPUNBVBLUTVCDEVDBFVEZ
      DWSGVFZVGZVFZWNOUSZJMVAZWNOUSWGWIWHWJUNUNWLWPWRXGUTWQWIWHWJWIWJWHWGWPVHWG
      WHWKWPVIZWIWJWHWGWPVJVKABCDEFWSKOUSIHWSOUSSRUSOUSRUSZHIJKGMLNXCOPQRXEWSSQ
      UOUPWSAVBZSRUSZOUSXKUTUNCVBXEXLOUSUTVCUAEVDCFVEZSTUAUBUCUDUEUFUGUHXJVLZUI
      UJXCVLZXAXAXDXJXCXAVMWSVNUMXDXJUTUAVOVNGHIWSKORSXJDUIXNVPVQZVRXMVLZUKVTVS
      WQXHXFWNOWQWGWMWHXHXFUTWGWLWPWAWGWLWMWOWBXIABCDEFXDGHIJKLMNXCOPQRXEXMSUAU
      BUCUDUEUFUGUHXPUIUJXOXEVLXQUKWCWDWEWF $.

    $( Remove ` P =/= Q ` condition in ~ cdleme48fv .  TODO:  Can this replace
       uses of ~ cdleme32a ?  TODO:  Can this be used to help prove the ` R `
       or ` S ` case where ` X ` is an atom?  TODO:  Can this be proved more
       directly by eliminating ` P =/= Q ` in earlier theorems?  Should this
       replace uses of ~ cdleme48fv ?  (Contributed by NM, 23-Apr-2013.) $)
    cdleme48fvg $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ -. X .<_ W )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S .\/ ( X ./\ W ) ) = X ) )
       -> ( F ` X ) = ( ( F ` S ) .\/ ( X ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq cfv simpl3r simp3ll adantr atbase cv wi
      syl wral crio csb cdleme31id sylancom oveq1d simp2l sylan 3eqtr4rd simpl1
      cif wne simpr simpl2 simpl3 cdleme48fv syl121anc pm2.61dane ) PULUMSNUMUN
      HEUMHSQUOUPUNIEUMISQUOUPUNUQZTFUMZTSQUOUPZUNZJEUMZJSQUOUPZUNZJTSRURZOURZT
      USZUNZUQZTMUTZJMUTZWMOURZUSZHIWQHIUSZUNZWNTWTWRWLWOWFWIXBVAXCWSJWMOWQXBJF
      UMZWSJUSXCWJXDWQWJXBWJWKWOWFWIVBVCEFJPUBUFVDVGAFHIMQUAVEZSQUOUPXEAVEZSRUR
      ZOURXFUSUNCVEXEHIOURZQUODVEZSQUOUPXIXHQUOUPUNBVELUSVFDEVHBFVIDXEGVJVRXGOU
      RUSVFUAEVHCFVIZSJUKVKVLVMWQWGXBWRTUSWFWGWHWPVNAFHIMQXJSTUKVKVOVPWQHIVSZUN
      WFXKWIWPXAWFWIWPXKVQWQXKVTWFWIWPXKWAWFWIWPXKWBABCDEFGHIJKLMNOPQRSTUAUBUCU
      DUEUFUGUHUIUJUKWCWDWE $.

    $( Show that ` ( F `` R ) ` is an atom not under ` W ` when ` R ` is an
       atom not under ` W ` .  (Contributed by NM, 18-Apr-2013.) $)
    cdleme46fvaw $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( R e. A /\ -. R .<_ W ) )
              -> ( ( F ` R ) e. A /\ -. ( F ` R ) .<_ W ) ) $=
      ( cv csb wbr wn co wa wceq wi wral crio cif cvv wcel vex cdleme31sc ax-mp
      eqid cdleme32fvaw ) ABCDEFDTUKZGULZGHIJKLMNDUKZSQUMUNVKHIOUOZQUMUNUPBUKLU
      QURDEUSBFUTZOPQRVIVLQUMVMVJVAZVISQUMUNVIAUKZSRUOZOUOVOUQUPCUKVNVPOUOUQURT
      EUSCFUTZSTUAUBUCUDUEUFUGVIVBVCVJVIKOUOIHVIOUOSRUOOUORUOZUQTVDVBGHIVIKORSV
      RDUHVRVGVEVFUHUIVMVGVNVGVQVGUJVH $.

    $( TODO: fix comment.  TODO:  Remove unnecessary ` P =/= Q ` from
       ~ cdleme48bw ~ cdlemeg46c ~ cdlemeg46fvaw ~ cdlemeg46rgv
       ~ cdlemeg46gfv ? ~ cdleme48d ? and possibly others they affect.
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme48bw $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S .\/ ( X ./\ W ) ) = X ) )
       -> -. ( F ` X ) .<_ W ) $=
      ( chlt wcel wa wbr wn w3a wne wceq cfv simp3l cdleme46fvaw syl2anc simprd
      simp1 clat simp11l hllat syl simpld atbase simp2rl simp11r lhpbase latmcl
      co syl3anc latlej1 cdleme48fv breqtrrd wi cv csb wral crio cif cdleme31sc
      cvv vex eqid ax-mp cdleme32fvcl lattr syl13anc mpand mtod ) PULUMZSNUMZUN
      HEUMHSQUOUPUNZIEUMISQUOUPUNZUQZHIURZTFUMZTSQUOUPZUNUNZJEUMJSQUOUPUNZJTSRV
      PZOVPTUSZUNZUQZTMUTZSQUOZJMUTZSQUOZXJXMEUMZXNUPZXJXAXFXOXPUNXAXEXIVEZXAXE
      XFXHVAABCDEFGHIJKLMNOPQRSUAUBUCUDUEUFUGUHUIUJUKVBVCZVDXJXMXKQUOZXLXNXJXMX
      MXGOVPZXKQXJPVFUMZXMFUMZXGFUMZXMXTQUOXJWQYAWQWRWSWTXEXIVGPVHVIZXJXOYBXJXO
      XPXRVJEFXMPUBUFVKVIZXJYAXCSFUMZYCYDXCXDXBXAXIVLZXJWRYFWQWRWSWTXEXIVMFNPSU
      BUGVNVIZFPRTSUBUEVOVQFOPQXMXGUBUCUDVRVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUG
      UHUIUJUKVSVTXJYAYBXKFUMZYFXSXLUNXNWAYDYEXJXAXCYIXQYGABCDEFDUAWBZGWCZGHIKL
      MNDWBZSQUOUPYLHIOVPZQUOUPUNBWBLUSWADEWDBFWEZOPQRYJYMQUOYNYKWFZYJSQUOUPYJA
      WBZSRVPZOVPYPUSUNCWBYOYQOVPUSWAUAEWDCFWEZSTUAUBUCUDUEUFUGUHYJWHUMYKYJKOVP
      IHYJOVPSRVPOVPRVPZUSUAWIWHGHIYJKORSYSDUIYSWJWGWKUIUJYNWJYOWJYRWJUKWLVCYHF
      PQXMXKSUBUCWMWNWOWP $.

    $( TODO: fix comment.  (Contributed by NM, 8-Apr-2013.) $)
    cdleme48b $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S .\/ ( X ./\ W ) ) = X ) )
       -> ( ( F ` X ) ./\ W ) = ( X ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cfv cdleme48fv oveq1d simp11 simp3l
      simp1 cdleme46fvaw syl2anc simp2rl lhpelim syl3anc eqtrd ) PULUMSNUMUNZHE
      UMHSQUOUPUNZIEUMISQUOUPUNZUQZHIURZTFUMZTSQUOUPZUNUNZJEUMJSQUOUPUNZJTSRUSZ
      OUSTUTZUNZUQZTMVAZSRUSJMVAZWBOUSZSRUSZWBWEWFWHSRABCDEFGHIJKLMNOPQRSTUAUBU
      CUDUEUFUGUHUIUJUKVBVCWEVMWGEUMWGSQUOUPUNZVRWIWBUTVMVNVOVTWDVDWEVPWAWJVPVT
      WDVFVPVTWAWCVEABCDEFGHIJKLMNOPQRSUAUBUCUDUEUFUGUHUIUJUKVGVHVRVSVQVPWDVIEF
      WGNOPQRSTUBUCUDUEUFUGVJVKVL $.

    $( Show that ` ( F `` S ) ` is not under ` P .\/ Q ` when ` S ` isn't.
       (Contributed by NM, 1-Apr-2013.) $)
    cdleme46frvlpq $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) ) -> -. ( F ` S ) .<_ ( P .\/ Q ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv eqid cdleme35fnpq cdlemefr45e breq1d
      mtbird ) PUKULSNULUMHEULHSQUNUOUMIEULISQUNUOUMUPHIUQJEULJSQUNUOUMUMJHIOUR
      ZQUNUOUPZJMUSZVEQUNJKOURIHJOURSRUROURRURZVEQUNEHIJKVHNOPQRSUBUCUDUEUFUGVH
      UTVAVFVGVHVEQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUJVBVCVD $.

    $( Show that ` ( F `` R ) ` is under ` P .\/ Q ` when ` R ` is.
       (Contributed by NM, 1-Apr-2013.) $)
    cdleme46fsvlpq $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) ) -> ( F ` R ) .<_ ( P .\/ Q ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv cv wceq wral crio csb cdlemefs32fva1
      wi cif eqid cvv vex cdleme31sc ax-mp cdleme41sn3a eqbrtrd ) PUKULSNULUMHE
      ULHSQUNUOUMIEULISQUNUOUMUPHIUQJEULJSQUNUOUMUMJHIOURZQUNUPJMUSTJTUTZVOQUND
      UTZSQUNUOVQVOQUNUOUMZBUTZLVAVFDEVBBFVCZDVPGVDZVGZVDVOQABCDEFWAGHIJKLMNVTO
      PQRWBVPSQUNUOVPAUTZSRURZOURWCVAUMCUTWBWDOURVAVFTEVBCFVCZSTUAUBUCUDUEUFUGU
      HUIVTVHZWBVHZWEVHUJVEBDEFWAGHIJKLNVTOPQRWBSVOGJVQOURSRUROURRURZVRVSWHVAVF
      DEVBBFVCZTUAUBUCUDUEUFUGVPVIULWAVPKOURIHVPOURSRUROURRURZVATVJVIGHIVPKORSW
      JDUHWJVHVKVLUHUIWFWGWHVHWIVHVMVN $.
  $}

  ${
    $d a b c u v w A $.  $d a b c u v B $.  $d a b c u v H $.
    $d a b c u v w .\/ $.  $d a b c u v K $.  $d a b c u v .<_ $.
    $d a b c u v w ./\ $.  $d a b c u w N $.  $d a b c O $.
    $d a b c u v w P $.  $d a b c u v w Q $.  $d a b c u v w R $.
    $d a b c u v w S $.  $d a b c u v V $.  $d a b c u v w W $.
    cdlemef47.b $e |- B = ( Base ` K ) $.
    cdlemef47.l $e |- .<_ = ( le ` K ) $.
    cdlemef47.j $e |- .\/ = ( join ` K ) $.
    cdlemef47.m $e |- ./\ = ( meet ` K ) $.
    cdlemef47.a $e |- A = ( Atoms ` K ) $.
    cdlemef47.h $e |- H = ( LHyp ` K ) $.
    cdlemef47.v $e |- V = ( ( Q .\/ P ) ./\ W ) $.
    $( g(t), ` -. ` v ` <_ ` p ` \/ ` q. $)
    cdlemef47.n $e |- N
        = ( ( v .\/ V ) ./\ ( P .\/ ( ( Q .\/ v ) ./\ W ) ) ) $.
    $( g_t(s), u ` <_ ` p ` \/ ` q $)
    cdlemefs47.o $e |- O
        = ( ( Q .\/ P ) ./\ ( N .\/ ( ( u .\/ v ) ./\ W ) ) ) $.
    cdlemef47.g $e |- G = ( a e. B |->
         if ( ( Q =/= P /\ -. a .<_ W ) ,
           $( g(x) when p ` =/= ` q and ` -. ` a ` <_ ` w. $)
           ( iota_ c e. B A. u e. A
                ( ( -. u .<_ W /\ ( u .\/ ( a ./\ W ) ) = a ) -> c = (
                    $( g_t(s), u ` <_ ` p ` \/ ` q $)
                    if ( u .<_ ( Q .\/ P ) ,
                       ( iota_ b e. B A. v e. A
                             ( ( -. v .<_ W /\ -. v .<_ ( Q .\/ P ) )
                             -> b = O ) ) ,
                    $( g(s), ` -. ` u ` <_ ` p ` \/ ` q. $)
                       [_ u / v ]_ N )
                .\/ ( a ./\ W ) ) ) ) ,
           $( g(x) when p = q or a ` <_ ` w is just x. $)
           a ) ) $.
    $d a c u v X $.
    $( TODO: fix comment.  (Contributed by NM, 9-Apr-2013.) $)
    cdlemeg46fvcl $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) ) /\ X e. B )
      -> ( G ` X ) e. B ) $=
      ( chlt wcel wa wbr wn w3a cfv simpl1 simpl3 simpl2 simpr cv csb wceq wral
      co wi crio cif cvv vex eqid cdleme31sc ax-mp cdleme32fvcl syl31anc ) JUKU
      LPHULUMZECULEPKUNUOUMZFCULFPKUNUOUMZUPZQDULZUMVQVSVRWAQGUQDULVQVRVSWAURVQ
      VRVSWAUSVQVRVSWAUTVTWAVARSTACDABVBZMVCZMFEONGHAVBZPKUNUOWDFEIVFZKUNUOUMSV
      BNVDVGACVESDVHZIJKLWBWEKUNWFWCVIZWBPKUNUOWBRVBZPLVFZIVFWHVDUMTVBWGWIIVFVD
      VGBCVETDVHZPQBUAUBUCUDUEUFUGWBVJULWCWBOIVFEFWBIVFPLVFIVFLVFZVDBVKVJMFEWBO
      ILPWKAUHWKVLVMVNUHUIWFVLWGVLWJVLUJVOVP $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO:  Can this replace
       uses of ~ cdleme32a ?  TODO:  Can this be used to help prove the ` R `
       or ` S ` case where ` X ` is an atom?  TODO:  Would an antecedent
       transformer like ~ cdleme46f2g2 help?  (Contributed by NM,
       8-Apr-2013.) $)
    cdleme4gfv $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S .\/ ( X ./\ W ) ) = X ) )
       -> ( G ` X ) = ( ( G ` S ) .\/ ( X ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne wceq cfv simp11 simp13 simp12 simp2l necomd
      co simp2r simp3 cdleme48fv syl321anc ) KULUMQIUMUNZECUMEQLUOUPUNZFCUMFQLU
      OUPUNZUQZEFURZRDUMRQLUOUPUNZUNZGCUMGQLUOUPUNGRQMVFZJVFRUSUNZUQZVKVMVLFEUR
      VPVSRHUTGHUTVRJVFUSVKVLVMVQVSVAVKVLVMVQVSVBVKVLVMVQVSVCVTEFVNVOVPVSVDVEVN
      VOVPVSVGVNVQVSVHSTUAACDNFEGPOHIJKLMQRBUBUCUDUEUFUGUHUIUJUKVIVJ $.

    $( TODO FIX COMMENT (Contributed by NM, 1-Apr-2013.) $)
    cdlemeg47b $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) )
      -> ( G ` S ) = [_ S / v ]_ N ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv csb wceq cdleme46f2g2 cdlemefr45 syl
      ) KUKULQIULUMZECULEQLUNUOUMZFCULFQLUNUOUMZUPEFUQGCULGQLUNUOUMZUMGEFJURLUN
      UOUPVEVGVFUPFEUQVHUMGFEJURLUNUOUPGHUSAGNUTVACEFGIJKLQUCUEVBRSTACDNFEGPOHI
      JKLMQBUAUBUCUDUEUFUGUHUJVCVD $.

    $( Value of g_s(r) when r is an atom under pq and s is any atom not under
       pq, using very compact hypotheses.  TODO FIX COMMENT (Contributed by NM,
       3-Apr-2013.) $)
    cdlemeg47rv $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( G ` R ) = [_ R / u ]_ [_ S / v ]_ O ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv csb wceq cdleme46f2g1 cdlemefs45 syl
      ) LULUMRJUMUNZECUMERMUOUPUNZFCUMFRMUOUPUNZUQEFURGCUMGRMUOUPUNZHCUMHRMUOUP
      UNZUQGEFKUSZMUOHVKMUOUPUNUQVFVHVGUQFEURVIVJUQGFEKUSZMUOHVLMUOUPUNUQGIUTBG
      AHPVAVAVBCEFGHJKLMRUDUFVCSTUAACDOFEGHQPIJKLMNRBUBUCUDUEUFUGUHUIUKUJVDVE
      $.

    $( Value of g_s(r) when r is an atom under pq and s is any atom not under
       pq, using very compact hypotheses.  TODO FIX COMMENT (Contributed by NM,
       1-Apr-2013.) $)
    cdlemeg47rv2 $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
     /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
 -> ( G ` R )
        = ( ( Q .\/ P ) ./\ ( ( G ` S ) .\/ ( ( R .\/ S ) ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv cdlemeg47rv wceq simp22l nfcvd oveq1
      csb cv oveq1d oveq2d csbiegf syl simp23l eqid cdleme31se2 csbeq2dv simp21
      simp1 simp23 simp3r cdlemeg47b syl121anc 3eqtr4d eqtrd ) LULUMRJUMUNECUME
      RMUOUPUNFCUMFRMUOUPUNUQZEFURZGCUMZGRMUOUPZUNZHCUMZHRMUOUPZUNZUQZGEFKUSZMU
      OZHWMMUOUPZUNZUQZGIUTBGAHPVFZVFZFEKUSZHIUTZGHKUSZRNUSZKUSZNUSZABCDEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVAWQBGWTAHOVFZBVGZHKUSZRNUSZKUSZNUSZVFZWTX
      FXCKUSZNUSZWSXEWQWFXLXNVBWFWGWEWKWDWPVCBGXKXNCWFBXNVDXGGVBZXJXMWTNXOXIXCX
      FKXOXHXBRNXGGHKVEVHVIVIVJVKWQBGWRXKWQWIWRXKVBWIWJWEWHWDWPVLACOFEXGHPKNRXK
      UJXKVMVNVKVOWQXDXMWTNWQXAXFXCKWQWDWEWKWOXAXFVBWDWLWPVQWDWEWHWKWPVPWDWEWHW
      KWPVRWDWLWNWOVSABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVTWAVHVIWBWC $.

    $d a b c u v Y $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  (Contributed by NM,
       9-Apr-2013.) $)
    cdlemeg49le $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B )
           /\ X .<_ Y ) -> ( G ` X ) .<_ ( G ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a cfv simp11 simp13 simp12 simp2 simp3 cv co wceq
      csb wi wral crio cif cvv vex eqid cdleme31sc ax-mp cdleme32le syl311anc )
      JULUMPHUMUNZECUMEPKUOUPUNZFCUMFPKUOUPUNZUQZQDUMRDUMUNZQRKUOZUQVSWAVTWCWDQ
      GURRGURKUOVSVTWAWCWDUSVSVTWAWCWDUTVSVTWAWCWDVAWBWCWDVBWBWCWDVCSTUAACDABVD
      ZMVGZMFEONGHAVDZPKUOUPWGFEIVEZKUOUPUNTVDNVFVHACVITDVJZIJKLWEWHKUOWIWFVKZW
      EPKUOUPWESVDZPLVEZIVEWKVFUNUAVDWJWLIVEVFVHBCVIUADVJZPQRBUBUCUDUEUFUGUHWEV
      LUMWFWEOIVEEFWEIVEPLVEIVELVEZVFBVMVLMFEWEOILPWNAUIWNVNVOVPUIUJWIVNWJVNWMV
      NUKVQVR $.
  $}

  ${
    $d s t x y z A $.  $d s t x y z B $.  $d s x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t x y z R $.  $d s t x y z U $.  $d s t x y z W $.
    $d s t x y z A $.  $d s t x y z B $.  $d x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t y R $.  $d s t x y z S $.  $d s t x y z U $.
    $d s t x y z W $.
    cdlemef46g.b $e |- B = ( Base ` K ) $.
    cdlemef46g.l $e |- .<_ = ( le ` K ) $.
    cdlemef46g.j $e |- .\/ = ( join ` K ) $.
    cdlemef46g.m $e |- ./\ = ( meet ` K ) $.
    cdlemef46g.a $e |- A = ( Atoms ` K ) $.
    cdlemef46g.h $e |- H = ( LHyp ` K ) $.
    cdlemef46g.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
    cdlemef46g.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    $( f_t(s), s ` <_ ` p ` \/ ` q $)
    cdlemefs46g.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdlemef46g.f $e |- F = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.
    cdlemef46.v $e |- V = ( ( Q .\/ P ) ./\ W ) $.
    $( g(t), ` -. ` v ` <_ ` p ` \/ ` q. $)
    cdlemef46.n $e |- N
        = ( ( v .\/ V ) ./\ ( P .\/ ( ( Q .\/ v ) ./\ W ) ) ) $.
    $( g_t(s), u ` <_ ` p ` \/ ` q $)
    cdlemefs46.o $e |- O
        = ( ( Q .\/ P ) ./\ ( N .\/ ( ( u .\/ v ) ./\ W ) ) ) $.
    cdlemef46.g $e |- G = ( a e. B |->
         if ( ( Q =/= P /\ -. a .<_ W ) ,
           $( g(x) when p ` =/= ` q and ` -. ` a ` <_ ` w. $)
           ( iota_ c e. B A. u e. A
                ( ( -. u .<_ W /\ ( u .\/ ( a ./\ W ) ) = a ) -> c = (
                    $( g_t(s), u ` <_ ` p ` \/ ` q $)
                    if ( u .<_ ( Q .\/ P ) ,
                       ( iota_ b e. B A. v e. A
                             ( ( -. v .<_ W /\ -. v .<_ ( Q .\/ P ) )
                             -> b = O ) ) ,
                    $( g(s), ` -. ` u ` <_ ` p ` \/ ` q. $)
                       [_ u / v ]_ N )
                .\/ ( a ./\ W ) ) ) ) ,
           $( g(x) when p = q or a ` <_ ` w is just x. $)
           a ) ) $.

    $d a b c u v w A $.  $d a b c u v B $.  $d v D $.  $d s t x y z G $.
    $d a b c u v H $.  $d a b c u v w .\/ $.  $d a b c u v K $.
    $d a b c u v .<_ $.  $d a b c u v w ./\ $.  $d a b c w N $.  $d a b c O $.
    $d a b c u v w P $.  $d a b c u v w Q $.  $d a b c u v w R $.
    $d a b c u v w S $.  $d a b c V $.  $d a b c u v w W $.  $d u x y z N $.
    $d x y z O $.  $d t v $.  $d x z S $.  $d u v x y z V $.
    $( TODO FIX COMMENT (Contributed by NM, 1-Apr-2013.)
       (New usage is discouraged.) $)
    cdlemeg46bOLDN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) )
      -> ( G ` S ) = [_ S / v ]_ N ) $=
      ( cdlemeg47b ) DEGHJKLPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUTVAVBVCVD $.

    $( TODO FIX COMMENT (Contributed by NM, 1-Apr-2013.) $)
    cdlemeg46c $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) )
      -> ( F ` ( G ` S ) ) = [_ S / v ]_ [_ N / t ]_ D ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv cdlemeg47b csbeq1d wceq simp1 simp2l
      csb simp11 simp13 simp12 cdleme46fvaw cdleme46f2g2 cdleme46frvlpq simp11l
      simp2r syl31anc simp12l simp13l hlatjcom syl3anc breq2d mtbird cdlemefr45
      syl syl121anc simp2rl csbnestg 3eqtr4d ) SVDVEZUEQVEZVFZJGVEZJUETVGVHZVFZ
      KGVEZKUETVGVHZVFZVIZJKVJZLGVEZLUETVGVHZVFZVFZLJKRVKZTVGVHZVIZFLPVLZIVRZFD
      LUBVRZIVRZXROVLZDLFUBIVRVRZXQFXRXTIDEGHJKLPQRSTUAUBUCUDUEUGUHUIUJUKULUMUN
      UOUTVAVBVCVMVNXQXIXJXRGVEXRUETVGVHVFZXRXOTVGZVHYBXSVOXIXNXPVPXIXJXMXPVQXQ
      XBXHXEXMYDXBXEXHXNXPVSXBXEXHXNXPVTXBXEXHXNXPWAXIXJXMXPWFUGUHUIDGHUBKJLUDU
      CPQRSTUAUEEUJUKULUMUNUOUTVAVBVCWBWGXQYEXRKJRVKZTVGZXQXBXHXEVIKJVJXMVFLYFT
      VGVHVIYGVHGJKLQRSTUEULUNWCUGUHUIDGHUBKJLUDUCPQRSTUAUEEUJUKULUMUNUOUTVAVBV
      CWDWOXQXOYFXRTXQWTXCXFXOYFVOWTXAXEXHXNXPWEXCXDXBXHXNXPWHXFXGXBXEXNXPWIGRS
      JKULUNWJWKWLWMABCFGHIJKXRMNOQRSTUAUEUFUJUKULUMUNUOUPUQUSWNWPXQXKYCYAVOXKX
      LXJXIXPWQDFLUBIGWRWOWS $.

    $( Value of g_s(r) when r is an atom under pq and s is any atom not under
       pq, using very compact hypotheses.  TODO FIX COMMENT (Contributed by NM,
       3-Apr-2013.)  (New usage is discouraged.) $)
    cdlemeg46rvOLDN $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( G ` R ) = [_ R / u ]_ [_ S / v ]_ O ) $=
      ( cdlemeg47rv ) DEGHJKLMQRSTUAUBUCUDUEUFUHUIUJUKULUMUNUOUPVAVBVCVDVE $.

    $( Value of g_s(r) when r is an atom under pq and s is any atom not under
       pq, using very compact hypotheses.  TODO FIX COMMENT (Contributed by NM,
       3-Apr-2013.)  (New usage is discouraged.) $)
    cdlemeg46rv2OLDN $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
      -> ( G ` R )
        = ( ( Q .\/ P ) ./\ ( ( G ` S ) .\/ ( ( R .\/ S ) ./\ W ) ) ) ) $=
      ( cdlemeg47rv2 ) DEGHJKLMQRSTUAUBUCUDUEUFUHUIUJUKULUMUNUOUPVAVBVCVDVE $.

    $( Show that ` ( F `` R ) ` is an atom not under ` W ` when ` R ` is an
       atom not under ` W ` .  (Contributed by NM, 1-Apr-2013.) $)
    cdlemeg46fvaw $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( R e. A /\ -. R .<_ W )
           /\ P =/= Q )
              -> ( ( G ` R ) e. A /\ -. ( G ` R ) .<_ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv simp11 simp13 simp12 simp2 cdleme46fvaw
      syl31anc ) SVDVEUEQVEVFZJGVEJUETVGVHVFZKGVEKUETVGVHVFZVIZLGVELUETVGVHVFZJ
      KVJZVIVRVTVSWBLPVKZGVEWDUETVGVHVFVRVSVTWBWCVLVRVSVTWBWCVMVRVSVTWBWCVNWAWB
      WCVOUGUHUIDGHUBKJLUDUCPQRSTUAUEEUJUKULUMUNUOUTVAVBVCVPVQ $.

    $( Show that ` ( G `` S ) ` is not under ` P .\/ Q ` when ` S ` isn't.
       (Contributed by NM, 3-Apr-2013.) $)
    cdlemeg46nlpq $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( S e. A /\ -. S .<_ W ) )
          /\ -. S .<_ ( P .\/ Q ) ) -> -. ( G ` S ) .<_ ( P .\/ Q ) ) $=
      ( chlt wa wbr wn w3a wne co cfv simp11 simp13 simp12 simp2l necomd simp2r
      wcel simp3 simp11l simp12l simp13l hlatjcom syl3anc breq2d cdleme46frvlpq
      wceq mtbid syl321anc mtbird ) SVDVRZUEQVRZVEZJGVRZJUETVFVGZVEZKGVRZKUETVF
      VGZVEZVHZJKVIZLGVRLUETVFVGVEZVEZLJKRVJZTVFZVGZVHZLPVKZXDTVFXHKJRVJZTVFZXG
      WMWSWPKJVIXBLXITVFZVGXJVGWMWPWSXCXFVLWMWPWSXCXFVMWMWPWSXCXFVNXGJKWTXAXBXF
      VOVPWTXAXBXFVQXGXEXKWTXCXFVSXGXDXILTXGWKWNWQXDXIWGWKWLWPWSXCXFVTWNWOWMWSX
      CXFWAWQWRWMWPXCXFWBGRSJKULUNWCWDZWEWHUGUHUIDGHUBKJLUDUCPQRSTUAUEEUJUKULUM
      UNUOUTVAVBVCWFWIXGXDXIXHTXLWEWJ $.

    $d a b c D $.  $d a b c E $.  $d a b c u v F $.  $d t N $.  $d a b c v U $.
    $d t V $.  $d a b c s t $.
    $( TODO FIX COMMENT g(f(s))=s p. 115 4th line from bottom.  (Contributed by
       NM, 4-Apr-2013.) $)
    cdlemeg46ngfr $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
      -> ( G ` ( F ` R ) ) = R ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv csb wceq cdleme46f2g2 cdlemeg46c syl
      simp2rl cdleme31snd eqtrd simp11l simp12l simp13l hlatjcom syl3anc oveq1d
      eqid 3eqtr4g oveq2d cdleme35g 3eqtr2d ) SVDVEZUEQVEZVFZJGVEZJUETVGVHZVFZK
      GVEZKUETVGVHZVFZVIZJKVJZLGVEZLUETVGVHZVFZVFZLJKRVKZTVGVHZVIZLOVLPVLZLMRVK
      KJLRVKUEUAVKRVKUAVKZUDRVKZJKXKRVKUEUAVKRVKZUAVKZXKMRVKZXMUAVKLXIXJFLDIUBV
      MVMZXNXIWNWTWQVIKJVJXEVFLKJRVKZTVGVHVIXJXPVNGJKLQRSTUEULUNVOUGUHUIFUFDGHU
      BKJLUDUCPOQRSTUAINMUEEABCUJUKULUMUNUOUTVAVBVCUPUQURUSVPVQXIXCXPXNVNXCXDXB
      XAXHVRFDGUBKJLUDXNRUAIXKMUEVAUQXNWGXKWGZVSVQVTXIXOXLXMUAXIMUDXKRXIXGUEUAV
      KXQUEUAVKMUDXIXGXQUEUAXIWLWOWRXGXQVNWLWMWQWTXFXHWAWOWPWNWTXFXHWBWRWSWNWQX
      FXHWCGRSJKULUNWDWEWFUPUTWHWIWFGJKLMXKQRSTUAUEUKULUMUNUOUPXRWJWK $.

    $( TODO FIX COMMENT f(g(s))=s p. 115 antepenultimate line.  (Contributed by
       NM, 4-Apr-2013.) $)
    cdlemeg46nfgr $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ -. R .<_ ( P .\/ Q ) )
      -> ( F ` ( G ` R ) ) = R ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv wceq cdleme46f2g2 cdlemeg46ngfr syl
      ) SVDVEUEQVEVFZJGVEJUETVGVHVFZKGVEKUETVGVHVFZVIJKVJLGVELUETVGVHVFZVFLJKRV
      KTVGVHVIVQVSVRVIKJVJVTVFLKJRVKTVGVHVILPVLOVLLVMGJKLQRSTUEULUNVNUGUHUIFUFD
      GHUBKJLUDUCPOQRSTUAINMUEEABCUJUKULUMUNUOUTVAVBVCUPUQURUSVOVP $.

    $( TODO FIX COMMENT f(r) ` \/ ` s = f(r) ` \/ ` g(s) p. 116 2nd line TODO:
       eliminate eqcomd?  (Contributed by NM, 4-Apr-2013.) $)
    cdlemeg46sfg $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( ( F ` R ) .\/ S ) = ( ( F ` R ) .\/ ( F ` ( G ` S ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv wceq simp21 simp23 simp3r cdlemeg46nfgr
      co simp1 syl121anc oveq2d eqcomd ) TVEVFUFRVFVGJGVFJUFUAVHVIVGKGVFKUFUAVH
      VIVGVJZJKVKZLGVFLUFUAVHVIVGZMGVFMUFUAVHVIVGZVJZLJKSVRZUAVHZMWHUAVHVIZVGZV
      JZLPVLZMQVLPVLZSVRWMMSVRWLWNMWMSWLWCWDWFWJWNMVMWCWGWKVSWCWDWEWFWKVNWCWDWE
      WFWKVOWCWGWIWJVPABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUS
      UTVAVBVCVDVQVTWAWB $.

    $( NOT NEEDED?  TODO FIX COMMENT TODO eliminate ~ eqcomd ? p. 116 2nd
       line.  (Contributed by NM, 2-Apr-2013.)  (New usage is discouraged.) $)
    cdlemeg46fjgN $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( ( F ` R ) .\/ ( F ` ( G ` S ) ) ) = ( F ` ( R .\/ ( G ` S ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv wceq simp21 simp22 simp23 cdlemeg46fvaw
      co simp1 syl3anc cv csb wral crio cif cvv vex cdleme31sc ax-mp cdleme42mN
      wi eqid syl13anc eqcomd ) TVEVFUFRVFVGJGVFJUFUAVHVIVGKGVFKUFUAVHVIVGVJZJK
      VKZLGVFLUFUAVHVIVGZMGVFMUFUAVHVIVGZVJZLJKSVRZUAVHMWTUAVHVIVGZVJZLMQVLZSVR
      PVLZLPVLXCPVLSVRZXBWOWPWQXCGVFXCUFUAVHVIVGZXDXEVMWOWSXAVSZWOWPWQWRXAVNZWO
      WPWQWRXAVOXBWOWRWPXFXGWOWPWQWRXAVPXHABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJUKULUMUNUOUPUQURUSUTVAVBVCVDVQVTABCFGHFUGWAZIWBZJKLXCNIPORFWAZUFUAVHVIX
      KWTUAVHVIVGBWAOVMWKFGWCBHWDZSTUAUBXIWTUAVHXLXJWEZXIUFUAVHVIXIAWAZUFUBVRZS
      VRXNVMVGCWAXMXOSVRVMWKUGGWCCHWDZUFUGUKULUMUNUOUPUQXIWFVFXJXINSVRKJXISVRUF
      UBVRSVRUBVRZVMUGWGWFIJKXINSUBUFXQFURXQWLWHWIURUSXLWLXMWLXPWLUTWJWMWN $.

    ${
      cdlemeg46.y $e |- Y = ( ( R .\/ ( G ` S ) ) ./\ W ) $.  $( v_2 $)
      $( NOT NEEDED?  TODO FIX COMMENT r ` \/ ` g(s) = r ` \/ ` v_2 p. 115 last
         line.  (Contributed by NM, 2-Apr-2013.)
         (New usage is discouraged.) $)
      cdlemeg46rjgN $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( R .\/ ( G ` S ) ) = ( R .\/ Y ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cfv wceq cdleme43cN 3adant3l csb simp1
        eqid simp21 simp23 simp3r cdlemeg47b syl121anc simp23l cdleme31sc eqtrd
        syl oveq2d oveq1d syl5eq 3eqtr4d ) TVGVHUFRVHVIJGVHJUFUAVJVKVIKGVHKUFUA
        VJVKVIVLZJKVMZLGVHLUFUAVJVKVIZMGVHZMUFUAVJVKZVIZVLZLJKSVNZUAVJZMXBUAVJV
        KZVIZVLZLMUESVNJKMSVNUFUBVNSVNUBVNZSVNZLXHUFUBVNZSVNZLMQVOZSVNZLUGSVNWO
        XAXDXHXJVPXCGHMNSVNKJMSVNUFUBVNSVNUBVNZXGJKLMNXGNSVNKJXGSVNUFUBVNSVNUBV
        NZKJSVNXGXBXMLMSVNUFUBVNSVNUBVNZMSVNUFUBVNZSVNUBVNZRSTUAUBXPUFUEXIXOULU
        MUNUOUPUQURVBXMWAXOWAXGWAZXQWAXNWAXPWAXIWAVQVRXFXKXGLSXFXKDMUCVSZXGXFWO
        WPWTXDXKXSVPWOXAXEVTWOWPWQWTXEWBWOWPWQWTXEWCWOXAXCXDWDDEGHJKMQRSTUAUBUC
        UDUEUFUIUJUKULUMUNUOUPUQVBVCVDVEWEWFXFWRXSXGVPWRWSWPWQWOXEWGGUCKJMUESUB
        UFXGDVCXRWHWJWIWKZXFUGXILSXFUGXLUFUBVNXIVFXFXLXHUFUBXTWLWMWKWN $.

      $d s t x z Y $.
      $( TODO FIX COMMENT f(r) ` \/ ` f(g(s)) = f(r) ` \/ ` v_2 p. 116 2nd
         line.  (Contributed by NM, 2-Apr-2013.) $)
      cdlemeg46fjv $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( ( F ` R ) .\/ ( F ` ( G ` S ) ) ) = ( ( F ` R ) .\/ Y ) ) $=
        ( chlt wcel wa wbr wn w3a wne co wceq simp1 simp21 simp22 cdlemeg46fvaw
        cfv simp23 syl3anc csb wral crio cif cvv vex eqid cdleme31sc cdleme42ke
        cv wi ax-mp syl13anc ) TVGVHUFRVHVIJGVHJUFUAVJVKVIKGVHKUFUAVJVKVIVLZJKV
        MZLGVHLUFUAVJVKVIZMGVHMUFUAVJVKVIZVLZLJKSVNZUAVJMXAUAVJVKVIZVLZWPWQWRMQ
        VTZGVHXDUFUAVJVKVIZLPVTZXDPVTSVNXFUGSVNVOWPWTXBVPZWPWQWRWSXBVQZWPWQWRWS
        XBVRXCWPWSWQXEXGWPWQWRWSXBWAXHABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUHUIUJUKUL
        UMUNUOUPUQURUSUTVAVBVCVDVEVSWBABCFGHFUHWLZIWCZJKLXDNIPORFWLZUFUAVJVKXKX
        AUAVJVKVIBWLOVOWMFGWDBHWEZSTUAUBXIXAUAVJXLXJWFZXIUFUAVJVKXIAWLZUFUBVNZS
        VNXNVOVICWLXMXOSVNVOWMUHGWDCHWEZUGUFUHULUMUNUOUPUQURXIWGVHXJXINSVNKJXIS
        VNUFUBVNSVNUBVNZVOUHWHWGIJKXINSUBUFXQFUSXQWIWJWNUSUTXLWIXMWIXPWIVAVFWKW
        O $.

      $( TODO FIX COMMENT f(r) ` \/ ` s = f(r) ` \/ ` v_2 p. 116 2nd line.
         (Contributed by NM, 2-Apr-2013.) $)
      cdlemeg46fsfv $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( ( F ` R ) .\/ S ) = ( ( F ` R ) .\/ Y ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cfv cdlemeg46sfg cdlemeg46fjv eqtrd )
        TVGVHUFRVHVIJGVHJUFUAVJVKVIKGVHKUFUAVJVKVIVLJKVMLGVHLUFUAVJVKVIMGVHMUFU
        AVJVKVIVLLJKSVNZUAVJMVSUAVJVKVIVLLPVOZMSVNVTMQVOPVOSVNVTUGSVNABCDEFGHIJ
        KLMNOPQRSTUAUBUCUDUEUFUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVPABCDEFGHIJK
        LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVQVR $.

      $( TODO FIX COMMENT (f(r) ` \/ ` v_2) ` /\ ` w = v_2 p. 116 3rd line.
         (Contributed by NM, 2-Apr-2013.) $)
      cdlemeg46frv $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( ( ( F ` R ) .\/ Y ) ./\ W ) = Y ) $=
        ( chlt wcel wa wbr wn w3a wne co cfv cp0 wceq simp11 simp1 cdleme46fvaw
        simp22 syl2anc lhpmat oveq1d simp11l simpld simp23 simp21 cdlemeg46fvaw
        eqid simp22l syl3anc cdleme0aa simp11r lhpbase syl clat hlatjcl latmle2
        hllat syl5eqbr atmod4i2 syl131anc col hlol olj02 3eqtr3d ) TVGVHZUFRVHZ
        VIZJGVHJUFUAVJVKVIZKGVHKUFUAVJVKVIZVLZJKVMZLGVHZLUFUAVJVKZVIZMGVHMUFUAV
        JVKVIZVLZLJKSVNZUAVJMXTUAVJVKVIZVLZLPVOZUFUBVNZUGSVNZTVPVOZUGSVNZYCUGSV
        NUFUBVNZUGYBYDYFUGSYBXJYCGVHZYCUFUAVJVKZVIZYDYFVQXJXKXLXSYAVRZYBXMXQYKX
        MXSYAVSZXMXNXQXRYAWAABCFGHIJKLNOPRSTUAUBUFUHULUMUNUOUPUQURUSUTVAVTWBZGY
        CRTUAUBUFYFUMUOYFWJZUPUQWCWBWDYBXHYIUGHVHZUFHVHZUGUFUAVJYEYHVQXHXIXKXLX
        SYAWEZYBYIYJYNWFYBXJXOMQVOZGVHZYPYLXOXPXNXRXMYAWKZYBXMXRXNYTYMXMXNXQXRY
        AWGXMXNXQXRYAWHXMXRXNVLYTYSUFUAVJVKABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUHUIU
        JUKULUMUNUOUPUQURUSUTVAVBVCVDVEWIWFWLZGHLYSUGRSTUAUBUFUMUNUOUPUQVFULWMW
        LZYBXIYQXHXIXKXLXSYAWNHRTUFULUQWOWPZYBUGLYSSVNZUFUBVNZUFUAVFYBTWQVHZUUE
        HVHZYQUUFUFUAVJYBXHUUGYRTWTWPYBXHXOYTUUHYRUUAUUBGHSTLYSULUNUPWRWLUUDHTU
        AUBUUEUFULUMUOWSWLXAGHYCSTUAUBUGUFULUMUNUOUPXBXCYBTXDVHZYPYGUGVQYBXHUUI
        YRTXEWPUUCHSTUGYFULUNYOXFWBXG $.

      cdlemeg46.x $e |- X = ( ( ( F ` R ) .\/ S ) ./\ W ) $.  $( v_1 $)
      $( TODO FIX COMMENT v_1 = v_2 p. 116 3rd line.  (Contributed by NM,
         2-Apr-2013.) $)
      cdlemeg46v1v2 $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> X = Y ) $=
        ( chlt wa wbr wn w3a wne co cfv cdlemeg46fsfv oveq1d cdlemeg46frv eqtrd
        wcel syl5eq ) TVIWAUFRWAVJJGWAJUFUAVKVLVJKGWAKUFUAVKVLVJVMJKVNLGWALUFUA
        VKVLVJMGWAMUFUAVKVLVJVMLJKSVOZUAVKMWCUAVKVLVJVMZUGLPVPZMSVOZUFUBVOZUHVH
        WDWGWEUHSVOZUFUBVOUHWDWFWHUFUBABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUHUIUJUKU
        LUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVQVRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUHUI
        UJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVSVTWB $.

      $( TODO FIX COMMENT v_1 ` <_ ` r ` \/ ` g(s) p. 116 3rd line.
         (Contributed by NM, 3-Apr-2013.) $)
      cdlemeg46vrg $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> X .<_ ( R .\/ ( G ` S ) ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cfv cdlemeg46v1v2 syl6eq simp11l hllat
        clat simp22l simp23 simp21 cdlemeg46fvaw simpld syl3anc hlatjcl simp11r
        syl simp1 lhpbase latmle1 eqbrtrd ) TVIVJZUFRVJZVKJGVJJUFUAVLVMVKZKGVJK
        UFUAVLVMVKZVNZJKVOZLGVJZLUFUAVLVMZVKZMGVJMUFUAVLVMVKZVNZLJKSVPZUAVLMXGU
        AVLVMVKZVNZUGLMQVQZSVPZUFUBVPZXKUAXIUGUHXLABCDEFGHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVRVGVSXITWBVJZXKHVJZUFHV
        JZXLXKUAVLXIWPXMWPWQWRWSXFXHVTZTWAWKXIWPXBXJGVJZXNXPXBXCXAXEWTXHWCXIWTX
        EXAXQWTXFXHWLWTXAXDXEXHWDWTXAXDXEXHWEWTXEXAVNXQXJUFUAVLVMABCDEFGHIJKMNO
        PQRSTUAUBUCUDUEUFUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFWFWGWHGHSTLXJUMUOU
        QWIWHXIWQXOWPWQWRWSXFXHWJHRTUFUMURWMWKHTUAUBXKUFUMUNUPWNWHWO $.

      $( TODO FIX COMMENT r ` <_ ` g(s) ` \/ ` v_1 p. 116 3rd line.
         (Contributed by NM, 3-Apr-2013.) $)
      cdlemeg46rgv $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> R .<_ ( ( G ` S ) .\/ X ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cfv cdlemeg46vrg simp11l simp11 simp22
        cdleme46fvaw syl2anc simp23l simp21 simp3l cdleme46fsvlpq simp3r nbrne2
        wi simp1 syl121anc lhpat2 syl112anc simp22l simp23 cdlemeg46fvaw simpld
        syl3anc clat hllat syl hlatjcl simp11r lhpbase latmle2 simprd hlatexch2
        syl5eqbr syl131anc mpd wceq hlatjcom breqtrd ) TVIVJZUFRVJZVKZJGVJJUFUA
        VLVMVKZKGVJKUFUAVLVMVKZVNZJKVOZLGVJZLUFUAVLVMZVKZMGVJZMUFUAVLVMZVKZVNZL
        JKSVPZUAVLZMYIUAVLVMZVKZVNZLUGMQVQZSVPZYNUGSVPZUAYMUGLYNSVPUAVLZLYOUAVL
        ZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVE
        VFVGVHVRYMXOUGGVJZYBYNGVJZUGYNVOZYQYRWJXOXPXRXSYHYLVSZYMXQLPVQZGVJZUUCU
        FUAVLVMZVKZYEUUCMVOZYSXQXRXSYHYLVTYMXTYDUUFXTYHYLWKZXTYAYDYGYLWAZABCFGH
        IJKLNOPRSTUAUBUFUIUMUNUOUPUQURUSUTVAVBWBWCZYEYFYAYDXTYLWDZYMUUCYIUAVLZY
        KUUGYMXTYAYDYJUULUUHXTYAYDYGYLWEZUUIXTYHYJYKWFABCFGHIJKLNOPRSTUAUBUFUIU
        MUNUOUPUQURUSUTVAVBWGWLXTYHYJYKWHUUCMYIUAWIWCGUUCMUGRSTUAUBUFUNUOUPUQUR
        VHWMWNZYBYCYAYGXTYLWOYMYTYNUFUAVLVMZYMXTYGYAYTUUOVKUUHXTYAYDYGYLWPUUMAB
        CDEFGHIJKMNOPQRSTUAUBUCUDUEUFUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFWQWSZW
        RZYMUGUFUAVLUUOUUAYMUGUUCMSVPZUFUBVPZUFUAVHYMTWTVJZUURHVJZUFHVJZUUSUFUA
        VLYMXOUUTUUBTXAXBYMXOUUDYEUVAUUBYMUUDUUEUUJWRUUKGHSTUUCMUMUOUQXCWSYMXPU
        VBXOXPXRXSYHYLXDHRTUFUMURXEXBHTUAUBUURUFUMUNUPXFWSXIYMYTUUOUUPXGUGYNUFU
        AWIWCGUGLYNSTUAUNUOUQXHXJXKYMXOYSYTYOYPXLUUBUUNUUQGSTUGYNUOUQXMWSXN $.

      $( TODO FIX COMMENT r = (v_1 ` \/ ` g(s)) p. 116 3rd line.  (Contributed
         by NM, 3-Apr-2013.) $)
      cdlemeg46req $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> R = ( ( P .\/ Q ) ./\ ( ( G ` S ) .\/ X ) ) ) $=
        ( chlt wcel wa wbr w3a wne clln cfv wceq simp11l simp12l simp13l simp21
        wn eqid llni2 syl31anc simp1 simp23 cdlemeg46fvaw syl3anc simpld simp11
        simp22 cdleme46fvaw syl2anc simp23l simp3l cdleme46fsvlpq simp3r nbrne2
        co syl121anc lhpat2 syl112anc hllat syl hlatjcl simp11r lhpbase latmle2
        clat syl5eqbr simprd necomd simp22l hlatlej1 cdlemeg46nlpq cdlemeg46rgv
        nbrne1 wb atbase latlem12 syl13anc mpbi2and 2llnmeqat syl132anc ) TVIVJ
        ZUFRVJZVKZJGVJZJUFUAVLWBZVKZKGVJZKUFUAVLWBZVKZVMZJKVNZLGVJZLUFUAVLWBZVK
        ZMGVJZMUFUAVLWBZVKZVMZLJKSWTZUAVLZMUUDUAVLWBZVKZVMZYFUUDTVOVPZVJZMQVPZU
        GSWTZUUIVJZYQUUDUULVNLUUDUULUBWTZUAVLZLUUNVQYFYGYKYNUUCUUGVRZUUHYFYIYLY
        PUUJUUPYIYJYHYNUUCUUGVSZYLYMYHYKUUCUUGVTZYOYPYSUUBUUGWAZGJKSTUUIUOUQUUI
        WCZWDWEUUHYFUUKGVJZUGGVJZUUKUGVNUUMUUPUUHUVAUUKUFUAVLWBZUUHYOUUBYPUVAUV
        CVKYOUUCUUGWFZYOYPYSUUBUUGWGZUUSABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUIUJUKUL
        UMUNUOUPUQURUSUTVAVBVCVDVEVFWHWIZWJZUUHYHLPVPZGVJZUVHUFUAVLWBZVKZYTUVHM
        VNZUVBYHYKYNUUCUUGWKUUHYOYSUVKUVDYOYPYSUUBUUGWLZABCFGHIJKLNOPRSTUAUBUFU
        IUMUNUOUPUQURUSUTVAVBWMWNZYTUUAYPYSYOUUGWOZUUHUVHUUDUAVLZUUFUVLUUHYOYPY
        SUUEUVPUVDUUSUVMYOUUCUUEUUFWPZABCFGHIJKLNOPRSTUAUBUFUIUMUNUOUPUQURUSUTV
        AVBWQXAYOUUCUUEUUFWRZUVHMUUDUAWSWNGUVHMUGRSTUAUBUFUNUOUPUQURVHXBXCZUUHU
        GUUKUUHUGUFUAVLUVCUGUUKVNUUHUGUVHMSWTZUFUBWTZUFUAVHUUHTXJVJZUVTHVJZUFHV
        JZUWAUFUAVLUUHYFUWBUUPTXDXEZUUHYFUVIYTUWCUUPUUHUVIUVJUVNWJUVOGHSTUVHMUM
        UOUQXFWIUUHYGUWDYFYGYKYNUUCUUGXGHRTUFUMURXHXEHTUAUBUVTUFUMUNUPXIWIXKUUH
        UVAUVCUVFXLUGUUKUFUAWSWNXMGUUKUGSTUUIUOUQUUTWDWEYQYRYPUUBYOUUGXNZUUHUUL
        UUDUUHUUKUULUAVLZUUKUUDUAVLWBZUULUUDVNUUHYFUVAUVBUWGUUPUVGUVSGUUKUGSTUA
        UNUOUQXOWIUUHYOYPUUBUUFUWHUVDUUSUVEUVRABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUI
        UJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFXPXAUUKUULUUDUAXRWNXMUUHUUELUULUAVLZU
        UOUVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVC
        VDVEVFVGVHXQUUHUWBLHVJZUUDHVJZUULHVJZUUEUWIVKUUOXSUWEUUHYQUWJUWFGHLTUMU
        QXTXEUUHYFYIYLUWKUUPUUQUURGHSTJKUMUOUQXFWIUUHYFUVAUVBUWLUUPUVGUVSGHSTUU
        KUGUMUOUQXFWIHTUAUBLUUDUULUMUNUPYAYBYCGLTUAUBUUIUUDUULUNUPUQUUTYDYE $.

      $d a b c u v F $.
      $( TODO FIX COMMENT p. 115 penultimate line: g(f(r)) = (p v q) ^ (g(s) v
         v_1) (Contributed by NM, 4-Apr-2013.) $)
      cdlemeg46gfv $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( G ` ( F ` R ) ) = ( ( P .\/ Q ) ./\ ( ( G ` S ) .\/ X ) ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv wceq simp1 simp21 simp22 cdleme46fvaw
        co simp23 simp3l cdleme46fsvlpq syl121anc simp3r cdlemeg47rv2 syl132anc
        syl2anc simp11l simp12l simp13l hlatjcom syl3anc oveq2i oveq12d eqtr4d
        a1i ) TVIVJZUFRVJZVKZJGVJZJUFUAVLVMZVKZKGVJZKUFUAVLVMZVKZVNZJKVOZLGVJLU
        FUAVLVMVKZMGVJMUFUAVLVMVKZVNZLJKSWBZUAVLZMXNUAVLVMZVKZVNZLPVPZQVPZKJSWB
        ZMQVPZXSMSWBUFUBWBZSWBZUBWBZXNYBUGSWBZUBWBXRXIXJXSGVJXSUFUAVLVMVKZXLXSX
        NUAVLZXPXTYEVQXIXMXQVRZXIXJXKXLXQVSZXRXIXKYGYIXIXJXKXLXQVTZABCFGHIJKLNO
        PRSTUAUBUFUIUMUNUOUPUQURUSUTVAVBWAWJXIXJXKXLXQWCXRXIXJXKXOYHYIYJYKXIXMX
        OXPWDABCFGHIJKLNOPRSTUAUBUFUIUMUNUOUPUQURUSUTVAVBWEWFXIXMXOXPWGDEGHJKXS
        MQRSTUAUBUCUDUEUFUJUKULUMUNUOUPUQURVCVDVEVFWHWIXRXNYAYFYDUBXRWTXCXFXNYA
        VQWTXAXEXHXMXQWKXCXDXBXHXMXQWLXFXGXBXEXMXQWMGSTJKUOUQWNWOYFYDVQXRUGYCYB
        SVHWPWSWQWR $.
    $}

    $d a b c u v F $.
    $( TODO FIX COMMENT p. 116 penultimate line: g(f(r)) = r.  (Contributed by
       NM, 4-Apr-2013.) $)
    cdlemeg46gfr $p |- ( ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
    -> ( G ` ( F ` R ) ) = R ) $=
      ( chlt wcel wa wbr wn w3a wne cfv eqid cdlemeg46gfv cdlemeg46req eqtr4d
      co ) TVEVFUFRVFVGJGVFJUFUAVHVIVGKGVFKUFUAVHVIVGVJJKVKLGVFLUFUAVHVIVGMGVFM
      UFUAVHVIVGVJLJKSVQZUAVHMVRUAVHVIVGVJLPVLZQVLVRMQVLZVSMSVQUFUBVQZSVQUBVQLA
      BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFWALVTSVQUFUBVQZUGUHUIUJUKULUMUNUOUPUQURUSU
      TVAVBVCVDWBVMZWAVMZVNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFWAWBUGUHUIUJUKULUMUN
      UOUPUQURUSUTVAVBVCVDWCWDVOVP $.

    $d e A $.  $d e F $.  $d e G $.  $d e H $.  $d e .\/ $.  $d e K $.
    $d e .<_ $.  $d e P $.  $d e Q $.  $d e R $.  $d e W $.
    $d e a b c s t u v x y z $.
    $( TODO FIX COMMENT p. 116 penultimate line: g(f(r)) = r.  (Contributed by
       NM, 4-Apr-2013.) $)
    cdlemeg46gfre $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
          /\ R .<_ ( P .\/ Q ) )
      -> ( G ` ( F ` R ) ) = R ) $=
      ( ve chlt wcel wa wbr wn w3a wne co cv wrex cfv wceq simp11 simp12 simp13
      simp2l cdlemb2 syl121anc wi simp2r simp32 simp33l jca simp31 cdlemeg46gfr
      simp1 simp33r syl132anc 3expia 3expd 3impia rexlimdv mpd ) SVEVFUEQVFVGZJ
      GVFJUETVHVIVGZKGVFKUETVHVIVGZVJZJKVKZLGVFLUETVHVIVGZVGZLJKRVLZTVHZVJZVDVM
      ZUETVHVIZXHXETVHVIZVGZVDGVNZLOVOPVOLVPZXGWRWSWTXBXLWRWSWTXDXFVQWRWSWTXDXF
      VRWRWSWTXDXFVSXAXBXCXFVTGJKQRSTUEVDUKULUNUOWAWBXGXKXMVDGXAXDXFXHGVFZXKXMW
      CWCXAXDVGXFXNXKXMXAXDXFXNXKVJZXMXAXDXOVJZXAXBXCXNXIVGXFXJXMXAXDXOWJXAXBXC
      XOVTXAXBXCXOWDXPXNXIXAXDXFXNXKWEXIXJXFXNXAXDWFWGXAXDXFXNXKWHXIXJXFXNXAXDW
      KABCDEFGHIJKLXHMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCWIWL
      WMWNWOWPWQ $.

    $( TODO FIX COMMENT Eliminate antecedent ` R .<_ ( P .\/ Q ) ` .
       (Contributed by NM, 4-Apr-2013.) $)
    cdlemeg46gf $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) ) )
      -> ( G ` ( F ` R ) ) = R ) $=
      ( chlt wcel wa wbr w3a wne cfv wceq cdlemeg46gfre cdlemeg46ngfr pm2.61dan
      wn co 3expa ) SVDVEUEQVEVFJGVEJUETVGVOVFKGVEKUETVGVOVFVHZJKVILGVELUETVGVO
      VFVFZVFLJKRVPTVGZLOVJPVJLVKZVRVSVTWAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
      IUJUKULUMUNUOUPUQURUSUTVAVBVCVLVQVRVSVTVOWAABCDEFGHIJKLMNOPQRSTUAUBUCUDUE
      UFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVMVQVN $.

    $d a b c D $.  $d a b c E $.  $d t N $.  $d a b c U $.
    $( TODO FIX COMMENT p. 116 penultimate line: f(g(r)) = r.  (Contributed by
       NM, 4-Apr-2013.)  (New usage is discouraged.) $)
    cdlemeg46fgN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) ) )
      -> ( F ` ( G ` R ) ) = R ) $=
      ( chlt wcel wa wbr wn w3a wne cfv wceq simpl1 simpl3 simpl2 simprl necomd
      simprr cdlemeg46gf syl32anc ) SVDVEUEQVEVFZJGVEJUETVGVHVFZKGVEKUETVGVHVFZ
      VIZJKVJZLGVELUETVGVHVFZVFZVFZWAWCWBKJVJWFLPVKOVKLVLWAWBWCWGVMWAWBWCWGVNWA
      WBWCWGVOWHJKWDWEWFVPVQWDWEWFVRUGUHUIFUFDGHUBKJLUDUCPOQRSTUAINMUEEABCUJUKU
      LUMUNUOUTVAVBVCUPUQURUSVSVT $.

    $d a c s t u v x z X $.
    $( TODO: fix comment.  (Contributed by NM, 8-Apr-2013.) $)
    cdleme48d $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) )
           /\ ( ( S e. A /\ -. S .<_ W ) /\ ( S .\/ ( X ./\ W ) ) = X ) )
       -> ( G ` ( F ` X ) ) = X ) $=
      ( chlt wcel wa wbr wn w3a wne co wceq cfv simp1 simp2l simp2rl cv wi wral
      csb crio cif cvv vex cdleme31sc ax-mp cdleme32fvcl syl2anc cdleme48bw jca
      eqid simp3l cdleme46fvaw cdleme48b oveq2d cdleme48fv cdleme4gfv syl122anc
      eqtr4d cdlemeg46gf syl12anc oveq12d simp3r 3eqtrd ) SVEVFUEQVFVGJGVFJUETV
      HVIVGKGVFKUETVHVIVGVJZJKVKZUFHVFZUFUETVHVIZVGZVGZLGVFLUETVHVIVGZLUFUEUAVL
      ZRVLZUFVMZVGZVJZUFOVNZPVNZLOVNZPVNZXRUEUAVLZRVLZXNUFXQXFXGXRHVFZXRUETVHVI
      ZVGXTGVFXTUETVHVIVGZXTYBRVLZXRVMXSYCVMXFXKXPVOZXFXGXJXPVPZXQYDYEXQXFXHYDY
      HXHXIXGXFXPVQABCFGHFUGVRZIWAZIJKMNOQFVRZUETVHVIYLJKRVLZTVHVIVGBVRNVMVSFGV
      TBHWBZRSTUAYJYMTVHYNYKWCZYJUETVHVIYJAVRZUEUAVLZRVLYPVMVGCVRYOYQRVLVMVSUGG
      VTCHWBZUEUFUGUKULUMUNUOUPUQYJWDVFYKYJMRVLKJYJRVLUEUAVLRVLUAVLZVMUGWEWDIJK
      YJMRUAUEYSFURYSWLWFWGURUSYNWLYOWLYRWLUTWHWIABCFGHIJKLMNOQRSTUAUEUFUGUKULU
      MUNUOUPUQURUSUTWJWKXQXFXLYFYHXFXKXLXOWMZABCFGHIJKLMNOQRSTUAUEUGUKULUMUNUO
      UPUQURUSUTWNWIXQYGXTXMRVLXRXQYBXMXTRABCFGHIJKLMNOQRSTUAUEUFUGUKULUMUNUOUP
      UQURUSUTWOZWPABCFGHIJKLMNOQRSTUAUEUFUGUKULUMUNUOUPUQURUSUTWQWTDEGHJKXTPQR
      STUAUBUCUDUEXRUHUIUJUKULUMUNUOUPVAVBVCVDWRWSXQYALYBXMRXQXFXGXLYALVMYHYIYT
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDXAXBUUA
      XCXFXKXLXOXDXE $.

    $d e B $.  $d e ./\ $.  $d e X $.
    $( TODO: fix comment.  (Contributed by NM, 9-Apr-2013.) $)
    cdleme48gfv1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( X e. B /\ -. X .<_ W ) ) )
       -> ( G ` ( F ` X ) ) = X ) $=
      ( ve chlt wcel wa wbr wn w3a wne cv wceq wrex cfv simpl1 lhpmcvr2 syl2anc
      co simprr cdleme48d 3expia exp4c imp4a rexlimdv mpd ) RVEVFUDPVFVGZJGVFJU
      DSVHVIVGZKGVFKUDSVHVIVGZVJZJKVKZUEHVFUEUDSVHVIVGZVGZVGZVDVLZUDSVHVIZWOUEU
      DTVSQVSUEVMZVGZVDGVNZUENVOOVOUEVMZWNWGWLWSWGWHWIWMVPWJWKWLVTGHPQRSTUDUEVD
      UJUKULUMUNUOVQVRWNWRWTVDGWNWOGVFZWPWQWTWNXAWPWQWTWJWMXAWPVGWQVGWTABCDEFGH
      IJKWOLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCWAWBWCWDWEWF
      $.

    $( TODO: fix comment.  (Contributed by NM, 9-Apr-2013.) $)
    cdleme48gfv $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ X e. B )
       -> ( G ` ( F ` X ) ) = X ) $=
      ( chlt wcel wbr w3a wne cfv wceq simpll simprl simplr simprr cdleme48gfv1
      wa wn jca syl12anc cv co wi wral crio csb cif cdleme31fv2 adantll eqeltrd
      simpr wb necom a1i breq1d notbid anbi12d mtbird syl2anc eqtrd pm2.61dan )
      RVDVEUDPVEVPJGVEJUDSVFVQVPKGVEKUDSVFVQVPVGZUEHVEZVPZJKVHZUEUDSVFZVQZVPZUE
      NVIZOVIZUEVJZXCXGVPZXAXDXBXFVPXJXAXBXGVKXCXDXFVLXKXBXFXAXBXGVMXCXDXFVNVRA
      BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVOVSXCXG
      VQZVPZXIXHUEXMXHHVEKJVHZXHUDSVFZVQZVPZVQXIXHVJXMXHUEHXBXLXHUEVJXAAHJKNSUF
      VTZUDSVFVQXRAVTZUDTWAZQWAXSVJVPCVTXRJKQWAZSVFFVTZUDSVFVQYBYASVFVQVPBVTMVJ
      WBFGWCBHWDFXRIWEWFXTQWAVJWBUFGWCCHWDUDUEUSWGWHZXAXBXLVMWIXMXQXGXCXLWJXMXN
      XDXPXFXNXDWKXMKJWLWMXMXOXEXMXHUEUDSYCWNWOWPWQUGHKJOSEVTZUDSVFVQYDUGVTZUDT
      WAZQWAYEVJVPUIVTYDKJQWAZSVFDVTZUDSVFVQYHYGSVFVQVPUHVTUBVJWBDGWCUHHWDDYDUA
      WEWFYFQWAVJWBEGWCUIHWDUDXHVCWGWRYCWSWT $.

    $( TODO: fix comment.  (Contributed by NM, 9-Apr-2013.) $)
    cdleme48fgv $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ X e. B )
       -> ( F ` ( G ` X ) ) = X ) $=
      ( chlt wcel wa wbr wn w3a cfv wceq simpl1 simpl3 simpl2 simpr cdleme48gfv
      syl31anc ) RVDVEUDPVEVFZJGVEJUDSVGVHVFZKGVEKUDSVGVHVFZVIZUEHVEZVFVRVTVSWB
      UEOVJNVJUEVKVRVSVTWBVLVRVSVTWBVMVRVSVTWBVNWAWBVOUGUHUIFUFDGHUAKJUCUBONPQR
      STIMLUDUEEABCUJUKULUMUNUOUTVAVBVCUPUQURUSVPVQ $.

    $d a b c s t u v x y z Y $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment.
       (Contributed by NM, 9-Apr-2013.) $)
    cdlemeg49lebilem $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B ) )
         -> ( X .<_ Y <-> ( F ` X ) .<_ ( F ` Y ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv cv csb co wceq wral crio cif cvv cdleme31sc
      wi vex ax-mp cdleme32le 3expia simp1 simp2l ifbieq2i cdleme32fvcl syl2anc
      eqid biid simp3 cdlemeg49le syl121anc cdleme48gfv adantrr adantrl breq12d
      simp2r wb 3adant3 mpbid impbid ) RVEVFUDPVFVGJGVFJUDSVHVIVGKGVFKUDSVHVIVG
      VJZUEHVFZUFHVFZVGZVGZUEUFSVHZUENVKZUFNVKZSVHZXEXHXJXMABCFGHFUGVLZIVMZIJKL
      MNPFVLZUDSVHVIXPJKQVNZSVHVIVGBVLMVOWAFGVPBHVQZQRSTXNXQSVHZXRXOVRZXNUDSVHV
      IXNAVLZUDTVNZQVNYAVOVGCVLXTYBQVNVOWAUGGVPCHVQZUDUEUFUGUKULUMUNUOUPUQXNVSV
      FXOXNLQVNKJXNQVNUDTVNQVNTVNZVOUGWBVSIJKXNLQTUDYDFURYDWKZVTWCZURUSXRWKZXTW
      KYCWKZUTWDWEXEXHXMXJXEXHXMVJZXKOVKZXLOVKZSVHZXJYIXEXKHVFZXLHVFZXMYLXEXHXM
      WFZYIXEXFYMYOXEXFXGXMWGABCFGHYDIJKLMNPXRQRSTXTYCUDUEUGUKULUMUNUOUPUQYEURU
      SYGXSXSXOYDXRXSWLYFWHZYHUTWIWJYIXEXGYNYOXEXFXGXMWTABCFGHYDIJKLMNPXRQRSTXT
      YCUDUFUGUKULUMUNUOUPUQYEURUSYGYPYHUTWIWJXEXHXMWMDEGHJKOPQRSTUAUBUCUDXKXLU
      HUIUJUKULUMUNUOUPVAVBVCVDWNWOXEXHYLXJXAXMXIYJUEYKUFSXEXFYJUEVOXGABCDEFGHI
      JKLMNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDWPWQXEXGYKUFVOXF
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDWPWRWSX
      BXCWEXD $.
  $}

  ${
    $d a b c s t u v x y z ./\ $.  $d a b c s t u v x y z .\/ $.
    $d a b c s t u v x y z .<_ $.  $d a b c s t u v x y z A $.
    $d a b c s t u v x y z B $.  $d a b c s v x y z D $.  $d a b c x y z E $.
    $d a b c u v F $.  $d a b c s t u v x y z H $.  $d a b c s t u v x y z K $.
    $d a b c s t u v x y z P $.  $d a b c s t u v x y z Q $.  $d s t x y z R $.
    $d s t x y z S $.  $d a b c s t v x y z U $.  $d a b c s t u v x y z W $.
    $d a c s t u v x y z X $.  $d a b c s t u v x y z Y $.
    cdlemef50.b $e |- B = ( Base ` K ) $.
    cdlemef50.l $e |- .<_ = ( le ` K ) $.
    cdlemef50.j $e |- .\/ = ( join ` K ) $.
    cdlemef50.m $e |- ./\ = ( meet ` K ) $.
    cdlemef50.a $e |- A = ( Atoms ` K ) $.
    cdlemef50.h $e |- H = ( LHyp ` K ) $.
    cdlemef50.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
    cdlemef50.d $e |- D
        = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
    $( f_t(s), s ` <_ ` p ` \/ ` q $)
    cdlemefs50.e $e |- E
        = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
    cdlemef50.f $e |- F = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment.
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme50lebi $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B ) )
         -> ( X .<_ Y <-> ( F ` X ) .<_ ( F ` Y ) ) ) $=
      ( vv vu va vc vb wne cv wbr wn wa wceq wral crio csb cif cdlemeg49lebilem
      co wi cmpt eqid ) ABCULUMDEFGHIJKLUNFIHUQUNURZRPUSUTVAUMURZRPUSUTVMVLRQVH
      ZNVHVLVBVAUOURVMIHNVHZPUSULURZRPUSUTVPVOPUSUTVAUPURVOVPVORQVHZNVHHIVPNVHR
      QVHNVHQVHZVMVPNVHRQVHNVHQVHZVBVIULEVCUPFVDULVMVRVEVFVNNVHVBVIUMEVCUOFVDVL
      VFVJZMNOPQVRVSVQRSTUAUNUPUOUBUCUDUEUFUGUHUIUJUKVQVKVRVKVSVKVTVKVG $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment.
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme50eq $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( X e. B /\ Y e. B ) )
         -> ( ( F ` X ) = ( F ` Y ) <-> X = Y ) ) $=
      ( chlt wcel wa wbr w3a cfv wceq cdleme50lebi ancom2s anbi12d clat simpl1l
      wn wb hllat syl simprl simprr latasymb syl3anc cv co wi wral crio csb cif
      eqid biid cvv vex cdleme31sc ax-mp ifbieq2i cdleme32fvcl adantrr 3bitr3rd
      adantrl ) OULUMZRMUMZUNHEUMHRPUOVDUNZIEUMIRPUOVDUNZUPZSFUMZTFUMZUNZUNZSTP
      UOZTSPUOZUNZSLUQZTLUQZPUOZXCXBPUOZUNZSTURZXBXCURZWRWSXDWTXEABCDEFGHIJKLMN
      OPQRSTUAUBUCUDUEUFUGUHUIUJUKUSWNWPWOWTXEVEABCDEFGHIJKLMNOPQRTSUAUBUCUDUEU
      FUGUHUIUJUKUSUTVAWROVBUMZWOWPXAXGVEWRWJXIWJWKWLWMWQVCOVFVGZWNWOWPVHWNWOWP
      VIFOPSTUBUCVJVKWRXIXBFUMZXCFUMZXFXHVEXJWNWOXKWPABCDEFUAVLZJNVMIHXMNVMRQVM
      NVMQVMZGHIJKLMDVLZRPUOVDXOHINVMZPUOVDUNBVLKURVNDEVOBFVPZNOPQXMXPPUOZXQDXM
      GVQZVRZXMRPUOVDXMAVLZRQVMZNVMYAURUNCVLXTYBNVMURVNUAEVOCFVPZRSUAUBUCUDUEUF
      UGUHXNVSZUIUJXQVSZXRXRXSXNXQXRVTXMWAUMXSXNURUAWBWAGHIXMJNQRXNDUIYDWCWDZWE
      YCVSZUKWFWGWNWPXLWOABCDEFXSGHIJKLMXQNOPQXTYCRTUAUBUCUDUEUFUGUHYFUIUJYEXTV
      SYGUKWFWIFOPXBXCUBUCVJVKWH $.

    $d d e A $.  $d d e B $.  $d d e F $.  $d d e H $.  $d d e K $.
    $d d e .<_ $.  $d d e P $.  $d d e Q $.  $d d e W $.  $d d e s t x y z $.
    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment TODO:
       can we use just ` F Fn B ` since range is computed in ~ cdleme50rn ?
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme50f $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F : B --> B ) $=
      ( ve chlt wcel wa wbr wn w3a wne cv co wceq wral crio csb cif cvv riotaex
      wi vex ifex a1i cmpt eqid cdleme31sc ax-mp cdleme32fvcl fmpt2d ) OUKULRMU
      LUMHEULHRPUNUOUMIEULIRPUNUOUMUPZAUJFHIUQAURZRPUNUOUMZSURZRPUNUOVTVRRQUSZN
      USVRUTUMCURVTHINUSZPUNDURZRPUNUOWCWBPUNUOUMBURKUTVGDEVABFVBZDVTGVCZVDZWAN
      USUTVGSEVAZCFVBZVRVDZFLVEWIVEULVQVRFULUMVSWHVRWGCFVFAVHVIVJLAFWIVKUTVQUIV
      JABCDEFWEGHIJKLMWDNOPQWFWHRUJURSTUAUBUCUDUEUFVTVEULWEVTJNUSIHVTNUSRQUSNUS
      QUSZUTSVHVEGHIVTJNQRWJDUGWJVLVMVNUGUHWDVLWFVLWHVLUIVOVP $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment.
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme50f1 $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F : B -1-1-> B ) $=
      ( vd ve chlt wcel wa wbr wn w3a wf cfv wceq wral wf1 cdleme50f cdleme50eq
      cv wi biimpd ralrimivva dff13 sylanbrc ) OULUMRMUMUNHEUMHRPUOUPUNIEUMIRPU
      OUPUNUQZFFLURUJVEZLUSUKVEZLUSUTZVLVMUTZVFZUKFVAUJFVAFFLVBABCDEFGHIJKLMNOP
      QRSTUAUBUCUDUEUFUGUHUIVCVKVPUJUKFFVKVLFUMVMFUMUNUNVNVOABCDEFGHIJKLMNOPQRV
      LVMSTUAUBUCUDUEUFUGUHUIVDVGVHUJUKFFLVIVJ $.

    ${
      cdlemef50.v $e |- V = ( ( Q .\/ P ) ./\ W ) $.
      $( g(t), ` -. ` v ` <_ ` p ` \/ ` q. $)
      cdlemef50.n $e |- N
          = ( ( v .\/ V ) ./\ ( P .\/ ( ( Q .\/ v ) ./\ W ) ) ) $.
      $( g_t(s), u ` <_ ` p ` \/ ` q $)
      cdlemefs50.o $e |- O
          = ( ( Q .\/ P ) ./\ ( N .\/ ( ( u .\/ v ) ./\ W ) ) ) $.
      cdlemef50.g $e |- G = ( a e. B |->
         if ( ( Q =/= P /\ -. a .<_ W ) ,
           $( g(x) when p ` =/= ` q and ` -. ` a ` <_ ` w. $)
           ( iota_ c e. B A. u e. A
                ( ( -. u .<_ W /\ ( u .\/ ( a ./\ W ) ) = a ) -> c = (
                    $( g_t(s), u ` <_ ` p ` \/ ` q $)
                    if ( u .<_ ( Q .\/ P ) ,
                       ( iota_ b e. B A. v e. A
                             ( ( -. v .<_ W /\ -. v .<_ ( Q .\/ P ) )
                             -> b = O ) ) ,
                    $( g(s), ` -. ` u ` <_ ` p ` \/ ` q. $)
                       [_ u / v ]_ N )
                .\/ ( a ./\ W ) ) ) ) ,
           $( g(x) when p = q or a ` <_ ` w is just x. $)
           a ) ) $.
      $d d s t x y z G $.  $d a b c t u x y z N $.  $d a b c x y z O $.
      $d a b c t u v x y z V $.  $d e a c u v $.
      $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment TODO:
         can we get rid of ` G ` stuff if we show ` G = ``' F ` earlier?
         (Contributed by NM, 9-Apr-2013.) $)
      cdleme50rnlem $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> ran F = B ) $=
        ( ve vd chlt wcel wa wbr wn w3a crn wss cdleme50f frn syl cfv wceq wrex
        wf cdlemeg46fvcl cdleme48fgv fveq2 eqeq1d rspcev syl2anc wfn adantr ffn
        cv wb fvelrnb 3syl mpbird ex ssrdv eqssd ) RVEVFUDPVFVGJGVFJUDSVHVIVGKG
        VFKUDSVHVIVGVJZNVKZHWQHHNVSZWRHVLABCFGHIJKLMNPQRSTUDUEUIUJUKULUMUNUOUPU
        QURVMZHHNVNVOWQVCHWRWQVCWIZHVFZXAWRVFZWQXBVGZXCVDWIZNVPZXAVQZVDHVRZXDXA
        OVPZHVFXINVPZXAVQZXHDEGHJKOPQRSTUAUBUCUDXAUFUGUHUIUJUKULUMUNUSUTVAVBVTA
        BCDEFGHIJKLMNOPQRSTUAUBUCUDXAUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBWAXGXK
        VDXIHXEXIVQXFXJXAXEXINWBWCWDWEXDWSNHWFXCXHWJWQWSXBWTWGHHNWHVDHXANWKWLWM
        WNWOWP $.
    $}

    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment.
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme50rn $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> ran F = B ) $=
      ( vv vu va vc vb wne cv wbr wn wa co wceq wral crio csb cif cdleme50rnlem
      wi cmpt eqid ) ABCUJUKDEFGHIJKLULFIHUOULUPZRPUQURUSUKUPZRPUQURVKVJRQUTZNU
      TVJVAUSUMUPVKIHNUTZPUQUJUPZRPUQURVNVMPUQURUSUNUPVMVNVMRQUTZNUTHIVNNUTRQUT
      NUTQUTZVKVNNUTRQUTNUTQUTZVAVGUJEVBUNFVCUJVKVPVDVEVLNUTVAVGUKEVBUMFVCVJVEV
      HZMNOPQVPVQVORSULUNUMTUAUBUCUDUEUFUGUHUIVOVIVPVIVQVIVRVIVF $.

    $( Part of proof of Lemma D in [Crawley] p. 113.  TODO: fix comment.
       (Contributed by NM, 9-Apr-2013.) $)
    cdleme50f1o $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F : B -1-1-onto-> B ) $=
      ( chlt wcel wa wbr w3a wf1 crn wceq cdleme50f1 cdleme50rn dff1o5 sylanbrc
      wn wf1o ) OUJUKRMUKULHEUKHRPUMVBULIEUKIRPUMVBULUNFFLUOLUPFUQFFLVCABCDEFGH
      IJKLMNOPQRSTUAUBUCUDUEUFUGUHUIURABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUSF
      FLUTVA $.

    ${
      cdleme50laut.i $e |- I = ( LAut ` K ) $.
      $( Part of proof of Lemma D in [Crawley] p. 113. ` F ` is a lattice
         automorphism.  TODO: fix comment.  (Contributed by NM, 9-Apr-2013.) $)
      cdleme50laut $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F e. I ) $=
        ( vd ve chlt wcel wa wbr wn w3a wf1o cv cfv wb cdleme50f1o cdleme50lebi
        wral ralrimivva simp1l islaut syl mpbir2and ) PUNUOZSMUOZUPHEUOHSQUQURU
        PZIEUOISQUQURUPZUSZLNUOZFFLUTZULVAZUMVAZQUQVSLVBVTLVBQUQVCZUMFVFULFVFZA
        BCDEFGHIJKLMOPQRSTUAUBUCUDUEUFUGUHUIUJVDVPWAULUMFFABCDEFGHIJKLMOPQRSVSV
        TTUAUBUCUDUEUFUGUHUIUJVEVGVPVLVQVRWBUPVCVLVMVNVOVHULUMUNFLNPQUAUBUKVIVJ
        VK $.
    $}

    ${
      cdleme50ldil.i $e |- C = ( ( LDil ` K ) ` W ) $.
      $( Part of proof of Lemma D in [Crawley] p. 113. ` F ` is a lattice
         dilation.  TODO: fix comment.  (Contributed by NM, 9-Apr-2013.) $)
      cdleme50ldil $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F e. C ) $=
        ( ve chlt wcel wa wbr wn w3a claut cfv cv wceq wi wral cdleme50laut wne
        eqid simpr con2i co crio csb cif cdleme31fv2 sylan2 ex rgen wb 3ad2ant1
        a1i isldil mpbir2and ) PUMUNSNUNUOZIEUNISQUPUQUOZJEUNJSQUPUQUOZURZMGUNZ
        MPUSUTZUNZULVAZSQUPZWJMUTWJVBZVCZULFVDZABCDEFHIJKLMNWHOPQRSTUAUBUCUDUEU
        FUGUHUIUJWHVGZVEWNWFWMULFWJFUNZWKWLWKWPIJVFZWKUQZUOZUQWLWSWKWQWRVHVIAFI
        JMQTVAZSQUPUQWTAVAZSRVJZOVJXAVBUOCVAWTIJOVJZQUPDVAZSQUPUQXDXCQUPUQUOBVA
        LVBVCDEVDBFVKDWTHVLVMXBOVJVBVCTEVDCFVKSWJUJVNVOVPVQVTWCWDWGWIWNUOVRWEUL
        FUMGMNWHPQSUAUBUFWOUKWAVSWB $.
    $}

    $( Part of proof that ` F ` is a tranlation. ` -. R .<_ ( P .\/ Q ) `
       case.  TODO: fix comment.  (Contributed by NM, 10-Apr-2013.) $)
    cdleme50trn1 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
           /\ -. R .<_ ( P .\/ Q ) )
         -> ( ( R .\/ ( F ` R ) ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn w3a wne co cdlemefr45e oveq2d oveq1d simp11 simp12l
      cfv wceq simp13l simp2r eqid cdleme2 syl13anc eqtrd ) PUKULSNULUMZHEULZHS
      QUNUOZUMZIEULZISQUNUOZUMZUPZHIUQZJEULJSQUNUOUMZUMZJHIOURQUNUOZUPZJJMVDZOU
      RZSRURJJKOURIHJOURSRUROURRURZOURZSRURZKWDWFWHSRWDWEWGJOABCDEFGHIJKLMNOPQR
      STUAUBUCUDUEUFUGUHUJUSUTVAWDVLVMVPWAWIKVEVLVOVRWBWCVBVMVNVLVRWBWCVCVPVQVL
      VOWBWCVFVSVTWAWCVGEHIJKWGNOPQRSUBUCUDUEUFUGWGVHVIVJVK $.

    $( Part of proof that ` F ` is a translation. ` R .<_ ( P .\/ Q ) ` case.
       TODO: fix comment.  (Contributed by NM, 10-Apr-2013.) $)
    cdleme50trn2a $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) /\ ( S e. A /\ -. S .<_ W ) )
       /\ ( R .<_ ( P .\/ Q ) /\ -. S .<_ ( P .\/ Q ) ) )
      -> ( ( R .\/ ( F ` R ) ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn w3a wne cfv cdlemefs45ee oveq2d oveq1d wceq simp12l
      simp11 simp13l simp22 simp23 simp3l eqid cdleme5 syl132anc syl6eqr eqtrd
      co ) QULUMTOUMUNZHEUMZHTRUOUPZUNZIEUMZITRUOUPZUNZUQZHIURZJEUMJTRUOUPUNZKE
      UMKTRUOUPUNZUQZJHIPVOZRUOZKWHRUOUPZUNZUQZJJNUSZPVOZTSVOJWHKLPVOIHKPVOTSVO
      PVOSVOZJKPVOTSVOPVOSVOZPVOZTSVOZLWLWNWQTSWLWMWPJPABCDEFGHIJKLMNOPQRSTUAUB
      UCUDUEUFUGUHUIUKUJUTVAVBWLWRWHTSVOLWLWQWHTSWLVPVQVTWEWFWIWQWHVCVPVSWBWGWK
      VEVQVRVPWBWGWKVDVTWAVPVSWGWKVFWCWDWEWFWKVGWCWDWEWFWKVHWCWGWIWJVIEHIJKLWOW
      POPQRSTUCUDUEUFUGUHWOVJWPVJVKVLVBUHVMVN $.

    $d e .\/ $.  $d e ./\ $.  $d e R $.  $d e U $.
    $( Part of proof that ` F ` is a translation.  Remove ` S ` hypotheses no
       longer needed from ~ cdleme50trn2a .  TODO: fix comment.  (Contributed
       by NM, 10-Apr-2013.) $)
    cdleme50trn2 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) )
           /\ R .<_ ( P .\/ Q ) )
         -> ( ( R .\/ ( F ` R ) ) ./\ W ) = U ) $=
      ( ve chlt wcel wa wbr wn w3a wne co cv wrex cfv wceq simp11 simp12 simp13
      simp2l cdlemb2 syl121anc simp1 simp2r simp3rl simprrl 3ad2ant3 jca simp3l
      wi simprrr cdleme50trn2a syl132anc 3exp exp4a 3imp exp3a rexlimdv mpd ) P
      ULUMSNUMUNZHEUMHSQUOUPUNZIEUMISQUOUPUNZUQZHIURZJEUMJSQUOUPUNZUNZJHIOUSZQU
      OZUQZUKUTZSQUOUPZWQWNQUOUPZUNZUKEVAZJJMVBOUSSRUSKVCZWPWGWHWIWKXAWGWHWIWMW
      OVDWGWHWIWMWOVEWGWHWIWMWOVFWJWKWLWOVGEHINOPQSUKUBUCUEUFVHVIWPWTXBUKEWPWQE
      UMZWTXBWJWMWOXCWTUNZXBVQWJWMWOXDXBWJWMWOXDUNZXBWJWMXEUQZWJWKWLXCWRUNWOWSX
      BWJWMXEVJWJWKWLXEVGWJWKWLXEVKXFXCWRXCWTWOWJWMVLXEWJWRWMWOXCWRWSVMVNVOWJWM
      WOXDVPXEWJWSWMWOXCWRWSVRVNABCDEFGHIJWQKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVSVTW
      AWBWCWDWEWF $.

    $( Part of proof that ` F ` is a translation.  Combine
       ` R .<_ ( P .\/ Q ) ` and ` -. R .<_ ( P .\/ Q ) ` cases.  TODO: fix
       comment.  (Contributed by NM, 10-Apr-2013.) $)
    cdleme50trn12 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P =/= Q /\ ( R e. A /\ -. R .<_ W ) ) )
         -> ( ( R .\/ ( F ` R ) ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn w3a wne co cfv wceq cdleme50trn2 3expa cdleme50trn1
      pm2.61dan ) PUKULSNULUMHEULHSQUNUOUMIEULISQUNUOUMUPZHIUQJEULJSQUNUOUMUMZU
      MJHIOURQUNZJJMUSOURSRURKUTZVEVFVGVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJVAVBVEVFVGUOVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVCVBVD $.

    $( Part of proof that ` F ` is a translation. ` P = Q ` case.  TODO: fix
       comment.  (Contributed by NM, 10-Apr-2013.) $)
    cdleme50trn3 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( P = Q /\ ( R e. A /\ -. R .<_ W ) ) )
         -> ( ( R .\/ ( F ` R ) ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn w3a wceq cfv cp0 simpl1 simprr eqid syl2anc simprrl
      co lhpmat atbase syl simprl cv wi wral crio csb cdleme31id oveq2d simpl1l
      cif hlatjidm eqtrd oveq1d simpl2 3eqtr4d simpl2l eqtr3d syl6eqr ) PUKULZS
      NULZUMZHEULZHSQUNUOZUMZIEULISQUNUOUMZUPZHIUQZJEULZJSQUNUOZUMZUMZUMZJJMURZ
      OVEZSRVEZHIOVEZSRVEZKWTXCHSRVEZXEWTJSRVEZPUSURZXCXFWTWIWRXGXHUQWIWLWMWSUT
      ZWNWOWRVAEJNPQRSXHUBUDXHVBZUEUFVFVCWTXBJSRWTXBJJOVEZJWTXAJJOWTJFULZWOXAJU
      QWTWPXLWNWOWPWQVDZEFJPUAUEVGVHWNWOWRVIZAFHIMQTVJZSQUNUOXOAVJZSRVEZOVEXPUQ
      UMCVJXOXDQUNDVJZSQUNUOXRXDQUNUOUMBVJLUQVKDEVLBFVMDXOGVNVRXQOVEUQVKTEVLCFV
      MSJUJVOVCVPWTWGWPXKJUQWGWHWLWMWSVQZXMEOPJUCUEVSVCVTWAWTWIWLXFXHUQXIWIWLWM
      WSWBEHNPQRSXHUBUDXJUEUFVFVCWCWTHXDSRWTHHOVEZHXDWTWGWJXTHUQXSWJWKWIWMWSWDE
      OPHUCUEVSVCWTHIHOXNVPWEWAVTUGWF $.

    $( Part of proof that ` F ` is a translation.  Combine all cases.  TODO:
       fix comment.  (Contributed by NM, 10-Apr-2013.) $)
    cdleme50trn123 $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( R e. A /\ -. R .<_ W ) )
         -> ( ( R .\/ ( F ` R ) ) ./\ W ) = U ) $=
      ( chlt wcel wa wbr wn w3a cfv co wceq cdleme50trn3 anass1rs cdleme50trn12
      wne pm2.61dane ) PUKULSNULUMHEULHSQUNUOUMIEULISQUNUOUMUPZJEULJSQUNUOUMZUM
      JJMUQOURSRURKUSZHIVEHIUSVFVGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUTVAV
      EHIVCVFVGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVBVAVD $.

    $d d e s t x y z G $.  $d a b c t u x y z N $.  $d a b c x y z O $.
    $d a b c t u v x y z V $.  $d e a b c u v $.
    ${
      cdlemef51.v $e |- V = ( ( Q .\/ P ) ./\ W ) $.
      $( g(t), ` -. ` v ` <_ ` p ` \/ ` q. $)
      cdlemef51.n $e |- N
          = ( ( v .\/ V ) ./\ ( P .\/ ( ( Q .\/ v ) ./\ W ) ) ) $.
      $( g_t(s), u ` <_ ` p ` \/ ` q $)
      cdlemefs51.o $e |- O
          = ( ( Q .\/ P ) ./\ ( N .\/ ( ( u .\/ v ) ./\ W ) ) ) $.
      cdlemef51.g $e |- G = ( a e. B |->
         if ( ( Q =/= P /\ -. a .<_ W ) ,
           $( g(x) when p ` =/= ` q and ` -. ` a ` <_ ` w. $)
           ( iota_ c e. B A. u e. A
                ( ( -. u .<_ W /\ ( u .\/ ( a ./\ W ) ) = a ) -> c = (
                    $( g_t(s), u ` <_ ` p ` \/ ` q $)
                    if ( u .<_ ( Q .\/ P ) ,
                       ( iota_ b e. B A. v e. A
                             ( ( -. v .<_ W /\ -. v .<_ ( Q .\/ P ) )
                             -> b = O ) ) ,
                    $( g(s), ` -. ` u ` <_ ` p ` \/ ` q. $)
                       [_ u / v ]_ N )
                .\/ ( a ./\ W ) ) ) ) ,
           $( g(x) when p = q or a ` <_ ` w is just x. $)
           a ) ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  TODO: fix comment.
         (Contributed by NM, 14-Apr-2013.)  (New usage is discouraged.) $)
      cdleme51finvfvN $p |- ( ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) ) /\ X e. B )
         -> ( `' F ` X ) = ( G ` X ) ) $=
        ( chlt wcel wa wbr wn w3a cfv wceq ccnv cdleme48fgv wf1o wi cdleme50f1o
        adantr cdlemeg46fvcl f1ocnvfv syl2anc mpd ) RVDVEUDPVEVFJGVEJUDSVGVHVFK
        GVEKUDSVGVHVFVIZUEHVEZVFZUEOVJZNVJUEVKZUENVLVJWEVKZABCDEFGHIJKLMNOPQRST
        UAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVMWDHHNVNZWEHVEWFWGVOWBWH
        WCABCFGHIJKLMNPQRSTUDUFUJUKULUMUNUOUPUQURUSVPVQDEGHJKOPQRSTUAUBUCUDUEUG
        UHUIUJUKULUMUNUOUTVAVBVCVRHHWEUENVSVTWA $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  TODO: fix comment.
         (Contributed by NM, 14-Apr-2013.)  (New usage is discouraged.) $)
      cdleme51finvN $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> `' F = G ) $=
        ( ve chlt wcel wa wbr w3a ccnv wfn wf1o cdleme50f1o dff1o4 sylib simprd
        wn 3com23 f1ofn syl cv cdleme51finvfvN eqfnfvd ) RVDVEUDPVEVFZJGVEJUDSV
        GVPVFZKGVEKUDSVGVPVFZVHZVCHNVIZOWFNHVJZWGHVJZWFHHNVKWHWIVFABCFGHIJKLMNP
        QRSTUDUEUIUJUKULUMUNUOUPUQURVLHHNVMVNVOWFHHOVKZOHVJWCWEWDWJUFUGUHDGHUAK
        JUCUBOPQRSTUDEUIUJUKULUMUNUSUTVAVBVLVQHHOVRVSABCDEFGHIJKLMNOPQRSTUAUBUC
        UDVCVTUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBWAWB $.
    $}

    ${
      cdleme50ltrn.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      $( Part of proof of Lemma E in [Crawley] p. 113. ` F ` is a lattice
         translation.  TODO: fix comment.  (Contributed by NM, 10-Apr-2013.) $)
      cdleme50ltrn $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F e. T ) $=
        ( vd ve chlt wcel wa wbr wn w3a cldil cv co wceq wral eqid cdleme50ldil
        cfv wi simp1 simp2l simp3l cdleme50trn123 syl12anc simp2r simp3r eqtr4d
        3exp ralrimivv wb isltrn 3ad2ant1 mpbir2and ) PUNUOSNUOUPZHEUOHSQUQURUP
        ZIEUOISQUQURUPZUSZMJUOZMSPUTVGVGZUOZULVAZSQUQURZUMVAZSQUQURZUPZWJWJMVGO
        VBSRVBZWLWLMVGOVBSRVBZVCZVHZUMEVDULEVDZABCDEFWHGHIKLMNOPQRSTUAUBUCUDUEU
        FUGUHUIUJWHVEZVFWFWRULUMEEWFWJEUOZWLEUOZUPZWNWQWFXCWNUSZWOKWPXDWFXAWKWO
        KVCWFXCWNVIZWFXAXBWNVJWFXCWKWMVKABCDEFGHIWJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
        UJVLVMXDWFXBWMWPKVCXEWFXAXBWNVNWFXCWKWMVOABCDEFGHIWLKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJVLVMVPVQVRWCWDWGWIWSUPVSWEEUNWHJMNOPQRSUMULUBUCUDUEUFWTUKVTW
        AWB $.

      $( Part of proof of Lemma E in [Crawley] p. 113.  TODO: fix comment.
         (Contributed by NM, 14-Apr-2013.)  (New usage is discouraged.) $)
      cdleme51finvtrN $p |- ( ( ( K e. HL /\ W e. H )
               /\ ( P e. A /\ -. P .<_ W )
               /\ ( Q e. A /\ -. Q .<_ W ) )
           -> `' F e. T ) $=
        ( va vu vc vv vb chlt wcel wa wbr wn w3a ccnv wne cv wceq wral crio csb
        co wi cif cmpt eqid cdleme51finvN cdleme50ltrn 3com23 eqeltrd ) PUQURSN
        URUSZHEURHSQUTVAUSZIEURISQUTVAUSZVBMVCULFIHVDULVEZSQUTVAUSUMVEZSQUTVAWC
        WBSRVJZOVJWBVFUSUNVEWCIHOVJZQUTUOVEZSQUTVAWFWEQUTVAUSUPVEWEWFWESRVJZOVJ
        HIWFOVJSRVJOVJRVJZWCWFOVJSRVJOVJRVJZVFVKUOEVGUPFVHUOWCWHVIVLWDOVJVFVKUM
        EVGUNFVHWBVLVMZJABCUOUMDEFGHIKLMWJNOPQRWHWIWGSTULUPUNUAUBUCUDUEUFUGUHUI
        UJWGVNZWHVNZWIVNZWJVNZVOVSWAVTWJJURULUPUNUOEFWHIHJWGWIWJNOPQRSUMUAUBUCU
        DUEUFWKWLWMWNUKVPVQVR $.
    $}
  $}

  ${
    $d f s t x y z A $.  $d s t x y z H $.  $d f s t x y z .\/ $.
    $d f s t x y z K $.  $d f s t x y z .<_ $.  $d f s t x y z P $.
    $d f s t x y z Q $.  $d f T $.  $d f s t x y z W $.
    cdleme.l $e |- .<_ = ( le ` K ) $.
    cdleme.a $e |- A = ( Atoms ` K ) $.
    cdleme.h $e |- H = ( LHyp ` K ) $.
    cdleme.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Part of Lemma E in [Crawley] p. 113.  TODO: fix comment.  (Contributed
       by NM, 11-Apr-2013.) $)
    cdleme50ex $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> E. f e. T ( f ` P ) = Q ) $=
      ( wa wbr wn cv co wceq eqid vx vs vz vt vy chlt wcel w3a cbs cfv wne cmee
      cjn wi wral crio csb cmpt wrex cdleme50ltrn cdleme17d fveq1 eqeq1d rspcev
      cif syl2anc ) GUFUGIFUGNBAUGBIHOPNCAUGCIHOPNUHUAGUIUJZBCUKUAQZIHOPNUBQZIH
      OPVIVHIGULUJZRZGUMUJZRVHSNUCQVIBCVLRZHOUDQZIHOPVNVMHOPNUEQVMVNVMIVJRZVLRC
      BVNVLRIVJRVLRVJRZVIVNVLRIVJRVLRVJRZSUNUDAUOUEVGUPUDVIVPUQVEVKVLRSUNUBAUOU
      CVGUPVHVEURZDUGBVRUJZCSZBEQZUJZCSZEDUSUAUEUCUDAVGVPBCDVOVQVRFVLGHVJIUBVGT
      ZJVLTZVJTZKLVOTZVPTZVQTZVRTZMUTUAUEUCUDAVGVPBCVOVQVRFVLGHVJIUBWDJWEWFKLWG
      WHWIWJVAWCVTEVRDWAVRSWBVSCBWAVRVBVCVDVF $.

    $d f H $.  $d z T $.
    $( Lemma E in [Crawley] p. 113.  If p,q are atoms not under hyperplane w,
       then there is a unique translation f such that f(p) = q.  (Contributed
       by NM, 11-Apr-2013.) $)
    cdleme $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> E! f e. T ( f ` P ) = Q ) $=
      ( vz wcel wa wbr wn w3a wceq chlt cv cfv wrex wral wreu cdleme50ex simp11
      simp2l simp2r simp12 eqtr3 3ad2ant3 cdlemd syl311anc 3exp ralrimivv fveq1
      wi eqeq1d reu4 sylanbrc ) GUAOIFOPZBAOBIHQRPZCAOCIHQRPZSZBEUBZUCZCTZEDUDV
      IBNUBZUCZCTZPZVGVJTZUSZNDUEEDUEVIEDUFABCDEFGHIJKLMUGVFVOENDDVFVGDOZVJDOZP
      ZVMVNVFVRVMSVCVPVQVDVHVKTZVNVCVDVEVRVMUHVFVPVQVMUIVFVPVQVMUJVCVDVEVRVMUKV
      MVFVSVRVHVKCULUMABDVGVJFGHIJKLMUNUOUPUQVIVLENDVNVHVKCBVGVJURUTVAVB $.
  $}

  ${
    $d p q A $.  $d p q H $.  $d p q K $.  $d p q .<_ $.  $d q P $.
    $d p q U $.  $d p q W $.
    cdlemf1.l $e |- .<_ = ( le ` K ) $.
    cdlemf1.j $e |- .\/ = ( join ` K ) $.
    cdlemf1.a $e |- A = ( Atoms ` K ) $.
    cdlemf1.h $e |- H = ( LHyp ` K ) $.
    $( Part of Lemma F in [Crawley] p. 116.  TODO: should this or part of it
       become a stand-alone theorem?  (Contributed by NM, 12-Apr-2013.) $)
    cdlemf1 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. A /\ U .<_ W )
        /\ ( P e. A /\ -. P .<_ W ) )
     -> E. q e. A ( P =/= q /\ -. q .<_ W /\ U .<_ ( P .\/ q ) ) ) $=
      ( wcel wa wbr w3a wne co syl chlt wrex simp1l simp3l simp2l simp2r simp3r
      nbrne2 necomd syl2anc hlsupr syl31anc simp31 simp13r simp12r clat cbs cfv
      wn cv simp11l hllat eqid atbase 3ad2ant2 simp12l simp11r lhpbase latjle12
      wb syl13anc biimpd mpan2d simp33 wi hlcvl simp2 simp13l simp32 cvlatexch2
      clc syl131anc mpd hlatjcl lattr mpand syld mtod cvlatexch1 3jca reximdvai
      syl3anc 3exp ) FUANZHDNZOZCANZCHGPZOZBANZBHGPZUSZOZQZIUTZBRZXECRZXEBCESGP
      ZQZIAUBZBXERZXEHGPZUSZCBXEESGPZQZIAUBXDWNWTWQBCRZXJWNWOWSXCUCWPWSWTXBUDWP
      WQWRXCUEXDWRXBXPWPWQWRXCUFWPWSWTXBUGWRXBOCBCBHGUHUIUJABCEFGIJKLUKULXDXIXO
      IAXDXEANZXIXOXDXQXIQZXKXMXNXRXEBXDXQXFXGXHUMZUIXRXLXAWTXBWPWSXQXIUNXRXLXE
      CESZHGPZXAXRXLWRYAWQWRWPXCXQXIUOXRXLWROZYAXRFUPNZXEFUQURZNZCYDNZHYDNZYBYA
      VJXRWNYCWNWOWSXCXQXIVAZFVBTZXQXDYEXIAYDXEFYDVCZLVDVEXRWQYFWQWRWPXCXQXIVFZ
      AYDCFYJLVDTXRWOYGWNWOWSXCXQXIVGYDDFHYJMVHTZYDEFGXECHYJJKVIVKVLVMXRBXTGPZY
      AXAXRXHYMXDXQXFXGXHVNZXRFWANZXQWTWQXGXHYMVOXRWNYOYHFVPTZXDXQXIVQZWTXBWPWS
      XQXIVRZYKXDXQXFXGXHVSAXEBCEFGJKLVTWBWCXRYCBYDNZXTYDNZYGYMYAOXAVOYIXRWTYSY
      RAYDBFYJLVDTXRWNXQWQYTYHYQYKAYDEFXECYJKLWDWLYLYDFGBXTHYJJWEVKWFWGWHXRXHXN
      YNXRYOXQWQWTXFXHXNVOYPYQYKYRXSAXECBEFGJKLWIWBWCWJWMWKWC $.

    cdlemf2.m $e |- ./\ = ( meet ` K ) $.
    $( Part of Lemma F in [Crawley] p. 116.  (Contributed by NM,
       12-Apr-2013.) $)
    cdlemf2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. A /\ U .<_ W ) )
     -> E. p e. A E. q e. A ( ( -. p .<_ W /\ -. q .<_ W )
            /\ U = ( ( p .\/ q ) ./\ W ) ) ) $=
      ( wcel wa wbr wrex w3a chlt cv wn co wceq lhpexnle adantr cdlemf1 simpr1r
      wne wi simpr32 simpr33 simplrr clat cbs wb hllat ad3antrrr simplrl atbase
      cfv eqid simplll simpr1l simpr2 hlatjcl syl3anc lhpbase ad3antlr latlem12
      syl syl13anc mpbi2and cal hlatl simpr31 lhpat syl122anc atcmp mpbid jca31
      simpll 3exp2 3impia reximdvai mpd 3expia exp3a ) EUAPZHCPZQZBAPZBHFRZQZQZ
      JUBZHFRUCZJASZWRIUBZHFRUCZQBWQWTDUDZHGUDZUEZQZIASZJASWLWSWOACEFHJKMNUFUGW
      PWRXFJAWPWQAPZWRXFWLWOXGWRQZXFWLWOXHTZWQWTUJZXABXBFRZTZIASXFAWQBCDEFHIKLM
      NUHXIXLXEIAWLWOXHWTAPZXLXEUKUKWPXHXMXLXEWPXHXMXLTZQZWRXAXDXGWRXMXLWPUIZXJ
      XAXKXHXMWPULXOBXCFRZXDXOXKWNXQXJXAXKXHXMWPUMWLWMWNXNUNXOEUOPZBEUPVBZPZXBX
      SPZHXSPZXKWNQXQUQWJXRWKWOXNEURUSXOWMXTWLWMWNXNUTZAXSBEXSVCZMVAVLXOWJXGXMY
      AWJWKWOXNVDXGWRXMXLWPVEZWPXHXMXLVFZAXSDEWQWTYDLMVGVHWKYBWJWOXNXSCEHYDNVIV
      JXSEFGBXBHYDKOVKVMVNXOEVOPZWMXCAPZXQXDUQWJYGWKWOXNEVPUSYCXOWLXGWRXMXJYHWL
      WOXNWCYEXPYFXJXAXKXHXMWPVQAWQWTCDEFGHKLOMNVRVSABXCEFKMVTVHWAWBWDWEWFWGWHW
      IWFWG $.
  $}

  ${
    $d f p q A $.  $d f p q H $.  $d f p q K $.  $d f p q .<_ $.  $d p q R $.
    $d f p q T $.  $d f p q U $.  $d f p q W $.
    cdlemf.l $e |- .<_ = ( le ` K ) $.
    cdlemf.a $e |- A = ( Atoms ` K ) $.
    cdlemf.h $e |- H = ( LHyp ` K ) $.
    cdlemf.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemf.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Lemma F in [Crawley] p. 116.  If u is an atom under w, there exists a
       translation whose trace is u.  (Contributed by NM, 12-Apr-2013.) $)
    cdlemf $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. A /\ U .<_ W ) )
                   -> E. f e. T ( R ` f ) = U ) $=
      ( vp vq wcel wa cfv co chlt wbr cv wn cjn cmee wceq wrex eqid cdlemf2 w3a
      simp1l simp2l simp3ll simp2r cdleme50ex syl122anc wi simp3r oveq2d oveq1d
      simp3lr simp11 simp3l simp13l simp2ll trlval2 syl112anc 3eqtr4d 3exp 3imp
      3expia exp3a reximdvai mpd rexlimdvv ) GUAQIFQRZDAQDIHUBRZRZOUCZIHUBUDZPU
      CZIHUBUDZRZDVTWBGUESZTZIGUFSZTZUGZRZPAUHOAUHEUCZBSZDUGZECUHZADFWEGHWGIPOJ
      WEUIZKLWGUIZUJVSWJWNOPAAVSVTAQZWBAQZRZWJWNVSWSWJUKZVTWKSZWBUGZECUHZWNWTVQ
      WQWAWRWCXCVQVRWSWJULVSWQWRWJUMWAWCWIVSWSUNVSWQWRWJUOWAWCWIVSWSVBAVTWBCEFG
      HIJKLMUPUQWTXBWMECWTWKCQZXBWMVSWSWJXDXBRZWMURZVQVRWSWJXFURVQVRWSUKZWJXEWM
      XGWJXEUKZVTXAWETZIWGTZWHWLDXHXIWFIWGXHXAWBVTWEXGWJXDXBUSUTVAXHVQXDWQWAWLX
      JUGVQVRWSWJXEVCXGWJXDXBVDWQWRVQVRWJXEVEWAWCWIXGXEVFAVTBCWKFWEGHWGIJWOWPKL
      MNVGVHXGWDWIXEUOVIVJVLVKVMVNVOVJVPVO $.
  $}

  ${
    $d f A $.  $d f H $.  $d f K $.  $d f .<_ $.  $d f T $.  $d f U $.
    $d f W $.
    cdlemfnid.b $e |- B = ( Base ` K ) $.
    cdlemfnid.l $e |- .<_ = ( le ` K ) $.
    cdlemfnid.a $e |- A = ( Atoms ` K ) $.
    cdlemfnid.h $e |- H = ( LHyp ` K ) $.
    cdlemfnid.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemfnid.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( ~ cdlemf with additional constraint of non-identity.  (Contributed by
       NM, 20-Jun-2013.) $)
    cdlemfnid $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. A /\ U .<_ W ) )
     -> E. f e. T ( ( R ` f ) = U /\ f =/= ( _I |` B ) ) ) $=
      ( chlt wcel wa wrex wbr cv cfv wceq cid cres wne cdlemf w3a simp3 simp1rl
      eqeltrd wb simp1l simp2 trlnidatb syl2anc mpbird jca 3expia reximdva mpd
      ) HQRJGRSZEARZEJIUAZSZSZFUBZCUCZEUDZFDTVJVHUEBUFUGZSZFDTACDEFGHIJLMNOPUHV
      GVJVLFDVGVHDRZVJVLVGVMVJUIZVJVKVGVMVJUJZVNVKVIARZVNVIEAVOVDVEVCVMVJUKULVN
      VCVMVKVPUMVCVFVMVJUNVGVMVJUOABCDVHGHJKMNOPUPUQURUSUTVAVB $.
  $}

  ${
    $d u B $.  $d u f X $.  $d u f Y $.  $d u f Z $.  $d u f H $.  $d u f K $.
    $d u f R $.  $d u f T $.  $d u f W $.
    cdlemftr.b $e |- B = ( Base ` K ) $.
    cdlemftr.h $e |- H = ( LHyp ` K ) $.
    cdlemftr.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemftr.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Special case of ~ cdlemf showing existence of non-identity translation
       with trace different from any 3 given lattice elements.  (Contributed by
       NM, 24-Jul-2013.) $)
    cdlemftr3 $p |- ( ( K e. HL /\ W e. H )
  -> E. f e. T ( f =/= ( _I |` B )
         /\ ( ( R ` f ) =/= X /\ ( R ` f ) =/= Y /\ ( R ` f ) =/= Z ) ) ) $=
      ( vu wcel wa wne wrex wex chlt cv cfv wceq cid cres w3a catm wbr lhpexle3
      cple eqid df-rex sylib cdlemfnid adantrrr eqcom anbi1i rexbii simprrr jca
      ex eximdv rexcom4 anass exbii fvex neeq1 3anbi123d anbi2d ceqsexv r19.41v
      mpd bitri 3bitr3ri ) FUAPGEPQZOUBZDUBZBUCZUDZVRUEAUFRZQZDCSZVQHRZVQIRZVQJ
      RZUGZQZOTZWAVSHRZVSIRZVSJRZUGZQZDCSZVPVQFUHUCZPZVQGFUKUCZUIZWGQZQZOTZWIVP
      WTOWPSXBWPEFWRGHIJOWRULZWPULZLUJWTOWPUMUNVPXAWHOVPXAWHVPXAQZWCWGXEVSVQUDZ
      WAQZDCSZWCVPWQWSXHWGWPABCVQDEFWRGKXCXDLMNUOUPXGWBDCXFVTWAVSVQUQURUSUNVPWQ
      WSWGUTVAVBVCVMWBWGQZOTZDCSXIDCSZOTWOWIXIDOCVDXJWNDCXJVTWAWGQZQZOTWNXIXMOV
      TWAWGVEVFXLWNOVSVRBVGVTWGWMWAVTWDWJWEWKWFWLVQVSHVHVQVSIVHVQVSJVHVIVJVKVNU
      SXKWHOWBWGDCVLVFVOUN $.

    $( Special case of ~ cdlemf showing existence of non-identity translation
       with trace different from any 2 given lattice elements.  (Contributed by
       NM, 25-Jul-2013.) $)
    cdlemftr2 $p |- ( ( K e. HL /\ W e. H )
  -> E. f e. T ( f =/= ( _I |` B ) /\ ( R ` f ) =/= X /\ ( R ` f ) =/= Y ) ) $=
      ( chlt wcel wa cv wne w3a wrex cid cres cfv cdlemftr3 simpl simpr1 simpr2
      3jca reximi syl ) FNOGEOPDQZUAAUBRZUKBUCZHRZUMIRZUOSZPZDCTULUNUOSZDCTABCD
      EFGHIIJKLMUDUQURDCUQULUNUOULUPUEULUNUOUOUFULUNUOUOUGUHUIUJ $.

    $( Part of proof of Lemma G of [Crawley] p. 116, sixth line of third
       paragraph on p. 117: there is "a translation h, different from the
       identity, such that tr h ` =/= ` tr f."  (Contributed by NM,
       25-Jul-2013.) $)
    cdlemftr1 $p |- ( ( K e. HL /\ W e. H )
        -> E. f e. T ( f =/= ( _I |` B ) /\ ( R ` f ) =/= X ) ) $=
      ( chlt wcel wa cv cid cres wne wrex cfv w3a cdlemftr2 3simpa reximi syl )
      FMNGENODPZQARSZUGBUAHSZUIUBZDCTUHUIOZDCTABCDEFGHHIJKLUCUJUKDCUHUIUIUDUEUF
      $.
  $}

  ${
    $d f H $.  $d f K $.  $d f T $.  $d f W $.
    cdlemftr0.b $e |- B = ( Base ` K ) $.
    cdlemftr0.h $e |- H = ( LHyp ` K ) $.
    cdlemftr0.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Special case of ~ cdlemf showing existence of a non-identity
       translation.  (Contributed by NM, 1-Aug-2013.) $)
    cdlemftr0 $p |- ( ( K e. HL /\ W e. H ) -> E. f e. T f =/= ( _I |` B ) ) $=
      ( chlt wcel wa cv cid cres wne ctrl cfv wrex eqid cdlemftr1 simpl reximi
      syl ) EJKFDKLCMZNAOPZUEFEQRRZRNPZLZCBSUFCBSAUGBCDEFNGHIUGTUAUIUFCBUFUHUBU
      CUD $.
  $}

  ${
    $d f g u .<_ $.  $d g u A $.  $d f g u B $.  $d f g u H $.  $d f g u K $.
    $d f g u R $.  $d f g u T $.  $d f g u W $.  $d f g u X $.  $d f g u Y $.
    trlord.b $e |- B = ( Base ` K ) $.
    trlord.l $e |- .<_ = ( le ` K ) $.
    trlord.a $e |- A = ( Atoms ` K ) $.
    trlord.h $e |- H = ( LHyp ` K ) $.
    trlord.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlord.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The ordering of two Hilbert lattice elements (under the fiducial
       hyperplane ` W ` ) is determined by the translations whose traces are
       under them.  (Contributed by NM, 3-Mar-2014.) $)
    trlord $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( X e. B /\ X .<_ W ) /\ ( Y e. B /\ Y .<_ W ) )
    -> ( X .<_ Y <-> A. f e. T ( ( R ` f ) .<_ X -> ( R ` f ) .<_ Y ) ) ) $=
      ( wcel wa wbr vu vg chlt w3a cv cfv wi wral clat simpl1l hllat syl simpl1
      simprlr trlcl syl2anc simpl2l simpl3l simprr simprll lattrd exp44 simp11l
      ralrimdv simp2r atbase simp12l simp11r lhpbase simp3 jca 3expia wceq wrex
      simp12r simp11 cdlemf syl12anc simp2l fveq2 breq1d imbi12d rspccv biimpcd
      weq breq1 syl6 rexlimdv mpd imp3a syld exp32 simp1l simp3l hlatle syl3anc
      wb sylibrd impbid ) GUCRZIFRZSZJBRZJIHTZSZKBRZKIHTZSZUDZJKHTZEUEZCUFZJHTZ
      XLKHTZUGZEDUHZXIXJXOEDXIXJXKDRZXMXNXIXJXQSZXMSZSZBGHXLJKLMXTWTGUIRZWTXAXE
      XHXSUJGUKZULXTXBXQXLBRXBXEXHXSUMXIXJXQXMUNBCDXKFGILOPQUOUPXCXDXBXHXSUQXFX
      GXBXEXSURXIXRXMUSXIXJXQXMUTVAVBVDXIXPUAUEZJHTZYCKHTZUGZUAAUHZXJXIXPYFUAAX
      IXPYCARZYFXIXPYHSZSZYDYCIHTZYDSZYEXIYIYDYLXIYIYDUDZYKYDYMBGHYCJILMYMWTYAW
      TXAXEXHYIYDVCYBULYMYHYCBRXIXPYHYDVEABYCGLNVFULXCXDXBXHYIYDVGYMXAIBRWTXAXE
      XHYIYDVHBFGILOVIULXIYIYDVJZXCXDXBXHYIYDVOVAYNVKVLYJYKYDYEXIYIYKYFXIYIYKUD
      ZUBUEZCUFZYCVMZUBDVNZYFYOXBYHYKYSXBXEXHYIYKVPXIXPYHYKVEXIYIYKVJACDYCUBFGH
      IMNOPQVQVRYOYRYFUBDYOYPDRZYQJHTZYQKHTZUGZYRYFUGYOXPYTUUCUGXIXPYHYKVSXOUUC
      EYPDEUBWEZXMUUAXNUUBUUDXLYQJHXKYPCVTZWAUUDXLYQKHUUEWAWBWCULYRUUCYFYRUUAYD
      UUBYEYQYCJHWFYQYCKHWFWBWDWGWHWIVLWJWKWLVDXIWTXCXFXJYGWQWTXAXEXHWMXBXCXDXH
      VSXBXEXFXGWNABGHJKUALMNWOWPWRWS $.
  $}

  ${
    $( TODO fix $d's $)
    $d s t x y z A $.  $d f s t x y z B $.  $d f s x y z D $.  $d f x y z E $.
    $d s t x y z H $.  $d f s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d f s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t x y z R $.  $d s t x y z U $.  $d s t x y z W $.
    $d s t x y z A $.  $d s t x y z B $.  $d x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t y R $.  $d s t x y z S $.  $d s t x y z U $.
    $d s t x y z W $.  $d a b c u v A $.  $d a b c u v B $.  $d a b c v D $.
    $d a b c E $.  $d a b c u v F $.  $d a b c u v H $.  $d a b c u v .\/ $.
    $d a b c u v K $.  $d a b c u v .<_ $.  $d a b c u v ./\ $.
    $d a b c u v P $.  $d a b c u v Q $.  $d a b c v U $.  $d a b c u v W $.
    $d a b c s t u v x y z X $.  $d a b c s t u v x y z Y $.  $d f A $.
    $d f H $.  $d f K $.  $d f .<_ $.  $d f P $.  $d f Q $.  $d f T $.
    $d f W $.
    cdlemg1.b $e |- B = ( Base ` K ) $.
    cdlemg1.l $e |- .<_ = ( le ` K ) $.
    cdlemg1.j $e |- .\/ = ( join ` K ) $.
    cdlemg1.m $e |- ./\ = ( meet ` K ) $.
    cdlemg1.a $e |- A = ( Atoms ` K ) $.
    cdlemg1.h $e |- H = ( LHyp ` K ) $.
    ${
      cdlemg1.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
      cdlemg1.d $e |- D
          = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
      $( f_t(s), s ` <_ ` p ` \/ ` q $)
      cdlemg1.e $e |- E
          = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
      cdlemg1.g $e |- G = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.

      $d f w G $.  $d w P $.  $d w Q $.  $d w T $.  $d w W $.
      cdlemg1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      $( Shorter expression for ` G ` .  TODO: fix comment.  TODO: shorten
         using ~ cdleme or vice-versa?  Also, if not shortened with ~ cdleme ,
         then it can be moved up to save repeating hypotheses.  (Contributed by
         NM, 15-Apr-2013.) $)
      cdlemg1a $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> G = ( iota_ f e. T ( f ` P ) = Q ) ) $=
        ( chlt wcel wa wbr wn w3a cv cfv wceq crio cdleme50ltrn simplr ad2antrr
        simpll1 simpll2 simpr cdleme17d eqtr4d cdlemd syl311anc ex adantr fveq1
        eqeq1d syl5ibrcom impbid riota5 eqcomd ) QUMUNTOUNUOZHEUNHTRUPUQUOZIEUN
        ITRUPUQUOZURZHLUSZUTZIVAZLJVBNWDWGLJNABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUGU
        HUIUJUKULVCZWDWEJUNZUOZWGWENVAZWJWGWKWJWGUOZWAWINJUNZWBWFHNUTZVAWKWAWBW
        CWIWGVFWDWIWGVDWDWMWIWGWHVEWAWBWCWIWGVGWLWFIWNWJWGVHWDWNIVAZWIWGABCDEFG
        HIKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVIZVEVJEHJWENOQRTUCUFUGULVKVLVMWJWGWKW
        OWDWOWIWPVNWKWFWNIHWENVOVPVQVRVSVT $.

      cdlemg1.f $e |- F = ( iota_ f e. T ( f ` P ) = Q ) $.
      $( This theorem can be used to shorten ` G = ` hypothesis.  TODO:  Fix
         comment.  (Contributed by NM, 18-Apr-2013.) $)
      cdlemg1b2 $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) ) -> F = G ) $=
        ( chlt wcel wa wbr wn w3a wne cv co wceq wi wral crio csb cif cmpt eqid
        cfv cdlemg1a syl6reqr syl6eqr ) RUOUPUAPUPUQHEUPHUASURUSUQIEUPIUASURUSU
        QUTZNAFHIVAAVBZUASURUSUQUBVBZUASURUSVRVQUATVCZQVCVQVDUQCVBVRHIQVCZSURDV
        BZUASURUSWAVTSURUSUQBVBMVDVEDEVFBFVGDVRGVHVIVSQVCVDVEUBEVFCFVGVQVIVJZOV
        PWBHLVBVLIVDLJVGNABCDEFGHIJKLMWBPQRSTUAUBUCUDUEUFUGUHUIUJUKWBVKUMVMUNVN
        ULVO $.

      $( Lemma for ~ cdlemg1idN .  (Contributed by NM, 18-Apr-2013.)
         (New usage is discouraged.) $)
      cdlemg1idlemN $p |- ( ( ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) ) /\ X e. B ) /\ P = Q )
           -> ( F ` X ) = X ) $=
        ( chlt wcel wa wbr wn w3a wceq cfv cdlemg1b2 fveq1d cv co wral crio csb
        wi cif cdleme31id sylan9eq anassrs ) RUPUQUAPUQURHEUQHUASUSUTURIEUQIUAS
        USUTURVAZUBFUQZHIVBZUBNVCZUBVBVPVQVRURVSUBOVCUBVPUBNOABCDEFGHIJKLMNOPQR
        STUAUCUDUEUFUGUHUIUJUKULUMUNUOVDVEAFHIOSUCVFZUASUSUTVTAVFZUATVGZQVGWAVB
        URCVFVTHIQVGZSUSDVFZUASUSUTWDWCSUSUTURBVFMVBVKDEVHBFVIDVTGVJVLWBQVGVBVK
        UCEVHCFVIUAUBUMVMVNVO $.

      $( Lemma for ~ ltrniotafvawN .  (Contributed by NM, 18-Apr-2013.)
         (New usage is discouraged.) $)
      cdlemg1fvawlemN $p |- ( ( ( ( K e. HL /\ W e. H )
      /\ ( P e. A /\ -. P .<_ W )
      /\ ( Q e. A /\ -. Q .<_ W ) ) /\ ( R e. A /\ -. R .<_ W ) )
           -> ( ( F ` R ) e. A /\ -. ( F ` R ) .<_ W ) ) $=
        ( chlt wcel wa wbr wn w3a cfv cdleme46fvaw wceq cdlemg1b2 adantr fveq1d
        eleq1d breq1d notbid anbi12d mpbird ) SUPUQUBQUQURHEUQHUBTUSUTURIEUQIUB
        TUSUTURVAZJEUQJUBTUSUTURZURZJOVBZEUQZVPUBTUSZUTZURJPVBZEUQZVTUBTUSZUTZU
        RABCDEFGHIJLNPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVCVOVQWAVSWCVOVPVTEVOJOPVMO
        PVDVNABCDEFGHIKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVEVFVGZVHVOVRWBVO
        VPVTUBTWDVIVJVKVL $.

      $( Lemma for ~ ltrniotacl .  (Contributed by NM, 18-Apr-2013.) $)
      cdlemg1ltrnlem $p |- ( ( ( K e. HL /\ W e. H )
               /\ ( P e. A /\ -. P .<_ W )
               /\ ( Q e. A /\ -. Q .<_ W ) )
           -> F e. T ) $=
        ( chlt wcel wa wbr wn w3a cdlemg1b2 cdleme50ltrn eqeltrd ) RUOUPUAPUPUQ
        HEUPHUASURUSUQIEUPIUASURUSUQUTNOJABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
        UJUKULUMUNVAABCDEFGHIJKMOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVBVC $.

      $( Lemma for ~ ltrniotacnvN .  (Contributed by NM, 18-Apr-2013.)
         (New usage is discouraged.) $)
      cdlemg1finvtrlemN $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> `' F e. T ) $=
        ( chlt wcel wa wbr wn w3a ccnv cdlemg1b2 cnveqd cdleme51finvtrN eqeltrd
        ) RUOUPUAPUPUQHEUPHUASURUSUQIEUPIUASURUSUQUTZNVAOVAJVFNOABCDEFGHIJKLMNO
        PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVBVCABCDEFGHIJKMOPQRSTUAUBUCUDUEUFUGUH
        UIUJUKULUMVDVE $.
    $}

    ${
      cdlemg1b.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
      cdlemg1b.d $e |- D
          = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
      $( f_t(s), s ` <_ ` p ` \/ ` q $)
      cdlemg1b.e $e |- E
          = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
      cdlemg1b.f $e |- F = ( iota_ f e. T ( f ` P ) = Q ) $.
      cdlemg1b.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      $( This theorem can be used to shorten ` F = ` hypothesis that have the
         form of the conclusion.  TODO: fix comment.  (Contributed by NM,
         16-Apr-2013.)  (New usage is discouraged.) $)
      cdlemg1bOLDN $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) ) $=
        ( wne cv wbr wn wa co wceq wi wral crio csb cif cmpt eqid cdlemg1b2 ) A
        BCDEFGHIJKLMNAFHIUMAUNZTRUOUPUQUAUNZTRUOUPVIVHTSURZPURVHUSUQCUNVIHIPURZ
        RUODUNZTRUOUPVLVKRUOUPUQBUNMUSUTDEVABFVBDVIGVCVDVJPURUSUTUAEVACFVBVHVDV
        EZOPQRSTUAUBUCUDUEUFUGUHUIUJVMVFULUKVG $.
    $}
  $}

  ${
    $d f s t x y z A $.  $d f s t x y z B $.  $d f s t x y z H $.
    $d f s t x y z K $.  $d f s t x y z .<_ $.  $d f s t x y z P $.
    $d f s t x y z Q $.  $d s t x y z R $.  $d f T $.  $d f s t x y z W $.
    $d s t x y z X $.
    cdlemg1ltrn.l $e |- .<_ = ( le ` K ) $.
    cdlemg1ltrn.a $e |- A = ( Atoms ` K ) $.
    cdlemg1ltrn.h $e |- H = ( LHyp ` K ) $.
    cdlemg1ltrn.f $e |- F = ( iota_ f e. T ( f ` P ) = Q ) $.
    cdlemg1ltrn.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ${
      cdlemg1id.b $e |- B = ( Base ` K ) $.
      $( Version of ~ cdleme31id with simpler hypotheses.  TODO:  Fix comment.
         (Contributed by NM, 18-Apr-2013.)  (New usage is discouraged.) $)
      cdlemg1idN $p |- ( ( ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) ) /\ X e. B ) /\ P = Q )
           -> ( F ` X ) = X ) $=
        ( co eqid vx vy vz vt vs cv cjn cfv cmee wne wbr wn wa wceq wi wral csb
        crio cif cmpt cdlemg1idlemN ) UAUBUCUDABUDUFZCDIUGUHZSZKIUIUHZSZVCSDCVB
        VCSKVESVCSVESZCDEVFFVDVGUEUFZVBVCSKVESVCSVESZGUABCDUJUAUFZKJUKULUMVHKJU
        KULVHVJKVESZVCSVJUNUMUCUFVHVDJUKVBKJUKULVBVDJUKULUMUBUFVIUNUOUDAUPUBBUR
        UDVHVGUQUSVKVCSUNUOUEAUPUCBURVJUSUTZHVCIJVEKLUERMVCTVETNOVFTVGTVITVLTQP
        VA $.
    $}
  $}

  ${
    $d f s t x y z A $.  $d f s t x y z B $.  $d f s t x y z H $.
    $d f s t x y z K $.  $d f s t x y z .<_ $.  $d f s t x y z P $.
    $d f s t x y z Q $.  $d s t x y z R $.  $d f T $.  $d f s t x y z W $.
    $d s t x y z X $.
    ltrniotaval.l $e |- .<_ = ( le ` K ) $.
    ltrniotaval.a $e |- A = ( Atoms ` K ) $.
    ltrniotaval.h $e |- H = ( LHyp ` K ) $.
    ltrniotaval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ltrniotaval.f $e |- F = ( iota_ f e. T ( f ` P ) = Q ) $.
    $( Version of ~ cdleme46fvaw with simpler hypotheses.  TODO:  Fix comment.
       (Contributed by NM, 18-Apr-2013.)  (New usage is discouraged.) $)
    ltrniotafvawN $p |- ( ( ( ( K e. HL /\ W e. H )
    /\ ( P e. A /\ -. P .<_ W )
    /\ ( Q e. A /\ -. Q .<_ W ) ) /\ ( R e. A /\ -. R .<_ W ) )
         -> ( ( F ` R ) e. A /\ -. ( F ` R ) .<_ W ) ) $=
      ( cv co wbr eqid vx vy vz vt vs cbs cfv cjn cmee wne wn wa wceq wral crio
      wi csb cif cmpt cdlemg1fvawlemN ) UAUBUCUDAIUFUGZUDQZBCIUHUGZRZKIUIUGZRZV
      CRCBVBVCRKVERVCRVERZBCDEVFFVDVGUEQZVBVCRKVERVCRVERZGUAVABCUJUAQZKJSUKULVH
      KJSUKVHVJKVERZVCRVJUMULUCQVHVDJSVBKJSUKVBVDJSUKULUBQVIUMUPUDAUNUBVAUOUDVH
      VGUQURVKVCRUMUPUEAUNUCVAUOVJURUSZHVCIJVEKUEVATLVCTVETMNVFTVGTVITVLTOPUT
      $.

    $( Version of ~ cdleme50ltrn with simpler hypotheses.  TODO:  Fix comment.
       (Contributed by NM, 17-Apr-2013.) $)
    ltrniotacl $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( P e. A /\ -. P .<_ W )
             /\ ( Q e. A /\ -. Q .<_ W ) )
         -> F e. T ) $=
      ( vt cv co wbr eqid vx vy vz vs cbs cfv cjn cmee wne wn wa wceq wral crio
      wi csb cif cmpt cdlemg1ltrnlem ) UAUBUCPAHUEUFZPQZBCHUGUFZRZJHUHUFZRZVBRC
      BVAVBRJVDRVBRVDRZBCDVEEVCVFUDQZVAVBRJVDRVBRVDRZFUAUTBCUIUAQZJISUJUKVGJISU
      JVGVIJVDRZVBRVIULUKUCQVGVCISVAJISUJVAVCISUJUKUBQVHULUOPAUMUBUTUNPVGVFUPUQ
      VJVBRULUOUDAUMUCUTUNVIUQURZGVBHIVDJUDUTTKVBTVDTLMVETVFTVHTVKTNOUS $.

    $( Version of ~ cdleme51finvtrN with simpler hypotheses.  TODO:  Fix
       comment.  (Contributed by NM, 18-Apr-2013.)
       (New usage is discouraged.) $)
    ltrniotacnvN $p |- ( ( ( K e. HL /\ W e. H )
               /\ ( P e. A /\ -. P .<_ W )
               /\ ( Q e. A /\ -. Q .<_ W ) )
           -> `' F e. T ) $=
      ( vt cv co wbr eqid vx vy vz vs cbs cfv cjn cmee wne wn wa wceq wral crio
      wi csb cif cmpt cdlemg1finvtrlemN ) UAUBUCPAHUEUFZPQZBCHUGUFZRZJHUHUFZRZV
      BRCBVAVBRJVDRVBRVDRZBCDVEEVCVFUDQZVAVBRJVDRVBRVDRZFUAUTBCUIUAQZJISUJUKVGJ
      ISUJVGVIJVDRZVBRVIULUKUCQVGVCISVAJISUJVAVCISUJUKUBQVHULUOPAUMUBUTUNPVGVFU
      PUQVJVBRULUOUDAUMUCUTUNVIUQURZGVBHIVDJUDUTTKVBTVDTLMVETVFTVHTVKTNOUS $.

    $d w F $.  $d w P $.  $d w Q $.  $d w T $.  $d w W $.  $d f w $.
    $( Value of the unique translation specified by a value.  (Contributed by
       NM, 21-Feb-2014.) $)
    ltrniotaval $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
    /\ ( Q e. A /\ -. Q .<_ W ) ) -> ( F ` P ) = Q ) $=
      ( wcel wa wbr wn wceq chlt w3a cv cfv wreu cdleme crio nfriota1 nfcv nffv
      nfcxfr nfeq1 fveq1 eqeq1d riotaprop simprd syl ) HUAPJGPQBAPBJIRSQCAPCJIR
      SQUBBEUCZUDZCTZEDUEZBFUDZCTZABCDEGHIJKLMNUFVAFDPVCUTVCEDFEVBCEBFEFUTEDUGO
      UTEDUHUKEBUIUJULOURFTUSVBCBURFUMUNUOUPUQ $.

    $( Converse value of the unique translation specified by a value.
       (Contributed by NM, 21-Feb-2014.) $)
    ltrniotacnvval $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
    /\ ( Q e. A /\ -. Q .<_ W ) ) -> ( `' F ` Q ) = P ) $=
      ( chlt wcel wa wbr cfv wn w3a wf1o wceq ccnv simp1 ltrniotacl eqid ltrn1o
      cbs syl2anc simp2l atbase syl jca ltrniotaval f1ocnvfv sylc ) HPQJGQRZBAQ
      ZBJISUAZRZCAQCJISUARZUBZHUJTZVEFUCZBVEQZRBFTCUDCFUETBUDVDVFVGVDUSFDQVFUSV
      BVCUFABCDEFGHIJKLMNOUGVEDFGHPJVEUHZMNUIUKVDUTVGUSUTVAVCULAVEBHVHLUMUNUOAB
      CDEFGHIJKLMNOUPVEVEBCFUQUR $.
  $}

  ${
    $d f .<_ $.  $d f A $.  $d f H $.  $d f K $.  $d f P $.  $d f T $.
    $d f W $.
    ltrniotaidval.b $e |- B = ( Base ` K ) $.
    ltrniotaidval.l $e |- .<_ = ( le ` K ) $.
    ltrniotaidval.a $e |- A = ( Atoms ` K ) $.
    ltrniotaidval.h $e |- H = ( LHyp ` K ) $.
    ltrniotaidval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ltrniotaidval.f $e |- F = ( iota_ f e. T ( f ` P ) = P ) $.
    $( Value of the unique translation specified by identity value.
       (Contributed by NM, 25-Aug-2014.)  (New usage is discouraged.) $)
    ltrniotaidvalN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        )
          -> F = ( _I |` B ) ) $=
      ( wcel wa wceq 3anidm23 chlt wbr wn cid cres ltrniotaval simpl ltrniotacl
      cfv wb simpr ltrnideq syl3anc mpbird ) HUAQJGQRZCAQCJIUBUCRZRZFUDBUESZCFU
      ICSZUOUPUSACCDEFGHIJLMNOPUFTUQUOFDQZUPURUSUJUOUPUGUOUPUTACCDEFGHIJLMNOPUH
      TUOUPUKABCDFGHIJKLMNOULUMUN $.
  $}

  ${
    $d f .<_ $.  $d f A $.  $d f H $.  $d f K $.  $d f P $.  $d f Q $.
    $d f T $.  $d f W $.
    ltrniotavalb.l $e |- .<_ = ( le ` K ) $.
    ltrniotavalb.a $e |- A = ( Atoms ` K ) $.
    ltrniotavalb.h $e |- H = ( LHyp ` K ) $.
    ltrniotavalb.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Value of the unique translation specified by a value.  (Contributed by
       NM, 10-Mar-2014.)  (New usage is discouraged.) $)
    ltrniotavalbN $p |- ( ( ( K e. HL /\ W e. H )
    /\ ( ( P e. A /\ -. P .<_ W )
      /\ ( Q e. A /\ -. Q .<_ W ) ) /\ F e. T )
  -> ( ( F ` P ) = Q <-> F = ( iota_ f e. T ( f ` P ) = Q ) ) ) $=
      ( wcel wa wbr cfv wceq syl3anc chlt wn w3a cv crio simpl1 simpl2l simpl2r
      simpl3 eqid ltrniotacl simpr ltrniotaval eqtr4d cdlemd fveq1 simp1 simp2l
      syl311anc simp2r sylan9eqr impbida ) HUAOJGOPZBAOBJIQUBPZCAOCJIQUBPZPZFDO
      ZUCZBFRZCSZFBEUDRCSEDUEZSZVHVJPZVCVGVKDOZVDVIBVKRZSVLVCVFVGVJUFZVCVFVGVJU
      IVMVCVDVEVNVPVDVEVCVGVJUGZVDVEVCVGVJUHZABCDEVKGHIJKLMNVKUJZUKTVQVMVICVOVH
      VJULVMVCVDVEVOCSZVPVQVRABCDEVKGHIJKLMNVSUMZTUNABDFVKGHIJKLMNUOUSVLVHVIVOC
      BFVKUPVHVCVDVEVTVCVFVGUQVCVDVEVGURVCVDVEVGUTWATVAVB $.
  $}

  ${
    $d f p q A $.  $d f p q w F $.  $d f p q H $.  $d f p q K $.
    $d f p q .<_ $.  $d f w P $.  $d f Q $.  $d f p q w T $.  $d f p q w W $.
    cdlemg1c.l $e |- .<_ = ( le ` K ) $.
    cdlemg1c.a $e |- A = ( Atoms ` K ) $.
    cdlemg1c.h $e |- H = ( LHyp ` K ) $.
    cdlemg1c.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( A translation is uniquely determined by one of its values.  (Contributed
       by NM, 18-Apr-2013.) $)
    cdlemeiota $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
       /\ F e. T ) -> F = ( iota_ f e. T ( f ` P ) = ( F ` P ) ) ) $=
      ( chlt wcel wa wbr wn cfv wceq w3a cv crio eqidd wreu simp3 ltrnel 3com23
      wb cdleme syld3an3 fveq1 eqeq1d riota2 syl2anc mpbid eqcomd ) GNOIFOPZBAO
      BIHQRPZECOZUAZBDUBZSZBESZTZDCUCZEVAVDVDTZVFETZVAVDUDVAUTVEDCUEZVGVHUIURUS
      UTUFURUSUTVDAOVDIHQRPZVIURUTUSVJABCEFGHIJKLMUGUHABVDCDFGHIJKLMUJUKVEVGDCE
      VBETVCVDVDBVBEULUMUNUOUPUQ $.

    $( Any function of the form of the function constructed for ~ cdleme is a
       translation.  TODO:  Fix comment.  (Contributed by NM, 18-Apr-2013.) $)
    cdlemg1ci2 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) )
   /\ F = ( iota_ f e. T ( f ` P ) = Q ) ) -> F e. T ) $=
      ( chlt wcel wa wbr wn wceq w3a cv cfv crio eqid ltrniotacl adantr eqeltrd
      simpr ) HOPJGPQBAPBJIRSQCAPCJIRSQUAZFBEUBUCCTEDUDZTZQFUKDUJULUIUJUKDPULAB
      CDEUKGHIJKLMNUKUEUFUGUH $.

    $( Any translation belongs to the set of functions constructed for
       ~ cdleme .  TODO:  Fix comment.  (Contributed by NM, 18-Apr-2013.)
       (New usage is discouraged.) $)
    cdlemg1cN $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
       /\ ( Q e. A /\ -. Q .<_ W ) ) /\ ( F ` P ) = Q )
       -> ( F e. T
             <-> F = ( iota_ f e. T ( f ` P ) = Q ) ) ) $=
      ( wcel wa wbr wn cfv wceq chlt cv crio simpll1 simpll2 cdlemeiota syl3anc
      w3a simpr simplr eqeq2d riotabidv eqtrd cdlemg1ci2 adantlr impbida ) HUAO
      JGOPZBAOBJIQRPZCAOCJIQRPZUHZBFSZCTZPZFDOZFBEUBSZCTZEDUCZTZVCVDPZFVEVATZED
      UCZVGVIUQURVDFVKTUQURUSVBVDUDUQURUSVBVDUEVCVDUIABDEFGHIJKLMNUFUGVIVJVFEDV
      IVACVEUTVBVDUJUKULUMUTVHVDVBABCDEFGHIJKLMNUNUOUP $.

    $( Any translation is one of our ` F ` s.  TODO: fix comment, move to its
       own block maybe?  Would this help for ~ cdlemf ?  (Contributed by NM,
       17-Apr-2013.) $)
    cdlemg1cex $p |- ( ( K e. HL /\ W e. H ) ->
          ( F e. T <-> E. p e. A E. q e. A
                ( -. p .<_ W /\ -. q .<_ W
                  /\ F = ( iota_ f e. T ( f ` p ) = q ) ) ) ) $=
      ( wcel wa cv wbr wn wceq chlt cfv crio wrex lhpexnle adantr ltrnel simpld
      w3a 3expa simprr simprd simpll simpr simplr cdlemeiota breq1 notbid eqeq2
      syl3anc riotabidv eqeq2d 3anbi23d rspcev syl13anc reximdvai mpd ex simp2l
      exp32 simp1 simp31 jca simp2r simp32 simp33 cdlemg1ci2 syl31anc rexlimdvv
      3exp impbid ) FUAOHEOPZDBOZJQZHGRSZIQZHGRZSZDWDCQUBZWFTZCBUCZTZUIZIAUDZJA
      UDZWBWCWOWBWCPZWEJAUDZWOWBWQWCAEFGHJKLMUEUFWPWEWNJAWPWDAOZWEWNWPWRWEPZPZW
      DDUBZAOZWEXAHGRZSZDWIXATZCBUCZTZWNWTXBXDWBWCWSXBXDPAWDBDEFGHKLMNUGUJZUHWP
      WRWEUKWTXBXDXHULWTWBWSWCXGWBWCWSUMWPWSUNWBWCWSUOAWDBCDEFGHKLMNUPUTWMWEXDX
      GUIIXAAWFXATZWHXDWLXGWEXIWGXCWFXAHGUQURXIWKXFDXIWJXECBWFXAWIUSVAVBVCVDVEV
      JVFVGVHWBWMWCJIAAWBWRWFAOZPZWMWCWBXKWMUIZWBWSXJWHPWLWCWBXKWMVKXLWRWEWBWRX
      JWMVIWBXKWEWHWLVLVMXLXJWHWBWRXJWMVNWBXKWEWHWLVOVMWBXKWEWHWLVPAWDWFBCDEFGH
      KLMNVQVRVTVSWA $.
  $}

  ${
    $( TODO fix $d's $)
    $d s t x y z A $.  $d f s t x y z B $.  $d f s x y z D $.  $d f x y z E $.
    $d s t x y z H $.  $d f s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d f s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t x y z R $.  $d s t x y z U $.  $d s t x y z W $.
    $d s t x y z A $.  $d s t x y z B $.  $d x y z D $.  $d x y z E $.
    $d s t x y z H $.  $d s t x y z .\/ $.  $d s t x y z K $.
    $d s t x y z .<_ $.  $d s t x y z ./\ $.  $d s t x y z P $.
    $d s t x y z Q $.  $d s t y R $.  $d s t x y z S $.  $d s t x y z U $.
    $d s t x y z W $.  $d a b c u v A $.  $d a b c u v B $.  $d a b c v D $.
    $d a b c E $.  $d a b c f u v F $.  $d a b c u v H $.  $d a b c u v .\/ $.
    $d a b c u v K $.  $d a b c u v .<_ $.  $d a b c u v ./\ $.
    $d a b c u v P $.  $d a b c u v Q $.  $d a b c v U $.  $d a b c u v W $.
    $d a b c s t u v x y z X $.  $d a b c s t u v x y z Y $.  $d f A $.
    $d f H $.  $d f K $.  $d f .<_ $.  $d f P $.  $d f Q $.  $d f T $.
    $d f W $.  $d f G $.
    cdlemg2.b $e |- B = ( Base ` K ) $.
    cdlemg2.l $e |- .<_ = ( le ` K ) $.
    cdlemg2.j $e |- .\/ = ( join ` K ) $.
    cdlemg2.m $e |- ./\ = ( meet ` K ) $.
    cdlemg2.a $e |- A = ( Atoms ` K ) $.
    cdlemg2.h $e |- H = ( LHyp ` K ) $.
    cdlemg2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ${
      cdlemg2.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
      cdlemg2.d $e |- D
          = ( ( t .\/ U ) ./\ ( Q .\/ ( ( P .\/ t ) ./\ W ) ) ) $.
      $( f_t(s), s ` <_ ` p ` \/ ` q $)
      cdlemg2.e $e |- E
          = ( ( P .\/ Q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
      cdlemg2.g $e |- G = ( x e. B |->
         if ( ( P =/= Q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( P .\/ Q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( P .\/ Q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.
      $( Any translation belongs to the set of functions constructed for
         ~ cdleme .  TODO:  Fix comment.  (Contributed by NM, 22-Apr-2013.)
         (New usage is discouraged.) $)
      cdlemg2cN $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) ) /\ ( F ` P ) = Q )
         -> ( F e. T
               <-> F = G ) ) $=
        ( vf chlt wcel wa wbr w3a cfv wceq crio cdlemg1cN eqid cdlemg1b2 adantr
        wn cv eqeq2d bitrd ) QUNUOTOUOUPHEUOHTRUQVFUPIEUOITRUQVFUPURZHMUSIUTZUP
        ZMJUOMHUMVGUSIUTUMJVAZUTMNUTEHIJUMMOQRTUCUFUGUHVBVLVMNMVJVMNUTVKABCDEFG
        HIJKUMLVMNOPQRSTUAUBUCUDUEUFUGUIUJUKULUHVMVCVDVEVHVI $.

      $( This theorem can be used to shorten ` G = ` hypothesis.  TODO:  Fix
         comment.  (Contributed by NM, 21-Apr-2013.)
         (New usage is discouraged.) $)
      cdlemg2dN $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ ( F e. T /\ ( F ` P ) = Q ) ) -> F = G ) $=
        ( chlt wcel wa wbr wn cfv wceq w3a simp3l wb simp1 simp2l simp2r simp3r
        cdlemg2cN syl31anc mpbid ) QUMUNTOUNUOZHEUNHTRUPUQUOZIEUNITRUPUQUOZUOZM
        JUNZHMURIUSZUOZUTZVNMNUSZVJVMVNVOVAVQVJVKVLVOVNVRVBVJVMVPVCVJVKVLVPVDVJ
        VKVLVPVEVJVMVNVOVFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVGVHVI $.
    $}

    ${
      $d p q A $.  $d p q F $.  $d p q H $.  $d p q K $.  $d p q .<_ $.
      $d p q T $.  $d p q W $.  $d f p q s t x y z $.
      cdlemg2ex.u $e |- U = ( ( p .\/ q ) ./\ W ) $.
      $( f(t), ` -. ` t ` <_ ` p ` \/ ` q. $)
      cdlemg2ex.d $e |- D
          = ( ( t .\/ U ) ./\ ( q .\/ ( ( p .\/ t ) ./\ W ) ) ) $.
      $( f_t(s), s ` <_ ` p ` \/ ` q $)
      cdlemg2ex.e $e |- E
          = ( ( p .\/ q ) ./\ ( D .\/ ( ( s .\/ t ) ./\ W ) ) ) $.
      cdlemg2ex.g $e |- G = ( x e. B |->
         if ( ( p =/= q /\ -. x .<_ W ) ,
           $( Value when p ` =/= ` q and ` -. ` x ` <_ ` w. $)
           ( iota_ z e. B A. s e. A
                ( ( -. s .<_ W /\ ( s .\/ ( x ./\ W ) ) = x ) -> z = (
                    if ( s .<_ ( p .\/ q ) ,
                       $( Unique f_t(s) for all t, s ` <_ ` p ` \/ ` q $)
                       ( iota_ y e. B A. t e. A
                             ( ( -. t .<_ W /\ -. t .<_ ( p .\/ q ) ) -> y =
                          $( f_t(s) $)
                          E )
                       ) ,
                       $( f(s), ` -. ` s ` <_ ` p ` \/ ` q. $)
                       [_ s / t ]_ D
                    )
                .\/ ( x ./\ W ) ) ) ) ,
           $( Value when p = q or x ` <_ ` w is just x. $)
           x
         ) ) $.
      $( Any translation is one of our ` F ` s.  TODO: fix comment, move to its
         own block maybe?  Would this help for ~ cdlemf ?  (Contributed by NM,
         22-Apr-2013.) $)
      cdlemg2cex $p |- ( ( K e. HL /\ W e. H ) ->
            ( F e. T <-> E. p e. A E. q e. A
                  ( -. p .<_ W /\ -. q .<_ W /\ F = G ) ) ) $=
        ( vf chlt wcel wa wbr cfv wceq crio w3a wrex cdlemg1cex simplll simpllr
        cv wn simplrl simprl simplrr simprr cdlemg1b2 syl222anc eqeq2d pm5.32da
        eqid df-3an 3bitr4g 2rexbidva bitrd ) OUNUOZRMUOZUPZKHUOUAVFZRPUQVGZTVF
        ZRPUQVGZKWDUMVFURWFUSUMHUTZUSZVAZTEVBUAEVBWEWGKLUSZVAZTEVBUAEVBEHUMKMOP
        RTUAUCUFUGUHVCWCWJWLUATEEWCWDEUOZWFEUOZUPZUPZWEWGUPZWIUPWQWKUPWJWLWPWQW
        IWKWPWQUPZWHLKWRWAWBWMWEWNWGWHLUSWAWBWOWQVDWAWBWOWQVEWCWMWNWQVHWPWEWGVI
        WCWMWNWQVJWPWEWGVKABCDEFGWDWFHIUMJWHLMNOPQRSUBUCUDUEUFUGUIUJUKULUHWHVPV
        LVMVNVOWEWGWIVQWEWGWKVQVRVSVT $.

      ${
        $d p q ph $.  $d p q ps $.
        cdlemg2ce.p $e |- ( F = G -> ( ps <-> ch ) ) $.
        cdlemg2ce.c $e |- ( ( ( ( K e. HL /\ W e. H )
               /\ ( p e. A /\ -. p .<_ W )
               /\ ( q e. A /\ -. q .<_ W ) ) /\ ph ) -> ch ) $.
        $( Utility theorem to eliminate p,q when converting theorems with
           explicit f.  TODO: fix comment.  (Contributed by NM,
           22-Apr-2013.) $)
        cdlemg2ce $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ ph )
          -> ps ) $=
          ( chlt wcel wa w3a cv wn wceq wrex simp2 wb cdlemg2cex 3ad2ant1 mpbid
          wbr simp11 simp2l simp31 jca simp2r simp32 simp13 syl31anc simp33 syl
          mpbird 3exp rexlimdvv mpd ) RURUSUAPUSUTZNKUSZAVAZUDVBZUASVKVCZUCVBZU
          ASVKVCZNOVDZVAZUCHVEUDHVEZBWHWGWOWFWGAVFWFWGWGWOVGADEFGHIJKLMNOPQRSTU
          AUBUCUDUEUFUGUHUIUJUKULUMUNUOVHVIVJWHWNBUDUCHHWHWIHUSZWKHUSZUTZWNBWHW
          RWNVAZBCWSWFWPWJUTWQWLUTACWFWGAWRWNVLWSWPWJWHWPWQWNVMWHWRWJWLWMVNVOWS
          WQWLWHWPWQWNVPWHWRWJWLWMVQVOWFWGAWRWNVRUQVSWSWMBCVGWHWRWJWLWMVTUPWAWB
          WCWDWE $.
      $}

      $d p q .\/ $.  $d p q P $.  $d p q Q $.
      $( Part of proof of Lemma E in [Crawley] p. 113.  TODO:  FIX COMMENT . f
         preserves join: f(r ` \/ ` s) = f(r) ` \/ ` s, p. 115 10th line from
         bottom.  TODO:  Combine with ~ cdlemg2jOLDN ?  (Contributed by NM,
         22-Apr-2013.)  (New usage is discouraged.) $)
      cdlemg2jlemOLDN $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ F e. T )
              -> ( F ` ( P .\/ Q ) ) = ( ( F ` P ) .\/ ( F ` Q ) ) ) $=
        ( chlt wcel wa wbr wn co cfv wceq fveq1 oveq12d eqeq12d cv wi wral crio
        csb cif cvv vex eqid cdleme31sc ax-mp cdleme42mgN cdlemg2ce 3com23 ) QU
        OUPTOUPUQMJUPHEUPHTRURUSUQIEUPITRURUSUQUQZHIPUTZMVAZHMVAZIMVAZPUTZVBZVT
        WFWANVAZHNVAZINVAZPUTZVBABCDEFGJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNM
        NVBZWBWGWEWJWAMNVCWKWCWHWDWIPHMNVCIMNVCVDVEABCDEFDUAVFZGVJZUCVFZUBVFZHI
        KGNLODVFZTRURUSWPWNWOPUTZRURUSUQBVFLVBVGDEVHBFVIZPQRSWLWQRURWRWMVKZWLTR
        URUSWLAVFZTSUTZPUTWTVBUQCVFWSXAPUTVBVGUAEVHCFVIZTUAUDUEUFUGUHUIUKWLVLUP
        WMWLKPUTWOWNWLPUTTSUTPUTSUTZVBUAVMVLGWNWOWLKPSTXCDULXCVNVOVPULUMWRVNWSV
        NXBVNUNVQVRVS $.

      $d p q B $.  $d p q ./\ $.  $d p q X $.
      $( Lemma for ~ cdlemg2fv .  (Contributed by NM, 23-Apr-2013.) $)
      cdlemg2fvlem $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( ( P e. A /\ -. P .<_ W ) /\ ( X e. B /\ -. X .<_ W ) )
             /\ ( F e. T /\ ( P .\/ ( X ./\ W ) ) = X ) )
         -> ( F ` X ) = ( ( F ` P ) .\/ ( X ./\ W ) ) ) $=
        ( chlt wcel wa wbr wn co wceq w3a cfv simp1 simp3l simp2r simp2l simp3r
        jca fveq1 oveq1d eqeq12d cv cdleme48fvg 3expb cdlemg2ce syl112anc ) PUO
        UPSNUPUQZHEUPHSQURUSUQZTFUPTSQURUSUQZUQZLIUPZHTSRUTZOUTTVAZUQZVBZVRWBVT
        VSWDUQZTLVCZHLVCZWCOUTZVAZVRWAWEVDVRWAWBWDVEVRVSVTWEVFWFVSWDVRVSVTWEVGV
        RWAWBWDVHVIVTWGUQWKTMVCZHMVCZWCOUTZVAZABCDEFGIJKLMNOPQRSUAUBUCUDUEUFUGU
        HUIUJUKULUMUNLMVAZWHWLWJWNTLMVJWPWIWMWCOHLMVJVKVLVRUCVMZEUPWQSQURUSUQUB
        VMZEUPWRSQURUSUQVBVTWGWOABCDEFGWQWRHJKMNOPQRSTUAUDUEUFUGUHUIUKULUMUNVNV
        OVPVQ $.

      $d p q s t x z V $.
      cdlemg2klem.v $e |- V = ( ( P .\/ Q ) ./\ W ) $.
      $( ~ cdleme42keg with simpler hypotheses.  TODO:  FIX COMMENT
         (Contributed by NM, 22-Apr-2013.) $)
      cdlemg2klem $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ F e. T ) -> ( ( F ` P ) .\/ ( F ` Q ) ) = ( ( F ` P ) .\/ V ) ) $=
        ( chlt wcel wa wbr wn cfv co wceq fveq1 oveq12d oveq1d eqeq12d csb wral
        cv crio cif cvv vex eqid cdleme31sc ax-mp cdleme42keg cdlemg2ce 3com23
        wi ) QUQURUAOURUSMJURHEURHUARUTVAUSIEURIUARUTVAUSUSZHMVBZIMVBZPVCZWDTPV
        CZVDZWCWHHNVBZINVBZPVCZWITPVCZVDABCDEFGJKLMNOPQRSUAUBUCUDUEUFUGUHUIUJUK
        ULUMUNUOMNVDZWFWKWGWLWMWDWIWEWJPHMNVEZIMNVEVFWMWDWITPWNVGVHABCDEFDUBVKZ
        GVIZUDVKZUCVKZHIKGNLODVKZUARUTVAWSWQWRPVCZRUTVAUSBVKLVDWBDEVJBFVLZPQRSW
        OWTRUTXAWPVMZWOUARUTVAWOAVKZUASVCZPVCXCVDUSCVKXBXDPVCVDWBUBEVJCFVLZTUAU
        BUEUFUGUHUIUJULWOVNURWPWOKPVCWRWQWOPVCUASVCPVCSVCZVDUBVOVNGWQWRWOKPSUAX
        FDUMXFVPVQVRUMUNXAVPXBVPXEVPUOUPVSVTWA $.
    $}
  $}

  ${
    $d f s t x y z A $.  $d f s t x y z B $.  $d f s t x y z H $.
    $d f s t x y z K $.  $d f s t x y z .<_ $.  $d f s t x y z P $.
    $d f s t x y z Q $.  $d s t x y z R $.  $d f T $.  $d f s t x y z W $.
    $d s t x y z X $.
    cdlemg2id.l $e |- .<_ = ( le ` K ) $.
    cdlemg2id.a $e |- A = ( Atoms ` K ) $.
    cdlemg2id.h $e |- H = ( LHyp ` K ) $.
    cdlemg2id.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemg2id.b $e |- B = ( Base ` K ) $.
    $( Version of ~ cdleme31id with simpler hypotheses.  TODO:  Fix comment.
       (Contributed by NM, 21-Apr-2013.)  (New usage is discouraged.) $)
    cdlemg2idN $p |- ( ( ( ( K e. HL /\ W e. H /\ F e. T )
         /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( F ` P ) = Q /\ X e. B ) /\ P = Q ) -> ( F ` X ) = X ) $=
      ( wcel wbr wceq co vx vs vz vt vy chlt w3a wn wa cfv wne cv cmee cjn wral
      wi crio csb cif cmpt simp111 simp112 simp12 simp13 simp113 eqid cdlemg2dN
      simp2l syl222anc fveq1d simp2r simp3 cdleme31id syl2anc eqtrd ) HUFQZJGQZ
      FEQZUGZCAQCJIRUHUIZDAQDJIRUHUIZUGZCFUJDSZKBQZUIZCDSZUGZKFUJKUABCDUKUAULZJ
      IRUHUIUBULZJIRUHWIWHJHUMUJZTZHUNUJZTWHSUIUCULWICDWLTZIRUDULZJIRUHWNWMIRUH
      UIUEULWMWNWMJWJTZWLTDCWNWLTJWJTWLTWJTZWIWNWLTJWJTWLTWJTZSUPUDAUOUEBUQUDWI
      WPURUSWKWLTSUPUBAUOUCBUQZWHUSUTZUJZKWGKFWSWGVPVQVTWAVRWCFWSSVPVQVRVTWAWEW
      FVAVPVQVRVTWAWEWFVBVSVTWAWEWFVCVSVTWAWEWFVDVPVQVRVTWAWEWFVEWBWCWDWFVHUAUE
      UCUDABWPCDEWOWQFWSGWLHIWJJUBPLWLVFWJVFMNOWOVFWPVFWQVFWSVFZVGVIVJWGWDWFWTK
      SWBWCWDWFVKWBWEWFVLUABCDWSIWRJKXAVMVNVO $.
  $}

  ${
    cdlemg3.l $e |- .<_ = ( le ` K ) $.
    cdlemg3.j $e |- .\/ = ( join ` K ) $.
    cdlemg3.m $e |- ./\ = ( meet ` K ) $.
    cdlemg3.a $e |- A = ( Atoms ` K ) $.
    cdlemg3.h $e |- H = ( LHyp ` K ) $.
    cdlemg3.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Part of proof of Lemma G in [Crawley] p. 116, line 19.  Show p ` \/ ` q
       = p ` \/ ` u.  TODO: reformat ~ cdleme0cp to match this, then replace
       with ~ cdleme0cp .  (Contributed by NM, 19-Apr-2013.) $)
    cdlemg3a $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( P e. A /\ -. P .<_ W )
         /\ Q e. A ) -> ( P .\/ Q ) = ( P .\/ U ) ) $=
      ( chlt wcel wa co wbr wn w3a cdleme8 eqcomd ) GQRJERSBARBJHUAUBSCARUCBDFT
      BCFTADBCEFGHIJKLMNOPUDUE $.
  $}

  ${
    $d p q s t x y z F $.  $d p q s t x y z H $.  $d p q s t x y z K $.
    $d p q s t x y z T $.  $d p q s t x y z W $.  $d p q s t x y z A $.
    $d p q s t x y z .\/ $.  $d p q s t x y z .<_ $.  $d p q s t x y z P $.
    $d p q s t x y z Q $.
    cdlemg2inv.h $e |- H = ( LHyp ` K ) $.
    cdlemg2inv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemg2j.l $e |- .<_ = ( le ` K ) $.
    cdlemg2j.j $e |- .\/ = ( join ` K ) $.
    cdlemg2j.a $e |- A = ( Atoms ` K ) $.
    $( TODO:  Replace this with ~ ltrnj .  (Contributed by NM, 22-Apr-2013.)
       (New usage is discouraged.) $)
    cdlemg2jOLDN $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ F e. T )
              -> ( F ` ( P .\/ Q ) ) = ( ( F ` P ) .\/ ( F ` Q ) ) ) $=
      ( vt cv co wbr eqid vx vy vz vp vq vs cbs cfv cmee wne wn wa wceq wi wral
      crio csb cif cmpt cdlemg2jlemOLDN ) UAUBUCPAHUGUHZPQZUDQZUEQZGRZJHUIUHZRZ
      GRVDVCVBGRJVFRGRVFRZBCDVGVEVHUFQZVBGRJVFRGRVFRZEUAVAVCVDUJUAQZJISUKULVIJI
      SUKVIVKJVFRZGRVKUMULUCQVIVEISVBJISUKVBVEISUKULUBQVJUMUNPAUOUBVAUPPVIVHUQU
      RVLGRUMUNUFAUOUCVAUPVKURUSZFGHIVFJUFUEUDVATMNVFTOKLVGTVHTVJTVMTUT $.

    $d p q s t x y z ./\ $.  $d p q s t x y z B $.  $d p q s t x y z X $.
    cdlemg2j.m $e |- ./\ = ( meet ` K ) $.
    ${
      cdlemg2j.b $e |- B = ( Base ` K ) $.
      $( Value of a translation in terms of an associated atom. ~ cdleme48fvg
         with simpler hypotheses.  TODO:  Use ~ ltrnj to vastly simplify.
         (Contributed by NM, 23-Apr-2013.) $)
      cdlemg2fv $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( ( P e. A /\ -. P .<_ W ) /\ ( X e. B /\ -. X .<_ W ) )
             /\ ( F e. T /\ ( P .\/ ( X ./\ W ) ) = X ) )
         -> ( F ` X ) = ( ( F ` P ) .\/ ( X ./\ W ) ) ) $=
        ( co vx vy vz vt vp vq vs cv wne wbr wn wa wceq wral crio csb cmpt eqid
        wi cif cdlemg2fvlem ) UAUBUCUDABUDUHZUEUHZUFUHZGTZKJTZGTVDVCVBGTKJTGTJT
        ZCDVFVEVGUGUHZVBGTKJTGTJTZEUABVCVDUIUAUHZKIUJUKULVHKIUJUKVHVJKJTZGTVJUM
        ULUCUHVHVEIUJVBKIUJUKVBVEIUJUKULUBUHVIUMUSUDAUNUBBUOUDVHVGUPUTVKGTUMUSU
        GAUNUCBUOVJUTUQZFGHIJKLUGUFUESOPRQMNVFURVGURVIURVLURVA $.
    $}

    $d p q s t x y z U $.
    cdlemg2j.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
    $( Value of a translation in terms of an associated atom.  TODO:  FIX
       COMMENT TODO:  Is this useful elsewhere e.g. around ~ cdlemeg46fjv that
       use more complex proofs?  TODO:  Use ~ ltrnj to vastly simplify.
       (Contributed by NM, 23-Apr-2013.) $)
    cdlemg2fv2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
             /\ ( R e. A /\ -. R .<_ W ) )
       /\ F e. T )
         -> ( F ` ( R .\/ U ) ) = ( ( F ` R ) .\/ U ) ) $=
      ( chlt wcel wa wbr wn w3a cfv cbs wceq simp1 simp23 clat simp1l hllat syl
      co simp23l eqid atbase simp1r simp21l simp22l cdleme0aa syl211anc syl3anc
      latjcl simp23r latlej1 wi lhpbase lattr syl13anc mpand mtod jca simp3 cp0
      lhpmat syl2anc hlatjcl latmle2 syl5eqbr atmod4i2 syl131anc col hlol olj02
      oveq1d 3eqtr3d oveq2d cdlemg2fv syl122anc eqtrd ) JUAUBZMHUBZUCZBAUBZBMKU
      DUEZUCZCAUBZCMKUDUEZUCZDAUBZDMKUDZUEZUCZUFZGEUBZUFZDFIUPZGUGZDGUGZXJMLUPZ
      IUPZXLFIUPXIWPXFXJJUHUGZUBZXJMKUDZUEZUCXHDXMIUPXJUIXKXNUIWPXGXHUJZWPWSXBX
      FXHUKZXIXPXRXIJULUBZDXOUBZFXOUBZXPXIWNYAWNWOXGXHUMZJUNUOZXIXCYBXCXEWSXBWP
      XHUQZAXODJXOURZRUSUOZXIWNWOWQWTYCYDWNWOXGXHUTZWQWRXBXFWPXHVAZWTXAWSXFWPXH
      VBZAXOBCFHIJKLMPQSRNTYGVCVDZXOIJDFYGQVFVEZXIXQXDXCXEWSXBWPXHVGXIDXJKUDZXQ
      XDXIYAYBYCYNYEYHYLXOIJKDFYGPQVHVEXIYAYBXPMXOUBZYNXQUCXDVIYEYHYMXIWOYOYIXO
      HJMYGNVJUOZXOJKDXJMYGPVKVLVMVNVOWPXGXHVPXIXMFDIXIDMLUPZFIUPZJVQUGZFIUPZXM
      FXIYQYSFIXIWPXFYQYSUIXSXTADHJKLMYSPSYSURZRNVRVSWHXIWNXCYCYOFMKUDYRXMUIYDY
      FYLYPXIFBCIUPZMLUPZMKTXIYAUUBXOUBZYOUUCMKUDYEXIWNWQWTUUDYDYJYKAXOIJBCYGQR
      VTVEYPXOJKLUUBMYGPSWAVEWBAXODIJKLFMYGPQSRWCWDXIJWEUBZYCYTFUIXIWNUUEYDJWFU
      OYLXOIJFYSYGQUUAWGVSWIZWJAXODEGHIJKLMXJNOPQRSYGWKWLXIXMFXLIUUFWJWM $.

    $( ~ cdleme42keg with simpler hypotheses.  TODO:  FIX COMMENT Todo: derive
       from ~ cdlemg3a , ~ cdlemg2fv2 , ~ cdlemg2jOLDN , ~ ltrnel ?
       (Contributed by NM, 22-Apr-2013.) $)
    cdlemg2k $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ F e. T ) -> ( ( F ` P ) .\/ ( F ` Q ) ) = ( ( F ` P ) .\/ U ) ) $=
      ( co vx vy vz vt vp vq vs cbs cfv cv wne wbr wn wa wceq wral crio csb cif
      wi cmpt eqid cdlemg2klem ) UAUBUCUDAIUHUIZUDUJZUEUJZUFUJZHTZLKTZHTVGVFVEH
      TLKTHTKTZBCDVIVHVJUGUJZVEHTLKTHTKTZFUAVDVFVGUKUAUJZLJULUMUNVKLJULUMVKVMLK
      TZHTVMUOUNUCUJVKVHJULVELJULUMVEVHJULUMUNUBUJVLUOUTUDAUPUBVDUQUDVKVJURUSVN
      HTUOUTUGAUPUCVDUQVMUSVAZGHIJKELUGUFUEVDVBOPRQMNVIVBVJVBVLVBVOVBSVC $.

    $( ~ cdlemg2k with ` P ` and ` Q ` swapped.  TODO:  FIX COMMENT
       (Contributed by NM, 15-May-2013.) $)
    cdlemg2kq $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ F e. T ) -> ( ( F ` P ) .\/ ( F ` Q ) ) = ( ( F ` Q ) .\/ U ) ) $=
      ( co chlt wcel wa wbr wn w3a wceq simp1 simp2r simp2l simp3 eqid cdlemg2k
      cfv syl121anc simp1l simp2ll ltrnat syl3anc hlatjcom oveq1d syl5eq oveq2d
      simp2rl 3eqtr4d ) IUAUBZLGUBZUCZBAUBZBLJUDUEZUCZCAUBZCLJUDUEZUCZUCZFDUBZU
      FZCFUNZBFUNZHTZVRCBHTZLKTZHTZVSVRHTZVREHTVQVHVNVKVPVTWCUGVHVOVPUHZVHVKVNV
      PUIVHVKVNVPUJVHVOVPUKZACBDWBFGHIJKLMNOPQRWBULUMUOVQVFVSAUBZVRAUBZWDVTUGVF
      VGVOVPUPZVQVHVPVIWGWEWFVIVJVNVHVPUQZABDFGIJLOQMNURUSVQVHVPVLWHWEWFVLVMVKV
      HVPVDZACDFGIJLOQMNURUSAHIVSVRPQUTUSVQEWBVRHVQEBCHTZLKTWBSVQWLWALKVQVFVIVL
      WLWAUGWIWJWKAHIBCPQUTUSVAVBVCVE $.

    $( TODO:  FIX COMMENT (Contributed by NM, 23-Apr-2013.) $)
    cdlemg2l $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
          /\ ( F e. T /\ G e. T ) )
                -> ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) )
                 = ( ( F ` ( G ` P ) ) .\/ U ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wceq cdlemg2k 3adant3l fveq2d cbs simp3l
      simp1 simp3r simp2l ltrnel syl3anc simpld eqid atbase syl ltrnj syl112anc
      simp2r cdlemg2fv2 syl131anc 3eqtr3d ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUD
      UEUCZUCZFDUBZGDUBZUCZUFZBGUGZCGUGZIUHZFUGZVREIUHZFUGZVRFUGZVSFUGIUHZWDEIU
      HZVQVTWBFVJVMVOVTWBUIVNABCDEGHIJKLMNOPQRSTUJUKULVQVJVNVRJUMUGZUBZVSWGUBZW
      AWEUIVJVMVPUOZVJVMVNVOUNZVQVRAUBZWHVQWLVRMKUDUEZVQVJVOVKWLWMUCZWJVJVMVNVO
      UPZVJVKVLVPUQZABDGHJKMPRNOURUSZUTAWGVRJWGVAZRVBVCVQVSAUBZWIVQWSVSMKUDUEZV
      QVJVOVLWSWTUCWJWOVJVKVLVPVFZACDGHJKMPRNOURUSUTAWGVSJWRRVBVCWGDFHIJMVRVSWR
      QNOVDVEVQVJVKVLWNVNWCWFUIWJWPXAWQWKABCVRDEFHIJKLMNOPQRSTVGVHVI $.

    $( TODO:  FIX COMMENT T (Contributed by NM, 25-Apr-2013.) $)
    cdlemg2m $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ F e. T ) -> ( ( ( F ` P ) .\/ ( F ` Q ) ) ./\ W ) = U ) $=
      ( wcel chlt wa wbr wn w3a cfv cdlemg2k oveq1d cp0 wceq simp1 simp3 simp2l
      co eqid ltrnmw syl3anc cbs simp1l ltrnel simpld simp2ll simp2rl cdleme0aa
      simp1r syl211anc lhpbase syl clat hllat hlatjcl latmle2 syl5eqbr atmod4i2
      syl131anc col hlol olj02 syl2anc 3eqtr3d eqtrd ) IUATZLGTZUBZBATZBLJUCUDZ
      UBZCATZCLJUCUDZUBZUBZFDTZUEZBFUFZCFUFHUNZLKUNWNEHUNZLKUNZEWMWOWPLKABCDEFG
      HIJKLMNOPQRSUGUHWMWNLKUNZEHUNZIUIUFZEHUNZWQEWMWRWTEHWMWDWLWGWRWTUJWDWKWLU
      KZWDWKWLULZWDWGWJWLUMZABDFGIJKLWTORWTUOZQMNUPUQUHWMWBWNATZEIURUFZTZLXGTZE
      LJUCWSWQUJWBWCWKWLUSZWMXFWNLJUCUDZWMWDWLWGXFXKUBXBXCXDABDFGIJLOQMNUTUQVAW
      MWBWCWEWHXHXJWBWCWKWLVEZWEWFWJWDWLVBZWHWIWGWDWLVCZAXGBCEGHIJKLOPRQMSXGUOZ
      VDVFZWMWCXIXLXGGILXOMVGVHZWMEBCHUNZLKUNZLJSWMIVITZXRXGTZXIXSLJUCWMWBXTXJI
      VJVHWMWBWEWHYAXJXMXNAXGHIBCXOPQVKUQXQXGIJKXRLXOORVLUQVMAXGWNHIJKELXOOPRQV
      NVOWMIVPTZXHXAEUJWMWBYBXJIVQVHXPXGHIEWTXOPXEVRVSVTWA $.
  $}

  ${
    $d q r A $.  $d q r H $.  $d q r K $.  $d q r .<_ $.  $d q r P $.
    $d q r W $.
    cdlemg5.l $e |- .<_ = ( le ` K ) $.
    cdlemg5.j $e |- .\/ = ( join ` K ) $.
    cdlemg5.a $e |- A = ( Atoms ` K ) $.
    cdlemg5.h $e |- H = ( LHyp ` K ) $.
    $( TODO:  Is there a simpler more direct proof, that could be placed
       earlier e.g. near ~ lhpexle ?  TODO:  The ` .\/ ` hypothesis is unused.
       FIX COMMENT (Contributed by NM, 26-Apr-2013.) $)
    cdlemg5 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W ) )
     -> E. q e. A ( P =/= q /\ -. q .<_ W ) ) $=
      ( vr chlt wcel wa wbr wn cv wrex wne lhpexle adantr co w3a simpll cdlemf1
      simpr simplr syl3anc 3simpa reximi syl rexlimddv ) ENOGCOPZBAOBGFQRPZPZMS
      ZGFQZBHSZUAZUTGFQRZPZHATZMAUOUSMATUPACEFGMIKLUBUCUQURAOUSPZPZVAVBURBUTDUD
      FQZUEZHATZVDVFUOVEUPVIUOUPVEUFUQVEUHUOUPVEUIABURCDEFGHIJKLUGUJVHVCHAVAVBV
      GUKULUMUN $.

    $d r .\/ $.  $d r Q $.
    $( Given two atoms not under the fiducial co-atom ` W ` , there is a
       third.  Lemma B in [Crawley] p. 112.  TODO:  Is there a simpler more
       direct proof, that could be placed earlier e.g. near ~ lhpexle ?  Then
       replace ~ cdlemb2 with it.  This is a more general version of ~ cdlemb2
       without ` P =/= Q ` condition.  (Contributed by NM, 27-Apr-2013.) $)
    cdlemb3 $p |- ( ( ( K e. HL /\ W e. H ) /\
             ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
         -> E. r e. A ( -. r .<_ W /\ -. r .<_ ( P .\/ Q ) ) ) $=
      ( wcel wa wbr wn w3a co wceq chlt cv wne simpl1 simpl2 cdlemg5 syl2anc wb
      ancom eqcom simp2 oveq2d simp11l simp12l hlatjidm eqtr3d breq2d cal hlatl
      wrex syl simp3 atcmp bitr2d syl5bb necon3abid anbi2d 3expa rexbidva mpbid
      syl3anc simpl3 simpr cdlemb2 syl121anc pm2.61dane ) FUANZHDNZOZBANZBHGPQZ
      OZCANCHGPQOZRZIUBZHGPQZWEBCESZGPZQZOZIAUTZBCWDBCTZOZBWEUCZWFOZIAUTZWKWMVS
      WBWPVSWBWCWLUDVSWBWCWLUEABDEFGHIJKLMUFUGWMWOWJIAWDWLWEANZWOWJUHWOWFWNOWDW
      LWQRZWJWNWFUIWRWNWIWFWRWHBWEBWETWEBTZWRWHBWEUJWRWHWEBGPZWSWRWGBWEGWRBBESZ
      WGBWRBCBEWDWLWQUKULWRVQVTXABTVQVRWBWCWLWQUMZVTWAVSWCWLWQUNZAEFBKLUOUGUPUQ
      WRFURNZWQVTWTWSUHWRVQXDXBFUSVAWDWLWQVBXCAWEBFGJLVCVKVDVEVFVGVEVHVIVJWDBCU
      CZOVSWBWCXEWKVSWBWCXEUDVSWBWCXEUEVSWBWCXEVLWDXEVMABCDEFGHIJKLMVNVOVP $.
  $}

  ${
    $d r A $.  $d r F $.  $d r G $.  $d r H $.  $d r .\/ $.  $d r K $.
    $d r .<_ $.  $d r P $.  $d r Q $.  $d r T $.  $d r V $.  $d r W $.
    cdlemg4.l $e |- .<_ = ( le ` K ) $.
    cdlemg4.a $e |- A = ( Atoms ` K ) $.
    cdlemg4.h $e |- H = ( LHyp ` K ) $.
    cdlemg4.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ${
      $d r B $.  $d r X $.
      cdlemg4.b $e |- B = ( Base ` K ) $.
      $( Properties of a translation of an element not under ` W ` .  TODO:
         Fix comment.  Can this be simplified?  Perhaps derived from
         ~ cdleme48bw ?  Done with a *ltrn* theorem?  (Contributed by NM,
         28-Apr-2013.)  (New usage is discouraged.) $)
      cdlemg7fvbwN $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( X e. B /\ -. X .<_ W ) /\ F e. T )
         -> ( ( F ` X ) e. B /\ -. ( F ` X ) .<_ W ) ) $=
        ( vr wcel wa wbr wn syl3anc chlt w3a cv cmee cfv cjn wceq wrex lhpmcvr2
        co 3adant3 simp11 simp2 simp3l simp12 simp13 simp3r cdlemg2fv syl122anc
        eqid jca simp11l hllat syl ltrnel simpld atbase simp12l simp11r lhpbase
        clat latmcl latjcl eqeltrd simprd latlej1 wi lattr syl13anc mtod breq1d
        mpand mtbird rexlimdv3a mpd ) FUAPZHEPZQZIBPZIHGRSZQZDCPZUBZOUCZHGRSZWN
        IHFUDUEZUJZFUFUEZUJIUGZQZOAUHZIDUEZBPZXBHGRZSZQZWHWKXAWLABEWRFGWPHIONJW
        RUTZWPUTZKLUIUKWMWTXFOAWMWNAPZWTUBZXCXEXJXBWNDUEZWQWRUJZBXJWHXIWOQZWKWL
        WSXBXLUGWHWKWLXIWTULZXJXIWOWMXIWTUMWMXIWOWSUNVAZWHWKWLXIWTUOWHWKWLXIWTU
        PZWMXIWOWSUQABWNCDEWRFGWPHILMJXGKXHNURUSZXJFVKPZXKBPZWQBPZXLBPZXJWFXRWF
        WGWKWLXIWTVBFVCVDZXJXKAPZXSXJWHWLXMYCXNXPXOWHWLXMUBZYCXKHGRZSZAWNCDEFGH
        JKLMVEZVFTABXKFNKVGVDZXJXRWIHBPZXTYBWIWJWHWLXIWTVHXJWGYIWFWGWKWLXIWTVIB
        EFHNLVJVDZBFWPIHNXHVLTZBWRFXKWQNXGVMTZVNXJXDXLHGRZXJYMYEXJWHWLXMYFXNXPX
        OYDYCYFYGVOTXJXKXLGRZYMYEXJXRXSXTYNYBYHYKBWRFGXKWQNJXGVPTXJXRXSYAYIYNYM
        QYEVQYBYHYLYJBFGXKXLHNJVRVSWBVTXJXBXLHGXQWAWCVAWDWE $.
    $}

    cdlemg4.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( TODO:  FIX COMMENT If fg(p) = p, then tr f = tr g.  (Contributed by NM,
       23-Apr-2013.) $)
    cdlemg4a $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ F e. T /\ G e. T )
           /\ ( F ` ( G ` P ) ) = P )
         -> ( R ` F ) = ( R ` G ) ) $=
      ( wcel cfv wceq co syl3anc chlt wa wbr wn w3a cjn cmee simp3 oveq2d simp1
      simp1l simp23 simp21 ltrnel simpld simp21l hlatjcom oveq1d simp22 trlval2
      eqid eqtrd 3eqtr4d ) HUAPZJGPZUBZBAPZBJIUCUDZUBZEDPZFDPZUEZBFQZEQZBRZUEZV
      MVNHUFQZSZJHUGQZSZBVMVQSZJVSSZECQZFCQZVPVRWAJVSVPVRVMBVQSZWAVPVNBVMVQVFVL
      VOUHUIVPVDVMAPZVGWEWARVDVEVLVOUKVPVFVKVIWFVFVLVOUJZVFVIVJVKVOULZVFVIVJVKV
      OUMZVFVKVIUEWFVMJIUCUDZABDFGHIJKLMNUNZUOTVGVHVJVKVFVOUPAVQHVMBVQVAZLUQTVB
      URVPVFVJWFWJUBZWCVTRWGVFVIVJVKVOUSVPVFVKVIWMWGWHWIWKTAVMCDEGVQHIVSJKWLVSV
      AZLMNOUTTVPVFVKVIWDWBRWGWHWIABCDFGVQHIVSJKWLWNLMNOUTTVC $.

    cdlemg4.j $e |- .\/ = ( join ` K ) $.
    cdlemg4b.v $e |- V = ( R ` G ) $.
    $( TODO:  FIX COMMENT (Contributed by NM, 24-Apr-2013.) $)
    cdlemg4b1 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W ) /\ G e. T )
     -> ( P .\/ V ) = ( P .\/ ( G ` P ) ) ) $=
      ( wcel co chlt wa wbr w3a cfv cmee wceq eqid trlval2 3com23 syl5eq oveq2d
      wn simp1 simp2 ltrnel simpld cdleme0cp syl12anc eqtrd ) HUASKFSUBZBASBKIU
      CUMUBZEDSZUDZBJGTBBBEUEZGTZKHUFUEZTZGTZVFVDJVHBGVDJECUEZVHRVAVCVBVJVHUGAB
      CDEFGHIVGKLQVGUHZMNOPUIUJUKULVDVAVBVEASZVIVFUGVAVBVCUNVAVBVCUOVAVCVBVLVAV
      CVBUDVLVEKIUCUMABDEFHIKLMNOUPUQUJABVEVHFGHIVGKLQVKMNVHUHURUSUT $.

    $( TODO:  FIX COMMENT (Contributed by NM, 24-Apr-2013.) $)
    cdlemg4b2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W ) /\ G e. T )
  -> ( ( G ` P ) .\/ V ) = ( P .\/ ( G ` P ) ) ) $=
      ( wcel co chlt wa wbr w3a cfv cmee wceq eqid trlval2 3com23 syl5eq oveq2d
      wn simp1 simp2l ltrnel cdleme0cq syl12anc eqtrd ) HUASKFSUBZBASZBKIUCUMZU
      BZEDSZUDZBEUEZJGTVFBVFGTZKHUFUEZTZGTZVGVEJVIVFGVEJECUEZVIRUTVDVCVKVIUGABC
      DEFGHIVHKLQVHUHZMNOPUIUJUKULVEUTVAVFASVFKIUCUMUBZVJVGUGUTVCVDUNUTVAVBVDUO
      UTVDVCVMABDEFHIKLMNOUPUJABVFVIFGHIVHKLQVLMNVIUHUQURUS $.

    $( TODO:  FIX COMMENT (Contributed by NM, 24-Apr-2013.) $)
    cdlemg4b12 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( P e. A /\ -. P .<_ W ) /\ G e. T )
     -> ( ( G ` P ) .\/ V ) = ( P .\/ V ) ) $=
      ( wcel co chlt wa wbr wn w3a cfv cdlemg4b2 cdlemg4b1 eqtr4d ) HUASKFSUBBA
      SBKIUCUDUBEDSUEBEUFZJGTBUJGTBJGTABCDEFGHIJKLMNOPQRUGABCDEFGHIJKLMNOPQRUHU
      I $.

    $( TODO:  FIX COMMENT (Contributed by NM, 24-Apr-2013.) $)
    cdlemg4c $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ G e. T )
    /\ -. Q .<_ ( P .\/ V ) ) -> -. ( G ` Q ) .<_ ( P .\/ V ) ) $=
      ( wcel chlt wa wbr wn w3a co cfv simpll simplr2 simplr3 cdlemg4b2 syl3anc
      wceq simpr clat cbs hllat simpr1l eqid atbase simpl simpr3 trlcl syl5eqel
      syl syl2anc latlej2 adantr wb simpr2l latjle12 syl13anc mpbi2and eqbrtrrd
      ltrncl latjcl mpbird simpld ex con3d 3impia ) IUATZLGTZUBZBATZBLJUCUDZUBZ
      CATZCLJUCUDZUBZFETZUEZCBKHUFZJUCZUDCFUGZWMJUCZUDWDWLUBZWPWNWQWPWNWQWPUBZW
      NWPWRWNWPUBZCWOHUFZWMJUCZWRWOKHUFZWTWMJWRWDWJWKXBWTUMWDWLWPUHZWGWJWKWDWPU
      IWGWJWKWDWPUJZACDEFGHIJKLMNOPQRSUKULWRWPKWMJUCZXBWMJUCZWQWPUNWQXEWPWQIUOT
      ZBIUPUGZTZKXHTZXEWQWBXGWBWCWLUHIUQVEZWQWEXIWEWFWJWKWDURAXHBIXHUSZNUTVEZWQ
      KFDUGZXHSWQWDWKXNXHTZWDWLVAZWDWGWJWKVBZXHDEFGILXLOPQVCZVFVDZXHHIJBKXLMRVG
      ULVHWQWPXEUBXFVIZWPWQXGWOXHTZXJWMXHTZXTXKWQWDWKCXHTZYAXPXQWQWHYCWHWIWGWKW
      DVJAXHCIXLNUTVEZXHEFGIUALCXLOPVOULZXSWQXGXIXJYBXKXMXSXHHIBKXLRVPZULXHHIJW
      OKWMXLMRVKVLVHVMVNWRXGYCYAYBWSXAVIWQXGWPXKVHZWQYCWPYDVHWQYAWPYEVHWRXGXIXJ
      YBYGWQXIWPXMVHWRKXNXHSWRWDWKXOXCXDXRVFVDYFULXHHIJCWOWMXLMRVKVLVQVRVSVTWA
      $.

    $( TODO:  FIX COMMENT (Contributed by NM, 25-Apr-2013.) $)
    cdlemg4d $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> -. ( G ` Q ) .<_ ( ( G ` P ) .\/ ( F ` ( G ` P ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a co cfv wceq simp1 simp21 simp22 simp31 cdlemg4c
      simp32 syl131anc simp1l simp21l ltrnel simpld hlatjcom cdlemg4b1 3eqtr4rd
      syl3anc simp33 oveq2d breq2d mtbird ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZCAUBC
      MKUDUEUCZFEUBZUFZGEUBZCBLIUGZKUDUEZBGUHZFUHZBUIZUFZUFZCGUHZWAWBIUGZKUDWFV
      SKUDZWEVKVNVOVRVTWHUEVKVQWDUJZVKVNVOVPWDUKZVKVNVOVPWDULVKVQVRVTWCUMZVKVQV
      RVTWCUOABCDEGHIJKLMNOPQRSTUNUPWEWGVSWFKWEBWAIUGZWABIUGZVSWGWEVIVLWAAUBZWL
      WMUIVIVJVQWDUQVLVMVOVPVKWDURWEVKVRVNWNWIWKWJVKVRVNUFWNWAMKUDUEABEGHJKMNOP
      QUSUTVDAIJBWASOVAVDWEVKVNVRVSWLUIWIWJWKABDEGHIJKLMNOPQRSTVBVDWEWBBWAIVKVQ
      VRVTWCVEVFVCVGVH $.

    ${
      cdlemg4.m $e |- ./\ = ( meet ` K ) $.
      $( TODO:  FIX COMMENT (Contributed by NM, 25-Apr-2013.) $)
      cdlemg4e $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
  -> ( F ` ( G ` Q ) ) = ( ( ( G ` Q ) .\/ ( R ` F ) )
    ./\ ( ( F ` ( G ` P ) )
         .\/ ( ( ( G ` P ) .\/ ( G ` Q ) ) ./\ W ) ) ) ) $=
        ( chlt wcel wa wbr wn w3a co cfv wceq simp1 simp23 simp31 simp21 ltrnel
        syl3anc simp22 cdlemg4d cdlemc syl131anc ) JUCUDNHUDUEZBAUDBNKUFUGUEZCA
        UDCNKUFUGUEZFEUDZUHZGEUDZCBMIUIKUFUGZBGUJZFUJZBUKZUHZUHZVBVEVIAUDVINKUF
        UGUEZCGUJZAUDVONKUFUGUEZVOVIVJIUIKUFUGVOFUJVOFDUJIUIVJVIVOIUINLUIIUILUI
        UKVBVFVLULZVBVCVDVEVLUMVMVBVGVCVNVQVBVFVGVHVKUNZVBVCVDVEVLUOABEGHJKNOPQ
        RUPUQVMVBVGVDVPVQVRVBVCVDVEVLURACEGHJKNOPQRUPUQABCDEFGHIJKMNOPQRSTUAUSA
        VIVODEFHIJKLNOTUBPQRSUTVA $.

      $( TODO:  FIX COMMENT (Contributed by NM, 25-Apr-2013.) $)
      cdlemg4f $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` Q ) )
         = ( ( Q .\/ V ) ./\ ( P .\/ ( ( P .\/ Q ) ./\ W ) ) ) ) $=
        ( chlt wcel wa wbr wn w3a cfv wceq cdlemg4e simp21 simp23 simp31 simp33
        simp1 cdlemg4a syl131anc syl6reqr oveq2d simp22 cdlemg4b12 syl3anc eqid
        co eqtr3d cdlemg2m syl121anc oveq12d eqtrd ) JUCUDNHUDUEZBAUDBNKUFUGUEZ
        CAUDCNKUFUGUEZFEUDZUHZGEUDZCBMIVEKUFUGZBGUIZFUIZBUJZUHZUHZCGUIZFUIWCFDU
        IZIVEZVSVRWCIVENLVEZIVEZLVECMIVEZBBCIVENLVEZIVEZLVEABCDEFGHIJKLMNOPQRST
        UAUBUKWBWEWHWGWJLWBWCMIVEZWEWHWBMWDWCIWBWDGDUIZMWBVKVLVNVPVTWDWLUJVKVOW
        AUPZVKVLVMVNWAULZVKVLVMVNWAUMVKVOVPVQVTUNZVKVOVPVQVTUOZABDEFGHJKNOPQRSU
        QURUAUSUTWBVKVMVPWKWHUJWMVKVLVMVNWAVAZWOACDEGHIJKMNOPQRSTUAVBVCVFWBVSBW
        FWIIWPWBVKVLVMVPWFWIUJWMWNWQWOABCEWIGHIJKLNQROTPUBWIVDVGVHVIVIVJ $.

      $( TODO:  FIX COMMENT (Contributed by NM, 25-Apr-2013.) $)
      cdlemg4g $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` Q ) ) = ( ( Q .\/ V ) ./\ ( P .\/ Q ) ) ) $=
        ( chlt wcel wa wbr wn w3a co wceq cdlemg4f simp1l simp1r simp21 simp22l
        cfv eqid cdleme0cp syl22anc oveq2d eqtrd ) JUCUDZNHUDZUEZBAUDBNKUFUGUEZ
        CAUDZCNKUFUGZUEZFEUDZUHZGEUDCBMIUIKUFUGBGUPFUPBUJUHZUHZCGUPFUPCMIUIZBBC
        IUIZNLUIZIUIZLUIVMVNLUIABCDEFGHIJKLMNOPQRSTUAUBUKVLVPVNVMLVLVBVCVEVFVPV
        NUJVBVCVJVKULVBVCVJVKUMVDVEVHVIVKUNVFVGVEVIVDVKUOABCVOHIJKLNOTUBPQVOUQU
        RUSUTVA $.
    $}
    $( TODO:  FIX COMMENT (Contributed by NM, 25-Apr-2013.) $)
    cdlemg4 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` Q ) ) = Q ) $=
      ( chlt wcel wa wbr w3a cfv wceq cmee eqid cdlemg4g simp1l simp21l simp22l
      wn hlatjcom syl3anc oveq2d cbs simp1 simp31 trlcl syl2anc syl5eqel simp32
      co wi simp21r simp21 trlval2 syl5eq clat syl ltrnel simpld hlatjcl simp1r
      hllat lhpbase latmle2 eqbrtrd atbase lattr syl13anc mpan2d mtod syl131anc
      hlexch2 2llnma1b 3eqtrd ) JUAUBZMHUBZUCZBAUBZBMKUDZUNZUCZCAUBZCMKUDUNZUCZ
      FEUBZUEZGEUBZCBLIVEKUDZUNZBGUFZFUFBUGZUEZUEZCGUFFUFCLIVEZBCIVEZJUHUFZVEXI
      CBIVEZXKVEZCABCDEFGHIJKXKLMNOPQRSTXKUIZUJXHXJXLXIXKXHWJWMWQXJXLUGWJWKXAXG
      UKZWMWOWSWTWLXGULZWQWRWPWTWLXGUMZAIJBCSOUOUPUQXHWJLJURUFZUBZWQWMBXIKUDZUN
      XMCUGXOXHLGDUFZXRTXHWLXBYAXRUBWLXAXGUSZWLXAXBXDXFUTZXRDEGHJMXRUIZPQRVAVBV
      CZXQXPXHXTXCWLXAXBXDXFVDXHWJWMWQXSBLKUDZUNXTXCVFXOXPXQYEXHYFWNWMWOWSWTWLX
      GVGXHYFLMKUDZWNXHLBXEIVEZMXKVEZMKXHLYAYITXHWLXBWPYAYIUGYBYCWLWPWSWTXGVHZA
      BDEGHIJKXKMNSXNOPQRVIUPVJXHJVKUBZYHXRUBZMXRUBZYIMKUDXHWJYKXOJVQVLZXHWJWMX
      EAUBZYLXOXPXHYOXEMKUDUNZXHWLXBWPYOYPUCYBYCYJABEGHJKMNOPQVMUPVNAXRIJBXEYDS
      OVOUPXHWKYMWJWKXAXGVPXRHJMYDPVRVLZXRJKXKYHMYDNXNVSUPVTXHYKBXRUBZXSYMYFYGU
      CWNVFYNXHWMYRXPAXRBJYDOWAVLYEYQXRJKBLMYDNWBWCWDWEAXRBCIJKLYDNSOWGWFWEAXRC
      BIJKXKLYDNSXNOWHWFWI $.

    $( TODO:  FIX COMMENT TODO: replace with ~ cdlemg4 .  (Contributed by NM,
       27-Apr-2013.) $)
    cdlemg6a $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( r e. A /\ -. r .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. r .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` r ) ) = r ) $=
      ( cv cdlemg4 ) ABMUACDEFGHIJKLNOPQRSTUB $.

    $( TODO:  FIX COMMENT TODO: replace with ~ cdlemg4 .  (Contributed by NM,
       27-Apr-2013.) $)
    cdlemg6b $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( r e. A /\ -. r .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ -. Q .<_ ( r .\/ V ) /\ ( F ` ( G ` r ) ) = r ) )
    -> ( F ` ( G ` Q ) ) = Q ) $=
      ( cv cdlemg4 ) AMUABCDEFGHIJKLNOPQRSTUB $.

    $( TODO:  FIX COMMENT (Contributed by NM, 27-Apr-2013.) $)
    cdlemg6c $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( ( ( r e. A /\ -. r .<_ W ) /\ -. r .<_ ( P .\/ V ) )
        -> ( F ` ( G ` Q ) ) = Q ) ) $=
      ( chlt wcel wa wbr wn w3a co cfv cv simpl1 simprl simpl22 simpl23 simpl31
      wceq simprr wi simpl1l simp22l adantr simprll eqid trlcl syl2anc syl5eqel
      cbs simp22r trlle syl5eqbr clat simp1l syl atbase simp1r lhpbase syl13anc
      hllat lattr mpan2d mtod hlexch2 syl131anc simpl32 simp21l latlej2 syl3anc
      latjcl latjle12 mpbi2and syld simpl21 simpl33 cdlemg6a syl133anc cdlemg6b
      wb ex ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEZUFZUDZFEUCZUGZGEUCZCBLIU
      HZKUEZBGUIFUIBUPZUGZUGZNUJZAUCZXQMKUEUFZUDZXQXLKUEZUFZUDZCGUIFUICUPZXPYCU
      DZXAXTXHXIXKCXQLIUHKUEZUFXQGUIFUIXQUPZYDXAXJXOYCUKZXPXTYBULZXDXHXIXAXOYCU
      MXDXHXIXAXOYCUNZXKXMXNXAXJYCUOZYEYFYAXPXTYBUQZYEYFXQCLIUHZKUEZYAYEWSXEXRL
      JVGUIZUCZCLKUEZUFYFYNURWSWTXJXOYCUSXPXEYCXEXGXDXIXAXOUTZVAXPXRXSYBVBZYELG
      DUIZYOUAYEXAXKYTYOUCYHYKYODEGHJMYOVCZQRSVDVEVFZYEYQXFXPXGYCXEXGXDXIXAXOVH
      VAYEYQLMKUEZXFYELYTMKUAYEXAXKYTMKUEYHYKDEGHJKMOQRSVIVEVJYEJVKUCZCYOUCZYPM
      YOUCZYQUUCUDXFURXPUUDYCXPWSUUDWSWTXJXOVLJVRVMVAZXPUUEYCXPXEUUEYRAYOCJUUAP
      VNVMVAZUUBXPUUFYCXPWTUUFWSWTXJXOVOYOHJMUUAQVPVMVAYOJKCLMUUAOVSVQVTWAAYOCX
      QIJKLUUAOTPWBWCYEYNYMXLKUEZYAYEXMLXLKUEZUUIXKXMXNXAXJYCWDYEUUDBYOUCZYPUUJ
      UUGYEXBUUKXPXBYCXBXCXHXIXAXOWEVAAYOBJUUAPVNVMZUUBYOIJKBLUUAOTWFWGYEUUDUUE
      YPXLYOUCZXMUUJUDUUIWQUUGUUHUUBYEUUDUUKYPUUMUUGUULUUBYOIJBLUUATWHWGZYOIJKC
      LXLUUAOTWIVQWJYEUUDXQYOUCZYMYOUCZUUMYNUUIUDYAURUUGYEXRUUOYSAYOXQJUUAPVNVM
      YEUUDUUEYPUUPUUGUUHUUBYOIJCLUUATWHWGUUNYOJKXQYMXLUUAOVSVQVTWKWAYEXAXDXTXI
      XKYBXNYGYHXDXHXIXAXOYCWLYIYJYKYLXKXMXNXAXJYCWMABDEFGHIJKLMNOPQRSTUAWNWOAC
      DEFGHIJKLMNOPQRSTUAWPWOWR $.

    $( TODO:  FIX COMMENT (Contributed by NM, 27-Apr-2013.) $)
    cdlemg6d $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( ( ( r e. A /\ -. r .<_ W ) /\ -. r .<_ ( P .\/ ( G ` P ) ) )
        -> ( F ` ( G ` Q ) ) = Q ) ) $=
      ( chlt wcel wa wbr wn w3a co cfv cv simp1 simp21 simp31 cdlemg4b1 syl3anc
      wceq breq2d notbid anbi2d cdlemg6c sylbird ) JUBUCMHUCUDZBAUCBMKUEUFUDZCA
      UCCMKUEUFUDZFEUCZUGZGEUCZCBLIUHZKUEZBGUIZFUIBUPZUGZUGZNUJZAUCVNMKUEUFUDZV
      NBVJIUHZKUEZUFZUDVOVNVHKUEZUFZUDCGUIFUICUPVMVTVRVOVMVSVQVMVHVPVNKVMVBVCVG
      VHVPUPVBVFVLUKVBVCVDVEVLULVBVFVGVIVKUMABDEGHIJKLMOPQRSTUAUNUOUQURUSABCDEF
      GHIJKLMNOPQRSTUAUTVA $.

    $( TODO:  FIX COMMENT (Contributed by NM, 27-Apr-2013.) $)
    cdlemg6e $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ Q .<_ ( P .\/ V ) /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` Q ) ) = Q ) $=
      ( vr chlt wcel wa wbr wn w3a co cfv wceq wrex simp1 simp21 simp31 syl3anc
      cv ltrnel cdlemb3 cdlemg6d exp4c imp4a rexlimdv mpd ) JUBUCMHUCUDZBAUCBMK
      UEUFUDZCAUCCMKUEUFUDZFEUCZUGZGEUCZCBLIUHKUEZBGUIZFUIBUJZUGZUGZUAUPZMKUEUF
      ZVOBVKIUHKUEUFZUDZUAAUKZCGUIFUICUJZVNVDVEVKAUCVKMKUEUFUDZVSVDVHVMULZVDVEV
      FVGVMUMZVNVDVIVEWAWBVDVHVIVJVLUNWCABEGHJKMNOPQUQUOABVKHIJKMUANSOPURUOVNVR
      VTUAAVNVOAUCZVPVQVTVNWDVPVQVTABCDEFGHIJKLMUANOPQRSTUSUTVAVBVC $.
  $}

  ${
    cdlemg6.l $e |- .<_ = ( le ` K ) $.
    cdlemg6.a $e |- A = ( Atoms ` K ) $.
    cdlemg6.h $e |- H = ( LHyp ` K ) $.
    cdlemg6.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( TODO:  FIX COMMENT (Contributed by NM, 27-Apr-2013.) $)
    cdlemg6 $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( F e. T /\ G e. T /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` Q ) ) = Q ) $=
      ( wcel wa wbr wn cfv eqid chlt wceq w3a co simpl1 simpl2l simpl2r simpl31
      ctrl cjn simpl32 simpr simpl33 cdlemg6e syl133anc cdlemg4 pm2.61dan ) HUA
      OJGOPZBAOBJIQRPZCAOCJIQRPZPZEDOZFDOZBFSESBUBZUCZUCZCBFJHUISSZSZHUJSZUDIQZ
      CFSESCUBZVFVJPURUSUTVBVCVJVDVKURVAVEVJUEUSUTURVEVJUFUSUTURVEVJUGVBVCVDURV
      AVJUHVBVCVDURVAVJUKVFVJULVBVCVDURVAVJUMABCVGDEFGVIHIVHJKLMNVGTZVITZVHTZUN
      UOVFVJRZPURUSUTVBVCVOVDVKURVAVEVOUEUSUTURVEVOUFUSUTURVEVOUGVBVCVDURVAVOUH
      VBVCVDURVAVOUKVFVOULVBVCVDURVAVOUMABCVGDEFGVIHIVHJKLMNVLVMVNUPUOUQ $.
  $}

  ${
    cdlemg7fv.b $e |- B = ( Base ` K ) $.
    cdlemg7fv.l $e |- .<_ = ( le ` K ) $.
    cdlemg7fv.j $e |- .\/ = ( join ` K ) $.
    cdlemg7fv.m $e |- ./\ = ( meet ` K ) $.
    cdlemg7fv.a $e |- A = ( Atoms ` K ) $.
    cdlemg7fv.h $e |- H = ( LHyp ` K ) $.
    cdlemg7fv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Value of a translation composition in terms of an associated atom.
       (Contributed by NM, 28-Apr-2013.)  (New usage is discouraged.) $)
    cdlemg7fvN $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( X e. B /\ -. X .<_ W ) )
       /\ ( F e. T /\ G e. T /\ ( P .\/ ( X ./\ W ) ) = X ) )
       -> ( F ` ( G ` X ) ) = ( ( F ` ( G ` P ) ) .\/ ( X ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn co wceq w3a cfv simp32 simp2l ltrnel syl3anc simp2r
      simp1 cdlemg7fvbwN simp31 simp33 cdlemg2fv syl122anc oveq1d simp2rl eqtrd
      lhpelim oveq2d eqtr4d ) IUAUBLGUBUCZCAUBCLJUDUEUCZMBUBZMLJUDUEZUCZUCZEDUB
      ZFDUBZCMLKUFZHUFMUGZUHZUHZMFUIZEUIZCFUIZEUIZVSLKUFZHUFZWBVOHUFVRVGWAAUBWA
      LJUDUEUCZVSBUBVSLJUDUEUCZVMWAWCHUFZVSUGVTWDUGVGVLVQUOZVRVGVNVHWEWHVGVLVMV
      NVPUJZVGVHVKVQUKZACDFGIJLORSTULUMZVRVGVKVNWFWHVGVHVKVQUNZWIABDFGIJLMORSTN
      UPUMVGVLVMVNVPUQVRWGWAVOHUFZVSVRWCVOWAHVRWCWMLKUFZVOVRVSWMLKVRVGVHVKVNVPV
      SWMUGWHWJWLWIVGVLVMVNVPURABCDFGHIJKLMSTOPRQNUSUTZVAVRVGWEVIWNVOUGWHWKVIVJ
      VHVGVQVBABWAGHIJKLMNOPQRSVDUMVCZVEWOVFABWADEGHIJKLVSSTOPRQNUSUTVRWCVOWBHW
      PVEVC $.
  $}

  ${
    $d r A $.  $d r B $.  $d r F $.  $d r G $.  $d r H $.  $d r K $.
    $d r .<_ $.  $d r P $.  $d r T $.  $d r W $.  $d r X $.
    cdlemg7.b $e |- B = ( Base ` K ) $.
    cdlemg7.l $e |- .<_ = ( le ` K ) $.
    cdlemg7.a $e |- A = ( Atoms ` K ) $.
    cdlemg7.h $e |- H = ( LHyp ` K ) $.
    cdlemg7.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( TODO:  FIX COMMENT (Contributed by NM, 28-Apr-2013.)
       (New usage is discouraged.) $)
    cdlemg7aN $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( X e. B /\ -. X .<_ W ) )
       /\ ( F e. T /\ G e. T /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` X ) ) = X ) $=
      ( wcel wa cfv wceq vr chlt wbr wn w3a cv cmee co cjn simp1l simp1r simp2r
      wrex lhpmcvr2 syl21anc simp11 simp2 simp3l simp12r simp131 simp132 simp3r
      jca cdlemg7fvN syl123anc simp12l simp133 cdlemg6 oveq1d 3eqtrd rexlimdv3a
      eqid mpd ) HUBQZJGQZRZCAQCJIUCUDRZKBQKJIUCUDRZRZEDQZFDQZCFSESCTZUEZUEZUAU
      FZJIUCUDZWEKJHUGSZUHZHUISZUHZKTZRZUAAUMZKFSESZKTZWDVNVOVRWMVNVOVSWCUJVNVO
      VSWCUKVPVQVRWCULABGWIHIWGJKUALMWIVLZWGVLZNOUNUOWDWLWOUAAWDWEAQZWLUEZWNWEF
      SESZWHWIUHZWJKWSVPWRWFRZVRVTWAWKWNXATVPVSWCWRWLUPZWSWRWFWDWRWLUQWDWRWFWKU
      RVCZVQVRVPWCWRWLUSVTWAWBVPVSWRWLUTZVTWAWBVPVSWRWLVAZWDWRWFWKVBZABWEDEFGWI
      HIWGJKLMWPWQNOPVDVEWSWTWEWHWIWSVPVQXBVTWAWBWTWETXCVQVRVPWCWRWLVFXDXEXFVTW
      AWBVPVSWRWLVGACWEDEFGHIJMNOPVHVEVIXGVJVKVM $.

    $( TODO:  FIX COMMENT (Contributed by NM, 28-Apr-2013.)
       (New usage is discouraged.) $)
    cdlemg7N $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ X e. B )
       /\ ( F e. T /\ G e. T /\ ( F ` ( G ` P ) ) = P ) )
    -> ( F ` ( G ` X ) ) = X ) $=
      ( chlt wcel wa cfv wbr wn wceq w3a simpl1 simpl31 simpl32 simpl2r syl3anc
      ltrncl simpr ltrnval1 syl112anc eqbrtrd eqtrd simpl2l cdlemg7aN syl123anc
      jca simpl33 pm2.61dan ) HQRJGRSZCARCJIUAUBSZKBRZSZEDRZFDRZCFTETCUCZUDZUDZ
      KJIUAZKFTZETZKUCZVJVKSZVMVLKVOVBVFVLBRZVLJIUAVMVLUCVBVEVIVKUEZVFVGVHVBVEV
      KUFVOVBVGVDVPVQVFVGVHVBVEVKUGZVCVDVBVIVKUHZBDFGHQJKLOPUJUIVOVLKJIVOVBVGVD
      VKVLKUCVQVRVSVJVKUKZBDFGHIQJKLMOPULUMZVTUNBDEGHIQJVLLMOPULUMWAUOVJVKUBZSZ
      VBVCVDWBSVFVGVHVNVBVEVIWBUEVCVDVBVIWBUPWCVDWBVCVDVBVIWBUHVJWBUKUSVFVGVHVB
      VEWBUFVFVGVHVBVEWBUGVFVGVHVBVEWBUTABCDEFGHIJKLMNOPUQURVA $.
  $}

  ${
    cdlemg8.l $e |- .<_ = ( le ` K ) $.
    cdlemg8.j $e |- .\/ = ( join ` K ) $.
    cdlemg8.m $e |- ./\ = ( meet ` K ) $.
    cdlemg8.a $e |- A = ( Atoms ` K ) $.
    cdlemg8.h $e |- H = ( LHyp ` K ) $.
    cdlemg8.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( TODO:  FIX COMMENT (Contributed by NM, 29-Apr-2013.) $)
    cdlemg8a $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( F e. T /\ G e. T /\ ( F ` ( G ` P ) ) = P ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( wcel co chlt wa wbr wn cfv wceq w3a simp1 simp2r lhpmat syl2anc cdlemg6
      eqid oveq2d simp1l simp2rl hlatjidm oveq1d simp33 simp2ll simp2l 3eqtr4rd
      cp0 eqtrd ) IUASZLGSZUBZBASZBLJUCUDZUBZCASZCLJUCUDZUBZUBZEDSZFDSZBFUEEUEZ
      BUFZUGZUGZCLKTZIVCUEZCCFUEEUEZHTZLKTBVQHTZLKTZVTVGVMWAWBUFVGVNVSUHZVGVJVM
      VSUIACGIJKLWBMOWBUMZPQUJUKVTWDCLKVTWDCCHTZCVTWCCCHABCDEFGIJLMPQRULUNVTVEV
      KWICUFVEVFVNVSUOZVKVLVJVGVSUPAHICNPUQUKVDURVTWFBLKTZWBVTWEBLKVTWEBBHTZBVT
      VQBBHVGVNVOVPVRUSUNVTVEVHWLBUFWJVHVIVMVGVSUTAHIBNPUQUKVDURVTVGVJWKWBUFWGV
      GVJVMVSVAABGIJKLWBMOWHPQUJUKVDVB $.

    $( TODO:  FIX COMMENT (Contributed by NM, 29-Apr-2013.) $)
    cdlemg8b $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) = ( P .\/ Q )
               /\ ( F ` ( G ` P ) ) =/= P ) )
    -> ( P .\/ ( F ` ( G ` P ) ) ) = ( P .\/ Q ) ) $=
      ( wcel wbr chlt wa wn w3a cfv wceq wne clat cbs simp1l hllat simp21l eqid
      co atbase simp22l latlej1 simp1 simp23 simp31 simp21 ltrnel simpld ltrncl
      syl syl3anc simp32 breqtrd hlatjcl latjle12 syl13anc mpbi2and simp33 ps-1
      wb necomd syl132anc mpbid ) IUASZLGSZUBZBASZBLJTUCZUBZCASZCLJTUCZUBZEDSZU
      DZFDSZBFUEZEUEZCFUEZEUEZHUNZBCHUNZUFZWLBUGZUDZUDZBWLHUNZWPJTZXAWPUFZWTBWP
      JTZWLWPJTZXBWTIUHSZBIUIUEZSZCXGSZXDWTVSXFVSVTWIWSUJZIUKVEZWTWBXHWBWCWGWHW
      AWSULZAXGBIXGUMZPUOVEZWTWEXIWEWFWDWHWAWSUPZAXGCIXMPUOVEZXGHIJBCXMMNUQVFWT
      WLWOWPJWTXFWLXGSZWNXGSZWLWOJTXKWTWLASZXQWTWAWHWKASWKLJTUCUBZXSWAWIWSURZWA
      WDWGWHWSUSZWTWAWJWDXTYAWAWIWJWQWRUTZWAWDWGWHWSVAABDFGIJLMPQRVBVFWAWHXTUDX
      SWLLJTUCAWKDEGIJLMPQRVBVCVFZAXGWLIXMPUOVEZWTWAWHWMXGSZXRYAYBWTWAWJXIYFYAY
      CXPXGDFGIUALCXMQRVDVFXGDEGIUALWMXMQRVDVFXGHIJWLWNXMMNUQVFWAWIWJWQWRVGVHWT
      XFXHXQWPXGSZXDXEUBXBVOXKXNYEWTVSWBWEYGXJXLXOAXGHIBCXMNPVIVFXGHIJBWLWPXMMN
      VJVKVLWTVSWBXSBWLUGWBWEXBXCVOXJXLYDWTWLBWAWIWJWQWRVMVPXLXOABWLBCHIJMNPVNV
      QVR $.

    $( TODO:  FIX COMMENT (Contributed by NM, 29-Apr-2013.) $)
    cdlemg8c $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) = ( P .\/ Q )
               /\ ( F ` ( G ` P ) ) =/= P ) )
    -> ( Q .\/ ( F ` ( G ` Q ) ) ) = ( P .\/ Q ) ) $=
      ( wcel wceq chlt wa wbr wn w3a cfv wne simp22 simp21 simp23 simp31 simp32
      simp1 simp1l ltrnel syl3anc simpld hlatjcom simp21l simp22l simp33 simpl1
      co 3eqtr3d simpl22 simpl21 simpl23 simpl31 simpr cdlemg6 syl123anc ex mpd
      necon3d cdlemg8b syl133anc eqtr4d ) IUASZLGSZUBZBASZBLJUCUDZUBZCASZCLJUCU
      DZUBZEDSZUEZFDSZBFUFZEUFZCFUFZEUFZHVCZBCHVCZTZWKBUGZUEZUEZCWMHVCZCBHVCZWO
      WSVTWFWCWGWIWMWKHVCZXATWMCUGZWTXATVTWHWRUMZVTWCWFWGWRUHZVTWCWFWGWRUIZVTWC
      WFWGWRUJZVTWHWIWPWQUKZWSWNWOXBXAVTWHWIWPWQULWSVRWKASZWMASZWNXBTVRVSWHWRUN
      ZWSVTWGWJASWJLJUCUDUBZXIXDXGWSVTWIWCXLXDXHXFABDFGIJLMPQRUOUPVTWGXLUEXIWKL
      JUCUDAWJDEGIJLMPQRUOUQUPWSVTWGWLASWLLJUCUDUBZXJXDXGWSVTWIWFXMXDXHXEACDFGI
      JLMPQRUOUPVTWGXMUEXJWMLJUCUDAWLDEGIJLMPQRUOUQUPAHIWKWMNPURUPWSVRWAWDWOXAT
      XKWAWBWFWGVTWRUSWDWEWCWGVTWRUTAHIBCNPURUPZVDWSWQXCVTWHWIWPWQVAWSWMCWKBWSW
      MCTZWKBTZWSXOUBVTWFWCWGWIXOXPVTWHWRXOVBWCWFWGVTWRXOVEWCWFWGVTWRXOVFWCWFWG
      VTWRXOVGWIWPWQVTWHXOVHWSXOVIACBDEFGIJLMPQRVJVKVLVNVMACBDEFGHIJKLMNOPQRVOV
      PXNVQ $.

    $( TODO:  FIX COMMENT (Contributed by NM, 29-Apr-2013.) $)
    cdlemg8d $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) = ( P .\/ Q )
               /\ ( F ` ( G ` P ) ) =/= P ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( wcel cfv chlt wa wbr wn w3a co wceq wne cdlemg8b cdlemg8c eqtr4d oveq1d
      ) IUASLGSUBBASBLJUCUDUBCASCLJUCUDUBEDSUEFDSBFTETZCFTETZHUFBCHUFZUGUMBUHUE
      UEZBUMHUFZCUNHUFZLKUPUQUOURABCDEFGHIJKLMNOPQRUIABCDEFGHIJKLMNOPQRUJUKUL
      $.

    $( TODO:  FIX COMMENT (Contributed by NM, 29-Apr-2013.) $)
    cdlemg8 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) = ( P .\/ Q ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( wcel wa chlt wbr wn w3a cfv wceq simpl1 simpl21 simpl22 simpl23 simpl3l
      simpr cdlemg8a syl123anc wne simpl2 simpl3r cdlemg8d syl113anc pm2.61dane
      co ) IUASLGSTZBASBLJUBUCTZCASCLJUBUCTZEDSZUDZFDSZBFUEEUEZCFUEEUEZHVABCHVA
      UFZTZUDZBVHHVALKVACVIHVALKVAUFZVHBVLVHBUFZTVBVCVDVEVGVNVMVBVFVKVNUGVCVDVE
      VBVKVNUHVCVDVEVBVKVNUIVCVDVEVBVKVNUJVGVJVBVFVNUKVLVNULABCDEFGHIJKLMNOPQRU
      MUNVLVHBUOZTVBVFVGVJVOVMVBVFVKVOUGVBVFVKVOUPVGVJVBVFVOUKVGVJVBVFVOUQVLVOU
      LABCDEFGHIJKLMNOPQRURUSUT $.

    ${
      cdlemg9.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( TODO:  FIX COMMENT (Contributed by NM, 1-May-2013.) $)
      cdlemg9a $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
            /\ F e. T )
         /\ ( G e. T /\ P =/= Q
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
    -> ( ( P .\/ U ) ./\ ( ( F ` ( G ` P ) ) .\/ U ) )
       .<_ ( ( G ` P ) .\/ U ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv co simp1l simp21l simp1 simp23 simp31
        wceq ltrncoat syl121anc simp1r simp21 simp22l simp32 cdleme0a syl212anc
        simp33 cdlemg2l syl122anc cdlemg3a syl211anc 3netr3d 2llnma3r syl131anc
        simp22 necomd ltrnat syl3anc hlatlej2 eqbrtrd ) JUAUBZMHUBZUCZBAUBZBMKU
        DUEZUCZCAUBZCMKUDUEZUCZFDUBZUFZGDUBZBCUGZBGUHZFUHZCGUHFUHIUIZBCIUIZUGZU
        FZUFZBEIUIZWLEIUIZLUIZEWKEIUIZKWQVRWAWLAUBZEAUBZWRWSUGWTEUOVRVSWHWPUJZW
        AWBWFWGVTWPUKZWQVTWGWIWAXBVTWHWPULZVTWCWFWGWPUMZVTWHWIWJWOUNZXEABDFGHJK
        MNQRSUPUQWQVRVSWCWDWJXCXDVRVSWHWPURZVTWCWFWGWPUSZWDWEWCWGVTWPUTZVTWHWIW
        JWOVAABCEHIJKLMNOPQRTVBVCZWQWSWRWQWMWNWSWRVTWHWIWJWOVDWQVTWCWFWGWIWMWSU
        OXFXJVTWCWFWGWPVLXGXHABCDEFGHIJKLMRSNOQPTVEVFWQVRVSWCWDWNWRUOXDXIXJXKAB
        CEHIJKLMNOPQRTVGVHVIVMABWLEIJKLNOPQVJVKWQVRWKAUBZXCEXAKUDXDWQVTWIWAXMXF
        XHXEABDGHJKMNQRSVNVOXLAWKEIJKNOQVPVOVQ $.
    $}

    $( The triples ` <. P , ( F `` ( G `` P ) ) , ( F `` P ) >. ` and
       ` <. Q , ( F `` ( G `` Q ) ) , ( F `` Q ) >. ` are centrally
       perspective.  TODO:  FIX COMMENT (Contributed by NM, 1-May-2013.) $)
    cdlemg9b $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ F e. T )
       /\ ( G e. T /\ P =/= Q
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
    -> ( ( P .\/ Q ) ./\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) )
       .<_ ( ( G ` P ) .\/ ( G ` Q ) ) ) $=
      ( wcel co chlt wa wbr w3a wne cfv eqid cdlemg9a wceq simp1l simp1r simp21
      wn simp22l cdlemg3a syl211anc simp1 simp22 simp23 simp31 cdlemg2l oveq12d
      syl122anc cdlemg2k syl121anc 3brtr4d ) IUASZLGSZUBZBASBLJUCUMUBZCASZCLJUC
      UMZUBZEDSZUDZFDSZBCUEZBFUFZEUFZCFUFZEUFHTZBCHTZUEZUDZUDZBWBLKTZHTZVSWFHTZ
      KTVRWFHTZWBWAKTVRVTHTZJABCDWFEFGHIJKLMNOPQRWFUGZUHWEWBWGWAWHKWEVGVHVJVKWB
      WGUIVGVHVOWDUJVGVHVOWDUKVIVJVMVNWDULZVKVLVJVNVIWDUNABCWFGHIJKLMNOPQWKUOUP
      WEVIVJVMVNVPWAWHUIVIVOWDUQZWLVIVJVMVNWDURZVIVJVMVNWDUSVIVOVPVQWCUTZABCDWF
      EFGHIJKLQRMNPOWKVAVCVBWEVIVJVMVPWJWIUIWMWLWNWOABCDWFFGHIJKLQRMNPOWKVDVEVF
      $.

    $( The triples ` <. P , ( F `` ( G `` P ) ) , ( F `` P ) >. ` and
       ` <. Q , ( F `` ( G `` Q ) ) , ( F `` Q ) >. ` are axially perspective
       by ~ dalaw .  Part of Lemma G of [Crawley] p. 116, last 2 lines.  TODO:
       FIX COMMENT (Contributed by NM, 1-May-2013.) $)
    cdlemg9 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ F e. T )
       /\ ( G e. T /\ P =/= Q
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) )
           .<_ ( ( ( ( F ` ( G ` P ) ) .\/ ( G ` P ) )
                ./\ ( ( F ` ( G ` Q ) ) .\/ ( G ` Q ) ) )
             .\/ ( ( ( G ` P ) .\/ P ) ./\ ( ( G ` Q ) .\/ Q ) ) ) ) $=
      ( wcel co chlt wa wbr wn w3a wne cfv cdlemg9b simp1l simp21l simp1 simp23
      wi simp31 ltrncoat syl121anc ltrnat syl3anc simp22l dalaw syl133anc mpd )
      IUASZLGSZUBZBASZBLJUCUDZUBZCASZCLJUCUDZUBZEDSZUEZFDSZBCUFZBFUGZEUGZCFUGZE
      UGZHTZBCHTZUFZUEZUEZWAVTKTVPVRHTJUCZBVQHTCVSHTKTVQVPHTVSVRHTKTVPBHTVRCHTK
      THTJUCZABCDEFGHIJKLMNOPQRUHWDVCVFVQASZVPASZVIVSASZVRASZWEWFUMVCVDVMWCUIVF
      VGVKVLVEWCUJZWDVEVLVNVFWGVEVMWCUKZVEVHVKVLWCULZVEVMVNVOWBUNZWKABDEFGIJLMP
      QRUOUPWDVEVNVFWHWLWNWKABDFGIJLMPQRUQURVIVJVHVLVEWCUSZWDVEVLVNVIWIWLWMWNWO
      ACDEFGIJLMPQRUOUPWDVEVNVIWJWLWNWOACDFGIJLMPQRUQURABVQVPCVSVRHIJKMNOPUTVAV
      B $.

    $( TODO:  FIX COMMENT TODO:  Can this be moved up as a stand-alone theorem
       in ltrn* area?  (Contributed by NM, 4-May-2013.) $)
    cdlemg10b $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
           /\ F e. T )
      -> ( ( ( F ` P ) .\/ ( F ` Q ) ) ./\ W ) = ( ( P .\/ Q ) ./\ W ) ) $=
      ( co eqid cdlemg2m ) ABCDBCGRKJRZEFGHIJKPQLMONUAST $.

    $( TODO:  FIX COMMENT TODO:  Can this be moved up as a stand-alone theorem
       in ltrn* area?  TODO:  Compare this proof to ~ cdlemg2m and pick best,
       if moved to ltrn* area.  (Contributed by NM, 4-May-2013.)
       (New usage is discouraged.) $)
    cdlemg10bALTN $p |- ( ( ( K e. HL /\ W e. H /\ F e. T )
           /\ ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
      -> ( ( ( F ` P ) .\/ ( F ` Q ) ) ./\ W ) = ( ( P .\/ Q ) ./\ W ) ) $=
      ( wcel co syl3anc chlt w3a wbr wn wa cfv wceq simp11 simp12 3simpc simp13
      jca eqid cdlemg2k oveq1d cp0 ltrnel lhpmat syl2anc cbs simp2l ltrnat clat
      simp2 hllat simp3l hlatjcl lhpbase latmcl latmle2 atmod4i2 syl131anc hlol
      syl col olj02 3eqtr3d eqtrd ) HUARZKFRZEDRZUBZBARZBKIUCUDZUEZCARZCKIUCUDZ
      UEZUBZBEUFZCEUFGSZKJSWJBCGSZKJSZGSZKJSZWMWIWKWNKJWIVSVTUEZWEWHUEWAWKWNUGW
      IVSVTVSVTWAWEWHUHZVSVTWAWEWHUIZULZWBWEWHUJVSVTWAWEWHUKZABCDWMEFGHIJKPQLMO
      NWMUMUNTUOWIWJKJSZWMGSZHUPUFZWMGSZWOWMWIXAXCWMGWIWPWJARZWJKIUCUDUEZXAXCUG
      WSWIWPWAWEXFWSWTWBWEWHVDABDEFHIKLOPQUQTAWJFHIJKXCLNXCUMZOPURUSUOWIVSXEWMH
      UTUFZRZKXHRZWMKIUCZXBWOUGWQWIWPWAWCXEWSWTWBWCWDWHVAZABDEFHIKLOPQVBTWIHVCR
      ZWLXHRZXJXIWIVSXMWQHVEVNZWIVSWCWFXNWQXLWBWEWFWGVFAXHGHBCXHUMZMOVGTZWIVTXJ
      WRXHFHKXPPVHVNZXHHJWLKXPNVITZXRWIXMXNXJXKXOXQXRXHHIJWLKXPLNVJTAXHWJGHIJWM
      KXPLMNOVKVLWIHVORZXIXDWMUGWIVSXTWQHVMVNXSXHGHWMXCXPMXGVPUSVQVR $.

    $( TODO:  FIX COMMENT (Contributed by NM, 4-May-2013.) $)
    cdlemg11a $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
      -> ( F ` ( G ` P ) ) =/= P ) $=
      ( wcel wa chlt wbr wn cfv wne w3a simp33 wceq simpr simpl1 simpl2 simpl31
      co simpl32 cdlemg6 syl113anc oveq12d ex necon3d mpd ) IUASLGSTZBASBLJUBUC
      TCASCLJUBUCTTZEDSZFDSZBFUDEUDZCFUDEUDZHUMZBCHUMZUEZUFZUFZVIVEBUEVAVBVCVDV
      IUGVKVEBVGVHVKVEBUHZVGVHUHVKVLTZVEBVFCHVKVLUIZVMVAVBVCVDVLVFCUHVAVBVJVLUJ
      VAVBVJVLUKVCVDVIVAVBVLULVCVDVIVAVBVLUNVNABCDEFGIJLMPQRUOUPUQURUSUT $.

    $( TODO:  FIX COMMENT TODO: can proof using this be restructured to use
       ~ cdlemg11a ?  (Contributed by NM, 4-May-2013.) $)
    cdlemg11aq $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
      -> ( F ` ( G ` Q ) ) =/= Q ) $=
      ( wcel wa chlt wbr wn cfv co wne simp1 simp2r simp2l simp31 simp32 simp33
      wceq simp1l simp2ll ltrncoat syl121anc simp2rl hlatjcom syl3anc cdlemg11a
      w3a 3netr3d syl123anc ) IUASZLGSZTZBASZBLJUBUCZTZCASZCLJUBUCZTZTZEDSZFDSZ
      BFUDEUDZCFUDEUDZHUEZBCHUEZUFZVBZVBZVGVMVJVOVPVRVQHUEZCBHUEZUFVRCUFVGVNWBU
      GZVGVJVMWBUHVGVJVMWBUIVGVNVOVPWAUJZVGVNVOVPWAUKZWCVSVTWDWEVGVNVOVPWAULWCV
      EVQASZVRASZVSWDUMVEVFVNWBUNZWCVGVOVPVHWIWFWGWHVHVIVMVGWBUOZABDEFGIJLMPQRU
      PUQWCVGVOVPVKWJWFWGWHVKVLVJVGWBURZACDEFGIJLMPQRUPUQAHIVQVRNPUSUTWCVEVHVKV
      TWEUMWKWLWMAHIBCNPUSUTVCACBDEFGHIJKLMNOPQRVAVD $.

    cdlemg10.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( TODO:  FIX COMMENT TODO:  Can this be moved up as a stand-alone theorem
       in trl* area?  (Contributed by NM, 4-May-2013.) $)
    cdlemg10c $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
                    /\ ( F e. T /\ G e. T ) )
      -> ( ( R ` F ) .<_ ( ( G ` P ) .\/ ( G ` Q ) )
             <-> ( R ` F ) .<_ ( P .\/ Q ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co simp1 simp3l trlle syl2anc biantrud clat
      cbs wb simp1l hllat syl eqid trlcl simp3r simp2ll syl3anc simp2rl hlatjcl
      ltrnat simp1r latlem12 syl13anc cdlemg10b 3adant3l breq2d 3bitr4rd 3bitrd
      lhpbase wceq ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZCAUBZCMKUDUEZUCZUCZFEUBZGEUB
      ZUCZUFZFDUGZBGUGZCGUGZIUHZKUDZWPWLMKUDZUCZWLWOMLUHZKUDZWLBCIUHZKUDZWKWQWP
      WKVTWHWQVTWGWJUIZVTWGWHWIUJZDEFHJKMNRSTUKULZUMWKJUNUBZWLJUOUGZUBZWOXGUBZM
      XGUBZWRWTUPWKVRXFVRVSWGWJUQZJURUSZWKVTWHXHXCXDXGDEFHJMXGUTZRSTVAULZWKVRWM
      AUBZWNAUBZXIXKWKVTWIWAXOXCVTWGWHWIVBZWAWBWFVTWJVCZABEGHJKMNQRSVGVDWKVTWIW
      DXPXCXQWDWEWCVTWJVEZACEGHJKMNQRSVGVDAXGIJWMWNXMOQVFVDWKVSXJVRVSWGWJVHXGHJ
      MXMRVPUSZXGJKLWLWOMXMNPVIVJWKXBWQUCZWLXAMLUHZKUDZXBWTWKXFXHXAXGUBZXJYAYCU
      PXLXNWKVRWAWDYDXKXRXSAXGIJBCXMOQVFVDXTXGJKLWLXAMXMNPVIVJWKWQXBXEUMWKWSYBW
      LKVTWGWIWSYBVQWHABCEGHIJKLMNOPQRSVKVLVMVNVO $.

    $( TODO:  FIX COMMENT (Contributed by NM, 3-May-2013.) $)
    cdlemg10a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( F e. T /\ G e. T /\ P =/= Q )
      /\ ( ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
        /\ -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) )
         .<_ ( ( R ` F ) .\/ ( R ` G ) ) ) $=
      ( chlt wa wbr wn w3a wne cfv co simp11 simp12 simp13 simp21 simp22 simp23
      wcel simp31 cdlemg9 syl133anc wceq ltrnel syl3anc simp12l ltrn11at simp32
      simp13l syl113anc wb cdlemg10c syl122anc mtbird trlval4 syl132anc simp11l
      ltrnat hlatjcom oveq12d eqtrd simp33 breqtrrd ) JUAUOZMHUOZUBZBAUOZBMKUCU
      DZUBZCAUOZCMKUCUDZUBZUEZFEUOZGEUOZBCUFZUEZBGUGZFUGZCGUGZFUGZIUHBCIUHZUFZF
      DUGZWRKUCZUDZGDUGZWRKUCUDZUEZUEZBWOIUHCWQIUHLUHZWOWNIUHZWQWPIUHZLUHZWNBIU
      HZWPCIUHZLUHZIUHZWTXCIUHKXFWBWEWHWJWKWLWSXGXNKUCWBWEWHWMXEUIZWBWEWHWMXEUJ
      ZWBWEWHWMXEUKZWIWJWKWLXEULZWIWJWKWLXEUMZWIWJWKWLXEUNZWIWMWSXBXDUPABCEFGHI
      JKLMNOPQRSUQURXFWTXJXCXMIXFWTWNWOIUHZWPWQIUHZLUHZXJXFWBWJWNAUOZWNMKUCUDUB
      ZWPAUOZWPMKUCUDUBZWNWPUFZWTWNWPIUHKUCZUDWTYCUSXOXRXFWBWKWEYEXOXSXPABEGHJK
      MNQRSUTVAXFWBWKWHYGXOXSXQACEGHJKMNQRSUTVAXFWBWKWCWFWLYHXOXSWCWDWBWHWMXEVB
      ZWFWGWBWEWMXEVEZXTABCEGHJMQRSVCVFXFYIXAWIWMWSXBXDVDXFWBWEWHWJWKYIXAVGXOXP
      XQXRXSABCDEFGHIJKLMNOPQRSTVHVIVJAWNWPDEFHIJKLMNOPQRSTVKVLXFYAXHYBXILXFVTY
      DWOAUOZYAXHUSVTWAWEWHWMXEVMZXFWBWKWCYDXOXSYJABEGHJKMNQRSVNVAZXFWBWJYDYLXO
      XRYNAWNEFHJKMNQRSVNVAAIJWNWOOQVOVAXFVTYFWQAUOZYBXIUSYMXFWBWKWFYFXOXSYKACE
      GHJKMNQRSVNVAZXFWBWJYFYOXOXRYPAWPEFHJKMNQRSVNVAAIJWPWQOQVOVAVPVQXFXCBWNIU
      HZCWPIUHZLUHZXMXFWBWKWEWHWLXDXCYSUSXOXSXPXQXTWIWMWSXBXDVRABCDEGHIJKLMNOPQ
      RSTVKVLXFYQXKYRXLLXFVTWCYDYQXKUSYMYJYNAIJBWNOQVOVAXFVTWFYFYRXLUSYMYKYPAIJ
      CWPOQVOVAVPVQVPVS $.

    $( TODO:  FIX COMMENT (Contributed by NM, 4-May-2013.) $)
    cdlemg10 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( F e. T /\ G e. T /\ P =/= Q )
     /\ ( ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
        /\ -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) )
         .<_ W ) $=
      ( chlt wcel wa wbr wn w3a wne cfv cbs eqid clat simp11l hllat syl simp12l
      simp11 simp21 simp22 ltrnat syl3anc hlatjcl simp13l latmcl syl2anc latjcl
      trlcl simp11r lhpbase cdlemg10a trlle latjle12 syl13anc mpbi2and lattrd
      co wb ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZCAUBZCMKUDUEZUCZUFZFEUBZGEUBZBCUGZU
      FZBGUHZFUHZCGUHZFUHZIVOBCIVOZUGFDUHZWOKUDUEGDUHZWOKUDUEUFZUFZJUIUHZJKBWLI
      VOZCWNIVOZLVOZWPWQIVOZMWTUJZNWSVQJUKUBZVQVRWBWEWJWRULZJUMUNZWSXFXAWTUBZXB
      WTUBZXCWTUBXHWSVQVTWLAUBZXIXGVTWAVSWEWJWRUOZWSVSWGWKAUBZXKVSWBWEWJWRUPZWF
      WGWHWIWRUQZWSVSWHVTXMXNWFWGWHWIWRURZXLABEGHJKMNQRSUSUTAWKEFHJKMNQRSUSUTAW
      TIJBWLXEOQVAUTWSVQWCWNAUBZXJXGWCWDVSWBWJWRVBZWSVSWGWMAUBZXQXNXOWSVSWHWCXS
      XNXPXRACEGHJKMNQRSUSUTAWMEFHJKMNQRSUSUTAWTIJCWNXEOQVAUTWTJLXAXBXEPVCUTWSX
      FWPWTUBZWQWTUBZXDWTUBXHWSVSWGXTXNXOWTDEFHJMXERSTVFVDZWSVSWHYAXNXPWTDEGHJM
      XERSTVFVDZWTIJWPWQXEOVEUTWSVRMWTUBZVQVRWBWEWJWRVGWTHJMXERVHUNZABCDEFGHIJK
      LMNOPQRSTVIWSWPMKUDZWQMKUDZXDMKUDZWSVSWGYFXNXODEFHJKMNRSTVJVDWSVSWHYGXNXP
      DEGHJKMNRSTVJVDWSXFXTYAYDYFYGUCYHVPXHYBYCYEWTIJKWPWQMXENOVKVLVMVN $.

    $( TODO:  FIX COMMENT (Contributed by NM, 5-May-2013.) $)
    cdlemg11b $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A )
           /\ ( G e. T /\ P =/= Q /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
      -> ( P .\/ Q ) =/= ( ( G ` P ) .\/ ( G ` Q ) ) ) $=
      ( wcel chlt wa wbr wne cfv w3a simp33 wceq simpl1 simpl31 simpl2l trlval2
      wn co syl3anc cbs eqid clat simpl1l hllat syl adantr atbase ltrncl latjcl
      simp2ll simpl1r lhpbase latmcl simpl2r latmle1 simpr breqtrrd wb latjle12
      latlej1 syl13anc mpbi2and lattrd eqbrtrd ex necon3bd mpd ) IUATZLGTZUBZBA
      TZBLJUCUMZUBZCATZUBZFETZBCUDZFDUEZBCHUNZJUCZUMZUFZUFZWQWOBFUEZCFUEZHUNZUD
      WFWKWLWMWQUGWSWPWOXBWSWOXBUHZWPWSXCUBZWNBWTHUNZLKUNZWOJXDWFWLWIWNXFUHWFWK
      WRXCUIZWLWMWQWFWKXCUJZWIWJWFWRXCUKABDEFGHIJKLMNOPQRSULUOXDIUPUEZIJXFXEWOX
      IUQZMXDWDIURTZWDWEWKWRXCUSIUTVAZXDXKXEXITZLXITZXFXITXLXDXKBXITZWTXITZXMXL
      XDWGXOWSWGXCWGWHWJWFWRVFVBAXIBIXJPVCVAZXDWFWLXOXPXGXHXQXIEFGIUALBXJQRVDUO
      ZXIHIBWTXJNVEUOZXDWEXNWDWEWKWRXCVGXIGILXJQVHVAZXIIKXELXJOVIUOXSXDXKXOCXIT
      ZWOXITZXLXQXDWJYAWIWJWFWRXCVJAXICIXJPVCVAZXIHIBCXJNVEUOZXDXKXMXNXFXEJUCXL
      XSXTXIIJKXELXJMOVKUOXDBWOJUCZWTWOJUCZXEWOJUCZXDXKXOYAYEXLXQYCXIHIJBCXJMNV
      PUOXDWTXBWOJXDXKXPXAXITZWTXBJUCXLXRXDWFWLYAYHXGXHYCXIEFGIUALCXJQRVDUOXIHI
      JWTXAXJMNVPUOWSXCVLVMXDXKXOXPYBYEYFUBYGVNXLXQXRYDXIHIJBWTWOXJMNVOVQVRVSVT
      WAWBWC $.
  $}

  ${
    cdlemg12.l $e |- .<_ = ( le ` K ) $.
    cdlemg12.j $e |- .\/ = ( join ` K ) $.
    cdlemg12.m $e |- ./\ = ( meet ` K ) $.
    cdlemg12.a $e |- A = ( Atoms ` K ) $.
    cdlemg12.h $e |- H = ( LHyp ` K ) $.
    cdlemg12.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ${
      cdlemg12.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( TODO:  FIX COMMENT. (Contributed by NM, 5-May-2013.) $)
      cdlemg12a $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
       /\ ( G e. T /\ P =/= Q /\ ( P .\/ U ) =/= ( ( G ` P ) .\/ U ) ) )
    -> ( ( P .\/ U ) ./\ ( ( G ` P ) .\/ U ) )
       .<_ ( ( F ` ( G ` P ) ) .\/ U ) ) $=
        ( chlt wcel wa wbr wn w3a wne co cfv simp1l simp21l simp1 simp31 ltrnat
        syl3anc simp1r simp21 simp22l simp32 cdleme0a syl212anc simp33 2llnma3r
        wceq syl131anc simp23 ltrncoat syl121anc hlatlej2 eqbrtrd ) JUAUBZMHUBZ
        UCZBAUBZBMKUDUEZUCZCAUBZCMKUDUEZUCZFDUBZUFZGDUBZBCUGZBEIUHZBGUIZEIUHZUG
        ZUFZUFZWDWFLUHZEWEFUIZEIUHZKWIVKVNWEAUBZEAUBZWGWJEVDVKVLWAWHUJZVNVOVSVT
        VMWHUKZWIVMWBVNWMVMWAWHULZVMWAWBWCWGUMZWPABDGHJKMNQRSUNUOWIVKVLVPVQWCWN
        WOVKVLWAWHUPVMVPVSVTWHUQVQVRVPVTVMWHURVMWAWBWCWGUSABCEHIJKLMNOPQRTUTVAZ
        VMWAWBWCWGVBABWEEIJKLNOPQVCVEWIVKWKAUBZWNEWLKUDWOWIVMVTWBVNWTWQVMVPVSVT
        WHVFWRWPABDFGHJKMNQRSVGVHWSAWKEIJKNOQVIUOVJ $.
    $}

    cdlemg12b.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The triples ` <. P , ( F `` P ) , ( F `` ( G `` P ) ) >. ` and
       ` <. Q , ( F `` Q ) , ( F `` ( G `` Q ) ) >. ` are centrally
       perspective.  TODO:  FIX COMMENT (Contributed by NM, 5-May-2013.) $)
    cdlemg12b $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
     /\ ( G e. T /\ P =/= Q /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
    -> ( ( P .\/ Q ) ./\ ( ( G ` P ) .\/ ( G ` Q ) ) )
       .<_ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co simp1 simp2 simp31 simp32 simp21 simp22l
      cfv simp33 cdlemg11b syl123anc wceq simp1l simp1r eqid cdlemg3a syl211anc
      cdlemg2k syl121anc 3netr3d cdlemg12a syl113anc oveq12d cdlemg2l syl122anc
      simp22 simp23 3brtr4d ) JUAUBZMHUBZUCZBAUBBMKUDUEUCZCAUBZCMKUDUEZUCZFEUBZ
      UFZGEUBZBCUGZGDUOBCIUHZKUDUEZUFZUFZBWGMLUHZIUHZBGUOZWKIUHZLUHZWMFUOZWKIUH
      ZWGWMCGUOZIUHZLUHWPWRFUOIUHZKWJVRWDWEWFWLWNUGWOWQKUDVRWDWIUIZVRWDWIUJVRWD
      WEWFWHUKZVRWDWEWFWHULZWJWGWSWLWNWJVRVSVTWEWFWHWGWSUGXAVRVSWBWCWIUMZVTWAVS
      WCVRWIUNZXBXCVRWDWEWFWHUPABCDEGHIJKLMNOPQRSTUQURWJVPVQVSVTWGWLUSVPVQWDWIU
      TVPVQWDWIVAXDXEABCWKHIJKLMNOPQRWKVBZVCVDZWJVRVSWBWEWSWNUSXAXDVRVSWBWCWIVM
      ZXBABCEWKGHIJKLMRSNOQPXFVEVFZVGABCEWKFGHIJKLMNOPQRSXFVHVIWJWGWLWSWNLXGXIV
      JWJVRVSWBWCWEWTWQUSXAXDXHVRVSWBWCWIVNXBABCEWKFGHIJKLMRSNOQPXFVKVLVO $.

    $( The triples ` <. P , ( F `` P ) , ( F `` ( G `` P ) ) >. ` and
       ` <. Q , ( F `` Q ) , ( F `` ( G `` Q ) ) >. ` are axially perspective
       by ~ dalaw .  TODO:  FIX COMMENT (Contributed by NM, 5-May-2013.) $)
    cdlemg12c $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
     /\ ( G e. T /\ P =/= Q /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
        -> ( ( P .\/ ( G ` P ) ) ./\ ( Q .\/ ( G ` Q ) ) )
             .<_ ( ( ( ( G ` P ) .\/ ( F ` ( G ` P ) ) )
                  ./\ ( ( G ` Q ) .\/ ( F ` ( G ` Q ) ) ) )
             .\/ ( ( ( F ` ( G ` P ) ) .\/ P )
                  ./\ ( ( F ` ( G ` Q ) ) .\/ Q ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cdlemg12b wi simp1l simp21l simp1 simp31
      cfv ltrnat syl3anc simp23 simp22l ltrncoat syl121anc dalaw syl133anc mpd
      ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZCAUBZCMKUDUEZUCZFEUBZUFZGEUBZBCUGZGDUOBCI
      UHZKUDUEZUFZUFZVRBGUOZCGUOZIUHLUHWBFUOZWCFUOZIUHKUDZBWBIUHCWCIUHLUHWBWDIU
      HWCWEIUHLUHWDBIUHWECIUHLUHIUHKUDZABCDEFGHIJKLMNOPQRSTUIWAVEVHWBAUBZWDAUBZ
      VKWCAUBZWEAUBZWFWGUJVEVFVOVTUKVHVIVMVNVGVTULZWAVGVPVHWHVGVOVTUMZVGVOVPVQV
      SUNZWLABEGHJKMNQRSUPUQZWAVGVNWHWIWMVGVJVMVNVTURZWOAWBEFHJKMNQRSUPUQVKVLVJ
      VNVGVTUSZWAVGVPVKWJWMWNWQACEGHJKMNQRSUPUQWAVGVNVPVKWKWMWPWNWQACEFGHJKMNQR
      SUTVAABWBWDCWCWEIJKLNOPQVBVCVD $.

    $( TODO:  FIX COMMENT (Contributed by NM, 5-May-2013.) $)
    cdlemg12d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F e. T /\ G e. T )
    /\ ( P =/= Q /\ -. ( R ` F ) .<_ ( P .\/ Q )
               /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
        -> ( R ` G )
           .<_ ( ( R ` F ) .\/ ( ( ( F ` ( G ` P ) ) .\/ P )
                ./\ ( ( F ` ( G ` Q ) ) .\/ Q ) ) ) ) $=
      ( chlt wa wbr wn w3a wne cfv co simp11 simp12 simp13 simp2l simp2r simp31
      wcel simp33 cdlemg12c syl133anc trlval4 syl132anc syl3anc simp12l simp13l
      wceq ltrnel ltrn11at syl113anc simp32 wb simp2 cdlemg10c syl121anc mtbird
      oveq1d 3brtr4d ) JUAUOMHUOUBZBAUOZBMKUCUDZUBZCAUOZCMKUCUDZUBZUEZFEUOZGEUO
      ZUBZBCUFZFDUGZBCIUHZKUCZUDZGDUGZWIKUCUDZUEZUEZBBGUGZIUHCCGUGZIUHLUHZWPWPF
      UGZIUHWQWQFUGZIUHLUHZWSBIUHWTCIUHLUHZIUHZWLWHXBIUHKWOVPVSWBWDWEWGWMWRXCKU
      CVPVSWBWFWNUIZVPVSWBWFWNUJZVPVSWBWFWNUKZWCWDWEWNULZWCWDWEWNUMZWCWFWGWKWMU
      NZWCWFWGWKWMUPZABCDEFGHIJKLMNOPQRSTUQURWOVPWEVSWBWGWMWLWRVDXDXHXEXFXIXJAB
      CDEGHIJKLMNOPQRSTUSUTWOWHXAXBIWOVPWDWPAUOWPMKUCUDUBZWQAUOWQMKUCUDUBZWPWQU
      FZWHWPWQIUHKUCZUDWHXAVDXDXGWOVPWEVSXKXDXHXEABEGHJKMNQRSVEVAWOVPWEWBXLXDXH
      XFACEGHJKMNQRSVEVAWOVPWEVQVTWGXMXDXHVQVRVPWBWFWNVBVTWAVPVSWFWNVCXIABCEGHJ
      MQRSVFVGWOXNWJWCWFWGWKWMVHWOVPVSWBWFXNWJVIXDXEXFWCWFWNVJABCDEFGHIJKLMNOPQ
      RSTVKVLVMAWPWQDEFHIJKLMNOPQRSTUSUTVNVO $.

    ${
      cdlemg12e.z $e |- .0. = ( 0. ` K ) $.
      $( TODO:  FIX COMMENT (Contributed by NM, 6-May-2013.) $)
      cdlemg12e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
          /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( F e. T /\ G e. T /\ P =/= Q )
      /\ ( -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q )
         /\ ( R ` F ) =/= ( R ` G ) ) )
  -> ( ( ( F ` ( G ` P ) ) .\/ P ) ./\ ( ( F ` ( G ` Q ) ) .\/ Q ) )
         =/= .0. ) $=
        ( chlt wcel wa wbr wn w3a wne cfv co simp33 wceq simpl1 simpl21 simpl22
        simpl23 simpl31 simpl32 cdlemg12d syl123anc simpr oveq2d col cbs adantr
        simp11l hlol syl simpl11 trlcl syl2anc olj01 eqtrd breqtrd cal wb hlatl
        eqid cops hlop simp12l simp13l hlatjcl syl3anc opnlen0 syl31anc simp11r
        trlatn0 syl21anc mpbird atcmp mpbid eqcomd ex necon3d mpd ) JUCUDZMHUDZ
        UEZBAUDZBMKUFUGZUEZCAUDZCMKUFUGZUEZUHZFEUDZGEUDZBCUIZUHZFDUJZBCIUKZKUFU
        GZGDUJZXMKUFUGZXLXOUIZUHZUHZXQBGUJFUJBIUKCGUJFUJCIUKLUKZNUIXGXKXNXPXQUL
        XSXTNXLXOXSXTNUMZXLXOUMXSYAUEZXOXLYBXOXLKUFZXOXLUMZYBXOXLXTIUKZXLKYBXGX
        HXIXJXNXPXOYEKUFXGXKXRYAUNXHXIXJXGXRYAUOZXHXIXJXGXRYAUPZXHXIXJXGXRYAUQX
        NXPXQXGXKYAURZXNXPXQXGXKYAUSZABCDEFGHIJKLMOPQRSTUAUTVAYBYEXLNIUKZXLYBXT
        NXLIXSYAVBVCYBJVDUDZXLJVEUJZUDZYJXLUMYBWRYKXSWRYAWRWSXCXFXKXRVGVFZJVHVI
        YBWTXHYMWTXCXFXKXRYAVJZYFYLDEFHJMYLVSZSTUAVKVLZYLIJXLNYPPUBVMVLVNVOYBJV
        PUDZXOAUDZXLAUDZYCYDVQYBWRYRYNJVRVIYBYSXONUIZYBJVTUDZXOYLUDZXMYLUDZXPUU
        AYBWRUUBYNJWAVIZYBWTXIUUCYOYGYLDEGHJMYPSTUAVKVLYBWRXAXDUUDYNXSXAYAXAXBW
        TXFXKXRWBVFXSXDYAXDXEWTXCXKXRWCVFAYLIJBCYPPRWDWEZYIYLJKXOXMNYPOUBWFWGYB
        WRWSXIYSUUAVQYNXSWSYAWRWSXCXFXKXRWHVFZYGADEGHJMNUBRSTUAWIWJWKYBYTXLNUIZ
        YBUUBYMUUDXNUUHUUEYQUUFYHYLJKXLXMNYPOUBWFWGYBWRWSXHYTUUHVQYNUUGYFADEFHJ
        MNUBRSTUAWIWJWKAXOXLJKORWLWEWMWNWOWPWQ $.
    $}

    $( TODO:  FIX COMMENT (Contributed by NM, 6-May-2013.) $)
    cdlemg12f $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F e. T /\ G e. T /\ P =/= Q )
     /\ ( ( -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) )
        /\ ( R ` F ) =/= ( R ` G )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) )
       .<_ ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cbs simp11l hllat syl simp12l simp11
      clat simp21 ltrncoat syl121anc eqid hlatjcl syl3anc simp13l latmle1 simp1
      simp22 simp2 simp33 simp31l simp31r cdlemg10 syl113anc wb simp11r lhpbase
      latmcl latlem12 syl13anc mpbi2and ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZCAUBZCM
      KUDUEZUCZUFZFEUBZGEUBZBCUGZUFZFDUHZBCIUIZKUDUEZGDUHZWOKUDUEZUCZWNWQUGZBGU
      HFUHZCGUHFUHZIUIWOUGZUFZUFZBXAIUIZCXBIUIZLUIZXFKUDZXHMKUDZXHXFMLUIKUDZXEJ
      UPUBZXFJUJUHZUBZXGXMUBZXIXEVTXLVTWAWEWHWMXDUKZJULUMZXEVTWCXAAUBZXNXPWCWDW
      BWHWMXDUNZXEWBWJWKWCXRWBWEWHWMXDUOZWIWJWKWLXDUQZWIWJWKWLXDVFZXSABEFGHJKMN
      QRSURUSAXMIJBXAXMUTZOQVAVBZXEVTWFXBAUBZXOXPWFWGWBWEWMXDVCZXEWBWJWKWFYEXTY
      AYBYFACEFGHJKMNQRSURUSAXMIJCXBYCOQVAVBZXMJKLXFXGYCNPVDVBXEWIWMXCWPWRXJWIW
      MXDVEWIWMXDVGWIWMWSWTXCVHWPWRWTXCWIWMVIWPWRWTXCWIWMVJABCDEFGHIJKLMNOPQRST
      VKVLXEXLXHXMUBZXNMXMUBZXIXJUCXKVMXQXEXLXNXOYHXQYDYGXMJLXFXGYCPVPVBYDXEWAY
      IVTWAWEWHWMXDVNXMHJMYCRVOUMXMJKLXHXFMYCNPVQVRVS $.

    $( TODO:  FIX COMMENT TODO:  Combine with ~ cdlemg12f .  (Contributed by
       NM, 6-May-2013.) $)
    cdlemg12g $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F e. T /\ G e. T /\ P =/= Q )
     /\ ( ( -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) )
        /\ ( R ` F ) =/= ( R ` G )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) )
       = ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv cops cbs cp0 wceq simp11l hlop syl clat
      co hllat simp12l simp11 simp21 ltrncoat syl121anc hlatjcl syl3anc simp13l
      simp22 latmcl simp12 simp13 simp33 cdlemg11a syl123anc syl112anc hlatjcom
      eqid necomd lhpat oveq12d simp1 simp2 simp31l simp31r cdlemg12e syl113anc
      simp32 eqnetrd cdlemg12f leat2 syl32anc ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZC
      AUBZCMKUDUEZUCZUFZFEUBZGEUBZBCUGZUFZFDUHZBCIUQZKUDUEZGDUHZXFKUDUEZUCZXEXH
      UGZBGUHFUHZCGUHFUHZIUQXFUGZUFZUFZJUIUBZBXLIUQZCXMIUQZLUQZJUJUHZUBZXRMLUQZ
      AUBZXTJUKUHZUGXTYCKUDXTYCULXPWKXQWKWLWPWSXDXOUMZJUNUOXPJUPUBZXRYAUBZXSYAU
      BZYBXPWKYGYFJURUOXPWKWNXLAUBZYHYFWNWOWMWSXDXOUSZXPWMXAXBWNYJWMWPWSXDXOUTZ
      WTXAXBXCXOVAZWTXAXBXCXOVGZYKABEFGHJKMNQRSVBVCZAYAIJBXLYAVPZOQVDVEXPWKWQXM
      AUBZYIYFWQWRWMWPXDXOVFZXPWMXAXBWQYQYLYMYNYRACEFGHJKMNQRSVBVCZAYAIJCXMYPOQ
      VDVEYAJLXRXSYPPVHVEXPWMWPYJBXLUGZYDYLWMWPWSXDXOVIZYOXPWMWPWSXAXBXNYTYLUUA
      WMWPWSXDXOVJYMYNWTXDXJXKXNVKWMWPWSUCXAXBXNUFUFXLBABCEFGHIJKLMNOPQRSVLVQVM
      ABXLHIJKLMNOPQRVRVNXPXTXLBIUQZXMCIUQZLUQZYEXPXRUUBXSUUCLXPWKWNYJXRUUBULYF
      YKYOAIJBXLOQVOVEXPWKWQYQXSUUCULYFYRYSAIJCXMOQVOVEVSXPWTXDXGXIXKUUDYEUGWTX
      DXOVTWTXDXOWAXGXIXKXNWTXDWBXGXIXKXNWTXDWCWTXDXJXKXNWFABCDEFGHIJKLMYENOPQR
      STYEVPZWDWEWGABCDEFGHIJKLMNOPQRSTWHAYAYCJKXTYEYPNUUEQWIWJ $.

    $( TODO:  FIX COMMENT (Contributed by NM, 6-May-2013.) $)
    cdlemg12 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F e. T /\ G e. T /\ P =/= Q )
     /\ ( ( -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) )
        /\ ( R ` F ) =/= ( R ` G )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
     = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv clat cbs wceq simp11l hllat syl simp12l
      co simp11 simp21 simp22 ltrncoat syl121anc eqid hlatjcl syl3anc cdlemg12g
      simp13l latmcom simp13 simp12 simp23 necomd simp31l hlatjcom breq2d mtbid
      simp31r jca simp32 simp33 3netr3d syl333anc 3eqtr3d ) JUAUBZMHUBZUCZBAUBZ
      BMKUDUEZUCZCAUBZCMKUDUEZUCZUFZFEUBZGEUBZBCUGZUFZFDUHZBCIUPZKUDZUEZGDUHZWR
      KUDZUEZUCZWQXAUGZBGUHFUHZCGUHFUHZIUPZWRUGZUFZUFZBXFIUPZCXGIUPZLUPZXMXLLUP
      ZXLMLUPXMMLUPZXKJUIUBZXLJUJUHZUBZXMXRUBZXNXOUKXKWCXQWCWDWHWKWPXJULZJUMUNX
      KWCWFXFAUBZXSYAWFWGWEWKWPXJUOZXKWEWMWNWFYBWEWHWKWPXJUQZWLWMWNWOXJURZWLWMW
      NWOXJUSZYCABEFGHJKMNQRSUTVAZAXRIJBXFXRVBZOQVCVDXKWCWIXGAUBZXTYAWIWJWEWHWP
      XJVFZXKWEWMWNWIYIYDYEYFYJACEFGHJKMNQRSUTVAZAXRIJCXGYHOQVCVDXRJLXLXMYHPVGV
      DABCDEFGHIJKLMNOPQRSTVEXKWEWKWHWMWNCBUGWQCBIUPZKUDZUEZXAYLKUDZUEZUCXEXGXF
      IUPZYLUGXOXPUKYDWEWHWKWPXJVHWEWHWKWPXJVIYEYFXKBCWLWMWNWOXJVJVKXKYNYPXKWSY
      MWTXCXEXIWLWPVLXKWRYLWQKXKWCWFWIWRYLUKYAYCYJAIJBCOQVMVDZVNVOXKXBYOWTXCXEX
      IWLWPVPXKWRYLXAKYRVNVOVQWLWPXDXEXIVRXKXHWRYQYLWLWPXDXEXIVSXKWCYBYIXHYQUKY
      AYGYKAIJXFXGOQVMVDYRVTACBDEFGHIJKLMNOPQRSTVEWAWB $.

    $( TODO:  FIX COMMENT (Contributed by NM, 6-May-2013.) $)
    cdlemg13a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F e. T /\ G e. T )
     /\ ( ( F ` P ) =/= P /\ ( R ` F ) = ( R ` G )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
    -> ( P .\/ ( F ` ( G ` P ) ) ) = ( ( G ` P ) .\/ ( F ` ( G ` P ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wne co simp11l simp12l simp11 simp2r ltrnat
      wceq syl3anc hlatlej1 simp32 simp2l simp12 ltrnel trlval2 oveq2d ltrncoat
      3eqtr3d syl121anc eqid cdleme0cp syl12anc cdleme0cq 3eqtr3rd breqtrd clat
      hlatlej2 cbs wb hllat syl atbase latjle12 syl13anc mpbi2and simp13 simp33
      hlatjcl cdlemg11a syl123anc necomd ps-1 syl132anc mpbid ) JUAUBZMHUBZUCZB
      AUBZBMKUDUEZUCZCAUBCMKUDUEUCZUFZFEUBZGEUBZUCZBFUGBUHZFDUGZGDUGZUOZBGUGZFU
      GZCGUGFUGIUIBCIUIUHZUFZUFZBXHIUIZXGXHIUIZKUDZXLXMUOZXKBXMKUDZXHXMKUDZXNXK
      BBXGIUIZXMKXKWLWOXGAUBZBXRKUDWLWMWQWRXBXJUJZWOWPWNWRXBXJUKZXKWNXAWOXSWNWQ
      WRXBXJULZWSWTXAXJUMZYAABEGHJKMNQRSUNUPZABXGIJKNOQUQUPXKXGXMMLUIZIUIZXGXRM
      LUIZIUIZXMXRXKYEYGXGIXKXDXEYEYGWSXBXCXFXIURXKWNWTXSXGMKUDUEUCZXDYEUOYBWSW
      TXAXJUSZXKWNXAWQYIYBYCWNWQWRXBXJUTZABEGHJKMNQRSVAUPZAXGDEFHIJKLMNOPQRSTVB
      UPXKWNXAWQXEYGUOYBYCYKABDEGHIJKLMNOPQRSTVBUPVEVCXKWNYIXHAUBZYFXMUOYBYLXKW
      NWTXAWOYMYBYJYCYAABEFGHJKMNQRSVDVFZAXGXHYEHIJKLMNOPQRYEVGVHVIXKWNWOYIYHXR
      UOYBYAYLABXGYGHIJKLMNOPQRYGVGVJVIVKVLXKWLXSYMXQXTYDYNAXGXHIJKNOQVNUPXKJVM
      UBZBJVOUGZUBZXHYPUBZXMYPUBZXPXQUCXNVPXKWLYOXTJVQVRXKWOYQYAAYPBJYPVGZQVSVR
      XKYMYRYNAYPXHJYTQVSVRXKWLXSYMYSXTYDYNAYPIJXGXHYTOQWEUPYPIJKBXHXMYTNOVTWAW
      BXKWLWOYMBXHUHXSYMXNXOVPXTYAYNXKXHBXKWNWQWRWTXAXIXHBUHYBYKWNWQWRXBXJWCYJY
      CWSXBXCXFXIWDABCEFGHIJKLMNOPQRSWFWGWHYDYNABXHXGXHIJKNOQWIWJWK $.

    $( TODO:  FIX COMMENT (Contributed by NM, 6-May-2013.) $)
    cdlemg13 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
    /\ ( F e. T /\ G e. T )
     /\ ( ( F ` P ) =/= P /\ ( R ` F ) = ( R ` G )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wne wceq simp11 simp2l simp2r simp12 ltrnel
      syl3anc trlval2 simp13 eqtr3d cdlemg13a oveq1d simp31 ltrnatneq syl131anc
      co simp2 simp32 simp33 simp11l simp12l ltrncoat simp13l 3netr3d syl313anc
      hlatjcom 3eqtr4d ) JUAUBZMHUBZUCZBAUBZBMKUDUEZUCZCAUBZCMKUDUEZUCZUFZFEUBZ
      GEUBZUCZBFUGBUHZFDUGZGDUGUIZBGUGZFUGZCGUGZFUGZIVDZBCIVDZUHZUFZUFZWLWMIVDZ
      MLVDZWNWOIVDZMLVDZBWMIVDZMLVDCWOIVDZMLVDWTWJXBXDWTVRWFWLAUBWLMKUDUEUCZWJX
      BUIVRWAWDWHWSUJZWEWFWGWSUKZWTVRWGWAXGXHWEWFWGWSULZVRWAWDWHWSUMZABEGHJKMNQ
      RSUNUOAWLDEFHIJKLMNOPQRSTUPUOWTVRWFWNAUBWNMKUDUEUCZWJXDUIXHXIWTVRWGWDXLXH
      XJVRWAWDWHWSUQZACEGHJKMNQRSUNUOAWNDEFHIJKLMNOPQRSTUPUOURWTXEXAMLABCDEFGHI
      JKLMNOPQRSTUSUTWTXFXCMLWTVRWDWAWHCFUGCUHZWKWOWMIVDZCBIVDZUHXFXCUIXHXMXKWE
      WHWSVEZWTVRWFWAWDWIXNXHXIXKXMWEWHWIWKWRVAABCEFHJKMNQRSVBVCWEWHWIWKWRVFWTW
      PWQXOXPWEWHWIWKWRVGWTVPWMAUBZWOAUBZWPXOUIVPVQWAWDWHWSVHZWTVRWHVSXRXHXQVSV
      TVRWDWHWSVIZABEFGHJKMNQRSVJUOWTVRWHWBXSXHXQWBWCVRWAWHWSVKZACEFGHJKMNQRSVJ
      UOAIJWMWOOQVNUOWTVPVSWBWQXPUIXTYAYBAIJBCOQVNUOVLACBDEFGHIJKLMNOPQRSTUSVMU
      TVO $.

    $( TODO:  FIX COMMENT (Contributed by NM, 6-May-2013.) $)
    cdlemg14f $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( F e. T /\ G e. T /\ ( F ` P ) = P ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn cfv wceq w3a co simp1 simp32 simp2l ltrnu syl211anc
      simp2r simp31 ltrnel syl3anc simp33 ltrnateq syl131anc oveq2d 3eqtr4d
      oveq1d ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZUCZFEUBZGEUBZBFUFBUGZUHZ
      UHZBBGUFZIUIZMLUIZCCGUFZIUIZMLUIZBVNFUFZIUIZMLUICVQFUFZIUIZMLUIVMVEVJVFVG
      VPVSUGVEVHVLUJZVEVHVIVJVKUKZVEVFVGVLULZVEVFVGVLUOZABCEGHIJKLUAMNOPQRSUMUN
      VMWAVOMLVMVTVNBIVMVEVIVFVNAUBVNMKUDUEUCZVKVTVNUGWDVEVHVIVJVKUPZWFVMVEVJVF
      WHWDWEWFABEGHJKMNQRSUQURVEVHVIVJVKUSZABVNEFHJKMNQRSUTVAVBVDVMWCVRMLVMWBVQ
      CIVMVEVIVFVQAUBVQMKUDUEUCZVKWBVQUGWDWIWFVMVEVJVGWKWDWEWGACEGHJKMNQRSUQURW
      JABVQEFHJKMNQRSUTVAVBVDVC $.

    $( TODO:  FIX COMMENT (Contributed by NM, 22-May-2013.) $)
    cdlemg14g $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( F e. T /\ G e. T /\ ( G ` P ) = P ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn cfv wceq w3a co simp1 simp31 simp2l ltrnu syl211anc
      simp2r simp33 fveq2d oveq2d oveq1d simp32 ltrnateq syl131anc 3eqtr4d ) JU
      AUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZUCZFEUBZGEUBZBGUFZBUGZUHZUHZBBFUFZI
      UIZMLUIZCCFUFZIUIZMLUIZBVJFUFZIUIZMLUICCGUFZFUFZIUIZMLUIVMVDVHVEVFVPVSUGV
      DVGVLUJZVDVGVHVIVKUKVDVEVFVLULZVDVEVFVLUOZABCEFHIJKLUAMNOPQRSUMUNVMWAVOML
      VMVTVNBIVMVJBFVDVGVHVIVKUPZUQURUSVMWDVRMLVMWCVQCIVMWBCFVMVDVIVEVFVKWBCUGW
      EVDVGVHVIVKUTWFWGWHABCEGHJKMNQRSVAVBUQURUSVC $.

    $( Eliminate the ` ( F `` P ) =/= P ` condition from ~ cdlemg13 .  TODO:
       FIX COMMENT (Contributed by NM, 6-May-2013.) $)
    cdlemg15a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( F e. T /\ G e. T )
     /\ ( ( R ` F ) = ( R ` G )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wceq co wne simpl11 simpl12 simpl13 simpl2l
      simpl2r simpr cdlemg14f syl123anc simpl1 simpl2 simpl3l simpl3r syl113anc
      cdlemg13 pm2.61dane ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZUFZFEUBZGEU
      BZUCZFDUGGDUGUHZBGUGFUGZCGUGFUGZIUIBCIUIUJZUCZUFZBVNIUIMLUICVOIUIMLUIUHZB
      FUGZBVRVTBUHZUCVFVGVHVJVKWAVSVFVGVHVLVQWAUKVFVGVHVLVQWAULVFVGVHVLVQWAUMVJ
      VKVIVQWAUNVJVKVIVQWAUOVRWAUPABCDEFGHIJKLMNOPQRSTUQURVRVTBUJZUCVIVLWBVMVPV
      SVIVLVQWBUSVIVLVQWBUTVRWBUPVMVPVIVLWBVAVMVPVIVLWBVBABCDEFGHIJKLMNOPQRSTVD
      VCVE $.

    $( Eliminate the
       ` ( ( F `` ( G `` P ) ) .\/ ( F `` ( G `` Q ) ) ) =/= ( P .\/ Q ) `
       condition from ~ cdlemg13 .  TODO:  FIX COMMENT (Contributed by NM,
       25-May-2013.) $)
    cdlemg15 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( F e. T /\ G e. T )
           /\ ( R ` F ) = ( R ` G ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wceq co simpl11 simpl12 simpl13 simpl2l simpl2r
      cfv simpr cdlemg8 syl132anc wne simpl1 simpl2 simpl3 cdlemg15a pm2.61dane
      syl112anc ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZUFZFEUBZGEUBZUCZFDUNG
      DUNUGZUFZBBGUNFUNZIUHMLUHCCGUNFUNZIUHMLUHUGZVNVOIUHZBCIUHZVMVQVRUGZUCVEVF
      VGVIVJVSVPVEVFVGVKVLVSUIVEVFVGVKVLVSUJVEVFVGVKVLVSUKVIVJVHVLVSULVIVJVHVLV
      SUMVMVSUOABCEFGHIJKLMNOPQRSUPUQVMVQVRURZUCVHVKVLVTVPVHVKVLVTUSVHVKVLVTUTV
      HVKVLVTVAVMVTUOABCDEFGHIJKLMNOPQRSTVBVDVC $.

    $( Part of proof of Lemma G of [Crawley] p. 116; 2nd line p. 117, which
       says that (our) ~ cdlemg10 "implies (2)" (of p. 116).  No details are
       provided by the authors, so there may be a shorter proof; but ours
       requires the 14 lemmas, one using Desargues' law ~ dalaw , in order to
       make this inference.  This final step eliminates the
       ` ( R `` F ) =/= ( R `` G ) ` condition from ~ cdlemg12 .  TODO:  FIX
       COMMENT TODO: should we also eliminate ` P =/= Q ` here (or earlier)?
       Do it if we don't need to add it in for something else later.
       (Contributed by NM, 6-May-2013.) $)
    cdlemg16 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( F e. T /\ G e. T /\ P =/= Q )
     /\ ( -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q )
        /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
     = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq simpl1 simpl21 simpl22 cdlemg15
      simpr syl121anc simpl31 simpl32 jca simpl33 cdlemg12 syl113anc pm2.61dane
      simpl2 ) JUAUBMHUBUCBAUBBMKUDUEUCCAUBCMKUDUEUCUFZFEUBZGEUBZBCUGZUFZFDUHZB
      CIUIZKUDUEZGDUHZVKKUDUEZBGUHFUHZCGUHFUHZIUIVKUGZUFZUFZBVOIUIMLUICVPIUIMLU
      IUJZVJVMVSVJVMUJZUCVEVFVGWAVTVEVIVRWAUKVFVGVHVEVRWAULVFVGVHVEVRWAUMVSWAUO
      ABCDEFGHIJKLMNOPQRSTUNUPVSVJVMUGZUCZVEVIVLVNUCWBVQVTVEVIVRWBUKVEVIVRWBVDW
      CVLVNVLVNVQVEVIWBUQVLVNVQVEVIWBURUSVSWBUOVLVNVQVEVIWBUTABCDEFGHIJKLMNOPQR
      STVAVBVC $.

    $( This version of ~ cdlemg16 uses ~ cdlemg15a instead of ~ cdlemg15 , in
       case ~ cdlemg15 ends up not being needed.  TODO:  FIX COMMENT
       (Contributed by NM, 6-May-2013.)  (New usage is discouraged.) $)
    cdlemg16ALTN $p |- ( ( ( K e. HL /\ W e. H
            /\ ( F e. T /\ G e. T ) )
         /\ ( ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) /\ P =/= Q )
         /\ ( ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. ( R ` F ) .<_ ( P .\/ Q )
           /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
     = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa w3a wbr wn wne cfv co wceq simpl11 simpl12 simpl21 simpl22
      simpl13 simpr simpl31 cdlemg15a syl312anc simp13l simp13r simpl23 simpl32
      jca adantr simpl33 cdlemg12 syl333anc pm2.61dane ) JUAUBZMHUBZFEUBZGEUBZU
      CZUDZBAUBBMKUEUFUCZCAUBCMKUEUFUCZBCUGZUDZBGUHFUHZCGUHFUHZIUIBCIUIZUGZFDUH
      ZWBKUEUFZGDUHZWBKUEUFZUDZUDZBVTIUIMLUICWAIUIMLUIUJZWDWFWIWDWFUJZUCZVJVKUC
      ZVPVQVNWKWCWJWLVJVKVJVKVNVSWHWKUKVJVKVNVSWHWKULVDVPVQVRVOWHWKUMVPVQVRVOWH
      WKUNVJVKVNVSWHWKUOWIWKUPWCWEWGVOVSWKUQABCDEFGHIJKLMNOPQRSTURUSWIWDWFUGZUC
      ZWMVPVQVLVMVRWEWGUCWNWCWJWOVJVKVJVKVNVSWHWNUKVJVKVNVSWHWNULVDVPVQVRVOWHWN
      UMVPVQVRVOWHWNUNWIVLWNVLVMVJVKVSWHUTVEWIVMWNVLVMVJVKVSWHVAVEVPVQVRVOWHWNV
      BWOWEWGWCWEWGVOVSWNVCWCWEWGVOVSWNVFVDWIWNUPWCWEWGVOVSWNUQABCDEFGHIJKLMNOP
      QRSTVGVHVI $.

    $( Eliminate
       ` ( ( F `` ( G `` P ) ) .\/ ( F `` ( G `` Q ) ) ) =/= ( P .\/ Q ) `
       condition from ~ cdlemg16 .  TODO: would it help to also eliminate
       ` P =/= Q ` here or later?  (Contributed by NM, 25-May-2013.) $)
    cdlemg16z $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
        /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( F e. T /\ G e. T /\ P =/= Q )
     /\ ( -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
     = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq simpl11 simpl12 simpl13 simpl21
      simpl22 simpr cdlemg8 syl132anc simpl1 simpl3l simpl3r cdlemg16 syl113anc
      simpl2 pm2.61dane ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZUFZFEUBZGEUBZ
      BCUGZUFZFDUHBCIUIZKUDUEZGDUHVNKUDUEZUCZUFZBBGUHFUHZIUIMLUICCGUHFUHZIUIMLU
      IUJZVSVTIUIZVNVRWBVNUJZUCVFVGVHVJVKWCWAVFVGVHVMVQWCUKVFVGVHVMVQWCULVFVGVH
      VMVQWCUMVJVKVLVIVQWCUNVJVKVLVIVQWCUOVRWCUPABCEFGHIJKLMNOPQRSUQURVRWBVNUGZ
      UCVIVMVOVPWDWAVIVMVQWDUSVIVMVQWDVDVOVPVIVMWDUTVOVPVIVMWDVAVRWDUPABCDEFGHI
      JKLMNOPQRSTVBVCVE $.

    $( Eliminate ` P =/= Q ` from ~ cdlemg16z .  TODO:  Use this only if
       needed.  (Contributed by NM, 26-May-2013.) $)
    cdlemg16zz $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
     /\ ( G e. T
        /\ -. ( R ` F ) .<_ ( P .\/ Q ) /\ -. ( R ` G ) .<_ ( P .\/ Q ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wceq id fveq2d oveq12d oveq1d adantl wne
      fveq2 simpl21 simpl22 simpl23 simpl31 simpl32 simpl33 cdlemg16z syl332anc
      simpl1 simpr pm2.61dane ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZFEUBZUF
      ZGEUBZFDUGBCIUHZKUDUEZGDUGVNKUDUEZUFZUFZBBGUGZFUGZIUHZMLUHCCGUGZFUGZIUHZM
      LUHUIZBCBCUIZWEVRWFWAWDMLWFBCVTWCIWFUJWFVSWBFBCGUPUKULUMUNVRBCUOZUCVHVIVJ
      VKVMWGVOVPWEVHVLVQWGVEVIVJVKVHVQWGUQVIVJVKVHVQWGURVIVJVKVHVQWGUSVMVOVPVHV
      LWGUTVRWGVFVMVOVPVHVLWGVAVMVOVPVHVLWGVBABCDEFGHIJKLMNOPQRSTVCVDVG $.

    $( TODO:  FIX COMMENT (Contributed by NM, 8-May-2013.) $)
    cdlemg17a $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
     /\ ( G e. T /\ ( R ` G ) .<_ ( P .\/ Q ) ) )
    -> ( G ` P ) .<_ ( P .\/ Q ) ) $=
      ( wcel chlt wa wbr wn cfv w3a cbs eqid clat simp1l hllat syl simp1 simp3l
      co simp2ll ltrnat syl3anc atbase hlatjcl simp2rl hlatlej2 simp2l syl12anc
      wceq cdleme0cp hlatlej1 trlval2 simp3r eqbrtrrd wb simp1r latmcl latjle12
      lhpbase syl13anc mpbi2and lattrd ) IUATZLGTZUBZBATZBLJUCUDZUBZCATZCLJUCUD
      ZUBZUBZFETZFDUEZBCHUOZJUCZUBZUFZIUGUEZIJBFUEZBWPHUOZWKWOUHZMWNVSIUITZVSVT
      WHWMUJZIUKULZWNWPATZWPWOTWNWAWIWBXBWAWHWMUMZWAWHWIWLUNZWBWCWGWAWMUPZABEFG
      IJLMPQRUQURZAWOWPIWRPUSULWNVSWBXBWQWOTZWTXEXFAWOHIBWPWRNPUTURZWNVSWBWEWKW
      OTZWTXEWEWFWDWAWMVAZAWOHIBCWRNPUTURZWNVSWBXBWPWQJUCWTXEXFABWPHIJMNPVBURWN
      BWQLKUOZHUOZWQWKJWNWAWDXBXMWQVEXCWAWDWGWMVCZXFABWPXLGHIJKLMNOPQXLUHVFVDWN
      BWKJUCZXLWKJUCZXMWKJUCZWNVSWBWEXOWTXEXJABCHIJMNPVGURWNWJXLWKJWNWAWIWDWJXL
      VEXCXDXNABDEFGHIJKLMNOPQRSVHURWAWHWIWLVIVJWNWSBWOTZXLWOTZXIXOXPUBXQVKXAWN
      WBXRXEAWOBIWRPUSULWNWSXGLWOTZXSXAXHWNVTXTVSVTWHWMVLWOGILWRQVOULWOIKWQLWRO
      VMURXKWOHIJBXLWKWRMNVNVPVQVJVR $.

    $d r A $.  $d r G $.  $d r .\/ $.  $d r .<_ $.  $d r P $.  $d r Q $.
    $d r W $.
    $( Part of proof of Lemma G in [Crawley] p. 117, 4th line.  Whenever (in
       their terminology) p ` \/ ` q/0 (i.e. the sublattice from 0 to p ` \/ `
       q) contains precisely three atoms and g is not the identity, g(p) = q.
       See also comments under ~ cdleme0nex .  (Contributed by NM,
       8-May-2013.) $)
    cdlemg17b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
  -> ( G ` P ) = Q ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex simp31 neneqd wo simp11
      simp11l simp12 simp13 simp2l simp32 simp33 simp12l simp13l simp2r syl3anc
      cdlemg17a syl122anc ltrnel cdleme0nex syl331anc ord mpd ) IUAUBZLGUBZUCZB
      AUBZBLJUDUEZUCZCAUBZCLJUDUEZUCZUFZFEUBZBCUGZUCZBFUHZBUGZFDUHBCHUIZJUDZMUJ
      ZLJUDUEBWKHUICWKHUIUKUCMAULUEZUFZUFZWGBUKZUEWGCUKZWNWGBWCWFWHWJWLUMUNWNWO
      WPWNVNWGWIJUDZWLVQVTWEWGAUBWGLJUDUEUCZWOWPUOVNVOVSWBWFWMUQWNVPVSWBWDWJWQV
      PVSWBWFWMUPZVPVSWBWFWMURZVPVSWBWFWMUSWCWDWEWMUTZWCWFWHWJWLVAABCDEFGHIJKLN
      OPQRSTVGVHWCWFWHWJWLVBVQVRVPWBWFWMVCVTWAVPVSWFWMVDWCWDWEWMVEWNVPWDVSWRWSX
      AWTABEFGIJLNQRSVIVFABCWGHIJLMNOQVJVKVLVM $.

    $( TODO: fix comment.  (Contributed by NM, 9-May-2013.)
       (New usage is discouraged.) $)
    cdlemg17dN $p |- ( ( ( K e. HL /\ W e. H
            /\ G e. T )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ P =/= Q )
       /\ ( ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) )
           /\ ( G ` P ) =/= P ) )
    -> ( R ` G ) = ( ( P .\/ Q ) ./\ W ) ) $=
      ( chlt wcel w3a wbr wn wa wne cfv co wceq wrex simp1 simp21 simpl1 simpl2
      cv simpl3 simpr trlval2 syl211anc syl2anc simp11 simp12 jca simp22 simp13
      simp23 simp33 simp31 simp32 cdlemg17b syl323anc oveq2d oveq1d eqtrd ) IUA
      UBZLGUBZFEUBZUCZBAUBBLJUDUEUFZCAUBCLJUDUEUFZBCUGZUCZFDUHZBCHUIZJUDZMUPZLJ
      UDUEBWGHUICWGHUIUJUFMAUKUEZBFUHZBUGZUCZUCZWDBWIHUIZLKUIZWELKUIWLVSVTWDWNU
      JZVSWCWKULVSVTWAWBWKUMZVSVTUFVPVQVRVTWOVPVQVRVTUNVPVQVRVTUOVPVQVRVTUQVSVT
      URABDEFGHIJKLNOPQRSTUSUTVAWLWMWELKWLWICBHWLVPVQUFVTWAVRWBWJWFWHWICUJWLVPV
      QVPVQVRWCWKVBVPVQVRWCWKVCVDWPVSVTWAWBWKVEVPVQVRWCWKVFVSVTWAWBWKVGVSWCWFWH
      WJVHVSWCWFWHWJVIVSWCWFWHWJVJABCDEFGHIJKLMNOPQRSTVKVLVMVNVO $.

    $( Same as ~ cdlemg17dN with fewer antecedents but longer proof TODO: fix
       comment.  (Contributed by NM, 9-May-2013.)
       (New usage is discouraged.) $)
    cdlemg17dALTN $p |- ( ( ( K e. HL /\ W e. H
              /\ G e. T )
           /\ ( ( P e. A /\ -. P .<_ W ) /\ Q e. A /\ P =/= Q )
           /\ ( ( R ` G ) .<_ ( P .\/ Q )
             /\ ( G ` P ) =/= P ) )
      -> ( R ` G ) = ( ( P .\/ Q ) ./\ W ) ) $=
      ( wcel chlt w3a wbr wn wa wne cfv co simp3l simp11 simp12 simp13 syl21anc
      wceq trlle clat cbs hllat syl eqid simp21l simp22 hlatjcl syl3anc lhpbase
      trlcl latlem12 syl13anc mpbi2and cal hlatl simp21 simp3r syl212anc simp23
      wb trlat lhpat atcmp mpbid ) IUATZLGTZFETZUBZBATZBLJUCUDZUEZCATZBCUFZUBZF
      DUGZBCHUHZJUCZBFUGBUFZUEZUBZWKWLLKUHZJUCZWKWQUNZWPWMWKLJUCZWRWDWJWMWNUIWP
      WAWBWCWTWAWBWCWJWOUJZWAWBWCWJWOUKZWAWBWCWJWOULZDEFGIJLMQRSUOUMWPIUPTZWKIU
      QUGZTZWLXETZLXETZWMWTUEWRVPWPWAXDXAIURUSWPWAWBWCXFXAXBXCXEDEFGILXEUTZQRSV
      FUMWPWAWEWHXGXAWEWFWHWIWDWOVAWDWGWHWIWOVBZAXEHIBCXINPVCVDWPWBXHXBXEGILXIQ
      VEUSXEIJKWKWLLXIMOVGVHVIWPIVJTZWKATZWQATZWRWSVPWPWAXKXAIVKUSWPWAWBWGWCWNX
      LXAXBWDWGWHWIWOVLZXCWDWJWMWNVMABDEFGIJLMPQRSVQVNWPWAWBWGWHWIXMXAXBXNXJWDW
      GWHWIWOVOABCGHIJKLMNOPQVRVNAWKWQIJMPVSVDVT $.

    $( TODO: fix comment.  (Contributed by NM, 8-May-2013.) $)
    cdlemg17e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( F ` P ) .\/ ( F ` Q ) ) = ( ( F ` P ) .\/ ( R ` G ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex simp11 simp12 simp13 simp21
      eqid cdlemg2k syl121anc simp22 trlval2 syl3anc simp1 simp23 simp31 simp32
      cfv simp33 cdlemg17b syl123anc oveq2d oveq1d eqtrd eqtr4d ) JUBUCMHUCUDZB
      AUCBMKUEUFUDZCAUCCMKUEUFUDZUGZFEUCZGEUCZBCUHZUGZBGVGZBUHZGDVGZBCIUIZKUEZN
      UJZMKUEUFBWHIUICWHIUIUKUDNAULUFZUGZUGZBFVGZCFVGIUIZWLWFMLUIZIUIZWLWEIUIWK
      VOVPVQVSWMWOUKVOVPVQWBWJUMZVOVPVQWBWJUNZVOVPVQWBWJUOVRVSVTWAWJUPABCEWNFHI
      JKLMSTOPRQWNUQURUSWKWEWNWLIWKWEBWCIUIZMLUIZWNWKVOVTVPWEWSUKWPVRVSVTWAWJUT
      ZWQABDEGHIJKLMOPQRSTUAVAVBWKWRWFMLWKWCCBIWKVRVTWAWDWGWIWCCUKVRWBWJVCWTVRV
      SVTWAWJVDVRWBWDWGWIVEVRWBWDWGWIVFVRWBWDWGWIVHABCDEGHIJKLMNOPQRSTUAVIVJVKV
      LVMVKVN $.

    $( TODO: fix comment.  (Contributed by NM, 8-May-2013.) $)
    cdlemg17f $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( F ` P ) .\/ ( F ` Q ) ) = ( ( F ` P ) .\/ ( G ` ( F ` P ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex cdlemg17e simp11 simp22
      simp21 simp12 ltrnel syl3anc trlval2 simp12l ltrncoat syl121anc cdleme0cp
      oveq2d eqid syl12anc 3eqtrd ) JUBUCMHUCUDZBAUCZBMKUEUFZUDZCAUCCMKUEUFUDZU
      GZFEUCZGEUCZBCUHZUGZBGUIBUHGDUIZBCIUJKUENUKZMKUEUFBWAIUJCWAIUJULUDNAUMUFU
      GZUGZBFUIZCFUIIUJWDVTIUJWDWDWDGUIZIUJZMLUJZIUJZWFABCDEFGHIJKLMNOPQRSTUAUN
      WCVTWGWDIWCVJVQWDAUCWDMKUEUFUDZVTWGULVJVMVNVSWBUOZVOVPVQVRWBUPZWCVJVPVMWI
      WJVOVPVQVRWBUQZVJVMVNVSWBURABEFHJKMORSTUSUTZAWDDEGHIJKLMOPQRSTUAVAUTVFWCV
      JWIWEAUCZWHWFULWJWMWCVJVQVPVKWNWJWKWLVKVLVJVNVSWBVBABEGFHJKMORSTVCVDAWDWE
      WGHIJKLMOPQRSWGVGVEVHVI $.

    $( TODO: fix comment.  (Contributed by NM, 9-May-2013.) $)
    cdlemg17g $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( G ` ( F ` P ) ) .<_ ( ( F ` P ) .\/ ( F ` Q ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv wceq wrex simp11l simp11 simp21 simp12l
      co ltrnat syl3anc simp22 ltrncoat syl121anc hlatlej2 cdlemg17f breqtrrd
      cv ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCCMKUEUFUDZUGZFEUCZGEUCZBCUHZUGZBGU
      IBUHGDUIBCIUPKUENVEZMKUEUFBVRIUPCVRIUPUJUDNAUKUFUGZUGZBFUIZGUIZWAWBIUPZWA
      CFUIIUPKVTVFWAAUCZWBAUCZWBWCKUEVFVGVKVLVQVSULVTVHVNVIWDVHVKVLVQVSUMZVMVNV
      OVPVSUNZVIVJVHVLVQVSUOZABEFHJKMORSTUQURVTVHVOVNVIWEWFVMVNVOVPVSUSWGWHABEG
      FHJKMORSTUTVAAWAWBIJKOPRVBURABCDEFGHIJKLMNOPQRSTUAVCVD $.

    $d r F $.  $d r S $.
    $( TODO: fix comment.  (Contributed by NM, 10-May-2013.) $)
    cdlemg17h $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( ( S e. A /\ -. S .<_ W ) /\ ( F e. T /\ G e. T )
            /\ ( P =/= Q /\ S .<_ ( ( F ` P ) .\/ ( F ` Q ) ) ) )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
      -> ( S = ( F ` P ) \/ S = ( F ` Q ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex ccnv wo simp11l simp23r
      cbs simp11 simp22l simp21l ltrncnvat syl3anc eqid simp12l simp13l hlatjcl
      wb atbase syl ltrnle syl112anc wf1o ltrn1o syl2anc f1ocnvfv2 ltrnj bitr2d
      breq12d mpbid simp33 simp21 ltrncnvel cdleme0nex syl331anc eqcom syl5rbbr
      simp23l f1ocnvfvb orbi12d ) KUCUDZNIUDZUEZBAUDZBNLUFUGZUEZCAUDZCNLUFUGZUE
      ZUHZEAUDZENLUFUGZUEZGFUDZHFUDZUEZBCUIZEBGUJZCGUJZJUKZLUFZUEZUHZBHUJBUIZHD
      UJBCJUKZLUFZOULZNLUFUGBXRJUKCXRJUKUMUEOAUNUGZUHZUHZEGUOUJZBUMZYBCUMZUPZEX
      IUMZEXJUMZUPYAWLYBXPLUFZXSWOWRXHYBAUDZYBNLUFUGUEZYEWLWMWQWTXNXTUQZYAXLYHX
      HXLXDXGXAXTURYAYHYBGUJZXPGUJZLUFZXLYAWNXEYBKUSUJZUDZXPYOUDZYHYNVIWNWQWTXN
      XTUTZXEXFXDXMXAXTVAZYAYIYPYAWNXEXBYIYRYSXBXCXGXMXAXTVBZAEFGIKLNPSTUAVCVDA
      YOYBKYOVEZSVJVKYAWLWOWRYQYKWOWPWNWTXNXTVFZWRWSWNWQXNXTVGZAYOJKBCUUAQSVHVD
      YOFGIKLUCNYBXPUUAPTUAVLVMYAYLEYMXKLYAYOYOGVNZEYOUDZYLEUMYAWNXEUUDYRYSYOFG
      IKUCNUUATUAVOVPZYAXBUUEYTAYOEKUUASVJVKZYOYOEGVQVPYAWNXEBYOUDZCYOUDZYMXKUM
      YRYSYAWOUUHUUBAYOBKUUASVJVKZYAWRUUIUUCAYOCKUUASVJVKZYOFGIJKNBCUUAQTUAVRVM
      VTVSWAXAXNXOXQXSWBUUBUUCXHXLXDXGXAXTWIYAWNXEXDYJYRYSXAXDXGXMXTWCAEFGIKLNP
      STUAWDVDABCYBJKLNOPQSWEWFYAYCYFYDYGYFXIEUMZYAYCXIEWGYAUUDUUHUUEUULYCVIUUF
      UUJUUGYOYOBEGWJVDWHYGXJEUMZYAYDXJEWGYAUUDUUIUUEUUMYDVIUUFUUKUUGYOYOCEGWJV
      DWHWKWA $.

    $( TODO: fix comment.  (Contributed by NM, 10-May-2013.) $)
    cdlemg17i $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( G ` ( F ` P ) ) = ( F ` Q ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex simp11 simp22 simp12 simp21
      cfv ltrnel syl3anc simp31 ltrnatneq syl131anc neneqd jca simp23 cdlemg17g
      wo simp1 simp3 cdlemg17h ord mpd ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUCCMKUEUFU
      DZUGZFEUCZGEUCZBCUHZUGZBGUQBUHZGDUQBCIUIKUEZNUJZMKUEUFBWCIUICWCIUIUKUDNAU
      LUFZUGZUGZBFUQZGUQZWGUKZUFWHCFUQZUKZWFWHWGWFVMVRVNWGAUCWGMKUEUFUDZWAWHWGU
      HVMVNVOVTWEUMZVPVQVRVSWEUNZVMVNVOVTWEUOZWFVMVQVNWLWMVPVQVRVSWEUPZWOABEFHJ
      KMORSTURUSZVPVTWAWBWDUTABWGEGHJKMORSTVAVBVCWFWIWKWFVPWHAUCWHMKUEUFUDZVQVR
      UDVSWHWGWJIUIKUEZUDWEWIWKVGVPVTWEVHWFVMVRWLWRWMWNWQAWGEGHJKMORSTURUSWFVQV
      RWPWNVDWFVSWSVPVQVRVSWEVEABCDEFGHIJKLMNOPQRSTUAVFVDVPVTWEVIABCDWHEFGHIJKL
      MNOPQRSTUAVJVBVKVL $.

    $( TODO: fix comment.  (Contributed by NM, 13-May-2013.) $)
    cdlemg17ir $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( F ` ( G ` P ) ) = ( F ` Q ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex simp22 simp23 cdlemg17b
      simp1 simp3 syl121anc fveq2d ) JUBUCMHUCUDBAUCBMKUEUFUDCAUCCMKUEUFUDUGZFE
      UCZGEUCZBCUHZUGZBGUIZBUHGDUIBCIUJKUENUKZMKUEUFBVGIUJCVGIUJULUDNAUMUFUGZUG
      ZVFCFVIVAVCVDVHVFCULVAVEVHUQVAVBVCVDVHUNVAVBVCVDVHUOVAVEVHURABCDEGHIJKLMN
      OPQRSTUAUPUSUT $.

    $( TODO: fix comment.  (Contributed by NM, 11-May-2013.) $)
    cdlemg17j $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( G ` ( F ` P ) ) = ( F ` ( G ` P ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex cdlemg17i cdlemg17ir eqtr4d
      cfv ) JUBUCMHUCUDBAUCBMKUEUFUDCAUCCMKUEUFUDUGFEUCGEUCBCUHUGBGUPZBUHGDUPBC
      IUIKUENUJZMKUEUFBURIUICURIUIUKUDNAULUFUGUGBFUPGUPCFUPUQFUPABCDEFGHIJKLMNO
      PQRSTUAUMABCDEFGHIJKLMNOPQRSTUAUNUO $.

    $( Utility theorem for swapping ` P ` and ` Q ` .  TODO: fix comment.
       (Contributed by NM, 11-May-2013.) $)
    cdlemg17pq $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
        ->
     ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
            /\ ( P e. A /\ -. P .<_ W ) )
       /\ ( F e. T /\ G e. T /\ Q =/= P )
       /\ ( ( G ` Q ) =/= Q /\ ( R ` G ) .<_ ( Q .\/ P )
        /\ -. E. r e. A ( -. r .<_ W /\ ( Q .\/ r ) = ( P .\/ r ) ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex simp11 simp13 simp12 simp21
      cfv 3jca simp22 simp23 necomd ltrnatneq syl131anc simp11l simp12l simp13l
      simp31 simp32 hlatjcom syl3anc breqtrd simp33 eqcom anbi2i rexbii sylnib
      ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZUGZFEUCZGEUCZBCUHZUGZBGUQ
      BUHZGDUQZBCIUIZKUEZNUJZMKUEUFZBWOIUIZCWOIUIZUKZUDZNAULZUFZUGZUGZVSWEWBUGW
      GWHCBUHZUGCGUQCUHZWLCBIUIZKUEZWPWRWQUKZUDZNAULZUFZUGXDVSWEWBVSWBWEWJXCUMZ
      VSWBWEWJXCUNZVSWBWEWJXCUOZURXDWGWHXEWFWGWHWIXCUPWFWGWHWIXCUSZXDBCWFWGWHWI
      XCUTVAURXDXFXHXLXDVSWHWBWEWKXFXMXPXOXNWFWJWKWNXBVGABCEGHJKMORSTVBVCXDWLWM
      XGKWFWJWKWNXBVHXDVQVTWCWMXGUKVQVRWBWEWJXCVDVTWAVSWEWJXCVEWCWDVSWBWJXCVFAI
      JBCPRVIVJVKXDXAXKWFWJWKWNXBVLWTXJNAWSXIWPWQWRVMVNVOVPURUR $.

    $( ~ cdlemg17b with ` P ` and ` Q ` swapped.  Antecedent
       ` F e. ( T `` W ) ` is redundant for easier use.  TODO: should we have
       redundant antecedent for ~ cdlemg17b also?  (Contributed by NM,
       13-May-2013.) $)
    cdlemg17bq $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
  -> ( G ` Q ) = P ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq cdlemg17pq simp11 simp12 simp13
      cv wrex simp22 simp23 simp3 cdlemg17b syl321anc syl ) JUBUCMHUCUDZBAUCBMK
      UEUFUDZCAUCCMKUEUFUDZUGFEUCZGEUCZBCUHUGBGUIBUHGDUIZBCIUJKUENUPZMKUEUFZBVJ
      IUJZCVJIUJZUKUDNAUQUFUGUGVDVFVEUGZVGVHCBUHZUGZCGUIZCUHVICBIUJKUEVKVMVLUKU
      DNAUQUFUGZUGZVQBUKZABCDEFGHIJKLMNOPQRSTUAULVSVDVFVEVHVOVRVTVDVFVEVPVRUMVD
      VFVEVPVRUNVDVFVEVPVRUOVNVGVHVOVRURVNVGVHVOVRUSVNVPVRUTACBDEGHIJKLMNOPQRST
      UAVAVBVC $.

    $( ~ cdlemg17i with ` P ` and ` Q ` swapped.  (Contributed by NM,
       13-May-2013.)  (New usage is discouraged.) $)
    cdlemg17iqN $p |- ( ( ( K e. HL /\ W e. H
          /\ ( F e. T /\ G e. T ) )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ P =/= Q )
       /\ ( ( R ` G ) .<_ ( P .\/ Q )
         /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) )
         /\ ( G ` P ) =/= P ) )
  -> ( G ` ( F ` Q ) ) = ( F ` P ) ) $=
      ( chlt wcel wa w3a wbr wn wne co cv wceq wrex simp11 simp12 simp21 simp22
      cfv jca simp13l simp13r simp23 simp33 simp31 simp32 cdlemg17pq syl333anc
      cdlemg17i syl ) JUBUCZMHUCZFEUCZGEUCZUDZUEZBAUCBMKUFUGUDZCAUCCMKUFUGUDZBC
      UHZUEZGDUQZBCIUIKUFZNUJZMKUFUGZBWAIUIZCWAIUIZUKUDNAULUGZBGUQBUHZUEZUEZVIV
      JUDZVPVOUEVKVLCBUHUECGUQCUHVSCBIUIKUFWBWDWCUKUDNAULUGUEUEZCFUQGUQBFUQUKWH
      WIVOVPVKVLVQWFVTWEWJWHVIVJVIVJVMVRWGUMVIVJVMVRWGUNURVNVOVPVQWGUOVNVOVPVQW
      GUPVKVLVIVJVRWGUSVKVLVIVJVRWGUTVNVOVPVQWGVAVNVRVTWEWFVBVNVRVTWEWFVCVNVRVT
      WEWFVDABCDEFGHIJKLMNOPQRSTUAVEVFACBDEFGHIJKLMNOPQRSTUAVGVH $.

    $( ~ cdlemg17ir with ` P ` and ` Q ` swapped.  (Contributed by NM,
       13-May-2013.) $)
    cdlemg17irq $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( F ` ( G ` Q ) ) = ( F ` P ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq wrex cdlemg17pq cdlemg17ir syl
      cv ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUCCMKUEUFUDZUGFEUCZGEUCZBCUHUGBGUIBUHGDU
      IZBCIUJKUENUPZMKUEUFZBVCIUJZCVCIUJZUKUDNAULUFUGUGUQUSURUGUTVACBUHUGCGUIZC
      UHVBCBIUJKUEVDVFVEUKUDNAULUFUGUGVGFUIBFUIUKABCDEFGHIJKLMNOPQRSTUAUMACBDEF
      GHIJKLMNOPQRSTUAUNUO $.

    $( ~ cdlemg17j with ` P ` and ` Q ` swapped.  (Contributed by NM,
       13-May-2013.) $)
    cdlemg17jq $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( G ` ( F ` Q ) ) = ( F ` ( G ` Q ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq wrex cdlemg17pq cdlemg17j syl
      cv ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUCCMKUEUFUDZUGFEUCZGEUCZBCUHUGBGUIBUHGDU
      IZBCIUJKUENUPZMKUEUFZBVCIUJZCVCIUJZUKUDNAULUFUGUGUQUSURUGUTVACBUHUGCGUIZC
      UHVBCBIUJKUEVDVFVEUKUDNAULUFUGUGCFUIGUIVGFUIUKABCDEFGHIJKLMNOPQRSTUAUMACB
      DEFGHIJKLMNOPQRSTUAUNUO $.

    $( Part of Lemma G of [Crawley] p. 117, lines 7 and 8.  We show an argument
       whose value at ` G ` equals itself.  TODO: fix comment.  (Contributed by
       NM, 12-May-2013.) $)
    cdlemg17 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( G ` P ) =/= P /\ ( R ` G ) .<_ ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
  -> ( G ` ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) ) )
      = ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex cbs simp11 simp12l eqid
      simp22 atbase syl simp21 syl121anc ltrnj syl112anc simp1 simp23 cdlemg17b
      ltrncoat simp3 fveq2d cdlemg17jq eqtrd oveq12d simp13l cdlemg17bq simp11l
      cdlemg17j hlatjcl syl3anc ltrnm clat hllat latmcom 3eqtr4d ) JUBUCZMHUCZU
      DZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZUGZFEUCZGEUCZBCUHZUGZBGUIZBUHGDUIBCIUJK
      UENUKZMKUEUFBWTIUJCWTIUJULUDNAUMUFUGZUGZBWSFUIZIUJZGUIZCCGUIZFUIZIUJZGUIZ
      LUJZXHXDLUJZXDXHLUJZGUIZXLXBXEXHXIXDLXBXEWSXCGUIZIUJZXHXBWGWPBJUNUIZUCZXC
      XPUCZXEXOULWGWJWMWRXAUOZWNWOWPWQXAURZXBWHXQWHWIWGWMWRXAUPZAXPBJXPUQZRUSUT
      XBXCAUCZXRXBWGWOWPWHYCXSWNWOWPWQXAVAZXTYAABEFGHJKMORSTVHVBZAXPXCJYBRUSUTX
      PEGHIJMBXCYBPSTVCVDXBWSCXNXGIXBWNWPWQXAWSCULWNWRXAVEXTWNWOWPWQXAVFWNWRXAV
      IABCDEGHIJKLMNOPQRSTUAVGVBZXBXNCFUIZGUIXGXBXCYGGXBWSCFYFVJVJABCDEFGHIJKLM
      NOPQRSTUAVKVLVMVLXBXIXFXGGUIZIUJZXDXBWGWPCXPUCZXGXPUCZXIYIULXSXTXBWKYJWKW
      LWGWJWRXAVNZAXPCJYBRUSUTXBXGAUCZYKXBWGWOWPWKYMXSYDXTYLACEFGHJKMORSTVHVBZA
      XPXGJYBRUSUTXPEGHIJMCXGYBPSTVCVDXBXFBYHXCIABCDEFGHIJKLMNOPQRSTUAVOZXBYHBF
      UIZGUIXCXBXGYPGXBXFBFYOVJVJABCDEFGHIJKLMNOPQRSTUAVQVLVMVLVMXBWGWPXDXPUCZX
      HXPUCZXMXJULXSXTXBWEWHYCYQWEWFWJWMWRXAVPZYAYEAXPIJBXCYBPRVRVSZXBWEWKYMYRY
      SYLYNAXPIJCXGYBPRVRVSZXPEGHJLMXDXHYBQSTVTVDXBJWAUCZYQYRXLXKULXBWEUUBYSJWB
      UTYTUUAXPJLXDXHYBQWCVSWD $.

    $( Show two lines are different.  TODO: fix comment.  (Contributed by NM,
       14-May-2013.) $)
    cdlemg18a $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( P e. A /\ Q e. A /\ F e. T )
           /\ ( P =/= Q /\ ( ( F ` Q ) .\/ ( F ` P ) ) =/= ( P .\/ Q ) ) )
      -> ( P .\/ ( F ` Q ) ) =/= ( Q .\/ ( F ` P ) ) ) $=
      ( wcel chlt wa w3a wne cfv co simp3r wceq simpl1l simpl21 simpl23 simpl22
      simpl1 ltrnat syl3anc ltrn11at syl113anc necomd simpr hlatexch4 syl323anc
      simpl3l eqcomd ex necon3d mpd ) IUATZLGTZUBZBATZCATZFETZUCZBCUDZCFUEZBFUE
      ZHUFZBCHUFZUDZUBZUCZVSBVOHUFZCVPHUFZUDVIVMVNVSUGWAWBWCVQVRWAWBWCUHZVQVRUH
      WAWDUBZVRVQWEVGVJVOATZVKVPATZVNVOVPUDWDVRVQUHVGVHVMVTWDUIVJVKVLVIVTWDUJZW
      EVIVLVKWFVIVMVTWDUMZVJVKVLVIVTWDUKZVJVKVLVIVTWDULZACEFGIJLMPQRUNUOWKWEVIV
      LVJWGWIWJWHABEFGIJLMPQRUNUOVNVSVIVMWDVBZWEVPVOWEVIVLVJVKVNVPVOUDWIWJWHWKW
      LABCEFGILPQRUPUQURWAWDUSABVOCVPHINPUTVAVCVDVEVF $.

    ${
      cdlemg18b.u $e |- U = ( ( P .\/ Q ) ./\ W ) $.
      $( Lemma for ~ cdlemg18c .  TODO: fix comment.  (Contributed by NM,
         15-May-2013.) $)
      cdlemg18b $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
        /\ ( P =/= Q /\ ( F ` P ) =/= Q /\
           ( ( F ` Q ) .\/ ( F ` P ) ) =/= ( P .\/ Q ) ) )
        -> -. P .<_ ( U .\/ ( F ` Q ) ) ) $=
        ( chlt wcel wa wbr wn w3a wne cfv co simp33 simp3r simp1l simp1r simp21
        wceq wi simp22l simp3l1 cdleme0a syl212anc simp1 simp23 ltrnat hlatlej1
        syl3anc clat cbs wb hllat simp21l eqid atbase hlatjcl latjle12 syl13anc
        mpbi2and cdleme0cp syl22anc simp22 cdlemg2kq syl121anc hlatjcom 3brtr3d
        syl eqtr2d ps-1 syl132anc mpbid 3exp exp4a 3imp necon3ad mpd ) JUBUCZMH
        UCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZGEUCZUGZBCUHZBGUIZCUHZCGUIZXGIUJZ
        BCIUJZUHZUGZUGZXLBFXIIUJZKUEZUFWQXEXFXHXLUKXNXPXJXKWQXEXMXPXJXKUPZUQWQX
        EXMXPXQWQXEXMXPUDZXQWQXEXRUGZXKXGXIIUJZXJXSXKXTKUEZXKXTUPZXSBFIUJZXOXKX
        TKXSXPFXOKUEZYCXOKUEZWQXEXMXPULXSWOFAUCZXIAUCZYDWOWPXEXRUMZXSWOWPWTXAXF
        YFYHWOWPXEXRUNZWQWTXCXDXRUOZXAXBWTXDWQXRURZXFXHXLXPWQXEUSZABCFHIJKLMNOP
        QRUAUTVAZXSWQXDXAYGWQXEXRVBZWQWTXCXDXRVCZYKACEGHJKMNQRSVDVFZAFXIIJKNOQV
        EVFXSJVGUCZBJVHUIZUCZFYRUCZXOYRUCZXPYDUDYEVIXSWOYQYHJVJWEXSWRYSWRWSXCXD
        WQXRVKZAYRBJYRVLZQVMWEXSYFYTYMAYRFJUUCQVMWEXSWOYFYGUUAYHYMYPAYRIJFXIUUC
        OQVNVFYRIJKBFXOUUCNOVOVPVQXSWOWPWTXAYCXKUPYHYIYJYKABCFHIJKLMNOPQRUAVRVS
        XSXTXIFIUJZXOXSWQWTXCXDXTUUDUPYNYJWQWTXCXDXRVTYOABCEFGHIJKLMRSNOQPUAWAW
        BXSWOYGYFUUDXOUPYHYPYMAIJXIFOQWCVFWFWDXSWOWRXAXFXGAUCZYGYAYBVIYHUUBYKYL
        XSWQXDWRUUEYNYOUUBABEGHJKMNQRSVDVFZYPABCXGXIIJKNOQWGWHWIXSWOUUEYGXTXJUP
        YHUUFYPAIJXGXIOQWCVFWFWJWKWLWMWN $.

      $( Show two lines intersect at an atom.  TODO: fix comment.  (Contributed
         by NM, 15-May-2013.) $)
      cdlemg18c $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
        /\ ( P =/= Q /\ ( F ` P ) =/= Q /\
           ( ( F ` Q ) .\/ ( F ` P ) ) =/= ( P .\/ Q ) ) )
        -> ( ( P .\/ ( F ` Q ) ) ./\ ( Q .\/ ( F ` P ) ) ) e. A ) $=
        ( chlt wcel wbr w3a wne cfv simp1l simp21l simp1r simp21 simp22l simp31
        wa wn co cdleme0a syl212anc simp1 simp23 ltrnat cdlemg18b simp32 necomd
        syl3anc jca simp33 cdlemg18a syl132anc hlatlej2 wceq cdleme0cp syl22anc
        breqtrrd simp22 cdlemg2kq syl121anc hlatjcom 3eqtr3d breqtrd syl333anc
        ps-2c ) JUBUCZMHUCZUNZBAUCZBMKUDUOZUNZCAUCZCMKUDUOZUNZGEUCZUEZBCUFZBGUG
        ZCUFZCGUGZWOIUPZBCIUPZUFZUEZUEZWCWFFAUCZWQAUCZWIWOAUCZBFWQIUPZKUDUOZCWO
        UFZUNBWQIUPZCWOIUPZUFZCBFIUPZKUDZWOXFKUDZUNXIXJLUPAUCWCWDWMXAUHZWFWGWKW
        LWEXAUIZXBWCWDWHWIWNXCXOWCWDWMXAUJZWEWHWKWLXAUKZWIWJWHWLWEXAULZWEWMWNWP
        WTUMZABCFHIJKLMNOPQRUAUQURZXBWEWLWIXDWEWMXAUSZWEWHWKWLXAUTZXSACEGHJKMNQ
        RSVAVEZXSXBWEWLWFXEYBYCXPABEGHJKMNQRSVAVEZXBXGXHABCDEFGHIJKLMNOPQRSTUAV
        BXBWOCWEWMWNWPWTVCVDVFXBWEWFWIWLWNWTXKYBXPXSYCXTWEWMWNWPWTVGABCDEGHIJKL
        MNOPQRSTVHVIXBXMXNXBCWSXLKXBWCWFWICWSKUDXOXPXSABCIJKNOQVJVEXBWCWDWHWIXL
        WSVKXOXQXRXSABCFHIJKLMNOPQRUAVLVMVNXBWOWRXFKXBWCXDXEWOWRKUDXOYDYEAWQWOI
        JKNOQVJVEXBWOWQIUPZWQFIUPZWRXFXBWEWHWKWLYFYGVKYBXRWEWHWKWLXAVOYCABCEFGH
        IJKLMRSNOQPUAVPVQXBWCXEXDYFWRVKXOYEYDAIJWOWQOQVRVEXBWCXDXCYGXFVKXOYDYAA
        IJWQFOQVRVEVSVTVFABFWQCWOIJKLNOPQWBWA $.
    $}

    $( Show two lines intersect at an atom.  TODO: fix comment.  (Contributed
       by NM, 15-May-2013.) $)
    cdlemg18d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( ( F e. T /\ G e. T ) /\ P =/= Q /\ ( G ` P ) =/= P )
        /\ ( ( R ` G ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
   -> ( ( P .\/ ( F ` ( G ` P ) ) )
          ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) ) e. A ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex simp1 simp21r simp22 simp23
      cfv simp31 simp33 cdlemg17b syl123anc fveq2d simp21l cdlemg17bq syl133anc
      oveq2d oveq12d simp11 simp12 simp13 simp32 eqnetrrd cdlemg17irq cdlemg18c
      cdlemg11aq eqid eqeltrd ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUCCMKUEUFUDZUGZFEUC
      ZGEUCZUDZBCUHZBGUQZBUHZUGZGDUQBCIUIZKUEZWFFUQZCGUQZFUQZIUIZWIUHZNUJZMKUEU
      FBWPIUICWPIUIUKUDNAULUFZUGZUGZBWKIUIZCWMIUIZLUIBCFUQZIUIZCBFUQZIUIZLUIZAW
      SWTXCXAXELWSWKXBBIWSWFCFWSWAWCWEWGWJWQWFCUKWAWHWRUMZWBWCWEWGWAWRUNZWAWDWE
      WGWRUOZWAWDWEWGWRUPZWAWHWJWOWQURZWAWHWJWOWQUSZABCDEGHIJKLMNOPQRSTUAUTVAVB
      ZVFWSWMXDCIWSWLBFWSWAWBWCWEWGWJWQWLBUKXGWBWCWEWGWAWRVCZXHXIXJXKXLABCDEFGH
      IJKLMNOPQRSTUAVDVEVBZVFVGWSVRVSVTWBWEXDCUHXBXDIUIZWIUHXFAUCVRVSVTWHWRVHZV
      RVSVTWHWRVIZVRVSVTWHWRVJZXNXIWSWMXDCXOWSVRVSVTWBWCWOWMCUHXQXRXSXNXHWAWHWJ
      WOWQVKZABCEFGHIJKLMOPQRSTVOVAVLWSWNXPWIWSWKXBWMXDIXMWSWAWBWCWEWGWJWQWMXDU
      KXGXNXHXIXJXKXLABCDEFGHIJKLMNOPQRSTUAVMVEVGXTVLABCDEWIMLUIZFHIJKLMOPQRSTU
      AYAVPVNVEVQ $.

    $( Part of proof of Lemma G of [Crawley] p. 116.  Line 10 of p. 117, (p
       ` \/ ` fg(p)) ` /\ ` (q ` \/ ` fg(q)) ` <_ ` w.  TODO: fix comment. $)
    $( Show two lines intersect at an atom.  TODO: fix comment.  (Contributed
       by NM, 15-May-2013.) $)
    cdlemg18 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( ( F e. T /\ G e. T ) /\ P =/= Q /\ ( G ` P ) =/= P )
       /\ ( ( R ` G ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) )
          ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) ) .<_ W ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex simp11 simp12 cdlemg18d
      simp21r simp23 simp1 simp21l simp22 cdlemg17 syl133anc ltrnatlw syl132anc
      simp31 simp33 ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUCCMKUEUFUDZUGZFEUCZGEUCZUDZB
      CUHZBGUIZBUHZUGZGDUIBCIUJZKUEZVPFUIZCGUIFUIZIUJVSUHZNUKZMKUEUFBWDIUJCWDIU
      JULUDNAUMUFZUGZUGZVHVMVIBWAIUJCWBIUJLUJZAUCVQWHGUIWHULZWHMKUEVHVIVJVRWFUN
      VLVMVOVQVKWFUQZVHVIVJVRWFUOABCDEFGHIJKLMNOPQRSTUAUPVKVNVOVQWFURZWGVKVLVMV
      OVQVTWEWIVKVRWFUSVLVMVOVQVKWFUTWJVKVNVOVQWFVAWKVKVRVTWCWEVFVKVRVTWCWEVGAB
      CDEFGHIJKLMNOPQRSTUAVBVCABWHEGHJKMORSTVDVE $.

    $( Part of proof of Lemma G of [Crawley] p. 116.  Line 10 of p. 117, (p
       ` \/ ` fg(p)) ` /\ ` (q ` \/ ` fg(q)) ` <_ ` w.  TODO: fix comment. $)
    $( Show two lines intersect at an atom.  TODO: fix comment.  (Contributed
       by NM, 15-May-2013.) $)
    cdlemg19a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( ( F e. T /\ G e. T ) /\ P =/= Q /\ ( G ` P ) =/= P )
         /\ ( ( R ` G ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ ( Q .\/ ( F ` ( G ` Q ) ) ) )
         = ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq wrex clat cbs simp11l hllat syl
      cv simp12l simp11 simp21 ltrncoat syl3anc eqid hlatjcl simp13l latmle1 wb
      cdlemg18 cdlemg18d atbase simp11r latlem12 syl13anc mpbi2and hlatl simp12
      lhpbase simp13 simp21l simp21r simp32 cdlemg11a syl123anc lhpat syl112anc
      cal necomd atcmp mpbid ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZUG
      ZFEUCZGEUCZUDZBCUHZBGUIZBUHZUGZGDUIBCIUJZKUEZXEFUIZCGUIFUIZIUJXHUHZNURZMK
      UEUFBXMIUJCXMIUJUKUDNAULUFZUGZUGZBXJIUJZCXKIUJZLUJZXQMLUJZKUEZXSXTUKZXPXS
      XQKUEZXSMKUEZYAXPJUMUCZXQJUNUIZUCZXRYFUCZYCXPWKYEWKWLWPWSXGXOUOZJUPUQZXPW
      KWNXJAUCZYGYIWNWOWMWSXGXOUSZXPWMXCWNYKWMWPWSXGXOUTZWTXCXDXFXOVAZYLABEFGHJ
      KMORSTVBVCZAYFIJBXJYFVDZPRVEVCZXPWKWQXKAUCZYHYIWQWRWMWPXGXOVFZXPWMXCWQYRY
      MYNYSACEFGHJKMORSTVBVCAYFIJCXKYPPRVEVCYFJKLXQXRYPOQVGVCABCDEFGHIJKLMNOPQR
      STUAVIXPYEXSYFUCZYGMYFUCZYCYDUDYAVHYJXPXSAUCZYTABCDEFGHIJKLMNOPQRSTUAVJZA
      YFXSJYPRVKUQYQXPWLUUAWKWLWPWSXGXOVLYFHJMYPSVRUQYFJKLXSXQMYPOQVMVNVOXPJWGU
      CZUUBXTAUCZYAYBVHXPWKUUDYIJVPUQUUCXPWMWPYKBXJUHUUEYMWMWPWSXGXOVQZYOXPXJBX
      PWMWPWSXAXBXLXJBUHYMUUFWMWPWSXGXOVSXAXBXDXFWTXOVTXAXBXDXFWTXOWAWTXGXIXLXN
      WBABCEFGHIJKLMOPQRSTWCWDWHABXJHIJKLMOPQRSWEWFAXSXTJKORWIVCWJ $.

    $( Part of proof of Lemma G of [Crawley] p. 116.  Line 11 of p. 117.  TODO:
       fix comment. $)
    $( Show two lines intersect at an atom.  TODO: fix comment.  (Contributed
       by NM, 15-May-2013.) $)
    cdlemg19 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( ( F e. T /\ G e. T ) /\ P =/= Q /\ ( G ` P ) =/= P )
         /\ ( ( R ` G ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
         = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co wceq wrex clat cbs simp11l hllat syl
      cv simp12l simp11 ltrncoat syl3anc eqid hlatjcl simp13l latmcom cdlemg19a
      simp21 simp13 simp12 simp22 necomd simp21r simp23 simp31 hlatjcom breqtrd
      ltrnatneq syl131anc simp32 3netr3d simp33 anbi2i rexbii syl333anc 3eqtr3d
      eqcom sylnib ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZUGZFEUCZGEUC
      ZUDZBCUHZBGUIZBUHZUGZGDUIZBCIUJZKUEZXCFUIZCGUIZFUIZIUJZXGUHZNURZMKUEUFZBX
      NIUJZCXNIUJZUKZUDZNAULZUFZUGZUGZBXIIUJZCXKIUJZLUJZYEYDLUJZYDMLUJYEMLUJZYC
      JUMUCZYDJUNUIZUCZYEYJUCZYFYGUKYCWIYIWIWJWNWQXEYBUOZJUPUQYCWIWLXIAUCZYKYMW
      LWMWKWQXEYBUSZYCWKXAWLYNWKWNWQXEYBUTZWRXAXBXDYBVHZYOABEFGHJKMORSTVAVBZAYJ
      IJBXIYJVCZPRVDVBYCWIWOXKAUCZYLYMWOWPWKWNXEYBVEZYCWKXAWOYTYPYQUUAACEFGHJKM
      ORSTVAVBZAYJIJCXKYSPRVDVBYJJLYDYEYSQVFVBABCDEFGHIJKLMNOPQRSTUAVGYCWKWQWNX
      ACBUHXJCUHZXFCBIUJZKUEXKXIIUJZUUDUHXOXQXPUKZUDZNAULZUFYGYHUKYPWKWNWQXEYBV
      IZWKWNWQXEYBVJZYQYCBCWRXAXBXDYBVKVLYCWKWTWNWQXDUUCYPWSWTXBXDWRYBVMUUJUUIW
      RXAXBXDYBVNABCEGHJKMORSTVRVSYCXFXGUUDKWRXEXHXMYAVOYCWIWLWOXGUUDUKYMYOUUAA
      IJBCPRVPVBZVQYCXLXGUUEUUDWRXEXHXMYAVTYCWIYNYTXLUUEUKYMYRUUBAIJXIXKPRVPVBU
      UKWAYCXTUUHWRXEXHXMYAWBXSUUGNAXRUUFXOXPXQWGWCWDWHACBDEFGHIJKLMNOPQRSTUAVG
      WEWF $.

    $( ~ cdlemg19 with ` ( G `` P ) =/= P ` condition removed. $)
    $( Show two lines intersect at an atom.  TODO: fix comment.  (Contributed
       by NM, 23-May-2013.) $)
    cdlemg20 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( R ` G ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
         = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex simpl11 simpl12 simpl13
      simpl21 simpl22 simpr cdlemg14g syl123anc simpl23 simpl31 simpl32 simpl33
      simpl1 jca cdlemg19 syl133anc pm2.61dane ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUC
      CMKUEUFUDZUGZFEUCZGEUCZBCUHZUGZGDUIBCIUJZKUEZBGUIZFUIZCGUIFUIZIUJVSUHZNUK
      ZMKUEUFBWEIUJCWEIUJULUDNAUMUFZUGZUGZBWBIUJMLUJCWCIUJMLUJULZWABWHWABULZUDV
      KVLVMVOVPWJWIVKVLVMVRWGWJUNVKVLVMVRWGWJUOVKVLVMVRWGWJUPVOVPVQVNWGWJUQVOVP
      VQVNWGWJURWHWJUSABCDEFGHIJKLMOPQRSTUAUTVAWHWABUHZUDZVNVOVPUDVQWKVTWDWFWIV
      NVRWGWKVFWLVOVPVOVPVQVNWGWKUQVOVPVQVNWGWKURVGVOVPVQVNWGWKVBWHWKUSVTWDWFVN
      VRWKVCVTWDWFVNVRWKVDVTWDWFVNVRWKVEABCDEFGHIJKLMNOPQRSTUAVHVIVJ $.

    $( Version of cdlemg19 with ` ( R `` F ) .<_ ( P .\/ Q ) ` instead of
       ` ( R `` G ) .<_ ( P .\/ Q ) ` as a condition.  (Contributed by NM,
       23-May-2013.) $)
    cdlemg21 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( ( F e. T /\ G e. T ) /\ P =/= Q /\ ( F ` P ) =/= P )
         /\ ( ( R ` F ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
         = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq simp1 simp21r simp21l simp22
      wrex simp23 simp31 simp33 cdlemg17j syl133anc simp11 simp13 simp12 necomd
      ltrnatneq syl131anc simp11l simp12l simp13l hlatjcom syl3anc eqcom anbi2i
      jca breqtrd rexbii sylnib syl333anc oveq12d simp32 eqnetrrd oveq2d oveq1d
      cdlemg19 3eqtr4d ) JUBUCZMHUCZUDZBAUCZBMKUEUFZUDZCAUCZCMKUEUFZUDZUGZFEUCZ
      GEUCZUDZBCUHZBFUIZBUHZUGZFDUIZBCIUJZKUEZBGUIFUIZCGUIFUIZIUJZXFUHZNUKZMKUE
      UFZBXLIUJZCXLIUJZULZUDZNAUQZUFZUGZUGZBXBGUIZIUJZMLUJZCCFUIZGUIZIUJZMLUJZB
      XHIUJZMLUJCXIIUJZMLUJYAWQWSWRUDXAXCXGYBYFIUJZXFUHXSYDYHULWQXDXTUMZYAWSWRW
      RWSXAXCWQXTUNZWRWSXAXCWQXTUOZVPWQWTXAXCXTUPZWQWTXAXCXTURZWQXDXGXKXSUSZYAX
      JYKXFYAXHYBXIYFIYAWQWSWRXAXCXGXSXHYBULYLYMYNYOYPYQWQXDXGXKXSUTZABCDEGFHIJ
      KLMNOPQRSTUAVAVBZYAWJWPWMWSWRCBUHYECUHZXECBIUJZKUEXMXOXNULZUDZNAUQZUFXIYF
      ULWJWMWPXDXTVCZWJWMWPXDXTVDZWJWMWPXDXTVEZYMYNYABCYOVFYAWJWRWMWPXCYTUUEYNU
      UGUUFYPABCEFHJKMORSTVGVHYAXEXFUUAKYQYAWHWKWNXFUUAULWHWIWMWPXDXTVIWKWLWJWP
      XDXTVJWNWOWJWMXDXTVKAIJBCPRVLVMVQYAXRUUDYRXQUUCNAXPUUBXMXNXOVNVOVRVSACBDE
      GFHIJKLMNOPQRSTUAVAVTZWAWQXDXGXKXSWBWCYRABCDEGFHIJKLMNOPQRSTUAWFVBYAYIYCM
      LYAXHYBBIYSWDWEYAYJYGMLYAXIYFCIUUHWDWEWG $.

    $( ~ cdlemg21 with ` ( F `` P ) =/= P ` condition removed.  (Contributed by
       NM, 23-May-2013.) $)
    cdlemg22 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( R ` F ) .<_ ( P .\/ Q )
           /\ ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
         = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv co cv wceq wrex simpl11 simpl12 simpl13
      simpl21 simpl22 simpr cdlemg14f syl123anc simpl23 simpl31 simpl32 simpl33
      simpl1 jca cdlemg21 syl133anc pm2.61dane ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUC
      CMKUEUFUDZUGZFEUCZGEUCZBCUHZUGZFDUIBCIUJZKUEZBGUIFUIZCGUIFUIZIUJVSUHZNUKZ
      MKUEUFBWDIUJCWDIUJULUDNAUMUFZUGZUGZBWAIUJMLUJCWBIUJMLUJULZBFUIZBWGWIBULZU
      DVKVLVMVOVPWJWHVKVLVMVRWFWJUNVKVLVMVRWFWJUOVKVLVMVRWFWJUPVOVPVQVNWFWJUQVO
      VPVQVNWFWJURWGWJUSABCDEFGHIJKLMOPQRSTUAUTVAWGWIBUHZUDZVNVOVPUDVQWKVTWCWEW
      HVNVRWFWKVFWLVOVPVOVPVQVNWFWKUQVOVPVQVNWFWKURVGVOVPVQVNWFWKVBWGWKUSVTWCWE
      VNVRWKVCVTWCWEVNVRWKVDVTWCWEVNVRWKVEABCDEFGHIJKLMNOPQRSTUAVHVIVJ $.

    $( Combine ~ cdlemg16z and ~ cdlemg22 .  TODO:  Fix comment.  (Contributed
       by NM, 24-May-2013.) $)
    cdlemg24 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
            /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F e. T /\ G e. T /\ P =/= Q )
         /\ ( ( ( F ` ( G ` P ) ) .\/ ( F ` ( G ` Q ) ) ) =/= ( P .\/ Q )
           /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
     = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne co cv wceq wrex simpl1 simpl2 simpr simpl3l
      cfv simpl3r cdlemg22 syl113anc cdlemg20 simprl simprr cdlemg16z syl112anc
      pm2.61ddan ) JUBUCMHUCUDBAUCBMKUEUFUDCAUCCMKUEUFUDUGZFEUCGEUCBCUHUGZBGUQF
      UQZCGUQFUQZIUIBCIUIZUHZNUJZMKUEUFBVMIUICVMIUIUKUDNAULUFZUDZUGZFDUQVKKUEZG
      DUQVKKUEZBVIIUIMLUICVJIUIMLUIUKZVPVQUDVGVHVQVLVNVSVGVHVOVQUMVGVHVOVQUNVPV
      QUOVLVNVGVHVQUPVLVNVGVHVQURABCDEFGHIJKLMNOPQRSTUAUSUTVPVRUDVGVHVRVLVNVSVG
      VHVOVRUMVGVHVOVRUNVPVRUOVLVNVGVHVRUPVLVNVGVHVRURABCDEFGHIJKLMNOPQRSTUAVAU
      TVPVQUFZVRUFZUDZUDVGVHVTWAVSVGVHVOWBUMVGVHVOWBUNVPVTWAVBVPVTWAVCABCDEFGHI
      JKLMOPQRSTUAVDVEVF $.

    $( Use ~ cdlemg8 to eliminate the ` =/= ( P .\/ Q ) ` condition of
       ~ cdlemg24 .  (Contributed by NM, 31-May-2013.) $)
    cdlemg37 $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) /\ F e. T )
      /\ ( G e. T /\ P =/= Q
         /\ -. E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
  -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
     = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a wne cv co wceq wrex simpl1 simpl2 simpl31 simpr
      cfv cdlemg8 syl112anc simpl21 simpl22 simpl23 simpl32 cdlemg24 pm2.61dane
      simpl33 syl332anc ) JUBUCMHUCUDZBAUCBMKUEUFUDZCAUCCMKUEUFUDZFEUCZUGZGEUCZ
      BCUHZNUIZMKUEUFBVOIUJCVOIUJUKUDNAULUFZUGZUGZBBGUQFUQZIUJMLUJCCGUQFUQZIUJM
      LUJUKZVSVTIUJZBCIUJZVRWBWCUKZUDVHVLVMWDWAVHVLVQWDUMVHVLVQWDUNVMVNVPVHVLWD
      UOVRWDUPABCEFGHIJKLMOPQRSTURUSVRWBWCUHZUDVHVIVJVKVMVNWEVPWAVHVLVQWEUMVIVJ
      VKVHVQWEUTVIVJVKVHVQWEVAVIVJVKVHVQWEVBVMVNVPVHVLWEUOVMVNVPVHVLWEVCVRWEUPV
      MVNVPVHVLWEVFABCDEFGHIJKLMNOPQRSTUAVDVGVE $.

    $( ~ cdlemg16zz restated for easier studying.  TODO:  Discard this after
       everything is figured out.  (Contributed by NM, 26-May-2013.) $)
    cdlemg25zz $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( P e. A /\ -. P .<_ W ) /\ ( z e. A /\ -. z .<_ W ) /\ F e. T )
     /\ ( G e. T
        /\ -. ( R ` F ) .<_ ( P .\/ z ) /\ -. ( R ` G ) .<_ ( P .\/ z ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( z .\/ ( F ` ( G ` z ) ) ) ./\ W ) ) $=
      ( cv cdlemg16zz ) BCAUADEFGHIJKLMNOPQRSTUB $.

    $( ~ cdlemg16zz restated for easier studying.  TODO:  Discard this after
       everything is figured out.  (Contributed by NM, 26-May-2013.) $)
    cdlemg26zz $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( ( Q e. A /\ -. Q .<_ W ) /\ ( z e. A /\ -. z .<_ W ) /\ F e. T )
     /\ ( G e. T
        /\ -. ( R ` F ) .<_ ( Q .\/ z ) /\ -. ( R ` G ) .<_ ( Q .\/ z ) ) )
    -> ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W )
       = ( ( z .\/ ( F ` ( G ` z ) ) ) ./\ W ) ) $=
      ( cdlemg25zz ) ABCDEFGHIJKLMNOPQRSTUA $.

    $( For use with case when ` ( P .\/ v ) ./\ ( Q .\/ ( R `` F ) ) ` or
       ` ( P .\/ v ) ./\ ( Q .\/ ( R `` F ) ) ` is zero, letting us establish
       ` -. z .<_ W /\ z .<_ ( P .\/ v ) ` via ~ 4atex .  TODO:  Fix comment.
       (Contributed by NM, 28-May-2013.) $)
    cdlemg27a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( v e. A /\ v .<_ W ) )
      /\ ( z e. A /\ F e. T )
      /\ ( v =/= ( R ` F ) /\ z .<_ ( P .\/ v ) /\ ( F ` P ) =/= P ) )
  -> -. ( R ` F ) .<_ ( P .\/ z ) ) $=
      ( chlt wa wbr wn cv w3a cfv wne simp11 simp12 simp31 simp13 simp2r simp33
      wcel co trlat syl112anc trlle syl2anc lhp2atnle syl312anc simp11l simp12l
      simp13l hlatlej1 syl3anc simp32 clat cbs wb hllat syl eqid atbase hlatjcl
      simp2l latjle12 syl13anc mpbi2and wi lattr mpan2d mtod ) JUAUOZMHUOZUBZDC
      UOZDMKUCUDZUBZBUEZCUOZWKMKUCZUBZUFZAUEZCUOZGFUOZUBZWKGEUGZUHZWPDWKIUPZKUC
      ZDGUGDUHZUFZUFZWTDWPIUPZKUCZWTXBKUCZXFWGWJXAWNWTCUOZWTMKUCZXIUDWGWJWNWSXE
      UIZWGWJWNWSXEUJZWOWSXAXCXDUKWGWJWNWSXEULXFWGWJWRXDXJXLXMWOWQWRXEUMZWOWSXA
      XCXDUNCDEFGHJKMNQRSTUQURZXFWGWRXKXLXNEFGHJKMNRSTUSUTCDWKHIJKWTMNOQRVAVBXF
      XHXGXBKUCZXIXFDXBKUCZXCXPXFWEWHWLXQWEWFWJWNWSXEVCZWHWIWGWNWSXEVDZWLWMWGWJ
      WSXEVEZCDWKIJKNOQVFVGWOWSXAXCXDVHXFJVIUOZDJVJUGZUOZWPYBUOZXBYBUOZXQXCUBXP
      VKXFWEYAXRJVLVMZXFWHYCXSCYBDJYBVNZQVOVMXFWQYDWOWQWRXEVQZCYBWPJYGQVOVMXFWE
      WHWLYEXRXSXTCYBIJDWKYGOQVPVGZYBIJKDWPXBYGNOVRVSVTXFYAWTYBUOZXGYBUOZYEXHXP
      UBXIWAYFXFXJYJXOCYBWTJYGQVOVMXFWEWHWQYKXRXSYHCYBIJDWPYGOQVPVGYIYBJKWTXGXB
      YGNWBVSWCWD $.

    $( Part of proof of Lemma G of [Crawley] p. 116.  First equality of the
       equation of line 14 on p. 117.  (Contributed by NM, 29-May-2013.) $)
    cdlemg28a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( v e. A /\ v .<_ W ) )
      /\ ( ( z e. A /\ -. z .<_ W ) /\ F e. T /\ G e. T )
      /\ ( ( v =/= ( R ` F ) /\ v =/= ( R ` G ) )
         /\ z .<_ ( P .\/ v )
         /\ ( ( F ` P ) =/= P /\ ( G ` P ) =/= P ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( z .\/ ( F ` ( G ` z ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wne wceq simp11 simp12 simp21 simp22 simp23
      cv co simp1 simp21l simp31l simp32 simp33l cdlemg27a syl123anc cdlemg25zz
      simp31r simp33r syl133anc ) KUBUCNIUCUDZDCUCDNLUEUFUDZBUPZCUCVKNLUEUDZUGZ
      AUPZCUCZVNNLUEUFZUDZGFUCZHFUCZUGZVKGEUHZUIZVKHEUHZUIZUDZVNDVKJUQLUEZDGUHD
      UIZDHUHZDUIZUDZUGZUGZVIVJVQVRVSWADVNJUQZLUEUFZWCWMLUEUFZDWHGUHJUQNMUQVNVN
      HUHGUHJUQNMUQUJVIVJVLVTWKUKVIVJVLVTWKULVMVQVRVSWKUMVMVQVRVSWKUNZVMVQVRVSW
      KUOZWLVMVOVRWBWFWGWNVMVTWKURZVOVPVRVSVMWKUSZWPWBWDWFWJVMVTUTVMVTWEWFWJVAZ
      WGWIWEWFVMVTVBABCDEFGIJKLMNOPQRSTUAVCVDWLVMVOVSWDWFWIWOWRWSWQWBWDWFWJVMVT
      VFWTWGWIWEWFVMVTVGABCDEFHIJKLMNOPQRSTUAVCVDACDEFGHIJKLMNOPQRSTUAVEVH $.

    cdlemg31.n $e |- N = ( ( P .\/ v ) ./\ ( Q .\/ ( R ` F ) ) ) $.
    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.)
       (New usage is discouraged.) $)
    cdlemg31b0N $p |- ( ( ( K e. HL /\ W e. H /\ F e. T )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
       /\ ( ( v e. A /\ v .<_ W ) /\ v =/= ( R ` F )
          /\ ( F ` P ) =/= P ) )
   -> ( N e. A
       \/ N = ( 0. ` K ) ) ) $=
      ( chlt wcel w3a wbr wn wa cfv wne cp0 wceq simp11 simp2ll simp31l simp2rl
      cv co wo simp12 simp2l simp13 simp33 trlat syl112anc simp2r trlle syl2anc
      jca simp31 simp32 necomd lhp2atne syl321anc eqid 2atmat0 syl33anc orbi12i
      eleq1i eqeq1i sylibr ) JUCUDZNHUDZGFUDZUEZCBUDZCNKUFUGZUHZDBUDZDNKUFUGZUH
      ZUHZAUQZBUDZWMNKUFZUHZWMGEUIZUJZCGUICUJZUEZUEZCWMIURZDWQIURZLURZBUDZXDJUK
      UIZULZUSZMBUDZMXFULZUSXAWBWFWNWIWQBUDZXBXCUJXHWBWCWDWLWTUMZWFWGWKWEWTUNZW
      NWOWRWSWEWLUOWIWJWHWEWTUPXAWBWCUHZWHWDWSXKXAWBWCXLWBWCWDWLWTUTVIZWEWHWKWT
      VAWBWCWDWLWTVBZWEWLWPWRWSVCBCEFGHJKNORSTUAVDVEZXAXCXBXAXNWKWFXKWQNKUFZUHW
      PWQWMUJXCXBUJXOWEWHWKWTVFXMXAXKXRXQXAXNWDXRXOXPEFGHJKNOSTUAVGVHVIWEWLWPWR
      WSVJXAWMWQWEWLWPWRWSVKVLBDCWQHIJKWMNOPRSVMVNVLBCWMDWQIJLXFPQXFVORVPVQXIXE
      XJXGMXDBUBVSMXDXFUBVTVRWA $.

    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg31b0a $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
         /\ ( v e. A /\ v .<_ W ) )
      /\ ( F e. T /\ v =/= ( R ` F ) ) )
   -> ( N e. A \/ N = ( 0. ` K ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv wne cp0 wceq simp1l simp21l simp23l simp22l
      cv co wo simp1 simp3l eqid trlator0 simp22 trlle jca simp23 simp3r necomd
      syl2anc lhp2at0ne syl321anc 2at0mat0 syl33anc eleq1i eqeq1i orbi12i
      sylibr ) JUCUDZNHUDZUEZCBUDZCNKUFUGZUEZDBUDZDNKUFUGZUEZAUQZBUDZWHNKUFZUEZ
      UHZGFUDZWHGEUIZUJZUEZUHZCWHIURZDWNIURZLURZBUDZWTJUKUIZULZUSZMBUDZMXBULZUS
      WQVSWBWIWEWNBUDWNXBULUSZWRWSUJXDVSVTWLWPUMWBWCWGWKWAWPUNZWIWJWDWGWAWPUOWE
      WFWDWKWAWPUPWQWAWMXGWAWLWPUTZWAWLWMWOVAZBEFGHJNXBXBVBZRSTUAVCVJZWQWSWRWQW
      AWGWBXGWNNKUFZUEWKWNWHUJWSWRUJXIWAWDWGWKWPVDXHWQXGXMXLWQWAWMXMXIXJEFGHJKN
      OSTUAVEVJVFWAWDWGWKWPVGWQWHWNWAWLWMWOVHVIBDCWNHIJKWHNXBOPXKRSVKVLVIBCWHDW
      NIJLXBPQXKRVMVNXEXAXFXCMWTBUBVOMWTXBUBVPVQVR $.

    $( TODO:  Fix comment.  (Contributed by NM, 28-May-2013.) $)
    cdlemg27b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( z e. A /\ ( v e. A /\ v .<_ W ) /\ ( F e. T /\ z =/= N ) )
      /\ ( v =/= ( R ` F ) /\ z .<_ ( P .\/ v ) /\ ( F ` P ) =/= P ) )
 -> -. ( R ` F ) .<_ ( Q .\/ z ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne cfv cp0 wceq simp11 simp12 simp13 simp22
      co wo simp23l simp31 cdlemg31b0a syl132anc simp23r adantr cal simp11l syl
      wb hlatl simpl21 simpr atcmp syl3anc necon3bbid eqid atnle0 breq2d mtbird
      syl2anc 2thd jaodan mpbird mpdan simp32 clat hllat simp21 simp12l simp22l
      cbs atbase hlatjcl simp13l simp33 trlat syl112anc latlem12 breq2i syl6bbr
      syl13anc biimpd mpand mtod wi trlle simp13r nbrne2 hlatexch1 syl131anc )
      KUDUEZOIUEZUFZDCUEZDOLUGUHZUFZECUEZEOLUGUHZUFZUIZAUJZCUEZBUJZCUEZYDOLUGZU
      FZHGUEZYBNUKZUFZUIZYDHFULZUKZYBDYDJUSZLUGZDHULDUKZUIZUIZYLEYBJUSLUGZYBEYL
      JUSZLUGZYRUUAYBNLUGZYRNCUEZNKUMULZUNZUTZUUBUHZYRXNXQXTYGYHYMUUFXNXQXTYKYQ
      UOZXNXQXTYKYQUPZXNXQXTYKYQUQYAYCYGYJYQURYHYIYCYGYAYQVAZYAYKYMYOYPVBBCDEFG
      HIJKLMNOPQRSTUAUBUCVCVDYRUUFUFUUGYIYRYIUUFYHYIYCYGYAYQVEZVFYRUUCUUGYIVJUU
      EYRUUCUFZUUBYBNUULKVGUEZYCUUCUUBYBNUNVJUULXLUUMYRXLUUCXLXMXQXTYKYQVHZVFKV
      KZVIYCYGYJYAYQUUCVLYRUUCVMCYBNKLPSVNVOVPYRUUEUFZUUGYIUUPUUBYBUUDLUGZUUPUU
      MYCUUQUHUUPXLUUMYRXLUUEUUNVFUUOVIYCYGYJYAYQUUEVLCYBKLUUDPUUDVQSVRWAUUPNUU
      DYBLYRUUEVMVSVTYRYIUUEUUKVFWBWCWDWEYRYOUUAUUBYAYKYMYOYPWFYRYOUUAUFZUUBYRU
      URYBYNYTMUSZLUGZUUBYRKWGUEZYBKWLULZUEZYNUVBUEZYTUVBUEZUURUUTVJYRXLUVAUUNK
      WHVIYRYCUVCYAYCYGYJYQWIZCUVBYBKUVBVQZSWMVIYRXLXOYEUVDUUNXOXPXNXTYKYQWJYEY
      FYCYJYAYQWKCUVBJKDYDUVGQSWNVOYRXLXRYLCUEZUVEUUNXRXSXNXQYKYQWOZYRXNXQYHYPU
      VHUUHUUIUUJYAYKYMYOYPWPCDFGHIKLOPSTUAUBWQWRZCUVBJKEYLUVGQSWNVOUVBKLMYBYNY
      TUVGPRWSXBNUUSYBLUCWTXAXCXDXEYRXLUVHYCXRYLEUKZYSUUAXFUUNUVJUVFUVIYRYLOLUG
      ZXSUVKYRXNYHUVLUUHUUJFGHIKLOPTUAUBXGWAXRXSXNXQYKYQXHYLEOLXIWACYLYBEJKLPQS
      XJXKXE $.

    $( TODO: fix comment.  (Contributed by NM, 29-May-2013.) $)
    cdlemg31a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A )
        /\ ( v e. A /\ F e. T ) )
         -> N .<_ ( P .\/ v ) ) $=
      ( chlt wcel wa cv w3a co cfv clat cbs wbr simp1l hllat simp2l simp3l eqid
      hlatjcl syl3anc simp2r atbase simp1 simp3r trlcl syl2anc latmle1 syl5eqbr
      syl latjcl ) JUCUDZNHUDZUEZCBUDZDBUDZUEZAUFZBUDZGFUDZUEZUGZMCVPIUHZDGEUIZ
      IUHZLUHZWAKUBVTJUJUDZWAJUKUIZUDZWCWFUDZWDWAKULVTVJWEVJVKVOVSUMZJUNVHZVTVJ
      VMVQWGWIVLVMVNVSUOVLVOVQVRUPBWFIJCVPWFUQZPRURUSVTWEDWFUDZWBWFUDZWHWJVTVNW
      LVLVMVNVSUTBWFDJWKRVAVHVTVLVRWMVLVOVSVBVLVOVQVRVCWFEFGHJNWKSTUAVDVEWFIJDW
      BWKPVIUSWFJKLWAWCWKOQVFUSVG $.

    $( TODO: fix comment.  (Contributed by NM, 29-May-2013.) $)
    cdlemg31b $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ Q e. A )
        /\ ( v e. A /\ F e. T ) )
         -> N .<_ ( Q .\/ ( R ` F ) ) ) $=
      ( chlt wcel wa cv w3a co cfv clat cbs wbr simp1l hllat simp2l simp3l eqid
      hlatjcl syl3anc simp2r atbase simp1 simp3r trlcl syl2anc latmle2 syl5eqbr
      syl latjcl ) JUCUDZNHUDZUEZCBUDZDBUDZUEZAUFZBUDZGFUDZUEZUGZMCVPIUHZDGEUIZ
      IUHZLUHZWCKUBVTJUJUDZWAJUKUIZUDZWCWFUDZWDWCKULVTVJWEVJVKVOVSUMZJUNVHZVTVJ
      VMVQWGWIVLVMVNVSUOVLVOVQVRUPBWFIJCVPWFUQZPRURUSVTWEDWFUDZWBWFUDZWHWJVTVNW
      LVLVMVNVSUTBWFDJWKRVAVHVTVLVRWMVLVOVSVBVLVOVQVRVCWFEFGHJNWKSTUAVDVEWFIJDW
      BWKPVIUSWFJKLWAWCWKOQVFUSVG $.

    $( Show that when ` N ` is an atom, it is not under ` W ` .  TODO:  Is
       there a shorter direct proof?  Todo: should we eliminate
       ` ( F `` P ) =/= P ` here?  (Contributed by NM, 29-May-2013.) $)
    cdlemg31c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ F e. T )
      /\ ( v =/= ( R ` F ) /\ ( F ` P ) =/= P /\ N e. A ) )
         -> -. N .<_ W ) $=
      ( chlt wcel wa wbr wn w3a cv cfv wne co simp11l simp11r jca simp13 simp31
      necomd simp12 simp2r simp32 trlat syl112anc syl2anc simp2l lhp2atnle wceq
      trlle syl321anc simp12l simp13l simp2ll cdlemg31a syl222anc simp111 simp3
      adantr simp112 simp133 simp2 syl312anc 3expia necon4ad cdlemg31b eqbrtrrd
      mpd mtand ) JUCUDZNHUDZUEZCBUDZCNKUFUGZUEZDBUDZDNKUFUGZUEZUHZAUIZBUDZWRNK
      UFZUEZGFUDZUEZWRGEUJZUKZCGUJCUKZMBUDZUHZUHZMNKUFZWRDXDIULZKUFZXIWJWPXDWRU
      KXDBUDZXDNKUFZXAXLUGXIWHWIWHWIWMWPXCXHUMZWHWIWMWPXCXHUNZUOZWJWMWPXCXHUPXI
      WRXDWQXCXEXFXGUQURXIWJWMXBXFXMXQWJWMWPXCXHUSWQXAXBXHUTZWQXCXEXFXGVABCEFGH
      JKNORSTUAVBVCXIWJXBXNXQXREFGHJKNOSTUAVHVDWQXAXBXHVEBDXDHIJKWRNOPRSVFVIXIX
      JUEZMWRXKKXSMCWRIULKUFZMWRVGXIXTXJXIWHWIWKWNWSXBXTXOXPWKWLWJWPXCXHVJZWNWO
      WJWMXCXHVKZWSWTXBWQXHVLZXRABCDEFGHIJKLMNOPQRSTUAUBVMVNVQXSXTMWRXIXJMWRUKZ
      XTUGZXIXJYDUHZWJWMWRMUKXAXGXJYEWJWMWPXCXHXJYDVOWJWMWPXCXHXJYDVRYFMWRXIXJY
      DVPURXAXBWQXHXJYDVJXEXFXGWQXCXJYDVSXIXJYDVTBCWRHIJKMNOPRSVFWAWBWCWFXIMXKK
      UFZXJXIWHWIWKWNWSXBYGXOXPYAYBYCXRABCDEFGHIJKLMNOPQRSTUAUBWDVNVQWEWG $.

    $( Eliminate ` ( F `` P ) =/= P ` from ~ cdlemg31c .  TODO:  Prove
       directly.  Todo: do we need to eliminate ` ( F `` P ) =/= P ` ?  It
       might be better to do this all at once at the end.  See also ~ cdlemg29
       vs. ~ cdlemg28 .  (Contributed by NM, 29-May-2013.) $)
    cdlemg31d $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
         /\ ( v e. A /\ v .<_ W ) )
      /\ ( F e. T /\ v =/= ( R ` F ) /\ N e. A ) )
         -> -. N .<_ W ) $=
      ( chlt wcel wa wbr w3a cfv wne wceq simp22r adantr simpl1 simp21l simp22l
      wn cv co simp23l simpl31 cdlemg31b syl122anc simpl21 simpr eqid syl112anc
      cp0 trl0 oveq2d col cbs simp1l syl atbase olj01 syl2anc eqtrd breqtrd cal
      hlol wb hlatl simpl33 atcmp syl3anc breq1d mtbird simpl22 simpl23 simpl32
      mpbid cdlemg31c syl323anc pm2.61dane ) JUCUDZNHUDZUEZCBUDZCNKUFUPZUEZDBUD
      ZDNKUFZUPZUEZAUQZBUDZXENKUFZUEZUGZGFUDZXEGEUHZUIZMBUDZUGZUGZMNKUFZUPZCGUH
      ZCXOXRCUJZUEZXPXBXOXCXSXAXCWTXHWQXNUKULXTMDNKXTMDKUFZMDUJZXTMDXKIURZDKXTW
      QWRXAXFXJMYCKUFWQXIXNXSUMZXOWRXSWRWSXDXHWQXNUNULXOXAXSXAXCWTXHWQXNUOULZXO
      XFXSXFXGWTXDWQXNUSULXJXLXMWQXIXSUTZABCDEFGHIJKLMNOPQRSTUAUBVAVBXTYCDJVGUH
      ZIURZDXTXKYGDIXTWQWTXJXSXKYGUJYDWTXDXHWQXNXSVCYFXOXSVDBCEFGHJKNYGOYGVEZRS
      TUAVHVFVIXTJVJUDZDJVKUHZUDZYHDUJXOYJXSXOWOYJWOWPXIXNVLZJVTVMULXTXAYLYEBYK
      DJYKVEZRVNVMYKIJDYGYNPYIVOVPVQVRXTJVSUDZXMXAYAYBWAXOYOXSXOWOYOYMJWBVMULXJ
      XLXMWQXIXSWCYEBMDJKORWDWEWKWFWGXOXRCUIZUEWQWTXDXHXJXLYPXMXQWQXIXNYPUMWTXD
      XHWQXNYPVCWTXDXHWQXNYPWHWTXDXHWQXNYPWIXJXLXMWQXIYPUTXJXLXMWQXIYPWJXOYPVDX
      JXLXMWQXIYPWCABCDEFGHIJKLMNOPQRSTUAUBWLWMWN $.

    $d z A $.  $d z F $.  $d r z H $.  $d z .\/ $.  $d r z K $.  $d z .<_ $.
    $d r z N $.  $d z P $.  $d z Q $.  $d z R $.  $d z T $.  $d z W $.
    $d v z r $.
    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33b0 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ N e. A /\ F e. T )
      /\ ( P =/= Q /\ v =/= ( R ` F )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne co wceq wrex simp11 simp12 simp13 simp22
      cfv simp21l simp23 simp32 cdlemg31d syl133anc simp31 nbrne2 necomd simp33
      simp21r jca syl2anc 4atex3 df-3an a1i simp12l simp13l cdlemg31a syl122anc
      wi simpl simp11l hlatlej2 syl3anc clat cbs hllat syl eqid atbase latjle12
      wb hlatjcl syl13anc mpbi2and adantr adantl mpan2d anim12d syl5bi reximdva
      lattr anim2d mpd ) KUEUFZOIUFZUGZDCUFZDOLUHUIZUGZECUFZEOLUHUIZUGZUJZBUKZC
      UFZXOOLUHZUGZNCUFZHGUFZUJZDEULZXOHFUTULZPUKZOLUHUIDYDJUMEYDJUMUNUGPCUOZUJ
      ZUJZAUKZOLUHUIZYHNULZYHXOULZYHNXOJUMZLUHZUJZUGZACUOZYIYJYHDXOJUMZLUHZUGZU
      GZACUOYGXGXJXMXSNOLUHUIZUGYBXPNXOULZUGYEYPXGXJXMYAYFUPZXGXJXMYAYFUQZXGXJX
      MYAYFURZYGXSUUAXNXRXSXTYFUSZYGXGXJXMXRXTYCXSUUAUUCUUDUUEYGXPXQXPXQXSXTXNY
      FVAZXPXQXSXTXNYFVJZVKXNXRXSXTYFVBZXNYAYBYCYEVCUUFBCDEFGHIJKLMNOQRSTUAUBUC
      UDVDVEZVKXNYAYBYCYEVFYGXPUUBUUGYGXQUUAUUBUUHUUJXQUUAUGXONXONOLVGVHVLVKXNY
      AYBYCYEVIACDENXOIJKLOPQRTUAVMVEYGYOYTACYGYHCUFZUGZYNYSYIYNYJYKUGZYMUGUULY
      SYJYKYMVNUULUUMYJYMYRUUMYJVTUULYJYKWAVOUULYMYLYQLUHZYRYGUUNUUKYGNYQLUHZXO
      YQLUHZUUNYGXGXHXKXPXTUUOUUCXHXIXGXMYAYFVPZXKXLXGXJYAYFVQUUGUUIBCDEFGHIJKL
      MNOQRSTUAUBUCUDVRVSYGXEXHXPUUPXEXFXJXMYAYFWBZUUQUUGCDXOJKLQRTWCWDYGKWEUFZ
      NKWFUTZUFZXOUUTUFZYQUUTUFZUUOUUPUGUUNWLYGXEUUSUURKWGWHZYGXSUVAUUFCUUTNKUU
      TWIZTWJWHYGXPUVBUUGCUUTXOKUVETWJWHYGXEXHXPUVCUURUUQUUGCUUTJKDXOUVERTWMWDZ
      UUTJKLNXOYQUVEQRWKWNWOWPUULUUSYHUUTUFZYLUUTUFZUVCYMUUNUGYRVTYGUUSUUKUVDWP
      UUKUVGYGCUUTYHKUVETWJWQYGUVHUUKYGXEXSXPUVHUURUUFUUGCUUTJKNXOUVERTWMWDWPYG
      UVCUUKUVFWPUUTKLYHYLYQUVEQXBWNWRWSWTXCXAXD $.

    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33c0 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ F e. T )
      /\ ( P =/= Q /\ v =/= ( R ` F )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ z .<_ ( P .\/ v ) ) ) $=
      ( chlt wcel wa wbr wn w3a wne cfv wceq wrex simp11l simp11r simp12 simp13
      cv simp31 simp2ll simp2lr simp12r nbrne2 necomd syl2anc jca simp33 4atex3
      co syl233anc simp3 anim2i reximi syl ) KUEUFZOIUFZUGZDCUFZDOLUHUIZUGZECUF
      EOLUHUIUGZUJZBUSZCUFZWDOLUHZUGHGUFZUGZDEUKZWDHFULUKZPUSZOLUHUIDWKJVJEWKJV
      JUMUGPCUNZUJZUJZAUSZOLUHUIZWODUKZWOWDUKZWODWDJVJLUHZUJZUGZACUNZWPWSUGZACU
      NWNVPVQWAWBWAWIWEDWDUKZUGWLXBVPVQWAWBWHWMUOVPVQWAWBWHWMUPVRWAWBWHWMUQZVRW
      AWBWHWMURXEWCWHWIWJWLUTWNWEXDWEWFWGWCWMVAWNWFVTXDWEWFWGWCWMVBVSVTVRWBWHWM
      VCWFVTUGWDDWDDOLVDVEVFVGWCWHWIWJWLVHACDEDWDIJKLOPQRTUAVIVKXAXCACWTWSWPWQW
      RWSVLVMVNVO $.

    $d z G $.  $d z r O $.
    cdlemg33.o $e |- O = ( ( P .\/ v ) ./\ ( Q .\/ ( R ` G ) ) ) $.
    $( Part of proof of Lemma G of [Crawley] p. 116.  Second equality of the
       equation of line 14 on p. 117.  Note that ` -. z .<_ W ` is redundant
       here (but simplifies ~ cdlemg28 .)  (Contributed by NM, 29-May-2013.) $)
    cdlemg28b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( z e. A /\ -. z .<_ W )
              /\ ( F e. T /\ G e. T ) )
      /\ ( ( z =/= N /\ z =/= O /\ z .<_ ( P .\/ v ) )
             /\ ( v =/= ( R ` F ) /\ v =/= ( R ` G ) )
         /\ ( ( F ` P ) =/= P /\ ( G ` P ) =/= P ) ) )
    -> ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W )
       = ( ( z .\/ ( F ` ( G ` z ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne co cfv wceq simp11 simp13 simp22 simp23l
      simp23r simp1 simp22l simp311 simp32l simp313 simp33l cdlemg27b syl133anc
      simp21 jca simp312 simp32r simp33r cdlemg26zz ) LUGUHQJUHUIZDCUHDQMUJUKUI
      ZECUHEQMUJUKUIZULZBUMZCUHWAQMUJUIZAUMZCUHZWCQMUJUKZUIZHGUHZIGUHZUIZULZWCO
      UNZWCPUNZWCDWAKUOMUJZULZWAHFUPZUNZWAIFUPZUNZUIZDHUPDUNZDIUPDUNZUIZULZULZV
      QVSWFWGWHWOEWCKUOZMUJUKZWQXEMUJUKZEEIUPHUPKUOQNUOWCWCIUPHUPKUOQNUOUQVQVRV
      SWJXCURVQVRVSWJXCUSVTWBWFWIXCUTWGWHWBWFVTXCVAZWGWHWBWFVTXCVBZXDVTWDWBWGWK
      UIWPWMWTXFVTWJXCVCZWDWEWBWIVTXCVDZVTWBWFWIXCVKZXDWGWKXHWKWLWMWSXBVTWJVEVL
      WPWRWNXBVTWJVFWKWLWMWSXBVTWJVGZWTXAWNWSVTWJVHABCDEFGHJKLMNOQRSTUAUBUCUDUE
      VIVJXDVTWDWBWHWLUIWRWMXAXGXJXKXLXDWHWLXIWKWLWMWSXBVTWJVMVLWPWRWNXBVTWJVNX
      MWTXAWNWSVTWJVOABCDEFGIJKLMNPQRSTUAUBUCUDUFVIVJACEFGHIJKLMNQRSTUAUBUCUDVP
      VJ $.

    $( Part of proof of Lemma G of [Crawley] p. 116.  Chain the equalities of
       line 14 on p. 117.  TODO: rearrange hypotheses in the order of
       ~ cdlemg29 (and maybe leading up to this too)?  (Contributed by NM,
       29-May-2013.) $)
    cdlemg28 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( z e. A /\ -. z .<_ W )
              /\ ( F e. T /\ G e. T ) )
      /\ ( ( z =/= N /\ z =/= O /\ z .<_ ( P .\/ v ) )
             /\ ( v =/= ( R ` F ) /\ v =/= ( R ` G ) )
         /\ ( ( F ` P ) =/= P /\ ( G ` P ) =/= P ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne co cfv wceq simp11 simp12 simp21 simp23l
      simp22 simp23r simp32 simp313 simp33 cdlemg28a syl333anc cdlemg28b eqtr4d
      ) LUGUHQJUHUIZDCUHDQMUJUKUIZECUHEQMUJUKUIZULZBUMZCUHVOQMUJUIZAUMZCUHVQQMU
      JUKUIZHGUHZIGUHZUIZULZVQOUNZVQPUNZVQDVOKUOMUJZULZVOHFUPUNVOIFUPUNUIZDHUPD
      UNDIUPZDUNUIZULZULZDWHHUPKUOQNUOZVQVQIUPHUPKUOQNUOZEEIUPHUPKUOQNUOWKVKVLV
      PVRVSVTWGWEWIWLWMUQVKVLVMWBWJURVKVLVMWBWJUSVNVPVRWAWJUTVNVPVRWAWJVBVSVTVP
      VRVNWJVAVSVTVPVRVNWJVCVNWBWFWGWIVDWCWDWEWGWIVNWBVEVNWBWFWGWIVFABCDFGHIJKL
      MNQRSTUAUBUCUDVGVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFVIVJ $.

    $( Eliminate ` ( F `` P ) =/= P ` and ` ( G `` P ) =/= P ` from
       ~ cdlemg28 .  TODO: would it be better to do this later?  (Contributed
       by NM, 29-May-2013.) $)
    cdlemg29 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( z e. A /\ -. z .<_ W )
              /\ ( F e. T /\ G e. T ) )
      /\ ( ( z =/= N /\ z =/= O ) /\ z .<_ ( P .\/ v )
                 /\ ( v =/= ( R ` F ) /\ v =/= ( R ` G ) ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne cfv wceq simpl11 simpl12 simpl13 simp23l
      adantr simp23r simpr cdlemg14f syl123anc cdlemg14g simpl1 simp31l simp31r
      co simpl2 simpl32 3jca simpl33 cdlemg28 syl113anc pm2.61da2ne ) LUGUHQJUH
      UIZDCUHDQMUJUKUIZECUHEQMUJUKUIZULZBUMZCUHWBQMUJUIZAUMZCUHWDQMUJUKUIZHGUHZ
      IGUHZUIULZWDOUNZWDPUNZUIZWDDWBKVJMUJZWBHFUOUNWBIFUOUNUIZULZULZDDIUOZHUOKV
      JQNVJEEIUOHUOKVJQNVJUPZDHUOZDWPDWOWRDUPZUIVRVSVTWFWGWSWQVRVSVTWHWNWSUQVRV
      SVTWHWNWSURVRVSVTWHWNWSUSWOWFWSWFWGWCWEWAWNUTZVAWOWGWSWFWGWCWEWAWNVBZVAWO
      WSVCCDEFGHIJKLMNQRSTUAUBUCUDVDVEWOWPDUPZUIVRVSVTWFWGXBWQVRVSVTWHWNXBUQVRV
      SVTWHWNXBURVRVSVTWHWNXBUSWOWFXBWTVAWOWGXBXAVAWOXBVCCDEFGHIJKLMNQRSTUAUBUC
      UDVFVEWOWRDUNWPDUNUIZUIZWAWHWIWJWLULWMXCWQWAWHWNXCVGWAWHWNXCVKXDWIWJWLWOW
      IXCWIWJWLWMWAWHVHVAWOWJXCWIWJWLWMWAWHVIVAWKWLWMWAWHXCVLVMWKWLWMWAWHXCVNWO
      XCVCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFVOVPVQ $.

    $( TODO:  Fix comment.  (Contributed by NM, 29-May-2013.) $)
    cdlemg33a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( N e. A /\ O e. A )
              /\ ( F e. T /\ G e. T ) )
      /\ ( ( P =/= Q /\ N =/= O )
           /\ v =/= ( R ` F )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z =/= O
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne cfv co wceq simp11 simp12 simp13 simp22l
      wrex simp21 simp23l simp32 cdlemg31d syl133anc jca simp31l simp22r simp33
      simp31r 4atex3 idd simp12l simp13l simp21l cdlemg31a syl122anc simp23r wi
      clat cbs simp11l syl eqid atbase hlatjcl syl3anc latjlej12 mp2and latjidm
      hllat syl2anc breqtrd adantr adantl lattr syl13anc mpan2d anim2d reximdva
      3anim123d mpd ) LUHUIZQJUIZUJZDCUIZDQMUKULZUJZECUIZEQMUKULZUJZUMZBUNZCUIZ
      XPQMUKZUJZOCUIZPCUIZUJZHGUIZIGUIZUJZUMZDEUOZOPUOZUJZXPHFUPUOZRUNZQMUKULDY
      KKUQEYKKUQURUJRCVCZUMZUMZAUNZQMUKULZYOOUOZYOPUOZYOOPKUQZMUKZUMZUJZACVCZYP
      YQYRYODXPKUQZMUKZUMZUJZACVCYNXHXKXNXTOQMUKULZUJYGYAYHUJYLUUCXHXKXNYFYMUSZ
      XHXKXNYFYMUTZXHXKXNYFYMVAZYNXTUUHXTYAXSYEXOYMVBZYNXHXKXNXSYCYJXTUUHUUIUUJ
      UUKXOXSYBYEYMVDYCYDXSYBXOYMVEZXOYFYIYJYLVFUULBCDEFGHJKLMNOQSTUAUBUCUDUEUF
      VGVHVIYGYHYJYLXOYFVJYNYAYHXTYAXSYEXOYMVKZYGYHYJYLXOYFVMVIXOYFYIYJYLVLACDE
      OPJKLMQRSTUBUCVNVHYNUUBUUGACYNYOCUIZUJZUUAUUFYPUUPYQYQYRYRYTUUEUUPYQVOUUP
      YRVOUUPYTYSUUDMUKZUUEYNUUQUUOYNYSUUDUUDKUQZUUDMYNOUUDMUKZPUUDMUKZYSUURMUK
      ZYNXHXIXLXQYCUUSUUIXIXJXHXNYFYMVPZXLXMXHXKYFYMVQZXQXRYBYEXOYMVRZUUMBCDEFG
      HJKLMNOQSTUAUBUCUDUEUFVSVTYNXHXIXLXQYDUUTUUIUVBUVCUVDYCYDXSYBXOYMWABCDEFG
      IJKLMNPQSTUAUBUCUDUEUGVSVTYNLWCUIZOLWDUPZUIZUUDUVFUIZPUVFUIZUVHUUSUUTUJUV
      AWBYNXFUVEXFXGXKXNYFYMWEZLWNWFZYNXTUVGUULCUVFOLUVFWGZUBWHWFYNXFXIXQUVHUVJ
      UVBUVDCUVFKLDXPUVLTUBWIWJZYNYAUVIUUNCUVFPLUVLUBWHWFUVMUVFKLMUUDOUUDPUVLST
      WKVTWLYNUVEUVHUURUUDURUVKUVMUVFKLUUDUVLTWMWOWPWQUUPUVEYOUVFUIZYSUVFUIZUVH
      YTUUQUJUUEWBYNUVEUUOUVKWQUUOUVNYNCUVFYOLUVLUBWHWRYNUVOUUOYNXFXTYAUVOUVJUU
      LUUNCUVFKLOPUVLTUBWIWJWQYNUVHUUOUVMWQUVFLMYOYSUUDUVLSWSWTXAXDXBXCXE $.

    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( N e. A /\ O e. A )
              /\ ( F e. T /\ G e. T ) )
      /\ ( P =/= Q /\ v =/= ( R ` F )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z =/= O
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne co wceq wrex df-3an anidm neeq2 syl5rbbr
      cfv anbi2d anbi1d syl5bb rexbidv simpl1 simpl31 simpr jca simpl32 simpl33
      simpl2 cdlemg33a simp21 simp22l simp23l 3jca cdlemg33b0 syld3an2 pm2.61ne
      syl113anc ) LUHUIQJUIUJDCUIDQMUKULUJECUIEQMUKULUJUMZBUNZCUIWEQMUKUJZOCUIZ
      PCUIZUJZHGUIZIGUIZUJZUMZDEUOZWEHFVCUOZRUNZQMUKULDWPKUPEWPKUPUQUJRCURZUMZU
      MZAUNZQMUKULZWTOUOZWTPUOZWTDWEKUPMUKZUMZUJZACURZXAXBXDUJZUJZACURZOPOPUQZX
      FXIACXKXEXHXAXEXBXCUJZXDUJXKXHXBXCXDUSXKXLXBXDXBXBXBUJXKXLXBUTXKXBXCXBOPW
      TVAVDVBVEVFVDVGWSOPUOZUJZWDWMWNXMUJWOWQXGWDWMWRXMVHWDWMWRXMVNXNWNXMWNWOWQ
      WDWMXMVIWSXMVJVKWNWOWQWDWMXMVLWNWOWQWDWMXMVMABCDEFGHIJKLMNOPQRSTUAUBUCUDU
      EUFUGVOWCWDWFWGWJUMWMWRXJWSWFWGWJWDWFWIWLWRVPWGWHWFWLWDWRVQWJWKWFWIWDWRVR
      VSABCDEFGHJKLMNOQRSTUAUBUCUDUEUFVTWAWB $.

    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( N e. A /\ O = ( 0. ` K ) )
              /\ ( F e. T /\ G e. T ) )
      /\ ( P =/= Q /\ v =/= ( R ` F )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z =/= O
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv cp0 cfv wceq wne wrex simp21 simp22l simp23l
      co simp1 simp3 cdlemg33b0 syl131anc cal simp11l adantr hlatl syl sylancom
      eqid atn0 simp22r neeqtrrd biantrud anbi1d df-3an syl6bbr anbi2d rexbidva
      mpbid ) LUHUIZQJUIZUJDCUIDQMUKULUJZECUIEQMUKULUJZUMZBUNZCUIWJQMUKUJZOCUIZ
      PLUOUPZUQZUJZHGUIZIGUIZUJZUMZDEURWJHFUPURRUNZQMUKULDWTKVCEWTKVCUQUJRCUSUM
      ZUMZAUNZQMUKULZXCOURZXCDWJKVCMUKZUJZUJZACUSZXDXEXCPURZXFUMZUJZACUSXBWIWKW
      LWPXAXIWIWSXAVDWIWKWOWRXAUTWLWNWKWRWIXAVAWPWQWKWOWIXAVBWIWSXAVEABCDEFGHJK
      LMNOQRSTUAUBUCUDUEUFVFVGXBXHXLACXBXCCUIZUJZXGXKXDXNXGXEXJUJZXFUJXKXNXEXOX
      FXNXJXEXNXCWMPXBXMLVHUIZXCWMURXNWEXPXBWEXMWEWFWGWHWSXAVIVJLVKVLCXCLWMWMVN
      UBVOVMXBWNXMWLWNWKWRWIXAVPVJVQVRVSXEXJXFVTWAWBWCWD $.

    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33d $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( N = ( 0. ` K ) /\ O e. A )
              /\ ( F e. T /\ G e. T ) )
      /\ ( P =/= Q /\ v =/= ( R ` G )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z =/= O
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv cp0 cfv wceq wne wrex simp21 simp22r simp22l
      simp1 jca simp23r simp23l simp3 cdlemg33c syl131anc 3ancoma anbi2i rexbii
      co sylib ) LUHUIQJUIUJDCUIDQMUKULUJECUIEQMUKULUJUMZBUNZCUIVPQMUKUJZOLUOUP
      UQZPCUIZUJZHGUIZIGUIZUJZUMZDEURVPIFUPURRUNZQMUKULDWEKVMEWEKVMUQUJRCUSUMZU
      MZAUNZQMUKULZWHPURZWHOURZWHDVPKVMMUKZUMZUJZACUSZWIWKWJWLUMZUJZACUSWGVOVQV
      SVRUJWBWAUJWFWOVOWDWFVCVOVQVTWCWFUTWGVSVRVRVSVQWCVOWFVAVRVSVQWCVOWFVBVDWG
      WBWAWAWBVQVTVOWFVEWAWBVQVTVOWFVFVDVOWDWFVGABCDEFGIHJKLMNPOQRSTUAUBUCUDUEU
      GUFVHVIWNWQACWMWPWIWJWKWLVJVKVLVN $.

    $( TODO:  Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33e $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( N = ( 0. ` K ) /\ O = ( 0. ` K ) )
              /\ ( F e. T /\ G e. T ) )
      /\ ( P =/= Q /\ v =/= ( R ` F )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z =/= O
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv cp0 cfv wceq wne co wrex simp1 simp23l simp3
      simp21 cdlemg33c0 syl121anc cal simp11l hlatl syl eqid atn0 sylan simp22l
      adantr neeqtrrd simp22r biantrurd df-3an syl6bbr anbi2d rexbidva mpbid
      jca ) LUHUIZQJUIZUJDCUIDQMUKULUJZECUIEQMUKULUJZUMZBUNZCUIWJQMUKUJZOLUOUPZ
      UQZPWLUQZUJZHGUIZIGUIZUJZUMZDEURWJHFUPURRUNZQMUKULDWTKUSEWTKUSUQUJRCUTUMZ
      UMZAUNZQMUKULZXCDWJKUSMUKZUJZACUTZXDXCOURZXCPURZXEUMZUJZACUTXBWIWKWPXAXGW
      IWSXAVAWIWKWOWRXAVDWPWQWKWOWIXAVBWIWSXAVCABCDEFGHJKLMNOQRSTUAUBUCUDUEUFVE
      VFXBXFXKACXBXCCUIZUJZXEXJXDXMXEXHXIUJZXEUJXJXMXNXEXMXHXIXMXCWLOXBLVGUIZXL
      XCWLURXBWEXOWEWFWGWHWSXAVHLVIVJCXCLWLWLVKUBVLVMZXBWMXLWMWNWKWRWIXAVNVOVPX
      MXCWLPXPXBWNXLWMWNWKWRWIXAVQVOVPWDVRXHXIXEVSVTWAWBWC $.

    $( Combine ~ cdlemg33b , ~ cdlemg33c , ~ cdlemg33d , ~ cdlemg33e .  TODO:
       Fix comment.  (Contributed by NM, 30-May-2013.) $)
    cdlemg33 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( F e. T /\ G e. T )
         /\ P =/= Q )
      /\ ( v =/= ( R ` F ) /\ v =/= ( R ` G )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
             -> E. z e. A ( -. z .<_ W
                /\ ( z =/= N
                /\ z =/= O
                /\ z .<_ ( P .\/ v ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv wne cfv co wceq wrex wo simp11 simp12 simp13
      simp21 simp22l simp31 cdlemg31b0a syl132anc simp22r simp32 simpl1 simpl21
      cp0 simpl22 simpl23 simpl31 simpl33 cdlemg33b syl133anc simpl32 cdlemg33d
      simpr ex cdlemg33c cdlemg33e ccased mp2and ) LUHUIQJUIUJZDCUIDQMUKULUJZEC
      UIEQMUKULUJZUMZBUNZCUIWLQMUKUJZHGUIZIGUIZUJZDEUOZUMZWLHFUPUOZWLIFUPUOZRUN
      ZQMUKULDXAKUQEXAKUQURUJRCUSZUMZUMZOCUIZOLVMUPZURZUTZPCUIZPXFURZUTZAUNZQMU
      KULXLOUOXLPUOXLDWLKUQMUKUMUJACUSZXDWHWIWJWMWNWSXHWHWIWJWRXCVAZWHWIWJWRXCV
      BZWHWIWJWRXCVCZWKWMWPWQXCVDZWNWOWMWQWKXCVEWKWRWSWTXBVFBCDEFGHJKLMNOQSTUAU
      BUCUDUEUFVGVHXDWHWIWJWMWOWTXKXNXOXPXQWNWOWMWQWKXCVIWKWRWSWTXBVJBCDEFGIJKL
      MNPQSTUAUBUCUDUEUGVGVHXDXEXIXGXJXMXDXEXIUJZXMXDXRUJWKWMXRWPWQWSXBXMWKWRXC
      XRVKWMWPWQWKXCXRVLXDXRWBWMWPWQWKXCXRVNWMWPWQWKXCXRVOWSWTXBWKWRXRVPWSWTXBW
      KWRXRVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGVRVSWCXDXGXIUJZXMXDXSUJWKWMXSWPW
      QWTXBXMWKWRXCXSVKWMWPWQWKXCXSVLXDXSWBWMWPWQWKXCXSVNWMWPWQWKXCXSVOWSWTXBWK
      WRXSVTWSWTXBWKWRXSVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGWAVSWCXDXEXJUJZXMXD
      XTUJWKWMXTWPWQWSXBXMWKWRXCXTVKWMWPWQWKXCXTVLXDXTWBWMWPWQWKXCXTVNWMWPWQWKX
      CXTVOWSWTXBWKWRXTVPWSWTXBWKWRXTVQABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGWDVSWC
      XDXGXJUJZXMXDYAUJWKWMYAWPWQWSXBXMWKWRXCYAVKWMWPWQWKXCYAVLXDYAWBWMWPWQWKXC
      YAVNWMWPWQWKXCYAVOWSWTXBWKWRYAVPWSWTXBWKWRYAVQABCDEFGHIJKLMNOPQRSTUAUBUCU
      DUEUFUGWEVSWCWFWG $.

    $d ./\ z $.
    $( Use cdlemg33 to eliminate ` z ` from ~ cdlemg29 .  TODO:  Fix comment.
       (Contributed by NM, 31-May-2013.) $)
    cdlemg34 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( Q e. A /\ -. Q .<_ W ) )
      /\ ( ( v e. A /\ v .<_ W ) /\ ( F e. T /\ G e. T )
         /\ P =/= Q )
      /\ ( v =/= ( R ` F ) /\ v =/= ( R ` G )
         /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
 -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
    = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( vz chlt wcel wa wbr wn w3a cv wne cfv wceq wrex cdlemg33 simp11 simp121
      simp2 simp3l jca simp122 simp3r1 simp3r2 simp3r3 simp131 simp132 cdlemg29
      co syl133anc rexlimdv3a mpd ) KUHUIPIUIUJCBUICPLUKULUJDBUIDPLUKULUJUMZAUN
      ZBUIVQPLUKUJZGFUIHFUIUJZCDUOZUMZVQGEUPUOZVQHEUPUOZQUNZPLUKULCWDJVLDWDJVLU
      QUJQBURZUMZUMZUGUNZPLUKULZWHNUOZWHOUOZWHCVQJVLLUKZUMZUJZUGBURCCHUPGUPJVLP
      MVLDDHUPGUPJVLPMVLUQZUGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUSWGWNWOUGBWGWHBUI
      ZWNUMZVPVRWPWIUJVSWJWKUJWLWBWCUJWOVPWAWFWPWNUTVRVSVTVPWFWPWNVAWQWPWIWGWPW
      NVBWGWPWIWMVCVDVRVSVTVPWFWPWNVEWQWJWKWJWKWLWIWGWPVFWJWKWLWIWGWPVGVDWJWKWL
      WIWGWPVHWQWBWCWBWCWEVPWAWPWNVIWBWCWEVPWAWPWNVJVDUGABCDEFGHIJKLMNOPRSTUAUB
      UCUDUEUFVKVMVNVO $.
  $}

  ${
    cdlemg35.l $e |- .<_ = ( le ` K ) $.
    cdlemg35.j $e |- .\/ = ( join ` K ) $.
    cdlemg35.m $e |- ./\ = ( meet ` K ) $.
    cdlemg35.a $e |- A = ( Atoms ` K ) $.
    cdlemg35.h $e |- H = ( LHyp ` K ) $.
    cdlemg35.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    ${
      cdlemg35.r $e |- R = ( ( trL ` K ) ` W ) $.
      $d v A $.  $d v F $.  $d v G $.  $d v H $.  $d v K $.  $d v .<_ $.
      $d v P $.  $d v R $.  $d v T $.  $d v W $.
      $( TODO:  Fix comment.  TODO: should we have a more general version of
         ~ hlsupr to avoid the ` =/= ` conditions?  (Contributed by NM,
         31-May-2013.) $)
      cdlemg35 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ F e. T /\ G e. T )
        /\ ( ( F ` P ) =/= P /\ ( G ` P ) =/= P /\ ( R ` F ) =/= ( R ` G ) ) )
     -> E. v e. A ( v .<_ W
                /\ ( v =/= ( R ` F )
                /\ v =/= ( R ` G ) ) ) ) $=
        ( chlt wcel wa wbr wn w3a cfv wne cv co wrex simp1l simp1 simp21 simp22
        simp31 trlat syl112anc simp23 simp32 simp33 hlsupr syl31anc cbs simp11l
        eqid clat hllat syl atbase 3ad2ant2 simp11 simp122 trlcl syl2anc latjcl
        simp123 syl3anc simp11r lhpbase trlle latjle12 syl13anc mpbi2and lattrd
        wb jca32 3expia reximdva mpd ) JUAUBZMHUBZUCZCBUBCMKUDUEUCZFEUBZGEUBZUF
        ZCFUGCUHZCGUGCUHZFDUGZGDUGZUHZUFZUFZAUIZWTUHZXEXAUHZXEWTXAIUJZKUDZUFZAB
        UKZXEMKUDZXFXGUCUCZABUKXDWKWTBUBZXABUBZXBXKWKWLWQXCULXDWMWNWOWRXNWMWQXC
        UMZWMWNWOWPXCUNZWMWNWOWPXCUOWMWQWRWSXBUPBCDEFHJKMNQRSTUQURXDWMWNWPWSXOX
        PXQWMWNWOWPXCUSWMWQWRWSXBUTBCDEGHJKMNQRSTUQURWMWQWRWSXBVABWTXAIJKANOQVB
        VCXDXJXMABXDXEBUBZXJXMXDXRXJUFZXLXFXGXSJVDUGZJKXEXHMXTVFZNXSWKJVGUBZWKW
        LWQXCXRXJVEJVHVIZXRXDXEXTUBXJBXTXEJYAQVJVKXSYBWTXTUBZXAXTUBZXHXTUBYCXSW
        MWOYDWMWQXCXRXJVLZWNWOWPWMXCXRXJVMZXTDEFHJMYARSTVNVOZXSWMWPYEYFWNWOWPWM
        XCXRXJVQZXTDEGHJMYARSTVNVOZXTIJWTXAYAOVPVRXSWLMXTUBZWKWLWQXCXRXJVSXTHJM
        YARVTVIZXDXRXFXGXIVAXSWTMKUDZXAMKUDZXHMKUDZXSWMWOYMYFYGDEFHJKMNRSTWAVOX
        SWMWPYNYFYIDEGHJKMNRSTWAVOXSYBYDYEYKYMYNUCYOWFYCYHYJYLXTIJKWTXAMYANOWBW
        CWDWEXDXRXFXGXIUPXDXRXFXGXIUTWGWHWIWJ $.

      $d r A $.  $d r F $.  $d r G $.  $d r H $.  $d r v .\/ $.  $d r K $.
      $d r .<_ $.  $d r v ./\ $.  $d r P $.  $d r v Q $.  $d r R $.  $d r W $.
      $( Use cdlemg35 to eliminate ` v ` from ~ cdlemg34 .  TODO:  Fix
         comment.  (Contributed by NM, 31-May-2013.) $)
      cdlemg36 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( F e. T /\ G e. T /\ P =/= Q )
        /\ ( ( ( F ` P ) =/= P /\ ( G ` P ) =/= P )
           /\ ( R ` F ) =/= ( R ` G )
           /\ E. r e. A ( -. r .<_ W /\ ( P .\/ r ) = ( Q .\/ r ) ) ) )
 -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
    = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
        ( vv chlt wcel wa wbr wn w3a wne cv co wceq simp11 simp12 simp21 simp22
        cfv wrex simp31l simp31r simp32 cdlemg35 syl133anc simp2 simp3l simp121
        jca simp122 simp123 simp3rl simp3rr simp133 eqid cdlemg34 rexlimdv3a
        mpd ) JUCUDMHUDUEZBAUDBMKUFUGUEZCAUDCMKUFUGUEZUHZFEUDZGEUDZBCUIZUHZBFUQ
        BUIZBGUQZBUIZUEZFDUQZGDUQZUIZNUJZMKUFUGBWLIUKCWLIUKULUENAURZUHZUHZUBUJZ
        MKUFZWPWIUIZWPWJUIZUEZUEZUBAURZBWFFUQIUKMLUKCCGUQFUQIUKMLUKULZWOVQVRWAW
        BWEWGWKXBVQVRVSWDWNUMVQVRVSWDWNUNVTWAWBWCWNUOVTWAWBWCWNUPWEWGWKWMVTWDUS
        WEWGWKWMVTWDUTVTWDWHWKWMVAUBABDEFGHIJKLMOPQRSTUAVBVCWOXAXCUBAWOWPAUDZXA
        UHZVTXDWQUEWAWBUEWCWRWSWMXCVTWDWNXDXAUMXEXDWQWOXDXAVDWOXDWQWTVEVGXEWAWB
        WAWBWCVTWNXDXAVFWAWBWCVTWNXDXAVHVGWAWBWCVTWNXDXAVIWRWSWQWOXDVJWRWSWQWOX
        DVKWHWKWMVTWDXDXAVLUBABCDEFGHIJKLBWPIUKZCWIIUKLUKZXFCWJIUKLUKZMNOPQRSTU
        AXGVMXHVMVNVCVOVP $.

      $( Use ~ cdlemg37 to eliminate ` E. r e. A ` from ~ cdlemg36 .  TODO:
         Fix comment.  (Contributed by NM, 31-May-2013.) $)
      cdlemg38 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
           /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( F e. T /\ G e. T /\ P =/= Q )
        /\ ( ( ( F ` P ) =/= P /\ ( G ` P ) =/= P )
           /\ ( R ` F ) =/= ( R ` G ) ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
        ( vr chlt wcel wa wbr wn w3a wne cfv cv wceq wrex simpl1 simpl2 simpl3l
        simpl3r simpr syl113anc simpl11 simpl12 simpl13 simpl21 simpl22 simpl23
        co cdlemg36 cdlemg37 syl133anc pm2.61dan ) JUBUCMHUCUDZBAUCBMKUEUFUDZCA
        UCCMKUEUFUDZUGZFEUCZGEUCZBCUHZUGZBFUIBUHBGUIZBUHUDZFDUIGDUIUHZUDZUGZUAU
        JZMKUEUFBWCIVECWCIVEUKUDUAAULZBVRFUIIVEMLVECCGUIFUIIVEMLVEUKZWBWDUDVMVQ
        VSVTWDWEVMVQWAWDUMVMVQWAWDUNVSVTVMVQWDUOVSVTVMVQWDUPWBWDUQABCDEFGHIJKLM
        UANOPQRSTVFURWBWDUFZUDVJVKVLVNVOVPWFWEVJVKVLVQWAWFUSVJVKVLVQWAWFUTVJVKV
        LVQWAWFVAVNVOVPVMWAWFVBVNVOVPVMWAWFVCVNVOVPVMWAWFVDWBWFUQABCDEFGHIJKLMU
        ANOPQRSTVGVHVI $.

      $( Eliminate ` =/= ` conditions from ~ cdlemg38 .  TODO:  Would this
         better be done at ~ cdlemg35 ?  TODO:  Fix comment.  (Contributed by
         NM, 31-May-2013.) $)
      cdlemg39 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
        /\ ( F e. T /\ G e. T /\ P =/= Q ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
        ( chlt wcel wa wbr wn wne w3a co simpl1 simpl2l simpl2r simpl31 simpl32
        cfv simpr cdlemg15 syl321anc simpll1 simpll2 adantr cdlemg14f syl113anc
        wceq cdlemg14g simpll3 simplr cdlemg38 syl312anc pm2.61da2ne pm2.61dane
        ) JUAUBMHUBUCZBAUBBMKUDUEUCZCAUBCMKUDUEUCZUCZFEUBZGEUBZBCUFZUGZUGZBBGUN
        ZFUNIUHMLUHCCGUNFUNIUHMLUHVCZFDUNZGDUNZVSWBWCVCZUCVKVLVMVOVPWDWAVKVNVRW
        DUIVLVMVKVRWDUJVLVMVKVRWDUKVOVPVQVKVNWDULVOVPVQVKVNWDUMVSWDUOABCDEFGHIJ
        KLMNOPQRSTUPUQVSWBWCUFZUCZWABFUNZBVTBWFWGBVCZUCVKVNVOVPWHWAVKVNVRWEWHUR
        VKVNVRWEWHUSWFVOWHVOVPVQVKVNWEULZUTWFVPWHVOVPVQVKVNWEUMZUTWFWHUOABCDEFG
        HIJKLMNOPQRSTVAVBWFVTBVCZUCVKVNVOVPWKWAVKVNVRWEWKURVKVNVRWEWKUSWFVOWKWI
        UTWFVPWKWJUTWFWKUOABCDEFGHIJKLMNOPQRSTVDVBWFWGBUFVTBUFUCZUCVKVLVMVRWLWE
        WAVKVNVRWEWLURWFVLWLVLVMVKVRWEUJUTWFVMWLVLVMVKVRWEUKUTVKVNVRWEWLVEWFWLU
        OVSWEWLVFABCDEFGHIJKLMNOPQRSTVGVHVIVJ $.
    $}

    $( Eliminate ` P =/= Q ` conditions from ~ cdlemg39 .  TODO:  Fix comment.
       (Contributed by NM, 31-May-2013.) $)
    cdlemg40 $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
              /\ ( F e. T /\ G e. T ) )
    -> ( ( P .\/ ( F ` ( G ` P ) ) ) ./\ W )
       = ( ( Q .\/ ( F ` ( G ` Q ) ) ) ./\ W ) ) $=
      ( wcel wa chlt wbr wn w3a cfv co wceq id fveq2d oveq12d oveq1d adantl wne
      fveq2 simpl1 simpl2 simpl3l simpr ctrl eqid cdlemg39 syl113anc pm2.61dane
      simpl3r ) IUASLGSTZBASBLJUBUCTCASCLJUBUCTTZEDSZFDSZTZUDZBBFUEZEUEZHUFZLKU
      FCCFUEZEUEZHUFZLKUFUGZBCBCUGZVQVJVRVMVPLKVRBCVLVOHVRUHVRVKVNEBCFUNUIUJUKU
      LVJBCUMZTVEVFVGVHVSVQVEVFVIVSUOVEVFVIVSUPVGVHVEVFVSUQVGVHVEVFVSVDVJVSURAB
      CLIUSUEUEZDEFGHIJKLMNOPQRVTUTVAVBVC $.

    $( Convert ~ cdlemg40 to function composition.  TODO:  Fix comment.
       (Contributed by NM, 31-May-2013.) $)
    cdlemg41 $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
              /\ ( F e. T /\ G e. T ) )
    -> ( ( P .\/ ( ( F o. G ) ` P ) ) ./\ W )
       = ( ( Q .\/ ( ( F o. G ) ` Q ) ) ./\ W ) ) $=
      ( wcel co chlt wa wbr wn w3a cfv ccom cdlemg40 wceq simp1 simp3 ltrncoval
      simp2ll syl3anc oveq2d oveq1d simp2rl 3eqtr4d ) IUASLGSUBZBASZBLJUCUDZUBZ
      CASZCLJUCUDZUBZUBZEDSFDSUBZUEZBBFUFEUFZHTZLKTCCFUFEUFZHTZLKTBBEFUGZUFZHTZ
      LKTCCVMUFZHTZLKTABCDEFGHIJKLMNOPQRUHVHVOVJLKVHVNVIBHVHUSVGUTVNVIUIUSVFVGU
      JZUSVFVGUKZUTVAVEUSVGUMABDEFGIJLMPQRULUNUOUPVHVQVLLKVHVPVKCHVHUSVGVCVPVKU
      IVRVSVCVDVBUSVGUQACDEFGIJLMPQRULUNUOUPUR $.
  $}

  ${
    ltrnco.h $e |- H = ( LHyp ` K ) $.
    ltrnco.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $d p q F $.  $d p q G $.  $d p q H $.  $d p q K $.  $d p q T $.
    $d p q W $.
    $( The composition of two translations is a translation.  Part of proof of
       Lemma G of [Crawley] p. 116, line 15 on p. 117.  (Contributed by NM,
       31-May-2013.) $)
    ltrnco $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
    -> ( F o. G ) e. T ) $=
      ( vp vq chlt wcel wa w3a cfv cv wbr wn co eqid ccom cple cjn cmee wceq wi
      cldil catm wral simp1 3adant3 3adant2 ldilco syl3anc simp11 simp2l simp3l
      ltrnldil simp2r simp3r simp12 simp13 cdlemg41 syl122anc 3exp ralrimivv wb
      jca isltrn 3ad2ant1 mpbir2and ) EKLFDLMZBALZCALZNZBCUAZALZVPFEUGOOZLZIPZF
      EUBOZQRZJPZFWAQRZMZVTVTVPOEUCOZSFEUDOZSWCWCVPOWFSFWGSUEZUFZJEUHOZUIIWJUIZ
      VOVLBVRLZCVRLZVSVLVMVNUJVLVMWLVNVRABDEKFGVRTZHURUKVLVNWMVMVRACDEKFGWNHURU
      LVRBCDEKFGWNUMUNVOWIIJWJWJVOVTWJLZWCWJLZMZWEWHVOWQWENZVLWOWBMWPWDMVMVNWHV
      LVMVNWQWEUOWRWOWBVOWOWPWEUPVOWQWBWDUQVHWRWPWDVOWOWPWEUSVOWQWBWDUTVHVLVMVN
      WQWEVAVLVMVNWQWEVBWJVTWCABCDWFEWAWGFWATZWFTZWGTZWJTZGHVCVDVEVFVLVMVQVSWKM
      VGVNWJKVRAVPDWFEWAWGFJIWSWTXAXBGWNHVIVJVK $.
  $}

  ${
    trlcocnv.h $e |- H = ( LHyp ` K ) $.
    trlcocnv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlcocnv.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Swap the arguments of the trace of a composition with converse.
       (Contributed by NM, 1-Jul-2013.) $)
    trlcocnv $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
    -> ( R ` ( F o. `' G ) ) = ( R ` ( G o. `' F ) ) ) $=
      ( chlt wcel wa w3a ccnv ccom cfv cnvco cocnvcnv1 eqtri wceq simp1 ltrncnv
      fveq2i 3adant2 ltrnco syld3an3 trlcnv syl2anc syl5reqr ) FKLGELMZCBLZDBLZ
      NZDCOZPZAQCDOZPZOZAQZURAQZUSUPAUSUQOUOPUPCUQRDUOSTUDUNUKURBLZUTVAUAUKULUM
      UBUKULUMUQBLZVBUKUMVCULBDEFGHIUCUEBCUQEFGHIUFUGABUREFGHIJUHUIUJ $.
  $}

  ${
    trlcoabs.l $e |- .<_ = ( le ` K ) $.
    trlcoabs.j $e |- .\/ = ( join ` K ) $.
    trlcoabs.a $e |- A = ( Atoms ` K ) $.
    trlcoabs.h $e |- H = ( LHyp ` K ) $.
    trlcoabs.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlcoabs.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Absorption into a composition by joining with trace.  (Contributed by
       NM, 22-Jul-2013.) $)
    trlcoabs $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
           /\ ( P e. A /\ -. P .<_ W ) )
   -> ( ( ( F o. G ) ` P ) .\/ ( R ` F ) ) = ( ( G ` P ) .\/ ( R ` F ) ) ) $=
      ( wcel wa cfv chlt wbr wn w3a ccom ltrncoval 3adant3r oveq1d simp1 simp2l
      co wceq ltrnel 3adant2l trljat3 syl3anc eqtr4d ) IUARKGRSZEDRZFDRZSZBARZB
      KJUBUCZSZUDZBEFUETZECTZHUKBFTZETZVGHUKZVHVGHUKZVEVFVIVGHURVAVBVFVIULVCABD
      EFGIJKLNOPUFUGUHVEURUSVHARVHKJUBUCSZVKVJULURVAVDUIURUSUTVDUJURUTVDVLUSABD
      FGIJKLNOPUMUNAVHCDEGHIJKLMNOPQUOUPUQ $.

    $( Absorption of the trace of a composition.  (Contributed by NM,
       29-Jul-2013.)  (New usage is discouraged.) $)
    trlcoabs2N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
           /\ ( P e. A /\ -. P .<_ W ) )
  -> ( ( F ` P ) .\/ ( R ` ( G o. `' F ) ) )
    = ( ( F ` P ) .\/ ( G ` P ) ) ) $=
      ( wcel cfv co chlt wa wbr wn w3a ccnv ccom cmee wceq simp1 simp2r ltrncnv
      simp2l syl2anc ltrnco syl3anc ltrnel 3adant2r oveq2d simp1l simp3l ltrnat
      eqid trlval2 hlatjcl simp1r lhpbase hlatlej1 atmod3i1 syl131anc ltrncoval
      cbs syl cp1 syl121anc coass cid cres wf1o ltrn1o f1ococnv1 coeq2d wf f1of
      fcoi1 3syl eqtrd syl5eq fveq1d eqtr3d lhpjat2 oveq12d hlol olm11 3eqtrd
      col ) IUARZKGRZUBZEDRZFDRZUBZBARZBKJUCUDZUBZUEZBESZFEUFZUGZCSZHTXGXGXGXIS
      ZHTZKIUHSZTZHTZXLXGKHTZXMTZXGBFSZHTZXFXJXNXGHXFWSXIDRZXGARZXGKJUCUDUBZXJX
      NUIWSXBXEUJZXFWSXAXHDRZXTYCWSWTXAXEUKZXFWSWTYDYCWSWTXAXEUMZDEGIKOPULUNDFX
      HGIKOPUOUPZWSWTXEYBXAABDEGIJKLNOPUQURZAXGCDXIGHIJXMKLMXMVCZNOPQVDUPUSXFWQ
      YAXLIVLSZRZKYJRZXGXLJUCZXOXQUIWQWRXBXEUTZXFWSWTXCYAYCYFWSXBXCXDVAZABDEGIJ
      KLNOPVBUPZXFWQYAXKARZYKYNYPXFWSXTYAYQYCYGYPAXGDXIGIJKLNOPVBUPZAYJHIXGXKYJ
      VCZMNVEUPXFWRYLWQWRXBXEVFYJGIKYSOVGVMXFWQYAYQYMYNYPYRAXGXKHIJLMNVHUPAYJXG
      HIJXMXLKYSLMYINVIVJXFXQXSIVNSZXMTZXSXFXLXSXPYTXMXFXKXRXGHXFBXIEUGZSZXKXRX
      FWSXTWTXCUUCXKUIYCYGYFYOABDXIEGIJKLNOPVKVOXFBUUBFXFUUBFXHEUGZUGZFFXHEVPXF
      UUEFVQYJVRZUGZFXFUUDUUFFXFYJYJEVSZUUDUUFUIXFWSWTUUHYCYFYJDEGIUAKYSOPVTUNY
      JYJEWAVMWBXFYJYJFVSZYJYJFWCUUGFUIXFWSXAUUIYCYEYJDFGIUAKYSOPVTUNYJYJFWDYJY
      JFWEWFWGWHWIWJUSXFWSYBXPYTUIYCYHAXGYTGHIJKLMYTVCZNOWKUNWLXFIWPRZXSYJRZUUA
      XSUIXFWQUUKYNIWMVMXFWQYAXRARZUULYNYPXFWSXAXCUUMYCYEYOABDFGIJKLNOPVBUPAYJH
      IXGXRYSMNVEUPYJYTIXMXSYSYIUUJWNUNWGWO $.
  $}

  ${
    trlcoat.a $e |- A = ( Atoms ` K ) $.
    trlcoat.h $e |- H = ( LHyp ` K ) $.
    trlcoat.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlcoat.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The trace of a composition of two translations is an atom if their
       traces are different.  (Contributed by NM, 15-Jun-2013.) $)
    trlcoat $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
    /\ ( R ` F ) =/= ( R ` G ) )
         -> ( R ` ( F o. G ) ) e. A ) $=
      ( chlt wcel wa cfv ccom wceq wf1o syl2anc wne cp0 cid cbs wb ltrnco 3expb
      cres eqid trlid0b syldan coass simpll simplrl ltrn1o f1ococnv1 syl coeq1d
      ccnv coeq2 adantl 3eqtr3a wf simplrr f1of fcoi2 3syl ltrncnv fcoi1 fveq2d
      3eqtr3d trlcnv eqtr2d ex sylbird necon3d trlatn0 sylibrd 3impia ) GMNHFNO
      ZDCNZECNZOZDBPZEBPZUAZDEQZBPZANZVTWCOZWFWHGUBPZUAZWIWJWHWKWDWEWJWHWKRZWGU
      CGUDPZUHZRZWDWERZVTWCWGCNZWPWMUEVTWAWBWRCDEFGHJKUFUGZWNBCWGFGHWKWNUIZWKUI
      ZJKLUJUKWJWPWQWJWPOZWEDUSZBPZWDXBEXCBXBWOEQZXCWOQZEXCXBXCDQZEQXCWGQZXEXFX
      CDEULXBXGWOEXBWNWNDSZXGWORXBVTWAXIVTWCWPUMZVTWAWBWPUNZWNCDFGMHWTJKUOTWNWN
      DUPUQURWPXHXFRWJWGWOXCUTVAVBXBWNWNESZWNWNEVCXEERXBVTWBXLXJVTWAWBWPVDWNCEF
      GMHWTJKUOTWNWNEVEWNWNEVFVGXBWNWNXCSZWNWNXCVCXFXCRXBVTXCCNZXMXJXBVTWAXNXJX
      KCDFGHJKVHTWNCXCFGMHWTJKUOTWNWNXCVEWNWNXCVIVGVKVJXBVTWAXDWDRXJXKBCDFGHJKL
      VLTVMVNVOVPVTWCWRWIWLUEWSABCWGFGHWKXAIJKLVQUKVRVS $.

    $( Commonly used special case of ~ trlcoat .  (Contributed by NM,
       1-Jul-2013.) $)
    trlcocnvat $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
    /\ ( R ` F ) =/= ( R ` G ) )
         -> ( R ` ( F o. `' G ) ) e. A ) $=
      ( chlt wcel wa cfv wne w3a ccnv syl2anc simp1 simp2l simp2r ltrncnv simp3
      ccom wceq trlcnv neeqtrrd trlcoat syl121anc ) GMNHFNOZDCNZECNZOZDBPZEBPZQ
      ZRZULUMESZCNZUPUTBPZQDUTUFBPANULUOURUAZULUMUNURUBUSULUNVAVCULUMUNURUCZCEF
      GHJKUDTUSUPUQVBULUOURUEUSULUNVBUQUGVCVDBCEFGHJKLUHTUIABCDUTFGHIJKLUJUK $.
  $}

  ${
    trlconid.b $e |- B = ( Base ` K ) $.
    trlconid.h $e |- H = ( LHyp ` K ) $.
    trlconid.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlconid.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( The composition of two different translations is not the identity
       translation.  (Contributed by NM, 22-Jul-2013.) $)
    trlconid $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
    /\ ( R ` F ) =/= ( R ` G ) )
         -> ( F o. G ) =/= ( _I |` B ) ) $=
      ( chlt wcel wa cfv wne w3a ccom cid cres catm trlcoat simp1 simp2l simp2r
      eqid wb ltrnco syl3anc trlnidatb syl2anc mpbird ) GMNHFNOZDCNZECNZOZDBPEB
      PQZRZDESZTAUAQZUTBPGUBPZNZVBBCDEFGHVBUGZJKLUCUSUNUTCNZVAVCUHUNUQURUDZUSUN
      UOUPVEVFUNUOUPURUEUNUOUPURUFCDEFGHJKUIUJVBABCUTFGHIVDJKLUKULUM $.
  $}

  ${
    trlco.l $e |- .<_ = ( le ` K ) $.
    trlco.j $e |- .\/ = ( join ` K ) $.
    trlco.h $e |- H = ( LHyp ` K ) $.
    trlco.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlco.r $e |- R = ( ( trL ` K ) ` W ) $.
    ${
      trlcolem.m $e |- ./\ = ( meet ` K ) $.
      trlcolem.a $e |- A = ( Atoms ` K ) $.
      $( Lemma for ~ trlco .  (Contributed by NM, 1-Jun-2013.) $)
      trlcolem $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
  -> ( R ` ( F o. G ) )
         .<_ ( ( R ` F ) .\/ ( R ` G ) ) ) $=
        ( wcel chlt wa wbr wn w3a cfv co ccom clat cbs simp1l hllat simp3l eqid
        syl atbase simp1 simp2r ltrnat syl3anc latlej1 wi hlatjcl simp2l ltrncl
        latjlej1 syl13anc latjcl simp1r lhpbase latmlem1 wceq trlval2 ltrncoval
        mpd ltrnco syld3an2 3adant3r oveq2d oveq1d eqtrd ltrnel oveq12d latjcom
        latmcl latmle2 lhpmod6i1 syl121anc latjass latlej2 lhpjat1 syl2anc hlol
        cp1 lhpmod2i2 col olm11 3eqtrd eqtr3d 3brtr4d ) IUATZLGTZUBZEDTZFDTZUBZ
        BATZBLJUCUDZUBZUEZBBFUFZEUFZHUGZLKUGZBXKHUGZXLHUGZLKUGZEFUHZCUFZECUFZFC
        UFZHUGZJXJXMXPJUCZXNXQJUCZXJBXOJUCZYCXJIUITZBIUJUFZTZXKYGTZYEXJXAYFXAXB
        XFXIUKZIULUOZXJXGYHXCXFXGXHUMZAYGBIYGUNZSUPUOZXJXKATZYIXJXCXEXGYOXCXFXI
        UQZXCXDXEXIURZYLABDFGIJLMSOPUSUTZAYGXKIYMSUPUOZYGHIJBXKYMMNVAUTXJYFYHXO
        YGTZXLYGTZYEYCVBYKYNXJXAXGYOYTYJYLYRAYGHIBXKYMNSVCUTZXJXCXDYIUUAYPXCXDX
        EXIVDZYSYGDEGIUALXKYMOPVEUTZYGHIJBXOXLYMMNVFVGVOXJYFXMYGTZXPYGTZLYGTZYC
        YDVBYKXJYFYHUUAUUEYKYNUUDYGHIBXLYMNVHUTXJYFYTUUAUUFYKUUBUUDYGHIXOXLYMNV
        HUTXJXBUUGXAXBXFXIVIYGGILYMOVJUOZYGIJKXMXPLYMMRVKVGVOXJXSBBXRUFZHUGZLKU
        GZXNXCXRDTZXFXIXSUUKVLXJXCXDXEUULYPUUCYQDEFGILOPVPUTABCDXRGHIJKLMNRSOPQ
        VMVQXJUUJXMLKXJUUIXLBHXCXFXGUUIXLVLXHABDEFGIJLMSOPVNVRVSVTWAXJYBXKXLHUG
        ZLKUGZXOLKUGZHUGZUUOUUNHUGZXQXJXTUUNYAUUOHXJXCXDYOXKLJUCUDUBZXTUUNVLYPU
        UCXCXEXFXIUURYQABDFGIJLMSOPWBVQZAXKCDEGHIJKLMNRSOPQVMUTXCXEXFXIYAUUOVLY
        QABCDFGHIJKLMNRSOPQVMVQWCXJYFUUNYGTZUUOYGTZUUPUUQVLYKXJYFUUMYGTZUUGUUTY
        KXJXAYOXLATZUVBYJYRXJXCXDYOUVCYPUUCYRAXKDEGIJLMSOPUSUTAYGHIXKXLYMNSVCUT
        UUHYGIKUUMLYMRWEUTXJYFYTUUGUVAYKUUBUUHYGIKXOLYMRWEUTZYGHIUUNUUOYMNWDUTX
        JUUQUUOUUMHUGZLKUGZXQXJXCUVAUVBUUOLJUCZUUQUVFVLYPUVDXJYFYIUUAUVBYKYSUUD
        YGHIXKXLYMNVHUTXJYFYTUUGUVGYKUUBUUHYGIJKXOLYMMRWFUTYGGHIJKLUUOUUMYMMNRO
        WGWHXJUVEXPLKXJUUOXKHUGZXLHUGZUVEXPXJYFUVAYIUUAUVIUVEVLYKUVDYSUUDYGHIUU
        OXKXLYMNWIVGXJUVHXOXLHXJUVHXOLXKHUGZKUGZXOIWNUFZKUGZXOXJXCYTYIXKXOJUCZU
        VHUVKVLYPUUBYSXJYFYHYIUVNYKYNYSYGHIJBXKYMMNWJUTYGGHIJKLXOXKYMMNROWOWHXJ
        UVJUVLXOKXJXCUURUVJUVLVLYPUUSAXKUVLGHIJLMNUVLUNZSOWKWLVSXJIWPTZYTUVMXOV
        LXJXAUVPYJIWMUOUUBYGUVLIKXOYMRUVOWQWLWRVTWSVTWAWRWT $.
    $}

    $d p F $.  $d p G $.  $d p H $.  $d p .\/ $.  $d p K $.  $d p .<_ $.
    $d p R $.  $d p T $.  $d p W $.
    $( The trace of a composition of translations is less than or equal to the
       join of their traces.  Part of proof of Lemma G of [Crawley] p. 116,
       second paragraph on p. 117.  (Contributed by NM, 2-Jun-2013.) $)
    trlco $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
   -> ( R ` ( F o. G ) )
     .<_ ( ( R ` F ) .\/ ( R ` G ) ) ) $=
      ( vp wcel wa wbr cfv eqid chlt w3a cv wn ccom catm wrex lhpexnle 3ad2ant1
      co simpl1 simpl2 simpl3 simpr cmee trlcolem syl121anc rexlimddv ) GUAPIEP
      QZCBPZDBPZUBZOUCZIHRUDZCDUEASCASDASFUJHRZOGUFSZUSUTVDOVFUGVAVFEGHIOJVFTZL
      UHUIVBVCVFPVDQZQUSUTVAVHVEUSUTVAVHUKUSUTVAVHULUSUTVAVHUMVBVHUNVFVCABCDEFG
      HGUOSZIJKLMNVITVGUPUQUR $.
  $}

  ${
    trlcone.b $e |- B = ( Base ` K ) $.
    trlcone.h $e |- H = ( LHyp ` K ) $.
    trlcone.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trlcone.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( If two translations have different traces, the trace of their
       composition is also different.  (Contributed by NM, 14-Jun-2013.) $)
    trlcone $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( F e. T /\ G e. T )
         /\ ( ( R ` F ) =/= ( R ` G ) /\ G =/= ( _I |` B ) ) )
    -> ( R ` F ) =/= ( R ` ( F o. G ) ) ) $=
      ( wcel wa cfv wne ccom wceq syl2anc syl3anc chlt cid cres w3a cp0 simpl3l
      catm cple wbr ccnv cjn co simp11 simp12l ltrncnv simp12r eqid trlco coass
      ltrnco wf1o ltrn1o f1ococnv1 syl coeq1d wf f1of fcoi2 3syl eqtrd syl5reqr
      fveq2d simp11l simp2 hlatjidm trlcnv eqcomd oveq12d eqtr3d 3brtr4d cal wb
      simp3 hlatl simp13r atcmp mpbid 3expia necon3d mpd simpl3r simpl1 simpl2r
      trlnidat trlid0b necon3bid necomd simpr simpl2l 3netr4d wo simp1 trlator0
      mpbird simp2l mpjaodan ) GUAMZHFMZNZDCMZECMZNZDBOZEBOZPZEUBAUCZPZNZUDZXMG
      UGOZMZXMDEQZBOZPZXMGUEOZRZXSYANZXOYDXOXQXIXLYAUFYGXMYCXMXNXSYAXMYCRZXMXNR
      XSYAYHUDZXNXMYIXNXMGUHOZUIZXNXMRZYIDUJZYBQZBOZYMBOZYCGUKOZULZXNXMYJYIXIYM
      CMZYBCMZYOYRYJUIXIXLXRYAYHUMZYIXIXJYSUUAXJXKXIXRYAYHUNZCDFGHJKUOSYIXIXJXK
      YTUUAUUBXJXKXIXRYAYHUPZCDEFGHJKUTTBCYMYBFYQGYJHYJUQZYQUQZJKLURTYIEYNBYIYN
      YMDQZEQZEYMDEUSYIUUGXPEQZEYIUUFXPEYIAADVAZUUFXPRYIXIXJUUIUUAUUBACDFGUAHIJ
      KVBSAADVCVDVEYIAAEVAZAAEVFZUUHERZYIXIXKUUJUUAUUCACEFGUAHIJKVBZSAAEVGZAAEV
      HZVIVJVKVLYIXMXMYQULZXMYRYIXGYAUUPXMRXGXHXLXRYAYHVMZXSYAYHVNZXTYQGXMUUEXT
      UQZVOSYIXMYPXMYCYQYIYPXMYIXIXJYPXMRUUAUUBBCDFGHJKLVPSVQXSYAYHWCVRVSVTYIGW
      AMZXNXTMZYAYKYLWBYIXGUUTUUQGWDVDYIXIXKXQUVAUUAUUCXOXQXIXLYAYHWEXTABCEFGHI
      UUSJKLWNTUURXTXNXMGYJUUDUUSWFTWGVQWHWIWJXSYFNZYEXNXMYCUVBXNYEUVBXQXNYEPXO
      XQXIXLYFWKUVBEXPXNYEUVBXIXKEXPRXNYERWBXIXLXRYFWLZXJXKXIXRYFWMZABCEFGHYEIY
      EUQZJKLWOSWPWGWQXSYFWRZUVBYBEBUVBYBUUHEUVBDXPEUVBDXPRZYFUVFUVBXIXJUVGYFWB
      UVCXJXKXIXRYFWSABCDFGHYEIUVEJKLWOSXDVEUVBUUJUUKUULUVBXIXKUUJUVCUVDUUMSUUN
      UUOVIVJVLWTXSXIXJYAYFXAXIXLXRXBXIXJXKXRXEXTBCDFGHYEUVEUUSJKLXCSXF $.
  $}

  ${
    cdlemg42.l $e |- .<_ = ( le ` K ) $.
    cdlemg42.j $e |- .\/ = ( join ` K ) $.
    cdlemg42.a $e |- A = ( Atoms ` K ) $.
    cdlemg42.h $e |- H = ( LHyp ` K ) $.
    cdlemg42.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemg42.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Part of proof of Lemma G of [Crawley] p. 116, first line of third
       paragraph on p. 117.  (Contributed by NM, 3-Jun-2013.) $)
    cdlemg42 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ G e. T )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( G ` P ) =/= P
              /\ ( R ` F ) =/= ( R ` G ) ) )
        -> -. ( G ` P ) .<_ ( P .\/ ( F ` P ) ) ) $=
      ( wcel cfv syl3anc chlt wa wbr wn wne co simp33 wceq cmee simpl1l simp31l
      w3a adantr simp1 simp2l ltrnat hlatlej1 simpr clat cbs wb syl eqid atbase
      hllat simp2r hlatjcl latjle12 syl13anc mpbi2and simpl32 necomd ps-1 mpbid
      syl132anc oveq1d simpl1 simpl2r simpl31 trlval2 simpl2l 3eqtr4rd necon3ad
      ex mpd ) IUARZKGRZUBZEDRZFDRZUBZBARZBKJUCUDZUBZBFSZBUEZECSZFCSZUEZULZULZW
      SWOBBESZHUFZJUCZUDWHWKWNWPWSUGXAXDWQWRXAXDWQWRUHXAXDUBZBWOHUFZKIUISZUFZXC
      KXGUFZWRWQXEXFXCKXGXEXFXCJUCZXFXCUHZXEBXCJUCZXDXJXEWFWLXBARZXLWFWGWKWTXDU
      JZXAWLXDWLWMWPWSWHWKUKZUMZXAXMXDXAWHWIWLXMWHWKWTUNZWHWIWJWTUOXOABDEGIJKLN
      OPUPTUMZABXBHIJLMNUQTXAXDURXEIUSRZBIUTSZRZWOXTRZXCXTRZXLXDUBXJVAXEWFXSXNI
      VEVBXEWLYAXPAXTBIXTVCZNVDVBXEWOARZYBXAYEXDXAWHWJWLYEXQWHWIWJWTVFXOABDFGIJ
      KLNOPUPTUMZAXTWOIYDNVDVBXEWFWLXMYCXNXPXRAXTHIBXBYDMNVGTXTHIJBWOXCYDLMVHVI
      VJXEWFWLYEBWOUEWLXMXJXKVAXNXPYFXEWOBWNWPWSWHWKXDVKVLXPXRABWOBXBHIJLMNVMVO
      VNVPXEWHWJWNWRXHUHWHWKWTXDVQZWIWJWHWTXDVRWNWPWSWHWKXDVSZABCDFGHIJXGKLMXGV
      CZNOPQVTTXEWHWIWNWQXIUHYGWIWJWHWTXDWAYHABCDEGHIJXGKLMYINOPQVTTWBWDWCWE $.

    cdlemg42.m $e |- ./\ = ( meet ` K ) $.
    $( Part of proof of Lemma G of [Crawley] p. 116, third line of third
       paragraph on p. 117.  (Contributed by NM, 3-Jun-2013.) $)
    cdlemg43 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ G e. T )
          /\ ( ( P e. A /\ -. P .<_ W ) /\ ( G ` P ) =/= P
              /\ ( R ` F ) =/= ( R ` G ) ) )
        -> ( F ` ( G ` P ) ) = ( ( ( G ` P ) .\/ ( R ` F ) )
              ./\ ( ( F ` P ) .\/ ( R ` G ) ) ) ) $=
      ( co chlt wcel wa wbr cfv wne w3a wceq simp1 simp2l simp31 simp2r syl3anc
      wn ltrnel cdlemg42 cdlemc syl131anc trlval2 oveq2d eqtr4d ) IUAUBLGUBUCZE
      DUBZFDUBZUCZBAUBBLJUDUNUCZBFUEZBUFZECUEZFCUEZUFZUGZUGZVGEUEZVGVIHTZBEUEZB
      VGHTLKTZHTZKTZVOVPVJHTZKTVMVBVCVFVGAUBVGLJUDUNUCZVGBVPHTJUDUNVNVSUHVBVEVL
      UIZVBVCVDVLUJVBVEVFVHVKUKZVMVBVDVFWAWBVBVCVDVLULZWCABDFGIJLMOPQUOUMABCDEF
      GHIJLMNOPQRUPABVGCDEGHIJKLMNSOPQRUQURVMVTVRVOKVMVJVQVPHVMVBVDVFVJVQUHWBWD
      WCABCDFGHIJKLMNSOPQRUSUMUTUTVA $.
  $}

  ${
    cdlemg44.h $e |- H = ( LHyp ` K ) $.
    cdlemg44.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemg44.r $e |- R = ( ( trL ` K ) ` W ) $.
    ${
      cdlemg44.l $e |- .<_ = ( le ` K ) $.
      cdlemg44.a $e |- A = ( Atoms ` K ) $.
      $( Part of proof of Lemma G of [Crawley] p. 116, fourth line of third
         paragraph on p. 117:  "so fg(p) = gf(p)."  (Contributed by NM,
         3-Jun-2013.) $)
      cdlemg44a $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
            /\ ( ( F ` P ) =/= P /\ ( G ` P ) =/= P
                /\ ( R ` F ) =/= ( R ` G ) ) )
        -> ( F ` ( G ` P ) ) = ( G ` ( F ` P ) ) ) $=
        ( wcel cfv wne co syl3anc chlt wa wbr w3a cjn cmee clat cbs wceq simp1l
        hllat syl simp1 simp22 simp23l eqid atbase ltrncl simp21 syl2anc latjcl
        wn trlcl latmcom simp23 simp32 simp33 cdlemg43 syl123anc simp31 3eqtr4d
        necomd ) HUAPZJGPZUBZEDPZFDPZBAPZBJIUCVBZUBZUDZBEQZBRZBFQZBRZECQZFCQZRZ
        UDZUDZWDWFHUEQZSZWBWGWKSZHUFQZSZWMWLWNSZWDEQZWBFQZWJHUGPZWLHUHQZPZWMWTP
        ZWOWPUIWJVMWSVMVNWAWIUJHUKULZWJWSWDWTPZWFWTPZXAXCWJVOVQBWTPZXDVOWAWIUMZ
        VOVPVQVTWIUNZWJVRXFVRVSVPVQVOWIUOAWTBHWTUPZOUQULZWTDFGHUAJBXIKLURTWJVOV
        PXEXGVOVPVQVTWIUSZWTCDEGHJXIKLMVCUTWTWKHWDWFXIWKUPZVATWJWSWBWTPZWGWTPZX
        BXCWJVOVPXFXMXGXKXJWTDEGHUAJBXIKLURTWJVOVQXNXGXHWTCDFGHJXIKLMVCUTWTWKHW
        BWGXIXLVATWTHWNWLWMXIWNUPZVDTWJVOVPVQVTWEWHWQWOUIXGXKXHVOVPVQVTWIVEZVOW
        AWCWEWHVFVOWAWCWEWHVGZABCDEFGWKHIWNJNXLOKLMXOVHVIWJVOVQVPVTWCWGWFRWRWPU
        IXGXHXKXPVOWAWCWEWHVJWJWFWGXQVLABCDFEGWKHIWNJNXLOKLMXOVHVIVK $.

      $( Eliminate ` ( F `` P ) =/= P ` , ` ( G `` P ) =/= P ` from
         ~ cdlemg44a .  (Contributed by NM, 3-Jun-2013.) $)
      cdlemg44b $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
            /\ ( R ` F ) =/= ( R ` G ) )
        -> ( F ` ( G ` P ) ) = ( G ` ( F ` P ) ) ) $=
        ( wcel wa wbr cfv wceq wn w3a wne simpl1 simpl21 simpl23 simpl22 ltrnel
        chlt simpr ltrnateq syl131anc fveq2d eqtr4d simpl2 simprl simprr simpl3
        syl3anc cdlemg44a syl113anc pm2.61da2ne ) HUIPJGPQZEDPZFDPZBAPBJIRUAQZU
        BZECSFCSUCZUBZBFSZESZBESZFSZTZVLBVJBVIVLBTZQZVKVJVMVPVCVDVFVJAPVJJIRUAQ
        ZVOVKVJTVCVGVHVOUDZVDVEVFVCVHVOUEVDVEVFVCVHVOUFZVPVCVEVFVQVRVDVEVFVCVHV
        OUGVSABDFGHIJNOKLUHUSVIVOUJZABVJDEGHIJNOKLUKULVPVLBFVTUMUNVIVJBTZQZVKVL
        VMWBVJBEVIWAUJZUMWBVCVEVFVLAPVLJIRUAQZWAVMVLTVCVGVHWAUDZVDVEVFVCVHWAUGV
        DVEVFVCVHWAUFZWBVCVDVFWDWEVDVEVFVCVHWAUEWFABDEGHIJNOKLUHUSWCABVLDFGHIJN
        OKLUKULUNVIVLBUCZVJBUCZQZQVCVGWGWHVHVNVCVGVHWIUDVCVGVHWIUOVIWGWHUPVIWGW
        HUQVCVGVHWIURABCDEFGHIJKLMNOUTVAVB $.
    $}

    $d p F $.  $d p G $.  $d p H $.  $d p K $.  $d p R $.  $d p T $.  $d p W $.
    $( Part of proof of Lemma G of [Crawley] p. 116, fifth line of third
       paragraph on p. 117:  "and hence fg = gf."  (Contributed by NM,
       3-Jun-2013.) $)
    cdlemg44 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
          /\ ( R ` F ) =/= ( R ` G ) )
        -> ( F o. G ) = ( G o. F ) ) $=
      ( vp wcel wa cfv w3a ccom wceq eqid ltrnco syl3anc chlt wne cple wbr catm
      cv wn lhpexnle 3ad2ant1 simp11 simp12l simp12r 3simpc cdlemg44b syl131anc
      wrex simp13 simp12 simp2 ltrncoval syl121anc 3eqtr4d syl311anc rexlimdv3a
      cdlemd mpd ) FUALGELMZCBLZDBLZMZCANDANUBZOZKUFZGFUCNZUDUGZKFUENZUPZCDPZDC
      PZQZVGVJVQVKVPEFVNGKVNRZVPRZHUHUIVLVOVTKVPVLVMVPLZVOOZVGVRBLZVSBLZWCVOMZV
      MVRNZVMVSNZQVTVGVJVKWCVOUJZWDVGVHVIWEWJVHVIVGVKWCVOUKZVHVIVGVKWCVOULZBCDE
      FGHISTWDVGVIVHWFWJWLWKBDCEFGHISTVLWCVOUMZWDVMDNCNZVMCNDNZWHWIWDVGVHVIWGVK
      WNWOQWJWKWLWMVGVJVKWCVOUQVPVMABCDEFVNGHIJWAWBUNUOWDVGVJWCWHWNQWJVGVJVKWCV
      OURVLWCVOUSZVPVMBCDEFVNGWAWBHIUTTWDVGVIVHWCWIWOQWJWLWKWPVPVMBDCEFVNGWAWBH
      IUTVAVBVPVMBVRVSEFVNGWAWBHIVEVCVDVF $.
  $}

  ${
    cdlemg46.b $e |- B = ( Base ` K ) $.
    cdlemg46.h $e |- H = ( LHyp ` K ) $.
    cdlemg46.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( TODO: fix comment.  TODO:  Use this above in place of ` ( F `` P ) = P `
       antecedents?  (Contributed by NM, 5-Jun-2013.) $)
    cdlemg47a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
        /\ F = ( _I |` B ) )
      -> ( F o. G ) = ( G o. F ) ) $=
      ( chlt wcel wa cid cres wceq w3a ccom wf syl wf1o simp1 simp2r f1of fcoi1
      ltrn1o syl2anc simp3 coeq2d coeq1d fcoi2 eqtrd 3eqtr4rd ) FKLGELMZCBLZDBL
      ZMZCNAOZPZQZDURRZDDCRCDRZUTAADSZVADPUTAADUAZVCUTUNUPVDUNUQUSUBUNUOUPUSUCA
      BDEFKGHIJUFUGAADUDTZAADUETUTCURDUNUQUSUHZUIUTVBURDRZDUTCURDVFUJUTVCVGDPVE
      AADUKTULUM $.

    cdlemg46.r $e |- R = ( ( trL ` K ) ` W ) $.
    $d u B $.  $d h u F $.  $d h u H $.  $d h u K $.  $d h u R $.  $d h u T $.
    $d h u W $.
    $( Part of proof of Lemma G of [Crawley] p. 116, seventh line of third
       paragraph on p. 117:  "hf and f have different traces."  (Contributed by
       NM, 5-Jun-2013.) $)
    cdlemg46 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ h e. T )
        /\ ( F =/= ( _I |` B ) /\ h =/= ( _I |` B )
           /\ ( R ` h ) =/= ( R ` F ) ) )
        -> ( R ` ( h o. F ) ) =/= ( R ` F ) ) $=
      ( wcel wa wne cfv ccom wbr syl3anc syl2anc chlt cv cid cres w3a catm cple
      co simpl1l simp1 simp2r simp32 eqid trlnidat adantr simp2l simp31 simpl33
      cjn simpr ccnv ltrnco ltrncnv trlco wf1o wceq ltrn1o f1ococnv2 syl coeq2d
      coass wf f1of fcoi1 3syl eqtrd syl5eq fveq2d trlcnv 3brtr3d hlatlej2 clat
      oveq2d wb hllat atbase hlatjcl latjle12 syl13anc 2atjlej syl133anc nelne2
      mpbi2and wn necomd sylan pm2.61dan ) GUAMZHFMZNZECMZDUBZCMZNZEUCAUDZOZXBX
      EOZXBBPZEBPZOZUEZUEZXBEQZBPZGUFPZMZXNXIOZXLXPNZWRXHXOMZXIXOMZXJXPXTXHXIGU
      SPZUHXNXIYAUHZGUGPZRZXQWRWSXDXKXPUIZXLXSXPXLWTXCXGXSWTXDXKUJZWTXAXCXKUKZW
      TXDXFXGXJULXOABCXBFGHIXOUMZJKLUNSUOZXLXTXPXLWTXAXFXTYFWTXAXCXKUPZWTXDXFXG
      XJUQXOABCEFGHIYHJKLUNSZUOZXFXGXJWTXDXPURXLXPUTZYLXRXHYBYCRZXIYBYCRZYDXLYN
      XPXLXMEVAZQZBPZXNYPBPZYAUHZXHYBYCXLWTXMCMZYPCMZYRYTYCRYFXLWTXCXAUUAYFYGYJ
      CXBEFGHJKVBSXLWTXAUUBYFYJCEFGHJKVCTBCXMYPFYAGYCHYCUMZYAUMZJKLVDSXLYQXBBXL
      YQXBEYPQZQZXBXBEYPVKXLUUFXBXEQZXBXLUUEXEXBXLAAEVEZUUEXEVFXLWTXAUUHYFYJACE
      FGUAHIJKVGTAAEVHVIVJXLAAXBVEZAAXBVLUUGXBVFXLWTXCUUIYFYGACXBFGUAHIJKVGTAAX
      BVMAAXBVNVOVPVQVRXLYSXIXNYAXLWTXAYSXIVFYFYJBCEFGHJKLVSTWCVTUOXRWRXPXTYOYE
      YMYLXOXNXIYAGYCUUCUUDYHWASXRGWBMZXHAMZXIAMZYBAMZYNYONYDWDXRWRUUJYEGWEVIXR
      XSUUKYIXOAXHGIYHWFVIXRXTUULYLXOAXIGIYHWFVIXRWRXPXTUUMYEYMYLXOAYAGXNXIIUUD
      YHWGSAYAGYCXHXIYBIUUCUUDWHWIWMXOXHXIXNXIYAGYCUUCUUDYHWJWKXLXTXPWNZXQYKXTU
      UNNXIXNXIXNXOWLWOWPWQ $.

    $( Part of proof of Lemma G of [Crawley] p. 116, ninth line of third
       paragraph on p. 117:  "we conclude that gf = fg."  (Contributed by NM,
       5-Jun-2013.) $)
    cdlemg47 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
        /\ ( h e. T /\ ( R ` F ) = ( R ` G ) )
        /\ ( F =/= ( _I |` B ) /\ h =/= ( _I |` B )
                /\ ( R ` h ) =/= ( R ` F ) ) )
        -> ( F o. G ) = ( G o. F ) ) $=
      ( chlt wcel cfv wceq wne ccom coass wa w3a cv cid cres ccnv simp11 simp2l
      simp12 ltrnco syl3anc simp13 simp3 cdlemg46 simp2r neeqtrd syl6eqr simp33
      syl121anc cdlemg44 coeq1d eqtr4d 3eqtr3g coeq2d wf1o ltrn1o f1ococnv1 syl
      syl2anc syl5eqr wf f1of fcoi2 3syl eqtrd 3eqtr3d ) HNOIGOUAZECOZFCOZUBZDU
      CZCOZEBPZFBPZQZUAZEUDAUEZRZWAWGRZWABPZWCRZUBZUBZWAUFZWAEFSZSZSZWNWAFESZSZ
      SZWOWRWMWPWSWNWMWAESZFSZWAFSZESZWPWSWMXBFWASZESZXDWMXBFXASZXFWMVQXACOZVSX
      ABPZWDRXBXGQVQVRVSWFWLUGZWMVQWBVRXHXJVTWBWEWLUHZVQVRVSWFWLUIZCWAEGHIKLUJU
      KVQVRVSWFWLULZWMXIWCWDWMVQVRWBWLXIWCRXJXLXKVTWFWLUMABCDEGHIJKLMUNUSVTWBWE
      WLUOZUPBCXAFGHIKLMUTUSFWAETUQWMXCXEEWMVQWBVSWJWDRXCXEQXJXKXMWMWJWCWDVTWFW
      HWIWKURXNUPBCWAFGHIKLMUTUSVAVBWAEFTWAFETVCVDWMWQWGWOSZWOWMWQWNWASZWOSXOWN
      WAWOTWMXPWGWOWMAAWAVEZXPWGQWMVQWBXQXJXKACWAGHNIJKLVFVIAAWAVGVHZVAVJWMAAWO
      VEZAAWOVKXOWOQWMVQWOCOZXSXJWMVQVRVSXTXJXLXMCEFGHIKLUJUKACWOGHNIJKLVFVIAAW
      OVLAAWOVMVNVOWMWTWGWRSZWRWMWTXPWRSYAWNWAWRTWMXPWGWRXRVAVJWMAAWRVEZAAWRVKY
      AWRQWMVQWRCOZYBXJWMVQVSVRYCXJXMXLCFEGHIKLUJUKACWRGHNIJKLVFVIAAWRVLAAWRVMV
      NVOVP $.

    $d h B $.  $d h G $.
    $( Elmininate ` h ` from ~ cdlemg47 .  (Contributed by NM, 5-Jun-2013.) $)
    cdlemg48 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ G e. T )
        /\ ( F =/= ( _I |` B ) /\ ( R ` F ) = ( R ` G ) ) )
        -> ( F o. G ) = ( G o. F ) ) $=
      ( vh wcel wa wne cfv wceq w3a ccom chlt cid cres cv wrex cdlemftr1 simp11
      3ad2ant1 simp12l simp12r simp13r simp13l simp3l simp3r cdlemg47 syl323anc
      simp2 rexlimdv3a mpd ) GUANHFNOZDCNZECNZOZDUBAUCZPZDBQZEBQRZOZSZMUDZVDPZV
      JBQVFPZOZMCUEZDETEDTRZUTVCVNVHABCMFGHVFIJKLUFUHVIVMVOMCVIVJCNZVMSUTVAVBVP
      VGVEVKVLVOUTVCVHVPVMUGVAVBUTVHVPVMUIVAVBUTVHVPVMUJVIVPVMUQVEVGUTVCVPVMUKV
      EVGUTVCVPVMULVIVPVKVLUMVIVPVKVLUNABCMDEFGHIJKLUOUPURUS $.
  $}

  ${
    ltrncom.h $e |- H = ( LHyp ` K ) $.
    ltrncom.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Composition is commutative for translations.  Part of proof of Lemma G
       of [Crawley] p. 116 (Contributed by NM, 5-Jun-2013.) $)
    ltrncom $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
        -> ( F o. G ) = ( G o. F ) ) $=
      ( wcel wa ccom wceq cfv simpr eqid syl121anc wne simpll1 simpll2 simpll3
      chlt w3a cid cbs cres simpl1 simpl2 simpl3 cdlemg47a ctrl simplr cdlemg48
      syl122anc cdlemg44 pm2.61dane ) EUAIFDIJZBAIZCAIZUBZBCKCBKLZBUCEUDMZUEZUS
      BVBLZJUPUQURVCUTUPUQURVCUFUPUQURVCUGUPUQURVCUHUSVCNVAABCDEFVAOZGHUIPUSBVB
      QZJZUTBFEUJMMZMZCVGMZVFVHVILZJUPUQURVEVJUTUPUQURVEVJRUPUQURVEVJSUPUQURVEV
      JTUSVEVJUKVFVJNVAVGABCDEFVDGHVGOZULUMVFVHVIQZJUPUQURVLUTUPUQURVEVLRUPUQUR
      VEVLSUPUQURVEVLTVFVLNVGABCDEFGHVKUNPUOUO $.

    $( Rearrange a composition of 4 translations, analogous to ~ an4 .
       (Contributed by NM, 10-Jun-2013.) $)
    ltrnco4 $p |- ( ( ( K e. HL /\ W e. H ) /\ E e. T /\ F e. T )
    -> ( ( D o. E ) o. ( F o. G ) ) = ( ( D o. F ) o. ( E o. G ) ) ) $=
      ( chlt wcel wa w3a ccom ltrncom coeq1d coass 3eqtr3g coeq2d 3eqtr4g ) GKL
      HFLMCBLDBLNZACDEOZOZOADCEOZOZOACOUCOADOUEOUBUDUFAUBCDOZEODCOZEOUDUFUBUGUH
      EBCDFGHIJPQCDERDCERSTACUCRADUERUA $.
  $}

  ${
    trljco.j $e |- .\/ = ( join ` K ) $.
    trljco.h $e |- H = ( LHyp ` K ) $.
    trljco.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    trljco.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Trace joined with trace of composition.  (Contributed by NM,
       15-Jun-2013.) $)
    trljco $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
   -> ( ( R ` F ) .\/ ( R ` ( F o. G ) ) )
         = ( ( R ` F ) .\/ ( R ` G ) ) ) $=
      ( wcel wa cfv co wceq adantr syl3anc wbr chlt w3a ccom cid cbs cres coeq1
      wf1o eqid ltrn1o 3adant2 f1of fcoi2 3syl sylan9eqr fveq2d oveq2d cp0 clat
      wf simp1l hllat syl trlcl 3adant3 latjidm syl2anc hlol olj01 eqtr4d coeq2
      fcoi1 wb trlid0b biimpa 3eqtr4d cple simp1 ltrnco latjcl latlej1 latjle12
      col trlco syl13anc mpbi2and eqbrtrd eqbrtrrd latasymd catm simpl1l simpl1
      simpr wne simpl2 simpr1 trlnidat simpl3 jca simpr3 trlcoat simpr2 trlcone
      syl112anc ps-1 syl132anc mpbid pm2.61da3ne ) GUAMZHEMZNZCBMZDBMZUBZCAOZCD
      UCZAOZFPZXODAOZFPZQZCUDGUEOZUFZDYCXOXSXNCYCQZNZXQXSXOFYEXPDAYDXNXPYCDUCZD
      CYCDUGXNYBYBDUHZYBYBDUTYFDQXKXMYGXLYBBDEGUAHYBUIZJKUJUKYBYBDULYBYBDUMUNUO
      UPUQXNDYCQZNZXOXOFPZXOGUROZFPZXRXTXNYKYMQYIXNYKXOYMXNGUSMZXOYBMZYKXOQXNXI
      YNXIXJXLXMVAZGVBVCZXKXLYOXMYBABCEGHYHJKLVDVEZYBFGXOYHIVFVGZXNGWCMZYOYMXOQ
      XNXIYTYPGVHVCYRYBFGXOYLYHIYLUIZVIVGVJRYJXQXOXOFYJXPCAYIXNXPCYCUCZCDYCCVKX
      NYBYBCUHZYBYBCUTUUBCQXKXLUUCXMYBBCEGUAHYHJKUJVEYBYBCULYBYBCVLUNUOUPUQYJXS
      YLXOFXNYIXSYLQZXKXMYIUUDVMXLYBABDEGHYLYHUUAJKLVNUKVOUQVPXNXOXSQZNZYBGGVQO
      ZXRXTYHUUGUIZXNYNUUEYQRXNXRYBMZUUEXNYNYOXQYBMZUUIYQYRXNXKXPBMUUJXKXLXMVRB
      CDEGHJKVSYBABXPEGHYHJKLVDVGZYBFGXOXQYHIVTSRXNXTYBMZUUEXNYNYOXSYBMZUULYQYR
      XKXMUUMXLYBABDEGHYHJKLVDUKZYBFGXOXSYHIVTSZRXNXRXTUUGTZUUEXNXOXTUUGTZXQXTU
      UGTZUUPXNYNYOUUMUUQYQYRUUNYBFGUUGXOXSYHUUHIWASABCDEFGUUGHUUHIJKLWDXNYNYOU
      UJUULUUQUURNUUPVMYQYRUUKUUOYBFGUUGXOXQXTYHUUHIWBWEWFZRUUFYKXTXRUUGUUFXOXS
      XOFXNUUEWMUQXNYKXRUUGTUUEXNYKXOXRUUGYSXNYNYOUUJXOXRUUGTYQYRUUKYBFGUUGXOXQ
      YHUUHIWASWGRWHWIXNCYCWNZDYCWNZXOXSWNZUBZNZUUPYAXNUUPUVCUUSRUVDXIXOGWJOZMZ
      XQUVEMZXOXQWNZUVFXSUVEMZUUPYAVMXIXJXLXMUVCWKUVDXKXLUUTUVFXKXLXMUVCWLZXKXL
      XMUVCWOZXNUUTUVAUVBWPUVEYBABCEGHYHUVEUIZJKLWQSZUVDXKXLXMNZUVBUVGUVJUVDXLX
      MUVKXKXLXMUVCWRZWSZXNUUTUVAUVBWTZUVEABCDEGHUVLJKLXASUVDXKUVNUVBUVAUVHUVJU
      VPUVQXNUUTUVAUVBXBZYBABCDEGHYHJKLXCXDUVMUVDXKXMUVAUVIUVJUVOUVRUVEYBABDEGH
      YHUVLJKLWQSUVEXOXQXOXSFGUUGUUHIUVLXEXFXGXH $.

    $( Trace joined with trace of composition.  (Contributed by NM,
       16-Jun-2013.) $)
    trljco2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
   -> ( ( R ` F ) .\/ ( R ` ( F o. G ) ) )
         = ( ( R ` G ) .\/ ( R ` ( F o. G ) ) ) ) $=
      ( chlt wcel cfv co ccom wceq trlcl trljco wa w3a clat cbs simp1l syl eqid
      hllat 3adant3 3adant2 latjcom syl3anc 3com23 eqtr4d ltrncom fveq2d oveq2d
      3eqtr4d ) GMNZHENZUAZCBNZDBNZUBZCAOZDAOZFPZVFDCQZAOZFPZVECDQZAOZFPVFVLFPV
      DVGVFVEFPZVJVDGUCNZVEGUDOZNZVFVONZVGVMRVDUSVNUSUTVBVCUEGUHUFVAVBVPVCVOABC
      EGHVOUGZJKLSUIVAVCVQVBVOABDEGHVRJKLSUJVOFGVEVFVRIUKULVAVCVBVJVMRABDCEFGHI
      JKLTUMUNABCDEFGHIJKLTVDVLVIVFFVDVKVHABCDEGHJKUOUPUQUR $.
  $}

  $c TGrp $.
  $( Extend class notation with translation group. $)
  ctgrp $a class TGrp $.

  ${
    $d k w f g $.
    $( Define the class of all translation groups. ` k ` is normally a member
       of ` HL ` .  Each base set is the set of all lattice translations with
       respect to a hyperplane ` w ` , and the operation is function
       composition.  Similar to definition of G in [Crawley] p. 116, third
       paragraph (which defines this for geomodular lattices).  (Contributed by
       NM, 5-Jun-2013.) $)
    df-tgrp $a |- TGrp = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
       { <. ( Base ` ndx ) , ( ( LTrn ` k ) ` w ) >. ,
       <. ( +g ` ndx ) , ( f e. ( ( LTrn ` k ) ` w ) ,
             g e. ( ( LTrn ` k ) ` w ) |-> ( f o. g ) ) >. } ) ) $.
  $}

  ${
    $d x y z .+ $.  $d k w x y z H $.  $d f g k w x y z K $.  $d f g x y z T $.
    $d x y z B $.  $d x y z G $.  $d f g w x y z W $.  $d f g X $.  $d f g Y $.
    tgrpset.h $e |- H = ( LHyp ` K ) $.
    $( The translation group maps for a lattice ` K ` .  (Contributed by NM,
       5-Jun-2013.) $)
    tgrpfset $p |- ( K e. V -> ( TGrp ` K ) = ( w e. H
   |-> { <. ( Base ` ndx ) , ( ( LTrn ` K ) ` w ) >. ,
       <. ( +g ` ndx ) , ( f e. ( ( LTrn ` K ) ` w ) ,
             g e. ( ( LTrn ` K ) ` w ) |-> ( f o. g ) ) >. } ) ) $=
      ( vk wcel cvv ctgrp cfv cnx cv cltrn cop cmpt2 cpr cmpt clh cbs ccom wceq
      cplusg elex fveq2 syl6eqr fveq1d opeq2d eqidd mpt2eq123dv preq12d df-tgrp
      mpteq12dv fvex eqeltri mptex fvmpt syl ) EFIEJIEKLADMUALZANZEOLZLZPZMUDLZ
      BCVCVCBNCNUBZQZPZRZSZUCEFUEHEAHNZTLZUTVAVKOLZLZPZVEBCVNVNVFQZPZRZSVJJKVKE
      UCZAVLVRDVIVSVLETLZDVKETUFGUGVSVOVDVQVHVSVNVCUTVSVAVMVBVKEOUFUHZUIVSVPVGV
      EVSBCVNVNVFVCVCVFWAWAVSVFUJUKUIULUNABCHUMADVIDVTJGETUOUPUQURUS $.

    tgrpset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tgrpset.g $e |- G = ( ( TGrp ` K ) ` W ) $.
    $( The translation group for a fiducial co-atom ` W ` .  (Contributed by
       NM, 5-Jun-2013.) $)
    tgrpset $p |- ( ( K e. V /\ W e. H ) -> G
       = { <. ( Base ` ndx ) , T >. ,
       <. ( +g ` ndx ) , ( f e. T ,
             g e. T |-> ( f o. g ) ) >. } ) $=
      ( vw wcel cfv cnx cop cv cmpt2 cpr opeq2d wa ctgrp cplusg ccom cltrn cmpt
      cbs tgrpfset fveq1d wceq fveq2 eqidd mpt2eq123dv preq12d eqid prex opeq2i
      fvmpt mpt2eq123i preq12i syl6eqr sylan9eq syl5eq ) FGMZHEMZUADHFUBNZNZOUG
      NZAPZOUCNZBCAABQCQUDZRZPZSZKVDVEVGHLEVHLQZFUENZNZPZVJBCVQVQVKRZPZSZUFZNZV
      NVDHVFWBLBCEFGIUHUIVEWCVHHVPNZPZVJBCWDWDVKRZPZSZVNLHWAWHEWBVOHUJZVRWEVTWG
      WIVQWDVHVOHVPUKZTWIVSWFVJWIBCVQVQVKWDWDVKWJWJWIVKULUMTUNWBUOWEWGUPURVIWEV
      MWGAWDVHJUQVLWFVJBCAAVKWDWDVKJJVKUOUSUQUTVAVBVC $.

    ${
      tgrp.c $e |- C = ( Base ` G ) $.
      $( The base set of the translation group is the set of all translations
         (for a fiducial co-atom ` W ` ).  (Contributed by NM, 5-Jun-2013.) $)
      tgrpbase $p |- ( ( K e. V /\ W e. H ) -> C = T ) $=
        ( vf vg wcel cbs cfv cnx cop cv cvv wa cplusg ccom cmpt2 tgrpset fveq2d
        cpr wceq cltrn fvex eqeltri eqid grpbase ax-mp 3eqtr4g ) EFNGDNUAZCOPQO
        PBRQUBPLMBBLSMSUCUDZRUGZOPZABUPCUROBLMCDEFGHIJUEUFKBTNBUSUHBGEUIPZPTIGU
        TUJUKBUQURTURULUMUNUO $.
    $}

    ${
      tgrp.o $e |- .+ = ( +g ` G ) $.
      $( The group operation of the translation group is function composition.
         (Contributed by NM, 5-Jun-2013.) $)
      tgrpopr $p |- ( ( K e. V /\ W e. H ) -> .+ = ( f e. T ,
             g e. T |-> ( f o. g ) ) ) $=
        ( wcel cplusg cfv cnx cop cv cvv cbs ccom cmpt2 cpr tgrpset fveq2d wceq
        wa cltrn fvex eqeltri mpt2ex eqid grpplusg ax-mp 3eqtr4g ) GHNIFNUHZEOP
        QUAPBRQOPCDBBCSDSUBZUCZRUDZOPZAUSUQEUTOBCDEFGHIJKLUEUFMUSTNUSVAUGCDBBUR
        BIGUIPZPTKIVBUJUKZVCULBUSUTTUTUMUNUOUP $.

      $( The group operation value of the translation group is the composition
         of translations.  (Contributed by NM, 5-Jun-2013.) $)
      tgrpov $p |- ( ( K e. V /\ W e. H
                /\ ( X e. T /\ Y e. T ) )
              -> ( X .+ Y ) = ( X o. Y ) ) $=
        ( vf vg wcel co cv ccom wceq w3a cmpt2 tgrpopr 3adant3 oveqd cvv simp3l
        wa simp3r coexg 3ad2ant3 coeq1 coeq2 eqid ovmpt2g syl3anc eqtrd ) EFPZG
        DPZHBPZIBPZUHZUAZHIAQHINOBBNRZORZSZUBZQZHISZVCAVGHIURUSAVGTVBABNOCDEFGJ
        KLMUCUDUEVCUTVAVIUFPZVHVITURUSUTVAUGURUSUTVAUIVBURVJUSHIBBUJUKNOHIBBVFV
        IVGHVESUFVDHVEULVEIHUMVGUNUOUPUQ $.

      tgrp.b $e |- B = ( Base ` K ) $.
      $( Lemma for ~ tgrpgrp .  (Contributed by NM, 6-Jun-2013.) $)
      tgrpgrplem $p |- ( ( K e. HL /\ W e. H ) -> G e. Grp ) $=
        ( chlt wcel wa wceq co ccom tgrpov syl112anc vx vy vz ccnv cid cres cbs
        cv cfv eqid tgrpbase eqcomd cplusg a1i 3expa 3impb ltrnco eqeltrd coass
        w3a simpll simplr simpr1 simpr2 oveq1d simpl simpr3 eqtrd oveq2d idltrn
        syl3anc 3eqtr4a adantr simpr wf1o wf ltrn1o f1of 3syl ltrncnv f1ococnv1
        fcoi2 syl isgrpd ) FMNZGENZOZUAUBUCCBDUAUHZUDZUEAUFZWGDUGUIZCWKCDEFMGHI
        JWKUJUKULBDUMUIPWGKUNWGWHCNZUBUHZCNZUTWHWMBQZWHWMRZCWGWLWNWOWPPZWEWFWLW
        NOWQBCDEFMGWHWMHIJKSZUOUPCWHWMEFGHIUQZURWGWLWNUCUHZCNZUTZOZWPWTRZWHWMWT
        RZRZWOWTBQZWHWMWTBQZBQZWHWMWTUSXCXGWPWTBQZXDXCWOWPWTBXCWEWFWLWNWQWEWFXB
        VAZWEWFXBVBZWGWLWNXAVCZWGWLWNXAVDZWRTVEXCWEWFWPCNZXAXJXDPXKXLXCWGWLWNXO
        WGXBVFZXMXNWSVKWGWLWNXAVGZBCDEFMGWPWTHIJKSTVHXCXIWHXEBQZXFXCXHXEWHBXCWE
        WFWNXAXHXEPXKXLXNXQBCDEFMGWMWTHIJKSTVIXCWEWFWLXECNZXRXFPXKXLXMXCWGWNXAX
        SXPXNXQCWMWTEFGHIUQVKBCDEFMGWHXEHIJKSTVHVLACEFGLHIVJZWGWLOZWJWHBQZWJWHR
        ZWHYAWEWFWJCNZWLYBYCPWEWFWLVAZWEWFWLVBZWGYDWLXTVMWGWLVNZBCDEFMGWJWHHIJK
        STYAAAWHVOZAAWHVPYCWHPACWHEFMGLHIVQZAAWHVRAAWHWBVSVHCWHEFGHIVTZYAWIWHBQ
        ZWIWHRZWJYAWEWFWICNWLYKYLPYEYFYJYGBCDEFMGWIWHHIJKSTYAYHYLWJPYIAAWHWAWCV
        HWD $.
    $}
  $}

  ${
    tgrpgrp.h $e |- H = ( LHyp ` K ) $.
    tgrpgrp.g $e |- G = ( ( TGrp ` K ) ` W ) $.
    $( The translation group is a group.  (Contributed by NM, 6-Jun-2013.) $)
    tgrpgrp $p |- ( ( K e. HL /\ W e. H ) -> G e. Grp ) $=
      ( cbs cfv cplusg cltrn eqid tgrpgrplem ) CGHZAIHZDCJHHZABCDEOKFNKMKL $.

    $d f g G $.  $d f g H $.  $d f g K $.  $d f g W $.
    $( The translation group is an Abelian group.  Lemma G of [Crawley]
       p. 116.  (Contributed by NM, 6-Jun-2013.) $)
    tgrpabl $p |- ( ( K e. HL /\ W e. H ) -> G e. Abel ) $=
      ( vf vg chlt wcel wa cfv eqid cv ccom co wceq tgrpov 3expa 3impb tgrpbase
      cltrn cplusg cbs eqcomd eqidd tgrpgrp w3a ltrncom 3com23 3eqtr4d isabld )
      CIJZDBJZKZGHDCUBLLZAUCLZAUOAUDLZUPURUPABCIDEUPMZFURMUAUEUOUQUFABCDEFUGUOG
      NZUPJZHNZUPJZUHUTVBOZVBUTOZUTVBUQPZVBUTUQPZUPUTVBBCDEUSUIUOVAVCVFVDQZUMUN
      VAVCKVHUQUPABCIDUTVBEUSFUQMZRSTUOVCVAVGVEQZUOVCVAVJUMUNVCVAKVJUQUPABCIDVB
      UTEUSFVIRSTUJUKUL $.
  $}

  $c TEndo $.
  $c EDRing $.
  $c EDRingR $.

  $( Extend class notation with translation group endomorphisms. $)
  ctendo $a class TEndo $.

  $( Extend class notation with division ring on trace-preserving
     endomorphisms. $)
  cedring $a class EDRing $.

  $( Extend class notation with division ring on trace-preserving
     endomorphisms, with multiplication reversed.  TODO: remove ` EDRingR `
     theorems if not used. $)
  cedring-rN $a class EDRingR $.

  ${
    $d k w f x y s t $.
    $( Define trace-preserving endomorphisms on the set of translations.
       (Contributed by NM, 8-Jun-2013.) $)
    df-tendo $a |- TEndo = ( k e. _V |-> ( w e. ( LHyp ` k ) |-> { f |
   ( f : ( ( LTrn ` k ) ` w ) --> ( ( LTrn ` k ) ` w )
      /\ A. x e. ( ( LTrn ` k ) ` w ) A. y e. ( ( LTrn ` k ) ` w )
       ( f ` ( x o. y ) ) = ( ( f ` x ) o. ( f ` y ) )
      /\ A. x e. ( ( LTrn ` k ) ` w ) ( ( ( trL ` k ) ` w ) ` ( f ` x ) )
         ( le ` k ) ( ( ( trL ` k ) ` w ) ` x ) ) } ) ) $.

    $( Define division ring on trace-preserving endomorphisms.  Definition of E
       of [Crawley] p. 117, 4th line from bottom.  (Contributed by NM,
       8-Jun-2013.) $)
    df-edring-rN $a |- EDRingR = ( k e. _V |-> ( w e. ( LHyp ` k ) |-> {
       <. ( Base ` ndx ) , ( ( TEndo ` k ) ` w ) >. ,
       <. ( +g ` ndx ) , ( s e. ( ( TEndo ` k ) ` w ) ,
               t e. ( ( TEndo ` k ) ` w ) |->
           ( f e. ( ( LTrn ` k ) ` w ) |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. ( .r ` ndx ) , ( s e. ( ( TEndo ` k ) ` w ) ,
               t e. ( ( TEndo ` k ) ` w ) |-> ( t o. s ) ) >. } ) ) $.

    $( Define division ring on trace-preserving endomorphisms.  The
       multiplication operation is reversed composition, per the definition of
       E of [Crawley] p. 117, 4th line from bottom.  (Contributed by NM,
       8-Jun-2013.) $)
    df-edring $a |- EDRing = ( k e. _V |-> ( w e. ( LHyp ` k ) |-> {
       <. ( Base ` ndx ) , ( ( TEndo ` k ) ` w ) >. ,
       <. ( +g ` ndx ) , ( s e. ( ( TEndo ` k ) ` w ) ,
               t e. ( ( TEndo ` k ) ` w ) |->
           ( f e. ( ( LTrn ` k ) ` w ) |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. ( .r ` ndx ) , ( s e. ( ( TEndo ` k ) ` w ) ,
               t e. ( ( TEndo ` k ) ` w ) |-> ( s o. t ) ) >. } ) ) $.
  $}

  ${
    $d k .<_ $.  $d k w H $.  $d s k w f g K $.  $d k R $.  $d k f g T $.
    tendoset.l $e |- .<_ = ( le ` K ) $.
    tendoset.h $e |- H = ( LHyp ` K ) $.
    $( The set of all trace-preserving endomorphisms on the set of translations
       for a lattice ` K ` .  (Contributed by NM, 8-Jun-2013.) $)
    tendofset $p |- ( K e. V -> ( TEndo ` K ) = ( w e. H
 |-> { s | ( s : ( ( LTrn ` K ) ` w ) --> ( ( LTrn ` K ) ` w )
      /\ A. f e. ( ( LTrn ` K ) ` w ) A. g e. ( ( LTrn ` K ) ` w )
       ( s ` ( f o. g ) ) = ( ( s ` f ) o. ( s ` g ) )
      /\ A. f e. ( ( LTrn ` K ) ` w ) ( ( ( trL ` K ) ` w ) ` ( s ` f ) )
         .<_ ( ( ( trL ` K ) ` w ) ` f ) ) } ) ) $=
      ( vk cvv cfv cv cltrn wceq wral clh fveq2 fveq1d wcel ctendo wf ccom ctrl
      wbr w3a cab cmpt elex syl6eqr feq23d raleqdv raleqbidv breq123d 3anbi123d
      cple abbidv mpteq12dv df-tendo fvex eqeltri mptex fvmpt syl ) EGUAELUAEUB
      MADANZEOMZMZVHHNZUCZBNZCNZUDVIMVKVIMZVLVIMUDPZCVHQZBVHQZVMVFEUEMZMZMZVKVR
      MZFUFZBVHQZUGZHUHZUIZPEGUJKEAKNZRMZVFWFOMZMZWIVIUCZVNCWIQZBWIQZVMVFWFUEMZ
      MZMZVKWNMZWFUQMZUFZBWIQZUGZHUHZUIWELUBWFEPZAWGXADWDXBWGERMZDWFERSJUKXBWTW
      CHXBWJVJWLVPWSWBXBWIWIVHVHVIXBVFWHVGWFEOSTZXDULXBWKVOBWIVHXDXBVNCWIVHXDUM
      UNXBWRWABWIVHXDXBWOVSWPVTWQFXBVMWNVRXBVFWMVQWFEUESTZTXBWQEUQMFWFEUQSIUKXB
      VKWNVRXETUOUNUPURUSBCAHKUTADWDDXCLJERVAVBVCVDVE $.

    tendoset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendoset.r $e |- R = ( ( trL ` K ) ` W ) $.
    tendoset.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $d w .<_ $.  $d w R $.  $d s w T $.  $d s w f g W $.
    $( The set of trace-preserving endomorphisms on the set of translations for
       a fiducial co-atom ` W ` .  (Contributed by NM, 8-Jun-2013.) $)
    tendoset $p |- ( ( K e. V /\ W e. H ) -> E
  = { s | ( s : T --> T
      /\ A. f e. T A. g e. T
       ( s ` ( f o. g ) ) = ( ( s ` f ) o. ( s ` g ) )
      /\ A. f e. T ( R ` ( s ` f ) )
         .<_ ( R ` f ) ) } ) $=
      ( vw cfv cv wral wcel wa ctendo wf ccom wceq wbr w3a cltrn ctrl tendofset
      cab cmpt fveq1d feq23d raleqdv raleqbidv syl6eqr breq12d 3anbi123d abbidv
      fveq2 eqid cmap co cvv fvex mapval ovex eqeltrri simp1 ss2abi ssexi fvmpt
      feq23i raleqi raleqbii 3anbi123i abbii sylan9eq syl5eq ) GIUAZJFUAZUBEJGU
      CRZRZBBKSZUDZCSZDSZUEWFRWHWFRZWIWFRUEUFZDBTZCBTZWJARZWHARZHUGZCBTZUHZKULZ
      PWBWCWEJQFQSZGUIRZRZXBWFUDZWKDXBTZCXBTZWJWTGUJRZRZRZWHXGRZHUGZCXBTZUHZKUL
      ZUMZRZWSWBJWDXNQCDFGHIKLMUKUNWCXOJXARZXPWFUDZWKDXPTZCXPTZWPCXPTZUHZKULZWS
      QJXMYBFXNWTJUFZXLYAKYCXCXQXEXSXKXTYCXBXBXPXPWFWTJXAVBZYDUOYCXDXRCXBXPYDYC
      WKDXBXPYDUPUQYCXJWPCXBXPYDYCXHWNXIWOHYCWJXGAYCXGJXFRAWTJXFVBOURZUNYCWHXGA
      YEUNUSUQUTVAXNVCYBXQKULZXPXPVDVEYFVFXPXPKJXAVGZYGVHXPXPVDVIVJYAXQKXQXSXTV
      KVLVMVNWRYAKWGXQWMXSWQXTBBXPXPWFNNVOWLXRCBXPNWKDBXPNVPVQWPCBXPNVPVRVSURVT
      WA $.

    $d s R $.  $d s f g S $.  $d s .<_ $.
    $( The predicate "is a trace-preserving endomorphism".  Similar to
       definition of trace-preserving endomorphism in [Crawley] p. 117,
       penultimate line.  (Contributed by NM, 8-Jun-2013.) $)
    istendo $p |- ( ( K e. V /\ W e. H ) -> ( S e. E
 <-> ( S : T --> T
      /\ A. f e. T A. g e. T
       ( S ` ( f o. g ) ) = ( ( S ` f ) o. ( S ` g ) )
      /\ A. f e. T ( R ` ( S ` f ) )
         .<_ ( R ` f ) ) ) ) $=
      ( vs wcel cfv wral wa cv ccom wceq wbr w3a cab tendoset eleq2d cltrn fvex
      cvv eqeltri fex mpan2 3ad2ant1 feq1 fveq1 coeq12d eqeq12d 2ralbidv fveq2d
      wf breq1d ralbidv 3anbi123d elab3 syl6bb ) HJRKGRUAZBFRBCCQUBZVCZDUBZEUBZ
      UCZVJSZVLVJSZVMVJSZUCZUDZECTDCTZVPASZVLASZIUEZDCTZUFZQUGZRCCBVCZVNBSZVLBS
      ZVMBSZUCZUDZECTDCTZWIASZWBIUEZDCTZUFZVIFWFBACDEFGHIJKQLMNOPUHUIWEWQQBWGWM
      BULRZWPWGCULRWRCKHUJSZSULNKWSUKUMCCULBUNUOUPVJBUDZVKWGVTWMWDWPCCVJBUQWTVS
      WLDECCWTVOWHVRWKVNVJBURWTVPWIVQWJVLVJBURZVMVJBURUSUTVAWTWCWODCWTWAWNWBIWT
      VPWIAXAVBVDVEVFVGVH $.

    $d f .<_ $.  $d f F $.  $d f R $.
    $( Trace-preserving property of a trace-preserving endomorphism.
       (Contributed by NM, 9-Jun-2013.) $)
    tendotp $p |- ( ( ( K e. V /\ W e. H )
             /\ S e. E /\ F e. T )
     -> ( R ` ( S ` F ) ) .<_ ( R ` F ) ) $=
      ( vf vg wcel cfv wral wa wbr wf cv ccom wceq w3a wi istendo fveq2 breq12d
      fveq2d rspccv 3ad2ant3 syl6bi 3imp ) GIRJFRUAZBDRZECRZEBSZASZEASZHUBZUQUR
      CCBUCZPUDZQUDZUEBSVEBSZVFBSUEUFQCTPCTZVGASZVEASZHUBZPCTZUGUSVCUHZABCPQDFG
      HIJKLMNOUIVLVDVMVHVKVCPECVEEUFZVIVAVJVBHVNVGUTAVEEBUJULVEEAUJUKUMUNUOUP
      $.

    $d f g ph $.
    istendod.1 $e |- ( ph -> ( K e. V /\ W e. H ) ) $.
    istendod.2 $e |- ( ph -> S : T --> T ) $.
    istendod.3 $e |- ( ( ph
       /\ f e. T /\ g e. T )
     -> ( S ` ( f o. g ) ) = ( ( S ` f ) o. ( S ` g ) ) ) $.
    istendod.4 $e |- ( ( ph /\ f e. T )
     -> ( R ` ( S ` f ) ) .<_ ( R ` f ) ) $.
    $( Deduce the predicate "is a trace-preserving endomorphism".  (Contributed
       by NM, 9-Jun-2013.) $)
    istendod $p |- ( ph -> S e. E ) $=
      ( wcel wf cv ccom cfv wceq wral wbr 3expb ralrimivva ralrimiva wa istendo
      w3a wb syl mpbir3and ) ACGUBZDDCUCZEUDZFUDZUECUFVACUFZVBCUFUEUGZFDUHEDUHZ
      VCBUFVABUFJUIZEDUHZSAVDEFDDAVADUBVBDUBVDTUJUKAVFEDUAULAIKUBLHUBUMUSUTVEVG
      UOUPRBCDEFGHIJKLMNOPQUNUQUR $.
  $}

  ${
    $d f g K $.  $d f g S $.  $d f g T $.  $d f g W $.
    tendof.h $e |- H = ( LHyp ` K ) $.
    tendof.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendof.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Functionality of a trace-preserving endomorphism.  (Contributed by NM,
       9-Jun-2013.) $)
    tendof $p |- ( ( ( K e. V /\ W e. H ) /\ S e. E )
          -> S : T --> T ) $=
      ( vf vg wcel wa wf cv ccom cfv wral eqid wceq ctrl cple wbr istendo simp1
      w3a syl6bi imp ) EFMGDMNZACMZBBAOZUJUKULKPZLPZQARUMARZUNARQUALBSKBSZUOGEU
      BRRZRUMUQREUCRZUDKBSZUGULUQABKLCDEURFGURTHIUQTJUEULUPUSUFUHUI $.

    $d f U $.  $d f V $.
    $( Condition determining equality of two trace-preserving endomorphisms.
       (Contributed by NM, 11-Jun-2013.) $)
    tendoeq1 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( U e. E /\ V e. E )
          /\ A. f e. T ( U ` f ) = ( V ` f ) ) -> U = V ) $=
      ( chlt wcel wa cfv wceq wfn wf tendof syl2anc cv wral w3a simp3 wb simp2l
      simp1 ffn syl simp2r eqfnfv mpbird ) FLMHEMNZBDMZGDMZNZCUAZBOUQGOPCAUBZUC
      ZBGPZURUMUPURUDUSBAQZGAQZUTURUEUSAABRZVAUSUMUNVCUMUPURUGZUMUNUOURUFBADEFL
      HIJKSTAABUHUIUSAAGRZVBUSUMUOVEVDUMUNUOURUJGADEFLHIJKSTAAGUHUICABGUKTUL $.

    $d f g F $.  $d g G $.
    $( Value of composition of translations in a trace-preserving
       endomorphism.  (Contributed by NM, 9-Jun-2013.) $)
    tendovalco $p |- ( ( ( K e. V /\ W e. H /\ S e. E )
       /\ ( F e. T /\ G e. T ) )
     -> ( S ` ( F o. G ) ) = ( ( S ` F ) o. ( S ` G ) ) ) $=
      ( vf vg wcel w3a ccom cfv wceq wral wa wi wf ctrl cple eqid istendo coeq1
      wbr fveq2d fveq2 coeq1d eqeq12d coeq2 coeq2d rspc2v com12 3ad2ant2 syl6bi
      cv 3impia imp ) GHOZIFOZACOZPDBOEBOUAZDEQZARZDARZEARZQZSZVCVDVEVFVLUBZVCV
      DUAVEBBAUCZMUTZNUTZQZARZVOARZVPARZQZSZNBTMBTZVSIGUDRRZRVOWDRGUERZUIMBTZPV
      MWDABMNCFGWEHIWEUFJKWDUFLUGWCVNVMWFVFWCVLWBVLDVPQZARZVIVTQZSMNDEBBVODSZVR
      WHWAWIWJVQWGAVODVPUHUJWJVSVIVTVODAUKULUMVPESZWHVHWIVKWKWGVGAVPEDUNUJWKVTV
      JVIVPEAUKUOUMUPUQURUSVAVB $.

    $( Value of composition of endomorphisms in a trace-preserving
       endomorphism.  (Contributed by NM, 9-Jun-2013.) $)
    tendocoval $p |- ( ( ( K e. X /\ W e. H )
       /\ ( U e. E /\ V e. E )
       /\ F e. T )
     -> ( ( U o. V ) ` F ) = ( U ` ( V ` F ) ) ) $=
      ( wcel wa w3a wf ccom cfv wceq syl2anc simp1 simp2r tendof simp3 fvco3 )
      FIMHEMNZBCMZGCMZNZDAMZOZAAGPZUJDBGQRDGRBRSUKUFUHULUFUIUJUAUFUGUHUJUBGACEF
      IHJKLUCTUFUIUJUDAADBGUET $.

    $( Closure of a trace-preserving endomorphism.  (Contributed by NM,
       9-Jun-2013.) $)
    tendocl $p |- ( ( ( K e. V /\ W e. H ) /\ S e. E /\ F e. T )
     -> ( S ` F ) e. T ) $=
      ( wcel wa w3a wf tendof 3adant3 simp3 ffvelrnd ) FGLHELMZACLZDBLZNBBDATUA
      BBAOUBABCEFGHIJKPQTUAUBRS $.

    $( Distribution of compositions in preparation for endomorphism sum
       definition.  (Contributed by NM, 10-Jun-2013.) $)
    tendoco2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( U e. E /\ V e. E )
       /\ ( F e. T /\ G e. T ) )
     -> ( ( U ` ( F o. G ) ) o. ( V ` ( F o. G ) ) )
          = ( ( ( U ` F ) o. ( V ` F ) ) o. ( ( U ` G ) o. ( V ` G ) ) ) ) $=
      ( chlt wcel wa ccom cfv wceq tendovalco syl3anc w3a simp1l simp1r coeq12d
      simp2l simp3l simp3r syl32anc simp2r simp1 tendocl ltrnco4 eqtrd ) GMNZIF
      NZOZBCNZHCNZOZDANZEANZOZUAZDEPZBQZVDHQZPDBQZEBQZPZDHQZEHQZPZPZVGVJPVHVKPP
      ZVCVEVIVFVLVCUNUOUQUTVAVEVIRUNUOUSVBUBZUNUOUSVBUCZUPUQURVBUEZUPUSUTVAUFZU
      PUSUTVAUGZBACDEFGMIJKLSUHVCUNUOURUTVAVFVLRVOVPUPUQURVBUIZVRVSHACDEFGMIJKL
      SUHUDVCUPVHANZVJANZVMVNRUPUSVBUJZVCUPUQVAWAWCVQVSBACEFGMIJKLUKTVCUPURUTWB
      WCVTVRHACDFGMIJKLUKTVGAVHVJVKFGIJKULTUM $.

    $d f g H $.
    $( The identity is a trace-preserving endomorphism.  (Contributed by NM,
       30-Jul-2013.) $)
    tendoidcl $p |- ( ( K e. HL /\ W e. H )
   -> ( _I |` T ) e. E ) $=
      ( vf vg chlt wcel wa ctrl cfv eqid cv ccom wceq fvresi cid cres cple wf1o
      id wf f1oi f1of mp1i w3a ltrnco syl 3ad2ant2 coeq12d eqtr4d adantl fveq2d
      3ad2ant3 clat cbs hllat ad2antrr trlcl latref syl2anc eqbrtrd istendod
      wbr ) DKLZECLZMZEDNOOZUAAUBZAIJBCDDUCOZKEVNPZFGVLPZHVKUEAAVMUDAAVMUFVKAUG
      AAVMUHUIVKIQZALZJQZALZUJZVQVSRZVMOZWBVQVMOZVSVMOZRWAWBALWCWBSAVQVSCDEFGUK
      AWBTULWAWDVQWEVSVRVKWDVQSZVTAVQTZUMVTVKWEVSSVRAVSTURUNUOVKVRMZWDVLOVQVLOZ
      WIVNWHWDVQVLVRWFVKWGUPUQWHDUSLZWIDUTOZLWIWIVNVHVIWJVJVRDVAVBWKVLAVQCDEWKP
      ZFGVPVCWKDVNWIWLVOVDVEVFVG $.

    $( Multiplicative identity multiplied by a trace-preserving endomorphism.
       (Contributed by NM, 20-Nov-2013.) $)
    tendo1mul $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E )
   -> ( ( _I |` T ) o. U ) = U ) $=
      ( chlt wcel wa wf cid cres ccom wceq tendof fcoi2 syl ) EJKFDKLBCKLAABMNA
      OBPBQBACDEJFGHIRAABST $.

    $( Multiplicative identity multiplied by a trace-preserving endomorphism.
       (Contributed by NM, 20-Nov-2013.) $)
    tendo1mulr $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E )
   -> ( U o. ( _I |` T ) ) = U ) $=
      ( chlt wcel wa wf cid cres ccom wceq tendof fcoi1 syl ) EJKFDKLBCKLAABMBN
      AOPBQBACDEJFGHIRAABST $.
  $}

  ${
    $d f g E $.  $d f g H $.  $d f g K $.  $d f g S $.  $d f g T $.
    $d f g W $.
    tendoco.h $e |- H = ( LHyp ` K ) $.
    tendoco.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( The composition of two trace-preserving endomorphisms (multiplication in
       the endormorphism ring) is a trace-preserving endomorphism.
       (Contributed by NM, 9-Jun-2013.) $)
    tendococl $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E /\ T e. E )
     -> ( S o. T ) e. E ) $=
      ( chlt wcel cfv ccom eqid wf syl2anc tendocl syl3anc tendocoval syl221anc
      wceq vf vg wa w3a ctrl cltrn cple simp1 simp2 tendof simp3 fco cv simp11l
      simp11r simp13 tendovalco syl32anc fveq2d simp12 simp11 syl121anc coeq12d
      eqtrd ltrnco 3eqtr4d cbs simpl1l hllat simpl1 simpl2 simpl3 simpr eqeltrd
      clat syl trlcl simpl1r wbr tendotp eqbrtrd lattrd istendod ) EIJZFDJZUCZA
      CJZBCJZUDZFEUEKKZABLZFEUFKKZUAUBCDEEUGKZIFWMMZGWLMZWJMZHWFWGWHUHZWIWLWLAN
      ZWLWLBNZWLWLWKNWIWFWGWRWQWFWGWHUIAWLCDEIFGWOHUJOWIWFWHWSWQWFWGWHUKBWLCDEI
      FGWOHUJOWLWLWLABULOWIUAUMZWLJZUBUMZWLJZUDZWTXBLZBKZAKZWTBKZAKZXBBKZAKZLZX
      EWKKZWTWKKZXBWKKZLXDXGXHXJLZAKZXLXDXFXPAXDWDWEWHXAXCXFXPTWDWEWGWHXAXCUNZW
      DWEWGWHXAXCUOZWFWGWHXAXCUPZWIXAXCUIZWIXAXCUKZBWLCWTXBDEIFGWOHUQURUSXDWDWE
      WGXHWLJZXJWLJZXQXLTXRXSWFWGWHXAXCUTZXDWFWHXAYCWFWGWHXAXCVAZXTYABWLCWTDEIF
      GWOHPZQXDWFWHXCYDYFXTYBBWLCXBDEIFGWOHPQAWLCXHXJDEIFGWOHUQURVDXDWFWGWHXEWL
      JZXMXGTYFYEXTXDWFXAXCYHYFYAYBWLWTXBDEFGWOVEQWLACXEDEBFIGWOHRVBXDXNXIXOXKX
      DWDWEWGWHXAXNXITZXRXSYEXTYAWLACWTDEBFIGWOHRZSXDWDWEWGWHXCXOXKTXRXSYEXTYBW
      LACXBDEBFIGWOHRSVCVFWIXAUCZEVGKZEWMXNWJKZXHWJKZWTWJKZYLMZWNYKWDEVOJWDWEWG
      WHXAVHZEVIVPYKWFXNWLJYMYLJWFWGWHXAVJZYKXNXIWLYKWFWGWHXAYIYRWFWGWHXAVKZWFW
      GWHXAVLZWIXAVMZYJVBYKWFWGYCXIWLJYRYSYKWFWHXAYCYRYTUUAYGQZAWLCXHDEIFGWOHPQ
      VNYLWJWLXNDEFYPGWOWPVQOYKWFYCYNYLJYRUUBYLWJWLXHDEFYPGWOWPVQOYKWFXAYOYLJYR
      UUAYLWJWLWTDEFYPGWOWPVQOYKYMXIWJKZYNWMYKXNXIWJYKWDWEWGWHXAYIYQWDWEWGWHXAV
      RYSYTUUAYJSUSYKWFWGYCUUCYNWMVSYRYSUUBWJAWLCXHDEWMIFWNGWOWPHVTQWAYKWFWHXAY
      NYOWMVSYRYTUUAWJBWLCWTDEWMIFWNGWOWPHVTQWBWC $.
  $}

  ${
    tendoid.b $e |- B = ( Base ` K ) $.
    tendoid.h $e |- H = ( LHyp ` K ) $.
    tendoid.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( The identity value of a trace-preserving endomorphism.  (Contributed by
       NM, 21-Jun-2013.) $)
    tendoid $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E )
     -> ( S ` ( _I |` B ) ) = ( _I |` B ) ) $=
      ( chlt wcel wa cfv wceq wbr eqid adantr mpd3an3 wb syldan cres ctrl cltrn
      cid cp0 cple idltrn tendotp trlid0 breqtrd cops hlop ad2antrr trlcl ople0
      tendocl syl2anc mpbid trlid0b mpbird ) EJKZFDKZLZBCKZLZUDAUAZBMZVFNZVGFEU
      BMMZMZEUEMZNZVEVJVKEUFMZOZVLVEVJVFVIMZVKVMVCVDVFFEUCMMZKZVJVOVMOVCVQVDAVP
      DEFGHVPPZUGQZVIBVPCVFDEVMJFVMPZHVRVIPZIUHRVCVOVKNVDAVIDEFVKGVKPZHWAUIQUJV
      EEUKKZVJAKZVNVLSVAWCVBVDEULUMVCVDVGVPKZWDVCVDVQWEVSBVPCVFDEJFHVRIUPRZAVIV
      PVGDEFGHVRWAUNTAEVMVJVKGVTWBUOUQURVCVDWEVHVLSWFAVIVPVGDEFVKGWBHVRWAUSTUT
      $.
  $}

  ${
    $d f E $.  $d f H $.  $d f K $.  $d f T $.  $d f W $.  $d f U $.  $d f V $.
    tendoeq2.b $e |- B = ( Base ` K ) $.
    tendoeq2.h $e |- H = ( LHyp ` K ) $.
    tendoeq2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendoeq2.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Condition determining equality of two trace-preserving endomorphisms,
       showing it is unnecessary to consider the identity translation.  In
       ~ tendocan , we show that we only need to consider a single non-identity
       translation.  (Contributed by NM, 21-Jun-2013.) $)
    tendoeq2 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( U e. E /\ V e. E )
          /\ A. f e. T ( f =/= ( _I |` B ) -> ( U ` f ) = ( V ` f ) ) )
     -> U = V ) $=
      ( wcel wa cfv wceq wi wral tendoid chlt cv cid wne adantrr adantrl eqtr4d
      cres fveq2 eqeq12d syl5ibrcom ralrimivw r19.26 wo wb exmidne pm5.5 bitr3i
      jaob ax-mp ralbii tendoeq1 3expia syl5bi mpand 3impia ) GUANIFNOZCENZHENZ
      OZDUBZUCAUHZUDZVKCPZVKHPZQZRZDBSZCHQZVGVJOZVKVLQZVPRZDBSZVRVSVTWBDBVTVPWA
      VLCPZVLHPZQVTWDVLWEVGVHWDVLQVIACEFGIJKMTUEVGVIWEVLQVHAHEFGIJKMTUFUGWAVNWD
      VOWEVKVLCUIVKVLHUIUJUKULWCVROZVPDBSZVTVSWFWBVQOZDBSWGWBVQDBUMWHVPDBWHWAVM
      UNZVPRZVPWAVPVMUSWIWJVPUOVKVLUPWIVPUQUTURVAURVGVJWGVSBCDEFGHIKLMVBVCVDVEV
      F $.
  $}

  ${
    $d s t u v E $.  $d f g s t u v T $.  $d f g s t u v W $.
    tendoplcbv.p $e |- P = ( s e. E ,
               t e. E |->
           ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    $( Define sum operation for trace-perserving endomorphisms.  Change bound
       variables to isolate them later.  (Contributed by NM, 11-Jun-2013.) $)
    tendoplcbv $p |- P = ( u e. E ,
               v e. E |->
           ( g e. T |-> ( ( u ` g ) o. ( v ` g ) ) ) ) $=
      ( cv cfv ccom cmpt cmpt2 weq fveq1 coeq1d mpteq2dv fveq2 coeq12d cbvmpt2v
      coeq2d cbvmptv syl6eq eqtri ) DICHHFEFKZIKZLZUGCKZLZMZNZOBAHHGEGKZBKZLZUN
      AKZLZMZNZOJICBAHHUMUTFEUGUOLZUKMZNZIBPZFEULVBVDUIVAUKUGUHUOQRSCAPZVCFEVAU
      GUQLZMZNUTVEFEVBVGVEUKVFVAUGUJUQQUCSFGEVGUSFGPVAUPVFURUGUNUOTUGUNUQTUAUDU
      EUBUF $.

    $d g u v U $.  $d g u v V $.
    tendopl2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Value of endomorphism sum operation.  (Contributed by NM,
       10-Jun-2013.) $)
    tendopl $p |- ( ( U e. E /\ V e. E ) -> ( U P V )
          = ( g e. T |-> ( ( U ` g ) o. ( V ` g ) ) ) ) $=
      ( vu vv cv cfv ccom cmpt wceq fveq1 coeq1d mpteq2dv coeq2d tendoplcbv cvv
      cltrn fvex eqeltri mptex ovmpt2 ) NODIGGFCFPZNPZQZULOPZQZRZSFCULDQZULIQZR
      ZSBFCURUPRZSUMDTZFCUQVAVBUNURUPULUMDUAUBUCUOITZFCVAUTVCUPUSURULUOIUAUDUCO
      NABCEFGKLUEFCUTCJHUGQZQUFMJVDUHUIUJUK $.

    $d g E $.  $d g F $.
    $( Value of result of endomorphism sum operation.  (Contributed by NM,
       10-Jun-2013.) $)
    tendopl2 $p |- ( ( U e. E /\ V e. E /\ F e. T )
     -> ( ( U P V ) ` F )
          = ( ( U ` F ) o. ( V ` F ) ) ) $=
      ( vg wcel cfv ccom cvv wceq fveq2 w3a cmpt tendopl 3adant3 coeq12d adantl
      cv co simp3 fvex coex a1i fvmptd ) DFOZIFOZGCOZUAZNGNUGZDPZURIPZQZGDPZGIP
      ZQZCDIBUHZRUNUOVENCVAUBSUPABCDENFHIJKLMUCUDURGSZVAVDSUQVFUSVBUTVCURGDTURG
      ITUEUFUNUOUPUIVDROUQVBVCGDUJGIUJUKULUM $.
  $}

  ${
    tendopl.h $e |- H = ( LHyp ` K ) $.
    tendopl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendopl.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendopl.p $e |- P = ( s e. E , t e. E
  |-> ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    $d s t E $.  $d f s t T $.  $d f s t W $.
    $( Value of result of endomorphism sum operation.  (Contributed by NM,
       10-Jun-2013.) $)
    tendoplcl2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( U e. E /\ V e. E )
       /\ F e. T )
     -> ( ( U P V ) ` F ) e. T ) $=
      ( chlt wcel wa cfv w3a co ccom wceq tendopl2 3expa 3adant1 simp1 3adant2r
      tendocl 3adant2l ltrnco syl3anc eqeltrd ) IQRKHRSZDFRZJFRZSZGCRZUAZGDJBUB
      TZGDTZGJTZUCZCURUSVAVDUDZUOUPUQUSVEABCDEFGIJKLPNUEUFUGUTUOVBCRZVCCRZVDCRU
      OURUSUHUOUPUSVFUQDCFGHIQKMNOUJUIUOUQUSVGUPJCFGHIQKMNOUJUKCVBVCHIKMNULUMUN
      $.

    $d f G $.
    $( Value of result of endomorphism sum operation on a translation
       composition.  (Contributed by NM, 10-Jun-2013.) $)
    tendoplco2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( U e. E /\ V e. E )
       /\ ( F e. T /\ G e. T ) )
     -> ( ( U P V ) ` ( F o. G ) )
          = ( ( ( U P V ) ` F ) o. ( ( U P V ) ` G ) ) ) $=
      ( wcel ccom cfv chlt wa w3a co tendoco2 wceq simp3l simp3r ltrnco syl3anc
      simp1 simp2l simp2r simp3 tendopl2 syld3an3 coeq12d 3eqtr4d ) JUARLIRUBZD
      FRZKFRZUBZGCRZHCRZUBZUCZGHSZDTVGKTSZGDTGKTSZHDTHKTSZSVGDKBUDZTZGVKTZHVKTZ
      SCDFGHIJKLNOPUEUSVBVEVGCRZVLVHUFZVFUSVCVDVOUSVBVEUKUSVBVCVDUGZUSVBVCVDUHZ
      CGHIJLNOUIUJUSVBVOUCUTVAVOVPUSUTVAVOULUSUTVAVOUMUSVBVOUNABCDEFVGJKLMQOUOU
      JUPVFVMVIVNVJVFUTVAVCVMVIUFUSUTVAVEULZUSUTVAVEUMZVQABCDEFGJKLMQOUOUJVFUTV
      AVDVNVJUFVSVTVRABCDEFHJKLMQOUOUJUQUR $.

    ${
      tendopltp.l $e |- .<_ = ( le ` K ) $.
      tendopltp.r $e |- R = ( ( trL ` K ) ` W ) $.
      $( Trace-preserving property of endomorphism sum operation ` P ` , based
         on theorem ~ trlco .  Part of remark in [Crawley] p. 118, 2nd line,
         "it is clear from the second part of G (our ~ trlco ) that Delta is a
         subring of E." (In our development, we will bypass their E and go
         directly to their Delta, whose base set is our
         ` ( TEndo `` K ) `` W ` .)  (Contributed by NM, 9-Jun-2013.) $)
      tendopltp $p |- ( ( ( K e. HL /\ W e. H )
               /\ ( U e. E /\ V e. E )
               /\ F e. T )
       -> ( R ` ( ( U P V ) ` F ) ) .<_ ( R ` F ) ) $=
        ( chlt wcel wa w3a cbs cfv co cjn eqid clat simp1l hllat syl tendoplcl2
        simp1 trlcl syl2anc tendocl 3adant2r 3adant2l latjcl syl3anc simp3 ccom
        wceq simp2l simp2r tendopl2 wbr trlco eqbrtrd tendotp latjle12 syl13anc
        fveq2d wb mpbi2and lattrd ) JUAUBZMIUBZUCZEGUBZLGUBZUCZHDUBZUDZJUEUFZJK
        HELBUGUFZCUFZHEUFZCUFZHLUFZCUFZJUHUFZUGZHCUFZWGUIZSWFVSJUJUBZVSVTWDWEUK
        JULUMZWFWAWHDUBWIWGUBWAWDWEUOZABDEFGHIJLMNOPQRUNWGCDWHIJMWQOPTUPUQWFWRW
        KWGUBZWMWGUBZWOWGUBWSWFWAWJDUBZXAWTWAWBWEXCWCEDGHIJUAMOPQURUSZWGCDWJIJM
        WQOPTUPUQZWFWAWLDUBZXBWTWAWCWEXFWBLDGHIJUAMOPQURUTZWGCDWLIJMWQOPTUPUQZW
        GWNJWKWMWQWNUIZVAVBWFWAWEWPWGUBZWTWAWDWEVCZWGCDHIJMWQOPTUPUQZWFWIWJWLVD
        ZCUFZWOKWFWHXMCWFWBWCWEWHXMVEWAWBWCWEVFWAWBWCWEVGXKABDEFGHJLMNRPVHVBVOW
        FWAXCXFXNWOKVIWTXDXGCDWJWLIWNJKMSXIOPTVJVBVKWFWKWPKVIZWMWPKVIZWOWPKVIZW
        AWBWEXOWCCEDGHIJKUAMSOPTQVLUSWAWCWEXPWBCLDGHIJKUAMSOPTQVLUTWFWRXAXBXJXO
        XPUCXQVPWSXEXHXLWGWNJKWKWMWPWQSXIVMVNVQVR $.
    $}

    $d g h i s t E $.  $d g h i H $.  $d g h i K $.  $d h i P $.  $d g h i T $.
    $d g h i U $.  $d g h i V $.  $d f g h i W $.
    $( Endomorphism sum is a trace-preserving endomorphism.  (Contributed by
       NM, 10-Jun-2013.) $)
    tendoplcl $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E /\ V e. E )
     -> ( U P V ) e. E ) $=
      ( vg chlt wcel wa cfv vh vi w3a ctrl co cple eqid simp1 wf cv ccom simpl1
      cmpt simpl2 simpr tendocl syl3anc simpl3 fmptd wceq tendopl 3adant1 feq1d
      ltrnco mpbird simp11 simp12 simp13 3simpc tendoplco2 syl121anc tendopltp
      wbr istendod ) HQRJGRSZDFRZIFRZUCZJHUDTTZDIBUEZCUAUBFGHHUFTZQJWAUGZLMVSUG
      ZNVOVPVQUHVRCCVTUICCPCPUJZDTZWDITZUKZUMZUIVRPCWGCWHVRWDCRZSZVOWECRZWFCRZW
      GCRVOVPVQWIULZWJVOVPWIWKWMVOVPVQWIUNVRWIUOZDCFWDGHQJLMNUPUQWJVOVQWIWLWMVO
      VPVQWIURWNICFWDGHQJLMNUPUQCWEWFGHJLMVDUQWHUGUSVRCCVTWHVPVQVTWHUTVOABCDEPF
      HIJKOMVAVBVCVEVRUAUJZCRZUBUJZCRZUCVOVPVQWPWRSWOWQUKVTTWOVTTZWQVTTUKUTVOVP
      VQWPWRVFVOVPVQWPWRVGVOVPVQWPWRVHVRWPWRVIABCDEFWOWQGHIJKLMNOVJVKVRWPSVOVPV
      QWPWSVSTWOVSTWAVMVOVPVQWPULVOVPVQWPUNVOVPVQWPURVRWPUOABVSCDEFWOGHWAIJKLMN
      OWBWCVLVKVN $.

    $d g P $.
    $( The endomorphism sum operation is commutative.  (Contributed by NM,
       11-Jun-2013.) $)
    tendoplcom $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E /\ V e. E )
     -> ( U P V ) = ( V P U ) ) $=
      ( vg wcel cfv wceq syl3anc chlt wa co cv wral simp1 tendoplcl 3com23 ccom
      w3a simpl1 simpl2 simpr tendocl simpl3 ltrncom tendopl2 3eqtr4d ralrimiva
      tendoeq1 syl121anc ) HUAQJGQUBZDFQZIFQZUJZVBDIBUCZFQIDBUCZFQZPUDZVFRZVIVG
      RZSZPCUEVFVGSVBVCVDUFABCDEFGHIJKLMNOUGVBVDVCVHABCIEFGHDJKLMNOUGUHVEVLPCVE
      VICQZUBZVIDRZVIIRZUIZVPVOUIZVJVKVNVBVOCQZVPCQZVQVRSVBVCVDVMUKZVNVBVCVMVSW
      AVBVCVDVMULZVEVMUMZDCFVIGHUAJLMNUNTVNVBVDVMVTWAVBVCVDVMUOZWCICFVIGHUAJLMN
      UNTCVOVPGHJLMUPTVNVCVDVMVJVQSWBWDWCABCDEFVIHIJKOMUQTVNVDVCVMVKVRSWDWBWCAB
      CIEFVIHDJKOMUQTURUSCVFPFGHVGJLMNUTVA $.

    $d g S $.
    $( The endomorphism sum operation is associative.  (Contributed by NM,
       11-Jun-2013.) $)
    tendoplass $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( S e. E /\ U e. E /\ V e. E ) )
     -> ( ( S P U ) P V ) = ( S P ( U P V ) ) ) $=
      ( wcel cfv wceq syl3anc vg chlt wa w3a co cv wral simpr1 simpr2 tendoplcl
      simpl simpr3 coass simplr1 simplr2 tendopl2 coeq1d simplr3 coeq2d 3eqtr4a
      ccom simpr adantr 3eqtr4d ralrimiva tendoeq1 syl121anc ) IUBQKHQUCZCGQZEG
      QZJGQZUDZUCZVHCEBUEZJBUEZGQZCEJBUEZBUEZGQZUAUFZVORZVTVRRZSZUADUGVOVRSVHVL
      UKZVMVHVNGQZVKVPWDVMVHVIVJWEWDVHVIVJVKUHZVHVIVJVKUIZABDCFGHIEKLMNOPUJTZVH
      VIVJVKULZABDVNFGHIJKLMNOPUJTVMVHVIVQGQZVSWDWFVMVHVJVKWJWDWGWIABDEFGHIJKLM
      NOPUJTZABDCFGHIVQKLMNOPUJTVMWCUADVMVTDQZUCZVTVNRZVTJRZVAZVTCRZVTVQRZVAZWA
      WBWMWQVTERZVAZWOVAWQWTWOVAZVAWPWSWQWTWOUMWMWNXAWOWMVIVJWLWNXASVIVJVKVHWLU
      NZVIVJVKVHWLUOZVMWLVBZABDCFGVTIEKLPNUPTUQWMWRXBWQWMVJVKWLWRXBSXDVIVJVKVHW
      LURZXEABDEFGVTIJKLPNUPTUSUTWMWEVKWLWAWPSVMWEWLWHVCXFXEABDVNFGVTIJKLPNUPTW
      MVIWJWLWBWSSXCVMWJWLWKVCXEABDCFGVTIVQKLPNUPTVDVEDVOUAGHIVRKMNOVFVG $.

    $( Endomorphism composition distributes over sum.  (Contributed by NM,
       13-Jun-2013.) $)
    tendodi1 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( S e. E /\ U e. E /\ V e. E ) )
     -> ( S o. ( U P V ) ) = ( ( S o. U ) P ( S o. V ) ) ) $=
      ( wcel cfv wceq syl3anc vg chlt wa w3a co ccom simpl simpr1 simpr2 simpr3
      cv wral tendoplcl tendococl simplll simpllr simplr1 simplr2 simpr tendocl
      simpll simplr3 tendovalco syl32anc tendopl2 tendocoval syl221anc 3eqtr4rd
      fveq2d coeq12d syl121anc ralrimiva tendoeq1 ) IUBQZKHQZUCZCGQZEGQZJGQZUDZ
      UCZVPCEJBUEZUFZGQZCEUFZCJUFZBUEZGQZUAUKZWCRZWIWGRZSZUADULWCWGSVPVTUGZWAVP
      VQWBGQZWDWMVPVQVRVSUHZWAVPVRVSWNWMVPVQVRVSUIZVPVQVRVSUJZABDEFGHIJKLMNOPUM
      ZTCWBGHIKMOUNTWAVPWEGQZWFGQZWHWMWAVPVQVRWSWMWOWPCEGHIKMOUNZTWAVPVQVSWTWMW
      OWQCJGHIKMOUNZTABDWEFGHIWFKLMNOPUMTWAWLUADWAWIDQZUCZWIWERZWIWFRZUFZWIWBRZ
      CRZWKWJXDWIERZWIJRZUFZCRZXJCRZXKCRZUFZXIXGXDVNVOVQXJDQZXKDQZXMXPSVNVOVTXC
      UOZVNVOVTXCUPZVQVRVSVPXCUQZXDVPVRXCXQVPVTXCVAZVQVRVSVPXCURZWAXCUSZEDGWIHI
      UBKMNOUTTXDVPVSXCXRYBVQVRVSVPXCVBZYDJDGWIHIUBKMNOUTTCDGXJXKHIUBKMNOVCVDXD
      XHXLCXDVRVSXCXHXLSYCYEYDABDEFGWIIJKLPNVETVIXDXEXNXFXOXDVNVOVQVRXCXEXNSXSX
      TYAYCYDDCGWIHIEKUBMNOVFVGXDVNVOVQVSXCXFXOSXSXTYAYEYDDCGWIHIJKUBMNOVFVGVJV
      HXDWSWTXCWKXGSXDVPVQVRWSYBYAYCXATXDVPVQVSWTYBYAYEXBTYDABDWEFGWIIWFKLPNVET
      XDVPVQWNXCWJXISYBYAXDVPVRVSWNYBYCYEWRTYDDCGWIHIWBKUBMNOVFVKVHVLDWCUAGHIWG
      KMNOVMVK $.

    $( Endomorphism composition distributes over sum.  (Contributed by NM,
       13-Jun-2013.) $)
    tendodi2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( S e. E /\ U e. E /\ V e. E ) )
     -> ( ( S P U ) o. V ) = ( ( S o. V ) P ( U o. V ) ) ) $=
      ( wcel cfv wceq syl3anc vg chlt wa co ccom cv wral simpl simpr1 tendoplcl
      simpr2 simpr3 tendococl simpll simplr1 simplr2 simpr tendocoval syl121anc
      simplr3 simplll simpllr syl221anc coeq12d tendopl2 tendocl 3eqtr4rd eqtrd
      w3a ralrimiva tendoeq1 ) IUBQZKHQZUCZCGQZEGQZJGQZVIZUCZVNCEBUDZJUEZGQZCJU
      EZEJUEZBUDZGQZUAUFZWARZWGWERZSZUADUGWAWESVNVRUHZVSVNVTGQZVQWBWKVSVNVOVPWL
      WKVNVOVPVQUIZVNVOVPVQUKZABDCFGHIEKLMNOPUJZTVNVOVPVQULZVTJGHIKMOUMTVSVNWCG
      QZWDGQZWFWKVSVNVOVQWQWKWMWPCJGHIKMOUMZTVSVNVPVQWRWKWNWPEJGHIKMOUMZTABDWCF
      GHIWDKLMNOPUJTVSWJUADVSWGDQZUCZWHWGJRZVTRZWIXBVNWLVQXAWHXDSVNVRXAUNZXBVNV
      OVPWLXEVOVPVQVNXAUOZVOVPVQVNXAUPZWOTVOVPVQVNXAUTZVSXAUQZDVTGWGHIJKUBMNOUR
      USXBWGWCRZWGWDRZUEZXCCRZXCERZUEZWIXDXBXJXMXKXNXBVLVMVOVQXAXJXMSVLVMVRXAVA
      ZVLVMVRXAVBZXFXHXIDCGWGHIJKUBMNOURVCXBVLVMVPVQXAXKXNSXPXQXGXHXIDEGWGHIJKU
      BMNOURVCVDXBWQWRXAWIXLSXBVNVOVQWQXEXFXHWSTXBVNVPVQWRXEXGXHWTTXIABDWCFGWGI
      WDKLPNVETXBVOVPXCDQZXDXOSXFXGXBVNVQXAXRXEXHXIJDGWGHIUBKMNOVFTABDCFGXCIEKL
      PNVETVGVHVJDWAUAGHIWEKMNOVKUS $.
  $}

  ${
    $d f B $.  $d g B $.  $d f T $.  $d g T $.  $d f W $.  $d g W $.
    tendo0cbv.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $( Define additive identity for trace-perserving endomorphisms.  Change
       bound variable to isolate it later.  (Contributed by NM,
       11-Jun-2013.) $)
    tendo0cbv $p |- O = ( g e. T |-> ( _I |` B ) ) $=
      ( cid cres cmpt weq eqidd cbvmptv eqtri ) ECBGAHZIDBNIFCDBNNCDJNKLM $.

    $d g F $.
    tendo02.b $e |- B = ( Base ` K ) $.
    $( Value of additive identity endomorphism.  (Contributed by NM,
       11-Jun-2013.) $)
    tendo02 $p |- ( F e. T -> ( O ` F ) = ( _I |` B ) ) $=
      ( vg cid cres cv wceq eqidd tendo0cbv wfun cvv wcel funi cbs fvex eqeltri
      cfv resfunexg mp2an fvmpt ) IDJAKZUGBFILDMUGNABCIFGOJPAQRUGQRSAETUCQHETUA
      UBJAQUDUEUF $.
  $}

  ${
    tendo0.b $e |- B = ( Base ` K ) $.
    tendo0.h $e |- H = ( LHyp ` K ) $.
    tendo0.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendo0.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendo0.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $d f B $.  $d f T $.
    $( The additive identity trace-perserving endormorphism preserves
       composition of translations.  TODO: why isn't this a special case of
       ~ tendospdi1 ?  (Contributed by NM, 11-Jun-2013.) $)
    tendo0co2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
   -> ( O ` ( F o. G ) ) = ( ( O ` F ) o. ( O ` G ) ) ) $=
      ( wcel ccom cfv wceq tendo02 chlt wa w3a cid ltrnco syl 3ad2ant2 3ad2ant3
      cres coeq12d wf1o wf f1oi f1of fcoi1 mp2b syl6req eqtrd ) HUAPJGPUBZEBPZF
      BPZUCZEFQZIRZUDAUIZEIRZFIRZQZVBVCBPVDVESBEFGHJLMUEABCVCHIOKTUFVBVHVEVEQZV
      EVBVFVEVGVEUTUSVFVESVAABCEHIOKTUGVAUSVGVESUTABCFHIOKTUHUJAAVEUKAAVEULVIVE
      SAUMAAVEUNAAVEUOUPUQUR $.

    ${
      tendo0tp.l $e |- .<_ = ( le ` K ) $.
      tendo0tp.r $e |- R = ( ( trL ` K ) ` W ) $.
      $( Trace-preserving property of endomorphism additive identity.
         (Contributed by NM, 11-Jun-2013.) $)
      tendo0tp $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
       -> ( R ` ( O ` F ) ) .<_ ( R ` F ) ) $=
        ( wcel cfv chlt wa cp0 cid cres wceq tendo02 adantl fveq2d trlid0 eqtrd
        eqid adantr cops wbr hlop ad2antrr trlcl op0le syl2anc eqbrtrd ) HUASZK
        GSZUBZFCSZUBZFJTZBTZHUCTZFBTZIVFVHUDAUEZBTZVIVFVGVKBVEVGVKUFVDACDFHJPLU
        GUHUIVDVLVIUFVEABGHKVILVIULZMRUJUMUKVFHUNSZVJASVIVJIUOVBVNVCVEHUPUQABCF
        GHKLMNRURAHIVJVILQVMUSUTVA $.
    $}

    $d g B $.  $d g h H $.  $d g h K $.  $d g h O $.  $d g h T $.  $d g h W $.
    $( The additive identity is a trace-perserving endormorphism.  (Contributed
       by NM, 12-Jun-2013.) $)
    tendo0cl $p |- ( ( K e. HL /\ W e. H ) -> O e. E ) $=
      ( vg vh chlt wcel cfv eqid cv wa ctrl cple id cid idltrn adantr tendo0cbv
      cres fmptd tendo0co2 tendo0tp istendod ) FPQHEQUAZHFUBRRZGBNODEFFUCRZPHUP
      SZJKUOSZLUNUDUNNBUEAUIZBGUNUSBQNTZBQABEFHIJKUFUGABCNGMUHUJABCDUTOTEFGHIJK
      LMUKAUOBCDUTEFUPGHIJKLMUQURULUM $.

    tendo0pl.p $e |- P = ( s e. E ,
               t e. E |->
           ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    $d g s t E $.  $d g P $.  $d g S $.  $d s t T $.  $d f s t W $.
    $d f s t $.
    $( Property of the additive identity endormorphism.  (Contributed by NM,
       12-Jun-2013.) $)
    tendo0pl $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E )
      -> ( O P S ) = S ) $=
      ( wcel wceq vg chlt wa co cv cfv wral simpl tendo0cl adantr simpr syl3anc
      tendoplcl ccom cid cres simpll simplr tendopl2 tendo02 adantl coeq1d wf1o
      wf tendocl 3expa ltrn1o syl2anc f1of fcoi2 3syl 3eqtrd ralrimiva tendoeq1
      syl syl121anc ) IUBSKHSUCZDGSZUCZVQJDCUDZGSZVRUAUEZVTUFZWBDUFZTZUAEUGVTDT
      VQVRUHZVSVQJGSZVRWAWFVQWGVRBEFGHIJKMNOPQUIZUJVQVRUKZACEJFGHIDKLNOPRUMULWI
      VSWEUAEVSWBESZUCZWCWBJUFZWDUNZUOBUPZWDUNZWDWKWGVRWJWCWMTWKVQWGVQVRWJUQZWH
      VOVQVRWJURVSWJUKACEJFGWBIDKLROUSULWKWLWNWDWJWLWNTVSBEFWBIJQMUTVAVBWKBBWDV
      CZBBWDVDWOWDTWKVQWDESZWQWPVQVRWJWRDEGWBHIUBKNOPVEVFBEWDHIUBKMNOVGVHBBWDVI
      BBWDVJVKVLVMEVTUAGHIDKNOPVNVP $.

    $( Property of the additive identity endormorphism.  (Contributed by NM,
       21-Feb-2014.) $)
    tendo0plr $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E )
      -> ( S P O ) = S ) $=
      ( wcel wa chlt co wceq tendo0cl adantr tendoplcom mpd3an3 tendo0pl eqtrd
      ) IUASKHSTZDGSZTDJCUBZJDCUBZDUJUKJGSZULUMUCUJUNUKBEFGHIJKMNOPQUDUEACEDFGH
      IJKLNOPRUFUGABCDEFGHIJKLMNOPQRUHUI $.
  $}

  ${
    tendoi.i $e |- I = ( s e. E |->
           ( f e. T |-> `' ( s ` f ) ) ) $.
    $d s u E $.  $d f g s u T $.  $d f g s u W $.
    $( Define inverse function for trace-perserving endomorphisms.  Change
       bound variable to isolate it later.  (Contributed by NM,
       12-Jun-2013.) $)
    tendoicbv $p |- I = ( u e. E |->
           ( g e. T |-> `' ( u ` g ) ) ) $=
      ( cv cfv ccnv cmpt weq fveq1 cnveqd mpteq2dv fveq2 cbvmptv syl6eq eqtri )
      FGECBCIZGIZJZKZLZLAEDBDIZAIZJZKZLZLHGAEUEUJGAMZUECBUAUGJZKZLUJUKCBUDUMUKU
      CULUAUBUGNOPCDBUMUICDMULUHUAUFUGQORSRT $.

    $d u g S $.
    tendoi.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    $( Value of inverse endomorphism.  (Contributed by NM, 12-Jun-2013.) $)
    tendoi $p |- ( S e. E
            -> ( I ` S ) = ( g e. T |-> `' ( S ` g ) ) ) $=
      ( vu cv cfv ccnv cmpt wceq fveq1 cnveqd mpteq2dv tendoicbv cltrn cvv fvex
      eqeltri mptex fvmpt ) LADBDMZLMZNZOZPDBUHANZOZPEFUIAQZDBUKUMUNUJULUHUIARS
      TLBCDEFIJUADBUMBHGUBNZNUCKHUOUDUEUFUG $.

    $d g E $.  $d g F $.
    $( Value of additive inverse endomorphism.  (Contributed by NM,
       12-Jun-2013.) $)
    tendoi2 $p |- ( ( S e. E /\ F e. T )
            -> ( ( I ` S ) ` F ) = `' ( S ` F ) ) $=
      ( vg wcel wa cv cfv ccnv cvv cmpt wceq tendoi adantr fveq2 simpr fvex a1i
      cnveqd adantl cnvex fvmptd ) ADMZEBMZNZLELOZAPZQZEAPZQZBAFPZRUKUSLBUPSTUL
      ABCLDFGHIJKUAUBUNETZUPURTUMUTUOUQUNEAUCUGUHUKULUDURRMUMUQEAUEUIUFUJ $.
  $}

  ${
    tendoicl.h $e |- H = ( LHyp ` K ) $.
    tendoicl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendoicl.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendoicl.i $e |- I = ( s e. E |->
           ( f e. T |-> `' ( s ` f ) ) ) $.
    $d g h s E $.  $d g h H $.  $d g h I $.  $d g h K $.  $d g h S $.
    $d f g h s T $.  $d f g h s W $.
    $( Closure of the additive inverse endomorphism.  (Contributed by NM,
       12-Jun-2013.) $)
    tendoicl $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E )
            -> ( I ` S ) e. E ) $=
      ( vg chlt wcel cfv syl2anc wceq ccom vh wa ctrl cple eqid simpl ccnv cmpt
      wf cv simpll tendocl 3expa fmptd tendoi adantl feq1d mpbird simp1r ltrnco
      ltrncnv 3adant1r tendoi2 cnvco ltrncom fveq2d simp1ll simp1lr simp3 simp2
      w3a tendovalco syl32anc cnveqd coeq12d 3eqtr4a adantll trlcnv wbr tendotp
      eqtrd eqbrtrd istendod ) GOPZHEPZUBZADPZUBZHGUCQQZAFQZBNUADEGGUDQZOHWKUEZ
      JKWIUEZLWFWGUFWHBBWJUIBBNBNUJZAQZUGZUHZUIWHNBWPBWQWHWNBPZUBZWFWOBPZWPBPWF
      WGWRUKZWFWGWRWTABDWNEGOHJKLULUMZBWOEGHJKVARWQUEUNWHBBWJWQWGWJWQSWFABCNDFG
      HIMKUOUPUQURWHWRUAUJZBPZVKZWNXCTZWJQZXFAQZUGZWNWJQZXCWJQZTZXEWGXFBPZXGXIS
      WFWGWRXDUSZWFWRXDXMWGBWNXCEGHJKUTVBABCDXFFGHIMKVCRXEXCAQZWOTZUGWPXOUGZTXI
      XLXOWOVDXEXHXPXEXHXCWNTZAQZXPXEXFXRAWFWRXDXFXRSWGBWNXCEGHJKVEVBVFXEWDWEWG
      XDWRXSXPSWDWEWGWRXDVGWDWEWGWRXDVHXNWHWRXDVIZWHWRXDVJZABDXCWNEGOHJKLVLVMWA
      VNXEXJWPXKXQXEWGWRXJWPSZXNYAABCDWNFGHIMKVCZRXEWGXDXKXQSXNXTABCDXCFGHIMKVC
      RVOVPWAWSXJWIQZWOWIQZWNWIQZWKWSYDWPWIQZYEWSXJWPWIWGWRYBWFYCVQVFWSWFWTYGYE
      SXAXBWIBWOEGHJKWMVRRWAWFWGWRYEYFWKVSWIABDWNEGWKOHWLJKWMLVTUMWBWC $.

    tendoi.b $e |- B = ( Base ` K ) $.
    tendoi.p $e |- P = ( s e. E ,
               t e. E |->
           ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    tendoi.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $d f B $.  $d t E $.  $d f H $.  $d f K $.  $d g O $.  $d g P $.
    $d f s t T $.  $d t W $.
    $( Property of the additive inverse endomorphism.  (Contributed by NM,
       12-Jun-2013.) $)
    tendoipl $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E )
      -> ( ( I ` S ) P S ) = O ) $=
      ( vg chlt wcel wa cfv co wceq wral simpl tendoicl simpr tendoplcl syl3anc
      cv tendo0cl adantr ccom cid cres ccnv tendoi2 adantll coeq1d wf1o tendocl
      simpll 3expa ltrn1o syl2anc f1ococnv1 syl simplr tendopl2 tendo02 3eqtr4d
      eqtrd adantl ralrimiva tendoeq1 syl121anc ) JUBUCLHUCUDZDGUCZUDZWADIUEZDC
      UFZGUCZKGUCZUAUNZWEUEZWHKUEZUGZUAEUHWEKUGWAWBUIZWCWAWDGUCZWBWFWLDEFGHIJLM
      NOPQUJZWAWBUKACEWDFGHJDLMNOPSULUMWAWGWBBEFGHJKLRNOPTUOUPWCWKUAEWCWHEUCZUD
      ZWHWDUEZWHDUEZUQZURBUSZWIWJWPWSWRUTZWRUQZWTWPWQXAWRWBWOWQXAUGWADEFGWHIJLM
      QOVAVBVCWPBBWRVDZXBWTUGWPWAWREUCZXCWAWBWOVFWAWBWOXDDEGWHHJUBLNOPVEVGBEWRH
      JUBLRNOVHVIBBWRVJVKVPWPWMWBWOWIWSUGWCWMWOWNUPWAWBWOVLWCWOUKACEWDFGWHJDLMS
      OVMUMWOWJWTUGWCBEFWHJKTRVNVQVOVREWEUAGHJKLNOPVSVT $.

    $( Property of the additive inverse endomorphism.  (Contributed by NM,
       29-Sep-2014.) $)
    tendoipl2 $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E )
      -> ( S P ( I ` S ) ) = O ) $=
      ( chlt wcel wa cfv co wceq tendoicl tendoplcom mpd3an3 tendoipl eqtrd ) J
      UAUBLHUBUCZDGUBZUCDDIUDZCUEZUNDCUEZKULUMUNGUBUOUPUFDEFGHIJLMNOPQUGACEDFGH
      JUNLMNOPSUHUIABCDEFGHIJKLMNOPQRSTUJUK $.
  $}

  ${
    $d k E $.  $d k w H $.  $d f k s t w K $.  $d k T $.
    erngset.h $e |- H = ( LHyp ` K ) $.
    $( The division rings on trace-preserving endomorphisms for a lattice
       ` K ` .  (Contributed by NM, 8-Jun-2013.) $)
    erngfset $p |- ( K e. V -> ( EDRing ` K ) = ( w e. H |-> {
       <. ( Base ` ndx ) , ( ( TEndo ` K ) ` w ) >. ,
       <. ( +g ` ndx ) , ( s e. ( ( TEndo ` K ) ` w ) ,
               t e. ( ( TEndo ` K ) ` w ) |->
           ( f e. ( ( LTrn ` K ) ` w ) |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. ( .r ` ndx ) , ( s e. ( ( TEndo ` K ) ` w ) ,
               t e. ( ( TEndo ` K ) ` w ) |-> ( s o. t ) ) >. } ) ) $=
      ( vk cvv cfv cnx cv ctendo cop cltrn cmpt cmpt2 clh fveq2 wcel cbs cplusg
      cedring ccom cmulr ctp wceq elex syl6eqr fveq1d mpteq1d mpt2eq123dv eqidd
      opeq2d tpeq123d mpteq12dv df-edring fvex eqeltri mptex fvmpt syl ) EFUAEJ
      UAEUDKADLUBKZAMZENKZKZOZLUCKZGBVGVGCVEEPKZKZCMZGMZKVLBMZKUEZQZRZOZLUFKZGB
      VGVGVMVNUEZRZOZUGZQZUHEFUIIEAIMZSKZVDVEWENKZKZOZVIGBWHWHCVEWEPKZKZVOQZRZO
      ZVSGBWHWHVTRZOZUGZQWDJUDWEEUHZAWFWQDWCWRWFESKZDWEESTHUJWRWIVHWNVRWPWBWRWH
      VGVDWRVEWGVFWEENTUKZUOWRWMVQVIWRGBWHWHWLVGVGVPWTWTWRCWKVKVOWRVEWJVJWEEPTU
      KULUMUOWRWOWAVSWRGBWHWHVTVGVGVTWTWTWRVTUNUMUOUPUQABCIGURADWCDWSJHESUSUTVA
      VBVC $.

    erngset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    erngset.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    erngset.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    $d w E $.  $d w T $.  $d f s t w W $.
    $( The division ring on trace-preserving endomorphisms for a fiducial
       co-atom ` W ` .  (Contributed by NM, 5-Jun-2013.) $)
    erngset $p |- ( ( K e. V /\ W e. H ) -> D
       = {
       <. ( Base ` ndx ) , E >. ,
       <. ( +g ` ndx ) , ( s e. E ,
               t e. E |->
           ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. ( .r ` ndx ) , ( s e. E ,
               t e. E |-> ( s o. t ) ) >. } ) $=
      ( vw cfv cv cop ctp wceq wcel cnx cbs ctendo cplusg cltrn ccom cmpt cmpt2
      cmulr cedring erngfset fveq1d syl5eq fveq2 opeq2d tpeq1 ax-mp syl6eqr syl
      opeq2i eqidd mpteq12dv mpt2eq123dv tpeq2d tpeq3d eqid tpex fvmpt sylan9eq
      3eqtrd ) GHUAZIFUABIOFUBUCPZOQZGUDPZPZRZUBUEPZJAVPVPDVNGUFPZPZDQZJQZPWAAQ
      ZPUGZUHZUIZRZUBUJPZJAVPVPWBWCUGZUIZRZSZUHZPZVMERZVRJAEEDCWDUHZUIZRZWHJAEE
      WIUIZRZSZVLBIGUKPZPWNNVLIXBWMOADFGHJKULUMUNOIWLXAFWMVNITZWLWOWGWKSZWOWRWK
      SXAXCVQVMIVOPZRZTZWLXDTXCVPXEVMVNIVOUOZUPXGWLXFWGWKSZXDVQXFWGWKUQWOXFTXDX
      ITEXEVMMVAWOXFWGWKUQURUSUTXCWGWRWOWKXCWFWQVRXCJAVPVPWEEEWPXCVPXEEXHMUSZXJ
      XCDVTWDCWDXCVTIVSPCVNIVSUOLUSXCWDVBVCVDUPVEXCWKWTWOWRXCWJWSWHXCJAVPVPWIEE
      WIXJXJXCWIVBVDUPVFVKWMVGWOWRWTVHVIVJ $.

    ${
      $d s t E $.
      erng.c $e |- C = ( Base ` D ) $.
      $( The base set of the division ring on trace-preserving endomorphisms is
         the set of all trace-preserving endomorphisms (for a fiducial co-atom
         ` W ` ).  TODO: the .t hypothesis isn't used.  (Also look at others.)
         (Contributed by NM, 9-Jun-2013.) $)
      erngbase $p |- ( ( K e. V /\ W e. H ) -> C = E ) $=
        ( vs vt vf wcel cbs cfv cnx wa cop cplusg ccom cmpt cmpt2 cmulr erngset
        cv ctp fveq2d cvv wceq ctendo fvex eqeltri eqid rngbase ax-mp 3eqtr4g )
        FGQHEQUAZBRSTRSDUBTUCSNODDPCPUIZNUIZSVBOUIZSUDUEUFZUBTUGSNODDVCVDUDUFZU
        BUJZRSZADVABVGROBCPDEFGHNIJKLUHUKMDULQDVHUMDHFUNSZSULKHVIUOUPDVEVGVFULV
        GUQURUSUT $.
    $}

    $d s t E $.
    ${
      erng.p $e |- .+ = ( +g ` D ) $.
      $( Ring addition operation.  (Contributed by NM, 9-Jun-2013.) $)
      erngfplus $p |- ( ( K e. V /\ W e. H ) -> .+ = ( s e. E ,
             t e. E
               |-> ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) ) $=
        ( wcel cplusg cfv cnx wa cbs cop cv ccom cmpt2 cmulr ctp erngset fveq2d
        cmpt cvv wceq ctendo fvex eqeltri mpt2ex eqid rngplusg ax-mp 3eqtr4g )
        HIQJGQUAZBRSTUBSFUCTRSKAFFEDEUDZKUDZSVCAUDZSUEUKZUFZUCTUGSKAFFVDVEUEUFZ
        UCUHZRSZCVGVBBVIRABDEFGHIJKLMNOUIUJPVGULQVGVJUMKAFFVFFJHUNSZSULNJVKUOUP
        ZVLUQFVGVIVHULVIURUSUTVA $.

      $d g K $.  $d f g s t T $.  $d f g s t U $.  $d f g s t V $.  $d g W $.
      $( Ring addition operation.  (Contributed by NM, 10-Jun-2013.) $)
      erngplus $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( U e. E /\ V e. E ) )
   -> ( U .+ V ) = ( f e. T |-> ( ( U ` f ) o. ( V ` f ) ) ) ) $=
        ( vs vt vg wcel cv chlt wa ccom cmpt cmpt2 erngfplus oveqd eqid tendopl
        co cfv sylan9eq ) HUASJGSUBZDFSIFSUBDIBUJDIPQFFRCRTZPTUKUNQTUKUCUDUEZUJ
        ECETZDUKUPIUKUCUDUMBUODIQABCRFGHUAJPKLMNOUFUGQUOCDREFHIJPUOUHLUIUL $.

      $d f E $.  $d f F $.  $d f H $.
      $( Ring addition operation.  (Contributed by NM, 10-Jun-2013.) $)
      erngplus2 $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( U e. E /\ V e. E /\ F e. T ) )
   -> ( ( U .+ V ) ` F ) = ( ( U ` F ) o. ( V ` F ) ) ) $=
        ( vf wcel wa cfv wceq chlt w3a cv ccom cvv cmpt erngplus 3adantr3 fveq2
        co coeq12d adantl simpr3 fvex coex a1i fvmptd ) HUAQJGQRZDEQZIEQZFCQZUB
        RZPFPUCZDSZVCISZUDZFDSZFISZUDZCDIBUJZUEURUSUTVJPCVFUFTVAABCDPEGHIJKLMNO
        UGUHVCFTZVFVITVBVKVDVGVEVHVCFDUIVCFIUIUKULURUSUTVAUMVIUEQVBVGVHFDUNFIUN
        UOUPUQ $.
    $}

    ${
      erng.m $e |- .x. = ( .r ` D ) $.
      $( Ring multiplication operation.  (Contributed by NM, 9-Jun-2013.) $)
      erngfmul $p |- ( ( K e. V /\ W e. H ) -> .x. = ( s e. E ,
             t e. E |-> ( s o. t ) ) ) $=
        ( vf wcel cmulr cfv cnx wa cbs cop cplusg cv ccom cmpt cmpt2 ctp fveq2d
        erngset cvv wceq ctendo fvex eqeltri mpt2ex eqid rngmulr ax-mp 3eqtr4g
        ) GHQIFQUAZBRSTUBSEUCTUDSJAEEPCPUEZJUEZSVCAUEZSUFUGUHZUCTRSJAEEVDVEUFZU
        HZUCUIZRSZDVHVBBVIRABCPEFGHIJKLMNUKUJOVHULQVHVJUMJAEEVGEIGUNSZSULMIVKUO
        UPZVLUQEVFVIVHULVIURUSUTVA $.

      $d s t U $.  $d s t V $.
      $( Ring addition operation.  (Contributed by NM, 10-Jun-2013.) $)
      erngmul $p |- ( ( ( K e. X /\ W e. H )
            /\ ( U e. E /\ V e. E ) )
   -> ( U .x. V ) = ( U o. V ) ) $=
        ( vs vt wcel wa ccom co cmpt2 erngfmul oveqd cvv wceq coexg coeq1 coeq2
        cv eqid ovmpt2g mpd3an3 sylan9eq ) GJRIFRSZDERZHERZSDHCUADHPQEEPUJZQUJZ
        TZUBZUAZDHTZUOCVADHQABCEFGJIPKLMNOUCUDUPUQVCUERVBVCUFDHEEUGPQDHEEUTVCVA
        DUSTUEURDUSUHUSHDUIVAUKULUMUN $.
    $}
  $}

  ${
    $d k E $.  $d k w H $.  $d f k s t w K $.  $d k T $.
    erngset.h-r $e |- H = ( LHyp ` K ) $.
    $( The division rings on trace-preserving endomorphisms for a lattice
       ` K ` .  (Contributed by NM, 8-Jun-2013.)
       (New usage is discouraged.) $)
    erngfset-rN $p |- ( K e. V -> ( EDRingR ` K ) = ( w e. H |-> {
       <. ( Base ` ndx ) , ( ( TEndo ` K ) ` w ) >. ,
       <. ( +g ` ndx ) , ( s e. ( ( TEndo ` K ) ` w ) ,
               t e. ( ( TEndo ` K ) ` w ) |->
           ( f e. ( ( LTrn ` K ) ` w ) |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. ( .r ` ndx ) , ( s e. ( ( TEndo ` K ) ` w ) ,
               t e. ( ( TEndo ` K ) ` w ) |-> ( t o. s ) ) >. } ) ) $=
      ( vk cvv cfv cnx cv ctendo cop cltrn cmpt cmpt2 clh fveq2 wcel cedring-rN
      cbs cplusg ccom cmulr wceq elex syl6eqr fveq1d opeq2d mpteq1d mpt2eq123dv
      ctp eqidd tpeq123d mpteq12dv df-edring-rN fvex eqeltri mptex fvmpt syl )
      EFUAEJUAEUBKADLUCKZAMZENKZKZOZLUDKZGBVGVGCVEEPKZKZCMZGMZKVLBMZKUEZQZRZOZL
      UFKZGBVGVGVNVMUEZRZOZUNZQZUGEFUHIEAIMZSKZVDVEWENKZKZOZVIGBWHWHCVEWEPKZKZV
      OQZRZOZVSGBWHWHVTRZOZUNZQWDJUBWEEUGZAWFWQDWCWRWFESKZDWEESTHUIWRWIVHWNVRWP
      WBWRWHVGVDWRVEWGVFWEENTUJZUKWRWMVQVIWRGBWHWHWLVGVGVPWTWTWRCWKVKVOWRVEWJVJ
      WEEPTUJULUMUKWRWOWAVSWRGBWHWHVTVGVGVTWTWTWRVTUOUMUKUPUQABCIGURADWCDWSJHES
      USUTVAVBVC $.

    erngset.t-r $e |- T = ( ( LTrn ` K ) ` W ) $.
    erngset.e-r $e |- E = ( ( TEndo ` K ) ` W ) $.
    erngset.d-r $e |- D = ( ( EDRingR ` K ) ` W ) $.
    $d w E $.  $d w T $.  $d f s t w W $.
    $( The division ring on trace-preserving endomorphisms for a fiducial
       co-atom ` W ` .  (Contributed by NM, 5-Jun-2013.)
       (New usage is discouraged.) $)
    erngset-rN $p |- ( ( K e. V /\ W e. H ) -> D
       = {
       <. ( Base ` ndx ) , E >. ,
       <. ( +g ` ndx ) , ( s e. E ,
               t e. E |->
           ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) >. ,
       <. ( .r ` ndx ) , ( s e. E ,
               t e. E |-> ( t o. s ) ) >. } ) $=
      ( vw cfv cv cop ctp wceq wcel cnx cbs ctendo cplusg cltrn ccom cmpt cmpt2
      cmulr cedring-rN erngfset-rN fveq1d syl5eq fveq2 opeq2d tpeq1 syl6eqr syl
      opeq2i ax-mp eqidd mpteq12dv mpt2eq123dv tpeq2d tpeq3d eqid tpex sylan9eq
      3eqtrd fvmpt ) GHUAZIFUABIOFUBUCPZOQZGUDPZPZRZUBUEPZJAVPVPDVNGUFPZPZDQZJQ
      ZPWAAQZPUGZUHZUIZRZUBUJPZJAVPVPWCWBUGZUIZRZSZUHZPZVMERZVRJAEEDCWDUHZUIZRZ
      WHJAEEWIUIZRZSZVLBIGUKPZPWNNVLIXBWMOADFGHJKULUMUNOIWLXAFWMVNITZWLWOWGWKSZ
      WOWRWKSXAXCVQVMIVOPZRZTZWLXDTXCVPXEVMVNIVOUOZUPXGWLXFWGWKSZXDVQXFWGWKUQWO
      XFTXDXITEXEVMMUTWOXFWGWKUQVAURUSXCWGWRWOWKXCWFWQVRXCJAVPVPWEEEWPXCVPXEEXH
      MURZXJXCDVTWDCWDXCVTIVSPCVNIVSUOLURXCWDVBVCVDUPVEXCWKWTWOWRXCWJWSWHXCJAVP
      VPWIEEWIXJXJXCWIVBVDUPVFVJWMVGWOWRWTVHVKVI $.

    ${
      $d s t E $.
      erng.c-r $e |- C = ( Base ` D ) $.
      $( The base set of the division ring on trace-preserving endomorphisms is
         the set of all trace-preserving endomorphisms (for a fiducial co-atom
         ` W ` ).  (Contributed by NM, 9-Jun-2013.)
         (New usage is discouraged.) $)
      erngbase-rN $p |- ( ( K e. V /\ W e. H ) -> C = E ) $=
        ( vs vt vf wcel cbs cfv cnx wa cop cplusg cv ccom cmpt cmpt2 erngset-rN
        cmulr ctp fveq2d wceq ctendo fvex eqeltri eqid rngbase ax-mp 3eqtr4g
        cvv ) FGQHEQUAZBRSTRSDUBTUCSNODDPCPUDZNUDZSVBOUDZSUEUFUGZUBTUISNODDVDVC
        UEUGZUBUJZRSZADVABVGROBCPDEFGHNIJKLUHUKMDUTQDVHULDHFUMSZSUTKHVIUNUODVEV
        GVFUTVGUPUQURUS $.
    $}

    $d s t E $.
    ${
      erng.p-r $e |- .+ = ( +g ` D ) $.
      $( Ring addition operation.  (Contributed by NM, 9-Jun-2013.)
         (New usage is discouraged.) $)
      erngfplus-rN $p |- ( ( K e. V /\ W e. H ) -> .+ = ( s e. E ,
             t e. E
               |-> ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) ) $=
        ( wcel cplusg cfv cnx wa cbs cv ccom cmpt cmpt2 cmulr erngset-rN fveq2d
        cop ctp cvv wceq ctendo fvex eqeltri mpt2ex eqid rngplusg ax-mp 3eqtr4g
        ) HIQJGQUAZBRSTUBSFUJTRSKAFFEDEUCZKUCZSVCAUCZSUDUEZUFZUJTUGSKAFFVEVDUDU
        FZUJUKZRSZCVGVBBVIRABDEFGHIJKLMNOUHUIPVGULQVGVJUMKAFFVFFJHUNSZSULNJVKUO
        UPZVLUQFVGVIVHULVIURUSUTVA $.

      $d g K $.  $d f g s t T $.  $d f g s t U $.  $d f g s t V $.  $d g W $.
      $( Ring addition operation.  (Contributed by NM, 10-Jun-2013.)
         (New usage is discouraged.) $)
      erngplus-rN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( U e. E /\ V e. E ) )
   -> ( U .+ V ) = ( f e. T |-> ( ( U ` f ) o. ( V ` f ) ) ) ) $=
        ( vs vt vg wcel cv chlt wa co cfv ccom cmpt2 erngfplus-rN oveqd tendopl
        cmpt eqid sylan9eq ) HUASJGSUBZDFSIFSUBDIBUCDIPQFFRCRTZPTUDUNQTUDUEUJUF
        ZUCECETZDUDUPIUDUEUJUMBUODIQABCRFGHUAJPKLMNOUGUHQUOCDREFHIJPUOUKLUIUL
        $.

      $d f E $.  $d f F $.  $d f H $.
      $( Ring addition operation.  (Contributed by NM, 10-Jun-2013.)
         (New usage is discouraged.) $)
      erngplus2-rN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( U e. E /\ V e. E /\ F e. T ) )
   -> ( ( U .+ V ) ` F ) = ( ( U ` F ) o. ( V ` F ) ) ) $=
        ( vf wcel wa cfv wceq chlt w3a cv ccom co cvv cmpt erngplus-rN 3adantr3
        fveq2 coeq12d adantl simpr3 fvex coex a1i fvmptd ) HUAQJGQRZDEQZIEQZFCQ
        ZUBRZPFPUCZDSZVCISZUDZFDSZFISZUDZCDIBUEZUFURUSUTVJPCVFUGTVAABCDPEGHIJKL
        MNOUHUIVCFTZVFVITVBVKVDVGVEVHVCFDUJVCFIUJUKULURUSUTVAUMVIUFQVBVGVHFDUNF
        IUNUOUPUQ $.
    $}

    ${
      erng.m-r $e |- .x. = ( .r ` D ) $.
      $( Ring multiplication operation.  (Contributed by NM, 9-Jun-2013.)
         (New usage is discouraged.) $)
      erngfmul-rN $p |- ( ( K e. V /\ W e. H ) -> .x. = ( s e. E ,
             t e. E |-> ( t o. s ) ) ) $=
        ( vf wcel cmulr cfv cnx wa cbs cop cplusg cv ccom cmpt cmpt2 erngset-rN
        ctp fveq2d wceq ctendo fvex eqeltri mpt2ex eqid rngmulr ax-mp 3eqtr4g
        cvv ) GHQIFQUAZBRSTUBSEUCTUDSJAEEPCPUEZJUEZSVCAUEZSUFUGUHZUCTRSJAEEVEVD
        UFZUHZUCUJZRSZDVHVBBVIRABCPEFGHIJKLMNUIUKOVHVAQVHVJULJAEEVGEIGUMSZSVAMI
        VKUNUOZVLUPEVFVIVHVAVIUQURUSUT $.

      $d s t U $.  $d s t V $.
      $( Ring addition operation.  (Contributed by NM, 10-Jun-2013.)
         (New usage is discouraged.) $)
      erngmul-rN $p |- ( ( ( K e. X /\ W e. H )
            /\ ( U e. E /\ V e. E ) )
   -> ( U .x. V ) = ( V o. U ) ) $=
        ( vs vt wcel wa ccom co cmpt2 erngfmul-rN adantr oveqd cvv coexg ancoms
        cv wceq coeq2 coeq1 eqid ovmpt2g mpd3an3 adantl eqtrd ) GJRIFRSZDERZHER
        ZSZSZDHCUADHPQEEQUIZPUIZTZUBZUAZHDTZVBCVFDHURCVFUJVAQABCEFGJIPKLMNOUCUD
        UEVAVGVHUJZURUSUTVHUFRZVIUTUSVJHDEEUGUHPQDHEEVEVHVFVCDTUFVDDVCUKVCHDULV
        FUMUNUOUPUQ $.
    $}
  $}

  ${
    cdlemh.b $e |- B = ( Base ` K ) $.
    cdlemh.l $e |- .<_ = ( le ` K ) $.
    cdlemh.j $e |- .\/ = ( join ` K ) $.
    cdlemh.m $e |- ./\ = ( meet ` K ) $.
    cdlemh.a $e |- A = ( Atoms ` K ) $.
    cdlemh.h $e |- H = ( LHyp ` K ) $.
    cdlemh.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemh.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemh.s $e |- S = ( ( P .\/ ( R ` G ) )
         ./\ ( Q .\/ ( R ` ( G o. `' F ) ) ) ) $.
    $( Part of proof of Lemma H of [Crawley] p. 118.  (Contributed by NM,
       17-Jun-2013.) $)
    cdlemh1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( P e. A /\ Q e. A )
       /\ ( Q .<_ ( P .\/ ( R ` F ) ) /\ ( R ` F ) =/= ( R ` G ) ) )
  -> ( S .\/ ( R ` ( G o. `' F ) ) )
       = ( Q .\/ ( R ` ( G o. `' F ) ) ) ) $=
      ( chlt wcel wa w3a cfv co wbr ccnv ccom oveq1i wceq simp11l simp11 simp13
      wne simp12 simp3r necomd trlcocnvat syl121anc clat hllat syl simp2l trlcl
      atbase syl2anc latjcl syl3anc hlatjcl hlatlej2 atmod4i1 syl131anc ltrncnv
      simp2r trljco2 trlcnv oveq1d eqtrd oveq2d ltrnco latjass syl13anc 3eqtr4d
      simp3l wi latjlej1 mpd wb latleeqm2 mpbid 3eqtrd syl5eq ) LUEUFZOJUFZUGZH
      GUFZIGUFZUHZCAUFZDAUFZUGZDCHEUIZKUJZMUKZXGIEUIZUSZUGZUHZFIHULZUMZEUIZKUJC
      XJKUJZDXPKUJZNUJZXPKUJZXRFXSXPKUDUNXMXTXQXPKUJZXRNUJZXHXPKUJZXRNUJZXRXMWR
      XPAUFZXQBUFZXRBUFZXPXRMUKZXTYBUOWRWSXAXBXFXLUPZXMWTXBXAXJXGUSYEWTXAXBXFXL
      UQZWTXAXBXFXLURZWTXAXBXFXLUTZXMXGXJXCXFXIXKVAVBAEGIHJLOTUAUBUCVCVDZXMLVEU
      FZCBUFZXJBUFZYFXMWRYNYILVFVGZXMXDYOXCXDXEXLVHABCLPTVJVGZXMWTXBYPYJYKBEGIJ
      LOPUAUBUCVIVKZBKLCXJPRVLVMXMWRXEYEYGYIXCXDXEXLVSZYMABKLDXPPRTVNVMZXMWRXEY
      EYHYIYTYMADXPKLMQRTVOVMABXPKLMNXQXRPQRSTVPVQXMYAYCXRNXMCXJXPKUJZKUJZCXGXP
      KUJZKUJZYAYCXMUUBUUDCKXMUUBXNEUIZXPKUJZUUDXMWTXBXNGUFZUUBUUGUOYJYKXMWTXAU
      UHYJYLGHJLOUAUBVRVKZEGIXNJKLORUAUBUCVTVMXMUUFXGXPKXMWTXAUUFXGUOYJYLEGHJLO
      UAUBUCWAVKWBWCWDXMYNYOYPXPBUFZYAUUCUOYQYRYSXMWTXOGUFZUUJYJXMWTXBUUHUUKYJY
      KUUIGIXNJLOUAUBWEVMBEGXOJLOPUAUBUCVIVKZBKLCXJXPPRWFWGXMYNYOXGBUFZUUJYCUUE
      UOYQYRXMWTXAUUMYJYLBEGHJLOPUAUBUCVIVKZUULBKLCXGXPPRWFWGWHWBXMXRYCMUKZYDXR
      UOZXMXIUUOXCXFXIXKWIXMYNDBUFZXHBUFZUUJXIUUOWJYQXMXEUUQYTABDLPTVJVGXMYNYOU
      UMUURYQYRUUNBKLCXGPRVLVMZUULBKLMDXHXPPQRWKWGWLXMYNYGYCBUFZUUOUUPWMYQUUAXM
      YNUURUUJUUTYQUUSUULBKLXHXPPRVLVMBLMNXRYCPQSWNVMWOWPWQ $.

    ${
      cdlemh.z $e |- .0. = ( 0. ` K ) $.
      $( Part of proof of Lemma H of [Crawley] p. 118.  (Contributed by NM,
         16-Jun-2013.) $)
      cdlemh2 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W ) )
         /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
            /\ ( R ` F ) =/= ( R ` G ) ) )
    -> ( S ./\ W ) = .0. ) $=
        ( chlt wcel wa w3a wbr cid cres wne cfv ccnv ccom col wceq simp11l hlol
        wn co syl clat hllat simp2ll atbase simp11r simp13 trlcl syl2anc latjcl
        syl3anc simp2rl simp12 ltrncnv ltrnco latmassOLD syl13anc simp2r lhpmat
        jca oveq1d trlle atmod4i2 syl131anc olj02 3eqtr3rd oveq2d simp2l simp33
        lhpbase necomd trlcnv neeqtrrd simp31 trlcone syl112anc simp32 trlnidat
        ltrncnvnid trlcoat lhp2at0 syl322anc 3eqtr2rd oveq1i syl6reqr ) LUGUHZO
        JUHZUIZHGUHZIGUHZUJZCAUHZCOMUKVBZUIZDAUHZDOMUKVBZUIZUIZHULBUMZUNZIYBUNZ
        HEUOZIEUOZUNZUJZUJZPCYFKVCZDIHUPZUQZEUOZKVCZNVCZONVCZFONVCYIYPYJYNONVCZ
        NVCZYJYMNVCZPYILURUHZYJBUHZYNBUHZOBUHZYPYRUSYIXIYTXIXJXLXMYAYHUTZLVAVDZ
        YILVEUHZCBUHZYFBUHZUUAYIXIUUFUUDLVFVDZYIXOUUGXOXPXTXNYHVGABCLQUAVHVDYIX
        KXMUUHYIXIXJUUDXIXJXLXMYAYHVIZWCZXKXLXMYAYHVJZBEGIJLOQUBUCUDVKVLBKLCYFQ
        SVMVNYIUUFDBUHZYMBUHZUUBUUIYIXRUUMXRXSXQXNYHVOZABDLQUAVHVDYIXKYLGUHZUUN
        UUKYIXKXMYKGUHZUUPUUKUULYIXKXLUUQUUKXKXLXMYAYHVPZGHJLOUBUCVQVLZGIYKJLOU
        BUCVRVNZBEGYLJLOQUBUCUDVKVLZBKLDYMQSVMVNYIXJUUCUUJBJLOQUBWMVDZBLNYJYNOQ
        TVSVTYIYMYQYJNYIDONVCZYMKVCZPYMKVCZYQYMYIUVCPYMKYIXKXTUVCPUSUUKXNXQXTYH
        WAADJLMNOPRTUFUAUBWBVLWDYIXIXRUUNUUCYMOMUKZUVDYQUSUUDUUOUVAUVBYIXKUUPUV
        FUUKUUTEGYLJLMORUBUCUDWEVLZABDKLMNYMOQRSTUAWFWGYIYTUUNUVEYMUSUUEUVABKLY
        MPQSUFWHVLWIWJYIXKXQYFYMUNZYFAUHZYFOMUKZYMAUHZUVFYSPUSUUKXNXQXTYHWKYIXK
        XMUUQUIZYFYKEUOZUNZYKYBUNZUVHUUKYIXMUUQUULUUSWCZYIYFYEUVMYIYEYFXNYAYCYD
        YGWLWNYIXKXLUVMYEUSUUKUUREGHJLOUBUCUDWOVLWPZYIXKXLYCUVOUUKUURXNYAYCYDYG
        WQBGHJLOQUBUCXBVNBEGIYKJLOQUBUCUDWRWSYIXKXMYDUVIUUKUULXNYAYCYDYGWTABEGI
        JLOQUAUBUCUDXAVNYIXKXMUVJUUKUULEGIJLMORUBUCUDWEVLYIXKUVLUVNUVKUUKUVPUVQ
        AEGIYKJLOUAUBUCUDXCVNUVGACYFJKLMNYMOPRSTUFUAUBXDXEXFFYOONUEXGXH $.
    $}

    $( Lemma H of [Crawley] p. 118.  (Contributed by NM, 17-Jun-2013.) $)
    cdlemh $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( ( P e. A /\ -. P .<_ W ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ Q .<_ ( P .\/ ( R ` F ) ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( R ` F ) =/= ( R ` G ) ) )
  -> ( S e. A /\ -. S .<_ W ) ) $=
      ( chlt wcel wa w3a wbr wn cfv co cid cres wne cp0 ccnv ccom simp1 simp21l
      wceq simp22l simp23 simp33 cdlemh1 syl122anc col simp11l hlol syl simp11r
      oveq1 simp13 simp12 ltrncnv syl2anc necomd trlcnv neeqtrrd trlcoat atbase
      jca syl3anc eqid olj02 sylan9eqr clln ltrnco trlle simp22r llni2 syl31anc
      nbrne2 llnneat nelne2 adantr eqnetrd necon2d mpd simp32 trlnidat hlatlej2
      ex wo simp22 simp31 ltrncnvnid trlcone lhp2atnle syl322anc nbrne1 2atmat0
      syl33anc eleq1i eqeq1i orbi12i sylibr necon1ad simp21 cdlemh2 syld3an2 wb
      ord lhpmatb syl21anc mpbird ) LUEUFZOJUFZUGZHGUFZIGUFZUHZCAUFZCOMUIUJZUGZ
      DAUFZDOMUIUJZUGZDCHEUKZKULMUIZUHZHUMBUNZUOZIUUBUOZYSIEUKZUOZUHZUHZFAUFZFO
      MUIUJZUUHFLUPUKZUOZUUIUUHFIHUQZURZEUKZKULZDUUOKULZVAZUULUUHYLYMYPYTUUFUUR
      YLUUAUUGUSYMYNYRYTYLUUGUTZYPYQYOYTYLUUGVBZYLYOYRYTUUGVCYLUUAUUCUUDUUFVDZA
      BCDEFGHIJKLMNOPQRSTUAUBUCUDVEVFUUHFUUKUUPUUQUUHFUUKVAZUUPUUQUOUUHUVBUGUUP
      UUOUUQUVBUUHUUPUUKUUOKULZUUOFUUKUUOKVLUUHLVGUFZUUOBUFZUVCUUOVAUUHYGUVDYGY
      HYJYKUUAUUGVHZLVIVJUUHUUOAUFZUVEUUHYIYKUUMGUFZUGZUUEUUMEUKZUOZUVGUUHYGYHU
      VFYGYHYJYKUUAUUGVKZWBZUUHYKUVHYIYJYKUUAUUGVMZUUHYIYJUVHUVMYIYJYKUUAUUGVNZ
      GHJLOUAUBVOVPZWBUUHUUEYSUVJUUHYSUUEUVAVQUUHYIYJUVJYSVAUVMUVOEGHJLOUAUBUCV
      RVPVSZAEGIUUMJLOTUAUBUCVTWCZABUUOLPTWAVJBKLUUOUUKPRUUKWDZWEVPWFUUHUUOUUQU
      OZUVBUUHUVGUUQAUFUJZUVTUVRUUHYGUUQLWGUKZUFZUWAUVFUUHYGYPUVGDUUOUOZUWCUVFU
      UTUVRUUHUUOOMUIZYQUWDUUHYIUUNGUFZUWEUVMUUHYIYKUVHUWFUVMUVNUVPGIUUMJLOUAUB
      WHWCEGUUNJLMOQUAUBUCWIVPZYPYQYOYTYLUUGWJUWEYQUGUUODUUODOMWMVQVPADUUOKLUWB
      RTUWBWDZWKWLALUWBUUQTUWHWNVPUUOUUQAWOVPWPWQXCWRWSUUHUUIFUUKUUHUUIUVBUUHCU
      UEKULZUUQNULZAUFZUWJUUKVAZXDZUUIUVBXDUUHYGYMUUEAUFZYPUVGUWIUUQUOZUWMUVFUU
      SUUHYIYKUUDUWNUVMUVNYLUUAUUCUUDUUFWTABEGIJLOPTUAUBUCXAWCZUUTUVRUUHUUEUWIM
      UIZUUEUUQMUIUJZUWOUUHYGYMUWNUWQUVFUUSUWPACUUEKLMQRTXBWCUUHYIYRUUOUUEUOZUV
      GUWEUWNUUEOMUIZUWRUVMYLYOYRYTUUGXEZUUHYIYKUVHUVKUUMUUBUOZUWSUVMUVNUVPUVQU
      UHYIYJUUCUXBUVMUVOYLUUAUUCUUDUUFXFBGHJLOPUAUBXGWCYIUVIUVKUXBUGUHUUEUUOBEG
      IUUMJLOPUAUBUCXHVQVFUVRUWGUWPUUHYIYKUWTUVMUVNEGIJLMOQUAUBUCWIVPADUUOJKLMU
      UEOQRTUAXIXJUUEUWIUUQMXKVPACUUEDUUOKLNUUKRSUVSTXLXMUUIUWKUVBUWLFUWJAUDXNF
      UWJUUKUDXOXPXQYCXRWSZUUHUUJFONULUUKVAZYLYOYRUGUUAUUGUXDUUHYOYRYLYOYRYTUUG
      XSUXAWBABCDEFGHIJKLMNOUUKPQRSTUAUBUCUDUVSXTYAUUHYGYHUUIUUJUXDYBUVFUVLUXCA
      FJLMNOUUKQSUVSTUAYDYEYFWB $.
  $}

  ${
    cdlemi.b $e |- B = ( Base ` K ) $.
    cdlemi.l $e |- .<_ = ( le ` K ) $.
    cdlemi.j $e |- .\/ = ( join ` K ) $.
    cdlemi.m $e |- ./\ = ( meet ` K ) $.
    cdlemi.a $e |- A = ( Atoms ` K ) $.
    cdlemi.h $e |- H = ( LHyp ` K ) $.
    cdlemi.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemi.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemi.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Part of proof of Lemma I of [Crawley] p. 118.  (Contributed by NM,
       18-Jun-2013.) $)
    cdlemi1 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( U e. E /\ G e. T )
       /\ ( P e. A /\ -. P .<_ W ) )
 -> ( ( U ` G ) ` P ) .<_ ( P .\/ ( R ` G ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv clat simp1l hllat syl simp2l simp2r tendocl
      co simp1 syl3anc simp3l atbase ltrncl syl2anc latjcl latlej2 wceq trlval2
      trlcl syld3an2 oveq2d lhpbase latlej1 atmod3i1 syl131anc cp1 eqid lhpjat2
      simp1r 3adant2 hlol olm11 eqtrd 3eqtrd breqtrrd tendotp latjlej2 syl13anc
      col wi mpd lattrd ) KUDUEZNIUEZUFZFGUEZHEUEZUFZCAUEZCNLUGUHZUFZUIZBKLCHFU
      JZUJZCXCDUJZJURZCHDUJZJURZOPXBWMKUKUEZWMWNWRXAULZKUMUNZXBWOXCEUEZCBUEZXDB
      UEZWOWRXAUSZXBWOWPWQXLXOWOWPWQXAUOZWOWPWQXAUPZFEGHIKUDNTUAUCUQUTZXBWSXMWO
      WRWSWTVAZABCKOSVBUNZBEXCIKUDNCOTUAVCUTZXBXIXMXEBUEZXFBUEXKXTXBWOXLYBXOXRB
      DEXCIKNOTUAUBVIVDZBJKCXEOQVEUTXBXIXMXGBUEZXHBUEXKXTXBWOWQYDXOXQBDEHIKNOTU
      AUBVIVDZBJKCXGOQVEUTXBXDCXDJURZXFLXBXIXMXNXDYFLUGXKXTYABJKLCXDOPQVFUTXBXF
      CYFNMURZJURZYFCNJURZMURZYFXBXEYGCJWOXLWRXAXEYGVGXRACDEXCIJKLMNPQRSTUAUBVH
      VJVKXBWMWSYFBUEZNBUEZCYFLUGZYHYJVGXJXSXBXIXMXNYKXKXTYABJKCXDOQVEUTZXBWNYL
      WMWNWRXAVSBIKNOTVLUNXBXIXMXNYMXKXTYABJKLCXDOPQVMUTABCJKLMYFNOPQRSVNVOXBYJ
      YFKVPUJZMURZYFXBYIYOYFMWOXAYIYOVGWRACYOIJKLNPQYOVQZSTVRVTVKXBKWIUEZYKYPYF
      VGXBWMYRXJKWAUNYNBYOKMYFORYQWBVDWCWDWEXBXEXGLUGZXFXHLUGZXBWOWPWQYSXOXPXQD
      FEGHIKLUDNPTUAUBUCWFUTXBXIYBYDXMYSYTWJXKYCYEXTBJKLXEXGCOPQWGWHWKWL $.

    $( Part of proof of Lemma I of [Crawley] p. 118.  (Contributed by NM,
       18-Jun-2013.) $)
    cdlemi2 $p |- ( ( ( K e. HL /\ W e. H )
       /\ ( U e. E /\ F e. T /\ G e. T )
       /\ ( P e. A /\ -. P .<_ W ) )
 -> ( ( U ` G ) ` P )
      .<_ ( ( ( U ` F ) ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv ccnv ccom simp1l simp1r simp21 simp1 simp23
      wceq simp22 ltrncnv syl2anc ltrnco syl3anc tendovalco syl32anc coass cres
      co cid wf1o ltrn1o f1ococnv1 syl coeq2d wf f1of fcoi1 eqtrd syl5eq fveq2d
      eqtr3d fveq1d tendocl simp3l ltrncoval syl121anc syld3an2 cdlemi1 eqbrtrd
      3syl ltrnel ) LUEUFZOJUFZUGZFGUFZHEUFZIEUFZUHZCAUFZCOMUIUJZUGZUHZCIFUKZUK
      ZCHFUKZUKZIHULZUMZFUKZUKZXGXIDUKKVIZMXCCXJXFUMZUKZXEXKXCCXMXDXCXIHUMZFUKZ
      XMXDXCWMWNWPXIEUFZWQXPXMUSWMWNWSXBUNWMWNWSXBUOWOWPWQWRXBUPZXCWOWRXHEUFZXQ
      WOWSXBUQZWOWPWQWRXBURZXCWOWQXSXTWOWPWQWRXBUTZEHJLOUAUBVAVBEIXHJLOUAUBVCVD
      ZYBFEGXIHJLUEOUAUBUDVEVFXCXOIFXCXOIXHHUMZUMZIIXHHVGXCYEIVJBVHZUMZIXCYDYFI
      XCBBHVKZYDYFUSXCWOWQYHXTYBBEHJLUEOPUAUBVLVBBBHVMVNVOXCBBIVKZBBIVPYGIUSXCW
      OWRYIXTYABEIJLUEOPUAUBVLVBBBIVQBBIVRWKVSVTWAWBWCXCWOXJEUFZXFEUFZWTXNXKUSX
      TXCWOWPXQYJXTXRYCFEGXIJLUEOUAUBUDWDVDXCWOWPWQYKXTXRYBFEGHJLUEOUAUBUDWDVDZ
      WOWSWTXAWEACEXJXFJLMOQTUAUBWFWGWBXCWOWPXQXGAUFXGOMUIUJUGZXKXLMUIXTXRYCWOY
      KWSXBYMYLACEXFJLMOQTUAUBWLWHABXGDEFGXIJKLMNOPQRSTUAUBUCUDWIWGWJ $.

    cdlemi.s $e |- S = ( ( P .\/ ( R ` G ) )
     ./\ ( ( ( U ` F ) ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) $.
    $( Lemma I of [Crawley] p. 118.  (Contributed by NM, 19-Jun-2013.) $)
    cdlemi $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( U e. E /\ ( P e. A /\ -. P .<_ W ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( R ` F ) =/= ( R ` G ) ) )
 -> ( ( U ` G ) ` P ) = S ) $=
      ( chlt wcel wa w3a wbr wn cid cres wne cfv ccnv ccom wceq simp11l simp11r
      co simp2l simp13 simp2r cdlemi1 syl221anc cdlemi2 syl231anc clat wb hllat
      simp12 simp11 tendocl syl3anc simp2rl atbase ltrncl trlcl syl2anc ltrncnv
      syl latjcl ltrnco latlem12 syl13anc mpbi2and cal hlatl ltrnat ltrnel 3jca
      eqid cdlemh simpld syld3an2 atcmp mpbid syl6eqr ) MUGUHZPKUHZUIZIFUHZJFUH
      ZUJZGHUHZCAUHZCPNUKULZUIZUIZIUMBUNZUOJXLUOIDUPZJDUPZUOUJZUJZCJGUPZUPZCXNL
      VBZCIGUPZUPZJIUQZURZDUPZLVBZOVBZEXPXRYFNUKZXRYFUSZXPXRXSNUKZXRYENUKZYGXPX
      AXBXGXEXJYIXAXBXDXEXKXOUTZXAXBXDXEXKXOVAZXFXGXJXOVCZXCXDXEXKXOVDZXFXGXJXO
      VEZABCDFGHJKLMNOPQRSTUAUBUCUDUEVFVGXPXAXBXGXDXEXJYJYKYLYMXCXDXEXKXOVMZYNY
      OABCDFGHIJKLMNOPQRSTUAUBUCUDUEVHVIXPMVJUHZXRBUHZXSBUHZYEBUHZYIYJUIYGVKXPX
      AYQYKMVLWCZXPXCXQFUHZCBUHZYRXCXDXEXKXOVNZXPXCXGXEUUBUUDYMYNGFHJKMUGPUBUCU
      EVOVPZXPXHUUCXHXIXGXFXOVQZABCMQUAVRWCZBFXQKMUGPCQUBUCVSVPXPYQUUCXNBUHZYSU
      UAUUGXPXCXEUUHUUDYNBDFJKMPQUBUCUDVTWABLMCXNQSWDVPXPYQYABUHZYDBUHZYTUUAXPX
      CXTFUHZUUCUUIUUDXPXCXGXDUUKUUDYMYPGFHIKMUGPUBUCUEVOVPZUUGBFXTKMUGPCQUBUCV
      SVPXPXCYCFUHZUUJUUDXPXCXEYBFUHZUUMUUDYNXPXCXDUUNUUDYPFIKMPUBUCWBWAFJYBKMP
      UBUCWEVPBDFYCKMPQUBUCUDVTWABLMYAYDQSWDVPBMNOXRXSYEQRTWFWGWHXPMWIUHZXRAUHZ
      YFAUHZYGYHVKXPXAUUOYKMWJWCXPXCUUBXHUUPUUDUUEUUFACFXQKMNPRUAUBUCWKVPXFXJYA
      AUHYAPNUKULUIZYACXMLVBNUKZUJZXKXOUUQXPXJUURUUSYOXPXCUUKXJUURUUDUULYOACFXT
      KMNPRUAUBUCWLVPXPXAXBXGXDXJUUSYKYLYMYPYOABCDFGHIKLMNOPQRSTUAUBUCUDUEVFVGW
      MXFUUTXOUJUUQYFPNUKULABCYADYFFIJKLMNOPQRSTUAUBUCUDYFWNWOWPWQAXRYFMNRUAWRV
      PWSUFWT $.
  $}

  ${
    cdlemj.b $e |- B = ( Base ` K ) $.
    cdlemj.h $e |- H = ( LHyp ` K ) $.
    cdlemj.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemj.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemj.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    ${
      cdlemj.l $e |- .<_ = ( le ` K ) $.
      cdlemj.a $e |- A = ( Atoms ` K ) $.
      $( Part of proof of Lemma J of [Crawley] p. 118.  (Contributed by NM,
         19-Jun-2013.) $)
      cdlemj1 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( U e. E /\ V e. E /\ ( U ` F ) = ( V ` F ) )
            /\ ( F e. T /\ F =/= ( _I |` B ) /\ h e. T ) )
         /\ ( h =/= ( _I |` B ) /\ g e. T
            /\ g =/= ( _I |` B ) )
         /\ ( ( R ` F ) =/= ( R ` g )
            /\ ( R ` g ) =/= ( R ` h )
            /\ ( p e. A /\ -. p .<_ W ) ) )
    -> ( ( U ` h ) ` p ) = ( ( V ` h ) ` p ) ) $=
        ( chlt wcel wa cfv wceq w3a cid cres wne cv wbr wn co ccnv ccom simp123
        fveq1d oveq1d oveq2d simp11 simp131 simp22 simp121 simp33 simp23 simp31
        cjn cmee simp132 cdlemi syl323anc simp122 3eqtr4d simp133 simp21 simp32
        eqid ) KUCUDNJUDUEZEHUDZMHUDZIEUFZIMUFZUGZUHZIDUDZIUIBUJZUKZGULZDUDZUHZ
        UHZWJWHUKZFULZDUDZWOWHUKZUHZICUFWOCUFZUKZWSWJCUFZUKZOULZAUDXCNLUMUNUEZU
        HZUHZXCXAKVIUFZUOZXCWOEUFUFZWJWOUPUQCUFZXGUOZKVJUFZUOZXHXCWOMUFUFZXJXGU
        OZXLUOZXCWJEUFUFZXCWJMUFUFZXFXKXOXHXLXFXIXNXJXGXFXCWSXGUOZXCWCUFZWOIUPU
        QCUFZXGUOZXLUOZXSXCWDUFZYAXGUOZXLUOZXIXNXFYBYEXSXLXFXTYDYAXGXFXCWCWDWAW
        BWEVTWLWRXEURUSUTVAXFVTWGWPWAXDWIWQWTXIYCUGVTWFWLWRXEVBZWGWIWKVTWFWRXEV
        CZWMWNWPWQXEVDZWAWBWEVTWLWRXEVEZWMWRWTXBXDVFZWGWIWKVTWFWRXEVKZWMWNWPWQX
        EVGZWMWRWTXBXDVHZABXCCYCDEHIWOJXGKLXLNPUAXGVSZXLVSZUBQRSTYCVSVLVMXFVTWG
        WPWBXDWIWQWTXNYFUGYGYHYIWAWBWEVTWLWRXEVNZYKYLYMYNABXCCYFDMHIWOJXGKLXLNP
        UAYOYPUBQRSTYFVSVLVMVOUTVAXFVTWPWKWAXDWQWNXBXQXMUGYGYIWGWIWKVTWFWRXEVPZ
        YJYKYMWMWNWPWQXEVQZWMWRWTXBXDVRZABXCCXMDEHWOWJJXGKLXLNPUAYOYPUBQRSTXMVS
        VLVMXFVTWPWKWBXDWQWNXBXRXPUGYGYIYRYQYKYMYSYTABXCCXPDMHWOWJJXGKLXLNPUAYO
        YPUBQRSTXPVSVLVMVO $.
    $}

    $d p B $.  $d p E $.  $d p F $.  $d p H $.  $d p K $.  $d p R $.  $d p T $.
    $d p U $.  $d p V $.  $d p W $.  $d p g $.  $d p h $.
    $( Part of proof of Lemma J of [Crawley] p. 118.  Eliminate ` p ` .
       (Contributed by NM, 20-Jun-2013.) $)
    cdlemj2 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( U e. E /\ V e. E /\ ( U ` F ) = ( V ` F ) )
          /\ ( F e. T /\ F =/= ( _I |` B ) /\ h e. T ) )
       /\ ( h =/= ( _I |` B ) /\ g e. T
          /\ g =/= ( _I |` B ) )
       /\ ( ( R ` F ) =/= ( R ` g )
          /\ ( R ` g ) =/= ( R ` h ) ) )
  -> ( U ` h ) = ( V ` h ) ) $=
      ( vp wcel cfv chlt wa wceq w3a cid cres wne cv cple wbr wn wi catm simpl1
      wral simpl2 simpl3l simpl3r simpr cdlemj1 syl113anc exp32 ralrimiv simp11
      eqid wb simp121 simp133 tendocl syl3anc simp122 ltrneq mpbid ) JUASLISUBZ
      DGSZKGSZHDTHKTUCZUDZHCSZHUEAUFZUGZFUHZCSZUDZUDZWBVTUGEUHZCSWFVTUGUDZHBTWF
      BTZUGZWHWBBTUGZUBZUDZRUHZLJUITZUJUKZWMWBDTZTWMWBKTZTUCZULZRJUMTZUOZWPWQUC
      ZWLWSRWTWLWMWTSZWOWRWLXCWOUBZUBWEWGWIWJXDWRWEWGWKXDUNWEWGWKXDUPWIWJWEWGXD
      UQWIWJWEWGXDURWLXDUSWTABCDEFGHIJWNKLRMNOPQWNVEZWTVEZUTVAVBVCWLVNWPCSZWQCS
      ZXAXBVFVNVRWDWGWKVDZWLVNVOWCXGXIVOVPVQVNWDWGWKVGVSWAWCVNVRWGWKVHZDCGWBIJU
      ALNOQVIVJWLVNVPWCXHXIVOVPVQVNWDWGWKVKXJKCGWBIJUALNOQVIVJWTCWPWQIJWNLRXEXF
      NOVLVJVM $.

    $d g u B $.  $d g u E $.  $d g u F $.  $d g u H $.  $d g u K $.
    $d g u R $.  $d g u T $.  $d g u U $.  $d g u V $.  $d g u W $.
    $d h g u $.
    $( Part of proof of Lemma J of [Crawley] p. 118.  Eliminate ` g ` .
       (Contributed by NM, 20-Jun-2013.) $)
    cdlemj3 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( U e. E /\ V e. E /\ ( U ` F ) = ( V ` F ) )
          /\ ( F e. T /\ F =/= ( _I |` B ) /\ h e. T ) )
       /\ h =/= ( _I |` B ) )
  -> ( U ` h ) = ( V ` h ) ) $=
      ( wcel wa cfv wne vu vg chlt wceq w3a cid cres cv cple wbr catm wrex eqid
      simpl1 lhpexle2 syl simpl1l adantr simpl1r simprl simprr1 syl22anc simp1l
      cdlemfnid simp1r simp3rr simp2r2 simp3rl neeqtrrd simp2r3 eqnetrd cdlemj2
      simp3l necomd syl132anc 3expia exp3a rexlimdv mpd rexlimddv ) IUCQZKHQZRZ
      DFQJFQGDSGJSUDUEZGCQGUFAUGZTEUHZCQUEZUEZWFWETZRZUAUHZKIUISZUJZWKGBSZTZWKW
      FBSZTZUEZWFDSWFJSUDZUAIUKSZWJWCWRUAWTULWCWDWGWIUNWTHIWLKWNWPUAWLUMZWTUMZM
      UOUPWJWKWTQZWRRZRZUBUHZBSZWKUDZXFWETZRZUBCULZWSXEWAWBXCWMXKWJWAXDWAWBWDWG
      WIUQURWJWBXDWAWBWDWGWIUSURWJXCWRUTWMWOWQXCWJVAWTABCWKUBHIWLKLXAXBMNOVDVBX
      EXJWSUBCXEXFCQZXJWSWJXDXLXJRZWSWJXDXMUEZWHWIXLXIWNXGTXGWPTWSWHWIXDXMVCWHW
      IXDXMVEWJXDXLXJVMXHXIXLWJXDVFXNWNWKXGXNWKWNWMWOWQXCWJXMVGVNXHXIXLWJXDVHZV
      IXNXGWKWPXOWMWOWQXCWJXMVJVKABCDUBEFGHIJKLMNOPVLVOVPVQVRVSVT $.
  $}

  ${
    $d h B $.  $d h E $.  $d h F $.  $d h H $.  $d h K $.  $d h T $.  $d h U $.
    $d h V $.  $d h W $.
    tendocan.b $e |- B = ( Base ` K ) $.
    tendocan.h $e |- H = ( LHyp ` K ) $.
    tendocan.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendocan.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Cancellation law: if the values of two trace-preserving endormorphisms
       are equal, so are the endormorphisms.  Lemma J of [Crawley] p. 118.
       (Contributed by NM, 21-Jun-2013.) $)
    tendocan $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( U e. E /\ V e. E /\ ( U ` F ) = ( V ` F ) )
          /\ ( F e. T /\ F =/= ( _I |` B ) ) )
  -> U = V ) $=
      ( vh wcel wa cfv wceq w3a wne chlt cres cv wi simp1l simp1r simp21 simp22
      cid wral simp11 simp12 simp13l simp13r simp2 3jca simp3 ctrl eqid cdlemj3
      syl31anc 3exp ralrimiv tendoeq2 syl221anc ) GUAOZIFOZPZCDOZHDOZECQEHQRZSZ
      EBOZEUIAUBZTZPZSZVFVGVIVJNUCZVNTZVRCQVRHQRZUDZNBUJCHRVFVGVLVPUEVFVGVLVPUF
      VHVIVJVKVPUGVHVIVJVKVPUHVQWANBVQVRBOZVSVTVQWBVSSZVHVLVMVOWBSVSVTVHVLVPWBV
      SUKVHVLVPWBVSULWCVMVOWBVMVOVHVLWBVSUMVMVOVHVLWBVSUNVQWBVSUOUPVQWBVSUQAIGU
      RQQZBCNDEFGHIJKLWDUSMUTVAVBVCABCNDFGHIJKLMVDVE $.
  $}

  ${
    $d f g B $.  $d g H $.  $d g K $.  $d f g T $.  $d g W $.
    tendoid0.b $e |- B = ( Base ` K ) $.
    tendoid0.h $e |- H = ( LHyp ` K ) $.
    tendoid0.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendoid0.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendoid0.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $( A trace-preserving endomorphism is the additive identity iff at least
       one of its values (at a non-identity translation) is the identity
       translation.  (Contributed by NM, 1-Aug-2013.) $)
    tendoid0 $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E
     /\ ( F e. T /\ F =/= ( _I |` B ) ) )
   -> ( ( U ` F ) = ( _I |` B ) <-> U = O ) ) $=
      ( wcel wa cfv wceq syl chlt cid cres wne w3a simp3l tendo02 eqeq2d simpl1
      simpl2 tendo0cl simpr simpl3l simpl3r tendocan syl132anc ex sylbird fveq1
      eqeq1d syl5ibrcom impbid ) HUAPJGPQZCEPZFBPZFUBAUCZUDZQZUEZFCRZVFSZCISZVI
      VKVJFIRZSZVLVIVMVFVJVIVEVMVFSZVCVDVEVGUFABDFHIOKUGTZUHVIVNVLVIVNQZVCVDIEP
      ZVNVEVGVLVCVDVHVNUIZVCVDVHVNUJVQVCVRVSABDEGHIJKLMNOUKTVIVNULVEVGVCVDVNUMV
      EVGVCVDVNUNABCEFGHIJKLMNUOUPUQURVIVKVLVOVPVLVJVMVFFCIUSUTVAVB $.

    $d g E $.  $d g O $.  $d g U $.  $d g V $.
    $( Additive identity multiplied by a trace-preserving endomorphism.
       (Contributed by NM, 1-Aug-2013.) $)
    tendo0mul $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E )
   -> ( O o. U ) = O ) $=
      ( vg chlt wcel wa wceq cfv cid cres wne ccom wrex cdlemftr0 adantr simpll
      tendo0cl ad2antrr simplr tendococl syl3anc tendocl tendo02 syl tendocoval
      cv simprl syl121anc ad2antrl 3eqtr4d simpr tendocan syl131anc rexlimddv )
      GPQIFQRZCEQZRZOURZUAAUBZUCZHCUDZHSZOBVGVLOBUEVHABOFGIJKLUFUGVIVJBQZVLRZRZ
      VGVMEQZHEQZVJVMTZVJHTZSVPVNVGVHVPUHZVQVGVSVHVRWBVGVSVHVPABDEFGHIJKLMNUIUJ
      ZVGVHVPUKZHCEFGIKMULUMWCVQVJCTZHTZVKVTWAVQWEBQZWFVKSVQVGVHVOWGWBWDVIVOVLU
      SZCBEVJFGPIKLMUNUMABDWEGHNJUOUPVQVGVSVHVOVTWFSWBWCWDWHBHEVJFGCIPKLMUQUTVO
      WAVKSVIVLABDVJGHNJUOVAVBVIVPVCABVMEVJFGHIJKLMVDVEVF $.

    $( Additive identity multiplied by a trace-preserving endomorphism.
       (Contributed by NM, 13-Feb-2014.) $)
    tendo0mulr $p |- ( ( ( K e. HL /\ W e. H ) /\ U e. E )
   -> ( U o. O ) = O ) $=
      ( vg chlt wcel wa wceq cfv cid cres wne ccom wrex cdlemftr0 adantr simpll
      simplr tendo0cl ad2antrr tendococl syl3anc tendo02 ad2antrl tendoid eqtrd
      cv fveq2d tendocoval syl121anc 3eqtr4d simpr tendocan syl131anc rexlimddv
      simprl ) GPQIFQRZCEQZRZOURZUAAUBZUCZCHUDZHSZOBVHVMOBUEVIABOFGIJKLUFUGVJVK
      BQZVMRZRZVHVNEQZHEQZVKVNTZVKHTZSVQVOVHVIVQUHZVRVHVIVTVSWCVHVIVQUIZVHVTVIV
      QABDEFGHIJKLMNUJUKZCHEFGIKMULUMWEVRWBCTZVLWAWBVRWFVLCTZVLVRWBVLCVPWBVLSVJ
      VMABDVKGHNJUNUOZUSVJWGVLSVQACEFGIJKMUPUGUQVRVHVIVTVPWAWFSWCWDWEVJVPVMVGBC
      EVKFGHIPKLMUTVAWHVBVJVQVCABVNEVKFGHIJKLMVDVEVF $.

    $( The identity (unity) is not equal to the zero trace-preserving
       endomorphism.  (Contributed by NM, 8-Aug-2013.) $)
    tendo1ne0 $p |- ( ( K e. HL /\ W e. H ) -> ( _I |` T ) =/= O ) $=
      ( vg wcel wa cid cres wne wceq chlt cv wrex cdlemftr0 w3a simp3 cfv fveq1
      adantl simpl2 fvresi syl tendo02 3eqtr3d ex necon3d mpd rexlimdv3a ) FUAO
      HEOPZNUBZQARZSZNBUCQBRZGSZABNEFHIJKUDUSVBVDNBUSUTBOZVBUEZVBVDUSVEVBUFVFVC
      GUTVAVFVCGTZUTVATVFVGPZUTVCUGZUTGUGZUTVAVGVIVJTVFUTVCGUHUIVHVEVIUTTUSVEVB
      VGUJZBUTUKULVHVEVJVATVKABCUTFGMIUMULUNUOUPUQURUQ $.

    $( The composition (product) of trace-preserving endormorphisms is nonzero
       when each argument is nonzero.  (Contributed by NM, 8-Aug-2013.) $)
    tendoconid $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ U =/= O )
       /\ ( V e. E /\ V =/= O ) ) -> ( U o. V ) =/= O ) $=
      ( vg wcel wa wne wceq chlt w3a cv cid cres ccom cdlemftr0 3ad2ant1 cfv wf
      wrex simpl1 simpl3l tendof syl2anc simprl simpl2r simpl2l tendocl syl3anc
      fvco3 simpl3r simpr tendoid0 necon3bid mpbird syl112anc eqnetrd tendococl
      wb mpbid rexlimddv ) GUAQJFQRZCEQZCHSZRZIEQZIHSZRZUBZPUCZUDAUEZSZCIUFZHSZ
      PBVMVPWCPBUKVSABPFGJKLMUGUHVTWABQZWCRZRZWAWDUIZWBSWEWHWIWAIUIZCUIZWBWHBBI
      UJZWFWIWKTWHVMVQWLVMVPVSWGULZVQVRVMVPWGUMZIBEFGUAJLMNUNUOVTWFWCUPZBBWACIV
      AUOWHWKWBSVOVNVOVMVSWGUQWHWKWBCHWHVMVNWJBQZWJWBSZWKWBTCHTVJWMVNVOVMVSWGUR
      ZWHVMVQWFWPWMWNWOIBEWAFGUAJLMNUSUTWHWQVRVQVRVMVPWGVBWHWJWBIHWHVMVQWGWJWBT
      IHTVJWMWNVTWGVCZABIDEWAFGHJKLMNOVDUTVEVFABCDEWJFGHJKLMNOVDVGVEVFVHWHWIWBW
      DHWHVMWDEQZWGWIWBTWDHTVJWMWHVMVNVQWTWMWRWNCIEFGJLNVIUTWSABWDDEWAFGHJKLMNO
      VDUTVEVKVL $.
  $}

  ${
    $d f g B $.  $d g H $.  $d g K $.  $d f g T $.  $d g W $.
    tendotr.b $e |- B = ( Base ` K ) $.
    tendotr.h $e |- H = ( LHyp ` K ) $.
    tendotr.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendotr.r $e |- R = ( ( trL ` K ) ` W ) $.
    tendotr.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendotr.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $( The trace of the value of a non-zero trace-preserving endomorphism
       equals the trace of the argument.  (Contributed by NM, 11-Aug-2013.) $)
    tendotr $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ U =/= O )
        /\ F e. T ) -> ( R ` ( U ` F ) ) = ( R ` F ) ) $=
      ( wcel cfv wceq chlt wa wne w3a cres simpl1 simpl2l tendoid syl2anc simpr
      cid fveq2d 3eqtr4d cple wbr simpl3 eqid tendotp syl3anc cal catm wb hlatl
      simpl1l tendocl simpl2r tendoid0 syl112anc necon3bid trlnidat atcmp mpbid
      syl mpbird pm2.61dane ) IUARZKHRZUBZDFRZDJUCZUBZGCRZUDZGDSZBSZGBSZTZGUKAU
      EZWCGWHTZUBZWDGBWJWHDSZWHWDGWJVRVSWKWHTVRWAWBWIUFVSVTVRWBWIUGADFHIKLMPUHU
      IWJGWHDWCWIUJZULWLUMULWCGWHUCZUBZWEWFIUNSZUOZWGWNVRVSWBWPVRWAWBWMUFZVSVTV
      RWBWMUGZVRWAWBWMUPZBDCFGHIWOUAKWOUQZMNOPURUSWNIUTRZWEIVASZRZWFXBRZWPWGVBW
      NVPXAVPVQWAWBWMVDIVCVMWNVRWDCRZWDWHUCZXCWQWNVRVSWBXEWQWRWSDCFGHIUAKMNPVEU
      SWNXFVTVSVTVRWBWMVFWNWDWHDJWNVRVSWBWMWDWHTDJTVBWQWRWSWCWMUJZACDEFGHIJKLMN
      PQVGVHVIVNXBABCWDHIKLXBUQZMNOVJUSWNVRWBWMXDWQWSXGXBABCGHIKLXHMNOVJUSXBWEW
      FIWOWTXHVKUSVLVO $.
  $}

  ${
    cdlemk.b $e |- B = ( Base ` K ) $.
    cdlemk.l $e |- .<_ = ( le ` K ) $.
    cdlemk.j $e |- .\/ = ( join ` K ) $.
    cdlemk.a $e |- A = ( Atoms ` K ) $.
    cdlemk.h $e |- H = ( LHyp ` K ) $.
    cdlemk.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       22-Jun-2013.) $)
    cdlemk1 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T )
        /\ ( ( R ` F ) = ( R ` N )
          /\ ( P e. A /\ -. P .<_ W ) ) )
  -> ( P .\/ ( N ` P ) ) = ( ( F ` P ) .\/ ( R ` F ) ) ) $=
      ( wcel chlt wa cfv wceq wbr wn w3a co simp3l oveq2d simp2l simp3r trljat3
      simp1 syl3anc simp2r trljat1 3eqtr3rd ) IUATLGTUBZFETZKETZUBZFDUCZKDUCZUD
      ZCATCLJUEUFUBZUBZUGZCVCHUHZCVDHUHZCFUCVCHUHZCCKUCHUHZVHVCVDCHUSVBVEVFUIUJ
      VHUSUTVFVIVKUDUSVBVGUNZUSUTVAVGUKUSVBVEVFULZACDEFGHIJLNOPQRSUMUOVHUSVAVFV
      JVLUDVMUSUTVAVGUPVNACDEKGHIJLNOPQRSUQUOUR $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       22-Jun-2013.) $)
    cdlemk2 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ G e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
  -> ( ( G ` P ) .\/ ( R ` ( G o. `' F ) ) )
        = ( ( F ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) $=
      ( wcel chlt wa wbr wn w3a cfv ccnv ccom wceq simp1 simp2r ltrncnv syl2anc
      co simp2l ltrnco syl3anc ltrnel 3adant2r simp3l ltrncoval syl121anc coass
      trljat3 cid cres wf1o ltrn1o f1ococnv1 syl coeq2d f1of fcoi1 eqtrd syl5eq
      wf 3syl fveq1d eqtr3d oveq1d eqtr2d ) JUATLHTUBZFETZGETZUBZCATZCLKUCUDZUB
      ZUEZCFUFZGFUGZUHZDUFZIUNZWJWLUFZWMIUNZCGUFZWMIUNWIWBWLETZWJATWJLKUCUDUBZW
      NWPUIWBWEWHUJZWIWBWDWKETZWRWTWBWCWDWHUKZWIWBWCXAWTWBWCWDWHUOZEFHJLQRULUME
      GWKHJLQRUPUQZWBWCWHWSWDACEFHJKLNPQRURUSAWJDEWLHIJKLNOPQRSVDUQWIWOWQWMIWIC
      WLFUHZUFZWOWQWIWBWRWCWFXFWOUIWTXDXCWBWEWFWGUTACEWLFHJKLNPQRVAVBWICXEGWIXE
      GWKFUHZUHZGGWKFVCWIXHGVEBVFZUHZGWIXGXIGWIBBFVGZXGXIUIWIWBWCXKWTXCBEFHJUAL
      MQRVHUMBBFVIVJVKWIBBGVGZBBGVPXJGUIWIWBWDXLWTXBBEGHJUALMQRVHUMBBGVLBBGVMVQ
      VNVOVRVSVTWA $.

    cdlemk.m $e |- ./\ = ( meet ` K ) $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       3-Jul-2013.) $)
    cdlemk3 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ G e. T )
        /\ ( ( R ` G ) =/= ( R ` F )
          /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( P e. A /\ -. P .<_ W ) ) )
  -> ( ( ( F ` P ) .\/ ( R ` F ) )
             ./\ ( ( F ` P ) .\/ ( R ` ( G o. `' F ) ) ) )
        = ( F ` P ) ) $=
      ( chlt wcel wa cfv wne cid cres wbr wn w3a ccnv ccom co wceq simp1l simp1
      simp2l simp32l trlnidat syl3anc simp2r simp31 trlcocnvat syl121anc ltrnat
      simp33l ltrncnv syl2anc eqnetrd simp32r trlcone syl122anc ltrncom 3netr3d
      trlcnv necomd fveq2d simp33 ltrnel simprd trlle ltrnco clat wb syl atbase
      hllat simp1r lhpbase latjle12 syl13anc mpbi2and hlatjcl lattr mpan2d mtod
      wi 2llnma2 syl132anc ) JUBUCZMHUCZUDZFEUCZGEUCZUDZGDUEZFDUEZUFZFUGBUHZUFZ
      GXJUFZUDZCAUCZCMKUIUJZUDZUKZUKZXAXHAUCZGFULZUMZDUEZAUCZCFUEZAUCZXHYBUFYDX
      HYBIUNZKUIZUJYDXHIUNYDYBIUNLUNYDUOXAXBXFXQUPZXRXCXDXKXSXCXFXQUQZXCXDXEXQU
      RZXKXLXIXPXCXFUSABDEFHJMNQRSTUTVAZXRXCXEXDXIYCYIXCXDXEXQVBZYJXCXFXIXMXPVC
      ZADEGFHJMQRSTVDVEZXRXCXDXNYEYIYJXNXOXIXMXCXFVGACEFHJKMOQRSVFVAZXRXTDUEZXT
      GUMZDUEZXHYBXRXCXTEUCZXEYPXGUFXLYPYRUFYIXRXCXDYSYIYJEFHJMRSVHVIZYLXRYPXHX
      GXRXCXDYPXHUOYIYJDEFHJMRSTVPVIZXRXGXHYMVQVJXKXLXIXPXCXFVKBDEXTGHJMNRSTVLV
      MUUAXRYQYADXRXCYSXEYQYAUOYIYTYLEXTGHJMRSVNVAVRVOXRYGYDMKUIZXRXCXDXPUUBUJZ
      YIYJXCXFXIXMXPVSXCXDXPUKYEUUCACEFHJKMOQRSVTWAVAXRYGYFMKUIZUUBXRXHMKUIZYBM
      KUIZUUDXRXCXDUUEYIYJDEFHJKMORSTWBVIXRXCYAEUCZUUFYIXRXCXEYSUUGYIYLYTEGXTHJ
      MRSWCVADEYAHJKMORSTWBVIXRJWDUCZXHBUCZYBBUCZMBUCZUUEUUFUDUUDWEXRXAUUHYHJWH
      WFZXRXSUUIYKABXHJNQWGWFXRYCUUJYNABYBJNQWGWFXRXBUUKXAXBXFXQWIBHJMNRWJWFZBI
      JKXHYBMNOPWKWLWMXRUUHYDBUCZYFBUCZUUKYGUUDUDUUBWRUULXRYEUUNYOABYDJNQWGWFXR
      XAXSYCUUOYHYKYNABIJXHYBNPQWNVAUUMBJKYDYFMNOWOWLWPWQAXHYBYDIJKLOPUAQWSWT
      $.

    $( Part of proof of Lemma K of [Crawley] p. 118, last line.  We use ` X `
       for their h, since ` H ` is already used.  (Contributed by NM,
       24-Jun-2013.) $)
    cdlemk4 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ X e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
  -> ( F ` P ) .<_ ( ( X ` P ) .\/ ( R ` ( X o. `' F ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv ccnv ccom simp1l simp1 simp2l simp3l ltrnat
      syl3anc simp2r hlatlej1 wceq clat hllat syl atbase latjcl simp1r hlatlej2
      lhpbase atmod3i1 syl131anc ltrncnv syl2anc ltrnco ltrnel syld3an2 trlval2
      co cid cres wf1o ltrn1o f1ococnv1 coeq2d wf f1of fcoi1 3syl coass syl6eqr
      eqtr2d fveq1d ltrncoval syl121anc eqtrd oveq2d eqcomd oveq1d eqid lhpjat2
      cp1 col hlol olm11 3eqtr4rd breqtrd ) IUBUCZLGUCZUDZFEUCZMEUCZUDZCAUCZCLJ
      UEUFZUDZUGZCFUHZXOCMUHZHVPZXPMFUIZUJZDUHZHVPZJXNXEXOAUCZXPAUCZXOXQJUEXEXF
      XJXMUKZXNXGXHXKYBXGXJXMULZXGXHXIXMUMZXGXJXKXLUNZACEFGIJLOQRSUOUPZXNXGXIXK
      YCYEXGXHXIXMUQZYGACEMGIJLOQRSUOUPZAXOXPHIJOPQURUPXNXPXQLKVPZHVPZXQXPLHVPZ
      KVPZYAXQXNXEYCXQBUCZLBUCZXPXQJUEZYLYNUSYDYJXNIUTUCZXOBUCZXPBUCZYOXNXEYRYD
      IVAVBXNYBYSYHABXOINQVCVBXNYCYTYJABXPINQVCVBBHIXOXPNPVDUPZXNXFYPXEXFXJXMVE
      BGILNRVGVBXNXEYBYCYQYDYHYJAXOXPHIJOPQVFUPABXPHIJKXQLNOPUAQVHVIXNXTYKXPHXN
      XTXOXOXSUHZHVPZLKVPZYKXNXGXSEUCZYBXOLJUEUFUDZXTUUDUSYEXNXGXIXREUCZUUEYEYI
      XNXGXHUUGYEYFEFGILRSVJVKEMXRGILRSVLUPZXGXHXJXMUUFYFACEFGIJLOQRSVMVNAXODEX
      SGHIJKLOPUAQRSTVOUPXNUUCXQLKXNXQUUCXNXPUUBXOHXNXPCXSFUJZUHZUUBXNCMUUIXNMM
      XRFUJZUJZUUIXNUULMVQBVRZUJZMXNUUKUUMMXNBBFVSZUUKUUMUSXNXGXHUUOYEYFBEFGIUB
      LNRSVTVKBBFWAVBWBXNBBMVSZBBMWCUUNMUSXNXGXIUUPYEYIBEMGIUBLNRSVTVKBBMWDBBMW
      EWFWIMXRFWGWHWJXNXGUUEXHXKUUJUUBUSYEUUHYFYGACEXSFGIJLOQRSWKWLWMWNWOWPWMWN
      XNYNXQIWSUHZKVPZXQXNYMUUQXQKXNXGYCXPLJUEUFUDZYMUUQUSYEXGXIXJXMUUSYIACEMGI
      JLOQRSVMVNAXPUUQGHIJLOPUUQWQZQRWRVKWNXNIWTUCZYOUURXQUSXNXEUVAYDIXAVBUUABU
      UQIKXQNUAUUTXBVKWIXCXD $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       3-Jul-2013.) $)
    cdlemk5a $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ G e. T /\ X e. T )
        /\ ( ( R ` G ) =/= ( R ` F )
          /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( P e. A /\ -. P .<_ W ) ) )
  -> ( ( ( F ` P ) .\/ ( R ` F ) )
             ./\ ( ( F ` P ) .\/ ( R ` ( G o. `' F ) ) ) )
        .<_ ( ( X ` P ) .\/ ( R ` ( X o. `' F ) ) ) ) $=
      ( chlt wcel wa w3a cfv wne cid cres wbr wn ccnv ccom simp1l simp1r simp21
      co wceq simp22 cdlemk3 syl221anc simp23 simp33l simp33r cdlemk4 syl222anc
      simp3 eqbrtrd ) JUCUDZMHUDZUEZFEUDZGEUDZNEUDZUFZGDUGFDUGZUHZFUIBUJZUHGVSU
      HUEZCAUDZCMKUKULZUEUFZUFZCFUGZVQIURWEGFUMZUNDUGIURLURZWECNUGNWFUNDUGIURZK
      WDVJVKVMVNWCWGWEUSVJVKVPWCUOZVJVKVPWCUPZVLVMVNVOWCUQZVLVMVNVOWCUTVLVPWCVH
      ABCDEFGHIJKLMOPQRSTUAUBVAVBWDVJVKVMVOWAWBWEWHKUKWIWJWKVLVMVNVOWCVCWAWBVRV
      TVLVPVDWAWBVRVTVLVPVEABCDEFHIJKLMNOPQRSTUAUBVFVGVI $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       25-Jun-2013.) $)
    cdlemk5 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( ( N e. T /\ X e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( R ` G ) =/= ( R ` F ) ) )
  -> ( ( P .\/ ( N ` P ) )
             ./\ ( ( G ` P ) .\/ ( R ` ( G o. `' F ) ) ) )
        .<_ ( ( X ` P ) .\/ ( R ` ( X o. `' F ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp11l simp11r
      co simp12 simp21l simp23 simp22 cdlemk1 syl222anc cdlemk2 oveq12d simp21r
      simp13 syl221anc simp33 simp31 simp32 jca cdlemk5a syl233anc eqbrtrd ) JU
      DUEZNHUEZUFZFEUEZGEUEZUGZMEUEZOEUEZUFZCAUECNKUHUIUFZFDUJZMDUJUKZUGZFULBUM
      ZUNZGWKUNZGDUJWHUNZUGZUGZCCMUJIUSZCGUJGFUOZUPDUJZIUSZLUSCFUJZWHIUSZXAWSIU
      SZLUSZCOUJOWRUPDUJIUSZKWPWQXBWTXCLWPVRVSWAWDWIWGWQXBUKVRVSWAWBWJWOUQZVRVS
      WAWBWJWOURZVTWAWBWJWOUTZWDWEWGWIWCWOVAWCWFWGWIWOVBWCWFWGWIWOVCZABCDEFHIJK
      MNPQRSTUAUBVDVEWPVRVSWAWBWGWTXCUKXFXGXHVTWAWBWJWOVIZXIABCDEFGHIJKNPQRSTUA
      UBVFVJVGWPVRVSWAWBWEWNWLWMUFWGXDXEKUHXFXGXHXJWDWEWGWIWCWOVHWCWJWLWMWNVKWP
      WLWMWCWJWLWMWNVLWCWJWLWMWNVMVNXIABCDEFGHIJKLNOPQRSTUAUBUCVOVPVQ $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Apply ~ dalaw .
       (Contributed by NM, 25-Jun-2013.) $)
    cdlemk6 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( ( N e. T /\ X e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( ( R ` G ) =/= ( R ` F ) /\ ( R ` X ) =/= ( R ` F ) ) ) )
       -> ( ( P .\/ ( G ` P ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( G o. `' F ) ) ) )
        .<_ ( ( ( ( G ` P ) .\/ ( X ` P ) )
                ./\ ( ( R ` ( G o. `' F ) )
                     .\/ ( R ` ( X o. `' F ) ) ) )
             .\/ ( ( ( X ` P ) .\/ P )
                ./\ ( ( R ` ( X o. `' F ) )
                     .\/ ( N ` P ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv simp31 simp32 simp33l
      wne ccom cdlemk5 syld3an3 wi simp11l simp22l simp11 simp13 ltrnat syl3anc
      3jca simp21r simp21l simp12 trlcocnvat syl121anc simp33r dalaw syl133anc
      mpd ) JUDUEZNHUEZUFZFEUEZGEUEZUGZMEUEZOEUEZUFZCAUEZCNKUHUIZUFZFDUJZMDUJUK
      ZUGZFULBUMZUSZGWOUSZGDUJWLUSZODUJWLUSZUFZUGZUGZCCMUJZIUNCGUJZGFUOZUTDUJZI
      UNLUNCOUJZOXEUTDUJZIUNKUHZCXDIUNXCXFIUNLUNXDXGIUNXFXHIUNLUNXGCIUNXHXCIUNL
      UNIUNKUHZWEWNXAWPWQWRUGXIXBWPWQWRWEWNWPWQWTUPWEWNWPWQWTUQWRWSWPWQWEWNURZV
      JABCDEFGHIJKLMNOPQRSTUAUBUCVAVBXBVTWIXDAUEZXGAUEZXCAUEZXFAUEZXHAUEZXIXJVC
      VTWAWCWDWNXAVDWIWJWHWMWEXAVEZXBWBWDWIXLWBWCWDWNXAVFZWBWCWDWNXAVGZXQACEGHJ
      KNQSTUAVHVIXBWBWGWIXMXRWFWGWKWMWEXAVKZXQACEOHJKNQSTUAVHVIXBWBWFWIXNXRWFWG
      WKWMWEXAVLXQACEMHJKNQSTUAVHVIXBWBWDWCWRXOXRXSWBWCWDWNXAVMZXKADEGFHJNSTUAU
      BVNVOXBWBWGWCWSXPXRXTYAWRWSWPWQWEWNVPADEOFHJNSTUAUBVNVOACXDXGXCXFXHIJKLQR
      UCSVQVRVS $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       26-Jun-2013.) $)
    cdlemk8 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( G e. T /\ X e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> ( ( G ` P ) .\/ ( X ` P ) )
             = ( ( G ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co ccnv ccom coass cid cres wf1o wceq simp1
      simp2l ltrn1o syl2anc f1ococnv1 syl coeq2d simp2r f1of fcoi1 eqtrd syl5eq
      wf fveq1d ltrncnv ltrnco syl3anc simp3l ltrncoval syl121anc eqtr3d oveq2d
      3syl ltrnel 3adant2r trljat1 eqtr4d ) IUBUCLGUCUDZFEUCZMEUCZUDZCAUCZCLJUE
      UFZUDZUGZCFUHZCMUHZHUIWLWLMFUJZUKZUHZHUIZWLWODUHHUIZWKWMWPWLHWKCWOFUKZUHZ
      WMWPWKCWSMWKWSMWNFUKZUKZMMWNFULWKXBMUMBUNZUKZMWKXAXCMWKBBFUOZXAXCUPWKWDWE
      XEWDWGWJUQZWDWEWFWJURZBEFGIUBLNRSUSUTBBFVAVBVCWKBBMUOZBBMVIXDMUPWKWDWFXHX
      FWDWEWFWJVDZBEMGIUBLNRSUSUTBBMVEBBMVFVSVGVHVJWKWDWOEUCZWEWHWTWPUPXFWKWDWF
      WNEUCZXJXFXIWKWDWEXKXFXGEFGILRSVKUTEMWNGILRSVLVMZXGWDWGWHWIVNACEWOFGIJLOQ
      RSVOVPVQVRWKWDXJWLAUCWLLJUEUFUDZWRWQUPXFXLWDWEWJXMWFACEFGIJLOQRSVTWAAWLDE
      WOGHIJLOPQRSTWBVMWC $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       29-Jun-2013.) $)
    cdlemk9 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( G e. T /\ X e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> ( ( ( G ` P ) .\/ ( X ` P ) ) ./\ W )
             = ( R ` ( X o. `' G ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co ccnv ccom cdlemk8 oveq1d cp0 wceq ltrnel
      simp1 3adant2r lhpmat syl2anc simp1l simp2l simp3l ltrnat syl3anc ltrncnv
      eqid simp2r ltrnco trlcl simp1r lhpbase syl trlle atmod4i2 syl131anc hlol
      col olj02 3eqtr3d eqtrd ) IUBUCZLGUCZUDZFEUCZMEUCZUDZCAUCZCLJUEUFZUDZUGZC
      FUHZCMUHHUIZLKUIWLMFUJZUKZDUHZHUIZLKUIZWPWKWMWQLKABCDEFGHIJKLMNOPQRSTUAUL
      UMWKWLLKUIZWPHUIZIUNUHZWPHUIZWRWPWKWSXAWPHWKWDWLAUCZWLLJUEUFUDZWSXAUOWDWG
      WJUQZWDWEWJXDWFACEFGIJLOQRSUPURAWLGIJKLXAOUAXAVGZQRUSUTUMWKWBXCWPBUCZLBUC
      ZWPLJUEZWTWRUOWBWCWGWJVAZWKWDWEWHXCXEWDWEWFWJVBZWDWGWHWIVCACEFGIJLOQRSVDV
      EWKWDWOEUCZXGXEWKWDWFWNEUCZXLXEWDWEWFWJVHWKWDWEXMXEXKEFGILRSVFUTEMWNGILRS
      VIVEZBDEWOGILNRSTVJUTZWKWCXHWBWCWGWJVKBGILNRVLVMWKWDXLXIXEXNDEWOGIJLORSTV
      NUTABWLHIJKWPLNOPUAQVOVPWKIVRUCZXGXBWPUOWKWBXPXJIVQVMXOBHIWPXANPXFVSUTVTW
      A $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: is this needed?  If
       so, shorten with ~ cdlemk9 if that one is also needed.  (Contributed by
       NM, 28-Jun-2013.)  (New usage is discouraged.) $)
    cdlemk9bN $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( G e. T /\ X e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> ( ( ( G ` P ) .\/ ( X ` P ) ) ./\ W )
             = ( R ` ( G o. `' X ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co ccnv ccom cdlemk8 oveq1d cp0 wceq ltrnel
      simp1 3adant2r lhpmat syl2anc simp1l simp2l simp3l ltrnat syl3anc ltrncnv
      eqid simp2r ltrnco trlcl simp1r lhpbase syl trlle atmod4i2 syl131anc hlol
      col olj02 trlcocnv eqtr4d 3eqtr3d eqtrd ) IUBUCZLGUCZUDZFEUCZMEUCZUDZCAUC
      ZCLJUEUFZUDZUGZCFUHZCMUHHUIZLKUIWNMFUJZUKZDUHZHUIZLKUIZFMUJUKDUHZWMWOWSLK
      ABCDEFGHIJKLMNOPQRSTUAULUMWMWNLKUIZWRHUIZIUNUHZWRHUIZWTXAWMXBXDWRHWMWFWNA
      UCZWNLJUEUFUDZXBXDUOWFWIWLUQZWFWGWLXGWHACEFGIJLOQRSUPURAWNGIJKLXDOUAXDVGZ
      QRUSUTUMWMWDXFWRBUCZLBUCZWRLJUEZXCWTUOWDWEWIWLVAZWMWFWGWJXFXHWFWGWHWLVBZW
      FWIWJWKVCACEFGIJLOQRSVDVEWMWFWQEUCZXJXHWMWFWHWPEUCZXOXHWFWGWHWLVHZWMWFWGX
      PXHXNEFGILRSVFUTEMWPGILRSVIVEZBDEWQGILNRSTVJUTZWMWEXKWDWEWIWLVKBGILNRVLVM
      WMWFXOXLXHXRDEWQGIJLORSTVNUTABWNHIJKWRLNOPUAQVOVPWMXEWRXAWMIVRUCZXJXEWRUO
      WMWDXTXMIVQVMXSBHIWRXDNPXIVSUTWMWFWGWHXAWRUOXHXNXQDEFMGILRSTVTVEWAWBWC $.

    ${

      cdlemk.i $e |- I = ( iota_ i e. T
        ( i ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) ) $.

      $d i ./\ $.  $d i .<_ $.  $d i .\/ $.  $d i A $.  $d i F $.  $d i H $.
      $d i K $.  $d i N $.  $d i P $.  $d i R $.  $d i T $.  $d i W $.
      $d i G $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  TODO:  Eliminate and
         put into ~ cdlemksel .  (Contributed by NM, 25-Jun-2013.) $)
      cdlemki $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
         /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
            /\ ( R ` G ) =/= ( R ` F ) ) )
       -> I e. T ) $=
        ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp11 simp22
        co simp21 ltrnel syl3anc simp11l simp22l simpld hlatlej2 simp23 trljat1
        oveq2d eqtr2d breqtrd simp31 simp32 simp33 necomd eqid cdlemh syl133anc
        simp1 ltrniotacl ) LUFUGZPIUGZUHZGEUGZHEUGZUIZOEUGZCAUGZCPMUJUKZUHZGDUL
        ZODULZUMZUIZGUNBUOZUPZHWQUPZHDULZWMUPZUIZUIZWEWLCWTKVACOULZHGUQURDULKVA
        NVAZAUGXEPMUJUKUHZJEUGWEWFWGWPXBUSZWHWIWLWOXBUTZXCWHWLXDAUGZXDPMUJUKZUH
        ZXDCWMKVAZMUJWRWSWMWTUPXFWHWPXBWAXHXCWEWIWLXKXGWHWIWLWOXBVBZXHACEOILMPR
        TUAUBVCZVDXCXDCXDKVAZXLMXCWCWJXIXDXOMUJWCWDWFWGWPXBVEWJWKWIWOWHXBVFXCWE
        WIWLXIXGXMXHWEWIWLUIXIXJXNVGVDACXDKLMRSTVHVDXCXLCWNKVAZXOXCWMWNCKWHWIWL
        WOXBVIVKXCWEWIWLXPXOUMXGXMXHACDEOIKLMPRSTUAUBUCVJVDVLVMWHWPWRWSXAVNWHWP
        WRWSXAVOXCWTWMWHWPWRWSXAVPVQABCXDDXEEGHIKLMNPQRSUDTUAUBUCXEVRVSVTACXEEF
        JILMPRTUAUBUEWBVD $.
    $}

    ${
      cdlemk.v1 $e |- V = ( ( ( G ` P ) .\/ ( X ` P ) )
                  ./\ ( ( R ` ( G o. `' F ) )
                       .\/ ( R ` ( X o. `' F ) ) ) ) $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
         27-Jun-2013.) $)
      cdlemkvcl $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ G e. T /\ X e. T )
            /\ P e. A )
         -> V e. B ) $=
        ( chlt wcel wa w3a cfv co ccnv ccom clat simp1l hllat syl simp22 atbase
        simp1 3ad2ant3 ltrncl syl3anc simp23 latjcl simp21 ltrncnv ltrnco trlcl
        syl2anc latmcl syl5eqel ) JUEUFZNHUFZUGZFEUFZGEUFZOEUFZUHZCAUFZUHZMCGUI
        ZCOUIZIUJZGFUKZULZDUIZOWDULZDUIZIUJZLUJZBUDVTJUMUFZWCBUFZWIBUFZWJBUFVTV
        LWKVLVMVRVSUNJUOUPZVTWKWABUFZWBBUFZWLWNVTVNVPCBUFZWOVNVRVSUSZVNVOVPVQVS
        UQZVSVNWQVRABCJPSURUTZBEGHJUENCPTUAVAVBVTVNVQWQWPWRVNVOVPVQVSVCZWTBEOHJ
        UENCPTUAVAVBBIJWAWBPRVDVBVTWKWFBUFZWHBUFZWMWNVTVNWEEUFZXBWRVTVNVPWDEUFZ
        XDWRWSVTVNVOXEWRVNVOVPVQVSVEEFHJNTUAVFVIZEGWDHJNTUAVGVBBDEWEHJNPTUAUBVH
        VIVTVNWGEUFZXCWRVTVNVQXEXGWRXAXFEOWDHJNTUAVGVBBDEWGHJNPTUAUBVHVIBIJWFWH
        PRVDVBBJLWCWIPUCVJVBVK $.

      $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
         29-Jun-2013.) $)
      cdlemk10 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ G e. T /\ X e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> V .<_ ( R ` ( X o. `' G ) ) ) $=
        ( chlt wcel wa w3a wbr wn cfv co ccnv ccom simp1 simp22 ltrncnv syl2anc
        simp21 ltrnco syl3anc trlle simp23 clat simp1l hllat syl simp1r lhpbase
        wb trlcl latjle12 syl13anc mpbi2and wi latjcl simp3l ltrnat hlatjcl mpd
        latmlem2 wceq simp3 cdlemk9 syl221anc breqtrd syl5eqbr ) JUEUFZNHUFZUGZ
        FEUFZGEUFZOEUFZUHZCAUFZCNKUIUJZUGZUHZMCGUKZCOUKZIULZGFUMZUNZDUKZOXBUNZD
        UKZIULZLULZOGUMUNDUKZKUDWRXHXANLULZXIKWRXGNKUIZXHXJKUIZWRXDNKUIZXFNKUIZ
        XKWRWJXCEUFZXMWJWNWQUOZWRWJWLXBEUFZXOXPWJWKWLWMWQUPZWRWJWKXQXPWJWKWLWMW
        QUSEFHJNTUAUQURZEGXBHJNTUAUTVAZDEXCHJKNQTUAUBVBURWRWJXEEUFZXNXPWRWJWMXQ
        YAXPWJWKWLWMWQVCZXSEOXBHJNTUAUTVAZDEXEHJKNQTUAUBVBURWRJVDUFZXDBUFZXFBUF
        ZNBUFZXMXNUGXKVJWRWHYDWHWIWNWQVEZJVFVGZWRWJXOYEXPXTBDEXCHJNPTUAUBVKURZW
        RWJYAYFXPYCBDEXEHJNPTUAUBVKURZWRWIYGWHWIWNWQVHZBHJNPTVIVGZBIJKXDXFNPQRV
        LVMVNWRYDXGBUFZYGXABUFZXKXLVOYIWRYDYEYFYNYIYJYKBIJXDXFPRVPVAYMWRWHWSAUF
        ZWTAUFZYOYHWRWJWLWOYPXPXRWJWNWOWPVQZACEGHJKNQSTUAVRVAWRWJWMWOYQXPYBYRAC
        EOHJKNQSTUAVRVAABIJWSWTPRSVSVABJKLXGNXAPQUCWAVMVTWRWHWIWLWMWQXJXIWBYHYL
        XRYBWJWNWQWCABCDEGHIJKLNOPQRSTUAUBUCWDWEWFWG $.
    $}

    $d f ./\ $.  $d f .\/ $.  $d f F $.  $d f i G $.  $d f N $.  $d f P $.
    $d f R $.  $d f T $.  $d f W $.
    cdlemk.s $e |- S = ( f e. T |-> ( iota_ i e. T
        ( i ` P ) = ( ( P .\/ ( R ` f ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Value of the sigma(p)
       function.  (Contributed by NM, 26-Jun-2013.) $)
    cdlemksv $p |- ( G e. T -> ( S ` G ) = ( iota_ i e. T
        ( i ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) ) ) $=
      ( cv cfv ccnv ccom wceq crio fveq2 oveq2d fveq2d oveq12d eqeq2d riotabidv
      co coeq1 riotaex fvmpt ) GJCHUGUHZCGUGZDUHZLUSZCPUHZVDIUIZUJZDUHZLUSZOUSZ
      UKZHFULVCCJDUHZLUSZVGJVHUJZDUHZLUSZOUSZUKZHFULFEVDJUKZVMVTHFWAVLVSVCWAVFV
      OVKVROWAVEVNCLVDJDUMUNWAVJVQVGLWAVIVPDVDJVHUTUOUNUPUQURUFVTHFVAVB $.

    $d i ./\ $.  $d i .<_ $.  $d i .\/ $.  $d i A $.  $d i F $.  $d i H $.
    $d i K $.  $d i N $.  $d i P $.  $d i R $.  $d i T $.  $d i W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Conditions for the
       sigma(p) function to be a translation.  TODO: combine ~ cdlemki ?
       (Contributed by NM, 26-Jun-2013.) $)
    cdlemksel $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( R ` G ) =/= ( R ` F ) ) )
       -> ( S ` G ) e. T ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres cv co ccnv ccom crio cdlemksv
      wne simp13 syl eqid cdlemki eqeltrd ) MUGUHQKUHUIZIFUHZJFUHZUJPFUHCAUHCQN
      UKULUIIDUMZPDUMUNUJZIUOBUPZVCJVNVCJDUMZVLVCUJZUJZJEUMZCHUQUMCVOLURCPUMJIU
      SUTDUMLUROURUNHFVAZFVQVKVRVSUNVIVJVKVMVPVDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEU
      FVBVEABCDFHIJKVSLMNOPQRSTUAUBUCUDUEVSVFVGVH $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       27-Jun-2013.) $)
    cdlemksat $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( R ` G ) =/= ( R ` F ) ) )
       -> ( ( S ` G ) ` P ) e. A ) $=
      ( chlt wcel w3a wbr cfv wceq cid cres wne simp11 cdlemksel simp22l ltrnat
      wa wn syl3anc ) MUGUHQKUHUTZIFUHZJFUHZUIZPFUHZCAUHZCQNUJVAZUTIDUKZPDUKULZ
      UIZIUMBUNZUOJVMUOJDUKVJUOUIZUIVCJEUKZFUHVHCVOUKAUHVCVDVEVLVNUPABCDEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUQVHVIVGVKVFVNURACFVOKMNQSUAUBUCUSVB $.

    $d w ./\ $.  $d w .\/ $.  $d w F $.  $d w G $.  $d w N $.  $d w P $.
    $d w R $.  $d w S $.  $d w T $.  $d w W $.  $d w f $.  $d w i $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Value of the sigma(p)
       function ` S ` at the fixed ` P ` parameter.  (Contributed by NM,
       26-Jun-2013.) $)
    cdlemksv2 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B )
          /\ ( R ` G ) =/= ( R ` F ) ) )
        -> ( ( S ` G ) ` P )
                = ( ( P .\/ ( R ` G ) )
       ./\ ( ( N ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv ccom cv crio cdlemksv
      wne simp13 syl eqcomd wreu wb cdlemksel simp11 simp22 simp1 simp21 ltrnel
      syl3anc simp11l simp22l simpld simp23 oveq2d trljat1 eqtr2d simp31 simp32
      hlatlej2 breqtrd simp33 necomd eqid cdlemh syl133anc cdleme cmpt nfriota1
      nfcv nfmpt nfcxfr nffv nfeq1 fveq1 eqeq1d riota2f syl2anc mpbird ) MUGUHZ
      QKUHZUIZIFUHZJFUHZUJZPFUHZCAUHZCQNUKULZUIZIDUMZPDUMZUNZUJZIUOBUPZVCZJXSVC
      ZJDUMZXOVCZUJZUJZCJEUMZUMZCYBLUQCPUMZJIURZUSDUMLUQOUQZUNZCHUTZUMZYJUNZHFV
      AZYFUNZYEYFYOYEXIYFYOUNXGXHXIXRYDVDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFVBVEVF
      YEYFFUHYNHFVGZYKYPVHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFVIYEXGXNYJAUHYJQNUKUL
      UIZYQXGXHXIXRYDVJZXJXKXNXQYDVKZYEXJXNYHAUHZYHQNUKULZUIZYHCXOLUQZNUKXTYAXO
      YBVCYRXJXRYDVLYTYEXGXKXNUUCYSXJXKXNXQYDVMZYTACFPKMNQSUAUBUCVNVOZYEYHCYHLU
      QZUUDNYEXEXLUUAYHUUGNUKXEXFXHXIXRYDVPXLXMXKXQXJYDVQYEUUAUUBUUFVRACYHLMNST
      UAWEVOYEUUDCXPLUQZUUGYEXOXPCLXJXKXNXQYDVSVTYEXGXKXNUUHUUGUNYSUUEYTACDFPKL
      MNQSTUAUBUCUDWAVOWBWFXJXRXTYAYCWCXJXRXTYAYCWDYEYBXOXJXRXTYAYCWGWHABCYHDYJ
      FIJKLMNOQRSTUEUAUBUCUDYJWIWJWKACYJFHKMNQSUAUBUCWLVOYNYKHFYFHJEHEGFYMCGUTZ
      DUMLUQYHUUIYIUSDUMLUQOUQUNZHFVAZWMUFHGFUUKHFWOUUJHFWNWPWQHJWOWRZHYGYJHCYF
      UULHCWOWRWSYLYFUNYMYGYJCYLYFWTXAXBXCXD $.

    $d f i G $.  $d f i X $.
    ${
      cdlemk.v $e |- V = ( ( ( G ` P ) .\/ ( X ` P ) )
                  ./\ ( ( R ` ( G o. `' F ) )
                       .\/ ( R ` ( X o. `' F ) ) ) ) $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  Line 5, p. 119.
         (Contributed by NM, 27-Jun-2013.) $)
      cdlemk7 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
         /\ ( ( N e. T /\ X e. T )
            /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
         /\ ( ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ X =/= ( _I |` B ) )
            /\ ( R ` G ) =/= ( R ` F ) /\ ( R ` X ) =/= ( R ` F ) ) )
       -> ( ( S ` G ) ` P ) .<_ ( ( ( S ` X ) ` P ) .\/ V ) ) $=
        ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp1 simp311
        simp2 simp312 simp32 simp33 jca cdlemk6 syl113anc simp21l simp22 simp23
        co 3jca cdlemksv2 simp11 simp13 trljat1 syl3anc oveq1d eqtrd clat hllat
        simp11l syl simp12 simp21r simp313 cdlemksat atbase cdlemkvcl syl231anc
        simp11r simp22l latjcom a1i ltrnat hlatjcom trlcocnvat oveq12d 3brtr4d
        eqtr4d ) MUJUKZRKUKZULZIFUKZJFUKZUMZPFUKZSFUKZULZCAUKZCRNUNUOZULZIDUPZP
        DUPUQZUMZIURBUSZUTZJXTUTZSXTUTZUMZJDUPZXQUTZSDUPZXQUTZUMZUMZCCJUPZLVOZC
        PUPZJIVAZVBDUPZLVOZOVOZYKCSUPZLVOYOSYNVBDUPZLVOOVOZYRCLVOZYSYMLVOZOVOZL
        VOZCJEUPUPZCSEUPUPZQLVOZNYJXJXSYAYBYFYHULYQUUDNUNXJXSYIVCZXJXSYIVEYAYBY
        CYFYHXJXSVDZYAYBYCYFYHXJXSVFZYJYFYHXJXSYDYFYHVGZXJXSYDYFYHVHZVIABCDFIJK
        LMNOPRSTUAUBUCUDUEUFUGVJVKYJUUECYELVOZYPOVOZYQYJXJXKXPXRUMZYAYBYFUUEUUN
        UQUUHYJXKXPXRXKXLXPXRXJYIVLZXJXMXPXRYIVMZXJXMXPXRYIVNVPZUUIUUJUUKABCDEF
        GHIJKLMNOPRTUAUBUCUDUEUFUGUHVQVKYJUUMYLYPOYJXGXIXPUUMYLUQXGXHXIXSYIVRZX
        GXHXIXSYIVSZUUQACDFJKLMNRUAUBUCUDUEUFVTWAWBWCYJUUGQUUFLVOZUUDYJMWDUKZUU
        FBUKZQBUKZUUGUVAUQYJXEUVBXEXFXHXIXSYIWFZMWEWGYJUUFAUKZUVCYJXGXHXLUMZUUO
        YAYCYHUVFYJXGXHXLUUSXGXHXIXSYIWHZXKXLXPXRXJYIWIZVPZUURUUIYAYBYCYFYHXJXS
        WJZUULABCDEFGHISKLMNOPRTUAUBUCUDUEUFUGUHWKVKABUUFMTUCWLWGYJXEXFXHXIXLXN
        UVDUVEXEXFXHXIXSYIWOUVHUUTUVIXNXOXMXRXJYIWPZABCDFIJKLMNOQRSTUAUBUCUDUEU
        FUGUIWMWNBLMUUFQTUBWQWAYJQYTUUFUUCLQYTUQYJUIWRYJUUFCYGLVOZYMYSLVOZOVOZU
        UCYJUVGUUOYAYCYHUUFUVOUQUVJUURUUIUVKUULABCDEFGHISKLMNOPRTUAUBUCUDUEUFUG
        UHVQVKYJUVMUUAUVNUUBOYJUVMCYRLVOZUUAYJXGXLXPUVMUVPUQUUSUVIUUQACDFSKLMNR
        UAUBUCUDUEUFVTWAYJXEYRAUKZXNUUAUVPUQUVEYJXGXLXNUVQUUSUVIUVLACFSKMNRUAUC
        UDUEWSWAUVLALMYRCUBUCWTWAXDYJXEYMAUKZYSAUKZUVNUUBUQUVEYJXGXKXNUVRUUSUUP
        UVLACFPKMNRUAUCUDUEWSWAYJXGXLXHULYHUVSUUSYJXLXHUVIUVHVIUULADFSIKMRUCUDU
        EUFXAWAALMYMYSUBUCWTWAXBWCXBWCXC $.

      $( Part of proof of Lemma K of [Crawley] p. 118.  Eq. 3, line 8, p. 119.
         (Contributed by NM, 29-Jun-2013.) $)
      cdlemk11 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
         /\ ( ( N e. T /\ X e. T )
            /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
         /\ ( ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ X =/= ( _I |` B ) )
            /\ ( R ` G ) =/= ( R ` F ) /\ ( R ` X ) =/= ( R ` F ) ) )
       -> ( ( S ` G ) ` P )
              .<_ ( ( ( S ` X ) ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) $=
        ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne co ccnv ccom clat hllat
        simp11l simp1 simp21l simp22 simp23 simp311 simp312 cdlemksat syl133anc
        syl simp32 atbase simp11 simp12 simp21r simp313 simp33 syl333anc simp13
        simp11r simp22l cdlemkvcl syl231anc latjcl syl3anc ltrncnv ltrnco trlcl
        syl2anc cdlemk7 cdlemk10 wi latjlej2 syl13anc mpd lattrd ) MUJUKZRKUKZU
        LZIFUKZJFUKZUMZPFUKZSFUKZULZCAUKZCRNUNUOZULZIDUPZPDUPUQZUMZIURBUSZUTZJX
        QUTZSXQUTZUMZJDUPXNUTZSDUPXNUTZUMZUMZBMNCJEUPUPZCSEUPUPZQLVAZYGSJVBZVCZ
        DUPZLVAZTUAYEXBMVDUKZXBXCXEXFXPYDVFZMVEVOZYEYFAUKZYFBUKYEXGXHXMXOXRXSYB
        YPXGXPYDVGXHXIXMXOXGYDVHZXGXJXMXOYDVIZXGXJXMXOYDVJZXRXSXTYBYCXGXPVKZXRX
        SXTYBYCXGXPVLXGXPYAYBYCVPABCDEFGHIJKLMNOPRTUAUBUCUDUEUFUGUHVMVNABYFMTUC
        VQVOYEYMYGBUKZQBUKZYHBUKYOYEYGAUKZUUAYEXDXEXIXHXMXOXRXTYCUUCXDXEXFXPYDV
        RZXDXEXFXPYDVSZXHXIXMXOXGYDVTZYQYRYSYTXRXSXTYBYCXGXPWAXGXPYAYBYCWBABCDE
        FGHISKLMNOPRTUAUBUCUDUEUFUGUHVMWCABYGMTUCVQVOZYEXBXCXEXFXIXKUUBYNXBXCXE
        XFXPYDWEZUUEXDXEXFXPYDWDZUUFXKXLXJXOXGYDWFABCDFIJKLMNOQRSTUAUBUCUDUEUFU
        GUIWGWHZBLMYGQTUBWIWJYEYMUUAYKBUKZYLBUKYOUUGYEXDYJFUKZUUKUUDYEXDXIYIFUK
        ZUULUUDUUFYEXDXFUUMUUDUUIFJKMRUDUEWKWNFSYIKMRUDUEWLWJBDFYJKMRTUDUEUFWMW
        NZBLMYGYKTUBWIWJABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIWOYEQYKNUNZYHYLNU
        NZYEXBXCXEXFXIXMUUOYNUUHUUEUUIUUFYRABCDFIJKLMNOQRSTUAUBUCUDUEUFUGUIWPWH
        YEYMUUBUUKUUAUUOUUPWQYOUUJUUNUUGBLMNQYKYGTUAUBWRWSWTXA $.
    $}

    $( Part of proof of Lemma K of [Crawley] p. 118.  Eq. 4, line 10, p. 119.
       (Contributed by NM, 30-Jun-2013.) $)
    cdlemk12 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ G e. T )
       /\ ( ( N e. T /\ X e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ X =/= ( _I |` B ) )
          /\ ( ( R ` G ) =/= ( R ` F ) /\ ( R ` X ) =/= ( R ` F ) )
             /\ ( R ` G ) =/= ( R ` X ) ) )
     -> ( ( S ` G ) ` P ) = ( ( P .\/ ( G ` P ) )
           ./\ ( ( ( S ` X ) ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp11l simp22l
      co simp11 simp13 ltrnat syl3anc simp12 simp21r 3jca simp21l simp22 simp23
      simp311 simp313 simp32r cdlemksat syl113anc simp33 necomd syl121anc simp1
      trlcocnvat simp312 simp32l cdlemksv2 syl trlnidat hlatjcl latmle1 eqbrtrd
      clat hllat trljat1 breqtrd simp31 eqid cdlemk11 hlatlej2 cdlemksel ltrnel
      simp2 ltrncnv syl2anc trlcnv eqnetrd trlcone ltrncom fveq2d 3netr3d trlle
      syl122anc ltrnco lhp2atnle syl322anc nbrne1 2atm syl333anc ) MUHUIZQKUIZU
      JZIFUIZJFUIZUKZPFUIZRFUIZUJZCAUIZCQNULUMZUJZIDUNZPDUNUOZUKZIUPBUQZURZJYNU
      RZRYNURZUKZJDUNZYKURZRDUNZYKURZUJZYSUUAURZUKZUKZXSYHCJUNZAUIZCREUNZUNZAUI
      ZRJUSZUTZDUNZAUIZCJEUNUNZAUIZUUPCUUGLVCZNULUUPUUJUUNLVCZNULZUURUUSURZUUPU
      URUUSOVCUOXSXTYBYCYMUUEVAZYHYIYGYLYDUUEVBZUUFYAYCYHUUHYAYBYCYMUUEVDZYAYBY
      CYMUUEVEZUVCACFJKMNQTUBUCUDVFVGUUFYAYBYFUKZYEYJYLUKZYOYQUUBUUKUUFYAYBYFUV
      DYAYBYCYMUUEVHZYEYFYJYLYDUUEVIZVJZUUFYEYJYLYEYFYJYLYDUUEVKZYDYGYJYLUUEVLZ
      YDYGYJYLUUEVMVJZYOYPYQUUCUUDYDYMVNZYOYPYQUUCUUDYDYMVOZYTUUBYRUUDYDYMVPZAB
      CDEFGHIRKLMNOPQSTUAUBUCUDUEUFUGVQVRUUFYAYFYCUUAYSURUUOUVDUVIUVEUUFYSUUAYD
      YMYRUUCUUDVSZVTADFRJKMQUBUCUDUEWCWAZUUFYDUVGYOYPYTUUQYDYMUUEWBZUVMUVNYOYP
      YQUUCUUDYDYMWDZYTUUBYRUUDYDYMWEZABCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGVQVRUUFU
      UPCYSLVCZUURNUUFUUPUWBCPUNZJIUSZUTDUNZLVCZOVCZUWBNUUFYDUVGYOYPYTUUPUWGUOU
      VSUVMUVNUVTUWAABCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGWFVRUUFMWLUIZUWBBUIZUWFBUI
      ZUWGUWBNULUUFXSUWHUVBMWMWGUUFXSYHYSAUIZUWIUVBUVCUUFYAYCYPUWKUVDUVEUVTABDF
      JKMQSUBUCUDUEWHVGZABLMCYSSUAUBWIVGUUFXSUWCAUIZUWEAUIZUWJUVBUUFYAYEYHUWMUV
      DUVKUVCACFPKMNQTUBUCUDVFVGUUFYAYCYBYTUWNUVDUVEUVHUWAADFJIKMQUBUCUDUEWCWAA
      BLMUWCUWESUAUBWIVGBMNOUWBUWFSTUFWJVGWKUUFYAYCYJUWBUURUOUVDUVEUVLACDFJKLMN
      QTUAUBUCUDUEWNVGZWOUUFYDYMYRYTUUBUUTUVSYDYMUUEXBYDYMYRUUCUUDWPUWAUVPABCDE
      FGHIJKLMNOPUUGCRUNLVCUWERUWDUTDUNLVCOVCZQRSTUAUBUCUDUEUFUGUWPWQWRVRUUFYSU
      URNULYSUUSNULUMZUVAUUFYSUWBUURNUUFXSYHUWKYSUWBNULUVBUVCUWLACYSLMNTUAUBWSV
      GUWOWOUUFYAUUKUUJQNULUMUJZUUNYSURUUOUUNQNULZUWKYSQNULZUWQUVDUUFYAUUIFUIZY
      JUWRUVDUUFUVFUVGYOYQUUBUXAUVJUVMUVNUVOUVPABCDEFGHIRKLMNOPQSTUAUBUCUDUEUFU
      GWTVRUVLACFUUIKMNQTUBUCUDXAVGUUFUULRUTZDUNZUULDUNZUUNYSUUFUXDUXCUUFYAUULF
      UIZYFUXDUUAURYQUXDUXCURUVDUUFYAYCUXEUVDUVEFJKMQUCUDXCXDZUVIUUFUXDYSUUAUUF
      YAYCUXDYSUOUVDUVEDFJKMQUCUDUEXEXDZUVQXFUVOBDFUULRKMQSUCUDUEXGXLVTUUFUXBUU
      MDUUFYAUXEYFUXBUUMUOUVDUXFUVIFUULRKMQUCUDXHVGXIUXGXJUVRUUFYAUUMFUIZUWSUVD
      UUFYAYFUXEUXHUVDUVIUXFFRUULKMQUCUDXMVGDFUUMKMNQTUCUDUEXKXDUWLUUFYAYCUWTUV
      DUVEDFJKMNQTUCUDUEXKXDAUUJUUNKLMNYSQTUAUBUCXNXOYSUURUUSNXPXDACUUGUUJUUNUU
      PLMNOTUAUFUBXQXR $.
  $}

  ${
    cdlemk1.b $e |- B = ( Base ` K ) $.
    cdlemk1.l $e |- .<_ = ( le ` K ) $.
    cdlemk1.j $e |- .\/ = ( join ` K ) $.
    cdlemk1.m $e |- ./\ = ( meet ` K ) $.
    cdlemk1.a $e |- A = ( Atoms ` K ) $.
    cdlemk1.h $e |- H = ( LHyp ` K ) $.
    cdlemk1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk1.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemk1.s $e |- S = ( f e. T |-> ( iota_ i e. T
        ( i ` P ) = ( ( P .\/ ( R ` f ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
    cdlemk1.o $e |- O = ( S ` D ) $.
    $d f i ./\ $.  $d i .<_ $.  $d f i .\/ $.  $d i A $.  $d f i D $.
    $d f i F $.  $d i H $.  $d i K $.  $d f i N $.  $d f i P $.  $d f i R $.
    $d f i T $.  $d f i W $.
    $( Utility lemma.  (Contributed by NM, 2-Jul-2013.) $)
    cdlemkoatnle $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
        -> ( ( O ` P ) e. A /\ -. ( O ` P ) .<_ W ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne simp11 cdlemksel syl5eqel
      simp22 ltrnel syl3anc ) MUIUJRKUJUKZJGUJZCGUJZULZPGUJZDAUJDRNUMUNUKZJEUOZ
      PEUOUPZULZJUQBURZUSCVOUSCEUOVLUSULZULZVFQGUJVKDQUOZAUJVRRNUMUNUKVFVGVHVNV
      PUTVQQCFUOGUHABDEFGHIJCKLMNOPRSTUAUCUDUEUFUBUGVAVBVIVJVKVMVPVCADGQKMNRTUC
      UDUEVDVE $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 13 on p. 119.
       ` O ` , ` D ` are k_1, f_1.  (Contributed by NM, 1-Jul-2013.) $)
    cdlemk13 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( O ` P ) = ( ( P .\/ ( R ` D ) )
       ./\ ( ( N ` P ) .\/ ( R ` ( D o. `' F ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv ccom fveq1i cdlemksv2
      wne syl5eq ) MUIUJRKUJUKJGUJCGUJULPGUJDAUJDRNUMUNUKJEUOZPEUOUPULJUQBURZVD
      CVGVDCEUOZVFVDULULDQUODCFUOZUODVHLUSDPUOCJUTVAEUOLUSOUSDQVIUHVBABDEFGHIJC
      KLMNOPRSTUAUCUDUEUFUBUGVCVE $.

    $( Utility lemma.  (Contributed by NM, 2-Jul-2013.) $)
    cdlemkole $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
     -> ( O ` P ) .<_ ( P .\/ ( R ` D ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv ccom cdlemk13 simp11l
      wne clat syl simp22l simp11 simp13 simp32 trlnidat syl3anc hlatjcl simp21
      hllat ltrnat simp12 simp33 trlcocnvat syl121anc latmle1 eqbrtrd ) MUIUJZR
      KUJZUKZJGUJZCGUJZULZPGUJZDAUJZDRNUMUNZUKZJEUOZPEUOUPZULZJUQBURZVDZCWPVDZC
      EUOZWMVDZULZULZDQUODWSLUSZDPUOZCJUTVAEUOZLUSZOUSZXCNABCDEFGHIJKLMNOPQRSTU
      AUBUCUDUEUFUGUHVBXBMVEUJZXCBUJZXFBUJZXGXCNUMXBWCXHWCWDWFWGWOXAVCZMVOVFXBW
      CWJWSAUJZXIXKWJWKWIWNWHXAVGZXBWEWGWRXLWEWFWGWOXAVHZWEWFWGWOXAVIZWHWOWQWRW
      TVJABEGCKMRSUCUDUEUFVKVLABLMDWSSUAUCVMVLXBWCXDAUJZXEAUJZXJXKXBWEWIWJXPXNW
      HWIWLWNXAVNXMADGPKMNRTUCUDUEVPVLXBWEWGWFWTXQXNXOWEWFWGWOXAVQWHWOWQWRWTVRA
      EGCJKMRUCUDUEUFVSVTABLMXDXESUAUCVMVLBMNOXCXFSTUBWAVLWB $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 19 on p. 119.
       ` O ` , ` D ` are k_1, f_1.  (Contributed by NM, 1-Jul-2013.) $)
    cdlemk14 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( N ` P ) .<_ ( ( O ` P ) .\/ ( R ` ( F o. `' D ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres ccnv ccom co cdlemk13 simp11l
      wne clat syl simp22l simp11 simp13 simp32 trlnidat syl3anc hlatjcl simp21
      hllat ltrnat simp12 simp33 trlcocnvat syl121anc latmle2 eqbrtrd wi fveq1i
      cdlemksat syl5eqel ltrncnv ltrnco trlle cdlemkoatnle simprd nbrne2 necomd
      syl2anc hlatexch2 syl131anc mpd trlcocnv oveq2d breqtrd ) MUIUJZRKUJZUKZJ
      GUJZCGUJZULZPGUJZDAUJZDRNUMUNZUKZJEUOZPEUOUPZULZJUQBURZVDZCXNVDZCEUOZXKVD
      ZULZULZDPUOZDQUOZCJUSZUTZEUOZLVAZYBJCUSUTEUOZLVANXTYBYAYELVAZNUMZYAYFNUMZ
      XTYBDXQLVAZYHOVAZYHNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHVBXTMVEUJZYKBUJZY
      HBUJZYLYHNUMXTXAYMXAXBXDXEXMXSVCZMVOVFXTXAXHXQAUJZYNYPXHXIXGXLXFXSVGZXTXC
      XEXPYQXCXDXEXMXSVHZXCXDXEXMXSVIZXFXMXOXPXRVJABEGCKMRSUCUDUEUFVKVLABLMDXQS
      UAUCVMVLXTXAYAAUJZYEAUJZYOYPXTXCXGXHUUAYSXFXGXJXLXSVNYRADGPKMNRTUCUDUEVPV
      LZXTXCXEXDXRUUBYSYTXCXDXEXMXSVQZXFXMXOXPXRVRAEGCJKMRUCUDUEUFVSVTZABLMYAYE
      SUAUCVMVLBMNOYKYHSTUBWAVLWBXTXAYBAUJZUUAUUBYBYEVDYIYJWCYPXTYBDCFUOZUOADQU
      UGUHWDABDEFGHIJCKLMNOPRSTUAUCUDUEUFUBUGWEWFUUCUUEXTYEYBXTYERNUMZYBRNUMUNZ
      YEYBVDXTXCYDGUJZUUHYSXTXCXEYCGUJZUUJYSYTXTXCXDUUKYSUUDGJKMRUDUEWGWNGCYCKM
      RUDUEWHVLEGYDKMNRTUDUEUFWIWNXTUUFUUIABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHW
      JWKYEYBRNWLWNWMAYBYAYELMNTUAUCWOWPWQXTYEYGYBLXTXCXEXDYEYGUPYSYTUUDEGCJKMR
      UDUEUFWRVLWSWT $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 21 on p. 119.
       ` O ` , ` D ` are k_1, f_1.  (Contributed by NM, 1-Jul-2013.) $)
    cdlemk15 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( N ` P )
  .<_ ( ( P .\/ ( R ` F ) )
     ./\ ( ( O ` P ) .\/ ( R ` ( F o. `' D ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp11l simp22l
      simp11 simp21 ltrnat syl3anc hlatlej2 simp23 oveq2d simp22 trljat1 eqtr2d
      co breqtrd cdlemk14 clat wb hllat syl atbase simp12 simp31 hlatjcl fveq1i
      trlnidat cdlemksat syl5eqel simp13 trlcocnvat syl121anc latlem12 syl13anc
      simp33 necomd mpbi2and ) MUIUJZRKUJZUKZJGUJZCGUJZULZPGUJZDAUJZDRNUMUNZUKZ
      JEUOZPEUOZUPZULZJUQBURZUSZCXKUSZCEUOZXGUSZULZULZDPUOZDXGLVNZNUMZXRDQUOZJC
      UTVAEUOZLVNZNUMZXRXSYCOVNNUMZXQXRDXRLVNZXSNXQWQXDXRAUJZXRYFNUMWQWRWTXAXJX
      PVBZXDXEXCXIXBXPVCZXQWSXCXDYGWSWTXAXJXPVDZXBXCXFXIXPVEZYIADGPKMNRTUCUDUEV
      FVGZADXRLMNTUAUCVHVGXQXSDXHLVNZYFXQXGXHDLXBXCXFXIXPVIVJXQWSXCXFYMYFUPYJYK
      XBXCXFXIXPVKADEGPKLMNRTUAUCUDUEUFVLVGVMVOABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUF
      UGUHVPXQMVQUJZXRBUJZXSBUJZYCBUJZXTYDUKYEVRXQWQYNYHMVSVTXQYGYOYLABXRMSUCWA
      VTXQWQXDXGAUJZYPYHYIXQWSWTXLYRYJWSWTXAXJXPWBZXBXJXLXMXOWCABEGJKMRSUCUDUEU
      FWFVGABLMDXGSUAUCWDVGXQWQYAAUJYBAUJZYQYHXQYADCFUOZUOADQUUAUHWEABDEFGHIJCK
      LMNOPRSTUAUCUDUEUFUBUGWGWHXQWSWTXAXGXNUSYTYJYSWSWTXAXJXPWIXQXNXGXBXJXLXMX
      OWNWOAEGJCKMRUCUDUEUFWJWKABLMYAYBSUAUCWDVGBMNOXRXSYCSTUBWLWMWP $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       3-Jul-2013.) $)
    cdlemk16a $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( ( ( P .\/ ( R ` G ) )
          ./\ ( ( O ` P ) .\/ ( R ` ( G o. `' D ) ) ) ) e. A
      /\ -. ( ( P .\/ ( R ` G ) )
          ./\ ( ( O ` P ) .\/ ( R ` ( G o. `' D ) ) ) ) .<_ W ) ) $=
      ( chlt wcel wa cfv wceq w3a wne cid cres wbr wn ccnv simp11 simp22 simp13
      ccom simp33 simp21 simp23 simp12 simp321 cdlemkoatnle syl333anc cdlemkole
      co simp323 simp31l simp322 simp31r eqid cdlemh ) NUJUKSLUKULZJEUMZQEUMUNZ
      KGUKZUOZJGUKZCGUKZQGUKZUOZCEUMZWBUPZWJKEUMZUPZULZJUQBURZUPZKWOUPZCWOUPZUO
      ZDAUKDSOUSUTULZUOZUOZWAWGWDWTDRUMZAUKXCSOUSUTULZXCDWJMVNOUSZWRWQWMDWLMVNX
      CKCVAVEEUMMVNPVNZAUKXFSOUSUTULWAWCWDWIXAVBZWEWFWGWHXAVCZWAWCWDWIXAVDWEWIW
      NWSWTVFZXBWAWFWGWHWTWCWPWRWKXDXGWEWFWGWHXAVGZXHWEWFWGWHXAVHZXIWAWCWDWIXAV
      IZWPWQWRWNWTWEWIVJZWPWQWRWNWTWEWIVOZWKWMWSWTWEWIVPZABCDEFGHIJLMNOPQRSTUAU
      BUCUDUEUFUGUHUIVKVLXBWAWFWGWHWTWCWPWRWKXEXGXJXHXKXIXLXMXNXOABCDEFGHIJLMNO
      PQRSTUAUBUCUDUEUFUGUHUIVMVLXNWPWQWRWNWTWEWIVQWKWMWSWTWEWIVRABDXCEXFGCKLMN
      OPSTUAUBUCUDUEUFUGXFVSVTVL $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       1-Jul-2013.) $)
    cdlemk16 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( ( ( P .\/ ( R ` F ) )
          ./\ ( ( O ` P ) .\/ ( R ` ( F o. `' D ) ) ) ) e. A
      /\ -. ( ( P .\/ ( R ` F ) )
          ./\ ( ( O ` P ) .\/ ( R ` ( F o. `' D ) ) ) ) .<_ W ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv simp11 simp23 simp12
      co ccom simp13 simp21 simp33 jca simp31 simp32 simp22 cdlemk16a syl333anc
      3jca ) MUIUJRKUJUKZJGUJZCGUJZULZPGUJZDAUJDRNUMUNUKZJEUOZPEUOUPZULZJUQBURZ
      USZCWEUSZCEUOWBUSZULZULZVPWCVQVQVRVTWHWHUKWFWFWGULWADWBLVDDQUOJCUTVEEUOLV
      DOVDZAUJWKRNUMUNUKVPVQVRWDWIVAVSVTWAWCWIVBVPVQVRWDWIVCZWLVPVQVRWDWIVFVSVT
      WAWCWIVGWJWHWHVSWDWFWGWHVHZWMVIWJWFWFWGVSWDWFWGWHVJZWNVSWDWFWGWHVKVOVSVTW
      AWCWIVLABCDEFGHIJJKLMNOPQRSTUAUBUCUDUEUFUGUHVMVN $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 21 on p. 119.
       ` O ` , ` D ` are k_1, f_1.  (Contributed by NM, 1-Jul-2013.) $)
    cdlemk17 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( N ` P ) = ( ( P .\/ ( R ` F ) )
           ./\ ( ( O ` P ) .\/ ( R ` ( F o. `' D ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne co ccnv ccom cdlemk15 cal
      wb simp11l hlatl syl simp11 simp21 simp22l ltrnat syl3anc cdlemk16 simpld
      atcmp mpbid ) MUIUJZRKUJZUKZJGUJZCGUJZULZPGUJZDAUJZDRNUMUNZUKZJEUOZPEUOUP
      ZULZJUQBURZUSCWKUSCEUOWHUSULZULZDPUOZDWHLUTDQUOJCVAVBEUOLUTOUTZNUMZWNWOUP
      ZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHVCWMMVDUJZWNAUJZWOAUJZWPWQVEWMVRWRVR
      VSWAWBWJWLVFMVGVHWMVTWDWEWSVTWAWBWJWLVIWCWDWGWIWLVJWEWFWDWIWCWLVKADGPKMNR
      TUCUDUEVLVMWMWTWORNUMUNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHVNVOAWNWOMNTUC
      VPVMVQ $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       3-Jul-2013.) $)
    cdlemk1u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
  -> ( P .\/ ( O ` P ) ) .<_ ( ( D ` P ) .\/ ( R ` D ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne co simp11l simp22l simp11
      simp13 simp32 trlnidat syl3anc hlatlej1 cdlemkole clat hllat cdlemkoatnle
      wb syl atbase simpld hlatjcl latjle12 syl13anc mpbi2and trljat3 breqtrd
      simp22 ) MUIUJZRKUJZUKZJGUJZCGUJZULZPGUJZDAUJZDRNUMUNZUKZJEUOZPEUOUPZULZJ
      UQBURZUSZCWQUSZCEUOZWNUSZULZULZDDQUOZLUTZDWTLUTZDCUOWTLUTZNXCDXFNUMZXDXFN
      UMZXEXFNUMZXCWDWKWTAUJZXHWDWEWGWHWPXBVAZWKWLWJWOWIXBVBZXCWFWHWSXKWFWGWHWP
      XBVCZWFWGWHWPXBVDZWIWPWRWSXAVEABEGCKMRSUCUDUEUFVFVGZADWTLMNTUAUCVHVGABCDE
      FGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHVIXCMVJUJZDBUJZXDBUJZXFBUJZXHXIUKXJVMXCWDX
      QXLMVKVNXCWKXRXMABDMSUCVOVNXCXDAUJZXSXCYAXDRNUMUNABCDEFGHIJKLMNOPQRSTUAUB
      UCUDUEUFUGUHVLVPABXDMSUCVOVNXCWDWKXKXTXLXMXPABLMDWTSUAUCVQVGBLMNDXDXFSTUA
      VRVSVTXCWFWHWMXFXGUPXNXOWIWJWMWOXBWCADEGCKLMNRTUAUCUDUEUFWAVGWB $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       3-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk5auN $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( D e. T /\ G e. T /\ X e. T )
        /\ ( ( R ` G ) =/= ( R ` D )
          /\ ( D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( P e. A /\ -. P .<_ W ) ) )
  -> ( ( ( D ` P ) .\/ ( R ` D ) )
             ./\ ( ( D ` P ) .\/ ( R ` ( G o. `' D ) ) ) )
        .<_ ( ( X ` P ) .\/ ( R ` ( X o. `' D ) ) ) ) $=
      ( cdlemk5a ) ABDEGCKLMNOPSTUAUBUCUEUFUGUHUDUK $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       4-Jul-2013.) $)
    cdlemk5u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ G e. T /\ X e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( ( R ` D ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` D )
             /\ ( R ` X ) =/= ( R ` D ) ) ) )
  -> ( ( P .\/ ( O ` P ) )
             ./\ ( ( G ` P ) .\/ ( R ` ( G o. `' D ) ) ) )
        .<_ ( ( X ` P ) .\/ ( R ` ( X o. `' D ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne co ccnv ccom clat simp11l
      hllat syl simp22l simp211 simp22 simp23 3jca simp3l1 simp3l2 cdlemkoatnle
      simp1 simp3r1 simpld syl3anc hlatjcl simp11 simp212 ltrnat simp13 simp3r2
      trlcocnvat syl121anc latmcl trlnidat simp213 simp3r3 cdlemk1u wi latmlem1
      syl13anc mpd simp11r cdlemk2 syl221anc breqtrd simp3l3 cdlemk5a syl233anc
      oveq2d jca lattrd ) NUKULZSLULZUMZJGULZCGULZUNZQGULZKGULZTGULZUNZDAULZDSO
      UOUPZUMZJEUQZQEUQURZUNZJUSBUTZVAZCYDVAZKYDVAZUNZCEUQZYAVAZKEUQYIVAZTEUQYI
      VAZUNZUMZUNZBNODDRUQZMVBZDKUQZKCVCZVDEUQZMVBZPVBZDCUQZYIMVBZUUCYTMVBZPVBZ
      DTUQZTYSVDEUQZMVBZUAUBYOXHNVEULZXHXIXKXLYCYNVFZNVGVHZYOUUJYQBULZUUABULZUU
      BBULUULYOXHXRYPAULZUUMUUKXRXSXQYBXMYNVIZYOXMXNXTYBUNZYEYFYJUNZUUOXMYCYNVQ
      ZYOXNXTYBXNXOXPXTYBXMYNVJXMXQXTYBYNVKZXMXQXTYBYNVLVMZYOYEYFYJYEYFYGYMXMYC
      VNYEYFYGYMXMYCVOZYJYKYLYHXMYCVRVMZXMUUQUURUNUUOYPSOUOUPABCDEFGHIJLMNOPQRS
      UAUBUCUDUEUFUGUHUIUJVPVSVTABMNDYPUAUCUEWAVTZYOXHYRAULZYTAULZUUNUUKYOXJXOX
      RUVEXJXKXLYCYNWBZXNXOXPXTYBXMYNWCZUUPADGKLNOSUBUEUFUGWDVTYOXJXOXLYKUVFUVG
      UVHXJXKXLYCYNWEZYJYKYLYHXMYCWFZAEGKCLNSUEUFUGUHWGWHZABMNYRYTUAUCUEWAVTZBN
      PYQUUAUAUDWIVTYOUUJUUDBULZUUEBULZUUFBULUULYOXHUUCAULZYIAULZUVMUUKYOXJXLXR
      UVOUVGUVIUUPADGCLNOSUBUEUFUGWDVTZYOXJXLYFUVPUVGUVIUVBABEGCLNSUAUEUFUGUHWJ
      VTABMNUUCYIUAUCUEWAVTZYOXHUVOUVFUVNUUKUVQUVKABMNUUCYTUAUCUEWAVTBNPUUDUUEU
      AUDWIVTYOXHUUGAULZUUHAULZUUIBULUUKYOXJXPXRUVSUVGXNXOXPXTYBXMYNWKZUUPADGTL
      NOSUBUEUFUGWDVTYOXJXPXLYLUVTUVGUWAUVIYJYKYLYHXMYCWLAEGTCLNSUEUFUGUHWGWHAB
      MNUUGUUHUAUCUEWAVTYOUUBUUDUUAPVBZUUFOYOYQUUDOUOZUUBUWBOUOZYOXMUUQUURUWCUU
      SUVAUVCABCDEFGHIJLMNOPQRSUAUBUCUDUEUFUGUHUIUJWMVTYOUUJUUMUVMUUNUWCUWDWNUU
      LUVDUVRUVLBNOPYQUUDUUAUAUBUDWOWPWQYOUUAUUEUUDPYOXHXIXLXOXTUUAUUEURUUKXHXI
      XKXLYCYNWRZUVIUVHUUTABDEGCKLMNOSUAUBUCUEUFUGUHWSWTXEXAYOXHXIXLXOXPYKYFYGU
      MXTUUFUUIOUOUUKUWEUVIUVHUWAUVJYOYFYGUVBYEYFYGYMXMYCXBXFUUTABDEGCKLMNOPSTU
      AUBUCUEUFUGUHUDXCXDXG $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Apply ~ dalaw .
       (Contributed by NM, 4-Jul-2013.) $)
    cdlemk6u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ G e. T /\ X e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( ( R ` D ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` D )
             /\ ( R ` X ) =/= ( R ` D ) ) ) )
       -> ( ( P .\/ ( G ` P ) )
              ./\ ( ( O ` P ) .\/ ( R ` ( G o. `' D ) ) ) )
        .<_ ( ( ( ( G ` P ) .\/ ( X ` P ) )
                ./\ ( ( R ` ( G o. `' D ) )
                     .\/ ( R ` ( X o. `' D ) ) ) )
             .\/ ( ( ( X ` P ) .\/ P )
                ./\ ( ( R ` ( X o. `' D ) )
                     .\/ ( O ` P ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv ccom cdlemk5u simp11l
      wne wi simp22l simp11 simp212 ltrnat syl3anc simp213 simp1 simp211 simp22
      simp23 simp3l1 simp3l2 simp3r1 simpld syl133anc simp13 simp3r2 trlcocnvat
      cdlemkoatnle syl121anc simp3r3 dalaw mpd ) NUKULZSLULZUMZJGULZCGULZUNZQGU
      LZKGULZTGULZUNZDAULZDSOUOUPZUMZJEUQZQEUQURZUNZJUSBUTZVFZCXGVFZKXGVFZUNZCE
      UQZXDVFZKEUQXLVFZTEUQXLVFZUNZUMZUNZDDRUQZMVADKUQZKCVBZVCEUQZMVAPVADTUQZTY
      AVCEUQZMVAOUOZDXTMVAXSYBMVAPVAXTYCMVAYBYDMVAPVAYCDMVAYDXSMVAPVAMVAOUOZABC
      DEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVDXRWKXAXTAULZYCAULZXSAULZYBAULZYDAU
      LZYEYFVGWKWLWNWOXFXQVEXAXBWTXEWPXQVHZXRWMWRXAYGWMWNWOXFXQVIZWQWRWSXCXEWPX
      QVJZYLADGKLNOSUBUEUFUGVKVLXRWMWSXAYHYMWQWRWSXCXEWPXQVMZYLADGTLNOSUBUEUFUG
      VKVLXRWPWQXCXEXHXIXMYIWPXFXQVNWQWRWSXCXEWPXQVOWPWTXCXEXQVPWPWTXCXEXQVQXHX
      IXJXPWPXFVRXHXIXJXPWPXFVSXMXNXOXKWPXFVTWPWQXCXEUNXHXIXMUNUNYIXSSOUOUPABCD
      EFGHIJLMNOPQRSUAUBUCUDUEUFUGUHUIUJWFWAWBXRWMWRWOXNYJYMYNWMWNWOXFXQWCZXMXN
      XOXKWPXFWDAEGKCLNSUEUFUGUHWEWGXRWMWSWOXOYKYMYOYPXMXNXOXKWPXFWHAEGTCLNSUEU
      FUGUHWEWGADXTYCXSYBYDMNOPUBUCUDUEWIWBWJ $.

    ${
      cdlemk.z $e |- Z = ( iota_ j e. T
        ( j ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( O ` P ) .\/ ( R ` ( G o. `' D ) ) ) ) ) $.

      $d j ./\ $.  $d j .<_ $.  $d j .\/ $.  $d j A $.  $d j D $.  $d j F $.
      $d j H $.  $d j K $.  $d j N $.  $d j O $.  $d j P $.  $d j R $.
      $d j T $.  $d j W $.  $d j G $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
         2-Jul-2013.) $)
      cdlemkj $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> Z e. T ) $=
        ( chlt wcel wa cfv wceq w3a wne cid cres wbr wn co ccnv simp11l simp11r
        ccom simp33 cdlemk16a ltrniotacl syl211anc ) OUMUNZTMUNZUOKEUPZREUPUQZL
        GUNZURZKGUNCGUNRGUNURZCEUPZVOUSVTLEUPZUSUOZKUTBVAZUSLWCUSCWCUSURZDAUNDT
        PVBVCUOZURZURVMVNWEDWANVDDSUPLCVEVHEUPNVDQVDZAUNWGTPVBVCUOUAGUNVMVNVPVQ
        VSWFVFVMVNVPVQVSWFVGVRVSWBWDWEVIABCDEFGHIKLMNOPQRSTUBUCUDUEUFUGUHUIUJUK
        VJADWGGJUAMOPTUCUFUGUHULVKVL $.
    $}

    cdlemk1.u $e |- U = ( e e. T |-> ( iota_ j e. T
        ( j ` P ) = ( ( P .\/ ( R ` e ) )
              ./\ ( ( O ` P ) .\/ ( R ` ( e o. `' D ) ) ) ) ) ) $.
    $d e ./\ $.  $d e .\/ $.  $d e D $.  $d e j G $.  $d e O $.  $d e P $.
    $d e R $.  $d e T $.  $d e W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Value of the sigma_1 (p)
       function ` U ` .  (Contributed by NM, 2-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkuvN $p |- ( G e. T -> ( U ` G ) = ( iota_ j e. T
        ( j ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( O ` P ) .\/ ( R ` ( G o. `' D ) ) ) ) ) ) $=
      ( cdlemksv ) ABDEHGILCNOPQRSUAUBUCUDUEUGUHUIUJUFUMUN $.

    $d j ./\ $.  $d j .<_ $.  $d j .\/ $.  $d j A $.  $d j D $.  $d j F $.
    $d j H $.  $d j K $.  $d j N $.  $d j O $.  $d j P $.  $d j R $.  $d j T $.
    $d j W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Conditions for the
       sigma_1 (p) function to be a translation.  TODO: combine ~ cdlemkj ?
       (Contributed by NM, 2-Jul-2013.) $)
    cdlemkuel $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( U ` G ) e. T ) $=
      ( chlt wcel wa cfv wceq w3a wne cid cres wn cv co ccnv ccom crio cdlemksv
      wbr simp13 syl eqid cdlemkj eqeltrd ) QUNUOUBOUOUPZMEUQZTEUQURZNGUOZUSMGU
      OCGUOTGUOUSZCEUQZVQUTWANEUQZUTUPMVABVBZUTNWCUTCWCUTUSDAUODUBRVJVCUPUSZUSZ
      NHUQZDLVDUQDWBPVEDUAUQNCVFVGEUQPVESVEURLGVHZGWEVSWFWGURVPVRVSVTWDVKABDEHG
      ILCNOPQRSUAUBUCUDUEUGUHUIUJUFUMVIVLABCDEFGJKLMNOPQRSTUAUBWGUCUDUEUFUGUHUI
      UJUKULWGVMVNVO $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       4-Jul-2013.) $)
    cdlemkuat $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( ( U ` G ) ` P ) e. A ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wbr simp11 cdlemkuel simp33l ltrnat
      wa wn syl3anc ) QUNUOUBOUOVGZMEUPZTEUPUQZNGUOZURZMGUOCGUOTGUOURZCEUPZVKUS
      VPNEUPUSVGZMUTBVAZUSNVRUSCVRUSURZDAUOZDUBRVBVHZVGURZURVJNHUPZGUOVTDWCUPAU
      OVJVLVMVOWBVCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVDVTWAVQVSVNVO
      VEADGWCOQRUBUDUGUHUIVFVI $.

    $d w ./\ $.  $d w .\/ $.  $d w D $.  $d w G $.  $d w O $.  $d w P $.
    $d w R $.  $d w T $.  $d w U $.  $d w W $.  $d w e j $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 16 on p. 119 for i =
       1, where sigma_1 (p) is ` U ` , f_1 is ` D ` , and k_1 is ` O ` .
       (Contributed by NM, 2-Jul-2013.) $)
    cdlemkuv2 $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
 -> ( ( U ` G ) ` P ) = ( ( P .\/ ( R ` G ) )
       ./\ ( ( O ` P ) .\/ ( R ` ( G o. `' D ) ) ) ) ) $=
      ( chlt wcel wa cfv wceq w3a wne cid cres wn co ccnv ccom cv crio cdlemksv
      wbr simp13 eqcomd wb cdlemkuel simp11l simp11r simp33 cdlemk16a syl211anc
      syl wreu cdleme cmpt nfcv nfriota1 nfmpt nfcxfr nffv nfeq1 eqeq1d riota2f
      fveq1 syl2anc mpbird ) QUNUOZUBOUOZUPZMEUQZTEUQURZNGUOZUSZMGUOCGUOTGUOUSZ
      CEUQZWRUTXCNEUQZUTUPZMVABVBZUTNXFUTCXFUTUSZDAUODUBRVJVCUPZUSZUSZDNHUQZUQZ
      DXDPVDDUAUQZNCVEZVFEUQPVDSVDZURZDLVGZUQZXOURZLGVHZXKURZXJXKXTXJWTXKXTURWQ
      WSWTXBXIVKABDEHGILCNOPQRSUAUBUCUDUEUGUHUIUJUFUMVIVTVLXJXKGUOXSLGWAZXPYAVM
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVNXJWOWPXHXOAUOXOUBRVJVCUPY
      BWOWPWSWTXBXIVOWOWPWSWTXBXIVPXAXBXEXGXHVQABCDEFGJKMNOPQRSTUAUBUCUDUEUFUGU
      HUIUJUKULVRADXOGLOQRUBUDUGUHUIWBVSXSXPLGXKLNHLHIGXRDIVGZEUQPVDXMYCXNVFEUQ
      PVDSVDURZLGVHZWCUMLIGYELGWDYDLGWEWFWGLNWDWHZLXLXOLDXKYFLDWDWHWIXQXKURXRXL
      XODXQXKWLWJWKWMWN $.

    $d d e F $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22 on p. 119.
       ` N ` , ` U ` , ` O ` , ` D ` are k, sigma_1 (p), k_1, f_1.
       (Contributed by NM, 2-Jul-2013.) $)
    cdlemk18 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( N ` P ) = ( ( U ` F ) ` P ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom cdlemk17 simp11
      co simp23 simp12 simp13 simp21 simp33 simp31 simp32 3jca simp22 cdlemkuv2
      jca syl333anc eqtr4d ) PUMUNUANUNUOZMGUNZCGUNZUPZSGUNZDAUNDUAQUQURUOZMEUS
      ZSEUSUTZUPZMVABVBZVCZCWKVCZCEUSWHVCZUPZUPZDSUSDWHOVHDTUSMCVDVEEUSOVHRVHZD
      MHUSUSZABCDEFGJKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVFWPWBWIWCWCWDWFWNWNUOWLWLW
      MUPWGWRWQUTWBWCWDWJWOVGWEWFWGWIWOVIWBWCWDWJWOVJZWSWBWCWDWJWOVKWEWFWGWIWOV
      LWPWNWNWEWJWLWMWNVMZWTVSWPWLWLWMWEWJWLWMWNVNZXAWEWJWLWMWNVOVPWEWFWGWIWOVQ
      ABCDEFGHIJKLMMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVRVTWA $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22 on p. 119.
       ` N ` , ` U ` , ` O ` , ` D ` are k, sigma_1 (p), k_1, f_1.
       (Contributed by NM, 2-Jul-2013.) $)
    cdlemk19 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B )
          /\ ( R ` D ) =/= ( R ` F ) ) )
      -> ( U ` F ) = N ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid simp11 simp21 simp23 simp12 simp13
      cres simp33 simp31 simp32 3jca simp22 cdlemkuel syl333anc cdlemk18 cdlemd
      wne jca syl311anc eqcomd ) PUMUNUANUNUOZMGUNZCGUNZUPZSGUNZDAUNDUAQUQURUOZ
      MEUSZSEUSUTZUPZMVABVGZVQZCWJVQZCEUSWGVQZUPZUPZSMHUSZWOWAWEWPGUNZWFDSUSDWP
      USUTSWPUTWAWBWCWIWNVBZWDWEWFWHWNVCZWOWAWHWBWBWCWEWMWMUOWKWKWLUPWFWQWRWDWE
      WFWHWNVDWAWBWCWIWNVEZWTWAWBWCWIWNVFWSWOWMWMWDWIWKWLWMVHZXAVRWOWKWKWLWDWIW
      KWLWMVIZXBWDWIWKWLWMVJVKWDWEWFWHWNVLZABCDEFGHIJKLMMNOPQRSTUAUBUCUDUEUFUGU
      HUIUJUKULVMVNXCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVOADGSWPNPQUAU
      CUFUGUHVPVSVT $.

    $d e j G $.  $d e j X $.
    ${
      cdlemk1.v $e |- V = ( ( ( G ` P ) .\/ ( X ` P ) )
                  ./\ ( ( R ` ( G o. `' D ) )
                       .\/ ( R ` ( X o. `' D ) ) ) ) $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  Line 5, p. 119 for the
         sigma_1 case.  (Contributed by NM, 3-Jul-2013.) $)
      cdlemk7u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
         /\ ( ( N e. T /\ G e. T /\ X e. T )
            /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
         /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
            /\ X =/= ( _I |` B )
            /\ ( ( R ` D ) =/= ( R ` F )
               /\ ( R ` G ) =/= ( R ` D )
               /\ ( R ` X ) =/= ( R ` D ) ) ) )
       -> ( ( U ` G ) ` P ) .<_ ( ( ( U ` X ) ` P ) .\/ V ) ) $=
        ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp31 simp33
        jca cdlemk6u syld3an3 simp11l simp11r simp23 simp212 simp12 simp13 3jca
        simp211 simp331 simp332 necomd simp311 simp313 simp312 simp22 cdlemkuv2
        co syl313anc trljat1 syl3anc oveq1d eqtrd clat hllat syl simp213 simp32
        simp333 cdlemkuat atbase simp22l cdlemkvcl syl231anc latjcom a1i ltrnat
        hlatjcom eqtr4d simp1 cdlemkoatnle simpld trlcocnvat oveq12d 3brtr4d )
        QUQURZUCOURZUSZMGURZCGURZUTZTGURZNGURZUDGURZUTZDAURZDUCRVAVBZUSZMEVCZTE
        VCVDZUTZMVEBVFZVGZCYOVGZNYOVGZUTZUDYOVGZCEVCZYLVGZNEVCZUUAVGZUDEVCZUUAV
        GZUTZUTZUTZDDNVCZPWKZDUAVCZNCVHZVIEVCZPWKZSWKZUUJDUDVCZPWKUUNUDUUMVIEVC
        ZPWKSWKZUUQDPWKZUURUULPWKZSWKZPWKZDNHVCVCZDUDHVCVCZUBPWKZRYDYNUUHYSUUGU
        SUUPUVCRVAUUIYSUUGYDYNYSYTUUGVJYDYNYSYTUUGVKVLABCDEFGJKMNOPQRSTUAUCUDUE
        UFUGUHUIUJUKULUMUNVMVNUUIUVDDUUCPWKZUUOSWKZUUPUUIYAYMYFYBYCYEUTZUUBUUAU
        UCVGZUSYPYRYQUTYKUVDUVHVDUUIXSXTXSXTYBYCYNUUHVOZXSXTYBYCYNUUHVPZVLZYDYH
        YKYMUUHVQZYEYFYGYKYMYDUUHVRZUUIYBYCYEYAYBYCYNUUHVSYAYBYCYNUUHVTZYEYFYGY
        KYMYDUUHWBZWAZUUIUUBUVJUUBUUDUUFYSYTYDYNWCZUUIUUCUUAUUBUUDUUFYSYTYDYNWD
        WEVLUUIYPYRYQYPYQYRYTUUGYDYNWFZYPYQYRYTUUGYDYNWGYPYQYRYTUUGYDYNWHZWAYDY
        HYKYMUUHWIZABCDEFGHIJKLMNOPQRSTUAUCUEUFUGUHUIUJUKULUMUNUOWJWLUUIUVGUUKU
        UOSUUIYAYFYKUVGUUKVDUVMUVOUWBADEGNOPQRUCUFUGUIUJUKULWMWNWOWPUUIUVFUBUVE
        PWKZUVCUUIQWQURZUVEBURZUBBURZUVFUWCVDUUIXSUWDUVKQWRWSUUIUVEAURZUWEUUIYA
        YMYGUVIUUBUUAUUEVGZUSZYPYTYQUTZYKUWGUVMUVNYEYFYGYKYMYDUUHWTZUVRUUIUUBUW
        HUVSUUIUUEUUAUUBUUDUUFYSYTYDYNXBZWEVLZUUIYPYTYQUVTYDYNYSYTUUGXAUWAWAZUW
        BABCDEFGHIJKLMUDOPQRSTUAUCUEUFUGUHUIUJUKULUMUNUOXCWLABUVEQUEUIXDWSUUIXS
        XTYCYFYGYIUWFUVKUVLUVPUVOUWKYIYJYHYMYDUUHXEZABDEGCNOPQRSUBUCUDUEUFUGUIU
        JUKULUHUPXFXGBPQUVEUBUEUGXHWNUUIUBUUSUVEUVBPUBUUSVDUUIUPXIUUIUVEDUUEPWK
        ZUULUURPWKZSWKZUVBUUIYAYMYGUVIUWIUWJYKUVEUWRVDUVMUVNUWKUVRUWMUWNUWBABCD
        EFGHIJKLMUDOPQRSTUAUCUEUFUGUHUIUJUKULUMUNUOWJWLUUIUWPUUTUWQUVASUUIUWPDU
        UQPWKZUUTUUIYAYGYKUWPUWSVDUVMUWKUWBADEGUDOPQRUCUFUGUIUJUKULWMWNUUIXSUUQ
        AURZYIUUTUWSVDUVKUUIYAYGYIUWTUVMUWKUWOADGUDOQRUCUFUIUJUKXJWNUWOAPQUUQDU
        GUIXKWNXLUUIXSUULAURZUURAURZUWQUVAVDUVKUUIYDYEYKYMUTZYPYQUUBUTZUXAYDYNU
        UHXMUUIYEYKYMUVQUWBUVNWAUUIYPYQUUBUVTUWAUVSWAYDUXCUXDUTUXAUULUCRVAVBABC
        DEFGJKMOPQRSTUAUCUEUFUGUHUIUJUKULUMUNXNXOWNUUIYAYGYCUSUUFUXBUVMUUIYGYCU
        WKUVPVLUWLAEGUDCOQUCUIUJUKULXPWNAPQUULUURUGUIXKWNXQWPXQWPXR $.

      $( Part of proof of Lemma K of [Crawley] p. 118.  Line 17, p. 119,
         showing Eq. 3 (line 8, p. 119) for the sigma_1 ( ` U ` ) case.
         (Contributed by NM, 4-Jul-2013.) $)
      cdlemk11u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
         /\ ( ( N e. T /\ G e. T /\ X e. T )
            /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
         /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
            /\ X =/= ( _I |` B )
            /\ ( ( R ` D ) =/= ( R ` F )
               /\ ( R ` G ) =/= ( R ` D )
               /\ ( R ` X ) =/= ( R ` D ) ) ) )
       -> ( ( U ` G ) ` P )
              .<_ ( ( ( U ` X ) ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) $=
        ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne co ccnv ccom clat hllat
        simp11l syl simp11r simp23 simp212 simp12 simp13 simp211 simp331 necomd
        simp332 simp311 simp313 simp312 3jca simp22 cdlemkuat syl333anc simp213
        atbase simp333 simp32 simp22l cdlemkvcl syl231anc latjcl syl3anc ltrnco
        jca ltrncnv syl2anc trlcl cdlemk7u cdlemk10 wi latjlej2 syl13anc lattrd
        mpd ) QUQURZUCOURZUSZMGURZCGURZUTZTGURZNGURZUDGURZUTZDAURZDUCRVAVBZUSZM
        EVCZTEVCVDZUTZMVEBVFZVGZCYHVGZNYHVGZUTZUDYHVGZCEVCZYEVGZNEVCZYNVGZUDEVC
        ZYNVGZUTZUTZUTZBQRDNHVCVCZDUDHVCVCZUBPVHZUUDUDNVIZVJZEVCZPVHZUEUFUUBXLQ
        VKURZXLXMXOXPYGUUAVMZQVLVNZUUBUUCAURZUUCBURUUBXNYFXSXOXPXRYOYNYPVGZUSYI
        YKYJUTYDUUMUUBXLXMUUKXLXMXOXPYGUUAVOZXAZXQYAYDYFUUAVPZXRXSXTYDYFXQUUAVQ
        ZXNXOXPYGUUAVRZXNXOXPYGUUAVSZXRXSXTYDYFXQUUAVTZUUBYOUUNYOYQYSYLYMXQYGWA
        ZUUBYPYNYOYQYSYLYMXQYGWCWBXAUUBYIYKYJYIYJYKYMYTXQYGWDZYIYJYKYMYTXQYGWEY
        IYJYKYMYTXQYGWFZWGXQYAYDYFUUAWHZABCDEFGHIJKLMNOPQRSTUAUCUEUFUGUHUIUJUKU
        LUMUNUOWIWJABUUCQUEUIWLVNUUBUUJUUDBURZUBBURZUUEBURUULUUBUUDAURZUVFUUBXN
        YFXTXOXPXRYOYNYRVGZUSYIYMYJUTYDUVHUUPUUQXRXSXTYDYFXQUUAWKZUUSUUTUVAUUBY
        OUVIUVBUUBYRYNYOYQYSYLYMXQYGWMWBXAUUBYIYMYJUVCXQYGYLYMYTWNUVDWGUVEABCDE
        FGHIJKLMUDOPQRSTUAUCUEUFUGUHUIUJUKULUMUNUOWIWJABUUDQUEUIWLVNZUUBXLXMXPX
        SXTYBUVGUUKUUOUUTUURUVJYBYCYAYFXQUUAWOABDEGCNOPQRSUBUCUDUEUFUGUIUJUKULU
        HUPWPWQZBPQUUDUBUEUGWRWSUUBUUJUVFUUHBURZUUIBURUULUVKUUBXNUUGGURZUVMUUPU
        UBXNXTUUFGURZUVNUUPUVJUUBXNXSUVOUUPUURGNOQUCUJUKXBXCGUDUUFOQUCUJUKWTWSB
        EGUUGOQUCUEUJUKULXDXCZBPQUUDUUHUEUGWRWSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUF
        UGUHUIUJUKULUMUNUOUPXEUUBUBUUHRVAZUUEUUIRVAZUUBXLXMXPXSXTYDUVQUUKUUOUUT
        UURUVJUVEABDEGCNOPQRSUBUCUDUEUFUGUIUJUKULUHUPXFWQUUBUUJUVGUVMUVFUVQUVRX
        GUULUVLUVPUVKBPQRUBUUHUUDUEUFUGXHXIXKXJ $.
    $}

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 18, p. 119, showing
       Eq. 4 (line 10, p. 119) for the sigma_1 ( ` U ` ) case.  (Contributed by
       NM, 4-Jul-2013.) $)
    cdlemk12u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ G e. T /\ X e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( X =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` X ) )
          /\ ( ( R ` D ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` D )
             /\ ( R ` X ) =/= ( R ` D ) ) ) )
     -> ( ( U ` G ) ` P ) = ( ( P .\/ ( G ` P ) )
           ./\ ( ( ( U ` X ) ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne ccnv ccom simp11l simp22l
      simp11 simp212 ltrnat syl3anc simp23 simp213 simp12 simp13 simp211 necomd
      co simp331 simp333 jca simp311 simp32l simp312 simp22 cdlemkuat syl333anc
      3jca simp32r trlcocnvat syl121anc simp332 simp313 cdlemkuv2 clat trlnidat
      hllat hlatjcl simp1 cdlemkoatnle simpld syl113anc latmle1 eqbrtrd trljat1
      syl breqtrd simp2 simp31 simp33 eqid cdlemk11u hlatlej2 cdlemkuel ltrncnv
      ltrnel syl2anc trlcnv eqnetrd trlcone ltrncom fveq2d 3netr3d ltrnco trlle
      syl122anc lhp2atnle syl322anc nbrne1 2atm ) QUOUPZUBOUPZUQZMGUPZCGUPZURZT
      GUPZNGUPZUCGUPZURZDAUPZDUBRUSUTZUQZMEVAZTEVAVBZURZMVCBVDZVEZCUUIVEZNUUIVE
      ZURZUCUUIVEZNEVAZUCEVAZVEZUQZCEVAZUUFVEZUUOUUSVEZUUPUUSVEZURZURZURZYMUUCD
      NVAZAUPZDUCHVAZVAZAUPZUCNVFZVGZEVAZAUPZDNHVAVAZAUPZUVODUVFPVTZRUSUVOUVIUV
      MPVTZRUSZUVQUVRVEZUVOUVQUVRSVTVBYMYNYPYQUUHUVDVHZUUCUUDUUBUUGYRUVDVIZUVEY
      OYTUUCUVGYOYPYQUUHUVDVJZYSYTUUAUUEUUGYRUVDVKZUWBADGNOQRUBUEUHUIUJVLVMUVEY
      OUUGUUAYPYQYSUUTUUSUUPVEZUQZUUJUUNUUKURZUUEUVJUWCYRUUBUUEUUGUVDVNZYSYTUUA
      UUEUUGYRUVDVOZYOYPYQUUHUVDVPZYOYPYQUUHUVDVQZYSYTUUAUUEUUGYRUVDVRZUVEUUTUW
      EUUTUVAUVBUUMUURYRUUHWAZUVEUUPUUSUUTUVAUVBUUMUURYRUUHWBVSWCZUVEUUJUUNUUKU
      UJUUKUULUURUVCYRUUHWDZUUNUUQUUMUVCYRUUHWEZUUJUUKUULUURUVCYRUUHWFZWJZYRUUB
      UUEUUGUVDWGZABCDEFGHIJKLMUCOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNWHWIUVEYOUUAYT
      UUPUUOVEUVNUWCUWIUWDUVEUUOUUPUUNUUQUUMUVCYRUUHWKZVSAEGUCNOQUBUHUIUJUKWLWM
      ZUVEYOUUGYTYPYQYSUUTUUSUUOVEZUQZUUJUULUUKURZUUEUVPUWCUWHUWDUWJUWKUWLUVEUU
      TUXBUWMUVEUUOUUSUUTUVAUVBUUMUURYRUUHWNZVSWCZUVEUUJUULUUKUWOUUJUUKUULUURUV
      CYRUUHWOZUWQWJZUWSABCDEFGHIJKLMNOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNWHWIUVEUV
      ODUUOPVTZUVQRUVEUVOUXIDUAVAZNCVFZVGEVAZPVTZSVTZUXIRUVEYOUUGYTYPYQYSUXCUXD
      UUEUVOUXNVBUWCUWHUWDUWJUWKUWLUXFUXHUWSABCDEFGHIJKLMNOPQRSTUAUBUDUEUFUGUHU
      IUJUKULUMUNWPWIUVEQWQUPZUXIBUPZUXMBUPZUXNUXIRUSUVEYMUXOUWAQWSXHUVEYMUUCUU
      OAUPZUXPUWAUWBUVEYOYTUULUXRUWCUWDUXGABEGNOQUBUDUHUIUJUKWRVMZABPQDUUOUDUFU
      HWTVMUVEYMUXJAUPZUXLAUPZUXQUWAUVEYRYSUUEUUGURZUUJUUKUUTUXTYRUUHUVDXAZUVEY
      SUUEUUGUWLUWSUWHWJUWOUWQUWMYRUYBUUJUUKUUTURURUXTUXJUBRUSUTABCDEFGJKMOPQRS
      TUAUBUDUEUFUGUHUIUJUKULUMXBXCXDUVEYOYTYQUVAUYAUWCUWDUWKUXEAEGNCOQUBUHUIUJ
      UKWLWMABPQUXJUXLUDUFUHWTVMBQRSUXIUXMUDUEUGXEVMXFUVEYOYTUUEUXIUVQVBUWCUWDU
      WSADEGNOPQRUBUEUFUHUIUJUKXGVMZXIUVEYRUUHUUMUUNUVCUVSUYCYRUUHUVDXJYRUUHUUM
      UURUVCXKUWPYRUUHUUMUURUVCXLABCDEFGHIJKLMNOPQRSTUAUVFDUCVAPVTUXLUCUXKVGEVA
      PVTSVTZUBUCUDUEUFUGUHUIUJUKULUMUNUYEXMXNXDUVEUUOUVQRUSUUOUVRRUSUTZUVTUVEU
      UOUXIUVQRUVEYMUUCUXRUUOUXIRUSUWAUWBUXSADUUOPQRUEUFUHXOVMUYDXIUVEYOUVJUVIU
      BRUSUTUQZUVMUUOVEUVNUVMUBRUSZUXRUUOUBRUSZUYFUWCUVEYOUVHGUPZUUEUYGUWCUVEYO
      UUGUUAYPYQYSUWFUWGUUEUYJUWCUWHUWIUWJUWKUWLUWNUWRUWSABCDEFGHIJKLMUCOPQRSTU
      AUBUDUEUFUGUHUIUJUKULUMUNXPWIUWSADGUVHOQRUBUEUHUIUJXRVMUVEUVKUCVGZEVAZUVK
      EVAZUVMUUOUVEUYMUYLUVEYOUVKGUPZUUAUYMUUPVEUUNUYMUYLVEUWCUVEYOYTUYNUWCUWDG
      NOQUBUIUJXQXSZUWIUVEUYMUUOUUPUVEYOYTUYMUUOVBUWCUWDEGNOQUBUIUJUKXTXSZUWTYA
      UWPBEGUVKUCOQUBUDUIUJUKYBYHVSUVEUYKUVLEUVEYOUYNUUAUYKUVLVBUWCUYOUWIGUVKUC
      OQUBUIUJYCVMYDUYPYEUXAUVEYOUVLGUPZUYHUWCUVEYOUUAUYNUYQUWCUWIUYOGUCUVKOQUB
      UIUJYFVMEGUVLOQRUBUEUIUJUKYGXSUXSUVEYOYTUYIUWCUWDEGNOQRUBUEUIUJUKYGXSAUVI
      UVMOPQRUUOUBUEUFUHUIYIYJUUOUVQUVRRYKXSADUVFUVIUVMUVOPQRSUEUFUGUHYLWI $.

    $d i f G $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Lines 26-27, p. 119 for
       i=0 and j=1.  (Contributed by NM, 5-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk21N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ G e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( ( R ` D ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` D )
             /\ ( R ` G ) =/= ( R ` F ) ) ) )
     -> ( ( S ` G ) ` P ) = ( ( U ` G ) ` P ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv simp11 simp21r simp22
      wne ccom trljat1 syl3anc fveq1i a1i simp13 trlcocnv oveq12d simp23 simp12
      simp21l simp3r1 simp3r2 necomd jca simp3l1 simp3l3 simp3l2 3jca cdlemkuv2
      syl333anc simp3r3 cdlemk12 3eqtr4rd ) QUNUOUBOUOUPZMGUOZCGUOZUQZTGUOZNGUO
      ZUPZDAUODUBRURUSUPZMEUTZTEUTVAZUQZMVBBVCZVIZCXEVIZNXEVIZUQZCEUTZXBVIZNEUT
      ZXJVIZXLXBVIZUQZUPZUQZDXLPVDZDUAUTZNCVEVJEUTZPVDZSVDZDDNUTPVDZDCFUTZUTZCN
      VEVJEUTZPVDZSVDZDNHUTUTZDNFUTUTZXQXRYCYAYGSXQWNWSXAXRYCVAWNWOWPXDXPVFZWRW
      SXAXCWQXPVGZWQWTXAXCXPVHZADEGNOPQRUBUDUEUGUHUIUJVKVLXQXSYEXTYFPXSYEVAXQDU
      AYDULVMVNXQWNWSWPXTYFVAYKYLWNWOWPXDXPVOZEGNCOQUBUHUIUJVPVLVQVQXQWNXCWSWOW
      PWRXKXJXLVIZUPXFXHXGUQZXAYIYBVAYKWQWTXAXCXPVRZYLWNWOWPXDXPVSZYNWRWSXAXCWQ
      XPVTZXQXKYOXKXMXNXIWQXDWAZXQXLXJXKXMXNXIWQXDWBZWCWDXQXFXHXGXFXGXHXOWQXDWE
      XFXGXHXOWQXDWFXFXGXHXOWQXDWGWHZYMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJ
      UKULUMWIWJXQWNWOWSWRWPUPXAXCYPXNXKUPXMYJYHVAYKYRYLXQWRWPYSYNWDYMYQUUBXQXN
      XKXKXMXNXIWQXDWKYTWDUUAABDEFGJKMNOPQRSTUBCUCUDUEUGUHUIUJUFUKWLWJWM $.

    cdlemk2a.q $e |- Q = ( S ` C ) $.
    $d e f i j C $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22, p. 119 for the
       i=2, j=1 case.  Note typo on line 22: f should be f_i.  Our ` D ` ,
       ` C ` , ` O ` , ` Q ` , ` U ` , ` V ` represent their f_1, f_2, k_1,
       k_2, sigma_1, sigma_2.  (Contributed by NM, 5-Jul-2013.) $)
    cdlemk20 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ C e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
          /\ ( ( R ` D ) =/= ( R ` F )
             /\ ( R ` C ) =/= ( R ` F )
             /\ ( R ` C ) =/= ( R ` D ) ) ) )
     -> ( ( U ` C ) ` P ) = ( Q ` P ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv simp11 simp23 simp21r
      wne ccom simp12 simp13 simp21l simp3r1 simp3r3 necomd jca simp3l1 simp3l3
      simp3l2 3jca simp22 cdlemkuv2 trljat1 syl3anc fveq1i a1i trlcocnv oveq12d
      syl333anc simp3r2 cdlemk12 syl5req 3eqtrd ) RUPUQUCPUQURZOIUQZDIUQZUSZUAI
      UQZCIUQZURZEAUQEUCSUTVAURZOGVBZUAGVBVCZUSZOVDBVEZVKZDXHVKZCXHVKZUSZDGVBZX
      EVKZCGVBZXEVKZXOXMVKZUSZURZUSZECJVBVBZEXOQVFZEUBVBZCDVGVLGVBZQVFZTVFZEECV
      BQVFZEDHVBZVBZDCVGVLGVBZQVFZTVFZEFVBZXTWQXFXBWRWSXAXNXMXOVKZURXIXKXJUSZXD
      YAYFVCWQWRWSXGXSVHZWTXCXDXFXSVIZXAXBXDXFWTXSVJZWQWRWSXGXSVMZWQWRWSXGXSVNZ
      XAXBXDXFWTXSVOZXTXNYNXNXPXQXLWTXGVPZXTXOXMXNXPXQXLWTXGVQZVRVSXTXIXKXJXIXJ
      XKXRWTXGVTXIXJXKXRWTXGWAXIXJXKXRWTXGWBWCZWTXCXDXFXSWDZABDEGHIJKLMNOCPQRST
      UAUBUCUDUEUFUGUHUIUJUKULUMUNWEWLXTYBYGYEYKTXTWQXBXDYBYGVCYPYRUUEAEGICPQRS
      UCUEUFUHUIUJUKWFWGXTYCYIYDYJQYCYIVCXTEUBYHUMWHWIXTWQXBWSYDYJVCYPYRYTGICDP
      RUCUIUJUKWJWGWKWKXTYMECHVBZVBZYLEFUUFUOWHXTWQWRXBXAWSURXDXFYOXPXNURXQUUGY
      LVCYPYSYRXTXAWSUUAYTVSUUEYQUUDXTXPXNXNXPXQXLWTXGWMUUBVSUUCABEGHILMOCPQRST
      UAUCDUDUEUFUHUIUJUKUGULWNWLWOWP $.
  $}

  ${
    cdlemk2.b $e |- B = ( Base ` K ) $.
    cdlemk2.l $e |- .<_ = ( le ` K ) $.
    cdlemk2.j $e |- .\/ = ( join ` K ) $.
    cdlemk2.m $e |- ./\ = ( meet ` K ) $.
    cdlemk2.a $e |- A = ( Atoms ` K ) $.
    cdlemk2.h $e |- H = ( LHyp ` K ) $.
    cdlemk2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk2.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemk2.s $e |- S = ( f e. T |-> ( iota_ i e. T
        ( i ` P ) = ( ( P .\/ ( R ` f ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
    cdlemk2.q $e |- Q = ( S ` C ) $.
    $d f i ./\ $.  $d i .<_ $.  $d f i .\/ $.  $d i A $.  $d f i C $.
    $d f i F $.  $d i H $.  $d i K $.  $d f i N $.  $d f i P $.  $d f i R $.
    $d f i T $.  $d f i W $.
    $( Utility lemma.  (Contributed by NM, 2-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkoatnle-2N $p |- ( ( ( K e. HL /\ W e. H
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( R ` C ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
        -> ( ( Q ` P ) e. A /\ -. ( Q ` P ) .<_ W ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wbr simp11 simp12 jca simp21 simp22
      wa wn simp23 simp33 simp13 simp32l simp32r simp31 cdlemkoatnle syl333anc
      ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKVOUNZKUOBUPZUNZCWCUNZVC
      ZDAUJDROUQVDVCZUMZUMZVMVNVCVRVSVTWGVPWDWEWBDEUKZAUJWJROUQVDVCWIVMVNVMVNVP
      WAWHURVMVNVPWAWHUSUTVQVRVSVTWHVAVQVRVSVTWHVBVQVRVSVTWHVEVQWAWBWFWGVFVMVNV
      PWAWHVGWDWEWBWGVQWAVHWDWEWBWGVQWAVIVQWAWBWFWGVJABCDFGHIJKLMNOPQERSTUAUBUC
      UDUEUFUGUHVKVL $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 13 on p. 119.
       ` Q ` , ` C ` are k_2, f_2.  (Contributed by NM, 1-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk13-2N $p |- ( ( ( K e. HL /\ W e. H
        /\ ( R ` F ) = ( R ` N ) )
 /\ ( F e. T /\ C e. T /\ N e. T )
 /\ ( ( R ` C ) =/= ( R ` F )
   /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
   /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( Q ` P ) = ( ( P .\/ ( R ` C ) )
       ./\ ( ( N ` P ) .\/ ( R ` ( C o. `' F ) ) ) ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wa wbr wn co ccnv simp11 simp12 jca
      ccom simp21 simp22 simp23 simp33 simp13 simp32l simp31 cdlemk13 syl333anc
      simp32r ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKZVRUNZKUOBUPZUN
      ZCWGUNZUQZDAUJDROURUSUQZUMZUMZVPVQUQWAWBWCWKVSWHWIWFDEUKDWEMUTDQUKCKVAVEF
      UKMUTPUTULWMVPVQVPVQVSWDWLVBVPVQVSWDWLVCVDVTWAWBWCWLVFVTWAWBWCWLVGVTWAWBW
      CWLVHVTWDWFWJWKVIVPVQVSWDWLVJWHWIWFWKVTWDVKWHWIWFWKVTWDVOVTWDWFWJWKVLABCD
      FGHIJKLMNOPQERSTUAUBUCUDUEUFUGUHVMVN $.

    $( Utility lemma.  (Contributed by NM, 2-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkole-2N $p |- ( ( ( K e. HL /\ W e. H
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( R ` C ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
     -> ( Q ` P ) .<_ ( P .\/ ( R ` C ) ) ) $=
      ( chlt wcel cfv wceq w3a wne cid wa wbr wn co simp11 simp12 simp21 simp22
      cres jca simp23 simp33 simp13 simp32l simp32r simp31 cdlemkole syl333anc
      ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKZVPUNZKUOBVDZUNZCWEUNZU
      PZDAUJDROUQURUPZUMZUMZVNVOUPVSVTWAWIVQWFWGWDDEUKDWCMUSOUQWKVNVOVNVOVQWBWJ
      UTVNVOVQWBWJVAVEVRVSVTWAWJVBVRVSVTWAWJVCVRVSVTWAWJVFVRWBWDWHWIVGVNVOVQWBW
      JVHWFWGWDWIVRWBVIWFWGWDWIVRWBVJVRWBWDWHWIVKABCDFGHIJKLMNOPQERSTUAUBUCUDUE
      UFUGUHVLVM $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 19 on p. 119.
       ` Q ` , ` C ` are k_2, f_2.  (Contributed by NM, 1-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk14-2N $p |- ( ( ( K e. HL /\ W e. H
        /\ ( R ` F ) = ( R ` N ) )
 /\ ( F e. T /\ C e. T /\ N e. T )
 /\ ( ( R ` C ) =/= ( R ` F )
   /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
   /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( N ` P ) .<_ ( ( Q ` P ) .\/ ( R ` ( F o. `' C ) ) ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wa wbr wn ccnv co simp11 simp12 jca
      ccom simp21 simp22 simp23 simp33 simp13 simp32l simp31 cdlemk14 syl333anc
      simp32r ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKVRUNZKUOBUPZUNZ
      CWFUNZUQZDAUJDROURUSUQZUMZUMZVPVQUQWAWBWCWJVSWGWHWEDQUKDEUKKCUTVEFUKMVAOU
      RWLVPVQVPVQVSWDWKVBVPVQVSWDWKVCVDVTWAWBWCWKVFVTWAWBWCWKVGVTWAWBWCWKVHVTWD
      WEWIWJVIVPVQVSWDWKVJWGWHWEWJVTWDVKWGWHWEWJVTWDVOVTWDWEWIWJVLABCDFGHIJKLMN
      OPQERSTUAUBUCUDUEUFUGUHVMVN $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 21 on p. 119.
       ` Q ` , ` C ` are k_2, f_2.  (Contributed by NM, 1-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk15-2N $p |- ( ( ( K e. HL /\ W e. H
        /\ ( R ` F ) = ( R ` N ) )
 /\ ( F e. T /\ C e. T /\ N e. T )
 /\ ( ( R ` C ) =/= ( R ` F )
   /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
   /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( N ` P )
  .<_ ( ( P .\/ ( R ` F ) )
     ./\ ( ( Q ` P ) .\/ ( R ` ( F o. `' C ) ) ) ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wa wbr wn co ccnv simp11 simp12 jca
      ccom simp21 simp22 simp23 simp33 simp13 simp32l simp31 cdlemk15 syl333anc
      simp32r ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKVRUNZKUOBUPZUNZ
      CWFUNZUQZDAUJDROURUSUQZUMZUMZVPVQUQWAWBWCWJVSWGWHWEDQUKDVRMUTDEUKKCVAVEFU
      KMUTPUTOURWLVPVQVPVQVSWDWKVBVPVQVSWDWKVCVDVTWAWBWCWKVFVTWAWBWCWKVGVTWAWBW
      CWKVHVTWDWEWIWJVIVPVQVSWDWKVJWGWHWEWJVTWDVKWGWHWEWJVTWDVOVTWDWEWIWJVLABCD
      FGHIJKLMNOPQERSTUAUBUCUDUEUFUGUHVMVN $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       1-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk16-2N $p |- ( ( ( K e. HL /\ W e. H
        /\ ( R ` F ) = ( R ` N ) )
 /\ ( F e. T /\ C e. T /\ N e. T )
 /\ ( ( R ` C ) =/= ( R ` F )
   /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
   /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( ( ( P .\/ ( R ` F ) )
          ./\ ( ( Q ` P ) .\/ ( R ` ( F o. `' C ) ) ) ) e. A
      /\ -. ( ( P .\/ ( R ` F ) )
          ./\ ( ( Q ` P ) .\/ ( R ` ( F o. `' C ) ) ) ) .<_ W ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wa wbr wn co ccnv simp11 simp12 jca
      ccom simp21 simp22 simp23 simp33 simp13 simp32l simp31 cdlemk16 syl333anc
      simp32r ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKVRUNZKUOBUPZUNZ
      CWFUNZUQZDAUJDROURUSUQZUMZUMZVPVQUQWAWBWCWJVSWGWHWEDVRMUTDEUKKCVAVEFUKMUT
      PUTZAUJWMROURUSUQWLVPVQVPVQVSWDWKVBVPVQVSWDWKVCVDVTWAWBWCWKVFVTWAWBWCWKVG
      VTWAWBWCWKVHVTWDWEWIWJVIVPVQVSWDWKVJWGWHWEWJVTWDVKWGWHWEWJVTWDVOVTWDWEWIW
      JVLABCDFGHIJKLMNOPQERSTUAUBUCUDUEUFUGUHVMVN $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 21 on p. 119.
       ` Q ` , ` C ` are k_2, f_2.  (Contributed by NM, 1-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk17-2N $p |- ( ( ( K e. HL /\ W e. H
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( R ` C ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( N ` P ) = ( ( P .\/ ( R ` F ) )
           ./\ ( ( Q ` P ) .\/ ( R ` ( F o. `' C ) ) ) ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wa wbr wn co ccnv simp11 simp12 jca
      ccom simp21 simp22 simp23 simp33 simp13 simp32l simp31 cdlemk17 syl333anc
      simp32r ) NUIUJZRLUJZKFUKZQFUKULZUMZKHUJZCHUJZQHUJZUMZCFUKVRUNZKUOBUPZUNZ
      CWFUNZUQZDAUJDROURUSUQZUMZUMZVPVQUQWAWBWCWJVSWGWHWEDQUKDVRMUTDEUKKCVAVEFU
      KMUTPUTULWLVPVQVPVQVSWDWKVBVPVQVSWDWKVCVDVTWAWBWCWKVFVTWAWBWCWKVGVTWAWBWC
      WKVHVTWDWEWIWJVIVPVQVSWDWKVJWGWHWEWJVTWDVKWGWHWEWJVTWDVOVTWDWEWIWJVLABCDF
      GHIJKLMNOPQERSTUAUBUCUDUEUFUGUHVMVN $.

    ${
      cdlemk.y $e |- Y = ( iota_ k e. T
        ( k ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( Q ` P ) .\/ ( R ` ( G o. `' C ) ) ) ) ) $.

      $d k ./\ $.  $d k .<_ $.  $d k .\/ $.  $d k A $.  $d k C $.  $d k F $.
      $d k H $.  $d k K $.  $d k N $.  $d k Q $.  $d k P $.  $d k R $.
      $d k T $.  $d k W $.  $d k G $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
         2-Jul-2013.)  (New usage is discouraged.) $)
      cdlemkj-2N $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( ( R ` C ) =/= ( R ` F )
                /\ ( R ` C ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> Y e. T ) $=
        ( cdlemkj ) ABCDFGHIJKLMNOPQRSETUAUBUCUDUEUFUGUHUIUJUKULUM $.
    $}

    cdlemk2.v $e |- V = ( d e. T |-> ( iota_ k e. T
        ( k ` P ) = ( ( P .\/ ( R ` d ) )
              ./\ ( ( Q ` P ) .\/ ( R ` ( d o. `' C ) ) ) ) ) ) $.
    $d d ./\ $.  $d d .\/ $.  $d d C $.  $d d k G $.  $d d Q $.  $d d P $.
    $d d R $.  $d d T $.  $d d W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Value of the sigma_2 (p)
       function, given ` V ` .  (Contributed by NM, 2-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkuv-2N $p |- ( G e. T -> ( V ` G ) = ( iota_ k e. T
        ( k ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( Q ` P ) .\/ ( R ` ( G o. `' C ) ) ) ) ) ) $=
      ( cdlemksv ) ABDFTHUBKCMNOPQREUAUCUDUEUGUHUIUJUFUMUN $.

    $d k ./\ $.  $d k .<_ $.  $d k .\/ $.  $d k A $.  $d k C $.  $d k F $.
    $d k H $.  $d k K $.  $d k N $.  $d k Q $.  $d k P $.  $d k R $.  $d k T $.
    $d k W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Conditions for the
       sigma_2 (p) function to be a translation.  TODO: combine ~ cdlemkj ?
       (Contributed by NM, 2-Jul-2013.)  (New usage is discouraged.) $)
    cdlemkuel-2N $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( ( R ` C ) =/= ( R ` F )
                /\ ( R ` C ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( V ` G ) e. T ) $=
      ( cdlemkuel ) ABCDFGHTUBIJKLMNOPQRSEUAUCUDUEUFUGUHUIUJUKULUMUN $.

    $d w ./\ $.  $d w .\/ $.  $d w C $.  $d w G $.  $d w Q $.  $d w P $.
    $d w R $.  $d w T $.  $d w V $.  $d w W $.  $d w d k $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 16 on p. 119 for i =
       2, where sigma_2 (p) is ` V ` , f_2 is ` C ` , and k_2 is ` Q ` .
       (Contributed by NM, 2-Jul-2013.) $)
    cdlemkuv2-2 $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( ( R ` C ) =/= ( R ` F )
                /\ ( R ` C ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
 -> ( ( V ` G ) ` P ) = ( ( P .\/ ( R ` G ) )
       ./\ ( ( Q ` P ) .\/ ( R ` ( G o. `' C ) ) ) ) ) $=
      ( cdlemkuv2 ) ABCDFGHTUBIJKLMNOPQRSEUAUCUDUEUFUGUHUIUJUKULUMUN $.

    $d d F $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22 on p. 119.
       ` N ` , ` V ` , ` Q ` , ` C ` are k, sigma_2 (p), k_2, f_2.
       (Contributed by NM, 2-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk18-2N $p |- ( ( ( K e. HL /\ W e. H
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( R ` C ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( N ` P ) = ( ( V ` F ) ` P ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wbr simp11 simp12 jca simp21 simp22
      wa wn simp23 simp33 simp13 simp32l simp32r simp31 cdlemk18 syl333anc ) OU
      MUNZTMUNZLFUOZRFUOUPZUQZLHUNZCHUNZRHUNZUQZCFUOVSURZLUSBUTZURZCWGURZVGZDAU
      NDTPVAVHVGZUQZUQZVQVRVGWBWCWDWKVTWHWIWFDRUODLSUOUOUPWMVQVRVQVRVTWEWLVBVQV
      RVTWEWLVCVDWAWBWCWDWLVEWAWBWCWDWLVFWAWBWCWDWLVIWAWEWFWJWKVJVQVRVTWEWLVKWH
      WIWFWKWAWEVLWHWIWFWKWAWEVMWAWEWFWJWKVNABCDFGHSUAIJKLMNOPQRETUBUCUDUEUFUGU
      HUIUJUKULVOVP $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22 on p. 119.
       ` N ` , ` V ` , ` Q ` , ` C ` are k, sigma_2 (p), k_2, f_2.
       (Contributed by NM, 2-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk19-2N $p |- ( ( ( K e. HL /\ W e. H
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ C e. T /\ N e. T )
           /\ ( ( R ` C ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( V ` F ) = N ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wbr simp11 simp12 jca simp21 simp22
      wa wn simp23 simp33 simp13 simp32l simp32r simp31 cdlemk19 syl333anc ) OU
      MUNZTMUNZLFUOZRFUOUPZUQZLHUNZCHUNZRHUNZUQZCFUOVSURZLUSBUTZURZCWGURZVGZDAU
      NDTPVAVHVGZUQZUQZVQVRVGWBWCWDWKVTWHWIWFLSUORUPWMVQVRVQVRVTWEWLVBVQVRVTWEW
      LVCVDWAWBWCWDWLVEWAWBWCWDWLVFWAWBWCWDWLVIWAWEWFWJWKVJVQVRVTWEWLVKWHWIWFWK
      WAWEVLWHWIWFWKWAWEVMWAWEWFWJWKVNABCDFGHSUAIJKLMNOPQRETUBUCUDUEUFUGUHUIUJU
      KULVOVP $.

    $d d k G $.  $d d k X $.
    ${
      cdlemk2.z $e |- Z = ( ( ( G ` P ) .\/ ( X ` P ) )
                  ./\ ( ( R ` ( G o. `' C ) )
                       .\/ ( R ` ( X o. `' C ) ) ) ) $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  Line 5, p. 119 for the
         sigma_2 case.  (Contributed by NM, 5-Jul-2013.)
         (New usage is discouraged.) $)
      cdlemk7u-2N $p |- ( ( ( K e. HL /\ W e. H
              /\ ( R ` F ) = ( R ` N ) )
          /\ ( ( F e. T /\ C e. T /\ N e. T )
                 /\ ( G e. T /\ G =/= ( _I |` B ) )
                 /\ ( X e. T /\ X =/= ( _I |` B ) ) )
          /\ ( ( ( R ` C ) =/= ( R ` F )
               /\ ( R ` G ) =/= ( R ` C )
               /\ ( R ` X ) =/= ( R ` C ) )
            /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
            /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( ( V ` G ) ` P ) .<_ ( ( ( V ` X ) ` P ) .\/ Z ) ) $=
        ( chlt wcel cfv wceq w3a cid wne wa wbr wn co simp11 simp12 jca simp211
        cres simp212 simp213 simp22l simp23l 3jca simp33 simp13 simp32l simp32r
        simp22r simp23r simp31 cdlemk7u syl333anc ) PUQURZUANURZLFUSZSFUSUTZVAZ
        LHURZCHURZSHURZVAZMHURZMVBBVLZVCZVDZUBHURZUBWQVCZVDZVAZCFUSZWIVCMFUSXDV
        CUBFUSXDVCVAZLWQVCZCWQVCZVDZDAURDUAQVEVFVDZVAZVAZWGWHVDWLWMWNWPWTVAXIWJ
        XFXGWRVAXAXEDMTUSUSDUBTUSUSUCOVGQVEXKWGWHWGWHWJXCXJVHWGWHWJXCXJVIVJWLWM
        WNWSXBWKXJVKWLWMWNWSXBWKXJVMXKWNWPWTWLWMWNWSXBWKXJVNWPWRWOXBWKXJVOWTXAW
        OWSWKXJVPVQWKXCXEXHXIVRWGWHWJXCXJVSXKXFXGWRXFXGXEXIWKXCVTXFXGXEXIWKXCWA
        WPWRWOXBWKXJWBVQWTXAWOWSWKXJWCWKXCXEXHXIWDABCDFGHTUDIJKLMNOPQRSEUCUAUBU
        EUFUGUHUIUJUKULUMUNUOUPWEWF $.

      $( Part of proof of Lemma K of [Crawley] p. 118.  Line 17, p. 119,
         showing Eq. 3 (line 8, p. 119) for the sigma_2 ( ` Z ` ) case.
         (Contributed by NM, 5-Jul-2013.)  (New usage is discouraged.) $)
      cdlemk11u-2N $p |- ( ( ( K e. HL /\ W e. H
              /\ ( R ` F ) = ( R ` N ) )
          /\ ( ( F e. T /\ C e. T /\ N e. T )
                 /\ ( G e. T /\ G =/= ( _I |` B ) )
                 /\ ( X e. T /\ X =/= ( _I |` B ) ) )
          /\ ( ( ( R ` C ) =/= ( R ` F )
               /\ ( R ` G ) =/= ( R ` C )
               /\ ( R ` X ) =/= ( R ` C ) )
            /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
            /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( ( V ` G ) ` P )
              .<_ ( ( ( V ` X ) ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) $=
        ( chlt wcel cfv wceq w3a cid cres wne wa wbr wn ccnv ccom simp11 simp12
        jca simp211 simp212 simp213 simp22l simp23l 3jca simp33 simp32l simp32r
        co simp13 simp22r simp23r simp31 cdlemk11u syl333anc ) PUQURZUANURZLFUS
        ZSFUSUTZVAZLHURZCHURZSHURZVAZMHURZMVBBVCZVDZVEZUBHURZUBWSVDZVEZVAZCFUSZ
        WKVDMFUSXFVDUBFUSXFVDVAZLWSVDZCWSVDZVEZDAURDUAQVFVGVEZVAZVAZWIWJVEWNWOW
        PWRXBVAXKWLXHXIWTVAXCXGDMTUSUSDUBTUSUSUBMVHVIFUSOWBQVFXMWIWJWIWJWLXEXLV
        JWIWJWLXEXLVKVLWNWOWPXAXDWMXLVMWNWOWPXAXDWMXLVNXMWPWRXBWNWOWPXAXDWMXLVO
        WRWTWQXDWMXLVPXBXCWQXAWMXLVQVRWMXEXGXJXKVSWIWJWLXEXLWCXMXHXIWTXHXIXGXKW
        MXEVTXHXIXGXKWMXEWAWRWTWQXDWMXLWDVRXBXCWQXAWMXLWEWMXEXGXJXKWFABCDFGHTUD
        IJKLMNOPQRSEUCUAUBUEUFUGUHUIUJUKULUMUNUOUPWGWH $.
    $}

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 18, p. 119, showing
       Eq. 4 (line 10, p. 119) for the sigma_2 ( ` V ` ) case.  (Contributed by
       NM, 5-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk12u-2N $p |- ( ( ( K e. HL /\ W e. H
            /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ C e. T /\ N e. T )
               /\ ( G e. T /\ G =/= ( _I |` B ) )
               /\ ( X e. T /\ X =/= ( _I |` B ) ) )
        /\ ( ( ( R ` C ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` C )
             /\ ( R ` X ) =/= ( R ` C ) )
          /\ ( ( R ` G ) =/= ( R ` X )
             /\ F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
          /\ ( P e. A /\ -. P .<_ W ) ) )
     -> ( ( V ` G ) ` P ) = ( ( P .\/ ( G ` P ) )
           ./\ ( ( ( V ` X ) ` P ) .\/ ( R ` ( X o. `' G ) ) ) ) ) $=
      ( chlt wcel cfv wceq w3a cid cres wne wa wbr wn co ccnv simp11 simp12 jca
      ccom simp211 simp212 simp213 simp22l simp23l 3jca simp322 simp323 simp22r
      simp33 simp13 simp23r simp321 simp31 cdlemk12u syl333anc ) PUOUPZUANUPZLF
      UQZSFUQURZUSZLHUPZCHUPZSHUPZUSZMHUPZMUTBVAZVBZVCZUBHUPZUBWRVBZVCZUSZCFUQZ
      WJVBMFUQZXEVBUBFUQZXEVBUSZXFXGVBZLWRVBZCWRVBZUSZDAUPDUAQVDVEVCZUSZUSZWHWI
      VCWMWNWOWQXAUSXMWKXJXKWSUSXBXIVCXHDMTUQUQDDMUQOVFDUBTUQUQUBMVGVKFUQOVFRVF
      URXOWHWIWHWIWKXDXNVHWHWIWKXDXNVIVJWMWNWOWTXCWLXNVLWMWNWOWTXCWLXNVMXOWOWQX
      AWMWNWOWTXCWLXNVNWQWSWPXCWLXNVOXAXBWPWTWLXNVPVQWLXDXHXLXMWAWHWIWKXDXNWBXO
      XJXKWSXIXJXKXHXMWLXDVRXIXJXKXHXMWLXDVSWQWSWPXCWLXNVTVQXOXBXIXAXBWPWTWLXNW
      CXIXJXKXHXMWLXDWDVJWLXDXHXLXMWEABCDFGHTUCIJKLMNOPQRSEUAUBUDUEUFUGUHUIUJUK
      ULUMUNWFWG $.

    $d i f G $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Lines 26-27, p. 119 for
       i=0 and j=2.  (Contributed by NM, 5-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk21-2N $p |- ( ( ( K e. HL /\ W e. H
            /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ C e. T /\ N e. T )
               /\ ( G e. T /\ G =/= ( _I |` B ) ) )
        /\ ( ( ( R ` C ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` C ) )
          /\ ( ( R ` G ) =/= ( R ` F )
             /\ F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
          /\ ( P e. A /\ -. P .<_ W ) ) )
     -> ( ( S ` G ) ` P ) = ( ( V ` G ) ` P ) ) $=
      ( chlt wcel cfv wceq w3a cid cres wne wa wbr wn simp11 simp12 jca simp2l1
      simp2l2 simp2l3 simp2rl simp322 simp323 simp2rr simp31l simp31r cdlemk21N
      simp33 simp13 3jca simp321 syl332anc ) PUNUOZUANUOZLFUPZSFUPUQZURZLHUOZCH
      UOZSHUOZURZMHUOZMUSBUTZVAZVBZVBZCFUPZWEVAZMFUPZWQVAZVBZWSWEVAZLWMVAZCWMVA
      ZURZDAUODUAQVCVDVBZURZURZWCWDVBWHWIWJWLVBXFWFXCXDWNURWRWTXBURDMGUPUPDMTUP
      UPUQXHWCWDWCWDWFWPXGVEWCWDWFWPXGVFVGWHWIWJWOWGXGVHWHWIWJWOWGXGVIXHWJWLWHW
      IWJWOWGXGVJWLWNWKWGXGVKVGWGWPXAXEXFVRWCWDWFWPXGVSXHXCXDWNXBXCXDXAXFWGWPVL
      XBXCXDXAXFWGWPVMWLWNWKWGXGVNVTXHWRWTXBWRWTXEXFWGWPVOWRWTXEXFWGWPVPXBXCXDX
      AXFWGWPWAVTABCDFGHTUBIJKLMNOPQRSEUAUCUDUEUFUGUHUIUJUKULUMVQWB $.

    cdlemk2a.o $e |- O = ( S ` D ) $.
    $d k i f d D $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22, p. 119 for the
       i=2, j=1 case.  Note typo on line 22: f should be f_i.  Our ` D ` ,
       ` C ` , ` O ` , ` Q ` , ` U ` , ` V ` represent their f_1, f_2, k_1,
       k_2, sigma_1, sigma_2.  (Contributed by NM, 5-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk20-2N $p |- ( ( ( K e. HL /\ W e. H
            /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ C e. T /\ N e. T )
               /\ ( D e. T /\ D =/= ( _I |` B ) )
               /\ ( C e. T /\ C =/= ( _I |` B ) ) )
        /\ ( ( ( R ` C ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` C ) )
          /\ ( F =/= ( _I |` B ) /\ C =/= ( _I |` B ) )
          /\ ( P e. A /\ -. P .<_ W ) ) )
     -> ( ( V ` D ) ` P ) = ( O ` P ) ) $=
      ( chlt wcel cfv wceq w3a cid cres wne wa wbr wn simp11 simp12 jca simp211
      simp212 simp213 simp22l simp33 simp13 simp32l simp32r simp22r 3jca simp31
      cdlemk20 syl332anc ) PUPUQZUBNUQZMGURZSGURUSZUTZMIUQZCIUQZSIUQZUTZDIUQZDV
      ABVBZVCZVDZWICWMVCZVDZUTZCGURZWEVCDGURZWEVCWTWSVCUTZMWMVCZWPVDZEAUQEUBQVE
      VFVDZUTZUTZWCWDVDWHWIWJWLVDXDWFXBWPWNUTXAEDUAURURETURUSXFWCWDWCWDWFWRXEVG
      WCWDWFWRXEVHVIWHWIWJWOWQWGXEVJWHWIWJWOWQWGXEVKXFWJWLWHWIWJWOWQWGXEVLWLWNW
      KWQWGXEVMVIWGWRXAXCXDVNWCWDWFWRXEVOXFXBWPWNXBWPXAXDWGWRVPXBWPXAXDWGWRVQWL
      WNWKWQWGXEVRVSWGWRXAXCXDVTABDCETGHIUAUCJKLMNOPQRSFUBUDUEUFUGUHUIUJUKULUMU
      NUOWAWB $.

    cdlemk2.u $e |- U = ( e e. T |-> ( iota_ j e. T
        ( j ` P ) = ( ( P .\/ ( R ` e ) )
              ./\ ( ( O ` P ) .\/ ( R ` ( e o. `' D ) ) ) ) ) ) $.
    $d e j ./\ $.  $d e j .<_ $.  $d e j .\/ $.  $d j A $.  $d e j C $.
    $d e j D $.  $d e j F $.  $d e j G $.  $d j H $.  $d j K $.  $d j N $.
    $d e j O $.  $d e j P $.  $d e j R $.  $d e j T $.  $d e j W $.
    $d e f i j $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Lines 26-27, p. 119 for
       i=1 and j=2.  (Contributed by NM, 5-Jul-2013.) $)
    cdlemk22 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ G e. T /\ C e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( C =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` C )
             /\ ( R ` C ) =/= ( R ` F ) )
            /\ ( ( R ` D ) =/= ( R ` F )
              /\ ( R ` G ) =/= ( R ` D )
             /\ ( R ` C ) =/= ( R ` D ) ) ) )
     -> ( ( U ` G ) ` P ) = ( ( V ` G ) ` P ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres co ccnv simp11 simp212 simp22
      wne ccom trljat1 syl3anc simp1 simp211 simp213 jca simp23 simp311 simp312
      simp321 simp331 simp323 simp333 cdlemk20 syl132anc eqcomd trlcocnv simp12
      3jca oveq12d simp322 necomd cdlemkuv2-2 syl333anc simp31 simp33 cdlemk12u
      simp313 syld3an3 3eqtr4rd ) TVAVBUFRVBVCZPIVBZDIVBZVDZUCIVBZQIVBZCIVBZVDZ
      EAVBEUFUAVEVFVCZPGVGZUCGVGVHZVDZPVIBVJZVPZDXTVPZQXTVPZVDZCXTVPZQGVGZCGVGZ
      VPZYGXQVPZVDZDGVGZXQVPZYFYKVPZYGYKVPZVDZVDZVDZEYFSVKZEFVGZQCVLVQGVGZSVKZU
      BVKZEEQVGSVKZECJVGVGZCQVLVQGVGZSVKZUBVKZEQUEVGVGZEQJVGVGZYQYRUUCUUAUUFUBY
      QXHXMXPYRUUCVHXHXIXJXSYPVMZXLXMXNXPXRXKYPVNZXKXOXPXRYPVOZAEGIQRSTUAUFUIUJ
      ULUMUNUOVRVSYQYSUUDYTUUESYQUUDYSYQXKXLXNVCXPXRYAYBYEVDYLYIYNVDUUDYSVHXKXS
      YPVTYQXLXNXLXMXNXPXRXKYPWAZXLXMXNXPXRXKYPWBZWCUULXKXOXPXRYPWDZYQYAYBYEYAY
      BYCYJYOXKXSWEZYAYBYCYJYOXKXSWFYEYHYIYDYOXKXSWGZWPYQYLYIYNYLYMYNYDYJXKXSWH
      YEYHYIYDYOXKXSWIZYLYMYNYDYJXKXSWJWPABCDEFGHIJKLMNPRSTUAUBUCUDUFUHUIUJUKUL
      UMUNUOUPUSUTUQWKWLWMYQXHXMXNYTUUEVHUUJUUKUUNGIQCRTUFUMUNUOWNVSWQWQYQXHXRX
      MXIXNXLYIYGYFVPZVCYAYCYEVDXPUUHUUBVHUUJUUOUUKXHXIXJXSYPWOUUNUUMYQYIUUSUUR
      YQYFYGYEYHYIYDYOXKXSWRZWSWCYQYAYCYEUUPYAYBYCYJYOXKXSXEUUQWPUULABCEFGHILMO
      PQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURWTXAXKXSYPYDYEYHVCZYOVDUUIUUGVHYQY
      DUVAYOXKXSYDYJYOXBYQYEYHUUQUUTWCXKXSYDYJYOXCWPABDEGHIJKLMNPQRSTUAUBUCUDUF
      CUHUIUJUKULUMUNUOUPUSUTXDXFXG $.
  $}

  ${
    cdlemk3.b $e |- B = ( Base ` K ) $.
    cdlemk3.l $e |- .<_ = ( le ` K ) $.
    cdlemk3.j $e |- .\/ = ( join ` K ) $.
    cdlemk3.m $e |- ./\ = ( meet ` K ) $.
    cdlemk3.a $e |- A = ( Atoms ` K ) $.
    cdlemk3.h $e |- H = ( LHyp ` K ) $.
    cdlemk3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk3.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemk3.s $e |- S = ( f e. T |-> ( iota_ i e. T
        ( i ` P ) = ( ( P .\/ ( R ` f ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
    $d d e f i ./\ $.  $d i .<_ $.  $d d e f i .\/ $.  $d i A $.
    $d d e f i j D $.  $d f i F $.  $d d e j G $.  $d i H $.  $d i K $.
    $d f i N $.  $d d e f i P $.  $d d e Q $.  $d d e f i R $.  $d d e f i T $.
    $d d e f i W $.  $d d e i j f $.  $d f i b $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.  Part
       of attempt to simplify hypotheses.  (Contributed by NM, 17-Jul-2013.) $)
    cdlemk30 $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ b e. T /\ N e. T )
           /\ ( ( R ` b ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ b =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( ( S ` b ) ` P ) = ( ( P .\/ ( R ` b ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( b o. `' F ) ) ) ) ) $=
      ( chlt wcel wa cfv wceq cv w3a wne cid cres wn co ccnv ccom simp1l simp21
      simp22 simp23 simp33 simp1r simp32l simp32r simp31 cdlemksv2 syl333anc
      wbr ) LUGUHPJUHUIZIDUJZODUJUKZUIZIFUHZQULZFUHZOFUHZUMZVRDUJZVNUNZIUOBUPZU
      NZVRWDUNZUIZCAUHCPMVLUQUIZUMZUMVMVQVSVTWHVOWEWFWCCVREUJUJCWBKURCOUJVRIUSU
      TDUJKURNURUKVMVOWAWIVAVPVQVSVTWIVBVPVQVSVTWIVCVPVQVSVTWIVDVPWAWCWGWHVEVMV
      OWAWIVFWEWFWCWHVPWAVGWEWFWCWHVPWAVHVPWAWCWGWHVIABCDEFGHIVRJKLMNOPRSTUBUCU
      DUEUAUFVJVK $.

    cdlemk3.u1 $e |- Y = ( d e. T , e e. T
          |-> ( iota_ j e. T
        ( j ` P ) = ( ( P .\/ ( R ` e ) )
              ./\ ( ( ( S ` d ) ` P )
                .\/ ( R ` ( e o. `' d ) ) ) ) ) ) $.

    ${
      cdlemk3.o2 $e |- Q = ( S ` D ) $.
      cdlemk3.u2 $e |- Z = ( e e. T |-> ( iota_ j e. T
          ( j ` P ) = ( ( P .\/ ( R ` e ) )
                ./\ ( ( Q ` P ) .\/ ( R ` ( e o. `' D ) ) ) ) ) ) $.
      $( Convert between function and operation forms of ` Y ` .  TODO:  Use
         operation form everywhere.  (Contributed by NM, 6-Jul-2013.) $)
      cdlemkuu $p |- ( ( D e. T /\ G e. T )
         -> ( D Y G ) = ( Z ` G ) ) $=
        ( wcel wa co cfv ccnv ccom wceq crio fveq2 syl6eqr fveq1d coeq2d fveq2d
        cv cnveq oveq12d oveq2d eqeq2d riotabidv riotaex ovmpt2 cdlemksv adantl
        coeq1 eqtr4d ) CHUQZNHUQZURCNUBUSDLVJUTZDNFUTZPUSZDEUTZNCVAZVBZFUTZPUSZ
        SUSZVCZLHVDZNUCUTZUDICNHHWDDIVJZFUTZPUSZDUDVJZGUTZUTZWPWSVAZVBZFUTZPUSZ
        SUSZVCZLHVDWNUBWDWRWGWPWHVBZFUTZPUSZSUSZVCZLHVDWSCVCZXGXLLHXMXFXKWDXMXE
        XJWRSXMXAWGXDXIPXMDWTEXMWTCGUTEWSCGVEUOVFVGXMXCXHFXMXBWHWPWSCVKVHVIVLVM
        VNVOWPNVCZXLWMLHXNXKWLWDXNWRWFXJWKSXNWQWEDPWPNFVEVMXNXIWJWGPXNXHWIFWPNW
        HVTVIVMVLVNVOUNWMLHVPVQWCWOWNVCWBABDFUCHILCNOPQRSEUAUEUFUGUIUJUKULUHUPV
        RVSWA $.
    $}

    $d j ./\ $.  $d j .<_ $.  $d j .\/ $.  $d j A $.  $d j F $.  $d j H $.
    $d j K $.  $d j N $.  $d j P $.  $d j R $.  $d d e j b S $.  $d j T $.
    $d j W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.  Part
       of attempt to simplify hypotheses.  (Contributed by NM, 17-Jul-2013.) $)
    cdlemk31 $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( ( F e. T /\ b e. T /\ N e. T ) /\ G e. T )
           /\ ( ( ( R ` b ) =/= ( R ` F ) /\ ( R ` b ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ b =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( ( b Y G ) ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( ( S ` b ) ` P )
                .\/ ( R ` ( G o. `' b ) ) ) ) ) $=
      ( chlt wcel wa cfv wceq cv w3a wne cid cres wbr wn co ccnv ccom crio cmpt
      simp2l2 simp2r eqid cdlemkuu syl2anc fveq1d simp1l simp1r simp321 simp323
      simp2l simp31 simp322 3jca simp33 cdlemkuv2 syl313anc eqtrd ) OUMUNSMUNUO
      ZKDUPZRDUPUQZUOZKFUNZUAURZFUNZRFUNZUSZLFUNZUOZWMDUPZWIUTWSLDUPZUTUOZKVABV
      BZUTZWMXBUTZLXBUTZUSZCAUNCSPVCVDUOZUSZUSZCWMLTVEZUPCLGFCJURUPCGURZDUPNVEC
      WMEUPZUPZXKWMVFZVGDUPNVEQVEUQJFVHVIZUPZUPZCWTNVEXMLXNVGDUPNVEQVEZXICXJXPX
      IWNWQXJXPUQWLWNWOWQWKXHVJWKWPWQXHVKZABWMCXLDEFGHIJKLMNOPQRSTXOUBUCUDUEUFU
      GUHUIUJUKULXLVLZXOVLZVMVNVOXIWHWJWQWPXAXCXEXDUSXGXQXRUQWHWJWRXHVPWHWJWRXH
      VQXSWKWPWQXHVTWKWRXAXFXGWAXIXCXEXDXCXDXEXAXGWKWRVRXCXDXEXAXGWKWRVSXCXDXEX
      AXGWKWRWBWCWKWRXAXFXGWDABWMCDEFXOGHIJKLMNOPQRXLSUCUDUEUFUGUHUIUJUKXTYAWEW
      FWG $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.  Part
       of attempt to simplify hypotheses.  (Contributed by NM, 17-Jul-2013.) $)
    cdlemk32 $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( ( F e. T /\ b e. T /\ N e. T ) /\ G e. T )
           /\ ( ( ( R ` b ) =/= ( R ` F ) /\ ( R ` b ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ b =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( ( b Y G ) ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( ( P .\/ ( R ` b ) )
                     ./\ ( ( N ` P ) .\/ ( R ` ( b o. `' F ) ) ) )
                .\/ ( R ` ( G o. `' b ) ) ) ) ) $=
      ( chlt wcel wa cfv wceq cv w3a wne cid cres wbr wn co ccnv cdlemk31 simp1
      simp2l simp31l simp321 simp322 jca simp33 cdlemk30 syl113anc oveq1d eqtrd
      ccom oveq2d ) OUMUNSMUNUOKDUPZRDUPUQUOZKFUNUAURZFUNRFUNUSZLFUNZUOZWCDUPZW
      AUTZWGLDUPZUTZUOZKVABVBZUTZWCWLUTZLWLUTZUSZCAUNCSPVCVDUOZUSZUSZCWCLTVEUPC
      WINVEZCWCEUPUPZLWCVFVSDUPZNVEZQVEWTCWGNVECRUPWCKVFVSDUPNVEQVEZXBNVEZQVEAB
      CDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVGWSXCXEWTQWSXAXDXBNWSWBWDWHWMW
      NUOWQXAXDUQWBWFWRVHWBWDWEWRVIWHWJWPWQWBWFVJWSWMWNWMWNWOWKWQWBWFVKWMWNWOWK
      WQWBWFVLVMWBWFWKWPWQVNABCDEFHIKMNOPQRSUAUCUDUEUFUGUHUIUJUKVOVPVQVTVR $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Conditions for the
       sigma_2 (p) function to be a translation.  TODO: combine ~ cdlemkj ?
       (Contributed by NM, 11-Jul-2013.) $)
    cdlemkuel-3 $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
       -> ( D Y G ) e. T ) $=
      ( chlt wcel wa cfv wceq w3a wne cid cres wbr wn co cv ccnv ccom crio cmpt
      simp22 simp13 eqid cdlemkuu syl2anc cdlemkuel eqeltrd ) PUMUNTNUNUOZLEUPZ
      SEUPUQZMGUNZURZLGUNZCGUNZSGUNZURZCEUPZVRUSWFMEUPUSUOLUTBVAZUSMWGUSCWGUSUR
      DAUNDTQVBVCUOURZURZCMUAVDZMHGDKVEUPDHVEZEUPOVDDCFUPZUPWKCVFVGEUPOVDRVDUQK
      GVHVIZUPZGWIWCVTWJWNUQWAWBWCWDWHVJVQVSVTWEWHVKABCDWLEFGHIJKLMNOPQRSTUAWMU
      BUCUDUEUFUGUHUIUJUKULWLVLZWMVLZVMVNABCDEFGWMHIJKLMNOPQRSWLTUCUDUEUFUGUHUI
      UJUKWOWPVOVP $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 16 on p. 119 for i =
       1, where sigma_2 (p) is ` Y ` , f_1 is ` D ` , and k_1 is ` O ` .
       (Contributed by NM, 6-Jul-2013.)  (New usage is discouraged.) $)
    cdlemkuv2-3N $p |- ( ( ( ( K e. HL /\ W e. H )
                  /\ ( R ` F ) = ( R ` N )
                  /\ G e. T )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( ( R ` D ) =/= ( R ` F )
                /\ ( R ` D ) =/= ( R ` G ) )
             /\ ( F =/= ( _I |` B ) /\ G =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
 -> ( ( D Y G ) ` P ) = ( ( P .\/ ( R ` G ) )
       ./\ ( ( ( S ` D ) ` P ) .\/ ( R ` ( G o. `' D ) ) ) ) ) $=
      ( chlt wcel wa cfv wceq w3a wne cid cres wbr wn co cv ccnv ccom crio cmpt
      simp22 simp13 eqid cdlemkuu syl2anc fveq1d cdlemkuv2 eqtrd ) PUMUNTNUNUOZ
      LEUPZSEUPUQZMGUNZURZLGUNZCGUNZSGUNZURZCEUPZVSUSWGMEUPZUSUOLUTBVAZUSMWIUSC
      WIUSURDAUNDTQVBVCUOURZURZDCMUAVDZUPDMHGDKVEUPDHVEZEUPOVDDCFUPZUPZWMCVFZVG
      EUPOVDRVDUQKGVHVIZUPZUPDWHOVDWOMWPVGEUPOVDRVDWKDWLWRWKWDWAWLWRUQWBWCWDWEW
      JVJVRVTWAWFWJVKABCDWNEFGHIJKLMNOPQRSTUAWQUBUCUDUEUFUGUHUIUJUKULWNVLZWQVLZ
      VMVNVOABCDEFGWQHIJKLMNOPQRSWNTUCUDUEUFUGUHUIUJUKWSWTVPVQ $.

    $d d e F $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 22 on p. 119.
       ` N ` , ` Y ` , ` O ` , ` D ` are k, sigma_2 (p), k_1, f_1.
       (Contributed by NM, 7-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk18-3N $p |- ( ( ( K e. HL /\ W e. H
                  /\ ( R ` F ) = ( R ` N ) )
           /\ ( F e. T /\ D e. T /\ N e. T )
           /\ ( ( R ` D ) =/= ( R ` F )
             /\ ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) )
             /\ ( P e. A /\ -. P .<_ W ) ) )
      -> ( ( D Y F ) ` P ) = ( N ` P ) ) $=
      ( chlt wcel cfv wceq w3a wne cid cres wa wbr wn co cv ccnv ccom crio cmpt
      simp22 simp21 eqid cdlemkuu syl2anc fveq1d cdlemk18-2N eqtr4d ) OULUMSMUM
      LEUNZREUNUOUPZLGUMZCGUMZRGUMZUPCEUNVQUQLURBUSZUQCWBUQUTDAUMDSPVAVBUTUPZUP
      ZDCLTVCZUNDLHGDKVDUNDHVDZEUNNVCDCFUNZUNWFCVEVFEUNNVCQVCUOKGVGVHZUNZUNDRUN
      WDDWEWIWDVTVSWEWIUOVRVSVTWAWCVIVRVSVTWAWCVJABCDWGEFGHIJKLLMNOPQRSTWHUAUBU
      CUDUEUFUGUHUIUJUKWGVKZWHVKZVLVMVNABCDWGEFGIJKLMNOPQRWHSHUBUCUDUEUFUGUHUIU
      JWJWKVOVP $.

    $d e .<_ $.  $d d e f i j C $.  $d f i G $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Lines 26-27, p. 119 for
       i=1 and j=2.  (Contributed by NM, 7-Jul-2013.) $)
    cdlemk22-3 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ D e. T )
       /\ ( ( N e. T /\ G e. T /\ C e. T )
          /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
       /\ ( ( F =/= ( _I |` B ) /\ D =/= ( _I |` B ) /\ G =/= ( _I |` B ) )
          /\ ( C =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` C )
             /\ ( R ` C ) =/= ( R ` F ) )
            /\ ( ( R ` D ) =/= ( R ` F )
              /\ ( R ` G ) =/= ( R ` D )
             /\ ( R ` C ) =/= ( R ` D ) ) ) )
     -> ( ( D Y G ) ` P ) = ( ( C Y G ) ` P ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne cv co ccnv ccom crio cmpt
      eqid cdlemk22 simp13 simp212 cdlemkuu syl2anc fveq1d simp213 3eqtr4d ) QU
      NUOUAOUOUPZMHUOZDHUOZUQZTHUOZNHUOZCHUOZUQEAUOEUARURUSUPZMFUTZTFUTVAZUQZMV
      BBVCZVDDWKVDNWKVDUQCWKVDNFUTZCFUTZVDWMWHVDUQDFUTZWHVDWLWNVDWMWNVDUQUQZUQZ
      ENIHELVEUTZEIVEZFUTPVFZEDGUTZUTWRDVGVHFUTPVFSVFVALHVIVJZUTZUTENIHWQWSECGU
      TZUTWRCVGVHFUTPVFSVFVALHVIVJZUTZUTEDNUBVFZUTECNUBVFZUTABCDEXCFGHXAIJKLLMN
      OPQRSTWTXDUAIUDUEUFUGUHUIUJUKULXCVKZXDVKZWTVKZXAVKZVLWPEXFXBWPWBWEXFXBVAV
      TWAWBWJWOVMWDWEWFWGWIWCWOVNZABDEWTFGHIJKLMNOPQRSTUAUBXAUCUDUEUFUGUHUIUJUK
      ULUMXJXKVOVPVQWPEXGXEWPWFWEXGXEVAWDWEWFWGWIWCWOVRXLABCEXCFGHIJKLMNOPQRSTU
      AUBXDUCUDUEUFUGUHUIUJUKULUMXHXIVOVPVQVS $.

    $d d e f i j x $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Eliminate the
       ` ( R `` C ) =/= ( R `` D ) ` requirement from ~ cdlemk22-3 .
       (Contributed by NM, 7-Jul-2013.) $)
    cdlemk23-3 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ D e. T /\ N e. T )
          /\ ( G e. T /\ C e. T /\ x e. T ) )
       /\ ( ( P e. A /\ -. P .<_ W )
          /\ ( ( R ` F ) = ( R ` N ) /\ F =/= ( _I |` B )
             /\ D =/= ( _I |` B ) )
          /\ ( G =/= ( _I |` B ) /\ C =/= ( _I |` B )
             /\ x =/= ( _I |` B ) ) )
       /\ ( ( ( R ` G ) =/= ( R ` C ) /\ ( R ` C ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` F ) )
         /\ ( ( R ` G ) =/= ( R ` D ) /\ ( R ` x ) =/= ( R ` C ) )
         /\ ( ( R ` x ) =/= ( R ` D ) /\ ( R ` x ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` x ) ) ) )
     -> ( ( D Y G ) ` P ) = ( ( C Y G ) ` P ) ) $=
      ( chlt wcel wa w3a cv wbr wn cfv wceq cid cres wne simp11 simp121 simp122
      co simp123 simp131 simp133 simp21 simp221 simp222 simp223 simp231 simp233
      3jca simp333 simp332 simp313 simp32l simp331 cdlemk22-3 syl333anc simp132
      simp232 simp312 simp311 simp32r eqtr4d ) RUOUPUBPUPUQZNIUPZEIUPZUAIUPZURZ
      OIUPZDIUPZAUSZIUPZURZURZFBUPFUBSUTVAUQZNGVBZUAGVBVCZNVDCVEZVFZEXHVFZURZOX
      HVFZDXHVFZXAXHVFZURZURZOGVBZDGVBZVFZXRXFVFZEGVBZXFVFZURZXQYAVFZXAGVBZXRVF
      ZUQZYEYAVFZYEXFVFZXQYEVFZURZURZURZFEOUCVJVBZFXAOUCVJVBZFDOUCVJVBZYMWNWOWP
      WQWSXBURZXEXGXIXJXLURXNYJYIURZYBYDYHURYNYOVCWNWRXCXPYLVGZWOWPWQWNXCXPYLVH
      ZWOWPWQWNXCXPYLVIYMWQWSXBWOWPWQWNXCXPYLVKWSWTXBWNWRXPYLVLWSWTXBWNWRXPYLVM
      VTZXDXEXKXOYLVNZXGXIXJXEXOXDYLVOZYMXIXJXLXGXIXJXEXOXDYLVPZXGXIXJXEXOXDYLV
      QXLXMXNXEXKXDYLVRZVTYMXNYJYIXLXMXNXEXKXDYLVSYHYIYJYCYGXDXPWAYHYIYJYCYGXDX
      PWBVTZYMYBYDYHXSXTYBYGYKXDXPWCYDYFYCYKXDXPWDYHYIYJYCYGXDXPWEVTBCXAEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNWFWGYMWNWOWTYQXEXGXIXMXLURYRXTXSYFUR
      YPYOVCYSYTWSWTXBWNWRXPYLWHUUAUUBUUCYMXIXMXLUUDXLXMXNXEXKXDYLWIUUEVTUUFYMX
      TXSYFXSXTYBYGYKXDXPWJXSXTYBYGYKXDXPWKYDYFYCYKXDXPWLVTBCXADFGHIJKLMNOPQRST
      UAUBUCUDUEUFUGUHUIUJUKULUMUNWFWGWM $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Eliminate the
       ` ( R `` x ) =/= ( R `` C ) ` requirement from ~ cdlemk23-3 using
       ` ( R `` C ) = ( R `` D ) ` .  (Contributed by NM, 7-Jul-2013.) $)
    cdlemk24-3 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ D e. T /\ N e. T )
          /\ ( G e. T /\ C e. T /\ x e. T ) )
       /\ ( ( P e. A /\ -. P .<_ W )
          /\ ( ( R ` F ) = ( R ` N ) /\ F =/= ( _I |` B )
             /\ D =/= ( _I |` B ) )
          /\ ( G =/= ( _I |` B ) /\ C =/= ( _I |` B )
             /\ x =/= ( _I |` B ) ) )
       /\ ( ( ( R ` G ) =/= ( R ` C ) /\ ( R ` C ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` F ) )
         /\ ( ( R ` G ) =/= ( R ` D ) /\ ( R ` C ) = ( R ` D ) )
         /\ ( ( R ` x ) =/= ( R ` D ) /\ ( R ` x ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` x ) ) ) )
     -> ( ( D Y G ) ` P ) = ( ( C Y G ) ` P ) ) $=
      ( chlt wcel wa w3a cv wbr wn cfv wceq cid cres wne simp31 simp32l simp331
      co simp32r neeqtrrd jca simp33 3jca cdlemk23-3 syld3an3 ) RUOUPUBPUPUQNIU
      PEIUPUAIUPUROIUPDIUPAUSZIUPURURZFBUPFUBSUTVAUQNGVBZUAGVBVCNVDCVEZVFEWAVFU
      ROWAVFDWAVFVRWAVFURURZOGVBZDGVBZVFWDVTVFEGVBZVTVFURZWCWEVFZWDWEVCZUQZVRGV
      BZWEVFZWJVTVFZWCWJVFZURZURZWFWGWJWDVFZUQZWNURFEOUCVJVBFDOUCVJVBVCVSWBWOUR
      ZWFWQWNVSWBWFWIWNVGWRWGWPWGWHWFWNVSWBVHWRWJWEWDWKWLWMWFWIVSWBVIWGWHWFWNVS
      WBVKVLVMVSWBWFWIWNVNVOABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVPV
      Q $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Eliminate the
       ` ( R `` C ) = ( R `` D ) ` requirement from ~ cdlemk24-3 .
       (Contributed by NM, 7-Jul-2013.) $)
    cdlemk25-3 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ D e. T /\ N e. T )
          /\ ( G e. T /\ C e. T /\ x e. T ) )
       /\ ( ( P e. A /\ -. P .<_ W )
          /\ ( ( R ` F ) = ( R ` N ) /\ F =/= ( _I |` B )
             /\ D =/= ( _I |` B ) )
          /\ ( G =/= ( _I |` B ) /\ C =/= ( _I |` B )
             /\ x =/= ( _I |` B ) ) )
       /\ ( ( ( R ` G ) =/= ( R ` C ) /\ ( R ` C ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` F ) )
              /\ ( R ` G ) =/= ( R ` D )
         /\ ( ( R ` x ) =/= ( R ` D ) /\ ( R ` x ) =/= ( R ` F )
             /\ ( R ` G ) =/= ( R ` x ) ) ) )
     -> ( ( D Y G ) ` P ) = ( ( C Y G ) ` P ) ) $=
      ( chlt wcel wa w3a cv wbr wn cfv wceq cid cres wne simpl1 simpl31 simpl32
      simpl2 simpr jca simpl33 cdlemk24-3 syl113anc simp11 simp121 simp122 3jca
      co adantr simp123 simp131 simp132 simp221 simp222 simp223 simp231 simp232
      simp21 simp311 simp312 simp313 cdlemk22-3 pm2.61dane ) RUOUPUBPUPUQZNIUPZ
      EIUPZUAIUPZURZOIUPZDIUPZAUSZIUPZURZURZFBUPFUBSUTVAUQZNGVBZUAGVBVCZNVDCVEZ
      VFZEXJVFZURZOXJVFZDXJVFZXCXJVFZURZURZOGVBZDGVBZVFZXTXHVFZEGVBZXHVFZURZXSY
      CVFZXCGVBZYCVFYGXHVFXSYGVFURZURZURZFEOUCVTVBFDOUCVTVBVCZXTYCYJXTYCVCZUQZX
      FXRYEYFYLUQYHYKXFXRYIYLVGXFXRYIYLVJYEYFYHXFXRYLVHYMYFYLYEYFYHXFXRYLVIYJYL
      VKVLYEYFYHXFXRYLVMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVNVOYJX
      TYCVFZUQZWPWQWRURZWSXAXBURZXGXIURZXKXLXNURZXOYAYBURZYDYFYNURYKYJYPYNYJWPW
      QWRWPWTXEXRYIVPWQWRWSWPXEXRYIVQWQWRWSWPXEXRYIVRVSWAYJYRYNYJYQXGXIYJWSXAXB
      WQWRWSWPXEXRYIWBXAXBXDWPWTXRYIWCXAXBXDWPWTXRYIWDVSXFXGXMXQYIWJXIXKXLXGXQX
      FYIWEVSWAYJYSYNYJXKXLXNXIXKXLXGXQXFYIWFXIXKXLXGXQXFYIWGXNXOXPXGXMXFYIWHVS
      WAYJYTYNYJXOYAYBXNXOXPXGXMXFYIWIYAYBYDYFYHXFXRWKYAYBYDYFYHXFXRWLVSWAYOYDY
      FYNYJYDYNYAYBYDYFYHXFXRWMWAYEYFYHXFXRYNVIYJYNVKVSBCDEFGHIJKLMNOPQRSTUAUBU
      CUDUEUFUGUHUIUJUKULUMUNWNVOWO $.

    $d u x .<_ $.  $d u x A $.  $d u x B $.  $d u x D $.  $d u x F $.
    $d u x G $.  $d u x H $.  $d u x K $.  $d u x N $.  $d u x P $.
    $d u x R $.  $d u x T $.  $d u x Y $.  $d u x W $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       14-Jul-2013.) $)
    cdlemk26b-3 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ ( G e. T /\ G =/= ( _I |` B )
                /\ ( R ` F ) = ( R ` N ) ) )
        /\ ( P e. A /\ -. P .<_ W ) )
   -> E. x e. T ( ( x =/= ( _I |` B )
          /\ ( R ` x ) =/= ( R ` F )
             /\ ( R ` x ) =/= ( R ` G ) )
         /\ ( x Y G ) e. T ) ) $=
      ( chlt wcel wa cid cres wne w3a cfv wceq wbr wn wrex simpl1 cdlemftr2 syl
      simp3r simp11 simp133 simp131 simp121 simp123 simp3r2 simp3r3 jca simp122
      cv co simp3l simp132 simp3r1 simp2 cdlemkuel-3 syl333anc 3expia reximdvai
      3jca exp3a mpd ) PUMUNTNUNUOZLGUNZLUPCUQZURZSGUNZUSZMGUNZMWMURZLEUTZSEUTV
      AZUSZUSZDBUNDTQVBVCUOZUOZAVRZWMURZXEEUTZWSURZXGMEUTZURZUSZAGVDZXKXEMUAVSG
      UNZUOZAGVDXDWKXLWKWPXAXCVECEGANPTWSXIUCUHUIUJVFVGXDXKXNAGXDXEGUNZXKXNXBXC
      XOXKUOZXNXBXCXPUSZXKXMXBXCXOXKVHXQWKWTWQWLXOWOXHXJUOWNWRXFUSXCXMWKWPXAXCX
      PVIWQWRWTWKWPXCXPVJWQWRWTWKWPXCXPVKWLWNWOWKXAXCXPVLXBXCXOXKVTWLWNWOWKXAXC
      XPVMXQXHXJXFXHXJXOXBXCVNXFXHXJXOXBXCVOVPXQWNWRXFWLWNWOWKXAXCXPVQWQWRWTWKW
      PXCXPWAXFXHXJXOXBXCWBWHXBXCXPWCBCXEDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
      KULWDWEVPWFWIWGWJ $.

    $d u x C $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Eliminate the ` x `
       requirements from ~ cdlemk25-3 .  (Contributed by NM, 10-Jul-2013.) $)
    cdlemk26-3 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ D e. T /\ N e. T )
          /\ ( G e. T /\ C e. T ) )
       /\ ( ( P e. A /\ -. P .<_ W )
          /\ ( ( R ` F ) = ( R ` N ) /\ F =/= ( _I |` B )
             /\ D =/= ( _I |` B ) )
          /\ ( G =/= ( _I |` B ) /\ C =/= ( _I |` B ) ) )
       /\ ( ( ( R ` G ) =/= ( R ` C ) /\ ( R ` C ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` F ) )
         /\ ( R ` G ) =/= ( R ` D ) ) )
     -> ( ( D Y G ) ` P ) = ( ( C Y G ) ` P ) ) $=
      ( vx chlt wcel wa w3a wbr wn cfv wceq cid cres cv wrex co simp11l simp11r
      wne cdlemftr3 syl2anc simp111 simp112 simp13l 3ad2ant1 simp13r simp2 3jca
      simp121 simp122 simp23l simp23r simp3l simp3r3 simp3r1 simp3r2 cdlemk25-3
      necomd syl333anc rexlimdv3a mpd ) QUOUPZUAOUPZUQZMHUPDHUPTHUPURZNHUPZCHUP
      ZUQZURZEAUPEUARUSUTUQZMFVAZTFVAVBMVCBVDZVJDXCVJURZNXCVJZCXCVJZUQZURZNFVAZ
      CFVAZVJXJXBVJDFVAZXBVJURZXIXKVJZUQZURZUNVEZXCVJZXPFVAZXBVJZXRXIVJZXRXKVJZ
      URZUQZUNHVFZEDNUBVGVAECNUBVGVAVBZXOWMWNYDWMWNWPWSXHXNVHWMWNWPWSXHXNVIBFHU
      NOQUAXBXIXKUDUIUJUKVKVLXOYCYEUNHXOXPHUPZYCURZWOWPWQWRYFURXAXDXEXFXQURXLXM
      YAXSXIXRVJZURYEWOWPWSXHXNYFYCVMWOWPWSXHXNYFYCVNYGWQWRYFXOYFWQYCWQWRWOWPXH
      XNVOVPXOYFWRYCWQWRWOWPXHXNVQVPXOYFYCVRVSXAXDXGWTXNYFYCVTXAXDXGWTXNYFYCWAY
      GXEXFXQXOYFXEYCXEXFXAXDWTXNWBVPXOYFXFYCXEXFXAXDWTXNWCVPXOYFXQYBWDVSXLXMWT
      XHYFYCVOXLXMWTXHYFYCVQYGYAXSYHXSXTYAXQXOYFWEXSXTYAXQXOYFWFYGXRXIXSXTYAXQX
      OYFWGWIVSUNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMWHWJWKWL $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Eliminate the ` P ` from
       the conclusion of ~ cdlemk25-3 .  (Contributed by NM, 10-Jul-2013.) $)
    cdlemk27-3 $p |- ( ( ( ( K e. HL /\ W e. H )
          /\ ( F e. T /\ D e. T /\ N e. T )
          /\ ( G e. T /\ C e. T ) )
       /\ ( ( P e. A /\ -. P .<_ W )
          /\ ( ( R ` F ) = ( R ` N ) /\ F =/= ( _I |` B )
             /\ D =/= ( _I |` B ) )
          /\ ( G =/= ( _I |` B ) /\ C =/= ( _I |` B ) ) )
       /\ ( ( ( R ` G ) =/= ( R ` C ) /\ ( R ` C ) =/= ( R ` F )
             /\ ( R ` D ) =/= ( R ` F ) )
         /\ ( R ` G ) =/= ( R ` D ) ) )
     -> ( D Y G ) = ( C Y G ) ) $=
      ( chlt wcel wa w3a wbr wn cfv wceq cid cres wne co simp11 simp221 simp13l
      simp12 simp3l3 simp3r necomd jca simp222 simp23l simp223 3jca cdlemkuel-3
      simp21 syl313anc simp121 simp13r simp123 simp3l2 simp3l1 syl333anc cdlemd
      simp23r cdlemk26-3 syl311anc ) QUNUOUAOUOUPZMHUOZDHUOZTHUOZUQZNHUOZCHUOZU
      PZUQZEAUOEUARURUSUPZMFUTZTFUTVAZMVBBVCZVDZDXCVDZUQZNXCVDZCXCVDZUPZUQZNFUT
      ZCFUTZVDZXLXAVDZDFUTZXAVDZUQZXKXOVDZUPZUQZWKDNUBVEZHUOZCNUBVEZHUOZWTEYAUT
      EYCUTVAYAYCVAWKWOWRXJXSVFZXTWKXBWPWOXPXOXKVDZUPXDXGXEUQWTYBYEXBXDXEWTXIWS
      XSVGZWPWQWKWOXJXSVHZWKWOWRXJXSVIXTXPYFXMXNXPXRWSXJVJXTXKXOWSXJXQXRVKVLVMX
      TXDXGXEXBXDXEWTXIWSXSVNZXGXHWTXFWSXSVOZXBXDXEWTXIWSXSVPVQWSWTXFXIXSVSZABD
      EFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVRVTXTWKXBWPWLWQWNXNXLXKVDZUPXD
      XGXHUQWTYDYEYGYHWLWMWNWKWRXJXSWAWPWQWKWOXJXSWBWLWMWNWKWRXJXSWCXTXNYLXMXNX
      PXRWSXJWDXTXKXLXMXNXPXRWSXJWEVLVMXTXDXGXHYIYJXGXHWTXFWSXSWHVQYKABCEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVRWFYKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUF
      UGUHUIUJUKULUMWIAEHYAYCOQRUAUEUHUIUJWGWJ $.

    $d a b .<_ $.  $d a b A $.  $d a b z B $.  $d a b z F $.  $d a b z G $.
    $d a b H $.  $d a b K $.  $d a b N $.  $d a b P $.  $d a b z R $.
    $d a b z T $.  $d a b z W $.  $d a b z Y $.  $d a b d e f i j z $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  (Contributed by NM,
       14-Jul-2013.) $)
    cdlemk28-3 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> E. z e. T A. b e. T
          ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ->
          z = ( b Y G ) ) ) $=
      ( va chlt wcel wa cid cres wne w3a wbr wn wceq cv co wrex wi wral simp21l
      cfv simp1 simp21r simp23 3jca simp22l simp22r simp3r cdlemk26b-3 syl31anc
      simp3l simp11 3ad2ant1 simp2l simp123 jca simp13l simp13r simp3l1 simp3r1
      simp2r simp3r3 necomd simp3r2 simp3l2 cdlemk27-3 syl332anc 3exp ralrimivv
      simp3l3 weq neeq1 fveq2 neeq1d 3anbi123d oveq1 reusv3 biimpd sylc ) PUOUP
      TNUPUQZLGUPZLURCUSZUTZUQZMGUPZMXLUTZUQZSGUPZVAZDBUPDTQVBVCUQZLEVKZSEVKVDZ
      UQZVAZUBVEZXLUTZYEEVKZYAUTZYGMEVKZUTZVAZYEMUAVFZGUPUQUBGVGZYKUNVEZXLUTZYN
      EVKZYAUTZYPYIUTZVAZUQZYLYNMUAVFZVDZVHZUNGVIUBGVIZYKAVEYLVDVHUBGVIAGVGZYDX
      JXKXMXRVAXOXPYBVAXTYMXJXSYCVLYDXKXMXRXKXMXQXRXJYCVJZXKXMXQXRXJYCVMZXJXNXQ
      XRYCVNVOYDXOXPYBXOXPXNXRXJYCVPZXOXPXNXRXJYCVQZXJXSXTYBVRVOXJXSXTYBWAUBBCD
      EFGHIJKLMNOPQRSTUAUCUDUEUFUGUHUIUJUKULUMVSVTYDUUCUBUNGGYDYEGUPZYNGUPZUQZY
      TUUBYDUULYTVAZXJXKUUJXRVAXOUUKUQXTYBXMYFVAXPYOUQYIYPUTZYQYHVAYIYGUTUUBXJX
      SYCUULYTWBUUMXKUUJXRYDUULXKYTUUFWCYDUUJUUKYTWDXNXQXRXJYCUULYTWEVOUUMXOUUK
      YDUULXOYTUUHWCYDUUJUUKYTWKWFXTYBXJXSUULYTWGUUMYBXMYFXTYBXJXSUULYTWHYDUULX
      MYTUUGWCYFYHYJYSYDUULWIVOUUMXPYOYDUULXPYTUUIWCYOYQYRYKYDUULWJWFUUMUUNYQYH
      UUMYPYIYOYQYRYKYDUULWLWMYOYQYRYKYDUULWNYFYHYJYSYDUULWOVOUUMYGYIYFYHYJYSYD
      UULWTWMBCYNYEDEFGHIJKLMNOPQRSTUAUCUDUEUFUGUHUIUJUKULUMWPWQWRWSYMUUDUUEYKY
      SAUBUNGGYLUUAUBUNXAZYFYOYHYQYJYRYEYNXLXBUUOYGYPYAYEYNEXCZXDUUOYGYPYIUUPXD
      XEYEYNMUAXFXGXHXI $.

    cdlemk3.x $e |- X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` G )
               ) -> z = ( b Y G ) ) ) $.

    $d z .<_ $.  $d z A $.  $d z H $.  $d z K $.  $d z N $.  $d z P $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.  Part
       of attempt to simplify hypotheses.  TODO: not needed, is embodied in
       ~ cdlemk34 .  (Contributed by NM, 18-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemk33N $p |- ( ( ( K e. HL /\ W e. H
            /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ ( G e. T /\ G =/= ( _I |` B ) )
            /\ ( P e. A /\ -. P .<_ W ) ) )
       -> X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` G )
               ) -> ( z ` P ) = ( ( b Y G ) ` P ) ) ) ) $=
      ( chlt wcel cfv wceq w3a cid cres wne wa wn cv co wi wral crio wb simpl11
      wbr fveq1 simpl12 jca simpl31 simp11 simp12 simp13 simp22l adantr simp211
      simp32 simp213 simp332 simp333 simp212 simp22r simp331 simp23 cdlemkuel-3
      3jca syl3anc simpl23 simpr cdlemd syl311anc ex impbid2 3expia 3expd imp31
      pm5.74d ralbidva riotabidva syl5eq ) PUPUQZTNUQZLEURZSEURUSZUTZLGUQZLVACV
      BZVCZSGUQZUTZMGUQZMXNVCZVDZDBUQDTQVMVEVDZUTZVDZUAUCVFZXNVCZYDEURZXJVCZYFM
      EURVCZUTZAVFZYDMUBVGZUSZVHZUCGVIZAGVJYIDYJURDYKURUSZVHZUCGVIZAGVJUOYCYNYQ
      AGYCYJGUQZVDZYMYPUCGYSYDGUQZVDYIYLYOYCYRYTYIYLYOVKZVHYCYRYTYIUUAXLYBYRYTY
      IUTZUUAXLYBUUBUTZYLYODYJYKVNUUCYOYLUUCYOVDZXHXIVDZYRYKGUQZYAYOYLUUDXHXIXH
      XIXKYBUUBYOVLXHXIXKYBUUBYOVOVPYRYTYIXLYBYOVQUUDUUEXKXRUTZXMYTXPUTZYGYHVDZ
      XOXSYEUTZYAUTZUUFUUCUUGYOUUCUUEXKXRUUCXHXIXHXIXKYBUUBVRXHXIXKYBUUBVSVPXHX
      IXKYBUUBVTXRXSXQYAXLUUBWAWMWBUUCUUHYOUUCXMYTXPXMXOXPXTYAXLUUBWCXLYBYRYTYI
      WDXMXOXPXTYAXLUUBWEWMWBUUCUUKYOUUCUUIUUJYAUUCYGYHYEYGYHYRYTXLYBWFYEYGYHYR
      YTXLYBWGVPUUCXOXSYEXMXOXPXTYAXLUUBWHXRXSXQYAXLUUBWIYEYGYHYRYTXLYBWJWMXLXQ
      XTYAUUBWKWMWBBCYDDEFGHIJKLMNOPQRSTUBUDUEUFUGUHUIUJUKULUMUNWLWNXQXTYAXLUUB
      YOWOUUCYOWPBDGYJYKNPQTUFUIUJUKWQWRWSWTXAXBXCXDXEXFXG $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.  Part
       of attempt to simplify hypotheses.  (Contributed by NM, 18-Jul-2013.) $)
    cdlemk34 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
       -> X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` G )
               ) -> ( z ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( ( ( P .\/ ( R ` b ) )
                     ./\ ( ( N ` P ) .\/ ( R ` ( b o. `' F ) ) ) )
                .\/ ( R ` ( G o. `' b ) ) ) ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv co wral crio ccnv ccom
      wi wb fveq1 simpll1 simplr1 simpl1 simpl3r simp22l adantr simp21l simpl23
      3jca simpr2 simpr32 simpr33 jca simp21r simp22r simpr31 simpl3l syl113anc
      cdlemkuel-3 simpr cdlemd syl311anc simp1 simp3r cdlemk32 syl123anc eqeq2d
      ex impbid2 bitrd 3exp2 imp31 pm5.74d ralbidva riotabidva syl5eq ) PUPUQTN
      UQURZLGUQZLUSCUTZVAZURZMGUQZMXNVAZURZSGUQZVBZDBUQDTQVCVDURZLEVEZSEVEVFZUR
      ZVBZUAUCVGZXNVAZYGEVEZYCVAZYIMEVEZVAZVBZAVGZYGMUBVHZVFZVMZUCGVIZAGVJYMDYN
      VEZDYKOVHDYIOVHDSVEYGLVKVLEVEOVHRVHMYGVKVLEVEOVHRVHZVFZVMZUCGVIZAGVJUOYFY
      RUUCAGYFYNGUQZURZYQUUBUCGUUEYGGUQZURYMYPUUAYFUUDUUFYMYPUUAVNZVMYFUUDUUFYM
      UUGYFUUDUUFYMVBZURZYPYSDYOVEZVFZUUAUUIYPUUKDYNYOVOUUIUUKYPUUIUUKURZXLUUDY
      OGUQZYBUUKYPXLYAYEUUHUUKVPUUDUUFYMYFUUKVQUULXLYDXQVBZXMUUFXTVBZYJYLURZXOX
      RYHVBZYBUUMUUIUUNUUKUUIXLYDXQXLYAYEUUHVRYBYDXLYAUUHVSYFXQUUHXQXRXPXTXLYEV
      TWAZWDWAUUIUUOUUKUUIXMUUFXTYFXMUUHXMXOXSXTXLYEWBWAYFUUDUUFYMWEXPXSXTXLYEU
      UHWCWDZWAUUIUUPUUKUUIYJYLYHYJYLUUDUUFYFWFYHYJYLUUDUUFYFWGWHZWAUUIUUQUUKUU
      IXOXRYHYFXOUUHXMXOXSXTXLYEWIWAZYFXRUUHXQXRXPXTXLYEWJWAZYHYJYLUUDUUFYFWKZW
      DWAUUIYBUUKYBYDXLYAUUHWLZWAZBCYGDEFGHIJKLMNOPQRSTUBUDUEUFUGUHUIUJUKULUMUN
      WNWMUVEUUIUUKWOBDGYNYONPQTUFUIUJUKWPWQXCXDUUIUUJYTYSUUIXLYDURZUUOXQUUPXOY
      HXRVBYBUUJYTVFYFUVFUUHYFXLYDXLYAYEWRXLYAYBYDWSWHWAUUSUURUUTUUIXOYHXRUVAUV
      CUVBWDUVDBCDEFGHIJKLMNOPQRSTUBUCUDUEUFUGUHUIUJUKULUMUNWTXAXBXEXFXGXHXIXJX
      K $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 14-Jul-2013.) $)
    cdlemk29-3 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> X e. T ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv co wral crio wreu wrex
      wi cdlemk28-3 wb simp1 cdlemftr2 reusv1 mpbird cltrn cvv eqeltri riotaclb
      3syl fvex sylib syl5eqel ) PUPUQTNUQURZLGUQLUSCUTZVAURMGUQMWIVAURSGUQVBZD
      BUQDTQVCVDURLEVEZSEVEVFURZVBZUAUCVGZWIVAWNEVEZWKVAWOMEVEZVAVBZAVGWNMUBVHZ
      VFVMUCGVIZAGVJZGUOWMWSAGVKZWTGUQWMXAWSAGVLZABCDEFGHIJKLMNOPQRSTUBUCUDUEUF
      UGUHUIUJUKULUMUNVNWMWHWQUCGVLXAXBVOWHWJWLVPCEGUCNPTWKWPUEUJUKULVQWQAUCGGW
      RVRWDVSWSAGGTPVTVEZVEWAUKTXCWEWBWCWFWG $.
  $}

  ${
    cdlemk4.b $e |- B = ( Base ` K ) $.
    cdlemk4.l $e |- .<_ = ( le ` K ) $.
    cdlemk4.j $e |- .\/ = ( join ` K ) $.
    cdlemk4.m $e |- ./\ = ( meet ` K ) $.
    cdlemk4.a $e |- A = ( Atoms ` K ) $.
    cdlemk4.h $e |- H = ( LHyp ` K ) $.
    cdlemk4.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk4.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemk4.z $e |- Z = ( ( P .\/ ( R ` b ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( b o. `' F ) ) ) ) $.
    cdlemk4.y $e |- Y = ( ( P .\/ ( R ` G ) )
              ./\ ( Z
                .\/ ( R ` ( G o. `' b ) ) ) ) $.
    cdlemk4.x $e |- X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` G )
               ) -> ( z ` P ) = Y ) ) $.
    $d b d e f i j z ./\ $.  $d b e i j z .<_ $.  $d b d e f i j z .\/ $.
    $d b i j z A $.  $d b z B $.  $d b d e f i j z F $.  $d b d e f i j z G $.
    $d b i j z H $.  $d b i j z K $.  $d b d e f i j z N $.
    $d b d e f i j z P $.  $d b d e f i j z R $.  $d b d e f i j z T $.
    $d b d e f i j z W $.  $d d b e f i j z $.
    $( Part of proof of Lemma K of [Crawley] p. 118. ~ cdlemk29-3 with shorter
       hypotheses.  (Contributed by NM, 18-Jul-2013.) $)
    cdlemk35 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> X e. T ) $=
      ( vd ve vj vf vi chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv co ccnv
      ccom crio cmpt cmpt2 wi wral eqid cdlemk34 wb oveq1i oveq2i eqeq2i imbi2i
      eqtri ralbii a1i riotabiia syl6eqr cdlemk29-3 eqeltrrd ) KUPUQOIUQURGFUQG
      USCUTZVAURHFUQHWJVAURNFUQVBDBUQDOLVCVDURGEVEZNEVEVFURVBZSVGZWJVAWMEVEZWKV
      AWNHEVEZVAVBZAVGZWMHUKULFFDUMVGVEDULVGZEVEJVHDUKVGZUNFDUOVGVEDUNVGZEVEJVH
      DNVEZWTGVIZVJEVEJVHMVHVFUOFVKVLZVEVEWRWSVIVJEVEJVHMVHVFUMFVKVMZVHVFVNSFVO
      AFVKZPFWLXEWPDWQVEZDWOJVHZDWNJVHXAWMXBVJEVEJVHMVHZHWMVIVJEVEZJVHZMVHZVFZV
      NZSFVOZAFVKZPABCDEXCFULUNUOUMGHIJKLMNOXEXDSUKTUAUBUCUDUEUFUGXCVPZXDVPZXEV
      PZVQPWPXFQVFZVNZSFVOZAFVKXOUJYAXNAFYAXNVRWQFUQXTXMSFXSXLWPQXKXFQXGRXIJVHZ
      MVHXKUIYBXJXGMRXHXIJUHVSVTWCWAWBWDWEWFWCWGABCDEXCFULUNUOUMGHIJKLMNOXEXDSU
      KTUAUBUCUDUEUFUGXPXQXRWHWI $.

    $d w B $.  $d w F $.  $d w G $.  $d w P $.  $d w R $.  $d w T $.  $d w X $.
    $d w z Y $.  $d w b $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 18-Jul-2013.) $)
    cdlemk36 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> ( X ` P ) = Y ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv wi wral crio eqcomi wb
      simpl1 simpl2 simpl3 simpr1 simpr2 cdlemk35 syl132anc syl5eqelr cltrn cvv
      wreu simpr3 fvex riotaclb sylibr nfriota1 nfcxfr nfcv nfv nffv nfeq1 nfim
      eqeltri nfral nfra1 nfriota nfeq2 fveq1 eqeq1d imbi2d riota2f syl2anc rsp
      ralbid mpbiri syl imp3a 3impia ) KUKULOIULUMZGFULGUNCUOZUPUMZHFULHXGUPUMZ
      UQZNFULZDBULDOLURUSUMZGEUTZNEUTVAZUQZSVBZFULZXPXGUPXPEUTZXMUPXRHEUTUPUQZU
      MDPUTZQVAZXJXOUMZXQXSYAYBXSYAVCZSFVDZXQYCVCYBYDXSDAVBZUTZQVAZVCZSFVDZAFVE
      ZPVAZPYJUJVFYBPFULZYIAFVRZYDYKVGYBXFXHXIXKXLXNYLXFXHXIXOVHXFXHXIXOVIXFXHX
      IXOVJXJXKXLXNVKXJXKXLXNVLXJXKXLXNVSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJVMVNZYBYJFULYMYBYJPFUJYNVOYIAFFOKVPUTZUTVQUFOYOVTWJWAWBYIYDAFPAPYJUJYIA
      FWCWDZYCASFAFWEXSYAAXSAWFAXTQADPYPADWEWGWHWIWKYEPVAZYHYCSFSYEPSPYJUJYISAF
      YHSFWLSFWEWMWDWNYQYGYAXSYQYFXTQDYEPWOWPWQXAWRWSXBYCSFWTXCXDXE $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 18-Jul-2013.) $)
    cdlemk37 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> ( X ` P ) .<_ ( P .\/ ( R ` G ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn wceq cv co cdlemk36 ccnv ccom clat
      cfv simp11l hllat simp22l simp11 simp13l simp13r trlnidat syl3anc hlatjcl
      simp3l simp3r1 simp21 ltrnat atbase simp12l ltrncnv syl2anc ltrnco latjcl
      syl trlcl latmcl syl5eqel latmle1 syl5eqbr eqbrtrd ) KUKULZOIULZUMZGFULZG
      UNCUOZUPZUMZHFULZHWRUPZUMZUQZNFULZDBULZDOLURUSZUMZGEVGZNEVGUTZUQZSVAZFULZ
      XLWRUPZXLEVGZXIUPZXOHEVGZUPZUQZUMZUQZDPVGQDXQJVBZLABCDEFGHIJKLMNOPQRSTUAU
      BUCUDUEUFUGUHUIUJVCYAQYBRHXLVDZVEZEVGZJVBZMVBZYBLUIYAKVFULZYBCULZYFCULZYG
      YBLURYAWNYHWNWOWTXCXKXTVHZKVIWGZYAWNXFXQBULZYIYKXFXGXEXJXDXTVJZYAWPXAXBYM
      WPWTXCXKXTVKZXAXBWPWTXKXTVLZXAXBWPWTXKXTVMBCEFHIKOTUDUEUFUGVNVOBCJKDXQTUB
      UDVPVOYAYHRCULYECULZYJYLYARDXOJVBZDNVGZXLGVDZVEZEVGZJVBZMVBZCUHYAYHYRCULZ
      UUCCULZUUDCULYLYAWNXFXOBULZUUEYKYNYAWPXMXNUUGYOXDXKXMXSVQZXNXPXRXMXDXKVRB
      CEFXLIKOTUDUEUFUGVNVOBCJKDXOTUBUDVPVOYAYHYSCULZUUBCULZUUFYLYAYSBULZUUIYAW
      PXEXFUUKYOXDXEXHXJXTVSYNBDFNIKLOUAUDUEUFVTVOBCYSKTUDWAWGYAWPUUAFULZUUJYOY
      AWPXMYTFULZUULYOUUHYAWPWQUUMYOWQWSWPXCXKXTWBFGIKOUEUFWCWDFXLYTIKOUEUFWEVO
      CEFUUAIKOTUEUFUGWHWDCJKYSUUBTUBWFVOCKMYRUUCTUCWIVOWJYAWPYDFULZYQYOYAWPXAY
      CFULZUUNYOYPYAWPXMUUOYOUUHFXLIKOUEUFWCWDFHYCIKOUEUFWEVOCEFYDIKOTUEUFUGWHW
      DCJKRYETUBWFVOCKLMYBYFTUAUCWKVOWLWM $.

    $d w .<_ $.  $d w .\/ $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 31, p. 119.  TODO:
       derive more directly with ~ r19.23 ?  (Contributed by NM,
       19-Jul-2013.) $)
    cdlemk38 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> ( X ` P ) .<_ ( P .\/ ( R ` G ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn wceq cv wrex co cdlemftr2 3ad2ant1
      cfv nfv wi wral crio nfcv nfriota nfcxfr nffv nfbr simpl1 simpl21 simpl22
      nfra1 simpl23 simpl3l simpl3r simpr cdlemk37 syl331anc exp32 rexlimd mpd
      ) KUKULOIULUMZGFULGUNCUOZUPUMZHFULHWJUPUMZNFULZUQZDBULDOLURUSUMZGEVFZNEVF
      UTZUMZUQZSVAZWJUPWTEVFZWPUPXAHEVFZUPUQZSFVBZDPVFZDXBJVCZLURZWIWNXDWRCEFSI
      KOWPXBTUEUFUGVDVEWSXCXGSFWSSVGSXEXFLSDPSPXCDAVAVFQUTVHZSFVIZAFVJUJXISAFXH
      SFVSSFVKVLVMSDVKVNSLVKSXFVKVOWSWTFULZXCXGWSXJXCUMZUMWIWKWLWMWOWQXKXGWIWNW
      RXKVPWKWLWMWIWRXKVQWKWLWMWIWRXKVRWKWLWMWIWRXKVTWOWQWIWNXKWAWOWQWIWNXKWBWS
      XKWCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJWDWEWFWGWH $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 31, p. 119.
       Trace-preserving property of tau, represented by ` X ` .  (Contributed
       by NM, 19-Jul-2013.) $)
    cdlemk39 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> ( R ` X ) .<_ ( R ` G ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq co simp1l simp3ll simp22l
      simp1 simp22r trlnidat syl3anc hlatlej1 cdlemk38 clat wb hllat syl atbase
      cdlemk35 ltrnat hlatjcl latjle12 syl13anc mpbi2and wi simp1r latmlem1 mpd
      lhpbase simp3l trlval2 trlval5 3brtr4d ) KUKULZOIULZUMZGFULGUNCUOZUPUMZHF
      ULZHWOUPZUMNFULZUQZDBULZDOLURUSZUMZGEUTNEUTVAZUMZUQZDDPUTZJVBZOMVBZDHEUTZ
      JVBZOMVBZPEUTZXJLXFXHXKLURZXIXLLURZXFDXKLURZXGXKLURZXNXFWLXAXJBULZXPWLWMW
      TXEVCZXAXBXDWNWTVDZXFWNWQWRXRWNWTXEVFZWQWRWPWSWNXEVEZWQWRWPWSWNXEVGBCEFHI
      KOTUDUEUFUGVHVIZBDXJJKLUAUBUDVJVIABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJ
      VKXFKVLULZDCULZXGCULZXKCULZXPXQUMXNVMXFWLYDXSKVNVOZXFXAYEXTBCDKTUDVPVOXFX
      GBULZYFXFWNPFULZXAYIYAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVQZXTBDFPIK
      LOUAUDUEUFVRVIZBCXGKTUDVPVOXFWLXAXRYGXSXTYCBCJKDXJTUBUDVSVIZCJKLDXGXKTUAU
      BVTWAWBXFYDXHCULZYGOCULZXNXOWCYHXFWLXAYIYNXSXTYLBCJKDXGTUBUDVSVIYMXFWMYOW
      LWMWTXEWDCIKOTUEWGVOCKLMXHXKOTUAUCWEWAWFXFWNYJXCXMXIVAYAYKWNWTXCXDWHZBDEF
      PIJKLMOUAUBUCUDUEUFUGWIVIXFWNWQXCXJXLVAYAYBYPBDEFHIJKLMOUAUBUCUDUEUFUGWJV
      IWK $.
  $}

  ${
    $d g F $.  $d g N $.  $d g T $.
    cdlemk40.x $e |- X = ( iota_ z e. T ph ) $.
    cdlemk40.u $e |- U = ( g e. T |-> if ( F = N , g , X ) ) $.
    $( TODO: fix comment.  (Contributed by NM, 31-Jul-2013.) $)
    cdlemk40 $p |- ( G e. T
          -> ( U ` G ) = if ( F = N , G , [_ G / g ]_ X ) ) $=
      ( wcel cfv wceq cv cif csb cvv vex crio riotaex eqeltri ifex csbex fvmpts
      mpan2 wsbc csbif sbcg csbvarg eqidd ifbieq12d syl5eq eqtrd ) GCLZGDMZEGFH
      NZEOZIPZQZUQGEGIQZPZUOUTRLUPUTNEGUSUQURIESIABCTRJABCUAUBUCUDEGUSCDRKUEUFU
      OUTUQEGUGZEGURQZVAPVBUQEGURIUHUOVCUQVDVAGVAUQEGCUIEGCUJUOVAUKULUMUN $.

    $( TODO: fix comment.  (Contributed by NM, 31-Jul-2013.) $)
    cdlemk40t $p |- ( ( F = N /\ G e. T ) -> ( U ` G ) = G ) $=
      ( wcel wceq cfv csb cif cdlemk40 iftrue sylan9eqr ) GCLFHMZGDNTGEGIOZPGAB
      CDEFGHIJKQTGUARS $.

    $( TODO: fix comment.  (Contributed by NM, 31-Jul-2013.) $)
    cdlemk40f $p |- ( ( F =/= N /\ G e. T ) -> ( U ` G ) = [_ G / g ]_ X ) $=
      ( wcel wne cfv wceq csb cif cdlemk40 ifnefalse sylan9eqr ) GCLFHMGDNFHOGE
      GIPZQUAABCDEFGHIJKRFHGUAST $.
  $}

  ${
    $d g w ./\ $.  $d g w .\/ $.  $d g w G $.  $d g w P $.  $d g w R $.
    $d g w T $.  $d g w Z $.  $d g w b $.
    cdlemk41.y $e |- Y = ( ( P .\/ ( R ` g ) )
              ./\ ( Z
                .\/ ( R ` ( g o. `' b ) ) ) ) $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 19-Jul-2013.) $)
    cdlemk41 $p |- ( G e. T -> [_ G / g ]_ Y = ( ( P .\/ ( R ` G ) )
              ./\ ( Z
                .\/ ( R ` ( G o. `' b ) ) ) ) ) $=
      ( cfv co cv ccnv ccom wcel nfcvd wceq oveq2d fveq2 fveq2d oveq12d csbiegf
      coeq1 syl5eq ) DEHAEBLZFMZIEJNOZPZBLZFMZGMZCECQDUMRDNZESZHAUNBLZFMZIUNUIP
      ZBLZFMZGMUMKUOUQUHUTULGUOUPUGAFUNEBUATUOUSUKIFUOURUJBUNEUIUEUBTUCUFUD $.
  $}

  ${
    cdlemk5.b $e |- B = ( Base ` K ) $.
    cdlemk5.l $e |- .<_ = ( le ` K ) $.
    cdlemk5.j $e |- .\/ = ( join ` K ) $.
    cdlemk5.m $e |- ./\ = ( meet ` K ) $.
    cdlemk5.a $e |- A = ( Atoms ` K ) $.
    cdlemk5.h $e |- H = ( LHyp ` K ) $.
    cdlemk5.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk5.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Lemma for ~ cdlemkfid3N .  (Contributed by NM, 29-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkfid1N $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ F =/= ( _I |` B ) /\ G e. T )
        /\ ( ( R ` G ) =/= ( R ` F ) /\ ( P e. A /\ -. P .<_ W ) ) )
    -> ( ( P .\/ ( R ` G ) )
              ./\ ( ( F ` P ) .\/ ( R ` ( G o. `' F ) ) ) ) = ( G ` P ) ) $=
      ( chlt wcel wa cid cres wne w3a cfv wbr wn co ccnv ccom wceq simp1 simp23
      simp3r trljat3 syl3anc simp1l simp21 ltrnat hlatjcom trlcoabs2N syl121anc
      simp3rl trlcocnv oveq2d eqtr3d 3eqtr4d oveq12d trlcl trlcocnvat syl221anc
      syl2anc simp1r simp3l wo ltrnel ltrncnv trlcnv neeqtrrd simp22 ltrncnvnid
      cp0 trlcone syl122anc trlator0 trlle syl21anc ltrnco lhp2at0nle syl322anc
      eqid 2llnma1b syl131anc eqtrd ) JUBUCZMHUCZUDZFEUCZFUEBUFZUGZGEUCZUHZGDUI
      ZFDUIZUGZCAUCZCMKUJUKZUDZUDZUHZCXGIULZCFUIZGFUMZUNZDUIZIULZLULCGUIZXGIULZ
      YAXSIULZLULZYAXNXOYBXTYCLXNXAXEXLXOYBUOXAXFXMUPZXAXBXDXEXMUQZXAXFXIXLURZA
      CDEGHIJKMOPRSTUAUSUTXNXPYAIULZYAXPIULZXTYCXNWSXPAUCZYAAUCZYHYIUOWSWTXFXMV
      AZXNXAXBXJYJYEXAXBXDXEXMVBZXJXKXIXAXFVGZACEFHJKMORSTVCUTXNXAXEXJYKYEYFYNA
      CEGHJKMORSTVCUTZAIJXPYAPRVDUTXNXAXBXEXLXTYHUOYEYMYFYGACDEFGHIJKMOPRSTUAVE
      VFXNYAFGUMUNDUIZIULZYCYIXNYPXSYAIXNXAXBXEYPXSUOYEYMYFDEFGHJMSTUAVHUTVIXNX
      AXEXBXLYQYIUOYEYFYMYGACDEGFHIJKMOPRSTUAVEVFVJVKVLXNWSXGBUCZYKXSAUCZXSYBKU
      JUKZYDYAUOYLXNXAXEYRYEYFBDEGHJMNSTUAVMVPYOXNWSWTXEXBXIYSYLWSWTXFXMVQZYFYM
      XAXFXIXLVRZADEGFHJMRSTUAVNVOZXNXAYKYAMKUJUKUDZXGXSUGZXGAUCXGJWFUIZUOVSZXG
      MKUJZYSXSMKUJZYTYEXNXAXEXLUUDYEYFYGACEGHJKMORSTVTUTXNXAXEXQEUCZXGXQDUIZUG
      XQXCUGZUUEYEYFXNXAXBUUJYEYMEFHJMSTWAVPZXNXGXHUUKUUBXNXAXBUUKXHUOYEYMDEFHJ
      MSTUAWBVPWCXNXAXBXDUULYEYMXAXBXDXEXMWDBEFHJMNSTWEUTBDEGXQHJMNSTUAWGWHXNXA
      XEUUGYEYFADEGHJMUUFUUFWOZRSTUAWIVPXNWSWTXEUUHYLUUAYFDEGHJKMOSTUAWJWKUUCXN
      XAXREUCZUUIYEXNXAXEUUJUUOYEYFUUMEGXQHJMSTWLUTDEXRHJKMOSTUAWJVPAYAXGHIJKXS
      MUUFOPUUNRSWMWNABYAXSIJKLXGNOPQRWPWQWR $.

    cdlemk5.z $e |- Z = ( ( P .\/ ( R ` b ) )
              ./\ ( ( N ` P ) .\/ ( R ` ( b o. `' F ) ) ) ) $.
    $( Lemma for ~ cdlemkid .  (Contributed by NM, 24-Jul-2013.) $)
    cdlemkid1 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( P e. A /\ -. P .<_ W )
            /\ ( b e. T /\ b =/= ( _I |` B ) ) ) )
     -> ( Z .\/ ( R ` b ) ) = ( P .\/ ( R ` b ) ) ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn cv cid cres co ccnv ccom oveq1i simp1l
      wne simp1 simp3rl simp3rr trlnidat syl3anc simp3ll hlatjcl clat hllat syl
      simp22 atbase ltrncl simp21 ltrncnv ltrnco trlcl latjcl hlatlej2 atmod2i1
      syl2anc latj32 simp3l trljat3 oveq1d latjass 3eqtrd latjcom trlcnv simp23
      syl131anc syl13anc eqtrd oveq2d eqtr4d trljco 3eqtr2d latabs2 syl5eq ) IU
      EUFZMGUFZUGZFEUFZLEUFZFDUHZLDUHZUIZUJZCAUFZCMJUKULZUGZOUMZEUFZXMUNBUOVAZU
      GZUGZUJZNXMDUHZHUPCXSHUPZCLUHZXMFUQZURZDUHZHUPZKUPZXSHUPZXTNYFXSHUDUSXRYG
      XTYEXSHUPZKUPZXTXTXGHUPZKUPZXTXRXAXSAUFZXTBUFZYEBUFZXSXTJUKZYGYIUIXAXBXIX
      QUTZXRXCXNXOYLXCXIXQVBZXNXOXLXCXIVCZXNXOXLXCXIVDABDEXMGIMPTUAUBUCVEVFZXRX
      AXJYLYMYPXJXKXPXCXIVGZYSABHICXSPRTVHVFZXRIVIUFZYABUFZYDBUFZYNXRXAUUBYPIVJ
      VKZXRXCXECBUFZUUCYQXCXDXEXHXQVLZXRXJUUFYTABCIPTVMVKZBELGIUEMCPUAUBVNVFZXR
      XCYCEUFZUUDYQXRXCXNYBEUFZUUJYQYRXRXCXDUUKYQXCXDXEXHXQVOZEFGIMUAUBVPWBZEXM
      YBGIMUAUBVQVFBDEYCGIMPUAUBUCVRWBZBHIYAYDPRVSVFXRXAXJYLYOYPYTYSACXSHIJQRTV
      TVFABXSHIJKXTYEPQRSTWAWLXRYJYHXTKXRYJYAXGXSHUPZHUPZYHXRYJCXGHUPZXSHUPZYAX
      GHUPZXSHUPZUUPXRUUBUUFXSBUFZXGBUFZYJUURUIUUEUUHXRYLUVAYSABXSIPTVMVKZXRXCX
      EUVBYQUUGBDELGIMPUAUBUCVRWBZBHICXSXGPRWCWMXRUUQUUSXSHXRXCXEXLUUQUUSUIYQUU
      GXCXIXLXPWDACDELGHIJMQRTUAUBUCWEVFWFXRUUBUUCUVBUVAUUTUUPUIUUEUUIUVDUVCBHI
      YAXGXSPRWGWMWHXRYHYAYDXSHUPZHUPZUUPXRUUBUUCUUDUVAYHUVFUIUUEUUIUUNUVCBHIYA
      YDXSPRWGWMXRUUOUVEYAHXRUUOXSYBDUHZHUPZXSYDHUPZUVEXRUUOXSXGHUPZUVHXRUUBUVB
      UVAUUOUVJUIUUEUVDUVCBHIXGXSPRWIVFXRUVGXGXSHXRUVGXFXGXRXCXDUVGXFUIYQUULDEF
      GIMUAUBUCWJWBXCXDXEXHXQWKWNWOWPXRXCXNUUKUVIUVHUIYQYRUUMDEXMYBGHIMRUAUBUCW
      QVFXRUUBUVAUUDUVIUVEUIUUEUVCUUNBHIXSYDPRWIVFWRWOWPWPWOXRUUBYMUVBYKXTUIUUE
      UUAUVDBHIKXTXGPRSWSVFWRWT $.

    $( Lemma for ~ cdlemkfid3N .  (Contributed by NM, 29-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkfid2N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F = N )
        /\ ( F e. T /\ F =/= ( _I |` B ) /\ b e. T )
        /\ ( ( R ` b ) =/= ( R ` F ) /\ ( P e. A /\ -. P .<_ W ) ) )
    -> Z = ( b ` P ) ) $=
      ( chlt wcel wa wceq cid cres wne cv w3a cfv wn co ccnv ccom simp1r fveq1d
      wbr oveq1d oveq2d cdlemkfid1N 3adant1r eqtr3d syl5eq ) IUEUFMGUFUGZFLUHZU
      GFEUFFUIBUJUKOULZEUFUMZVJDUNZFDUNUKCAUFCMJVAUOUGUGZUMZNCVLHUPZCLUNZVJFUQU
      RDUNZHUPZKUPZCVJUNZUDVNVOCFUNZVQHUPZKUPZVSVTVNWBVRVOKVNWAVPVQHVNCFLVHVIVK
      VMUSUTVBVCVHVKVMWCVTUHVIABCDEFVJGHIJKMPQRSTUAUBUCVDVEVFVG $.

    cdlemk5.y $e |- Y = ( ( P .\/ ( R ` g ) )
              ./\ ( Z .\/ ( R ` ( g o. `' b ) ) ) ) $.
    $d g ./\ $.  $d g .\/ $.  $d g B $.  $d g P $.  $d g R $.  $d g T $.
    $d g Z $.  $d g b $.
    $( Lemma for ~ cdlemkid .  (Contributed by NM, 24-Jul-2013.) $)
    cdlemkid2 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ G = ( _I |` B )
            /\ ( b e. T /\ b =/= ( _I |` B ) ) ) )
     -> [_ G / g ]_ Y = P ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn cid cres cv wne simp32 csbeq1d co ccnv
      csb ccom idltrn 3ad2ant1 cdlemk41 syl cp0 eqid trlid0 oveq2d hlol simp31l
      col simp1l atbase olj01 syl2anc eqtrd wf1o wf simp33l ltrncnv ltrn1o f1of
      simp1 fcoi2 3syl fveq2d trlcnv simp31 jca cdlemkid1 syld3an3 oveq12d clat
      simp33 hllat trlcl latabs2 syl3anc ) KUIUJZOIUJZUKZGEUJNEUJGDULNDULUMUNZC
      AUJZCOLUOUPZUKZHUQBURZUMZRUSZEUJZXNXLUTZUKZUNZUNZFHPVEFXLPVEZCXSFHXLPXGXH
      XKXMXQVAVBXSXTCXLDULZJVCZQXLXNVDZVFZDULZJVCZMVCZCXSXLEUJZXTYGUMXGXHYHXRBE
      IKOSUDUEVGVHCDEFXLJMPQRUHVIVJXSYGCCXNDULZJVCZMVCZCXSYBCYFYJMXSYBCKVKULZJV
      CZCXSYAYLCJXGXHYAYLUMXRBDIKOYLSYLVLZUDUFVMVHVNXSKVQUJZCBUJZYMCUMXSXEYOXEX
      FXHXRVRZKVOVJXSXIYPXIXJXMXQXGXHVPABCKSUCVSVJZBJKCYLSUAYNVTWAWBXSYFQYIJVCZ
      YJXSYEYIQJXSYEYCDULZYIXSYDYCDXSBBYCWCZBBYCWDYDYCUMXSXGYCEUJZUUAXGXHXRWIZX
      SXGXOUUBUUCXOXPXKXMXGXHWEZEXNIKOUDUEWFWABEYCIKUIOSUDUEWGWABBYCWHBBYCWJWKW
      LXSXGXOYTYIUMUUCUUDDEXNIKOUDUEUFWMWAWBVNXGXHXRXKXQUKYSYJUMXSXKXQXGXHXKXMX
      QWNXGXHXKXMXQWTWOABCDEGIJKLMNOQRSTUAUBUCUDUEUFUGWPWQWBWRXSKWSUJZYPYIBUJZY
      KCUMXSXEUUEYQKXAVJYRXSXGXOUUFUUCUUDBDEXNIKOSUDUEUFXBWABJKMCYISUAUBXCXDWBW
      BWB $.

    $d g G $.
    $( TODO: is this useful or should it be deleted?  (Contributed by NM,
       29-Jul-2013.)  (New usage is discouraged.) $)
    cdlemkfid3N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F = N )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) ) /\ G e. T
              /\ ( b e. T /\ b =/= ( _I |` B ) ) )
        /\ ( ( R ` b ) =/= ( R ` F ) /\ ( R ` b ) =/= ( R ` G )
             /\ ( P e. A /\ -. P .<_ W ) ) )
    -> [_ G / g ]_ Y = ( G ` P ) ) $=
      ( chlt wcel wa wceq cid cres wne cv w3a cfv wbr wn csb ccnv ccom cdlemk41
      co simp22 syl simp21l simp21r simp23l simp31 simp33 cdlemkfid2N syl132anc
      simp1 oveq1d oveq2d simp1l simp23r simp32 necomd cdlemkfid1N 3eqtrd ) KUI
      UJOIUJUKZGNULZUKZGEUJZGUMBUNZUOZUKZHEUJZRUPZEUJZWLWHUOZUKZUQZWLDURZGDURUO
      ZWQHDURZUOZCAUJCOLUSUTUKZUQZUQZFHPVAZCWSJVEZQHWLVBVCDURZJVEZMVEZXECWLURZX
      FJVEZMVEZCHURZXCWKXDXHULWFWJWKWOXBVFZCDEFHJMPQRUHVDVGXCXGXJXEMXCQXIXFJXCW
      FWGWIWMWRXAQXIULWFWPXBVOWGWIWKWOWFXBVHWGWIWKWOWFXBVIWMWNWJWKWFXBVJZWFWPWR
      WTXAVKWFWPWRWTXAVLZABCDEGIJKLMNOQRSTUAUBUCUDUEUFUGVMVNVPVQXCWDWMWNWKWSWQU
      OXAXKXLULWDWEWPXBVRXNWMWNWJWKWFXBVSXMXCWQWSWFWPWRWTXAVTWAXOABCDEWLHIJKLMO
      STUAUBUCUDUEUFWBVNWC $.

    ${
      cdlemk5b.s $e |- S = ( f e. T |-> ( iota_ i e. T
          ( i ` P ) = ( ( P .\/ ( R ` f ) )
                ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
      cdlemk5b.u1 $e |- V = ( d e. T , e e. T
            |-> ( iota_ j e. T
          ( j ` P ) = ( ( P .\/ ( R ` e ) )
                ./\ ( ( ( S ` d ) ` P )
                  .\/ ( R ` ( e o. `' d ) ) ) ) ) ) $.
      $d g d e f i j ./\ $.  $d i j .<_ $.  $d g d e f i j .\/ $.  $d i j A $.
      $d f i j F $.  $d g d e j G $.  $d i j H $.  $d i j K $.  $d f i j N $.
      $d g d e f i j P $.  $d g d e f i j R $.  $d b d e j S $.
      $d g d e f i j T $.  $d d e f i j W $.  $d g Z $.  $d g d e f i j b $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: clean up
         ` ( b Y G ) ` stuff. ` V ` represents ` Y ` in ~ cdlemk31 .
         (Contributed by NM, 21-Jul-2013.) $)
      cdlemky $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) )
              /\ ( G e. T /\ G =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> [_ G / g ]_ Y = ( ( b V G ) ` P ) ) $=
        ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv ccnv ccom csb simp11
        co simp23 simp12l simp3l simp21 simp3r2 simp12r simp3r1 simp22 cdlemk30
        syl233anc syl6eqr oveq1d oveq2d 3jca simp13l simp3r3 cdlemk31 syl223anc
        jca simp13r cdlemk41 syl 3eqtr4rd ) PURUSUANUSUTZLFUSZLVABVBZVCZUTZMFUS
        ZMWTVCZUTZVDZSFUSZCAUSCUAQVEVFUTZLDVGZSDVGVHZVDZUDVIZFUSZXLWTVCZXLDVGZX
        IVCZXOMDVGZVCZVDZUTZVDZCXQOVNZCXLEVGVGZMXLVJVKDVGZOVNZRVNZYBUCYDOVNZRVN
        ZCXLMTVNVGZIMUBVLZYAYEYGYBRYAYCUCYDOYAYCCXOOVNCSVGXLLVJVKDVGOVNRVNZUCYA
        WRXJWSXMXGXPXAXNUTXHYCYKVHWRXBXEXKXTVMZXFXGXHXJXTVOZWSXAWRXEXKXTVPZXFXK
        XMXSVQZXFXGXHXJXTVRZXNXPXRXMXFXKVSZYAXAXNWSXAWRXEXKXTVTZXNXPXRXMXFXKWAZ
        WMXFXGXHXJXTWBZABCDEFHJLNOPQRSUAUDUFUGUHUIUJUKULUMUPWCWDUNWEWFWGYAWRXJW
        SXMXGVDXCXPXRUTXAXNXDVDXHYIYFVHYLYMYAWSXMXGYNYOYPWHXCXDWRXBXKXTWIZYAXPX
        RYQXNXPXRXMXFXKWJWMYAXAXNXDYRYSXCXDWRXBXKXTWNWHYTABCDEFGHJKLMNOPQRSUATU
        DUEUFUGUHUIUJUKULUMUPUQWKWLYAXCYJYHVHUUACDFIMORUBUCUDUOWOWPWQ $.

      $d d Q $.  $d e Q $.
      cdlemk5.o2 $e |- Q = ( S ` b ) $.
      cdlemk5.u2 $e |- C = ( e e. T |-> ( iota_ j e. T
          ( j ` P ) = ( ( P .\/ ( R ` e ) )
                ./\ ( ( Q ` P ) .\/ ( R ` ( e o. `' b ) ) ) ) ) ) $.
      $( Convert between function and explicit forms. ` C ` represents ` Z ` in
         ~ cdlemkuu .  TODO:  Clean all this up.  (Contributed by NM,
         21-Jul-2013.) $)
      cdlemkyu $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) )
              /\ ( G e. T /\ G =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> [_ G / g ]_ Y = ( ( C ` G ) ` P ) ) $=
        ( chlt wcel wa cid cres wne w3a wbr cfv wceq csb cdlemky simp3l simp13l
        wn cv co cdlemkuu syl2anc fveq1d eqtrd ) RVBVCUCPVCVDZNHVCNVEBVFZVGVDZO
        HVCZOWDVGZVDVHZUAHVCDAVCDUCSVIVPVDNFVJZUAFVJVKVHZUFVQZHVCZWKWDVGWKFVJZW
        IVGWMOFVJVGVHZVDZVHZKOUDVLDWKOUBVRZVJDOCVJZVJABDFGHIJKLMNOPQRSTUAUBUCUD
        UEUFUGUHUIUJUKULUMUNUOUPUQURUSVMWPDWQWRWPWLWFWQWRVKWHWJWLWNVNWFWGWCWEWJ
        WOVOABWKDEFGHIJLMNOPQRSTUAUCUBCUGUHUIUJUKULUMUNUOURUSUTVAVSVTWAWB $.
    $}

    ${
      $d g d e f i j ./\ $.  $d i j .<_ $.  $d g d e f i j .\/ $.  $d i j A $.
      $d f i j F $.  $d g d e j G $.  $d i j H $.  $d i j K $.  $d f i j N $.
      $d g d e f i j P $.  $d g d e f i j R $.  $d b d e j S $.
      $d g d e f i j T $.  $d d e f i j W $.  $d g Z $.  $d g d e f i j b $.
      $d d Q $.  $d e Q $.
      cdlemk5c.s $e |- S = ( f e. T |-> ( iota_ i e. T
          ( i ` P ) = ( ( P .\/ ( R ` f ) )
                ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
      cdlemk5a.u2 $e |- C = ( e e. T |-> ( iota_ j e. T
          ( j ` P ) = ( ( P .\/ ( R ` e ) )
                ./\ ( ( ( S ` b ) ` P ) .\/ ( R ` ( e o. `' b ) ) ) ) ) ) $.
      $( ~ cdlemkyu with some hypotheses eliminated.  TODO:  Clean all this
         up.  (Contributed by NM, 21-Jul-2013.) $)
      cdlemkyuu $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) )
              /\ ( G e. T /\ G =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> [_ G / g ]_ Y = ( ( C ` G ) ` P ) ) $=
        ( vd cv cfv co ccnv ccom wceq crio cmpt2 eqid cdlemkyu ) ABCDUDURFUSZEF
        GHIJKLMNOPQRSTUQHGGDLURUSDHURZEUSPUTDUQURZFUSUSVIVJVAVBEUSPUTSUTVCLGVDV
        EZUAUBUCUDUQUEUFUGUHUIUJUKULUMUNUOVKVFVHVFUPVG $.

      $d e F $.  $d e g j I $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  Lemma for Eq. 5,
         p. 119. ` G ` , ` I ` stand for g, h.  TODO: fix comment.
         (Contributed by NM, 21-Jul-2013.) $)
      cdlemk11ta $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) )
              /\ ( G e. T /\ G =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
           /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
                  /\ ( R ` b ) =/= ( R ` G ) )
              /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` I ) ) ) )
         -> [_ G / g ]_ Y
                .<_ ( [_ I / g ]_ Y .\/ ( R ` ( I o. `' G ) ) ) ) $=
        ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv ccnv ccom csb simp11
        co simp12l simp31 simp21 simp13l simp331 simp22 simp12r simp321 simp13r
        3jca simp23 simp332 simp322 simp323 necomd eqid cdlemk11u syl333anc jca
        simp333 simp32 cdlemkyuu syld3an3 simp12 simp2 syl312anc oveq1d 3brtr4d
        ) RURUSUBOUSUTZMGUSZMVABVBZVCZUTZNGUSZNXEVCZUTZVDZUAGUSZDAUSDUBSVEVFUTZ
        MEVGZUAEVGVHZVDZUEVIZGUSZXQXEVCZXQEVGZXNVCZXTNEVGZVCZVDZPGUSZPXEVCZXTPE
        VGZVCZVDZVDZVDZDNCVGVGZDPCVGVGZPNVJVKEVGZQVNZJNUCVLZJPUCVLZYNQVNSYKXCXD
        XRXLXHYEVDXMXOXFXSXIVDYFYAYBXTVCZYGXTVCZVDYLYOSVEXCXGXJXPYJVMZXDXFXCXJX
        PYJVOXKXPXRYDYIVPZYKXLXHYEXKXLXMXOYJVQXHXIXCXGXPYJVRYEYFYHXRYDXKXPVSZWD
        XKXLXMXOYJVTXKXLXMXOYJWEYKXFXSXIXDXFXCXJXPYJWAXSYAYCXRYIXKXPWBZXHXIXCXG
        XPYJWCWDYEYFYHXRYDXKXPWFZYKYAYRYSXSYAYCXRYIXKXPWGZYKXTYBXSYAYCXRYIXKXPW
        HWIYKXTYGYEYFYHXRYDXKXPWNZWIWDABXQDEFGCHIKLMNOQRSTUAXQFVGZDNVGDPVGQVNNX
        QVJZVKEVGPUUHVKEVGQVNTVNZUBPUFUGUHUIUJUKULUMUPUUGWJUQUUIWJWKWLXKXPYJXRY
        DUTYPYLVHYKXRYDUUAXKXPXRYDYIWOWMABCDEFGHIJKLMNOQRSTUAUBUCUDUEUFUGUHUIUJ
        UKULUMUNUOUPUQWPWQYKYQYMYNQYKXCXGYEYFUTXPXRXSYAYHVDYQYMVHYTXCXGXJXPYJWR
        YKYEYFUUBUUDWMXKXPYJWSUUAYKXSYAYHUUCUUEUUFWDABCDEFGHIJKLMPOQRSTUAUBUCUD
        UEUFUGUHUIUJUKULUMUNUOUPUQWPWTXAXB $.

      $d g F $.
      $( Lemma for ~ cdlemk19y .  (Contributed by NM, 30-Jul-2013.) $)
      cdlemk19ylem $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
           /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F ) ) ) )
     -> [_ F / g ]_ Y = ( N ` P ) ) $=
        ( chlt wcel wa cid cres wne wbr wn cfv wceq w3a csb simp1l simp1r simp2
        cv simp3l simp3rl simp3rr 3jca cdlemkyuu syl312anc simp1rl simp1rr eqid
        cdlemk19 syl313anc fveq1d eqtrd ) PUPUQTNUQURZMGUQZMUSBUTZVAZURZURZSGUQ
        DAUQDTQVBVCURMEVDZSEVDVEVFZUCVKZGUQZWMWGVAZWMEVDWKVAZURZURZVFZJMUAVGZDM
        CVDZVDZDSVDWSWEWIWIWLWNWOWPWPVFWTXBVEWEWIWLWRVHZWEWIWLWRVIZXDWJWLWRVJZW
        JWLWNWQVLZWSWOWPWPWOWPWNWJWLVMZWOWPWNWJWLVNZXHVOABCDEFGHIJKLMMNOPQRSTUA
        UBUCUDUEUFUGUHUIUJUKULUMUNUOVPVQWSDXASWSWEWFWNWLWHWOWPXASVEXCWFWHWEWLWR
        VRXFXEWFWHWEWLWRVSXGXHABWMDEFGCHIKLMNOPQRSWMFVDZTUDUEUFUGUHUIUJUKUNXIVT
        UOWAWBWCWD $.
    $}

    ${
      $d g d e f i j ./\ $.  $d i j .<_ $.  $d g d e f i j .\/ $.  $d i j A $.
      $d f i j F $.  $d g e j G $.  $d i j H $.  $d i j K $.  $d f i j N $.
      $d g d e f i j P $.  $d g d e f i j R $.  $d b d e j S $.
      $d g d e f i j T $.  $d d e f i j W $.  $d g Z $.  $d g d e f i j b $.
      $d d Q $.  $d e Q $.  $d e F $.  $d e g j I $.  $d b ./\ $.  $d b .\/ $.
      $d b F $.  $d b e N $.  $d b P $.  $d b R $.  $d b T $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  Lemma for Eq. 5,
         p. 119. ` G ` , ` I ` stand for g, h. ~ cdlemk11ta with hypotheses
         removed.  TODO:  Can this be proved directly with no quantification?
         (Contributed by NM, 21-Jul-2013.) $)
      cdlemk11tb $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) )
              /\ ( G e. T /\ G =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
           /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
                /\ ( R ` b ) =/= ( R ` G ) )
            /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` I ) ) ) )
       -> [_ G / g ]_ Y
              .<_ ( [_ I / g ]_ Y .\/ ( R ` ( I o. `' G ) ) ) ) $=
        ( ve vj vf vi cv cfv co ccnv ccom wceq crio cmpt eqid cdlemk11ta ) ABUJ
        ECUKUNUOCUJUNZDUOKUPCSUNZULECUMUNUOCULUNZDUOKUPCOUOVFGUQURDUOKUPNUPUSUM
        EUTVAZUOUOVDVEUQURDUOKUPNUPUSUKEUTVAZCDVGEUJULFUMUKGHIJKLMNOPQRSTUAUBUC
        UDUEUFUGUHUIVGVBVHVBVC $.

      $d g F $.
      $( ~ cdlemk19 with simpler hypotheses.  TODO:  Clean all this up.
         (Contributed by NM, 30-Jul-2013.) $)
      cdlemk19y $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( F e. T /\ F =/= ( _I |` B ) ) )
           /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
           /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F ) ) ) )
     -> [_ F / g ]_ Y = ( N ` P ) ) $=
        ( ve vj vf vi cv cfv co ccnv ccom wceq crio cmpt eqid cdlemk19ylem ) AB
        UHECUIULUMCUHULZDUMIUNCQULZUJECUKULUMCUJULZDUMIUNCMUMVDGUOUPDUMIUNLUNUQ
        UKEURUSZUMUMVBVCUOUPDUMIUNLUNUQUIEURUSZCDVEEUHUJFUKUIGHIJKLMNOPQRSTUAUB
        UCUDUEUFUGVEUTVFUTVA $.
    $}

    cdlemk5.x $e |- X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` g )
               ) -> ( z ` P ) = Y ) ) $.
    $d b z ./\ $.  $d b g z .<_ $.  $d b z .\/ $.  $d b g z A $.  $d b g z B $.
    $d b g z F $.  $d g z G $.  $d b g z H $.  $d b g z K $.  $d b g z N $.
    $d b g z P $.  $d b g z R $.  $d b g z T $.  $d b g z W $.  $d z Y $.
    $d g b z $.  $d w .<_ $.  $d w .\/ $.  $d w A $.  $d w B $.  $d w F $.
    $d b w G $.  $d w H $.  $d b w I $.  $d w K $.  $d w N $.  $d w P $.
    $d w R $.  $d w T $.  $d w W $.  $d w X $.  $d w Y $.  $d w b $.  $d w g $.
    $d w z $.
    $( Lemma for ~ cdlemkid .  (Contributed by NM, 25-Jul-2013.)
       (New usage is discouraged.) $)
    cdlemkid3N $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ G = ( _I |` B ) ) )
     -> [_ G / g ]_ X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` G )
               ) -> ( z ` P ) = P ) ) ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn cid cres csb cv wne wral simp3r idltrn
      crio 3ad2ant1 eqeltrd wsbc csbeq2i csbriotag syl5eq sbcralg sbcimg sbc3an
      sbcg sbcne12 csbconstg csbfv a1i neeq12d syl5bb 3anbi123d sbceq2g imbi12d
      wi bitrd ralbidv riotabidv eqtrd syl simp11 simp12 simp13l simp13r simp31
      simp2 jca cdlemkid2 syl113anc 3expa eqeq2d pm5.74da ralbidva ) LULUMPJUMU
      NZHFUMOFUMHEUOZOEUOUPUQZDBUMDPMURUSUNZIUTCVAZUPZUNZUQZGIQVBZTVCZXKVDZXPEU
      OZXHVDZXRIEUOZVDZUQZDAVCUOZGIRVBZUPZWHZTFVEZAFVHZYBYCDUPZWHZTFVEZAFVHXNIF
      UMZXOYHUPXNIXKFXGXIXJXLVFXGXIXKFUMXMCFJLPUAUFUGVGVIVJYLXOXQXSXRGVCEUOZVDZ
      UQZYCRUPZWHZTFVEZGIVKZAFVHZYHYLXOGIYRAFVHZVBYTGIQUUAUKVLYRGAIFFVMVNYLYSYG
      AFYLYSYQGIVKZTFVEYGYQGTIFFVOYLUUBYFTFYLUUBYOGIVKZYPGIVKZWHYFYOYPGIFVPYLUU
      CYBUUDYEUUCXQGIVKZXSGIVKZYNGIVKZUQYLYBXQXSYNGIVQYLUUEXQUUFXSUUGYAXQGIFVRX
      SGIFVRUUGGIXRVBZGIYMVBZVDYLYAGIXRYMVSYLUUHXRUUIXTGIXRFVTUUIXTUPYLGIEWAWBW
      CWDWEWDGIYCRFWFWGWIWJWIWKWLWMXNYGYKAFXNYFYJTFXNXPFUMZUNZYBYEYIUUKYBUNYDDY
      CXNUUJYBYDDUPZXNUUJYBUQZXGXIXJXLUUJXQUNUULXGXIXMUUJYBWNXGXIXMUUJYBWOXJXLX
      GXIUUJYBWPXJXLXGXIUUJYBWQUUMUUJXQXNUUJYBWSXNUUJXQXSYAWRWTBCDEFGHIJKLMNOPR
      STUAUBUCUDUEUFUGUHUIUJXAXBXCXDXEXFWKWL $.

    $( Lemma for ~ cdlemkid .  (Contributed by NM, 25-Jul-2013.) $)
    cdlemkid4 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ G = ( _I |` B ) ) )
     -> [_ G / g ]_ X = ( iota_ z e. T A. b e. T
                ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F )
              /\ ( R ` b ) =/= ( R ` G )
               ) -> z = ( _I |` B ) ) ) ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn cid cres csb cv wne wral simp3r idltrn
      crio 3ad2ant1 eqeltrd wsbc csbeq2i csbriotag syl5eq sbcralg sbcimg sbc3an
      sbcg sbcne12 csbconstg csbfv a1i neeq12d syl5bb 3anbi123d sbceq2g imbi12d
      wi bitrd ralbidv riotabidv eqtrd wb simpl1 simpl2 simpl3l simpl3r simprlr
      syl simprr1 jca cdlemkid2 syl113anc eqeq2d simprll ltrnideq syl3anc exp44
      bitr4d imp41 pm5.74da ralbidva riotabidva ) LULUMPJUMUNZHFUMOFUMHEUOZOEUO
      UPUQZDBUMDPMURUSUNZIUTCVAZUPZUNZUQZGIQVBZTVCZXRVDZYCEUOZXOVDZYEIEUOZVDZUQ
      ZDAVCZUOZGIRVBZUPZWHZTFVEZAFVHZYIYJXRUPZWHZTFVEZAFVHYAIFUMZYBYPUPYAIXRFXN
      XPXQXSVFXNXPXRFUMXTCFJLPUAUFUGVGVIVJYTYBYDYFYEGVCEUOZVDZUQZYKRUPZWHZTFVEZ
      GIVKZAFVHZYPYTYBGIUUFAFVHZVBUUHGIQUUIUKVLUUFGAIFFVMVNYTUUGYOAFYTUUGUUEGIV
      KZTFVEYOUUEGTIFFVOYTUUJYNTFYTUUJUUCGIVKZUUDGIVKZWHYNUUCUUDGIFVPYTUUKYIUUL
      YMUUKYDGIVKZYFGIVKZUUBGIVKZUQYTYIYDYFUUBGIVQYTUUMYDUUNYFUUOYHYDGIFVRYFGIF
      VRUUOGIYEVBZGIUUAVBZVDYTYHGIYEUUAVSYTUUPYEUUQYGGIYEFVTUUQYGUPYTGIEWAWBWCW
      DWEWDGIYKRFWFWGWIWJWIWKWLWSYAYOYSAFYAYJFUMZUNZYNYRTFUUSYCFUMZUNYIYMYQYAUU
      RUUTYIYMYQWMZYAUURUUTYIUVAYAUURUUTUNZYIUNZUNZYMYKDUPZYQUVDYLDYKUVDXNXPXQX
      SUUTYDUNYLDUPXNXPXTUVCWNZXNXPXTUVCWOXQXSXNXPUVCWPZXQXSXNXPUVCWQUVDUUTYDYA
      UURUUTYIWRYDYFYHUVBYAWTXABCDEFGHIJKLMNOPRSTUAUBUCUDUEUFUGUHUIUJXBXCXDUVDX
      NUURXQYQUVEWMUVFYAUURUUTYIXEUVGBCDFYJJLMPUAUBUEUFUGXFXGXIXHXJXKXLXMWL $.

    $( Lemma for ~ cdlemkid .  (Contributed by NM, 25-Jul-2013.) $)
    cdlemkid5 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ G = ( _I |` B ) ) )
     -> [_ G / g ]_ X e. T ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn cid cres csb cv wi wral crio cdlemkid4
      wreu wrex idltrn 3ad2ant1 eqidd rgenw eqeq1 imbi2d ralbidv rspcev sylancl
      wne cdlemftr2 reusv1 syl mpbird cltrn fvex eqeltri riotaclb sylib eqeltrd
      wb cvv ) LULUMPJUMUNZHFUMOFUMHEUOZOEUOUPUQZDBUMDPMURUSUNIUTCVAZUPUNZUQZGI
      QVBTVCZWOVSWREUOZWMVSWSIEUOZVSUQZAVCZWOUPZVDZTFVEZAFVFZFABCDEFGHIJKLMNOPQ
      RSTUAUBUCUDUEUFUGUHUIUJUKVGWQXEAFVHZXFFUMWQXGXEAFVIZWQWOFUMZXAWOWOUPZVDZT
      FVEZXHWLWNXIWPCFJLPUAUFUGVJVKXKTFXAWOVLVMXEXLAWOFXCXDXKTFXCXCXJXAXBWOWOVN
      VOVPVQVRWQXATFVIZXGXHWJWLWNXMWPCEFTJLPWMWTUAUFUGUHVTVKXAATFFWOWAWBWCXEAFF
      PLWDUOZUOWKUGPXNWEWFWGWHWI $.

    $( The value of the tau function (in Lemma K of [Crawley] p. 118) on the
       identity relation.  (Contributed by NM, 25-Jul-2013.) $)
    cdlemkid $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( F e. T /\ N e. T /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( P e. A /\ -. P .<_ W ) /\ G = ( _I |` B ) ) )
     -> [_ G / g ]_ X = ( _I |` B ) ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn cid cres cvv csb cltrn fvex eqeltri cv
      wne nfv wnf nfcv wral crio nfra1 nfriota nfcxfr nfcsb nfeq1 a1i cdlemkid4
      wi eqeq1 adantl eqidd cdlemkid5 wrex cdlemftr2 3ad2ant1 riotasv3d mpan2
      wb ) LULUMPJUMUNZHFUMOFUMHEUOZOEUOUPUQZDBUMDPMURUSUNIUTCVAZUPUNZUQZFVBUMG
      IQVCZWOUPZFPLVDUOZUOVBUGPWTVEVFWQTVGZWOVHZXAEUOZWMVHZXCIEUOZVHUQZWOWOUPZW
      SATFFWOWRVBWQTVIWSTVJWQTWRWOTGIQTIVKTQXBXDXCGVGEUOVHUQDAVGUORUPWAZTFVLZAF
      VMUKXITAFXHTFVNTFVKVOVPVQVRVSABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVT
      WOWRUPXGWSWKWQWOWRWOWBWCXAFUMXFUNZXGWAWQXJWOWDVSABCDEFGHIJKLMNOPQRSTUAUBU
      CUDUEUFUGUHUIUJUKWEWLWNXFTFWFWPCEFTJLPWMXEUAUFUGUHWGWHWIWJ $.

    $( Substitution version of ~ cdlemk35 .  (Contributed by NM,
       22-Jul-2013.) $)
    cdlemk35s $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> [_ G / g ]_ X e. T ) $=
      ( wcel chlt wa cid cres wne w3a wbr wn cfv wceq csb simp22l wsbc cdlemk35
      cv wi sbcth sbcimg mpbid eleq1 neeq1 anbi12d 3anbi2d sbcieg sbcel1g mpcom
      3imtr3d ) IFULZLUMULPJULUNZHFULHUOCUPZUQUNZVTIWBUQZUNZOFULZURZDBULDPMUSUT
      UNHEVAOEVAVBUNZURZGIQVCFULZVTWDWCWFWAWHVDVTWAWCGVGZFULZWKWBUQZUNZWFURZWHU
      RZGIVEZQFULZGIVEZWIWJVTWPWRVHZGIVEWQWSVHWTGIFABCDEFHWKJKLMNOPQRSTUAUBUCUD
      UEUFUGUHUIUJUKVFVIWPWRGIFVJVKWPWIGIFWKIVBZWOWGWAWHXAWNWEWCWFXAWLVTWMWDWKI
      FVLWKIWBVMVNVOVOVPGIQFFVQVSVR $.

    $( Substitution version of ~ cdlemk35 .  (Contributed by NM,
       26-Jul-2013.) $)
    cdlemk35s-id $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ G e. T /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> [_ G / g ]_ X e. T ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq csb simpl1 simp21l simp23
      simp3r 3jca adantr simpl3l simpr syl112anc simpl1l simpl1r idltrn syl2anc
      eqeltrd simpl21 simpl22 jca simpl23 simpl3 cdlemk35s syl131anc pm2.61dane
      cdlemkid ) LULUMZPJUMZUNZHFUMZHUOCUPZUQZUNZIFUMZOFUMZURZDBUMDPMUSUTUNZHEV
      AOEVAVBZUNZURZGIQVCZFUMZIWKWTIWKVBZUNZXAWKFXDWIWJWOWRURZWQXCXAWKVBWIWPWSX
      CVDWTXEXCWTWJWOWRWJWLWNWOWIWSVEWIWMWNWOWSVFWIWPWQWRVGVHVIWQWRWIWPXCVJWTXC
      VKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKWFVLXDWGWHWKFUMWGWHWPWSXCVMWG
      WHWPWSXCVNCFJLPUAUFUGVOVPVQWTIWKUQZUNZWIWMWNXFUNWOWSXBWIWPWSXFVDWMWNWOWIW
      SXFVRXGWNXFWMWNWOWIWSXFVSWTXFVKVTWMWNWOWIWSXFWAWIWPWSXFWBABCDEFGHIJKLMNOP
      QRSTUAUBUCUDUEUFUGUHUIUJUKWCWDWE $.

    $d z G $.
    $( Substitution version of ~ cdlemk39 .  TODO:  Can any commonality with
       ~ cdlemk35s be exploited?  (Contributed by NM, 23-Jul-2013.) $)
    cdlemk39s $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> ( R ` [_ G / g ]_ X ) .<_ ( R ` G ) ) $=
      ( wcel chlt wa cid cres wne w3a wbr wn cfv wceq csb simp22l wsbc cdlemk39
      cv sbcth sbcimg mpbid eleq1 neeq1 anbi12d 3anbi2d sbcieg sbcbr12g csbfv2g
      wi csbfv a1i breq12d bitrd 3imtr3d mpcom ) IFULZLUMULPJULUNZHFULHUOCUPZUQ
      UNZWEIWGUQZUNZOFULZURZDBULDPMUSUTUNHEVAOEVAVBUNZURZGIQVCEVAZIEVAZMUSZWEWI
      WHWKWFWMVDWEWFWHGVGZFULZWRWGUQZUNZWKURZWMURZGIVEZQEVAZWREVAZMUSZGIVEZWNWQ
      WEXCXGVRZGIVEXDXHVRXIGIFABCDEFHWRJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVFVHXCX
      GGIFVIVJXCWNGIFWRIVBZXBWLWFWMXJXAWJWHWKXJWSWEWTWIWRIFVKWRIWGVLVMVNVNVOWEX
      HGIXEVCZGIXFVCZMUSWQGIXEXFMFVPWEXKWOXLWPMGIQFEVQXLWPVBWEGIEVSVTWAWBWCWD
      $.

    $( Substitution version of ~ cdlemk39 with non-identity requirement on
       ` G ` removed.  TODO:  Can any commonality with ~ cdlemk35s be
       exploited?  (Contributed by NM, 26-Jul-2013.) $)
    cdlemk39s-id $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( ( F e. T /\ F =/= ( _I |` B ) )
            /\ G e. T /\ N e. T )
         /\ ( ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) ) )
     -> ( R ` [_ G / g ]_ X ) .<_ ( R ` G ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq csb simpl1 simp21l simp23
      cp0 simp3r adantr simpl3l simpr cdlemkid syl112anc fveq2d simpl1l simpl1r
      3jca eqid syl2anc eqtrd cops hlop syl simpl22 trlcl op0le eqbrtrd simpl21
      trlid0 jca simpl23 simpl3 cdlemk39s syl131anc pm2.61dane ) LULUMZPJUMZUNZ
      HFUMZHUOCUPZUQZUNZIFUMZOFUMZURZDBUMDPMUSUTUNZHEVAOEVAVBZUNZURZGIQVCZEVAZI
      EVAZMUSZIWTXIIWTVBZUNZXKLVGVAZXLMXOXKWTEVAZXPXOXJWTEXOWRWSXDXGURZXFXNXJWT
      VBWRXEXHXNVDZXIXRXNXIWSXDXGWSXAXCXDWRXHVEWRXBXCXDXHVFWRXEXFXGVHVQVIXFXGWR
      XEXNVJXIXNVKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVLVMVNXOWPWQXQXPVBW
      PWQXEXHXNVOZWPWQXEXHXNVPCEJLPXPUAXPVRZUFUHWIVSVTXOLWAUMZXLCUMZXPXLMUSXOWP
      YBXTLWBWCXOWRXCYCXSXBXCXDWRXHXNWDCEFIJLPUAUFUGUHWEVSCLMXLXPUAUBYAWFVSWGXI
      IWTUQZUNZWRXBXCYDUNXDXHXMWRXEXHYDVDXBXCXDWRXHYDWHYEXCYDXBXCXDWRXHYDWDXIYD
      VKWJXBXCXDWRXHYDWKWRXEXHYDWLABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKWMW
      NWO $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 20-Jul-2013.) $)
    cdlemk42 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> ( [_ G / g ]_ X ` P ) = [_ G / g ]_ Y ) $=
      ( wcel chlt wa cid cres wne w3a wbr wn cfv wceq csb simp13l wsbc cdlemk36
      cv wi sbcth sbcimg mpbid eleq1 neeq1 anbi12d fveq2 neeq2d anbi2d 3anbi13d
      3anbi3d sbcieg sbceqg csbfv12 csbconstg fveq2d syl5eq bitrd 3imtr3d mpcom
      eqeq1d ) IFULZLUMULPJULUNZHFULHUOCUPZUQUNZWJIWLUQZUNZURZOFULDBULDPMUSUTUN
      HEVAZOEVAVBURZTVGZFULZWSWLUQZWSEVAZWQUQZXBIEVAZUQZURZUNZURZDGIQVCZVAZGIRV
      CZVBZWJWNWKWMWRXGVDWJWKWMGVGZFULZXMWLUQZUNZURZWRWTXAXCXBXMEVAZUQZURZUNZUR
      ZGIVEZDQVAZRVBZGIVEZXHXLWJYBYEVHZGIVEYCYFVHYGGIFABCDEFHXMJKLMNOPQRSTUAUBU
      CUDUEUFUGUHUIUJUKVFVIYBYEGIFVJVKYBXHGIFXMIVBZXQWPYAXGWRYHXPWOWKWMYHXNWJXO
      WNXMIFVLXMIWLVMVNVSYHXTXFWTYHXSXEXAXCYHXRXDXBXMIEVOVPVSVQVRVTWJYFGIYDVCZX
      KVBXLGIYDRFWAWJYIXJXKWJYIGIDVCZXIVAXJGIDQWBWJYJDXIGIDFWCWDWEWIWFWGWH $.

    $( Lemma for ~ cdlemk19x .  (Contributed by NM, 30-Jul-2013.) $)
    cdlemk19xlem $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
      /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
           /\ ( P e. A /\ -. P .<_ W ) )
      /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
           ) ) )
   -> ( [_ F / g ]_ X ` P ) = ( N ` P ) ) $=
      ( chlt wcel wa cfv wceq cid cres wne w3a wbr wn cv simp1l simp2l1 simp2l2
      csb jca simp2l3 simp2r simp1r simp3l simp3rl simp3rr 3jca syl332anc simp3
      cdlemk42 cdlemk19y syl231anc eqtrd ) KUKULOIULUMZHEUNZNEUNUOZUMZHFULZHUPC
      UQZURZNFULZUSZDBULDOLUTVAUMZUMZSVBZFULZWLWFURZWLEUNWBURZUMZUMZUSZDGHPVFUN
      ZGHQVFZDNUNZWRWAWEWGUMZXBWHWJWCWMWNWOWOUSWSWTUOWAWCWKWQVCZWRWEWGWEWGWHWJW
      DWQVDWEWGWHWJWDWQVEVGZXDWEWGWHWJWDWQVHZWDWIWJWQVIZWAWCWKWQVJZWDWKWMWPVKWR
      WNWOWOWNWOWMWDWKVLWNWOWMWDWKVMZXHVNABCDEFGHHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
      IUJVQVOWRWAXBWHWJWCWQWTXAUOXCXDXEXFXGWDWKWQVPBCDEFGHIJKLMNOQRSTUAUBUCUDUE
      UFUGUHUIVRVSVT $.

    $( ~ cdlemk19 with simpler hypotheses.  TODO:  Clean all this up.
       (Contributed by NM, 30-Jul-2013.) $)
    cdlemk19x $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
      /\ ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
      /\ ( P e. A /\ -. P .<_ W ) )
   -> ( [_ F / g ]_ X ` P ) = ( N ` P ) ) $=
      ( chlt wcel wa cfv wceq cid cres wne w3a wbr wn wrex csb simp1l cdlemftr1
      cv syl nfv nfcv wi wral crio nfra1 nfriota nfcxfr nfcsb nffv nfeq1 simpl1
      simpl2 simpl3 simpr cdlemk19xlem syl121anc exp32 rexlimd mpd ) KUKULOIULU
      MZHEUNZNEUNUOZUMZHFULHUPCUQZURNFULUSZDBULDOLUTVAUMZUSZSVFZWLURZWPEUNZWIUR
      ZUMZSFVBZDGHPVCZUNZDNUNZUOZWOWHXAWHWJWMWNVDCEFSIKOWITUEUFUGVEVGWOWTXESFWO
      SVHSXCXDSDXBSGHPSHVISPWQWSWRGVFEUNURUSDAVFUNQUOVJZSFVKZAFVLUJXGSAFXFSFVMS
      FVIVNVOVPSDVIVQVRWOWPFULZWTXEWOXHWTUMZUMWKWMWNXIXEWKWMWNXIVSWKWMWNXIVTWKW
      MWNXIWAWOXIWBABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJWCWDWEWFWG $.

    $d g ./\ $.  $d g .\/ $.  $d g Z $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 20-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk42yN $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> ( [_ G / g ]_ X ` P ) = ( ( P .\/ ( R ` G ) )
              ./\ ( Z
                .\/ ( R ` ( G o. `' b ) ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv csb ccnv ccom cdlemk42
      co simp13l cdlemk41 syl eqtrd ) LULUMPJUMUNZHFUMHUOCUPZUQUNZIFUMZIVNUQZUN
      UROFUMDBUMDPMUSUTUNHEVAZOEVAVBURZTVCZFUMVTVNUQVTEVAZVRUQWAIEVAZUQURUNZURZ
      DGIQVDVAGIRVDZDWBKVHSIVTVEVFEVAKVHNVHZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGU
      HUIUJUKVGWDVPWEWFVBVPVQVMVOVSWCVIDEFGIKNRSTUJVJVKVL $.

    $d g z I $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Lemma for Eq. 5, p. 119.
       ` G ` , ` I ` stand for g, h.  TODO: fix comment.  (Contributed by NM,
       21-Jul-2013.) $)
    cdlemk11tc $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
         /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
                /\ ( R ` b ) =/= ( R ` G ) )
            /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` I ) ) ) )
       -> ( [_ G / g ]_ X ` P )
              .<_ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` ( I o. `' G ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv csb ccnv co cdlemk11tb
      simp31 simp32 jca cdlemk42 syld3an3 simp11 simp12 simp331 simp332 simp321
      ccom simp2 simp322 simp333 3jca syl312anc oveq1d 3brtr4d ) MUMUNQJUNUOZHF
      UNHUPCUQZURUOZIFUNIWHURUOZUSZPFUNDBUNDQNUTVAUOHEVBZPEVBVCUSZUAVDZFUNZWNWH
      URZWNEVBZWLURZWQIEVBURZUSZKFUNZKWHURZWQKEVBURZUSZUSZUSZGISVEZGKSVEZKIVFVS
      EVBZLVGDGIRVEVBZDGKRVEVBZXILVGNBCDEFGHIJKLMNOPQSTUAUBUCUDUEUFUGUHUIUJUKVH
      WKWMXEWOWTUOXJXGVCXFWOWTWKWMWOWTXDVIZWKWMWOWTXDVJVKABCDEFGHIJLMNOPQRSTUAU
      BUCUDUEUFUGUHUIUJUKULVLVMXFXKXHXILXFWGWIXAXBUOWMWOWPWRXCUSXKXHVCWGWIWJWMX
      EVNWGWIWJWMXEVOXFXAXBXAXBXCWOWTWKWMVPXAXBXCWOWTWKWMVQVKWKWMXEVTXLXFWPWRXC
      WPWRWSWOXDWKWMVRWPWRWSWOXDWKWMWAXAXBXCWOWTWKWMWBWCABCDEFGHKJLMNOPQRSTUAUB
      UCUDUEUFUGUHUIUJUKULVLWDWEWF $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Eq. 5, line 36, p. 119.
       ` G ` , ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       21-Jul-2013.) $)
    cdlemk11t $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) ) )
       -> ( [_ G / g ]_ X ` P )
              .<_ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` ( I o. `' G ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq cv wrex ccnv ccom simp11l
      csb co simp11r cdlemftr3 syl2anc nfv nfcv wi wral crio nfra1 nfcxfr nfcsb
      nfriota nffv nfov nfbr simp11 simp12 simp2 simp3l simp3r1 simp3r2 simp13l
      3jca simp13r simp3r3 cdlemk11tc syl113anc 3exp rexlimd mpd ) MUMUNZQJUNZU
      OHFUNHUPCUQZURUOZIFUNIXCURUOZUSZPFUNDBUNDQNUTVAUOHEVBZPEVBVCUSZKFUNZKXCUR
      ZUOZUSZUAVDZXCURZXMEVBZXGURZXOIEVBZURZXOKEVBZURZUSZUOZUAFVEZDGIRVIZVBZDGK
      RVIZVBZKIVFVGEVBZLVJZNUTZXLXAXBYCXAXBXDXEXHXKVHXAXBXDXEXHXKVKCEFUAJMQXGXQ
      XSUBUGUHUIVLVMXLYBYJUAFXLUAVNUAYEYINUADYDUAGIRUAIVOUARXNXPXOGVDEVBURUSDAV
      DVBSVCVPZUAFVQZAFVRULYLUAAFYKUAFVSUAFVOWBVTZWAUADVOZWCUANVOUAYGYHLUADYFUA
      GKRUAKVOYMWAYNWCUALVOUAYHVOWDWEXLXMFUNZYBYJXLYOYBUSZXFXHYOXNXPXRUSXIXJXTU
      SYJXFXHXKYOYBWFXFXHXKYOYBWGXLYOYBWHYPXNXPXRXLYOXNYAWIXPXRXTXNXLYOWJXPXRXT
      XNXLYOWKWMYPXIXJXTXIXJXFXHYOYBWLXIXJXFXHYOYBWNXPXRXTXNXLYOWOWMABCDEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWPWQWRWSWT $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 37, p. 119. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  They do not explicitly
       mention the requirement ` ( G o. I ) =/= ( _I | `` B ) ` .  (Contributed
       by NM, 22-Jul-2013.) $)
    cdlemk45 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( G o. I ) =/= ( _I |` B ) ) )
       -> ( [_ ( G o. I ) / g ]_ X ` P )
              .<_ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` G ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq ccom csb co simp11 simp12
      simp13l simp31 ltrnco syl3anc simp33 jca simp2 simp32 cdlemk11t syl312anc
      ccnv cnvco coeq2i coass eqtr4i ltrn1o syl2anc f1ococnv2 syl coeq1d f1ocnv
      wf1o wf f1of fcoi2 4syl eqtrd syl5eq fveq2d trlcnv oveq2d breqtrd ) MUMUN
      QJUNUOZHFUNHUPCUQZURUOZIFUNZIXBURZUOZUSZPFUNDBUNDQNUTVAUOHEVBPEVBVCUSZKFU
      NZKXBURZIKVDZXBURZUSZUSZDGXKRVEVBZDGKRVEVBZKXKVSZVDZEVBZLVFZXPIEVBZLVFNXN
      XAXCXKFUNZXLUOXHXIXJXOXTNUTXAXCXFXHXMVGZXAXCXFXHXMVHXNYBXLXNXAXDXIYBYCXDX
      EXAXCXHXMVIZXGXHXIXJXLVJZFIKJMQUGUHVKVLXGXHXIXJXLVMVNXGXHXMVOYEXGXHXIXJXL
      VPABCDEFGHXKJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVQVRXNXSYAXPLXNXSIVSZEVBZY
      AXNXRYFEXNXRKKVSZVDZYFVDZYFXRKYHYFVDZVDYJXQYKKIKVTWAKYHYFWBWCXNYJXBYFVDZY
      FXNYIXBYFXNCCKWJZYIXBVCXNXAXIYMYCYECFKJMUMQUBUGUHWDWECCKWFWGWHXNCCIWJZCCY
      FWJCCYFWKYLYFVCXNXAXDYNYCYDCFIJMUMQUBUGUHWDWECCIWICCYFWLCCYFWMWNWOWPWQXNX
      AXDYGYAVCYCYDEFIJMQUGUHUIWRWEWOWSWT $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 38 (last line),
       p. 119. ` G ` , ` I ` stand for g, h. ` X ` represents tau.
       (Contributed by NM, 22-Jul-2013.) $)
    cdlemk46 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( G o. I ) =/= ( _I |` B ) ) )
       -> ( [_ ( G o. I ) / g ]_ X ` P )
              .<_ ( ( [_ G / g ]_ X ` P ) .\/ ( R ` I ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq ccom csb co simp11 simp31
      simp13l ltrncom syl3anc csbeq1d fveq1d simp12 simp32 simp2 simp13r simp33
      jca eqnetrd cdlemk45 syl313anc eqbrtrrd ) MUMUNQJUNUOZHFUNHUPCUQZURUOZIFU
      NZIWEURZUOZUSZPFUNDBUNDQNUTVAUOHEVBPEVBVCUSZKFUNZKWEURZIKVDZWEURZUSZUSZDG
      KIVDZRVEZVBZDGWNRVEZVBDGIRVEVBKEVBLVFZNWQDWSXAWQGWRWNRWQWDWLWGWRWNVCWDWFW
      IWKWPVGZWJWKWLWMWOVHZWGWHWDWFWKWPVIZFKIJMQUGUHVJVKZVLVMWQWDWFWLWMUOWKWGWH
      WRWEURWTXBNUTXCWDWFWIWKWPVNWQWLWMXDWJWKWLWMWOVOVSWJWKWPVPXEWGWHWDWFWKWPVQ
      WQWRWNWEXFWJWKWLWMWOVRVTABCDEFGHKJILMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWAWBW
      C $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 2, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       22-Jul-2013.) $)
    cdlemk47 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` I ) ) )
       -> ( [_ ( G o. I ) / g ]_ X ` P )
              = ( ( ( [_ G / g ]_ X ` P ) .\/ ( R ` I ) )
                ./\ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` G ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq csb ccom co simp11 simp12
      simp11l simp13 simp21 simp22 simp23 cdlemk35s ltrnel simpld simp31 simp32
      syl132anc syl3anc trlnidat simp22l ltrnat simp13l simp13r ltrnco trlconid
      jca simp33 3jca cdlemk46 syld3an3 cdlemk45 trlle syl2anc necomd syl321anc
      lhp2atne 2atm syl333anc ) MUMUNZQJUNZUOZHFUNHUPCUQZURUOZIFUNZIXDURZUOZUSZ
      PFUNZDBUNZDQNUTVAZUOZHEVBPEVBVCZUSZKFUNZKXDURZIEVBZKEVBZURZUSZUSZXADGIRVD
      ZVBZBUNZXSBUNZDGKRVDZVBZBUNZXRBUNZDGIKVEZRVDZVBZBUNZYMYDXSLVFZNUTZYMYHXRL
      VFZNUTZYOYQURZYMYOYQOVFVCXAXBXEXHXOYAVIYBYEYDQNUTVAZYBXCYCFUNZXMYEYTUOZXC
      XEXHXOYAVGZYBXCXEXHXJXMXNUUAUUCXCXEXHXOYAVHZXCXEXHXOYAVJXIXJXMXNYAVKZXIXJ
      XMXNYAVLZXIXJXMXNYAVMZABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVNVSUUFB
      DFYCJMNQUCUFUGUHVOVTZVPYBXCXPXQYFUUCXIXOXPXQXTVQZXIXOXPXQXTVRZBCEFKJMQUBU
      FUGUHUIWAVTZYBXCYGFUNZXKYIUUCYBXCXEXPXQUOXJXMXNUULUUCUUDYBXPXQUUIUUJWHUUE
      UUFUUGABCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVNVSXKXLXJXNXIYAWBZBDFYG
      JMNQUCUFUGUHWCVTZYBXCXFXGYJUUCXFXGXCXEXOYAWDZXFXGXCXEXOYAWEBCEFIJMQUBUFUG
      UHUIWAVTZYBXCYLFUNZXKYNUUCYBXCXEYKFUNZYKXDURZUOXJXMXNUUQUUCUUDYBUURUUSYBX
      CXFXPUURUUCUUOUUIFIKJMQUGUHWFVTYBXCXFXPUOXTUUSUUCYBXFXPUUOUUIWHXIXOXPXQXT
      WIZCEFIKJMQUBUGUHUIWGVTZWHUUEUUFUUGABCDEFGHYKJLMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJUKULVNVSUUMBDFYLJMNQUCUFUGUHWCVTXIXOYAXPXQUUSUSZYPYBXPXQUUSUUIUUJUVAWJZ
      ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWKWLXIXOYAUVBYRUVCABCDEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWMWLYBXCUUBYIYFXSQNUTZUOYJXRQNUTZUOXSXRU
      RYSUUCUUHUUNYBYFUVDUUKYBXCXPUVDUUCUUIEFKJMNQUCUGUHUIWNWOWHYBYJUVEUUPYBXCX
      FUVEUUCUUOEFIJMNQUCUGUHUIWNWOWHYBXRXSUUTWPBYDYHXSJLMNXRQUCUDUFUGWRWQBYDXS
      YHXRYMLMNOUCUDUEUFWSWT $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 4, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       22-Jul-2013.) $)
    cdlemk48 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) ) )
       -> ( ( [_ G / g ]_ X o. [_ I / g ]_ X ) ` P )
              .<_ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` [_ G / g ]_ X ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq csb ccom co simp11l hllat
      clat simp11 simp12 simp13 simp21 simp22 simp23 cdlemk35s syl132anc ltrnco
      syl simp3 syl3anc simp22l ltrnat trlcl syl2anc latlej1 trlcoabs syl121anc
      atbase breqtrd ) MUMUNZQJUNZUOZHFUNHUPCUQZURUOZIFUNIWNURUOZUSZPFUNZDBUNZD
      QNUTVAZUOZHEVBPEVBVCZUSZKFUNKWNURUOZUSZDGIRVDZGKRVDZVEZVBZXIXFEVBZLVFZDXG
      VBXJLVFZNXEMVIUNZXICUNZXJCUNZXIXKNUTXEWKXMWKWLWOWPXCXDVGMVHVSXEXIBUNZXNXE
      WMXHFUNZWSXPWMWOWPXCXDVJZXEWMXFFUNZXGFUNZXQXRXEWMWOWPWRXAXBXSXRWMWOWPXCXD
      VKZWMWOWPXCXDVLWQWRXAXBXDVMZWQWRXAXBXDVNZWQWRXAXBXDVOZABCDEFGHIJLMNOPQRST
      UAUBUCUDUEUFUGUHUIUJUKULVPVQZXEWMWOXDWRXAXBXTXRYAWQXCXDVTYBYCYDABCDEFGHKJ
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVPVQZFXFXGJMQUGUHVRWAWSWTWRXBWQXDWBBDFXH
      JMNQUCUFUGUHWCWABCXIMUBUFWIVSXEWMXSXOXRYECEFXFJMQUBUGUHUIWDWECLMNXIXJUBUC
      UDWFWAXEWMXSXTXAXKXLVCXRYEYFYCBDEFXFXGJLMNQUCUDUFUGUHUIWGWHWJ $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 5, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       23-Jul-2013.) $)
    cdlemk49 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) ) )
       -> ( ( [_ G / g ]_ X o. [_ I / g ]_ X ) ` P )
              .<_ ( ( [_ G / g ]_ X ` P ) .\/ ( R ` [_ I / g ]_ X ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq csb ccom co simp11 simp12
      simp13 simp21 simp22 simp23 cdlemk35s simp3 ltrncom fveq1d simp2 cdlemk48
      syl132anc syl3anc syl311anc eqbrtrd ) MUMUNQJUNUOZHFUNHUPCUQZURUOZIFUNIWD
      URUOZUSZPFUNZDBUNDQNUTVAUOZHEVBPEVBVCZUSZKFUNKWDURUOZUSZDGIRVDZGKRVDZVEZV
      BDWOWNVEZVBZDWNVBWOEVBLVFZNWMDWPWQWMWCWNFUNZWOFUNZWPWQVCWCWEWFWKWLVGZWMWC
      WEWFWHWIWJWTXBWCWEWFWKWLVHZWCWEWFWKWLVIZWGWHWIWJWLVJZWGWHWIWJWLVKZWGWHWIW
      JWLVLZABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVMVSWMWCWEWLWHWIWJXAXBXC
      WGWKWLVNZXEXFXGABCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVMVSFWNWOJMQUGU
      HVOVTVPWMWCWEWLWKWFWRWSNUTXBXCXHWGWKWLVQXDABCDEFGHKJILMNOPQRSTUAUBUCUDUEU
      FUGUHUIUJUKULVRWAWB $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 6, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  TODO:  Combine into
       ~ cdlemk52 ?  (Contributed by NM, 23-Jul-2013.) $)
    cdlemk50 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) ) )
       -> ( ( [_ G / g ]_ X o. [_ I / g ]_ X ) ` P )
            .<_ ( ( ( [_ G / g ]_ X ` P ) .\/ ( R ` [_ I / g ]_ X ) )
              ./\ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` [_ G / g ]_ X ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq ccom co cdlemk49 cdlemk48
      clat wb simp11l hllat simp11 simp12 simp13 simp21 simp22 simp23 cdlemk35s
      csb syl syl132anc simp3 ltrnco syl3anc simp22l ltrnat atbase trlcl latjcl
      syl2anc latlem12 syl13anc mpbi2and ) MUMUNZQJUNZUOZHFUNHUPCUQZURUOZIFUNIW
      QURUOZUSZPFUNZDBUNZDQNUTVAZUOZHEVBPEVBVCZUSZKFUNKWQURUOZUSZDGIRVSZGKRVSZV
      DZVBZDXIVBZXJEVBZLVEZNUTZXLDXJVBZXIEVBZLVEZNUTZXLXOXSOVENUTZABCDEFGHIJKLM
      NOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJ
      UKULVGXHMVHUNZXLCUNZXOCUNZXSCUNZXPXTUOYAVIXHWNYBWNWOWRWSXFXGVJMVKVTZXHXLB
      UNZYCXHWPXKFUNZXBYGWPWRWSXFXGVLZXHWPXIFUNZXJFUNZYHYIXHWPWRWSXAXDXEYJYIWPW
      RWSXFXGVMZWPWRWSXFXGVNWTXAXDXEXGVOZWTXAXDXEXGVPZWTXAXDXEXGVQZABCDEFGHIJLM
      NOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVRWAZXHWPWRXGXAXDXEYKYIYLWTXFXGWBYMYNYOABC
      DEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVRWAZFXIXJJMQUGUHWCWDXBXCXAXEWTXG
      WEZBDFXKJMNQUCUFUGUHWFWDBCXLMUBUFWGVTXHYBXMCUNZXNCUNZYDYFXHXMBUNZYSXHWPYJ
      XBUUAYIYPYRBDFXIJMNQUCUFUGUHWFWDBCXMMUBUFWGVTXHWPYKYTYIYQCEFXJJMQUBUGUHUI
      WHWJCLMXMXNUBUDWIWDXHYBXQCUNZXRCUNZYEYFXHXQBUNZUUBXHWPYKXBUUDYIYQYRBDFXJJ
      MNQUCUFUGUHWFWDBCXQMUBUFWGVTXHWPYJUUCYIYPCEFXIJMQUBUGUHUIWHWJCLMXQXRUBUDW
      IWDCMNOXLXOXSUBUCUEWKWLWM $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 6, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  TODO:  Combine into
       ~ cdlemk52 ?  (Contributed by NM, 23-Jul-2013.) $)
    cdlemk51 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) ) )
       -> ( ( ( [_ G / g ]_ X ` P ) .\/ ( R ` [_ I / g ]_ X ) )
              ./\ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` [_ G / g ]_ X ) ) )
            .<_ ( ( ( [_ G / g ]_ X ` P ) .\/ ( R ` I ) )
              ./\ ( ( [_ I / g ]_ X ` P ) .\/ ( R ` G ) ) ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv csb simp11 simp12 simp3 simp21
      wceq co simp22 simp23 cdlemk39s syl132anc clat wi simp11l hllat cdlemk35s
      trlcl syl2anc simp3l simp3r trlnidat syl3anc atbase simp13 simp22l ltrnat
      syl latjlej2 syl13anc mpd simp13l simp13r latjcl hlatjcl latmlem12 mp2and
      syl122anc ) MUMUNZQJUNZUOZHFUNHUPCUQZURUOZIFUNZIXCURZUOZUSZPFUNZDBUNZDQNU
      TVAZUOZHEVBPEVBVHZUSZKFUNZKXCURZUOZUSZDGIRVCZVBZGKRVCZEVBZLVIZXTKEVBZLVIZ
      NUTZDYAVBZXSEVBZLVIZYGIEVBZLVIZNUTZYCYIOVIYEYKOVINUTZXRYBYDNUTZYFXRXBXDXQ
      XIXLXMYNXBXDXGXNXQVDZXBXDXGXNXQVEZXHXNXQVFZXHXIXLXMXQVGZXHXIXLXMXQVJZXHXI
      XLXMXQVKZABCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVLVMXRMVNUNZYBCUNZYDC
      UNZXTCUNZYNYFVOXRWTUUAWTXAXDXGXNXQVPZMVQWIZXRXBYAFUNZUUBYOXRXBXDXQXIXLXMU
      UGYOYPYQYRYSYTABCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVRVMZCEFYAJMQUBU
      GUHUIVSVTZXRYDBUNZUUCXRXBXOXPUUJYOXHXNXOXPWAXHXNXOXPWBBCEFKJMQUBUFUGUHUIW
      CWDZBCYDMUBUFWEWIXRXTBUNZUUDXRXBXSFUNZXJUULYOXRXBXDXGXIXLXMUUMYOYPXBXDXGX
      NXQWFZYRYSYTABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVRVMZXJXKXIXMXHXQW
      GZBDFXSJMNQUCUFUGUHWHWDZBCXTMUBUFWEWIZCLMNYBYDXTUBUCUDWJWKWLXRYHYJNUTZYLX
      RXBXDXGXIXLXMUUSYOYPUUNYRYSYTABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULV
      LVMXRUUAYHCUNZYJCUNZYGCUNZUUSYLVOUUFXRXBUUMUUTYOUUOCEFXSJMQUBUGUHUIVSVTZX
      RYJBUNZUVAXRXBXEXFUVDYOXEXFXBXDXNXQWMXEXFXBXDXNXQWNBCEFIJMQUBUFUGUHUIWCWD
      ZBCYJMUBUFWEWIXRYGBUNZUVBXRXBUUGXJUVFYOUUHUUPBDFYAJMNQUCUFUGUHWHWDZBCYGMU
      BUFWEWIZCLMNYHYJYGUBUCUDWJWKWLXRUUAYCCUNZYECUNZYICUNZYKCUNZYFYLUOYMVOUUFX
      RUUAUUDUUBUVIUUFUURUUICLMXTYBUBUDWOWDXRWTUULUUJUVJUUEUUQUUKBCLMXTYDUBUDUF
      WPWDXRUUAUVBUUTUVKUUFUVHUVCCLMYGYHUBUDWOWDXRWTUVFUVDUVLUUEUVGUVEBCLMYGYJU
      BUDUFWPWDCMNOYKYCYEYIUBUCUEWQWSWR $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 6, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       23-Jul-2013.) $)
    cdlemk52 $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` I ) ) )
       -> ( ( [_ G / g ]_ X o. [_ I / g ]_ X ) ` P )
            = ( [_ ( G o. I ) / g ]_ X ` P ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr wn cfv wceq csb ccom co simp11l hllat
      clat simp11 simp12 simp13 simp21 simp22 simp23 cdlemk35s syl132anc simp31
      syl simp32 jca ltrnco syl3anc simp22l ltrnat atbase syl2anc latjcl latmcl
      trlcl simp11r trlnidat hlatjcl simp13l simp13r cdlemk50 syld3an3 cdlemk51
      syl211anc lattrd cdlemk47 breqtrrd cal hlatl simp33 trlconid atcmp mpbid
      wb ) MUMUNZQJUNZUOZHFUNHUPCUQZURUOZIFUNZIXMURZUOZUSZPFUNZDBUNZDQNUTVAZUOZ
      HEVBPEVBVCZUSZKFUNZKXMURZIEVBZKEVBZURZUSZUSZDGIRVDZGKRVDZVEZVBZDGIKVEZRVD
      ZVBZNUTZYOYRVCZYKYODYLVBZYHLVFZDYMVBZYGLVFZOVFZYRNYKCMNYOUUAYMEVBZLVFZUUC
      YLEVBZLVFZOVFZUUEUBUCYKXJMVIUNZXJXKXNXQYDYJVGZMVHVSZYKYOBUNZYOCUNYKXLYNFU
      NZXTUUNXLXNXQYDYJVJZYKXLYLFUNZYMFUNZUUOUUPYKXLXNXQXSYBYCUUQUUPXLXNXQYDYJV
      KZXLXNXQYDYJVLXRXSYBYCYJVMZXRXSYBYCYJVNZXRXSYBYCYJVOZABCDEFGHIJLMNOPQRSTU
      AUBUCUDUEUFUGUHUIUJUKULVPVQZYKXLXNYEYFUOZXSYBYCUURUUPUUSYKYEYFXRYDYEYFYIV
      RZXRYDYEYFYIVTZWAZUUTUVAUVBABCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVPV
      QZFYLYMJMQUGUHWBWCXTYAXSYCXRYJWDZBDFYNJMNQUCUFUGUHWEWCZBCYOMUBUFWFVSYKUUK
      UUGCUNZUUICUNZUUJCUNUUMYKUUKUUACUNZUUFCUNZUVKUUMYKUUABUNZUVMYKXLUUQXTUVOU
      UPUVCUVIBDFYLJMNQUCUFUGUHWEWCZBCUUAMUBUFWFVSYKXLUURUVNUUPUVHCEFYMJMQUBUGU
      HUIWJWGCLMUUAUUFUBUDWHWCYKUUKUUCCUNZUUHCUNZUVLUUMYKUUCBUNZUVQYKXLUURXTUVS
      UUPUVHUVIBDFYMJMNQUCUFUGUHWEWCZBCUUCMUBUFWFVSYKXLUUQUVRUUPUVCCEFYLJMQUBUG
      UHUIWJWGCLMUUCUUHUBUDWHWCCMOUUGUUIUBUEWIWCYKUUKUUBCUNZUUDCUNZUUECUNUUMYKX
      JUVOYHBUNZUWAUULUVPYKXJXKYEYFUWCUULXJXKXNXQYDYJWKZUVEUVFBCEFKJMQUBUFUGUHU
      IWLWSBCLMUUAYHUBUDUFWMWCYKXJUVSYGBUNZUWBUULUVTYKXJXKXOXPUWEUULUWDXOXPXLXN
      YDYJWNZXOXPXLXNYDYJWOBCEFIJMQUBUFUGUHUIWLWSBCLMUUCYGUBUDUFWMWCCMOUUBUUDUB
      UEWIWCXRYDYJUVDYOUUJNUTUVGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWPW
      QXRYDYJUVDUUJUUENUTUVGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWRWQWTA
      BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULXAXBYKMXCUNZUUNYRBUNZYSYTXIYKX
      JUWGUULMXDVSUVJYKXLYQFUNZXTUWHUUPYKXLXNYPFUNZYPXMURZUOXSYBYCUWIUUPUUSYKUW
      JUWKYKXLXOYEUWJUUPUWFUVEFIKJMQUGUHWBWCYKXLXOYEUOYIUWKUUPYKXOYEUWFUVEWAXRY
      DYEYFYIXECEFIKJMQUBUGUHUIXFWCWAUUTUVAUVBABCDEFGHYPJLMNOPQRSTUAUBUCUDUEUFU
      GUHUIUJUKULVPVQUVIBDFYQJMNQUCUFUGUHWEWCBYOYRMNUCUFXGWCXH $.

    $( Lemma for ~ cdlemk53 .  (Contributed by NM, 26-Jul-2013.) $)
    cdlemk53a $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( F e. T /\ F =/= ( _I |` B ) )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) )
         /\ ( N e. T /\ ( P e. A /\ -. P .<_ W ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` I ) ) )
       -> [_ ( G o. I ) / g ]_ X
               = ( [_ G / g ]_ X o. [_ I / g ]_ X ) ) $=
      ( chlt wcel wa cid cres wne w3a wbr cfv wceq ccom csb simp11l simp11r jca
      wn simp12 simp31 ltrnco syl211anc simp33 trlconid syl121anc simp21 simp22
      simp23 cdlemk35s syl132anc simp13 simp32 cdlemk52 eqcomd cdlemd syl311anc
      simp13l ) MUMUNZQJUNZUOZHFUNHUPCUQZURUOZIFUNZIWKURZUOZUSZPFUNZDBUNDQNUTVH
      UOZHEVAPEVAVBZUSZKFUNZKWKURZIEVAKEVAURZUSZUSZWJGIKVCZRVDZFUNZGIRVDZGKRVDZ
      VCZFUNZWRDXGVAZDXKVAZVBXGXKVBXEWHWIWHWIWLWOWTXDVEZWHWIWLWOWTXDVFZVGZXEWJW
      LXFFUNZXFWKURZUOWQWRWSXHXQWJWLWOWTXDVIZXEXRXSXEWHWIWMXAXRXOXPWMWNWJWLWTXD
      WGZWPWTXAXBXCVJZFIKJMQUGUHVKVLXEWJWMXAXCXSXQYAYBWPWTXAXBXCVMCEFIKJMQUBUGU
      HUIVNVOVGWPWQWRWSXDVPZWPWQWRWSXDVQZWPWQWRWSXDVRZABCDEFGHXFJLMNOPQRSTUAUBU
      CUDUEUFUGUHUIUJUKULVSVTXEWHWIXIFUNZXJFUNZXLXOXPXEWJWLWOWQWRWSYFXQXTWJWLWO
      WTXDWAYCYDYEABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVSVTXEWJWLXAXBUOWQ
      WRWSYGXQXTXEXAXBYBWPWTXAXBXCWBVGYCYDYEABCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUH
      UIUJUKULVSVTFXIXJJMQUGUHVKVLYDXEXNXMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHU
      IUJUKULWCWDBDFXGXKJMNQUCUFUGUHWEWF $.

    $( Lemma for ~ cdlemk53 .  (Contributed by NM, 26-Jul-2013.) $)
    cdlemk53b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( I e. T /\ I =/= ( _I |` B ) /\ ( R ` G ) =/= ( R ` I ) ) )
       -> [_ ( G o. I ) / g ]_ X
               = ( [_ G / g ]_ X o. [_ I / g ]_ X ) ) $=
      ( chlt wcel wa cfv wceq cid cres wne w3a wbr ccom csb wf1o simp1l simp211
      wn simp212 jca simp31 simp213 simp23 simp1r cdlemk35s-id syl132anc ltrn1o
      wf syl2anc adantr f1of fcoi2 3syl simpl1l 3jca simpl23 cdlemkid syl112anc
      simpr coeq1d simpl31 csbeq1d 3eqtr4rd simpl22 simpl1r cdlemk53a syl331anc
      eqtrd simpl3 pm2.61dane ) MUMUNQJUNUOZHEUPPEUPUQZUOZHFUNZHURCUSZUTZPFUNZV
      AZIFUNZDBUNDQNVBVHUOZVAZKFUNZKXEUTZIEUPKEUPUTZVAZVAZGIKVCZRVDZGIRVDZGKRVD
      ZVCZUQZIXEXPIXEUQZUOZXEXTVCZXTYAXRYDCCXTVEZCCXTVRYEXTUQXPYFYCXPXAXTFUNZYF
      XAXBXKXOVFZXPXAXDXFUOZXLXGXJXBYGYHXPXDXFXDXFXGXIXJXCXOVGZXDXFXGXIXJXCXOVI
      VJZXCXKXLXMXNVKXDXFXGXIXJXCXOVLZXCXHXIXJXOVMXAXBXKXOVNZABCDEFGHKJLMNOPQRS
      TUAUBUCUDUEUFUGUHUIUJUKULVOVPCFXTJMUMQUBUGUHVQVSVTCCXTWACCXTWBWCYDXSXEXTY
      DXAXDXGXBVAZXJYCXSXEUQXAXBXKXOYCWDZXPYNYCXPXDXGXBYJYLYMWEVTXHXIXJXCXOYCWF
      XPYCWIZABCDEFGHIJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWGWHWJYDGXQKRYDXQXEKVCZ
      KYDIXEKYPWJYDCCKVEZCCKVRYQKUQYDXAXLYRYOXLXMXNXCXKYCWKCFKJMUMQUBUGUHVQVSCC
      KWACCKWBWCWRWLWMXPIXEUTZUOZXAYIXIYSUOXGXJXBXOYBXAXBXKXOYSWDXPYIYSYKVTYTXI
      YSXHXIXJXCXOYSWNXPYSWIVJXPXGYSYLVTXHXIXJXCXOYSWFXAXBXKXOYSWOXCXKXOYSWSABC
      DEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWPWQWT $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 7, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       26-Jul-2013.) $)
    cdlemk53 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( I e. T /\ ( R ` G ) =/= ( R ` I ) ) )
       -> [_ ( G o. I ) / g ]_ X
               = ( [_ G / g ]_ X o. [_ I / g ]_ X ) ) $=
      ( chlt wcel wa cfv wceq cid cres wne w3a wbr ccom csb wf1o simp1l simp211
      wn simp212 jca simp22 simp213 simp23 simp1r cdlemk35s-id syl132anc ltrn1o
      wf syl2anc f1of fcoi1 3syl adantr simpl1l 3jca simpl23 cdlemkid syl112anc
      coeq2d csbeq1d 3eqtr4rd simpl1 simpl2 simpl3l simpl3r cdlemk53b syl113anc
      simpr eqtrd pm2.61dane ) MUMUNQJUNUOZHEUPPEUPUQZUOZHFUNZHURCUSZUTZPFUNZVA
      ZIFUNZDBUNDQNVBVHUOZVAZKFUNZIEUPKEUPUTZUOZVAZGIKVCZRVDZGIRVDZGKRVDZVCZUQZ
      KXEXOKXEUQZUOZXRXEVCZXRXTXQXOYDXRUQZYBXOCCXRVEZCCXRVRYEXOXAXRFUNZYFXAXBXK
      XNVFZXOXAXDXFUOXIXGXJXBYGYHXOXDXFXDXFXGXIXJXCXNVGZXDXFXGXIXJXCXNVIVJXCXHX
      IXJXNVKZXDXFXGXIXJXCXNVLZXCXHXIXJXNVMXAXBXKXNVNZABCDEFGHIJLMNOPQRSTUAUBUC
      UDUEUFUGUHUIUJUKULVOVPCFXRJMUMQUBUGUHVQVSCCXRVTCCXRWAWBWCYCXSXEXRYCXAXDXG
      XBVAZXJYBXSXEUQXAXBXKXNYBWDXOYMYBXOXDXGXBYIYKYLWEWCXHXIXJXCXNYBWFXOYBWRZA
      BCDEFGHKJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWGWHWIYCGXPIRYCXPIXEVCZIYCKXEIY
      NWIXOYOIUQZYBXOCCIVEZCCIVRYPXOXAXIYQYHYJCFIJMUMQUBUGUHVQVSCCIVTCCIWAWBWCW
      SWJWKXOKXEUTZUOXCXKXLYRXMYAXCXKXNYRWLXCXKXNYRWMXLXMXCXKYRWNXOYRWRXLXMXCXK
      YRWOABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWPWQWT $.

    $d b g j z $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 10, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       26-Jul-2013.) $)
    cdlemk54 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( ( I e. T /\ ( R ` G ) = ( R ` I ) ) /\ j e. T
            /\ ( j =/= ( _I |` B ) /\ ( R ` j ) =/= ( R ` G )
                /\ ( R ` j ) =/= ( R ` ( G o. I ) ) ) ) )
       -> ( [_ ( G o. I ) / g ]_ X o. [_ j / g ]_ X )
               = ( ( [_ G / g ]_ X o. [_ I / g ]_ X ) o. [_ j / g ]_ X ) ) $=
      ( chlt wcel wa cfv wceq cid cres wne w3a wbr wn cv csb coass csbeq1 ax-mp
      simp1 simp21 simp1l simp22 simp31l ltrnco syl3anc simp23 simp333 cdlemk53
      simp32 necomd syl132anc simp31r simp332 neeqtrd simp331 trlcone syl122anc
      ccom simp2 eqnetrd syl112anc coeq2d syl6eqr eqtrd 3eqtr3a ) NUNUORKUOUPZI
      EUQQEUQURZUPZIFUOIUSCUTZVAQFUOVBZJFUOZDBUODROVCVDUPZVBZLFUOZJEUQZLEUQZURZ
      UPZHVEZFUOZXJWTVAZXJEUQZXFVAZXMJLWIZEUQZVAZVBZVBZVBZGXOXJWIZSVFZGJLXJWIZW
      IZSVFZGXOSVFGXJSVFZWIZGJSVFZGLSVFZWIYFWIZYAYDURYBYEURJLXJVGGYAYDSVHVIXTWS
      XAXOFUOZXCXKXPXMVAYBYGURWSXDXSVJZWSXAXBXCXSVKZXTWQXBXEYKWQWRXDXSVLZWSXAXB
      XCXSVMXEXHXKXRWSXDVNZFJLKNRUHUIVOVPWSXAXBXCXSVQZWSXDXIXKXRVTZXTXMXPXLXNXQ
      XIXKWSXDVRWAABCDEFGIXOKXJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVSWBXTYEYHGYCS
      VFZWIZYJXTWSXDYCFUOZXFYCEUQZVAYEYSURYLWSXDXSWJXTWQXEXKYTYNYOYQFLXJKNRUHUI
      VOVPXTXFXGUUAXEXHXKXRWSXDWCZXTWQXEXKXGXMVAZXLXGUUAVAYNYOYQXTXMXGXTXMXFXGX
      LXNXQXIXKWSXDWDUUBWEWAZXLXNXQXIXKWSXDWFCEFLXJKNRUCUHUIUJWGWHWKABCDEFGIJKY
      CMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVSWLXTYSYHYIYFWIZWIYJXTYRUUEYHXTWSXAXE
      XCXKUUCYRUUEURYLYMYOYPYQUUDABCDEFGILKXJMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
      VSWBWMYHYIYFVGWNWOWP $.

    $( Lemma for ~ cdlemk55 .  (Contributed by NM, 26-Jul-2013.) $)
    cdlemk55a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( ( I e. T /\ ( R ` G ) = ( R ` I ) ) /\ j e. T
            /\ ( j =/= ( _I |` B ) /\ ( R ` j ) =/= ( R ` G )
                /\ ( R ` j ) =/= ( R ` ( G o. I ) ) ) ) )
       -> [_ ( G o. I ) / g ]_ X
               = ( [_ G / g ]_ X o. [_ I / g ]_ X ) ) $=
      ( chlt wcel wa cfv wceq cid cres wne w3a wbr wn ccom csb ccnv wf1o simp1l
      cv simp211 simp212 jca simp32 simp23 simp1r cdlemk35s-id syl131anc ltrn1o
      simp213 syl2anc f1ococnv2 syl coeq2d wf simp22 simp31l syl3anc f1of fcoi1
      ltrnco 3syl eqtr2d coass syl6eqr cdlemk54 coeq1d eqtrd syl5eq ) NUNUORKUO
      UPZIEUQQEUQURZUPZIFUOZIUSCUTZVAZQFUOZVBZJFUOZDBUODROVCVDUPZVBZLFUOZJEUQZL
      EUQURZUPZHVJZFUOZXOXDVAXOEUQZXLVAXQJLVEZEUQVAVBZVBZVBZGXRSVFZYBGXOSVFZVEZ
      YCVGZVEZGJSVFZGLSVFZVEZYAYBYBYCYEVEZVEZYFYAYKYBXDVEZYBYAYJXDYBYACCYCVHZYJ
      XDURYAWTYCFUOZYMWTXAXJXTVIZYAWTXCXEUPZXPXFXIXAUPZYNYOYAXCXEXCXEXFXHXIXBXT
      VKXCXEXFXHXIXBXTVLVMZXBXJXNXPXSVNXCXEXFXHXIXBXTVTZYAXIXAXBXGXHXIXTVOWTXAX
      JXTVPVMZABCDEFGIXOKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVQVRCFYCKNUNRUCUHUIV
      SWACCYCWBWCZWDYACCYBVHZCCYBWEYLYBURYAWTYBFUOZUUBYOYAWTYPXRFUOZXFYQUUCYOYR
      YAWTXHXKUUDYOXBXGXHXIXTWFZXKXMXPXSXBXJWGZFJLKNRUHUIWKWHYSYTABCDEFGIXRKMNO
      PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVQVRCFYBKNUNRUCUHUIVSWACCYBWICCYBWJWLWMYBY
      CYEWNWOYAYFYIYCVEZYEVEZYIYAYDUUGYEABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
      JUKULUMWPWQYAUUHYIYJVEZYIYIYCYEWNYAUUIYIXDVEZYIYAYJXDYIUUAWDYACCYIVHZCCYI
      WEUUJYIURYAWTYIFUOZUUKYOYAWTYGFUOZYHFUOZUULYOYAWTYPXHXFYQUUMYOYRUUEYSYTAB
      CDEFGIJKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVQVRYAWTYPXKXFYQUUNYOYRUUFYSYTA
      BCDEFGILKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVQVRFYGYHKNRUHUIWKWHCFYIKNUNRU
      CUHUIVSWACCYIWICCYIWJWLWRWSWRWR $.

    $d j .<_ $.  $d j A $.  $d j B $.  $d j F $.  $d j G $.  $d j H $.
    $d j I $.  $d j K $.  $d j N $.  $d j P $.  $d j R $.  $d j T $.  $d j W $.
    $d j X $.
    $( Lemma for ~ cdlemk55 .  (Contributed by NM, 26-Jul-2013.) $)
    cdlemk55b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ G e. T /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( I e. T /\ ( R ` G ) = ( R ` I ) ) )
       -> [_ ( G o. I ) / g ]_ X
               = ( [_ G / g ]_ X o. [_ I / g ]_ X ) ) $=
      ( vj chlt wcel wa cfv wceq cid cres wne w3a wbr ccom wrex simp1ll simp1lr
      wn cv csb cdlemftr2 syl2anc simp11 simp12 simp2 simp3 cdlemk55a syl113anc
      simp13 rexlimdv3a mpd ) MUNUOZQJUOZUPHEUQPEUQURZUPZHFUOHUSCUTZVAPFUOVBIFU
      ODBUODQNVCVHUPVBZKFUOIEUQZKEUQURUPZVBZUMVIZWFVAWKEUQZWHVAWLIKVDZEUQZVAVBZ
      UMFVEZGWMRVJGIRVJGKRVJVDURZWJWBWCWPWBWCWDWGWIVFWBWCWDWGWIVGCEFUMJMQWHWNUB
      UGUHUIVKVLWJWOWQUMFWJWKFUOZWOVBWEWGWIWRWOWQWEWGWIWRWOVMWEWGWIWRWOVNWEWGWI
      WRWOVSWJWRWOVOWJWRWOVPABCDEFGUMHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVQVRV
      TWA $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 11, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       26-Jul-2013.) $)
    cdlemk55 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ G e. T /\ I e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> [_ ( G o. I ) / g ]_ X
               = ( [_ G / g ]_ X o. [_ I / g ]_ X ) ) $=
      ( chlt wcel cfv wceq cid cres wne w3a wbr ccom csb simpl1 simpl21 simpl22
      wa wn simpl3 simpl23 simpr cdlemk55b syl132anc cdlemk53 pm2.61dane ) MUMU
      NQJUNVGHEUOPEUOUPVGZHFUNHUQCURUSPFUNUTZIFUNZKFUNZUTZDBUNDQNVAVHVGZUTZGIKV
      BRVCGIRVCGKRVCVBUPZIEUOZKEUOZWBWDWEUPZVGVPVQVRWAVSWFWCVPVTWAWFVDVQVRVSVPW
      AWFVEVQVRVSVPWAWFVFVPVTWAWFVIVQVRVSVPWAWFVJWBWFVKABCDEFGHIJKLMNOPQRSTUAUB
      UCUDUEUFUGUHUIUJUKULVLVMWBWDWEUSZVGVPVQVRWAVSWGWCVPVTWAWGVDVQVRVSVPWAWGVE
      VQVRVSVPWAWGVFVPVTWAWGVIVQVRVSVPWAWGVJWBWGVKABCDEFGHIJKLMNOPQRSTUAUBUCUDU
      EUFUGUHUIUJUKULVNVMVO $.

    ${
      cdlemk5a.s $e |- S = ( f e. T |-> ( iota_ i e. T
          ( i ` P ) = ( ( P .\/ ( R ` f ) )
                ./\ ( ( N ` P ) .\/ ( R ` ( f o. `' F ) ) ) ) ) ) $.
      cdlemk5a.u1 $e |- V = ( d e. T , e e. T
            |-> ( iota_ j e. T
          ( j ` P ) = ( ( P .\/ ( R ` e ) )
                ./\ ( ( ( S ` d ) ` P )
                  .\/ ( R ` ( e o. `' d ) ) ) ) ) ) $.
      $d d e f i j ./\ $.  $d i j .<_ $.  $d d e f i j .\/ $.  $d i j A $.
      $d f i j F $.  $d d e j G $.  $d i j H $.  $d i j K $.  $d f i j N $.
      $d d e f i j P $.  $d d e f i j R $.  $d b d e j S $.  $d d e f i j T $.
      $d d e f i j W $.  $d d e f i j b $.
      $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: clean up
         ` ( b Y G ) ` stuff.  (Contributed by NM, 21-Jul-2013.)
         (New usage is discouraged.) $)
      cdlemkyyN $p |- ( ( ( K e. HL /\ W e. H /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ F =/= ( _I |` B ) /\ N e. T )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> ( [_ G / g ]_ X ` P ) = ( ( b V G ) ` P ) ) $=
        ( chlt wcel cfv wceq w3a cid cres wne wa wbr wn cv ccnv ccom csb simp11
        simp12 jca simp13 simp211 simp3l simp213 simp3r2 simp212 simp3r1 simp23
        cdlemk30 syl233anc syl6eqr oveq1d 3jca simp22l simp3r3 simp22r cdlemk31
        co oveq2d syl223anc simp22 simp3 cdlemk42yN syl331anc 3eqtr4rd ) QVAVBZ
        UBOVBZMEVCZTEVCVDZVEZMGVBZMVFCVGZVHZTGVBZVEZNGVBZNXJVHZVIZDBVBDUBRVJVKV
        IZVEZUFVLZGVBZXSXJVHZXSEVCZXFVHZYBNEVCZVHZVEZVIZVEZDYDPWPZDXSFVCVCZNXSV
        MVNEVCZPWPZSWPZYIUEYKPWPZSWPZDXSNUAWPVCZDJNUCVOVCZYHYLYNYISYHYJUEYKPYHY
        JDYBPWPDTVCXSMVMVNEVCPWPSWPZUEYHXDXEVIZXGXIXTXLYCXKYAVIXQYJYRVDYHXDXEXD
        XEXGXRYGVPXDXEXGXRYGVQVRZXDXEXGXRYGVSZXIXKXLXPXQXHYGVTZXHXRXTYFWAZXIXKX
        LXPXQXHYGWBZYAYCYEXTXHXRWCZYHXKYAXIXKXLXPXQXHYGWDZYAYCYEXTXHXRWEZVRXHXM
        XPXQYGWFZBCDEFGIKMOPQRSTUBUFUHUIUJUKULUMUNUOUSWGWHUPWIWJWQYHYSXGXIXTXLV
        EXNYCYEVIXKYAXOVEXQYPYMVDYTUUAYHXIXTXLUUBUUCUUDWKXNXOXMXQXHYGWLYHYCYEUU
        EYAYCYEXTXHXRWMVRYHXKYAXOUUFUUGXNXOXMXQXHYGWNWKUUHBCDEFGHIKLMNOPQRSTUBU
        AUFUGUHUIUJUKULUMUNUOUSUTWOWRYHYSXIXKVIXPXLXQXGYGYQYOVDYTYHXIXKUUBUUFVR
        XHXMXPXQYGWSUUDUUHUUAXHXRYGWTABCDEGJMNOPQRSTUBUCUDUEUFUHUIUJUKULUMUNUOU
        PUQURXAXBXC $.
    $}

    cdlemk5.u $e |- U = ( g e. T |-> if ( F = N , g , X ) ) $.
    $( Part of proof of Lemma K of [Crawley] p. 118.  TODO: fix comment.
       (Contributed by NM, 31-Jul-2013.)  (New usage is discouraged.) $)
    cdlemk43N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( ( F e. T /\ N e. T /\ F =/= N )
            /\ ( G e. T /\ G =/= ( _I |` B ) ) /\ ( P e. A /\ -. P .<_ W ) )
        /\ ( b e. T /\ ( b =/= ( _I |` B ) /\ ( R ` b ) =/= ( R ` F )
            /\ ( R ` b ) =/= ( R ` G ) ) ) )
     -> ( ( U ` G ) ` P ) = [_ G / g ]_ Y ) $=
      ( chlt wcel wa cfv wceq wne w3a cid cres wbr wn cv csb simp213 simp22l wi
      wral cdlemk40f syl2anc fveq1d simp1l simp211 simp212 simp1r syl122anc jca
      trlnid simp22 simp23 simp3 cdlemk42 syl331anc eqtrd ) MUNUOQKUOUPZIEUQZPE
      UQURZUPZIFUOZPFUOZIPUSZUTZJFUOZJVACVBZUSZUPZDBUODQNVCVDUPZUTZUAVEZFUOXAWP
      USZXAEUQZWHUSZXCJEUQUSUTUPZUTZDJGUQZUQDHJRVFZUQZHJSVFZXFDXGXHXFWMWOXGXHUR
      WKWLWMWRWSWJXEVGZWOWQWNWSWJXEVHXBXDXCHVEEUQUSUTDAVEUQSURVIUAFVJAFGHIJPRUL
      UMVKVLVMXFWGWKIWPUSZUPWRWLWSWIXEXIXJURWGWIWTXEVNZXFWKXLWKWLWMWRWSWJXEVOZX
      FWGWKWLWMWIXLXMXNWKWLWMWRWSWJXEVPZXKWGWIWTXEVQZCEFIPKMQUBUGUHUIVTVRVSWJWN
      WRWSXEWAXOWJWNWRWSXEWBXPWJWTXEWCABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUK
      ULWDWEWF $.

    $( Substitution version of ~ cdlemk35 .  (Contributed by NM,
       31-Jul-2013.) $)
    cdlemk35u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
        /\ ( F e. T /\ N e. T /\ G e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( U ` G ) e. T ) $=
      ( chlt wcel wa cfv wceq w3a wbr wn simpr simpl23 cv cid cres wi cdlemk40t
      wne wral syl2anc eqeltrd cdlemk40f simpl1l simpl21 simpl22 simpl1r trlnid
      csb syl122anc jca simpl3 cdlemk35s-id syl132anc pm2.61dane ) MUNUOQKUOUPZ
      IEUQZPEUQURZUPZIFUOZPFUOZJFUOZUSZDBUODQNUTVAUPZUSZJGUQZFUOIPWOIPURZUPZWPJ
      FWRWQWLWPJURWOWQVBWJWKWLWIWNWQVCZUAVDZVECVFZVIWTEUQZWGVIXBHVDEUQVIUSDAVDU
      QSURVGUAFVJZAFGHIJPRULUMVHVKWSVLWOIPVIZUPZWPHJRVSZFXEXDWLWPXFURWOXDVBZWJW
      KWLWIWNXDVCZXCAFGHIJPRULUMVMVKXEWFWJIXAVIZUPWLWKWNWHXFFUOWFWHWMWNXDVNZXEW
      JXIWJWKWLWIWNXDVOZXEWFWJWKXDWHXIXJXKWJWKWLWIWNXDVPZXGWFWHWMWNXDVQZCEFIPKM
      QUBUGUHUIVRVTWAXHXLWIWMWNXDWBXMABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKU
      LWCWDVLWE $.

    $( Lemma for ~ cdlemk55u .  (Contributed by NM, 31-Jul-2013.) $)
    cdlemk55u1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ N e. T )
        /\ ( ( ( R ` F ) = ( R ` N ) /\ F =/= N ) /\ G e. T /\ I e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> ( U ` ( G o. I ) ) = ( ( U ` G ) o. ( U ` I ) ) ) $=
      ( chlt wcel wa w3a cfv wceq wne wbr wn ccom csb cid simp11 simp21l simp12
      cres simp13 simp21r trlnid syl122anc 3jca simp22 simp3 cdlemk55 syl231anc
      simp23 ltrnco syl3anc cv wi wral cdlemk40f syl2anc coeq12d 3eqtr4d ) NUOU
      PRKUPUQZIFUPZQFUPZURZIEUSZQEUSUTZIQVAZUQZJFUPZLFUPZURZDBUPDROVBVCUQZURZHJ
      LVDZSVEZHJSVEZHLSVEZVDZXCGUSZJGUSZLGUSZVDXBWJWOWKIVFCVJZVAZWLURWRWSXAXDXG
      UTWJWKWLWTXAVGZWOWPWRWSWMXAVHZXBWKXLWLWJWKWLWTXAVIZXBWJWKWLWPWOXLXMXOWJWK
      WLWTXAVKZWOWPWRWSWMXAVLZXNCEFIQKNRUCUHUIUJVMVNXPVOWMWQWRWSXAVPZWMWQWRWSXA
      VTZWMWTXAVQABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVRVSXBWPXCFUPZXHX
      DUTXQXBWJWRWSXTXMXRXSFJLKNRUHUIWAWBUBWCZXKVAYAEUSZWNVAYBHWCEUSVAURDAWCUST
      UTWDUBFWEZAFGHIXCQSUMUNWFWGXBXIXEXJXFXBWPWRXIXEUTXQXRYCAFGHIJQSUMUNWFWGXB
      WPWSXJXFUTXQXSYCAFGHILQSUMUNWFWGWHWI $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 11, p. 120. ` G ` ,
       ` I ` stand for g, h. ` X ` represents tau.  (Contributed by NM,
       31-Jul-2013.) $)
    cdlemk55u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ N e. T )
        /\ ( ( R ` F ) = ( R ` N ) /\ G e. T /\ I e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
       -> ( U ` ( G o. I ) ) = ( ( U ` G ) o. ( U ` I ) ) ) $=
      ( chlt wcel wa w3a cfv wceq wbr wn ccom simpr simp11 simp22 simp23 ltrnco
      syl3anc adantr cv cid cres wral cdlemk40t syl2anc simpl22 simpl23 coeq12d
      wne wi eqtr4d simpl1 simpl21 jca simpl3 cdlemk55u1 syl131anc pm2.61dane )
      NUOUPRKUPUQZIFUPZQFUPZURZIEUSZQEUSUTZJFUPZLFUPZURZDBUPDROVAVBUQZURZJLVCZG
      USZJGUSZLGUSZVCZUTZIQWTIQUTZUQZXBXAXEXHXGXAFUPZXBXAUTWTXGVDZWTXIXGWTWJWPW
      QXIWJWKWLWRWSVEWMWOWPWQWSVFWMWOWPWQWSVGFJLKNRUHUIVHVIVJUBVKZVLCVMVTXKEUSZ
      WNVTXLHVKEUSVTURDAVKUSTUTWAUBFVNZAFGHIXAQSUMUNVOVPXHXCJXDLXHXGWPXCJUTXJWO
      WPWQWMWSXGVQXMAFGHIJQSUMUNVOVPXHXGWQXDLUTXJWOWPWQWMWSXGVRXMAFGHILQSUMUNVO
      VPVSWBWTIQVTZUQZWMWOXNUQWPWQWSXFWMWRWSXNWCXOWOXNWOWPWQWMWSXNWDWTXNVDWEWOW
      PWQWMWSXNVQWOWPWQWMWSXNVRWMWRWSXNWFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJUKULUMUNWGWHWI $.

    $( Lemma for ~ cdlemk39u .  (Contributed by NM, 31-Jul-2013.) $)
    cdlemk39u1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ N e. T )
        /\ ( ( R ` F ) = ( R ` N ) /\ F =/= N /\ G e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( R ` ( U ` G ) ) .<_ ( R ` G ) ) $=
      ( chlt wcel wa w3a cfv wceq wne wbr wn csb simp22 simp23 cv cid cres wral
      cdlemk40f syl2anc fveq2d simp11 simp12 simp13 simp21 trlnid syl122anc jca
      wi simp3 cdlemk39s-id syl132anc eqbrtrd ) MUNUOQKUOUPZIFUOZPFUOZUQZIEURZP
      EURUSZIPUTZJFUOZUQZDBUODQNVAVBUPZUQZJGURZEURHJRVCZEURZJEURZNWOWPWQEWOWKWL
      WPWQUSWHWJWKWLWNVDZWHWJWKWLWNVEZUAVFZVGCVHZUTXBEURZWIUTXDHVFEURUTUQDAVFUR
      SUSVTUAFVIAFGHIJPRULUMVJVKVLWOWEWFIXCUTZUPWLWGWNWJWRWSNVAWEWFWGWMWNVMZWOW
      FXEWEWFWGWMWNVNZWOWEWFWGWKWJXEXFXGWEWFWGWMWNVOZWTWHWJWKWLWNVPZCEFIPKMQUBU
      GUHUIVQVRVSXAXHWHWMWNWAXIABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWBWCW
      D $.

    $( Part of proof of Lemma K of [Crawley] p. 118.  Line 31, p. 119.
       Trace-preserving property of the value of tau, represented by
       ` ( U `` G ) ` .  (Contributed by NM, 31-Jul-2013.) $)
    cdlemk39u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ N e. T )
        /\ ( ( R ` F ) = ( R ` N ) /\ G e. T )
        /\ ( P e. A /\ -. P .<_ W ) )
     -> ( R ` ( U ` G ) ) .<_ ( R ` G ) ) $=
      ( chlt wcel wa w3a cfv wceq wbr wn simpr simpl2r cv cid cres wi cdlemk40t
      wne wral syl2anc fveq2d clat simp11l hllat syl simp11 simp2r trlcl latref
      adantr eqbrtrd simpl1 simpl2l simpl3 cdlemk39u1 syl131anc pm2.61dane ) MU
      NUOZQKUOZUPZIFUOZPFUOZUQZIEURZPEURUSZJFUOZUPZDBUODQNUTVAUPZUQZJGURZEURZJE
      URZNUTZIPWTIPUSZUPZXBXCXCNXFXAJEXFXEWQXAJUSWTXEVBWPWQWNWSXEVCUAVDZVECVFVI
      XGEURZWOVIXHHVDEURVIUQDAVDURSUSVGUAFVJAFGHIJPRULUMVHVKVLWTXCXCNUTZXEWTMVM
      UOZXCCUOZXIWTWIXJWIWJWLWMWRWSVNMVOVPWTWKWQXKWKWLWMWRWSVQWNWPWQWSVRCEFJKMQ
      UBUGUHUIVSVKCMNXCUBUCVTVKWAWBWTIPVIZUPWNWPXLWQWSXDWNWRWSXLWCWPWQWNWSXLWDW
      TXLVBWPWQWNWSXLVCWNWRWSXLWEABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
      WFWGWH $.

    $( ~ cdlemk19 with simpler hypotheses.  TODO:  Clean all this up.
       (Contributed by NM, 31-Jul-2013.) $)
    cdlemk19u1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
      /\ ( F e. T /\ F =/= N /\ N e. T )
      /\ ( P e. A /\ -. P .<_ W ) )
   -> ( ( U ` F ) ` P ) = ( N ` P ) ) $=
      ( chlt wcel wa cfv wceq wne w3a wbr wn csb simp22 simp21 cv cid cres wral
      wi cdlemk40f syl2anc fveq1d simp1l simp23 simp1r syl122anc 3jca cdlemk19x
      trlnid syld3an2 eqtrd ) LUMUNPJUNUOZIEUPZOEUPUQZUOZIFUNZIOURZOFUNZUSZDBUN
      DPMUTVAUOZUSZDIGUPZUPDHIQVBZUPZDOUPZWKDWLWMWKWGWFWLWMUQWEWFWGWHWJVCZWEWFW
      GWHWJVDZTVEZVFCVGZURWREUPZWCURWTHVEEUPURUSDAVEUPRUQVITFVHAFGHIIOQUKULVJVK
      VLWEWFIWSURZWHUSWIWJWNWOUQWKWFXAWHWQWKWBWFWHWGWDXAWBWDWIWJVMWQWEWFWGWHWJV
      NZWPWBWDWIWJVOCEFIOJLPUAUFUGUHVSVPXBVQABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUH
      UIUJUKVRVTWA $.

    $( Part of Lemma K of [Crawley] p. 118.  Line 12, p. 120, "f (exponent) tau
       = k".  We represent f, k, tau with ` F ` , ` N ` , ` U ` .  (Contributed
       by NM, 31-Jul-2013.) $)
    cdlemk19u $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( R ` F ) = ( R ` N ) )
      /\ ( F e. T /\ N e. T )
      /\ ( P e. A /\ -. P .<_ W ) )
   -> ( U ` F ) = N ) $=
      ( chlt wcel wa cfv wceq wbr wn simp1l simp1 simp2l simp2r simp3 cdlemk35u
      w3a syl131anc simpr simpl2l cv cid cres wne wral cdlemk40t syl2anc fveq1d
      fveq1 adantl simpl1 simpl2r simpl3 cdlemk19u1 pm2.61dane cdlemd syl311anc
      wi eqtrd ) LUMUNPJUNUOZIEUPZOEUPUQZUOZIFUNZOFUNZUOZDBUNDPMURUSUOZVFZWIIGU
      PZFUNZWNWPDWRUPZDOUPZUQZWROUQWIWKWOWPUTWQWLWMWNWMWPWSWLWOWPVAWLWMWNWPVBZW
      LWMWNWPVCZXCWLWOWPVDZABCDEFGHIIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULVEVGXDX
      EWQXBIOWQIOUQZUOZWTDIUPZXAXGDWRIXGXFWMWRIUQWQXFVHWMWNWLWPXFVITVJZVKCVLVMX
      IEUPZWJVMXJHVJEUPVMVFDAVJUPRUQWGTFVNAFGHIIOQUKULVOVPVQXFXHXAUQWQDIOVRVSWH
      WQIOVMZUOWLWMXKWNWPXBWLWOWPXKVTWMWNWLWPXKVIWQXKVHWMWNWLWPXKWAWLWOWPXKWBAB
      CDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULWCVGWDBDFWROJLMPUBUEUFUGWEWF $.

    cdlemk5.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $d f h .<_ $.  $d f h A $.  $d f h F $.  $d f h H $.  $d f h K $.
    $d f h N $.  $d f h P $.  $d f h R $.  $d f h T $.  $d f h U $.
    $d f h W $.  $d b f h g z $.
    $( Part of Lemma K of [Crawley] p. 118.  Line 11, p. 120, "tau is in Delta"
       i.e. ` U ` is a trace-preserving endormorphism.  (Contributed by NM,
       31-Jul-2013.) $)
    cdlemk56 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ F e. T /\ N e. T )
        /\ ( R ` F ) = ( R ` N ) /\ ( P e. A /\ -. P .<_ W ) )
     -> U e. E ) $=
      ( vf vh chlt wcel wa w3a cfv wceq wbr wn simp11 wfn cv wf cif cvv vex cid
      wral cres wi crio riotaex eqeltri ifex rgenw fnmpt simpl11 simpl2 simpl12
      wne mp1i simpl13 simpr simpl3 cdlemk35u syl231anc ralrimiva sylanbrc ccom
      ffnfv simp12 simp2 simp3 cdlemk55u syl131anc cdlemk39u syl121anc istendod
      simp13 simpl1 ) MUQURQKURUSZJFURZPFURZUTZJEVAZPEVAVBZDBURDQNVCVDUSZUTZEGF
      UOUPIKMNUQQUCUGUHUIUNXFXGXHXKXLVEXMGFVFZUOVGZGVAZFURZUOFVMFFGVHJPVBZHVGZR
      VIZVJURZHFVMXNXMYAHFXRXSRHVKRUAVGZVLCVNWEYBEVAZXJWEYCXSEVAWEUTDAVGVASVBVO
      UAFVMZAFVPVJULYDAFVQVRVSVTHFXTGVJUMWAWFXMXQUOFXMXOFURZUSZXFXKXGXHYEXLXQXF
      XGXHXKXLYEWBXIXKXLYEWCZXFXGXHXKXLYEWDXFXGXHXKXLYEWGXMYEWHZXIXKXLYEWIZABCD
      EFGHJXOKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMWJWKWLUOFFGWOWMXMYEUPVGZFURZUT
      XIXKYEYKXLXOYJWNGVAXPYJGVAWNVBXIXKXLYEYKVEXIXKXLYEYKWPXMYEYKWQXMYEYKWRXIX
      KXLYEYKXDABCDEFGHJXOKYJLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMWSWTYFXIXKYEXLX
      PEVAXOEVANVCXIXKXLYEXEYGYHYIABCDEFGHJXOKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
      UMXAXBXC $.
  $}

  ${
    cdlemk6.b $e |- B = ( Base ` K ) $.
    cdlemk6.j $e |- .\/ = ( join ` K ) $.
    cdlemk6.m $e |- ./\ = ( meet ` K ) $.
    cdlemk6.o $e |- ._|_ = ( oc ` K ) $.
    cdlemk6.a $e |- A = ( Atoms ` K ) $.
    cdlemk6.h $e |- H = ( LHyp ` K ) $.
    cdlemk6.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk6.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemk6.p $e |- P = ( ._|_ ` W ) $.
    cdlemk6.z $e |- Z = ( ( P .\/ ( R ` b ) )
       ./\ ( ( N ` P ) .\/ ( R ` ( b o. `' F ) ) ) ) $.
    cdlemk6.y $e |- Y = ( ( P .\/ ( R ` g ) )
       ./\ ( Z .\/ ( R ` ( g o. `' b ) ) ) ) $.
    cdlemk6.x $e |- X = ( iota_ z e. T A. b e. T ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` F ) /\ ( R ` b ) =/= ( R ` g ) )
      -> ( z ` P ) = Y ) ) $.
    cdlemk6.u $e |- U = ( g e. T |-> if ( F = N , g , X ) ) $.
    $d b g z ./\ $.  $d b g z .\/ $.  $d b g z A $.  $d b g z B $.
    $d b g z F $.  $d b g z H $.  $d b g z K $.  $d b g z N $.  $d b g z P $.
    $d b g z R $.  $d b g z T $.  $d b g z W $.  $d z Y $.  $d g Z $.
    $( Use a fixed element to eliminate ` P ` in ~ cdlemk19u .  (Contributed by
       NM, 1-Aug-2013.) $)
    cdlemk19w $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ N e. T )
       /\ ( R ` F ) = ( R ` N ) ) -> ( U ` F ) = N ) $=
      ( chlt wcel wa cfv wceq w3a cple wbr wn 3simpb simp2 eqid lhpocnel eleq1i
      3ad2ant1 breq1i notbii anbi12i sylibr cdlemk19u syl3anc ) LUNUOPJUOUPZIFU
      ONFUOUPZIEUQNEUQURZUSZVOVQUPVPDBUOZDPLUTUQZVAZVBZUPZIGUQNURVOVPVQVCVOVPVQ
      VDVRPOUQZBUOZWDPVTVAZVBZUPZWCVOVPWHVQBJLVTOPVTVEZUDUEUFVFVHVSWEWBWGDWDBUI
      VGWAWFDWDPVTUIVIVJVKVLABCDEFGHIJKLVTMNPQRSTUAWIUBUCUEUFUGUHUJUKULUMVMVN
      $.

    cdlemk6.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Use a fixed element to eliminate ` P ` in ~ cdlemk56 .  (Contributed by
       NM, 1-Aug-2013.) $)
    cdlemk56w $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ N e. T )
       /\ ( R ` F ) = ( R ` N ) ) -> ( U e. E /\ ( U ` F ) = N ) ) $=
      ( chlt wcel wa cfv wceq w3a cple wn simp1 simp2l simp2r simp3 eqid fveq1i
      wbr coc eqtri lhpocnel2 3ad2ant1 cdlemk56 syl311anc cdlemk19w jca ) MUPUQ
      QKUQURZJFUQZOFUQZURZJEUSOEUSUTZVAZGIUQZJGUSOUTWDVSVTWAWCDBUQDQMVBUSZVJVCU
      RZWEVSWBWCVDVSVTWAWCVEVSVTWAWCVFVSWBWCVGVSWBWGWCBDKMWFQWFVHZUFUGDQPUSQMVK
      USZUSUJQPWIUEVIVLVMVNABCDEFGHIJKLMWFNOQRSTUAUBWHUCUDUFUGUHUIUKULUMUNUOVOV
      PABCDEFGHJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVQVR $.
  $}

  ${
    $d u E $.  $d b f u z F $.  $d b f z H $.  $d b f u z K $.  $d b f u z N $.
    $d b f u z R $.  $d b f u z T $.  $d b f u z W $.
    cdlemk7.h $e |- H = ( LHyp ` K ) $.
    cdlemk7.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemk7.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemk7.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Lemma K of [Crawley] p. 118.  Final result, lines 11 and 12 on p. 120:
       given two translations f and k with the same trace, there exists a
       trace-preserving endomorphism tau whose value at f is k.  We use ` F ` ,
       ` N ` , and ` u ` to represent f, k, and tau.  (Contributed by NM,
       1-Aug-2013.) $)
    cdlemk $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ N e. T )
       /\ ( R ` F ) = ( R ` N ) ) -> E. u e. E ( u ` F ) = N ) $=
      ( vf wcel cfv wceq cv co eqid vb vz chlt wa w3a cid cbs cres wne coc ccnv
      cjn ccom cmee wi wral crio cif cmpt wrex catm cdlemk56w eqeq1d rspcev syl
      fveq1 ) GUCOIFOUDECOHCOUDEBPZHBPQUENCEHQNRZUARZUFGUGPZUHUIVIBPZVGUIVKVHBP
      ZUIUEIGUJPZPZUBRPVNVLGULPZSVNVKVOSVNHPVIEUKUMBPVOSGUNPZSZVHVIUKUMBPVOSVPS
      ZQUOUACUPUBCUQZURUSZDOEVTPZHQZUDEARZPZHQZADUTUBGVAPZVJVNBCVTNDEFVOGVPHVMI
      VSVRVQUAVJTVOTVPTVMTWFTJKLVNTVQTVRTVSTVTTMVBWEWBAVTDWCVTQWDWAHEWCVTVFVCVD
      VE $.
  $}

  ${
    $d u E $.  $d u F $.  $d h H $.  $d h u K $.  $d u N $.  $d u R $.
    $d h u T $.  $d h u W $.
    tendoex.l $e |- .<_ = ( le ` K ) $.
    tendoex.h $e |- H = ( LHyp ` K ) $.
    tendoex.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendoex.r $e |- R = ( ( trL ` K ) ` W ) $.
    tendoex.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Generalization of Lemma K of [Crawley] p. 118, ~ cdlemk .  TODO: can
       this be used to shorten uses of ~ cdlemk ?  (Contributed by NM,
       15-Oct-2013.) $)
    tendoex $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ N e. T )
       /\ ( R ` N ) .<_ ( R ` F ) ) -> E. u e. E ( u ` F ) = N ) $=
      ( wcel wa cfv wceq syl2anc vh chlt wbr wrex cp0 w3a catm cops cbs simpl1l
      cv wo hlop syl simpl1 simpl2r eqid trlcl simpr simpl3 leat syl31anc simp3
      breq2 syl5ibcom imp ople0 mpbid olcd simp1 simp2l trlator0 mpjaodan 3expa
      wb cdlemk sylan2b cid cres cmpt tendo0cl ad2antrr simplrl tendo02 trlid0b
      eqcom adantrl biimpar eqtr4d fveq1 eqeq1d rspcev jaodan syldan 3impa ) GU
      BPZJFPZQZECPZICPZQZIBRZEBRZHUCZEAUKZRZISZADUDZWRXAQZXDXBXCSZXBGUERZSZULZX
      HWRXAXDXMWRXAXDUFZXCGUGRZPZXMXCXKSZXNXPQZGUHPZXBGUIRZPZXPXDXMXRWPXSWPWQXA
      XDXPUJGUMZUNXRWRWTYAWRXAXDXPUOWSWTWRXDXPUPXTBCIFGJXTUQZLMNURZTXNXPUSWRXAX
      DXPUTXOXTXCGHXBXKYCKXKUQZXOUQZVAVBXNXQQZXLXJYGXBXKHUCZXLXNXQYHXNXDXQYHWRX
      AXDVCXCXKXBHVDVEVFYGXSYAYHXLVOYGWPXSWPWQXAXDXQUJYBUNYGWRWTYAWRXAXDXQUOWSW
      TWRXDXQUPYDTXTGHXBXKYCKYEVGTVHVIXNWRWSXPXQULWRXAXDVJWRWSWTXDVKXOBCEFGJXKY
      EYFLMNVLTVMVNXIXJXHXLXJXIXCXBSZXHXBXCWFWRXAYIXHABCDEFGIJLMNOVPVNVQXIXLQZU
      ACVRXTVSZVTZDPZEYLRZISZXHWRYMXAXLXTCUADFGYLJYCLMOYLUQZWAWBYJYNYKIYJWSYNYK
      SWRWSWTXLWCXTCUAEGYLYPYCWDUNXIIYKSZXLWRWTYQXLVOWSXTBCIFGJXKYCYELMNWEWGWHW
      IXGYOAYLDXEYLSXFYNIEXEYLWJWKWLTWMWNWO $.
  $}

  ${
    cdleml1.b $e |- B = ( Base ` K ) $.
    cdleml1.h $e |- H = ( LHyp ` K ) $.
    cdleml1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdleml1.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdleml1.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 1-Aug-2013.)  (New usage is discouraged.) $)
    cdleml1N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ V e. E /\ f e. T )
      /\ ( f =/= ( _I |` B )
            /\ ( U ` f ) =/= ( _I |` B ) /\ ( V ` f ) =/= ( _I |` B ) ) )
        -> ( R ` ( U ` f ) ) = ( R ` ( V ` f ) ) ) $=
      ( chlt wcel w3a cfv syl3anc wa cv cid cres wne cple wbr wceq simp1 simp21
      simp23 eqid tendotp cal catm wb simp1l syl tendocl simp32 trlnidat simp31
      hlatl atcmp mpbid simp22 simp33 eqtr4d ) HPQZJGQZUAZDFQZIFQZEUBZCQZRZVNUC
      AUDZUEZVNDSZVQUEZVNISZVQUEZRZRZVSBSZVNBSZWABSZWDWEWFHUFSZUGZWEWFUHZWDVKVL
      VOWIVKVPWCUIZVKVLVMVOWCUJZVKVLVMVOWCUKZBDCFVNGHWHPJWHULZLMNOUMTWDHUNQZWEH
      UOSZQZWFWPQZWIWJUPWDVIWOVIVJVPWCUQHVCURZWDVKVSCQZVTWQWKWDVKVLVOWTWKWLWMDC
      FVNGHPJLMOUSTVKVPVRVTWBUTWPABCVSGHJKWPULZLMNVATWDVKVOVRWRWKWMVKVPVRVTWBVB
      WPABCVNGHJKXALMNVATZWPWEWFHWHWNXAVDTVEWDWGWFWHUGZWGWFUHZWDVKVMVOXCWKVKVLV
      MVOWCVFZWMBICFVNGHWHPJWNLMNOUMTWDWOWGWPQZWRXCXDUPWSWDVKWACQZWBXFWKWDVKVMV
      OXGWKXEWMICFVNGHPJLMOUSTVKVPVRVTWBVGWPABCWAGHJKXALMNVATXBWPWGWFHWHWNXAVDT
      VEVH $.

    $d s E $.  $d s K $.  $d s R $.  $d s T $.  $d s U $.  $d s V $.  $d s W $.
    $d s f $.
    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 1-Aug-2013.)  (New usage is discouraged.) $)
    cdleml2N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ V e. E /\ f e. T )
      /\ ( f =/= ( _I |` B )
            /\ ( U ` f ) =/= ( _I |` B ) /\ ( V ` f ) =/= ( _I |` B ) ) )
        -> E. s e. E ( s ` ( U ` f ) ) = ( V ` f ) ) $=
      ( chlt wcel w3a cfv wa cid cres wne wceq wrex simp1 simp21 simp23 tendocl
      cv syl3anc simp22 cdleml1N cdlemk syl121anc ) HQRJGRUAZDFRZIFRZEUKZCRZSZU
      TUBAUCZUDUTDTZVCUDUTITZVCUDSZSZUQVDCRZVECRZVDBTVEBTUEVDKUKTVEUEKFUFUQVBVF
      UGZVGUQURVAVHVJUQURUSVAVFUHUQURUSVAVFUIZDCFUTGHQJMNPUJULVGUQUSVAVIVJUQURU
      SVAVFUMVKICFUTGHQJMNPUJULABCDEFGHIJLMNOPUNKBCFVDGHVEJMNOPUOUP $.

    $d g s B $.  $d f E $.  $d f g s H $.  $d f g K $.  $d f s .0. $.
    $d f g T $.  $d f U $.  $d f V $.  $d f g W $.
    cdleml3.o $e |- .0. = ( g e. T |-> ( _I |` B ) ) $.
    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 1-Aug-2013.)  (New usage is discouraged.) $)
    cdleml3N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ V e. E /\ f e. T )
      /\ ( f =/= ( _I |` B ) /\ U =/= .0. /\ V =/= .0. ) )
        -> E. s e. E ( s o. U ) = V ) $=
      ( wceq chlt wcel wa cv w3a cid cres wne cfv wrex ccom simp1 simp31 simp32
      simp2 wb simp21 simp23 syl112anc necon3bid mpbird simp33 simp22 syl113anc
      tendoid0 cdleml2N simpl1 simpr simpl21 tendocoval syl121anc eqeq1d simp11
      simpl23 simp121 tendococl syl3anc simp122 simp3 simp123 simp131 syl132anc
      tendocan 3expia sylbird reximdva mpd ) IUAUBKHUBUCZDGUBZJGUBZEUDZCUBZUEZW
      KUFAUGZUHZDLUHZJLUHZUEZUEZWKDUIZMUDZUIZWKJUIZTZMGUJZXADUKZJTZMGUJWSWHWMWO
      WTWNUHZXCWNUHZXEWHWMWRULZWHWMWRUOWHWMWOWPWQUMZWSXHWPWHWMWOWPWQUNWSWTWNDLW
      SWHWIWLWOWTWNTDLTUPXJWHWIWJWLWRUQWHWIWJWLWRURZXKACDFGWKHILKNOPRSVEUSUTVAW
      SXIWQWHWMWOWPWQVBWSXCWNJLWSWHWJWLWOXCWNTJLTUPXJWHWIWJWLWRVCXLXKACJFGWKHIL
      KNOPRSVEUSUTVAABCDEGHIJKMNOPQRVFVDWSXDXGMGWSXAGUBZUCZXDWKXFUIZXCTZXGXNXOX
      BXCXNWHXMWIWLXOXBTWHWMWRXMVGWSXMVHWIWJWLWHWRXMVIWIWJWLWHWRXMVNCXAGWKHIDKU
      AOPRVJVKVLWSXMXPXGWSXMXPUEZWHXFGUBZWJXPWLWOXGWHWMWRXMXPVMZXQWHXMWIXRXSWSX
      MXPUOWIWJWLWHWRXMXPVOXADGHIKORVPVQWIWJWLWHWRXMXPVRWSXMXPVSWIWJWLWHWRXMXPV
      TWOWPWQWHWMXMXPWAACXFGWKHIJKNOPRWCWBWDWEWFWG $.

    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 1-Aug-2013.)  (New usage is discouraged.) $)
    cdleml4N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ V e. E )
      /\ ( U =/= .0. /\ V =/= .0. ) )
        -> E. s e. E ( s o. U ) = V ) $=
      ( vf wcel chlt wa wne w3a cv cid cres wrex ccom cdlemftr0 3ad2ant1 simp11
      simp12l simp12r simp2 simp3 simp13l simp13r cdleml3N syl133anc rexlimdv3a
      wceq mpd ) HUATJGTUBZDFTZIFTZUBZDKUCZIKUCZUBZUDZSUEZUFAUGUCZSCUHZLUEDUIIV
      BLFUHZVDVGVNVJACSGHJMNOUJUKVKVMVOSCVKVLCTZVMUDVDVEVFVPVMVHVIVOVDVGVJVPVMU
      LVEVFVDVJVPVMUMVEVFVDVJVPVMUNVKVPVMUOVKVPVMUPVHVIVDVGVPVMUQVHVIVDVGVPVMUR
      ABCDSEFGHIJKLMNOPQRUSUTVAVC $.

    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 1-Aug-2013.)  (New usage is discouraged.) $)
    cdleml5N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( U e. E /\ V e. E )
       /\ U =/= .0. ) -> E. s e. E ( s o. U ) = V ) $=
      ( wcel wceq chlt wa wne w3a cv ccom simpl1 tendo0cl syl simpl2l tendo0mul
      syl2anc simpr eqtr4d coeq1 eqeq1d rspcev simpl2 simpl3 cdleml4N syl112anc
      wrex pm2.61dane ) HUASJGSUBZDFSZIFSZUBZDKUCZUDZLUEZDUFZITZLFVBZIKVIIKTZUB
      ZKFSZKDUFZITZVMVOVDVPVDVGVHVNUGZACEFGHKJMNOQRUHUIVOVQKIVOVDVEVQKTVSVEVFVD
      VHVNUJACDEFGHKJMNOQRUKULVIVNUMUNVLVRLKFVJKTVKVQIVJKDUOUPUQULVIIKUCZUBVDVG
      VHVTVMVDVGVHVTUGVDVGVHVTURVDVGVHVTUSVIVTUMABCDEFGHIJKLMNOPQRUTVAVC $.
  $}

  ${
    $d g b z ./\ $.  $d b .\/ g z $.  $d B b f g z $.  $d h b g z $.
    $d s b g z $.  $d H b g z $.  $d K b g z $.  $d Q b g z $.  $d R b g z $.
    $d T b f g z $.  $d W b g z $.  $d z Y $.  $d g Z $.
    cdleml6.b $e |- B = ( Base ` K ) $.
    cdleml6.j $e |- .\/ = ( join ` K ) $.
    cdleml6.m $e |- ./\ = ( meet ` K ) $.
    cdleml6.h $e |- H = ( LHyp ` K ) $.
    cdleml6.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdleml6.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdleml6.p $e |- Q = ( ( oc ` K ) ` W ) $.
    cdleml6.z $e |- Z = ( ( Q .\/ ( R ` b ) )
       ./\ ( ( h ` Q ) .\/ ( R ` ( b o. `' ( s ` h ) ) ) ) ) $.
    cdleml6.y $e |- Y = ( ( Q .\/ ( R ` g ) )
       ./\ ( Z .\/ ( R ` ( g o. `' b ) ) ) ) $.
    cdleml6.x $e |- X = ( iota_ z e. T A. b e. T ( ( b =/= ( _I |` B )
            /\ ( R ` b ) =/= ( R ` ( s ` h ) ) /\ ( R ` b ) =/= ( R ` g ) )
      -> ( z ` Q ) = Y ) ) $.
    cdleml6.u $e |- U = ( g e. T |-> if ( ( s ` h ) = h , g , X ) ) $.
    cdleml6.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    cdleml6.o $e |- .0. = ( f e. T |-> ( _I |` B ) ) $.
    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 11-Aug-2013.) $)
    cdleml6 $p |- ( ( ( K e. HL /\ W e. H )
             /\ h e. T /\ ( s e. E /\ s =/= .0. ) )
        -> ( U e. E /\ ( U ` ( s ` h ) ) = h ) ) $=
      ( chlt wcel wa cv wne w3a wceq simp1 simp3l simp2 tendocl syl3anc tendotr
      cfv 3com23 catm coc eqid cdlemk56w syl121anc ) MUOUPOKUPUQZIURZEUPZTURZJU
      PZVRRUSZUQZUTZVOVPVRVHZEUPZVQWCDVHVPDVHVAZFJUPWCFVHVPVAUQVOVQWAVBZWBVOVSV
      QWDWFVOVQVSVTVCVOVQWAVDZVREJVPKMUOOUEUFUMVEVFWGVOWAVQWEBDEVRGJVPKMROUBUEU
      FUGUMUNVGVIAMVJVHZBCDEFHJWCKLMNVPMVKVHZOPQSUAUBUCUDWIVLWHVLUEUFUGUHUIUJUK
      ULUMVMVN $.

    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 11-Aug-2013.) $)
    cdleml7 $p |- ( ( ( K e. HL /\ W e. H )
             /\ h e. T /\ ( s e. E /\ s =/= .0. ) )
        -> ( ( U o. s ) ` h ) = ( ( _I |` T ) ` h ) ) $=
      ( chlt wcel wa wne w3a cfv ccom cid cres wceq cdleml6 simprd simp1 simpld
      cv simp3l simp2 tendocoval syl121anc fvresi 3ad2ant2 3eqtr4d ) MUOUPOKUPU
      QZIVIZEUPZTVIZJUPZVTRURZUQZUSZVRVTUTFUTZVRVRFVTVAUTZVRVBEVCUTZWDFJUPZWEVR
      VDZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVEZVFWDVQWHWAVSWFWEVDV
      QVSWCVGWDWHWIWJVHVQVSWAWBVJVQVSWCVKEFJVRKMVTOUOUEUFUMVLVMVSVQWGVRVDWCEVRV
      NVOVP $.

    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 11-Aug-2013.) $)
    cdleml8 $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( h e. T /\ h =/= ( _I |` B ) ) /\ ( s e. E /\ s =/= .0. ) )
        -> ( U o. s ) = ( _I |` T ) ) $=
      ( chlt wcel wa cv cid cres wne w3a ccom cfv simp1 cdleml6 3adant2r simpld
      wceq simp3l tendococl syl3anc tendoidcl 3ad2ant1 simp2 tendocan syl131anc
      cdleml7 ) MUOUPOKUPUQZIURZEUPZVTUSBUTVAZUQZTURZJUPZWDRVAZUQZVBZVSFWDVCZJU
      PZUSEUTZJUPZVTWIVDVTWKVDVIZWCWIWKVIVSWCWGVEZWHVSFJUPZWEWJWNWHWOVTWDVDFVDV
      TVIZVSWAWGWOWPUQWBABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVFVGVHV
      SWCWEWFVJFWDJKMOUEUMVKVLVSWCWLWGEJKMOUEUFUMVMVNVSWAWGWMWBABCDEFGHIJKLMNOP
      QRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVRVGVSWCWGVOBEWIJVTKMWKOUBUEUFUMVPVQ $.

    $( Part of proof of Lemma L of [Crawley] p. 120.  TODO: fix comment.
       (Contributed by NM, 11-Aug-2013.) $)
    cdleml9 $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( h e. T /\ h =/= ( _I |` B ) ) /\ ( s e. E /\ s =/= .0. ) )
        -> U =/= .0. ) $=
      ( chlt wcel wa cv cid cres wne w3a tendo1ne0 3ad2ant1 wceq cdleml8 adantr
      ccom coeq1 simp1 simp3l tendo0mul syl2anc sylan9eqr eqtr3d ex necon3d mpd
      ) MUOUPOKUPUQZIURZEUPVTUSBUTVAUQZTURZJUPZWBRVAZUQZVBZUSEUTZRVAZFRVAVSWAWH
      WEBEGJKMROUBUEUFUMUNVCVDWFFRWGRWFFRVEZWGRVEWFWIUQFWBVHZWGRWFWJWGVEWIABCDE
      FGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNVFVGWIWFWJRWBVHZRFRWBVIWFVSWCW
      KRVEVSWAWEVJVSWAWCWDVKBEWBGJKMROUBUEUFUMUNVLVMVNVOVPVQVR $.
  $}

  ${
    $d s .<_ $.  $d s E $.  $d g s F $.  $d g h s H $.  $d g h s K $.
    $d g s F $.  $d s R $.  $d g h s T $.  $d g h s W $.
    dva1dim.l $e |- .<_ = ( le ` K ) $.
    dva1dim.h $e |- H = ( LHyp ` K ) $.
    dva1dim.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dva1dim.r $e |- R = ( ( trL ` K ) ` W ) $.
    dva1dim.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Two expressions for the 1-dimensional subspaces of partial vector space
       A. Remark in [Crawley] p. 120 line 21, but using a non-identity
       translation (nonzero vector) ` F ` whose trace is ` P ` rather than
       ` P ` itself; ` F ` exists by ~ cdlemf . ` E ` is the division ring base
       by ~ erngdv , and ` s `` F ` is the scalar product by ~ dvavsca . ` F `
       must be a non-identity translation for the expression to be a
       1-dimensional subspace, although the theorem doesn't require it.
       (Contributed by NM, 14-Oct-2013.) $)
    dva1dim $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> { g | E. s e. E g = ( s ` F ) }
           = { g e. T | ( R ` g ) .<_ ( R ` F ) } ) $=
      ( chlt wcel wa cv cfv wceq wrex cab wbr crab w3a tendocl tendotp anass1rs
      3expb eleq1 fveq2 breq1d syl5ibrcom rexlimdva simpll simplr simprl simprr
      jca anbi12d tendoex syl121anc eqcom rexbii sylib ex impbid abbidv syl6eqr
      df-rab ) GPQIFQRZEBQZRZCSZEJSZTZUAZJDUBZCUCVOBQZVOATZEATZHUDZRZCUCWCCBUEV
      NVSWDCVNVSWDVNVRWDJDVNVPDQZRWDVRVQBQZVQATZWBHUDZRZVLWEVMWIVLWEVMWIVLWEVMU
      FWFWHVPBDEFGPILMOUGAVPBDEFGHPIKLMNOUHUTUJUIVRVTWFWCWHVOVQBUKVRWAWGWBHVOVQ
      AULUMVAUNUOVNWDVSVNWDRZVQVOUAZJDUBZVSWJVLVMVTWCWLVLVMWDUPVLVMWDUQVNVTWCUR
      VNVTWCUSJABDEFGHVOIKLMNOVBVCWKVRJDVQVOVDVEVFVGVHVIWCCBVKVJ $.
  $}

  ${
    $d f s .<_ $.  $d f s E $.  $d f g s F $.  $d f g s H $.  $d f g s K $.
    $d f g s F $.  $d s .0. $.  $d f s R $.  $d f g h s T $.  $d f g s W $.
    dvhb1dim.l $e |- .<_ = ( le ` K ) $.
    dvhb1dim.h $e |- H = ( LHyp ` K ) $.
    dvhb1dim.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhb1dim.r $e |- R = ( ( trL ` K ) ` W ) $.
    dvhb1dim.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhb1dim.o $e |- .0. = ( h e. T |-> ( _I |` B ) ) $.
    $( Two expressions for the 1-dimensional subspaces of vector space H, in
       the isomorphism B case where the 2nd vector component is zero.
       (Contributed by NM, 23-Feb-2014.)  (New usage is discouraged.) $)
    dvhb1dimN $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> { g e. ( T X. E ) | E. s e. E g = <. ( s ` F ) , .0. >. }
           = { g e. ( T X. E ) | ( ( R ` ( 1st ` g ) ) .<_ ( R ` F )
                 /\ ( 2nd ` g ) = .0. ) } ) $=
      ( wcel vf chlt wa cfv cop wceq wrex c1st wbr c2nd cxp eqop adantl rexbidv
      cv wb r19.41v crab cab fvex eqeq1 elab dva1dim adantr syl5bbr xp1st fveq2
      eleq2d breq1d elrab3 syl bitrd anbi1d syl5bb rabbidva ) IUBTKHTUCGCTUCZDU
      OZGMUOUDZLUEUFZMFUGZVQUHUDZBUDZGBUDZJUIZVQUJUDLUFZUCZDCFUKZVPVQWGTZUCZVTW
      AVRUFZWEUCZMFUGZWFWIVSWKMFWHVSWKUPVPVQVRLCFULUMUNWLWJMFUGZWEUCWIWFWJWEMFU
      QWIWMWDWEWIWMWAUAUOZBUDZWCJUIZUACURZTZWDWMWAWNVRUFZMFUGZUAUSZTWIWRWTWMUAW
      AVQUHUTWNWAUFZWSWJMFWNWAVRVAUNVBWIXAWQWAVPXAWQUFWHBCUAFGHIJKMNOPQRVCVDVHV
      EWIWACTZWRWDUPWHXCVPVQCFVFUMWPWDUAWACXBWOWBWCJWNWABVGVIVJVKVLVMVNVLVO $.
  $}

  ${
    $d u D $.  $d u H $.  $d u K $.  $d u T $.  $d u W $.
    erng1.h $e |- H = ( LHyp ` K ) $.
    erng1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    erng1.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    erng1.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    erng1.r $e |- ( ( K e. HL /\ W e. H ) -> D e. Ring ) $.
    $( Value of the endomorphism division ring unit.  (Contributed by NM,
       12-Oct-2013.) $)
    erng1lem $p |- ( ( K e. HL /\ W e. H ) -> ( 1r ` D ) = ( _I |` T ) ) $=
      ( vu chlt wcel wa cfv co wceq eqid ccom cid cres cbs cmulr wral tendoidcl
      cv erngbase eleqtrrd eleq2d simpl adantr simpr erngmul syl12anc tendo1mul
      cur eqtrd tendo1mulr jca ex sylbid ralrimiv crg wb isrngid syl mpbi2and )
      EMNFDNOZUABUBZAUCPZNZVJLUGZAUDPZQZVMRZVMVJVNQZVMRZOZLVKUEZAUQPZVJRZVIVJCV
      KBCDEFGHIUFZVKABCDEMFGHIJVKSZUHZUIVIVSLVKVIVMVKNVMCNZVSVIVKCVMWEUJVIWFVSV
      IWFOZVPVRWGVOVJVMTZVMWGVIVJCNZWFVOWHRVIWFUKZVIWIWFWCULZVIWFUMZABVNVJCDEVM
      FMGHIJVNSZUNUOBVMCDEFGHIUPURWGVQVMVJTZVMWGVIWFWIVQWNRWJWLWKABVNVMCDEVJFMG
      HIJWMUNUOBVMCDEFGHIUSURUTVAVBVCVIAVDNVLVTOWBVEKLVKAVNWAVJWDWMWASVFVGVH $.
  $}

  ${
    $d f B $.  $d s t u D $.  $d a b s t u E $.  $d t I $.  $d a b f s t u K $.
    $d f s t u H $.  $d s t u .0. $.  $d a b f s T $.  $d a b f s t u W $.
    $d s t u P $.
    ernggrp.h $e |- H = ( LHyp ` K ) $.
    ernggrp.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    ${
      erngdv.b $e |- B = ( Base ` K ) $.
      erngdv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      erngdv.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      erngdv.p $e |- P = ( a e. E , b e. E |-> ( f e. T
          |-> ( ( a ` f ) o. ( b ` f ) ) ) ) $.
      erngdv.o $e |- .0. = ( f e. T |-> ( _I |` B ) ) $.
      erngdv.i $e |- I = ( a e. E |-> ( f e. T |-> `' ( a ` f ) ) ) $.
      $( Lemma for ~ erngrng .  (Contributed by NM, 4-Aug-2013.) $)
      erngdvlem1 $p |- ( ( K e. HL /\ W e. H ) -> D e. Grp ) $=
        ( vs vt vu chlt wcel wa cv cfv cbs eqid erngbase eqcomd ccom cmpt cmpt2
        cplusg erngfplus syl6reqr tendoplcl tendo0cl tendo0pl tendoicl tendoipl
        tendoplass isgrpd ) IUEUFJGUFUGZUBUCUDFCBUBUHZHUIKVGBUJUIZFVIBDFGIUEJNQ
        ROVIUKULUMVGBUQUIZLMFFEDEUHZLUHUIVKMUHUIUNUOUPCMBVJDEFGIUEJLNQROVJUKURS
        USMCDVHEFGIUCUHZJLNQRSUTMCVHDVLEFGIUDUHJLNQRSVEADEFGIKJPNQRTVAMACVHDEFG
        IKJLPNQRTSVBVHDEFGHIJLNQRUAVCMACVHDEFGHIKJLNQRUAPSTVDVF $.

      $( Lemma for ~ erngrng .  (Contributed by NM, 6-Aug-2013.)
         (New usage is discouraged.) $)
      erngdvlem2N $p |- ( ( K e. HL /\ W e. H ) -> D e. Abel ) $=
        ( vs vt chlt wcel wa cbs eqid erngbase eqcomd cplusg cv ccom cmpt cmpt2
        cfv erngfplus syl6reqr erngdvlem1 tendoplcom isabld ) IUDUEJGUEUFZUBUCF
        CBVBBUGUPZFVCBDFGIUDJNQROVCUHUIUJVBBUKUPZLMFFEDEULZLULUPVEMULUPUMUNUOCM
        BVDDEFGIUDJLNQROVDUHUQSURABCDEFGHIJKLMNOPQRSTUAUSMCDUBULEFGIUCULJLNQRSU
        TVA $.

      erngrnglem.m $e |- .+ = ( a e. E , b e. E |-> ( a o. b ) ) $.
      $( Lemma for ~ erngrng .  (Contributed by NM, 6-Aug-2013.) $)
      erngdvlem3 $p |- ( ( K e. HL /\ W e. H ) -> D e. Ring ) $=
        ( vs vt vu chlt wcel wa cid cres cbs cfv eqid erngbase eqcomd cplusg cv
        ccom cmpt cmpt2 erngfplus syl6reqr cmulr erngfmul erngdvlem1 wceq oveqd
        co 3ad2ant1 erngmul 3impb eqtrd tendococl eqeltrd coass simpl 3adant3r3
        adantr simpr3 syl12anc proplem3 3adantr3 coeq1d 3eqtrd simpr1 3adant3r1
        w3a 3adantr1 coeq2d 3eqtr4a tendodi1 tendoplcl 3adantr2 oveq12d 3eqtr4d
        tendodi2 tendoidcl simpr tendo1mul tendo1mulr isrngd ) JUGUHKHUHUIZUDUE
        UFGCBDUJEUKZXCBULUMZGXEBEGHJUGKORSPXEUNUOUPXCBUQUMZMNGGFEFURZMURZUMXGNU
        RZUMUSUTVACNBXFEFGHJUGKMORSPXFUNVBTVCXCBVDUMZMNGGXHXIUSVADNBEXJGHJUGKMO
        RSPXJUNZVEUCVCZABCEFGHIJKLMNOPQRSTUAUBVFXCUDURZGUHZUEURZGUHZWHZXMXODVIZ
        XMXOUSZGXQXRXMXOXJVIZXSXCXNXRXTVGXPXCDXJXMXOXLVHVJXCXNXPXTXSVGZBEXJXMGH
        JXOKUGORSPXKVKZVLVMXMXOGHJKOSVNVOZXCXNXPUFURZGUHZWHZUIZXSYDUSZXMXOYDUSZ
        USZXRYDDVIZXMXOYDDVIZDVIZXMXOYDVPYGYKXRYDXJVIZXRYDUSZYHXCYKYNVGYFXCDXJX
        RYDXLVHVSYGXCXRGUHZYEYNYOVGXCYFVQZXCXNXPYPYEYCVRXCXNXPYEVTZBEXJXRGHJYDK
        UGORSPXKVKWAYGXRXSYDYGXRXTXSXCYFUDUEDXJXLWBXCXNXPYAYEYBWCVMZWDWEYGYMXMY
        LXJVIZXMYLUSZYJXCYMYTVGYFXCDXJXMYLXLVHVSYGXCXNYLGUHYTUUAVGYQXCXNXPYEWFZ
        YGYLYIGYGYLXOYDXJVIZYIXCYFUEUFDXJXLWBXCXPYEUUCYIVGXNBEXJXOGHJYDKUGORSPX
        KVKWIVMZXCXPYEYIGUHXNXOYDGHJKOSVNWGVOBEXJXMGHJYLKUGORSPXKVKWAYGYLYIXMUU
        DWJWEWKYGXMXOYDCVIZUSZXSXMYDUSZCVIXMUUEDVIZXRXMYDDVIZCVINCXMEXOFGHJYDKM
        ORSTWLYGUUHXMUUEXJVIZUUFXCUUHUUJVGYFXCDXJXMUUEXLVHVSYGXCXNUUEGUHZUUJUUF
        VGYQUUBXCXPYEUUKXNNCEXOFGHJYDKMORSTWMWGBEXJXMGHJUUEKUGORSPXKVKWAVMYGXRX
        SUUIUUGCYSYGUUIXMYDXJVIZUUGXCYFUDUFDXJXLWBXCXNYEUULUUGVGXPBEXJXMGHJYDKU
        GORSPXKVKWNVMZWOWPYGXMXOCVIZYDUSZUUGYICVIUUNYDDVIZUUIYLCVINCXMEXOFGHJYD
        KMORSTWQYGUUPUUNYDXJVIZUUOXCUUPUUQVGYFXCDXJUUNYDXLVHVSYGXCUUNGUHZYEUUQU
        UOVGYQXCXNXPUURYENCEXMFGHJXOKMORSTWMVRYRBEXJUUNGHJYDKUGORSPXKVKWAVMYGUU
        IUUGYLYICUUMUUDWOWPEGHJKORSWRZXCXNUIZXDXMDVIZXDXMXJVIZXDXMUSZXMXCUVAUVB
        VGXNXCDXJXDXMXLVHVSUUTXCXDGUHZXNUVBUVCVGXCXNVQZXCUVDXNUUSVSZXCXNWSZBEXJ
        XDGHJXMKUGORSPXKVKWAEXMGHJKORSWTWEUUTXMXDDVIZXMXDXJVIZXMXDUSZXMXCUVHUVI
        VGXNXCDXJXMXDXLVHVSUUTXCXNUVDUVIUVJVGUVEUVGUVFBEXJXMGHJXDKUGORSPXKVKWAE
        XMGHJKORSXAWEXB $.

      edlemk6.j $e |- .\/ = ( join ` K ) $.
      edlemk6.m $e |- ./\ = ( meet ` K ) $.
      edlemk6.r $e |- R = ( ( trL ` K ) ` W ) $.
      edlemk6.p $e |- Q = ( ( oc ` K ) ` W ) $.
      edlemk6.z $e |- Z = ( ( Q .\/ ( R ` b ) )
         ./\ ( ( h ` Q ) .\/ ( R ` ( b o. `' ( s ` h ) ) ) ) ) $.
      edlemk6.y $e |- Y = ( ( Q .\/ ( R ` g ) )
         ./\ ( Z .\/ ( R ` ( g o. `' b ) ) ) ) $.
      edlemk6.x $e |- X = ( iota_ z e. T A. b e. T ( ( b =/= ( _I |` B )
              /\ ( R ` b ) =/= ( R ` ( s ` h ) ) /\ ( R ` b ) =/= ( R ` g ) )
        -> ( z ` Q ) = Y ) ) $.
      edlemk6.u $e |- U = ( g e. T |-> if ( ( s ` h ) = h , g , X ) ) $.
      $d b g z ./\ $.  $d b g z .\/ $.  $d b g z A $.  $d b g s t z B $.
      $d b g z F $.  $d b g z H $.  $d b g z K $.  $d s t .+ $.  $d b g z N $.
      $d t O $.  $d g z P $.  $d b g z Q $.  $d b g z R $.  $d b g t u z T $.
      $d t U $.  $d b g z W $.  $d z Y $.  $d g Z $.  $d g z f $.
      $d b g s t z h $.
      $( Lemma for ~ erngdv .  (Contributed by NM, 11-Aug-2013.) $)
      erngdvlem4 $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( h e. T /\ h =/= ( _I |` B ) ) ) -> D e. DivRing ) $=
        ( vt chlt wcel wa cid cres wne cbs cfv wceq eqid erngbase eqcomd adantr
        cv cmulr ccom cmpt2 erngfmul syl6reqr c0g cplusg tendo0cl eleqtrrd cmpt
        erngfplus oveqd tendo0pl mpdan eqtr3d cgrp erngdvlem1 isgrpid2 mpbi2and
        co wb syl cur erngdvlem3 erng1lem crg w3a simp1l simp2l simp3l syl12anc
        erngmul eqtrd tendoconid eqnetrd tendo1ne0 simpll simplrl simpr cdleml6
        3adant1r simpld syl3anc cdleml9 ad2antrr simprl cdleml8 3eqtrd isdrngd
        3expa ) QVEVFSNVFVGZLVRZHVFZYJVHBVIVJZVGZVGZUDVDMCEVHHVIZIUBYIMCVKVLZVM
        YMYIYPMYPCHMNQVESUGUJUKUHYPVNZVOZVPVQYIECVSVLZVMYMYIYSUEUFMMUEVRZUFVRZV
        TWAEUFCHYSMNQVESUEUGUJUKUHYSVNZWBUOWCZVQYIUBCWDVLZVMYMYIUUDUBYIUBYPVFZU
        BUBCWEVLZWRZUBVMZUUDUBVMZYIUBMYPBHJMNQUBSUIUGUJUKUMWFZYRWGYIUBUBDWRZUUG
        UBYIDUUFUBUBYIUUFUEUFMMJHJVRZYTVLUULUUAVLVTWHWADUFCUUFHJMNQVESUEUGUJUKU
        HUUFVNZWIULWCWJYIUBMVFUUKUBVMUUJUFBDUBHJMNQUBSUEUIUGUJUKUMULWKWLWMYICWN
        VFUUEUUHVGUUIWSBCDHJMNOQSUBUEUFUGUHUIUJUKULUMUNWOYPUUFCUUDUBYQUUMUUDVNW
        PWTWQVPVQYIYOCXAVLZVMYMYIUUNYOCHMNQSUGUJUKUHBCDEHJMNOQSUBUEUFUGUHUIUJUK
        ULUMUNUOXBZXCVPVQYICXDVFYMUUOVQYNUDVRZMVFZUUPUBVJZVGZVDVRZMVFZUUTUBVJZV
        GZXEZUUPUUTEWRZUUPUUTVTZUBUVDUVEUUPUUTYSWRZUVFUVDYIUVEUVGVMYIYMUUSUVCXF
        ZYIEYSUUPUUTUUCWJWTUVDYIUUQUVAUVGUVFVMUVHYNUUQUURUVCXGYNUUSUVAUVBXHCHYS
        UUPMNQUUTSVEUGUJUKUHUUBXJXIXKYIUUSUVCUVFUBVJYMBHUUPJMNQUBUUTSUIUGUJUKUM
        XLXSXMYIYOUBVJYMBHJMNQUBSUIUGUJUKUMXNVQYNUUSVGZYIYKUUSIMVFZYIYMUUSXOZYI
        YKYLUUSXPYNUUSXQYIYKUUSXEUVJYJUUPVLIVLYJVMABFGHIJKLMNPQRSTUAUBUCUDUFUIU
        PUQUGUJURUSUTVAVBVCUKUMXRXTYAZYIYMUUSIUBVJABFGHIJKLMNPQRSTUAUBUCUDUFUIU
        PUQUGUJURUSUTVAVBVCUKUMYBYHUVIIUUPEWRZIUUPYSWRZIUUPVTZYOYIUVMUVNVMYMUUS
        YIEYSIUUPUUCWJYCUVIYIUVJUUQUVNUVOVMUVKUVLYNUUQUURYDCHYSIMNQUUPSVEUGUJUK
        UHUUBXJXIYIYMUUSUVOYOVMABFGHIJKLMNPQRSTUAUBUCUDUFUIUPUQUGUJURUSUTVAVBVC
        UKUMYEYHYFYG $.
    $}

    $( An endomorphism ring is a ring.  Todo: fix comment.  (Contributed by NM,
       4-Aug-2013.) $)
    erngrng $p |- ( ( K e. HL /\ W e. H ) -> D e. Ring ) $=
      ( va vb vf cbs cfv ctendo cltrn cv ccom cmpt cmpt2 ccnv cid eqid cres
      erngdvlem3 ) CJKZAGHDCLKKZUDIDCMKKZINZGNZKZUFHNZKOPQZGHUDUDUGUIOQZUEIUDBG
      UDIUEUHRPPZCDIUESUCUAPZGHEFUCTUETUDTUJTUMTULTUKTUB $.

    $d f D $.  $d b g z H $.  $d g z K $.  $d g z W $.  $d a f g s z $.
    $( An endomorphism ring is a division ring.  Todo: fix comment.
       (Contributed by NM, 11-Aug-2013.) $)
    erngdv $p |- ( ( K e. HL /\ W e. H ) -> D e. DivRing ) $=
      ( vf vz va vb vg wcel cv cfv wne eqid ccom cmpt co ccnv chlt cid cbs cres
      vs wa cdr cltrn cdlemftr0 ctendo cmpt2 coc ctrl wceq w3a cjn cmee wi wral
      crio cif erngdvlem4 rexlimddv ) CUALDBLUFGMZUBCUCNZUDZOAUGLGDCUHNNZVEVGGB
      CDVEPZEVGPZUIHVEAIJDCUJNNZVJGVGVDIMZNZVDJMZNQRUKZIJVJVJVKVMQUKZDCULNNZDCU
      MNNZVGKVGVDUEMNZVDUNKMZVMVFOVMVQNZVRVQNOVTVSVQNZOUOVPHMNVPWACUPNZSVPVTWBS
      VPVDNVMVRTQVQNWBSCUQNZSZVSVMTQVQNWBSWCSZUNURJVGUSHVGUTZVARZGKGVJBIVJGVGVL
      TRRZWBCWCDWFWEGVGVFRZWDUEIJEFVHVIVJPVNPWIPWHPVOPWBPWCPVQPVPPWDPWEPWFPWGPV
      BVC $.
  $}

  ${
    $d f B $.  $d f H $.  $d f s t K $.  $d f s t T $.  $d f s t W $.
    erng0g.b $e |- B = ( Base ` K ) $.
    erng0g.h $e |- H = ( LHyp ` K ) $.
    erng0g.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    erng0g.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    erng0g.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    erng0g.z $e |- .0. = ( 0g ` D ) $.
    $( The division ring zero of an endomorphism ring.  (Contributed by NM,
       5-Nov-2013.)  (Revised by Mario Carneiro, 23-Jun-2014.) $)
    erng0g $p |- ( ( K e. HL /\ W e. H ) -> .0. = O ) $=
      ( vs vt wcel cfv eqid chlt wa cplusg co wceq cv ccom cmpt cmpt2 erngfplus
      ctendo oveqd tendo0cl tendo0pl mpdan eqtrd cgrp cbs wb crg erngrng rnggrp
      syl erngbase eleqtrrd grpid syl2anc mpbid ) FUARHERUBZGGBUCSZUDZGUEZIGUEZ
      VIVKGGPQHFUKSSZVNDCDUFZPUFSVOQUFSUGUHUIZUDZGVIVJVPGGQBVJCDVNEFUAHPKLVNTZM
      VJTZUJULVIGVNRVQGUEACDVNEFGHJKLVRNUMZQAVPGCDVNEFGHPJKLVRNVPTUNUOUPVIBUQRZ
      GBURSZRVLVMUSVIBUTRWABEFHKMVABVBVCVIGVNWBVTWBBCVNEFUAHKLVRMWBTZVDVEWBVJBG
      IWCVSOVFVGVH $.
  $}

  ${
    $d f H $.  $d f s t K $.  $d f s t T $.  $d f s t W $.
    erng1r.h $e |- H = ( LHyp ` K ) $.
    erng1r.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    erng1r.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    erng1r.r $e |- .1. = ( 1r ` D ) $.
    $( The division ring unit of an endomorphism ring.  (Contributed by NM,
       5-Nov-2013.)  (Revised by Mario Carneiro, 23-Jun-2014.) $)
    erng1r $p |- ( ( K e. HL /\ W e. H ) -> .1. = ( _I |` T ) ) $=
      ( vf chlt wcel wa cid cres cbs cfv wceq eqid c0g wne w3a ctendo tendoidcl
      cmulr co erngbase eleqtrrd cmpt tendo1ne0 erng0g neeqtrrd ccom id erngmul
      syl12anc wf1o wf f1oi f1of fcoi2 mp2b syl6eq 3jca wb erngdv drngid2 mpbid
      cdr syl ) ELMFDMNZOBPZAQRZMZVMAUARZUBZVMVMAUFRZUGZVMSZUCZCVMSZVLVOVQVTVLV
      MFEUDRRZVNBWCDEFGHWCTZUEZVNABWCDELFGHWDIVNTZUHUIVLVMKBOEQRZPUJZVPWGBKWCDE
      WHFWGTZGHWDWHTZUKWGABKDEWHFVPWIGHIWJVPTZULUMVLVSVMVMUNZVMVLVLVMWCMZWMVSWL
      SVLUOWEWEABVRVMWCDEVMFLGHWDIVRTZUPUQBBVMURBBVMUSWLVMSBUTBBVMVABBVMVBVCVDV
      EVLAVJMWAWBVFADEFGIVGVNAVRCVMVPWFWNWKJVHVKVI $.
  $}

  ${
    $d f B $.  $d s t u D $.  $d a b s t u E $.  $d t I $.  $d a b f s t u K $.
    $d f s t u H $.  $d s t u O $.  $d a b f s T $.  $d a b f s t u W $.
    $d s t u P $.
    ernggrp.h-r $e |- H = ( LHyp ` K ) $.
    ernggrp.d-r $e |- D = ( ( EDRingR ` K ) ` W ) $.
    ${
      ernggrplem.b-r $e |- B = ( Base ` K ) $.
      ernggrplem.t-r $e |- T = ( ( LTrn ` K ) ` W ) $.
      ernggrplem.e-r $e |- E = ( ( TEndo ` K ) ` W ) $.
      ernggrplem.p-r $e |- P = ( a e. E , b e. E |-> ( f e. T
          |-> ( ( a ` f ) o. ( b ` f ) ) ) ) $.
      ernggrplem.o-r $e |- O = ( f e. T |-> ( _I |` B ) ) $.
      ernggrplem.i-r $e |- I = ( a e. E |-> ( f e. T |-> `' ( a ` f ) ) ) $.
      $( Lemma for ~ erngrng .  (Contributed by NM, 4-Aug-2013.)
         (New usage is discouraged.) $)
      erngdvlem1-rN $p |- ( ( K e. HL /\ W e. H ) -> D e. Grp ) $=
        ( vs vt vu chlt wcel wa cv cfv eqid erngbase-rN eqcomd cplusg ccom cmpt
        cbs erngfplus-rN syl6reqr tendoplcl tendo0cl tendo0pl tendoicl tendoipl
        cmpt2 tendoplass isgrpd ) IUEUFKGUFUGZUBUCUDFCBUBUHZHUIJVGBUPUIZFVIBDFG
        IUEKNQROVIUJUKULVGBUMUIZLMFFEDEUHZLUHUIVKMUHUIUNUOVDCMBVJDEFGIUEKLNQROV
        JUJUQSURMCDVHEFGIUCUHZKLNQRSUSMCVHDVLEFGIUDUHKLNQRSVEADEFGIJKPNQRTUTMAC
        VHDEFGIJKLPNQRTSVAVHDEFGHIKLNQRUAVBMACVHDEFGHIJKLNQRUAPSTVCVF $.

      $( Lemma for ~ erngrng .  (Contributed by NM, 6-Aug-2013.)
         (New usage is discouraged.) $)
      erngdvlem2-rN $p |- ( ( K e. HL /\ W e. H ) -> D e. Abel ) $=
        ( vs vt chlt wcel wa cbs eqid erngbase-rN eqcomd cplusg ccom cmpt cmpt2
        cfv cv erngfplus-rN syl6reqr erngdvlem1-rN tendoplcom isabld ) IUDUEKGU
        EUFZUBUCFCBVBBUGUOZFVCBDFGIUDKNQROVCUHUIUJVBBUKUOZLMFFEDEUPZLUPUOVEMUPU
        OULUMUNCMBVDDEFGIUDKLNQROVDUHUQSURABCDEFGHIJKLMNOPQRSTUAUSMCDUBUPEFGIUC
        UPKLNQRSUTVA $.

      erngrnglem.m-r $e |- M = ( a e. E , b e. E |-> ( b o. a ) ) $.
      $( Lemma for ~ erngrng .  (Contributed by NM, 6-Aug-2013.)
         (New usage is discouraged.) $)
      erngdvlem3-rN $p |- ( ( K e. HL /\ W e. H ) -> D e. Ring ) $=
        ( vs vt vu chlt wcel wa cid cres cbs cfv eqid erngbase-rN eqcomd cplusg
        cv ccom cmpt2 erngfplus-rN syl6reqr cmulr erngfmul-rN erngdvlem1-rN w3a
        cmpt co oveqd 3ad2ant1 erngmul-rN 3impb eqtrd tendococl 3com23 proplem3
        wceq eqeltrd 3adantr1 coeq1d adantr simpl simpr1 simpr3 simpr2 syl12anc
        syl3anc 3adantr3 coeq2d 3eqtrd coass syl6eqr 3eqtr4rd tendodi2 syl13anc
        3adant3r3 tendoplcl 3adantr2 oveq12d 3eqtr4d tendoidcl simpr tendo1mulr
        tendodi1 tendo1mul isrngd ) IUGUHLGUHUIZUDUEUFFCBJUJDUKZXGBULUMZFXIBDFG
        IUGLORSPXIUNUOUPXGBUQUMZMNFFEDEURZMURZUMXKNURZUMUSVGUTCNBXJDEFGIUGLMORS
        PXJUNVATVBXGBVCUMZMNFFXMXLUSUTJNBDXNFGIUGLMORSPXNUNZVDUCVBZABCDEFGHIKLM
        NOPQRSTUAUBVEXGUDURZFUHZUEURZFUHZVFZXQXSJVHZXSXQUSZFYAYBXQXSXNVHZYCXGXR
        YBYDVQXTXGJXNXQXSXPVIVJXGXRXTYDYCVQZBDXNXQFGIXSLUGORSPXOVKZVLVMXGXTXRYC
        FUHXSXQFGILOSVNVOVRZXGXRXTUFURZFUHZVFZUIZXSYHJVHZXQUSZYHXSUSZXQUSZXQYLJ
        VHZYBYHJVHZYKYLYNXQYKYLXSYHXNVHZYNXGYJUEUFJXNXPVPXGXTYIYRYNVQXRBDXNXSFG
        IYHLUGORSPXOVKVSVMZVTYKYPXQYLXNVHZYMXGYPYTVQYJXGJXNXQYLXPVIWAYKXGXRYLFU
        HYTYMVQXGYJWBZXGXRXTYIWCZYKYLYNFYSYKXGYIXTYNFUHUUAXGXRXTYIWDZXGXRXTYIWE
        ZYHXSFGILOSVNWGVRBDXNXQFGIYLLUGORSPXOVKWFVMYKYQYHYCUSZYOYKYQYBYHXNVHZYH
        YBUSZUUEXGYQUUFVQYJXGJXNYBYHXPVIWAYKXGYBFUHZYIUUFUUGVQUUAXGXRXTUUHYIYGW
        PUUCBDXNYBFGIYHLUGORSPXOVKWFYKYBYCYHYKYBYDYCXGYJUDUEJXNXPVPXGXRXTYEYIYF
        WHVMZWIWJYHXSXQWKWLWMYKXSYHCVHZXQUSZYCYHXQUSZCVHZXQUUJJVHZYBXQYHJVHZCVH
        YKXGXTYIXRUUKUUMVQUUAUUDUUCUUBNCXSDYHEFGIXQLMORSTWNWOYKUUNXQUUJXNVHZUUK
        XGUUNUUPVQYJXGJXNXQUUJXPVIWAYKXGXRUUJFUHZUUPUUKVQUUAUUBYKXGXTYIUUQUUAUU
        DUUCNCDXSEFGIYHLMORSTWQWGBDXNXQFGIUUJLUGORSPXOVKWFVMYKYBYCUUOUULCUUIYKU
        UOXQYHXNVHZUULXGYJUDUFJXNXPVPXGXRYIUURUULVQXTBDXNXQFGIYHLUGORSPXOVKWRVM
        ZWSWTYKYHXQXSCVHZUSZUULYNCVHZUUTYHJVHZUUOYLCVHYKXGYIXRXTUVAUVBVQUUAUUCU
        UBUUDNCYHDXQEFGIXSLMORSTXDWOYKUVCUUTYHXNVHZUVAYKJXNUUTYHXGJXNVQYJXPWAVI
        YKXGUUTFUHZYIUVDUVAVQUUAXGXRXTUVEYINCDXQEFGIXSLMORSTWQWPUUCBDXNUUTFGIYH
        LUGORSPXOVKWFVMYKUUOUULYLYNCUUSYSWSWTDFGILORSXAZXGXRUIZXHXQJVHZXHXQXNVH
        ZXQXHUSZXQXGUVHUVIVQXRXGJXNXHXQXPVIWAUVGXGXHFUHZXRUVIUVJVQXGXRWBZXGUVKX
        RUVFWAZXGXRXBZBDXNXHFGIXQLUGORSPXOVKWFDXQFGILORSXCWJUVGXQXHJVHZXQXHXNVH
        ZXHXQUSZXQXGUVOUVPVQXRXGJXNXQXHXPVIWAUVGXGXRUVKUVPUVQVQUVLUVNUVMBDXNXQF
        GIXHLUGORSPXOVKWFDXQFGILORSXEWJXF $.

      edlemk6.j-r $e |- .\/ = ( join ` K ) $.
      edlemk6.m-r $e |- ./\ = ( meet ` K ) $.
      edlemk6.r-r $e |- R = ( ( trL ` K ) ` W ) $.
      edlemk6.p-r $e |- Q = ( ( oc ` K ) ` W ) $.
      edlemk6.z-r $e |- Z = ( ( Q .\/ ( R ` b ) )
         ./\ ( ( h ` Q ) .\/ ( R ` ( b o. `' ( s ` h ) ) ) ) ) $.
      edlemk6.y-r $e |- Y = ( ( Q .\/ ( R ` g ) )
         ./\ ( Z .\/ ( R ` ( g o. `' b ) ) ) ) $.
      edlemk6.x-r $e |- X = ( iota_ z e. T A. b e. T ( ( b =/= ( _I |` B )
              /\ ( R ` b ) =/= ( R ` ( s ` h ) ) /\ ( R ` b ) =/= ( R ` g ) )
        -> ( z ` Q ) = Y ) ) $.
      edlemk6.u-r $e |- U = ( g e. T |-> if ( ( s ` h ) = h , g , X ) ) $.
      $d b g z ./\ $.  $d b g z .\/ $.  $d b g z A $.  $d b g s t z B $.
      $d b g z F $.  $d b g z H $.  $d b g z K $.  $d s t M $.  $d b g z N $.
      $d t O $.  $d g z P $.  $d b g z Q $.  $d b g z R $.  $d b g t u z T $.
      $d t U $.  $d b g z W $.  $d z Y $.  $d g Z $.  $d g z f $.
      $d b g s t z h $.
      $( Lemma for ~ erngdv .  (Contributed by NM, 11-Aug-2013.)
         (New usage is discouraged.) $)
      erngdvlem4-rN $p |- ( ( ( K e. HL /\ W e. H )
             /\ ( h e. T /\ h =/= ( _I |` B ) ) ) -> D e. DivRing ) $=
        ( vt vu chlt wcel wa cv cid cres wne cbs wceq erngbase-rN eqcomd adantr
        cfv eqid cmulr ccom cmpt2 erngfmul-rN syl6reqr cplusg tendo0cl eleqtrrd
        c0g co cmpt erngfplus-rN oveqd tendo0pl mpdan eqtr3d cgrp erngdvlem1-rN
        wb isgrpid2 syl mpbi2and cur wral tendoidcl eleq2d simpl simpr syl12anc
        erngmul-rN tendo1mulr eqtrd tendo1mul jca sylbid ralrimiv erngdvlem3-rN
        ex crg isrngid w3a simp1l simp2l simp3 simp2 tendoconid syl3anc eqnetrd
        simp3l tendo1ne0 simpll simplrl cdleml6 simpld cdleml9 ad2antrr cdleml8
        3expa simprl isdrngrd ) PVFVGTMVGVHZKVIZGVGZUUAVJBVKVLZVHZVHZUDVDLCQVJG
        VKZHSYTLCVMVRZVNUUDYTUUGLUUGCGLMPVFTUGUJUKUHUUGVSZVOZVPVQYTQCVTVRZVNUUD
        YTUUJUEUFLLUFVIZUEVIZWAWBQUFCGUUJLMPVFTUEUGUJUKUHUUJVSZWCUOWDZVQYTSCWHV
        RZVNUUDYTUUOSYTSUUGVGZSSCWEVRZWIZSVNZUUOSVNZYTSLUUGBGILMPSTUIUGUJUKUMWF
        ZUUIWGYTSSDWIZUURSYTDUUQSSYTUUQUEUFLLIGIVIZUULVRUVCUUKVRWAWJWBDUFCUUQGI
        LMPVFTUEUGUJUKUHUUQVSZWKULWDWLYTSLVGUVBSVNUVAUFBDSGILMPSTUEUIUGUJUKUMUL
        WMWNWOYTCWPVGUUPUUSVHUUTWRBCDGILMNPSTUEUFUGUHUIUJUKULUMUNWQUUGUUQCUUOSU
        UHUVDUUOVSWSWTXAVPVQYTUUFCXBVRZVNUUDYTUVEUUFYTUUFUUGVGZUUFVEVIZUUJWIZUV
        GVNZUVGUUFUUJWIZUVGVNZVHZVEUUGXCZUVEUUFVNZYTUUFLUUGGLMPTUGUJUKXDZUUIWGY
        TUVLVEUUGYTUVGUUGVGUVGLVGZUVLYTUUGLUVGUUIXEYTUVPUVLYTUVPVHZUVIUVKUVQUVH
        UVGUUFWAZUVGUVQYTUUFLVGZUVPUVHUVRVNYTUVPXFZYTUVSUVPUVOVQZYTUVPXGZCGUUJU
        UFLMPUVGTVFUGUJUKUHUUMXIXHGUVGLMPTUGUJUKXJXKUVQUVJUUFUVGWAZUVGUVQYTUVPU
        VSUVJUWCVNUVTUWBUWACGUUJUVGLMPUUFTVFUGUJUKUHUUMXIXHGUVGLMPTUGUJUKXLXKXM
        XQXNXOYTCXRVGZUVFUVMVHUVNWRBCDGILMNPQSTUEUFUGUHUIUJUKULUMUNUOXPZVEUUGCU
        UJUVEUUFUUHUUMUVEVSXSWTXAVPVQYTUWDUUDUWEVQUUEUDVIZLVGZUWFSVLZVHZVDVIZLV
        GZUWJSVLZVHZXTZUWFUWJQWIZUWJUWFWAZSUWNUWOUWFUWJUUJWIZUWPUWNYTUWOUWQVNYT
        UUDUWIUWMYAZYTQUUJUWFUWJUUNWLWTUWNYTUWGUWKUWQUWPVNUWRUUEUWGUWHUWMYBUUEU
        WIUWKUWLYHCGUUJUWFLMPUWJTVFUGUJUKUHUUMXIXHXKUWNYTUWMUWIUWPSVLUWRUUEUWIU
        WMYCUUEUWIUWMYDBGUWJILMPSUWFTUIUGUJUKUMYEYFYGYTUUFSVLUUDBGILMPSTUIUGUJU
        KUMYIVQUUEUWIVHZYTUUBUWIHLVGZYTUUDUWIYJZYTUUBUUCUWIYKUUEUWIXGYTUUBUWIXT
        UWTUUAUWFVRHVRUUAVNABEFGHIJKLMOPRTUAUBSUCUDUFUIUPUQUGUJURUSUTVAVBVCUKUM
        YLYMYFZYTUUDUWIHSVLABEFGHIJKLMOPRTUAUBSUCUDUFUIUPUQUGUJURUSUTVAVBVCUKUM
        YNYQUWSUWFHQWIZUWFHUUJWIZUUFYTUXCUXDVNUUDUWIYTQUUJUWFHUUNWLYOUWSUXDHUWF
        WAZUUFUWSYTUWGUWTUXDUXEVNUXAUUEUWGUWHYRUXBCGUUJUWFLMPHTVFUGUJUKUHUUMXIX
        HYTUUDUWIUXEUUFVNABEFGHIJKLMOPRTUAUBSUCUDUFUIUPUQUGUJURUSUTVAVBVCUKUMYP
        YQXKXKYS $.
    $}

    $( An endomorphism ring is a ring.  Todo: fix comment.  (Contributed by NM,
       4-Aug-2013.)  (New usage is discouraged.) $)
    erngrng-rN $p |- ( ( K e. HL /\ W e. H ) -> D e. Ring ) $=
      ( va vb vf cbs cfv ctendo cltrn cv ccom cmpt cmpt2 ccnv cid eqid cres
      erngdvlem3-rN ) CJKZAGHDCLKKZUDIDCMKKZINZGNZKZUFHNZKOPQZUEIUDBGUDIUEUHRPP
      ZCGHUDUDUIUGOQZIUESUCUAPZDGHEFUCTUETUDTUJTUMTUKTULTUB $.

    $d f D $.  $d b g z H $.  $d g z K $.  $d g z W $.  $d a f g s z $.
    $( An endomorphism ring is a division ring.  Todo: fix comment.
       (Contributed by NM, 11-Aug-2013.)  (New usage is discouraged.) $)
    erngdv-rN $p |- ( ( K e. HL /\ W e. H ) -> D e. DivRing ) $=
      ( vf vz va vb vg wcel cv cfv wne eqid ccom cmpt co ccnv chlt cid cbs cres
      vs wa cdr cltrn cdlemftr0 ctendo cmpt2 coc ctrl wceq w3a cjn cmee wi wral
      crio cif erngdvlem4-rN rexlimddv ) CUALDBLUFGMZUBCUCNZUDZOAUGLGDCUHNNZVEV
      GGBCDVEPZEVGPZUIHVEAIJDCUJNNZVJGVGVDIMZNZVDJMZNQRUKZDCULNNZDCUMNNZVGKVGVD
      UEMNZVDUNKMZVMVFOVMVPNZVQVPNOVSVRVPNZOUOVOHMNVOVTCUPNZSVOVSWASVOVDNVMVQTQ
      VPNWASCUQNZSZVRVMTQVPNWASWBSZUNURJVGUSHVGUTZVARZGKGVJBIVJGVGVLTRRZWACIJVJ
      VJVMVKQUKZWBGVGVFRZDWEWDWCUEIJEFVHVIVJPVNPWIPWGPWHPWAPWBPVPPVOPWCPWDPWEPW
      FPVBVC $.
  $}

  $c DVecA $.

  $( Extend class notation with constructed vector space A. $)
  cdveca $a class DVecA $.

  ${
    $d k w s f g $.
    $( Define constructed partial vector space A. (Contributed by NM,
       8-Oct-2013.) $)
    df-dveca $a |- DVecA = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      ( { <. ( Base ` ndx ) , ( ( LTrn ` k ) ` w ) >. ,
          <. ( +g ` ndx ) , ( f e. ( ( LTrn ` k ) ` w ) ,
             g e. ( ( LTrn ` k ) ` w ) |-> ( f o. g ) ) >. ,
          <. ( Scalar ` ndx ) , ( ( EDRing ` k ) ` w ) >. } u. {
          <. ( .s ` ndx ) , ( s e. ( ( TEndo ` k ) ` w ) ,
             f e. ( ( LTrn ` k ) ` w ) |-> ( s ` f ) ) >. } ) ) ) $.
  $}

  ${
    $d w D $.  $d w E $.  $d k w H $.  $d f g k s w K $.  $d w T $.
    $d f g k s w W $.
    dvaset.h $e |- H = ( LHyp ` K ) $.
    $( The constructed partial vector space A for a lattice ` K ` .
       (Contributed by NM, 8-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvafset $p |- ( K e. V -> ( DVecA ` K ) = ( w e. H |->
      ( { <. ( Base ` ndx ) , ( ( LTrn ` K ) ` w ) >. ,
          <. ( +g ` ndx ) , ( f e. ( ( LTrn ` K ) ` w ) ,
             g e. ( ( LTrn ` K ) ` w ) |-> ( f o. g ) ) >. ,
          <. ( Scalar ` ndx ) , ( ( EDRing ` K ) ` w ) >. } u. {
          <. ( .s ` ndx ) , ( s e. ( ( TEndo ` K ) ` w ) ,
             f e. ( ( LTrn ` K ) ` w ) |-> ( s ` f ) ) >. } ) ) ) $=
      ( vk cvv cfv cnx cv cltrn cop cmpt2 cedring clh fveq2 opeq2d wcel cbs ctp
      cdveca cplusg ccom csca cvsca ctendo csn cun cmpt wceq elex syl6eqr eqidd
      fveq1d mpt2eq123dv tpeq123d sneqd uneq12d mpteq12dv df-dveca fvex eqeltri
      mptex fvmpt syl ) EFUAEJUAEUDKADLUBKZAMZENKZKZOZLUEKZBCVLVLBMZCMUFZPZOZLU
      GKZVJEQKZKZOZUCZLUHKZGBVJEUIKZKZVLVOGMKZPZOZUJZUKZULZUMEFUNIEAIMZRKZVIVJW
      MNKZKZOZVNBCWPWPVPPZOZVSVJWMQKZKZOZUCZWDGBVJWMUIKZKZWPWGPZOZUJZUKZULWLJUD
      WMEUMZAWNXIDWKXJWNERKZDWMERSHUOXJXCWCXHWJXJWQVMWSVRXBWBXJWPVLVIXJVJWOVKWM
      ENSUQZTXJWRVQVNXJBCWPWPVPVLVLVPXLXLXJVPUPURTXJXAWAVSXJVJWTVTWMEQSUQTUSXJX
      GWIXJXFWHWDXJGBXEWPWGWFVLWGXJVJXDWEWMEUISUQXLXJWGUPURTUTVAVBABCIGVCADWKDX
      KJHERVDVEVFVGVH $.

    dvaset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvaset.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvaset.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    dvaset.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    $( The constructed partial vector space A for a lattice ` K ` .
       (Contributed by NM, 8-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvaset $p |- ( ( K e. X /\ W e. H ) -> U =
      ( { <. ( Base ` ndx ) , T >. ,
          <. ( +g ` ndx ) , ( f e. T , g e. T |-> ( f o. g ) ) >. ,
          <. ( Scalar ` ndx ) , D >. } u. {
          <. ( .s ` ndx ) , ( s e. E , f e. T |-> ( s ` f ) ) >. } ) ) $=
      ( vw cfv cnx cop wcel wa cdveca cbs cplusg cv ccom cmpt2 csca ctp csn cun
      cvsca cltrn cedring ctendo cmpt dvafset fveq1d fveq2 syl6eqr opeq2d eqidd
      wceq mpt2eq123dv tpeq123d sneqd eqid tpex snex unex fvmpt sylan9eq syl5eq
      uneq12d ) HJUAZIGUAZUBCIHUCRZRZSUDRZBTZSUERZDEBBDUFZEUFUGZUHZTZSUIRZATZUJ
      ZSUMRZKDFBWCKUFRZUHZTZUKZULZPVPVQVSIQGVTQUFZHUNRZRZTZWBDEWRWRWDUHZTZWGWPH
      UORZRZTZUJZWJKDWPHUPRZRZWRWKUHZTZUKZULZUQZRWOVPIVRXLQDEGHJKLURUSQIXKWOGXL
      WPIVDZXEWIXJWNXMWSWAXAWFXDWHXMWRBVTXMWRIWQRBWPIWQUTMVAZVBXMWTWEWBXMDEWRWR
      WDBBWDXNXNXMWDVCVEVBXMXCAWGXMXCIXBRAWPIXBUTOVAVBVFXMXIWMXMXHWLWJXMKDXGWRW
      KFBWKXMXGIXFRFWPIXFUTNVAXNXMWKVCVEVBVGVOXLVHWIWNWAWFWHVIWMVJVKVLVMVN $.
  $}

  ${
    $d f g s t K $.  $d f g s t W $.
    dvasca.h $e |- H = ( LHyp ` K ) $.
    dvasca.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    dvasca.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvasca.f $e |- F = ( Scalar ` U ) $.
    $( The ring base set of the constructed partial vector space A are all
       translation group endomorphisms (for a fiducial co-atom ` W ` ).
       (Contributed by NM, 22-Jun-2014.) $)
    dvasca $p |- ( ( K e. X /\ W e. H ) -> F = D ) $=
      ( vf vg vs wcel csca cfv cnx cop cv cbs cltrn cplusg ccom cmpt2 ctp cvsca
      ctendo csn cun eqid dvaset fveq2d wceq cedring fvex eqeltri lmodsca ax-mp
      wa cvv 3eqtr4g ) EGOFDOUTZBPQRUAQFEUBQQZSRUCQLMVDVDLTZMTUDUEZSRPQASUFRUGQ
      NLFEUHQQZVDVENTQUEZSUIUJZPQZCAVCBVIPAVDBLMVGDEFGNHVDUKVGUKIJULUMKAVAOAVJU
      NAFEUOQZQVAIFVKUPUQVDVFVHAVIVAVIUKURUSVB $.
  $}

  ${
    $d f g s t K $.  $d f g s t W $.
    dvabase.h $e |- H = ( LHyp ` K ) $.
    dvabase.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvabase.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvabase.f $e |- F = ( Scalar ` U ) $.
    dvabase.c $e |- C = ( Base ` F ) $.
    $( The ring base set of the constructed partial vector space A are all
       translation group endomorphisms (for a fiducial co-atom ` W ` ).
       (Contributed by NM, 9-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvabase $p |- ( ( K e. X /\ W e. H ) -> C = E ) $=
      ( wcel wa cedring cfv cbs eqid dvasca fveq2d syl5eq cltrn erngbase eqtrd
      ) FHNGENOZAGFPQQZRQZCUFADRQUHMUFDUGRUGBDEFGHIUGSZKLTUAUBUHUGGFUCQQZCEFHGI
      UJSJUIUHSUDUE $.
  $}

  ${
    $d s t E $.  $d f G $.  $d f g s t K $.  $d f g s t T $.  $d f g s t W $.
    $d f R $.  $d f S $.
    dvafplus.h $e |- H = ( LHyp ` K ) $.
    dvafplus.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvafplus.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvafplus.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvafplus.f $e |- F = ( Scalar ` U ) $.
    dvafplus.p $e |- .+ = ( +g ` F ) $.
    $( Ring addition operation for the constructed partial vector space A.
       (Contributed by NM, 9-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvafplusg $p |- ( ( K e. V /\ W e. H ) -> .+ = ( s e. E ,
           t e. E |-> ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) ) $=
      ( cfv cplusg wcel wa cedring cv ccom cmpt cmpt2 eqid dvasca fveq2d syl5eq
      erngfplus eqtrd ) IJUAKHUAUBZBKIUCSSZTSZLAFFECEUDZLUDSUQAUDSUEUFUGUNBGTSU
      PRUNGUOTUODGHIKJMUOUHZPQUIUJUKAUOUPCEFHIJKLMNOURUPUHULUM $.

    $( Ring addition operation for the constructed partial vector space A.
       (Contributed by NM, 11-Oct-2013.) $)
    dvaplusg $p |- ( ( ( K e. V /\ W e. H ) /\ ( R e. E /\ S e. E ) )
        -> ( R .+ S ) = ( f e. T |-> ( ( R ` f ) o. ( S ` f ) ) ) ) $=
      ( vs vt vg wcel wa co cv cfv ccom cmpt cmpt2 dvafplusg oveqd eqid tendopl
      sylan9eq ) JKUBLIUBUCZBGUBCGUBUCBCAUDBCSTGGUADUAUEZSUEUFUPTUEUFUGUHUIZUDF
      DFUEZBUFURCUFUGUHUOAUQBCTADEUAGHIJKLSMNOPQRUJUKTUQDBUAFGJCLSUQULNUMUN $.

    $( Ring addition operation for the constructed partial vector space A.
       (Contributed by NM, 11-Oct-2013.) $)
    dvaplusgv $p |- ( ( ( K e. V /\ W e. H )
                     /\ ( R e. E /\ S e. E /\ G e. T ) )
        -> ( ( R .+ S ) ` G ) = ( ( R ` G ) o. ( S ` G ) ) ) $=
      ( wcel cfv vf wa w3a co cv ccom cmpt wceq dvaplusg fveq1d 3adantr3 simpr3
      fveq2 coeq12d eqid fvex coex fvmpt syl eqtrd ) JKSLISUBZBFSZCFSZHDSZUCUBZ
      HBCAUDZTZHUADUAUEZBTZVHCTZUFZUGZTZHBTZHCTZUFZVAVBVCVGVMUHVDVAVBVCUBUBHVFV
      LABCDEUAFGIJKLMNOPQRUIUJUKVEVDVMVPUHVAVBVCVDULUAHVKVPDVLVHHUHVIVNVJVOVHHB
      UMVHHCUMUNVLUOVNVOHBUPHCUPUQURUSUT $.
  $}

  ${
    $d s t E $.  $d f g s t K $.  $d f g s t W $.
    dvafmul.h $e |- H = ( LHyp ` K ) $.
    dvafmul.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvafmul.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvafmul.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvafmul.f $e |- F = ( Scalar ` U ) $.
    dvafmul.p $e |- .x. = ( .r ` F ) $.
    $( Ring multiplication operation for the constructed partial vector space
       A. (Contributed by NM, 9-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvafmulr $p |- ( ( K e. V /\ W e. H ) -> .x. = ( s e. E ,
           t e. E |-> ( s o. t ) ) ) $=
      ( wcel cfv cmulr wa cedring ccom cmpt2 eqid dvasca fveq2d syl5eq erngfmul
      cv eqtrd ) HIRJGRUAZCJHUBSSZTSZKAEEKUJAUJUCUDULCFTSUNQULFUMTUMDFGHJILUMUE
      ZOPUFUGUHAUMBUNEGHIJKLMNUOUNUEUIUK $.

    $d r E $.  $d r K $.  $d r s R $.  $d r s S $.  $d r W $.
    $( Ring multiplication operation for the constructed partial vector space
       A. (Contributed by NM, 11-Oct-2013.) $)
    dvamulr $p |- ( ( ( K e. V /\ W e. H ) /\ ( R e. E /\ S e. E ) )
        -> ( R .x. S ) = ( R o. S ) ) $=
      ( vr vs wcel wa co cv ccom cmpt2 dvafmulr oveqd cvv wceq coexg coeq1 eqid
      coeq2 ovmpt2g mpd3an3 sylan9eq ) IJTKHTUAZAFTZBFTZUAABDUBABRSFFRUCZSUCZUD
      ZUEZUBZABUDZUQDVCABSCDEFGHIJKRLMNOPQUFUGURUSVEUHTVDVEUIABFFUJRSABFFVBVEVC
      AVAUDUHUTAVAUKVABAUMVCULUNUOUP $.
  $}

  ${
    $d f g s K $.  $d f g s W $.
    dvavbase.h $e |- H = ( LHyp ` K ) $.
    dvavbase.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvavbase.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvavbase.v $e |- V = ( Base ` U ) $.
    $( The vectors (vector base set) of the constructed partial vector space A
       are all translations (for a fiducial co-atom ` W ` ).  (Contributed by
       NM, 9-Oct-2013.)  (Revised by Mario Carneiro, 22-Jun-2014.) $)
    dvavbase $p |- ( ( K e. X /\ W e. H ) -> V = T ) $=
      ( vf vg vs wcel cbs cfv cnx cop cv wa cplusg ccom cmpt2 cedring ctp cvsca
      csca ctendo csn cun eqid dvaset fveq2d cvv wceq cltrn fvex lmodbase ax-mp
      eqeltri 3eqtr4g ) DGOFCOUAZBPQRPQASRUBQLMAALTZMTUCUDZSRUHQFDUEQQZSUFRUGQN
      LFDUIQQZAVDNTQUDZSUJUKZPQZEAVCBVIPVFABLMVGCDFGNHIVGULVFULJUMUNKAUOOAVJUPA
      FDUQQZQUOIFVKURVAAVEVHVFVIUOVIULUSUTVB $.
  $}

  ${
    $d f g s K $.  $d f g T $.  $d f g s W $.
    dvafvadd.h $e |- H = ( LHyp ` K ) $.
    dvafvadd.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvafvadd.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvafvadd.v $e |- .+ = ( +g ` U ) $.
    $( The vector sum operation for the constructed partial vector space A.
       (Contributed by NM, 9-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvafvadd $p |- ( ( K e. X /\ W e. H ) -> .+ = ( f e. T ,
           g e. T |-> ( f o. g ) ) ) $=
      ( vs wcel cplusg cfv cnx cop cv wa cbs ccom cmpt2 csca cedring ctp ctendo
      cvsca csn cun eqid dvaset fveq2d wceq cltrn fvex eqeltri mpt2ex lmodplusg
      cvv ax-mp 3eqtr4g ) GIOHFOUAZCPQRUBQBSRPQDEBBDTZETUCZUDZSRUEQHGUFQQZSUGRU
      IQNDHGUHQQZBVENTQUDZSUJUKZPQZAVGVDCVKPVHBCDEVIFGHINJKVIULVHULLUMUNMVGVAOV
      GVLUODEBBVFBHGUPQZQVAKHVMUQURZVNUSBVGVJVHVKVAVKULUTVBVC $.

    $d f g F $.  $d f g G $.
    $( Ring addition operation for the constructed partial vector space A.
       (Contributed by NM, 11-Oct-2013.) $)
    dvavadd $p |- ( ( ( K e. V /\ W e. H ) /\ ( F e. T /\ G e. T ) )
        -> ( F .+ G ) = ( F o. G ) ) $=
      ( vf vg wcel wa co cv ccom cmpt2 dvafvadd oveqd cvv wceq coexg coeq1 eqid
      coeq2 ovmpt2g mpd3an3 sylan9eq ) GHPIFPQZDBPZEBPZQDEARDENOBBNSZOSZTZUAZRZ
      DETZUMAUSDEABCNOFGIHJKLMUBUCUNUOVAUDPUTVAUEDEBBUFNODEBBURVAUSDUQTUDUPDUQU
      GUQEDUIUSUHUJUKUL $.
  $}

  ${
    $d f s E $.  $d f g s K $.  $d f s T $.  $d f g s W $.
    dvafvsca.h $e |- H = ( LHyp ` K ) $.
    dvafvsca.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvafvsca.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvafvsca.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvafvsca.s $e |- .x. = ( .s ` U ) $.
    $( Ring addition operation for the constructed partial vector space A.
       (Contributed by NM, 9-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvafvsca $p |- ( ( K e. V /\ W e. H ) -> .x. = ( s e. E ,
           f e. T |-> ( s ` f ) ) ) $=
      ( cvsca cfv cnx cop cvv vg wcel wa cbs cplusg ccom cmpt2 csca cedring ctp
      csn cun eqid dvaset fveq2d wceq ctendo fvex eqeltri cltrn mpt2ex lmodvsca
      cv ax-mp 3eqtr4g ) GHUBIFUBUCZCPQRUDQASRUEQDUAAADVCZUAVCUFUGZSRUHQIGUIQQZ
      SUJRPQJDEAVGJVCQZUGZSUKULZPQZBVKVFCVLPVIACDUAEFGIHJKLMVIUMNUNUOOVKTUBVKVM
      UPJDEAVJEIGUQQZQTMIVNURUSAIGUTQZQTLIVOURUSVAAVHVKVIVLTVLUMVBVDVE $.

    $d f s F $.  $d f s R $.
    $( Ring addition operation for the constructed partial vector space A.
       (Contributed by NM, 11-Oct-2013.) $)
    dvavsca $p |- ( ( ( K e. V /\ W e. H ) /\ ( R e. E /\ F e. T ) )
        -> ( R .x. F ) = ( R ` F ) ) $=
      ( vs vf wcel wa cfv co cv cmpt2 dvafvsca oveqd fveq1 eqid ovmpt2 sylan9eq
      fveq2 fvex ) HIRJGRSZAERFBRSAFCUAAFPQEBQUBZPUBZTZUCZUAFATZULCUPAFBCDQEGHI
      JPKLMNOUDUEPQAFEBUOUQUPUMATUMUNAUFUMFAUJUPUGFAUKUHUI $.
  $}

  $( Identity property of endomorphism scalar product operation.  (Contributed
     by NM, 10-Oct-2013.) $)
  tendospid $p |- ( F e. T -> ( ( _I |` T ) ` F ) = F ) $=
    ( fvresi ) ABC $.

  ${
    tendosp.h $e |- H = ( LHyp ` K ) $.
    tendosp.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendosp.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    $( Closure of endomorphism scalar product operation.  (Contributed by NM,
       10-Oct-2013.) $)
    tendospcl $p |- ( ( ( K e. V /\ W e. H ) /\ U e. E /\ F e. T )
     -> ( U ` F ) e. T ) $=
      ( tendocl ) BACDEFGHIJKL $.

    $( Associative law for endomorphism scalar product operation.  (Contributed
       by NM, 10-Oct-2013.) $)
    tendospass $p |- ( ( ( K e. X /\ W e. H )
           /\ ( U e. E /\ V e. E /\ F e. T ) )
     -> ( ( U o. V ) ` F ) = ( U ` ( V ` F ) ) ) $=
      ( wcel wa w3a wf ccom cfv wceq tendof 3ad2antr2 simpr3 fvco3 syl2anc ) FI
      MHEMNZBCMZGCMZDAMZONAAGPZUHDBGQRDGRBRSUEUFUGUIUHGACEFIHJKLTUAUEUFUGUHUBAA
      DBGUCUD $.

    $( Forward distributive law for endomorphism scalar product operation.
       (Contributed by NM, 10-Oct-2013.) $)
    tendospdi1 $p |- ( ( ( K e. V /\ W e. H )
           /\ ( U e. E /\ F e. T /\ G e. T ) )
     -> ( U ` ( F o. G ) ) = ( ( U ` F ) o. ( U ` G ) ) ) $=
      ( wcel wa w3a ccom cfv wceq simpll simplr simpr1 simpr2 simpr3 tendovalco
      syl32anc ) GHMZIFMZNZBCMZDAMZEAMZOZNUFUGUIUJUKDEPBQDBQEBQPRUFUGULSUFUGULT
      UHUIUJUKUAUHUIUJUKUBUHUIUJUKUCBACDEFGHIJKLUDUE $.

    $( Converse of a trace-preserving endomorphism value.  (Contributed by NM,
       7-Apr-2014.) $)
    tendocnv $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E /\ F e. T )
       -> `' ( S ` F ) = ( S ` `' F ) ) $=
      ( chlt wcel cfv ccnv ccom wf1o wceq ltrn1o syl2anc syl w3a cid cres simp1
      wa tendocl eqid f1ococnv1 coeq1d simp2 tendoid 3adant2 f1ococnv2 3eqtr4rd
      cbs fveq2d simp3 ltrncnv tendospdi1 syl13anc eqtrd coass 3eqtr4g syld3an3
      coeq2d wf f1of fcoi2 3syl 3eqtrd 3eqtr3rd ) FKLGELUEZACLZDBLZUAZDAMZNZVPO
      ZVQOZUBFUOMZUCZVQOZDNZAMZVQVOVRWAVQVOVTVTVPPZVRWAQVOVLVPBLZWEVLVMVNUDZABC
      DEFKGHIJUFZVTBVPEFKGVTUGZHIRSZVTVTVPUHTZUIVOVSVRWDOZWAWDOZWDVOVQVPVQOZOVQ
      VPWDOZOVSWLVOWNWOVQVOWNDWCOZAMZWOVOWAAMZWAWQWNVOVLVMWRWAQWGVLVMVNUJZVTACE
      FGWIHJUKSVOWPWAAVOVTVTDPZWPWAQVLVNWTVMVTBDEFKGWIHIRULVTVTDUMTUPVOWEWNWAQW
      JVTVTVPUMTUNVOVLVMVNWCBLZWQWOQWGWSVLVMVNUQVLVNXAVMBDEFGHIURULZBACDWCEFKGH
      IJUSUTVAVEVQVPVQVBVQVPWDVBVCVOVRWAWDWKUIVOVTVTWDPZVTVTWDVFWMWDQVOVLWDBLZX
      CWGVLVMVNXAXDXBABCWCEFKGHIJUFVDVTBWDEFKGWIHIRSVTVTWDVGVTVTWDVHVIVJVOVTVTV
      QPZVTVTVQVFWBVQQVOVLVQBLZXEWGVOVLWFXFWGWHBVPEFGHIURSVTBVQEFKGWIHIRSVTVTVQ
      VGVTVTVQVHVIVK $.
  $}

  ${
    $d s t E $.  $d f s t T $.  $d f s t W $.
    tendospd.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendosp.p $e |- P = ( s e. E , t e. E
  |-> ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    $( Reverse distributive law for endomorphism scalar product operation.
       (Contributed by NM, 10-Oct-2013.) $)
    tendospdi2 $p |- ( ( U e. E /\ V e. E /\ F e. T )
     -> ( ( U P V ) ` F ) = ( ( U ` F ) o. ( V ` F ) ) ) $=
      ( tendopl2 ) ABCDEFGHIJKMLN $.
  $}

  ${
    $d f B $.  $d f T $.
    tendospcan.b $e |- B = ( Base ` K ) $.
    tendospcan.h $e |- H = ( LHyp ` K ) $.
    tendospcan.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendospcan.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendospcan.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $( Cancellation law for trace-perserving endomorphism values (used as
       scalar product).  (Contributed by NM, 7-Apr-2014.)
       (New usage is discouraged.) $)
    tendospcanN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S e. E /\ S =/= O )
       /\ ( F e. T /\ G e. T ) )
   -> ( ( S ` F ) = ( S ` G ) <-> F = G ) ) $=
      ( wcel wa wceq syl3anc chlt wne w3a cfv wi ccnv ccom cres tendocnv coeq2d
      cid 3adant3l simp1 simp2 simp3l simp3r ltrncnv tendospdi1 syl13anc eqtr4d
      syl2anc adantr eqeq1d wb simpl1 simpl2 simpl3l tendocl ltrncoidN tendoid0
      simpl3r ltrnco simpr syl112anc 3bitr3d biimpd impancom sylibd 3exp1 com24
      necon1d imp5a 3imp fveq2 impbid1 ) IUAQKHQRZBEQZBJUBZRZFCQZGCQZRZUCFBUDZG
      BUDZSZFGSZWFWIWLWOWPUEWFWOWLWIWPWFWOWLWGWHWPWFWGWLWOWHWPUEZWFWGWLWOWQWFWG
      WLUCZWORZWHFGUFZUGZUKAUHZSZWPWSXAXBBJWRXAXBUBZWOBJSZWRXDRZWOXEXFWMWNUFZUG
      ZXBSZXABUDZXBSZWOXEXFXHXJXBWRXHXJSXDWRXHWMWTBUDZUGZXJWRXGXLWMWFWGWKXGXLSW
      JBCEGHIKMNOUIULUJWRWFWGWJWTCQZXJXMSWFWGWLUMZWFWGWLUNWFWGWJWKUOWRWFWKXNXOW
      FWGWJWKUPCGHIKMNUQZVACBEFWTHIUAKMNOURUSUTVBVCXFWFWMCQZWNCQZXIWOVDWFWGWLXD
      VEZXFWFWGWJXQXSWFWGWLXDVFZWJWKWFWGXDVGZBCEFHIUAKMNOVHTXFWFWGWKXRXSXTWJWKW
      FWGXDVKZBCEGHIUAKMNOVHTACWMWNHIKLMNVITXFWFWGXACQZXDXKXEVDXSXTXFWFWJXNYCXS
      YAXFWFWKXNXSYBXPVACFWTHIKMNVLTWRXDVMACBDEXAHIJKLMNOPVJVNVOVPVQWAWSWFWJWKX
      CWPVDWFWGWLWOVEWJWKWFWGWOVGWJWKWFWGWOVKACFGHIKLMNVITVRVSVTWBVTWCFGBWDWE
      $.
  $}

  ${
    $d f t .+^ $.  $d f B $.  $d a b f s t E $.  $d a b f g s t K $.  $d s U $.
    $d f s t .+ $.  $d a b f s t T $.  $d a b f g s t W $.  $d f s t .x. $.
    $d f s t H $.  $d f t .X. $.
    dvalvec.h $e |- H = ( LHyp ` K ) $.
    dvalvec.v $e |- U = ( ( DVecA ` K ) ` W ) $.
    $( The constructed partial vector space A for a lattice ` K ` is an abelian
       group.  (Contributed by NM, 11-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvaabl $p |- ( ( K e. HL /\ W e. H ) -> U e. Abel ) $=
      ( vf vg vs chlt wcel cnx cbs cfv cop cplusg cv cabel eqid cvv cltrn cmpt2
      wa ccom cedring ctp cvsca ctendo csn cun dvaset cpr ctgrp tgrpset tgrpabl
      csca eqeltrrd wceq fvex grpbase lmodbase eqtr3d mpt2ex grpplusg lmodplusg
      ax-mp ablprop sylib eqeltrd ) CJKDBKUCZALMNDCUANZNZOZLPNGHVLVLGQZHQUDZUBZ
      OZLUPNDCUENNZOUFLUGNIGDCUHNNZVLVNIQNUBZOUIUJZRVRVLAGHVSBCDJIEVLSZVSSVRSFU
      KVJVMVQULZRKWARKVJDCUMNNZWCRVLGHWDBCJDEWBWDSZUNWDBCDEWEUOUQWCWAVLTKZWCMNZ
      WAMNZURDVKUSZWFVLWGWHVLVPWCTWCSZUTVLVPVTVRWATWASZVAVBVFVPTKZWCPNZWAPNZURG
      HVLVLVOWIWIVCWLVPWMWNVLVPWCTWJVDVLVPVTVRWATWKVEVBVFVGVHVI $.

    ${
      dvalveclem.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      dvalveclem.a $e |- .+ = ( +g ` U ) $.
      dvalveclem.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      dvalveclem.d $e |- D = ( Scalar ` U ) $.
      dvalveclem.b $e |- B = ( Base ` K ) $.
      dvalveclem.p $e |- .+^ = ( +g ` D ) $.
      dvalveclem.m $e |- .X. = ( .r ` D ) $.
      dvalveclem.s $e |- .x. = ( .s ` U ) $.
      $( Lemma for ~ dvalvec .  (Contributed by NM, 11-Oct-2013.)  (Proof
         shortened by Mario Carneiro, 22-Jun-2014.) $)
      dvalveclem $p |- ( ( K e. HL /\ W e. H ) -> U e. LVec ) $=
        ( vs vt vf va vb chlt wcel wa clmod cdr clvec cid cres cbs cfv dvavbase
        eqid eqcomd cplusg wceq a1i csca cvsca dvabase cmulr cur c0g wne co w3a
        tendoidcl eleqtrd tendo1ne0 cedring dvasca fveq2d erng0g eqtrd neeqtrrd
        cmpt ccom jca dvamulr mpdan wf1o wf f1oi f1of fcoi2 mp2b syl6eq 3jca wb
        erngdv eqeltrd drngid2 syl mpbid crg drngrng cgrp dvaabl ablgrp dvavsca
        cabel 3impb tendocl tendospdi1 simpr1 ltrnco 3adant3r1 syldan 3adant3r3
        cv 3adant3r2 dvavadd 3eqtr4d 3adantr1 oveq2d 3adantr3 oveq12d dvaplusgv
        3adantr2 cmpt2 dvafplusg 3ad2ant1 tendoplcl simpr3 tendospcl tendospass
        oveqd tendococl oveq1d anim1i fvresi adantl islmodd islvec sylanbrc ) K
        UHUILJUIUJZHUKUIBULUIZHUMUIUUBUCUDUEICDFGUNEUOZBEHUUBHUPUQZEEHJKUUELUHM
        ONUUEUSURUTCHVAUQVBUUBPVCBHVDUQVBUUBRVCFHVEUQVBUUBUBVCUUBBUPUQZIUUFHIBJ
        KLUHMQNRUUFUSZVFUTZDBVAUQVBUUBTVCGBVGUQVBUUBUAVCUUBBVHUQZUUDUUBUUDUUFUI
        ZUUDBVIUQZVJZUUDUUDGVKZUUDVBZVLZUUIUUDVBZUUBUUJUULUUNUUBUUDIUUFEIJKLMOQ
        VMZUUHVNUUBUUDUEEUNAUOWBZUUKAEUEIJKUURLSMOQUURUSZVOUUBUUKLKVPUQUQZVIUQZ
        UURUUBBUUTVIUUTHBJKLUHMUUTUSZNRVQZVRAUUTEUEJKUURLUVASMOUVBUUSUVAUSVSVTW
        AUUBUUMUUDUUDWCZUUDUUBUUDIUIZUVEUJUUMUVDVBUUBUVEUVEUUQUUQWDUUDUUDEGHIBJ
        KUHLMOQNRUAWEWFEEUUDWGEEUUDWHUVDUUDVBEWIEEUUDWJEEUUDWKWLWMWNUUBUUCUUOUU
        PWOUUBBUUTULUVCUUTJKLMUVBWPWQZUUFBGUUIUUDUUKUUGUAUUKUSUUIUSWRWSWTUTUUBU
        UCBXAUIUVFBXBWSUUBHXGUIHXCUIHJKLMNXDHXEWSUUBUCXPZIUIZUDXPZEUIZVLUVGUVIF
        VKZUVIUVGUQZEUUBUVHUVJUVKUVLVBZUVGEFHIUVIJKUHLMOQNUBXFZXHUVGEIUVIJKUHLM
        OQXIZWQUUBUVHUVJUEXPZEUIZVLZUJZUVGUVIUVPWCZFVKZUVLUVPUVGUQZCVKZUVGUVIUV
        PCVKZFVKUVKUVGUVPFVKZCVKUVSUVTUVGUQZUVLUWBWCZUWAUWCEUVGIUVIUVPJKUHLMOQX
        JUUBUVRUVHUVTEUIZUJUWAUWFVBUVSUVHUWHUUBUVHUVJUVQXKUUBUVJUVQUWHUVHEUVIUV
        PJKLMOXLXMWDUVGEFHIUVTJKUHLMOQNUBXFXNUUBUVRUVLEUIZUWBEUIZUJUWCUWGVBUVSU
        WIUWJUUBUVHUVJUWIUVQUVOXOUUBUVHUVQUWJUVJUVGEIUVPJKUHLMOQXIZXQWDCEHUVLUW
        BJKUHLMONPXRXNXSUVSUWDUVTUVGFUUBUVJUVQUWDUVTVBUVHCEHUVIUVPJKUHLMONPXRXT
        YAUVSUVKUVLUWEUWBCUUBUVHUVJUVMUVQUVNYBUUBUVHUVQUWEUWBVBZUVJUVGEFHIUVPJK
        UHLMOQNUBXFZYEYCXSUUBUVHUVIIUIZUVQVLZUJZUVPUVGUVIDVKZUQZUWBUVPUVIUQZWCZ
        UWQUVPFVKZUWEUVIUVPFVKZCVKZDUVGUVIEHIBUVPJKUHLMOQNRTYDUUBUWOUWQIUIZUVQU
        JUXAUWRVBUWPUXDUVQUUBUVHUWNUXDUVQUUBUVHUWNVLZUWQUVGUVIUFUGIIUEEUVPUFXPU
        QUVPUGXPUQWCWBYFZVKIUXEDUXFUVGUVIUUBUVHDUXFVBUWNUGDEHUEIBJKUHLUFMOQNRTY
        GYHYMUGUXFEUVGUEIJKUVILUFMOQUXFUSYIWQXOUUBUVHUWNUVQYJZWDUWQEFHIUVPJKUHL
        MOQNUBXFXNUWPUXCUWBUWSCVKZUWTUWPUWEUWBUXBUWSCUUBUVHUVQUWLUWNUWMYEUUBUWN
        UVQUXBUWSVBUVHUVIEFHIUVPJKUHLMOQNUBXFXTZYCUUBUWOUWJUWSEUIZUJUXHUWTVBUWP
        UWJUXJUUBUVHUVQUWJUWNUWKXQUUBUWNUVQUXJUVHEUVIIUVPJKUHLMOQYKXMZWDCEHUWBU
        WSJKUHLMONPXRXNVTXSUWPUVGUVIWCZUVPFVKZUVGUWSFVKZUVGUVIGVKZUVPFVKUVGUXBF
        VKUWPUVPUXLUQZUWSUVGUQZUXMUXNEUVGIUVPJKUVILUHMOQYLUUBUWOUXLIUIZUVQUJUXM
        UXPVBUWPUXRUVQUUBUVHUWNUXRUVQUVGUVIIJKLMQYNXOUXGWDUXLEFHIUVPJKUHLMOQNUB
        XFXNUUBUWOUVHUXJUJUXNUXQVBUWPUVHUXJUUBUVHUWNUVQXKUXKWDUVGEFHIUWSJKUHLMO
        QNUBXFXNXSUWPUXOUXLUVPFUUBUVHUWNUXOUXLVBUVQUVGUVIEGHIBJKUHLMOQNRUAWEYBY
        OUWPUXBUWSUVGFUXIYAXSUUBUVGEUIZUJUUDUVGFVKZUVGUUDUQZUVGUUBUXSUVEUXSUJUX
        TUYAVBUUBUVEUXSUUQYPUUDEFHIUVGJKUHLMOQNUBXFXNUXSUYAUVGVBUUBEUVGYQYRVTYS
        UVFBHRYTUUA $.
    $}

    $( The constructed partial vector space A for a lattice ` K ` is a left
       vector space.  (Contributed by NM, 11-Oct-2013.)  (Revised by Mario
       Carneiro, 22-Jun-2014.) $)
    dvalvec $p |- ( ( K e. HL /\ W e. H ) -> U e. LVec ) $=
      ( cbs cfv csca cplusg cltrn cvsca cmulr ctendo eqid dvalveclem ) CGHZAIHZ
      AJHZRJHZDCKHHZALHZRMHZADCNHHZBCDEFUAOSOUDOROQOTOUCOUBOP $.
  $}

  ${
    dva0g.b $e |- B = ( Base ` K ) $.
    dva0g.h $e |- H = ( LHyp ` K ) $.
    dva0g.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dva0g.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dva0g.z $e |- .0. = ( 0g ` U ) $.
    $( The zero vector of partial vector space A. (Contributed by NM,
       9-Sep-2014.) $)
    dva0g $p |- ( ( K e. HL /\ W e. H ) -> .0. = ( _I |` B ) ) $=
      ( chlt wcel wa cid cres cfv wceq eqid cplusg ccom idltrn dvavadd syl12anc
      co id wf1o wf f1oi f1of fcoi2 mp2b syl6eq clmod wb clvec dvalvec lveclmod
      cbs syl dvavbase eleqtrrd lmod0vid syl2anc mpbid ) EMNFDNOZPAQZVHCUARZUFZ
      VHSZGVHSZVGVJVHVHUBZVHVGVGVHBNZVNVJVMSVGUGABDEFHIJUCZVOVIBCVHVHDEMFIJKVIT
      ZUDUEAAVHUHAAVHUIVMVHSAUJAAVHUKAAVHULUMUNVGCUONZVHCUTRZNVKVLUPVGCUQNVQCDE
      FIKURCUSVAVGVHBVRVOBCDEVRFMIJKVRTZVBVCVIVRCVHGVSVPLVDVEVF $.
  $}

  $c DIsoA $.

  $( Extend class notation with partial isomorphism A. $)
  cdia $a class DIsoA $.

  ${
    $d k w x y f $.
    $( Define partial isomorphism A. (Contributed by NM, 15-Oct-2013.) $)
    df-disoa $a |- DIsoA = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
        ( x e. { y e. ( Base ` k ) | y ( le ` k ) w } |->
             { f e. ( ( LTrn ` k ) ` w ) |
                   ( ( ( trL ` k ) ` w ) ` f ) ( le ` k ) x } ) ) ) $.
  $}

  ${
    $d k w x y .<_ $.  $d k w x y B $.  $d k w H $.  $d f k w x y K $.
    $d w x R $.  $d f w x T $.  $d f w x y W $.  $d f x y X $.
    diaval.b $e |- B = ( Base ` K ) $.
    diaval.l $e |- .<_ = ( le ` K ) $.
    diaval.h $e |- H = ( LHyp ` K ) $.
    $( The partial isomorphism A for a lattice ` K ` .  (Contributed by NM,
       15-Oct-2013.) $)
    diaffval $p |- ( K e. V -> ( DIsoA ` K ) = ( w e. H |->
        ( x e. { y e. B | y .<_ w } |->
             { f e. ( ( LTrn ` K ) ` w ) |
                   ( ( ( trL ` K ) ` w ) ` f ) .<_ x } ) ) ) $=
      ( vk cfv cv wbr crab cmpt clh fveq2 wcel cvv cdia ctrl wceq elex cple cbs
      cltrn syl6eqr breqd rabeqbidv fveq1d eqidd breq123d df-disoa fvex eqeltri
      mpteq12dv mptex fvmpt syl ) GIUAGUBUAGUCNCFABOZCOZHPZBDQZEOZVDGUDNZNZNZAO
      ZHPZEVDGUINZNZQZRZRZUEGIUFMGCMOZSNZAVCVDVRUGNZPZBVRUHNZQZVGVDVRUDNZNZNZVK
      VTPZEVDVRUINZNZQZRZRVQUBUCVRGUEZCVSWKFVPWLVSGSNZFVRGSTLUJWLAWCWJVFVOWLWAV
      EBWBDWLWBGUHNDVRGUHTJUJWLVTHVCVDWLVTGUGNHVRGUGTKUJZUKULWLWGVLEWIVNWLVDWHV
      MVRGUITUMWLWFVJVKVKVTHWLVGWEVIWLVDWDVHVRGUDTUMUMWNWLVKUNUOULUSUSABCEMUPCF
      VPFWMUBLGSUQURUTVAVB $.

    diaval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diaval.r $e |- R = ( ( trL ` K ) ` W ) $.
    diaval.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The partial isomorphism A for a lattice ` K ` .  (Contributed by NM,
       15-Oct-2013.) $)
    diafval $p |- ( ( K e. V /\ W e. H )
   -> I = ( x e. { y e. B | y .<_ W } |->
             { f e. T | ( R ` f ) .<_ x } ) ) $=
      ( vw cfv wcel cv wbr crab ctrl cltrn cmpt cdia diaffval fveq1d wceq breq2
      syl5eq rabbidv fveq2 syl6eqr breq1d rabeqbidv mpteq12dv eqid cbs cvv fvex
      eqeltri rabex mptex fvmpt sylan9eq ) IKUAZLGUAHLSGABUBZSUBZJUCZBCUDZFUBZV
      KIUETZTZTZAUBZJUCZFVKIUFTZTZUDZUGZUGZTZAVJLJUCZBCUDZVNDTZVRJUCZFEUDZUGZVI
      HLIUHTZTWERVILWLWDABSCFGIJKMNOUIUJUMSLWCWKGWDVKLUKZAVMWBWGWJWMVLWFBCVKLVJ
      JULUNWMVSWIFWAEWMWALVTTEVKLVTUOPUPWMVQWHVRJWMVNVPDWMVPLVOTDVKLVOUOQUPUJUQ
      URUSWDUTAWGWJWFBCCIVATVBMIVAVCVDVEVFVGVH $.

    $( The partial isomorphism A for a lattice ` K ` .  Definition of
       isomorphism map in [Crawley] p. 120 line 24.  (Contributed by NM,
       15-Oct-2013.) $)
    diaval $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( I ` X ) = { f e. T | ( R ` f ) .<_ X } ) $=
      ( vx vy cfv wcel wa wbr cv crab cmpt wceq adantr fveq1d simpr breq1 elrab
      diafval sylibr breq2 rabbidv eqid cltrn cvv eqeltri rabex fvmpt syl eqtrd
      fvex ) GIUAJEUAUBZKAUAKJHUCZUBZUBZKFTKRSUDZJHUCZSAUEZDUDBTZRUDZHUCZDCUEZU
      FZTZVMKHUCZDCUEZVIKFVQVFFVQUGVHRSABCDEFGHIJLMNOPQUMUHUIVIKVLUAZVRVTUGVIVH
      WAVFVHUJVKVGSKAVJKJHUKULUNRKVPVTVLVQVNKUGVOVSDCVNKVMHUOUPVQUQVSDCCJGURTZT
      USOJWBVEUTVAVBVCVD $.

    $d f .<_ $.  $d f F $.  $d f R $.
    $( Member of the partial isomorphism A for a lattice ` K ` .  (Contributed
       by NM, 3-Dec-2013.) $)
    diaelval $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( F e. ( I ` X ) <-> ( F e. T /\ ( R ` F ) .<_ X ) ) ) $=
      ( vf wcel wa wbr cfv cv crab diaval eleq2d wceq fveq2 breq1d elrab syl6bb
      ) GISJESTKASKJHUATTZDKFUBZSDRUCZBUBZKHUAZRCUDZSDCSDBUBZKHUAZTULUMUQDABCRE
      FGHIJKLMNOPQUEUFUPUSRDCUNDUGUOURKHUNDBUHUIUJUK $.
  $}

  ${
    $d x y .<_ $.  $d x y B $.  $d f x y K $.  $d f x y W $.  $d x X $.
    diafn.b $e |- B = ( Base ` K ) $.
    diafn.l $e |- .<_ = ( le ` K ) $.
    diafn.h $e |- H = ( LHyp ` K ) $.
    diafn.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( Functionality and domain of the partial isomorphism A. (Contributed by
       NM, 26-Nov-2013.) $)
    diafn $p |- ( ( K e. V /\ W e. H ) -> I Fn { x e. B | x .<_ W } ) $=
      ( vy vf wcel cv wbr crab cfv eqid wfn ctrl cltrn cmpt fvex fnmpti diafval
      wa rabex fneq1d mpbiri ) EGOHCOUHZDAPHFQABRZUAMUMNPHEUBSSZSMPFQZNHEUCSZSZ
      RZUDZUMUAMUMURUSUONUQHUPUEUIUSTUFULUMDUSMABUNUQNCDEFGHIJKUQTUNTLUGUJUK $.

    $( Domain of the partial isomorphism A. (Contributed by NM, 3-Dec-2013.) $)
    diadm $p |- ( ( K e. V /\ W e. H ) -> dom I = { x e. B | x .<_ W } ) $=
      ( wcel wa cv wbr crab wfn cdm wceq diafn fndm syl ) EGMHCMNDAOHFPABQZRDSU
      DTABCDEFGHIJKLUAUDDUBUC $.

    $( Member of domain of the partial isomorphism A. (Contributed by NM,
       4-Dec-2013.) $)
    diaeldm $p |- ( ( K e. V /\ W e. H )
          -> ( X e. dom I <-> ( X e. B /\ X .<_ W ) ) ) $=
      ( vx wcel wa cdm cv wbr crab diadm eleq2d breq1 elrab syl6bb ) DFNGBNOZHC
      PZNHMQZGERZMASZNHANHGERZOUEUFUIHMABCDEFGIJKLTUAUHUJMHAUGHGEUBUCUD $.
  $}

  ${
    diadmcl.b $e |- B = ( Base ` K ) $.
    diadmcl.h $e |- H = ( LHyp ` K ) $.
    diadmcl.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( A member of domain of the partial isomorphism A is a lattice element.
       (Contributed by NM, 5-Dec-2013.)  (New usage is discouraged.) $)
    diadmclN $p |- ( ( ( K e. V /\ W e. H ) /\ X e. dom I ) -> X e. B ) $=
      ( wcel wa cdm cple cfv wbr eqid diaeldm simprbda ) DEKFBKLGCMKGAKGFDNOZPA
      BCDTEFGHTQIJRS $.
  $}

  ${
    diadmle.l $e |- .<_ = ( le ` K ) $.
    diadmle.h $e |- H = ( LHyp ` K ) $.
    diadmle.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( A member of domain of the partial isomorphism A is under the fiducial
       hyperplane.  (Contributed by NM, 5-Dec-2013.)
       (New usage is discouraged.) $)
    diadmleN $p |- ( ( ( K e. V /\ W e. H ) /\ X e. dom I ) -> X .<_ W ) $=
      ( wcel wa cdm cbs cfv wbr eqid diaeldm simplbda ) CEKFAKLGBMKGCNOZKGFDPTA
      BCDEFGTQHIJRS $.
  $}

  ${
    dian0.b $e |- B = ( Base ` K ) $.
    dian0.l $e |- .<_ = ( le ` K ) $.
    dian0.h $e |- H = ( LHyp ` K ) $.
    dian0.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The value of the partial isomorphism A is not empty.  (Contributed by
       NM, 17-Jan-2014.) $)
    dian0 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
            -> ( I ` X ) =/= (/) ) $=
      ( chlt wcel wa wbr cid cres cfv eqid adantr c0 wne cltrn ctrl idltrn wceq
      cp0 trlid0 cal hlatl simpl atl0le syl2an eqbrtrd diaelval mpbir2and ne0i
      syl ) DLMZFBMZNZGAMZGFEOZNZNZPAQZGCRZMZVGUAUBVEVHVFFDUCRRZMZVFFDUDRRZRZGE
      OVAVJVDAVIBDFHJVISZUETVEVLDUGRZGEVAVLVNUFVDAVKBDFVNHVNSZJVKSZUHTVADUIMZVB
      VNGEOVDUSVQUTDUJTVBVCUKADEGVNHIVOULUMUNAVKVIVFBCDELFGHIJVMVPKUOUPVGVFUQUR
      $.
  $}

  ${
    dia0eldm.z $e |- .0. = ( 0. ` K ) $.
    dia0eldm.h $e |- H = ( LHyp ` K ) $.
    dia0eldm.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The lattice zero belongs to the domain of partial isomorphism A.
       (Contributed by NM, 5-Dec-2013.)  (New usage is discouraged.) $)
    dia0eldmN $p |- ( ( K e. HL /\ W e. H ) -> .0. e. dom I ) $=
      ( chlt wcel wa cdm cbs cfv cple wbr cops hlop adantr eqid op0cl syl op0le
      lhpbase syl2an diaeldm mpbir2and ) CIJZDAJZKZEBLJECMNZJZEDCONZPZUJCQJZULU
      HUOUICRZSUKCEUKTZFUAUBUHUODUKJUNUIUPUKACDUQGUDUKCUMDEUQUMTZFUCUEUKABCUMID
      EUQURGHUFUG $.
  $}

  ${
    dia1eldm.h $e |- H = ( LHyp ` K ) $.
    dia1eldm.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The fiducial hyperplane (the largest allowed lattice element) belongs to
       the domain of partial isomorphism A. (Contributed by NM, 5-Dec-2013.)
       (New usage is discouraged.) $)
    dia1eldmN $p |- ( ( K e. HL /\ W e. H ) -> W e. dom I ) $=
      ( chlt wcel wa cdm cbs cfv cple wbr eqid lhpbase adantl clat hllat latref
      syl2an diaeldm mpbir2and ) CGHZDAHZIDBJHDCKLZHZDDCMLZNZUEUGUDUFACDUFOZEPZ
      QUDCRHUGUIUECSUKUFCUHDUJUHOZTUAUFABCUHGDDUJULEFUBUC $.
  $}

  ${
    $d f K $.  $d f T $.  $d f W $.  $d f X $.
    diass.b $e |- B = ( Base ` K ) $.
    diass.l $e |- .<_ = ( le ` K ) $.
    diass.h $e |- H = ( LHyp ` K ) $.
    diass.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diass.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The value of the partial isomorphism A is a set of translations i.e. a
       set of vectors.  (Contributed by NM, 26-Nov-2013.) $)
    diass $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
            -> ( I ` X ) C_ T ) $=
      ( vf wcel wa wbr cfv cv ctrl crab eqid diaval ssrab2 syl6eqss ) EGPHCPQIA
      PIHFRQQIDSOTHEUASSZSIFRZOBUBBAUGBOCDEFGHIJKLMUGUCNUDUHOBUEUF $.

    $( A member of the value of the partial isomorphism A is a translation i.e.
       a vector.  (Contributed by NM, 17-Jan-2014.) $)
    diael $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W )
        /\ F e. ( I ` X ) ) -> F e. T ) $=
      ( wcel wa wbr cfv diass sseld 3impia ) FHPIDPQZJAPJIGRQZCJESZPCBPUCUDQUEB
      CABDEFGHIJKLMNOTUAUB $.
  $}

  ${
    $d k w x y .<_ $.  $d k w x y B $.  $d k w H $.  $d f k w x y K $.
    $d w x R $.  $d f w x T $.  $d f w x y W $.  $d f x y X $.
    diatrl.b $e |- B = ( Base ` K ) $.
    diatrl.l $e |- .<_ = ( le ` K ) $.
    diatrl.h $e |- H = ( LHyp ` K ) $.
    diatrl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diatrl.r $e |- R = ( ( trL ` K ) ` W ) $.
    diatrl.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( Trace of a member of the partial isomorphism A. (Contributed by NM,
       17-Jan-2014.) $)
    diatrl $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W )
       /\ F e. ( I ` X ) ) -> ( R ` F ) .<_ X ) $=
      ( wcel wa wbr cfv diaelval simpr syl6bi 3impia ) GIRJERSZKARKJHTSZDKFUARZ
      DBUAKHTZUFUGSUHDCRZUISUIABCDEFGHIJKLMNOPQUBUJUIUCUDUE $.
  $}

  ${
    $d x H $.  $d x I $.  $d x y K $.  $d x S $.  $d x T $.  $d x V $.
    $d x y W $.
    diaelrn.h $e |- H = ( LHyp ` K ) $.
    diaelrn.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diaelrn.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( Any value of the partial isomorphism A is a set of translations i.e. a
       set of vectors.  (Contributed by NM, 26-Nov-2013.)
       (New usage is discouraged.) $)
    diaelrnN $p |- ( ( ( K e. V /\ W e. H ) /\ S e. ran I )
            -> S C_ T ) $=
      ( vx vy wcel wa crn wss cv cfv wbr eqid wceq cple cbs crab wrex wfn diafn
      wb fvelrnb syl wi breq1 elrab diass ex sseq1 biimpcd syl6 syl5bi rexlimdv
      sylbid imp ) EFMGCMNZADOMZABPZVCVDKQZDRZAUAZKLQZGEUBRZSZLEUCRZUDZUEZVEVCD
      VMUFVDVNUHLVLCDEVJFGVLTZVJTZHJUGKVMADUIUJVCVHVEKVMVFVMMVFVLMVFGVJSZNZVCVH
      VEUKZVKVQLVFVLVIVFGVJULUMVCVRVGBPZVSVCVRVTVLBCDEVJFGVFVOVPHIJUNUOVHVTVEVG
      ABUPUQURUSUTVAVB $.
  $}

  ${
    $d a b x .<_ $.  $d a b x B $.  $d a b x H $.  $d a b x I $.  $d a b x K $.
    $d a b x U $.  $d a b x W $.  $d a b x X $.
    dialss.b $e |- B = ( Base ` K ) $.
    dialss.l $e |- .<_ = ( le ` K ) $.
    dialss.h $e |- H = ( LHyp ` K ) $.
    dialss.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dialss.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dialss.s $e |- S = ( LSubSp ` U ) $.
    $( The value of partial isomorphism A is a subspace of partial vector space
       A. Part of Lemma M of [Crawley] p. 120 line 26.  (Contributed by NM,
       17-Jan-2014.)  (Revised by Mario Carneiro, 23-Jun-2014.) $)
    dialss $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
        -> ( I ` X ) e. S ) $=
      ( chlt wcel cfv eqid syl3anc vx va vb wbr ctendo cplusg cvsca cltrn eqidd
      wa csca cbs wceq dvabase eqcomd adantr dvavbase a1i diass dian0 cv w3a co
      clss ccom simpll simpr1 simplr simpr2 diael dvavsca oveq1d tendocl simpr3
      syl12anc dvavadd eqtrd ctrl ltrnco cjn clat hllat ad3antrrr trlcl syl2anc
      latjcl simplrl trlco diatrl lattrd wb latjle12 syl13anc mpbi2and diaelval
      tendotp mpbir2and eqeltrd islssd ) FPQZHDQZUJZIAQZIHGUDZUJZUJZUAHFUERRZCU
      FRZBCUGRZIERZCUKRZHFUHRRZCUBUCXFXKUIXBXGXKULRZUMXEXBXMXGXMCXGXKDFHPLXGSZM
      XKSXMSUNUOUPXBXLCULRZUMXEXBXOXLXLCDFXOHPLXLSZMXOSUQUOUPXFXHUIXFXIUIBCVDRU
      MXFOURAXLDEFGPHIJKLXPNUSADEFGHIJKLNUTXFUAVAZXGQZUBVAZXJQZUCVAZXJQZVBZUJZX
      QXSXIVCZYAXHVCZXSXQRZYAVEZXJYDYFYGYAXHVCZYHYDYEYGYAXHYDXBXRXSXLQZYEYGUMXB
      XEYCVFZXFXRXTYBVGZYDXBXEXTYJYKXBXEYCVHZXFXRXTYBVIZAXLXSDEFGPHIJKLXPNVJTZX
      QXLXICXGXSDFPHLXPXNMXISVKVOVLYDXBYGXLQZYAXLQZYIYHUMYKYDXBXRYJYPYKYLYOXQXL
      XGXSDFPHLXPXNVMTZYDXBXEYBYQYKYMXFXRXTYBVNZAXLYADEFGPHIJKLXPNVJTZXHXLCYGYA
      DFPHLXPMXHSVPVOVQYDYHXJQZYHXLQZYHHFVRRRZRZIGUDZYDXBYPYQUUBYKYRYTXLYGYADFH
      LXPVSTZYDAFGUUDYGUUCRZYAUUCRZFVTRZVCZIJKWTFWAQZXAXEYCFWBWCZYDXBUUBUUDAQYK
      UUFAUUCXLYHDFHJLXPUUCSZWDWEYDUUKUUGAQZUUHAQZUUJAQUULYDXBYPUUNYKYRAUUCXLYG
      DFHJLXPUUMWDWEZYDXBYQUUOYKYTAUUCXLYADFHJLXPUUMWDWEZAUUIFUUGUUHJUUISZWFTXB
      XCXDYCWGZYDXBYPYQUUDUUJGUDYKYRYTUUCXLYGYADUUIFGHKUURLXPUUMWHTYDUUGIGUDZUU
      HIGUDZUUJIGUDZYDAFGUUGXSUUCRZIJKUULUUPYDXBYJUVCAQYKYOAUUCXLXSDFHJLXPUUMWD
      WEUUSYDXBXRYJUUGUVCGUDYKYLYOUUCXQXLXGXSDFGPHKLXPUUMXNWPTYDXBXEXTUVCIGUDYK
      YMYNAUUCXLXSDEFGPHIJKLXPUUMNWITWJYDXBXEYBUVAYKYMYSAUUCXLYADEFGPHIJKLXPUUM
      NWITYDUUKUUNUUOXCUUTUVAUJUVBWKUULUUPUUQUUSAUUIFGUUGUUHIJKUURWLWMWNWJXFUUA
      UUBUUEUJWKYCAUUCXLYHDEFGPHIJKLXPUUMNWOUPWQWRWS $.
  $}

  ${
    $d f .<_ $.  $d f B $.  $d f H $.  $d f K $.  $d f W $.  $d f X $.
    $d f Y $.
    dia11.b $e |- B = ( Base ` K ) $.
    dia11.l $e |- .<_ = ( le ` K ) $.
    dia11.h $e |- H = ( LHyp ` K ) $.
    dia11.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The partial isomorphism A for a lattice ` K ` is order-preserving in the
       region under co-atom ` W ` .  Part of Lemma M of [Crawley] p. 120 line
       28.  (Contributed by NM, 26-Nov-2013.) $)
    diaord $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
      /\ ( Y e. B /\ Y .<_ W ) )
   -> ( ( I ` X ) C_ ( I ` Y ) <-> X .<_ Y ) ) $=
      ( vf chlt wcel wa wbr cfv wss eqid cv ctrl cltrn crab wceq diaval 3adant3
      w3a 3adant2 sseq12d wi wral catm trlord ss2rab syl6rbbr bitrd ) DNOFBOPZG
      AOGFEQPZHAOHFEQPZUHZGCRZHCRZSMUAFDUBRRZRZGEQZMFDUCRRZUDZVEHEQZMVGUDZSZGHE
      QZVAVBVHVCVJURUSVBVHUEUTAVDVGMBCDENFGIJKVGTZVDTZLUFUGURUTVCVJUEUSAVDVGMBC
      DENFHIJKVMVNLUFUIUJVAVLVFVIUKMVGULVKDUMRZAVDVGMBDEFGHIJVOTKVMVNUNVFVIMVGU
      OUPUQ $.

    $( The partial isomorphism A for a lattice ` K ` is one-to-one in the
       region under co-atom ` W ` .  Part of Lemma M of [Crawley] p. 120 line
       28.  (Contributed by NM, 25-Nov-2013.)  (New usage is discouraged.) $)
    dia11N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
        /\ ( Y e. B /\ Y .<_ W ) ) -> ( ( I ` X ) = ( I ` Y ) <-> X = Y ) ) $=
      ( cfv wceq wss wa wcel wbr diaord wb chlt eqss 3com23 anbi12d clat simp1l
      w3a hllat syl simp2l simp3l latasymb syl3anc bitrd syl5bb ) GCMZHCMZNUPUQ
      OZUQUPOZPZDUAQZFBQZPZGAQZGFERZPZHAQZHFERZPZUGZGHNZUPUQUBVJUTGHERZHGERZPZV
      KVJURVLUSVMABCDEFGHIJKLSVCVIVFUSVMTABCDEFHGIJKLSUCUDVJDUEQZVDVGVNVKTVJVAV
      OVAVBVFVIUFDUHUIVCVDVEVIUJVCVFVGVHUKADEGHIJULUMUNUO $.
  $}

  ${
    $d x y H $.  $d x y I $.  $d x y K $.  $d x y W $.
    dia1o.h $e |- H = ( LHyp ` K ) $.
    dia1o.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The partial isomorphism A for a lattice ` K ` is a one-to-one
       function. .  Part of Lemma M of [Crawley] p. 120 line 27.  (Contributed
       by NM, 4-Dec-2013.)  (New usage is discouraged.) $)
    diaf11N $p |- ( ( K e. HL /\ W e. H ) -> I : dom I -1-1-onto-> ran I ) $=
      ( vx vy chlt wcel wa cdm wfn wceq cv cfv wral wbr eqid diaeldm crn weq wi
      wf1o cple cbs crab diafn wfun fnfun funfn sylib syl anbi12d dia11N biimpd
      eqidd w3a 3expib sylbid ralrimivv dff1o6 syl3anbrc ) CIJDAJKZBBLZMZBUAZVG
      NGOZBPHOZBPNZGHUBZUCZHVEQGVEQVEVGBUDVDBVHDCUEPZRZGCUFPZUGZMZVFGVOABCVMIDV
      OSZVMSZEFUHVQBUIVFVPBUJBUKULUMVDVGUQVDVLGHVEVEVDVHVEJZVIVEJZKVHVOJVNKZVIV
      OJVIDVMRKZKVLVDVTWBWAWCVOABCVMIDVHVRVSEFTVOABCVMIDVIVRVSEFTUNVDWBWCVLVDWB
      WCURVJVKVOABCVMDVHVIVRVSEFUOUPUSUTVAGHVEVGBVBVC $.

    $( Closure of partial isomorphism A for a lattice ` K ` .  (Contributed by
       NM, 4-Dec-2013.)  (New usage is discouraged.) $)
    diaclN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. dom I )
            -> ( I ` X ) e. ran I ) $=
      ( chlt wcel wa wfun cdm cfv crn wf1o diaf11N f1ofun syl fvelrn sylan ) CH
      IDAIJZBKZEBLZIEBMBNZIUAUCUDBOUBABCDFGPUCUDBQREBST $.

    $( Closure of partial isomorphism A converse.  (Contributed by NM,
       6-Dec-2013.)  (New usage is discouraged.) $)
    diacnvclN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
            -> ( `' I ` X ) e. dom I ) $=
      ( chlt wcel wa cdm crn wf1o ccnv cfv diaf11N f1ocnvdm sylan ) CHIDAIJBKZB
      LZBMETIEBNOSIABCDFGPSTEBQR $.
  $}

  ${
    $d f B $.  $d f H $.  $d f K $.  $d f W $.  $d f .0. $.
    dia0.b $e |- B = ( Base ` K ) $.
    dia0.z $e |- .0. = ( 0. ` K ) $.
    dia0.h $e |- H = ( LHyp ` K ) $.
    dia0.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The value of the partial isomorphism A at the lattice zero is the
       singleton of the identity translation i.e. the zero subspace.
       (Contributed by NM, 26-Nov-2013.) $)
    dia0 $p |- ( ( K e. HL /\ W e. H ) -> ( I ` .0. ) = { ( _I |` B ) } ) $=
      ( vf chlt wcel wa cfv wbr crab wceq syl eqid ctrl cple cltrn cid cres csn
      cv cal hlatl atl0cl adantr lhpbase atl0le syl2an diaval syl12anc ad2antrr
      id wb trlcl atlle0 syl2anc trlid0b bitr4d rabbidva idltrn rabsn 3eqtrd )
      DLMZEBMZNZFCOZKUGZEDUAOOZOZFDUBOZPZKEDUCOOZQZVMUDAUEZRZKVRQZVTUFZVKVKFAMZ
      FEVPPZVLVSRVKURVIWDVJVIDUHMZWDDUIZADFGHUJSUKVIWFEAMWEVJWGABDEGIULADVPEFGV
      PTZHUMUNAVNVRKBCDVPLEFGWHIVRTZVNTZJUOUPVKVQWAKVRVKVMVRMZNZVQVOFRZWAWLWFVO
      AMVQWMUSVIWFVJWKWGUQAVNVRVMBDEGIWIWJUTADVPVOFGWHHVAVBAVNVRVMBDEFGHIWIWJVC
      VDVEVKVTVRMWBWCRAVRBDEGIWIVFKVRVTVGSVH $.
  $}

  ${
    $d f H $.  $d f K $.  $d f T $.  $d f W $.
    dia1.h $e |- H = ( LHyp ` K ) $.
    dia1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia1.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The value of the partial isomorphism A at the fiducial co-atom is the
       set of all translations i.e. the entire vector space.  (Contributed by
       NM, 26-Nov-2013.)  (New usage is discouraged.) $)
    dia1N $p |- ( ( K e. HL /\ W e. H ) -> ( I ` W ) = T ) $=
      ( vf chlt wcel wa cfv cv ctrl cple wbr crab wceq eqid cbs id lhpbase clat
      adantl hllat latref syl2an diaval syl12anc ralrimiva rabid2 sylibr eqtr4d
      wral trlle ) DJKZEBKZLZECMZINZEDOMMZMEDPMZQZIARZAUSUSEDUAMZKZEEVCQZUTVESU
      SUBURVGUQVFBDEVFTZFUCZUEUQDUDKVGVHURDUFVJVFDVCEVIVCTZUGUHVFVBAIBCDVCJEEVI
      VKFGVBTZHUIUJUSVDIAUOAVESUSVDIAVBAVABDVCEVKFGVLUPUKVDIAULUMUN $.

    $( The largest subspace in the range of partial isomorphism A. (Contributed
       by NM, 5-Dec-2013.)  (New usage is discouraged.) $)
    dia1elN $p |- ( ( K e. HL /\ W e. H ) -> T e. ran I ) $=
      ( chlt wcel wa cfv crn dia1N wfun cdm wf1o diaf11N f1ofun syl dia1eldmN
      fvelrn syl2anc eqeltrrd ) DIJEBJKZECLZACMZABCDEFGHNUECOZECPZJUFUGJUEUIUGC
      QUHBCDEFHRUIUGCSTBCDEFHUAECUBUCUD $.
  $}

  ${
    $d f x G $.  $d f x H $.  $d f x I $.  $d f x y K $.  $d f x S $.
    $d f x y W $.
    diaglb.g $e |- G = ( glb ` K ) $.
    diaglb.h $e |- H = ( LHyp ` K ) $.
    diaglb.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( Partial isomorphism A of a lattice glb.  (Contributed by NM,
       3-Dec-2013.)  (New usage is discouraged.) $)
    diaglbN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ dom I /\ S =/= (/) ) )
       -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
      ( vf vy chlt wcel wa wss cfv wbr wb eqid cdm c0 wne cv ciin ctrl cple cbs
      cltrn simpl ccla hlclat ad2antrr crab sseq2d biimpa adantrr ssrab2 syl6ss
      diadm clatglbcl syl2anc simprr n0 sylib clat hllat ad3antrrr adantr ssel2
      wex adantlr adantll diaeldm mpbid simpld lhpbase ad3antlr simpr clatglble
      syl3anc simprd lattrd exlimddv diaelval syl12anc r19.28zv ad2antll simpll
      wral ralbidva trlcl clatleglb pm5.32da 3bitr4rd cvv vex eliin ax-mp bitrd
      syl6bbr eqrdv ) FMNZGDNZOZBEUAZPZBUBUCZOZOZKBCQZEQZABAUDZEQZUEZXJKUDZXLNZ
      XPGFUIQQZNZXPGFUFQQZQZXKFUGQZRZOZXPXONZXJXEXKFUHQZNZXKGYBRZXQYDSXEXIUJXJF
      UKNZBYFPZYGXCYIXDXIFULZUMXJBLUDGYBRZLYFUNZYFXEXGBYMPZXHXEXGYNXEXFYMBLYFDE
      FYBMGYFTZYBTZIJUTUOUPUQYLLYFURUSZYFBCFYOHVAVBZXJXMBNZYHAXJXHYSAVKXEXGXHVC
      ABVDVEXJYSOZYFFYBXKXMGYOYPXCFVFNXDXIYSFVGVHXJYGYSYRVIYTXMYFNZXMGYBRZYTXMX
      FNZUUAUUBOZXIYSUUCXEXGYSUUCXHBXFXMVJVLVMXEUUCUUDSXIYSYFDEFYBMGXMYOYPIJVNU
      MVOZVPXDGYFNXCXIYSYFDFGYOIVQVRYTYIYJYSXKXMYBRXCYIXDXIYSYKVHXJYJYSYQVIXJYS
      VSYFBCFYBXMYOYPHVTWAYTUUAUUBUUEWBWCWDYFXTXRXPDEFYBMGXKYOYPIXRTZXTTZJWEWFX
      JYDXPXNNZABWJZYEXJXSYAXMYBRZOZABWJZXSUUJABWJZOZUUIYDXHUULUUNSXEXGXSUUJABW
      GWHXJUUHUUKABYTXEUUDUUHUUKSXEXIYSWIUUEYFXTXRXPDEFYBMGXMYOYPIUUFUUGJWEVBWK
      XJXSYCUUMXJXSOYIYAYFNZYJYCUUMSXCYIXDXIXSYKVHXEXSUUOXIYFXTXRXPDFGYOIUUFUUG
      WLVLXJYJXSYQVIAYFBCFYBYAYOYPHWMWAWNWOXPWPNYEUUISKWQAXPBXNWPWRWSXAWTXB $.
  $}

  ${
    $d x H $.  $d x I $.  $d x K $.  $d x W $.  $d x X $.  $d x Y $.
    diam.m $e |- ./\ = ( meet ` K ) $.
    diam.h $e |- H = ( LHyp ` K ) $.
    diam.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( Partial isomorphism A of a lattice meet.  (Contributed by NM,
       5-Dec-2013.)  (New usage is discouraged.) $)
    diameetN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. dom I /\ Y e. dom I ) )
       -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( vx chlt wcel wa cfv wceq eqid diadmclN adantl fveq2 cdm co cglb cv ciin
      cpr cin cbs simpll adantrr adantrl meetval syl3anc fveq2d wss simpl prssi
      c0 wne prnzg ad2antrl diaglbN syl12anc iinxprg 3eqtrd ) CLMZEAMZNZFBUAZMZ
      GVIMZNZNZFGDUBZBOFGUFZCUCOZOZBOZKVOKUDZBOZUEZFBOZGBOZUGZVMVNVQBVMVFFCUHOZ
      MZGWEMZVNVQPVFVGVLUIVHVJWFVKWEABCLEFWEQZIJRUJVHVKWGVJWEABCLEGWHIJRUKLWEVP
      CDFGWHVPQZHULUMUNVMVHVOVIUOZVOURUSZVRWAPVHVLUPVLWJVHFGVIUQSVJWKVHVKFGVIUT
      VAKVOVPABCEWIIJVBVCVLWAWDPVHKFGVTWBWCVIVIVSFBTVSGBTVDSVE $.

    $( Inverse partial isomorphism A of an intersection.  (Contributed by NM,
       6-Dec-2013.)  (New usage is discouraged.) $)
    diainN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. ran I /\ Y e. ran I ) )
       -> ( X i^i Y ) = ( I ` ( ( `' I ` X ) ./\ ( `' I ` Y ) ) ) ) $=
      ( chlt wcel wa crn cfv cin wceq diacnvclN f1ocnvfv2 syl2anc ccnv co simpl
      cdm adantrr adantrl diameetN syl12anc diaf11N adantr simprl simprr eqtr2d
      wf1o ineq12d ) CKLEALMZFBNZLZGUQLZMZMZFBUAZOZGVBOZDUBBOZVCBOZVDBOZPZFGPVA
      UPVCBUDZLZVDVILZVEVHQUPUTUCUPURVJUSABCEFIJRUEUPUSVKURABCEGIJRUFABCDEVCVDH
      IJUGUHVAVFFVGGVAVIUQBUNZURVFFQUPVLUTABCEIJUIUJZUPURUSUKVIUQFBSTVAVLUSVGGQ
      VMUPURUSULVIUQGBSTUOUM $.
  $}

  ${
    $d y x H $.  $d y x I $.  $d y x K $.  $d y x S $.  $d y x W $.
    diaintcl.h $e |- H = ( LHyp ` K ) $.
    diaintcl.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( The intersection of partial isomorphism A closed subspaces is a closed
       subspace.  (Contributed by NM, 3-Dec-2013.)
       (New usage is discouraged.) $)
    diaintclN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ ran I /\ S =/= (/) ) )
       -> |^| S e. ran I ) $=
      ( vy vx chlt wcel wa wss cfv wceq adantr syl wb wi wbr crn c0 wne ccnv cv
      cima cres ciin cint wfn cdm wf1o diaf11N cnvimass fnssres sylancl fniinfv
      f1ofn df-ima wfo f1ofo simprl foimacnv syl2anc syl5eqr inteqd eqtrd simpl
      cglb a1i simprr n0 sylib wrex sselda ad2antrr fvelrnb mpbid wfun fvimacnv
      wex f1ofun sylan ne0i syl6bi eleq1 biimprd imim1d syl9 com24 imp rexlimdv
      ex mpd exlimddv eqid diaglbN syl12anc fvres iineq2i syl6eqr cbs cple ccla
      hlclat crab diadm ssrab2 syl6eqss syl5ss clatglbcl clat ad3antrrr lhpbase
      hllat ad3antlr syl6ss simpr clatglble syl3anc sseli adantl diaeldm simprd
      syl5sseq lattrd mpbir2and diaclN syldan eqeltrrd ) DJKZEBKZLZACUAZMZAUBUC
      ZLZLZHCUDAUFZHUEZCYSUGZNZUHZAUIZYNYRUUCUUAUAZUIZUUDYRUUAYSUJZUUCUUFOYRCCU
      KZUJZYSUUHMZUUGYRUUHYNCULZUUIYMUUKYQBCDEFGUMZPUUHYNCURZQCAUNZUUHYSCUOUPHY
      SUUAUQQYRUUEAYRUUECYSUFZACYSUSYRUUHYNCUTZYOUUOAOYMUUPYQYMUUKUUPUULUUHYNCV
      AQPYMYOYPVBZUUHYNACVCVDVEVFVGYRYSDVINZNZCNZUUCYNYRUUTHYSYTCNZUHZUUCYRYMUU
      JYSUBUCZUUTUVBOYMYQVHUUJYRUUNVJYRYTAKZUVCHYRYPUVDHWAYMYOYPVKHAVLVMYRUVDLZ
      IUEZCNZYTOZIUUHVNZUVCUVEYTYNKZUVIYRAYNYTUUQVOUVEUUIUVJUVIRUVEUUKUUIYMUUKY
      QUVDUULVPUUMQIUUHYTCVQQVRUVEUVHUVCIUUHYRUVDUVFUUHKZUVHUVCSSYRUVHUVKUVDUVC
      YRUVKUVGAKZUVCSZUVHUVDUVCSYRUVKUVMYRUVKLUVLUVFYSKZUVCYRCVSZUVKUVLUVNRYMUV
      OYQYMUUKUVOUULUUHYNCWBQPUVFACVTWCYSUVFWDWEWMUVHUVDUVLUVCUVHUVLUVDUVGYTAWF
      WGWHWIWJWKWLWNWOZHYSUURBCDEUURWPZFGWQWRHYSUUBUVAYTYSCWSWTXAYMYQUUSUUHKZUU
      TYNKYRUVRUUSDXBNZKZUUSEDXCNZTZYRDXDKZYSUVSMZUVTYKUWCYLYQDXEZVPYRYSUUHUVSU
      UNYMUUHUVSMYQYMUUHUVFEUWATZIUVSXFZUVSIUVSBCDUWAJEUVSWPZUWAWPZFGXGZUWFIUVS
      XHZXIPXJZUVSYSUURDUWHUVQXKVDZYRYTYSKZUWBHYRUVCUWNHWAUVPHYSVLVMYRUWNLZUVSD
      UWAUUSYTEUWHUWIYKDXLKYLYQUWNDXOXMYRUVTUWNUWMPYRYSUVSYTUWLVOYLEUVSKYKYQUWN
      UVSBDEUWHFXNXPUWOUWCUWDUWNUUSYTUWATYKUWCYLYQUWNUWEXMYRUWDUWNYRYSUWGUVSYRU
      UHYSUWGUUNYMUUHUWGOYQUWJPYEUWKXQPYRUWNXRUVSYSUURDUWAYTUWHUWIUVQXSXTUWOYTU
      VSKZYTEUWATZUWOYTUUHKZUWPUWQLZUWNUWRYRYSUUHYTUUNYAYBYMUWRUWSRYQUWNUVSBCDU
      WAJEYTUWHUWIFGYCVPVRYDYFWOYMUVRUVTUWBLRYQUVSBCDUWAJEUUSUWHUWIFGYCPYGBCDEU
      USFGYHYIYJYJ $.
  $}

  ${
    $d x H $.  $d x I $.  $d x K $.  $d x S $.  $d x W $.
    diasslss.h $e |- H = ( LHyp ` K ) $.
    diasslss.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    diasslss.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    diasslss.s $e |- S = ( LSubSp ` U ) $.
    $( The partial isomorphism A maps to subspaces of partial vector space A.
       (Contributed by NM, 17-Jan-2014.)  (New usage is discouraged.) $)
    diasslssN $p |- ( ( K e. HL /\ W e. H ) -> ran I C_ S ) $=
      ( vx chlt wcel wa crn cv ccnv cfv cdm eqid wf1o wceq f1ocnvfv2 sylan cple
      diaf11N cbs wbr diacnvclN wb adantr mpbid dialss syldan eqeltrrd ex ssrdv
      diaeldm ) ELMFCMNZKDOZAUSKPZUTMZVAAMUSVBNZVADQRZDRZVAAUSDSZUTDUAVBVEVAUBC
      DEFGIUFVFUTVADUCUDUSVBVDEUGRZMVDFEUERZUHNZVEAMVCVDVFMZVICDEFVAGIUIUSVJVIU
      JVBVGCDEVHLFVDVGTZVHTZGIURUKULVGABCDEVHFVDVKVLGHIJUMUNUOUPUQ $.
  $}

  ${
    $d f K $.  $d f W $.  $d f X $.
    diassdva.b $e |- B = ( Base ` K ) $.
    diassdva.l $e |- .<_ = ( le ` K ) $.
    diassdva.h $e |- H = ( LHyp ` K ) $.
    diassdva.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    diassdva.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    diassdva.v $e |- V = ( Base ` U ) $.
    $( The partial isomorphism A maps to a set of vectors in partial vector
       space A. (Contributed by NM, 1-Jan-2014.)
       (New usage is discouraged.) $)
    diassdvaN $p |- ( ( ( K e. Y /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( I ` X ) C_ V ) $=
      ( vf wcel wa cfv wbr cv ctrl crab eqid diaval ssrab2 wceq dvavbase adantr
      cltrn syl5sseqr eqsstrd ) EJRHCRSZIARIHFUASZSZIDTQUBHEUCTTZTIFUAZQHEUKTTZ
      UDZGAUQUSQCDEFJHIKLMUSUEZUQUENUFUPUSUTGURQUSUGUNGUSUHUOUSBCEGHJMVAOPUIUJU
      LUM $.
  $}

  ${
    $d s .<_ $.  $d s E $.  $d g s F $.  $d g s H $.  $d g s K $.  $d g s R $.
    $d g s T $.  $d g s W $.
    dia1dim.h $e |- H = ( LHyp ` K ) $.
    dia1dim.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia1dim.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia1dim.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dia1dim.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( Two expressions for the 1-dimensional subspaces of partial vector space
       A (when ` F ` is a nonzero vector i.e. non-identity translation).
       Remark after Lemma L in [Crawley] p. 120 line 21.  (Contributed by NM,
       15-Oct-2013.)  (Revised by Mario Carneiro, 22-Jun-2014.) $)
    dia1dim $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( I ` ( R ` F ) ) = { g | E. s e. E g = ( s ` F ) } ) $=
      ( chlt wcel wa cfv cv cple wbr crab wceq wrex cab simpl eqid trlcl diaval
      cbs trlle syl12anc dva1dim eqtr4d ) HPQIFQRZEBQZRZEASZGSZCTZASUSHUASZUBCB
      UCZVAEJTSUDJDUECUFURUPUSHUKSZQUSIVBUBUTVCUDUPUQUGVDABEFHIVDUHZKLMUIABEFHV
      BIVBUHZKLMULVDABCFGHVBPIUSVEVFKLMOUJUMABCDEFHVBIJVFKLMNUNUO $.
  $}

  ${
    $d g s F $.  $d g s H $.  $d g s K $.  $d g s N $.  $d g s R $.
    $d g s T $.  $d g s U $.  $d g s W $.
    dia1dim2.h $e |- H = ( LHyp ` K ) $.
    dia1dim2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia1dim2.r $e |- R = ( ( trL ` K ) ` W ) $.
    dva1dim2.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dia1dim2.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dva1dim2.n $e |- N = ( LSpan ` U ) $.
    $( Two expressions for a 1-dimensional subspace of partial vector space A
       (when ` F ` is a nonzero vector i.e. non-identity translation).
       (Contributed by NM, 15-Jan-2014.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dia1dim2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( I ` ( R ` F ) ) = ( N ` { F } ) ) $=
      ( vg vs wcel cfv wceq chlt wa cv cvsca co csca cbs cab ctendo csn dvabase
      wrex eqid adantr rexeqdv dvavsca anass1rs eqeq2d bitrd abbidv clmod clvec
      rexbidva dvalvec lveclmod simpr dvavbase eleqtrrd lspsn syl2anc 3eqtr4rd
      syl dia1dim ) GUARIERUBZDBRZUBZPUCZQUCZDCUDSZUEZTZQCUFSZUGSZULZPUHZVQDVRS
      ZTZQIGUISSZULZPUHDUJHSZDASFSVPWDWIPVPWDWAQWHULWIVPWAQWCWHVNWCWHTVOWCCWHWB
      EGIUAJWHUMZMWBUMZWCUMZUKUNUOVPWAWGQWHVPVRWHRZUBVTWFVQVNWNVOVTWFTVRBVSCWHD
      EGUAIJKWKMVSUMZUPUQURVCUSUTVPCVARZDCUGSZRWJWETVPCVBRZWPVNWRVOCEGIJMVDUNCV
      EVLVPDBWQVNVOVFVNWQBTVOBCEGWQIUAJKMWQUMZVGUNVHPVSQWBWCHWQCDWLWMWSWOOVIVJA
      BPWHDEFGIQJKLWKNVMVK $.
  $}

  ${
    dia1dimid.h $e |- H = ( LHyp ` K ) $.
    dia1dimid.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia1dimid.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia1dimid.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    $( A vector (translation) belongs to the 1-dim subspace it generates.
       (Contributed by NM, 8-Sep-2014.) $)
    dia1dimid $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> F e. ( I ` ( R ` F ) ) ) $=
      ( chlt wcel wa csn cdveca cfv clspn clmod eqid cbs clvec dvalvec lveclmod
      syl adantr dvavbase eleq2d biimpar lspsnid syl2anc dia1dim2 eleqtrrd ) FL
      MGDMNZCBMZNZCCOGFPQQZRQZQZCAQEQUPUQSMZCUQUAQZMZCUSMUNUTUOUNUQUBMUTUQDFGHU
      QTZUCUQUDUEUFUNVBUOUNVABCBUQDFVAGLHIVCVATZUGUHUIURVAUQCVDURTZUJUKABUQCDEF
      URGHIJVCKVEULUM $.
  $}

  ${
    dia2dimlem1.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem1.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem1.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem1.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem1.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem1.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem1.q $e |- Q = ( ( P .\/ U ) ./\ ( ( F ` P ) .\/ V ) ) $.
    dia2dimlem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem1.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem1.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem1.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem1.f $e |- ( ph -> ( F e. T /\ ( F ` P ) =/= P ) ) $.
    dia2dimlem1.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem1.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem1.ru $e |- ( ph -> ( R ` F ) =/= U ) $.
    $( Lemma for ~ dia2dim .  Show properties of the auxiliary atom ` Q ` .
       Part of proof of Lemma M in [Crawley] p. 121 line 3.  (Contributed by
       NM, 8-Sep-2014.) $)
    dia2dimlem1 $p |- ( ph -> ( Q e. A /\ -. Q .<_ W ) ) $=
      ( wcel wbr wn co cfv chlt wne wa simpld trlat syl3anc ltrnel simprd trlle
      syl2anc clat cbs hllat syl eqid atbase lhpbase latjle12 syl13anc mpbi2and
      wb hlatjcl lattr mpan2d mtod nbrne2 necomd jca wceq adantr hlatlej2 simpr
      wi breqtrrd hlatexch2 syl131anc lattrd necon3bd trlval2 hlatlej1 atmod3i1
      mpd ex oveq2d cp1 lhpjat2 col hlol olm11 eqtrd hlatjcom breqtrd syl333anc
      ps-2c syl5eqel latmle1 syl5eqbr latlem12 biimpd mpand imp lhpmat atmod4i1
      cp0 oveq1d olj02 3eqtr3d cal hlatl atcmp mpbid latmle2 eqtr3d necon3ad )
      ADBULZDOLUMZUNZADCGJUOZCHUPZNJUOZMUOZBUCAKUQULZCBULZHEUPZBULZGBULZYOBULZN
      BULZCYTGJUOZLUMZUNZYONURZUSYNYPURZYOCYTJUOZLUMZNUUELUMZUSYQBULAYROIULZUDU
      TZAYSCOLUMZUNZUGUTZAYRUUMUSZYSUUPUSZHFULZYOCURZUSUUAUDUGUHBCEFHIKLOPSTUAU
      BVAVBZAUUBGOLUMZUEUTZAUUCYOOLUMUNZAUURUUTUUSUUCUVEUSZUDAUUTUVAUHUTZUGBCFH
      IKLOPSTUAVCVBZUTZAUUDNOLUMZUFUTZAUUGUUHAUUFUUOAYSUUPUGVDZAUUFUUEOLUMZUUOA
      YTOLUMZUVCUVMAUURUUTUVNUDUVGEFHIKLOPTUAUBVEVFAUUBUVCUEVDZAKVGULZYTKVHUPZU
      LZGUVQULZOUVQULZUVNUVCUSUVMVQAYRUVPUUNKVIVJZAUUAUVRUVBBUVQYTKUVQVKZSVLVJA
      UUBUVSUVDBUVQGKUWBSVLVJZAUUMUVTAYRUUMUDVDUVQIKOUWBTVMVJZUVQJKLYTGOUWBPQVN
      VOVPAUVPCUVQULZUUEUVQULZUVTUUFUVMUSUUOWIUWAAYSUWEUUQBUVQCKUWBSVLVJZAYRUUA
      UUBUWFUUNUVBUVDBUVQJKYTGUWBQSVRVBUWDUVQKLCUUEOUWBPVSVOVTWAANYOAUVJUVENYOU
      RAUUDUVJUFVDZAUUCUVEUVHVDNYOOLWBVFWCWDAUUPUUIUVLAUUOYNYPAYNYPWEZUUOAUWIUS
      ZUVQKLCNGJUOZOUWBPAUVPUWIUWAWFAUWEUWIUWGWFAUWKUVQULZUWIAYRUUDUUBUWLUUNUVK
      UVDBUVQJKNGUWBQSVRVBWFAUVTUWIUWDWFUWJNYNLUMZCUWKLUMZUWJNYPYNLANYPLUMZUWIA
      YRUUCUUDUWOUUNUVIUVKBYONJKLPQSWGVBWFAUWIWHWJAUWMUWNWIZUWIAYRUUDYSUUBNGURU
      WPUUNUVKUUQUVDAGNUJWCBNCGJKLPQSWKWLWFWRAUWKOLUMZUWIAUVJUVCUWQUWHUVOAUVPNU
      VQULZUVSUVTUVJUVCUSUWQVQUWAAUUDUWRUVKBUVQNKUWBSVLVJZUWCUWDUVQJKLNGOUWBPQV
      NVOVPWFWMWSWNWRAUUKUULAYOCYOJUOZUUJLAYRYSUUCYOUWTLUMUUNUUQUVIBCYOJKLPQSWG
      VBAUUJCUWTOMUOZJUOZUWTAYTUXACJAUURUUTUUSYTUXAWEUDUVGUGBCEFHIJKLMOPQRSTUAU
      BWOVBWTAUXBUWTCOJUOZMUOZUWTAYRYSUWTUVQULZUVTCUWTLUMZUXBUXDWEUUNUUQAYRYSUU
      CUXEUUNUUQUVIBUVQJKCYOUWBQSVRVBZUWDAYRYSUUCUXFUUNUUQUVIBCYOJKLPQSWPVBBUVQ
      CJKLMUWTOUWBPQRSWQWLAUXDUWTKXAUPZMUOZUWTAUXCUXHUWTMAUURUUSUXCUXHWEUDUGBCU
      XHIJKLOPQUXHVKZSTXBVFWTAKXCULZUXEUXIUWTWEAYRUXKUUNKXDVJZUXGUVQUXHKMUWTUWB
      RUXJXEVFXFXFXFWJAYTUWKLUMZUULAYTGNJUOZUWKLUIAYRUUBUUDUXNUWKWEUUNUVDUVKBJK
      GNQSXGVBXHAYRUUAUUDUUBYTGURUXMUULWIUUNUVBUVKUVDUKBYTNGJKLPQSWKWLWRWDBCYTG
      YONJKLMPQRSXJXIXKZAGNURYMUJAYLGNAYLGNWEAYLUSZDGNUXPDGLUMZDGWEZUXPDYNOMUOZ
      GLAYLDUXSLUMZADYNLUMZYLUXTADYQYNLUCAUVPYNUVQULZYPUVQULZYQYNLUMUWAAYRYSUUB
      UYBUUNUUQUVDBUVQJKCGUWBQSVRVBZAYRUUCUUDUYCUUNUVIUVKBUVQJKYONUWBQSVRVBZUVQ
      KLMYNYPUWBPRXLVBXMAUYAYLUSZUXTAUVPDUVQULZUYBUVTUYFUXTVQUWAAYKUYGUXOBUVQDK
      UWBSVLVJZUYDUWDUVQKLMDYNOUWBPRXNVOXOXPXQAUXSGWEYLACOMUOZGJUOZKXTUPZGJUOZU
      XSGAUYIUYKGJAUURUUSUYIUYKWEUDUGBCIKLMOUYKPRUYKVKZSTXRVFYAAYRUUBUWEUVTUVCU
      YJUXSWEUUNUVDUWGUWDUVOBUVQGJKLMCOUWBPQRSXSWLAUXKUVSUYLGWEUXLUWCUVQJKGUYKU
      WBQUYMYBVFYCWFXHUXPKYDULZYKUUBUXQUXRVQAUYNYLAYRUYNUUNKYEVJWFZAYKYLUXOWFZA
      UUBYLUVDWFBDGKLPSYFVBYGUXPDNLUMZDNWEZUXPDYPOMUOZNLAYLDUYSLUMZADYPLUMZYLUY
      TADYQYPLUCAUVPUYBUYCYQYPLUMUWAUYDUYEUVQKLMYNYPUWBPRYHVBXMAVUAYLUSZUYTAUVP
      UYGUYCUVTVUBUYTVQUWAUYHUYEUWDUVQKLMDYPOUWBPRXNVOXOXPXQAUYSNWEYLAYOOMUOZNJ
      UOZUYKNJUOZUYSNAVUCUYKNJAUURUVFVUCUYKWEUDUVHBYOIKLMOUYKPRUYMSTXRVFYAAYRUU
      DYOUVQULZUVTUVJVUDUYSWEUUNUVKAUUCVUFUVIBUVQYOKUWBSVLVJUWDUWHBUVQNJKLMYOOU
      WBPQRSXSWLAUXKUWRVUENWEUXLUWSUVQJKNUYKUWBQUYMYBVFYCWFXHUXPUYNYKUUDUYQUYRV
      QUYOUYPAUUDYLUVKWFBDNKLPSYFVBYGYIWSYJWRWD $.
  $}

  ${
    dia2dimlem2.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem2.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem2.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem2.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem2.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem2.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem2.q $e |- Q = ( ( P .\/ U ) ./\ ( ( F ` P ) .\/ V ) ) $.
    dia2dimlem2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem2.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem2.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem2.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem2.f $e |- ( ph -> ( F e. T /\ ( F ` P ) =/= P ) ) $.
    dia2dimlem2.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem2.rv $e |- ( ph -> ( R ` F ) =/= V ) $.
    dia2dimlem2.g $e |- ( ph -> G e. T ) $.
    dia2dimlem2.gv $e |- ( ph -> ( G ` P ) = Q ) $.
    $( Lemma for ~ dia2dim .  Define a translation ` G ` whose trace is atom
       ` U ` .  Part of proof of Lemma M in [Crawley] p. 121 line 4.
       (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem2 $p |- ( ph -> ( R ` G ) = U ) $=
      ( cfv wbr wceq co clat wcel cbs chlt simpld hllat syl eqid atbase latlej2
      wn syl3anc wb hlatjcl latleeqm2 mpbid wne wi wa trlat hlatexch2 syl131anc
      mpd trlval2 oveq1d ltrnel simprd lhpbase atmod4i1 hlatjass syl13anc eqtrd
      breqtrd latjcl latmcl latmlem2 eqbrtrrd syl6eq hlatlej1 atmod3i1 col hlol
      oveq2d latmassOLD eqcomd cal hlatl cp0 cplt cops hlop 0ltat syl2anc hlpos
      cpo op0cl trlcl pltletr mp2and opltn0 neneqd wo trlator0 orcomd ord atcmp
      ) AGIEUNZAGYDMUOZGYDUPZAGCGKUQZCCHUNZOKUQZKUQZPNUQZNUQZYDMAYGGNUQZGYLMAGY
      GMUOZYMGUPZALURUSZCLUTUNZUSZGYQUSZYNALVAUSZYPAYTPJUSZUEVBZLVCVDZACBUSZYRA
      UUDCPMUOVHZUHVBZBYQCLYQVEZTVFVDZAGBUSZYSAUUIGPMUOUFVBZBYQGLUUGTVFVDZYQKLM
      CGUUGQRVGVIAYPYSYGYQUSZYNYOVJUUCUUKAYTUUDUUIUULUUBUUFUUJBYQKLCGUUGRTVKVIZ
      YQLMNGYGUUGQSVLVIVMAGYKMUOZYMYLMUOZAGHEUNZOKUQZYKMAUUPGOKUQMUOZGUUQMUOZUJ
      AYTUUPBUSZUUIOBUSZUUPOVNUURUUSVOUUBAYTUUAVPZUUDUUEVPZHFUSZYHCVNZVPUUTUEUH
      UIBCEFHJLMPQTUAUBUCVQVIUUJAUVAOPMUOZUGVBZUKBUUPGOKLMQRTVRVSVTAUUQCYHKUQZP
      NUQZOKUQZYKAUUPUVIOKAUVBUVDUVCUUPUVIUPUEAUVDUVEUIVBZUHBCEFHJKLMNPQRSTUAUB
      UCWAVIWBAUVJUVHOKUQZPNUQZYKAYTUVAUVHYQUSZPYQUSZUVFUVJUVMUPUUBUVGAYTUUDYHB
      USZUVNUUBUUFAUVPYHPMUOVHZAUVBUVDUVCUVPUVQVPUEUVKUHBCFHJLMPQTUAUBWCVIVBZBY
      QKLCYHUUGRTVKVIAUUAUVOAYTUUAUEWDYQJLPUUGUAWEVDZAUVAUVFUGWDBYQOKLMNUVHPUUG
      QRSTWFVSAUVLYJPNAYTUUDUVPUVAUVLYJUPUUBUUFUVRUVGBCYHOKLRTWGWHWBWIWIWJAYPYS
      YKYQUSZUULUUNUUOVOUUCUUKAYPYJYQUSZUVOUVTUUCAYPYRYIYQUSZUWAUUCUUHAYTUVPUVA
      UWBUUBUVRUVGBYQKLYHOUUGRTVKVIZYQKLCYIUUGRWKVIZUVSYQLNYJPUUGSWLVIUUMYQLMNG
      YKYGUUGQSWMWHVTWNAYDYLAYDCCIUNZKUQZPNUQZYLAUVBIFUSZUVCYDUWGUPUEULUHBCEFIJ
      KLMNPQRSTUAUBUCWAVIAUWGCYGYINUQZKUQZPNUQZYLAUWFUWJPNAUWEUWICKAUWEDUWIUMUD
      WOWTWBAUWKYGYJNUQZPNUQZYLAUWJUWLPNAYTUUDUULUWBCYGMUOZUWJUWLUPUUBUUFUUMUWC
      AYTUUDUUIUWNUUBUUFUUJBCGKLMQRTWPVIBYQCKLMNYGYIUUGQRSTWQVSWBALWRUSZUULUWAU
      VOUWMYLUPAYTUWOUUBLWSVDUUMUWDUVSYQLNYGYJPUUGSXAWHWIWIWIXBWJZALXCUSZUUIYDB
      USZYEYFVJAYTUWQUUBLXDVDUUJAYDLXEUNZUPZVHUWRAYDUWSAUWSYDLXFUNZUOZYDUWSVNZA
      UWSGUXAUOZYEUXBALXGUSZUUIUXDAYTUXEUUBLXHVDZUUJBGUXALUWSUWSVEZUXAVEZTXIXJU
      WPALXLUSZUWSYQUSZYSYDYQUSZUXDYEVPUXBVOAYTUXIUUBLXKVDAUXEUXJUXFYQLUWSUUGUX
      GXMVDUUKAUVBUWHUXKUEULYQEFIJLPUUGUAUBUCXNXJZYQUXALMUWSGYDUUGQUXHXOWHXPAUX
      EUXKUXBUXCVJUXFUXLYQUXALYDUWSUUGUXHUXGXQXJVMXRAUWTUWRAUWRUWTAUVBUWHUWRUWT
      XSUEULBEFIJLPUWSUXGTUAUBUCXTXJYAYBVTBGYDLMQTYCVIVMXB $.
  $}

  ${
    dia2dimlem3.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem3.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem3.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem3.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem3.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem3.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem3.q $e |- Q = ( ( P .\/ U ) ./\ ( ( F ` P ) .\/ V ) ) $.
    dia2dimlem3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem3.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem3.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem3.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem3.f $e |- ( ph -> ( F e. T /\ ( F ` P ) =/= P ) ) $.
    dia2dimlem3.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem3.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem3.ru $e |- ( ph -> ( R ` F ) =/= U ) $.
    dia2dimlem3.rv $e |- ( ph -> ( R ` F ) =/= V ) $.
    dia2dimlem3.d $e |- ( ph -> D e. T ) $.
    dia2dimlem3.dv $e |- ( ph -> ( D ` Q ) = ( F ` P ) ) $.
    $( Lemma for ~ dia2dim .  Define a translation ` D ` whose trace is atom
       ` V ` .  Part of proof of Lemma M in [Crawley] p. 121 line 5.
       (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem3 $p |- ( ph -> ( R ` D ) = V ) $=
      ( cfv wbr wceq co chlt wcel simpld wn wa wne ltrnel syl3anc hlatlej2 clat
      cbs wi hllat syl eqid atbase hlatjcl trlat latmlem2 syl13anc mpd hlatjcom
      breqtrd hlatexch2 syl131anc wb latleeqm2 dia2dimlem1 trlval2 a1i hlatlej1
      mpbid oveq12d atmod4i1 hlatj32 oveq1d 3eqtrd latjcl simprd lhpbase latm32
      col hlol eqtr2d 3brtr3d cal hlatl cp0 cplt cops 0ltat syl2anc hlpos op0cl
      hlop cpo trlcl pltletr mp2and opltn0 neneqd wo trlator0 orcomd ord eqcomd
      atcmp ) AOCFUPZAOYGMUQZOYGURZAIFUPZHKUSZONUSZYKDIUPZOKUSZNUSZOYGMAOYNMUQZ
      YLYOMUQZALUTVAZYMBVAZOBVAZYPAYRPJVAZUEVBZAYSYMPMUQVCZAYRUUAVDZIGVAZDBVAZD
      PMUQVCZVDZYSUUCVDUEAUUEYMDVEZUIVBZUHBDGIJLMPQTUAUBVFVGVBZAYTOPMUQUGVBZBYM
      OKLMQRTVHVGALVIVAZOLVJUPZVAZYNUUNVAZYKUUNVAZYPYQVKAYRUUMUUBLVLVMZAYTUUOUU
      LBUUNOLUUNVNZTVOVMZAYRYSYTUUPUUBUUKUULBUUNKLYMOUUSRTVPVGZAYRYJBVAZHBVAZUU
      QUUBAUUDUUHUUEUUIVDUVBUEUHUIBDFGIJLMPQTUAUBUCVQVGZAUVCHPMUQZUFVBZBUUNKLYJ
      HUUSRTVPVGZUUNLMNOYNYKUUSQSVRVSVTAOYKMUQZYLOURZAYJOHKUSZMUQZUVHAYJHOKUSZU
      VJMUJAYRUVCYTUVLUVJURUUBUVFUULBKLHORTWAVGWBAYRUVBYTUVCYJHVEUVKUVHVKUUBUVD
      UULUVFULBYJOHKLMQRTWCWDVTAUUMUUOUUQUVHUVIWEUURUUTUVGUUNLMNOYKUUSQSWFVGWKA
      YGEECUPZKUSZPNUSZYOAUUDCGVAZEBVAEPMUQVCVDYGUVOURUEUNABDEFGHIJKLMNOPQRSTUA
      UBUCUDUEUFUGUHUIUJUKULWGBEFGCJKLMNPQRSTUAUBUCWHVGAUVODYMKUSZHKUSZYNNUSZPN
      USZUVRPNUSZYNNUSZYOAUVNUVSPNAUVNDHKUSZYNNUSZYMKUSZUWCYMKUSZYNNUSZUVSAEUWD
      UVMYMKEUWDURAUDWIUOWLAYRYSUWCUUNVAZUUPYMYNMUQZUWEUWGURUUBUUKAYRUUFUVCUWHU
      UBAUUFUUGUHVBZUVFBUUNKLDHUUSRTVPVGUVAAYRYSYTUWIUUBUUKUULBYMOKLMQRTWJVGBUU
      NYMKLMNUWCYNUUSQRSTWMWDAUWFUVRYNNAYRUUFUVCYSUWFUVRURUUBUWJUVFUUKBDHYMKLRT
      WNVSWOWPWOALXAVAZUVRUUNVAZUUPPUUNVAZUVTUWBURAYRUWKUUBLXBVMAUUMUVQUUNVAZHU
      UNVAZUWLUURAYRUUFYSUWNUUBUWJUUKBUUNKLDYMUUSRTVPVGZAUVCUWOUVFBUUNHLUUSTVOV
      MUUNKLUVQHUUSRWQVGUVAAUUAUWMAYRUUAUEWRUUNJLPUUSUAWSVMZUUNLNUVRYNPUUSSWTVS
      AUWAYKYNNAYKUVQPNUSZHKUSZUWAAYJUWRHKAUUDUUEUUHYJUWRURUEUUJUHBDFGIJKLMNPQR
      STUAUBUCWHVGWOAYRUVCUWNUWMUVEUWSUWAURUUBUVFUWPUWQAUVCUVEUFWRBUUNHKLMNUVQP
      UUSQRSTWMWDXCWOWPXCXDZALXEVAZYTYGBVAZYHYIWEAYRUXAUUBLXFVMUULAYGLXGUPZURZV
      CUXBAYGUXCAUXCYGLXHUPZUQZYGUXCVEZAUXCOUXEUQZYHUXFALXIVAZYTUXHAYRUXIUUBLXN
      VMZUULBOUXELUXCUXCVNZUXEVNZTXJXKUWTALXOVAZUXCUUNVAZUUOYGUUNVAZUXHYHVDUXFV
      KAYRUXMUUBLXLVMAUXIUXNUXJUUNLUXCUUSUXKXMVMUUTAUUDUVPUXOUEUNUUNFGCJLPUUSUA
      UBUCXPXKZUUNUXELMUXCOYGUUSQUXLXQVSXRAUXIUXOUXFUXGWEUXJUXPUUNUXELYGUXCUUSU
      XLUXKXSXKWKXTAUXDUXBAUXBUXDAUUDUVPUXBUXDYAUEUNBFGCJLPUXCUXKTUAUBUCYBXKYCY
      DVTBOYGLMQTYFVGWKYE $.
  $}

  ${
    dia2dimlem4.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem4.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem4.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem4.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem4.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem4.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem4.f $e |- ( ph -> F e. T ) $.
    dia2dimlem4.g $e |- ( ph -> G e. T ) $.
    dia2dimlem4.gv $e |- ( ph -> ( G ` P ) = Q ) $.
    dia2dimlem4.d $e |- ( ph -> D e. T ) $.
    dia2dimlem4.dv $e |- ( ph -> ( D ` Q ) = ( F ` P ) ) $.
    $( Lemma for ~ dia2dim .  Show that the composition (sum) of translations
       (vectors) ` G ` and ` D ` equals ` F ` .  Part of proof of Lemma M in
       [Crawley] p. 121 line 5.  (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem4 $p |- ( ph -> ( D o. G ) = F ) $=
      ( chlt wcel wa ccom wbr wn wceq ltrnco syl3anc simpld ltrncoval syl121anc
      cfv fveq2d 3eqtrd cdlemd syl311anc ) AJUDUELIUEUFZCHUGZFUEZGFUEDBUEZDLKUH
      UIZUFDVBUPZDGUPZUJVBGUJQAVACFUEZHFUEZVCQUBTFCHIJLOPUKULSRAVFDHUPZCUPZECUP
      VGAVAVHVIVDVFVKUJQUBTAVDVERUMBDFCHIJKLMNOPUNUOAVJECUAUQUCURBDFVBGIJKLMNOP
      USUT $.
  $}

  ${
    dia2dimlem5.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem5.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem5.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem5.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem5.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem5.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem5.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem5.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem5.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem5.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem5.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem5.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem5.q $e |- Q = ( ( P .\/ U ) ./\ ( ( F ` P ) .\/ V ) ) $.
    dia2dimlem5.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem5.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem5.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem5.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem5.f $e |- ( ph -> ( F e. T /\ ( F ` P ) =/= P ) ) $.
    dia2dimlem5.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem5.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem5.ru $e |- ( ph -> ( R ` F ) =/= U ) $.
    dia2dimlem5.rv $e |- ( ph -> ( R ` F ) =/= V ) $.
    dia2dimlem5.g $e |- ( ph -> G e. T ) $.
    dia2dimlem5.gv $e |- ( ph -> ( G ` P ) = Q ) $.
    dia2dimlem5.d $e |- ( ph -> D e. T ) $.
    dia2dimlem5.dv $e |- ( ph -> ( D ` Q ) = ( F ` P ) ) $.
    $( Lemma for ~ dia2dim .  The sum of vectors ` G ` and ` D ` belongs to the
       sum of the subspaces generated by them.  Thus, ` F = ( G o. D ) `
       belongs to the subspace sum.  Part of proof of Lemma M in [Crawley]
       p. 121 line 5.  (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem5 $p |- ( ph -> F e. ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( cfv co cplusg ccom chlt wcel wceq eqid dvavadd syl12anc wne dia2dimlem4
      wa simpld eqtr2d csubg clmod wss clvec dvalvec lveclmod lsssssubg syl cbs
      3syl wbr atbase simprd dialss sseldd csn dia1dim2 dia2dimlem3 fveq2d eqss
      eqsstr3d dvavbase eleqtrrd lspsnel5 mpbird dia2dimlem2 lsmelvali syl22anc
      syl2anc sylib eqeltrd cabel lmodabl lsmcom syl3anc eleqtrd ) AKTNVIZJNVIZ
      EVJZYAXTEVJZAKCLUBVKVIZVJZYBAYECLVLZKAPVMVNUAMVNWAZCIVNZLIVNZYEYFVOUPVGVE
      YDIUBCLMPVMUAUGUHUJYDVPZVQVRABCDFIKLMPQUAUCUFUGUHUPUSAKIVNDKVIDVSUTWBVEVF
      VGVHVTWCAXTUBWDVIZVNZYAYKVNZCXTVNZLYAVNZYEYBVNAHYKXTAUBWEVNZHYKWFAYGUBWGV
      NYPUPUBMPUAUGUJWHUBWIWMZHUBUKWJWKZAYGTPWLVIZVNZTUAQWNZXTHVNUPATBVNZYTAUUB
      UUAURWBBYSTPYSVPZUFWOWKAUUBUUAURWPYSHUBMNPQUATUUCUCUGUJUNUKWQVRZWRZAHYKYA
      YRAYGJYSVNZJUAQWNZYAHVNUPAJBVNZUUFAUUHUUGUQWBBYSJPUUCUFWOWKAUUHUUGUQWPYSH
      UBMNPQUAJUUCUCUGUJUNUKWQVRZWRZAYNCWSSVIZXTWFAUUKCGVIZNVIZXTAYGYHUUMUUKVOU
      PVGGIUBCMNPSUAUGUHUIUJUNUMWTXLAUUMXTWFZXTUUMWFZAUUMXTVOUUNUUOWAAUULTNABCD
      FGIJKMOPQRTUAUCUDUEUFUGUHUIUOUPUQURUSUTVAVBVCVDVGVHXAXBUUMXTXCXMWBXDAHXTS
      UBWLVIZUBCUUPVPZUKUMYQUUDACIUUPVGAYGUUPIVOUPIUBMPUUPUAVMUGUHUJUUQXEWKZXFX
      GXHAYOLWSSVIZYAWFAUUSLGVIZNVIZYAAYGYIUVAUUSVOUPVEGIUBLMNPSUAUGUHUIUJUNUMW
      TXLAUVAYAWFZYAUVAWFZAUVAYAVOUVBUVCWAAUUTJNABDFGIJKLMOPQRTUAUCUDUEUFUGUHUI
      UOUPUQURUSUTVAVDVEVFXIXBUVAYAXCXMWBXDAHYASUUPUBLUUQUKUMYQUUIALIUUPVEUURXF
      XGXHYDEXTYAUBCLYJULXJXKXNAUBXOVNZYLYMYBYCVOAYPUVDYQUBXPWKUUEUUJEXTYAUBULX
      QXRXS $.
  $}

  ${
    $d d g .(+) $.  $d d g .<_ $.  $d d g A $.  $d d g F $.  $d d g I $.
    $d d g K $.  $d d g P $.  $d d g Q $.  $d d g T $.  $d d g U $.
    $d d g V $.  $d d g W $.  $d d g ph $.
    dia2dimlem6.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem6.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem6.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem6.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem6.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem6.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem6.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem6.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem6.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem6.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem6.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem6.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem6.q $e |- Q = ( ( P .\/ U ) ./\ ( ( F ` P ) .\/ V ) ) $.
    dia2dimlem6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem6.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem6.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem6.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem6.f $e |- ( ph -> ( F e. T /\ ( F ` P ) =/= P ) ) $.
    dia2dimlem6.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem6.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem6.ru $e |- ( ph -> ( R ` F ) =/= U ) $.
    dia2dimlem6.rv $e |- ( ph -> ( R ` F ) =/= V ) $.
    $( Lemma for ~ dia2dim .  Eliminate auxiliary translations ` G ` and
       ` D ` .  (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem6 $p |- ( ph -> F e. ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( vd vg cv cfv wceq wrex co wcel chlt wa wbr wn dia2dimlem1 simpld ltrnel
      wne syl3anc cdleme50ex wi 3ad2ant1 simp21 simp22 simp23 simp3 dia2dimlem5
      w3a 3exp 3expd rexlimdv mpd ) AEVCVEZVFCJVFZVGZVCHVHZJILVFRLVFDVIVJZANVKV
      JSKVJVLZEBVJESOVMVNVLZWNBVJWNSOVMVNVLZWPUNABCEFHIJKMNOPRSUAUBUCUDUEUFUGUM
      UNUOUPUQURUSUTVAVOZAWRJHVJZCBVJCSOVMVNVLZWTUNAXBWNCVRZURVPUQBCHJKNOSUAUDU
      EUFVQVSBEWNHVCKNOSUAUDUEUFVTVSAWOWQVCHACVDVEZVFEVGZVDHVHZWMHVJZWOWQWAZWAZ
      AWRXCWSXGUNUQXABCEHVDKNOSUAUDUEUFVTVSAXFXJVDHAXEHVJZXFXHXIAXKXFXHWHZWOWQA
      XLWOWHBWMCDEFGHIJXEKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMAXLWRWOUNWBAXLIBVJ
      ISOVMVLWOUOWBAXLRBVJRSOVMVLWOUPWBAXLXCWOUQWBAXLXBXDVLWOURWBAXLJFVFZIRMVIO
      VMWOUSWBAXLIRVRWOUTWBAXLXMIVRWOVAWBAXLXMRVRWOVBWBAXKXFXHWOWCAXKXFXHWOWDAX
      KXFXHWOWEAXLWOWFWGWIWJWKWLWKWL $.
  $}

  ${
    dia2dimlem7.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem7.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem7.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem7.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem7.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem7.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem7.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem7.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem7.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem7.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem7.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem7.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem7.q $e |- Q = ( ( P .\/ U ) ./\ ( ( F ` P ) .\/ V ) ) $.
    dia2dimlem7.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem7.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem7.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem7.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dia2dimlem7.f $e |- ( ph -> F e. T ) $.
    dia2dimlem7.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem7.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem7.ru $e |- ( ph -> ( R ` F ) =/= U ) $.
    dia2dimlem7.rv $e |- ( ph -> ( R ` F ) =/= V ) $.
    $( Lemma for ~ dia2dim .  Eliminate ` ( F `` P ) =/= P ` condition.
       (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem7 $p |- ( ph -> F e. ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( cfv co wcel wceq cid cbs cres chlt wa wbr wn wb ltrnideq syl3anc wi c0g
      eqid dva0g syl clmod clvec dvalvec lveclmod simpld atbase simprd syl12anc
      dialss lsmcl lss0cl syl2anc eqeltrrd eleq1a sylbird imp wne adantr anim1i
      3syl dia2dimlem6 pm2.61dane ) AJILVCZRLVCZDVDZVEZCJVCZCAXHCVFZXGAXIJVGNVH
      VCZVIZVFZXGANVJVESKVEVKZJHVEZCBVECSOVLVMVKZXLXIVNUNURUQBXJCHJKNOSXJVSZUAU
      DUEUFVOVPAXKXFVEXLXGVQATVRVCZXKXFAXMXQXKVFUNXJHTKNSXQXPUEUFUHXQVSZVTWAATW
      BVEZXFGVEZXQXFVEAXMTWCVEXSUNTKNSUEUHWDTWEXAZAXSXDGVEZXEGVEZXTYAAXMIXJVEZI
      SOVLZYBUNAIBVEZYDAYFYEUOWFBXJINXPUDWGWAAYFYEUOWHXJGTKLNOSIXPUAUEUHULUIWJW
      IAXMRXJVEZRSOVLZYCUNARBVEZYGAYIYHUPWFBXJRNXPUDWGWAAYIYHUPWHXJGTKLNOSRXPUA
      UEUHULUIWJWIDGXDXETUIUJWKVPGXFTXQXRUIWLWMWNXKXFJWOWAWPWQAXHCWRZVKBCDEFGHI
      JKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMAXMYJUNWSAYFYEVKYJUOWSAYIYHVKYJUPWSA
      XOYJUQWSAXNYJURWTAJFVCZIRMVDOVLYJUSWSAIRWRYJUTWSAYKIWRYJVAWSAYKRWRYJVBWSX
      BXC $.
  $}

  ${
    dia2dimlem8.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem8.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem8.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem8.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem8.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem8.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem8.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem8.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem8.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem8.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem8.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem8.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem8.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem8.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem8.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem8.f $e |- ( ph -> F e. T ) $.
    dia2dimlem8.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem8.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem8.ru $e |- ( ph -> ( R ` F ) =/= U ) $.
    dia2dimlem8.rv $e |- ( ph -> ( R ` F ) =/= V ) $.
    $( Lemma for ~ dia2dim .  Eliminate no-longer used auxiliary atoms ` P `
       and ` Q ` .  (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem8 $p |- ( ph -> F e. ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( coc cfv co eqid chlt wcel wa wbr wn lhpocnel syl dia2dimlem7 ) ABQLUSUT
      ZUTZCVLGKVAVLHUTPKVANVAZDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVMVBUKULUMAL
      VCVDQIVDVEVLBVDVLQMVFVGVEUKBILMVKQSVKVBUBUCVHVIUNUOUPUQURVJ $.
  $}

  ${
    dia2dimlem9.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem9.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem9.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem9.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem9.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem9.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem9.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem9.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem9.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem9.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem9.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem9.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem9.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem9.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem9.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem9.f $e |- ( ph -> F e. T ) $.
    dia2dimlem9.rf $e |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $.
    dia2dimlem9.uv $e |- ( ph -> U =/= V ) $.
    $( Lemma for ~ dia2dim .  Eliminate ` ( R `` F ) =/= U ` , ` V `
       conditions.  (Contributed by NM, 8-Sep-2014.) $)
    dia2dimlem9 $p |- ( ph -> F e. ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( cfv co wcel wceq csubg chlt clvec clmod dvalvec lveclmod lsssssubg 4syl
      wa wss cbs wbr simpld eqid atbase syl simprd dialss sseldd lsmub1 syl2anc
      syl12anc adantr dia1dimid adantl eleqtrd lsmub2 simprl simprr dia2dimlem8
      fveq2 wne pm2.61da2ne ) AHGJUQZPJUQZCURZUSHDUQZGWQPAWQGUTZVIZWNWPHAWNWPVJ
      ZWRAWNRVAUQZUSZWOXAUSZWTAEXAWNALVBUSQIUSVIZRVCUSRVDUSEXAVJUKRILQUCUFVERVF
      ERUGVGVHZAXDGLVKUQZUSZGQMVLZWNEUSUKAGBUSZXGAXIXHULVMBXFGLXFVNZUBVOVPAXIXH
      ULVQXFERIJLMQGXJSUCUFUJUGVRWBVSZAEXAWOXEAXDPXFUSZPQMVLZWOEUSUKAPBUSZXLAXN
      XMUMVMBXFPLXJUBVOVPAXNXMUMVQXFERIJLMQPXJSUCUFUJUGVRWBVSZCWNWORUHVTWAWCWSH
      WQJUQZWNAHXPUSZWRAXDHFUSZXQUKUNDFHIJLQUCUDUEUJWDWAZWCWRXPWNUTAWQGJWKWEWFV
      SAWQPUTZVIZWOWPHYAXBXCWOWPVJAXBXTXKWCAXCXTXOWCCWNWORUHWGWAYAHXPWOAXQXTXSW
      CXTXPWOUTAWQPJWKWEWFVSAWQGWLZWQPWLZVIZVIBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUG
      UHUIUJAXDYDUKWCAXIXHVIYDULWCAXNXMVIYDUMWCAXRYDUNWCAWQGPKURMVLYDUOWCAGPWLY
      DUPWCAYBYCWHAYBYCWIWJWM $.
  $}

  ${
    dia2dimlem10.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem10.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem10.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem10.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem10.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem10.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem10.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem10.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem10.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem10.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem10.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem10.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem10.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem10.f $e |- ( ph -> F e. T ) $.
    dia2dimlem10.fe $e |- ( ph -> F e. ( I ` ( U .\/ V ) ) ) $.
    $( Lemma for ~ dia2dim .  Convert membership in closed subspace
       ` ( I `` ( U .\/ V ) ) ` to a lattice ordering.  (Contributed by NM,
       8-Sep-2014.) $)
    dia2dimlem10 $p |- ( ph -> ( R ` F ) .<_ ( U .\/ V ) ) $=
      ( cfv co wss wbr csn chlt wcel wceq dia1dim2 syl2anc clvec clmod lveclmod
      wa dvalvec 3syl cbs simpld eqid hlatjcl syl3anc simprd clat wb syl atbase
      hllat lhpbase latjle12 syl13anc mpbi2and syl12anc lspsnel5a eqsstrd trlcl
      dialss trlle diaord syl122anc mpbid ) AGCULZIULZFNJUMZIULZUNZWLWNLUOZAWMG
      UPMULZWOAKUQURZOHURZVEZGEURZWMWRUSUGUJCEPGHIKMOTUAUBUCUFUEUTVAADWOMPGUDUE
      AXAPVBURPVCURUGPHKOTUCVFPVDVGAXAWNKVHULZURZWNOLUOZWODURUGAWSFBURZNBURZXDA
      WSWTUGVIZAXFFOLUOZUHVIZAXGNOLUOZUIVIZBXCJKFNXCVJZRSVKVLZAXIXKXEAXFXIUHVMA
      XGXKUIVMAKVNURZFXCURZNXCURZOXCURZXIXKVEXEVOAWSXOXHKVRVPAXFXPXJBXCFKXMSVQV
      PAXGXQXLBXCNKXMSVQVPAWTXRAWSWTUGVMXCHKOXMTVSVPXCJKLFNOXMQRVTWAWBZXCDPHIKL
      OWNXMQTUCUFUDWGWCUKWDWEAXAWLXCURZWLOLUOZXDXEWPWQVOUGAXAXBXTUGUJXCCEGHKOXM
      TUAUBWFVAAXAXBYAUGUJCEGHKLOQTUAUBWHVAXNXSXCHIKLOWLWNXMQTUFWIWJWK $.
  $}

  ${
    dia2dimlem11.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem11.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem11.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem11.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem11.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem11.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem11.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem11.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem11.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem11.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem11.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem11.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem11.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem11.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem11.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    dia2dimlem11.f $e |- ( ph -> F e. T ) $.
    dia2dimlem11.uv $e |- ( ph -> U =/= V ) $.
    dia2dimlem11.fe $e |- ( ph -> F e. ( I ` ( U .\/ V ) ) ) $.
    $( Lemma for ~ dia2dim .  Convert ordering hypothesis on ` R `` F ` to
       subspace membership ` F e. ( I `` ( U .\/ V ) ) ` .  (Contributed by NM,
       8-Sep-2014.) $)
    dia2dimlem11 $p |- ( ph -> F e. ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( dia2dimlem10 dia2dimlem9 ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
      UMUNABDEFGHIJKLMOPQRSTUBUCUDUEUFUGUIUJUKULUMUNUPUQUOUR $.
  $}

  ${
    $d f .(+) $.  $d f .\/ $.  $d f I $.  $d f U $.  $d f V $.  $d f ph $.
    dia2dimlem12.l $e |- .<_ = ( le ` K ) $.
    dia2dimlem12.j $e |- .\/ = ( join ` K ) $.
    dia2dimlem12.m $e |- ./\ = ( meet ` K ) $.
    dia2dimlem12.a $e |- A = ( Atoms ` K ) $.
    dia2dimlem12.h $e |- H = ( LHyp ` K ) $.
    dia2dimlem12.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dia2dimlem12.r $e |- R = ( ( trL ` K ) ` W ) $.
    dia2dimlem12.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dimlem12.s $e |- S = ( LSubSp ` Y ) $.
    dia2dimlem12.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dimlem12.n $e |- N = ( LSpan ` Y ) $.
    dia2dimlem12.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dimlem12.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dimlem12.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dimlem12.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    ${
      dia2dimlem12.uv $e |- ( ph -> U =/= V ) $.
      $( Lemma for ~ dia2dim .  Obtain subset relation.  (Contributed by NM,
         8-Sep-2014.) $)
      dia2dimlem12 $p |- ( ph
              -> ( I ` ( U .\/ V ) ) C_ ( ( I ` U ) .(+) ( I ` V ) ) ) $=
        ( vf co cfv cv wcel chlt cbs wbr wss simpld eqid hlatjcl syl3anc simprd
        wa clat wb hllat syl atbase lhpbase latjle12 syl13anc mpbi2and syl12anc
        diass sseld w3a 3ad2ant1 simp3 wne simp2 dia2dimlem11 3exp mpdd ssrdv )
        AUNGOJUOZIUPZGIUPOIUPCUOZAUNUQZWKURZWMFURZWMWLURZAWKFWMAKUSURZPHURZVHZW
        JKUTUPZURZWJPLVAZWKFVBUJAWQGBURZOBURZXAAWQWRUJVCZAXCGPLVAZUKVCZAXDOPLVA
        ZULVCZBWTJKGOWTVDZSUAVEVFAXFXHXBAXCXFUKVGAXDXHULVGAKVIURZGWTURZOWTURZPW
        TURZXFXHVHXBVJAWQXKXEKVKVLAXCXLXGBWTGKXJUAVMVLAXDXMXIBWTOKXJUAVMVLAWRXN
        AWQWRUJVGWTHKPXJUBVNVLWTJKLGOPXJRSVOVPVQWTFHIKLUSPWJXJRUBUCUIVSVRVTAWNW
        OWPAWNWOWABCDEFGWMHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIAWNWSWOUJWBAWNXCXFVHWO
        UKWBAWNXDXHVHWOULWBAWNWOWCAWNGOWDWOUMWBAWNWOWEWFWGWHWI $.
    $}

    $( Lemma for ~ dia2dim .  Eliminate ` U =/= V ` condition.  (Contributed by
       NM, 8-Sep-2014.) $)
    dia2dimlem13 $p |- ( ph
            -> ( I ` ( U .\/ V ) ) C_ ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( co cfv wss wceq wa oveq2 adantl chlt simpld wbr hlatjidm syl2anc adantr
      wcel eqtr3d fveq2d ssid syl6eqss csubg clmod clvec lveclmod 3syl cbs eqid
      dvalvec atbase syl simprd dialss syl12anc lsssubg lsmidm oveq2d sylan9req
      fveq2 sseqtrd wne simpr dia2dimlem12 pm2.61dane ) AGOJUMZIUNZGIUNZOIUNZCU
      MZUOGOAGOUPZUQZWOWPWRWTWOWPWPWTWNGIWTGGJUMZWNGWSXAWNUPAGOGJURUSAXAGUPZWSA
      KUTVFZGBVFZXBAXCPHVFZUJVAAXDGPLVBZUKVAZBJKGSUAVCVDVEVGVHWPVIVJAWSWPWPWPCU
      MZWRAWPQVKUNVFZXHWPUPAQVLVFZWPEVFZXIAXCXEUQZQVMVFXJUJQHKPUBUEVRQVNVOAXLGK
      VPUNZVFZXFXKUJAXDXNXGBXMGKXMVQZUAVSVTAXDXFUKWAXMEQHIKLPGXORUBUEUIUFWBWCEW
      PQUFWDVDCWPQUGWEVTWSWPWQWPCGOIWHWFWGWIAGOWJZUQBCDEFGHIJKLMNOPQRSTUAUBUCUD
      UEUFUGUHUIAXLXPUJVEAXDXFUQXPUKVEAOBVFOPLVBUQXPULVEAXPWKWLWM $.
  $}

  ${
    dia2dim.l $e |- .<_ = ( le ` K ) $.
    dia2dim.j $e |- .\/ = ( join ` K ) $.
    dia2dim.a $e |- A = ( Atoms ` K ) $.
    dia2dim.h $e |- H = ( LHyp ` K ) $.
    dia2dim.y $e |- Y = ( ( DVecA ` K ) ` W ) $.
    dia2dim.pl $e |- .(+) = ( LSSum ` Y ) $.
    dia2dim.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dia2dim.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dia2dim.u $e |- ( ph -> ( U e. A /\ U .<_ W ) ) $.
    dia2dim.v $e |- ( ph -> ( V e. A /\ V .<_ W ) ) $.
    $( A two-dimensional subspace of partial vector space A is closed, or
       equivalently, the isomorphism of a join of two atoms is a subset of the
       subspace sum of the isomorphisms of each atom (and thus they are equal,
       as shown later for the full vector space H).  (Contributed by NM,
       9-Sep-2014.) $)
    dia2dim $p |- ( ph
            -> ( I ` ( U .\/ V ) ) C_ ( ( I ` U ) .(+) ( I ` V ) ) ) $=
      ( ctrl cfv clss cltrn cmee clspn eqid dia2dimlem13 ) ABCKHUCUDUDZLUEUDZKH
      UFUDUDZDEFGHIHUGUDZLUHUDZJKLMNUNUIOPUMUIUKUIQULUIRUOUISTUAUBUJ $.
  $}

  $c DVecH $.

  $( Extend class notation with constructed full vector space H. $)
  cdvh $a class DVecH $.

  ${
    $d f g h k s w $.
    $( Define constructed full vector space H. (Contributed by NM,
       17-Oct-2013.) $)
    df-dvech $a |- DVecH = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      ( { <. ( Base ` ndx ) ,
             ( ( ( LTrn ` k ) ` w ) X. ( ( TEndo ` k ) ` w ) ) >. ,
          <. ( +g ` ndx ) ,
             ( f e. ( ( ( LTrn ` k ) ` w ) X. ( ( TEndo ` k ) ` w ) ) ,
               g e. ( ( ( LTrn ` k ) ` w ) X. ( ( TEndo ` k ) ` w ) )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
               ( h e. ( ( LTrn ` k ) ` w ) |->
                 ( ( ( 2nd ` f ) ` h ) o. ( ( 2nd ` g ) ` h ) ) ) >. ) >. ,
          <. ( Scalar ` ndx ) , ( ( EDRing ` k ) ` w ) >. } u. {
          <. ( .s ` ndx ) , ( s e. ( ( TEndo ` k ) ` w ) ,
               f e. ( ( ( LTrn ` k ) ` w ) X. ( ( TEndo ` k ) ` w ) )
           |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) >. } ) ) ) $.
  $}

  ${
    $d w D $.  $d a b w E $.  $d f g k w H $.  $d f g h k s w K $.
    $d a b c h w T $.  $d a b c f g h s w W $.  $d f g X $.
    dvhset.h $e |- H = ( LHyp ` K ) $.
    $( The constructed full vector space H for a lattice ` K ` .  (Contributed
       by NM, 17-Oct-2013.)  (Revised by Mario Carneiro, 22-Jun-2014.) $)
    dvhfset $p |- ( K e. V -> ( DVecH ` K ) = ( w e. H |->
      ( { <. ( Base ` ndx ) ,
             ( ( ( LTrn ` K ) ` w ) X. ( ( TEndo ` K ) ` w ) ) >. ,
          <. ( +g ` ndx ) ,
             ( f e. ( ( ( LTrn ` K ) ` w ) X. ( ( TEndo ` K ) ` w ) ) ,
               g e. ( ( ( LTrn ` K ) ` w ) X. ( ( TEndo ` K ) ` w ) )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
               ( h e. ( ( LTrn ` K ) ` w ) |->
                 ( ( ( 2nd ` f ) ` h ) o. ( ( 2nd ` g ) ` h ) ) ) >. ) >. ,
          <. ( Scalar ` ndx ) , ( ( EDRing ` K ) ` w ) >. } u. {
          <. ( .s ` ndx ) , ( s e. ( ( TEndo ` K ) ` w ) ,
               f e. ( ( ( LTrn ` K ) ` w ) X. ( ( TEndo ` K ) ` w ) )
           |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) >. } ) ) ) $=
      ( vk cvv cfv cnx cv cop cmpt cmpt2 clh fveq2 opeq2d wcel cbs cltrn ctendo
      cdvh cxp cplusg c1st ccom c2nd csca cedring ctp csn cun wceq elex syl6eqr
      cvsca fveq1d xpeq12d mpteq1d mpt2eq123dv tpeq123d eqidd uneq12d mpteq12dv
      sneqd df-dvech fvex eqeltri mptex fvmpt syl ) FGUAFKUAFUELAEMUBLZANZFUCLZ
      LZVPFUDLZLZUFZOZMUGLZBCWAWABNZUHLZCNZUHLUIZDVRDNZWDUJLZLWHWFUJLLUIZPZOZQZ
      OZMUKLZVPFULLZLZOZUMZMUSLZHBVTWAWEHNZLXAWIUIOZQZOZUNZUOZPZUPFGUQJFAJNZRLZ
      VOVPXHUCLZLZVPXHUDLZLZUFZOZWCBCXNXNWGDXKWJPZOZQZOZWOVPXHULLZLZOZUMZWTHBXM
      XNXBQZOZUNZUOZPXGKUEXHFUPZAXIYGEXFYHXIFRLZEXHFRSIURYHYCWSYFXEYHXOWBXSWNYB
      WRYHXNWAVOYHXKVRXMVTYHVPXJVQXHFUCSUTZYHVPXLVSXHFUDSUTZVAZTYHXRWMWCYHBCXNX
      NXQWAWAWLYLYLYHXPWKWGYHDXKVRWJYJVBTVCTYHYAWQWOYHVPXTWPXHFULSUTTVDYHYEXDYH
      YDXCWTYHHBXMXNXBVTWAXBYKYLYHXBVEVCTVHVFVGABCDJHVIAEXFEYIKIFRVJVKVLVMVN $.

    dvhset.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhset.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhset.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    dvhset.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    $( The constructed full vector space H for a lattice ` K ` .  (Contributed
       by NM, 17-Oct-2013.)  (Revised by Mario Carneiro, 22-Jun-2014.) $)
    dvhset $p |- ( ( K e. X /\ W e. H ) -> U =
      ( { <. ( Base ` ndx ) , ( T X. E ) >. ,
          <. ( +g ` ndx ) , ( f e. ( T X. E ) , g e. ( T X. E )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
               ( h e. T |->
                 ( ( ( 2nd ` f ) ` h ) o. ( ( 2nd ` g ) ` h ) ) ) >. ) >. ,
          <. ( Scalar ` ndx ) , D >. } u. {
          <. ( .s ` ndx ) , ( s e. E , f e. ( T X. E )
           |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) >. } ) ) $=
      ( cfv cv cop vw wcel cnx cbs cltrn ctendo cxp cplusg c1st ccom c2nd cmpt2
      cmpt csca cedring ctp cvsca csn cun cdvh dvhfset fveq1d syl5eq wceq fveq2
      syl6eqr xpeq12d opeq2d mpteq1d mpt2eq123dv tpeq123d eqidd sneqd eqid tpex
      uneq12d snex unex fvmpt sylan9eq ) IKUBZJHUBCJUAHUCUDRZUASZIUERZRZWCIUFRZ
      RZUGZTZUCUHRZDEWHWHDSZUIRZESZUIRUJZFWEFSZWKUKRZRWOWMUKRRUJZUMZTZULZTZUCUN
      RZWCIUORZRZTZUPZUCUQRZLDWGWHWLLSZRXHWPUJTZULZTZURZUSZUMZRZWBBGUGZTZWJDEXP
      XPWNFBWQUMZTZULZTZXBATZUPZXGLDGXPXIULZTZURZUSZWACJIUTRZRXOQWAJYHXNUADEFHI
      KLMVAVBVCUAJXMYGHXNWCJVDZXFYCXLYFYIWIXQXAYAXEYBYIWHXPWBYIWEBWGGYIWEJWDRBW
      CJWDVENVFZYIWGJWFRGWCJWFVEOVFZVGZVHYIWTXTWJYIDEWHWHWSXPXPXSYLYLYIWRXRWNYI
      FWEBWQYJVIVHVJVHYIXDAXBYIXDJXCRAWCJXCVEPVFVHVKYIXKYEYIXJYDXGYILDWGWHXIGXP
      XIYKYLYIXIVLVJVHVMVPXNVNYCYFXQYAYBVOYEVQVRVSVT $.
  $}

  ${
    $d f g H $.  $d f g h s K $.  $d f g h s W $.  $d f g X $.
    dvhsca.h $e |- H = ( LHyp ` K ) $.
    dvhsca.d $e |- D = ( ( EDRing ` K ) ` W ) $.
    dvhsca.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhsca.f $e |- F = ( Scalar ` U ) $.
    $( The ring of scalars of the constructed full vector space H. (Contributed
       by NM, 22-Jun-2014.) $)
    dvhsca $p |- ( ( K e. X /\ W e. H ) -> F = D ) $=
      ( vf vg vh vs csca cfv cnx cop cv wcel wa cbs ctendo cxp cplusg c1st ccom
      cltrn c2nd cmpt cmpt2 ctp cvsca csn cun eqid dvhset cvv wceq cedring fvex
      fveq2d eqeltri lmodsca ax-mp 3eqtr4g ) EGUAFDUAUBZBPQRUCQFEUIQQZFEUDQQZUE
      ZSRUFQLMVKVKLTZUGQZMTZUGQUHNVINTZVLUJQZQVOVNUJQQUHUKSULZSRPQASUMRUNQOLVJV
      KVMOTZQVRVPUHSULZSUOUPZPQZCAVHBVTPAVIBLMNVJDEFGOHVIUQVJUQIJURVCKAUSUAAWAU
      TAFEVAQZQUSIFWBVBVDVKVQVSAVTUSVTUQVEVFVG $.
  $}

  ${
    $d f g H $.  $d a b c f g h s K $.  $d a b c f g h s W $.  $d f g X $.
    dvhbase.h $e |- H = ( LHyp ` K ) $.
    dvhbase.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhbase.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhbase.f $e |- F = ( Scalar ` U ) $.
    dvhbase.c $e |- C = ( Base ` F ) $.
    $( The ring base set of the constructed full vector space H. (Contributed
       by NM, 29-Oct-2013.)  (Revised by Mario Carneiro, 22-Jun-2014.) $)
    dvhbase $p |- ( ( K e. X /\ W e. H ) -> C = E ) $=
      ( wcel wa cedring cfv cbs eqid dvhsca fveq2d syl5eq cltrn erngbase eqtrd
      ) FHNGENOZAGFPQQZRQZCUFADRQUHMUFDUGRUGBDEFGHIUGSZKLTUAUBUHUGGFUCQQZCEFHGI
      UJSJUIUHSUDUE $.
  $}

  ${
    $d s t E $.  $d f g H $.  $d f g h s t K $.  $d h T $.  $d f g V $.
    $d f g h s t W $.
    dvhfplusr.h $e |- H = ( LHyp ` K ) $.
    dvhfplusr.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhfplusr.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhfplusr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhfplusr.f $e |- F = ( Scalar ` U ) $.
    dvhfplusr.p $e |- .+ = ( s e. E ,
           t e. E |-> ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    dvhfplusr.s $e |- .+b = ( +g ` F ) $.
    $( Ring addition operation for the constructed full vector space H.
       (Contributed by NM, 29-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvhfplusr $p |- ( ( K e. V /\ W e. H ) -> .+b = .+ ) $=
      ( wcel wa cplusg cfv ccom cmpt cmpt2 cedring eqid dvhsca fveq2d erngfplus
      cv eqtrd 3eqtr4g ) JKUALIUAUBZHUCUDZMAGGFDFUMZMUMUDURAUMUDUEUFUGZCBUPUQLJ
      UHUDUDZUCUDZUSUPHUTUCUTEHIJLKNUTUIZQRUJUKAUTVADFGIJKLMNOPVBVAUIULUNTSUO
      $.
  $}

  ${
    $d s t E $.  $d f g H $.  $d f g h s t K $.  $d h T $.  $d f g V $.
    $d f g h s t W $.
    dvhfmul.h $e |- H = ( LHyp ` K ) $.
    dvhfmul.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhfmul.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhfmul.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhfmul.f $e |- F = ( Scalar ` U ) $.
    dvhfmul.m $e |- .x. = ( .r ` F ) $.
    $( Ring multiplication operation for the constructed full vector space H.
       (Contributed by NM, 29-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvhfmulr $p |- ( ( K e. V /\ W e. H ) -> .x. = ( s e. E ,
           t e. E |-> ( s o. t ) ) ) $=
      ( wcel cfv cmulr wa cedring ccom cmpt2 eqid dvhsca fveq2d syl5eq erngfmul
      cv eqtrd ) HIRJGRUAZCJHUBSSZTSZKAEEKUJAUJUCUDULCFTSUNQULFUMTUMDFGHJILUMUE
      ZOPUFUGUHAUMBUNEGHIJKLMNUOUNUEUIUK $.

    $d r E $.  $d r K $.  $d r s R $.  $d r s S $.  $d r W $.
    $( Ring multiplication operation for the constructed full vector space H.
       (Contributed by NM, 29-Oct-2013.)  (Revised by Mario Carneiro,
       22-Jun-2014.) $)
    dvhmulr $p |- ( ( ( K e. V /\ W e. H ) /\ ( R e. E /\ S e. E ) )
        -> ( R .x. S ) = ( R o. S ) ) $=
      ( vr vs wcel wa co cv ccom cmpt2 dvhfmulr oveqd cvv wceq coexg coeq1 eqid
      coeq2 ovmpt2g mpd3an3 sylan9eq ) IJTKHTUAZAFTZBFTZUAABDUBABRSFFRUCZSUCZUD
      ZUEZUBZABUDZUQDVCABSCDEFGHIJKRLMNOPQUFUGURUSVEUHTVDVEUIABFFUJRSABFFVBVEVC
      AVAUDUHUTAVAUKVABAUMVCULUNUOUP $.
  $}

  ${
    $d f g H $.  $d f g h s t K $.  $d h T $.  $d f g h s t W $.  $d f g X $.
    dvhvbase.h $e |- H = ( LHyp ` K ) $.
    dvhvbase.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhvbase.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhvbase.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhvbase.v $e |- V = ( Base ` U ) $.
    $( The vectors (vector base set) of the constructed full vector space H are
       all translations (for a fiducial co-atom ` W ` ).  (Contributed by NM,
       2-Nov-2013.)  (Revised by Mario Carneiro, 22-Jun-2014.) $)
    dvhvbase $p |- ( ( K e. X /\ W e. H ) -> V = ( T X. E ) ) $=
      ( vf cbs cfv cnx cop cv cvv vg vh vs wcel cxp cplusg c1st ccom c2nd cmpt2
      wa cmpt csca cedring ctp cvsca csn cun eqid dvhset fveq2d wceq cltrn fvex
      eqeltri ctendo xpex lmodbase ax-mp 3eqtr4g ) EHUDGDUDUKZBOPQOPACUEZRQUFPN
      UAVLVLNSZUGPZUASZUGPUHUBAUBSZVMUIPZPVPVOUIPPUHULRUJZRQUMPGEUNPPZRUOQUPPUC
      NCVLVNUCSZPVTVQUHRUJZRUQURZOPZFVLVKBWBOVSABNUAUBCDEGHUCIJKVSUSLUTVAMVLTUD
      VLWCVBACAGEVCPZPTJGWDVDVECGEVFPZPTKGWEVDVEVGVLVRWAVSWBTWBUSVHVIVJ $.

    $( Vector membership in the constructed full vector space H. (Contributed
       by NM, 20-Feb-2014.) $)
    dvhelvbasei $p |- ( ( ( K e. X /\ W e. H ) /\ ( F e. T /\ S e. E ) )
      -> <. F , S >. e. V ) $=
      ( wcel wa cop cxp opelxpi adantl wceq dvhvbase adantr eleqtrrd ) GJPIFPQZ
      EBPADPQZQEARZBDSZHUGUHUIPUFEABDTUAUFHUIUBUGBCDFGHIJKLMNOUCUDUE $.
  $}

  ${
    dvhvaddval.a $e |- .+ = ( f e. ( T X. E ) , g e. ( T X. E )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
              ( ( 2nd ` f ) .+^ ( 2nd ` g ) ) >. ) $.
    $d f g h i E $.  $d f g h i .+^ $.  $d f g h i T $.
    $( Change bound variables to isolate them later.  (Contributed by NM,
       3-Nov-2013.) $)
    dvhvaddcbv $p |- .+ = ( h e. ( T X. E ) , i e. ( T X. E )
           |-> <. ( ( 1st ` h ) o. ( 1st ` i ) ) ,
              ( ( 2nd ` h ) .+^ ( 2nd ` i ) ) >. ) $=
      ( cv c1st cfv ccom c2nd co cop cmpt2 weq fveq2 opeq12d cxp cbvmpt2v eqtri
      coeq1d oveq1d coeq2d oveq2d ) ADECHUAZUHDJZKLZEJZKLZMZUINLZUKNLZBOZPZQFGU
      HUHFJZKLZGJZKLZMZURNLZUTNLZBOZPZQIDEFGUHUHUQVFUSULMZVCUOBOZPDFRZUMVGUPVHV
      IUJUSULUIURKSUDVIUNVCUOBUIURNSUETEGRZVGVBVHVEVJULVAUSUKUTKSUFVJUOVDVCBUKU
      TNSUGTUBUC $.

    $d h i F $.  $d h i G $.
    $( The vector sum operation for the constructed full vector space H.
       (Contributed by NM, 26-Oct-2013.) $)
    dvhvaddval $p |- ( ( F e. ( T X. E ) /\ G e. ( T X. E ) )
        -> ( F .+ G ) = <. ( ( 1st ` F ) o. ( 1st ` G ) ) ,
               ( ( 2nd ` F ) .+^ ( 2nd ` G ) ) >. ) $=
      ( vh vi cv c1st cfv ccom c2nd co cop wceq fveq2 cxp coeq1d oveq1d opeq12d
      coeq2d oveq2d dvhvaddcbv opex ovmpt2 ) JKGHCFUAZUJJLZMNZKLZMNZOZUKPNZUMPN
      ZBQZRGMNZHMNZOZGPNZHPNZBQZRAUSUNOZVBUQBQZRUKGSZUOVEURVFVGULUSUNUKGMTUBVGU
      PVBUQBUKGPTUCUDUMHSZVEVAVFVDVHUNUTUSUMHMTUEVHUQVCVBBUMHPTUFUDABCDEJKFIUGV
      AVDUHUI $.
  $}

  ${
    $d a b f g E $.  $d f g H $.  $d f g h s t K $.  $d a b c f g h T $.
    $d a b c f g h s t W $.  $d f g X $.
    dvhfvadd.h $e |- H = ( LHyp ` K ) $.
    dvhfvadd.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhfvadd.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhfvadd.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhfvadd.f $e |- D = ( Scalar ` U ) $.
    dvhfvadd.p $e |- .+^ = ( +g ` D ) $.
    dvhfvadd.a $e |- .+b = ( f e. ( T X. E ) , g e. ( T X. E )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
              ( ( 2nd ` f ) .+^ ( 2nd ` g ) ) >. ) $.
    dvhfvadd.s $e |- .+ = ( +g ` U ) $.
    $( The vector sum operation for the constructed full vector space H.
       (Contributed by NM, 26-Oct-2013.)  (Revised by Mario Carneiro,
       23-Jun-2014.) $)
    dvhfvadd $p |- ( ( K e. HL /\ W e. H ) -> .+ = .+b ) $=
      ( vh vs chlt wcel wa cplusg cfv cxp cv c1st ccom c2nd co cop cnx cbs cmpt
      cmpt2 csca cedring ctp cvsca csn cun eqid dvhset fveq2d w3a dvhsca syl5eq
      wceq oveqd 3ad2ant1 xp2nd anim12i erngplus sylan2 3impb opeq2d mpt2eq3dva
      eqtrd cvv cltrn fvex eqeltri ctendo xpex mpt2ex lmodplusg syl6req 3eqtr4g
      ax-mp ) KUCUDLJUDUEZFUFUGZGHEIUHZWOGUIZUJUGZHUIZUJUGUKZWPULUGZWRULUGZCUMZ
      UNZURZBDWMWNUOUPUGWOUNUOUFUGGHWOWOWSUAEUAUIZWTUGXEXAUGUKUQZUNZURZUNUOUSUG
      LKUTUGUGZUNVAUOVBUGUBGIWOWQUBUIZUGXJWTUKUNURZUNVCVDZUFUGZXDWMFXLUFXIEFGHU
      AIJKLUCUBMNOXIVEZPVFVGWMXDXHXMWMGHWOWOXCXGWMWPWOUDZWRWOUDZVHZXBXFWSXQXBWT
      XAXIUFUGZUMZXFWMXOXBXSVKXPWMCXRWTXAWMCAUFUGXRRWMAXIUFXIFAJKLUCMXNPQVIVGVJ
      VLVMWMXOXPXSXFVKZXOXPUEWMWTIUDZXAIUDZUEXTXOYAXPYBWPEIVNWREIVNVOXIXREWTUAI
      JKXALMNOXNXRVEVPVQVRWAVSVTXHWBUDXHXMVKGHWOWOXGEIELKWCUGZUGWBNLYCWDWEILKWF
      UGZUGWBOLYDWDWEWGZYEWHWOXHXKXIXLWBXLVEWIWLWJWATSWK $.
  $}

  ${
    $d a b f g E $.  $d f g H $.  $d f g K $.  $d f g .+^ $.  $d a b c f g T $.
    $d a b c f g W $.  $d f g X $.
    dvhvadd.h $e |- H = ( LHyp ` K ) $.
    dvhvadd.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhvadd.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhvadd.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhvadd.f $e |- D = ( Scalar ` U ) $.
    dvhvadd.s $e |- .+ = ( +g ` U ) $.
    dvhvadd.p $e |- .+^ = ( +g ` D ) $.
    $( The vector sum operation for the constructed full vector space H.
       (Contributed by NM, 11-Feb-2014.)  (Revised by Mario Carneiro,
       23-Jun-2014.) $)
    dvhvadd $p |- ( ( ( K e. HL /\ W e. H ) /\
       ( F e. ( T X. E ) /\ G e. ( T X. E ) ) ) -> ( F .+ G ) =
    <. ( ( 1st ` F ) o. ( 1st ` G ) ) , ( ( 2nd ` F ) .+^ ( 2nd ` G ) ) >. ) $=
      ( vf cfv vg chlt wcel wa cxp co cv c1st ccom c2nd cop cmpt2 eqid dvhfvadd
      oveqd dvhvaddval sylan9eq ) JUBUCKIUCUDZGDFUEZUCHUSUCUDGHBUFGHSUAUSUSSUGZ
      UHTUAUGZUHTUIUTUJTVAUJTCUFUKULZUFGUHTHUHTUIGUJTHUJTCUFUKURBVBGHABCVBDESUA
      FIJKLMNOPRVBUMZQUNUOVBCDSUAFGHVCUPUQ $.

    $( The vector sum operation for the constructed full vector space H.
       (Contributed by NM, 21-Feb-2014.)  (Revised by Mario Carneiro,
       6-May-2015.) $)
    dvhopvadd $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ Q e. E )
             /\ ( G e. T /\ R e. E ) )
    -> ( <. F , Q >. .+ <. G , R >. ) = <. ( F o. G ) , ( Q .+^ R ) >. ) $=
      ( chlt wcel wa w3a cop c1st cfv ccom c2nd cxp wceq simp1 opelxpi 3ad2ant2
      co 3ad2ant3 dvhvadd syl12anc op1stg coeq12d op2ndg oveq12d opeq12d eqtrd
      ) LUAUBMKUBUCZIFUBDHUBUCZJFUBEHUBUCZUDZIDUEZJEUEZBUOZVIUFUGZVJUFUGZUHZVIU
      IUGZVJUIUGZCUOZUEZIJUHZDECUOZUEVHVEVIFHUJZUBZVJWAUBZVKVRUKVEVFVGULVFVEWBV
      GIDFHUMUNVGVEWCVFJEFHUMUPABCFGHVIVJKLMNOPQRSTUQURVHVNVSVQVTVHVLIVMJVFVEVL
      IUKVGIDFHUSUNVGVEVMJUKVFJEFHUSUPUTVHVODVPECVFVEVODUKVGIDFHVAUNVGVEVPEUKVF
      JEFHVAUPVBVCVD $.
  $}

  ${
    $d s t E $.  $d f H $.  $d f s t K $.  $d f s t W $.
    dvhopvadd2.h $e |- H = ( LHyp ` K ) $.
    dvhopvadd2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhopvadd2.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhopvadd2.p $e |- .+ = ( s e. E , t e. E |->
        ( f e. T |-> ( ( s ` f ) o. ( t ` f ) ) ) ) $.
    dvhopvadd2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhopvadd2.s $e |- .+b = ( +g ` U ) $.
    $( The vector sum operation for the constructed full vector space H. TODO:
       check if this will shorten proofs that use ~ dvhopvadd and/or
       ~ dvhfplusr .  (Contributed by NM, 26-Sep-2014.) $)
    dvhopvadd2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ Q e. E )
             /\ ( G e. T /\ R e. E ) )
    -> ( <. F , Q >. .+b <. G , R >. ) = <. ( F o. G ) , ( Q .+ R ) >. ) $=
      ( chlt wcel wa w3a cop ccom csca cfv cplusg eqid dvhopvadd wceq dvhfplusr
      co 3ad2ant1 oveqd opeq2d eqtrd ) MUBUCNLUCUDZJFUCDIUCUDZKFUCEIUCUDZUEZJDU
      FKEUFCUOJKUGZDEGUHUIZUJUIZUOZUFVDDEBUOZUFVECVFDEFGIJKLMNPQRTVEUKZUAVFUKZU
      LVCVGVHVDVCVFBDEUTVAVFBUMVBABVFFGHIVELMUBNOPQRTVISVJUNUPUQURUS $.
  $}

  ${
    $d a b E $.  $d c H $.  $d a b c K $.  $d a b c T $.  $d a b c W $.
    dvhvaddcl.h $e |- H = ( LHyp ` K ) $.
    dvhvaddcl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhvaddcl.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhvaddcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhvaddcl.d $e |- D = ( Scalar ` U ) $.
    dvhvaddcl.p $e |- .+^ = ( +g ` D ) $.
    dvhvaddcl.a $e |- .+ = ( +g ` U ) $.
    $( Closure of the vector sum operation for the constructed full vector
       space H. (Contributed by NM, 26-Oct-2013.)  (Revised by Mario Carneiro,
       23-Jun-2014.) $)
    dvhvaddcl $p |- ( ( ( K e. HL /\ W e. H ) /\
      ( F e. ( T X. E ) /\ G e. ( T X. E ) ) ) -> ( F .+ G ) e. ( T X. E ) ) $=
      ( wcel cfv va vb vc chlt wa cxp co c1st ccom c2nd cop dvhvadd simpl xp1st
      ad2antrl ad2antll ltrnco syl3anc cv cmpt cmpt2 wceq eqid dvhfplusr adantr
      oveqd xp2nd tendoplcl eqeltrd opelxpi syl2anc ) JUDSKISUEZGDFUFZSZHVMSZUE
      ZUEZGHBUGGUHTZHUHTZUIZGUJTZHUJTZCUGZUKZVMABCDEFGHIJKLMNOPRQULVQVTDSZWCFSW
      DVMSVQVLVRDSZVSDSZWEVLVPUMZVNWFVLVOGDFUNUOVOWGVLVNHDFUNUPDVRVSIJKLMUQURVQ
      WCWAWBUAUBFFUCDUCUSZUAUSTWIUBUSTUIUTVAZUGZFVQCWJWAWBVLCWJVBVPUBWJCDEUCFAI
      JUDKUALMNOPWJVCZQVDVEVFVQVLWAFSZWBFSZWKFSWHVNWMVLVOGDFVGUOVOWNVLVNHDFVGUP
      UBWJDWAUCFIJWBKUALMNWLVHURVIVTWCDFVJVKVI $.

    $( Commutativity of vector sum.  (Contributed by NM, 26-Oct-2013.)
       (Revised by Mario Carneiro, 23-Jun-2014.)
       (New usage is discouraged.) $)
    dvhvaddcomN $p |- ( ( ( K e. HL /\ W e. H ) /\
       ( F e. ( T X. E ) /\ G e. ( T X. E ) ) ) -> ( F .+ G ) = ( G .+ F ) ) $=
      ( wcel cfv va vb vc chlt wa cxp c1st ccom c2nd co cop wceq simpl ad2antrl
      xp1st ad2antll ltrncom syl3anc cmpt cmpt2 xp2nd anim12i tendoplcom sylan2
      cv eqid 3expb dvhfplusr adantr oveqd 3eqtr4d opeq12d dvhvadd ancom2s ) JU
      DSKISUEZGDFUFZSZHVPSZUEZUEZGUGTZHUGTZUHZGUITZHUITZCUJZUKWBWAUHZWEWDCUJZUK
      ZGHBUJHGBUJZVTWCWGWFWHVTVOWADSZWBDSZWCWGULVOVSUMVQWKVOVRGDFUOUNVRWLVOVQHD
      FUOUPDWAWBIJKLMUQURVTWDWEUAUBFFUCDUCVEZUAVETWMUBVETUHUSUTZUJZWEWDWNUJZWFW
      HVSVOWDFSZWEFSZUEWOWPULZVQWQVRWRGDFVAHDFVAVBVOWQWRWSUBWNDWDUCFIJWEKUALMNW
      NVFZVCVGVDVTCWNWDWEVOCWNULVSUBWNCDEUCFAIJUDKUALMNOPWTQVHVIZVJVTCWNWEWDXAV
      JVKVLABCDEFGHIJKLMNOPRQVMVOVRVQWJWIULABCDEFHGIJKLMNOPRQVMVNVK $.

    $( Associativity of vector sum.  (Contributed by NM, 31-Oct-2013.) $)
    dvhvaddass $p |- ( ( ( K e. HL /\ W e. H ) /\
       ( F e. ( T X. E ) /\ G e. ( T X. E ) /\ I e. ( T X. E ) ) )
          -> ( ( F .+ G ) .+ I ) = ( F .+ ( G .+ I ) ) ) $=
      ( cfv chlt wcel wa cxp w3a c1st ccom c2nd cop coass wceq dvhvadd 3adantr3
      co fveq2d fvex coex op1st syl6eq coeq1d 3adantr1 coeq2d 3eqtr4a 3anim123i
      ovex xp2nd cgrp cbs cdr cedring eqid dvhsca erngdv eqeltrd drnggrp adantr
      simpr1 dvhbase eleqtrrd simpr2 simpr3 grpass syl13anc sylan2 op2nd oveq1d
      syl oveq2d 3eqtr4d opeq12d simpl dvhvaddcl syl12anc ) KUAUBLIUBUCZGDFUDZU
      BZHWOUBZJWOUBZUEZUCZGHBUNZUFTZJUFTZUGZXAUHTZJUHTZCUNZUIZGUFTZHJBUNZUFTZUG
      ZGUHTZXJUHTZCUNZUIZXAJBUNZGXJBUNZWTXDXLXGXOWTXIHUFTZUGZXCUGXIXSXCUGZUGXDX
      LXIXSXCUJWTXBXTXCWTXBXTXMHUHTZCUNZUIZUFTXTWTXAYDUFWNWPWQXAYDUKWRABCDEFGHI
      KLMNOPQSRULUMZUOXTYCXIXSGUFUPHUFUPZUQZXMYBCVEZURUSUTWTXKYAXIWTXKYAYBXFCUN
      ZUIZUFTYAWTXJYJUFWNWQWRXJYJUKWPABCDEFHJIKLMNOPQSRULVAZUOYAYIXSXCYFJUFUPUQ
      ZYBXFCVEZURUSVBVCWTYCXFCUNZXMYICUNZXGXOWSWNXMFUBZYBFUBZXFFUBZUEZYNYOUKZWP
      YPWQYQWRYRGDFVFHDFVFJDFVFVDWNYSUCZAVGUBZXMAVHTZUBYBUUCUBXFUUCUBYTWNUUBYSW
      NAVIUBUUBWNALKVJTTZVIUUDEAIKLUAMUUDVKZPQVLUUDIKLMUUEVMVNAVOWGVPUUAXMFUUCW
      NYPYQYRVQWNUUCFUKYSUUCEFAIKLUAMOPQUUCVKZVRVPZVSUUAYBFUUCWNYPYQYRVTUUGVSUU
      AXFFUUCWNYPYQYRWAUUGVSUUCCAXMYBXFUUFRWBWCWDWTXEYCXFCWTXEYDUHTYCWTXAYDUHYE
      UOXTYCYGYHWEUSWFWTXNYIXMCWTXNYJUHTYIWTXJYJUHYKUOYAYIYLYMWEUSWHWIWJWTWNXAW
      OUBZWRXQXHUKWNWSWKZWNWPWQUUHWRABCDEFGHIKLMNOPQRSWLUMWNWPWQWRWAABCDEFXAJIK
      LMNOPQSRULWMWTWNWPXJWOUBZXRXPUKUUIWNWPWQWRVQWNWQWRUUJWPABCDEFHJIKLMNOPQRS
      WLVAABCDEFGXJIKLMNOPQSRULWMWI $.
  $}

  ${
    $d s f t g E $.  $d s f t g T $.
    dvhvscaval.s $e |- .x. = ( s e. E ,
  f e. ( T X. E ) |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) $.
    $( Change bound variables to isolate them later.  (Contributed by NM,
       20-Nov-2013.) $)
    dvhvscacbv $p |- .x. = ( t e. E , g e. ( T X. E )
         |-> <. ( t ` ( 1st ` g ) ) , ( t o. ( 2nd ` g ) ) >. ) $=
      ( cxp cv c1st cfv c2nd ccom cop cmpt2 weq fveq1 opeq12d fveq2 coeq1 eqtri
      fveq2d coeq2d cbvmpt2v ) CGDFBFIZDJZKLZGJZLZUIUGMLZNZOZPAEFUFEJZKLZAJZLZU
      PUNMLZNZOZPHGDAEFUFUMUTUHUPLZUPUKNZOGAQUJVAULVBUHUIUPRUIUPUKUASDEQZVAUQVB
      USVCUHUOUPUGUNKTUCVCUKURUPUGUNMTUDSUEUB $.

    $d t g U $.  $d t g F $.
    $( The scalar product operation for the constructed full vector space H.
       (Contributed by NM, 20-Nov-2013.) $)
    dvhvscaval $p |- ( ( U e. E /\ F e. ( T X. E ) )
        -> ( U .x. F ) = <. ( U ` ( 1st ` F ) ) , ( U o. ( 2nd ` F ) ) >. ) $=
      ( vt vg cxp cv c1st cfv c2nd ccom cop wceq opeq12d fveq2 fveq1 dvhvscacbv
      coeq1 fveq2d coeq2d opex ovmpt2 ) IJCFEAEKJLZMNZILZNZUJUHONZPZQFMNZCNZCFO
      NZPZQBUICNZCULPZQUJCRUKURUMUSUIUJCUAUJCULUCSUHFRZURUOUSUQUTUIUNCUHFMTUDUT
      ULUPCUHFOTUESIABDJEGHUBUOUQUFUG $.
  $}

  ${
    $d f s E $.  $d f g H $.  $d f g h s t K $.  $d f h s T $.  $d f g V $.
    $d f g h s t W $.
    dvhfvsca.h $e |- H = ( LHyp ` K ) $.
    dvhfvsca.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhfvsca.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhfvsca.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhfvsca.s $e |- .x. = ( .s ` U ) $.
    $( Scalar product operation for the constructed full vector space H.
       (Contributed by NM, 2-Nov-2013.)  (Revised by Mario Carneiro,
       23-Jun-2014.) $)
    dvhfvsca $p |- ( ( K e. V /\ W e. H ) -> .x. = ( s e. E , f e. ( T X. E )
         |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) ) $=
      ( cvsca cfv cnx cop cv vg vh wcel wa cbs cplusg c1st ccom c2nd cmpt cmpt2
      cxp csca cedring ctp csn cun eqid dvhset fveq2d wceq ctendo eqeltri cltrn
      cvv fvex xpex mpt2ex lmodvsca ax-mp 3eqtr4g ) GHUCIFUCUDZCPQRUEQAEULZSRUF
      QDUAVMVMDTZUGQZUATZUGQUHUBAUBTZVNUIQZQVQVPUIQQUHUJSUKZSRUMQIGUNQQZSUORPQJ
      DEVMVOJTZQWAVRUHSZUKZSUPUQZPQZBWCVLCWDPVTACDUAUBEFGIHJKLMVTURNUSUTOWCVEUC
      WCWEVAJDEVMWBEIGVBQZQVEMIWFVFVCZAEAIGVDQZQVELIWHVFVCWGVGVHVMVSWCVTWDVEWDU
      RVIVJVK $.

    $d f F $.  $d f s R $.
    $( Scalar product operation for the constructed full vector space H.
       (Contributed by NM, 2-Nov-2013.) $)
    dvhvsca $p |- ( ( ( K e. V /\ W e. H )
           /\ ( R e. E /\ F e. ( T X. E ) ) )
        -> ( R .x. F ) = <. ( R ` ( 1st ` F ) ) , ( R o. ( 2nd ` F ) ) >. ) $=
      ( vs vf wcel wa cfv cxp co c1st c2nd ccom cmpt2 dvhfvsca oveqd dvhvscaval
      cv cop eqid sylan9eq ) HIRJGRSZAERFBEUAZRSAFCUBAFPQEUOQUJZUCTPUJZTUQUPUDT
      UEUKUFZUBFUCTATAFUDTUEUKUNCURAFBCDQEGHIJPKLMNOUGUHBURAQEFPURULUIUM $.

    $( Scalar product operation for the constructed full vector space H.
       (Contributed by NM, 20-Feb-2014.) $)
    dvhopvsca $p |- ( ( ( K e. V /\ W e. H )
          /\ ( R e. E /\ F e. T /\ X e. E ) )
        -> ( R .x. <. F , X >. ) = <. ( R ` F ) , ( R o. X ) >. ) $=
      ( wcel cop cfv wceq wa w3a c1st c2nd ccom cxp simpl simpr1 simpr2 opelxpi
      simpr3 syl2anc dvhvsca syl12anc op1stg fveq2d op2ndg coeq2d opeq12d eqtrd
      co ) HIQJGQUAZAEQZFBQZKEQZUBZUAZAFKRZCVAZVHUCSZASZAVHUDSZUEZRZFASZAKUEZRV
      GVBVCVHBEUFQZVIVNTVBVFUGVBVCVDVEUHVGVDVEVQVBVCVDVEUIZVBVCVDVEUKZFKBEUJULA
      BCDEVHGHIJLMNOPUMUNVGVKVOVMVPVGVJFAVGVDVEVJFTVRVSFKBEUOULUPVGVLKAVGVDVEVL
      KTVRVSFKBEUQULURUSUT $.

    $( Closure of the scalar product operation for the constructed full vector
       space H. (Contributed by NM, 12-Feb-2014.) $)
    dvhvscacl $p |- ( ( ( K e. HL /\ W e. H ) /\
       ( R e. E /\ F e. ( T X. E ) ) ) -> ( R .x. F ) e. ( T X. E ) ) $=
      ( chlt wcel wa cfv ad2antll syl3anc cxp c1st c2nd ccom cop dvhvsca simprl
      co simpl xp1st tendocl xp2nd tendococl opelxpi syl2anc eqeltrd ) HOPIGPQZ
      AEPZFBEUAZPZQZQZAFCUHFUBRZARZAFUCRZUDZUEZUSABCDEFGHOIJKLMNUFVBVDBPZVFEPZV
      GUSPVBUQURVCBPZVHUQVAUIZUQURUTUGZUTVJUQURFBEUJSABEVCGHOIJKLUKTVBUQURVEEPZ
      VIVKVLUTVMUQURFBEULSAVEEGHIJLUMTVDVFBEUNUOUP $.
  $}

  ${
    $d h B $.  $d h H $.  $d h K $.  $d h T $.  $d h W $.
    tendoinv.b $e |- B = ( Base ` K ) $.
    tendoinv.h $e |- H = ( LHyp ` K ) $.
    tendoinv.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    tendoinv.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    tendoinv.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    tendoinv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    tendoinv.f $e |- F = ( Scalar ` U ) $.
    tendoinv.n $e |- N = ( invr ` F ) $.
    $( Closure of multiplicative inverse for endomorphism.  We use the scalar
       inverse of the vector space since it is much simpler than the direct
       inverse of ~ cdleml8 .  (Contributed by NM, 10-Apr-2014.)  (Revised by
       Mario Carneiro, 23-Jun-2014.) $)
    tendoinvcl $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E /\ S =/= O )
      -> ( ( N ` S ) e. E /\ ( N ` S ) =/= O ) ) $=
      ( chlt wcel wa wne w3a cfv cbs cdr c0g cedring eqid dvhsca erngdv eqeltrd
      3ad2ant1 simp2 wceq dvhbase eleqtrrd simp3 fveq2d erng0g eqtrd drnginvrcl
      neeqtrrd syl3anc eleqtrd drnginvrn0 neeqtrd jca ) IUAUBLHUBUCZBFUBZBKUDZU
      EZBJUFZFUBVOKUDVNVOGUGUFZFVNGUHUBZBVPUBZBGUIUFZUDZVOVPUBVKVLVQVMVKGLIUJUF
      UFZUHWADGHILUANWAUKZRSULZWAHILNWBUMUNUOZVNBFVPVKVLVMUPVKVLVPFUQVMVPDFGHIL
      UANPRSVPUKZURUOZUSZVNBKVSVKVLVMUTVKVLVSKUQVMVKVSWAUIUFZKVKGWAUIWCVAAWACEH
      IKLWHMNOWBQWHUKVBVCUOZVEZVPGJBVSWEVSUKZTVDVFWFVGVNVOVSKVNVQVRVTVOVSUDWDWG
      WJVPGJBVSWEWKTVHVFWIVIVJ $.

    $( Left multiplicative inverse for endomorphism.  (Contributed by NM,
       10-Apr-2014.)  (Revised by Mario Carneiro, 23-Jun-2014.) $)
    tendolinv $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E /\ S =/= O )
      -> ( ( N ` S ) o. S ) = ( _I |` T ) ) $=
      ( chlt wcel wa wne w3a cfv cmulr co cur ccom cid cres cdr cbs c0g cedring
      wceq simp1 eqid dvhsca erngdv eqeltrd simp2 dvhbase eleqtrrd simp3 fveq2d
      erng0g eqtrd neeqtrrd drnginvrl syl3anc tendoinvcl simpld syl12anc erng1r
      syl dvhmulr 3eqtr3d ) IUAUBLHUBUCZBFUBZBKUDZUEZBJUFZBGUGUFZUHZGUIUFZWDBUJ
      ZUKCULZWCGUMUBBGUNUFZUBBGUOUFZUDWFWGUQWCGLIUPUFUFZUMWCVTGWLUQVTWAWBURZWLD
      GHILUANWLUSZRSUTZVQWCVTWLUMUBWMWLHILNWNVAVQVBWCBFWJVTWAWBVCZWCVTWJFUQWMWJ
      DFGHILUANPRSWJUSZVDVQVEWCBKWKVTWAWBVFWCVTWKKUQWMVTWKWLUOUFZKVTGWLUOWOVGAW
      LCEHIKLWRMNOWNQWRUSVHVIVQVJWJGWEWGJBWKWQWKUSWEUSZWGUSTVKVLWCVTWDFUBZWAWFW
      HUQWMWCWTWDKUDABCDEFGHIJKLMNOPQRSTVMVNWPWDBCWEDFGHIUALNOPRSWSVRVOWCVTWGWI
      UQWMVTWGWLUIUFZWIVTGWLUIWOVGWLCXAHILNOWNXAUSVPVIVQVS $.

    $( Right multiplicative inverse for endomorphism.  (Contributed by NM,
       10-Apr-2014.)  (Revised by Mario Carneiro, 23-Jun-2014.) $)
    tendorinv $p |- ( ( ( K e. HL /\ W e. H ) /\ S e. E /\ S =/= O )
      -> ( S o. ( N ` S ) ) = ( _I |` T ) ) $=
      ( chlt wcel wa wne w3a cfv cmulr co cur ccom cid cres cdr cbs c0g cedring
      wceq simp1 eqid dvhsca erngdv eqeltrd simp2 dvhbase eleqtrrd simp3 fveq2d
      erng0g eqtrd neeqtrrd drnginvrr syl3anc tendoinvcl simpld syl12anc erng1r
      syl dvhmulr 3eqtr3d ) IUAUBLHUBUCZBFUBZBKUDZUEZBBJUFZGUGUFZUHZGUIUFZBWDUJ
      ZUKCULZWCGUMUBBGUNUFZUBBGUOUFZUDWFWGUQWCGLIUPUFUFZUMWCVTGWLUQVTWAWBURZWLD
      GHILUANWLUSZRSUTZVQWCVTWLUMUBWMWLHILNWNVAVQVBWCBFWJVTWAWBVCZWCVTWJFUQWMWJ
      DFGHILUANPRSWJUSZVDVQVEWCBKWKVTWAWBVFWCVTWKKUQWMVTWKWLUOUFZKVTGWLUOWOVGAW
      LCEHIKLWRMNOWNQWRUSVHVIVQVJWJGWEWGJBWKWQWKUSWEUSZWGUSTVKVLWCVTWAWDFUBZWFW
      HUQWMWPWCWTWDKUDABCDEFGHIJKLMNOPQRSTVMVNBWDCWEDFGHIUALNOPRSWSVRVOWCVTWGWI
      UQWMVTWGWLUIUFZWIVTGWLUIWOVGWLCXAHILNOWNXAUSVPVIVQVS $.
  $}

  ${
    $d f t .+^ $.  $d f g h .0. $.  $d f g h B $.  $d f g h s t E $.  $d g I $.
    $d f g h s t .+ $.  $d f g h s t H $.  $d f g h s t K $.  $d f g h s t T $.
    $d f g h s U $.  $d f g h s t W $.  $d f s t .x. $.  $d f t .X. $.
    dvhgrp.b $e |- B = ( Base ` K ) $.
    dvhgrp.h $e |- H = ( LHyp ` K ) $.
    dvhgrp.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhgrp.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhgrp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhgrp.d $e |- D = ( Scalar ` U ) $.
    dvhgrp.p $e |- .+^ = ( +g ` D ) $.
    dvhgrp.a $e |- .+ = ( +g ` U ) $.
    dvhgrp.o $e |- .0. = ( 0g ` D ) $.
    dvhgrp.i $e |- I = ( invg ` D ) $.
    $( The full vector space ` U ` constructed from a Hilbert lattice ` K `
       (given a fiducial hyperplane ` W ` ) is a group.  (Contributed by NM,
       19-Oct-2013.)  (Revised by Mario Carneiro, 24-Jun-2014.) $)
    dvhgrp $p |- ( ( K e. HL /\ W e. H ) -> U e. Grp ) $=
      ( vf vg vh chlt wcel wa cxp c1st cfv ccnv c2nd cop cid cres eqid dvhvbase
      cv cbs eqcomd cplusg wceq a1i co dvhvaddcl dvhvaddass idltrn cgrp cedring
      cdr dvhsca erngdv eqeltrd drnggrp grpidcl dvhbase eleqtrd opelxpi syl2anc
      3impb syl ccom simpl adantr xp1st adantl xp2nd dvhopvadd syl122anc ltrn1o
      wf1o syldan f1of fcoi2 3syl eleqtrrd grplid opeq12d eqtrd 1st2nd2 3eqtr4d
      wf oveq2d ltrncnv grpinvcl f1ococnv1 grplinv isgrpd ) JUFUGKHUGUHZUCUDUEE
      GUIZCFUCUSZUJUKZULZXLUMUKZIUKZUNZUOAUPZLUNZXJFUTUKZXKEFGHJXTKUFNOPQXTUQUR
      VACFVBUKVCXJTVDXJXLXKUGZUDUSZXKUGXLYBCVEXKUGBCDEFGXLYBHJKNOPQRSTVFWABCDEF
      GXLYBHUEUSJKNOPQRSTVGXJXREUGZLGUGZXSXKUGAEHJKMNOVHZXJLBUTUKZGXJBVIUGZLYFU
      GXJBVKUGYGXJBKJVJUKUKZVKYHFBHJKUFNYHUQZQRVLYHHJKNYIVMVNBVOWBZYFBLYFUQZUAV
      PWBYFFGBHJKUFNPQRYKVQZVRZXRLEGVSVTXJYAUHZXSXMXOUNZCVEZYOXSXLCVEXLYNYPXRXM
      WCZLXODVEZUNZYOYNXJYCYDXMEUGZXOGUGZYPYSVCXJYAWDZXJYCYAYEWEXJYDYAYMWEYAYTX
      JXLEGWFWGZYAUUAXJXLEGWHWGZBCDLXOEFGXRXMHJKNOPQRTSWIWJYNYQXMYRXOYNAAXMWLZA
      AXMXCYQXMVCXJYAYTUUEUUCAEXMHJUFKMNOWKWMZAAXMWNAAXMWOWPYNYGXOYFUGZYRXOVCXJ
      YGYAYJWEZYNXOGYFUUDXJYFGVCYAYLWEZWQZYFDBXOLYKSUAWRVTWSWTYNXLYOXSCYAXLYOVC
      XJXLEGXAWGZXDUUKXBYNXNEUGZXPGUGZXQXKUGXJYAYTUULUUCEXMHJKNOXEWMZYNXPYFGYNY
      GUUGXPYFUGUUHUUJYFBIXOYKUBXFVTUUIVRZXNXPEGVSVTYNXQXLCVEXQYOCVEZXSYNXLYOXQ
      CUUKXDYNUUPXNXMWCZXPXODVEZUNZXSYNXJUULUUMYTUUAUUPUUSVCUUBUUNUUOUUCUUDBCDX
      PXOEFGXNXMHJKNOPQRTSWIWJYNUUQXRUURLYNUUEUUQXRVCUUFAAXMXGWBYNYGUUGUURLVCUU
      HUUJYFDBIXOLYKSUAUBXHVTWSWTWTXI $.

    dvhlvec.m $e |- .X. = ( .r ` D ) $.
    dvhlvec.s $e |- .x. = ( .s ` U ) $.
    $( Lemma for ~ dvhlvec .  TODO: proof substituting inner part first
       shorter/longer than substituting outer part first?  TODO: break up into
       smaller lemmas?  TODO: does ` ph -> ` method shorten proof?
       (Contributed by NM, 22-Oct-2013.)  (Proof shortened by Mario Carneiro,
       24-Jun-2014.) $)
    dvhlveclem $p |- ( ( K e. HL /\ W e. H ) -> U e. LVec ) $=
      ( vs vt vf chlt wcel clmod cdr clvec cid cres cxp cbs cfv dvhvbase eqcomd
      wa eqid cplusg wceq a1i csca cvsca dvhbase cmulr cur dvhsca fveq2d erng1r
      cedring eqtr2d crg erngdv eqeltrd drngrng syl dvhgrp cv co dvhvscacl c1st
      3impb w3a c2nd ccom cop simpl simpr1 simpr2 xp1st simpr3 syl13anc dvhvadd
      tendospdi1 3adantr1 fvex coex ovex op1st syl6eq dvhvsca 3adantr3 3adantr2
      vex coeq12d 3eqtr4d adantr eleqtrd xp2nd rngacl syl3anc eleqtrrd syl12anc
      rngdi dvhmulr oveq12d 3eqtr3d op2nd coeq2d opeq12d dvhvaddcl syl5eq oveqd
      erngplus2 fveq1d rngdir eqtr4d syl121anc coass tendococl dvhopvsca oveq1d
      tendocoval tendocl adantl oveq2d tendospid tendof sylan2 tendoidcl anim1i
      wf fcoi2 syldan 1st2nd2 islmodd islvec sylanbrc ) LUJUKMJUKVBZHULUKBUMUKZ
      HUNUKUUNUGUHUIICDFGUOEUPZBEIUQZHUUNHURUSZUUQEHIJLUURMUJPQRSUURVCUTVACHVDU
      SVEUUNUBVFBHVGUSVEUUNTVFFHVHUSVEUUNUFVFUUNBURUSZIUUSHIBJLMUJPRSTUUSVCZVIV
      AZDBVDUSZVEUUNUAVFGBVJUSVEUUNUEVFUUNBVKUSMLVOUSUSZVKUSZUUPUUNBUVCVKUVCHBJ
      LMUJPUVCVCZSTVLZVMUVCEUVDJLMPQUVEUVDVCVNVPUUNUUOBVQUKZUUNBUVCUMUVFUVCJLMP
      UVEVRVSZBVTWAZABCDEHIJKLMNOPQRSTUAUBUCUDWBUUNUGWCZIUKZUHWCZUUQUKZUVJUVLFW
      DZUUQUKZUVJEFHIUVLJLMPQRSUFWEZWGUUNUVKUVMUIWCZUUQUKZWHZVBZUVLUVQCWDZWFUSZ
      UVJUSZUVJUWAWIUSZWJZWKZUVNWFUSZUVJUVQFWDZWFUSZWJZUVNWIUSZUWHWIUSZDWDZWKZU
      VJUWAFWDZUVNUWHCWDZUVTUWCUWJUWEUWMUVTUVLWFUSZUVQWFUSZWJZUVJUSZUWQUVJUSZUW
      RUVJUSZWJZUWCUWJUVTUUNUVKUWQEUKZUWREUKZUWTUXCVEUUNUVSWLZUUNUVKUVMUVRWMZUV
      TUVMUXDUUNUVKUVMUVRWNZUVLEIWOWAUVTUVRUXEUUNUVKUVMUVRWPZUVQEIWOZWAEUVJIUWQ
      UWRJLUJMPQRWSWQUVTUWBUWSUVJUVTUWBUWSUVLWIUSZUVQWIUSZDWDZWKZWFUSUWSUVTUWAU
      XNWFUUNUVMUVRUWAUXNVEUVKBCDEHIUVLUVQJLMPQRSTUBUAWRWTZVMUWSUXMUWQUWRUVLWFX
      AUVQWFXAXBZUXKUXLDXCZXDXEVMUVTUWGUXAUWIUXBUVTUWGUXAUVJUXKWJZWKZWFUSUXAUVT
      UVNUXSWFUUNUVKUVMUVNUXSVEUVRUVJEFHIUVLJLUJMPQRSUFXFXGZVMUXAUXRUWQUVJXAZUV
      JUXKUGXIZUVLWIXAXBZXDXEUVTUWIUXBUVJUXLWJZWKZWFUSZUXBUVTUWHUYEWFUUNUVKUVRU
      WHUYEVEZUVMUVJEFHIUVQJLUJMPQRSUFXFZXHZVMUXBUYDUWRUVJXAZUVJUXLUYBUVQWIXAZX
      BZXDZXEXJXKUVTUVJUXMWJZUXRUYDDWDZUWEUWMUVTUVJUXMGWDZUVJUXKGWDZUVJUXLGWDZD
      WDZUYNUYOUVTUVGUVJUUSUKZUXKUUSUKZUXLUUSUKZUYPUYSVEUUNUVGUVSUVIXLZUVTUVJIU
      USUXGUUNIUUSVEZUVSUVAXLZXMUVTUXKIUUSUVTUVMUXKIUKZUXHUVLEIXNWAZVUEXMZUVTUX
      LIUUSUVTUVRUXLIUKZUXIUVQEIXNZWAZVUEXMZUUSDBGUVJUXKUXLUUTUAUEXSWQUVTUUNUVK
      UXMIUKUYPUYNVEUXFUXGUVTUXMUUSIUVTUVGVUAVUBUXMUUSUKVUCVUHVULUUSDBUXKUXLUUT
      UAXOXPVUEXQUVJUXMEGHIBJLUJMPQRSTUEXTXRUVTUYQUXRUYRUYDDUVTUUNUVKVUFUYQUXRV
      EUXFUXGVUGUVJUXKEGHIBJLUJMPQRSTUEXTXRUVTUUNUVKVUIUYRUYDVEZUXFUXGVUKUVJUXL
      EGHIBJLUJMPQRSTUEXTZXRYAYBUVTUWDUXMUVJUVTUWDUXNWIUSUXMUVTUWAUXNWIUXOVMUWS
      UXMUXPUXQYCXEYDUVTUWKUXRUWLUYDDUVTUWKUXSWIUSUXRUVTUVNUXSWIUXTVMUXAUXRUYAU
      YCYCXEUVTUWLUYEWIUSZUYDUVTUWHUYEWIUYIVMUXBUYDUYJUYLYCZXEYAXKYEUVTUUNUVKUW
      AUUQUKZUWOUWFVEUXFUXGUUNUVMUVRVUQUVKBCDEHIUVLUVQJLMPQRSTUAUBYFWTUVJEFHIUW
      AJLUJMPQRSUFXFXRUVTUUNUVOUWHUUQUKZUWPUWNVEUXFUUNUVKUVMUVOUVRUVPXGUUNUVKUV
      RVURUVMUVJEFHIUVQJLMPQRSUFWEZXHBCDEHIUVNUWHJLMPQRSTUBUAWRXRXKUUNUVKUVLIUK
      ZUVRWHZVBZUWRUVJUVLDWDZUSZVVCUXLWJZWKZUWIUVLUVQFWDZWFUSZWJZUWLVVGWIUSZDWD
      ZWKZVVCUVQFWDZUWHVVGCWDZVVBVVDVVIVVEVVKVVBUWRUVJUVLUVCVDUSZWDZUSZUXBUWRUV
      LUSZWJZVVDVVIVVBUUNUVKVUTUXEVVQVVSVEUUNVVAWLZUUNUVKVUTUVRWMZUUNUVKVUTUVRW
      NZVVBUVRUXEUUNUVKVUTUVRWPZUXJWAZUVCVVOEUVJIUWRJLUVLMPQRUVEVVOVCYIWQUUNVVD
      VVQVEVVAUUNUWRVVCVVPUUNDVVOUVJUVLUUNDUVBVVOUAUUNBUVCVDUVFVMYGYHYJXLVVBUWI
      UXBVVHVVRVVBUWIUYFUXBVVBUWHUYEWFUUNUVKUVRUYGVUTUYHXHZVMUYMXEVVBVVHVVRUVLU
      XLWJZWKZWFUSVVRVVBVVGVWGWFUUNVUTUVRVVGVWGVEUVKUVLEFHIUVQJLUJMPQRSUFXFWTZV
      MVVRVWFUWRUVLXAZUVLUXLUHXIUYKXBZXDXEXJXKVVBVVEUYDVWFDWDZVVKVVBVVCUXLGWDZU
      YRUVLUXLGWDZDWDZVVEVWKVVBUVGUYTUVLUUSUKZVUBVWLVWNVEUUNUVGVVAUVIXLZVVBUVJI
      UUSVWAUUNVUDVVAUVAXLZXMZVVBUVLIUUSVWBVWQXMZVVBUXLIUUSVVBUVRVUIVWCVUJWAZVW
      QXMUUSDBGUVJUVLUXLUUTUAUEYKWQVVBUUNVVCIUKZVUIVWLVVEVEVVTVVBVVCUUSIVVBUVGU
      YTVWOVVCUUSUKVWPVWRVWSUUSDBUVJUVLUUTUAXOXPVWQXQZVWTVVCUXLEGHIBJLUJMPQRSTU
      EXTXRVVBUYRUYDVWMVWFDVVBUUNUVKVUIVUMVVTVWAVWTVUNXRVVBUUNVUTVUIVWMVWFVEVVT
      VWBVWTUVLUXLEGHIBJLUJMPQRSTUEXTXRYAYBVVBUWLUYDVVJVWFDVVBUWLVUOUYDVVBUWHUY
      EWIVWEVMVUPXEVVBVVJVWGWIUSVWFVVBVVGVWGWIVWHVMVVRVWFVWIVWJYCXEYAYLYEVVBUUN
      VXAUVRVVMVVFVEVVTVXBVWCVVCEFHIUVQJLUJMPQRSUFXFXRVVBUUNVURVVGUUQUKZVVNVVLV
      EVVTUUNUVKUVRVURVUTVUSXHUUNVUTUVRVXCUVKUVLEFHIUVQJLMPQRSUFWEWTBCDEHIUWHVV
      GJLMPQRSTUBUAWRXRXKVVBUVJUVLWJZUVQFWDZUVJVWGFWDZUVJUVLGWDZUVQFWDUVJVVGFWD
      VVBUWRVXDUSZVXDUXLWJZWKZVVRUVJUSZUVJVWFWJZWKZVXEVXFVVBVXHVXKVXIVXLVVBUUNU
      VKVUTUXEVXHVXKVEVVTVWAVWBVWDEUVJIUWRJLUVLMUJPQRYRYMVXIVXLVEVVBUVJUVLUXLYN
      VFYEVVBUUNVXDIUKZUVRVXEVXJVEVVTVVBUUNUVKVUTVXNVVTVWAVWBUVJUVLIJLMPRYOXPVW
      CVXDEFHIUVQJLUJMPQRSUFXFXRVVBUUNUVKVVREUKZVWFIUKZVXFVXMVEVVTVWAVVBUUNVUTU
      XEVXOVVTVWBVWDUVLEIUWRJLUJMPQRYSXPVVBUUNVUTVUIVXPVVTVWBVWTUVLUXLIJLMPRYOX
      PUVJEFHIVVRJLUJMVWFPQRSUFYPWQXKVVBVXGVXDUVQFUUNUVKVUTVXGVXDVEUVRUVJUVLEGH
      IBJLUJMPQRSTUEXTXGYQVVBVVGVWGUVJFVWHUUAXKUUNUVJUUQUKZVBZUVJWFUSZUUPUSZUUP
      UVJWIUSZWJZWKZVXSVYAWKZUUPUVJFWDZUVJVXRVXTVXSVYBVYAVXRVXSEUKZVXTVXSVEVXQV
      YFUUNUVJEIWOYTEVXSUUBWAVXREEVYAUUGZVYBVYAVEVXQUUNVYAIUKVYGUVJEIXNVYAEIJLU
      JMPQRUUCUUDEEVYAUUHWAYEUUNVXQUUPIUKZVXQVBVYEVYCVEUUNVYHVXQEIJLMPQRUUEUUFU
      UPEFHIUVJJLUJMPQRSUFXFUUIVXQUVJVYDVEUUNUVJEIUUJYTXKUUKUVHBHTUULUUM $.
  $}

  ${
    dvhlvec.h $e |- H = ( LHyp ` K ) $.
    dvhlvec.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhlvec.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The full vector space ` U ` constructed from a Hilbert lattice ` K `
       (given a fiducial hyperplane ` W ` ) is a left module.  (Contributed by
       NM, 23-May-2015.) $)
    dvhlvec $p |- ( ph -> U e. LVec ) $=
      ( chlt wcel wa clvec cbs cfv csca cplusg cltrn cvsca cmulr eqid cminusg
      ctendo c0g dvhlveclem syl ) ADIJECJKBLJHDMNZBONZBPNZUGPNZEDQNNZBRNZUGSNZB
      EDUBNNZCUGUANZDEUGUCNZUFTFUJTUMTGUGTUITUHTUOTUNTULTUKTUDUE $.

    $( The full vector space ` U ` constructed from a Hilbert lattice ` K `
       (given a fiducial hyperplane ` W ` ) is a left module.  (Contributed by
       NM, 23-May-2015.) $)
    dvhlmod $p |- ( ph -> U e. LMod ) $=
      ( clvec wcel clmod dvhlvec lveclmod syl ) ABIJBKJABCDEFGHLBMN $.
  $}

  ${
    $d f B $.  $d f H $.  $d f s t K $.  $d f s t T $.  $d f s t W $.
    dvh0g.b $e |- B = ( Base ` K ) $.
    dvh0g.h $e |- H = ( LHyp ` K ) $.
    dvh0g.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvh0g.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvh0g.z $e |- .0. = ( 0g ` U ) $.
    dvh0g.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    $( The zero vector of vector space H has the zero translation as its first
       member and the zero trace-preserving endomorphism as the second.
       (Contributed by NM, 9-Mar-2014.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    dvh0g $p |- ( ( K e. HL /\ W e. H ) -> .0. = <. ( _I |` B ) , O >. ) $=
      ( vs wcel cfv wceq eqid vt chlt wa cid cres cplusg co ccom csca ctendo id
      cop idltrn tendo0cl dvhopvadd syl122anc wf1o wf f1oi f1of fcoi2 mp2b cmpt
      a1i cv cmpt2 dvhfplusr oveqd tendo0pl mpdan eqtrd opeq12d cbs dvhelvbasei
      clmod wb dvhlmod syl12anc lmod0vid syl2anc mpbid ) FUBQHEQUCZUDAUEZGULZWD
      CUFRZUGZWDSZIWDSZWBWFWCWCUHZGGCUIRZUFRZUGZULZWDWBWBWCBQZGHFUJRRZQZWNWPWFW
      MSWBUKZABEFHJKLUMZABDWOEFGHJKLWOTZOUNZWRWTWJWEWKGGBCWOWCWCEFHKLWSMWJTZWET
      ZWKTZUOUPWBWIWCWLGWIWCSZWBAAWCUQAAWCURXDAUSAAWCUTAAWCVAVBVDWBWLGGPUAWOWOD
      BDVEZPVERXEUAVERUHVCVFZUGZGWBWKXFGGUAXFWKBCDWOWJEFUBHPKLWSMXAXFTZXCVGVHWB
      WPXGGSWTUAAXFGBDWOEFGHPJKLWSOXHVIVJVKVLVKWBCVOQWDCVMRZQZWGWHVPWBCEFHKMWQV
      QWBWBWNWPXJWQWRWTGBCWOWCEFXIHUBKLWSMXITZVNVRWEXICWDIXKXBNVSVTWA $.
  $}

  ${
    $d f B $.  $d f H $.  $d f K $.  $d f T $.  $d f W $.
    dvheveccl.h $e |- H = ( LHyp ` K ) $.
    dvheveccl.b $e |- B = ( Base ` K ) $.
    dvheveccl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvheveccl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvheveccl.v $e |- V = ( Base ` U ) $.
    dvheveccl.z $e |- .0. = ( 0g ` U ) $.
    dvheveccl.e $e |- E = <. ( _I |` B ) , ( _I |` T ) >. $.
    dvheveccl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Properties of a unit vector that we will use later as a convenient
       reference vector.  This vector is called "e" in the remark after Lemma M
       of [Crawley] p. 121. line 17.  See also ~ dvhopN and ~ dihpN .
       (Contributed by NM, 27-Mar-2015.) $)
    dvheveccl $p |- ( ph -> E e. ( V \ { .0. } ) ) $=
      ( wcel wceq vf cid cres cop csn cdif wne chlt ctendo cfv idltrn tendoidcl
      wa syl eqid dvhelvbasei syl12anc cmpt tendo1ne0 dvh0g eqtr wb opthg simpr
      syl2anc syl6bi syl5 mpan2d necon3d mpd eldifsn sylanbrc syl5eqel ) AEUBBU
      CZUBCUCZUDZHJUEUFZQAVPHSZVPJUGZVPVQSAGUHSIFSUMZVNCSZVOIGUIUJUJZSZVRRAVTWA
      RBCFGILKMUKUNZAVTWCRCWBFGIKMWBUOZULUNZVOCDWBVNFGHIUHKMWENOUPUQAVOUACVNURZ
      UGZVSAVTWHRBCUAWBFGWGILKMWEWGUOZUSUNAVPJVOWGAVPJTZJVNWGUDZTZVOWGTZAVTWLRB
      CDUAFGWGIJLKMNPWIUTUNWJWLUMVPWKTZAWMVPJWKVAAWNVNVNTZWMUMZWMAWAWCWNWPVBWDW
      FVNVOVNWGCWBVCVEWOWMVDVFVGVHVIVJVPHJVKVLVM $.
  $}

  $( Closure of a ` DVecH ` vector expressed as ordered pair.  (Contributed by
     NM, 20-Nov-2013.)  (New usage is discouraged.) $)
  dvhopclN $p |- ( ( F e. T /\ U e. E )
          -> <. F , U >. e. ( T X. E ) ) $=
    ( opelxpi ) DBACE $.

  ${
    $d f g E $.  $d f g P $.  $d f g T $.
    dvhopadd.a $e |- A = ( f e. ( T X. E ) , g e. ( T X. E )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
              ( ( 2nd ` f ) P ( 2nd ` g ) ) >. ) $.
    $( Sum of ` DVecH ` vectors expressed as ordered pair.  (Contributed by NM,
       20-Nov-2013.)  (New usage is discouraged.) $)
    dvhopaddN $p |- ( ( ( F e. T /\ U e. E ) /\ ( G e. T /\ V e. E ) )
  -> ( <. F , U >. A <. G , V >. ) = <. ( F o. G ) , ( U P V ) >. ) $=
      ( wcel wa cop co c1st cfv ccom c2nd wceq opelxpi dvhvaddval syl2an op1stg
      cxp adantr adantl coeq12d op2ndg oveqan12d opeq12d eqtrd ) HCLDGLMZICLJGL
      MZMZHDNZIJNZAOZUPPQZUQPQZRZUPSQZUQSQZBOZNZHIRZDJBOZNUMUPCGUEZLUQVHLURVETU
      NHDCGUAIJCGUAABCEFGUPUQKUBUCUOVAVFVDVGUOUSHUTIUMUSHTUNHDCGUDUFUNUTITUMIJC
      GUDUGUHUMUNVBDVCJBHDCGUIIJCGUIUJUKUL $.
  $}

  ${
    $d f s E $.  $d f s T $.
    dvhopsp.s $e |- S = ( s e. E ,
  f e. ( T X. E ) |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) $.
    $( Scalar product of ` DVecH ` vector expressed as ordered pair.
       (Contributed by NM, 20-Nov-2013.)  (New usage is discouraged.) $)
    dvhopspN $p |- ( ( R e. E /\ ( F e. T /\ U e. E ) )
  -> ( R S <. F , U >. ) = <. ( R ` F ) , ( R o. U ) >. ) $=
      ( wcel wa cop co c1st cfv c2nd ccom cxp wceq opelxpi sylan2 op1stg fveq2d
      dvhvscaval op2ndg coeq2d opeq12d adantl eqtrd ) AFJZGCJDFJKZKAGDLZBMZULNO
      ZAOZAULPOZQZLZGAOZADQZLZUKUJULCFRJUMURSGDCFTCBAEFULHIUDUAUKURVASUJUKUOUSU
      QUTUKUNGAGDCFUBUCUKUPDAGDCFUEUFUGUHUI $.
  $}

  ${
    $d c B $.  $d a b f g s E $.  $d c H $.  $d c K $.  $d f g P $.
    $d a b c f g s T $.  $d a b c W $.
    dvhop.b $e |- B = ( Base ` K ) $.
    dvhop.h $e |- H = ( LHyp ` K ) $.
    dvhop.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dvhop.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dvhop.p $e |- P = ( a e. E , b e. E |-> ( c e. T
          |-> ( ( a ` c ) o. ( b ` c ) ) ) ) $.
    dvhop.a $e |- A = ( f e. ( T X. E ) , g e. ( T X. E )
           |-> <. ( ( 1st ` f ) o. ( 1st ` g ) ) ,
              ( ( 2nd ` f ) P ( 2nd ` g ) ) >. ) $.
    dvhop.s $e |- S = ( s e. E ,
  f e. ( T X. E ) |-> <. ( s ` ( 1st ` f ) ) , ( s o. ( 2nd ` f ) ) >. ) $.
    dvhop.o $e |- O = ( c e. T |-> ( _I |` B ) ) $.
    $( Decompose a ` DVecH ` vector expressed as an ordered pair into the sum
       of two components, the first from the translation group vector base of
       ` DVecA ` and the other from the one-dimensional vector subspace
       ` E ` .  Part of Lemma M of [Crawley] p. 121, line 18.  We represent
       their e, sigma, f by ` <. ( _I |`` B ) , ( _I |`` T ) >. ` , ` U ` ,
       ` <. F , O >. ` .  We swapped the order of vector sum (their
       juxtaposition i.e. composition) to show ` <. F , O >. ` first.  Note
       that ` O ` and ` ( _I |`` T ) ` are the zero and one of the division
       ring ` E ` , and ` ( _I |`` B ) ` is the zero of the translation group.
       ` S ` is the scalar product.  (Contributed by NM, 21-Nov-2013.)
       (New usage is discouraged.) $)
    dvhopN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( F e. T /\ U e. E ) )
  -> <. F , U >.
       = ( <. F , O >. A ( U S <. ( _I |` B ) , ( _I |` T ) >. ) ) ) $=
      ( chlt wcel wa cop cid cres co ccom wceq simprr idltrn tendoidcl dvhopspN
      adantr syl12anc tendoid adantrl tendo1mulr opeq12d oveq2d simprl tendo0cl
      cfv eqtrd dvhopaddN syl22anc wf1o ltrn1o adantrr f1of fcoi1 3syl tendo0pl
      wf 3eqtrrd ) LUGUHNKUHUIZJEUHZFIUHZUIZUIZJMUJZFUKBULZUKEULZUJDUMZAUMWGWHF
      UJZAUMZJWHUNZMFCUMZUJZJFUJWFWJWKWGAWFWJWHFVIZFWIUNZUJZWKWFWDWHEUHZWIIUHZW
      JWRUOWBWCWDUPZWBWSWEBEKLNSTUAUQUTZWBWTWEEIKLNTUAUBURUTFDEWIGIWHOUEUSVAWFW
      PWHWQFWBWDWPWHUOWCBFIKLNSTUBVBVCWBWDWQFUOWCEFIKLNTUAUBVDVCVEVJVFWFWCMIUHZ
      WSWDWLWOUOWBWCWDVGWBXCWEBERIKLMNSTUAUBUFVHUTXBXAACEMGHIJWHFUDVKVLWFWMJWNF
      WFBBJVMZBBJVTWMJUOWBWCXDWDBEJKLUGNSTUAVNVOBBJVPBBJVQVRWBWDWNFUOWCQBCFERIK
      LMNPSTUAUBUFUCVSVCVEWA $.
  $}

  ${
    $d u v w x y z .+ $.  $d u v w x y z F $.  $d u x y H $.  $d u x y K $.
    $d u x y S $.  $d u v w x y z T $.  $d u v U $.  $d u x y W $.
    $d u v w x y z X $.  $d u v w x y z Y $.
    dvhopellsm.h $e |- H = ( LHyp ` K ) $.
    dvhopellsm.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvhopellsm.a $e |- .+ = ( +g ` U ) $.
    dvhopellsm.s $e |- S = ( LSubSp ` U ) $.
    dvhopellsm.p $e |- .(+) = ( LSSum ` U ) $.
    $( Ordered pair membership in a subspace sum.  (Contributed by NM,
       12-Mar-2014.) $)
    dvhopellsm $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. S /\ Y e. S )
  -> ( <. F , T >. e. ( X .(+) Y ) <-> E. x E. y E. z E. w
        ( ( <. x , y >. e. X /\ <. z , w >. e. Y )
            /\ <. F , T >. = ( <. x , y >. .+ <. z , w >. ) ) ) ) $=
      ( vu vv chlt wcel wa w3a cop co cv wceq wrex wex csubg cfv wb wss dvhlmod
      clmod id 3ad2ant1 lsssssubg syl simp2 sseldd simp3 lsmelval syl2anc cltrn
      wrel ctendo cxp cbs eqid lssss 3ad2ant3 dvhvbase sseqtrd relxp relss ee10
      oveq2 eqeq2d exopxfr2 rexbidv 3ad2ant2 oveq1 anbi2d 2exbidv 19.42vv anass
      2exbii bicomi a1i syl5bbr bitrd 3bitrd ) LUCUDMKUDUEZNGUDZOGUDZUFZJHUGZNO
      FUHUDZXAUAUIZUBUIZEUHZUJZUBOUKZUANUKZCUIDUIUGZOUDZXAXCXIEUHZUJZUEZDULCULZ
      UANUKZAUIBUIUGZNUDZXJUEXAXPXIEUHZUJZUEZDULCULZBULAULZWTNIUMUNZUDOYCUDXBXH
      UOWTGYCNWTIURUDZGYCUPWQWRYDWSWQIKLMPQWQUSUQUTGISVAVBZWQWRWSVCVDWTGYCOYEWQ
      WRWSVEVDUAUBEFNOIXARTVFVGWTXGXNUANWTOVIZXGXNUOWTOMLVHUNUNZMLVJUNUNZVKZUPY
      IVIZYFWTOIVLUNZYIWSWQOYKUPWRGOYKIYKVMZSVNVOWQWRYKYIUJWSYGIYHKLYKMUCPYGVMY
      HVMQYLVPUTZVQYGYHVRZOYIVSVTXFXLUBCDOXDXIUJXEXKXAXDXIXCEWAWBWCVBWDWTXOXQXJ
      XSUEZDULCULZUEZBULAULZYBWTNVIZXOYRUOWTNYIUPYJYSWTNYKYIWRWQNYKUPWSGNYKIYLS
      VNWEYMVQYNNYIVSVTXNYPUAABNXCXPUJZXMYOCDYTXLXSXJYTXKXRXAXCXPXIEWFWBWGWHWCV
      BWTYQYAABYQXQYOUEZDULCULZWTYAXQYOCDWIUUBYAUOWTYAUUBXTUUACDXQXJXSWJWKWLWMW
      NWHWOWP $.
  $}

  ${
    $d f g r s .<_ $.  $d r .\/ $.  $d f g r s A $.  $d q s C $.  $d g s G $.
    $d w F $.  $d f g s H $.  $d g I $.  $d f g s K $.  $d f g q r s w P $.
    $d f s R $.  $d f q s w T $.  $d f g r s V $.  $d f g r s W $.  $d f q s $.
    cdlemm10.l $e |- .<_ = ( le ` K ) $.
    cdlemm10.j $e |- .\/ = ( join ` K ) $.
    cdlemm10.a $e |- A = ( Atoms ` K ) $.
    cdlemm10.h $e |- H = ( LHyp ` K ) $.
    cdlemm10.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemm10.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemm10.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    cdlemm10.c $e |- C = { r e. A | ( r .<_ ( P .\/ V ) /\ -. r .<_ W ) } $.
    $( Can be eliminated: $)
    cdlemm10.f $e |- F = ( iota_ f e. T ( f ` P ) = s ) $.
    cdlemm10.g $e |- G = ( q e. C |-> ( iota_ f e. T ( f ` P ) = q ) ) $.
    $( The image of the map ` G ` is the entire one-dimensional subspace
       ` ( I `` V ) ` .  Remark after Lemma M of [Crawley] p. 121 line 23.
       (Contributed by NM, 24-Nov-2013.)  (New usage is discouraged.) $)
    cdlemm10N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( P e. A /\ -. P .<_ W )
         /\ ( V e. A /\ V .<_ W ) )
      -> ran G = ( I ` V ) ) $=
      ( vg chlt wcel wa wbr wn w3a crn cfv cv wceq wrex wfn crio riotaex fnmpti
      wb fvelrnb ax-mp weq eqeq2 riotabidv fvmpt syl6eqr adantl eqeq1d rexbidva
      crab simpl1 simprl simpl2l ltrnat syl3anc cbs eqid clat simpl1l hllat syl
      co atbase ltrncl latjcl simpl3l hlatjcl latlej2 simpl2 trljat1 wi syl2anc
      simprr trlcl latjlej2 syl13anc eqbrtrrd lattrd ltrnel simprd breq1 notbid
      mpd jca anbi12d elrab2 cdlemeiota eqcomd syl5eq rspcev ex simpl2r simprrr
      ltrniotacl ltrniotaval syl122anc simp3l cmee simp11 simp12 trlval2 simp3r
      sylanbrc oveq2d oveq1d hlatlej1 simprrl ad2antrl latjle12 mpbi2and breq1d
      eqtrd fveq2 bitr4d simpl1r lhpbase lhpat4N adantr breqtrd 3adant3 eqbrtrd
      latmlem1 mpd3an3 sylan2b eleq1 biimpcd syl6 rexlimdv impbid elrab syl6bbr
      simp1l simp1r diaval syl22anc eleq2d syl5bb eqrdv ) LUJUKZOIUKZULZCAUKZCO
      MUMUNZULZNAUKZNOMUMZULZUOZUIHUPZNJUQZUIURZUVOUKZPURZHUQZUVQUSZPBUTZUVNUVQ
      UVPUKZHBVAUVRUWBVERBCFURZUQZRURZUSZFEVBZHUWGFEVCUHVDPBUVQHVFVGUVNUWBUVQUW
      DDUQZNMUMZFEVPZUKZUWCUVNUWBUVQEUKZUVQDUQZNMUMZULZUWLUVNUWBGUVQUSZPBUTZUWP
      UVNUWAUWQPBUVNUVSBUKZULUVTGUVQUWSUVTGUSUVNUWSUVTUWEUVSUSZFEVBZGRUVSUWHUXA
      BHRPVHUWGUWTFEUWFUVSUWEVIVJUHUWTFEVCVKUGVLVMVNVOUVNUWPUWRUVNUWPUWRUVNUWPU
      LZCUVQUQZBUKZUWEUXCUSZFEVBZUVQUSZUWRUXBUXCAUKZUXCCNKWHZMUMZUXCOMUMZUNZULZ
      UXDUXBUVGUWMUVHUXHUVGUVJUVMUWPVQZUVNUWMUWOVRZUVHUVIUVGUVMUWPVSZACEUVQILMO
      SUAUBUCVTWAUXBUXJUXLUXBLWBUQZLMUXCCUXCKWHZUXIUXQWCZSUXBUVELWDUKZUVEUVFUVJ
      UVMUWPWEZLWFZWGZUXBUVGUWMCUXQUKZUXCUXQUKZUXNUXOUXBUVHUYDUXPAUXQCLUXSUAWIZ
      WGZUXQEUVQILUJOCUXSUBUCWJWAZUXBUXTUYDUYEUXRUXQUKUYCUYGUYHUXQKLCUXCUXSTWKW
      AUXBUVEUVHUVKUXIUXQUKZUYAUXPUVKUVLUVGUVJUWPWLZAUXQKLCNUXSTUAWMZWAUXBUXTUY
      DUYEUXCUXRMUMUYCUYGUYHUXQKLMCUXCUXSSTWNWAUXBCUWNKWHZUXRUXIMUXBUVGUWMUVJUY
      LUXRUSUXNUXOUVGUVJUVMUWPWOZACDEUVQIKLMOSTUAUBUCUDWPWAUXBUWOUYLUXIMUMZUVNU
      WMUWOWSUXBUXTUWNUXQUKZNUXQUKZUYDUWOUYNWQUYCUXBUVGUWMUYOUXNUXOUXQDEUVQILOU
      XSUBUCUDWTWRUXBUVKUYPUYJAUXQNLUXSUAWIZWGUYGUXQKLMUWNNCUXSSTXAXBXIXCXDUXBU
      VGUWMUVJUXLUXNUXOUYMUVGUWMUVJUOUXHUXLACEUVQILMOSUAUBUCXEXFWAXJQURZUXIMUMZ
      UYROMUMZUNZULZUXMQUXCABUYRUXCUSZUYSUXJVUAUXLUYRUXCUXIMXGVUCUYTUXKUYRUXCOM
      XGXHXKUFXLYIUXBUVQUXFUXBUVGUVJUWMUVQUXFUSUXNUYMUXOACEFUVQILMOSUAUBUCXMWAX
      NUWQUXGPUXCBUVSUXCUSZGUXFUVQVUDGUXAUXFUGVUDUWTUXEFEUVSUXCUWEVIVJXOVNXPWRX
      QUVNUWQUWPPBUVNUWSGEUKZGDUQZNMUMZULZUWQUWPWQUVNUWSVUHUWSUVNUVSAUKZUVSUXIM
      UMZUVSOMUMZUNZULZULZVUHVUBVUMQUVSABQPVHZUYSVUJVUAVULUYRUVSUXIMXGVUOUYTVUK
      UYRUVSOMXGXHXKUFXLUVNVUNVUECGUQZUVSUSZULZVUHUVNVUNULZUVGUVHUVIVUIVULVURUV
      GUVJUVMVUNVQUVHUVIUVGUVMVUNVSZUVHUVIUVGUVMVUNXRUVNVUIVUMVRZUVNVUIVUJVULXS
      UVGUVJVUIVULULUOVUEVUQACUVSEFGILMOSUAUBUCUGXTACUVSEFGILMOSUAUBUCUGYAXJYBU
      VNVUNVURUOZVUEVUGUVNVUNVUEVUQYCZVVBVUFCUVSKWHZOLYDUQZWHZNMVVBVUFCVUPKWHZO
      VVEWHZVVFVVBUVGVUEUVJVUFVVHUSUVGUVJUVMVUNVURYEVVCUVGUVJUVMVUNVURYFACDEGIK
      LMVVEOSTVVEWCZUAUBUCUDYGWAVVBVVGVVDOVVEVVBVUPUVSCKUVNVUNVUEVUQYHYJYKYRUVN
      VUNVVFNMUMVURVUSVVFUXIOVVEWHZNMVUSVVDUXIMUMZVVFVVJMUMZVUSCUXIMUMZVUJVVKVU
      SUVEUVHUVKVVMUVEUVFUVJUVMVUNWEZVUTUVKUVLUVGUVJVUNWLZACNKLMSTUAYLWAUVNVUIV
      UJVULYMVUSUXTUYDUVSUXQUKZUYIVVMVUJULVVKVEVUSUVEUXTVVNUYBWGZVUSUVHUYDVUTUY
      FWGVUIVVPUVNVUMAUXQUVSLUXSUAWIYNVUSUVEUVHUVKUYIVVNVUTVVOUYKWAZUXQKLMCUVSU
      XIUXSSTYOXBYPVUSUXTVVDUXQUKZUYIOUXQUKZVVKVVLWQVVQVUSUVEUVHVUIVVSVVNVUTVVA
      AUXQKLCUVSUXSTUAWMWAVVRVUSUVFVVTUVEUVFUVJUVMVUNUUAUXQILOUXSUBUUBWGUXQLMVV
      EVVDUXIOUXSSVVIUUHXBXIUVNVVJNUSVUNACNIKLMVVEOSTVVIUAUBUUCUUDUUEUUFUUGXJUU
      IUUJXQUWQVUHUWPUWQVUEUWMVUGUWOGUVQEUUKUWQVUFUWNNMGUVQDYSYQXKUULUUMUUNUUOY
      TUWJUWOFUVQEFUIVHUWIUWNNMUWDUVQDYSYQUUPUUQUVNUVPUWKUVQUVNUVEUVFUYPUVLUVPU
      WKUSUVEUVFUVJUVMUURUVEUVFUVJUVMUUSUVNUVKUYPUVGUVJUVKUVLYCUYQWGUVGUVJUVKUV
      LYHUXQDEFIJLMUJONUXSSUBUCUDUEUUTUVAUVBYTUVCUVD $.
  $}

  $c ocA $.

  $( Extend class notation with subspace orthocomplement for ` DVecA ` partial
     vector space. $)
  cocaN $a class ocA $.

  ${
    $d k w x z $.
    $( Define subspace orthocomplement for ` DVecA ` partial vector space.
       Temporarily, we are using the range of the isomorphism instead of the
       set of closed subspaces.  Later, when inner product is introduced, we
       will show that these are the same.  (Contributed by NM, 6-Dec-2013.) $)
    df-docaN $a |- ocA = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
          ( x e. ~P ( ( LTrn ` k ) ` w ) |-> ( ( ( DIsoA ` k ) ` w ) `
              ( ( ( ( oc ` k ) ` ( `' ( ( DIsoA ` k ) ` w ) `
     |^| { z e. ran ( ( DIsoA ` k ) ` w ) | x C_ z } ) )
            ( join ` k ) ( ( oc ` k ) ` w ) )
            ( meet ` k ) w ) ) ) ) ) $.
  $}

  ${
    $d k ./\ $.  $d k .\/ $.  $d k w H $.  $d k w x z K $.  $d k ._|_ $.
    docaval.j $e |- .\/ = ( join ` K ) $.
    docaval.m $e |- ./\ = ( meet ` K ) $.
    docaval.o $e |- ._|_ = ( oc ` K ) $.
    docaval.h $e |- H = ( LHyp ` K ) $.
    $( Subspace orthocomplement for ` DVecA ` partial vector space.
       (Contributed by NM, 6-Dec-2013.)  (New usage is discouraged.) $)
    docaffvalN $p |- ( K e. V -> ( ocA ` K ) = ( w e. H |->
        ( x e. ~P ( ( LTrn ` K ) ` w ) |-> ( ( ( DIsoA ` K ) ` w ) `
 ( ( ( ._|_ ` ( `' ( ( DIsoA ` K ) ` w ) ` |^| { z e. ran ( ( DIsoA ` K ) ` w )
         | x C_ z } ) ) .\/ ( ._|_ ` w ) ) ./\ w ) ) ) ) ) $=
      ( cfv cv co cmpt wceq clh fveq2 vk wcel cvv cocaN cltrn cpw wss cdia crab
      crn cint ccnv elex coc cjn syl6eqr fveq1d pweqd cnveqd rneqd rabeq inteqd
      cmee fveq12d oveq123d eqidd mpteq12dv df-docaN fvex eqeltri mptex fvmpt
      syl ) FIUBFUCUBFUDNCDACOZFUENZNZUFZAOBOUGZBVNFUHNZNZUJZUIZUKZVTULZNZHNZVN
      HNZEPZVNGPZVTNZQZQZRFIUMUAFCUAOZSNZAVNWMUENZNZUFZVRBVNWMUHNZNZUJZUIZUKZWS
      ULZNZWMUNNZNZVNXENZWMUONZPZVNWMVCNZPZWSNZQZQWLUCUDWMFRZCWNXMDWKXNWNFSNZDW
      MFSTMUPXNAWQXLVQWJXNWPVPXNVNWOVOWMFUETUQURXNXKWIWSVTXNVNWRVSWMFUHTUQZXNXI
      WHVNVNXJGXNXJFVCNGWMFVCTKUPXNXFWFXGWGXHEXNXHFUONEWMFUOTJUPXNXDWEXEHXNXEFU
      NNHWMFUNTLUPZXNXBWCXCWDXNWSVTXPUSXNXAWBXNWTWARXAWBRXNWSVTXPUTVRBWTWAVAVMV
      BVDVDXNVNXEHXQUQVEXNVNVFVEVDVGVGABCUAVHCDWKDXOUCMFSVIVJVKVLVM $.

    $d w ./\ $.  $d w .\/ $.  $d w x z I $.  $d w ._|_ $.  $d w x T $.
    $d w x z W $.
    docaval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    docaval.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    docaval.n $e |- N = ( ( ocA ` K ) ` W ) $.
    $( Subspace orthocomplement for ` DVecA ` partial vector space.
       (Contributed by NM, 6-Dec-2013.)  (New usage is discouraged.) $)
    docafvalN $p |- ( ( K e. V /\ W e. H ) -> N = ( x e. ~P T |->
        ( I ` ( ( ( ._|_ ` ( `' I ` |^| { z e. ran I | x C_ z } ) )
             .\/ ( ._|_ ` W ) ) ./\ W ) ) ) ) $=
      ( cfv vw wcel cv cltrn cpw wss cdia crn crab cint ccnv co cmpt docaffvalN
      cocaN fveq1d syl5eq fveq2 syl6eqr pweqd cnveqd rneqd rabeq inteqd fveq12d
      wceq syl fveq2d oveq12d id mpteq12dv eqid cvv fvex eqeltri mptex sylan9eq
      pwex fvmpt ) GKUBZLDUBILUADAUAUCZGUDTZTZUEZAUCBUCUFZBWAGUGTZTZUHZUIZUJZWG
      UKZTZJTZWAJTZFULZWAHULZWGTZUMZUMZTZACUEZWEBEUHZUIZUJZEUKZTZJTZLJTZFULZLHU
      LZETZUMZVTILGUOTZTWTSVTLXMWSABUADFGHJKMNOPUNUPUQUALWRXLDWSWALVFZAWDWQXAXK
      XNWCCXNWCLWBTZCWALWBURQUSUTXNWPXJWGEXNWGLWFTEWALWFURRUSZXNWOXIWALHXNWMXGW
      NXHFXNWLXFJXNWJXDWKXEXNWGEXPVAXNWIXCXNWHXBVFWIXCVFXNWGEXPVBWEBWHXBVCVGVDV
      EVHWALJURVIXNVJVIVEVKWSVLAXAXKCCXOVMQLWBVNVOVRVPVSVQ $.

    $d x ./\ $.  $d x .\/ $.  $d x ._|_ $.  $d z T $.  $d x z X $.
    $( Subspace orthocomplement for ` DVecA ` partial vector space.
       (Contributed by NM, 6-Dec-2013.)  (New usage is discouraged.) $)
    docavalN $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ T ) -> ( N ` X )
        = ( I ` ( ( ( ._|_ ` ( `' I ` |^| { z e. ran I | X C_ z } ) )
            .\/ ( ._|_ ` W ) ) ./\ W ) ) ) $=
      ( vx cfv chlt wcel wa wss cpw cv crn crab cint ccnv cmpt docafvalN adantr
      co wceq fveq1d cvv cltrn fvex eqeltri elpw2 biimpri adantl rabbidv inteqd
      sseq1 fveq2d oveq1d eqid fvmptg sylancl eqtrd ) FUAUBJCUBUCZKBUDZUCZKHTKS
      BUEZSUFZAUFZUDZADUGZUHZUIZDUJZTZITZJITZEUNZJGUNZDTZUKZTZKVRUDZAVTUHZUIZWC
      TZITZWFEUNZJGUNZDTZVOKHWJVMHWJUOVNSABCDEFGHIUAJLMNOPQRULUMUPVOKVPUBZWSUQU
      BWKWSUOVNWTVMWTVNKBBJFURTZTUQPJXAUSUTVAVBVCWRDUSSKWIWSVPUQWJVQKUOZWHWRDXB
      WGWQJGXBWEWPWFEXBWDWOIXBWBWNWCXBWAWMXBVSWLAVTVQKVRVFVDVEVGVGVHVHVGWJVIVJV
      KVL $.
  $}

  ${
    $d z I $.  $d z K $.  $d z T $.  $d z W $.  $d z X $.
    docacl.h $e |- H = ( LHyp ` K ) $.
    docacl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    docacl.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    docacl.n $e |- ._|_ = ( ( ocA ` K ) ` W ) $.
    $( Closure of subspace orthocomplement for ` DVecA ` partial vector space.
       (Contributed by NM, 6-Dec-2013.)  (New usage is discouraged.) $)
    docaclN $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ T )
          -> ( ._|_ ` X ) e. ran I ) $=
      ( vz chlt wcel wa wss cfv eqid syl2anc syl3anc crn crab cint ccnv coc cjn
      cv co cmee docavalN wfun cdm wf1o diaf11N f1ofun syl adantr cbs cple clat
      wbr hllat ad2antrr cops hlop c0 wne simpl ssrab2 a1i dia1elN anim1i sseq2
      elrab sylibr diaintclN syl12anc diacnvclN syldan diadmclN opoccl ad2antlr
      ne0i lhpbase latjcl latmcl latmle2 wb diaeldm mpbir2and fvelrn eqeltrd )
      DMNZFBNZOZGAPZOZGEQGLUGZPZLCUAZUBZUCZCUDQZDUEQZQZFXDQZDUFQZUHZFDUIQZUHZCQ
      ZWTLABCXGDXIEXDFGXGRZXIRZXDRZHIJKUJWQCUKZXJCULZNZXKWTNWOXOWPWOXPWTCUMXOBC
      DFHJUNXPWTCUOUPUQWQXQXJDURQZNZXJFDUSQZVAZWQDUTNZXHXRNZFXRNZXSWMYBWNWPDVBV
      CZWQYBXEXRNZXFXRNZYCYEWQDVDNZXCXRNZYFWMYHWNWPDVEVCZWOWPXCXPNZYIWOWPXBWTNZ
      YKWQWOXAWTPZXAVFVGZYLWOWPVHYMWQWSLWTVIVJWQAXANZYNWQAWTNZWPOYOWOYPWPABCDFH
      IJVKVLWSWPLAWTWRAGVMVNVOXAAWCUPXABCDFHJVPVQBCDFXBHJVRVSXRBCDMFXCXRRZHJVTV
      SXRDXDXCYQXNWASWQYHYDYGYJWNYDWMWPXRBDFYQHWDWBZXRDXDFYQXNWASXRXGDXEXFYQXLW
      ETZYRXRDXIXHFYQXMWFTWQYBYCYDYAYEYSYRXRDXTXIXHFYQXTRZXMWGTWOXQXSYAOWHWPXRB
      CDXTMFXJYQYTHJWIUQWJXJCWKSWL $.
  $}

  ${
    $d z I $.  $d z K $.  $d z T $.  $d z W $.  $d z X $.
    diaoc.j $e |- .\/ = ( join ` K ) $.
    diaoc.m $e |- ./\ = ( meet ` K ) $.
    diaoc.o $e |- ._|_ = ( oc ` K ) $.
    diaoc.h $e |- H = ( LHyp ` K ) $.
    diaoc.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diaoc.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    diaoc.n $e |- N = ( ( ocA ` K ) ` W ) $.
    $( Value of partial isomorphism A at lattice orthocomplement (using a
       Sasaki projection to get orthocomplement relative to the fiducial
       co-atom ` W ` ).  (Contributed by NM, 6-Dec-2013.)
       (New usage is discouraged.) $)
    diaocN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. dom I ) ->
   ( I ` ( ( ( ._|_ ` X ) .\/ ( ._|_ ` W ) ) ./\ W ) ) = ( N ` ( I ` X ) ) ) $=
      ( vz wcel cfv chlt wa cdm cv wss crn crab cint ccnv co wceq cbs wbr simpl
      cple eqid diadmclN diadmleN syl12anc docavalN syldan diaclN intmin fveq2d
      diass syl wf1o diaf11N f1ocnvfv1 sylan eqtrd oveq1d eqtr2d ) EUASIBSUBZJC
      UCZSZUBZJCTZGTZVRRUDUERCUFZUGUHZCUIZTZHTZIHTZDUJZIFUJZCTZJHTZWEDUJZIFUJZC
      TVNVPVRAUEZVSWHUKVQVNJEULTZSJIEUOTZUMWLVNVPUNWMBCEUAIJWMUPZNPUQBCEWNUAIJW
      NUPZNPURWMABCEWNUAIJWOWPNOPVEUSRABCDEFGHIVRKLMNOPQUTVAVQWGWKCVQWFWJIFVQWD
      WIWEDVQWCJHVQWCVRWBTZJVQWAVRWBVQVRVTSWAVRUKBCEIJNPVBRVRVTVCVFVDVNVOVTCVGV
      PWQJUKBCEINPVHVOVTJCVIVJVKVDVLVLVDVM $.
  $}

  ${
    doca2.h $e |- H = ( LHyp ` K ) $.
    doca2.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    doca2.n $e |- ._|_ = ( ( ocA ` K ) ` W ) $.
    $( Double orthocomplement of partial isomorphism A. (Contributed by NM,
       6-Dec-2013.)  (New usage is discouraged.) $)
    doca2N $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. dom I )
     -> ( ._|_ ` ( ._|_ ` ( I ` X ) ) ) = ( I ` X ) ) $=
      ( chlt wcel wa cfv co wceq ad2antrr eqid syl3anc oveq1d fveq2d cdm oldmm1
      coc cjn cmee col hlol diadmclN lhpbase ad2antlr eqcomd clat latmcl oldmm2
      hllat eqtrd cops hlop opoccl syl2anc latjass syl13anc latjidm oveq2d coml
      cbs cple hloml latmle2 omlspjN syl121anc diadmleN latleeqm1 mpbid 3eqtrrd
      wbr wb latjcl diaeldm adantr mpbir2and cltrn diaocN syldan ) CJKZEAKZLZFB
      UAZKZLZFBMZFCUCMZMZEWLMZCUDMZNZECUEMZNZWLMZWNWONZEWQNZBMZWRBMZDMZWKDMZDMW
      JFXABWJXAFEWQNZWNWONZEWQNZXFFWJWTXGEWQWJWTXGWNWONZXGWJWSXGWNWOWJWSXFWLMZE
      WQNZWLMZXGWJWRXKWLWJXKWRWJXJWPEWQWJCUFKZFCVFMZKZEXNKZXJWPOWEXMWFWICUGPZXN
      ABCJEFXNQZGHUHZWFXPWEWIXNACEXRGUIUJZXNWOCWQWLFEXRWOQZWQQZWLQZUBRSUKTWJXMX
      FXNKZXPXLXGOXQWJCULKZXOXPYDWEYEWFWICUOPZXSXTXNCWQFEXRYBUMRZXTXNWOCWQWLXFE
      XRYAYBYCUNRUPSWJXIXFWNWNWONZWONZXGWJYEYDWNXNKZYJXIYIOYFYGWJCUQKZXPYJWEYKW
      FWICURPZXTXNCWLEXRYCUSUTZYMXNWOCXFWNWNXRYAVAVBWJYHWNXFWOWJYEYJYHWNOYFYMXN
      WOCWNXRYAVCUTVDUPUPSWJCVEKZYDXPXFECVGMZVPZXHXFOWEYNWFWICVHPYGXTWJYEXOXPYP
      YFXSXTXNCYOWQFEXRYOQZYBVIRXNWOCYOWQWLXFEXRYQYAYBYCVJVKWJFEYOVPZXFFOZABCYO
      JEFYQGHVLWJYEXOXPYRYSVQYFXSXTXNCYOWQFEXRYQYBVMRVNVOTWGWIWRWHKZXBXDOWJYTWR
      XNKZWREYOVPZWJYEWPXNKZXPUUAYFWJYEWMXNKZYJUUCYFWJYKXOUUDYLXSXNCWLFXRYCUSUT
      YMXNWOCWMWNXRYAVRRZXTXNCWQWPEXRYBUMRWJYEUUCXPUUBYFUUEXTXNCYOWQWPEXRYQYBVI
      RWGYTUUAUUBLVQWIXNABCYOJEWRXRYQGHVSVTWAECWBMMZABWOCWQDWLEWRYAYBYCGUUFQZHI
      WCWDWJXCXEDUUFABWOCWQDWLEFYAYBYCGUUGHIWCTVO $.

    $( Double orthocomplement of partial isomorphism A. (Contributed by NM,
       17-Jan-2014.)  (New usage is discouraged.) $)
    doca3N $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
     -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $=
      ( chlt wcel wa crn ccnv cfv cdm wceq diacnvclN doca2N fveq2d wf1o diaf11N
      syldan f1ocnvfv2 sylan 3eqtr3d ) CJKEAKLZFBMZKZLZFBNOZBOZDOZDOZULFDOZDOFU
      GUIUKBPZKUNULQABCEFGHRABCDEUKGHISUCUJUMUODUJULFDUGUPUHBUAUIULFQABCEGHUBUP
      UHFBUDUEZTTUQUF $.
  $}

  ${
    dvadia.h $e |- H = ( LHyp ` K ) $.
    dvadia.u $e |- U = ( ( DVecA ` K ) ` W ) $.
    dvadia.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    dvadia.n $e |- ._|_ = ( ( ocA ` K ) ` W ) $.
    dvadia.s $e |- S = ( LSubSp ` U ) $.
    $( Any closed subspace is a member of the range of partial isomorphism A,
       showing the isomorphism maps onto the set of closed subspaces of partial
       vector space A. (Contributed by NM, 17-Jan-2014.)
       (New usage is discouraged.) $)
    dvadiaN $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( X e. S /\ ( ._|_ ` ( ._|_ ` X ) ) = X ) ) -> X e. ran I ) $=
      ( chlt wcel wa cfv wceq wss syldan crn simprr cltrn cbs ad2antrl dvavbase
      eqid lssss adantr sseqtrd docaclN diaelrnN eqeltrrd ) ENOGCOPZHAOZHFQZFQZ
      HRZPZPZUQHDUAZUNUOURUBUNUSUPGEUCQQZSZUQVAOUNUSUPVAOZVCUNUSHVBSVDUTHBUDQZV
      BUOHVESUNURAHVEBVEUGZMUHUEUNVEVBRUSVBBCEVEGNIVBUGZJVFUFUIUJVBCDEFGHIVGKLU
      KTUPVBCDENGIVGKULTVBCDEFGUPIVGKLUKTUM $.

    $d x H $.  $d x I $.  $d x K $.  $d x S $.  $d x W $.
    $( Partial isomorphism A maps onto the set of all closed subspaces of
       partial vector space A. Part of Lemma M of [Crawley] p. 121 line 12,
       with closed subspaces rather than subspaces.  (Contributed by NM,
       17-Jan-2014.)  (New usage is discouraged.) $)
    diarnN $p |- ( ( K e. HL /\ W e. H ) ->
         ran I = { x e. S | ( ._|_ ` ( ._|_ ` x ) ) = x } ) $=
      ( chlt wcel wa crn cin cfv wceq cv wss diasslssN dfss5 sylib wi doca3N ex
      crab adantr dvadiaN expr impbid rabbi2dva eqtrd ) FNOHDOPZEQZBUQRZAUAZGSG
      SUSTZABUIUPUQBUBUQURTBCDEFHIJKMUCUQBUDUEUPUTABUQUPUSBOZPUSUQOZUTUPVBUTUFV
      AUPVBUTDEFGHUSIKLUGUHUJUPVAUTVBBCDEFGHUSIJKLMUKULUMUNUO $.

    $( The partial isomorphism A for a lattice ` K ` is a one-to-one, onto
       function.  Part of Lemma M of [Crawley] p. 121 line 12, with closed
       subspaces rather than subspaces.  See ~ diadm for the domain.
       (Contributed by NM, 17-Jan-2014.)  (New usage is discouraged.) $)
    diaf1oN $p |- ( ( K e. HL /\ W e. H )
       -> I : dom I -1-1-onto-> { x e. S | ( ._|_ ` ( ._|_ ` x ) ) = x } ) $=
      ( chlt wcel cfv wceq wf1 wf1o syl wa cdm cv crab crn diaf11N f1of1 diarnN
      wb f1eq3 mpbid dff1o5 sylanbrc ) FNOHDOUAZEUBZAUCZGPGPUPQABUDZERZEUEZUQQZ
      UOUQESUNUOUSERZURUNUOUSESVADEFHIKUFUOUSEUGTUNUTVAURUIABCDEFGHIJKLMUHZUSUQ
      UOEUJTUKVBUOUQEULUM $.
  $}

  $c vA $.

  $( Extend class notation with subspace join for ` DVecA ` partial vector
     space. $)
  cdjaN $a class vA $.

  ${
    $d k w x y z $.
    $( Define (closed) subspace join for ` DVecA ` partial vector space.
       (Contributed by NM, 6-Dec-2013.) $)
    df-djaN $a |- vA = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
          ( x e. ~P ( ( LTrn ` k ) ` w ) , y e. ~P ( ( LTrn ` k ) ` w ) |->
      ( ( ( ocA ` k ) ` w ) `
     ( ( ( ( ocA ` k ) ` w ) ` x ) i^i ( ( ( ocA ` k ) ` w ) ` y ) ) ) ) ) ) $.
  $}

  ${
    $d k w H $.  $d k w x y K $.
    djaval.h $e |- H = ( LHyp ` K ) $.
    $( Subspace join for ` DVecA ` partial vector space.  (Contributed by NM,
       6-Dec-2013.)  (New usage is discouraged.) $)
    djaffvalN $p |- ( K e. V -> ( vA ` K ) = ( w e. H |->
        ( x e. ~P ( ( LTrn ` K ) ` w ) , y e. ~P ( ( LTrn ` K ) ` w )
     |-> ( ( ( ocA ` K ) ` w ) `
     ( ( ( ( ocA ` K ) ` w ) ` x ) i^i ( ( ( ocA ` K ) ` w ) ` y ) ) ) ) ) ) $=
      ( vk wcel cvv cdjaN cfv cv cltrn cpw cocaN cin clh fveq2 fveq1d cmpt wceq
      cmpt2 syl6eqr pweqd ineq12d fveq12d mpt2eq123dv mpteq12dv df-djaN eqeltri
      elex fvex mptex fvmpt syl ) EFIEJIEKLCDABCMZENLZLZOZUTAMZUQEPLZLZLZBMZVCL
      ZQZVCLZUCZUAZUBEFULHECHMZRLZABUQVKNLZLZOZVOVAUQVKPLZLZLZVEVQLZQZVQLZUCZUA
      VJJKVKEUBZCVLWBDVIWCVLERLZDVKERSGUDWCABVOVOWAUTUTVHWCVNUSWCUQVMURVKENSTUE
      ZWEWCVTVGVQVCWCUQVPVBVKEPSTZWCVRVDVSVFWCVAVQVCWFTWCVEVQVCWFTUFUGUHUIABCHU
      JCDVIDWDJGERUMUKUNUOUP $.

    $d w ._|_ $.  $d w x y T $.  $d w x y W $.
    djaval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    djaval.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    djaval.n $e |- ._|_ = ( ( ocA ` K ) ` W ) $.
    djaval.j $e |- J = ( ( vA ` K ) ` W ) $.
    $( Subspace join for ` DVecA ` partial vector space.  TODO: take out
       hypothesis .i, no longer used.  (Contributed by NM, 6-Dec-2013.)
       (New usage is discouraged.) $)
    djafvalN $p |- ( ( K e. V /\ W e. H ) -> J = ( x e. ~P T ,
        y e. ~P T |-> ( ._|_ ` ( ( ._|_ ` x ) i^i ( ._|_ ` y ) ) ) ) ) $=
      ( vw wcel cv cfv fveq1d cltrn cpw cocaN cmpt2 cmpt cdjaN djaffvalN syl5eq
      cin wceq fveq2 syl6eqr pweqd ineq12d fveq12d mpt2eq123dv eqid cvv eqeltri
      fvex pwex mpt2ex fvmpt sylan9eq ) GIQZJDQFJPDABPRZGUASZSZUBZVIARZVFGUCSZS
      ZSZBRZVLSZUIZVLSZUDZUEZSZABCUBZWAVJHSZVNHSZUIZHSZUDZVEFJGUFSZSVTOVEJWGVSA
      BPDGIKUGTUHPJVRWFDVSVFJUJZABVIVIVQWAWAWEWHVHCWHVHJVGSZCVFJVGUKLULUMZWJWHV
      PWDVLHWHVLJVKSHVFJVKUKNULZWHVMWBVOWCWHVJVLHWKTWHVNVLHWKTUNUOUPVSUQABWAWAW
      ECCWIURLJVGUTUSVAZWLVBVCVD $.

    $d x y ._|_ $.  $d x y X $.  $d x y Y $.
    $( Subspace join for ` DVecA ` partial vector space.  (Contributed by NM,
       6-Dec-2013.)  (New usage is discouraged.) $)
    djavalN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X C_ T /\ Y C_ T ) )
          -> ( X J Y ) = ( ._|_ ` ( ( ._|_ ` X ) i^i ( ._|_ ` Y ) ) ) ) $=
      ( vx vy wcel wa cfv wceq chlt wss co cpw cv cin cmpt2 djafvalN adantr cvv
      oveqd cltrn fvex eqeltri elpw2 biimpri ad2antrl ad2antll a1i fveq2 ineq1d
      fveq2d ineq2d eqid ovmpt2g syl3anc eqtrd ) EUAQGBQRZHAUBZIAUBZRZRZHIDUCHI
      OPAUDZVMOUEZFSZPUEZFSZUFZFSZUGZUCZHFSZIFSZUFZFSZVLDVTHIVHDVTTVKOPABCDEFUA
      GJKLMNUHUIUKVLHVMQZIVMQZWEUJQZWAWETVIWFVHVJWFVIHAAGEULSZSUJKGWIUMUNZUOUPU
      QVJWGVHVIWGVJIAWJUOUPURWHVLWDFUMUSOPHIVMVMVSWEVTWBVQUFZFSUJVNHTZVRWKFWLVO
      WBVQVNHFUTVAVBVPITZWKWDFWMVQWCWBVPIFUTVCVBVTVDVEVFVG $.
  $}

  ${
    djacl.h $e |- H = ( LHyp ` K ) $.
    djacl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    djacl.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    djacl.j $e |- J = ( ( vA ` K ) ` W ) $.
    $( Closure of subspace join for ` DVecA ` partial vector space.
       (Contributed by NM, 5-Dec-2013.)  (New usage is discouraged.) $)
    djaclN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X C_ T /\ Y C_ T ) )
          -> ( X J Y ) e. ran I ) $=
      ( chlt wcel wa wss co cfv docaclN syldan cocaN cin crn eqid djavalN inss1
      adantrr diaelrnN syl5ss eqeltrd ) EMNFBNOZGAPZHAPZOZOZGHDQGFEUARRZRZHUPRZ
      UBZUPRZCUCZABCDEUPFGHIJKUPUDZLUEUKUNUSAPUTVANUOUSUQAUQURUFUKUNUQVANZUQAPU
      KULVCUMABCEUPFGIJKVBSUGUQABCEMFIJKUHTUIABCEUPFUSIJKVBSTUJ $.
  $}

  ${
    djaj.k $e |- .\/ = ( join ` K ) $.
    djaj.h $e |- H = ( LHyp ` K ) $.
    djaj.i $e |- I = ( ( DIsoA ` K ) ` W ) $.
    djaj.j $e |- J = ( ( vA ` K ) ` W ) $.
    $( Transfer lattice join to ` DVecA ` partial vector space closed subspace
       join.  Part of Lemma M of [Crawley] p. 120 line 29, with closed subspace
       join rather than subspace sum.  (Contributed by NM, 5-Dec-2013.)
       (New usage is discouraged.) $)
    djajN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. dom I /\ Y e. dom I ) )
          -> ( I ` ( X .\/ Y ) ) = ( ( I ` X ) J ( I ` Y ) ) ) $=
      ( chlt wcel wa cfv co wceq wbr syl3anc cdm coc cmee cocaN cple clat hllat
      cbs ad2antrr cops diadmclN adantrr opoccl syl2anc lhpbase ad2antlr latjcl
      hlop eqid latmcl adantrl latmle2 lattrd wb diaeldm adantr mpbir2and cltrn
      diaocN syldan hloml diadmleN latjle12 syl13anc mpbi2and omlspjN syl121anc
      coml latjidm oveq2d latjass col hlol oldmm2 oldmj1 latleeqm1 mpbid fveq2d
      oldmm1 eqtr3d oveq12d eqtrd oveq1d latmmdir cin wss simpl diaclN diaelrnN
      crn djavalN syl12anc diameetN ineq12d eqtr4d 3eqtr4d ) EMNZFANZOZGBUAZNZH
      XJNZOZOZGEUBPZPZFXOPZDQZFEUCPZQZHXOPZXQDQZFXSQZXSQZXOPZXQDQZFXSQZBPZYDBPZ
      FEUDPPZPZGHDQZBPGBPZHBPZCQZXIXMYDXJNZYHYKRXNYPYDEUHPZNZYDFEUEPZSZXNEUFNZX
      TYQNZYCYQNZYRXGUUAXHXMEUGUIZXNUUAXRYQNZFYQNZUUBUUDXNUUAXPYQNZXQYQNZUUEUUD
      XNEUJNZGYQNZUUGXGUUIXHXMEURUIZXIXKUUJXLYQABEMFGYQUSZJKUKULZYQEXOGUULXOUSZ
      UMUNXNUUIUUFUUHUUKXHUUFXGXMYQAEFUULJUOUPZYQEXOFUULUUNUMUNZYQDEXPXQUULIUQT
      ZUUOYQEXSXRFUULXSUSZUTTZXNUUAYBYQNZUUFUUCUUDXNUUAYAYQNZUUHUUTUUDXNUUIHYQN
      ZUVAUUKXIXLUVBXKYQABEMFHUULJKUKVAZYQEXOHUULUUNUMUNUUPYQDEYAXQUULIUQTZUUOY
      QEXSYBFUULUURUTTZYQEXSXTYCUULUURUTTZXNYQEYSYDYCFUULYSUSZUUDUVFUVEUUOXNUUA
      UUBUUCYDYCYSSUUDUUSUVEYQEYSXSXTYCUULUVGUURVBTXNUUAUUTUUFYCFYSSZUUDUVDUUOY
      QEYSXSYBFUULUVGUURVBTZVCXIYPYRYTOVDXMYQABEYSMFYDUULUVGJKVEVFVGFEVHPPZABDE
      XSYJXOFYDIUURUUNJUVJUSZKYJUSZVIVJXNYLYGBXNYLXQDQZFXSQZYLYGXNEVRNZYLYQNZUU
      FYLFYSSZUVNYLRXGUVOXHXMEVKUIXNUUAUUJUVBUVPUUDUUMUVCYQDEGHUULIUQTZUUOXNGFY
      SSZHFYSSZUVQXIXKUVSXLABEYSMFGUVGJKVLULZXIXLUVTXKABEYSMFHUVGJKVLVAZXNUUAUU
      JUVBUUFUVSUVTOUVQVDUUDUUMUVCUUOYQDEYSGHFUULUVGIVMVNVOYQDEYSXSXOYLFUULUVGI
      UURUUNVPVQXNUVMYFFXSXNYLXQXQDQZDQZUVMYFXNUWCXQYLDXNUUAUUHUWCXQRUUDUUPYQDE
      XQUULIVSUNVTXNUVMXQDQZUWDYFXNUUAUVPUUHUUHUWEUWDRUUDUVRUUPUUPYQDEYLXQXQUUL
      IWAVNXNUVMYEXQDXNYLXOPZFXSQZXOPZUVMYEXNEWBNZUVPUUFUWHUVMRXGUWIXHXMEWCUIZU
      VRUUOYQDEXSXOYLFUULIUURUUNWDTXNUWGYDXOXNUWGXRYBXSQZFXSQZYDXNUWFUWKFXSXNUW
      FXPYAXSQZUWKXNUWIUUJUVBUWFUWMRUWJUUMUVCYQDEXSXOGHUULIUURUUNWETXNXPXRYAYBX
      SXNGFXSQZXOPZXPXRXNUWNGXOXNUVSUWNGRZUWAXNUUAUUJUUFUVSUWPVDUUDUUMUUOYQEYSX
      SGFUULUVGUURWFTWGWHXNUWIUUJUUFUWOXRRUWJUUMUUOYQDEXSXOGFUULIUURUUNWITWJXNH
      FXSQZXOPZYAYBXNUWQHXOXNUVTUWQHRZUWBXNUUAUVBUUFUVTUWSVDUUDUVCUUOYQEYSXSHFU
      ULUVGUURWFTWGWHXNUWIUVBUUFUWRYBRUWJUVCUUOYQDEXSXOHFUULIUURUUNWITWJWKWLWMX
      NUWIUUEUUTUUFUWLYDRUWJUUQUVDUUOYQEXSXRYBFUULUURWNVNWLWHWJWMWJWJWMWJWHXNYO
      YMYJPZYNYJPZWOZYJPZYKXNXIYMUVJWPZYNUVJWPZYOUXCRXIXMWQZXIXMYMBWTZNZUXDXIXK
      UXHXLABEFGJKWRULYMUVJABEMFJUVKKWSVJXIXMYNUXGNZUXEXIXLUXIXKABEFHJKWRVAYNUV
      JABEMFJUVKKWSVJUVJABCEYJFYMYNJUVKKUVLLXAXBXNYIUXBYJXNYIXTBPZYCBPZWOZUXBXN
      XIXTXJNZYCXJNZYIUXLRUXFXNUXMUUBXTFYSSZUUSXNUUAUUEUUFUXOUUDUUQUUOYQEYSXSXR
      FUULUVGUURVBTXIUXMUUBUXOOVDXMYQABEYSMFXTUULUVGJKVEVFVGXNUXNUUCUVHUVEUVIXI
      UXNUUCUVHOVDXMYQABEYSMFYCUULUVGJKVEVFVGABEXSFXTYCUURJKXCXBXNUXJUWTUXKUXAX
      IXKUXJUWTRXLUVJABDEXSYJXOFGIUURUUNJUVKKUVLVIULXIXLUXKUXARXKUVJABDEXSYJXOF
      HIUURUUNJUVKKUVLVIVAXDWLWHXEXF $.
  $}

  $c DIsoB $.

  $( Extend class notation with isomorphism B. $)
  cdib $a class DIsoB $.

  ${
    $d k w x f $.
    $( Isomorphism B is isomorphism A extended with an extra dimension set to
       the zero vector component i.e. the zero endormorphism.  Its domain is
       lattice elements less than or equal to the fiducial co-atom ` w ` .
       (Contributed by NM, 8-Dec-2013.) $)
    df-dib $a |- DIsoB = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
        ( x e. dom ( ( DIsoA ` k ) ` w ) |->
         ( ( ( ( DIsoA ` k ) ` w ) ` x ) X. {
          ( f e. ( ( LTrn ` k ) ` w ) |-> ( _I |` ( Base ` k ) ) ) } ) ) ) ) $.
  $}

  ${
    $d k B $.  $d k w H $.  $d f k w x K $.
    dibval.b $e |- B = ( Base ` K ) $.
    dibval.h $e |- H = ( LHyp ` K ) $.
    $( The partial isomorphism B for a lattice ` K ` .  (Contributed by NM,
       8-Dec-2013.) $)
    dibffval $p |- ( K e. V -> ( DIsoB ` K ) = ( w e. H |->
       ( x e. dom ( ( DIsoA ` K ) ` w ) |->
         ( ( ( ( DIsoA ` K ) ` w ) ` x ) X.
            { ( f e. ( ( LTrn ` K ) ` w ) |-> ( _I |` B ) ) } ) ) ) ) $=
      ( vk cvv cfv cv cdia cltrn cid cmpt clh cbs fveq2 wcel cdib cdm cres wceq
      csn elex syl6eqr fveq1d dmeqd reseq2d mpteq12dv sneqd xpeq12d df-dib fvex
      cxp eqeltri mptex fvmpt syl ) FGUAFKUAFUBLBEABMZFNLZLZUCZAMZVDLZDVBFOLZLZ
      PCUDZQZUFZUQZQZQZUEFGUGJFBJMZRLZAVBVPNLZLZUCZVFVSLZDVBVPOLZLZPVPSLZUDZQZU
      FZUQZQZQVOKUBVPFUEZBVQWIEVNWJVQFRLZEVPFRTIUHWJAVTWHVEVMWJVSVDWJVBVRVCVPFN
      TUIZUJWJWAVGWGVLWJVFVSVDWLUIWJWFVKWJDWCWEVIVJWJVBWBVHVPFOTUIWJWDCPWJWDFSL
      CVPFSTHUHUKULUMUNULULABDJUOBEVNEWKKIFRUPURUSUTVA $.

    $d w x J $.  $d w .0. $.  $d f w x W $.
    dibval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dibval.o $e |- .0. = ( f e. T |-> ( _I |` B ) ) $.
    dibval.j $e |- J = ( ( DIsoA ` K ) ` W ) $.
    dibval.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( The partial isomorphism B for a lattice ` K ` .  (Contributed by NM,
       8-Dec-2013.) $)
    dibfval $p |- ( ( K e. V /\ W e. H ) -> I =
        ( x e. dom J |-> ( ( J ` x ) X. { .0. } ) ) ) $=
      ( vw cfv cmpt wcel cdia cdm cltrn cid cres csn cxp dibffval fveq1d syl5eq
      cdib wceq fveq2 syl6eqr dmeqd eqidd mpteq12dv sneqd xpeq12d eqid cvv fvex
      cv eqeltri dmex mptex fvmpt sylan9eq ) HIUAZJEUAFJREARVDZHUBSZSZUCZAVDZVM
      SZDVKHUDSZSZUEBUFZTZUGZUHZTZTZSZAGUCZVOGSZKUGZUHZTZVJFJHULSZSWEQVJJWKWDAR
      BDEHILMUIUJUKRJWCWJEWDVKJUMZAVNWBWFWIWLVMGWLVMJVLSZGVKJVLUNPUOZUPWLVPWGWA
      WHWLVOVMGWNUJWLVTKWLVTDCVSTKWLDVRVSCVSWLVRJVQSCVKJVQUNNUOWLVSUQUROUOUSUTU
      RWDVAAWFWIGGWMVBPJVLVCVEVFVGVHVI $.

    $d x .0. $.  $d x X $.
    $( The partial isomorphism B for a lattice ` K ` .  (Contributed by NM,
       8-Dec-2013.) $)
    dibval $p |- ( ( ( K e. V /\ W e. H ) /\ X e. dom J )
          -> ( I ` X ) = ( ( J ` X ) X. { .0. } ) ) $=
      ( vx wcel cfv wa cdm csn cxp cmpt wceq dibfval adantr fveq1d fveq2 xpeq1d
      cv eqid fvex snex xpex fvmpt adantl eqtrd ) GHSIDSUAZJFUBZSZUAZJETJRVARUL
      ZFTZKUCZUDZUEZTZJFTZVFUDZVCJEVHUTEVHUFVBRABCDEFGHIKLMNOPQUGUHUIVBVIVKUFUT
      RJVGVKVAVHVDJUFVEVJVFVDJFUJUKVHUMVJVFJFUNKUOUPUQURUS $.

    $d f K $.  $d f T $.  $d f W $.
    $( Member of the partial isomorphism B. (Contributed by NM, 18-Jan-2014.)
       (Revised by Mario Carneiro, 6-May-2015.)  (New usage is discouraged.) $)
    dibopelvalN $p |- ( ( ( K e. V /\ W e. H ) /\ X e. dom J )
          -> ( <. F , S >. e. ( I ` X )
          <-> ( F e. ( J ` X ) /\ S = .0. ) ) ) $=
      ( wcel wa cdm cop cfv csn cxp wceq dibval eleq2d opelxp cid cres cmpt cvv
      cltrn fvex eqeltri mptex elsnc2 anbi2i bitri syl6bb ) IJTKFTUALHUBTUAZEBU
      CZLGUDZTVDLHUDZMUEZUFZTZEVFTZBMUGZUAZVCVEVHVDACDFGHIJKLMNOPQRSUHUIVIVJBVG
      TZUAVLEBVFVGUJVMVKVJBMMDCUKAULZUMUNQDCVNCKIUOUDZUDUNPKVOUPUQURUQUSUTVAVB
      $.
  $}

  ${
    $d f K $.  $d f W $.
    dibval2.b $e |- B = ( Base ` K ) $.
    dibval2.l $e |- .<_ = ( le ` K ) $.
    dibval2.h $e |- H = ( LHyp ` K ) $.
    dibval2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dibval2.o $e |- .0. = ( f e. T |-> ( _I |` B ) ) $.
    dibval2.j $e |- J = ( ( DIsoA ` K ) ` W ) $.
    dibval2.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Value of the partial isomorphism B. (Contributed by NM, 18-Jan-2014.) $)
    dibval2 $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( I ` X ) = ( ( J ` X ) X. { .0. } ) ) $=
      ( wcel wa wbr cdm cfv csn cxp wceq diaeldm biimpar dibval syldan ) GITJDT
      UAZKATKJHUBUAZKFUCTZKEUDKFUDLUEUFUGULUNUMADFGHIJKMNORUHUIABCDEFGIJKLMOPQR
      SUJUK $.

    $d f T $.
    $( Member of the partial isomorphism B. (Contributed by NM, 3-Mar-2014.)
       (Revised by Mario Carneiro, 6-May-2015.) $)
    dibopelval2 $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( <. F , S >. e. ( I ` X )
          <-> ( F e. ( J ` X ) /\ S = .0. ) ) ) $=
      ( wcel wbr cop cfv csn cxp wceq dibval2 eleq2d opelxp cid cres cmpt cltrn
      wa cvv fvex eqeltri mptex elsnc2 anbi2i bitri syl6bb ) IKUBLFUBUPMAUBMLJU
      CUPUPZEBUDZMGUEZUBVFMHUEZNUFZUGZUBZEVHUBZBNUHZUPZVEVGVJVFACDFGHIJKLMNOPQR
      STUAUIUJVKVLBVIUBZUPVNEBVHVIUKVOVMVLBNNDCULAUMZUNUQSDCVPCLIUOUEZUEUQRLVQU
      RUSUTUSVAVBVCVD $.
  $}

  ${
    $d f K $.  $d g K $.  $d f T $.  $d f W $.  $d g W $.  $d f X $.
    dibval3.b $e |- B = ( Base ` K ) $.
    dibval3.l $e |- .<_ = ( le ` K ) $.
    dibval3.h $e |- H = ( LHyp ` K ) $.
    dibval3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dibval3.r $e |- R = ( ( trL ` K ) ` W ) $.
    dibval3.o $e |- .0. = ( g e. T |-> ( _I |` B ) ) $.
    dibval3.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Value of the partial isomorphism B for a lattice ` K ` .  (Contributed
       by NM, 24-Feb-2014.)  (New usage is discouraged.) $)
    dibval3N $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( I ` X ) = ( { f e. T | ( R ` f ) .<_ X } X. { .0. } ) ) $=
      ( wcel wa wbr cfv cdia csn cxp cv crab eqid dibval2 diaval xpeq1d eqtrd )
      HJUAKFUAUBLAUALKIUCUBUBZLGUDLKHUEUDUDZUDZMUFZUGDUHBUDLIUCDCUIZURUGACEFGUP
      HIJKLMNOPQSUPUJZTUKUOUQUSURABCDFUPHIJKLNOPQRUTULUMUN $.

    $d f .<_ $.  $d f B $.  $d f H $.  $d s K $.  $d f s .0. $.  $d g T $.
    $d f V $.  $d s W $.  $d s X $.  $d f s Y $.
    $( Member of the partial isomorphism B. (Contributed by NM,
       26-Feb-2014.) $)
    dibelval3 $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
      -> ( Y e. ( I ` X )
         <-> E. f e. T ( Y = <. f , .0. >. /\ ( R ` f ) .<_ X ) ) ) $=
      ( vs wcel wbr cfv cdia csn cxp cop wceq wrex eqid dibval2 eleq2d diaelval
      wa cv wex anbi1d an13 elsn anbi1i bitri exbii cid cres cmpt cltrn eqeltri
      cvv fvex mptex opeq2 eqeq2d anbi2d ceqsexv anass an32 bitr3i 3bitr4g elxp
      exbidv df-rex bitrd ) HJUCKFUCUPLAUCLKIUDUPUPZMLGUEZUCMLKHUFUEUEZUEZNUGZU
      HZUCZMDUQZNUIZUJZWLBUELIUDZUPZDCUKZWEWFWJMACEFGWGHIJKLNOPQRTWGULZUAUMUNWE
      MWLUBUQZUIZUJZWLWHUCZWSWIUCZUPUPZUBURZDURWLCUCZWPUPZDURWKWQWEXEXGDWEXBWNU
      PZXFWOUPZWNUPZXEXGWEXBXIWNABCWLFWGHIJKLOPQRSWRUOUSXEWSNUJZXBXAUPZUPZUBURX
      HXDXMUBXDXCXLUPXMXAXBXCUTXCXKXLUBNVAVBVCVDXLXHUBNNECVEAVFZVGVJTECXNCKHVHU
      EZUEVJRKXOVKVIVLVIXKXAWNXBXKWTWMMWSNWLVMVNVOVPVCXGXFWNUPWOUPXJXFWNWOVQXFW
      NWOVRVSVTWBDUBMWHWIWAWPDCWCVTWD $.

    $( Member of the partial isomorphism B. (Contributed by NM, 3-Mar-2014.) $)
    dibopelval3 $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( <. F , S >. e. ( I ` X )
          <-> ( ( F e. T /\ ( R ` F ) .<_ X ) /\ S = .0. ) ) ) $=
      ( wcel wa wbr cop cfv cdia wceq eqid dibopelval2 diaelval anbi1d bitrd )
      IKUBLGUBUCMAUBMLJUDUCUCZFCUEMHUFUBFMLIUGUFUFZUFUBZCNUHZUCFDUBFBUFMJUDUCZU
      QUCACDEFGHUOIJKLMNOPQRTUOUIZUAUJUNUPURUQABDFGUOIJKLMOPQRSUSUKULUM $.
  $}

  ${
    $d f K $.  $d f W $.
    dibelval1.b $e |- B = ( Base ` K ) $.
    dibelval1.l $e |- .<_ = ( le ` K ) $.
    dibelval1.h $e |- H = ( LHyp ` K ) $.
    dibelval1.j $e |- J = ( ( DIsoA ` K ) ` W ) $.
    dibelval1.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism B for a lattice ` K ` .
       (Contributed by NM, 13-Feb-2014.) $)
    dibelval1st $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W )
       /\ Y e. ( I ` X ) ) -> ( 1st ` Y ) e. ( J ` X ) ) $=
      ( vf wcel wa cfv eqid wbr w3a cltrn cid cres cmpt csn c1st dibval2 eleq2d
      cxp biimp3a xp1st syl ) EGQHBQRZIAQIHFUARZJICSZQZUBJIDSZPHEUCSSZUDAUEUFZU
      GZUKZQZJUHSUSQUOUPURVDUOUPRUQVCJAUTPBCDEFGHIVAKLMUTTVATNOUIUJULJUSVBUMUN
      $.
  $}

  ${
    $d f K $.  $d f W $.
    dibelval1st1.b $e |- B = ( Base ` K ) $.
    dibelval1st1.l $e |- .<_ = ( le ` K ) $.
    dibelval1st1.h $e |- H = ( LHyp ` K ) $.
    dibelval1st1.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dibelval1st1.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism B for a lattice ` K ` .
       (Contributed by NM, 13-Feb-2014.) $)
    dibelval1st1 $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W )
       /\ Y e. ( I ` X ) ) -> ( 1st ` Y ) e. T ) $=
      ( wcel wa wbr cfv c1st cdia eqid dibelval1st diael syld3an3 ) EGPHCPQIAPI
      HFRQJIDSPJTSZIHEUASSZSPUFBPACDUGEFGHIJKLMUGUBZOUCABUFCUGEFGHIKLMNUHUDUE
      $.
  $}

  ${
    $d f K $.  $d f W $.
    dibelval1st2.b $e |- B = ( Base ` K ) $.
    dibelval1st2.l $e |- .<_ = ( le ` K ) $.
    dibelval1st2.h $e |- H = ( LHyp ` K ) $.
    dibelval1st2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dibelval1st2.r $e |- R = ( ( trL ` K ) ` W ) $.
    dibelval1st2.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism B for a lattice ` K ` .
       (Contributed by NM, 13-Feb-2014.)  (New usage is discouraged.) $)
    dibelval1st2N $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W )
       /\ Y e. ( I ` X ) ) -> ( R ` ( 1st ` Y ) ) .<_ X ) $=
      ( wcel wa cfv wbr c1st cdia eqid dibelval1st diatrl syld3an3 ) FHRIDRSJAR
      JIGUASKJETRKUBTZJIFUCTTZTRUHBTJGUAADEUIFGHIJKLMNUIUDZQUEABCUHDUIFGHIJLMNO
      PUJUFUG $.
  $}

  ${
    $d f K $.  $d f W $.
    dibelval2nd.b $e |- B = ( Base ` K ) $.
    dibelval2nd.l $e |- .<_ = ( le ` K ) $.
    dibelval2nd.h $e |- H = ( LHyp ` K ) $.
    dibelval2nd.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dibelval2nd.o $e |- .0. = ( f e. T |-> ( _I |` B ) ) $.
    dibelval2nd.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism B for a lattice ` K ` .
       (Contributed by NM, 13-Feb-2014.) $)
    dibelval2nd $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W )
       /\ Y e. ( I ` X ) ) -> ( 2nd ` Y ) = .0. ) $=
      ( wcel cfv wa wbr w3a cdia csn cxp c2nd wceq dibval2 eleq2d biimp3a xp2nd
      eqid elsni 3syl ) FHSIDSUAZJASJIGUBUAZKJETZSZUCKJIFUDTTZTZLUEZUFZSZKUGTZV
      BSVELUHUPUQUSVDUPUQUAURVCKABCDEUTFGHIJLMNOPQUTUMRUIUJUKKVAVBULVELUNUO $.
  $}

  ${
    $d f .<_ $.  $d f B $.  $d f K $.  $d f W $.  $d f X $.
    dibn0.b $e |- B = ( Base ` K ) $.
    dibn0.l $e |- .<_ = ( le ` K ) $.
    dibn0.h $e |- H = ( LHyp ` K ) $.
    dibn0.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( The value of the partial isomorphism B is not empty.  (Contributed by
       NM, 18-Jan-2014.) $)
    dibn0 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
            -> ( I ` X ) =/= (/) ) $=
      ( vf chlt wcel wa wbr cfv c0 eqid wne cdia cltrn cid cres csn cxp dibval2
      cmpt dian0 fvex mptex snnz jctir xpnz sylib eqnetrd ) DMNFBNOGANGFEPOOZGC
      QGFDUAQQZQZLFDUBQZQZUCAUDZUHZUEZUFZRAVALBCURDEMFGVCHIJVASVCSURSZKUGUQUSRT
      ZVDRTZOVERTUQVGVHABURDEFGHIJVFUIVCLVAVBFUTUJUKULUMUSVDUNUOUP $.
  $}

  ${
    $d y J $.  $d f y K $.  $d f y W $.
    dibfna.h $e |- H = ( LHyp ` K ) $.
    dibfna.j $e |- J = ( ( DIsoA ` K ) ` W ) $.
    dibfna.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Functionality and domain of the partial isomorphism B. (Contributed by
       NM, 17-Jan-2014.) $)
    dibfna $p |- ( ( K e. V /\ W e. H ) -> I Fn dom J ) $=
      ( vy vf wcel wa cdm wfn cv cfv cltrn cmpt eqid cid cbs cres csn fvex snex
      cxp xpex fnmpti dibfval fneq1d mpbiri ) DELFALMZBCNZOJUNJPZCQZKFDRQQZUADU
      BQZUCSZUDZUGZSZUNOJUNVAVBUPUTUOCUEUSUFUHVBTUIUMUNBVBJURUQKABCDEFUSURTGUQT
      USTHIUJUKUL $.

    $( Domain of the partial isomorphism B. (Contributed by NM,
       17-Jan-2014.) $)
    dibdiadm $p |- ( ( K e. V /\ W e. H ) -> dom I = dom J ) $=
      ( wcel wa cdm wfn wceq dibfna fndm syl ) DEJFAJKBCLZMBLRNABCDEFGHIORBPQ
      $.
  $}

  ${
    $d x .<_ $.  $d x B $.  $d x K $.  $d x W $.
    dibfn.b $e |- B = ( Base ` K ) $.
    dibfn.l $e |- .<_ = ( le ` K ) $.
    dibfn.h $e |- H = ( LHyp ` K ) $.
    dibfn.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Functionality and domain of the partial isomorphism B. (Contributed by
       NM, 17-Jan-2014.)  (New usage is discouraged.) $)
    dibfnN $p |- ( ( K e. V /\ W e. H ) -> I Fn { x e. B | x .<_ W } ) $=
      ( wcel wa cdia cfv cdm wfn cv wbr crab eqid dibfna diadm fneq2d mpbid ) E
      GMHCMNZDHEOPPZQZRDASHFTABUAZRCDUHEGHKUHUBZLUCUGUIUJDABCUHEFGHIJKUKUDUEUF
      $.

    $( Domain of the partial isomorphism A. (Contributed by NM, 8-Mar-2014.)
       (New usage is discouraged.) $)
    dibdmN $p |- ( ( K e. V /\ W e. H ) -> dom I = { x e. B | x .<_ W } ) $=
      ( wcel wa cv wbr crab wfn cdm wceq dibfnN fndm syl ) EGMHCMNDAOHFPABQZRDS
      UDTABCDEFGHIJKLUAUDDUBUC $.

    $( Member of domain of the partial isomorphism B. (Contributed by NM,
       17-Jan-2014.)  (New usage is discouraged.) $)
    dibeldmN $p |- ( ( K e. V /\ W e. H )
          -> ( X e. dom I <-> ( X e. B /\ X .<_ W ) ) ) $=
      ( wcel wa cdm cdia cfv wbr eqid dibdiadm eleq2d diaeldm bitrd ) DFMGBMNZH
      COZMHGDPQQZOZMHAMHGERNUDUEUGHBCUFDFGKUFSZLTUAABUFDEFGHIJKUHUBUC $.
  $}

  ${
    $d f K $.  $d f W $.
    dib11.b $e |- B = ( Base ` K ) $.
    dib11.l $e |- .<_ = ( le ` K ) $.
    dib11.h $e |- H = ( LHyp ` K ) $.
    dib11.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( The isomorphism B for a lattice ` K ` is order-preserving in the region
       under co-atom ` W ` .  (Contributed by NM, 24-Feb-2014.) $)
    dibord $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
      /\ ( Y e. B /\ Y .<_ W ) )
  -> ( ( I ` X ) C_ ( I ` Y ) <-> X .<_ Y ) ) $=
      ( vf chlt wcel wa wbr cfv wss eqid w3a cdia cid cres cmpt csn cxp dibval2
      cltrn wceq 3adant3 3adant2 sseq12d c0 wne wb dibn0 eqnetrrd ssxpb biantru
      syl ssid diaord syl5bbr 3bitrd ) DNOFBOPZGAOGFEQPZHAOHFEQPZUAZGCRZHCRZSGF
      DUBRRZRZMFDUIRRZUCAUDUEZUFZUGZHVLRZVPUGZSZVMVRSZVPVPSZPZGHEQZVIVJVQVKVSVF
      VGVJVQUJVHAVNMBCVLDENFGVOIJKVNTZVOTZVLTZLUHUKZVFVHVKVSUJVGAVNMBCVLDENFHVO
      IJKWEWFWGLUHULUMVIVQUNUOVTWCUPVIVJVQUNWHVFVGVJUNUOVHABCDEFGIJKLUQUKURVMVP
      VRVPUSVAWCWAVIWDWBWAVPVBUTABVLDEFGHIJKWGVCVDVE $.

    $( The isomorphism B for a lattice ` K ` is one-to-one in the region under
       co-atom ` W ` .  (Contributed by NM, 24-Feb-2014.)
       (New usage is discouraged.) $)
    dib11N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
        /\ ( Y e. B /\ Y .<_ W ) ) -> ( ( I ` X ) = ( I ` Y ) <-> X = Y ) ) $=
      ( cfv wceq wss wa wcel wbr dibord wb chlt eqss 3com23 anbi12d clat simp1l
      w3a hllat syl simp2l simp3l latasymb syl3anc bitrd syl5bb ) GCMZHCMZNUPUQ
      OZUQUPOZPZDUAQZFBQZPZGAQZGFERZPZHAQZHFERZPZUGZGHNZUPUQUBVJUTGHERZHGERZPZV
      KVJURVLUSVMABCDEFGHIJKLSVCVIVFUSVMTABCDEFHGIJKLSUCUDVJDUEQZVDVGVNVKTVJVAV
      OVAVBVFVIUFDUHUIVCVDVEVIUJVCVFVGVHUKADEGHIJULUMUNUO $.
  $}

  ${
    $d x y H $.  $d x y I $.  $d x y K $.  $d x y W $.
    dibcl.h $e |- H = ( LHyp ` K ) $.
    dibcl.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( The partial isomorphism A for a lattice ` K ` is a one-to-one
       function. .  Part of Lemma M of [Crawley] p. 120 line 27.  (Contributed
       by NM, 4-Dec-2013.)  (New usage is discouraged.) $)
    dibf11N $p |- ( ( K e. HL /\ W e. H ) -> I : dom I -1-1-onto-> ran I ) $=
      ( vx vy chlt wcel wa cdm wfn wceq cv cfv wral wbr eqid dibeldmN wf1o cple
      crn weq wi cbs crab dibfnN fnfun funfn sylib syl eqidd anbi12d w3a dib11N
      wfun biimpd 3expib sylbid ralrimivv dff1o6 syl3anbrc ) CIJDAJKZBBLZMZBUCZ
      VGNGOZBPHOZBPNZGHUDZUEZHVEQGVEQVEVGBUAVDBVHDCUBPZRZGCUFPZUGZMZVFGVOABCVMI
      DVOSZVMSZEFUHVQBUQVFVPBUIBUJUKULVDVGUMVDVLGHVEVEVDVHVEJZVIVEJZKVHVOJVNKZV
      IVOJVIDVMRKZKVLVDVTWBWAWCVOABCVMIDVHVRVSEFTVOABCVMIDVIVRVSEFTUNVDWBWCVLVD
      WBWCUOVJVKVOABCVMDVHVIVRVSEFUPURUSUTVAGHVEVGBVBVC $.

    $( Closure of partial isomorphism B for a lattice ` K ` .  (Contributed by
       NM, 8-Mar-2014.)  (New usage is discouraged.) $)
    dibclN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. dom I )
            -> ( I ` X ) e. ran I ) $=
      ( chlt wcel wa wfun cdm cfv crn cdia wfn eqid dibfna fnfun syl fvelrn
      sylan ) CHIDAIJZBKZEBLIEBMBNIUCBDCOMMZLZPUDABUECHDFUEQGRUFBSTEBUAUB $.

    $d h K $.  $d h W $.
    $( The value of partial isomorphism B is a relation.  (Contributed by NM,
       8-Mar-2014.) $)
    dibvalrel $p |- ( ( K e. V /\ W e. H ) -> Rel ( I ` X ) ) $=
      ( vh wcel wa cdm cfv wrel cdia cltrn eqid releqd mpbiri c0 cid cres relxp
      cbs cmpt csn cxp wceq dibdiadm eleq2d biimpa dibval syldan wn rel0 adantl
      ndmfv pm2.61dan ) CDJEAJKZFBLZJZFBMZNZUSVAKZVCFECOMMZMZIECPMMZUACUDMZUBUE
      ZUFZUGZNVFVJUCVDVBVKUSVAFVELZJZVBVKUHUSVAVMUSUTVLFABVECDEGVEQZHUIUJUKVHVG
      IABVECDEFVIVHQGVGQVIQVNHULUMRSVAUNZVCUSVOVCTNUOVOVBTFBUQRSUPUR $.
  $}

  ${
    $d f H $.  $d f K $.  $d f W $.
    dib0.z $e |- .0. = ( 0. ` K ) $.
    dib0.h $e |- H = ( LHyp ` K ) $.
    dib0.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    dib0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dib0.o $e |- O = ( 0g ` U ) $.
    $( The value of partial isomorphism B at the lattice zero is the singleton
       of the zero vector i.e. the zero subspace.  (Contributed by NM,
       27-Mar-2014.) $)
    dib0 $p |- ( ( K e. HL /\ W e. H ) -> ( I ` .0. ) = { O } ) $=
      ( vf chlt wcel cbs cfv csn cvv eqid wa cid cres cmpt cxp cop fvex resiexg
      cltrn ax-mp mptex xpsn cdia cple wbr wceq id cops hlop adantr syl lhpbase
      op0cl op0le syl2an dibval2 syl12anc dia0 xpeq1d eqtrd dvh0g sneqd 3eqtr4a
      ) DNOZFBOZUAZUBDPQZUCZRZMFDUIQZQZVRUDZRZUEZVRWBUFZRGCQZERVRWBVQSOVRSODPUG
      VQSUHUJMWAVRFVTUGUKULVPWFGFDUMQQZQZWCUEZWDVPVPGVQOZGFDUNQZUOZWFWIUPVPUQVP
      DUROZWJVNWMVODUSZUTVQDGVQTZHVCVAVNWMFVQOWLVOWNVQBDFWOIVBVQDWKFGWOWKTZHVDV
      EVQWAMBCWGDWKNFGWBWOWPIWATZWBTZWGTZJVFVGVPWHVSWCVQBWGDFGWOHIWSVHVIVJVPEWE
      VQWAAMBDWBFEWOIWQKLWRVKVLVM $.
  $}

  ${
    $d h B $.  $d f g s t E $.  $d f g s t F $.  $d f s t H $.  $d f h s t K $.
    $d f g s t O $.  $d f s t R $.  $d f g h s t T $.  $d f h s t W $.
    dib1dim.b $e |- B = ( Base ` K ) $.
    dib1dim.h $e |- H = ( LHyp ` K ) $.
    dib1dim.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dib1dim.r $e |- R = ( ( trL ` K ) ` W ) $.
    dib1dim.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dib1dim.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dib1dim.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Two expressions for the 1-dimensional subspaces of vector space H.
       (Contributed by NM, 24-Feb-2014.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    dib1dim $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T ) -> ( I ` ( R ` F ) )
       = { g e. ( T X. E ) | E. s e. E g = <. ( s ` F ) , O >. } ) $=
      ( vf vt chlt wcel wa cfv cv wceq wrex w3a copab cop cxp crab cdia csn wbr
      cple simpl trlcl eqid trlle dibval2 syl12anc opelxp dia1dim abeq2d anbi1d
      relxp tendocl 3expa an32s tendo0cl ad2antrr jca eleq1 bi2anan9 syl5ibrcom
      rexlimdva pm4.71rd elsn anbi2i r19.41v bitr4i df-3an 3bitr4g bitrd syl5bb
      opabbi2dv eqtrd eqeq1 vex opth syl6bb rexbidv rabxp syl6eqr ) JUCUDLHUDUE
      ZGCUDZUEZGBUFZIUFZUAUGZCUDZUBUGZFUDZXCGMUGZUFZUHZXEKUHZUEZMFUIZUJZUAUBUKZ
      DUGZXHKULZUHZMFUIZDCFUMUNWTXBXALJUOUFUFZUFZKUPZUMZXNWTWRXAAUDXALJURUFZUQX
      BYBUHWRWSUSABCGHJLNOPQUTBCGHJYCLYCVAZOPQVBACEHIXSJYCUCLXAKNYDOPSXSVAZTVCV
      DWTXMUAUBYBXTYAVIXCXEULZYBUDXCXTUDZXEYAUDZUEZWTXMXCXEXTYAVEWTYIXIMFUIZYHU
      EZXMWTYGYJYHWTYJUAXTBCUAFGHXSJLMOPQRYEVFVGVHWTXLXDXFUEZXLUEYKXMWTXLYLWTXK
      YLMFWTXGFUDZUEZYLXKXHCUDZKFUDZUEYNYOYPWRYMWSYOWRYMWSYOXGCFGHJUCLOPRVJVKVL
      WRYPWSYMACEFHJKLNOPRSVMVNVOXIXDYOXJXFYPXCXHCVPXEKFVPVQVRVSVTYKYJXJUEXLYHX
      JYJUBKWAWBXIXJMFWCWDXDXFXLWEWFWGWHWIWJXRXLDUAUBCFXOYFUHZXQXKMFYQXQYFXPUHX
      KXOYFXPWKXCXEXHKUAWLUBWLWMWNWOWPWQ $.
  $}

  ${
    $d f s x G $.  $d f s x H $.  $d f s I $.  $d f h s x y K $.  $d f s x S $.
    $d f h s x y W $.
    dibglb.g $e |- G = ( glb ` K ) $.
    dibglb.h $e |- H = ( LHyp ` K ) $.
    dibglb.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( Partial isomorphism B of a lattice glb.  (Contributed by NM,
       9-Mar-2014.)  (New usage is discouraged.) $)
    dibglbN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( S C_ dom I /\ S =/= (/) ) )
       -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
      ( vy chlt wcel wa wss cv cfv wbr wb eqid vf vs cdm wne cple cbs crab ciin
      vh wceq simpl simprl dibdmN sseq2d adantr mpbid simprr wrel dibvalrel wex
      c0 wrex n0 biimpi ad2antll a1d ancld eximdv mpd df-rex sylibr reliin cdia
      syl id cltrn cid cres cmpt cop diadm sseqtr4d diaglbN syl12anc eleq2d cvv
      wral vex eliin ax-mp syl6bb anbi1d r19.27zv bitr4d hlclat ad2antrr ssrab2
      ccla syl6ss clatglbcl syl2anc clat hllat ad3antrrr simplrl sselda lhpbase
      ad3antlr simpr clatglble syl3anc breq1 elrab sylib simprd lattrd exlimddv
      dibopelval2 opex simpll ralbidva syl5bb 3bitr4d eqrelrdv2 syl21anc ) FLMZ
      GDMZNZBEUCZOZBVAUDZNZNZYHBKPZGFUEQZRZKFUFQZUGZOZYKBCQZEQZABAPZEQZUHZUJZYH
      YLUKYMYJYSYHYJYKULYHYJYSSYLYHYIYRBKYQDEFYOLGYQTZYOTZIJUMUNUOUPYHYJYKUQYHY
      SYKNZNZUUAURZUUDURZUUIUUEYHUUJUUHDEFLGYTIJUSUOUUIUUCURZABVBZUUKUUIUUBBMZU
      ULNZAUTZUUMUUIUUNAUTZUUPYKUUQYHYSYKUUQABVCVDVEZUUIUUNUUOAUUIUUNUULUUIUULU
      UNYHUULUUHDEFLGUUBIJUSUOVFVGVHVIUULABVJVKABUUCVLVNUUIVOUUIUAUBUUAUUDUUIUA
      PZYTGFVMQQZQZMZUBPZUIGFVPQQZVQYQVRVSZUJZNZUUSUUBUUTQZMZUVFNZABWGZUUSUVCVT
      ZUUAMZUVLUUDMZUUIUVGUVIABWGZUVFNZUVKUUIUVBUVOUVFUUIUVBUUSABUVHUHZMZUVOUUI
      UVAUVQUUSUUIYHBUUTUCZOYKUVAUVQUJYHUUHUKZUUIBYRUVSYHYSYKULZYHUVSYRUJUUHKYQ
      DUUTFYOLGUUFUUGIUUTTZWAUOWBYHYSYKUQABCDUUTFGHIUWBWCWDWEUUSWFMUVRUVOSUAWHA
      UUSBUVHWFWIWJWKWLYKUVKUVPSYHYSUVIUVFABWMVEWNUUIYHYTYQMZYTGYORZUVMUVGSUVTU
      UIFWRMZBYQOZUWCYFUWEYGUUHFWOZWPUUIBYRYQUWAYPKYQWQZWSZYQBCFUUFHWTZXAUUIUUN
      UWDAUURUUIUUNNZYQFYOYTUUBGUUFUUGYFFXBMYGUUHUUNFXCXDUWKUWEUWFUWCYFUWEYGUUH
      UUNUWGXDZUWKBYRYQYHYSYKUUNXEUWHWSZUWJXAUUIBYQUUBUWIXFYGGYQMYFUUHUUNYQDFGU
      UFIXGXHUWKUWEUWFUUNYTUUBYORUWLUWMUUIUUNXIYQBCFYOUUBUUFUUGHXJXKUWKUUBYQMZU
      UBGYORZUWKUUBYRMUWNUWONZUUIBYRUUBUWAXFYPUWOKUUBYQYNUUBGYOXLXMXNZXOXPXQYQU
      VCUVDUIUUSDEUUTFYOLGYTUVEUUFUUGIUVDTZUVETZUWBJXRWDUVNUVLUUCMZABWGZUUIUVKU
      VLWFMUVNUXASUUSUVCXSAUVLBUUCWFWIWJUUIUWTUVJABUWKYHUWPUWTUVJSYHUUHUUNXTUWQ
      YQUVCUVDUIUUSDEUUTFYOLGUUBUVEUUFUUGIUWRUWSUWBJXRXAYAYBYCYDYEWD $.
  $}

  ${
    $d y x H $.  $d y x I $.  $d y x K $.  $d y x S $.  $d y x W $.
    dibintcl.h $e |- H = ( LHyp ` K ) $.
    dibintcl.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    $( The intersection of partial isomorphism B closed subspaces is a closed
       subspace.  (Contributed by NM, 8-Mar-2014.)
       (New usage is discouraged.) $)
    dibintclN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ ran I /\ S =/= (/) ) )
       -> |^| S e. ran I ) $=
      ( vy vx chlt wcel wa wss cfv wceq adantr syl wb wi wbr crn c0 wne ccnv cv
      cima cres ciin cint wfn cdm wf1o dibf11N cnvimass fnssres sylancl fniinfv
      f1ofn df-ima wfo f1ofo simprl foimacnv syl2anc syl5eqr inteqd eqtrd simpl
      cglb a1i simprr n0 sylib wrex sselda ad2antrr fvelrnb mpbid wfun fvimacnv
      wex f1ofun sylan ne0i syl6bi eleq1 biimprd imim1d syl9 com24 imp rexlimdv
      ex mpd exlimddv eqid dibglbN syl12anc fvres iineq2i syl6eqr cbs cple ccla
      hlclat crab dibdmN ssrab2 syl6eqss clatglbcl clat hllat ad3antrrr lhpbase
      syl5ss ad3antlr syl6ss simpr clatglble syl3anc sseli adantl simprd lattrd
      syl5sseq dibeldmN mpbir2and dibclN syldan eqeltrrd ) DJKZEBKZLZACUAZMZAUB
      UCZLZLZHCUDAUFZHUEZCYSUGZNZUHZAUIZYNYRUUCUUAUAZUIZUUDYRUUAYSUJZUUCUUFOYRC
      CUKZUJZYSUUHMZUUGYRUUHYNCULZUUIYMUUKYQBCDEFGUMZPUUHYNCURZQCAUNZUUHYSCUOUP
      HYSUUAUQQYRUUEAYRUUECYSUFZACYSUSYRUUHYNCUTZYOUUOAOYMUUPYQYMUUKUUPUULUUHYN
      CVAQPYMYOYPVBZUUHYNACVCVDVEVFVGYRYSDVINZNZCNZUUCYNYRUUTHYSYTCNZUHZUUCYRYM
      UUJYSUBUCZUUTUVBOYMYQVHUUJYRUUNVJYRYTAKZUVCHYRYPUVDHWAYMYOYPVKHAVLVMYRUVD
      LZIUEZCNZYTOZIUUHVNZUVCUVEYTYNKZUVIYRAYNYTUUQVOUVEUUIUVJUVIRUVEUUKUUIYMUU
      KYQUVDUULVPUUMQIUUHYTCVQQVRUVEUVHUVCIUUHYRUVDUVFUUHKZUVHUVCSSYRUVHUVKUVDU
      VCYRUVKUVGAKZUVCSZUVHUVDUVCSYRUVKUVMYRUVKLUVLUVFYSKZUVCYRCVSZUVKUVLUVNRYM
      UVOYQYMUUKUVOUULUUHYNCWBQPUVFACVTWCYSUVFWDWEWMUVHUVDUVLUVCUVHUVLUVDUVGYTA
      WFWGWHWIWJWKWLWNWOZHYSUURBCDEUURWPZFGWQWRHYSUUBUVAYTYSCWSWTXAYMYQUUSUUHKZ
      UUTYNKYRUVRUUSDXBNZKZUUSEDXCNZTZYRDXDKZYSUVSMZUVTYKUWCYLYQDXEZVPYRYSUUHUV
      SUUNYMUUHUVSMYQYMUUHUVFEUWATZIUVSXFZUVSIUVSBCDUWAJEUVSWPZUWAWPZFGXGZUWFIU
      VSXHZXIPXOZUVSYSUURDUWHUVQXJVDZYRYTYSKZUWBHYRUVCUWNHWAUVPHYSVLVMYRUWNLZUV
      SDUWAUUSYTEUWHUWIYKDXKKYLYQUWNDXLXMYRUVTUWNUWMPYRYSUVSYTUWLVOYLEUVSKYKYQU
      WNUVSBDEUWHFXNXPUWOUWCUWDUWNUUSYTUWATYKUWCYLYQUWNUWEXMYRUWDUWNYRYSUWGUVSY
      RUUHYSUWGUUNYMUUHUWGOYQUWJPYEUWKXQPYRUWNXRUVSYSUURDUWAYTUWHUWIUVQXSXTUWOY
      TUVSKZYTEUWATZUWOYTUUHKZUWPUWQLZUWNUWRYRYSUUHYTUUNYAYBYMUWRUWSRYQUWNUVSBC
      DUWAJEYTUWHUWIFGYFVPVRYCYDWOYMUVRUVTUWBLRYQUVSBCDUWAJEUUSUWHUWIFGYFPYGBCD
      EUUSFGYHYIYJYJ $.
  $}

  ${
    $d h B $.  $d u v F $.  $d u v H $.  $d h u v K $.  $d u v N $.  $d v R $.
    $d u v O $.  $d h u v T $.  $d u v U $.  $d h u v W $.
    dib1dim2.b $e |- B = ( Base ` K ) $.
    dib1dim2.h $e |- H = ( LHyp ` K ) $.
    dib1dim2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dib1dim2.r $e |- R = ( ( trL ` K ) ` W ) $.
    dib1dim2.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dib1dim2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dib1dim2.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    dib1dim2.n $e |- N = ( LSpan ` U ) $.
    $( Two expressions for a 1-dimensional subspace of vector space H (when
       ` F ` is a nonzero vector i.e. non-identity translation).  (Contributed
       by NM, 24-Feb-2014.) $)
    dib1dim2 $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( I ` ( R ` F ) ) = ( N ` { <. F , O >. } ) ) $=
      ( vu vv chlt wcel wa cfv cv cop cvsca co wceq csca cbs cab csn ctendo cxp
      wrex crab df-rab eqid dib1dim dvhbase adantr rexeqdv ccom simpll tendo0cl
      simpr simplr ad2antrr dvhopvsca syl13anc tendo0mulr adantlr opeq2d eqeq2d
      eqtrd rexbidva wi tendocl 3expa an32s opelxpi syl2anc eleq1a syl pm4.71rd
      rexlimdva 3bitrd abbidv 3eqtr4a clmod dvhlmod dvhelvbasei syl12anc eqtr4d
      simpl lspsn ) IUCUDLGUDUEZFCUDZUEZFBUFHUFZUAUGZUBUGZFKUHZDUIUFZUJZUKZUBDU
      LUFZUMUFZURZUAUNZXFUOJUFZXBXDFXEUFZKUHZUKZUBLIUPUFUFZURZUACXRUQZUSXDXTUDZ
      XSUEZUAUNXCXMXSUAXTUTABCUAEXRFGHIKLUBMNOPXRVAZQSVBXBXLYBUAXBXLXIUBXRURXSY
      BXBXIUBXKXRWTXKXRUKXAXKDXRXJGILUCNYCRXJVAZXKVAZVCVDVEXBXIXQUBXRXBXEXRUDZU
      EZXHXPXDYGXHXOXEKVFZUHZXPYGWTYFXAKXRUDZXHYIUKWTXAYFVGXBYFVIWTXAYFVJWTYJXA
      YFACEXRGIKLMNOYCQVHZVKZXECXGDXRFGIUCLKNOYCRXGVAZVLVMYGYHKXOWTYFYHKUKXAACX
      EEXRGIKLMNOYCQVNVOVPVRVQVSXBXSYAXBXQYAUBXRYGXPXTUDZXQYAVTYGXOCUDZYJYNWTYF
      XAYOWTYFXAYOXECXRFGIUCLNOYCWAWBWCYLXOKCXRWDWEXPXTXDWFWGWIWHWJWKWLXBDWMUDX
      FDUMUFZUDZXNXMUKXBDGILNRWTXAWRZWNXBWTXAYJYQYRWTXAVIWTYJXAYKVDKCDXRFGIYPLU
      CNOYCRYPVAZWOWPUAXGUBXJXKJYPDXFYDYEYSYMTWSWEWQ $.
  $}

  ${
    $d f B $.  $d f H $.  $d f K $.  $d f W $.
    dibss.b $e |- B = ( Base ` K ) $.
    dibss.l $e |- .<_ = ( le ` K ) $.
    dibss.h $e |- H = ( LHyp ` K ) $.
    dibss.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    dibss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dibss.v $e |- V = ( Base ` U ) $.
    $( The partial isomorphism B maps to a set of vectors in full vector space
       H. (Contributed by NM, 1-Jan-2014.) $)
    dibss $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( I ` X ) C_ V ) $=
      ( vf chlt wcel cfv eqid wbr cdia cltrn cid cres cmpt csn cxp ctendo diass
      wa wss tendo0cl snssd adantr xpss12 syl2anc dibval2 wceq dvhvbase 3sstr4d
      ) EQRHCRUKZIARIHFUAUKZUKZIHEUBSSZSZPHEUCSSZUDAUEUFZUGZUHZVGHEUISSZUHZIDSG
      VDVFVGULVIVKULZVJVLULAVGCVEEFQHIJKLVGTZVETZUJVBVMVCVBVHVKAVGPVKCEVHHJLVNV
      KTZVHTZUMUNUOVFVGVIVKUPUQAVGPCDVEEFQHIVHJKLVNVQVOMURVBGVLUSVCVGBVKCEGHQLV
      NVPNOUTUOVA $.
  $}

  ${
    $d a b x .<_ $.  $d a b f h x B $.  $d a b f g h x H $.  $d a b x I $.
    $d a b f g h s t x K $.  $d a b x U $.  $d a b f g h s t x W $.
    $d a b x X $.
    diblss.b $e |- B = ( Base ` K ) $.
    diblss.l $e |- .<_ = ( le ` K ) $.
    diblss.h $e |- H = ( LHyp ` K ) $.
    diblss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    diblss.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    diblss.s $e |- S = ( LSubSp ` U ) $.
    $( The value of partial isomorphism B is a subspace of partial vector space
       H. TODO: use dib* specific theorems instead of dia* ones to shorten
       proof?  (Contributed by NM, 11-Feb-2014.) $)
    diblss $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
        -> ( I ` X ) e. S ) $=
      ( chlt wcel cfv eqid syl3anc vx va vb vh vs vt wa wbr ctendo cplusg cvsca
      csca cltrn cxp eqidd cbs wceq dvhbase eqcomd adantr dvhvbase a1i sseqtr4d
      clss dibss dibn0 cv w3a c1st c2nd ccom cop co cdia cid cres cmpt csn fvex
      coex op1st coeq1i simpll simpr1 simplr simpr2 dibelval1st1 tendocl simpr3
      vex ctrl ltrnco cjn clat simplll hllat trlcl syl2anc latjcl simplrl trlco
      syl tendotp dibelval1st diatrl lattrd latjle12 syl13anc mpbi2and diaelval
      mpbir2and syl5eqel cmpt2 dvhfplusr ad2antrr dibelval2nd coeq2d tendo0mulr
      op2nd eqtrd syl5eq oveq123d simpllr tendo0cl tendo0pl syl21anc ovex elsnc
      sylibr opelxpi wss sseldd dvhvsca syl12anc oveq1d eqeltrd dvhvadd dibval2
      wb tendococl 3eltr4d islssd ) FPQZHDQZUGZIAQZIHGUHZUGZUGZUAHFUIRRZCUJRZBC
      UKRZIERZCULRZHFUMRRZUUJUNZCUBUCUUIUUNUOUUEUUJUUNUPRZUQUUHUUEUUQUUJUUQCUUJ
      UUNDFHPLUUJSZMUUNSZUUQSURUSUTUUEUUPCUPRZUQUUHUUEUUTUUPUUOCUUJDFUUTHPLUUOS
      ZUURMUUTSZVAUSUTZUUIUUKUOUUIUULUOBCVDRUQUUIOVBUUIUUMUUTUUPACDEFGUUTHIJKLN
      MUVBVEUVCVCZADEFGHIJKLNVFUUIUAVGZUUJQZUBVGZUUMQZUCVGZUUMQZVHZUGZUVGVIRZUV
      ERZUVEUVGVJRZVKZVLZVIRZUVIVIRZVKZUVQVJRZUVIVJRZUUNUJRZVMZVLZIHFVNRRZRZUDU
      UOVOAVPVQZVRZUNZUVEUVGUULVMZUVIUUKVMZUUMUVLUVTUWGQUWDUWIQZUWEUWJQUVLUVTUV
      NUVSVKZUWGUVRUVNUVSUVNUVPUVMUVEVSZUVEUVOUAWJUVGVJVSVTZWAWBUVLUWNUWGQZUWNU
      UOQZUWNHFWKRRZRZIGUHZUVLUUEUVNUUOQZUVSUUOQZUWRUUEUUHUVKWCZUVLUUEUVFUVMUUO
      QZUXBUXDUUIUVFUVHUVJWDZUVLUUEUUHUVHUXEUXDUUEUUHUVKWEZUUIUVFUVHUVJWFZAUUOD
      EFGPHIUVGJKLUVANWGTZUVEUUOUUJUVMDFPHLUVAUURWHTZUVLUUEUUHUVJUXCUXDUXGUUIUV
      FUVHUVJWIZAUUODEFGPHIUVIJKLUVANWGTZUUOUVNUVSDFHLUVAWLTZUVLAFGUWTUVNUWSRZU
      VSUWSRZFWMRZVMZIJKUVLUUCFWNQZUUCUUDUUHUVKWOZFWPXBZUVLUUEUWRUWTAQUXDUXMAUW
      SUUOUWNDFHJLUVAUWSSZWQWRUVLUXRUXNAQZUXOAQZUXQAQUXTUVLUUEUXBUYBUXDUXJAUWSU
      UOUVNDFHJLUVAUYAWQWRZUVLUUEUXCUYCUXDUXLAUWSUUOUVSDFHJLUVAUYAWQWRZAUXPFUXN
      UXOJUXPSZWSTUUEUUFUUGUVKWTZUVLUUEUXBUXCUWTUXQGUHUXDUXJUXLUWSUUOUVNUVSDUXP
      FGHKUYFLUVAUYAXATUVLUXNIGUHZUXOIGUHZUXQIGUHZUVLAFGUXNUVMUWSRZIJKUXTUYDUVL
      UUEUXEUYKAQUXDUXIAUWSUUOUVMDFHJLUVAUYAWQWRUYGUVLUUEUVFUXEUXNUYKGUHUXDUXFU
      XIUWSUVEUUOUUJUVMDFGPHKLUVAUYAUURXCTUVLUUEUUHUVMUWGQZUYKIGUHUXDUXGUVLUUEU
      UHUVHUYLUXDUXGUXHADEUWFFGPHIUVGJKLUWFSZNXDTAUWSUUOUVMDUWFFGPHIJKLUVAUYAUY
      MXETXFUVLUUEUUHUVSUWGQZUYIUXDUXGUVLUUEUUHUVJUYNUXDUXGUXKADEUWFFGPHIUVIJKL
      UYMNXDTAUWSUUOUVSDUWFFGPHIJKLUVAUYAUYMXETUVLUXRUYBUYCUUFUYHUYIUGUYJYSUXTU
      YDUYEUYGAUXPFGUXNUXOIJKUYFXGXHXIXFUUIUWQUWRUXAUGYSUVKAUWSUUOUWNDUWFFGPHIJ
      KLUVAUYAUYMXJUTXKXLUVLUWDUWHUQUWMUVLUWDUWHUWHUEUFUUJUUJUDUUOUDVGZUEVGRUYO
      UFVGRVKVQXMZVMZUWHUVLUWAUWHUWBUWHUWCUYPUUEUWCUYPUQUUHUVKUFUYPUWCUUOCUDUUJ
      UUNDFPHUELUVAUURMUUSUYPSZUWCSZXNXOUVLUWAUVPUWHUVNUVPUWOUWPXSUVLUVPUVEUWHV
      KZUWHUVLUVOUWHUVEUVLUUEUUHUVHUVOUWHUQUXDUXGUXHAUUOUDDEFGPHIUVGUWHJKLUVAUW
      HSZNXPTZXQUVLUUEUVFUYTUWHUQUXDUXFAUUOUVEUDUUJDFUWHHJLUVAUURVUAXRWRXTYAUVL
      UUEUUHUVJUWBUWHUQUXDUXGUXKAUUOUDDEFGPHIUVIUWHJKLUVAVUANXPTYBUVLUUCUUDUWHU
      UJQZUYQUWHUQUXSUUCUUDUUHUVKYCUUEVUCUUHUVKAUUOUDUUJDFUWHHJLUVAUURVUAYDXOZU
      FAUYPUWHUUOUDUUJDFUWHHUEJLUVAUURVUAUYRYEYFXTUWDUWHUWAUWBUWCYGYHYIUVTUWDUW
      GUWIYJWRUVLUWLUVQUVIUUKVMZUWEUVLUWKUVQUVIUUKUVLUUEUVFUVGUUPQUWKUVQUQUXDUX
      FUVLUUMUUPUVGUUIUUMUUPYKUVKUVDUTZUXHYLUVEUUOUULCUUJUVGDFPHLUVAUURMUULSYMY
      NYOUVLUUEUVQUUPQZUVIUUPQVUEUWEUQUXDUVLUXBUVPUUJQZVUGUXJUVLUUEUVFUVOUUJQVU
      HUXDUXFUVLUVOUWHUUJVUBVUDYPUVEUVOUUJDFHLUURYTTUVNUVPUUOUUJYJWRUVLUUMUUPUV
      IVUFUXKYLUUNUUKUWCUUOCUUJUVQUVIDFHLUVAUURMUUSUUKSUYSYQYNXTUUIUUMUWJUQUVKA
      UUOUDDEUWFFGPHIUWHJKLUVAVUAUYMNYRUTUUAUUB $.
  $}

  ${
    $d f B $.  $d w x y z F $.  $d f x y H $.  $d w x y z I $.  $d w x y z J $.
    $d f s t x y K $.  $d w x y z O $.  $d w x y z S $.  $d f s t T $.
    $d w x y z U $.  $d x z V $.  $d f s t x y W $.  $d w x y z X $.
    $d w x y z Y $.  $d w x y z ph $.
    diblsmopel.b $e |- B = ( Base ` K ) $.
    diblsmopel.l $e |- .<_ = ( le ` K ) $.
    diblsmopel.h $e |- H = ( LHyp ` K ) $.
    diblsmopel.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diblsmopel.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    diblsmopel.v $e |- V = ( ( DVecA ` K ) ` W ) $.
    diblsmopel.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    diblsmopel.q $e |- .(+) = ( LSSum ` V ) $.
    diblsmopel.p $e |- .+b = ( LSSum ` U ) $.
    diblsmopel.j $e |- J = ( ( DIsoA ` K ) ` W ) $.
    diblsmopel.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    diblsmopel.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    diblsmopel.x $e |- ( ph -> ( X e. B /\ X .<_ W ) ) $.
    diblsmopel.y $e |- ( ph -> ( Y e. B /\ Y .<_ W ) ) $.
    $( Membership in subspace sum for partial isomorphism B. (Contributed by
       NM, 21-Sep-2014.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    diblsmopel $p |- ( ph
            -> ( <. F , S >. e. ( ( I ` X ) .+b ( I ` Y ) )
              <-> ( F e. ( ( J ` X ) .(+) ( J ` Y ) ) /\ S = O ) ) ) $=
      ( vx vy vz vw vs vt cop cfv co wcel cv cplusg wceq wex chlt clss wbr eqid
      wa wb diblss syl2anc dvhopellsm syl3anc excom w3a dibopelval2 anbi12d an4
      ancom bitri syl6bb anbi1d anass df-3an bitr4i 2exbidv cid cres cmpt cltrn
      fvex eqeltri mptex opeq2 oveq1d eqeq2d anbi2d oveq2d ceqsex2v ccom ctendo
      cvv csca adantr simprl diael tendo0cl syl simprr dvhopvadd syl122anc coex
      vex ovex opth2 dvavadd syl12anc bicomd cmpt2 dvhfplusr oveqd eqtrd syl5bb
      tendo0pl bitrd exbidv bicomi 2exbii 19.41vv wrex csubg clvec clmod dialss
      pm5.32da sseldd wss dvalvec lveclmod lsssssubg 4syl lsmelval r2ex 3bitrd
      ) AIEUTZRKVAZSKVAZCVBVCZUNVDZUOVDZUTZUUJVCZUPVDZUQVDZUTZUUKVCZVLZUUIUUOUU
      SGVEVAZVBZVFZVLZUQVGZUPVGUOVGZUNVGZUUMRLVAZVCZUUQSLVAZVCZVLZIUUMUUQPVEVAZ
      VBZVFZEOVFZVLZVLZUPVGZUNVGZIUVIUVKDVBVCZUVQVLZAMVHVCQJVCVLZUUJGVIVAZVCZUU
      KUWEVCZUULUVHVMUKAUWDRBVCRQNVJVLZUWFUKULBUWEGJKMNQRTUAUBUFUJUWEVKZVNVOAUW
      DSBVCSQNVJVLZUWGUKUMBUWEGJKMNQSTUAUBUFUJUWIVNVOUNUOUPUQUVBCUWEEGIJMQUUJUU
      KUBUFUVBVKZUWIUHVPVQAUVGUVTUNUVGUVFUOVGZUPVGAUVTUVFUOUPVRAUWLUVSUPAUWLUUN
      OVFZUUROVFZUVMUVDVLZVSZUQVGUOVGZUVSAUVEUWPUOUQAUVEUWMUWNVLZUVMVLZUVDVLZUW
      PAUVAUWSUVDAUVAUVJUWMVLZUVLUWNVLZVLZUWSAUUPUXAUUTUXBAUWDUWHUUPUXAVMUKULBU
      UNFHUUMJKLMNVHQROTUAUBUCUDUIUJVTVOAUWDUWJUUTUXBVMUKUMBUURFHUUQJKLMNVHQSOT
      UAUBUCUDUIUJVTVOWAUXCUVMUWRVLUWSUVJUWMUVLUWNWBUVMUWRWCWDWEWFUWTUWRUWOVLUW
      PUWRUVMUVDWGUWMUWNUWOWHWIWEWJUWQUVMUUIUUMOUTZUUQOUTZUVBVBZVFZVLZAUVSUWOUV
      MUUIUXDUUSUVBVBZVFZVLUXHUOUQOOOHFWKBWLZWMXFUDHFUXKFQMWNVAZVAXFUCQUXLWOWPW
      QWPZUXMUWMUVDUXJUVMUWMUVCUXIUUIUWMUUOUXDUUSUVBUUNOUUMWRWSWTXAUWNUXJUXGUVM
      UWNUXIUXFUUIUWNUUSUXEUXDUVBUUROUUQWRXBWTXAXCAUVMUXGUVRAUVMVLZUXGUUIUUMUUQ
      XDZOOGXGVAZVEVAZVBZUTZVFZUVRUXNUXFUXSUUIUXNUWDUUMFVCZOQMXEVAVAZVCZUUQFVCZ
      UYCUXFUXSVFAUWDUVMUKXHZUXNUWDUWHUVJUYAUYEAUWHUVMULXHAUVJUVLXIBFUUMJLMNVHQ
      RTUAUBUCUIXJVQZUXNUWDUYCUYEBFHUYBJMOQTUBUCUYBVKZUDXKXLZUXNUWDUWJUVLUYDUYE
      AUWJUVMUMXHAUVJUVLXMBFUUQJLMNVHQSTUAUBUCUIXJVQZUYHUXPUVBUXQOOFGUYBUUMUUQJ
      MQUBUCUYGUFUXPVKZUWKUXQVKZXNXOWTUXTIUXOVFZEUXRVFZVLUXNUVRIEUXOUXRUUMUUQUN
      XQUPXQXPOOUXQXRXSUXNUYLUVPUYMUVQUXNUVPUYLUXNUVOUXOIUXNUWDUYAUYDUVOUXOVFUY
      EUYFUYIUVNFPUUMUUQJMVHQUBUCUEUVNVKZXTYAWTYBUXNUXROEUXNUXROOURUSUYBUYBHFHV
      DZURVDVAUYOUSVDVAXDWMYCZVBZOUXNUXQUYPOOUXNUWDUXQUYPVFUYEUSUYPUXQFGHUYBUXP
      JMVHQURUBUCUYGUFUYJUYPVKZUYKYDXLYEUXNUWDUYCUYQOVFUYEUYHUSBUYPOFHUYBJMOQUR
      TUBUCUYGUDUYRYHVOYFWTWAYGYIYSYGYIYJYGYJUWAUVMUVPVLZUPVGUNVGZUVQVLZAUWCUWA
      UYSUVQVLZUPVGUNVGVUAUVSVUBUNUPVUBUVSUVMUVPUVQWGYKYLUYSUVQUNUPYMWDAUWCVUAA
      UWBUYTUVQAUWBUVPUPUVKYNUNUVIYNZUYTAUVIPYOVAZVCUVKVUDVCUWBVUCVMAPVIVAZVUDU
      VIAUWDPYPVCPYQVCVUEVUDUUAUKPJMQUBUEUUBPUUCVUEPVUEVKZUUDUUEZAUWDUWHUVIVUEV
      CUKULBVUEPJLMNQRTUAUBUEUIVUFYRVOYTAVUEVUDUVKVUGAUWDUWJUVKVUEVCUKUMBVUEPJL
      MNQSTUAUBUEUIVUFYRVOYTUNUPUVNDUVIUVKPIUYNUGUUFVOUVPUNUPUVIUVKUUGWEWFYBYGU
      UH $.
  $}

  $c DIsoC $.

  $( Extend class notation with isomorphism C. $)
  cdic $a class DIsoC $.

  ${
    $d k w x q r f s g $.
    $( Isomorphism C has domain of lattice atoms that are not less than or
       equal to the fiducial co-atom ` w ` .  The value is a one-dimensional
       subspace generated by the pair consisting of the ` iota_ ` vector below
       and the endomorphism ring unit.  Definition of phi(q) in [Crawley]
       p. 121.  Note that we use the fixed atom ` ( ( oc ` k ) ` w ) ` to
       represent the p in their "Choose an atom p..." on line 21.  (Contributed
       by NM, 15-Dec-2013.) $)
    df-dic $a |- DIsoC = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
        ( q e. { r e. ( Atoms ` k ) | -. r ( le ` k ) w } |->
    { <. f , s >. | ( f = ( s ` ( iota_ g e. ( ( LTrn ` k ) ` w )
           ( g ` ( ( oc ` k ) ` w ) ) = q ) )
        /\ s e. ( ( TEndo ` k ) ` w ) ) } ) ) ) $.
  $}

  ${
    $d k .<_ $.  $d k r A $.  $d k w H $.  $d f g k q r s w K $.
    dicval.l $e |- .<_ = ( le ` K ) $.
    dicval.a $e |- A = ( Atoms ` K ) $.
    dicval.h $e |- H = ( LHyp ` K ) $.
    $( The partial isomorphism C for a lattice ` K ` .  (Contributed by NM,
       15-Dec-2013.) $)
    dicffval $p |- ( K e. V -> ( DIsoC ` K ) = ( w e. H |->
        ( q e. { r e. A | -. r .<_ w } |->
    { <. f , s >. | ( f = ( s ` ( iota_ g e. ( ( LTrn ` K ) ` w )
  ( g ` ( ( oc ` K ) ` w ) ) = q ) ) /\ s e. ( ( TEndo ` K ) ` w ) ) } ) ) ) $=
      ( wcel cfv cv wceq cmpt fveq2 vk cvv cdic wbr wn crab coc cltrn ctendo wa
      crio copab elex clh cple catm breqd notbid rabeqbidv fveq1d fveq2d eqeq1d
      syl6eqr riotaeqbidv eqeq2d eleq2d anbi12d opabbidv mpteq12dv fvex eqeltri
      df-dic mptex fvmpt syl ) FHOFUBOFUCPAEKJQZAQZGUDZUEZJBUFZCQZVQFUGPZPZDQZP
      ZKQZRZDVQFUHPZPZUKZIQZPZRZWKVQFUIPZPZOZUJZCIULZSZSZRFHUMUAFAUAQZUNPZKVPVQ
      XAUOPZUDZUEZJXAUPPZUFZWAVQXAUGPZPZWDPZWFRZDVQXAUHPZPZUKZWKPZRZWKVQXAUIPZP
      ZOZUJZCIULZSZSWTUBUCXAFRZAXBYBEWSYCXBFUNPZEXAFUNTNVCYCKXGYAVTWRYCXEVSJXFB
      YCXFFUPPBXAFUPTMVCYCXDVRYCXCGVPVQYCXCFUOPGXAFUOTLVCUQURUSYCXTWQCIYCXPWMXS
      WPYCXOWLWAYCXNWJWKYCXKWGDXMWIYCVQXLWHXAFUHTUTYCXJWEWFYCXIWCWDYCVQXHWBXAFU
      GTUTVAVBVDVAVEYCXRWOWKYCVQXQWNXAFUITUTVFVGVHVIVIACDUAIJKVLAEWSEYDUBNFUNVJ
      VKVMVNVO $.

    $d q w .<_ $.  $d q w A $.  $d w E $.  $d w P $.  $d g w T $.
    $d f g q r s w W $.
    dicval.p $e |- P = ( ( oc ` K ) ` W ) $.
    dicval.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dicval.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dicval.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( The partial isomorphism C for a lattice ` K ` .  (Contributed by NM,
       15-Dec-2013.) $)
    dicfval $p |- ( ( K e. V /\ W e. H ) -> I =
        ( q e. { r e. A | -. r .<_ W } |-> { <. f , s >. | (
          f = ( s ` ( iota_ g e. T ( g ` P ) = q ) ) /\ s e. E ) } ) ) $=
      ( vw wcel cv wbr wn crab coc cfv wceq cltrn crio ctendo wa copab dicffval
      cmpt fveq1d syl5eq breq2 notbid rabbidv syl6eqr fveq2d eqeq1d riotaeqbidv
      cdic fveq2 eqeq2d eleq2d anbi12d opabbidv mpteq12dv eqid catm cvv eqeltri
      fvex rabex mptex fvmpt sylan9eq ) IKUDZLGUDHLUCGONUEZUCUEZJUFZUGZNAUHZDUE
      ZWFIUIUJZUJZEUEZUJZOUEZUKZEWFIULUJZUJZUMZMUEZUJZUKZWTWFIUNUJZUJZUDZUOZDMU
      PZURZURZUJZOWELJUFZUGZNAUHZWJBWMUJZWOUKZECUMZWTUJZUKZWTFUDZUOZDMUPZURZWDH
      LIVHUJZUJXJUBWDLYCXIUCADEGIJKMNOPQRUQUSUTUCLXHYBGXIWFLUKZOWIXGXMYAYDWHXLN
      AYDWGXKWFLWEJVAVBVCYDXFXTDMYDXBXRXEXSYDXAXQWJYDWSXPWTYDWPXOEWRCYDWRLWQUJC
      WFLWQVITVDYDWNXNWOYDWLBWMYDWLLWKUJBWFLWKVISVDVEVFVGVEVJYDXDFWTYDXDLXCUJFW
      FLXCVIUAVDVKVLVMVNXIVOOXMYAXLNAAIVPUJVQQIVPVSVRVTWAWBWC $.

    $d r .<_ $.  $d f q s E $.  $d f q P $.  $d f g q r s Q $.  $d f q T $.
    $( The partial isomorphism C for a lattice ` K ` .  (Contributed by NM,
       15-Dec-2013.)  (Revised by Mario Carneiro, 22-Sep-2015.) $)
    dicval $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
          -> ( I ` Q ) = { <. f , s >. | (
              f = ( s ` ( iota_ g e. T ( g ` P ) = Q ) ) /\ s e. E ) } ) $=
      ( vq vr wcel wa wbr wn cv crab wceq crio copab cmpt dicfval adantr fveq1d
      simpr breq1 notbid elrab sylibr eqeq2 riotabidv fveq2d eqeq2d anbi1d eqid
      cfv opabbidv cuni crn cpw cxp cvv fvex eqeltri uniex rnex pwex xpex simpl
      ctendo wss fvssunirn elssuni adantl rnss uniss 3syl syl5ss elpw2 ssopab2i
      eqeltrd jca df-xp sseqtr4i ssexi fvmpt syl eqtrd ) JLUDMHUDUEZCAUDCMKUFZU
      GZUEZUEZCIVHCUBUCUHZMKUFZUGZUCAUIZEUHZBFUHVHZUBUHZUJZFDUKZNUHZVHZUJZXOGUD
      ZUEZENULZUMZVHZXJXKCUJZFDUKZXOVHZUJZXRUEZENULZXECIYAXAIYAUJXDABDEFGHIJKLM
      NUCUBOPQRSTUAUNUOUPXECXIUDZYBYHUJXEXDYIXAXDUQXHXCUCCAXFCUJXGXBXFCMKURUSUT
      VAUBCXTYHXIYAXLCUJZXSYGENYJXQYFXRYJXPYEXJYJXNYDXOYJXMYCFDXLCXKVBVCVDVEVFV
      IYAVGYHGVJZVKZVJZVLZGVMZYNGYMYLYKGGMJWBVHZVHVNTMYPVOVPZVQVRVQZVSYQVTYHXJY
      NUDZXRUEZENULYOYGYTENYGYSXRYGXJYEYNYFXRWAYGYEYMWCYEYNUDYGYEXOVKZVJZYMXOYD
      WDYGXOYKWCZUUAYLWCUUBYMWCXRUUCYFXOGWEWFXOYKWGUUAYLWHWIWJYEYMYRWKVAWMYFXRU
      QWNWLENYNGWOWPWQWRWSWT $.

    ${
      $d f s F $.  $d s P $.  $d f s S $.  $d s T $.
      dicelval.f $e |- F e. _V $.
      dicelval.s $e |- S e. _V $.
      $( Membership in value of the partial isomorphism C for a lattice
         ` K ` .  (Contributed by NM, 15-Feb-2014.) $)
      dicopelval $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
            -> ( <. F , S >. e. ( I ` Q )
            <-> ( F = ( S ` ( iota_ g e. T ( g ` P ) = Q ) ) /\ S e. E ) ) ) $=
        ( vf vs wcel wa wbr wn cop cfv cv wceq copab dicval eleq2d eqeq1 anbi1d
        crio fveq1 eqeq2d eleq1 anbi12d opelopab syl6bb ) KMUFNIUFUGCAUFCNLUHUI
        UGUGZHDUJZCJUKZUFVGUDULZBFULUKCUMFEUSZUEULZUKZUMZVKGUFZUGZUDUEUNZUFHVJD
        UKZUMZDGUFZUGZVFVHVPVGABCEUDFGIJKLMNUEOPQRSTUAUOUPVOHVLUMZVNUGVTUDUEHDU
        BUCVIHUMVMWAVNVIHVLUQURVKDUMZWAVRVNVSWBVLVQHVJVKDUTVAVKDGVBVCVDVE $.
    $}

    ${
      $d s P $.  $d s T $.  $d f s Y $.
      $( Membership in value of the partial isomorphism C for a lattice
         ` K ` .  (Contributed by NM, 25-Feb-2014.)
         (New usage is discouraged.) $)
      dicelvalN $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
            -> ( Y e. ( I ` Q ) <-> ( Y e. ( _V X. _V )
           /\ ( ( 1st ` Y ) = ( ( 2nd ` Y ) ` ( iota_ g e. T ( g ` P ) = Q ) )
                /\ ( 2nd ` Y ) e. E ) ) ) ) $=
        ( vf vs wcel wa wbr wn cfv cv wceq crio cvv cxp c1st c2nd dicval eleq2d
        copab cop op1std op2ndd fveq1d eqeq12d eleq1d anbi12d elopaba syl6bb
        vex ) IKUCLGUCUDCAUCCLJUEUFUDUDZMCHUGZUCMUAUHZBEUHUGCUIEDUJZUBUHZUGZUIZ
        VLFUCZUDZUAUBUQZUCMUKUKULUCMUMUGZVKMUNUGZUGZUIZVSFUCZUDZUDVHVIVQMABCDUA
        EFGHIJKLUBNOPQRSTUOUPWCVPUAUBMMVJVLURUIZWAVNWBVOWDVRVJVTVMVJVLMUAVGZUBV
        GZUSWDVKVSVLVJVLMWEWFUTZVAVBWDVSVLFWGVCVDVEVF $.
    $}

    dicval2.g $e |- G = ( iota_ g e. T ( g ` P ) = Q ) $.
    $( The partial isomorphism C for a lattice ` K ` .  (Contributed by NM,
       20-Feb-2014.) $)
    dicval2 $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
          -> ( I ` Q ) = { <. f , s >. | (
              f = ( s ` G ) /\ s e. E ) } ) $=
      ( wcel wa wbr wn cfv wceq crio copab dicval fveq2i eqeq2i opabbii syl6eqr
      cv anbi1i ) KMUDNIUDUECAUDCNLUFUGUEUECJUHEUQZBFUQUHCUIFDUJZOUQZUHZUIZVAGU
      DZUEZEOUKUSHVAUHZUIZVDUEZEOUKABCDEFGIJKLMNOPQRSTUAUBULVHVEEOVGVCVDVFVBUSH
      UTVAUCUMUNURUOUP $.

    $d f G $.  $d f s Y $.
    $( Member of the partial isomorphism C. (Contributed by NM,
       26-Feb-2014.) $)
    dicelval3 $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
    -> ( Y e. ( I ` Q ) <-> E. s e. E Y = <. ( s ` G ) , s >. ) ) $=
      ( vf wcel wa wbr wn cfv wceq copab cop wrex dicval2 eleq2d wex excom an12
      exbii fvex opeq1 eqeq2d anbi1d ceqsexv ancom 3bitri elopab df-rex 3bitr4i
      cv bitri syl6bb ) JLUEMHUEUFCAUECMKUGUHUFUFZNCIUIZUENUDVJZGOVJZUIZUJZVPFU
      EZUFZUDOUKZUEZNVQVPULZUJZOFUMZVMVNWANABCDUDEFGHIJKLMOPQRSTUAUBUCUNUONVOVP
      ULZUJZVTUFZOUPUDUPZVSWDUFZOUPZWBWEWIWHUDUPZOUPWKWHUDOUQWLWJOWLVRWGVSUFZUF
      ZUDUPWDVSUFZWJWHWNUDWGVRVSURUSWMWOUDVQGVPUTVRWGWDVSVRWFWCNVOVQVPVAVBVCVDW
      DVSVEVFUSVKVTUDONVGWDOFVHVIVL $.

    ${
      dicelval2.f $e |- F e. _V $.
      dicelval2.s $e |- S e. _V $.
      $( Membership in value of the partial isomorphism C for a lattice
         ` K ` .  (Contributed by NM, 20-Feb-2014.) $)
      dicopelval2 $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
            -> ( <. F , S >. e. ( I ` Q )
            <-> ( F = ( S ` G ) /\ S e. E ) ) ) $=
        ( wcel wa wbr cop cfv wceq crio dicopelval fveq2i eqeq2i anbi1i syl6bbr
        wn cv ) LNUFOJUFUGCAUFCOMUHURUGUGHDUICKUJUFHBFUSUJCUKFEULZDUJZUKZDGUFZU
        GHIDUJZUKZVCUGABCDEFGHJKLMNOPQRSTUAUBUDUEUMVEVBVCVDVAHIUTDUCUNUOUPUQ $.
    $}

    $( Membership in value of the partial isomorphism C for a lattice ` K ` .
       (Contributed by NM, 25-Feb-2014.)  (New usage is discouraged.) $)
    dicelval2N $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
    -> ( Y e. ( I ` Q ) <-> ( Y e. ( _V X. _V )
        /\ ( ( 1st ` Y ) = ( ( 2nd ` Y ) ` G ) /\ ( 2nd ` Y ) e. E ) ) ) ) $=
      ( wcel wa wbr wn cfv cvv c1st cv wceq crio dicelvalN fveq2i eqeq2i anbi1i
      cxp c2nd anbi2i syl6bbr ) JLUCMHUCUDCAUCCMKUEUFUDUDNCIUGUCNUHUHUQUCZNUIUG
      ZBEUJUGCUKEDULZNURUGZUGZUKZVDFUCZUDZUDVAVBGVDUGZUKZVGUDZUDABCDEFHIJKLMNOP
      QRSTUAUMVKVHVAVJVFVGVIVEVBGVCVDUBUNUOUPUSUT $.
  $}

  ${
    $d p q .<_ $.  $d p q A $.  $d q H $.  $d f p q s u K $.  $d f p q s u W $.
    $d q V $.
    dicfn.l $e |- .<_ = ( le ` K ) $.
    dicfn.a $e |- A = ( Atoms ` K ) $.
    dicfn.h $e |- H = ( LHyp ` K ) $.
    dicfn.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( Functionality and domain of the partial isomorphism C. (Contributed by
       NM, 8-Mar-2014.)  (New usage is discouraged.) $)
    dicfnN $p |- ( ( K e. V /\ W e. H ) -> I Fn { p e. A | -. p .<_ W } ) $=
      ( vq vf vu vs wcel wa cv cfv wbr wn crab wfn wceq cltrn crio ctendo copab
      coc cmpt cvv wral breq1 notbid elrab eqid dicval fvex syl6eqelr ralrimiva
      sylan2b fnmpt syl dicfval fneq1d mpbird ) DFQGBQRZCHSZGEUAZUBZHAUCZUDMVLN
      SGDUJTTZOSTMSZUEOGDUFTTZUGPSZTUEVPGDUHTTZQRNPUIZUKZVLUDZVHVRULQZMVLUMVTVH
      WAMVLVNVLQVHVNAQVNGEUAZUBZRZWAVKWCHVNAVIVNUEVJWBVIVNGEUNUOUPVHWDRVRVNCTUL
      AVMVNVONOVQBCDEFGPIJKVMUQZVOUQZVQUQZLURVNCUSUTVBVAMVLVRVSULVSUQVCVDVHVLCV
      SAVMVONOVQBCDEFGPHMIJKWEWFWGLVEVFVG $.

    $( Domain of the partial isomorphism C. (Contributed by NM, 8-Mar-2014.)
       (New usage is discouraged.) $)
    dicdmN $p |- ( ( K e. V /\ W e. H )
  -> dom I = { p e. A | -. p .<_ W } ) $=
      ( wcel wa cv wbr wn crab wfn cdm wceq dicfnN fndm syl ) DFMGBMNCHOGEPQHAR
      ZSCTUEUAABCDEFGHIJKLUBUECUCUD $.
  $}

  ${
    $d f g p s K $.  $d f g p s W $.  $d f g p s X $.
    dicvalrel.h $e |- H = ( LHyp ` K ) $.
    dicvalrel.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( The value of partial isomorphism C is a relation.  (Contributed by NM,
       8-Mar-2014.)  (New usage is discouraged.) $)
    dicvalrelN $p |- ( ( K e. V /\ W e. H ) -> Rel ( I ` X ) ) $=
      ( vf vg vs vp wcel wa cfv wrel cv wceq wn eqid cdm coc cltrn ctendo copab
      crio relopab catm cple wbr dicdmN eleq2d breq1 notbid elrab syl6bb biimpa
      crab dicval syldan releqd mpbiri ex c0 rel0 ndmfv pm2.61d1 ) CDMEAMNZFBUA
      ZMZFBOZPZVHVJVLVHVJNZVLIQECUBOOZJQOFRJECUCOOZUFKQZORVPECUDOOZMNZIKUEZPVRI
      KUGVMVKVSVHVJFCUHOZMFECUIOZUJZSZNZVKVSRVHVJWDVHVJFLQZEWAUJZSZLVTURZMWDVHV
      IWHFVTABCWADELWATZVTTZGHUKULWGWCLFVTWEFRWFWBWEFEWAUMUNUOUPUQVTVNFVOIJVQAB
      CWADEKWIWJGVNTVOTVQTHUSUTVAVBVCVJSZVLVDPVEWKVKVDFBVFVAVBVG $.
  $}

  ${
    $d f g s .<_ $.  $d f g s A $.  $d f g s H $.  $d f g s K $.  $d f g s W $.
    $d f g s Q $.
    dicssdvh.l $e |- .<_ = ( le ` K ) $.
    dicssdvh.a $e |- A = ( Atoms ` K ) $.
    dicssdvh.h $e |- H = ( LHyp ` K ) $.
    dicssdvh.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    dicssdvh.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dicssdvh.v $e |- V = ( Base ` U ) $.
    $( The partial isomorphism C maps to a set of vectors in full vector space
       H. (Contributed by NM, 19-Jan-2014.) $)
    dicssdvh $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
          -> ( I ` Q ) C_ V ) $=
      ( vf vs wcel wa cfv vg chlt wbr wn cv wceq cltrn crio ctendo copab simprl
      coc cxp simpll simprr lhpocnel ad2antrr simplr ltrniotacl syl3anc tendocl
      eqeltrd jca31 ex ssopab2dv opabssxp syl6ss dicval dvhvbase adantr 3sstr4d
      eqid ) FUBRIDRSZBARBIGUCUDSZSZPUEZIFULTZTZUAUETBUFUAIFUGTTZUHZQUEZTZUFZWA
      IFUITTZRZSZPQUJZVSWDUMZBETHVOWGVPVSRZWESWESZPQUJWHVOWFWJPQVOWFWJVOWFSZWIW
      EWEWKVPWBVSVOWCWEUKWKVMWEVTVSRZWBVSRVMVNWFUNZVOWCWEUOZWKVMVRARVRIGUCUDSZV
      NWLWMVMWOVNWFADFGVQIJVQVLKLUPUQVMVNWFURAVRBVSUAVTDFGIJKLVSVLZVTVLUSUTWAVS
      WDVTDFUBILWPWDVLZVAUTVBWNWNVCVDVEWEPQVSWDVFVGAVRBVSPUAWDDEFGUBIQJKLVRVLWP
      WQMVHVMHWHUFVNVSCWDDFHIUBLWPWQNOVIVJVK $.
  $}

  ${
    $d f g s K $.  $d f s P $.  $d f g s Q $.  $d f g s T $.  $d f g s W $.
    $d f s Y $.
    dicelval1sta.l $e |- .<_ = ( le ` K ) $.
    dicelval1sta.a $e |- A = ( Atoms ` K ) $.
    dicelval1sta.h $e |- H = ( LHyp ` K ) $.
    dicelval1sta.p $e |- P = ( ( oc ` K ) ` W ) $.
    dicelval1sta.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dicelval1sta.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism C for a lattice ` K ` .
       (Contributed by NM, 16-Feb-2014.) $)
    dicelval1sta $p |- ( ( ( K e. V /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ Y e. ( I ` Q ) )
       -> ( 1st ` Y ) = ( ( 2nd ` Y ) ` ( iota_ g e. T ( g ` P ) = Q ) ) ) $=
      ( wcel cfv vf vs wa wbr wn w3a c1st cv wceq crio c2nd ctendo copab dicval
      eleq2d biimp3a eqeq1 anbi1d fveq1 eqeq2d eleq1 anbi12d elopabi syl simpld
      eqid ) HJSKFSUCZCASCKIUDUEUCZLCGTZSZUFZLUGTZBEUHTCUIEDUJZLUKTZTZUIZVNKHUL
      TTZSZVKLUAUHZVMUBUHZTZUIZVTVQSZUCZUAUBUMZSZVPVRUCZVGVHVJWFVGVHUCVIWELABCD
      UAEVQFGHIJKUBMNOPQVQVFRUNUOUPWDVLWAUIZWCUCWGUAUBLVSVLUIWBWHWCVSVLWAUQURVT
      VNUIZWHVPWCVRWIWAVOVLVMVTVNUSUTVTVNVQVAVBVCVDVE $.
  $}

  ${
    dicelval1st.l $e |- .<_ = ( le ` K ) $.
    dicelval1st.a $e |- A = ( Atoms ` K ) $.
    dicelval1st.h $e |- H = ( LHyp ` K ) $.
    dicelval1st.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dicelval1st.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism C for a lattice ` K ` .
       (Contributed by NM, 16-Feb-2014.)  (New usage is discouraged.) $)
    dicelval1stN $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( Q e. A /\ -. Q .<_ W ) /\ Y e. ( I ` Q ) ) -> ( 1st ` Y ) e. T ) $=
      ( chlt wcel wa wbr cfv eqid wn w3a ctendo cxp c1st cdvh cbs dicssdvh wceq
      dvhvbase adantr sseqtrd sseld 3impia xp1st syl ) FOPHDPQZBAPBHGRUAQZIBESZ
      PZUBICHFUCSSZUDZPZIUESCPUQURUTVCUQURQZUSVBIVDUSHFUFSSZUGSZVBABVEDEFGVFHJK
      LNVETZVFTZUHUQVFVBUIURCVEVADFVFHOLMVATVGVHUJUKULUMUNICVAUOUP $.
  $}

  ${
    dicelval2nd.l $e |- .<_ = ( le ` K ) $.
    dicelval2nd.a $e |- A = ( Atoms ` K ) $.
    dicelval2nd.h $e |- H = ( LHyp ` K ) $.
    dicelval2nd.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dicelval2nd.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( Membership in value of the partial isomorphism C for a lattice ` K ` .
       (Contributed by NM, 16-Feb-2014.) $)
    dicelval2nd $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( Q e. A /\ -. Q .<_ W ) /\ Y e. ( I ` Q ) ) -> ( 2nd ` Y ) e. E ) $=
      ( chlt wcel wa wbr cfv eqid w3a cltrn cxp c2nd cdvh cbs dicssdvh dvhvbase
      wn wceq adantr sseqtrd sseld 3impia xp2nd syl ) FOPHDPQZBAPBHGRUIQZIBESZP
      ZUAIHFUBSSZCUCZPZIUDSCPUQURUTVCUQURQZUSVBIVDUSHFUESSZUFSZVBABVEDEFGVFHJKL
      NVETZVFTZUGUQVFVBUJURVAVECDFVFHOLVATMVGVHUHUKULUMUNIVACUOUP $.
  $}

  ${
    $d g .<_ $.  $d g A $.  $d g h H $.  $d g h s t K $.  $d g h s t W $.
    $d g Q $.
    dicvaddcl.l $e |- .<_ = ( le ` K ) $.
    dicvaddcl.a $e |- A = ( Atoms ` K ) $.
    dicvaddcl.h $e |- H = ( LHyp ` K ) $.
    dicvaddcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dicvaddcl.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    dicvaddcl.p $e |- .+ = ( +g ` U ) $.
    $( Membership in value of the partial isomorphism C is closed under vector
       sum.  (Contributed by NM, 16-Feb-2014.) $)
    dicvaddcl $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( X e. ( I ` Q ) /\ Y e. ( I ` Q ) ) )
      -> ( X .+ Y ) e. ( I ` Q ) ) $=
      ( wcel cfv eqid vg vs vt vh chlt wa wbr wn w3a c1st ccom c2nd csca cplusg
      cop cltrn ctendo cxp wceq simp1 wss cbs dicssdvh dvhvbase eqcomd sseqtr4d
      co adantr 3adant3 simp3l sseldd simp3r dvhvadd syl12anc coc cv crio cmpt2
      cmpt dicelval2nd 3adant3r 3adant3l lhpocnel ltrniotacl syl3anc tendospdi2
      3ad2ant1 dvhfplusr fveq1d dicelval1sta coeq12d 3eqtr4rd tendoplcl eqeltrd
      simp2 oveqd wb fvex coex ovex dicopelval mpbir2and ) GUERIERUFZCARCIHUGUH
      UFZJCFSZRZKXERZUFZUIZJKBVGZJUJSZKUJSZUKZJULSZKULSZDUMSZUNSZVGZUOZXEXIXCJI
      GUPSSZIGUQSSZURZRKYBRXJXSUSXCXDXHUTZXIXEYBJXCXDXEYBVAXHXCXDUFXEDVBSZYBACD
      EFGHYDILMNPOYDTZVCXCYBYDUSXDXCYDYBXTDYAEGYDIUENXTTZYATZOYEVDVEVHVFVIZXCXD
      XFXGVJVKXIXEYBKYHXCXDXFXGVLVKXPBXQXTDYAJKEGINYFYGOXPTZQXQTZVMVNXIXSXERZXM
      IGVOSZSZUAVPSCUSUAXTVQZXRSZUSZXRYARZXIYNXNXOUBUCYAYAUDXTUDVPZUBVPSYRUCVPS
      UKVSVRZVGZSZYNXNSZYNXOSZUKZYOXMXIXNYARZXOYARZYNXTRZUUAUUDUSXCXDXFUUEXGACY
      AEFGHIJLMNYGPVTWAZXCXDXGUUFXFACYAEFGHIKLMNYGPVTWBZXIXCYMARYMIHUGUHUFZXDUU
      GYCXCXDUUJXHAEGHYLILYLTMNWCWGXCXDXHWOAYMCXTUAYNEGHILMNYFYNTWDWEUCYSXTXNUD
      YAYNGXOIUBYFYSTZWFWEXIYNXRYTXIXQYSXNXOXCXDXQYSUSXHUCYSXQXTDUDYAXPEGUEIUBN
      YFYGOYIUUKYJWHWGWPZWIXIXKUUBXLUUCXCXDXFXKUUBUSXGAYMCXTUAEFGHUEIJLMNYMTZYF
      PWJWAXCXDXGXLUUCUSXFAYMCXTUAEFGHUEIKLMNUUMYFPWJWBWKWLXIXRYTYAUULXIXCUUEUU
      FYTYARYCUUHUUIUCYSXTXNUDYAEGXOIUBNYFYGUUKWMWEWNXCXDYKYPYQUFWQXHAYMCXRXTUA
      YAXMEFGHUEILMNUUMYFYGPXKXLJUJWRKUJWRWSXNXOXQWTXAVIXBWN $.
  $}

  ${
    $d g .<_ $.  $d g A $.  $d g H $.  $d g K $.  $d g Q $.  $d g W $.
    dicvscacl.l $e |- .<_ = ( le ` K ) $.
    dicvscacl.a $e |- A = ( Atoms ` K ) $.
    dicvscacl.h $e |- H = ( LHyp ` K ) $.
    dicvscacl.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dicvscacl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dicvscacl.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    dicvscacl.s $e |- .x. = ( .s ` U ) $.
    $( Membership in value of the partial isomorphism C is closed under scalar
       product.  (Contributed by NM, 16-Feb-2014.)  (Revised by Mario Carneiro,
       24-Jun-2014.) $)
    dicvscacl $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( X e. E /\ Y e. ( I ` Q ) ) )
      -> ( X .x. Y ) e. ( I ` Q ) ) $=
      ( cfv vg chlt wcel wa wbr wn w3a co c1st cid c2nd ccom cop cltrn cxp wceq
      simp1 simp3l wss cbs eqid dicssdvh dvhvbase eqcomd adantr sseqtr4d simp3r
      3adant3 sseldd dvhvsca syl12anc fvi syl coeq1d opeq2d eqtr4d dicelval1sta
      coc cv crio 3adant3l fveq2d wf dicelval2nd tendof lhpocnel 3ad2ant1 simp2
      syl2anc ltrniotacl syl3anc fvco3 fveq1d tendococl eqeltrd fvex dicopelval
      wb coex mpbir2and ) HUBUCJFUCUDZBAUCBJIUEUFUDZKEUCZLBGTZUCZUDZUGZKLCUHZLU
      ITZKTZKUJTZLUKTZULZUMZXDXGXHXJKXLULZUMZXNXGXAXCLJHUNTTZEUOZUCXHXPUPXAXBXF
      UQZXAXBXCXEURZXGXDXRLXAXBXDXRUSXFXAXBUDXDDUTTZXRABDFGHIYAJMNORQYAVAZVBXAX
      RYAUPXBXAYAXRXQDEFHYAJUBOXQVAZPQYBVCVDVEVFVHXAXBXCXEVGVIKXQCDELFHUBJOYCPQ
      SVJVKXGXMXOXJXGXKKXLXGXCXKKUPXTKEVLVMVNZVOVPXGXNXDUCZXJJHVRTZTZUAVSTBUPUA
      XQVTZXMTZUPZXMEUCZXGXJYHXOTZYIXGXJYHXLTZKTZYLXGXIYMKXAXBXEXIYMUPXCAYGBXQU
      AFGHIUBJLMNOYGVAZYCRVQWAWBXGXQXQXLWCZYHXQUCZYLYNUPXGXAXLEUCZYPXSXAXBXEYRX
      CABEFGHIJLMNOPRWDWAZXLXQEFHUBJOYCPWEWIXGXAYGAUCYGJIUEUFUDZXBYQXSXAXBYTXFA
      FHIYFJMYFVANOWFWGXAXBXFWHAYGBXQUAYHFHIJMNOYCYHVAWJWKXQXQYHKXLWLWIVPXGYHXM
      XOYDWMVPXGXMXOEYDXGXAXCYRXOEUCXSXTYSKXLEFHJOPWNWKWOXAXBYEYJYKUDWRXFAYGBXM
      XQUAEXJFGHIUBJMNOYOYCPRXIKWPXKXLKUJWPLUKWPWSWQVHWTWO $.
  $}

  ${
    $d g .<_ $.  $d g A $.  $d g H $.  $d f g K $.  $d g Q $.  $d f g W $.
    dicn0.l $e |- .<_ = ( le ` K ) $.
    dicn0.a $e |- A = ( Atoms ` K ) $.
    dicn0.h $e |- H = ( LHyp ` K ) $.
    dicn0.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    $( The value of the partial isomorphism C is not empty.  (Contributed by
       NM, 15-Feb-2014.) $)
    dicn0 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
            -> ( I ` Q ) =/= (/) ) $=
      ( vf vg chlt wcel wa cfv wceq eqid cvv wbr wn cid cbs cres cltrn cmpt cop
      c0 wne coc cv crio ctendo simpl lhpocnel simpr ltrniotacl syl3anc tendo02
      adantr eqcomd tendo0cl fvex resiexg ax-mp mptex dicopelval mpbir2and ne0i
      syl ) ENOGCOPZBAOBGFUAUBPZPZUCEUDQZUEZLGEUFQZQZVPUGZUHZBDQZOZWAUIUJVNWBVP
      GEUKQZQZMULQBRMVRUMZVSQZRVSGEUNQQZOZVNWFVPVNWEVROZWFVPRVNVLWDAOWDGFUAUBPZ
      VMWIVLVMUOVLWJVMACEFWCGHWCSIJUPVAVLVMUQAWDBVRMWECEFGHIJVRSZWESURUSVOVRLWE
      EVSVSSZVOSZUTVKVBVLWHVMVOVRLWGCEVSGWMJWKWGSZWLVCVAAWDBVSVRMWGVPCDEFNGHIJW
      DSWKWNKVOTOVPTOEUDVDVOTVEVFLVRVPGVQVDVGVHVIWAVTVJVK $.
  $}

  ${
    $d a b x .<_ $.  $d a b x A $.  $d a b x H $.  $d a b x I $.  $d a b x K $.
    $d a b x Q $.  $d a b x U $.  $d a b x W $.
    diclss.l $e |- .<_ = ( le ` K ) $.
    diclss.a $e |- A = ( Atoms ` K ) $.
    diclss.h $e |- H = ( LHyp ` K ) $.
    diclss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    diclss.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    diclss.s $e |- S = ( LSubSp ` U ) $.
    $( The value of partial isomorphism C is a subspace of partial vector space
       H. (Contributed by NM, 16-Feb-2014.) $)
    diclss $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
          -> ( I ` Q ) e. S ) $=
      ( chlt wcel wa cfv eqid vx va vb wbr ctendo cplusg cvsca csca cltrn eqidd
      wn cxp cbs wceq dvhbase eqcomd adantr dvhvbase clss a1i dicssdvh sseqtr4d
      dicn0 cv w3a co simpll simplr simpr1 simpr2 dicvscacl syl112anc dicvaddcl
      simpr3 islssd ) GPQIEQRZBAQBIHUDUKRZRZUAIGUESSZDUFSZCDUGSZBFSZDUHSZIGUISS
      ZVSULZDUBUCVRWCUJVPVSWCUMSZUNVQVPWFVSWFDVSWCEGIPLVSTZMWCTWFTUOUPUQVPWEDUM
      SZUNVQVPWHWEWDDVSEGWHIPLWDTWGMWHTZURUPUQZVRVTUJVRWAUJCDUSSUNVROUTVRWBWHWE
      ABDEFGHWHIJKLNMWIVAWJVBABEFGHIJKLNVCVRUAVDZVSQZUBVDZWBQZUCVDZWBQZVEZRZVPV
      QWKWMWAVFZWBQZWPWSWOVTVFWBQVPVQWQVGZVPVQWQVHZWRVPVQWLWNWTXAXBVRWLWNWPVIVR
      WLWNWPVJABWADVSEFGHIWKWMJKLWGMNWATVKVLVRWLWNWPVNAVTBDEFGHIWSWOJKLMNVTTVMV
      LVO $.
  $}

  ${
    $d f g s v x .<_ $.  $d g s v x F $.  $d g s I $.  $d v x N $.  $d f y P $.
    $d f g s v x A $.  $d f g s v x H $.  $d f g s v x y T $.  $d g s v x U $.
    $d f g s v x y z K $.  $d f g s v x y z Q $.  $d f g s v x y z W $.
    diclspsn.l $e |- .<_ = ( le ` K ) $.
    diclspsn.a $e |- A = ( Atoms ` K ) $.
    diclspsn.h $e |- H = ( LHyp ` K ) $.
    diclspsn.p $e |- P = ( ( oc ` K ) ` W ) $.
    diclspsn.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    diclspsn.i $e |- I = ( ( DIsoC ` K ) ` W ) $.
    diclspsn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    diclspsn.n $e |- N = ( LSpan ` U ) $.
    diclspsn.f $e |- F = ( iota_ f e. T ( f ` P ) = Q ) $.
    $( The value of isomorphism C is spanned by vector ` F ` .  Part of proof
       of Lemma N of [Crawley] p. 121 line 29.  (Contributed by NM,
       21-Feb-2014.)  (Revised by Mario Carneiro, 24-Jun-2014.) $)
    diclspsn $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
         -> ( I ` Q ) = ( N ` { <. F , ( _I |` T ) >. } ) ) $=
      ( vv vx vy vz vg vs chlt wcel wa wbr wn cfv cv cid cres cop cvsca co wceq
      csca cbs wrex cab csn ctendo cxp crab df-rab copab relopab dicval2 releqd
      wrel eqid mpbiri wss ssrab2 relxp relss mp2 a1i id vex dicopelval2 simprl
      w3a simpll simprr simpl lhpocnel2 adantr simpr ltrniotacl syl3anc tendocl
      eqeltrd 3jca simpr3 simpr2 jca impbida dvhbase rexeqdv tendoidcl ad2antrr
      ccom dvhopvsca syl13anc eqeq2d opth syl6bb tendo1mulr equcom anbi2d bitrd
      adantlr ancom rexbidva 3anbi3d fveq1 ceqsrexv pm5.32i anbi2i 3anass eqeq1
      3bitr4i syl6rbb rexbidv eleq2i opabid bitr2i eqrelrdv2 syl21anc wi eleq2d
      rabxp syl2anc syl12anc biimpa opelxpi dvhvscacl eleq1a rexlimdva pm4.71rd
      syl abbidv 3eqtr4a clmod dvhlmod dvhelvbasei lspsn eqtr4d ) JUIUJMHUJUKZC
      AUJCMKULUMUKZUKZCIUNZUCUOZUDUOZGUPDUQZURZEUSUNZUTZVAZUDEVBUNZVCUNZVDZUCVE
      ZUVBVFLUNZUUQUVHUCDMJVGUNUNZVHZVIZUUSUVLUJZUVHUKZUCVEUURUVIUVHUCUVLVJUUQU
      URVOZUVMVOZUUQUURUVMVAUUQUVPUEUOGUFUOZUNVAUVRUVKUJUKZUEUFVKZVOUVSUEUFVLUU
      QUURUVTABCDUEFUVKGHIJKUIMUFNOPQRUVKVPZSUBVMVNVQUVQUUQUVMUVLVRUVLVOUVQUVHU
      CUVLVSDUVKVTUVMUVLWAWBWCUUQWDUUQUGUHUURUVMUUQUGUOZUHUOZURZUURUJUWBGUWCUNZ
      VAZUWCUVKUJZUKZUWDUVMUJZABCUWCDFUVKUWBGHIJKUIMNOPQRUWASUBUGWEZUHWEZWFUUQU
      WHUWBDUJZUWGUWDUVDVAZUDUVGVDZWHZUWIUUQUWHUWLUWGUWFWHZUWOUUQUWHUWPUUQUWHUK
      ZUWLUWGUWFUWQUWBUWEDUUQUWFUWGWGZUWQUUOUWGGDUJZUWEDUJUUOUUPUWHWIUUQUWFUWGW
      JZUUQUWSUWHUUQUUOBAUJBMKULUMUKZUUPUWSUUOUUPWKZUUOUXAUUPABHJKMNOPQWLWMUUOU
      UPWNABCDFGHJKMNOPRUBWOWPZWMUWCDUVKGHJUIMPRUWAWQWPWRUWTUWRWSUUQUWPUKUWFUWG
      UUQUWLUWGUWFWTUUQUWLUWGUWFXAXBXCUUQUWOUWLUWGUUTUWCVAZUWBGUUTUNZVAZUKZUDUV
      KVDZWHZUWPUUQUWNUXHUWLUWGUUQUWNUWMUDUVKVDUXHUUQUWMUDUVGUVKUUOUVGUVKVAUUPU
      VGEUVKUVFHJMUIPUWATUVFVPZUVGVPZXDWMZXEUUQUWMUXGUDUVKUUQUUTUVKUJZUKZUWMUXF
      UXDUKZUXGUXNUWMUXFUWCUUTUVAXHZVAZUKZUXOUXNUWMUWDUXEUXPURZVAUXRUXNUVDUXSUW
      DUXNUUOUXMUWSUVAUVKUJZUVDUXSVAUUOUUPUXMWIUUQUXMWNUUQUWSUXMUXCWMUUOUXTUUPU
      XMDUVKHJMPRUWAXFZXGUUTDUVCEUVKGHJUIMUVAPRUWATUVCVPZXIXJXKUWBUWCUXEUXPUWJU
      WKXLXMUXNUXQUXDUXFUXNUXQUWCUUTVAUXDUXNUXPUUTUWCUUOUXMUXPUUTVAUUPDUUTUVKHJ
      MPRUWAXNXRXKUHUDXOXMXPXQUXFUXDXSXMXTXQYAUWLUWGUXHUKZUKUWLUWGUWFUKZUKUXIUW
      PUYCUYDUWLUWGUXHUWFUXFUWFUDUWCUVKUXDUXEUWEUWBGUUTUWCYBXKYCYDYEUWLUWGUXHYF
      UWLUWGUWFYFYHYIXQUWIUWDUWOUGUHVKZUJUWOUVMUYEUWDUVHUWNUCUGUHDUVKUUSUWDVAUV
      EUWMUDUVGUUSUWDUVDYGYJYRYKUWOUGUHYLYMXMXQYNYOUUQUVHUVOUCUUQUVHUVNUUQUVEUV
      NUDUVGUUQUUTUVGUJZUKZUVDUVLUJZUVEUVNYPUYGUUOUXMUVBUVLUJZUYHUUOUUPUYFWIUUQ
      UYFUXMUUQUVGUVKUUTUXLYQUUAUUQUYIUYFUUQUWSUXTUYIUXCUUOUXTUUPUYAWMZGUVADUVK
      UUBYSWMUUTDUVCEUVKUVBHJMPRUWATUYBUUCYTUVDUVLUUSUUDUUGUUEUUFUUHUUIUUQEUUJU
      JUVBEVCUNZUJZUVJUVIVAUUQEHJMPTUXBUUKUUQUUOUWSUXTUYLUXBUXCUYJUVADEUVKGHJUY
      KMUIPRUWATUYKVPZUULYTUCUVCUDUVFUVGLUYKEUVBUXJUXKUYMUYBUAUUMYSUUN $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h H $.  $d h K $.  $d h Q $.  $d h S $.
    $d h T $.  $d h W $.
    cdlemn2.b $e |- B = ( Base ` K ) $.
    cdlemn2.l $e |- .<_ = ( le ` K ) $.
    cdlemn2.j $e |- .\/ = ( join ` K ) $.
    cdlemn2.a $e |- A = ( Atoms ` K ) $.
    cdlemn2.h $e |- H = ( LHyp ` K ) $.
    cdlemn2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn2.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemn2.f $e |- F = ( iota_ h e. T ( h ` Q ) = S ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 30.  (Contributed by
       NM, 21-Feb-2014.) $)
    cdlemn2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( S e. A /\ -. S .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ S .<_ ( Q .\/ X ) ) -> ( R ` F ) .<_ X ) $=
      ( chlt wcel wa wbr wn w3a co cfv cmee wceq simp1 simp21 simp22 ltrniotacl
      syl3anc eqid trlval2 ltrniotaval oveq2d oveq1d eqtrd simp1l hllat simp21l
      clat syl atbase simp23l latlej1 simp3 wb simp22l latjcl latjle12 syl13anc
      mpbi2and hlatjcl simp1r lhpbase latmlem1 mpd eqbrtrd simp23 lhple breqtrd
      wi ) KUCUDZMIUDZUEZCAUDZCMLUFUGZUEZEAUDZEMLUFUGZUEZNBUDZNMLUFZUEZUHZECNJU
      IZLUFZUHZHDUJZXBMKUKUJZUIZNLXDXECEJUIZMXFUIZXGLXDXECCHUJZJUIZMXFUIZXIXDWK
      HFUDZWNXEXLULWKXAXCUMZXDWKWNWQXMXNWKWNWQWTXCUNZWKWNWQWTXCUOZACEFGHIKLMPRS
      TUBUPUQXOACDFHIJKLXFMPQXFURZRSTUAUSUQXDXKXHMXFXDXJECJXDWKWNWQXJEULXNXOXPA
      CEFGHIKLMPRSTUBUTUQVAVBVCXDXHXBLUFZXIXGLUFZXDCXBLUFZXCXRXDKVGUDZCBUDZWRXT
      XDWIYAWIWJXAXCVDZKVEVHZXDWLYBWLWMWQWTWKXCVFZABCKORVIVHZWRWSWNWQWKXCVJZBJK
      LCNOPQVKUQWKXAXCVLXDYAYBEBUDZXBBUDZXTXCUEXRVMYDYFXDWOYHWOWPWNWTWKXCVNZABE
      KORVIVHXDYAYBWRYIYDYFYGBJKCNOQVOUQZBJKLCEXBOPQVPVQVRXDYAXHBUDZYIMBUDZXRXS
      WHYDXDWIWLWOYLYCYEYJABJKCEOQRVSUQYKXDWJYMWIWJXAXCVTBIKMOSWAVHBKLXFXHXBMOP
      XQWBVQWCWDXDWKWNWTXGNULXNXOWKWNWQWTXCWEABCIJKLXFMNOPQXQRSWFUQWG $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d f B $.  $d h H $.  $d f K $.  $d h K $.
    $d h Q $.  $d h S $.  $d f T $.  $d h T $.  $d f W $.  $d h W $.
    cdlemn2a.b $e |- B = ( Base ` K ) $.
    cdlemn2a.l $e |- .<_ = ( le ` K ) $.
    cdlemn2a.j $e |- .\/ = ( join ` K ) $.
    cdlemn2a.a $e |- A = ( Atoms ` K ) $.
    cdlemn2a.h $e |- H = ( LHyp ` K ) $.
    cdlemn2a.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn2a.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemn2a.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    cdlemn2a.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    cdlemn2a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    cdlemn2a.n $e |- N = ( LSpan ` U ) $.
    cdlemn2a.f $e |- F = ( iota_ h e. T ( h ` Q ) = S ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121.  (Contributed by NM,
       24-Feb-2014.) $)
    cdlemn2a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( S e. A /\ -. S .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ S .<_ ( Q .\/ X ) ) -> ( N ` { <. F , O >. } ) C_ ( I ` X ) ) $=
      ( chlt wcel wa wbr wn w3a cop csn cfv wceq simp1 simp21 simp22 ltrniotacl
      co syl3anc dib1dim2 syl2anc wss cdlemn2 wb simp23 dibord syl121anc mpbird
      trlcl trlle eqsstr3d ) NULUMRKUMUNZCAUMCROUOUPUNZEAUMEROUOUPUNZSBUMSROUOU
      NZUQZECSMVFOUOZUQZJQURUSPUTZJDUTZLUTZSLUTZWFVTJFUMZWIWGVAVTWDWEVBZWFVTWAW
      BWKWLVTWAWBWCWEVCVTWAWBWCWEVDACEFIJKNORUAUCUDUEUKVEVGZBDFGHJKLNPQRTUDUEUF
      UGUIUHUJVHVIWFWIWJVJZWHSOUOZABCDEFIJKMNORSTUAUBUCUDUEUFUKVKWFVTWHBUMZWHRO
      UOZWCWNWOVLWLWFVTWKWPWLWMBDFJKNRTUDUEUFVQVIWFVTWKWQWLWMDFJKNORUAUDUEUFVRV
      IVTWAWBWCWEVMBKLNORWHSTUAUDUHVNVOVPVS $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h H $.  $d h K $.  $d h P $.  $d h Q $.
    $d h R $.  $d h T $.  $d h W $.
    cdlemn3.l $e |- .<_ = ( le ` K ) $.
    cdlemn3.a $e |- A = ( Atoms ` K ) $.
    cdlemn3.p $e |- P = ( ( oc ` K ) ` W ) $.
    cdlemn3.h $e |- H = ( LHyp ` K ) $.
    cdlemn3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn3.f $e |- F = ( iota_ h e. T ( h ` P ) = Q ) $.
    cdlemn3.g $e |- G = ( iota_ h e. T ( h ` P ) = R ) $.
    cdlemn3.j $e |- J = ( iota_ h e. T ( h ` Q ) = R ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 31.  (Contributed by
       NM, 21-Feb-2014.) $)
    cdlemn3 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) -> ( J o. F ) = G ) $=
      ( chlt wcel wa wbr wn w3a ccom cfv wceq cbs wf1o simp1 lhpocnel2 3ad2ant1
      simp2 ltrniotacl syl3anc eqid ltrn1o syl2anc f1of syl simpld atbase fvco3
      wf ltrniotaval fveq2d 3eqtrd syld3an2 eqtr4d wb ltrnco ltrneq3 syl121anc
      mpbid ) KUBUCMIUCUDZCAUCCMLUEUFUDZDAUCDMLUEUFUDZUGZBJGUHZUIZBHUIZUJZWBHUJ
      ZWAWCDWDWAWCBGUIZJUIZCJUIDWAKUKUIZWIGVGZBWIUCZWCWHUJWAWIWIGULZWJWAVRGEUCZ
      WLVRVSVTUMZWAVRBAUCZBMLUEUFZUDZVSWMWNVRVSWQVTABIKLMNOQPUNUOZVRVSVTUPZABCE
      FGIKLMNOQRSUQURZWIEGIKUBMWIUSZQRUTVAWIWIGVBVCWAWOWKWAWOWPWRVDAWIBKXAOVEVC
      WIWIBJGVFVAWAWGCJWAVRWQVSWGCUJWNWRWSABCEFGIKLMNOQRSVHURVIACDEFJIKLMNOQRUA
      VHVJVRWQVSVTWDDUJWRABDEFHIKLMNOQRTVHVKVLWAVRWBEUCZHEUCZWQWEWFVMWNWAVRJEUC
      WMXBWNACDEFJIKLMNOQRUAUQWTEJGIKMQRVNURVRWQVSVTXCWRABDEFHIKLMNOQRTUQVKWRAB
      EWBHIKLMNOQRVOVPVQ $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h B $.  $d h H $.  $d h s t K $.  $d h P $.
    $d h Q $.  $d h R $.  $d h s t T $.  $d h s t W $.
    cdlemn4.b $e |- B = ( Base ` K ) $.
    cdlemn4.l $e |- .<_ = ( le ` K ) $.
    cdlemn4.a $e |- A = ( Atoms ` K ) $.
    cdlemn4.p $e |- P = ( ( oc ` K ) ` W ) $.
    cdlemn4.h $e |- H = ( LHyp ` K ) $.
    cdlemn4.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn4.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    cdlemn4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    cdlemn4.f $e |- F = ( iota_ h e. T ( h ` P ) = Q ) $.
    cdlemn4.g $e |- G = ( iota_ h e. T ( h ` P ) = R ) $.
    cdlemn4.j $e |- J = ( iota_ h e. T ( h ` Q ) = R ) $.
    ${
      cdlemn4.s $e |- .+ = ( +g ` U ) $.
      $( Part of proof of Lemma N of [Crawley] p. 121 line 31.  (Contributed by
         NM, 21-Feb-2014.)  (Revised by Mario Carneiro, 24-Jun-2014.) $)
      cdlemn4 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ ( R e. A /\ -. R .<_ W ) ) -> <. G , ( _I |` T ) >.
              = ( <. F , ( _I |` T ) >. .+ <. J , O >. ) ) $=
        ( chlt wcel wa wbr wn w3a cid cres cop ccom csca cfv cplusg ctendo wceq
        co simp1 lhpocnel2 syl simp2 ltrniotacl syl3anc eqid tendoidcl tendo0cl
        dvhopvadd syl122anc ltrncom cdlemn3 cedring dvhsca fveq2d erng0g oveq2d
        c0g cgrp cbs cdr erngdv drnggrp eqeltrd dvhbase eleqtrrd grprid syl2anc
        eqtrd eqtr3d opeq12d eqtr2d ) NUJUKQLUKULZEAUKEQOUMUNULZFAUKFQOUMUNULZU
        OZJUPGUQZURMPURDVEZJMUSZXCPHUTVAZVBVAZVEZURZKXCURXBWSJGUKZXCQNVCVAVAZUK
        ZMGUKZPXKUKZXDXIVDWSWTXAVFZXBWSCAUKCQOUMUNULZWTXJXOXBWSXPXOACLNOQSTUBUA
        VGVHWSWTXAVIACEGIJLNOQSTUBUCUFVJVKZXBWSXLXOGXKLNQUBUCXKVLZVMVHZAEFGIMLN
        OQSTUBUCUHVJZXBWSXNXOBGIXKLNPQRUBUCXRUDVNVHXFDXGXCPGHXKJMLNQUBUCXRUEXFV
        LZUIXGVLZVOVPXBXEKXHXCXBXEMJUSZKXBWSXJXMXEYCVDXOXQXTGJMLNQUBUCVQVKACEFG
        IJKLMNOQSTUAUBUCUFUGUHVRWOXBXCXFWDVAZXGVEZXHXCXBYDPXCXGXBWSYDPVDXOWSYDQ
        NVSVAVAZWDVAZPWSXFYFWDYFHXFLNQUJUBYFVLZUEYAVTZWABYFGILNPQYGRUBUCYHUDYGV
        LWBWOVHWCXBXFWEUKZXCXFWFVAZUKYEXCVDXBWSYJXOWSXFYFWEYIWSYFWGUKYFWEUKYFLN
        QUBYHWHYFWIVHWJVHXBXCXKYKXSXBWSYKXKVDXOYKHXKXFLNQUJUBXRUEYAYKVLZWKVHWLY
        KXGXFXCYDYLYBYDVLWMWNWPWQWR $.
    $}

    ${
      cdlemn4a.n $e |- N = ( LSpan ` U ) $.
      cdlemn4a.s $e |- .(+) = ( LSSum ` U ) $.
      $( Part of proof of Lemma N of [Crawley] p. 121 line 32.  (Contributed by
         NM, 24-Feb-2014.) $)
      cdlemn4a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
          /\ ( R e. A /\ -. R .<_ W ) ) -> ( N ` { <. G , ( _I |` T ) >. } )
     C_ ( ( N ` { <. F , ( _I |` T ) >. } ) .(+) ( N ` { <. J , O >. } ) ) ) $=
        ( chlt wcel wa wbr wn w3a cid cres cop csn cplusg co eqid cdlemn4 sneqd
        cfv fveq2d clmod cbs simp1 dvhlmod ctendo lhpocnel2 3ad2ant1 ltrniotacl
        simp2 syl3anc tendoidcl dvhelvbasei syl12anc tendo0cl lspsntri eqsstrd
        wss ) NULUMRLUMUNZEAUMEROUOUPUNZFAUMFROUOUPUNZUQZKURGUSZUTZVAZPVGJWJUTZ
        MQUTZHVBVGZVCZVAZPVGZWMVAPVGWNVAPVGDVCZWIWLWQPWIWKWPABCWOEFGHIJKLMNOQRS
        TUAUBUCUDUEUFUGUHUIWOVDZVEVFVHWIHVIUMWMHVJVGZUMZWNXAUMZWRWSWEWIHLNRUCUF
        WFWGWHVKZVLWIWFJGUMZWJRNVMVGVGZUMZXBXDWIWFCAUMCROUOUPUNZWGXEXDWFWGXHWHA
        CLNORTUAUCUBVNVOWFWGWHVQACEGIJLNORTUAUCUDUGVPVRWFWGXGWHGXFLNRUCUDXFVDZV
        SVOWJGHXFJLNXARULUCUDXIUFXAVDZVTWAWIWFMGUMQXFUMZXCXDAEFGIMLNORTUAUCUDUI
        VPWFWGXKWHBGIXFLNQRSUCUDXIUEWBVOQGHXFMLNXARULUCUDXIUFXJVTWAWODPXAHWMWNX
        JWTUJUKWCVRWD $.
    $}
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h B $.  $d h H $.  $d h K $.  $d h P $.
    $d h Q $.  $d h R $.  $d h T $.  $d h W $.
    cdlemn5.b $e |- B = ( Base ` K ) $.
    cdlemn5.l $e |- .<_ = ( le ` K ) $.
    cdlemn5.j $e |- .\/ = ( join ` K ) $.
    cdlemn5.a $e |- A = ( Atoms ` K ) $.
    cdlemn5.h $e |- H = ( LHyp ` K ) $.
    cdlemn5.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    cdlemn5.s $e |- .(+) = ( LSSum ` U ) $.
    cdlemn5.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    cdlemn5.J $e |- J = ( ( DIsoC ` K ) ` W ) $.

    ${
      cdlemn5.p $e |- P = ( ( oc ` K ) ` W ) $.
      cdlemn5.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
      cdlemn5.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      cdlemn5.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      cdlemn5.n $e |- N = ( LSpan ` U ) $.
      cdlemn5.f $e |- F = ( iota_ h e. T ( h ` P ) = Q ) $.
      cdlemn5.g $e |- G = ( iota_ h e. T ( h ` P ) = R ) $.
      cdlemn5.m $e |- M = ( iota_ h e. T ( h ` Q ) = R ) $.
      $( Part of proof of Lemma N of [Crawley] p. 121 line 32.  (Contributed by
         NM, 25-Feb-2014.) $)
      cdlemn5pre $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ R .<_ ( Q .\/ X ) ) -> ( J ` R ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) ) $=
        ( chlt wcel wa wbr wn w3a co cfv cid cres cop csn simp1 simp22 diclspsn
        wceq syl2anc simp21 cdlemn4a syl3anc oveq1d sseqtr4d csubg clss dvhlmod
        clmod eqid lsssssubg diclss sseldd simp23 diblss ctrl cdlemn2a lsmless2
        wss syl sstrd eqsstrd ) QVAVBUBMVBVCZEAVBEUBRVDVEVCZFAVBFUBRVDVEVCZUCBV
        BUCUBRVDVCZVFZFEUCPVGRVDZVFZFOVHZLVIGVJZVKVLTVHZEOVHZUCNVHZDVGZXFWTXBXG
        XIVPWTXDXEVMZWTXAXBXCXEVNZACFGHILMOQRTUBUEUGUHUMUOULUIUQUSVOVQXFXIXJSUA
        VKVLTVHZDVGZXLXFXIKXHVKVLTVHZXODVGZXPXFWTXAXBXIXRWPXMWTXAXBXCXEVRZXNABC
        DEFGHIKLMSQRTUAUBUDUEUGUMUHUOUNUIURUSUTUQUJVSVTXFXJXQXODXFWTXAXJXQVPXMX
        SACEGHIKMOQRTUBUEUGUHUMUOULUIUQURVOVQWAWBXFXJHWCVHZVBXKXTVBXOXKWPXPXLWP
        XFHWDVHZXTXJXFHWFVBYAXTWPXFHMQUBUHUIXMWEYAHYAWGZWHWQZXFWTXAXJYAVBXMXSAE
        YAHMOQRUBUEUGUHUIULYBWIVQWJXFYAXTXKYCXFWTXCXKYAVBXMWTXAXBXCXEWKBYAHMNQR
        UBUCUDUEUHUIUKYBWLVQWJABEUBQWMVHVHZFGHIISMNPQRTUAUBUCUDUEUFUGUHUOYDWGUN
        UKUIUQUTWNDXJXOXKHUJWOVTWRWS $.
    $}

    $( Part of proof of Lemma N of [Crawley] p. 121 line 32.  (Contributed by
       NM, 25-Feb-2014.) $)
    cdlemn5 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ R .<_ ( Q .\/ X ) ) -> ( J ` R ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) ) $=
      ( vh coc cfv cltrn ctendo wceq crio clspn cid cres cmpt eqid cdlemn5pre
      cv ) ABMKUEUFUFZCDEMKUGUFUFZFUDMKUHUFUFZURUDUQZUFZDUIUDUSUJZVBEUIUDUSUJZG
      HIJKLDVAUFEUIUDUSUJZFUKUFZUDUSULBUMUNZMNOPQRSTUAUBUCURUOVGUOUSUOUTUOVFUOV
      CUOVDUOVEUOUP $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h B $.  $d h H $.  $d h t u K $.  $d h t u T $.
    $d t u E $.  $d h P $.  $d h Q $.  $d h t u W $.
    cdlemn8.b $e |- B = ( Base ` K ) $.
    cdlemn8.l $e |- .<_ = ( le ` K ) $.
    cdlemn8.a $e |- A = ( Atoms ` K ) $.
    cdlemn8.h $e |- H = ( LHyp ` K ) $.
    cdlemn8.p $e |- P = ( ( oc ` K ) ` W ) $.
    cdlemn8.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    cdlemn8.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn8.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    cdlemn8.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    cdlemn8.s $e |- .+ = ( +g ` U ) $.
    cdlemn8.f $e |- F = ( iota_ h e. T ( h ` P ) = Q ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 35.  (Contributed by
       NM, 26-Feb-2014.) $)
    cdlemn6 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T ) ) ->
     ( <. ( s ` F ) , s >. .+ <. g , O >. ) = <. ( ( s ` F ) o. g ) , s >. ) $=
      ( vt vu chlt wcel wa wbr wn cv w3a cfv cop co ccom csca cplusg wceq simp1
      simp3l lhpocnel2 syl simp2l ltrniotacl syl3anc tendocl tendo0cl dvhopvadd
      simp3r eqid syl122anc cmpt cmpt2 dvhfplusr oveqd tendo0plr syl2anc opeq2d
      eqtrd ) NULUMQMUMUNZEAUMEQOUOUPUNZFAUMFQOUOUPUNZUNZRUQZKUMZIUQZGUMZUNZURZ
      LWKUSZWKUTWMPUTDVAZWQWMVBZWKPHVCUSZVDUSZVAZUTZWSWKUTWPWGWQGUMZWLWNPKUMZWR
      XCVEWGWJWOVFZWPWGWLLGUMZXDXFWGWJWLWNVGZWPWGCAUMCQOUOUPUNZWHXGXFWPWGXIXFAC
      MNOQTUAUBUCVHVIWGWHWIWOVJACEGJLMNOQTUAUBUEUIVKVLWKGKLMNULQUBUEUFVMVLXHWGW
      JWLWNVPWPWGXEXFBGJKMNPQSUBUEUFUDVNVIWTDXAWKPGHKWQWMMNQUBUEUFUGWTVQZUHXAVQ
      ZVOVRWPXBWKWSWPXBWKPUJUKKKJGJUQZUJUQUSXLUKUQUSVBVSVTZVAZWKWPXAXMWKPWPWGXA
      XMVEXFUKXMXAGHJKWTMNULQUJUBUEUFUGXJXMVQZXKWAVIWBWPWGWLXNWKVEXFXHUKBXMWKGJ
      KMNPQUJSUBUEUFUDXOWCWDWFWEWF $.

    cdlemn8.g $e |- G = ( iota_ h e. T ( h ` P ) = R ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 36.  (Contributed by
       NM, 26-Feb-2014.) $)
    cdlemn7 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T
          /\ <. G , ( _I |` T ) >. = ( <. ( s ` F ) , s >. .+ <. g , O >. ) ) )
       -> ( G = ( ( s ` F ) o. g ) /\ ( _I |` T ) = s ) ) $=
      ( chlt wcel wa wbr wn cv cid cres cop cfv co wceq w3a simp33 simp1 simp2l
      ccom simp2r simp31 simp32 cdlemn6 syl122anc eqtrd fvex coex opth2 sylib
      vex ) OULUMRNUMUNZEAUMERPUOUPUNZFAUMFRPUOUPUNZUNZSUQZKUMZIUQZGUMZMURGUSZU
      TZLWDVAZWDUTWFQUTDVBZVCZVDZVDZWIWJWFVHZWDUTZVCMWOVCWHWDVCUNWNWIWKWPVTWCWE
      WGWLVEWNVTWAWBWEWGWKWPVCVTWCWMVFVTWAWBWMVGVTWAWBWMVIVTWCWEWGWLVJVTWCWEWGW
      LVKABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJVLVMVNMWHWOWDWJWFLWDVOIVSVPSVSV
      QVR $.

    $d h R $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 36.  (Contributed by
       NM, 26-Feb-2014.) $)
    cdlemn8 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T
          /\ <. G , ( _I |` T ) >. = ( <. ( s ` F ) , s >. .+ <. g , O >. ) ) )
       -> g = ( G o. `' F ) ) $=
      ( chlt wcel wa wbr wn cv cid cres cop cfv wceq ccnv ccom coass wf1o simp1
      w3a lhpocnel2 3ad2ant1 simp2l ltrniotacl syl3anc ltrn1o syl2anc f1ococnv1
      co syl coeq1d wf simp32 f1of fcoi2 eqtr2d cdlemn7 simpld simprd tendospid
      3syl fveq1d eqtr3d eqtrd coeq2d 3eqtr4a ltrncnv simp2r ltrncom ) OULUMRNU
      MUNZEAUMERPUOUPUNZFAUMFRPUOUPUNZUNZSUQZKUMZIUQZGUMZMURGUSZUTLXBVAZXBUTXDQ
      UTDVQVBZVHZVHZXDLVCZMVDZMXKVDZXJXKLVDZXDVDZXKLXDVDZVDXDXLXKLXDVEXJXOURBUS
      ZXDVDZXDXJXNXQXDXJBBLVFZXNXQVBXJWRLGUMZXSWRXAXIVGZXJWRCAUMCRPUOUPUNZWSXTY
      AWRXAYBXIACNOPRUAUBUCUDVIVJZWRWSWTXIVKACEGJLNOPRUAUBUCUFUJVLVMZBGLNOULRTU
      CUFVNVOBBLVPVRVSXJBBXDVFZBBXDVTXRXDVBXJWRXEYEYAWRXAXCXEXHWABGXDNOULRTUCUF
      VNVOBBXDWBBBXDWCWIWDXJMXPXKXJMXGXDVDZXPXJMYFVBZXFXBVBZABCDEFGHIJKLMNOPQRS
      TUAUBUCUDUEUFUGUHUIUJUKWEZWFXJXGLXDXJLXFVAZXGLXJLXFXBXJYGYHYIWGWJXJXTYJLV
      BYDGLWHVRWKVSWLWMWNXJWRXKGUMZMGUMZXLXMVBYAXJWRXTYKYAYDGLNORUCUFWOVOXJWRYB
      WTYLYAYCWRWSWTXIWPACFGJMNOPRUAUBUCUFUKVLVMGXKMNORUCUFWQVMWL $.

    $( Part of proof of Lemma N of [Crawley] p. 121 line 36.  (Contributed by
       NM, 27-Feb-2014.) $)
    cdlemn9 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T
          /\ <. G , ( _I |` T ) >. = ( <. ( s ` F ) , s >. .+ <. g , O >. ) ) )
       -> ( g ` Q ) = R ) $=
      ( chlt wcel wa wbr wn cv cid cres cop cfv co wceq w3a ccnv cdlemn8 fveq1d
      ccom wf simp1 lhpocnel2 3ad2ant1 simp2l ltrniotacl syl3anc ltrn1o syl2anc
      wf1o f1ocnv f1of 3syl simp2ll atbase syl fvco3 ltrniotacnvval ltrniotaval
      fveq2d simp2r eqtrd 3eqtrd ) OULUMRNUMUNZEAUMZERPUOUPZUNZFAUMFRPUOUPUNZUN
      ZSUQZKUMIUQZGUMMURGUSUTLWRVAWRUTWSQUTDVBVCVDZVDZEWSVAEMLVEZVHZVAZEXBVAZMV
      AZFXAEWSXCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKVFVGXABBXBVIZEBUMZXDX
      FVCXABBLVRZBBXBVRXGXAWLLGUMZXIWLWQWTVJZXAWLCAUMCRPUOUPUNZWOXJXKWLWQXLWTAC
      NOPRUAUBUCUDVKVLZWLWOWPWTVMZACEGJLNOPRUAUBUCUFUJVNVOBGLNOULRTUCUFVPVQBBLV
      SBBXBVTWAXAWMXHWMWNWPWLWTWBABEOTUBWCWDBBEMXBWEVQXAXFCMVAZFXAXECMXAWLXLWOX
      ECVCXKXMXNACEGJLNOPRUAUBUCUFUJWFVOWHXAWLXLWPXOFVCXKXMWLWOWPWTWIACFGJMNOPR
      UAUBUCUFUKWGVOWJWK $.
  $}

  ${
    cdlemn10.b $e |- B = ( Base ` K ) $.
    cdlemn10.l $e |- .<_ = ( le ` K ) $.
    cdlemn10.j $e |- .\/ = ( join ` K ) $.
    cdlemn10.a $e |- A = ( Atoms ` K ) $.
    cdlemn10.h $e |- H = ( LHyp ` K ) $.
    cdlemn10.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn10.r $e |- R = ( ( trL ` K ) ` W ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 36.  (Contributed by
       NM, 27-Feb-2014.) $)
    cdlemn10 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( S e. A /\ -. S .<_ W ) /\ ( X e. B /\ X .<_ W ) )
           /\ ( g e. T /\ ( g ` Q ) = S /\ ( R ` g ) .<_ X ) )
       -> S .<_ ( Q .\/ X ) ) $=
      ( chlt wcel wa wbr wn w3a cv cfv wceq co clat simp1l hllat simp22l atbase
      syl simp21l hlatjcl syl3anc simp23l latjcl hlatlej2 cmee lhpbase hlatlej1
      cp1 simp1r eqid atmod3i1 syl131anc simp21 lhpjat2 syl2anc oveq2d col hlol
      simp1 olm11 3eqtrrd simp31 trlval2 simp32 oveq1d eqtrd simp33 eqbrtrrd wi
      latmcl latjlej2 syl13anc mpd eqbrtrd lattrd ) JUAUBZLHUBZUCZCAUBZCLKUDUEZ
      UCZEAUBZELKUDUEZUCZMBUBZMLKUDZUCZUFZGUGZFUBZCXGUHZEUIZXGDUHZMKUDZUFZUFZBJ
      KECEIUJZCMIUJZNOXNWNJUKUBZWNWOXFXMULZJUMUPZXNWTEBUBWTXAWSXEWPXMUNZABEJNQU
      OUPXNWNWQWTXOBUBZXRWQWRXBXEWPXMUQZXTABIJCENPQURUSZXNXQCBUBZXCXPBUBXSXNWQY
      DYBABCJNQUOUPZXCXDWSXBWPXMUTZBIJCMNPVAUSXNWNWQWTEXOKUDXRYBXTACEIJKOPQVBUS
      XNXOCXOLJVCUHZUJZIUJZXPKXNYIXOCLIUJZYGUJZXOJVFUHZYGUJZXOXNWNWQYALBUBZCXOK
      UDZYIYKUIXRYBYCXNWOYNWNWOXFXMVGBHJLNRVDUPZXNWNWQWTYOXRYBXTACEIJKOPQVEUSAB
      CIJKYGXOLNOPYGVHZQVIVJXNYJYLXOYGXNWPWSYJYLUIWPXFXMVQZWPWSXBXEXMVKZACYLHIJ
      KLOPYLVHZQRVLVMVNXNJVOUBZYAYMXOUIXNWNUUAXRJVPUPYCBYLJYGXONYQYTVRVMVSXNYHM
      KUDZYIXPKUDZXNXKYHMKXNXKCXIIUJZLYGUJZYHXNWPXHWSXKUUEUIYRWPXFXHXJXLVTYSACD
      FXGHIJKYGLOPYQQRSTWAUSXNUUDXOLYGXNXIECIWPXFXHXJXLWBVNWCWDWPXFXHXJXLWEWFXN
      XQYHBUBZXCYDUUBUUCWGXSXNXQYAYNUUFXSYCYPBJYGXOLNYQWHUSYFYEBIJKYHMCNOPWIWJW
      KWLWM $.
  $}

  ${
    $d g s y z .+ $.  $d g s y z .\/ $.  $d g h s y z .<_ $.  $d g h s y z A $.
    $d g h s y z B $.  $d g s E $.  $d g F $.  $d g s y z G $.  $d g s y z I $.
    $d g s y z .(+) $.  $d g h s y z H $.  $d g h s y z K $.  $d g h s y z N $.
    $d g s y z J $.  $d h P $.  $d g h s y z Q $.  $d s R $.  $d g h s y z T $.
    $d g s O $.  $d y z U $.  $d g h s y z W $.  $d g s y z X $.
    cdlemn11a.b $e |- B = ( Base ` K ) $.
    cdlemn11a.l $e |- .<_ = ( le ` K ) $.
    cdlemn11a.j $e |- .\/ = ( join ` K ) $.
    cdlemn11a.a $e |- A = ( Atoms ` K ) $.
    cdlemn11a.h $e |- H = ( LHyp ` K ) $.
    cdlemn11a.p $e |- P = ( ( oc ` K ) ` W ) $.
    cdlemn11a.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    cdlemn11a.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    cdlemn11a.r $e |- R = ( ( trL ` K ) ` W ) $.
    cdlemn11a.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    cdlemn11a.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    cdlemn11a.J $e |- J = ( ( DIsoC ` K ) ` W ) $.
    cdlemn11a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    cdlemn11a.d $e |- .+ = ( +g ` U ) $.
    cdlemn11a.s $e |- .(+) = ( LSSum ` U ) $.
    cdlemn11a.f $e |- F = ( iota_ h e. T ( h ` P ) = Q ) $.
    cdlemn11a.g $e |- G = ( iota_ h e. T ( h ` P ) = N ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 37.  (Contributed by
       NM, 27-Feb-2014.) $)
    cdlemn11a $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ ( J ` N ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) )
       -> <. G , ( _I |` T ) >. e. ( J ` N ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wss cid cres cop wceq lhpocnel2 3ad2ant1
      simp1 simp22 ltrniotacl syl3anc tendospid syl eqcomd tendoidcl wb cv crio
      riotaex eqeltri cltrn fvex resiexg ax-mp dicopelval2 syl2anc mpbir2and
      cvv ) RVAVBUBNVBVCZFAVBFUBSVDVEVCZTAVBTUBSVDVEVCZUCBVBUCUBSVDVCZVFZTPVGZF
      PVGUCOVGEVHVIZVFZMVJHVKZVLXBVBZMMXEVGZVMZXEKVBZXDXGMXDMHVBZXGMVMXDWQCAVBC
      UBSVDVEVCZWSXJWQXAXCVPZWQXAXKXCACNRSUBUEUGUHUIVNVOWQWRWSWTXCVQZACTHJMNRSU
      BUEUGUHUKUTVRVSHMVTWAWBWQXAXIXCHKNRUBUHUKUMWCVOXDWQWSXFXHXIVCWDXLXMACTXEH
      JKMMNPRSVAUBUEUGUHUIUKUMUOUTMCJWEVGTVMZJHWFWPUTXNJHWGWHHWPVBXEWPVBHUBRWIV
      GZVGWPUKUBXOWJWHHWPWKWLWMWNWO $.

    $( Part of proof of Lemma N of [Crawley] p. 121 line 37.  (Contributed by
       NM, 27-Feb-2014.) $)
    cdlemn11b $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ ( J ` N ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) )
       -> <. G , ( _I |` T ) >. e. ( ( J ` Q ) .(+) ( I ` X ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wss cid cres cop simp3 cdlemn11a sseldd
      ) RVAVBUBNVBVCZFAVBFUBSVDVEVCTAVBTUBSVDVEVCUCBVBUCUBSVDVCVFZTPVGZFPVGUCOV
      GEVHZVIZVFVRVSMVJHVKVLVPVQVTVMABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKU
      LUMUNUOUPUQURUSUTVNVO $.

    $( Part of proof of Lemma N of [Crawley] p. 121 line 37.  (Contributed by
       NM, 27-Feb-2014.) $)
    cdlemn11c $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ ( J ` N ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) )
 -> E. y e. ( J ` Q ) E. z e. ( I ` X ) <. G , ( _I |` T ) >. = ( y .+ z ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wss cid cres cop cv wceq cdlemn11b csubg
      wrex wb clss clmod simp1 dvhlmod eqid lsssssubg syl simp21 diclss syl2anc
      sseldd simp23l simp23r diblss syl12anc lsmelval mpbid ) TVCVDUDPVDVEZHCVD
      HUDUAVFVGVEZUBCVDUBUDUAVFVGVEZUEDVDZUEUDUAVFZVEZVHZUBRVIHRVIZUEQVIZGVJZVK
      ZVHZOVLJVMVNZXGVDZXJAVOBVOFVJVPBXFVSAXEVSZCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFU
      GUHUIUJUKULUMUNUOUPUQURUSUTVAVBVQXIXEKVRVIZVDXFXMVDXKXLVTXIKWAVIZXMXEXIKW
      BVDXNXMVKXIKPTUDUJURWRXDXHWCZWDXNKXNWEZWFWGZXIWRWSXEXNVDXOWRWSWTXCXHWHCHX
      NKPRTUAUDUGUIUJURUQXPWIWJWKXIXNXMXFXQXIWRXAXBXFXNVDXOXAXBWSWTWRXHWLXAXBWS
      WTWRXHWMDXNKPQTUAUDUEUFUGUJURUPXPWNWOWKABFGXEXFKXJUSUTWPWJWQ $.

    $( Part of proof of Lemma N of [Crawley] p. 121 line 37.  TODO: combine
       ~ cdlemn11a , ~ cdlemn11b , ~ cdlemn11c , cdlemn11pre into one?
       (Contributed by NM, 27-Feb-2014.) $)
    cdlemn11pre $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( Q e. A /\ -. Q .<_ W )
          /\ ( N e. A /\ -. N .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ ( J ` N ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) ) -> N .<_ ( Q .\/ X ) ) $=
      ( vy vz vs vg chlt wcel wa wbr wn w3a cfv wss cid cres cop wceq cdlemn11c
      co cv wrex wi wb simp21 dicelval3 syl2anc simp23 dibelval3 anbi12d reeanv
      simpl1 simpl21 simpl22 simpl23 simpr1r simpr1l cdlemn9 syl123anc cdlemn10
      simp1 simpr3 simpr2 3exp2 oveq12 eqeq2d imbi1d imbi2d biimprd com23 com12
      syl133anc impr syl6 rexlimdvv syl5bir sylbid mpd ) RVEVFUBNVFVGZFAVFFUBSV
      HVIVGZTAVFTUBSVHVIVGZUCBVFUCUBSVHVGZVJZTPVKFPVKZUCOVKZEVRVLZVJZMVMHVNVOZV
      AVSZVBVSZDVRZVPZVBYCVTVAYBVTTFUCQVRSVHZVAVBABCDEFGHIJKLMNOPQRSTUAUBUCUDUE
      UFUGUHUIUJUKULUMUNUOUPUQURUSUTVQYEYJYKVAVBYBYCYEYGYBVFZYHYCVFZVGYGLVCVSZV
      KYNVOZVPZVCKVTZYHVDVSZUAVOZVPZYRGVKUCSVHZVGZVDHVTZVGZYJYKWAZYEYLYQYMUUCYE
      XQXRYLYQWBXQYAYDWSZXQXRXSXTYDWCACFHJKLNPRSVEUBYGVCUEUGUHUIUKUMUOUSWDWEYEX
      QXTYMUUCWBUUFXQXRXSXTYDWFBGHVDJNORSVEUBUCYHUAUDUEUHUKULUJUNWGWEWHUUDYPUUB
      VGZVDHVTVCKVTYEUUEYPUUBVCVDKHWIYEUUGUUEVCVDKHYEYNKVFZYRHVFZVGZUUAYFYOYSDV
      RZVPZYKWAZWAZUUGUUEWAYEUUJUUAUULYKYEUUJUUAUULVJZVGZXQXRXSXTUUIFYRVKTVPZUU
      AYKXQYAYDUUOWJZXRXSXTXQYDUUOWKZXRXSXTXQYDUUOWLZXRXSXTXQYDUUOWMUUHUUIUUAUU
      LYEWNZUUPXQXRXSUUHUUIUULUUQUURUUSUUTUUHUUIUUAUULYEWOUVAYEUUJUUAUULWTABCDF
      THIVDJKLMNRSUAUBVCUDUEUGUHUIUJUKUMUPUQUSUTWPWQYEUUJUUAUULXAABFGTHVDNQRSUB
      UCUDUEUFUGUHUKULWRXJXBUUGUUNUUEYPYTUUAUUNUUEWAYPYTVGZUUNUUAUUEUVBUUAUUEWA
      UUNUVBUUEUUMUUAUVBYJUULYKUVBYIUUKYFYGYOYHYSDXCXDXEXFXGXHXKXIXLXMXNXOXMXP
      $.
  $}

  ${
    $d h B $.  $d h .<_ $.  $d h A $.  $d h H $.  $d h K $.  $d h Q $.
    $d h R $.  $d h W $.
    cdlemn11.b $e |- B = ( Base ` K ) $.
    cdlemn11.l $e |- .<_ = ( le ` K ) $.
    cdlemn11.j $e |- .\/ = ( join ` K ) $.
    cdlemn11.a $e |- A = ( Atoms ` K ) $.
    cdlemn11.h $e |- H = ( LHyp ` K ) $.
    cdlemn11.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    cdlemn11.J $e |- J = ( ( DIsoC ` K ) ` W ) $.
    cdlemn11.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    cdlemn11.s $e |- .(+) = ( LSSum ` U ) $.
    $( Part of proof of Lemma N of [Crawley] p. 121 line 37.  (Contributed by
       NM, 27-Feb-2014.) $)
    cdlemn11 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) /\ ( X e. B /\ X .<_ W ) )
    /\ ( J ` R ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) ) -> R .<_ ( Q .\/ X ) ) $=
      ( vh coc cfv cplusg ctrl cltrn ctendo wceq crio cid cres cmpt cdlemn11pre
      cv eqid ) ABMKUEUFUFZFUGUFZCDMKUHUFUFZMKUIUFUFZFUDMKUJUFUFZUSUDUQUFZDUKUD
      VBULZVDEUKUDVBULZGHIJKLEUDVBUMBUNUOZMNOPQRSUSURVGURVBURVAURVCURTUAUBUTURU
      CVEURVFURUP $.

    $( Lemma N of [Crawley] p. 121 line 27.  (Contributed by NM,
       27-Feb-2014.) $)
    cdlemn $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) /\ ( X e. B /\ X .<_ W ) ) )
 -> ( R .<_ ( Q .\/ X ) <-> ( J ` R ) C_ ( ( J ` Q ) .(+) ( I ` X ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a co cfv wss cdlemn5 3expia cdlemn11 impbid ) KUD
      UEMGUEUFZDAUEDMLUGUHUFEAUEEMLUGUHUFNBUENMLUGUFUIZUFEDNJUJLUGZEIUKDIUKNHUK
      CUJULZUQURUSUTABCDEFGHIJKLMNOPQRSUBUCTUAUMUNUQURUTUSABCDEFGHIJKLMNOPQRSTU
      AUBUCUOUNUP $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h B $.  $d h H $.  $d h K $.  $d h P $.
    $d h R $.  $d h T $.  $d h W $.
    dihordlem8.b $e |- B = ( Base ` K ) $.
    dihordlem8.l $e |- .<_ = ( le ` K ) $.
    dihordlem8.a $e |- A = ( Atoms ` K ) $.
    dihordlem8.h $e |- H = ( LHyp ` K ) $.
    dihordlem8.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihordlem8.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dihordlem8.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihordlem8.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihordlem8.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihordlem8.s $e |- .+ = ( +g ` U ) $.
    dihordlem8.g $e |- G = ( iota_ h e. T ( h ` P ) = R ) $.
    $( Part of proof of Lemma N of [Crawley] p. 122 line 35.  (Contributed by
       NM, 3-Mar-2014.) $)
    dihordlem6 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T ) )
  -> ( <. ( s ` G ) , s >. .+ <. g , O >. ) = <. ( ( s ` G ) o. g ) , s >. ) $=
      ( chlt wcel wa wbr wn cv w3a cfv co ccom wceq simp1 simp2r simp2l cdlemn6
      cop simp3 syl121anc ) NUJUKQMUKULZEAUKEQOUMUNULZFAUKFQOUMUNULZULZRUOZKUKI
      UOZGUKULZUPVHVJVIVNLVLUQZVLVEVMPVEDURVOVMUSVLVEUTVHVKVNVAVHVIVJVNVBVHVIVJ
      VNVCVHVKVNVFABCDFEGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIVDVG $.

    $( Part of proof of Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihordlem7 $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T
           /\ <. f , O >. = ( <. ( s ` G ) , s >. .+ <. g , O >. ) ) )
       -> ( f = ( ( s ` G ) o. g ) /\ O = s ) ) $=
      ( chlt wcel wa wbr wn cv cop cfv wceq w3a ccom simp33 simp1 simp2l simp2r
      co simp31 simp32 dihordlem6 syl122anc eqtrd fvex vex coex opth2 sylib ) O
      UKULRNULUMZEAULERPUNUOUMZFAULFRPUNUOUMZUMZSUPZLULZJUPZGULZIUPZQUQZMWAURZW
      AUQWCQUQDVFZUSZUTZUTZWFWGWCVAZWAUQZUSWEWLUSQWAUSUMWKWFWHWMVQVTWBWDWIVBWKV
      QVRVSWBWDWHWMUSVQVTWJVCVQVRVSWJVDVQVRVSWJVEVQVTWBWDWIVGVQVTWBWDWIVHABCDEF
      GHJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVIVJVKWEQWLWAWGWCMWAVLJVMVNSVMVOVP $.

    $( Part of proof of Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihordlem7b $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( s e. E /\ g e. T
           /\ <. f , O >. = ( <. ( s ` G ) , s >. .+ <. g , O >. ) ) )
       -> ( f = g /\ O = s ) ) $=
      ( chlt wcel wa wbr wn cv cop cfv co wceq w3a weq ccom cid cres dihordlem7
      simpld simprd fveq1d lhpocnel2 3ad2ant1 simp2r ltrniotacl syl3anc tendo02
      simp1 syl eqtr3d coeq1d wf1o simp32 ltrn1o syl2anc f1of fcoi2 3syl 3eqtrd
      wf jca ) OUKULRNULUMZEAULERPUNUOUMZFAULFRPUNUOUMZUMZSUPZLULZJUPZGULZIUPZQ
      UQMWNURZWNUQWPQUQDUSUTZVAZVAZIJVBQWNUTZXBWRWSWPVCZVDBVEZWPVCZWPXBWRXDUTZX
      CABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJVFZVGXBWSXEWPXBMQURZWSXEXBMQWNXB
      XGXCXHVHZVIXBMGULZXIXEUTXBWJCAULCRPUNUOUMZWLXKWJWMXAVPZWJWMXLXAACNOPRUAUB
      UCUDVJVKWJWKWLXAVLACFGKMNOPRUAUBUCUFUJVMVNBGKMOQUETVOVQVRVSXBBBWPVTZBBWPW
      HXFWPUTXBWJWQXNXMWJWMWOWQWTWABGWPNOUKRTUCUFWBWCBBWPWDBBWPWEWFWGXJWI $.
  $}

  ${
    dihjust.b $e |- B = ( Base ` K ) $.
    dihjust.l $e |- .<_ = ( le ` K ) $.
    dihjust.j $e |- .\/ = ( join ` K ) $.
    dihjust.m $e |- ./\ = ( meet ` K ) $.
    dihjust.a $e |- A = ( Atoms ` K ) $.
    dihjust.h $e |- H = ( LHyp ` K ) $.
    dihjust.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    dihjust.J $e |- J = ( ( DIsoC ` K ) ` W ) $.
    dihjust.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjust.s $e |- .(+) = ( LSSum ` U ) $.
    $( Part of proof after Lemma N of [Crawley] p. 122 line 4, "the definition
       of phi(x) is independent of the atom q."  (Contributed by NM,
       2-Mar-2014.) $)
    dihjustlem $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) /\ X e. B )
    /\ ( Q .\/ ( X ./\ W ) ) = ( R .\/ ( X ./\ W ) ) )
    -> ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
             C_ ( ( J ` R ) .(+) ( I ` ( X ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq cfv wss simp1l hllat syl simp21l atbase
      clat simp23 simp1r lhpbase latmcl syl3anc latlej1 simp3 breqtrd wb simp22
      simp1 simp21 latmle2 jca cdlemn syl13anc mpbid csubg clss clmod lsssssubg
      dvhlmod eqid diclss syl2anc sseldd diblss syl12anc lsmub2 lsmlub mpbi2and
      lsmcl ) KUFUGZNGUGZUHZDAUGZDNLUIUJZUHZEAUGENLUIUJUHZOBUGZUKZDONMULZJULZEX
      CJULZUMZUKZDIUNZEIUNZXCHUNZCULZUOZXJXKUOZXHXJCULXKUOZXGDXELUIZXLXGDXDXELX
      GKVAUGZDBUGZXCBUGZDXDLUIXGWNXPWNWOXBXFUPKUQURZXGWQXQWQWRWTXAWPXFUSABDKPTU
      TURXGXPXANBUGZXRXSWPWSWTXAXFVBZXGWOXTWNWOXBXFVCBGKNPUAVDURZBKMONPSVEVFZBJ
      KLDXCPQRVGVFWPXBXFVHVIXGWPWTWSXRXCNLUIZUHXOXLVJWPXBXFVLZWPWSWTXAXFVKZWPWS
      WTXAXFVMZXGXRYDYCXGXPXAXTYDXSYAYBBKLMONPQSVNVFZVOABCEDFGHIJKLNXCPQRTUAUBU
      CUDUEVPVQVRXGXIFVSUNZUGXJYIUGZXMXGFVTUNZYIXIXGFWAUGZYKYIUOXGFGKNUAUDYEWCZ
      YKFYKWDZWBURZXGWPWTXIYKUGZYEYFAEYKFGIKLNQTUAUDUCYNWEWFZWGXGYKYIXJYOXGWPXR
      YDXJYKUGZYEYCYHBYKFGHKLNXCPQUAUDUBYNWHWIZWGZCXIXJFUEWJWFXGXHYIUGYJXKYIUGX
      LXMUHXNVJXGYKYIXHYOXGWPWSXHYKUGYEYGADYKFGIKLNQTUAUDUCYNWEWFWGYTXGYKYIXKYO
      XGYLYPYRXKYKUGYMYQYSCYKXIXJFYNUEWMVFWGCXHXJXKFUEWKVFWL $.

    $( Part of proof after Lemma N of [Crawley] p. 122 line 4, "the definition
       of phi(x) is independent of the atom q."  (Contributed by NM,
       2-Mar-2014.) $)
    dihjust $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) /\ X e. B )
    /\ ( Q .\/ ( X ./\ W ) ) = ( R .\/ ( X ./\ W ) ) )
  -> ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        = ( ( J ` R ) .(+) ( I ` ( X ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq cfv dihjustlem wss simp22 simp21 simp23
      simp1 simp3 eqcomd syl131anc eqssd ) KUFUGNGUGUHZDAUGDNLUIUJUHZEAUGENLUIU
      JUHZOBUGZUKZDONMULZJULZEVJJULZUMZUKZDIUNVJHUNZCULZEIUNVOCULZABCDEFGHIJKLM
      NOPQRSTUAUBUCUDUEUOVNVEVGVFVHVLVKUMVQVPUPVEVIVMUTVEVFVGVHVMUQVEVFVGVHVMUR
      VEVFVGVHVMUSVNVKVLVEVIVMVAVBABCEDFGHIJKLMNOPQRSTUAUBUCUDUEUOVCVD $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Forward ordering
       property.  TODO: change ` ( Q .\/ ( X ./\ W ) ) = X ` to ` Q .<_ X `
       using ~ lhpmcvr3 , here and all theorems below.  (Contributed by NM,
       2-Mar-2014.) $)
    dihord1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( Q .\/ ( X ./\ W ) ) = X
      /\ ( R .\/ ( Y ./\ W ) ) = Y /\ X .<_ Y ) )
  -> ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        C_ ( ( J ` R ) .(+) ( I ` ( Y ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq cfv wss simp11 simp13 simp12 clat hllat
      simp11l syl simp2r simp11r lhpbase latmcl syl3anc latmle2 simp12l latlej1
      atbase simp2l latjcl simp31 simp33 eqbrtrd lattrd simp32 breqtrrd cdlemn5
      jca syl131anc wi latmlem1 syl13anc mpd dibord syl122anc mpbird csubg clss
      clmod dvhlmod eqid lsssssubg diclss syl2anc sseldd diblss syl12anc lsmub2
      wb sstrd lsmcl lsmlub mpbi2and ) KUGUHZNGUHZUIZDAUHZDNLUJUKZUIZEAUHENLUJU
      KUIZULZOBUHZPBUHZUIZDONMUMZJUMZOUNZEPNMUMZJUMZPUNZOPLUJZULZULZDIUOZEIUOZY
      BHUOZCUMZUPZXSHUOZYKUPZYHYMCUMYKUPZYGXJXNXMYBBUHZYBNLUJZUIDYCLUJYLXJXMXNX
      RYFUQZXJXMXNXRYFURZXJXMXNXRYFUSZYGYPYQYGKUTUHZXQNBUHZYPYGXHUUAXHXIXMXNXRY
      FVBKVAVCZXOXPXQYFVDZYGXIUUBXHXIXMXNXRYFVEBGKNQUBVFVCZBKMPNQTVGVHZYGUUAXQU
      UBYQUUCUUDUUEBKLMPNQRTVIVHZWBYGDPYCLYGBKLDXTPQRUUCYGXKDBUHZXKXLXJXNXRYFVJ
      ABDKQUAVLVCZYGUUAUUHXSBUHZXTBUHUUCUUIYGUUAXPUUBUUJUUCXOXPXQYFVMZUUEBKMONQ
      TVGVHZBJKDXSQSVNVHUUDYGUUAUUHUUJDXTLUJUUCUUIUULBJKLDXSQRSVKVHYGXTOPLXOXRY
      AYDYEVOXOXRYAYDYEVPZVQVRXOXRYAYDYEVSVTABCEDFGHIJKLNYBQRSUAUBUEUFUCUDWAWCY
      GYMYJYKYGYMYJUPZXSYBLUJZYGYEUUOUUMYGUUAXPXQUUBYEUUOWDUUCUUKUUDUUEBKLMOPNQ
      RTWEWFWGYGXJUUJXSNLUJZYPYQUUNUUOXCYRUULYGUUAXPUUBUUPUUCUUKUUEBKLMONQRTVIV
      HZUUFUUGBGHKLNXSYBQRUBUCWHWIWJYGYIFWKUOZUHYJUURUHYJYKUPYGFWLUOZUURYIYGFWM
      UHZUUSUURUPYGFGKNUBUEYRWNZUUSFUUSWOZWPVCZYGXJXNYIUUSUHZYRYSAEUUSFGIKLNRUA
      UBUEUDUVBWQWRZWSYGUUSUURYJUVCYGXJYPYQYJUUSUHZYRUUFUUGBUUSFGHKLNYBQRUBUEUC
      UVBWTXAZWSCYIYJFUFXBWRXDYGYHUURUHYMUURUHYKUURUHYLYNUIYOXCYGUUSUURYHUVCYGX
      JXMYHUUSUHYRYTADUUSFGIKLNRUAUBUEUDUVBWQWRWSYGUUSUURYMUVCYGXJUUJUUPYMUUSUH
      YRUULUUQBUUSFGHKLNXSQRUBUEUCUVBWTXAWSYGUUSUURYKUVCYGUUTUVDUVFYKUUSUHUVAUV
      EUVGCUUSYIYJFUVBUFXEVHWSCYHYMYKFUFXFVHXG $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihord2a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( Q .\/ ( X ./\ W ) ) = X /\ ( R .\/ ( Y ./\ W ) ) = Y /\
          ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        C_ ( ( J ` R ) .(+) ( I ` ( Y ./\ W ) ) ) ) )
       -> Q .<_ ( R .\/ ( Y ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq cfv wss csubg clss clmod simp11 dvhlmod
      eqid lsssssubg syl simp12 diclss syl2anc sseldd clat simp11l hllat simp2l
      simp11r lhpbase latmcl syl3anc diblss syl12anc lsmub1 simp33 sstrd simp13
      latmle2 wb simp2r jca cdlemn syl13anc mpbird ) KUGUHZNGUHZUIZDAUHDNLUJUKU
      IZEAUHENLUJUKUIZULZOBUHZPBUHZUIZDONMUMZJUMOUNZEPNMUMZJUMZPUNZDIUOZWSHUOZC
      UMZEIUOXAHUOCUMZUPZULZULZDXBLUJZXDXGUPZXJXDXFXGXJXDFUQUOZUHXEXMUHXDXFUPXJ
      FURUOZXMXDXJFUSUHXNXMUPXJFGKNUBUEWLWMWNWRXIUTZVAXNFXNVBZVCVDZXJWLWMXDXNUH
      XOWLWMWNWRXIVEZADXNFGIKLNRUAUBUEUDXPVFVGVHXJXNXMXEXQXJWLWSBUHZWSNLUJZXEXN
      UHXOXJKVIUHZWPNBUHZXSXJWJYAWJWKWMWNWRXIVJKVKVDZWOWPWQXIVLZXJWKYBWJWKWMWNW
      RXIVMBGKNQUBVNVDZBKMONQTVOVPXJYAWPYBXTYCYDYEBKLMONQRTWCVPBXNFGHKLNWSQRUBU
      EUCXPVQVRVHCXDXEFUFVSVGWOWRWTXCXHVTWAXJWLWNWMXABUHZXANLUJZUIXKXLWDXOWLWMW
      NWRXIWBXRXJYFYGXJYAWQYBYFYCWOWPWQXIWEZYEBKMPNQTVOVPXJYAWQYBYGYCYHYEBKLMPN
      QRTWCVPWFABCEDFGHIJKLNXAQRSUAUBUCUDUEUFWGWHWI $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihord2b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        C_ ( ( J ` R ) .(+) ( I ` ( Y ./\ W ) ) ) )
       -> ( I ` ( X ./\ W ) ) C_ ( ( J ` R ) .(+) ( I ` ( Y ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wss csubg clss clmod simp11 dvhlmod eqid
      lsssssubg simp12 diclss syl2anc sseldd clat simp11l hllat simp11r lhpbase
      syl simp2l latmcl syl3anc latmle2 diblss syl12anc lsmub2 simp3 sstrd ) KU
      GUHZNGUHZUIZDAUHDNLUJUKUIZEAUHENLUJUKUIZULZOBUHZPBUHZUIZDIUMZONMUNZHUMZCU
      NZEIUMPNMUNHUMCUNZUOZULZWMWNWOWQWKFUPUMZUHWMWRUHWMWNUOWQFUQUMZWRWKWQFURUH
      WSWRUOWQFGKNUBUEWDWEWFWJWPUSZUTWSFWSVAZVBVLZWQWDWEWKWSUHWTWDWEWFWJWPVCADW
      SFGIKLNRUAUBUEUDXAVDVEVFWQWSWRWMXBWQWDWLBUHZWLNLUJZWMWSUHWTWQKVGUHZWHNBUH
      ZXCWQWBXEWBWCWEWFWJWPVHKVIVLZWGWHWIWPVMZWQWCXFWBWCWEWFWJWPVJBGKNQUBVKVLZB
      KMONQTVNVOWQXEWHXFXDXGXHXIBKLMONQRTVPVOBWSFGHKLNWLQRUBUEUCXAVQVRVFCWKWMFU
      FVSVEWGWJWPVTWA $.

    $d f g s y z .\/ $.  $d f g s y z ./\ $.  $d f g s y z .(+) $.  $d g s E $.
    $d g s y z .+ $.  $d f g h s y z A $.  $d f g s y z I $.  $d f g s y z J $.
    $d g G $.  $d g s y z O $.  $d h P $.  $d f g s y z Q $.  $d f g s y z R $.
    $d f g h s y z B $.  $d f g h s y z H $.  $d f g h s y z K $.  $d y z U $.
    $d f g h s y z .<_ $.  $d f g h s y z N $.  $d f g h s y z T $.
    $d f g h s y z W $.  $d f g s y z X $.  $d f g s y z Y $.
    dihord2c.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihord2c.r $e |- R = ( ( trL ` K ) ` W ) $.
    dihord2c.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  TODO: needed? shorten other proof with it?  (Contributed by
       NM, 3-Mar-2014.)  (New usage is discouraged.) $)
    dihord2cN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B
    /\ ( f e. T /\ ( R ` f ) .<_ ( X ./\ W ) ) )
       -> <. f , O >. e. ( I ` ( X ./\ W ) ) ) $=
      ( chlt wcel wa cv cfv co wbr w3a cop wceq simp3 eqidd wb simp1 clat hllat
      simp1l syl simp2 simp1r lhpbase latmcl syl3anc latmle2 syl12anc mpbir2and
      dibopelval3 ) MULUMZQIUMZUNZRBUMZGUOZEUMWCDUPRQOUQZNURUNZUSZWCPUTWDJUPUMZ
      WEPPVAZWAWBWEVBWFPVCWFWAWDBUMZWDQNURZWGWEWHUNVDWAWBWEVEWFMVFUMZWBQBUMZWIW
      FVSWKVSVTWBWEVHMVGVIZWAWBWEVJZWFVTWLVSVTWBWEVKBIMQSUDVLVIZBMORQSUBVMVNWFW
      KWBWLWJWMWNWOBMNORQSTUBVOVNBDPEHWCIJMNULQWDPSTUDUIUJUKUEVRVPVQ $.

    $( Part of proof after Lemma N of [Crawley] p. 122.   Reverse ordering
       property. TODO: needed? shorten other proof with it? $)
$(
    dihord2d $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B
      /\ ( I ` ( X ./\ W ) ) C_ ( ( J ` R ) .(+) ( I ` ( Y ./\ W ) ) ) )
    /\ ( f e. T /\ ( R ` f ) .<_ ( X ./\ W ) ) )
       -> <. f , O >. e. ( I ` ( Y ./\ W ) ) ) $=
      ( chlt wcel wa co cfv wss w3a cv wbr cop wceq wb simp1 cid cres cvv cltrn
      cmpt fvex eqeltri mptex dibopelval3 syl12anc mpbird ) MUMUNQIUNUOZRBUNSBU
      NRQOUPZJUQCKUQSQOUPZJUQZDUPURUSZGUTZEUNZWBCUQZVRNVAUOZUSZWBPVBVTUNZWCWDVS
      NVAUOPPVCUOZ?WFVQVSBUNVSQNVAWGWHVDVQWAWEVE??BCPEHWBIJMNPUMQVSTUAUEUJUKULU
      FPHEVFBVGZVJVHULHEWIEQMVIUQZUQVHUJQWJVKVLVMVLVNVOVP $.
      @( [3-Mar-2014] @)
$)

    dihord2.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihord2.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihord2.d $e |- .+ = ( +g ` U ) $.
    dihord2.g $e |- G = ( iota_ h e. T ( h ` P ) = N ) $.
    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihord11b $p |- ( ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\
-. Q .<_ W ) /\ ( N e. A /\ -. N .<_ W ) ) /\ ( X e. B /\ Y
 e. B ) /\
 ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) ) C_ ( ( J ` N ) .(+) ( I ` ( Y ./\ W ) )
 ) ) /\ ( f e. T /\ ( R ` f ) .<_ ( X ./\ W ) ) ) -> <. f , O >. e. ( ( J ` N
                                  ) .(+) ( I ` ( Y ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wss cop dihord2b adantr wceq simpr eqidd
      cv simpl11 clat simp11l hllat syl simpl2l simp11r lhpbase syl3anc latmle2
      wb latmcl dibopelval3 syl12anc mpbir2and sseldd ) RVCVDZUCNVDZVEZFAVDFUCS
      VFVGVEZUAAVDUAUCSVFVGVEZVHZUDBVDZUEBVDZVEZFPVIUDUCTVJZOVIZEVJUAPVIUEUCTVJ
      OVIEVJZVKZVHZJVRZHVDXIGVIXDSVFVEZVEZXEXFXIUBVLZXHXEXFVKXJABEFUAINOPQRSTUC
      UDUEUFUGUHUIUJUKULUMUNUOVMVNXKXLXEVDZXJUBUBVOZXHXJVPXKUBVQXKWQXDBVDZXDUCS
      VFZXMXJXNVEWIWQWRWSXCXGXJVSXKRVTVDZXAUCBVDZXOXKWOXQXHWOXJWOWPWRWSXCXGWAVN
      RWBWCZXAXBWTXGXJWDZXKWPXRXHWPXJWOWPWRWSXCXGWEVNBNRUCUFUKWFWCZBRTUDUCUFUIW
      JWGXKXQXAXRXPXSXTYABRSTUDUCUFUGUIWHWGBGUBHKXINORSVCUCXDUBUFUGUKUPUQURULWK
      WLWMWN $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihord10 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) )
     /\ ( f e. T /\ ( R ` f ) .<_ ( X ./\ W ) )
     /\ ( ( s e. E /\ g e. T ) /\ ( R ` g ) .<_ ( Y ./\ W ) /\ <. f , O >.
       = ( <. ( s ` G ) , s >. .+ <. g , O >. ) ) )
  -> ( R ` f ) .<_ ( Y ./\ W ) ) $=
      ( chlt wcel wa wbr wn w3a cv cfv co cop wceq simp11 simp12 simp13 simp31l
      weq simp31r simp33 dihordlem7b simpld syl123anc fveq2d simp32 eqbrtrd ) S
      VEVFUDOVFVGZFAVFFUDTVHVIVGZUBAVFUBUDTVHVIVGZVJZJVKZHVFWMGVLZUEUDUAVMTVHVG
      ZUGVKZMVFZKVKZHVFZVGZWRGVLZUFUDUAVMZTVHZWMUCVNNWPVLWPVNWRUCVNDVMVOZVJZVJZ
      WNXAXBTXFWMWRGXFWIWJWKWQWSXDJKVTZWIWJWKWOXEVPWIWJWKWOXEVQWIWJWKWOXEVRWQWS
      XCXDWLWOVSWQWSXCXDWLWOWAWLWOWTXCXDWBWIWJWKVGWQWSXDVJVJXGUCWPVOABCDFUBHIJK
      LMNOSTUCUDUGUHUIULUMVAUTURVBUPVCVDWCWDWEWFWLWOWTXCXDWGWH $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihord11c $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
    /\ ( N e. A /\ -. N .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
  C_ ( ( J ` N ) .(+) ( I ` ( Y ./\ W ) ) ) /\ f e. T
    /\ ( R ` f ) .<_ ( X ./\ W ) ) ) -> E. y e. ( J ` N )
                E. z e. ( I ` ( Y ./\ W ) ) <. f , O >. = ( y .+ z ) ) $=
      ( chlt wcel wa wbr wn w3a cfv co wss cv cop wceq wrex simp1 simp31 simp32
      simp2 simp33 dihord11b syl32anc csubg clss clmod simp11 dvhlmod lsssssubg
      eqid syl simp13 diclss syl2anc sseldd clat simp11l simp2r simp11r lhpbase
      wb hllat latmcl syl3anc latmle2 diblss syl12anc lsmelval mpbid ) TVEVFZUE
      PVFZVGZHCVFHUEUAVHVIVGZUCCVFUCUEUAVHVIVGZVJZUFDVFZUGDVFZVGZHRVKUFUEUBVLZQ
      VKGVLUCRVKZUGUEUBVLZQVKZGVLZVMZLVNZJVFZYFIVKXTUAVHZVJZVJZYFUDVOZYDVFZYKAV
      NBVNFVLVPBYCVQAYAVQZYJXPXSYEYGYHYLXPXSYIVRXPXSYIWAXPXSYEYGYHVSXPXSYEYGYHV
      TXPXSYEYGYHWBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVA
      VBVCVDWCWDYJYAKWEVKZVFYCYNVFYLYMXBYJKWFVKZYNYAYJKWGVFYOYNVMYJKPTUEUMUPXMX
      NXOXSYIWHZWIYOKYOWKZWJWLZYJXMXOYAYOVFYPXMXNXOXSYIWMCUCYOKPRTUAUEUIULUMUPU
      OYQWNWOWPYJYOYNYCYRYJXMYBDVFZYBUEUAVHZYCYOVFYPYJTWQVFZXRUEDVFZYSYJXKUUAXK
      XLXNXOXSYIWRTXCWLZXPXQXRYIWSZYJXLUUBXKXLXNXOXSYIWTDPTUEUHUMXAWLZDTUBUGUEU
      HUKXDXEYJUUAXRUUBYTUUCUUDUUEDTUAUBUGUEUHUIUKXFXEDYOKPQTUAUEYBUHUIUMUPUNYQ
      XGXHWPABFGYAYCKYKVCUQXIWOXJ $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 3-Mar-2014.) $)
    dihord2pre $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        C_ ( ( J ` N ) .(+) ( I ` ( Y ./\ W ) ) ) )
       -> ( X ./\ W ) .<_ ( Y ./\ W ) ) $=
      ( vf vy vz vs vg chlt wcel wa wbr wn w3a cfv co wss cv wral cop wceq wrex
      simpl1 simpl2l simpl2r simpl3 simprl simprr dihord11c syl123anc dicelval3
      wi wb simpl11 simpl13 syl2anc simp11l adantr hllat simp11r lhpbase latmcl
      clat syl syl3anc latmle2 dibelval3 syl12anc anbi12d reeanv simpll1 simplr
      simpr dihord10 3exp2 oveq12 eqeq2d imbi1d imbi2d biimprd com23 impr com12
      syl6 rexlimdvv syl5bir sylbid mpd ralrimiv simp11 simp2l simp2r syl122anc
      exp32 trlord mpbird ) QVGVHZUBMVHZVIZFAVHFUBRVJVKVIZTAVHTUBRVJVKVIZVLZUCB
      VHZUDBVHZVIZFOVMUCUBSVNZNVMEVNTOVMZUDUBSVNZNVMZEVNVOZVLZUUDUUFRVJZVBVPZGV
      MZUUDRVJZUULUUFRVJZWJZVBHVQZUUIUUOVBHUUIUUKHVHZUUMUUNUUIUUQUUMVIZVIZUUKUA
      VRZVCVPZVDVPZDVNZVSZVDUUGVTVCUUEVTZUUNUUSYTUUAUUBUUHUUQUUMUVEYTUUCUUHUURW
      AUUAUUBYTUUHUURWBUUAUUBYTUUHUURWCZYTUUCUUHUURWDUUIUUQUUMWEUUIUUQUUMWFVCVD
      ABCDEFGHIVBJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAWGWHUUSUV
      DUUNVCVDUUEUUGUUSUVAUUEVHZUVBUUGVHZVIUVALVEVPZVMUVIVRZVSZVEKVTZUVBVFVPZUA
      VRZVSZUVMGVMUUFRVJZVIZVFHVTZVIZUVDUUNWJZUUSUVGUVLUVHUVRUUSYQYSUVGUVLWKYQY
      RYSUUCUUHUURWLZYQYRYSUUCUUHUURWMACTHJKLMOQRVGUBUVAVEUFUIUJURUOUSULVAWIWNU
      USYQUUFBVHZUUFUBRVJZUVHUVRWKUWAUUSQXAVHZUUBUBBVHZUWBUUSYOUWDUUIYOUURYOYPY
      RYSUUCUUHWOZWPQWQZXBZUVFUUSYPUWEUUIYPUURYOYPYRYSUUCUUHWRZWPBMQUBUEUJWSZXB
      ZBQSUDUBUEUHWTZXCUUSUWDUUBUWEUWCUWHUVFUWKBQRSUDUBUEUFUHXDZXCBGHVFJMNQRVGU
      BUUFUVBUAUEUFUJUOUPUQUKXEXFXGUVSUVKUVQVIZVFHVTVEKVTUUSUVTUVKUVQVEVFKHXHUU
      SUWNUVTVEVFKHUUSUVIKVHUVMHVHVIZUVPUUTUVJUVNDVNZVSZUUNWJZWJZUWNUVTWJUUSUWO
      UVPUWQUUNUUSUWOUVPUWQVLZVIYTUURUWTUUNYTUUCUUHUURUWTXIUUIUURUWTXJUUSUWTXKA
      BCDEFGHIVBVFJKLMNOPQRSTUAUBUCUDVEUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAXLXCXM
      UWNUWSUVTUVKUVOUVPUWSUVTWJUVKUVOVIZUWSUVPUVTUXAUVPUVTWJUWSUXAUVTUWRUVPUXA
      UVDUWQUUNUXAUVCUWPUUTUVAUVJUVBUVNDXNXOXPXQXRXSXTYAYBYCYDYEYCYFYLYGUUIYQUU
      DBVHZUUDUBRVJZUWBUWCUUJUUPWKYQYRYSUUCUUHYHUUIUWDUUAUWEUXBUUIYOUWDUWFUWGXB
      ZYTUUAUUBUUHYIZUUIYPUWEUWIUWJXBZBQSUCUBUEUHWTXCUUIUWDUUAUWEUXCUXDUXEUXFBQ
      RSUCUBUEUFUHXDXCUUIUWDUUBUWEUWBUXDYTUUAUUBUUHYJZUXFUWLXCUUIUWDUUBUWEUWCUX
      DUXGUXFUWMXCABGHVBMQRUBUUDUUFUEUFUIUJUOUPYMYKYN $.

    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  (Contributed by NM, 4-Mar-2014.) $)
    dihord2pre2 $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( Q .\/ ( X ./\ W ) ) = X /\ ( N .\/ ( Y ./\ W ) ) = Y /\
          ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        C_ ( ( J ` N ) .(+) ( I ` ( Y ./\ W ) ) ) ) )
       -> ( Q .\/ ( X ./\ W ) ) .<_ ( N .\/ ( Y ./\ W ) ) ) $=
      ( chlt wcel wa wbr wn w3a co wceq cfv wss dihord2a clat simp11l hllat syl
      simp2l simp11r lhpbase latmcl syl3anc simp2r simp13l atbase latjcl simp33
      dihord2pre syld3an3 latlej2 lattrd wb simp12l latjle12 syl13anc mpbi2and
      ) QVBVCZUBMVCZVDZFAVCZFUBRVEVFZVDZTAVCZTUBRVEVFZVDZVGZUCBVCZUDBVCZVDZFUCU
      BSVHZPVHZUCVIZTUDUBSVHZPVHZUDVIZFOVJXINVJEVHTOVJXLNVJEVHVKZVGZVGZFXMRVEZX
      IXMRVEZXJXMRVEZABEFTIMNOPQRSUBUCUDUEUFUGUHUIUJUKULUMUNVLXQBQRXIXLXMUEUFXQ
      WPQVMVCZWPWQXAXDXHXPVNQVOVPZXQYAXFUBBVCZXIBVCZYBXEXFXGXPVQXQWQYCWPWQXAXDX
      HXPVRBMQUBUEUJVSVPZBQSUCUBUEUHVTWAZXQYAXGYCXLBVCZYBXEXFXGXPWBYEBQSUDUBUEU
      HVTWAZXQYATBVCZYGXMBVCZYBXQXBYIXBXCWRXAXHXPWCABTQUEUIWDVPZYHBPQTXLUEUGWEW
      AZXEXHXPXOXIXLRVEXEXHXKXNXOWFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
      UMUNUOUPUQURUSUTVAWGWHXQYAYIYGXLXMRVEYBYKYHBPQRTXLUEUFUGWIWAWJXQYAFBVCZYD
      YJXRXSVDXTWKYBXQWSYMWSWTWRXDXHXPWLABFQUEUIWDVPYFYLBPQRFXIXMUEUFUGWMWNWO
      $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h B $.  $d h H $.  $d h K $.  $d h N $.
    $d h W $.
    dihord2.b $e |- B = ( Base ` K ) $.
    dihord2.l $e |- .<_ = ( le ` K ) $.
    dihord2.j $e |- .\/ = ( join ` K ) $.
    dihord2.m $e |- ./\ = ( meet ` K ) $.
    dihord2.a $e |- A = ( Atoms ` K ) $.
    dihord2.h $e |- H = ( LHyp ` K ) $.
    dihord2.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    dihord2.J $e |- J = ( ( DIsoC ` K ) ` W ) $.
    dihord2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihord2.s $e |- .(+) = ( LSSum ` U ) $.
    $( Part of proof after Lemma N of [Crawley] p. 122.  Reverse ordering
       property.  Todo: do we need ` -. X .<_ W ` and ` -. Y .<_ W ` ?
       (Contributed by NM, 4-Mar-2014.) $)
    dihord2 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W )
        /\ ( N e. A /\ -. N .<_ W ) ) /\ ( X e. B /\ Y e. B )
    /\ ( ( Q .\/ ( X ./\ W ) ) = X /\ ( N .\/ ( Y ./\ W ) ) = Y /\
          ( ( J ` Q ) .(+) ( I ` ( X ./\ W ) ) )
        C_ ( ( J ` N ) .(+) ( I ` ( Y ./\ W ) ) ) ) )
       -> X .<_ Y ) $=
      ( vh chlt wcel wa wbr wn w3a co wceq cfv wss coc cplusg ctrl cltrn ctendo
      cv crio cid cres cmpt eqid dihord2pre2 simp31 simp32 3brtr3d ) JUHUINFUIU
      JDAUIDNKUKULUJMAUIMNKUKULUJUMZOBUIPBUIUJZDONLUNZIUNZOUOZMPNLUNZIUNZPUOZDH
      UPVOGUPCUNMHUPVRGUPCUNUQZUMUMVPVSOPKABNJURUPUPZEUSUPZCDNJUTUPUPZNJVAUPUPZ
      EUGNJVBUPUPZWBUGVCUPMUOUGWEVDZFGHIJKLMUGWEVEBVFVGZNOPQRSTUAUBUCUDUEUFWEVH
      WDVHWHVHWBVHWFVHWCVHWGVHVIVMVNVQVTWAVJVMVNVQVTWAVKVL $.
  $}

  $c DIsoH $.

  $( Extend class notation with isomorphism H. $)
  cdih $a class DIsoH $.

  ${
    $d k q w u x $.
    $( Define isomorphism H. (Contributed by NM, 28-Jan-2014.) $)
    df-dih $a |- DIsoH = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
  ( x e. ( Base ` k ) |-> if ( x ( le ` k ) w , ( ( ( DIsoB ` k ) ` w ) ` x ) ,
    ( iota_ u e. ( LSubSp ` ( ( DVecH ` k ) ` w ) )
       A. q e. ( Atoms ` k ) ( ( -. q ( le ` k ) w /\
             ( q ( join ` k ) ( x ( meet ` k ) w ) ) = x )
         -> u = ( ( ( ( DIsoC ` k ) ` w ) ` q )
             ( LSSum ` ( ( DVecH ` k ) ` w ) )
        ( ( ( DIsoB ` k ) ` w ) ` ( x ( meet ` k ) w ) ) ) ) ) ) ) ) ) $.
  $}

  ${
    $d k ./\ $.  $d k .<_ $.  $d k .\/ $.  $d k q A $.  $d k B $.  $d k q A $.
    $d k w H $.  $d k q u w x K $.
    dihval.b $e |- B = ( Base ` K ) $.
    dihval.l $e |- .<_ = ( le ` K ) $.
    dihval.j $e |- .\/ = ( join ` K ) $.
    dihval.m $e |- ./\ = ( meet ` K ) $.
    dihval.a $e |- A = ( Atoms ` K ) $.
    dihval.h $e |- H = ( LHyp ` K ) $.
    $( The isomorphism H for a lattice ` K ` .  Definition of isomorphism map
       in [Crawley] p. 122 line 3.  (Contributed by NM, 28-Jan-2014.) $)
    dihffval $p |- ( K e. V -> ( DIsoH ` K ) = ( w e. H |->
  ( x e. B |-> if ( x .<_ w , ( ( ( DIsoB ` K ) ` w ) ` x ) ,
    ( iota_ u e. ( LSubSp ` ( ( DVecH ` K ) ` w ) )
       A. q e. A ( ( -. q .<_ w /\
             ( q .\/ ( x ./\ w ) ) = x )
         -> u = ( ( ( ( DIsoC ` K ) ` w ) ` q )
             ( LSSum ` ( ( DVecH ` K ) ` w ) )
        ( ( ( DIsoB ` K ) ` w ) ` ( x ./\ w ) ) ) ) ) ) ) ) ) $=
      ( cfv fveq2 vk wcel cvv cdih cv cdib wn co wceq wa cdic cdvh clsm wi wral
      wbr clss crio cif cmpt elex clh cbs cple cmee syl6eqr breqd fveq1d fveq2d
      catm notbid eqidd oveqd oveq123d eqeq1d anbi12d fveq12d imbi12d raleqbidv
      cjn eqeq2d riotaeqbidv ifbieq12d mpteq12dv df-dih eqeltri mptex fvmpt syl
      fvex ) HKUBHUCUBHUDSBFAEAUEZBUEZIUPZWKWLHUFSZSZSZLUEZWLIUPZUGZWQWKWLJUHZG
      UHZWKUIZUJZCUEZWQWLHUKSZSZSZWTWOSZWLHULSZSZUMSZUHZUIZUNZLDUOZCXJUQSZURZUS
      ZUTZUTZUIHKVAUAHBUAUEZVBSZAYAVCSZWKWLYAVDSZUPZWKWLYAUFSZSZSZWQWLYDUPZUGZW
      QWKWLYAVESZUHZYAVTSZUHZWKUIZUJZXDWQWLYAUKSZSZSZYLYGSZWLYAULSZSZUMSZUHZUIZ
      UNZLYAVJSZUOZCUUBUQSZURZUSZUTZUTXTUCUDYAHUIZBYBUULFXSUUMYBHVBSZFYAHVBTRVF
      UUMAYCUUKEXRUUMYCHVCSEYAHVCTMVFUUMYEWMYHUUJWPXQUUMYDIWKWLUUMYDHVDSIYAHVDT
      NVFZVGUUMWKYGWOUUMWLYFWNYAHUFTVHZVHUUMUUHXOCUUIXPUUMUUBXJUQUUMWLUUAXIYAHU
      LTVHZVIUUMUUFXNLUUGDUUMUUGHVJSDYAHVJTQVFUUMYPXCUUEXMUUMYJWSYOXBUUMYIWRUUM
      YDIWQWLUUOVGVKUUMYNXAWKUUMWQWQYLWTYMGUUMYMHVTSGYAHVTTOVFUUMWQVLUUMYKJWKWL
      UUMYKHVESJYAHVETPVFVMZVNVOVPUUMUUDXLXDUUMYSXGYTXHUUCXKUUMUUBXJUMUUQVIUUMW
      QYRXFUUMWLYQXEYAHUKTVHVHUUMYLWTYGWOUUPUURVQVNWAVRVSWBWCWDWDABCUALWEBFXSFU
      UNUCRHVBWJWFWGWHWI $.

    $d w ./\ $.  $d w .<_ $.  $d w .\/ $.  $d w A $.  $d w x B $.  $d w C $.
    $d w D $.  $d w .(+) $.  $d u w S $.  $d q u w x W $.
    dihval.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihval.d $e |- D = ( ( DIsoB ` K ) ` W ) $.
    dihval.c $e |- C = ( ( DIsoC ` K ) ` W ) $.
    dihval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihval.s $e |- S = ( LSubSp ` U ) $.
    dihval.p $e |- .(+) = ( LSSum ` U ) $.
    $( Isomorphism H for a lattice ` K ` .  Definition of isomorphism map in
       [Crawley] p. 122 line 3.  (Contributed by NM, 28-Jan-2014.) $)
    dihfval $p |- ( ( K e. V /\ W e. H )
  -> I = ( x e. B |-> if ( x .<_ W , ( D ` x ) ,
    ( iota_ u e. S A. q e. A ( ( -. q .<_ W /\ ( q .\/ ( x ./\ W ) ) = x )
         -> u = ( ( C ` q ) .(+) ( D ` ( x ./\ W ) ) ) ) ) ) ) ) $=
      ( vw wcel cv wbr cdib cfv wn co wceq wa cdic cdvh clsm wral clss crio cif
      cmpt cdih dihffval fveq1d syl5eq breq2 fveq2 syl6eqr fveq2d notbid oveq2d
      wi oveq2 eqeq1d anbi12d fveq12d oveq123d eqeq2d imbi12d ralbidv ifbieq12d
      riotaeqbidv mpteq2dv eqid cbs cvv fvex eqeltri mptex fvmpt sylan9eq ) MPU
      LZQJULKQUKJADAUMZUKUMZNUNZWTXAMUOUPZUPZUPZRUMZXANUNZUQZXFWTXAOURZLURZWTUS
      ZUTZBUMZXFXAMVAUPZUPZUPZXIXDUPZXAMVBUPZUPZVCUPZURZUSZVSZRCVDZBXSVEUPZVFZV
      GZVHZVHZUPZADWTQNUNZWTFUPZXFQNUNZUQZXFWTQOURZLURZWTUSZUTZXMXFEUPZYOFUPZGU
      RZUSZVSZRCVDZBHVFZVGZVHZWSKQMVIUPZUPYJUEWSQUUHYIAUKBCDJLMNOPRSTUAUBUCUDVJ
      VKVLUKQYHUUGJYIXAQUSZADYGUUFUUIXBYKXEYFYLUUEXAQWTNVMUUIWTXDFUUIXDQXCUPFXA
      QXCVNUFVOZVKUUIYDUUDBYEHUUIYEIVEUPHUUIXSIVEUUIXSQXRUPIXAQXRVNUHVOZVPUIVOU
      UIYCUUCRCUUIXLYRYBUUBUUIXHYNXKYQUUIXGYMXAQXFNVMVQUUIXJYPWTUUIXIYOXFLXAQWT
      OVTZVRWAWBUUIYAUUAXMUUIXPYSXQYTXTGUUIXTIVCUPGUUIXSIVCUUKVPUJVOUUIXFXOEUUI
      XOQXNUPEXAQXNVNUGVOVKUUIXIYOXDFUUJUULWCWDWEWFWGWIWHWJYIWKADUUFDMWLUPWMSMW
      LWNWOWPWQWR $.

    $d x ./\ $.  $d x .<_ $.  $d x .\/ $.  $d x A $.  $d x C $.  $d x D $.
    $d x .(+) $.  $d x S $.  $d q u x X $.
    $( Value of isomorphism H for a lattice ` K ` .  Definition of isomorphism
       map in [Crawley] p. 122 line 3.  (Contributed by NM, 3-Feb-2014.) $)
    dihval $p |- ( ( ( K e. V /\ W e. H ) /\ X e. B )
        -> ( I ` X ) = if ( X .<_ W , ( D ` X ) ,
    ( iota_ u e. S A. q e. A ( ( -. q .<_ W /\ ( q .\/ ( X ./\ W ) ) = X )
         -> u = ( ( C ` q ) .(+) ( D ` ( X ./\ W ) ) ) ) ) ) ) $=
      ( vx wcel wa cfv cv wbr wn co wceq wi wral crio cmpt dihfval fveq1d breq1
      cif fveq2 oveq1 oveq2d id eqeq12d anbi2d fveq2d imbi12d ralbidv riotabidv
      eqeq2d ifbieq12d eqid fvex riotaex ifex fvmpt sylan9eq ) LOULPIULUMZQCULQ
      JUNQUKCUKUOZPMUPZWGEUNZRUOZPMUPUQZWJWGPNURZKURZWGUSZUMZAUOZWJDUNZWLEUNZFU
      RZUSZUTZRBVAZAGVBZVGZVCZUNQPMUPZQEUNZWKWJQPNURZKURZQUSZUMZWPWQXHEUNZFURZU
      SZUTZRBVAZAGVBZVGZWFQJXEUKABCDEFGHIJKLMNOPRSTUAUBUCUDUEUFUGUHUIUJVDVEUKQX
      DXRCXEWGQUSZWHXFWIXCXGXQWGQPMVFWGQEVHXSXBXPAGXSXAXORBXSWOXKWTXNXSWNXJWKXS
      WMXIWGQXSWLXHWJKWGQPNVIZVJXSVKVLVMXSWSXMWPXSWRXLWQFXSWLXHEXTVNVJVRVOVPVQV
      SXEVTXFXGXQQEWAXPAGWBWCWDWE $.

    $( Value of isomorphism H for a lattice ` K ` when ` -. X .<_ W ` .
       (Contributed by NM, 4-Mar-2014.) $)
    dihvalc $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ -. X .<_ W ) )
        -> ( I ` X ) =
    ( iota_ u e. S A. q e. A ( ( -. q .<_ W /\ ( q .\/ ( X ./\ W ) ) = X )
         -> u = ( ( C ` q ) .(+) ( D ` ( X ./\ W ) ) ) ) ) ) $=
      ( wcel wa wbr wn cfv cv wceq wral crio cif dihval iffalse sylan9eq anasss
      co wi ) LOUKPIUKULZQCUKZQPMUMZUNZQJUOZRUPZPMUMUNVLQPNVEZKVEQUQULAUPVLDUOV
      MEUOFVEUQVFRBURAGUSZUQVGVHULVJVKVIQEUOZVNUTVNABCDEFGHIJKLMNOPQRSTUAUBUCUD
      UEUFUGUHUIUJVAVIVOVNVBVCVD $.

    $d q r u .\/ $.  $d q r u .<_ $.  $d r u A $.  $d q r u B $.  $d q r u C $.
    $d q r u .(+) $.  $d q r u D $.  $d q I $.  $d r K $.  $d r W $.  $d r X $.
    $d q r u ./\ $.  $d q r u H $.  $d q r u Q $.  $d q r S $.
    $( Closure of isomorphism H for a lattice ` K ` when ` -. X .<_ W ` .
       (Contributed by NM, 6-Mar-2014.) $)
    dihlsscpre $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( X e. B /\ -. X .<_ W ) ) -> ( I ` X ) e. S ) $=
      ( vq vu vr chlt wcel wa wbr wn cfv cv co wceq wral crio dihvalc wreu wrex
      wi w3a simp1l simp2l simp3ll jca simp2r simp3rl simp1rl simp3lr syl131anc
      simp3rr eqtr4d dihjust ralrimivv wb lhpmcvr2 clmod simpll dvhlmod adantlr
      3exp diclss clat hllat ad3antrrr simplrl lhpbase ad3antlr syl3anc latmle2
      latmcl diblss syl12anc lsmcl a1d expr imp3a ancld reximdva mpd weq notbid
      breq1 oveq1 eqeq1d anbi12d fveq2 oveq1d reusv3 syl reusv1 riotacl eqeltrd
      mpbid mpbird ) KUKULZNHULZUMZOBULZONLUNUOZUMZUMZOIUPUHUQZNLUNZUOZYHONMURZ
      JURZOUSZUMZUIUQYHCUPZYKDUPZEURZUSVEUHAUTZUIFVAZFUIABCDEFGHIJKLMUKNOUHPQRS
      TUAUBUCUDUEUFUGVBYGYRUIFVCZYSFULYGYTYRUIFVDZYGYNUJUQZNLUNZUOZUUBYKJURZOUS
      ZUMZUMZYQUUBCUPZYPEURZUSZVEZUJAUTUHAUTZUUAYGUULUHUJAAYGYHAULZUUBAULZUMZUU
      HUUKYGUUPUUHVFZYCUUNYJUMZUUOUUDUMYDYLUUEUSUUKYCYFUUPUUHVGUUQUUNYJYGUUNUUO
      UUHVHYJYMUUGYGUUPVIVJUUQUUOUUDYGUUNUUOUUHVKUUDUUFYNYGUUPVLVJYDYEYCUUPUUHV
      MUUQYLOUUEYJYMUUGYGUUPVNUUDUUFYNYGUUPVPVQABEYHUUBGHDCJKLMNOPQRSTUAUCUDUEU
      GVRVOWFVSYGYNYQFULZUMZUHAVDZUUMUUAVTYGYNUHAVDZUVAABHJKLMNOUHPQRSTUAWAZYGY
      NUUTUHAYGUUNUMZYNUUSUVDYJYMUUSYGUUNYJYMUUSVEYGUURUMZUUSYMUVEGWBULYOFULZYP
      FULZUUSUVEGHKNUAUEYCYFUURWCZWDYCUURUVFYFAYHFGHCKLNQTUAUEUDUFWGWEUVEYCYKBU
      LZYKNLUNZUVGUVHUVEKWHULZYDNBULZUVIYAUVKYBYFUURKWIWJZYCYDYEUURWKZYBUVLYAYF
      UURBHKNPUAWLWMZBKMONPSWPWNUVEUVKYDUVLUVJUVMUVNUVOBKLMONPQSWOWNBFGHDKLNYKP
      QUAUEUCUFWQWREFYOYPGUFUGWSWNWTXAXBXCXDXEYNUUGUIUHUJFAYQUUJUHUJXFZYJUUDYMU
      UFUVPYIUUCYHUUBNLXHXGUVPYLUUEOYHUUBYKJXIXJXKUVPYOUUIYPEYHUUBCXLXMXNXOXSYG
      UVBYTUUAVTUVCYNUIUHFAYQXPXOXTYRUIFXQXOXR $.

    $( Value of isomorphism H for a lattice ` K ` when ` -. X .<_ W ` , given
       auxiliary atom ` Q ` .  (Contributed by NM, 6-Mar-2014.) $)
    dihvalcqpre $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( X e. B /\ -. X .<_ W )
          /\ ( ( Q e. A /\ -. Q .<_ W ) /\ ( Q .\/ ( X ./\ W ) ) = X ) )
        -> ( I ` X ) = ( ( C ` Q ) .(+) ( D ` ( X ./\ W ) ) ) ) $=
      ( vq vu chlt wcel wa wbr wn co wceq w3a cvv cfv clss fvex eqeltri cv nfvd
      nfv wi wral dihvalc 3adant3 wb eqeq1 adantl simpl1 simprl simprrl simpl3l
      crio jca simpl2l simprrr simpl3r eqtr4d dihjust syl131anc dihlsscpre wrex
      ex lhpmcvr2 riotasv3d mpan2 ) LUKULOIULUMZPBULZPOMUNUOZUMZFAULFOMUNUOUMZF
      PONUPZKUPZPUQZUMZURZGUSULPJUTZFCUTWQDUTZEUPZUQZGHVAUTUSUGHVAVBVCXAUIVDZOM
      UNUOZXFWQKUPZPUQZUMZXFCUTXCEUPZXDUQZXEUJUIGAXKXBUSXAUIVFXAXEUIVEWLWOXBXJU
      JVDXKUQVGUIAVHUJGVRUQWTUJABCDEGHIJKLMNUKOPUIQRSTUAUBUCUDUEUFUGUHVIVJXKXBU
      QXLXEVKXAXKXBXDVLVMXAXFAULZXJUMZXLXAXNUMZWLXMXGUMWPWMXHWRUQXLWLWOWTXNVNXO
      XMXGXAXMXJVOXAXMXGXIVPVSWPWSWLWOXNVQWMWNWLWTXNVTXOXHPWRXAXMXGXIWAWPWSWLWO
      XNWBWCABEXFFHIDCKLMNOPQRSTUAUBUDUEUFUHWDWEWHWLWOXBGULWTABCDEGHIJKLMNOPQRS
      TUAUBUCUDUEUFUGUHWFVJWLWOXJUIAWGWTABIKLMNOPUIQRSTUAUBWIVJWJWK $.
  $}

  ${
    dihvalcq.b $e |- B = ( Base ` K ) $.
    dihvalcq.l $e |- .<_ = ( le ` K ) $.
    dihvalcq.j $e |- .\/ = ( join ` K ) $.
    dihvalcq.m $e |- ./\ = ( meet ` K ) $.
    dihvalcq.a $e |- A = ( Atoms ` K ) $.
    dihvalcq.h $e |- H = ( LHyp ` K ) $.
    dihvalcq.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihvalcq.d $e |- D = ( ( DIsoB ` K ) ` W ) $.
    dihvalcq.c $e |- C = ( ( DIsoC ` K ) ` W ) $.
    dihvalcq.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihvalcq.p $e |- .(+) = ( LSSum ` U ) $.
    $( Value of isomorphism H for a lattice ` K ` when ` -. X .<_ W ` , given
       auxiliary atom ` Q ` .  TODO:  Use ~ dihvalcq2 (with ~ lhpmcvr3 for
       ` ( Q .\/ ( X ./\ W ) ) = X ` simplification) that changes ` C ` and
       ` D ` to ` I ` and make this obsolete.  Do to other theorems as well.
       (Contributed by NM, 6-Mar-2014.) $)
    dihvalcq $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
      /\ ( ( Q e. A /\ -. Q .<_ W ) /\ ( Q .\/ ( X ./\ W ) ) = X ) )
        -> ( I ` X ) = ( ( C ` Q ) .(+) ( D ` ( X ./\ W ) ) ) ) $=
      ( clss cfv eqid dihvalcqpre ) ABCDEFGUGUHZGHIJKLMNOPQRSTUAUBUCUDUEUKUIUFU
      J $.
  $}

  ${
    $d q u K $.  $d q u W $.  $d q u X $.
    dihvalb.b $e |- B = ( Base ` K ) $.
    dihvalb.l $e |- .<_ = ( le ` K ) $.
    dihvalb.h $e |- H = ( LHyp ` K ) $.
    dihvalb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihvalb.d $e |- D = ( ( DIsoB ` K ) ` W ) $.
    $( Value of isomorphism H for a lattice ` K ` when ` X .<_ W ` .
       (Contributed by NM, 4-Mar-2014.) $)
    dihvalb $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
        -> ( I ` X ) = ( D ` X ) ) $=
      ( vq vu wcel wa cfv eqid wbr wceq cv wn cmee cjn cdic cdvh clsm catm wral
      co wi clss crio cif dihval iftrue sylan9eq anasss ) EGQHCQRZIAQZIHFUAZIDS
      ZIBSZUBVAVBRVCVDVCVEOUCZHFUAUDVFIHEUESZULZEUFSZULIUBRPUCVFHEUGSSZSVHBSHEU
      HSSZUISZULUBUMOEUJSZUKPVKUNSZUOZUPVEPVMAVJBVLVNVKCDVIEFVGGHIOJKVITVGTVMTL
      MNVJTVKTVNTVLTUQVCVEVOURUSUT $.
  $}

  ${
    $d g K $.  $d g T $.  $d g W $.
    dihval3.b $e |- B = ( Base ` K ) $.
    dihval3.l $e |- .<_ = ( le ` K ) $.
    dihval3.h $e |- H = ( LHyp ` K ) $.
    dihval3.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihval3.r $e |- R = ( ( trL ` K ) ` W ) $.
    dihval3.o $e |- O = ( g e. T |-> ( _I |` B ) ) $.
    dihval3.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Ordered pair member of the partial isomorphism H for argument under
       ` W ` .  (Contributed by NM, 21-Mar-2014.)
       (New usage is discouraged.) $)
    dihopelvalbN $p |- ( ( ( K e. V /\ W e. H ) /\ ( X e. B /\ X .<_ W ) )
          -> ( <. F , S >. e. ( I ` X )
          <-> ( ( F e. T /\ ( R ` F ) .<_ X ) /\ S = O ) ) ) $=
      ( wcel wa wbr cop cfv cdib wceq eqid dihvalb eleq2d dibopelval3 bitrd ) I
      LUBMGUBUCNAUBNMJUDUCUCZFCUEZNHUFZUBUONMIUGUFUFZUFZUBFDUBFBUFNJUDUCCKUHUCU
      NUPURUOAUQGHIJLMNOPQUAUQUIZUJUKABCDEFGUQIJLMNKOPQRSTUSULUM $.
  $}

  ${
    dihvalcqat.l $e |- .<_ = ( le ` K ) $.
    dihvalcqat.a $e |- A = ( Atoms ` K ) $.
    dihvalcqat.h $e |- H = ( LHyp ` K ) $.
    dihvalcqat.j $e |- J = ( ( DIsoC ` K ) ` W ) $.
    dihvalcqat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Value of isomorphism H for a lattice ` K ` at an atom not under ` W ` .
       (Contributed by NM, 27-Mar-2014.) $)
    dihvalcqat $p |- ( ( ( K e. HL /\ W e. H )
      /\ ( Q e. A /\ -. Q .<_ W ) ) -> ( I ` Q ) = ( J ` Q ) ) $=
      ( wcel wa cfv co wceq eqid eqtrd chlt wbr wn cmee cdib cdvh cbs cjn simpl
      clsm atbase ad2antrl simprr simpr cp0 lhpmat oveq2d hlol ad2antrr syl2anc
      col olj01 dihvalcq syl122anc c0g csn fveq2d dib0 csubg clmod clss dvhlmod
      adantr diclss lsssubg lsm01 syl ) FUANZHCNZOZBANZBHGUBUCZOZOZBDPZBEPZBHFU
      DPZQZHFUEPPZPZHFUFPPZUJPZQZWFWDVTBFUGPZNZWBWCBWHFUHPZQZBRWEWMRVTWCUIZWAWO
      VTWBAWNBFWNSZJUKULZVTWAWBUMVTWCUNWDWQBFUOPZWPQZBWDWHXABWPABCFGWGHXAIWGSZX
      ASZJKUPZUQWDFVANZWOXBBRVRXFVSWCFURUSWTWNWPFBXAWSWPSZXDVBUTTAWNEWIWLBWKCDW
      PFGWGHBWSIXGXCJKMWISZLWKSZWLSZVCVDWDWMWFWKVEPZVFZWLQZWFWDWJXLWFWLWDWJXAWI
      PZXLWDWHXAWIXEVGVTXNXLRWCWKCWIFXKHXAXDKXHXIXKSZVHVMTUQWDWFWKVIPNZXMWFRWDW
      KVJNWFWKVKPZNXPWDWKCFHKXIWRVLABXQWKCEFGHIJKXILXQSZVNXQWFWKXRVOUTWLWKWFXKX
      OXJVPVQTT $.
  $}

  ${
    $d h B $.  $d h K $.  $d h T $.  $d h W $.
    dih1dimb.b $e |- B = ( Base ` K ) $.
    dih1dimb.h $e |- H = ( LHyp ` K ) $.
    dih1dimb.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dih1dimb.r $e |- R = ( ( trL ` K ) ` W ) $.
    dih1dimb.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dih1dimb.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1dimb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1dimb.n $e |- N = ( LSpan ` U ) $.
    $( Two expressions for a 1-dimensional subspace of vector space H (when
       ` F ` is a nonzero vector i.e. non-identity translation).  (Contributed
       by NM, 27-Apr-2014.) $)
    dih1dimb $p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( I ` ( R ` F ) ) = ( N ` { <. F , O >. } ) ) $=
      ( chlt wcel cfv cdib cop csn cple wbr wceq simpl trlcl eqid trlle dihvalb
      wa syl12anc dib1dim2 eqtrd ) IUAUBLGUBUOZFCUBZUOZFBUCZHUCZVBLIUDUCUCZUCZF
      KUEUFJUCVAUSVBAUBVBLIUGUCZUHVCVEUIUSUTUJABCFGILMNOPUKBCFGIVFLVFULZNOPUMAV
      DGHIVFUALVBMVGNSVDULZUNUPABCDEFGVDIJKLMNOPQRVHTUQUR $.
  $}

  ${
    $d f .<_ $.  $d f A $.  $d h B $.  $d f H $.  $d f h K $.  $d f Q $.
    $d f h T $.  $d f h W $.
    dih1dimb2.b $e |- B = ( Base ` K ) $.
    dih1dimb2.l $e |- .<_ = ( le ` K ) $.
    dih1dimb2.a $e |- A = ( Atoms ` K ) $.
    dih1dimb2.h $e |- H = ( LHyp ` K ) $.
    dih1dimb2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dih1dimb2.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dih1dimb2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1dimb2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1dimb2.n $e |- N = ( LSpan ` U ) $.
    $( Isomorphism H at an atom under ` W ` .  (Contributed by NM,
       27-Apr-2014.) $)
    dih1dimb2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ Q .<_ W ) )
 -> E. f e. T ( f =/= ( _I |` B ) /\ ( I ` Q ) = ( N ` { <. f , O >. } ) ) ) $=
      ( chlt wcel wa wbr cv ctrl cfv wceq wrex cid cres wne cop csn eqid cdlemf
      w3a simp3 simp1rl eqeltrd wb simp1l simp2 trlnidatb syl2anc mpbird fveq2d
      dih1dimb eqtr3d jca 3expia reximdva mpd ) JUDUENHUEUFZCAUEZCNKUGZUFZUFZFU
      HZNJUIUJUJZUJZCUKZFDULWBUMBUNUOZCIUJZWBMUPUQLUJZUKZUFZFDULAWCDCFHJKNPQRSW
      CURZUSWAWEWJFDWAWBDUEZWEWJWAWLWEUTZWFWIWMWFWDAUEZWMWDCAWAWLWEVAZVRVSVQWLW
      EVBVCWMVQWLWFWNVDVQVTWLWEVEZWAWLWEVFZABWCDWBHJNOQRSWKVGVHVIWMWDIUJZWGWHWM
      WDCIWOVJWMVQWLWRWHUKWPWQBWCDEGWBHIJLMNORSWKTUAUBUCVKVHVLVMVNVOVP $.
  $}

  ${
    $d f .<_ $.  $d f A $.  $d f H $.  $d f K $.  $d f P $.  $d f Q $.
    $d f T $.  $d f W $.
    dih1dimc.l $e |- .<_ = ( le ` K ) $.
    dih1dimc.a $e |- A = ( Atoms ` K ) $.
    dih1dimc.h $e |- H = ( LHyp ` K ) $.
    dih1dimc.p $e |- P = ( ( oc ` K ) ` W ) $.
    dih1dimc.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dih1dimc.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1dimc.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1dimc.n $e |- N = ( LSpan ` U ) $.
    dih1dimc.f $e |- F = ( iota_ f e. T ( f ` P ) = Q ) $.
    $( Isomorphism H at an atom not under ` W ` .  (Contributed by NM,
       27-Apr-2014.) $)
    dih1dimc $p |- ( ( ( K e. HL /\ W e. H ) /\ ( Q e. A /\ -. Q .<_ W ) )
         -> ( I ` Q ) = ( N ` { <. F , ( _I |` T ) >. } ) ) $=
      ( chlt wcel wa wbr wn cfv cdic cid cres cop csn dihvalcqat diclspsn eqtrd
      eqid ) JUCUDMHUDUECAUDCMKUFUGUEUECIUHCMJUIUHUHZUHGUJDUKULUMLUHACHIURJKMNO
      PURUQZSUNABCDEFGHURJKLMNOPQRUSTUAUBUOUP $.
  $}

  ${
    $d f s .\/ $.  $d f H $.  $d f s I $.  $d f K $.  $d f s P $.  $d f s ph $.
    $d f s .(+) $.  $d f s Q $.  $d f W $.
    dib2dim.l $e |- .<_ = ( le ` K ) $.
    dib2dim.j $e |- .\/ = ( join ` K ) $.
    dib2dim.a $e |- A = ( Atoms ` K ) $.
    dib2dim.h $e |- H = ( LHyp ` K ) $.
    dib2dim.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dib2dim.s $e |- .(+) = ( LSSum ` U ) $.
    dib2dim.i $e |- I = ( ( DIsoB ` K ) ` W ) $.
    dib2dim.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dib2dim.p $e |- ( ph -> ( P e. A /\ P .<_ W ) ) $.
    dib2dim.q $e |- ( ph -> ( Q e. A /\ Q .<_ W ) ) $.
    $( Extend ~ dia2dim to partial isomorphism B. (Contributed by NM,
       22-Sep-2014.) $)
    dib2dim $p |- ( ph
            -> ( I ` ( P .\/ Q ) ) C_ ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( vf vs co cfv chlt wcel wa wrel dibvalrel syl cv cdia cltrn cid cbs cres
      cmpt wceq cdveca clsm cop eqid dia2dim sseld anim1d wbr wb simpld hlatjcl
      syl3anc simprd clat atbase lhpbase latjle12 syl13anc mpbi2and dibopelval2
      hllat syl12anc jca diblsmopel 3imtr4d relssdv ) AUCUDCEIUEZHUFZCHUFEHUFDU
      EZAJUGUHZLGUHZUIZWHUJTGHJUGLWGPSUKULAUCUMZWGLJUNUFUFZUFZUHZUDUMZUCLJUOUFU
      FZUPJUQUFZURUSZUTZUIZWMCWNUFEWNUFLJVAUFUFZVBUFZUEZUHZXAUIWMWQVCZWHUHZXGWI
      UHAWPXFXAAWOXEWMABXDCGWNIJKELXCMNOPXCVDZXDVDZWNVDZTUAUBVEVFVGAWLWGWSUHZWG
      LKVHZXHXBVITAWJCBUHZEBUHZXLAWJWKTVJZAXNCLKVHZUAVJZAXOELKVHZUBVJZBWSIJCEWS
      VDZNOVKVLAXQXSXMAXNXQUAVMZAXOXSUBVMZAJVNUHZCWSUHZEWSUHZLWSUHZXQXSUIXMVIAW
      JYDXPJWAULAXNYEXRBWSCJYAOVOULZAXOYFXTBWSEJYAOVOULZAWKYGAWJWKTVMWSGJLYAPVP
      ULWSIJKCELYAMNVQVRVSWSWQWRUCWMGHWNJKUGLWGWTYAMPWRVDZWTVDZXKSVTWBAWSDXDWQW
      RFUCWMGHWNJKWTXCLCEYAMPYJYKXIQXJRXKSTAYEXQYHYBWCAYFXSYIYCWCWDWEWF $.
  $}

  ${
    dih2dimb.l $e |- .<_ = ( le ` K ) $.
    dih2dimb.j $e |- .\/ = ( join ` K ) $.
    dih2dimb.a $e |- A = ( Atoms ` K ) $.
    dih2dimb.h $e |- H = ( LHyp ` K ) $.
    dih2dimb.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih2dimb.s $e |- .(+) = ( LSSum ` U ) $.
    dih2dimb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih2dimb.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dih2dimb.p $e |- ( ph -> ( P e. A /\ P .<_ W ) ) $.
    dih2dimb.q $e |- ( ph -> ( Q e. A /\ Q .<_ W ) ) $.
    $( Extend ~ dib2dim to isomorphism H. (Contributed by NM, 22-Sep-2014.) $)
    dih2dimb $p |- ( ph
            -> ( I ` ( P .\/ Q ) ) C_ ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( co cdib cfv eqid dib2dim chlt wcel wa cbs simpld hlatjcl syl3anc simprd
      wbr wceq clat hllat syl atbase lhpbase latjle12 syl13anc mpbi2and dihvalb
      wb syl12anc oveq12d 3sstr4d ) ACEIUCZLJUDUEUEZUEZCVLUEZEVLUEZDUCVKHUEZCHU
      EZEHUEZDUCABCDEFGVLIJKLMNOPQRVLUFZTUAUBUGAJUHUIZLGUIZUJZVKJUKUEZUIZVKLKUP
      ZVPVMUQTAVTCBUIZEBUIZWDAVTWATULZAWFCLKUPZUAULZAWGELKUPZUBULZBWCIJCEWCUFZN
      OUMUNAWIWKWEAWFWIUAUOZAWGWKUBUOZAJURUIZCWCUIZEWCUIZLWCUIZWIWKUJWEVGAVTWPW
      HJUSUTAWFWQWJBWCCJWMOVAUTZAWGWRWLBWCEJWMOVAUTZAWAWSAVTWATUOWCGJLWMPVBUTWC
      IJKCELWMMNVCVDVEWCVLGHJKUHLVKWMMPSVSVFVHAVQVNVRVODAWBWQWIVQVNUQTWTWNWCVLG
      HJKUHLCWMMPSVSVFVHAWBWRWKVRVOUQTXAWOWCVLGHJKUHLEWMMPSVSVFVHVIVJ $.

    $d f s .(+) $.  $d f s .\/ $.  $d f H $.  $d f s K $.  $d f s P $.
    $d f s Q $.  $d f s W $.  $d f s ph $.
    $( Extend ~ dia2dim to isomorphism H. (This version combines ~ dib2dim and
       ~ dih2dimb for shorter overall proof, but may be less easy to
       understand.  TODO: decide which to use.)  (Contributed by NM,
       22-Sep-2014.)  (Proof modification is discouraged.)
       (New usage is discouraged.) $)
    dih2dimbALTN $p |- ( ph
            -> ( I ` ( P .\/ Q ) ) C_ ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( vf vs co cdib cfv chlt wcel wa wrel eqid dibvalrel syl cv cltrn cid cbs
      cdia cres cmpt wceq cdveca cop dia2dim sseld anim1d wbr wb simpld hlatjcl
      clsm syl3anc simprd atbase lhpbase latjle12 syl13anc mpbi2and dibopelval2
      clat hllat syl12anc diblsmopel 3imtr4d relssdv dihvalb oveq12d 3sstr4d
      jca ) ACEIUEZLJUFUGUGZUGZCWLUGZEWLUGZDUEZWKHUGZCHUGZEHUGZDUEAUCUDWMWPAJUH
      UIZLGUIZUJZWMUKTGWLJUHLWKPWLULZUMUNAUCUOZWKLJUSUGUGZUGZUIZUDUOZUCLJUPUGUG
      ZUQJURUGZUTVAZVBZUJZXDCXEUGEXEUGLJVCUGUGZVLUGZUEZUIZXLUJXDXHVDZWMUIZXRWPU
      IAXGXQXLAXFXPXDABXOCGXEIJKELXNMNOPXNULZXOULZXEULZTUAUBVEVFVGAXBWKXJUIZWKL
      KVHZXSXMVITAWTCBUIZEBUIZYCAWTXATVJZAYECLKVHZUAVJZAYFELKVHZUBVJZBXJIJCEXJU
      LZNOVKVMZAYHYJYDAYEYHUAVNZAYFYJUBVNZAJWAUIZCXJUIZEXJUIZLXJUIZYHYJUJYDVIAW
      TYPYGJWBUNAYEYQYIBXJCJYLOVOUNZAYFYRYKBXJEJYLOVOUNZAXAYSAWTXATVNXJGJLYLPVP
      UNXJIJKCELYLMNVQVRVSZXJXHXIUCXDGWLXEJKUHLWKXKYLMPXIULZXKULZYBXCVTWCAXJDXO
      XHXIFUCXDGWLXEJKXKXNLCEYLMPUUCUUDXTQYARYBXCTAYQYHYTYNWJAYRYJUUAYOWJWDWEWF
      AXBYCYDWQWMVBTYMUUBXJWLGHJKUHLWKYLMPSXCWGWCAWRWNWSWODAXBYQYHWRWNVBTYTYNXJ
      WLGHJKUHLCYLMPSXCWGWCAXBYRYJWSWOVBTUUAYOXJWLGHJKUHLEYLMPSXCWGWCWHWI $.
  $}

  ${
    $d g K $.  $d g Q $.  $d g T $.  $d g W $.
    dihelval2.l $e |- .<_ = ( le ` K ) $.
    dihelval2.a $e |- A = ( Atoms ` K ) $.
    dihelval2.h $e |- H = ( LHyp ` K ) $.
    dihelval2.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihelval2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihelval2.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihelval2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihelval2.g $e |- G = ( iota_ g e. T ( g ` P ) = Q ) $.
    dihelval2.f $e |- F e. _V $.
    dihelval2.s $e |- S e. _V $.
    $( Ordered pair member of the partial isomorphism H for atom argument not
       under ` W ` .  TODO: remove .t hypothesis.  (Contributed by NM,
       30-Mar-2014.) $)
    dihopelvalcqat $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( Q e. A /\ -. Q .<_ W ) )
    -> ( <. F , S >. e. ( I ` Q ) <-> ( F = ( S ` G ) /\ S e. E ) ) ) $=
      ( chlt wcel wa wbr wn cop cfv cdic wceq eqid dihvalcqat dicopelval2 bitrd
      eleq2d ) LUEUFNJUFUGCAUFCNMUHUIUGUGZHDUJZCKUKZUFUTCNLULUKUKZUKZUFHIDUKUMD
      GUFUGUSVAVCUTACJKVBLMNOPQVBUNZUAUOURABCDEFGHIJVBLMUENOPQRSTVDUBUCUDUPUQ
      $.
  $}

  ${
    dihvalcq2.b $e |- B = ( Base ` K ) $.
    dihvalcq2.l $e |- .<_ = ( le ` K ) $.
    dihvalcq2.j $e |- .\/ = ( join ` K ) $.
    dihvalcq2.m $e |- ./\ = ( meet ` K ) $.
    dihvalcq2.a $e |- A = ( Atoms ` K ) $.
    dihvalcq2.h $e |- H = ( LHyp ` K ) $.
    dihvalcq2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihvalcq2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihvalcq2.p $e |- .(+) = ( LSSum ` U ) $.
    $( Value of isomorphism H for a lattice ` K ` when ` -. X .<_ W ` , given
       auxiliary atom ` Q ` .  (Contributed by NM, 26-Sep-2014.) $)
    dihvalcq2 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
      /\ ( ( Q e. A /\ -. Q .<_ W ) /\ Q .<_ X ) )
        -> ( I ` X ) = ( ( I ` Q ) .(+) ( I ` ( X ./\ W ) ) ) ) $=
      ( chlt wcel wa wbr wn w3a cfv cdic co cdib wceq simp1 simp2 simp3l simp3r
      wb lhpmcvr3 syl3anc mpbid eqid dihvalcq syl112anc dihvalcqat syl2anc clat
      simp1l hllat simp2l simp1r lhpbase latmcl latmle2 dihvalb syl12anc eqtr4d
      syl oveq12d ) IUCUDZLFUDZUEZMBUDZMLJUFUGZUEZDAUDDLJUFUGUEZDMJUFZUEZUHZMGU
      IZDLIUJUIUIZUIZMLKUKZLIULUIUIZUIZCUKZDGUIZWMGUIZCUKWIWBWEWFDWMHUKMUMZWJWP
      UMWBWEWHUNZWBWEWHUOZWBWEWFWGUPZWIWGWSWBWEWFWGUQWIWBWEWFWGWSURWTXAXBABDFHI
      JKLMNOPQRSUSUTVAABWKWNCDEFGHIJKLMNOPQRSTWNVBZWKVBZUAUBVCVDWIWQWLWRWOCWIWB
      WFWQWLUMWTXBADFGWKIJLORSXDTVEVFWIWBWMBUDZWMLJUFZWRWOUMWTWIIVGUDZWCLBUDZXE
      WIVTXGVTWAWEWHVHIVIVRZWBWCWDWHVJZWIWAXHVTWAWEWHVKBFILNSVLVRZBIKMLNQVMUTWI
      XGWCXHXFXIXJXKBIJKMLNOQVNUTBWNFGIJUCLWMNOSTXCVOVPVSVQ $.
  $}

  ${
    $d w x y z .+ $.  $d w x y z .\/ $.  $d g w x y z .<_ $.  $d w x y z ./\ $.
    $d g w x y z A $.  $d w x y z C $.  $d w x y z F $.  $d g P $.  $d x y V $.
    $d a b w x y z E $.  $d w x y z G $.  $d g h w x y z H $.  $d w x y z N $.
    $d a b g h w x y z K $.  $d w x y z R $.  $d w x y z S $.  $d w x y z X $.
    $d h w x y z B $.  $d a b g h w x y z T $.  $d a b g h w x y z W $.
    $d g w x y z Q $.  $d w x y z Z $.
    dihopelvalcp.b $e |- B = ( Base ` K ) $.
    dihopelvalcp.l $e |- .<_ = ( le ` K ) $.
    dihopelvalcp.j $e |- .\/ = ( join ` K ) $.
    dihopelvalcp.m $e |- ./\ = ( meet ` K ) $.
    dihopelvalcp.a $e |- A = ( Atoms ` K ) $.
    dihopelvalcp.h $e |- H = ( LHyp ` K ) $.
    dihopelvalcp.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihopelvalcp.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihopelvalcp.r $e |- R = ( ( trL ` K ) ` W ) $.
    dihopelvalcp.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihopelvalcp.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihopelvalcp.g $e |- G = ( iota_ g e. T ( g ` P ) = Q ) $.
    dihopelvalcp.f $e |- F e. _V $.
    dihopelvalcp.s $e |- S e. _V $.

    ${
      dihopelvalcp.z $e |- Z = ( h e. T |-> ( _I |` B ) ) $.
      dihopelvalcp.n $e |- N = ( ( DIsoB ` K ) ` W ) $.
      dihopelvalcp.c $e |- C = ( ( DIsoC ` K ) ` W ) $.
      dihopelvalcp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
      dihopelvalcp.d $e |- .+ = ( +g ` U ) $.
      dihopelvalcp.v $e |- V = ( LSubSp ` U ) $.
      dihopelvalcp.y $e |- .(+) = ( LSSum ` U ) $.
      dihopelvalcp.o $e |- O = ( a e. E , b e. E |-> ( h e. T
        |-> ( ( a ` h ) o. ( b ` h ) ) ) ) $.
      $( Member of value of isomorphism H for a lattice ` K ` when
         ` -. X .<_ W ` , given auxiliary atom ` Q ` .  TODO: refactor to be
         shorter and more understandable; add lemmas?  (Contributed by NM,
         13-Mar-2014.) $)
      dihopelvalcpre $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( X e. B /\ -. X .<_ W )
         /\ ( ( Q e. A /\ -. Q .<_ W ) /\ ( Q .\/ ( X ./\ W ) ) = X ) )
  -> ( <. F , S >. e. ( I ` X )
    <-> ( ( F e. T /\ S e. E ) /\ ( R ` ( F o. `' ( S ` G ) ) ) .<_ X ) ) ) $=
        ( vx vy vz vw chlt wcel wa wbr wn co wceq w3a cop cfv wex ccnv dihvalcq
        cv ccom eleq2d wb simp3l diclss syl2anc syl syl3anc syl12anc vex anbi1d
        simp1 simpl1 simprll simprlr simpl3l tendocl eqeltrd simprrr eqid eqtrd
        adantl eqeq2d anbi2d bitrd pm5.32da fveq1d eqtr4d eqcomd wf1o ltrn1o wf
        coass coeq1d ad2antrl f1of 3syl eqtr2d simprrl ltrnco ltrncom jca jca31
        simpll1 adantr 3bitrd fvex cvv eqeltri biidd simp1l hllat simp2l simp1r
        clat lhpbase latmcl latmle2 diblss dicopelval2 dibopelval3 anbi12d csca
        dvhopellsm cplusg lhpocnel2 ltrniotacl dvhopvadd syl122anc oveqd opeq2d
        tendo0cl dvhfplusr opth oveq2d tendo0plr syl5bb simplll simpllr adantrr
        cid cres f1ococnv1 fcoi2 ltrncnv 3eqtr4a simplrr pm4.71rd simpl1l trlcl
        simpl2l simpl1r lattrd eqeltrrd simprr trlle latlem12 syl13anc mpbi2and
        latmle1 coeq2d fcoi1 syl6eqr coeq12d impbida syl6bbr 4exbidv cnvex coex
        ex df-3an cmpt cltrn mptex eleq1 fveq2 breq1d ceqsex4v syl6bb ) TVQVRZU
        FQVRZVSZUGBVRZUGUFUAVTWAZVSZGAVRGUFUAVTWAVSZGUGUFUBWBZSWBUGWCZVSZWDZOIW
        EZUGRWFZVRUYAGCWFZUXQUCWFZFWBZVRZVMWJZVNWJZWEZUYCVRZVOWJZVPWJZWEZUYDVRZ
        VSZUYAUYIUYMEWBZWCZVSZVPWGVOWGVNWGVMWGZOJVRZINVRZVSZOPIWFZWHZWKZHWFZUGU
        AVTZVSZUXTUYBUYEUYAABCUCFGKQRSTUAUBUFUGUKULUMUNUOUPVAVFVGVHVKWIWLUXTUXL
        UYCUEVRZUYDUEVRZUYFUYSWMUXLUXOUXSXBZUXTUXLUXPVUIVUKUXLUXOUXPUXRWNZAGUEK
        QCTUAUFULUOUPVHVGVJWOWPUXTUXLUXQBVRZUXQUFUAVTZVUJVUKUXTTUUEVRZUXMUFBVRZ
        VUMUXTUXJVUOUXJUXKUXOUXSUUATUUBZWQZUXLUXMUXNUXSUUCZUXTUXKVUPUXJUXKUXOUX
        SUUDBQTUFUKUPUUFZWQZBTUBUGUFUKUNUUGZWRZUXTVUOUXMVUPVUNVURVUSVVABTUAUBUG
        UFUKULUNUUHWRZBUEKQUCTUAUFUXQUKULUPVHVFVJUUIWSVMVNVOVPEFUEIKOQTUFUYCUYD
        UPVHVIVJVKUUNWRUXTUYSUYGVUCWCZUYHIWCZVSZUYKVUEWCZUYLUHWCZVSZUYTUYHNVRZV
        SZUYKHWFZUGUAVTZVSZWDZVPWGVOWGVNWGVMWGVUHUXTUYRVVPVMVNVOVPUXTUYRUYGPUYH
        WFZWCZVVKVSZUYKJVRZVVMUXQUAVTZVSZVVIVSZVSZUYQVSZVVGVVJVSZVWDOUYGUYKWKZW
        CZIUYHWCZVSZVSZVSZVVPUXTUYOVWDUYQUXTUYJVVSUYNVWCUXTUXLUXPUYJVVSWMVUKVUL
        ADGUYHJLNUYGPQCTUAVQUFULUOUPUQURUTVGVBVMWTVNWTUUJWPUXTUXLVUMVUNUYNVWCWM
        VUKVVCVVDBHUYLJMUYKQUCTUAVQUFUXQUHUKULUPURUSVEVFUUKWSUULXAUXTVWEVWKVWLU
        XTVWDUYQVWJUXTVWDVSZUYQUYAVWGUYHUYLUDWBZWEZWCZVWJVWMUYPVWOUYAVWMUYPVWGU
        YHUYLKUUMWFZUUOWFZWBZWEZVWOVWMUXLUYGJVRZVVKVVTUYLNVRUYPVWTWCUXLUXOUXSVW
        DXCZVWMUYGVVQJUXTVVRVVKVWCXDVWMUXLVVKPJVRZVVQJVRZVXBUXTVVRVVKVWCXEZVWMU
        XLDAVRDUFUAVTWAVSZUXPVXCVXBVWMUXLVXFVXBADQTUAUFULUOUPUQUUPZWQUXPUXRUXLU
        XOVWDXFADGJLPQTUAUFULUOUPURVBUUQZWRZUYHJNPQTVQUFUPURUTXGZWRXHVXEVWDVVTU
        XTVVSVVTVWAVVIXDZXLVWMUYLUHNUXTVVSVWBVVIXIZVWMUXLUHNVRVXBBJMNQTUHUFUKUP
        URUTVEUVBWQXHVWQEVWRUYHUYLJKNUYGUYKQTUFUPURUTVHVWQXJZVIVWRXJZUURUUSVWMV
        WSVWNVWGVWMVWRUDUYHUYLVWMUXLVWRUDWCVXBUJUDVWRJKMNVWQQTVQUFUIUPURUTVHVXM
        VLVXNUVCWQUUTUVAXKXMVWPVWHIVWNWCZVSVWMVWJOIVWGVWNVCVDUVDVWMVXOVWIVWHVWM
        VWNUYHIVWMVWNUYHUHUDWBZUYHVWMUYLUHUYHUDVXLUVEVWMUXLVVKVXPUYHWCVXBVXEUJB
        UDUYHJMNQTUHUFUIUKUPURUTVEVLUVFWPXKXMXNUVGXOXPUXTVWKVWFUXTVWKVWFUXTVWKV
        SZVVEVVFVVJVXQUYGVVQVUCVWKVVRUXTVVRVVKVWCVWJUVHZXLVXQPIUYHUXTVWDVWHVWIX
        IZXQXRZVXQIUYHVXSXSVXQVVHVVIVXQVUDVUCWKZUYKWKZVUDVUCUYKWKZWKZUYKVUEVUDV
        UCUYKYCVXQVYBUVKBUVLZUYKWKZUYKVXQVYAVYEUYKVXQBBVUCXTZVYAVYEWCZVXQUXLVUC
        JVRZVYGUXLUXOUXSVWKXCZVXQUXLVUAVXCVYIVYJVXQIUYHNVXSVWKVVKUXTVVRVVKVWCVW
        JUVIZXLXHUXTVWDVXCVWJVXIUVJIJNPQTVQUFUPURUTXGZWRZBJVUCQTVQUFUKUPURYAZWP
        BBVUCUVMZWQYDVXQBBUYKXTZBBUYKYBVYFUYKWCVXQUXLVVTVYPVYJVWDVVTUXTVWJVXKYE
        ZBJUYKQTVQUFUKUPURYAWPBBUYKYFBBUYKUVNYGYHVXQVUEVYCVUDWKZVYDVXQOVYCVUDVX
        QOVWGVYCUXTVWDVWHVWIYIVXQUYGVUCUYKVXTYDXKYDVXQUXLVUDJVRZVYCJVRZVYDVYRWC
        VYJVXQUXLVYIVYSVYJVYMJVUCQTUFUPURUVOZWPVXQUXLVYIVVTVYTVYJVYMVYQJVUCUYKQ
        TUFUPURYJWRJVUDVYCQTUFUPURYKWRXRUVPVWKVVIUXTVVSVWBVVIVWJUVQXLYLYMUWTUVR
        XOUXTVWLVWFVVOVSVVPUXTVWFVWKVVOUXTVWFVSZVWKVVOWUBVWKVSZUYTVVKVVNWUCOVWG
        JWUBVWDVWHVWIYIWUCUXLVXAVVTVWGJVRUXLUXOUXSVWFVWKYNZWUCUYGVVQJVWKVVRWUBV
        XRXLWUCUXLVVKVXCVXDWUDVWKVVKWUBVYKXLZWUCUXLVXFUXPVXCWUDWUCUXLVXFWUDVXGW
        QWUBUXPVWKUXPUXRUXLUXOVWFXFZYOVXHWRVXJWRXHVWDVVTWUBVWJVXKYEZJUYGUYKQTUF
        UPURYJWRXHWUEWUCBTUAVVMUXQUGUKULWUCUXJVUOWUBUXJVWKUXJUXKUXOUXSVWFUVSZYO
        VUQWQZWUCUXLVVTVVMBVRZWUDWUGBHJUYKQTUFUKUPURUSUVTZWPWUCVUOUXMVUPVUMWUIW
        UBUXMVWKUXMUXNUXLUXSVWFUWAZYOZWUCUXKVUPWUBUXKVWKUXJUXKUXOUXSVWFUWBZYOVU
        TWQZVVBWRWUMVWDVWAWUBVWJVVSVVTVWAVVIXEYEWUCVUOUXMVUPUXQUGUAVTWUIWUMWUOB
        TUAUBUGUFUKULUNUWJWRUWCYMWUBVVOVSZVVSVWCVWJWUPVVRVVKWUPUYGVUCVVQWUBVVEV
        VOUXTVVEVVFVVJXDYOZWUPPUYHIWUBVVFVVOUXTVVEVVFVVJXEYOZXQXRWUBUYTVVKVVNXE
        ZYLWUPVVTVWAVVIWUPUYKVUEJWUBVVHVVOUXTVVGVVHVVIYIYOZWUPUXLUYTVYSVUEJVRZU
        XLUXOUXSVWFVVOYNZWUBUYTVVKVVNXDZWUPUXLVYIVYSWVBWUPUXLVUAVXCVYIWVBWUPUYH
        INWURWUSUWDWUPUXLVXFUXPVXCWVBWUPUXLVXFWVBVXGWQWUBUXPVVOWUFYOVXHWRVYLWRZ
        WUAWPJOVUDQTUFUPURYJWRZXHZWUPVVNVVMUFUAVTZVWAWUBVVLVVNUWEWUPUXLVVTWVGWV
        BWVFHJUYKQTUAUFULUPURUSUWFWPWUPVUOWUJUXMVUPVVNWVGVSVWAWMWUPUXJVUOWUBUXJ
        VVOWUHYOVUQWQWUPUXLVVTWUJWVBWVFWUKWPWUBUXMVVOWULYOWUPUXKVUPWUBUXKVVOWUN
        YOVUTWQBTUAUBVVMUGUFUKULUNUWGUWHUWIWUBVVIVVOUXTVVGVVHVVIXIYOYMWUPVWHVWI
        WUPOVUCVUEWKZVWGWUPOVUEVUCWKZWVHWUPOOVYAWKZWVIWUPWVJOVYEWKZOWUPVYAVYEOW
        UPVYGVYHWUPUXLVYIVYGWVBWVDVYNWPVYOWQUWKWUPBBOXTZBBOYBWVKOWCWUPUXLUYTWVL
        WVBWVCBJOQTVQUFUKUPURYAWPBBOYFBBOUWLYGYHOVUDVUCYCUWMWUPUXLVYIWVAWVHWVIW
        CWVBWVDWVEJVUCVUEQTUFUPURYKWRXRWUPUYGVUCUYKVUEWUQWUTUWNXRWUPUYHIWURXSYL
        YMUWOXPVVGVVJVVOUXAUWPYPUWQVVOVVOVUBVVNVSVUHVUHVMVNVOVPVUCIVUEUHPIYQZVD
        OVUDVCVUCWVMUWRUWSUHMJVYEUXBYRVEMJVYEJUFTUXCWFZWFYRURUFWVNYQYSUXDYSVVEV
        VOYTVVFVVLVUBVVNVVFVVKVUAUYTUYHINUXEXNXAVVHVVNVUGVUBVVHVVMVUFUGUAUYKVUE
        HUXFUXGXNVVIVUHYTUXHUXIYP $.
    $}

    $( Member of value of isomorphism H for a lattice ` K ` when
       ` -. X .<_ W ` , given auxiliary atom ` Q ` .  (Contributed by NM,
       13-Mar-2014.) $)
    dihopelvalc $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( X e. B /\ -. X .<_ W )
        /\ ( ( Q e. A /\ -. Q .<_ W ) /\ ( Q .\/ ( X ./\ W ) ) = X ) )
  -> ( <. F , S >. e. ( I ` X )
    <-> ( ( F e. T /\ S e. E ) /\ ( R ` ( F o. `' ( S ` G ) ) ) .<_ X ) ) ) $=
      ( vh va vb cdic cfv cdvh cplusg clsm cdib cv ccom cmpt clss cid cres eqid
      cmpt2 dihopelvalcpre ) ABROUQURURZCROUSURURZUTURZVMVAURZDEFGVMHUNIJKLMNOP
      QROVBURURZUOUPIIUNGUNVCZUOVCURVQUPVCURVDVEVJZVMVFURZRSUNGVGBVHVEZUOUPTUAU
      BUCUDUEUFUGUHUIUJUKULUMVTVIVPVIVLVIVMVIVNVIVSVIVOVIVRVIVK $.
  $}

  ${
    dihlss.b $e |- B = ( Base ` K ) $.
    dihlss.h $e |- H = ( LHyp ` K ) $.
    dihlss.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihlss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihlss.s $e |- S = ( LSubSp ` U ) $.
    $( The value of isomorphism H is a subspace.  (Contributed by NM,
       6-Mar-2014.) $)
    dihlss $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B )
      -> ( I ` X ) e. S ) $=
      ( chlt wcel wa cple cfv eqid anassrs wbr cdib dihvalb diblss eqeltrd catm
      wn cdic clsm cjn cmee dihlsscpre pm2.61dan ) FNOGDOPZHAOZPHGFQRZUAZHERZBO
      ZUNUOUQUSUNUOUQPPURHGFUBRRZRBAUTDEFUPNGHIUPSZJKUTSZUCABCDUTFUPGHIVAJLVBMU
      DUETUNUOUQUGUSFUFRZAGFUHRRZUTCUIRZBCDEFUJRZFUPFUKRZGHIVAVFSVGSVCSJKVBVDSL
      MVESULTUM $.
  $}

  ${
    dihss.b $e |- B = ( Base ` K ) $.
    dihss.h $e |- H = ( LHyp ` K ) $.
    dihss.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihss.v $e |- V = ( Base ` U ) $.
    $( The value of isomorphism H is a set of vectors.  (Contributed by NM,
       14-Mar-2014.) $)
    dihss $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B )
         -> ( I ` X ) C_ V ) $=
      ( chlt wcel wa cfv clss wss eqid dihlss lssss syl ) ENOGCOPHAOPHDQZBRQZOU
      DFSAUEBCDEGHIJKLUETZUAUEUDFBMUFUBUC $.
  $}

  ${
    dihssxp.b $e |- B = ( Base ` K ) $.
    dihssxp.h $e |- H = ( LHyp ` K ) $.
    dihssxp.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihssxp.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihssxp.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihssxp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihssxp.x $e |- ( ph -> X e. B ) $.
    $( An isomorphism H value is included in the vector space (expressed as
       ` T X. E ` ).  (Contributed by NM, 26-Sep-2014.) $)
    dihssxp $p |- ( ph -> ( I ` X ) C_ ( T X. E ) ) $=
      ( cfv chlt wcel eqid cdvh cbs cxp wss dihss syl2anc wceq dvhvbase sseqtrd
      wa syl ) AIFQZHGUAQQZUBQZCDUCZAGRSHESUJZIBSULUNUDOPBUMEFGUNHIJKNUMTZUNTZU
      EUFAUPUNUOUGOCUMDEGUNHRKLMUQURUHUKUI $.
  $}

  ${
    dihopcl.b $e |- B = ( Base ` K ) $.
    dihopcl.h $e |- H = ( LHyp ` K ) $.
    dihopcl.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihopcl.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihopcl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihopcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihopcl.x $e |- ( ph -> X e. B ) $.
    dihopcl.y $e |- ( ph -> <. F , S >. e. ( I ` X ) ) $.
    $( Closure of an ordered pair (vector) member of a value of isomorphism H.
       (Contributed by NM, 26-Sep-2014.) $)
    dihopcl $p |- ( ph -> ( F e. T /\ S e. E ) ) $=
      ( wcel cop cxp wa cfv dihssxp sseldd opelxp sylib ) AFCUAZDEUBZTFDTCETUCA
      KHUDUJUIABDEGHIJKLMNOPQRUESUFFCDEUGUH $.
  $}

  ${
    $d s t E $.  $d g h t u F $.  $d f g t H $.  $d g h t u I $.
    $d f g s t K $.  $d g h t u S $.  $d g h t u U $.  $d f g s t W $.
    $d g h t u X $.  $d g h t u Y $.  $d g h t u ph $.
    xihopellsm.b $e |- B = ( Base ` K ) $.
    xihopellsm.h $e |- H = ( LHyp ` K ) $.
    xihopellsm.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    xihopellsm.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    xihopellsm.a $e |- A = ( s e. E , t e. E |-> ( f e. T |-> ( ( s ` f ) o.
         ( t ` f ) ) ) ) $.
    xihopellsm.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    xihopellsm.l $e |- L = ( LSubSp ` U ) $.
    xihopellsm.p $e |- .(+) = ( LSSum ` U ) $.
    xihopellsm.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    xihopellsm.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    xihopellsm.x $e |- ( ph -> X e. B ) $.
    xihopellsm.y $e |- ( ph -> Y e. B ) $.
    $( Ordered pair membership in a subspace sum of isomorphism H values.
       (Contributed by NM, 26-Sep-2014.)  (New usage is discouraged.) $)
    xihopellsmN $p |- ( ph
  -> ( <. F , S >. e. ( ( I ` X ) .(+) ( I ` Y ) ) <-> E. g E. t E. h E. u
        ( ( <. g , t >. e. ( I ` X ) /\ <. h , u >. e. ( I ` Y ) )
           /\ ( F = ( g o. h ) /\ S = ( t A u ) ) ) ) ) $=
      ( cop cfv co wcel cv wa cplusg wceq ccom chlt clss wb eqid dihlss syl2anc
      dvhopellsm syl3anc adantr simpr anim12dan simprl simprr dvhopvadd2 eqeq2d
      wex dihopcl vex coex ovex opth2 syl6bb syldan pm5.32da 4exbidv bitrd ) AN
      GUOZTPUPZUAPUPZFUQURZKUSZCUSZUOZWKURZLUSZBUSZUOZWLURZUTZWJWPWTIVAUPZUQZVB
      ZUTZBVSLVSCVSKVSZXBNWNWRVCZVBGWOWSDUQZVBUTZUTZBVSLVSCVSKVSAQVDURSOURUTZWK
      IVEUPZURZWLXMURZWMXGVFULAXLTEURZXNULUMEXMIOPQSTUCUDUKUHXMVGZVHVIAXLUAEURZ
      XOULUNEXMIOPQSUAUCUDUKUHXQVHVIKCLBXCFXMGINOQSWKWLUDUHXCVGZXQUJVJVKAXFXKKC
      LBAXBXEXJAXBWNHURWOMURUTZWRHURWSMURUTZUTZXEXJVFAWQXTXAYAAWQUTEWOHMWNOPQST
      UCUDUEUFUKAXLWQULVLAXPWQUMVLAWQVMVTAXAUTEWSHMWROPQSUAUCUDUEUFUKAXLXAULVLA
      XRXAUNVLAXAVMVTVNAYBUTZXEWJXHXIUOZVBXJYCXDYDWJYCXLXTYAXDYDVBAXLYBULVLAXTY
      AVOAXTYAVPCDXCWOWSHIJMWNWROQSUBUDUEUFUGUHXSVQVKVRNGXHXIWNWRKWALWAWBWOWSDW
      CWDWEWFWGWHWI $.
  $}

  ${
    $d v w E $.  $d g h t u F $.  $d g i t H $.  $d g h t u I $.
    $d g i t v w K $.  $d g h t u S $.  $d g h t u U $.  $d g i t v w W $.
    $d g h t u X $.  $d g h t u Y $.  $d g h t u ph $.
    dihopellsm.b $e |- B = ( Base ` K ) $.
    dihopellsm.h $e |- H = ( LHyp ` K ) $.
    dihopellsm.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihopellsm.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihopellsm.a $e |- A = ( v e. E , w e. E |-> ( i e. T |-> ( ( v ` i ) o.
         ( w ` i ) ) ) ) $.
    dihopellsm.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihopellsm.l $e |- L = ( LSubSp ` U ) $.
    dihopellsm.p $e |- .(+) = ( LSSum ` U ) $.
    dihopellsm.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihopellsm.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihopellsm.x $e |- ( ph -> X e. B ) $.
    dihopellsm.y $e |- ( ph -> Y e. B ) $.
    $( Ordered pair membership in a subspace sum of isomorphism H values.
       (Contributed by NM, 26-Sep-2014.) $)
    dihopellsm $p |- ( ph
  -> ( <. F , S >. e. ( ( I ` X ) .(+) ( I ` Y ) ) <-> E. g E. t E. h E. u
        ( ( <. g , t >. e. ( I ` X ) /\ <. h , u >. e. ( I ` Y ) )
           /\ ( F = ( g o. h ) /\ S = ( t A u ) ) ) ) ) $=
      ( cop cfv co wcel cv wa cplusg wceq ccom chlt clss wb eqid dihlss syl2anc
      dvhopellsm syl3anc adantr simpr anim12dan simprl simprr dvhopvadd2 eqeq2d
      wex dihopcl vex coex ovex opth2 syl6bb syldan pm5.32da 4exbidv bitrd ) AP
      IUPZUBRUQZUCRUQZHURUSZLUTZEUTZUPZWLUSZMUTZDUTZUPZWMUSZVAZWKWQXAKVBUQZURZV
      CZVAZDVTMVTEVTLVTZXCPWOWSVDZVCIWPWTFURZVCVAZVAZDVTMVTEVTLVTASVEUSUAQUSVAZ
      WLKVFUQZUSZWMXNUSZWNXHVGUMAXMUBGUSZXOUMUNGXNKQRSUAUBUDUEULUIXNVHZVIVJAXMU
      CGUSZXPUMUOGXNKQRSUAUCUDUEULUIXRVIVJLEMDXDHXNIKPQSUAWLWMUEUIXDVHZXRUKVKVL
      AXGXLLEMDAXCXFXKAXCWOJUSWPOUSVAZWSJUSWTOUSVAZVAZXFXKVGAWRYAXBYBAWRVAGWPJO
      WOQRSUAUBUDUEUFUGULAXMWRUMVMAXQWRUNVMAWRVNWAAXBVAGWTJOWSQRSUAUCUDUEUFUGUL
      AXMXBUMVMAXSXBUOVMAXBVNWAVOAYCVAZXFWKXIXJUPZVCXKYDXEYEWKYDXMYAYBXEYEVCAXM
      YCUMVMAYAYBVPAYAYBVQBFXDWPWTJKNOWOWSQSUACUEUFUGUHUIXTVRVLVSPIXIXJWOWSLWBM
      WBWCWPWTFWDWEWFWGWHWIWJ $.
  $}

  ${
    $d q .<_ $.  $d q A $.  $d h q B $.  $d q H $.  $d q I $.  $d h q K $.
    $d q O $.  $d h q T $.  $d h q W $.  $d q X $.  $d q Y $.
    dihord6apre.b $e |- B = ( Base ` K ) $.
    dihord6apre.l $e |- .<_ = ( le ` K ) $.
    dihord6apre.a $e |- A = ( Atoms ` K ) $.
    dihord6apre.h $e |- H = ( LHyp ` K ) $.
    dihord6apre.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihord6apre.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dihord6apre.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihord6apre.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihord6apre.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihord6apre.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihord6apre.s $e |- .(+) = ( LSSum ` U ) $.
    dihord6apre.g $e |- G = ( iota_ h e. T ( h ` P ) = q ) $.
    $( Part of proof that isomorphism H is order-preserving .  (Contributed by
       NM, 7-Mar-2014.) $)
    dihord6apre $p |- ( ( ( ( K e. HL /\ W e. H )
        /\ ( X e. B /\ -. X .<_ W )
   /\ ( Y e. B /\ Y .<_ W ) ) /\ ( I ` X ) C_ ( I ` Y ) ) -> X .<_ Y ) $=
      ( chlt wcel wa wbr wn w3a cfv wss cid cres wceq tendo1ne0 3ad2ant1 neneqd
      wne cv cmee co cjn wrex wi eqid lhpmcvr2 3adant3 cdic simpl1 simpl2 simpr
      cdib dihvalcq syl3anc simpl3 dihvalb syl2anc sseq12d csubg clss lsssssubg
      clmod dvhlmod syl simprl diclss sseldd clat simpl1l hllat simpl2l simpl1r
      lhpbase latmcl latmle2 diblss syl12anc lsmub1 sstr cop eqidd tendoidcl wb
      fvex cvv cltrn eqeltri ax-mp dicopelval2 mpbir2and ssel2 cdia dibopelval2
      resiexg syl6bi syl5 mpan2d mpand sylbid exp44 imp4a rexlimdv mtod pm2.21d
      mpd imp ) LUKULZOJULZUMZPBULZPOMUNUOZUMZQBULQOMUNUMZUPZPKUQZQKUQZURZPQMUN
      ZUUAUUDUUEUUAUUDUSEUTZNVAZUUAUUFNYPYSUUFNVEYTBEGHJLNOSUBUEUFUDVBVCVDUUARV
      FZOMUNUOZUUHPOLVGUQZVHZLVIUQZVHPVAZUMZRAVJZUUDUUGVKZYPYSUUOYTABJUULLMUUJO
      PRSTUULVLZUUJVLZUAUBVMVNUUAUUNUUPRAUUAUUHAULZUUIUUMUUPUUAUUSUUIUUMUUPUUAU
      USUUIUMZUUMUMZUMZUUDUUHOLVOUQUQZUQZUUKOLVSUQUQZUQZDVHZQUVEUQZURZUUGUVBUUB
      UVGUUCUVHUVBYPYSUVAUUBUVGVAYPYSYTUVAVPZYPYSYTUVAVQUUAUVAVRABUVCUVEDUUHFJK
      UULLMUUJOPSTUUQUURUAUBUGUVEVLZUVCVLZUHUIVTWAUVBYPYTUUCUVHVAUVJYPYSYTUVAWB
      ZBUVEJKLMUKOQSTUBUGUVKWCWDWEUVBUVDUVGURZUVIUUGUVBUVDFWFUQZULUVFUVOULUVNUV
      BFWGUQZUVOUVDUVBFWIULUVPUVOURUVBFJLOUBUHUVJWJUVPFUVPVLZWHWKZUVBYPUUTUVDUV
      PULUVJUUAUUTUUMWLZAUUHUVPFJUVCLMOTUAUBUHUVLUVQWMWDWNUVBUVPUVOUVFUVRUVBYPU
      UKBULZUUKOMUNZUVFUVPULUVJUVBLWOULZYQOBULZUVTUVBYNUWBYNYOYSYTUVAWPLWQWKZYQ
      YRYPYTUVAWRZUVBYOUWCYNYOYSYTUVAWSBJLOSUBWTWKZBLUUJPOSUURXAWAUVBUWBYQUWCUW
      AUWDUWEUWFBLMUUJPOSTUURXBWABUVPFJUVELMOUUKSTUBUHUVKUVQXCXDWNDUVDUVFFUIXEW
      DUVNUVIUMUVDUVHURZUVBUUGUVDUVGUVHXFUVBUWGIUUFUQZUUFXGZUVDULZUUGUVBUWJUWHU
      WHVAZUUFHULZUVBUWHXHUVBYPUWLUVJEHJLOUBUEUFXIWKUVBYPUUTUWJUWKUWLUMXJUVJUVS
      ACUUHUUFEGHUWHIJUVCLMUKOTUAUBUCUEUFUVLUJIUUFXKEXLULUUFXLULEOLXMUQZUQXLUEO
      UWMXKXNEXLYAXOXPWDXQUWGUWJUMUWIUVHULZUVBUUGUVDUVHUWIXRUVBUWNUWHQOLXSUQUQZ
      UQULZUUGUMZUUGUVBYPYTUWNUWQXJUVJUVMBUUFEGUWHJUVEUWOLMUKOQNSTUBUEUDUWOVLUV
      KXTWDUWPUUGVRYBYCYDYCYEYFYGYHYIYLYJYKYM $.
  $}

  ${
    dihord3.b $e |- B = ( Base ` K ) $.
    dihord3.l $e |- .<_ = ( le ` K ) $.
    dihord3.h $e |- H = ( LHyp ` K ) $.
    dihord3.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The isomorphism H for a lattice ` K ` is order-preserving in the region
       under co-atom ` W ` .  (Contributed by NM, 6-Mar-2014.) $)
    dihord3 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
   /\ ( Y e. B /\ Y .<_ W ) ) -> ( ( I ` X ) C_ ( I ` Y ) <-> X .<_ Y ) ) $=
      ( chlt wcel wa wbr cfv wss wceq dihvalb cdib eqid 3adant3 3adant2 sseq12d
      w3a dibord bitrd ) DMNFBNOZGANGFEPOZHANHFEPOZUFZGCQZHCQZRGFDUAQQZQZHUOQZR
      GHEPULUMUPUNUQUIUJUMUPSUKAUOBCDEMFGIJKLUOUBZTUCUIUKUNUQSUJAUOBCDEMFHIJKLU
      RTUDUEABUODEFGHIJKURUGUH $.

    $d q r .<_ $.  $d q r B $.  $d q r H $.  $d q r I $.  $d q r K $.
    $d q r W $.  $d q r X $.  $d q r Y $.
    $( The isomorphism H for a lattice ` K ` is order-preserving in the region
       not under co-atom ` W ` .  TODO: reformat q e.  A /\ -. q .<_ W to
       eliminate adant*.  (Contributed by NM, 6-Mar-2014.) $)
    dihord4 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
     /\ ( Y e. B /\ -. Y .<_ W ) )
   -> ( ( I ` X ) C_ ( I ` Y ) <-> X .<_ Y ) ) $=
      ( vq vr wcel wa cfv co eqid adantr chlt wbr wn w3a cv cmee wceq catm wrex
      cjn wss wb lhpmcvr2 3adant3 3adant2 reeanv sylanbrc cdic cdib cdvh simp11
      clsm simp12 simp2l simp3ll jca simp3lr dihvalcq syl112anc simp3rl simp3rr
      sseq12d simpl11 simpl2l simpl2r simp12l simp13l dihord2 syl323anc dihord1
      simp13 simp2r simpr impbida bitrd 3exp rexlimdvv mpd ) DUAOFBOPZGAOZGFEUB
      UCZPZHAOZHFEUBUCZPZUDZMUEZFEUBUCZWQGFDUFQZRZDUJQZRGUGZPZNUEZFEUBUCZXDHFWS
      RZXARHUGZPZPZNDUHQZUIMXJUIZGCQZHCQZUKZGHEUBZULZWPXCMXJUIZXHNXJUIZXKWIWLXQ
      WOXJABXADEWSFGMIJXASZWSSZXJSZKUMUNWIWOXRWLXJABXADEWSFHNIJXSXTYAKUMUOXCXHM
      NXJXJUPUQWPXIXPMNXJXJWPWQXJOZXDXJOZPZXIXPWPYDXIUDZXNWQFDURQQZQWTFDUSQQZQF
      DUTQQZVBQZRZXDYFQXFYGQYIRZUKZXOYEXLYJXMYKYEWIWLYBWRPZXBXLYJUGWIWLWOYDXIVA
      ZWIWLWOYDXIVCYEYBWRWPYBYCXIVDWRXBXHWPYDVEZVFWRXBXHWPYDVGZXJAYFYGYIWQYHBCX
      ADEWSFGIJXSXTYAKLYGSZYFSZYHSZYISZVHVIYEWIWOYCXEPZXGXMYKUGYNWIWLWOYDXIWAYE
      YCXEWPYBYCXIWBXEXGXCWPYDVJZVFXEXGXCWPYDVKZXJAYFYGYIXDYHBCXADEWSFHIJXSXTYA
      KLYQYRYSYTVHVIVLYEYLXOYEYLPZWIYMUUAWJWMXBXGYLXOWIWLWOYDXIYLVMUUDYBWRYBYCW
      PXIYLVNYEWRYLYOTVFUUDYCXEYBYCWPXIYLVOYEXEYLUUBTVFYEWJYLWJWKWIWOYDXIVPZTYE
      WMYLWMWNWIWLYDXIVQZTYEXBYLYPTYEXGYLUUCTYEYLWCXJAYIWQYHBYGYFXADEWSXDFGHIJX
      SXTYAKYQYRYSYTVRVSYEXOPZWIYMUUAWJWMXBXGXOYLWIWLWOYDXIXOVMUUGYBWRYBYCWPXIX
      OVNYEWRXOYOTVFUUGYCXEYBYCWPXIXOVOYEXEXOUUBTVFYEWJXOUUETYEWMXOUUFTYEXBXOYP
      TYEXGXOUUCTYEXOWCXJAYIWQXDYHBYGYFXADEWSFGHIJXSXTYAKYQYRYSYTVTVSWDWEWFWGWH
      $.

    $( Part of proof that isomorphism H is order-preserving.  TODO: eliminate
       3ad2ant1; combine w/ other way to have one lhpmcvr2 (Contributed by NM,
       7-Mar-2014.) $)
    dihord5b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
   /\ ( Y e. B /\ -. Y .<_ W ) ) /\ X .<_ Y ) -> ( I ` X ) C_ ( I ` Y ) ) $=
      ( vr wcel wa wbr cfv wss eqid 3ad2ant1 chlt wn w3a cv cmee wceq catm wrex
      co cjn simpl1 simpl3 lhpmcvr2 syl2anc wi cdib cdic cdvh clsm simpl2r clat
      simp1r wb simpl1l hllat simpl2l simpl3l simpl1r lhpbase latlem12 syl13anc
      syl mpbi2and simp1l1 simp1l2 latmcl syl3anc dibord syl112anc mpbird csubg
      latmle2 clss clmod dvhlmod lsssssubg diclss sseldd diblss syl12anc lsmub2
      simp2 sstrd dihvalb simp1l3 simp3 dihvalcq 3exp exp3a imp4a rexlimdv mpd
      3sstr4d ) DUANZFBNZOZGANZGFEPZOZHANZHFEPUBZOZUCZGHEPZOZMUDZFEPUBZXPHFDUEQ
      ZUIZDUJQZUIHUFZOZMDUGQZUHZGCQZHCQZRZXOXFXLYDXFXIXLXNUKXFXIXLXNULYCABXTDEX
      RFHMIJXTSZXRSZYCSZKUMUNXOYBYGMYCXOXPYCNZXQYAYGXOYKXQYAYGUOXOYKXQOZYAYGXOY
      LYAUCZGFDUPQQZQZXPFDUQQQZQZXSYNQZFDURQQZUSQZUIZYEYFYMYOYRUUAYMYOYRRZGXSEP
      ZYMXNXHUUCXMXNYLYAVBXOYLXHYAXGXHXFXLXNUTTYMDVANZXGXJFANZXNXHOUUCVCYMXDUUD
      XOYLXDYAXDXEXIXLXNVDTDVEVLZXOYLXGYAXGXHXFXLXNVFTXOYLXJYAXJXKXFXIXNVGTZYMX
      EUUEXOYLXEYAXDXEXIXLXNVHTABDFIKVIVLZADEXRGHFIJYIVJVKVMYMXFXIXSANZXSFEPZUU
      BUUCVCXFXIXLXNYLYAVNZXFXIXLXNYLYAVOZYMUUDXJUUEUUIUUFUUGUUHADXRHFIYIVPVQZY
      MUUDXJUUEUUJUUFUUGUUHADEXRHFIJYIWBVQZABYNDEFGXSIJKYNSZVRVSVTYMYQYSWAQZNYR
      UUPNYRUUARYMYSWCQZUUPYQYMYSWDNUUQUUPRYMYSBDFKYSSZUUKWEUUQYSUUQSZWFVLZYMXF
      YLYQUUQNUUKXOYLYAWLZYCXPUUQYSBYPDEFJYJKUURYPSZUUSWGUNWHYMUUQUUPYRUUTYMXFU
      UIUUJYRUUQNUUKUUMUUNAUUQYSBYNDEFXSIJKUURUUOUUSWIWJWHYTYQYRYSYTSZWKUNWMYMX
      FXIYEYOUFUUKUULAYNBCDEUAFGIJKLUUOWNUNYMXFXLYLYAYFUUAUFUUKXFXIXLXNYLYAWOUV
      AXOYLYAWPYCAYPYNYTXPYSBCXTDEXRFHIJYHYIYJKLUUOUVBUURUVCWQVSXCWRWSWTXAXB $.

    $( Part of proof that isomorphism H is order-preserving .  (Contributed by
       NM, 7-Mar-2014.) $)
    dihord6b $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
   /\ ( Y e. B /\ Y .<_ W ) ) /\ X .<_ Y ) -> ( I ` X ) C_ ( I ` Y ) ) $=
      ( chlt wcel wa wbr wn w3a cfv syl wss simp2r simp3r clat wi simp1l simp2l
      hllat simp3l simp1r lhpbase lattr syl13anc mpan2d mtod pm2.21d imp ) DMNZ
      FBNZOZGANZGFEPZQZOZHANZHFEPZOZRZGHEPZGCSHCSUAZVHVIVJVHVIVBUTVAVCVGUBVHVIV
      FVBUTVDVEVFUCVHDUDNZVAVEFANZVIVFOVBUEVHURVKURUSVDVGUFDUHTUTVAVCVGUGUTVDVE
      VFUIVHUSVLURUSVDVGUJABDFIKUKTADEGHFIJULUMUNUOUPUQ $.

    $d h B $.  $d h q K $.  $d h W $.
    $( Part of proof that isomorphism H is order-preserving .  (Contributed by
       NM, 7-Mar-2014.) $)
    dihord6a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W )
   /\ ( Y e. B /\ Y .<_ W ) ) /\ ( I ` X ) C_ ( I ` Y ) ) -> X .<_ Y ) $=
      ( vh vq catm cfv coc cdvh cv eqid clsm cltrn ctendo wceq crio dihord6apre
      cid cres cmpt ) DOPZAFDQPPZFDRPPZUAPZFDUBPPZULMFDUCPPZUKMSPNSUDMUNUEZBCDE
      MUNUGAUHUIZFGHNIJUJTKUKTUQTUNTUOTLULTUMTUPTUF $.
  $}

  ${
    $d r ./\ $.  $d r .<_ $.  $d r A $.  $d r B $.  $d r H $.  $d r I $.
    $d r K $.  $d r W $.  $d r X $.  $d r Y $.
    dihord5apre.b $e |- B = ( Base ` K ) $.
    dihord5apre.l $e |- .<_ = ( le ` K ) $.
    dihord5apre.h $e |- H = ( LHyp ` K ) $.
    dihord5apre.j $e |- .\/ = ( join ` K ) $.
    dihord5apre.m $e |- ./\ = ( meet ` K ) $.
    dihord5apre.a $e |- A = ( Atoms ` K ) $.
    dihord5apre.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihord5apre.s $e |- .(+) = ( LSSum ` U ) $.
    dihord5apre.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Part of proof that isomorphism H is order-preserving .  (Contributed by
       NM, 7-Mar-2014.) $)
    dihord5apre $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
   /\ ( Y e. B /\ -. Y .<_ W ) ) /\ ( I ` X ) C_ ( I ` Y ) ) -> X .<_ Y ) $=
      ( vr chlt wcel wa wbr wn w3a cfv wss cv wceq wrex simpl1 lhpmcvr2 syl2anc
      co simpl3 simp11l hllat syl simp12l simp3ll atbase latjcl syl3anc simp13l
      clat latlej2 cdic cdib simp11 simp3lr latlej1 wi simp11r lhpbase syl13anc
      lattr mpand mtod simp3l simp12 lhple oveq2d eqid dihvalcq syl122anc csubg
      clss clmod dvhlmod lsssssubg diclss sseldd latmcl latmle2 diblss syl12anc
      lsmub1 simp13 simp3r syl112anc fveq2d dihvalb eqtr4d simp2 eqsstrd dihlss
      sseqtr4d wb lsmlub mpbi2and dihord4 syl121anc mpbid lattrd exp4c rexlimdv
      3expia imp4a mpd ) HUDUEZKEUEZUFZLBUEZLKIUGZUFZMBUEZMKIUGUHZUFZUIZLFUJZMF
      UJZUKZUFZUCULZKIUGZUHZYRMKJURZGURMUMZUFZUCAUNZLMIUGZYQYFYLUUDYFYIYLYPUOYF
      YIYLYPUSABEGHIJKMUCNOQRSPUPUQYQUUCUUEUCAYQYRAUEZYTUUBUUEYQUUFYTUUBUUEYMYP
      UUFYTUFZUUBUFZUUEYMYPUUHUIZBHILYRLGURZMNOUUIYDHVIUEZYDYEYIYLYPUUHUTHVAVBZ
      YGYHYFYLYPUUHVCZUUIUUKYRBUEZYGUUJBUEZUULUUIUUFUUNUUFYTUUBYMYPVDABYRHNSVEV
      BZUUMBGHYRLNQVFVGZYJYKYFYIYPUUHVHZUUIUUKUUNYGLUUJIUGUULUUPUUMBGHIYRLNOQVJ
      VGUUIUUJFUJZYOUKZUUJMIUGZUUIUUSYRKHVKUJUJZUJZUUJKJURZKHVLUJUJZUJZCURZYOUU
      IYFUUOUUJKIUGZUHZUUGYRUVDGURUUJUMUUSUVGUMYFYIYLYPUUHVMZUUQUUIUVHYSUUFYTUU
      BYMYPVNUUIYRUUJIUGZUVHYSUUIUUKUUNYGUVKUULUUPUUMBGHIYRLNOQVOVGUUIUUKUUNUUO
      KBUEZUVKUVHUFYSVPUULUUPUUQUUIYEUVLYDYEYIYLYPUUHVQBEHKNPVRVBZBHIYRUUJKNOVT
      VSWAWBZYMYPUUGUUBWCZUUIUVDLYRGUUIYFUUGYIUVDLUMUVJUVOYFYIYLYPUUHWDZABYREGH
      IJKLNOQRSPWEVGZWFABUVBUVECYRDEFGHIJKUUJNOQRSPUBUVEWGZUVBWGZTUAWHWIUUIUVCY
      OUKZUVFYOUKZUVGYOUKZUUIUVCUVCUUAUVEUJZCURZYOUUIUVCDWJUJZUEZUWCUWEUEUVCUWD
      UKUUIDWKUJZUWEUVCUUIDWLUEUWGUWEUKUUIDEHKPTUVJWMUWGDUWGWGZWNVBZUUIYFUUGUVC
      UWGUEUVJUVOAYRUWGDEUVBHIKOSPTUVSUWHWOUQWPZUUIUWGUWEUWCUWIUUIYFUUABUEZUUAK
      IUGZUWCUWGUEUVJUUIUUKYJUVLUWKUULUURUVMBHJMKNRWQVGUUIUUKYJUVLUWLUULUURUVMB
      HIJMKNORWRVGBUWGDEUVEHIKUUANOPTUVRUWHWSWTWPCUVCUWCDUAXAUQUUIYFYLUUGUUBYOU
      WDUMUVJYFYIYLYPUUHXBZUVOYMYPUUGUUBXCABUVBUVECYRDEFGHIJKMNOQRSPUBUVRUVSTUA
      WHXDXKUUIUVFYNYOUUIUVFLUVEUJZYNUUIUVDLUVEUVQXEUUIYFYIYNUWNUMUVJUVPBUVEEFH
      IUDKLNOPUBUVRXFUQXGYMYPUUHXHXIUUIUWFUVFUWEUEYOUWEUEUVTUWAUFUWBXLUWJUUIUWG
      UWEUVFUWIUUIYFUVDBUEZUVDKIUGZUVFUWGUEUVJUUIUUKUUOUVLUWOUULUUQUVMBHJUUJKNR
      WQVGUUIUUKUUOUVLUWPUULUUQUVMBHIJUUJKNORWRVGBUWGDEUVEHIKUVDNOPTUVRUWHWSWTW
      PUUIUWGUWEYOUWIUUIYFYJYOUWGUEUVJUURBUWGDEFHKMNPUBTUWHXJUQWPCUVCUVFYODUAXM
      VGXNXIUUIYFUUOUVIYLUUTUVAXLUVJUUQUVNUWMBEFHIKUUJMNOPUBXOXPXQXRYAXSYBXTYC
      $.
  $}

  ${
    dihord.b $e |- B = ( Base ` K ) $.
    dihord.l $e |- .<_ = ( le ` K ) $.
    dihord.h $e |- H = ( LHyp ` K ) $.
    dihord.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Part of proof that isomorphism H is order-preserving .  (Contributed by
       NM, 7-Mar-2014.) $)
    dihord5a $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ X .<_ W )
   /\ ( Y e. B /\ -. Y .<_ W ) ) /\ ( I ` X ) C_ ( I ` Y ) ) -> X .<_ Y ) $=
      ( catm cfv cdvh clsm cjn cmee eqid dihord5apre ) DMNZAFDONNZPNZUBBCDQNZDE
      DRNZFGHIJKUDSUESUASUBSUCSLT $.

    $( The isomorphism H is order-preserving.  Part of proof after Lemma N of
       [Crawley] p. 122 line 6.  (Contributed by NM, 7-Mar-2014.) $)
    dihord $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
            -> ( ( I ` X ) C_ ( I ` Y ) <-> X .<_ Y ) ) $=
      ( wcel wa simpl1 simpl2 simprl simpl3 simprr syl122anc w3a wbr cfv wss wb
      dihord3 wn dihord5a dihord5b impbida dihord6a dihord6b dihord4 4casesdan
      chlt ) DUOMFBMNZGAMZHAMZUAZGFEUBZHFEUBZGCUCHCUCUDZGHEUBZUEZUSUTVANZNUPUQU
      TURVAVDUPUQURVEOUPUQURVEPUSUTVAQUPUQURVERUSUTVASABCDEFGHIJKLUFTUSUTVAUGZN
      ZNUPUQUTURVFVDUPUQURVGOUPUQURVGPUSUTVFQUPUQURVGRUSUTVFSUPUQUTNURVFNUAVBVC
      ABCDEFGHIJKLUHABCDEFGHIJKLUIUJTUSUTUGZVANZNUPUQVHURVAVDUPUQURVIOUPUQURVIP
      USVHVAQUPUQURVIRUSVHVASUPUQVHNURVANUAVBVCABCDEFGHIJKLUKABCDEFGHIJKLULUJTU
      SVHVFNZNUPUQVHURVFVDUPUQURVJOUPUQURVJPUSVHVFQUPUQURVJRUSVHVFSABCDEFGHIJKL
      UMTUN $.
  $}

  ${
    dih11.b $e |- B = ( Base ` K ) $.
    dih11.h $e |- H = ( LHyp ` K ) $.
    dih11.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The isomorphism H is one-to-one.  Part of proof after Lemma N of
       [Crawley] p. 122 line 6.  (Contributed by NM, 7-Mar-2014.) $)
    dih11 $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
              -> ( ( I ` X ) = ( I ` Y ) <-> X = Y ) ) $=
      ( cfv wceq wss wa chlt wcel w3a wbr dihord wb eqss cple eqid anbi12d clat
      3com23 simp1l hllat syl latasymb syld3an1 bitrd syl5bb ) FCKZGCKZLUNUOMZU
      OUNMZNZDOPZEBPZNZFAPZGAPZQZFGLZUNUOUAVDURFGDUBKZRZGFVFRZNZVEVDUPVGUQVHABC
      DVFEFGHVFUCZIJSVAVCVBUQVHTABCDVFEGFHVJIJSUFUDDUEPZVBVAVCVIVETVDUSVKUSUTVB
      VCUGDUHUIADVFFGHVJUJUKULUM $.
  $}

  ${
    $d x y B $.  $d x y H $.  $d x y I $.  $d q u x y K $.  $d u y S $.
    $d q u x y W $.
    dihf11.b $e |- B = ( Base ` K ) $.
    dihf11.h $e |- H = ( LHyp ` K ) $.
    dihf11.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihf11.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihf11.s $e |- S = ( LSubSp ` U ) $.
    $( Functionality of the isomorphism H. (Contributed by NM, 6-Mar-2014.) $)
    dihf11lem $p |- ( ( K e. HL /\ W e. H ) -> I : B --> S ) $=
      ( vx vq vu vy wcel cv cfv eqid chlt wa wfn crn wss wf cple wbr cdib wn co
      cmee cjn wceq cdic clsm wi catm wral crio cif cmpt cvv fvex riotaex rgenw
      ifex mptfng sylib dihfval fneq1d mpbird dihlss ralrimiva fnfvrnss syl2anc
      a1i df-f sylanbrc ) FUAQGDQUBZEAUCZEUDBUEZABEUFVTWAMAMRZGFUGSZUHZWCGFUISS
      ZSZNRZGWDUHUJWHWCGFULSZUKZFUMSZUKWCUNUBORWHGFUOSSZSWJWFSCUPSZUKUNUQNFURSZ
      USZOBUTZVAZVBZAUCZVTWQVCQZMAUSZWSXAVTWTMAWEWGWPWCWFVDWOOBVEVGVFVQMAWQWRWR
      TVHVIVTAEWRMOWNAWLWFWMBCDEWKFWDWIUAGNHWDTWKTWITWNTIJWFTWLTKLWMTVJVKVLZVTW
      APRZESBQZPAUSWBXBVTXDPAABCDEFGXCHIJKLVMVNPABEVOVPABEVRVS $.

    $( The isomorphism H for a lattice ` K ` is a one-to-one function. .  Part
       of proof after Lemma N of [Crawley] p. 122 line 6.  (Contributed by NM,
       7-Mar-2014.) $)
    dihf11 $p |- ( ( K e. HL /\ W e. H ) -> I : B -1-1-> S ) $=
      ( vx vy chlt wcel wa cv cfv wral wf weq wi wf1 dihf11lem w3a dih11 biimpd
      wceq 3expb ralrimivva dff13 sylanbrc ) FOPGDPQZABEUAMRZESNRZESUIZMNUBZUCZ
      NATMATABEUDABCDEFGHIJKLUEUNUSMNAAUNUOAPZUPAPZUSUNUTVAUFUQURADEFGUOUPHIJUG
      UHUJUKMNABEULUM $.
  $}

  ${
    dihfn.b $e |- B = ( Base ` K ) $.
    dihfn.h $e |- H = ( LHyp ` K ) $.
    dihfn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Functionality and domain of isomorphism H. (Contributed by NM,
       9-Mar-2014.) $)
    dihfn $p |- ( ( K e. HL /\ W e. H ) -> I Fn B ) $=
      ( chlt wcel wa cdvh cfv clss wf1 wfn eqid dihf11 f1fn syl ) DIJEBJKAEDLMM
      ZNMZCOCAPAUBUABCDEFGHUAQUBQRAUBCST $.

    $( Domain of isomorphism H. (Contributed by NM, 9-Mar-2014.) $)
    dihdm $p |- ( ( K e. HL /\ W e. H ) -> dom I = B ) $=
      ( chlt wcel wa wfn cdm wceq dihfn fndm syl ) DIJEBJKCALCMANABCDEFGHOACPQ
      $.

    $( Closure of isomorphism H. (Contributed by NM, 8-Mar-2014.) $)
    dihcl $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B )
            -> ( I ` X ) e. ran I ) $=
      ( chlt wcel wa wfn cfv crn cdvh clss wf1 eqid dihf11 adantr f1fn fnfvelrn
      syl sylancom ) DJKEBKLZFAKZCAMZFCNCOKUFUGLAEDPNNZQNZCRZUHUFUKUGAUJUIBCDEG
      HIUISUJSTUAAUJCUBUDAFCUCUE $.

    $( Closure of isomorphism H converse.  (Contributed by NM, 8-Mar-2014.) $)
    dihcnvcl $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
            -> ( `' I ` X ) e. B ) $=
      ( chlt wcel wa crn wf1o ccnv cfv cdvh clss wf1 eqid dihf11 f1ocnvdm sylan
      f1f1orn syl ) DJKEBKLZACMZCNZFUGKFCOPAKUFAEDQPPZRPZCSUHAUJUIBCDEGHIUITUJT
      UAAUJCUDUEAUGFCUBUC $.
  $}

  ${
    dihcnvid1.b $e |- B = ( Base ` K ) $.
    dihcnvid1.h $e |- H = ( LHyp ` K ) $.
    dihcnvid1.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The converse isomorphism of an isomorphism.  (Contributed by NM,
       5-Aug-2014.) $)
    dihcnvid1 $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B )
            -> ( `' I ` ( I ` X ) ) = X ) $=
      ( chlt wcel wa crn wf1o cfv ccnv wceq cdvh clss eqid wf1 dihf11 f1ocnvfv1
      f1f1orn syl sylan ) DJKEBKLZACMZCNZFAKFCOCPOFQUGAEDROOZSOZCUAUIAUKUJBCDEG
      HIUJTUKTUBAUKCUDUEAUHFCUCUF $.
  $}

  ${
    dihcnvid2.h $e |- H = ( LHyp ` K ) $.
    dihcnvid2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The isomorphism of a converse isomorphism.  (Contributed by NM,
       5-Aug-2014.) $)
    dihcnvid2 $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
            -> ( I ` ( `' I ` X ) ) = X ) $=
      ( chlt wcel wa cbs cfv crn wf1o ccnv wceq cdvh clss wf1 eqid dihf11 sylan
      f1f1orn syl f1ocnvfv2 ) CHIDAIJZCKLZBMZBNZEUHIEBOLBLEPUFUGDCQLLZRLZBSUIUG
      UKUJABCDUGTFGUJTUKTUAUGUKBUCUDUGUHEBUEUB $.
  $}

  ${
    dihcnvord.l $e |- .<_ = ( le ` K ) $.
    dihcnvord.h $e |- H = ( LHyp ` K ) $.
    dihcnvord.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihcnvord.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihcnvord.x $e |- ( ph -> X e. ran I ) $.
    dihcnvord.y $e |- ( ph -> Y e. ran I ) $.
    $( Ordering property for converse of isomorphism H. (Contributed by NM,
       17-Aug-2014.) $)
    dihcnvord $p |- ( ph -> ( ( `' I ` X ) .<_ ( `' I ` Y ) <-> X C_ Y ) ) $=
      ( cfv wss wcel dihcnvcl syl2anc wceq ccnv wbr chlt wa cbs crn eqid dihord
      wb syl3anc dihcnvid2 sseq12d bitr3d ) AGCUAZOZCOZHUNOZCOZPZUOUQEUBZGHPADU
      CQFBQUDZUODUEOZQZUQVBQZUSUTUILAVAGCUFZQZVCLMVBBCDFGVBUGZJKRSAVAHVEQZVDLNV
      BBCDFHVGJKRSVBBCDEFUOUQVGIJKUHUJAUPGURHAVAVFUPGTLMBCDFGJKUKSAVAVHURHTLNBC
      DFHJKUKSULUM $.
  $}

  ${
    dihcnv11.h $e |- H = ( LHyp ` K ) $.
    dihcnv11.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihcnv11.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihcnv11.x $e |- ( ph -> X e. ran I ) $.
    dihcnv11.y $e |- ( ph -> Y e. ran I ) $.
    $( The converse of isomorphism H is one-to-one.  (Contributed by NM,
       17-Aug-2014.) $)
    dihcnv11 $p |- ( ph -> ( ( `' I ` X ) = ( `' I ` Y ) <-> X = Y ) ) $=
      ( ccnv cfv wceq chlt wcel dihcnvcl syl2anc dihcnvid2 wa cbs wb eqid dih11
      crn syl3anc eqeq12d bitr3d ) AFCMZNZCNZGUJNZCNZOZUKUMOZFGOADPQEBQUAZUKDUB
      NZQZUMURQZUOUPUCJAUQFCUFZQZUSJKURBCDEFURUDZHIRSAUQGVAQZUTJLURBCDEGVCHIRSU
      RBCDEUKUMVCHIUEUGAULFUNGAUQVBULFOJKBCDEFHITSAUQVDUNGOJLBCDEGHITSUHUI $.
  $}

  ${
    $d x H $.  $d x I $.  $d x K $.  $d x S $.  $d x W $.
    dihsslss.h $e |- H = ( LHyp ` K ) $.
    dihsslss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihsslss.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihsslss.s $e |- S = ( LSubSp ` U ) $.
    $( The isomorphism H maps to subspaces.  (Contributed by NM,
       14-Mar-2014.) $)
    dihsslss $p |- ( ( K e. HL /\ W e. H ) -> ran I C_ S ) $=
      ( vx chlt wcel wa crn cv ccnv cfv dihcnvid2 cbs dihcnvcl dihlss syldan ex
      eqid eqeltrrd ssrdv ) ELMFCMNZKDOZAUHKPZUIMZUJAMUHUKNUJDQRZDRZUJACDEFUJGI
      SUHUKULETRZMUMAMUNCDEFUJUNUEZGIUAUNABCDEFULUOGIHJUBUCUFUDUG $.

    $( The isomorphism H maps to subspaces.  (Contributed by NM,
       14-Mar-2014.) $)
    dihrnlss $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
           -> X e. S ) $=
      ( chlt wcel wa crn dihsslss sselda ) ELMFCMNDOAGABCDEFHIJKPQ $.
  $}

  ${
    dihrnss.h $e |- H = ( LHyp ` K ) $.
    dihrnss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihrnss.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihrnss.v $e |- V = ( Base ` U ) $.
    $( The isomorphism H maps to a set of vectors.  (Contributed by NM,
       14-Mar-2014.) $)
    dihrnss $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I ) -> X C_ V ) $=
      ( chlt wcel wa crn clss cfv wss eqid dihrnlss lssss syl ) DLMFBMNGCOMNGAP
      QZMGERUCABCDFGHIJUCSZTUCGEAKUDUAUB $.
  $}

  ${
    dihvalrel.h $e |- H = ( LHyp ` K ) $.
    dihvalrel.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The value of isomorphism H is a relation.  (Contributed by NM,
       9-Mar-2014.) $)
    dihvalrel $p |- ( ( K e. HL /\ W e. H ) -> Rel ( I ` X ) ) $=
      ( chlt wcel wa cdm cfv wrel cbs eqid dihdm eleq2d cvv cxp c0 cltrn ctendo
      wss cdvh wceq dvhvbase adantr sseqtrd xpss syl6ss df-rel sylibr ex sylbid
      dihss wn rel0 ndmfv releqd mpbiri pm2.61d1 ) CHIDAIJZEBKZIZEBLZMZVBVDECNL
      ZIZVFVBVCVGEVGABCDVGOZFGPQVBVHVFVBVHJZVERRSZUCVFVJVEDCUALLZDCUBLLZSZVKVJV
      EDCUDLLZNLZVNVGVOABCVPDEVIFGVOOZVPOZUOVBVPVNUEVHVLVOVMACVPDHFVLOVMOVQVRUF
      UGUHVLVMUIUJVEUKULUMUNVDUPZVFTMUQVSVETEBURUSUTVA $.
  $}

  ${
    dih0.z $e |- .0. = ( 0. ` K ) $.
    dih0.h $e |- H = ( LHyp ` K ) $.
    dih0.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih0.o $e |- O = ( 0g ` U ) $.
    $( The value of isomorphism H at the lattice zero is the singleton of the
       zero vector i.e. the zero subspace.  (Contributed by NM, 9-Mar-2014.) $)
    dih0 $p |- ( ( K e. HL /\ W e. H ) -> ( I ` .0. ) = { O } ) $=
      ( chlt wcel wa cfv cdib csn cbs eqid cple wbr wceq cops hlop adantr op0cl
      id syl lhpbase op0le syl2an dihvalb syl12anc dib0 eqtrd ) DMNZFBNZOZGCPZG
      FDQPPZPZERUSUSGDSPZNZGFDUAPZUBZUTVBUCUSUHUSDUDNZVDUQVGURDUEZUFVCDGVCTZHUG
      UIUQVGFVCNVFURVHVCBDFVIIUJVCDVEFGVIVETZHUKULVCVABCDVEMFGVIVJIJVATZUMUNABV
      ADEFGHIVKKLUOUP $.
  $}

  ${
    dih0b.b $e |- B = ( Base ` K ) $.
    dih0b.h $e |- H = ( LHyp ` K ) $.
    dih0b.o $e |- .0. = ( 0. ` K ) $.
    dih0b.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih0b.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih0b.z $e |- Z = ( 0g ` U ) $.
    dih0b.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dih0b.x $e |- ( ph -> X e. B ) $.
    $( A lattice element is zero iff its isomorphism is the zero subspace.
       (Contributed by NM, 16-Aug-2014.)  (New usage is discouraged.) $)
    dih0bN $p |- ( ph -> ( X = .0. <-> ( I ` X ) = { Z } ) ) $=
      ( wceq wcel cfv chlt wa wb cops simpld hlop op0cl 3syl dih11 syl3anc dih0
      csn syl eqeq2d bitr3d ) AHEUAZIEUAZSZHISZUQJUMZSAFUBTZGDTZUCZHBTIBTZUSUTU
      DQRAVBFUETVEAVBVCQUFFUGBFIKMUHUIBDEFGHIKLNUJUKAURVAUQAVDURVASQCDEFJGIMLNO
      PULUNUOUP $.
  $}

  ${
    dih0vb.h $e |- H = ( LHyp ` K ) $.
    dih0vb.o $e |- .0. = ( 0. ` K ) $.
    dih0vb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih0vb.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih0vb.v $e |- V = ( Base ` U ) $.
    dih0vb.z $e |- Z = ( 0g ` U ) $.
    dih0vb.n $e |- N = ( LSpan ` U ) $.
    dih0vb.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dih0vb.x $e |- ( ph -> X e. V ) $.
    $( A vector is zero iff its span is the isomorphism of lattice zero.
       (Contributed by NM, 16-Aug-2014.)  (New usage is discouraged.) $)
    dih0vbN $p |- ( ph -> ( X = Z <-> ( N ` { X } ) = ( I ` .0. ) ) ) $=
      ( csn cfv wceq chlt wcel wa dih0 eqeq2d clmod wb dvhlmod lspsneq0 syl2anc
      syl bitr2d ) AIUAFUBZJDUBZUCUPKUAZUCZIKUCZAUQURUPAEUDUEHCUEUFUQURUCSBCDEK
      HJMLNOQUGUNUHABUIUEIGUEUSUTUJABCEHLOSUKTFGBIKPQRULUMUO $.
  $}

  ${
    dih0cnv.h $e |- H = ( LHyp ` K ) $.
    dih0cnv.o $e |- .0. = ( 0. ` K ) $.
    dih0cnv.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih0cnv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih0cnv.z $e |- Z = ( 0g ` U ) $.
    $( The isomorphism H converse value of the zero subspace is the lattice
       zero.  (Contributed by NM, 19-Jun-2014.) $)
    dih0cnv $p |- ( ( K e. HL /\ W e. H ) -> ( `' I ` { Z } ) = .0. ) $=
      ( chlt wcel wa cfv ccnv csn dih0 fveq2d cbs wceq hlatl adantr eqid atl0cl
      cal syl dihcnvid1 mpdan eqtr3d ) DMNZEBNZOZFCPZCQZPZGRZUPPFUNUOURUPABCDGE
      FIHJKLSTUNFDUAPZNZUQFUBUNDUGNZUTULVAUMDUCUDUSDFUSUEZIUFUHUSBCDEFVBHJUIUJU
      K $.
  $}

  ${
    dih0rn.h $e |- H = ( LHyp ` K ) $.
    dih0rn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih0rn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih0rn.o $e |- .0. = ( 0g ` U ) $.
    $( The zero subspace belongs to the range of isomorphism H. (Contributed by
       NM, 27-Apr-2014.) $)
    dih0rn $p |- ( ( K e. HL /\ W e. H ) -> { .0. } e. ran I ) $=
      ( chlt wcel wa cp0 cfv csn crn eqid dih0 cbs dihfn cops hlop adantr op0cl
      wfn syl fnfvelrn syl2anc eqeltrrd ) DKLZEBLZMZDNOZCOZFPCQZABCDFEUNUNRZGHI
      JSUMCDTOZUFUNURLZUOUPLURBCDEURRZGHUAUMDUBLZUSUKVAULDUCUDURDUNUTUQUEUGURUN
      CUHUIUJ $.
  $}

  ${
    dih0sb.h $e |- H = ( LHyp ` K ) $.
    dih0sb.o $e |- .0. = ( 0. ` K ) $.
    dih0sb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih0sb.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih0sb.v $e |- V = ( Base ` U ) $.
    dih0sb.z $e |- Z = ( 0g ` U ) $.
    dih0sb.n $e |- N = ( LSpan ` U ) $.
    dih0sb.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dih0sb.x $e |- ( ph -> X e. ran I ) $.
    $( A subspace is zero iff the converse of its isomorphism is lattice zero.
       (Contributed by NM, 17-Aug-2014.) $)
    dih0sb $p |- ( ph -> ( X = { Z } <-> ( `' I ` X ) = .0. ) ) $=
      ( ccnv cfv csn wceq chlt wa crn dih0rn syl dihcnv11 dih0cnv eqeq2d bitr3d
      wcel ) AIDUAZUBZKUCZUOUBZUDIUQUDUPJUDACDEHIUQLNSTAEUEUNHCUNUFZUQDUGUNSBCD
      EHKLNOQUHUIUJAURJUPAUSURJUDSBCDEHJKLMNOQUKUIULUM $.
  $}

  ${
    $d f g s H $.  $d f s I $.  $d f g s K $.  $d f s .1. $.  $d f s V $.
    $d f g s W $.
    dih1.m $e |- .1. = ( 1. ` K ) $.
    dih1.h $e |- H = ( LHyp ` K ) $.
    dih1.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1.v $e |- V = ( Base ` U ) $.
    $( The value of isomorphism H at the lattice unit is the set of all
       vectors.  (Contributed by NM, 13-Mar-2014.) $)
    dih1 $p |- ( ( K e. HL /\ W e. H ) -> ( I ` .1. ) = V ) $=
      ( vg chlt wcel wa cfv wceq eqid wbr vf vs wrel dihvalrel cltrn ctendo cxp
      relxp dvhvbase releqd mpbiri id coc crio ccnv ccom ctrl cple cop cops cbs
      hlop ad2antrr simpl simprl simprr catm lhpocnel adantr ltrniotacl syl3anc
      cv wn tendocl ltrncnv syldan ltrnco trlcl ople1 syl2anc ex pm4.71d eleq2d
      opelxp syl6bb cmee co cjn op1cl syl cpo ccvr hlpos lhpbase adantl lhp1cvr
      wb cvrnle syl31anc col hlol olm12 syl2an oveq2d clat hllat opoccl latjcom
      opexmid 3eqtrd vex dihopelvalc syl122anc 3bitr4rd eqrelrdv2 syl21anc ) EN
      OZGCOZPZBDQZUCFUCZXSXTFRCDEGBIJUDXSYAGEUEQQZGEUFQQZUGZUCYBYCUHXSFYDYBAYCC
      EFGNIYBSZYCSZKLUIZUJUKXSULZXSUAUBXTFXSUAVLZYBOZUBVLZYCOZPZYMYIGEUMQZQZMVL
      QYORMYBUNZYKQZUOZUPZGEUQQQZQZBEURQZTZPZYIYKUSZFOZUUEXTOZXSYMUUCXSYMUUCXSY
      MPZEUTOZUUAEVAQZOZUUCXQUUIXRYMEVBZVCXSYMYSYBOZUUKUUHXSYJYRYBOZUUMXSYMVDZX
      SYJYLVEXSYMYQYBOZUUNUUHXSYLYPYBOZUUPUUOXSYJYLVFUUHXSYOEVGQZOYOGUUBTVMPZUU
      SUUQUUOXSUUSYMUURCEUUBYNGUUBSZYNSZUURSZIVHZVIZUVDUURYOYOYBMYPCEUUBGUUTUVB
      IYEYPSZVJVKYKYBYCYPCENGIYEYFVNVKYBYQCEGIYEVOVPYBYIYRCEGIYEVQVKUUJYTYBYSCE
      GUUJSZIYEYTSZVRVPUUJBEUUBUUAUVFUUTHVSVTWAWBXSUUFUUEYDOYMXSFYDUUEYGWCYIYKY
      BYCWDWEXSXSBUUJOZBGUUBTVMZUUSYOBGEWFQZWGZEWHQZWGZBRUUGUUDWQYHXSUUIUVHXQUU
      IXRUULVIUUJBEUVFHWIWJZXSEWKOZGUUJOZUVHGBEWLQZTUVIXQUVOXREWMVIXRUVPXQUUJCE
      GUVFIWNZWOZUVNNUVQBCEGHUVQSZIWPUUJUVQEUUBGBUVFUUTUVTWRWSUVCXSUVMYOGUVLWGZ
      GYOUVLWGZBXSUVKGYOUVLXQEWTOUVPUVKGRXREXAUVRUUJBEUVJGUVFUVJSZHXBXCXDXSEXEO
      ZYOUUJOZUVPUWAUWBRXQUWDXREXFVIXQUUIUVPUWEXRUULUVRUUJEYNGUVFUVAXGXCUVSUUJU
      VLEYOGUVFUVLSZXHVKXQUUIUVPUWBBRXRUULUVRUUJBUVLEYNGUVFUVAUWFHXIXCXJUURUUJY
      OYOYTYKYBMYCYIYPCDUVLEUUBUVJGBUVFUUTUWFUWCUVBIYOSYEUVGYFJUVEUAXKUBXKXLXMX
      NXOXP $.
  $}

  ${
    dih1rn.h $e |- H = ( LHyp ` K ) $.
    dih1rn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1rn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1rn.v $e |- V = ( Base ` U ) $.
    $( The full vector space belongs to the range of isomorphism H.
       (Contributed by NM, 19-Jun-2014.) $)
    dih1rn $p |- ( ( K e. HL /\ W e. H ) -> V e. ran I ) $=
      ( chlt wcel wa cp1 cfv crn eqid dih1 cbs cops hlop adantr op1cl syl dihcl
      mpdan eqeltrrd ) DKLZFBLZMZDNOZCOZECPZAUKBCDEFUKQZGHIJRUJUKDSOZLZULUMLUJD
      TLZUPUHUQUIDUAUBUOUKDUOQZUNUCUDUOBCDFUKURGHUEUFUG $.
  $}

  ${
    dih1cnv.h $e |- H = ( LHyp ` K ) $.
    dih1cnv.m $e |- .1. = ( 1. ` K ) $.
    dih1cnv.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1cnv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1cnv.v $e |- V = ( Base ` U ) $.
    $( The isomorphism H converse value of the full vector space is the lattice
       one.  (Contributed by NM, 19-Jun-2014.) $)
    dih1cnv $p |- ( ( K e. HL /\ W e. H ) -> ( `' I ` V ) = .1. ) $=
      ( chlt wcel wa cfv ccnv dih1 fveq2d cbs wceq cops hlop eqid syl dihcnvid1
      adantr op1cl mpdan eqtr3d ) EMNZGCNZOZBDPZDQZPZFUOPBUMUNFUOABCDEFGIHJKLRS
      UMBETPZNZUPBUAUMEUBNZURUKUSULEUCUGUQBEUQUDZIUHUEUQCDEGBUTHJUFUIUJ $.
  $}

  ${
    $d f g K $.  $d g T $.  $d f g W $.  $d g ph $.
    dihw.b $e |- B = ( Base ` K ) $.
    dihw.h $e |- H = ( LHyp ` K ) $.
    dihw.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihw.o $e |- .0. = ( f e. T |-> ( _I |` B ) ) $.
    dihw.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihw.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Value of isomorphism H at the fiducial hyperplane ` W ` .  (Contributed
       by NM, 25-Aug-2014.)  (New usage is discouraged.) $)
    dihwN $p |- ( ph -> ( I ` W ) = ( T X. { .0. } ) ) $=
      ( vg cfv chlt wcel wceq cdib cdia csn cxp wa cple wbr simprd lhpbase clat
      syl simpld hllat eqid latref syl2anc jca dihvalb dibval2 ctrl crab diaval
      cv wral trlle sylan ralrimiva rabid2 sylibr eqtr4d xpeq1d 3eqtrd ) AHFQZH
      HGUAQQZQZHHGUBQQZQZIUCZUDZCVRUDAGRSZHESZUEZHBSZHHGUFQZUGZUEZVMVOTOAWCWEAW
      AWCAVTWAOUHBEGHJKUIUKZAGUJSZWCWEAVTWHAVTWAOULGUMUKWGBGWDHJWDUNZUOUPUQZBVN
      EFGWDRHHJWIKNVNUNZURUPAWBWFVOVSTOWJBCDEVNVPGWDRHHIJWIKLMVPUNZWKUSUPAVQCVR
      AVQPVCZHGUTQQZQHWDUGZPCVAZCAWBWFVQWPTOWJBWNCPEVPGWDRHHJWIKLWNUNZWLVBUPAWO
      PCVDCWPTAWOPCAWBWMCSWOOWNCWMEGWDHWIKLWQVEVFVGWOPCVHVIVJVKVL $.
  $}

$(
  @{
    @d s .<_ @.  @d s E @.  @d g s F @.  @d g s H @.  @d g s K @.  @d g s R @.
    @d g s T @.  @d g s W @.
    dih1dim.l @e |- .<_ = ( le ` K ) @.
    dih1dim.h @e |- H = ( LHyp ` K ) @.
    dih1dim.t @e |- T = ( ( LTrn ` K ) ` W ) @.
    dih1dim.r @e |- R = ( ( trL ` K ) ` W ) @.
    dih1dim.e @e |- E = ( ( TEndo ` K ) ` W ) @.
    dih1dim.i @e |- I = ( ( DIsoH ` K ) ` W ) @.
    @( Two expressions for the 1-dimensional subspaces of  vector space
       A (when ` F ` is a nonzero vector i.e. non-identity translation).
       Remark after Lemma L in [Crawley] p. 120 line 21. @)
    dih1dim @p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( I ` ( R ` F ) ) = { g e. T | E. s e. E g = ( s ` F ) } ) @=
      ? @.
      @( [15-Oct-1013] @)
  @}

$)

$(
  @{
    @d s .<_ @.  @d s E @.  @d g s F @.  @d g s H @.  @d g s K @.  @d g s R @.
    @d g s T @.  @d g s W @.
    dia1dimx.l @e |- .<_ = ( le ` K ) @.
    dia1dimx.h @e |- H = ( LHyp ` K ) @.
    dia1dimx.t @e |- T = ( ( LTrn ` K ) ` W ) @.
    dia1dimx.r @e |- R = ( ( trL ` K ) ` W ) @.
    dia1dimx.e @e |- E = ( ( TEndo ` K ) ` W ) @.
    dia1dimx.i @e |- I = ( ( DIsoA ` K ) ` W ) @.
    @( Two expressions for the 1-dimensional subspaces of partial vector space
       A (when ` F ` is a nonzero vector i.e. non-identity translation).
       Remark after Lemma L in [Crawley] p. 120 line 21. @)
    dia1dimx @p |- ( ( ( K e. HL /\ W e. H ) /\ F e. T )
      -> ( I ` ( R ` F ) ) = { g e. T | E. s e. E g = ( s ` F ) } ) @=
?      @.
  @}
$)

  ${
    $d f q s ./\ $.  $d f h q s .<_ $.  $d h q A $.  $d f h q s B $.
    $d f h q s H $.  $d f q s I $.  $d f h q s K $.  $d h P $.  $d h T $.
    $d f h q s W $.  $d f q s X $.  $d f q s Y $.
    dihglblem5a.b $e |- B = ( Base ` K ) $.
    dihglblem5a.m $e |- ./\ = ( meet ` K ) $.
    dihglblem5a.h $e |- H = ( LHyp ` K ) $.
    dihglblem5a.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    ${
      dihglblem5a.l $e |- .<_ = ( le ` K ) $.
      dihglblem5a.j $e |- .\/ = ( join ` K ) $.
      dihglblem5a.a $e |- A = ( Atoms ` K ) $.
      dihglblem5a.p $e |- P = ( ( oc ` K ) ` W ) $.
      dihglblem5a.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      dihglblem5a.r $e |- R = ( ( trL ` K ) ` W ) $.
      dihglblem5a.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      dihglblem5a.g $e |- G = ( iota_ h e. T ( h ` P ) = q ) $.
      dihglblem5a.o $e |- .0. = ( h e. T |-> ( _I |` B ) ) $.
      $( Isomorphism H of a conjunction.  (Contributed by NM, 21-Mar-2014.)
         (New usage is discouraged.) $)
      dihmeetlem1N $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( X e. B /\ -. X .<_ W ) /\ ( Y e. B /\ Y .<_ W ) )
         -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
        ( vf vs chlt wcel wa wbr wn w3a co cfv cin wss clat simp1l hllat simp2l
        simp3l latmle1 syl3anc wb simp1 latmcl dihord mpbird latmle2 ssind wrel
        syl dihvalrel relin1 3ad2ant1 cv cop elin wceq wi wrex lhpmcvr2 3adant3
        ccnv simpl1 simpl2 simprl simprrl jca simprrr vex dihopelvalc syl112anc
        ccom simpr syl6bi simpl3 dihopelvalbN syl2anc simprll 3ad2ant3 cid cres
        biimpd simp3rr fveq1d simp11 lhpocnel2 simp2rl ltrniotacl tendo02 eqtrd
        cnveqd cnvresid syl6eq coeq2d wf1o wf ltrn1o f1of fcoi1 fveq2d eqbrtrrd
        3syl simprlr simp11l trlcl simp12l simp13l latlem12 syl13anc mpbi2and
        simp11r lhpbase simp13r lattrd syl12anc mpbir2and 3expia syl2and syl5bi
        rexlimddv relssdv eqssd ) LUOUPZOIUPZUQZPBUPZPOMURUSZUQZQBUPZQOMURZUQZU
        TZPQNVAZJVBZPJVBZQJVBZVCZUVBUVDUVEUVFUVBUVDUVEVDZUVCPMURZUVBLVEUPZUUPUU
        SUVIUVBUUMUVJUUMUUNUURUVAVFLVGZVTZUUOUUPUUQUVAVHZUUOUURUUSUUTVIZBLMNPQT
        UDUAVJVKUVBUUOUVCBUPZUUPUVHUVIVLUUOUURUVAVMZUVBUVJUUPUUSUVOUVLUVMUVNBLN
        PQTUAVNZVKZUVMBIJLMOUVCPTUDUBUCVOVKVPUVBUVDUVFVDZUVCQMURZUVBUVJUUPUUSUV
        TUVLUVMUVNBLMNPQTUDUAVQZVKUVBUUOUVOUUSUVSUVTVLUVPUVRUVNBIJLMOUVCQTUDUBU
        CVOVKVPVRUVBUMUNUVGUVDUUOUURUVGVSZUVAUUOUVEVSUWBIJLOPUBUCWAUVEUVFWBVTWC
        UMWDZUNWDZWEZUVGUPUWEUVEUPZUWEUVFUPZUQZUVBUWEUVDUPZUWEUVEUVFWFUVBSWDZOM
        URUSZUWJPONVAKVAPWGZUQZUWHUWIWHSAUUOUURUWMSAWIUVAABIKLMNOPSTUDUEUAUFUBW
        JWKUVBUWJAUPZUWMUQZUQZUWFUWCHUWDVBZWLZXBZDVBZPMURZUWGUWCEUPZUWCDVBZQMUR
        ZUQZUWDRWGZUQZUWIUWPUWFUXBUWDGUPUQZUXAUQZUXAUWPUUOUURUWNUWKUQUWLUWFUXIV
        LUUOUURUVAUWOWMZUUOUURUVAUWOWNUWPUWNUWKUVBUWNUWMWOUVBUWNUWKUWLWPWQUVBUW
        NUWKUWLWRABCUWJDUWDEFGUWCHIJKLMNOPTUDUEUAUFUBUGUHUIUJUCUKUMWSUNWSWTXAUX
        HUXAXCXDUWPUWGUXGUWPUUOUVAUWGUXGVLUXJUUOUURUVAUWOXEBDUWDEFUWCIJLMRUOOQT
        UDUBUHUIULUCXFXGXLUVBUWOUXAUXGUQZUWIUVBUWOUXKUTZUWIUXBUXCUVCMURZUQZUXFU
        XLUXBUXMUXKUVBUXBUWOUXAUXBUXDUXFXHXIZUXLUXCPMURZUXDUXMUXLUWTUXCPMUXLUWS
        UWCDUXLUWSUWCXJBXKZXBZUWCUXLUWRUXQUWCUXLUWRUXQWLUXQUXLUWQUXQUXLUWQHRVBZ
        UXQUXLHUWDRUXEUXFUXAUVBUWOXMZXNUXLHEUPZUXSUXQWGUXLUUOCAUPCOMURUSUQZUWNU
        WKUYAUUOUURUVAUWOUXKXOZUXLUUOUYBUYCACILMOUDUFUBUGXPVTUVBUWNUWMUXKVHUWKU
        WLUWNUVBUXKXQACUWJEFHILMOUDUFUBUHUKXRXABEFHLRULTXSVTXTYABYBYCYDUXLBBUWC
        YEZBBUWCYFUXRUWCWGUXLUUOUXBUYDUYCUXOBEUWCILUOOTUBUHYGXGBBUWCYHBBUWCYIYL
        XTYJUVBUWOUXAUXGVIYKUXKUVBUXDUWOUXAUXBUXDUXFYMXIUXLUVJUXCBUPZUUPUUSUXPU
        XDUQUXMVLUXLUUMUVJUUMUUNUURUVAUWOUXKYNUVKVTZUXLUUOUXBUYEUYCUXOBDEUWCILO
        TUBUHUIYOXGUUPUUQUUOUVAUWOUXKYPZUUSUUTUUOUURUWOUXKYQZBLMNUXCPQTUDUAYRYS
        YTWQUXTUXLUUOUVOUVCOMURUWIUXNUXFUQVLUYCUXLUVJUUPUUSUVOUYFUYGUYHUVQVKZUX
        LBLMUVCQOTUDUYFUYIUYHUXLUUNOBUPUUMUUNUURUVAUWOUXKUUABILOTUBUUBVTUXLUVJU
        UPUUSUVTUYFUYGUYHUWAVKUUSUUTUUOUURUWOUXKUUCUUDBDUWDEFUWCIJLMRUOOUVCTUDU
        BUHUIULUCXFUUEUUFUUGUUHUUJUUIUUKUUL $.

      $( A conjunction property of isomorphism H. TODO: reduce antecedent size;
         general review for shorter proof.  (Contributed by NM, 21-Mar-2014.)
         (New usage is discouraged.) $)
      dihglblem5apreN $p |- ( ( ( K e. HL /\ W e. H )
           /\ ( X e. B /\ -. X .<_ W ) )
         -> ( I ` ( X ./\ W ) ) = ( ( I ` X ) i^i ( I ` W ) ) ) $=
        ( vf vs chlt wcel wa wbr wn co cfv cin wss clat ad2antrr simprl lhpbase
        hllat ad2antlr latmle1 syl3anc simpl latmcl dihord mpbird latmle2 ssind
        wb wrel dihvalrel relin1 syl adantr cv cop elin wceq wrex lhpmcvr2 ccnv
        wi w3a ccom dihopelvalc id adantl latref dihopelvalbN syl12anc 3ad2ant1
        vex syl2an anbi12d simprll cres simprrr fveq1d simpl1 lhpocnel2 simpl3l
        cid ltrniotacl tendo02 eqtrd cnveqd cnvresid syl6eq coeq2d wf1o syl2anc
        wf ltrn1o f1of fcoi1 3syl fveq2d simprlr eqbrtrrd trlle simpl1l simpl2l
        trlcl simpl1r latlem12 syl13anc mpbi2and jca mpbir2and ex sylbid 3expia
        exp4c imp4a rexlimdv mpd syl5bi relssdv eqssd ) LUNUOZOIUOZUPZPBUOZPOMU
        QURZUPZUPZPONUSZJUTZPJUTZOJUTZVAZUUNUUPUUQUURUUNUUPUUQVBZUUOPMUQZUUNLVC
        UOZUUKOBUOZUVAUUHUVBUUIUUMLVGZVDZUUJUUKUULVEZUUIUVCUUHUUMBILOSUAVFZVHZB
        LMNPOSUCTVIVJUUNUUJUUOBUOZUUKUUTUVAVQUUJUUMVKZUUNUVBUUKUVCUVIUVEUVFUVHB
        LNPOSTVLZVJZUVFBIJLMOUUOPSUCUAUBVMVJVNUUNUUPUURVBZUUOOMUQZUUNUVBUUKUVCU
        VNUVEUVFUVHBLMNPOSUCTVOZVJUUNUUJUVIUVCUVMUVNVQUVJUVLUVHBIJLMOUUOOSUCUAU
        BVMVJVNVPUUNULUMUUSUUPUUJUUSVRZUUMUUJUUQVRUVPIJLOPUAUBVSUUQUURVTWAWBULW
        CZUMWCZWDZUUSUOUVSUUQUOZUVSUURUOZUPZUUNUVSUUPUOZUVSUUQUURWEUUNRWCZOMUQU
        RZUWDUUOKUSPWFZUPZRAWGUWBUWCWJZABIKLMNOPRSUCUDTUEUAWHUUNUWGUWHRAUUNUWDA
        UOZUWEUWFUWHUUNUWIUWEUWFUWHUUJUUMUWIUWEUPZUWFUPZUWHUUJUUMUWKWKZUWBUVQEU
        OZUVRGUOUPZUVQHUVRUTZWIZWLZDUTZPMUQZUPZUWMUVQDUTZOMUQZUPZUVRQWFZUPZUPZU
        WCUWLUVTUWTUWAUXEABCUWDDUVREFGUVQHIJKLMNOPSUCUDTUEUAUFUGUHUIUBUJULWTUMW
        TWMUUJUUMUWAUXEVQZUWKUUJUUJUVCOOMUQZUXGUUJWNUUIUVCUUHUVGWOUUHUVBUVCUXHU
        UIUVDUVGBLMOSUCWPXABDUVREFUVQIJLMQUNOOSUCUAUGUHUKUBWQWRWSXBUWLUXFUWCUWL
        UXFUPZUWCUWMUXAUUOMUQZUPZUXDUXIUWMUXJUXFUWMUWLUWTUWMUXBUXDXCWOZUXIUXAPM
        UQZUXBUXJUXIUWRUXAPMUXIUWQUVQDUXIUWQUVQXJBXDZWLZUVQUXIUWPUXNUVQUXIUWPUX
        NWIUXNUXIUWOUXNUXIUWOHQUTZUXNUXIHUVRQUWLUWTUXCUXDXEZXFUXIHEUOZUXPUXNWFU
        XIUUJCAUOCOMUQURUPZUWJUXRUUJUUMUWKUXFXGZUXIUUJUXSUXTACILMOUCUEUAUFXHWAU
        WJUWFUUJUUMUXFXIACUWDEFHILMOUCUEUAUGUJXKVJBEFHLQUKSXLWAXMXNBXOXPXQUXIBB
        UVQXRZBBUVQXTUXOUVQWFUXIUUJUWMUYAUXTUXLBEUVQILUNOSUAUGYAXSBBUVQYBBBUVQY
        CYDXMYEUWLUWNUWSUXEYFYGUXIUUJUWMUXBUXTUXLDEUVQILMOUCUAUGUHYHXSUXIUVBUXA
        BUOZUUKUVCUXMUXBUPUXJVQUXIUUHUVBUUHUUIUUMUWKUXFYIUVDWAZUXIUUJUWMUYBUXTU
        XLBDEUVQILOSUAUGUHYKXSUUKUULUUJUWKUXFYJZUXIUUIUVCUUHUUIUUMUWKUXFYLUVGWA
        ZBLMNUXAPOSUCTYMYNYOYPUXQUXIUUJUVIUVNUWCUXKUXDUPVQUXTUXIUVBUUKUVCUVIUYC
        UYDUYEUVKVJUXIUVBUUKUVCUVNUYCUYDUYEUVOVJBDUVREFUVQIJLMQUNOUUOSUCUAUGUHU
        KUBWQWRYQYRYSYTUUAUUBUUCUUDUUEUUFUUG $.
    $}

    $( A conjunction property of isomorphism H. (Contributed by NM,
       21-Mar-2014.)  (New usage is discouraged.) $)
    dihglblem5aN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B )
       -> ( I ` ( X ./\ W ) ) = ( ( I ` X ) i^i ( I ` W ) ) ) $=
      ( vh vq wcel wa cfv wceq wb eqid syl3anc chlt cple wbr co cin simpr hllat
      clat ad3antrrr simplr lhpbase ad3antlr latleeqm1 fveq2d wss simpll dihord
      mpbid mpbird df-ss sylib eqtr4d wn catm coc ctrl cltrn ctendo cv crio cjn
      cid cres cmpt dihglblem5apreN anassrs pm2.61dan ) DUANZFBNZOZGANZOZGFDUBP
      ZUCZGFEUDZCPZGCPZFCPZUEZQZWBWDOZWFWGWIWKWEGCWKWDWEGQZWBWDUFZWKDUHNZWAFANZ
      WDWLRVRWNVSWAWDDUGUIVTWAWDUJZVSWOVRWAWDABDFHJUKULZADWCEGFHWCSZIUMTURUNWKW
      GWHUOZWIWGQWKWSWDWMWKVTWAWOWSWDRVTWAWDUPWPWQABCDWCFGFHWRJKUQTUSWGWHUTVAVB
      VTWAWDVCWJDVDPZAFDVEPPZFDVFPPZFDVGPPZLFDVHPPZXALVIPMVIQLXCVJZBCDVKPZDWCEF
      GLXCVLAVMVNZMHIJKWRXFSWTSXASXCSXBSXDSXESXGSVOVPVQ $.
  $}

  ${
    $d x y w u v z ./\ $.  $d x y w z .<_ $.  $d x y w u z B $.
    $d x y w z G $.  $d x y w z H $.  $d x y w z K $.  $d x y w u v z S $.
    $d x y w z T $.  $d x y w u v z W $.
    dihglblem.b $e |- B = ( Base ` K ) $.
    dihglblem.l $e |- .<_ = ( le ` K ) $.
    dihglblem.m $e |- ./\ = ( meet ` K ) $.
    dihglblem.g $e |- G = ( glb ` K ) $.
    dihglblem.h $e |- H = ( LHyp ` K ) $.
    dihglblem.t $e |- T = { u e. B | E. v e. S u = ( v ./\ W ) } $.
    $( Lemma for isomorphism H of a GLB. (Contributed by NM, 19-Mar-2014.)
       (New usage is discouraged.) $)
    dihglblem2aN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( S C_ B /\ S =/= (/) ) ) -> T =/= (/) ) $=
      ( vz wcel wceq vw chlt wa wss c0 wne cv co wrex crab a1i wex simprr sylib
      clat hllat ad3antrrr simplrl simpr sseldd lhpbase ad3antlr latmcl syl3anc
      n0 eqidd weq oveq1 eqeq2d rspcev syl2anc eleq1 eqeq1 rexbidv elrab syl6bb
      ovex spcev sylibr exlimddv eqnetrd ) HUBSZKGSZUCZDCUDZDUEUFZUCZUCZEBUGZAU
      GZKJUHZTZADUIZBCUJZUEEWNTWHQUKWHRUGZDSZWNUEUFZRWHWFWPRULWDWEWFUMRDVEUNWHW
      PUCZUAUGZWNSZUAULZWQWRWOKJUHZCSZXBWKTZADUIZXAWRHUOSZWOCSKCSZXCWBXFWCWGWPH
      UPUQWRDCWOWDWEWFWPURWHWPUSZUTWCXGWBWGWPCGHKLPVAVBCHJWOKLNVCVDWRWPXBXBTZXE
      XHWRXBVFXDXIAWODARVGWKXBXBWJWOKJVHVIVJVKWTXCXEUCZUAXBWOKJVQWSXBTWTXBWNSXJ
      WSXBWNVLWMXEBXBCWIXBTWLXDADWIXBWKVMVNVOVPVRVKUAWNVEVSVTWA $.

    $( The GLB of a set of lattice elements ` S ` is the same as that of the
       set ` T ` with elements of ` S ` cut down to be under ` W ` .
       (Contributed by NM, 19-Mar-2014.)  (New usage is discouraged.) $)
    dihglblem2N $p |- ( ( ( K e. HL /\ W e. H ) /\ S C_ B
        /\ ( G ` S ) .<_ W ) -> ( G ` S ) = ( G ` T ) ) $=
      ( wcel wbr syl vz vx vw vy chlt wa wss cfv w3a cv clat simpl1l hllat ccla
      co simp1l hlclat wceq wrex ssrab2 eqsstri clatglbcl sylancl adantr simpl2
      simpr sseldd simpl1r lhpbase latmcl syl3anc eqidd weq oveq1 eqeq2d rspcev
      crab syl2anc eqeq1 rexbidv elrab sylanbrc syl6eleqr mp3an2 latmle1 lattrd
      clatglble wral cbvrexv syl6bb elrab2 wi simp3 simp13 breq2 rspcva simp11l
      3ad2ant1 simp12 simp112 simp11r mpbird simp113 latlem12 syl13anc mpbi2and
      wb clatleglb 3expia biimprcd syl6 rexlimdv expimpd syl5bi ralrimiv mp3an3
      simp2 isglbd ) HUERZKGRZUFZDCUGZDFUHZKISZUIZUAUBCDFEFUHZHILMOYEUBUJZDRZUF
      ZCHIYFYGKJUOZYGLMYIXSHUKRZXSXTYBYDYHULZHUMZTZYEYFCRZYHYEHUNRZECUGZYOYEXSY
      PXSXTYBYDUPHUQZTZEBUJZAUJZKJUOZURZADUSZBCVQZCQUUDBCUTVAZCEFHLOVBVCZVDYIYK
      YGCRZKCRZYJCRZYNYIDCYGYAYBYDYHVEYEYHVFZVGZYIXTUUIXSXTYBYDYHVHCGHKLPVIZTZC
      HJYGKLNVJVKZUULYIYPYJERZYFYJISZYIXSYPYLYRTYIYJUUEEYIUUJYJUUBURZADUSZYJUUE
      RUUOYIYHYJYJURZUUSUUKYIYJVLUURUUTAYGDAUBVMUUBYJYJUUAYGKJVNVOVPVRUUDUUSBYJ
      CYTYJURUUCUURADYTYJUUBVSVTWAWBQWCYPYQUUPUUQUUFCEFHIYJLMOWGWDVRYIYKUUHUUIY
      JYGISYNUULUUNCHIJYGKLMNWEVKWFYEUAUJZCRZUVAYGISZUBDWHZUIZUVAYFISZUVAUCUJZI
      SZUCEWHZUVEUVHUCEUVGERUVGCRZUVGUDUJZKJUOZURZUDDUSZUFUVEUVHUUDUVNBUVGCEBUC
      VMZUUDUVGUUBURZADUSUVNUVOUUCUVPADYTUVGUUBVSVTUVPUVMAUDDAUDVMUUBUVLUVGUUAU
      VKKJVNVOWIWJQWKUVEUVJUVNUVHUVEUVJUFZUVMUVHUDDUVQUVKDRZUVAUVLISZUVMUVHWLUV
      EUVJUVRUVSUVEUVJUVRUIZUVAUVKISZUVAKISZUVSUVTUVRUVDUWAUVEUVJUVRWMZYEUVBUVD
      UVJUVRWNZUVCUWAUBUVKDYGUVKUVAIWOWPVRUVTCHIUVAYCKLMUVTXSYKUVEUVJXSUVRXSXTY
      BYDUVBUVDWQZWRZYMTZYEUVBUVDUVJUVRWSZUVTYPYBYCCRUVTXSYPUWFYRTZYAYBYDUVBUVD
      UVJUVRWTZCDFHLOVBVRUVTXTUUIUVEUVJXTUVRXSXTYBYDUVBUVDXAWRUUMTZUVTUVAYCISZU
      VDUWDUVTYPUVBYBUWLUVDXGUWIUWHUWJUBCDFHIUVALMOXHVKXBYAYBYDUVBUVDUVJUVRXCWF
      UVTYKUVBUVKCRUUIUWAUWBUFUVSXGUWGUWHUVTDCUVKUWJUWCVGUWKCHIJUVAUVKKLMNXDXEX
      FXIUVMUVHUVSUVGUVLUVAIWOXJXKXLXMXNXOUVEYPUVBUVFUVIXGZUVEXSYPUWEYRTYEUVBUV
      DXQYPUVBYQUWMUUFUCCEFHIUVALMOXHXPVRXBYSYAYBYDXQUUGXR $.

    $d u v .<_ $.  $d v B $.  $d u v G $.  $d u v H $.  $d u v K $.
    dihglblem.i $e |- J = ( ( DIsoB ` K ) ` W ) $.
    dihglblem.ih $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Isomorphism H of a lattice glb.  (Contributed by NM, 20-Mar-2014.)
       (New usage is discouraged.) $)
    dihglblem3N $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( S C_ B /\ S =/= (/) ) /\ ( G ` S ) .<_ W )
       -> ( I ` ( G ` T ) ) = |^|_ x e. T ( I ` x ) ) $=
      ( chlt wcel wa wss c0 wne cfv wbr w3a cv ciin cdm wceq simp1 crab co wrex
      wi simp11l hllat syl simp12l simp3 sseldd simp11r lhpbase latmle2 syl3anc
      3expia breq1 biimprcd rexlimdv ss2rabdv syl5eqss dibdmN 3ad2ant1 sseqtr4d
      clat syl6 dihglblem2aN 3adant3 dibglbN syl12anc dihglblem2N fveq2d simpl1
      3adant2r sselda elrab sylib dihvalb syl2anc iineq2dv 3eqtr4rd ccla simp1l
      hlclat simp2l clatglbcl 3eqtr2rd ) KUCUDZNHUDZUEZEDUFZEUGUHZUEZEGUIZNLUJZ
      UKZAFAULZIUIZUMZXIJUIZXIIUIZFGUIZIUIXKXQJUIZAFXLJUIZUMZXOXNXKXEFJUNZUFFUG
      UHZXRXTUOXEXHXJUPZXKFCULZNLUJZCDUQZYAXKFYDBULZNMURZUOZBEUSZCDUQYFTXKYJYEC
      DXKYDDUDZUEZYIYEBEYLYGEUDZYHNLUJZYIYEUTXKYKYMYNXKYKYMUKZKVTUDZYGDUDNDUDZY
      NYOXCYPXCXDXHXJYKYMVAKVBVCYOEDYGXFXGXEXJYKYMVDXKYKYMVEVFYOXDYQXCXDXHXJYKY
      MVGDHKNOSVHVCDKLMYGNOPQVIVJVKYIYEYNYDYHNLVLVMWAVNVOVPZXEXHYAYFUOXJCDHJKLU
      CNOPSUAVQVRVSXEXHYBXJBCDEFGHKLMNOPQRSTWBWCAFGHJKNRSUAWDWEXKXIXQJXEXFXJXIX
      QUOXGBCDEFGHKLMNOPQRSTWFWIZWGXKAFXMXSXKXLFUDZUEZXEXLDUDXLNLUJZUEZXMXSUOXE
      XHXJYTWHUUAXLYFUDUUCXKFYFXLYRWJYEUUBCXLDYDXLNLVLWKWLDJHIKLUCNXLOPSUBUAWMW
      NWOWPXKXEXIDUDZXJXPXOUOYCXKKWQUDZXFUUDXKXCUUEXCXDXHXJWRKWSVCXEXFXGXJWTDEG
      KORXAWNXEXHXJVEDJHIKLUCNXIOPSUBUAWMWEXKXIXQIYSWGXB $.

    $( Isomorphism H of a lattice glb.  (Contributed by NM, 7-Apr-2014.)
       (New usage is discouraged.) $)
    dihglblem3aN $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( S C_ B /\ S =/= (/) ) /\ ( G ` S ) .<_ W )
       -> ( I ` ( G ` S ) ) = |^|_ x e. T ( I ` x ) ) $=
      ( chlt wcel wa wss c0 wne cfv wbr w3a cv ciin dihglblem2N 3adant2r fveq2d
      wceq dihglblem3N eqtrd ) KUCUDNHUDUEZEDUFZEUGUHZUEEGUIZNLUJZUKZVCIUIFGUIZ
      IUIAFAULIUIUMVEVCVFIUTVAVDVCVFUQVBBCDEFGHKLMNOPQRSTUNUOUPABCDEFGHIJKLMNOP
      QRSTUAUBURUS $.

    $d x I $.
    $( Isomorphism H of a lattice glb.  (Contributed by NM, 21-Mar-2014.) $)
    dihglblem4 $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( S C_ B /\ S =/= (/) ) )
       -> ( I ` ( G ` S ) ) C_ |^|_ x e. S ( I ` x ) ) $=
      ( chlt wcel wa wss c0 wne cfv wral ciin wbr ccla hlclat ad3antrrr simplrl
      clatglble syl3anc simpll clatglbcl syl2anc sseldd dihord mpbird ralrimiva
      cv simpr wb ssiin sylibr ) KUCUDZNHUDZUEZEDUFZEUGUHZUEZUEZEGUIZIUIZAVFZIU
      IZUFZAEUJVSAEWAUKUFVQWBAEVQVTEUDZUEZWBVRVTLULZWDKUMUDZVNWCWEVKWFVLVPWCKUN
      UOZVMVNVOWCUPZVQWCVGZDEGKLVTOPRUQURWDVMVRDUDZVTDUDWBWEVHVMVPWCUSWDWFVNWJW
      GWHDEGKORUTVAWDEDVTWHWIVBDHIKLNVRVTOPSUBVCURVDVEAEWAVSVIVJ $.
  $}

  ${
    $d x B $.  $d x H $.  $d w y I $.  $d x K $.  $d x S $.  $d w x y T $.
    $d x W $.
    dihglblem5.b $e |- B = ( Base ` K ) $.
    dihglblem5.g $e |- G = ( glb ` K ) $.
    dihglblem5.h $e |- H = ( LHyp ` K ) $.
    dihglblem5.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihglblem5.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihglblem5.s $e |- S = ( LSubSp ` U ) $.
    $( Isomorphism H of a lattice glb.  (Contributed by NM, 9-Apr-2014.) $)
    dihglblem5 $p |- ( ( ( K e. HL /\ W e. H )
     /\ ( T C_ B /\ T =/= (/) ) ) -> |^|_ x e. T ( I ` x ) e. S ) $=
      ( vy wcel wa c0 chlt wss wne cv cfv ciin wceq wrex cint fvex dfiin2 clmod
      cab simpl dvhlmod simpll simplrl simpr sseldd dihlss syl2anc ralrimiva wb
      wral uniiunlem syl mpbid wex simprr n0 sylib nfre1 nfab nfcv nfne elabrex
      ne0i exlimi lssintcl syl3anc syl5eqel ) IUARJGRSZDBUBZDTUCZSZSZADAUDZHUEZ
      UFQUDWHUGZADUHZQUMZUIZCAQDWHWGHUJZUKWFEULRWKCUBZWKTUCZWLCRWFEGIJMNWBWEUNU
      OWFWHCRZADVDZWNWFWPADWFWGDRZSZWBWGBRWPWBWEWRUPWSDBWGWBWCWDWRUQWFWRURUSBCE
      GHIJWGKMONPUTVAVBZWFWQWQWNVCWTAQDWHCCVEVFVGWFWRAVHZWOWFWDXAWBWCWDVIADVJVK
      WRWOAAWKTWJAQWIADVLVMATVNVOWRWHWKRWOAQDWHWMVPWKWHVQVFVRVFWKCEPVSVTWA $.
  $}

  ${
    $d x .<_ $.  $d x B $.  $d x H $.  $d x I $.  $d x K $.  $d x W $.
    $d x X $.  $d x Y $.
    dihmeetlem2.b $e |- B = ( Base ` K ) $.
    dihmeetlem2.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem2.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihmeetlem2.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem2.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem2.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem2.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihmeetlem2.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihmeetlem2.r $e |- R = ( ( trL ` K ) ` W ) $.
    dihmeetlem2.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihmeetlem2.g $e |- G = ( iota_ h e. T ( h ` P ) = q ) $.
    dihmeetlem2.o $e |- .0. = ( h e. T |-> ( _I |` B ) ) $.
    $( Isomorphism H of a conjunction.  (Contributed by NM, 22-Mar-2014.)
       (New usage is discouraged.) $)
    dihmeetlem2N $p |- ( ( ( K e. HL /\ W e. H )
         /\ ( X e. B /\ X .<_ W ) /\ ( Y e. B /\ Y .<_ W ) )
       -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( vx chlt wcel wa wbr w3a co cfv cpr cv ciin cdib cglb wceq simp1l simp2l
      cin simp3l eqid meetval syl3anc fveq2d cdm wss wne simp1 dibeldmN biimpar
      c0 3adant3 3adant2 wb prssg syl2anc mpbi2and prnzg dibglbN syl12anc eqtrd
      syl clat hllat latmcl simp1r lhpbase latmle1 simp2r lattrd dihvalb simpl1
      vex elpr simpl2 eleq1 breq1 anbi12d adantl mpbird simpl3 sylan2b iineq2dv
      wo jaodan 3eqtr4d fveq2 iinxprg ) LUNUOZOIUOZUPZPBUOZPOMUQZUPZQBUOZQOMUQZ
      UPZURZPQNUSZJUTZUMPQVAZUMVBZJUTZVCZPJUTZQJUTZVIZYHYIOLVDUTUTZUTZUMYKYLYRU
      TZVCZYJYNYHYSYKLVEUTZUTZYRUTZUUAYHYIUUCYRYHXSYBYEYIUUCVFXSXTYDYGVGZYAYBYC
      YGVHZYAYDYEYFVJZUNBUUBLNPQTUUBVKZUAVLVMVNYHYAYKYRVOZVPZYKWAVQZUUDUUAVFYAY
      DYGVRZYHPUUIUOZQUUIUOZUUJYAYDUUMYGYAUUMYDBIYRLMUNOPTUDUBYRVKZVSVTWBYAYGUU
      NYDYAUUNYGBIYRLMUNOQTUDUBUUOVSVTWCYHYBYEUUMUUNUPUUJWDUUFUUGPQUUIBBWEWFWGY
      HYBUUKUUFPQBWHWLUMYKUUBIYRLOUUHUBUUOWIWJWKYHYAYIBUOZYIOMUQYJYSVFUULYHLWMU
      OZYBYEUUPYHXSUUQUUELWNWLZUUFUUGBLNPQTUAWOVMZYHBLMYIPOTUDUURUUSUUFYHXTOBUO
      XSXTYDYGWPBILOTUBWQWLYHUUQYBYEYIPMUQUURUUFUUGBLMNPQTUDUAWRVMYAYBYCYGWSWTB
      YRIJLMUNOYITUDUBUCUUOXAWJYHUMYKYMYTYHYLYKUOZUPYAYLBUOZYLOMUQZUPZYMYTVFYAY
      DYGUUTXBUUTYHYLPVFZYLQVFZXNUVCYLPQUMXCXDYHUVDUVCUVEYHUVDUPUVCYDYAYDYGUVDX
      EUVDUVCYDWDYHUVDUVAYBUVBYCYLPBXFYLPOMXGXHXIXJYHUVEUPUVCYGYAYDYGUVEXKUVEUV
      CYGWDYHUVEUVAYEUVBYFYLQBXFYLQOMXGXHXIXJXOXLBYRIJLMUNOYLTUDUBUCUUOXAWFXMXP
      YHYBYEYNYQVFUUFUUGUMPQYMYOYPBBYLPJXQYLQJXQXRWFWK $.
  $}

  ${
    $d q x ./\ $.  $d f g q s x .<_ $.  $d x .\/ $.  $d g q x A $.
    $d f q s x B $.  $d x E $.  $d x F $.  $d f q s x G $.  $d f g q s x H $.
    $d f q s I $.  $d f g q s x K $.  $d g P $.  $d x R $.  $d f q s x S $.
    $d g x T $.  $d f g q s x W $.
    dihglbc.b $e |- B = ( Base ` K ) $.
    dihglbc.g $e |- G = ( glb ` K ) $.
    dihglbc.h $e |- H = ( LHyp ` K ) $.
    dihglbc.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihglbc.l $e |- .<_ = ( le ` K ) $.
    ${
      dihglbcpre.j $e |- .\/ = ( join ` K ) $.
      dihglbcpre.m $e |- ./\ = ( meet ` K ) $.
      dihglbcpre.a $e |- A = ( Atoms ` K ) $.
      dihglbcpre.p $e |- P = ( ( oc ` K ) ` W ) $.
      dihglbcpre.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      dihglbcpre.r $e |- R = ( ( trL ` K ) ` W ) $.
      dihglbcpre.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      dihglbcpre.f $e |- F = ( iota_ g e. T ( g ` P ) = q ) $.
      $( Isomorphism H of a lattice glb when the glb is not under the fiducial
         hyperplane ` W ` .  (Contributed by NM, 20-Mar-2014.)
         (New usage is discouraged.) $)
      dihglbcpreN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ B /\ S =/= (/)
          )
          /\ -. ( G ` S ) .<_ W )
       -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
        ( vf vs chlt wcel wa wss c0 wne cfv wbr wn w3a wrel ciin wceq dihvalrel
        cv 3ad2ant1 wrex wex simp2r n0 sylib simpr simpl1 syl jca ex eximdv mpd
        df-rex sylibr reliin id co wb simp1 ccla simp1l hlclat simp2l clatglbcl
        cop syl2anc simp3 lhpmcvr2 syl12anc ccnv ccom adantr simpl3 dihopelvalc
        syl121anc wral simpl2r r19.28zv simp11 simp12l sseldd simp11l clatglble
        vex simp13 syl3anc clat hllat simp11r lhpbase lattr syl13anc mpand mtod
        wi simp2ll atbase latmcl latlej1 breqtrd lattrd atmod3i1 syl131anc eqid
        cp1 lhpjat2 oveq2d col 3expa cvv olm11 3eqtrd syl122anc ralbidva simp3l
        hlol simp3r lhpocnel2 ltrniotacl tendocl ltrncnv ltrnco trlcl clatleglb
        pm5.32da 3bitr4rd opex eliin ax-mp bitrd exp44 imp4a rexlimdv eqrelrdv2
        syl6bbr syl21anc ) OUOUPZRLUPZUQZFCURZFUSUTZUQZFKVAZRPVBZVCZVDZUVMMVAZV
        EZAFAVIZMVAZVFZVEZUVPUVQUWAVGUVIUVLUVRUVOLMORUVMUBUCVHVJUVPUVTVEZAFVKZU
        WBUVPUVSFUPZUWCUQZAVLZUWDUVPUWEAVLZUWGUVPUVKUWHUVIUVJUVKUVOVMAFVNVOUVPU
        WEUWFAUVPUWEUWFUVPUWEUQZUWEUWCUVPUWEVPUWIUVIUWCUVIUVLUVOUWEVQLMORUVSUBU
        CVHVRVSVTWAWBUWCAFWCWDAFUVTWEVRUVPWFUVPUMUNUVQUWAUVPSVIZRPVBVCZUWJUVMRQ
        WGZNWGZUVMVGZUQZSBVKZUMVIZUNVIZWOZUVQUPZUWSUWAUPZWHZUVPUVIUVMCUPZUVOUWP
        UVIUVLUVOWIUVPOWJUPZUVJUXCUVPUVGUXDUVGUVHUVLUVOWKOWLZVRUVIUVJUVKUVOWMCF
        KOTUAWNWPZUVIUVLUVOWQBCLNOPQRUVMSTUDUEUFUGUBWRWSUVPUWOUXBSBUVPUWJBUPZUW
        KUWNUXBUVPUXGUWKUWNUXBUVPUXGUWKUQZUWNUQZUQZUWTUWQGUPZUWRIUPZUQZUWQJUWRV
        AZWTZXAZEVAZUVMPVBZUQZUXAUXJUVIUXCUVOUXIUWTUXSWHUVIUVLUVOUXIVQUVPUXCUXI
        UXFXBUVIUVLUVOUXIXCUVPUXIVPBCDUWJEUWRGHIUWQJLMNOPQRUVMTUDUEUFUGUBUHUIUJ
        UKUCULUMXNZUNXNZXDXEUXJUXSUWSUVTUPZAFXFZUXAUXJUXMUXQUVSPVBZUQZAFXFZUXMU
        YDAFXFZUQZUYCUXSUXJUVKUYFUYHWHUVJUVKUVIUVOUXIXGUXMUYDAFXHVRUXJUYBUYEAFU
        VPUXIUWEUYBUYEWHZUVPUXIUWEVDZUVIUVSCUPZUVSRPVBZVCUXHUWJUVSRQWGNWGZUVSVG
        UYIUVIUVLUVOUXIUWEXIZUYJFCUVSUVJUVKUVIUVOUXIUWEXJZUVPUXIUWEWQZXKZUYJUYL
        UVNUVIUVLUVOUXIUWEXOUYJUVMUVSPVBZUYLUVNUYJUXDUVJUWEUYRUYJUVGUXDUVGUVHUV
        LUVOUXIUWEXLZUXEVRUYOUYPCFKOPUVSTUDUAXMXPZUYJOXQUPZUXCUYKRCUPZUYRUYLUQU
        VNYEUYJUVGVUAUYSOXRVRZUVPUXIUXCUWEUXFVJZUYQUYJUVHVUBUVGUVHUVLUVOUXIUWEX
        SCLORTUBXTVRZCOPUVMUVSRTUDYAYBYCYDUVPUXHUWNUWEWMZUYJUYMUVSUWJRNWGZQWGZU
        VSOYOVAZQWGZUVSUYJUVGUXGUYKVUBUWJUVSPVBUYMVUHVGUYSUXGUWKUWNUVPUWEYFZUYQ
        VUEUYJCOPUWJUVMUVSTUDVUCUYJUXGUWJCUPZVUKBCUWJOTUGYGVRZVUDUYQUYJUWJUWMUV
        MPUYJVUAVULUWLCUPZUWJUWMPVBVUCVUMUYJVUAUXCVUBVUNVUCVUDVUECOQUVMRTUFYHXP
        CNOPUWJUWLTUDUEYIXPUVPUXHUWNUWEVMYJUYTYKBCUWJNOPQUVSRTUDUEUFUGYLYMUYJVU
        GVUIUVSQUYJUVIUXHVUGVUIVGUYNVUFBUWJVUILNOPRUDUEVUIYNZUGUBYPWPYQUYJOYRUP
        ZUYKVUJUVSVGUYJUVGVUPUYSOUUFVRUYQCVUIOQUVSTUFVUOUUAWPUUBBCDUWJEUWRGHIUW
        QJLMNOPQRUVSTUDUEUFUGUBUHUIUJUKUCULUXTUYAXDUUCYSUUDUXJUXMUXRUYGUVPUXIUX
        MUXRUYGWHZUVPUXIUXMVDZUXDUXQCUPZUVJVUQVURUVGUXDUVGUVHUVLUVOUXIUXMXLUXEV
        RVURUVIUXPGUPZVUSUVIUVLUVOUXIUXMXIZVURUVIUXKUXOGUPZVUTVVAUVPUXIUXKUXLUU
        EVURUVIUXNGUPZVVBVVAVURUVIUXLJGUPZVVCVVAUVPUXIUXKUXLUUGVURUVIDBUPDRPVBV
        CUQZUXHVVDVVAVURUVIVVEVVABDLOPRUDUGUBUHUUHVRUVPUXHUWNUXMWMBDUWJGHJLOPRU
        DUGUBUIULUUIXPUWRGIJLOUORUBUIUKUUJXPGUXNLORUBUIUUKWPGUWQUXOLORUBUIUULXP
        CEGUXPLORTUBUIUJUUMWPUVJUVKUVIUVOUXIUXMXJACFKOPUXQTUDUAUUNXPYSUUOUUPUWS
        YTUPUXAUYCWHUWQUWRUUQAUWSFUVTYTUURUUSUVEUUTUVAUVBUVCWBUVDUVF $.

      $d h K $.  $d h T $.  $d h W $.
      dihglbb.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
      $( Isomorphism H of a lattice glb when the glb is  under the
         fiduial hyperplane ` W ` . $)
$(
      dihglbb $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ B /\ S =/= (/) )
          /\ ( G ` S ) .<_ W )
       -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
        ( vf vs chlt wcel wa wss c0 wne cfv wbr w3a wrel cv ciin wceq
        dihvalrel
        3ad2ant1 wrex wex simp2r n0 sylib simpr simpl1 syl jca ex eximdv df-rex
        mpd sylibr reliin id cop wb simp1 ccla simp1l hlclat clatglbcl syl2anc
        simp2l simp3 vex dihopelvalbN syl12anc an32 wral simpl1l simprl
        trlcl
        simpl2l clatleglb syl3anc bitrd pm5.32da syl5bb cvv opex eliin bicomi
        ax-mp syl6bb eqrelrdv2 syl21anc ) PURUSZTMUSZUTZFCVAZFVBVCZUTZFLVDZTQVE
        ZVFZYGNVDZVGZAFAVHZNVDZVIZVGZYIYJYNVJYCYFYKYHMNPTYGUDUEVKVLYIYMVGZAFVMZ
        YOYIYLFUSZYPUTZAVNZYQYIYRAVNZYTYIYEUUAYCYDYEYHVOAFVPVQYIYRYSAYIYRYSYIYR
        UTZYRYPYIYRVRUUBYCYPYCYFYHYRVSMNPTYLUDUEVKVTWAWBWCWEYPAFWDWFAFYMWGVTYIW
        HYIUPUQYJYNYIUPVHZUQVHZWIZYJUSZUUCGUSZUUCEVDZYGQVEZUTUUDSVJZUTZUUEYNUSZ
        YIYCYGCUSZYHUUFUUKWJYCYFYHWKYIPWLUSZYDUUMYIYAUUNYAYBYFYHWMPWNZVTYCYDYEY
        HWQCFLPUBUCWOWPYCYFYHWRCEUUDGIUUCMNPQSURTYGUBUFUDUKULUOUEUQWSWTXAYIUUK?
        UULUUKUUGUUJUTZUUIUTYI?UUGUUIUUJXBYIUUPUUI?YIUUPUTZUUIUUHYLQVEAFXCZ?UUQ
        UUNUUHCUSZYDUUIUURWJUUQYAUUNYAYBYFYHUUPXDUUOVTUUQYCUUGUUSYCYFYHUUPVSYIU
        UGUUJXECEGUUCMPTUBUDUKULXFWPYDYEYCYHUUPXGACFLPQUUHUBUFUCXHXI?XJXKXLYI?U
        UEYMUSAFXCZUUL?UULUUTUUEXMUSUULUUTWJUUCUUDXNAUUEFYMXMXOXQXPXRXJXJXSXT
        $.
$)
    $}

    $( Isomorphism H of a lattice glb when the glb is not under the fiducial
       hyperplane ` W ` .  (Contributed by NM, 26-Mar-2014.)
       (New usage is discouraged.) $)
    dihglbcN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ B /\ S =/= (/) )
        /\ -. ( G ` S ) .<_ W )
     -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
      ( vg vq catm cfv cv eqid coc ctrl cltrn ctendo wceq crio cmee dihglbcpreN
      cjn ) AGQRZBIGUARRZIGUBRRZCIGUCRRZOIGUDRRZUKOSRPSUEOUMUFZDEFGUIRZGHGUGRZI
      PJKLMNUPTUQTUJTUKTUMTULTUNTUOTUH $.
  $}

  ${
    $d g q x .<_ $.  $d q ./\ $.  $d g q x B $.  $d g q x H $.  $d q x I $.
    $d g q x K $.  $d g q x W $.  $d q x X $.  $d q x Y $.
    dihmeetc.b $e |- B = ( Base ` K ) $.
    dihmeetc.l $e |- .<_ = ( le ` K ) $.
    dihmeetc.m $e |- ./\ = ( meet ` K ) $.
    dihmeetc.h $e |- H = ( LHyp ` K ) $.
    dihmeetc.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Isomorphism H of a lattice meet when the meet is not under the fiducial
       hyperplane ` W ` .  (Contributed by NM, 26-Mar-2014.)
       (New usage is discouraged.) $)
    dihmeetcN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B )
        /\ -. ( X ./\ Y ) .<_ W )
     -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( vx chlt wcel wa cfv wceq co wbr wn w3a cpr cglb cv simp1l simp2l simp2r
      ciin cin meetval syl3anc fveq2d wss c0 wne simp1 prssi 3ad2ant2 prnzg syl
      eqid simp3 breq1d mtbid dihglbcN syl121anc fveq2 iinxprg 3eqtrd ) DPQZGBQ
      ZRZHAQZIAQZRZHIFUAZGEUBZUCZUDZVSCSHIUEZDUFSZSZCSZOWCOUGZCSZUKZHCSZICSZULZ
      WBVSWECWBVMVPVQVSWETVMVNVRWAUHVOVPVQWAUIZVOVPVQWAUJPAWDDFHIJWDVDZLUMUNZUO
      WBVOWCAUPZWCUQURZWEGEUBZUCWFWITVOVRWAUSVRVOWPWAHIAUTVAWBVPWQWMHIAVBVCWBVT
      WRVOVRWAVEWBVSWEGEWOVFVGOAWCWDBCDEGJWNMNKVHVIVRVOWIWLTWAOHIWHWJWKAAWGHCVJ
      WGICVJVKVAVL $.

    $( Isomorphism H of a lattice meet when one element is under the fiducial
       hyperplane ` W ` .  (Contributed by NM, 26-Mar-2014.)
       (New usage is discouraged.) $)
    dihmeetbN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B
              /\ ( Y e. B /\ Y .<_ W ) )
     -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( vg vq wcel wa cfv eqid chlt wbr w3a cin wceq simpl1 simpl2 simpr simpl3
      co catm coc ctrl cltrn ctendo cv crio cjn cid cres dihmeetlem2N syl121anc
      cmpt wn dihmeetlem1N pm2.61dan ) DUAQGBQRZHAQZIAQIGEUBRZUCZHGEUBZHIFUJCSH
      CSICSUDUEZVJVKRVGVHVKVIVLVGVHVIVKUFVGVHVIVKUGVJVKUHVGVHVIVKUIDUKSZAGDULSS
      ZGDUMSSZGDUNSSZOGDUOSSZVNOUPSPUPUEOVPUQZBCDURSZDEFGHIOVPUSAUTVCZPJLMNKVST
      ZVMTZVNTZVPTZVOTZVQTZVRTZVTTZVAVBVJVKVDZRVGVHWIVIVLVGVHVIWIUFVGVHVIWIUGVJ
      WIUHVGVHVIWIUIVMAVNVOVPOVQVRBCVSDEFGHIVTPJLMNKWAWBWCWDWEWFWGWHVEVBVF $.

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       30-Mar-2014.)  (New usage is discouraged.) $)
    dihmeetbclemN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B )
        /\ ( X ./\ Y ) .<_ W )
   -> ( I ` ( X ./\ Y ) ) = ( ( ( I ` X ) i^i ( I ` Y ) ) i^i ( I ` W ) ) ) $=
      ( wcel co cfv cin wceq syl3anc chlt wa wbr w3a simp3 clat wb simp1l hllat
      syl simp2l simp2r latmcl simp1r lhpbase latleeqm1 mpbid col hlol syl13anc
      latmassOLD eqtr3d fveq2d simp1 latmle2 dihmeetbN syl112anc latref syl2anc
      ineq2d 3eqtrd inass syl6eqr ) DUAOZGBOZUBZHAOZIAOZUBZHIFPZGEUCZUDZVTCQZHC
      QZICQZGCQZRZRZWDWERWFRWBWCHIGFPZFPZCQZWDWICQZRZWHWBVTWJCWBVTGFPZVTWJWBWAW
      NVTSZVPVSWAUEWBDUFOZVTAOZGAOZWAWOUGWBVNWPVNVOVSWAUHZDUIUJZWBWPVQVRWQWTVPV
      QVRWAUKZVPVQVRWAULZADFHIJLUMTWBVOWRVNVOVSWAUNABDGJMUOUJZADEFVTGJKLUPTUQWB
      DUROZVQVRWRWNWJSWBVNXDWSDUSUJXAXBXCADFHIGJLVAUTVBVCWBVPVQWIAOZWIGEUCZWKWM
      SVPVSWAVDZXAWBWPVRWRXEWTXBXCADFIGJLUMTWBWPVRWRXFWTXBXCADEFIGJKLVETABCDEFG
      HWIJKLMNVFVGWBWLWGWDWBVPVRWRGGEUCZWLWGSXGXBXCWBWPWRXHWTXCADEGJKVHVIABCDEF
      GIGJKLMNVFVGVJVKWDWEWFVLVM $.
  $}

  ${
    dihmeetlem3.b $e |- B = ( Base ` K ) $.
    dihmeetlem3.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem3.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem3.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem3.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem3.h $e |- H = ( LHyp ` K ) $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       30-Mar-2014.)  (New usage is discouraged.) $)
    dihmeetlem3N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B )
            /\ ( X ./\ Y ) .<_ W )
    /\ ( ( Q e. A /\ -. Q .<_ W ) /\ ( Q .\/ ( X ./\ W ) ) = X )
    /\ ( ( R e. A /\ -. R .<_ W ) /\ ( R .\/ ( Y ./\ W ) ) = Y ) )
        -> Q =/= R ) $=
      ( wcel wa chlt co wbr w3a wn wne simp2lr wi oveq1 simpr sylan9eqr simp11l
      wceq clat hllat syl simp2ll atbase simp12l simp12r latmcl syl3anc simp11r
      lhpbase latlej1 simp2r breqtrd simp3 wb latlem12 syl13anc mpbi2and simp13
      lattrd 3exp syl7 exp4a 3imp necon3bd mpd ) GUASZJESZTZKBSZLBSZTZKLIUBZJHU
      CZUDZCASZCJHUCZUEZTZCKJIUBZFUBZKUMZTZDASDJHUCUETZDLJIUBZFUBZLUMZTZUDZWLCD
      UFWJWLWPWIXBUGXCWKCDWIWQXBCDUMZWKUHWIWQXBXDWKXBXDTCWSFUBZLUMZWIWQWKXDXBXE
      WTLCDWSFUIWRXAUJUKWIWQXFWKWIWQXFUDZBGHCWGJMNXGWAGUNSZWAWBWFWHWQXFULGUOUPZ
      XGWJCBSZWJWLWPWIXFUQABCGMQURUPZXGXHWDWEWGBSXIWDWEWCWHWQXFUSZWDWEWCWHWQXFU
      TZBGIKLMPVAVBXGWBJBSZWAWBWFWHWQXFVCBEGJMRVDUPZXGCKHUCZCLHUCZCWGHUCZXGCWOK
      HXGXHXJWNBSZCWOHUCXIXKXGXHWDXNXSXIXLXOBGIKJMPVAVBBFGHCWNMNOVEVBWIWMWPXFVF
      VGXGCXELHXGXHXJWSBSZCXEHUCXIXKXGXHWEXNXTXIXMXOBGILJMPVAVBBFGHCWSMNOVEVBWI
      WQXFVHVGXGXHXJWDWEXPXQTXRVIXIXKXLXMBGHICKLMNPVJVKVLWCWFWHWQXFVMVNVOVPVQVR
      VSVT $.
  $}

  ${
    $d f g s .<_ $.  $d f s ./\ $.  $d f g s A $.  $d f g h s H $.  $d f s I $.
    $d f h s B $.  $d f g h s K $.  $d f g s Q $.  $d g h T $.  $d f g h s W $.
    $d g P $.  $d f s X $.  $d f s .0. $.
    dihmeetlem4.b $e |- B = ( Base ` K ) $.
    dihmeetlem4.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem4.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem4.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem4.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem4.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihmeetlem4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihmeetlem4.z $e |- .0. = ( 0g ` U ) $.
    ${
      dihmeetlem4.g $e |- G = ( iota_ g e. T ( g ` P ) = Q ) $.
      dihmeetlem4.p $e |- P = ( ( oc ` K ) ` W ) $.
      dihmeetlem4.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      dihmeetlem4.r $e |- R = ( ( trL ` K ) ` W ) $.
      dihmeetlem4.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      dihmeetlem4.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
      $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
         30-Mar-2014.)  (New usage is discouraged.) $)
      dihmeetlem4preN $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X
          .<_ W
          )
        /\ ( Q e. A /\ -. Q .<_ W ) )
          -> ( ( I ` Q ) i^i ( I ` ( X ./\ W ) ) ) = { .0. } ) $=
        ( vf vs chlt wcel wa wbr w3a cfv cin wrel csn wceq dihvalrel relin1 syl
        wn co 3ad2ant1 cp0 eqid dih0 releqd mpbid id cv cop elin dihopelvalcqat
        cid cres wb vex 3adant2 simp1 simp1l hllat simp2l simp1r lhpbase latmcl
        clat syl3anc latmle2 dihopelvalbN anbi12d simprll simprrr fveq1d simpl1
        syl12anc lhpocnel2 simpl3 ltrniotacl tendo02 3eqtrd jca simprr 3eqtr4rd
        simprl tendo0cl eqeltrd idltrn fveq2d trlid0 eqtrd simpl1l hlatl adantr
        cal atl0le syl2anc eqbrtrd jca31 impbida bitrd opex elsnc bitr2i syl6bb
        opth dvh0g sneqd eleq2d bitr4d syl5bb eqrelrdv2 syl21anc ) NUQURZRLURZU
        SZSBURZSROUTVJZUSZDAURDROUTVJUSZVAZDMVBZSRPVKZMVBZVCZVDZTVEZVDZUUIUUMUU
        OVFUUDUUGUUNUUHUUDUUJVDUUNLMNRDUEUFVGUUJUULVHVIVLUUDUUGUUPUUHUUDNVMVBZM
        VBZVDUUPLMNRUUQUEUFVGUUDUURUUOGLMNTRUUQUUQVNZUEUFUGUHVOVPVQVLUUIVRUUIUO
        UPUUMUUOUOVSZUPVSZVTZUUMURUVBUUJURZUVBUULURZUSZUUIUVBUUOURZUVBUUJUULWAU
        UIUVEUVBWCBWDZQVTZVEZURZUVFUUIUVEUUTUVGVFZUVAQVFZUSZUVJUUIUVEUUTKUVAVBZ
        VFZUVAJURZUSZUUTFURZUUTEVBZUUKOUTZUSZUVLUSZUSZUVMUUIUVCUVQUVDUWBUUDUUHU
        VCUVQWEUUGACDUVAFHJUUTKLMNORUBUDUEUJUKUMUFUIUOWFZUPWFZWBWGUUIUUDUUKBURZ
        UUKROUTZUVDUWBWEUUDUUGUUHWHUUINWOURZUUERBURZUWFUUIUUBUWHUUBUUCUUGUUHWIN
        WJVIZUUDUUEUUFUUHWKZUUIUUCUWIUUBUUCUUGUUHWLBLNRUAUEWMVIZBNPSRUAUCWNWPZU
        UIUWHUUEUWIUWGUWJUWKUWLBNOPSRUAUBUCWQWPBEUVAFIUUTLMNOQUQRUUKUAUBUEUKULU
        NUFWRXDWSUUIUWCUVMUUIUWCUSZUVKUVLUWNUUTUVNKQVBZUVGUUIUVOUVPUWBWTUWNKUVA
        QUUIUVQUWAUVLXAZXBUWNKFURZUWOUVGVFZUWNUUDCAURCROUTVJUSZUUHUWQUUDUUGUUHU
        WCXCZUWNUUDUWSUWTACLNORUBUDUEUJXEZVIUUDUUGUUHUWCXFACDFHKLNORUBUDUEUKUIX
        GZWPBFIKNQUNUAXHZVIXIUWPXJUUIUVMUSZUVOUVPUWBUXDUWOUVGUVNUUTUXDUWQUWRUXD
        UUDUWSUUHUWQUUDUUGUUHUVMXCZUXDUUDUWSUXEUXAVIUUDUUGUUHUVMXFUXBWPUXCVIUXD
        KUVAQUUIUVKUVLXKZXBUUIUVKUVLXMZXLUXDUVAQJUXFUXDUUDQJURUXEBFIJLNQRUAUEUK
        UMUNXNVIXOUXDUVRUVTUVLUXDUUTUVGFUXGUXDUUDUVGFURUXEBFLNRUAUEUKXPVIXOUXDU
        VSUUQUUKOUXDUVSUVGEVBZUUQUXDUUTUVGEUXGXQUXDUUDUXHUUQVFUXEBELNRUUQUAUUSU
        EULXRVIXSUXDNYCURZUWFUUQUUKOUTUXDUUBUXIUUBUUCUUGUUHUVMXTNYAVIUUIUWFUVMU
        WMYBBNOUUKUUQUAUBUUSYDYEYFUXFYGYGYHYIUVJUVBUVHVFUVMUVBUVHUUTUVAYJYKUUTU
        VAUVGQUWDUWEYNYLYMUUIUUOUVIUVBUUITUVHUUDUUGTUVHVFUUHBFGILNQRTUAUEUKUGUH
        UNYOVLYPYQYRYSYTUUA $.
    $}

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       30-Mar-2014.)  (New usage is discouraged.) $)
    dihmeetlem4N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ -. X .<_ W
        )
        /\ ( Q e. A /\ -. Q .<_ W ) )
          -> ( ( I ` Q ) i^i ( I ` ( X ./\ W ) ) ) = { .0. } ) $=
      ( vg vh coc cfv ctrl cltrn ctendo wceq crio cid cres cmpt dihmeetlem4preN
      cv eqid ) ABJGUCUDUDZCJGUEUDUDZJGUFUDUDZDUAUBJGUGUDUDZUPUAUNUDCUHUAURUIZE
      FGHIUBURUJBUKULZJKLMNOPQRSTUTUOUPUOURUOUQUOUSUOVAUOUM $.
  $}

  ${
    dihmeetlem5.b $e |- B = ( Base ` K ) $.
    dihmeetlem5.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem5.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem5.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem5.a $e |- A = ( Atoms ` K ) $.
    $( Part of proof that isomorphism H is order-preserving .  (Contributed by
       NM, 6-Apr-2014.) $)
    dihmeetlem5 $p |- ( ( ( K e. HL /\ X e. B /\ Y e. B )
         /\ ( Q e. A /\ Q .<_ X ) )
  -> ( X ./\ ( Y .\/ Q ) ) = ( ( X ./\ Y ) .\/ Q ) ) $=
      ( chlt wcel w3a wbr wa co simpl1 simprl simpl2 simpl3 atmod2i1 syl131anc
      wceq simprr eqcomd ) EOPZHBPZIBPZQZCAPZCHFRZSZSZHIGTCDTZHICDTGTZUQUJUNUKU
      LUOURUSUGUJUKULUPUAUMUNUOUBUJUKULUPUCUJUKULUPUDUMUNUOUHABCDEFGHIJKLMNUEUF
      UI $.
  $}

  ${
    dihmeetlem6.b $e |- B = ( Base ` K ) $.
    dihmeetlem6.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem6.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem6.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem6.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem6.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       6-Apr-2014.) $)
    dihmeetlem6 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
       /\ ( ( Q e. A /\ -. Q .<_ W ) /\ Q .<_ X ) )
  -> -. ( X ./\ ( Y .\/ Q ) ) .<_ W ) $=
      ( wcel wa wbr chlt w3a wn co simprlr clat simpl1l hllat syl simpl2 simpl3
      wb latmcl syl3anc simprll simpl1r lhpbase latjle12 syl13anc simpr syl6bir
      atbase mtod wceq simprr dihmeetlem5 syl32anc breq1d mtbird ) FUARZIDRZSZJ
      BRZKBRZUBZCARZCIGTZUCZSZCJGTZSZSZJKCEUDHUDZIGTJKHUDZCEUDZIGTZWBWFVQVOVPVR
      VTUEWBWFWDIGTZVQSZVQWBFUFRZWDBRZCBRZIBRZWHWFULWBVJWIVJVKVMVNWAUGZFUHUIZWB
      WIVMVNWJWNVLVMVNWAUJZVLVMVNWAUKZBFHJKLPUMUNWBVPWKVOVPVRVTUOZABCFLQVBUIWBV
      KWLVJVKVMVNWAUPBDFILNUQUIBEFGWDCILMOURUSWGVQUTVAVCWBWCWEIGWBVJVMVNVPVTWCW
      EVDWMWOWPWQVOVSVTVEABCEFGHJKLMOPQVFVGVHVI $.
  $}

  ${
    dihmeetlem7.b $e |- B = ( Base ` K ) $.
    dihmeetlem7.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem7.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem7.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem7.a $e |- A = ( Atoms ` K ) $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       6-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem7N $p |- ( ( ( K e. HL /\ X e. B
    /\ Y e. B ) /\ ( p e. A /\ -. p .<_ Y ) )
  -> ( ( ( X ./\ Y ) .\/ p ) ./\ Y ) = ( X ./\ Y ) ) $=
      ( wcel wbr co wceq syl syl3anc chlt w3a cv wn wa cp0 cfv simprr wb simpl1
      cal hlatl simprl simpl3 eqid atnle mpbid oveq2d clat hllat simpl2 latmle2
      latmcl atmod1i2 syl131anc col hlol olj01 syl2anc 3eqtr3d ) DUAOZGBOZHBOZU
      BZIUCZAOZVOHEPUDZUEZUEZGHFQZVOHFQZCQZVTDUFUGZCQZVTVOCQHFQZVTVSWAWCVTCVSVQ
      WAWCRZVNVPVQUHVSDUKOZVPVMVQWFUIVSVKWGVKVLVMVRUJZDULSVNVPVQUMZVKVLVMVRUNZA
      BVODEFHWCJKMWCUOZNUPTUQURVSVKVPVTBOZVMVTHEPZWBWERWHWIVSDUSOZVLVMWLVSVKWNW
      HDUTSZVKVLVMVRVAZWJBDFGHJMVCTZWJVSWNVLVMWMWOWPWJBDEFGHJKMVBTABVOCDEFVTHJK
      LMNVDVEVSDVFOZWLWDVTRVSVKWRWHDVGSWQBCDVTWCJLWKVHVIVJ $.
  $}

  ${
    dihjatc1.b $e |- B = ( Base ` K ) $.
    dihjatc1.l $e |- .<_ = ( le ` K ) $.
    dihjatc1.h $e |- H = ( LHyp ` K ) $.
    dihjatc1.j $e |- .\/ = ( join ` K ) $.
    dihjatc1.m $e |- ./\ = ( meet ` K ) $.
    dihjatc1.a $e |- A = ( Atoms ` K ) $.
    dihjatc1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjatc1.s $e |- .(+) = ( LSSum ` U ) $.
    dihjatc1.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Lemma for isomorphism H of a lattice meet.  TODO: shorter proof if we
       change ` .\/ ` order of ` ( X ./\ Y ) .\/ Q ` here and down?
       (Contributed by NM, 6-Apr-2014.) $)
    dihjatc1 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B
    /\ Y e. B ) /\ ( Q e. A /\ -. Q .<_ W )
            /\ ( Q .<_ X /\ ( X ./\ Y ) .<_ W ) )
 -> ( I ` ( ( X ./\ Y ) .\/ Q ) ) = ( ( I ` Q ) .(+) ( I ` ( X ./\ Y ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn co wceq simp11 clat simp11l hllat simp12 simp13
      cfv latmcl syl3anc simp2l atbase latjcl simp2 simp3l dihmeetlem6 syl32anc
      syl dihmeetlem5 breq1d mtbid latlej2 dihvalcq2 syl122anc cp0 eqid syl2anc
      lhpmat oveq2d simp11r lhpbase simp3r atmod1i2 syl131anc col olj01 3eqtr3d
      hlol fveq2d eqtrd ) IUDUEZLFUEZUFZMBUEZNBUEZUGZDAUEZDLJUHUIZUFZDMJUHZMNKU
      JZLJUHZUFZUGZXADHUJZGURZDGURZXELKUJZGURZCUJZXGXAGURZCUJXDWMXEBUEZXELJUHZU
      IWSDXEJUHZXFXJUKWMWNWOWSXCULZXDIUMUEZXABUEZDBUEZXLXDWKXPWKWLWNWOWSXCUNZIU
      OVHZXDXPWNWOXQXTWMWNWOWSXCUPZWMWNWOWSXCUQZBIKMNOSUSUTZXDWQXRWPWQWRXCVAZAB
      DIOTVBVHZBHIXADORVCUTXDMNDHUJKUJZLJUHZXMXDWMWNWOWSWTYGUIXOYAYBWPWSXCVDZWP
      WSWTXBVEZABDFHIJKLMNOPQRSTVFVGXDYFXELJXDWKWNWOWQWTYFXEUKXSYAYBYDYIABDHIJK
      MNOPRSTVIVGVJVKYHXDXPXQXRXNXTYCYEBHIJXADOPRVLUTABCDEFGHIJKLXEOPRSTQUCUAUB
      VMVNXDXIXKXGCXDXHXAGXDXADLKUJZHUJZXAIVOURZHUJZXHXAXDYJYLXAHXDWMWSYJYLUKXO
      YHADFIJKLYLPSYLVPZTQVRVQVSXDWKWQXQLBUEZXBYKXHUKXSYDYCXDWLYOWKWLWNWOWSXCVT
      BFILOQWAVHWPWSWTXBWBABDHIJKXALOPRSTWCWDXDIWEUEZXQYMXAUKXDWKYPXSIWHVHYCBHI
      XAYLORYNWFVQWGWIVSWJ $.

    $( Isomorphism H of join with an atom.  (Contributed by NM, 26-Aug-2014.)
       (New usage is discouraged.) $)
    dihjatc2N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B
    /\ Y e. B ) /\ ( Q e. A /\ -. Q .<_ W )
            /\ ( Q .<_ X /\ ( X ./\ Y ) .<_ W ) )
 -> ( I ` ( Q .\/ ( X ./\ Y ) ) ) = ( ( I ` Q ) .(+) ( I ` ( X ./\ Y ) ) ) ) $=
      ( chlt wcel wa w3a wbr wn co clat wceq simp11l hllat simp2l atbase simp12
      cfv syl simp13 latmcl syl3anc latjcom fveq2d dihjatc1 eqtrd ) IUDUEZLFUEZ
      UFZMBUEZNBUEZUGZDAUEZDLJUHUIZUFZDMJUHMNKUJZLJUHUFZUGZDVPHUJZGURVPDHUJZGUR
      DGURVPGURCUJVRVSVTGVRIUKUEZDBUEZVPBUEZVSVTULVRVGWAVGVHVJVKVOVQUMIUNUSZVRV
      MWBVLVMVNVQUOABDIOTUPUSVRWAVJVKWCWDVIVJVKVOVQUQVIVJVKVOVQUTBIKMNOSVAVBBHI
      DVPORVCVBVDABCDEFGHIJKLMNOPQRSTUAUBUCVEVF $.

    $( Isomorphism H of join with an atom.  (Contributed by NM,
       26-Aug-2014.) $)
    dihjatc3 $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B
    /\ Y e. B ) /\ ( Q e. A /\ -. Q .<_ W )
            /\ ( Q .<_ X /\ ( X ./\ Y ) .<_ W ) )
 -> ( I ` ( ( X ./\ Y ) .\/ Q ) ) = ( ( I ` ( X ./\ Y ) ) .(+) ( I ` Q ) ) ) $=
      ( chlt wcel wa w3a wbr wn co cfv dihjatc1 cabel csubg wceq simp11 dvhlmod
      clmod lmodabl syl clss wss eqid lsssssubg clat hllat simp12 simp13 latmcl
      simp11l syl3anc dihlss syl2anc sseldd simp2l atbase lsmcom eqtr4d ) IUDUE
      ZLFUEZUFZMBUEZNBUEZUGZDAUEZDLJUHUIZUFZDMJUHMNKUJZLJUHUFZUGZWHDHUJGUKDGUKZ
      WHGUKZCUJZWLWKCUJZABCDEFGHIJKLMNOPQRSTUAUBUCULWJEUMUEZWLEUNUKZUEWKWPUEWNW
      MUOWJEURUEZWOWJEFILQUAWAWBWCWGWIUPZUQZEUSUTWJEVAUKZWPWLWJWQWTWPVBWSWTEWTV
      CZVDUTZWJWAWHBUEZWLWTUEWRWJIVEUEZWBWCXCWJVSXDVSVTWBWCWGWIVJIVFUTWAWBWCWGW
      IVGWAWBWCWGWIVHBIKMNOSVIVKBWTEFGILWHOQUCUAXAVLVMVNWJWTWPWKXBWJWADBUEZWKWT
      UEWRWJWEXEWDWEWFWIVOABDIOTVPUTBWTEFGILDOQUCUAXAVLVMVNCWLWKEUBVQVKVR $.
  $}

  ${
    dihmeetlem8.b $e |- B = ( Base ` K ) $.
    dihmeetlem8.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem8.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem8.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem8.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem8.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem8.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihmeetlem8.s $e |- .(+) = ( LSSum ` U ) $.
    dihmeetlem8.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Lemma for isomorphism H of a lattice meet.  TODO: shorter proof if we
       change ` .\/ ` order of ` ( X ./\ Y ) .\/ p ` here and down?
       (Contributed by NM, 6-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem8N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B
    /\ Y e. B ) /\ ( p e. A /\ -. p .<_ W )
            /\ ( p .<_ X /\ ( X ./\ Y ) .<_ W ) )
  -> ( I ` ( ( X ./\ Y ) .\/ p ) )
        = ( ( I ` p ) .(+) ( I ` ( X ./\ Y ) ) ) ) $=
      ( cv dihjatc1 ) ABCNUDDEFGHIJKLMOPQRSTUAUBUCUE $.
  $}

  ${
    dihmeetlem9.b $e |- B = ( Base ` K ) $.
    dihmeetlem9.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem9.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem9.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem9.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem9.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem9.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihmeetlem9.s $e |- .(+) = ( LSSum ` U ) $.
    dihmeetlem9.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       6-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem9N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B )
       /\ p e. A )
  -> ( ( ( I ` p ) .(+) ( I ` ( X ./\ Y ) ) ) i^i ( I ` Y ) )
            = ( ( I ` ( X ./\ Y ) ) .(+) ( ( I ` p ) i^i ( I ` Y ) ) ) ) $=
      ( chlt wcel wa cv w3a co cfv cin csubg wceq clss clmod simp1 dvhlmod eqid
      wss lsssssubg syl clat simp1l simp2l simp2r latmcl syl3anc dihlss syl2anc
      hllat sseldd atbase 3ad2ant3 wbr latmle2 wb dihord mpbird lsmmod syl31anc
      cabel lmodabl lsmcom ineq1d eqtr2d ) HUDUEZKEUEZUFZLBUEZMBUEZUFZNUGZAUEZU
      HZLMJUIZFUJZWLFUJZMFUJZUKCUIZWPWQCUIZWRUKZWQWPCUIZWRUKWNWPDULUJZUEZWQXCUE
      ZWRXCUEWPWRUSZWSXAUMWNDUNUJZXCWPWNDUOUEZXGXCUSWNDEHKQUAWHWKWMUPZUQZXGDXGU
      RZUTVAZWNWHWOBUEZWPXGUEXIWNHVBUEZWIWJXMWNWFXNWFWGWKWMVCHVJVAZWHWIWJWMVDZW
      HWIWJWMVEZBHJLMOSVFVGZBXGDEFHKWOOQUCUAXKVHVIVKZWNXGXCWQXLWNWHWLBUEZWQXGUE
      XIWMWHXTWKABWLHOTVLVMBXGDEFHKWLOQUCUAXKVHVIVKZWNXGXCWRXLWNWHWJWRXGUEXIXQB
      XGDEFHKMOQUCUAXKVHVIVKWNXFWOMIVNZWNXNWIWJYBXOXPXQBHIJLMOPSVOVGWNWHXMWJXFY
      BVPXIXRXQBEFHIKWOMOPQUCVQVGVRCWPWQWRDUBVSVTWNWTXBWRWNDWAUEZXDXEWTXBUMWNXH
      YCXJDWBVAXSYACWPWQDUBWCVGWDWE $.

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       6-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem10N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
     /\ ( ( p e. A /\ -. p .<_ W ) /\ p .<_ X ) )
  -> ( I ` ( ( X ./\ Y ) .\/ p ) )
        = ( ( I ` X ) i^i ( I ` ( Y .\/ p ) ) ) ) $=
      ( chlt wcel wa w3a cv wbr wn co cfv cin wceq simpl1l simpl2 simpl3 simprr
      simprll dihmeetlem5 syl32anc fveq2d simpl1 clat syl atbase latjcl syl3anc
      hllat dihmeetlem6 dihmeetcN syl121anc eqtr3d ) HUDUEZKEUEZUFZLBUEZMBUEZUG
      ZNUHZAUEZVTKIUIUJZUFZVTLIUIZUFZUFZLMVTGUKZJUKZFULZLMJUKVTGUKZFULLFULWGFUL
      UMZWFWHWJFWFVNVQVRWAWDWHWJUNVNVOVQVRWEUOZVPVQVRWEUPZVPVQVRWEUQZVSWAWBWDUS
      ZVSWCWDURABVTGHIJLMOPRSTUTVAVBWFVPVQWGBUEZWHKIUIUJWIWKUNVPVQVRWEVCWMWFHVD
      UEZVRVTBUEZWPWFVNWQWLHVIVEWNWFWAWRWOABVTHOTVFVEBGHMVTORVGVHABVTEGHIJKLMOP
      QRSTVJBEFHIJKLWGOPSQUCVKVLVM $.

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       6-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem11N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
     /\ ( ( p e. A /\ -. p .<_ W ) /\ p .<_ X ) )
  -> ( ( I ` ( ( X ./\ Y ) .\/ p ) ) i^i ( I ` Y ) )
                 = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( chlt wcel wa w3a cv wbr wn cfv cin dihmeetlem10N ineq1d inass wceq clat
      wss simpl1l hllat syl simpl3 simprll atbase latlej1 syl3anc simpl1 latjcl
      co wb dihord mpbird sseqin2 sylib ineq2d syl5eq eqtrd ) HUDUEZKEUEZUFZLBU
      EZMBUEZUGZNUHZAUEZWDKIUIUJZUFWDLIUIZUFZUFZLMJVIWDGVIFUKZMFUKZULLFUKZMWDGV
      IZFUKZULZWKULZWLWKULZWIWJWOWKABCDEFGHIJKLMNOPQRSTUAUBUCUMUNWIWPWLWNWKULZU
      LWQWLWNWKUOWIWRWKWLWIWKWNURZWRWKUPWIWSMWMIUIZWIHUQUEZWBWDBUEZWTWIVRXAVRVS
      WAWBWHUSHUTVAZVTWAWBWHVBZWIWEXBWCWEWFWGVCABWDHOTVDVAZBGHIMWDOPRVEVFWIVTWB
      WMBUEZWSWTVJVTWAWBWHVGXDWIXAWBXBXFXCXDXEBGHMWDORVHVFBEFHIKMWMOPQUCVKVFVLW
      KWNVMVNVOVPVQ $.

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       6-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem12N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
     /\ ( ( p e. A /\ -. p .<_ W ) /\ p .<_ X /\ ( X ./\ Y ) .<_ W ) )
    -> ( ( I ` ( X ./\ Y ) ) .(+) ( ( I ` p ) i^i ( I ` Y ) ) )
        = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( chlt wcel wa w3a cv wbr cfv cin wceq simpl1 simpl2 simpl3 simpr1 simpr2
      wn co simpr3 dihmeetlem8N syl312anc ineq1d dihmeetlem11N 3adantr3 simpr1l
      dihmeetlem9N syl121anc 3eqtr3rd ) HUDUEKEUEUFZLBUEZMBUEZUGZNUHZAUEZVNKIUI
      URZUFZVNLIUIZLMJUSZKIUIZUGZUFZVSVNGUSFUJZMFUJZUKZVNFUJZVSFUJZCUSZWDUKZLFU
      JWDUKZWGWFWDUKCUSZWBWCWHWDWBVJVKVLVQVRVTWCWHULVJVKVLWAUMZVJVKVLWAUNZVJVKV
      LWAUOZVMVQVRVTUPVMVQVRVTUQVMVQVRVTUTABCDEFGHIJKLMNOPQRSTUAUBUCVAVBVCVMVQV
      RWEWJULVTABCDEFGHIJKLMNOPQRSTUAUBUCVDVEWBVJVKVLVOWIWKULWLWMWNVOVPVRVTVMVF
      ABCDEFGHIJKLMNOPQRSTUAUBUCVGVHVI $.
  $}

  ${
    $d f h s .<_ $.  $d f h s A $.  $d h B $.  $d f h s H $.  $d f s I $.
    $d f h s K $.  $d h P $.  $d f h s Q $.  $d f h s R $.  $d h T $.
    $d f h s W $.  $d f s .0. $.
    dihmeetlem13.b $e |- B = ( Base ` K ) $.
    dihmeetlem13.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem13.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem13.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem13.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem13.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihmeetlem13.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihmeetlem13.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihmeetlem13.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
    dihmeetlem13.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihmeetlem13.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihmeetlem13.z $e |- .0. = ( 0g ` U ) $.
    dihmeetlem13.f $e |- F = ( iota_ h e. T ( h ` P ) = Q ) $.
    dihmeetlem13.g $e |- G = ( iota_ h e. T ( h ` P ) = R ) $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       7-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem13N $p |- ( ( ( K e. HL /\ W e. H ) /\ ( ( Q e. A /\ -. Q .<_
        W )
        /\ ( R e. A /\ -. R .<_ W ) ) /\ Q =/= R )
       -> ( ( I ` Q ) i^i ( I ` R ) ) = { .0. } ) $=
      ( vf vs chlt wcel wa wbr wn wne w3a cfv cin csn dihvalrel 3ad2ant1 relin1
      wrel syl cv cop cid cres wceq elin wb simp1 simp2l dihopelvalcqat syl2anc
      vex simp2r anbi12d syl5bb simprll simpl3 fveq1 simpl1 simpl2l ltrniotaval
      syl3anc simpl2r eqeq12d syl5ib necon3d mpd simp2ll simp2rl eqtr3d simp2rr
      lhpocnel2 simp11 simp3 simp12l simp12r tendospcanN syl122anc mpbid 3expia
      ltrniotacl necon1d fveq1d tendo02 3eqtrd jca ex sylbid dvh0g sneqd eleq2d
      opex elsnc opth bitr2i syl6rbbr sylibd relssdv clmod clss wss atbase eqid
      dvhlmod dihlss lssincl lss0ss eqssd ) OUPUQRLUQURZDAUQZDRPUSUTZURZEAUQZER
      PUSUTZURZURZDEVAZVBZDMVCZEMVCZVDZSVEZUUHUNUOUUKUULUUHUUIVIZUUKVIYSUUFUUMU
      UGLMORDUDUIVFVGUUIUUJVHVJUUHUNVKZUOVKZVLZUUKUQZUUNVMBVNZVOZUUOQVOZURZUUPU
      ULUQZUUHUUQUUNJUUOVCZVOZUUOIUQZURZUUNKUUOVCZVOZUVEURZURZUVAUUQUUPUUIUQZUU
      PUUJUQZURUUHUVJUUPUUIUUJVPUUHUVKUVFUVLUVIUUHYSUUBUVKUVFVQYSUUFUUGVRZYSUUB
      UUEUUGVSACDUUOFHIUUNJLMOPRUAUCUDUEUFUGUIULUNWBZUOWBZVTWAUUHYSUUEUVLUVIVQU
      VMYSUUBUUEUUGWCACEUUOFHIUUNKLMOPRUAUCUDUEUFUGUIUMUVNUVOVTWAWDWEUUHUVJUVAU
      UHUVJURZUUSUUTUVPUUNUVCJQVCZUURUUHUVDUVEUVIWFUVPJUUOQUVPJKVAZUUTUVPUUGUVR
      YSUUFUUGUVJWGUVPJKDEJKVOZCJVCZCKVCZVOUVPDEVOCJKWHUVPUVTDUWAEUVPYSCAUQCRPU
      SUTURZUUBUVTDVOYSUUFUUGUVJWIZUVPYSUWBUWCACLOPRUAUCUDUEXBZVJZUUBUUEYSUUGUV
      JWJZACDFHJLOPRUAUCUDUFULWKWLUVPYSUWBUUEUWAEVOUWCUWEUUBUUEYSUUGUVJWMACEFHK
      LOPRUAUCUDUFUMWKWLWNWOWPWQUVPUUOQJKUUHUVJUUOQVAZUVSUUHUVJUWGVBZUVCUVGVOZU
      VSUWHUUNUVCUVGUVDUVEUVIUUHUWGWRUVHUVEUVFUUHUWGWSWTUWHYSUVEUWGJFUQZKFUQZUW
      IUVSVQYSUUFUUGUVJUWGXCZUVHUVEUVFUUHUWGXAUUHUVJUWGXDUWHYSUWBUUBUWJUWLUWHYS
      UWBUWLUWDVJZUUBUUEYSUUGUVJUWGXEACDFHJLOPRUAUCUDUFULXKZWLUWHYSUWBUUEUWKUWL
      UWMUUBUUEYSUUGUVJUWGXFACEFHKLOPRUAUCUDUFUMXKWLBUUOFHIJKLOQRTUDUFUGUHXGXHX
      IXJXLWQZXMUVPUWJUVQUURVOUVPYSUWBUUBUWJUWCUWEUWFUWNWLBFHJOQUHTXNVJXOUWOXPX
      QXRUUHUVBUUPUURQVLZVEZUQZUVAUUHUULUWQUUPUUHSUWPYSUUFSUWPVOUUGBFGHLOQRSTUD
      UFUJUKUHXSVGXTYAUWRUUPUWPVOUVAUUPUWPUUNUUOYBYCUUNUUOUURQUVNUVOYDYEYFYGYHU
      UHGYIUQZUUKGYJVCZUQZUULUUKYKUUHGLORUDUJUVMYNZUUHUWSUUIUWTUQZUUJUWTUQZUXAU
      XBUUHYSDBUQZUXCUVMUUHYTUXEYTUUAUUEYSUUGWRABDOTUCYLVJBUWTGLMORDTUDUIUJUWTY
      MZYOWAUUHYSEBUQZUXDUVMUUHUUCUXGUUCUUDUUBYSUUGWSABEOTUCYLVJBUWTGLMORETUDUI
      UJUXFYOWAUWTUUIUUJGUXFYPWLUWTGUUKSUKUXFYQWAYR $.
  $}

  ${
    $d h .<_ $.  $d h A $.  $d h B $.  $d h H $.  $d h K $.  $d h R $.
    $d h W $.  $d h p $.  $d h r $.
    dihmeetlem14.b $e |- B = ( Base ` K ) $.
    dihmeetlem14.l $e |- .<_ = ( le ` K ) $.
    dihmeetlem14.h $e |- H = ( LHyp ` K ) $.
    dihmeetlem14.j $e |- .\/ = ( join ` K ) $.
    dihmeetlem14.m $e |- ./\ = ( meet ` K ) $.
    dihmeetlem14.a $e |- A = ( Atoms ` K ) $.
    dihmeetlem14.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihmeetlem14.s $e |- .(+) = ( LSSum ` U ) $.
    dihmeetlem14.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       7-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem14N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ Y e. B /\ p e. B )
     /\ ( ( r e. A /\ -. r .<_ W ) /\ r .<_ Y /\ ( Y ./\ p ) .<_ W ) )
    -> ( ( I ` ( Y ./\ p ) ) .(+) ( ( I ` r ) i^i ( I ` p ) ) )
        = ( ( I ` Y ) i^i ( I ` p ) ) ) $=
      ( cv dihmeetlem12N ) ABCDEFGHIJKLNUDMOPQRSTUAUBUCUE $.

    ${
      dihmeetlem15.z $e |- .0. = ( 0g ` U ) $.
      $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
         7-Apr-2014.)  (New usage is discouraged.) $)
      dihmeetlem15N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ Y e. B
         /\ ( p e. A /\ -. p .<_ W ) )
     /\ ( ( r e. A /\ -. r .<_ W ) /\ r .<_ Y /\ ( Y ./\ p ) .<_ W ) )
    -> ( ( I ` r ) i^i ( I ` p ) ) = { .0. } ) $=
        ( vh chlt wcel wa cv wbr wn w3a co wne cfv cin csn simpl1 simpr1 simpl3
        wceq simpl3r weq simp3 simp22 eqbrtrrd clat wb simp11l hllat syl atbase
        simp13l simp12 latleeqm2 syl3anc mpbid simp23 3expia necon3bd mpd cltrn
        coc ctendo crio cid cres cmpt eqid dihmeetlem13N syl121anc ) HUGUHZKEUH
        ZUIZLBUHZOUJZAUHZWQKIUKZULZUIZUMZNUJZAUHXCKIUKULUIZXCLIUKZLWQJUNZKIUKZU
        MZUIZWOXDXAXCWQUOZXCFUPWQFUPUQMURVBWOWPXAXHUSXBXDXEXGUTWOWPXAXHVAXIWTXJ
        WRWTWOWPXHVCXIWSXCWQXBXHNOVDZWSXBXHXKUMZXFWQKIXLWQLIUKZXFWQVBZXLXCWQLIX
        BXHXKVEXBXDXEXGXKVFVGXLHVHUHZWQBUHZWPXMXNVIXLWMXOWMWNWPXAXHXKVJHVKVLXLW
        RXPWRWTWOWPXHXKVNABWQHPUAVMVLWOWPXAXHXKVOBHIJWQLPQTVPVQVRXBXDXEXGXKVSVG
        VTWAWBABKHWDUPUPZXCWQKHWCUPUPZDUFKHWEUPUPZXQUFUJUPZXCVBUFXRWFZXTWQVBUFX
        RWFZEFGHIUFXRWGBWHWIZKMPQSUARXQWJXRWJXSWJYCWJUDUBUEYAWJYBWJWKWL $.
    $}

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       7-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem16N $p |- ( ( ( ( K e. HL /\ W e. H ) /\ Y e. B
            /\ ( p e. A /\ -. p .<_ W ) )
     /\ ( ( r e. A /\ -. r .<_ W ) /\ r .<_ Y /\ ( Y ./\ p ) .<_ W ) )
    -> ( I ` ( Y ./\ p ) ) = ( ( I ` Y ) i^i ( I ` p ) ) ) $=
      ( chlt wcel wa cv wbr wn w3a co cfv cin c0g csn eqid dihmeetlem15N oveq2d
      wceq simpl1 simpl2 atbase syl simpr1 simpr2 simpr3 dihmeetlem14N syl33anc
      simpl3l csubg clmod clss dvhlmod clat simpl1l hllat latmcl syl3anc dihlss
      syl2anc lsssubg lsm01 3eqtr3rd ) HUDUEZKEUEZUFZLBUEZNUGZAUEZWHKIUHUIZUFZU
      JZMUGZAUEWMKIUHUIUFZWMLIUHZLWHJUKZKIUHZUJZUFZWPFULZWMFULWHFULZUMZCUKZWTDU
      NULZUOZCUKZLFULXAUMZWTWSXBXEWTCABCDEFGHIJKLXDMNOPQRSTUAUBUCXDUPZUQURWSWFW
      GWHBUEZWNWOWQXCXGUSWFWGWKWRUTZWFWGWKWRVAZWSWIXIWIWJWFWGWRVIABWHHOTVBVCZWL
      WNWOWQVDWLWNWOWQVEWLWNWOWQVFABCDEFGHIJKLMNOPQRSTUAUBUCVGVHWSWTDVJULUEZXFW
      TUSWSDVKUEWTDVLULZUEZXMWSDEHKQUAXJVMWSWFWPBUEZXOXJWSHVNUEZWGXIXPWSWDXQWDW
      EWGWKWRVOHVPVCXKXLBHJLWHOSVQVRBXNDEFHKWPOQUCUAXNUPZVSVTXNWTDXRWAVTCDWTXDX
      HUBWBVCWC $.

    ${
      dihmeetlem17.o $e |- .0. = ( 0. ` K ) $.
      $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
         7-Apr-2014.)  (New usage is discouraged.) $)
      dihmeetlem17N $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( X e. B /\ -. X .<_ W ) /\ ( p e. A /\ -. p .<_ W ) )
       /\ ( Y e. B /\ ( X ./\ Y ) .<_ W /\ p .<_ X ) )
    -> ( Y ./\ p ) = .0. ) $=
        ( chlt wcel wa wbr wn cv w3a clat wceq simpl1l hllat syl simpl3l atbase
        simpr1 latmcom syl3anc simpl1 simpl2 simpl3 simpr2 simpr3 lhpmcvr4N cal
        co syl123anc wb hlatl atnle mpbid eqtr3d ) HUFUGZKEUGZUHZLBUGLKIUIUJUHZ
        OUKZAUGZWAKIUIUJZUHZULZMBUGZLMJVJKIUIZWALIUIZULZUHZWAMJVJZMWAJVJZNWJHUM
        UGZWABUGZWFWKWLUNWJVQWMVQVRVTWDWIUOZHUPUQWJWBWNWBWCVSVTWIURZABWAHPUAUSU
        QWEWFWGWHUTZBHJWAMPTVAVBWJWAMIUIUJZWKNUNZWJVSVTWDWFWGWHWRVSVTWDWIVCVSVT
        WDWIVDVSVTWDWIVEWQWEWFWGWHVFWEWFWGWHVGABWAEGHIJKLMPQSTUARVHVKWJHVIUGZWB
        WFWRWSVLWJVQWTWOHVMUQWPWQABWAHIJMNPQTUEUAVNVBVOVP $.
    $}

    ${
      dihmeetlem18.z $e |- .0. = ( 0g ` U ) $.
      $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
         7-Apr-2014.)  (New usage is discouraged.) $)
      dihmeetlem18N $p |- ( ( ( ( K e. HL /\ W e. H )
              /\ ( X e. B /\ -. X .<_ W ) /\ Y e. B )
          /\ ( ( p e. A /\ -. p .<_ W ) /\ ( r e. A /\ -. r .<_ W )
              /\ ( p .<_ X /\ r .<_ Y /\ ( X ./\ Y ) .<_ W ) ) )
      -> ( ( I ` Y ) i^i ( I ` p ) ) = { .0. } ) $=
        ( chlt wcel wa wbr wn w3a cv co cfv cp0 cin simpl1 simpl2 simpr1 simpl3
        csn wceq simpr33 simpr31 eqid dihmeetlem17N syl33anc fveq2d simpr2 cops
        simpr32 simpl1l syl simpl1r lhpbase op0le syl2anc eqbrtrd dihmeetlem16N
        hlop dih0 3eqtr3d ) HUGUHZKEUHZUIZLBUHLKIUJUKUIZMBUHZULZPUMZAUHWJKIUJUK
        UIZOUMZAUHWLKIUJUKUIZWJLIUJZWLMIUJZLMJUNKIUJZULZULZUIZMWJJUNZFUOZHUPUOZ
        FUOZMFUOWJFUOUQZNVBZWSWTXBFWSWFWGWKWHWPWNWTXBVCWFWGWHWRURZWFWGWHWRUSWIW
        KWMWQUTZWFWGWHWRVAZWNWOWPWKWMWIVDWNWOWPWKWMWIVEABCDEFGHIJKLMXBPQRSTUAUB
        UCUDUEXBVFZVGVHZVIWSWFWHWKWMWOWTKIUJXAXDVCXFXHXGWIWKWMWQVJWNWOWPWKWMWIV
        LWSWTXBKIXJWSHVKUHZKBUHZXBKIUJWSWDXKWDWEWGWHWRVMHWAVNWSWEXLWDWEWGWHWRVO
        BEHKQSVPVNBHIKXBQRXIVQVRVSABCDEFGHIJKMOPQRSTUAUBUCUDUEVTVHWSWFXCXEVCXFD
        EFHNKXBXISUEUCUFWBVNWC $.
    $}

    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       7-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem19N $p |- ( ( ( ( K e. HL /\ W e. H )
            /\ ( X e. B /\ -. X .<_ W ) /\ Y e. B )
        /\ ( ( p e. A /\ -. p .<_ W ) /\ ( r e. A /\ -. r .<_ W )
            /\ ( p .<_ X /\ r .<_ Y /\ ( X ./\ Y ) .<_ W ) ) )
    -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( chlt wcel wa wbr wn w3a cv co cfv cin c0g csn eqid dihmeetlem18N syl5eq
      incom oveq2d simpl1 simpl2l simpl3 simpr31 simpr33 dihmeetlem12N syl33anc
      wceq simpr1 csubg clmod clss dvhlmod clat simpl1l hllat syl latmcl dihlss
      syl3anc syl2anc lsssubg lsm01 3eqtr3rd ) HUEUFZKEUFZUGZLBUFZLKIUHUIZUGZMB
      UFZUJZOUKZAUFWNKIUHUIUGZNUKZAUFWPKIUHUIUGZWNLIUHZWPMIUHZLMJULZKIUHZUJZUJZ
      UGZWTFUMZWNFUMZMFUMZUNZCULZXEDUOUMZUPZCULZLFUMXGUNZXEXDXHXKXECXDXHXGXFUNX
      KXFXGUTABCDEFGHIJKLMXJNOPQRSTUAUBUCUDXJUQZURUSVAXDWHWIWLWOWRXAXIXMVIWHWKW
      LXCVBZWIWJWHWLXCVCZWHWKWLXCVDZWMWOWQXBVJWRWSXAWOWQWMVEWRWSXAWOWQWMVFABCDE
      FGHIJKLMOPQRSTUAUBUCUDVGVHXDXEDVKUMUFZXLXEVIXDDVLUFXEDVMUMZUFZXRXDDEHKRUB
      XOVNXDWHWTBUFZXTXOXDHVOUFZWIWLYAXDWFYBWFWGWKWLXCVPHVQVRXPXQBHJLMPTVSWABXS
      DEFHKWTPRUDUBXSUQZVTWBXSXEDYCWCWBCDXEXJXNUCWDVRWE $.

    $d q r ./\ $.  $d q r .<_ $.  $d q r A $.  $d q r B $.  $d q r H $.
    $d q r I $.  $d q r K $.  $d q r W $.  $d q r X $.  $d q r Y $.
    $( Lemma for isomorphism H of a lattice meet.  (Contributed by NM,
       7-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetlem20N $p |- ( ( ( K e. HL /\ W e. H )
            /\ ( X e. B /\ -. X .<_ W ) /\ ( ( Y e. B /\ -. Y .<_ W )
          /\ ( X ./\ Y ) .<_ W ) )
    -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( vq vr chlt wcel wa wbr wn co w3a wrex cfv cin wceq simp1 simp3ll simp3r
      simp2 lhpmcvr6N syl112anc simp3l simp2l clat simp1l hllat latmcom syl3anc
      syl eqbrtrd reeanv simp11 simp12 3ad2ant1 simp3l1 simp3r1 simp3l3 simp3r3
      cv jca simp2r simp13r 3jca dihmeetlem19N syl33anc 3exp rexlimdvv syl5bir
      mp2and ) HUEUFZKEUFZUGZLBUFZLKIUHUIZUGZMBUFZMKIUHUIZUGZLMJUJZKIUHZUGZUKZU
      CVSZKIUHUIZXCMIUHUIZXCLIUHZUKZUCAULZUDVSZKIUHUIZXILIUHUIZXIMIUHZUKZUDAULZ
      WSFUMLFUMMFUMUNUOZXBWLWOWPWTXHWLWOXAUPZWLWOXAUSWPWQWTWLWOUQZWLWOWRWTURZAB
      EGHIJKLMUCNOQRSPUTVAXBWLWRWMMLJUJZKIUHXNXPWLWOWRWTVBWLWMWNXAVCZXBXSWSKIXB
      HVDUFZWPWMXSWSUOXBWJYAWJWKWOXAVEHVFVIXQXTBHJMLNRVGVHXRVJABEGHIJKMLUDNOQRS
      PUTVAXHXNUGXGXMUGZUDAULUCAULXBXOXGXMUCUDAAVKXBYBXOUCUDAAXBXCAUFZXIAUFZUGZ
      YBXOXBYEYBUKZWLWOWPYCXDUGYDXJUGXFXLWTUKXOWLWOXAYEYBVLWLWOXAYEYBVMXBYEWPYB
      XQVNYFYCXDXBYCYDYBVCXDXEXFXMXBYEVOVTYFYDXJXBYCYDYBWAXJXKXLXGXBYEVPVTYFXFX
      LWTXDXEXFXMXBYEVQXJXKXLXGXBYEVRWRWTWLWOYEYBWBWCABCDEFGHIJKLMUDUCNOPQRSTUA
      UBWDWEWFWGWHWI $.

  $}

  ${
    dihmeetALT.b $e |- B = ( Base ` K ) $.
    dihmeetALT.m $e |- ./\ = ( meet ` K ) $.
    dihmeetALT.h $e |- H = ( LHyp ` K ) $.
    dihmeetALT.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Isomorphism H of a lattice meet.  This version does not depend on the
       atomisticity of the constructed vector space.  TODO:  Delete?
       (Contributed by NM, 7-Apr-2014.)  (New usage is discouraged.) $)
    dihmeetALTN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
     -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( wcel wa cfv wbr wceq simpr eqid wn chlt w3a cple cin clat simpl1l hllat
      syl simpl2 simpl3 latmcom syl3anc fveq2d simpl1 dihmeetbN syl112anc incom
      syl6eq eqtrd simpll1 simpll2 simpll3 adantlr simp1l1 simp1l2 simp1r simp3
      co simp1l3 jca simp2 catm cdvh clsm cjn dihmeetlem20N syl122anc pm2.61dan
      3expa dihmeetcN syl121anc ) DUAMZFBMZNZGAMZHAMZUBZGFDUCOZPZGHEVHZCOZGCOZH
      COZUDZQZWGWINZWKHGEVHZCOZWNWPWJWQCWPDUEMZWEWFWJWQQWPWBWSWBWCWEWFWIUFDUGUH
      WDWEWFWIUIZWDWEWFWIUJZADEGHIJUKULUMWPWRWMWLUDZWNWPWDWFWEWIWRXBQWDWEWFWIUN
      XAWTWGWIRABCDWHEFHGIWHSZJKLUOUPWMWLUQURUSWGWITZNZWJFWHPZWOXEXFNHFWHPZWOXE
      XGWOXFXEXGNWDWEWFXGWOWDWEWFXDXGUTWDWEWFXDXGVAWDWEWFXDXGVBXEXGRABCDWHEFGHI
      XCJKLUOUPVCXEXFXGTZWOXEXFXHUBZWDWEXDWFXHNXFWOWDWEWFXDXFXHVDWDWEWFXDXFXHVE
      WGXDXFXHVFXIWFXHWDWEWFXDXFXHVIXEXFXHVGVJXEXFXHVKDVLOZAFDVMOOZVNOZXKBCDVOO
      ZDWHEFGHIXCKXMSJXJSXKSXLSLVPVQVSVRXEXFTZNWDWEWFXNWOWDWEWFXDXNUTWDWEWFXDXN
      VAWDWEWFXDXNVBXEXNRABCDWHEFGHIXCJKLVTWAVRVR $.
  $}

  ${
    $d h .<_ $.  $d v .0. $.  $d h B $.  $d f g i p r s t u v E $.  $d t u F $.
    $d h C $.  $d v D $.  $d g i p r t G $.  $d g h r t J $.  $d f s t u v N $.
    $d f g h i p r s t u v K $.  $d f g h i p s t u v T $.  $d f h s t u v U $.
    $d f h i p s t u v H $.  $d f i p s t u v V $.  $d f g h i p r s t u v W $.
    $d f s v I $.  $d i p t u O $.  $d g h r P $.  $d t u .x. $.
    dih1dimat.h $e |- H = ( LHyp ` K ) $.
    dih1dimat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dih1dimat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dih1dimat.a $e |- A = ( LSAtoms ` U ) $.
    ${
      dih1dimat.b $e |- B = ( Base ` K ) $.
      dih1dimat.l $e |- .<_ = ( le ` K ) $.
      dih1dimat.c $e |- C = ( Atoms ` K ) $.
      dih1dimat.p $e |- P = ( ( oc ` K ) ` W ) $.
      dih1dimat.t $e |- T = ( ( LTrn ` K ) ` W ) $.
      dih1dimat.r $e |- R = ( ( trL ` K ) ` W ) $.
      dih1dimat.e $e |- E = ( ( TEndo ` K ) ` W ) $.
      dih1dimat.o $e |- O = ( h e. T |-> ( _I |` B ) ) $.
      dih1dimat.d $e |- F = ( Scalar ` U ) $.
      dih1dimat.j $e |- J = ( invr ` F ) $.
      dih1dimat.v $e |- V = ( Base ` U ) $.
      dih1dimat.m $e |- .x. = ( .s ` U ) $.
      dih1dimat.s $e |- S = ( LSubSp ` U ) $.
      dih1dimat.n $e |- N = ( LSpan ` U ) $.
      dih1dimat.z $e |- .0. = ( 0g ` U ) $.
      dih1dimat.g $e |- G
          = ( iota_ h e. T ( h ` P ) = ( ( ( J ` s ) ` f ) ` P ) ) $.
      $( Lemma for ~ dih1dimat .  (Contributed by NM, 11-Apr-2014.) $)
      dih1dimatlem0 $p |- ( ( ( K e. HL /\ W e. H ) /\ ( f e. T /\ s e. E
          )
         /\ s =/= O ) -> ( ( i = ( p ` G ) /\ p e. E )
   <-> ( ( i e. T /\ p e. E )
            /\ E. t e. E ( i = ( t ` f ) /\ p = ( t o. s ) ) ) ) ) $=
        ( chlt wcel wa cv wne w3a wceq ccom wrex simprl simpl1 simprr lhpocnel2
        cfv wbr wn syl simpl2r simpl3 tendoinvcl simpld syl3anc simpl2l tendocl
        ltrnel ltrniotacl eqeltrd tendococl simp1 3ad2ant1 3adant2l ltrniotaval
        simp2l cdlemd syl311anc adantr fveq2d tendocoval syl121anc 3eqtr4d cres
        coass cid tendolinv coeq2d tendo1mulr syl2anc eqtrd syl5req fveq1 coeq1
        eqeq2d anbi12d rspcev syl12anc jca31 simp3r fveq1d simp1l1 simp2 syl5eq
        simp1l3 tendorinv 3eqtr2rd simp3l rexlimdv3a impr simprlr jca impbida )
        TVIVJUEQVJVKZKVLZHVJZUGVLZNVJZVKZUUBUCVMZVNZMVLZPUHVLZWBZVOZUUHNVJZVKZU
        UGHVJZUUKVKZUUGYTAVLZWBZVOZUUHUUOUUBVPZVOZVKZANVQZVKZUUFUULVKZUUMUUKUVA
        UVCUUGUUIHUUFUUJUUKVRZUVCYSUUKPHVJZUUIHVJYSUUDUUEUULVSZUUFUUJUUKVTZUVCY
        SEDVJEUEUAWCWDVKZEYTUUBSWBZWBZWBZDVJUVKUEUAWCWDVKZUVEUVFUVCYSUVHUVFDEQT
        UAUEUNUOUIUPWAZWEZUVCYSUVJHVJZUVHUVLUVFUVCYSUVINVJZUUAUVOUVFUVCYSUUCUUE
        UVPUVFUUAUUCYSUUEUULWFZYSUUDUUEUULWGZYSUUCUUEVNUVPUVIUCVMCUUBHJLNOQTSUC
        UEUMUIUQUSUTUJVAVBWHWIZWJZUUAUUCYSUUEUULWKZUVIHNYTQTVIUEUIUQUSWLZWJUVND
        EHUVJQTUAUEUNUOUIUQWMZWJDEUVKHLPQTUAUEUNUOUIUQVHWNZWJUUHHNPQTVIUEUIUQUS
        WLWJWOUVGUVCUUHUVIVPZNVJZUUGYTUWEWBZVOZUUHUWEUUBVPZVOZUVAUVCYSUUKUVPUWF
        UVFUVGUVTUUHUVINQTUEUIUSWPWJUVCUUIUVJUUHWBZUUGUWGUVCPUVJUUHUUFPUVJVOZUU
        LUUFYSUVEUVOUVHEPWBUVKVOZUWLYSUUDUUEWQZUUFYSUVHUVLUVEUWNYSUUDUVHUUEUVMW
        RZUUFYSUVOUVHUVLUWNUUFYSUVPUUAUVOUWNYSUUCUUEUVPUUAUVSWSYSUUAUUCUUEXAUWB
        WJZUWOUWCWJZUWDWJUWPUWOUUFYSUVHUVLUWMUWNUWOUWQDEUVKHLPQTUAUEUNUOUIUQVHW
        TWJDEHPUVJQTUAUEUNUOUIUQXBXCZXDXEUVDUVCYSUUKUVPUUAUWGUWKVOUVFUVGUVTUWAH
        UUHNYTQTUVIUEVIUIUQUSXFXGXHUVCUWIUUHUVIUUBVPZVPZUUHUUHUVIUUBXJUVCUWTUUH
        XKHXIZVPZUUHUVCUWSUXAUUHUVCYSUUCUUEUWSUXAVOUVFUVQUVRCUUBHJLNOQTSUCUEUMU
        IUQUSUTUJVAVBXLWJXMUVCYSUUKUXBUUHVOUVFUVGHUUHNQTUEUIUQUSXNXOXPXQUUTUWHU
        WJVKAUWENUUOUWEVOZUUQUWHUUSUWJUXCUUPUWGUUGYTUUOUWEXRXTUXCUURUWIUUHUUOUW
        EUUBXSXTYAYBYCYDUUFUVBVKUUJUUKUUFUUNUVAUUJUUFUUNVKZUUTUUJANUXDUUONVJZUU
        TVNZUUPUWKUUGUUIUXFUWKUVJUURWBZYTUURUVIVPZWBZUUPUXFUVJUUHUURUXDUXEUUQUU
        SYEYFUXFYSUURNVJZUVPUUAUXIUXGVOYSUUDUUEUUNUXEUUTYGZUXFYSUXEUUCUXJUXKUXD
        UXEUUTYHZUXDUXEUUCUUTUUAUUCYSUUEUUNWFWRZUUOUUBNQTUEUIUSWPWJUXFYSUUCUUEU
        VPUXKUXMYSUUDUUEUUNUXEUUTYJZUVSWJUXDUXEUUAUUTUUAUUCYSUUEUUNWKWRHUURNYTQ
        TUVIUEVIUIUQUSXFXGUXFYTUXHUUOUXFUXHUUOUUBUVIVPZVPZUUOUUOUUBUVIXJUXFUXPU
        UOUXAVPZUUOUXFUXOUXAUUOUXFYSUUCUUEUXOUXAVOUXKUXMUXNCUUBHJLNOQTSUCUEUMUI
        UQUSUTUJVAVBYKWJXMUXFYSUXEUXQUUOVOUXKUXLHUUONQTUEUIUQUSXNXOXPYIYFYLUXDU
        XEUUQUUSYMUXFPUVJUUHUXDUXEUWLUUTUUFUWLUUNUWRXDWRXEXHYNYOUUFUUMUUKUVAYPY
        QYR $.

      $( Lemma for ~ dih1dimat .  (Contributed by NM, 10-Apr-2014.) $)
      dih1dimatlem $p |- ( ( ( K e. HL /\ W e. H ) /\ D e. A )
           -> D e. ran I ) $=
        ( vv vu vt vg vr vi vp chlt wcel wa cv csn cfv wceq cdif wrex crn clvec
        wb dvhlvec islsat syl biimpa cxp eldifi dvhvbase eleq2d syl5ib imp wral
        id wi cop simpr opeq2d sneqd fveq2d cdib simpl trlcl trlle eqid dihvalb
        wbr syl12anc dib1dim2 eqtr2d wfn wf1 dihf11 adantr f1fn syl2anc eqeltrd
        fnfvelrn adantrr wne co cbs cab copab simplll ad3antlr eleq1a rexlimdva
        ccom eqeq2d wrel vex eqeq1 syl6bbr eqtrd wn syl3anc crab simpll dvhbase
        rexeqdv opelxpi dvhvscacl pm4.71rd simplrl simplrr anbi2d 3bitrd abbidv
        dvhopvsca syl13anc rexbidva df-rab syl6eqr wss ssrab2 relxp mp2 relopab
        relss anbi1d fveq1 eleq1 anbi12d dih1dimatlem0 3expa opelxp opth rexbii
        opelopab anbi12i rexbidv elrab syl5rbb eqrelrdv clmod dvhelvbasei lspsn
        dvhlmod cdic w3a tendoinvcl simpld tendocl lhpocnel2 dihvalcqat dicval2
        ltrnel 3eqtr4d dihfn coc cops lhpbase opoccl syl5eqel ltrncl pm2.61dane
        hlop ralrimivva sneq eleq1d ralxp sylibr r19.21bi syldan mpd ) SVNVOZUD
        PVOZVPZDAVOZVPDVGVQZVRZUAVSZVTZVGUCUEVRZWAZWBZDQWCZVOZUXLUXMUXTUXLJWDVO
        UXMUXTWEUXLJPSUDUGUHUXLWQWFVGADUAUCJWDUEVAVDVEUJWGWHWIUXLUXTUYBWRUXMUXL
        UXQUYBVGUXSUXLUXNUXSVOZVPUXPUYAVOZUXQUYBWRUXLUYCUXNHMWJZVOZUYDUXLUYCUYF
        UYCUXNUCVOUXLUYFUXNUCUXRWKUXLUCUYEUXNHJMPSUCUDVNUGUOUQUHVAWLWMWNWOUXLUY
        DVGUYEUXLKVQZUFVQZWSZVRZUAVSZUYAVOZUFMWPKHWPUYDVGUYEWPUXLUYLKUFHMUXLUYG
        HVOZUYHMVOZVPZVPZUYLUYHUBUYPUYHUBVTZVPZUYKUYGUBWSZVRZUAVSZUYAUYRUYJUYTU
        AUYRUYIUYSUYRUYHUBUYGUYPUYQWTXAXBXCUYPVUAUYAVOZUYQUXLUYMVUBUYNUXLUYMVPZ
        VUAUYGFVSZQVSZUYAVUCVUEVUDUDSXDVSVSZVSZVUAVUCUXLVUDBVOZVUDUDTXJVUEVUGVT
        UXLUYMXEBFHUYGPSUDUKUGUOUPXFZFHUYGPSTUDULUGUOUPXGBVUFPQSTVNUDVUDUKULUGU
        IVUFXHZXIXKBFHJLUYGPVUFSUAUBUDUKUGUOUPURUHVUJVDXLXMVUCQBXNZVUHVUEUYAVOV
        UCBGQXOZVUKUXLVULUYMBGJPQSUDUKUGUIUHVCXPXQBGQXRWHVUIBVUDQYAXSXTYBXQXTUY
        PUYHUBYCZVPZUYKEUYGUYHRVSZVSZVSZQVSZUYAVUNVHVQZVIVQZUYIIYDZVTZVINYEVSZW
        BZVHYFZVJVQZOVKVQZVSZVTZVVGMVOZVPZVJVKYGZUYKVURVUNVVEVUSUYGVUTVSZVUTUYH
        YLZWSZVTZVIMWBZVHUYEUUAZVVLVUNVVEVUSUYEVOZVVQVPZVHYFVVRVUNVVDVVTVHVUNVV
        DVVBVIMWBZVVSVWAVPVVTVUNVVBVIVVCMVUNUXLVVCMVTUXLUYOVUMUUBZVVCJMNPSUDVNU
        GUQUHUSVVCXHZUUCWHUUDVUNVWAVVSVUNVVBVVSVIMVUNVUTMVOZVPZVVAUYEVOZVVBVVSW
        RVWEUXLVWDUYIUYEVOZVWFUXLUYOVUMVWDYHZVUNVWDWTZUYOVWGUXLVUMVWDUYGUYHHMUU
        EYIVUTHIJMUYIPSUDUGUOUQUHVBUUFXKVVAUYEVUSYJWHYKUUGVUNVWAVVQVVSVUNVVBVVP
        VIMVWEVVAVVOVUSVWEUXLVWDUYMUYNVVAVVOVTVWHVWIVUNUYMVWDUXLUYMUYNVUMUUHZXQ
        VUNUYNVWDUXLUYMUYNVUMUUIZXQVUTHIJMUYGPSVNUDUYHUGUOUQUHVBUUMUUNYMUUOUUJU
        UKUULVVQVHUYEUUPUUQVUNVLVMVVRVVLVVRUYEUURUYEYNVVRYNVVQVHUYEUUSHMUUTVVRU
        YEUVCUVAVVKVJVKUVBVLVQZVMVQZWSZVVLVOVWLOVWMVSZVTZVWMMVOZVPZVUNVWNVVRVOZ
        VVKVWLVVHVTZVVJVPVWRVJVKVWLVWMVLYOZVMYOZVVFVWLVTVVIVWTVVJVVFVWLVVHYPUVD
        VVGVWMVTZVWTVWPVVJVWQVXCVVHVWOVWLOVVGVWMUVEYMVVGVWMMUVFUVGUVMVUNVWRVWNU
        YEVOZVWNVVOVTZVIMWBZVPZVWSVUNVWRVWLHVOVWQVPZVWLVVMVTVWMVVNVTVPZVIMWBZVP
        ZVXGUXLUYOVUMVWRVXKWEVIABCEFGHIJKLVLMNOPQRSTUAUBUCUDUEUFVMUGUHUIUJUKULU
        MUNUOUPUQURUSUTVAVBVCVDVEVFUVHUVIVXDVXHVXFVXJVWLVWMHMUVJVXEVXIVIMVWLVWM
        VVMVVNVXAVXBUVKUVLUVNYQVVQVXFVHVWNUYEVUSVWNVTVVPVXEVIMVUSVWNVVOYPUVOUVP
        YQUVQUVRYRVUNJUVSVOUYIUCVOZUYKVVEVTVUNJPSUDUGUHVWBUWBUYPVXLVUMUYHHJMUYG
        PSUCUDVNUGUOUQUHVAUVTXQVHIVINVVCUAUCJUYIUSVWCVAVBVDUWAXSVUNVURVUQUDSUWC
        VSVSZVSZVVLVUNUXLVUQCVOVUQUDTXJYSVPZVURVXNVTVWBVUNUXLVUPHVOZECVOEUDTXJY
        SVPZVXOVWBVUNUXLVUOMVOZUYMVXPVWBVUNUXLUYNVUMVXRVWBVWKUYPVUMWTUXLUYNVUMU
        WDVXRVUOUBYCBUYHHJLMNPSRUBUDUKUGUOUQURUHUSUTUWEUWFYTVWJVUOHMUYGPSVNUDUG
        UOUQUWGYTZVUNUXLVXQVWBCEPSTUDULUMUGUNUWHWHCEHVUPPSTUDULUMUGUOUWKYTZCVUQ
        PQVXMSTUDULUMUGVXMXHZUIUWIXSVUNUXLVXOVXNVVLVTVWBVXTCEVUQHVJLMOPVXMSTVNU
        DVKULUMUGUNUOUQVYAVFUWJXSYRUWLVUNVUKVUQBVOZVURUYAVOUYPVUKVUMUXLVUKUYOBP
        QSUDUKUGUIUWMXQXQVUNUXLVXPEBVOVYBVWBVXSVUNEUDSUWNVSZVSZBUNVUNSUWOVOZUDB
        VOZVYDBVOVUNUXJVYEUXJUXKUYOVUMYHSUXAWHUXKVYFUXJUYOVUMBPSUDUKUGUWPYIBSVY
        CUDUKVYCXHUWQXSUWRBHVUPPSVNUDEUKUGUOUWSYTBVUQQYAXSXTUWTUXBUYDUYLVGKUFHM
        UXNUYIVTZUXPUYKUYAVYGUXOUYJUAUXNUYIUXCXCUXDUXEUXFUXGUXHUXPUYADYJWHYKXQU
        XI $.
    $}

    $( Any 1-dimensional subspace is a value of isomorphism H. (Contributed by
       NM, 11-Apr-2014.) $)
    dih1dimat $p |- ( ( ( K e. HL /\ W e. H ) /\ P e. A )
         -> P e. ran I ) $=
      ( vf vh vs cbs cfv catm coc cv eqid ctrl clss cltrn cvsca csca cinvr wceq
      ctendo crio cple clspn cid cres cmpt c0g dih1dimatlem ) AFOPZFQPZBGFRPPZG
      FUAPPZCUBPZGFUCPPZCUDPZCLMGFUHPPZCUEPZUSMSPUSLSNSVEUFPZPPPUGMVBUIZDEVFFFU
      JPZCUKPZMVBULUQUMUNZCOPZGCUOPZNHIJKUQTVHTURTUSTVBTUTTVDTVJTVETVFTVKTVCTVA
      TVITVLTVGTUP $.
  $}

  ${
    dihlsprn.h $e |- H = ( LHyp ` K ) $.
    dihlsprn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihlsprn.v $e |- V = ( Base ` U ) $.
    dihlsprn.n $e |- N = ( LSpan ` U ) $.
    dihlsprn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The span of a vector belongs to the range of isomorphism H. (Contributed
       by NM, 27-Apr-2014.) $)
    dihlsprn $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. V )
       -> ( N ` { X } ) e. ran I ) $=
      ( wcel wa csn cfv wceq simpr simpll chlt crn c0g sneqd clmod dvhlmod eqid
      fveq2d lspsn0 syl eqtrd dih0rn ad2antrr eqeltrd simplr lsatlspsn2 syl3anc
      wne clsa dih1dimat syl2anc pm2.61dane ) DUANGBNOZHFNZOZHPZEQZCUBZNZHAUCQZ
      VEHVJRZOZVGVJPZVHVLVGVMEQZVMVLVFVMEVLHVJVEVKSUDUHVLAUENZVNVMRVLABDGIJVCVD
      VKTUFEAVJVJUGZLUIUJUKVCVMVHNVDVKABCDGVJIMJVPULUMUNVEHVJURZOZVCVGAUSQZNZVI
      VCVDVQTZVRVOVDVQVTVRABDGIJWAUFVCVDVQUOVEVQSVSEFAHVJKLVPVSUGZUPUQVSVGABCDG
      IJMWBUTVAVB $.
  $}

  ${
    dih1dor0.h $e |- H = ( LHyp ` K ) $.
    dih1dor0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihldor0.v $e |- V = ( Base ` U ) $.
    dih1dor0.s $e |- S = ( LSubSp ` U ) $.
    dih1dor0.n $e |- N = ( LSpan ` U ) $.
    dih1dor0.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( A subspace included in a 1-dim subspace belongs to the range of
       isomorphism H. (Contributed by NM, 26-Apr-2014.)
       (New usage is discouraged.) $)
    dihlspsnssN $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. V
         /\ T C_ ( N ` { X } ) ) -> ( T e. S <-> T e. ran I ) ) $=
      ( wcel wa cfv wceq chlt csn wss w3a crn dihlsprn 3adant3 ad2antrr eqeltrd
      c0g simpr cp0 simpll1 eqid dih0 syl eqtr4d cbs wfn dihfn cops simp1l hlop
      op0cl 3syl fnfvelrn syl2anc clvec wo simpl1 dvhlvec simpl2 simpl3 lspsnat
      syl31anc mpjaodan ex dihsslss 3ad2ant1 sseld impbid ) FUAQZIDQZRZJHQZBJUB
      GSZUCZUDZBAQZBEUEZQZWHWIWKWHWIRZBWFTZWKBCUJSZUBZTZWLWMRBWFWJWLWMUKWHWFWJQ
      ZWIWMWDWEWQWGCDEFGHIJKLMOPUFUGUHUIWLWPRZBFULSZESZWJWRBWOWTWLWPUKWRWDWTWOT
      WDWEWGWIWPUMZCDEFWNIWSWSUNZKPLWNUNZUOUPUQWREFURSZUSZWSXDQZWTWJQWRWDXEXAXD
      DEFIXDUNZKPUTUPWRWBFVAQXFWHWBWIWPWBWCWEWGVBUHFVCXDFWSXGXBVDVEXDWSEVFVGUIW
      LCVHQWIWEWGWMWPVIWLCDFIKLWDWEWGWIVJVKWHWIUKWDWEWGWIVLWDWEWGWIVMABGHCJWNMX
      CNOVNVOVPVQWHWJABWDWEWJAUCWGACDEFIKLPNVRVSVTWA $.
  $}

  ${
    $d x H $.  $d x I $.  $d x K $.  $d x N $.  $d x V $.  $d x W $.  $d x X $.
    $d x .0. $.
    dihlspsnat.a $e |- A = ( Atoms ` K ) $.
    dihlspsnat.h $e |- H = ( LHyp ` K ) $.
    dihlspsnat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihlspsnat.v $e |- V = ( Base ` U ) $.
    dihlspsnat.o $e |- .0. = ( 0g ` U ) $.
    dihlspsnat.n $e |- N = ( LSpan ` U ) $.
    dihlspsnat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The inverse isomorphism H of the span of a singleton is a Hilbert
       lattice atom.  (Contributed by NM, 27-Apr-2014.) $)
    dihlspsnat $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. V /\ X =/= .0. )
       -> ( `' I ` ( N ` { X } ) ) e. A ) $=
      ( wcel cfv wceq vx chlt wa wne w3a csn ccnv cbs cp0 cv cple wbr wo wi crn
      wral wf1o clss wf1 eqid dihf11 3ad2ant1 f1f1orn dihlsprn 3adant3 f1ocnvdm
      syl2anc fveq2 dihcnvid2 syldan dih0 adantr eqeq12d clmod dvhlmod lspsneq0
      syl wb sylan bitrd syl5ib necon3d 3impia wss clvec simpll1 dvhlvec simplr
      dihlss simpll2 simpr lspsnat syl31anc sseq2d simpl1 dihord syl3anc bitr3d
      id ex simp1 eqeq2d dih11 cops simpl1l hlop 3syl orbi12d 3imtr3d ralrimiva
      op0cl cal simp1l hlatl isat3 mpbir3and ) EUBRZHCRZUCZIGRZIJUDZUEZIUFFSZDU
      GSZARZYDEUHSZRZYDEUISZUDZUAUJZYDEUKSZULZYJYDTZYJYHTZUMZUNZUAYFUPZYBYFDUOZ
      DUQZYCYRRZYGYBYFBURSZDUSZYSXSXTUUBYAYFUUABCDEHYFUTZLQMUUAUTZVAVBYFUUADVCV
      QXSXTYTYABCDEFGHILMNPQVDZVEZYFYRYCDVFVGZXSXTYAYIXSXTUCZYDYHIJYDYHTYDDSZYH
      DSZTZUUHIJTZYDYHDVHUUHUUKYCJUFZTZUULUUHUUIYCUUJUUMXSXTYTUUIYCTZUUECDEHYCL
      QVIZVJXSUUJUUMTZXTBCDEJHYHYHUTZLQMOVKZVLVMXSBVNRXTUUNUULVRXSBCEHLMXSWSVOF
      GBIJNOPVPVSVTWAWBWCYBYPUAYFYBYJYFRZUCZYJDSZYCWDZUVBYCTZUVBUUMTZUMZYLYOUVA
      UVCUVFUVAUVCUCZBWERUVBUUARZXTUVCUVFUVGBCEHLMXSXTYAUUTUVCWFZWGUVGXSUUTUVHU
      VIYBUUTUVCWHYFUUABCDEHYJUUCLQMUUDWIVGXSXTYAUUTUVCWJUVAUVCWKUUAUVBFGBIJNOU
      UDPWLWMWTUVAUVBUUIWDZUVCYLUVAUUIYCUVBYBUUOUUTYBXSYTUUOXSXTYAXAUUFUUPVGVLZ
      WNUVAXSUUTYGUVJYLVRXSXTYAUUTWOZYBUUTWKZYBYGUUTUUGVLZYFCDEYKHYJYDUUCYKUTZL
      QWPWQWRUVAUVDYMUVEYNUVAUVBUUITZUVDYMUVAUUIYCUVBUVKXBUVAXSUUTYGUVPYMVRUVLU
      VMUVNYFCDEHYJYDUUCLQXCWQWRUVAUVBUUJTZUVEYNUVAUUJUUMUVBUVAXSUUQUVLUUSVQXBU
      VAXSUUTYHYFRZUVQYNVRUVLUVMUVAXQEXDRUVRXQXRXTYAUUTXEEXFYFEYHUUCUURXKXGYFCD
      EHYJYHUUCLQXCWQWRXHXIXJYBXQEXLRYEYGYIYQUEVRXQXRXTYAXMEXNUAAYFYDEYKYHUUCUV
      OUURKXOXGXP $.
  $}

  ${
    $d f g A $.  $d f g H $.  $d g I $.  $d f g K $.  $d g L $.  $d f g Q $.
    $d f g W $.
    dihatlat.a $e |- A = ( Atoms ` K ) $.
    dihatlat.h $e |- H = ( LHyp ` K ) $.
    dihatlat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihatlat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihatlat.l $e |- L = ( LSAtoms ` U ) $.
    $( The isomorphism H of an atom is a 1-dim subspace.  (Contributed by NM,
       28-Apr-2014.) $)
    dihatlat $p |- ( ( ( K e. HL /\ W e. H ) /\ Q e. A )
       -> ( I ` Q ) e. L ) $=
      ( vf wcel wa cfv wne wceq eqid vg chlt cple wbr cv cid cbs cres cltrn cop
      cmpt csn clspn wrex dih1dimb2 anassrs w3a simp3rr clmod c0g simp1l ctendo
      dvhlmod simp3l tendo0cl syl dvhelvbasei syl12anc wn simp3rl intnanrd fvex
      neneqd vex mptex opth necon3abii sylibr dvh0g neeqtrrd lsatlspsn2 syl3anc
      eqeltrd 3expa rexlimddv coc crio dih1dimc simpll lhpocnel ad2antrr simplr
      simpr syl112anc tendoidcl tendo1ne0 intnand riotaex cvv resiexg pm2.61dan
      ltrniotacl ax-mp ) FUBOHDOPZBAOZPZBHFUCQZUDZBEQZGOZXFXHPUAUEZUFFUGQZUHZRZ
      XIXKNHFUIQZQZXMUKZUJZULCUMQZQZSZPZXJUAXPXDXEXHYBUAXPUNAXLBXPCUANDEFXGXSXQ
      HXLTZXGTZIJXPTZXQTZKLXSTZUOUPXFXHXKXPOZYBPZXJXFXHYIUQZXIXTGXNYAYHXFXHURYJ
      CUSOZXRCUGQZOZXRCUTQZRXTGOYJCDFHJKXDXEXHYIVAZVCYJXDYHXQHFVBQQZOZYMYOXFXHY
      HYBVDYJXDYQYOXLXPNYPDFXQHYCJYEYPTZYFVEVFXQXPCYPXKDFYLHUBJYEYRKYLTZVGVHYJX
      RXMXQUJZYNYJXKXMSZXQXQSZPZVIXRYTRYJUUAUUBYJXKXMXNYAYHXFXHVJVMVKUUCXRYTXKX
      QXMXQUAVNNXPXMHXOVLZVOVPVQVRYJXDYNYTSZYOXLXPCNDFXQHYNYCJYEKYNTZYFVSZVFVTG
      XSYLCXRYNYSYGUUFMWAWBWCWDWEXFXHVIZPZXIHFWFQZQZNUEQBSZNXPWGZUFXPUHZUJZULXS
      QZGXDXEUUHXIUUPSAUUKBXPCNUUMDEFXGXSHYDIJUUKTYELKYGUUMTZWHUPUUIYKUUOYLOZUU
      OYNRUUPGOUUICDFHJKXDXEUUHWIZVCUUIXDUUMXPOZUUNYPOZUURUUSUUIXDUUKAOUUKHXGUD
      VIPZXEUUHUUTUUSXDUVBXEUUHADFXGUUJHYDUUJTIJWJWKXDXEUUHWLXFUUHWMAUUKBXPNUUM
      DFXGHYDIJYEUUQXBWNXDUVAXEUUHXPYPDFHJYEYRWOWKUUNXPCYPUUMDFYLHUBJYEYRKYSVGV
      HUUIUUOYTYNUUIUUMXMSZUUNXQSZPZVIUUOYTRUUIUVDUVCUUIUUNXQXDUUNXQRXEUUHXLXPN
      YPDFXQHYCJYEYRYFWPWKVMWQUVEUUOYTUUMUUNXMXQUULNXPWRXPWSOUUNWSOUUDXPWSWTXCV
      PVQVRXDUUEXEUUHUUGWKVTGXSYLCUUOYNYSYGUUFMWAWBWCXA $.
  $}

  ${
    dihat.h $e |- H = ( LHyp ` K ) $.
    dihat.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihat.a $e |- A = ( LSAtoms ` U ) $.
    dihat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( There exists at least one atom in the subspaces of vector space H.
       (Contributed by NM, 12-Aug-2014.) $)
    dihat $p |- ( ph -> ( I ` P ) e. A ) $=
      ( chlt wcel wa catm cfv eqid coc lhpocat syl syl5eqel dihatlat syl2anc )
      AGOPHEPQZCGRSZPCFSBPNACHGUASZSZUHJAUGUJUHPNUHEGUIHUITUHTZIUBUCUDUHCDEFGBH
      UKILKMUEUF $.
  $}

  ${
    $d f g s B $.  $d g s E $.  $d f H $.  $d f g s K $.  $d f g s P $.
    $d g s S $.  $d f g s T $.  $d f g s W $.
    dihp.b $e |- B = ( Base ` K ) $.
    dihp.h $e |- H = ( LHyp ` K ) $.
    dihp.p $e |- P = ( ( oc ` K ) ` W ) $.
    dihp.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihp.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihp.o $e |- O = ( f e. T |-> ( _I |` B ) ) $.
    dihp.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihp.n $e |- N = ( LSpan ` U ) $.
    dihp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihp.s $e |- ( ph -> ( S e. E /\ S =/= O ) ) $.
    $( The value of isomorphism H at the fiducial atom ` P ` is determined by
       the vector ` <. 0 , S >. ` (the zero translation ~ ltrnid and a nonzero
       member of the endomorphism ring).  In particular, ` S ` can be replaced
       with the ring unit ` ( _I |`` T ) ` .  (Contributed by NM,
       26-Aug-2014.)  (New usage is discouraged.) $)
    dihpN $p |- ( ph
     -> ( I ` P ) = ( N ` { <. ( _I |` B ) , S >. } ) ) $=
      ( vg vs clsa cfv cid cres cop c0g eqid dvhlvec dihat cv wceq crio wcel wa
      copab chlt catm wbr wn lhpocnel2 syl ltrniotaidvalN syl2anc fveq2d simpld
      cple wne tendoid eqtr2d cvv wb cbs fvex eqeltri resiexg mp1i eqeq1 anbi1d
      fveq1 eqeq2d eleq1 anbi12d opelopabg mpbir2and cdic dicval eleqtrd simprd
      dihvalcqat dvh0g ax-mp cmpt cltrn mptex simprbi syl6bi necon3d mpd lsatel
      opth2 ) AFUHUIZCJUIZLFUJBUKZDULZFUMUIZXLUNZUCXHUNZAFIKNPUBUDUOAXHCFIJKNPQ
      UAUBXNUDUPAXKUFUQZCGUQUICURGEUSZUGUQZUIZURZXQHUTZVAZUFUGVBZXIAXKYBUTZXJXP
      DUIZURZDHUTZAYDXJDUIZXJAXPXJDAKVCUTNIUTVAZCKVDUIZUTCNKVMUIZVEVFVAZXPXJURU
      DAYHYKUDYICIKYJNYJUNZYIUNZPQVGVHZYIBCEGXPIKYJNOYLYMPRXPUNVIVJVKAYHYFYGXJU
      RUDAYFDMVNZUEVLZBDHIKNOPSVOVJVPYPAXJVQUTZYFYCYEYFVAZVRBVQUTZYQABKVSUIVQOK
      VSVTWAZBVQWBZWCYPYAXJXRURZXTVAYRUFUGXJDVQHXOXJURXSUUBXTXOXJXRWDWEXQDURZUU
      BYEXTYFUUCXRYDXJXPXQDWFWGXQDHWHWIWJVJWKAXICNKWLUIUIZUIZYBAYHYKXIUUEURUDYN
      YICIJUUDKYJNYLYMPUUDUNZUAWPVJAYHYKUUEYBURUDYNYICCEUFGHIUUDKYJVCNUGYLYMPQR
      SUUFWMVJVPWNAYOXKXLVNAYFYOUEWOAXKXLDMAXKXLURXKXJMULZURZDMURZAXLUUGXKAYHXL
      UUGURUDBEFGIKMNXLOPRUBXMTWQVHWGUUHXJXJURUUIXJDXJMYSYQYTUUAWRMGEXJWSVQTGEX
      JENKWTUIZUIVQRNUUJVTWAXAWAXGXBXCXDXEXF $.
  $}

  ${
    $d v A $.  $d v H $.  $d v I $.  $d v K $.  $d v L $.  $d v Q $.  $d v U $.
    $d v W $.
    dihlatat.a $e |- A = ( Atoms ` K ) $.
    dihlatat.h $e |- H = ( LHyp ` K ) $.
    dihlatat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihlatat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihlatat.l $e |- L = ( LSAtoms ` U ) $.
    $( The reverse isomorphism H of a 1-dim subspace is an atom.  (Contributed
       by NM, 28-Apr-2014.) $)
    dihlatat $p |- ( ( ( K e. HL /\ W e. H ) /\ Q e. L )
       -> ( `' I ` Q ) e. A ) $=
      ( vv wcel wa csn cfv clvec eqid chlt cv clspn wceq cbs c0g cdif wrex ccnv
      wb id dvhlvec islsat syl biimpa wi eldifsn dihlspsnat 3expb sylan2b fveq2
      wne eleq1d syl5ibrcom rexlimdva adantr mpd ) FUAOHDOPZBGOZPBNUBZQCUCRZRZU
      DZNCUERZCUFRZQUGZUHZBEUIZRZAOZVHVIVQVHCSOVIVQUJVHCDFHJKVHUKULNGBVKVNCSVOV
      NTZVKTZVOTZMUMUNUOVHVQVTUPVIVHVMVTNVPVHVJVPOZPVTVMVLVRRZAOZWDVHVJVNOZVJVO
      VBZPWFVJVNVOUQVHWGWHWFACDEFVKVNHVJVOIJKWAWCWBLURUSUTVMVSWEABVLVRVAVCVDVEV
      FVG $.
  $}

  ${
    $d x f g A $.  $d f x B $.  $d f g H $.  $d g x I $.  $d f g x K $.
    $d g x N $.  $d f g x Q $.  $d g x V $.  $d f g x W $.  $d g x ph $.
    dihatexv.b $e |- B = ( Base ` K ) $.
    dihatexv.a $e |- A = ( Atoms ` K ) $.
    dihatexv.h $e |- H = ( LHyp ` K ) $.
    dihatexv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihatexv.v $e |- V = ( Base ` U ) $.
    dihatexv.o $e |- .0. = ( 0g ` U ) $.
    dihatexv.n $e |- N = ( LSpan ` U ) $.
    dihatexv.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihatexv.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihatexv.q $e |- ( ph -> Q e. B ) $.
    $( There is a nonzero vector that maps to every lattice atom.  (Contributed
       by NM, 16-Aug-2014.) $)
    dihatexv $p |- ( ph
       -> ( Q e. A <-> E. x e. ( V \ { .0. } ) ( I ` Q ) = ( N ` { x } ) ) ) $=
      ( vg vf wcel cv wne cfv csn wceq wa wrex cdif cple wbr cid cres cltrn cop
      cmpt chlt ad2antrr simplr simpr dih1dimb2 syl12anc ad3antrrr tendo0cl syl
      eqid ctendo dvhelvbasei sneq fveq2d eqeq2d rspcev sylan adantld rexlimdva
      ex mpd coc crio lhpocnel2 ltrniotacl syl112anc tendoidcl dih1dimc syl2anc
      wn pm2.61dan cp0 cal simpld hlatl simpllr atn0 w3a 3ad2ant3 clmod simp1ll
      dvhlmod lspsn0 3syl eqtrd simp2 dih0 3eqtr4d wb op0cl dih11 syl3anc mpbid
      cops hlop 3expia ancrd reximdva ccnv dihcnvid1 fveq2 ad2antll eqtr3d clsa
      necon3d simprl lsatlspsn2 dihlatat eqeltrd impbid rexdifsn syl6bbr ) AECU
      FZBUGZMUHZEHUIZYOUJZJUIZUKZULZBKUMZYTBKMUJZUNUMAYNUUBAYNUUBAYNULZYTBKUMZU
      UBUUDELIUOUIZUPZUUEUUDUUGULZUDUGZUQDURZUHZYQUUIUELIUSUIUIZUUJVAZUTZUJZJUI
      ZUKZULZUDUULUMZUUEUUHIVBUFZLGUFZULZYNUUGUUSAUVBYNUUGUBVCAYNUUGVDUUDUUGVEC
      DEUULFUDUEGHIUUFJUUMLNUUFVKZOPUULVKZUUMVKZQUATVFVGUUHUURUUEUDUULUUHUUIUUL
      UFZULZUUQUUEUUKUVGUUQUUEUVGUUNKUFZUUQUUEUVGUVBUVFUUMLIVLUIUIZUFZUVHAUVBYN
      UUGUVFUBVHZUUHUVFVEUVGUVBUVJUVKDUULUEUVIGIUUMLNPUVDUVIVKZUVEVIVJUUMUULFUV
      IUUIGIKLVBPUVDUVLQRVMVGYTUUQBUUNKYOUUNUKZYSUUPYQUVMYRUUOJYOUUNVNVOVPVQVRW
      AVSVTWBUUDUUGWKZULZLIWCUIUIZUEUGUIEUKUEUULWDZUQUULURZUTZKUFZYQUVSUJZJUIZU
      KZUUEUVOUVBUVQUULUFZUVRUVIUFZUVTAUVBYNUVNUBVCZUVOUVBUVPCUFUVPLUUFUPWKULZY
      NUVNUWDUWFUVOUVBUWGUWFCUVPGIUUFLUVCOPUVPVKZWEVJAYNUVNVDZUUDUVNVEZCUVPEUUL
      UEUVQGIUUFLUVCOPUVDUVQVKZWFWGUVOUVBUWEUWFUULUVIGILPUVDUVLWHVJUVRUULFUVIUV
      QGIKLVBPUVDUVLQRVMVGUVOUVBYNUVNUWCUWFUWIUWJCUVPEUULFUEUVQGHIUUFJLUVCOPUWH
      UVDUAQTUWKWIVGYTUWCBUVSKYOUVSUKZYSUWBYQUWLYRUWAJYOUVSVNVOVPVQWJWLUUDYTUUA
      BKUUDYOKUFZULZYTYPUWNYTYPUWNYTULZEIWMUIZUHZYPUWOIWNUFZYNUWQUWOUUTUWRAUUTY
      NUWMYTAUUTUVAUBWOZVHIWPVJAYNUWMYTWQCEIUWPUWPVKZOWRWJUWOYOMEUWPUWNYTYOMUKZ
      EUWPUKZUWNYTUXAWSZYQUWPHUIZUKZUXBUXCYSUUCYQUXDUXCYSUUCJUIZUUCUXAUWNYSUXFU
      KYTUXAYRUUCJYOMVNVOWTUXCAFXAUFZUXFUUCUKAYNUWMYTUXAXBZAFGILPQUBXCZJFMSTXDX
      EXFUWNYTUXAXGUXCAUVBUXDUUCUKUXHUBFGHIMLUWPUWTPUAQSXHXEXIUXCUVBEDUFZUWPDUF
      ZUXEUXBXJUXCAUVBUXHUBVJUXCAUXJUXHUCVJUXCUUTIXOUFUXKUXCAUUTUXHUWSVJIXPDIUW
      PNUWTXKXEDGHILEUWPNPUAXLXMXNXQYFWBWAXRXSWBWAAUUAYNBKAUWMULZUUAYNUXLUUAULZ
      EYSHXTZUIZCUXMYQUXNUIZEUXOUXMUVBUXJUXPEUKAUVBUWMUUAUBVCZAUXJUWMUUAUCVCDGH
      ILENPUAYAWJYTUXPUXOUKUXLYPYQYSUXNYBYCYDUXMUVBYSFYEUIZUFZUXOCUFUXQUXMUXGUW
      MYPUXSAUXGUWMUUAUXIVCAUWMUUAVDUXLYPYTYGUXRJKFYOMRTSUXRVKZYHXMCYSFGHIUXRLO
      PQUAUXTYIWJYJWAVTYKYTBKMYLYM $.
  $}

  ${
    $d x A $.  $d x I $.  $d x K $.  $d x N $.  $d x Q $.  $d x V $.  $d x W $.
    $d x ph $.
    dihatexv2.a $e |- A = ( Atoms ` K ) $.
    dihatexv2.h $e |- H = ( LHyp ` K ) $.
    dihatexv2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihatexv2.v $e |- V = ( Base ` U ) $.
    dihatexv2.o $e |- .0. = ( 0g ` U ) $.
    dihatexv2.n $e |- N = ( LSpan ` U ) $.
    dihatexv2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihatexv2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( There is a nonzero vector that maps to every lattice atom.  (Contributed
       by NM, 17-Aug-2014.) $)
    dihatexv2 $p |- ( ph ->
      ( Q e. A <-> E. x e. ( V \ { .0. } ) Q = ( `' I ` ( N ` { x } ) ) ) ) $=
      ( wcel cv csn cfv ccnv wceq cdif wrex cbs wa eqid atbase anim2i wi adantr
      chlt crn eldifi dihlsprn syl2an dihcnvcl eleq1a rexlimdva imdistani simpr
      syl2anc dihatexv dihcnvid2 eqeq2d wb simplr dih11 syl3anc bitr3d rexbidva
      syl bitrd pm5.21nd ) ADCUAZDBUBZUCIUDZGUEUDZUFZBJLUCZUGZUHZADHUIUDZUAZUJZ
      VSWHACWGDHWGUKZMULUMAWFWHAWCWHBWEAVTWEUAZUJZWBWGUAZWCWHUNWLHUPUAKFUAUJZWA
      GUQUAZWMAWNWKTUOAWNVTJUAZWOWKTVTJWDURZEFGHIJKVTNOPRSUSZUTWGFGHKWAWJNSVAZV
      FWBWGDVBVPVCVDWIVSDGUDZWAUFZBWEUHWFWIBCWGDEFGHIJKLWJMNOPQRSAWNWHTUOZAWHVE
      VGWIXAWCBWEWIWKUJZWTWBGUDZUFZXAWCXCXDWAWTXCWNWOXDWAUFWIWNWKXBUOZWIWNWPWOW
      KXBWQWRUTZFGHKWANSVHVFVIXCWNWHWMXEWCVJXFAWHWKVKXCWNWOWMXFXGWSVFWGFGHKDWBW
      JNSVLVMVNVOVQVR $.
  $}

  ${
    $d u v x ./\ $.  $d p u v x .<_ $.  $d p u v x B $.  $d p x D $.
    $d p u v x G $.  $d p u v x H $.  $d p x I $.  $d p u v x K $.  $d p x P $.
    $d p u v x S $.  $d p U $.  $d p u v x W $.
    dihglblem6.b $e |- B = ( Base ` K ) $.
    dihglblem6.l $e |- .<_ = ( le ` K ) $.
    dihglblem6.m $e |- ./\ = ( meet ` K ) $.
    dihglblem6.a $e |- A = ( Atoms ` K ) $.
    dihglblem6.g $e |- G = ( glb ` K ) $.
    dihglblem6.h $e |- H = ( LHyp ` K ) $.
    dihglblem6.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihglblem6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihglblem6.s $e |- P = ( LSubSp ` U ) $.
    dihglblem6.d $e |- D = ( LSAtoms ` U ) $.
    $( Isomorphism H of a lattice glb.  (Contributed by NM, 9-Apr-2014.) $)
    dihglblem6 $p |- ( ( ( K e. HL /\ W e. H )
          /\ ( S C_ B /\ S =/= (/) ) )
        -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
      ( vv vu vp chlt wcel wa wss c0 wne cfv ciin wceq cmee wrex crab cdib eqid
      cv co dihglblem4 wpss wfal fal simpll dvhlmod ccla simplll hlclat simplrl
      wn wi syl clatglbcl syl2anc dihlss dihglblem5 adantr simpr lpssat ex ccnv
      w3a crn simp1l dih1dimat adantlr 3adant3 dihcnvid2 wbr simp3l ssiin sylib
      wral wb wf1o wf1 dihf11 f1f1orn 3syl f1ocnvdm sselda dihord sseq1d bitr3d
      syl3anc ralbidva mpbird simp1ll simp1rl clatleglb eqsstr3d pm2.21fal syld
      simp3r rexlimdv3a mtoi dfpss3 notbii iman anclb 3bitr2i mpd eqss sylibr )
      KUHUIZNIUIZUJZFCUKZFULUMZUJZUJZFHUNZJUNZAFAVBZJUNZUOZUKZYTYQUKZUJZYQYTUPY
      OUUAUUCAUEUFCFUFVBUEVBNKUQUNZVCUPUEFURUFCUSZHIJNKUTUNUNZKLUUDNOPUUDVASTUU
      EVAUUFVAUAVDYOYQYTVEZVNZUUAUUCVOZYOUUGVFVGYOUUGUGVBZYTUKZUUJYQUKZVNZUJZUG
      DURZVFYOUUGUUOYOUUGUJZDEYQYTGUGUCUDUUPGIKNTUBYKYNUUGVHZVIUUPYKYPCUIZYQEUI
      UUQUUPKVJUIZYLUURUUPYIUUSYIYJYNUUGVKKVLZVPYKYLYMUUGVMCFHKOSVQZVRCEGIJKNYP
      OTUAUBUCVSVRYOYTEUIUUGACEFGHIJKNOSTUBUAUCVTWAYOUUGWBWCWDYOUUNVFUGDYOUUJDU
      IZUUNWFZUULUVCUUJUUJJWEUNZJUNZYQUVCYKUUJJWGZUIZUVEUUJUPZYKYNUVBUUNWHZYOUV
      BUVGUUNYKUVBUVGYNDUUJGIJKNTUBUAUDWIWJZWKIJKNUUJTUAWLZVRUVCUVEYQUKZUVDYPLW
      MZUVCUVMUVDYRLWMZAFWQZUVCUVOUUJYSUKZAFWQZUVCUUKUVQYOUVBUUKUUMWNAFYSUUJWOW
      PYOUVBUVOUVQWRUUNYOUVBUJZUVNUVPAFUVRYRFUIZUJZUVEYSUKZUVNUVPUVTYKUVDCUIZYR
      CUIUWAUVNWRYKYNUVBUVSVKUVRUWBUVSUVRCUVFJWSZUVGUWBUVRYKCEJWTUWCYKYNUVBVHZC
      EGIJKNOTUAUBUCXACEJXBXCUVJCUVFUUJJXDVRZWAUVRFCYRYKYLYMUVBVMXECIJKLNUVDYRO
      PTUAXFXIUVTUVEUUJYSUVRUVHUVSUVRYKUVGUVHUWDUVJUVKVRWAXGXHXJWKXKUVCUUSUWBYL
      UVMUVOWRUVCYIUUSYIYJYNUVBUUNXLUUTVPZYOUVBUWBUUNUWEWKZYLYMYKUVBUUNXMZACFHK
      LUVDOPSXNXIXKUVCYKUWBUURUVLUVMWRUVIUWGUVCUUSYLUURUWFUWHUVAVRCIJKLNUVDYPOP
      TUAXFXIXKXOYOUVBUUKUUMXRXPXSXQXTUUHUUAUUBVNUJZVNUUAUUBVOUUIUUGUWIYQYTYAYB
      UUAUUBYCUUAUUBYDYEWPYFYQYTYGYH $.
  $}

  ${
    $d x B $.  $d x I $.  $d x K $.  $d x S $.
    dihglb.b $e |- B = ( Base ` K ) $.
    dihglb.g $e |- G = ( glb ` K ) $.
    dihglb.h $e |- H = ( LHyp ` K ) $.
    dihglb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    ${
      $d x G $.  $d x H $.  $d x W $.
      $( Isomorphism H of a lattice glb.  (Contributed by NM, 11-Apr-2014.) $)
      dihglb $p |- ( ( ( K e. HL /\ W e. H ) /\ ( S C_ B /\ S =/= (/) ) )
            -> ( I ` ( G ` S ) ) = |^|_ x e. S ( I ` x ) ) $=
        ( catm cfv cdvh clsa clss cple cmee eqid dihglblem6 ) AGMNZBHGONNZPNZUC
        QNZCUCDEFGGRNZGSNZHIUFTUGTUBTJKLUCTUETUDTUA $.
    $}

    $d x y z B $.  $d z G $.  $d y z H $.  $d y z I $.  $d y z K $.
    $d y z S $.  $d y V $.  $d y z W $.
    dihglb2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihglb2.v $e |- V = ( Base ` U ) $.
    $( Isomorphism H of a lattice glb.  (Contributed by NM, 11-Apr-2014.) $)
    dihglb2 $p |- ( ( ( K e. HL /\ W e. H ) /\ S C_ V )
      -> ( I ` ( G ` { x e. B | S C_ ( I ` x ) } ) )
            = |^| { y e. ran I | S C_ y } ) $=
      ( vz wcel wa chlt wss cv cfv crab ciin crn cint wne wceq simpl ssrab2 a1i
      c0 cp1 cops hlop ad2antrr eqid op1cl syl simpr dih1 adantr sseqtr4d fveq2
      sseq2d elrab sylanbrc ne0i dihglb syl12anc wrex cab fvex dfiin2 wex dihfn
      wb wfn fvelrnb eqcom rexbii df-rex bitri syl6bb pm5.32rd weq anbi1i sseq2
      anbi2d pm5.32ri an32 3bitr2i 19.41v 3bitrri syl6rbb abbidv df-rab syl6eqr
      ex exbii inteqd syl5eq eqtrd ) IUASZKGSZTZDJUBZTZDAUCZHUDZUBZACUEZFUDHUDZ
      RXNRUCZHUDZUFZDBUCZUBZBHUGZUEZUHZXJXHXNCUBZXNUNUIZXOXRUJXHXIUKYDXJXMACULU
      MXJIUOUDZXNSZYEXJYFCSZDYFHUDZUBZYGXJIUPSZYHXFYKXGXIIUQURCYFILYFUSZUTVAXJD
      JYIXHXIVBXHYIJUJXIEYFGHIJKYLNOPQVCVDVEXMYJAYFCXKYFUJXLYIDXKYFHVFVGVHVIXNY
      FVJVARCXNFGHIKLMNOVKVLXJXRXSXQUJZRXNVMZBVNZUHYCRBXNXQXPHVOVPXJYOYBXJYOXSY
      ASZXTTZBVNYBXJYNYQBXJYQXPCSZYMTZRVQZXTTZYNXJXTYPYTXJXTYPYTVSXJXTTZYPXQXSU
      JZRCVMZYTUUBHCVTZYPUUDVSXHUUEXIXTCGHIKLNOVRURRCXSHWAVAUUDYMRCVMYTUUCYMRCX
      QXSWBWCYMRCWDWEWFXAWGYNXPXNSZYMTZRVQYSXTTZRVQUUAYMRXNWDUUGUUHRUUGYRDXQUBZ
      TZYMTYRXTTZYMTUUHUUFUUJYMXMUUIAXPCARWHXLXQDXKXPHVFVGVHWIYMUUKUUJYMXTUUIYR
      XSXQDWJWKWLYRXTYMWMWNXBYSXTRWOWPWQWRXTBYAWSWTXCXDXE $.
  $}

  ${
    $d x B $.  $d x H $.  $d x I $.  $d x K $.  $d x W $.  $d x X $.  $d x Y $.
    dihmeet.b $e |- B = ( Base ` K ) $.
    dihmeet.m $e |- ./\ = ( meet ` K ) $.
    dihmeet.h $e |- H = ( LHyp ` K ) $.
    dihmeet.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Isomorphism H of a lattice meet.  (Contributed by NM, 13-Apr-2014.) $)
    dihmeet $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B /\ Y e. B )
     -> ( I ` ( X ./\ Y ) ) = ( ( I ` X ) i^i ( I ` Y ) ) ) $=
      ( vx chlt wcel wa cfv wceq 3adant1 fveq2 w3a co cpr cglb cv ciin cin eqid
      meetval 3adant1r fveq2d wss c0 simp1 prssi prnzg 3ad2ant2 dihglb syl12anc
      wne iinxprg 3eqtrd ) DNOZFBOZPZGAOZHAOZUAZGHEUBZCQGHUCZDUDQZQZCQZMVJMUEZC
      QZUFZGCQZHCQZUGZVHVIVLCVCVFVGVIVLRVDNAVKDEGHIVKUHZJUIUJUKVHVEVJAULZVJUMUT
      ZVMVPRVEVFVGUNVFVGWAVEGHAUOSVFVEWBVGGHAUPUQMAVJVKBCDFIVTKLURUSVFVGVPVSRVE
      MGHVOVQVRAAVNGCTVNHCTVASVB $.
  $}

  ${
    $d y x H $.  $d y x I $.  $d y x K $.  $d y x S $.  $d y x W $.
    dihintcl.h $e |- H = ( LHyp ` K ) $.
    dihintcl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( The intersection of closed subspaces (the range of isomorphism H) is a
       closed subspace.  (Contributed by NM, 14-Apr-2014.) $)
    dihintcl $p |- ( ( ( K e. HL /\ W e. H )
        /\ ( S C_ ran I /\ S =/= (/) ) ) -> |^| S e. ran I ) $=
      ( vy vx wcel wa crn wss c0 cfv wfn wceq adantr syl wi chlt ccnv cima cres
      wne cv ciin cint cdm cbs eqid dihfn dihdm fneq2d cnvimass fnssres sylancl
      mpbird fniinfv df-ima wfo dffn4 sylib simprl syl2anc syl5eqr inteqd eqtrd
      foimacnv cglb simpl syl5sseq wex simprr n0 wrex sselda fvelrnb mpbid wfun
      wb fnfun fvimacnv sylan ne0i syl6bi ex eleq1 biimprd imim1d syl9 rexlimdv
      com24 imp mpd exlimddv dihglb syl12anc fvres iineq2i ccla hlclat ad2antrr
      syl6eqr clatglbcl dihcl syldan eqeltrrd ) DUAJZEBJZKZACLZMZANUEZKZKZHCUBA
      UCZHUFZCXQUDZOZUGZAUHZXLXPYAXSLZUHZYBXPXSXQPZYAYDQXPCCUIZPZXQYFMYEXKYGXOX
      KYGCDUJOZPZYHBCDEYHUKZFGULZXKYFYHCYHBCDEYJFGUMZUNURRCAUOZYFXQCUPUQHXQXSUS
      SXPYCAXPYCCXQUCZACXQUTXPYHXLCVAZXMYNAQXPYIYOXKYIXOYKRZYHCVBVCXKXMXNVDZYHX
      LACVIVEVFVGVHXPXQDVJOZOZCOZYAXLXPYTHXQXRCOZUGZYAXPXKXQYHMZXQNUEZYTUUBQXKX
      OVKXPYFXQYHYMXKYFYHQXOYLRZVLZXPXRAJZUUDHXPXNUUGHVMXKXMXNVNHAVOVCXPUUGKZIU
      FZCOZXRQZIYFVPZUUDUUHXRXLJZUULXPAXLXRYQVQUUHYGUUMUULWAXPYGUUGXPYGYIYPXPYF
      YHCUUEUNURRIYFXRCVRSVSUUHUUKUUDIYFXPUUGUUIYFJZUUKUUDTTXPUUKUUNUUGUUDXPUUN
      UUJAJZUUDTZUUKUUGUUDTXPUUNUUPXPUUNKUUOUUIXQJZUUDXPCVTZUUNUUOUUQWAXPYIUURY
      PYHCWBSUUIACWCWDXQUUIWEWFWGUUKUUGUUOUUDUUKUUOUUGUUJXRAWHWIWJWKWMWNWLWOWPH
      YHXQYRBCDEYJYRUKZFGWQWRHXQXTUUAXRXQCWSWTXDXKXOYSYHJZYTXLJXPDXAJZUUCUUTXIU
      VAXJXODXBXCUUFYHXQYRDYJUUSXEVEYHBCDEYSYJFGXFXGXHXH $.
  $}

  ${
    dihmeetcl.h $e |- H = ( LHyp ` K ) $.
    dihmeetcl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    $( Closure of closed subspace meet for ` DVecH ` vector space.
       (Contributed by NM, 5-Aug-2014.) $)
    dihmeetcl $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. ran I /\ Y e. ran I ) )
          -> ( X i^i Y ) e. ran I ) $=
      ( wcel cfv wceq dihcnvid2 adantrr adantrl eqid dihcnvcl syl3anc eqeltrrd
      wa cin chlt crn ccnv ineq12d cmee cbs simpl dihmeet hllat ad2antrr latmcl
      co clat dihcl syldan ) CUAIZDAIZSZEBUBZIZFUSIZSZSZEBUCZJZBJZFVDJZBJZTZEFT
      USVCVFEVHFURUTVFEKVAABCDEGHLMURVAVHFKUTABCDFGHLNUDVCVEVGCUEJZULZBJZVIUSVC
      URVECUFJZIZVGVMIZVLVIKURVBUGURUTVNVAVMABCDEVMOZGHPMZURVAVOUTVMABCDFVPGHPN
      ZVMABCVJDVEVGVPVJOZGHUHQURVBVKVMIZVLUSIVCCUMIZVNVOVTUPWAUQVBCUIUJVQVRVMCV
      JVEVGVPVSUKQVMABCDVKVPGHUNUORR $.
  $}

  ${
    $d x B $.  $d x H $.  $d x I $.  $d x K $.  $d x W $.  $d x X $.  $d x Y $.
    dihmeet2.m $e |- ./\ = ( meet ` K ) $.
    dihmeet2.h $e |- H = ( LHyp ` K ) $.
    dihmeet2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihmeet2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihmeet2.x $e |- ( ph -> X e. ran I ) $.
    dihmeet2.y $e |- ( ph -> Y e. ran I ) $.
    $( Reverse isomorphism H of a closed subspace intersection.  (Contributed
       by NM, 15-Jan-2015.) $)
    dihmeet2 $p |- ( ph
     -> ( `' I ` ( X i^i Y ) ) = ( ( `' I ` X ) ./\ ( `' I ` Y ) ) ) $=
      ( cfv wceq wcel dihcnvid2 syl2anc dihcnvcl cin ccnv co wa crn ineq12d cbs
      chlt eqid dihmeet syl3anc dihmeetcl syl12anc 3eqtr4rd wb simpld hllat syl
      clat latmcl dih11 mpbid ) AGHUAZCUBZOZCOZGVDOZHVDOZEUCZCOZPZVEVIPZAVGCOZV
      HCOZUAZVCVJVFAVMGVNHADUHQZFBQZUDZGCUEZQZVMGPLMBCDFGJKRSAVRHVSQZVNHPLNBCDF
      HJKRSUFAVRVGDUGOZQZVHWBQZVJVOPLAVRVTWCLMWBBCDFGWBUIZJKTSZAVRWAWDLNWBBCDFH
      WEJKTSZWBBCDEFVGVHWEIJKUJUKAVRVCVSQZVFVCPLAVRVTWAWHLMNBCDFGHJKULUMZBCDFVC
      JKRSUNAVRVEWBQZVIWBQZVKVLUOLAVRWHWJLWIWBBCDFVCWEJKTSADUSQZWCWDWKAVPWLAVPV
      QLUPDUQURWFWGWBDEVGVHWEIUTUKWBBCDFVEVIWEJKVAUKVB $.
  $}

  $c ocH $.

  $( Extend class notation with subspace orthocomplement for ` DVecH ` vector
     space. $)
  coch $a class ocH $.

  ${
    $d k w x y $.
    $( Define subspace orthocomplement for ` DVecH ` vector space.
       Temporarily, we are using the range of the isomorphism instead of the
       set of closed subspaces.  Later, when inner product is introduced, we
       will show that these are the same.  (Contributed by NM, 14-Mar-2014.) $)
    df-doch $a |- ocH = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
          ( x e. ~P ( Base ` ( ( DVecH ` k ) ` w ) ) |->
 ( ( ( DIsoH ` k ) ` w ) ` ( ( oc ` k ) ` ( ( glb ` k ) `
   { y e. ( Base ` k ) | x C_ ( ( ( DIsoH ` k ) ` w ) ` y ) } ) ) ) ) ) ) $.
  $}

  ${
    $d k y B $.  $d k G $.  $d k w H $.  $d k w x y K $.  $d k ._|_ $.
    dochval.b $e |- B = ( Base ` K ) $.
    dochval.g $e |- G = ( glb ` K ) $.
    dochval.o $e |- ._|_ = ( oc ` K ) $.
    dochval.h $e |- H = ( LHyp ` K ) $.
    $( Subspace orthocomplement for ` DVecH ` vector space.  (Contributed by
       NM, 14-Mar-2014.) $)
    dochffval $p |- ( K e. V -> ( ocH ` K ) = ( w e. H |->
          ( x e. ~P ( Base ` ( ( DVecH ` K ) ` w ) ) |->
       ( ( ( DIsoH ` K ) ` w ) ` ( ._|_ ` ( G ` { y e. B |
             x C_ ( ( ( DIsoH ` K ) ` w ) ` y ) } ) ) ) ) ) ) $=
      ( cfv cv cbs cmpt clh fveq2 syl6eqr wcel cvv coch cdvh cpw cdih crab wceq
      vk wss elex cglb coc fveq1d fveq2d pweqd sseq2d rabeqbidv fveq12d df-doch
      mpteq12dv fvex eqeltri mptex fvmpt syl ) GIUAGUBUAGUCNCFACOZGUDNZNZPNZUEZ
      AOZBOZVGGUFNZNZNZUJZBDUGZENZHNZVONZQZQZUHGIUKUIGCUIOZRNZAVGWDUDNZNZPNZUEZ
      VLVMVGWDUFNZNZNZUJZBWDPNZUGZWDULNZNZWDUMNZNZWKNZQZQWCUBUCWDGUHZCWEXAFWBXB
      WEGRNZFWDGRSMTXBAWIWTVKWAXBWHVJXBWGVIPXBVGWFVHWDGUDSUNUOUPXBWSVTWKVOXBVGW
      JVNWDGUFSUNZXBWQVSWRHXBWRGUMNHWDGUMSLTXBWOVRWPEXBWPGULNEWDGULSKTXBWMVQBWN
      DXBWNGPNDWDGPSJTXBWLVPVLXBVMWKVOXDUNUQURUSUSUSVAVAABCUIUTCFWBFXCUBMGRVBVC
      VDVEVF $.

    $d w B $.  $d w G $.  $d w I $.  $d w ._|_ $.  $d w x V $.  $d w x y W $.
    dochval.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochval.v $e |- V = ( Base ` U ) $.
    dochval.n $e |- N = ( ( ocH ` K ) ` W ) $.
    $( Subspace orthocomplement for ` DVecH ` vector space.  (Contributed by
       NM, 14-Mar-2014.) $)
    dochfval $p |- ( ( K e. X /\ W e. H ) -> N = ( x e. ~P V |->
       ( I ` ( ._|_ ` ( G ` { y e. B | x C_ ( I ` y ) } ) ) ) ) ) $=
      ( vw wcel cv cdvh cfv cbs cpw cdih crab cmpt coch dochffval fveq1d syl5eq
      wss wceq fveq2 syl6eqr fveq2d pweqd sseq2d rabbidv fveq12d mpteq12dv eqid
      cvv fvex eqeltri pwex mptex fvmpt sylan9eq ) HMUCZLFUCILUBFAUBUDZHUEUFZUF
      ZUGUFZUHZAUDZBUDZVOHUIUFZUFZUFZUPZBCUJZEUFZJUFZWCUFZUKZUKZUFZAKUHZVTWAGUF
      ZUPZBCUJZEUFZJUFZGUFZUKZVNILHULUFZUFWLUAVNLXAWKABUBCEFHJMNOPQUMUNUOUBLWJW
      TFWKVOLUQZAVSWIWMWSXBVRKXBVRDUGUFZKXBVQDUGXBVQLVPUFDVOLVPURSUSUTTUSVAXBWH
      WRWCGXBWCLWBUFGVOLWBURRUSZXBWGWQJXBWFWPEXBWEWOBCXBWDWNVTXBWAWCGXDUNVBVCUT
      UTVDVEWKVFAWMWSKKXCVGTDUGVHVIVJVKVLVM $.

    $d x B $.  $d x G $.  $d x I $.  $d x ._|_ $.  $d x y X $.
    $( Subspace orthocomplement for ` DVecH ` vector space.  (Contributed by
       NM, 14-Mar-2014.) $)
    dochval $p |- ( ( ( K e. Y /\ W e. H ) /\ X C_ V ) -> ( N ` X )
        = ( I ` ( ._|_ ` ( G ` { y e. B | X C_ ( I ` y ) } ) ) ) ) $=
      ( vx wcel wa wss cfv cpw cv crab cmpt wceq dochfval adantr fveq1d cvv cbs
      fvex eqeltri elpw2 biimpri adantl sseq1 rabbidv fveq2d eqid sylancl eqtrd
      fvmptg ) GMUCKEUCUDZLJUEZUDZLHUFLUBJUGZUBUHZAUHFUFZUEZABUIZDUFZIUFZFUFZUJ
      ZUFZLVNUEZABUIZDUFZIUFZFUFZVKLHVTVIHVTUKVJUBABCDEFGHIJKMNOPQRSTUAULUMUNVK
      LVLUCZWFUOUCWAWFUKVJWGVIWGVJLJJCUPUFUOTCUPUQURUSUTVAWEFUQUBLVSWFVLUOVTVML
      UKZVRWEFWHVQWDIWHVPWCDWHVOWBABVMLVNVBVCVDVDVDVTVEVHVFVG $.
  $}

  ${
    $d z H $.  $d x z I $.  $d x z K $.  $d z V $.  $d x z W $.  $d x z X $.
    dochval2.o $e |- ._|_ = ( oc ` K ) $.
    dochval2.h $e |- H = ( LHyp ` K ) $.
    dochval2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochval2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochval2.v $e |- V = ( Base ` U ) $.
    dochval2.n $e |- N = ( ( ocH ` K ) ` W ) $.
    $( Subspace orthocomplement for ` DVecH ` vector space.  (Contributed by
       NM, 14-Apr-2014.) $)
    dochval2 $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V ) -> ( N ` X )
        = ( I ` ( ._|_ ` ( `' I ` |^| { z e. ran I | X C_ z } ) ) ) ) $=
      ( vx wcel wss cfv chlt cbs crab cglb crn cint ccnv eqid dochval wceq ccla
      wa hlclat ssrab2 clatglbcl sylancl dihcnvid1 syldan dihglb2 fveq2d eqtr3d
      cv ad2antrr eqtrd ) EUARZICRZULZJHSZULZJFTJQVBDTSZQEUBTZUCZEUDTZTZGTZDTJA
      VBSADUEUCUFZDUGZTZGTZDTQVKBVMCDEFGHIJUAVKUHZVMUHZKLMNOPUIVIVOVSDVIVNVRGVI
      VNDTZVQTZVNVRVGVHVNVKRZWCVNUJVIEUKRZVLVKSWDVEWEVFVHEUMVCVJQVKUNVKVLVMEVTW
      AUOUPVKCDEIVNVTLMUQURVIWBVPVQQAVKJBVMCDEHIVTWALMNOUSUTVAUTUTVD $.
  $}

  ${
    $d y K $.  $d y W $.  $d y X $.
    dochcl.h $e |- H = ( LHyp ` K ) $.
    dochcl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochcl.v $e |- V = ( Base ` U ) $.
    dochcl.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( Closure of subspace orthocomplement for ` DVecH ` vector space.
       (Contributed by NM, 9-Mar-2014.) $)
    dochcl $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V )
          -> ( ._|_ ` X ) e. ran I ) $=
      ( vy chlt wcel wa wss cfv eqid cv cbs crab cglb coc crn dochval cops hlop
      ad2antrr ccla hlclat ssrab2 clatglbcl sylancl opoccl syl2anc dihcl syldan
      eqeltrd ) DOPZGBPZQZHFRZQZHESHNUACSRZNDUBSZUCZDUDSZSZDUESZSZCSZCUFZNVGAVI
      BCDEVKFGHOVGTZVITZVKTZIJKLMUGVCVDVLVGPZVMVNPVEDUHPZVJVGPZVRVAVSVBVDDUIUJV
      EDUKPZVHVGRVTVAWAVBVDDULUJVFNVGUMVGVHVIDVOVPUNUOVGDVKVJVOVQUPUQVGBCDGVLVO
      IJURUSUT $.
  $}

  ${
    dochlss.h $e |- H = ( LHyp ` K ) $.
    dochlss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochlss.v $e |- V = ( Base ` U ) $.
    dochlss.s $e |- S = ( LSubSp ` U ) $.
    dochlss.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( A subspace orthocomplement is a subspace of the ` DVecH ` vector space.
       (Contributed by NM, 22-Jul-2014.) $)
    dochlss $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V ) ->
      ( ._|_ ` X ) e. S ) $=
      ( chlt wcel wa wss cfv cdih crn eqid dochcl dihrnlss syldan ) DNOGCOPHFQH
      ERZGDSRRZTOUEAOBCUFDEFGHIUFUAZJKMUBABCUFDGUEIJUGLUCUD $.
  $}

  ${
    dochssv.h $e |- H = ( LHyp ` K ) $.
    dochssv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochssv.v $e |- V = ( Base ` U ) $.
    dochssv.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( A subspace orthocomplement belongs to the ` DVecH ` vector space.
       (Contributed by NM, 22-Jul-2014.) $)
    dochssv $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V ) ->
      ( ._|_ ` X ) C_ V ) $=
      ( chlt wcel wa wss cfv cdih crn eqid dochcl dihrnss syldan ) CLMFBMNGEOGD
      PZFCQPPZRMUCEOABUDCDEFGHUDSZIJKTABUDCEFUCHIUEJUAUB $.
  $}

  ${
    $d y ._|_ $.  $d x y K $.  $d x y ph $.  $d x y V $.  $d x y W $.
    $d y I $.
    dochf.h $e |- H = ( LHyp ` K ) $.
    dochf.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochf.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochf.v $e |- V = ( Base ` U ) $.
    dochf.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochf.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Domain and codomain of the subspace orthocomplement for the ` DVecH `
       vector space.  (Contributed by NM, 27-Dec-2014.)
       (New usage is discouraged.) $)
    dochfN $p |- ( ph -> ._|_ : ~P V --> ran I ) $=
      ( vx vy cv cfv wcel eqid cpw wss cbs crab cglb coc crn cvv fvex chlt cmpt
      wa a1i wceq dochfval syl elpwi dochcl syl2an fmpt2d ) AOPGUAZOQZPQZDRUBPE
      UCRZUDEUERZREUFRZRZDRZDUGZFUHVHUHSAVBVASULVGDUIUMAEUJSHCSULZFOVAVHUKUNNOP
      VDBVECDEFVFGHUJVDTVETVFTIJKLMUOUPAVJVCGUBVCFRVISVCVASNVCGUQBCDEFGHVCIJKLM
      URUSUT $.
  $}

  ${
    $d z H $.  $d y z I $.  $d y z K $.  $d y z W $.  $d y z X $.
    dochvalr.o $e |- ._|_ = ( oc ` K ) $.
    dochvalr.h $e |- H = ( LHyp ` K ) $.
    dochvalr.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochvalr.n $e |- N = ( ( ocH ` K ) ` W ) $.
    $( Orthocomplement of a closed subspace.  (Contributed by NM,
       14-Mar-2014.) $)
    dochvalr $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
        -> ( N ` X ) = ( I ` ( ._|_ ` ( `' I ` X ) ) ) ) $=
      ( vy vz wcel wa cfv wss wceq eqid wbr chlt crn cv cbs crab cglb ccnv cdvh
      dihrnss dochval syldan cple clat ad2antrr hlclat ssrab2 clatglbcl sylancl
      hllat ccla dihcnvcl ssid dihcnvid2 syl5sseqr fveq2 sseq2d elrab clatglble
      a1i sylanbrc syl3anc wral adantr sseq1d simpll simpr dihord bitr3d biimpd
      wb expimpd syl5bi ralrimiv clatleglb mpbird latasymd fveq2d eqtrd ) CUANZ
      FANZOZGBUBNZOZGDPZGLUCZBPZQZLCUDPZUEZCUFPZPZEPZBPZGBUGPZEPZBPWKWLGFCUHPPZ
      UDPZQWNXCRXFABCXGFGIXFSZJXGSZUILWRXFWTABCDEXGFGUAWRSZWTSZHIJXHXIKUJUKWMXB
      XEBWMXAXDEWMWRCCULPZXAXDXJXLSZWICUMNWJWLCUSUNWMCUTNZWSWRQZXAWRNWIXNWJWLCU
      OUNZWQLWRUPZWRWSWTCXJXKUQURWRABCFGXJIJVAZWMXNXOXDWSNZXAXDXLTXPXOWMXQVIZWM
      XDWRNZGXDBPZQZXSXRWMGGYBGVBABCFGIJVCZVDWQYCLXDWRWOXDRWPYBGWOXDBVEVFVGVJWR
      WSWTCXLXDXJXMXKVHVKWMXDXAXLTZXDMUCZXLTZMWSVLZWMYGMWSYFWSNYFWRNZGYFBPZQZOW
      MYGWQYKLYFWRWOYFRWPYJGWOYFBVEVFVGWMYIYKYGWMYIOZYKYGYLYBYJQZYKYGYLYBGYJWMY
      BGRYIYDVMVNYLWKYAYIYMYGVTWKWLYIVOWMYAYIXRVMWMYIVPWRABCXLFXDYFXJXMIJVQVKVR
      VSWAWBWCWMXNYAXOYEYHVTXPXRXTMWRWSWTCXLXDXJXMXKWDVKWEWFWGWGWH $.
  $}

  ${
    doch0.h $e |- H = ( LHyp ` K ) $.
    doch0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    doch0.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    doch0.v $e |- V = ( Base ` U ) $.
    doch0.z $e |- .0. = ( 0g ` U ) $.
    $( Orthocomplement of the zero subspace.  (Contributed by NM,
       19-Jun-2014.) $)
    doch0 $p |- ( ( K e. HL /\ W e. H ) -> ( ._|_ ` { .0. } ) = V ) $=
      ( chlt wcel wa cfv wceq eqid fveq2d eqtrd csn cdih coc crn dochvalr mpdan
      ccnv dih0rn cp1 cp0 dih0cnv cops hlop adantr opoc0 syl dih1 ) CMNZFBNZOZG
      UAZDPZVAFCUBPPZUGPZCUCPZPZVCPZEUTVAVCUDNVBVGQABVCCFGHVCRZILUHBVCCDVEFVAVE
      RZHVHJUEUFUTVGCUIPZVCPEUTVFVJVCUTVFCUJPZVEPZVJUTVDVKVEABVCCFVKGHVKRZVHILU
      KSUTCULNZVLVJQURVNUSCUMUNVJCVEVKVMVJRZVIUOUPTSAVJBVCCEFVOHVHIKUQTT $.
  $}

  ${
    doch1.h $e |- H = ( LHyp ` K ) $.
    doch1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    doch1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    doch1.v $e |- V = ( Base ` U ) $.
    doch1.z $e |- .0. = ( 0g ` U ) $.
    $( Orthocomplement of the unit subspace (all vectors).  (Contributed by NM,
       19-Jun-2014.) $)
    doch1 $p |- ( ( K e. HL /\ W e. H ) -> ( ._|_ ` V ) = { .0. } ) $=
      ( chlt wcel wa cfv cdih wceq eqid fveq2d ccnv coc cp0 csn dih1rn dochvalr
      crn mpdan cp1 dih1cnv cops hlop adantr opoc1 syl eqtrd dih0 3eqtrd ) CMNZ
      FBNZOZEDPZEFCQPPZUAPZCUBPZPZVCPZCUCPZVCPGUDVAEVCUGNVBVGRABVCCEFHVCSZIKUEB
      VCCDVEFEVESZHVIJUFUHVAVFVHVCVAVFCUIPZVEPZVHVAVDVKVEAVKBVCCEFHVKSZVIIKUJTV
      ACUKNZVLVHRUSVNUTCULUMVKCVEVHVHSZVMVJUNUOUPTABVCCGFVHVOHVIILUQUR $.
  $}

  ${
    dochoc0.h $e |- H = ( LHyp ` K ) $.
    dochoc0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochoc0.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochoc0.z $e |- .0. = ( 0g ` U ) $.
    dochoc0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The zero subspace is closed.  (Contributed by NM, 16-Feb-2015.) $)
    dochoc0 $p |- ( ph -> ( ._|_ ` ( ._|_ ` { .0. } ) ) = { .0. } ) $=
      ( chlt wcel wa csn cfv wceq cbs eqid doch0 fveq2d doch1 eqtrd syl ) ADMNF
      CNOZGPZEQZEQZUGRLUFUIBSQZEQUGUFUHUJEBCDEUJFGHIJUJTZKUAUBBCDEUJFGHIJUKKUCU
      DUE $.
  $}

  ${
    dochoc1.h $e |- H = ( LHyp ` K ) $.
    dochoc1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochoc1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochoc1.v $e |- V = ( Base ` U ) $.
    dochoc1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The unit subspace (all vectors) is closed.  (Contributed by NM,
       16-Feb-2015.) $)
    dochoc1 $p |- ( ph -> ( ._|_ ` ( ._|_ ` V ) ) = V ) $=
      ( chlt wcel wa cfv wceq c0g csn eqid doch1 fveq2d doch0 eqtrd syl ) ADMNG
      CNOZFEPZEPZFQLUFUHBRPZSZEPFUFUGUJEBCDEFGUIHIJKUITZUAUBBCDEFGUIHIJKUKUCUDU
      E $.
  $}

  ${
    dochvalr2.b $e |- B = ( Base ` K ) $.
    dochvalr2.o $e |- ._|_ = ( oc ` K ) $.
    dochvalr2.h $e |- H = ( LHyp ` K ) $.
    dochvalr2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochvalr2.n $e |- N = ( ( ocH ` K ) ` W ) $.
    $( Orthocomplement of a closed subspace.  (Contributed by NM,
       21-Jul-2014.) $)
    dochvalr2 $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. B )
        -> ( N ` ( I ` X ) ) = ( I ` ( ._|_ ` X ) ) ) $=
      ( chlt wcel wa cfv ccnv crn fveq2d dihcl dochvalr syldan dihcnvid1 eqtrd
      wceq ) DNOGBOPZHAOZPZHCQZEQZUJCRQZFQZCQZHFQZCQUGUHUJCSOUKUNUFABCDGHIKLUAB
      CDEFGUJJKLMUBUCUIUMUOCUIULHFABCDGHIKLUDTTUE $.
  $}

  ${
    dochvalr3.o $e |- ._|_ = ( oc ` K ) $.
    dochvalr3.h $e |- H = ( LHyp ` K ) $.
    dochvalr3.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochvalr3.n $e |- N = ( ( ocH ` K ) ` W ) $.
    dochvalr3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochvalr3.x $e |- ( ph -> X e. ran I ) $.
    $( Orthocomplement of a closed subspace.  (Contributed by NM,
       15-Jan-2015.) $)
    dochvalr3 $p |- ( ph -> ( ._|_ ` ( `' I ` X ) ) = ( `' I ` ( N ` X ) ) ) $=
      ( cfv wceq wcel cbs eqid syl2anc ccnv chlt wa crn cdvh wss dihrnss dochcl
      dihcnvid2 dochvalr eqtr2d wb cops simpld hlop syl dihcnvcl opoccl syl3anc
      dih11 mpbid ) AHCUAZOZFOZCOZHEOZVBOZCOZPZVDVGPZAVHVFVEADUBQZGBQZUCZVFCUDZ
      QZVHVFPMAVMHGDUEOOZROZUFZVOMAVMHVNQZVRMNVPBCDVQGHJVPSZKVQSZUGTVPBCDEVQGHJ
      KVTWALUHTZBCDGVFJKUITAVMVSVFVEPMNBCDEFGHIJKLUJTUKAVMVDDROZQZVGWCQZVIVJULM
      ADUMQZVCWCQZWDAVKWFAVKVLMUNDUOUPAVMVSWGMNWCBCDGHWCSZJKUQTWCDFVCWHIURTAVMV
      OWEMWBWCBCDGVFWHJKUQTWCBCDGVDVGWHJKUTUSVA $.
  $}

  ${
    $d z H $.  $d z I $.  $d z K $.  $d z V $.  $d z W $.  $d z X $.
    doch2val2.h $e |- H = ( LHyp ` K ) $.
    doch2val2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    doch2val2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    doch2val2.v $e |- V = ( Base ` U ) $.
    doch2val2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    doch2val2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    doch2val2.x $e |- ( ph -> X C_ V ) $.
    $( Double orthocomplement for ` DVecH ` vector space.  (Contributed by NM,
       26-Jul-2014.) $)
    doch2val2 $p |- ( ph -> ( ._|_ ` ( ._|_ ` X ) )
        = |^| { z e. ran I | X C_ z } ) $=
      ( cfv wcel syl2anc cv wss crn crab cint ccnv coc chlt wa wceq eqid fveq2d
      dochval2 cbs cops simpld hlop syl c0 wne ssrab2 a1i dih1rn sseq2 sylanbrc
      elrab dihintcl syl12anc dihcnvcl opoccl dochvalr2 opococ dihcnvid2 3eqtrd
      ne0i eqtrd ) AJGRZGRJBUAZUBZBEUCZUDZUEZEUFRZFUGRZRZERZGRZWEWDRZERZWBAVQWF
      GAFUHSZIDSZUIZJHUBZVQWFUJPQBCDEFGWDHIJWDUKZKLMNOUMTULAWLWEFUNRZSZWGWIUJPA
      FUOSZWCWOSZWPAWJWQAWJWKPUPFUQURZAWLWBVTSZWRPAWLWAVTUBZWAUSUTZWTPXAAVSBVTV
      AVBAHWASZXBAHVTSZWMXCAWLXDPCDEFHIKLMNVCURQVSWMBHVTVRHJVDVFVEWAHVOURWADEFI
      KLVGVHZWODEFIWBWOUKZKLVITZWOFWDWCXFWNVJTWODEFGWDIWEXFWNKLOVKTAWIWCERZWBAW
      HWCEAWQWRWHWCUJWSXGWOFWDWCXFWNVLTULAWLWTXHWBUJPXEDEFIWBKLVMTVPVN $.
  $}

  ${
    $d z H $.  $d z K $.  $d z V $.  $d z W $.  $d z X $.  $d z Y $.
    dochss.h $e |- H = ( LHyp ` K ) $.
    dochss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochss.v $e |- V = ( Base ` U ) $.
    dochss.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( Subset law for orthocomplement.  (Contributed by NM, 16-Apr-2014.) $)
    dochss $p |- ( ( ( K e. HL /\ W e. H ) /\ Y C_ V /\ X C_ Y )
        -> ( ._|_ ` Y ) C_ ( ._|_ ` X ) ) $=
      ( vz chlt wcel wa wss cfv eqid syl3anc w3a cv cdih cbs crab cglb coc cple
      wbr ccla simp1l hlclat syl ssrab2 a1i simpll3 simpr ex ss2rabdv clatglbss
      sstrd cops wb hlop clatglbcl sylancl oplecon3b mpbid simp1 opoccl syl2anc
      dihord mpbird wceq dochval 3adant3 simp3 simp2 3sstr4d ) CNOZFBOZPZHEQZGH
      QZUAZHMUBZFCUCRRZRZQZMCUDRZUEZCUFRZRZCUGRZRZWGRZGWHQZMWJUEZWLRZWNRZWGRZHD
      RZGDRZWEWPXAQZWOWTCUHRZUIZWEWSWMXEUIZXFWECUJOZWRWJQZWKWRQXGWEVTXHVTWAWCWD
      UKZCULUMZXIWEWQMWJUNZUOWEWIWQMWJWEWFWJOZPZWIWQXNWIPGHWHWBWCWDXMWIUPXNWIUQ
      VAURUSWJWKWRWLCXEWJSZXESZWLSZUTTWECVBOZWSWJOZWMWJOZXGXFVCWEVTXRXJCVDUMZWE
      XHXIXSXKXLWJWRWLCXOXQVEVFZWEXHWKWJQXTXKWIMWJUNWJWKWLCXOXQVEVFZWJCXEWNWSWM
      XOXPWNSZVGTVHWEWBWOWJOZWTWJOZXDXFVCWBWCWDVIZWEXRXTYEYAYCWJCWNWMXOYDVJVKWE
      XRXSYFYAYBWJCWNWSXOYDVJVKWJBWGCXEFWOWTXOXPIWGSZVLTVMWBWCXBWPVNWDMWJAWLBWG
      CDWNEFHNXOXQYDIYHJKLVOVPWEWBGEQXCXAVNYGWEGHEWBWCWDVQWBWCWDVRVAMWJAWLBWGCD
      WNEFGNXOXQYDIYHJKLVOVKVS $.

    $( Double negative law for orthocomplement of an arbitrary set of vectors.
       (Contributed by NM, 16-Apr-2014.) $)
    dochocss $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V )
        -> X C_ ( ._|_ ` ( ._|_ ` X ) ) ) $=
      ( vz wcel wss cfv wceq eqid fveq2d syl syl2anc chlt wa cdih crn crab cint
      ssintub ccnv coc dochcl dochvalr syldan dochval2 cbs wf1o clss wf1 dihf11
      cv adantr f1f1orn cops hlop ad2antrr c0 wne simpl ssrab2 a1i cp1 dih1 wfn
      f1fn op1cl fnfvelrn eqeltrrd simpr sseq2 elrab sylanbrc dihintcl syl12anc
      ne0i f1ocnvdm opoccl f1ocnvfv1 eqtrd opococ f1ocnvfv2 3eqtrrd syl5sseq )
      CUAMZFBMZUBZGENZUBZGLUSZNZLFCUCOOZUDZUEZUFZGGDOZDOZLGWTUGWPXDXCWSUHZOZCUI
      OZOZWSOZXBXEOZWSOZXBWNWOXCWTMXDXIPABWSCDEFGHWSQZIJKUJBWSCDXGFXCXGQZHXLKUK
      ULWPXHXJWSWPXHXJXGOZXGOZXJWPXFXNXGWPXFXNWSOZXEOZXNWPXCXPXELABWSCDXGEFGXMH
      XLIJKUMRWPCUNOZWTWSUOZXNXRMZXQXNPWPXRAUPOZWSUQZXSWNYBWOXRYAABWSCFXRQZHXLI
      YAQURUTZXRYAWSVASZWPCVBMZXJXRMZXTWLYFWMWOCVCVDZWPXSXBWTMZYGYEWPWNXAWTNZXA
      VEVFZYIWNWOVGYJWPWRLWTVHVIWPEXAMZYKWPEWTMWOYLWPCVJOZWSOZEWTWNYNEPWOAYMBWS
      CEFYMQZHXLIJVKUTWPWSXRVLZYMXRMZYNWTMWPYBYPYDXRYAWSVMSWPYFYQYHXRYMCYCYOVNS
      XRYMWSVOTVPWNWOVQWRWOLEWTWQEGVRVSVTXAEWCSXABWSCFHXLWAWBZXRWTXBWSWDTZXRCXG
      XJYCXMWETXRWTXNWSWFTWGRWPYFYGXOXJPYHYSXRCXGXJYCXMWHTWGRWPXSYIXKXBPYEYRXRW
      TXBWSWITWJWK $.
  $}

  ${
    dochoc.h $e |- H = ( LHyp ` K ) $.
    dochoc.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochoc.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( Double negative law for orthocomplement of a closed subspace.
       (Contributed by NM, 14-Mar-2014.) $)
    dochoc $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. ran I )
        -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $=
      ( chlt wcel wa cfv eqid dochvalr fveq2d wceq syl2anc syldan eqtrd crn coc
      ccnv cops hlop ad2antrr dihcnvcl opoccl dihcl dihcnvid1 opococ dihcnvid2
      cbs ) CJKZEAKZLZFBUAZKZLZFDMZDMFBUCZMZCUBMZMZBMZDMZFUSUTVEDABCDVCEFVCNZGH
      IOPUSVFVEVAMZVCMZBMZFUPURVEUQKZVFVJQUPURVDCUMMZKZVKUSCUDKZVBVLKZVMUNVNUOU
      RCUEUFZVLABCEFVLNZGHUGZVLCVCVBVQVGUHRZVLABCEVDVQGHUISABCDVCEVEVGGHIOSUSVJ
      VBBMFUSVIVBBUSVIVDVCMZVBUSVHVDVCUPURVMVHVDQVSVLABCEVDVQGHUJSPUSVNVOVTVBQV
      PVRVLCVCVBVQVGUKRTPABCEFGHULTTT $.
  $}

  ${
    dochsscl.h $e |- H = ( LHyp ` K ) $.
    dochsscl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsscl.v $e |- V = ( Base ` U ) $.
    dochsscl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochsscl.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsscl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsscl.x $e |- ( ph -> X C_ V ) $.
    dochsscl.y $e |- ( ph -> Y e. ran I ) $.
    $( If a set of vectors is included in a closed set, so is its closure.
       (Contributed by NM, 17-Jun-2015.) $)
    dochsscl $p |- ( ph -> ( X C_ Y <-> ( ._|_ ` ( ._|_ ` X ) ) C_ Y ) ) $=
      ( wss cfv wa chlt adantr dochssv syl2anc crn dihrnss simpr dochss syl3anc
      wcel wceq dochoc sseqtrd dochocss sstr sylan impbida ) AIJSZIFTZFTZJSZAUS
      UAZVAJFTZFTZJVCEUBUKHCUKUAZUTGSZVDUTSZVAVESAVFUSPUCZVCVFIGSZVGVIAVJUSQUCB
      CEFGHIKLMOUDUEVCVFJGSZUSVHVIAVKUSAVFJDUFUKZVKPRBCDEGHJKLNMUGUEUCAUSUHBCEF
      GHIJKLMOUIUJBCEFGHVDUTKLMOUIUJVCVFVLVEJULVIAVLUSRUCCDEFHJKNOUMUEUNAIVASZV
      BUSAVFVJVMPQBCEFGHIKLMOUOUEIVAJUPUQUR $.
  $}

  ${
    dochoccl.h $e |- H = ( LHyp ` K ) $.
    dochoccl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochoccl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochoccl.v $e |- V = ( Base ` U ) $.
    dochoccl.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochoccl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochoccl.g $e |- ( ph -> X C_ V ) $.
    $( A set of vectors is closed iff it equals its double orthocomplent.
       (Contributed by NM, 1-Jan-2015.) $)
    dochoccl $p |- ( ph -> ( X e. ran I <-> ( ._|_ ` ( ._|_ ` X ) ) = X ) ) $=
      ( wcel cfv wa wss crn wceq chlt dochoc sylan simpr dochssv syl2anc dochcl
      adantr eqeltrrd impbida ) AIDUAZQZIFRZFRZIUBZAEUCQHCQSZUNUQOCDEFHIJKNUDUE
      AUQSUPIUMAUQUFAUPUMQZUQAURUOGTZUSOAURIGTUTOPBCEFGHIJLMNUGUHBCDEFGHUOJKLMN
      UIUHUJUKUL $.
  $}

  ${
    doch11.h $e |- H = ( LHyp ` K ) $.
    doch11.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    doch11.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    doch11.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    doch11.x $e |- ( ph -> X e. ran I ) $.
    doch11.y $e |- ( ph -> Y e. ran I ) $.
    $( Ordering law for orthocomplement.  (Contributed by NM, 12-Aug-2014.) $)
    dochord $p |- ( ph -> ( X C_ Y <-> ( ._|_ ` Y ) C_ ( ._|_ ` X ) ) ) $=
      ( wss cfv wa wcel adantr syl2anc chlt cdvh cbs eqid dihrnss simpr syl3anc
      crn dochss dochcl wceq dochoc 3sstr3d impbida ) AGHOZHEPZGEPZOZAUOQDUARFB
      RQZHFDUBPPZUCPZOZUOURAUSUOLSAVBUOAUSHCUHZRZVBLNUTBCDVAFHIUTUDZJVAUDZUETSA
      UOUFUTBDEVAFGHIVEVFKUIUGAURQZUQEPZUPEPZGHVGUSUQVAOZURVHVIOAUSURLSAVJURAUS
      UQVCRZVJLAUSGVAOZVKLAUSGVCRZVLLMUTBCDVAFGIVEJVFUETUTBCDEVAFGIJVEVFKUJTUTB
      CDVAFUQIVEJVFUETSAURUFUTBDEVAFUPUQIVEVFKUIUGAVHGUKZURAUSVMVNLMBCDEFGIJKUL
      TSAVIHUKZURAUSVDVOLNBCDEFHIJKULTSUMUN $.

    $( Ordering law for orthocomplement.  (Contributed by NM, 29-Oct-2014.)
       (New usage is discouraged.) $)
    dochord2N $p |- ( ph -> ( ( ._|_ ` X ) C_ Y <-> ( ._|_ ` Y ) C_ X ) ) $=
      ( cfv wss chlt wcel eqid syl2anc wa cdvh cbs crn clss dihrnlss syl dochcl
      lssss dochord wceq dochoc sseq2d bitrd ) AGEOZHPHEOZUOEOZPUPGPABCDEFUOHIJ
      KLADQRFBRUAZGFDUBOOZUCOZPZUOCUDZRLAGUSUEOZRZVAAURGVBRZVDLMVCUSBCDFGIUSSZJ
      VCSZUFTVCGUTUSUTSZVGUIUGUSBCDEUTFGIJVFVHKUHTNUJAUQGUPAURVEUQGUKLMBCDEFGIJ
      KULTUMUN $.

    $( Ordering law for orthocomplement.  (Contributed by NM, 9-Mar-2015.) $)
    dochord3 $p |- ( ph -> ( X C_ ( ._|_ ` Y ) <-> Y C_ ( ._|_ ` X ) ) ) $=
      ( cfv wss chlt wcel eqid syl2anc wa cdvh cbs crn clss dihrnlss syl dochcl
      lssss dochord wceq dochoc sseq1d bitrd ) AGHEOZPUOEOZGEOZPHUQPABCDEFGUOIJ
      KLMADQRFBRUAZHFDUBOOZUCOZPZUOCUDZRLAHUSUEOZRZVAAURHVBRZVDLNVCUSBCDFHIUSSZ
      JVCSZUFTVCHUTUSUTSZVGUIUGUSBCDEUTFHIJVFVHKUHTUJAUPHUQAURVEUPHUKLNBCDEFHIJ
      KULTUMUN $.

    $( Orthocomplement is one-to-one.  (Contributed by NM, 12-Aug-2014.) $)
    doch11 $p |- ( ph -> ( ( ._|_ ` X ) = ( ._|_ ` Y ) <-> X = Y ) ) $=
      ( wceq cfv wss wa dochord eqss anbi12d eqcom bitri 3bitr4g bicomd ) AGHOZ
      GEPZHEPZOZAHGQZGHQZRZUGUHQZUHUGQZRUFUIAUJUMUKUNABCDEFHGIJKLNMSABCDEFGHIJK
      LMNSUAUFHGOULGHUBHGTUCUGUHTUDUE $.

    $( Strict ordering law for orthocomplement.  (Contributed by NM,
       12-Aug-2014.)  (New usage is discouraged.) $)
    dochsordN $p |- ( ph -> ( X C. Y <-> ( ._|_ ` Y ) C. ( ._|_ ` X ) ) ) $=
      ( wss wne wa cfv wpss wceq dochord doch11 eqcom syl6rbb necon3bid anbi12d
      df-pss 3bitr4g ) AGHOZGHPZQHERZGERZOZUKULPZQGHSUKULSAUIUMUJUNABCDEFGHIJKL
      MNUAAGHUKULAUKULTHGTGHTABCDEFHGIJKLNMUBHGUCUDUEUFGHUGUKULUGUH $.
  $}

  ${
    dochn0nv.h $e |- H = ( LHyp ` K ) $.
    dochn0nv.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochn0nv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochn0nv.v $e |- V = ( Base ` U ) $.
    dochn0nv.z $e |- .0. = ( 0g ` U ) $.
    dochn0nv.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochn0nv.x $e |- ( ph -> X C_ V ) $.
    $( An orthocomplement is nonzero iff the double orthocomplement is not the
       whole vector space.  (Contributed by NM, 1-Jan-2015.) $)
    dochn0nv $p |- ( ph
        -> ( ( ._|_ ` X ) =/= { .0. } <-> ( ._|_ ` ( ._|_ ` X ) ) =/= V ) ) $=
      ( cfv wceq wcel syl2anc csn chlt wa cdih crn wss eqid dochcl dochoc doch1
      syl eqeq12d dochssv dih1rn doch11 bitr3d necon3bid ) AHEQZIUAZUREQZFAUTEQ
      ZFEQZRURUSRUTFRAVAURVBUSADUBSGCSUCZURGDUDQQZUEZSZVAURROAVCHFUFZVFOPBCVDDE
      FGHJVDUGZLMKUHTCVDDEGURJVHKUITAVCVBUSROBCDEFGIJLKMNUJUKULACVDDEGUTFJVHKOA
      VCURFUFZUTVESOAVCVGVIOPBCDEFGHJLMKUMTBCVDDEFGURJVHLMKUHTAVCFVESOBCVDDFGJV
      HLMUNUKUOUPUQ $.
  $}

  ${
    dihoml4c.h $e |- H = ( LHyp ` K ) $.
    dihoml4c.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihoml4c.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dihoml4c.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihoml4c.x $e |- ( ph -> X e. ran I ) $.
    dihoml4c.y $e |- ( ph -> Y e. ran I ) $.
    dihoml4c.l $e |- ( ph -> X C_ Y ) $.
    $( Version of ~ dihoml4 with closed subspaces.  (Contributed by NM,
       15-Jan-2015.) $)
    dihoml4c $p |- ( ph
           -> ( ( ._|_ ` ( ( ._|_ ` X ) i^i Y ) ) i^i Y ) = X ) $=
      ( cfv co eqid wcel syl2anc cin ccnv wceq cmee coc chlt cdvh cbs wss inss1
      wa crn dihrnss syl5ss dochcl dihmeet2 dihmeetcl syl12anc dochvalr3 oveq1d
      dochssv eqtr4d fveq2d eqtr3d cple wbr dihcnvord mpbird coml wi simpld syl
      hloml dihcnvcl omllaw4 syl3anc mpd 3eqtrd dihcnv11 mpbid ) AGEPZHUAZEPZHU
      AZCUBZPZGWEPZUCWDGUCAWFWCWEPZHWEPZDUDPZQWGDUEPZPZWIWJQZWKPZWIWJQZWGABCDWJ
      FWCHWJRZIJLADUFSZFBSZUKZWBFDUGPPZUHPZUIWCCULZSZLAWBWAXAWAHUJAWSGXAUIZWAXA
      UILAWSGXBSZXDLMWTBCDXAFGIWTRZJXARZUMTZWTBDEXAFGIXFXGKVATUNWTBCDEXAFWBIJXF
      XGKUOTZNUPAWHWNWIWJAWBWEPZWKPWHWNABCDEWKFWBWKRZIJKLAWSWAXBSZHXBSZWBXBSLAW
      SXDXLLXHWTBCDEXAFGIJXFXGKUOTZNBCDFWAHIJUQURUSAXJWMWKAXJWAWEPZWIWJQWMABCDW
      JFWAHWPIJLXNNUPAWLXOWIWJABCDEWKFGXKIJKLMUSUTVBVCVDUTAWGWIDVEPZVFZWOWGUCZA
      XQGHUIOABCDXPFGHXPRZIJLMNVGVHADVISZWGDUHPZSZWIYASZXQXRVJAWQXTAWQWRLVKDVMV
      LAWSXEYBLMYABCDFGYARZIJVNTAWSXMYCLNYABCDFHYDIJVNTYADXPWJWKWGWIYDXSWPXKVOV
      PVQVRABCDFWDGIJLAWSXCXMWDXBSLXINBCDFWCHIJUQURMVSVT $.
  $}

  ${
    dihoml4.h $e |- H = ( LHyp ` K ) $.
    dihoml4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihoml4.s $e |- S = ( LSubSp ` U ) $.
    dihoml4.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dihoml4.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihoml4.x $e |- ( ph -> X e. S ) $.
    dihoml4.y $e |- ( ph -> Y e. S ) $.
    dihoml4.c $e |- ( ph -> ( ._|_ ` ( ._|_ ` Y ) ) = Y ) $.
    dihoml4.l $e |- ( ph -> X C_ Y ) $.
    $( Orthomodular law for constructed vector space H. Lemma 3.3(1) in
       [Holland95] p. 215.  ( ~ poml4N analog.)  (Contributed by NM,
       15-Jan-2015.) $)
    dihoml4 $p |- ( ph ->
     ( ( ._|_ ` ( ( ._|_ ` X ) i^i Y ) ) i^i Y ) = ( ._|_ ` ( ._|_ ` X ) ) ) $=
      ( cfv wcel cin chlt wa cdih crn wceq cbs wss eqid lssss syl dochcl dochoc
      syl2anc ineq1d fveq2d dochssv dochoccl mpbird syl3anc sseqtrd dihoml4c
      dochss eqtr3d ) AHFSZFSZFSZIUAZFSZIUAVEIUAZFSZIUAVFAVIVKIAVHVJFAVGVEIAEUB
      TGDTUCZVEGEUDSSZUEZTZVGVEUFNAVLHCUGSZUHZVONAHBTVQOBHVPCVPUIZLUJUKZCDVMEFV
      PGHJVMUIZKVRMULUNDVMEFGVEJVTMUMUNUOUPUOADVMEFGVFIJVTMNAVLVEVPUHZVFVNTNAVL
      VQWANVSCDEFVPGHJKVRMUQUNZCDVMEFVPGVEJVTKVRMULUNAIVNTIFSZFSZIUFQACDVMEFVPG
      IJVTKVRMNAIBTIVPUHZPBIVPCVRLUJUKZURUSAVFWDIAVLWAWCVEUHZVFWDUHNWBAVLWEHIUH
      WGNWFRCDEFVPGHIJKVRMVCUTCDEFVPGWCVEJKVRMVCUTQVAVBVD $.
  $}

  ${
    $d z H $.  $d z K $.  $d z U $.  $d z V $.  $d z W $.  $d z X $.
    dochsp.h $e |- H = ( LHyp ` K ) $.
    dochsp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsp.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsp.v $e |- V = ( Base ` U ) $.
    dochsp.n $e |- N = ( LSpan ` U ) $.
    dochsp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsp.x $e |- ( ph -> X C_ V ) $.
    $( The span of a set of vectors is included in their double
       orthocomplement.  (Contributed by NM, 26-Jul-2014.) $)
    dochspss $p |- ( ph -> ( N ` X ) C_ ( ._|_ ` ( ._|_ ` X ) ) ) $=
      ( vz wss cfv wcel cv clss crab cint cdih crn chlt wa eqid dihsslss rabss2
      intss 4syl clmod wceq dvhlmod lspval syl2anc doch2val2 3sstr4d ) AIQUARZQ
      BUBSZUCZUDZVAQHDUESSZUFZUCZUDZIESZIFSFSADUGTHCTUHVFVBRVGVCRVDVHROVBBCVEDH
      JKVEUIZVBUIZUJVAQVFVBUKVGVCULUMABUNTIGRVIVDUOABCDHJKOUPPQVBIEGBMVKNUQURAQ
      BCVEDFGHIJVJKMLOPUSUT $.

    $( The span of an orthocomplement equals the orthocomplement of the span.
       (Contributed by NM, 7-Aug-2014.) $)
    dochocsp $p |- ( ph -> ( ._|_ ` ( N ` X ) ) = ( ._|_ ` X ) ) $=
      ( cfv wcel wss syl2anc chlt wa dvhlmod lspssv lspssid dochss syl3anc cdih
      clmod crn wceq eqid dochcl dochoc dochssv dochspss eqsstr3d eqssd ) AIEQZ
      FQZIFQZADUARHCRUBZUSGSZIUSSZUTVASOABUIRZIGSZVCABCDHJKOUCZPIEGBMNUDTAVEVFV
      DVGPIEGBMNUETBCDFGHIUSJKMLUFUGAVAVAFQZFQZUTAVBVAHDUHQQZUJRZVIVAUKOAVBVFVK
      OPBCVJDFGHIJVJULZKMLUMTCVJDFHVAJVLLUNTAVBVHGSZUSVHSVIUTSOAVBVAGSZVMOAVBVF
      VNOPBCDFGHIJKMLUOTBCDFGHVAJKMLUOTABCDEFGHIJKLMNOPUPBCDFGHUSVHJKMLUFUGUQUR
      $.

    $( The span of an orthocomplement equals the orthocomplement of the span.
       (Contributed by NM, 7-Aug-2014.)  (New usage is discouraged.) $)
    dochspocN $p |- ( ph -> ( N ` ( ._|_ ` X ) ) = ( ._|_ ` ( N ` X ) ) ) $=
      ( cfv clmod wcel syl2anc clss wceq dvhlmod chlt wa wss eqid dochlss lspid
      dochocsp eqtr4d ) AIFQZEQZULIEQFQABRSULBUAQZSZUMULUBABCDHJKOUCADUDSHCSUEI
      GUFUOOPUNBCDFGHIJKMUNUGZLUHTUNULEBUPNUITABCDEFGHIJKLMNOPUJUK $.
  $}

  ${
    dochocsn.h $e |- H = ( LHyp ` K ) $.
    dochocsn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochocsn.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochocsn.v $e |- V = ( Base ` U ) $.
    dochocsn.n $e |- N = ( LSpan ` U ) $.
    dochocsn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochocsn.x $e |- ( ph -> X e. V ) $.
    $( The double orthocomplement of a singleton is its span.  (Contributed by
       NM, 13-Jan-2015.) $)
    dochocsn $p |- ( ph -> ( ._|_ ` ( ._|_ ` { X } ) ) = ( N ` { X } ) ) $=
      ( csn cfv wcel syl2anc snssd dochocsp fveq2d chlt cdih wceq eqid dihlsprn
      wa crn dochoc eqtr3d ) AIQZERZFRZFRZUMFRZFRUNAUOUQFABCDEFGHUMJKLMNOAIGPUA
      UBUCADUDSHCSUIZUNHDUERRZUJSZUPUNUFOAURIGSUTOPBCUSDEGHIJKMNUSUGZUHTCUSDFHU
      NJVALUKTUL $.
  $}

  ${
    dochsncom.h $e |- H = ( LHyp ` K ) $.
    dochsncom.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsncom.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsncom.v $e |- V = ( Base ` U ) $.
    dochsncom.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsncom.x $e |- ( ph -> X e. V ) $.
    dochsncom.y $e |- ( ph -> Y e. V ) $.
    $( Swap vectors in an orthocomplement of a singleton.  (Contributed by NM,
       17-Jun-2015.) $)
    dochsncom $p |- ( ph ->
      ( X e. ( ._|_ ` { Y } ) <-> Y e. ( ._|_ ` { X } ) ) ) $=
      ( cfv wss wcel syl2anc csn clspn cdih eqid wa crn dihlsprn dochord3 snssd
      chlt dochocsp sseq2d 3bitr3d clss dvhlmod dochlss lspsnel5 3bitr4d ) AHUA
      ZBUBQZQZIUAZEQZRZVBUTQZUSEQZRZHVCSIVFSAVAVEEQZRVEVAEQZRVDVGACGDUCQQZDEGVA
      VEJVJUDZKNADUJSGCSUEZHFSVAVJUFZSNOBCVJDUTFGHJLMUTUDZVKUGTAVLIFSVEVMSNPBCV
      JDUTFGIJLMVNVKUGTUHAVHVCVAABCDUTEFGVBJLKMVNNAIFPUIZUKULAVIVFVEABCDUTEFGUS
      JLKMVNNAHFOUIZUKULUMABUNQZVCUTFBHMVQUDZVNABCDGJLNUOZAVLVBFRVCVQSNVOVQBCDE
      FGVBJLMVRKUPTOUQAVQVFUTFBIMVRVNVSAVLUSFRVFVQSNVPVQBCDEFGUSJLMVRKUPTPUQUR
      $.
  $}

  ${
    dochsat.h $e |- H = ( LHyp ` K ) $.
    dochsat.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsat.s $e |- S = ( LSubSp ` U ) $.
    dochsat.a $e |- A = ( LSAtoms ` U ) $.
    dochsat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsat.q $e |- ( ph -> Q e. S ) $.
    $( The double orthocomplement of an atom is an atom.  (Contributed by NM,
       29-Oct-2014.) $)
    dochsat $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` Q ) ) e. A <-> Q e. A ) ) $=
      ( cfv wcel wceq adantr wa c0g csn clsm co wpss wss wne clmod dvhlmod eqid
      lss0ss syl2anc simpr lsatn0 fveq2d dochoc0 eqtrd ex necon3d necomd df-pss
      mpd sylanbrc chlt cbs lssss syl dochocss csubg lsatlssel lsssubg sseqtr4d
      lsm02 dvhlvec lsssn0 lsmsatcv mpd3an23 eqtr2d eqeltrrd cdih crn dih1dimat
      clvec sylan dochoc eqeltrd impbida ) ACHQZHQZBRZCBRZAWKUAZWJCBWMCEUBQZUCZ
      WJEUDQZUEZWJWMWOCUFZCWQUGCWQSWMWOCUGZWOCUHWRWMEUIRZCDRZWSAWTWKAEFGIJLOUJT
      ZAXAWKPTZDECWNWNUKZMULUMWMCWOWMWJWOUHCWOUHWMBWJEWNXDNXBAWKUNZUOWMCWOWJWOW
      MCWOSZWJWOSWMXFUAZWJWOHQZHQZWOXGWIXHHXGCWOHWMXFUNUPUPWMXIWOSZXFAXJWKAEFGH
      IWNJLKXDOUQTTURUSUTVCVAWOCVBVDWMCWJWQWMGVERIFRUAZCEVFQZUGZCWJUGAXKWKOTAXM
      WKAXAXMPDCXLEXLUKZMVGVHTEFGHXLICJLXNKVIUMWMWJEVJQRZWQWJSWMWTWJDRXOXBWMBDW
      JEMNXBXEVKDWJEMVLUMWPEWJWNXDWPUKZVNVHZVMWMBWPWJDWOCEMXPNAEWDRWKAEFGIJLOVO
      TWMWTWODRXBDEWNXDMVPVHXCXEVQVRXQVSXEVTAWLUAZWJCBXRXKCIGWAQQZWBRZWJCSAXKWL
      OTAXKWLXTOBCEFXSGIJLXSUKZNWCWEFXSGHICJYAKWFUMAWLUNWGWH $.
  $}

  ${
    $d v ._|_ $.  $d v U $.  $d v V $.  $d v X $.  $d v ph $.
    dochshpncl.h $e |- H = ( LHyp ` K ) $.
    dochshpncl.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochshpncl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochshpncl.v $e |- V = ( Base ` U ) $.
    dochshpncl.y $e |- Y = ( LSHyp ` U ) $.
    dochshpncl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochshpncl.x $e |- ( ph -> X e. Y ) $.
    $( If a hyperplane is not closed, its closure equals the vector space.
       (Contributed by NM, 29-Oct-2014.) $)
    dochshpncl $p |- ( ph ->
      ( ( ._|_ ` ( ._|_ ` X ) ) =/= X <-> ( ._|_ ` ( ._|_ ` X ) ) = V ) ) $=
      ( cfv wcel adantr wss vv wne wceq wa cv csn clspn clsm wrex clss w3a eqid
      co dvhlmod islshpsm mpbid simp3d wpss id adantlr 3adant3 chlt lshplss syl
      dochocss syl2anc 3ad2ant1 simp1r necomd sylanbrc dochssv sseqtr4d dvhlvec
      lssss df-pss simp3 dochlss simpr lsmcv syl3anc rexlimdv3a eqnetrd impbida
      eqtrd mpd lshpne ) AHEQZEQZHUBZWHFUCZAWIUDZHUAUEZUFBUGQZQBUHQZUMZFUCZUAFU
      IZWJAWQWIAHBUJQZRZHFUBZWQAHIRWSWTWQUKPAUAWNWRHIWMFBMWMULZWRULZWNULZNABCDG
      JLOUNZUOUPUQSWKWPWJUAFWKWLFRZWPUKZWHWOFXFAXEUDZHWHURZWHWOTWHWOUCWKXEXGWPA
      XEXGWIXGUSUTVAXFHWHTZHWHUBXHWKXEXIWPAXIWIADVBRGCRUDZHFTZXIOAWSXKAWRHIBXBN
      XDPVCZWRHFBMXBVNVDZBCDEFGHJLMKVEVFSVGXFWHHAWIXEWPVHVIHWHVOVJXFWHFWOWKXEWH
      FTZWPAXNWIAXJWGFTZXNOAXJXKXOOXMBCDEFGHJLMKVKVFZBCDEFGWGJLMKVKVFSVGWKXEWPV
      PZVLXGWNWRHWHWMFBWLMXBXAXCXGBCDGJLAXJXEOSVMAWSXEXLSAWHWRRZXEAXJXOXROXPWRB
      CDEFGWGJLMXBKVQVFSAXEVRVSVTXQWDWAWEAWJUDZWHFHAWJVRXSHFAWTWJAHIFBMNXDPWFSV
      IWBWC $.
  $}

  ${
    dochlkr.h $e |- H = ( LHyp ` K ) $.
    dochlkr.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochlkr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochlkr.f $e |- F = ( LFnl ` U ) $.
    dochlkr.y $e |- Y = ( LSHyp ` U ) $.
    dochlkr.l $e |- L = ( LKer ` U ) $.
    dochlkr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochlkr.g $e |- ( ph -> G e. F ) $.
    $( Equivalent conditions for the closure of a kernel to be a hyperplane.
       (Contributed by NM, 29-Oct-2014.) $)
    dochlkr $p |- ( ph
     -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) e. Y
       <-> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G )
                /\ ( L ` G ) e. Y ) ) ) $=
      ( cfv wcel wceq wa wss chlt cbs eqid dvhlmod lkrssv dochocss adantr clvec
      syl2anc dvhlvec wne clmod simpr lshpne ex wn lkrshpor fveq2 fveq2d adantl
      ord dochoc1 eqtrd necon1ad imp lshpcmp mpbid eqcomd eleq1 biimpar impbid1
      syld jca ) ADGSZHSZHSZJTZVSVQUAZVQJTZUBZAVTWCAVTUBZWAWBWDVQVSWDVQVSUCZVQV
      SUAAWEVTAFUDTIETUBZVQBUESZUCWEQACDGWGBWGUFZNPABEFIKMQUGZRUHBEFHWGIVQKMWHL
      UIULUJWDVQVSJBOABUKTVTABEFIKMQUMZUJAVTWBAVTVSWGUNZWBAVTWKWDVSJWGBWHOABUOT
      VTWIUJAVTUPZUQURAWBVSWGAWBUSVQWGUAZVSWGUAZAWBWMACDJGWGBWHONPWJRUTVDAWMWNA
      WMUBZVSWGHSZHSZWGWMVSWQUAAWMVRWPHVQWGHVAVBVCWOBEFHWGIKMLWHAWFWMQUJVEVFURV
      OVGVOVHZWLVIVJVKWRVPURWAVTWBVSVQJVLVMVN $.
  $}

  ${
    dochkrshp.h $e |- H = ( LHyp ` K ) $.
    dochkrshp.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkrshp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkrshp.v $e |- V = ( Base ` U ) $.
    dochkrshp.y $e |- Y = ( LSHyp ` U ) $.
    dochkrshp.f $e |- F = ( LFnl ` U ) $.
    dochkrshp.l $e |- L = ( LKer ` U ) $.
    dochkrshp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkrshp.g $e |- ( ph -> G e. F ) $.
    $( The closure of a kernel is a hyperplane iff it doesn't contain all
       vectors.  (Contributed by NM, 1-Nov-2014.) $)
    dochkrshp $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V
              <-> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) e. Y ) ) $=
      ( cfv wne wcel wceq wa simpr adantr fveq2 fveq2d dochoc1 sylan9eqr eqtr4d
      chlt ex necon3d wn dvhlvec lkrshpor orcomd ord syl5bi syld imp dochshpncl
      df-ne mpbid necon1d necon3ad dochlkr sylibrd clmod dvhlmod lshpne impbid
      jcad ) ADGUAZHUAZHUAZIUBZVRKUCZAVSVRVPUDZVPKUCZUEVTAVSWAWBAVRVPVRIAVRVPUB
      ZVRIUDZAWCUEZWCWDAWCUFWEBEFHIJVPKLMNOPAFUMUCJEUCUEWCSUGAWCWBAWCVPIUBZWBAV
      PIVRVPAVPIUDZWAAWGUEVRIVPWGAVRIHUAZHUAIWGVQWHHVPIHUHUIABEFHIJLNMOSUJUKZAW
      GUFULUNUOWFWGUPZAWBVPIVEAWGWBAWBWGACDKGIBOPQRABEFJLNSUQTURUSUTZVAVBVCVDVF
      UNVGAVSWJWBAWGVRIAWGWDWIUNVHWKVBVOABCDEFGHJKLMNQPRSTVIVJAVTVSAVTUEVRKIBOP
      ABVKUCVTABEFJLNSVLUGAVTUFVMUNVN $.
  $}

  ${
    dochkrshp2.h $e |- H = ( LHyp ` K ) $.
    dochkrshp2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkrshp2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkrshp2.v $e |- V = ( Base ` U ) $.
    dochkrshp2.y $e |- Y = ( LSHyp ` U ) $.
    dochkrshp2.f $e |- F = ( LFnl ` U ) $.
    dochkrshp2.l $e |- L = ( LKer ` U ) $.
    dochkrshp2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkrshp2.g $e |- ( ph -> G e. F ) $.
    $( Properties of the closure of the kernel of a functional.  (Contributed
       by NM, 1-Jan-2015.) $)
    dochkrshp2 $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V <->
      ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) /\ ( L ` G ) e. Y ) ) ) $=
      ( cfv wne wcel wceq wa dochkrshp dochlkr bitrd ) ADGUAZHUAHUAZIUBUJKUCUJU
      IUDUIKUCUEABCDEFGHIJKLMNOPQRSTUFABCDEFGHJKLMNQPRSTUGUH $.
  $}

  ${
    dochkrshp3.h $e |- H = ( LHyp ` K ) $.
    dochkrshp3.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkrshp3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkrshp3.v $e |- V = ( Base ` U ) $.
    dochkrshp3.f $e |- F = ( LFnl ` U ) $.
    dochkrshp3.l $e |- L = ( LKer ` U ) $.
    dochkrshp3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkrshp3.g $e |- ( ph -> G e. F ) $.
    $( Properties of the closure of the kernel of a functional.  (Contributed
       by NM, 1-Jan-2015.) $)
    dochkrshp3 $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V <->
      ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) /\ ( L ` G ) =/= V ) ) ) $=
      ( cfv wne wceq clsh wcel wa eqid dochkrshp2 dvhlvec lkrshp4 anbi2d bitr4d
      ) ADGSZHSHSZITULUKUAZUKBUBSZUCZUDUMUKITZUDABCDEFGHIJUNKLMNUNUEZOPQRUFAUPU
      OUMACDUNGIBNUQOPABEFJKMQUGRUHUIUJ $.

    $( Properties of the closure of the kernel of a functional.  (Contributed
       by NM, 1-Jan-2015.) $)
    dochkrshp4 $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) <->
      ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V \/ ( L ` G ) = V ) ) ) $=
      ( cfv wceq wne wo wa df-ne dochkrshp3 biimprd expdimp syl5bir orrd orcomd
      wn ex simpl syl6bi dochoc1 fveq2 fveq2d id eqeq12d syl5ibrcom jaod impbid
      ) ADGSZHSZHSZVCTZVEIUAZVCITZUBZAVFVIAVFUCZVHVGVJVHVGVHUKVCIUAZVJVGVCIUDAV
      FVKVGAVGVFVKUCZABCDEFGHIJKLMNOPQRUEZUFUGUHUIUJULAVGVFVHAVGVLVFVMVFVKUMUNA
      VFVHIHSZHSZITABEFHIJKMLNQUOVHVEVOVCIVHVDVNHVCIHUPUQVHURUSUTVAVB $.
  $}

  ${
    dochdmj1.h $e |- H = ( LHyp ` K ) $.
    dochdmj1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochdmj1.v $e |- V = ( Base ` U ) $.
    dochdmj1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( De Morgan-like law for subspace orthocomplement.  (Contributed by NM,
       5-Aug-2014.) $)
    dochdmj1 $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V /\ Y C_ V )
        -> ( ._|_ ` ( X u. Y ) ) = ( ( ._|_ ` X ) i^i ( ._|_ ` Y ) ) ) $=
      ( wcel wss cfv a1i dochss syl3anc 3adant3 3adant2 chlt wa w3a simp1 simp2
      cun cin simp3 unssd ssun1 ssun2 ssind cdih crn wceq eqid dochcl dihmeetcl
      syl12anc dochoc syl2anc dochssv ssinss1 dochocss unss12 inss1 inss2 sstrd
      syl eqsstr3d eqssd ) CUAMFBMUBZGENZHENZUCZGHUFZDOZGDOZHDOZUGZVOVQVRVSVOVL
      VPENZGVPNZVQVRNVLVMVNUDZVOGHEVLVMVNUEVLVMVNUHUIZWBVOGHUJPABCDEFGVPIJKLQRV
      OVLWAHVPNZVQVSNWCWDWEVOHGUKPABCDEFHVPIJKLQRULVOVTVTDOZDOZVQVOVLVTFCUMOOZU
      NZMZWGVTUOWCVOVLVRWIMZVSWIMZWJWCVLVMWKVNABWHCDEFGIWHUPZJKLUQSVLVNWLVMABWH
      CDEFHIWMJKLUQTBWHCFVRVSIWMURUSBWHCDFVTIWMLUTVAVOVLWFENZVPWFNWGVQNWCVOVLVT
      ENZWNWCVOVRENZWOVLVMWPVNABCDEFGIJKLVBSZVRVSEVCVIABCDEFVTIJKLVBVAVOVPVRDOZ
      VSDOZUFZWFVOGWRNZHWSNZVPWTNVLVMXAVNABCDEFGIJKLVDSVLVNXBVMABCDEFHIJKLVDTGW
      RHWSVEVAVOWRWSWFVOVLWPVTVRNZWRWFNWCWQXCVOVRVSVFPABCDEFVTVRIJKLQRVOVLVSENZ
      VTVSNZWSWFNWCVLVNXDVMABCDEFHIJKLVBTXEVOVRVSVGPABCDEFVTVSIJKLQRUIVHABCDEFV
      PWFIJKLQRVJVK $.
  $}

  ${
    dochnoncon.h $e |- H = ( LHyp ` K ) $.
    dochnoncon.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochnoncon.s $e |- S = ( LSubSp ` U ) $.
    dochnoncon.z $e |- .0. = ( 0g ` U ) $.
    dochnoncon.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    $( Law of noncontradiction.  The intersection of a subspace and its
       orthocomplement is the zero subspace.  (Contributed by NM,
       16-Apr-2014.) $)
    dochnoncon $p |- ( ( ( K e. HL /\ W e. H ) /\ X e. S )
        -> ( X i^i ( ._|_ ` X ) ) = { .0. } ) $=
      ( wcel cfv wss eqid wceq syldan syl2anc chlt wa cin lssss dochocss sylan2
      csn cbs ssrin syl cdih ccnv coc cp0 cmee co simpl wf1o clss dihf11 adantr
      crn wf1 f1f1orn dochcl dihrnlss f1ocnvdm cops hlop opoccl dihmeet syl3anc
      ad2antrr opnoncon fveq2d eqtr3d dihcnvid2 dochvalr dochoc ineq12d 3eqtr3d
      dih0 sseqtrd clmod dvhlmod simpr lssincl lss0ss eqssd ) DUANZFCNZUBZGANZU
      BZGGEOZUCZHUGZWNWPWOEOZWOUCZWQWNGWRPZWPWSPWMWLGBUHOZPZWTAGXABXAQZKUDZBCDE
      XAFGIJXCMUEUFGWRWOUIUJWNWRFDUKOOZULOZXEOZXFDUMOZOZXEOZUCZDUNOZXEOZWSWQWNX
      FXIDUOOZUPZXEOZXKXMWNWLXFDUHOZNZXIXQNZXPXKRWLWMUQZWNXQXEVBZXEURZWRYANZXRW
      NXQBUSOZXEVCZYBWLYEWMXQYDBCXEDFXQQZIXEQZJYDQZUTVAXQYDXEVDUJWLWMWOXAPZYCWN
      WOYDNZYIWLWMWOYANZYJWMWLXBYKXDBCXEDEXAFGIYGJXCMVEUFZYDBCXEDFWOIJYGYHVFSYD
      WOXABXCYHUDUJBCXEDEXAFWOIYGJXCMVESZXQYAWRXEVGTZWNDVHNZXRXSWJYOWKWMDVIVMZY
      NXQDXHXFYFXHQZVJTXQCXEDXNFXFXIYFXNQZIYGVKVLWNXOXLXEWNYOXRXOXLRYPYNXQDXNXH
      XFXLYFYQYRXLQZVNTVOVPWNXGWRXJWOWLWMYCXGWRRYMCXEDFWRIYGVQSWNWREOZXJWOWLWMY
      CYTXJRYMCXEDEXHFWRYQIYGMVRSWLWMYKYTWORYLCXEDEFWOIYGMVSSVPVTWLXMWQRWMBCXED
      HFXLYSIYGJLWBVAWAWCWNBWDNZWPANZWQWPPWNBCDFIJXTWEZWNUUAWMWOANZUUBUUCWLWMWF
      WLWMYKUUDYLABCXEDFWOIJYGKVFSAGWOBKWGVLABWPHLKWHTWI $.

    dochnel2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochnel2.t $e |- ( ph -> T e. S ) $.
    dochnel2.x $e |- ( ph -> X e. ( T \ { .0. } ) ) $.
    $( A nonzero member of a subspace doesn't belong to the orthocomplement of
       the subspace.  (Contributed by NM, 28-Feb-2015.) $)
    dochnel2 $p |- ( ph -> -. X e. ( ._|_ ` T ) ) $=
      ( wcel wa cfv csn eldifbd eldifad cin elin chlt dochnoncon syl2anc eleq2d
      wceq syl5bbr biimpd mpand mtod ) AICGUAZSZIJUBZSZAICURRUCAICSZUQUSAICURRU
      DAUTUQTZUSVAICUPUEZSAUSICUPUFAVBURIAFUGSHESTCBSVBURUKPQBDEFGHCJKLMNOUHUIU
      JULUMUNUO $.
  $}

  ${
    dochnel.h $e |- H = ( LHyp ` K ) $.
    dochnel.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochnel.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochnel.v $e |- V = ( Base ` U ) $.
    dochnel.z $e |- .0. = ( 0g ` U ) $.
    dochnel.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochnel.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( A nonzero vector doesn't belong to the orthocomplement of its
       singleton.  (Contributed by NM, 27-Oct-2014.) $)
    dochnel $p |- ( ph -> -. X e. ( ._|_ ` { X } ) ) $=
      ( csn cfv eqid wcel clspn clss clmod dvhlmod eldifad lspsncl syl2anc cdif
      wne lspsnid eldifsni eldifsn sylanbrc dochnel2 snssd dochocsp neleqtrd
      syl ) AHQZBUARZRZERUSERHABUBRZVABCDEGHIJLVBSZNKOABUCTZHFTZVAVBTABCDGJLOUD
      ZAHFIQZPUEZVBUTFBHMVCUTSZUFUGAHVATZHIUIZHVAVGUHTAVDVEVJVFVHUTFBHMVIUJUGAH
      FVGUHTVKPHFIUKURHVAIULUMUNABCDUTEFGUSJLKMVIOAHFVHUOUPUQ $.
  $}

  $c joinH $.

  $( Extend class notation with subspace join for ` DVecH ` vector space. $)
  cdjh $a class joinH $.

  ${
    $d k w x y z $.
    $( Define (closed) subspace join for ` DVecH ` vector space.  (Contributed
       by NM, 19-Jul-2014.) $)
    df-djh $a |- joinH = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
        ( x e. ~P ( Base ` ( ( DVecH ` k ) ` w ) ) ,
          y e. ~P ( Base ` ( ( DVecH ` k ) ` w ) ) |-> ( ( ( ocH ` k ) ` w ) `
     ( ( ( ( ocH ` k ) ` w ) ` x ) i^i ( ( ( ocH ` k ) ` w ) ` y ) ) ) ) ) ) $.
  $}

  ${
    $d k w H $.  $d k w x y K $.
    djhval.h $e |- H = ( LHyp ` K ) $.
    $( Subspace join for ` DVecH ` vector space.  (Contributed by NM,
       19-Jul-2014.) $)
    djhffval $p |- ( K e. X -> ( joinH ` K ) = ( w e. H |->
        ( x e. ~P ( Base ` ( ( DVecH ` K ) ` w ) ) ,
          y e. ~P ( Base ` ( ( DVecH ` K ) ` w ) ) |-> ( ( ( ocH ` K ) ` w ) `
     ( ( ( ( ocH ` K ) ` w ) ` x ) i^i ( ( ( ocH ` K ) ` w ) ` y ) ) ) ) ) ) $=
      ( vk wcel cvv cdjh cfv cv cdvh cbs cpw coch clh fveq2 fveq1d cmpt syl6eqr
      cmpt2 wceq elex fveq2d pweqd ineq12d fveq12d mpt2eq123dv mpteq12dv df-djh
      cin fvex eqeltri mptex fvmpt syl ) EFIEJIEKLCDABCMZENLZLZOLZPZVCAMZUSEQLZ
      LZLZBMZVFLZUMZVFLZUCZUAZUDEFUEHECHMZRLZABUSVNNLZLZOLZPZVSVDUSVNQLZLZLZVHW
      ALZUMZWALZUCZUAVMJKVNEUDZCVOWFDVLWGVOERLZDVNERSGUBWGABVSVSWEVCVCVKWGVRVBW
      GVQVAOWGUSVPUTVNENSTUFUGZWIWGWDVJWAVFWGUSVTVEVNEQSTZWGWBVGWCVIWGVDWAVFWJT
      WGVHWAVFWJTUHUIUJUKABCHULCDVLDWHJGERUNUOUPUQUR $.

    $d w ._|_ $.  $d w x y V $.  $d w x y W $.
    djhval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhval.v $e |- V = ( Base ` U ) $.
    djhval.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    djhval.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    $( Subspace join for ` DVecH ` vector space.  (Contributed by NM,
       19-Jul-2014.) $)
    djhfval $p |- ( ( K e. X /\ W e. H ) -> .\/ = ( x e. ~P V ,
        y e. ~P V |-> ( ._|_ ` ( ( ._|_ ` x ) i^i ( ._|_ ` y ) ) ) ) ) $=
      ( vw cv cfv cbs fveq1d wcel cdvh cpw coch cmpt2 cmpt cdjh djhffval syl5eq
      cin wceq fveq2 fveq2d fveq2i eqtri syl6eqr pweqd ineq12d mpt2eq123dv eqid
      fveq12d cvv fvex eqeltri pwex mpt2ex fvmpt sylan9eq ) FJUAZIDUAEIPDABPQZF
      UBRZRZSRZUCZVNAQZVJFUDRZRZRZBQZVQRZUJZVQRZUEZUFZRZABHUCZWFVOGRZVSGRZUJZGR
      ZUEZVIEIFUGRZRWEOVIIWLWDABPDFJKUHTUIPIWCWKDWDVJIUKZABVNVNWBWFWFWJWMVMHWMV
      MIVKRZSRZHWMVLWNSVJIVKULUMHCSRZWOMCWNSLUNUOUPUQZWQWMWAWIVQGWMVQIVPRGVJIVP
      ULNUPZWMVRWGVTWHWMVOVQGWRTWMVSVQGWRTURVAUSWDUTABWFWFWJHHWPVBMCSVCVDVEZWSV
      FVGVH $.

    $d x y ._|_ $.  $d x y X $.  $d x y Y $.
    $( Subspace join for ` DVecH ` vector space.  (Contributed by NM,
       19-Jul-2014.) $)
    djhval $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X C_ V /\ Y C_ V ) )
          -> ( X .\/ Y ) = ( ._|_ ` ( ( ._|_ ` X ) i^i ( ._|_ ` Y ) ) ) ) $=
      ( vx vy wcel wa cfv wceq wss co cpw cv cin cmpt2 djhfval adantr oveqd cvv
      chlt cbs fvex eqeltri elpw2 biimpri ad2antrl ad2antll fveq2 ineq1d fveq2d
      a1i ineq2d eqid ovmpt2g syl3anc eqtrd ) DUKQGBQRZHFUAZIFUAZRZRZHICUBHIOPF
      UCZVMOUDZESZPUDZESZUEZESZUFZUBZHESZIESZUEZESZVLCVTHIVHCVTTVKOPABCDEFGUKJK
      LMNUGUHUIVLHVMQZIVMQZWEUJQZWAWETVIWFVHVJWFVIHFFAULSUJLAULUMUNZUOUPUQVJWGV
      HVIWGVJIFWIUOUPURWHVLWDEUMVBOPHIVMVMVSWEVTWBVQUEZESUJVNHTZVRWJEWKVOWBVQVN
      HEUSUTVAVPITZWJWDEWLVQWCWBVPIEUSVCVAVTVDVEVFVG $.

    $( Value of subspace join for ` DVecH ` vector space.  (Contributed by NM,
       6-Aug-2014.) $)
    djhval2 $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V /\ Y C_ V )
          -> ( X .\/ Y ) = ( ._|_ ` ( ._|_ ` ( X u. Y ) ) ) ) $=
      ( chlt wcel wa wss w3a cfv co cin cun djhval 3impb dochdmj1 fveq2d eqtr4d
      wceq ) DOPGBPQZHFRZIFRZSZHICUAZHETIETUBZETZHIUCETZETUJUKULUNUPUIABCDEFGHI
      JKLMNUDUEUMUQUOEABDEFGHIJKLMUFUGUH $.
  $}

  ${
    djhcl.h $e |- H = ( LHyp ` K ) $.
    djhcl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djhcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhcl.v $e |- V = ( Base ` U ) $.
    djhcl.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    $( Closure of subspace join for ` DVecH ` vector space.  (Contributed by
       NM, 19-Jul-2014.) $)
    djhcl $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X C_ V /\ Y C_ V ) )
          -> ( X .\/ Y ) e. ran I ) $=
      ( wcel wa wss cfv dochcl syldan chlt co coch cin crn djhval inss1 adantrr
      eqid dihrnss syl5ss eqeltrd ) EUAOGBOPZHFQZIFQZPZPZHIDUBHGEUCRRZRZIURRZUD
      ZURRZCUEZABDEURFGHIJLMURUIZNUFUMUPVAFQVBVCOUQVAUSFUSUTUGUMUPUSVCOZUSFQUMU
      NVEUOABCEURFGHJKLMVDSUHABCEFGUSJLKMUJTUKABCEURFGVAJKLMVDSTUL $.
  $}

  ${
    djhlj.b $e |- B = ( Base ` K ) $.
    djhlj.k $e |- .\/ = ( join ` K ) $.
    djhlj.h $e |- H = ( LHyp ` K ) $.
    djhlj.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djhlj.j $e |- J = ( ( joinH ` K ) ` W ) $.
    $( Transfer lattice join to ` DVecH ` vector space closed subspace join.
       (Contributed by NM, 19-Jul-2014.) $)
    djhlj $p |- ( ( ( K e. HL /\ W e. H ) /\ ( X e. B /\ Y e. B ) )
          -> ( I ` ( X .\/ Y ) ) = ( ( I ` X ) J ( I ` Y ) ) ) $=
      ( wcel wa cfv wceq eqid syldan chlt coch cin coc cmee cdvh cbs wss simprl
      co simpl simprr djhval syl12anc cops hlop ad2antrr opoccl syl2anc dihmeet
      dihss syl3anc dochvalr2 ineq12d eqtr4d fveq2d clat latmcl eqtr3d col hlol
      hllat oldmm4 3eqtrrd ) FUAOZGBOZPZHAOZIAOZPZPZHCQZICQZDUJZWBGFUBQQZQZWCWE
      QZUCZWEQZHFUDQZQZIWJQZFUEQZUJZWJQZCQZHIEUJZCQWAVQWBGFUFQQZUGQZUHZWCWSUHZW
      DWIRVQVTUKZVQVTVRWTVQVRVSUIZAWRBCFWSGHJLMWRSZWSSZVATVQVTVSXAVQVRVSULZAWRB
      CFWSGIJLMXDXEVATWRBDFWEWSGWBWCLXDXEWESZNUMUNWAWNCQZWEQZWIWPWAXHWHWEWAXHWK
      CQZWLCQZUCZWHWAVQWKAOZWLAOZXHXLRXBWAFUOOZVRXMVOXOVPVTFUPUQZXCAFWJHJWJSZUR
      USZWAXOVSXNXPXFAFWJIJXQURUSZABCFWMGWKWLJWMSZLMUTVBWAWFXJWGXKVQVTVRWFXJRXC
      ABCFWEWJGHJXQLMXGVCTVQVTVSWGXKRXFABCFWEWJGIJXQLMXGVCTVDVEVFVQVTWNAOZXIWPR
      WAFVGOZXMXNYAVOYBVPVTFVLUQXRXSAFWMWKWLJXTVHVBABCFWEWJGWNJXQLMXGVCTVIWAWOW
      QCWAFVJOZVRVSWOWQRVOYCVPVTFVKUQXCXFAEFWMWJHIJKXTXQVMVBVFVN $.

    djhljj.w $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhljj.x $e |- ( ph -> X e. B ) $.
    djhljj.y $e |- ( ph -> Y e. B ) $.
    $( Lattice join in terms of ` DVecH ` vector space closed subspace join.
       (Contributed by NM, 17-Aug-2014.)  (New usage is discouraged.) $)
    djhljjN $p |- ( ph
          -> ( X .\/ Y ) = ( `' I ` ( ( I ` X ) J ( I ` Y ) ) ) ) $=
      ( cfv wcel co ccnv wceq chlt wa djhlj syl12anc crn cdvh cbs dihcl syl2anc
      wss eqid dihrnss djhcl dihcnvid2 eqtr4d wb clat simpld syl latjcl syl3anc
      hllat dihcnvcl dih11 mpbid ) AIJFUAZDSZIDSZJDSZEUAZDUBSZDSZUCZVIVNUCZAVJV
      MVOAGUDTZHCTZUEZIBTZJBTZVJVMUCPQRBCDEFGHIJKLMNOUFUGAVTVMDUHZTZVOVMUCPAVTV
      KHGUISSZUJSZUMZVLWFUMZWDPAVTVKWCTZWGPAVTWAWIPQBCDGHIKMNUKULWECDGWFHVKMWEU
      NZNWFUNZUOULAVTVLWCTZWHPAVTWBWLPRBCDGHJKMNUKULWECDGWFHVLMWJNWKUOULWECDEGW
      FHVKVLMNWJWKOUPUGZCDGHVMMNUQULURAVTVIBTZVNBTZVPVQUSPAGUTTZWAWBWNAVRWPAVRV
      SPVAGVEVBQRBFGIJKLVCVDAVTWDWOPWMBCDGHVMKMNVFULBCDGHVIVNKMNVGVDVH $.
  $}

  ${
    djhj.k $e |- .\/ = ( join ` K ) $.
    djhj.h $e |- H = ( LHyp ` K ) $.
    djhj.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djhj.j $e |- J = ( ( joinH ` K ) ` W ) $.
    djhj.w $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhj.x $e |- ( ph -> X e. ran I ) $.
    djhj.y $e |- ( ph -> Y e. ran I ) $.
    $( ` DVecH ` vector space closed subspace join in terms of lattice join.
       (Contributed by NM, 9-Aug-2014.) $)
    djhjlj $p |- ( ph
          -> ( X J Y ) = ( I ` ( ( `' I ` X ) .\/ ( `' I ` Y ) ) ) ) $=
      ( cfv co wcel syl2anc ccnv chlt cbs wceq crn eqid dihcnvcl djhlj syl12anc
      wa dihcnvid2 oveq12d eqtr2d ) AHCUAZQZIUNQZERCQZUOCQZUPCQZDRZHIDRAFUBSGBS
      UJZUOFUCQZSZUPVBSZUQUTUDNAVAHCUEZSZVCNOVBBCFGHVBUFZKLUGTAVAIVESZVDNPVBBCF
      GIVGKLUGTVBBCDEFGUOUPVGJKLMUHUIAURHUSIDAVAVFURHUDNOBCFGHKLUKTAVAVHUSIUDNP
      BCFGIKLUKTULUM $.

    $( ` DVecH ` vector space closed subspace join in terms of lattice join.
       (Contributed by NM, 17-Aug-2014.) $)
    djhj $p |- ( ph
          -> ( `' I ` ( X J Y ) ) = ( ( `' I ` X ) .\/ ( `' I ` Y ) ) ) $=
      ( co cfv wcel syl2anc ccnv djhjlj fveq2d chlt wa cbs wceq clat simpld syl
      hllat crn eqid dihcnvcl latjcl syl3anc dihcnvid1 eqtrd ) AHIDQZCUAZRHUTRZ
      IUTRZEQZCRZUTRZVCAUSVDUTABCDEFGHIJKLMNOPUBUCAFUDSZGBSZUEZVCFUFRZSZVEVCUGN
      AFUHSZVAVISZVBVISZVJAVFVKAVFVGNUIFUKUJAVHHCULZSVLNOVIBCFGHVIUMZKLUNTAVHIV
      NSVMNPVIBCFGIVOKLUNTVIEFVAVBVOJUOUPVIBCFGVCVOKLUQTUR $.
  $}

  ${
    djhcom.h $e |- H = ( LHyp ` K ) $.
    djhcom.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhcom.v $e |- V = ( Base ` U ) $.
    djhcom.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhcom.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhcom.x $e |- ( ph -> X C_ V ) $.
    djhcom.y $e |- ( ph -> Y C_ V ) $.
    $( Subspace join commutes.  (Contributed by NM, 8-Aug-2014.) $)
    djhcom $p |- ( ph -> ( X .\/ Y ) = ( Y .\/ X ) ) $=
      ( cun cfv co fveq2i coch uncom chlt wcel wa wss wceq eqid djhval2 syl3anc
      3eqtr4a ) AHIQZGEUARRZRZUMRZIHQZUMRZUMRZHIDSZIHDSZUNUQUMULUPUMHIUBTTAEUCU
      DGCUDUEZHFUFZIFUFZUSUOUGNOPBCDEUMFGHIJKLUMUHZMUIUJAVAVCVBUTURUGNPOBCDEUMF
      GIHJKLVDMUIUJUK $.
  $}

  ${
    djhspss.h $e |- H = ( LHyp ` K ) $.
    djhspss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhspss.v $e |- V = ( Base ` U ) $.
    djhspss.n $e |- N = ( LSpan ` U ) $.
    djhspss.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhspss.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhspss.x $e |- ( ph -> X C_ V ) $.
    djhspss.y $e |- ( ph -> Y C_ V ) $.
    $( Subspace span of union is a subset of subspace join.  (Contributed by
       NM, 6-Aug-2014.) $)
    djhspss $p |- ( ph -> ( N ` ( X u. Y ) ) C_ ( X .\/ Y ) ) $=
      ( cfv wcel cun coch co eqid unssd dochspss chlt wss wceq djhval2 sseqtr4d
      wa syl3anc ) AIJUAZFSUNHEUBSSZSUOSZIJDUCZABCEFUOGHUNKLUOUDZMNPAIJGQRUEUFA
      EUGTHCTULIGUHJGUHUQUPUIPQRBCDEUOGHIJKLMUROUJUMUK $.
  $}

  ${
    djhsumss.h $e |- H = ( LHyp ` K ) $.
    djhsumss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhsumss.v $e |- V = ( Base ` U ) $.
    djhsumss.p $e |- .(+) = ( LSSum ` U ) $.
    djhsumss.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhsumss.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhsumss.x $e |- ( ph -> X C_ V ) $.
    djhsumss.y $e |- ( ph -> Y C_ V ) $.
    $( Subspace sum is a subset of subspace join.  (Contributed by NM,
       6-Aug-2014.) $)
    djhsumss $p |- ( ph -> ( X .(+) Y ) C_ ( X .\/ Y ) ) $=
      ( co cfv cun clspn eqid dvhlmod lsmssspx djhspss sstrd ) AIJBSIJUACUBTZTI
      JESABIJUHGCMUHUCZNQRACDFHKLPUDUEACDEFUHGHIJKLMUIOPQRUFUG $.
  $}

  ${
    dihsumssj.b $e |- B = ( Base ` K ) $.
    dihsumssj.h $e |- H = ( LHyp ` K ) $.
    dihsumssj.j $e |- .\/ = ( join ` K ) $.
    dihsumssj.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihsumssj.p $e |- .(+) = ( LSSum ` U ) $.
    dihsumssj.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihsumssj.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihsumssj.x $e |- ( ph -> X e. B ) $.
    dihsumssj.y $e |- ( ph -> Y e. B ) $.
    $( The subspace sum of two isomorphisms of lattice elements is less than
       the isomorphism of their lattice join.  (Contributed by NM,
       23-Sep-2014.) $)
    dihsumssj $p |- ( ph
     -> ( ( I ` X ) .(+) ( I ` Y ) ) C_ ( I ` ( X .\/ Y ) ) ) $=
      ( cfv co cdjh cbs eqid chlt wcel wa wss dihss syl2anc djhsumss wceq djhlj
      syl12anc sseqtr4d ) AJFUAZKFUAZCUBUQURIHUCUAUAZUBZJKGUBFUAZACDEUSHDUDUAZI
      UQURMOVBUEZPUSUEZRAHUFUGIEUGUHZJBUGZUQVBUIRSBDEFHVBIJLMQOVCUJUKAVEKBUGZUR
      VBUIRTBDEFHVBIKLMQOVCUJUKULAVEVFVGVAUTUMRSTBEFUSGHIJKLNMQVDUNUOUP $.
  $}

  ${
    djhunss.h $e |- H = ( LHyp ` K ) $.
    djhunss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhunss.v $e |- V = ( Base ` U ) $.
    djhunss.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhunss.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhunss.x $e |- ( ph -> X C_ V ) $.
    djhunss.y $e |- ( ph -> Y C_ V ) $.
    $( Subspace union is a subset of subspace join.  (Contributed by NM,
       6-Aug-2014.)  (New usage is discouraged.) $)
    djhunssN $p |- ( ph -> ( X u. Y ) C_ ( X .\/ Y ) ) $=
      ( cun clspn cfv wss clmod wcel dvhlmod unssd eqid lspssid syl2anc djhspss
      co sstrd ) AHIQZUKBRSZSZHIDUIABUAUBUKFTUKUMTABCEGJKNUCAHIFOPUDUKULFBLULUE
      ZUFUGABCDEULFGHIJKLUNMNOPUHUJ $.
  $}

  ${
    dochdmm1.h $e |- H = ( LHyp ` K ) $.
    dochdmm1.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochdmm1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochdmm1.v $e |- V = ( Base ` U ) $.
    dochdmm1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochdmm1.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    dochdmm1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochdmm1.x $e |- ( ph -> X e. ran I ) $.
    dochdmm1.y $e |- ( ph -> Y e. ran I ) $.
    $( De Morgan-like law for closed subspace orthocomplement.  (Contributed by
       NM, 13-Jan-2015.) $)
    dochdmm1 $p |- ( ph
           -> ( ._|_ ` ( X i^i Y ) ) = ( ( ._|_ ` X ) .\/ ( ._|_ ` Y ) ) ) $=
      ( cin cfv cun chlt wcel wss wceq dihrnss syl2anc dochssv dochdmj1 syl3anc
      co wa crn dochoc ineq12d eqtr2d fveq2d djhval2 eqtr4d ) AJKUAZGUBJGUBZKGU
      BZUCGUBZGUBZVCVDEUMZAVBVEGAVEVCGUBZVDGUBZUAZVBAFUDUEICUEUNZVCHUFZVDHUFZVE
      VJUGRAVKJHUFZVLRAVKJDUOZUEZVNRSBCDFHIJLNMOUHUIBCFGHIJLNOPUJUIZAVKKHUFZVMR
      AVKKVOUEZVRRTBCDFHIKLNMOUHUIBCFGHIKLNOPUJUIZBCFGHIVCVDLNOPUKULAVHJVIKAVKV
      PVHJUGRSCDFGIJLMPUPUIAVKVSVIKUGRTCDFGIKLMPUPUIUQURUSAVKVLVMVGVFUGRVQVTBCE
      FGHIVCVDLNOPQUTULVA $.
  $}

  ${
    djhexmid.h $e |- H = ( LHyp ` K ) $.
    djhexmid.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhexmid.v $e |- V = ( Base ` U ) $.
    djhexmid.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    djhexmid.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    $( Excluded middle property of ` DVecH ` vector space closed subspace
       join.  (Contributed by NM, 22-Jul-2014.) $)
    djhexmid $p |- ( ( ( K e. HL /\ W e. H ) /\ X C_ V )
          -> ( X .\/ ( ._|_ ` X ) ) = V ) $=
      ( wcel wa wss cfv wceq eqid syldan chlt co cin simpl simpr dochssv djhval
      syl12anc c0g csn clss dochlss dochnoncon adantr eqtr4d fveq2d cdih dih1rn
      doch1 crn dochoc 3eqtrd ) DUANGBNOZHFPZOZHHEQZCUBZVFVFEQUCZEQZFEQZEQZFVEV
      CVDVFFPVGVIRVCVDUDVCVDUEABDEFGHIJKLUFABCDEFGHVFIJKLMUGUHVEVHVJEVEVHAUIQZU
      JZVJVCVDVFAUKQZNVHVMRVNABDEFGHIJKVNSZLULVNABDEGVFVLIJVOVLSZLUMTVCVJVMRVDA
      BDEFGVLIJLKVPUSUNUOUPVCVDFGDUQQQZUTNZVKFRVCVRVDABVQDFGIVQSZJKURUNBVQDEGFI
      VSLVATVB $.
  $}

  ${
    djh01.h $e |- H = ( LHyp ` K ) $.
    djh01.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djh01.o $e |- .0. = ( 0g ` U ) $.
    djh01.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djh01.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djh01.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djh01.x $e |- ( ph -> X e. ran I ) $.
    $( Closed subspace join with zero.  (Contributed by NM, 9-Aug-2014.) $)
    djh01 $p |- ( ph -> ( X .\/ { .0. } ) = X ) $=
      ( co cfv eqid wcel csn ccnv cjn chlt wa crn dih0rn syl djhjlj cp0 dih0cnv
      wceq oveq2d col simpld hlol dihcnvcl syl2anc olj01 eqtrd fveq2d dihcnvid2
      cbs 3eqtrd ) AHIUAZEQHDUBZRZVEVFRZFUCRZQZDRVGDRZHACDEVIFGHVEVISZJMNOPAFUD
      TZGCTZUEZVEDUFZTOBCDFGIJMKLUGUHUIAVJVGDAVJVGFUJRZVIQZVGAVHVQVGVIAVOVHVQUL
      OBCDFGVQIJVQSZMKLUKUHUMAFUNTZVGFVCRZTZVRVGULAVMVTAVMVNOUOFUPUHAVOHVPTZWBO
      PWACDFGHWASZJMUQURWAVIFVGVQWDVLVSUSURUTVAAVOWCVKHULOPCDFGHJMVBURVD $.

    $( Closed subspace join with zero.  (Contributed by NM, 9-Aug-2014.) $)
    djh02 $p |- ( ph -> ( { .0. } .\/ X ) = X ) $=
      ( co wcel wss dihrnss csn cbs cfv eqid chlt crn dih0rn syl syl2anc djhcom
      wa djh01 eqtrd ) AIUAZHEQHUNEQHABCEFBUBUCZGUNHJKUOUDZNOAFUERGCRUKZUNDUFZR
      ZUNUOSOAUQUSOBCDFGIJMKLUGUHBCDFUOGUNJKMUPTUIAUQHURRHUOSOPBCDFUOGHJKMUPTUI
      UJABCDEFGHIJKLMNOPULUM $.
  $}

  ${
    djhlsmcl.h $e |- H = ( LHyp ` K ) $.
    djhlsmcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhlsmcl.v $e |- V = ( Base ` U ) $.
    djhlsmcl.s $e |- S = ( LSubSp ` U ) $.
    djhlsmcl.p $e |- .(+) = ( LSSum ` U ) $.
    djhlsmcl.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djhlsmcl.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhlsmcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhlsmcl.x $e |- ( ph -> X e. S ) $.
    djhlsmcl.y $e |- ( ph -> Y e. S ) $.
    $( A closed subspace sum equals subspace join.  ( ~ shjshseli analog.)
       (Contributed by NM, 13-Aug-2014.) $)
    djhlsmcl $p |- ( ph
       -> ( ( X .(+) Y ) e. ran I <-> ( X .(+) Y ) = ( X .\/ Y ) ) ) $=
      ( co crn wcel wceq wa cun coch cfv chlt wss adantr lssss syl eqid djhval2
      syl3anc clspn clmod dvhlmod lsmsp fveq2d unssd dochocsp eqtrd 3eqtr2rd ex
      dochoc sylan wi djhcl syl12anc eleq1a impbid ) AKLBUCZFUDZUEZVPKLGUCZUFZA
      VRVTAVRUGZVSKLUHZJHUIUJUJZUJZWCUJZVPWCUJZWCUJZVPWAHUKUEJEUEUGZKIULZLIULZV
      SWEUFAWHVRTUMZAWIVRAKCUEZWIUACKIDOPUNUOZUMAWJVRALCUEZWJUBCLIDOPUNUOZUMDEG
      HWCIJKLMNOWCUPZSUQURWAWFWDWCWAWFWBDUSUJZUJZWCUJWDWAVPWRWCWADUTUEZWLWNVPWR
      UFAWSVRADEHJMNTVAUMAWLVRUAUMAWNVRUBUMBCKLWQDPWQUPZQVBURVCWADEHWQWCIJWBMNW
      POWTWKAWBIULVRAKLIWMWOVDUMVEVFVCAWHVRWGVPUFTEFHWCJVPMRWPVIVJVGVHAVSVQUEZV
      TVRVKAWHWIWJXATWMWODEFGHIJKLMRNOSVLVMVSVQVPVNUOVO $.
  $}

  ${
    $d r .0. $.  $d r z I $.  $d r z K $.  $d r z N $.  $d r z ph $.  $d z W $.
    $d r z S $.  $d r z V $.  $d r z X $.  $d r z Y $.
    djhcvat42.h $e |- H = ( LHyp ` K ) $.
    djhcvat42.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhcvat42.v $e |- V = ( Base ` U ) $.
    djhcvat42.o $e |- .0. = ( 0g ` U ) $.
    djhcvat42.n $e |- N = ( LSpan ` U ) $.
    djhcvat42.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djhcvat42.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhcvat42.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhcvat42.s $e |- ( ph -> S e. ran I ) $.
    djhcvat42.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    djhcvat42.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    $( A covering property.  ( ~ cvrat42 analog.)  (Contributed by NM,
       17-Aug-2014.) $)
    djhcvat42 $p |- ( ph
      -> ( ( S =/= { .0. } /\ ( N ` { X } ) C_ ( S .\/ ( N ` { Y } ) ) )
        -> E. z e. ( V \ { .0. } ) ( ( N ` { z } ) C_ S
           /\ ( N ` { X } ) C_ ( ( N ` { z } ) .\/ ( N ` { Y } ) ) ) ) ) $=
      ( vr ccnv cfv cp0 wne csn cjn co cple wbr wa catm wrex wss cdif chlt wcel
      cv cbs wi simpld crn dihcnvcl syl2anc eldifad eldifsni dihlspsnat syl3anc
      syl cvrat42 syl13anc dih0sb necon3bid dihlsprn dihrnss syl12anc dihcnvord
      eqid djhcl djhj breq2d bitr3d anbi12d adantr eldifi adantl dihatexv2 wceq
      wb breq1 oveq1 rexxfr2d rexbidva bitr2d 3imtr4d ) ACFUGZUHZHUIUHZUJZLUKIU
      HZXAUHZXBMUKIUHZXAUHZHULUHZUMZHUNUHZUOZUPZUFVCZXBXKUOZXFXNXHXIUMZXKUOZUPZ
      UFHUQUHZURZCNUKZUJZXECXGGUMZUSZUPBVCZUKIUHZCUSZXEYFXGGUMZUSZUPZBJYAUTZURZ
      AHVAVBZXBHVDUHZVBZXFXSVBZXHXSVBZXMXTVEAYMKEVBZUBVFAYMYRUPZCFVGZVBZYOUBUCY
      NEFHKCYNWCZOTVHVIAYSLJVBZLNUJZYPUBALJYAUDVJZALYKVBUUDUDLJNVKVNXSDEFHIJKLN
      XSWCZOPQRSTVLVMAYSMJVBZMNUJZYQUBAMJYAUEVJZAMYKVBUUHUEMJNVKVNXSDEFHIJKMNUU
      FOPQRSTVLVMXSYNXFXHXIHXKXBXCUFUUBXKWCZXIWCZXCWCZUUFVOVPAYBXDYDXLACYAXBXCA
      DEFHIJKCXCNOUULTPQRSUBUCVQVRAXFYCXAUHZXKUOYDXLAEFHXKKXEYCUUJOTUBAYSUUCXEY
      TVBZUBUUEDEFHIJKLOPQSTVSZVIAYSCJUSZXGJUSZYCYTVBUBAYSUUAUUPUBUCDEFHJKCOPTQ
      VTVIAYSXGYTVBZUUQUBAYSUUGUURUBUUIDEFHIJKMOPQSTVSVIZDEFHJKXGOPTQVTVIZDEFGH
      JKCXGOTPQUAWDWAWBAUUMXJXFXKAEFGXIHKCXGUUKOTUAUBUCUUSWEWFWGWHAXTYFXAUHZXBX
      KUOZXFUVAXHXIUMZXKUOZUPZBYKURYLAXRUVEUFBUVAXSYKXSAYEYKVBZUPZYSYEJVBZYENUJ
      ZUVAXSVBAYSUVFUBWIZUVFUVHAYEJYAWJWKZUVFUVIAYEJNVKWKXSDEFHIJKYENUUFOPQRSTV
      LVMABXSXNDEFHIJKNUUFOPQRSTUBWLXNUVAWMZXRUVEWNAUVLXOUVBXQUVDXNUVAXBXKWOUVL
      XPUVCXFXKXNUVAXHXIWPWFWHWKWQAUVEYJBYKUVGUVBYGUVDYIUVGEFHXKKYFCUUJOTUVJUVG
      YSUVHYFYTVBZUVJUVKDEFHIJKYEOPQSTVSVIZAUUAUVFUCWIWBUVGXFYHXAUHZXKUOUVDYIUV
      GUVOUVCXFXKUVGEFGXIHKYFXGUUKOTUAUVJUVNAUURUVFUUSWIWEWFUVGEFHXKKXEYHUUJOTU
      VJUVGYSUUCUUNUVJAUUCUVFUUEWIUUOVIUVGYSYFJUSZUUQYHYTVBUVJUVGYSUVMUVPUVJUVN
      DEFHJKYFOPTQVTVIAUUQUVFUUTWIDEFGHJKYFXGOTPQUAWDWAWBWGWHWRWSWT $.
  $}

  ${
    dihjatb.l $e |- .<_ = ( le ` K ) $.
    dihjatb.h $e |- H = ( LHyp ` K ) $.
    dihjatb.j $e |- .\/ = ( join ` K ) $.
    dihjatb.a $e |- A = ( Atoms ` K ) $.
    dihjatb.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjatb.s $e |- .(+) = ( LSSum ` U ) $.
    dihjatb.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjatb.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjatb.p $e |- ( ph -> ( P e. A /\ P .<_ W ) ) $.
    dihjatb.q $e |- ( ph -> ( Q e. A /\ Q .<_ W ) ) $.
    $( Isomorphism H of lattice join of two atoms under the fiducial
       hyperplane.  (Contributed by NM, 23-Sep-2014.) $)
    dihjatb $p |- ( ph ->
      ( I ` ( P .\/ Q ) ) = ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( co cfv dih2dimb cbs eqid wcel wbr simpld atbase syl dihsumssj eqssd ) A
      CEIUCHUDCHUDEHUDDUCABCDEFGHIJKLMOPNQRSTUAUBUEAJUFUDZDFGHIJLCEUOUGZNOQRSTA
      CBUHZCUOUHAUQCLKUIUAUJBUOCJUPPUKULAEBUHZEUOUHAURELKUIUBUJBUOEJUPPUKULUMUN
      $.
  $}

  ${
    dihjatc.b $e |- B = ( Base ` K ) $.
    dihjatc.l $e |- .<_ = ( le ` K ) $.
    dihjatc.h $e |- H = ( LHyp ` K ) $.
    dihjatc.j $e |- .\/ = ( join ` K ) $.
    dihjatc.a $e |- A = ( Atoms ` K ) $.
    dihjatc.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjatc.s $e |- .(+) = ( LSSum ` U ) $.
    dihjatc.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjatc.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjatc.x $e |- ( ph -> ( X e. B /\ X .<_ W ) ) $.
    dihjatc.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    $( Isomorphism H of lattice join of an element under the fiducial
       hyperplane with atom not under it.  (Contributed by NM, 26-Aug-2014.) $)
    dihjatc $p |- ( ph ->
      ( I ` ( X .\/ P ) ) = ( ( I ` X ) .(+) ( I ` P ) ) ) $=
      ( cp1 cfv cmee co chlt wcel wa wbr wceq cops simpld hlop syl op1cl atbase
      wn eqid ople1 syl2anc hlol olm12 simprd eqbrtrd dihjatc3 syl312anc oveq1d
      col fveq2d 3eqtr3d ) AJUEUFZMJUGUFZUHZDIUHZHUFZVPHUFZDHUFZEUHZMDIUHZHUFMH
      UFZVTEUHAJUIUJZLGUJZUKVNCUJZMCUJZDBUJZDLKULUTZUKDVNKULZVPLKULVRWAUMUBAJUN
      UJZWFAWDWKAWDWEUBUOZJUPUQZCVNJNVNVAZURUQAWGMLKULZUCUOZUDAWKDCUJZWJWMAWHWQ
      AWHWIUDUOBCDJNRUSUQCVNJKDNOWNVBVCAVPMLKAJVKUJZWGVPMUMAWDWRWLJVDUQWPCVNJVO
      MNVOVAZWNVEVCZAWGWOUCVFVGBCEDFGHIJKVOLVNMNOPQWSRSTUAVHVIAVQWBHAVPMDIWTVJV
      LAVSWCVTEAVPMHWTVLVJVM $.
  $}

  ${
    dihjatcclem.b $e |- B = ( Base ` K ) $.
    dihjatcclem.l $e |- .<_ = ( le ` K ) $.
    dihjatcclem.h $e |- H = ( LHyp ` K ) $.
    dihjatcclem.j $e |- .\/ = ( join ` K ) $.
    dihjatcclem.m $e |- ./\ = ( meet ` K ) $.
    dihjatcclem.a $e |- A = ( Atoms ` K ) $.
    dihjatcclem.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjatcclem.s $e |- .(+) = ( LSSum ` U ) $.
    dihjatcclem.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjatcclem.v $e |- V = ( ( P .\/ Q ) ./\ W ) $.
    dihjatcclem.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjatcclem.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dihjatcclem.q $e |- ( ph -> ( Q e. A /\ -. Q .<_ W ) ) $.
    $( Lemma for isomorphism H of lattice join of two atoms not under the
       fiducial hyperplane.  (Contributed by NM, 26-Sep-2014.) $)
    dihjatcclem1 $p |- ( ph -> ( I ` ( P .\/ Q ) )
 = ( ( ( I ` P ) .(+) ( I ` Q ) ) .(+) ( I ` V ) ) ) $=
      ( cfv cabel wcel csubg wceq clmod dvhlmod lmodabl syl clss eqid lsssssubg
      co wss chlt wa wbr simpld atbase dihlss syl2anc sseldd clat hllat hlatjcl
      wn syl3anc simprd lhpbase latmcl syl5eqel lsm4 syl122anc intnand latjle12
      wb syl13anc mtbid hlatlej1 dihvalcq2 fveq2i oveq2i syl6eqr oveq12d lsmidm
      hlatlej2 eqtr3d oveq2d 3eqtr3d ) ADIUIZNIUIZEVAZFIUIZWSEVAZEVAZWRXAEVAZWS
      WSEVAZEVAZDFJVAZIUIZXDWSEVAAGUJUKZWRGULUIZUKWSXJUKZXAXJUKXKXCXFUMAGUNUKZX
      IAGHKORUBUFUOZGUPUQAGURUIZXJWRAXLXNXJVBXMXNGXNUSZUTUQZAKVCUKZOHUKZVDZDCUK
      ZWRXNUKUFADBUKZXTAYADOLVEZVNZUGVFZBCDKPUAVGUQZCXNGHIKODPRUDUBXOVHVIVJAXNX
      JWSXPAXSNCUKWSXNUKUFANXGOMVAZCUEAKVKUKZXGCUKZOCUKZYFCUKAXQYGAXQXRUFVFZKVL
      UQZAXQYAFBUKZYHYJYDAYLFOLVEZVNZUHVFZBCJKDFPSUAVMVOZAXRYIAXQXRUFVPCHKOPRVQ
      UQZCKMXGOPTVRVOVSCXNGHIKONPRUDUBXOVHVIVJZAXNXJXAXPAXSFCUKZXAXNUKUFAYLYSYO
      BCFKPUAVGUQZCXNGHIKOFPRUDUBXOVHVIVJYREWRWSXAWSGUCVTWAAXHXHEVAZXCXHAXHWTXH
      XBEAXHWRYFIUIZEVAZWTAXSYHXGOLVEZVNZYAYCVDDXGLVEZXHUUCUMUFYPAYBYMVDZUUDAYM
      YBAYLYNUHVPWBAYGXTYSYIUUGUUDWDYKYEYTYQCJKLDFOPQSWCWEWFZUGAXQYAYLUUFYJYDYO
      BDFJKLQSUAWGVOBCEDGHIJKLMOXGPQSTUARUDUBUCWHWAWSUUBWRENYFIUEWIZWJWKAXHXAUU
      BEVAZXBAXSYHUUEYLYNVDFXGLVEZXHUUJUMUFYPUUHUHAXQYAYLUUKYJYDYOBDFJKLQSUAWNV
      OBCEFGHIJKLMOXGPQSTUARUDUBUCWHWAWSUUBXAEUUIWJWKWLAXHXJUKUUAXHUMAXNXJXHXPA
      XSYHXHXNUKUFYPCXNGHIKOXGPRUDUBXOVHVIVJEXHGUCWMUQWOAXEWSXDEAXKXEWSUMYREWSG
      UCWMUQWPWQ $.

    ${
      dihjatcclem2.c $e |- ( ph ->
        ( I ` V ) C_ ( ( I ` P ) .(+) ( I ` Q ) ) ) $.
      $( Lemma for isomorphism H of lattice join of two atoms not under the
         fiducial hyperplane.  (Contributed by NM, 26-Sep-2014.) $)
      dihjatcclem2 $p |- ( ph ->
        ( I ` ( P .\/ Q ) ) = ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
        ( co cfv dihjatcclem1 csubg wcel wceq clss clmod dvhlmod eqid lsssssubg
        wss syl chlt wa wbr wn simpld atbase dihlss syl2anc lsmcl sseldd fveq2i
        syl3anc clat hllat hlatjcl simprd lhpbase latmcl syl5eqel lsmss2 eqtrd
        ) ADFJUJZIUKDIUKZFIUKZEUJZNIUKZEUJZWGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUG
        UHULAWGGUMUKZUNWHWJUNWHWGVAWIWGUOAGUPUKZWJWGAGUQUNZWKWJVAAGHKORUBUFURZW
        KGWKUSZUTVBZAWLWEWKUNZWFWKUNZWGWKUNWMAKVCUNZOHUNZVDZDCUNZWPUFADBUNZXAAX
        BDOLVEVFUGVGZBCDKPUAVHVBCWKGHIKODPRUDUBWNVIVJAWTFCUNZWQUFAFBUNZXDAXEFOL
        VEVFUHVGZBCFKPUAVHVBCWKGHIKOFPRUDUBWNVIVJEWKWEWFGWNUCVKVNVLAWKWJWHWOAWH
        WDOMUJZIUKZWKNXGIUEVMAWTXGCUNZXHWKUNUFAKVOUNZWDCUNZOCUNZXIAWRXJAWRWSUFV
        GZKVPVBAWRXBXEXKXMXCXFBCJKDFPSUAVQVNAWSXLAWRWSUFVRCHKOPRVSVBCKMWDOPTVTV
        NCWKGHIKOXGPRUDUBWNVIVJWAVLUIEWGWHGUCWBVNWC $.
    $}

    $d d t .<_ $.  $d f s .(+) $.  $d t .0. $.  $d d A $.  $d d B $.  $d d C $.
    $d g h t u D $.  $d a b t E $.  $d d g t H $.  $d g h u J $.  $d g h u N $.
    $d f g h s t u I $.  $d d f g h s t u P $.  $d f g h s t u ph $.  $d t R $.
    $d g h t u G $.  $d a b d g t K $.  $d d f g h s t u Q $.  $d a b d t T $.
    $d g h t u U $.  $d f s t V $.  $d a b d g t W $.
    dihjatcc.w $e |- C = ( ( oc ` K ) ` W ) $.
    dihjatcc.t $e |- T = ( ( LTrn ` K ) ` W ) $.
    dihjatcc.r $e |- R = ( ( trL ` K ) ` W ) $.
    dihjatcc.e $e |- E = ( ( TEndo ` K ) ` W ) $.
    dihjatcc.g $e |- G = ( iota_ d e. T ( d ` C ) = P ) $.
    dihjatcc.dd $e |- D = ( iota_ d e. T ( d ` C ) = Q ) $.
    $( Lemma for ~ dihjatcc .  (Contributed by NM, 28-Sep-2014.) $)
    dihjatcclem3 $p |- ( ph -> ( R ` ( G o. `' D ) ) = V ) $=
      ( ccnv ccom cfv co chlt wcel wa wbr wceq lhpocnel2 syl ltrniotacl syl3anc
      wn ltrncnv syl2anc trlval2 ltrncoval syl121anc ltrniotacnvval ltrniotaval
      ltrnco simpld fveq2d eqtrd oveq2d hlatjcom eqtr4d oveq1d syl6eqr ) AMEVBZ
      VCZIVDZHHWMVDZPVEZUASVEZTAQVFVGZUANVGZVHZWMJVGZHBVGZHUARVIVOZVHZWNWQVJUMA
      WTMJVGZWLJVGZXAUMAWTDBVGDUARVIVOVHZFBVGZFUARVIVOZVHZXEUMAWTXGUMBDNQRUAUDU
      HUEUPVKVLZUNBDFJUBMNQRUAUDUHUEUQUTVMVNZAWTEJVGZXFUMAWTXGXDXMUMXKUOBDHJUBE
      NQRUAUDUHUEUQVAVMVNJENQUAUEUQVPVQZJMWLNQUAUEUQWCVNUOBHIJWMNPQRSUAUDUFUGUH
      UEUQURVRVNAWQFHPVEZUASVETAWPXOUASAWPHFPVEZXOAWOFHPAWOHWLVDZMVDZFAWTXEXFXB
      WOXRVJUMXLXNAXBXCUOWDZBHJMWLNQRUAUDUHUEUQVSVTAXRDMVDZFAXQDMAWTXGXDXQDVJUM
      XKUOBDHJUBENQRUAUDUHUEUQVAWAVNWEAWTXGXJXTFVJUMXKUNBDFJUBMNQRUAUDUHUEUQUTW
      BVNWFWFWGAWRXHXBXOXPVJAWRWSUMWDAXHXIUNWDXSBPQFHUFUHWHVNWIWJULWKWF $.

    dihjatcc.n $e |- N = ( a e. E |-> ( d e. T |-> `' ( a ` d ) ) ) $.
    dihjatcc.o $e |- .0. = ( d e. T |-> ( _I |` B ) ) $.
    dihjatcc.d $e |- J = ( a e. E , b e. E |-> ( d e. T
          |-> ( ( a ` d ) o. ( b ` d ) ) ) ) $.
    $( Lemma for isomorphism H of lattice join of two atoms not under the
       fiducial hyperplane.  (Contributed by NM, 29-Sep-2014.) $)
    dihjatcclem4 $p |- ( ph -> ( I ` V ) C_ ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( vf vs vg vt vh vu cfv co chlt wcel wrel dihvalrel syl wbr wceq cop ccom
      wa cv wex ccnv wrex adantr wn lhpocnel2 ltrniotacl syl3anc ltrncnv ltrnco
      syl2anc simprll simprlr dihjatcclem3 tendoex syl121anc df-rex sylib eqidd
      breqtrrd simprl ad2antrr vex dihopelvalcqat mpbir2and tendoicl tendospdi1
      wb fvex syl13anc simprr tendoi2 tendocnv eqtr2d 3eqtr3d simplrr tendoipl2
      coeq2d eqtr4d wi opeq1 eleq1d anbi1d eqeq2d anbi12d anbi2d ex simpld eqid
      cvv syl12anc atbase coeq1 coeq2 opeq2 oveq2 syl3an9b spc3egv mp3an eximdv
      syl22anc excom syl6ib mpd cdib clat hllat hlatjcl simprd lhpbase syl5eqel
      latmcl latmle2 syl5eqbr dihvalb dibopelval3 bitrd clss dihopellsm 3imtr4d
      eleq2d relssdv ) AVJVKUBOVPZFOVPZHOVPZGVQZARVRVSZUCNVSZWGZUVKVTURNORUCUBU
      JUPWAWBAVJWHZJVSZUVRIVPZUBSWCZWGZVKWHZUDWDZWGZVLWHZVMWHZWEZUVLVSZVNWHZVOW
      HZWEZUVMVSZWGZUVRUWFUWJWFZWDZUWCUWGUWKPVQZWDZWGZWGZVOWIVNWIZVMWIVLWIZUVRU
      WCWEZUVKVSZUXCUVNVSAUWEUXBAUWEWGZUWGLVSZMEWJZWFZUWGVPZUVRWDZWGZVMWIZUXBUX
      EUXJVMLWKZUXLUXEUVQUXHJVSZUVSUVTUXHIVPZSWCUXMAUVQUWEURWLAUXNUWEAUVQMJVSZU
      XGJVSZUXNURAUVQDBVSDUCSWCWMWGZFBVSZFUCSWCWMZWGZUXPURAUVQUXRURBDNRSUCUIUMU
      JVAWNWBZUSBDFJUGMNRSUCUIUMUJVBVEWOWPZAUVQEJVSZUXQURAUVQUXRHBVSZHUCSWCWMZW
      GZUYDURUYBUTBDHJUGENRSUCUIUMUJVBVFWOWPZJENRUCUJVBWQWSZJMUXGNRUCUJVBWRWPWL
      AUVSUWAUWDWTUXEUVTUBUXOSAUVSUWAUWDXAAUXOUBWDUWEABCDEFGHIJKLMNOQRSTUBUCUGU
      HUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFXBWLXHVMIJLUXHNRSUVRUCUIUJVBVCVDXCXD
      UXJVMLXEXFUXEUXLUXAVLWIZVMWIUXBUXEUXKUYJVMUXEUXKUYJUXEUXKWGZMUWGVPZUWGWEZ
      UVLVSZEUWGUAVPZVPZUYOWEZUVMVSZUVRUYLUYPWFZWDZUWCUWGUYOPVQZWDZUYJUYKUYNUYL
      UYLWDZUXFUYKUYLXGUXEUXFUXJXIZUYKUVQUYAUYNVUCUXFWGXPAUVQUWEUXKURXJZAUYAUWE
      UXKUSXJBDFUWGJUGLUYLMNORSUCUIUMUJVAVBVDUPVEMUWGXQZVMXKXLWSXMUYKUYRUYPUYPW
      DZUYOLVSZUYKUYPXGUYKUVQUXFVUHVUEVUDUWGJUGLNUARUCUEUJVBVDVGXNWSUYKUVQUYGUY
      RVUGVUHWGXPVUEAUYGUWEUXKUTXJBDHUYOJUGLUYPENORSUCUIUMUJVAVBVDUPVFEUYOXQZUW
      GUAXQZXLWSXMUYKUXIUYLUXGUWGVPZWFZUVRUYSUYKUVQUXFUXPUXQUXIVULWDVUEVUDAUXPU
      WEUXKUYCXJAUXQUWEUXKUYIXJJUWGLMUXGNRVRUCUJVBVDXOXRUXEUXFUXJXSUYKVUKUYPUYL
      UYKUYPEUWGVPWJZVUKUYKUXFUYDUYPVUMWDVUDAUYDUWEUXKUYHXJZUWGJUGLEUARUCUEVGVB
      XTWSUYKUVQUXFUYDVUMVUKWDVUEVUDVUNUWGJLENRUCUJVBVDYAWPYBYFYCUYKUWCUDVUAAUW
      BUWDUXKYDUYKUVQUXFVUAUDWDVUEVUDUFCPUWGJUGLNUARUDUCUEUJVBVDVGUHVIVHYEWSYGU
      YLYRVSUYPYRVSUYOYRVSUYNUYRWGZUYTVUBWGZWGZUYJYHVUFVUIVUJUWTVUQVLVNVOUYLUYP
      UYOYRYRYRUWFUYLWDZUWTUYNUWMWGZUVRUYLUWJWFZWDZUWRWGZWGUWJUYPWDZUYNUYPUWKWE
      ZUVMVSZWGZUYTUWRWGZWGUWKUYOWDZVUQVURUWNVUSUWSVVBVURUWIUYNUWMVURUWHUYMUVLU
      WFUYLUWGYIYJYKVURUWPVVAUWRVURUWOVUTUVRUWFUYLUWJUUAYLYKYMVVCVUSVVFVVBVVGVV
      CUWMVVEUYNVVCUWLVVDUVMUWJUYPUWKYIYJYNVVCVVAUYTUWRVVCVUTUYSUVRUWJUYPUYLUUB
      YLYKYMVVHVVFVUOVVGVUPVVHVVEUYRUYNVVHVVDUYQUVMUWKUYOUYPUUCYJYNVVHUWRVUBUYT
      VVHUWQVUAUWCUWKUYOUWGPUUDYLYNYMUUEUUFUUGUUIYOUUHUXAVMVLUUJUUKUULYOAUXDUXC
      UBUCRUUMVPVPZVPZVSZUWEAUVKVVJUXCAUVQUBCVSZUBUCSWCZUVKVVJWDURAUBFHQVQZUCTV
      QZCUQARUUNVSZVVNCVSZUCCVSZVVOCVSAUVOVVPAUVOUVPURYPZRUUOWBZAUVOUXSUYEVVQVV
      SAUXSUXTUSYPZAUYEUYFUTYPZBCQRFHUHUKUMUUPWPZAUVPVVRAUVOUVPURUUQCNRUCUHUJUU
      RWBZCRTVVNUCUHULUUTWPUUSZAUBVVOUCSUQAVVPVVQVVRVVOUCSWCVVTVWCVWDCRSTVVNUCU
      HUIULUVAWPUVBZCVVINORSVRUCUBUHUIUJUPVVIYQZUVCYSUVIAUVQVVLVVMVVKUWEXPURVWE
      VWFCIUWCJUGUVRNVVIRSVRUCUBUDUHUIUJVBVCVHVWGUVDYSUVEAUFUEVOVMPCGUWCJKVLVNU
      GLUVRNORKUVFVPZUCFHUHUJVBVDVIUNVWHYQUOUPURAUXSFCVSVWABCFRUHUMYTWBAUYEHCVS
      VWBBCHRUHUMYTWBUVGUVHUVJ $.
  $}

  ${
    $d d .<_ $.  $d d A $.  $d d H $.  $d a b d K $.  $d d P $.  $d d Q $.
    $d a b d W $.
    dihjatcc.l $e |- .<_ = ( le ` K ) $.
    dihjatcc.h $e |- H = ( LHyp ` K ) $.
    dihjatcc.j $e |- .\/ = ( join ` K ) $.
    dihjatcc.a $e |- A = ( Atoms ` K ) $.
    dihjatcc.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjatcc.s $e |- .(+) = ( LSSum ` U ) $.
    dihjatcc.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjatcc.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjatcc.p $e |- ( ph -> ( P e. A /\ -. P .<_ W ) ) $.
    dihjatcc.q $e |- ( ph -> ( Q e. A /\ -. Q .<_ W ) ) $.
    $( Isomorphism H of lattice join of two atoms not under the fiducial
       hyperplane.  (Contributed by NM, 29-Sep-2014.) $)
    dihjatcc $p |- ( ph ->
        ( I ` ( P .\/ Q ) ) = ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( vd va vb cbs cfv cmee co eqid coc wceq cltrn crio ctrl ctendo ccom cmpt
      cv cmpt2 ccnv cid cres dihjatcclem4 dihjatcclem2 ) ABJUFUGZCDEFGHIJKJUHUG
      ZCEIUILVGUIZLVFUJZMNOVGUJZPQRSVHUJZTUAUBABVFLJUKUGUGZVLUCUSZUGZEULUCLJUMU
      GUGZUNZCDELJUOUGUGZVOFLJUPUGUGZVNCULUCVOUNZGHUDUEVRVRUCVOVMUDUSUGZVMUEUSU
      GUQURUTZIJKVGUDVRUCVOVTVAURURZVHLUCVOVBVFVCURZUDUEUCVIMNOVJPQRSVKTUAUBVLU
      JVOUJVQUJVRUJVSUJVPUJWBUJWCUJWAUJVDVE $.
  $}

  ${
    dihjat.h $e |- H = ( LHyp ` K ) $.
    dihjat.j $e |- .\/ = ( join ` K ) $.
    dihjat.a $e |- A = ( Atoms ` K ) $.
    dihjat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat.s $e |- .(+) = ( LSSum ` U ) $.
    dihjat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat.p $e |- ( ph -> P e. A ) $.
    dihjat.q $e |- ( ph -> Q e. A ) $.
    $( Isomorphism H of lattice join of two atoms.  (Contributed by NM,
       29-Sep-2014.) $)
    dihjat $p |- ( ph ->
        ( I ` ( P .\/ Q ) ) = ( ( I ` P ) .(+) ( I ` Q ) ) ) $=
      ( cple cfv wbr co wceq wa eqid chlt wcel adantr simprl jca simprr dihjatb
      cbs atbase syl dihjatc simpld hlatjcom syl3anc fveq2d cabel csubg dvhlmod
      wn clmod lmodabl clss wss lsssssubg dihlss syl2anc sseldd lsmcom dihjatcc
      3eqtr4d 4casesdan ) ACKJUAUBZUCZEKVSUCZCEIUDZHUBZCHUBZEHUBZDUDZUEAVTWAUFZ
      UFZBCDEFGHIJVSKVSUGZLMNOPQAJUHUIZKGUIZUFZWGRUJWHCBUIZVTAWMWGSUJAVTWAUKULW
      HEBUIZWAAWNWGTUJAVTWAUMULUNAVTWAVFZUFZUFZBJUOUBZEDFGHIJVSKCWRUGZWILMNOPQA
      WLWPRUJWQCWRUIZVTAWTWPAWMWTSBWRCJWSNUPUQZUJAVTWOUKULWQWNWOAWNWPTUJAVTWOUM
      ULURAVTVFZWAUFZUFZECIUDZHUBZWEWDDUDZWCWFXDBWRCDFGHIJVSKEWSWILMNOPQAWLXCRU
      JXDEWRUIZWAAXHXCAWNXHTBWREJWSNUPUQZUJAXBWAUMULXDWMXBAWMXCSUJAXBWAUKULURAW
      CXFUEXCAWBXEHAWJWMWNWBXEUEAWJWKRUSSTBIJCEMNUTVAVBUJAWFXGUEZXCAFVCUIZWDFVD
      UBZUIWEXLUIXJAFVGUIZXKAFGJKLORVEZFVHUQAFVIUBZXLWDAXMXOXLVJXNXOFXOUGZVKUQZ
      AWLWTWDXOUIRXAWRXOFGHJKCWSLQOXPVLVMVNAXOXLWEXQAWLXHWEXOUIRXIWRXOFGHJKEWSL
      QOXPVLVMVNDWDWEFPVOVAUJVQAXBWOUFZUFZBCDEFGHIJVSKWILMNOPQAWLXRRUJXSWMXBAWM
      XRSUJAXBWOUKULXSWNWOAWNXRTUJAXBWOUMULVPVR $.
  $}

  ${
    dihprrn.h $e |- H = ( LHyp ` K ) $.
    dihprrn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihprrn.v $e |- V = ( Base ` U ) $.
    dihprrn.n $e |- N = ( LSpan ` U ) $.
    dihprrn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihprrn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihprrn.x $e |- ( ph -> X e. V ) $.
    dihprrn.y $e |- ( ph -> Y e. V ) $.
    ${
      dihprrnlem1.l $e |- .<_ = ( le ` K ) $.
      dihprrnlem1.o $e |- .0. = ( 0g ` U ) $.
      dihprrnlem1.nz $e |- ( ph -> Y =/= .0. ) $.
      dihprrnlem1.x $e |- ( ph -> ( `' I ` ( N ` { X } ) ) .<_ W ) $.
      dihprrnlem1.y $e |- ( ph -> -. ( `' I ` ( N ` { Y } ) ) .<_ W ) $.
      $( Lemma for ~ dihprrn , showing one of 4 cases.  (Contributed by NM,
         30-Aug-2014.)  (New usage is discouraged.) $)
      dihprrnlem1N $p |- ( ph -> ( N ` { X , Y } ) e. ran I ) $=
        ( cpr cfv csn ccnv cjn crn cun df-pr fveq2i clsm catm cbs eqid wcel wbr
        co chlt wa dihlsprn syl2anc dihcnvcl jca wne dihlspsnat syl3anc dihjatc
        wn wceq dihcnvid2 oveq12d clmod wss dvhlmod snssd lsmsp2 3eqtrrd syl5eq
        clat simpld hllat syl latjcl dihcl eqeltrd ) AJKUFZGUGZJUHZGUGZDUIZUGZK
        UHZGUGZWNUGZEUJUGZVAZDUGZDUKZAWKWLWPULZGUGZXAWJXCGJKUMUNAXAWODUGZWRDUGZ
        BUOUGZVAWMWQXGVAZXDAEUPUGZEUQUGZWRXGBCDWSEFIWOXJURZUAMWSURZXIURZNXGURZQ
        RAWOXJUSZWOIFUTAEVBUSZICUSZVCZWMXBUSZXORAXRJHUSXSRSBCDEGHIJMNOPQVDVEZXJ
        CDEIWMXKMQVFVEZUDVGAWRXIUSZWRIFUTVLAXRKHUSZKLVHYBRTUCXIBCDEGHIKLXMMNOUB
        PQVIVJUEVGVKAXEWMXFWQXGAXRXSXEWMVMRXTCDEIWMMQVNVEAXRWQXBUSZXFWQVMRAXRYC
        YDRTBCDEGHIKMNOPQVDVEZCDEIWQMQVNVEVOABVPUSWLHVQWPHVQXHXDVMABCEIMNRVRAJH
        SVSAKHTVSXGWLWPGHBOPXNVTVJWAWBAXRWTXJUSZXAXBUSRAEWCUSZXOWRXJUSZYFAXPYGA
        XPXQRWDEWEWFYAAXRYDYHRYEXJCDEIWQXKMQVFVEXJWSEWOWRXKXLWGVJXJCDEIWTXKMQWH
        VEWI $.
    $}

    ${
      dihprrnlem2.o $e |- .0. = ( 0g ` U ) $.
      dihprrnlem2.xz $e |- ( ph -> X =/= .0. ) $.
      dihprrnlem2.yz $e |- ( ph -> Y =/= .0. ) $.
      $( Lemma for ~ dihprrn .  (Contributed by NM, 29-Sep-2014.) $)
      dihprrnlem2 $p |- ( ph -> ( N ` { X , Y } ) e. ran I ) $=
        ( cpr cfv csn ccnv cjn co crn cun df-pr fveq2i clsm catm eqid chlt wcel
        wa wne dihlspsnat syl3anc wceq dihlsprn syl2anc dihcnvid2 oveq12d clmod
        dihjat wss dvhlmod snssd lsmsp2 3eqtrrd syl5eq cbs clat simpld dihcnvcl
        hllat syl latjcl dihcl eqeltrd ) AIJUCZFUDZIUEZFUDZDUFZUDZJUEZFUDZWHUDZ
        EUGUDZUHZDUDZDUIZAWEWFWJUJZFUDZWOWDWQFIJUKULAWOWIDUDZWLDUDZBUMUDZUHWGWK
        XAUHZWRAEUNUDZWIXAWLBCDWMEHLWMUOZXCUOZMXAUOZPQAEUPUQZHCUQZURZIGUQZIKUSW
        IXCUQQRUAXCBCDEFGHIKXELMNTOPUTVAAXIJGUQZJKUSWLXCUQQSUBXCBCDEFGHJKXELMNT
        OPUTVAVHAWSWGWTWKXAAXIWGWPUQZWSWGVBQAXIXJXLQRBCDEFGHILMNOPVCVDZCDEHWGLP
        VEVDAXIWKWPUQZWTWKVBQAXIXKXNQSBCDEFGHJLMNOPVCVDZCDEHWKLPVEVDVFABVGUQWFG
        VIWJGVIXBWRVBABCEHLMQVJAIGRVKAJGSVKXAWFWJFGBNOXFVLVAVMVNAXIWNEVOUDZUQZW
        OWPUQQAEVPUQZWIXPUQZWLXPUQZXQAXGXRAXGXHQVQEVSVTAXIXLXSQXMXPCDEHWGXPUOZL
        PVRVDAXIXNXTQXOXPCDEHWKYALPVRVDXPWMEWIWLYAXDWAVAXPCDEHWNYALPWBVDWC $.
    $}

    $( The span of a vector pair belongs to the range of isomorphism H i.e. is
       a closed subspace.  (Contributed by NM, 29-Sep-2014.) $)
    dihprrn $p |- ( ph -> ( N ` { X , Y } ) e. ran I ) $=
      ( cfv wcel cpr crn c0g wceq wa csn prcom preq2 syl5eq fveq2d eqid dvhlmod
      lsppr0 chlt dihlsprn syl2anc adantr eqeltrd wne simprl simprr dihprrnlem2
      sylan9eqr pm2.61da2ne ) AIJUAZFSZDUBZTIBUCSZJVHAIVHUDZUEVFJUFFSZVGVIAVFJV
      HUAZFSVJVIVEVKFVIVEJIUAVKIJUGIVHJUHUIUJAFGBJVHMVHUKZNABCEHKLPULZRUMVCAVJV
      GTZVIAEUNTHCTUEZJGTZVNPRBCDEFGHJKLMNOUOUPUQURAJVHUDZUEVFIUFFSZVGVQAVFIVHU
      AZFSVRVQVEVSFJVHIUHUJAFGBIVHMVLNVMQUMVCAVRVGTZVQAVOIGTZVTPQBCDEFGHIKLMNOU
      OUPUQURAIVHUSZJVHUSZUEZUEBCDEFGHIJVHKLMNOAVOWDPUQAWAWDQUQAVPWDRUQVLAWBWCU
      TAWBWCVAVBVD $.
  $}

  ${
    djhlsmat.h $e |- H = ( LHyp ` K ) $.
    djhlsmat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    djhlsmat.v $e |- V = ( Base ` U ) $.
    djhlsmat.p $e |- .(+) = ( LSSum ` U ) $.
    djhlsmat.n $e |- N = ( LSpan ` U ) $.
    djhlsmat.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    djhlsmat.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    djhlsmat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    djhlsmat.x $e |- ( ph -> X e. V ) $.
    djhlsmat.y $e |- ( ph -> Y e. V ) $.
    $( The sum of two subspace atoms equals their join.  TODO: seems convoluted
       to go via ~ dihprrn ; should we directly use ~ dihjat ?  (Contributed by
       NM, 13-Aug-2014.) $)
    djhlsmat $p |- ( ph -> ( ( N ` { X } ) .(+) ( N ` { Y } ) ) =
      ( ( N ` { X } ) .\/ ( N ` { Y } ) ) ) $=
      ( csn cfv co crn wcel wceq cpr cun clmod wss dvhlmod snssd lsmsp2 syl3anc
      df-pr fveq2i syl6eqr dihprrn eqeltrd clss lspsncl syl2anc djhlsmcl mpbid
      eqid ) AKUCZHUDZLUCZHUDZBUEZEUFZUGVLVIVKFUEUHAVLKLUIZHUDZVMAVLVHVJUJZHUDZ
      VOACUKUGZVHIULVJIULVLVQUHACDGJMNTUMZAKIUAUNALIUBUNBVHVJHICOQPUOUPVNVPHKLU
      QURUSACDEGHIJKLMNOQRTUAUBUTVAABCVBUDZCDEFGIJVIVKMNOVTVGZPRSTAVRKIUGVIVTUG
      VSUAVTHICKOWAQVCVDAVRLIUGVKVTUGVSUBVTHICLOWAQVCVDVEVF $.
  $}

  ${
    $d y I $.  $d x z .\/ $.  $d y K $.  $d x y z N $.  $d x y .0. $.
    $d x y z .(+) $.  $d x y z T $.  $d x y z U $.  $d y z V $.  $d y W $.
    $d x y z X $.  $d x y z ph $.
    dihjat1.h $e |- H = ( LHyp ` K ) $.
    dihjat1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat1.v $e |- V = ( Base ` U ) $.
    dihjat1.p $e |- .(+) = ( LSSum ` U ) $.
    dihjat1.n $e |- N = ( LSpan ` U ) $.
    dihjat1.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat1.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    dihjat1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat1.x $e |- ( ph -> X e. ran I ) $.
    ${
      dihjat1.o $e |- .0. = ( 0g ` U ) $.
      dihjat1lem.q $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      $( Subspace sum of a closed subspace and an atom.  ( ~ pmapjat1 analog.)
         TODO: merge into ~ dihjat1 ?  (Contributed by NM, 18-Aug-2014.) $)
      dihjat1lem $p |- ( ph
          -> ( X .\/ ( N ` { T } ) ) = ( X .(+) ( N ` { T } ) ) ) $=
        ( vx vy vz csn cfv co wceq wa oveq1d chlt wcel crn cdif eldifi dihlsprn
        simpr syl2anc djh02 csubg clmod clss dvhlmod eqid lspsncl lsssubg lsm02
        syl eqtr4d adantr wne wss dihrnss lssss djhcl syl12anc dihrnlss syl3anc
        lsmcl cv wrex simplr ad2antrr djhcvat42 mpand simprrl ad2antrl lspsnel5
        ad3antrrr mpbird lspsnid simprrr sneq fveq2d oveq2d sseq2d jca reximdv2
        rspcev ex syld anim2d lspsnel6 lsmelval2 lssel djhlsmat rexbidva anbi2d
        wb bitrd 3imtr4d lssssr djhsumss eqssd pm2.61dane ) ALCUHZIUIZGUJZLXTBU
        JZUKLMUHZALYCUKZULZYAYCXTGUJZYBYELYCXTGAYDUTZUMYEYBYCXTBUJZYFYELYCXTBYG
        UMAYFYHUKYDAYFXTYHADEFGHKXTMNOUCSTUAAHUNUOKEUOULZCJUOZXTFUPZUOUAACJYCUQ
        ZUOZYJUDCJYCURVKZDEFHIJKCNOPRSUSVAVBAXTDVCUIUOZYHXTUKADVDUOZXTDVEUIZUOZ
        YOADEHKNOUAVFZAYPYJYRYSYNYQIJDCPYQVGZRVHVAZYQXTDYTVIVABDXTMUCQVJVKVLVMV
        LVLALYCVNZULZYAYBUUCUEYQYAYBJDMPUCYTAYPUUBYSVMAYAJVOZUUBAYIYAYKUOZUUDUA
        AYILJVOZXTJVOZUUEUAAYILYKUOZUUFUAUBDEFHJKLNOSPVPVAZAYRUUGUUAYQXTJDPYTVQ
        VKZDEFGHJKLXTNSOPTVRVSZDEFHJKYANOSPVPVAVMAYBYQUOZUUBAYPLYQUOZYRUULYSAYI
        UUHUUMUAUBYQDEFHKLNOSYTVTVAZUUABYQLXTDYTQWBWAVMUUCUEWCZYLUOZULZUUOJUOZU
        UOUHIUIZYAVOZULZUURUUSUFWCZUHIUIZUGWCZUHZIUIZGUJZVOZUGXTWDZUFLWDZULZUUO
        YAUOZUUOYBUOZUUQUUTUVJUURUUQUUTUVCLVOZUUSUVCXTGUJZVOZULZUFYLWDZUVJUUQUU
        BUUTUVRAUUBUUPWEUUQUFLDEFGHIJKUUOCMNOPUCRSTAYIUUBUUPUAWFAUUHUUBUUPUBWFU
        UCUUPUTAYMUUBUUPUDWFWGWHUUQUVQUVIUFYLLUUQUVBYLUOZUVQULZUVBLUOZUVIULUUQU
        VTULZUWAUVIUWBUWAUVNUUQUVSUVNUVPWIUWBYQLIJDUVBPYTRAYPUUBUUPUVTYSWLZAUUM
        UUBUUPUVTUUNWLUVSUVBJUOZUUQUVQUVBJYCURWJWKWMUWBCXTUOZUVPUVIUWBYPYJUWEUW
        CAYJUUBUUPUVTYNWLIJDCPRWNVAUUQUVSUVNUVPWOUVHUVPUGCXTUVDCUKZUVGUVOUUSUWF
        UVFXTUVCGUWFUVEXSIUVDCWPWQWRWSXBVAWTXCXAXDXEAUVLUVAXLUUBUUPAYQYAIJDUUOP
        YTRYSAYIUUEYAYQUOUAUUKYQDEFHKYANOSYTVTVAXFWFAUVMUVKXLUUBUUPAUVMUURUUSUV
        CUVFBUJZVOZUGXTWDZUFLWDZULUVKAUFUGBYQLXTIJDUUOPYTQRYSUUNUUAXGAUWJUVJUUR
        AUWIUVIUFLAUWAULZUWHUVHUGXTUWKUVDXTUOZULZUWGUVGUUSUWMBDEFGHIJKUVBUVDNOP
        QRSTAYIUWAUWLUAWFUWMUUMUWAUWDAUUMUWAUWLUUNWFAUWAUWLWEYQLJDUVBPYTXHVAUWM
        YRUWLUVDJUOAYRUWAUWLUUAWFUWKUWLUTYQXTJDUVDPYTXHVAXIWSXJXJXKXMWFXNXOAYBY
        AVOUUBABDEGHJKLXTNOPQTUAUUIUUJXPVMXQXR $.
    $}

    dihjat1.q $e |- ( ph -> T e. V ) $.
    $( Subspace sum of a closed subspace and an atom.  ( ~ pmapjat1 analog.)
       (Contributed by NM, 1-Oct-2014.) $)
    dihjat1 $p |- ( ph ->
      ( X .\/ ( N ` { T } ) ) = ( X .(+) ( N ` { T } ) ) ) $=
      ( csn cfv co wceq wa sneq fveq2d clmod wcel dvhlmod eqid lspsn0 sylan9eqr
      c0g syl oveq2d djh01 adantr csubg clss crn dihrnlss syl2anc lsssubg lsm01
      chlt eqtr2d 3eqtrd wne cdif anim1i eldifsn sylibr dihjat1lem pm2.61dane )
      ALCUCZIUDZGUEZLVSBUEZUFCDUPUDZACWBUFZUGZVTLWBUCZGUEZLWAWDVSWELGWCAVSWEIUD
      ZWEWCVRWEICWBUHUIADUJUKZWGWEUFADEHKMNTULZIDWBWBUMZQUNUQUOZURAWFLUFWCADEFG
      HKLWBMNWJRSTUAUSUTWDWALWEBUEZLWDVSWELBWKURAWLLUFZWCALDVAUDUKZWMAWHLDVBUDZ
      UKZWNWIAHVHUKKEUKUGZLFVCUKZWPTUAWODEFHKLMNRWOUMZVDVEWOLDWSVFVEBDLWBWJPVGU
      QUTVIVJACWBVKZUGZBCDEFGHIJKLWBMNOPQRSAWQWTTUTAWRWTUAUTWJXACJUKZWTUGCJWEVL
      UKAXBWTUBVMCJWBVNVOVPVQ $.
  $}

  ${
    dihsmsprn.h $e |- H = ( LHyp ` K ) $.
    dihsmsprn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihsmsprn.v $e |- V = ( Base ` U ) $.
    dihsmsprn.p $e |- .(+) = ( LSSum ` U ) $.
    dihsmsprn.n $e |- N = ( LSpan ` U ) $.
    dihsmsprn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihsmsprn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihsmsprn.x $e |- ( ph -> X e. ran I ) $.
    dihsmsprn.t $e |- ( ph -> T e. V ) $.
    $( Subspace sum of a closed subspace and the span of a singleton.
       (Contributed by NM, 17-Jan-2015.) $)
    dihsmsprn $p |- ( ph -> ( X .(+) ( N ` { T } ) ) e. ran I ) $=
      ( csn cfv cdjh co crn eqid dihjat1 chlt wcel wa wss dihrnss syl2anc clmod
      dvhlmod snssd lspssv djhcl syl12anc eqeltrrd ) AKCUAZHUBZJGUCUBUBZUDZKVBB
      UDFUEZABCDEFVCGHIJKLMNOPQVCUFZRSTUGAGUHUIJEUIUJZKIUKZVBIUKZVDVEUIRAVGKVEU
      IVHRSDEFGIJKLMQNULUMADUNUIVAIUKVIADEGJLMRUOACITUPVAHIDNPUQUMDEFVCGIJKVBLQ
      MNVFURUSUT $.
  $}

  ${
    $d v .\/ $.  $d v .(+) $.  $d v Q $.  $d v U $.  $d v X $.  $d v ph $.
    dihjat2.h $e |- H = ( LHyp ` K ) $.
    dihjat2.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat2.j $e |- .\/ = ( ( joinH ` K ) ` W ) $.
    dihjat2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat2.p $e |- .(+) = ( LSSum ` U ) $.
    dihjat2.a $e |- A = ( LSAtoms ` U ) $.
    dihjat2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat2.x $e |- ( ph -> X e. ran I ) $.
    dihjat2.q $e |- ( ph -> Q e. A ) $.
    $( The subspace sum of a closed subspace and an atom is the same as their
       subspace join.  (Contributed by NM, 1-Oct-2014.) $)
    dihjat2 $p |- ( ph -> ( X .\/ Q ) = ( X .(+) Q ) ) $=
      ( vv cv csn clspn cfv wceq cbs wrex co clmod wcel dvhlmod islsati syl2anc
      eqid wa chlt adantr crn simpr dihjat1 oveq2 adantl 3eqtr4d rexlimdva mpd
      ex ) ADUAUBZUCEUDUEZUEZUFZUAEUGUEZUHZKDHUIZKDCUIZUFZAEUJUKDBUKVMAEFIJLORU
      LTUABDVIVLEUJVLUOZVIUOZQUMUNAVKVPUAVLAVHVLUKZUPZVKVPVTVKUPKVJHUIZKVJCUIZV
      NVOVTWAWBUFVKVTCVHEFGHIVIVLJKLOVQPVRMNAIUQUKJFUKUPVSRURAKGUSUKVSSURAVSUTV
      AURVKVNWAUFVTDVJKHVBVCVKVOWBUFVTDVJKCVBVCVDVGVEVF $.
  $}

  ${
    dihjat3.b $e |- B = ( Base ` K ) $.
    dihjat3.h $e |- H = ( LHyp ` K ) $.
    dihjat3.j $e |- .\/ = ( join ` K ) $.
    dihjat3.a $e |- A = ( Atoms ` K ) $.
    dihjat3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat3.s $e |- .(+) = ( LSSum ` U ) $.
    dihjat3.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat3.x $e |- ( ph -> X e. B ) $.
    dihjat3.p $e |- ( ph -> P e. A ) $.
    $( Isomorphism H of lattice join with an atom.  (Contributed by NM,
       25-Apr-2015.) $)
    dihjat3 $p |- ( ph ->
      ( I ` ( X .\/ P ) ) = ( ( I ` X ) .(+) ( I ` P ) ) ) $=
      ( co cfv cdjh chlt wcel wa wceq atbase syl eqid djhlj syl12anc clsa dihcl
      crn syl2anc dihatlat dihjat2 eqtrd ) ALDIUCHUDZLHUDZDHUDZKJUEUDUDZUCZVCVD
      EUCAJUFUGKGUGUHZLCUGZDCUGZVBVFUITUAADBUGZVIUBBCDJMPUJUKCGHVEIJKLDMONSVEUL
      ZUMUNAFUOUDZEVDFGHVEJKVCNSVKQRVLULZTAVGVHVCHUQUGTUACGHJKLMNSUPURAVGVJVDVL
      UGTUBBDFGHJVLKPNQSVMUSURUTVA $.
  $}

  ${
    dihjat4.j $e |- .\/ = ( join ` K ) $.
    dihjat4.h $e |- H = ( LHyp ` K ) $.
    dihjat4.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat4.s $e |- .(+) = ( LSSum ` U ) $.
    dihjat4.a $e |- A = ( LSAtoms ` U ) $.
    dihjat4.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat4.x $e |- ( ph -> X e. ran I ) $.
    dihjat4.q $e |- ( ph -> Q e. A ) $.
    $( Transfer the subspace sum of a closed subspace and an atom back to
       lattice join.  (Contributed by NM, 25-Apr-2015.) $)
    dihjat4 $p |- ( ph
     -> ( X .(+) Q ) = ( I ` ( ( `' I ` X ) .\/ ( `' I ` Q ) ) ) ) $=
      ( ccnv cfv co catm cbs eqid chlt wa crn dihcnvcl syl2anc dihlatat dihjat3
      wcel wceq dihcnvid2 dih1dimat oveq12d eqtr2d ) AKGUAZUBZDUTUBZHUCGUBVAGUB
      ZVBGUBZCUCKDCUCAIUDUBZIUEUBZVBCEFGHIJVAVFUFZMLVEUFZOPNRAIUGUNJFUNUHZKGUIZ
      UNZVAVFUNRSVFFGIJKVGMNUJUKAVIDBUNZVBVEUNRTVEDEFGIBJVHMONQULUKUMAVCKVDDCAV
      IVKVCKUORSFGIJKMNUPUKAVIDVJUNZVDDUORAVIVLVMRTBDEFGIJMONQUQUKFGIJDMNUPUKUR
      US $.
  $}

  ${
    dihjat6.j $e |- .\/ = ( join ` K ) $.
    dihjat6.h $e |- H = ( LHyp ` K ) $.
    dihjat6.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat6.s $e |- .(+) = ( LSSum ` U ) $.
    dihjat6.a $e |- A = ( LSAtoms ` U ) $.
    dihjat6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat6.x $e |- ( ph -> X e. ran I ) $.
    dihjat6.q $e |- ( ph -> Q e. A ) $.
    $( Transfer the subspace sum of a closed subspace and an atom back to
       lattice join.  (Contributed by NM, 25-Apr-2015.) $)
    dihjat6 $p |- ( ph
     -> ( `' I ` ( X .(+) Q ) ) = ( ( `' I ` X ) .\/ ( `' I ` Q ) ) ) $=
      ( co ccnv cfv dihjat4 fveq2d chlt wcel cbs wceq clat simpld hllat syl crn
      wa eqid dihcnvcl syl2anc dih1dimat latjcl syl3anc dihcnvid1 eqtrd ) AKDCU
      AZGUBZUCKVEUCZDVEUCZHUAZGUCZVEUCZVHAVDVIVEABCDEFGHIJKLMNOPQRSTUDUEAIUFUGZ
      JFUGZUOZVHIUHUCZUGZVJVHUIRAIUJUGZVFVNUGZVGVNUGZVOAVKVPAVKVLRUKIULUMAVMKGU
      NZUGVQRSVNFGIJKVNUPZMNUQURAVMDVSUGZVRRAVMDBUGWARTBDEFGIJMONQUSURVNFGIJDVT
      MNUQURVNHIVFVGVTLUTVAVNFGIJVHVTMNVBURVC $.
  $}

  ${
    dihsmsnrn.h $e |- H = ( LHyp ` K ) $.
    dihsmsnrn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihsmsnrn.v $e |- V = ( Base ` U ) $.
    dihsmsnrn.p $e |- .(+) = ( LSSum ` U ) $.
    dihsmsnrn.n $e |- N = ( LSpan ` U ) $.
    dihsmsnrn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihsmsnrn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihsmsnrn.x $e |- ( ph -> X e. V ) $.
    dihsmsnrn.y $e |- ( ph -> Y e. V ) $.
    $( The subspace sum of two singleton spans is closed.  (Contributed by NM,
       27-Feb-2015.) $)
    dihsmsnrn $p |- ( ph -> ( ( N ` { X } ) .(+) ( N ` { Y } ) ) e. ran I ) $=
      ( csn cfv chlt wcel wa crn dihlsprn syl2anc dihsmsprn ) ABKCDEFGHIJUAGUBZ
      LMNOPQRAFUCUDIDUDUEJHUDUJEUFUDRSCDEFGHIJLMNPQUGUHTUI $.
  $}

  ${
    dihsmatrn.h $e |- H = ( LHyp ` K ) $.
    dihsmatrn.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihsmatrn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihsmatrn.p $e |- .(+) = ( LSSum ` U ) $.
    dihsmatrn.a $e |- A = ( LSAtoms ` U ) $.
    dihsmatrn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihsmatrn.x $e |- ( ph -> X e. ran I ) $.
    dihsmatrn.q $e |- ( ph -> Q e. A ) $.
    $( The subspace sum of a closed subspace and an atom is closed.  TODO: see
       if proof at http://math.stackexchange.com/a/1233211/50776 and Mon, 13
       Apr 2015 20:44:07 -0400 email could be used instead of this and
       ~ dihjat2 .  (Contributed by NM, 15-Jan-2015.) $)
    dihsmatrn $p |- ( ph -> ( X .(+) Q ) e. ran I ) $=
      ( wcel cfv co crn cdjh wceq eqid dihjat2 eqcomd clss cbs chlt wa dihrnlss
      syl2anc dvhlmod lsatlssel djhlsmcl mpbird ) AJDCUAZGUBZSURJDIHUCTTZUAZUDA
      VAURABCDEFGUTHIJKLUTUEZMNOPQRUFUGACEUHTZEFGUTHEUITZIJDKMVDUEVCUEZNLVBPAHU
      JSIFSUKJUSSJVCSPQVCEFGHIJKMLVEULUMABVCDEVEOAEFHIKMPUNRUOUPUQ $.
  $}

  ${
    dihjat5.b $e |- B = ( Base ` K ) $.
    dihjat5.h $e |- H = ( LHyp ` K ) $.
    dihjat5.j $e |- .\/ = ( join ` K ) $.
    dihjat5.a $e |- A = ( Atoms ` K ) $.
    dihjat5.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dihjat5.s $e |- .(+) = ( LSSum ` U ) $.
    dihjat5.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dihjat5.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dihjat5.x $e |- ( ph -> X e. B ) $.
    dihjat5.p $e |- ( ph -> P e. A ) $.
    $( Transfer lattice join with atom to subspace sum.  (Contributed by NM,
       25-Apr-2015.)  (New usage is discouraged.) $)
    dihjat5N $p |- ( ph
         -> ( X .\/ P ) = ( `' I ` ( ( I ` X ) .(+) ( I ` P ) ) ) ) $=
      ( co cfv ccnv wceq dihjat3 chlt wcel crn clsa eqid dihcl syl2anc dihatlat
      wa dihsmatrn dihcnvid2 eqtr4d clat simpld hllat syl atbase latjcl syl3anc
      wb dihcnvcl dih11 mpbid ) ALDIUCZHUDZLHUDZDHUDZEUCZHUEUDZHUDZUFZVKVPUFZAV
      LVOVQABCDEFGHIJKLMNOPQRSTUAUBUGAJUHUIZKGUIZUPZVOHUJZUIZVQVOUFTAFUKUDZEVNF
      GHJKVMNSQRWEULZTAWBLCUIZVMWCUITUACGHJKLMNSUMUNAWBDBUIZVNWEUITUBBDFGHJWEKP
      NQSWFUOUNUQZGHJKVONSURUNUSAWBVKCUIZVPCUIZVRVSVGTAJUTUIZWGDCUIZWJAVTWLAVTW
      ATVAJVBVCUAAWHWMUBBCDJMPVDVCCIJLDMOVEVFAWBWDWKTWICGHJKVOMNSVHUNCGHJKVKVPM
      NSVIVFVJ $.
  $}

  ${
    $d r s A $.  $d r s K $.  $d r s P $.  $d r s Q $.  $d r s R $.
    $d r s .(+) $.  $d r s W $.  $d r s ph $.
    dvh4dimat.h $e |- H = ( LHyp ` K ) $.
    dvh4dimat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    ${
      dvh4dimat.s $e |- .(+) = ( LSSum ` U ) $.
      dvh4dimat.a $e |- A = ( LSAtoms ` U ) $.
      dvh4dimat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
      dvh4dimat.p $e |- ( ph -> P e. A ) $.
      dvh4dimat.q $e |- ( ph -> Q e. A ) $.
      dvh4dimat.r $e |- ( ph -> R e. A ) $.
      $( There is an atom that is outside the subspace sum of 3 others.
         (Contributed by NM, 25-Apr-2015.) $)
      dvh4dimat $p |- ( ph -> E. s e. A -. s C_ ( ( P .(+) Q ) .(+) R ) ) $=
        ( wcel vr cv co wss wn wrex cdih cfv catm ccnv cjn cple wbr chlt simpld
        eqid dihlatat syl2anc 3dim3 syl13anc adantr dih1dimat dihsmatrn dihjat4
        wa crn dihjat6 oveq1d fveq2d eqtrd sseq2d cbs wb atbase adantl clat syl
        hllat hlatjcl latjcl dihord bitr2d notbid rexbidva mpbid dihatlat sylan
        syl3anc wceq dihcnvid2 eqcomd fveq2 eqeq2d rspcev sseq1 rexxfrd mpbird
        ) AKUBZCEDUCZFDUCZUDZUEZKBUFUAUBZJIUGUHUHZUHZWTUDZUEZUAIUIUHZUFZAXCCXDU
        JZUHZEXJUHZIUKUHZUCZFXJUHZXMUCZIULUHZUMZUEZUAXHUFZXIAIUNTZXKXHTZXLXHTZX
        OXHTZXTAYAJHTZPUOZAYAYEVEZCBTZYBPQXHCGHXDIBJXHUPZLMXDUPZOUQURZAYGEBTZYC
        PRXHEGHXDIBJYILMYJOUQURZAYGFBTZYDPSXHFGHXDIBJYILMYJOUQURZXHXKXLXOXMIXQU
        AXMUPZXQUPZYIUSUTAXSXGUAXHAXCXHTZVEZXRXFYSXFXEXPXDUHZUDZXRYSWTYTXEYSWTW
        SXJUHZXOXMUCZXDUHYTYSBDFGHXDXMIJWSYPLYJMNOAYGYRPVAZAWSXDVFZTYRABDEGHXDI
        JCLYJMNOPAYGYHCUUETZPQBCGHXDIJLMYJOVBURZRVCVAAYNYRSVAVDYSUUCXPXDYSUUBXN
        XOXMYSBDEGHXDXMIJCYPLYJMNOUUDAUUFYRUUGVAAYLYRRVAVGVHVIVJVKYSYGXCIVLUHZT
        ZXPUUHTZUUAXRVMUUDYRUUIAXHUUHXCIUUHUPZYIVNVOAUUJYRAIVPTZXNUUHTZXOUUHTZU
        UJAYAUULYFIVRVQAYAYBYCUUMYFYKYMXHUUHXMIXKXLUUKYPYIVSWHAYDUUNYOXHUUHXOIU
        UKYIVNVQUUHXMIXNXOUUKYPVTWHVAUUHHXDIXQJXCXPUUKYQLYJWAWHWBWCWDWEAXBXGKUA
        XEBXHAYGYRXEBTPXHXCGHXDIBJYILMYJOWFWGAWRBTZVEZWRXJUHZXHTZWRUUQXDUHZWIZW
        RXEWIZUAXHUFAYGUUOUURPXHWRGHXDIBJYILMYJOUQWGUUPUUSWRUUPYGWRUUETZUUSWRWI
        AYGUUOPVAAYGUUOUVBPBWRGHXDIJLMYJOVBWGHXDIJWRLYJWJURWKUVAUUTUAUUQXHXCUUQ
        WIXEUUSWRXCUUQXDWLWMWNURUVAXBXGVMAUVAXAXFWRXEWTWOWCVOWPWQ $.
    $}

    ${
      dvh3dimat.s $e |- .(+) = ( LSSum ` U ) $.
      dvh3dimat.a $e |- A = ( LSAtoms ` U ) $.
      dvh3dimat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
      dvh3dimat.p $e |- ( ph -> P e. A ) $.
      dvh3dimat.q $e |- ( ph -> Q e. A ) $.
      $( There is an atom that is outside the subspace sum of 2 others.
         (Contributed by NM, 25-Apr-2015.)  (New usage is discouraged.) $)
      dvh3dimatN $p |- ( ph -> E. s e. A -. s C_ ( P .(+) Q ) ) $=
        ( co wss wcel cv wrex dvh4dimat csubg wceq clmod clss dvhlmod lsatlssel
        cfv eqid lsssubg syl2anc lsmidm syl oveq1d sseq2d notbid rexbidv mpbid
        wn ) AJUAZCCDRZEDRZSZVAZJBUBVBCEDRZSZVAZJBUBABCDCEFGHIJKLMNOPPQUCAVFVIJ
        BAVEVHAVDVGVBAVCCEDACFUDUJTZVCCUEAFUFTCFUGUJZTVJAFGHIKLOUHZABVKCFVKUKZN
        VLPUIVKCFVMULUMDCFMUNUOUPUQURUSUT $.
    $}

    ${
      $d s U $.
      dvh2dimat.a $e |- A = ( LSAtoms ` U ) $.
      dvh2dimat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
      dvh2dimat.p $e |- ( ph -> P e. A ) $.
      $( Given an atom, there exists another.  (Contributed by NM,
         25-Apr-2015.)  (New usage is discouraged.) $)
      dvh2dimatN $p |- ( ph -> E. s e. A s =/= P ) $=
        ( cfv wss wrex eqid wcel wceq adantr cv clsm co wn wne dvh3dimatN wa wb
        csubg clmod dvhlmod lsatlssel lsssubg syl2anc lsmidm syl sseq2d dvhlvec
        clss clvec simpr lsatcmp bitrd necon3bbid rexbidva mpbid ) AHUAZCCDUBNZ
        UCZOZUDZHBPVGCUEZHBPABCVHCDEFGHIJVHQZKLMMUFAVKVLHBAVGBRZUGZVJVGCVOVJVGC
        OZVGCSAVJVPUHVNAVICVGACDUINRZVICSADUJRCDUSNZRVQADEFGIJLUKZABVRCDVRQZKVS
        MULVRCDVTUMUNVHCDVMUOUPUQTVOBVGCDKADUTRVNADEFGIJLURTAVNVAACBRVNMTVBVCVD
        VEVF $.
    $}

    ${
      dvh1dimat.a $e |- A = ( LSAtoms ` U ) $.
      dvh1dimat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
      $( There exists an atom.  (Contributed by NM, 25-Apr-2015.) $)
      dvh1dimat $p |- ( ph -> E. s s e. A ) $=
        ( coc cfv cdih wcel cv wex eqid dihat elex2 syl ) AFELMMZFENMMZMZBOGPBO
        GQABUBCDUCEFHUBRUCRIJKSGUDBTUA $.
    $}
  $}

  ${
    $d p K $.  $d p z N $.  $d p z .0. $.  $d p z U $.  $d p z V $.  $d p W $.
    $d p z X $.  $d p z Y $.  $d p z Z $.  $d p z ph $.
    dvh3dim.h $e |- H = ( LHyp ` K ) $.
    dvh3dim.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dvh3dim.v $e |- V = ( Base ` U ) $.
    ${
      dvh1dim.o $e |- .0. = ( 0g ` U ) $.
      dvh1dim.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
      $( There exists a nonzero vector.  (Contributed by NM, 26-Apr-2015.) $)
      dvh1dim $p |- ( ph -> E. z e. V z =/= .0. ) $=
        ( vp cv clsa cfv wcel wne wrex eqid dvh1dimat wa clmod dvhlmod lsateln0
        adantr simpr wel lsatssv sseld anim1d reximdv2 mpd exlimddv ) ANOZCPQZR
        ZBOZHSZBFTZNAUQCDEGNIJUQUAZMUBAURUCZUTBUPTVAVCBUQUPCHLVBACUDRURACDEGIJM
        UEUGZAURUHZUFVCUTUTBUPFVCBNUIUSFRUTVCUPFUSVCUQUPFCKVBVDVEUJUKULUMUNUO
        $.
    $}

    dvh3dim.n $e |- N = ( LSpan ` U ) $.
    dvh3dim.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dvh3dim.x $e |- ( ph -> X e. V ) $.
    ${
      dvh4dim.y $e |- ( ph -> Y e. V ) $.
      dvhdim.z $e |- ( ph -> Z e. V ) $.
      dvh4dim.o $e |- .0. = ( 0g ` U ) $.
      dvh4dim.x $e |- ( ph -> X =/= .0. ) $.
      dvh4dimlem.y $e |- ( ph -> Y =/= .0. ) $.
      dvh4dimlem.z $e |- ( ph -> Z =/= .0. ) $.
      $( Lemma for ~ dvh4dimN .  (Contributed by NM, 22-May-2015.) $)
      dvh4dimlem $p |- ( ph -> E. z e. V -. z e. ( N ` { X , Y , Z } ) ) $=
        ( vp cv csn cfv clsm co wss wn clsa wrex ctp wcel eqid dvhlmod wne cdif
        eldifsn sylanbrc lsatlspsn dvh4dimat w3a clmod 3ad2ant1 islsati syl2anc
        simp2 wi cpr cun lsmpr oveq1d prssi snssd lsmsp2 syl3anc eqtr3d sseq12d
        wceq clss unssd lspcl simp3 lspsnel5 bitr4d df-tp fveq2i eleq2i syl6bbr
        notbid biimpd 3exp com24 a1d 3imp reximdvai mpd rexlimdv3a ) AUEUFZIUGF
        UHZJUGFUHZCUIUHZUJZLUGZFUHZXEUJZUKZULZUECUMUHZUNBUFZIJLUOZFUHZUPZULZBGU
        NZAXLXCXEXDXHCDEHUEMNXEUQZXLUQZQAXLFGCIKOPUAXTACDEHMNQURZAIGUPZIKUSIGKU
        GUTZUPRUBIGKVAVBVCAXLFGCJKOPUAXTYAAJGUPZJKUSJYCUPSUCJGKVAVBVCAXLFGCLKOP
        UAXTYAALGUPLKUSLYCUPTUDLGKVAVBVCVDAXKXRUEXLAXBXLUPZXKVEZXBXMUGFUHZWBZBG
        UNZXRYFCVFUPZYEYIAYEYJXKYAVGAYEXKVJBXLXBFGCVFOPXTVHVIYFYHXQBGAYEXKXMGUP
        ZYHXQVKVKZAXKYLVKYEAYHYKXKXQAYHYKXKXQVKAYHYKVEZXKXQYMXJXPYMXJXMIJVLZXGV
        MZFUHZUPZXPYMXJYGYPUKYQYMXBYGXIYPAYHYKVJYMYNFUHZXHXEUJZXIYPYMYRXFXHXEYM
        XEFGCIJOPXSAYHYJYKYAVGZAYHYBYKRVGAYHYDYKSVGVNVOYMYJYNGUKZXGGUKZYSYPWBYT
        AYHUUAYKAYBYDUUARSIJGVPVIZVGAYHUUBYKALGTVQZVGXEYNXGFGCOPXSVRVSVTWAYMCWC
        UHZYPFGCXMOUUEUQZPYTAYHYPUUEUPZYKAYJYOGUKUUGYAAYNXGGUUCUUDWDUUEYOFGCOUU
        FPWEVIVGAYHYKWFWGWHXOYPXMXNYOFIJLWIWJWKWLWMWNWOWPWQWRWSWTXAWT $.
    $}

    ${
      dvhdim.y $e |- ( ph -> Y e. V ) $.
      dvhdim.o $e |- .0. = ( 0g ` U ) $.
      dvhdim.x $e |- ( ph -> X =/= .0. ) $.
      dvhdimlem.y $e |- ( ph -> Y =/= .0. ) $.
      $( Lemma for ~ dvh2dim and ~ dvh3dim .  TODO: make this obsolete and use
         ~ dvh4dimlem directly?  (Contributed by NM, 24-Apr-2015.) $)
      dvhdimlem $p |- ( ph -> E. z e. V -. z e. ( N ` { X , Y } ) ) $=
        ( cv ctp cfv wcel wrex cpr dvh4dimlem clmod wss dvhlmod csn df-tp prssi
        wn cun syl2anc snssd unssd syl5eqss ssun1 sseqtr4i lspss syl3anc ssneld
        a1i reximdv mpd ) ABUBZIJJUCZFUDZUEUOZBGUFVIIJUGZFUDZUEUOZBGUFABCDEFGHI
        JKJLMNOPQRRSTUAUAUHAVLVOBGAVNVKVIACUIUEVJGUJVMVJUJZVNVKUJACDEHLMPUKAVJV
        MJULZUPZGIJJUMZAVMVQGAIGUEJGUEVMGUJQRIJGUNUQAJGRURUSUTVPAVMVRVJVMVQVAVS
        VBVFVMVJFGCNOVCVDVEVGVH $.
    $}

    $( There is a vector that is outside the span of another.  (Contributed by
       NM, 25-Apr-2015.) $)
    dvh2dim $p |- ( ph -> E. z e. V -. z e. ( N ` { X } ) ) $=
      ( cfv wcel wrex wceq adantr cv csn wn c0g wa wne eqid dvh1dim simpr sneqd
      fveq2d clmod dvhlmod lspsn0 eqtrd eleq2d syl6bb necon3bbid rexbidv mpbird
      syl elsn cpr chlt dvhdimlem fveq2i eleq2i notbii rexbii sylibr pm2.61dane
      dfsn2 ) ABUAZIUBZFPZQZUCZBGRZICUDPZAIVSSZUEZVRVMVSUFZBGRZAWCVTABCDEGHVSJK
      LVSUGZNUHTWAVQWBBGWAVPVMVSWAVPVMVSUBZQVMVSSWAVOWEVMWAVOWEFPZWEWAVNWEFWAIV
      SAVTUIUJUKAWFWESZVTACULQWGACDEHJKNUMFCVSWDMUNVATUOUPBVSVBUQURUSUTAIVSUFZU
      EZVMIIVCZFPZQZUCZBGRVRWIBCDEFGHIIVSJKLMAEVDQHDQUEWHNTAIGQWHOTZWNWDAWHUIZW
      OVEVQWMBGVPWLVOWKVMVNWJFIVLVFVGVHVIVJVK $.

    dvh3dim.y $e |- ( ph -> Y e. V ) $.
    $( There is a vector that is outside the span of 2 others.  (Contributed by
       NM, 24-Apr-2015.) $)
    dvh3dim $p |- ( ph -> E. z e. V -. z e. ( N ` { X , Y } ) ) $=
      ( cfv wcel wa cv cpr wrex c0g wceq csn dvh2dim adantr prcom syl5eq fveq2d
      preq2 eqid dvhlmod lsppr0 sylan9eqr eleq2d notbid rexbidv mpbird wne chlt
      wn simprl simprr dvhdimlem pm2.61da2ne ) ABUAZIJUBZFRZSZVCZBGUCZICUDRZJVN
      AIVNUEZTZVMVHJUFFRZSZVCZBGUCZAVTVOABCDEFGHJKLMNOQUGUHVPVLVSBGVPVKVRVPVJVQ
      VHVOAVJJVNUBZFRVQVOVIWAFVOVIJIUBWAIJUIIVNJULUJUKAFGCJVNMVNUMZNACDEHKLOUNZ
      QUOUPUQURUSUTAJVNUEZTZVMVHIUFFRZSZVCZBGUCZAWIWDABCDEFGHIKLMNOPUGUHWEVLWHB
      GWEVKWGWEVJWFVHWDAVJIVNUBZFRWFWDVIWJFJVNIULUKAFGCIVNMWBNWCPUOUPUQURUSUTAI
      VNVAZJVNVAZTZTBCDEFGHIJVNKLMNAEVBSHDSTWMOUHAIGSWMPUHAJGSWMQUHWBAWKWLVDAWK
      WLVEVFVG $.

    dvh3dim2.z $e |- ( ph -> Z e. V ) $.
    $( There is a vector that is outside the span of 3 others.  (Contributed by
       NM, 22-May-2015.)  (New usage is discouraged.) $)
    dvh4dimN $p |- ( ph -> E. z e. V -. z e. ( N ` { X , Y , Z } ) ) $=
      ( wcel cv ctp cfv wn wrex c0g wceq wa cpr dvh3dim adantr csn eqid dvhlmod
      cun wss prssi syl2anc lspun0 tpeq1 tprot eqtr2i syl6reqr fveq2d sylan9req
      df-tp eleq2d notbid rexbidv mpbid tpeq2 tpcomb tpeq3 syl6req wne w3a chlt
      eqtr3i simpr1 simpr2 simpr3 dvh4dimlem pm2.61da3ne ) ABUAZIJKUBZFUCZTZUDZ
      BGUEZICUFUCZJWJKWJAIWJUGZUHZWDJKUIZFUCZTZUDZBGUEZWIAWQWKABCDEFGHJKLMNOPRS
      UJUKWLWPWHBGWLWOWGWLWNWFWDAWKWNWMWJULZUOZFUCWFAFGCWMWJNWJUMZOACDEHLMPUNZA
      JGTZKGTZWMGUPRSJKGUQURUSWKWSWEFWKWEWJJKUBZWSIWJJKUTXDJKWJUBWSWJJKVAJKWJVF
      VBVCVDVEVGVHVIVJAJWJUGZUHZWDIKUIZFUCZTZUDZBGUEZWIAXKXEABCDEFGHIKLMNOPQSUJ
      UKXFXJWHBGXFXIWGXFXHWFWDAXEXHXGWRUOZFUCWFAFGCXGWJNWTOXAAIGTZXCXGGUPQSIKGU
      QURUSXEXLWEFXEWEIWJKUBZXLJWJIKVKIKWJUBXLXNIKWJVFIKWJVLVRVCVDVEVGVHVIVJAKW
      JUGZUHZWDIJUIZFUCZTZUDZBGUEZWIAYAXOABCDEFGHIJLMNOPQRUJUKXPXTWHBGXPXSWGXPX
      RWFWDAXOXRXQWRUOZFUCWFAFGCXQWJNWTOXAAXMXBXQGUPQRIJGUQURUSXOYBWEFXOWEIJWJU
      BYBKWJIJVMIJWJVFVNVDVEVGVHVIVJAIWJVOZJWJVOZKWJVOZVPZUHBCDEFGHIJWJKLMNOAEV
      QTHDTUHYFPUKAXMYFQUKAXBYFRUKAXCYFSUKWTAYCYDYEVSAYCYDYEVTAYCYDYEWAWBWC $.

    $d w N $.  $d w U $.  $d w V $.  $d w X $.  $d w Y $.  $d w Z $.  $d z Z $.
    $d w ph $.  $d z w $.
    $( There is a vector that is outside of 2 spans with a common vector.
       (Contributed by NM, 13-May-2015.) $)
    dvh3dim2 $p |- ( ph -> E. z e. V ( -. z e. ( N ` { X , Y } )
        /\ -. z e. ( N ` { X , Z } ) ) ) $=
      ( wcel vw cpr cfv cv wn wa wrex dvh3dim adantr clss eqid dvhlmod ad2antrr
      clmod lspprcl lspprid1 simplr lspprss ssneld ancrd reximdva mpd cplusg co
      w3a simpl1l syl simpl2 lmodvacl syl3anc lspprid2 simpl3 lssvancl2 simpl1r
      simpr lssvancl1 eleq1 notbid anbi12d rspcev syl12anc pm2.61dan rexlimdv3a
      wceq weq ) AJIKUBFUCZTZBUDZIJUBFUCZTZUEZWHWFTZUEZUFZBGUGZAWGUFZWMBGUGZWOA
      WQWGABCDEFGHIKLMNOPQSUHUIWPWMWNBGWPWHGTZUFZWMWKWSWIWFWHWSCUJUCZWFFCIJWTUK
      ZOACUNTZWGWRACDEHLMPULZUMAWFWTTZWGWRAWTFGCIKNXAOXCQSUOZUMAIWFTWGWRAFGCIKN
      OXCQSUPUMAWGWRUQURUSUTVAVBAWGUEZUFZUAUDZWITZUEZUAGUGZWOAXKXFAUACDEFGHIJLM
      NOPQRUHUIXGXJWOUAGXGXHGTZXJVEZXHWFTZWOXMXNUFZXHJCVCUCZVDZGTZXQWITZUEZXQWF
      TZUEZWOXOXBXLJGTZXRXOAXBAXFXLXJXNVFZXCVGZXGXLXJXNVHZXOAYCYDRVGZXPGCXHJNXP
      UKZVIVJXOXPWTWIGCJXHNYHXAYEXOAWIWTTYDAWTFGCIJNXAOXCQRUOVGXOAJWITYDAFGCIJN
      OXCQRVKVGYFXGXLXJXNVLVMXOXPWTWFGCXHJNYHXAYEXOAXDYDXEVGXMXNVOYGAXFXLXJXNVN
      VPWNXTYBUFBXQGWHXQWDZWKXTWMYBYIWJXSWHXQWIVQVRYIWLYAWHXQWFVQVRVSVTWAXMXNUE
      ZUFXLXJYJWOXGXLXJYJVHXGXLXJYJVLXMYJVOWNXJYJUFBXHGBUAWEZWKXJWMYJYKWJXIWHXH
      WIVQVRYKWLXNWHXHWFVQVRVSVTWAWBWCVBWB $.


    $d w T $.  $d z T $.
    dvh3dim3.t $e |- ( ph -> T e. V ) $.
    $( There is a vector that is outside of 2 spans.  TODO: decide to use
       either this or ~ dvh3dim2 everywhere.  If this one is needed, make
       ~ dvh3dim2 into a lemma.  (Contributed by NM, 21-May-2015.)
       (New usage is discouraged.) $)
    dvh3dim3N $p |- ( ph -> E. z e. V ( -. z e. ( N ` { X , Y } )
        /\ -. z e. ( N ` { Z , T } ) ) ) $=
      ( vw cpr cfv wcel cv wn wa wrex wpss wceq wo wss clss eqid dvhlmod adantr
      clmod lspprcl simpr lspprid2 lspprss sspss sylib clvec dvhlvec lspprat wi
      csn w3a chlt 3ad2ant1 simp2 dvh3dim2 clsm csubg lsssssubg lspsncl syl2anc
      syl sseldd prssi snsspr1 lspss syl3anc simp3 sseqtrd lsmless2 lsmpr prcom
      co a1i fveq2i syl5eq 3sstr4d ssneld snsspr2 anim12d reximdv rexlimdv3a wb
      mpd eleq2i notbii eleq2 notbid anbi12d rexbidv mpbid jaodan syldan cplusg
      simpl1l simpl2 lmodvacl simpl3l sylnib lssvancl2 simpl1r lssvancl1 rspcev
      eleq1 syl12anc pm2.61dan ) AKLCUCGUDZUEZBUFZJKUCZGUDZUEZUGZYGYEUEZUGZUHZB
      HUIZAYFKCUCZGUDZYEUJZYQYEUKZULZYOAYFUHZYQYEUMYTUUADUNUDZYEGDKCUUBUOZPADUR
      UEZYFADEFIMNQUPZUQAYEUUBUEZYFAUUBGHDLCOUUCPUUETUAUSZUQAYFUTACYEUEYFAGHDLC
      OPUUETUAVAUQVBYQYEVCVDAYRYOYSAYRUHZYQUBUFZVIGUDZUKZUBHUIZYOUUHUBUUBYQGHDL
      COUUCPADVEUEYRADEFIMNQVFUQAYQUUBUEYRAUUBGHDKCOUUCPUUESUAUSUQALHUEZYRTUQAC
      HUEZYRUAUQAYRUTVGAUULYOVHYRAUUKYOUBHAUUIHUEZUUKVJZYGUUIJUCZGUDZUEUGZYGUUI
      LUCZGUDZUEUGZUHZBHUIYOUUPBDEFGHIUUIJLMNOPAUUOFVKUEIEUEUHUUKQVLAUUOUUKVMZA
      UUOJHUEZUUKRVLZAUUOUUMUUKTVLZVNUUPUVCYNBHUUPUUSYKUVBYMUUPYIUURYGUUPJVIGUD
      ZKVIZGUDZDVOUDZWKZUVHUUJUVKWKZYIUURUUPUVHDVPUDZUEUUJUVNUEZUVJUUJUMUVLUVMU
      MUUPUUBUVNUVHUUPUUDUUBUVNUMAUUOUUDUUKUUEVLZUUBDUUCVQVTZAUUOUVHUUBUEZUUKAU
      UDUVEUVRUUERUUBGHDJOUUCPVRVSVLWAUUPUUBUVNUUJUVQUUPUUDUUOUUJUUBUEUVPUVDUUB
      GHDUUIOUUCPVRVSWAZUUPUVJYQUUJAUUOUVJYQUMZUUKAUUDYPHUMZUVIYPUMZUVTUUEAKHUE
      ZUUNUWASUAKCHWBVSZUWBAKCWCWLUVIYPGHDOPWDWEVLAUUOUUKWFZWGUVKUVHUVJUUJDUVKU
      OZWHWEAUUOYIUVLUKUUKAUVKGHDJKOPUWFUUERSWIVLUUPUURJUUIUCZGUDUVMUUQUWGGUUIJ
      WJWMUUPUVKGHDJUUIOPUWFUVPUVFUVDWIWNWOWPUUPYEUVAYGUUPLVIGUDZCVIZGUDZUVKWKZ
      UWHUUJUVKWKZYEUVAUUPUWHUVNUEUVOUWJUUJUMUWKUWLUMUUPUUBUVNUWHUVQAUUOUWHUUBU
      EZUUKAUUDUUMUWMUUETUUBGHDLOUUCPVRVSVLWAUVSUUPUWJYQUUJAUUOUWJYQUMZUUKAUUDU
      WAUWIYPUMZUWNUUEUWDUWOAKCWQWLUWIYPGHDOPWDWEVLUWEWGUVKUWHUWJUUJDUWFWHWEAUU
      OYEUWKUKUUKAUVKGHDLCOPUWFUUETUAWIVLUUPUVALUUIUCZGUDUWLUUTUWPGUUILWJWMUUPU
      VKGHDLUUIOPUWFUVPUVGUVDWIWNWOWPWRWSXBWTUQXBAYSUHZYGKJUCZGUDZUEZUGZYGYQUEZ
      UGZUHZBHUIZYOAUXEYSABDEFGHIKJCMNOPQSRUAVNUQUWQUXDYNBHUWQYSUXDYNXAAYSUTYSU
      XAYKUXCYMUXAYKXAYSUWTYJUWSYIYGUWRYHGKJWJWMZXCXDWLYSUXBYLYQYEYGXEXFXGVTXHX
      IXJXKAYFUGZUHZUUIUWSUEZUGZUUIYQUEUGZUHZUBHUIZYOAUXMUXGAUBDEFGHIKJCMNOPQSR
      UAVNUQUXHUXLYOUBHUXHUUOUXLVJZUUIYEUEZYOUXNUXOUHZUUIKDXLUDZWKZHUEZUXRYIUEZ
      UGZUXRYEUEZUGZYOUXPUUDUUOUWCUXSUXPAUUDAUXGUUOUXLUXOXMZUUEVTZUXHUUOUXLUXOX
      NZUXPAUWCUYDSVTZUXQHDUUIKOUXQUOZXOWEUXPUXQUUBYIHDKUUIOUYHUUCUYEUXPAYIUUBU
      EUYDAUUBGHDJKOUUCPUUERSUSVTUXPAKYIUEUYDAGHDJKOPUUERSVAVTUYFUXPUXIUUIYIUEZ
      UXJUXKUXHUUOUXOXPUWSYIUUIUXFXCZXQXRUXPUXQUUBYEHDUUIKOUYHUUCUYEUXPAUUFUYDU
      UGVTUXNUXOUTUYGAUXGUUOUXLUXOXSXTYNUYAUYCUHBUXRHYGUXRUKZYKUYAYMUYCUYKYJUXT
      YGUXRYIYBXFUYKYLUYBYGUXRYEYBXFXGYAYCUXNUXOUGZUHZUUOUYIUGZUYLYOUXHUUOUXLUY
      LXNUYMUXIUYIUXJUXKUXHUUOUYLXPUYJXQUXNUYLUTYNUYNUYLUHBUUIHYGUUIUKZYKUYNYMU
      YLUYOYJUYIYGUUIYIYBXFUYOYLUXOYGUUIYEYBXFXGYAYCYDWTXBYD $.
  $}

  ${
    $d y U $.  $d y V $.  $d y X $.  $d y ph $.
    dochsnnz.h $e |- H = ( LHyp ` K ) $.
    dochsnnz.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsnnz.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsnnz.v $e |- V = ( Base ` U ) $.
    dochsnnz.z $e |- .0. = ( 0g ` U ) $.
    dochsnnz.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsnnz.x $e |- ( ph -> X e. V ) $.
    $( The orthocomplement of a singleton is nonzero.  (Contributed by NM,
       13-Jun-2015.) $)
    dochsnnz $p |- ( ph -> ( ._|_ ` { X } ) =/= { .0. } ) $=
      ( vy csn cfv wne clspn eqid dochocsn cv wcel wn dvh2dim biimprcd necon3bd
      wrex wceq eleq2 rexlimiv syl eqnetrd snssd dochn0nv mpbird ) AHRZESZIRTUT
      ESZFTAVAUSBUASZSZFABCDVBEFGHJLKMVBUBZOPUCAQUDZVCUEZUFZQFUJVCFTZAQBCDVBFGH
      JLMVDOPUGVGVHQFVEFUEZVFVCFVCFUKVFVIVCFVEULUHUIUMUNUOABCDEFGUSIJKLMNOAHFPU
      PUQUR $.
  $}

  ${
    $d v ._|_ $.  $d v Q $.  $d v U $.  $d v ph $.
    dochsatshp.h $e |- H = ( LHyp ` K ) $.
    dochsatshp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsatshp.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsatshp.a $e |- A = ( LSAtoms ` U ) $.
    dochsatshp.y $e |- Y = ( LSHyp ` U ) $.
    dochsatshp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsatshp.q $e |- ( ph -> Q e. A ) $.
    $( The orthocomplement of a subspace atom is a hyperplane.  (Contributed by
       NM, 27-Jul-2014.)  (Revised by Mario Carneiro, 1-Oct-2014.) $)
    dochsatshp $p |- ( ph -> ( ._|_ ` Q ) e. Y ) $=
      ( cfv wcel wceq eqid vv clss cbs wne cv csn cun clspn wrex wa wss dvhlmod
      chlt lsatssv dochlss syl2anc c0g lsatn0 doch0 syl eqeq2d dih1dimat dih0rn
      cdih crn doch11 bitr3d necon3bid mpbird cdif clmod wb islsat mpbid eldifi
      wi adantr a1i lspid uneq1d fveq2d lssss snssd lspun syl3anc uneq2 3eqtr4d
      adantl cdjh co clsm dochcl djhcom lsatlssel lsmsp 3eqtr3rd djhexmid eqtrd
      dihjat2 ex jcad reximdv2 mpd clvec w3a dvhlvec islshp mpbir3and ) ACGQZIR
      ZXIDUBQZRZXIDUCQZUDZXIUAUEZUFZUGDUHQZQZXMSZUAXMUIZAFUMRHERUJZCXMUKZXLOABC
      XMDXMTZMADEFHJKOULZPUNZXKDEFGXMHCJKYCXKTZLUOUPZAXNCDUQQZUFZUDABCDYHYHTZMY
      DPURAXIXMCYIAXIYIGQZSXIXMSCYISAYKXMXIAYAYKXMSODEFGXMHYHJKLYCYJUSUTVAAEHFV
      DQQZFGHCYIJYLTZLOAYACBRZCYLVEZROPBCDEYLFHJKYMMVBUPAYAYIYORODEYLFHYHJYMKYJ
      VCUTVFVGVHVIACXPXQQZSZUAXMYIVJZUIZXTAYNYSPADVKRZYNYSVLYDUABCXQXMDVKYHYCXQ
      TZYJMVMUTVNAYQXSUAYRXMAXOYRRZYQUJZXOXMRZXSUUCUUDVPAUUBUUDYQXOXMYIVOZVQVRA
      UUCXSAUUCUJZXRXICUGZXQQZXMUUFXIXQQZYPUGZXQQZXIYPUGZXQQZXRUUHAUUKUUMSUUCAU
      UJUULXQAUUIXIYPAYTXLUUIXISYDYGXKXIXQDYFUUAVSUPVTWAVQUUFYTXIXMUKZXPXMUKZXR
      UUKSAYTUUCYDVQAUUNUUCAXLUUNYGXKXIXMDYCYFWBUTZVQUUCUUOAUUBUUOYQUUBXOXMUUEW
      CVQWHXIXPXQXMDYCUUAWDWEUUCUUHUUMSZAYQUUQUUBYQUUGUULXQCYPXIWFWAWHWHWGAUUHX
      MSUUCAUUHCXIHFWIQQZWJZXMAXICUURWJXICDWKQZWJZUUSUUHABUUTCDEYLUURFHXIJYMUUR
      TZKUUTTZMOAYAYBXIYOROYEDEYLFGXMHCJYMKYCLWLUPPWSADEUURFXMHXICJKYCUVBOUUPYE
      WMAYTXLCXKRUVAUUHSYDYGABXKCDYFMYDPWNUUTXKXICXQDYFUUAUVCWOWEWPAYAYBUUSXMSO
      YEDEUURFGXMHCJKYCLUVBWQUPWRVQWRWTXAXBXCADXDRXJXLXNXTXEVLADEFHJKOXFUAXKXII
      XQXMDXDYCUUAYFNXGUTXH $.
  $}

  ${
    $d v A $.  $d v ._|_ $.  $d v Q $.  $d v U $.  $d v Y $.  $d v ph $.
    dochsatshpb.h $e |- H = ( LHyp ` K ) $.
    dochsatshpb.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsatshpb.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsatshpb.s $e |- S = ( LSubSp ` U ) $.
    dochsatshpb.a $e |- A = ( LSAtoms ` U ) $.
    dochsatshpb.y $e |- Y = ( LSHyp ` U ) $.
    dochsatshpb.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsatshpb.q $e |- ( ph -> Q e. S ) $.
    $( The orthocomplement of a subspace atom is a hyperplane.  (Contributed by
       NM, 29-Oct-2014.) $)
    dochsatshpb $p |- ( ph -> ( Q e. A <-> ( ._|_ ` Q ) e. Y ) ) $=
      ( wcel cfv vv chlt adantr simpr dochsatshp c0g wne wrex csn cbs wceq cdih
      wa cv crn wss eqid lssss syl dochcl syl2anc dochoc dvhlmod lshpne eqnetrd
      clmod wb dochssv dochn0nv mpbird dochlss lssne0 mpbid w3a clspn lspsnel5a
      3ad2ant1 simp2 lssel dihlsprn dochord eqsstr3d clvec dvhlvec simp1r simp3
      lsatlspsn2 syl3anc lshpcmp fveq2d eqeltrd rexlimdv3a mpd dochsat impbida
      eqtrd ) ACBSZCHTZJSZAWQUMBCEFGHIJKMLOPAGUBSIFSUMZWQQUCAWQUDUEAWSUMZWRHTZB
      SZWQXAUAUNZEUFTZUGZUAXBUHZXCXAXBXEUIUGZXGXAXHXBHTZEUJTZUGZXAXIWRXJAXIWRUK
      ZWSAWTWRIGULTTZUOZSZXLQAWTCXJUPZXOQACDSZXPRDCXJEXJUQZNURUSZEFXMGHXJICKXMU
      QZMXRLUTVAZFXMGHIWRKXTLVBZVAUCXAWRJXJEXRPAEVFSZWSAEFGIKMQVCUCZAWSUDVDVEAX
      HXKVGWSAEFGHXJIWRXEKLMXRXEUQZQAWTXPWRXJUPZQXSEFGHXJICKMXRLVHVAVIUCVJXAXBD
      SZXHXGVGAYGWSAWTYFYGQAWRDSZYFAWTXPYHQXSDEFGHXJICKMXRNLVKVADWRXJEXRNURUSZD
      EFGHXJIWRKMXRNLVKVAUCZUADEXBXEYENVLUSVMXAXFXCUAXBXAXDXBSZXFVNZXBXDUIEVOTZ
      TZBYLXBYNHTZHTZYNYLWRYOHYLWRYOUPWRYOUKYLWRXIYOYLWTXOXLXAYKWTXFAWTWSQUCZVQ
      ZXAYKXOXFAXOWSYAUCVQYBVAYLYNXBUPXIYOUPYLDXBYMEXDNYMUQZXAYKYCXFYDVQZXAYKYG
      XFYJVQZXAYKXFVRZVPYLFXMGHIYNXBKXTLYRYLWTXDXJSZYNXNSZYRYLYGYKUUCUUAUUBDXBX
      JEXDXRNVSVAZEFXMGYMXJIXDKMXRYSXTVTVAZXAYKXBXNSZXFAUUGWSAWTYFUUGQYIEFXMGHX
      JIWRKXTMXRLUTVAUCVQWAVMWBYLWRYOJEPXAYKEWCSZXFAUUHWSAEFGIKMQWDUCVQAWSYKXFW
      EYLBYNEFGHIJKMLOPYRYLYCUUCXFYNBSYTUUEXAYKXFWFBYMXJEXDXEXRYSYEOWGWHZUEWIVM
      WJYLWTUUDYPYNUKYRUUFFXMGHIYNKXTLVBVAWPUUIWKWLWMXABCDEFGHIKLMNOYQAXQWSRUCW
      NVMWO $.
  $}

  ${
    dochsnshp.h $e |- H = ( LHyp ` K ) $.
    dochsnshp.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsnshp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsnshp.v $e |- V = ( Base ` U ) $.
    dochsnshp.z $e |- .0. = ( 0g ` U ) $.
    dochsnshp.y $e |- Y = ( LSHyp ` U ) $.
    dochsnshp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsnshp.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( The orthocomplement of a nonzero singleton is a hyperplane.
       (Contributed by NM, 3-Jan-2015.) $)
    dochsnshp $p |- ( ph -> ( ._|_ ` { X } ) e. Y ) $=
      ( csn cfv clspn eqid eldifad snssd dochocsp lsatlspsn dochsatshp eqeltrrd
      clsa dvhlmod ) AHSZBUATZTZETUKETIABCDULEFGUKKMLNULUBZQAHFAHFJSRUCUDUEABUI
      TZUMBCDEGIKMLUOUBZPQAUOULFBHJNUNOUPABCDGKMQUJRUFUGUH $.
  $}

  ${
    dochshpsat.h $e |- H = ( LHyp ` K ) $.
    dochshpsat.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochshpsat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochshpsat.a $e |- A = ( LSAtoms ` U ) $.
    dochshpsat.y $e |- Y = ( LSHyp ` U ) $.
    dochshpsat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochshpsat.x $e |- ( ph -> X e. Y ) $.
    $( A hyperplane is closed iff its orthocomplement is an atom.  (Contributed
       by NM, 29-Oct-2014.) $)
    dochshpsat $p |- ( ph
         -> ( ( ._|_ ` ( ._|_ ` X ) ) = X <-> ( ._|_ ` X ) e. A ) ) $=
      ( cfv wceq wcel adantr wa simpr eqeltrd wb clss eqid chlt cbs wss dvhlmod
      lshplss lssss syl dochlss syl2anc dochsatshpb mpbird c0g csn clmod lsatn0
      wn neneqd doch0 eqeq2d cdih dochcl dih0rn doch11 bitr3d mtbird dochshpncl
      crn necon1bbid mpbid impbida ) AHFQZFQZHRZVQBSZAVSUAZVTVRISZWAVRHIAVSUBAH
      ISVSPTUCAVTWBUDVSABVQCUEQZCDEFGIJKLWCUFZMNOAEUGSGDSUAZHCUHQZUIZVQWCSOAHWC
      SWGAWCHICWDNACDEGJLOUJZPUKWCHWFCWFUFZWDULUMZWCCDEFWFGHJLWIWDKUNUOUPTUQAVT
      UAZVRWFRZVBZVSWKWLVQCURQZUSZRZWKVQWOWKBVQCWNWNUFZMACUTSVTWHTAVTUBVAVCWKVR
      WOFQZRZWLWPWKWRWFVRWKWEWRWFRAWEVTOTCDEFWFGWNJLKWIWQVDUMVEAWSWPUDVTADGEVFQ
      QZEFGVQWOJWTUFZKOAWEWGVQWTVMZSOWJCDWTEFWFGHJXALWIKVGUOAWEWOXBSOCDWTEGWNJX
      ALWQVHUMVITVJVKAWMVSUDVTAWLVRHACDEFWFGHIJKLWINOPVLVNTVOVP $.
  $}

  ${
    dochkrsat.h $e |- H = ( LHyp ` K ) $.
    dochkrsat.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkrsat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkrsat.a $e |- A = ( LSAtoms ` U ) $.
    dochkrsat.f $e |- F = ( LFnl ` U ) $.
    dochkrsat.l $e |- L = ( LKer ` U ) $.
    dochkrsat.z $e |- .0. = ( 0g ` U ) $.
    dochkrsat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkrsat.g $e |- ( ph -> G e. F ) $.
    $( The orthocomplement of a kernel is an atom iff it is nonzero.
       (Contributed by NM, 1-Nov-2014.) $)
    dochkrsat $p |- ( ph
     -> ( ( ._|_ ` ( L ` G ) ) =/= { .0. } <-> ( ._|_ ` ( L ` G ) ) e. A ) ) $=
      ( cfv cbs wne clsh wcel csn eqid dochkrshp dvhlmod dochn0nv clss chlt wss
      lkrssv wa dochlss syl2anc dochsatshpb 3bitr4d ) AEHUAZIUAZIUAZCUBUAZUCVBC
      UDUAZUEVAKUFUCVABUEACDEFGHIVCJVDLMNVCUGZVDUGZPQSTUHACFGIVCJUTKLMNVERSADEH
      VCCVEPQACFGJLNSUITUNZUJABVACUKUAZCFGIJVDLMNVHUGZOVFSAGULUEJFUEUOUTVCUMVAV
      HUESVGVHCFGIVCJUTLNVEVIMUPUQURUS $.
  $}

  ${
    dochkrsat2.h $e |- H = ( LHyp ` K ) $.
    dochkrsat2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkrsat2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkrsat2.v $e |- V = ( Base ` U ) $.
    dochkrsat2.a $e |- A = ( LSAtoms ` U ) $.
    dochkrsat2.f $e |- F = ( LFnl ` U ) $.
    dochkrsat2.l $e |- L = ( LKer ` U ) $.
    dochkrsat2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkrsat2.g $e |- ( ph -> G e. F ) $.
    $( The orthocomplement of a kernel is an atom iff the double
       orthocomplement is not the vector space.  (Contributed by NM,
       1-Jan-2015.) $)
    dochkrsat2 $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V <->
      ( ._|_ ` ( L ` G ) ) e. A ) ) $=
      ( cfv c0g csn wne wcel eqid dvhlmod lkrssv dochn0nv dochkrsat bitr3d ) AE
      HUAZIUAZCUBUAZUCUDUMIUAJUDUMBUEACFGIJKULUNLMNOUNUFZSADEHJCOQRACFGKLNSUGTU
      HUIABCDEFGHIKUNLMNPQRUOSTUJUK $.
  $}

  ${
    dochsat0.h $e |- H = ( LHyp ` K ) $.
    dochsat0.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsat0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsat0.z $e |- .0. = ( 0g ` U ) $.
    dochsat0.a $e |- A = ( LSAtoms ` U ) $.
    dochsat0.f $e |- F = ( LFnl ` U ) $.
    dochsat0.l $e |- L = ( LKer ` U ) $.
    dochsat0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsat0.g $e |- ( ph -> G e. F ) $.
    $( The orthocomplement of a kernel is either an atom or zero.  (Contributed
       by NM, 29-Jan-2015.) $)
    dochsat0 $p |- ( ph
        -> ( ( ._|_ ` ( L ` G ) ) e. A \/ ( ._|_ ` ( L ` G ) ) = { .0. } ) ) $=
      ( cfv wcel csn wceq wne dochkrsat biimpd necon1bd orrd ) AEHUAIUAZBUBZUJK
      UCZUDAUKUJULAUJULUEUKABCDEFGHIJKLMNPQROSTUFUGUHUI $.
  $}

  ${
    dochkrsm.h $e |- H = ( LHyp ` K ) $.
    dochkrsm.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    dochkrsm.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkrsm.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkrsm.p $e |- .(+) = ( LSSum ` U ) $.
    dochkrsm.f $e |- F = ( LFnl ` U ) $.
    dochkrsm.l $e |- L = ( LKer ` U ) $.
    dochkrsm.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkrsm.x $e |- ( ph -> X e. ran I ) $.
    dochkrsm.g $e |- ( ph -> G e. F ) $.
    $( The subspace sum of a closed subspace and a kernel orthocomplement is
       closed.  ( ~ djhlsmcl can be used to convert sum to join.)  (Contributed
       by NM, 29-Jan-2015.) $)
    dochkrsm $p |- ( ph -> ( X .(+) ( ._|_ ` ( L ` G ) ) ) e. ran I ) $=
      ( cfv clsa wcel co crn c0g wceq wa eqid chlt adantr simpr dihsmatrn oveq2
      csn csubg clmod clss dvhlmod dihrnlss syl2anc lsssubg lsm01 syl sylan9eqr
      eqeltrd dochsat0 mpjaodan ) AEIUCJUCZCUDUCZUEZLVKBUFZGUGZUEVKCUHUCZUQZUIZ
      AVMUJVLBVKCFGHKLMNPQVLUKZAHULUEKFUEUJZVMTUMALVOUEZVMUAUMAVMUNUOAVRUJVNLVO
      VRAVNLVQBUFZLVKVQLBUPALCURUCUEZWBLUIACUSUELCUTUCZUEZWCACFHKMPTVAAVTWAWETU
      AWDCFGHKLMPNWDUKZVBVCWDLCWFVDVCBCLVPVPUKZQVEVFVGAWAVRUAUMVHAVLCDEFHIJKVPM
      OPWGVSRSTUBVIVJ $.
  $}

  ${
    dochexmidat.h $e |- H = ( LHyp ` K ) $.
    dochexmidat.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochexmidat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochexmidat.v $e |- V = ( Base ` U ) $.
    dochexmidat.z $e |- .0. = ( 0g ` U ) $.
    dochexmidat.r $e |- N = ( LSpan ` U ) $.
    dochexmidat.p $e |- .(+) = ( LSSum ` U ) $.
    dochexmidat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochexmidat.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Special case of excluded middle for the singleton of a vector.
       (Contributed by NM, 27-Oct-2014.) $)
    dochexmidat $p |- ( ph -> ( ( ._|_ ` { X } ) .(+) ( N ` { X } ) ) = V ) $=
      ( csn cfv wcel wn co wceq dochnel clsh dvhlvec dochsnshp eldifad lshpnelb
      eqid mpbid ) AJJUAZGUBZUCUDUPUOFUBBUEHUFACDEGHIJKLMNOPSTUGABUPCUHUBZFHCJO
      QRUQUMZACDEILNSUIACDEGHIJUQKLMNOPURSTUJAJHKUATUKULUN $.
  $}

  ${
    dochexmidlem1.h $e |- H = ( LHyp ` K ) $.
    dochexmidlem1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochexmidlem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochexmidlem1.v $e |- V = ( Base ` U ) $.
    dochexmidlem1.s $e |- S = ( LSubSp ` U ) $.
    dochexmidlem1.n $e |- N = ( LSpan ` U ) $.
    dochexmidlem1.p $e |- .(+) = ( LSSum ` U ) $.
    dochexmidlem1.a $e |- A = ( LSAtoms ` U ) $.
    dochexmidlem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochexmidlem1.x $e |- ( ph -> X e. S ) $.
    ${
      dochexmidlem1.pp $e |- ( ph -> p e. A ) $.
      dochexmidlem1.qq $e |- ( ph -> q e. A ) $.
      dochexmidlem1.rr $e |- ( ph -> r e. A ) $.
      dochexmidlem1.ql $e |- ( ph -> q C_ ( ._|_ ` X ) ) $.
      dochexmidlem1.rl $e |- ( ph -> r C_ X ) $.
      $( Lemma for ~ dochexmid .  Holland's proof implicitly requires
         ` q =/= r ` , which we prove here.  (Contributed by NM,
         14-Jan-2015.) $)
      dochexmidlem1 $p |- ( ph -> q =/= r ) $=
        ( cv cfv cin wss wn wne c0g csn eqid dvhlmod lsatn0 wcel wceq lsatlssel
        clmod wb lssle0 syl2anc necon3bbid mpbird chlt dochnoncon sseq2d mtbird
        wa weq sseq1 syl5ibcom jctild ssin syl6ib necon3bd mpd ) AMUKZLLIULZUMZ
        UNZUONUKZWDUPAWGWDEUQULZURZUNZAWKUOWDWJUPABWDEWIWIUSZUCAEFGKPRUDUTZUHVA
        AWKWDWJAEVEVBWDDVBWKWDWJVCVFWMABDWDETUCWMUHVDDEWDWIWLTVGVHVIVJAWFWJWDAG
        VKVBKFVBVOLDVBWFWJVCUDUEDEFGIKLWIPRTWLQVLVHVMVNAWGWHWDANMVPZWDLUNZWDWEU
        NZVOWGAWNWPWOAWHWEUNWNWPUIWHWDWEVQVRUJVSWDLWEVTWAWBWC $.
    $}

    ${
      dochexmidlem2.pp $e |- ( ph -> p e. A ) $.
      dochexmidlem2.qq $e |- ( ph -> q e. A ) $.
      dochexmidlem2.rr $e |- ( ph -> r e. A ) $.
      dochexmidlem2.ql $e |- ( ph -> q C_ ( ._|_ ` X ) ) $.
      dochexmidlem2.rl $e |- ( ph -> r C_ X ) $.
      dochexmidlem2.pl $e |- ( ph -> p C_ ( r .(+) q ) ) $.
      $( Lemma for ~ dochexmid .  (Contributed by NM, 14-Jan-2015.) $)
      dochexmidlem2 $p |- ( ph -> p C_ ( X .(+) ( ._|_ ` X ) ) ) $=
        ( cv co cfv csubg wcel wss clmod dvhlmod lsssssubg sseldd chlt wa lssss
        syl dochlss syl2anc lsmless12 syl22anc sstrd ) AOULMULZNULZCUMZLLIUNZCU
        MZUKALEUOUNZUPVNVPUPVKLUQVLVNUQVMVOUQADVPLAEURUPDVPUQAEFGKPRUDUSDETUTVE
        ZUEVAADVPVNVQAGVBUPKFUPVCLJUQZVNDUPUDALDUPVRUEDLJESTVDVEDEFGIJKLPRSTQVF
        VGVAUJUICVKLVLVNEUBVHVIVJ $.
    $}

    ${
      dochexmidlem3.pp $e |- ( ph -> p e. A ) $.
      dochexmidlem3.qq $e |- ( ph -> q e. A ) $.
      dochexmidlem3.rr $e |- ( ph -> r e. A ) $.
      dochexmidlem3.ql $e |- ( ph -> q C_ ( ._|_ ` X ) ) $.
      dochexmidlem3.rl $e |- ( ph -> r C_ X ) $.
      dochexmidlem3.pl $e |- ( ph -> q C_ ( r .(+) p ) ) $.
      $( Lemma for ~ dochexmid .  Use atom exchange ~ lsatexch1 to swap ` p `
         and ` q ` .  (Contributed by NM, 14-Jan-2015.) $)
      dochexmidlem3 $p |- ( ph -> p C_ ( X .(+) ( ._|_ ` X ) ) ) $=
        ( cv dvhlvec dochexmidlem1 lsatexch1 dochexmidlem2 ) ABCDEFGHIJKLMNOPQR
        STUAUBUCUDUEUFUGUHUIUJABCNULOULMULEUBUCAEFGKPRUDUMUGUFUHUKABCDEFGHIJKLM
        NOPQRSTUAUBUCUDUEUFUGUHUIUJUNUOUP $.
    $}

    ${
      $d r A $.  $d r ._|_ $.  $d r .(+) $.  $d r U $.  $d r X $.  $d r p $.
      $d r q $.  $d r ph $.
      dochexmidlem4.pp $e |- ( ph -> p e. A ) $.
      dochexmidlem4.qq $e |- ( ph -> q e. A ) $.
      dochexmidlem4.z $e |- .0. = ( 0g ` U ) $.
      dochexmidlem4.m $e |- M = ( X .(+) p ) $.
      dochexmidlem4.xn $e |- ( ph -> X =/= { .0. } ) $.
      dochexmidlem4.pl $e |- ( ph -> q C_ ( ( ._|_ ` X ) i^i M ) ) $.
      $( Lemma for ~ dochexmid .  (Contributed by NM, 15-Jan-2015.) $)
      dochexmidlem4 $p |- ( ph -> p C_ ( X .(+) ( ._|_ ` X ) ) ) $=
        ( vr cv wss co wa wrex cfv dvhlmod lsatlssel cin syl6ss syl6sseq lsmsat
        inss2 wcel w3a 3ad2ant1 simp2 inss1 simp3l dochexmidlem3 rexlimdv3a mpd
        chlt simp3r ) AUMUNZMUOZOUNZVRPUNZCUPUOZUQZUMBURWAMMJUSZCUPUOZABCVTDMWA
        ENUMUIUAUCUDAEFGLQSUEUTZUFABDWAEUAUDWFUGVAUHUKAVTHMWACUPAVTWDHVBZHULWDH
        VFVCUJVDVEAWCWEUMBAVRBVGZWCVHBCDEFGIJKLMUMOPQRSTUAUBUCUDAWHGVPVGLFVGUQW
        CUEVIAWHMDVGWCUFVIAWHWABVGWCUGVIAWHVTBVGWCUHVIAWHWCVJAWHVTWDUOWCAVTWGWD
        ULWDHVKVCVIAWHVSWBVLAWHVSWBVQVMVNVO $.
    $}

    ${
      $d q A $.  $d q M $.  $d q ._|_ $.  $d q .(+) $.  $d q U $.  $d q X $.
      $d q p $.  $d q ph $.
      dochexmidlem5.pp $e |- ( ph -> p e. A ) $.
      dochexmidlem5.z $e |- .0. = ( 0g ` U ) $.
      dochexmidlem5.m $e |- M = ( X .(+) p ) $.
      dochexmidlem5.xn $e |- ( ph -> X =/= { .0. } ) $.
      dochexmidlem5.pl $e |- ( ph -> -. p C_ ( X .(+) ( ._|_ ` X ) ) ) $.
      $( Lemma for ~ dochexmid .  (Contributed by NM, 15-Jan-2015.) $)
      dochexmidlem5 $p |- ( ph -> ( ( ._|_ ` X ) i^i M ) = { .0. } ) $=
        ( vq cv cfv co wss wn cin csn wceq wne wrex wa wcel dvhlmod adantr chlt
        clmod lssss syl dochlss syl2anc lsatlssel lsmcl syl3anc simpr lssatomic
        syl5eqel lssincl w3a 3ad2ant1 simp2 simp3 dochexmidlem4 rexlimdv3a syld
        ex necon1bd mpd ) AOULZMMJUMZCUNUOZUPWJHUQZNURZUSUJAWKWLWMAWLWMUTZUKULZ
        WLUOZUKBVAZWKAWNWQAWNVBBDWLENUKTUGUCAEVGVCZWNAEFGLPRUDVDZVEAWLDVCZWNAWR
        WJDVCZHDVCWTWSAGVFVCLFVCVBZMKUOZXAUDAMDVCZXCUEDMKESTVHVIDEFGJKLMPRSTQVJ
        VKAHMWICUNZDUHAWRXDWIDVCXEDVCWSUEABDWIETUCWSUFVLCDMWIETUBVMVNVQDWJHETVR
        VNVEAWNVOVPWFAWPWKUKBAWOBVCZWPVSBCDEFGHIJKLMNUKOPQRSTUAUBUCAXFXBWPUDVTA
        XFXDWPUEVTAXFWIBVCWPUFVTAXFWPWAUGUHAXFMWMUTWPUIVTAXFWPWBWCWDWEWGWH $.
    $}

    ${
      dochexmidlem6.pp $e |- ( ph -> p e. A ) $.
      dochexmidlem6.z $e |- .0. = ( 0g ` U ) $.
      dochexmidlem6.m $e |- M = ( X .(+) p ) $.
      dochexmidlem6.xn $e |- ( ph -> X =/= { .0. } ) $.
      dochexmidlem6.c $e |- ( ph -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $.
      dochexmidlem6.pl $e |- ( ph -> -. p C_ ( X .(+) ( ._|_ ` X ) ) ) $.
      $( Lemma for ~ dochexmid .  (Contributed by NM, 15-Jan-2015.) $)
      dochexmidlem6 $p |- ( ph -> M = X ) $=
        ( cfv cin csn dochexmidlem5 fveq2d chlt wcel wa wceq doch0 eqtrd ineq1d
        syl cdih crn cv co eqid lssss dochssv syl2anc dochcl eqeltrrd dihsmatrn
        wss syl5eqel dihrnlss clmod dvhlmod lsatlssel syl3anc syl5eqss dochoccl
        lsmcl mpbid lsssssubg sseldd lsmub1 syl6sseqr dihoml4 sseqin2 3eqtr3rd
        csubg sylib ) AHMJULZJULZMAWPHUMZJULZHUMKHUMZWQHAWSKHAWSNUNZJULZKAWRXAJ
        ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUKUOUPAGUQURLFURUSZXBKUTUDEFGJKLN
        PRQSUGVAVDVBVCADEFGJLMHPRTQUDUEAXCHLGVEULULZVFZURZHDURUDAHMOVGZCVHZXEUH
        ABCXGEFXDGLMPXDVIZRUBUCUDAWQMXEUJAXCWPKVPZWQXEURUDAXCMKVPZXJUDAMDURZXKU
        EDMKESTVJVDEFGJKLMPRSQVKVLEFXDGJKLWPPXIRSQVMVLVNUFVOVQZDEFXDGLHPRXITVRV
        LAXFHJULJULHUTXMAEFXDGJKLHPXIRSQUDAHXHKUHAXHDURZXHKVPAEVSURZXLXGDURXNAE
        FGLPRUDVTZUEABDXGETUCXPUFWAZCDMXGETUBWEWBDXHKESTVJVDWCZWDWFAMXHHAMEWNUL
        ZURXGXSURMXHVPADXSMAXODXSVPXPDETWGVDZUEWHADXSXGXTXQWHCMXGEUBWIVLUHWJWKA
        HKVPWTHUTXRHKWLWOWMUJVB $.

      $( Lemma for ~ dochexmid .  Contradict ~ dochexmidlem6 .  (Contributed by
         NM, 15-Jan-2015.) $)
      dochexmidlem7 $p |- ( ph -> M =/= X ) $=
        ( cv wss wn wne co csubg cfv wcel clmod dvhlmod lsssssubg syl lsatlssel
        sseldd lsmub2 syl2anc syl6sseqr chlt lssss dochlss lsmub1 sstr2 syl5com
        wa mtod wceq sseq2 biimpcd necon3bd sylc ) AOULZHUMZWBMUMZUNHMUOAWBMWBC
        UPZHAMEUQURZUSZWBWFUSWBWEUMADWFMAEUTUSDWFUMAEFGLPRUDVAZDETVBVCZUEVEZADW
        FWBWIABDWBETUCWHUFVDVECMWBEUBVFVGUHVHAWDWBMMJURZCUPZUMZUKAMWLUMZWDWMAWG
        WKWFUSWNWJADWFWKWIAGVIUSLFUSVOMKUMZWKDUSUDAMDUSWOUEDMKESTVJVCDEFGJKLMPR
        STQVKVGVECMWKEUBVLVGWBMWLVMVNVPWCWDHMHMVQWCWDHMWBVRVSVTWA $.
    $}

    $d p .(+) $.  $d p ._|_ $.  $d p A $.  $d p ph $.  $d p S $.  $d p U $.
    $d p V $.  $d p X $.
    dochexmidlem8.z $e |- .0. = ( 0g ` U ) $.
    dochexmidlem8.xn $e |- ( ph -> X =/= { .0. } ) $.
    dochexmidlem8.c $e |- ( ph -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $.
    $( Lemma for ~ dochexmid .  The contradiction of ~ dochexmidlem6 and
       ~ dochexmidlem7 shows that there can be no atom ` p ` that is not in
       ` X + ( ._|_ `` X ) ` , which is therefore the whole atom space.
       (Contributed by NM, 15-Jan-2015.) $)
    dochexmidlem8 $p |- ( ph -> ( X .(+) ( ._|_ ` X ) ) = V ) $=
      ( vp wceq wne wa wn cfv co nonconne wss wcel clmod dvhlmod chlt lssss syl
      dochlss syl2anc lsmcl syl3anc wrex adantr lss1 wpss df-pss biimpri adantl
      cv lpssat ex w3a 3ad2ant1 eqid csn dochexmidlem6 dochexmidlem7 pm2.21ddne
      simp2 simp3 3adant3l rexlimdv3a syld mpand necon1bd mpi ) ALLUHLLUIUJZUKL
      LIULZCUMZJUHLLUNAWKWMJAWMJUOZWMJUIZWKAWMDUPZWNAEUQUPZLDUPZWLDUPZWPAEFGKNP
      UBURZUCAGUSUPKFUPUJZLJUOZWSUBAWRXBUCDLJEQRUTVADEFGIJKLNPQROVBVCCDLWLERTVD
      VEZDWMJEQRUTVAAWNWOUJZUGVMZJUOZXEWMUOUKZUJZUGBVFZWKAXDXIAXDUJBDWMJEUGRUAA
      WQXDWTVGAWPXDXCVGAJDUPZXDAWQXJWTDJEQRVHVAVGXDWMJVIZAXKXDWMJVJVKVLVNVOAXHW
      KUGBAXEBUPZXGWKXFAXLXGVPZWKLXECUMZLXMBCDEFGXNHIJKLMUGNOPQRSTUAAXLXAXGUBVQ
      ZAXLWRXGUCVQZAXLXGWCZUDXNVRZAXLLMVSUIXGUEVQZAXLWLIULLUHXGUFVQZAXLXGWDZVTX
      MBCDEFGXNHIJKLMUGNOPQRSTUAXOXPXQUDXRXSXTYAWAWBWEWFWGWHWIWJ $.
  $}

  ${
    dochexmid.h $e |- H = ( LHyp ` K ) $.
    dochexmid.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochexmid.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochexmid.v $e |- V = ( Base ` U ) $.
    dochexmid.s $e |- S = ( LSubSp ` U ) $.
    dochexmid.p $e |- .(+) = ( LSSum ` U ) $.
    dochexmid.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochexmid.x $e |- ( ph -> X e. S ) $.
    dochexmid.c $e |- ( ph -> ( ._|_ ` ( ._|_ ` X ) ) = X ) $.
    $( Excluded middle law for closed subspaces, which is equivalent to (and
       derived from) the orthomodular law ~ dihoml4 .  Lemma 3.3(2) in
       [Holland95] p. 215.  In our proof, we use the variables ` X ` , ` M ` ,
       ` p ` , ` q ` , ` r ` in place of Hollands' l, m, P, Q, L respectively.
       ( ~ pexmidALTN analog.)  (Contributed by NM, 15-Jan-2015.) $)
    dochexmid $p |- ( ph -> ( X .(+) ( ._|_ ` X ) ) = V ) $=
      ( cfv co wceq c0g csn id fveq2 oveq12d csubg wcel clmod dvhlmod chlt eqid
      wa wss lmod0vcl snssd dochlss syl2anc lsssubg lsm02 doch0 eqtrd sylan9eqr
      syl wne clsa clspn adantr simpr dochexmidlem8 pm2.61dane ) AJJGTZBUAZHUBJ
      DUCTZUDZJVPUBZAVNVPVPGTZBUAZHVQJVPVMVRBVQUEJVPGUFUGAVSVRHAVRDUHTUIZVSVRUB
      ADUJUIZVRCUIZVTADEFIKMQUKZAFULUIIEUIUNZVPHUOWBQAVOHAWAVOHUIWCHDVONVOUMZUP
      VEUQCDEFGHIVPKMNOLURUSCVRDOUTUSBDVRVOWEPVAVEAWDVRHUBQDEFGHIVOKMLNWEVBVEVC
      VDAJVPVFZUNDVGTZBCDEFDVHTZGHIJVOKLMNOWHUMPWGUMAWDWFQVIAJCUIWFRVIWEAWFVJAV
      MGTJUBWFSVIVKVL $.
  $}

  ${
    $d x D $.  $d z F $.  $d x z G $.  $d x z U $.  $d x z V $.  $d x z W $.
    $d z ._|_ $.
    dochsnkr.h $e |- H = ( LHyp ` K ) $.
    dochsnkr.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsnkr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsnkr.v $e |- V = ( Base ` U ) $.
    dochsnkr.z $e |- .0. = ( 0g ` U ) $.
    dochsnkr.f $e |- F = ( LFnl ` U ) $.
    dochsnkr.l $e |- L = ( LKer ` U ) $.
    dochsnkr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsnkr.g $e |- ( ph -> G e. F ) $.
    dochsnkr.x $e |- ( ph -> X e. ( ( ._|_ ` ( L ` G ) ) \ { .0. } ) ) $.
    $( Lemma for ~ dochsnkr .  (Contributed by NM, 1-Jan-2015.) $)
    dochsnkrlem1 $p |- ( ph -> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V ) $=
      ( cfv csn wne cdif wcel wn eldif nelne1 sylbi syl dvhlmod lkrssv dochn0nv
      wa mpbid ) ADGUCZHUCZLUDZUEZUSHUCIUEAKUSUTUFUGZVAUBVBKUSUGKUTUGUHUPVAKUSU
      TUIKUSUTUJUKULABEFHIJURLMNOPQTACDGIBPRSABEFJMOTUMUAUNUOUQ $.

    ${
      dochsnkr.a $e |- A = ( LSAtoms ` U ) $.
      $( Lemma for ~ dochsnkr .  (Contributed by NM, 1-Jan-2015.) $)
      dochsnkrlem2 $p |- ( ph -> ( ._|_ ` ( L ` G ) ) e. A ) $=
        ( cfv wne wcel dochsnkrlem1 dochkrsat2 mpbid ) AEHUEIUEZIUEJUFUKBUGACDE
        FGHIJKLMNOPQRSTUAUBUCUHABCDEFGHIJKNOPQUDSTUAUBUIUJ $.
    $}

    $( Lemma for ~ dochsnkr .  (Contributed by NM, 2-Jan-2015.) $)
    dochsnkrlem3 $p |- ( ph -> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) ) $=
      ( cfv wceq wne wo dochsnkrlem1 orcd dochkrshp4 mpbird ) ADGUCZHUCHUCZUKUD
      ULIUEZUKIUDZUFAUMUNABCDEFGHIJKLMNOPQRSTUAUBUGUHABCDEFGHIJMNOPRSTUAUIUJ $.

    $( A (closed) kernel expressed in terms of a nonzero vector in its
       orthocomplement.  TODO: consolidate lemmas unless they're needed for
       something else (in which case break out as theorems) (Contributed by NM,
       2-Jan-2015.) $)
    dochsnkr $p |- ( ph -> ( L ` G ) = ( ._|_ ` { X } ) ) $=
      ( cfv csn clspn clsa eqid dvhlvec dochsnkrlem2 eldifad cdif wcel eldifsni
      wne syl lsatel fveq2d dochsnkrlem3 chlt wa dvhlmod lkrssv dochssv syl2anc
      wss ssdifssd sseldd snssd dochocsp 3eqtr3d ) ADGUCZHUCZHUCKUDZBUEUCZUCZHU
      CVKVMHUCAVLVOHABUFUCZVLVNBKLQVNUGZVPUGZABEFJMOTUHAVPBCDEFGHIJKLMNOPQRSTUA
      UBVRUIAKVLLUDZUBUJAKVLVSUKZULKLUNUBKVLLUMUOUPUQABCDEFGHIJKLMNOPQRSTUAUBUR
      ABEFVNHIJVMMONPVQTAKIAVTIKAVLIVSAFUSULJEULUTVKIVEVLIVETACDGIBPRSABEFJMOTV
      AUAVBBEFHIJVKMOPNVCVDVFUBVGVHVIVJ $.
  $}

  ${
    $d k v w .+ $.  $d k D $.  $d k v w ._|_ $.  $d k v R $.  $d k v w .x. $.
    $d v V $.  $d k v w X $.
    dochsnkr2.h $e |- H = ( LHyp ` K ) $.
    dochsnkr2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochsnkr2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochsnkr2.v $e |- V = ( Base ` U ) $.
    dochsnkr2.z $e |- .0. = ( 0g ` U ) $.
    dochsnkr2.a $e |- .+ = ( +g ` U ) $.
    dochsnkr2.t $e |- .x. = ( .s ` U ) $.
    dochsnkr2.l $e |- L = ( LKer ` U ) $.
    dochsnkr2.d $e |- D = ( Scalar ` U ) $.
    dochsnkr2.r $e |- R = ( Base ` D ) $.
    dochsnkr2.g $e |- G = ( v e. V |->
        ( iota_ k e. R E. w e. ( ._|_ ` { X } ) v = ( w .+ ( k .x. X ) ) ) ) $.
    dochsnkr2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochsnkr2.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Kernel of the explicit functional ` G ` determined by a nonzero vector
       ` X ` .  Compare the more general ~ lshpkr .  (Contributed by NM,
       27-Oct-2014.) $)
    dochsnkr2 $p |- ( ph -> ( L ` G ) = ( ._|_ ` { X } ) ) $=
      ( clsm cfv clsh clspn eqid dvhlvec dochsnshp eldifad dochexmidat lshpkr
      csn ) ACBDEHULUMZGQVBNUMIJHUNUMZFMHUOUMZOHQUBUDVEUPZVCUPZVDUPZAHKLPSUAUJU
      QAHKLNOPQVDRSTUAUBUCVHUJUKURAQORVBUKUSAVCHKLVENOPQRSTUAUBUCVFVGUJUKUTUGUH
      UEUIUFVA $.

    $( The ` X ` determining functional ` G ` belongs to the atom formed by the
       orthocomplement of the kernel.  (Contributed by NM, 4-Jan-2015.) $)
    dochsnkr2cl $p |- ( ph -> X e. ( ( ._|_ ` ( L ` G ) ) \ { .0. } ) ) $=
      ( cfv wcel wne cdif clspn clmod dvhlmod eldifad lspsnid syl2anc dochsnkr2
      csn eqid snssd dochocsp eqtr4d fveq2d chlt wa cdih crn wceq dochoc eqtr2d
      dihlsprn eleqtrd eldifsni syl eldifsn sylanbrc ) AQJMULZNULZUMQRUNZQWCRVC
      ZUOUMAQQVCZHUPULZULZWCAHUQUMQOUMZQWHUMAHKLPSUAUJURAQOWEUKUSZWGOHQUBWGVDZU
      TVAAWCWHNULZNULZWHAWBWLNAWBWFNULWLABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
      JUKVBAHKLWGNOPWFSUATUBWKUJAQOWJVEVFVGVHALVIUMPKUMVJZWHPLVKULULZVLUMZWMWHV
      MUJAWNWIWPUJWJHKWOLWGOPQSUAUBWKWOVDZVPVAKWOLNPWHSWQTVNVAVOVQAQOWEUOUMWDUK
      QORVRVSQWCRVTWA $.
  $}

  ${
    $d k v w .+ $.  $d k D $.  $d k v w ._|_ $.  $d k v R $.  $d k v w .x. $.
    $d v V $.  $d k v w X $.
    dochflcl.h $e |- H = ( LHyp ` K ) $.
    dochflcl.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochflcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochflcl.v $e |- V = ( Base ` U ) $.
    dochflcl.z $e |- .0. = ( 0g ` U ) $.
    dochflcl.a $e |- .+ = ( +g ` U ) $.
    dochflcl.t $e |- .x. = ( .s ` U ) $.
    dochflcl.f $e |- F = ( LFnl ` U ) $.
    dochflcl.d $e |- D = ( Scalar ` U ) $.
    dochflcl.r $e |- R = ( Base ` D ) $.
    dochflcl.g $e |- G = ( v e. V |->
        ( iota_ k e. R E. w e. ( ._|_ ` { X } ) v = ( w .+ ( k .x. X ) ) ) ) $.
    dochflcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochflcl.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Closure of the explicit functional ` G ` determined by a nonzero vector
       ` X ` .  Compare the more general ~ lshpkrcl .  (Contributed by NM,
       27-Oct-2014.) $)
    dochflcl $p |- ( ph -> G e. F ) $=
      ( clsm cfv clsh clspn eqid dvhlvec dochsnshp eldifad dochexmidat lshpkrcl
      csn ) ACBDEHULUMZGQVBNUMIJKHUNUMZFHUOUMZOHQUBUDVEUPZVCUPZVDUPZAHLMPSUAUJU
      QAHLMNOPQVDRSTUAUBUCVHUJUKURAQORVBUKUSAVCHLMVENOPQRSTUAUBUCVFVGUJUKUTUGUH
      UEUIUFVA $.
  $}

  ${
    $d a k v w .+ $.  $d a k w .1. $.  $d a k v w ._|_ $.  $d a k v R $.
    $d a k v w .x. $.  $d v V $.  $d a k v w X $.  $d w .0. $.
    dochfl1.h $e |- H = ( LHyp ` K ) $.
    dochfl1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochfl1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochfl1.v $e |- V = ( Base ` U ) $.
    dochfl1.a $e |- .+ = ( +g ` U ) $.
    dochfl1.t $e |- .x. = ( .s ` U ) $.
    dochfl1.z $e |- .0. = ( 0g ` U ) $.
    dochfl1.d $e |- D = ( Scalar ` U ) $.
    dochfl1.r $e |- R = ( Base ` D ) $.
    dochfl1.i $e |- .1. = ( 1r ` D ) $.
    dochfl1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochfl1.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    dochfl1.g $e |- G = ( v e. V |->
        ( iota_ k e. R E. w e. ( ._|_ ` { X } ) v = ( w .+ ( k .x. X ) ) ) ) $.
    $( The value of the explicit functional ` G ` is 1 at the ` X ` that
       determines it.  (Contributed by NM, 27-Oct-2014.) $)
    dochfl1 $p |- ( ph -> ( G ` X ) = .1. ) $=
      ( cfv cv co wceq csn wrex crio wcel eldifad eqeq1 rexbidv riotabidv fvmpt
      riotaex syl clmod clss dvhlmod chlt wss snssd eqid dochlss syl2anc lss0cl
      wa lmodvs1 oveq2d lmod0vlid eqtr2d oveq1 eqeq2d rspcev wb lmodrng rngidcl
      wreu 3syl clsm clspn dvhlvec dochsnshp dochexmidat lshpsmreu riota2 mpbid
      crg clsh eqtrd ) AQKULZQBUMZJUMZQGUNZEUNZUOZBQUPZNULZUQZJFURZIAQOUSZXAXJU
      OAQORUPUJUTZCQCUMZXEUOZBXHUQZJFURXJOKXMQUOZXOXIJFXPXNXFBXHXMQXEVAVBVCUKXI
      JFVEVDVFAQXBIQGUNZEUNZUOZBXHUQZXJIUOZARXHUSZQRXQEUNZUOZXTAHVGUSZXHHVHULZU
      SZYBAHLMPSUAUIVIZAMVJUSPLUSVQXGOVKYGUIAQOXLVLYFHLMNOPXGSUAUBYFVMZTVNVOYFX
      HHRUEYIVPVOAYCRQEUNZQAXQQREAYEXKXQQUOYHXLGIDOHQUBUFUDUHVRVOVSAYEXKYJQUOYH
      XLEOHQRUBUCUEVTVOWAXSYDBRXHXBRUOXRYCQXBRXQEWBWCWDVOAIFUSZXIJFWHXTYAWEAYED
      WRUSYKYHDHUFWFFDIUGUHWGWIABDEHWJULZGXHJHWSULZFHWKULZOHQQUBUCYNVMZYLVMZYMV
      MZAHLMPSUAUIWLAHLMNOPQYMRSTUAUBUEYQUIUJWMXLXLAYLHLMYNNOPQRSTUAUBUEYOYPUIU
      JWNUFUGUDWOXIXTJFIXCIUOZXFXSBXHYRXEXRQYRXDXQXBEXCIQGWBVSWCVBWPVOWQWT $.
  $}

  ${
    $d x D $.  $d z F $.  $d x z G $.  $d x z U $.  $d x z V $.  $d x z W $.
    $d z ._|_ $.
    dochfln0.h $e |- H = ( LHyp ` K ) $.
    dochfln0.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochfln0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochfln0.v $e |- V = ( Base ` U ) $.
    dochfln0.r $e |- R = ( Scalar ` U ) $.
    dochfln0.n $e |- N = ( 0g ` R ) $.
    dochfln0.z $e |- .0. = ( 0g ` U ) $.
    dochfln0.f $e |- F = ( LFnl ` U ) $.
    dochfln0.l $e |- L = ( LKer ` U ) $.
    dochfln0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochfln0.g $e |- ( ph -> G e. F ) $.
    dochfln0.x $e |- ( ph -> X e. ( ( ._|_ ` ( L ` G ) ) \ { .0. } ) ) $.
    $( The value of a functional is nonzero at a nonzero vector in the
       orthocomplement of its kernel.  (Contributed by NM, 2-Jan-2015.) $)
    dochfln0 $p |- ( ph -> ( G ` X ) =/= N ) $=
      ( csn cfv wcel wn wne cdif chlt wss dvhlmod lkrssv dochssv syl2anc ssdifd
      wa sseldd dochnel wceq eldifad biantrurd clmod wb ellkr dochsnkr 3bitr2rd
      eleq2d necon3bbid mpbid ) AMMUGJUHZUIZUJMEUHZIUKACFGJKLMNOPQRUAUDAEHUHZJU
      HZNUGZULKVSULMAVRKVSAGUMUILFUIUTVQKUNVRKUNUDADEHKCRUBUCACFGLOQUDUOZUEUPCF
      GJKLVQOQRPUQURZUSUFVAVBAVOVPIAVPIVCZMKUIZWBUTZMVQUIZVOAWCWBAVRKMWAAMVRVSU
      FVDVAVEACVFUIEDUIWEWDVGVTUEBDEHKCMVFIRSTUBUCVHURAVQVNMACDEFGHJKLMNOPQRUAU
      BUCUDUEUFVIVKVJVLVM $.
  $}


  ${
    $d x z .0. $.  $d x z G $.  $d x z L $.  $d z ph $.  $d x R $.  $d x z U $.
    $d x z ._|_ $.  $d x z .1. $.
    dochkr1.h $e |- H = ( LHyp ` K ) $.
    dochkr1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkr1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkr1.v $e |- V = ( Base ` U ) $.
    dochkr1.r $e |- R = ( Scalar ` U ) $.
    dochkr1.z $e |- .0. = ( 0g ` U ) $.
    dochkr1.i $e |- .1. = ( 1r ` R ) $.
    dochkr1.f $e |- F = ( LFnl ` U ) $.
    dochkr1.l $e |- L = ( LKer ` U ) $.
    dochkr1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkr1.g $e |- ( ph -> G e. F ) $.
    dochkr1.n $e |- ( ph -> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V ) $.
    $( A non-zero functional has a value of 1 at some argument belonging to the
       orthocomplement of its kernel (when its kernel is a closed hyperplane).
       Tighter version of ~ lfl1 .  (Contributed by NM, 2-Jan-2015.) $)
    dochkr1 $p |- ( ph
           -> E. x e. ( ( ._|_ ` ( L ` G ) ) \ { .0. } ) ( G ` x ) = .1. ) $=
      ( vz cv cfv c0g wne wrex wceq csn cdif clsa eqid dvhlmod dochkrsat2 mpbid
      wcel lsateln0 chlt ad2antrr eldifsn biimpri adantll dochfln0 reximdva mpd
      wa ex w3a cinvr cvsca co clss cbs wss lkrssv dochlss syl2anc jca 3ad2ant1
      clmod cdr clvec dvhlvec lvecdrng syl dochssv sselda 3adant3 lflcl syl3anc
      simp3 drnginvrcl simp2 lssvscl drnginvrn0 adantr fveq2 syl5ibrcom necon3d
      lfl0 eqeq1d 3impia lvecvsn0 mpbir2and sylanbrc lflmul syl112anc drnginvrl
      cmulr eqtrd rspcev rexlimdv3a ) AUGUHZGUIZCUJUIZUKZUGGJUIZKUIZULZBUHZGUIZ
      EUMZBYCNUNUOZULZAXRDUJUIZUKZUGYCULYDAUGDUPUIZYCDYJYJUQZYLUQZADHIMOQUDURZA
      YCKUILUKYCYLVAUFAYLDFGHIJKLMOPQRYNUBUCUDUEUSUTVBAYKYAUGYCAXRYCVAZVKZYKYAY
      QYKVKCDFGHIJXTKLMXRYJOPQRSXTUQZYMUBUCAIVCVAMHVAVKZYPYKUDVDAGFVAZYPYKUEVDY
      PYKXRYCYJUNUOVAZAUUAYPYKVKXRYCYJVEVFVGVHVLVIVJAYAYIUGYCAYPYAVMZXSCVNUIZUI
      ZXRDVOUIZVPZYHVAZUUFGUIZEUMZYIUUBUUFYCVAZUUFNUKZUUGUUBDWEVAZYCDVQUIZVAZVK
      ZUUDCVRUIZVAZYPVKUUJAYPUUOYAAUULUUNYOAYSYBLVSZUUNUDAFGJLDRUBUCYOUEVTZUUMD
      HIKLMYBOQRUUMUQZPWAWBWCWDUUBUUQYPUUBCWFVAZXSUUPVAZYAUUQUUBDWGVAZUVAAYPUVC
      YAADHIMOQUDWHWDZCDSWIWJZUUBUULYTXRLVAZUVBAYPUULYAYOWDZAYPYTYAUEWDZAYPUVFY
      AAYCLXRAYSUURYCLVSUDUUSDHIKLMYBOQRPWKWBWLWMZCFGUUPLDXRWESUUPUQZRUBWNWOZAY
      PYAWPZUUPCUUCXSXTUVJYRUUCUQZWQWOZAYPYAWRWCUUPUUMUUEYCCDUUDXRSUUEUQZUVJUUT
      WSWBUUBUUKUUDXTUKZXRNUKZUUBUVAUVBYAUVPUVEUVKUVLUUPCUUCXSXTUVJYRUVMWTWOAYP
      YAUVQYQXRNXSXTYQXSXTUMXRNUMZNGUIZXTUMZYQUULYTUVTAUULYPYOXAAYTYPUEXACFGDXT
      NSYRTUBXEWBUVRXSUVSXTXRNGXBXFXCXDXGUUBUUDUUECUUPXTLDXRNRUVOSUVJYRTUVDUVNU
      VIXHXIUUFYCNVEXJUUBUUHUUDXSCXNUIZVPZEUUBUULYTUUQUVFUUHUWBUMUVGUVHUVNUVICU
      UDUUEUWAFGUUPLDXRSUVJUWAUQZRUVOUBXKXLUUBUVAUVBYAUWBEUMUVEUVKUVLUUPCUWAEUU
      CXSXTUVJYRUWCUAUVMXMWOXOYGUUIBUUFYHYEUUFUMYFUUHEYEUUFGXBXFXPWBXQVJ $.
  $}

  ${
    $d x z .1. $.  $d x z G $.  $d x z L $.  $d z ph $.  $d x R $.  $d x z U $.
    $d x z ._|_ $.
    dochkr1OLD.h $e |- H = ( LHyp ` K ) $.
    dochkr1OLD.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochkr1OLD.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochkr1OLD.v $e |- V = ( Base ` U ) $.
    dochkr1OLD.r $e |- R = ( Scalar ` U ) $.
    dochkr1OLD.z $e |- .0. = ( 0g ` R ) $.
    dochkr1OLD.i $e |- .1. = ( 1r ` R ) $.
    dochkr1OLD.f $e |- F = ( LFnl ` U ) $.
    dochkr1OLD.l $e |- L = ( LKer ` U ) $.
    dochkr1OLD.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    dochkr1OLD.g $e |- ( ph -> G e. F ) $.
    dochkr1OLD.n $e |- ( ph -> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V ) $.
    $( A non-zero functional has a value of 1 at some argument belonging to the
       orthocomplement of its kernel (when its kernel is a closed hyperplane).
       Tighter version of ~ lfl1 .  (Contributed by NM, 2-Jan-2015.)
       (New usage is discouraged.) $)
    dochkr1OLDN $p |- ( ph -> E. x e. ( ._|_ ` ( L ` G ) ) ( G ` x ) = .1. ) $=
      ( vz cv cfv wne wrex wceq c0g clsa eqid dvhlmod dochkrsat2 mpbid lsateln0
      wcel chlt ad2antrr csn cdif eldifsn biimpri adantll dochfln0 reximdva mpd
      wa ex w3a cinvr cvsca co clss cbs wss lkrssv dochlss syl2anc jca 3ad2ant1
      clmod cdr clvec dvhlvec lvecdrng syl dochssv sselda 3adant3 lflcl syl3anc
      simp3 simp2 lssvscl syl12anc cmulr lflmul syl112anc drnginvrl eqtrd fveq2
      drnginvrcl eqeq1d rspcev rexlimdv3a ) AUGUHZGUIZNUJZUGGJUIZKUIZUKZBUHZGUI
      ZEULZBXNUKZAXJDUMUIZUJZUGXNUKXOAUGDUNUIZXNDXTXTUOZYBUOZADHIMOQUDUPZAXNKUI
      LUJXNYBUTUFAYBDFGHIJKLMOPQRYDUBUCUDUEUQURUSAYAXLUGXNAXJXNUTZVKZYAXLYGYAVK
      CDFGHIJNKLMXJXTOPQRSTYCUBUCAIVAUTMHUTVKZYFYAUDVBAGFUTZYFYAUEVBYFYAXJXNXTV
      CVDUTZAYJYFYAVKXJXNXTVEVFVGVHVLVIVJAXLXSUGXNAYFXLVMZXKCVNUIZUIZXJDVOUIZVP
      ZXNUTZYOGUIZEULZXSYKDWEUTZXNDVQUIZUTZVKZYMCVRUIZUTZYFYPAYFUUBXLAYSUUAYEAY
      HXMLVSZUUAUDAFGJLDRUBUCYEUEVTZYTDHIKLMXMOQRYTUOZPWAWBWCWDYKCWFUTZXKUUCUTZ
      XLUUDYKDWGUTZUUHAYFUUJXLADHIMOQUDWHWDCDSWIWJZYKYSYIXJLUTZUUIAYFYSXLYEWDZA
      YFYIXLUEWDZAYFUULXLAXNLXJAYHUUEXNLVSUDUUFDHIKLMXMOQRPWKWBWLWMZCFGUUCLDXJW
      ESUUCUOZRUBWNWOZAYFXLWPZUUCCYLXKNUUPTYLUOZXFWOZAYFXLWQUUCYTYNXNCDYMXJSYNU
      OZUUPUUGWRWSYKYQYMXKCWTUIZVPZEYKYSYIUUDUULYQUVCULUUMUUNUUTUUOCYMYNUVBFGUU
      CLDXJSUUPUVBUOZRUVAUBXAXBYKUUHUUIXLUVCEULUUKUUQUURUUCCUVBEYLXKNUUPTUVDUAU
      USXCWOXDXRYRBYOXNXPYOULXQYQEXPYOGXEXGXHWBXIVJ $.
  $}


$(
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
     Construction of involution and inner product from a Hilbert lattice
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
$)

  $c LPol $.

  $( Extend class notation with all polarities of a left module or left vector
     space. $)
  clpoN $a class LPol $.

  ${
    $d o w x y $.
    $( Define the set of all polarities of a left module or left vector space.
       A polarity is a kind of complementation operation on a subspace.  The
       double polarity of a subspace is a closure operation.  Based on
       Definition 3.2 of [Holland95] p. 214 for projective geometry
       polarities.  For convenience, we open up the domain to include all
       vector subsets and not just subspaces, but any more restricted polarity
       can be converted to this one by taking the span of its argument.
       (Contributed by NM, 24-Nov-2014.) $)
    df-lpolN $a |- LPol = ( w e. _V |->
       { o e. ( ( LSubSp ` w ) ^m ~P ( Base ` w ) ) |
         ( ( o ` ( Base ` w ) ) = { ( 0g ` w ) }
           /\ A. x A. y ( ( x C_ ( Base ` w ) /\ y C_ ( Base ` w ) /\ x C_ y )
                   -> ( o ` y ) C_ ( o ` x ) )
           /\ A. x e. ( LSAtoms ` w )
               ( ( o ` x ) e. ( LSHyp ` w ) /\ ( o ` ( o ` x ) ) = x ) ) } ) $.
  $}

  ${
    $d w x A $.  $d w H $.  $d o w S $.  $d o w V $.  $d o w x y W $.
    $d w .0. $.
    lpolset.v $e |- V = ( Base ` W ) $.
    lpolset.s $e |- S = ( LSubSp ` W ) $.
    lpolset.z $e |- .0. = ( 0g ` W ) $.
    lpolset.a $e |- A = ( LSAtoms ` W ) $.
    lpolset.h $e |- H = ( LSHyp ` W ) $.
    lpolset.p $e |- P = ( LPol ` W ) $.
    $( The set of polarities of a left module or left vector space.
       (Contributed by NM, 24-Nov-2014.)  (New usage is discouraged.) $)
    lpolsetN $p |- ( W e. X -> P = { o e. ( S ^m ~P V ) | ( ( o ` V ) = { .0. }
           /\ A. x A. y ( ( x C_ V /\ y C_ V /\ x C_ y )
                   -> ( o ` y ) C_ ( o ` x ) )
           /\ A. x e. A ( ( o ` x ) e. H /\ ( o ` ( o ` x ) ) = x ) ) } ) $=
      ( cfv wceq wss vw wcel cvv cv csn w3a wi wal wa wral cmap crab elex clpoN
      cpw co cbs c0g clsh clsa fveq2 syl6eqr pweqd oveq12d fveq2d sneqd eqeq12d
      sseq2d 3anbi12d imbi1d 2albidv eleq2d anbi1d raleqbidv 3anbi123d df-lpolN
      clss rabeqbidv ovex rabex fvmpt syl5eq syl ) IJUBIUCUBZDHFUDZRZKUEZSZAUDZ
      HTZBUDZHTZWIWKTZUFZWKWERWIWERZTZUGZBUHAUHZWOGUBZWOWERWISZUIZACUJZUFZFEHUO
      ZUKUPZULZSIJUMWDDIUNRXFQUAIUAUDZUQRZWERZXGURRZUEZSZWIXHTZWKXHTZWMUFZWPUGZ
      BUHAUHZWOXGUSRZUBZWTUIZAXGUTRZUJZUFZFXGVQRZXHUOZUKUPZULXFUCUNXGISZYCXCFYF
      XEYGYDEYEXDUKYGYDIVQREXGIVQVAMVBYGXHHYGXHIUQRHXGIUQVALVBZVCVDYGXLWHXQWRYB
      XBYGXIWFXKWGYGXHHWEYHVEYGXJKYGXJIURRKXGIURVANVBVFVGYGXPWQABYGXOWNWPYGXMWJ
      XNWLWMYGXHHWIYHVHYGXHHWKYHVHVIVJVKYGXTXAAYACYGYAIUTRCXGIUTVAOVBYGXSWSWTYG
      XRGWOYGXRIUSRGXGIUSVAPVBVLVMVNVOVRABUAFVPXCFXEEXDUKVSVTWAWBWC $.

    $d o A $.  $d o H $.  $d o x y ._|_ $.  $d o .0. $.
    $( The predicate "is a polarity".  (Contributed by NM, 24-Nov-2014.)
       (New usage is discouraged.) $)
    islpolN $p |- ( W e. X -> ( ._|_ e. P <-> ( ._|_ : ~P V --> S
      /\ ( ( ._|_ ` V ) = { .0. }
           /\ A. x A. y ( ( x C_ V /\ y C_ V /\ x C_ y )
                   -> ( ._|_ ` y ) C_ ( ._|_ ` x ) )
           /\ A. x e. A
               ( ( ._|_ ` x ) e. H /\ ( ._|_ ` ( ._|_ ` x ) ) = x ) ) ) ) ) $=
      ( wcel cfv wceq vo cv csn wss w3a wi wal wa wral cmap co crab wf lpolsetN
      eleq2d fveq1 eqeq1d sseq12d imbi2d 2albidv eleq1d fveq12d anbi12d ralbidv
      cpw id 3anbi123d elrab clss cvv fvex eqeltri cbs pwex elmap anbi1i syl6bb
      bitri ) IJRZGDRGHUAUBZSZKUCZTZAUBZHUDBUBZHUDWDWEUDUEZWEVTSZWDVTSZUDZUFZBU
      GAUGZWHFRZWHVTSZWDTZUHZACUIZUEZUAEHVEZUJUKZULZRZWREGUMZHGSZWBTZWFWEGSZWDG
      SZUDZUFZBUGAUGZXFFRZXFGSZWDTZUHZACUIZUEZUHZVSDWTGABCDEUAFHIJKLMNOPQUNUOXA
      GWSRZXOUHXPWQXOUAGWSVTGTZWCXDWKXIWPXNXRWAXCWBHVTGUPUQXRWJXHABXRWIXGWFXRWG
      XEWHXFWEVTGUPWDVTGUPZURUSUTXRWOXMACXRWLXJWNXLXRWHXFFXSVAXRWMXKWDXRWHXFVTG
      XRVFXSVBUQVCVDVGVHXQXBXOEWRGEIVISVJMIVIVKVLHHIVMSVJLIVMVKVLVNVOVPVRVQ $.

    $d x y ph $.
    islpold.w $e |- ( ph -> W e. X ) $.
    islpold.1 $e |- ( ph -> ._|_ : ~P V --> S ) $.
    islpold.2 $e |- ( ph -> ( ._|_ ` V ) = { .0. } ) $.
    islpold.3 $e |- ( ( ph /\ ( x C_ V /\ y C_ V /\ x C_ y ) )
                   -> ( ._|_ ` y ) C_ ( ._|_ ` x ) ) $.
    islpold.4 $e |- ( ( ph /\ x e. A ) -> ( ._|_ ` x ) e. H ) $.
    islpold.5 $e |- ( ( ph /\ x e. A ) -> ( ._|_ ` ( ._|_ ` x ) ) = x ) $.
    $( Properties that determine a polarity.  (Contributed by NM,
       26-Nov-2014.)  (New usage is discouraged.) $)
    islpoldN $p |- ( ph -> ._|_ e. P ) $=
      ( wcel cpw wf cfv csn wceq cv wss w3a wi wal wa ex alrimivv jca ralrimiva
      wral 3jca wb islpolN syl mpbir2and ) AHEUEZIUFFHUGZIHUHLUIUJZBUKZIULCUKZI
      ULVJVKULUMZVKHUHVJHUHZULZUNZCUOBUOZVMGUEZVMHUHVJUJZUPZBDVAZUMZTAVIVPVTUAA
      VOBCAVLVNUBUQURAVSBDAVJDUEUPVQVRUCUDUSUTVBAJKUEVGVHWAUPVCSBCDEFGHIJKLMNOP
      QRVDVEVF $.
  $}

  ${
    $d x y ._|_ $.  $d x y W $.
    lpolf.v $e |- V = ( Base ` W ) $.
    lpolf.s $e |- S = ( LSubSp ` W ) $.
    lpolf.p $e |- P = ( LPol ` W ) $.
    lpolf.w $e |- ( ph -> W e. X ) $.
    lpolf.o $e |- ( ph -> ._|_ e. P ) $.
    $( Functionality of a polarity.  (Contributed by NM, 26-Nov-2014.)
       (New usage is discouraged.) $)
    lpolfN $p |- ( ph -> ._|_ : ~P V --> S ) $=
      ( vx vy cfv wceq cv wss wcel eqid cpw wf c0g csn w3a wi clsh wa clsa wral
      wal wb islpolN syl mpbid simpld ) AEUACDUBZEDOFUCOZUDPMQZERNQZERUSUTRUEUT
      DOUSDOZRUFNUKMUKVAFUGOZSVADOUSPUHMFUIOZUJUEZADBSZUQVDUHZLAFGSVEVFULKMNVCB
      CVBDEFGURHIURTVCTVBTJUMUNUOUP $.
  $}

  ${
    $d x y ._|_ $.  $d x y W $.
    lpolv.v $e |- V = ( Base ` W ) $.
    lpolv.z $e |- .0. = ( 0g ` W ) $.
    lpolv.p $e |- P = ( LPol ` W ) $.
    lpolv.w $e |- ( ph -> W e. X ) $.
    lpolv.o $e |- ( ph -> ._|_ e. P ) $.
    $( The polarity of the whole space is the zero subspace.  (Contributed by
       NM, 26-Nov-2014.)  (New usage is discouraged.) $)
    lpolvN $p |- ( ph -> ( ._|_ ` V ) = { .0. } ) $=
      ( vx vy cfv wceq cv wss wcel eqid cpw clss wf csn w3a wi wal clsh wa clsa
      wral wb islpolN syl mpbid simpr1 ) ADUAEUBOZCUCZDCOGUDPZMQZDRNQZDRUTVARUE
      VACOUTCOZRUFNUGMUGZVBEUHOZSVBCOUTPUIMEUJOZUKZUEUIZUSACBSZVGLAEFSVHVGULKMN
      VEBUQVDCDEFGHUQTIVETVDTJUMUNUOURUSVCVFUPUN $.
  $}

  ${
    $d x y ._|_ $.  $d x y V $.  $d x y W $.  $d x y X $.  $d x y Y $.
    lpolcon.v $e |- V = ( Base ` W ) $.
    lpolcon.p $e |- P = ( LPol ` W ) $.
    lpolcon.w $e |- ( ph -> W e. X ) $.
    lpolcon.o $e |- ( ph -> ._|_ e. P ) $.
    lpolcon.x $e |- ( ph -> X C_ V ) $.
    lpolcon.y $e |- ( ph -> Y C_ V ) $.
    lpolcon.c $e |- ( ph -> X C_ Y ) $.
    $( Contraposition property of a polarity.  (Contributed by NM,
       26-Nov-2014.)  (New usage is discouraged.) $)
    lpolconN $p |- ( ph -> ( ._|_ ` Y ) C_ ( ._|_ ` X ) ) $=
      ( vx vy cfv wceq wss wcel cpw clss wf c0g csn cv w3a wi clsh wa clsa wral
      wal wb eqid islpolN syl mpbid simpr2 3jca cbs cvv fvex elpw2 sylibr sseq1
      eqeltri biidd 3anbi123d fveq2 sseq2d imbi12d sseq2 sseq1d sylan9bb spc2gv
      syl2anc mpid syl5 mpd ) ADUAZEUBQZCUCZDCQEUDQZUERZOUFZDSZPUFZDSZWFWHSZUGZ
      WHCQZWFCQZSZUHZPUMOUMZWMEUIQZTWMCQWFRUJOEUKQZULZUGUJZGCQZFCQZSZACBTZWTKAE
      FTXDWTUNJOPWRBWBWQCDEFWDHWBUOWDUOWRUOWQUOIUPUQURWTWPAXCWCWEWPWSUSAWPFDSZG
      DSZFGSZUGZXCAXEXFXGLMNUTAFWATZGWATZWPXHXCUHZUHAXEXILFDDEVAQVBHEVAVCVGZVDV
      EAXFXJMGDXLVDVEWOXKOPFGWAWAWFFRZWOXEWIFWHSZUGZWLXBSZUHWHGRZXKXMWKXOWNXPXM
      WGXEWIWIWJXNWFFDVFXMWIVHWFFWHVFVIXMWMXBWLWFFCVJVKVLXQXOXHXPXCXQXEXEWIXFXN
      XGXQXEVHWHGDVFWHGFVMVIXQWLXAXBWHGCVJVNVLVOVPVQVRVSVT $.
  $}

  ${
    $d x A $.  $d x H $.  $d x y ._|_ $.  $d x Q $.  $d x y W $.
    lpolsat.a $e |- A = ( LSAtoms ` W ) $.
    lpolsat.h $e |- H = ( LSHyp ` W ) $.
    lpolsat.p $e |- P = ( LPol ` W ) $.
    lpolsat.w $e |- ( ph -> W e. X ) $.
    lpolsat.o $e |- ( ph -> ._|_ e. P ) $.
    lpolsat.q $e |- ( ph -> Q e. A ) $.
    $( The polarity of an atomic subspace is a hyperplane.  (Contributed by NM,
       26-Nov-2014.)  (New usage is discouraged.) $)
    lpolsatN $p |- ( ph -> ( ._|_ ` Q ) e. H ) $=
      ( vx vy cfv wceq wss wcel cbs cpw clss wf c0g csn cv w3a wi wal wral eqid
      wa wb islpolN syl mpbid simpr3 fveq2 eleq1d fveq2d id eqeq12d rspcv simpl
      anbi12d syl56 mpd ) AGUAQZUBGUCQZFUDZVIFQGUEQZUFRZOUGZVISPUGZVISVNVOSUHVO
      FQVNFQZSUIPUJOUJZVPETZVPFQZVNRZUMZOBUKZUHUMZDFQZETZAFCTZWCMAGHTWFWCUNLOPB
      CVJEFVIGHVLVIULVJULVLULIJKUOUPUQWCWBAWEWDFQZDRZUMZWEVKVMVQWBURADBTWBWIUIN
      WAWIODBVNDRZVRWEVTWHWJVPWDEVNDFUSZUTWJVSWGVNDWJVPWDFWKVAWJVBVCVFVDUPWEWHV
      EVGVH $.
  $}

  ${
    $d x A $.  $d x y ._|_ $.  $d x Q $.  $d x y W $.
    lpolpolsat.a $e |- A = ( LSAtoms ` W ) $.
    lpolpolsat.p $e |- P = ( LPol ` W ) $.
    lpolpolsat.w $e |- ( ph -> W e. X ) $.
    lpolpolsat.o $e |- ( ph -> ._|_ e. P ) $.
    lpolpolsat.q $e |- ( ph -> Q e. A ) $.
    $( Property of a polarity.  (Contributed by NM, 26-Nov-2014.)
       (New usage is discouraged.) $)
    lpolpolsatN $p |- ( ph -> ( ._|_ ` ( ._|_ ` Q ) ) = Q ) $=
      ( vx vy cfv wceq wss wcel wa eqid cbs cpw clss wf c0g csn cv w3a wal clsh
      wi wral wb islpolN mpbid simpr3 fveq2 eleq1d fveq2d eqeq12d anbi12d rspcv
      syl id simpr syl56 mpd ) AFUAOZUBFUCOZEUDZVHEOFUEOZUFPZMUGZVHQNUGZVHQVMVN
      QUHVNEOVMEOZQUKNUIMUIZVOFUJOZRZVOEOZVMPZSZMBULZUHSZDEOZEOZDPZAECRZWCKAFGR
      WGWCUMJMNBCVIVQEVHFGVKVHTVITVKTHVQTIUNVCUOWCWBAWDVQRZWFSZWFVJVLVPWBUPADBR
      WBWIUKLWAWIMDBVMDPZVRWHVTWFWJVOWDVQVMDEUQZURWJVSWEVMDWJVOWDEWKUSWJVDUTVAV
      BVCWHWFVEVFVG $.
  $}

  ${
    $d x y ._|_ $.  $d x y U $.  $d x y ph $.
    dochpol.h $e |- H = ( LHyp ` K ) $.
    dochpol.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    dochpol.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    dochpol.p $e |- P = ( LPol ` U ) $.
    dochpol.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The subspace orthocomplement for the ` DVecH ` vector space is a
       polarity.  (Contributed by NM, 27-Dec-2014.)
       (New usage is discouraged.) $)
    dochpolN $p |- ( ph -> ._|_ e. P ) $=
      ( vx cfv cvv eqid wcel wss wa syl2anc vy clsa clss clsh cbs c0g cdvh fvex
      eqeltri a1i cpw cdih crn wf dochfN chlt dihsslss syl fss csn doch1 cv w3a
      wceq adantr simpr2 simpr3 dochss syl3anc simpr dochsatshp dochoc islpoldN
      dih1dimat ) AMUACUBNZBCUCNZCUDNZFCUENZCOCUFNZVRPZVPPZVSPZVOPZVQPZKCOQACGE
      UGNZNOJGWEUHUIUJAVRUKZGEULNNZUMZFUNWHVPRZWFVPFUNACDWGEFVRGHWGPZJVTILUOAEU
      PQGDQSZWILVPCDWGEGHJWJWAUQURWFWHVPFUSTAWKVRFNVSUTVDLCDEFVRGVSHJIVTWBVAURA
      MVBZVRRZUAVBZVRRZWLWNRZVCZSWKWOWPWNFNWLFNZRAWKWQLVEAWMWOWPVFAWMWOWPVGCDEF
      VRGWLWNHJVTIVHVIAWLVOQZSZVOWLCDEFGVQHJIWCWDAWKWSLVEZAWSVJZVKWTWKWLWHQZWRF
      NWLVDXAWTWKWSXCXAXBVOWLCDWGEGHJWJWCVNTDWGEFGWLHWJIVLTVM $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.
    lcfl1.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       28-Dec-2014.) $)
    lcfl1lem $p |- ( G e. C
           <-> ( G e. F /\ ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) ) ) $=
      ( cv cfv wceq fveq2 fveq2d eqeq12d elrab2 ) BHZEIZFIZFIZPJDEIZFIZFIZSJBDC
      AODJZRUAPSUBQTFUBPSFODEKZLLUCMGN $.

    lcfl1.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       31-Dec-2014.) $)
    lcfl1 $p |- ( ph
        -> ( G e. C <-> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) ) ) $=
      ( cfv wceq wcel wa biantrurd lcfl1lem syl6rbbr ) AEFJZGJGJQKZEDLZRMEBLASR
      INBCDEFGHOP $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.
    lcfl2.h $e |- H = ( LHyp ` K ) $.
    lcfl2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl2.v $e |- V = ( Base ` U ) $.
    lcfl2.f $e |- F = ( LFnl ` U ) $.
    lcfl2.l $e |- L = ( LKer ` U ) $.
    lcfl2.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl2.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       1-Jan-2015.) $)
    lcfl2 $p |- ( ph -> ( G e. C
         <-> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) =/= V \/ ( L ` G ) = V ) ) ) $=
      ( wcel cfv wceq wne wo lcfl1 dochkrshp4 bitrd ) AFBUBFIUCZJUCJUCZUJUDUKKU
      EUJKUDUFABDEFIJSUAUGACEFGHIJKLMNOPQRTUAUHUI $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.
    lcfl3.h $e |- H = ( LHyp ` K ) $.
    lcfl3.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl3.v $e |- V = ( Base ` U ) $.
    lcfl3.a $e |- A = ( LSAtoms ` U ) $.
    lcfl3.f $e |- F = ( LFnl ` U ) $.
    lcfl3.l $e |- L = ( LKer ` U ) $.
    lcfl3.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl3.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       1-Jan-2015.) $)
    lcfl3 $p |- ( ph -> ( G e. C
         <-> ( ( ._|_ ` ( L ` G ) ) e. A \/ ( L ` G ) = V ) ) ) $=
      ( wcel cfv wne wceq wo lcfl2 dochkrsat2 orbi1d bitrd ) AGCUDGJUEZKUEZKUEL
      UFZUMLUGZUHUNBUDZUPUHACDEFGHIJKLMNOPQSTUAUBUCUIAUOUQUPABDFGHIJKLMNOPQRSTU
      BUCUJUKUL $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.
    lcfl4.h $e |- H = ( LHyp ` K ) $.
    lcfl4.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl4.v $e |- V = ( Base ` U ) $.
    lcfl4.y $e |- Y = ( LSHyp ` U ) $.
    lcfl4.f $e |- F = ( LFnl ` U ) $.
    lcfl4.l $e |- L = ( LKer ` U ) $.
    lcfl4.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl4.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl4.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       1-Jan-2015.)  (New usage is discouraged.) $)
    lcfl4N $p |- ( ph -> ( G e. C
         <-> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) e. Y \/ ( L ` G ) = V ) ) ) $=
      ( wcel cfv clsa wceq wo eqid lcfl3 clss wa dvhlmod lkrssv dochlss syl2anc
      chlt wss dochsatshpb orbi1d bitrd ) AFBUDFIUEZJUEZCUFUEZUDZVBKUGZUHVCJUEM
      UDZVFUHAVDBCDEFGHIJKLNOPQVDUIZSTUAUBUCUJAVEVGVFAVDVCCUKUEZCGHJLMNOPVIUIZV
      HRUBAHUQUDLGUDULVBKURVCVIUDUBAEFIKCQSTACGHLNPUBUMUCUNVICGHJKLVBNPQVJOUOUP
      USUTVA $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.
    lcfl5.h $e |- H = ( LHyp ` K ) $.
    lcfl5.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    lcfl5.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl5.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl5.f $e |- F = ( LFnl ` U ) $.
    lcfl5.l $e |- L = ( LKer ` U ) $.
    lcfl5.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl5.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl5.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       1-Jan-2015.) $)
    lcfl5 $p |- ( ph -> ( G e. C <-> ( L ` G ) e. ran I ) ) $=
      ( wcel cfv wceq crn lcfl1 cbs eqid dvhlmod lkrssv dochoccl bitr4d ) AFBUB
      FJUCZKUCKUCUMUDUMHUEUBABDEFJKSUAUFACGHIKCUGUCZLUMMNPUNUHZOTAEFJUNCUOQRACG
      ILMPTUIUAUJUKUL $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.
    lcfl5a.h $e |- H = ( LHyp ` K ) $.
    lcfl5a.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    lcfl5a.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl5a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl5a.f $e |- F = ( LFnl ` U ) $.
    lcfl5a.l $e |- L = ( LKer ` U ) $.
    lcfl5a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl5a.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  TODO:  Make ~ lcfl5 etc.
       obsolete and rewrite w/out ` C ` hypothesis?  (Contributed by NM,
       29-Jan-2015.) $)
    lcfl5a $p |- ( ph ->
    ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) <-> ( L ` G ) e. ran I ) ) $=
      ( vf cfv cv wceq crab wcel crn eqid lcfl1 lcfl5 bitr3d ) ADSUAHTZITITUJUB
      SCUCZUDDHTZITITULUBULFUEUDAUKSCDHIUKUFZRUGAUKBSCDEFGHIJKLMNOPUMQRUHUI $.
  $}

  ${
    $d k v w .+ $.  $d k w .1. $.  $d k v w ._|_ $.  $d k v R $.  $d k S $.
    $d k v w .x. $.  $d v V $.  $d k v w X $.  $d w .0. $.
    lcfl6lem.h $e |- H = ( LHyp ` K ) $.
    lcfl6lem.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl6lem.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl6lem.v $e |- V = ( Base ` U ) $.
    lcfl6lem.a $e |- .+ = ( +g ` U ) $.
    lcfl6lem.t $e |- .x. = ( .s ` U ) $.
    lcfl6lem.s $e |- S = ( Scalar ` U ) $.
    lcfl6lem.i $e |- .1. = ( 1r ` S ) $.
    lcfl6lem.r $e |- R = ( Base ` S ) $.
    lcfl6lem.z $e |- .0. = ( 0g ` U ) $.
    lcfl6lem.f $e |- F = ( LFnl ` U ) $.
    lcfl6lem.l $e |- L = ( LKer ` U ) $.
    lcfl6lem.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl6lem.g $e |- ( ph -> G e. F ) $.
    lcfl6lem.x $e |- ( ph -> X e. ( ( ._|_ ` ( L ` G ) ) \ { .0. } ) ) $.
    lcfl6lem.y $e |- ( ph -> ( G ` X ) = .1. ) $.
    $( Lemma for ~ lcfl6 .  A functional ` G ` (whose kernel is closed by
       ~ dochsnkr ) is comletely determined by a vector ` X ` in the
       orthocomplement in its kernel at which the functional value is 1.  Note
       that the ` \ { .0. } ` in the ` X ` hypothesis is redundant by the last
       hypothesis but allows easier use of other theorems.  (Contributed by NM,
       3-Jan-2015.) $)
    lcfl6lem $p |- ( ph -> G = ( v e. V |->
      ( iota_ k e. R E. w e. ( ._|_ ` { X } ) v = ( w .+ ( k .x. X ) ) ) ) ) $=
      ( cv co wceq csn cfv wrex crio cmpt c0g eqid dvhlvec chlt wcel wa dvhlmod
      wss lkrssv dochssv syl2anc eldifad wne cdif eldifsni syl eldifsn sylanbrc
      sseldd dochflcl dochsnkr dochsnkr2 eqtr4d dochfl1 dochfln0 eqlkr3 ) AEFKL
      CQCUQBUQJUQSGURDURUSBSUTPVAZVBJEVCVDZOQHSFVEVAZUDUGUIWMVFZUKULAHMNRUAUCUM
      VGALOVAZPVAZQSANVHVIRMVIVJWOQVLWPQVLUMAKLOQHUDUKULAHMNRUAUCUMVKUNVMHMNPQR
      WOUAUCUDUBVNVOASWPTUTZUOVPWCZUNABCFDEGHJKWLMNPQRSTUAUBUCUDUJUEUFUKUGUIWLV
      FZUMASQVISTVQZSQWQVRVIWRASWPWQVRVIWTUOSWPTVSVTSQTWAWBZWDAWOWKWLOVAAHKLMNO
      PQRSTUAUBUCUDUJUKULUMUNUOWEABCFDEGHJWLMNOPQRSTUAUBUCUDUJUEUFULUGUIWSUMXAW
      FWGASLVAISWLVAUPABCFDEGHIJWLMNPQRSTUAUBUCUDUEUFUJUGUIUHUMXAWSWHWGAFHKLMNO
      WMPQRSTUAUBUCUDUGWNUJUKULUMUNUOWIWJ $.
  $}

  ${
    $d k v w .+ $.  $d k v w ._|_ $.  $d w .0. $.  $d k s v R $.  $d k s w S $.
    $d s U $.  $d s v V $.  $d k s v w .x. $.  $d k s v w X $.  $d k s v w Y $.
    $d s ph $.
    lcfl7lem.h $e |- H = ( LHyp ` K ) $.
    lcfl7lem.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl7lem.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl7lem.v $e |- V = ( Base ` U ) $.
    lcfl7lem.a $e |- .+ = ( +g ` U ) $.
    lcfl7lem.t $e |- .x. = ( .s ` U ) $.
    lcfl7lem.s $e |- S = ( Scalar ` U ) $.
    lcfl7lem.r $e |- R = ( Base ` S ) $.
    lcfl7lem.z $e |- .0. = ( 0g ` U ) $.
    lcfl7lem.f $e |- F = ( LFnl ` U ) $.
    lcfl7lem.l $e |- L = ( LKer ` U ) $.
    lcfl7lem.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl7lem.g $e |- G = ( v e. V |->
        ( iota_ k e. R E. w e. ( ._|_ ` { X } ) v = ( w .+ ( k .x. X ) ) ) ) $.
    lcfl7lem.j $e |- J = ( v e. V |->
        ( iota_ k e. R E. w e. ( ._|_ ` { Y } ) v = ( w .+ ( k .x. Y ) ) ) ) $.
    lcfl7lem.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lcfl7lem.x2 $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    lcfl7lem.gj $e |- ( ph -> G = J ) $.
    $( Lemma for ~ lcfl7N .  If two functionals ` G ` and ` J ` are equal, they
       are determined by the same vector.  (Contributed by NM, 4-Jan-2015.) $)
    lcfl7lem $p |- ( ph -> X = Y ) $=
      ( vs cv wceq wrex csn clspn cfv wcel dochsnkr2cl eldifad fveq2d dochsnkr2
      co eqtrd eqid snssd dochocsp chlt wa cdih dihlsprn syl2anc dochoc 3eqtr2d
      crn eleqtrd clmod wb dvhlmod lspsnel mpbid w3a simp3 cmulr cinvr 3ad2ant3
      cur fveq2 dochfl1 fveq1d 3eqtr4rd 3ad2ant1 simp2 lflmul syl112anc 3eqtr3d
      dochflcl crg lmodrng syl lflcl syl3anc cdr c0g wne clvec dvhlvec lvecdrng
      oveq1d drngunz eqnetrd drnginvrcl rngass drnginvrr oveq2d 3eqtrrd rngridm
      syl13anc oveq1 lmodvs1 sylan9eqr mpdan rexlimdv3a mpd ) ASUSUTZTGVKZVAZUS
      EVBZSTVAZASTVCZHVDVEZVEZVFZYPASKOVEZPVEZYTASUUCUAVCZABCFDEGHIKLNOPQRSUAUB
      UCUDUEUJUFUGULUHUIUNUMUPVGVHAUUCYRPVEZPVEYTPVEZPVEZYTAUUBUUEPAUUBMOVEUUEA
      KMOURVIABCFDEGHIMLNOPQRTUAUBUCUDUEUJUFUGULUHUIUOUMUQVJVLVIAUUFUUEPAHLNYSP
      QRYRUBUDUCUEYSVMZUMATQATQUUDUQVHZVNVOVIANVPVFRLVFVQZYTRNVRVEVEZWCVFZUUGYT
      VAUMAUUJTQVFZUULUMUUIHLUUKNYSQRTUBUDUEUUHUUKVMZVSVTLUUKNPRYTUBUUNUCWAVTWB
      WDAHWEVFZUUMUUAYPWFAHLNRUBUDUMWGZUUIGSUSFEYSQHTUHUIUEUGUUHWHVTWIAYOYQUSEA
      YMEVFZYOWJZSYNTAUUQYOWKUURYMFWOVEZVAZYNTVAUURYMUUSFWLVEZVKZTKVEZUVCFWMVEZ
      VEZUVAVKZYMUUSUURUVFYMUVCUVAVKZUVEUVAVKZYMUVFUVAVKZUVBUURUVCUVGUVEUVAUURS
      KVEZYNKVEZUVCUVGYOAUVJUVKVAUUQSYNKWPWNAUUQUVJUVCVAYOATMVEZUUSUVCUVJABCFDE
      GHUUSIMLNPQRTUAUBUCUDUEUFUGUJUHUIUUSVMZUMUQUOWQZATKMURWRZABCFDEGHUUSIKLNP
      QRSUAUBUCUDUEUFUGUJUHUIUVMUMUPUNWQWSWTUURUUOKJVFZUUQUUMUVKUVGVAAUUQUUOYOU
      UPWTAUUQUVPYOABCFDEGHIJKLNPQRSUAUBUCUDUEUJUFUGUKUHUIUNUMUPXEZWTAUUQYOXAZA
      UUQUUMYOUUIWTFYMGUVAJKEQHTUHUIUVAVMZUEUGUKXBXCXDXQUURFXFVFZUUQUVCEVFZUVEE
      VFZUVHUVIVAAUUQUVTYOAUUOUVTUUPFHUHXGXHWTZUVRAUUQUWAYOAUUOUVPUUMUWAUUPUVQU
      UIFJKEQHTWEUHUIUEUKXIXJZWTAUUQUWBYOAFXKVFZUWAUVCFXLVEZXMZUWBAHXNVFUWEAHLN
      RUBUDUMXOFHUHXPXHZUWDAUVCUUSUWFAUVCUVLUUSUVOUVNVLAUWEUUSUWFXMUWHFUUSUWFUW
      FVMZUVMXRXHXSZEFUVDUVCUWFUIUWIUVDVMZXTXJWTEFUVAYMUVCUVEUIUVSYAYFUURUVFUUS
      YMUVAAUUQUVFUUSVAZYOAUWEUWAUWGUWLUWHUWDUWJEFUVAUUSUVDUVCUWFUIUWIUVSUVMUWK
      YBXJWTZYCYDUURUVTUUQUVBYMVAUWCUVREFUVAUUSYMUIUVSUVMYEVTUWMXDUUTUURYNUUSTG
      VKZTYMUUSTGYGAUUQUWNTVAZYOAUUOUUMUWOUUPUUIGUUSFQHTUEUHUGUVMYHVTWTYIYJVLYK
      YL $.
  $}

  ${
    $d k v w .+ $.  $d f k v w x ._|_ $.  $d w x .0. $.  $d x C $.  $d f x G $.
    $d f F $.  $d f x L $.  $d x ph $.  $d k v R $.  $d k w x S $.  $d v x V $.
    $d x U $.  $d k v w .x. $.
    lcfl6.h $e |- H = ( LHyp ` K ) $.
    lcfl6.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl6.v $e |- V = ( Base ` U ) $.
    lcfl6.a $e |- .+ = ( +g ` U ) $.
    lcfl6.t $e |- .x. = ( .s ` U ) $.
    lcfl6.s $e |- S = ( Scalar ` U ) $.
    lcfl6.r $e |- R = ( Base ` S ) $.
    lcfl6.z $e |- .0. = ( 0g ` U ) $.
    lcfl6.f $e |- F = ( LFnl ` U ) $.
    lcfl6.l $e |- L = ( LKer ` U ) $.
    lcfl6.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl6.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  Note that
       ` ( L `` G ) = V ` means the functional is zero by ~ lkr0f .
       (Contributed by NM, 3-Jan-2015.) $)
    lcfl6 $p |- ( ph -> ( G e. C <-> ( ( L ` G ) = V
   \/ E. x e. ( V \ { .0. } ) G = ( v e. V |->
  ( iota_ k e. R E. w e. ( ._|_ ` { x } ) v = ( w .+ ( k .x. x ) ) ) ) ) ) ) $=
      ( wcel cfv wceq cv co csn wrex crio cmpt cdif wo wa wn wne df-ne cur eqid
      chlt ad2antrr biimpa orcomd ord syl5bi imp dochkr1 dvhlmod lkrssv dochssv
      lcfl2 wss syl2anc ssdifd ad3antrrr simprl sseldd simprr lcfl6lem reximdv2
      jca mpd syl5bir orrd olc syl5ibr w3a cdih crn adantr eldifi adantl dochcl
      ex snssd dochoc 3adant3 simp3 fveq2d simpr dochsnkr2 eqtrd 3ad2ant1 lcfl1
      3eqtr4d mpbird rexlimdv3a jaod impbid ) ANEUPZNQUQZSURZNDSDUSCUSLUSBUSZIU
      TFUTURCYFVAZRUQZVBLGVCVDZURZBSUAVAZVEZVBZVFZAYCYNAYCVGZYEYMYEVHZYDSVIZYOY
      MYDSVJZYOYQYMYOYQVGZYFNUQHVKUQZURZBYDRUQZYKVEZVBYMYSBHJYTMNOPQRSTUAUBUCUD
      UEUHUJYTVLZUKULAPVMUPTOUPVGZYCYQUNVNANMUPZYCYQUOVNYOYQUUBRUQZSVIZYQYPYOUU
      HYRYOYEUUHYOUUHYEAYCUUHYEVFZAEJKMNOPQRSTUBUCUDUEUKULUMUNUOWDZVOVPVQVRVSVT
      YSUUAYJBUUCYLYSYFUUCUPZUUAVGZYFYLUPZYJVGYSUULVGZUUMYJUUNUUCYLYFAUUCYLWEYC
      YQUULAUUBSYKAUUEYDSWEUUBSWEUNAMNQSJUEUKULAJOPTUBUDUNWAUOWBJOPRSTYDUBUDUEU
      CWCWFWGWHYSUUKUUAWIZWJUUNCDFGHIJYTLMNOPQRSTYFUAUBUCUDUEUFUGUHUUDUIUJUKULA
      UUEYCYQUULUNWHAUUFYCYQUULUOWHUUOYSUUKUUAWKWLWNXGWMWOXGWPWQXGAYEYCYMYEYCAU
      UIYEUUHWRUUJWSAYJYCBYLAUUMYJWTZYCUUGYDURUUPYHRUQZRUQZYHUUGYDAUUMUURYHURZY
      JAUUMVGZUUEYHTPXAUQUQZXBUPZUUSAUUEUUMUNXCZUUTUUEYGSWEUVBUVCUUTYFSUUMYFSUP
      AYFSYKXDXEXHJOUVAPRSTYGUBUVAVLZUDUEUCXFWFOUVAPRTYHUBUVDUCXIWFXJUUPUUBUUQR
      UUPYDYHRUUPYDYIQUQZYHUUPNYIQAUUMYJXKXLAUUMUVEYHURYJUUTCDHFGIJLYIOPQRSTYFU
      AUBUCUDUEUJUFUGULUHUIYIVLUVCAUUMXMXNXJXOZXLXLUVFXRUUPEKMNQRUMAUUMUUFYJUOX
      PXQXSXTYAYB $.

    $d k l u v w y z $.  $d l u x y z .+ $.  $d y G $.  $d y ph $.  $d l z S $.
    $d l u y z ._|_ $.  $d y z .0. $.  $d l u x y R $.  $d l u x y z .x. $.
    $d l z U $.  $d u y V $.
    $( Property of a functional with a closed kernel.  Every nonzero functional
       is determined by a unique nonzero vector.  Note that ` ( L `` G ) = V `
       means the functional is zero by ~ lkr0f .  (Contributed by NM,
       4-Jan-2015.)  (New usage is discouraged.) $)
    lcfl7N $p |- ( ph -> ( G e. C <-> ( ( L ` G ) = V
   \/ E! x e. ( V \ { .0. } ) G = ( v e. V |->
  ( iota_ k e. R E. w e. ( ._|_ ` { x } ) v = ( w .+ ( k .x. x ) ) ) ) ) ) ) $=
      ( vy vz vu vl wcel cfv wceq cv co csn wrex crio cmpt cdif wo lcfl6 wa weq
      wreu wi wral chlt ad2antrr simplrl simplrr simprl eqeq1 rexbidv riotabidv
      oveq1 oveq2d eqeq2d cbvrexv syl6bb cbvriotav syl6eq cbvmptv simprr eqtr3d
      eqid lcfl7lem ex ralrimivva a1d ancld sneq fveq2d rexeqbidv mpteq2dv reu4
      oveq2 syl6ibr reurex impbid1 orbi2d bitrd ) ANEUTNQVASVBZNDSDVCZCVCZLVCZB
      VCZIVDZFVDZVBZCXPVEZRVAZVFZLGVGZVHZVBZBSUAVEVIZVFZVJXLYEBYFVNZVJABCDEFGHI
      JKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVKAYGYHXLAYGYHAYGYGYENDSXMXNXOUP
      VCZIVDZFVDZVBZCYIVEZRVAZVFZLGVGZVHZVBZVLZBUPVMZVOZUPYFVPBYFVPZVLYHAYGUUBA
      UUBYGAUUABUPYFYFAXPYFUTZYIYFUTZVLZVLZYSYTUUFYSVLZUQURFGHIJUSMURSURVCZUQVC
      ZUSVCZXPIVDZFVDZVBZUQYAVFZUSGVGZVHZOURSUUHUUIUUJYIIVDZFVDZVBZUQYNVFZUSGVG
      ZVHZPQRSTXPYIUAUBUCUDUEUFUGUHUIUJUKULAPVQUTTOUTVLUUEYSUNVRUUPWOUVBWOAUUCU
      UDYSVSAUUCUUDYSVTUUGNUUPUVBUUGNYDUUPUUFYEYRWADURSYCUUODURVMZYCUUHXRVBZCYA
      VFZLGVGUUOUVCYBUVELGUVCXSUVDCYAXMUUHXRWBWCWDUVEUUNLUSGLUSVMZUVEUUHXNUUKFV
      DZVBZCYAVFUUNUVFUVDUVHCYAUVFXRUVGUUHUVFXQUUKXNFXOUUJXPIWEWFWGWCUVHUUMCUQY
      ACUQVMZUVGUULUUHXNUUIUUKFWEWGWHWIWJWKWLWKUUGNYQUVBUUFYEYRWMDURSYPUVAUVCYP
      UUHYKVBZCYNVFZLGVGUVAUVCYOUVKLGUVCYLUVJCYNXMUUHYKWBWCWDUVKUUTLUSGUVFUVKUU
      HXNUUQFVDZVBZCYNVFUUTUVFUVJUVMCYNUVFYKUVLUUHUVFYJUUQXNFXOUUJYIIWEWFWGWCUV
      MUUSCUQYNUVIUVLUURUUHXNUUIUUQFWEWGWHWIWJWKWLWKWNWPWQWRWSWTYEYRBUPYFYTYDYQ
      NYTDSYCYPYTYBYOLGYTXSYLCYAYNYTXTYMRXPYIXAXBYTXRYKXMYTXQYJXNFXPYIXOIXFWFWG
      XCWDXDWGXEXGYEBYFXHXIXJXK $.
  $}

  ${
    $d x C $.  $d f F $.  $d f x G $.  $d f x L $.  $d f x ._|_ $.  $d x U $.
    $d x V $.  $d x ph $.
    lcfl8.h $e |- H = ( LHyp ` K ) $.
    lcfl8.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl8.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl8.v $e |- V = ( Base ` U ) $.
    lcfl8.f $e |- F = ( LFnl ` U ) $.
    lcfl8.l $e |- L = ( LKer ` U ) $.
    lcfl8.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl8.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl8.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       17-Jan-2015.) $)
    lcfl8 $p |- ( ph ->
      ( G e. C <-> E. x e. V ( L ` G ) = ( ._|_ ` { x } ) ) ) $=
      ( wcel cfv cv csn wceq wrex wa clsa clspn clmod dvhlmod adantr eqid sylan
      islsati simpr fveq2d simp-4r ad4antr lcfl1 mpbid simplr snssd dochocsp ex
      chlt 3eqtr3d reximdva mpd c0g lmod0vcl doch0 eqtr4d eqeq2d rspcev syl2anc
      syl sneq wo lcfl3 biimpa mpjaodan w3a cdih crn 3ad2ant1 wss dochcl dochoc
      simp2 simp3 3eqtr4d rexlimdv3a sylibrd impbid ) AGCUCZGJUDZBUEZUFZKUDZUGZ
      BLUHZAWRXDAWRUIZWSKUDZDUJUDZUCZXDWSLUGZXEXHUIZXFXADUKUDZUDZUGZBLUHZXDXEDU
      LUCZXHXNAXOWRADHIMNPUAUMUNZBXGXFXKLDULQXKUOZXGUOZUQUPXJXMXCBLXJWTLUCZUIZX
      MXCXTXMUIZXFKUDZXLKUDWSXBYAXFXLKXTXMURUSYAWRYBWSUGZAWRXHXSXMUTYACEFGJKTAG
      FUCWRXHXSXMUBVAVBVCYADHIXKKLMXANPOQXQAIVHUCMHUCUIZWRXHXSXMUAVAYAWTLXJXSXM
      VDVEVFVIVGVJVKXEXIUIZDVLUDZLUCZWSYFUFZKUDZUGZXDYEXOYGXEXOXIXPUNLDYFQYFUOZ
      VMVSYEWSLYIXEXIURYEYDYILUGXEYDXIAYDWRUAUNUNDHIKLMYFNPOQYKVNVSVOXCYJBYFLWT
      YFUGZXBYIWSYLXAYHKWTYFVTUSVPVQVRAWRXHXIWAAXGCDEFGHIJKLMNOPQXRRSTUAUBWBWCW
      DVGAXDYCWRAXCYCBLAXSXCWEZXBKUDZKUDZXBYBWSYMYDXBMIWFUDUDZWGUCZYOXBUGAXSYDX
      CUAWHZYMYDXALWIYQYRYMWTLAXSXCWLVEDHYPIKLMXANYPUOZPQOWJVRHYPIKMXBNYSOWKVRY
      MXFYNKYMWSXBKAXSXCWMZUSUSYTWNWOACEFGJKTUBVBWPWQ $.
  $}

  ${
    $d f x F $.  $d f x G $.  $d f x L $.  $d f x ._|_ $.  $d x U $.  $d x V $.
    $d x ph $.
    lcfl8a.h $e |- H = ( LHyp ` K ) $.
    lcfl8a.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl8a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl8a.v $e |- V = ( Base ` U ) $.
    lcfl8a.f $e |- F = ( LFnl ` U ) $.
    lcfl8a.l $e |- L = ( LKer ` U ) $.
    lcfl8a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl8a.g $e |- ( ph -> G e. F ) $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       17-Jan-2015.) $)
    lcfl8a $p |- ( ph -> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G )
                  <-> E. x e. V ( L ` G ) = ( ._|_ ` { x } ) ) ) $=
      ( cfv vf cv wceq crab wcel csn wrex eqid lcfl1 lcfl8 bitr3d ) AEUAUBHTZIT
      ITULUCUADUDZUEEHTZITITUNUCUNBUBUFITUCBJUGAUMUADEHIUMUHZSUIABUMCUADEFGHIJK
      LMNOPQUORSUJUK $.
  $}

  ${
    $d x C $.  $d f F $.  $d f x G $.  $d f x L $.  $d f x ._|_ $.  $d x U $.
    $d x V $.  $d x ph $.
    lcfl8b.h $e |- H = ( LHyp ` K ) $.
    lcfl8b.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl8b.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl8b.v $e |- V = ( Base ` U ) $.
    lcfl8b.n $e |- N = ( LSpan ` U ) $.
    lcfl8b.z $e |- .0. = ( 0g ` U ) $.
    lcfl8b.f $e |- F = ( LFnl ` U ) $.
    lcfl8b.l $e |- L = ( LKer ` U ) $.
    lcfl8b.d $e |- D = ( LDual ` U ) $.
    lcfl8b.y $e |- Y = ( 0g ` D ) $.
    lcfl8b.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfl8b.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl8b.g $e |- ( ph -> G e. ( C \ { Y } ) ) $.
    $( Property of a nonzero functional with a closed kernel.  (Contributed by
       NM, 4-Feb-2015.) $)
    lcfl8b $p |- ( ph
     -> E. x e. ( V \ { .0. } ) ( ._|_ ` ( L ` G ) ) = ( N ` { x } ) ) $=
      ( cv wne cfv csn wceq wrex cdif wcel eldifad lcfl1lem simplbi lcfl8 mpbid
      wa syl clsa fveq2 adantl chlt ad2antrr simplr dochocsn eqtrd sylib simprd
      eldifsni dvhlmod lkr0f2 necon3bid mpbird eqnetrd eqid dochkrsat2 eqeltrrd
      clmod lsatspn0 jca ex reximdva mpd rexdifsn sylibr ) ABUKZQULZHKUMZMUMZWM
      UNZLUMZUOZVDZBNUPZWSBNQUNUQUPAWOWQMUMZUOZBNUPZXAAHCURZXDAHCPUNZUJUSZABCEF
      GHIJKMNORSTUAUDUEUHUIAXEHGURZXGXEXHWPMUMZWOUOZCFGHKMUHUTZVAVEZVBVCAXCWTBN
      AWMNURZVDZXCWTXNXCVDZWNWSXOWREVFUMZURWNXOWPWRXPXOWPXBMUMZWRXCWPXQUOXNWOXB
      MVGVHXOEIJLMNOWMRTSUAUBAJVIUROIURVDXMXCUIVJZAXMXCVKZVLVMZXOXINULZWPXPURAY
      AXMXCAXIWONAXHXJAXEXHXJVDXGXKVNVOAWONULHPULZAHCXFUQURYBUJHCPVPVEAWONHPADG
      HKNEPUAUDUEUFUGAEIJORTUIVQZXLVRVSVTWAVJXOXPEGHIJKMNORSTUAXPWBZUDUEXRAXHXM
      XCXLVJWCVCWDXOXPLNEWMQUAUBUCYDAEWEURXMXCYCVJXSWFVCXTWGWHWIWJWSBNQWKWL $.
  $}

  ${
    lcfl9a.h $e |- H = ( LHyp ` K ) $.
    lcfl9a.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfl9a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfl9a.v $e |- V = ( Base ` U ) $.
    lcfl9a.f $e |- F = ( LFnl ` U ) $.
    lcfl9a.l $e |- L = ( LKer ` U ) $.
    lcfl9a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfl9a.g $e |- ( ph -> G e. F ) $.
    lcfl9a.x $e |- ( ph -> X e. V ) $.
    lcfl9a.s $e |- ( ph -> ( ._|_ ` { X } ) C_ ( L ` G ) ) $.
    $( Property implying that a functional has a closed kernel.  (Contributed
       by NM, 16-Feb-2015.) $)
    lcfl9a $p |- ( ph -> ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) ) $=
      ( cfv wceq c0g wa dochoc1 adantr wss dvhlmod lkrssv sneq fveq2d chlt wcel
      csn eqid doch0 syl sylan9eqr eqsstr3d eqssd 3eqtr4d simpr wne cdih dochcl
      crn snssd syl2anc dochoc clsh clvec dvhlvec cdif simprl eldifsn dochsnshp
      sylanbrc simprr wb lkrshp4 mpbid lshpcmp 3eqtr3d pm2.61da2ne ) ADGUBZHUBZ
      HUBZWFUCKBUDUBZWFIAKWIUCZUEZIHUBZHUBZIWHWFAWMIUCZWJABEFHIJLNMORUFZUGWKWGW
      LHWKWFIHWKWFIAWFIUHWJACDGIBOPQABEFJLNRUISUJUGWKIKUOZHUBZWFWJAWQWIUOZHUBZI
      WJWPWRHKWIUKULAFUMUNJEUNUEZWSIUCRBEFHIJWILNMOWIUPZUQURUSAWQWFUHZWJUAUGUTV
      AZULULXCVBAWFIUCZUEZWMIWHWFAWNXDWOUGXEWGWLHXEWFIHAXDVCZULULXFVBAKWIVDZWFI
      VDZUEZUEZWQHUBZHUBZWQWHWFAXLWQUCZXIAWTWQJFVEUBUBZVGUNZXMRAWTWPIUHXORAKITV
      HBEXNFHIJWPLXNUPZNOMVFVIEXNFHJWQLXPMVJVIUGXJXKWGHXJWQWFHXJXBWQWFUCAXBXIUA
      UGXJWQWFBVKUBZBXQUPZABVLUNXIABEFJLNRVMZUGXJBEFHIJKXQWILMNOXAXRAWTXIRUGXJK
      IUNZXGKIWRVNUNAXTXITUGAXGXHVOKIWIVPVRVQXJXHWFXQUNZAXGXHVSAXHYAVTXIACDXQGI
      BOXRPQXSSWAUGWBWCWBZULULYBWDWE $.
  $}

  ${
    $d f F $.  $d f L $.  $d f ._|_ $.  $d f .x. $.  $d f G $.  $d f X $.
    lclkrlem1.h $e |- H = ( LHyp ` K ) $.
    lclkrlem1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem1.f $e |- F = ( LFnl ` U ) $.
    lclkrlem1.l $e |- L = ( LKer ` U ) $.
    lclkrlem1.d $e |- D = ( LDual ` U ) $.
    lclkrlem1.r $e |- R = ( Scalar ` U ) $.
    lclkrlem1.b $e |- B = ( Base ` R ) $.
    lclkrlem1.t $e |- .x. = ( .s ` D ) $.
    lclkrlem1.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lclkrlem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem1.x $e |- ( ph -> X e. B ) $.
    lclkrlem1.g $e |- ( ph -> G e. C ) $.
    $( The set of functionals having closed kernels is closed under scalar
       product.  (Contributed by NM, 28-Dec-2014.) $)
    lclkrlem1 $p |- ( ph -> ( X .x. G ) e. C ) $=
      ( co wcel cfv wceq dvhlmod wa lcfl1lem sylib simpld ldualvscl c0g dochoc1
      cbs eqid adantr oveq1 fveq2d csn cxp clmod lduallmod ldualelvbase lmod0vs
      syl2anc ldual0 oveq1d ldual0v 3eqtr3d wb lfl0f syl lkr0f mpbiri sylan9eqr
      csca eqtrd 3eqtr4d wne simprd clvec dvhlvec ldualkrsc pm2.61dane sylanbrc
      simpr ) APJFUJZIUKWOMULZNULZNULZWPUMZWOCUKADEFIJBGPTUCUDUBUEAGKLOQSUGUNZU
      HAJIUKZJMULZNULZNULZXBUMZAJCUKXAXEUOUICHIJMNUFUPUQZURZUSAWSPEUTULZAPXHUMZ
      UOZGVBULZNULZNULZXKWRWPAXMXKUMXIAGKLNXKOQSRXKVCZUGVAVDXJWQXLNXJWPXKNXIAWP
      XHJFUJZMULZXKXIWOXOMPXHJFVEVFAXPXKXHVGVHZMULZXKAXOXQMADWDULZUTULZJFUJZDUT
      ULZXOXQADVIUKJDVBULZUKYAYBUMADGUBWTVJADIJYCGVITUBYCVCZWTXGVKFXSXTYCDJYBYD
      XSVCZUEXTVCZYBVCZVLVMAXTXHJFADEXSXTGXHUCXHVCZUBYEYFWTVNVOADEYBXKGXHXNUCYH
      UBYGWTVPVQVFAXRXKUMZXQXQUMZXQVCAGVIUKZXQIUKZYIYJVRWTAYKYLWTEIXKGXHUCYHXNT
      VSVTEIXQMXKGXHUCYHXNTUAWAVMWBWEWCZVFVFYMWFAPXHWGZUOZXDXBWRWPAXEYNAXAXEXFW
      HVDYOWQXCNYOWPXBNYODEFIJBMGPXHUCUDYHTUAUBUEAGWIUKYNAGKLOQSUGWJVDAXAYNXGVD
      APBUKYNUHVDAYNWNWKZVFVFYPWFWLCHIWOMNUFUPWM $.
  $}

  ${
    lclkrlem2a.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2a.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2a.v $e |- V = ( Base ` U ) $.
    lclkrlem2a.z $e |- .0. = ( 0g ` U ) $.
    lclkrlem2a.p $e |- .(+) = ( LSSum ` U ) $.
    lclkrlem2a.n $e |- N = ( LSpan ` U ) $.
    lclkrlem2a.a $e |- A = ( LSAtoms ` U ) $.
    lclkrlem2a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem2a.b $e |- ( ph -> B e. ( V \ { .0. } ) ) $.
    lclkrlem2a.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lclkrlem2a.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    lclkrlem2a.e $e |- ( ph -> ( ._|_ ` { X } ) =/= ( ._|_ ` { Y } ) ) $.
    ${
      lclkrlem2a.d $e |- ( ph -> -. X e. ( ._|_ ` { B } ) ) $.
      $( Lemma for ~ lclkr .  Use ~ lshpat to show that the intersection of a
         hyperplane with a noncomparable sum of atoms is an atom.  (Contributed
         by NM, 16-Jan-2015.) $)
      lclkrlem2a $p |- ( ph
     -> ( ( ( N ` { X } ) .(+) ( N ` { Y } ) ) i^i ( ._|_ ` { B } ) ) e. A ) $=
        ( csn cfv clss clsh eqid dvhlvec dochsnshp dvhlmod lsatlspsn wceq snssd
        wne eldifad dochocsp eqeq12d cdih chlt wcel crn dihlsprn syl2anc doch11
        wa bitr3d necon3bid mpbid wss dochlss lspsnel5 mtbid lshpat ) ABDLUIZHU
        JZMUIZHUJZEUKUJZCUIZIUJZEULUJZEWDUMZTWGUMZUBAEFGKOQUCUNAEFGIJKCWGNOPQRS
        WIUCUDUOABHJELNRUASUBAEFGKOQUCUPZUEUQABHJEMNRUASUBWJUFUQAVTIUJZWBIUJZUT
        WAWCUTUGAWKWLWAWCAWAIUJZWCIUJZURWKWLURWAWCURAWMWKWNWLAEFGHIJKVTOQPRUAUC
        ALJALJNUIZUEVAZUSVBAEFGHIJKWBOQPRUAUCAMJAMJWOUFVAZUSVBVCAFKGVDUJUJZGIKW
        AWCOWRUMZPUCAGVEVFKFVFVKZLJVFWAWRVGZVFUCWPEFWRGHJKLOQRUAWSVHVIAWTMJVFWC
        XAVFUCWQEFWRGHJKMOQRUAWSVHVIVJVLVMVNALWFVFWAWFVOUHAWDWFHJELRWHUAWJAWTWE
        JVOWFWDVFUCACJACJWOUDVAUSWDEFGIJKWEOQRWHPVPVIWPVQVRVS $.
    $}

    lclkrlem2b.da $e |- ( ph
               -> ( -. X e. ( ._|_ ` { B } ) \/ -. Y e. ( ._|_ ` { B } ) ) ) $.
    $( Lemma for ~ lclkr .  (Contributed by NM, 17-Jan-2015.) $)
    lclkrlem2b $p |- ( ph
     -> ( ( ( N ` { X } ) .(+) ( N ` { Y } ) ) i^i ( ._|_ ` { B } ) ) e. A ) $=
      ( csn cfv wcel wn co cin chlt adantr cdif wne simpr lclkrlem2a wceq cabel
      wa csubg clmod dvhlmod lmodabl syl clss lsssssubg eldifad lspsncl syl2anc
      wss eqid sseldd lsmcom syl3anc ineq1d necomd eqeltrd mpjaodan ) ALCUIIUJZ
      UKULZLUIZHUJZMUIZHUJZDUMZWCUNZBUKMWCUKULZAWDVCBCDEFGHIJKLMNOPQRSTUAUBAGUO
      UKKFUKVCZWDUCUPACJNUIZUQZUKZWDUDUPALWNUKZWDUEUPAMWNUKZWDUFUPAWEIUJZWGIUJZ
      URWDUGUPAWDUSUTAWKVCZWJWHWFDUMZWCUNZBAWJXBVAWKAWIXAWCAEVBUKZWFEVDUJZUKWHX
      DUKWIXAVAAEVEUKZXCAEFGKOQUCVFZEVGVHAEVIUJZXDWFAXEXGXDVNXFXGEXGVOZVJVHZAXE
      LJUKWFXGUKXFALJWMUEVKXGHJELRXHUAVLVMVPAXGXDWHXIAXEMJUKWHXGUKXFAMJWMUFVKXG
      HJEMRXHUAVLVMVPDWFWHETVQVRVSUPWTBCDEFGHIJKMLNOPQRSTUAUBAWLWKUCUPAWOWKUDUP
      AWQWKUFUPAWPWKUEUPAWSWRURWKAWRWSUGVTUPAWKUSUTWAUHWB $.

    ${
      lclkrlem2c.j $e |- J = ( LSHyp ` U ) $.
      $( Lemma for ~ lclkr .  (Contributed by NM, 16-Jan-2015.) $)
      lclkrlem2c $p |- ( ph ->
     ( ( ( ._|_ ` { X } ) i^i ( ._|_ ` { Y } ) ) .(+) ( N ` { B } ) ) e. J ) $=
        ( csn cfv cin cdjh cdih eqid chlt wcel eldifad dihlsprn syl2anc dvhlmod
        co wa crn lsatlspsn dihsmatrn wss snssd dochcl dochdmm1 cun df-pr lsmpr
        cpr fveq2i syl5reqr fveq2d unssd dochocsp wceq dochdmj1 3eqtrd dochocsn
        syl3anc oveq12d dihmeetcl dihjat1 3eqtrrd lclkrlem2b dochsatshp eqeltrd
        syl12anc ) AMUKZJULZNUKZJULZUMZCUKZIULZDVCZWNIULZWPIULZDVCZWSJULZUMZJUL
        ZGAXGXDJULZXEJULZLHUNULULZVCWRWTXJVCXAAEFLHUOULULZXJHJKLXDXEPXKUPZRSQXJ
        UPZUDABDXCEFXKHLXBPXLRUAUCUDAHUQURLFURVDZMKURXBXKVEZURUDAMKOUKZUFUSZEFX
        KHIKLMPRSUBXLUTVAABIKENOSUBTUCAEFHLPRUDVBZUGVFVGAXNWSKVHXEXOURUDACKACKX
        PUEUSZVIEFXKHJKLWSPXLRSQVJVAVKAXHWRXIWTXJAXHWNWPVLZIULZJULXTJULZWRAXDYA
        JAYAMNVOZIULXDYCXTIMNVMVPADIKEMNSUBUAXRXQANKXPUGUSZVNVQVRAEFHIJKLXTPRQS
        UBUDAWNWPKAMKXQVIZANKYDVIZVSVTAXNWNKVHZWPKVHZYBWRWAUDYEYFEFHJKLWNWPPRSQ
        WBWEWCAEFHIJKLCPRQSUBUDXSWDWFADCEFXKXJHIKLWRPRSUAUBXLXMUDAXNWOXOURZWQXO
        URZWRXOURUDAXNYGYIUDYEEFXKHJKLWNPXLRSQVJVAAXNYHYJUDYFEFXKHJKLWPPXLRSQVJ
        VAFXKHLWOWQPXLWGWMXSWHWIABXFEFHJLGPRQUCUJUDABCDEFHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIWJWKWL $.
    $}

    ${
      lclkrlem2d.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
      $( Lemma for ~ lclkr .  (Contributed by NM, 16-Jan-2015.) $)
      lclkrlem2d $p |- ( ph ->
 ( ( ( ._|_ ` { X } ) i^i ( ._|_ ` { Y } ) ) .(+) ( N ` { B } ) ) e. ran I ) $=
        ( csn cfv cin chlt wcel crn wss eldifad snssd dochcl dihmeetcl syl12anc
        wa syl2anc dihsmsprn ) ADCEFGHIKLMUKZJULZNUKZJULZUMZPRSUAUBUJUDAHUNUOLF
        UOVCZVGGUPZUOZVIVLUOZVJVLUOUDAVKVFKUQVMUDAMKAMKOUKZUFURUSEFGHJKLVFPUJRS
        QUTVDAVKVHKUQVNUDANKANKVOUGURUSEFGHJKLVHPUJRSQUTVDFGHLVGVIPUJVAVBACKVOU
        EURVE $.
    $}
  $}

  ${
    lclkrlem2e.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2e.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2e.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2e.v $e |- V = ( Base ` U ) $.
    lclkrlem2e.z $e |- .0. = ( 0g ` U ) $.
    lclkrlem2e.f $e |- F = ( LFnl ` U ) $.
    lclkrlem2e.l $e |- L = ( LKer ` U ) $.
    lclkrlem2e.d $e |- D = ( LDual ` U ) $.
    lclkrlem2e.p $e |- .+ = ( +g ` D ) $.
    lclkrlem2e.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem2e.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lclkrlem2e.e $e |- ( ph -> E e. F ) $.
    lclkrlem2e.g $e |- ( ph -> G e. F ) $.
    lclkrlem2e.le $e |- ( ph -> ( L ` E ) = ( ._|_ ` { X } ) ) $.
    lclkrlem2e.ne $e |- ( ph -> ( L ` E ) = ( L ` G ) ) $.
    $( Lemma for ~ lclkr .  The kernel of the sum is closed when the kernels of
       the summands are equal and closed.  (Contributed by NM, 17-Jan-2015.) $)
    lclkrlem2e $p |- ( ph
     -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
      ( co cfv clsh wcel wceq csn chlt cdih crn adantr wss eldifad snssd dochcl
      wa eqid syl2anc dochoc inidm ineq2d syl5eqr dvhlmod lkrin eqsstrd dvhlvec
      cin clvec clspn dochocsp eqtr4d clsa lsatlspsn dochsatshp eqeltrd lshpcmp
      simpr mpbid eqtr3d fveq2d 3eqtr3d ex dochoc1 fveq2 id eqeq12d ldualvaddcl
      syl5ibrcom lkrshpor mpjaod ) AEGCUKZJULZDUMULZUNZXAKULZKULZXAUOZXALUOZAXC
      XFAXCVEZNUPZKULZKULZKULZXJXEXAXHIUQUNMHUNVEZXJMIURULULZUSUNZXLXJUOAXMXCUE
      UTZXHXMXILVAZXOXPAXQXCANLANLOUPUFVBVCZUTDHXNIKLMXIPXNVFZRSQVDVGHXNIKMXJPX
      SQVHVGXHXKXDKXHXJXAKXHEJULZXJXAAXTXJUOXCUIUTZXHXTXAVAZXTXAUOAYBXCAXTXTGJU
      LZVPZXAAXTXTXTVPYDXTVIAXTYCXTUJVJVKABCFEGJDUAUBUCUDADHIMPRUEVLZUGUHVMVNUT
      XHXTXAXBDXBVFZADVQUNXCADHIMPRUEVOZUTXHXTXIDVRULZULZKULZXBXHXTXJYJYAAYJXJU
      OXCADHIYHKLMXIPRQSYHVFZUEXRVSUTVTXHDWAULZYIDHIKMXBPRQYLVFZYFXPAYIYLUNXCAY
      LYHLDNOSYKTYMYEUFWBUTWCWDAXCWFWEWGWHZWIWIYNWJWKAXFXGLKULZKULZLUOADHIKLMPR
      QSUEWLXGXEYPXALXGXDYOKXALKWMWIXGWNWOWQAFWTXBJLDSYFUAUBYGABCFEGDUAUCUDYEUG
      UHWPWRWS $.
  $}

  ${
    lclkrlem2f.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2f.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2f.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2f.v $e |- V = ( Base ` U ) $.
    lclkrlem2f.s $e |- S = ( Scalar ` U ) $.
    lclkrlem2f.q $e |- Q = ( 0g ` S ) $.
    lclkrlem2f.z $e |- .0. = ( 0g ` U ) $.
    lclkrlem2f.a $e |- .(+) = ( LSSum ` U ) $.
    lclkrlem2f.n $e |- N = ( LSpan ` U ) $.
    lclkrlem2f.f $e |- F = ( LFnl ` U ) $.
    lclkrlem2f.j $e |- J = ( LSHyp ` U ) $.
    lclkrlem2f.l $e |- L = ( LKer ` U ) $.
    lclkrlem2f.d $e |- D = ( LDual ` U ) $.
    lclkrlem2f.p $e |- .+ = ( +g ` D ) $.
    lclkrlem2f.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem2f.b $e |- ( ph -> B e. ( V \ { .0. } ) ) $.
    lclkrlem2f.e $e |- ( ph -> E e. F ) $.
    lclkrlem2f.g $e |- ( ph -> G e. F ) $.
    lclkrlem2f.le $e |- ( ph -> ( L ` E ) = ( ._|_ ` { X } ) ) $.
    lclkrlem2f.lg $e |- ( ph -> ( L ` G ) = ( ._|_ ` { Y } ) ) $.
    lclkrlem2f.kb $e |- ( ph -> ( ( E .+ G ) ` B ) = Q ) $.
    lclkrlem2f.nx $e |- ( ph
               -> ( -. X e. ( ._|_ ` { B } ) \/ -. Y e. ( ._|_ ` { B } ) ) ) $.
    ${
      lclkrlem2f.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      lclkrlem2f.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      lclkrlem2f.ne $e |- ( ph -> ( L ` E ) =/= ( L ` G ) ) $.
      lclkrlem2f.lp $e |- ( ph -> ( L ` ( E .+ G ) ) e. J ) $.
      $( Lemma for ~ lclkr .  Construct a closed hyperplane under the kernel of
         the sum.  (Contributed by NM, 16-Jan-2015.) $)
      lclkrlem2f $p |- ( ph ->
  ( ( ( L ` E ) i^i ( L ` G ) ) .(+) ( N ` { B } ) ) C_ ( L ` ( E .+ G ) ) ) $=
        ( cfv cin wss csn dvhlmod lkrin clss eqid lshplss wcel wceq ldualvaddcl
        co clmod eldifad ellkr2 mpbird lspsnel5a csubg wa lsssssubg syl syl2anc
        wb lkrlss lssincl syl3anc sseldd lspsncl lsmlub mpbi2and ) AIOVIZKOVIZV
        JZIKDWAZOVIZVKZBVLPVIZXDVKZXBXFEWAXDVKZACDJIKOHULUNUOUPAHLNSUCUEUQVMZUS
        UTVNAHVOVIZXDPHBXJVPZUKXIAXJXDMHXKUMXIVHVQZABXDVRBXCVIFVSVCAGJXCORHBWBF
        UFUGUHULUNXIACDJIKHULUOUPXIUSUTVTABRUBVLURWCZWDWEWFAXBHWGVIZVRXFXNVRXDX
        NVRXEXGWHXHWLAXJXNXBAHWBVRZXJXNVKXIXJHXKWIWJZAXOWTXJVRZXAXJVRZXBXJVRXIA
        XOIJVRXQXIUSXJJIOHULUNXKWMWKAXOKJVRXRXIUTXJJKOHULUNXKWMWKXJWTXAHXKWNWOW
        PAXJXNXFXPAXOBRVRXFXJVRXIXMXJPRHBUFXKUKWQWKWPAXJXNXDXPXLWPEXBXFXDHUJWRW
        OWS $.

      $( Lemma for ~ lclkr .  Comparable hyperplanes are equal, so the kernel
         of the sum is closed.  (Contributed by NM, 16-Jan-2015.) $)
      lclkrlem2g $p |- ( ph
          -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( co cfv cdih crn wcel wceq cin csn wss lclkrlem2f dvhlvec ineq12d clsa
        oveq1d eqid 3netr3d lclkrlem2c eqeltrd lshpcmp lclkrlem2d eqeltrrd chlt
        mpbid wa dihrnss syl2anc dochoccl ) AIKDVIOVJZSNVKVJVJZVLZVMZWPQVJQVJWP
        VNAIOVJZKOVJZVOZBVPPVJZEVIZWPWRAXDWPVQXDWPVNABCDEFGHIJKLMNOPQRSTUAUBUCU
        DUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVRAXDWPMHUMAHLNSUCUEUQ
        VSAXDTVPQVJZUAVPQVJZVOZXCEVIZMAXBXGXCEAWTXEXAXFVAVBVTWBZAHWAVJZBEHLMNPQ
        RSTUAUBUCUDUEUFUIUJUKXJWCZUQURVEVFAWTXAXEXFVGVAVBWDZVDUMWEWFVHWGWKAXDXH
        WRXIAXJBEHLWQNPQRSTUAUBUCUDUEUFUIUJUKXKUQURVEVFXLVDWQWCZWHWFWIZAHLWQNQR
        SWPUCXMUEUFUDUQANWJVMSLVMWLWSWPRVQUQXNHLWQNRSWPUCUEXMUFWMWNWOWK $.
    $}

    ${
      lclkrlem2h.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      lclkrlem2h.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      lclkrlem2h.ne $e |- ( ph -> ( L ` E ) =/= ( L ` G ) ) $.
      $( Lemma for ~ lclkr .  Eliminate the ` ( L `` ( E .+ G ) ) e. J `
         hypothesis.  (Contributed by NM, 16-Jan-2015.) $)
      lclkrlem2h $p |- ( ph
          -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( co cfv wcel wceq wa chlt adantr csn cdif wn wo wne lclkrlem2g dochoc1
        dvhlvec dvhlmod ldualvaddcl lkrshpor orcanai fveq2d 3eqtr4d pm2.61dan
        simpr ) AIKDVHZOVIZMVJZWLQVIZQVIZWLVKAWMVLBCDEFGHIJKLMNOPQRSTUAUBUCUDUE
        UFUGUHUIUJUKULUMUNUOUPANVMVJSLVJVLWMUQVNABRUBVOVPZVJWMURVNAIJVJWMUSVNAK
        JVJWMUTVNAIOVIZTVOQVIVKWMVAVNAKOVIZUAVOQVIVKWMVBVNABWKVIFVKWMVCVNATBVOQ
        VIZVJVQUAWSVJVQVRWMVDVNATWPVJWMVEVNAUAWPVJWMVFVNAWQWRVSWMVGVNAWMWJVTAWM
        VQZVLZRQVIZQVIZRWOWLAXCRVKWTAHLNQRSUCUEUDUFUQWAVNXAWNXBQXAWLRQAWMWLRVKA
        JWKMORHUFUMULUNAHLNSUCUEUQWBACDJIKHULUOUPAHLNSUCUEUQWCUSUTWDWEWFZWGWGXD
        WHWI $.
    $}

    ${
      lclkrlem2i.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      lclkrlem2i.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      $( Lemma for ~ lclkr .  Eliminate the ` ( L `` E ) =/= ( L `` G ) `
         hypothesis.  (Contributed by NM, 17-Jan-2015.) $)
      lclkrlem2i $p |- ( ph
          -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( co cfv wceq chlt wcel adantr csn cdif simpr lclkrlem2e wne lclkrlem2h
        wa wn wo pm2.61dane ) AIKDVGZOVHZQVHQVHWDVIIOVHZKOVHZAWEWFVIZVSCDHIJKLN
        OQRSTUBUCUDUEUFUIULUNUOUPANVJVKSLVKVSZWGUQVLATRUBVMVNZVKZWGVEVLAIJVKZWG
        USVLAKJVKZWGUTVLAWETVMQVHVIZWGVAVLAWGVOVPAWEWFVQZVSBCDEFGHIJKLMNOPQRSTU
        AUBUCUDUEUFUGUHUIUJUKULUMUNUOUPAWHWNUQVLABWIVKWNURVLAWKWNUSVLAWLWNUTVLA
        WMWNVAVLAWFUAVMQVHVIWNVBVLABWCVHFVIWNVCVLATBVMQVHZVKVTUAWOVKVTWAWNVDVLA
        WJWNVEVLAUAWIVKWNVFVLAWNVOVRWB $.
    $}

    ${
      lclkrlem2j.x $e |- ( ph -> X e. V ) $.
      lclkrlem2j.y $e |- ( ph -> Y = .0. ) $.
      $( Lemma for ~ lclkr .  Kernel closure when ` Y ` is zero.  (Contributed
         by NM, 18-Jan-2015.) $)
      lclkrlem2j $p |- ( ph
          -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( csn cfv co chlt wcel wa cdih crn wceq wss snssd dochcl syl2anc dochoc
        eqid c0g cbs cxp sneqd fveq2d doch0 3eqtrd clmod wb dvhlmod lkr0f mpbid
        syl ldual0v eqtr4d oveq2d lduallmod ldualelvbase lmod0vrid eqtrd eqtr2d
        3eqtr3d ) ATVGZQVHZQVHZQVHZXEIKDVIZOVHZQVHZQVHXIANVJVKSLVKVLZXESNVMVHVH
        ZVNVKZXGXEVOUQAXKXDRVPXMUQATRVEVQHLXLNQRSXDUCXLWAZUEUFUDVRVSLXLNQSXEUCX
        NUDVTVSAXFXJQAXEXIQAXIIOVHXEAXHIOAXHICWBVHZDVIZIAKXOIDAKHWCVHZFVGWDZXOA
        KOVHZXQVOZKXRVOZAXSUAVGZQVHUBVGZQVHZXQVBAYBYCQAUAUBVFWEWFAXKYDXQVOUQHLN
        QXQSUBUCUEUDXQWAZUIWGWNWHAHWIVKKJVKXTYAWJAHLNSUCUEUQWKZUTGJKOXQHFUGUHYE
        ULUNWLVSWMACGXOXQHFYEUGUHUOXOWAZYFWOWPWQACWIVKICWCVHZVKXPIVOACHUOYFWRAC
        JIYHHWIULUOYHWAZYFUSWSDYHCIXOYIUPYGWTVSXAWFVAXBZWFWFYJXC $.
    $}

    ${
      lclkrlem2k.x $e |- ( ph -> X = .0. ) $.
      lclkrlem2k.y $e |- ( ph -> Y e. V ) $.
      $( Lemma for ~ lclkr .  Kernel closure when ` X ` is zero.  (Contributed
         by NM, 18-Jan-2015.) $)
      lclkrlem2k $p |- ( ph
          -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( co cfv dvhlmod ldualvaddcom fveq1d eqtr3d wn orcomd lclkrlem2j fveq2d
        csn wcel 3eqtr4d ) AKIDVGZOVHZQVHZQVHWAIKDVGZOVHZQVHZQVHWDABCDEFGHKJILM
        NOPQRSUATUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUTUSVBVAABWCVHBVTVHFABWCVTAC
        DJHIKULUOUPAHLNSUCUEUQVIUSUTVJZVKVCVLATBVQQVHZVRVMUAWGVRVMVDVNVFVEVOAWE
        WBQAWDWAQAWCVTOWFVPZVPVPWHVS $.
    $}

    lclkrlem2l.x $e |- ( ph -> X e. V ) $.
    lclkrlem2l.y $e |- ( ph -> Y e. V ) $.
    $( Lemma for ~ lclkr .  Eliminate the ` X =/= .0. ` , ` Y =/= .0. `
       hypotheses.  (Contributed by NM, 18-Jan-2015.) $)
    lclkrlem2l $p |- ( ph
         -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
      ( co cfv wceq wa chlt wcel adantr csn cdif wn simpr lclkrlem2k lclkrlem2j
      wo wne simprl eldifsn sylanbrc simprr lclkrlem2i pm2.61da2ne ) AIKDVGZOVH
      ZQVHQVHWIVITUBUAUBATUBVIZVJBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMU
      NUOUPANVKVLSLVLVJZWJUQVMABRUBVNVOZVLZWJURVMAIJVLZWJUSVMAKJVLZWJUTVMAIOVHT
      VNQVHVIZWJVAVMAKOVHUAVNQVHVIZWJVBVMABWHVHFVIZWJVCVMATBVNQVHZVLVPUAWSVLVPV
      TZWJVDVMAWJVQAUARVLZWJVFVMVRAUAUBVIZVJBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUH
      UIUJUKULUMUNUOUPAWKXBUQVMAWMXBURVMAWNXBUSVMAWOXBUTVMAWPXBVAVMAWQXBVBVMAWR
      XBVCVMAWTXBVDVMATRVLZXBVEVMAXBVQVSATUBWAZUAUBWAZVJZVJZBCDEFGHIJKLMNOPQRST
      UAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPAWKXFUQVMAWMXFURVMAWNXFUSVMAWOXFUTVMAWPXF
      VAVMAWQXFVBVMAWRXFVCVMAWTXFVDVMXGXCXDTWLVLAXCXFVEVMAXDXEWBTRUBWCWDXGXAXEU
      AWLVLAXAXFVFVMAXDXEWEUARUBWCWDWFWG $.
  $}

  ${
    lclkrlem2m.v $e |- V = ( Base ` U ) $.
    lclkrlem2m.t $e |- .x. = ( .s ` U ) $.
    lclkrlem2m.s $e |- S = ( Scalar ` U ) $.
    lclkrlem2m.q $e |- .X. = ( .r ` S ) $.
    lclkrlem2m.z $e |- .0. = ( 0g ` S ) $.
    lclkrlem2m.i $e |- I = ( invr ` S ) $.
    lclkrlem2m.m $e |- .- = ( -g ` U ) $.
    lclkrlem2m.f $e |- F = ( LFnl ` U ) $.
    lclkrlem2m.d $e |- D = ( LDual ` U ) $.
    lclkrlem2m.p $e |- .+ = ( +g ` D ) $.
    lclkrlem2m.x $e |- ( ph -> X e. V ) $.
    lclkrlem2m.y $e |- ( ph -> Y e. V ) $.
    lclkrlem2m.e $e |- ( ph -> E e. F ) $.
    lclkrlem2m.g $e |- ( ph -> G e. F ) $.
    ${
      lclkrlem2m.w $e |- ( ph -> U e. LVec ) $.
      lclkrlem2m.b $e |- B = ( X .-
        ( ( ( ( E .+ G ) ` X ) .X. ( I ` ( ( E .+ G ) ` Y ) ) ) .x. Y ) ) $.
      lclkrlem2m.n $e |- ( ph -> ( ( E .+ G ) ` Y ) =/= .0. ) $.
      $( Lemma for ~ lclkr .  Construct a vector ` B ` that makes the sum of
         functionals zero.  Combine with ` B e. V ` to shorten overall proof.
         (Contributed by NM, 17-Jan-2015.) $)
      lclkrlem2m $p |- ( ph -> ( B e. V /\ ( ( E .+ G ) ` B ) = .0. ) ) $=
        ( wcel co cfv wceq clmod clvec lveclmod syl lmodgrp cbs crg ldualvaddcl
        cgrp lmodrng eqid syl3anc cdr wne lvecdrng drnginvrcl lmodvscl grpsubcl
        lflcl rngcl syl5eqel fveq2i csg lflsub syl112anc lflmul rngass syl13anc
        cur drnginvrl oveq2d rngridm syl2anc 3eqtrd rnggrp grpsubid syl5eq jca
        eqtrd ) ABNUOBIKDUPZUQZQURABOOWRUQZPWRUQZLUQZGUPZPFUPZMUPZNUMAHVGUOZONU
        OZXDNUOZXENUOAHUSUOZXFAHUTUOZXIULHVAVBZHVCVBUHAXIXCEVDUQZUOZPNUOZXHXKAE
        VEUOZWTXLUOZXBXLUOZXMAXIXOXKEHTVHVBZAXJWRJUOZXGXPULACDJIKHUEUFUGXKUJUKV
        FZUHEJWRXLNHOUTTXLVIZRUEVQVJZAEVKUOZXAXLUOZXAQVLZXQAXJYCULEHTVMVBZAXJXS
        XNYDULXTUIEJWRXLNHPUTTYARUEVQVJZUNXLELXAQYAUBUCVNVJZXLEGWTXBYAUAVRVJZUI
        XCFEXLNHPRTSYAVOVJZNHMOXDRUDVPVJVSAWSXEWRUQZQBXEWRUMVTAYKWTXDWRUQZEWAUQ
        ZUPZWTWTYMUPZQAXIXSXGXHYKYNURXKXTUHYJEJWRYMMNHOXDTYMVIZRUDUEWBWCAYLWTWT
        YMAYLXCXAGUPZWTEWGUQZGUPZWTAXIXSXMXNYLYQURXKXTYIUIEXCFGJWRXLNHPTYAUARSU
        EWDWCAYQWTXBXAGUPZGUPZYSAXOXPXQYDYQUUAURXRYBYHYGXLEGWTXBXAYAUAWEWFAYTYR
        WTGAYCYDYEYTYRURYFYGUNXLEGYRLXAQYAUBUAYRVIZUCWHVJWIWQAXOXPYSWTURXRYBXLE
        GYRWTYAUAUUBWJWKWLWIAEVGUOZXPYOQURAXOUUCXREWMVBYBXLEYMWTQYAUBYPWNWKWLWO
        WP $.
    $}

    lclkrlem2n.n $e |- N = ( LSpan ` U ) $.
    lclkrlem2n.l $e |- L = ( LKer ` U ) $.
    ${
      lclkrlem2n.w $e |- ( ph -> U e. LVec ) $.
      lclkrlem2n.j $e |- ( ph -> ( ( E .+ G ) ` X ) = .0. ) $.
      lclkrlem2n.k $e |- ( ph -> ( ( E .+ G ) ` Y ) = .0. ) $.
      $( Lemma for ~ lclkr .  (Contributed by NM, 12-Jan-2015.) $)
      lclkrlem2n $p |- ( ph -> ( N ` { X , Y } ) C_ ( L ` ( E .+ G ) ) ) $=
        ( clss cfv co eqid clvec wcel clmod lveclmod ldualvaddcl lkrlss syl2anc
        syl wceq ellkr2 mpbird lspprss ) AGURUSZHJCUTZLUSZNGPQVNVAZUMAGVBVCGVDV
        CZUOGVEVIZAVRVOIVCVPVNVCVSABCIHJGUFUGUHVSUKULVFZVNIVOLGUFUNVQVGVHAPVPVC
        PVOUSRVJUPADIVOLOGPVBRSUAUCUFUNUOVTUIVKVLAQVPVCQVOUSRVJUQADIVOLOGQVBRSU
        AUCUFUNUOVTUJVKVLVM $.
    $}

    lclkrlem2o.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2o.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2o.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2o.a $e |- .(+) = ( LSSum ` U ) $.
    lclkrlem2o.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      lclkrlem2o.b $e |- B = ( X .-
        ( ( ( ( E .+ G ) ` X ) .X. ( I ` ( ( E .+ G ) ` Y ) ) ) .x. Y ) ) $.
      lclkrlem2o.n $e |- ( ph -> ( ( E .+ G ) ` Y ) =/= .0. ) $.
      ${
        lclkrlem2o.bn $e |- ( ph -> B =/= ( 0g ` U ) ) $.
        $( Lemma for ~ lclkr .  When ` B ` is nonzero, the vectors ` X ` and
           ` Y ` can't both belong to the hyperplane generated by ` B ` .
           (Contributed by NM, 17-Jan-2015.) $)
        lclkrlem2o $p |- ( ph
               -> ( -. X e. ( ._|_ ` { B } ) \/ -. Y e. ( ._|_ ` { B } ) ) ) $=
          ( csn cfv wcel wa wn c0g eqid wne cdif wceq dvhlvec lclkrlem2m simpld
          wo co eldifsn sylanbrc dochnel clmod clss dvhlmod adantr chlt dochlss
          wss snssd syl2anc cbs crg lmodrng syl ldualvaddcl lflcl syl3anc clvec
          simprl cdr lvecdrng drnginvrcl rngcl simprr lssvscl syl22anc syl5eqel
          lssvsubcl mtand ianor sylib ) AUBBVIZSVJZVKZUCXRVKZVLZVMXSVMXTVMWBAYA
          BXRVKAIMOSTUABIVNVJZVAVBVCUEYBVOVEABTVKZBYBVPBTYBVIVQVKAYCBJLDWCZVJUD
          VRABCDFGHIJKLNQTUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURAIMOUAVAVCVEVSZVFVG
          VTWAZVHBTYBWDWEWFAYAVLZBUBUBYDVJZUCYDVJZNVJZHWCZUCGWCZQWCZXRVFYGIWGVK
          ZXRIWHVJZVKZXSYLXRVKZYMXRVKAYNYAAIMOUAVAVCVEWIZWJZAYPYAAOWKVKUAMVKVLX
          QTWMYPVEABTYFWNYOIMOSTUAXQVAVCUEYOVOZVBWLWOWJZAXSXTXDYGYNYPYKFWPVJZVK
          ZXTYQYSUUAAUUCYAAFWQVKZYHUUBVKZYJUUBVKZUUCAYNUUDYRFIUGWRWSAYNYDKVKZUB
          TVKUUEYRACDKJLIULUMUNYRUQURWTZUOFKYDUUBTIUBWGUGUUBVOZUEULXAXBAFXEVKZY
          IUUBVKZYIUDVPUUFAIXCVKUUJYEFIUGXFWSAYNUUGUCTVKUUKYRUUHUPFKYDUUBTIUCWG
          UGUUIUEULXAXBVGUUBFNYIUDUUIUIUJXGXBUUBFHYHYJUUIUHXHXBWJAXSXTXIUUBYOGX
          RFIYKUCUGUFUUIYTXJXKYOXRQIUBYLUKYTXMXKXLXNXSXTXOXP $.
      $}

      ${
        lclkrlem2p.bn $e |- ( ph -> B = ( 0g ` U ) ) $.
        $( Lemma for ~ lclkr .  When ` B ` is zero, ` X ` and ` Y ` must
           colinear, so their orthocomplements must be comparable.
           (Contributed by NM, 17-Jan-2015.) $)
        lclkrlem2p $p |- ( ph -> ( ._|_ ` { Y } ) C_ ( ._|_ ` { X } ) ) $=
          ( csn cfv chlt wcel wss clss clmod dvhlmod eqid lspsncl syl2anc lssss
          wa syl co c0g wceq syl5eqr wb cbs crg lmodrng ldualvaddcl syl3anc cdr
          lflcl wne clvec dvhlvec lvecdrng drnginvrcl rngcl lmodvscl lmodsubeq0
          mpbid sneqd fveq2d lspsnvsi eqsstrd dochss snssd dochocsp 3sstr3d ) A
          UCVIZRVJZSVJZUBVIZRVJZSVJZXLSVJXOSVJAOVKVLUAMVLWAXMTVMZXPXMVMXNXQVMVE
          AXMIVNVJZVLZXRAIVOVLZUCTVLZXTAIMOUAVAVCVEVPZUPXSRTIUCUEXSVQZUSVRVSXSX
          MTIUEYDVTWBAXPUBJLDWCZVJZUCYEVJZNVJZHWCZUCGWCZVIZRVJZXMAXOYKRAUBYJAUB
          YJQWCZIWDVJZWEZUBYJWEZAYMBYNVFVHWFAYAUBTVLZYJTVLZYOYPWGYCUOAYAYIFWHVJ
          ZVLZYBYRYCAFWIVLZYFYSVLZYHYSVLZYTAYAUUAYCFIUGWJWBAYAYEKVLZYQUUBYCACDK
          JLIULUMUNYCUQURWKZUOFKYEYSTIUBVOUGYSVQZUEULWNWLAFWMVLZYGYSVLZYGUDWOUU
          CAIWPVLUUGAIMOUAVAVCVEWQFIUGWRWBAYAUUDYBUUHYCUUEUPFKYEYSTIUCVOUGUUFUE
          ULWNWLVGYSFNYGUDUUFUIUJWSWLYSFHYFYHUUFUHWTWLZUPYIGFYSTIUCUEUGUFUUFXAW
          LUBYJQTIYNUEYNVQUKXBWLXCXDXEAYAYTYBYLXMVMYCUUIUPYIGFYSRTIUCUGUUFUEUFU
          SXFWLXGIMOSTUAXPXMVAVCUEVBXHWLAIMORSTUAXLVAVCVBUEUSVEAUCTUPXIXJAIMORS
          TUAXOVAVCVBUEUSVEAUBTUOXIXJXK $.
      $}
    $}

    lclkrlem2q.le $e |- ( ph -> ( L ` E ) = ( ._|_ ` { X } ) ) $.
    lclkrlem2q.lg $e |- ( ph -> ( L ` G ) = ( ._|_ ` { Y } ) ) $.
    ${
      lclkrlem2q.b $e |- B = ( X .-
        ( ( ( ( E .+ G ) ` X ) .X. ( I ` ( ( E .+ G ) ` Y ) ) ) .x. Y ) ) $.
      lclkrlem2q.n $e |- ( ph -> ( ( E .+ G ) ` Y ) =/= .0. ) $.
      ${
        lclkrlem2q.bn $e |- ( ph -> B =/= ( 0g ` U ) ) $.
        $( Lemma for ~ lclkr .  The sum has a closed kernel when ` B ` is
           nonzero.  (Contributed by NM, 18-Jan-2015.) $)
        lclkrlem2q $p |- ( ph
          -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
          ( clsh cfv c0g eqid wcel wne csn cdif wceq dvhlvec lclkrlem2m eldifsn
          co simpld sylanbrc simprd lclkrlem2o lclkrlem2l ) ABCDEUDFIJKLMIVKVLZ
          OPRSTUAUBUCIVMVLZVAVBVCUEUGUIWJVNVDUSULWIVNUTUMUNVEABTVOZBWJVPBTWJVQV
          RVOAWKBJLDWCVLUDVSZABCDFGHIJKLNQTUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURAI
          MOUAVAVCVEVTVHVIWAZWDVJBTWJWBWEUQURVFVGAWKWLWMWFABCDEFGHIJKLMNOPQRSTU
          AUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVHVIVJWGUOUPWH $.
      $}

      lclkrlem2r.bn $e |- ( ph -> B = ( 0g ` U ) ) $.
      $( Lemma for ~ lclkr .  When ` B ` is zero, i.e. when ` X ` and ` Y ` are
         colinear, the intersection of the kernels of ` E ` and ` G ` equal the
         kernel of ` G ` , so the kernels of ` G ` and the sum are comparable.
         (Contributed by NM, 18-Jan-2015.) $)
      lclkrlem2r $p |- ( ph -> ( L ` G ) C_ ( L ` ( E .+ G ) ) ) $=
        ( cfv cin co wss wceq csn lclkrlem2p 3sstr4d dfss1 sylib lkrin eqsstr3d
        dvhlmod ) ALPVKZJPVKZWDVLZJLDVMPVKAWDWEVNWFWDVOAUCVPSVKUBVPSVKWDWEABCDE
        FGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVHVIVJ
        VQVGVFVRWDWEVSVTACDKJLPIULUTUMUNAIMOUAVAVCVEWCUQURWAWB $.

      $( Lemma for ~ lclkr .  Thus, the sum has a closed kernel when ` B ` is
         zero.  (Contributed by NM, 18-Jan-2015.) $)
      lclkrlem2s $p |- ( ph
         -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( cfv clsh wcel co wceq csn chlt cdih crn wss snssd eqid dochcl syl2anc
        wa dochoc ad2antrr lclkrlem2r clvec dvhlvec simplr simpr lshpcmp eqtr3d
        mpbid fveq2d 3eqtr4d dochoc1 dvhlmod ldualvaddcl lkrshpor adantr lkrssv
        wo mpjaodan eqsstr3d eqssd ) ALPVKZIVLVKZVMZJLDVNZPVKZSVKZSVKZXLVOZXHTV
        OZAXJWEZXLXIVMZXOXLTVOZXQXRWEZUCVPZSVKZSVKZSVKZYBXNXLAYDYBVOZXJXRAOVQVM
        UAMVMWEZYBUAOVRVKVKZVSVMZYEVEAYFYATVTYHVEAUCTUPWAIMYGOSTUAYAVAYGWBZVCUE
        VBWCWDMYGOSUAYBVAYIVBWFWDWGXTXMYCSXTXLYBSXTXHXLYBXTXHXLVTZXHXLVOAYJXJXR
        ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEV
        FVGVHVIVJWHZWGXTXHXLXIIXIWBZAIWIVMXJXRAIMOUAVAVCVEWJZWGAXJXRWKXQXRWLWMW
        OAXHYBVOXJXRVGWGWNZWPWPYNWQXQXSWEZTSVKZSVKZTXNXLAYQTVOZXJXSAIMOSTUAVAVC
        VBUEVEWRZWGYOXMYPSYOXLTSXQXSWLZWPWPYTWQAXRXSXDXJAKXKXIPTIUEYLULUTYMACDK
        JLIULUMUNAIMOUAVAVCVEWSZUQURWTZXAXBXEAXPWEZYQTXNXLAYRXPYSXBUUCXMYPSUUCX
        LTSUUCXLTAXLTVTXPAKXKPTIUEULUTUUAUUBXCXBUUCTXHXLAXPWLAYJXPYKXBXFXGZWPWP
        UUDWQAKLXIPTIUEYLULUTYMURXAXE $.
    $}

    ${
      lclkrlem2t.n $e |- ( ph -> ( ( E .+ G ) ` Y ) =/= .0. ) $.
      $( Lemma for ~ lclkr .  We eliminate all hypotheses with ` B ` here.
         (Contributed by NM, 18-Jan-2015.) $)
      lclkrlem2t $p |- ( ph
         -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( co cfv wceq c0g wcel adantr chlt csn eqid simpr lclkrlem2s lclkrlem2q
        wa wne pm2.61dane ) AIKCVHZOVIZRVIRVIWDVJUAUAWCVIUBWCVIZMVIGVHUBFVHPVHZ
        HVKVIZAWFWGVJZVTWFBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMAUASVLZW
        HUNVMAUBSVLZWHUOVMAIJVLZWHUPVMAKJVLZWHUQVMURUSUTVAVBVCANVNVLTLVLVTZWHVD
        VMAIOVIUAVORVIVJZWHVEVMAKOVIUBVORVIVJZWHVFVMWFVPZAWEUCWAZWHVGVMAWHVQVRA
        WFWGWAZVTWFBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMAWIWRUNVMAWJWRU
        OVMAWKWRUPVMAWLWRUQVMURUSUTVAVBVCAWMWRVDVMAWNWRVEVMAWOWRVFVMWPAWQWRVGVM
        AWRVQVSWB $.
    $}

    ${
      lclkrlem2u.n $e |- ( ph -> ( ( E .+ G ) ` X ) =/= .0. ) $.
      $( Lemma for ~ lclkr . ~ lclkrlem2t with ` X ` and ` Y ` swapped.
         (Contributed by NM, 18-Jan-2015.) $)
      lclkrlem2u $p |- ( ph
         -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
        ( co cfv dvhlmod ldualvaddcom fveq1d eqnetrrd lclkrlem2t fveq2d 3eqtr4d
        ) AKICVHZOVIZRVIZRVIVRIKCVHZOVIZRVIZRVIWAABCDEFGHKJILMNOPQRSTUBUAUCUDUE
        UFUGUHUIUJUKULUMUOUNUQUPURUSUTVAVBVCVDVFVEAUAVTVIUAVQVIUCAUAVTVQABCJHIK
        UKULUMAHLNTUTVBVDVJUPUQVKZVLVGVMVNAWBVSRAWAVRRAVTVQOWCVOZVOVOWDVP $.
    $}

    ${
      lclkrlem2v.j $e |- ( ph -> ( ( E .+ G ) ` X ) = .0. ) $.
      lclkrlem2v.k $e |- ( ph -> ( ( E .+ G ) ` Y ) = .0. ) $.
      $( Lemma for ~ lclkr .  When the hypotheses of ~ lclkrlem2u and
         ~ lclkrlem2u are negated, the functional sum must be zero, so the
         kernel is the vector space.  We make use of the law of excluded
         middle, ~ dochexmid , which requires the orthomodular law ~ dihoml4
         (Lemma 3.3 of [Holland95] p. 214).  (Contributed by NM,
         16-Jan-2015.) $)
      lclkrlem2v $p |- ( ph -> ( L ` ( E .+ G ) ) = V ) $=
        ( co cfv dvhlmod ldualvaddcl lkrssv cpr clss eqid lspprcl cdih crn wcel
        wceq dihprrn wss lssss syl dochoccl mpbid dochexmid dvhlvec cin csn cun
        lclkrlem2n wa snssd dochdmj1 syl3anc df-pr fveq2i unssd dochocsp syl5eq
        chlt ineq12d 3eqtr4d lkrin eqsstrd csubg clmod lsssssubg sseldd dochlss
        wb syl2anc lkrlss lsmlub mpbi2and eqsstr3d eqssd ) AIKCVIZOVJZSAJXTOSHU
        DUKUSAHLNTUTVBVDVKZABCJIKHUKULUMYBUPUQVLZVMASUAUBVNZQVJZYERVJZDVIZYAADH
        VOVJZHLNRSTYEUTVAVBUDYHVPZVCVDAYHQSHUAUBUDYIURYBUNUOVQZAYETNVRVJVJZVSVT
        YFRVJYEWAAHLYKNQSTUAUBUTVBUDURYKVPZVDUNUOWBAHLYKNRSTYEUTYLVBUDVAVDAYEYH
        VTYESWCZYJYHYESHUDYIWDWEZWFWGWHAYEYAWCZYFYAWCZYGYAWCZABCEFGHIJKMOPQSUAU
        BUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSAHLNTUTVBVDWIVGVHWMAYFIOVJZKOVJZWJZY
        AAUAWKZUBWKZWLZRVJZUUARVJZUUBRVJZWJZYFYTANXCVTTLVTWNZUUASWCUUBSWCUUDUUG
        WAVDAUASUNWOZAUBSUOWOZHLNRSTUUAUUBUTVBUDVAWPWQAYFUUCQVJZRVJUUDYEUUKRYDU
        UCQUAUBWRWSWSAHLNQRSTUUCUTVBVAUDURVDAUUAUUBSUUIUUJWTXAXBAYRUUEYSUUFVEVF
        XDXEABCJIKOHUKUSULUMYBUPUQXFXGAYEHXHVJZVTYFUULVTYAUULVTYOYPWNYQXMAYHUUL
        YEAHXIVTZYHUULWCYBYHHYIXJWEZYJXKAYHUULYFUUNAUUHYMYFYHVTVDYNYHHLNRSTYEUT
        VBUDYIVAXLXNXKAYHUULYAUUNAUUMXTJVTYAYHVTYBYCYHJXTOHUKUSYIXOXNXKDYEYFYAH
        VCXPWQXQXRXS $.

      $( Lemma for ~ lclkr .  This is the same as ~ lclkrlem2u and ~ lclkrlem2u
         with the inequality hypotheses negated.  When the sum of two
         functionals is zero at each generating vector, the kernel is the
         vector space and therefore closed.  (Contributed by NM,
         16-Jan-2015.) $)
      lclkrlem2w $p |- ( ph -> ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) )
                 = ( L ` ( E .+ G ) ) ) $=
        ( cfv co dochoc1 lclkrlem2v fveq2d 3eqtr4d ) ASRVIZRVISIKCVJOVIZRVIZRVI
        VPAHLNRSTUTVBVAUDVDVKAVQVORAVPSRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
        JUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVLZVMVMVRVN $.
    $}
  $}

  ${
    lclkrlem2x.l $e |- L = ( LKer ` U ) $.
    lclkrlem2x.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2x.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2x.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2x.v $e |- V = ( Base ` U ) $.
    lclkrlem2x.f $e |- F = ( LFnl ` U ) $.
    lclkrlem2x.d $e |- D = ( LDual ` U ) $.
    lclkrlem2x.p $e |- .+ = ( +g ` D ) $.
    lclkrlem2x.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem2x.x $e |- ( ph -> X e. V ) $.
    lclkrlem2x.y $e |- ( ph -> Y e. V ) $.
    lclkrlem2x.e $e |- ( ph -> E e. F ) $.
    lclkrlem2x.g $e |- ( ph -> G e. F ) $.
    lclkrlem2x.le $e |- ( ph -> ( L ` E ) = ( ._|_ ` { X } ) ) $.
    lclkrlem2x.lg $e |- ( ph -> ( L ` G ) = ( ._|_ ` { Y } ) ) $.
    $( Lemma for ~ lclkr .  Eliminate by cases the hypotheses of ~ lclkrlem2u ,
       ~ lclkrlem2u and ~ lclkrlem2w .  (Contributed by NM, 18-Jan-2015.) $)
    lclkrlem2x $p |- ( ph ->
       ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
      ( co cfv csca c0g wceq wn wne df-ne clsm cvsca cmulr cinvr csg clspn eqid
      wa wcel adantr csn simpr lclkrlem2u sylan2br lclkrlem2t simprl lclkrlem2w
      chlt simprr pm2.61dda ) ANEGCUKZULZDUMULZUNULZUOZOVSULZWBUOZVSJULZKULKULW
      FUOZWCUPAVTWBUQZWGVTWBURAWHVFBCDUSULZWADUTULZWAVAULZDEFGHWAVBULZIJDVCULZD
      VDULZKLMNOWBTWJVEZWAVEZWKVEZWBVEZWLVEZWMVEZUAUBUCANLVGZWHUEVHAOLVGZWHUFVH
      AEFVGZWHUGVHAGFVGZWHUHVHWNVEZPQRSWIVEZAIVPVGMHVGVFZWHUDVHAEJULNVIKULUOZWH
      UIVHAGJULOVIKULUOZWHUJVHAWHVJVKVLWEUPAWDWBUQZWGWDWBURAXJVFBCWIWAWJWKDEFGH
      WLIJWMWNKLMNOWBTWOWPWQWRWSWTUAUBUCAXAXJUEVHAXBXJUFVHAXCXJUGVHAXDXJUHVHXEP
      QRSXFAXGXJUDVHAXHXJUIVHAXIXJUJVHAXJVJVMVLAWCWEVFZVFBCWIWAWJWKDEFGHWLIJWMW
      NKLMNOWBTWOWPWQWRWSWTUAUBUCAXAXKUEVHAXBXKUFVHAXCXKUGVHAXDXKUHVHXEPQRSXFAX
      GXKUDVHAXHXKUIVHAXIXKUJVHAWCWEVNAWCWEVQVOVR $.
  $}

  ${
    $d x y E $.  $d x y F $.  $d x y G $.  $d x y L $.  $d x y ._|_ $.
    $d x y .+ $.  $d x y U $.  $d x y ph $.
    lclkrlem2y.l $e |- L = ( LKer ` U ) $.
    lclkrlem2y.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2y.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2y.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2y.f $e |- F = ( LFnl ` U ) $.
    lclkrlem2y.d $e |- D = ( LDual ` U ) $.
    lclkrlem2y.p $e |- .+ = ( +g ` D ) $.
    lclkrlem2y.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem2y.e $e |- ( ph -> E e. F ) $.
    lclkrlem2y.g $e |- ( ph -> G e. F ) $.
    lclkrlem2y.le $e |- ( ph ->
      ( ._|_ ` ( ._|_ ` ( L ` E ) ) ) = ( L ` E ) ) $.
    lclkrlem2y.lg $e |- ( ph ->
      ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G ) ) $.
    $( Lemma for ~ lclkr .  Restate the hypotheses for ` E ` and ` G ` to say
       their kernels are closed, in order to eliminate the generating vectors
       ` X ` and ` Y ` .  (Contributed by NM, 18-Jan-2015.) $)
    lclkrlem2y $p |- ( ph ->
       ( ._|_ ` ( ._|_ ` ( L ` ( E .+ G ) ) ) ) = ( L ` ( E .+ G ) ) ) $=
      ( vy vx cfv cv csn wceq cbs wrex co eqid lcfl8a mpbid wcel wi w3a chlt wa
      3ad2ant1 simp21 simp23 simp22 simp3 lclkrlem2x 3exp 3expd rexlimdv mpd )
      AGJUGZUEUHZUIKUGUJZUEDUKUGZULZEGCUMJUGZKUGKUGVQUJZAVLKUGKUGVLUJVPUDAUEDFG
      HIJKVOLNOPVOUNZQMTUBUOUPAVNVRUEVOAEJUGZUFUHZUIKUGUJZUFVOULZVMVOUQZVNVRURZ
      URZAVTKUGKUGVTUJWCUCAUFDFEHIJKVOLNOPVSQMTUAUOUPAWBWFUFVOAWAVOUQZWBWDWEAWG
      WBWDUSZVNVRAWHVNUSBCDEFGHIJKVOLWAVMMNOPVSQRSAWHIUTUQLHUQVAVNTVBAWGWBWDVNV
      CAWGWBWDVNVDAWHEFUQVNUAVBAWHGFUQVNUBVBAWGWBWDVNVEAWHVNVFVGVHVIVJVKVJVK $.
  $}

  ${
    $d f E $.  $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.  $d f .+ $.
    lclkrlem2.h $e |- H = ( LHyp ` K ) $.
    lclkrlem2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrlem2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrlem2.f $e |- F = ( LFnl ` U ) $.
    lclkrlem2.l $e |- L = ( LKer ` U ) $.
    lclkrlem2.d $e |- D = ( LDual ` U ) $.
    lclkrlem2.p $e |- .+ = ( +g ` D ) $.
    lclkrlem2.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lclkrlem2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrlem2.e $e |- ( ph -> E e. C ) $.
    lclkrlem2.g $e |- ( ph -> G e. C ) $.
    $( The set of functionals having closed kernels is closed under vector
       (functional) addition.  Lemmas ~ lclkrlem2a through ~ lclkrlem2y are
       used for the proof.  Here we express ~ lclkrlem2y in terms of membership
       in the set ` C ` of functionals with closed kernels.  (Contributed by
       NM, 18-Jan-2015.) $)
    lclkrlem2 $p |- ( ph -> ( E .+ G ) e. C ) $=
      ( wcel cfv wceq lcfl1lem simplbi syl lcfl1 lclkrlem2y dvhlmod ldualvaddcl
      co mpbid mpbird ) AGIDUPZBUFUSLUGZMUGMUGUTUHACDEGHIJKLMNSOPQRTUAUCAGBUFZG
      HUFZUDVAVBGLUGZMUGMUGVCUHZBFHGLMUBUIUJUKZAIBUFZIHUFZUEVFVGILUGZMUGMUGVHUH
      ZBFHILMUBUIUJUKZAVAVDUDABFHGLMUBVEULUQAVFVIUEABFHILMUBVJULUQUMABFHUSLMUBA
      CDHGIERTUAAEJKNOQUCUNVEVJUOULUR $.
  $}

  ${
    $d f ._|_ $.  $d a b x C $.  $d a b f x D $.  $d f F $.  $d a b x ph $.
    $d f L $.  $d f U $.
    lclkr.h $e |- H = ( LHyp ` K ) $.
    lclkr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkr.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkr.f $e |- F = ( LFnl ` U ) $.
    lclkr.l $e |- L = ( LKer ` U ) $.
    lclkr.d $e |- D = ( LDual ` U ) $.
    lclkr.s $e |- S = ( LSubSp ` D ) $.
    lclkr.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lclkr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The set of functionals with closed kernels is a subspace.  Part of proof
       of Theorem 3.6 of [Holland95] p. 218, line 20, stating "The f_M that
       arise this way generate a subspace F of E'".  Our proof was suggested by
       Mario Carneiro, 5-Jan-2015.  (Contributed by NM, 18-Jan-2015.) $)
    lclkr $p |- ( ph -> C e. S ) $=
      ( vx va vb cbs cfv wss c0 wne cv cvsca co cplusg wcel wral csca wceq crab
      ssrab2 a1i clmod dvhlmod ldualvbase 3sstr4d c0g csn cxp lfl0f syl dochoc1
      eqid wb lkr0f syl2anc mpbiri fveq2d 3eqtr4d lcfl1lem sylanbrc ne0i w3a wa
      chlt adantr simpr1 ldualsbase eleqtrd simpr2 lclkrlem1 simpr3 ralrimivvva
      lclkrlem2 islss syl3anbrc ) ABCUEUFZUGBUHUIZUBUJZUCUJZCUKUFZULZUDUJZCUMUF
      ZULBUNZUDBUOUCBUOUBCUPUFZUEUFZUOBDUNAFUJJUFZKUFKUFXFUQZFGURZGBWOXHGUGAXGF
      GUSUTBXHUQATUTACGWOEVAPRWOVKZAEHILMNUAVBZVCVDAEUEUFZEUPUFZVEUFZVFVGZBUNZW
      PAXNGUNZXNJUFZKUFZKUFZXQUQXOAEVAUNZXPXJXLGXKEXMXLVKZXMVKZXKVKZPVHVIZAXKKU
      FZKUFXKXSXQAEHIKXKLMNOYCUAVJAXRYEKAXQXKKAXQXKUQZXNXNUQZXNVKAXTXPYFYGVLXJY
      DXLGXNJXKEXMYAYBYCPQVMVNVOZVPVPYHVQBFGXNJKTVRVSBXNVTVIAXCUBUCUDXEBBAWQXEU
      NZWRBUNZXABUNZWAZWBZBCXBEFWTGXAHIJKLMONPQRXBVKZTAIWCUNLHUNWBYLUAWDZYMXLUE
      UFZBCXLWSEFGWRHIJKLWQMONPQRYAYPVKZWSVKZTYOYMWQXEYPAYIYJYKWEAXEYPUQYLACXDX
      LXEYPVAEYAYQRXDVKZXEVKZXJWFWDWGAYIYJYKWHWIAYIYJYKWJWLWKUBXEXBDWSBXDWOCUCU
      DYSYTXIYNYRSWMWN $.
  $}

  ${
    $d f F $.  $d f G $.  $d f L $.  $d f ._|_ $.  $d f Q $.
    lcfls1.c $e |- C = { f e. F | ( ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f )
        /\ ( ._|_ ` ( L ` f ) ) C_ Q ) } $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       27-Jan-2015.) $)
    lcfls1lem $p |- ( G e. C
           <-> ( G e. F /\ ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G )
                  /\ ( ._|_ ` ( L ` G ) ) C_ Q ) ) $=
      ( wcel cfv wceq wss wa w3a cv fveq2 fveq2d eqeq12d sseq1d anbi12d elrab2
      3anass bitr4i ) EAIEDIZEFJZGJZGJZUEKZUFBLZMZMUDUHUINCOZFJZGJZGJZULKZUMBLZ
      MUJCEDAUKEKZUOUHUPUIUQUNUGULUEUQUMUFGUQULUEGUKEFPZQZQURRUQUMUFBUSSTHUAUDU
      HUIUBUC $.

    ${
      lcfls1.g $e |- ( ph -> G e. F ) $.
      $( Property of a functional with a closed kernel.  (Contributed by NM,
         27-Jan-2015.)  (New usage is discouraged.) $)
      lcfls1N $p |- ( ph
          -> ( G e. C <-> ( ( ._|_ ` ( ._|_ ` ( L ` G ) ) ) = ( L ` G )
                /\ ( ._|_ ` ( L ` G ) ) C_ Q ) ) ) $=
        ( cfv wceq wss wa wcel biantrurd w3a lcfls1lem 3anass bitri syl6rbbr )
        AFGKZHKZHKUBLZUCCMZNZFEOZUFNZFBOZAUGUFJPUIUGUDUEQUHBCDEFGHIRUGUDUESTUA
        $.
    $}

    lcfls1c.c $e |- D = { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) )
           = ( L ` f ) } $.
    $( Property of a functional with a closed kernel.  (Contributed by NM,
       28-Jan-2015.) $)
    lcfls1c $p |- ( G e. C
           <-> ( G e. D /\ ( ._|_ ` ( L ` G ) ) C_ Q ) ) $=
      ( wcel cfv wceq wss w3a wa df-3an lcfls1lem lcfl1lem anbi1i 3bitr4i ) FEK
      ZFGLZHLZHLUCMZUDCNZOUBUEPZUFPFAKFBKZUFPUBUEUFQACDEFGHIRUHUGUFBDEFGHJSTUA
      $.
  $}

  ${
    $d f ._|_ $.  $d f F $.  $d f G $.  $d f L $.  $d f Q $.  $d f .x. $.
    $d f X $.
    lclkrslem1.h $e |- H = ( LHyp ` K ) $.
    lclkrslem1.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrslem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrslem1.s $e |- S = ( LSubSp ` U ) $.
    lclkrslem1.f $e |- F = ( LFnl ` U ) $.
    lclkrslem1.l $e |- L = ( LKer ` U ) $.
    lclkrslem1.d $e |- D = ( LDual ` U ) $.
    lclkrslem1.r $e |- R = ( Scalar ` U ) $.
    lclkrslem1.b $e |- B = ( Base ` R ) $.
    lclkrslem1.t $e |- .x. = ( .s ` D ) $.
    lclkrslem1.c $e |- C = { f e. F | ( ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) =
      ( L ` f ) /\ ( ._|_ ` ( L ` f ) ) C_ Q ) } $.
    lclkrslem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrslem1.q $e |- ( ph -> Q e. S ) $.
    lclkrslem1.g $e |- ( ph -> G e. C ) $.
    ${
      lclkrslem1.x $e |- ( ph -> X e. B ) $.
      $( The set of functionals having closed kernels and majorizing the
         orthocomplement of a given subspace ` Q ` is closed under scalar
         product.  (Contributed by NM, 27-Jan-2015.) $)
      lclkrslem1 $p |- ( ph -> ( X .x. G ) e. C ) $=
        ( co cfv wceq crab wcel wss eqid lcfls1c simplbi syl lclkrlem1 chlt cbs
        cv wa dvhlmod w3a lcfls1lem sylib simp1d ldualvscl lkrssv dvhlvec lkrss
        dochss syl3anc simp3d sstrd sylanbrc ) ARLHUNZJVGOUOZPUOPUOWDUPJKUQZURW
        COUOZPUOZEUSWCCURABWEDFHIJKLMNOPQRSTUAUCUDUEUFUGUHWEUTZUJUMALCURZLWEURZ
        ULWIWJLOUOZPUOZEUSZCWEEJKLOPUIWHVAVBVCVDAWGWLEANVEURQMURVHWFIVFUOZUSWKW
        FUSWGWLUSUJAKWCOWNIWNUTZUCUDAIMNQSUAUJVIZADFHKLBIRUCUFUGUEUHWPUMALKURZW
        LPUOWKUPZWMAWIWQWRWMVJULCEJKLOPUIVKVLZVMZVNVOADFHKLBOIRUFUGUCUDUEUHAIMN
        QSUAUJVPWTUMVQIMNPWNQWKWFSUAWOTVRVSAWQWRWMWSVTWACWEEJKWCOPUIWHVAWB $.
    $}

    $d f E $.  $d f .+ $.
    lclkrslem2.p $e |- .+ = ( +g ` D ) $.
    lclkrslem2.e $e |- ( ph -> E e. C ) $.
    $( The set of functionals having closed kernels and majorizing the
       orthocomplement of a given subspace ` Q ` is closed under scalar
       product.  (Contributed by NM, 28-Jan-2015.) $)
    lclkrslem2 $p |- ( ph -> ( E .+ G ) e. C ) $=
      ( co cv cfv wceq crab wcel wss eqid lcfls1c simplbi syl lclkrlem2 chlt wa
      cin cbs dvhlmod w3a lcfls1lem sylib simp1d ldualvaddcl lkrssv dochss clsm
      lkrin syl3anc cdjh cdih crn simp2d lcfl5a mpbid dochdmm1 syl2anc dochkrsm
      dochcl dochlss djhlsmcl eqtr4d simp3d csubg clmod lsssssubg sseldd lsmlub
      wb mpbi2and eqsstrd sstrd sylanbrc ) ALNEUPZKUQQURZRURRURXHUSKMUTZVAXGQUR
      ZRURZFVBXGCVAAXIDEJKLMNOPQRSTUAUBUDUEUFUNXIVCZUKALCVAZLXIVAZUOXMXNLQURZRU
      RZFVBZCXIFKMLQRUJXLVDVEVFANCVAZNXIVAZUMXRXSNQURZRURZFVBZCXIFKMNQRUJXLVDVE
      VFVGAXKXOXTVJZRURZFAPVHVASOVAVIZXJJVKURZVBYCXJVBXKYDVBUKAMXGQYFJYFVCZUDUE
      AJOPSTUBUKVLZADEMLNJUDUFUNYHALMVAZXPRURXOUSZXQAXMYIYJXQVMUOCFKMLQRUJVNVOZ
      VPZANMVAZYARURXTUSZYBAXRYMYNYBVMUMCFKMNQRUJVNVOZVPZVQVRADEMLNQJUDUEUFUNYH
      YLYPWAJOPRYFSYCXJTUBYGUAVSWBAYDXPYAJVTURZUPZFAYDXPYASPWCURURZUPZYRAJOSPWD
      URURZYSPRYFSXOXTTUUAVCZUBYGUAYSVCZUKAYJXOUUAWEZVAAYIYJXQYKWFAJMLOUUAPQRST
      UUBUAUBUDUEUKYLWGWHAYNXTUUDVAAYMYNYBYOWFAJMNOUUAPQRSTUUBUAUBUDUEUKYPWGWHW
      IAYRUUDVAYRYTUSAYQJMNOUUAPQRSXPTUUBUAUBYQVCZUDUEUKAYEXOYFVBZXPUUDVAUKAMLQ
      YFJYGUDUEYHYLVRZJOUUAPRYFSXOTUUBUBYGUAWLWJYPWKAYQHJOUUAYSPYFSXPYATUBYGUCU
      UEUUBUUCUKAYEUUFXPHVAUKUUGHJOPRYFSXOTUBYGUCUAWMWJZAYEXTYFVBYAHVAUKAMNQYFJ
      YGUDUEYHYPVRHJOPRYFSXTTUBYGUCUAWMWJZWNWHWOAXQYBYRFVBZAYIYJXQYKWPAYMYNYBYO
      WPAXPJWQURZVAYAUUKVAFUUKVAXQYBVIUUJXBAHUUKXPAJWRVAHUUKVBYHHJUCWSVFZUUHWTA
      HUUKYAUULUUIWTAHUUKFUULULWTYQXPYAFJUUEXAWBXCXDXECXIFKMXGQRUJXLVDXF $.
  $}

  ${
    $d a b f x D $.  $d f F $.  $d f L $.  $d a b x ph $.  $d f R $.  $d f U $.
    $d f ._|_ $.  $d a b x C $.
    lclkrs.h $e |- H = ( LHyp ` K ) $.
    lclkrs.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrs.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrs.s $e |- S = ( LSubSp ` U ) $.
    lclkrs.f $e |- F = ( LFnl ` U ) $.
    lclkrs.l $e |- L = ( LKer ` U ) $.
    lclkrs.d $e |- D = ( LDual ` U ) $.
    lclkrs.t $e |- T = ( LSubSp ` D ) $.
    lclkrs.c $e |- C = { f e. F | ( ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f )
        /\ ( ._|_ ` ( L ` f ) ) C_ R ) } $.
    lclkrs.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrs.r $e |- ( ph -> R e. S ) $.
    $( The set of functionals having closed kernels and majorizing the
       orthocomplement of a given subspace ` R ` is a subspace of the dual
       space.  TODO:  This proof repeats large parts of the ~ lclkr proof.  Do
       we achieve overall shortening by breaking them out as subtheorems?  Or
       make ~ lclkr a special case of this?  (Contributed by NM,
       29-Jan-2015.) $)
    lclkrs $p |- ( ph -> C e. T ) $=
      ( vx va vb cbs cfv wss c0 wne cv cvsca co cplusg wcel wral csca wceq crab
      wa ssrab2 a1i clmod eqid dvhlmod ldualvbase 3sstr4d c0g csn cxp lfl0f syl
      dochoc1 eqidd lkr0f syl2anc mpbird fveq2d 3eqtr4d chlt doch1 eqtrd lss0ss
      wb eqsstrd lcfls1lem syl3anbrc w3a adantr simpr3 simpr2 simpr1 ldualsbase
      ne0i eleqtrd lclkrslem1 lclkrslem2 ralrimivvva islss ) ABCUIUJZUKBULUMZUF
      UNZUGUNZCUOUJZUPZUHUNZCUQUJZUPBURZUHBUSUGBUSUFCUTUJZUIUJZUSBFURAHUNLUJZMU
      JZMUJXNVAXODUKVCZHIVBZIBXCXQIUKAXPHIVDVEBXQVAAUCVEACIXCGVFSUAXCVGZAGJKNOQ
      UDVHZVIVJAGUIUJZGUTUJZVKUJZVLVMZBURZXDAYCIURZYCLUJZMUJZMUJZYFVAYGDUKYDAGV
      FURZYEXSYAIXTGYBYAVGZYBVGZXTVGZSVNVOZAXTMUJZMUJXTYHYFAGJKMXTNOQPYLUDVPAYG
      YNMAYFXTMAYFXTVAZYCYCVAZAYCVQAYIYEYOYPWGXSYMYAIYCLXTGYBYJYKYLSTVRVSVTZWAZ
      WAYQWBAYGGVKUJZVLZDAYGYNYTYRAKWCURNJURVCZYNYTVAUDGJKMXTNYSOQPYLYSVGZWDVOW
      EAYIDEURZYTDUKXSUEEGDYSUUBRWFVSWHBDHIYCLMUCWIWJBYCWQVOAXKUFUGUHXMBBAXEXMU
      RZXFBURZXIBURZWKZVCZYAUIUJZBCXJDYAEXGGHXHIXIJKLMNOPQRSTUAYJUUIVGZXGVGZUCA
      UUAUUGUDWLZAUUCUUGUEWLZAUUDUUEUUFWMXJVGZUUHUUIBCDYAEXGGHIXFJKLMNXEOPQRSTU
      AYJUUJUUKUCUULUUMAUUDUUEUUFWNUUHXEXMUUIAUUDUUEUUFWOAXMUUIVAUUGACXLYAXMUUI
      VFGYJUUJUAXLVGZXMVGZXSWPWLWRWSWTXAUFXMXJFXGBXLXCCUGUHUUOUUPXRUUNUUKUBXBWJ
      $.
  $}

  ${
    $d g D $.  $d f g F $.  $d f g L $.  $d f g ._|_ $.  $d g Q $.  $d g U $.
    lclkrs2.h $e |- H = ( LHyp ` K ) $.
    lclkrs2.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lclkrs2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lclkrs2.s $e |- S = ( LSubSp ` U ) $.
    lclkrs2.f $e |- F = ( LFnl ` U ) $.
    lclkrs2.l $e |- L = ( LKer ` U ) $.
    lclkrs2.d $e |- D = ( LDual ` U ) $.
    lclkrs2.t $e |- T = ( LSubSp ` D ) $.
    lclkrs2.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lclkrs2.r $e |- R = { g e. F | ( ( ._|_ ` ( ._|_ ` ( L ` g ) ) ) =
      ( L ` g ) /\ ( ._|_ ` ( L ` g ) ) C_ Q ) } $.
    lclkrs2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lclkrs2.q $e |- ( ph -> Q e. S ) $.
    $( The set of functionals with closed kernels and majorizing the
       orthocomplement of a given subspace ` Q ` is a subspace of the dual
       space containing functionals with closed kernels.  Note that ` R ` is
       the value given by ~ mapdval .  (Contributed by NM, 12-Mar-2015.) $)
    lclkrs2 $p |- ( ph -> ( R e. T /\ R C_ C ) ) $=
      ( wcel wss lclkrs cv cfv wceq wa crab simpl a1i ss2rabi weq fveq2 eqeq12d
      wi fveq2d cbvrabv eqtri 3sstr4i jctir ) AEGUIEBUJAECDFGHJKLMNOPQRSTUAUBUC
      UDUFUGUHUKJULZNUMZOUMZOUMZVJUNZVKDUJZUOZJKUPVMJKUPZEBVOVMJKVOVMVCVIKUIVMV
      NUQURUSUFBIULZNUMZOUMZOUMZVRUNZIKUPVPUEWAVMIJKIJUTZVTVLVRVJWBVSVKOWBVRVJO
      VQVINVAZVDVDWCVBVEVFVGVH $.
  $}

  ${
    $d f x ._|_ $.  $d k D $.  $d k F $.  $d f k x G $.  $d k N $.  $d f x R $.
    $d f k x L $.  $d f k x ph $.  $d k U $.
    lcfrvalsn.h $e |- H = ( LHyp ` K ) $.
    lcfrvalsn.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrvalsn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrvalsn.f $e |- F = ( LFnl ` U ) $.
    lcfrvalsn.l $e |- L = ( LKer ` U ) $.
    lcfrvalsn.d $e |- D = ( LDual ` U ) $.
    lcfrvalsn.n $e |- N = ( LSpan ` D ) $.
    lcfrvalsn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrvalsn.g $e |- ( ph -> G e. F ) $.
    lcfrvalsn.q $e |- Q = U_ f e. R ( ._|_ ` ( L ` f ) ) $.
    lcfrvalsn.r $e |- R = ( N ` { G } ) $.
    $( Reconstruction from the dual space span of a singleton.  (Contributed by
       NM, 19-Feb-2015.)  (New usage is discouraged.) $)
    lcfrvalsnN $p |- ( ph -> Q = ( ._|_ ` ( L ` G ) ) ) $=
      ( vx vk cv cfv ciun wcel wrex eliun csn wi eleq2i wa chlt cbs adantr eqid
      wss clmod dvhlmod clss lduallmod ldualelvbase lspsncl syl2anc lssel sylan
      wceq ldualvbase eleqtrd cvsca co csca wb lspsnel ldualsbase rexeqdv bitrd
      lkrssv biimpa clvec dvhlvec lkrss2N mpbird dochss syl3anc sseld ex syl5bi
      rexlimdv lspsnid syl6eleqr fveq2 fveq2d eleq2d rspcev impbid syl5bb eqrdv
      syl5eq ) ACFDFUHZKUIZMUIZUJZHKUIZMUIZUDAUFXHXJUFUHZXHUKXKXGUKZFDULZAXKXJU
      KZFXKDXGUMAXMXNAXLXNFDXEDUKXEHUNLUIZUKZAXLXNUOZDXOXEUEUPAXPXQAXPUQZXGXJXK
      XRJURUKNIUKUQZXFEUSUIZVBXIXFVBZXGXJVBAXSXPUBUTXRGXEKXTEXTVAZRSAEVCUKXPAEI
      JNOQUBVDZUTXRXEBUSUIZGAXOBVEUIZUKZXPXEYDUKABVCUKZHYDUKZYFABETYCVFZABGHYDE
      VCRTYDVAZYCUCVGZYELYDBHYJYEVAZUAVHVIYEXOYDBXEYJYLVJVKAYDGVLXPABGYDEVCRTYJ
      YCVMUTVNZWCXRYAXEUGUHHBVOUIZVPVLZUGEVQUIZUSUIZULZAXPYRAXPYOUGBVQUIZUSUIZU
      LZYRAYGYHXPUUAVRYIYKYNXEUGYSYTLYDBHYSVAZYTVAZYJYNVAZUAVSVIAYOUGYTYQABYSYP
      YTYQVCEYPVAZYQVAZTUUBUUCYCVTWAWBWDXRBYQYPYNGHXEKEUGUUEUUFRSTUUDAEWEUKXPAE
      IJNOQUBWFUTAHGUKXPUCUTYMWGWHEIJMXTNXIXFOQYBPWIWJWKWLWMWNAXNXMAHDUKXNXMAHX
      ODAYGYHHXOUKYIYKLYDBHYJUAWOVIUEWPXLXNFHDXEHVLZXGXJXKUUGXFXIMXEHKWQWRWSWTV
      KWLXAXBXCXD $.
  $}

  ${
    lcfrlem1.v $e |- V = ( Base ` U ) $.
    lcfrlem1.s $e |- S = ( Scalar ` U ) $.
    lcfrlem1.q $e |- .X. = ( .r ` S ) $.
    lcfrlem1.z $e |- .0. = ( 0g ` S ) $.
    lcfrlem1.i $e |- I = ( invr ` S ) $.
    lcfrlem1.f $e |- F = ( LFnl ` U ) $.
    lcfrlem1.d $e |- D = ( LDual ` U ) $.
    lcfrlem1.t $e |- .x. = ( .s ` D ) $.
    lcfrlem1.m $e |- .- = ( -g ` D ) $.
    lcfrlem1.u $e |- ( ph -> U e. LVec ) $.
    lcfrlem1.e $e |- ( ph -> E e. F ) $.
    lcfrlem1.g $e |- ( ph -> G e. F ) $.
    lcfrlem1.x $e |- ( ph -> X e. V ) $.
    lcfrlem1.n $e |- ( ph -> ( G ` X ) =/= .0. ) $.
    lcfrlem1.h $e |- H = ( E .-
      ( ( ( I ` ( G ` X ) ) .X. ( E ` X ) ) .x. G ) ) $.
    $( Lemma for ~ lcfr .  Note that ` X ` is z in Mario's notes.  (Contributed
       by NM, 27-Feb-2015.) $)
    lcfrlem1 $p |- ( ph -> ( H ` X ) = .0. ) $=
      ( cfv co fveq1i csg eqid clvec wcel clmod lveclmod syl cbs lvecdrng lflcl
      cdr wne syl3anc drnginvrcl lmodmcl ldualvscl ldualvsubval ldualvsval wceq
      cur drnginvrr oveq1d lmodrng rngass syl13anc rnglidm syl2anc eqtrd oveq2d
      crg 3eqtr3d cgrp lmodfgrp grpsubid 3eqtrd syl5eq ) ANJUKNGNIUKZKUKZNGUKZE
      ULZIDULZLULZUKZONJWOUJUMAWPWLNWNUKZCUNUKZULWLWLWRULZOABCWRHGWNLMFNPQWRUOZ
      UAUBUDAFUPUQZFURUQZUEFUSUTZUFABCDHICVAUKZFWMUAQXDUOZUBUCXCAXBWKXDUQZWLXDU
      QZWMXDUQXCACVDUQZWJXDUQZWJOVEZXFAXAXHUECFQVBUTZAXAIHUQNMUQZXIUEUGUHCHIXDM
      FNUPQXEPUAVCVFZUIXDCKWJOXESTVGVFZAXAGHUQXLXGUEUFUHCHGXDMFNUPQXEPUAVCVFZEC
      XDFWKWLQXERVHVFZUGVIUHVJAWQWLWLWRAWQWJWMEULZWLANBCDEHIXDMFWMUPUAPQXERUBUC
      UEXPUGUHVKAWJWKEULZWLEULZCVMUKZWLEULZXQWLAXRXTWLEAXHXIXJXRXTVLXKXMUIXDCEX
      TKWJOXESRXTUOZTVNVFVOACWCUQZXIXFXGXSXQVLAXBYCXCCFQVPUTZXMXNXOXDCEWJWKWLXE
      RVQVRAYCXGYAWLVLYDXOXDCEXTWLXERYBVSVTWDWAWBACWEUQZXGWSOVLAXBYEXCCFQWFUTXO
      XDCWRWLOXESWTWGVTWHWI $.

    lcfrlem2.l $e |- L = ( LKer ` U ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 27-Feb-2015.) $)
    lcfrlem2 $p |- ( ph -> ( ( L ` E ) i^i ( L ` G ) ) C_ ( L ` H ) ) $=
      ( cfv cin cur cminusg co cplusg wss cbs eqid crg clmod clvec lveclmod syl
      wcel lmodrng cdr wne lvecdrng lflcl drnginvrcl rngcl lkrss ldualvscl cgrp
      syl3anc rnggrp rngidcl grpinvcl sstrd sslin lkrin fveq2i ldualvsub fveq2d
      syl2anc syl5req sseqtrd ) AGLUMZILUMZUNZGCUOUMZCUPUMZUMZOIUMZKUMZOGUMZEUQ
      ZIDUQZDUQZBURUMZUQZLUMZJLUMZAWMWKXBLUMZUNZXEAWLXGUSWMXHUSAWLXALUMXGABCDHI
      CUTUMZLFWTRXIVAZUBULUCUDUFUHACVBVGZWRXIVGZWSXIVGZWTXIVGAFVCVGZXKAFVDVGZXN
      UFFVEVFZCFRVHVFZACVIVGZWQXIVGZWQPVJXLAXOXRUFCFRVKVFAXOIHVGONVGZXSUFUHUICH
      IXINFOVDRXJQUBVLVRUJXICKWQPXJTUAVMVRAXOGHVGXTXMUFUGUICHGXINFOVDRXJQUBVLVR
      XICEWRWSXJSVNVRZVOABCDHXAXILFWPRXJUBULUCUDUFABCDHIXIFWTUBRXJUCUDXPYAUHVPZ
      ACVQVGZWNXIVGZWPXIVGAXKYCXQCVSVFAXKYDXQXICWNXJWNVAZVTVFXICWOWNXJWOVAZWAWH
      ZVOWBWLXGWKWCVFABXCHGXBLFUBULUCXCVAZXPUGABCDHXAXIFWPUBRXJUCUDXPYGYBVPWDWB
      AXFGXAMUQZLUMXEJYILUKWEAYIXDLABXCCDWNHGXAMWOFRYFYEUBUCYHUDUEXPUGYBWFWGWIW
      J $.

    $( Lemma for ~ lcfr .  (Contributed by NM, 27-Feb-2015.) $)
    lcfrlem3 $p |- ( ph -> X e. ( L ` H ) ) $=
      ( cfv wcel wceq lcfrlem1 clvec co clmod lveclmod syl cbs eqid crg lmodrng
      cdr wne lvecdrng lflcl syl3anc drnginvrcl rngcl ldualvscl syl5eqel ellkr2
      ldualvsubcl mpbird ) AOJLUMUNOJUMPUOABCDEFGHIJKMNOPQRSTUAUBUCUDUEUFUGUHUI
      UJUKUPACHJLNFOUQPQRTUBULUFAJGOIUMZKUMZOGUMZEURZIDURZMURHUKABHGWBMFUBUCUEA
      FUQUNZFUSUNZUFFUTVAZUGABCDHICVBUMZFWAUBRWFVCZUCUDWEACVDUNZVSWFUNZVTWFUNZW
      AWFUNAWDWHWECFRVEVAACVFUNZVRWFUNZVRPVGWIAWCWKUFCFRVHVAAWCIHUNONUNZWLUFUHU
      ICHIWFNFOUQRWGQUBVIVJUJWFCKVRPWGTUAVKVJAWCGHUNWMWJUFUGUICHGWFNFOUQRWGQUBV
      IVJWFCEVSVTWGSVLVJUHVMVPVNUIVOVQ $.
  $}

  ${
    $d g V $.  $d g ph $.
    lcfrlem4.h $e |- H = ( LHyp ` K ) $.
    lcfrlem4.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrlem4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrlem4.v $e |- V = ( Base ` U ) $.
    lcfrlem4.l $e |- L = ( LKer ` U ) $.
    lcfrlem4.d $e |- D = ( LDual ` U ) $.
    lcfrlem4.q $e |- Q = ( LSubSp ` D ) $.
    lcfrlem4.e $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
    lcfrlem4.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrlem4.g $e |- ( ph -> G e. Q ) $.
    lcfrlem4.x $e |- ( ph -> X e. E ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 10-Mar-2015.) $)
    lcfrlem4 $p |- ( ph -> X e. V ) $=
      ( cv cfv ciun wss wral wcel chlt adantr clfn eqid clmod dvhlmod cbs lssel
      wa sylan ldualvbase eleqtrd lkrssv dochssv syl2anc ralrimiva iunss sylibr
      wceq syl6eleq sseldd ) AEGEUFZJUGZKUGZUHZLNAVOLUIZEGUJVPLUIAVQEGAVMGUKZUT
      ZIULUKMHUKUTZVNLUIVQAVTVRUCUMVSDUNUGZVMJLDRWAUOZSADUPUKVRADHIMOQUCUQZUMVS
      VMBURUGZWAAGCUKVRVMWDUKUDCGWDBVMWDUOZUAUSVAAWDWAVJVRABWAWDDUPWBTWEWCVBUMV
      CVDDHIKLMVNOQRPVEVFVGEGVOLVHVIANFVPUEUBVKVL $.
  $}

  ${
    $d f A $.  $d f .x. $.  $d f X $.  $d f ph $.
    lcfrlem5.h $e |- H = ( LHyp ` K ) $.
    lcfrlem5.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrlem5.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrlem5.v $e |- V = ( Base ` U ) $.
    lcfrlem5.f $e |- F = ( LFnl ` U ) $.
    lcfrlem5.l $e |- L = ( LKer ` U ) $.
    lcfrlem5.d $e |- D = ( LDual ` U ) $.
    lcfrlem5.s $e |- S = ( LSubSp ` D ) $.
    lcfrlem5.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrlem5.r $e |- ( ph -> R e. S ) $.
    lcfrlem5.q $e |- Q = U_ f e. R ( ._|_ ` ( L ` f ) ) $.
    lcfrlem5.x $e |- ( ph -> X e. Q ) $.
    lcfrlem5.c $e |- C = ( Scalar ` U ) $.
    lcfrlem5.b $e |- B = ( Base ` C ) $.
    lcfrlem5.t $e |- .x. = ( .s ` U ) $.
    lcfrlem5.a $e |- ( ph -> A e. B ) $.
    $( Lemma for ~ lcfr .  The set of functionals having closed kernels and
       majorizing the orthocomplement of a given subspace ` Q ` is closed under
       scalar product.  TODO: share hypotheses with others.  Use more
       consistent variable names here or elsewhere when possible.  (Contributed
       by NM, 5-Mar-2015.) $)
    lcfrlem5 $p |- ( ph -> ( A .x. X ) e. Q ) $=
      ( co cv cfv ciun wcel wrex syl6eleq eliun sylib wa clmod dvhlmod ad2antrr
      clss chlt wss cbs eqid lssss syl ldualvbase sseqtrd sselda adantr dochlss
      lkrssv syl2anc simpr lssvscl syl22anc ex reximdva mpd sylibr syl6eleqr )
      ABSIUPZKGKUQZOURZPURZUSZFAWKWNUTZKGVAZWKWOUTASWNUTZKGVAZWQASWOUTWSASFWOUK
      UJVBKSGWNVCVDAWRWPKGAWLGUTZVEZWRWPXAWRVEZJVFUTZWNJVIURZUTZBCUTZWRWPAXCWTW
      RAJMNRTUBUHVGZVHZXBNVJUTRMUTVEZWMQVKXEAXIWTWRUHVHXBLWLOQJUCUDUEXHXAWLLUTW
      RAGLWLAGEVLURZLAGHUTGXJVKUIHGXJEXJVMZUGVNVOAELXJJVFUDUFXKXGVPVQVRVSWAXDJM
      NPQRWMTUBUCXDVMZUAVTWBAXFWTWRUOVHXAWRWCCXDIWNDJBSULUNUMXLWDWEWFWGWHKWKGWN
      VCWIUJWJ $.
  $}

  ${
    $d g .+ $.  $d g U $.  $d g X $.  $d g Y $.  $d g ph $.
    lcfrlem6.h $e |- H = ( LHyp ` K ) $.
    lcfrlem6.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrlem6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrlem6.p $e |- .+ = ( +g ` U ) $.
    lcfrlem6.n $e |- N = ( LSpan ` U ) $.
    lcfrlem6.l $e |- L = ( LKer ` U ) $.
    lcfrlem6.d $e |- D = ( LDual ` U ) $.
    lcfrlem6.q $e |- Q = ( LSubSp ` D ) $.
    lcfrlem6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrlem6.g $e |- ( ph -> G e. Q ) $.
    lcfrlem6.e $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
    lcfrlem6.x $e |- ( ph -> X e. E ) $.
    lcfrlem6.y $e |- ( ph -> Y e. E ) $.
    lcfrlem6.en $e |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $.
    $( Lemma for ~ lcfr .  Closure of vector sum with colinear vectors.  TODO:
       Move down ` N ` definition so top hypotheses can be shared.
       (Contributed by NM, 10-Mar-2015.) $)
    lcfrlem6 $p |- ( ph -> ( X .+ Y ) e. E ) $=
      ( co cv cfv ciun wcel wrex syl6eleq eliun sylib clmod clss dvhlmod adantr
      chlt cbs wss clfn eqid lssel sylan wceq ldualvbase eleqtrd lkrssv dochlss
      syl2anc simpr csn eqsstr3d lcfrlem4 lspsnel5 3imtr4d imp lssvacl syl22anc
      wa ex reximdva mpd sylibr syl6eleqr ) AOPCUKZFHFULZKUMZMUMZUNZGAWLWOUOZFH
      UPZWLWPUOAOWOUOZFHUPZWRAOWPUOWTAOGWPUHUGUQFOHWOURUSAWSWQFHAWMHUOZWFZWSWQX
      BWSWFEUTUOZWOEVAUMZUOZWSPWOUOZWQXBXCWSAXCXAAEIJNQSUEVBZVCZVCXBXEWSXBJVDUO
      NIUOWFZWNEVEUMZVFXEAXIXAUEVCXBEVGUMZWMKXJEXJVHZXKVHZUBXHXBWMBVEUMZXKAHDUO
      XAWMXNUOUFDHXNBWMXNVHZUDVIVJAXNXKVKXAABXKXNEUTXMUCXOXGVLVCVMVNXDEIJMXJNWN
      QSXLXDVHZRVOVPZVCXBWSVQXBWSXFXBOVRLUMZWOVFZPVRLUMZWOVFZWSXFXBXSYAXBXSWFXT
      XRWOXBXRXTVKZXSAYBXAUJVCVCXBXSVQVSWGXBXDWOLXJEOXLXPUAXHXQAOXJUOXAABDEFGHI
      JKMXJNOQRSXLUBUCUDUGUEUFUHVTVCWAXBXDWOLXJEPXLXPUAXHXQAPXJUOXAABDEFGHIJKMX
      JNPQRSXLUBUCUDUGUEUFUIVTVCWAWBWCCXDWOEOPTXPWDWEWGWHWIFWLHWOURWJUGWK $.
  $}

  ${
    $d g U $.  $d g ph $.
    lcfrlem7.h $e |- H = ( LHyp ` K ) $.
    lcfrlem7.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrlem7.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrlem7.p $e |- .+ = ( +g ` U ) $.
    lcfrlem7.l $e |- L = ( LKer ` U ) $.
    lcfrlem7.d $e |- D = ( LDual ` U ) $.
    lcfrlem7.q $e |- Q = ( LSubSp ` D ) $.
    lcfrlem7.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrlem7.g $e |- ( ph -> G e. Q ) $.
    lcfrlem7.e $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
    lcfrlem7.x $e |- ( ph -> X e. E ) $.
    lcfrlem7.z $e |- .0. = ( 0g ` U ) $.
    lcfrlem7.y $e |- ( ph -> Y = .0. ) $.
    $( Lemma for ~ lcfr .  Closure of vector sum when one vector is zero.
       TODO: share hypotheses with others.  (Contributed by NM,
       11-Mar-2015.) $)
    lcfrlem7 $p |- ( ph -> ( X .+ Y ) e. E ) $=
      ( co oveq2d clmod wcel cbs cfv wceq dvhlmod eqid lcfrlem4 lmod0vrid eqtrd
      syl2anc eqeltrd ) ANOCUJZNGAVDNPCUJZNAOPNCUIUKAEULUMNEUNUOZUMVENUPAEIJMQS
      UDUQABDEFGHIJKLVFMNQRSVFURZUAUBUCUFUDUEUGUSCVFENPVGTUHUTVBVAUGVC $.
  $}

  ${
    $d w x ._|_ $.  $d x .0. $.  $d v x V $.  $d x .x. $.  $d k v w x X $.
    $d x .+ $.  $d x R $.
    lcf1o.h $e |- H = ( LHyp ` K ) $.
    lcf1o.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcf1o.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcf1o.v $e |- V = ( Base ` U ) $.
    lcf1o.a $e |- .+ = ( +g ` U ) $.
    lcf1o.t $e |- .x. = ( .s ` U ) $.
    lcf1o.s $e |- S = ( Scalar ` U ) $.
    lcf1o.r $e |- R = ( Base ` S ) $.
    lcf1o.z $e |- .0. = ( 0g ` U ) $.
    lcf1o.f $e |- F = ( LFnl ` U ) $.
    lcf1o.l $e |- L = ( LKer ` U ) $.
    lcf1o.d $e |- D = ( LDual ` U ) $.
    lcf1o.q $e |- Q = ( 0g ` D ) $.
    lcf1o.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcf1o.j $e |- J = ( x e. ( V \ { .0. } ) |-> ( v e. V |->
      ( iota_ k e. R E. w e. ( ._|_ ` { x } ) v = ( w .+ ( k .x. x ) ) ) ) ) $.
    lcflo.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      lcfrlem8.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      $( Lemma for ~ lcf1o and ~ lcfr .  (Contributed by NM, 21-Feb-2015.) $)
      lcfrlem8 $p |- ( ph -> ( J ` X ) = ( v e. V |->
      ( iota_ k e. R E. w e. ( ._|_ ` { X } ) v = ( w .+ ( k .x. X ) ) ) ) ) $=
        ( csn cdif wcel cfv cv co wceq wrex crio cmpt sneq fveq2d oveq2d eqeq2d
        oveq2 rexeqbidv riotabidv mpteq2dv cbs cvv fvex eqeltri mptex fvmpt syl
        ) AUCUAUDVBVCZVDUCQVEDUADVFZCVFZNVFZUCKVGZGVGZVHZCUCVBZTVEZVIZNIVJZVKZV
        HVABUCDUAWHWIWJBVFZKVGZGVGZVHZCWSVBZTVEZVIZNIVJZVKWRWGQWSUCVHZDUAXFWQXG
        XEWPNIXGXBWMCXDWOXGXCWNTWSUCVLVMXGXAWLWHXGWTWKWIGWSUCWJKVPVNVOVQVRVSUSD
        UAWQUALVTVEWAUHLVTWBWCWDWEWF $.
    $}

    ${
      $d f k v w x y .+ $.  $d g k t u v w x z J $.  $d g k v w x y z C $.
      $d f F $.  $d f k v w x y z L $.  $d f k v w x y z ._|_ $.
      $d g k v w x z Q $.  $d f k v w x y R $.  $d k v w x y z S $.
      $d f k v w x y .x. $.  $d k w x y z U $.  $d f k t u v w x y z V $.
      $d k t u v w x y z .0. $.  $d g k t u v w x y z ph $.  $d f g $.
      $( Lemma for ~ lcf1o .  (This part has undesirable $d's on ` J ` and
         ` ph ` that we remove in ~ lcf1o .)  TODO: ugly proof; maybe have
         better subtheorems or abbreviate some ` iota_ k ` expansions with
         ` J `` z ` ?  TODO:  Some redundant $d's?  (Contributed by NM,
         22-Feb-2015.) $)
      lcfrlem9 $p |- ( ph -> J : ( V \ { .0. } ) -1-1-onto-> ( C \ { Q } ) ) $=
        ( vt vu vg vz vy csn cdif wfn crn wceq cv cfv wi wral wf1o co wrex crio
        weq cmpt cbs cvv fvex eqeltri mptex fnmpti a1i wcel wb fvelrnb syl chlt
        wa adantr simpr lcfrlem8 wne wo eqid sneq fveq2d oveq2 oveq2d rexeqbidv
        eqeq2d riotabidv mpteq2dv rspcev olcd dochflcl lcfl6 mpbird dochsnkr2cl
        sylancl dochsnkrlem3 dochsnkrlem1 eqnetrrd clmod lkr0f2 necon3bid mpbid
        dvhlmod eldifsn sylanbrc eqeltrd syl5ibcom rexlimdva wn simprl lcfl1lem
        eleq1 simplbi adantl biimprd impr neneqd biimpa ord 3impia ad2antrr ex
        mpd3an23 sylan2b eqcom syl5bb rexbidva simplrl simplrr 3eqtr3d lcfl7lem
        impbid bitrd eqrdv ralrimivva dff1o6 syl3anbrc ) AQUAUCVEVFZVGZQVHZEHVE
        VFZVIUTVJZQVKZVAVJZQVKZVIZUTVAVRZVLZVAUUPVMUTUUPVMUUPUUSQVNUUQABUUPDUAD
        VJZCVJZNVJZBVJZKVOGVOVICUVJVETVKVPNIVQZVSQDUAUVKUALVTVKWAUGLVTWBWCWDURW
        EWFZAVBUURUUSAVBVJZUURWGZVCVJZQVKZUVMVIZVCUUPVPZUVMUUSWGZAUUQUVNUVRWHUV
        LVCUUPUVMQWIWJAUVRUVSAUVQUVSVCUUPAUVOUUPWGZWLZUVPUUSWGUVQUVSUWAUVPDUAUV
        GUVHUVIUVOKVOZGVOZVIZCUVOVEZTVKZVPZNIVQZVSZUUSUWABCDEFGHIJKLMNOPQRSTUAU
        BUVOUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURARWKWGUBPWGWLZUVTUSWMZAUVTWNZWOUWAU
        WIEWGZUWIHWPZUWIUUSWGUWAUWMUWISVKZUAVIZUWIDUAUVGUVHUVIVDVJZKVOZGVOZVIZC
        UWQVEZTVKZVPZNIVQZVSZVIZVDUUPVPZWQUWAUXGUWPUWAUVTUWIUWIVIZUXGUWLUWIWRZU
        XFUXHVDUVOUUPVDVCVRZUXEUWIUWIUXJDUAUXDUWHUXJUXCUWGNIUXJUWTUWDCUXBUWFUXJ
        UXAUWETUWQUVOWSWTUXJUWSUWCUVGUXJUWRUWBUVHGUWQUVOUVIKXAXBXDXCXEXFXDXGXMX
        HUWAVDCDEGIJKLMNOUWIPRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUQUWKUWACDJGIKLNOUW
        IPRTUAUBUVOUCUDUEUFUGULUHUIUMUJUKUXIUWKUWLXIZXJXKUWAUWOUAWPUWNUWAUWOTVK
        TVKUWOUAUWALOUWIPRSTUAUBUVOUCUDUEUFUGULUMUNUWKUXKUWACDJGIKLNUWIPRSTUAUB
        UVOUCUDUEUFUGULUHUIUNUJUKUXIUWKUWLXLZXNUWALOUWIPRSTUAUBUVOUCUDUEUFUGULU
        MUNUWKUXKUXLXOXPUWAUWOUAUWIHUWAFOUWISUALHUGUMUNUOUPALXQWGZUVTALPRUBUDUF
        USYAZWMUXKXRXSXTUWIEHYBYCYDUVPUVMUUSYJYEYFAUVSUVRAUVSWLZUVRUVMUWIVIZVCU
        UPVPZUVSAUVMEWGZUVMHWPZWLZUXQUVMEHYBAUXTWLZUXRUVMSVKZUAVIZYGZUXQAUXRUXS
        YHUYAUYBUAAUXRUXSUYBUAWPZAUXRWLZUYEUXSUYFUYBUAUVMHUYFFOUVMSUALHUGUMUNUO
        UPAUXMUXRUXNWMUXRUVMOWGZAUXRUYGUYBTVKTVKUYBVIEMOUVMSTUQYIYKZYLXRXSYMYNY
        OUYAUXRUYDUXQUYAUXRWLUYCUXQUYAUXRUYCUXQWQUYAVCCDEGIJKLMNOUVMPRSTUAUBUCU
        DUEUFUGUHUIUJUKULUMUNUQAUWJUXTUSWMUXTUYGAUXRUYGUXSUYHWMYLXJYPYQYRUUAUUB
        UXOUVQUXPVCUUPUVQUVMUVPVIUXOUVTWLZUXPUVPUVMUUCUYIUVPUWIUVMUYIBCDEFGHIJK
        LMNOPQRSTUAUBUVOUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURAUWJUVSUVTUSYSUXOUVTWNW
        OXDUUDUUEXKYTUUJUUKUULAUVFUTVAUUPUUPAUUTUUPWGZUVBUUPWGZWLZWLZUVDUVEUYMU
        VDWLZCDGIJKLNODUAUVGUVHUVIUUTKVOGVOVICUUTVETVKVPNIVQVSZPDUAUVGUVHUVIUVB
        KVOGVOVICUVBVETVKVPNIVQVSZRSTUAUBUUTUVBUCUDUEUFUGUHUIUJUKULUMUNAUWJUYLU
        VDUSYSZUYOWRUYPWRAUYJUYKUVDUUFZAUYJUYKUVDUUGZUYNUVAUVCUYOUYPUYMUVDWNUYN
        BCDEFGHIJKLMNOPQRSTUAUBUUTUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUYQUYRWOUYNBC
        DEFGHIJKLMNOPQRSTUAUBUVBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUYQUYSWOUUHUUIY
        TUUMUTVAUUPUUSQUUNUUO $.
    $}

    ${
      $d f k l u v w x y z .+ $.  $d f k l u v w x y z ._|_ $.  $d l u y z C $.
      $d l u x y z .0. $.  $d l u y z J $.  $d f l u y z L $.  $d l u y z ph $.
      $d l u y z Q $.  $d f k l u v x y z R $.  $d l u y z S $.  $d l y z U $.
      $d f F $.  $d f l u v x y z V $.  $d f k l u v w x y z .x. $.
      $( Define a function ` J ` that provides a bijection from nonzero vectors
         ` V ` to nonzero functionals with closed kernels ` C ` .  (Contributed
         by NM, 22-Feb-2015.) $)
      lcf1o $p |- ( ph -> J : ( V \ { .0. } ) -1-1-onto-> ( C \ { Q } ) ) $=
        ( vy vz vu vl csn cdif cv co wceq cfv wrex crio cmpt weq eqeq2d cbvrexv
        oveq1 oveq2d rexbidv syl5bb cbvriotav eqeq1 riotabidv syl5eq sneq oveq2
        cbvmptv fveq2d rexeqbidv mpteq2dv eqtri lcfrlem9 ) AUTVAVBEFGHIJKLMVCOP
        QRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQQBUAUCVDVEZDUADVFZCVFZNVFZBVFZKVG
        ZGVGZVHZCWPVDZTVIZVJZNIVKZVLZVLUTWLVBUAVBVFZVAVFZVCVFZUTVFZKVGZGVGZVHZV
        AXHVDZTVIZVJZVCIVKZVLZVLURBUTWLXDXPBUTVMZXDVBUAXEXFXGWPKVGZGVGZVHZVAXAV
        JZVCIVKZVLXPDVBUAXCYBDVBVMZXCWMXSVHZVAXAVJZVCIVKYBXBYENVCIXBWMXFWQGVGZV
        HZVAXAVJNVCVMZYEWSYGCVAXACVAVMWRYFWMWNXFWQGVPVNVOYHYGYDVAXAYHYFXSWMYHWQ
        XRXFGWOXGWPKVPVQVNVRVSVTYCYEYAVCIYCYDXTVAXAWMXEXSWAVRWBWCWFXQVBUAYBXOXQ
        YAXNVCIXQXTXKVAXAXMXQWTXLTWPXHWDWGXQXSXJXEXQXRXIXFGWPXHXGKWEVQVNWHWBWIW
        CWFWJUSWK $.
    $}

    ${
      $d k v w .+ $.  $d k v ._|_ $.  $d k v R $.  $d k S $.  $d k v w .x. $.
      lcfrlem10.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      $( Lemma for ~ lcfr .  (Contributed by NM, 23-Feb-2015.) $)
      lcfrlem10 $p |- ( ph -> ( J ` X ) e. F ) $=
        ( cfv cv co wceq csn wrex crio cmpt lcfrlem8 eqid dochflcl eqeltrd ) AU
        CQVBDUADVCCVCNVCUCKVDGVDVECUCVFTVBVGNIVHVIZOABCDEFGHIJKLMNOPQRSTUAUBUCU
        DUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVJACDJGIKLNOVNPRTUAUBUCUDUEUFUGUHUMU
        IUJUNUKULVNVKUTVAVLVM $.

      $( Lemma for ~ lcfr .  (Contributed by NM, 23-Feb-2015.) $)
      lcfrlem11 $p |- ( ph -> ( L ` ( J ` X ) ) = ( ._|_ ` { X } ) ) $=
        ( cfv cv wceq csn wrex crio cmpt lcfrlem8 fveq2d eqid dochsnkr2 eqtrd
        co ) AUCQVBZSVBDUADVCCVCNVCUCKVNGVNVDCUCVETVBZVFNIVGVHZSVBVPAVOVQSABCDE
        FGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVIVJACDJGIKLNV
        QPRSTUAUBUCUDUEUFUGUHUMUIUJUOUKULVQVKUTVAVLVM $.

      ${
        lcfrlem12.b $e |- B = ( 0g ` S ) $.
        lcfrlem12.y $e |- ( ph -> Y e. ( ._|_ ` { X } ) ) $.
        $( Lemma for ~ lcfr .  (Contributed by NM, 23-Feb-2015.)
           (New usage is discouraged.) $)
        lcfrlem12N $p |- ( ph -> ( ( J ` X ) ` Y ) = B ) $=
          ( clmod wcel cfv wceq dvhlmod lcfrlem10 csn lcfrlem11 eleqtrrd lkrf0
          syl3anc ) AMVFVGUDRVHZPVGUEVQTVHZVGUEVQVHEVIAMQSUCUGUIVBVJABCDFGHIJKL
          MNOPQRSTUAUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVKAUEUDVLUAVHVRVE
          ABCDFGHIJKLMNOPQRSTUAUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVMVNKP
          VQTMUEVFEUMVDUPUQVOVP $.
      $}

      $d f k v w .+ $.  $d f F $.  $d f L $.  $d f k v ._|_ $.  $d f k v R $.
      $d f k v w .x. $.  $d f V $.  $d f k x $.
      $( Lemma for ~ lcfr .  (Contributed by NM, 8-Mar-2015.) $)
      lcfrlem13 $p |- ( ph -> ( J ` X ) e. ( C \ { Q } ) ) $=
        ( csn cdif wf1o wf lcf1o f1of syl ffvelrnd ) AUAUDVBVCZEHVBVCZUCQAVJVKQ
        VDVJVKQVEABCDEFGHIJKLMNOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVFVJ
        VKQVGVHVAVI $.

      $d f J $.  $d k S $.  $d f k v w x X $.
      ${
        lcfrlem14.n $e |- N = ( LSpan ` U ) $.
        $( Lemma for ~ lcfr .  (Contributed by NM, 10-Mar-2015.) $)
        lcfrlem14 $p |- ( ph ->
          ( ._|_ ` ( L ` ( J ` X ) ) ) = ( N ` { X } ) ) $=
          ( cfv csn lcfrlem11 eldifad snssd dochocsp eqtr4d fveq2d chlt wcel wa
          cdih crn wceq eqid dihlsprn syl2anc dochoc eqtrd ) AUDQVDSVDZUAVDUDVE
          ZTVDZUAVDZUAVDZWEAWCWFUAAWCWDUAVDWFABCDEFGHIJKLMNOPQRSUAUBUCUDUEUFUGU
          HUIUJUKULUMUNUOUPUQURUSUTVAVBVFALPRTUAUBUCWDUFUHUGUIVCVAAUDUBAUDUBUEV
          EVBVGZVHVIVJVKARVLVMUCPVMVNZWEUCRVOVDVDZVPVMZWGWEVQVAAWIUDUBVMWKVAWHL
          PWJRTUBUCUDUFUHUIVCWJVRZVSVTPWJRUAUCWEUFWLUGWAVTWB $.
      $}

      $( Lemma for ~ lcfr .  (Contributed by NM, 9-Mar-2015.) $)
      lcfrlem15 $p |- ( ph -> X e. ( ._|_ ` ( L ` ( J ` X ) ) ) ) $=
        ( csn clspn cfv wcel dvhlmod eldifad lspsnid syl2anc lcfrlem14 eleqtrrd
        clmod eqid ) AUCUCVBLVCVDZVDZUCQVDSVDTVDALVLVEUCUAVEUCVOVEALPRUBUEUGUTV
        FAUCUAUDVBVAVGVNUALUCUHVNVMZVHVIABCDEFGHIJKLMNOPQRSVNTUAUBUCUDUEUFUGUHU
        IUJUKULUMUNUOUPUQURUSUTVAVPVJVK $.
    $}

    $d f k v w .+ $.  $d f k F $.  $d g k G $.  $d f g k J $.  $d f k L $.
    $d f k v ._|_ $.  $d f k v R $.  $d k S $.  $d f k v w .x. $.  $d k U $.
    $d f g V $.  $d f g k v w x X $.  $d g ph $.  $d k ph $.
    lcfrlem16.p $e |- P = ( LSubSp ` D ) $.
    lcfrlem16.g $e |- ( ph -> G e. P ) $.
    lcfrlem16.gs $e |- ( ph -> G C_ C ) $.
    lcfrlem16.m $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
    lcfrlem16.x $e |- ( ph -> X e. ( E \ { .0. } ) ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 8-Mar-2015.) $)
    lcfrlem16 $p |- ( ph -> ( J ` X ) e. G ) $=
      ( cfv wcel wrex ciun csn eldifad syl6eleq eliun sylib w3a cvsca wceq eqid
      cv co clvec dvhlvec 3ad2ant1 wa cbs lssel sylan dvhlmod ldualvbase adantr
      clmod eleqtrd 3adant3 cdif wss wral chlt lkrssv dochssv syl2anc ralrimiva
      iunss sylibr syl5eqss ssdifd sseldd lcfrlem10 clsa wne simp3 eldifsni syl
      eldifsn sylanbrc dochsnkrlem2 lcfrlem15 lsat2el crn simp2 lcfl5 lcfrlem13
      cdih mpbid doch11 eqlkr4 simpr ldualssvscl eleq1 syl5ibrcom rexlimdva mpd
      simpl2 rexlimdv3a ) AUGOWCZUCVJZUDVJZVKZOSVLZUGUAVJZSVKZAUGOSYTVMZVKUUBAU
      GQUUEAUGQUHVNZVIVOVHVPOUGSYTVQVRAUUAUUDOSAYRSVKZUUAVSZUUCPWCZYRFVTVJZWDZW
      AZPJVLUUDUUHFJKUUJRYRUUCUCMPUOUPURUSUTUUJWBZAUUGMWEVKUUAAMTUBUFUIUKVDWFWG
      ZAUUGYRRVKUUAAUUGWHZYRFWIVJZRASGVKZUUGYRUUPVKVFGSUUPFYRUUPWBZVEWJWKAUUPRW
      AUUGAFRUUPMWOURUTUURAMTUBUFUIUKVDWLZWMWNWPZWQZAUUGUUCRVKUUAABCDEFHIJKLMNP
      RTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDAQUUFWRZUEUUFWRUGAQUEUU
      FAQUUEUEVHAYTUEWSZOSWTUUEUEWSAUVCOSUUOUBXAVKUFTVKWHZYSUEWSUVCAUVDUUGVDWNU
      UORYRUCUEMULURUSAMWOVKZUUGUUSWNUUTXBMTUBUDUEUFYSUIUKULUJXCXDXEOSYTUEXFXGX
      HXIVIXJZXKZWGUUHYTUUCUCVJZUDVJZWAYSUVHWAUUHMXLVJZYTUVIMUGUHUQUVJWBZUUNUUH
      UVJMRYRTUBUCUDUEUFUGUHUIUJUKULUQURUSAUUGUVDUUAVDWGZUVAUUHUUAUGUHXMZUGYTUU
      FWRVKAUUGUUAXNZAUUGUVMUUAAUGUVBVKUVMVIUGQUHXOXPZWGZUGYTUHXQXRUVKXSAUUGUVI
      UVJVKUUAAUVJMRUUCTUBUCUDUEUFUGUHUIUJUKULUQURUSVDUVGAUGUVIVKZUVMUGUVIUUFWR
      VKABCDEFHIJKLMNPRTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDUVFXTZU
      VOUGUVIUHXQXRUVKXSWGUVPUVNAUUGUVQUUAUVRWGYAUUHTUFUBYFVJVJZUBUDUFYSUVHUIUV
      SWBZUJUVLUUHYREVKYSUVSYBZVKUUHSEYRAUUGSEWSUUAVGWGAUUGUUAYCXJUUHEMNRYRTUVS
      UBUCUDUFUIUVTUJUKURUSVBUVLUVAYDYGAUUGUVHUWAVKZUUAAUUCEVKUWBAUUCEIVNABCDEF
      HIJKLMNPRTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDUVFYEVOAEMNRUUC
      TUVSUBUCUDUFUIUVTUJUKURUSVBVDUVGYDYGWGYHYGYIUUHUULUUDPJUUHUUIJVKZWHZUUDUU
      LUUKSVKUWDFKGUUJSJMUUIYRUOUPUTUUMVEUUHUVEUWCAUUGUVEUUAUUSWGWNUUHUUQUWCAUU
      GUUQUUAVFWGWNUUHUWCYJAUUGUUAUWCYPYKUUCUUKSYLYMYNYOYQYO $.
  $}

  ${
    lcfrlem17.h $e |- H = ( LHyp ` K ) $.
    lcfrlem17.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrlem17.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrlem17.v $e |- V = ( Base ` U ) $.
    lcfrlem17.p $e |- .+ = ( +g ` U ) $.
    lcfrlem17.z $e |- .0. = ( 0g ` U ) $.
    lcfrlem17.n $e |- N = ( LSpan ` U ) $.
    lcfrlem17.a $e |- A = ( LSAtoms ` U ) $.
    lcfrlem17.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrlem17.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    lcfrlem17.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    lcfrlem17.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    $( Lemma for ~ lcfr .  Condition needed more than once.  (Contributed by
       NM, 11-Mar-2015.) $)
    lcfrlem17 $p |- ( ph -> ( X .+ Y ) e. ( V \ { .0. } ) ) $=
      ( co wcel wne csn cdif dvhlmod eldifad lmodvacl syl3anc lmodindp1 eldifsn
      clmod sylanbrc ) AKLCUFZIUGZUSMUHUSIMUIZUJUGADUQUGKIUGLIUGUTADEFJNPUBUKZA
      KIVAUCULZALIVAUDULZCIDKLQRUMUNACGIDKLMQRSTVBVCVDUEUOUSIMUPUR $.

    $( Lemma for ~ lcfr .  (Contributed by NM, 24-Feb-2015.) $)
    lcfrlem18 $p |- ( ph
  -> ( ._|_ ` { X , Y } ) = ( ( ._|_ ` { X } ) i^i ( ._|_ ` { Y } ) ) ) $=
      ( cpr cfv csn cun cin df-pr fveq2i chlt wcel wa wss wceq eldifad dochdmj1
      snssd syl3anc syl5eq ) AKLUFZHUGKUHZLUHZUIZHUGZVDHUGVEHUGUJZVCVFHKLUKULAF
      UMUNJEUNUOVDIUPVEIUPVGVHUQUBAKIAKIMUHZUCURUTALIALIVIUDURUTDEFHIJVDVENPQOU
      SVAVB $.

    $( Lemma for ~ lcfr .  (Contributed by NM, 11-Mar-2015.) $)
    lcfrlem19 $p |- ( ph -> ( -. X e. ( ._|_ ` { ( X .+ Y ) } ) \/
                              -. Y e. ( ._|_ ` { ( X .+ Y ) } ) ) ) $=
      ( co csn cfv wcel wa wn wo lcfrlem17 dochnel clss dvhlmod adantr chlt wss
      clmod eldifad lmodvacl syl3anc snssd dochlss syl2anc simpr syl21anc mtand
      eqid lssvacl ianor sylib ) AKKLCUFZUGZHUHZUIZLVPUIZUJZUKVQUKVRUKULAVSVNVP
      UIZADEFHIJVNMNOPQSUBABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUMUNAVSUJDUTUIZVPDUOUHZ
      UIZVSVTAWAVSADEFJNPUBUPZUQAWCVSAFURUIJEUIUJVOIUSWCUBAVNIAWAKIUILIUIVNIUIW
      DAKIMUGZUCVAALIWEUDVACIDKLQRVBVCVDWBDEFHIJVONPQWBVJZOVEVFUQAVSVGCWBVPDKLR
      WFVKVHVIVQVRVLVM $.

    ${
      lcfrlem20.e $e |- ( ph -> -. X e. ( ._|_ ` { ( X .+ Y ) } ) ) $.
      $( Lemma for ~ lcfr .  (Contributed by NM, 11-Mar-2015.) $)
      lcfrlem20 $p |- ( ph
  -> ( ( N ` { X , Y } ) i^i ( ._|_ ` { ( X .+ Y ) } ) ) e. A ) $=
        ( cpr cfv co csn cin clsm eqid dvhlmod eldifad ineq1d clss clsh dvhlvec
        lsmpr lcfrlem17 dochsnshp lsatlspsn wcel chlt wa clmod lmodvacl syl3anc
        wss snssd dochlss syl2anc lspsnel5 mtbid lshpat eqeltrd ) AKLUGGUHZKLCU
        IZUJZHUHZUKKUJGUHZLUJGUHZDULUHZUIZWAUKBAVRWEWAAWDGIDKLQTWDUMZADEFJNPUBU
        NZAKIMUJZUCUOZALIWHUDUOZUTUPABWDWBWCDUQUHZWADURUHZDWKUMZWFWLUMZUAADEFJN
        PUBUSADEFHIJVSWLMNOPQSWNUBABCDEFGHIJKLMNOPQRSTUAUBUCUDUEVAVBABGIDKMQTSU
        AWGUCVCABGIDLMQTSUAWGUDVCUEAKWAVDWBWAVJUFAWKWAGIDKQWMTWGAFVEVDJEVDVFVTI
        VJWAWKVDUBAVSIADVGVDKIVDLIVDVSIVDWGWIWJCIDKLQRVHVIVKWKDEFHIJVTNPQWMOVLV
        MWIVNVOVPVQ $.
    $}

    $( Lemma for ~ lcfr .  (Contributed by NM, 11-Mar-2015.) $)
    lcfrlem21 $p |- ( ph
  -> ( ( N ` { X , Y } ) i^i ( ._|_ ` { ( X .+ Y ) } ) ) e. A ) $=
      ( co csn cfv wcel wn cpr cin wa chlt adantr cdif wne simpr lcfrlem20 wceq
      clmod dvhlmod eldifad lmodcom syl3anc sneqd fveq2d eleq2d biimprd con3and
      prcom fveq2i a1i ineq12d necomd eqeltrd syldan lcfrlem19 mpjaodan ) AKKLC
      UFZUGZHUHZUIUJZKLUKZGUHZWBULZBUIZLWBUIZUJZAWCUMBCDEFGHIJKLMNOPQRSTUAAFUNU
      IJEUIUMZWCUBUOAKIMUGZUPZUIZWCUCUOALWLUIZWCUDUOAKUGGUHZLUGGUHZUQWCUEUOAWCU
      RUSAWILLKCUFZUGZHUHZUIZUJZWGAWTWHAWHWTAWBWSLAWAWRHAVTWQADVAUIKIUILIUIVTWQ
      UTADEFJNPUBVBAKIWKUCVCALIWKUDVCCIDKLQRVDVEVFVGZVHVIVJAXAUMZWFLKUKZGUHZWSU
      LZBAWFXFUTXAAWEXEWBWSWEXEUTAWDXDGKLVKVLVMXBVNUOXCBCDEFGHIJLKMNOPQRSTUAAWJ
      XAUBUOAWNXAUDUOAWMXAUCUOAWPWOUQXAAWOWPUEVOUOAXAURUSVPVQABCDEFGHIJKLMNOPQR
      STUAUBUCUDUEVRVS $.

    lcfrlem22.b $e |- B = ( ( N ` { X , Y } ) i^i ( ._|_ ` { ( X .+ Y ) } ) )
        $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 24-Feb-2015.) $)
    lcfrlem22 $p |- ( ph -> B e. A ) $=
      ( cpr cfv co csn cin lcfrlem21 syl5eqel ) ACLMUHHUILMDUJUKIUIULBUGABDEFGH
      IJKLMNOPQRSTUAUBUCUDUEUFUMUN $.

    ${
      lcfrlem23.s $e |- .(+) = ( LSSum ` U ) $.
      $( Lemma for ~ lcfr .  TODO: this proof was built from other proof pieces
         that may change ` N `` { X , Y } ` into subspace sum and back
         unnecessarily, or similar things.  (Contributed by NM, 1-Mar-2015.) $)
      lcfrlem23 $p |- ( ph
         -> ( ( ._|_ ` { X , Y } ) .(+) B ) = ( ._|_ ` { ( X .+ Y ) } ) ) $=
        ( csn cfv co cin cpr fveq2i cdjh cdih eqid eldifad dihprrn chlt wcel wa
        wss crn clmod dvhlmod lmodvacl syl3anc dochcl syl2anc dochdmm1 dochocsn
        snssd oveq2d prssi lspssv 3eqtrd syl5eq ineq2d csubg wceq lsssssubg syl
        dihjat1 clss lspsncl lsmcl sseldd dochlss lspsntri lsmmod2 lsmpr ineq1d
        lspprcl dochnoncon eqtr3d oveq1d lsm02 eqtrd fveq2d dihsmsnrn lcfrlem22
        syl31anc lsatssv dochocsp dih1dimat dochoc oveq12d dihjat2 3eqtr3d ) AM
        UJIUKZNUJIUKZEULZCJUKZUMZJUKZMNDULZUJZIUKZJUKMNUNZJUKZCEULZXSJUKZAXPXTJ
        AXPXNYAIUKZJUKZXTEULZUMZXNYFUMZXTEULZXTAXOYGXNAXOYEYDUMZJUKZYGCYKJUHUOA
        YLYFYDJUKZLHUPUKUKZULYFXTYNULYGAFGLHUQUKUKZYNHJKLYEYDPYOURZRSQYNURZUDAF
        GYOHIKLMNPRSUBYPUDAMKOUJZUEUSZANKYRUFUSZUTAHVAVBLGVBVCZXSKVDYDYOVEZVBUD
        AXRKAFVFVBZMKVBZNKVBZXRKVBZAFGHLPRUDVGZYSYTDKFMNSTVHVIZVNZFGYOHJKLXSPYP
        RSQVJVKVLAYMXTYFYNAFGHIJKLXRPRQSUBUDUUHVMVOAEXRFGYOYNHIKLYFPRSUIUBYPYQU
        DAUUAYEKVDZYFUUBVBUDAUUCYAKVDZUUJUUGAUUDUUEUUKYSYTMNKVPVKZYAIKFSUBVQVKZ
        FGYOHJKLYEPYPRSQVJVKUUHWEVRVSVTAXNFWAUKZVBYFUUNVBXTUUNVBZXTXNVDZYHYJWBA
        FWFUKZUUNXNAUUCUUQUUNVDUUGUUQFUUQURZWCWDZAUUCXLUUQVBZXMUUQVBZXNUUQVBUUG
        AUUCUUDUUTUUGYSUUQIKFMSUURUBWGVKAUUCUUEUVAUUGYTUUQIKFNSUURUBWGVKEUUQXLX
        MFUURUIWHVIWIAUUQUUNYFUUSAUUAUUJYFUUQVBUDUUMUUQFGHJKLYEPRSUURQWJVKWIAUU
        QUUNXTUUSAUUCUUFXTUUQVBUUGUUHUUQIKFXRSUURUBWGVKWIZAUUCUUDUUEUUPUUGYSYTD
        EIKFMNSTUBUIWKVIEXNYFXTFUIWLXDAYJYRXTEULZXTAYIYRXTEAYEYFUMZYIYRAYEXNYFA
        EIKFMNSUBUIUUGYSYTWMZWNAUUAYEUUQVBUVDYRWBUDAUUQIKFMNSUURUBUUGYSYTWOUUQF
        GHJLYEOPRUURUAQWPVKWQWRAUUOUVCXTWBUVBEFXTOUAUIWSWDWTVRXAAXQXNJUKZXOJUKZ
        YNULYBCYNULYCAFGYOYNHJKLXNXOPYPRSQYQUDAEFGYOHIKLMNPRSUIUBYPUDYSYTXBAUUA
        CKVDXOUUBVBUDABCKFSUCUUGABCDFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHXCZXEFGYOHJK
        LCPYPRSQVJVKVLAUVFYBUVGCYNAYFUVFYBAYEXNJUVEXAAFGHIJKLYAPRQSUBUDUULXFWQA
        UUACUUBVBZUVGCWBUDAUUACBVBUVIUDUVHBCFGYOHLPRYPUCXGVKGYOHJLCPYPQXHVKXIAB
        ECFGYOYNHLYBPYPYQRUIUCUDAUUAUUKYBUUBVBUDUULFGYOHJKLYAPYPRSQVJVKUVHXJVRA
        FGHIJKLXSPRQSUBUDUUIXFXK $.
    $}

    $d k v w x ._|_ $.  $d k v w x .+ $.  $d k v x R $.  $d k S $.
    $d k v w x .x. $.  $d v x V $.  $d k v w x X $.  $d k v w x Y $.
    $d x .0. $.
    lcfrlem24.t $e |- .x. = ( .s ` U ) $.
    lcfrlem24.s $e |- S = ( Scalar ` U ) $.
    lcfrlem24.q $e |- Q = ( 0g ` S ) $.
    lcfrlem24.r $e |- R = ( Base ` S ) $.
    lcfrlem24.j $e |- J = ( x e. ( V \ { .0. } ) |-> ( v e. V |->
        ( iota_ k e. R E. w e. ( ._|_ ` { x } ) v = ( w .+ ( k .x. x ) ) ) ) )
        $.
    lcfrlem24.ib $e |- ( ph -> I e. B ) $.
    lcfrlem24.l $e |- L = ( LKer ` U ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 24-Feb-2015.) $)
    lcfrlem24 $p |- ( ph
        -> ( ._|_ ` { X , Y } ) = ( ( L ` ( J ` X ) ) i^i ( L ` ( J ` Y ) ) ) )
        $=
      ( cpr cfv csn cin lcfrlem18 wceq clfn crab cld c0g eqid lcfrlem11 ineq12d
      vf cv eqtr4d ) AUCUDVFTVGUCVHTVGZUDVHTVGZVIUCPVGRVGZUDPVGRVGZVIAEGLNQSTUA
      UBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQVJAWDWBWEWCABCDVSVTRVGZTVGTVGWFVKVSLVLVGZ
      VMZLVNVGZGWIVOVGZIJKLVSMWGNPQRTUAUBUCUEUFUGUHUIUJUSUTVBUKWGVPZVEWIVPZWJVP
      ZWHVPZVCUNUOVQABCDWHWIGWJIJKLVSMWGNPQRTUAUBUDUEUFUGUHUIUJUSUTVBUKWKVEWLWM
      WNVCUNUPVQVRWA $.

    lcfrlem25.d $e |- D = ( LDual ` U ) $.
    ${
      $d f L $.  $d f ._|_ $.  $d f .+ $.  $d f R $.  $d f .x. $.  $d f U $.
      $d f V $.  $d f k v w x $.
      lcfrlem25.jz $e |- ( ph -> ( ( J ` Y ) ` I ) = Q ) $.
      lcfrlem25.in $e |- ( ph -> I =/= .0. ) $.
      $( Lemma for ~ lcfr .  Special case of ~ lcfrlem35 when
         ` ( ( J `` Y ) `` I ) ` is zero.  (Contributed by NM, 11-Mar-2015.) $)
      lcfrlem25 $p |- ( ph
         -> ( ._|_ ` { ( X .+ Y ) } ) = ( L ` ( J ` Y ) ) ) $=
        ( vf co csn cfv wss wceq cpr clsm eqid lcfrlem23 cin lcfrlem24 syl6eqss
        inss2 dvhlvec lcfrlem22 lsatel clss dvhlmod clmod wcel clfn cv crab c0g
        lcfrlem10 lkrlss syl2anc lsatssv sseldd ellkr2 mpbird lspsnel5a eqsstrd
        csubg wa wb lsssssubg syl eldifad prssi dochlss lspprcl lcfrlem17 snssd
        chlt lssincl syl3anc syl5eqel mpbi2and eqsstr3d clsh dochsnshp wne cdif
        lsmlub lcfrlem13 eldifsni lduallkr3 lshpcmp mpbid ) AUDUEHVKZVLZUAVMZUE
        QVMZSVMZVNYMYOVOAYMUDUEVPZUAVMZFMVQVMZVKZYOAEFHYRMORTUAUBUCUDUEUFUGUHUI
        UJUKULUMUNUOUPUQURUSYRVRZVSAYQYOVNZFYOVNZYSYOVNZAYQUDQVMSVMZYOVTYOABCDE
        FHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFWAUUD
        YOWCWBAFPVLTVMYOAEFTMPUFULUMUNAMORUCUGUIUOWDZAEFHMORTUAUBUCUDUEUFUGUHUI
        UJUKULUMUNUOUPUQURUSWEZVEVIWFAMWGVMZYOTMPUUGVRZUMAMORUCUGUIUOWHZAMWIWJZ
        YNMWKVMZWJYOUUGWJUUIABCDVJWLSVMZUAVMUAVMUULVOVJUUKWMZGHGWNVMZJKLMVJNUUK
        OQRSUAUBUCUEUFUGUHUIUJUKUTVAVCULUUKVRZVFVGUUNVRZUUMVRZVDUOUQWOZUUGUUKYN
        SMUUOVFUUHWPWQZAPYOWJPYNVMIVOVHAKUUKYNSUBMPWIIUJVAVBUUOVFUUIUURAFUBPAEF
        UBMUJUNUUIUUFWRVEWSWTXAXBXCAYQMXDVMZWJFUUTWJYOUUTWJUUAUUBXEUUCXFAUUGUUT
        YQAUUJUUGUUTVNUUIUUGMUUHXGXHZARXOWJUCOWJXEZYPUBVNZYQUUGWJUOAUDUBWJUEUBW
        JUVCAUDUBUFVLZUPXIZAUEUBUVDUQXIZUDUEUBXJWQUUGMORUAUBUCYPUGUIUJUUHUHXKWQ
        WSAUUGUUTFUVAAFYPTVMZYMVTZUUGUSAUUJUVGUUGWJYMUUGWJZUVHUUGWJUUIAUUGTUBMU
        DUEUJUUHUMUUIUVEUVFXLAUVBYLUBVNUVIUOAYKUBAYKUBUVDAEHMORTUAUBUCUDUEUFUGU
        HUIUJUKULUMUNUOUPUQURXMZXIXNUUGMORUAUBUCYLUGUIUJUUHUHXKWQUUGUVGYMMUUHXP
        XQXRWSAUUGUUTYOUVAUUSWSYRYQFYOMYTYEXQXSXTAYMYOMYAVMZMUVKVRZUUEAMORUAUBU
        CYKUVKUFUGUHUIUJULUVLUOUVJYBAYOUVKWJYNUUNYCZAYNUUMUUNVLYDWJUVMABCDUUMGH
        UUNJKLMVJNUUKOQRSUAUBUCUEUFUGUHUIUJUKUTVAVCULUUOVFVGUUPUUQVDUOUQYFYNUUM
        UUNYGXHAGUUKYNUVKSMUUNUVLUUOVFVGUUPUUEUURYHXAYIYJ $.

      $( Lemma for ~ lcfr .  Special case of ~ lcfrlem36 when
         ` ( ( J `` Y ) `` I ) ` is zero.  (Contributed by NM, 11-Mar-2015.) $)
      lcfrlem26 $p |- ( ph
           -> ( X .+ Y ) e. ( ._|_ ` ( L ` ( J ` Y ) ) ) ) $=
        ( vf co cfv wcel csn wss wceq lcfrlem17 eldifad lcfrlem25 fveq2d eqtr3d
        dochocsn eqimss clss eqid dvhlmod chlt wa clfn cv crab lcfrlem10 lkrssv
        syl c0g dochlss syl2anc lspsnel5 mpbird ) AUDUEHVKZUEQVLZSVLZUAVLZVMWTV
        NZTVLZXCVOZAXEXCVPXFAXDUAVLZUAVLXEXCAMORTUAUBUCWTUGUIUHUJUMUOAWTUBUFVNA
        EHMORTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURVQVRZWBAXGXBUAABCDEFGHIJKLMNO
        PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVSVTWAXE
        XCWCWNAMWDVLZXCTUBMWTUJXIWEZUMAMORUCUGUIUOWFZARWGVMUCOVMWHXBUBVOXCXIVMU
        OAMWIVLZXASUBMUJXLWEZVFXKABCDVJWJSVLZUAVLUAVLXNVPVJXLWKZGHGWOVLZJKLMVJN
        XLOQRSUAUBUCUEUFUGUHUIUJUKUTVAVCULXMVFVGXPWEXOWEVDUOUQWLWMXIMORUAUBUCXB
        UGUIUJXJUHWPWQXHWRWS $.

      $d g k G $.  $d f g k J $.  $d g k L $.  $d g ._|_ $.  $d g .+ $.
      $d k U $.  $d g V $.  $d g X $.  $d f g Y $.  $d g k ph $.  $d g v w x $.
      lcfrlem27.g $e |- ( ph -> G e. ( LSubSp ` D ) ) $.
      lcfrlem27.gs $e |- ( ph
       -> G C_ { f e. ( LFnl ` U ) | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f
          ) } ) $.
      lcfrlem27.e $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
      lcfrlem27.xe $e |- ( ph -> X e. E ) $.
      lcfrlem27.ye $e |- ( ph -> Y e. E ) $.
      $( Lemma for ~ lcfr .  Special case of ~ lcfrlem37 when
         ` ( ( J `` Y ) `` I ) ` is zero.  (Contributed by NM, 11-Mar-2015.) $)
      lcfrlem27 $p |- ( ph -> ( X .+ Y ) e. E ) $=
        ( cfv ciun wcel wrex wceq clfn crab clss c0g eqid wne csn cdif eldifsni
        co syl eldifsn sylanbrc lcfrlem16 lcfrlem26 fveq2 fveq2d eleq2d syl2anc
        cv rspcev eliun sylibr syl6eleqr ) AUHUIHWMZOROXCZUCVSZUEVSZVTZQAXHXKWA
        ZORWBZXHXLWAAUIUAVSZRWAXHXOUCVSZUEVSZWAZXNABCDNXCUCVSZUEVSUEVSXSWCNMWDV
        SZWEZGGWFVSZHGWGVSZJKLMNOPQXTRSUAUBUCUEUFUGUIUJUKULUMUNUOVDVEVGUPXTWHVJ
        VKYCWHYAWHVHUSYBWHVNVOVPAUIQWAUIUJWIZUIQUJWJZWKWAVRAUIUFYEWKWAYDVAUIUFU
        JWLWNUIQUJWOWPWQABCDEFGHIJKLMPSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSU
        TVAVBVCVDVEVFVGVHVIVJVKVLVMWRXMXROXORXIXOWCZXKXQXHYFXJXPUEXIXOUCWSWTXAX
        DXBOXHRXKXEXFVPXG $.
    $}

    lcfrlem28.jn $e |- ( ph -> ( ( J ` Y ) ` I ) =/= Q ) $.
    $( Lemma for ~ lcfr .  TODO:  This can be a hypothesis since the zero
       version of ` ( J `` Y ) `` I ` needs it.  (Contributed by NM,
       9-Mar-2015.) $)
    lcfrlem28 $p |- ( ph -> I =/= .0. ) $=
      ( vf cfv wne wceq clmod wcel clfn dvhlmod cv crab c0g eqid lcfrlem10 lfl0
      syl2anc fveq2 eqeq1d syl5ibrcom necon3d mpd ) APUEQVJZVJZIVKPUFVKVHAPUFWJ
      IAWJIVLPUFVLZUFWIVJZIVLZAMVMVNWIMVOVJZVNWMAMORUCUGUIUOVPABCDVIVQSVJZUAVJU
      AVJWOVLVIWNVRZGHGVSVJZJKLMVINWNOQRSUAUBUCUEUFUGUHUIUJUKUTVAVCULWNVTZVFVGW
      QVTWPVTVDUOUQWAKWNWIMIUFVAVBULWRWBWCWKWJWLIPUFWIWDWEWFWGWH $.

    lcfrlem29.i $e |- F = ( invr ` S ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 9-Mar-2015.) $)
    lcfrlem29 $p |- ( ph
        -> ( ( F ` ( ( J ` Y ) ` I ) ) ( .r ` S ) ( ( J ` X ) ` I ) ) e. R ) $=
      ( vf crg wcel cfv cmulr co clmod dvhlmod lmodrng syl cdr dvhlvec lvecdrng
      wne clvec clfn cv wceq crab eqid lcfrlem10 clss lcfrlem22 lsatlssel lssel
      c0g syl2anc lflcl syl3anc drnginvrcl rngcl ) AKVLVMZQUFRVNZVNZOVNZJVMZQUE
      RVNZVNZJVMZXEXHKVOVNZVPJVMAMVQVMZXBAMPSUDUHUJUPVRZKMVBVSVTAKWAVMZXDJVMZXD
      IWDXFAMWEVMXMAMPSUDUHUJUPWBKMVBWCVTAXKXCMWFVNZVMQUCVMZXNXLABCDVKWGTVNZUBV
      NUBVNXQWHVKXOWIZGHGWPVNZJKLMVKNXOPRSTUBUCUDUFUGUHUIUJUKULVAVBVDUMXOWJZVGV
      HXSWJZXRWJZVEUPURWKAFMWLVNZVMQFVMXPAEYCFMYCWJZUOXLAEFHMPSUAUBUCUDUEUFUGUH
      UIUJUKULUMUNUOUPUQURUSUTWMWNVFYCFUCMQUKYDWOWQZKXOXCJUCMQVQVBVDUKXTWRWSVIJ
      KOXDIVDVCVJWTWSAXKXGXOVMXPXIXLABCDXRGHXSJKLMVKNXOPRSTUBUCUDUEUGUHUIUJUKUL
      VAVBVDUMXTVGVHYAYBVEUPUQWKYEKXOXGJUCMQVQVBVDUKXTWRWSJKXJXEXHVDXJWJXAWS $.

    lcfrlem30.m $e |- .- = ( -g ` D ) $.
    lcfrlem30.c $e |- C = ( ( J ` X ) .- ( ( ( F ` ( ( J ` Y ) ` I ) )
            ( .r ` S ) ( ( J ` X ) ` I ) ) ( .s ` D ) ( J ` Y ) ) ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 6-Mar-2015.) $)
    lcfrlem30 $p |- ( ph -> C e. ( LFnl ` U ) ) $=
      ( vf cfv cmulr co cvsca clfn eqid dvhlmod cv wceq c0g lcfrlem10 lcfrlem29
      crab ldualvscl ldualvsubcl syl5eqel ) AGUGSVPZRUHSVPZVPPVPRWLVPLVQVPVRZWM
      HVSVPZVRZUBVRNVTVPZVNAHWQWLWPUBNWQWAZVJVMANQTUFUJULURWBZABCDVOWCUAVPZUDVP
      UDVPWTWDVOWQWHZHIHWEVPZKLMNVOOWQQSTUAUDUEUFUGUIUJUKULUMUNVCVDVFUOWRVIVJXB
      WAZXAWAZVGURUSWFAHLWOWQWMKNWNWRVDVFVJWOWAWSABCDEFHIJKLMNOPQRSTUAUCUDUEUFU
      GUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLWGABCDXAHIXBKLMNVOOWQQ
      STUAUDUEUFUHUIUJUKULUMUNVCVDVFUOWRVIVJXCXDVGURUTWFWIWJWK $.

    $d f J $.  $d f L $.  $d f ._|_ $.  $d f .+ $.  $d f R $.  $d f .x. $.
    $d f U $.  $d f V $.  $d f X $.  $d f Y $.  $d k v w x f $.
    ${
      lcfrlem31.xi $e |- ( ph -> ( ( J ` X ) ` I ) =/= Q ) $.
      ${
        lcfrlem31.cn $e |- ( ph -> C = ( 0g ` D ) ) $.
        $( Lemma for ~ lcfr .  (Contributed by NM, 10-Mar-2015.) $)
        lcfrlem31 $p |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $=
          ( vf cfv csn cmulr co cvsca c0g wceq syl5eqr clmod wcel cbs lduallmod
          wb dvhlmod clfn eqid crab lcfrlem10 ldualelvbase lcfrlem29 lmodsubeq0
          cv ldualvscl syl3anc mpbid fveq2d dvhlvec wne cdr clvec syl lcfrlem22
          lvecdrng lsatssv drnginvrn0 drnginvrcl drngmulne0 mpbir2and ldualkrsc
          sseldd lflcl eqtrd lcfrlem14 3eqtr3d ) AUGSVRZUAVRZUDVRUHSVRZUAVRZUDV
          RUGVSUCVRUHVSUCVRAYCYEUDAYCRYDVRZPVRZRYBVRZLVTVRZWAZYDHWBVRZWAZUAVRYE
          AYBYLUAAYBYLUBWAZHWCVRZWDZYBYLWDZAYMGYNVNVPWEAHWFWGYBHWHVRZWGYLYQWGYO
          YPWJAHNVJANQTUFUJULURWKZWIAHNWLVRZYBYQNWFYSWMZVJYQWMZYRABCDVQWSUAVRZU
          DVRUDVRUUBWDVQYSWNZHIYNKLMNVQOYSQSTUAUDUEUFUGUIUJUKULUMUNVCVDVFUOYTVI
          VJYNWMZUUCWMZVGURUSWOZWPAHYSYLYQNWFYTVJUUAYRAHLYKYSYDKNYJYTVDVFVJYKWM
          ZYRABCDEFHIJKLMNOPQRSTUAUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDV
          EVFVGVHVIVJVKVLWQZABCDUUCHIYNKLMNVQOYSQSTUAUDUEUFUHUIUJUKULUMUNVCVDVF
          UOYTVIVJUUDUUEVGURUTWOZWTWPYBYLUBYQHYNUUAUUDVMWRXAXBXCAHLYKYSYDKUANYJ
          JVDVFVEYTVIVJUUGANQTUFUJULURXDZUUIUUHAYJJXEYGJXEZYHJXEALXFWGZYFKWGZYF
          JXEZUUKANXGWGUULUUJLNVDXJXHZANWFWGZYDYSWGRUEWGZUUMYRUUIAFUERAEFUENUMU
          QYRAEFINQTUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBXIXKVHXQZLYSYDKUENR
          WFVDVFUMYTXRXAZVKKLPYFJVFVEVLXLXAVOAKLYIYGYHJVFVEYIWMUUOAUULUUMUUNYGK
          WGUUOUUSVKKLPYFJVFVEVLXMXAAUUPYBYSWGUUQYHKWGYRUUFUURLYSYBKUENRWFVDVFU
          MYTXRXAXNXOXPXSXCABCDUUCHIYNKLMNVQOYSQSTUAUCUDUEUFUGUIUJUKULUMUNVCVDV
          FUOYTVIVJUUDUUEVGURUSUPXTABCDUUCHIYNKLMNVQOYSQSTUAUCUDUEUFUHUIUJUKULU
          MUNVCVDVFUOYTVIVJUUDUUEVGURUTUPXTYA $.
      $}

      $( Lemma for ~ lcfr .  (Contributed by NM, 10-Mar-2015.) $)
      lcfrlem32 $p |- ( ph -> C =/= ( 0g ` D ) ) $=
        ( csn cfv wne c0g wceq wa chlt wcel adantr cdif simpr lcfrlem31 necon3d
        ex mpd ) AUGVPUCVQZUHVPUCVQZVRZGHVSVQZVRVAAGWNWKWLAGWNVTZWKWLVTAWOWABCD
        EFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQATWBWCUFQWCWAWOURWDAU
        GUEUIVPWEZWCWOUSWDAUHWPWCWOUTWDAWMWOVAWDVBVCVDVEVFVGARFWCWOVHWDVIVJARUH
        SVQVQJVRWOVKWDVLVMVNARUGSVQVQJVRWOVOWDAWOWFWGWIWHWJ $.
    $}

    ${
      lcfrlem33.xi $e |- ( ph -> ( ( J ` X ) ` I ) = Q ) $.
      $( Lemma for ~ lcfr .  (Contributed by NM, 10-Mar-2015.) $)
      lcfrlem33 $p |- ( ph -> C =/= ( 0g ` D ) ) $=
        ( vf cfv c0g cmulr cvsca oveq2d crg wcel wceq clmod dvhlmod lmodrng syl
        co cdr wne clvec dvhlvec lvecdrng clfn cv crab eqid lcfrlem10 lcfrlem22
        lsatssv sseldd lflcl syl3anc drnginvrcl rngrz syl2anc eqtrd oveq1d cgrp
        ldual0vs ldualgrp ldualelvbase grpsubid1 syl5eq cdif lcfrlem13 eldifsni
        cbs csn eqnetrd ) AGUGSVQZHVRVQZAGYBRUHSVQZVQZPVQZRYBVQZLVSVQZWIZYDHVTV
        QZWIZUBWIZYBVNAYLYBYCUBWIZYBAYKYCYBUBAYKJYDYJWIYCAYIJYDYJAYIYFJYHWIZJAY
        GJYFYHVOWAALWBWCZYFKWCZYNJWDANWEWCZYOANQTUFUJULURWFZLNVDWGWHALWJWCZYEKW
        CZYEJWKYPANWLWCYSANQTUFUJULURWMLNVDWNWHAYQYDNWOVQZWCRUEWCYTYRABCDVPWPUA
        VQZUDVQUDVQUUBWDVPUUAWQZHIYCKLMNVPOUUAQSTUAUDUEUFUHUIUJUKULUMUNVCVDVFUO
        UUAWRZVIVJYCWRZUUCWRZVGURUTWSZAFUERAEFUENUMUQYRAEFINQTUCUDUEUFUGUHUIUJU
        KULUMUNUOUPUQURUSUTVAVBWTXAVHXBLUUAYDKUENRWEVDVFUMUUDXCXDVKKLPYEJVFVEVL
        XEXDKLYHYFJVFYHWRVEXFXGXHXIAHLYJUUAYDYCNJUUDVDVEVJYJWRUUEYRUUGXKXHWAAHX
        JWCYBHXSVQZWCYMYBWDAHNVJYRXLAHUUAYBUUHNWEUUDVJUUHWRZYRABCDUUCHIYCKLMNVP
        OUUAQSTUAUDUEUFUGUIUJUKULUMUNVCVDVFUOUUDVIVJUUEUUFVGURUSWSXMUUHHUBYBYCU
        UIUUEVMXNXGXHXOAYBUUCYCXTXPWCYBYCWKABCDUUCHIYCKLMNVPOUUAQSTUAUDUEUFUGUI
        UJUKULUMUNVCVDVFUOUUDVIVJUUEUUFVGURUSXQYBUUCYCXRWHYA $.
    $}

    $( Lemma for ~ lcfr .  (Contributed by NM, 10-Mar-2015.) $)
    lcfrlem34 $p |- ( ph -> C =/= ( 0g ` D ) ) $=
      ( c0g cfv wne wceq wa chlt wcel adantr csn cdif simpr lcfrlem33 lcfrlem32
      pm2.61dane ) AGHVOVPVQRUGSVPVPZJAWIJVRZVSBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFU
      GUHUIUJUKULUMUNUOUPUQATVTWAUFQWAVSZWJURWBAUGUEUIWCWDZWAZWJUSWBAUHWLWAZWJU
      TWBAUGWCUCVPUHWCUCVPVQZWJVAWBVBVCVDVEVFVGARFWAZWJVHWBVIVJARUHSVPVPJVQZWJV
      KWBVLVMVNAWJWEWFAWIJVQZVSBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNU
      OUPUQAWKWRURWBAWMWRUSWBAWNWRUTWBAWOWRVAWBVBVCVDVEVFVGAWPWRVHWBVIVJAWQWRVK
      WBVLVMVNAWRWEWGWH $.

    $( Lemma for ~ lcfr .  (Contributed by NM, 2-Mar-2015.) $)
    lcfrlem35 $p |- ( ph
         -> ( ._|_ ` { ( X .+ Y ) } ) = ( L ` C ) ) $=
      ( vf co csn cfv wss wceq cpr clsm eqid lcfrlem23 cin lcfrlem24 cvsca clfn
      cmulr dvhlvec cv crab c0g lcfrlem10 clss wcel dvhlmod lcfrlem22 lsatlssel
      lssel syl2anc lcfrlem2 eqsstrd lcfrlem28 lsatel lcfrlem30 lkrlss lcfrlem3
      clmod lspsnel5a csubg wa lsssssubg syl chlt eldifad dochlss sseldd lsmlub
      wb prssi syl3anc mpbi2and eqsstr3d clsh lcfrlem17 dochsnshp wne lcfrlem34
      lduallkr3 mpbird lshpcmp mpbid ) AUGUHIVPZVQUDVRZGUAVRZVSYOYPVTAYOUGUHWAZ
      UDVRZFNWBVRZVPZYPAEFIYSNQTUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBYSWCZWD
      AYRYPVSZFYPVSZYTYPVSZAYRUGSVRZUAVRUHSVRZUAVRWEYPABCDEFIJKLMNOQRSTUAUCUDUE
      UFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIWFAHLHWGVRZLWIVRZNUUENWHV
      RZUUFGPUAUBUERJUMVDUUHWCZVEVLUUIWCZVJUUGWCZVMANQTUFUJULURWJZABCDVOWKUAVRZ
      UDVRUDVRUUNVTVOUUIWLZHIHWMVRZKLMNVOOUUIQSTUAUDUEUFUGUIUJUKULUMUNVCVDVFUOU
      UKVIVJUUPWCZUUOWCZVGURUSWNZABCDUUOHIUUPKLMNVOOUUIQSTUAUDUEUFUHUIUJUKULUMU
      NVCVDVFUOUUKVIVJUUQUURVGURUTWNZAFNWOVRZWPRFWPRUEWPAEUVAFNUVAWCZUQANQTUFUJ
      ULURWQZAEFINQTUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBWRZWSZVHUVAFUENRUMU
      VBWTXAZVKVNVIXBXCAFRVQUCVRYPAEFUCNRUIUOUPUQUUMUVDVHABCDEFHIJKLMNOQRSTUAUC
      UDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKXDXEAUVAYPUCNRUVB
      UPUVCANXIWPZGUUIWPYPUVAWPUVCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULU
      MUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNXFZUVAUUIGUANUUKVIUVBXGXAZAHLU
      UGUUHNUUEUUIUUFGPUAUBUERJUMVDUUJVEVLUUKVJUULVMUUMUUSUUTUVFVKVNVIXHXJXCAYR
      NXKVRZWPFUVJWPYPUVJWPUUBUUCXLUUDXTAUVAUVJYRAUVGUVAUVJVSUVCUVANUVBXMXNZATX
      OWPUFQWPXLYQUEVSZYRUVAWPURAUGUEWPUHUEWPUVLAUGUEUIVQZUSXPAUHUEUVMUTXPUGUHU
      EYAXAUVANQTUDUEUFYQUJULUMUVBUKXQXAXRAUVAUVJFUVKUVEXRAUVAUVJYPUVKUVIXRYSYR
      FYPNUUAXSYBYCYDAYOYPNYEVRZNUVNWCZUUMANQTUDUEUFYNUVNUIUJUKULUMUOUVOURAEINQ
      TUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAYFYGAYPUVNWPGUUPYHABCDEFGHIJKLMNOP
      QRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNY
      IAHUUIGUVNUANUUPUVOUUKVIVJUUQUUMUVHYJYKYLYM $.

    $( Lemma for ~ lcfr .  (Contributed by NM, 6-Mar-2015.) $)
    lcfrlem36 $p |- ( ph
           -> ( X .+ Y ) e. ( ._|_ ` ( L ` C ) ) ) $=
      ( co cfv wcel csn wceq lcfrlem17 eldifad dochocsn lcfrlem35 fveq2d eqtr3d
      wss eqimss syl clss eqid dvhlmod chlt wa lcfrlem30 lkrssv dochlss syl2anc
      clfn lspsnel5 mpbird ) AUGUHIVOZGUAVPZUDVPZVQXAVRZUCVPZXCWFZAXEXCVSXFAXDU
      DVPZUDVPXEXCANQTUCUDUEUFXAUJULUKUMUPURAXAUEUIVRAEINQTUCUDUEUFUGUHUIUJUKUL
      UMUNUOUPUQURUSUTVAVTWAZWBAXGXBUDABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
      KULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNWCWDWEXEXCWGWHANWIVPZXCUCU
      ENXAUMXIWJZUPANQTUFUJULURWKZATWLVQUFQVQWMXBUEWFXCXIVQURANWRVPZGUAUENUMXLW
      JVIXKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVD
      VEVFVGVHVIVJVKVLVMVNWNWOXINQTUDUEUFXBUJULUMXJUKWPWQXHWSWT $.

    $d g k C $.  $d g k D $.  $d g k G $.  $d g k I $.  $d f g k J $.
    $d f g k L $.  $d f g ._|_ $.  $d f g .+ $.  $d g k Q $.  $d f R $.
    $d f .x. $.  $d f k U $.  $d f g V $.  $d f g X $.  $d f g Y $.  $d g ph $.
    $d k ph $.  $d f g v w x $.
    lcfrlem37.g $e |- ( ph -> G e. ( LSubSp ` D ) ) $.
    lcfrlem37.gs $e |- ( ph
     -> G C_ { f e. ( LFnl ` U ) | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f )
        } ) $.
    lcfrlem37.e $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
    lcfrlem37.xe $e |- ( ph -> X e. E ) $.
    lcfrlem37.ye $e |- ( ph -> Y e. E ) $.
    $( Lemma for ~ lcfr .  (Contributed by NM, 8-Mar-2015.) $)
    lcfrlem37 $p |- ( ph -> ( X .+ Y ) e. E ) $=
      ( co cv cfv ciun wcel wrex cmulr clss eqid dvhlmod wceq clfn crab c0g wne
      cvsca csn eldifsni syl eldifsn sylanbrc lcfrlem16 lcfrlem29 ldualssvsubcl
      cdif ldualssvscl syl5eqel fveq2 fveq2d eleq2d rspcev syl2anc eliun sylibr
      lcfrlem36 syl6eleqr ) AUKULIWDZPTPWEZUEWFZUHWFZWGZRAXTYCWHZPTWIZXTYDWHAGT
      WHXTGUEWFZUHWFZWHZYFAGUKUCWFZUBULUCWFZWFSWFUBYJWFLWJWFWDZYKHWSWFZWDZUFWDT
      VRAHHWKWFZTUFNYJYNVNVQYOWLZANUAUDUJUNUPVBWMZVSABCDOWEUEWFZUHWFUHWFYRWNONW
      OWFZWPZHYOIHWQWFZKLMNOPQRYSTUAUCUDUEUHUIUJUKUMUNUOUPUQURVGVHVJUSYSWLZVMVN
      UUAWLZYTWLZVKVBYPVSVTWAAUKRWHUKUMWRZUKRUMWTZXHZWHWBAUKUIUUFXHZWHUUEVCUKUI
      UMXAXBUKRUMXCXDXEAHLYOYMTKNYLYKVHVJVNYMWLYPYQVSABCDEFHIJKLMNQSUAUBUCUDUEU
      GUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOVPXFABCDYTHYOIUU
      AKLMNOPQRYSTUAUCUDUEUHUIUJULUMUNUOUPUQURVGVHVJUSUUBVMVNUUCUUDVKVBYPVSVTWA
      AULRWHULUMWRZULUUGWHWCAULUUHWHUUIVDULUIUMXAXBULRUMXCXDXEXIXGXJABCDEFGHIJK
      LMNQSUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVN
      VOVPVQVRXRYEYIPGTYAGWNZYCYHXTUUJYBYGUHYAGUEXKXLXMXNXOPXTTYCXPXQWAXS $.
  $}

  ${
    $d g k D $.  $d g k G $.  $d g k I $.  $d f g k J $.  $d f g k L $.
    $d f g j k v w x ._|_ $.  $d f g j k v w x .+ $.  $d f k v x R $.
    $d g k S $.  $d f k v w x .x. $.  $d f g j k v w x U $.  $d f g v x V $.
    $d f g k v w x X $.  $d f g k v w x Y $.  $d f g k x .0. $.  $d g k ph $.
    lcfrlem38.h $e |- H = ( LHyp ` K ) $.
    lcfrlem38.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfrlem38.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfrlem38.p $e |- .+ = ( +g ` U ) $.
    lcfrlem38.f $e |- F = ( LFnl ` U ) $.
    lcfrlem38.l $e |- L = ( LKer ` U ) $.
    lcfrlem38.d $e |- D = ( LDual ` U ) $.
    lcfrlem38.q $e |- Q = ( LSubSp ` D ) $.
    lcfrlem38.c $e |- C = { f e. ( LFnl ` U ) | ( ._|_ ` ( ._|_ ` ( L `
             f ) ) ) = ( L ` f ) } $.
    lcfrlem38.e $e |- E = U_ g e. G ( ._|_ ` ( L ` g ) ) $.
    lcfrlem38.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfrlem38.g $e |- ( ph -> G e. Q ) $.
    lcfrlem38.gs $e |- ( ph -> G C_ C ) $.
    lcfrlem38.xe $e |- ( ph -> X e. E ) $.
    lcfrlem38.ye $e |- ( ph -> Y e. E ) $.
    ${
      lcfrlem38.z $e |- .0. = ( 0g ` U ) $.
      lcfrlem38.x $e |- ( ph -> X =/= .0. ) $.
      lcfrlem38.y $e |- ( ph -> Y =/= .0. ) $.
      ${
        lcfrlem38.sp $e |- N = ( LSpan ` U ) $.
        lcfrlem38.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
        ${
          lcfrlem38.b $e |- B
                   = ( ( N ` { X , Y } ) i^i ( ._|_ ` { ( X .+ Y ) } ) ) $.
          lcfrlem38.i $e |- ( ph -> I e. B ) $.
          lcfrlem38.n $e |- ( ph -> I =/= .0. ) $.
          ${
            lcfrlem38.v $e |- V = ( Base ` U ) $.
            lcfrlem38.t $e |- .x. = ( .s ` U ) $.
            lcfrlem38.s $e |- S = ( Scalar ` U ) $.
            lcfrlem38.r $e |- R = ( Base ` S ) $.
            lcfrlem38.j $e |- J = ( x e. ( V \ { .0. } ) |-> ( v e. V |->
       ( iota_ k e. R E. w e. ( ._|_ ` { x } ) v = ( w .+ ( k .x. x ) ) ) ) )
                $.
            $( Lemma for ~ lcfr .  Combine ~ lcfrlem27 and ~ lcfrlem37 .
               (Contributed by NM, 11-Mar-2015.) $)
            lcfrlem38 $p |- ( ph -> ( X .+ Y ) e. E ) $=
              ( co wcel cfv c0g wceq wa clsa eqid chlt adantr csn cdif lcfrlem4
              eldifsn sylanbrc simpr clss syl6eleq clfn crab syl6sseq lcfrlem27
              wne cv wss cinvr cmulr cvsca csg lcfrlem37 pm2.61dane ) AUIUJHVTQ
              WAUAUJUBWBZWBZKWCWBZAXLXMWDZWEBCDMWFWBZEGHXMJKLMNOPQSTUAUBUCUDUEU
              FUGUHUIUJUKULUMUNVOUOVGVJXOWGZAUCWHWAUHTWAWEZXNVBWIAUIUGUKWJWKZWA
              ZXNAUIUGWAUIUKXBXSAGIMOQSTUCUDUFUGUHUIULUMUNVOUQURUSVAVBVCVEWLVHU
              IUGUKWMWNZWIAUJXRWAZXNAUJUGWAUJUKXBYAAGIMOQSTUCUDUFUGUHUJULUMUNVO
              UQURUSVAVBVCVFWLVIUJUGUKWMWNZWIAUIWJUEWBUJWJUEWBXBZXNVKWIVLVPVQXM
              WGZVRVSAUAEWAZXNVMWIUQURAXNWOAUAUKXBXNVNWIASGWPWBZWAZXNASIYFVCUSW
              QZWIASNXCUDWBZUFWBUFWBYIWDNMWRWBWSZXDZXNASFYJVDUTWTZWIVAAUIQWAZXN
              VEWIAUJQWAZXNVFWIXAAXLXMXBZWEBCDXOEUIUBWBZXLKXEWBZWBUAYPWBKXFWBVT
              XKGXGWBVTGXHWBZVTZGHXMJKLMNOPQYQSTUAUBUCUDYRUEUFUGUHUIUJUKULUMUNV
              OUOVGVJXPAXQYOVBWIAXSYOXTWIAYAYOYBWIAYCYOVKWIVLVPVQYDVRVSAYEYOVMW
              IUQURAYOWOYQWGYRWGYSWGAYGYOYHWIAYKYOYLWIVAAYMYOVEWIAYNYOVFWIXIXJ
              $.
          $}

          $( Lemma for ~ lcfr .  Eliminate ` J ` .  (Contributed by NM,
             11-Mar-2015.) $)
          lcfrlem39 $p |- ( ph -> ( X .+ Y ) e. E ) $=
            ( vx vw vv vk vj csca cfv cbs cvsca csn cdif cv wceq wrex crio cmpt
            co eqid weq oveq1 oveq2d eqeq2d rexbidv cbvriotav mpteq2i lcfrlem38
            ) AVFVGVHBCDEFGVKVLZVMVLZWLGVNVLZGHIVIJKLMNVFGVMVLZUBVOVPZVHWOVHVQZ
            VGVQZVJVQZVFVQZWNWBZEWBZVRZVGWTVORVLZVSZVJWMVTZWAZWAOPQRWOSTUAUBUCU
            DUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEWOWCWNWCWLWCWMWCVFWPXGVH
            WOWQWRVIVQZWTWNWBZEWBZVRZVGXDVSZVIWMVTZWAVHWOXFXMXEXLVJVIWMVJVIWDZX
            CXKVGXDXNXBXJWQXNXAXIWREWSXHWTWNWEWFWGWHWIWJWJWK $.
        $}

        $d i E $.  $d g i N $.  $d i ._|_ $.  $d i .+ $.  $d i U $.  $d i X $.
        $d i Y $.  $d i .0. $.  $d i ph $.
        $( Lemma for ~ lcfr .  Eliminate ` B ` and ` I ` .  (Contributed by NM,
           11-Mar-2015.) $)
        lcfrlem40 $p |- ( ph -> ( X .+ Y ) e. E ) $=
          ( vi cv wne cpr cfv csn cin wrex wcel clsa eqid dvhlmod cdif lcfrlem4
          co cbs eldifsn sylanbrc lcfrlem21 lsateln0 w3a chlt wa 3ad2ant1 simp2
          wss simp3 lcfrlem39 rexlimdv3a mpd ) AVAVBZTVCZVARSVDOVERSDVOZVFPVEVG
          ZVHWMIVIZAVAFVJVEZWNFTUPWPVKZAFLMQUAUCUKVLAWPDFLMOPFVPVEZQRSTUAUBUCWR
          VKZUDUPUSWQUKARWRVIRTVCZRWRTVFVMZVIACEFHIKLMNPWRQRUAUBUCWSUFUGUHUJUKU
          LUNVNUQRWRTVQVRASWRVISTVCZSXAVIACEFHIKLMNPWRQSUAUBUCWSUFUGUHUJUKULUOV
          NURSWRTVQVRUTVSVTAWLWOVAWNAWKWNVIZWLWAWNBCDEFGHIJKLWKMNOPQRSTUAUBUCUD
          UEUFUGUHUIUJAXCMWBVIQLVIWCWLUKWDAXCKEVIWLULWDAXCKBWFWLUMWDAXCRIVIWLUN
          WDAXCSIVIWLUOWDUPAXCWTWLUQWDAXCXBWLURWDUSAXCRVFOVESVFOVEVCWLUTWDWNVKA
          XCWLWEAXCWLWGWHWIWJ $.
      $}

      $( Lemma for ~ lcfr .  Eliminate span condition.  (Contributed by NM,
         11-Mar-2015.) $)
      lcfrlem41 $p |- ( ph -> ( X .+ Y ) e. E ) $=
        ( co wcel csn clspn cfv wceq wa eqid chlt adantr simpr lcfrlem6 wne wss
        lcfrlem40 pm2.61dane ) AQRDURIUSQUTFVAVBZVBZRUTVNVBZAVOVPVCZVDCDEFHIKLM
        NVNOPQRTUAUBUCVNVEZUEUFUGAMVFUSPLUSVDZVQUJVGAKEUSZVQUKVGUIAQIUSZVQUMVGA
        RIUSZVQUNVGAVQVHVIAVOVPVJZVDBCDEFGHIJKLMNVNOPQRSTUAUBUCUDUEUFUGUHUIAVSW
        CUJVGAVTWCUKVGAKBVKWCULVGAWAWCUMVGAWBWCUNVGUOAQSVJWCUPVGARSVJWCUQVGVRAW
        CVHVLVM $.
    $}

    $( Lemma for ~ lcfr .  Eliminate nonzero condition.  (Contributed by NM,
       11-Mar-2015.) $)
    lcfrlem42 $p |- ( ph -> ( X .+ Y ) e. E ) $=
      ( co wcel c0g cfv wceq wa clmod cbs dvhlmod eqid lcfrlem4 lmodcom syl3anc
      adantr simpr lcfrlem7 eqeltrd wne wss simprl simprr lcfrlem41 pm2.61da2ne
      chlt ) AQRDUNZIUOQFUPUQZRVSAQVSURZUSZVRRQDUNZIAVRWBURZVTAFUTUOQFVAUQZUORW
      DUOWCAFLMPSUAUIVBACEFHIKLMNOWDPQSTUAWDVCZUDUEUFUHUIUJULVDACEFHIKLMNOWDPRS
      TUAWEUDUEUFUHUIUJUMVDDWDFQRWEUBVEVFVGWACDEFHIKLMNOPRQVSSTUAUBUDUEUFAMVQUO
      PLUOUSZVTUIVGAKEUOZVTUJVGUHARIUOZVTUMVGVSVCZAVTVHVIVJARVSURZUSCDEFHIKLMNO
      PQRVSSTUAUBUDUEUFAWFWJUIVGAWGWJUJVGUHAQIUOZWJULVGWIAWJVHVIAQVSVKZRVSVKZUS
      ZUSBCDEFGHIJKLMNOPQRVSSTUAUBUCUDUEUFUGUHAWFWNUIVGAWGWNUJVGAKBVLWNUKVGAWKW
      NULVGAWHWNUMVGWIAWLWMVMAWLWMVNVOVP $.
  $}

  ${
    $d h D $.  $d f F $.  $d f g h L $.  $d f g h ._|_ $.  $d a b h x Q $.
    $d g h R $.  $d a b f h x U $.  $d a b h x ph $.
    lcfr.h $e |- H = ( LHyp ` K ) $.
    lcfr.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcfr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcfr.s $e |- S = ( LSubSp ` U ) $.
    lcfr.f $e |- F = ( LFnl ` U ) $.
    lcfr.l $e |- L = ( LKer ` U ) $.
    lcfr.d $e |- D = ( LDual ` U ) $.
    lcfr.t $e |- T = ( LSubSp ` D ) $.
    lcfr.c $e |- C =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcfr.q $e |- Q = U_ g e. R ( ._|_ ` ( L ` g ) ) $.
    lcfr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcfr.r $e |- ( ph -> R e. T ) $.
    lcfr.rs $e |- ( ph -> R C_ C ) $.
    $( Reconstruction of a subspace from a dual subspace of functionals with
       closed kernels.  Our proof was suggested by Mario Carneiro,
       20-Feb-2015.  (Contributed by NM, 5-Mar-2015.) $)
    lcfr $p |- ( ph -> Q e. S ) $=
      ( vx va vb vh cbs cfv wss c0 cv cvsca co cplusg wcel wral csca ciun fveq2
      wne weq fveq2d cbviunv eqtri wa chlt adantr eqid clmod dvhlmod ldualvbase
      lssss syl sseqtrd sselda lkrssv dochssv syl2anc ralrimiva sylibr syl5eqss
      iunss wceq a1i c0g lduallmod lss0cl ldual0vcl dochlss eleq2d rspcev eliun
      wrex ne0i eqnetrd w3a crab clfn rabeq ax-mp simpr2 simpr1 lcfrlem5 simpr3
      lcfrlem42 ralrimivvva islss syl3anbrc ) ADHUNUOZUPDUQVGUJURZUKURZHUSUOZUT
      ZULURZHVAUOZUTDVBZULDVCUKDVCUJHVDUOZUNUOZVCDFVBADUMEUMURZNUOZOUOZVEZXPDJE
      JURZNUOZOUOZVEYIUFJUMEYLYHJUMVHYKYGOYJYFNVFVIVJVKZAYHXPUPZUMEVCYIXPUPAYNU
      MEAYFEVBZVLZMVMVBPLVBVLZYGXPUPYNAYQYOUGVNYPKYFNXPHXPVOZUAUBAHVPVBZYOAHLMP
      QSUGVQZVNAEKYFAECUNUOZKAEGVBZEUUAUPUHGEUUACUUAVOZUDVSVTACKUUAHVPUAUCUUCYT
      VRWAWBWCHLMOXPPYGQSYRRWDWEWFUMEYHXPWIWGWHADYIUQDYIWJAYMWKAHWLUOZYIVBZYIUQ
      VGAUUDYHVBZUMEWTZUUEACWLUOZEVBZUUDUUHNUOZOUOZVBZUUGACVPVBUUBUUIACHUCYTWMU
      HGECUUHUUHVOZUDWNWEAYSUUKFVBZUULYTAYQUUJXPUPUUNUGAKUUHNXPHYRUAUBYTACKHUUH
      UAUCUUMYTWOWCFHLMOXPPUUJQSYRTRWPWEFUUKHUUDUUDVOTWNWEUUFUULUMUUHEYFUUHWJZY
      HUUKUUDUUOYGUUJOYFUUHNVFVIWQWRWEUMUUDEYHWSWGYIUUDXAVTXBAYCUJUKULYEDDAXQYE
      VBZXRDVBZYADVBZXCZVLZBCYBGHIUMDKELMNOPXTYAQRSYBVOZUAUBUCUDBIURNUOZOUOOUOU
      VBWJZIKXDZUVCIHXEUOZXDZUEKUVEWJUVDUVFWJUAUVCIKUVEXFXGVKYMAYQUUSUGVNZAUUBU
      USUHVNZAEBUPUUSUIVNUUTXQYEYDCDEGXSHUMKLMNOXPPXRQRSYRUAUBUCUDUVGUVHYMAUUPU
      UQUURXHYDVOZYEVOZXSVOZAUUPUUQUURXIXJAUUPUUQUURXKXLXMUJYEYBFXSDYDXPHUKULUV
      IUVJYRUVAUVKTXNXO $.
  $}


  $c LCDual $.

  $( Extend class notation with vector space of functionals with closed
     kernels. $)
  clcd $a class LCDual $.

  ${
    $d k w $.
    $( Dual vector space of functionals with closed  kernels.  Note: we
       could also define this directly without ` mapd ` by using
       ~ mapdrn . TODO: see if it makes sense to go back and
       replace  the ` LDual ` stuff with this. $)
  $}

  ${
    $d f k w $.
$(
    df-lcdual $a |- LCDual = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
   ( ( LDual ` ( ( DVecH ` k ) ` w ) ) |`s U. ran ( ( mapd ` k ) ` w ) ) ) ) $.
$)
    $( Dual vector space of functionals with closed kernels.  Note: we could
       also define this directly without ` mapd ` by using ~ mapdrn .  TODO:
       see if it makes sense to go back and replace some of the ` LDual ` stuff
       with this.  TODO:  We could simplify ~ df-mapd using
       ` ( Base `` ( ( LCDual `` K ) `` W ) ) ` .  (Contributed by NM,
       13-Mar-2015.) $)
    df-lcdual $a |- LCDual = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
    ( ( LDual ` ( ( DVecH ` k ) ` w ) )
       |`s { f e. ( LFnl ` ( ( DVecH ` k ) ` w ) )
            | ( ( ( ocH ` k ) ` w ) ` ( ( ( ocH ` k ) ` w )
                   ` ( ( LKer ` ( ( DVecH ` k ) ` w ) ) ` f ) ) )
                = ( ( LKer ` ( ( DVecH ` k ) ` w ) ) ` f ) } ) ) ) $.
  $}

  ${
    $d k w H $.  $d f k w K $.
    lcdval.h $e |- H = ( LHyp ` K ) $.
    $( Dual vector space of functionals with closed kernels.  (Contributed by
       NM, 13-Mar-2015.) $)
    lcdfval $p |- ( K e. X -> ( LCDual ` K ) = ( w e. H |->
   ( ( LDual ` ( ( DVecH ` K ) ` w ) )
      |`s { f e. ( LFnl ` ( ( DVecH ` K ) ` w ) )
            | ( ( ( ocH ` K ) ` w ) ` ( ( ( ocH ` K ) ` w )
                   ` ( ( LKer ` ( ( DVecH ` K ) ` w ) ) ` f ) ) )
                = ( ( LKer ` ( ( DVecH ` K ) ` w ) ) ` f ) } ) ) ) $=
      ( vk cvv cfv cv cdvh cld clk coch wceq clfn cress clh fveq2 fveq1d fveq2d
      wcel clcd crab co cmpt elex syl6eqr fveq12d rabeqbidv mpteq12dv df-lcdual
      eqeq12d oveq12d fvex eqeltri mptex fvmpt syl ) DEUBDHUBDUCIACAJZDKIZIZLIZ
      BJZVBMIZIZUTDNIZIZIZVHIZVFOZBVBPIZUDZQUEZUFZODEUGGDAGJZRIZUTVPKIZIZLIZVDV
      SMIZIZUTVPNIZIZIZWDIZWBOZBVSPIZUDZQUEZUFVOHUCVPDOZAVQWJCVNWKVQDRIZCVPDRSF
      UHWKVTVCWIVMQWKVSVBLWKUTVRVAVPDKSTZUAWKWGVKBWHVLWKVSVBPWMUAWKWFVJWBVFWKWE
      VIWDVHWKUTWCVGVPDNSTZWKWBVFWDVHWNWKVDWAVEWKVSVBMWMUATZUIUIWOUMUJUNUKABGUL
      ACVNCWLHFDRUOUPUQURUS $.

    $d w D $.  $d f w F $.  $d w L $.  $d w ._|_ $.  $d f w W $.
    lcdval.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcdval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdval.f $e |- F = ( LFnl ` U ) $.
    lcdval.l $e |- L = ( LKer ` U ) $.
    lcdval.d $e |- D = ( LDual ` U ) $.
    lcdval.k $e |- ( ph -> ( K e. X /\ W e. H ) ) $.
    $( Dual vector space of functionals with closed kernels.  (Contributed by
       NM, 13-Mar-2015.) $)
    lcdval $p |- ( ph -> C = ( D |`s { f e. F
            | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } ) ) $=
      ( vw wcel wa cfv wceq crab cress cdvh cld clk coch clfn cmpt clcd lcdfval
      cv co fveq1d syl5eq syl6eqr fveq2d fveq12d eqeq12d rabeqbidv oveq12d eqid
      fveq2 ovex fvmpt sylan9eq syl ) AHLUBZKGUBZUCBCEUPZIUDZJUDZJUDZVOUEZEFUFZ
      UGUQZUETVLVMBKUAGUAUPZHUHUDZUDZUIUDZVNWCUJUDZUDZWAHUKUDZUDZUDZWHUDZWFUEZE
      WCULUDZUFZUGUQZUMZUDZVTVLBKHUNUDZUDWPOVLKWQWOUAEGHLMUOURUSUAKWNVTGWOWAKUE
      ZWDCWMVSUGWRWDDUIUDCWRWCDUIWRWCKWBUDDWAKWBVGPUTZVASUTWRWKVREWLFWRWLDULUDF
      WRWCDULWSVAQUTWRWJVQWFVOWRWIVPWHJWRWHKWGUDJWAKWGVGNUTZWRWFVOWHJWTWRVNWEIW
      RWEDUJUDIWRWCDUJWSVARUTURZVBVBXAVCVDVEWOVFCVSUGVHVIVJVK $.

    lcdval2.b $e |- B =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    $( Dual vector space of functionals with closed kernels.  (Contributed by
       NM, 13-Mar-2015.) $)
    lcdval2 $p |- ( ph -> C = ( D |`s B ) ) $=
      ( cv cfv wceq crab cress co lcdval oveq2i syl6eqr ) ACDFUCJUDZKUDKUDULUEF
      GUFZUGUHDBUGUHACDEFGHIJKLMNOPQRSTUAUIBUMDUGUBUJUK $.
  $}

  ${
    $d f K $.  $d f W $.
    lcdlmod.h $e |- H = ( LHyp ` K ) $.
    lcdlmod.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlmod.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The dual vector space of functionals with closed kernels is a left
       vector space.  (Contributed by NM, 14-Mar-2015.) $)
    lcdlvec $p |- ( ph -> C e. LVec ) $=
      ( vf cdvh cfv cld cv clk coch wceq clfn clvec eqid wcel crab cress lcdval
      co chlt clss dvhlvec lduallvec lclkr lsslvec syl2anc eqeltrd ) ABEDJKKZLK
      ZIMUMNKZKZEDOKKZKUQKUPPIUMQKZUAZUBUDZRABUNUMIURCDUOUQEUEFUQSZGUMSZURSZUOS
      ZUNSZHUCAUNRTUSUNUFKZTUTRTAUNUMVEAUMCDEFVBHUGUHAUSUNVFUMIURCDUOUQEFVBVAVC
      VDVEVFSZUSSHUIVFUSUNUTUTSVGUJUKUL $.

    $( The dual vector space of functionals with closed kernels is a left
       module.  (Contributed by NM, 13-Mar-2015.) $)
    lcdlmod $p |- ( ph -> C e. LMod ) $=
      ( clvec wcel clmod lcdlvec lveclmod syl ) ABIJBKJABCDEFGHLBMN $.
  $}

  ${
    $d f F $.  $d f K $.  $d f W $.
    lcdvbase.h $e |- H = ( LHyp ` K ) $.
    lcdvbase.o $e |- ._|_ = ( ( ocH ` K ) ` W ) $.
    lcdvbase.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvbase.v $e |- V = ( Base ` C ) $.
    lcdvbase.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvbase.f $e |- F = ( LFnl ` U ) $.
    lcdvbase.l $e |- L = ( LKer ` U ) $.
    lcdvbase.b $e |- B =
      { f e. F | ( ._|_ ` ( ._|_ ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcdvbase.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Vector base set of a dual vector space of functionals with closed
       kernels.  (Contributed by NM, 13-Mar-2015.) $)
    lcdvbase $p |- ( ph -> V = B ) $=
      ( cld cfv cress co cbs chlt eqid lcdval2 fveq2d syl5eq wss wceq cv ssrab2
      crab eqsstri clmod dvhlmod ldualvbase syl5sseqr ressbas2 syl eqtr4d ) AKD
      UBUCZBUDUEZUFUCZBAKCUFUCVGPACVFUFABCVEDEFGHIJLUGMNOQRSVEUHZUATUIUJUKABVEU
      FUCZULBVGUMAFBVIBEUNIUCZJUCJUCVJUMZEFUPFTVKEFUOUQAVEFVIDURRVHVIUHZADGHLMQ
      UAUSUTVABVIVFVEVFUHVLVBVCVD $.
  $}

  ${
    $d f F $.  $d f K $.  $d f W $.
    lcdvbasess.h $e |- H = ( LHyp ` K ) $.
    lcdvbasess.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvbasess.v $e |- V = ( Base ` C ) $.
    lcdvbasess.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvbasess.f $e |- F = ( LFnl ` U ) $.
    lcdvbasess.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The vector base set of the closed kernel dual space is a set of
       functionals.  (Contributed by NM, 15-Mar-2015.) $)
    lcdvbasess $p |- ( ph -> V C_ F ) $=
      ( vf cv clk cfv coch eqid wceq crab lcdvbase ssrab2 syl6eqss ) AGOPCQRZRZ
      HFSRRZRUHRUGUAZODUBZDAUJBCODEFUFUHGHIUHTJKLMUFTUJTNUCUIODUDUE $.

    lcdvbaselfl.x $e |- ( ph -> X e. V ) $.
    $( A vector in the base set of the closed kernel dual space is a
       functional.  (Contributed by NM, 28-Mar-2015.) $)
    lcdvbaselfl $p |- ( ph -> X e. F ) $=
      ( lcdvbasess sseldd ) AGDIABCDEFGHJKLMNOQPR $.
  $}

  ${
    $d f F $.  $d f K $.  $d f W $.
    lcdvbasecl.h $e |- H = ( LHyp ` K ) $.
    lcdvbasecl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvbasecl.v $e |- V = ( Base ` U ) $.
    lcdvbasecl.s $e |- S = ( Scalar ` U ) $.
    lcdvbasecl.r $e |- R = ( Base ` S ) $.
    lcdvbasecl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvbasecl.e $e |- E = ( Base ` C ) $.
    lcdvbasecl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvbasecl.f $e |- ( ph -> F e. E ) $.
    lcdvbasecl.x $e |- ( ph -> X e. V ) $.
    $( Closure of the value of a vector (functional) in the closed kernel dual
       space.  (Contributed by NM, 28-Mar-2015.) $)
    lcdvbasecl $p |- ( ph -> ( F ` X ) e. R ) $=
      ( clmod wcel clfn cfv dvhlmod eqid lcdvbaselfl lflcl syl3anc ) AEUCUDGEUE
      UFZUDLJUDLGUFCUDAEHIKMNTUGABEULHIFKGMRSNULUHZTUAUIUBDULGCJELUCPQOUMUJUK
      $.
  $}

  ${
    $d f K $.  $d f U $.  $d f W $.
    lcdvadd.h $e |- H = ( LHyp ` K ) $.
    lcdvadd.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvadd.d $e |- D = ( LDual ` U ) $.
    lcdvadd.a $e |- .+ = ( +g ` D ) $.
    lcdvadd.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvadd.p $e |- .+b = ( +g ` C ) $.
    lcdvadd.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Vector addition for the closed kernel vector space dual.  (Contributed
       by NM, 10-Jun-2015.) $)
    lcdvadd $p |- ( ph -> .+b = .+ ) $=
      ( vf cplusg cfv eqid clk coch wceq clfn crab cress chlt lcdval fveq2d cvv
      cv co wcel fvex rabex ressplusg ax-mp 3eqtr4g ) ABRSCQUKFUASZSZIHUBSSZSVA
      SUTUCZQFUDSZUEZUFULZRSZEDABVERABCFQVCGHUSVAIUGJVATNKVCTUSTLPUHUIOVDUJUMDV
      FUCVBQVCFUDUNUOVDDCVEUJVETMUPUQUR $.
  $}

  ${
    lcdvaddval.h $e |- H = ( LHyp ` K ) $.
    lcdvaddval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvaddval.v $e |- V = ( Base ` U ) $.
    lcdvaddval.r $e |- R = ( Scalar ` U ) $.
    lcdvaddval.a $e |- .+ = ( +g ` R ) $.
    lcdvaddval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvaddval.d $e |- D = ( Base ` C ) $.
    lcdvaddval.p $e |- .+b = ( +g ` C ) $.
    lcdvaddval.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvaddval.f $e |- ( ph -> F e. D ) $.
    lcdvaddval.g $e |- ( ph -> G e. D ) $.
    lcdvaddval.x $e |- ( ph -> X e. V ) $.
    $( The value of the value of vector addition in the closed kernel vector
       space dual.  (Contributed by NM, 10-Jun-2015.) $)
    lcdvaddval $p |- ( ph
             -> ( ( F .+b G ) ` X ) = ( ( F ` X ) .+ ( G ` X ) ) ) $=
      ( co cfv cld cplusg lcdvadd oveqd fveq1d dvhlmod lcdvbaselfl ldualvaddval
      eqid clfn eqtrd ) ANHIEUGZUHNHIGUIUHZUJUHZUGZUHNHUHNIUHDUGANUTVCAEVBHIABV
      AVBEGJKMOPVAUQZVBUQZTUBUCUKULUMAVADVBFGURUHZHILGNQRSVFUQZVDVEAGJKMOPUCUNA
      BGVFJKCMHOTUAPVGUCUDUOABGVFJKCMIOTUAPVGUCUEUOUFUPUS $.
  $}

  ${
    $d f K $.  $d f U $.  $d f W $.
    lcdsca.h $e |- H = ( LHyp ` K ) $.
    lcdsca.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdsca.f $e |- F = ( Scalar ` U ) $.
    lcdsca.o $e |- O = ( oppR ` F ) $.
    lcdsca.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdsca.r $e |- R = ( Scalar ` C ) $.
    lcdsca.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The ring of scalars of the closed kernel dual space.  (Contributed by
       NM, 16-Mar-2015.)  (Revised by Mario Carneiro, 6-May-2015.) $)
    lcdsca $p |- ( ph -> R = O ) $=
      ( vf csca cfv eqid cld cv coch wceq clfn crab cress co chlt lcdval fveq2d
      clk cvv wcel fvex rabex resssca ax-mp syl6eqr clmod ldualsca eqtrd syl5eq
      dvhlmod ) ACBRSZHOAVEDUASZRSZHAVEVFQUBDULSZSZIGUCSSZSVJSVIUDZQDUESZUFZUGU
      HZRSZVGABVNRABVFDQVLFGVHVJIUIJVJTNKVLTVHTVFTZPUJUKVMUMUNVGVOUDVKQVLDUEUOU
      PVMVGVFVNUMVNTVGTZUQURUSAVFVGEHDUTLMVPVQADFGIJKPVDVAVBVC $.
  $}

  ${
    lcdsbase.h $e |- H = ( LHyp ` K ) $.
    lcdsbase.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdsbase.f $e |- F = ( Scalar ` U ) $.
    lcdsbase.l $e |- L = ( Base ` F ) $.
    lcdsbase.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdsbase.s $e |- S = ( Scalar ` C ) $.
    lcdsbase.r $e |- R = ( Base ` S ) $.
    lcdsbase.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Base set of scalar ring for the closed kernel dual of a vector space.
       (Contributed by NM, 18-Mar-2015.) $)
    lcdsbase $p |- ( ph -> R = L ) $=
      ( cbs cfv coppr eqid lcdsca fveq2d opprbas 3eqtr4g ) ADSTFUATZSTCIADUGSAB
      DEFGHUGJKLMUGUBZOPRUCUDQIFUGUHNUEUF $.
  $}

  ${
    lcdsadd.h $e |- H = ( LHyp ` K ) $.
    lcdsadd.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdsadd.f $e |- F = ( Scalar ` U ) $.
    lcdsadd.p $e |- .+ = ( +g ` F ) $.
    lcdsadd.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdsadd.s $e |- S = ( Scalar ` C ) $.
    lcdsadd.a $e |- .+b = ( +g ` S ) $.
    lcdsadd.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Scalar addition for the closed kernel vector space dual.  (Contributed
       by NM, 6-Jun-2015.) $)
    lcdsadd $p |- ( ph -> .+b = .+ ) $=
      ( cplusg cfv coppr eqid lcdsca fveq2d oppradd 3eqtr4g ) AESTGUATZSTDCAEUG
      SABEFGHIUGJKLMUGUBZOPRUCUDQCGUGUHNUEUF $.
  $}

  ${
    lcdsmul.h $e |- H = ( LHyp ` K ) $.
    lcdsmul.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdsmul.f $e |- F = ( Scalar ` U ) $.
    lcdsmul.l $e |- L = ( Base ` F ) $.
    lcdsmul.t $e |- .x. = ( .r ` F ) $.
    lcdsmul.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdsmul.s $e |- S = ( Scalar ` C ) $.
    lcdsmul.m $e |- .xb = ( .r ` S ) $.
    lcdsmul.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdsmul.x $e |- ( ph -> X e. L ) $.
    lcdsmul.y $e |- ( ph -> Y e. L ) $.
    $( Scalar multiplication for the closed kernel vector space dual.
       (Contributed by NM, 20-Mar-2015.) $)
    lcdsmul $p |- ( ph -> ( X .xb Y ) = ( Y .x. X ) ) $=
      ( co coppr cfv cmulr eqid lcdsca fveq2d syl5eq oveqd opprmul syl6eq ) ALM
      DUELMGUFUGZUHUGZUEMLEUEADUQLMADCUHUGUQUAACUPUHABCFGHIUPKNOPUPUIZSTUBUJUKU
      LUMJGUQEUPLMQRURUQUIUNUO $.
  $}

  ${
    $d f K $.  $d f U $.  $d f W $.
    lcdvs.h $e |- H = ( LHyp ` K ) $.
    lcdvs.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvs.d $e |- D = ( LDual ` U ) $.
    lcdvs.t $e |- .x. = ( .s ` D ) $.
    lcdvs.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvs.m $e |- .xb = ( .s ` C ) $.
    lcdvs.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Scalar product for the closed kernel vector space dual.  (Contributed by
       NM, 28-Mar-2015.) $)
    lcdvs $p |- ( ph -> .xb = .x. ) $=
      ( vf cvsca cfv eqid cv clk coch wceq clfn crab cress co lcdval fveq2d cvv
      chlt wcel fvex rabex ressvsca ax-mp 3eqtr4g ) ABRSCQUAFUBSZSZIHUCSSZSVASU
      TUDZQFUESZUFZUGUHZRSZDEABVERABCFQVCGHUSVAIULJVATNKVCTUSTLPUIUJOVDUKUMEVFU
      DVBQVCFUEUNUOVDECVEUKVETMUPUQUR $.
  $}

  ${
    lcdvsval.h $e |- H = ( LHyp ` K ) $.
    lcdvsval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvsval.v $e |- V = ( Base ` U ) $.
    lcdvsval.s $e |- S = ( Scalar ` U ) $.
    lcdvsval.r $e |- R = ( Base ` S ) $.
    lcdvsval.t $e |- .x. = ( .r ` S ) $.
    lcdvsval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvsval.f $e |- F = ( Base ` C ) $.
    lcdvsval.m $e |- .xb = ( .s ` C ) $.
    lcdvsval.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvsval.x $e |- ( ph -> X e. R ) $.
    lcdvsval.g $e |- ( ph -> G e. F ) $.
    lcdvsval.a $e |- ( ph -> A e. V ) $.
    $( Value of scalar product operation value for the closed kernel vector
       space dual.  (Contributed by NM, 28-Mar-2015.) $)
    lcdvsval $p |- ( ph -> ( ( X .xb G ) ` A ) = ( ( G ` A ) .x. X ) ) $=
      ( co cfv cld cvsca eqid lcdvs oveqd fveq1d clfn clmod dvhlmod lcdvbaselfl
      ldualvsval eqtrd ) ABOJFUIZUJBOJHUKUJZULUJZUIZUJBJUJOGUIABVCVFAFVEOJACVDF
      VEHKLNPQVDUMZVEUMZUBUDUEUNUOUPABVDEVEGHUQUJZJDMHOURVIUMZRSTUAVGVHAHKLNPQU
      EUSUFACHVIKLINJPUBUCQVJUEUGUTUHVAVB $.
  $}

  ${
    lcdvscl.h $e |- H = ( LHyp ` K ) $.
    lcdvscl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvscl.s $e |- S = ( Scalar ` U ) $.
    lcdvscl.r $e |- R = ( Base ` S ) $.
    lcdvscl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvscl.v $e |- V = ( Base ` C ) $.
    lcdvscl.t $e |- .x. = ( .s ` C ) $.
    lcdvscl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvscl.x $e |- ( ph -> X e. R ) $.
    lcdvscl.g $e |- ( ph -> G e. V ) $.
    $( The scalar product operation value is a functional.  (Contributed by NM,
       20-Mar-2015.) $)
    lcdvscl $p |- ( ph -> ( X .x. G ) e. V ) $=
      ( clmod wcel csca cfv cbs lcdlmod eqid lcdsbase eleqtrrd lmodvscl syl3anc
      co ) ABUCUDLBUEUFZUGUFZUDGJUDLGEUNJUDABHIKMQTUHALCUPUAABUPUOFDHICKMNOPQUO
      UIZUPUIZTUJUKUBLEUOUPJBGRUQSURULUM $.
  $}

  ${
    lcdlssvscl.h $e |- H = ( LHyp ` K ) $.
    lcdlssvscl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdlssvscl.f $e |- F = ( Scalar ` U ) $.
    lcdlssvscl.r $e |- R = ( Base ` F ) $.
    lcdlssvscl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlssvscl.v $e |- V = ( Base ` C ) $.
    lcdlssvscl.t $e |- .x. = ( .s ` C ) $.
    lcdlssvscl.s $e |- S = ( LSubSp ` C ) $.
    lcdlssvscl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdlssvscl.l $e |- ( ph -> L e. S ) $.
    lcdlssvscl.x $e |- ( ph -> X e. R ) $.
    lcdlssvscl.y $e |- ( ph -> Y e. L ) $.
    $( Closure of scalar product in a closed kernel dual vector space.
       (Contributed by NM, 20-Mar-2015.) $)
    lcdlssvscl $p |- ( ph -> ( X .x. Y ) e. L ) $=
      ( clmod wcel csca cfv cbs lcdlmod eqid lcdsbase eleqtrrd lssvscl syl22anc
      co ) ABUGUHJDUHMBUIUJZUKUJZUHNJUHMNEURJUHABHILOSUCULUDAMCUTUEABUTUSFGHICL
      OPQRSUSUMZUTUMZUCUNUOUFUTDEJUSBMNVAUAVBUBUPUQ $.
  $}


  ${
    lcdvsass.h $e |- H = ( LHyp ` K ) $.
    lcdvsass.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvsass.r $e |- R = ( Scalar ` U ) $.
    lcdvsass.l $e |- L = ( Base ` R ) $.
    lcdvsass.t $e |- .x. = ( .r ` R ) $.
    lcdvsass.d $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvsass.f $e |- F = ( Base ` C ) $.
    lcdvsass.s $e |- .xb = ( .s ` C ) $.
    lcdvsass.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvsass.x $e |- ( ph -> X e. L ) $.
    lcdvsass.y $e |- ( ph -> Y e. L ) $.
    lcdvsass.g $e |- ( ph -> G e. F ) $.
    $( Associative law for scalar product in a closed kernel dual vector
       space.  (Contributed by NM, 20-Mar-2015.) $)
    lcdvsass $p |- ( ph -> ( ( Y .x. X ) .xb G ) = ( X .xb ( Y .xb G ) ) ) $=
      ( csca cfv cmulr eqid lcdsmul oveq1d clmod wcel cbs wceq lcdlmod lcdsbase
      co eleqtrrd lmodvsass syl13anc eqtr3d ) AMNBUGUHZUIUHZUSZHDUSZNMEUSZHDUSM
      NHDUSDUSZAVFVHHDABVDVEEFCIJKLMNOPQRSTVDUJZVEUJZUCUDUEUKULABUMUNMVDUOUHZUN
      NVLUNHGUNVGVIUPABIJLOTUCUQAMKVLUDABVLVDFCIJKLOPQRTVJVLUJZUCURZUTANKVLUEVN
      UTUFMNDVEVDVLGBHUAVJUBVMVKVAVBVC $.
  $}

  ${
    lcd0.h $e |- H = ( LHyp ` K ) $.
    lcd0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcd0.f $e |- F = ( Scalar ` U ) $.
    lcd0.z $e |- .0. = ( 0g ` F ) $.
    lcd0.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcd0.s $e |- S = ( Scalar ` C ) $.
    lcd0.o $e |- O = ( 0g ` S ) $.
    lcd0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The zero scalar of the closed kernel dual of a vector space.
       (Contributed by NM, 20-Mar-2015.) $)
    lcd0 $p |- ( ph -> O = .0. ) $=
      ( c0g cfv coppr eqid lcdsca fveq2d oppr0 3eqtr4g ) ACSTEUATZSTHJACUGSABCD
      EFGUGIKLMUGUBZOPRUCUDQEUGJUHNUEUF $.
  $}

  ${
    lcd1.h $e |- H = ( LHyp ` K ) $.
    lcd1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcd1.f $e |- F = ( Scalar ` U ) $.
    lcd1.j $e |- .1. = ( 1r ` F ) $.
    lcd1.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcd1.s $e |- S = ( Scalar ` C ) $.
    lcd1.i $e |- I = ( 1r ` S ) $.
    lcd1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The unit scalar of the closed kernel dual of a vector space.
       (Contributed by NM, 20-Mar-2015.) $)
    lcd1 $p |- ( ph -> I = .1. ) $=
      ( cur cfv coppr eqid lcdsca fveq2d oppr1 3eqtr4g ) ACSTFUATZSTHEACUGSABCD
      FGIUGJKLMUGUBZOPRUCUDQFEUGUHNUEUF $.
  $}

  ${
    lcdneg.h $e |- H = ( LHyp ` K ) $.
    lcdneg.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdneg.r $e |- R = ( Scalar ` U ) $.
    lcdneg.m $e |- M = ( invg ` R ) $.
    lcdneg.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdneg.s $e |- S = ( Scalar ` C ) $.
    lcdneg.n $e |- N = ( invg ` S ) $.
    lcdneg.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The unit scalar of the closed kernel dual of a vector space.
       (Contributed by NM, 11-Jun-2015.) $)
    lcdneg $p |- ( ph -> N = M ) $=
      ( cminusg cfv coppr eqid lcdsca fveq2d opprneg 3eqtr4g ) ADSTCUATZSTIHADU
      GSABDECFGUGJKLMUGUBZOPRUCUDQCHUGUHNUEUF $.
  $}

  ${
    $d f K $.  $d f U $.  $d f W $.
    lcd0v.h $e |- H = ( LHyp ` K ) $.
    lcd0v.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcd0v.v $e |- V = ( Base ` U ) $.
    lcd0v.r $e |- R = ( Scalar ` U ) $.
    lcd0v.z $e |- .0. = ( 0g ` R ) $.
    lcd0v.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcd0v.o $e |- O = ( 0g ` C ) $.
    lcd0v.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The zero functional in the set of functionals with closed kernels.
       (Contributed by NM, 20-Mar-2015.) $)
    lcd0v $p |- ( ph -> O = ( V X. { .0. } ) ) $=
      ( cfv eqid vf cld cv clk coch wceq clfn crab cress co c0g csn chlt lcdval
      cxp fveq2d syl5eq clmod wcel clss dvhlmod lduallmod lclkr syl2anc ldual0v
      lss0v 3eqtrd ) AGDUBSZUAUCDUDSZSZIFUESSZSVKSVJUFUADUGSZUHZUIUJZUKSZVHUKSZ
      HJULUOAGBUKSVOQABVNUKABVHDUAVLEFVIVKIUMKVKTZPLVLTZVITZVHTZRUNUPUQAVHURUSV
      MVHUTSZUSVOVPUFAVHDVTADEFIKLRVAZVBAVMVHWADUAVLEFVIVKIKLVQVRVSVTWATZVMTRVC
      VMWAVHVNVPVOVNTVPTZVOTWCVFVDAVHCVPHDJMNOVTWDWBVEVG $.
  $}

  ${
    lcd0v2.h $e |- H = ( LHyp ` K ) $.
    lcd0v2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcd0v2.d $e |- D = ( LDual ` U ) $.
    lcd0v2.z $e |- .0. = ( 0g ` D ) $.
    lcd0v2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcd0v2.o $e |- O = ( 0g ` C ) $.
    lcd0v2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The zero functional in the set of functionals with closed kernels.
       (Contributed by NM, 27-Mar-2015.) $)
    lcd0v2 $p |- ( ph -> O = .0. ) $=
      ( cbs cfv csca eqid c0g csn cxp lcd0v dvhlmod ldual0v eqtr4d ) AGDQRZDSRZ
      UARZUBUCIABUIDEFGUHHUJJKUHTZUITZUJTZNOPUDACUIIUHDUJUKULUMLMADEFHJKPUEUFUG
      $.
  $}

  ${
    lcd0vval.h $e |- H = ( LHyp ` K ) $.
    lcd0vval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcd0vval.v $e |- V = ( Base ` U ) $.
    lcd0vval.s $e |- S = ( Scalar ` U ) $.
    lcd0vval.z $e |- .0. = ( 0g ` S ) $.
    lcd0vval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcd0vval.o $e |- O = ( 0g ` C ) $.
    lcd0vval.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcd0vval.x $e |- ( ph -> X e. V ) $.
    $( Value of the zero functional at any vector.  (Contributed by NM,
       28-Mar-2015.)  (New usage is discouraged.) $)
    lcd0vvalN $p |- ( ph -> ( O ` X ) = .0. ) $=
      ( cfv csn cxp lcd0v fveq1d wcel wceq c0g cvv fvex eqeltri fvconst2 eqtrd
      syl ) AJGUAJHKUBUCZUAZKAJGUOABCDEFGHIKLMNOPQRSUDUEAJHUFUPKUGTHKJKCUHUAUIP
      CUHUJUKULUNUM $.
  $}

  ${
    lcdv0cl.h $e |- H = ( LHyp ` K ) $.
    lcdv0cl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdv0cl.v $e |- V = ( Base ` C ) $.
    lcdv0cl.o $e |- O = ( 0g ` C ) $.
    lcdv0cl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Closure of the zero functional in the set of functionals with closed
       kernels.  (Contributed by NM, 15-Mar-2015.) $)
    lcd0vcl $p |- ( ph -> O e. V ) $=
      ( clmod wcel lcdlmod lmod0vcl syl ) ABMNEFNABCDGHILOFBEJKPQ $.
  $}

  ${
    lcd0vs.h $e |- H = ( LHyp ` K ) $.
    lcd0vs.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcd0vs.r $e |- R = ( Scalar ` U ) $.
    lcd0vs.z $e |- .0. = ( 0g ` R ) $.
    lcd0vs.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcd0vs.v $e |- V = ( Base ` C ) $.
    lcd0vs.t $e |- .x. = ( .s ` C ) $.
    lcd0vs.o $e |- O = ( 0g ` C ) $.
    lcd0vs.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcd0vs.g $e |- ( ph -> G e. V ) $.
    $( A scalar zero times a functional is the zero functional.  (Contributed
       by NM, 20-Mar-2015.) $)
    lcd0vs $p |- ( ph -> ( .0. .x. G ) = O ) $=
      ( csca cfv c0g co eqid lcd0 oveq1d clmod wcel wceq lcdlmod lmod0vs eqtr3d
      syl2anc ) ABUCUDZUEUDZFDUFZLFDUFIAURLFDABUQECGHURKLMNOPQUQUGZURUGZUAUHUIA
      BUJUKFJUKUSIULABGHKMQUAUMUBDUQURJBFIRUTSVATUNUPUO $.
  $}

  ${
    lcdvs0.h $e |- H = ( LHyp ` K ) $.
    lcdvs0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvs0.s $e |- S = ( Scalar ` U ) $.
    lcdvs0.r $e |- R = ( Base ` S ) $.
    lcdvs0.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvs0.t $e |- .x. = ( .s ` C ) $.
    lcdvs0.o $e |- .0. = ( 0g ` C ) $.
    lcdvs0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvs0.x $e |- ( ph -> X e. R ) $.
    $( A scalar times the zero functional is the zero functional.  (Contributed
       by NM, 20-Mar-2015.)  (New usage is discouraged.) $)
    lcdvs0N $p |- ( ph -> ( X .x. .0. ) = .0. ) $=
      ( clmod wcel csca cfv wceq lcdlmod eqid lcdsbase eleqtrrd lmodvs0 syl2anc
      cbs co ) ABUAUBJBUCUDZULUDZUBJKEUMKUEABGHILPSUFAJCUOTABUOUNFDGHCILMNOPUNU
      GZUOUGZSUHUIEUNUOBJKUPQUQRUJUK $.
  $}

  ${
    lcdvsub.h $e |- H = ( LHyp ` K ) $.
    lcdvsub.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvsub.s $e |- S = ( Scalar ` U ) $.
    lcdvsub.n $e |- N = ( invg ` S ) $.
    lcdvsub.e $e |- .1. = ( 1r ` S ) $.
    lcdvsub.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvsub.v $e |- V = ( Base ` C ) $.
    lcdvsub.p $e |- .+ = ( +g ` C ) $.
    lcdvsub.t $e |- .x. = ( .s ` C ) $.
    lcdvsub.m $e |- .- = ( -g ` C ) $.
    lcdvsub.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvsub.f $e |- ( ph -> F e. V ) $.
    lcdvsub.g $e |- ( ph -> G e. V ) $.
    $( The value of vector subtraction in the closed kernel dual space.
       (Contributed by NM, 22-Mar-2015.) $)
    lcdvsub $p |- ( ph -> ( F .- G ) = ( F .+ ( ( N ` .1. ) .x. G ) ) ) $=
      ( co csca cfv cur cminusg clmod wcel wceq lcdlmod eqid lmodvsubval2 coppr
      syl3anc lcdsca fveq2d opprneg syl6reqr oppr1 fveq12d oveq1d oveq2d eqtr4d
      ) AHILUIZHBUJUKZULUKZVLUMUKZUKZIEUIZCUIZHGMUKZIEUIZCUIABUNUOHNUOINUOVKVQU
      PABJKOPUAUFUQUGUHHICEVMVLLVNNBUBUCUEVLURZUDVNURVMURUSVAAVSVPHCAVRVOIEAGVM
      MVNAVNDUTUKZUMUKMAVLWAUMABVLFDJKWAOPQRWAURZUAVTUFVBZVCDMWAWBSVDVEAVMWAULU
      KGAVLWAULWCVCDGWAWBTVFVEVGVHVIVJ $.
  $}

  ${
    lcdvsubval.h $e |- H = ( LHyp ` K ) $.
    lcdvsubval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdvsubval.v $e |- V = ( Base ` U ) $.
    lcdvsubval.r $e |- R = ( Scalar ` U ) $.
    lcdvsubval.s $e |- S = ( -g ` R ) $.
    lcdvsubval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdvsubval.d $e |- D = ( Base ` C ) $.
    lcdvsubval.m $e |- .- = ( -g ` C ) $.
    lcdvsubval.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdvsubval.f $e |- ( ph -> F e. D ) $.
    lcdvsubval.g $e |- ( ph -> G e. D ) $.
    lcdvsubval.x $e |- ( ph -> X e. V ) $.
    $( The value of the value of vector addition in the closed kernel vector
       space dual.  (Contributed by NM, 11-Jun-2015.) $)
    lcdvsubval $p |- ( ph
             -> ( ( F .- G ) ` X ) = ( ( F ` X ) S ( G ` X ) ) ) $=
      ( co cfv csca cur cminusg cvsca clmod wcel wceq lcdlmod eqid lmodvsubval2
      cplusg syl3anc cbs cgrp lmodfgrp syl crg lmodrng rngidcl grpinvcl syl2anc
      fveq1d eleqtrd lcdvscl lcdvaddval cmulr lcdneg lcd1 fveq12d oveq1d rnggrp
      lcdsbase dvhlmod lmod1cl lcdvsval lcdvbasecl rngnegr 3eqtrd oveq2d eqtr4d
      grpsubval ) ANGHKUGZUHNGBUIUHZUJUHZWKUKUHZUHZHBULUHZUGZBUSUHZUGZUHNGUHZNW
      PUHZDUSUHZUGZWSNHUHZEUGZANWJWRABUMUNZGCUNHCUNWJWRUOABIJMOTUCUPZUDUEGHWQWO
      WLWKKWMCBUAWQUQZUBWKUQZWOUQZWMUQZWLUQZURUTVJABCXAWQDFGWPIJLMNOPQRXAUQZTUA
      XGUCUDABDVAUHZDWOFHIJCMWNOPRXMUQZTUAXIUCAWNWKVAUHZXMAWKVBUNZWLXOUNZWNXOUN
      AXEXPXFWKBXHVCVDAWKVEUNZXQAXEXRXFWKBXHVFVDXOWKWLXOUQZXKVGVDXOWKWMWLXSXJVH
      VIABXOWKFDIJXMMOPRXNTXHXSUCVTVKUEVLUFVMAXBWSXCDUKUHZUHZXAUGZXDAWTYAWSXAAW
      TNDUJUHZXTUHZHWOUGZUHXCYDDVNUHZUGYAANWPYEAWNYDHWOAWLYCWMXTABDWKFIJXTWMMOP
      RXTUQZTXHXJUCVOABWKFYCDIWLJMOPRYCUQZTXHXKUCVPVQVRVJANBXMDWOYFFCHIJLMYDOPQ
      RXNYFUQZTUAXIUCADVBUNZYCXMUNZYDXMUNADVEUNZYJAFUMUNZYLAFIJMOPUCWAZDFRVFVDZ
      DVSVDAYMYKYNYCDXMFRXNYHWBVDXMDXTYCXNYGVHVIUEUFWCAXMDYFYCXTXCXNYIYHYGYOABX
      MDFCHIJLMNOPQRXNTUAUCUEUFWDZWEWFWGAWSXMUNXCXMUNXDYBUOABXMDFCGIJLMNOPQRXNT
      UAUCUDUFWDYPXMXADXTEWSXCXNXLYGSWIVIWHWF $.
  $}

  ${
    $d u B $.  $d f D $.  $d f F $.  $d f K $.  $d f L $.  $d f O $.  $d u S $.
    $d u T $.  $d f U $.  $d f W $.  $d u ph $.
    lcdlss.h $e |- H = ( LHyp ` K ) $.
    lcdlss.o $e |- O = ( ( ocH ` K ) ` W ) $.
    lcdlss.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlss.s $e |- S = ( LSubSp ` C ) $.
    lcdlss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdlss.f $e |- F = ( LFnl ` U ) $.
    lcdlss.l $e |- L = ( LKer ` U ) $.
    lcdlss.d $e |- D = ( LDual ` U ) $.
    lcdlss.t $e |- T = ( LSubSp ` D ) $.
    lcdlss.b $e |- B = { f e. F | ( O ` ( O ` ( L ` f ) ) ) = ( L ` f ) } $.
    lcdlss.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Subspaces of a dual vector space of functionals with closed kernels.
       (Contributed by NM, 13-Mar-2015.) $)
    lcdlss $p |- ( ph -> S = ( T i^i ~P B ) ) $=
      ( vu cpw cin cv wcel wss cress clss cfv chlt lcdval2 fveq2d syl5eq eleq2d
      wa co clmod wb dvhlmod lduallmod lclkr eqid lsslss syl2anc bitrd elin vex
      elpw anbi2i bitr2i syl6bb eqrdv ) AUFEFBUGZUHZAUFUIZEUJZVTFUJZVTBUKZUTZVT
      VSUJZAWAVTDBULVAZUMUNZUJZWDAEWGVTAECUMUNWGRACWFUMABCDGHIJKLMNUOOPQSTUAUBU
      EUDUPUQURUSADVBUJBFUJWHWDVCADGUBAGJKNOSUEVDVEABDFGHIJKLMNOSPTUAUBUCUDUEVF
      FWGBVTDWFWFVGUCWGVGVHVIVJWEWBVTVRUJZUTWDVTFVRVKWIWCWBVTBUFVLVMVNVOVPVQ $.
  $}

  ${
    $d f D $.  $d f K $.  $d f U $.  $d f W $.
    lcdlss2.h $e |- H = ( LHyp ` K ) $.
    lcdlss2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlss2.s $e |- S = ( LSubSp ` C ) $.
    lcdlss2.v $e |- V = ( Base ` C ) $.
    lcdlss2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdlss2.d $e |- D = ( LDual ` U ) $.
    lcdlss2.t $e |- T = ( LSubSp ` D ) $.
    lcdlss2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Subspaces of a dual vector space of functionals with closed kernels.
       (Contributed by NM, 13-Mar-2015.)  (New usage is discouraged.) $)
    lcdlss2N $p |- ( ph -> S = ( T i^i ~P V ) ) $=
      ( vf cfv cv clk coch wceq clfn crab cpw eqid lcdlss lcdvbase pweqd ineq2d
      cin eqtr4d ) ADESUAFUBTZTZJHUCTTZTUQTUPUDSFUETZUFZUGZUMEIUGZUMAUSBCDEFSUR
      GHUOUQJKUQUHZLMOURUHZUOUHZPQUSUHZRUIAVAUTEAIUSAUSBFSURGHUOUQIJKVBLNOVCVDV
      ERUJUKULUN $.
  $}

  ${
    $d f D $.  $d f K $.  $d f U $.  $d f W $.
    lcdlsp.h $e |- H = ( LHyp ` K ) $.
    lcdlsp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdlsp.d $e |- D = ( LDual ` U ) $.
    lcdlsp.m $e |- M = ( LSpan ` D ) $.
    lcdlsp.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlsp.f $e |- F = ( Base ` C ) $.
    lcdlsp.n $e |- N = ( LSpan ` C ) $.
    lcdlsp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdlsp.g $e |- ( ph -> G C_ F ) $.
    $( Span in the set of functionals with closed kernels.  (Contributed by NM,
       28-Mar-2015.) $)
    lcdlsp $p |- ( ph -> ( N ` G ) = ( M ` G ) ) $=
      ( vf cfv cv clk coch wceq clfn crab cress clspn chlt lcdval fveq2d syl5eq
      co eqid fveq1d clmod wcel clss wss dvhlmod lduallmod lclkr sseqtrd lsslsp
      lcdvbase syl3anc eqtr4d ) AFJUBFCUAUCDUDUBZUBZKHUEUBUBZUBVLUBVKUFUADUGUBZ
      UHZUIUOZUJUBZUBZFIUBZAFJVPAJBUJUBVPRABVOUJABCDUAVMGHVJVLKUKLVLUPZPMVMUPZV
      JUPZNSULUMUNUQACURUSVNCUTUBZUSFVNVAVRVQUFACDNADGHKLMSVBVCAVNCWBDUAVMGHVJV
      LKLMVSVTWANWBUPZVNUPZSVDAFEVNTAVNBDUAVMGHVJVLEKLVSPQMVTWAWDSVGVEVNFWBIVPC
      VOVOUPOVPUPWCVFVHVI $.
  $}

  ${
    lcdlkreq.h $e |- H = ( LHyp ` K ) $.
    lcdlkreq.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdlkreq.l $e |- L = ( LKer ` U ) $.
    lcdlkreq.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlkreq.o $e |- .0. = ( 0g ` C ) $.
    lcdlkreq.n $e |- N = ( LSpan ` C ) $.
    lcdlkreq.v $e |- V = ( Base ` C ) $.
    lcdlkreq.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdlkreq.i $e |- ( ph -> I e. V ) $.
    lcdlkreq.g $e |- ( ph -> G e. ( N ` { I } ) ) $.
    lcdlkreq.z $e |- ( ph -> G =/= .0. ) $.
    $( Colinear functionals have equal kernels.  (Contributed by NM,
       28-Mar-2015.)  (New usage is discouraged.) $)
    lcdlkreqN $p |- ( ph -> ( L ` G ) = ( L ` I ) ) $=
      ( cld cfv clfn clspn c0g eqid dvhlvec lcdvbaselfl csn wcel wne cdif snssd
      lcdlsp eleqtrd lcd0v2 neeqtrd eldifsn sylanbrc lkrlspeqN ) ACUDUEZCUFUEZD
      FHVDUGUEZCVDUHUEZVEUIZOVDUIZVGUIZVFUIZACEGKMNTUJABCVEEGJKFMPSNVHTUAUKADFU
      LZVFUEZUMDVGUNDVMVGULUOUMADVLIUEVMUBABVDCJVLEGVFIKMNVIVKPSRTAFJUAUPUQURAD
      LVGUCABVDCEGLKVGMNVIVJPQTUSUTDVMVGVAVBVC $.
  $}

  ${
    lcdlkreq2.h $e |- H = ( LHyp ` K ) $.
    lcdlkreq2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    lcdlkreq2.s $e |- S = ( Scalar ` U ) $.
    lcdlkreq2.r $e |- R = ( Base ` S ) $.
    lcdlkreq2.o $e |- .0. = ( 0g ` S ) $.
    lcdlkreq2.l $e |- L = ( LKer ` U ) $.
    lcdlkreq2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    lcdlkreq2.v $e |- V = ( Base ` C ) $.
    lcdlkreq2.t $e |- .x. = ( .s ` C ) $.
    lcdlkreq2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    lcdlkreq2.a $e |- ( ph -> A e. ( R \ { .0. } ) ) $.
    lcdlkreq2.i $e |- ( ph -> I e. V ) $.
    lcdlkreq2.g $e |- ( ph -> G = ( A .x. I ) ) $.
    $( Colinear functionals have equal kernels.  (Contributed by NM,
       28-Mar-2015.)  (New usage is discouraged.) $)
    lcdlkreq2N $p |- ( ph -> ( L ` G ) = ( L ` I ) ) $=
      ( cld cfv cvsca clfn eqid dvhlvec lcdvbaselfl co lcdvs oveqd eqtrd lkreqN
      ) ABGUIUJZDEVAUKUJZGULUJZHJLGORSTVCUMZUAVAUMZVBUMZAGIKNPQUEUNUFACGVCIKMNJ
      PUBUCQVDUEUGUOAHBJFUPBJVBUPUHAFVBBJACVAFVBGIKNPQVEVFUBUDUEUQURUSUT $.
  $}


  $c mapd $.

  $( Extend class notation with projectivity from subspaces of vector space H
     to subspaces of functionals with closed kernels. $)
  cmpd $a class mapd $.

  ${
    $d s k w f $.
    $( Extend class notation with a one-to-one onto ( ~ mapd1o ),
       order-preserving ( ~ mapdord ) map, called a projectivity (definition of
       projectivity in [Baer] p. 40), from subspaces of vector space H to those
       subspaces of the dual space having functionals with closed kernels.
       (Contributed by NM, 25-Jan-2015.) $)
    df-mapd $a |- mapd = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
          ( s e. ( LSubSp ` ( ( DVecH ` k ) ` w ) ) |->
  { f e. ( LFnl ` ( ( DVecH ` k ) ` w ) ) |
 ( ( ( ( ocH ` k ) ` w ) ` ( ( ( ocH ` k ) ` w )
     ` ( ( LKer ` ( ( DVecH ` k ) ` w ) ) ` f ) ) )
   = ( ( LKer ` ( ( DVecH ` k ) ` w ) ) ` f ) /\
 ( ( ( ocH ` k ) ` w ) ` ( ( LKer ` ( ( DVecH ` k ) ` w ) ) ` f ) )
        C_ s ) } ) ) ) $.
  $}

  ${
    $d k w H $.  $d f k s w K $.
    mapdval.h $e |- H = ( LHyp ` K ) $.
    $( Projectivity from vector space H to dual space.  (Contributed by NM,
       25-Jan-2015.) $)
    mapdffval $p |- ( K e. X -> ( mapd ` K ) = ( w e. H
  |-> ( s e. ( LSubSp ` ( ( DVecH ` K ) ` w ) ) |->
  { f e. ( LFnl ` ( ( DVecH ` K ) ` w ) ) |
 ( ( ( ( ocH ` K ) ` w ) ` ( ( ( ocH ` K ) ` w )
     ` ( ( LKer ` ( ( DVecH ` K ) ` w ) ) ` f ) ) )
   = ( ( LKer ` ( ( DVecH ` K ) ` w ) ) ` f ) /\
 ( ( ( ocH ` K ) ` w ) ` ( ( LKer ` ( ( DVecH ` K ) ` w ) ) ` f ) )
        C_ s ) } ) ) ) $=
      ( vk cvv cfv cv cdvh clss clk coch wceq clfn cmpt clh fveq2 wcel cmpd wss
      wa crab syl6eqr fveq1d fveq2d fveq12d eqeq12d anbi12d rabeqbidv mpteq12dv
      elex sseq1d df-mapd fvex eqeltri mptex fvmpt syl ) DEUADIUADUBJACFAKZDLJZ
      JZMJZBKZVDNJZJZVBDOJZJZJZVJJZVHPZVKFKZUCZUDZBVDQJZUEZRZRZPDEUNHDAHKZSJZFV
      BWALJZJZMJZVFWDNJZJZVBWAOJZJZJZWIJZWGPZWJVNUCZUDZBWDQJZUEZRZRVTIUBWADPZAW
      BWQCVSWRWBDSJZCWADSTGUFWRFWEWPVEVRWRWDVDMWRVBWCVCWADLTUGZUHWRWNVPBWOVQWRW
      DVDQWTUHWRWLVMWMVOWRWKVLWGVHWRWJVKWIVJWRVBWHVIWADOTUGZWRWGVHWIVJXAWRVFWFV
      GWRWDVDNWTUHUGZUIZUIXBUJWRWJVKVNXCUOUKULUMUMABHFUPACVSCWSIGDSUQURUSUTVA
      $.

    $d f w F $.  $d w L $.  $d w O $.  $d s w S $.  $d f s w W $.
    mapdval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdval.s $e |- S = ( LSubSp ` U ) $.
    mapdval.f $e |- F = ( LFnl ` U ) $.
    mapdval.l $e |- L = ( LKer ` U ) $.
    mapdval.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdval.m $e |- M = ( ( mapd ` K ) ` W ) $.
    $( Projectivity from vector space H to dual space.  (Contributed by NM,
       25-Jan-2015.) $)
    mapdfval $p |- ( ( K e. X /\ W e. H )
     -> M = ( s e. S |-> { f e. F |
   ( ( O ` ( O ` ( L ` f ) ) ) = ( L ` f ) /\ ( O ` ( L ` f ) ) C_ s ) } ) ) $=
      ( cfv vw wcel cv cdvh clss clk coch wceq wa clfn crab cmpt cmpd mapdffval
      wss fveq1d syl5eq syl6eqr fveq2d fveq12d eqeq12d sseq1d anbi12d rabeqbidv
      fveq2 mpteq12dv eqid cvv fvex eqeltri mptex fvmpt sylan9eq ) FKUBZJEUBHJU
      AELUAUCZFUDTZTZUETZCUCZVQUFTZTZVOFUGTZTZTZWCTZWAUHZWDLUCZUOZUIZCVQUJTZUKZ
      ULZULZTZLAVSGTZITZITZWOUHZWPWGUOZUIZCDUKZULZVNHJFUMTZTWNSVNJXCWMUACEFKLMU
      NUPUQUAJWLXBEWMVOJUHZLVRWKAXAXDVRBUETZAXDVQBUEXDVQJVPTBVOJVPVENURZUSOURXD
      WIWTCWJDXDWJBUJTDXDVQBUJXFUSPURXDWFWRWHWSXDWEWQWAWOXDWDWPWCIXDWCJWBTIVOJW
      BVERURZXDWAWOWCIXGXDVSVTGXDVTBUFTGXDVQBUFXFUSQURUPZUTZUTXHVAXDWDWPWGXIVBV
      CVDVFWMVGLAXAAXEVHOBUEVIVJVKVLVM $.

    $d f g s F $.  $d g s L $.  $d g s O $.  $d f s T $.
    mapdval.k $e |- ( ph -> ( K e. X /\ W e. H ) ) $.
    mapdval.t $e |- ( ph -> T e. S ) $.
    $( Value of projectivity from vector space H to dual space.  (Contributed
       by NM, 27-Jan-2015.) $)
    mapdval $p |- ( ph -> ( M ` T )
            = { f e. F |
     ( ( O ` ( O ` ( L ` f ) ) ) = ( L ` f ) /\ ( O ` ( L ` f ) ) C_ T ) } ) $=
      ( vs cfv cv wceq wss crab cmpt wcel mapdfval syl fveq1d clfn fvex eqeltri
      wa cvv rabex sseq2 anbi2d rabbidv eqid fvmptg sylancl eqtrd ) ACJUDCUCBEU
      EIUDZKUDZKUDVGUFZVHUCUEZUGZUQZEFUHZUIZUDZVIVHCUGZUQZEFUHZACJVNAHMUJLGUJUQ
      JVNUFUABDEFGHIJKLMUCNOPQRSTUKULUMACBUJVRURUJVOVRUFUBVQEFFDUNUDURQDUNUOUPU
      SUCCVMVRBURVNVJCUFZVLVQEFVSVKVPVIVJCVHUTVAVBVNVCVDVEVF $.

    $d f ph $.
    mapdvalc.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
    $( Value of projectivity from vector space H to dual space.  (Contributed
       by NM, 27-Jan-2015.) $)
    mapdvalc $p |- ( ph -> ( M ` T )
          = { f e. C | ( O ` ( L ` f ) ) C_ T } ) $=
      ( cfv cv wceq wss wa crab mapdval cab anass wb lcfl1lem anbi1i bicomi a1i
      wcel syl5bbr abbidv df-rab 3eqtr4g eqtrd ) ADLUFFUGZKUFZMUFZMUFVGUHZVHDUI
      ZUJZFHUKZVJFBUKZACDEFHIJKLMNOPQRSTUAUBUCUDULAVFHUTZVKUJZFUMVFBUTZVJUJZFUM
      VLVMAVOVQFVOVNVIUJZVJUJZAVQVNVIVJUNVSVQUOAVQVSVPVRVJBGHVFKMUEUPUQURUSVAVB
      VKFHVCVJFBVCVDVE $.
  $}

  ${
    $d v C $.  $d f g F $.  $d f K $.  $d g v L $.  $d v N $.  $d g v O $.
    $d f v T $.  $d v U $.  $d f W $.  $d f v ph $.
    mapdval2.h $e |- H = ( LHyp ` K ) $.
    mapdval2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdval2.s $e |- S = ( LSubSp ` U ) $.
    mapdval2.n $e |- N = ( LSpan ` U ) $.
    mapdval2.f $e |- F = ( LFnl ` U ) $.
    mapdval2.l $e |- L = ( LKer ` U ) $.
    mapdval2.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdval2.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdval2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdval2.t $e |- ( ph -> T e. S ) $.
    mapdval2.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
    $( Value of projectivity from vector space H to dual space.  (Contributed
       by NM, 31-Jan-2015.)  (New usage is discouraged.) $)
    mapdval2N $p |- ( ph
   -> ( M ` T ) = { f e. C | E. v e. T ( O ` ( L ` f ) ) = ( N ` { v } ) } ) $=
      ( cfv cv wss crab csn wceq wrex chlt mapdvalc wcel wa clsa wi c0g dvhlmod
      clmod ad3antrrr simplr eqid islsati syl2anc simprr eqsstr3d adantr simprl
      cbs lspsnel5 mpbird jca ex reximdv2 mpd lss0cl simpr lspsn0 eqtr4d fveq2d
      syl sneq eqeq2d rspcev adantlr a1d lcfl1lem simplbi dochsat0 mpjaodan w3a
      adantl simp3 3ad2ant1 simp2 lspsnel5a eqsstrd rexlimdv3a impbid rabbidva
      eqtrd ) AEMUHGUIZLUHZOUHZEUJZGCUKXHBUIZULZNUHZUMZBEUNZGCUKACDEFGHIJKLMOPU
      OQRSUAUBUCUDUEUFUGUPAXIXNGCAXFCUQZURZXIXNXPXHFUSUHZUQZXIXNUTXHFVAUHZULZUM
      ZXPXRURZXIXNYBXIURZXMBFVMUHZUNZXNYCFVCUQZXRYEAYFXOXRXIAFJKPQRUEVBZVDXPXRX
      IVEBXQXHNYDFVCYDVFZTXQVFZVGVHYCXMXMBYDEYCXJYDUQZXMURZXJEUQZXMURYCYKURZYLX
      MYMYLXLEUJYMXLXHEYCYJXMVIZYBXIYKVEVJYMDENYDFXJYHSTXPYFXRXIYKAYFXOYGVKZVDX
      PEDUQZXRXIYKAYPXOUFVKZVDYCYJXMVLVNVOYNVPVQVRVSVQXPYAURXNXIAYAXNXOAYAURZXS
      EUQZXHXTNUHZUMZXNAYSYAAYFYPYSYGUFDEFXSXSVFZSVTVHVKYRXHXTYTAYAWAYRYFYTXTUM
      AYFYAYGVKNFXSUUBTWBWEWCXMUUABXSEXJXSUMZXLYTXHUUCXKXTNXJXSWFWDWGWHVHWIWJXP
      XQFIXFJKLOPXSQUCRUUBYIUAUBAKUOUQPJUQURXOUEVKXOXFIUQZAXOUUDXHOUHXGUMCHIXFL
      OUGWKWLWPWMWNXPXMXIBEXPYLXMWOZXHXLEXPYLXMWQUUEDENFXJSTXPYLYFXMYOWRXPYLYPX
      MYQWRXPYLXMWSWTXAXBXCXDXE $.

    $d f C $.
    $( Value of projectivity from vector space H to dual space.  (Contributed
       by NM, 31-Jan-2015.)  (New usage is discouraged.) $)
    mapdval3N $p |- ( ph
   -> ( M ` T ) = U_ v e. T { f e. C | ( O ` ( L ` f ) ) = ( N ` { v } ) } ) $=
      ( cfv cv csn wceq wrex crab ciun mapdval2N iunrab syl6eqr ) AEMUHGUILUHOU
      HBUIUJNUHUKZBEULGCUMBEURGCUMUNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUOURBGECU
      PUQ $.
  $}

  ${
    $d v C $.  $d f g v w F $.  $d f K $.  $d g v w L $.  $d v N $.
    $d g v w O $.  $d f v w T $.  $d v w U $.  $d f W $.  $d f v w ph $.
    mapdval4.h $e |- H = ( LHyp ` K ) $.
    mapdval4.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdval4.s $e |- S = ( LSubSp ` U ) $.
    mapdval4.f $e |- F = ( LFnl ` U ) $.
    mapdval4.l $e |- L = ( LKer ` U ) $.
    mapdval4.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdval4.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdval4.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdval4.t $e |- ( ph -> T e. S ) $.
    $( Value of projectivity from vector space H to dual space.  TODO: 1.  This
       is shorter than others - make it the official def?  (but is not as
       obvious that it is ` C_ C ` ) 2.  The unneeded direction of ~ lcfl8a has
       awkward ` E. ` - add another thm with only one direction of it? 3.  Swap
       ` O `` { v } ` and ` L `` f ` ?  (Contributed by NM, 31-Jan-2015.)
       (New usage is discouraged.) $)
    mapdval4N $p |- ( ph
           -> ( M ` T ) = { f e. F | E. v e. T ( O ` { v } ) = ( L ` f ) } ) $=
      ( vg vw cfv cv csn clspn wceq wrex crab eqid mapdval2N wcel wa cab anbi1i
      lcfl1lem anass bitri r19.42v simprr fveq2d simprl chlt adantr lssel sylan
      cbs wss snssd dochocsp 3eqtr3rd eqcomd sneq eqeq2d rspcev syl2anc simpllr
      simpr weq lcfl8a mpbird dochocsn fveq2 sylan9req impbida rexbidva syl5bbr
      jca pm5.32da syl5bb abbidv df-rab 3eqtr4g eqtrd ) ADKUEFUFZJUEZLUEZBUFZUG
      ZEUHUEZUEZUIZBDUJZFUCUFJUEZLUELUEXFUIUCGUKZUKZXALUEZWRUIZBDUJZFGUKZABXGCD
      EFUCGHIJKXBLMNOPXBULZQRSTUAUBXGULZUMAWQXGUNZXEUOZFUPWQGUNZXKUOZFUPXHXLAXP
      XRFXPXQWSLUEZWRUIZXEUOZUOZAXRXPXQXTUOZXEUOYBXOYCXEXGUCGWQJLXNURUQXQXTXEUS
      UTAXQYAXKYAXTXDUOZBDUJAXQUOZXKXTXDBDVAYEYDXJBDYEWTDUNZUOZYDXJYGYDUOZXSXCL
      UEWRXIYHWSXCLYGXTXDVBVCYGXTXDVDYHEHIXBLEVIUEZMXANOSYIULZXMYGIVEUNMHUNUOZY
      DYEYKYFAYKXQUAVFVFZVFYGXAYIVJYDYGWTYIYEDCUNZYFWTYIUNZAYMXQUBVFCDYIEWTYJPV
      GVHZVKVFVLVMYGXJUOZXTXDYPXTWRUDUFZUGZLUEZUIZUDYIUJZYPYNWRXIUIZUUAYGYNXJYO
      VFYPXIWRYGXJVTVNYTUUBUDWTYIUDBWAZYSXIWRUUCYRXALYQWTVOVCVPVQVRYPUDEGWQHIJL
      YIMNSOYJQRYGYKXJYLVFAXQYFXJVSWBWCYPXCWSYGXJXCXILUEWSYGEHIXBLYIMWTNOSYJXMY
      LYOWDXIWRLWEWFVNWJWGWHWIWKWLWMXEFXGWNXKFGWNWOWP $.

    $( Value of projectivity from vector space H to dual space.  (Contributed
       by NM, 31-Jan-2015.)  (New usage is discouraged.) $)
    mapdval5N $p |- ( ph
           -> ( M ` T ) = U_ v e. T { f e. F | ( O ` { v } ) = ( L ` f ) } ) $=
      ( cfv cv csn wceq wrex crab ciun mapdval4N iunrab syl6eqr ) ADKUCBUDUELUC
      FUDJUCUFZBDUGFGUHBDUMFGUHUIABCDEFGHIJKLMNOPQRSTUAUBUJUMBFDGUKUL $.
  $}

  ${
    $d g F $.  $d g J $.  $d g L $.  $d g O $.  $d g Y $.
    mapdordlem1a.h $e |- H = ( LHyp ` K ) $.
    mapdordlem1a.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdordlem1a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdordlem1a.v $e |- V = ( Base ` U ) $.
    mapdordlem1a.y $e |- Y = ( LSHyp ` U ) $.
    mapdordlem1a.f $e |- F = ( LFnl ` U ) $.
    mapdordlem1a.l $e |- L = ( LKer ` U ) $.
    mapdordlem1a.t $e |- T = { g e. F | ( O ` ( O ` ( L ` g ) ) ) e. Y } $.
    mapdordlem1a.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) )
           = ( L ` g ) } $.
    mapdordlem1a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Lemma for ~ mapdord .  (Contributed by NM, 27-Jan-2015.) $)
    mapdordlem1a $p |- ( ph -> ( J e. T
          <-> ( J e. C /\ ( O ` ( O ` ( L ` J ) ) ) e. Y ) ) ) $=
      ( wcel wa wceq simprr chlt adantr simprl dochlkr mpbid simpld ex pm4.71rd
      cfv fveq2 fveq2d eleq1d elrab2 lcfl1lem anbi1i anass an12 3bitri 3bitr4g
      cv ) AHFUEZHJUQZKUQZKUQZNUEZUFZVLVJUGZVNUFZHCUEHBUEZVMUFZAVNVOAVNVOAVNUFZ
      VOVJNUEZVSVMVOVTUFAVIVMUHVSDFHGIJKMNOPQTSUAAIUIUEMGUEUFVNUDUJAVIVMUKULUMU
      NUOUPEVHZJUQZKUQZKUQZNUEVMEHFCWAHUGZWDVLNWEWCVKKWEWBVJKWAHJURUSUSUTUBVAVR
      VIVOUFZVMUFVIVOVMUFUFVPVQWFVMBEFHJKUCVBVCVIVOVMVDVIVOVMVEVFVG $.
  $}

  ${
    $d g F $.  $d g J $.  $d g L $.  $d g O $.
    mapdordlem1b.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) )
           = ( L ` g ) } $.
    $( Lemma for ~ mapdord .  (Contributed by NM, 27-Jan-2015.)
       (New usage is discouraged.) $)
    mapdordlem1bN $p |- ( J e. C
          <-> ( J e. F /\ ( O ` ( O ` ( L ` J ) ) ) = ( L ` J ) ) ) $=
      ( lcfl1lem ) ABCDEFGH $.
  $}

  ${
    $d g F $.  $d g J $.  $d g L $.  $d g O $.  $d g Y $.
    mapdordlem1.t $e |- T = { g e. F | ( O ` ( O ` ( L ` g ) ) ) e. Y } $.
    $( Lemma for ~ mapdord .  (Contributed by NM, 27-Jan-2015.) $)
    mapdordlem1 $p |- ( J e. T
          <-> ( J e. F /\ ( O ` ( O ` ( L ` J ) ) ) e. Y ) ) $=
      ( cv cfv wcel wceq fveq2 fveq2d eleq1d elrab2 ) BIZEJZFJZFJZGKDEJZFJZFJZG
      KBDCAQDLZTUCGUDSUBFUDRUAFQDEMNNOHP $.
  $}

  ${
    $d f g K $.  $d p S $.  $d f g p U $.  $d f g W $.
    mapdord.h $e |- H = ( LHyp ` K ) $.
    mapdord.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdord.s $e |- S = ( LSubSp ` U ) $.
    mapdord.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdord.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdord.x $e |- ( ph -> X e. S ) $.
    mapdord.y $e |- ( ph -> Y e. S ) $.
    ${
      $d f p A $.  $d f g F $.  $d g J $.  $d f g p L $.  $d f g p O $.
      $d p T $.  $d f p X $.  $d f p Y $.  $d f p ph $.
      mapdord.o $e |- O = ( ( ocH ` K ) ` W ) $.
      mapdord.a $e |- A = ( LSAtoms ` U ) $.
      mapdord.f $e |- F = ( LFnl ` U ) $.
      mapdord.c $e |- J = ( LSHyp ` U ) $.
      mapdord.l $e |- L = ( LKer ` U ) $.
      mapdord.t $e |- T = { g e. F | ( O ` ( O ` ( L ` g ) ) ) e. J } $.
      mapdord.q $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
      $( Lemma for ~ mapdord .  Ordering property of projectivity ` M ` .
         TODO:  This was proved using some hacked-up older proofs.  Maybe
         simplify; get rid of the ` T ` hypothesis.  (Contributed by NM,
         27-Jan-2015.) $)
      mapdordlem2 $p |- ( ph -> ( ( M ` X ) C_ ( M ` Y ) <-> X C_ Y ) ) $=
        ( vf vp cfv wss cv crab chlt mapdvalc sseq12d wral ss2rab wcel cbs eqid
        wi wa mapdordlem1a simprl idd embantd ex sylbid ralimdv2 syl5bi dvhlmod
        lssatle mapdordlem1 simprbi adantl adantr simplbi dochlkr simpld simprd
        com23 wceq mpbid dochshpsat wex clvec dvhlvec simpr dochsatshp lshpkrex
        wrex syl2anc df-rex sylib simprr fveq2d crn clmod lsatssv dochcl dochoc
        cdih eqtrd eqeltrd sylanbrc dih1dimat eqtr2d jca eximdv sylibr wb sseq1
        mpd imbi12d ralxfrd bitr2d sylibd simplr sstr ancoms a1i mpand ss2rabdv
        impbid bitrd ) APMUNZQMUNZUOULUPZLUNZNUNZPUOZULCUQZYOQUOZULCUQZUOZPQUOZ
        AYKYQYLYSACDPFULGHIKLMNOURRSTUGUIUEUAUBUCUKUSACDQFULGHIKLMNOURRSTUGUIUE
        UAUBUDUKUSUTAYTUUAAYTYPYRVFZULEVAZUUAYTUUBULCVAAUUCYPYRULCVBAUUBUUBULCE
        AYMEVCZYMCVCZUUBVFZUUBAUUDUUEYONUNZJVCZVGZUUFUUBVFZACEFGHIYMKLNFVDUNZOJ
        RUESUUKVEZUHUGUIUJUKUBVHAUUIUUJAUUIVGZUUEUUBUUBAUUEUUHVIUUMUUBVJVKVLVMW
        FVNVOAUUAUMUPZPUOZUUNQUOZVFZUMBVAUUCABDPQFUMTUFAFIKORSUBVPZUCUDVQAUUQUU
        BUMULYOBEAUUDVGZUUGYNWGZYOBVCUUSUUTYNJVCZUUSUUHUUTUVAVGUUDUUHAUUDYMHVCZ
        UUHEGHYMLNJUJVRZVSVTUUSFHYMIKLNOJRUESUGUHUIAKURVCOIVCVGZUUDUBWAZUUDUVBA
        UUDUVBUUHUVCWBVTWCWHZWDUUSBFIKNOYNJRUESUFUHUVEUUSUUTUVAUVFWEWIWHAUUNBVC
        ZVGZUUDUUNYOWGZVGZULWJZUVIULEWPUVHUVBYNUUNNUNZWGZVGZULWJZUVKUVHUVMULHWP
        ZUVOUVHFWKVCZUVLJVCZUVPAUVQUVGAFIKORSUBWLWAUVHBUUNFIKNOJRSUEUFUHAUVDUVG
        UBWAZAUVGWMZWNZUVLULHJLFUHUGUIWOWQUVMULHWRWSUVHUVNUVJULUVHUVNUVJUVHUVNV
        GZUUDUVIUWBUVBUUHUUDUVHUVBUVMVIUWBUUGUVLJUWBUUGUVLNUNZNUNZUVLUWBYOUWCNU
        WBYNUVLNUVHUVBUVMWTXAZXAUVHUWDUVLWGZUVNUVHUVDUVLOKXGUNUNZXBZVCZUWFUVSUV
        HUVDUUNUUKUOUWIUVSUVHBUUNUUKFUULUFAFXCVCUVGUURWAUVTXDFIUWGKNUUKOUUNRUWG
        VEZSUULUEXEWQIUWGKNOUVLRUWJUEXFWQWAXHUVHUVRUVNUWAWAXIUVCXJUWBYOUWCUUNUW
        EUVHUWCUUNWGZUVNUVHUVDUUNUWHVCZUWKUVSUVHUVDUVGUWLUVSUVTBUUNFIUWGKORSUWJ
        UFXKWQIUWGKNOUUNRUWJUEXFWQWAXLXMVLXNXRUVIULEWRXOUVIUUQUUBXPAUVIUUOYPUUP
        YRUUNYOPXQUUNYOQXQXSVTXTYAYBAUUAYTAUUAVGZYPYRULCUWMUUEVGZUUAYPYRAUUAUUE
        YCUUAYPVGYRVFUWNYPUUAYRYOPQYDYEYFYGYHVLYIYJ $.
    $}

    $( Ordering property of the map defined by ~ df-mapd .  Property (b) of
       [Baer] p. 40.  (Contributed by NM, 27-Jan-2015.) $)
    mapdord $p |- ( ph -> ( ( M ` X ) C_ ( M ` Y ) <-> X C_ Y ) ) $=
      ( vg cfv crab eqid clsa cv clk coch wceq clfn clsh wcel mapdordlem2 ) ACU
      ARZQUBCUCRZRZGEUDRRZRUMRZULUEQCUFRZSZBUNCUGRZUHQUOSZCQUODUQEUKFUMGHIJKLMN
      OPUMTUJTUOTUQTUKTURTUPTUI $.

    $( The map defined by ~ df-mapd is one-to-one.  Property (c) of [Baer]
       p. 40.  (Contributed by NM, 12-Mar-2015.) $)
    mapd11 $p |- ( ph -> ( ( M ` X ) = ( M ` Y ) <-> X = Y ) ) $=
      ( cfv wss wa wceq mapdord anbi12d eqss 3bitr4g ) AHFQZIFQZRZUFUERZSHIRZIH
      RZSUEUFTHITAUGUIUHUJABCDEFGHIJKLMNOPUAABCDEFGIHJKLMNPOUAUBUEUFUCHIUCUD $.
  $}

  ${
    $d f D $.  $d f K $.  $d f R $.  $d f U $.  $d f W $.
    mapddlss.h $e |- H = ( LHyp ` K ) $.
    mapddlss.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapddlss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapddlss.s $e |- S = ( LSubSp ` U ) $.
    mapddlss.d $e |- D = ( LDual ` U ) $.
    mapddlss.t $e |- T = ( LSubSp ` D ) $.
    mapddlss.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapddlss.r $e |- ( ph -> R e. S ) $.
    $( The mapping of a subspace of vector space H to the dual space is a
       subspace of the dual space.  TODO:  Make this obsolete, use ~ mapdcl2
       instead.  (Contributed by NM, 31-Jan-2015.)
       (New usage is discouraged.) $)
    mapddlssN $p |- ( ph -> ( M ` R ) e. T ) $=
      ( vf cfv cv clk coch wceq wss clfn crab chlt eqid mapdval lclkrs eqeltrd
      wa ) ACITSUAFUBTZTZJHUCTTZTZUPTUOUDUQCUEUMSFUFTZUGZEADCFSURGHUNIUPJUHKMNU
      RUIZUNUIZUPUIZLQRUJAUSBCDEFSURGHUNUPJKVBMNUTVAOPUSUIQRUKUL $.
  $}

  ${
    $d f F $.  $d f K $.  $d f N $.  $d f W $.  $d f X $.  $d f ph $.
    mapdsn.h $e |- H = ( LHyp ` K ) $.
    mapdsn.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdsn.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdsn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdsn.v $e |- V = ( Base ` U ) $.
    mapdsn.n $e |- N = ( LSpan ` U ) $.
    mapdsn.f $e |- F = ( LFnl ` U ) $.
    mapdsn.l $e |- L = ( LKer ` U ) $.
    mapdsn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdsn.x $e |- ( ph -> X e. V ) $.
    $( Value of the map defined by ~ df-mapd at the span of a singleton.
       (Contributed by NM, 16-Feb-2015.) $)
    mapdsn $p |- ( ph
     -> ( M ` ( N ` { X } ) ) = { f e. F | ( O ` { X } ) C_ ( L ` f ) } ) $=
      ( csn cfv cv wceq wss wa crab clss chlt eqid wcel dvhlmod lspsncl syl2anc
      clmod mapdval ad2antrr snssd lspssv simprr dochss syl3anc dochocsp simprl
      3sstr3d simplr simpr lcfl9a lkrssv dochocsn sseqtrd jca impbida rabbidva
      eqtrd ) AMUDZIUEZHUECUFZGUEZJUEZJUEZWBUGZWCVTUHZUIZCDUJVSJUEZWBUHZCDUJABU
      KUEZVTBCDEFGHJLULNQWJUMZTUAOPUBABURUNZMKUNZVTWJUNABEFLNQUBUOZUCWJIKBMRWKS
      UPUQUSAWGWICDAWADUNZUIZWGWIWPWGUIZVTJUEZWDWHWBWQFULUNLEUNUIZVTKUHZWFWRWDU
      HAWSWOWGUBUTAWTWOWGAWLVSKUHWTWNAMKUCVAZVSIKBRSVBUQUTWPWEWFVCBEFJKLWCVTNQR
      OVDVEAWRWHUGWOWGABEFIJKLVSNQORSUBXAVFUTWPWEWFVGVHWPWIUIZWEWFXBBDWAEFGJKLM
      NOQRTUAAWSWOWIUBUTZAWOWIVIZAWMWOWIUCUTWPWIVJZVKXBWCWHJUEZVTXBWSWBKUHWIWCX
      FUHXCXBDWAGKBRTUAAWLWOWIWNUTXDVLXEBEFJKLWHWBNQROVDVEAXFVTUGWOWIABEFIJKLMN
      QORSUBUCVMUTVNVOVPVQVR $.

    mapdsn2.e $e |- ( ph -> ( L ` G ) = ( O ` { X } ) ) $.
    $( Value of the map defined by ~ df-mapd at the span of a singleton.
       (Contributed by NM, 16-Feb-2015.) $)
    mapdsn2 $p |- ( ph
     -> ( M ` ( N ` { X } ) ) = { f e. F | ( L ` G ) C_ ( L ` f ) } ) $=
      ( csn cfv cv wss crab mapdsn sseq1d rabbidv eqtr4d ) ANUFZJUGIUGUOKUGZCUH
      HUGZUIZCDUJEHUGZUQUIZCDUJABCDFGHIJKLMNOPQRSTUAUBUCUDUKAUTURCDAUSUPUQUEULU
      MUN $.
  $}

  ${
    $d f D $.  $d f F $.  $d f G $.  $d f K $.  $d f N $.  $d f P $.  $d f W $.
    $d f X $.  $d f ph $.
    mapdsn3.h $e |- H = ( LHyp ` K ) $.
    mapdsn3.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdsn3.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdsn3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdsn3.v $e |- V = ( Base ` U ) $.
    mapdsn3.n $e |- N = ( LSpan ` U ) $.
    mapdsn3.f $e |- F = ( LFnl ` U ) $.
    mapdsn3.l $e |- L = ( LKer ` U ) $.
    mapdsn3.d $e |- D = ( LDual ` U ) $.
    mapdsn3.p $e |- P = ( LSpan ` D ) $.
    mapdsn3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdsn3.x $e |- ( ph -> X e. V ) $.
    mapdsn3.g $e |- ( ph -> G e. F ) $.
    mapdsn3.e $e |- ( ph -> ( L ` G ) = ( O ` { X } ) ) $.
    $( Value of the map defined by ~ df-mapd at the span of a singleton.
       (Contributed by NM, 17-Feb-2015.) $)
    mapdsn3 $p |- ( ph -> ( M ` ( N ` { X } ) ) = ( P ` { G } ) ) $=
      ( vf csn cfv cv wss crab mapdsn2 dvhlvec ldual1dim eqtr4d ) AOUKKULJULFIU
      LUJUMIULUNUJEUOFUKCULADUJEFGHIJKLMNOPQRSTUAUBUCUFUGUIUPABUJEFICDUBUCUDUEA
      DGHNPSUFUQUHURUS $.
  $}

  ${
    $d f v F $.  $d f K $.  $d v L $.  $d v O $.  $d f v Q $.  $d v U $.
    $d f W $.  $d f v ph $.
    mapd1dim2.h $e |- H = ( LHyp ` K ) $.
    mapd1dim2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapd1dim2.a $e |- A = ( LSAtoms ` U ) $.
    mapd1dim2.f $e |- F = ( LFnl ` U ) $.
    mapd1dim2.l $e |- L = ( LKer ` U ) $.
    mapd1dim2.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapd1dim2.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapd1dim2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapd1dim2.t $e |- ( ph -> Q e. A ) $.
    $( Value of the map defined by ~ df-mapd at an atom.  (Contributed by NM,
       10-Feb-2015.)  (New usage is discouraged.) $)
    mapd1dim2lem1N $p |- ( ph
           -> ( M ` Q ) = { f e. F | E. v e. Q ( O ` { v } ) = ( L ` f ) } ) $=
      ( clss cfv eqid dvhlmod lsatlssel mapdval4N ) ABEUCUDZDEFGHIJKLMNOUIUEZQR
      STUAACUIDEUJPAEHIMNOUAUFUBUGUH $.

    mapd1dim2.d $e |- D = ( LDual ` U ) $.
    mapd1dim2.b $e |- B = ( LSAtoms ` D ) $.
    $( Value of the map defined by ~ df-mapd at an atom.  $)
$(
     mapd1dim2 $p |- ( ph -> ( M ` Q ) e. B ) $=
      ( dvhlmod lduallmod eqid islsat syl mpbird ) ??????????UCAFHIMNOUAUEUF?
      ????????UGZUKUKUDUHUIUJ $.
  $)
  $}

  ${
    $d f v F $.  $d f K $.  $d v L $.  $d v O $.  $d f v Q $.  $d v U $.
    $d f W $.  $d f v ph $.
    mapd1dim3.h $e |- H = ( LHyp ` K ) $.
    mapd1dim3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapd1dim3.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapd1dim3.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapd1dim3.v $e |- V = ( Base ` U ) $.
    mapd1dim3.n $e |- N = ( LSpan ` U ) $.
    mapd1dim3.f $e |- F = ( LFnl ` U ) $.
    mapd1dim3.l $e |- L = ( LKer ` U ) $.
    mapd1dim3.d $e |- D = ( LDual ` U ) $.
    mapd1dim3.j $e |- J = ( LSpan ` D ) $.
    mapd1dim3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapd1dim3.t $e |- ( ph -> X e. V ) $.
    mapd1dim3.g $e |- ( ph -> G e. F ) $.
    mapd1dim3.e $e |- ( ph -> ( L ` G ) = ( O ` { X } ) ) $.
    $( Value of the map defined by ~ df-mapd at the span of a singleton.  $)
$(
     mapd1dim3 $p |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { G } ) ) $=
      ( vf csn cfv cv wss crab eqtrd sseq1d rabbidv eqcomd dvhlvec ldual1dim
      ) AOUKKULJULEIULUJUMIULUNUJDUOZEUKGULZ??????????UP????????????UIUQURUSUP
      AVCVBABUJDEIGCUBUCUDUEACFHNPQUFUTUHVAUSUP $.
  $)
  $}

  ${
    mapdrval.h $e |- H = ( LHyp ` K ) $.
    mapdrval.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdrval.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdrval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdrval.s $e |- S = ( LSubSp ` U ) $.
    mapdrval.f $e |- F = ( LFnl ` U ) $.
    mapdrval.l $e |- L = ( LKer ` U ) $.
    mapdrval.d $e |- D = ( LDual ` U ) $.
    mapdrval.t $e |- T = ( LSubSp ` D ) $.
    mapdrval.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
    mapdrval.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdrval.r $e |- ( ph -> R e. T ) $.
    mapdrval.e $e |- ( ph -> R C_ C ) $.
    ${
      $d f i C $.  $d i D $.  $d f g F $.  $d f K $.  $d g h i L $.
      $d g h i O $.  $d f i Q $.  $d f h i R $.  $d g i U $.  $d i V $.
      $d f W $.  $d f i ph $.
      mapdrval.q $e |- Q = U_ h e. R ( O ` ( L ` h ) ) $.
      ${
        $d h r x C $.  $d r F $.  $d r x L $.  $d h r N $.  $d r x O $.
        $d h r x Q $.  $d r x R $.  $d h r x U $.  $d h r x V $.  $d h r x Y $.
        $d h r .0. $.  $d h r x ph $.  $d f g r x $.
        mapdrval.v $e |- V = ( Base ` U ) $.
        mapdrvallem2.a $e |- A = ( LSAtoms ` U ) $.
        mapdrvallem2.n $e |- N = ( LSpan ` U ) $.
        mapdrvallem2.z $e |- .0. = ( 0g ` U ) $.
        mapdrvallem2.y $e |- Y = ( 0g ` D ) $.
        $( Lemma for ~~? mapdrval .  TODO: very long antecendents are dragged
           through proof in some places - see if it shortens proof to remove
           unused conjuncts.  (Contributed by NM, 2-Feb-2015.) $)
        mapdrvallem2 $p |- ( ph
                 -> { f e. C | ( O ` ( L ` f ) ) C_ Q } C_ R ) $=
          ( vx vr cv cfv wss wcel w3a eleq1 wne wa wceq cdif wrex chlt 3ad2ant1
          csn adantr simpl2 simpr eldifsn sylanbrc lcfl8b cvsca co wex csca cbs
          ciun simp1l3 eqimss2 3ad2ant3 clmod dvhlmod lcfl1lem simplbi 3ad2ant2
          wb lkrssv dochlss syl2anc eldifi lspsnel5 mpbird syl6eleq eliun sylib
          sseldd eqid clvec dvhlvec ad2antrr simp1l1 syl sseld syl6 mpd simpll3
          lspsnel5a simpll2 lsatlspsn dochsat0 lsatcmp2 mpbid eqtr2d crn sselda
          cdih lcfl5 simp1l2 doch11 eqlkr4 reximdva reximi rexcom df-rex rexbii
          ex wi bitri simplr simprl ldualssvscl bi2 ad2antll exlimdv rexlimdv3a
          rexlimdva lduallmod lss0cl pm2.61ne rabssdv ) AJVEZPVFZSVFZEVGZJCFAUU
          NCVHZUUQVIZUUNFVHZUBFVHZUUNUBUUNUBFVJUUSUUNUBVKZVLZUUPVCVEZVRRVFZVMZV
          CTUCVRZVNZVOUUTUVCVCCDIKMUUNNOPRSTUAUBUCUDUEUGURUTVAUIUJUKVBUMUUSOVPV
          HUANVHVLZUVBAUURUVIUUQUNVQVSZUVCUURUVBUUNCUBVRVNVHAUURUUQUVBVTUUSUVBW
          AUUNCUBWBWCWDUVCUVFUUTVCUVHUVCUVDUVHVHZUVFVIZLVEZFVHZUUTVDVEZUVMDWEVF
          ZWFZFVHZWSZVLZLWGZVDIWHVFZWIVFZVOZUUTUVLUUNUVQVMZVDUWCVOZLFVOZUWDUVLU
          VDUVMPVFZSVFZVHZLFVOZUWGUVLUVDLFUWIWJZVHUWKUVLUVDEUWLUVLUUPEUVDAUURUU
          QUVBUVKUVFWKUVLUVDUUPVHUVEUUPVGZUVFUVCUWMUVKUVEUUPWLWMUVLGUUPRTIUVDUR
          UHUTUVCUVKIWNVHZUVFUUSUWNUVBAUURUWNUUQAINOUAUDUGUNWOZVQVSZVQZUVLUVIUU
          OTVGUUPGVHUVCUVKUVIUVFUVJVQZUVLMUUNPTIURUIUJUWQUVCUVKUUNMVHZUVFUUSUWS
          UVBUURAUWSUUQUURUWSUUPSVFUUOVMCKMUUNPSUMWPWQWRVSVQZWTGINOSTUAUUOUDUGU
          RUHUEXAXBUVKUVCUVDTVHUVFUVDTUVGXCWRXDXEXIUQXFLUVDFUWIXGXHUVLUWJUWFLFU
          VLUVNVLZUWJUWFUXAUWJVLZDUWCUWBUVPMUVMUUNPIVDUWBXJZUWCXJZUIUJUKUVPXJZU
          VLIXKVHZUVNUWJUVCUVKUXFUVFUUSUXFUVBAUURUXFUUQAINOUAUDUGUNXLVQVSVQXMZU
          XAUVMMVHZUWJUXAUVNUXHUVLUVNWAUXAUVNUVMCVHZUXHUXAFCUVMUXAAFCVGZUVLAUVN
          AUURUUQUVBUVKUVFXNZVSUPXOXPUXIUXHUWISVFUWHVMCKMUVMPSUMWPWQXQXRVSZUVLU
          WSUVNUWJUWTXMZUXBUWIUUPVMUWHUUOVMUXBUUPUVEUWIUVCUVKUVFUVNUWJXSUXBUVEU
          WIVGUVEUWIVMUXBGUWIRIUVDUHUTUVLUWNUVNUWJUWQXMZUXBUVIUWHTVGUWIGVHUVLUV
          IUVNUWJUWRXMZUXBMUVMPTIURUIUJUXNUXLWTGINOSTUAUWHUDUGURUHUEXAXBUXAUWJW
          AXTUXBBUVEUWIIUCVAUSUXGUXBBRTIUVDUCURUTVAUSUXNUVCUVKUVFUVNUWJYAYBUXBB
          IMUVMNOPSUAUCUDUEUGVAUSUIUJUXOUXLYCYDYEYFUXBNUAOYIVFVFZOSUAUWHUUOUDUX
          PXJZUEUXOUXBUXIUWHUXPYGZVHUXAUXIUWJUVLFCUVMUVLAUXJUXKUPXOYHVSUXBCIKMU
          VMNUXPOPSUAUDUXQUEUGUIUJUMUXOUXLYJYEUXBUURUUOUXRVHUVLUURUVNUWJAUURUUQ
          UVBUVKUVFYKXMUXBCIKMUUNNUXPOPSUAUDUXQUEUGUIUJUMUXOUXMYJYEYLYEYMYSYNXR
          UWGUVSVDUWCVOZLFVOZUWDUWFUXSLFUWEUVSVDUWCUUNUVQFVJYOYOUXTUVSLFVOZVDUW
          CVOUWDUVSLVDFUWCYPUYAUWAVDUWCUVSLFYQYRUUAXHXOUVCUVKUWDUUTYTUVFUVCUWAU
          UTVDUWCUVCUVOUWCVHZVLZUVTUUTLUYCUVTUUTUYCUVTVLZUVRUUTUYDDUWBHUVPFUWCI
          UVOUVMUXCUXDUKUXEULUVCUWNUYBUVTUWPXMUVCFHVHZUYBUVTUUSUYEUVBAUURUYEUUQ
          UOVQZVSXMUVCUYBUVTUUBUYCUVNUVSUUCUUDUVSUVRUUTYTUYCUVNUUTUVRUUEUUFXRYS
          UUGUUIVQXRUUHXRUUSDWNVHZUYEUVAAUURUYGUUQADIUKUWOUUJVQUYFHFDUBVBULUUKX
          BUULUUM $.

        $( Lemma for ~~? mapdrval .  (Contributed by NM, 2-Feb-2015.) $)
        mapdrvallem3 $p |- ( ph -> { f e. C | ( O ` ( L ` f ) ) C_ Q } = R ) $=
          ( cv cfv wss crab mapdrvallem2 wcel wa ciun weq fveq2d ssiun2s adantl
          fveq2 syl6sseqr ssrabdv eqssd ) AJVCZPVDZSVDZEVEZJCVFFABCDEFGHIJKLMNO
          PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVGAWBJCFUPAVSFVHZVIW
          ALFLVCZPVDZSVDZVJZEWCWAWGVEALFWFVSWALJVKWEVTSWDVSPVOVLVMVNUQVPVQVR $.
      $}

      $( Given a dual subspace ` R ` (of functionals with closed kernels),
         reconstruct the subspace ` Q ` that maps to it.  (Contributed by NM,
         12-Mar-2015.) $)
      mapdrval $p |- ( ph -> ( M ` Q ) = R ) $=
        ( vf vi cfv cv wss crab chlt lcfr mapdvalc clsa clspn cbs c0g weq fveq2
        ciun fveq2d cbviunv eqtri eqid mapdrvallem3 eqtrd ) ADOUNULUONUNPUNDUPU
        LBUQEABFDHULIKLMNOPQURRUAUBUCUDSTUHABCDEFGHIJKLMNPQRSUAUBUCUDUEUFUGUKUH
        UIUJUSUGUTAHVAUNZBCDEFGHULIUMKLMNOHVBUNZPHVCUNZQCVDUNZHVDUNZRSTUAUBUCUD
        UEUFUGUHUIUJDJEJUOZNUNZPUNZVGUMEUMUOZNUNZPUNZVGUKJUMEWAWDJUMVEVTWCPVSWB
        NVFVHVIVJVPVKVNVKVOVKVRVKVQVKVLVM $.
    $}

    mapdrval2.v $e |- V = ( Base ` U ) $.
    mapdrval2.q $e |- Q = { v e. V | E. f e. R ( L ` f ) = ( O ` { v } ) } $.
    $( Given a dual subspace ` R ` (of functionals with closed
       kernels), construct a subspace ` Q ` that
       maps to it. $)
$(
     mapdrval2 $p |- ( ph -> ( M ` Q ) = R ) $=
      ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?  mapdrval.h  mapdrval.u ? eqid
      mapdrval.f
       mapdrval.l  mapdrval.o  mapdrval.m  mapdrval.k ?  mapdval4N ? eqtrd $.
$)
  $}

  ${
    $d c f t C $.  $d f D $.  $d f g F $.  $d f g t K $.  $d c f g L $.
    $d c t u M $.  $d c f g O $.  $d c t u S $.  $d c f t T $.  $d f g U $.
    $d f g t W $.  $d c f t u ph $.
    mapd1o.h $e |- H = ( LHyp ` K ) $.
    mapd1o.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapd1o.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapd1o.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapd1o.s $e |- S = ( LSubSp ` U ) $.
    mapd1o.f $e |- F = ( LFnl ` U ) $.
    mapd1o.l $e |- L = ( LKer ` U ) $.
    mapd1o.d $e |- D = ( LDual ` U ) $.
    mapd1o.t $e |- T = ( LSubSp ` D ) $.
    mapd1o.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
    mapd1o.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The map defined by ~ df-mapd is one-to-one and onto the set of dual
       subspaces of functionals with closed kernels.  This shows ` M `
       satisfies part of the definition of projectivity of [Baer] p. 40.  TODO:
       change theorems leading to this ( ~ lcfr , ~ mapdrval , ~ lclkrs ,
       ~ lclkr ,...) to use ` T i^i ~P C ` ?  TODO: maybe get rid of $d's for
       ` g ` vs. ` K U W ` ,. propagate to ~ mapdrn and any others.
       (Contributed by NM, 12-Mar-2015.) $)
    mapd1o $p |- ( ph -> M : S -1-1-onto-> ( T i^i ~P C ) ) $=
      ( vt vu vf vc wfn crn cpw cin wceq cv cfv weq wi wral wf1o crab cmpt clfn
      wss wa cvv fvex eqeltri rabex eqid fnmpti chlt mapdfval syl fneq1d mpbiri
      wcel wrex wb fvelrnb adantr simpr mapdval lclkrs2 elin elpw anbi2i bitr2i
      sylib eleq1 syl5ibcom rexlimdva ciun inss1 sseli adantl inss2 elpwid lcfr
      eqeltrd mapdrval fveq2 eqeq1d rspcev syl2anc ex impbid bitrd eqrdv simprl
      simprr mapd11 biimpd ralrimivva dff1o6 syl3anbrc ) ALDUJZLUKZEBULZUMZUNUF
      UOZLUPUGUOZLUPUNZUFUGUQZURZUGDUSUFDUSDXTLUTAXQUFDUHUOKUPZMUPZMUPYFUNZYGYA
      VDVEZUHHVAZVBZDUJUFDYJYKYIUHHHFVCUPVFTFVCVGVHZVIYKVJVKADLYKAJVLVQNIVQVEZL
      YKUNUEDFUHHIJKLMNVLUFORSTUAPQVMVNVOVPAUFXRXTAYAXRVQZUIUOZLUPZYAUNZUIDVRZY
      AXTVQZAXQYNYRVSAXQUFDGUOKUPZMUPZMUPYTUNUUAYAVDVEZGHVAZVBZDUJUFDUUCUUDUUBG
      HYLVIUUDVJVKADLUUDAYMLUUDUNUEDFGHIJKLMNVLUFORSTUAPQVMVNVOVPUIDYALVTVNAYRY
      SAYQYSUIDAYODVQZVEZYPXTVQYQYSUUFYPYHYGYOVDVEZUHHVAZXTUUFDYOFUHHIJKLMNVLOR
      STUAPQAYMUUEUEWAZAUUEWBZWCUUFUUHEVQZUUHBVDZVEZUUHXTVQZUUFBCYOUUHDEFGUHHIJ
      KMNOPRSTUAUBUCUDUUHVJUUIUUJWDUUNUUKUUHXSVQZVEUUMUUHEXSWEUUOUULUUKUUHBUUGU
      HHYLVIWFWGWHWIWTYPYAXTWJWKWLAYSYRAYSVEZUHYAYGWMZDVQUUQLUPZYAUNZYRUUPBCUUQ
      YADEFGUHHIJKMNOPRSTUAUBUCUDUUQVJZAYMYSUEWAZYSYAEVQAXTEYAEXSWNWOWPZYSYABVD
      AYSYABXTXSYAEXSWQWOWRWPZWSUUPBCUUQYADEFGUHHIJKLMNOPQRSTUAUBUCUDUVAUVBUVCU
      UTXAYQUUSUIUUQDYOUUQUNYPUURYAYOUUQLXBXCXDXEXFXGXHXIAYEUFUGDDAYADVQZYBDVQZ
      VEZVEZYCYDUVGDFIJLNYAYBORSQAYMUVFUEWAAUVDUVEXJAUVDUVEXKXLXMXNUFUGDXTLXOXP
      $.
  $}

  ${
    $d g F $.  $d g K $.  $d g L $.  $d g O $.  $d g U $.  $d g W $.
    mapdrn.h $e |- H = ( LHyp ` K ) $.
    mapdrn.o $e |- O = ( ( ocH ` K ) ` W ) $.
    mapdrn.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdrn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdrn.f $e |- F = ( LFnl ` U ) $.
    mapdrn.l $e |- L = ( LKer ` U ) $.
    ${
      mapdrn.d $e |- D = ( LDual ` U ) $.
      mapdrn.t $e |- T = ( LSubSp ` D ) $.
      mapdrn.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
      mapdrn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
      $( Range of the map defined by ~ df-mapd .  (Contributed by NM,
         12-Mar-2015.) $)
      mapdrn $p |- ( ph -> ran M = ( T i^i ~P C ) ) $=
        ( clss cfv cpw cin wf1o wfo crn wceq eqid mapd1o f1ofo forn 3syl ) AEUD
        UEZDBUFUGZKUHUQURKUIKUJURUKABCUQDEFGHIJKLMNOPQUQULRSTUAUBUCUMUQURKUNUQU
        RKUOUP $.
    $}

    mapdunirn.c $e |- C = { g e. F | ( O ` ( O ` ( L ` g ) ) ) = ( L ` g ) } $.
    mapdunirn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Union of the range of the map defined by ~ df-mapd .  (Contributed by
       NM, 13-Mar-2015.)  (New usage is discouraged.) $)
    mapdunirnN $p |- ( ph -> U. ran M = C ) $=
      ( cfv crn cuni cld clss cpw cin mapdrn unieqd uniin cbs dvhlmod lduallmod
      eqid lssuni clmod ldualvbase eqtrd wceq unipw a1i ineq12d wss crab ssrab2
      cv eqsstri dfss1 mpbi syl5sseq wcel lclkr cvv clfn fvex eqeltri pwid elin
      rabex sylanbrc elssuni syl eqssd ) AIUAZUBCUCTZUDTZBUEZUFZUBZBAWCWGABWDWE
      CDEFGHIJKLMNOPQWDUMZWEUMZRSUGUHAWHBAWEUBZWFUBZUFZWHBWEWFUIAWMEBUFZBAWKEWL
      BAWKWDUJTZEAWEWOWDWOUMZWJAWDCWIACFGKLOSUKZULUNAWDEWOCUOPWIWPWQUPUQWLBURAB
      USUTVAWNBURZABEVBWRBDVEHTZJTJTWSURZDEVCZERWTDEVDVFBEVGVHUTUQVIABWGVJZBWHV
      BABWEVJBWFVJZXBABWDWECDEFGHJKLOMPQWIWJRSVKXCABBXAVLRWTDEECVMTVLPCVMVNVOVR
      VOVPUTBWEWFVQVSBWGVTWAWBUQ $.
  $}

  ${
    $d f K $.  $d f W $.
    mapdrn2.h $e |- H = ( LHyp ` K ) $.
    mapdrn2.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdrn2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdrn2.t $e |- T = ( LSubSp ` C ) $.
    mapdrn2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Range of the map defined by ~ df-mapd .  TODO: this seems to be needed a
       lot in ~ hdmaprnlem3eN etc.  Would it be better to change ~ df-mapd
       theorems to use ` LSubSp `` C ` instead of ` ran M ` ?  (Contributed by
       NM, 13-Mar-2015.) $)
    mapdrn2 $p |- ( ph -> ran M = T ) $=
      ( vf crn cdvh cfv cld clss cv eqid clk coch wceq clfn crab cpw cin mapdrn
      lcdlss eqtr4d ) AFNGEOPPZQPZRPZMSUKUAPZPZGEUBPPZPUPPUOUCMUKUDPZUEZUFUGCAU
      RULUMUKMUQDEUNFUPGHUPTZIUKTZUQTZUNTZULTZUMTZURTZLUHAURBULCUMUKMUQDEUNUPGH
      USJKUTVAVBVCVDVELUIUJ $.
  $}

  ${
    $d g K $.  $d g U $.  $d g W $.
    mapdcnvcl.h $e |- H = ( LHyp ` K ) $.
    mapdcnvcl.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdcnvcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdcnvcl.s $e |- S = ( LSubSp ` U ) $.
    mapdcnvcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      mapdcnvcl.x $e |- ( ph -> X e. ran M ) $.
      $( Closure of the converse of the map defined by ~ df-mapd .
         (Contributed by NM, 13-Mar-2015.) $)
      mapdcnvcl $p |- ( ph -> ( `' M ` X ) e. S ) $=
        ( vg crn wf1o wcel cfv eqid ccnv cld clss cv clk coch wceq clfn cpw cin
        crab wf1 mapd1o f1of1 f1f1orn 3syl f1ocnvdm syl2anc ) ABFPZFQZHUSRHFUAS
        BRABCUBSZUCSZOUDCUESZSZGEUFSSZSVESVDUGOCUHSZUKZUIUJZFQBVHFULUTAVGVABVBC
        OVFDEVCFVEGIVETJKLVFTVCTVATVBTVGTMUMBVHFUNBVHFUOUPNBUSHFUQUR $.
    $}

    mapdcl.x $e |- ( ph -> X e. S ) $.
    $( Closure the value of the map defined by ~ df-mapd .  (Contributed by NM,
       13-Mar-2015.) $)
    mapdcl $p |- ( ph -> ( M ` X ) e. ran M ) $=
      ( vg crn wfn wf cfv eqid cld clss cv clk coch wceq clfn crab cpw cin wf1o
      mapd1o f1ofn syl dffn3 sylib ffvelrnd ) ABFPZHFAFBQZBURFRABCUASZUBSZOUCCU
      DSZSZGEUESSZSVDSVCUFOCUGSZUHZUIUJZFUKUSAVFUTBVACOVEDEVBFVDGIVDTJKLVETVBTU
      TTVATVFTMULBVGFUMUNBFUOUPNUQ $.

    $( Converse of the value of the map defined by ~ df-mapd .  (Contributed by
       NM, 13-Mar-2015.)  (New usage is discouraged.) $)
    mapdcnvid1N $p |- ( ph -> ( `' M ` ( M ` X ) ) = X ) $=
      ( vg cld cfv clss wceq eqid cv clk coch clfn crab cpw wf1o wcel f1ocnvfv1
      cin ccnv mapd1o syl2anc ) ABCPQZRQZOUACUBQZQZGEUCQQZQURQUQSOCUDQZUEZUFUJZ
      FUGHBUHHFQFUKQHSAUTUNBUOCOUSDEUPFURGIURTJKLUSTUPTUNTUOTUTTMULNBVAHFUIUM
      $.

    mapdsord.x $e |- ( ph -> Y e. S ) $.
    $( Strong ordering property of themap defined by ~ df-mapd .  (Contributed
       by NM, 13-Mar-2015.) $)
    mapdsord $p |- ( ph -> ( ( M ` X ) C. ( M ` Y ) <-> X C. Y ) ) $=
      ( cfv wss wne wa wpss mapdord mapd11 necon3bid anbi12d df-pss 3bitr4g ) A
      HFQZIFQZRZUHUISZTHIRZHISZTUHUIUAHIUAAUJULUKUMABCDEFGHIJLMKNOPUBAUHUIHIABC
      DEFGHIJLMKNOPUCUDUEUHUIUFHIUFUG $.
  $}

  ${
    mapdlss.h $e |- H = ( LHyp ` K ) $.
    mapdlss.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdlss.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdlss.s $e |- S = ( LSubSp ` U ) $.
    mapdlss.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdlss.t $e |- T = ( LSubSp ` C ) $.
    mapdlss.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdlss.r $e |- ( ph -> R e. S ) $.
    $( The mapping of a subspace of vector space H is a subspace in the dual
       space of functionals with closed kernels.  (Contributed by NM,
       31-Jan-2015.) $)
    mapdcl2 $p |- ( ph -> ( M ` R ) e. T ) $=
      ( cfv crn mapdcl mapdrn2 eleqtrd ) ACISITEADFGHIJCKLMNQRUAABEGHIJKLOPQUBU
      C $.
  $}

  ${
    $d g K $.  $d g W $.
    mapdcnvid2.h $e |- H = ( LHyp ` K ) $.
    mapdcnvid2.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdcnvid2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdcnvid2.x $e |- ( ph -> X e. ran M ) $.
    $( Value of the converse of the map defined by ~ df-mapd .  (Contributed by
       NM, 13-Mar-2015.) $)
    mapdcnvid2 $p |- ( ph -> ( M ` ( `' M ` X ) ) = X ) $=
      ( vg cdvh cfv clss crn wf1o wcel ccnv wceq eqid cld cv clk coch clfn crab
      cpw cin wf1 mapd1o f1of1 f1f1orn 3syl f1ocnvfv2 syl2anc ) AECLMMZNMZDOZDP
      ZFURQFDRMDMFSAUQUPUAMZNMZKUBUPUCMZMZECUDMMZMVDMVCSKUPUEMZUFZUGUHZDPUQVGDU
      IUSAVFUTUQVAUPKVEBCVBDVDEGVDTHUPTUQTVETVBTUTTVATVFTIUJUQVGDUKUQVGDULUMJUQ
      URFDUNUO $.
  $}

  ${
    mapdcnvord.h $e |- H = ( LHyp ` K ) $.
    mapdcnvord.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdcnvord.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdcnvord.x $e |- ( ph -> X e. ran M ) $.
    mapdcnvord.y $e |- ( ph -> Y e. ran M ) $.
    $( Ordering property of the converse of the map defined by ~ df-mapd .
       (Contributed by NM, 13-Mar-2015.)  (New usage is discouraged.) $)
    mapdcnvordN $p |- ( ph -> ( ( `' M ` X ) C_ ( `' M ` Y ) <-> X C_ Y ) ) $=
      ( ccnv cfv wss cdvh clss eqid mapdcnvcl mapdcnvid2 mapdord sseq12d bitr3d
      ) AFDMZNZDNZGUDNZDNZOUEUGOFGOAECPNNZQNZUIBCDEUEUGHUIRZUJRZIJAUJUIBCDEFHIU
      KULJKSAUJUIBCDEGHIUKULJLSUAAUFFUHGABCDEFHIJKTABCDEGHIJLTUBUC $.

    $( The converse of the map defined by ~ df-mapd is one-to-one.
       (Contributed by NM, 13-Mar-2015.)  (New usage is discouraged.) $)
    mapdcnv11N $p |- ( ph -> ( ( `' M ` X ) = ( `' M ` Y ) <-> X = Y ) ) $=
      ( ccnv cfv wss wa wceq mapdcnvordN anbi12d eqss 3bitr4g ) AFDMZNZGUBNZOZU
      DUCOZPFGOZGFOZPUCUDQFGQAUEUGUFUHABCDEFGHIJKLRABCDEGFHIJLKRSUCUDTFGTUA $.
  $}

  ${
    $d f v D $.  $d f v M $.  $d f v S $.  $d v U $.  $d f v X $.  $d f v Y $.
    $d f v ph $.
    mapdcv.h $e |- H = ( LHyp ` K ) $.
    mapdcv.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdcv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdcv.s $e |- S = ( LSubSp ` U ) $.
    mapdcv.c $e |- C = ( <oL ` U ) $.
    mapdcv.d $e |- D = ( ( LCDual ` K ) ` W ) $.
    mapdcv.e $e |- E = ( <oL ` D ) $.
    mapdcv.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdcv.x $e |- ( ph -> X e. S ) $.
    mapdcv.y $e |- ( ph -> Y e. S ) $.
    $( Covering property of the converse of the map defined by ~ df-mapd .
       (Contributed by NM, 14-Mar-2015.) $)
    mapdcv $p |- ( ph -> ( X C Y <-> ( M ` X ) E ( M ` Y ) ) ) $=
      ( vf vv cfv wpss cv wa clss wrex wbr mapdsord wcel eqid chlt adantr simpr
      wn mapdcl2 ccnv wceq crn mapdrn2 eleq2d mapdcnvcl mapdcnvid2 eqcomd fveq2
      biimpar eqeq2d rspcev syl2anc psseq2 psseq1 anbi12d adantl rexbidva bitrd
      wb rexxfrd notbid clmod lcdlmod lcvbr dvhlmod 3bitr4rd ) AKIUEZLIUEZUFZWG
      UCUGZUFZWJWHUFZUHZUCCUIUEZUJZURZUHKLUFZKUDUGZUFZWRLUFZUHZUDDUJZURZUHWGWHF
      UKKLBUKAWIWQWPXCADEGHIJKLMNOPTUAUBULAWOXBAWOWGWRIUEZUFZXDWHUFZUHZUDDUJXBA
      WMXGUCUDXDWNDAWRDUMZUHZCWRDWNEGHIJMNOPRWNUNZAHUOUMJGUMUHZXHTUPZAXHUQZUSAW
      JWNUMZUHZWJIUTUEZDUMWJXPIUEZVAZWJXDVAZUDDUJXODEGHIJWJMNOPAXKXNTUPZAWJIVBZ
      UMXNAYAWNWJACWNGHIJMNRXJTVCVDVIZVEXOXQWJXOGHIJWJMNXTYBVFVGXSXRUDXPDWRXPVA
      XDXQWJWRXPIVHVJVKVLXSWMXGVSAXSWKXEWLXFWJXDWGVMWJXDWHVNVOVPVTAXGXAUDDXIXEW
      SXFWTXIDEGHIJKWRMNOPXLAKDUMXHUAUPXMULXIDEGHIJWRLMNOPXLXMALDUMXHUBUPULVOVQ
      VRWAVOAFWNWGWHCWBUCXJSACGHJMRTWCACKDWNEGHIJMNOPRXJTUAUSACLDWNEGHIJMNOPRXJ
      TUBUSWDABDKLEWBUDPQAEGHJMOTWEUAUBWDWF $.
  $}

  ${
    $d g D $.  $d g K $.  $d g U $.  $d g W $.
    mapdincl.h $e |- H = ( LHyp ` K ) $.
    mapdincl.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdincl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdincl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdincl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdincl.x $e |- ( ph -> X e. ran M ) $.
    mapdincl.y $e |- ( ph -> Y e. ran M ) $.
    $( Closure of dual subspace intersection for the map defined by
       ~ df-mapd .  (Contributed by NM, 12-Apr-2015.) $)
    mapdincl $p |- ( ph -> ( X i^i Y ) e. ran M ) $=
      ( cfv wcel eqid eleqtrd cin clcd clss crn lcdlmod mapdrn2 lssincl syl3anc
      clmod eleqtrrd ) AHIUAZGEUBQQZUCQZFUDZAULUIRHUMRIUMRUKUMRAULDEGJULSZNUEAH
      UNUMOAULUMDEFGJKUOUMSZNUFZTAIUNUMPUQTUMHIULUPUGUHUQUJ $.
  $}

  ${
    mapdin.h $e |- H = ( LHyp ` K ) $.
    mapdin.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdin.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdin.s $e |- S = ( LSubSp ` U ) $.
    mapdin.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdin.x $e |- ( ph -> X e. S ) $.
    mapdin.y $e |- ( ph -> Y e. S ) $.
    $( Subspace intersection is preserved by the map defined by ~ df-mapd .
       Part of property (e) in [Baer] p. 40.  (Contributed by NM,
       12-Apr-2015.) $)
    mapdin $p |- ( ph -> ( M ` ( X i^i Y ) ) = ( ( M ` X ) i^i ( M ` Y ) ) ) $=
      ( cfv wss wcel mapdord cin inss1 clmod dvhlmod lssincl mpbiri inss2 ssind
      syl3anc ccnv clcd eqid clss mapdcl2 eleqtrrd mapdincl mapdcnvid2 syl6eqss
      crn mapdrn2 lcdlmod mapdcnvcl mpbid mpbird eqsstr3d eqssd ) AHIUAZFQZHFQZ
      IFQZUAZAVHVIVJAVHVIRVGHRHIUBABCDEFGVGHJLMKNACUCSHBSIBSVGBSACDEGJLNUDOPBHI
      CMUEUIZOTUFAVHVJRVGIRHIUGABCDEFGVGIJLMKNVLPTUFUHAVKVKFUJQZFQZVHADEFGVKJKN
      AGEUKQQZCDEFGVIVJJKLVOULZNAVIVOUMQZFUSZAVOHBVQCDEFGJKLMVPVQULZNOUNZAVOVQD
      EFGJKVPVSNUTZUOAVJVQVRAVOIBVQCDEFGJKLMVPVSNPUNZWAUOUPUQZAVNVHRVMVGRAVMHIA
      VNVIRVMHRAVNVKVIWCVIVJUBURABCDEFGVMHJLMKNABCDEFGVKJKLMNAVKVQVRAVOUCSVIVQS
      VJVQSVKVQSAVODEGJVPNVAVTWBVQVIVJVOVSUEUIWAUOZVBZOTVCAVNVJRVMIRAVNVKVJADEF
      GVKJKNWDUQVIVJUGURABCDEFGVMIJLMKNWEPTVCUHABCDEFGVMVGJLMKNWEVLTVDVEVF $.
  $}

  ${
    mapdlsmcl.h $e |- H = ( LHyp ` K ) $.
    mapdlsmcl.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdlsmcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdlsmcl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdlsmcl.p $e |- .(+) = ( LSSum ` C ) $.
    mapdlsmcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdlsmcl.x $e |- ( ph -> X e. ran M ) $.
    mapdlsmcl.y $e |- ( ph -> Y e. ran M ) $.
    $( Closure of dual subspace sum for the map defined by ~ df-mapd .
       (Contributed by NM, 13-Mar-2015.) $)
    mapdlsmcl $p |- ( ph -> ( X .(+) Y ) e. ran M ) $=
      ( wcel eleqtrd clss cfv clmod lcdlmod eqid mapdrn2 lsmcl syl3anc eleqtrrd
      co crn ) AIJCUJZBUAUBZGUKZABUCSIUMSJUMSULUMSABEFHKNPUDAIUNUMQABUMEFGHKLNU
      MUEZPUFZTAJUNUMRUPTCUMIJBUOOUGUHUPUI $.
  $}

  ${
    mapdlsm.h $e |- H = ( LHyp ` K ) $.
    mapdlsm.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdlsm.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdlsm.s $e |- S = ( LSubSp ` U ) $.
    mapdlsm.p $e |- .(+) = ( LSSum ` U ) $.
    mapdlsm.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdlsm.q $e |- .+b = ( LSSum ` C ) $.
    mapdlsm.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdlsm.x $e |- ( ph -> X e. S ) $.
    mapdlsm.y $e |- ( ph -> Y e. S ) $.
    $( Subspace sum is preserved by the map defined by ~ df-mapd .  Part of
       property (e) in [Baer] p. 40.  (Contributed by NM, 13-Mar-2015.) $)
    mapdlsm $p |- ( ph ->
      ( M ` ( X .(+) Y ) ) = ( ( M ` X ) .+b ( M ` Y ) ) ) $=
      ( co cfv ccnv wss csubg wcel clss clmod lcdlmod eqid lsssssubg syl sseldd
      mapdcl2 lsmub1 syl2anc mapdcl mapdlsmcl mapdcnvid2 sseqtr4d mapdord mpbid
      mapdcnvcl lsmub2 wa wb dvhlmod lsmlub syl3anc mpbi2and lsmcl mpbird eqssd
      sseqtrd ) AKLDUCZIUDZKIUDZLIUDZCUCZAVRWAIUEUDZIUDZWAAVRWCUFVQWBUFZAKWBUFZ
      LWBUFZWDAVSWCUFWEAVSWAWCAVSBUGUDZUHZVTWGUHZVSWAUFABUIUDZWGVSABUJUHWJWGUFA
      BGHJMRTUKWJBWJULZUMUNZABKEWJFGHIJMNOPRWKTUAUPUOZAWJWGVTWLABLEWJFGHIJMNOPR
      WKTUBUPUOZCVSVTBSUQURAGHIJWAMNTABCFGHIJVSVTMNORSTAEFGHIJKMNOPTUAUSAEFGHIJ
      LMNOPTUBUSUTZVAZVBAEFGHIJKWBMOPNTUAAEFGHIJWAMNOPTWOVEZVCVDAVTWCUFWFAVTWAW
      CAWHWIVTWAUFWMWNCVSVTBSVFURWPVBAEFGHIJLWBMOPNTUBWQVCVDAKFUGUDZUHZLWRUHZWB
      WRUHWEWFVGWDVHAEWRKAFUJUHZEWRUFAFGHJMOTVIZEFPUMUNZUAUOZAEWRLXCUBUOZAEWRWB
      XCWQUODKLWBFQVJVKVLAEFGHIJVQWBMOPNTAXAKEUHLEUHVQEUHXBUAUBDEKLFPQVMVKZWQVC
      VNWPVPAVSVRUFZVTVRUFZWAVRUFZAXGKVQUFZAWSWTXJXDXEDKLFQUQURAEFGHIJKVQMOPNTU
      AXFVCVNAXHLVQUFZAWSWTXKXDXEDKLFQVFURAEFGHIJLVQMOPNTUBXFVCVNAWHWIVRWGUHXGX
      HVGXIVHWMWNAWJWGVRWLABVQEWJFGHIJMNOPRWKTXFUPUOCVSVTVRBSVJVKVLVO $.
  $}

  ${
    $d f K $.  $d g K $.  $d f O $.  $d g O $.  $d f U $.  $d g U $.  $d f W $.
    $d g W $.  $d g .0. $.  $d g f $.  $d g ph $.
    mapd0.h $e |- H = ( LHyp ` K ) $.
    mapd0.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapd0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapd0.o $e |- O = ( 0g ` U ) $.
    mapd0.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapd0.z $e |- .0. = ( 0g ` C ) $.
    mapd0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Projectivity map of the zero subspace.  Part of property (f) in [Baer]
       p. 40.  TODO: does proof need to be this long for this simple fact?
       (Contributed by NM, 15-Mar-2015.) $)
    mapd0 $p |- ( ph -> ( M ` { O } ) = { .0. } ) $=
      ( cfv wceq eqid wcel vf vg csn cv clk coch wa clfn crab clss chlt dvhlmod
      wss clmod lsssn0 syl mapdval cbs csca c0g simprrr wb adantr simprl lkrssv
      cxp dochlss syl2anc lssle0 mpbid fveq2d simprrl doch0 3eqtr3d lkr0f lcd0v
      eqtr4d ex lcd0vcl lcdvbaselfl mpbird eqtrd doch1 eqimss jca32 eleq1 fveq2
      dochoc1 eqeq12d sseq1d anbi12d syl5ibrcom impbid elrab elsn 3bitr4g eqrdv
      weq ) AGUCZFQUAUDZCUEQZQZHEUFQQZQZXCQZXBRZXDWSUMZUGZUACUHQZUIZIUCZACUJQZW
      SCUAXIDEXAFXCHUKJLXLSZXISZXASZXCSZKPACUNTZWSXLTACDEHJLPULZXLCGMXMUOUPUQAU
      BXJXKAUBUDZXITZXSXAQZXCQZXCQZYARZYBWSUMZUGZUGZXSIRZXSXJTXSXKTAYGYHAYGYHAY
      GUGZXSCURQZCUSQZUTQZUCVFZIYIYAYJRZXSYMRZYIYCWSXCQZYAYJYIYBWSXCYIYEYBWSRZA
      XTYDYEVAYIXQYBXLTZYEYQVBAXQYGXRVCZYIEUKTHDTUGZYAYJUMYRAYTYGPVCYIXIXSXAYJC
      YJSZXNXOYSAXTYFVDZVEXLCDEXCYJHYAJLUUAXMXPVGVHXLCYBGMXMVIVHVJVKAXTYDYEVLAY
      PYJRZYGAYTUUCPCDEXCYJHGJLXPUUAMVMUPVCVNYIXQXTYNYOVBYSUUBYKXIXSXAYJCYLYKSZ
      YLSZUUAXNXOVOVHVJAIYMRZYGABYKCDEIYJHYLJLUUAUUDUUENOPVPZVCVQVRAYGYHIXITZIX
      AQZXCQZXCQZUUIRZUUJWSUMZUGZUGAUUHUULUUMABCXIDEBURQZHIJNUUOSZLXNPABDEIUUOH
      JNUUPOPVSVTZAUUKYJUUIAUUKYJXCQZXCQYJAUUJUURXCAUUIYJXCAUUIYJRZUUFUUGAXQUUH
      UUSUUFVBXRUUQYKXIIXAYJCYLUUDUUEUUAXNXOVOVHWAZVKZVKACDEXCYJHJLXPUUAPWHWBUU
      TVQAUUJWSRUUMAUUJUURWSUVAAYTUURWSRPCDEXCYJHGJLXPUUAMWCUPWBUUJWSWDUPWEYHXT
      UUHYFUUNXSIXIWFYHYDUULYEUUMYHYCUUKYAUUIYHYBUUJXCYHYAUUIXCXSIXAWGZVKZVKUVB
      WIYHYBUUJWSUVCWJWKWKWLWMXHYFUAXSXIUAUBWRZXFYDXGYEUVDXEYCXBYAUVDXDYBXCUVDX
      BYAXCWTXSXAWGZVKZVKUVEWIUVDXDYBWSUVFWJWKWNUBIWOWPWQWB $.
  $}

  ${
    mapdat.h $e |- H = ( LHyp ` K ) $.
    mapdat.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdat.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdat.a $e |- A = ( LSAtoms ` U ) $.
    mapdat.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdat.b $e |- B = ( LSAtoms ` C ) $.
    mapdat.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      mapdcnvat.q $e |- ( ph -> Q e. B ) $.
      $( Atoms are preserved by the map defined by ~ df-mapd .  (Contributed by
         NM, 29-May-2015.)  (New usage is discouraged.) $)
      mapdcnvatN $p |- ( ph -> ( `' M ` Q ) e. A ) $=
        ( cfv eqid ccnv wcel c0g csn clcv clss clmod dvhlmod lsssn0 mapdcnvid1N
        wbr syl mapd0 fveq2d eqtr3d lcdlvec lsatcv0 lcdlmod eleqtrrd mapdcnvid2
        crn mapdrn2 lsatlssel 3brtr4d mapdcnvcl mapdcv eqbrtrd dvhlvec lsat0cv
        mpbird ) AEIUAZSZBUBFUCSZUDZVLFUESZUKAVNDUCSZUDZVKSZVLVOAVNISZVKSVNVRAF
        UFSZFGHIJVNKLMVTTZQAFUGUBVNVTUBAFGHJKMQUHVTFVMVMTZWAUIULUJAVSVQVKADFGHI
        VMJVPKLMWBOVPTZQUMUNUOAVRVLVOUKVRISZVLISZDUESZUKAVQEWDWEWFACWFEDVPWCPWF
        TZADGHJKOQUPRUQAGHIJVQKLQAVQDUFSZIVAZADUGUBVQWHUBADGHJKOQURZWHDVPWCWHTZ
        UIULADWHGHIJKLOWKQVBZUSZUTAGHIJEKLQAEWHWIACWHEDWKPWJRVCWLUSZUTVDAVODVTF
        WFGHIJVRVLKLMWAVOTZOWGQAVTFGHIJVQKLMWAQWMVEAVTFGHIJEKLMWAQWNVEZVFVJVGAB
        VOVTVLFVMWBWANWOAFGHJKMQVHWPVIVJ $.
    $}
    mapdat.q $e |- ( ph -> Q e. A ) $.
    $( Atoms are preserved by the map defined by ~ df-mapd .  Property (g) in
       [Baer] p. 41.  (Contributed by NM, 14-Mar-2015.) $)
    mapdat $p |- ( ph -> ( M ` Q ) e. B ) $=
      ( cfv eqid wcel c0g csn clcv wbr mapd0 dvhlvec lsatcv0 clss clmod dvhlmod
      lsssn0 syl lsatlssel mapdcv mpbid eqbrtrrd lcdlvec mapdcl2 lsat0cv mpbird
      ) AEISZCUADUBSZUCZVBDUDSZUEAFUBSZUCZISZVDVBVEADFGHIVFJVCKLMVFTZOVCTZQUFAV
      GEFUDSZUEVHVBVEUEABVKEFVFVINVKTZAFGHJKMQUGRUHAVKDFUISZFVEGHIJVGEKLMVMTZVL
      OVETZQAFUJUAVGVMUAAFGHJKMQUKZVMFVFVIVNULUMABVMEFVNNVPRUNZUOUPUQACVEDUISZV
      BDVCVJVRTZPVOADGHJKOQURADEVMVRFGHIJKLMVNOVSQVQUSUTVA $.
  $}

  ${
    $d g B $.  $d g C $.  $d g J $.  $d g M $.  $d g N $.  $d g X $.
    mapdspex.h $e |- H = ( LHyp ` K ) $.
    mapdspex.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdspex.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdspex.v $e |- V = ( Base ` U ) $.
    mapdspex.n $e |- N = ( LSpan ` U ) $.
    mapdspex.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdspex.b $e |- B = ( Base ` C ) $.
    mapdspex.j $e |- J = ( LSpan ` C ) $.
    mapdspex.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdspex.x $e |- ( ph -> X e. V ) $.
    $( The map of a span equals the dual span of some vector (functional).
       (Contributed by NM, 15-Mar-2015.) $)
    mapdspex $p |- ( ph
       -> E. g e. B ( M ` ( N ` { X } ) ) = ( J ` { g } ) ) $=
      ( csn cfv clsa wcel cv wceq wrex c0g clmod lcdlmod adantr eqid chlt simpr
      wa mapdat islsati syl2anc lcd0vcl fveq2 mapd0 lspsn0 syl eqtr4d sylan9eqr
      sneq fveq2d eqeq2d rspcev dvhlmod lsator0sp mpjaodan ) AMUDJUEZDUFUEZUGZV
      PIUEZEUHZUDZGUEZUIZEBUJZVPDUKUEZUDZUIZAVRURZCULUGZVSCUFUEZUGWDAWIVRACFHLN
      SUBUMZUNWHVQWJCVPDFHILNOPVQUOZSWJUOZAHUPUGLFUGURVRUBUNAVRUQUSEWJVSGBCULTU
      AWMUTVAAWGURCUKUEZBUGZVSWNUDZGUEZUIZWDAWOWGACFHWNBLNSTWNUOZUBVBUNWGAVSWFI
      UEZWQVPWFIVCAWTWPWQACDFHIWELWNNOPWEUOZSWSUBVDAWIWQWPUIWKGCWNWSUAVEVFVGVHW
      CWREWNBVTWNUIZWBWQVSXBWAWPGVTWNVIVJVKVLVAAVQJKDMWEQRXAWLADFHLNPUBVMUCVNVO
      $.
  $}

  ${
    mapdindp.h $e |- H = ( LHyp ` K ) $.
    mapdindp.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdindp.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdindp.v $e |- V = ( Base ` U ) $.
    mapdindp.n $e |- N = ( LSpan ` U ) $.
    mapdindp.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdindp.d $e |- D = ( Base ` C ) $.
    mapdindp.j $e |- J = ( LSpan ` C ) $.
    mapdindp.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdindp.f $e |- ( ph -> F e. D ) $.
    mapdindp.mx $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
    ${
      mapdn0.o $e |- .0. = ( 0g ` U ) $.
      mapdn0.z $e |- Z = ( 0g ` C ) $.
      mapdn0.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      $( Transfer non-zero property from domain to range of projectivity
         ` mapd ` .  (Contributed by NM, 12-Apr-2015.) $)
      mapdn0 $p |- ( ph -> F e. ( D \ { Z } ) ) $=
        ( wcel wne csn cdif eldifsni syl wceq cfv wa sneq fveq2d sylan9eq mapd0
        clmod lcdlmod lspsn0 eqtr4d adantr ex clss eqid dvhlmod eldifad lspsncl
        syl2anc lsssn0 mapd11 wb lspsneq0 bitrd sylibd necon3d eldifsn sylanbrc
        mpd ) AECUJEOUKZECOULZUMUJUEAMNUKZWEAMKNULZUMUJWGUIMKNUNUOAEOMNAEOUPZMU
        LJUQZIUQZWHIUQZUPZMNUPZAWIWMAWIURWKWFGUQZWLAWIWKEULZGUQWOUFWIWPWFGEOUSU
        TVAAWLWOUPWIAWLWFWOABDFHINLOPQRUGUAUHUDVBABVCUJWOWFUPABFHLPUAUDVDGBOUHU
        CVEUOVFVGVFVHAWMWJWHUPZWNADVIUQZDFHILWJWHPRWRVJZQUDADVCUJZMKUJZWJWRUJAD
        FHLPRUDVKZAMKWHUIVLZWRJKDMSWSTVMVNAWTWHWRUJXBWRDNUGWSVOUOVPAWTXAWQWNVQX
        BXCJKDMNSUGTVRVNVSVTWAWDECOWBWC $.
    $}

    mapdindp.x $e |- ( ph -> X e. V ) $.
    mapdindp.y $e |- ( ph -> Y e. V ) $.
    mapdindp.g $e |- ( ph -> G e. D ) $.
    mapdindp.my $e |- ( ph -> ( M ` ( N ` { Y } ) ) = ( J ` { G } ) ) $.
    ${
      mapdncol.q $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      $( Transfer non-colinearity from domain to range of projectivity
         ` mapd ` .  (Contributed by NM, 11-Apr-2015.) $)
      mapdncol $p |- ( ph -> ( J ` { F } ) =/= ( J ` { G } ) ) $=
        ( csn cfv clss eqid clmod wcel dvhlmod lspsncl syl2anc mapd11 necon3bid
        wne mpbird 3netr3d ) ANULKUMZJUMZOULKUMZJUMZEULHUMFULHUMAVGVIVCVFVHVCUK
        AVGVIVFVHADUNUMZDGIJMVFVHPRVJUOZQUDADUPUQZNLUQVFVJUQADGIMPRUDURZUGVJKLD
        NSVKTUSUTAVLOLUQVHVJUQVMUHVJKLDOSVKTUSUTVAVBVDUFUJVE $.
    $}

    mapdindp.z $e |- ( ph -> Z e. V ) $.
    mapdindp.e $e |- ( ph -> E e. D ) $.
    mapdindp.mg $e |- ( ph -> ( M ` ( N ` { Z } ) ) = ( J ` { E } ) ) $.
    mapdindp.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    $( Transfer (part of) vector independence condition from domain to range of
       projectivity ` mapd ` .  (Contributed by NM, 11-Apr-2015.) $)
    mapdindp $p |- ( ph -> -. F e. ( J ` { G , E } ) ) $=
      ( cpr cfv wcel csn wss clss eqid lcdlmod lspprcl lspsnel5 dvhlmod lspsncl
      clmod syl2anc mapdord clsm co lsmpr fveq2d mapdlsm oveq12d 3eqtrd sseq12d
      eqtr4d 3bitr2rd bitrd mtbird ) AFGEUQIURZUSZOPQUQLURZUSZUPAWEFUTIURZWDVAZ
      WGABVBURZWDICBFUDWJVCZUEABHJNRUCUFVDZAWJICBGEUDWKUEWLUKUNVEUGVFAWGOUTLURZ
      WFVAWMKURZWFKURZVAWIADVBURZWFLMDOUAWPVCZUBADHJNRTUFVGZAWPLMDPQUAWQUBWRUJU
      MVEZUIVFAWPDHJKNWMWFRTWQSUFADVIUSZOMUSWMWPUSWRUIWPLMDOUAWQUBVHVJWSVKAWNWH
      WOWDUHAWOGUTIURZEUTIURZBVLURZVMZWDAWOPUTLURZQUTLURZDVLURZVMZKURXEKURZXFKU
      RZXCVMXDAWFXHKAXGLMDPQUAUBXGVCZWRUJUMVNVOABXCXGWPDHJKNXEXFRSTWQXKUCXCVCZU
      FAWTPMUSXEWPUSWRUJWPLMDPUAWQUBVHVJAWTQMUSXFWPUSWRUMWPLMDQUAWQUBVHVJVPAXIX
      AXJXBXCULUOVQVRAXCICBGEUDUEXLWLUKUNVNVTVSWAWBWC $.
  $}

  ${
    mapdpglem.h $e |- H = ( LHyp ` K ) $.
    mapdpglem.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdpglem.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdpglem.v $e |- V = ( Base ` U ) $.
    mapdpglem.s $e |- .- = ( -g ` U ) $.
    mapdpglem.n $e |- N = ( LSpan ` U ) $.
    mapdpglem.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdpglem.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdpglem.x $e |- ( ph -> X e. V ) $.
    mapdpglem.y $e |- ( ph -> Y e. V ) $.
    mapdpglem1.p $e |- .(+) = ( LSSum ` C ) $.
    $( Lemma for ~ mapdpg .  Baer p. 44, last line:  "(F(x-y))* =<
       (Fx)*+(Fy)*."  (Contributed by NM, 15-Mar-2015.) $)
    mapdpglem1 $p |- ( ph ->
      ( M ` ( N ` { ( X .- Y ) } ) ) C_
            ( ( M ` ( N ` { X } ) ) .(+) ( M ` ( N ` { Y } ) ) ) ) $=
      ( co csn cfv clsm wss wcel dvhlmod eqid lspsntrim syl3anc clss lmodvsubcl
      clmod lspsncl syl2anc lsmcl mapdord mpbird mapdlsm sseqtrd ) ALMHUEZUFIUG
      ZGUGZLUFIUGZMUFIUGZDUHUGZUEZGUGZVHGUGVIGUGCUEAVGVLUIVFVKUIZADUQUJZLJUJZMJ
      UJZVMADEFKNPUAUKZUBUCVJHIJDLMQRVJULZSUMUNADUOUGZDEFGKVFVKNPVSULZOUAAVNVEJ
      UJZVFVSUJVQAVNVOVPWAVQUBUCHJDLMQRUPUNVSIJDVEQVTSURUSAVNVHVSUJZVIVSUJZVKVS
      UJVQAVNVOWBVQUBVSIJDLQVTSURUSZAVNVPWCVQUCVSIJDMQVTSURUSZVJVSVHVIDVTVRUTUN
      VAVBABCVJVSDEFGKVHVINOPVTVRTUDUAWDWEVCVD $.

    $d t .- $.  $d t C $.  $d t J $.  $d t M $.  $d t N $.  $d t X $.
    $d t Y $.
    mapdpglem2.j $e |- J = ( LSpan ` C ) $.
    ${
      $d t ph $.
      $( Lemma for ~ mapdpg .  Baer p. 45, lines 1 and 2:  "we have (F(x-y))* =
         Gt where t necessarily belongs to (Fx)*+(Fy)*."  (We scope $d ` t ph `
         locally to avoid clashes with later substitutions into ` ph ` .)
         (Contributed by NM, 15-Mar-2015.) $)
      mapdpglem2 $p |- ( ph ->
               E. t e. ( ( M ` ( N ` { X } ) ) .(+) ( M ` ( N ` { Y } ) ) )
             ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { t } ) ) $=
        ( co csn cfv cv wceq wrex cbs clmod dvhlmod lmodvsubcl syl3anc mapdspex
        eqid wcel wa lcdlmod lspsnid sylan adantrr simprr eleqtrrd jca reximdv2
        ex mpd mapdpglem1 sseld anim1d ) ANOJUHZUIKUJIUJZBUKZUIGUJZULZBVQUMZVTB
        NUIKUJIUJOUIKUJIUJDUHZUMAVTBCUNUJZUMWAAWCCEBFGHIKLMVPPQRSUAUBWCUTZUGUCA
        EUOVANLVAOLVAVPLVAAEFHMPRUCUPUDUEJLENOSTUQURUSAVTVTBWCVQAVRWCVAZVTVBZVR
        VQVAZVTVBAWFVBZWGVTWHVRVSVQAWEVRVSVAZVTACUOVAWEWIACFHMPUBUCVCGWCCVRWDUG
        VDVEVFAWEVTVGZVHWJVIVKVJVLAVTVTBVQWBAWGVRWBVAVTAVQWBVRACDEFHIJKLMNOPQRS
        TUAUBUCUDUEUFVMVNVOVJVL $.
    $}

    mapdpglem3.f $e |- F = ( Base ` C ) $.
    mapdpglem3.te $e |- ( ph
        -> t e. ( ( M ` ( N ` { X } ) ) .(+) ( M ` ( N ` { Y } ) ) ) ) $.
    $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem2a $p |- ( ph -> t e. F ) $=
      ( csn cfv co clss wcel clmod lcdlmod eqid dvhlmod lspsncl syl2anc mapdcl2
      cv lsmcl syl3anc lssel ) AOUKLULZJULZPUKLULZJULZDUMZCUNULZUOZBVCZVKUOVNFU
      OACUPUOVHVLUOVJVLUOVMACGINQUCUDUQACVGEUNULZVLEGIJNQRSVOURZUCVLURZUDAEUPUO
      ZOMUOVGVOUOAEGINQSUDUSZUEVOLMEOTVPUBUTVAVBACVIVOVLEGIJNQRSVPUCVQUDAVRPMUO
      VIVOUOVSUFVOLMEPTVPUBUTVAVBDVLVHVJCVQUGVDVEUJVLVKFCVNUIVQVFVA $.

    $d g w B $.  $d g w z C $.  $d g F $.  $d g w z G $.  $d g w z J $.
    $d g w z M $.  $d g w z N $.  $d g w z R $.  $d g w z .x. $.  $d g w z Y $.
    $d g t w z $.
    mapdpglem3.a $e |- A = ( Scalar ` U ) $.
    mapdpglem3.b $e |- B = ( Base ` A ) $.
    mapdpglem3.t $e |- .x. = ( .s ` C ) $.
    mapdpglem3.r $e |- R = ( -g ` C ) $.
    mapdpglem3.g $e |- ( ph -> G e. F ) $.
    mapdpglem3.e $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { G } ) ) $.
    ${
      $d g w z ph $.
      $( Lemma for ~ mapdpg .  Baer p. 45, line 3:  "infer...the existence of a
         number g in G and of an element z in (Fy)* such that t = gx'-z."  (We
         scope $d ` g w z ph ` locally to avoid clashes with later
         substitutions into ` ph ` .)  (Contributed by NM, 18-Mar-2015.) $)
      mapdpglem3 $p |- ( ph ->
              E. g e. B E. z e. ( M ` ( N ` { Y } ) )
                  t = ( ( g .x. G ) R z ) ) $=
        ( vw cv co wceq csn cfv wrex wex wcel oveq1d eleqtrd csca clmod lcdlmod
        wa cbs wb eqid lspsnel syl2anc lcdsbase rexeqdv anbi1d r19.41v syl6rbbr
        bitrd exbidv df-rex syl6bbr clss csubg wss lsssssubg syl lspsncl sseldd
        dvhlmod mapdcl2 bitr4d mpbird ovex oveq1 eqeq2d rexbidv ceqsexv rexcom4
        lsmelvalm rexbii bitr3i sylibr ) AVDVEZKVEZMIVFZVGZCVEZXNBVEZHVFZVGZBUC
        VHSVIZQVIZVJZVRZKEVJZVDVKZXRXPXSHVFZVGZBYCVJZKEVJZAYGXRMVHOVIZYCGVFZVLZ
        AXRUBVHSVIQVIZYCGVFYMUQAYOYLYCGVCVMVNAYGYDVDYLVJZYNAYGXNYLVLZYDVRZVDVKY
        PAYFYRVDAYRXQKEVJZYDVRYFAYQYSYDAYQXQKFVOVIZVSVIZVJZYSAFVPVLZMLVLZYQUUBV
        TAFNPUAUDUJUKVQZVBIXNKYTUUAOLFMYTWAZUUAWAZUPUTUOWBWCAXQKUUAEAFUUAYTJDNP
        EUAUDUFURUSUJUUFUUGUKWDWEWIWFXQYDKEWGWHWJYDVDYLWKWLAVDBGYLYCFHXRVAUNAFW
        MVIZFWNVIZYLAUUCUUHUUIWOUUEUUHFUUHWAZWPWQZAUUCUUDYLUUHVLUUEVBUUHOLFMUPU
        UJUOWRWCWSAUUHUUIYCUUKAFYBJWMVIZUUHJNPQUAUDUEUFUULWAZUJUUJUKAJVPVLUCTVL
        YBUULVLAJNPUAUDUFUKWTUMUULSTJUCUGUUMUIWRWCXAWSXJXBXCYKYEVDVKZKEVJYGUUNY
        JKEYDYJVDXPXOMIXDXQYAYIBYCXQXTYHXRXNXPXSHXEXFXGXHXKYEKVDEXIXLXM $.
    $}

    mapdpglem4.q $e |- Q = ( 0g ` U ) $.
    mapdpglem.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.)
       (New usage is discouraged.) $)
    mapdpglem4N $p |- ( ph -> ( X .- Y ) =/= Q ) $=
      ( dvhlmod lspsnsubn0 ) AQRSJUAUBGUFVCUGAJMOTUCUEUJVEUKULVDVF $.

    mapdpglem4.jt $e |- ( ph
           -> ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { t } ) ) $.
    $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.)
       (New usage is discouraged.) $)
    mapdpglem5N $p |- ( ph -> t =/= ( 0g ` C ) ) $=
      ( cv csn cfv clsa wcel c0g co eqid mapdpglem4N dvhlmod lmodvsubcl syl3anc
      wne clmod lsatspn0 mpbird mapdat eqeltrrd lcdlmod mapdpglem2a mpbid ) ABV
      FZVGNVHZEVIVHZVJWGEVKVHZVRAUAUBQVLZVGRVHZPVHWHWIVEAJVIVHZWIEWLJMOPTUCUDUE
      WMVMZUIWIVMZUJAWLWMVJWKGVRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMU
      NUOUPUQURUSUTVAVBVCVDVNAWMRSJWKGUFUHVCWNAJMOTUCUEUJVOZAJVSVJUASVJUBSVJWKS
      VJWPUKULQSJUAUBUFUGVPVQVTWAWBWCAWINKEWGWJUOUNWJVMWOAEMOTUCUIUJWDABEFJKMNO
      PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPWEVTWF $.

    mapdpglem4.z $e |- .0. = ( 0g ` A ) $.
    mapdpglem4.g4 $e |- ( ph -> g e. B ) $.
    mapdpglem4.z4 $e |- ( ph -> z e. ( M ` ( N ` { Y } ) ) ) $.
    mapdpglem4.t4 $e |- ( ph -> t = ( ( g .x. G ) R z ) ) $.
    mapdpglem4.xn $e |- ( ph -> X =/= Q ) $.
    ${
      mapdpglem4.g0 $e |- ( ph -> g = .0. ) $.
      $( Lemma for ~ mapdpg .  Baer p. 45, line 4:  "If g were 0, then t would
         be in (Fy)*..."  (Contributed by NM, 18-Mar-2015.) $)
      mapdpglem6 $p |- ( ph -> t e. ( M ` ( N ` { Y } ) ) ) $=
        ( cv co csn cfv clmod wcel clss lcdlmod dvhlmod lspsncl syl2anc mapdcl2
        eqid c0g oveq1d lcd0vs eqtrd lss0cl eqeltrd lssvsubcl syl22anc ) ACVOLV
        OZNJVPZBVOZIVPZUDVQTVRZRVRZVLAFVSVTZXAFWAVRZVTZWQXAVTWRXAVTWSXAVTAFOQUB
        UFULUMWBZAFWTKWAVRZXCKOQRUBUFUGUHXFWGZULXCWGZUMAKVSVTUDUAVTWTXFVTAKOQUB
        UFUHUMWCUOXFTUAKUDUIXGUKWDWEWFZAWQFWHVRZXAAWQUENJVPXJAWPUENJVNWIAFDJKNO
        QXJMUBUEUFUHUTVIULURVBXJWGZUMVDWJWKAXBXDXJXAVTXEXIXCXAFXJXKXHWLWEWMVKXC
        XAIFWQWRVCXHWNWOWM $.

      $( Lemma for ~ mapdpg .  Baer p. 45, line 4:  "...so that (F(x-y))* =<
         (Fy)*.  This would imply that F(x-y) =< F(y)..."  (Contributed by NM,
         20-Mar-2015.) $)
      mapdpglem8 $p |- ( ph -> ( N ` { ( X .- Y ) } )
        C_ ( N ` { Y } ) ) $=
        ( co csn cfv cv clss eqid lcdlmod clmod dvhlmod lspsncl syl2anc mapdcl2
        wss wcel mapdpglem6 lspsnel5a eqsstrd lmodvsubcl syl3anc mapdord mpbid
        ) AUCUDSVOZVPTVQZRVQZUDVPTVQZRVQZWGWQWSWGAWRCVRZVPPVQWTVHAFVSVQZWTPFXAX
        BVTZUQAFOQUBUFULUMWAAFWSKVSVQZXBKOQRUBUFUGUHXDVTZULXCUMAKWBWHZUDUAWHZWS
        XDWHAKOQUBUFUHUMWCZUOXDTUAKUDUIXEUKWDWEZWFABCDEFGHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNWIWJWKAXDKOQ
        RUBWQWSUFUHXEUGUMAXFWPUAWHZWQXDWHXHAXFUCUAWHXGXJXHUNUOSUAKUCUDUIUJWLWMX
        DTUAKWPUIXEUKWDWEXIWNWO $.

      $( Lemma for ~ mapdpg .  Baer p. 45, line 4:  "...so that x would
         consequently belong to Fy."  (Contributed by NM, 20-Mar-2015.) $)
      mapdpglem9 $p |- ( ph -> X e. ( N ` { Y } ) ) $=
        ( co cplusg cfv clmod wcel wceq dvhlmod eqid lmodvnpcan syl3anc lspsncl
        csn clss syl2anc mapdpglem8 lmodvsubcl lspsnid sseldd syl22anc eqeltrrd
        lssvacl ) AUCUDSVOZUDKVPVQZVOZUCUDWFTVQZAKVRVSZUCUAVSZUDUAVSZWRUCVTAKOQ
        UBUFUHUMWAZUNUOUCUDWQSUAKUIWQWBZUJWCWDAWTWSKWGVQZVSZWPWSVSUDWSVSZWRWSVS
        XCAWTXBXFXCUOXETUAKUDUIXEWBZUKWEWHAWPWFTVQZWSWPABCDEFGHIJKLMNOPQRSTUAUB
        UCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNWIAWTWP
        UAVSZWPXIVSXCAWTXAXBXJXCUNUOSUAKUCUDUIUJWJWDTUAKWPUIUKWKWHWLAWTXBXGXCUO
        TUAKUDUIUKWKWHWQXEWSKWPUDXDXHWOWMWN $.

      $( Lemma for ~ mapdpg .  Baer p. 45, line 6:  "Hence Fx=Fy, an
         impossibility."  (Contributed by NM, 20-Mar-2015.) $)
      mapdpglem10 $p |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $=
        ( dvhlvec mapdpglem9 lspsneleq ) ATUAKUDUCHUIVFUKAKOQUBUFUHUMVOUOABCDEF
        GHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHV
        IVJVKVLVMVNVPVMVQ $.
    $}

    $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem11 $p |- ( ph -> g =/= .0. ) $=
      ( csn cfv wne cv wceq wa chlt wcel adantr co simpr mapdpglem10 ex necon3d
      mpd ) AUCVNTVOZUDVNTVOZVPZLVQZUEVPVGAWLUEWIWJAWLUEVRZWIWJVRAWMVSBCDEFGHIJ
      KLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULAQVTWAUBOWAVSWMUMWBAUCUAWAWMUNWBAUDUAWA
      WMUOWBUPUQURACVQZWIRVOZWJRVOZGWCWAWMUSWBUTVAVBVCANMWAWMVDWBAWONVNPVOVRWMV
      EWBVFAWKWMVGWBAUCUDSWCVNTVORVOWNVNPVOVRWMVHWBVIAWLEWAWMVJWBABVQZWPWAWMVKW
      BAWNWLNJWCWQIWCVRWMVLWBAUCHVPWMVMWBAWMWDWEWFWGWH $.

    mapdpglem12.yn $e |- ( ph -> Y =/= Q ) $.
    ${
      mapdpglem12.g0 $e |- ( ph -> z = ( 0g ` C ) ) $.
      $( Lemma for ~ mapdpg .  TODO:  Can some commonality with ~ mapdpglem6
         through ~ mapdpglem11 be exploited?  Also, some consolidation of small
         lemmas here could be done.  (Contributed by NM, 18-Mar-2015.) $)
      mapdpglem12 $p |- ( ph -> t e. ( M ` ( N ` { X } ) ) ) $=
        ( cv co csn cfv clmod wcel clss lcdlmod dvhlmod lspsncl syl2anc mapdcl2
        eqid lspsnid eleqtrrd lcdlssvscl c0g lss0cl eqeltrd lssvsubcl syl22anc
        ) ACVPLVPZNJVQZBVPZIVQZUCVRTVSZRVSZVLAFVTWAZXBFWBVSZWAZWRXBWAWSXBWAWTXB
        WAAFOQUBUFULUMWCZAFXAKWBVSZXDKOQRUBUFUGUHXGWHZULXDWHZUMAKVTWAUCUAWAXAXG
        WAAKOQUBUFUHUMWDUNXGTUAKUCUIXHUKWEWFWGZAFEXDJKDOQXBMUBWQNUFUHUTVAULURVB
        XIUMXJVJANNVRPVSZXBAXCNMWANXKWAXFVDPMFNURUQWIWFVEWJWKAWSFWLVSZXBVOAXCXE
        XLXBWAXFXJXDXBFXLXLWHXIWMWFWNXDXBIFWRWSVCXIWOWPWN $.

      $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.) $)
      mapdpglem13 $p |- ( ph -> ( N ` { ( X .- Y ) } )
        C_ ( N ` { X } ) ) $=
        ( co csn cfv cv clss eqid lcdlmod clmod dvhlmod lspsncl syl2anc mapdcl2
        wss wcel mapdpglem12 lspsnel5a eqsstrd lmodvsubcl syl3anc mapdord mpbid
        ) AUCUDSVPZVQTVRZRVRZUCVQTVRZRVRZWHWRWTWHAWSCVSZVQPVRXAVHAFVTVRZXAPFXBX
        CWAZUQAFOQUBUFULUMWBAFWTKVTVRZXCKOQRUBUFUGUHXEWAZULXDUMAKWCWIZUCUAWIZWT
        XEWIAKOQUBUFUHUMWDZUNXETUAKUCUIXFUKWEWFZWGABCDEFGHIJKLMNOPQRSTUAUBUCUDU
        EUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOWJWKWLAXEK
        OQRUBWRWTUFUHXFUGUMAXGWQUAWIZWRXEWIXIAXGXHUDUAWIXKXIUNUOSUAKUCUDUIUJWMW
        NXETUAKWQUIXFUKWEWFXJWOWP $.

      $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.) $)
      mapdpglem14 $p |- ( ph -> Y e. ( N ` { X } ) ) $=
        ( co cplusg cfv clmod wcel wceq dvhlmod eqid lmodvnpcan syl3anc lspsncl
        csn clss syl2anc cminusg cgrp lmodgrp syl grpinvsub mapdpglem13 lspsnid
        lmodvsubcl sseldd lssvnegcl eqeltrrd lssvacl syl22anc ) AUDUCSVPZUCKVQV
        RZVPZUDUCWGTVRZAKVSVTZUDUAVTZUCUAVTZXEUDWAAKOQUBUFUHUMWBZUOUNUDUCXDSUAK
        UIXDWCZUJWDWEAXGXFKWHVRZVTZXCXFVTUCXFVTZXEXFVTXJAXGXIXMXJUNXLTUAKUCUIXL
        WCZUKWFWIZAUCUDSVPZKWJVRZVRZXCXFAKWKVTZXIXHXSXCWAAXGXTXJKWLWMUNUOUAKSXR
        UCUDUIUJXRWCZWNWEAXGXMXQXFVTXSXFVTXJXPAXQWGTVRZXFXQABCDEFGHIJKLMNOPQRST
        UAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOW
        OAXGXQUAVTZXQYBVTXJAXGXIXHYCXJUNUOSUAKUCUDUIUJWQWETUAKXQUIUKWPWIWRXLXFX
        RKXQXOYAWSWEWTAXGXIXNXJUNTUAKUCUIUKWPWIXDXLXFKXCUCXKXOXAXBWT $.

      $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.) $)
      mapdpglem15 $p |- ( ph -> ( N ` { X } ) = ( N ` { Y } ) ) $=
        ( csn cfv dvhlvec mapdpglem14 lspsneleq eqcomd ) AUDVPTVQUCVPTVQATUAKUC
        UDHUIVFUKAKOQUBUFUHUMVRUNABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
        UNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOVSVNVTWA $.
    $}

    $( Lemma for ~ mapdpg .  Baer p. 45, line 7:  "Likewise we see that z =/=
       0."  (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem16 $p |- ( ph -> z =/= ( 0g ` C ) ) $=
      ( csn cfv wne cv wceq wa chlt wcel adantr co simpr mapdpglem15 ex necon3d
      c0g mpd ) AUCVOTVPZUDVOTVPZVQZBVRZFWIVPZVQVGAWNWOWKWLAWNWOVSZWKWLVSAWPVTB
      CDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULAQWAWBUBOWBVTWPUMWCAUCUAWBWPUNW
      CAUDUAWBWPUOWCUPUQURACVRZWKRVPZWLRVPZGWDWBWPUSWCUTVAVBVCANMWBWPVDWCAWRNVO
      PVPVSWPVEWCVFAWMWPVGWCAUCUDSWDVOTVPRVPWQVOPVPVSWPVHWCVIALVRZEWBWPVJWCAWNW
      SWBWPVKWCAWQWTNJWDWNIWDVSWPVLWCAUCHVQWPVMWCAUDHVQWPVNWCAWPWEWFWGWHWJ $.

    mapdpglem17.ep $e |- E = ( ( ( invr ` A ) ` g ) .x. z ) $.
    $( Lemma for ~ mapdpg .  Baer p. 45, line 7:  "Hence we may form y' = g^-1
       z."  (Contributed by NM, 20-Mar-2015.)  (New usage is discouraged.) $)
    mapdpglem17N $p |- ( ph -> E e. F ) $=
      ( cv cinvr cfv cdr wcel wne clvec dvhlvec lvecdrng mapdpglem11 drnginvrcl
      syl eqid syl3anc csn clss wss clmod dvhlmod lspsncl syl2anc mapdcl2 lssss
      co sseldd lcdvscl syl5eqel ) AMLVQZDVRVSZVSZBVQZJWTNVPAFEDJKXGPRNUCXFUGUI
      VAVBUMUSVCUNADVTWAZXDEWAXDUFWBXFEWAAKWCWAXHAKPRUCUGUIUNWDDKVAWEWHVKABCDEF
      GHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJ
      VKVLVMVNWFEDXEXDUFVBVJXEWIWGWJAUEWKUAVSZSVSZNXGAXJFWLVSZWAXJNWMAFXIKWLVSZ
      XKKPRSUCUGUHUIXLWIZUMXKWIZUNAKWNWAUEUBWAXIXLWAAKPRUCUGUIUNWOUPXLUAUBKUEUJ
      XMULWPWQWRXKXJNFUSXNWSWHVLXAXBXC $.

    $( Lemma for ~ mapdpg .  Baer p. 45, line 7:  "Then y =/= 0..."
       (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem18 $p |- ( ph -> E =/= ( 0g ` C ) ) $=
      ( cv cinvr cfv co c0g wne csca cdr clvec dvhlvec lvecdrng syl mapdpglem11
      wcel eqid drnginvrn0 syl3anc lcd0 neeqtrrd mapdpglem16 lcdlvec drnginvrcl
      cbs lcdsbase eleqtrrd csn wss clmod dvhlmod lspsncl syl2anc mapdcl2 lssss
      clss sseldd lvecvsn0 mpbir2and 3netr4g ) ALVQZDVRVSZVSZBVQZJVTZFWAVSZMXTA
      XSXTWBXQFWCVSZWAVSZWBXRXTWBAXQUFYBADWDWJZXOEWJZXOUFWBZXQUFWBAKWEWJYCAKPRU
      CUGUIUNWFDKVAWGWHZVKABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQ
      URUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNWIZEDXPXOUFVBVJXPWKZWLWMAFYAKDPRYBUCUFU
      GUIVAVJUMYAWKZYBWKZUNWNWOABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNU
      OUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOWPAXQJYAYAWSVSZYBNFXRXTUSVCYIYKW
      KZYJXTWKZAFPRUCUGUMUNWQAXQEYKAYCYDYEXQEWJYFVKYGEDXPXOUFVBVJYHWRWMAFYKYAKD
      PREUCUGUIVAVBUMYIYLUNWTXAAUEXBUAVSZSVSZNXRAYOFXJVSZWJYONXCAFYNKXJVSZYPKPR
      SUCUGUHUIYQWKZUMYPWKZUNAKXDWJUEUBWJYNYQWJAKPRUCUGUIUNXEUPYQUAUBKUEUJYRULX
      FXGXHYPYONFUSYSXIWHVLXKXLXMVPYMXN $.

    $( Lemma for ~ mapdpg .  Baer p. 45, line 8:  "...is in (Fy)*..."
       (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem19 $p |- ( ph -> E e. ( M ` ( N ` { Y } ) ) ) $=
      ( cv cinvr cfv co csn clss eqid clmod dvhlmod lspsncl syl2anc mapdcl2 cdr
      wcel wne clvec dvhlvec lvecdrng mapdpglem11 drnginvrcl syl3anc lcdlssvscl
      syl syl5eqel ) AMLVQZDVRVSZVSZBVQZJVTUEWAUAVSZSVSZVPAFEFWBVSZJKDPRXFNUCXC
      XDUGUIVAVBUMUSVCXGWCZUNAFXEKWBVSZXGKPRSUCUGUHUIXIWCZUMXHUNAKWDWJUEUBWJXEX
      IWJAKPRUCUGUIUNWEUPXIUAUBKUEUJXJULWFWGWHADWIWJZXAEWJXAUFWKXCEWJAKWLWJXKAK
      PRUCUGUIUNWMDKVAWNWSVKABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUP
      UQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNWOEDXBXAUFVBVJXBWCWPWQVLWRWT $.

    $( Lemma for ~ mapdpg .  Baer p. 45, line 8:  "...so that (Fy)*=Gy'."
       (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem20 $p |- ( ph -> ( M ` ( N ` { Y } ) ) = ( J ` { E } ) ) $=
      ( clsa cfv csn c0g eqid lcdlvec dvhlmod wcel cdif eldifsn sylanbrc mapdat
      wne lsatlspsn mapdpglem19 mapdpglem18 lsatel ) AFVQVRZUEVSUAVRZSVRQFMFVTV
      RZWPWAURWNWAZAFPRUCUGUMUNWBAKVQVRZWNFWOKPRSUCUGUHUIWRWAZUMWQUNAWRUAUBKUEH
      UJULVGWSAKPRUCUGUIUNWCAUEUBWDUEHWIUEUBHVSWEWDUPVOUEUBHWFWGWJWHABCDEFGHIJK
      LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVL
      VMVNVOVPWKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAV
      BVCVDVEVFVGVHVIVJVKVLVMVNVOVPWLWM $.

    $( Lemma for ~ mapdpg .  (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem21 $p |- ( ph -> ( ( ( invr ` A ) ` g ) .x. t ) = ( G R E ) ) $=
      ( cv cinvr cfv co oveq2d csca cbs eqid lcdlmod cdr wcel wne clvec dvhlvec
      lvecdrng syl mapdpglem11 drnginvrcl syl3anc lcdsbase eleqtrrd lcdvscl csn
      clss wss clmod dvhlmod lspsncl syl2anc mapdcl2 lssss sseldd lmodsubdi cur
      wceq drnginvrr lcd1 eqtr4d oveq1d lcdvsass lmodvs1 3eqtr3d oveq2i syl6eqr
      cmulr 3eqtrd ) ALVQZDVRVSZVSZCVQZJVTYEYCOJVTZBVQZIVTZJVTYEYGJVTZYEYHJVTZI
      VTZOMIVTZAYFYIYEJVMWAAYEJFWBVSZYNWCVSZINFYGYHUSVCYNWDZYOWDZVDAFPRUCUGUMUN
      WEZAYEEYOADWFWGZYCEWGZYCUFWHZYEEWGAKWIWGYSAKPRUCUGUIUNWJDKVAWKWLZVKABCDEF
      GHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJ
      VKVLVMVNWMZEDYDYCUFVBVJYDWDZWNWOZAFYOYNKDPREUCUGUIVAVBUMYPYQUNWPWQAFEDJKO
      PRNUCYCUGUIVAVBUMUSVCUNVKVEWRAUEWSUAVSZSVSZNYHAUUGFWTVSZWGUUGNXAAFUUFKWTV
      SZUUHKPRSUCUGUHUIUUIWDZUMUUHWDZUNAKXBWGUEUBWGUUFUUIWGAKPRUCUGUIUNXCUPUUIU
      AUBKUEUJUUJULXDXEXFUUHUUGNFUSUUKXGWLVLXHXIAYLOYKIVTYMAYJOYKIAYCYEDYAVSZVT
      ZOJVTYNXJVSZOJVTZYJOAUUMUUNOJAUUMDXJVSZUUNAYSYTUUAUUMUUPXKUUBVKUUCEDUULUU
      PYDYCUFVBVJUULWDZUUPWDZUUDXLWOAFYNKUUPDPUUNRUCUGUIVAUURUMYPUUNWDZUNXMXNXO
      AFDJUULKNOPREUCYEYCUGUIVAVBUUQUMUSVCUNUUEVKVEXPAFXBWGONWGUUOOXKYRVEJUUNYN
      NFOUSYPVCUUSXQXEXRXOMYKOIVPXSXTYB $.

    $( Lemma for ~ mapdpg .  Baer p. 45, line 9:  "(F(x-y))* = ... =
       G(x'-y')."  (Contributed by NM, 20-Mar-2015.) $)
    mapdpglem22 $p |- ( ph
           -> ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R E ) } ) ) $=
      ( co csn cfv cv cinvr wcel csca cbs c0g wne wceq lcdlvec dvhlvec lvecdrng
      clvec cdr syl mapdpglem11 drnginvrcl syl3anc lcdsbase eleqtrrd drnginvrn0
      eqid lcd0 neeqtrrd mapdpglem2a lspsnvs syl121anc mapdpglem21 sneqd fveq2d
      3eqtr2d ) AUDUETVQVRUAVSSVSCVTZVRQVSZLVTZDWAVSZVSZXJJVQZVRZQVSZOMIVQZVRZQ
      VSVIAFWKWBXNFWCVSZWDVSZWBXNXTWEVSZWFXJNWBXQXKWGAFPRUCUGUMUNWHAXNEYAADWLWB
      ZXLEWBZXLUFWFZXNEWBAKWKWBYCAKPRUCUGUIUNWIDKVAWJWMZVKABCDEFGHIJKLNOPQRSTUA
      UBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNWNZEDXM
      XLUFVBVJXMWTZWOWPAFYAXTKDPREUCUGUIVAVBUMXTWTZYAWTZUNWQWRAXNUFYBAYCYDYEXNU
      FWFYFVKYGEDXMXLUFVBVJYHWSWPAFXTKDPRYBUCUFUGUIVAVJUMYIYBWTZUNXAXBACFGKNPQR
      STUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTXCXNJXTYAQNFXJYBUSYIVCYJYKURXDXEA
      XPXSQAXOXRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAV
      BVCVDVEVFVGVHVIVJVKVLVMVNVOVPXFXGXHXI $.

    $d h E $.  $d h F $.  $d h G $.  $d h J $.  $d h M $.  $d h N $.  $d h R $.
    $d h .- $.  $d h X $.  $d h Y $.
    $( Lemma for ~ mapdpg .  Baer p. 45, line 10:  "and so y' meets all our
       requirements."  Our ` h ` is Baer's y'.  (Contributed by NM,
       20-Mar-2015.) $)
    mapdpglem23 $p |- ( ph ->
            E. h e. F ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
         /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R h ) } ) ) ) $=
      ( wcel csn cfv wceq co cv wa wrex clss eqid clmod dvhlmod lspsncl syl2anc
      mapdcl2 mapdpglem19 lssel mapdpglem20 mapdpglem22 sneq fveq2d oveq2 sneqd
      eqeq2d anbi12d rspcev syl12anc ) ANOVRZUFVSUBVTZTVTZNVSZRVTZWAZUEUFUAWBVS
      UBVTTVTZPNIWBZVSZRVTZWAZXGMWCZVSZRVTZWAZXKPXPIWBZVSZRVTZWAZWDZMOWEAXGFWFV
      TZVRNXGVRXEAFXFKWFVTZYEKQSTUDUHUIUJYFWGZUNYEWGZUOAKWHVRUFUCVRXFYFVRAKQSUD
      UHUJUOWIUQYFUBUCKUFUKYGUMWJWKWLABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKU
      LUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOVPVQWMYEXGOFNUTYHWNWKABCDE
      FGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIV
      JVKVLVMVNVOVPVQWOABCDEFGHIJKLNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURU
      SUTVAVBVCVDVEVFVGVHVIVJVKVLVMVNVOVPVQWPYDXJXOWDMNOXPNWAZXSXJYCXOYIXRXIXGY
      IXQXHRXPNWQWRXAYIYBXNXKYIYAXMRYIXTXLXPNPIWSWTWRXAXBXCXD $.
  $}

  ${
    mapdpg.h $e |- H = ( LHyp ` K ) $.
    mapdpg.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdpg.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdpg.v $e |- V = ( Base ` U ) $.
    mapdpg.s $e |- .- = ( -g ` U ) $.
    mapdpg.z $e |- .0. = ( 0g ` U ) $.
    mapdpg.n $e |- N = ( LSpan ` U ) $.
    mapdpg.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdpg.f $e |- F = ( Base ` C ) $.
    mapdpg.r $e |- R = ( -g ` C ) $.
    mapdpg.j $e |- J = ( LSpan ` C ) $.
    mapdpg.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdpg.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    mapdpg.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    mapdpg.g $e |- ( ph -> G e. F ) $.
    mapdpg.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    mapdpg.e $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { G } ) ) $.
    $( Lemma for ~ mapdpg .  (Contributed by NM, 22-Mar-2015.) $)
    mapdpglem30a $p |- ( ph -> G =/= ( 0g ` C ) ) $=
      ( csn cfv clsa wcel c0g wne eqid dvhlmod mapdat eqeltrrd lcdlmod lsatspn0
      lsatlspsn mpbid ) AFUOHUPZBUQUPZURFBUSUPZUTAOUOLUPZJUPVIVJUNADUQUPZVJBVLD
      GIJNRSTVMVAZUEVJVAZUIAVMLMDOQUAUDUCVNADGINRTUIVBUJVGVCVDAVJHEBFVKUFUHVKVA
      VOABGINRUEUIVEULVFVH $.

    ${
      mapdpgem25.h1 $e |- ( ph ->
              ( h e. F /\ ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R h ) } ) ) ) ) $.
      mapdpgem25.i1 $e |- ( ph ->
              ( i e. F /\ ( ( M ` ( N ` { Y } ) ) = ( J ` { i } )
           /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R i ) } ) ) ) ) $.
      $( Lemma for ~ mapdpg .  (Contributed by NM, 22-Mar-2015.) $)
      mapdpglem30b $p |- ( ph -> i =/= ( 0g ` C ) ) $=
        ( cv csn cfv clsa wcel c0g wne wceq co wa simprd eqid dvhlmod lsatlspsn
        simpld mapdat eqeltrrd lcdlmod lsatspn0 mpbid ) AFUSZUTJVAZBVBVAZVCVSBV
        DVAZVEARUTNVAZLVAZVTWAAWDVTVFZQRMVGUTNVALVAHVSCVGUTJVAVFZAVSGVCZWEWFVHZ
        URVIVMADVBVAZWABWCDIKLPTUAUBWIVJZUGWAVJZUKAWINODRSUCUFUEWJADIKPTUBUKVKU
        MVLVNVOAWAJGBVSWBUHUJWBVJWKABIKPTUGUKVPAWGWHURVMVQVR $.

      $( Lemma for ~ mapdpg .  Baer p. 45 line 12:  "Then we have Gy' =
         Gy'' and G(x'-y') = G(x'-y'')."  (Contributed by NM, 21-Mar-2015.) $)
      mapdpglem25 $p |- ( ph -> ( ( J ` { h } ) = ( J ` { i } )
         /\ ( J ` { ( G R h ) } ) = ( J ` { ( G R i ) } ) ) ) $=
        ( cv csn cfv wceq co wcel wa simprd simpld eqtr3d jca ) AEUSZUTJVAZFUSZ
        UTJVAZVBHVJCVCUTJVAZHVLCVCUTJVAZVBARUTNVALVAZVKVMAVPVKVBZQRMVCUTNVALVAZ
        VNVBZAVJGVDVQVSVEUQVFZVGAVPVMVBZVRVOVBZAVLGVDWAWBVEURVFZVGVHAVRVNVOAVQV
        SVTVFAWAWBWCVFVHVI $.

      $d h i u v $.  $d u v B $.  $d u v C $.  $d u v O $.  $d u v .x. $.
      $d v G $.  $d v R $.
      mapdpglem26.a $e |- A = ( Scalar ` U ) $.
      mapdpglem26.b $e |- B = ( Base ` A ) $.
      mapdpglem26.t $e |- .x. = ( .s ` C ) $.
      mapdpglem26.o $e |- O = ( 0g ` A ) $.
      ${
        $d u v ph $.
        $( Lemma for ~ mapdpg .  Baer p. 45 line 14:  "Consequently there exist
           numbers u,v in G neither of which is 0 such that y = uy'' and..."
           (We scope $d ` u ph ` locally to avoid clashes with later
           substitutions into ` ph ` .)  (Contributed by NM, 22-Mar-2015.) $)
        mapdpglem26 $p |- ( ph -> E. u e. ( B \ { O } ) h = ( u .x. i ) ) $=
          ( csn cfv wceq cdif wrex mapdpglem25 simpld csca cbs c0g eqid lcdlvec
          cv co wcel lspsneq lcdsbase lcd0 sneqd difeq12d rexeqdv bitrd mpbid
          wa ) AIVTZVHNVIZJVTZVHNVIZVJZWLBVTWNGWAVJZBDSVHZVKZVLZAWPLWLFWAVHNVIZ
          LWNFWAVHNVIZVJAEFHIJKLMNOPQRTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUT
          VAVBVCVMVNAWPWQBEVOVIZVPVIZXCVQVIZVHZVKZVLWTAXCGBXDNKEWLWNXEUMXCVRZXD
          VRZXEVRZVFUOAEMOUAUEULUPVSAWLKWBUCVHRVIPVIZWMVJUBUCQWAVHRVIPVIZXAVJWK
          VBVNAWNKWBXKWOVJXLXBVJWKVCVNWCAWQBXGWSAXDDXFWRAEXDXCHCMODUAUEUGVDVEUL
          XHXIUPWDAXESAEXCHCMOXEUASUEUGVDVGULXHXJUPWEWFWGWHWIWJ $.

        $( Lemma for ~ mapdpg .  Baer p. 45 line 16:  "v(x'-y'') = x'-y'" (with
           equality swapped).  (Contributed by NM, 22-Mar-2015.) $)
        mapdpglem27 $p |- ( ph
            -> E. v e. ( B \ { O } ) ( G R h ) = ( v .x. ( G R i ) ) ) $=
          ( csn cfv wceq cdif wrex mapdpglem25 simprd csca cbs c0g eqid lcdlvec
          cv clmod wcel lcdlmod simpld lmodvsubcl syl3anc lspsneq lcdsbase lcd0
          co wa sneqd difeq12d rexeqdv bitrd mpbid ) ALIVTZFWJZVHNVIZLJVTZFWJZV
          HNVIZVJZWRBVTXAGWJVJZBDSVHZVKZVLZAWQVHNVIZWTVHNVIZVJXCAEFHIJKLMNOPQRT
          UAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVMVNAXCXDBEVOVIZVPVIZXJ
          VQVIZVHZVKZVLXGAXJGBXKNKEWRXAXLUMXJVRZXKVRZXLVRZVFUOAEMOUAUEULUPVSAEW
          AWBZLKWBZWQKWBZWRKWBAEMOUAUEULUPWCZUSAXTUCVHRVIPVIZXHVJUBUCQWJVHRVIPV
          IZWSVJWKVBWDFKELWQUMUNWEWFAXRXSWTKWBZXAKWBYAUSAYDYBXIVJYCXBVJWKVCWDFK
          ELWTUMUNWEWFWGAXDBXNXFAXKDXMXEAEXKXJHCMODUAUEUGVDVEULXOXPUPWHAXLSAEXJ
          HCMOXLUASUEUGVDVGULXOXQUPWIWLWMWNWOWP $.
      $}

      mapdpglem28.ve $e |- ( ph -> v e. B ) $.
      mapdpglem28.u1 $e |- ( ph -> h = ( u .x. i ) ) $.
      mapdpglem28.u2 $e |- ( ph -> ( G R h ) = ( v .x. ( G R i ) ) ) $.
      $( Lemma for ~ mapdpg .  Baer p. 45 line 16:  "But Gx' and Gy'' are
         distinct points and so x' and y'' are independent elements in B.
         (Contributed by NM, 22-Mar-2015.) $)
      mapdpglem29 $p |- ( ph -> ( J ` { G } ) =/= ( J ` { i } ) ) $=
        ( csn cfv cv wne clss eqid clmod dvhlmod eldifad lspsncl syl2anc mapd11
        wcel necon3bid mpbird wceq co wa simprd simpld 3netr3d ) AUCVLSVMZQVMZU
        DVLSVMZQVMZMVLOVMKVNZVLOVMZAWNWPVOWMWOVOVAAWNWPWMWOAIVPVMZINPQUBWMWOUFU
        HWSVQZUGUQAIVRWDZUCUAWDWMWSWDAINPUBUFUHUQVSZAUCUAUEVLZURVTWSSUAIUCUIWTU
        LWAWBAXAUDUAWDWOWSWDXBAUDUAXCUSVTWSSUAIUDUIWTULWAWBWCWEWFVBAWPWRWGZUCUD
        RWHVLSVMQVMMWQGWHVLOVMWGZAWQLWDXDXEWIVDWJWKWL $.

      $( Lemma for ~ mapdpg .  Baer p. 45 line 18:  "vx'-vy'' = x'-uy''".
         (Contributed by NM, 22-Mar-2015.) $)
      mapdpglem28 $p |- ( ph
        -> ( ( v .x. G ) R ( v .x. i ) ) = ( G R ( u .x. i ) ) ) $=
        ( cv co oveq2d csca cfv cbs eqid lcdlmod lcdsbase eleqtrrd wcel wceq wa
        csn simpld lmodsubdi 3eqtr3rd ) AMJVLZGVMBVLZMKVLZGVMZHVMMCVLWKHVMZGVMW
        JMHVMWJWKHVMGVMVKAWIWMMGVJVNAWJHFVOVPZWNVQVPZGLFMWKUNVGWNVRZWOVRZUOAFNP
        UBUFUMUQVSAWJEWOVIAFWOWNIDNPEUBUFUHVEVFUMWPWQUQVTWAUTAWKLWBUDWESVPQVPWK
        WEOVPWCUCUDRVMWESVPQVPWLWEOVPWCWDVDWFWGWH $.

      mapdpglem28.ue $e |- ( ph -> u e. B ) $.
      $( Lemma for ~ mapdpg .  Baer p. 45 line 18:  "Hence we deduce (from
         ~ mapdpglem28 , using ~ lvecindp2 ) that v = 1 and v = u...".  TODO:
         would it be shorter to have only the ` v = ( 1r `` A ) ` part and use
         mapdpglem28.u2 in ~ mapdpglem31 ?  (Contributed by NM,
         22-Mar-2015.) $)
      mapdpglem30 $p |- ( ph -> ( v = ( 1r ` A ) /\ v = u ) ) $=
        ( cv cur cfv wceq cminusg cmulr co weq cplusg csca cbs c0g eqid lcdlvec
        wa wcel wne csn cdif mapdpglem30a sylanbrc simpld mapdpglem30b lcdsbase
        eldifsn eleqtrrd crg clmod dvhlmod lmodrng cgrp rnggrp rngidcl grpinvcl
        syl2anc syl3anc mapdpglem29 lcdvsass oveq2d lcdvscl lcdvsub mapdpglem28
        syl rngcl lcd1 oveq1d lcdlmod lmodvs1 eqtr3d 3eqtr2rd lvecindp2 rngnegr
        eqtr4d eqeq12d grpinv11 bitrd anbi2d mpbid ) ABVMZDVNVOZVPZYKYLDVQVOZVO
        ZDVRVOZVSZCVMZYOYPVSZVPZWGYMBCVTZWGAYKYQYLYSFWAVOZHFWBVOZUUCWCVOZOLFMKV
        MZFWDVOZUNUUBWEZUUCWEZUUDWEZVGUUFWEUPAFNPUBUFUMUQWFAMLWHZMUUFWIMLUUFWJW
        KZWHUTAFGILMNOPQRSUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBWLMLUUFWQ
        WMAUUELWHZUUEUUFWIUUEUUKWHAUULUDWJSVOQVOUUEWJOVOVPUCUDRVSWJSVOQVOMUUEGV
        SWJOVOVPWGVDWNZAFGIJKLMNOPQRSUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVA
        VBVCVDWOUUELUUFWQWMAYKEUUDVIAFUUDUUCIDNPEUBUFUHVEVFUMUUHUUIUQWPZWRAYQEU
        UDADWSWHZYKEWHYOEWHZYQEWHAIWTWHUUOAINPUBUFUHUQXADIVEXBXOZVIADXCWHZYLEWH
        ZUUPAUUOUURUUQDXDXOZAUUOUUSUUQEDYLVFYLWEZXEXOZEDYNYLVFYNWEZXFXGZEDYPYKY
        OVFYPWEZXPXHUUNWRAYLEUUDUVBUUNWRAYSEUUDAUUOYREWHUUPYSEWHUUQVLUVDEDYPYRY
        OVFUVEXPXHUUNWRABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQUR
        USUTVAVBVCVDVEVFVGVHVIVJVKXIAYLMHVSZYSUUEHVSZUUBVSUVFYOYRUUEHVSZHVSZUUB
        VSUVFUVHGVSZYKMHVSZYQUUEHVSZUUBVSZAUVGUVIUVFUUBAFDHYPILUUENPEUBYOYRUFUH
        VEVFUVEUMUNVGUQUVDVLUUMXJXKAFUUBDHIYLUVFUVHNPGYNLUBUFUHVEUVCUVAUMUNUUGV
        GUOUQAFEDHIMNPLUBYLUFUHVEVFUMUNVGUQUVBUTXLAFEDHIUUENPLUBYRUFUHVEVFUMUNV
        GUQVLUUMXLXMAUVMUVKYOYKUUEHVSZHVSZUUBVSUVKUVNGVSZUVJAUVLUVOUVKUUBAFDHYP
        ILUUENPEUBYOYKUFUHVEVFUVEUMUNVGUQUVDVIUUMXJXKAFUUBDHIYLUVKUVNNPGYNLUBUF
        UHVEUVCUVAUMUNUUGVGUOUQAFEDHIMNPLUBYKUFUHVEVFUMUNVGUQVIUTXLAFEDHIUUENPL
        UBYKUFUHVEVFUMUNVGUQVIUUMXLXMAUVPMUVHGVSUVJABCDEFGHIJKLMNOPQRSTUAUBUCUD
        UEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKXNAUVFMUVHGAUUCVN
        VOZMHVSZUVFMAUVQYLMHAFUUCIYLDNUVQPUBUFUHVEUVAUMUUHUVQWEZUQXQXRAFWTWHUUJ
        UVRMVPAFNPUBUFUMUQXSUTHUVQUUCLFMUNUUHVGUVSXTXGYAXRYEYBYBYCAYTUUAYMAYTYK
        YNVOZYRYNVOZVPUUAAYQUVTYSUWAAEDYPYLYNYKVFUVEUVAUVCUUQVIYDAEDYPYLYNYRVFU
        VEUVAUVCUUQVLYDYFAEDYNYKYRVFUVCUUTVIVLYGYHYIYJ $.

      $( Lemma for ~ mapdpg .  Baer p. 45 line 19:  "...and we have
         consequently that y' = y'', as we claimed."  (Contributed by NM,
         23-Mar-2015.) $)
      mapdpglem31 $p |- ( ph -> h = i ) $=
        ( cv co csca cfv cur eqid lcd1 oveq1d clmod wcel wceq lcdlmod wa simpld
        csn lmodvs1 syl2anc weq mapdpglem30 eqtr2 syl 3eqtr3rd eqtrd ) AJVMCVMZ
        KVMZHVNZWQVJAFVOVPZVQVPZWQHVNZDVQVPZWQHVNWQWRAWTXBWQHAFWSIXBDNWTPUBUFUH
        VEXBVRUMWSVRZWTVRZUQVSVTAFWAWBWQLWBZXAWQWCAFNPUBUFUMUQWDAXEUDWGSVPQVPWQ
        WGOVPWCUCUDRVNWGSVPQVPMWQGVNWGOVPWCWEVDWFHWTWSLFWQUNXCVGXDWHWIAXBWPWQHA
        BVMZXBWCBCWJWEXBWPWCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOU
        PUQURUSUTVAVBVCVDVEVFVGVHVIVJVKVLWKXFXBWPWLWMVTWNWO $.
    $}

    $d g h t z C $.  $d g h t z F $.  $d g h t z G $.  $d g h t z J $.
    $d g h t z M $.  $d g h t z N $.  $d g h t z R $.  $d g h t z .- $.
    $d g h z U $.  $d g h t z X $.  $d g h t z Y $.  $d g t z ph $.
    $( Lemma for ~ mapdpg .  Existence part - consolidate hypotheses in
       ~ mapdpglem23 .  (Contributed by NM, 21-Mar-2015.) $)
    mapdpglem24 $p |- ( ph ->
              E. h e. F ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R h ) } ) ) ) $=
      ( vt vg vz co csn cv wceq clsm wrex wa eldifad eqid mapdpglem2 wcel cvsca
      cfv w3a csca cbs 3ad2ant1 simp2 mapdpglem3 cinvr c0g simp12 simp13 simp2l
      chlt wne simp2r simp3 cdif eldifsni mapdpglem23 3exp rexlimdvv rexlimdv3a
      syl mpd ) APQLUSUTMVKKVKZUPVAZUTIVKVBZUPPUTMVKZKVKZQUTMVKZKVKZBVCVKZUSZVD
      XAEVAZUTIVKVBWOGXDCUSUTIVKVBVEEFVDZAUPBXBDHIJKLMNOPQSTUAUBUCUEUFUJAPNRUTZ
      UKVFZAQNXFULVFZXBVGZUIVHAWQXEUPXCAWPXCVIZWQVLZWPUQVAZGBVJVKZUSURVAZCUSVBZ
      URXAVDUQDVMVKZVNVKZVDXEXKURUPXPXQBXBCXMDUQFGHIJKLMNOPQSTUAUBUCUEUFAXJJWCV
      IOHVIVEZWQUJVOZAXJPNVIZWQXGVOZAXJQNVIZWQXHVOZXIUIUGAXJWQVPXPVGZXQVGZXMVGZ
      UHAXJGFVIZWQUMVOZAXJWSGUTIVKVBZWQUOVOZVQXKXOXEUQURXQXAXKXLXQVIZXNXAVIZVEZ
      XOXEXKYMXOVLURUPXPXQBXBRCXMDUQEXLXPVRVKVKXNXMUSZFGHIJKLMNOPQXPVSVKZSTUAUB
      UCUEUFXKYMXRXOXSVOXKYMXTXOYAVOXKYMYBXOYCVOXIUIUGAXJWQYMXOVTYDYEYFUHXKYMYG
      XOYHVOXKYMYIXOYJVOUDXKYMWRWTWDZXOAXJYPWQUNVOVOAXJWQYMXOWAYOVGXKYKYLXOWBXK
      YKYLXOWEXKYMXOWFXKYMPRWDZXOAXJYQWQAPNXFWGZVIYQUKPNRWHWMVOVOXKYMQRWDZXOAXJ
      YSWQAQYRVIYSULQNRWHWMVOVOYNVGWIWJWKWNWLWN $.

    $d u v C $.  $d u v F $.  $d u v G $.  $d u v J $.  $d u v M $.
    $d u v N $.  $d u v R $.  $d u v .- $.  $d u v U $.  $d u v X $.
    $d u v Y $.  $d u v h i $.  $d u v ph $.
    $( Lemma for ~ mapdpg .  Uniqueness part - consolidate hypotheses in
       ~ mapdpglem31 .  (Contributed by NM, 23-Mar-2015.) $)
    mapdpglem32 $p |- ( ( ph /\ ( h e. F /\ i e. F )
  /\ ( ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
   /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R h ) } ) )
  /\ ( ( M ` ( N ` { Y } ) ) = ( J ` { i } )
  /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R i ) } ) ) ) ) -> h = i ) $=
      ( vu vv cv wcel wa csn cfv wceq w3a cvsca csca cbs c0g cdif wrex weq chlt
      3ad2ant1 wne simp2l simp3l jca simp2r simp3r eqid mapdpglem26 mapdpglem27
      co reeanv sylanbrc simp12l simp13l simp12r simp13r eldifi adantl 3ad2ant2
      adantr mapdpglem31 3exp rexlimdvv mpd ) AEUSZGUTZFUSZGUTZVAZRVBNVCZLVCZWS
      VBJVCVDQRMWDVBNVCLVCZHWSCWDZVBJVCVDVAZXEXAVBJVCVDXFHXACWDZVBJVCVDVAZVAZVE
      ZWSUQUSZXABVFVCZWDVDZXGURUSZXIXNWDVDZVAZURDVGVCZVHVCZXSVIVCZVBZVJZVKUQYCV
      KZEFVLZXLXOUQYCVKXQURYCVKYDXLUQXSXTBCXNDEFGHIJKLMNYAOPQRSTUAUBUCUDUEUFUGU
      HUIUJAXCKVMUTPIUTVAZXKUKVNZAXCQOSVBVJZUTZXKULVNZAXCRYHUTZXKUMVNZAXCHGUTZX
      KUNVNZAXCQVBNVCZXDVOZXKUOVNZAXCYOLVCHVBJVCVDZXKUPVNZXLWTXHAWTXBXKVPAXCXHX
      JVQVRZXLXBXJAWTXBXKVSAXCXHXJVTVRZXSWAZXTWAZXNWAZYAWAZWBXLURXSXTBCXNDEFGHI
      JKLMNYAOPQRSTUAUBUCUDUEUFUGUHUIUJYGYJYLYNYQYSYTUUAUUBUUCUUDUUEWCXOXQUQURY
      CYCWEWFXLXRYEUQURYCYCXLXMYCUTZXPYCUTZVAZXRYEXLUUHXRVEZURUQXSXTBCXNDEFGHIJ
      KLMNYAOPQRSTUAUBUCUDUEUFUGUHUIUJXLUUHYFXRYGVNXLUUHYIXRYJVNXLUUHYKXRYLVNXL
      UUHYMXRYNVNXLUUHYPXRYQVNXLUUHYRXRYSVNUUIWTXHWTXBAXKUUHXRWGXHXJAXCUUHXRWHV
      RUUIXBXJWTXBAXKUUHXRWIXHXJAXCUUHXRWJVRUUBUUCUUDUUEUUHXLXPXTUTZXRUUGUUJUUF
      XPXTYBWKWLWMXLUUHXOXQVQXLUUHXOXQVTUUHXLXMXTUTZXRUUFUUKUUGXMXTYBWKWNWMWOWP
      WQWR $.

    $d i F $.  $d i G $.  $d i J $.  $d i M $.  $d i N $.  $d i R $.  $d i X $.
    $d i .- $.  $d h i ph $.  $d i Y $.
    $( Part 1 of proof of the first fundamental theorem of projective
       geometry.  Part (1) in [Baer] p. 44.  Our notation corresponds to Baer's
       as follows: ` M ` for *, ` N `` { } ` for F(), ` J `` { } ` for G(),
       ` X ` for x, ` G ` for x', ` Y ` for y, ` h ` for y'.  TODO:  Rename
       variables per ~ mapdhval .  (Contributed by NM, 22-Mar-2015.) $)
    mapdpg $p |- ( ph ->
              E! h e. F ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( G R h ) } ) ) ) $=
      ( vi csn cfv cv wceq co wa wrex wi wral wreu mapdpglem24 wcel mapdpglem32
      weq 3exp ralrimivv sneq fveq2d eqeq2d oveq2 sneqd anbi12d reu4 sylanbrc )
      AQUQMURKURZEUSZUQZIURZUTZPQLVAUQMURKURZGWBCVAZUQZIURZUTZVBZEFVCWKWAUPUSZU
      QZIURZUTZWFGWLCVAZUQZIURZUTZVBZVBZEUPVJZVDZUPFVEEFVEWKEFVFABCDEFGHIJKLMNO
      PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVGAXCEUPFFAWBFVHWLFVHVBXAXBABCDEUPFGHI
      JKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVIVKVLWKWTEUPFXBWEWOWJWSXBWDWNWA
      XBWCWMIWBWLVMVNVOXBWIWRWFXBWHWQIXBWGWPWBWLGCVPVQVNVOVRVSVT $.
  $}

  ${
    baerlem3.v $e |- V = ( Base ` W ) $.
    baerlem3.m $e |- .- = ( -g ` W ) $.
    baerlem3.o $e |- .0. = ( 0g ` W ) $.
    baerlem3.s $e |- .(+) = ( LSSum ` W ) $.
    baerlem3.n $e |- N = ( LSpan ` W ) $.
    baerlem3.w $e |- ( ph -> W e. LVec ) $.
    baerlem3.x $e |- ( ph -> X e. V ) $.
    baerlem3.c $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    baerlem3.d $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
    baerlem3.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    baerlem3.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
    ${
      baerlem3.p $e |- .+ = ( +g ` W ) $.
      baerlem3.t $e |- .x. = ( .s ` W ) $.
      baerlem3.r $e |- R = ( Scalar ` W ) $.
      baerlem3.b $e |- B = ( Base ` R ) $.
      baerlem3.a $e |- .+^ = ( +g ` R ) $.
      baerlem3.l $e |- L = ( -g ` R ) $.
      baerlem3.q $e |- Q = ( 0g ` R ) $.
      baerlem3.i $e |- I = ( invg ` R ) $.
      ${
        baerlem3.a1 $e |- ( ph -> a e. B ) $.
        baerlem3.b1 $e |- ( ph -> b e. B ) $.
        baerlem3.d1 $e |- ( ph -> d e. B ) $.
        baerlem3.e1 $e |- ( ph -> e e. B ) $.
        baerlem3.j1 $e |- ( ph -> j = ( ( a .x. Y ) .+ ( b .x. Z ) ) ) $.
        baerlem3.j2 $e |- ( ph
            -> j = ( ( d .x. ( X .- Y ) ) .+ ( e .x. ( X .- Z ) ) ) ) $.
        $( Lemma for ~ baerlem3 .  (Contributed by NM, 9-Apr-2015.) $)
        baerlem3lem1 $p |- ( ph -> j = ( a .x. ( Y .- Z ) ) ) $=
          ( cv co cur cfv clmod wcel wceq lveclmod syl eldifad lmodvscl syl3anc
          clvec csn eqid lmodvsubval2 lmodsubdi cgrp crg lmodrng rnggrp lmod1cl
          cmulr grpinvcl syl2anc lmodvsass syl13anc cabel rngabl ablinvadd clss
          rngnegl cminusg cpr lspprcl lsppreli lssvnegcl rng0cl lmod0vs lmodgrp
          rngacl oveq1d lmodvacl grplid lmodabl ablsub4 syl122anc oveq12d eqtrd
          lmodvsdir 3eqtr4rd grpsubval 3eqtr3d 3eqtrd lvecindp simpld fveq2d wa
          simprd lmodnegadd lvecindp2 oveq12 wb grpinvid1 mpbird eqtr3d oveq2d
          grpinvid eqtr4d ) AUAVIZRHVJZYRTHVJZMVJZYSGVKVLZKVLZYTHVJZCVJZYRRTMVJ
          HVJJVIZAPVMVNZYSOVNZYTOVNZUUAUUEVOAPWAVNUUGUIPVPVQZAUUGYRBVNZROVNZUUH
          UUJVCAROSWBZUMVRZYRHGBOPRUDUQUPURVSVTZAUUGUUKTOVNZUUIUUJVCATOUUMUNVRZ
          YRHGBOPTUDUQUPURVSVTYSYTCHUUBGMKOPUDUOUEUQUPVBUUBWCZWDVTAYRHGBMOPRTUD
          UPUQURUEUUJVCUUNUUQWEAUUFYSUBVIZTHVJZCVJZUUEVGAUUDUUTYSCAUUCYRGWKVLZV
          JZTHVJZUUDUUTAUUGUUCBVNZUUKUUPUVDUUDVOUUJAGWFVNZUUBBVNZUVEAGWGVNZUVFA
          UUGUVHUUJGPUQWHVQZGWIVQZAUUGUVGUUJUUBGBPUQURUURWJVQBGKUUBURVBWLWMVCUU
          QUUCYRHUVBGBOPTUDUQUPURUVBWCZWNWOAUVCUUSTHAUVCYRKVLZUUSABGUVBUUBKYRUR
          UVKUURVBUVIVCWTAUVLUUSVOZYRUUSDVJZFVOZAUVNFKVLZFAUCVIZIVIZDVJZKVLZUVQ
          KVLZUVRKVLZDVJZUVPUVNAGWPVNZUVQBVNZUVRBVNZUVTUWCVOAUVHUWDUVIGWQVQVEVF
          BDGKUVQUVRURUSVBWRVTAFUVSKAFUVSVOZUVAUVQRHVJZUVRTHVJZCVJZPXAVLZVLZVOZ
          AFUVSCPWSVLZHRTXBNVLZGBOPQUVAUWLUDUOUQURUPUWNWCZUIAUWNNOPRTUDUWPUHUUJ
          UUNUUQXCZUJUKAYRUUSCHGBNOPRTUDUOUPUQURUHUUJVCVDUUNUUQXDAUUGUWOUWNVNUW
          JUWOVNUWLUWOVNUUJUWQAUVQUVRCHGBNOPRTUDUOUPUQURUHUUJVEVFUUNUUQXDUWNUWO
          UWKPUWJUWPUWKWCZXEVTAUVHFBVNUVIBGFURVAXFVQAUVHUWEUWFUVSBVNZUVIVEVFBDG
          UVQUVRURUSXIVTZAFQHVJZUVACVJSUVACVJZUVAUVSQHVJZUWLCVJZAUXASUVACAUUGQO
          VNZUXASVOUUJUJHGFOPQSUDUQUPVAUFXGWMXJAPWFVNZUVAOVNZUXBUVAVOAUUGUXFUUJ
          PXHVQAUUGUUHUUTOVNZUXGUUJUUOAUUGUUSBVNZUUPUXHUUJVDUUQUUSHGBOPTUDUQUPU
          RVSVTCOPYSUUTUDUOXKVTOCPUVASUDUOUFXLWMAUUFUXCUWJMVJZUVAUXDAUVQQHVJZUV
          RQHVJZCVJZUWJMVJZUXKUWHMVJZUXLUWIMVJZCVJZUXJUUFAPWPVNZUXKOVNZUXLOVNZU
          WHOVNZUWIOVNZUXNUXQVOAUUGUXRUUJPXMVQAUUGUWEUXEUXSUUJVEUJUVQHGBOPQUDUQ
          UPURVSVTAUUGUWFUXEUXTUUJVFUJUVRHGBOPQUDUQUPURVSVTAUUGUWEUULUYAUUJVEUU
          NUVQHGBOPRUDUQUPURVSVTZAUUGUWFUUPUYBUUJVFUUQUVRHGBOPTUDUQUPURVSVTZOCP
          MUWIUXKUXLUWHUDUOUEXNXOAUXCUXMUWJMAUUGUWEUWFUXEUXCUXMVOUUJVEVFUJCDUVQ
          UVRHGBOPQUDUOUQUPURUSXRWOXJAUUFUVQQRMVJHVJZUVRQTMVJHVJZCVJUXQVHAUYEUX
          OUYFUXPCAUVQHGBMOPQRUDUPUQURUEUUJVEUJUUNWEAUVRHGBMOPQTUDUPUQURUEUUJVF
          UJUUQWEXPXQXSVGAUXCOVNZUWJOVNZUXJUXDVOAUUGUWSUXEUYGUUJUWTUJUVSHGBOPQU
          DUQUPURVSVTAUUGUYAUYBUYHUUJUYCUYDCOPUWHUWIUDUOXKVTOCPUWKMUXCUWJUDUOUW
          RUEXTWMYAYBYCZYDYEAYRUWAVOUUSUWBVOYFUVNUWCVOAYRUUSUWAUWBCHGBNOPRTSUDU
          OUQURUPUFUHUIUMUNVCVDAUVFUWEUWABVNUVJVEBGKUVQURVBWLWMAUVFUWFUWBBVNUVJ
          VFBGKUVRURVBWLWMULAUVAUWLUWARHVJUWBTHVJCVJAUWGUWMUYIYGAUVQUVRCGHKBUWK
          OPRTUDUOUPUWRUQURVBUUJVEVFUUNUUQYHXQYIYRUWAUUSUWBDYJVQXSAUVFUVPFVOUVJ
          GKFVAVBYPVQXQAUVFUUKUXIUVMUVOYKUVJVCVDBDGKYRUUSFURUSVAVBYLVTYMXQXJYNY
          OYQXS $.

      $}

      ${
        baerlem5a.a1 $e |- ( ph -> a e. B ) $.
        baerlem5a.b1 $e |- ( ph -> b e. B ) $.
        baerlem5a.d1 $e |- ( ph -> d e. B ) $.
        baerlem5a.e1 $e |- ( ph -> e e. B ) $.
        baerlem5a.j1 $e |- ( ph ->
          j = ( ( a .x. ( X .- Y ) ) .+ ( b .x. Z ) ) ) $.
        baerlem5a.j2 $e |- ( ph
            -> j = ( ( d .x. ( X .- Z ) ) .+ ( e .x. Y ) ) ) $.
        $( Lemma for ~ baerlem5a .  (Contributed by NM, 13-Apr-2015.) $)
        baerlem5alem1 $p |- ( ph -> j = ( a .x. ( X .- ( Y .+ Z ) ) ) ) $=
          ( cv cfv clvec wcel clmod lveclmod syl csn eldifad lmodsubdi lmodvscl
          co syl3anc lmodsubvs eqtrd oveq1d wceq cgrp crg lmodrng 3syl grpinvcl
          rnggrp syl2anc lmodass syl13anc 3eqtrd cminusg lmodvacl eqid lmodvsdi
          grpsubval lmodvsneg clss lspprcl lsppreli cabel lmodabl abl32 3eqtr3d
          cpr lvecindp simprd lvecindp2 simpld fveq2d eqtr4d oveq2d 3eqtr4rd )
          AJVIZUAVIZQHVTZXSKVJZRHVTZUBVIZTHVTZCVTZCVTZXSQRTCVTZMVTHVTZAXRXSQRMV
          THVTZYDCVTXTYBCVTZYDCVTZYFVGAYIYJYDCAYIXTXSRHVTMVTYJAXSHGBMOPQRUDUPUQ
          URUEAPVKVLZPVMVLZUIPVNZVOZVCUJAROSVPZUMVQZVRAXSCHGBMKOPXTRUDUOUEUPUQU
          RVBYOVCAYMXSBVLZQOVLZXTOVLZYOVCUJXSHGBOPQUDUQUPURVSWAZYQWBWCWDAYMYTYB
          OVLZYDOVLZYKYFWEYOUUAAYMYABVLZROVLZUUBYOAGWFVLZYRUUDAYMGWGVLUUFYOGPUQ
          WHGWKWIZVCBGKXSURVBWJWLZYQYAHGBOPRUDUQUPURVSWAAYMYCBVLTOVLZUUCYOVDATO
          YPUNVQZYCHGBOPTUDUQUPURVSWACOPXTYBYDUDUOWMWNWOZAXTXSYGHVTZMVTZXTUULPW
          PVJZVJZCVTZYHYFAYTUULOVLZUUMUUPWEUUAAYMYRYGOVLZUUQYOVCAYMUUEUUIUURYOY
          QUUJCOPRTUDUOWQWAZXSHGBOPYGUDUQUPURVSWAOCPUUNMXTUULUDUOUUNWRZUEWTWLAX
          SHGBMOPQYGUDUPUQURUEYOVCUJUUSVRAYEUUOXTCAYAYGHVTZYBYATHVTZCVTZUUOYEAY
          MUUDUUEUUIUVAUVCWEYOUUHYQUUJCYAHGBOPRTUDUOUQUPURWSWNAOXSHGBKUUNPYGUDU
          QUPUUTURVBYOUUSVCXAAYDUVBYBCAYCYATHAYCUCVIZKVJZYAAYAIVIZWEYCUVEWEAYAY
          CUVFUVECHGBNOPRTSUDUOUQURUPUFUHUIUMUNUUHVDVFAUUFUVDBVLZUVEBVLZUUGVEBG
          KUVDURVBWJWLZULAXSUVDWEZYEUVFRHVTZUVETHVTZCVTZWEZAXSUVDCPXBVJZHRTXINV
          JGBOPQYEUVMUDUOUQURUPUVOWRZUIAUVONOPRTUDUVPUHYOYQUUJXCUJUKAYAYCCHGBNO
          PRTUDUOUPUQURUHYOUUHVDYQUUJXDAUVFUVECHGBNOPRTUDUOUPUQURUHYOVFUVIYQUUJ
          XDVCVEAXRUVDQTMVTHVTZUVKCVTZYFUVDQHVTZUVMCVTZVHUUKAUVRUVSUVLCVTZUVKCV
          TUVSUVKCVTUVLCVTZUVTAUVQUWAUVKCAUVQUVSUVDTHVTMVTUWAAUVDHGBMOPQTUDUPUQ
          URUEYOVEUJUUJVRAUVDCHGBMKOPUVSTUDUOUEUPUQURVBYOVEAYMUVGYSUVSOVLZYOVEU
          JUVDHGBOPQUDUQUPURVSWAZUUJWBWCWDAOCPUVSUVLUVKUDUOAYLYMPXEVLUIYNPXFWIU
          WDAYMUVHUUIUVLOVLZYOUVIUUJUVEHGBOPTUDUQUPURVSWAZAYMUVFBVLUUEUVKOVLZYO
          VFYQUVFHGBOPRUDUQUPURVSWAZXGAYMUWCUWGUWEUWBUVTWEYOUWDUWHUWFCOPUVSUVKU
          VLUDUOWMWNWOXHXJZXKXLXKAXSUVDKAUVJUVNUWIXMXNXOWDXPXQXPXQWC $.
      $}

      ${
        baerlem5b.a1 $e |- ( ph -> a e. B ) $.
        baerlem5b.b1 $e |- ( ph -> b e. B ) $.
        baerlem5b.d1 $e |- ( ph -> d e. B ) $.
        baerlem5b.e1 $e |- ( ph -> e e. B ) $.
        baerlem5b.j1 $e |- ( ph -> j = ( ( a .x. Y ) .+ ( b .x. Z ) ) ) $.
        baerlem5b.j2 $e |- ( ph
            -> j = ( ( d .x. ( X .- ( Y .+ Z ) ) ) .+ ( e .x. X ) ) ) $.
        $( Lemma for ~ baerlem5b .  (Contributed by NM, 9-Apr-2015.) $)
        baerlem5blem1 $p |- ( ph -> j = ( ( I ` d ) .x. ( Y .+ Z ) ) ) $=
          ( cv cfv wceq clss cpr eqid clvec wcel clmod lveclmod syl csn eldifad
          co lspprcl lsppreli cgrp crg lmodrng grpinvcl syl2anc lmod0cl lmodacl
          rnggrp syl3anc lmodvscl lmodvacl lmod0vlid oveq1d lmodsubdi lmodsubvs
          lmod0vs 3eqtr4d lmodvsdi syl13anc oveq2d 3eqtrd lmodvsdir cabel abl32
          lmodabl eqtrd lvecindp simpld eqtr3d ) AUCVIZIVIZDWBZQHWBZXNKVJZRHWBZ
          XRTHWBZCWBZCWBZYAJVIZXRRTCWBZHWBZAYBSYACWBZYAAXQSYACAFQHWBZXQSAFXPQHA
          FXPVKUAVIZRHWBZUBVIZTHWBZCWBZYAVKAFXPCPVLVJZHRTVMNVJGBOPQYLYAUDUOUQUR
          UPYMVNZUIAYMNOPRTUDYNUHAPVOVPPVQVPZUIPVRVSZAROSVTZUMWAZATOYQUNWAZWCUJ
          UKAYHYJCHGBNOPRTUDUOUPUQURUHYPVCVDYRYSWDAXRXRCHGBNOPRTUDUOUPUQURUHYPA
          GWEVPZXNBVPZXRBVPZAGWFVPZYTAYOUUCYPGPUQWGVSGWLVSVEBGKXNURVBWHWIZUUDYR
          YSWDAYOFBVPYPGBPFUQURVAWJVSAYOUUAXOBVPZXPBVPYPVEVFDGBPXNXOUQURUSWKWMA
          YGYLCWBZYCYBASYLCWBZYLUUFYCAYOYLOVPZUUGYLVKYPAYOYIOVPZYKOVPZUUHYPAYOY
          HBVPROVPZUUIYPVCYRYHHGBOPRUDUQUPURWNWMAYOYJBVPTOVPZUUJYPVDYSYJHGBOPTU
          DUQUPURWNWMCOPYIYKUDUOWOWMCOPYLSUDUOUFWPWIAYGSYLCAYOQOVPZYGSVKYPUJHGF
          OPQSUDUQUPVAUFWTWIZWQVGXAAXNQYDMWBHWBZXOQHWBZCWBXNQHWBZYACWBZUUPCWBZY
          CYBAUUOUURUUPCAUUOUUQXNYDHWBMWBUUQYECWBUURAXNHGBMOPQYDUDUPUQURUEYPVEU
          JAYOUUKUULYDOVPYPYRYSCOPRTUDUOWOWMZWRAXNCHGBMKOPUUQYDUDUOUEUPUQURVBYP
          VEAYOUUAUUMUUQOVPYPVEUJXNHGBOPQUDUQUPURWNWMZUUTWSAYEYAUUQCAYOUUBUUKUU
          LYEYAVKYPUUDYRYSCXRHGBOPRTUDUOUQUPURXBXCZXDXEWQVHAYBUUQUUPCWBZYACWBUU
          SAXQUVCYACAYOUUAUUEUUMXQUVCVKYPVEVFUJCDXNXOHGBOPQUDUOUQUPURUSXFXCWQAO
          CPUUQUUPYAUDUOAYOPXGVPYPPXIVSUVAAYOUUEUUMUUPOVPYPVFUJXOHGBOPQUDUQUPUR
          WNWMAYOXSOVPZXTOVPZYAOVPZYPAYOUUBUUKUVDYPUUDYRXRHGBOPRUDUQUPURWNWMAYO
          UUBUULUVEYPUUDYSXRHGBOPTUDUQUPURWNWMCOPXSXTUDUOWOWMZXHXJXAZXJXKXLWQUU
          NXMWQAYOUVFYFYAVKYPUVGCOPYASUDUOUFWPWIXJUVHUVBXA $.
      $}

      $d a b d e j .- $.  $d a b d e B $.  $d a b d e j N $.  $d a b d e .x. $.
      $d a b d e j .+ $.  $d a b d e R $.  $d a b d e j X $.  $d a b d e j Y $.
      $d a b d e j ph $.  $d a b d e V $.  $d a b d e W $.  $d a b d e j Z $.
      $d j .(+) $.
      $( Lemma for ~ baerlem3 .  (Contributed by NM, 9-Apr-2015.) $)
      baerlem3lem2 $p |- ( ph -> ( N ` { ( Y .- Z ) } )
         = ( ( ( N ` { Y } ) .(+) ( N ` { Z } ) )
              i^i ( ( N ` { ( X .- Y ) } ) .(+) ( N ` { ( X .- Z ) } ) ) ) ) $=
        ( vj va vb vd ve co csn cfv cin clmod wcel wss clvec lveclmod lspsntrim
        syl eldifad syl3anc lspsnsub cabel lmodabl ablnnncan1 fveq2d lmodvsubcl
        sneqd eqtr4d eqsstrd ssind cv wceq wrex elin lsmspsn anbi12d syl5bb w3a
        wa wi simp11 cpr wn wne cdif simp12l simp12r simp2l simp2r simp13 simp3
        baerlem3lem1 lspsneli eqeltrd 3exp rexlimdvv imp3a sylbid ssrdv eqssd )
        APRKVCZVDLVEZPVDLVEZRVDLVEZEVCZOPKVCZVDLVEORKVCZVDLVEEVCZVFZAXQXTYCANVG
        VHZPMVHZRMVHZXQXTVIANVJVHZYEUDNVKVMZAPMQVDZUHVNZARMYJUIVNZEKLMNPRSTUBUC
        VLVOAXQYAYBKVCZVDZLVEZYCAXQRPKVCZVDZLVEYOAKLMNPRSTUCYIYKYLVPAYNYQLAYMYP
        AMNKOPRSTAYENVQVHYINVRVMUEYKYLVSWBVTWCAYEYAMVHZYBMVHZYOYCVIYIAYEOMVHZYF
        YRYIUEYKKMNOPSTWAVOZAYEYTYGYSYIUEYLKMNORSTWAVOZEKLMNYAYBSTUBUCVLVOWDWEA
        URYDXQAURWFZYDVHZUUCUSWFZPHVCUTWFZRHVCCVCWGZUTBWHUSBWHZUUCVAWFZYAHVCVBW
        FZYBHVCCVCWGZVBBWHVABWHZWNZUUCXQVHZUUDUUCXTVHZUUCYCVHZWNAUUMUUCXTYCWIAU
        UOUUHUUPUULACEHUUCUSUTGBLMNPRSUJULUMUKUBUCYIYKYLWJACEHUUCVAVBGBLMNYAYBS
        UJULUMUKUBUCYIUUAUUBWJWKWLAUUHUULUUNAUUGUULUUNWOZUSUTBBAUUEBVHZUUFBVHZW
        NZUUGUUQAUUTUUGWMZUUKUUNVAVBBBUVAUUIBVHZUUJBVHZWNZUUKUUNUVAUVDUUKWMZUUC
        UUEXPHVCXQUVEBCDEFGHVBURIJKLMNOPQRUSUTVASTUAUBUCUVEAYHAUUTUUGUVDUUKWPZU
        DVMUVEAYTUVFUEVMUVEAOPRWQLVEVHWRUVFUFVMUVEAXRXSWSUVFUGVMUVEAPMYJWTZVHUV
        FUHVMUVEARUVGVHUVFUIVMUJUKULUMUNUOUPUQUURUUSAUUGUVDUUKXAZUURUUSAUUGUVDU
        UKXBUVAUVBUVCUUKXCUVAUVBUVCUUKXDAUUTUUGUVDUUKXEUVAUVDUUKXFXGUVEUUEHGBLM
        NXPSUKULUMUCUVEAYEUVFYIVMUVHUVEAXPMVHZUVFAYEYFYGUVIYIYKYLKMNPRSTWAVOVMX
        HXIXJXKXJXKXLXMXNXO $.

      $( Lemma for ~ baerlem5a .  (Contributed by NM, 9-Apr-2015.) $)
      baerlem5alem2 $p |- ( ph -> ( N ` { ( X .- ( Y .+ Z ) ) } )
         = ( ( ( N ` { ( X .- Y ) } ) .(+) ( N ` { Z } ) )
               i^i ( ( N ` { ( X .- Z ) } ) .(+) ( N ` { Y } ) ) ) ) $=
        ( vj va vb vd ve co csn cfv cin clmod wcel cabel clvec lveclmod lmodabl
        syl eldifad ablsubsub4 fveq2d wss lmodvsubcl syl3anc lspsntrim eqsstr3d
        sneqd ablsub32 eqtrd ssind cv wceq wrex elin lsmspsn anbi12d syl5bb w3a
        wa wi simp11 cpr wn wne cdif simp12l simp12r simp2l simp2r simp13 simp3
        baerlem5alem1 lmodvacl lspsneli 3exp rexlimdvv imp3a sylbid ssrdv eqssd
        eqeltrd ) AOPRCVCZKVCZVDZLVEZOPKVCZVDLVERVDLVEZEVCZORKVCZVDLVEPVDLVEZEV
        CZVFZAXTYCYFAXTYARKVCZVDZLVEZYCAYIXSLAYHXRAMCNKOPRSUJTANVGVHZNVIVHANVJV
        HZYKUDNVKVMZNVLVMZUEAPMQVDZUHVNZARMYOUIVNZVOZWBVPAYKYAMVHZRMVHZYJYCVQYM
        AYKOMVHZPMVHZYSYMUEYPKMNOPSTVRVSZYQEKLMNYARSTUBUCVTVSWAAXTYDPKVCZVDZLVE
        ZYFAUUEXSLAUUDXRAUUDYHXRAMNKORPSTYNUEYQYPWCYRWDWBVPAYKYDMVHZUUBUUFYFVQY
        MAYKUUAYTUUGYMUEYQKMNORSTVRVSZYPEKLMNYDPSTUBUCVTVSWAWEAURYGXTAURWFZYGVH
        ZUUIUSWFZYAHVCUTWFZRHVCCVCWGZUTBWHUSBWHZUUIVAWFZYDHVCVBWFZPHVCCVCWGZVBB
        WHVABWHZWNZUUIXTVHZUUJUUIYCVHZUUIYFVHZWNAUUSUUIYCYFWIAUVAUUNUVBUURACEHU
        UIUSUTGBLMNYARSUJULUMUKUBUCYMUUCYQWJACEHUUIVAVBGBLMNYDPSUJULUMUKUBUCYMU
        UHYPWJWKWLAUUNUURUUTAUUMUURUUTWOZUSUTBBAUUKBVHZUULBVHZWNZUUMUVCAUVFUUMW
        MZUUQUUTVAVBBBUVGUUOBVHZUUPBVHZWNZUUQUUTUVGUVJUUQWMZUUIUUKXRHVCXTUVKBCD
        EFGHVBURIJKLMNOPQRUSUTVASTUAUBUCUVKAYLAUVFUUMUVJUUQWPZUDVMUVKAUUAUVLUEV
        MUVKAOPRWQLVEVHWRUVLUFVMUVKAYEYBWSUVLUGVMUVKAPMYOWTZVHUVLUHVMUVKARUVMVH
        UVLUIVMUJUKULUMUNUOUPUQUVDUVEAUUMUVJUUQXAZUVDUVEAUUMUVJUUQXBUVGUVHUVIUU
        QXCUVGUVHUVIUUQXDAUVFUUMUVJUUQXEUVGUVJUUQXFXGUVKUUKHGBLMNXRSUKULUMUCUVK
        AYKUVLYMVMUVNUVKAXRMVHZUVLAYKUUAXQMVHZUVOYMUEAYKUUBYTUVPYMYPYQCMNPRSUJX
        HVSKMNOXQSTVRVSVMXIXPXJXKXJXKXLXMXNXO $.

      $( Lemma for ~ baerlem5b .  (Contributed by NM, 13-Apr-2015.) $)
      baerlem5blem2 $p |- ( ph -> ( N ` { ( Y .+ Z ) } )
         = ( ( ( N ` { Y } ) .(+) ( N ` { Z } ) )
              i^i ( ( N ` { ( X .- ( Y .+ Z ) ) } ) .(+) ( N ` { X } ) ) ) ) $=
        ( vj va vb vd ve csn cfv cin clmod wcel wss clvec lveclmod syl lspsntri
        co eldifad syl3anc lmodvacl lmodvsubcl lspsnsub lmodabl ablnncan fveq2d
        cabel sneqd eqtrd lspsntrim eqsstr3d ssind cv wceq wrex wa elin lsmspsn
        anbi12d syl5bb wi w3a simp11 cpr wne cdif simp12l simp12r simp2l simp2r
        wn simp13 simp3 baerlem5blem1 cgrp lmodrng rnggrp 4syl grpinvcl syl2anc
        crg lspsneli eqeltrd 3exp rexlimdvv imp3a sylbid ssrdv eqssd ) APRCVMZV
        CZLVDZPVCLVDZRVCLVDZEVMZOYEKVMZVCLVDOVCLVDEVMZVEZAYGYJYLANVFVGZPMVGZRMV
        GZYGYJVHANVIVGZYNUDNVJVKZAPMQVCZUHVNZARMYSUIVNZCELMNPRSUJUCUBVLVOAYGYKO
        KVMVCLVDZYLAUUBOYKKVMZVCZLVDYGAKLMNYKOSTUCYRAYNOMVGZYEMVGZYKMVGZYRUEAYN
        YOYPUUFYRYTUUACMNPRSUJVPVOZKMNOYESTVQVOZUEVRAUUDYFLAUUCYEAMNKOYESTAYNNW
        BVGYRNVSVKUEUUHVTWCWAWDAYNUUGUUEUUBYLVHYRUUIUEEKLMNYKOSTUBUCWEVOWFWGAUR
        YMYGAURWHZYMVGZUUJUSWHZPHVMUTWHZRHVMCVMWIZUTBWJUSBWJZUUJVAWHZYKHVMVBWHZ
        OHVMCVMWIZVBBWJVABWJZWKZUUJYGVGZUUKUUJYJVGZUUJYLVGZWKAUUTUUJYJYLWLAUVBU
        UOUVCUUSACEHUUJUSUTGBLMNPRSUJULUMUKUBUCYRYTUUAWMACEHUUJVAVBGBLMNYKOSUJU
        LUMUKUBUCYRUUIUEWMWNWOAUUOUUSUVAAUUNUUSUVAWPZUSUTBBAUULBVGZUUMBVGZWKZUU
        NUVDAUVGUUNWQZUURUVAVAVBBBUVHUUPBVGZUUQBVGZWKZUURUVAUVHUVKUURWQZUUJUUPI
        VDZYEHVMYGUVLBCDEFGHVBURIJKLMNOPQRUSUTVASTUAUBUCUVLAYQAUVGUUNUVKUURWRZU
        DVKUVLAUUEUVNUEVKUVLAOPRWSLVDVGXFUVNUFVKUVLAYHYIWTUVNUGVKUVLAPMYSXAZVGU
        VNUHVKUVLARUVOVGUVNUIVKUJUKULUMUNUOUPUQUVEUVFAUUNUVKUURXBUVEUVFAUUNUVKU
        URXCUVHUVIUVJUURXDZUVHUVIUVJUURXEAUVGUUNUVKUURXGUVHUVKUURXHXIUVLUVMHGBL
        MNYESUKULUMUCUVLAYNUVNYRVKUVLGXJVGZUVIUVMBVGUVLAYNGXPVGUVQUVNYRGNULXKGX
        LXMUVPBGIUUPUMUQXNXOUVLAUUFUVNUUHVKXQXRXSXTXSXTYAYBYCYD $.
    $}

    $( An equality that holds when ` X ` , ` Y ` , ` Z ` are independent
       (non-colinear) vectors.  Part (3) in [Baer] p. 45.  TODO fix ref.
       (Contributed by NM, 9-Apr-2015.) $)
    baerlem3 $p |- ( ph -> ( N ` { ( Y .- Z ) } )
       = ( ( ( N ` { Y } ) .(+) ( N ` { Z } ) )
             i^i ( ( N ` { ( X .- Y ) } ) .(+) ( N ` { ( X .- Z ) } ) ) ) ) $=
      ( csca cfv cbs cplusg c0g cvsca cminusg csg eqid baerlem3lem2 ) AFUBUCZUD
      UCZFUEUCZULUEUCZBULUFUCZULFUGUCZULUHUCZULUIUCZCDEFGHIJKLMNOPQRSTUAUNUJUQU
      JULUJUMUJUOUJUSUJUPUJURUJUK $.

    baerlem5a.p $e |- .+ = ( +g ` W ) $.
    $( An equality that holds when ` X ` , ` Y ` , ` Z ` are independent
       (non-colinear) vectors.  First equation of part (5) in [Baer] p. 46.
       (Contributed by NM, 10-Apr-2015.) $)
    baerlem5a $p |- ( ph -> ( N ` { ( X .- ( Y .+ Z ) ) } )
       = ( ( ( N ` { ( X .- Y ) } ) .(+) ( N ` { Z } ) )
             i^i ( ( N ` { ( X .- Z ) } ) .(+) ( N ` { Y } ) ) ) ) $=
      ( csca cfv cbs cplusg c0g cvsca cminusg csg eqid baerlem5alem2 ) AGUDUEZU
      FUEZBUNUGUEZCUNUHUEZUNGUIUEZUNUJUEZUNUKUEZDEFGHIJKLMNOPQRSTUAUBUCURULUNUL
      UOULUPULUTULUQULUSULUM $.

    $( An equality that holds when ` X ` , ` Y ` , ` Z ` are independent
       (non-colinear) vectors.  Second equation of part (5) in [Baer] p. 46.
       (Contributed by NM, 13-Apr-2015.) $)
    baerlem5b $p |- ( ph -> ( N ` { ( Y .+ Z ) } )
       = ( ( ( N ` { Y } ) .(+) ( N ` { Z } ) )
             i^i ( ( N ` { ( X .- ( Y .+ Z ) ) } ) .(+) ( N ` { X } ) ) ) ) $=
      ( csca cfv cbs cplusg c0g cvsca cminusg csg eqid baerlem5blem2 ) AGUDUEZU
      FUEZBUNUGUEZCUNUHUEZUNGUIUEZUNUJUEZUNUKUEZDEFGHIJKLMNOPQRSTUAUBUCURULUNUL
      UOULUPULUTULUQULUSULUM $.

    $( An equality that holds when ` X ` , ` Y ` , ` Z ` are independent
       (non-colinear) vectors.  Subtraction version of first equation of part
       (5) in [Baer] p. 46.  TODO:  This is the subtraction version, may not be
       needed.  TODO: delete if ~ baerlem5abmN is used.  (Contributed by NM,
       24-May-2015.)  (New usage is discouraged.) $)
    baerlem5amN $p |- ( ph -> ( N ` { ( X .- ( Y .- Z ) ) } )
       = ( ( ( N ` { ( X .- Y ) } ) .(+) ( N ` { Z } ) )
             i^i ( ( N ` { ( X .+ Z ) } ) .(+) ( N ` { Y } ) ) ) ) $=
      ( co csn cfv cminusg cin wcel wceq eldifad grpsubval syl2anc oveq2d sneqd
      eqid fveq2d clmod clvec lveclmod syl lmodvnegcl clss cpr lspprcl lssneln0
      wne lspindpi simpld lspsnne1 necomd lspexchn2 wa cgrp lmodgrp 3syl adantr
      grpinvinv simpr lssvnegcl syl3anc eqeltrrd mtand lspsnneg cdif grpinvnzcl
      neeqtrrd baerlem5a grpsubinv oveq1d ineq12d 3eqtrd ) AHIKDUDZDUDZUEZEUFHI
      KGUGUFZUFZBUDZDUDZUEZEUFHIDUDUEEUFZWQUEEUFZCUDZHWQDUDZUEZEUFZIUEEUFZCUDZU
      HXAKUEEUFZCUDZHKBUDZUEZEUFZXGCUDZUHAWOWTEAWNWSAWMWRHDAIFUIKFUIZWMWRUJAIFJ
      UEZUAUKZAKFXPUBUKZFBGWPDIKLUCWPUPZMULUMUNUOUQABCDEFGHIJWQLMNOPQRAEFGWQHIL
      PQAGURUIZXOWQFUIAGUSUIZXTQGUTZVAZXRWPFGKLXSVBUMRXQAEFGHIJLNPQAGVCUFZIKVDE
      UFFGHJLNYDUPZYCAYDEFGIKLYEPYCXQXRVERSVFXQAHUEEUFZXGVGYFXIVGAEFGHIKLPQRXQX
      RSVHVIVJAWQIHVDEUFZUIZKYGUIAEFGHKILPQRXRXQAEFGKIJLNPQUBXQAXGXITVKVJSVLAYH
      VMZWQWPUFZKYGYIGVNUIZXOYJKUJAYKYHAYAXTYKQYBGVOVPZVQAXOYHXRVQFGWPKLXSVRUMY
      IXTYGYDUIZYHYJYGUIAXTYHYCVQAYMYHAYDEFGIHLYEPYCXQRVEVQAYHVSYDYGWPGWQYEXSVT
      WAWBWCVLAXGXIXBTAXTXOXBXIUJYCXRWPEFGKLXSPWDUMZWGUAAYKKFXPWEZUIWQYOUIYLUBF
      GWPKJLNXSWFUMUCWHAXCXJXHXNAXBXIXACYNUNAXFXMXGCAXEXLEAXDXKAFBGDWPHKLUCMXSY
      LRXRWIUOUQWJWKWL $.

    $( An equality that holds when ` X ` , ` Y ` , ` Z ` are independent
       (non-colinear) vectors.  Subtraction version of second equation of part
       (5) in [Baer] p. 46.  TODO:  This is the subtraction version, may not be
       needed.  TODO: delete if ~ baerlem5abmN is used.  (Contributed by NM,
       24-May-2015.)  (New usage is discouraged.) $)
    baerlem5bmN $p |- ( ph -> ( N ` { ( Y .- Z ) } )
       = ( ( ( N ` { Y } ) .(+) ( N ` { Z } ) )
             i^i ( ( N ` { ( X .- ( Y .- Z ) ) } ) .(+) ( N ` { X } ) ) ) ) $=
      ( co csn cfv cminusg cin wcel wceq eldifad grpsubval syl2anc sneqd fveq2d
      eqid clmod lveclmod syl lmodvnegcl clss cpr lspprcl lssneln0 wne lspindpi
      clvec simpld lspsnne1 necomd lspexchn2 wa cgrp adantr grpinvinv lssvnegcl
      lmodgrp simpr syl3anc eqeltrrd mtand lspsnneg grpinvnzcl baerlem5b oveq2d
      neeqtrrd cdif eqcomd oveq1d ineq12d 3eqtrd ) AIKDUDZUEZEUFIKGUGUFZUFZBUDZ
      UEZEUFIUEEUFZWOUEEUFZCUDZHWPDUDZUEZEUFZHUEEUFZCUDZUHWRKUEEUFZCUDZHWLDUDZU
      EZEUFZXDCUDZUHAWMWQEAWLWPAIFUIKFUIZWLWPUJAIFJUEZUAUKZAKFXMUBUKZFBGWNDIKLU
      CWNUPZMULUMZUNUOABCDEFGHIJWOLMNOPQRAEFGWOHILPQAGUQUIZXLWOFUIAGVGUIXRQGURU
      SZXOWNFGKLXPUTUMRXNAEFGHIJLNPQAGVAUFZIKVBEUFFGHJLNXTUPZXSAXTEFGIKLYAPXSXN
      XOVCRSVDXNAXDWRVEXDXFVEAEFGHIKLPQRXNXOSVFVHVIAWOIHVBEUFZUIZKYBUIAEFGHKILP
      QRXOXNAEFGKIJLNPQUBXNAWRXFTVJVISVKAYCVLZWOWNUFZKYBYDGVMUIZXLYEKUJAYFYCAXR
      YFXSGVQUSZVNAXLYCXOVNFGWNKLXPVOUMYDXRYBXTUIZYCYEYBUIAXRYCXSVNAYHYCAXTEFGI
      HLYAPXSXNRVCVNAYCVRXTYBWNGWOYAXPVPVSVTWAVKAWRXFWSTAXRXLWSXFUJXSXOWNEFGKLX
      PPWBUMZWFUAAYFKFXMWGZUIWOYJUIYGUBFGWNKJLNXPWCUMUCWDAWTXGXEXKAWSXFWRCYIWEA
      XCXJXDCAXBXIEAXAXHAWPWLHDAWLWPXQWHWEUNUOWIWJWK $.

    $( An equality that holds when ` X ` , ` Y ` , ` Z ` are independent
       (non-colinear) vectors.  Subtraction versions of first and second
       equations of part (5) in [Baer] p. 46, conjoined to share commonality in
       their proofs.  TODO:  Delete if not be needed.  (Contributed by NM,
       24-May-2015.)  (New usage is discouraged.) $)
    baerlem5abmN $p |- ( ph -> ( ( N ` { ( X .- ( Y .- Z ) ) } )
       = ( ( ( N ` { ( X .- Y ) } ) .(+) ( N ` { Z } ) )
             i^i ( ( N ` { ( X .+ Z ) } ) .(+) ( N ` { Y } ) ) )
   /\ ( N ` { ( Y .- Z ) } )
       = ( ( ( N ` { Y } ) .(+) ( N ` { Z } ) )
            i^i ( ( N ` { ( X .- ( Y .- Z ) ) } ) .(+) ( N ` { X } ) ) ) ) ) $=
      ( co csn cfv cin wceq cminusg wcel eldifad grpsubval syl2anc oveq2d sneqd
      eqid fveq2d clmod clvec lveclmod syl lmodvnegcl clss cpr lspprcl lssneln0
      wne lspindpi simpld lspsnne1 necomd lspexchn2 wa cgrp lmodgrp 3syl adantr
      grpinvinv simpr lssvnegcl syl3anc eqeltrrd mtand lspsnneg cdif grpinvnzcl
      neeqtrrd baerlem5a grpsubinv oveq1d ineq12d 3eqtrd baerlem5b eqcomd jca )
      AHIKDUDZDUDZUEZEUFZHIDUDUEEUFZKUEEUFZCUDZHKBUDZUEZEUFZIUEEUFZCUDZUGZUHWPU
      EZEUFZXFXACUDZWSHUEEUFZCUDZUGZUHAWSHIKGUIUFZUFZBUDZDUDZUEZEUFZWTXPUEEUFZC
      UDZHXPDUDZUEZEUFZXFCUDZUGXHAWRXSEAWQXRAWPXQHDAIFUJKFUJZWPXQUHAIFJUEZUAUKZ
      AKFYHUBUKZFBGXODIKLUCXOUPZMULUMZUNUOUQABCDEFGHIJXPLMNOPQRAEFGXPHILPQAGURU
      JZYGXPFUJAGUSUJZYMQGUTZVAZYJXOFGKLYKVBUMRYIAEFGHIJLNPQAGVCUFZIKVDEUFFGHJL
      NYQUPZYPAYQEFGIKLYRPYPYIYJVERSVFYIAXLXFVGXLXAVGAEFGHIKLPQRYIYJSVHVIVJAXPI
      HVDEUFZUJZKYSUJAEFGHKILPQRYJYIAEFGKIJLNPQUBYIAXFXATVKVJSVLAYTVMZXPXOUFZKY
      SUUAGVNUJZYGUUBKUHAUUCYTAYNYMUUCQYOGVOVPZVQAYGYTYJVQFGXOKLYKVRUMUUAYMYSYQ
      UJZYTUUBYSUJAYMYTYPVQAUUEYTAYQEFGIHLYRPYPYIRVEVQAYTVSYQYSXOGXPYRYKVTWAWBW
      CVLZAXFXAYATAYMYGYAXAUHYPYJXOEFGKLYKPWDUMZWGZUAAUUCKFYHWEZUJXPUUIUJUUDUBF
      GXOKJLNYKWFUMZUCWHAYBXBYFXGAYAXAWTCUUGUNAYEXEXFCAYDXDEAYCXCAFBGDXOHKLUCMY
      KUUDRYJWIUOUQWJWKWLAXJXQUEZEUFXFYACUDZXTXLCUDZUGXNAXIUUKEAWPXQYLUOUQABCDE
      FGHIJXPLMNOPQRUUFUUHUAUUJUCWMAUULXKUUMXMAYAXAXFCUUGUNAXTWSXLCAXSWREAXRWQA
      XQWPHDAWPXQYLWNUNUOUQWJWKWLWO $.
  $}

  ${
    mapdindp1.v $e |- V = ( Base ` W ) $.
    mapdindp1.p $e |- .+ = ( +g ` W ) $.
    mapdindp1.o $e |- .0. = ( 0g ` W ) $.
    mapdindp1.n $e |- N = ( LSpan ` W ) $.
    mapdindp1.w $e |- ( ph -> W e. LVec ) $.
    mapdindp1.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    mapdindp1.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    mapdindp1.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
    mapdindp1.W $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
    mapdindp1.e $e |- ( ph -> ( N ` { Y } ) = ( N ` { Z } ) ) $.
    mapdindp1.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    mapdindp1.f $e |- ( ph -> -. w e. ( N ` { X , Y } ) ) $.
    ${
      mapdindp1.yz $e |- ( ph -> ( Y .+ Z ) =/= .0. ) $.
      $( Vector independence lemma.  (Contributed by NM, 29-Apr-2015.) $)
      mapdindp0 $p |- ( ph -> ( N ` { ( Y .+ Z ) } ) = ( N ` { Y } ) ) $=
        ( csn cfv wss wceq clsm clss eqid clvec wcel clmod lveclmod syl eldifad
        lspsncl syl2anc eqeltrrd lsmcl syl3anc csubg lsssssubg sseldd lsmelvali
        co lspsnid syl22anc lspsnel5a oveq2d lsmidm eqtr3d sseqtrd wne lmodvacl
        cdif eldifsn sylanbrc lspsncmp mpbid ) AHJCVFZUDDUEZHUDDUEZUFWBWCUGAWBW
        CJUDDUEZFUHUEZVFZWCAFUIUEZWFDFWAWGUJZNAFUKULFUMULZOFUNUOZAWIWCWGULZWDWG
        ULWFWGULWJAWIHEULZWKWJAHEIUDZQUPZWGDEFHKWHNUQURZAWCWDWGTWOUSWEWGWCWDFWH
        WEUJZUTVAAWCFVBUEZULZWDWQULHWCULZJWDULZWAWFULAWGWQWCAWIWGWQUFWJWGFWHVCU
        OWOVDZAWCWDWQTXAUSAWIWLWSWJWNDEFHKNVGURAWIJEULZWTWJAJEWMRUPZDEFJKNVGURC
        WEWCWDFHJLWPVEVHVIAWCWCWEVFZWFWCAWCWDWCWETVJAWRXDWCUGXAWEWCFWPVKUOVLVMA
        DEFWAHIKMNOAWAEULZWAIVNWAEWMVPULAWIWLXBXEWJWNXCCEFHJKLVOVAUCWAEIVQVRWNV
        SVT $.
    $}

    $( Vector independence lemma.  (Contributed by NM, 1-May-2015.) $)
    mapdindp1 $p |- ( ph -> ( N ` { X } ) =/= ( N ` { ( Y .+ Z ) } ) ) $=
      ( csn cfv co wne wceq wa cdif wcel eldifsni syl clmod clvec lspsn0 eqeq2d
      lveclmod wb eldifad lspsneq0 syl2anc bitrd necon3bid mpbird adantr fveq2d
      sneq adantl neeqtrrd cv cpr wn simpr mapdindp0 pm2.61dane ) AGUCDUDZHJCUE
      ZUCZDUDZUFVQIAVQIUGZUHVPIUCZDUDZVSAVPWBUFZVTAWCGIUFZAGEWAUIZUJZWDPGEIUKUL
      AVPWBGIAVPWBUGVPWAUGZGIUGZAWBWAVPAFUMUJZWBWAUGAFUNUJZWIOFUQULZDFIMNUOULUP
      AWIGEUJWGWHURWKAGEWAPUSDEFGIKMNUTVAVBVCVDVEVTVSWBUGAVTVRWADVQIVGVFVHVIAVQ
      IUFZUHZVPHUCDUDZVSAVPWNUFWLUAVEZWMBCDEFGHIJKLMNAWJWLOVEAWFWLPVEAHWEUJWLQV
      EAJWEUJWLRVEABVJZWEUJWLSVEAWNJUCDUDUGWLTVEWOAWPGHVKDUDUJVLWLUBVEAWLVMVNVI
      VO $.

    $( Vector independence lemma.  (Contributed by NM, 1-May-2015.) $)
    mapdindp2 $p |- ( ph -> -. w e. ( N ` { X , ( Y .+ Z ) } ) ) $=
      ( cv co cpr cfv wcel wn wceq wa csn preq2 fveq2d clvec clmod lveclmod syl
      eldifad lsppr0 sylan9eqr wss prssi syl2anc snsspr1 syl3anc adantr eqsstrd
      a1i lspss ssneldd wne clsm cdif simpr mapdindp0 oveq2d eqid lsmpr 3eqtr4d
      lmodvacl neleqtrrd pm2.61dane ) ABUCZGHJCUDZUEZDUFZUGUHWDIAWDIUIZUJZWFGHU
      EZDUFZWCWHWFGUKZDUFZWJWGAWFGIUEZDUFWLWGWEWMDWDIGULUMADEFGIKMNAFUNUGZFUOUG
      ZOFUPUQZAGEIUKZPURZUSUTAWLWJVAZWGAWOWIEVAZWKWIVAZWSWPAGEUGHEUGZWTWRAHEWQQ
      URZGHEVBVCXAAGHVDVHWKWIDEFKNVIVEVFVGAWCWJUGUHZWGUBVFVJAWDIVKZUJZWFWJWCAXD
      XEUBVFZXFWLWDUKDUFZFVLUFZUDZWLHUKDUFZXIUDZWFWJXFXHXKWLXIXFBCDEFGHIJKLMNAW
      NXEOVFAGEWQVMZUGXEPVFAHXMUGXEQVFAJXMUGXERVFAWCXMUGXESVFAXKJUKDUFUIXETVFAW
      LXKVKXEUAVFXGAXEVNVOVPAWFXJUIXEAXIDEFGWDKNXIVQZWPWRAWOXBJEUGWDEUGWPXCAJEW
      QRURCEFHJKLVTVEVRVFAWJXLUIXEAXIDEFGHKNXNWPWRXCVRVFVSWAWB $.

    $( Vector independence lemma.  (Contributed by NM, 29-Apr-2015.) $)
    mapdindp3 $p |- ( ph -> ( N ` { X } ) =/= ( N ` { ( w .+ Y ) } ) ) $=
      ( cv co csn cfv wcel wne cpr clmod wss clvec lveclmod syl eldifad lspvadd
      wn syl3anc lspindp1 ssneldd wceq lspsnid syl2anc eleq2 syl5ibcom necon3bd
      simprd mpd ) AGBUCZHCUDUEDUFZUGZUQGUEDUFZVJUHAVJVIHUIDUFZGAFUJUGZVIEUGHEU
      GVJVMUKAFULUGVNOFUMUNZAVIEIUEZSUOZAHEVPQUOZCDEFVIHKLNUPURAVIUEDUFHUEDUFUH
      GVMUGUQADEFGHIVIKMNOPVRVQUAUBUSVGUTAVKVLVJAGVLUGZVLVJVAVKAVNGEUGVSVOAGEVP
      PUODEFGKNVBVCVLVJGVDVEVFVH $.

    $( Vector independence lemma.  (Contributed by NM, 29-Apr-2015.) $)
    mapdindp4 $p |- ( ph -> -. Z e. ( N ` { X , ( w .+ Y ) } ) ) $=
      ( csn cfv cv co wne cpr wcel wn clmod clvec lveclmod syl eldifad lmodvacl
      syl3anc lspindpi simprd lspindp3 lmodcom sneqd neeqtrrd eqnetrrd lspindp1
      necomd wceq fveq2d clsm eqid lsmpr preq2d lspprabs 3eqtr3rd oveq1d fveq2i
      prcom a1i 3eqtr3d eqtrd neleqtrrd ) AGUCDUDZBUEZHCUFZUCZDUDZUGJGWDUHDUDUI
      UJADEFJWDIGKMNORAFUKUIZWCEUIZHEUIZWDEUIAFULUIWGOFUMUNZAWCEIUCZSUOZAHEWKQU
      OZCEFWCHKLUPUQZAGEWKPUOZAHUCDUDZJUCDUDZWFTAWPHWCCUFZUCZDUDWFACDEFHWCIKLMN
      OWMSAWCUCDUDZWPAWTWBUGWTWPUGZADEFWCGHKNOWLWOWMUBURUSVFUTAWEWSDAWDWRAWGWHW
      IWDWRVGWJWLWMCEFWCHKLVAUQVBVHVCVDAJWDUHDUDZWCHUHZDUDZGAXAGXDUIUJADEFGHIWC
      KMNOPWMWLUAUBVEUSAXBWQWFFVIUDZUFZXDAXEDEFJWDKNXEVJZWJAJEWKRUOWNVKAWPWFXEU
      FZHWCUHZDUDZXFXDAHWRUHZDUDHWDUHZDUDXJXHAXKXLDAWRWDHAWGWIWHWRWDVGWJWMWLCEF
      HWCKLVAUQVLVHACDEFHWCKLNWJWMWLVMAXEDEFHWDKNXGWJWMWNVKVNAWPWQWFXETVOXJXDVG
      AXIXCDHWCVQVPVRVSVTWAVEUS $.
  $}

  ${
    $d x D $.  $d h x F $.  $d x J $.  $d x M $.  $d x N $.  $d x .0. $.
    $d x Q $.  $d x R $.  $d x .- $.  $d h x X $.  $d h x Y $.  $d h ph $.
    mapdh.q $e |- Q = ( 0g ` C ) $.
    mapdh.i $e |- I = ( x e. _V |->
     if ( ( 2nd ` x ) = .0. , Q ,
        ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    ${
      mapdh.x $e |- ( ph -> X e. A ) $.
      mapdh.f $e |- ( ph -> F e. B ) $.
      mapdh.y $e |- ( ph -> Y e. E ) $.
      $( Lemmma for ~~? mapdh .  (Contributed by NM, 3-Apr-2015.)  (Revised by
         Mario Carneiro, 6-May-2015.) $)
      mapdhval $p |- ( ph -> ( I ` <. X , F , Y >. )
    = if ( Y = .0. , Q , ( iota_ h e. D ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( J ` { ( F R h ) } ) ) ) ) ) $=
        ( cotp cfv c2nd wceq csn cv c1st co crio cif cvv wcel otex fveq2 eqeq1d
        sneqd fveq2d oveq12d oveq1d eqeq12d anbi12d riotabidv ifbieq2d c0g fvex
        eqeltri riotaex ifex fvmpt mp1i ot3rdg syl ot1stg syl3anc ot2ndg eqtrd
        wa ) AQKRUEZLUFZWBUGUFZSUHZGWDUIZPUFZNUFZIUJZUIMUFZUHZWBUKUFZUKUFZWDOUL
        ZUIZPUFZNUFZWLUGUFZWIHULZUIZMUFZUHZWAZIFUMZUNZRSUHZGRUIZPUFZNUFZWJUHZQR
        OULZUIZPUFZNUFZKWIHULZUIZMUFZUHZWAZIFUMZUNWBUOUPWCXEUHAQKRUQBWBBUJZUGUF
        ZSUHZGYBUIZPUFZNUFZWJUHZYAUKUFZUKUFZYBOULZUIZPUFZNUFZYHUGUFZWIHULZUIZMU
        FZUHZWAZIFUMZUNXEUOLYAWBUHZYCWEYTXDGUUAYBWDSYAWBUGURZUSUUAYSXCIFUUAYGWK
        YRXBUUAYFWHWJUUAYEWGNUUAYDWFPUUAYBWDUUBUTVAVAUSUUAYMWQYQXAUUAYLWPNUUAYK
        WOPUUAYJWNUUAYIWMYBWDOUUAYHWLUKYAWBUKURZVAUUBVBUTVAVAUUAYPWTMUUAYOWSUUA
        YNWRWIHUUAYHWLUGUUCVAVCUTVAVDVEVFVGUAWEGXDGEVHUFUOTEVHVIVJXCIFVKVLVMVNA
        WEXFXDXTGAWDRSARJUPZWDRUHUDQKRJVOVPZUSAXCXSIFAWKXJXBXRAWHXIWJAWGXHNAWFX
        GPAWDRUUEUTVAVAUSAWQXNXAXQAWPXMNAWOXLPAWNXKAWMQWDROAQCUPZKDUPZUUDWMQUHU
        BUCUDQKRCDJVQVRUUEVBUTVAVAAWTXPMAWSXOAWRKWIHAUUFUUGUUDWRKUHUBUCUDQKRCDJ
        VSVRVCUTVAVDVEVFVGVT $.
    $}

    $d h .0. $.
    ${
      mapdh0.o $e |- .0. = ( 0g ` U ) $.
      mapdh0.x $e |- ( ph -> X e. A ) $.
      mapdh0.f $e |- ( ph -> F e. B ) $.
      $( Lemmma for ~~? mapdh .  (Contributed by NM, 3-Apr-2015.) $)
      mapdhval0 $p |- ( ph -> ( I ` <. X , F , .0. >. ) = Q ) $=
        ( cotp cfv wceq csn cv co wa crio cif cvv wcel c0g eqeltri a1i mapdhval
        fvex eqid iftrue ax-mp syl6eq ) AQKRUDLUERRUFZGRUGPUENUEJUHZUGMUEUFQROU
        IUGPUENUEKVEHUIUGMUEUFUJJFUKZULZGABCDEFGHJUMKLMNOPQRRSTUBUCRUMUNARIUOUE
        UMUAIUOUSUPUQURVDVGGUFRUTVDGVFVAVBVC $.
    $}

    ${
      mapdh2.x $e |- ( ph -> X e. A ) $.
      mapdh2.f $e |- ( ph -> F e. B ) $.
      mapdh2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      $( Lemmma for ~~? mapdh .  (Contributed by NM, 3-Apr-2015.) $)
      mapdhval2 $p |- ( ph -> ( I ` <. X , F , Y >. )
    = ( iota_ h e. D ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
             /\ ( M ` ( N ` { ( X .- Y ) } ) )
                   = ( J ` { ( F R h ) } ) ) ) ) $=
        ( cotp cfv wceq csn cv co wa crio cdif mapdhval wcel wn eldifsni neneqd
        cif iffalse 3syl eqtrd ) AQJRUEKUFRSUGZGRUHOUFMUFIUIZUHLUFUGQRNUJUHOUFM
        UFJVDHUJUHLUFUGUKIFULZUSZVEABCDEFGHIPSUHUMZJKLMNOQRSTUAUBUCUDUNARVGUOZV
        CUPVFVEUGUDVHRSRPSUQURVCGVEUTVAVB $.
    $}

    $d h C $.  $d h D $.  $d h J $.  $d h M $.  $d h N $.  $d h R $.  $d h U $.
    $d h .- $.
    mapdh.h $e |- H = ( LHyp ` K ) $.
    mapdh.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdh.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdh.v $e |- V = ( Base ` U ) $.
    mapdh.s $e |- .- = ( -g ` U ) $.
    mapdhc.o $e |- .0. = ( 0g ` U ) $.
    mapdh.n $e |- N = ( LSpan ` U ) $.
    mapdh.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdh.d $e |- D = ( Base ` C ) $.
    mapdh.r $e |- R = ( -g ` C ) $.
    mapdh.j $e |- J = ( LSpan ` C ) $.
    mapdh.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdhc.f $e |- ( ph -> F e. D ) $.
    mapdh.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
    mapdhcl.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    ${
      mapdhc.y $e |- ( ph -> Y e. V ) $.
      mapdh.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      $( Lemmma for ~~? mapdh .  (Contributed by NM, 3-Apr-2015.) $)
      mapdhcl $p |- ( ph -> ( I ` <. X , F , Y >. ) e. D ) $=
        ( cotp cfv wcel wceq oteq3 fveq2d eleq1d wne wa csn cv crio cdif adantr
        co anim1i eldifsn sylibr mapdhval2 wreu chlt mapdpg riotacl syl eqeltrd
        mapdhval0 lcd0vcl pm2.61ne ) ASITVAZKVBZDVCSIUAVAZKVBZDVCTUATUAVDZWJWLD
        WMWIWKKTUASIVEVFVGATUAVHZVIZWJTVJPVBZNVBHVKZVJLVBVDSTOVOVJPVBNVBIWQFVOV
        JLVBVDVIZHDVLZDWOBQUAVJVMZDCDEFHIKLNOPQSTUAUBUCASWTVCWNURVNZAIDVCWNUPVN
        ZWOTQVCZWNVITWTVCAXCWNUSVPTQUAVQVRZVSWOWRHDVTWSDVCWOCFGHDIJLMNOPQRSTUAU
        DUEUFUGUHUIUJUKULUMUNAMWAVCRJVCVIWNUOVNXAXDXBASVJPVBZWPVHWNUTVNAXENVBIV
        JLVBVDWNUQVNWBWRHDWCWDWEAWLEDABWTDCDEFGHIKLNOPSUAUBUCUIURUPWFACJMEDRUDU
        KULUBUOWGWEWH $.
    $}

    $d h G $.  $d w h $.
    ${
      $d w D $.  $d w F $.  $d w G $.  $d w J $.  $d w M $.  $d w N $.
      $d w R $.  $d w .- $.  $d w X $.  $d w Y $.  $d w ph $.
      mapdhe.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdhe.g $e |- ( ph -> G e. D ) $.
      mapdh.ne2 $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      $( Lemmma for ~~? mapdh .  The defining equation for h(x,x',y)=y' in part
         (2) in [Baer] p. 45 line 24.  (Contributed by NM, 4-Apr-2015.) $)
      mapdheq $p |- ( ph -> ( ( I ` <. X , F , Y >. ) = G
         <-> ( ( M ` ( N ` { Y } ) ) = ( J ` { G } )
             /\ ( M ` ( N ` { ( X .- Y ) } ) )
                   = ( J ` { ( F R G ) } ) ) ) ) $=
        ( cotp cfv wceq csn cv co wa crio cdif mapdhval2 eqeq1d wreu mapdpg nfv
        nfcvd nfvd sneq fveq2d eqeq2d oveq2 sneqd anbi12d adantl riota2df mpdan
        wb bitr4d ) ATIUAVCLVDZJVEUAVFQVDOVDZHVGZVFZMVDZVEZTUAPVHVFQVDOVDZIWLFV
        HZVFZMVDZVEZVIZHDVJZJVEZWKJVFZMVDZVEZWPIJFVHZVFZMVDZVEZVIZAWJXBJABRUBVF
        VKDCDEFHILMOPQRTUAUBUCUDUSUQUTVLVMAXAHDVNXKXCWHACFGHDIKMNOPQRSTUAUBUEUF
        UGUHUIUJUKULUMUNUOUPUSUTUQVBURVOAXAXKHDJAHVPAHJVQAXKHVRVAWLJVEZXAXKWHAX
        LWOXFWTXJXLWNXEWKXLWMXDMWLJVSVTWAXLWSXIWPXLWRXHMXLWQXGWLJIFWBWCVTWAWDWE
        WFWGWI $.

      $d x G $.
      $( Lemmma for ~~? mapdh .  One direction of part (2) in [Baer] p. 45.
         (Contributed by NM, 4-Apr-2015.) $)
      mapdheq2 $p |- ( ph -> ( ( I ` <. X , F , Y >. ) = G
          -> ( I ` <. Y , G , X >. ) = F ) ) $=
        ( cotp cfv wceq csn co wa mapdheq adantr dvhlmod eldifad fveq2d lcdlmod
        lspsnsub eqeq12d biimpa adantrl chlt wcel simprl cdif wne necomd sylbid
        mpbir2and ex ) ATIUAVCLVDJVEUAVFQVDZOVDJVFMVDVEZTUAPVGVFQVDZOVDZIJFVGVF
        MVDZVEZVHZUAJTVCLVDIVEZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
        UOUPUQURUSUTVAVBVIAWNWOAWNVHZWOTVFQVDZOVDIVFMVDVEZUATPVGVFQVDZOVDZJIFVG
        VFMVDZVEZAWRWNURVJAWMXBWIAWMXBAWKWTWLXAAWJWSOAPQRGTUAUHUIUKAGKNSUEUGUPV
        KATRUBVFZUSVLAUARXCUTVLVOVMAFMDCIJUMUNUOACKNSUEULUPVNUQVAVOVPVQVRWPBCDE
        FGHJIKLMNOPQRSUATUBUCUDUEUFUGUHUIUJUKULUMUNUOANVSVTSKVTVHWNUPVJAJDVTWNV
        AVJAWIWMWAAUARXCWBZVTWNUTVJATXDVTWNUSVJAIDVTWNUQVJAWHWQWCWNAWQWHVBWDVJV
        IWFWGWE $.
    $}

    $d x G $.
    ${
      mapdhe2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdhe2.g $e |- ( ph -> G e. D ) $.
      mapdh.ne3 $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      mapdh.my $e |- ( ph -> ( M ` ( N ` { Y } ) ) = ( J ` { G } ) ) $.
      $( Lemmma for ~~? mapdh .  Part (2) in [Baer] p. 45.  The bidirectional
         version of ~ mapdheq2 seems to require an additional hypothesis not
         mentioned in Baer.  TODO fix ref.  TODO:  We probably don't need this;
         delete if never used.  (Contributed by NM, 4-Apr-2015.)
         (New usage is discouraged.) $)
      mapdheq2biN $p |- ( ph -> ( ( I ` <. X , F , Y >. ) = G
           <-> ( I ` <. Y , G , X >. ) = F ) ) $=
        ( cotp cfv wceq mapdheq2 csn necomd impbid ) ATIUAVDLVEJVFUAJTVDLVEIVFA
        BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVGABCDEF
        GHJIKLMNOPQRSUATUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVAVCUTUSUQATVHQVEUAVHQVEV
        BVIVGVJ $.
    $}

    $d h E $.  $d h x Z $.
    ${
      mapdhe4.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdhe.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdh.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      mapdh.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
      mapdh.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh.ee $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      $( Lemma for ~ mapdheq4 .  Part (4) in [Baer] p. 46.  (Contributed by NM,
         12-Apr-2015.) $)
      mapdheq4lem $p |- ( ph
          -> ( M ` ( N ` { ( Y .- Z ) } ) ) = ( J ` { ( G R E ) } ) ) $=
        ( csn cfv clsm cin clss eqid clmod wcel dvhlmod eldifad lspsncl syl2anc
        co lsmcl syl3anc lmodvsubcl mapdin mapdlsm wceq cotp wa wne cpr dvhlvec
        wn lspindp2 simpld mapdhcl eqeltrrd mapdheq mpbid lspindp1 eqtrd simprd
        oveq12d ineq12d baerlem3 fveq2d c0g lcdlvec mapdindp mapdncol 3eqtr4d
        mapdn0 ) AUBVHRVIZUDVHRVIZGVJVIZVTZUAUBQVTZVHRVIZUAUDQVTZVHRVIZXNVTZVKZ
        PVIZKVHNVIZIVHNVIZCVJVIZVTZJKFVTVHNVIZJIFVTVHNVIZYEVTZVKZUBUDQVTVHRVIZP
        VIKIFVTVHNVIAYBXOPVIZXTPVIZVKYJAGVLVIZGLOPTXOXTUGUHUIYNVMZURAGVNVOZXLYN
        VOZXMYNVOZXOYNVOAGLOTUGUIURVPZAYPUBSVOZYQYSAUBSUCVHZVBVQZYNRSGUBUJYOUMV
        RVSZAYPUDSVOZYRYSAUDSUUAVCVQZYNRSGUDUJYOUMVRVSZXNYNXLXMGYOXNVMZWAWBAYPX
        QYNVOZXSYNVOZXTYNVOYSAYPXPSVOZUUHYSAYPUASVOZYTUUJYSAUASUUAVAVQZUUBQSGUA
        UBUJUKWCWBYNRSGXPUJYOUMVRVSZAYPXRSVOZUUIYSAYPUUKUUDUUNYSUULUUEQSGUAUDUJ
        UKWCWBYNRSGXRUJYOUMVRVSZXNYNXQXSGYOUUGWAWBWDAYLYFYMYIAYLXLPVIZXMPVIZYEV
        TYFACYEXNYNGLOPTXLXMUGUHUIYOUUGUNYEVMZURUUCUUFWEAUUPYCUUQYDYEAUUPYCWFZX
        QPVIZYGWFZAUAJUBWGMVIZKWFUUSUVAWHVFABCDEFGHJKLMNOPQRSTUAUBUCUEUFUGUHUIU
        JUKULUMUNUOUPUQURUSUTVAVBAUVBKDVFABCDEFGHJLMNOPQRSTUAUBUCUEUFUGUHUIUJUK
        ULUMUNUOUPUQURUSUTVAUUBAUAVHRVIZXLWIUDUAUBWJRVIVOWLARSGUBUDUCUAUJULUMAG
        LOTUGUIURWKZUUBVCUULVEVDWMWNZWOWPZUVEWQWRZWNZAUUQYDWFZXSPVIZYHWFZAUAJUD
        WGMVIZIWFUVIUVKWHVGABCDEFGHJILMNOPQRSTUAUDUCUEUFUGUHUIUJUKULUMUNUOUPUQU
        RUSUTVAVCAUVLIDVGABCDEFGHJLMNOPQRSTUAUDUCUEUFUGUHUIUJUKULUMUNUOUPUQURUS
        UTVAUUEAUVCXMWIUBUAUDWJRVIVOWLARSGUBUDUCUAUJULUMUVDVBUUEUULVEVDWSWNZWOW
        PZUVMWQWRZWNZXBWTAYMUUTUVJYEVTYIACYEXNYNGLOPTXQXSUGUHUIYOUUGUNUURURUUMU
        UOWEAUUTYGUVJYHYEAUUSUVAUVGXAAUVIUVKUVOXAXBWTXCWTAYKYAPAXNQRSGUAUBUCUDU
        JUKULUUGUMUVDUULVDVEVBVCXDXEAYEFNDCJKCXFVIZIUOUPUVQVMZUURUQACLOTUGUNURX
        GUSACDGIJKLNOPRSTUAUBUDUGUHUIUJUMUNUOUQURUSUTUULUUBUVFUVHUUEUVNUVPVDXHA
        CDGKILNOPRSTUBUDUGUHUIUJUMUNUOUQURUVFUVHUUBUUEUVNUVPVEXIACDGKLNOPRSTUBU
        CUVQUGUHUIUJUMUNUOUQURUVFUVHULUVRVBXKACDGILNOPRSTUDUCUVQUGUHUIUJUMUNUOU
        QURUVNUVPULUVRVCXKXDXJ $.

      $( Lemma for ~~? mapdh .  Part (4) in [Baer] p. 46.  (Contributed by NM,
         12-Apr-2015.) $)
      mapdheq4 $p |- ( ph -> ( I ` <. Y , G , Z >. ) = E ) $=
        ( cotp cfv wceq csn co wa eldifad wne cpr wcel dvhlvec lspindp1 mapdhcl
        wn simpld eqeltrrd mapdheq mpbid mapdheq4lem lspindp2 mpbir2and ) AUBKU
        DVHMVIIVJUDVKRVIZPVIIVKNVIVJZUBUDQVLVKRVIPVIKIFVLVKNVIVJAWJUAUDQVLVKRVI
        PVIJIFVLVKNVIVJZAUAJUDVHMVIZIVJWJWKVMVGABCDEFGHJILMNOPQRSTUAUDUCUEUFUGU
        HUIUJUKULUMUNUOUPUQURUSUTVAVCAWLIDVGABCDEFGHJLMNOPQRSTUAUDUCUEUFUGUHUIU
        JUKULUMUNUOUPUQURUSUTVAAUDSUCVKZVCVNZAUAVKRVIZWIVOUBUAUDVPRVIVQWAARSGUB
        UDUCUAUJULUMAGLOTUGUIURVRZVBWNAUASWMVAVNZVEVDVSWBZVTWCZWRWDWEWBABCDEFGH
        IJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGWFABC
        DEFGHKILMNOPQRSTUBUDUCUEUFUGUHUIUJUKULUMUNUOUPUQURAUAJUBVHMVIZKDVFABCDE
        FGHJLMNOPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAAUBSWMVBVNZAWOUBVK
        RVIZVOUDUAUBVPRVIVQWAARSGUBUDUCUAUJULUMWPXAVCWQVEVDWGWBZVTWCZAXBPVIKVKN
        VIVJZUAUBQVLVKRVIPVIJKFVLVKNVIVJZAWTKVJXEXFVMVFABCDEFGHJKLMNOPQRSTUAUBU
        CUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBXDXCWDWEWBVBVCWSVEWDWH $.
    $}

    mapdh.p $e |- .+ = ( +g ` U ) $.
    mapdh.a $e |- .+b = ( +g ` C ) $.
    ${
      $d h E $.  $d h x Z $.  $d h .+b $.  $d h I $.  $d h x .+ $.
      mapdhe6.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdhe6.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdhe6.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      mapdh6.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
      mapdh6.fg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh6.fe $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      $( Lemma for ~ mapdh6N .  Part (6) in [Baer] p. 47, lines 16-18.
         (Contributed by NM, 13-Apr-2015.)  (New usage is discouraged.) $)
      mapdh6lem1N $p |- ( ph
          -> ( M ` ( N ` { ( X .- ( Y .+ Z ) ) } ) )
                 = ( J ` { ( F R ( G .+b E ) ) } ) ) $=
        ( co csn cfv clsm cin clss eqid wcel dvhlmod eldifad lmodvsubcl syl3anc
        clmod lspsncl syl2anc lsmcl mapdin mapdlsm ineq12d wceq cotp wa wne cpr
        dvhlvec lspindp2 simpld mapdhcl eqeltrrd mapdheq mpbid lspindp1 oveq12d
        simprd eqtrd baerlem5a fveq2d lcdlvec mapdindp mapdncol mapdn0 3eqtr4d
        wn ) AUCUDSVLZVMTVNZUFVMTVNZIVOVNZVLZUCUFSVLZVMTVNZUDVMTVNZXRVLZVPZRVNZ
        LMHVLVMPVNZKVMPVNZCVOVNZVLZLKHVLVMPVNZMVMPVNZYHVLZVPZUCUDUFEVLSVLVMTVNZ
        RVNLMKFVLHVLVMPVNAYEXSRVNZYCRVNZVPZYMAIVQVNZINQRUBXSYCUIUJUKYRVRZUTAIWD
        VSZXPYRVSZXQYRVSZXSYRVSAINQUBUIUKUTVTZAYTXOUAVSZUUAUUCAYTUCUAVSZUDUAVSZ
        UUDUUCAUCUAUEVMZVCWAZAUDUAUUGVFWAZSUAIUCUDULUMWBWCYRTUAIXOULYSUOWEWFZAY
        TUFUAVSZUUBUUCAUFUAUUGVGWAZYRTUAIUFULYSUOWEWFZXRYRXPXQIYSXRVRZWGWCAYTYA
        YRVSZYBYRVSZYCYRVSUUCAYTXTUAVSZUUOUUCAYTUUEUUKUUQUUCUUHUULSUAIUCUFULUMW
        BWCYRTUAIXTULYSUOWEWFZAYTUUFUUPUUCUUIYRTUAIUDULYSUOWEWFZXRYRYAYBIYSUUNW
        GWCWHAYQXPRVNZXQRVNZYHVLZYARVNZYBRVNZYHVLZVPYMAYOUVBYPUVEACYHXRYRINQRUB
        XPXQUIUJUKYSUUNUPYHVRZUTUUJUUMWIACYHXRYRINQRUBYAYBUIUJUKYSUUNUPUVFUTUUR
        UUSWIWJAUVBYIUVEYLAUUTYFUVAYGYHAUVDYKWKZUUTYFWKZAUCLUDWLOVNZMWKUVGUVHWM
        VJABCDGHIJLMNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVFAUVIMD
        VJABCDGHIJLNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCUUIAUCVMT
        VNZYBWNUFUCUDWOTVNVSXNATUAIUDUFUEUCULUNUOAINQUBUIUKUTWPZUUIVGUUHVIVHWQW
        RZWSWTZUVLXAXBZXEAUVAYGWKZUVCYJWKZAUCLUFWLOVNZKWKUVOUVPWMVKABCDGHIJLKNO
        PQRSTUAUBUCUFUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVGAUVQKDVKABCDGHIJLNOP
        QRSTUAUBUCUFUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCUULAUVJXQWNUDUCUFWOTVNV
        SXNATUAIUDUFUEUCULUNUOUVKVFUULUUHVIVHXCWRZWSWTZUVRXAXBZWRZXDAUVCYJUVDYK
        YHAUVOUVPUVTXEAUVGUVHUVNWRZXDWJXFXFAYNYDRAEXRSTUAIUCUDUEUFULUMUNUUNUOUV
        KUUHVHVIVFVGVDXGXHAFYHHPDCLMGKUQURUGUVFUSACNQUBUIUPUTXIVAACDIKLMNPQRTUA
        UBUCUDUFUIUJUKULUOUPUQUSUTVAVBUUHUUIUVMUWBUULUVSUWAVHXJACDIMKNPQRTUAUBU
        DUFUIUJUKULUOUPUQUSUTUVMUWBUUIUULUVSUWAVIXKACDIMNPQRTUAUBUDUEGUIUJUKULU
        OUPUQUSUTUVMUWBUNUGVFXLACDIKNPQRTUAUBUFUEGUIUJUKULUOUPUQUSUTUVSUWAUNUGV
        GXLVEXGXM $.

      $( Lemma for ~ mapdh6N .  Part (6) in [Baer] p. 47, lines 20-22.
         (Contributed by NM, 13-Apr-2015.)  (New usage is discouraged.) $)
      mapdh6lem2N $p |- ( ph
          -> ( M ` ( N ` { ( Y .+ Z ) } ) ) = ( J ` { ( G .+b E ) } ) ) $=
        ( csn cfv clsm cin clss eqid clmod wcel dvhlmod eldifad lspsncl syl2anc
        co lsmcl syl3anc lmodvacl lmodvsubcl mapdin mapdlsm wceq cotp wa wne wn
        dvhlvec lspindp2 simpld mapdhcl eqeltrrd mapdheq mpbid lspindp1 oveq12d
        cpr eqtrd mapdh6lem1N ineq12d baerlem5b fveq2d mapdindp mapdncol mapdn0
        lcdlvec 3eqtr4d ) AUDVLTVMZUFVLTVMZIVNVMZWDZUCUDUFEWDZSWDZVLTVMZUCVLTVM
        ZXRWDZVOZRVMZMVLPVMZKVLPVMZCVNVMZWDZLMKFWDZHWDVLPVMZLVLPVMZYIWDZVOZXTVL
        TVMZRVMYKVLPVMAYFXSRVMZYDRVMZVOYOAIVPVMZINQRUBXSYDUIUJUKYSVQZUTAIVRVSZX
        PYSVSZXQYSVSZXSYSVSAINQUBUIUKUTVTZAUUAUDUAVSZUUBUUDAUDUAUEVLZVFWAZYSTUA
        IUDULYTUOWBWCZAUUAUFUAVSZUUCUUDAUFUAUUFVGWAZYSTUAIUFULYTUOWBWCZXRYSXPXQ
        IYTXRVQZWEWFAUUAYBYSVSZYCYSVSZYDYSVSUUDAUUAYAUAVSZUUMUUDAUUAUCUAVSZXTUA
        VSZUUOUUDAUCUAUUFVCWAZAUUAUUEUUIUUQUUDUUGUUJEUAIUDUFULVDWGWFSUAIUCXTULU
        MWHWFYSTUAIYAULYTUOWBWCZAUUAUUPUUNUUDUURYSTUAIUCULYTUOWBWCZXRYSYBYCIYTU
        ULWEWFWIAYQYJYRYNAYQXPRVMZXQRVMZYIWDYJACYIXRYSINQRUBXPXQUIUJUKYTUULUPYI
        VQZUTUUHUUKWJAUVAYGUVBYHYIAUVAYGWKZUCUDSWDVLTVMRVMLMHWDVLPVMWKZAUCLUDWL
        OVMZMWKUVDUVEWMVJABCDGHIJLMNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSU
        TVAVBVCVFAUVFMDVJABCDGHIJLNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUT
        VAVBVCUUGAYCXPWNUFUCUDXETVMVSWOATUAIUDUFUEUCULUNUOAINQUBUIUKUTWPZUUGVGU
        URVIVHWQWRZWSWTZUVHXAXBWRZAUVBYHWKZUCUFSWDVLTVMRVMLKHWDVLPVMWKZAUCLUFWL
        OVMZKWKUVKUVLWMVKABCDGHIJLKNOPQRSTUAUBUCUFUEUGUHUIUJUKULUMUNUOUPUQURUSU
        TVAVBVCVGAUVMKDVKABCDGHIJLNOPQRSTUAUBUCUFUEUGUHUIUJUKULUMUNUOUPUQURUSUT
        VAVBVCUUJAYCXQWNUDUCUFXETVMVSWOATUAIUDUFUEUCULUNUOUVGVFUUJUURVIVHXCWRZW
        SWTZUVNXAXBWRZXDXFAYRYBRVMZYCRVMZYIWDYNACYIXRYSINQRUBYBYCUIUJUKYTUULUPU
        VCUTUUSUUTWJAUVQYLUVRYMYIABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUM
        UNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVKXGVBXDXFXHXFAYPYERAEXRSTUAIUCUDUEUF
        ULUMUNUULUOUVGUURVHVIVFVGVDXIXJAFYIHPDCLMGKUQURUGUVCUSACNQUBUIUPUTXNVAA
        CDIKLMNPQRTUAUBUCUDUFUIUJUKULUOUPUQUSUTVAVBUURUUGUVIUVJUUJUVOUVPVHXKACD
        IMKNPQRTUAUBUDUFUIUJUKULUOUPUQUSUTUVIUVJUUGUUJUVOUVPVIXLACDIMNPQRTUAUBU
        DUEGUIUJUKULUOUPUQUSUTUVIUVJUNUGVFXMACDIKNPQRTUAUBUFUEGUIUJUKULUOUPUQUS
        UTUVOUVPUNUGVGXMVEXIXO $.

      $( Lemma for ~ mapdh6N .  Part (6) in [Baer] p. 47, case 1.  (Contributed
         by NM, 23-Apr-2015.)  (New usage is discouraged.) $)
      mapdh6aN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. ) =
            ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv wceq csn mapdh6lem2N oveq12d sneqd fveq2d eqtr4d mapdh6lem1N
        co oveq2d wcel wne cdif clmod dvhlmod eldifad syl3anc lmodindp1 eldifsn
        lmodvacl sylanbrc lcdlmod cpr wn dvhlvec lspindp2 mapdhcl lspindp1 clss
        simpld wss eqid lspprcl lspprvacl lspsnel5a mtbid nssne2 syl2anc necomd
        lspsnel5 mapdheq mpbir2and ) AUCLUDUFEWBZVLOVMUCLUDVLOVMZUCLUFVLOVMZFWB
        ZVNXPVOTVMZRVMZXSVOZPVMZVNUCXPSWBVOTVMRVMZLXSHWBZVOZPVMZVNAYAMKFWBZVOZP
        VMYCABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCV
        DVEVFVGVHVIVJVKVPAYBYIPAXSYHAXQMXRKFVJVKVQZVRVSVTAYDLYHHWBZVOZPVMYGABCD
        EFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGV
        HVIVJVKWAAYFYLPAYEYKAXSYHLHYJWCVRVSVTABCDGHIJLXSNOPQRSTUAUBUCXPUEUGUHUI
        UJUKULUMUNUOUPUQURUSUTVAVBVCAXPUAWDZXPUEWEXPUAUEVOZWFWDAIWGWDUDUAWDUFUA
        WDYMAINQUBUIUKUTWHZAUDUAYNVFWIZAUFUAYNVGWIZEUAIUDUFULVDWMWJAETUAIUDUFUE
        ULVDUNUOYOYPYQVIWKXPUAUEWLWNACWGWDXQDWDXRDWDXSDWDACNQUBUIUPUTWOABCDGHIJ
        LNOPQRSTUAUBUCUDUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCYPAUCVOTVMZUDVOTVMW
        EUFUCUDWPTVMWDWQATUAIUDUFUEUCULUNUOAINQUBUIUKUTWRZYPVGAUCUAYNVCWIZVIVHW
        SXCWTABCDGHIJLNOPQRSTUAUBUCUFUEUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCYQAYRU
        FVOTVMWEUDUCUFWPTVMWDWQATUAIUDUFUEUCULUNUOYSVFYQYTVIVHXAXCWTFDCXQXRUQVE
        WMWJAXTYRAXTUDUFWPTVMZXDYRUUAXDZWQXTYRWEAIXBVMZUUATIXPUUCXEZUOYOAUUCTUA
        IUDUFULUUDUOYOYPYQXFZAETUAIUDUFULVDUOYOYPYQXGXHAUCUUAWDUUBVHAUUCUUATUAI
        UCULUUDUOYOUUEYTXMXIXTYRUUAXJXKXLXNXO $.
    $}

    ${
      mapdh6b0.y $e |- ( ph -> Y e. V ) $.
      mapdh6b0.z $e |- ( ph -> Z e. V ) $.
      mapdh6b0.ne $e |- ( ph
            -> ( ( N ` { X } ) i^i ( N ` { Y , Z } ) ) = { .0. } ) $.
      $( Lemmma for ~ mapdh6N .  (Contributed by NM, 23-Apr-2015.)
         (New usage is discouraged.) $)
      mapdh6b0N $p |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $=
        ( cpr cfv wcel wn csn cin wceq clss eqid dvhlvec dvhlmod lspprcl mpbird
        lspdisjb ) AUAUBUDVGRVHZVIVJUAVKRVHWAVLUCVKVMVFAIVNVHZWARSIUAUCUJULUMWB
        VOZAILOTUGUIURVPAWBRSIUBUDUJWCUMAILOTUGUIURVQVDVEVRVAVTVS $.
    $}

    ${
      mapdh6b.y $e |- ( ph -> Y = .0. ) $.
      mapdh6b.z $e |- ( ph -> Z e. V ) $.
      mapdh6b.ne $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Lemmma for ~ mapdh6N .  (Contributed by NM, 24-Apr-2015.)
         (New usage is discouraged.) $)
      mapdh6bN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
           = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv cgrp wcel wceq clmod lcdlmod lmodgrp syl csn dvhlvec eldifad
        co dvhlmod lmod0vcl eqeltrd simprd mapdhcl grplid syl2anc oteq3d fveq2d
        wne lspindpi cdif mapdhval0 eqtrd oveq1d 3eqtr4rd ) AGUAKUDVGZMVHZFVSZW
        QUAKUBVGZMVHZWQFVSUAKUBUDEVSZVGZMVHACVIVJZWQDVJWRWQVKACVLVJXCACLOTUGUNU
        RVMCVNVOABCDGHIJKLMNOPQRSTUAUDUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVEAUA
        VPRVHZUBVPRVHWIXDUDVPRVHWIARSIUAUBUDUJUMAILOTUGUIURVQAUASUCVPZVAVRAUBUC
        SVDAIVLVJZUCSVJAILOTUGUIURVTZSIUCUJULWAVOWBVEVFWJWCWDDFCWQGUOVCUEWEWFAW
        TGWQFAWTUAKUCVGZMVHGAWSXHMAUBUCUAKVDWGWHABSXEWKDCDGHIJKMNPQRUAUCUEUFULV
        AUSWLWMWNAXBWPMAXAUDUAKAXAUCUDEVSZUDAUBUCUDEVDWNAIVIVJZUDSVJXIUDVKAXFXJ
        XGIVNVOVESEIUDUCUJVBULWEWFWMWGWHWO $.
    $}

    ${
      mapdh6c.y $e |- ( ph -> Y e. V ) $.
      mapdh6c.z $e |- ( ph -> Z = .0. ) $.
      mapdh6c.ne $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Lemmma for ~ mapdh6N .  (Contributed by NM, 24-Apr-2015.)
         (New usage is discouraged.) $)
      mapdh6cN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
           = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv cgrp wcel wceq clmod lcdlmod lmodgrp syl csn dvhlvec eldifad
        co dvhlmod lmod0vcl eqeltrd simpld mapdhcl grprid syl2anc oteq3d fveq2d
        wne lspindpi cdif mapdhval0 eqtrd oveq2d 3eqtr4rd ) AUAKUBVGZMVHZGFVSZW
        QWQUAKUDVGZMVHZFVSUAKUBUDEVSZVGZMVHACVIVJZWQDVJWRWQVKACVLVJXCACLOTUGUNU
        RVMCVNVOABCDGHIJKLMNOPQRSTUAUBUCUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVDAUA
        VPRVHZUBVPRVHWIXDUDVPRVHWIARSIUAUBUDUJUMAILOTUGUIURVQAUASUCVPZVAVRVDAUD
        UCSVEAIVLVJZUCSVJAILOTUGUIURVTZSIUCUJULWAVOWBVFWJWCWDDFCWQGUOVCUEWEWFAW
        TGWQFAWTUAKUCVGZMVHGAWSXHMAUDUCUAKVEWGWHABSXEWKDCDGHIJKMNPQRUAUCUEUFULV
        AUSWLWMWNAXBWPMAXAUBUAKAXAUBUCEVSZUBAUDUCUBEVEWNAIVIVJZUBSVJXIUBVKAXFXJ
        XGIVNVOVDSEIUBUCUJVBULWEWFWMWGWHWO $.
    $}

    $d h .+b $.  $d h x I $.  $d h x .+ $.  $d x w $.
    ${
      mapdh6d.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      mapdh6d.yz $e |- ( ph -> ( N ` { Y } ) = ( N ` { Z } ) ) $.
      $(
      mapdh6d.fg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh6d.fe $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      mapdh6d.fb $e |- ( ph -> ( I ` <. X , F , w >. ) = B ) $.
      $)
      mapdh6d.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh6d.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdh6d.w $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
      mapdh6d.wn $e |- ( ph -> -. w e. ( N ` { X , Y } ) ) $.
      $( Lemmma for ~ mapdh6N .  (Contributed by NM, 1-May-2015.)
         (New usage is discouraged.) $)
      mapdh6dN $p |- ( ph -> ( I ` <. X , F , ( w .+ ( Y .+ Z ) ) >. )
        = ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , ( Y .+ Z ) >. ) ) ) $=
        ( cv co cotp cfv wceq wa clmod lcdlmod csn eldifad wne dvhlvec lspindpi
        wcel simpld necomd mapdhcl lmod0vrid adantr oteq3 fveq2d cdif mapdhval0
        syl2anc sylan9eqr oveq2d oveq2 dvhlmod oteq3d 3eqtr4rd lmodvacl syl3anc
        chlt anim1i eldifsn sylibr cpr wn mapdindp1 mapdindp2 lspindp1 lspsnne1
        simprd clsm eqid lsmpr csubg clss lspsncl lsssubg syl 3eqtr2d neleqtrrd
        lsmidm lspindp4 eqidd mapdh6aN pm2.61dane ) AUBLCVKZUCUEFVLZFVLZVMZNVNZ
        UBLYIVMZNVNZUBLYJVMZNVNZGVLZVOYJUDAYJUDVOZVPZYOHGVLZYOYRYMAUUAYOVOZYSAD
        VQWDYOEWDUUBADMPUAUHUOUSVRABDEHIJKLMNOPQRSTUAUBYIUDUFUGUHUIUJUKULUMUNUO
        UPUQURUSUTVAVBAYITUDVSZVIVTZAYIVSSVNZUBVSSVNZAUUEUUFWAZUUEUCVSSVNZWAZAS
        TJYIUBUCUKUNAJMPUAUHUJUSWBZUUDAUBTUUCVBVTZAUCTUUCVGVTZVJWCZWEWFWGGEDYOH
        UPVDUFWHWNWIYTYQHYOGYSAYQUBLUDVMZNVNHYSYPUUNNYJUDUBLWJWKABTUUCWLZEDEHIJ
        KLNOQRSUBUDUFUGUMVBUTWMWOWPYTYLYNNYTYKYIUBLYSAYKYIUDFVLZYIYJUDYIFWQAJVQ
        WDZYITWDUUPYIVOAJMPUAUHUJUSWRZUUDFTJYIUDUKVCUMWHWNWOWSWKWTAYJUDWAZVPZBD
        EFGHIJKYQLYOMNOPQRSTUAUBYIUDYJUFUGUHUIUJUKULUMUNUOUPUQURAPXCWDUAMWDVPUU
        SUSWIALEWDUUSUTWIAUUFQVNLVSOVNVOUUSVAWIAUBUUOWDUUSVBWIVCVDAYIUUOWDUUSVI
        WIUUTYJTWDZUUSVPYJUUOWDAUVAUUSAUUQUCTWDZUETWDUVAUURUULAUETUUCVHVTZFTJUC
        UEUKVCXAXBZXDYJTUDXEXFAUBYIYJXGSVNWDXHZUUSAUUEYJVSSVNWAZUVEASTJUBYJUDYI
        UKUMUNUUJVBUVDUUDACFSTJUBUCUDUEUKVCUMUNUUJVBVGVHVIVFAUUFUUHWAUUFUEVSSVN
        ZWAASTJUBUCUEUKUNUUJUUKUULUVCVEWCWEZVJXIACFSTJUBUCUDUEUKVCUMUNUUJVBVGVH
        VIVFUVHVJXJXKXMWIAUVFUUSAUUIUVFASTJYIUCYJUKUNUUJUUDUULUVDAFSTJUCUEYIUKV
        CUNUURUULUVCUUDAUCUEXGSVNZUUHYIASTJYIUCUDUKUMUNUUJVIUULAUUGUUIUUMXMXLAU
        VIUUHUVGJXNVNZVLUUHUUHUVJVLZUUHAUVJSTJUCUEUKUNUVJXOZUURUULUVCXPAUUHUVGU
        UHUVJVFWPAUUHJXQVNWDZUVKUUHVOAUUQUUHJXRVNZWDZUVMUURAUUQUVBUVOUURUULUVNS
        TJUCUKUVNXOZUNXSWNUVNUUHJUVPXTWNUVJUUHJUVLYDYAYBYCYEWCXMWIUUTYOYFUUTYQY
        FYGYH $.

      $( Lemmma for ~ mapdh6N .  Part (6) in [Baer] p. 47 line 38.
         (Contributed by NM, 1-May-2015.)  (New usage is discouraged.) $)
      mapdh6eN $p |- ( ph -> ( I ` <. X , F , ( ( w .+ Y ) .+ Z ) >. )
        = ( ( I ` <. X , F , ( w .+ Y ) >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv cv co wcel wne cdif dvhlmod eldifad lmodvacl syl3anc dvhlvec
        clmod lspindpi simprd lmodindp1 eldifsn sylanbrc wn mapdindp3 mapdindp4
        csn simpld lspindp1 prcom fveq2i eleq2i sylnibr necomd eqidd mapdh6aN
        cpr ) ABDEFGHIJKUBLUEVKNVLZLUBLCVMZUCFVNZVKNVLZMNOPQRSTUAUBXEUDUEUFUGUH
        UIUJUKULUMUNUOUPUQURUSUTVAVBVCVDAXETVOZXEUDVPXETUDWLZVQVOAJWCVOXDTVOUCT
        VOXGAJMPUAUHUJUSVRZAXDTXHVIVSZAUCTXHVGVSZFTJXDUCUKVCVTWAZAFSTJXDUCUDUKV
        CUMUNXIXJXKAXDWLSVLZUBWLSVLZVPXMUCWLSVLZVPASTJXDUBUCUKUNAJMPUAUHUJUSWBZ
        XJAUBTXHVBVSZXKVJWDWEWFXETUDWGWHVHAUBUEXEXBZSVLZVOZUBXEUEXBZSVLZVOAUEWL
        SVLZXEWLSVLZVPZXTWIASTJUBXEUDUEUKUMUNXPVBXLAUETXHVHVSZACFSTJUBUCUDUEUKV
        CUMUNXPVBVGVHVIVFAXNXOVPXNYCVPASTJUBUCUEUKUNXPXQXKYFVEWDWMZVJWJACFSTJUB
        UCUDUEUKVCUMUNXPVBVGVHVIVFYGVJWKZWNWEYBXSUBYAXRSXEUEWOWPWQWRAYCYDAYCXNV
        PYEASTJUEUBXEUKUNXPYFXQXLYHWDWEWSAXFWTAXCWTXA $.

      $( Lemmma for ~ mapdh6N .  Part (6) in [Baer] p. 47 line 38.
         (Contributed by NM, 1-May-2015.)  (New usage is discouraged.) $)
      mapdh6fN $p |- ( ph -> ( I ` <. X , F , ( w .+ Y ) >. )
           = ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , Y >. ) ) ) $=
        ( cotp cfv cv csn wne cpr wcel dvhlvec eldifad lspindpi simpld lspindp1
        wn simprd eqidd mapdh6aN ) ABDEFGHIJKUBLUCVKNVLZLUBLCVMZVKNVLZMNOPQRSTU
        AUBWHUDUCUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVIVGAWHVNSVLZUCVNSVLZVOZ
        UBWHUCVPSVLVQWCASTJUBUCUDWHUKUMUNAJMPUAUHUJUSVRZVBAUCTUDVNZVGVSZAWHTWNV
        IVSZAUBVNSVLZWKVOWQUEVNSVLVOASTJUBUCUEUKUNWMAUBTWNVBVSZWOAUETWNVHVSVEVT
        WAVJWBWDAWJWQVOWLASTJWHUBUCUKUNWMWPWRWOVJVTWDAWIWEAWGWEWF $.

      $( Lemmma for ~ mapdh6N .  Part (6) of [Baer] p. 47 line 39.
         (Contributed by NM, 1-May-2015.)  (New usage is discouraged.) $)
      mapdh6gN $p |- ( ph
  -> ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , ( Y .+ Z ) >. ) )
           = ( ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , Y >. ) )
               .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cv cotp cfv mapdh6dN mapdh6eN clmod wcel wceq dvhlmod eldifad lmodass
        co csn syl13anc oteq3d fveq2d mapdh6fN oveq1d 3eqtr3d eqtr3d ) AUBLCVKZ
        UCUEFWBZFWBZVLZNVMZUBLWKVLNVMZUBLWLVLNVMGWBWPUBLUCVLNVMGWBZUBLUEVLNVMZG
        WBZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVD
        VEVFVGVHVIVJVNAUBLWKUCFWBZUEFWBZVLZNVMUBLWTVLNVMZWRGWBWOWSABCDEFGHIJKLM
        NOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJVOAX
        BWNNAXAWMUBLAJVPVQWKTVQUCTVQUETVQXAWMVRAJMPUAUHUJUSVSAWKTUDWCZVIVTAUCTX
        DVGVTAUETXDVHVTFTJWKUCUEUKVCWAWDWEWFAXCWQWRGABCDEFGHIJKLMNOPQRSTUAUBUCU
        DUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJWGWHWIWJ $.

      $( Lemmma for ~ mapdh6N .  Part (6) of [Baer] p. 48 line 2.  (Contributed
         by NM, 1-May-2015.)  (New usage is discouraged.) $)
      mapdh6hN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
           = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cv cotp cfv wceq mapdh6gN clmod wcel lcdlmod csn eldifad wne lspindpi
        co dvhlvec simpld necomd mapdhcl simprd lmodass syl13anc eqtrd lmodvacl
        wb dvhlmod syl3anc mapdindp1 lmodlcan mpbid ) AUBLCVKZVLNVMZUBLUCUEFWCZ
        VLNVMZGWCZWTUBLUCVLNVMZUBLUEVLNVMZGWCZGWCZVNZXBXFVNZAXCWTXDGWCXEGWCZXGA
        BCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVF
        VGVHVIVJVOADVPVQZWTEVQZXDEVQZXEEVQZXJXGVNADMPUAUHUOUSVRZABDEHIJKLMNOPQR
        STUAUBWSUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBAWSTUDVSZVIVTZAWSVSSVMZUBVS
        SVMZAXRXSWAXRUCVSSVMZWAASTJWSUBUCUKUNAJMPUAUHUJUSWDZXQAUBTXPVBVTZAUCTXP
        VGVTZVJWBWEWFWGZABDEHIJKLMNOPQRSTUAUBUCUDUFUGUHUIUJUKULUMUNUOUPUQURUSUT
        VAVBYCAXSXTWAZXSUEVSSVMWAZASTJUBUCUEUKUNYAYBYCAUETXPVHVTZVEWBZWEZWGZABD
        EHIJKLMNOPQRSTUAUBUEUDUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBYGAYEYFYHWHWGZG
        EDWTXDXEUPVDWIWJWKAXKXBEVQXFEVQZXLXHXIWMXOABDEHIJKLMNOPQRSTUAUBXAUDUFUG
        UHUIUJUKULUMUNUOUPUQURUSUTVAVBAJVPVQUCTVQUETVQXATVQAJMPUAUHUJUSWNYCYGFT
        JUCUEUKVCWLWOACFSTJUBUCUDUEUKVCUMUNYAVBVGVHVIVFYIVJWPWGAXKXMXNYLXOYJYKG
        EDXDXEUPVDWLWOYDGEDXBXFWTUPVDWQWJWR $.
    $}

    ${
      $d w .+b $.  $d w F $.  $d w I $.  $d w N $.  $d w .+ $.  $d w U $.
      $d h w V $.  $d w X $.  $d w Y $.  $d w Z $.  $d w ph $.
      mapdh6i.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      mapdh6i.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh6i.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      ${
        mapdh6i.yz $e |- ( ph -> ( N ` { Y } ) = ( N ` { Z } ) ) $.
        $( Lemmma for ~ mapdh6N .  Eliminate auxiliary vector ` w ` .
           (Contributed by NM, 1-May-2015.)  (New usage is discouraged.) $)
        mapdh6iN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
             = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
          ( vw cv cpr cfv wcel wn wrex co cotp wceq csn eldifad dvh3dim chlt wa
          3ad2ant1 cdif clss eqid clmod dvhlmod lspprcl simp2 lssneln0 mapdh6hN
          w3a simp3 rexlimdv3a mpd ) AVHVIZUAUBVJRVKZVLVMZVHSVNUAKUBUDEVOVPMVKU
          AKUBVPMVKUAKUDVPMVKFVOVQZAVHILORSTUAUBUGUIUJUMURAUASUCVRZVAVSZAUBSXAV
          EVSZVTAWSWTVHSAWQSVLZWSWMZBVHCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUK
          ULUMUNUOUPUQAXDOWAVLTLVLWBWSURWCAXDKDVLWSUSWCAXDUAVRRVKPVKKVRNVKVQWSU
          TWCAXDUASXAWDZVLWSVAWCVBVCAXDUAUBUDVJRVKVLVMWSVDWCAXDUBVRRVKUDVRRVKVQ
          WSVGWCAXDUBXFVLWSVEWCAXDUDXFVLWSVFWCXEIWEVKZWRSIWQUCUJULXGWFZAXDIWGVL
          WSAILOTUGUIURWHZWCAXDWRXGVLWSAXGRSIUAUBUJXHUMXIXBXCWIWCAXDWSWJAXDWSWN
          ZWKXJWLWOWP $.
      $}

      $( Lemmma for ~ mapdh6N .  Eliminate ` ( N ` { Y } ) = ( N ` { Z } ) `
         hypothesis.  (Contributed by NM, 1-May-2015.)
         (New usage is discouraged.) $)
      mapdh6jN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
             = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( co cotp cfv wceq csn wa chlt wcel adantr cdif wn simpr mapdh6iN eqidd
        cpr wne mapdh6aN pm2.61dane ) AUAKUBUDEVGVHMVIUAKUBVHMVIZUAKUDVHMVIZFVG
        VJUBVKRVIZUDVKRVIZAWGWHVJZVLBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
        UMUNUOUPUQAOVMVNTLVNVLZWIURVOAKDVNZWIUSVOAUAVKRVIPVIKVKNVIVJZWIUTVOAUAS
        UCVKVPZVNZWIVAVOVBVCAUAUBUDWARVIVNVQZWIVDVOAUBWMVNZWIVEVOAUDWMVNZWIVFVO
        AWIVRVSAWGWHWBZVLZBCDEFGHIJWFKWELMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUO
        UPUQAWJWRURVOAWKWRUSVOAWLWRUTVOAWNWRVAVOVBVCAWPWRVEVOAWQWRVFVOAWOWRVDVO
        AWRVRWSWEVTWSWFVTWCWD $.
    $}

    ${
      $d h V $.
      mapdh6k.y $e |- ( ph -> Y e. V ) $.
      mapdh6k.z $e |- ( ph -> Z e. V ) $.
      mapdh6k.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Lemmma for ~ mapdh6N .  Eliminate nonzero vector requirement.
         (Contributed by NM, 1-May-2015.)  (New usage is discouraged.) $)
      mapdh6kN $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
             = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( co cotp cfv wceq wa chlt wcel adantr csn cdif simpr mapdh6bN mapdh6cN
        cpr wn wne simprl eldifsn sylanbrc simprr mapdh6jN pm2.61da2ne ) AUAKUB
        UDEVGVHMVIUAKUBVHMVIUAKUDVHMVIFVGVJUBUCUDUCAUBUCVJZVKBCDEFGHIJKLMNOPQRS
        TUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQAOVLVMTLVMVKZWIURVNAKDVMZWIUSVNAUAVO
        RVIPVIKVONVIVJZWIUTVNAUASUCVOVPZVMZWIVAVNVBVCAWIVQAUDSVMZWIVEVNAUAUBUDV
        TRVIVMWAZWIVFVNVRAUDUCVJZVKBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULU
        MUNUOUPUQAWJWQURVNAWKWQUSVNAWLWQUTVNAWNWQVAVNVBVCAUBSVMZWQVDVNAWQVQAWPW
        QVFVNVSAUBUCWBZUDUCWBZVKZVKZBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
        UMUNUOUPUQAWJXAURVNAWKXAUSVNAWLXAUTVNAWNXAVAVNVBVCAWPXAVFVNXBWRWSUBWMVM
        AWRXAVDVNAWSWTWCUBSUCWDWEXBWOWTUDWMVMAWOXAVEVNAWSWTWFUDSUCWDWEWGWH $.
    $}

  $}

  ${
    $d h x .- $.  $d h .+b $.  $d h C $.  $d h x D $.  $d h x F $.  $d h x I $.
    $d h x .0. $.  $d h x J $.  $d h x M $.  $d h x N $.  $d h ph $.  $d x Q $.
    $d h x .+ $.  $d h x R $.  $d h U $.  $d h x X $.  $d h x Y $.  $d h x Z $.
    $d h V $.
    mapdh6.h $e |- H = ( LHyp ` K ) $.
    mapdh6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdh6.v $e |- V = ( Base ` U ) $.
    mapdh6.p $e |- .+ = ( +g ` U ) $.
    mapdh6.s $e |- .- = ( -g ` U ) $.
    mapdh6.o $e |- .0. = ( 0g ` U ) $.
    mapdh6.n $e |- N = ( LSpan ` U ) $.
    mapdh6.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdh6.d $e |- D = ( Base ` C ) $.
    mapdh6.a $e |- .+b = ( +g ` C ) $.
    mapdh6.r $e |- R = ( -g ` C ) $.
    mapdh6.q $e |- Q = ( 0g ` C ) $.
    mapdh6.j $e |- J = ( LSpan ` C ) $.
    mapdh6.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdh6.i $e |- I = ( x e. _V |->
     if ( ( 2nd ` x ) = .0. , Q ,
        ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    mapdh6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdh6.f $e |- ( ph -> F e. D ) $.
    mapdh6.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    mapdh6.y $e |- ( ph -> Y e. V ) $.
    mapdh6.z $e |- ( ph -> Z e. V ) $.
    mapdh6.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    mapdh6.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
    $( Part (6) of [Baer] p. 47 line 6.  Note that we use
       ` -. X e. ( N `` { Y , Z } ) ` which is equivalent to Baer's "Fx ` i^i `
       (Fy + Fz)" by ~ lspdisjb .  TODO:  If $ds with ` I ` and ` ph ` becomes
       a problem later, cbv's on ` I ` variables here to get rid of them. .
       Maybe reorder hypotheses in lemmas to the more consistent order of this
       theorem, so they can be shared with this theorem.  (Contributed by NM,
       1-May-2015.)  (New usage is discouraged.) $)
    mapdh6N $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. ) = ( ( I ` <. X , F
   , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
      ( mapdh6kN ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUPUSUEURUFUGUIUJUKULUMUOUQUTVAVF
      VBUHUNVCVDVEVG $.
  $}

  ${
    $d h x .- $.  $d h C $.  $d h x D $.  $d h x E $.  $d h x F $.  $d h x G $.
    $d h x .0. $.  $d h x J $.  $d h x M $.  $d h x N $.  $d h ph $.  $d x Q $.
    $d h u v w x $.  $d h x R $.  $d h U $.
    mapdh7.h $e |- H = ( LHyp ` K ) $.
    mapdh7.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdh7.v $e |- V = ( Base ` U ) $.
    mapdh7.s $e |- .- = ( -g ` U ) $.
    mapdh7.o $e |- .0. = ( 0g ` U ) $.
    mapdh7.n $e |- N = ( LSpan ` U ) $.
    mapdh7.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdh7.d $e |- D = ( Base ` C ) $.
    mapdh7.r $e |- R = ( -g ` C ) $.
    mapdh7.q $e |- Q = ( 0g ` C ) $.
    mapdh7.j $e |- J = ( LSpan ` C ) $.
    mapdh7.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdh7.i $e |- I = ( x e. _V |->
     if ( ( 2nd ` x ) = .0. , Q ,
        ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    mapdh7.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdh7.f $e |- ( ph -> F e. D ) $.
    mapdh7.mn $e |- ( ph -> ( M ` ( N ` { u } ) ) = ( J ` { F } ) ) $.
    mapdh7.x $e |- ( ph -> u e. ( V \ { .0. } ) ) $.
    mapdh7.y $e |- ( ph -> v e. ( V \ { .0. } ) ) $.
    mapdh7.z $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
    mapdh7.ne $e |- ( ph -> ( N ` { u } ) =/= ( N ` { v } ) ) $.
    mapdh7.wn $e |- ( ph -> -. w e. ( N ` { u , v } ) ) $.
    ${
      mapdh7b $e |- ( ph -> ( I ` <. u , F , w >. ) = E ) $.
      $( Part (7) of [Baer] p. 48 line 10 (5 of 6 cases).  (Note: 1 of 6 and 2
         of 6 are hypotheses a and b.)  (Contributed by NM, 2-May-2015.)
         (New usage is discouraged.) $)
      mapdh7eN $p |- ( ph -> ( I ` <. w , E , u >. ) = F ) $=
        ( cotp cfv wceq csn eldifad wne dvhlvec lspindpi simpld necomd eqeltrrd
        cv mapdhcl mapdheq2 mpd ) AEVQZMCVQZVFOVGZLVHWBLWAVFOVGMVHVEABFGHIJKMLN
        OPQRSTUAUBWAWBUCUMUPUDUOUEUFUGUHUIUJUKULUNUQURUSUTVBAWCLGVEABFGHIJKMNOP
        QRSTUAUBWAWBUCUMUPUDUOUEUFUGUHUIUJUKULUNUQURUSUTAWBUAUCVIZVBVJZAWBVITVG
        ZWAVITVGZAWFWGVKWFDVQZVITVGVKATUAJWBWAWHUFUIAJNQUBUDUEUQVLWEAWAUAWDUTVJ
        AWHUAWDVAVJVDVMVNVOZVRVPWIVSVT $.
    $}

    mapdh7a $e |- ( ph -> ( I ` <. u , F , v >. ) = G ) $.
    $( Part (7) of [Baer] p. 48 line 10 (3 of 6 cases).  (Contributed by NM,
       2-May-2015.)  (New usage is discouraged.) $)
    mapdh7cN $p |- ( ph -> ( I ` <. v , G , u >. ) = F ) $=
      ( cv cotp cfv wceq csn eldifad mapdhcl eqeltrrd mapdheq2 mpd ) AEVFZLDVFZ
      VGOVHZMVIVQMVPVGOVHLVIVEABFGHIJKLMNOPQRSTUAUBVPVQUCUMUPUDUOUEUFUGUHUIUJUK
      ULUNUQURUSUTVAAVRMGVEABFGHIJKLNOPQRSTUAUBVPVQUCUMUPUDUOUEUFUGUHUIUJUKULUN
      UQURUSUTAVQUAUCVJVAVKVCVLVMVCVNVO $.

    mapdh7.b $e |- ( ph -> ( I ` <. u , F , w >. ) = E ) $.
    $( Part (7) of [Baer] p. 48 line 10 (4 of 6 cases).  (Contributed by NM,
       2-May-2015.)  (New usage is discouraged.) $)
    mapdh7dN $p |- ( ph -> ( I ` <. v , G , w >. ) = E ) $=
      ( cv cpr cfv wcel csn wne wn dvhlvec eldifad lspindp1 simprd prcom fveq2i
      eleq2i sylnibr lspindpi necomd mapdheq4 ) ABFGHIJKLMNOPQRSTUAUBUCEVHZDVHZ
      UDCVHZUNUQUEUPUFUGUHUIUJUKULUMUOURUSUTVAVBVCAWFWHWGVIZUAVJZVKZWFWGWHVIZUA
      VJZVKAWHVLUAVJZWGVLUAVJZVMZWKVNAUAUBJWFWGUDWHUGUIUJAJORUCUEUFURVOZVAAWGUB
      UDVLZVBVPZAWHUBWRVCVPZVDVEVQVRWMWJWFWLWIUAWGWHVSVTWAWBAWNWOAWNWFVLUAVJVMW
      PAUAUBJWHWFWGUGUJWQWTAWFUBWRVAVPWSVEWCVRWDVFVGWE $.

    $( Part (7) of [Baer] p. 48 line 10 (6 of 6 cases).  (Contributed by NM,
       2-May-2015.)  (New usage is discouraged.) $)
    mapdh7fN $p |- ( ph -> ( I ` <. w , E , v >. ) = G ) $=
      ( cv cotp cfv wceq mapdh7dN csn eldifad mapdhcl eqeltrrd co mapdheq mpbid
      wa simpld wne dvhlvec lspindpi necomd simprd mapdheq2 mpd ) ADVHZNCVHZVIP
      VJLVKWJLWIVIPVJNVKABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQU
      RUSUTVAVBVCVDVEVFVGVLABFGHIJKNLOPQRSTUAUBUCWIWJUDUNUQUEUPUFUGUHUIUJUKULUM
      UOURAEVHZMWIVIPVJZNGVFABFGHIJKMOPQRSTUAUBUCWKWIUDUNUQUEUPUFUGUHUIUJUKULUM
      UOURUSUTVAAWIUBUDVMZVBVNZVDVOVPZAWIVMUAVJZSVJNVMQVJVKZWKWITVQVMUAVJSVJMNI
      VQVMQVJVKZAWLNVKWQWRVTVFABFGHIJKMNOPQRSTUAUBUCWKWIUDUNUQUEUPUFUGUHUIUJUKU
      LUMUOURUSUTVAVBWOVDVRVSWAVBVCAWKMWJVIPVJLGVGABFGHIJKMOPQRSTUAUBUCWKWJUDUN
      UQUEUPUFUGUHUIUJUKULUMUOURUSUTVAAWJUBWMVCVNZAWJVMUAVJZWKVMUAVJZAWTXAWBZWT
      WPWBZAUAUBJWJWKWIUGUJAJORUCUEUFURWCWSAWKUBWMVAVNWNVEWDZWAWEVOVPAWTWPAXBXC
      XDWFWEWGWH $.
  $}

  ${
    $d h x .- $.  $d h C $.  $d h x D $.  $d h x E $.  $d h x F $.  $d h x G $.
    $d h x .0. $.  $d h x J $.  $d h x M $.  $d h x N $.  $d h ph $.  $d x Q $.
    $d h x R $.  $d h U $.  $d h x X $.  $d h x Y $.  $d h x Z $.
    mapdh75.h $e |- H = ( LHyp ` K ) $.
    mapdh75.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdh75.v $e |- V = ( Base ` U ) $.
    mapdh75.s $e |- .- = ( -g ` U ) $.
    mapdh75.o $e |- .0. = ( 0g ` U ) $.
    mapdh75.n $e |- N = ( LSpan ` U ) $.
    mapdh75.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdh75.d $e |- D = ( Base ` C ) $.
    mapdh75.r $e |- R = ( -g ` C ) $.
    mapdh75.q $e |- Q = ( 0g ` C ) $.
    mapdh75.j $e |- J = ( LSpan ` C ) $.
    mapdh75.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdh75.i $e |- I = ( x e. _V |->
     if ( ( 2nd ` x ) = .0. , Q ,
        ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    mapdh75.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdh75.f $e |- ( ph -> F e. D ) $.
    mapdh75.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
    ${
      mapdh75b $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      mapdh75e.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Z } ) ) $.
      mapdh75e.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh75e.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      $( Part (7) of [Baer] p. 48 line 10 (5 of 6 cases). ` X ` , ` Y ` , ` Z `
         are Baer's u, v, w.  (Note:  Cases 1 of 6 and 2 of 6 are hypotheses
         mapdh75b here and mapdh75a in ~ mapdh75cN .)  (Contributed by NM,
         2-May-2015.) $)
      mapdh75e $p |- ( ph -> ( I ` <. Z , E , X >. ) = F ) $=
        ( cotp cfv wceq csn eldifad mapdhcl eqeltrrd mapdheq2 mpd ) ATJUBVCLVDZ
        IVEUBITVCLVDJVEUSABCDEFGHJIKLMNOPQRSTUBUAULUOUCUNUDUEUFUGUHUIUJUKUMUPUQ
        URVAVBAVLIDUSABCDEFGHJKLMNOPQRSTUBUAULUOUCUNUDUEUFUGUHUIUJUKUMUPUQURVAA
        UBRUAVFVBVGUTVHVIUTVJVK $.
    $}

    mapdh75a $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
    ${
      mapdh75c.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      mapdh75c.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh75c.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      $( Part (7) of [Baer] p. 48 line 10 (3 of 6 cases).  (Contributed by NM,
         2-May-2015.)  (New usage is discouraged.) $)
      mapdh75cN $p |- ( ph -> ( I ` <. Y , G , X >. ) = F ) $=
        ( mapdh75e ) ABCDEFGHJIKLMNOPQRSTUBUAUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUS
        UTVAVBVC $.
    $}

    mapdh75d.b $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
    mapdh75d.vw $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
    mapdh75d.un $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    mapdh75d.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    mapdh75d.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    mapdh75d.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
    ${
      $( Part (7) of [Baer] p. 48 line 10 (4 of 6 cases).  (Contributed by NM,
         2-May-2015.) $)
      mapdh75d $p |- ( ph -> ( I ` <. Y , G , Z >. ) = E ) $=
        ( mapdheq4 ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUNUQUEUPUFUGUHUIUJUKULUMUOURUS
        UTVEVFVGVDVCVAVBVH $.
    $}

    $( Part (7) of [Baer] p. 48 line 10 (6 of 6 cases).  (Contributed by NM,
       2-May-2015.)  (New usage is discouraged.) $)
    mapdh75fN $p |- ( ph -> ( I ` <. Z , E , Y >. ) = G ) $=
      ( cotp cfv csn eldifad wne dvhlvec lspindpi simpld mapdhcl eqeltrrd co wa
      wceq mapdheq mpbid mapdh75d mapdh75e ) ABCDEFGHIKLMNOPQRSTUBUCUDUEUFUGUHU
      IUJUKULUMUNUOUPUQURAUAJUBVHMVIZKDVAABCDEFGHJLMNOPQRSTUAUBUCUNUQUEUPUFUGUH
      UIUJUKULUMUOURUSUTVEAUBSUCVJZVFVKZAUAVJRVIZUBVJRVIZVLWHUDVJRVIVLARSGUAUBU
      DUGUJAGLOTUEUFURVMAUASWFVEVKWGAUDSWFVGVKVDVNVOZVPVQZAWIPVIKVJNVIVTZUAUBQV
      RVJRVIPVIJKFVRVJNVIVTZAWEKVTWLWMVSVAABCDEFGHJKLMNOPQRSTUAUBUCUNUQUEUPUFUG
      UHUIUJUKULUMUOURUSUTVEVFWKWJWAWBVOABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIU
      JUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGWCVCVFVGWD $.
  $}

  $c HVMap $.

  $( Extend class notation with vector to dual map. $)
  chvm $a class HVMap $.

  ${
    $d k w x v j t $.
    $( Extend class notation with a map from each nonzero vector ` x ` to a
       unique nonzero functional in the closed kernel dual space.  (We could
       extend it to include the zero vector, but that is unnecessary for our
       purposes.)  TODO:  This pattern is used several times earlier e.g.
       ~ lcf1o , ~ dochfl1 - should we update those to use this definition?
       (Contributed by NM, 23-Mar-2015.) $)
    df-hvmap $a |- HVMap = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
          ( x e. ( ( Base ` ( ( DVecH ` k ) ` w ) )
               \ { ( 0g ` ( ( DVecH ` k ) ` w ) ) } ) |->
  ( v e. ( Base ` ( ( DVecH ` k ) ` w ) ) |->
          ( iota_ j e. ( Base ` ( Scalar ` ( ( DVecH ` k ) ` w ) ) )
      E. t e. ( ( ( ocH ` k ) ` w ) ` { x } )
          v = ( t ( +g ` ( ( DVecH ` k ) ` w ) ) ( j
           ( .s ` ( ( DVecH ` k ) ` w ) ) x ) ) ) ) ) ) ) $.
  $}

  ${
    $d k w H $.  $d j k t v x w K $.  $d t W $.  $d x k t $.
    hvmapval.h $e |- H = ( LHyp ` K ) $.
    $( Map from nonzero vectors to nonzero functionals in the closed kernel
       dual space.  (Contributed by NM, 23-Mar-2015.) $)
    hvmapffval $p |- ( K e. X -> ( HVMap ` K ) = ( w e. H |->
          ( x e. ( ( Base ` ( ( DVecH ` K ) ` w ) )
               \ { ( 0g ` ( ( DVecH ` K ) ` w ) ) } ) |->
  ( v e. ( Base ` ( ( DVecH ` K ) ` w ) ) |->
          ( iota_ j e. ( Base ` ( Scalar ` ( ( DVecH ` K ) ` w ) ) )
      E. t e. ( ( ( ocH ` K ) ` w ) ` { x } )
          v = ( t ( +g ` ( ( DVecH ` K ) ` w ) ) ( j
           ( .s ` ( ( DVecH ` K ) ` w ) ) x ) ) ) ) ) ) ) $=
      ( vk cvv cfv cv cdvh cbs co wceq cmpt clh fveq2d wcel chvm c0g cdif cvsca
      cplusg coch wrex csca crio elex fveq2 syl6eqr fveq1d sneqd difeq12d eqidd
      csn oveq123d eqeq2d rexeqbidv riotaeqbidv mpteq12dv df-hvmap fvex eqeltri
      oveqd mptex fvmpt syl ) GHUAGKUAGUBLBFABMZGNLZLZOLZVMUCLZURZUDZCVNCMZDMZE
      MZAMZVMUELZPZVMUFLZPZQZDWAURZVKGUGLZLZLZUHZEVMUILZOLZUJZRZRZRZQGHUKJGBJMZ
      SLZAVKWRNLZLZOLZXAUCLZURZUDZCXBVRVSVTWAXAUELZPZXAUFLZPZQZDWGVKWRUGLZLZLZU
      HZEXAUILZOLZUJZRZRZRWQKUBWRGQZBWSXSFWPXTWSGSLZFWRGSULIUMXTAXEXRVQWOXTXBVN
      XDVPXTXAVMOXTVKWTVLWRGNULUNZTZXTXCVOXTXAVMUCYBTUOUPXTCXBXQVNWNYCXTXNWKEXP
      WMXTXOWLOXTXAVMUIYBTTXTXJWFDXMWJXTWGXLWIXTVKXKWHWRGUGULUNUNXTXIWEVRXTVSVS
      XGWCXHWDXTXAVMUFYBTXTVSUQXTXFWBVTWAXTXAVMUEYBTVGUSUTVAVBVCVCVCABCDEJVDBFW
      PFYAKIGSVEVFVHVIVJ $.

    $d t w O $.  $d w .+ $.  $d j w R $.  $d w .x. $.  $d w x V $.
    $d j v w x W $.  $d w x .0. $.
    hvmapval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hvmapval.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hvmapval.v $e |- V = ( Base ` U ) $.
    hvmapval.p $e |- .+ = ( +g ` U ) $.
    hvmapval.t $e |- .x. = ( .s ` U ) $.
    hvmapval.z $e |- .0. = ( 0g ` U ) $.
    hvmapval.s $e |- S = ( Scalar ` U ) $.
    hvmapval.r $e |- R = ( Base ` S ) $.
    hvmapval.m $e |- M = ( ( HVMap ` K ) ` W ) $.
    hvmapval.k $e |- ( ph -> ( K e. A /\ W e. H ) ) $.
    $( Map from nonzero vectors to nonzero functionals in the closed kernel
       dual space.  (Contributed by NM, 23-Mar-2015.) $)
    hvmapfval $p |- ( ph -> M = ( x e. ( V \ { .0. } ) |-> ( v e. V |->
     ( iota_ j e. R E. t e. ( O ` { x } ) v = ( t .+ ( j .x. x ) ) ) ) ) ) $=
      ( vw wcel wa csn cdif cv co wceq cfv wrex crio cmpt cdvh cbs cvsca cplusg
      c0g coch csca chvm hvmapffval fveq1d syl5eq fveq2 syl6eqr fveq2d difeq12d
      sneqd eqidd oveq123d eqeq2d rexeqbidv riotaeqbidv mpteq12dv eqid cvv fvex
      oveqd eqeltri difexg ax-mp mptex fvmpt sylan9eq syl ) AMEUKZQLUKZULNBPRUM
      ZUNZCPCUOZDUOZKUOZBUOZIUPZFUPZUQZDXBUMZOURZUSZKGUTZVAZVAZUQUIWOWPNQUJLBUJ
      UOZMVBURZURZVCURZXNVFURZUMZUNZCXOWSWTXAXBXNVDURZUPZXNVEURZUPZUQZDXFXLMVGU
      RZURZURZUSZKXNVHURZVCURZUTZVAZVAZVAZURZXKWONQMVIURZURYNUHWOQYOYMBUJCDKLME
      SVJVKVLUJQYLXKLYMXLQUQZBXRYKWRXJYPXOPXQWQYPXOJVCURZPYPXNJVCYPXNQXMURJXLQX
      MVMTVNZVOUBVNZYPXPRYPXPJVFURRYPXNJVFYRVOUEVNVQVPYPCXOYJPXIYSYPYGXHKYIGYPY
      IHVCURGYPYHHVCYPYHJVHURHYPXNJVHYRVOUFVNVOUGVNYPYCXEDYFXGYPXFYEOYPYEQYDURO
      XLQYDVMUAVNVKYPYBXDWSYPWTWTXTXCYAFYPYAJVEURFYPXNJVEYRVOUCVNYPWTVRYPXSIXAX
      BYPXSJVDURIYPXNJVDYRVOUDVNWGVSVTWAWBWCWCYMWDBWRXJPWEUKWRWEUKPYQWEUBJVCWFW
      HPWQWEWIWJWKWLWMWN $.

    $d x O $.  $d x .+ $.  $d x R $.  $d x .x. $.  $d v V $.  $d j t v x X $.
    hvmapval.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Value of map from nonzero vectors to nonzero functionals in the closed
       kernel dual space.  (Contributed by NM, 23-Mar-2015.) $)
    hvmapval $p |- ( ph -> ( M ` X ) = ( v e. V |->
     ( iota_ j e. R E. t e. ( O ` { X } ) v = ( t .+ ( j .x. X ) ) ) ) ) $=
      ( vx cfv csn cdif cv co wceq wrex crio cmpt hvmapfval fveq1d wcel cvv cbs
      fvex eqeltri mptex sneq fveq2d oveq2d eqeq2d rexeqbidv riotabidv mpteq2dv
      oveq2 eqid fvmptg sylancl eqtrd ) AQMULQUKORUMUNZBOBUOZCUOZJUOZUKUOZHUPZE
      UPZUQZCWEUMZNULZURZJFUSZUTZUTZULZBOWBWCWDQHUPZEUPZUQZCQUMZNULZURZJFUSZUTZ
      AQMWNAUKBCDEFGHIJKLMNOPRSTUAUBUCUDUEUFUGUHUIVAVBAQWAVCXCVDVCWOXCUQUJBOXBO
      IVEULVDUBIVEVFVGVHUKQWMXCWAVDWNWEQUQZBOWLXBXDWKXAJFXDWHWRCWJWTXDWIWSNWEQV
      IVJXDWGWQWBXDWFWPWCEWEQWDHVPVKVLVMVNVOWNVQVRVSVT $.

    $d y .+ $.  $d y K $.  $d y O $.  $d y R $.  $d y .x. $.  $d j t y Y $.
    $d y V $.  $d y W $.  $d y X $.
    hvmapval.y $e |- ( ph -> Y e. V ) $.
    $( Value of value of map (i.e. functional value) from nonzero vectors to
       nonzero functionals in the closed kernel dual space.  (Contributed by
       NM, 23-Mar-2015.)  (New usage is discouraged.) $)
    hvmapvalvalN $p |- ( ph -> ( ( M ` X ) ` Y )
      = ( iota_ j e. R E. t e. ( O ` { X } ) Y = ( t .+ ( j .x. X ) ) ) ) $=
      ( vy cfv cv co wceq csn wrex crio cmpt hvmapval fveq1d wcel riotaex eqeq1
      cvv rexbidv riotabidv eqid fvmptg sylancl eqtrd ) AQPLUMZUMQULNULUNZBUNIU
      NPGUODUOZUPZBPUQMUMZURZIEUSZUTZUMZQVOUPZBVQURZIEUSZAQVMVTAULBCDEFGHIJKLMN
      OPRSTUAUBUCUDUEUFUGUHUIUJVAVBAQNVCWDVFVCWAWDUPUKWCIEVDULQVSWDNVFVTVNQUPZV
      RWCIEWEVPWBBVQVNQVOVEVGVHVTVIVJVKVL $.
  $}

  ${
    $d j t .1. $.  $d j t v K $.  $d j v S $.  $d j t v U $.  $d v V $.
    $d j t v W $.  $d j t v X $.  $d t .0. $.
    hvmapid.h $e |- H = ( LHyp ` K ) $.
    hvmapid.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hvmapid.v $e |- V = ( Base ` U ) $.
    hvmapid.z $e |- .0. = ( 0g ` U ) $.
    hvmapid.s $e |- S = ( Scalar ` U ) $.
    hvmapid.i $e |- .1. = ( 1r ` S ) $.
    hvmapid.m $e |- M = ( ( HVMap ` K ) ` W ) $.
    hvmapid.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hvmapid.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( The value of the vector to functional map, at the vector, is one.
       (Contributed by NM, 23-Mar-2015.)  (New usage is discouraged.) $)
    hvmapidN $p |- ( ph -> ( ( M ` X ) ` X ) = .1. ) $=
      ( vv vt vj cfv cv cvsca cplusg wceq csn coch wrex cbs crio cmpt chlt eqid
      co hvmapval fveq1d dochfl1 eqtrd ) AJJGUDZUDJUAHUAUEUBUEUCUEJCUFUDZUQCUGU
      DZUQUHUBJUIIFUJUDUDZUDUKUCBULUDZUMUNZUDDAJVBVGAUAUBUOVDVFBVCCUCEFGVEHIJKL
      MVEUPZNVDUPZVCUPZOPVFUPZRSTURUSAUBUABVDVFVCCDUCVGEFVEHIJKLVHMNVIVJOPVKQST
      VGUPUTVA $.
  $}

  ${
    $d f F $.  $d k v w x K $.  $d f L $.  $d f k v w x O $.  $d f k v w x U $.
    $d f v x V $.  $d k v w x W $.  $d x .0. $.
    hvmap1o.h $e |- H = ( LHyp ` K ) $.
    hvmap1o.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hvmap1o.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hvmap1o.v $e |- V = ( Base ` U ) $.
    hvmap1o.z $e |- .0. = ( 0g ` U ) $.
    hvmap1o.f $e |- F = ( LFnl ` U ) $.
    hvmap1o.l $e |- L = ( LKer ` U ) $.
    hvmap1o.d $e |- D = ( LDual ` U ) $.
    hvmap1o.q $e |- Q = ( 0g ` D ) $.
    hvmap1o.c $e |- C = { f e. F | ( O ` ( O ` ( L ` f ) ) ) = ( L ` f ) } $.
    hvmap1o.m $e |- M = ( ( HVMap ` K ) ` W ) $.
    hvmap1o.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The vector to functional map provides a bijection from nonzero vectors
       ` V ` to nonzero functionals with closed kernels ` C ` .  (Contributed
       by NM, 27-Mar-2015.) $)
    hvmap1o $p |- ( ph -> M : ( V \ { .0. } ) -1-1-onto-> ( C \ { Q } ) ) $=
      ( vx vv vw vk csn cdif wf1o cvsca cfv cplusg wceq wrex csca cbs crio cmpt
      cv co eqid lcf1o wb chlt hvmapfval f1oeq1 syl mpbird ) AMOULUMZBDULUMZKUN
      ZVNVOUHVNUIMUIVDUJVDUKVDUHVDZEUOUPZVEEUQUPZVEURUJVQULLUPUSUKEUTUPZVAUPZVB
      VCVCZUNZAUHUJUIBCVSDWAVTVREFUKGHWBIJLMNOPQRSVSVFZVRVFZVTVFZWAVFZTUAUBUCUD
      UEWBVFUGVGAKWBURVPWCVHAUHUIUJVIVSWAVTVREUKHIKLMNOPRQSWDWETWFWGUFUGVJVNVOK
      WBVKVLVM $.

    hvmapcl.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Closure of the vector to functional map.  (Contributed by NM,
       27-Mar-2015.)  (New usage is discouraged.) $)
    hvmapclN $p |- ( ph -> ( M ` X ) e. ( C \ { Q } ) ) $=
      ( csn cdif wf1o wf hvmap1o f1of syl ffvelrnd ) AMPUJUKZBDUJUKZOKAURUSKULU
      RUSKUMABCDEFGHIJKLMNPQRSTUAUBUCUDUEUFUGUHUNURUSKUOUPUIUQ $.
  $}

  ${
    $d f K $.  $d f U $.  $d f V $.  $d f W $.
    hvmap1o2.h $e |- H = ( LHyp ` K ) $.
    hvmap1o2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hvmap1o2.v $e |- V = ( Base ` U ) $.
    hvmap1o2.z $e |- .0. = ( 0g ` U ) $.
    hvmap1o2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hvmap1o2.f $e |- F = ( Base ` C ) $.
    hvmap1o2.o $e |- O = ( 0g ` C ) $.
    hvmap1o2.m $e |- M = ( ( HVMap ` K ) ` W ) $.
    hvmap1o2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The vector to functional map provides a bijection from nonzero vectors
       ` V ` to nonzero functionals with closed kernels ` C ` .  (Contributed
       by NM, 27-Mar-2015.) $)
    hvmap1o2 $p |- ( ph -> M : ( V \ { .0. } ) -1-1-onto-> ( F \ { O } ) ) $=
      ( vf csn cdif wf1o cv clk cfv coch wceq clfn crab cld c0g eqid hvmap1o wb
      lcdvbase lcd0v2 sneqd difeq12d f1oeq3 syl mpbird ) AIKUBUCZDHUBZUCZGUDZVD
      UAUECUFUGZUGZJFUHUGUGZUGVJUGVIUIUACUJUGZUKZCULUGZUMUGZUBZUCZGUDZAVLVMVNCU
      AVKEFVHGVJIJKLVJUNZMNOVKUNZVHUNZVMUNZVNUNZVLUNZSTUOAVFVPUIVGVQUPADVLVEVOA
      VLBCUAVKEFVHVJDJLVRPQMVSVTWCTUQAHVNABVMCEFHJVNLMWAWBPRTURUSUTVFVPVDGVAVBV
      C $.

    hvmapcl2.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Closure of the vector to functional map.  (Contributed by NM,
       27-Mar-2015.) $)
    hvmapcl2 $p |- ( ph -> ( M ` X ) e. ( F \ { O } ) ) $=
      ( csn cdif wf1o wf hvmap1o2 f1of syl ffvelrnd ) AILUCUDZDHUCUDZKGAUKULGUE
      UKULGUFABCDEFGHIJLMNOPQRSTUAUGUKULGUHUIUBUJ $.
  $}

  ${
    hvmaplfl.h $e |- H = ( LHyp ` K ) $.
    hvmaplfl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hvmaplfl.v $e |- V = ( Base ` U ) $.
    hvmaplfl.z $e |- .0. = ( 0g ` U ) $.
    hvmaplfl.f $e |- F = ( LFnl ` U ) $.
    hvmaplfl.m $e |- M = ( ( HVMap ` K ) ` W ) $.
    hvmaplfl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hvmaplfl.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( The vector to functional map value is a functional.  (Contributed by NM,
       28-Mar-2015.) $)
    hvmaplfl $p |- ( ph -> ( M ` X ) e. F ) $=
      ( cfv eqid clcd cbs c0g csn hvmapcl2 eldifad lcdvbaselfl ) AHEUASSZBCDEUH
      UBSZHIFSZKUHTZUITZLOQAUJUIUHUCSZUDAUHBUIDEFUMGHIJKLMNUKULUMTPQRUEUFUG $.
  $}

  ${
    $d j t v x K $.  $d j t v x O $.  $d j t v x U $.  $d v x V $.
    $d j t v x W $.  $d j t v x X $.  $d x .0. $.  $d x v $.
    hvmaplkr.h $e |- H = ( LHyp ` K ) $.
    hvmaplkr.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hvmaplkr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hvmaplkr.v $e |- V = ( Base ` U ) $.
    hvmaplkr.z $e |- .0. = ( 0g ` U ) $.
    hvmaplkr.l $e |- L = ( LKer ` U ) $.
    hvmaplkr.m $e |- M = ( ( HVMap ` K ) ` W ) $.
    hvmaplkr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hvmaplkr.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Kernel of the vector to functional map.  TODO: make this become
       ~ lcfrlem11 .  (Contributed by NM, 29-Mar-2015.) $)
    hvmaplkr $p |- ( ph -> ( L ` ( M ` X ) ) = ( O ` { X } ) ) $=
      ( vx vv vt vj vf cfv csn cdif cv cvsca co cplusg wceq wrex csca crio cmpt
      cbs chlt eqid hvmapfval fveq1d fveq2d clfn crab cld c0g lcfrlem11 eqtrd )
      AJFUFZEUFJUAHKUGUHUBHUBUIUCUIUDUIUAUIZBUJUFZUKBULUFZUKUMUCVKUGGUFUNUDBUOU
      FZURUFZUPUQUQZUFZEUFJUGGUFAVJVQEAJFVPAUAUBUCUSVMVOVNVLBUDCDFGHIKLNMOVMUTZ
      VLUTZPVNUTZVOUTZRSVAVBVCAUAUCUBUEUIEUFZGUFGUFWBUMUEBVDUFZVEZBVFUFZVMWEVGU
      FZVOVNVLBUEUDWCCVPDEGHIJKLMNOVRVSVTWAPWCUTQWEUTWFUTWDUTVPUTSTVHVI $.
  $}

  ${
    mapdhvmap.h $e |- H = ( LHyp ` K ) $.
    mapdhvmap.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdhvmap.v $e |- V = ( Base ` U ) $.
    mapdhvmap.z $e |- .0. = ( 0g ` U ) $.
    mapdhvmap.n $e |- N = ( LSpan ` U ) $.
    mapdhvmap.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdhvmap.j $e |- J = ( LSpan ` C ) $.
    mapdhvmap.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdhvmap.p $e |- P = ( ( HVMap ` K ) ` W ) $.
    mapdhvmap.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    mapdhvmap.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    $( Relationship between ` mapd ` and ` HVMap ` , which can be used to
       satify the last hypothesis of ~ mapdpg .  Equation 10 of [Baer] p. 48.
       (Contributed by NM, 29-Mar-2015.) $)
    mapdhvmap $p |- ( ph
           -> ( M ` ( N ` { X } ) ) = ( J ` { ( P ` X ) } ) ) $=
      ( csn cfv cld clspn clfn clk coch eqid eldifad hvmaplfl hvmaplkr hvmapcl2
      mapdsn3 cbs c0g snssd lcdlsp eqtr4d ) ALUEIUFHUFLCUFZUEZDUGUFZUHUFZUFVDFU
      FAVEVFDDUIUFZVCEGDUJUFZHIKGUKUFUFZJKLNVIULZUAOPRVGULZVHULZVEULZVFULZUCALJ
      MUEUDUMADVGEGCJKLMNOPQVKUBUCUDUNADEGVHCVIJKLMNVJOPQVLUBUCUDUOUQABVEDBURUF
      ZVDEGVFFKNOVMVNSVOULZTUCAVCVOAVCVOBUSUFZUEABDVOEGCVQJKLMNOPQSVPVQULUBUCUD
      UPUMUTVAVB $.
  $}

$(
  @c eVec @.

  @( Extend class notation with e vector. @)
  cev @a class eVec @.

  @{
    @d k w @.
    @( Define the "e" (unit) vectore.  This is the fixed unit vector
       ` <. 0 , 1 >. ` whose span is the lattice isomorphism map of the
       fiducial atom ` P = ( ( oc ` K ) ` W ) ` (see ~ dihpN ).  Its purpose is
       to provide a fixed reference vector (any other fixed vector would also
       do). @)
    df-evec @a |- eVec = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
         <. ( _I |` ( Base ` k ) ) ,
                 ( _I |` ( ( LTrn ` k ) ` w ) ) >. ) ) @.
  @}

  @c eImage @.

  @( Extend class notation with e vector image. @)
  ceim @a class eImage @.

  @{
    @d k w @.
    @( Define the "e" (unit) vector image.  This is the fixed functional mapped
       from the unit vector ` <. 0 , 1 >. ` whose span is the lattice
       isomorphism map of the fiducial atom ` P = ( ( oc ` K ) ` W ) ` (see
       ~ dihpN ).  Its purpose is to provide a fixed reference functional (any
       other fixed functional would also do). @)
    df-eimage @a |- eImage = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
         ( ( ( HVMap ` k ) ` w )
            ` <. ( _I |` ( Base ` k ) ) ,
                 ( _I |` ( ( LTrn ` k ) ` w ) ) >. ) ) ) @.
  @}

  @{
    @d k B @.  @d k w H @.  @d k w K @.
    eimval.b @e |- B = ( Base ` K ) @.
    eimval.h @e |- H = ( LHyp ` K ) @.
    @( The "e" (unit) vector image.  This is the fixed functional mapped from
       the unit vector ` <. 0 , 1 >. ` whose span is the lattice isomorphism
       map of the fiducial atom ` P = ( ( oc ` K ) ` W ) ` (see ~ dihpN ). @)
    eimfval @p |- ( K e. X -> ( eImage ` K ) = ( w e. H |->
         ( ( ( HVMap ` K ) ` w )
            ` <. ( _I |` B ) ,
                 ( _I |` ( ( LTrn ` K ) ` w ) ) >. ) ) ) @=
      ( vk wcel cvv ceim cfv cid cres cv cltrn chvm clh cbs fveq2 cop cmpt wceq
      elex syl6eqr reseq2d opeq12d fveq12d mpteq12dv df-eimage fvex mptex fvmpt
      fveq1d eqeltri syl ) DEIDJIDKLACMBNZMAOZDPLZLZNZUAZURDQLZLZLZUBZUCDEUDHDA
      HOZRLZMVGSLZNZMURVGPLZLZNZUAZURVGQLZLZLZUBVFJKVGDUCZAVHVQCVEVRVHDRLZCVGDR
      TGUEVRVNVBVPVDVRURVOVCVGDQTUNVRVJUQVMVAVRVIBMVRVIDSLBVGDSTFUEUFVRVLUTMVRU
      RVKUSVGDPTUNUFUGUHUIAHUJACVECVSJGDRUKUOULUMUP @.
      @( [23-Mar-2015] @)

    @d w B @.  @d w T @.  @d w M @.  @d w W @.
    eimval.t @e |- T = ( ( LTrn ` K ) ` W ) @.
    eimval.m @e |- M = ( ( HVMap ` K ) ` W ) @.
    eimval.i @e |- I = ( ( eImage ` K ) ` W ) @.
    eimval.k @e |- ( ph -> ( K e. A /\ W e. H ) ) @.
    @( The "e" (unit) vector image.  This is the fixed functional mapped from
       the unit vector ` <. 0 , 1 >. ` whose span is the lattice isomorphism
       map of the fiducial atom ` P = ( ( oc ` K ) ` W ) ` (see ~ dihpN ). @)
    eimval @p |- ( ph -> I = ( M ` <. ( _I |` B ) , ( _I |` T ) >. ) ) @=
      ( vw wcel cid cres cfv wa cop wceq cv cltrn chvm cmpt ceim eimfval fveq1d
      syl5eq fveq2 syl6eqr eqidd reseq2d opeq12d fveq12d eqid fvex sylan9eq syl
      fvmpt ) AGBQZIEQZUAFRCSZRDSZUBZHTZUCOVCVDFIPEVERPUDZGUETZTZSZUBZVIGUFTZTZ
      TZUGZTZVHVCFIGUHTZTVRNVCIVSVQPCEGBJKUIUJUKPIVPVHEVQVIIUCZVMVGVOHVTVOIVNTH
      VIIVNULMUMVTVEVEVLVFVTVEUNVTVKDRVTVKIVJTDVIIVJULLUMUOUPUQVQURVGHUSVBUTVA
      @.
      @( [23-Mar-2015] @)
  @}
  @{
    @d f B @.  @d f H @.  @d f K @.  @d f T @.  @d f W @.
    hmaplem.h @e |- H = ( LHyp ` K ) @.
    hmaplem.b @e |- B = ( Base ` K ) @.
    hmaplem.t @e |- T = ( ( LTrn ` K ) ` W ) @.
    hmaplem.e @e |- E = <. ( _I |` B ) , ( _I |` T ) >. @.
    hmaplem.d @e |- F = ( ( ( HVMap ` K ) ` W ) ` E ) @.
    hmaplem.u @e |- U = ( ( DVecH ` K ) ` W ) @.
    hmaplem.o @e |- .0. = ( 0g ` U ) @.
    hmaplem.n @e |- N = ( LSpan ` U ) @.
    hmaplem.c @e |- C = ( ( LCDual ` K ) ` W ) @.
    hmaplem.q @e |- .x. = ( .s ` C ) @.
    hmaplem.j @e |- J = ( LSpan ` C ) @.
    hmaplem.k @e |- ( ph -> ( K e. HL /\ W e. H ) ) @.
    hmaplem.x @e |- ( ph -> X e. ( N ` { E } ) ) @.
    hmaplem.xn @e |- ( ph -> X =/= .0. ) @.
    @( Lemma for vector to functional map, when ` X ` and the reference vector
       ` E ` are colinear. @)
    hmaplem1 @p |- ( ph -> ( ( F ` X ) .x. F ) e. ( J ` { F } ) ) @=
      ( csca cfv cbs clss csn eqid clmod wcel lcdlmod chvm c0g dvheveccl eldifi
      cdif hvmapcl2 syl5eqel lspsncl syl2anc clfn dvhlmod lcdvbaselfl cres chlt
      syl cid cop wa ctendo idltrn tendoidcl dvhelvbasei syl12anc lssel syl3anc
      lflcl lspsnid lcdlssvscl ) ACFUJUKZULUKZCUMUKZDFWGIKHUNJUKZCULUKZNOHUKZHP
      UAWGUOZWHUOZUDWKUOZUEWIUOZUGACUPUQZHWKUQZWJWIUQACIKNPUDUGURZAHGNKUSUKUKZU
      KZWKTAXAWKCUTUKZUNZVCUQXAWKUQACFWKIKWTXBFULUKZNGMPUAXDUOZUBUDWOXBUOWTUOUG
      ABEFGIKXDNMPQRUAXEUBSUGVAVDXAWKXCVBVMVEZWIJWKCHWOWPUFVFVGAFUPUQZHFVHUKZUQ
      OXDUQZWLWHUQAFIKNPUAUGVIZACFXHIKWKNHPUDWOUAXHUOZUGXFVJAGUNLUKZFUMUKZUQZOX
      LUQXIAXGGXDUQXNXJAGVNBVKZVNEVKZVOZXDSAKVLUQNIUQVPZXOEUQZXPNKVQUKUKZUQZXQX
      DUQUGAXRXSUGBEIKNQPRVRVMAXRYAUGEXTIKNPRXTUOZVSVMXPEFXTXOIKXDNVLPRYBUAXEVT
      WAVEXMLXDFGXEXMUOZUCVFVGUHXMXLXDFOXEYCWBVGWGXHHWHXDFOUPWMWNXEXKWDWCAWQWRH
      WJUQWSXFJWKCHWOUFWEVGWF @.
      @( [27-Mar-2015] @)

    @d k E @.  @d k F @.  @d k N @.  @d k U @.  @d k X @.  @d k ph @.
    hmaplem.g @e |- ( ph -> G e. ( J ` { F } ) ) @.
    @( Lemma for vector to functional map, when ` X ` and the reference vector
       ` E ` are colinear.  This and ~ hmaplem1 show that we can replace
       ` ( iota_ h e. ( J `` { F } ) ( h `` E ) = ( F `` X ) ) ` with simply
       ` ( ( F `` X ) Q F ) ` in an older version os ~ hmapval (and an older
       version of ~ df-hmap ). @)
    hmaplem2 @p |- ( ph
        -> ( ( G ` E ) = ( F ` X ) <-> G = ( ( F ` X ) .x. F ) ) ) @=
      ( vk cfv wceq co csca cbs clfn clk c0g eqid clvec wcel dvhlvec adantr csn
      wa cdif dvheveccl eldifi syl clss clmod lcdlmod hvmapcl2 syl5eqel lspsncl
     chvm syl2anc lssel lcdvbaselfl dvhlmod lflcl syl3anc lcdvscl wne lcd0vvalN
      chlt fveq1 adantl simpr cv cvsca wrex wb lspsnel ad2antrr eqnetrrd simplr
      mpbid lvecvsn0 simpld jca ex reximdva mpd w3a cmulr simp3r 3ad2ant1 simp2
     fveq2d lflmul cur fveq1i hvmapidN syl5eq oveq2d crg lmodrng rngridm 3eqtrd
     syl112anc eqtrd simp3l eqnetrd rexlimdv3a necon2d lcdlkreqN sylanbrc eqidd
      eldifsn lcdlkreq2N eqtr4d lcdvsval oveq1d rnglidm 3eqtrrd eqlkr3 eqeq1d
      syl5ibrcom impbid ) AGIUMZPHUMZUNZIUUDHDUOZUNZAUUEUUGAUUEVGZFUPUMZUQUMZUU
      IFURUMZIUUFFUSUMZUUIUTUMZFUQUMZFGUUNVAZUUIVAZUUJVAZUUMVAZUUKVAZUULVAZAFVB
      VCZUUEAFJLOQUBUHVDZVEAGUUNVCZUUEAGUUNNVFZVHVCUVCABEFGJLUUNONQRSUBUUOUCTUH
      VIZGUUNUVDVJVKZVEAIUUKVCUUEACFUUKJLCUQUMZOIQUEUVGVAZUBUUSUHAHVFKUMZCVLUMZ
      VCZIUVIVCZIUVGVCACVMVCHUVGVCZUVKACJLOQUEUHVNAHGOLVRUMUMZUMZUVGUAAUVOUVGCU
      TUMZVFZVHVCUVOUVGVCACFUVGJLUVNUVPUUNOGNQUBUUOUCUEUVHUVPVAZUVNVAZUHUVEVOUV
      OUVGUVQVJVKVPZUVJKUVGCHUVHUVJVAZUGVQVSUKUVJUVIUVGCIUVHUWAVTVSWAVEAUUFUUKV
      CUUEACFUUKJLUVGOUUFQUEUVHUBUUSUHACUUJUUIDFHJLUVGOUUDQUBUUPUUQUEUVHUFUHAFV
      MVCZHUUKVCZPUUNVCZUUDUUJVCZAFJLOQUBUHWBZACFUUKJLUVGOHQUEUVHUBUUSUHUVTWAZA
      GVFMUMZFVLUMZVCZPUWHVCZUWDAUWBUVCUWJUWFUVFUWIMUUNFGUUOUWIVAZUDVQVSUIUWIUW
      HUUNFPUUOUWLVTVSUUIUUKHUUJUUNFPVMUUPUUQUUOUUSWCWDZUVTWEWAVEUUHIUULUMHUULU
      MUUFUULUMUUHCFIJHLUULKUVPUVGOQUBUUTUEUVRUGUVHALWHVCOJVCVGUUEUHVEZAUVMUUEU
      VTVEZAUVLUUEUKVEUUHGUVPUMZUUMUNZIUVPWFAUWQUUEACUUIFJLUVPUUNOGUUMQUBUUOUUP
      UURUEUVRUHUVFWGVEUUHIUVPUWPUUMUUHIUVPUNZUWPUUMWFUUHUWRVGUUCUWPUUMUWRUUCUW
      PUNUUHGIUVPWIWJUUHUUCUUMWFUWRUUHUUCUUDUUMAUUEWKZAUUDUUMWFZUUEAULWLZUUMWFZ
      PUXAGFWMUMZUOZUNZVGZULUUJWNZUWTAUXEULUUJWNZUXGAUWKUXHUIAUWBUVCUWKUXHWOUWF
      UVFUXCPULUUIUUJMUUNFGUUPUUQUUOUXCVAZUDWPVSWTAUXEUXFULUUJAUXAUUJVCZVGZUXEU
      XFUXKUXEVGZUXBUXEUXLUXBGNWFZUXLUXDNWFUXBUXMVGUXLPUXDNUXKUXEWKZAPNWFUXJUXE
      UJWQWRUXLUXAUXCUUIUUJUUMUUNFGNUUOUXIUUPUUQUURUCAUVAUXJUXEUVBWQAUXJUXEWSAU
      VCUXJUXEUVFWQXAWTXBUXNXCXDXEXFAUXFUWTULUUJAUXJUXFXGZUUDUXAUUMUXOUUDUXDHUM
      ZUXAGHUMZUUIXHUMZUOZUXAUXOPUXDHAUXJUXBUXEXIXLUXOUWBUWCUXJUVCUXPUXSUNAUXJU
      WBUXFUWFXJAUXJUWCUXFUWGXJAUXJUXFXKZAUXJUVCUXFUVFXJUUIUXAUXCUXRUUKHUUJUUNF
      GUUPUUQUXRVAZUUOUXIUUSXMYCUXOUXSUXAUUIXNUMZUXRUOZUXAAUXJUXSUYCUNUXFAUXQUY
      BUXAUXRAUXQGUVOUMUYBGHUVOUAXOAUUIFJUYBLUVNUUNOGNQUBUUOUCUUPUYBVAZUVSUHUVE
      XPXQZXRXJUXOUUIXSVCZUXJUYCUXAUNAUXJUYFUXFAUWBUYFUWFUUIFUUPXTVKZXJUXTUUJUU
      IUXRUYBUXAUUQUYAUYDYAVSYDYBAUXJUXBUXEYEYFYGXFZVEYFZVEWRXDYHXFYIUUHUUDCUUJ
      UUIDFUUFJHLUULUUMUVGOQUBUUPUUQUURUUTUEUVHUFUWNAUUDUUJUUMVFVHVCZUUEAUWEUWT
      UYJUWMUYHUUDUUJUUMYLYJVEUWOUUHUUFYKYMYNUUHUUCUUDGUUFUMZUWSAUUDUYKUNUUEAUY
      KUXQUUDUXRUOZUYBUUDUXRUOZUUDAGCUUJUUIUXRFUVGHJLDUUNOUUDQUBUUOUUPUUQUYAUEU
      VHUFUHUWMUVTUVFYOZAUXQUYBUUDUXRUYEYPZAUYFUWEUYMUUDUNUYGUWMUUJUUIUXRUYBUUD
      UUQUYAUYDYQVSZYRVEYDUYIYSXDAUUEUUGUYKUUDUNAUYKUYLUYMUUDUYNUYOUYPYBUUGUUCU
      YKUUDGIUUFWIYTUUAUUB @.
      @( [27-Mar-2015] @)
  @}

  @c hmap @.

  @( Extend class notation with h-map. @)
  chma @a class hmap @.

  @{
    @d a c e f h j k m n u w y @.
    @( Define map from vectors to functionals in the closed kernel dual space.
       See ~ hmapfval description for more details. @)
    df-hmap @a |- hmap = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      { a | [ <. ( _I |` ( Base ` k ) ) ,
                 ( _I |` ( ( LTrn ` k ) ` w ) ) >. / e ]
            [ ( ( ( HVMap ` k ) ` w ) ` e ) / f ]
            [ ( ( DVecH ` k ) ` w ) / u ]
            [ ( LSpan ` u ) / n ]
            [ ( ( LCDual ` k ) ` w ) / c ]
            [ ( LSpan ` c ) / j ]
            [ ( ( mapd ` k ) ` w ) / m ]
        a e. ( y e. ( Base ` u ) |->
           if ( y e. ( n ` { e } ) , ( ( f ` y ) ( .s ` c ) f ) ,
             ( iota_ h e. ( Base ` c )
                 ( ( m ` ( n ` { y } ) ) = ( j ` { h } )
                 /\ ( m ` ( n ` { ( e ( -g ` u ) y ) } ) )
                     = ( j ` { ( f ( -g ` c ) h ) } ) ) ) ) ) } ) ) @.
  @}

  @{
    @d k B @.  @d k w H @.  @d a c e f j k m n u w K @.
    @d a c e f h j k m n u w y @.
    hmapval.h @e |- H = ( LHyp ` K ) @.
    hmapfval.b @e |- B = ( Base ` K ) @.
    @( Map from vectors to functionals in the closed kernel dual space. @)
    hmapffval @p |- ( K e. X -> ( hmap ` K ) = ( w e. H |->
      { a | [ <. ( _I |` B ) ,
                 ( _I |` ( ( LTrn ` K ) ` w ) ) >. / e ]
            [ ( ( ( HVMap ` K ) ` w ) ` e ) / f ]
            [ ( ( DVecH ` K ) ` w ) / u ]
            [ ( LSpan ` u ) / n ]
            [ ( ( LCDual ` K ) ` w ) / c ]
            [ ( LSpan ` c ) / j ]
            [ ( ( mapd ` K ) ` w ) / m ]
        a e. ( y e. ( Base ` u ) |->
          if ( y e. ( n ` { e } ) , ( ( f ` y ) ( .s ` c ) f ) ,
             ( iota_ h e. ( Base ` c )
                 ( ( m ` ( n ` { y } ) ) = ( j ` { h } )
                 /\ ( m ` ( n ` { ( e ( -g ` u ) y ) } ) )
                     = ( j ` { ( f ( -g ` c ) h ) } ) ) ) ) ) } ) ) @=
      ( cfv cv wsbcSBC vk wcel cvv chma cbs csn cvsca co wceq csg wa crio cif
      cmpt
      cmpd clspn clcd cdvh chvm cid cres cltrn cop cab elex clh syl6eqr reseq2d
      fveq2 wb fveq1d opeq12d dfsbcqSBC syl sbcbidvSBC bitrd abbidv
      mpteq12dv df-hmap
      fvex eqeltri mptex fvmpt ) LMUBLUCUBLUDRBKNSACSZUERASZESZUFJSZRUBWEFSZRWH
      OSZUGRUHWEUFWGRISZRGSZUFHSZRUIWFWEWDUJRUHUFWGRWJRWHWKWIUJRUHUFWLRUIUKGWIU
      ERULUMUNUBZIBSZLUORZRZTZHWIUPRZTZOWNLUQRZRZTZJWDUPRZTZCWNLURRZRZTZFWFWNLU
      SRZRZRZTZEUTDVAZUTWNLVBRZRZVAZVCZTZNVDZUNZUILMVEUALBUASZVFRZWMIWNXTUORZRZ
      TZHWRTZOWNXTUQRZRZTZJXCTZCWNXTURRZRZTZFWFWNXTUSRZRZRZTZEUTXTUERZVAZUTWNXT
      VBRZRZVAZVCZTZNVDZUNXSUCUDXTLUIZBYAUUDKXRUUEYALVFRZKXTLVFVIPVGUUEUUCXQNUU
      EUUCYPEXPTZXQUUEUUBXPUIUUCUUGVJUUEYRXLUUAXOUUEYQDUTUUEYQLUERDXTLUEVIQVGVH
      UUEYTXNUTUUEWNYSXMXTLVBVIVKVHVLYPEUUBXPVMVNUUEYPXKEXPUUEYPYLFXJTZXKUUEYOX
      JUIYPUUHVJUUEWFYNXIUUEWNYMXHXTLUSVIVKVKYLFYOXJVMVNUUEYLXGFXJUUEYLYICXFTZX
      GUUEYKXFUIYLUUIVJUUEWNYJXEXTLURVIVKYICYKXFVMVNUUEYIXDCXFUUEYHXBJXCUUEYHYE
      OXATZXBUUEYGXAUIYHUUJVJUUEWNYFWTXTLUQVIVKYEOYGXAVMVNUUEYEWSOXAUUEYDWQHWRU
      UEYCWPUIYDWQVJUUEWNYBWOXTLUOVIVKWMIYCWPVMVNVOVOVPVOVOVPVOVPVOVPVQVRABCEFG
      HUAIJNOVSBKXRKUUFUCPLVFVTWAWBWCVN @.
      @( [24-Mar-2015] @)

    @d c h j y C @.  @d a e f h u w y E @.  @d a e f h u w y F @.
    @d a c e f h j n u w G @.  @d a c e f h j n u w y J @.
    @d a c e f h j n u w y N @.  @d a e f u w .0. @.
    @d a c e f h j m n u w y P @.  @d a c e f j n u w Q @.
    @d a c e f j n u w R @.  @d a e f u w S @.  @d h u y U @.
    @d a e f u w y V @.  @d a c e f j n u w W @.  @d a c e f j n u w .0. @.
    hmapfval.t @e |- T = ( ( LTrn ` K ) ` W ) @.
    hmapfval.e @e |- E = <. ( _I |` B ) , ( _I |` T ) >. @.
    hmapfval.f @e |- F = ( ( ( HVMap ` K ) ` W ) ` E ) @.
    hmapfval.u @e |- U = ( ( DVecH ` K ) ` W ) @.
    hmapfval.v @e |- V = ( Base ` U ) @.
    hmapfval.s @e |- .- = ( -g ` U ) @.
    hmapfval.n @e |- N = ( LSpan ` U ) @.
    hmapfval.c @e |- C = ( ( LCDual ` K ) ` W ) @.
    hmapfval.g @e |- G = ( Base ` C ) @.
    hmapfval.q @e |- .x. = ( .s ` C ) @.
    hmapfval.r @e |- R = ( -g ` C ) @.
    hmapfval.j @e |- J = ( LSpan ` C ) @.
    hmapfval.p @e |- P = ( ( mapd ` K ) ` W ) @.
    hmapfval.m @e |- M = ( ( hmap ` K ) ` W ) @.
    hmapfval.k @e |- ( ph -> ( K e. A /\ W e. H ) ) @.
    @( Map from vectors to functionals in the closed kernel dual space. ` E `
       is the convenient fixed reference vector ` <. 0 , 1 >. ` whose span is
       the lattice isomorphism map of the fiducial atom ` P = ( ( oc ` K )
       ` W ) ` (see ~ dvheveccl ). ` F ` is the fixed reference functional
       determined by this vector.  When the argument ` y ` is not in the span
       of the reference vector, we map it to the unique functional given by the
       first fundamental theorem of projective geometry (see ~ mapdpg ). @)
    hmapfval @p |- ( ph
    -> M = ( y e. V |-> if ( y e. ( N ` { E } ) , ( ( F ` y ) .x. F ) ,
             ( iota_ h e. G ( ( P ` ( N ` { y } ) ) = ( J ` { h } )
                 /\ ( P ` ( N ` { ( E .- y ) } ) )
                     = ( J ` { ( F R h ) } ) ) ) ) ) ) @=
      ( vw va vu ve vn vf vc vm vj wcel wa cv csn cfv co wceq crio cif cmpt cbs
      cvsca csg cmpd wsbcSBC clspn clcd cdvh chvm cid cres cltrn cop cab
      hmapffval
      fveq1d syl5eq wb fveq2 syl6reqr reseq2d opeq2d syl5req dfsbcqSBC syl
      syl6eqr
      chma sbcbidvSBC bitrd cvv opex eqeltri w3a simp3 fveq2d fveq1 eqeq1d
      anbi12d
      fvex riotabidv ifeq2d mpteq2dv eleq2d sbcieSBC simp2 eqtrd simp1 oveqd
      sneqd
      eqeq12d fveq12d riotaeqbidv syld3an3 syl5bb sbc3ieSBC oveq12d eqidd
      oveq123d
      ifbieq12d oveq1d anbi2d mpteq12dv syld3an2 syl6bb abbi1dv mptex sylan9eq
      eqid fvmpt ) ARCVIZUBPVIZVJSBUABVKZMVLZTVMZVIZUUJNVMZNGVNZUUJVLZTVMZFVMZL
      VKZVLZQVMZVOZMUUJIVNZVLZTVMZFVMZNUUSHVNZVLZQVMZVOZVJZLOVPZVQZVRZVOUSUUHUU
      ISUBUTPVAVKZBVBVKZVSVMZUUJVCVKZVLZVDVKZVMZVIZUUJVEVKZVMZUWCVFVKZVTVMZVNZU
      UPUVTVMZVGVKZVMZUUTVHVKZVMZVOZUVRUUJUVPWAVMZVNZVLZUVTVMZUWIVMZUWCUUSUWEWA
      VMZVNZVLZUWKVMZVOZVJZLUWEVSVMZVPZVQZVRZVIZVGUTVKZRWBVMZVMZWCZVHUWEWDVMZWC
      ZVFUXJRWEVMZVMZWCZVDUVPWDVMZWCZVBUXJRWFVMZVMZWCZVEUVRUXJRWGVMZVMZVMZWCZVC
      WHDWIZWHUXJRWJVMZVMZWIZWKZWCZVAWLZVRZVMZUVNUUHSUBRXEVMZVMUYPURUUHUBUYQUYO
      BUTVBDVCVELVHVGVDPRCVAVFUCUDWMWNWOUTUBUYNUVNPUYOUXJUBVOZUYMVAUVNUYRUYMUXI
      VGFWCZVHUXNWCZVFEWCZVDUXSWCZVBKWCZVEUVRUBUYDVMZVMZWCZVCMWCZUVOUVNVIZUYRUY
      MUYGVCMWCZVUGUYRUYLMVOUYMVUIWPUYRMUYHWHJWIZWKZUYLUFUYRVUJUYKUYHUYRJUYJWHU
      YRUYJUBUYIVMJUXJUBUYIWQUEWRWSWTXAUYGVCUYLMXBXCUYRUYGVUFVCMUYRUYGUYCVEVUEW
      CZVUFUYRUYFVUEVOUYGVULWPUYRUVRUYEVUDUXJUBUYDWQWNUYCVEUYFVUEXBXCUYRUYCVUCV
      EVUEUYRUYCUXTVBKWCZVUCUYRUYBKVOUYCVUMWPUYRUYBUBUYAVMZKUXJUBUYAWQUHXDUXTVB
      UYBKXBXCUYRUXTVUBVBKUYRUXRVUAVDUXSUYRUXRUXOVFEWCZVUAUYRUXQEVOUXRVUOWPUYRU
      XQUBUXPVMZEUXJUBUXPWQULXDUXOVFUXQEXBXCUYRUXOUYTVFEUYRUXMUYSVHUXNUYRUXLFVO
      UXMUYSWPUYRUXLUBUXKVMZFUXJUBUXKWQUQXDUXIVGUXLFXBXCXFXFXGXFXFXGXFXGXFXGVUB
      VUHVCVEVBMVUEKMVUKXHUFUYHVUJXIXJUVRVUDXQKVUNXHUHUBUYAXQXJUVRMVOZUWCVUEVOZ
      UVPKVOZXKZVUBVUAVDTWCZVUHVVAUXSTVOVUBVVBWPVVAUXSKWDVMZTVVAUVPKWDVURVUSVUT
      XLXMUKXDVUAVDUXSTXBXCVVBUVOBUVQUUJUVSTVMZVIZUWDUWCGVNZUVBUWPTVMZFVMZUWCUU
      SHVNZVLZQVMZVOZVJZLOVPZVQZVRZVIZVVAVUHUYSVVQVDVFVHTEUXNTVVCXHUKKWDXQXJEVU
      PXHULUBUXPXQXJUWEWDXQUYSUVOBUVQUWBUWGUWHFVMZUWLVOZUWQFVMZUXBVOZVJZLUXEVPZ
      VQZVRZVIZUVTTVOZUWEEVOZUWKUXNVOZXKZVVQUXIVWFVGFFVUQXHUQUBUXKXQXJUWIFVOZUX
      HVWEUVOVWKBUVQUXGVWDVWKUWBUXFVWCUWGVWKUXDVWBLUXEVWKUWMVVSUXCVWAVWKUWJVVRU
      WLUWHUWIFXNXOVWKUWRVVTUXBUWQUWIFXNXOXPXRXSXTYAYBVWGVWHVWIUWKQVOZVWFVVQWPV
      WJUWKUXNQVWGVWHVWIXLVWJUXNEWDVMQVWJUWEEWDVWGVWHVWIYCXMUPXDYDVWGVWHVWLXKZV
      WEVVPUVOVWMBUVQVWDVVOVWMUWBVVEUWGVWCVVFVVNVWMUWAVVDUUJVWMUVSUVTTVWGVWHVWL
      YEZWNYAVWMUWFGUWDUWCVWMUWFEVTVMGVWMUWEEVTVWGVWHVWLYCZXMUNXDYFVWMVWBVVMLUX
      EOVWMUXEEVSVMOVWMUWEEVSVWOXMUMXDVWMVVSUVBVWAVVLVWMVVRUURUWLUVAVWMUWHUUQFV
      WMUUPUVTTVWNWNXMVWMUUTUWKQVWGVWHVWLXLZWNYHVWMVVTVVHUXBVVKVWMUWQVVGFVWMUWP
      UVTTVWNWNXMVWMUXAVVJUWKQVWPVWMUWTVVIVWMUWSHUWCUUSVWMUWSEWAVMHVWMUWEEWAVWO
      XMUOXDYFYGYIYHXPYJYQXTYAYKYLYMVURUWCNVOZVUSVUTVVQVUHWPVVAUWCVUENVURVUSVUT
      YCVVAVUEMVUDVMNVVAUVRMVUDVURVUSVUTYEXMUGXDYDVURVWQVUTXKZVVPUVNUVOVWRBUVQV
      VOUAUVMVWRUVQKVSVMZUAVWRUVPKVSVURVWQVUTXLZXMUIXDVWRVVEUUMVVFVVNUUOUVLVWRV
      VDUULUUJVWRUVSUUKTVWRUVRMVURVWQVUTYEZYGXMYAVWRUWDUUNUWCNGVWRUUJUWCNVURVWQ
      VUTYCZWNVXBYNVWRVVMUVKLOVWRVVLUVJUVBVWRVVHUVFVVKUVIVWRVVGUVEFVWRUWPUVDTVW
      RUWOUVCVWRUVRMUUJUUJUWNIVWRUWNKWAVMIVWRUVPKWAVWTXMUJXDVXAVWRUUJYOYPYGXMXM
      VWRVVJUVHQVWRVVIUVGVWRUWCNUUSHVXBYRYGXMYHYSXRYQYTYAUUAYLXGYMUUBUUCUYOUUFB
      UAUVMUAVWSXHUIKVSXQXJUUDUUGUUEXC @.
      @( [24-Mar-2015] @)

    @d y G @.  @d y .0. @.  @d y Q @.  @d y R @.  @d y .- @.  @d h y X @.
    @d y .0. @.
    hmapval.x @e |- ( ph -> X e. V ) @.
    @( Value of map from vectors to functionals in the closed kernel dual
       space. @)
    hmapval @p |- ( ph -> ( M ` X )
          = if ( X e. ( N ` { E } ) , ( ( F ` X ) Q F ) ,
               ( iota_ h e. G ( ( P ` ( N ` { X } ) ) = ( J ` { h } )
                   /\ ( P ` ( N ` { ( E .- X ) } ) )
                       = ( J ` { ( F R h ) } ) ) ) ) ) @=
      ( vy cfv cv csn wcel co wceq wa crio cif cmpt hmapfval fveq1d cvv riotaex
      ovex ifex eleq1 fveq2 oveq1d sneq fveq2d eqeq1d oveq2 riotabidv ifbieq12d
      sneqd anbi12d eqid fvmptg sylancl eqtrd ) AUBRVBUBVATVAVCZLVDSVBZVEZWMMVB
      ZMFVFZWMVDZSVBZEVBZKVCZVDPVBZVGZLWMHVFZVDZSVBZEVBZMXAGVFVDPVBZVGZVHZKNVIZ
      VJZVKZVBZUBWNVEZUBMVBZMFVFZUBVDZSVBZEVBZXBVGZLUBHVFZVDZSVBZEVBZXHVGZVHZKN
      VIZVJZAUBRXMAVABCDEFGHIJKLMNOPQRSTUAUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSVLV
      MAUBTVEYIVNVEXNYIVGUTXOXQYHXPMFVPYGKNVOVQVAUBXLYITVNXMWMUBVGZWOXOWQXKXQYH
      WMUBWNVRYJWPXPMFWMUBMVSVTYJXJYGKNYJXCYAXIYFYJWTXTXBYJWSXSEYJWRXRSWMUBWAWB
      WBWCYJXGYEXHYJXFYDEYJXEYCSYJXDYBWMUBLHWDWGWBWBWCWHWEWFXMWIWJWKWL @.
      @( [25-Mar-2015] @)

    hmapval2.xn @e |- ( ph -> -. X e. ( N ` { E } ) ) @.
    @( Value from ~ hmapval when ` X ` is outside the span of the reference
       vector ` E ` .  Note: the hypotheses for ` Q ` is unused. @)
    hmapval2 @p |- ( ph -> ( M ` X ) = ( iota_ h e. G
           ( ( P ` ( N ` { X } ) ) = ( J ` { h } )
             /\ ( P ` ( N ` { ( E .- X ) } ) ) = ( J ` { ( F R h ) } ) ) ) ) @=
      ( cfv csn wcel cvsca co cv wceq wa crio cif eqid hmapval wn iffalse eqtrd
      syl ) AUBRVBUBLVCSVBVDZUBMVBMDVEVBZVFZUBVCSVBEVBKVGZVCPVBVHLUBHVFVCSVBEVB
      MWAGVFVCPVBVHVIKNVJZVKZWBABCDEVSGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMV
      SVLUOUPUQURUSUTVMAVRVNWCWBVHVAVRVTWBVOVQVP @.
      @( [28-Mar-2015] @)
  @}

  @{
    @d h C @.  @d h E @.  @d h F @.  @d h K @.  @d h N @.  @d h U @.  @d h W @.
    @d h X @.
    hmapval1.h @e |- H = ( LHyp ` K ) @.
    hmapval1.b @e |- B = ( Base ` K ) @.
    hmapval1.t @e |- T = ( ( LTrn ` K ) ` W ) @.
    hmapval1.e @e |- E = <. ( _I |` B ) , ( _I |` T ) >. @.
    hmapval1.f @e |- F = ( ( ( HVMap ` K ) ` W ) ` E ) @.
    hmapval1.u @e |- U = ( ( DVecH ` K ) ` W ) @.
    hmapval1.n @e |- N = ( LSpan ` U ) @.
    hmapval1.c @e |- C = ( ( LCDual ` K ) ` W ) @.
    hmapval1.q @e |- .x. = ( .s ` C ) @.
    hmapval1.m @e |- M = ( ( hmap ` K ) ` W ) @.
    hmapval1.k @e |- ( ph -> ( K e. HL /\ W e. H ) ) @.
    hmapval1.x @e |- ( ph -> X e. ( N ` { E } ) ) @.
    @( Value from ~ hmapval when ` X ` is in the span of the reference vector
       ` E ` . @)
    hmapval1 @p |- ( ph -> ( M ` X ) = ( ( F ` X ) .x. F ) ) @=
      ( vh cfv csn wcel co cmpd cv clspn wceq csg cbs crio chlt eqid clss clmod
      wa cif dvhlmod c0g cdif dvheveccl eldifi syl lspsncl syl2anc lssel iftrue
      hmapval eqtrd ) ANKUHNGUILUHZUJZNHUHHDUKZNUILUHMJULUHUHZUHUGUMZUICUNUHZUH
      UOGNFUPUHZUKUILUHVTUHHWACUPUHZUKUIWBUHUOVCUGCUQUHZURZVDZVSAUSBCVTDWDWCEFU
      GGHWEIWBJKLFUQUHZMNOPQRSTWHUTZWCUTUAUBWEUTUCWDUTWBUTVTUTUDUEAVQFVAUHZUJZV
      RNWHUJAFVBUJGWHUJZWKAFIJMOTUEVEAGWHFVFUHZUIZVGUJWLABEFGIJWHMWMOPQTWIWMUTR
      UEVHGWHWNVIVJWJLWHFGWIWJUTZUAVKVLUFWJVQWHFNWIWOVMVLVOAVRWGVSUOUFVRVSWFVNV
      JVP @.
      @( [28-Mar-2015] @)
  @}

  @{
    hmap0.h @e |- H = ( LHyp ` K ) @.
    hmap0.u @e |- U = ( ( DVecH ` K ) ` W ) @.
    hmap0.z @e |- .0. = ( 0g ` U ) @.
    hmap0.c @e |- C = ( ( LCDual ` K ) ` W ) @.
    hmap0.o @e |- O = ( 0g ` C ) @.
    hmap0.m @e |- M = ( ( hmap ` K ) ` W ) @.
    hmap0.k @e |- ( ph -> ( K e. HL /\ W e. H ) ) @.
    @( The zero value of map from vectors to functionals in the closed kernel
       dual space. @)
    hmap0 @p |- ( ph -> ( M ` .0. ) = O ) @=
      ( cfv cbs eqid wcel cid cres cltrn cop chvm cvsca co csca c0g clspn clmod
      csn clss dvhlmod cdif dvheveccl eldifi lspsncl syl2anc hmapval1 clfn wceq
      syl lss0cl hvmaplfl lfl0 oveq1d hvmapcl2 lcd0vs 3eqtrd ) AIFQIUAERQZUBUAH
      EUCQQZUBUDZHEUEQQZQZQZVOBUFQZUGCUHQZUIQZVOVQUGGAVKBVQVLCVMVODEFCUJQZHIJVK
      SZVLSZVMSZVOSKVTSZMVQSZOPACUKTZVMULVTQZCUMQZTZIWGTACDEHJKPUNZAWFVMCRQZTZW
      IWJAVMWKIULZUOTWLAVKVLCVMDEWKHIJWAWBKWKSZLWCPUPZVMWKWMUQVCWHVTWKCVMWNWHSZ
      WDURUSWHWGCILWPVDUSUTAVPVSVOVQAWFVOCVAQZTVPVSVBWJACWQDEVNWKHVMIJKWNLWQSZV
      NSZPWOVEVRWQVOVSCIVRSZVSSZLWRVFUSVGABVRVQCVODEGBRQZHVSJKWTXAMXBSZWENPAVOX
      BGULZUOTVOXBTABCXBDEVNGWKHVMIJKWNLMXCNWSPWOVHVOXBXDUQVCVIVJ @.
      @( [28-Mar-2015] @)
  @}

  @{
    @d h C @.  @d h E @.  @d h K @.  @d h U @.  @d h W @.  @d h X @.
    @d h ph @.
    hmapcl.h @e |- H = ( LHyp ` K ) @.
    hmapcl.u @e |- U = ( ( DVecH ` K ) ` W ) @.
    hmapcl.v @e |- V = ( Base ` U ) @.
    hmapcl.c @e |- C = ( ( LCDual ` K ) ` W ) @.
    hmapcl.e @e |- E = ( Base ` C ) @.
    hmapcl.m @e |- M = ( ( hmap ` K ) ` W ) @.
    hmapcl.k @e |- ( ph -> ( K e. HL /\ W e. H ) ) @.
    hmapcl.x @e |- ( ph -> X e. V ) @.
    @( Closure of map from vectors to functionals in the closed kernel dual
       space. @)
    hmapcl @p |- ( ph -> ( M ` X ) e. E ) @=
      ( cfv eqid vh cid cbs cres cltrn cop csn clspn wcel wa chvm cvsca co chlt
      adantr simpr hmapval1 csca c0g cdif dvheveccl hvmapcl2 eldifi syl lcdvscl
      lcdvbasecl eqeltrd wn cmpd wceq csg crio hmapval2 wreu clss clmod dvhlmod
      cv lspsncl syl2anc lssneln0 wne wss eqimss2 lspsnel5 syl5ibr necon3bd imp
      mapdhvmap mapdpg riotacl pm2.61dan ) AJUBFUCSZUDUBIFUESSZUDUFZUGCUHSZSZUI
      ZJGSZDUIAWRUJZWSJWOIFUKSSZSZSZXBBULSZUMZDWTWMBXDWNCWOXBEFGWPIJKWMTZWNTZWO
      TZXBTZLWPTZNXDTZPAFUNUIIEUIUJZWRQUOAWRUPUQAXEDUIWRABCURSZUCSZXMXDCXBEFDIX
      CKLXMTZXNTZNOXKQABXNXMCDXBEFHIJKLMXOXPNOQAXBDBUSSZUGZUTUIXBDUIZABCDEFXAXQ
      HIWOCUSSZKLMXTTZNOXQTXATZQAWMWNCWOEFHIXTKXFXGLMYAXHQVAZVBXBDXRVCVDZRVFYDV
      EUOVGAWRVHZUJZWSJUGWPSZIFVISSZSUAVRZUGBUHSZSVJWOJCVKSZUMUGWPSYHSXBYIBVKSZ
      UMUGYJSVJUJZUADVLZDYFUNWMBYHXDYLYKWNCUAWOXBDEYJFGWPHIJKXFXGXHXILMYKTZXJNO
      XKYLTZYJTZYHTZPAXLYEQUOZAJHUIYERUOZAYEUPZVMYFYMUADVNYNDUIYFBYLYKCUADXBEYJ
      FYHWPHIWOJXTKYRLMYOYAXJNOYPYQYSAWOHXTUGZUTUIZYEYCUOYFCVOSZWQXTHCJMYAUUDTZ
      ACVPUIZYEACEFIKLQVQZUOAWQUUDUIZYEAUUFWOHUIZUUHUUGAUUCUUIYCWOHUUBVCVDUUDWP
      HCWOMUUEXJVSVTZUOYTUUAWAAXSYEYDUOAYEWQYGWBAWRWQYGWQYGVJWRAYGWQWCYGWQWDAUU
      DWQWPHCJMUUEXJUUGUUJRWEWFWGWHAWQYHSXBUGYJSVJYEABXACEYJFYHWPHIWOXTKLMYAXJN
      YQYRYBQYCWIUOWJYMUADWKVDVGWL @.
      @( [29-Mar-2015] @)
  @}

  @c gmap @.

  @( Extend class notation with g-map. @)
  cgma @a class gmap @.

  @{
    @d a b k m u v w x y @.
    @( Define map from the scalar division ring of the vector space to the
       scalar division ring of its closed kernel dual. @)
    df-gmap @a |- gmap = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      { a | [ ( ( DVecH ` k ) ` w ) / u ]
            [ ( Base ` ( Scalar ` u ) ) / b ]
            [ ( ( hmap ` k ) ` w ) / m ]
        a e. ( x e. b |-> ( iota_ y e. b
            A. v e. ( Base ` u ) ( m ` ( x ( .s ` u ) v ) )
              = ( y ( .s ` ( ( LCDual ` k ) ` w ) ) ( m ` v ) ) ) ) } ) ) @.
  @}

  @{
    @d k w H @.  @d a b k m u v w x y K @.
    gmapval.h @e |- H = ( LHyp ` K ) @.
    @( Map from the scalar division ring of the vector space to the scalar
       division ring of its closed kernel dual. @)
    gmapffval @p |- ( K e. X -> ( gmap ` K ) = ( w e. H |->
      { a | [ ( ( DVecH ` K ) ` w ) / u ]
            [ ( Base ` ( Scalar ` u ) ) / b ]
            [ ( ( hmap ` K ) ` w ) / m ]
        a e. ( x e. b |-> ( iota_ y e. b
            A. v e. ( Base ` u ) ( m ` ( x ( .s ` u ) v ) )
              = ( y ( .s ` ( ( LCDual ` K ) ` w ) ) ( m ` v ) ) ) ) } ) ) @=
      ( wcel cfv cv cvsca wceq cmpt wsbcSBC clh vk cvv cgma co clcd wral crio
      chma
      cbs csca cdvh cab elex fveq2 syl6eqr wb fveq1d dfsbcqSBC fveq2d oveqd
      eqeq2d
      syl ralbidv riotabidv mpteq2dv eleq2d sbcbidvSBC bitrd abbidv mpteq12dv
      fvex
      df-gmap eqeltri mptex fvmpt ) HIMHUBMHUCNCGJOZAKOZAODOZEOZPNUDFOZNZBOZVRV
      TNZCOZHUENZNZPNZUDZQZDVSUINZUFZBVQUGZRZMZFWDHUHNZNZSZKVSUJNUINZSZEWDHUKNZ
      NZSZJULZRZQHIUMUAHCUAOZTNZVPAVQWAWBWCWDXEUENZNZPNZUDZQZDWJUFZBVQUGZRZMZFW
      DXEUHNZNZSZKWRSZEWDXEUKNZNZSZJULZRXDUBUCXEHQZCXFYCGXCYDXFHTNZGXEHTUNLUOYD
      YBXBJYDYBXSEXASZXBYDYAXAQYBYFUPYDWDXTWTXEHUKUNUQXSEYAXAURVBYDXSWSEXAYDXRW
      QKWRYDXRXOFWPSZWQYDXQWPQXRYGUPYDWDXPWOXEHUHUNUQXOFXQWPURVBYDXOWNFWPYDXNWM
      VPYDAVQXMWLYDXLWKBVQYDXKWIDWJYDXJWHWAYDXIWGWBWCYDXHWFPYDWDXGWEXEHUEUNUQUS
      UTVAVCVDVEVFVGVHVGVGVHVIVJABCDEUAFJKVLCGXCGYEUBLHTVKVMVNVOVB @.
      @( [25-Mar-2015] @)

    @d a b m u v w x y B @.  @d a b m u v w x y M @.  @d a b m u w .- @.
    @d a b m u w T @.  @d b m u v x y U @.  @d a b m u v w V @.
    @d a b m u v w x y W @.
    gmapfval.u @e |- U = ( ( DVecH ` K ) ` W ) @.
    gmapfval.v @e |- V = ( Base ` U ) @.
    gmapfval.t @e |- .x. = ( .s ` U ) @.
    gmapfval.r @e |- R = ( Scalar ` U ) @.
    gmapfval.b @e |- B = ( Base ` R ) @.
    gmapfval.c @e |- C = ( ( LCDual ` K ) ` W ) @.
    gmapfval.s @e |- .xb = ( .s ` C ) @.
    gmapfval.m @e |- M = ( ( hmap ` K ) ` W ) @.
    gmapfval.i @e |- I = ( ( gmap ` K ) ` W ) @.
    gmapfval.k @e |- ( ph -> ( K e. Y /\ W e. H ) ) @.
    @( Map from the scalar division ring of the vector space to the scalar
       division ring of its closed kernel dual. @)
    gmapfval @p |- ( ph -> I = ( x e. B |-> ( iota_ y e. B
            A. v e. V ( M ` ( x .x. v ) ) = ( y .xb ( M ` v ) ) ) ) ) @=
      ( vw va vb vu vm wcel wa cv co cfv wceq wral crio cmpt clcd cbs chma
      wsbcSBC
      cvsca csca cdvh cab cgma gmapffval fveq1d syl5eq fveq2 syl6eqr dfsbcqSBC
      syl
      wb fveq2d oveqd eqeq2d ralbidv riotabidv mpteq2dv eleq2d sbcbidvSBC cvv
      fvex
      bitrd eqeltri w3a simp2 simp1 eqtrd simp3 fveq12d eqidd eqeq12d raleqbidv
      oveq123d riotaeqbidv mpteq12dv syld3an2 sbc3ieSBC syl6bb abbi1dv mptex
      fvmpt
      eqid sylan9eq ) AMQUNZPKUNZUOLBEBUPZDUPZIUQZNURZCUPZXONURZHUQZUSZDOUTZCEV
      AZVBZUSUHXLXMLPUIKUJUPZBUKUPZXNXOULUPZVGURZUQZUMUPZURZXRXOYJURZUIUPZMVCUR
      ZURZVGURZUQZUSZDYGVDURZUTZCYFVAZVBZUNZUMYMMVEURZURZVFZUKYGVHURZVDURZVFZUL
      YMMVIURZURZVFZUJVJZVBZURZYDXLLPMVKURZURUUOUGXLPUUPUUNBCUIDULUMKMQUJUKRVLV
      MVNUIPUUMYDKUUNYMPUSZUULUJYDUUQUULYEBYFYKXRYLPYNURZVGURZUQZUSZDYSUTZCYFVA
      ZVBZUNZUMNVFZUKUUHVFZULJVFZYEYDUNZUUQUULUUIULJVFZUVHUUQUUKJUSUULUVJVSUUQU
      UKPUUJURZJYMPUUJVOSVPUUIULUUKJVQVRUUQUUIUVGULJUUQUUFUVFUKUUHUUQUUFUUCUMNV
      FZUVFUUQUUENUSUUFUVLVSUUQUUEPUUDURZNYMPUUDVOUFVPUUCUMUUENVQVRUUQUUCUVEUMN
      UUQUUBUVDYEUUQBYFUUAUVCUUQYTUVBCYFUUQYRUVADYSUUQYQUUTYKUUQYPUUSXRYLUUQYOU
      URVGYMPYNVOVTWAWBWCWDWEWFWGWJWGWGWJUVEUVIULUKUMJUUHNJUVKWHSPUUJWIWKUUGVDW
      INUVMWHUFPUUDWIWKYGJUSZYFEUSZYFUUHUSZYJNUSZUVEUVIVSUVNUVPUVQWLZYFGVDURZEU
      VRYFUUHUVSUVNUVPUVQWMUVRUUGGVDUVRUUGJVHURGUVRYGJVHUVNUVPUVQWNVTUBVPVTWOUC
      VPUVNUVOUVQWLZUVDYDYEUVTBYFUVCEYCUVNUVOUVQWMZUVTUVBYBCYFEUWAUVTUVAYADYSOU
      VTYSJVDUROUVTYGJVDUVNUVOUVQWNZVTTVPUVTYKXQUUTXTUVTYIXPYJNUVNUVOUVQWPZUVTY
      HIXNXOUVTYHJVGURIUVTYGJVGUWBVTUAVPWAWQUVTXRXRYLXSUUSHUVTUUSFVGURHUVTUURFV
      GUVTUURUURFUVTUURWRUDVPVTUEVPUVTXRWRUVTXOYJNUWCVMXAWSWTXBXCWFXDXEXFXGUUNX
      JBEYCEUVSWHUCGVDWIWKXHXIXKVR @.
      @( [25-Mar-2015] @)

    @d x .- @.  @d x T @.  @d x V @.  @d v x y X @.
    gmapval.x @e |- ( ph -> X e. B ) @.
    @( Value of map from the scalar division ring of the vector space to the
       scalar division ring of its closed kernel dual. @)
    gmapval @p |- ( ph -> ( I ` X ) = ( iota_ y e. B
            A. v e. V ( M ` ( X T v ) ) = ( y .- ( M ` v ) ) ) ) @=
      ( vx cfv cv co wceq wral crio cmpt gmapfval fveq1d wcel cvv riotaex oveq1
      fveq2d eqeq1d ralbidv riotabidv eqid fvmptg sylancl eqtrd ) APKUKPUJDUJUL
      ZCULZHUMZMUKZBULVMMUKGUMZUNZCNUOZBDUPZUQZUKZPVMHUMZMUKZVPUNZCNUOZBDUPZAPK
      VTAUJBCDEFGHIJKLMNOQRSTUAUBUCUDUEUFUGUHURUSAPDUTWFVAUTWAWFUNUIWEBDVBUJPVS
      WFDVAVTVLPUNZVRWEBDWGVQWDCNWGVOWCVPWGVNWBMVLPVMHVCVDVEVFVGVTVHVIVJVK @.
      @( [25-Mar-2015] @)
  @}
$)

  ${
    lspindp5.v $e |- V = ( Base ` W ) $.
    lspindp5.n $e |- N = ( LSpan ` W ) $.
    lspindp5.w $e |- ( ph -> W e. LVec ) $.
    lspindp5.y $e |- ( ph -> X e. V ) $.
    lspindp5.x $e |- ( ph -> Y e. V ) $.
    lspindp5.u $e |- ( ph -> U e. V ) $.
    lspindp5.e $e |- ( ph -> Z e. ( N ` { X , U } ) ) $.
    lspindp5.m $e |- ( ph -> -. Z e. ( N ` { X , Y } ) ) $.
    $( Obtain an independent vector set ` U , X , Y ` from a vector ` U `
       dependent on ` X ` and ` Z ` and another independent set
       ` Z , X , Y ` .  (Here we don't show the
       ` ( N `` { X } ) =/= ( N `` { Y } ) ` part of the independence, which
       passes straight through.  We also don't show nonzero vector requirements
       that are redundant for this theorem.  Different orderings can be
       obtained using ~ lspexch and ~ prcom .)  (Contributed by NM,
       4-May-2015.) $)
    lspindp5 $p |- ( ph -> -. U e. ( N ` { X , Y } ) ) $=
      ( cfv wcel wss syl2anc cpr ssel syl5com mtod clsm co clmod clvec lveclmod
      csn wa syl prssi snsspr1 a1i lspss syl3anc biantrurd csubg clss lsssssubg
      wb eqid lspsncl sseldd lspprcl lsmlub bitrd lspsnel5 lsmpr sseq1d 3bitr4d
      mtbird ) ABFGUAZCQZRZFBUACQZVOSZAVRHVORZPAHVQRVRVSOVQVOHUBUCUDABUJCQZVOSZ
      FUJZCQZVTEUEQZUFZVOSZVPVRAWAWCVOSZWAUKZWFAWGWAAEUGRZVNDSZWBVNSZWGAEUHRWIK
      EUIULZAFDRZGDRWJLMFGDUMTWKAFGUNUOWBVNCDEIJUPUQURAWCEUSQZRVTWNRVOWNRWHWFVB
      AEUTQZWNWCAWIWOWNSWLWOEWOVCZVAULZAWIWMWCWORWLLWOCDEFIWPJVDTVEAWOWNVTWQAWI
      BDRVTWORWLNWOCDEBIWPJVDTVEAWOWNVOWQAWOCDEFGIWPJWLLMVFZVEWDWCVTVOEWDVCZVGU
      QVHAWOVOCDEBIWPJWLWRNVIAVQWEVOAWDCDEFBIJWSWLLNVJVKVLVM $.
  $}


  ${
    hdmaplem1.v $e |- V = ( Base ` W ) $.
    hdmaplem1.n $e |- N = ( LSpan ` W ) $.
    ${
      hdmaplem1.w $e |- ( ph -> W e. LMod ) $.
      hdmaplem1.z $e |- ( ph -> Z e. V ) $.
      hdmaplem1.j $e |- ( ph -> -. Z e. ( ( N ` { X } ) u. ( N ` { Y } ) ) ) $.
      ${
        hdmaplem1.x $e |- ( ph -> X e. V ) $.
        $( Lemma to convert a frequently-used union condition.  TODO: see if
           this can be applied to other hdmap* theorems.  (Contributed by NM,
           17-May-2015.) $)
        hdmaplem1 $p |- ( ph -> ( N ` { Z } ) =/= ( N ` { X } ) ) $=
          ( csn cfv cun wcel elun1 nsyl lspsnne2 ) ABCDGEHIJKMAGENBOZFNBOZPQGUA
          QLGUAUBRST $.
      $}

      hdmaplem1.y $e |- ( ph -> Y e. V ) $.
      $( Lemma to convert a frequently-used union condition.  TODO: see if this
         can be applied to other hdmap* theorems.  (Contributed by NM,
         17-May-2015.)  (New usage is discouraged.) $)
      hdmaplem2N $p |- ( ph -> ( N ` { Z } ) =/= ( N ` { Y } ) ) $=
        ( csn cfv cun wcel elun2 nsyl lspsnne2 ) ABCDGFHIJKMAGENBOZFNBOZPQGUBQL
        GUBUARST $.

      hdmaplem3.o $e |- .0. = ( 0g ` W ) $.
      $( Lemma to convert a frequently-used union condition.  TODO: see if this
         can be applied to other hdmap* theorems.  (Contributed by NM,
         17-May-2015.) $)
      hdmaplem3 $p |- ( ph -> Z e. ( V \ { .0. } ) ) $=
        ( clss cfv csn eqid wcel clmod lspsncl syl2anc cun elun2 nsyl lssneln0
        ) ADPQZFRBQZCDHGIOUHSZKADUATFCTUIUHTKNUHBCDFIUJJUBUCLAHERBQZUIUDTHUITMH
        UIUKUEUFUG $.
    $}

    hdmaplem4.o $e |- .0. = ( 0g ` W ) $.
    hdmaplem4.w $e |- ( ph -> W e. LVec ) $.
    hdmaplem4.x $e |- ( ph -> X e. V ) $.
    hdmaplem4.y $e |- ( ph -> Y e. V ) $.
    hdmaplem4.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
    hdmaplem4.e $e |- ( ph -> ( N ` { Z } ) =/= ( N ` { X } ) ) $.
    hdmaplem4.f $e |- ( ph -> ( N ` { Z } ) =/= ( N ` { Y } ) ) $.
    $( Lemma to convert a frequently-used union condition.  TODO: see if this
       can be applied to other hdmap* theorems.  (Contributed by NM,
       17-May-2015.) $)
    hdmaplem4 $p |- ( ph -> -. Z e. ( ( N ` { X } ) u. ( N ` { Y } ) ) ) $=
      ( csn wcel wn cfv cun lspsnne1 wo wa ioran elun xchnxbir sylanbrc ) AHERB
      UAZSZTZHFRBUAZSZTZHUJUMUBSZTABCDHEGIKJLOMPUCABCDHFGIKJLONQUCUKUNUDULUOUEU
      PUKUNUFHUJUMUGUHUI $.
  $}

  ${
    $d h x .- $.  $d h x .0. $.  $d h C $.  $d h x D $.  $d h x F $.  $d h I $.
    $d h x G $.  $d h x J $.  $d h x M $.  $d h x N $.  $d h ph $.  $d h x R $.
    $d x Q $.  $d h x T $.  $d h U $.  $d h x X $.  $d h x Y $.
    mapdh8a.h $e |- H = ( LHyp ` K ) $.
    mapdh8a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    mapdh8a.v $e |- V = ( Base ` U ) $.
    mapdh8a.s $e |- .- = ( -g ` U ) $.
    mapdh8a.o $e |- .0. = ( 0g ` U ) $.
    mapdh8a.n $e |- N = ( LSpan ` U ) $.
    mapdh8a.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    mapdh8a.d $e |- D = ( Base ` C ) $.
    mapdh8a.r $e |- R = ( -g ` C ) $.
    mapdh8a.q $e |- Q = ( 0g ` C ) $.
    mapdh8a.j $e |- J = ( LSpan ` C ) $.
    mapdh8a.m $e |- M = ( ( mapd ` K ) ` W ) $.
    mapdh8a.i $e |- I = ( x e. _V |->
     if ( ( 2nd ` x ) = .0. , Q ,
        ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    mapdh8a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.

    ${
      mapdh8a.f $e |- ( ph -> F e. D ) $.
      mapdh8a.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8a.a $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh8a.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8a.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8a.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { T } ) ) $.
      mapdh8a.xt $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8a.xn $e |- ( ph -> -. X e. ( N ` { Y , T } ) ) $.
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM, 5-May-2015.) $)
      mapdh8a $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. X , F , T >. ) ) $=
        ( cotp cfv eqidd mapdheq4 ) ABCDEFHIUAJGVFMVGZJKLMNOPQRSTUAUBUCGUMUPUDU
        OUEUFUGUHUIUJUKULUNUQURUSVAVBVDVEVCUTAVJVHVI $.
    $}

    $d h x E $.  $d h x Z $.
    ${
      mapdh8aa.f $e |- ( ph -> F e. D ) $.
      mapdh8aa.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8aa.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh8aa.ee $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      mapdh8aa.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8aa.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8aa.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdh8aa.zt $e |- ( ph -> ( N ` { Z } ) =/= ( N ` { T } ) ) $.
      mapdh8aa.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8aa.yn $e |- ( ph -> -. Y e. ( N ` { Z , T } ) ) $.
      mapdh8aa.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
         12-May-2015.) $)
      mapdh8aa $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. Z , E , T >. ) ) $=
        ( cotp cfv csn eldifad dvhlvec lspindpi simpld mapdhcl eqeltrrd wceq co
        wne wa mapdheq mpbid mapdh75d mapdh8a eqcomd ) AUEJGVKNVLUCLGVKNVLABCDE
        FGHILJMNOPQRSTUAUCUEUDUFUGUHUIUJUKULUMUNUOUPUQURUSAUBKUCVKNVLZLDVBABCDE
        FHIKMNOPQRSTUAUBUCUDUOURUFUQUGUHUIUJUKULUMUNUPUSUTVAVDAUCTUDVMZVEVNZAUB
        VMSVLZUCVMSVLZWBWLUEVMSVLZWBASTHUBUCUEUHUKAHMPUAUFUGUSVOZAUBTWJVDVNWKAU
        ETWJVFVNZVJVPVQZVRVSZAWMQVLLVMOVLVTZUBUCRWAVMSVLQVLKLFWAVMOVLVTZAWILVTW
        SWTWCVBABCDEFHIKLMNOPQRSTUAUBUCUDUOURUFUQUGUHUIUJUKULUMUNUPUSUTVAVDVEWR
        WQWDWEVQABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVB
        VCAWMWNWBWMGVMSVLWBASTHUCUEGUHUKWOWKWPAGTWJVHVNVIVPVQVJVDVEVFWFVEVFVGVH
        VIWGWH $.
    $}

    ${
      mapdh8ab.f $e |- ( ph -> F e. D ) $.
      mapdh8ab.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8ab.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh8ab.ee $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      mapdh8ab.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8ab.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8ab.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdh8ab.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8ab.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
      mapdh8ab.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      mapdh8ab.yn $e |- ( ph -> ( N ` { X } ) = ( N ` { T } ) ) $.
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
         13-May-2015.) $)
      mapdh8ab $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. Z , E , T >. ) ) $=
        ( csn cfv wne dvhlvec eldifad lspindpi simprd necomd neeqtrd cpr sseq1d
        wcel wss clss eqid dvhlmod lspprcl lspsnel5 3bitr4d mtbid wa clvec cdif
        adantr simpr prcom fveq2i syl6eleq lspexch mtand mapdh8aa ) ABCDEFGHIJK
        LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFAUEVKSVLZU
        BVKSVLZGVKSVLZAXCXBAXCUCVKSVLZVMXCXBVMASTHUBUCUEUHUKAHMPUAUFUGUSVNZAUBT
        UDVKZVDVOZAUCTXGVEVOZAUETXGVFVOZVIVPVQVRVJVSVGAUCUEGVTZSVLZWBZGUCUEVTSV
        LZWBZAUBXNWBZXOVIAXCXNWCXDXNWCXPXOAXCXDXNVJWAAHWDVLZXNSTHUBUHXQWEZUKAHM
        PUAUFUGUSWFZAXQSTHUCUEUHXRUKXSXIXJWGZXHWHAXQXNSTHGUHXRUKXSXTAGTXGVGVOZW
        HWIWJAXMWKZSTHUCGUDUEUHUJUKAHWLWBXMXFWNAUCTXGWMWBXMVEWNAGTWBXMYAWNAUETW
        BXMXJWNAXEXBVMXMVHWNYBUCXLGUEVTZSVLAXMWOXKYCSUEGWPWQWRWSWTVIXA $.
    $}

    ${
      $d h x B $.  $d h x w $.
      mapdh8ac.f $e |- ( ph -> F e. D ) $.
      mapdh8ac.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8ac.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh8ac.ee $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      mapdh8ac.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8ac.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8ac.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdh8ac.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8ac.yn $e |- ( ph -> ( N ` { X } ) = ( N ` { T } ) ) $.
      ${
        mapdh8ac.ew $e |- ( ph -> ( I ` <. X , F , w >. ) = B ) $.
        mapdh8ac.w $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
        mapdh8ac.yw $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { w } ) ) $.
        mapdh8ac.xy $e |- ( ph -> -. X e. ( N ` { Y , w } ) ) $.
        mapdh8ac.wz $e |- ( ph -> ( N ` { w } ) =/= ( N ` { Z } ) ) $.
        mapdh8ac.xz $e |- ( ph -> -. X e. ( N ` { w , Z } ) ) $.
        $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
           13-May-2015.) $)
        mapdh8ac $p |- ( ph
             -> ( I ` <. Y , G , T >. ) = ( I ` <. Z , E , T >. ) ) $=
          ( cotp cfv cv mapdh8ab eqtrd ) AUENIVQPVRCVSZDIVQPVRUGLIVQPVRABEFGHIJ
          KDMNOPQRSTUAUBUCUDUEUFWBUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVKVFVGVLVIV
          MVNVJVTABEFGHIJKLMDOPQRSTUAUBUCUDWBUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVB
          VCVKVEVFVLVHVIVOVPVJVTWA $.
      $}

      $d w E $.  $d w G $.  $d w x I $.  $d w N $.  $d w T $.  $d w U $.
      $d h w V $.  $d w X $.  $d w Y $.  $d w Z $.  $d w ph $.
      mapdh8ad.xy $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      mapdh8ad.xz $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Z } ) ) $.
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
         13-May-2015.) $)
      mapdh8ad $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. Z , E , T >. ) ) $=
        ( vw cv cpr cfv wcel wn wa wrex cotp wceq csn eldifad dvh3dim2 w3a chlt
        3ad2ant1 cdif eqidd clss eqid clmod dvhlmod lspprcl simp3l lssneln0 wne
        simp2 clvec lspindpi simprd necomd simpl1 syl simpl2 simpr prcom fveq2i
        dvhlvec syl6eleq lspexch mtand simp3r mapdh8ac rexlimdv3a mpd ) AVKVLZU
        BUCVMSVNZVOZVPZXPUBUEVMSVNVOZVPZVQZVKTVRUCLGVSNVNUEJGVSNVNVTZAVKHMPSTUA
        UBUCUEUFUGUHUKUSAUBTUDWAZVDWBZAUCTYDVEWBZAUETYDVFWBZWCAYBYCVKTAXPTVOZYB
        WDZBVKUBKXPVSNVNZCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQUR
        AYHPWEVOUAMVOVQYBUSWFAYHKDVOYBUTWFAYHUBWASVNZQVNKWAOVNVTYBVAWFAYHUBKUCV
        SNVNLVTYBVBWFAYHUBKUEVSNVNJVTYBVCWFAYHUBTYDWGZVOZYBVDWFAYHUCYLVOYBVEWFA
        YHUEYLVOYBVFWFAYHGYLVOYBVGWFAYHYKGWASVNVTYBVHWFYIYJWHYIHWIVNZXQTHXPUDUH
        UJYNWJZAYHHWKVOYBAHMPUAUFUGUSWLZWFAYHXQYNVOYBAYNSTHUBUCUHYOUKYPYEYFWMWF
        AYHYBWQZAYHXSYAWNZWOYIXPWASVNZUCWASVNZYIYSYKWPZYSYTWPYISTHXPUBUCUHUKAYH
        HWRVOZYBAHMPUAUFUGUSXHZWFZYQAYHUBTVOYBYEWFZAYHUCTVOZYBYFWFYRWSWTXAYIUBU
        CXPVMZSVNZVOZXRYRYIUUIVQZSTHUBXPUDUCUHUJUKUUJAUUBAYHYBUUIXBZUUCXCUUJAYM
        UUKVDXCAYHYBUUIXDUUJAUUFUUKYFXCUUJAYKYTWPUUKVIXCUUJUBUUHXPUCVMZSVNYIUUI
        XEUUGUULSUCXPXFXGXIXJXKYIUUAYSUEWASVNZWPYISTHXPUBUEUHUKUUDYQUUEAYHUETVO
        ZYBYGWFAYHXSYAXLZWSWTYIUBXPUEVMSVNVOZXTUUOYIUUPVQZSTHUBXPUDUEUHUJUKUUQA
        UUBAYHYBUUPXBZUUCXCUUQAYMUURVDXCAYHYBUUPXDUUQAUUNUURYGXCUUQAYKUUMWPUURV
        JXCYIUUPXEXJXKXMXNXO $.
    $}

    $d h x w $.
    ${
      mapdh8b.f $e |- ( ph -> G e. D ) $.
      mapdh8b.mn $e |- ( ph -> ( M ` ( N ` { Y } ) ) = ( J ` { G } ) ) $.
      mapdh8b.a $e |- ( ph -> ( I ` <. Y , G , w >. ) = E ) $.
      mapdh8b.x $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8b.y $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
      mapdh8b.yz $e |- ( ph -> ( N ` { w } ) =/= ( N ` { T } ) ) $.
      mapdh8b.xt $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8b.vw $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { w } ) ) $.
      mapdh8b.e $e |- ( ph -> X e. ( N ` { Y , T } ) ) $.
      mapdh8b.xn $e |- ( ph -> -. X e. ( N ` { Y , w } ) ) $.
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM, 6-May-2015.) $)
      mapdh8b $p |- ( ph
           -> ( I ` <. w , E , T >. ) = ( I ` <. Y , G , T >. ) ) $=
        ( cv cpr cfv wcel dvhlvec eldifad lspindp5 prcom fveq2i eleq2i wa clvec
        csn adantr cdif wne simpr lspexch ex syl5bi mtod mapdh8a ) ABDEFGHIJLKM
        NOPQRSTUAUCCVIZUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEAUCWKHVJZSVK
        ZVLZHUCWKVJSVKVLZAHSTIUCWKUBUGUJAIMPUAUEUFURVMZAUCTUDWAZVBVNAWKTWQVCVNZ
        AHTWQVEVNZVGVHVOWNUCHWKVJZSVKZVLZAWOWMXAUCWLWTSWKHVPVQVRAXBWOAXBVSSTIUC
        HUDWKUGUIUJAIVTVLXBWPWBAUCTWQWCVLXBVBWBAHTVLXBWSWBAWKTVLXBWRWBAUCWASVKW
        KWASVKWDXBVFWBAXBWEWFWGWHWIWJ $.
    $}

    ${
      mapdh8c.f $e |- ( ph -> F e. D ) $.
      mapdh8c.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8c.a $e |- ( ph -> ( I ` <. X , F , w >. ) = E ) $.
      mapdh8c.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8c.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8c.xt $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8c.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { T } ) ) $.
      mapdh8c.w $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
      mapdh8c.wt $e |- ( ph -> ( N ` { w } ) =/= ( N ` { T } ) ) $.
      mapdh8c.ut $e |- ( ph -> ( N ` { X } ) =/= ( N ` { T } ) ) $.
      mapdh8c.vw $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { w } ) ) $.
      mapdh8c.e $e |- ( ph -> X e. ( N ` { Y , T } ) ) $.
      mapdh8c.xn $e |- ( ph -> -. X e. ( N ` { Y , w } ) ) $.
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM, 6-May-2015.) $)
      mapdh8c $p |- ( ph
           -> ( I ` <. w , E , T >. ) = ( I ` <. X , F , T >. ) ) $=
        ( csn cfv wne cv dvhlvec eldifad lspindpi simprd lspexch cpr wcel clvec
        wa adantr cdif simpr mtand mapdh8b ) ABCDEFGHIJKLMNOPQRSTUAUCUBUDUEUFUG
        UHUIUJUKULUMUNUOUPUQURUSUTVAVBVFVGVDAUBVLSVMZUCVLSVMZVNWJCVOZVLSVMZVNAS
        TIUBUCWLUGUJAIMPUAUEUFURVPZAUBTUDVLZVBVQZAUCTWOVCVQZAWLTWOVFVQZVKVRVSAS
        TIUBUCUDHUGUIUJWNVBWQAHTWOVDVQVHVJVTAUCUBWLWASVMWBZUBUCWLWASVMWBVKAWSWD
        STIUCUBUDWLUGUIUJAIWCWBWSWNWEAUCTWOWFWBWSVCWEAUBTWBWSWPWEAWLTWBWSWRWEAW
        KWMVNWSVIWEAWSWGVTWHWI $.
    $}

    $d x I $.
    ${
      mapdh8d.f $e |- ( ph -> F e. D ) $.
      mapdh8d.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8b.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh8d.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8d.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8d.xt $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8d.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { T } ) ) $.
      mapdh8d.w $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
      mapdh8d.wt $e |- ( ph -> ( N ` { w } ) =/= ( N ` { T } ) ) $.
      mapdh8d.ut $e |- ( ph -> ( N ` { X } ) =/= ( N ` { T } ) ) $.
      mapdh8d.vw $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { w } ) ) $.
      mapdh8d.xn $e |- ( ph -> -. X e. ( N ` { Y , w } ) ) $.
      ${
        mapdh8d0.e $e |- ( ph -> X e. ( N ` { Y , T } ) ) $.
        $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
           10-May-2015.)  (New usage is discouraged.) $)
        mapdh8d0N $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. X , F , T >. ) ) $=
          ( cv cotp cfv csn eldifad dvhlvec lspindpi simpld mapdhcl eqeltrrd co
          wne wceq wa mapdheq mpbid mapdh8a mapdh8b eqidd mapdh8c eqtr3d ) ACVL
          ZUBKWMVMNVNZHVMNVNUCLHVMNVNUBKHVMNVNABCDEFGHIJWNLMNOPQRSTUAUBUCUDUEUF
          UGUHUIUJUKULUMUNUOUPUQURAUBKUCVMNVNZLEVAABDEFGIJKMNOPQRSTUAUBUCUDUNUQ
          UEUPUFUGUHUIUJUKULUMUOURUSUTVBAUCTUDVOZVCVPZAUBVOSVNZUCVOSVNZWCWRWMVO
          SVNWCASTIUBUCWMUGUJAIMPUAUEUFURVQAUBTWPVBVPWQAWMTWPVFVPVJVRVSZVTWAZAW
          SQVNLVOOVNWDZUBUCRWBVOSVNQVNKLGWBVOOVNWDZAWOLWDXBXCWEVAABDEFGIJKLMNOP
          QRSTUAUBUCUDUNUQUEUPUFUGUHUIUJUKULUMUOURUSUTVBVCXAWTWFWGVSABDEFGWMIJK
          LMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVIVFVJWHVCVFVG
          VDVIVKVJWIABCDEFGHIJWNKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUS
          UTAWNWJVBVCVDVEVFVGVHVIVKVJWKWL $.
      $}
      $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM, 6-May-2015.) $)
      mapdh8d $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. X , F , T >. ) ) $=
        ( cpr cfv wcel cotp wceq wa cv chlt adantr csn eldifad dvhlvec lspindpi
        wne simpld mapdhcl eqeltrrd co mapdheq mpbid mapdh8a cdif simpr mapdh8b
        wn eqidd mapdh8c eqtr3d pm2.61dan ) AUBUCHVKSVLVMZUCLHVNNVLZUBKHVNNVLZV
        OAWTVPZCVQZUBKXDVNNVLZHVNNVLXAXBXCBCDEFGHIJXELMNOPQRSTUAUBUCUDUEUFUGUHU
        IUJUKULUMUNUOUPUQAPVRVMUAMVMVPZWTURVSZALEVMWTAUBKUCVNNVLZLEVAABDEFGIJKM
        NOPQRSTUAUBUCUDUNUQUEUPUFUGUHUIUJUKULUMUOURUSUTVBAUCTUDVTZVCWAZAUBVTSVL
        ZUCVTSVLZWDXKXDVTSVLZWDASTIUBUCXDUGUJAIMPUAUEUFURWBAUBTXIVBWAXJAXDTXIVF
        WAVJWCWEZWFWGZVSAXLQVLLVTOVLVOZWTAXPUBUCRWHVTSVLQVLKLGWHVTOVLVOZAXHLVOZ
        XPXQVPVAABDEFGIJKLMNOPQRSTUAUBUCUDUNUQUEUPUFUGUHUIUJUKULUMUOURUSUTVBVCX
        OXNWIWJWEVSAUCLXDVNNVLXEVOWTABDEFGXDIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKU
        LUMUNUOUPUQURUSUTVAVBVCVIVFVJWKVSAUCTXIWLZVMZWTVCVSZAXDXSVMWTVFVSZAXMHV
        TSVLZWDWTVGVSZAHXSVMZWTVDVSZAXLXMWDWTVIVSZAWTWMZAUBUCXDVKSVLVMWOWTVJVSZ
        WNXCBCDEFGHIJXEKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQXGAKEVMZWTUSV
        SAXKQVLKVTOVLVOZWTUTVSXCXEWPAUBXSVMZWTVBVSYAYFAXLYCWDZWTVEVSYBYDAXKYCWD
        WTVHVSYGYHYIWQWRAWTWOZVPBDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNU
        OUPUQAXFYNURVSAYJYNUSVSAYKYNUTVSAXRYNVAVSAYLYNVBVSAXTYNVCVSAYMYNVEVSAYE
        YNVDVSAYNWMWKWS $.
    $}

    ${
      $d w F $.  $d w G $.  $d w I $.  $d w N $.  $d w T $.  $d w U $.
      $d h V $.  $d w V $.  $d w X $.  $d w Y $.  $d w ph $.
      mapdh8e.f $e |- ( ph -> F e. D ) $.
      mapdh8e.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
      mapdh8e.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      mapdh8e.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8e.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8e.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      mapdh8e.xy $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      mapdh8e.xt $e |- ( ph -> ( N ` { X } ) =/= ( N ` { T } ) ) $.
      mapdh8e.yt $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { T } ) ) $.
      ${
        mapdh8e.e $e |- ( ph -> X e. ( N ` { Y , T } ) ) $.
        $( Part of Part (8) in [Baer] p. 48.  Eliminate ` w ` .  (Contributed
           by NM, 10-May-2015.) $)
        mapdh8e $p |- ( ph
             -> ( I ` <. Y , G , T >. ) = ( I ` <. X , F , T >. ) ) $=
          ( vw cv cpr cfv wcel wrex cotp wceq csn eldifad dvh3dim chlt 3ad2ant1
          wn w3a wa cdif wne clss eqid clmod dvhlmod lspprcl simp2 lssneln0 wss
          simp3 dvhlvec prcom fveq2i syl6eleq lspexch lspsnel5a adantr lspsnel5
          simpr biimprd con3d 3impia nssne2 syl2anc necomd clvec simprd mapdh8d
          lspindpi lspindp2l rexlimdv3a mpd ) AVHVIZUAUBVJRVKZVLZWAZVHSVMUBKGVN
          MVKUAJGVNMVKVOZAVHHLORSTUAUBUDUEUFUIUQAUASUCVPZVAVQZAUBSYBVBVQZVRAXTY
          AVHSAXQSVLZXTWBZBVHCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUP
          AYEOVSVLTLVLWCXTUQVTAYEJDVLXTURVTAYEUAVPRVKZPVKJVPNVKVOXTUSVTAYEUAJUB
          VNMVKKVOXTUTVTAYEUASYBWDZVLXTVAVTZAYEUBYHVLXTVBVTAYEGYHVLXTVCVTAYEUBV
          PRVKZGVPRVKZWEXTVFVTYFHWFVKZXRSHXQUCUFUHYLWGZAYEHWHVLZXTAHLOTUDUEUQWI
          ZVTAYEXRYLVLZXTAYLRSHUAUBUFYMUIYOYCYDWJZVTAYEXTWKZAYEXTWNZWLYFYKXQVPR
          VKZYFYKXRWMZYTXRWMZWAZYKYTWEAYEUUAXTAYLXRRHGYMUIYOYQARSHUAGUCUBUFUHUI
          AHLOTUDUEUQWOZVAAGSYBVCVQYDVDAUAUBGVJZRVKGUBVJZRVKVGUUEUUFRUBGWPWQWRW
          SWTVTAYEXTUUCAYEWCZUUBXSUUGXSUUBUUGYLXRRSHXQUFYMUIAYNYEYOXAAYPYEYQXAA
          YEXCXBXDXEXFYKYTXRXGXHXIAYEYGYKWEXTVEVTYFYTYJYFYTYGWEYTYJWEYFRSHXQUAU
          BUFUIAYEHXJVLXTUUDVTZYRAYEUASVLXTYCVTAYEUBSVLXTYDVTZYSXMXKXIYFYJYTWEU
          AUBXQVJRVKVLWAYFRSHUAUBUCXQUFUHUIUUHYIUUIYRAYEYGYJWEXTVDVTYSXNXKXLXOX
          P $.
      $}

      ${
        mapdh8f.e $e |- ( ph -> -. X e. ( N ` { Y , T } ) ) $.
        $( Part of Part (8) in [Baer] p. 48.  Eliminate ` w ` .  TODO: this is
           an instance of ~ mapdh8a - delete this?  (Contributed by NM,
           10-May-2015.)  (New usage is discouraged.) $)
        mapdh8fN $p |- ( ph
             -> ( I ` <. Y , G , T >. ) = ( I ` <. X , F , T >. ) ) $=
          ( mapdh8a ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURU
          SUTVAVBVFVCVGVH $.
      $}

      $( Part of Part (8) in [Baer] p. 48.  Eliminate
         ` X e. ( N `` { Y , T } ) ` .  TODO: break out ` T =/= .0. ` in
         ~ mapdh8e so we can share hypotheses.  Also, look at hypothesis
         sharing for earlier mapdh8* and mapdh75* stuff.  (Contributed by NM,
         10-May-2015.) $)
      mapdh8g $p |- ( ph
           -> ( I ` <. Y , G , T >. ) = ( I ` <. X , F , T >. ) ) $=
        ( cpr cfv wcel cotp wceq chlt adantr csn cdif wne simpr mapdh8e mapdh8a
        wa wn pm2.61dan ) AUAUBGVGRVHVIZUBKGVJMVHUAJGVJMVHVKAWCVTBCDEFGHIJKLMNO
        PQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPAOVLVITLVIVTZWCUQVMAJDVIZWCURVMAUA
        VNRVHZPVHJVNNVHVKZWCUSVMAUAJUBVJMVHKVKZWCUTVMAUASUCVNVOZVIZWCVAVMAUBWIV
        IZWCVBVMAGWIVIZWCVCVMAWFUBVNRVHZVPWCVDVMAWFGVNRVHZVPWCVEVMAWMWNVPZWCVFV
        MAWCVQVRAWCWAZVTBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPAWDW
        PUQVMAWEWPURVMAWGWPUSVMAWHWPUTVMAWJWPVAVMAWKWPVBVMAWOWPVFVMAWLWPVCVMAWP
        VQVSWB $.
    $}

    $d h V $.
    mapdh8h.f $e |- ( ph -> F e. D ) $.
    mapdh8h.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
    ${
      mapdh8i.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      mapdh8i.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      mapdh8i.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      mapdh8i.xy $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      mapdh8i.xz $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Z } ) ) $.
      mapdh8i.yt $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { T } ) ) $.
      mapdh8i.zt $e |- ( ph -> ( N ` { Z } ) =/= ( N ` { T } ) ) $.
      ${
        mapdh8i.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
        mapdh8i.xt $e |- ( ph -> ( N ` { X } ) =/= ( N ` { T } ) ) $.
        $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
           11-May-2015.) $)
        mapdh8i $p |- ( ph
             -> ( I ` <. Y , ( I ` <. X , F , Y >. ) , T >. )
                 = ( I ` <. Z , ( I ` <. X , F , Z >. ) , T >. ) ) $=
          ( cotp cfv eqidd mapdh8g eqtr4d ) AUATJUAVILVJZGVILVJTJGVILVJUCTJUCVI
          LVJZGVILVJABCDEFGHIJVNKLMNOPQRSTUAUBUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSA
          VNVKUTVAVGVCVHVEVLABCDEFGHIJVOKLMNOPQRSTUCUBUDUEUFUGUHUIUJUKULUMUNUOU
          PUQURUSAVOVKUTVBVGVDVHVFVLVM $.
      $}

      ${
        mapdh8j.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
        $( Part of Part (8) in [Baer] p. 48.  (Contributed by NM,
           13-May-2015.) $)
        mapdh8j $p |- ( ph
             -> ( I ` <. Y , ( I ` <. X , F , Y >. ) , T >. )
                 = ( I ` <. Z , ( I ` <. X , F , Z >. ) , T >. ) ) $=
          ( cotp cfv wceq csn wa chlt wcel adantr eqidd cdif simpr wne mapdh8ad
          mapdh8i pm2.61dane ) AUATJUAVHLVIZGVHLVIUCTJUCVHLVIZGVHLVIVJTVKQVIZGV
          KQVIZAWEWFVJZVLZBCDEFGHIWDJWCKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUO
          UPANVMVNSKVNVLZWGUQVOAJDVNZWGURVOAWEOVIJVKMVIVJZWGUSVOWHWCVPWHWDVPATR
          UBVKVQZVNZWGUTVOAUAWLVNZWGVAVOAUCWLVNZWGVBVOAGWLVNZWGVGVOAWGVRAWEUAVK
          QVIZVSZWGVCVOAWEUCVKQVIZVSZWGVDVOVTAWEWFVSZVLBCDEFGHIJKLMNOPQRSTUAUBU
          CUDUEUFUGUHUIUJUKULUMUNUOUPAWIXAUQVOAWJXAURVOAWKXAUSVOAWMXAUTVOAWNXAV
          AVOAWOXAVBVOAWRXAVCVOAWTXAVDVOAWQWFVSXAVEVOAWSWFVSXAVFVOAWPXAVGVOAXAV
          RWAWB $.
      $}

      mapdh8.t $e |- ( ph -> T e. V ) $.
      $( Part (8) in [Baer] p. 48.  Given a reference vector ` X ` , the value
         of function ` I ` at a vector ` T ` is independent of the choice of
         auxiliary vectors ` Y ` and ` Z ` .  Unlike Baer's, our version does
         not require ` X ` , ` Y ` , and ` Z ` to be independent, and also is
         defined for all ` Y ` and ` Z ` that are not colinear with ` X ` or
         ` T ` .  We do this to make the definition of Baer's sigma function
         more straightforward.  (This part eliminates ` T =/= .0. ` .)
         (Contributed by NM, 13-May-2015.) $)
      mapdh8 $p |- ( ph
           -> ( I ` <. Y , ( I ` <. X , F , Y >. ) , T >. )
               = ( I ` <. Z , ( I ` <. X , F , Z >. ) , T >. ) ) $=
        ( cotp cfv wceq wa csn cdif cvv wcel fvex mapdhval0 eqtr4d adantr oteq3
        a1i fveq2d adantl 3eqtr4d chlt anim1i eldifsn sylibr mapdh8j pm2.61dane
        wne ) AUATJUAVHZLVIZGVHZLVIZUCTJUCVHZLVIZGVHZLVIZVJGUBAGUBVJZVKUAWMUBVH
        ZLVIZUCWQUBVHZLVIZWOWSAXBXDVJWTAXBEXDABRUBVLVMZVNCDEFHIWMLMOPQUAUBUMUPU
        HVAWMVNVOAWLLVPWAVQABXEVNCDEFHIWQLMOPQUCUBUMUPUHVBWQVNVOAWPLVPWAVQVRVSW
        TWOXBVJAWTWNXALGUBUAWMVTWBWCWTWSXDVJAWTWRXCLGUBUCWQVTWBWCWDAGUBWKZVKZBC
        DEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPANWEVOSKVOVKXFUQVSAJDV
        OXFURVSATVLQVIZOVIJVLMVIVJXFUSVSATXEVOXFUTVSAUAXEVOXFVAVSAUCXEVOXFVBVSA
        XHUAVLQVIZWKXFVCVSAXHUCVLQVIZWKXFVDVSAXIGVLQVIZWKXFVEVSAXJXKWKXFVFVSXGG
        RVOZXFVKGXEVOAXLXFVGWFGRUBWGWHWIWJ $.
    $}

    $d w y z D $.  $d w y z F $.  $d w y z I $.  $d w y z N $.  $d w y z .0. $.
    $d w y z T $.  $d z U $.  $d w y z V $.  $d w y z X $.  $d w y z ph $.
    $d h x z $.
    mapdh9a.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    mapdh9a.t $e |- ( ph -> T e. V ) $.
    $( Lemma for part (9) in [Baer] p. 48.  TODO: why is this 50% larger than
       ~ mapdh9aOLDN ?  (Contributed by NM, 14-May-2015.) $)
    mapdh9a $p |- ( ph -> E! y e. D A. z e. V (
       -. z e. ( ( N ` { X } ) u. ( N ` { T } ) )
         -> y = ( I ` <. z , ( I ` <. X , F , z >. ) , T >. ) ) ) $=
      ( vw cv csn cfv cun wcel wn cotp wceq wi wral wreu wrex cdif wne w3a chlt
      wa 3ad2ant1 simp3ll simp3rl simplrl necomd simprrl simplrr simprrr mapdh8
      3ad2ant3 3exp ralrimivv wb cpr eldifad dvh3dim clss eqid dvhlmod ad2antrr
      clmod lspprcl simplr simpr lssneln0 clvec dvhlvec lspindpi jca ex mapdhcl
      reximdva mpd co eqidd simprl mapdheq mpbid simpld ancld eleq1 sneq fveq2d
      weq neeq1d anbi12d oteq1 oteq3 oteq2d eqtrd reusv3 wo ioran elun xchnxbir
      syl lspsncl syl2anc lspsnne2 reximdv lspsnel5a anim12d jcad syl5bi imim1d
      ralimdva lspprid1 lspprid2 unssd ssneld reusv1 mpbird ) ADVCZUBVDSVEZIVDS
      VEZVFZVGZVHZCVCUULUBLUULVIZNVEZIVIZNVEZVJZVKZDTVLZCFVMZUVDCFVNZAUULTUCVDZ
      VOZVGZUULVDZSVEZUUMVPZUVKUUNVPZVSZVSZUVBVKZDTVLZCFVNZUVFAUVOVBVCZUVHVGZUV
      SVDZSVEZUUMVPZUWBUUNVPZVSZVSZVSZUVAUVSUBLUVSVIZNVEZIVIZNVEZVJZVKZVBTVLDTV
      LZUVRAUWMDVBTTAUULTVGZUVSTVGVSZUWGUWLAUWPUWGVQZBEFGHIJKLMNOPQRSTUAUBUULUC
      UVSUDUEUFUGUHUIUJUKULUMUNUOUPAUWPPVRVGUAMVGVSZUWGUQVTAUWPLFVGZUWGURVTAUWP
      UUMQVELVDOVEVJZUWGUSVTAUWPUBUVHVGZUWGUTVTUVIUVNUWFAUWPWAUVTUWEUVOAUWPWBUW
      QUVKUUMUWGAUVLUWPUVIUVLUVMUWFWCWIWDUWQUWBUUMUWGAUWCUWPUVOUVTUWCUWDWEWIWDU
      WGAUVMUWPUVIUVLUVMUWFWFWIUWGAUWDUWPUVOUVTUWCUWDWGWIAUWPITVGZUWGVAVTWHWJWK
      AUVOUVAFVGZVSZDTVNZUWNUVRWLAUVODTVNZUXEAUULUBIWMSVEZVGVHZDTVNZUXFADJMPSTU
      AUBIUDUEUFUIUQAUBTUVGUTWNZVAWOZAUXHUVODTAUWOVSZUXHUVOUXLUXHVSZUVIUVNUXMJW
      PVEZUXGTJUULUCUFUHUXNWQZAJWTVGZUWOUXHAJMPUAUDUEUQWRZWSAUXGUXNVGUWOUXHAUXN
      STJUBIUFUXOUIUXQUXJVAXAZWSAUWOUXHXBZUXLUXHXCZXDUXMSTJUULUBIUFUIAJXEVGUWOU
      XHAJMPUAUDUEUQXFWSUXSAUBTVGZUWOUXHUXJWSAUXBUWOUXHVAWSUXTXGXHXIXKXLAUVOUXD
      DTUXLUVOUXCUXLUVOUXCUXLUVOVSZBEFGHJKUUSMNOPQRSTUAUULIUCUMUPUDUOUEUFUGUHUI
      UJUKULUNAUWRUWOUVOUQWSZUYBBEFGHJKLMNOPQRSTUAUBUULUCUMUPUDUOUEUFUGUHUIUJUK
      ULUNUYCAUWSUWOUVOURWSZAUWTUWOUVOUSWSZAUXAUWOUVOUTWSZAUWOUVOXBUYBUVKUUMUXL
      UVIUVLUVMWEWDZXJZUYBUVKQVEUUSVDOVEVJZUBUULRXMVDSVEQVELUUSHXMVDOVEVJZUYBUU
      SUUSVJUYIUYJVSUYBUUSXNUYBBEFGHJKLUUSMNOPQRSTUAUBUULUCUMUPUDUOUEUFUGUHUIUJ
      UKULUNUYCUYDUYEUYFUXLUVIUVNXOZUYHUYGXPXQXRUYKAUXBUWOUVOVAWSUXLUVIUVLUVMWG
      XJXIXSXKXLUVOUWFCDVBFTUVAUWKDVBYCZUVIUVTUVNUWEUULUVSUVHXTUYLUVLUWCUVMUWDU
      YLUVKUWBUUMUYLUVJUWASUULUVSYAYBZYDUYLUVKUWBUUNUYMYDYEYEUYLUUTUWJNUYLUUTUV
      SUUSIVIUWJUULUVSUUSIYFUYLUUSUWIUVSIUYLUURUWHNUULUVSUBLYGYBYHYIYBYJYOXQAUV
      QUVDCFAUVPUVCDTUXLUUQUVOUVBUUQUULUUMVGZVHZUULUUNVGZVHZVSZUXLUVOUYNUYPYKUY
      RUUPUYNUYPYLUULUUMUUNYMYNUXLUYRUVIUVNUXLUYRUVIUXLUYRVSUXNUUMTJUULUCUFUHUX
      OAUXPUWOUYRUXQWSAUUMUXNVGZUWOUYRAUXPUYAUYSUXQUXJUXNSTJUBUFUXOUIYPYQWSAUWO
      UYRXBUXLUYOUYQXOXDXIUXLUYOUVLUYQUVMUXLUYOUVLUXLUYOVSSTJUULUBUFUIAUXPUWOUY
      OUXQWSAUWOUYOXBAUYAUWOUYOUXJWSUXLUYOXCYRXIUXLUYQUVMUXLUYQVSSTJUULIUFUIAUX
      PUWOUYQUXQWSAUWOUYQXBAUXBUWOUYQVAWSUXLUYQXCYRXIUUAUUBUUCUUDUUEYSXLAUUQDTV
      NZUVEUVFWLAUXIUYTUXKAUXHUUQDTAUUOUXGUULAUUMUUNUXGAUXNUXGSJUBUXOUIUXQUXRAS
      TJUBIUFUIUXQUXJVAUUFYTAUXNUXGSJIUXOUIUXQUXRASTJUBIUFUIUXQUXJVAUUGYTUUHUUI
      YSXLUUQCDFTUVAUUJYOUUK $.

    $( Lemma for part (9) in [Baer] p. 48.  (Contributed by NM, 14-May-2015.)
       (New usage is discouraged.) $)
    mapdh9aOLDN $p |- ( ph -> E! y e. D A. z e. V ( -. z e. ( N ` { X , T } )
         -> y = ( I ` <. z , ( I ` <. X , F , z >. ) , T >. ) ) ) $=
      ( vw cv cpr cfv wcel wn cotp wceq wi wral wreu wrex w3a chlt 3ad2ant1 csn
      wa cdif clss eqid clmod dvhlmod eldifi syl lspprcl simp2l simp3l lssneln0
      simp2r simp3r wne clvec dvhlvec lspindpi simpld necomd simprd mapdh8 3exp
      ralrimivv wb dvh3dim ad2antrr simplr simpr mapdhcl co eqidd mapdheq mpbid
      ancld reximdva mpd weq eleq1 notbid oteq1 oteq3 fveq2d oteq2 eqtrd reusv3
      ex reusv1 mpbird ) ADVCZUBIVDSVEZVFZVGZCVCYGUBLYGVHZNVEZIVHZNVEZVIVJDTVKZ
      CFVLZYOCFVMZAYJVBVCZYHVFZVGZVRZYNYRUBLYRVHZNVEZIVHZNVEZVIZVJZVBTVKDTVKZYQ
      AUUGDVBTTAYGTVFZYRTVFZVRZUUAUUFAUUKUUAVNZBEFGHIJKLMNOPQRSTUAUBYGUCYRUDUEU
      FUGUHUIUJUKULUMUNUOUPAUUKPVOVFUAMVFVRZUUAUQVPAUUKLFVFZUUAURVPAUUKUBVQSVEZ
      QVELVQOVEVIZUUAUSVPAUUKUBTUCVQZVSVFZUUAUTVPUULJVTVEZYHTJYGUCUFUHUUSWAZAUU
      KJWBVFZUUAAJMPUAUDUEUQWCZVPZAUUKYHUUSVFZUUAAUUSSTJUBIUFUUTUIUVBAUURUBTVFZ
      UTUBTUUQWDWEZVAWFZVPZAUUIUUJUUAWGZAUUKYJYTWHZWIUULUUSYHTJYRUCUFUHUUTUVCUV
      HAUUIUUJUUAWJZAUUKYJYTWKZWIUULYGVQSVEZUUOUULUVMUUOWLZUVMIVQSVEZWLZUULSTJY
      GUBIUFUIAUUKJWMVFZUUAAJMPUAUDUEUQWNZVPZUVIAUUKUVEUUAUVFVPZAUUKITVFZUUAVAV
      PZUVJWOZWPWQUULYRVQSVEZUUOUULUWDUUOWLZUWDUVOWLZUULSTJYRUBIUFUIUVSUVKUVTUW
      BUVLWOZWPWQUULUVNUVPUWCWRUULUWEUWFUWGWRUWBWSWTXAAYJYNFVFZVRZDTVMZUUHYQXBA
      YJDTVMZUWJADJMPSTUAUBIUDUEUFUIUQUVFVAXCZAYJUWIDTAUUIVRZYJUWHUWMYJUWHUWMYJ
      VRZBEFGHJKYLMNOPQRSTUAYGIUCUMUPUDUOUEUFUGUHUIUJUKULUNAUUMUUIYJUQXDZUWNBEF
      GHJKLMNOPQRSTUAUBYGUCUMUPUDUOUEUFUGUHUIUJUKULUNUWOAUUNUUIYJURXDZAUUPUUIYJ
      USXDZAUURUUIYJUTXDZAUUIYJXEZUWNUVMUUOUWNUVNUVPUWNSTJYGUBIUFUIAUVQUUIYJUVR
      XDUWSAUVEUUIYJUVFXDAUWAUUIYJVAXDZUWMYJXFZWOZWPWQZXGZUWNUVMQVEYLVQOVEVIZUB
      YGRXHVQSVEQVELYLHXHVQOVEVIZUWNYLYLVIUXEUXFVRUWNYLXIUWNBEFGHJKLYLMNOPQRSTU
      AUBYGUCUMUPUDUOUEUFUGUHUIUJUKULUNUWOUWPUWQUWRUWNUUSYHTJYGUCUFUHUUTAUVAUUI
      YJUVBXDAUVDUUIYJUVGXDUWSUXAWIZUXDUXCXJXKWPUXGUWTUWNUVNUVPUXBWRXGYDXLXMXNY
      JYTCDVBFTYNUUEDVBXOZYIYSYGYRYHXPXQUXHYMUUDNUXHYMYRYLIVHZUUDYGYRYLIXRUXHYL
      UUCVIUXIUUDVIUXHYKUUBNYGYRUBLXSXTYLUUCYRIYAWEYBXTYCWEXKAUWKYPYQXBUWLYJCDF
      TYNYEWEYF $.
  $}

  $c HDMap1 $.

  $( Extend class notation with preliminary map from vectors to functionals in
     the closed kernel dual space. $)
  chdma1 $a class HDMap1 $.

  $c HDMap $.

  $( Extend class notation with map from vectors to functionals in the closed
     kernel dual space. $)
  chdma $a class HDMap $.

  ${
    $d a c d e h i j k m n t u v w x y z $.
    $( Define preliminary map from vectors to functionals in the closed kernel
       dual space.  See ~ hdmap1fval description for more details.
       (Contributed by NM, 14-May-2015.) $)
    df-hdmap1 $a |- HDMap1 = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      { a | [. ( ( DVecH ` k ) ` w ) / u ].
            [. ( Base ` u ) / v ].
            [. ( LSpan ` u ) / n ].
            [. ( ( LCDual ` k ) ` w ) / c ].
            [. ( Base ` c ) / d ].
            [. ( LSpan ` c ) / j ].
            [. ( ( mapd ` k ) ` w ) / m ].
  a e. ( x e. ( ( v X. d ) X. v ) |->
    if ( ( 2nd ` x ) = ( 0g ` u ) , ( 0g ` c ) ,
      ( iota_ h e. d
      ( ( m ` ( n ` { ( 2nd ` x ) } ) ) = ( j ` { h } )
        /\ ( m ` ( n ` { ( ( 1st ` ( 1st ` x ) ) ( -g ` u ) ( 2nd ` x ) ) } ) )
          = ( j ` { ( ( 2nd ` ( 1st ` x ) ) ( -g ` c ) h ) } ) ) ) ) ) } ) ) $.

    $( Define map from vectors to functionals in the closed kernel dual space.
       See ~ hdmapfval description for more details.  (Contributed by NM,
       15-May-2015.) $)
    df-hdmap $a |- HDMap = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      { a | [. <. ( _I |` ( Base ` k ) ) ,
                 ( _I |` ( ( LTrn ` k ) ` w ) ) >. / e ].
            [. ( ( DVecH ` k ) ` w ) / u ].
            [. ( Base ` u ) / v ].
            [. ( ( HDMap1 ` k ) ` w ) / i ].
  a e. ( t e. v |->
      ( iota_ y e. ( Base ` ( ( LCDual ` k ) ` w ) )
         A. z e. v ( -. z e. ( ( ( LSpan ` u ) ` { e } )
              u. ( ( LSpan ` u ) ` { t } ) ) ->
$(
         A. z e. v ( ( -. z e. ( ( LSpan ` u ) ` { e } )
              /\ -. z e. ( ( LSpan ` u ) ` { t } ) ) ->
$)
      y = ( i ` <. z ,
                  ( i ` <. e , ( ( ( HVMap ` k ) ` w ) ` e ) , z >. ) ,
                  t >. ) ) ) ) } ) ) $.
  $}

  ${
    $d k w H $.  $d a c d j k m n u v w K $.  $d a c d h j k m n u v w x $.
    hdmap1val.h $e |- H = ( LHyp ` K ) $.
    $( Preliminary map from vectors to functionals in the closed kernel dual
       space.  (Contributed by NM, 14-May-2015.) $)
    hdmap1ffval $p |- ( K e. X -> ( HDMap1 ` K ) = ( w e. H |->
      { a | [. ( ( DVecH ` K ) ` w ) / u ].
            [. ( Base ` u ) / v ].
            [. ( LSpan ` u ) / n ].
            [. ( ( LCDual ` K ) ` w ) / c ].
            [. ( Base ` c ) / d ].
            [. ( LSpan ` c ) / j ].
            [. ( ( mapd ` K ) ` w ) / m ].
  a e. ( x e. ( ( v X. d ) X. v ) |->
    if ( ( 2nd ` x ) = ( 0g ` u ) , ( 0g ` c ) ,
      ( iota_ h e. d
      ( ( m ` ( n ` { ( 2nd ` x ) } ) ) = ( j ` { h } )
        /\ ( m ` ( n ` { ( ( 1st ` ( 1st ` x ) ) ( -g ` u ) ( 2nd ` x ) ) } ) )
          = ( j ` { ( ( 2nd ` ( 1st ` x ) ) ( -g ` c ) h ) } ) ) ) ) ) } ) ) $=
      ( cfv cv wceq wsbc sbcbidv vk wcel cvv chdma1 cxp c2nd c0g csn c1st co wa
      csg crio cif cmpt cmpd clspn cbs clcd cdvh cab elex clh syl6eqr wb fveq1d
      fveq2 dfsbcq bitrd abbidv mpteq12dv df-hdmap1 fvex eqeltri mptex fvmpt
      syl ) JKUBJUCUBJUDPBILQACQZNQZUEVRUEAQZUFPZDQZUGPRMQZUGPWAUHHQZPGQZPEQZUH
      FQZPRVTUIPZUIPWAWBULPUJUHWDPWEPWHUFPWFWCULPUJUHWGPRUKEVSUMUNUOUBZGBQZJUPP
      ZPZSZFWCUQPZSZNWCURPZSZMWJJUSPZPZSZHWBUQPZSZCWBURPZSZDWJJUTPZPZSZLVAZUOZR
      JKVBUAJBUAQZVCPZWIGWJXJUPPZPZSZFWNSZNWPSZMWJXJUSPZPZSZHXASZCXCSZDWJXJUTPZ
      PZSZLVAZUOXIUCUDXJJRZBXKYEIXHYFXKJVCPZIXJJVCVGOVDYFYDXGLYFYDYADXFSZXGYFYC
      XFRYDYHVEYFWJYBXEXJJUTVGVFYADYCXFVHVQYFYAXDDXFYFXTXBCXCYFXSWTHXAYFXSXPMWS
      SZWTYFXRWSRXSYIVEYFWJXQWRXJJUSVGVFXPMXRWSVHVQYFXPWQMWSYFXOWONWPYFXNWMFWNY
      FXMWLRXNWMVEYFWJXLWKXJJUPVGVFWIGXMWLVHVQTTTVITTTVIVJVKABCDEFUAGHLMNVLBIXH
      IYGUCOJVCVMVNVOVPVQ $.

    $d h x C $.  $d a c d h j n u v w x D $.  $d a c d h j n u v w x J $.
    $d a c d h j m n u v w x M $.  $d a h n u v w x N $.  $d a n u v w .0. $.
    $d a Q $.  $d c d j n u v w Q $.  $d a c d j n u v w R $.
    $d a n u v w .- $.  $d h x U $.  $d a h n u v w x V $.
    $d a c d j m n u v w W $.
    hdmap1fval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1fval.v $e |- V = ( Base ` U ) $.
    hdmap1fval.s $e |- .- = ( -g ` U ) $.
    hdmap1fval.o $e |- .0. = ( 0g ` U ) $.
    hdmap1fval.n $e |- N = ( LSpan ` U ) $.
    hdmap1fval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1fval.d $e |- D = ( Base ` C ) $.
    hdmap1fval.r $e |- R = ( -g ` C ) $.
    hdmap1fval.q $e |- Q = ( 0g ` C ) $.
    hdmap1fval.j $e |- J = ( LSpan ` C ) $.
    hdmap1fval.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1fval.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1fval.k $e |- ( ph -> ( K e. A /\ W e. H ) ) $.
    $( Preliminary map from vectors to functionals in the closed kernel dual
       space.  TODO: change span ` J ` to the convention ` L ` for this
       section.  (Contributed by NM, 15-May-2015.) $)
    hdmap1fval $p |- ( ph
    -> I = ( x e. ( ( V X. D ) X. V ) |->
    if ( ( 2nd ` x ) = .0. , Q ,
      ( iota_ h e. D
      ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
        /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
          = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) ) $=
      ( vw va vv vd vu vc vn vm vj wcel wa cxp cv c2nd cfv wceq csn c1st co cif
      crio cmpt c0g csg cmpd wsbc clspn cbs clcd cdvh chdma1 hdmap1ffval fveq1d
      cab syl5eq wb fveq2 dfsbcq syl sbcbidv bitrd fvex eqeq2i biimpri 3ad2ant1
      simp2 fveq2d eqtrd syl6eqr simp3 id fveq1 eqeq1d anbi12d riotabidv ifeq2d
      mpteq2dv eleq2d sbcie xpeq2 xpeq1d simp1 eqeq2d oveqd fveq12d riotaeqbidv
      w3a sneqd ifeq12d mpteq12dv syl5bb syl3anc sbc3ie xpeq12d ifbieq2d syl6bb
      abbi1dv eqid cvv eqeltri xpex mptex fvmpt sylan9eq ) AMCVCZRJVCZVDKBQEVEZ
      QVEZBVFZVGVHZSVIZFUUCVJZPVHZNVHZIVFZVJZLVHZVIZUUBVKVHZVKVHZUUCOVLZVJZPVHZ
      NVHZUULVGVHZUUHGVLZVJZLVHZVIZVDZIEVNZVMZVOZVIUMYRYSKRUNJUOVFZBUPVFZUQVFZV
      EZUVHVEZUUCURVFZVPVHZVIZUSVFZVPVHZUUEUTVFZVHZVAVFZVHZUUIVBVFZVHZVIZUUMUUC
      UVLVQVHZVLZVJZUVQVHZUVSVHZUURUUHUVOVQVHZVLZVJZUWAVHZVIZVDZIUVIVNZVMZVOZVC
      ZVAUNVFZMVRVHZVHZVSZVBUVOVTVHZVSZUQUVOWAVHZVSZUSUWSMWBVHZVHZVSZUTUVLVTVHZ
      VSZUPUVLWAVHZVSZURUWSMWCVHZVHZVSZUOWGZVOZVHZUVFYRKRMWDVHZVHUXSULYRRUXTUXR
      BUNUPURIVBVAUTJMCUOUSUQTWEWFWHUNRUXQUVFJUXRUWSRVIZUXPUOUVFUYAUXPUWRVARUWT
      VHZVSZVBUXCVSZUQUXEVSZUSRUXGVHZVSZUTUXJVSZUPUXLVSZURRUXNVHZVSZUVGUVFVCZUY
      AUXPUXMURUYJVSZUYKUYAUXOUYJVIUXPUYMWIUWSRUXNWJUXMURUXOUYJWKWLUYAUXMUYIURU
      YJUYAUXKUYHUPUXLUYAUXIUYGUTUXJUYAUXIUXFUSUYFVSZUYGUYAUXHUYFVIUXIUYNWIUWSR
      UXGWJUXFUSUXHUYFWKWLUYAUXFUYEUSUYFUYAUXDUYDUQUXEUYAUXBUYCVBUXCUYAUXAUYBVI
      UXBUYCWIUWSRUWTWJUWRVAUXAUYBWKWLWMWMWMWNWMWMWMWNUYGUYLURUPUTUYJUXLUXJRUXN
      WOUVLWAWOUVLVTWOUVLUYJVIZUVHUXLVIZUVQUXJVIZXTZUVLHVIZUVHQVIZUVQPVIZUYGUYL
      WIUYOUYPUYSUYQUYSUYOHUYJUVLUAWPWQZWRZUYRUVHHWAVHZQUYRUVHUXLVUDUYOUYPUYQWS
      UYOUYPUXLVUDVIUYQUYOUVLHWAVUBWTWRXAUBXBUYRUVQHVTVHZPUYRUVQUXJVUEUYOUYPUYQ
      XCUYRUVLHVTVUCWTXAUEXBUYGUVGBUVHEVEZUVHVEZUVNFUVRNVHZUUJVIZUWGNVHZUVAVIZV
      DZIEVNZVMZVOZVCZUYSUYTVUAXTZUYLUYCVUPUSUQVBUYFUXEUXCRUXGWOUVOWAWOUVOVTWOU
      VOUYFVIZUVIUXEVIZUWAUXCVIZXTZUVODVIZUVIEVIZUWALVIZUYCVUPWIVURVUSVVBVUTVUR
      UVOUYFDVURXDUFXBWRZVVAUVIUXEEVURVUSVUTWSVVAUXEDWAVHZEVVAUVODWAVVEWTUGXBXA
      VVAUWAUXCLVURVUSVUTXCVVAUXCDVTVHLVVAUVODVTVVEWTUJXBXAUYCUVGBUVKUVNUVPVUHU
      WBVIZVUJUWLVIZVDZIUVIVNZVMZVOZVCZVVBVVCVVDXTZVUPUWRVVMVAUYBRUWTWOUVSUYBVI
      ZUVSNVIZUWRVVMWIVVOUVSUYBNVVOXDUKXBVVPUWQVVLUVGVVPBUVKUWPVVKVVPUVNUWOVVJU
      VPVVPUWNVVIIUVIVVPUWCVVGUWMVVHVVPUVTVUHUWBUVRUVSNXEXFVVPUWHVUJUWLUWGUVSNX
      EXFXGXHXIXJXKWLXLVVNVVLVUOUVGVVNBUVKVVKVUGVUNVVNVVCUVKVUGVIVVBVVCVVDWSZVV
      CUVJVUFUVHUVIEUVHXMXNWLVVNUVNUVPFVVJVUMVVNUVPDVPVHFVVNUVODVPVVBVVCVVDXOZW
      TUIXBVVNVVIVULIUVIEVVQVVNVVGVUIVVHVUKVVNUWBUUJVUHVVNUUIUWALVVBVVCVVDXCZWF
      XPVVNUWLUVAVUJVVNUWKUUTUWALVVSVVNUWJUUSVVNUWIGUURUUHVVNUWIDVQVHGVVNUVODVQ
      VVRWTUHXBXQYAXRXPXGXSYBYCXKYDYEYFVUQVUOUVFUVGVUQBVUGVUNUUAUVEVUQVUFYTUVHQ
      VUQUVHQEUYSUYTVUAWSZXNVVTYGVUQUVNUUDVUMUVDFVUQUVMSUUCVUQUVMHVPVHSVUQUVLHV
      PUYSUYTVUAXOZWTUDXBXPVUQVULUVCIEVUQVUIUUKVUKUVBVUQVUHUUGUUJVUQUVRUUFNVUQU
      UEUVQPUYSUYTVUAXCZWFWTXFVUQVUJUUQUVAVUQUWGUUPNVUQUWFUUOUVQPVWBVUQUWEUUNVU
      QUWDOUUMUUCVUQUWDHVQVHOVUQUVLHVQVWAWTUCXBXQYAXRWTXFXGXHYHYCXKYDYEYFYIYJUX
      RYKBUUAUVEYTQQEQVUDYLUBHWAWOYMZEVVFYLUGDWAWOYMYNVWCYNYOYPYQWL $.

    $d x .0. $.  $d x Q $.  $d x R $.  $d x .- $.  $d h x T $.
    ${
      hdmap1val.t $e |- ( ph -> T e. ( ( V X. D ) X. V ) ) $.
      $( Value of preliminary map from vectors to functionals in the closed
         kernel dual space.  (Contributed by NM, 15-May-2015.) $)
      hdmap1vallem $p |- ( ph -> ( I ` T )
            = if ( ( 2nd ` T ) = .0. , Q ,
        ( iota_ h e. D
        ( ( M ` ( N ` { ( 2nd ` T ) } ) ) = ( J ` { h } )
          /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` T ) ) .- ( 2nd ` T ) ) } ) )
            = ( J ` { ( ( 2nd ` ( 1st ` T ) ) R h ) } ) ) ) ) ) $=
        ( vx cfv cxp cv c2nd wceq csn c1st crio cif cmpt hdmap1fval fveq1d wcel
        co cvv c0g fvex eqeltri riotaex ifex fveq2 eqeq1d fveq2d oveq12d oveq1d
        wa sneqd eqeq12d anbi12d riotabidv ifbieq2d eqid fvmptg sylancl eqtrd )
        AGKUPGUOQDUQQUQZUOURZUSUPZSUTZEWMVAZPUPZNUPZIURZVALUPZUTZWLVBUPZVBUPZWM
        OVIZVAZPUPZNUPZXAUSUPZWRFVIZVAZLUPZUTZWAZIDVCZVDZVEZUPZGUSUPZSUTZEXQVAZ
        PUPZNUPZWSUTZGVBUPZVBUPZXQOVIZVAZPUPZNUPZYCUSUPZWRFVIZVAZLUPZUTZWAZIDVC
        ZVDZAGKXOAUOBCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMVFVGAGWKVHYPVJV
        HXPYPUTUNXREYOECVKUPVJUICVKVLVMYNIDVNVOUOGXNYPWKVJXOWLGUTZWNXRXMYOEYQWM
        XQSWLGUSVPZVQYQXLYNIDYQWTYBXKYMYQWQYAWSYQWPXTNYQWOXSPYQWMXQYRWBVRVRVQYQ
        XFYHXJYLYQXEYGNYQXDYFPYQXCYEYQXBYDWMXQOYQXAYCVBWLGVBVPZVRYRVSWBVRVRYQXI
        YKLYQXHYJYQXGYIWRFYQXAYCUSYSVRVTWBVRWCWDWEWFXOWGWHWIWJ $.
    $}

    $d h F $.  $d h X $.  $d h Y $.  $d h ph $.
    ${
      hdmap1val.x $e |- ( ph -> X e. V ) $.
      hdmap1val.f $e |- ( ph -> F e. D ) $.
      hdmap1val.y $e |- ( ph -> Y e. V ) $.
      $( Value of preliminary map from vectors to functionals in the closed
         kernel dual space.  (Restatement of ~ mapdhval .)  TODO: change
         ` I = ( x e. _V |-> ` ... to ` ( ph -> ( I `` <. X , F , Y > ) = ` ...
         in e.g. ~ mapdh8 to shorten proofs with no $d on ` x ` .  (Contributed
         by NM, 15-May-2015.) $)
      hdmap1val $p |- ( ph -> ( I ` <. X , F , Y >. )
            = if ( Y = .0. , Q ,
        ( iota_ h e. D
        ( ( M ` ( N ` { Y } ) ) = ( J ` { h } )
          /\ ( M ` ( N ` { ( X .- Y ) } ) )
            = ( J ` { ( F R h ) } ) ) ) ) ) $=
        ( cotp cfv c2nd wceq csn cv c1st co wa crio cif cop df-ot wcel sylanbrc
        cxp opelxp syl5eqel hdmap1vallem ot3rdg syl eqeq1d sneqd fveq2d syl3anc
        ot1stg oveq12d ot2ndg oveq1d eqeq12d anbi12d riotabidv ifbieq2d eqtrd )
        ASITUSZKUTWMVAUTZUAVBZEWNVCZPUTZNUTZHVDZVCLUTZVBZWMVEUTZVEUTZWNOVFZVCZP
        UTZNUTZXBVAUTZWSFVFZVCZLUTZVBZVGZHDVHZVITUAVBZETVCZPUTZNUTZWTVBZSTOVFZV
        CZPUTZNUTZIWSFVFZVCZLUTZVBZVGZHDVHZVIABCDEFWMGHJKLMNOPQRUAUBUCUDUEUFUGU
        HUIUJUKULUMUNUOAWMSIVJZTVJZQDVNZQVNZSITVKAYJYLVLZTQVLZYKYMVLASQVLZIDVLZ
        YNUPUQSIQDVOVMURYJTYLQVOVMVPVQAWOXOXNYIEAWNTUAAYOWNTVBURSITQVRVSZVTAXMY
        HHDAXAXSXLYGAWRXRWTAWQXQNAWPXPPAWNTYRWAWBWBVTAXGYCXKYFAXFYBNAXEYAPAXDXT
        AXCSWNTOAYPYQYOXCSVBUPUQURSITQDQWDWCYRWEWAWBWBAXJYELAXIYDAXHIWSFAYPYQYO
        XHIVBUPUQURSITQDQWFWCWGWAWBWHWIWJWKWL $.
    $}
  $}

  ${
    $d h C $.  $d h D $.  $d h F $.  $d h K $.  $d h U $.  $d h V $.  $d h W $.
    $d h .0. $.  $d h ph $.  $d h X $.
    hdmap1val0.h $e |- H = ( LHyp ` K ) $.
    hdmap1val0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1val0.v $e |- V = ( Base ` U ) $.
    hdmap1val0.o $e |- .0. = ( 0g ` U ) $.
    hdmap1val0.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1val0.d $e |- D = ( Base ` C ) $.
    hdmap1val0.q $e |- Q = ( 0g ` C ) $.
    hdmap1val0.s $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1val0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1val0.f $e |- ( ph -> F e. D ) $.
    hdmap1val0.x $e |- ( ph -> X e. V ) $.
    $( Value of preliminary map from vectors to functionals at zero.  (Restated
       ~ mapdhval0 .)  (Contributed by NM, 17-May-2015.) $)
    hdmap1val0 $p |- ( ph -> ( I ` <. X , F , .0. >. ) = Q ) $=
      ( vh cotp cfv wceq csn clspn cmpd cv csg co crio cif chlt eqid clmod wcel
      wa dvhlmod lmod0vcl syl hdmap1val iftrue ax-mp syl6eq ) ALFMUFHUGMMUHZDMU
      IEUJUGZUGKIUKUGUGZUGUEULZUIBUJUGZUGUHLMEUMUGZUNUIVJUGVKUGFVLBUMUGZUNUIVMU
      GUHVAUECUOZUPZDAUQBCDVOEUEFGHVMIVKVNVJJKLMMNOPVNURQVJURRSVOURTVMURVKURUAU
      BUDUCAEUSUTMJUTAEGIKNOUBVBJEMPQVCVDVEVIVQDUHMURVIDVPVFVGVH $.
  $}


  ${
    $d h C $.  $d h D $.  $d h F $.  $d h L $.  $d h M $.  $d h N $.  $d h U $.
    $d h V $.  $d h X $.  $d h Y $.  $d h ph $.
    hdmap1val2.h $e |- H = ( LHyp ` K ) $.
    hdmap1val2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1val2.v $e |- V = ( Base ` U ) $.
    hdmap1val2.s $e |- .- = ( -g ` U ) $.
    hdmap1val2.o $e |- .0. = ( 0g ` U ) $.
    hdmap1val2.n $e |- N = ( LSpan ` U ) $.
    hdmap1val2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1val2.d $e |- D = ( Base ` C ) $.
    hdmap1val2.r $e |- R = ( -g ` C ) $.
    hdmap1val2.l $e |- L = ( LSpan ` C ) $.
    hdmap1val2.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1val2.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1val2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hdmap1val2.x $e |- ( ph -> X e. V ) $.
      hdmap1val2.f $e |- ( ph -> F e. D ) $.
      hdmap1val2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      $( Value of preliminary map from vectors to functionals in the closed
         kernel dual space, for nonzero ` Y ` .  (Contributed by NM,
         16-May-2015.) $)
      hdmap1val2 $p |- ( ph -> ( I ` <. X , F , Y >. )
            = ( iota_ h e. D ( ( M ` ( N ` { Y } ) ) = ( L ` { h } )
             /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( L ` { ( F R h ) } ) ) ) ) $=
        ( cotp cfv wceq c0g csn cv co crio cif chlt eqid eldifad hdmap1val cdif
        wa wcel wn eldifsni neneqd iffalse 3syl eqtrd ) AQGRUPIUQRSURZBUSUQZRUT
        NUQLUQFVAZUTKUQURQRMVBUTNUQLUQGVTDVBUTKUQURVJFCVCZVDZWAAVEBCVSDEFGHIKJL
        MNOPQRSTUAUBUCUDUEUFUGUHVSVFUIUJUKULUMUNAROSUTZUOVGVHAROWCVIVKZVRVLWBWA
        URUOWDRSROSVMVNVRVSWAVOVPVQ $.
    $}

    ${
      $d w D $.  $d w F $.  $d h w G $.  $d w L $.  $d w M $.  $d w N $.
      $d h w R $.  $d h w .- $.  $d w X $.  $d w Y $.  $d w ph $.
      hdmap1eq.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      hdmap1eq.f $e |- ( ph -> F e. D ) $.
      hdmap1eq.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      hdmap1eq.g $e |- ( ph -> G e. D ) $.
      hdmap1eq.e $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      hdmap1eq.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
      $( The defining equation for h(x,x',y)=y' in part (2) in [Baer] p. 45
         line 24.  (Contributed by NM, 16-May-2015.) $)
      hdmap1eq $p |- ( ph -> ( ( I ` <. X , F , Y >. ) = G
         <-> ( ( M ` ( N ` { Y } ) ) = ( L ` { G } )
             /\ ( M ` ( N ` { ( X .- Y ) } ) ) = ( L ` { ( F R G ) } ) ) ) ) $=
        ( vh cotp cfv wceq csn cv co crio eldifad hdmap1val2 eqeq1d wreu mapdpg
        wa wb nfcvd nfvd sneq fveq2d eqeq2d oveq2 sneqd anbi12d adantl riota2df
        nfv mpdan bitr4d ) AQFRUTIVAZGVBRVCNVALVAZUSVDZVCZKVAZVBZQRMVEVCNVALVAZ
        FWIDVEZVCZKVAZVBZVLZUSCVFZGVBZWHGVCZKVAZVBZWMFGDVEZVCZKVAZVBZVLZAWGWSGA
        BCDEUSFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULAQOSVCUMVGUNUOVHVIAWRUSCVJX
        HWTVMABDEUSCFHKJLMNOPQRSTUJUAUBUCUDUEUFUGUHUIULUMUOUNUQURVKAWRXHUSCGAUS
        WDAUSGVNAXHUSVOUPWIGVBZWRXHVMAXIWLXCWQXGXIWKXBWHXIWJXAKWIGVPVQVRXIWPXFW
        MXIWOXEKXIWNXDWIGFDVSVTVQVRWAWBWCWEWF $.
    $}
  $}

  ${
    $d h i x y D $.  $d h i x y J $.  $d h i x y M $.  $d h i x y N $.
    $d x y .0. $.  $d x y Q $.  $d h i x y R $.  $d h i x y .- $.
    hdmap1cbv.l $e |- L = ( x e. _V |->
     if ( ( 2nd ` x ) = .0. , Q ,
        ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    $( Frequently used lemma to change bound variables in ` L ` hypothesis.
       (Contributed by NM, 15-May-2015.) $)
    hdmap1cbv $p |- L = ( y e. _V |->
     if ( ( 2nd ` y ) = .0. , Q ,
        ( iota_ i e. D ( ( M ` ( N ` { ( 2nd ` y ) } ) ) = ( J ` { i } )
           /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` y ) ) .- ( 2nd ` y ) ) } ) )
                 = ( J ` { ( ( 2nd ` ( 1st ` y ) ) R i ) } ) ) ) ) ) $=
      ( c2nd cfv wceq csn c1st fveq2d cvv cv co wa crio cmpt fveq2 eqeq1d sneqd
      cif oveq12d oveq1d eqeq12d anbi12d riotabidv ifbieq2d cbvmptv sneq eqeq2d
      weq oveq2 cbvriotav ifeq2 ax-mp mpteq2i 3eqtri ) IAUAAUBZOPZMQZDVHRZLPZJP
      ZFUBZRZHPZQZVGSPZSPZVHKUCZRZLPZJPZVQOPZVMEUCZRZHPZQZUDZFCUEZUJZUFBUABUBZO
      PZMQZDWLRZLPZJPZVOQZWKSPZSPZWLKUCZRZLPZJPZWROPZVMEUCZRZHPZQZUDZFCUEZUJZUF
      BUAWMDWPGUBZRZHPZQZXCXDXLEUCZRZHPZQZUDZGCUEZUJZUFNABUAWJXKABUTZVIWMWIXJDY
      CVHWLMVGWKOUGZUHYCWHXIFCYCVPWQWGXHYCVLWPVOYCVKWOJYCVJWNLYCVHWLYDUITTUHYCW
      BXCWFXGYCWAXBJYCVTXALYCVSWTYCVRWSVHWLKYCVQWRSVGWKSUGZTYDUKUITTYCWEXFHYCWD
      XEYCWCXDVMEYCVQWROYETULUITUMUNUOUPUQBUAXKYBXJYAQXKYBQXIXTFGCFGUTZWQXOXHXS
      YFVOXNWPYFVNXMHVMXLURTUSYFXGXRXCYFXFXQHYFXEXPVMXLXDEVAUITUSUNVBWMXJYADVCV
      DVEVF $.
  $}

  ${
    $d w x .0. $.  $d g C $.  $d g h w x D $.  $d g h w x J $.  $d g h w x M $.
    $d g h w x .- $.  $d g w F $.  $d g h w x N $.  $d g ph $.  $d g h w x R $.
    $d w x Q $.  $d g U $.  $d g V $.  $d g w X $.  $d g w Y $.
    hdmap1valc.h $e |- H = ( LHyp ` K ) $.
    hdmap1valc.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1valc.v $e |- V = ( Base ` U ) $.
    hdmap1valc.s $e |- .- = ( -g ` U ) $.
    hdmap1valc.o $e |- .0. = ( 0g ` U ) $.
    hdmap1valc.n $e |- N = ( LSpan ` U ) $.
    hdmap1valc.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1valc.d $e |- D = ( Base ` C ) $.
    hdmap1valc.r $e |- R = ( -g ` C ) $.
    hdmap1valc.q $e |- Q = ( 0g ` C ) $.
    hdmap1valc.j $e |- J = ( LSpan ` C ) $.
    hdmap1valc.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1valc.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1valc.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1valc.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1valc.f $e |- ( ph -> F e. D ) $.
    hdmap1valc.y $e |- ( ph -> Y e. V ) $.
    ${
      hdmap1valc.l $e |- L = ( x e. _V |->
       if ( ( 2nd ` x ) = .0. , Q ,
          ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
             /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
                   = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
      $( Connect the value of the preliminary map from vectors to functionals
         ` I ` to the hypothesis ` L ` used by earlier theorems.  Note: the
         ` X e. ( V \ { .0. } ) ` hypothesis could be the more general
         ` X e. V ` but the former will be easier to use.  TODO: use the ` I `
         function directly in those theorems, so this theorem becomes
         unnecessary?  TODO:  The ~ hdmap1cbv is probably unnecessary, but it
         would mean different $d's later on.  (Contributed by NM,
         15-May-2015.) $)
      hdmap1valc $p |- ( ph
         -> ( I ` <. X , F , Y >. ) = ( L ` <. X , F , Y >. ) ) $=
        ( vg vw cotp cfv wceq csn cv co wa crio cif eldifad hdmap1val hdmap1cbv
        chlt mapdhval eqtr4d ) ATIUAVCZKVDUAUBVEEUAVFQVDOVDVAVGZVFLVDVETUAPVHVF
        QVDOVDIVSFVHVFLVDVEVIVADVJVKVRNVDAVOCDEFGVAIJKLMOPQRSTUAUBUCUDUEUFUGUHU
        IUJUKULUMUNUOUPATRUBVFUQVLZURUSVMAVBRDCDEFVARINLOPQTUAUBULBVBDEFHVALNOP
        QUBUTVNVTURUSVPVQ $.
    $}
  $}

  ${
    $d h x C $.  $d h x D $.  $d h x F $.  $d h x G $.  $d h x L $.
    $d h x M $.  $d h x N $.  $d h x .0. $.  $d h x U $.  $d h x X $.
    $d h x Y $.  $d h ph $.
    hdmap1eq2.h $e |- H = ( LHyp ` K ) $.
    hdmap1eq2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1eq2.v $e |- V = ( Base ` U ) $.
    hdmap1eq2.o $e |- .0. = ( 0g ` U ) $.
    hdmap1eq2.n $e |- N = ( LSpan ` U ) $.
    hdmap1eq2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1eq2.d $e |- D = ( Base ` C ) $.
    hdmap1eq2.l $e |- L = ( LSpan ` C ) $.
    hdmap1eq2.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1eq2.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1eq2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1eq2.f $e |- ( ph -> F e. D ) $.
    hdmap1eq2.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
    ${
      hdmap1cl.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      hdmap1cl.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      hdmap1cl.y $e |- ( ph -> Y e. V ) $.
      $( Convert closure theorem ~ mapdhcl to use ` HDMap1 ` function.
         (Contributed by NM, 15-May-2015.) $)
      hdmap1cl $p |- ( ph -> ( I ` <. X , F , Y >. ) e. D ) $=
        ( vx vh cotp cfv cvv cv c2nd wceq c0g csn c1st csg co wa crio cmpt eqid
        cif hdmap1valc mapdhcl eqeltrd ) ANEOUOZGUPVNUMUQUMURZUSUPZPUTBVAUPZVPV
        BKUPJUPUNURZVBIUPUTVOVCUPZVCUPVPDVDUPZVEVBKUPJUPVSUSUPVRBVDUPZVEVBIUPUT
        VFUNCVGVJVHZUPCAUMBCVQWADUNEFGIHWBJVTKLMNOPQRSVTVIZTUAUBUCWAVIZVQVIZUDU
        EUFUGUKUHULWBVIZVKAUMBCVQWADUNEFWBIHJVTKLMNOPWEWFQUERSWCTUAUBUCWDUDUGUH
        UIUKULUJVLVM $.
    $}

    ${
      hdmap1eq2.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      hdmap1eq2.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
      hdmap1eq2.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      hdmap1eq2.e $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      $( Convert ~ mapdheq2 to use ` HDMap1 ` function.  (Contributed by NM,
         16-May-2015.) $)
      hdmap1eq2 $p |- ( ph -> ( I ` <. Y , G , X >. ) = F ) $=
        ( vx vh cotp cfv cvv cv c2nd wceq c0g csn c1st csg co wa crio cmpt eqid
        cif eldifad hdmap1cl eqeltrrd hdmap1valc eqtr3d mapdh75e eqtrd ) APFOUQ
        ZHURVTUOUSUOUTZVAURZQVBBVCURZWBVDLURKURUPUTZVDJURVBWAVEURZVEURWBDVFURZV
        GVDLURKURWEVAURWDBVFURZVGVDJURVBVHUPCVIVLVJZUREAUOBCWCWGDUPFGHJIWHKWFLM
        NPOQRSTWFVKZUAUBUCUDWGVKZWCVKZUEUFUGUHUMAOEPUQZHURZFCUNABCDEGHIJKLMNOPQ
        RSTUAUBUCUDUEUFUGUHUIUJUKULAPMQVDZUMVMZVNVOAOMWNULVMWHVKZVPAUOBCWCWGDUP
        FEGWHJIKWFLMNOQPRSTWIUAUBUCUDWJWKUEUFWPUHUIUJAWMWLWHURFAUOBCWCWGDUPEGHJ
        IWHKWFLMNOPQRSTWIUAUBUCUDWJWKUEUFUGUHULUIWOWPVPUNVQUKULUMVRVS $.
    $}

    $d h B $.  $d h x Z $.
    hdmap1eq4.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1eq4.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    hdmap1eq4.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
    hdmap1eq4.ne $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
    hdmap1eq4.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    hdmap1eq4.eg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
    hdmap1eq4.ee $e |- ( ph -> ( I ` <. X , F , Z >. ) = B ) $.
    $( Convert ~ mapdheq4 to use ` HDMap1 ` function.  (Contributed by NM,
       17-May-2015.)  (New usage is discouraged.) $)
    hdmap1eq4N $p |- ( ph -> ( I ` <. Y , G , Z >. ) = B ) $=
      ( vx vh cotp cfv cvv cv c2nd wceq c0g csn c1st csg crio cif cmpt eqid wne
      co wa dvhlvec eldifad lspindpi simpld hdmap1cl eqeltrrd hdmap1valc eqtr3d
      mapdheq4 eqtrd ) AQGSVBZIVCWIUTVDUTVEZVFVCZRVGCVHVCZWKVIMVCLVCVAVEZVIKVCV
      GWJVJVCZVJVCWKEVKVCZVQVIMVCLVCWNVFVCWMCVKVCZVQVIKVCVGVRVADVLVMVNZVCBAUTCD
      WLWPEVAGHIKJWQLWOMNOQSRTUAUBWOVOZUCUDUEUFWPVOZWLVOZUGUHUIUJUNAPFQVBZIVCZG
      DURACDEFHIJKLMNOPQRTUAUBUCUDUEUFUGUHUIUJUKULAPVIMVCZQVIMVCVPXCSVIMVCVPAMN
      EPQSUBUDAEHJOTUAUJVSAPNRVIZUMVTAQNXDUNVTZASNXDUOVTZUQWAWBUMXEWCWDXFWQVOZW
      EAUTCDWLWPEVABFGHWQKJLWOMNOPQRSWTXGTUHUAUBWRUCUDUEUFWSUGUJUKULUMUNUOUQUPA
      XBXAWQVCGAUTCDWLWPEVAFHIKJWQLWOMNOPQRTUAUBWRUCUDUEUFWSWTUGUHUIUJUMUKXEXGW
      EURWFAPFSVBZIVCXHWQVCBAUTCDWLWPEVAFHIKJWQLWOMNOPSRTUAUBWRUCUDUEUFWSWTUGUH
      UIUJUMUKXFXGWEUSWFWGWH $.
  $}

  ${
    hdmap1l6.h $e |- H = ( LHyp ` K ) $.
    hdmap1l6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1l6.v $e |- V = ( Base ` U ) $.
    hdmap1l6.p $e |- .+ = ( +g ` U ) $.
    hdmap1l6.s $e |- .- = ( -g ` U ) $.
    hdmap1l6c.o $e |- .0. = ( 0g ` U ) $.
    hdmap1l6.n $e |- N = ( LSpan ` U ) $.
    hdmap1l6.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1l6.d $e |- D = ( Base ` C ) $.
    hdmap1l6.a $e |- .+b = ( +g ` C ) $.
    hdmap1l6.r $e |- R = ( -g ` C ) $.
    hdmap1l6.q $e |- Q = ( 0g ` C ) $.
    hdmap1l6.l $e |- L = ( LSpan ` C ) $.
    hdmap1l6.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1l6.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1l6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1l6.f $e |- ( ph -> F e. D ) $.
    hdmap1l6cl.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1l6.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
    ${
      hdmap1l6e.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      hdmap1l6e.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      hdmap1l6e.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      hdmap1l6.yz $e |- ( ph -> ( N ` { Y } ) =/= ( N ` { Z } ) ) $.
      hdmap1l6.fg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      hdmap1l6.fe $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      $( Lemma for ~ hdmap1l6 .  Part (6) in [Baer] p. 47, lines 16-18.
         (Contributed by NM, 13-Apr-2015.) $)
      hdmap1l6lem1 $p |- ( ph
          -> ( M ` ( N ` { ( X .- ( Y .+ Z ) ) } ) )
                 = ( L ` { ( F R ( G .+b E ) ) } ) ) $=
        ( co csn cfv clsm cin clss eqid wcel dvhlmod eldifad lmodvsubcl syl3anc
        clmod lspsncl syl2anc lsmcl mapdin mapdlsm ineq12d wceq cotp wa wne cpr
        dvhlvec lspindp2 simpld hdmap1cl eqeltrrd hdmap1eq mpbid simprd oveq12d
        wn lspindp1 baerlem5a fveq2d lcdlvec mapdindp mapdncol mapdn0 3eqtr4d
        eqtrd ) AUAUBQVJZVKRVLZUDVKRVLZHVMVLZVJZUAUDQVJZVKRVLZUBVKRVLZXPVJZVNZP
        VLZJKGVJVKOVLZIVKOVLZBVMVLZVJZJIGVJVKOVLZKVKOVLZYFVJZVNZUAUBUDDVJQVJVKR
        VLZPVLJKIEVJGVJVKOVLAYCXQPVLZYAPVLZVNZYKAHVOVLZHLNPTXQYAUEURUFYPVPZUTAH
        WBVQZXNYPVQZXOYPVQZXQYPVQAHLNTUEUFUTVRZAYRXMSVQZYSUUAAYRUASVQZUBSVQZUUB
        UUAAUASUCVKZVBVSZAUBSUUEVDVSZQSHUAUBUGUIVTWAYPRSHXMUGYQUKWCWDZAYRUDSVQZ
        YTUUAAUDSUUEVEVSZYPRSHUDUGYQUKWCWDZXPYPXNXOHYQXPVPZWEWAAYRXSYPVQZXTYPVQ
        ZYAYPVQUUAAYRXRSVQZUUMUUAAYRUUCUUIUUOUUAUUFUUJQSHUAUDUGUIVTWAYPRSHXRUGY
        QUKWCWDZAYRUUDUUNUUAUUGYPRSHUBUGYQUKWCWDZXPYPXSXTHYQUULWEWAWFAYOXNPVLZX
        OPVLZYFVJZXSPVLZXTPVLZYFVJZVNYKAYMUUTYNUVCABYFXPYPHLNPTXNXOUEURUFYQUULU
        LYFVPZUTUUHUUKWGABYFXPYPHLNPTXSXTUEURUFYQUULULUVDUTUUPUUQWGWHAUUTYGUVCY
        JAUURYDUUSYEYFAUVBYIWIZUURYDWIZAUAJUBWJMVLZKWIUVEUVFWKVHABCGHJKLMNOPQRS
        TUAUBUCUEUFUGUIUJUKULUMUOUQURUSUTVBVAVDAUVGKCVHABCHJLMNOPRSTUAUBUCUEUFU
        GUJUKULUMUQURUSUTVAVCAUAVKRVLZXTWLUDUAUBWMRVLVQXCARSHUBUDUCUAUGUJUKAHLN
        TUEUFUTWNZUUGVEUUFVGVFWOWPZVBUUGWQWRZUVJVCWSWTZXAAUUSYEWIZUVAYHWIZAUAJU
        DWJMVLZIWIUVMUVNWKVIABCGHJILMNOPQRSTUAUDUCUEUFUGUIUJUKULUMUOUQURUSUTVBV
        AVEAUVOICVIABCHJLMNOPRSTUAUDUCUEUFUGUJUKULUMUQURUSUTVAVCAUVHXOWLUBUAUDW
        MRVLVQXCARSHUBUDUCUAUGUJUKUVIVDUUJUUFVGVFXDWPZVBUUJWQWRZUVPVCWSWTZWPZXB
        AUVAYHUVBYIYFAUVMUVNUVRXAAUVEUVFUVLWPZXBWHXLXLAYLYBPADXPQRSHUAUBUCUDUGU
        IUJUULUKUVIUUFVFVGVDVEUHXEXFAEYFGOCBJKFIUMUOUPUVDUQABLNTUEULUTXGVAABCHI
        JKLONPRSTUAUBUDUEURUFUGUKULUMUQUTVAVCUUFUUGUVKUVTUUJUVQUVSVFXHABCHKILON
        PRSTUBUDUEURUFUGUKULUMUQUTUVKUVTUUGUUJUVQUVSVGXIABCHKLONPRSTUBUCFUEURUF
        UGUKULUMUQUTUVKUVTUJUPVDXJABCHILONPRSTUDUCFUEURUFUGUKULUMUQUTUVQUVSUJUP
        VEXJUNXEXK $.

      $( Lemma for ~ hdmap1l6 .  Part (6) in [Baer] p. 47, lines 20-22.
         (Contributed by NM, 13-Apr-2015.) $)
      hdmap1l6lem2 $p |- ( ph
          -> ( M ` ( N ` { ( Y .+ Z ) } ) ) = ( L ` { ( G .+b E ) } ) ) $=
        ( csn cfv clsm cin clss eqid clmod wcel dvhlmod eldifad lspsncl syl2anc
        co lsmcl syl3anc lmodvacl lmodvsubcl mapdin mapdlsm wceq cotp wa wne wn
        cpr dvhlvec lspindp2 simpld hdmap1cl eqeltrrd hdmap1eq lspindp1 oveq12d
        hdmap1l6lem1 ineq12d baerlem5b fveq2d lcdlvec mapdindp mapdncol 3eqtr4d
        mpbid eqtrd mapdn0 ) AUBVJRVKZUDVJRVKZHVLVKZWBZUAUBUDDWBZQWBZVJRVKZUAVJ
        RVKZXPWBZVMZPVKZKVJOVKZIVJOVKZBVLVKZWBZJKIEWBZGWBVJOVKZJVJOVKZYGWBZVMZX
        RVJRVKZPVKYIVJOVKAYDXQPVKZYBPVKZVMYMAHVNVKZHLNPTXQYBUEURUFYQVOZUTAHVPVQ
        ZXNYQVQZXOYQVQZXQYQVQAHLNTUEUFUTVRZAYSUBSVQZYTUUBAUBSUCVJZVDVSZYQRSHUBU
        GYRUKVTWAZAYSUDSVQZUUAUUBAUDSUUDVEVSZYQRSHUDUGYRUKVTWAZXPYQXNXOHYRXPVOZ
        WCWDAYSXTYQVQZYAYQVQZYBYQVQUUBAYSXSSVQZUUKUUBAYSUASVQZXRSVQZUUMUUBAUASU
        UDVBVSZAYSUUCUUGUUOUUBUUEUUHDSHUBUDUGUHWEWDQSHUAXRUGUIWFWDYQRSHXSUGYRUK
        VTWAZAYSUUNUULUUBUUPYQRSHUAUGYRUKVTWAZXPYQXTYAHYRUUJWCWDWGAYOYHYPYLAYOX
        NPVKZXOPVKZYGWBYHABYGXPYQHLNPTXNXOUEURUFYRUUJULYGVOZUTUUFUUIWHAUUSYEUUT
        YFYGAUUSYEWIZUAUBQWBVJRVKPVKJKGWBVJOVKWIZAUAJUBWJMVKZKWIUVBUVCWKVHABCGH
        JKLMNOPQRSTUAUBUCUEUFUGUIUJUKULUMUOUQURUSUTVBVAVDAUVDKCVHABCHJLMNOPRSTU
        AUBUCUEUFUGUJUKULUMUQURUSUTVAVCAYAXNWLUDUAUBWNRVKVQWMARSHUBUDUCUAUGUJUK
        AHLNTUEUFUTWOZUUEVEUUPVGVFWPWQZVBUUEWRWSZUVFVCWTXKWQZAUUTYFWIZUAUDQWBVJ
        RVKPVKJIGWBVJOVKWIZAUAJUDWJMVKZIWIUVIUVJWKVIABCGHJILMNOPQRSTUAUDUCUEUFU
        GUIUJUKULUMUOUQURUSUTVBVAVEAUVKICVIABCHJLMNOPRSTUAUDUCUEUFUGUJUKULUMUQU
        RUSUTVAVCAYAXOWLUBUAUDWNRVKVQWMARSHUBUDUCUAUGUJUKUVEVDUUHUUPVGVFXAWQZVB
        UUHWRWSZUVLVCWTXKWQZXBXLAYPXTPVKZYAPVKZYGWBYLABYGXPYQHLNPTXTYAUEURUFYRU
        UJULUVAUTUUQUURWHAUVOYJUVPYKYGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
        KULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIXCVCXBXLXDXLAYNYCPADXPQRSHUAUBUCUD
        UGUIUJUUJUKUVEUUPVFVGVDVEUHXEXFAEYGGOCBJKFIUMUOUPUVAUQABLNTUEULUTXGVAAB
        CHIJKLONPRSTUAUBUDUEURUFUGUKULUMUQUTVAVCUUPUUEUVGUVHUUHUVMUVNVFXHABCHKI
        LONPRSTUBUDUEURUFUGUKULUMUQUTUVGUVHUUEUUHUVMUVNVGXIABCHKLONPRSTUBUCFUEU
        RUFUGUKULUMUQUTUVGUVHUJUPVDXMABCHILONPRSTUDUCFUEURUFUGUKULUMUQUTUVMUVNU
        JUPVEXMUNXEXJ $.

      $( Lemma for ~ hdmap1l6 .  Part (6) in [Baer] p. 47, case 1.
         (Contributed by NM, 23-Apr-2015.) $)
      hdmap1l6a $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. ) =
            ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( co cotp cfv csn hdmap1l6lem2 oveq12d sneqd fveq2d eqtr4d hdmap1l6lem1
        wceq oveq2d wcel wne dvhlmod eldifad lmodvacl syl3anc lmodindp1 eldifsn
        clmod sylanbrc lcdlmod cpr wn dvhlvec lspindp2 simpld hdmap1cl lspindp1
        cdif wss clss lspprcl lspprvacl lspsnel5a lspsnel5 mtbid nssne2 syl2anc
        eqid necomd hdmap1eq mpbir2and ) AUAJUBUDDVJZVKMVLUAJUBVKMVLZUAJUDVKMVL
        ZEVJZVTXNVMRVLZPVLZXQVMZOVLZVTUAXNQVJVMRVLPVLZJXQGVJZVMZOVLZVTAXSKIEVJZ
        VMZOVLYAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAV
        BVCVDVEVFVGVHVIVNAXTYGOAXQYFAXOKXPIEVHVIVOZVPVQVRAYBJYFGVJZVMZOVLYEABCD
        EFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGV
        HVIVSAYDYJOAYCYIAXQYFJGYHWAVPVQVRABCGHJXQLMNOPQRSTUAXNUCUEUFUGUIUJUKULU
        MUOUQURUSUTVBVAAXNSWBZXNUCWCXNSUCVMZWTWBAHWJWBUBSWBUDSWBYKAHLNTUEUFUTWD
        ZAUBSYLVDWEZAUDSYLVEWEZDSHUBUDUGUHWFWGADRSHUBUDUCUGUHUJUKYMYNYOVGWHXNSU
        CWIWKABWJWBXOCWBXPCWBXQCWBABLNTUEULUTWLABCHJLMNOPRSTUAUBUCUEUFUGUJUKULU
        MUQURUSUTVAVCAUAVMRVLZUBVMRVLWCUDUAUBWMRVLWBWNARSHUBUDUCUAUGUJUKAHLNTUE
        UFUTWOZYNVEAUASYLVBWEZVGVFWPWQVBYNWRABCHJLMNOPRSTUAUDUCUEUFUGUJUKULUMUQ
        URUSUTVAVCAYPUDVMRVLWCUBUAUDWMRVLWBWNARSHUBUDUCUAUGUJUKYQVDYOYRVGVFWSWQ
        VBYOWRECBXOXPUMUNWFWGAXRYPAXRUBUDWMRVLZXAYPYSXAZWNXRYPWCAHXBVLZYSRHXNUU
        AXJZUKYMAUUARSHUBUDUGUUBUKYMYNYOXCZADRSHUBUDUGUHUKYMYNYOXDXEAUAYSWBYTVF
        AUUAYSRSHUAUGUUBUKYMUUCYRXFXGXRYPYSXHXIXKVCXLXM $.
    $}

    ${
      hdmap1l6b0.y $e |- ( ph -> Y e. V ) $.
      hdmap1l6b0.z $e |- ( ph -> Z e. V ) $.
      hdmap1l6b0.ne $e |- ( ph
            -> ( ( N ` { X } ) i^i ( N ` { Y , Z } ) ) = { .0. } ) $.
      $( Lemmma for ~ hdmap1l6 .  (Contributed by NM, 23-Apr-2015.)
         (New usage is discouraged.) $)
      hdmap1l6b0N $p |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $=
        ( cpr cfv wcel wn csn cin wceq clss eqid dvhlvec dvhlmod lspprcl mpbird
        lspdisjb ) ASTUBVEPVFZVGVHSVIPVFVSVJUAVIVKVDAHVLVFZVSPQHSUAUEUHUIVTVMZA
        HJLRUCUDURVNAVTPQHTUBUEWAUIAHJLRUCUDURVOVBVCVPUTVRVQ $.
    $}

    ${
      hdmap1l6b.y $e |- ( ph -> Y = .0. ) $.
      hdmap1l6b.z $e |- ( ph -> Z e. V ) $.
      hdmap1l6b.ne $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Lemmma for ~ hdmap1l6 .  (Contributed by NM, 24-Apr-2015.) $)
      hdmap1l6b $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
           = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv cgrp wcel wceq clmod lcdlmod lmodgrp syl csn dvhlvec eldifad
        co wne dvhlmod lmod0vcl eqeltrd lspindpi simprd hdmap1cl grplid syl2anc
        oteq3d fveq2d hdmap1val0 eqtrd oveq1d 3eqtr4rd ) AFSIUBVEZKVFZEVQZWNSIT
        VEZKVFZWNEVQSITUBDVQZVEZKVFABVGVHZWNCVHWOWNVIABVJVHWTABJLRUCUJURVKBVLVM
        ABCHIJKLMNPQRSUBUAUCUDUEUHUIUJUKUOUPUQURUSVAASVNPVFZTVNPVFVRXAUBVNPVFVR
        APQHSTUBUEUIAHJLRUCUDURVOASQUAVNUTVPZATUAQVBAHVJVHZUAQVHAHJLRUCUDURVSZQ
        HUAUEUHVTVMWAVCVDWBWCUTVCWDCEBWNFUKULUNWEWFAWQFWNEAWQSIUAVEZKVFFAWPXEKA
        TUASIVBWGWHABCFHIJKLQRSUAUCUDUEUHUJUKUNUQURUSXBWIWJWKAWSWMKAWRUBSIAWRUA
        UBDVQZUBATUAUBDVBWKAHVGVHZUBQVHXFUBVIAXCXGXDHVLVMVCQDHUBUAUEUFUHWEWFWJW
        GWHWL $.
    $}

    ${
      hdmap1l6c.y $e |- ( ph -> Y e. V ) $.
      hdmap1l6c.z $e |- ( ph -> Z = .0. ) $.
      hdmap1l6c.ne $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Lemmma for ~ hdmap1l6 .  (Contributed by NM, 24-Apr-2015.) $)
      hdmap1l6c $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
           = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv cgrp wcel wceq clmod lcdlmod lmodgrp syl csn dvhlvec eldifad
        co wne dvhlmod lmod0vcl eqeltrd lspindpi simpld hdmap1cl grprid syl2anc
        oteq3d fveq2d hdmap1val0 eqtrd oveq2d 3eqtr4rd ) ASITVEZKVFZFEVQZWNWNSI
        UBVEZKVFZEVQSITUBDVQZVEZKVFABVGVHZWNCVHWOWNVIABVJVHWTABJLRUCUJURVKBVLVM
        ABCHIJKLMNPQRSTUAUCUDUEUHUIUJUKUOUPUQURUSVAASVNPVFZTVNPVFVRXAUBVNPVFVRA
        PQHSTUBUEUIAHJLRUCUDURVOASQUAVNUTVPZVBAUBUAQVCAHVJVHZUAQVHAHJLRUCUDURVS
        ZQHUAUEUHVTVMWAVDWBWCUTVBWDCEBWNFUKULUNWEWFAWQFWNEAWQSIUAVEZKVFFAWPXEKA
        UBUASIVCWGWHABCFHIJKLQRSUAUCUDUEUHUJUKUNUQURUSXBWIWJWKAWSWMKAWRTSIAWRTU
        ADVQZTAUBUATDVCWKAHVGVHZTQVHXFTVIAXCXGXDHVLVMVBQDHTUAUEUFUHWEWFWJWGWHWL
        $.
    $}

    ${
      hdmap1l6d.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      hdmap1l6d.yz $e |- ( ph -> ( N ` { Y } ) = ( N ` { Z } ) ) $.
      $(
      hdmap1l6d.fg $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
      hdmap1l6d.fe $e |- ( ph -> ( I ` <. X , F , Z >. ) = E ) $.
      hdmap1l6d.fb $e |- ( ph -> ( I ` <. X , F , w >. ) = B ) $.
      $)
      hdmap1l6d.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      hdmap1l6d.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      hdmap1l6d.w $e |- ( ph -> w e. ( V \ { .0. } ) ) $.
      hdmap1l6d.wn $e |- ( ph -> -. w e. ( N ` { X , Y } ) ) $.
      $( Lemmma for ~ hdmap1l6 .  (Contributed by NM, 1-May-2015.) $)
      hdmap1l6d $p |- ( ph -> ( I ` <. X , F , ( w .+ ( Y .+ Z ) ) >. )
        = ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , ( Y .+ Z ) >. ) ) ) $=
        ( cv co cotp cfv wceq wa clmod lcdlmod csn wne dvhlvec eldifad lspindpi
        simpld necomd hdmap1cl lmod0vrid syl2anc adantr oteq3 fveq2d hdmap1val0
        wcel sylan9eqr oveq2d oveq2 dvhlmod 3eqtr4rd chlt cdif lmodvacl syl3anc
        oteq3d anim1i eldifsn sylibr cpr wn mapdindp1 mapdindp2 lspindp1 simprd
        lspsnne1 clsm eqid lsmpr csubg lspsncl lsssubg lsmidm 3eqtr2d neleqtrrd
        clss syl lspindp4 eqidd hdmap1l6a pm2.61dane ) ATJBVIZUAUCEVJZEVJZVKZLV
        LZTJYGVKZLVLZTJYHVKZLVLZFVJZVMYHUBAYHUBVMZVNZYMGFVJZYMYPYKAYSYMVMZYQACV
        OWKYMDWKYTACKMSUDUKUSVPACDIJKLMNOQRSTYGUBUDUEUFUIUJUKULUPUQURUSUTVBAYGV
        QQVLZTVQQVLZAUUAUUBVRZUUAUAVQQVLZVRZAQRIYGTUAUFUJAIKMSUDUEUSVSZAYGRUBVQ
        ZVGVTZATRUUGVAVTZAUARUUGVEVTZVHWAZWBWCVAUUHWDFDCYMGULUMUOWEWFWGYRYOGYMF
        YQAYOTJUBVKZLVLGYQYNUULLYHUBTJWHWIACDGIJKLMRSTUBUDUEUFUIUKULUOURUSUTUUI
        WJWLWMYRYJYLLYRYIYGTJYQAYIYGUBEVJZYGYHUBYGEWNAIVOWKZYGRWKUUMYGVMAIKMSUD
        UEUSWOZUUHERIYGUBUFUGUIWEWFWLXAWIWPAYHUBVRZVNZCDEFGHIYOJYMKLMNOPQRSTYGU
        BYHUDUEUFUGUHUIUJUKULUMUNUOUPUQURAMWQWKSKWKVNUUPUSWGAJDWKUUPUTWGATRUUGW
        RZWKUUPVAWGAUUBOVLJVQNVLVMUUPVBWGAYGUURWKUUPVGWGUUQYHRWKZUUPVNYHUURWKAU
        USUUPAUUNUARWKZUCRWKUUSUUOUUJAUCRUUGVFVTZERIUAUCUFUGWSWTZXBYHRUBXCXDATY
        GYHXEQVLWKXFZUUPAUUAYHVQQVLVRZUVCAQRITYHUBYGUFUIUJUUFVAUVBUUHABEQRITUAU
        BUCUFUGUIUJUUFVAVEVFVGVDAUUBUUDVRUUBUCVQQVLZVRAQRITUAUCUFUJUUFUUIUUJUVA
        VCWAWBZVHXGABEQRITUAUBUCUFUGUIUJUUFVAVEVFVGVDUVFVHXHXIXJWGAUVDUUPAUUEUV
        DAQRIYGUAYHUFUJUUFUUHUUJUVBAEQRIUAUCYGUFUGUJUUOUUJUVAUUHAUAUCXEQVLZUUDY
        GAQRIYGUAUBUFUIUJUUFVGUUJAUUCUUEUUKXJXKAUVGUUDUVEIXLVLZVJUUDUUDUVHVJZUU
        DAUVHQRIUAUCUFUJUVHXMZUUOUUJUVAXNAUUDUVEUUDUVHVDWMAUUDIXOVLWKZUVIUUDVMA
        UUNUUDIYAVLZWKZUVKUUOAUUNUUTUVMUUOUUJUVLQRIUAUFUVLXMZUJXPWFUVLUUDIUVNXQ
        WFUVHUUDIUVJXRYBXSXTYCWAXJWGUUQYMYDUUQYOYDYEYF $.

      $( Lemmma for ~ hdmap1l6 .  Part (6) in [Baer] p. 47 line 38.
         (Contributed by NM, 1-May-2015.) $)
      hdmap1l6e $p |- ( ph -> ( I ` <. X , F , ( ( w .+ Y ) .+ Z ) >. )
        = ( ( I ` <. X , F , ( w .+ Y ) >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cotp cfv cv co wcel wne cdif dvhlmod eldifad lmodvacl syl3anc dvhlvec
        clmod lspindpi simprd lmodindp1 eldifsn sylanbrc wn mapdindp3 mapdindp4
        csn simpld lspindp1 prcom fveq2i eleq2i sylnibr necomd eqidd hdmap1l6a
        cpr ) ACDEFGHITJUCVILVJZJTJBVKZUAEVLZVILVJZKLMNOPQRSTXCUBUCUDUEUFUGUHUI
        UJUKULUMUNUOUPUQURUSUTVAVBAXCRVMZXCUBVNXCRUBWJZVOVMAIWAVMXBRVMUARVMXEAI
        KMSUDUEUSVPZAXBRXFVGVQZAUARXFVEVQZERIXBUAUFUGVRVSZAEQRIXBUAUBUFUGUIUJXG
        XHXIAXBWJQVJZTWJQVJZVNXKUAWJQVJZVNAQRIXBTUAUFUJAIKMSUDUEUSVTZXHATRXFVAV
        QZXIVHWBWCWDXCRUBWEWFVFATUCXCWTZQVJZVMZTXCUCWTZQVJZVMAUCWJQVJZXCWJQVJZV
        NZXRWGAQRITXCUBUCUFUIUJXNVAXJAUCRXFVFVQZABEQRITUAUBUCUFUGUIUJXNVAVEVFVG
        VDAXLXMVNXLYAVNAQRITUAUCUFUJXNXOXIYDVCWBWKZVHWHABEQRITUAUBUCUFUGUIUJXNV
        AVEVFVGVDYEVHWIZWLWCXTXQTXSXPQXCUCWMWNWOWPAYAYBAYAXLVNYCAQRIUCTXCUFUJXN
        YDXOXJYFWBWCWQAXDWRAXAWRWS $.

      $( Lemmma for ~ hdmap1l6 .  Part (6) in [Baer] p. 47 line 38.
         (Contributed by NM, 1-May-2015.) $)
      hdmap1l6f $p |- ( ph -> ( I ` <. X , F , ( w .+ Y ) >. )
           = ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , Y >. ) ) ) $=
        ( cotp cfv cv csn wne cpr wcel dvhlvec eldifad lspindpi simpld lspindp1
        wn simprd eqidd hdmap1l6a ) ACDEFGHITJUAVILVJZJTJBVKZVILVJZKLMNOPQRSTWF
        UBUAUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVGVEAWFVLQVJZUAVLQVJZVMZTWFUA
        VNQVJVOWAAQRITUAUBWFUFUIUJAIKMSUDUEUSVPZVAAUARUBVLZVEVQZAWFRWLVGVQZATVL
        QVJZWIVMWOUCVLQVJVMAQRITUAUCUFUJWKATRWLVAVQZWMAUCRWLVFVQVCVRVSVHVTWBAWH
        WOVMWJAQRIWFTUAUFUJWKWNWPWMVHVRWBAWGWCAWEWCWD $.

      $( Lemmma for ~ hdmap1l6 .  Part (6) of [Baer] p. 47 line 39.
         (Contributed by NM, 1-May-2015.) $)
      hdmap1l6g $p |- ( ph
  -> ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , ( Y .+ Z ) >. ) )
           = ( ( ( I ` <. X , F , w >. ) .+b ( I ` <. X , F , Y >. ) )
               .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cv co cotp cfv hdmap1l6d hdmap1l6e clmod wcel dvhlmod eldifad lmodass
        wceq csn syl13anc oteq3d fveq2d hdmap1l6f oveq1d 3eqtr3d eqtr3d ) ATJBV
        IZUAUCEVJZEVJZVKZLVLZTJWIVKLVLZTJWJVKLVLFVJWNTJUAVKLVLFVJZTJUCVKLVLZFVJ
        ZABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVE
        VFVGVHVMATJWIUAEVJZUCEVJZVKZLVLTJWRVKLVLZWPFVJWMWQABCDEFGHIJKLMNOPQRSTU
        AUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVNAWTWLLAWSWKTJA
        IVOVPWIRVPUARVPUCRVPWSWKVTAIKMSUDUEUSVQAWIRUBWAZVGVRAUARXBVEVRAUCRXBVFV
        RERIWIUAUCUFUGVSWBWCWDAXAWOWPFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
        KULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHWEWFWGWH $.

      $( Lemmma for ~ hdmap1l6 .  Part (6) of [Baer] p. 48 line 2.
         (Contributed by NM, 1-May-2015.) $)
      hdmap1l6h $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
           = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( cv cotp cfv wceq hdmap1l6g clmod wcel lcdlmod csn wne dvhlvec eldifad
        lspindpi simpld necomd hdmap1cl simprd lmodass syl13anc eqtrd mapdindp1
        co wb dvhlmod lmodvacl syl3anc lmodlcan mpbid ) ATJBVIZVJLVKZTJUAUCEWJZ
        VJLVKZFWJZWRTJUAVJLVKZTJUCVJLVKZFWJZFWJZVLZWTXDVLZAXAWRXBFWJXCFWJZXEABC
        DEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVG
        VHVMACVNVOZWRDVOZXBDVOZXCDVOZXHXEVLACKMSUDUKUSVPZACDIJKLMNOQRSTWQUBUDUE
        UFUIUJUKULUPUQURUSUTVBAWQVQQVKZTVQQVKZAXNXOVRXNUAVQQVKZVRAQRIWQTUAUFUJA
        IKMSUDUEUSVSZAWQRUBVQZVGVTZATRXRVAVTZAUARXRVEVTZVHWAWBWCVAXSWDZACDIJKLM
        NOQRSTUAUBUDUEUFUIUJUKULUPUQURUSUTVBAXOXPVRZXOUCVQQVKVRZAQRITUAUCUFUJXQ
        XTYAAUCRXRVFVTZVCWAZWBZVAYAWDZACDIJKLMNOQRSTUCUBUDUEUFUIUJUKULUPUQURUSU
        TVBAYCYDYFWEVAYEWDZFDCWRXBXCULUMWFWGWHAXIWTDVOXDDVOZXJXFXGWKXMACDIJKLMN
        OQRSTWSUBUDUEUFUIUJUKULUPUQURUSUTVBABEQRITUAUBUCUFUGUIUJXQVAVEVFVGVDYGV
        HWIVAAIVNVOUARVOUCRVOWSRVOAIKMSUDUEUSWLYAYEERIUAUCUFUGWMWNWDAXIXKXLYJXM
        YHYIFDCXBXCULUMWMWNYBFDCWTXDWRULUMWOWGWP $.
    $}

    ${
      hdmap1l6i.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      hdmap1l6i.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
      hdmap1l6i.z $e |- ( ph -> Z e. ( V \ { .0. } ) ) $.
      ${
        $d w .+b $.  $d w F $.  $d w I $.  $d w N $.  $d w .+ $.  $d w U $.
        $d w V $.  $d w X $.  $d w Y $.  $d w Z $.  $d w ph $.
        hdmap1l6i.yz $e |- ( ph -> ( N ` { Y } ) = ( N ` { Z } ) ) $.
        $( Lemmma for ~ hdmap1l6 .  Eliminate auxiliary vector ` w ` .
           (Contributed by NM, 1-May-2015.) $)
        hdmap1l6i $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
             = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
          ( vw cv cpr cfv wcel wn wrex co cotp wceq csn eldifad dvh3dim chlt wa
          w3a 3ad2ant1 cdif clss clmod dvhlmod lspprcl simp2 lssneln0 hdmap1l6h
          eqid simp3 rexlimdv3a mpd ) AVFVGZSTVHPVIZVJVKZVFQVLSITUBDVMVNKVISITV
          NKVISIUBVNKVIEVMVOZAVFHJLPQRSTUCUDUEUIURASQUAVPZUTVQZATQWSVCVQZVRAWQW
          RVFQAWOQVJZWQWAZVFBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUP
          UQAXBLVSVJRJVJVTWQURWBAXBICVJWQUSWBAXBSQWSWCZVJWQUTWBAXBSVPPVINVIIVPM
          VIVOWQVAWBAXBSTUBVHPVIVJVKWQVBWBAXBTVPPVIUBVPPVIVOWQVEWBAXBTXDVJWQVCW
          BAXBUBXDVJWQVDWBXCHWDVIZWPQHWOUAUEUHXEWKZAXBHWEVJWQAHJLRUCUDURWFZWBAX
          BWPXEVJWQAXEPQHSTUEXFUIXGWTXAWGWBAXBWQWHAXBWQWLZWIXHWJWMWN $.
      $}

      $( Lemmma for ~ hdmap1l6 .  Eliminate ` ( N ` { Y } ) = ( N ` { Z } ) `
         hypothesis.  (Contributed by NM, 1-May-2015.) $)
      hdmap1l6j $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
             = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( co cotp cfv wceq csn wa chlt wcel adantr cdif cpr simpr hdmap1l6i wne
        wn eqidd hdmap1l6a pm2.61dane ) ASITUBDVEVFKVGSITVFKVGZSIUBVFKVGZEVEVHT
        VIPVGZUBVIPVGZAWEWFVHZVJBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
        UOUPUQALVKVLRJVLVJZWGURVMAICVLZWGUSVMASQUAVIVNZVLZWGUTVMASVIPVGNVGIVIMV
        GVHZWGVAVMASTUBVOPVGVLVSZWGVBVMATWJVLZWGVCVMAUBWJVLZWGVDVMAWGVPVQAWEWFV
        RZVJZBCDEFGHWDIWCJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQAWHWPURVM
        AWIWPUSVMAWKWPUTVMAWLWPVAVMAWNWPVCVMAWOWPVDVMAWMWPVBVMAWPVPWQWCVTWQWDVT
        WAWB $.
    $}

    ${
      hdmap1l6k.y $e |- ( ph -> Y e. V ) $.
      hdmap1l6k.z $e |- ( ph -> Z e. V ) $.
      hdmap1l6k.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
      $( Lemmma for ~ hdmap1l6 .  Eliminate nonzero vector requirement.
         (Contributed by NM, 1-May-2015.) $)
      hdmap1l6k $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
             = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
        ( co cotp cfv wceq wa chlt wcel adantr csn cdif cpr hdmap1l6b hdmap1l6c
        simpr wn wne simprl eldifsn sylanbrc simprr hdmap1l6j pm2.61da2ne ) ASI
        TUBDVEVFKVGSITVFKVGSIUBVFKVGEVEVHTUAUBUAATUAVHZVIBCDEFGHIJKLMNOPQRSTUAU
        BUCUDUEUFUGUHUIUJUKULUMUNUOUPUQALVJVKRJVKVIZWGURVLAICVKZWGUSVLASQUAVMVN
        ZVKZWGUTVLASVMPVGNVGIVMMVGVHZWGVAVLAWGVRAUBQVKZWGVCVLASTUBVOPVGVKVSZWGV
        DVLVPAUBUAVHZVIBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQAWH
        WOURVLAWIWOUSVLAWKWOUTVLAWLWOVAVLATQVKZWOVBVLAWOVRAWNWOVDVLVQATUAVTZUBU
        AVTZVIZVIZBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQAWHWSURV
        LAWIWSUSVLAWKWSUTVLAWLWSVAVLAWNWSVDVLWTWPWQTWJVKAWPWSVBVLAWQWRWATQUAWBW
        CWTWMWRUBWJVKAWMWSVCVLAWQWRWDUBQUAWBWCWEWF $.
    $}
  $}

  ${
    hdmap1-6.h $e |- H = ( LHyp ` K ) $.
    hdmap1-6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1-6.v $e |- V = ( Base ` U ) $.
    hdmap1-6.p $e |- .+ = ( +g ` U ) $.
    hdmap1-6.o $e |- .0. = ( 0g ` U ) $.
    hdmap1-6.n $e |- N = ( LSpan ` U ) $.
    hdmap1-6.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1-6.d $e |- D = ( Base ` C ) $.
    hdmap1-6.a $e |- .+b = ( +g ` C ) $.
    hdmap1-6.l $e |- L = ( LSpan ` C ) $.
    hdmap1-6.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1-6.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1-6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1-6.f $e |- ( ph -> F e. D ) $.
    hdmap1-6.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1-6.y $e |- ( ph -> Y e. V ) $.
    hdmap1-6.z $e |- ( ph -> Z e. V ) $.
    hdmap1-6.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    hdmap1-6.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
    $( Part (6) of [Baer] p. 47 line 6.  Note that we use
       ` -. X e. ( N `` { Y , Z } ) ` which is equivalent to Baer's "Fx ` i^i `
       (Fy + Fz)" by ~ lspdisjb .  (Contributed by NM, 17-May-2015.) $)
    hdmap1l6 $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
         = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
      ( c0g cfv csg eqid hdmap1l6k ) ABCDEBUSUTZBVAUTZFGHIJKLFVAUTZMNOPQRSTUAUB
      UCVFVBUDUEUFUGUHVEVBVDVBUIUJUKULUMUNURUOUPUQVC $.
  $}

  ${
    $d g .+b $.  $d g h w x C $.  $d g h w x D $.  $d g w F $.  $d g h w x L $.
    $d g h w x M $.  $d g h w x N $.  $d g w x .0. $.  $d g w .+ $.
    $d g h w x U $.  $d g V $.  $d g w X $.  $d g w Y $.  $d g w Z $.
    $d g ph $.
    hdmap1p6.h $e |- H = ( LHyp ` K ) $.
    hdmap1p6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1p6.v $e |- V = ( Base ` U ) $.
    hdmap1p6.p $e |- .+ = ( +g ` U ) $.
    hdmap1p6.o $e |- .0. = ( 0g ` U ) $.
    hdmap1p6.n $e |- N = ( LSpan ` U ) $.
    hdmap1p6.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1p6.d $e |- D = ( Base ` C ) $.
    hdmap1p6.a $e |- .+b = ( +g ` C ) $.
    hdmap1p6.l $e |- L = ( LSpan ` C ) $.
    hdmap1p6.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1p6.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1p6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1p6.f $e |- ( ph -> F e. D ) $.
    hdmap1p6.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1p6.y $e |- ( ph -> Y e. V ) $.
    hdmap1p6.z $e |- ( ph -> Z e. V ) $.
    hdmap1p6.xn $e |- ( ph -> -. X e. ( N ` { Y , Z } ) ) $.
    hdmap1p6.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
    $( (Convert ~ mapdh6N to use ` HDMap1 ` function.)  Part (6) of [Baer]
       p. 47 line 6.  Note that we use ` -. X e. ( N `` { Y , Z } ) ` which is
       equivalent to Baer's "Fx ` i^i ` (Fy + Fz)" by ~ lspdisjb .  TODO:  No
       longer used and should be deleted.  Use ~ hdmap1l6 instead.  Also delete
       unused ~ mapdh6N etc. leading up to this.  (Contributed by NM,
       17-May-2015.)  (New usage is discouraged.) $)
    hdmap1p6N $p |- ( ph -> ( I ` <. X , F , ( Y .+ Z ) >. )
         = ( ( I ` <. X , F , Y >. ) .+b ( I ` <. X , F , Z >. ) ) ) $=
      ( hdmap1l6 ) ABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUS
      $.
  $}

  ${
    $d h C $.  $d h x y z D $.  $d h x y z F $.  $d h x J $.  $d h x y z L $.
    $d h x M $.  $d h x y z N $.  $d h x y z .0. $.  $d x Q $.  $d h x R $.
    $d h x .- $.  $d h x y z T $.  $d h z U $.  $d h y z V $.  $d h x y z X $.
    $d h y z ph $.
    hdmap1eulem.h $e |- H = ( LHyp ` K ) $.
    hdmap1eulem.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1eulem.v $e |- V = ( Base ` U ) $.
    hdmap1eulem.s $e |- .- = ( -g ` U ) $.
    hdmap1eulem.o $e |- .0. = ( 0g ` U ) $.
    hdmap1eulem.n $e |- N = ( LSpan ` U ) $.
    hdmap1eulem.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1eulem.d $e |- D = ( Base ` C ) $.
    hdmap1eulem.r $e |- R = ( -g ` C ) $.
    hdmap1eulem.q $e |- Q = ( 0g ` C ) $.
    hdmap1eulem.j $e |- J = ( LSpan ` C ) $.
    hdmap1eulem.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1eulem.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1eulem.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1eulem.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( J ` { F } ) ) $.
    hdmap1eulem.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1eulem.f $e |- ( ph -> F e. D ) $.
    hdmap1eulem.y $e |- ( ph -> T e. V ) $.
    hdmap1eulem.l $e |- L = ( x e. _V |->
   if ( ( 2nd ` x ) = .0. , Q ,
      ( iota_ h e. D ( ( M ` ( N ` { ( 2nd ` x ) } ) ) = ( J ` { h } )
         /\ ( M ` ( N ` { ( ( 1st ` ( 1st ` x ) ) .- ( 2nd ` x ) ) } ) )
               = ( J ` { ( ( 2nd ` ( 1st ` x ) ) R h ) } ) ) ) ) ) $.
    $( Lemma for ~ hdmap1eu .  TODO: combine with ~ hdmap1eu or at least share
       some hypotheses.  (Contributed by NM, 15-May-2015.) $)
    hdmap1eulem $p |- ( ph -> E! y e. D A. z e. V (
     -. z e. ( ( N ` { X } ) u. ( N ` { T } ) )
       -> y = ( I ` <. z , ( I ` <. X , F , z >. ) , T >. ) ) ) $=
      ( cv csn cfv wcel wn cotp wceq wi wral wreu mapdh9a wa chlt ad2antrr cdif
      cun simplr hdmap1valc oteq2d fveq2d elun1 con3i clss eqid dvhlmod eldifad
      clmod lspsncl syl2anc simpr lssneln0 lspsnne2 necomd mapdhcl sylan2 eqtrd
      eqeq2d pm5.74da ralbidva reubidv mpbird ) ADVDZUCVETVFZIVETVFZVSVGZVHZCVD
      ZXEUCLXEVIZNVFZIVIZNVFZVJZVKZDUAVLZCFVMXIXJXEXKQVFZIVIZQVFZVJZVKZDUAVLZCF
      VMABCDEFGHIJKLMQOPRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVCURVAUSUTVBVNAXQYCC
      FAXPYBDUAAXEUAVGZVOZXIXOYAYEXIVOZXNXTXJYFXNXSNVFZXTYFXMXSNYFXLXRXEIYFBEFG
      HJKLMNOPQRSTUAUBUCXEUDUEUFUGUHUIUJUKULUMUNUOUPUQAPVPVGUBMVGVOZYDXIURVQAUC
      UAUDVEZVRVGZYDXIUTVQALFVGZYDXIVAVQAYDXIVTVCWAWBWCXIYEXEXFVGZVHZYGXTVJYLXH
      XEXFXGWDWEYEYMVOZBEFGHJKXRMNOPQRSTUAUBXEIUDUEUFUGUHUIUJUKULUMUNUOUPUQAYHY
      DYMURVQZYNJWFVFZXFUAJXEUDUGUIYPWGZAJWJVGZYDYMAJMPUBUEUFURWHVQZYNYRUCUAVGZ
      XFYPVGYSAYTYDYMAUCUAYIUTWIVQZYPTUAJUCUGYQUJWKWLAYDYMVTZYEYMWMZWNYNBEFGHJK
      LMQOPRSTUAUBUCXEUDUNVCUEUPUFUGUHUIUJUKULUMUOYOAYKYDYMVAVQAXFRVFLVEOVFVJYD
      YMUSVQAYJYDYMUTVQUUBYNXEVETVFXFYNTUAJXEUCUGUJYSUUBUUAUUCWOWPWQAIUAVGYDYMV
      BVQVCWAWRWSWTXAXBXCXD $.

    $( Lemma for ~ hdmap1euOLDN .  TODO: combine with ~ hdmap1euOLDN or at
       least share some hypotheses.  (Contributed by NM, 15-May-2015.)
       (New usage is discouraged.) $)
    hdmap1eulemOLDN $p |- ( ph -> E! y e. D A. z e. V (
     -. z e. ( N ` { X , T } )
       -> y = ( I ` <. z , ( I ` <. X , F , z >. ) , T >. ) ) ) $=
      ( cv cpr cfv wcel wn cotp wceq wi wral wreu mapdh9aOLDN chlt ad2antrr csn
      wa cdif simplr hdmap1valc oteq2 syl fveq2d clss eqid clmod dvhlmod eldifi
      lspprcl simpr lssneln0 clvec dvhlvec lspindpi simpld necomd mapdhcl eqtrd
      wne eqeq2d pm5.74da ralbidva reubidv mpbird ) ADVDZUCIVETVFZVGVHZCVDZXFUC
      LXFVIZNVFZIVIZNVFZVJZVKZDUAVLZCFVMXHXIXFXJQVFZIVIZQVFZVJZVKZDUAVLZCFVMABC
      DEFGHIJKLMQOPRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPVCURVAUSUTVBVNAXPYBCFAXOY
      ADUAAXFUAVGZVRZXHXNXTYDXHVRZXMXSXIYEXMXRNVFXSYEXLXRNYEXKXQVJXLXRVJYEBEFGH
      JKLMNOPQRSTUAUBUCXFUDUEUFUGUHUIUJUKULUMUNUOUPUQAPVOVGUBMVGVRYCXHURVPZAUCU
      AUDVQZVSVGZYCXHUTVPZALFVGYCXHVAVPZAYCXHVTZVCWAXKXQXFIWBWCWDYEBEFGHJKXQMNO
      PQRSTUAUBXFIUDUEUFUGUHUIUJUKULUMUNUOUPUQYFYEJWEVFZXGUAJXFUDUGUIYLWFZAJWGV
      GYCXHAJMPUBUEUFURWHZVPAXGYLVGYCXHAYLTUAJUCIUGYMUJYNAYHUCUAVGZUTUCUAYGWIWC
      ZVBWJVPYKYDXHWKZWLYEBEFGHJKLMQOPRSTUAUBUCXFUDUNVCUEUPUFUGUHUIUJUKULUMUOYF
      YJAUCVQTVFZRVFLVQOVFVJYCXHUSVPYIYKYEXFVQTVFZYRYEYSYRWTYSIVQTVFWTYETUAJXFU
      CIUGUJAJWMVGYCXHAJMPUBUEUFURWNVPYKAYOYCXHYPVPAIUAVGYCXHVBVPZYQWOWPWQWRYTV
      CWAWSXAXBXCXDXE $.
  $}

  ${
    $d g h w x y z C $.  $d g h w x y z D $.  $d g w y z F $.
    $d g h w x y z L $.  $d g h w x y z M $.  $d g h w x y z N $.
    $d g w x y z .0. $.  $d g w y z T $.  $d g h w x y z U $.  $d g y z V $.
    $d g w y z X $.  $d g y z ph $.
    hdmap1eu.h $e |- H = ( LHyp ` K ) $.
    hdmap1eu.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1eu.v $e |- V = ( Base ` U ) $.
    hdmap1eu.o $e |- .0. = ( 0g ` U ) $.
    hdmap1eu.n $e |- N = ( LSpan ` U ) $.
    hdmap1eu.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1eu.d $e |- D = ( Base ` C ) $.
    hdmap1eu.l $e |- L = ( LSpan ` C ) $.
    hdmap1eu.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1eu.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1eu.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1eu.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
    hdmap1eu.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1eu.f $e |- ( ph -> F e. D ) $.
    hdmap1eu.t $e |- ( ph -> T e. V ) $.
    $( Convert ~ mapdh9a to use the ` HDMap1 ` notation.  (Contributed by NM,
       15-May-2015.) $)
    hdmap1eu $p |- ( ph -> E! y e. D A. z e. V (
       -. z e. ( ( N ` { X } ) u. ( N ` { T } ) )
         -> y = ( I ` <. z , ( I ` <. X , F , z >. ) , T >. ) ) ) $=
      ( vw vg vx vh c0g cfv csg cvv cv c2nd wceq csn c1st co crio cif cmpt eqid
      wa hdmap1cbv hdmap1eulem ) AUNBCDEDURUSZDUTUSZFGUOHIJLKUPVAUPVBZVCUSZRVDV
      OVRVENUSMUSUQVBZVELUSVDVQVFUSZVFUSVRGUTUSZVGVENUSMUSVTVCUSVSVPVGVELUSVDVL
      UQEVHVIVJZMWANOPQRSTUAWAVKUBUCUDUEVPVKVOVKUFUGUHUIUJUKULUMUPUNEVOVPUQUOLW
      BMWANRWBVKVMVN $.

    $( Convert ~ mapdh9aOLDN to use the ` HDMap1 ` notation.  (Contributed by
       NM, 15-May-2015.)  (New usage is discouraged.) $)
    hdmap1euOLDN $p |- ( ph -> E! y e. D A. z e. V ( -. z e. ( N ` { X , T } )
       -> y = ( I ` <. z , ( I ` <. X , F , z >. ) , T >. ) ) ) $=
      ( vw vg vx vh c0g cfv csg cvv cv c2nd wceq csn c1st co crio cif cmpt eqid
      wa hdmap1cbv hdmap1eulemOLDN ) AUNBCDEDURUSZDUTUSZFGUOHIJLKUPVAUPVBZVCUSZ
      RVDVOVRVENUSMUSUQVBZVELUSVDVQVFUSZVFUSVRGUTUSZVGVENUSMUSVTVCUSVSVPVGVELUS
      VDVLUQEVHVIVJZMWANOPQRSTUAWAVKUBUCUDUEVPVKVOVKUFUGUHUIUJUKULUMUPUNEVOVPUQ
      UOLWBMWANRWBVKVMVN $.
  $}

  ${
    hdmap1neglem1.h $e |- H = ( LHyp ` K ) $.
    hdmap1neglem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap1neglem1.v $e |- V = ( Base ` U ) $.
    hdmap1neglem1.r $e |- R = ( invg ` U ) $.
    hdmap1neglem1.o $e |- .0. = ( 0g ` U ) $.
    hdmap1neglem1.n $e |- N = ( LSpan ` U ) $.
    hdmap1neglem1.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap1neglem1.d $e |- D = ( Base ` C ) $.
    hdmap1neglem1.s $e |- S = ( invg ` C ) $.
    hdmap1neglem1.l $e |- L = ( LSpan ` C ) $.
    hdmap1neglem1.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap1neglem1.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmap1neglem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap1neglem1.f $e |- ( ph -> F e. D ) $.
    hdmap1neglem1.mn $e |- ( ph -> ( M ` ( N ` { X } ) ) = ( L ` { F } ) ) $.
    hdmap1neglem1.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
    hdmap1neglem1.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap1neglem1.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    hdmap1neglem1.e $e |- ( ph -> ( I ` <. X , F , Y >. ) = G ) $.
    $( Lemma for ~ hdmapneg .  TODO:  Not used; delete.  (Contributed by NM,
       23-May-2015.)  (New usage is discouraged.) $)
    hdmap1neglem1N $p |- ( ph
       -> ( I ` <. ( R ` X ) , ( S ` F ) , ( R ` Y ) >. ) = ( S ` G ) ) $=
      ( cfv cotp wceq csn csg co eqid eldifad hdmap1cl eqeltrrd hdmap1eq simpld
      wa mpbid clmod wcel dvhlmod lspsnneg syl2anc fveq2d lcdlmod 3eqtr4d cabel
      simprd lmodabl syl ablsub2inv sneqd lspsnsub cgrp cdif lmodgrp grpinvnzcl
      eqtrd lmodvnegcl 3netr4d mpbir2and ) AQDUSZGEUSZRDUSZUTJUSHEUSZVAWRVBNUSZ
      MUSZWSVBLUSZVAWPWRFVCUSZVDZVBZNUSZMUSZWQWSBVCUSZVDZVBZLUSZVAARVBNUSZMUSZH
      VBLUSZXAXBAXMXNVAZQRXCVDVBNUSZMUSZGHXHVDVBLUSZVAZAQGRUTJUSZHVAXOXSVKURABC
      XHFGHIJKLMXCNOPQRSTUAUBXCVEZUDUEUFUGXHVEZUIUJUKULUPUMUQAXTHCURABCFGIJKLMN
      OPQRSTUAUBUDUEUFUGUIUJUKULUMUNUOUPAROSVBZUQVFZVGVHZUOUNVIVLZVJAWTXLMAFVMV
      NZROVNWTXLVAAFIKPTUAULVOZYDDNOFRUBUCUEVPVQZVRABVMVNZHCVNZXBXNVAABIKPTUFUL
      VSZYEELCBHUGUHUIVPVQVTAXQXRXGXKAXOXSYFWBAXFXPMAXFRQXCVDZVBZNUSXPAXEYNNAXD
      YMAOFXCDQRUBYAUCAYGFWAVNYHFWCWDAQOYCUPVFZYDWEWFVRAXCNOFRQUBYAUEYHYDYOWGWL
      VRAXKHGXHVDZVBZLUSXRAXJYQLAXIYPACBXHEGHUGYBUHAYJBWAVNYLBWCWDUMYEWEWFVRAXH
      LCBHGUGYBUIYLYEUMWGWLVTABCXHFWQWSIJKLMXCNOPWPWRSTUAUBYAUDUEUFUGYBUIUJUKUL
      AFWHVNZQOYCWIZVNWPYSVNAYGYRYHFWJWDZUPOFDQSUBUDUCWKVQAYJGCVNZWQCVNYLUMECBG
      UGUHWMVQAYRRYSVNWRYSVNYTUQOFDRSUBUDUCWKVQAYJYKWSCVNYLYEECBHUGUHWMVQAQVBNU
      SZXLWPVBNUSZWTUOAYGQOVNUUCUUBVAYHYODNOFQUBUCUEVPVQZYIWNAUUBMUSGVBLUSZUUCM
      USWQVBLUSZUNAUUCUUBMUUDVRAYJUUAUUFUUEVAYLUMELCBGUGUHUIVPVQVTVIWO $.
  $}

  ${
    $d k w H $.  $d a e i k t u v w y z K $.
    hdmapval.h $e |- H = ( LHyp ` K ) $.
    $( Map from vectors to functionals in the closed kernel dual space.
       (Contributed by NM, 15-May-2015.) $)
    hdmapffval $p |- ( K e. X -> ( HDMap ` K ) = ( w e. H |->
      { a | [. <. ( _I |` ( Base ` K ) ) ,
                 ( _I |` ( ( LTrn ` K ) ` w ) ) >. / e ].
            [. ( ( DVecH ` K ) ` w ) / u ].
            [. ( Base ` u ) / v ].
            [. ( ( HDMap1 ` K ) ` w ) / i ].
  a e. ( t e. v |->
      ( iota_ y e. ( Base ` ( ( LCDual ` K ) ` w ) )
         A. z e. v ( -. z e. ( ( ( LSpan ` u ) ` { e } )
                 u. ( ( LSpan ` u ) ` { t } ) )
           -> y = ( i ` <. z ,
                  ( i ` <. e , ( ( ( HVMap ` K ) ` w ) ` e ) , z >. ) ,
                  t >. ) ) ) ) } ) ) $=
      ( cfv cv wceq cbs wsbc cid fveq2 vk wcel cvv chdma csn clspn wn chvm cotp
      cun wi wral clcd crio cmpt chdma1 cdvh cres cltrn cop cab elex syl6eqr wb
      clh reseq2d fveq1d opeq12d dfsbcq syl fveq2d oteq2d eqeq2d imbi2d ralbidv
      riotaeqbidv mpteq2dv eleq2d sbcbidv bitrd mpteq12dv df-hdmap fvex eqeltri
      abbidv mptex fvmpt ) JKUBJUCUBJUDNCILOZFDOZBOZGOZUEEOZUFNZNFOZUEWMNUJUBUG
      ZAOZWJWKWKCOZJUHNZNZNZWJUIZHOZNZWNUIZXBNZPZUKZBWIULZAWQJUMNZNZQNZUNZUOZUB
      ZHWQJUPNZNZRZDWLQNZRZEWQJUQNZNZRZGSJQNZURZSWQJUSNZNZURZUTZRZLVAZUOZPJKVBU
      AJCUAOZVENZWHFWIWOWPWJWKWKWQYLUHNZNZNZWJUIZXBNZWNUIZXBNZPZUKZBWIULZAWQYLU
      MNZNZQNZUNZUOZUBZHWQYLUPNZNZRZDXRRZEWQYLUQNZNZRZGSYLQNZURZSWQYLUSNZNZURZU
      TZRZLVAZUOYKUCUDYLJPZCYMUVDIYJUVEYMJVENZIYLJVETMVCUVEUVCYILUVEUVCUUPGYHRZ
      YIUVEUVBYHPUVCUVGVDUVEUURYDUVAYGUVEUUQYCSYLJQTVFUVEUUTYFSUVEWQUUSYEYLJUST
      VGVFVHUUPGUVBYHVIVJUVEUUPYBGYHUVEUUPUUMEYARZYBUVEUUOYAPUUPUVHVDUVEWQUUNXT
      YLJUQTVGUUMEUUOYAVIVJUVEUUMXSEYAUVEUULXQDXRUVEUULUUIHXPRZXQUVEUUKXPPUULUV
      IVDUVEWQUUJXOYLJUPTVGUUIHUUKXPVIVJUVEUUIXNHXPUVEUUHXMWHUVEFWIUUGXLUVEUUCX
      HAUUFXKUVEUUEXJQUVEWQUUDXIYLJUMTVGVKUVEUUBXGBWIUVEUUAXFWOUVEYTXEWPUVEYSXD
      XBUVEYRXCWJWNUVEYQXAXBUVEYPWTWKWJUVEWKYOWSUVEWQYNWRYLJUHTVGVGVLVKVLVKVMVN
      VOVPVQVRVSVTVSVSVTVSVTWEWAABCDEFGHUALWBCIYJIUVFUCMJVEWCWDWFWGVJ $.

    $d a e u v w y D $.  $d a e t u v w y z E $.  $d a e i t u v w y z I $.
    $d a e u v w J $.  $d a e u v w N $.  $d t y z U $.
    $d a e t u v w y z V $.  $d a e i t u v w y z W $.
    hdmapfval.e $e |- E = <. ( _I |` ( Base ` K ) ) ,
                 ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapfval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapfval.v $e |- V = ( Base ` U ) $.
    hdmapfval.n $e |- N = ( LSpan ` U ) $.
    hdmapfval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapfval.d $e |- D = ( Base ` C ) $.
    hdmapfval.j $e |- J = ( ( HVMap ` K ) ` W ) $.
    hdmapfval.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmapfval.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapfval.k $e |- ( ph -> ( K e. A /\ W e. H ) ) $.
    $( Map from vectors to functionals in the closed kernel dual space.
       (Contributed by NM, 15-May-2015.) $)
    hdmapfval $p |- ( ph -> S = ( t e. V |->
      ( iota_ y e. D A. z e. V ( -. z e. ( ( N ` { E } ) u. ( N ` { t } ) ) ->
          y = ( I ` <. z , ( I ` <. E , ( J ` E ) , z >. ) , t >. ) ) ) ) ) $=
      ( vw va vv ve vu vi wcel wa cv csn cfv cun wn cotp wceq wi wral crio cmpt
      clspn chvm clcd cbs chdma1 wsbc cdvh cid cres cltrn cop hdmapffval fveq1d
      cab chdma syl5eq wb reseq2d opeq2d dfsbcq syl fveq2d oteq2d eqeq2d imbi2d
      fveq2 ralbidv riotaeqbidv mpteq2dv eleq2d sbcbidv bitrd opex fvex syl6eqr
      w3a simp1 simp2 simp3 eqtrd fveq1 riotabidv sbcie fveq2i eqtr2i a1i sneqd
      id fveq12d uneq12d notbid oteq1d fveq1i raleqbidv mpteq12dv syl5bb sbc3ie
      imbi12d syl3anc syl6bb abbi1dv eqid cvv eqeltri mptex fvmpt sylan9eq ) AN
      EUOZQKUOZUPHDPCUQZJURZOUSZDUQZURZOUSZUTZUOZVAZBUQZYQJJMUSZYQVBZLUSZYTVBZL
      USZVCZVDZCPVEZBGVFZVGZVCUHYOYPHQUIKUJUQZDUKUQZYQULUQZURZUMUQZVHUSZUSZUUAU
      VBUSZUTZUOZVAZUUFYQUUSUUSUIUQZNVIUSZUSZUSZYQVBZUNUQZUSZYTVBZUVMUSZVCZVDZC
      UURVEZBUVHNVJUSZUSZVKUSZVFZVGZUOZUNUVHNVLUSZUSZVMZUKUVAVKUSZVMZUMUVHNVNUS
      ZUSZVMZULVONVKUSVPZVOUVHNVQUSZUSZVPZVRZVMZUJWAZVGZUSZUUPYOHQNWBUSZUSUXBUG
      YOQUXCUXABCUIUKUMDULUNKNEUJRVSVTWCUIQUWTUUPKUXAUVHQVCZUWSUJUUPUXDUWSUUQDU
      URUVGUUFYQUUSUUSQUVIUSZUSZYQVBZUVMUSZYTVBZUVMUSZVCZVDZCUURVEZBQUVTUSZVKUS
      ZVFZVGZUOZUNQUWFUSZVMZUKUWIVMZUMQUWKUSZVMZULUWNVOQUWOUSZVPZVRZVMZUUQUUPUO
      ZUXDUWSUWMULUYFVMZUYGUXDUWRUYFVCUWSUYIWDUXDUWQUYEUWNUXDUWPUYDVOUVHQUWOWMW
      EWFUWMULUWRUYFWGWHUXDUWMUYCULUYFUXDUWMUWJUMUYBVMZUYCUXDUWLUYBVCUWMUYJWDUV
      HQUWKWMUWJUMUWLUYBWGWHUXDUWJUYAUMUYBUXDUWHUXTUKUWIUXDUWHUWEUNUXSVMZUXTUXD
      UWGUXSVCUWHUYKWDUVHQUWFWMUWEUNUWGUXSWGWHUXDUWEUXRUNUXSUXDUWDUXQUUQUXDDUUR
      UWCUXPUXDUVSUXMBUWBUXOUXDUWAUXNVKUVHQUVTWMWIUXDUVRUXLCUURUXDUVQUXKUVGUXDU
      VPUXJUUFUXDUVOUXIUVMUXDUVNUXHYQYTUXDUVLUXGUVMUXDUVKUXFUUSYQUXDUUSUVJUXEUV
      HQUVIWMVTWJWIWJWIWKWLWNWOWPWQWRWSWRWRWSWRWSUXTUYHULUMUKUYFUYBUWIUWNUYEWTQ
      UWKXAUVAVKXAUUSUYFVCZUVAUYBVCZUURUWIVCZXCZUUSJVCZUVAIVCZUURPVCZUXTUYHWDUY
      OUUSUYFJUYLUYMUYNXDSXBUYOUVAUYBIUYLUYMUYNXETXBZUYOUURIVKUSZPUYOUURUWIUYTU
      YLUYMUYNXFUYOUVAIVKUYSWIXGUAXBUXTUUQDUURUVGUUFYQUXGLUSZYTVBZLUSZVCZVDZCUU
      RVEZBUXOVFZVGZUOZUYPUYQUYRXCZUYHUXRVUIUNUXSQUWFXAUVMUXSVCZUVMLVCZUXRVUIWD
      VUKUVMUXSLVUKXOUFXBVULUXQVUHUUQVULDUURUXPVUGVULUXMVUFBUXOVULUXLVUECUURVUL
      UXKVUDUVGVULUXJVUCUUFVULUXJUXILUSVUCUXIUVMLXHVULUXIVUBLVULUXHVUAYQYTUXGUV
      MLXHWJWIXGWKWLWNXIWPWQWHXJVUJVUHUUPUUQVUJDUURVUGPUUOUYPUYQUYRXFZVUJVUFUUN
      BUXOGUXOGVCVUJGFVKUSUXOUDFUXNVKUCXKXLXMVUJVUEUUMCUURPVUMVUJUVGUUEVUDUULVU
      JUVFUUDVUJUVEUUCYQVUJUVCYSUVDUUBVUJUUTYRUVBOVUJUVBIVHUSOVUJUVAIVHUYPUYQUY
      RXEWIUBXBZVUJUUSJUYPUYQUYRXDZXNXPVUJUUAUVBOVUNVTXQWQXRVUJVUCUUKUUFVUJVUBU
      UJLVUJVUAUUIYQYTVUJUXGUUHLVUJUXGJUXFYQVBUUHVUJUUSJUXFYQVUOXSVUJUXFUUGJYQV
      UJUXFJUXEUSUUGVUJUUSJUXEVUOWIJMUXEUEXTXBWJXGWIWJWIWKYEYAWOYBWQYCYFYDYGYHU
      XAYIDPUUOPUYTYJUAIVKXAYKYLYMYNWH $.

    $d t D $.  $d t J $.  $d t N $.  $d t y z T $.
    hdmapval.t $e |- ( ph -> T e. V ) $.
    $( Value of map from vectors to functionals in the closed kernel dual
       space.  This is the function sigma on line 27 above part 9 in [Baer]
       p. 48.  We select a convenient fixed reference vector ` E ` to be
       ` <. 0 , 1 >. ` (corresponding to vector u on p. 48 line 7) whose span
       is the lattice isomorphism map of the fiducial atom
       ` P = ( ( oc `` K ) `` W ) ` (see ~ dvheveccl ). ` ( J `` E ) ` is a
       fixed reference functional determined by this vector (corresponding to
       u' on line 8; ~ mapdhvmap shows in Baer's notation (Fu)* = Gu').  Baer's
       independent vectors v and w on line 7 correspond to our ` z ` that the
       ` A. z e. V ` ranges over.  The middle term
       ` ( I `` <. E , ( J `` E ) , z >. ) ` provides isolation to allow ` E `
       and ` T ` to assume the same value without conflict.  Closure is shown
       by ~ hdmapcl .  If a separate auxiliary vector is known, ~ hdmapval2
       provides a version without quantification.  (Contributed by NM,
       15-May-2015.) $)
    hdmapval $p |- ( ph -> ( S ` T )
     = ( iota_ y e. D A. z e. V ( -. z e. ( ( N ` { E } ) u. ( N ` { T } ) ) ->
          y = ( I ` <. z , ( I ` <. E , ( J ` E ) , z >. ) , T >. ) ) ) ) $=
      ( vt cfv cv csn cun wcel wn cotp wceq wral crio cmpt hdmapfval fveq1d cvv
      riotaex sneq fveq2d uneq2d eleq2d notbid eqeq2d imbi12d ralbidv riotabidv
      wi oteq3 eqid fvmptg sylancl eqtrd ) AHGUKHUJPCULZJUMOUKZUJULZUMZOUKZUNZU
      OZUPZBULZWAJJMUKWAUQLUKZWCUQZLUKZURZVOZCPUSZBFUTZVAZUKZWAWBHUMZOUKZUNZUOZ
      UPZWIWAWJHUQZLUKZURZVOZCPUSZBFUTZAHGWQABCUJDEFGIJKLMNOPQRSTUAUBUCUDUEUFUG
      UHVBVCAHPUOXIVDUOWRXIURUIXHBFVEUJHWPXIPVDWQWCHURZWOXHBFXJWNXGCPXJWHXCWMXF
      XJWGXBXJWFXAWAXJWEWTWBXJWDWSOWCHVFVGVHVIVJXJWLXEWIXJWKXDLWCHWAWJVPVGVKVLV
      MVNWQVQVRVSVT $.
  $}

  ${
    $d t y z K $.  $d t y z U $.  $d t y z V $.  $d t y z W $.
    hdmapfn.h $e |- H = ( LHyp ` K ) $.
    hdmapfn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapfn.v $e |- V = ( Base ` U ) $.
    hdmapfn.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapfn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Functionality of map from vectors to functionals with closed kernels.
       (Contributed by NM, 30-May-2015.)  (New usage is discouraged.) $)
    hdmapfnN $p |- ( ph -> S Fn V ) $=
      ( vt vz vy wfn cv cid cfv eqid cbs cres cltrn cop csn clspn cun wcel chvm
      cotp chdma1 wceq wral clcd crio cmpt riotaex fnmpti chlt hdmapfval fneq1d
      wn wi mpbiri ) ABFPMFNQZREUASUBRGEUCSSUBUDZUECUFSZSMQZUEVGSUGUHVBOQVEVFVF
      GEUISSZSVEUJGEUKSSZSVHUJVJSULVCNFUMZOGEUNSSZUASZUOZUPZFPMFVNVOVKOVMUQVOTU
      RAFBVOAONMUSVLVMBCVFDVJVIEVGFGHVFTIJVGTVLTVMTVITVJTKLUTVAVD $.
  $}

  ${
    $d h y C $.  $d h y D $.  $d h y K $.  $d h y T $.  $d h y U $.
    $d h y V $.  $d h y W $.  $d h y ph $.
    hdmapcl.h $e |- H = ( LHyp ` K ) $.
    hdmapcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapcl.v $e |- V = ( Base ` U ) $.
    hdmapcl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapcl.d $e |- D = ( Base ` C ) $.
    hdmapcl.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapcl.t $e |- ( ph -> T e. V ) $.
    $( Closure of map from vectors to functionals with closed kernels.
       (Contributed by NM, 15-May-2015.) $)
    hdmapcl $p |- ( ph -> ( S ` T ) e. D ) $=
      ( cfv eqid vy vh cv cid cbs cres cltrn cop csn clspn cun wcel chvm chdma1
      wn cotp wceq wi wral crio chlt hdmapval wreu cmpd c0g dvheveccl mapdhvmap
      hvmapcl2 eldifad hdmap1eu riotacl syl eqeltrd ) AEDSUAUCZUDHUESZUFUDJHUGS
      SZUFUHZUIFUJSZSEUIVRSUKULUOUBUCVNVQVQJHUMSSZSZVNUPJHUNSSZSEUPWASUQURUAIUS
      ZUBCUTZCAUBUAVABCDEFVQGWAVSHVRIJKVQTZLMVRTZNOVSTZWATZPQRVBAWBUBCVCWCCULAU
      BUABCEFVTGWAHBUJSZJHVDSSZVRIJVQFVESZKLMWJTZWENOWHTZWITZWGQABVSFGWHHWIVRIJ
      VQWJKLMWKWENWLWMWFQAVOVPFVQGHIJWJKVOTVPTLMWKWDQVFZVGWNAVTCBVESZUIABFCGHVS
      WOIJVQWJKLMWKNOWOTWFQWNVHVIRVJWBUBCVKVLVM $.
  $}

  ${
    $d h z C $.  $d h w z D $.  $d h w z E $.  $d h w z F $.  $d h w z I $.
    $d h w z J $.  $d h z K $.  $d h w z N $.  $d h w z T $.  $d h z U $.
    $d h w z V $.  $d h z W $.  $d h w z ph $.
    hdmapval2.h $e |- H = ( LHyp ` K ) $.
    hdmapval2.e $e |- E
          = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapval2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapval2.v $e |- V = ( Base ` U ) $.
    hdmapval2.n $e |- N = ( LSpan ` U ) $.
    hdmapval2.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapval2.d $e |- D = ( Base ` C ) $.
    hdmapval2.j $e |- J = ( ( HVMap ` K ) ` W ) $.
    hdmapval2.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmapval2.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapval2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapval2.t $e |- ( ph -> T e. V ) $.
    ${
      hdmapval2.f $e |- ( ph -> F e. D ) $.
      $( Lemma for ~ hdmapval2 .  (Contributed by NM, 15-May-2015.) $)
      hdmapval2lem $p |- ( ph -> ( ( S ` T ) = F <->
         A. z e. V ( -. z e. ( ( N ` { E } ) u. ( N ` { T } ) ) ->
            F = ( I ` <. z , ( I ` <. E , ( J ` E ) , z >. ) , T >. ) ) ) ) $=
        ( vh cfv wceq cv csn cun wcel wn cotp wi wral crio chlt hdmapval eqeq1d
        wreu clspn cmpd c0g eqid cbs cltrn dvheveccl mapdhvmap hvmapcl2 eldifad
        wb hdmap1eu nfv nfcvd eqeq1 imbi2d ralbidv adantl riota2df mpdan bitr4d
        nfvd ) AFEUKZIULBUMZHUNNUKFUNNUKUOUPUQZUJUMZWIHHLUKZWIURKUKFURKUKZULZUS
        ZBOUTZUJDVAZIULZWJIWMULZUSZBOUTZAWHWQIAUJBVBCDEFGHJKLMNOPQRSTUAUBUCUDUE
        UFUGUHVCVDAWPUJDVEXAWRVPAUJBCDFGWLJKMCVFUKZPMVGUKUKZNOPHGVHUKZQSTXDVIZU
        AUBUCXBVIZXCVIZUEUGACLGJXBMXCNOPHXDQSTXEUAUBXFXGUDUGAMVJUKZPMVKUKUKZGHJ
        MOPXDQXHVIXIVISTXERUGVLZVMXJAWLDCVHUKZUNACGDJMLXKOPHXDQSTXEUBUCXKVIUDUG
        XJVNVOUHVQAWPXAUJDIAUJVRAUJIVSAXAUJWGUIWKIULZWPXAVPAXLWOWTBOXLWNWSWJWKI
        WMVTWAWBWCWDWEWF $.
    $}

    $d z S $.  $d z X $.
    hdmapval2.x $e |- ( ph -> X e. V ) $.
    hdmapval2.ne $e |- ( ph -> -. X e. ( ( N ` { E } ) u. ( N ` { T } ) ) ) $.
    $( Value of map from vectors to functionals with a specific auxiliary
       vector.  TODO:  Would shorter proofs result if the .ne hypothesis were
       changed to two ` =/= ` hypothesis?  Consider ~ hdmaplem1 through
       ~ hdmaplem4 , which would become obsolete.  (Contributed by NM,
       15-May-2015.) $)
    hdmapval2 $p |- ( ph
   -> ( S ` T ) = ( I ` <. X , ( I ` <. E , ( J ` E ) , X >. ) , T >. ) ) $=
      ( vz cv csn cfv cun wcel wn cotp wceq wi eqidd hdmapcl hdmapval2lem mpbid
      eleq1 notbid oteq1 oteq3 fveq2d oteq2d eqtrd eqeq2d imbi12d rspccv syl3c
      wral ) AUJUKZGULLUMEULLUMUNZUOZUPZEDUMZVPGGJUMZVPUQZIUMZEUQZIUMZURZUSZUJM
      VOZOMUOOVQUOZUPZVTOGWAOUQZIUMZEUQZIUMZURZAVTVTURWHAVTUTAUJBCDEFGVTHIJKLMN
      PQRSTUAUBUCUDUEUFUGABCDEFHKMNPRSUAUBUEUFUGVAVBVCUHUIWGWJWOUSUJOMVPOURZVSW
      JWFWOWPVRWIVPOVQVDVEWPWEWNVTWPWDWMIWPWDOWCEUQWMVPOWCEVFWPWCWLOEWPWBWKIVPO
      GWAVGVHVIVJVHVKVLVMVN $.
  $}

  ${
    $d x K $.  $d x .0. $.  $d x Q $.  $d x S $.  $d x U $.  $d x W $.
    $d x ph $.
    hdmapval0.h $e |- H = ( LHyp ` K ) $.
    hdmapval0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapval0.o $e |- .0. = ( 0g ` U ) $.
    hdmapval0.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapval0.q $e |- Q = ( 0g ` C ) $.
    hdmapval0.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapval0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Value of map from vectors to functionals at zero.  Note: we use
       ~ dvh3dim for convenience, even though 3 dimensions aren't necessary at
       this point.  TODO:  I think either this or ~ hdmapeq0 could be derived
       from the other to shorten proof.  (Contributed by NM, 17-May-2015.) $)
    hdmapval0 $p |- ( ph -> ( S ` .0. ) = Q ) $=
      ( cfv wcel eqid 3ad2ant1 vx cv cid cbs cres cltrn cop cpr clspn wrex wceq
      wn csn dvheveccl eldifad clmod dvhlmod lmod0vcl syl dvh3dim w3a chvm cotp
      chdma1 chlt wa simp2 cun wi clss lspprid1 lspsnel5a lspprid2 unssd ssneld
      lspprcl adantr 3impia hdmapval2 cmpd hvmapcl2 mapdhvmap wne clvec dvhlvec
      simp3 lspindpi simpld necomd cdif hdmap1cl hdmap1val0 eqtrd rexlimdv3a
      mpd ) AUAUBZUCGUDQZUEUCHGUFQQZUEUGZIUHEUIQZQZRULZUAEUDQZUJIDQZCUKZAUAEFGW
      TXCHWSIJKXCSZWTSZPAWSXCIUMZAWQWREWSFGXCHIJWQSWRSKXFLWSSZPUNZUOZAEUPRIXCRZ
      AEFGHJKPUQZXCEIXFLURUSZUTAXBXEUAXCAWPXCRZXBVAZXDWPWSWSHGVBQQZQZWPVCHGVDQQ
      ZQZIVCXSQCXPBBUDQZDIEWSFXSXQGWTXCHWPJXIKXFXGMYASZXQSZXSSZOAXOGVERHFRVFXBP
      TZAXOXLXBXNTZAXOXBVGZAXOXBWPWSUMWTQZXHWTQZVHZRULZAXBYKVIXOAYJXAWPAYHYIXAA
      EVJQZXAWTEWSYLSZXGXMAYLWTXCEWSIXFYMXGXMXKXNVPZAWTXCEWSIXFXGXMXKXNVKVLAYLX
      AWTEIYMXGXMYNAWTXCEWSIXFXGXMXKXNVMVLVNVOVQVRVSXPBYACEXTFXSGXCHWPIJKXFLMYB
      NYDYEXPBYAEXRFXSGBUIQZHGVTQQZWTXCHWSWPIJKXFLXGMYBYOSZYPSZYDYEAXOXRYARXBAX
      RYACUMABEYAFGXQCXCHWSIJKXFLMYBNYCPXJWAUOTAXOYHYPQXRUMYOQUKXBABXQEFYOGYPWT
      XCHWSIJKXFLXGMYQYRYCPXJWBTXPWPUMWTQZYHXPYSYHWCYSYIWCXPWTXCEWPWSIXFXGAXOEW
      DRXBAEFGHJKPWETYGAXOWSXCRXBXKTYFAXOXBWFWGWHWIAXOWSXCXHWJRXBXJTYGWKYGWLWMW
      NWO $.
  $}

  ${
    hdmapevec.h $e |- H = ( LHyp ` K ) $.
    hdmapevec.e $e |- E
          = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapevec.j $e |- J = ( ( HVMap ` K ) ` W ) $.
    hdmapevec.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapevec.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hdmapevec.u $e |- U = ( ( DVecH ` K ) ` W ) $.
      hdmapevec.v $e |- V = ( Base ` U ) $.
      hdmapevec.n $e |- N = ( LSpan ` U ) $.
      hdmapevec.c $e |- C = ( ( LCDual ` K ) ` W ) $.
      hdmapevec.d $e |- D = ( Base ` C ) $.
      hdmapevec.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
      hdmapevec.x $e |- ( ph -> X e. V ) $.
      hdmapevec.ne $e |- ( ph
         -> -. X e. ( ( N ` { E } ) u. ( N ` { E } ) ) ) $.
      $( Lemma for ~ hdmapevec .  TODO: combine with ~ hdmapevec if it shortens
         overall.  (Contributed by NM, 16-May-2015.) $)
      hdmapeveclem $p |- ( ph -> ( S ` E ) = ( J ` E ) ) $=
        ( cfv cotp c0g csn cbs cltrn dvheveccl eldifad hdmapval2 clspn hvmapcl2
        eqid mapdhvmap dvhlmod hdmaplem1 necomd hdmaplem3 eqidd hdmap1eq2 eqtrd
        cmpd ) AFDUHNFFIUHZNUIHUHZFUIHUHVIABCDFEFGHIJKLMNOPTUAUBUCUDQUERSAFLEUJ
        UHZUKAJULUHZMJUMUHUHZEFGJLMVKOVLUSVMUSTUAVKUSZPSUNZUOZUFUGUPABCEVIVJGHJ
        BUQUHZMJVHUHUHZKLMFNVKOTUAVNUBUCUDVQUSZVRUSZUESAVICBUJUHZUKABECGJIWALMF
        VKOTUAVNUCUDWAUSQSVOURUOABIEGVQJVRKLMFVKOTUAVNUBUCVSVTQSVOUTANUKKUHFUKK
        UHAKLEFFNUAUBAEGJMOTSVAZUFUGVPVBVCVOAKLEFFVKNUAUBWBUFUGVPVNVDAVJVEVFVG
        $.
    $}

    $d z E $.  $d z J $.  $d z K $.  $d z S $.  $d z W $.  $d z ph $.
    $( Value of map from vectors to functionals at the reference vector
       ` E ` .  (Contributed by NM, 16-May-2015.) $)
    hdmapevec $p |- ( ph -> ( S ` E ) = ( J ` E ) ) $=
      ( vz cv csn cfv wcel wn cbs eqid cdvh clspn wrex wceq c0g cltrn dvheveccl
      eldifad dvh2dim w3a clcd chdma1 chlt 3ad2ant1 simp2 cun unssi sseli con3i
      wa ssid 3ad2ant3 hdmapeveclem rexlimdv3a mpd ) AMNZCOGFUAPPZUBPZPZQZRZMVG
      SPZUCCBPCEPUDZAMVGDFVHVLGCHVGTZVLTZVHTZLACVLVGUEPZOAFSPZGFUFPPZVGCDFVLGVQ
      HVRTVSTVNVOVQTILUGUHUIAVKVMMVLAVFVLQZVKUJGFUKPPZWASPZBVGCDGFULPPZEFVHVLGV
      FHIJKAVTFUMQGDQUTVKLUNVNVOVPWATWBTWCTAVTVKUOVKAVFVIVIUPZQZRVTWEVJWDVIVFVI
      VIVIVIVAZWFUQURUSVBVCVDVE $.

    $d k v w E $.  $d k w .1. $.  $d k v w K $.  $d k v R $.  $d k v w U $.
    $d k v w W $.
    hdmapevec2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapevec2.r $e |- R = ( Scalar ` U ) $.
    hdmapevec2.i $e |- .1. = ( 1r ` R ) $.
    $( The inner product of the reference vector ` E ` with itself is nonzero.
       This shows the inner product condition in the proof of Theorem 3.6 of
       [Holland95] p. 14 line 32, ` [ ` e , e ` ] =/= 0 ` is satisfied.  TODO:
       remove redundant hypothesis hdmapevec.j.  (Contributed by NM,
       1-Jun-2015.) $)
    hdmapevec2 $p |- ( ph -> ( ( S ` E ) ` E ) = .1. ) $=
      ( cfv eqid vv vw vk cbs cv cvsca cplusg wceq csn coch wrex crio hdmapevec
      co cmpt chlt c0g cltrn dvheveccl hvmapval eqtrd fveq1d dochfl1 ) AFFCSZSF
      UADUDSZUAUEUBUEUCUEFDUFSZUNDUGSZUNUHUBFUIJIUJSSZSUKUCBUDSZULUOZSEAFVDVJAV
      DFHSVJACFGHIJKLMNOUMAUAUBUPVGVIBVFDUCGIHVHVEJFDUQSZKPVHTZVETZVGTZVFTZVKTZ
      QVITZMOAIUDSZJIURSSZDFGIVEJVKKVRTVSTPVMVPLOUSZUTVAVBAUBUABVGVIVFDEUCVJGIV
      HVEJFVKKVLPVMVNVOVPQVQROVTVJTVCVA $.
  $}

  ${
    hdmapval3.h $e |- H = ( LHyp ` K ) $.
    hdmapval3.e $e |- E
          = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapval3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapval3.v $e |- V = ( Base ` U ) $.
    hdmapval3.n $e |- N = ( LSpan ` U ) $.
    hdmapval3.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapval3.d $e |- D = ( Base ` C ) $.
    hdmapval3.j $e |- J = ( ( HVMap ` K ) ` W ) $.
    hdmapval3.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
    hdmapval3.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapval3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapval3.te $e |- ( ph -> ( N ` { T } ) =/= ( N ` { E } ) ) $.
    ${
      hdmapval3lem.t $e |- ( ph -> T e. ( V \ { ( 0g ` U ) } ) ) $.
      hdmapval3lem.x $e |- ( ph -> x e. V ) $.
      hdmapval3lem.xn $e |- ( ph -> -. x e. ( N ` { E , T } ) ) $.
      $( Value of map from vectors to functionals at arguments not colinear
         with the reference vector ` E ` .  (Contributed by NM, 17-May-2015.)
         (New usage is discouraged.) $)
      hdmapval3lemN $p |- ( ph
              -> ( S ` T ) = ( I ` <. E , ( J ` E ) , T >. ) ) $=
        ( cfv cotp clspn cmpd c0g eqid csn cbs cltrn dvheveccl hvmapcl2 eldifad
        cv mapdhvmap wne dvhlvec lspindpi simpld necomd hdmap1cl wceq csg co wa
        eqidd clss cpr dvhlmod lspprcl lssneln0 hdmap1eq cun lspprid1 lspsnel5a
        mpbid ssneldd hdmapval2 hdmapevec eqtr3d lspprid2 eqcomd hdmap1eq4N
        unssd ) AHHKUKZFULJUKFEUKZAWOCDGHWNBVCZULJUKZWNIJLCUMUKZOLUNUKUKZMNOWPH
        GUOUKZFPRSWTUPZTUAUBWRUPZWSUPZUDUFACDGWNIJLWRWSMNOHWPWTPRSXATUAUBXBXCUD
        UFAWNDCUOUKZUQACGDILKXDNOHWTPRSXAUAUBXDUPUCUFALURUKZOLUSUKUKZGHILNOWTPX
        EUPXFUPRSXAQUFUTZVAVBZACKGIWRLWSMNOHWTPRSXATUAXBXCUCUFXGVDZAWPUQMUKZHUQ
        MUKZAXJXKVEXJFUQMUKZVEAMNGWPHFSTAGILOPRUFVFUIAHNWTUQZXGVBZAFNXMUHVBZUJV
        GVHVIZXGUIVJZAXJWSUKWQUQWRUKVKZHWPGVLUKZVMUQMUKWSUKWNWQCVLUKZVMUQWRUKVK
        ZAWQWQVKXRYAVNAWQVOACDXTGWNWQIJLWRWSXSMNOHWPWTPRSXSUPXATUAUBXTUPXBXCUDU
        FXGXHAGVPUKZHFVQMUKZNGWPWTSXAYBUPZAGILOPRUFVRZAYBMNGHFSYDTYEXNXOVSZUIUJ
        VTZXQXPXIWAWEVHYGXGUHAXLXKUGVIUJAHEUKWPWQHULJUKWNACDEHGHIJKLMNOWPPQRSTU
        AUBUCUDUEUFXNUIAXKXKWBYCWPAXKXKYCAYBYCMGHYDTYEYFAMNGHFSTYEXNXOWCWDZYHWM
        UJWFWGAEHIKLOPQUCUEUFWHWIAWOWPWQFULJUKACDEFGHIJKLMNOWPPQRSTUAUBUCUDUEUF
        XOUIAXKXLWBYCWPAXKXLYCYHAYBYCMGFYDTYEYFAMNGHFSTYEXNXOWJWDWMUJWFWGWKWLWK
        $.
    $}

    $d x E $.  $d x I $.  $d x J $.  $d x N $.  $d x S $.  $d x T $.  $d x U $.
    $d x V $.  $d x ph $.
    hdmapval3.t $e |- ( ph -> T e. V ) $.
    $( Value of map from vectors to functionals at arguments not colinear with
       the reference vector ` E ` .  (Contributed by NM, 17-May-2015.)
       (New usage is discouraged.) $)
    hdmapval3N $p |- ( ph -> ( S ` T ) = ( I ` <. E , ( J ` E ) , T >. ) ) $=
      ( vx cfv cotp wceq c0g fveq2 oteq3 fveq2d eqeq12d wne wa cv cpr wcel wrex
      wn csn cbs eqid dvheveccl eldifad dvh3dim adantr w3a chlt simp1l syl cdif
      cltrn eldifsn sylanbrc simp2 simp3 hdmapval3lemN rexlimdv3a mpd hdmapval0
      simp1r hvmapcl2 hdmap1val0 eqtr4d pm2.61ne ) AEDUIZGGJUIZEUJZIUIZUKZFULUI
      ZDUIZGWKWOUJZIUIZUKEWOEWOUKZWJWPWMWREWODUMWSWLWQIEWOGWKUNUOUPAEWOUQZURZUH
      USZGEUTLUIVAVCZUHMVBZWNAXDWTAUHFHKLMNGEOQRSUEAGMWOVDZAKVEUIZNKVPUIUIZFGHK
      MNWOOXFVFXGVFQRWOVFZPUEVGZVHZUGVIVJXAXCWNUHMXAXBMVAZXCVKZUHBCDEFGHIJKLMNO
      PQRSTUAUBUCUDXLAKVLVANHVAURAWTXKXCVMZUEVNXLAEVDLUIGVDLUIUQXMUFVNXLEMVAZWT
      EMXEVOVAXLAXNXMUGVNAWTXKXCWEEMWOVQVRXAXKXCVSXAXKXCVTWAWBWCAWPBULUIZWRABXO
      DFHKNWOOQXHTXOVFZUDUEWDABCXOFWKHIKMNGWOOQRXHTUAXPUCUEAWKCXOVDABFCHKJXOMNG
      WOOQRXHTUAXPUBUEXIWFVHXJWGWHWI $.
  $}

  ${
    hdmap10.h $e |- H = ( LHyp ` K ) $.
    hdmap10.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap10.v $e |- V = ( Base ` U ) $.
    hdmap10.n $e |- N = ( LSpan ` U ) $.
    hdmap10.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap10.l $e |- L = ( LSpan ` C ) $.
    hdmap10.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmap10.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap10.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      $d x E $.  $d x L $.  $d x M $.  $d x N $.  $d x S $.  $d x T $.
      $d x U $.  $d x V $.  $d x ph $.
      hdmap10.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
      hdmap10.o $e |- .0. = ( 0g ` U ) $.
      hdmap10.d $e |- D = ( Base ` C ) $.
      hdmap10.j $e |- J = ( ( HVMap ` K ) ` W ) $.
      hdmap10.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
      hdmap10lem.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
      $( Lemma for ~ hdmap10 .  (Contributed by NM, 17-May-2015.) $)
      hdmap10lem $p |- ( ph
         -> ( M ` ( N ` { T } ) ) = ( L ` { ( S ` T ) } ) ) $=
        ( vx cv cpr cfv wcel wrex csn wceq cltrn eqid dvheveccl eldifad dvh3dim
        wn cbs w3a csg co cotp wa chlt 3ad2ant1 simp2 cun clss dvhlmod lspprid1
        lspprcl lspsnel5a lspprid2 unssd sseld con3and 3adant2 hdmapval2 eqcomd
        clmod simp3 lssneln0 c0g hvmapcl2 mapdhvmap wne dvhlvec lspindpi simpld
        clvec necomd cdif hdmap1cl hdmapcl simprd hdmap1eq mpbii rexlimdv3a mpd
        mpbid ) AUMUNZGEUONUPZUQZVFZUMOUREUSNUPZMUPEDUPZUSLUPUTZAUMFHKNOPGERSTU
        AUFAGOQUSZAKVGUPZPKVAUPUPZFGHKOPQRXRVBXSVBSTUHUGUFVCZVDZAEOXQULVDZVEAXM
        XPUMOAXJOUQZXMVHZXPXJEFVIUPZVJUSNUPMUPGGJUPZXJVKIUPZXOBVIUPZVJUSLUPUTZY
        DXJYGEVKIUPZXOUTXPYIVLYDXOYJYDBCDEFGHIJKNOPXJRUGSTUAUBUIUJUKUEAYCKVMUQP
        HUQVLXMUFVNZAYCEOUQXMYBVNZAYCXMVOZAXMXJGUSNUPZXNVPZUQZVFYCAYPXLAYOXKXJA
        YNXNXKAFVQUPZXKNFGYQVBZUAAFHKPRSUFVRZAYQNOFGETYRUAYSYAYBVTZANOFGETUAYSY
        AYBVSWAAYQXKNFEYRUAYSYTANOFGETUAYSYAYBWBWAWCWDWEWFWGWHYDBCYHFYGXOHIKLMY
        ENOPXJEQRSTYEVBZUHUAUBUIYHVBZUCUDUKYKYDYQXKOFXJQTUHYRAYCFWIUQXMYSVNAYCX
        KYQUQXMYTVNYMAYCXMWJZWKZYDBCFYFHIKLMNOPGXJQRSTUHUAUBUIUCUDUKYKAYCYFCUQX
        MAYFCBWLUPZUSABFCHKJUUEOPGQRSTUHUBUIUUEVBUJUFXTWMVDVNZAYCYNMUPYFUSLUPUT
        XMABJFHLKMNOPGQRSTUHUAUBUCUDUJUFXTWNVNZYDXJUSNUPZYNYDUUHYNWOZUUHXNWOZYD
        NOFXJGETUAAYCFWSUQXMAFHKPRSUFWPVNYMAYCGOUQXMYAVNYLUUCWQZWRWTZAYCGOXQXAZ
        UQXMXTVNZYMXBZAYCEUUMUQXMULVNAYCXOCUQXMABCDEFHKOPRSTUBUIUEUFYBXCVNYDUUI
        UUJUUKXDYDUUHMUPYGUSLUPUTZGXJYEVJUSNUPMUPYFYGYHVJUSLUPUTZYDYGYGUTUUPUUQ
        VLYGVBYDBCYHFYFYGHIKLMYENOPGXJQRSTUUAUHUAUBUIUUBUCUDUKYKUUNUUFUUDUUOUUL
        UUGXEXFWRXEXIWRXGXH $.
    $}

    hdmap10.t $e |- ( ph -> T e. V ) $.
    $( Part 10 in [Baer] p. 48 line 33, (Ft)* = G(tS) in their notation (S =
       sigma).  (Contributed by NM, 17-May-2015.) $)
    hdmap10 $p |- ( ph -> ( M ` ( N ` { T } ) ) = ( L ` { ( S ` T ) } ) ) $=
      ( csn cfv wceq c0g sneq fveq2d fveq2 sneqd eqeq12d wne cbs cid cres cltrn
      wa cop chdma1 chvm chlt wcel adantr eqid anim1i eldifsn sylibr hdmap10lem
      cdif clmod dvhlmod lspsn0 mapd0 hdmapval0 lcdlmod eqtr2d 3eqtrd pm2.61ne
      syl ) ADUCZJUDZIUDZDCUDZUCZHUDZUEEUFUDZUCZJUDZIUDZWFCUDZUCZHUDZUEDWFDWFUE
      ZWBWIWEWLWMWAWHIWMVTWGJDWFUGUHUHWMWDWKHWMWCWJDWFCUIUJUHUKADWFULZUQZBBUMUD
      ZCDEUNGUMUDUOUNLGUPUDUDUOURZFLGUSUDUDZLGUTUDUDZGHIJKLWFMNOPQRSTAGVAVBLFVB
      UQWNUAVCWQVDWFVDZWPVDWSVDWRVDWODKVBZWNUQDKWGVIVBAXAWNUBVEDKWFVFVGVHAWIWGI
      UDBUFUDZUCZWLAWHWGIAEVJVBWHWGUEAEFGLMNUAVKJEWFWTPVLVSUHABEFGIWFLXBMSNWTQX
      BVDZUAVMAWLXCHUDZXCAWKXCHAWJXBABXBCEFGLWFMNWTQXDTUAVNUJUHABVJVBXEXCUEABFG
      LMQUAVOHBXBXDRVLVSVPVQVR $.
  $}

  ${
    hdmap11.h $e |- H = ( LHyp ` K ) $.
    hdmap11.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap11.v $e |- V = ( Base ` U ) $.
    hdmap11.p $e |- .+ = ( +g ` U ) $.
    hdmap11.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap11.a $e |- .+b = ( +g ` C ) $.
    hdmap11.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap11.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap11.x $e |- ( ph -> X e. V ) $.
    hdmap11.y $e |- ( ph -> Y e. V ) $.
    ${
      hdmap11.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
      hdmap11.o $e |- .0. = ( 0g ` U ) $.
      hdmap11.n $e |- N = ( LSpan ` U ) $.
      hdmap11.d $e |- D = ( Base ` C ) $.
      hdmap11.l $e |- L = ( LSpan ` C ) $.
      hdmap11.m $e |- M = ( ( mapd ` K ) ` W ) $.
      hdmap11.j $e |- J = ( ( HVMap ` K ) ` W ) $.
      hdmap11.i $e |- I = ( ( HDMap1 ` K ) ` W ) $.
      ${
        hdmap11lem0.1a $e |- ( ph -> z e. V ) $.
        hdmap11lem0.6 $e |- ( ph -> -. z e. ( N ` { X , Y } ) ) $.
        hdmap11lem0.2a $e |- ( ph -> ( N ` { z } ) =/= ( N ` { E } ) ) $.
        $( Lemma for ~ hdmapadd .  (Contributed by NM, 26-May-2015.) $)
        hdmap11lem1 $p |- ( ph
             -> ( S ` ( X .+ Y ) ) = ( ( S ` X ) .+b ( S ` Y ) ) ) $=
          ( cv cfv cotp c0g csn eqid cltrn dvheveccl hvmapcl2 eldifad mapdhvmap
          co cbs necomd hdmap1cl clss cpr dvhlmod lspprcl lssneln0 csg wa eqidd
          wceq hdmap1eq mpbid hdmap1l6 clmod lmodvacl syl3anc dvhlvec lspprvacl
          simpld wcel lspsnel5a ssneldd lspsnne2 hdmaplem4 hdmapval2 wne simprd
          lspindpi oveq12d 3eqtr4d ) ABVCZIILVDZXGVEKVDZSTEVNZVEKVDXGXISVEKVDZX
          GXITVEKVDZFVNXJGVDSGVDZTGVDZFVNACDEFHXIJKMNOPQRXGSUATUBUCUDUEUMUNUFUO
          UGUPUQUSUIACDHXHJKMNOPQRIXGUAUBUCUDUMUNUFUOUPUQUSUIAXHDCVFVDZVGACHDJM
          LXOQRIUAUBUCUDUMUFUOXOVHURUIAMVOVDZRMVIVDVDZHIJMQRUAUBXPVHXQVHUCUDUMU
          LUIVJZVKVLZACLHJNMOPQRIUAUBUCUDUMUNUFUPUQURUIXRVMZAXGVGPVDZIVGPVDVBVP
          ZXRUTVQZAHVRVDZSTVSPVDZQHXGUAUDUMYDVHZAHJMRUBUCUIVTZAYDPQHSTUDYFUNYGU
          JUKWAZUTVAWBZUJUKVAAYAOVDXIVGNVDWFZIXGHWCVDZVNVGPVDOVDXHXICWCVDZVNVGN
          VDWFZAXIXIWFYJYMWDAXIWEACDYLHXHXIJKMNOYKPQRIXGUAUBUCUDYKVHUMUNUFUOYLV
          HUPUQUSUIXRXSYIYCYBXTWGWHWOWIACDGXJHIJKLMPQRXGUBULUCUDUNUFUOURUSUHUIA
          HWJWPSQWPTQWPXJQWPYGUJUKEQHSTUDUEWKWLZUTAPQHIXJUAXGUDUNUMAHJMRUBUCUIW
          MZAIQUAVGXRVLZYNYIVBAPQHXGXJUDUNYGUTYNAXJVGPVDYEXGAYDYEPHXJYFUNYGYHAE
          PQHSTUDUEUNYGUJUKWNWQVAWRWSWTXAAXMXKXNXLFACDGSHIJKLMPQRXGUBULUCUDUNUF
          UOURUSUHUIUJUTAPQHISUAXGUDUNUMYOYPUJYIVBAYASVGPVDXBZYATVGPVDXBZAPQHXG
          STUDUNYOUTUJUKVAXDZWOWTXAACDGTHIJKLMPQRXGUBULUCUDUNUFUOURUSUHUIUKUTAP
          QHITUAXGUDUNUMYOYPUKYIVBAYQYRYSXCWTXAXEXF $.
      $}

      $d z .+b $.  $d z E $.  $d z N $.  $d z .0. $.  $d z .+ $.  $d z S $.
      $d z U $.  $d z V $.  $d z X $.  $d z Y $.  $d z ph $.
      $( Lemma for ~ hdmapadd .  (Contributed by NM, 26-May-2015.) $)
      hdmap11lem2 $p |- ( ph
             -> ( S ` ( X .+ Y ) ) = ( ( S ` X ) .+b ( S ` Y ) ) ) $=
        ( vz cv cpr cfv wcel wn csn wa wrex wceq dvh3dim adantr clss eqid clmod
        co dvhlmod lspprcl simpr lspsnel5a ssneld ancld reximdv cltrn dvheveccl
        mpd cbs eldifad preq1 prcom syl6eq fveq2d lsppr0 sylan9eqr wss lspprid2
        eqsstrd lspprid1 adantlr wne lmodvacl syl3anc ad2antrr simplr lssvancl2
        lspsncl syl2anc lspsnid clvec dvhlvec eldifsn sylanbrc sseld lspsnnecom
        jcad con3and lssvancl1 eleq1 notbid anbi12d rspcev pm2.61dane pm2.61dan
        cdif syl12anc w3a chlt 3ad2ant1 simp2 simp3l simp3r lspsnne2 rexlimdv3a
        hdmap11lem1 ) AUSUTZRSVAZOVBZVCZVDZYMHVEOVBZVCZVDZVFZUSPVGZRSDVNFVBRFVB
        SFVBEVNVHZAHYOVCZUUBAUUDVFZYQUSPVGZUUBAUUFUUDAUSGILOPQRSUAUBUCUMUHUIUJV
        IVJUUEYQUUAUSPUUEYQYTUUEYRYOYMUUEGVKVBZYOOGHUUGVLZUMAGVMVCZUUDAGILQUAUB
        UHVOZVJAYOUUGVCZUUDAUUGOPGRSUCUUHUMUUJUIUJVPZVJAUUDVQVRVSVTWAWDAUUDVDZV
        FZUUBRTARTVHZUUBUUMAUUOVFZYMHSVAOVBZVCVDZUSPVGZUUBAUUSUUOAUSGILOPQHSUAU
        BUCUMUHAHPTVEZALWEVBZQLWBVBVBZGHILPQTUAUVAVLUVBVLUBUCULUKUHWCWFZUJVIVJU
        UPUURUUAUSPUUPUURYQYTUUPYOUUQYMUUPYOSVEOVBZUUQUUOAYOSTVAZOVBUVDUUOYNUVE
        OUUOYNTSVAUVERTSWGTSWHWIWJAOPGSTUCULUMUUJUJWKWLAUVDUUQWMUUOAUUGUUQOGSUU
        HUMUUJAUUGOPGHSUCUUHUMUUJUVCUJVPZAOPGHSUCUMUUJUVCUJWNVRVJWOVSUUPYRUUQYM
        AYRUUQWMUUOAUUGUUQOGHUUHUMUUJUVFAOPGHSUCUMUUJUVCUJWPVRVJVSXMWAWDWQUUNRT
        WRZVFZHRDVNZPVCZUVIYOVCZVDZUVIYRVCZVDZUUBAUVJUUMUVGAUUIHPVCZRPVCZUVJUUJ
        UVCUIDPGHRUCUDWSWTXAUVHDUUGYOPGRHUCUDUUHAUUIUUMUVGUUJXAZAUUKUUMUVGUULXA
        ARYOVCUUMUVGAOPGRSUCUMUUJUIUJWPZXAAUVOUUMUVGUVCXAZAUUMUVGXBXCUVHDUUGYRP
        GHRUCUDUUHUVQAYRUUGVCZUUMUVGAUUIUVOUVTUUJUVCUUGOPGHUCUUHUMXDXEXAAHYRVCZ
        UUMUVGAUUIUVOUWAUUJUVCOPGHUCUMXFXEXAAUVPUUMUVGUIXAZUVHOPGHRTUCULUMAGXGV
        CUUMUVGAGILQUAUBUHXHXAUVSUVHUVPUVGRPUUTYBVCUWBUUNUVGVQRPTXIXJUUNHRVEOVB
        ZVCZVDUVGAUWDUUDAUWCYOHAUUGYOOGRUUHUMUUJUULUVRVRXKXNVJXLXOUUAUVLUVNVFUS
        UVIPYMUVIVHZYQUVLYTUVNUWEYPUVKYMUVIYOXPXQUWEYSUVMYMUVIYRXPXQXRXSYCXTYAA
        UUAUUCUSPAYMPVCZUUAYDZUSBCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGAUWFLYEVCQIVCV
        FUUAUHYFAUWFUVPUUAUIYFAUWFSPVCUUAUJYFUKULUMUNUOUPUQURAUWFUUAYGZAUWFYQYT
        YHUWGOPGYMHUCUMAUWFUUIUUAUUJYFUWHAUWFUVOUUAUVCYFAUWFYQYTYIYJYLYKWD $.
    $}

    $( Part 11 in [Baer] p. 48 line 35, (a+b)S = aS+bS in their notation (S =
       sigma).  (Contributed by NM, 22-May-2015.) $)
    hdmapadd $p |- ( ph ->
      ( S ` ( X .+ Y ) ) = ( ( S ` X ) .+b ( S ` Y ) ) ) $=
      ( cbs cfv cid cres cltrn cop chdma1 chvm clspn cmpd c0g eqid hdmap11lem2
      ) ABBUCUDZCDEFUEHUCUDUFUEJHUGUDUDUFUHZGJHUIUDUDZJHUJUDUDZHBUKUDZJHULUDUDZ
      FUKUDZIJKLFUMUDZMNOPQRSTUAUBUQUNVCUNVBUNUPUNUTUNVAUNUSUNURUNUO $.
  $}

  ${
    hdmap12a.h $e |- H = ( LHyp ` K ) $.
    hdmap12a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap12a.v $e |- V = ( Base ` U ) $.
    hdmap12a.o $e |- .0. = ( 0g ` U ) $.
    hdmap12a.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap12a.q $e |- Q = ( 0g ` C ) $.
    hdmap12a.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap12a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap12a.x $e |- ( ph -> T e. V ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 3.  (Contributed by NM,
       22-May-2015.) $)
    hdmapeq0 $p |- ( ph -> ( ( S ` T ) = Q <-> T = .0. ) ) $=
      ( cfv wceq csn clspn cmpd eqid hdmap10 mapd0 eqeq12d clss dvhlmod lspsncl
      clmod wcel syl2anc lsssn0 syl mapd11 wb lcdlmod hdmapcl lspsneq0 3bitr3rd
      cbs bitrd ) AEDUAZCUBZEUCFUDUAZUAZKUCZUBZEKUBZAVIJHUEUAUAZUAZVJVMUAZUBVFU
      CBUDUAZUAZCUCZUBZVKVGAVNVQVOVRABDEFGHVPVMVHIJLMNVHUFZPVPUFZVMUFZRSTUGABFG
      HVMKJCLWBMOPQSUHUIAFUJUAZFGHVMJVIVJLMWCUFZWBSAFUMUNZEIUNZVIWCUNAFGHJLMSUK
      ZTWCVHIFENWDVTULUOAWEVJWCUNWGWCFKOWDUPUQURABUMUNVFBVDUAZUNVSVGUSABGHJLPSU
      TABWHDEFGHIJLMNPWHUFZRSTVAVPWHBVFCWIQWAVBUOVCAWEWFVKVLUSWGTVHIFEKNOVTVBUO
      VE $.
  $}

  ${
    hdmapnzcl.h $e |- H = ( LHyp ` K ) $.
    hdmapnzcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapnzcl.v $e |- V = ( Base ` U ) $.
    hdmapnzcl.o $e |- .0. = ( 0g ` U ) $.
    hdmapnzcl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapnzcl.q $e |- Q = ( 0g ` C ) $.
    hdmapnzcl.d $e |- D = ( Base ` C ) $.
    hdmapnzcl.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapnzcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapnzcl.t $e |- ( ph -> T e. ( V \ { .0. } ) ) $.
    $( Nonzero vector closure of map from vectors to functionals with closed
       kernels.  (Contributed by NM, 27-May-2015.) $)
    hdmapnzcl $p |- ( ph -> ( S ` T ) e. ( D \ { Q } ) ) $=
      ( cfv wcel wne csn eldifad hdmapcl eldifsni syl hdmapeq0 necon3bid mpbird
      cdif eldifsn sylanbrc ) AFEUCZCUDUQDUEZUQCDUFUNUDABCEFGHIJKMNOQSTUAAFJLUF
      ZUBUGZUHAURFLUEZAFJUSUNUDVAUBFJLUIUJAUQDFLABDEFGHIJKLMNOPQRTUAUTUKULUMUQC
      DUOUP $.
  $}

  ${
    hdmap12b.h $e |- H = ( LHyp ` K ) $.
    hdmap12b.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap12b.v $e |- V = ( Base ` U ) $.
    hdmap12b.m $e |- M = ( invg ` U ) $.
    hdmap12b.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap12b.i $e |- I = ( invg ` C ) $.
    hdmap12b.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap12b.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap12b.x $e |- ( ph -> T e. V ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 4.  The sigma map of a
       negative is the negative of the sigma map.  (Contributed by NM,
       24-May-2015.) $)
    hdmapneg $p |- ( ph -> ( S ` ( M ` T ) ) = ( I ` ( S ` T ) ) ) $=
      ( cfv cplusg co wceq c0g wcel cbs lcdlmod eqid hdmapcl lmodvnegid syl2anc
      clmod dvhlmod lmodvacl syl3anc hdmapeq0 mpbird hdmapadd 3eqtr2rd lmodlcan
      lmodvnegcl wb syl13anc mpbid ) ADCUAZDIUAZCUAZBUBUAZUCZVFVFGUAZVIUCZUDZVH
      VKUDZAVLBUEUAZDVGEUBUAZUCZCUAZVJABUMUFZVFBUGUAZUFZVLVOUDABFHKLPSUHZABVTCD
      EFHJKLMNPVTUIZRSTUJZVIGVTBVFVOWCVIUIZVOUIZQUKULAVRVOUDVQEUEUAZUDZAEUMUFZD
      JUFZWHAEFHKLMSUNZTVPIJEDWGNVPUIZWGUIZOUKULABVOCVQEFHJKWGLMNWMPWFRSAWIWJVG
      JUFZVQJUFWKTAWIWJWNWKTIJEDNOVBULZVPJEDVGNWLUOUPUQURABVPVICEFHJKDVGLMNWLPW
      ERSTWOUSUTAVSVHVTUFVKVTUFZWAVMVNVCWBABVTCVGEFHJKLMNPWCRSWOUJAVSWAWPWBWDGV
      TBVFWCQVBULWDVIVTBVHVKVFWCWEVAVDVE $.
  $}


  ${
    hdmap12c.h $e |- H = ( LHyp ` K ) $.
    hdmap12c.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap12c.v $e |- V = ( Base ` U ) $.
    hdmap12c.m $e |- .- = ( -g ` U ) $.
    hdmap12c.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap12c.n $e |- N = ( -g ` C ) $.
    hdmap12c.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap12c.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap12c.x $e |- ( ph -> X e. V ) $.
    hdmap12c.y $e |- ( ph -> Y e. V ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 5, (a-b)S = aS-bS in their
       notation (S = sigma).  (Contributed by NM, 26-May-2015.) $)
    hdmapsub $p |- ( ph -> ( S ` ( X .- Y ) ) = ( ( S ` X ) N ( S ` Y ) ) ) $=
      ( co cminusg cplusg wcel wceq eqid grpsubval syl2anc fveq2d clmod dvhlmod
      cfv lmodvnegcl hdmapadd hdmapneg oveq2d 3eqtrd cbs hdmapcl eqtr4d ) AKLGU
      CZCUNZKCUNZLCUNZBUDUNZUNZBUEUNZUCZVEVFHUCZAVDKLDUDUNZUNZDUEUNZUCZCUNVEVMC
      UNZVIUCVJAVCVOCAKIUFLIUFZVCVOUGUAUBIVNDVLGKLOVNUHZVLUHZPUIUJUKABVNVICDEFI
      JKVMMNOVRQVIUHZSTUAADULUFVQVMIUFADEFJMNTUMUBVLIDLOVSUOUJUPAVPVHVEVIABCLDE
      VGFVLIJMNOVSQVGUHZSTUBUQURUSAVEBUTUNZUFVFWBUFVKVJUGABWBCKDEFIJMNOQWBUHZST
      UAVAABWBCLDEFIJMNOQWCSTUBVAWBVIBVGHVEVFWCVTWARUIUJVB $.
  $}

  ${
    hdmap12d.h $e |- H = ( LHyp ` K ) $.
    hdmap12d.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap12d.v $e |- V = ( Base ` U ) $.
    hdmap12d.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap12d.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap12d.x $e |- ( ph -> X e. V ) $.
    hdmap12d.y $e |- ( ph -> Y e. V ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 4, aS=bS iff a=b in their
       notation (S = sigma).  The sigma map is one-to-one.  (Contributed by NM,
       26-May-2015.) $)
    hdmap11 $p |- ( ph -> ( ( S ` X ) = ( S ` Y ) <-> X = Y ) ) $=
      ( cfv wceq eqid wcel csg co clcd hdmapsub eqeq1d clmod dvhlmod lmodvsubcl
      c0g syl3anc hdmapeq0 cgrp cbs lcdlmod lmodgrp syl hdmapcl grpsubeq0 bitrd
      wb 3bitr3rd ) AHBQZIBQZRZHICUAQZUBZCUIQZRZHIRZAVFBQZGEUCQQZUIQZRVBVCVKUAQ
      ZUBZVLRZVHVDAVJVNVLAVKBCDEVEVMFGHIJKLVESZVKSZVMSZMNOPUDUEAVKVLBVFCDEFGVGJ
      KLVGSZVQVLSZMNACUFTZHFTZIFTZVFFTACDEGJKNUGZOPVEFCHILVPUHUJUKAVKULTZVBVKUM
      QZTVCWFTVOVDUTAVKUFTWEAVKDEGJVQNUNVKUOUPAVKWFBHCDEFGJKLVQWFSZMNOUQAVKWFBI
      CDEFGJKLVQWGMNPUQWFVKVMVBVCVLWGVTVRURUJVAACULTZWBWCVHVIUTAWAWHWDCUOUPOPFC
      VEHIVGLVSVPURUJUS $.
  $}

  ${
    hdmaprnlem1.h $e |- H = ( LHyp ` K ) $.
    hdmaprnlem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaprnlem1.v $e |- V = ( Base ` U ) $.
    hdmaprnlem1.n $e |- N = ( LSpan ` U ) $.
    hdmaprnlem1.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmaprnlem1.l $e |- L = ( LSpan ` C ) $.
    hdmaprnlem1.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmaprnlem1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaprnlem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmaprnlem1.se $e |- ( ph -> s e. ( D \ { Q } ) ) $.
    hdmaprnlem1.ve $e |- ( ph -> v e. V ) $.
    hdmaprnlem1.e $e |- ( ph -> ( M ` ( N ` { v } ) ) = ( L ` { s } ) ) $.
    hdmaprnlem1.ue $e |- ( ph -> u e. V ) $.
    hdmaprnlem1.un $e |- ( ph -> -. u e. ( N ` { v } ) ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 10, Gu' ` =/= ` Gs.  Our
       ` ( N `` { v } ) ` is Baer's T. (Contributed by NM, 26-May-2015.)
       (New usage is discouraged.) $)
    hdmaprnlem1N $p |- ( ph -> ( L ` { ( S ` u ) } ) =/= ( L ` { s } ) ) $=
      ( cv csn cfv dvhlmod lspsnne2 clss eqid clmod wcel lspsncl syl2anc mapd11
      wne necon3bid mpbird hdmap10 3netr3d ) ACUKZULMUMZLUMZBUKZULMUMZLUMZVHGUM
      ULKUMPUKULKUMAVJVMVCVIVLVCAMNHVHVKSTAHIJOQRUEUNZUIUGUJUOAVJVMVIVLAHUPUMZH
      IJLOVIVLQRVOUQZUCUEAHURUSZVHNUSVIVOUSVNUIVOMNHVHSVPTUTVAAVQVKNUSVLVOUSVNU
      GVOMNHVKSVPTUTVAVBVDVEADGVHHIJKLMNOQRSTUAUBUCUDUEUIVFUHVG $.

    hdmaprnlem1.d $e |- D = ( Base ` C ) $.
    hdmaprnlem1.q $e |- Q = ( 0g ` C ) $.
    hdmaprnlem1.o $e |- .0. = ( 0g ` U ) $.
    hdmaprnlem1.a $e |- .+b = ( +g ` C ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 15, T ` =/= ` P. Our
       ` ( ``' M `` ( L `` { ( ( S `` u ) .+b s ) } ) ) ` is Baer's P, where P*
       = G(u'+s).  (Contributed by NM, 27-May-2015.)
       (New usage is discouraged.) $)
    hdmaprnlem3N $p |- ( ph
      -> ( N ` { v } ) =/= ( `' M ` ( L ` { ( ( S ` u ) .+b s ) } ) ) ) $=
      ( cv csn cfv ccnv wne lcdlmod clmod wcel hdmapcl eldifad lmodvacl syl3anc
      clss eqid lspsncl syl2anc lspsnid lcdlvec lssneln0 hdmapnzcl hdmaprnlem1N
      co dvhlmod lspsnne1 lssvancl2 lspsnne2 necomd mapdrn2 eleqtrrd mapdcnvid2
      crn 3netr4d mapdcnvcl mapd11 necon3bid mpbid ) ABUQZURNUSZMUSZCUQZHUSZRUQ
      ZFVRZURLUSZMUTUSZMUSZVAWNXAVAAWRURLUSZWTWOXBAWTXCALEDWSWRUMUDADJKPSUCUGVB
      ZADVCVDZWQEVDWREVDZWSEVDZXDADEHWPIJKOPSTUAUCUMUFUGUKVEZAWREGURUHVFZFEDWQW
      RUMUPVGVHZXIAFDVIUSZXCEDWRWQUMUPXKVJZXDAXEXFXCXKVDXDXIXKLEDWRUMXLUDVKVLAX
      EXFWRXCVDXDXILEDWRUMUDVMVLXHALEDWQWRGUMUNUDADJKPSUCUGVNADEGHWPIJKOPQSTUAU
      OUCUNUMUFUGAIVIUSZWNOIWPQUAUOXMVJZAIJKPSTUGVSZAIVCVDWMOVDWNXMVDXOUIXMNOIW
      MUAXNUBVKVLZUKULVOVPXIABCDEGHIJKLMNOPRSTUAUBUCUDUEUFUGUHUIUJUKULVQVTWAWBW
      CUJAJKMPWTSUEUGAWTXKMWGAXEXGWTXKVDXDXJXKLEDWSUMXLUDVKVLADXKJKMPSUEUCXLUGW
      DWEZWFWHAWOXBWNXAAXMIJKMPWNXASTXNUEUGXPAXMIJKMPWTSUETXNUGXQWIWJWKWL $.

    $( Part of proof of part 12 in [Baer] p. 49.  (Contributed by NM,
       29-May-2015.)  (New usage is discouraged.) $)
    hdmaprnlem3uN $p |- ( ph
      -> ( N ` { u } ) =/= ( `' M ` ( L ` { ( ( S ` u ) .+b s ) } ) ) ) $=
      ( cv csn ccnv co clss eqid clmod wcel dvhlmod lspsncl syl2anc mapdcnvid1N
      cfv wne hdmap10 lcdlvec hdmapcl hdmaprnlem1N lspindp3 eqnetrd crn lcdlmod
      eldifad lmodvacl syl3anc mapdrn2 eleqtrrd mapdcnv11N necon3bid eqnetrrd
      mapdcl mpbird ) ACUQZURNVIZMVIZMUSZVIZWJWIHVIZRUQZFUTZURLVIZWLVIZAIVAVIZI
      JKMPWJSUETWSVBZUGAIVCVDWIOVDWJWSVDAIJKPSTUGVEUKWSNOIWIUAWTUBVFVGZVHAWMWRV
      JWKWQVJAWKWNURLVIWQADHWIIJKLMNOPSTUAUBUCUDUEUFUGUKVKAFLEDWNWOGUMUPUNUDADJ
      KPSUCUGVLADEHWIIJKOPSTUAUCUMUFUGUKVMZUHABCDEGHIJKLMNOPRSTUAUBUCUDUEUFUGUH
      UIUJUKULVNVOVPAWMWRWKWQAJKMPWKWQSUEUGAWSIJKMPWJSUETWTUGXAWGAWQDVAVIZMVQAD
      VCVDZWPEVDZWQXCVDADJKPSUCUGVRZAXDWNEVDWOEVDXEXFXBAWOEGURUHVSFEDWNWOUMUPVT
      WAXCLEDWPUMXCVBZUDVFVGADXCJKMPSUEUCXGUGWBWCWDWEWHWF $.

    ${
      hdmaprnlem1.t2 $e |- ( ph -> t e. ( ( N ` { v } ) \ { .0. } ) ) $.
      $( Lemma for ~ hdmaprnN .  TODO:  This lemma doesn't quite pay for itself
         even though used 4 times.  Maybe prove this directly instead.
         (Contributed by NM, 27-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem4tN $p |- ( ph -> t e. V ) $=
        ( cv csn cfv cdif clmod wcel wss dvhlmod lspssv syl2anc ssdifssd sseldd
        snssd ) ABUSZUTZOVAZRUTZVBPDUSAVNPVOAJVCVDVMPVEVNPVEAJKLQTUAUHVFAVLPUJV
        KVMOPJUBUCVGVHVIURVJ $.

      $( Part of proof of part 12 in [Baer] p. 49 line 19.  (T* =) (Ft)* = Gs.
         (Contributed by NM, 27-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem4N $p |- ( ph -> ( M ` ( N ` { t } ) ) = ( L ` { s } ) ) $=
        ( csn cfv wss wceq clss eqid dvhlmod clmod wcel lspsncl syl2anc eldifad
        cv lspsnel5a dvhlvec cdif syl ssdifd sseldd lspsncmp mpbid fveq2d eqtrd
        lss1 ) ADVKZUSOUTZNUTBVKZUSOUTZNUTSVKUSMUTAWDWFNAWDWFVAWDWFVBAJVCUTZWFO
        JWCWGVDZUCAJKLQTUAUHVEZAJVFVGZWEPVGWFWGVGWIUJWGOPJWEUBWHUCVHVIAWCWFRUSZ
        URVJVLAOPJWCWERUBUPUCAJKLQTUAUHVMAWFWKVNPWKVNWCAWFPWKAWGPOJWEWHUCWIAWJP
        WGVGWIWGPJUBWHWBVOUJVLVPURVQUJVRVSVTUKWA $.

      hdmaprnlem1.p $e |- .+ = ( +g ` U ) $.
      hdmaprnlem1.pt $e |- ( ph -> ( L ` { ( ( S ` u ) .+b s ) } )
            = ( M ` ( N ` { ( u .+ t ) } ) ) ) $.
      $( Part of proof of part 12 in [Baer] p. 49 line 18, G(u'+s) = G(u'+t).
         (Contributed by NM, 27-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem6N $p |- ( ph ->
 ( L ` { ( ( S ` u ) .+b s ) } ) = ( L ` { ( ( S ` u ) .+b ( S ` t ) ) } ) ) $=
        ( cv cfv csn clmod wcel dvhlmod hdmaprnlem4tN lmodvacl syl3anc hdmapadd
        co hdmap10 sneqd fveq2d 3eqtrd ) ACVBZJVCZTVBHVLVDNVCVQDVBZGVLZVDPVCOVC
        VTJVCZVDZNVCVRVSJVCHVLZVDZNVCVAAEJVTKLMNOPQRUAUBUCUDUEUFUGUHUIAKVEVFVQQ
        VFVSQVFVTQVFAKLMRUAUBUIVGUMABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULU
        MUNUOUPUQURUSVHZGQKVQVSUCUTVIVJVMAWBWDNAWAWCAEGHJKLMQRVQVSUAUBUCUTUEURU
        HUIUMWEVKVNVOVP $.

      $( Part of proof of part 12 in [Baer] p. 49 line 19, s-St ` e. ` G(u'+s)
         = P*.  (Contributed by NM, 27-May-2015.)
         (New usage is discouraged.) $)
      hdmaprnlem7N $p |- ( ph -> ( s ( -g ` C ) ( S ` t ) )
         e. ( L ` { ( ( S ` u ) .+b s ) } ) ) $=
        ( cv cfv co csg csn eqid clmod wcel lcdlmod lmodabl syl hdmapcl eldifad
        cabel hdmaprnlem4tN ablpnpcan clss syl3anc lspsncl syl2anc hdmaprnlem6N
        lmodvacl lspsnid eleqtrrd lssvsubcl syl22anc eqeltrrd ) ACVBZJVCZTVBZHV
        DZWJDVBZJVCZHVDZEVEVCZVDZWKWNWPVDWLVFNVCZAFHEWPWJWKWNUOURWPVGZAEVHVIZEV
        OVIAELMRUAUEUIVJZEVKVLZAEFJWIKLMQRUAUBUCUEUOUHUIUMVMZAWKFIVFUJVNZAEFJWM
        KLMQRUAUBUCUEUOUHUIABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPU
        QURUSVPVMZXBXCXDXEVQAWTWREVRVCZVIZWLWRVIZWOWRVIWQWRVIXAAWTWLFVIZXGXAAWT
        WJFVIZWKFVIXIXAXCXDHFEWJWKUOURWCVSZXFNFEWLUOXFVGZUFVTWAAWTXIXHXAXKNFEWL
        UOUFWDWAAWOWOVFNVCZWRAWTWOFVIZWOXMVIXAAWTXJWNFVIXNXAXCXEHFEWJWNUOURWCVS
        NFEWOUOUFWDWAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUS
        UTVAWBWEXFWRWPEWLWOWSXLWFWGWH $.

      $( Part of proof of part 12 in [Baer] p. 49 line 19, s-St ` e. ` (Ft)* =
         T*.  (Contributed by NM, 27-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem8N $p |- ( ph -> ( s ( -g ` C ) ( S ` t ) )
         e. ( M ` ( N ` { t } ) ) ) $=
        ( clmod wcel cv csn cfv clss lcdlmod eqid dvhlmod hdmaprnlem4tN lspsncl
        syl2anc mapdcl2 eldifad lspsnid hdmaprnlem4N eleqtrrd hdmapcl lssvsubcl
        csg co hdmap10 syl22anc ) AEVBVCZDVDZVEPVFZOVFZEVGVFZVCTVDZWHVCWFJVFZWH
        VCWJWKEWAVFZWBWHVCAELMRUAUEUIVHZAEWGKVGVFZWIKLMORUAUGUBWNVIZUEWIVIZUIAK
        VBVCWFQVCWGWNVCAKLMRUAUBUIVJABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKUL
        UMUNUOUPUQURUSVKZWNPQKWFUCWOUDVLVMVNAWJWJVENVFZWHAWEWJFVCWJWRVCWMAWJFIV
        EUJVONFEWJUOUFVPVMABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQ
        URUSVQVRAWKWKVENVFZWHAWEWKFVCWKWSVCWMAEFJWFKLMQRUAUBUCUEUOUHUIWQVSNFEWK
        UOUFVPVMAEJWFKLMNOPQRUAUBUCUDUEUFUGUHUIWQWCVRWIWHWLEWJWKWLVIWPVTWD $.

      $( Part of proof of part 12 in [Baer] p. 49 line 21, s=S(t).  TODO: we
         seem to be going back and forth with ~ mapd11 and ~ mapdcnv11N .  Use
         better hypotheses and/or theorems?  (Contributed by NM, 27-May-2015.)
         (New usage is discouraged.) $)
      hdmaprnlem9N $p |- ( ph -> s = ( S ` t ) ) $=
        ( cv cfv csg co wceq csn hdmaprnlem7N hdmaprnlem8N hdmaprnlem4N eleqtrd
        wcel cin elin sylanbrc lcdlvec lcdlmod hdmapcl eldifad lmodvacl syl3anc
        clmod ccnv wne clss crn eqid lspsncl syl2anc eleqtrrd mapdcnvid2 eqtr4d
        mapdrn2 dvhlmod mapdcnvcl mapd11 mpbid hdmaprnlem3N eqnetrrd mapdcnv11N
        necon3bid necomd lspdisj2 elsni syl wb hdmaprnlem4tN lmodsubeq0 ) ATVBZ
        DVBZJVCZEVDVCZVEZIVFZXIXKVFZAXMIVGZVLXNAXMCVBZJVCZXIHVEZVGNVCZXIVGNVCZV
        MZXPAXMXTVLXMYAVLXMYBVLABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
        UOUPUQURUSUTVAVHAXMXJVGPVCOVCYAABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJ
        UKULUMUNUOUPUQURUSUTVAVIABCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUN
        UOUPUQURUSVJVKXMXTYAVNVOANFEXSXIIUOUPUFAELMRUAUEUIVPAEWBVLZXRFVLXIFVLZX
        SFVLZAELMRUAUEUIVQZAEFJXQKLMQRUAUBUCUEUOUHUIUMVRAXIFXPUJVSZHFEXRXIUOURV
        TWAZYGAYAXTAYAOWCZVCZXTYIVCZWDYAXTWDABVBZVGPVCZYJYKAYMOVCZYJOVCZVFYMYJV
        FAYNYAYOULALMORYAUAUGUIAYAEWEVCZOWFZAYCYDYAYPVLYFYGYPNFEXIUOYPWGZUFWHWI
        AEYPLMORUAUGUEYRUIWMZWJZWKWLAKWEVCZKLMORYMYJUAUBUUAWGZUGUIAKWBVLYLQVLYM
        UUAVLAKLMRUAUBUIWNUKUUAPQKYLUCUUBUDWHWIAUUAKLMORYAUAUGUBUUBUIYTWOWPWQAB
        CEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURWRWSAYJYKYAXTALMORY
        AXTUAUGUIYTAXTYPYQAYCYEXTYPVLYFYHYPNFEXSUOYRUFWHWIYSWJWTXAWQXBXCVKXMIXD
        XEAYCYDXKFVLXNXOXFYFYGAEFJXJKLMQRUAUBUCUEUOUHUIABCDEFHIJKLMNOPQRSTUAUBU
        CUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSXGVRXIXKXLFEIUOUPXLWGXHWAWQ $.
    $}

    ${
      $d t .+b $.  $d t L $.  $d t M $.  $d t N $.  $d t .0. $.  $d t .+ $.
      $d t S $.  $d t U $.  $d t V $.  $d t ph $.  $d t s u v $.
      hdmaprnlem3e.p $e |- .+ = ( +g ` U ) $.
      $( Lemma for ~ hdmaprnN .  (Contributed by NM, 29-May-2015.)
         (New usage is discouraged.) $)
      hdmaprnlem3eN $p |- ( ph -> E. t e. ( ( N ` { v } ) \ { .0. } )
          ( L ` { ( ( S ` u ) .+b s ) } ) = ( M ` ( N ` { ( u .+ t ) } ) ) ) $=
        ( cv cfv co csn ccnv wceq cdif wrex clsa eqid dvhlvec lcdlmod wne clmod
        wcel hdmapcl eldifad lmodvacl hdmaprnlem1N lmodindp1 sylanbrc lsatlspsn
        syl3anc eldifsn mapdcnvatN hdmaprnlem3uN hdmaprnlem3N clsm cpr wss clss
        necomd dvhlmod lspsncl syl2anc mapdcl2 lsmcl csubg lsssssubg syl sseldd
        lspsnid hdmap10 eleqtrrd lspsnel5 lsmelvali syl22anc lspsnel5a sseqtr4d
        eqimss2 mpbird mapdlsm crn mapdrn2 mapdcl mapdcnvordN lsmpr mapdcnvid1N
        eqtr4d lsatfixedN wa simpr chlt ad2antrr hdmaprnlem4tN mapdcnv11N mpbid
        wn simplr ex reximdva mpd ) ACUTZJVAZTUTZHVBZVCNVAZOVDZVAZYLDUTZGVBZVCP
        VAZVEZDBUTZVCPVAZSVCVFZVGYPUUAOVAZVEZDUUEVGADKVHVAZGYRPQKYLUUCSUCUSUQUD
        UUHVIZAKLMRUAUBUIVJAUUHEVHVAZEYPKLMORUAUGUBUUIUEUUJVIZUIAUUJNFEYOIUOUFU
        PUUKAELMRUAUEUIVKZAYOFVNZYOIVLYOFIVCZVFZVNAEVMVNZYMFVNZYNFVNUUMUULAEFJY
        LKLMQRUAUBUCUEUOUHUIUMVOZAYNFUUNUJVPZHFEYMYNUOURVQWBZAHNFEYMYNIUOURUPUF
        UULUURUUSABCEFIJKLMNOPQRTUAUBUCUDUEUFUGUHUIUJUKULUMUNVRVSYOFIWCVTWAWDUM
        UKAYLVCPVAZYRABCEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURWEWK
        AUUDYRABCEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURWFWKAYRUVAU
        UDKWGVAZVBZOVAZYQVAZYLUUCWHPVAZAYRUVEWIYPUVDWIAYPUVAOVAZUUDOVAZEWGVAZVB
        ZUVDAEWJVAZUVJNEYOUVKVIZUFUULAUUPUVGUVKVNUVHUVKVNUVJUVKVNUULAEUVAKWJVAZ
        UVKKLMORUAUGUBUVMVIZUEUVLUIAKVMVNZYLQVNZUVAUVMVNZAKLMRUAUBUIWLZUMUVMPQK
        YLUCUVNUDWMWNZWOZAEUUDUVMUVKKLMORUAUGUBUVNUEUVLUIAUVOUUCQVNZUUDUVMVNZUV
        RUKUVMPQKUUCUCUVNUDWMWNZWOZUVIUVKUVGUVHEUVLUVIVIZWPWBAUVGEWQVAZVNUVHUWF
        VNYMUVGVNYNUVHVNZYOUVJVNAUVKUWFUVGAUUPUVKUWFWIUULUVKEUVLWRWSZUVTWTAUVKU
        WFUVHUWHUWDWTAYMYMVCNVAZUVGAUUPUUQYMUWIVNUULUURNFEYMUOUFXAWNAEJYLKLMNOP
        QRUAUBUCUDUEUFUGUHUIUMXBXCAUWGYNVCNVAZUVHWIZAUVHUWJVEZUWKULUWJUVHXIWSAU
        VKUVHNFEYNUOUVLUFUULUWDUUSXDXJHUVIUVGUVHEYMYNURUWEXEXFXGAEUVIUVBUVMKLMO
        RUVAUUDUAUGUBUVNUVBVIZUEUWEUIUVSUWCXKXHALMORYPUVDUAUGUIAYPUVKOXLZAUUPUU
        MYPUVKVNUULUUTUVKNFEYOUOUVLUFWMWNAEUVKLMORUAUGUEUVLUIXMXCZAUVMKLMORUVCU
        AUGUBUVNUIAUVOUVQUWBUVCUVMVNUVRUVSUWCUVBUVMUVAUUDKUVNUWMWPWBZXNXOXJAUVF
        UVCUVEAUVBPQKYLUUCUCUDUWMUVRUMUKXPAUVMKLMORUVCUAUGUBUVNUIUWPXQXRXHXSAUU
        BUUGDUUEAYSUUEVNZXTZUUBUUGUWRUUBXTZYRUUFYQVAZVEUUGUWSYRUUAUWTUWRUUBYAUW
        SUVMKLMORUUAUAUGUBUVNAMYBVNRLVNXTUWQUUBUIYCZUWSUVOYTQVNZUUAUVMVNAUVOUWQ
        UUBUVRYCZUWSUVOUVPYSQVNUXBUXCAUVPUWQUUBUMYCZUWSBCDEFHIJKLMNOPQRSTUAUBUC
        UDUEUFUGUHUXAAYNUUOVNUWQUUBUJYCAUWAUWQUUBUKYCAUWLUWQUUBULYCUXDAYLUUDVNY
        GUWQUUBUNYCUOUPUQURAUWQUUBYHYDGQKYLYSUCUSVQWBUVMPQKYTUCUVNUDWMWNZXQXRUW
        SLMORYPUUFUAUGUXAAYPUWNVNUWQUUBUWOYCUWSUVMKLMORUUAUAUGUBUVNUXAUXEXNYEYF
        YIYJYK $.

      $( Lemma for ~ hdmaprnN .  Show ` s ` is in the range of ` S ` .
         (Contributed by NM, 29-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem10N $p |- ( ph
          -> E. t e. V ( S ` t ) = s ) $=
        ( cv cfv co csn wceq cdif wrex hdmaprnlem3eN wcel wa chlt adantr simprl
        wn hdmaprnlem4tN simprr hdmaprnlem9N eqcomd jca ex reximdv2 mpd ) ACUTZ
        JVATUTZHVBVCNVAWBDUTZGVBVCPVAOVAVDZDBUTZVCPVAZSVCVEZVFWDJVAZWCVDZDQVFAB
        CDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSVGAWEWJDWHQAWDW
        HVHZWEVIZWDQVHZWJVIAWLVIZWMWJWNBCDEFHIJKLMNOPQRSTUAUBUCUDUEUFUGUHAMVJVH
        RLVHVIWLUIVKZAWCFIVCVEVHWLUJVKZAWFQVHWLUKVKZAWGOVAWCVCNVAVDWLULVKZAWBQV
        HWLUMVKZAWBWGVHVMWLUNVKZUOUPUQURAWKWEVLZVNWNWCWIWNBCDEFGHIJKLMNOPQRSTUA
        UBUCUDUEUFUGUHWOWPWQWRWSWTUOUPUQURXAUSAWKWEVOVPVQVRVSVTWA $.

      $( Lemma for ~ hdmaprnN .  Show ` s ` is in the range of ` S ` .
         (Contributed by NM, 29-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem11N $p |- ( ph -> s e. ran S ) $=
        ( vt cv crn wcel cfv wceq wrex hdmaprnlem10N wb hdmapfnN fvelrnb mpbird
        wfn syl ) ASUTZIVAVBZUSUTIVCVMVDUSPVEZABCUSDEFGHIJKLMNOPQRSTUAUBUCUDUEU
        FUGUHUIUJUKULUMUNUOUPUQURVFAIPVKVNVOVGAIJKLPQTUAUBUGUHVHUSPVMIVIVLVJ $.
    $}

  $}

  ${
    hdmaprnlem15.h $e |- H = ( LHyp ` K ) $.
    hdmaprnlem15.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaprnlem15.v $e |- V = ( Base ` U ) $.
    hdmaprnlem15.n $e |- N = ( LSpan ` U ) $.
    hdmaprnlem15.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmaprnlem15.d $e |- D = ( Base ` C ) $.
    hdmaprnlem15.q $e |- .0. = ( 0g ` C ) $.
    hdmaprnlem15.l $e |- L = ( LSpan ` C ) $.
    hdmaprnlem15.m $e |- M = ( ( mapd ` K ) ` W ) $.
    hdmaprnlem15.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaprnlem15.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      $d t N $.  $d t S $.  $d t U $.  $d t V $.  $d t ph $.  $d t s v $.
      hdmaprnlem15.se $e |- ( ph -> s e. ( D \ { .0. } ) ) $.
      hdmaprnlem15.ve $e |- ( ph -> v e. V ) $.
      hdmaprnlem15.e $e |- ( ph -> ( M ` ( N ` { v } ) ) = ( L ` { s } ) ) $.
      $( Lemma for ~ hdmaprnN .  Eliminate ` u ` .  (Contributed by NM,
         30-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem15N $p |- ( ph -> s e. ran S ) $=
        ( vt cv csn cfv wcel wrex crn dvh2dim w3a cplusg c0g chlt 3ad2ant1 cdif
        wn wa wceq simp2 simp3 eqid hdmaprnlem11N rexlimdv3a mpd ) AUJUKZBUKZUL
        KUMZUNVDZUJLUOOUKZEUPUNZAUJFGHKLMVNPQRSUFUHUQAVPVRUJLAVMLUNZVPURBUJCDFU
        SUMZCUSUMZNEFGHIJKLMFUTUMZOPQRSTUCUDUEAVSHVAUNMGUNVEVPUFVBAVSVQDNULVCUN
        VPUGVBAVSVNLUNVPUHVBAVSVOJUMVQULIUMVFVPUIVBAVSVPVGAVSVPVHUAUBWBVIWAVIVT
        VIVJVKVL $.
    $}

    ${
      $d v L $.  $d v M $.  $d v N $.  $d v S $.  $d v U $.  $d v V $.
      $d v ph $.  $d v s $.
      hdmaprnlem16.se $e |- ( ph -> s e. ( D \ { .0. } ) ) $.
      $( Lemma for ~ hdmaprnN .  Eliminate ` v ` .  (Contributed by NM,
         30-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem16N $p |- ( ph -> s e. ran S ) $=
        ( vv cv csn cfv wceq wrex crn wcel ccnv clmod clsa dvhlmod eqid lcdlmod
        lsatlspsn mapdcnvatN islsati syl2anc wa simpr fveq2d chlt ad2antrr clss
        eldifad lspsncl mapdrn2 eleqtrrd mapdcnvid2 eqtr3d ex reximdva 3ad2ant1
        mpd w3a cdif simp2 simp3 hdmaprnlem15N rexlimdv3a ) AUGUHZUIJUJZIUJZNUH
        ZUIHUJZUKZUGKULZWJDUMUNZAWKIUOUJZWHUKZUGKULZWMAEUPUNWOEUQUJZUNWQAEFGLOP
        UEURAWRBUQUJZBWKEFGILOUCPWRUSZSWSUSZUEAWSHCBWJMTUBUAXAABFGLOSUEUTZUFVAV
        BUGWRWOJKEUPQRWTVCVDAWPWLUGKAWGKUNZVEZWPWLXDWPVEZWOIUJWIWKXEWOWHIXDWPVF
        VGXEFGILWKOUCAGVHUNLFUNVEZXCWPUEVIAWKIUMZUNXCWPAWKBVJUJZXGABUPUNWJCUNWK
        XHUNXBAWJCMUIZUFVKXHHCBWJTXHUSZUBVLVDABXHFGILOUCSXJUEVMVNVIVOVPVQVRVTAW
        LWNUGKAXCWLWAUGBCDEFGHIJKLMNOPQRSTUAUBUCUDAXCXFWLUEVSAXCWJCXIWBUNWLUFVS
        AXCWLWCAXCWLWDWEWFVT $.
    $}

    ${
      hdmaprnlem17.se $e |- ( ph -> s e. D ) $.
      $( Lemma for ~ hdmaprnN .  Include zero.  (Contributed by NM,
         30-May-2015.)  (New usage is discouraged.) $)
      hdmaprnlem17N $p |- ( ph -> s e. ran S ) $=
        ( cv crn wcel eleq1 wne wa chlt adantr csn anim1i eldifsn hdmaprnlem16N
        cdif sylibr c0g cfv eqid hdmapval0 wfn hdmapfnN clmod lmod0vcl fnfvelrn
        dvhlmod syl syl2anc eqeltrrd pm2.61ne ) ANUGZDUHZUIMVPUIVOMVOMVPUJAVOMU
        KZULZBCDEFGHIJKLMNOPQRSTUAUBUCUDAGUMUILFUIULVQUEUNVRVOCUIZVQULVOCMUOUSU
        IAVSVQUFUPVOCMUQUTURAEVAVBZDVBZMVPABMDEFGLVTOPVTVCZSUAUDUEVDADKVEVTKUIZ
        WAVPUIADEFGKLOPQUDUEVFAEVGUIWCAEFGLOPUEVJKEVTQWBVHVKKVTDVIVLVMVN $.
    $}
  $}

  ${
    $d s D $.  $d s K $.  $d s S $.  $d s W $.  $d s ph $.
    hdmaprn.h $e |- H = ( LHyp ` K ) $.
    hdmaprn.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmaprn.d $e |- D = ( Base ` C ) $.
    hdmaprn.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaprn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Part of proof of part 12 in [Baer] p. 49 line 21, As=B. (Contributed by
       NM, 30-May-2015.)  (New usage is discouraged.) $)
    hdmaprnN $p |- ( ph -> ran S = D ) $=
      ( vs cfv wcel eqid wa adantr simpr clspn crn cdvh cbs wfn cv wss hdmapfnN
      wral chlt hdmapcl ralrimiva fnfvrnss syl2anc cmpd c0g hdmaprnlem17N ssrdv
      ex eqssd ) ADUAZCADGFUBNNZUCNZUDMUEZDNCOZMVBUHUTCUFADVAEFVBGHVAPZVBPZKLUG
      AVDMVBAVCVBOZQBCDVCVAEFVBGHVEVFIJKAFUIOGEOQZVGLRAVGSUJUKMVBCDULUMAMCUTAVC
      COZVCUTOAVIQBCDVAEFBTNZGFUNNNZVATNZVBGBUONZMHVEVFVLPIJVMPVJPVKPKAVHVILRAV
      ISUPURUQUS $.
  $}

  ${
    $d x y S $.  $d x y V $.  $d x y ph $.
    hdmapf1o.h $e |- H = ( LHyp ` K ) $.
    hdmapf1o.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapf1o.v $e |- V = ( Base ` U ) $.
    hdmapf1o.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmapf1o.d $e |- D = ( Base ` C ) $.
    hdmapf1o.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapf1o.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Part 12 in [Baer] p. 49.  The map from vectors to functionals with
       closed kernels maps one-to-one onto.  Combined with ~ hdmapadd , this
       shows the map is an automorphism from the additive group of vectors to
       the additive group of functionals with closed kernels.  (Contributed by
       NM, 30-May-2015.)  (New usage is discouraged.) $)
    hdmapf1oN $p |- ( ph -> S : V -1-1-onto-> D ) $=
      ( vx vy wcel wa wfn crn wceq cv cfv wi wral wf1o hdmapfnN hdmaprnN adantr
      weq chlt simprl simprr hdmap11 biimpd ralrimivva dff1o6 syl3anbrc ) ADHUA
      DUBCUCQUDZDUERUDZDUEUCZQRULZUFZRHUGQHUGHCDUHADEFGHIJKLOPUIABCDFGIJMNOPUJA
      VEQRHHAVAHSZVBHSZTZTZVCVDVIDEFGHIVAVBJKLOAGUMSIFSTVHPUKAVFVGUNAVFVGUOUPUQ
      URQRHCDUSUT $.
  $}

  ${
    hdmap14lem1a.h $e |- H = ( LHyp ` K ) $.
    hdmap14lem1a.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap14lem1a.v $e |- V = ( Base ` U ) $.
    hdmap14lem1a.t $e |- .x. = ( .s ` U ) $.
    hdmap14lem1a.r $e |- R = ( Scalar ` U ) $.
    hdmap14lem1a.b $e |- B = ( Base ` R ) $.
    hdmap14lem1a.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap14lem2a.e $e |- .xb = ( .s ` C ) $.
    hdmap14lem1a.l $e |- L = ( LSpan ` C ) $.
    hdmap14lem2a.p $e |- P = ( Scalar ` C ) $.
    hdmap14lem2a.a $e |- A = ( Base ` P ) $.
    hdmap14lem1a.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap14lem1a.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap14lem3a.x $e |- ( ph -> X e. V ) $.
    hdmap14lem1a.f $e |- ( ph -> F e. B ) $.
    ${
      hdmap14lem1a.z $e |- .0. = ( 0g ` R ) $.
      hdmap14lem1a.fn $e |- ( ph -> F =/= .0. ) $.
      $( Prior to part 14 in [Baer] p. 49, line 25.  (Contributed by NM,
         31-May-2015.) $)
      hdmap14lem1a $p |- ( ph
           -> ( L ` { ( S ` X ) } ) = ( L ` { ( S ` ( F .x. X ) ) } ) ) $=
        ( csn clspn cfv cmpd clvec wcel wne wceq dvhlvec eqid lspsnvs syl121anc
        co fveq2d clmod dvhlmod lmodvscl syl3anc hdmap10 3eqtr3rd ) AKQIVHZUPJU
        QURZURZPMUSURURZURQUPVQURZVSURVPGURUPNURQGURUPNURAVRVTVSAJUTVAKCVAZKRVB
        QOVAZVRVTVCAJLMPSTUKVDUMUOULKIFCVQOJQRUAUCUBUDUNVQVEZVFVGVIADGVPJLMNVSV
        QOPSTUAWCUEUGVSVEZUJUKAJVJVAWAWBVPOVAAJLMPSTUKVKUMULKIFCOJQUAUCUBUDVLVM
        VNADGQJLMNVSVQOPSTUAWCUEUGWDUJUKULVNVO $.
    $}

    $d g A $.  $d g F $.  $d g P $.  $d g R $.  $d g .x. $.  $d g .xb $.
    $d g S $.  $d g X $.
    $( Prior to part 14 in [Baer] p. 49, line 25.  TODO: fix to include
       ` F = .0. ` so it can be used in ~ hdmap14lem10 .  (Contributed by NM,
       31-May-2015.) $)
    hdmap14lem2a $p |- ( ph
         -> E. g e. A ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) $=
      ( co cfv cv wceq wrex c0g oveq1 fveq2d eqeq1d rexbidv csn cdif wss wne wa
      difss chlt wcel adantr eqid simpr hdmap14lem1a eqcomd cbs lcdlvec dvhlmod
      clmod lmodvscl syl3anc hdmapcl lspsneq mpbid ssrexv mpsyl lcdlmod lmod0cl
      wb syl hdmapval0 lmod0vs syl2anc 3eqtr4d eqeq2d rspcev pm2.61ne ) ALRIUNZ
      GUOZKUPZRGUOZHUNZUQZKBURZFUSUOZRIUNZGUOZXCUQZKBURZLXFLXFUQZXDXIKBXKWTXHXC
      XKWSXGGLXFRIUTVAVBVCBEUSUOZVDZVEZBVFALXFVGZVHZXDKXNURZXEBXMVIXPWTVDOUOZXB
      VDOUOZUQZXQXPXSXRXPBCDEFGHIJLMNOPQRXFSTUAUBUCUDUEUFUGUHUIUJANVJVKQMVKVHXO
      UKVLARPVKZXOULVLALCVKZXOUMVLXFVMZAXOVNVOVPAXTXQWJXOAEHKBODVQUOZDWTXBXLYDV
      MZUHUIXLVMZUFUGADMNQSUEUKVRADYDGWSJMNPQSTUAUEYEUJUKAJVTVKZYBYAWSPVKAJMNQS
      TUKVSZUMULLIFCPJRUAUCUBUDWAWBWCADYDGRJMNPQSTUAUEYEUJUKULWCZWDVLWEXDKXNBWF
      WGAXLBVKZXHXLXBHUNZUQZXJADVTVKZYJADMNQSUEUKWHZEBDXLUHUIYFWIWKAJUSUOZGUODU
      SUOZXHYKADYPGJMNQYOSTYOVMZUEYPVMZUJUKWLAXGYOGAYGYAXGYOUQYHULIFXFPJRYOUAUC
      UBYCYQWMWNVAAYMXBYDVKYKYPUQYNYIHEXLYDDXBYPYEUHUFYFYRWMWNWOXIYLKXLBXAXLUQX
      CYKXHXAXLXBHUTWPWQWNWR $.
  $}

  ${
    hdmap14lem1.h $e |- H = ( LHyp ` K ) $.
    hdmap14lem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap14lem1.v $e |- V = ( Base ` U ) $.
    hdmap14lem1.t $e |- .x. = ( .s ` U ) $.
    hdmap14lem3.o $e |- .0. = ( 0g ` U ) $.
    hdmap14lem1.r $e |- R = ( Scalar ` U ) $.
    hdmap14lem1.b $e |- B = ( Base ` R ) $.
    hdmap14lem1.z $e |- Z = ( 0g ` R ) $.
    hdmap14lem1.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap14lem2.e $e |- .xb = ( .s ` C ) $.
    hdmap14lem1.l $e |- L = ( LSpan ` C ) $.
    hdmap14lem2.p $e |- P = ( Scalar ` C ) $.
    hdmap14lem2.a $e |- A = ( Base ` P ) $.
    hdmap14lem2.q $e |- Q = ( 0g ` P ) $.
    hdmap14lem1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap14lem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap14lem3.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    ${
      hdmap14lem1.f $e |- ( ph -> F e. ( B \ { Z } ) ) $.
      $( Prior to part 14 in [Baer] p. 49, line 25.  (Contributed by NM,
         31-May-2015.) $)
      hdmap14lem1 $p |- ( ph
           -> ( L ` { ( S ` X ) } ) = ( L ` { ( S ` ( F .x. X ) ) } ) ) $=
        ( csn eldifad cdif wcel wne eldifsni syl hdmap14lem1a ) ABCDEGHIJKLMNOP
        QRTUAUBUCUDUFUGUIUJUKULUMUOUPARPSUSUQUTALCTUSZURUTUHALCVGVAVBLTVCURLCTV
        DVEVF $.

      $d g A $.  $d g .xb $.  $d g F $.  $d g Q $.  $d g S $.  $d g .x. $.
      $d g X $.
      $( Prior to part 14 in [Baer] p. 49, line 25.  TODO: fix to include
         ` F = Z ` so it can be used in ~ hdmap14lem10 .  (Contributed by NM,
         31-May-2015.)  (New usage is discouraged.) $)
      hdmap14lem2N $p |- ( ph
        -> E. g e. ( A \ { Q } ) ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) $=
        ( co cfv csn wceq cv cdif wrex hdmap14lem1 eqcomd cbs eqid lcdlvec wcel
        clmod dvhlmod eldifad lmodvscl syl3anc hdmapcl lspsneq mpbid ) AMSJUTZH
        VAZVBPVAZSHVAZVBPVAZVCWBLVDWDIUTVCLBFVBVEVFAWEWCABCDEFGHIJKMNOPQRSTUAUB
        UCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSVGVHAEILBPDVIVAZDWBWDFWFVJZUMUNUOUKUL
        ADNORUBUJUQVKADWFHWAKNOQRUBUCUDUJWGUPUQAKVMVLMCVLSQVLWAQVLAKNORUBUCUQVN
        AMCUAVBUSVOASQTVBURVOZMJGCQKSUDUGUEUHVPVQVRADWFHSKNOQRUBUCUDUJWGUPUQWHV
        RVSVT $.

      $( Prior to part 14 in [Baer] p. 49, line 26.  (Contributed by NM,
         31-May-2015.) $)
      hdmap14lem3 $p |- ( ph
        -> E! g e. ( A \ { Q } ) ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) $=
        ( co cfv csn wceq cv cdif wreu hdmap14lem1 eqcomd cbs c0g lcdlvec clmod
        eqid dvhlmod eldifad lmodvscl syl3anc hdmapcl hdmapnzcl lspsneu mpbid
        wcel ) AMSJUTZHVAZVBPVAZSHVAZVBPVAZVCWDLVDWFIUTVCLBFVBVEVFAWGWEABCDEFGH
        IJKMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSVGVHAEILBPFDVIVAZDWDWF
        DVJVAZWHVMZUMUNUOUKWIVMZULADNORUBUJUQVKADWHHWCKNOQRUBUCUDUJWJUPUQAKVLWB
        MCWBSQWBWCQWBAKNORUBUCUQVNAMCUAVBUSVOASQTVBURVOMJGCQKSUDUGUEUHVPVQVRADW
        HWIHSKNOQRTUBUCUDUFUJWKWJUPUQURVSVTWA $.

      $d g ph $.
      $( Simplify ` ( A \ { Q } ) ` in ~ hdmap14lem3 to provide a slightly
         simpler definition later.  (Contributed by NM, 31-May-2015.) $)
      hdmap14lem4a $p |- ( ph
       -> ( E! g e. ( A \ { Q } ) ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) )
         <-> E! g e. A ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) ) $=
        ( co cfv cv wceq csn cdif cun wreu wrex wn wb wcel wa c0g wne cbs clmod
        eqid dvhlmod eldifad lmodvscl syl3anc eldifsni dvhlvec lvecvsn0 eldifsn
        syl mpbir2and sylanbrc hdmapnzcl adantr lcdlmod hdmapcl lmod0vs syl2anc
        elsni oveq1d sylan9eqr neneqd nrexdv reuun2 lmod0cl difsnid reueq1 4syl
        neeqtrrd bitr3d ) AMSJUTZHVAZLVBZSHVAZIUTZVCZLBFVDZVEZXMVFZVGZXLLXNVGZX
        LLBVGZAXLLXMVHVIXPXQVJAXLLXMAXIXMVKZVLZXHXKXTXHDVMVAZXKAXHYAVNZXSAXHDVO
        VAZYAVDVEVKYBADYCYAHXGKNOQRTUBUCUDUFUJYAVQZYCVQZUPUQAXGQVKZXGTVNZXGQTVD
        ZVEZVKAKVPVKMCVKSQVKYFAKNORUBUCUQVRAMCUAVDZUSVSZASQYHURVSZMJGCQKSUDUGUE
        UHVTWAAYGMUAVNZSTVNZAMCYJVEVKYMUSMCUAWBWFASYIVKYNURSQTWBWFAMJGCUAQKSTUD
        UEUGUHUIUFAKNORUBUCUQWCYKYLWDWGXGQTWEWHWIXHYCYAWBWFWJXSAXKFXJIUTZYAXSXI
        FXJIXIFWOWPADVPVKZXJYCVKYOYAVCADNORUBUJUQWKZADYCHSKNOQRUBUCUDUJYEUPUQYL
        WLIEFYCDXJYAYEUMUKUOYDWMWNWQXEWRWSXLLXNXMWTWFAYPFBVKXOBVCXPXRVJYQEBDFUM
        UNUOXABFXBXLLXOBXCXDXF $.

      $( Simplify ` ( A \ { Q } ) ` in ~ hdmap14lem3 to provide a slightly
         simpler definition later.  TODO:  Use ~ hdmap14lem4a if that one is
         also used directly elsewhere.  Otherwise, merge ~ hdmap14lem4a into
         this one.  (Contributed by NM, 31-May-2015.) $)
      hdmap14lem4 $p |- ( ph
           -> E! g e. A ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) $=
        ( co cfv cv wceq csn cdif wreu hdmap14lem3 hdmap14lem4a mpbid ) AMSJUTH
        VALVBSHVAIUTVCZLBFVDVEVFVJLBVFABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
        KULUMUNUOUPUQURUSVGABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUP
        UQURUSVHVI $.
    $}

    ${
      $d g h A $.  $d g h C $.  $d g h .xb $.  $d g Q $.  $d g h S $.
      $d g h X $.  $d g h ph $.
      hdmap14lem6.f $e |- ( ph -> F = Z ) $.
      $( Case where ` F ` is zero.  (Contributed by NM, 1-Jun-2015.) $)
      hdmap14lem6 $p |- ( ph
           -> E! g e. A ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) $=
        ( vh co cfv cv wceq wreu c0g wrex wa wi wral wcel clmod lcdlmod lmod0cl
        weq syl cbs eqid csn eldifad hdmapcl lmod0vs eqcomd oveq1 eqeq2d rspcev
        syl2anc w3a wn cdif wne hdmapnzcl eldifsni neneqd 3ad2ant1 simp3l clvec
        lcdlvec simp2l lvecvs0or mpbid orcomd ord mpd simp3r simp2r eqtr4d 3exp
        wo ralrimivv reu4 sylanbrc oveq1d dvhlmod eqtrd fveq2d hdmapval0 eqeq1d
        reubidv mpbird ) AMSJVAZHVBZLVCZSHVBZIVAZVDZLBVEDVFVBZYEVDZLBVEZAYHLBVG
        ZYHYGUTVCZYDIVAZVDZVHZLUTVOZVIZUTBVJLBVJYIAFBVKZYGFYDIVAZVDZYJADVLVKZYQ
        ADNORUBUJUQVMZEBDFUMUNUOVNVPAYRYGAYTYDDVQVBZVKZYRYGVDUUAADUUBHSKNOQRUBU
        CUDUJUUBVRZUPUQASQTVSURVTZWAZIEFUUBDYDYGUUDUMUKUOYGVRZWBWGWCYHYSLFBYCFV
        DZYEYRYGYCFYDIWDWEWFWGAYPLUTBBAYCBVKZYKBVKZVHZYNYOAUUKYNWHZYCFYKUULYDYG
        VDZWIZUUHAUUKUUNYNAYDYGAYDUUBYGVSWJVKYDYGWKADUUBYGHSKNOQRTUBUCUDUFUJUUG
        UUDUPUQURWLYDUUBYGWMVPWNWOZUULUUMUUHUULUUHUUMUULYEYGVDUUHUUMXIUULYGYEAU
        UKYHYMWPWCUULYCIEBFUUBDYDYGUUDUKUMUNUOUUGAUUKDWQVKYNADNORUBUJUQWRWOZAUU
        IUUJYNWSAUUKUUCYNUUFWOZWTXAXBXCXDUULUUNYKFVDZUUOUULUUMUURUULUURUUMUULYL
        YGVDUURUUMXIUULYGYLAUUKYHYMXEWCUULYKIEBFUUBDYDYGUUDUKUMUNUOUUGUUPAUUIUU
        JYNXFUUQWTXAXBXCXDXGXHXJYHYMLUTBYOYEYLYGYCYKYDIWDWEXKXLAYFYHLBAYBYGYEAY
        BTHVBYGAYATHAYAUASJVAZTAMUASJUSXMAKVLVKSQVKUUSTVDAKNORUBUCUQXNUUEJGUAQK
        STUDUGUEUIUFWBWGXOXPADYGHKNORTUBUCUFUJUUGUPUQXQXOXRXSXT $.
    $}
  $}

  ${
    $d g A $.  $d g C $.  $d g F $.  $d g P $.  $d g R $.  $d g S $.  $d g X $.
    $d g ph $.  $d g .x. $.  $d g .xb $.
    hdmap14lem7.h $e |- H = ( LHyp ` K ) $.
    hdmap14lem7.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap14lem7.v $e |- V = ( Base ` U ) $.
    hdmap14lem7.t $e |- .x. = ( .s ` U ) $.
    hdmap14lem7.o $e |- .0. = ( 0g ` U ) $.
    hdmap14lem7.r $e |- R = ( Scalar ` U ) $.
    hdmap14lem7.b $e |- B = ( Base ` R ) $.
    hdmap14lem7.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap14lem7.e $e |- .xb = ( .s ` C ) $.
    hdmap14lem7.p $e |- P = ( Scalar ` C ) $.
    hdmap14lem7.a $e |- A = ( Base ` P ) $.
    hdmap14lem7.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap14lem7.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap14lem7.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap14lem7.f $e |- ( ph -> F e. B ) $.
    $( Combine cases of ` F ` .  TODO:  Can this be done at once in
       ~ hdmap14lem3 , in order to get rid of ~ hdmap14lem6 ?  Perhaps modify
       ~ lspsneu to become ` E! k e. K ` instead of
       ` E! k e. ( K \ { .0. } ) ` ?  (Contributed by NM, 1-Jun-2015.) $)
    hdmap14lem7 $p |- ( ph
         -> E! g e. A ( S ` ( F .x. X ) ) = ( g .xb ( S ` X ) ) ) $=
      ( co cfv cv wceq wreu c0g wa clspn eqid chlt wcel adantr cdif hdmap14lem6
      csn simpr wne eldifsn sylanbrc hdmap14lem4 pm2.61dane ) ALQIUNGUOKUPQGUOH
      UNUQKBURLFUSUOZALVOUQZUTBCDEEUSUOZFGHIJKLMNDVAUOZOPQRVOSTUAUBUCUDUEVOVBZU
      FUGVRVBZUHUIVQVBZUJANVCVDPMVDUTZVPUKVEAQORVHVFVDZVPULVEAVPVIVGALVOVJZUTZB
      CDEVQFGHIJKLMNVROPQRVOSTUAUBUCUDUEVSUFUGVTUHUIWAUJAWBWDUKVEAWCWDULVEWELCV
      DZWDLCVOVHVFVDAWFWDUMVEAWDVILCVOVKVLVMVN $.
  $}

  ${
    hdmap14lem8.h $e |- H = ( LHyp ` K ) $.
    hdmap14lem8.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap14lem8.v $e |- V = ( Base ` U ) $.
    hdmap14lem8.q $e |- .+ = ( +g ` U ) $.
    hdmap14lem8.t $e |- .x. = ( .s ` U ) $.
    hdmap14lem8.o $e |- .0. = ( 0g ` U ) $.
    hdmap14lem8.n $e |- N = ( LSpan ` U ) $.
    hdmap14lem8.r $e |- R = ( Scalar ` U ) $.
    hdmap14lem8.b $e |- B = ( Base ` R ) $.
    hdmap14lem8.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap14lem8.d $e |- .+b = ( +g ` C ) $.
    hdmap14lem8.e $e |- .xb = ( .s ` C ) $.
    hdmap14lem8.p $e |- P = ( Scalar ` C ) $.
    hdmap14lem8.a $e |- A = ( Base ` P ) $.
    hdmap14lem8.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap14lem8.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap14lem8.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmap14lem8.y $e |- ( ph -> Y e. ( V \ { .0. } ) ) $.
    hdmap14lem8.f $e |- ( ph -> F e. B ) $.
    hdmap14lem8.g $e |- ( ph -> G e. A ) $.
    hdmap14lem8.i $e |- ( ph -> I e. A ) $.
    hdmap14lem8.xx $e |- ( ph -> ( S ` ( F .x. X ) ) = ( G .xb ( S ` X ) ) ) $.
    hdmap14lem8.yy $e |- ( ph -> ( S ` ( F .x. Y ) ) = ( I .xb ( S ` Y ) ) ) $.
    ${
      hdmap14lem8.ne $e |- ( ph -> ( N ` { X } ) =/= ( N ` { Y } ) ) $.
      ${
        hdmap14lem8.j $e |- ( ph -> J e. A ) $.
        hdmap14lem8.xy $e |- ( ph
            -> ( S ` ( F .x. ( X .+ Y ) ) ) = ( J .xb ( S ` ( X .+ Y ) ) ) ) $.
        $( Part of proof of part 14 in [Baer] p. 49 lines 33-35.  (Contributed
           by NM, 1-Jun-2015.) $)
        hdmap14lem8 $p |- ( ph
           -> ( ( J .xb ( S ` X ) ) .+b ( J .xb ( S ` Y ) ) )
            = ( ( G .xb ( S ` X ) ) .+b ( I .xb ( S ` Y ) ) ) ) $=
          ( cfv co wcel cbs wceq lcdlmod eqid eldifad hdmapcl lmodvsdi syl13anc
          hdmapadd oveq2d dvhlmod fveq2d lmodvscl syl3anc oveq12d 3eqtrd eqtr3d
          clmod csn ) AQUBIVKZUCIVKZGVLZJVLZQWMJVLQWNJVLGVLZNWMJVLZPWNJVLZGVLZA
          DWKVMQBVMWMDVNVKZVMWNXAVMWPWQVOADORUAUEUNUTVPVIADXAIUBLORTUAUEUFUGUNX
          AVQZUSUTAUBTUDWLZVAVRZVSADXAIUCLORTUAUEUFUGUNXBUSUTAUCTXCVBVRZVSGQJEB
          XADWMWNXBUOUQUPURVTWAAQUBUCFVLZIVKZJVLZWPWTAXGWOQJADFGILORTUAUBUCUEUF
          UGUHUNUOUSUTXDXEWBWCAMXFKVLZIVKZXHWTVJAXJMUBKVLZMUCKVLZFVLZIVKXKIVKZX
          LIVKZGVLWTAXIXMIALWKVMZMCVMZUBTVMZUCTVMZXIXMVOALORUAUEUFUTWDZVCXDXEFM
          KHCTLUBUCUGUHULUIUMVTWAWEADFGILORTUAXKXLUEUFUGUHUNUOUSUTAXPXQXRXKTVMX
          TVCXDMKHCTLUBUGULUIUMWFWGAXPXQXSXLTVMXTVCXEMKHCTLUCUGULUIUMWFWGWBAXNW
          RXOWSGVFVGWHWIWJWJWJ $.

        $( Part of proof of part 14 in [Baer] p. 49 line 38.  (Contributed by
           NM, 1-Jun-2015.) $)
        hdmap14lem9 $p |- ( ph -> G = I ) $=
          ( wceq clspn cfv cbs c0g eqid lcdlvec hdmapnzcl csn cmpd clss dvhlmod
          clmod eldifad lspsncl syl2anc mapd11 necon3bid mpbird hdmap10 3netr3d
          wne wcel hdmap14lem8 lvecindp2 simpld simprd eqtr3d ) AQNPAQNVKZQPVKZ
          AQQNPGJEBDVLVMZDVNVMZDUBIVMZUCIVMZDVOVMZXBVPZUOUQURUPXEVPZXAVPZADORUA
          UEUNUTVQADXBXEIUBLORTUAUDUEUFUGUJUNXGXFUSUTVAVRADXBXEIUCLORTUAUDUEUFU
          GUJUNXGXFUSUTVBVRVIVIVDVEAUBVSSVMZUARVTVMVMZVMZUCVSSVMZXJVMZXCVSXAVMX
          DVSXAVMAXKXMWLXIXLWLVHAXKXMXIXLALWAVMZLORXJUAXIXLUEUFXNVPZXJVPZUTALWC
          WMZUBTWMXIXNWMALORUAUEUFUTWBZAUBTUDVSZVAWDZXNSTLUBUGXOUKWEWFAXQUCTWMX
          LXNWMXRAUCTXSVBWDZXNSTLUCUGXOUKWEWFWGWHWIADIUBLORXAXJSTUAUEUFUGUKUNXH
          XPUSUTXTWJADIUCLORXAXJSTUAUEUFUGUKUNXHXPUSUTYAWJWKABCDEFGHIJKLMNOPQRS
          TUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVDVEVFVGVHVIVJWNWOZWPA
          WSWTYBWQWR $.
      $}

      $d g A $.  $d g C $.  $d g .xb $.  $d g F $.  $d g G $.  $d g I $.
      $d g P $.  $d g .+ $.  $d g R $.  $d g S $.  $d g .x. $.  $d g X $.
      $d g Y $.  $d g ph $.
      $( Part of proof of part 14 in [Baer] p. 49 line 38.  (Contributed by NM,
         3-Jun-2015.) $)
      hdmap14lem10 $p |- ( ph -> G = I ) $=
        ( vg co cfv cv wceq wrex clspn eqid clmod wcel dvhlmod eldifad lmodvacl
        csn syl3anc hdmap14lem2a w3a chlt 3ad2ant1 cdif simp2 simp3 hdmap14lem9
        wa wne rexlimdv3a mpd ) AMUAUBFVIZKVIIVJVHVKZWOIVJJVIVLZVHBVMNPVLZABCDE
        HIJKLVHMOQDVNVJZSTWOUDUEUFUHUKULUMUOWSVOUPUQURUSALVPVQUASVQUBSVQWOSVQAL
        OQTUDUEUSVRAUASUCWAZUTVSAUBSWTVAVSFSLUAUBUFUGVTWBVBWCAWQWRVHBAWPBVQZWQW
        DBCDEFGHIJKLMNOPWPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURAXAQWEVQTOVQW
        KWQUSWFAXAUASWTWGZVQWQUTWFAXAUBXBVQWQVAWFAXAMCVQWQVBWFAXANBVQWQVCWFAXAP
        BVQWQVDWFAXAMUAKVIIVJNUAIVJJVIVLWQVEWFAXAMUBKVIIVJPUBIVJJVIVLWQVFWFAXAU
        AWARVJUBWARVJWLWQVGWFAXAWQWHAXAWQWIWJWMWN $.
    $}

    $d g A $.  $d g .xb $.  $d g F $.  $d g z G $.  $d g z I $.  $d g z N $.
    $d g P $.  $d g R $.  $d g S $.  $d g .x. $.  $d z U $.  $d g z V $.
    $d g z X $.  $d g z Y $.  $d g z ph $.
    $( Part of proof of part 14 in [Baer] p. 50 line 3.  (Contributed by NM,
       3-Jun-2015.) $)
    hdmap14lem11 $p |- ( ph -> G = I ) $=
      ( vz vg cv cpr cfv wcel wn wrex wceq csn eldifad dvh3dim w3a co eqid chlt
      clspn wa 3ad2ant1 simp2 hdmap14lem2a simp11 syl clss clmod dvhlmod simp12
      lspprcl simp13 lssneln0 cdif simp3 wne clvec lspindpi simpld hdmap14lem10
      dvhlvec simprd eqtr3d rexlimdv3a mpd ) AVGVIZUAUBVJRVKZVLVMZVGSVNNPVOZAVG
      LOQRSTUAUBUDUEUFUJUSAUASUCVPZUTVQZAUBSXMVAVQZVRAXKXLVGSAXISVLZXKVSZMXIKVT
      IVKVHVIZXIIVKJVTVOZVHBVNXLXQBCDEHIJKLVHMOQDWCVKZSTXIUDUEUFUHUKULUMUOXTWAU
      PUQURAXPQWBVLTOVLWDZXKUSWEAXPXKWFAXPMCVLZXKVBWEWGXQXSXLVHBXQXRBVLZXSVSZXR
      NPYDBCDEFGHIJKLMXRONQRSTXIUAUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURYDAYAAXPXKYCX
      SWHZUSWIZYDLWJVKZXJSLXIUCUFUIYGWAZYDALWKVLYEALOQTUDUEUSWLZWIYDAXJYGVLYEAY
      GRSLUAUBUFYHUJYIXNXOWNWIAXPXKYCXSWMZAXPXKYCXSWOZWPZYDAUASXMWQZVLYEUTWIYDA
      YBYEVBWIZXQYCXSWFZYDANBVLYEVCWIXQYCXSWRZYDAMUAKVTIVKNUAIVKJVTVOYEVEWIYDXI
      VPRVKZUAVPRVKWSZYQUBVPRVKWSZYDRSLXIUAUBUFUJYDALWTVLYEALOQTUDUEUSXDWIYJYDA
      UASVLYEXNWIYDAUBSVLYEXOWIYKXAZXBXCYDBCDEFGHIJKLMXROPQRSTXIUBUCUDUEUFUGUHU
      IUJUKULUMUNUOUPUQURYFYLYDAUBYMVLYEVAWIYNYOYDAPBVLYEVDWIYPYDAMUBKVTIVKPUBI
      VKJVTVOYEVFWIYDYRYSYTXEXCXFXGXHXGXH $.
  $}

  ${
    $d g x y A $.  $d g B $.  $d g x C $.  $d g x y .xb $.  $d g x y F $.
    $d g y G $.  $d g y .0. $.  $d g P $.  $d g R $.  $d g x y S $.
    $d g x y .x. $.  $d g x y U $.  $d g x y V $.  $d g y X $.  $d g x y ph $.
    hdmap14lem12.h $e |- H = ( LHyp ` K ) $.
    hdmap14lem12.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmap14lem12.v $e |- V = ( Base ` U ) $.
    hdmap14lem12.t $e |- .x. = ( .s ` U ) $.
    hdmap14lem12.r $e |- R = ( Scalar ` U ) $.
    hdmap14lem12.b $e |- B = ( Base ` R ) $.
    hdmap14lem12.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hdmap14lem12.e $e |- .xb = ( .s ` C ) $.
    hdmap14lem12.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmap14lem12.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmap14lem12.f $e |- ( ph -> F e. B ) $.
    ${
      hdmap14lem12.p $e |- P = ( Scalar ` C ) $.
      hdmap14lem12.a $e |- A = ( Base ` P ) $.
      ${
        hdmap14lem12.o $e |- .0. = ( 0g ` U ) $.
        hdmap14lem12.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
        hdmap14lem12.g $e |- ( ph -> G e. A ) $.
        $( Lemma for proof of part 14 in [Baer] p. 50.  (Contributed by NM,
           6-Jun-2015.) $)
        hdmap14lem12 $p |- ( ph -> ( ( S ` ( F .x. X ) ) = ( G .xb ( S ` X ) )
   <-> A. y e. ( V \ { .0. } ) ( S ` ( F .x. y ) ) = ( G .xb ( S ` y ) ) ) ) $=
          ( vg co cfv wceq cv csn cdif wral wa wcel w3a wrex eqid chlt 3ad2ant1
          clspn simp3 eldifad hdmap14lem2a cplusg simp11 syl simp2 hdmap14lem11
          simp13 simp12 oveq1d eqtr4d rexlimdv3a 3expia ralrimiv wi oveq2 fveq2
          mpd fveq2d oveq2d eqeq12d rspcv imp impbida ) ALRJUQZHURZMRHURZIUQZUS
          ZLBUTZJUQZHURZMXBHURZIUQZUSZBPSVAZVBZVCZAXAVDXGBXIAXAXBXIVEZXGAXAXKVF
          ZXDUPUTZXEIUQZUSZUPCVGXGXLCDEFGHIJKUPLNOEVKURZPQXBTUAUBUCUDUEUFUGXPVH
          UKULUHAXAOVIVEQNVEVDZXKUIVJXLXBPXHAXAXKVLVMAXALDVEZXKUJVJVNXLXOXGUPCX
          LXMCVEZXOVFZXDXNXFXLXSXOVLZXTMXMXEIXTCDEFKVOURZEVOURZGHIJKLMNXMOKVKUR
          ZPQRXBSTUAUBYBVHUCUMYDVHUDUEUFYCVHUGUKULUHXTAXQAXAXKXSXOVPZUIVQXTARXI
          VEZYEUNVQAXAXKXSXOVTXTAXRYEUJVQXTAMCVEYEUOVQXLXSXOVRAXAXKXSXOWAYAVSWB
          WCWDWJWEWFAXJXAAYFXJXAWGUNXGXABRXIXBRUSZXDWRXFWTYGXCWQHXBRLJWHWKYGXEW
          SMIXBRHWIWLWMWNVQWOWP $.

        $( Lemma for proof of part 14 in [Baer] p. 50.  (Contributed by NM,
           6-Jun-2015.) $)
        hdmap14lem13 $p |- ( ph -> ( ( S ` ( F .x. X ) ) = ( G .xb ( S ` X ) )
       <-> A. y e. V ( S ` ( F .x. y ) ) = ( G .xb ( S ` y ) ) ) ) $=
          ( co cfv wceq cv csn cdif wral cun hdmap14lem12 wcel elsn c0g lcdlmod
          wa clmod eqid lmodvs0 syl2anc hdmapval0 oveq2d dvhlmod eqtrd 3eqtr4rd
          fveq2d oveq2 fveq2 eqeq12d syl5ibrcom syl5bi ralrimiv biantrud ralunb
          syl6bbr lmod0vcl difsnid 3syl raleqdv 3bitrd ) ALRJUPHUQMRHUQIUPURLBU
          SZJUPZHUQZMWNHUQZIUPZURZBPSUTZVAZVBZWSBXAWTVCZVBZWSBPVBABCDEFGHIJKLMN
          OPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOVDAXBXBWSBWTVBZVIXDAXEXBAWSBWTWNW
          TVEWNSURZAWSBSVFAWSXFLSJUPZHUQZMSHUQZIUPZURAMEVGUQZIUPZXKXJXHAEVJVEMC
          VEXLXKURAENOQTUFUIVHUOIFCEMXKUKUGULXKVKZVLVMAXIXKMIAEXKHKNOQSTUAUMUFX
          MUHUIVNZVOAXHXIXKAXGSHAKVJVEZLDVEXGSURAKNOQTUAUIVPZUJJGDKLSUDUCUEUMVL
          VMVSXNVQVRXFWPXHWRXJXFWOXGHWNSLJVTVSXFWQXIMIWNSHWAVOWBWCWDWEWFWSBXAWT
          WGWHAWSBXCPAXOSPVEXCPURXPPKSUBUMWIPSWJWKWLWM $.
      $}

      $( Part of proof of part 14 in [Baer] p. 50 line 3.  (Contributed by NM,
         6-Jun-2015.) $)
      hdmap14lem14 $p |- ( ph ->
        E! g e. A A. x e. V ( S ` ( F .x. x ) ) = ( g .xb ( S ` x ) ) ) $=
        ( vy cv c0g cfv wne wrex wceq wral wreu eqid dvh1dim wcel chlt 3ad2ant1
        co w3a wa csn 3simpc eldifsn sylibr hdmap14lem7 simpl1 syl adantr simpr
        cdif hdmap14lem13 reubidva mpbid rexlimdv3a mpd ) AUKULZKUMUNZUOZUKPUPM
        BULZJVEHUNLULZWFHUNIVEUQBPURZLCUSZAUKKNOPQWDRSTWDUTZUGVAAWEWIUKPAWCPVBZ
        WEVFZMWCJVEHUNWGWCHUNIVEUQZLCUSWIWLCDEFGHIJKLMNOPQWCWDRSTUAWJUBUCUDUEUI
        UJUFAWKOVCVBQNVBVGZWEUGVDWLWKWEVGWCPWDVHVQVBZAWKWEVIWCPWDVJVKZAWKMDVBZW
        EUHVDVLWLWMWHLCWLWGCVBZVGZBCDEFGHIJKMWGNOPQWCWDRSTUAUBUCUDUEUFWSAWNAWKW
        EWRVMZUGVNWSAWQWTUHVNUIUJWJWLWOWRWPVOWLWRVPVRVSVTWAWB $.
    $}

    $( Part of proof of part 14 in [Baer] p. 50 line 3.  Convert scalar base of
       dual to scalar base of vector space.  (Contributed by NM,
       6-Jun-2015.) $)
    hdmap14lem15 $p |- ( ph ->
      E! g e. B A. x e. V ( S ` ( F .x. x ) ) = ( g .xb ( S ` x ) ) ) $=
      ( cv co cfv wceq wral csca cbs wreu eqid hdmap14lem14 lcdsbase reueq1 syl
      wb mpbid ) AKBUGZHUHFUIJUGVBFUIGUHUJBNUKZJDULUIZUMUIZUNZVCJCUNZABVECDVDEF
      GHIJKLMNOPQRSTUAUBUCUDUEUFVDUOZVEUOZUPAVECUJVFVGUTADVEVDIELMCOPQTUAUBVHVI
      UEUQVCJVECURUSVA $.
  $}

  $c HGMap $.

  $( Extend class notation with g-map. $)
  chg $a class HGMap $.

  ${
    $d a b k m u v w x y $.
    $( Define map from the scalar division ring of the vector space to the
       scalar division ring of its closed kernel dual.  (Contributed by NM,
       25-Mar-2015.) $)
    df-hgmap $a |- HGMap = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      { a | [. ( ( DVecH ` k ) ` w ) / u ].
            [. ( Base ` ( Scalar ` u ) ) / b ].
            [. ( ( HDMap ` k ) ` w ) / m ].
        a e. ( x e. b |-> ( iota_ y e. b
            A. v e. ( Base ` u ) ( m ` ( x ( .s ` u ) v ) )
              = ( y ( .s ` ( ( LCDual ` k ) ` w ) ) ( m ` v ) ) ) ) } ) ) $.
  $}

  ${
    $d k w H $.  $d a b k m u v w x y K $.
    hgmapval.h $e |- H = ( LHyp ` K ) $.
    $( Map from the scalar division ring of the vector space to the scalar
       division ring of its closed kernel dual.  (Contributed by NM,
       25-Mar-2015.) $)
    hgmapffval $p |- ( K e. X -> ( HGMap ` K ) = ( w e. H |->
      { a | [. ( ( DVecH ` K ) ` w ) / u ].
            [. ( Base ` ( Scalar ` u ) ) / b ].
            [. ( ( HDMap ` K ) ` w ) / m ].
        a e. ( x e. b |-> ( iota_ y e. b
            A. v e. ( Base ` u ) ( m ` ( x ( .s ` u ) v ) )
              = ( y ( .s ` ( ( LCDual ` K ) ` w ) ) ( m ` v ) ) ) ) } ) ) $=
      ( wcel cfv cv cvsca wceq cmpt wsbc clh vk cvv chg co clcd wral crio chdma
      cbs csca cdvh cab elex fveq2 syl6eqr wb fveq1d dfsbcq fveq2d oveqd eqeq2d
      ralbidv riotabidv mpteq2dv eleq2d sbcbidv bitrd abbidv mpteq12dv df-hgmap
      syl fvex eqeltri mptex fvmpt ) HIMHUBMHUCNCGJOZAKOZAODOZEOZPNUDFOZNZBOZVR
      VTNZCOZHUENZNZPNZUDZQZDVSUINZUFZBVQUGZRZMZFWDHUHNZNZSZKVSUJNUINZSZEWDHUKN
      ZNZSZJULZRZQHIUMUAHCUAOZTNZVPAVQWAWBWCWDXEUENZNZPNZUDZQZDWJUFZBVQUGZRZMZF
      WDXEUHNZNZSZKWRSZEWDXEUKNZNZSZJULZRXDUBUCXEHQZCXFYCGXCYDXFHTNZGXEHTUNLUOY
      DYBXBJYDYBXSEXASZXBYDYAXAQYBYFUPYDWDXTWTXEHUKUNUQXSEYAXAURVKYDXSWSEXAYDXR
      WQKWRYDXRXOFWPSZWQYDXQWPQXRYGUPYDWDXPWOXEHUHUNUQXOFXQWPURVKYDXOWNFWPYDXNW
      MVPYDAVQXMWLYDXLWKBVQYDXKWIDWJYDXJWHWAYDXIWGWBWCYDXHWFPYDWDXGWEXEHUEUNUQU
      SUTVAVBVCVDVEVFVGVFVFVGVHVIABCDEUAFJKVJCGXCGYEUBLHTVLVMVNVOVK $.

    $d a b m u v w x y B $.  $d a b m u v w x y M $.  $d a b m u w .xb $.
    $d a b m u w .x. $.  $d b m u v x y U $.  $d a b m u v w V $.
    $d a b m u v w x y W $.
    hgmapfval.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapfval.v $e |- V = ( Base ` U ) $.
    hgmapfval.t $e |- .x. = ( .s ` U ) $.
    hgmapfval.r $e |- R = ( Scalar ` U ) $.
    hgmapfval.b $e |- B = ( Base ` R ) $.
    hgmapfval.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hgmapfval.s $e |- .xb = ( .s ` C ) $.
    hgmapfval.m $e |- M = ( ( HDMap ` K ) ` W ) $.
    hgmapfval.i $e |- I = ( ( HGMap ` K ) ` W ) $.
    hgmapfval.k $e |- ( ph -> ( K e. Y /\ W e. H ) ) $.
    $( Map from the scalar division ring of the vector space to the scalar
       division ring of its closed kernel dual.  (Contributed by NM,
       25-Mar-2015.) $)
    hgmapfval $p |- ( ph -> I = ( x e. B |-> ( iota_ y e. B
            A. v e. V ( M ` ( x .x. v ) ) = ( y .xb ( M ` v ) ) ) ) ) $=
      ( vw va vb vu vm wcel wa cv cfv wceq wral crio cmpt cvsca clcd chdma wsbc
      co cbs csca cdvh cab chg hgmapffval fveq1d syl5eq wb fveq2 syl6eqr dfsbcq
      syl fveq2d oveqd eqeq2d ralbidv riotabidv mpteq2dv sbcbidv bitrd cvv fvex
      eleq2d eqeltri w3a simp2 simp1 eqtrd simp3 fveq12d eqidd oveq123d eqeq12d
      raleqbidv riotaeqbidv mpteq12dv syld3an2 sbc3ie syl6bb abbi1dv eqid mptex
      fvmpt sylan9eq ) AMQUNZPKUNZUOLBEBUPZDUPZIVFZNUQZCUPZXONUQZHVFZURZDOUSZCE
      UTZVAZURUHXLXMLPUIKUJUPZBUKUPZXNXOULUPZVBUQZVFZUMUPZUQZXRXOYJUQZUIUPZMVCU
      QZUQZVBUQZVFZURZDYGVGUQZUSZCYFUTZVAZUNZUMYMMVDUQZUQZVEZUKYGVHUQZVGUQZVEZU
      LYMMVIUQZUQZVEZUJVJZVAZUQZYDXLLPMVKUQZUQUUOUGXLPUUPUUNBCUIDULUMKMQUJUKRVL
      VMVNUIPUUMYDKUUNYMPURZUULUJYDUUQUULYEBYFYKXRYLPYNUQZVBUQZVFZURZDYSUSZCYFU
      TZVAZUNZUMNVEZUKUUHVEZULJVEZYEYDUNZUUQUULUUIULJVEZUVHUUQUUKJURUULUVJVOUUQ
      UUKPUUJUQZJYMPUUJVPSVQUUIULUUKJVRVSUUQUUIUVGULJUUQUUFUVFUKUUHUUQUUFUUCUMN
      VEZUVFUUQUUENURUUFUVLVOUUQUUEPUUDUQZNYMPUUDVPUFVQUUCUMUUENVRVSUUQUUCUVEUM
      NUUQUUBUVDYEUUQBYFUUAUVCUUQYTUVBCYFUUQYRUVADYSUUQYQUUTYKUUQYPUUSXRYLUUQYO
      UURVBYMPYNVPVTWAWBWCWDWEWJWFWGWFWFWGUVEUVIULUKUMJUUHNJUVKWHSPUUJWIWKUUGVG
      WINUVMWHUFPUUDWIWKYGJURZYFEURZYFUUHURZYJNURZUVEUVIVOUVNUVPUVQWLZYFGVGUQZE
      UVRYFUUHUVSUVNUVPUVQWMUVRUUGGVGUVRUUGJVHUQGUVRYGJVHUVNUVPUVQWNVTUBVQVTWOU
      CVQUVNUVOUVQWLZUVDYDYEUVTBYFUVCEYCUVNUVOUVQWMZUVTUVBYBCYFEUWAUVTUVAYADYSO
      UVTYSJVGUQOUVTYGJVGUVNUVOUVQWNZVTTVQUVTYKXQUUTXTUVTYIXPYJNUVNUVOUVQWPZUVT
      YHIXNXOUVTYHJVBUQIUVTYGJVBUWBVTUAVQWAWQUVTXRXRYLXSUUSHUVTUUSFVBUQHUVTUURF
      VBUVTUURUURFUVTUURWRUDVQVTUEVQUVTXRWRUVTXOYJNUWCVMWSWTXAXBXCWJXDXEXFXGUUN
      XHBEYCEUVSWHUCGVGWIWKXIXJXKVS $.

    $d x .xb $.  $d x .x. $.  $d x V $.  $d v x y X $.
    hgmapval.x $e |- ( ph -> X e. B ) $.
    $( Value of map from the scalar division ring of the vector space to the
       scalar division ring of its closed kernel dual.  Function sigma of
       scalar f in part 14 of [Baer] p. 50 line 4.  TODO: variable names are
       inherited from older version.  Maybe make more consistent with
       ~ hdmap14lem15 .  (Contributed by NM, 25-Mar-2015.) $)
    hgmapval $p |- ( ph -> ( I ` X ) = ( iota_ y e. B
            A. v e. V ( M ` ( X .x. v ) ) = ( y .xb ( M ` v ) ) ) ) $=
      ( vx cfv cv co wceq wral crio cmpt hgmapfval fveq1d wcel cvv oveq1 fveq2d
      riotaex eqeq1d ralbidv riotabidv eqid fvmptg sylancl eqtrd ) APKUKPUJDUJU
      LZCULZHUMZMUKZBULVMMUKGUMZUNZCNUOZBDUPZUQZUKZPVMHUMZMUKZVPUNZCNUOZBDUPZAP
      KVTAUJBCDEFGHIJKLMNOQRSTUAUBUCUDUEUFUGUHURUSAPDUTWFVAUTWAWFUNUIWEBDVDUJPV
      SWFDVAVTVLPUNZVRWEBDWGVQWDCNWGVOWCVPWGVNWBMVLPVMHVBVCVEVFVGVTVHVIVJVK $.
  $}

  ${
    $d j k x B $.  $d j k x K $.  $d j k x U $.  $d j k x W $.
    hgmapfn.h $e |- H = ( LHyp ` K ) $.
    hgmapfn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapfn.r $e |- R = ( Scalar ` U ) $.
    hgmapfn.b $e |- B = ( Base ` R ) $.
    hgmapfn.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapfn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Functionality of scalar sigma map.  (Contributed by NM, 7-Jun-2015.)
       (New usage is discouraged.) $)
    hgmapfnN $p |- ( ph -> G Fn B ) $=
      ( vk vx vj cv cfv eqid wfn cvsca co chdma clcd wceq cbs wral crio riotaex
      cmpt fnmpti chlt hgmapfval fneq1d mpbiri ) AEBUAOBORPRZDUBSZUCHGUDSSZSQRU
      QUSSHGUESSZUBSZUCUFPDUGSZUHZQBUIZUKZBUAOBVDVEVCQBUJVETULABEVEAOQPBUTCVAUR
      DFEGUSVBHUMIJVBTURTKLUTTVATUSTMNUNUOUP $.
  $}

  ${
    $d g x B $.  $d g x F $.  $d g x K $.  $d g R $.  $d g x U $.  $d g x W $.
    $d g x ph $.
    hgmapcl.h $e |- H = ( LHyp ` K ) $.
    hgmapcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapcl.r $e |- R = ( Scalar ` U ) $.
    hgmapcl.b $e |- B = ( Base ` R ) $.
    hgmapcl.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapcl.f $e |- ( ph -> F e. B ) $.
    $( Closure of scalar sigma map i.e. the map from the vector space scalar
       base to the dual space scalar base.  (Contributed by NM, 6-Jun-2015.) $)
    hgmapcl $p |- ( ph -> ( G ` F ) e. B ) $=
      ( vx vg cfv eqid cv cvsca co chdma clcd wceq wral crio chlt hgmapval wreu
      cbs wcel hdmap14lem15 riotacl syl eqeltrd ) AEFSEQUAZDUBSZUCIHUDSSZSRUAUR
      UTSIHUESSZUBSZUCUFQDULSZUGZRBUHZBARQBVACVBUSDGFHUTVCIEUIJKVCTZUSTZLMVATZV
      BTZUTTZNOPUJAVDRBUKVEBUMAQBVACUTVBUSDREGHVCIJKVFVGLMVHVIVJOPUNVDRBUOUPUQ
      $.
  $}

  ${
    hgmapdcl.h $e |- H = ( LHyp ` K ) $.
    hgmapdcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapdcl.r $e |- R = ( Scalar ` U ) $.
    hgmapdcl.b $e |- B = ( Base ` R ) $.
    hgmapdcl.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hgmapdcl.q $e |- Q = ( Scalar ` C ) $.
    hgmapdcl.a $e |- A = ( Base ` Q ) $.
    hgmapdcl.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapdcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapdcl.f $e |- ( ph -> F e. B ) $.
    $( Closure of the vector space to dual space scalar map, in the scalar
       sigma map.  (Contributed by NM, 6-Jun-2015.) $)
    hgmapdcl $p |- ( ph -> ( G ` F ) e. A ) $=
      ( cfv hgmapcl lcdsbase eleqtrrd ) AHIUCCBACFGHIJKLMNOPTUAUBUDADBEGFJKCLMN
      OPQRSUAUEUF $.
  $}

  ${
    $d g w x B $.  $d g x C $.  $d g w x .xb $.  $d g w x F $.  $d g w x G $.
    $d g x K $.  $d g R $.  $d g w x S $.  $d g w x .x. $.  $d g x U $.
    $d g w x V $.  $d g x W $.  $d x X $.  $d g x ph $.
    hgmapvs.h $e |- H = ( LHyp ` K ) $.
    hgmapvs.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapvs.v $e |- V = ( Base ` U ) $.
    hgmapvs.t $e |- .x. = ( .s ` U ) $.
    hgmapvs.r $e |- R = ( Scalar ` U ) $.
    hgmapvs.b $e |- B = ( Base ` R ) $.
    hgmapvs.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hgmapvs.e $e |- .xb = ( .s ` C ) $.
    hgmapvs.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hgmapvs.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapvs.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapvs.x $e |- ( ph -> X e. V ) $.
    hgmapvs.f $e |- ( ph -> F e. B ) $.
    $( Part 15 of [Baer] p. 50 line 6.  Also line 15 in [Holland95] p. 14.
       (Contributed by NM, 6-Jun-2015.) $)
    hgmapvs $p |- ( ph ->
      ( S ` ( F .x. X ) ) = ( ( G ` F ) .xb ( S ` X ) ) ) $=
      ( vx vg wcel cv cfv wceq wral crio chlt hgmapval eqcomd wreu hdmap14lem15
      co hgmapcl oveq1 eqeq2d ralbidv riota2 syl2anc mpbird oveq2 fveq2d oveq2d
      wb fveq2 eqeq12d rspcva ) AOMUKIUIULZGVBZEUMZIJUMZVQEUMZFVBZUNZUIMUOZIOGV
      BZEUMZVTOEUMZFVBZUNZUGAWDVSUJULZWAFVBZUNZUIMUOZUJBUPZVTUNZAVTWNAUJUIBCDFG
      HKJLEMNIUQPQRSTUAUBUCUDUEUFUHURUSAVTBUKWMUJBUTWDWOVMABDHIJKLNPQTUAUEUFUHV
      CAUIBCDEFGHUJIKLMNPQRSTUAUBUCUDUFUHVAWMWDUJBVTWJVTUNZWLWCUIMWPWKWBVSWJVTW
      AFVDVEVFVGVHVIWCWIUIOMVQOUNZVSWFWBWHWQVRWEEVQOIGVJVKWQWAWGVTFVQOEVNVLVOVP
      VH $.
  $}

  ${
    $d x G $.  $d x K $.  $d x .0. $.  $d x U $.  $d x W $.  $d x ph $.
    hgmapval0.h $e |- H = ( LHyp ` K ) $.
    hgmapval0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapval0.r $e |- R = ( Scalar ` U ) $.
    hgmapval0.o $e |- .0. = ( 0g ` R ) $.
    hgmapval0.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapval0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Value of the scalar sigma map at zero.  (Contributed by NM,
       12-Jun-2015.) $)
    hgmapval0 $p |- ( ph -> ( G ` .0. ) = .0. ) $=
      ( vx cfv cbs wceq eqid wcel clcd csca c0g cv wne wrex dvh1dim chdma wn wa
      w3a chlt adantr simpr hdmapeq0 biimpd necon3ad 3impia wi cvsca co dvhlmod
      wo clmod lmod0vs sylan fveq2d lmod0cl syl hgmapvs hdmapval0 3eqtr3d clvec
      lcdlvec hgmapdcl hdmapcl lvecvs0or orcomd ord 3adant3 mpd rexlimdv3a lcd0
      mpbid eqtrd ) AHDPZGFUAPPZUBPZUCPZHAOUDZCUCPZUEZOCQPZUFWFWIRZAOCEFWMGWKIJ
      WMSZWKSZNUGAWLWNOWMAWJWMTZWLUKWJGFUHPPZPZWGUCPZRZUIZWNAWQWLXBAWQUJZXAWJWK
      XCXAWJWKRXCWGWTWRWJCEFWMGWKIJWOWPWGSZWTSZWRSZAFULTGETUJWQNUMZAWQUNZUOUPUQ
      URAWQXBWNUSWLXCXAWNXCWNXAXCWFWSWGUTPZVAZWTRWNXAVCXCHWJCUTPZVAZWRPWKWRPZXJ
      WTXCXLWKWRACVDTZWQXLWKRACEFGIJNVBZXKBHWMCWJWKWOKXKSZLWPVEVFVGXCBQPZWGBWRX
      IXKCHDEFWMGWJIJWOXPKXQSZXDXISZXFMXGXHAHXQTZWQAXNXTXOBXQCHKXRLVHZVIUMVJAXM
      WTRWQAWGWTWRCEFGWKIJWPXDXEXFNVKUMVLXCWFXIWHWHQPZWIWGQPZWGWSWTYCSZXSWHSZYB
      SZWISZXEAWGVMTWQAWGEFGIXDNVNUMXCYBXQWGWHBCHDEFGIJKXRXDYEYFMXGXCXNXTXCCEFG
      IJXGVBYAVIVOXCWGYCWRWJCEFWMGIJWOXDYDXFXGXHVPVQWDVRVSVTWAWBWAAWGWHCBEFWIGH
      IJKLXDYEYGNWCWE $.
  $}

  ${
    $d x G $.  $d x .1. $.  $d x U $.  $d x ph $.
    hgmapval1.h $e |- H = ( LHyp ` K ) $.
    hgmapval1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapval1.r $e |- R = ( Scalar ` U ) $.
    hgmapval1.i $e |- .1. = ( 1r ` R ) $.
    hgmapval1.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapval1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Value of the scalar sigma map at one.  (Contributed by NM,
       12-Jun-2015.) $)
    hgmapval1 $p |- ( ph -> ( G ` .1. ) = .1. ) $=
      ( vx cfv wceq eqid wcel 3ad2ant1 c0g wne cbs wrex dvh1dim w3a chdma cvsca
      cv clcd co csca lcd1 oveq1d clmod lcdlmod chlt wa hdmapcl lmodvs1 syl2anc
      cur simp2 eqtr3d dvhlmod fveq2d crg lmodrng rngidcl 3syl hgmapvs 3eqtr2rd
      clvec lcdlvec hgmapcl lcdsbase eleqtrrd simp3 necon3bid mpbird lvecvscan2
      hdmapeq0 mpbid rexlimdv3a mpd ) AOUIZCUAPZUBZOCUCPZUDDEPZDQZAOCFGWIHWGIJW
      IRZWGRZNUEAWHWKOWIAWFWISZWHUFZWJWFHGUGPPZPZHGUJPPZUHPZUKZDWQWSUKZQWKWOXAW
      QDWFCUHPZUKZWPPWTWOWRULPZVBPZWQWSUKZXAWQAWNXFXAQWHAXEDWQWSAWRXDCDBFXEGHIJ
      KLWRRZXDRZXERZNUMUNTWOWRUOSZWQWRUCPZSXFWQQAWNXJWHAWRFGHIXGNUPTWOWRXKWPWFC
      FGWIHIJWLXGXKRZWPRZAWNGUQSHFSURWHNTZAWNWHVCZUSZWSXEXDXKWRWQXLXHWSRZXIUTVA
      VDWOXCWFWPWOCUOSZWNXCWFQAWNXRWHACFGHIJNVEZTXOXBDBWICWFWLKXBRZLUTVAVFWOBUC
      PZWRBWPWSXBCDEFGWIHWFIJWLXTKYARZXGXQXMMXNXOAWNDYASZWHAXRBVGSYCXSBCKVHYABD
      YBLVIVJZTVKVLWOWJDWSXDXDUCPZXKWRWQWRUAPZXLXQXHYERZYFRZAWNWRVMSWHAWRFGHIXG
      NVNTAWNWJYESWHAWJYAYEAYABCDEFGHIJKYBMNYDVOAWRYEXDCBFGYAHIJKYBXGXHYGNVPZVQ
      TAWNDYESWHADYAYEYDYIVQTXPWOWQYFUBWHAWNWHVRWOWQYFWFWGWOWRYFWPWFCFGWIHWGIJW
      LWMXGYHXMXNXOWBVSVTWAWCWDWE $.
  $}

  ${
    $d t .+ $.  $d t G $.  $d t K $.  $d t ph $.  $d t U $.  $d t W $.
    $d t X $.  $d t Y $.
    hgmapadd.h $e |- H = ( LHyp ` K ) $.
    hgmapadd.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapadd.r $e |- R = ( Scalar ` U ) $.
    hgmapadd.b $e |- B = ( Base ` R ) $.
    hgmapadd.p $e |- .+ = ( +g ` R ) $.
    hgmapadd.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapadd.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapadd.x $e |- ( ph -> X e. B ) $.
    hgmapadd.y $e |- ( ph -> Y e. B ) $.
    $( Part 15 of [Baer] p. 50 line 13.  (Contributed by NM, 6-Jun-2015.) $)
    hgmapadd $p |- ( ph -> ( G ` ( X .+ Y ) ) = ( ( G ` X ) .+ ( G ` Y ) ) ) $=
      ( vt co cfv clcd csca cplusg cv c0g wne wrex wceq eqid dvh1dim wcel chdma
      cbs cvsca clmod lcdlmod 3ad2ant1 chlt wa hgmapdcl simp2 hdmapcl lmodvsdir
      syl13anc dvhlmod fveq2d lmodvscl syl3anc hdmapadd hgmapvs oveq12d 3eqtrrd
      w3a lmodacl clvec lcdlvec hdmapeq0 necon3bid mpbird lvecvscan2 rexlimdv3a
      simp3 mpbid mpd lcdsadd oveqd eqtrd ) AJKCUBZFUCZJFUCZKFUCZIHUDUCUCZUEUCZ
      UFUCZUBZWMWNCUBAUAUGZEUHUCZUIZUAEUPUCZUJWLWRUKZAUAEGHXBIWTLMXBULZWTULZRUM
      AXAXCUAXBAWSXBUNZXAVPZWLWSIHUOUCUCZUCZWOUQUCZUBZWRXIXJUBZUKXCXGXLWMXIXJUB
      ZWNXIXJUBZWOUFUCZUBZWKWSEUQUCZUBZXHUCZXKXGWOURUNZWMWPUPUCZUNZWNYAUNZXIWOU
      PUCZUNXLXPUKAXFXTXAAWOGHILWOULZRUSZUTXGYABWOWPDEJFGHILMNOYEWPULZYAULZQAXF
      HVAUNIGUNVBXARUTZAXFJBUNZXASUTZVCAXFYCXAAYABWOWPDEKFGHILMNOYEYGYHQRTVCZUT
      XGWOYDXHWSEGHXBILMXDYEYDULZXHULZYIAXFXAVDZVEZXOWQWMWNXJWPYAYDWOXIYMXOULZY
      GXJULZYHWQULZVFVGXGXSJWSXQUBZKWSXQUBZEUFUCZUBZXHUCYTXHUCZUUAXHUCZXOUBXPXG
      XRUUCXHXGEURUNZYJKBUNZXFXRUUCUKAXFUUFXAAEGHILMRVHZUTZYKAXFUUGXATUTZYOUUBC
      JKXQDBXBEWSXDUUBULZNXQULZOPVFVGVIXGWOUUBXOXHEGHXBIYTUUALMXDUUKYEYQYNYIXGU
      UFYJXFYTXBUNUUIYKYOJXQDBXBEWSXDNUULOVJVKXGUUFUUGXFUUAXBUNUUIUUJYOKXQDBXBE
      WSXDNUULOVJVKVLXGUUDXMUUEXNXOXGBWODXHXJXQEJFGHXBIWSLMXDUULNOYEYRYNQYIYOYK
      VMXGBWODXHXJXQEKFGHXBIWSLMXDUULNOYEYRYNQYIYOUUJVMVNVOXGBWODXHXJXQEWKFGHXB
      IWSLMXDUULNOYEYRYNQYIYOAXFWKBUNZXAAUUFYJUUGUUMUUHSTCDBEJKNOPVQVKZUTVMVOXG
      WLWRXJWPYAYDWOXIWOUHUCZYMYRYGYHUUOULZAXFWOVRUNXAAWOGHILYERVSUTAXFWLYAUNXA
      AYABWOWPDEWKFGHILMNOYEYGYHQRUUNVCUTAXFWRYAUNZXAAXTYBYCUUQYFAYABWOWPDEJFGH
      ILMNOYEYGYHQRSVCYLWQWPYAWOWMWNYGYHYSVQVKUTYPXGXIUUOUIXAAXFXAWEXGXIUUOWSWT
      XGWOUUOXHWSEGHXBIWTLMXDXEYEUUPYNYIYOVTWAWBWCWFWDWGAWQCWMWNAWOCWQWPEDGHILM
      NPYEYGYSRWHWIWJ $.
  $}

  ${
    $d t G $.  $d t K $.  $d t ph $.  $d t U $.  $d t W $.  $d t .x. $.
    $d t X $.  $d t Y $.
    hgmapmul.h $e |- H = ( LHyp ` K ) $.
    hgmapmul.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapmul.r $e |- R = ( Scalar ` U ) $.
    hgmapmul.b $e |- B = ( Base ` R ) $.
    hgmapmul.t $e |- .x. = ( .r ` R ) $.
    hgmapmul.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapmul.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapmul.x $e |- ( ph -> X e. B ) $.
    hgmapmul.y $e |- ( ph -> Y e. B ) $.
    $( Part 15 of [Baer] p. 50 line 16.  The multiplication is reversed after
       converting to the dual space scalar to the vector space scalar.
       (Contributed by NM, 7-Jun-2015.) $)
    hgmapmul $p |- ( ph ->
      ( G ` ( X .x. Y ) ) = ( ( G ` Y ) .x. ( G ` X ) ) ) $=
      ( vt co cfv clcd csca cmulr c0g wne cbs wrex wceq eqid dvh1dim wcel chdma
      cv w3a cvsca clmod lcdlmod 3ad2ant1 hgmapdcl chlt simp2 hdmapcl lmodvsass
      wa syl13anc dvhlmod fveq2d lmodvscl syl3anc hgmapvs oveq2d 3eqtrd lmodmcl
      3eqtr2rd clvec lcdlvec simp3 necon3bid mpbird lvecvscan2 mpbid rexlimdv3a
      hdmapeq0 mpd hgmapcl lcdsmul eqtrd ) AJKDUBZFUCZJFUCZKFUCZIHUDUCUCZUEUCZU
      FUCZUBZWNWMDUBAUAUPZEUGUCZUHZUAEUIUCZUJWLWRUKZAUAEGHXBIWTLMXBULZWTULZRUMA
      XAXCUAXBAWSXBUNZXAUQZWLWSIHUOUCUCZUCZWOURUCZUBZWRXIXJUBZUKXCXGXLWMWNXIXJU
      BZXJUBZWKWSEURUCZUBZXHUCZXKXGWOUSUNZWMWPUIUCZUNZWNXSUNZXIWOUIUCZUNXLXNUKA
      XFXRXAAWOGHILWOULZRUTZVAAXFXTXAAXSBWOWPCEJFGHILMNOYCWPULZXSULZQRSVBZVAAXF
      YAXAAXSBWOWPCEKFGHILMNOYCYEYFQRTVBZVAXGWOYBXHWSEGHXBILMXDYCYBULZXHULZAXFH
      VCUNIGUNVGXARVAZAXFXAVDZVEZWMWNXJWQWPXSYBWOXIYIYEXJULZYFWQULZVFVHXGXQJKWS
      XOUBZXOUBZXHUCWMYPXHUCZXJUBXNXGXPYQXHXGEUSUNZJBUNZKBUNZXFXPYQUKAXFYSXAAEG
      HILMRVIZVAZAXFYTXASVAZAXFUUAXATVAZYLJKXODCBXBEWSXDNXOULZOPVFVHVJXGBWOCXHX
      JXOEJFGHXBIYPLMXDUUFNOYCYNYJQYKXGYSUUAXFYPXBUNUUCUUEYLKXOCBXBEWSXDNUUFOVK
      VLUUDVMXGYRXMWMXJXGBWOCXHXJXOEKFGHXBIWSLMXDUUFNOYCYNYJQYKYLUUEVMVNVOXGBWO
      CXHXJXOEWKFGHXBIWSLMXDUUFNOYCYNYJQYKYLAXFWKBUNZXAAYSYTUUAUUGUUBSTDCBEJKNO
      PVPVLZVAVMVQXGWLWRXJWPXSYBWOXIWOUGUCZYIYNYEYFUUIULZAXFWOVRUNXAAWOGHILYCRV
      SVAAXFWLXSUNXAAXSBWOWPCEWKFGHILMNOYCYEYFQRUUHVBVAAXFWRXSUNZXAAXRXTYAUUKYD
      YGYHWQWPXSWOWMWNYEYFYOVPVLVAYMXGXIUUIUHXAAXFXAVTXGXIUUIWSWTXGWOUUIXHWSEGH
      XBIWTLMXDXEYCUUJYJYKYLWFWAWBWCWDWEWGAWOWPWQDECGHBIWMWNLMNOPYCYEYORABCEJFG
      HILMNOQRSWHABCEKFGHILMNOQRTWHWIWJ $.
  $}

  ${
    hgmaprnlem1.h $e |- H = ( LHyp ` K ) $.
    hgmaprnlem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmaprnlem1.v $e |- V = ( Base ` U ) $.
    hgmaprnlem1.r $e |- R = ( Scalar ` U ) $.
    hgmaprnlem1.b $e |- B = ( Base ` R ) $.
    hgmaprnlem1.t $e |- .x. = ( .s ` U ) $.
    hgmaprnlem1.o $e |- .0. = ( 0g ` U ) $.
    hgmaprnlem1.c $e |- C = ( ( LCDual ` K ) ` W ) $.
    hgmaprnlem1.d $e |- D = ( Base ` C ) $.
    hgmaprnlem1.p $e |- P = ( Scalar ` C ) $.
    hgmaprnlem1.a $e |- A = ( Base ` P ) $.
    hgmaprnlem1.e $e |- .xb = ( .s ` C ) $.
    hgmaprnlem1.q $e |- Q = ( 0g ` C ) $.
    hgmaprnlem1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hgmaprnlem1.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmaprnlem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmaprnlem1.z $e |- ( ph -> z e. A ) $.
    ${
      hgmaprnlem1.t2 $e |- ( ph -> t e. ( V \ { .0. } ) ) $.
      ${
        hgmaprnlem1.s2 $e |- ( ph -> s e. V ) $.
        hgmaprnlem1.sz $e |- ( ph -> ( S ` s ) = ( z .xb ( S ` t ) ) ) $.
        ${
          hgmaprnlem1.k2 $e |- ( ph -> k e. B ) $.
          hgmaprnlem1.sk $e |- ( ph -> s = ( k .x. t ) ) $.
          $( Lemma for ~ hgmaprnN .  (Contributed by NM, 7-Jun-2015.)
             (New usage is discouraged.) $)
          hgmaprnlem1N $p |- ( ph -> z e. ran G ) $=
            ( cv cfv crn co fveq2d csn eldifad hgmapvs 3eqtr3d lcdlvec hgmapdcl
            wceq hdmapcl wne cdif wcel eldifsni syl necon3bid mpbird lvecvscan2
            hdmapeq0 mpbid wfn hgmapfnN fnfvelrn syl2anc eqeltrd ) ABVEZOVEZPVF
            ZPVGZAWMCVEZKVFZLVHZWOWRLVHZVPWMWOVPAUBVEZKVFWNWQMVHZKVFWSWTAXAXBKV
            DVIVBAEFJKLMNWNPQRSTWQUCUDUEUHUFUGUJUNUPUQURAWQSUAVJZUTVKZVCVLVMAWM
            WOLHDGFWRIUKUNULUMUOAFQRTUCUJURVNUSADEFHJNWNPQRTUCUDUFUGUJULUMUQURV
            CVOAFGKWQNQRSTUCUDUEUJUKUPURXDVQAWRIVRWQUAVRZAWQSXCVSVTXEUTWQSUAWAW
            BAWRIWQUAAFIKWQNQRSTUAUCUDUEUIUJUOUPURXDWFWCWDWEWGAPEWHWNEVTWOWPVTA
            EJNPQRTUCUDUFUGUQURWIVCEWNPWJWKWL $.
        $}

        hgmaprnlem1.m $e |- M = ( ( mapd ` K ) ` W ) $.
        hgmaprnlem1.n $e |- N = ( LSpan ` U ) $.
        hgmaprnlem1.l $e |- L = ( LSpan ` C ) $.
        $( Lemma for ~ hgmaprnN .  Part 15 of [Baer] p. 50 line 20.  We only
           require a subset relation, rather than equality, so that the case of
           zero ` z ` is taken care of automatically.  (Contributed by NM,
           7-Jun-2015.)  (New usage is discouraged.) $)
        hgmaprnlem2N $p |- ( ph -> ( N ` { s } ) C_ ( N ` { t } ) ) $=
          ( cv csn cfv co wcel lcdlmod eldifad hdmapcl lspsnvsi syl3anc hdmap10
          clmod sneqd fveq2d eqtrd 3sstr4d clss dvhlmod lspsncl syl2anc mapdord
          wss eqid mpbid ) AUDVHZVITVJZSVJZCVHZVITVJZSVJZWIWMWPWIABVHZWOKVJZLVK
          ZVIZRVJZWSVIRVJZWNWQAFVSVLWRDVLWSGVLXBXCWIAFPQUBUEULUTVMVAAFGKWONPQUA
          UBUEUFUGULUMURUTAWOUAUCVIVBVNZVOWRLHDRGFWSUNUOUMUPVGVPVQAWNWLKVJZVIZR
          VJXBAFKWLNPQRSTUAUBUEUFUGVFULVGVEURUTVCVRAXFXARAXEWTVDVTWAWBAFKWONPQR
          STUAUBUEUFUGVFULVGVEURUTXDVRWCANWDVJZNPQSUBWMWPUEUFXGWJZVEUTANVSVLZWL
          UAVLWMXGVLANPQUBUEUFUTWEZVCXGTUANWLUGXHVFWFWGAXIWOUAVLWPXGVLXJXDXGTUA
          NWOUGXHVFWFWGWHWK $.

        $d k B $.  $d k G $.  $d k N $.  $d k R $.  $d k .x. $.  $d k U $.
        $d k V $.  $d k ph $.  $d s t z k $.
        $( Lemma for ~ hgmaprnN .  Eliminate ` k ` .  (Contributed by NM,
           7-Jun-2015.)  (New usage is discouraged.) $)
        hgmaprnlem3N $p |- ( ph -> z e. ran G ) $=
          ( vk wceq wrex crn wcel csn cfv hgmaprnlem2N dvhlmod eldifad lspsnss2
          cv co wss mpbid w3a chlt 3ad2ant1 simp2 simp3 hgmaprnlem1N rexlimdv3a
          wa cdif mpd ) AUDVSZVHVSZCVSZMVTVIZVHEVJZBVSZOVKVLZAWMVMTVNWOVMTVNWAW
          QABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAVBVCVD
          VEVFVGVOAJMVHETUANWMWOUGUHUIUJVFANPQUBUEUFUTVPVCAWOUAUCVMZVBVQVRWBAWP
          WSVHEAWNEVLZWPWCBCDEFGHIJKLMNVHOPQUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQU
          RUSAXAQWDVLUBPVLWJWPUTWEAXAWRDVLWPVAWEAXAWOUAWTWKVLWPVBWEAXAWMUAVLWPV
          CWEAXAWMKVNWRWOKVNLVTVIWPVDWEAXAWPWFAXAWPWGWHWIWL $.
      $}

      $d s .xb $.  $d s G $.  $d s S $.  $d s V $.  $d s ph $.  $d t z s $.
      $( Lemma for ~ hgmaprnN .  Eliminate ` s ` .  (Contributed by NM,
         7-Jun-2015.)  (New usage is discouraged.) $)
      hgmaprnlem4N $p |- ( ph -> z e. ran G ) $=
        ( vs cv cfv co wceq wrex crn clmod lcdlmod csn eldifad hdmapcl lmodvscl
        wcel syl3anc hdmaprnN eleqtrrd wfn hdmapfnN fvelrnb syl mpbid w3a clspn
        wb cmpd chlt 3ad2ant1 cdif simp2 simp3 eqid hgmaprnlem3N rexlimdv3a mpd
        wa ) AUSUTZKVABUTZCUTZKVAZLVBZVCZUSRVDZWPOVEVLZAWSKVEZVLZXAAWSGXCAFVFVL
        WPDVLZWRGVLWSGVLAFPQSUAUHUPVGUQAFGKWQNPQRSUAUBUCUHUIUNUPAWQRTVHZURVIVJW
        PLHDGFWRUIUJULUKVKVMAFGKPQSUAUHUIUNUPVNVOAKRVPXDXAWCAKNPQRSUAUBUCUNUPVQ
        USRWSKVRVSVTAWTXBUSRAWORVLZWTWABCDEFGHIJKLMNOPQFWBVAZSQWDVAVAZNWBVAZRST
        USUAUBUCUDUEUFUGUHUIUJUKULUMUNUOAXGQWEVLSPVLWNWTUPWFAXGXEWTUQWFAXGWQRXF
        WGVLWTURWFAXGWTWHAXGWTWIXIWJXJWJXHWJWKWLWM $.
    $}

    $d t G $.  $d t .0. $.  $d t U $.  $d t V $.  $d t ph $.  $d z t $.
    $( Lemma for ~ hgmaprnN .  Eliminate ` t ` .  (Contributed by NM,
       7-Jun-2015.)  (New usage is discouraged.) $)
    hgmaprnlem5N $p |- ( ph -> z e. ran G ) $=
      ( vt cv wne crn wcel dvh1dim wa csn cdif eldifsn chlt adantr hgmaprnlem4N
      simpr sylan2br rexlimddv ) AUQURZSUSZBURZNUTVAZUQQAUQMOPQRSTUAUBUFUOVBVMQ
      VAVNVCAVMQSVDVEVAZVPVMQSVFAVQVCBUQCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
      KULUMUNAPVGVAROVAVCVQUOVHAVOCVAVQUPVHAVQVJVIVKVL $.
  $}

  ${
    $d z B $.  $d z G $.  $d z K $.  $d z W $.  $d z ph $.
    hgmaprn.h $e |- H = ( LHyp ` K ) $.
    hgmaprn.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmaprn.r $e |- R = ( Scalar ` U ) $.
    hgmaprn.b $e |- B = ( Base ` R ) $.
    hgmaprn.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmaprn.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( Part of proof of part 16 in [Baer] p. 50 line 23, Fs=G, except that we
       use the original vector space scalars for the range.  (Contributed by
       NM, 7-Jun-2015.)  (New usage is discouraged.) $)
    hgmaprnN $p |- ( ph -> ran G = B ) $=
      ( vz cfv cbs wcel wa eqid crn clcd csca wfn wral wss hgmapfnN chlt adantr
      cv simpr hgmapdcl ralrimiva fnfvrnss syl2anc c0g chdma cvsca hgmaprnlem5N
      ex ssrdv eqssd lcdsbase eqtrd ) AEUAZHGUBPPZUCPZQPZBAVEVHAEBUDOUJZEPVHRZO
      BUEVEVHUFABCDEFGHIJKLMNUGAVJOBAVIBRZSVHBVFVGCDVIEFGHIJKLVFTZVGTZVHTZMAGUH
      RHFRSZVKNUIAVKUKULUMOBVHEUNUOAOVHVEAVIVHRZVIVERAVPSOVHBVFVFQPZVGVFUPPZCHG
      UQPPZVFURPZDURPZDEFGDQPZHDUPPZIJWBTKLWATWCTVLVQTVMVNVTTVRTVSTMAVOVPNUIAVP
      UKUSUTVAVBAVFVHVGDCFGBHIJKLVLVMVNNVCVD $.
  $}

  ${
    $d t G $.  $d t U $.  $d t X $.  $d t Y $.  $d t ph $.
    hgmap11.h $e |- H = ( LHyp ` K ) $.
    hgmap11.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmap11.r $e |- R = ( Scalar ` U ) $.
    hgmap11.b $e |- B = ( Base ` R ) $.
    hgmap11.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmap11.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmap11.x $e |- ( ph -> X e. B ) $.
    hgmap11.y $e |- ( ph -> Y e. B ) $.
    $( The scalar sigma map is one-to-one.  (Contributed by NM, 7-Jun-2015.) $)
    hgmap11 $p |- ( ph -> ( ( G ` X ) = ( G ` Y ) <-> X = Y ) ) $=
      ( cfv wcel vt wceq wa cv c0g wne cbs wrex eqid dvh1dim adantr cvsca chdma
      w3a co clcd simp1r oveq1d chlt simp1l simp2 hgmapvs 3eqtr4d clmod dvhlmod
      syl lmodvscl syl3anc hdmap11 mpbid clvec dvhlvec lvecvscan2 rexlimdv3a ex
      simp3 mpd fveq2 impbid1 ) AIESZJESZUBZIJUBZAWBWCAWBUCZUAUDZDUESZUFZUADUGS
      ZUHZWCAWIWBAUADFGWHHWFKLWHUIZWFUIZPUJUKWDWGWCUAWHWDWEWHTZWGUNZIWEDULSZUOZ
      JWEWNUOZUBZWCWMWOHGUMSSZSZWPWRSZUBWQWMVTWEWRSZHGUPSSZULSZUOWAXAXCUOWSWTWM
      VTWAXAXCAWBWLWGUQURWMBXBCWRXCWNDIEFGWHHWEKLWJWNUIZMNXBUIZXCUIZWRUIZOWMAGU
      STHFTUCAWBWLWGUTZPVFZWDWLWGVAZWMAIBTZXHQVFZVBWMBXBCWRXCWNDJEFGWHHWEKLWJXD
      MNXEXFXGOXIXJWMAJBTZXHRVFZVBVCWMWRDFGWHHWOWPKLWJXGXIWMDVDTZXKWLWOWHTWMAXO
      XHADFGHKLPVEVFZXLXJIWNCBWHDWEWJMXDNVGVHWMXOXMWLWPWHTXPXNXJJWNCBWHDWEWJMXD
      NVGVHVIVJWMIJWNCBWHDWEWFWJXDMNWKWMADVKTXHADFGHKLPVLVFXLXNXJWDWLWGVPVMVJVN
      VQVOIJEVRVS $.
  $}

  ${
    $d x y G $.  $d x y B $.  $d x y ph $.
    hgmapf1o.h $e |- H = ( LHyp ` K ) $.
    hgmapf1o.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapf1o.r $e |- R = ( Scalar ` U ) $.
    hgmapf1o.b $e |- B = ( Base ` R ) $.
    hgmapf1o.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapf1o.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The scalar sigma map is a one-to-one onto function.  (Contributed by NM,
       7-Jun-2015.)  (New usage is discouraged.) $)
    hgmapf1oN $p |- ( ph -> G : B -1-1-onto-> B ) $=
      ( vx vy wceq cv wcel wa wfn crn cfv wi wral wf1o hgmapfnN hgmaprnN adantr
      weq chlt simprl simprr hgmap11 biimpd ralrimivva dff1o6 syl3anbrc ) AEBUA
      EUBBQORZEUCPRZEUCQZOPUJZUDZPBUEOBUEBBEUFABCDEFGHIJKLMNUGABCDEFGHIJKLMNUHA
      VCOPBBAUSBSZUTBSZTZTZVAVBVGBCDEFGHUSUTIJKLMAGUKSHFSTVFNUIAVDVEULAVDVEUMUN
      UOUPOPBBEUQUR $.
  $}

  ${
    hgmapeq0.h $e |- H = ( LHyp ` K ) $.
    hgmapeq0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapeq0.r $e |- R = ( Scalar ` U ) $.
    hgmapeq0.b $e |- B = ( Base ` R ) $.
    hgmapeq0.o $e |- .0. = ( 0g ` R ) $.
    hgmapeq0.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapeq0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapeq0.x $e |- ( ph -> X e. B ) $.
    $( The scalar sigma map is zero iff its argument is zero.  (Contributed by
       NM, 12-Jun-2015.) $)
    hgmapeq0 $p |- ( ph -> ( ( G ` X ) = .0. <-> X = .0. ) ) $=
      ( cfv wceq hgmapval0 eqeq2d clmod wcel dvhlmod lmod0cl syl hgmap11 bitr3d
      ) AIESZJESZTUJJTIJTAUKJUJACDEFGHJKLMOPQUAUBABCDEFGHIJKLMNPQRADUCUDJBUDADF
      GHKLQUECBDJMNOUFUGUHUI $.
  $}

  ${
    hdmapipcl.h $e |- H = ( LHyp ` K ) $.
    hdmapipcl.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapipcl.v $e |- V = ( Base ` U ) $.
    hdmapipcl.r $e |- R = ( Scalar ` U ) $.
    hdmapipcl.b $e |- B = ( Base ` R ) $.
    hdmapipcl.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapipcl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapipcl.x $e |- ( ph -> X e. V ) $.
    hdmapipcl.y $e |- ( ph -> Y e. V ) $.
    $( The inner product (Hermitian form) ` ( X , Y ) ` will be defined as
       ` ( ( S `` Y ) `` X ) ` .  Show closure.  (Contributed by NM,
       7-Jun-2015.) $)
    hdmapipcl $p |- ( ph -> ( ( S ` Y ) ` X ) e. B ) $=
      ( clcd cfv cbs eqid hdmapcl lcdvbasecl ) AIGUAUBUBZBCEUGUCUBZKDUBFGHIJLMN
      OPUGUDZUHUDZRAUGUHDKEFGHILMNUIUJQRTUESUF $.
  $}

  ${
    hdmapln1.h $e |- H = ( LHyp ` K ) $.
    hdmapln1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapln1.v $e |- V = ( Base ` U ) $.
    hdmapln1.p $e |- .+ = ( +g ` U ) $.
    hdmapln1.t $e |- .x. = ( .s ` U ) $.
    hdmapln1.r $e |- R = ( Scalar ` U ) $.
    hdmapln1.b $e |- B = ( Base ` R ) $.
    hdmapln1.q $e |- .+^ = ( +g ` R ) $.
    hdmapln1.m $e |- .X. = ( .r ` R ) $.
    hdmapln1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapln1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapln1.x $e |- ( ph -> X e. V ) $.
    hdmapln1.y $e |- ( ph -> Y e. V ) $.
    hdmapln1.z $e |- ( ph -> Z e. V ) $.
    hdmapln1.a $e |- ( ph -> A e. B ) $.
    $( Linearity property that will be used for inner product.  TODO: try to
       combine hypotheses in hdmap*ln* series.  (Contributed by NM,
       7-Jun-2015.) $)
    hdmapln1 $p |- ( ph -> ( ( S ` Z ) ` ( ( A .x. X ) .+ Y ) )
          = ( ( A .X. ( ( S ` Z ) ` X ) ) .+^ ( ( S ` Z ) ` Y ) ) ) $=
      ( clmod wcel cfv clfn wceq dvhlmod clcd cbs eqid hdmapcl lcdvbaselfl lfli
      co syl113anc ) AJUMUNQGUOZJUPUOZUNBCUNOMUNPMUNBOHVEPDVEVGUOBOVGUOIVEPVGUO
      EVEUQAJKLNRSUHURANLUSUOUOZJVHKLVIUTUOZNVGRVIVAZVJVAZSVHVAZUHAVIVJGQJKLMNR
      STVKVLUGUHUKVBVCULUIUJFDEBHIVHVGCMJOPUMTUAUCUBUDUEUFVMVDVF $.
  $}

  ${
    hdmaplna1.h $e |- H = ( LHyp ` K ) $.
    hdmaplna1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaplna1.v $e |- V = ( Base ` U ) $.
    hdmaplna1.p $e |- .+ = ( +g ` U ) $.
    hdmaplna1.r $e |- R = ( Scalar ` U ) $.
    hdmaplna1.q $e |- .+^ = ( +g ` R ) $.
    hdmaplna1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaplna1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmaplna1.x $e |- ( ph -> X e. V ) $.
    hdmaplna1.y $e |- ( ph -> Y e. V ) $.
    hdmaplna1.z $e |- ( ph -> Z e. V ) $.
    $( Additive property of first (inner product) argument.  (Contributed by
       NM, 11-Jun-2015.) $)
    hdmaplna1 $p |- ( ph -> ( ( S ` Z ) ` ( X .+ Y ) )
          = ( ( ( S ` Z ) ` X ) .+^ ( ( S ` Z ) ` Y ) ) ) $=
      ( clmod wcel cfv clfn co wceq dvhlmod clcd cbs hdmapcl lcdvbaselfl lfladd
      eqid syl112anc ) AFUEUFMEUGZFUHUGZUFKIUFLIUFKLBUIUSUGKUSUGLUSUGCUIUJAFGHJ
      NOUAUKAJHULUGUGZFUTGHVAUMUGZJUSNVAUQZVBUQZOUTUQZUAAVAVBEMFGHIJNOPVCVDTUAU
      DUNUOUBUCDBCUTUSIFKLRSPQVEUPUR $.
  $}

  ${
    hdmaplns1.h $e |- H = ( LHyp ` K ) $.
    hdmaplns1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaplns1.v $e |- V = ( Base ` U ) $.
    hdmaplns1.m $e |- .- = ( -g ` U ) $.
    hdmaplns1.r $e |- R = ( Scalar ` U ) $.
    hdmaplns1.n $e |- N = ( -g ` R ) $.
    hdmaplns1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaplns1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmaplns1.x $e |- ( ph -> X e. V ) $.
    hdmaplns1.y $e |- ( ph -> Y e. V ) $.
    hdmaplns1.z $e |- ( ph -> Z e. V ) $.
    $( Subtraction property of first (inner product) argument.  (Contributed by
       NM, 12-Jun-2015.) $)
    hdmaplns1 $p |- ( ph -> ( ( S ` Z ) ` ( X .- Y ) )
          = ( ( ( S ` Z ) ` X ) N ( ( S ` Z ) ` Y ) ) ) $=
      ( clmod wcel cfv clfn co wceq dvhlmod clcd cbs hdmapcl lcdvbaselfl lflsub
      eqid syl112anc ) ADUEUFMCUGZDUHUGZUFKIUFLIUFKLGUIUSUGKUSUGLUSUGHUIUJADEFJ
      NOUAUKAJFULUGUGZDUTEFVAUMUGZJUSNVAUQZVBUQZOUTUQZUAAVAVBCMDEFIJNOPVCVDTUAU
      DUNUOUBUCBUTUSHGIDKLRSPQVEUPUR $.
  $}

  ${
    hdmaplnm1.h $e |- H = ( LHyp ` K ) $.
    hdmaplnm1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaplnm1.v $e |- V = ( Base ` U ) $.
    hdmaplnm1.t $e |- .x. = ( .s ` U ) $.
    hdmaplnm1.r $e |- R = ( Scalar ` U ) $.
    hdmaplnm1.b $e |- B = ( Base ` R ) $.
    hdmaplnm1.m $e |- .X. = ( .r ` R ) $.
    hdmaplnm1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaplnm1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmaplnm1.x $e |- ( ph -> X e. V ) $.
    hdmaplnm1.y $e |- ( ph -> Y e. V ) $.
    hdmaplnm1.a $e |- ( ph -> A e. B ) $.
    $( Multiplicative property of first (inner product) argument.  (Contributed
       by NM, 11-Jun-2015.) $)
    hdmaplnm1 $p |- ( ph -> ( ( S ` Y ) ` ( A .x. X ) )
          = ( A .X. ( ( S ` Y ) ` X ) ) ) $=
      ( clmod wcel cfv clfn co wceq dvhlmod clcd cbs hdmapcl lcdvbaselfl lflmul
      eqid syl112anc ) AHUGUHNEUIZHUJUIZUHBCUHMKUHBMFUKVAUIBMVAUIGUKULAHIJLOPUC
      UMALJUNUIUIZHVBIJVCUOUIZLVAOVCUSZVDUSZPVBUSZUCAVCVDENHIJKLOPQVEVFUBUCUEUP
      UQUFUDDBFGVBVACKHMSTUAQRVGURUT $.
  $}

  ${
    hdmaplna2.h $e |- H = ( LHyp ` K ) $.
    hdmaplna2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaplna2.v $e |- V = ( Base ` U ) $.
    hdmaplna2.p $e |- .+ = ( +g ` U ) $.
    hdmaplna2.r $e |- R = ( Scalar ` U ) $.
    hdmaplna2.q $e |- .+^ = ( +g ` R ) $.
    hdmaplna2.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaplna2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmaplna2.x $e |- ( ph -> X e. V ) $.
    hdmaplna2.y $e |- ( ph -> Y e. V ) $.
    hdmaplna2.z $e |- ( ph -> Z e. V ) $.
    $( Additive property of second (inner product) argument.  (Contributed by
       NM, 10-Jun-2015.) $)
    hdmaplna2 $p |- ( ph -> ( ( S ` ( Y .+ Z ) ) ` X )
          = ( ( ( S ` Y ) ` X ) .+^ ( ( S ` Z ) ` X ) ) ) $=
      ( co cfv clcd cplusg eqid hdmapadd fveq1d cbs hdmapcl lcdvaddval eqtrd )
      AKLMBUEEUFZUFKLEUFZMEUFZJHUGUFUFZUHUFZUEZUFKUQUFKURUFCUEAKUPVAAUSBUTEFGHI
      JLMNOPQUSUIZUTUIZTUAUCUDUJUKAUSUSULUFZCUTDFUQURGHIJKNOPRSVBVDUIZVCUAAUSVD
      ELFGHIJNOPVBVETUAUCUMAUSVDEMFGHIJNOPVBVETUAUDUMUBUNUO $.
  $}

  ${
    hdmapglnm2.h $e |- H = ( LHyp ` K ) $.
    hdmapglnm2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapglnm2.v $e |- V = ( Base ` U ) $.
    hdmapglnm2.t $e |- .x. = ( .s ` U ) $.
    hdmapglnm2.r $e |- R = ( Scalar ` U ) $.
    hdmapglnm2.b $e |- B = ( Base ` R ) $.
    hdmapglnm2.m $e |- .X. = ( .r ` R ) $.
    hdmapglnm2.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapglnm2.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hdmapglnm2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapglnm2.x $e |- ( ph -> X e. V ) $.
    hdmapglnm2.y $e |- ( ph -> Y e. V ) $.
    hdmapglnm2.z $e |- ( ph -> A e. B ) $.
    $( g-linear property of second (inner product) argument.  Line 19 in
       [Holland95] p. 14.  (Contributed by NM, 10-Jun-2015.) $)
    hdmapglnm2 $p |- ( ph -> ( ( S ` ( A .x. Y ) ) ` X )
          = ( ( ( S ` Y ) ` X ) .X. ( G ` A ) ) ) $=
      ( cfv clcd cvsca eqid hgmapvs fveq1d cbs hgmapcl hdmapcl lcdvsval eqtrd
      co ) ANBOFUTEUIZUINBIUIZOEUIZMKUJUIUIZUKUIZUTZUINVCUIVBGUTANVAVFACVDDEVEF
      HBIJKLMOPQRSTUAVDULZVEULZUCUDUEUGUHUMUNANVDCDVEGHVDUOUIZVCJKLMVBPQRTUAUBV
      GVIULZVHUEACDHBIJKMPQTUAUDUEUHUPAVDVIEOHJKLMPQRVGVJUCUEUGUQUFURUS $.
  $}

  ${
    hdmapgln2.h $e |- H = ( LHyp ` K ) $.
    hdmapgln2.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapgln2.v $e |- V = ( Base ` U ) $.
    hdmapgln2.p $e |- .+ = ( +g ` U ) $.
    hdmapgln2.t $e |- .x. = ( .s ` U ) $.
    hdmapgln2.r $e |- R = ( Scalar ` U ) $.
    hdmapgln2.b $e |- B = ( Base ` R ) $.
    hdmapgln2.q $e |- .+^ = ( +g ` R ) $.
    hdmapgln2.m $e |- .X. = ( .r ` R ) $.
    hdmapgln2.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapgln2.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hdmapgln2.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapgln2.x $e |- ( ph -> X e. V ) $.
    hdmapgln2.y $e |- ( ph -> Y e. V ) $.
    hdmapgln2.z $e |- ( ph -> Z e. V ) $.
    hdmapgln2.a $e |- ( ph -> A e. B ) $.
    $( g-linear property that will be used for inner product.  (Contributed by
       NM, 14-Jun-2015.) $)
    hdmapgln2 $p |- ( ph -> ( ( S ` ( ( A .x. Y ) .+ Z ) ) ` X )
          = ( ( ( ( S ` Y ) ` X ) .X. ( G ` A ) ) .+^ ( ( S ` Z ) ` X ) ) ) $=
      ( co cfv clmod dvhlmod lmodvscl syl3anc hdmaplna2 hdmapglnm2 oveq1d eqtrd
      wcel ) APBQHUOZRDUOGUPUPPVFGUPUPZPRGUPUPZEUOPQGUPUPBKUPIUOZVHEUOADEFGJLMN
      OPVFRSTUAUBUDUFUHUJUKAJUQVEBCVEQNVEVFNVEAJLMOSTUJURUNULBHFCNJQUAUDUCUEUSU
      TUMVAAVGVIVHEABCFGHIJKLMNOPQSTUAUCUDUEUGUHUIUJUKULUNVBVCVD $.
  $}

  ${
    $d f K $.  $d f O $.  $d f S $.  $d f U $.  $d f W $.  $d f X $.  $d f Y $.
    $d f ph $.
    hdmaplkr.h $e |- H = ( LHyp ` K ) $.
    hdmaplkr.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmaplkr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmaplkr.v $e |- V = ( Base ` U ) $.
    hdmaplkr.f $e |- F = ( LFnl ` U ) $.
    hdmaplkr.y $e |- Y = ( LKer ` U ) $.
    hdmaplkr.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmaplkr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmaplkr.x $e |- ( ph -> X e. V ) $.
    $( Kernel of the vector to dual map.  Line 16 in [Holland95] p. 14.  TODO:
       eliminate ` F ` hypothesis.  (Contributed by NM, 9-Jun-2015.) $)
    hdmaplkr $p |- ( ph -> ( Y ` ( S ` X ) ) = ( O ` { X } ) ) $=
      ( vf cfv csn wss c0g wceq fveq2 fveq2d sneq sseq12d wne wa clfn crab wcel
      cv clcd clspn clmod cbs eqid lcdlmod hdmapcl lspsnid syl2anc cmpd hdmap10
      mapdsn eqtr3d eleqtrd wb lcdvbaselfl sseq2d elrab3 syl mpbid adantr clvec
      clsh dvhlvec chlt cdif anim1i eldifsn sylibr dochsnshp cxp lcd0v hdmapeq0
      csca eqeq2d bitr3d biimpar lkrshp syl3anc lshpcmp eqimss2 lmod0vcl lkrssv
      necon3bid dvhlmod doch0 sseqtr4d pm2.61ne eqssd ) AJBUBZKUBZJUCZGUBZAXGXI
      UDZCUEUBZBUBZKUBZXKUCZGUBZUDJXKJXKUFZXGXMXIXOXPXFXLKJXKBUGUHXPXHXNGJXKUIU
      HUJAJXKUKZULZXIXGUFZXJXRXIXGUDZXSAXTXQAXFXIUAUPZKUBZUDZUACUMUBZUNZUOZXTAX
      FXFUCIFUQUBUBZURUBZUBZYEAYGUSUOXFYGUTUBZUOXFYIUOAYGEFILYGVAZSVBAYGYJBJCEF
      HILNOYKYJVAZRSTVCZYHYJYGXFYLYHVAZVDVEAXHCURUBZUBIFVFUBUBZUBYIYEAYGBJCEFYH
      YPYOHILNOYOVAZYKYNYPVAZRSTVGACUAYDEFKYPYOGHIJLMYRNOYQYDVAZQSTVHVIVJAXFYDU
      OZYFXTVKAYGCYDEFYJIXFLYKYLNYSSYMVLZYCXTUAXFYDYAXFUFYBXGXIYAXFKUGVMVNVOVPZ
      VQXRXIXGCVSUBZCUUCVAZACVRUOZXQACEFILNSVTVQZXRCEFGHIJUUCXKLMNOXKVAZUUDAFWA
      UOIEUOULZXQSVQXRJHUOZXQULJHXNWBUOAUUIXQTWCJHXKWDWEWFXRUUEYTXFHCWJUBZUEUBZ
      UCWGZUKZXGUUCUOUUFAYTXQUUAVQAUUMXQAXFUULJXKAXFYGUEUBZUFXFUULUFXPAUUNUULXF
      AYGUUJCEFUUNHIUUKLNOUUJVAZUUKVAZYKUUNVAZSWHWKAYGUUNBJCEFHIXKLNOUUGYKUUQRS
      TWIWLWTWMUUJYDXFUUCKHCUUKOUUOUUPUUDYSQWNWOWPVPXGXIWQVOAXMHXOAYDXLKHCOYSQA
      CEFILNSXAZAYGCYDEFYJIXLLYKYLNYSSAYGYJBXKCEFHILNOYKYLRSACUSUOXKHUOUURHCXKO
      UUGWRVOVCVLWSAUUHXOHUFSCEFGHIXKLNMOUUGXBVOXCXDUUBXE $.
  $}

  ${
    hdmapellkr.h $e |- H = ( LHyp ` K ) $.
    hdmapellkr.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapellkr.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapellkr.v $e |- V = ( Base ` U ) $.
    hdmapellkr.r $e |- R = ( Scalar ` U ) $.
    hdmapellkr.z $e |- .0. = ( 0g ` R ) $.
    hdmapellkr.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapellkr.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapellkr.x $e |- ( ph -> X e. V ) $.
    hdmapellkr.y $e |- ( ph -> Y e. V ) $.
    $( Membership in the kernel (as shown by ~ hdmaplkr ) of the vector to dual
       map.  Line 17 in [Holland95] p. 14.  (Contributed by NM,
       16-Jun-2015.) $)
    hdmapellkr $p |- ( ph
       -> ( ( ( S ` X ) ` Y ) = .0. <-> Y e. ( O ` { X } ) ) ) $=
      ( cfv clk wcel wceq csn clfn eqid dvhlmod clcd hdmapcl lcdvbaselfl ellkr2
      clmod cbs hdmaplkr eleq2d bitr3d ) AKJCUCZDUDUCZUCZUEKUTUCLUFKJUGGUCZUEAB
      DUHUCZUTVAHDKUOLPQRVDUIZVAUIZADEFIMOTUJAIFUKUCUCZDVDEFVGUPUCZIUTMVGUIZVHU
      IZOVETAVGVHCJDEFHIMOPVIVJSTUAULUMUBUNAVBVCKACDVDEFGHIJVAMNOPVEVFSTUAUQURU
      S $.
  $}

  ${
    hdmapip0.h $e |- H = ( LHyp ` K ) $.
    hdmapip0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapip0.v $e |- V = ( Base ` U ) $.
    hdmapip0.o $e |- .0. = ( 0g ` U ) $.
    hdmapip0.r $e |- R = ( Scalar ` U ) $.
    hdmapip0.z $e |- Z = ( 0g ` R ) $.
    hdmapip0.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapip0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapip0.x $e |- ( ph -> X e. V ) $.
    $( Zero property that will be used for inner product.  (Contributed by NM,
       9-Jun-2015.) $)
    hdmapip0 $p |- ( ph -> ( ( ( S ` X ) ` X ) = Z <-> X = .0. ) ) $=
      ( cfv wceq wne csn coch wcel eqid chlt adantr cdif anim1i eldifsn dochnel
      wa sylibr wi clk clfn dvhlmod clcd cbs hdmapcl lcdvbaselfl ellkr2 biimpar
      clmod hdmaplkr eleqtrd ex mtod neneqad necon4d imp lfl0 syl2anc sylan9eqr
      fveq2 impbida ) AIICUAZUAZKUBZIJUBZAWAWBAIJVTKAIJUCZVTKUCAWCUNZVTKWDWAIIU
      DHFUEUAUAZUAZUFZWDDEFWEGHIJLWEUGZMNOAFUHUFHEUFUNWCSUIWDIGUFZWCUNIGJUDUJUF
      AWIWCTUKIGJULUOUMAWAWGUPWCAWAWGAWAUNIVSDUQUAZUAZWFAIWKUFWAABDURUAZVSWJGDI
      VFKNPQWLUGZWJUGZADEFHLMSUSZAHFUTUAUAZDWLEFWPVAUAZHVSLWPUGZWQUGZMWMSAWPWQC
      IDEFGHLMNWRWSRSTVBVCZTVDVEAWKWFUBWAACDWLEFWEGHIWJLWHMNWMWNRSTVGUIVHVIUIVJ
      VKVIVLVMWBAVTJVSUAZKIJVSVQADVFUFVSWLUFXAKUBWOWTBWLVSDKJPQOWMVNVOVPVR $.
  $}

  ${
    hdmapip1.h $e |- H = ( LHyp ` K ) $.
    hdmapip1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapip1.v $e |- V = ( Base ` U ) $.
    hdmapip1.t $e |- .x. = ( .s ` U ) $.
    hdmapip1.o $e |- .0. = ( 0g ` U ) $.
    hdmapip1.r $e |- R = ( Scalar ` U ) $.
    hdmapip1.i $e |- .1. = ( 1r ` R ) $.
    hdmapip1.n $e |- N = ( invr ` R ) $.
    hdmapip1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapip1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapip1.x $e |- ( ph -> X e. ( V \ { .0. } ) ) $.
    hdmapip1.y $e |- Y = ( ( N ` ( ( S ` X ) ` X ) ) .x. X ) $.
    $( Construct a proportional vector ` Y ` whose inner product with the
       original ` X ` equals one.  (Contributed by NM, 13-Jun-2015.) $)
    hdmapip1 $p |- ( ph -> ( ( S ` X ) ` Y ) = .1. ) $=
      ( cfv co fveq2i cmulr cbs eqid csn eldifad cdr wcel c0g wne clvec dvhlvec
      lvecdrng syl hdmapipcl cdif eldifsni hdmapip0 necon3bid mpbird drnginvrcl
      syl3anc hdmaplnm1 wceq drnginvrl eqtrd syl5eq ) AMLCUGZUGLVPUGZIUGZLDUHZV
      PUGZFMVSVPUFUIAVTVRVQBUJUGZUHZFAVRBUKUGZBCDWAEGHJKLLOPQRTWCULZWAULZUCUDAL
      JNUMZUEUNZWGABUOUPZVQWCUPZVQBUQUGZURZVRWCUPAEUSUPWHAEGHKOPUDUTBETVAVBZAWC
      BCEGHJKLLOPQTWDUCUDWGWGVCZAWKLNURZALJWFVDUPWNUELJNVEVBAVQWJLNABCEGHJKLNWJ
      OPQSTWJULZUCUDWGVFVGVHZWCBIVQWJWDWOUBVIVJVKAWHWIWKWBFVLWLWMWPWCBWAFIVQWJW
      DWOWEUAUBVMVJVNVO $.
  $}

  ${
    hdmapip0com.h $e |- H = ( LHyp ` K ) $.
    hdmapip0com.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapip0com.v $e |- V = ( Base ` U ) $.
    hdmapip0com.r $e |- R = ( Scalar ` U ) $.
    hdmapip0com.z $e |- .0. = ( 0g ` R ) $.
    hdmapip0com.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapip0com.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapip0com.x $e |- ( ph -> X e. V ) $.
    hdmapip0com.y $e |- ( ph -> Y e. V ) $.
    $( Commutation property of Baer's sigma map (Holland's A map).  Line 20 of
       [Holland95] p. 14.  Also part of Lemma 1 of [Baer] p. 110 line 7.
       (Contributed by NM, 9-Jun-2015.) $)
    hdmapip0com $p |- ( ph
      -> ( ( ( S ` X ) ` Y ) = .0. <-> ( ( S ` Y ) ` X ) = .0. ) ) $=
      ( csn coch cfv wcel wceq eqid dochsncom hdmapellkr 3bitr4d ) AJIUAHFUBUCU
      CZUCUDIJUAUJUCUDJICUCUCKUEIJCUCUCKUEADEFUJGHJILUJUFZMNRTSUGABCDEFUJGHIJKL
      UKMNOPQRSTUHABCDEFUJGHJIKLUKMNOPQRTSUHUI $.
  $}

  ${
    hdmapinvlem0.h $e |- H = ( LHyp ` K ) $.
    hdmapinvlem0.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapinvlem0.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapinvlem0.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapinvlem0.v $e |- V = ( Base ` U ) $.
    hdmapinvlem0.r $e |- R = ( Scalar ` U ) $.
    hdmapinvlem0.b $e |- B = ( Base ` R ) $.
    hdmapinvlem0.t $e |- .x. = ( .r ` R ) $.
    hdmapinvlem0.z $e |- .0. = ( 0g ` R ) $.
    hdmapinvlem0.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapinvlem0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapinvlem0.c $e |- ( ph -> C e. V ) $.
    hdmapinvlem0.d $e |- ( ph -> D e. V ) $.
    $( There exists a vector ` w ` satisfying the properties of Proposition
        1 of [Baer] p. 110.  Rather than fix ` w ` as Baer does, we select
        w based on the u, v ( ` C ` , ` D ` ) chosen.  This lets us work
        with the final x and y directly and bypass the conversion of u, v
        to x, y in the last part of Baer's proof by sacrificing one
        dimension (for the existence of ` w ` ) that we already have
        available anyway.  (Alternately, we could
        have used the ` E ` of ~ hdmapevec2 for ` w ` and followed Baer's proof
        directly, which would require one less dimension.)
        TODO: not clear this is possible; it seems we need existence of
        a square-root type factor. $)
$(
    hdmapinvlem0 $p |- ( ph -> E. w e. ( V \ { O } )
      ( ( ( S ` w ) ` w ) = I /\
      C e. ( O ` { w } ) /\ D e. ( O ` { w } ) ) ) $=
? $.
$)
  $}


  ${
    hdmapinvlem1.h $e |- H = ( LHyp ` K ) $.
    hdmapinvlem1.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapinvlem1.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapinvlem1.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapinvlem1.v $e |- V = ( Base ` U ) $.
    hdmapinvlem1.r $e |- R = ( Scalar ` U ) $.
    hdmapinvlem1.b $e |- B = ( Base ` R ) $.
    hdmapinvlem1.t $e |- .x. = ( .r ` R ) $.
    hdmapinvlem1.z $e |- .0. = ( 0g ` R ) $.
    hdmapinvlem1.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapinvlem1.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapinvlem1.c $e |- ( ph -> C e. ( O ` { E } ) ) $.
    $( Line 27 in [Baer] p. 110.  We use ` C ` for Baer's u.  Our unit vector
       ` E ` has the required properties for his w by ~ hdmapevec2 .  Our
       ` ( ( S `` E ) `` C ) ` means the inner product ` <. C , E >. ` i.e. his
       f(u,w) (note argument reversal).  (Contributed by NM, 11-Jun-2015.) $)
    hdmapinvlem1 $p |- ( ph -> ( ( S ` E ) ` C ) = .0. ) $=
      ( cfv clk wcel wceq csn clfn eqid c0g cbs cltrn eldifad hdmaplkr eleqtrrd
      dvheveccl clmod dvhlmod clcd hdmapcl lcdvbaselfl chlt wss dochssv syl2anc
      wa snssd sseldd ellkr2 mpbid ) ACHEUGZGUHUGZUGZUICVOUGNUJACHUKZKUGZVQUFAE
      GGULUGZIJKLMHVPOQRSVTUMZVPUMZUDUEAHLGUNUGZUKAJUOUGZMJUPUGUGZGHIJLMWCOWDUM
      WEUMRSWCUMPUEUTUQZURUSADVTVOVPLGCVANSTUCWAWBAGIJMORUEVBAMJVCUGUGZGVTIJWGU
      OUGZMVOOWGUMZWHUMZRWAUEAWGWHEHGIJLMORSWIWJUDUEWFVDVEAVSLCAJVFUIMIUIVJVRLV
      GVSLVGUEAHLWFVKGIJKLMVRORSQVHVIUFVLVMVN $.

    $( Line 28 in [Baer] p. 110, 0 = f(w,u).  (Contributed by NM,
       11-Jun-2015.) $)
    hdmapinvlem2 $p |- ( ph -> ( ( S ` C ) ` E ) = .0. ) $=
      ( cfv wceq hdmapinvlem1 c0g csn cltrn eqid dvheveccl eldifad chlt wcel wa
      cbs wss snssd dochssv syl2anc sseldd hdmapip0com mpbid ) ACHEUGUGNUHHCEUG
      UGNUHABCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUIADEGIJLMHCNORSTUCUDUEAHLGUJUGZUKAJ
      USUGZMJULUGUGZGHIJLMVGOVHUMVIUMRSVGUMPUEUNUOZAHUKZKUGZLCAJUPUQMIUQURVKLUT
      VLLUTUEAHLVJVAGIJKLMVKORSQVBVCUFVDVEVF $.
  $}

  ${
    hdmapinvlem3.h $e |- H = ( LHyp ` K ) $.
    hdmapinvlem3.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapinvlem3.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapinvlem3.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapinvlem3.v $e |- V = ( Base ` U ) $.
    hdmapinvlem3.p $e |- .+ = ( +g ` U ) $.
    hdmapinvlem3.m $e |- .- = ( -g ` U ) $.
    hdmapinvlem3.q $e |- .x. = ( .s ` U ) $.
    hdmapinvlem3.r $e |- R = ( Scalar ` U ) $.
    hdmapinvlem3.b $e |- B = ( Base ` R ) $.
    hdmapinvlem3.t $e |- .X. = ( .r ` R ) $.
    hdmapinvlem3.z $e |- .0. = ( 0g ` R ) $.
    hdmapinvlem3.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapinvlem3.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hdmapinvlem3.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapinvlem3.c $e |- ( ph -> C e. ( O ` { E } ) ) $.
    hdmapinvlem3.d $e |- ( ph -> D e. ( O ` { E } ) ) $.
    hdmapinvlem3.i $e |- ( ph -> I e. B ) $.
    hdmapinvlem3.j $e |- ( ph -> J e. B ) $.
    hdmapinvlem3.ij $e |- ( ph -> ( I .X. ( G ` J ) ) = ( ( S ` D ) ` C ) ) $.
    $( Line 30 in [Baer] p. 110, f(sw + u, tw - v) = 0.  (Contributed by NM,
       12-Jun-2015.) $)
    hdmapinvlem3 $p |- ( ph
          -> ( ( S ` ( ( J .x. E ) .- D ) ) ` ( ( I .x. E ) .+ C ) ) = .0. ) $=
      ( co cfv clcd csg eqid clmod wcel dvhlmod c0g csn cltrn dvheveccl eldifad
      cbs lmodvscl syl3anc chlt wa snssd dochssv syl2anc sseldd hdmapsub fveq1d
      wss hdmapcl lmodvacl lcdvsubval cplusg hdmaplna1 hdmapglnm2 cur hdmaplnm1
      chvm hdmapevec2 oveq2d crg lmodrng syl rngridm 3eqtrd oveq1d hdmapinvlem1
      wceq eqtrd hgmapcl rnglz oveq12d rnggrp lmodmcl grprid hdmapinvlem2 rngrz
      cgrp 3eqtrrd grplid 3eqtr2d grpsubid ) ANKHVBZCEVBZOKHVBZDQVBGVCZVCYAYBGV
      CZDGVCZTPVDVCVCZVEVCZVBZVCZNOLVCZIVBZYKFVEVCZVBZUAAYAYCYHAYFGJMPQYGSTYBDU
      BUEUFUHYFVFZYGVFZUNUPAJVGVHZOBVHKSVHZYBSVHAJMPTUBUEUPVIZUTAKSJVJVCZVKAPVO
      VCZTPVLVCVCZJKMPSTYSUBYTVFUUAVFUEUFYSVFUCUPVMVNZOHFBSJKUFUJUIUKVPVQZAKVKZ
      RVCZSDAPVRVHTMVHVSUUDSWFUUESWFUPAKSUUBVTJMPRSTUUDUBUEUFUDWAWBZURWCZWDWEAY
      IYAYDVCZYAYEVCZYLVBYMAYFYFVOVCZFYLJYDYEMPYGSTYAUBUEUFUJYLVFZYNUUJVFZYOUPA
      YFUUJGYBJMPSTUBUEUFYNUULUNUPUUCWGAYFUUJGDJMPSTUBUEUFYNUULUNUPUUGWGAYPXTSV
      HZCSVHYASVHYRAYPNBVHZYQUUMYRUSUUBNHFBSJKUFUJUIUKVPVQZAUUESCUUFUQWCZESJXTC
      UFUGWHVQWIAUUHYKUUIYKYLAUUHXTYDVCZCYDVCZFWJVCZVBYKUAUUSVBZYKAEUUSFGJMPSTX
      TCYBUBUEUFUGUJUUSVFZUNUPUUOUUPUUCWKAUUQYKUURUAUUSAUUQXTKGVCZVCZYJIVBYKAOB
      FGHIJLMPSTXTKUBUEUFUIUJUKULUNUOUPUUOUUBUTWLAUVCNYJIAUVCNKUVBVCZIVBNFWMVCZ
      IVBZNANBFGHIJMPSTKKUBUEUFUIUJUKULUNUPUUBUUBUSWNAUVDUVENIAFGJUVEKMTPWOVCVC
      ZPTUBUCUVGVFUNUPUEUJUVEVFZWPWQAFWRVHZUUNUVFNXEAYPUVIYRFJUJWSWTZUSBFIUVENU
      KULUVHXAWBXBXCXFAUURCUVBVCZYJIVBUAYJIVBZUAAOBFGHIJLMPSTCKUBUEUFUIUJUKULUN
      UOUPUUPUUBUTWLAUVKUAYJIABCFGIJKMPRSTUAUBUCUDUEUFUJUKULUMUNUPUQXDXCAUVIYJB
      VHZUVLUAXEUVJABFJOLMPTUBUEUJUKUOUPUTXGZBFIYJUAUKULUMXHWBXBXIAFXOVHZYKBVHZ
      UUTYKXEAUVIUVOUVJFXJWTZAYPUUNUVMUVPYRUSUVNIFBJNYJUJUKULXKVQZBUUSFYKUAUKUV
      AUMXLWBXBAUUIXTYEVCZCYEVCZUUSVBUAYKUUSVBZYKAEUUSFGJMPSTXTCDUBUEUFUGUJUVAU
      NUPUUOUUPUUGWKAUAUVSYKUVTUUSAUVSNKYEVCZIVBNUAIVBZUAANBFGHIJMPSTKDUBUEUFUI
      UJUKULUNUPUUBUUGUSWNAUWBUANIABDFGIJKMPRSTUAUBUCUDUEUFUJUKULUMUNUPURXMWQAU
      VIUUNUWCUAXEUVJUSBFINUAUKULUMXNWBXPVAXIAUVOUVPUWAYKXEUVQUVRBUUSFYKUAUKUVA
      UMXQWBXRXIXFAUVOUVPYMUAXEUVQUVRBFYLYKUAUKUMUUKXSWBXB $.

    $( Part 1.1 of Proposition 1 of [Baer] p. 110.  We use ` C ` , ` D ` ,
       ` I ` , and ` J ` for Baer's u, v, s, and t.  Our unit vector ` E ` has
       the required properties for his w by ~ hdmapevec2 .  Our
       ` ( ( S `` D ) `` C ) ` means his f(u,v) (note argument reversal).
       (Contributed by NM, 12-Jun-2015.) $)
    hdmapinvlem4 $p |- ( ph
           -> ( J .X. ( G ` I ) ) = ( ( S ` C ) ` D ) ) $=
      ( cfv co csg wceq eqid clmod wcel dvhlmod c0g csn cltrn dvheveccl eldifad
      cbs lmodvscl syl3anc chlt wa wss snssd dochssv syl2anc lmodvacl hdmaplns1
      sseldd hdmapinvlem3 lmodvsubcl mpbid hdmaplnm1 cplusg hdmapinvlem2 oveq2d
      hdmapip0com hdmaplna2 cgrp crg lmodrng rnggrp hdmapipcl grprid hdmapglnm2
      syl cur hdmapevec2 oveq1d hgmapcl rnglidm eqtrd 3eqtrd hdmapinvlem1 rnglz
      chvm grplid oveq12d 3eqtr3rd wb lmodmcl grpsubeq0 ) AONLVBZIVCZDCGVBZVBZF
      VDVBZVCZUAVEZYAYCVEZAOKHVCZDQVCZNKHVCZCEVCZGVBZVBZYHYLVBZDYLVBZYDVCUAYEAF
      GJMPQYDSTYHDYKUBUEUFUHUJYDVFZUNUPAJVGVHZOBVHZKSVHZYHSVHZAJMPTUBUEUPVIZUTA
      KSJVJVBZVKAPVOVBZTPVLVBVBZJKMPSTUUBUBUUCVFUUDVFUEUFUUBVFUCUPVMVNZOHFBSJKU
      FUJUIUKVPVQZAKVKZRVBZSDAPVRVHTMVHVSUUGSVTUUHSVTUPAKSUUEWAJMPRSTUUGUBUEUFU
      DWBWCZURWFZAYQYJSVHZCSVHYKSVHUUAAYQNBVHYSUUKUUAUSUUENHFBSJKUFUJUIUKVPVQZA
      UUHSCUUIUQWFZESJYJCUFUGWDVQZWEAYKYIGVBVBUAVEYMUAVEABCDEFGHIJKLMNOPQRSTUAU
      BUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSUTVAWGAFGJMPSTYIYKUAUBUEUFUJUMUNUPAYQY
      TDSVHYISVHUUAUUFUUJQSJYHDUFUHWHVQUUNWNWIAYNYAYOYCYDAYNOKYLVBZIVCYAAOBFGHI
      JMPSTKYKUBUEUFUIUJUKULUNUPUUEUUNUTWJAUUOXTOIAUUOKYJGVBZVBZKYBVBZFWKVBZVCU
      UQUAUUSVCZXTAEUUSFGJMPSTKYJCUBUEUFUGUJUUSVFZUNUPUUEUULUUMWOAUURUAUUQUUSAB
      CFGIJKMPRSTUAUBUCUDUEUFUJUKULUMUNUPUQWLWMAUUTUUQKKGVBZVBZXTIVCZXTAFWPVHZU
      UQBVHUUTUUQVEAFWQVHZUVEAYQUVFUUAFJUJWRXCZFWSXCZABFGJMPSTKYJUBUEUFUJUKUNUP
      UUEUULWTBUUSFUUQUAUKUVAUMXAWCANBFGHIJLMPSTKKUBUEUFUIUJUKULUNUOUPUUEUUEUSX
      BAUVDFXDVBZXTIVCZXTAUVCUVIXTIAFGJUVIKMTPXMVBVBZPTUBUCUVKVFUNUPUEUJUVIVFZX
      EXFAUVFXTBVHZUVJXTVEUVGABFJNLMPTUBUEUJUKUOUPUSXGZBFIUVIXTUKULUVLXHWCXIXJX
      JWMXIAYODUUPVBZYCUUSVCUAYCUUSVCZYCAEUUSFGJMPSTDYJCUBUEUFUGUJUVAUNUPUUJUUL
      UUMWOAUVOUAYCUUSAUVODUVBVBZXTIVCUAXTIVCZUAANBFGHIJLMPSTDKUBUEUFUIUJUKULUN
      UOUPUUJUUEUSXBAUVQUAXTIABDFGIJKMPRSTUAUBUCUDUEUFUJUKULUMUNUPURXKXFAUVFUVM
      UVRUAVEUVGUVNBFIXTUAUKULUMXLWCXJXFAUVEYCBVHZUVPYCVEUVHABFGJMPSTDCUBUEUFUJ
      UKUNUPUUJUUMWTZBUUSFYCUAUKUVAUMXNWCXJXOXPAUVEYABVHZUVSYFYGXQUVHAYQYRUVMUW
      AUUAUTUVNIFBJOXTUJUKULXRVQUVTBFYDYAYCUAUKUMYPXSVQWI $.
  $}

  ${
    hdmapglem5.h $e |- H = ( LHyp ` K ) $.
    hdmapglem5.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapglem5.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapglem5.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapglem5.v $e |- V = ( Base ` U ) $.
    hdmapglem5.p $e |- .+ = ( +g ` U ) $.
    hdmapglem5.m $e |- .- = ( -g ` U ) $.
    hdmapglem5.q $e |- .x. = ( .s ` U ) $.
    hdmapglem5.r $e |- R = ( Scalar ` U ) $.
    hdmapglem5.b $e |- B = ( Base ` R ) $.
    hdmapglem5.t $e |- .X. = ( .r ` R ) $.
    hdmapglem5.z $e |- .0. = ( 0g ` R ) $.
    hdmapglem5.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapglem5.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hdmapglem5.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapglem5.c $e |- ( ph -> C e. ( O ` { E } ) ) $.
    hdmapglem5.d $e |- ( ph -> D e. ( O ` { E } ) ) $.
    hdmapglem5.i $e |- ( ph -> I e. B ) $.
    hdmapglem5.j $e |- ( ph -> J e. B ) $.
    $( Part 1.2 in [Baer] p. 110 line 34, f(u,v) alpha = f(v,u).  (Contributed
       by NM, 12-Jun-2015.) $)
    hdmapglem5 $p |- ( ph
           -> ( G ` ( ( S ` D ) ` C ) ) = ( ( S ` C ) ` D ) ) $=
      ( cur cfv co crg wcel wceq clmod dvhlmod lmodrng syl csn chlt wss c0g cbs
      wa cltrn dvheveccl eldifad snssd dochssv syl2anc sseldd hdmapipcl hgmapcl
      eqid rnglidm rngidcl hgmapval1 oveq2d rngridm eqtrd hdmapinvlem4 eqtr3d )
      AFVAVBZCDGVBVBZLVBZIVCZWQDCGVBVBAFVDVEZWQBVEWRWQVFAJVGVEWSAJMPTUBUEUPVHFJ
      UJVIVJZABFJWPLMPTUBUEUJUKUOUPABFGJMPSTCDUBUEUFUJUKUNUPAKVKZRVBZSCAPVLVETM
      VEVPXASVMXBSVMUPAKSAKSJVNVBZVKAPVOVBZTPVQVBVBZJKMPSTXCUBXDWFXEWFUEUFXCWFU
      CUPVRVSVTJMPRSTXAUBUEUFUDWAWBZUQWCAXBSDXFURWCWDZWEBFIWOWQUKULWOWFZWGWBABC
      DEFGHIJKLMWPWOPQRSTUAUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURXGAWSWOBVEWTBFWOUK
      XHWHVJAWPWOLVBZIVCWPWOIVCZWPAXIWOWPIAFJWOLMPTUBUEUJXHUOUPWIWJAWSWPBVEXJWP
      VFWTXGBFIWOWPUKULXHWKWBWLWMWN $.
  $}

  ${
    hdmapglem6.h $e |- H = ( LHyp ` K ) $.
    hdmapglem6.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapglem6.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapglem6.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapglem6.v $e |- V = ( Base ` U ) $.
    hdmapglem6.q $e |- .x. = ( .s ` U ) $.
    hdmapglem6.r $e |- R = ( Scalar ` U ) $.
    hdmapglem6.b $e |- B = ( Base ` R ) $.
    hdmapglem6.t $e |- .X. = ( .r ` R ) $.
    hdmapglem6.z $e |- .0. = ( 0g ` R ) $.
    hdmapglem6.i $e |- .1. = ( 1r ` R ) $.
    hdmapglem6.n $e |- N = ( invr ` R ) $.
    hdmapglem6.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapglem6.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hdmapglem6.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapglem6.x $e |- ( ph -> X e. ( B \ { .0. } ) ) $.
    ${
      hdmapglem6.c $e |- ( ph -> C e. ( O ` { E } ) ) $.
      hdmapglem6.d $e |- ( ph -> D e. ( O ` { E } ) ) $.
      hdmapglem6.cd $e |- ( ph -> ( ( S ` D ) ` C ) = .1. ) $.
      ${
        hdmapglem6.y $e |- ( ph -> Y e. ( B \ { .0. } ) ) $.
        hdmapglem6.yx $e |- ( ph -> ( Y .X. ( G ` X ) ) = .1. ) $.
        $( Involution property of scalar sigma map.  Line 10 in [Baer] p. 111,
           t sigma squared = t.  Our ` E ` , ` C ` , ` D ` , ` Y ` , ` X `
           correspond to Baer's w, h, k, s, t.  (Contributed by NM,
           13-Jun-2015.) $)
        hgmapvvlem1 $p |- ( ph -> ( G ` ( G ` X ) ) = X ) $=
          ( cfv crg wcel wceq clmod dvhlmod lmodrng syl csn eldifad hgmapcl cdr
          co wne clvec dvhlvec lvecdrng cdif eldifsni hgmapeq0 necon3bid mpbird
          drnginvrcl syl3anc rngass syl13anc drnginvrr rngridm syl2anc hgmapmul
          oveq2d 3eqtrrd fveq2d eqtr3d cplusg csg eqid hdmapglem5 eqtr4d oveq1d
          hdmapinvlem4 3eqtrd ) ASLVCZLVCZXFTLVCZHVOZXGOVCZHVOZSXGHVOZXIHVOZSAX
          JXFXGXIHVOZHVOZXFJHVOZXFAEVDVEZXFBVEZXGBVEZXIBVEZXJXNVFAIVGVEXPAIMNRU
          BUEUPVHEIUHVIVJZABEIXELMNRUBUEUHUIUOUPABEISLMNRUBUEUHUIUOUPASBUAVKZUQ
          VLZVMZVMZABEITLMNRUBUEUHUIUOUPATBYAVAVLZVMZAEVNVEZXRXGUAVPZXSAIVQVEYG
          AIMNRUBUEUPVREIUHVSVJZYFAYHTUAVPZATBYAVTVEYJVATBUAWAVJAXGUATUAABEILMN
          RTUAUBUEUHUIUKUOUPYEWBWCWDZBEOXGUAUIUKUMWEWFZBEHXFXGXIUIUJWGWHAXMJXFH
          AYGXRYHXMJVFYIYFYKBEHJOXGUAUIUKUJULUMWIWFZWMAXPXQXOXFVFXTYDBEHJXFUIUJ
          ULWJWKWNAXHXKXIHAXHDCFVCVCZXKAJLVCZXHYNATXEHVOZLVCYOXHAYPJLVBWOABEHIL
          MNRTXEUBUEUHUIUJUOUPYEYCWLWPACDFVCVCZLVCYOYNAYQJLUTWOABCDIWQVCZEFGHIK
          LMTSNIWRVCZPQRUAUBUCUDUEUFYRWSZYSWSZUGUHUIUJUKUNUOUPURUSYEYBWTWPWPABC
          DYREFGHIKLMTSNYSPQRUAUBUCUDUEUFYTUUAUGUHUIUJUKUNUOUPURUSYEYBAYPJYQVBU
          TXAXCXAXBAXLSXMHVOZSJHVOZSAXPSBVEZXRXSXLUUBVFXTYBYFYLBEHSXGXIUIUJWGWH
          AXMJSHYMWMAXPUUDUUCSVFXTYBBEHJSUIUJULWJWKXDXD $.
      $}

      $( Lemma for ~ hgmapvv .  Eliminate ` Y ` (Baer's s).  (Contributed by
         NM, 13-Jun-2015.) $)
      hgmapvvlem2 $p |- ( ph -> ( G ` ( G ` X ) ) = X ) $=
        ( cfv wcel wne csn cdif cdr clvec dvhlvec lvecdrng syl eldifad eldifsni
        hgmapcl hgmapeq0 necon3bid mpbird drnginvrcl syl3anc drnginvrn0 eldifsn
        sylanbrc co wceq drnginvrl hgmapvvlem1 ) ABCDEFGHIJKLMNOPQRSSLUTZOUTZTU
        AUBUCUDUEUFUGUHUIUJUKULUMUNUOUPUQURUSAWFBVAZWFTVBZWFBTVCZVDZVAAEVEVAZWE
        BVAZWETVBZWGAIVFVAWKAIMNRUAUDUOVGEIUGVHVIZABEISLMNRUAUDUGUHUNUOASBWIUPV
        JZVLZAWMSTVBZASWJVAWQUPSBTVKVIAWETSTABEILMNRSTUAUDUGUHUJUNUOWOVMVNVOZBE
        OWETUHUJULVPVQAWKWLWMWHWNWPWRBEOWETUHUJULVRVQWFBTVSVTAWKWLWMWFWEHWAJWBW
        NWPWRBEHJOWETUHUJUIUKULWCVQWD $.
    $}

    $d k E $.  $d k G $.  $d k O $.  $d k U $.  $d k X $.  $d k ph $.
    $( Lemma for ~ hgmapvv .  Eliminate ` ( ( S `` D ) `` C ) = .1. ` (Baer's
       f(h,k)=1).  (Contributed by NM, 13-Jun-2015.) $)
    hgmapvvlem3 $p |- ( ph -> ( G ` ( G ` X ) ) = X ) $=
      ( vk c0g cfv wne csn wrex wceq eqid cltrn dvheveccl eldifad dochsnnz clss
      cv cbs wcel wb wa wss snssd dochlss syl2anc lssne0 syl mpbid w3a cvsca co
      chlt 3ad2ant1 cdif dochssv sselda 3adant3 simp3 eldifsn sylanbrc hdmapip1
      simpl1 clmod dvhlmod cdr clvec dvhlvec lvecdrng adantr hdmapipcl hdmapip0
      necon3bid biimp3ar drnginvrcl syl3anc simpl2 lssvscl syl22anc hgmapvvlem2
      simpr mpdan rexlimdv3a mpd ) AUOVHZGUPUQZURZUOIUSZNUQZUTZQJUQJUQQVAZAXSXP
      USZURZXTAGKLNOPIXPSUAUBUCXPVBZUMAIOYBALVIUQZPLVCUQUQZGIKLOPXPSYEVBYFVBUBU
      CYDTUMVDVEZVFAXSGVGUQZVJZYCXTVKALWCVJPKVJVLZXROVMZYIUMAIOYGVNZYHGKLNOPXRS
      UBUCYHVBZUAVOVPZUOYHGXSXPYDYMVQVRVSAXQYAUOXSAXOXSVJZXQVTZXOXODUQZUQZMUQZX
      OGWAUQZWBZYQUQHVAZYAYPCDYTGHKLMOPXOUUAXPSUBUCYTVBZYDUEUIUJUKAYOYJXQUMWDYP
      XOOVJZXQXOOYBWEVJAYOUUDXQAXSOXOAYJYKXSOVMUMYLGKLNOPXRSUBUCUAWFVPWGZWHZAYO
      XQWIXOOXPWJWKUUAVBWLYPUUBVLZBUUAXOCDEFGHIJKLMNOPQRSTUAUBUCUDUEUFUGUHUIUJU
      KULUUGAYJAYOXQUUBWMZUMVRZUUGAQBRUSWEVJUUHUNVRUUGGWNVJZYIYSBVJZYOUUAXSVJUU
      GAUUJUUHAGKLPSUBUMWOVRUUGAYIUUHYNVRUUGCWPVJZYRBVJYRRURZUUKUUGAUULUUHAGWQV
      JUULAGKLPSUBUMWRCGUEWSVRVRUUGBCDGKLOPXOXOSUBUCUEUFUKUUIYPUUDUUBUUFWTZUUNX
      AYPUUMUUBAYOUUMXQAYOVLZYRRXOXPUUOCDGKLOPXOXPRSUBUCYDUEUHUKAYJYOUMWTUUEXBX
      CXDWTBCMYRRUFUHUJXEXFAYOXQUUBXGZBYHYTXSCGYSXOUEUUCUFYMXHXIUUPYPUUBXKXJXLX
      MXN $.
  $}

  ${
    hgmapvv.h $e |- H = ( LHyp ` K ) $.
    hgmapvv.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hgmapvv.r $e |- R = ( Scalar ` U ) $.
    hgmapvv.b $e |- B = ( Base ` R ) $.
    hgmapvv.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hgmapvv.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hgmapvv.j $e |- ( ph -> X e. B ) $.
    $( Value of a double involution.  Part 1.2 of [Baer] p. 110 line 37.
       (Contributed by NM, 13-Jun-2015.) $)
    hgmapvv $p |- ( ph -> ( G ` ( G ` X ) ) = X ) $=
      ( cfv wceq eqid wcel c0g fveq2 fveq2d id eqeq12d wne wa chdma cvsca cmulr
      cur cid cbs cres cltrn cop cinvr coch chlt adantr csn cdif anim1i eldifsn
      sylibr hgmapvvlem3 hgmapval0 eqtrd pm2.61ne ) AIEQZEQZIRCUAQZEQZEQZVLRIVL
      IVLRZVKVNIVLVOVJVMEIVLEUBUCVOUDUEAIVLUFZUGZBCHGUHQQZDUIQZCUJQZDCUKQZULGUM
      QUNULHGUOQQUNUPZEFGCUQQZHGURQQZDUMQZHIVLJWBSWDSKWESVSSLMVTSVLSZWASWCSVRSN
      AGUSTHFTUGVPOUTVQIBTZVPUGIBVLVAVBTAWGVPPVCIBVLVDVEVFAVNVMVLAVMVLEACDEFGHV
      LJKLWFNOVGZUCWHVHVI $.
  $}

  ${
    $d a b k l u v .+ $.  $d a b k l u v B $.  $d a b k l u v E $.
    $d k l u v G $.  $d a b k l u v N $.  $d a b k l u v O $.
    $d a b k l u v .x. $.  $d k l R $.  $d k l u v S $.  $d a b k l u v U $.
    $d k l V $.  $d a k l u v X $.  $d b k l u v Y $.  $d a b k l u v ph $.
    hdmapglem7.h $e |- H = ( LHyp ` K ) $.
    hdmapglem7.e $e |- E
            = <. ( _I |` ( Base ` K ) ) , ( _I |` ( ( LTrn ` K ) ` W ) ) >. $.
    hdmapglem7.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapglem7.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapglem7.v $e |- V = ( Base ` U ) $.
    hdmapglem7.p $e |- .+ = ( +g ` U ) $.
    hdmapglem7.q $e |- .x. = ( .s ` U ) $.
    hdmapglem7.r $e |- R = ( Scalar ` U ) $.
    hdmapglem7.b $e |- B = ( Base ` R ) $.
    hdmapglem7.a $e |- .(+) = ( LSSum ` U ) $.
    hdmapglem7.n $e |- N = ( LSpan ` U ) $.
    hdmapglem7.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapglem7.x $e |- ( ph -> X e. V ) $.
    $( Lemma for ~ hdmapg .  (Contributed by NM, 14-Jun-2015.) $)
    hdmapglem7a $p |- ( ph
       -> E. u e. ( O ` { E } ) E. k e. B X = ( ( k .x. E ) .+ u ) ) $=
      ( va cv co wceq csn cfv wrex wcel clss eqid clmod dvhlmod cltrn dvheveccl
      c0g cbs eldifad lspsncl syl2anc dochocsp fveq2d dochocsn dochexmid oveq2d
      snssd eqtrd eqtr3d eleqtrd csubg wb wss lsssssubg syl sseldd chlt dochlss
      wa lsmelval mpbid rexcom wex df-rex lspsnel anbi1d r19.41v syl6bbr exbidv
      rexcom4 ovex oveq1 eqeq2d ceqsexv rexbii bitr3i syl6bb syl5bb rexbidv ) A
      QUKULZBULZDUMZUNZBJUOZNUPZUQUKXLMUPZUQZQIULZJGUMZXIDUMZUNZICUQZBXMUQZAQXN
      XMEUMZURZXOAQOYBUJAXNXNNUPZEUMOYBAEHUSUPZHKLNOPXNRTUAUBYEUTZUGUIAHVAURZJO
      URZXNYEURAHKLPRUAUIVBZAJOHVEUPZUOALVFUPZPLVCUPUPZHJKLOPYJRYKUTYLUTUAUBYJU
      TSUIVDVGZYEMOHJUBYFUHVHVIZAYDNUPXMNUPXNAYDXMNAHKLMNOPXLRUATUBUHUIAJOYMVOZ
      VJZVKAHKLMNOPJRUATUBUHUIYMVLVPVMAYDXMXNEYPVNVQVRAXNHVSUPZURXMYQURYCXOVTAY
      EYQXNAYGYEYQWAYIYEHYFWBWCZYNWDAYEYQXMYRALWEURPKURWGXLOWAXMYEURUIYOYEHKLNO
      PXLRUAUBYFTWFVIWDUKBDEXNXMHQUCUGWHVIWIXOXKUKXNUQZBXMUQAYAXKUKBXNXMWJAYSXT
      BXMYSXHXNURZXKWGZUKWKZAXTXKUKXNWLAUUBXHXQUNZXKWGZICUQZUKWKZXTAUUAUUEUKAUU
      AUUCICUQZXKWGUUEAYTUUGXKAYGYHYTUUGVTYIYMGXHIFCMOHJUEUFUBUDUHWMVIWNUUCXKIC
      WOWPWQUUFUUDUKWKZICUQXTUUDIUKCWRUUHXSICXKXSUKXQXPJGWSUUCXJXRQXHXQXIDWTXAX
      BXCXDXEXFXGXFWI $.

    hdmapglem7.t $e |- .X. = ( .r ` R ) $.
    hdmapglem7.z $e |- .0. = ( 0g ` R ) $.
    hdmapglem7.c $e |- .+b = ( +g ` R ) $.
    hdmapglem7.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapglem7.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    ${
      hdmapglem7b.u $e |- ( ph -> x e. ( O ` { E } ) ) $.
      hdmapglem7b.v $e |- ( ph -> y e. ( O ` { E } ) ) $.
      hdmapglem7b.k $e |- ( ph -> m e. B ) $.
      hdmapglem7b.l $e |- ( ph -> n e. B ) $.
      $( Lemma for ~ hdmapg .  (Contributed by NM, 14-Jun-2015.) $)
      hdmapglem7b $p |- ( ph
   -> ( ( S ` ( ( m .x. E ) .+ x ) ) ` ( ( n .x. E ) .+ y ) )
         = ( ( n .X. ( G ` m ) ) .+b ( ( S ` x ) ` y ) ) ) $=
        ( cv co cfv clmod wcel dvhlmod c0g csn cbs cltrn eqid dvheveccl eldifad
        lmodvscl syl3anc wa wss snssd dochssv syl2anc sseldd lmodvacl hdmapgln2
        chlt hdmapln1 cur chvm hdmapevec2 oveq2d crg wceq lmodrng rngridm eqtrd
        syl hdmapinvlem1 oveq12d rnggrp grprid 3eqtrd oveq1d hdmapinvlem2 rngrz
        cgrp hdmapipcl grplid ) ANVGZOJVHZCVGZEVHZMVGZOJVHBVGZEVHIVIVIXPOIVIZVI
        ZXQPVIZKVHZXPXRIVIZVIZFVHXMYAKVHZXOYCVIZFVHAXQDEFHIJKLPQRUAUBXPOXRUEUHU
        IUJUKULUMUTURVAVBUPALVJVKZXNUAVKZXOUAVKXPUAVKALQRUBUEUHUPVLZAYGXMDVKZOU
        AVKYHYIVFAOUALVMVIZVNARVOVIZUBRVPVIVIZLOQRUAUBYKUEYLVQYMVQUHUIYKVQUFUPV
        RVSZXMJHDUALOUIULUKUMVTWAAOVNZTVIZUAXOARWJVKUBQVKWBYOUAWCYPUAWCUPAOUAYN
        WDLQRTUAUBYOUEUHUIUGWEWFZVDWGZEUALXNXOUIUJWHWAYNAYPUAXRYQVCWGZVEWIAYBYE
        YDYFFAXTXMYAKAXTXMOXSVIZKVHZXOXSVIZFVHXMUDFVHZXMAXMDEFHIJKLQRUAUBOXOOUE
        UHUIUJUKULUMUTURVAUPYNYRYNVFWKAUUAXMUUBUDFAUUAXMHWLVIZKVHZXMAYTUUDXMKAH
        ILUUDOQUBRWMVIVIZRUBUEUFUUFVQVAUPUHULUUDVQZWNWOAHWPVKZYJUUEXMWQAYGUUHYI
        HLULWRXAZVFDHKUUDXMUMURUUGWSWFWTADXOHIKLOQRTUAUBUDUEUFUGUHUIULUMURUSVAU
        PVDXBXCAHXJVKZYJUUCXMWQAUUHUUJUUIHXDXAZVFDFHXMUDUMUTUSXEWFXFXGAYDXMOYCV
        IZKVHZYFFVHUDYFFVHZYFAXMDEFHIJKLQRUAUBOXOXRUEUHUIUJUKULUMUTURVAUPYNYRYS
        VFWKAUUMUDYFFAUUMXMUDKVHZUDAUULUDXMKADXRHIKLOQRTUAUBUDUEUFUGUHUIULUMURU
        SVAUPVCXHWOAUUHYJUUOUDWQUUIVFDHKXMUDUMURUSXIWFWTXGAUUJYFDVKUUNYFWQUUKAD
        HILQRUAUBXOXRUEUHUIULUMVAUPYRYSXKDFHYFUDUMUTUSXLWFXFXCWT $.
    $}

    hdmapglem7.y $e |- ( ph -> Y e. V ) $.
    $( Lemma for ~ hdmapg .  Line 15 in [Baer] p. 111, f(x,y) alpha = f(y,x).
       In the proof, our ` E ` , ` ( O `` { E } ) ` ` X ` , ` Y ` , ` k ` ,
       ` u ` , ` l ` , ` v ` correspond to Baer's w, H, x, y, x', x'', y' ,
       y'', and our ` ( ( S `` Y ) `` X ) ` corresponds to Baer's f(x,y).
       (Contributed by NM, 14-Jun-2015.) $)
    hdmapglem7 $p |- ( ph
           -> ( G ` ( ( S ` Y ) ` X ) ) = ( ( S ` X ) ` Y ) ) $=
      ( vk vu vl vv cv co wceq wrex csn cfv hdmapglem7a wi wcel wa w3a ad2antrr
      chlt crg clmod dvhlmod lmodrng syl simplrr simprr hgmapcl syl3anc wss c0g
      rngcl cltrn dvheveccl eldifad snssd dochssv syl2anc simplrl sseldd simprl
      cbs eqid hdmapipcl hgmapadd hgmapmul hgmapvv eqtrd csg hdmapglem5 oveq12d
      oveq1d hdmapglem7b fveq2d 3eqtr4d 3adantl3 3adant3 simp3 simp13 rexlimdvv
      fveq12d 3exp mp2d ) ASVAVEZKHVFVBVEZCVFZVGZVABVHVBKVIZPVJZVHTVCVEZKHVFVDV
      EZCVFZVGZVCBVHVDYFVHZSTGVJZVJZLVJZTSGVJZVJZVGZAVBBCEFHJVAKMNOPQRSUBUCUDUE
      UFUGUHUIUJUKULUMUNVKAVDBCEFHJVCKMNOPQRTUBUCUDUEUFUGUHUIUJUKULUMUTVKAYDYKY
      QVLZVBVAYFBAYBYFVMZYABVMZVNZYDYRAUUAYDVOZYJYQVDVCYFBUUBYHYFVMZYGBVMZVNZYJ
      YQUUBUUEYJVOZYCYIGVJZVJZLVJZYIYCGVJZVJZYNYPUUBUUEUUIUUKVGZYJAUUAUUEUULYDA
      UUAVNZUUEVNZYAYGLVJZIVFZYBYHGVJVJZDVFZLVJZYGYALVJZIVFZYHYBGVJVJZDVFZUUIUU
      KUUNUUSUUPLVJZUUQLVJZDVFUVCUUNBDFJLMNRUUPUUQUBUEUIUJUQUSANVQVMRMVMVNZUUAU
      UEUMVPZUUNFVRVMZYTUUOBVMUUPBVMAUVHUUAUUEAJVSVMUVHAJMNRUBUEUMVTFJUIWAWBVPA
      YSYTUUEWCZUUNBFJYGLMNRUBUEUIUJUSUVGUUMUUCUUDWDZWEZBFIYAUUOUJUOWIWFUUNBFGJ
      MNQRYBYHUBUEUFUIUJURUVGUUNYFQYBAYFQWGZUUAUUEAUVFYEQWGUVLUMAKQAKQJWHVJZVIA
      NWSVJZRNWJVJVJZJKMNQRUVMUBUVNWTUVOWTUEUFUVMWTUCUMWKWLWMJMNPQRYEUBUEUFUDWN
      WOVPZAYSYTUUEWPZWQUUNYFQYHUVPUUMUUCUUDWRZWQXAXBUUNUVDUVAUVEUVBDUUNUVDUUOL
      VJZUUTIVFUVAUUNBFIJLMNRYAUUOUBUEUIUJUOUSUVGUVIUVKXCUUNUVSYGUUTIUUNBFJLMNR
      YGUBUEUIUJUSUVGUVJXDXIXEUUNBYBYHCFGHIJKLMYAYANJXFVJZPQRUAUBUCUDUEUFUGUVTW
      TUHUIUJUOUPURUSUVGUVQUVRUVIUVIXGXHXEUUNUUHUURLUUNVDVBBCDEFGHIJVCVAKLMNOPQ
      RSUAUBUCUDUEUFUGUHUIUJUKULUVGASQVMUUAUUEUNVPZUOUPUQURUSUVRUVQUVJUVIXJXKUU
      NVBVDBCDEFGHIJVAVCKLMNOPQRSUAUBUCUDUEUFUGUHUIUJUKULUVGUWAUOUPUQURUSUVQUVR
      UVIUVJXJXLXMXNUUFYMUUHLUUFSYCYLUUGUUFTYIGUUBUUEYJXOZXKAUUAYDUUEYJXPZXRXKU
      UFTYIYOUUJUUFSYCGUWCXKUWBXRXLXSXQXSXQXT $.
  $}

  ${
    hdmapg.h $e |- H = ( LHyp ` K ) $.
    hdmapg.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapg.v $e |- V = ( Base ` U ) $.
    hdmapg.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapg.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hdmapg.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapg.x $e |- ( ph -> X e. V ) $.
    hdmapg.y $e |- ( ph -> Y e. V ) $.
    $( Apply the scalar sigma function (involution) ` G ` to an inner product
       reverses the arguments.  The inner product of ` X ` and ` Y ` is
       represented by ` ( ( S `` Y ) `` X ) ` .  Line 15 in [Baer] p. 111,
       f(x,y) alpha = f(y,x).  (Contributed by NM, 14-Jun-2015.) $)
    hdmapg $p |- ( ph
           -> ( G ` ( ( S ` Y ) ` X ) ) = ( ( S ` X ) ` Y ) ) $=
      ( cfv eqid csca cbs cplusg clsm cvsca cmulr cid cres cltrn cop clspn coch
      c0g hdmapglem7 ) ACUASZUBSZCUCSZUOUCSZCUDSZUOBCUESZUOUFSZCUGFUBSUHUGHFUIS
      SUHUJZDEFCUKSZHFULSSZGHIJUOUMSZKVBTVDTLMUQTUTTUOTUPTUSTVCTPQVATVETURTNORU
      N $.
  $}

  ${
    $d y z O $.  $d z V $.  $d y z X $.  $d y z ph $.
    hdmapoc.h $e |- H = ( LHyp ` K ) $.
    hdmapoc.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hdmapoc.v $e |- V = ( Base ` U ) $.
    hdmapoc.r $e |- R = ( Scalar ` U ) $.
    hdmapoc.z $e |- .0. = ( 0g ` R ) $.
    hdmapoc.o $e |- O = ( ( ocH ` K ) ` W ) $.
    hdmapoc.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hdmapoc.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    hdmapoc.x $e |- ( ph -> X C_ V ) $.
    $( Express our constructed orthocomplement (polarity) in terms of the
       Hilbert space definition of orthocomplement.  Lines 24 and 25 in
       [Holland95] p. 14.  (Contributed by NM, 17-Jun-2015.) $)
    hdmapoc $p |- ( ph
           -> ( O ` X ) = { y e. V | A. z e. X ( ( S ` z ) ` y ) = .0. } ) $=
      ( cfv cv wcel wceq wral wa cab crab chlt wss dochssv syl2anc pm4.71rd csn
      sseld clspn clss eqid clmod dvhlmod adantr dochlss lspsnel5 cdih dihlsprn
      simpr crn dochcl dochord snssd dochocsp sseq2d bitr4d 3bitrd dfss3 syl6bb
      dochsscl ad2antrr sselda simplr dochsncom bitrd ralbidva pm5.32da abbi2dv
      hdmapellkr df-rab syl6eqr ) ALIUCZBUDZJUEZWLCUDZEUCUCMUFZCLUGZUHZBUIWPBJU
      JAWQBWKAWLWKUEZWMWRUHWQAWRWMAWKJWLAHUKUEKGUEUHZLJULZWKJULUAUBFGHIJKLNOPSU
      MUNUQUOAWMWRWPAWMUHZWRWNWLUPZIUCZUEZCLUGZWPXAWRLXCULZXEXAWRXBFURUCZUCZWKU
      LWKIUCZXHIUCZULZXFXAFUSUCZWKXGJFWLPXLUTZXGUTZAFVAUEWMAFGHKNOUAVBVCAWKXLUE
      ZWMAWSWTXOUAUBXLFGHIJKLNOPXMSVDUNVCAWMVHZVEXAGKHVFUCUCZHIKXHWKNXQUTZSAWSW
      MUAVCZXAWSWMXHXQVIZUEXSXPFGXQHXGJKWLNOPXNXRVGUNAWKXTUEZWMAWSWTYAUAUBFGXQH
      IJKLNXROPSVJUNVCVKXAXKXIXCULXFXAXJXCXIXAFGHXGIJKXBNOSPXNXSXAWLJXPVLZVMVNX
      AFGXQHIJKLXCNOPXRSXSAWTWMUBVCZXAWSXBJULXCXTUEXSYBFGXQHIJKXBNXROPSVJUNVSVO
      VPCLXCVQVRXAWOXDCLXAWNLUEZUHZWOWLWNUPIUCUEXDYEDEFGHIJKWNWLMNSOPQRTAWSWMYD
      UAVTZXALJWNYCWAZAWMYDWBZWHYEFGHIJKWLWNNSOPYFYHYGWCWDWEVOWFWDWGWPBJWIWJ $.
  $}

  $c HLHil $.

  $( Extend class notation with the final constructed Hilbert space. $)
  chlh $a class HLHil $.

  ${
    $d k w u v x y $.

    $( Define our final Hilbert space constructed from a Hilbert lattice.
       (Contributed by NM, 21-Jun-2015.)  (Revised by Mario Carneiro,
       28-Jun-2015.) $)
    df-hlhil $a |- HLHil = ( k e. _V |-> ( w e. ( LHyp ` k ) |->
      [_ ( ( DVecH ` k ) ` w ) / u ]_ [_ ( Base ` u ) / v ]_
      ( { <. ( Base ` ndx ) , v >. ,
          <. ( +g ` ndx ) , ( +g ` u ) >. ,
          <. ( Scalar ` ndx ) , ( ( ( EDRing ` k ) ` w ) sSet
             <. ( *r ` ndx ) , ( ( HGMap ` k ) ` w ) >. ) >. } u. {
          <. ( .s ` ndx ) , ( .s ` u ) >. ,
          <. ( .i ` ndx ) , ( x e. v , y e. v |->
           ( ( ( ( HDMap ` k ) ` w ) ` y ) ` x ) ) >. } ) ) ) $.
  $}

  ${
    $d k w z H $.  $d k u v w x y z K $.  $d k u v w x y ph $.  $d k u v w R $.
    $d k u v w .+ $.  $d k u v w ., $.  $d k u v w x y W $.  $d k u v w .x. $.
    $d k u v w V $.
    hlhilset.h $e |- H = ( LHyp ` K ) $.
    hlhilset.l $e |- L = ( ( HLHil ` K ) ` W ) $.
    hlhilset.u $e |- U = ( ( DVecH ` K ) ` W ) $.
    hlhilset.v $e |- V = ( Base ` U ) $.
    hlhilset.p $e |- .+ = ( +g ` U ) $.
    hlhilset.e $e |- E = ( ( EDRing ` K ) ` W ) $.
    hlhilset.g $e |- G = ( ( HGMap ` K ) ` W ) $.
    hlhilset.r $e |- R = ( E sSet <. ( *r ` ndx ) , G >. ) $.
    hlhilset.t $e |- .x. = ( .s ` U ) $.
    hlhilset.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hlhilset.i $e |- ., = ( x e. V , y e. V |-> ( ( S ` y ) ` x ) ) $.
    hlhilset.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The final Hilbert space constructed from a Hilbert lattice ` K ` and an
       arbitrary hyperplane ` W ` in ` K ` .  (Contributed by NM,
       21-Jun-2015.)  (Revised by Mario Carneiro, 28-Jun-2015.) $)
    hlhilset $p |- ( ph -> L = ( { <. ( Base ` ndx ) , V >. ,
          <. ( +g ` ndx ) , .+ >. ,
          <. ( Scalar ` ndx ) , R >. } u. {
          <. ( .s ` ndx ) , .x. >. ,
          <. ( .i ` ndx ) , ., >. } ) ) $=
      ( vw vk vu vv chlh cfv cnx cbs cop cplusg csca ctp cvsca cip cpr cun cdvh
      cv cedring cstv chg csts co chdma cmpt2 csb wcel cmpt wceq chlt wa adantr
      cvv elex syl clh fvex eqeltri mptex nfcsb1v nfmpt fveq2 syl6eqr mpteq12dv
      nfcv csbeq1a df-hlhil fvmptf sylancl a1i id simpr fveq2d simplr sylan9eqr
      fveq12d opeq2d oveq12d ad2antrr fveq1d mpt2eq123dv preq12d uneq12d csbied
      tpeq123d simprd tpex prex unex fvmptd syl5eq ) ANPMUMUNZUNUOUPUNZOUQZUOUR
      UNZDUQZUOUSUNZEUQZUTZUOVAUNZGUQZUOVBUNZLUQZVCZVDZRAUIPUJMUKUIVFZUJVFZVEUN
      ZUNZULUKVFZUPUNZYAULVFZUQZYCYRURUNZUQZYEYNYOVGUNZUNZUOVHUNZYNYOVIUNZUNZUQ
      ZVJVKZUQZUTZYHYRVAUNZUQZYJBCYTYTBVFZCVFZYNYOVLUNZUNZUNZUNZVMZUQZVCZVDZVNZ
      VNZVNZYMKXTWAAMWAVOZUIKUVGVPZWAVOXTUVIVQAMVRVOZPKVOZVSUVHUHUVJUVHUVKMVRWB
      VTWCZUIKUVGKMWDUNZWAQMWDWEWFWGUJMUIYOWDUNZUVFVPUVIWAUMWAUJMWMUJUIKUVGUJKW
      MUJMUVFWHWIYOMVQZUIUVNUVFKUVGUVOUVNUVMKYOMWDWJQWKUJMUVFWNWLBCUIULUKUJWOWP
      WQAYNPVQZVSZUJMUVFYMWAAUVHUVPUVLVTUVQUVOVSZUKYQUVEYMWAYQWAVOUVRYNYPWEWRUV
      RYRYQVQZVSZULYSUVDYMWAYSWAVOUVTYRUPWEWRUVTYTYSVQZVSZUULYGUVCYLUWBUUAYBUUC
      YDUUKYFUWBYTOYAUWAUVTYTYSOUWAWSUVTYSHUPUNOUVTYRHUPUVSUVRYRYQHUVSWSUVRYQPM
      VEUNZUNHUVRYNPYPUWCUVRYOMVEUVQUVOWTZXAAUVPUVOXBZXDSWKXCZXATWKXCZXEUWBUUBD
      YCUWBUUBHURUNDUWBYRHURUVTYRHVQUWAUWFVTZXAUAWKXEUVRUUKYFVQUVSUWAUVRUUJEYEU
      VRUUJIUUFJUQZVJVKEUVRUUEIUUIUWIVJUVRUUEPMVGUNZUNIUVRYNPUUDUWJUVRYOMVGUWDX
      AUWEXDUBWKUVRUUHJUUFUVRUUHPMVIUNZUNJUVRYNPUUGUWKUVRYOMVIUWDXAUWEXDUCWKXEX
      FUDWKXEXGXMUWBUUNYIUVBYKUWBUUMGYHUWBUUMHVAUNGUWBYRHVAUWHXAUEWKXEUWBUVALYJ
      UWBUVABCOOUUOUUPFUNZUNZVMLUWBBCYTYTUUTOOUWMUWGUWGUWBUUOUUSUWLUWBUUPUURFUV
      RUURFVQUVSUWAUVRUURPMVLUNZUNFUVRYNPUUQUWNUVRYOMVLUWDXAUWEXDUFWKXGXHXHXIUG
      WKXEXJXKXLXLXLAUVJUVKUHXNYMWAVOAYGYLYBYDYFXOYIYKXPXQWRXRXS $.
  $}

  ${
    $d x y K $.  $d x y ph $.  $d x y W $.
    hlhilbase.h $e |- H = ( LHyp ` K ) $.
    hlhilbase.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilbase.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hlhilsca.e $e |- E = ( ( EDRing ` K ) ` W ) $.
      hlhilsca.g $e |- G = ( ( HGMap ` K ) ` W ) $.
      hlhilsca.r $e |- R = ( E sSet <. ( *r ` ndx ) , G >. ) $.
      $( The scalar of the final constructed Hilbert space.  (Contributed by
         NM, 22-Jun-2015.)  (Revised by Mario Carneiro, 28-Jun-2015.) $)
      hlhilsca $p |- ( ph -> R = ( Scalar ` U ) ) $=
        ( vx csca cfv cnx cop eqid vy cbs cdvh cplusg ctp cvsca cip chdma cmpt2
        cv cpr cun hlhilset fveq2d cvv wcel wceq cstv csts co ovex phlsca ax-mp
        eqeltri syl6reqr ) ACPQRUBQHGUCQQZUBQZSRUDQVFUDQZSRPQBSUERUFQVFUFQZSRUG
        QOUAVGVGOUJUAUJHGUHQQZQQUIZSUKULZPQZBACVLPAOUAVHBVJVIVFDEFVKGCVGHIJVFTV
        GTVHTLMNVITVJTVKTKUMUNBUOUPBVMUQBDRURQESZUSUTUONDVNUSVAVDVGVHBVIVLVKUOV
        LTVBVCVE $.
    $}

    hlhilbase.l $e |- L = ( ( DVecH ` K ) ` W ) $.
    ${
      hlhilbase.m $e |- M = ( Base ` L ) $.
      $( The base set of the final constructed Hilbert space.  (Contributed by
         NM, 21-Jun-2015.)  (Revised by Mario Carneiro, 28-Jun-2015.) $)
      hlhilbase $p |- ( ph -> M = ( Base ` U ) ) $=
        ( vx vy cbs cfv cnx cop eqid cvv cplusg csca cedring cstv csts co cvsca
        chg ctp cip cv chdma cmpt2 cpr cun hlhilset fveq2d wcel eqeltri phlbase
        wceq fvex ax-mp syl6reqr ) ABOPQOPFRQUAPEUAPZRQUBPGDUCPPZQUDPGDUHPPZRUE
        UFZRUIQUGPEUGPZRQUJPMNFFMUKNUKGDULPPZPPUMZRUNUOZOPZFABVLOAMNVEVHVJVIEVF
        VGCVKDBFGHIKLVESVFSVGSVHSVISVJSVKSJUPUQFTURFVMVAFEOPTLEOVBUSFVEVHVIVLVK
        TVLSUTVCVD $.
    $}

    ${
      hlhilplus.a $e |- .+ = ( +g ` L ) $.
      $( The vector addition for the final constructed Hilbert space.
         (Contributed by NM, 21-Jun-2015.) $)
      hlhilplus $p |- ( ph -> .+ = ( +g ` U ) ) $=
        ( vx vy cplusg cfv cnx cop eqid cvv cbs csca cedring cstv csts co cvsca
        chg ctp cip chdma cmpt2 cpr cun hlhilset fveq2d wcel wceq fvex phlplusg
        cv eqeltri ax-mp syl6reqr ) ACOPQUAPFUAPZRQOPBRQUBPGEUCPPZQUDPGEUHPPZRU
        EUFZRUIQUGPFUGPZRQUJPMNVEVEMVANVAGEUKPPZPPULZRUMUNZOPZBACVLOAMNBVHVJVIF
        VFVGDVKECVEGHIKVESLVFSVGSVHSVISVJSVKSJUOUPBTUQBVMURBFOPTLFOUSVBVEBVHVIV
        LVKTVLSUTVCVD $.
    $}
  $}

  ${
    $d x E $.  $d x F $.  $d x K $.  $d x N $.  $d x W $.
    hlhilslem.h $e |- H = ( LHyp ` K ) $.
    hlhilslem.e $e |- E = ( ( EDRing ` K ) ` W ) $.
    hlhilslem.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilslem.r $e |- R = ( Scalar ` U ) $.
    hlhilslem.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hlhilslem.f $e |- F = Slot N $.
      hlhilslem.1 $e |- N e. NN $.
      hlhilslem.2 $e |- N < 4 $.
      hlhilslem.c $e |- C = ( F ` E ) $.
      $( Lemma for ~ hlhilsbase2 .  (Contributed by Mario Carneiro,
         28-Jun-2015.) $)
      hlhilslem $p |- ( ph -> C = ( F ` R ) ) $=
        ( cfv cnx cstv chg cop csts co ndxid wne c4 nnrei ltneii ndxarg neeq12i
        starvndx mpbir setsnid eqtri csca eqid hlhilsca syl6eqr fveq2d syl5eq )
        ABEUAUBTZJHUCTTZUDUEUFZFTZCFTBEFTVGSVEVDFEFIPQUGUAFTZVDUHIUIUHIUIIQUJRU
        KVHIVDUIFIPQULUNUMUOUPUQAVFCFAVFDURTCAVFDEVEGHJKMOLVEUSVFUSUTNVAVBVC $.
    $}

    ${
      hlhilsbase.c $e |- C = ( Base ` E ) $.
      $( The scalar base set of the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         28-Jun-2015.) $)
      hlhilsbase $p |- ( ph -> C = ( Base ` R ) ) $=
        ( cbs c1 df-base 1nn 1lt4 hlhilslem ) ABCDEOFGPHIJKLMQRSNT $.
    $}

    ${
      hlhilsplus.a $e |- .+ = ( +g ` E ) $.
      $( Scalar addition for the final constructed Hilbert space.  (Contributed
         by NM, 22-Jun-2015.)  (Revised by Mario Carneiro, 28-Jun-2015.) $)
      hlhilsplus $p |- ( ph -> .+ = ( +g ` R ) ) $=
        ( cplusg c2 df-plusg 2nn 2lt4 hlhilslem ) ABCDEOFGPHIJKLMQRSNT $.
    $}

    ${
      hlhilsmul.m $e |- .x. = ( .r ` E ) $.
      $( Scalar multiplication for the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         28-Jun-2015.) $)
      hlhilsmul $p |- ( ph -> .x. = ( .r ` R ) ) $=
        ( cmulr c3 df-mulr 3nn 3lt4 hlhilslem ) ACBDEOFGPHIJKLMQRSNT $.
    $}
  $}

  ${
    $d x y ph $.  $d x y R $.  $d x y S $.
    hlhilsbase.h $e |- H = ( LHyp ` K ) $.
    hlhilsbase.l $e |- L = ( ( DVecH ` K ) ` W ) $.
    hlhilsbase.s $e |- S = ( Scalar ` L ) $.
    hlhilsbase.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilsbase.r $e |- R = ( Scalar ` U ) $.
    hlhilsbase.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hlhilsbase2.c $e |- C = ( Base ` S ) $.
      $( The scalar base set of the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         28-Jun-2015.) $)
      hlhilsbase2 $p |- ( ph -> C = ( Base ` R ) ) $=
        ( cfv cbs chlt wcel cedring wa wceq dvhsca syl fveq2d syl5eq hlhilsbase
        eqid eqtrd ) ABIGUAQQZRQZCRQABDRQULPADUKRAGSTIFTUBDUKUCOUKHDFGISJUKUIZK
        LUDUEUFUGAULCEUKFGIJUMMNOULUIUHUJ $.
    $}

    ${
      hlhilsplus2.a $e |- .+ = ( +g ` S ) $.
      $( Scalar addition for the final constructed Hilbert space.  (Contributed
         by NM, 22-Jun-2015.)  (Revised by Mario Carneiro, 28-Jun-2015.) $)
      hlhilsplus2 $p |- ( ph -> .+ = ( +g ` R ) ) $=
        ( cfv cplusg chlt wcel cedring wceq dvhsca syl fveq2d syl5eq hlhilsplus
        wa eqid eqtrd ) ABIGUAQQZRQZCRQABDRQULPADUKRAGSTIFTUHDUKUBOUKHDFGISJUKU
        IZKLUCUDUEUFAULCEUKFGIJUMMNOULUIUGUJ $.
    $}

    ${
      hlhilsmul2.m $e |- .x. = ( .r ` S ) $.
      $( Scalar multiplication for the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         28-Jun-2015.) $)
      hlhilsmul2 $p |- ( ph -> .x. = ( .r ` R ) ) $=
        ( cfv cmulr chlt wcel cedring wa wceq dvhsca syl fveq2d hlhilsmul eqtrd
        eqid syl5eq ) ADIGUAQQZRQZBRQADCRQULPACUKRAGSTIFTUBCUKUCOUKHCFGISJUKUIZ
        KLUDUEUFUJABULEUKFGIJUMMNOULUIUGUH $.
    $}

    ${
      hlhils0.z $e |- .0. = ( 0g ` S ) $.
      $( The scalar ring zero for the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         29-Jun-2015.) $)
      hlhils0 $p |- ( ph -> .0. = ( 0g ` R ) ) $=
        ( vx vy c0g cfv cbs eqidd eqid hlhilsbase2 cv wcel hlhilsplus2 proplem3
        wa cplusg grpidpropd syl5eq ) AICSTBSTPAQRCUATZCBAUMUBAUMBCDEFGHJKLMNOU
        MUCUDAQUEUMUFRUEUMUFUIQRCUJTZBUJTAUNBCDEFGHJKLMNOUNUCUGUHUKUL $.
    $}

    ${
      hlhils1.t $e |- .1. = ( 1r ` S ) $.
      $( The scalar ring unity for the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         29-Jun-2015.)  (New usage is discouraged.) $)
      hlhils1N $p |- ( ph -> .1. = ( 1r ` R ) ) $=
        ( vx vy cur cfv cbs eqidd eqid hlhilsbase2 cv cmulr hlhilsmul2 proplem3
        wcel wa rngidpropd syl5eq ) AECSTBSTPAQRCUATZCBAUMUBAUMBCDFGHIJKLMNOUMU
        CUDAQUEUMUIRUEUMUIUJQRCUFTZBUFTABCUNDFGHIJKLMNOUNUCUGUHUKUL $.
    $}
  $}

  ${
    $d x y K $.  $d x y ph $.  $d x y W $.
    hlhilvsca.h $e |- H = ( LHyp ` K ) $.
    hlhilvsca.l $e |- L = ( ( DVecH ` K ) ` W ) $.
    hlhilvsca.t $e |- .x. = ( .s ` L ) $.
    hlhilvsca.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilvsca.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The scalar product for the final constructed Hilbert space.
       (Contributed by NM, 21-Jun-2015.)  (Revised by Mario Carneiro,
       28-Jun-2015.) $)
    hlhilvsca $p |- ( ph -> .x. = ( .s ` U ) ) $=
      ( vx vy cvsca cfv cnx cop eqid cvv cbs csca cedring cstv chg csts ctp cip
      cplusg co cv chdma cpr cun hlhilset fveq2d wcel wceq fvex eqeltri phlvsca
      cmpt2 ax-mp syl6reqr ) ACOPQUAPFUAPZRQUIPFUIPZRQUBPGEUCPPZQUDPGEUEPPZRUFU
      JZRUGQOPBRQUHPMNVEVEMUKNUKGEULPPZPPVBZRUMUNZOPZBACVLOAMNVFVIVJBFVGVHDVKEC
      VEGHKIVESVFSVGSVHSVISJVJSVKSLUOUPBTUQBVMURBFOPTJFOUSUTVEVFVIBVLVKTVLSVAVC
      VD $.
  $}

  ${
    $d x y K $.  $d x y ph $.  $d x y S $.  $d x y V $.  $d x y W $.
    $d x y X $.  $d x y Y $.
    hlhilip.h $e |- H = ( LHyp ` K ) $.
    hlhilip.l $e |- L = ( ( DVecH ` K ) ` W ) $.
    hlhilip.v $e |- V = ( Base ` L ) $.
    hlhilip.s $e |- S = ( ( HDMap ` K ) ` W ) $.
    hlhilip.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilip.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hlhilip.p $e |- ., = ( x e. V , y e. V |-> ( ( S ` y ) ` x ) ) $.
      $( Inner product operation for the final constructed Hilbert space.
         (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
         28-Jun-2015.) $)
      hlhilip $p |- ( ph -> ., = ( .i ` U ) ) $=
        ( cfv cnx cip cbs cop cplusg csca cedring cstv chg co ctp cvsca cpr cun
        csts eqid hlhilset fveq2d cvv wcel wceq cmpt2 fvex eqeltri mpt2ex phlip
        cv ax-mp syl6reqr ) AEUASTUBSJUCTUDSIUDSZUCTUESKHUFSSZTUGSKHUHSSZUCUNUI
        ZUCUJTUKSIUKSZUCTUASGUCULUMZUASZGAEVNUAABCVIVLDVMIVJVKFGHEJKLPMNVIUOVJU
        OVKUOVLUOVMUOORQUPUQGURUSGVOUTGBCJJBVFCVFDSSZVAURRBCJJVPJIUBSURNIUBVBVC
        ZVQVDVCJVIVLVMVNGURVNUOVEVGVH $.
    $}

    hlhilip.i $e |- ., = ( .i ` U ) $.
    hlhilip.x $e |- ( ph -> X e. V ) $.
    hlhilip.y $e |- ( ph -> Y e. V ) $.
    $( Value of inner product operation for the final constructed Hilbert
       space.  (Contributed by NM, 22-Jun-2015.)  (Revised by Mario Carneiro,
       28-Jun-2015.) $)
    hlhilipval $p |- ( ph -> ( X ., Y ) = ( ( S ` Y ) ` X ) ) $=
      ( vx vy co cv cfv cmpt2 cip eqid hlhilip syl6reqr oveqd wcel fveq2 fveq1d
      wceq fvex ovmpt2 syl2anc eqtrd ) AJKEUCJKUAUBHHUAUDZUBUDZBUEZUEZUFZUCZJKB
      UEZUEZAEVDJKAVDCUGUEEAUAUBBCDVDFGHILMNOPQVDUHZUIRUJUKAJHULKHULVEVGUOSTUAU
      BJKHHVCVGVDJVBUEUTJVBUMVAKUOJVBVFVAKBUMUNVHJVFUPUQURUS $.
  $}

  ${
    $d x I $.  $d x K $.  $d x W $.
    hlhilnvl.h $e |- H = ( LHyp ` K ) $.
    hlhilnvl.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilnvl.r $e |- R = ( Scalar ` U ) $.
    hlhilnvl.i $e |- .* = ( ( HGMap ` K ) ` W ) $.
    hlhilnvl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The involution operation of the star division ring for the final
       constructed Hilbert space.  (Contributed by NM, 20-Jun-2015.)  (Revised
       by Mario Carneiro, 28-Jun-2015.) $)
    hlhilnvl $p |- ( ph -> .* = ( *r ` R ) ) $=
      ( cedring cfv cnx cstv cvv wcel fvex eqid cop csts co chg eqeltri starvid
      wceq setsid mp2an csca hlhilsca syl6eqr fveq2d syl5eq ) AEGFMNZNZOPNEUAUB
      UCZPNZBPNUPQREQREURUGGUOSEGFUDNZNQKGUSSUEQEPQUPUFUHUIAUQBPAUQCUJNBAUQCUPE
      DFGHILUPTKUQTUKJULUMUN $.
  $}

  ${
    $d x y B $.  $d x y K $.  $d x y ph $.  $d x y R $.  $d x y U $.
    $d x y W $.
    hlhillvec.h $e |- H = ( LHyp ` K ) $.
    hlhillvec.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhillvec.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The final constructed Hilbert space is a vector space.  (Contributed by
       NM, 22-Jun-2015.)  (Revised by Mario Carneiro, 29-Jun-2015.) $)
    hlhillvec $p |- ( ph -> U e. LVec ) $=
      ( vx vy cfv clvec wcel eqid cbs csca eqidd wa cplusg proplem3 hlhilsbase2
      dvhlvec hlhilbase hlhilplus hlhilsplus2 cmulr hlhilsmul2 cvsca lvecprop2d
      cdvh cv hlhilvsca mpbid ) AEDUJKKZLMBLMAUNCDEFUNNZHUBAIJUNOKZUNPKZOKZUQBP
      KZUNBAUPQABCDUNUPEFGHUOUPNUCUQNZUSNZAURQAURUSUQBCDUNEFUOUTGVAHURNUAAIUKZU
      PMJUKZUPMZRIJUNSKZBSKAVEBCDUNEFGHUOVENUDTAVBURMZVCURMRZIJUQSKZUSSKAVHUSUQ
      BCDUNEFUOUTGVAHVHNUETAVGIJUQUFKZUSUFKAUSUQVIBCDUNEFUOUTGVAHVINUGTAVFVDRIJ
      UNUHKZBUHKAVJBCDUNEFUOVJNGHULTUIUM $.

    hlhildrng.r $e |- R = ( Scalar ` U ) $.
    $( The star division ring for the final constructed Hilbert space is a
       division ring.  (Contributed by NM, 20-Jun-2015.)  (Revised by Mario
       Carneiro, 28-Jun-2015.) $)
    hlhildrng $p |- ( ph -> R e. DivRing ) $=
      ( vx vy cfv cdr wcel wa eqid cv cplusg proplem3 cedring chlt erngdv eqidd
      syl cbs hlhilsbase hlhilsplus cmulr hlhilsmul drngpropd mpbid ) AFEUAMMZN
      OZBNOAEUBOFDOPUNIUMDEFGUMQZUCUEAKLUMUFMZUMBAUPUDAUPBCUMDEFGUOHJIUPQUGAKRU
      POLRUPOPZKLUMSMZBSMAURBCUMDEFGUOHJIURQUHTAUQKLUMUIMZBUIMABUSCUMDEFGUOHJIU
      SQUJTUKUL $.

    ${
      hlhilsrng.l $e |- L = ( ( DVecH ` K ) ` W ) $.
      hlhilsrng.s $e |- S = ( Scalar ` L ) $.
      hlhilsrng.b $e |- B = ( Base ` S ) $.
      hlhilsrng.p $e |- .+ = ( +g ` S ) $.
      hlhilsrng.t $e |- .x. = ( .r ` S ) $.
      hlhilsrng.g $e |- G = ( ( HGMap ` K ) ` W ) $.
      $( Lemma for ~ hlhilsrng .  (Contributed by NM, 21-Jun-2015.)  (Revised
         by Mario Carneiro, 28-Jun-2015.) $)
      hlhilsrnglem $p |- ( ph -> R e. *Ring ) $=
        ( vx hlhilsbase2 hlhilsplus2 hlhilsmul2 hlhilnvl cdr wcel crg hlhildrng
        vy drngrng syl cv wa chlt adantr simpr hgmapcl w3a 3ad2ant1 simp2 simp3
        hgmapadd hgmapmul hgmapvv issrngd ) AUCULCDFHBABDEGIJKLMQRNPOSUDACDEGIJ
        KLMQRNPOTUEADEFGIJKLMQRNPOUAUFADGIHJLMNPUBOUGADUHUIDUJUIADGIJLMNOPUKDUM
        UNAUCUOZBUIZUPZBEKVIHIJLMQRSUBAJUQUILIUIUPZVJOURZAVJUSZUTAVJULUOZBUIZVA
        ZBCEKHIJLVIVOMQRSTUBAVJVLVPOVBZAVJVPVCZAVJVPVDZVEVQBEFKHIJLVIVOMQRSUAUB
        VRVSVTVFVKBEKHIJLVIMQRSUBVMVNVGVH $.
    $}

    $( The star division ring for the final constructed Hilbert space is a
       division ring.  (Contributed by NM, 21-Jun-2015.) $)
    hlhilsrng $p |- ( ph -> R e. *Ring ) $=
      ( cdvh cfv csca cbs cplusg cmulr chg eqid hlhilsrnglem ) AFEKLLZMLZNLZUAO
      LZBUAUAPLZCFEQLLZDETFGHIJTRUARUBRUCRUDRUERS $.
  $}

  ${
    $d x y L $.  $d y z N $.  $d x y z ph $.  $d x y z U $.  $d y z V $.
    $d y z X $.
    hlhil0.h $e |- H = ( LHyp ` K ) $.
    hlhil0.l $e |- L = ( ( DVecH ` K ) ` W ) $.
    hlhil0.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhil0.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      hlhil0.z $e |- .0. = ( 0g ` L ) $.
      $( The zero vector for the final constructed Hilbert space.  (Contributed
         by NM, 22-Jun-2015.)  (Revised by Mario Carneiro, 29-Jun-2015.) $)
      hlhil0 $p |- ( ph -> .0. = ( 0g ` U ) ) $=
        ( vx vy c0g cfv eqid cv wcel cplusg cbs hlhilbase wa hlhilplus proplem3
        eqidd grpidpropd syl5eq ) AGEOPBOPLAMNEUAPZEBAUIUFABCDEUIFHJKIUIQUBAMRU
        ISNRUISUCMNETPZBTPAUJBCDEFHJKIUJQUDUEUGUH $.
    $}

    ${
      hlhillsm.a $e |- .(+) = ( LSSum ` L ) $.
      $( The vector sum operation for the final constructed Hilbert space.
         (Contributed by NM, 23-Jun-2015.)  (Revised by Mario Carneiro,
         29-Jun-2015.) $)
      hlhillsm $p |- ( ph -> .(+) = ( LSSum ` U ) ) $=
        ( vx vy clsm cfv eqid cv wcel cvv eqidd hlhilbase wa hlhilplus proplem3
        cbs cplusg cdvh fvex eqeltri a1i chlh lsmpropd syl5eq ) ABFOPCOPLAMNFUF
        PZFCAUOUAACDEFUOGHJKIUOQUBAMRUOSNRUOSUCMNFUGPZCUGPAUPCDEFGHJKIUPQUDUEFT
        SAFGEUHPZPTIGUQUIUJUKCTSACGEULPZPTJGURUIUJUKUMUN $.
    $}

    hlhilocv.v $e |- V = ( Base ` L ) $.
    hlhilocv.n $e |- N = ( ( ocH ` K ) ` W ) $.
    hlhilocv.o $e |- O = ( ocv ` U ) $.
    hlhilocv.x $e |- ( ph -> X C_ V ) $.
    $( The orthocomplement for the final constructed Hilbert space.
       (Contributed by NM, 23-Jun-2015.)  (Revised by Mario Carneiro,
       29-Jun-2015.) $)
    hlhilocv $p |- ( ph -> ( O ` X ) = ( N ` X ) ) $=
      ( vy cfv vz cv cip csca c0g wceq wral cbs crab chdma hlhilbase rabeq wcel
      syl eqid chlt ad2antrr simplr wss adantr sselda hlhilipval hlhils0 eqcomd
      co wa eqeq12d ralbidva rabbidva eqtr3d sseqtrd ocvval hdmapoc 3eqtr4d ) A
      SUBZUAUBZBUCTZVEZBUDTZUETZUFZUAJUGZSBUHTZUIZVOVPIDUJTTZTTZEUDTZUETZUFZUAJ
      UGZSHUIZJGTZJFTAWBSHUIZWDWKAHWCUFWMWDUFABCDEHIKMNLOUKZWBSHWCULUNAWBWJSHAV
      OHUMZVFZWAWIUAJWPVPJUMZVFZVRWFVTWHWRWEBCVQDEHIVOVPKLOWEUOZMADUPUMICUMVFWO
      WQNUQVQUOZAWOWQURWPJHVPAJHUSWORUTVAVBAVTWHUFWOWQAWHVTAVSWGBCDEIWHKLWGUOZM
      VSUOZNWHUOZVCVDUQVGVHVIVJAJWCUSWLWDUFAJHWCRWNVKSUAJVSVQGWCBVTWCUOWTXBVTUO
      QVLUNASUAWGWEECDFHIJWHKLOXAXCPWSNRVMVN $.
  $}

  ${
    $d x C $.  $d x I $.  $d x ph $.
    hlhillcs.h $e |- H = ( LHyp ` K ) $.
    hlhillcs.i $e |- I = ( ( DIsoH ` K ) ` W ) $.
    hlhillcs.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhillcs.c $e |- C = ( CSubSp ` U ) $.
    hlhillcs.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    $( The closed subspaces of the final constructed Hilbert space.  TODO:
       ~ hlhilbase is applied over and over to conclusion rather than applied
       once to antecedent - would compressed proof be shorter if applied once
       to antecedent?  (Contributed by NM, 23-Jun-2015.) $)
    hlhillcs $p |- ( ph -> C = ran I ) $=
      ( wcel wa cfv wceq cvv eqid wss hlhilocv vx crn cv cocv chlh fvex eqeltri
      wb iscss mp1i biimpa cssss coch cdvh chlt adantr hlhilbase sseq2d biimpar
      cbs eqcom fveq2d dochssv syl2anc eqtrd eqeq1d syl5bb bitr4d sylan2 mpbird
      dochoccl simpr dihrnss sylan eqcomd ex 3imtr4d mpd impbida eqrdv ) AUABEU
      BZAUAUCZBMZWBWAMZAWCNWDWBWBCUDOZOZWEOZPZAWCWHCQMZWCWHUHZACGFUEOZOQJGWKUFU
      GZBWBWECQWERZKUIZUJUKWCAWBCUTOZSZWDWHUHBWBWOCWORKULAWPNZWDWBGFUMOOZOZWROZ
      WBPZWHWQGFUNOOZDEFWRXBUTOZGWBHIXBRZXCRZWRRZAFUOMGDMNZWPLUPZAWBXCSZWPAXCWO
      WBACDFXBXCGHJLXDXEUQURUSZVKWHWGWBPZWQXAWBWGVAWQWGWTWBWQWGWSWEOZWTWQWFWSWE
      WQCDFXBWRWEXCGWBHXDJXHXEXFWMXJTVBWQCDFXBWRWEXCGWSHXDJXHXEXFWMWQXGXIWSXCSZ
      XHXJXBDFWRXCGWBHXDXEXFVCZVDTVEVFVGVHVIVJAWDNZWDWCAWDVLXOXAWHWDWCXOXAWHXOX
      ANWGWBXOXKXAXOWGWTWBXOWGXLWTXOWFWSWEXOCDFXBWRWEXCGWBHXDJAXGWDLUPZXEXFWMAX
      GWDXILXBDEFXCGWBHXDIXEVMVNZTVBXOCDFXBWRWEXCGWSHXDJXPXEXFWMXOXGXIXMXPXQXNV
      DTVEVFUSVOVPXOXBDEFWRXCGWBHIXDXEXFXPXQVKWIWJXOWLWNUJVQVRVSVT $.
  $}

  ${
    $d x y K $.  $d x U $.  $d x y W $.  $d x ph $.
    hlhilphl.h $e |- H = ( LHyp ` K ) $.
    hlhilphllem.u $e |- U = ( ( HLHil ` K ) ` W ) $.
    hlhilphl.k $e |- ( ph -> ( K e. HL /\ W e. H ) ) $.
    ${
      $d x y A $.  $d a b c d B $.  $d x y J $.  $d x y S $.  $d a b c d U $.
      $d a b c d x y V $.  $d a b c d ph $.
      hlhilphllem.f $e |- F = ( Scalar ` U ) $.
      hlhilphllem.l $e |- L = ( ( DVecH ` K ) ` W ) $.
      hlhilphllem.v $e |- V = ( Base ` L ) $.
      hlhilphllem.a $e |- .+ = ( +g ` L ) $.
      hlhilphllem.s $e |- .x. = ( .s ` L ) $.
      hlhilphllem.r $e |- R = ( Scalar ` L ) $.
      hlhilphllem.b $e |- B = ( Base ` R ) $.
      hlhilphllem.p $e |- .+^ = ( +g ` R ) $.
      hlhilphllem.t $e |- .X. = ( .r ` R ) $.
      hlhilphllem.q $e |- Q = ( 0g ` R ) $.
      hlhilphllem.z $e |- .0. = ( 0g ` L ) $.
      hlhilphllem.i $e |- ., = ( .i ` U ) $.
      hlhilphllem.j $e |- J = ( ( HDMap ` K ) ` W ) $.
      hlhilphllem.g $e |- G = ( ( HGMap ` K ) ` W ) $.
      hlhilphllem.e $e |- E = ( x e. V , y e. V |-> ( ( J ` y ) ` x ) ) $.
      $( Lemma for ~ hlhil .  (Contributed by NM, 23-Jun-2015.) $)
      hlhilphllem $p |- ( ph -> U e. PreHil ) $=
        ( va vb vc vd hlhilbase hlhilplus hlhilvsca cip wceq hlhil0 hlhilsbase2
        cfv csca hlhilsplus2 hlhilsmul2 hlhilnvl hlhils0 hlhillvec hlhilsrng cv
        a1i wcel w3a co chlt 3ad2ant1 simp2 hlhilipval hdmapipcl eqeltrd simp31
        wa simp3 simp32 simp33 hdmapln1 clmod dvhlmod lmodvscl syl3anc lmodvacl
        oveq2d oveq12d 3eqtr4d adantr simpr eqeq1d hdmapip0 bitrd hdmapg fveq2d
        biimp3a isphld ) AVAVBVCEFIJMPNDGTKUBVDAKORSTUAUCUDUEUGUHVEAEKORSUAUCUD
        UEUGUIVFAIKORSUAUCUGUJUDUEVGPKVHVLVIAUQWAAKORSUAUBUCUGUDUEUPVJMKVMVLVIA
        UFWAADMHKORSUAUCUGUKUDUFUEULVKAFMHKORSUAUCUGUKUDUFUEUMVNAMHJKORSUAUCUGU
        KUDUFUEUNVOAMKONRUAUCUDUFUSUEVPAMHKORSUAGUCUGUKUDUFUEUOVQAKORUAUCUDUEVR
        AMKORUAUCUDUEUFVSAVAVTZTWBZVBVTZTWBZWCZXNXPPWDZXNXPQVLVLZDXRQKOPRSTUAXN
        XPUCUGUHURUDAXORWEWBUAOWBWLZXQUEWFZUQAXOXQWGZAXOXQWMZWHZXRDHQSORTUAXNXP
        UCUGUHUKULURYBYCYDWIWJAVDVTZDWBZXOXQVCVTZTWBZWCZWCZYFXNIWDZXPEWDZYHQVLZ
        VLYFXNYNVLZJWDZXPYNVLZFWDYMYHPWDYFXNYHPWDZJWDZXPYHPWDZFWDYKYFDEFHQIJSOR
        TUAXNXPYHUCUGUHUIUJUKULUMUNURAYGYAYJUEWFZAYGXOXQYIWKZAYGXOXQYIWNZAYGXOX
        QYIWOZAYGYJWGZWPYKQKOPRSTUAYMYHUCUGUHURUDUUAUQYKSWQWBZYLTWBZXQYMTWBAYGU
        UFYJASORUAUCUGUEWRWFZYKUUFYGXOUUGUUHUUEUUBYFIHDTSXNUHUKUJULWSWTUUCETSYL
        XPUHUIXAWTUUDWHYKYSYPYTYQFYKYRYOYFJYKQKOPRSTUAXNYHUCUGUHURUDUUAUQUUBUUD
        WHXBYKQKOPRSTUAXPYHUCUGUHURUDUUAUQUUCUUDWHXCXDAXOXNXNPWDZGVIZXNUBVIZAXO
        WLZUUJXNXNQVLZVLZGVIUUKUULUUIUUNGUULQKOPRSTUAXNXNUCUGUHURUDAYAXOUEXEZUQ
        AXOXFZUUPWHXGUULHQSORTUAXNUBGUCUGUHUPUKUOURUUOUUPXHXIXLXRXTNVLXPUUMVLXS
        NVLXPXNPWDXRQSNORTUAXNXPUCUGUHURUSYBYCYDXJXRXSXTNYEXKXRQKOPRSTUAXPXNUCU
        GUHURUDYBUQYDYCWHXDXM $.

      $d x C $.
      hlhilphllem.o $e |- O = ( ocv ` U ) $.
      hlhilphllem.c $e |- C = ( CSubSp ` U ) $.
      $( Lemma for ~ hlhil .  (Contributed by NM, 23-Jun-2015.) $)
      hlhilhillem $p |- ( ph -> U e. Hil ) $=
        ( cphl wcel cv cfv clsm co cbs wceq wral chs hlhilphllem wa coch adantr
        chlt eqid cdih crn hlhillcs eleq2d biimpa dihrnss sylan syldan hlhilocv
        wss oveq2d hlhillsm oveqd clss dihrnlss wi dochoccl biimpd ex dochexmid
        pm2.43d imp 3eqtr3d hlhilbase eqtrd ralrimiva ishil2 sylanbrc ) ALVEVFB
        VGZXIUAVHZLVIVHZVJZLVKVHZVLZBEVMLVNVFABCDFGHIJKLMNOPQRSTUBUCUDUEUFUGUHU
        IUJUKULUMUNUOUPUQURUSUTVAVBVOAXNBEAXIEVFZVPZXLUBXMXPXIXJTVIVHZVJXIXIUCS
        VQVHVHZVHZXQVJZXLUBXPXJXSXIXQXPLPSTXRUAUBUCXIUEUIUFASVSVFUCPVFVPZXOUGVR
        UJXRVTZVCAXOXIUCSWAVHVHZWBZVFZXIUBWJZAXOYEAEYDXIAELPYCSUCUEYCVTZUFVDUGW
        CWDWEZAYAYEYFUGTPYCSUBUCXIUEUIYGUJWFWGZWHWIWKXPXQXKXIXJAXQXKVLXOAXQLPST
        UCUEUIUFUGXQVTZWLVRWMAXOYEXTUBVLYHAYEVPZXQTWNVHZTPSXRUBUCXIUEYBUIUJYLVT
        ZYJAYAYEUGVRZAYAYEXIYLVFUGYLTPYCSUCXIUEUIYGYMWOWGAYEXSXRVHXIVLZAYEYOAYE
        YEYOWPYKYEYOYKTPYCSXRUBUCXIUEYGUIUJYBYNYIWQWRWSXAXBWTWHXCAUBXMVLXOALPST
        UBUCUEUFUGUIUJXDVRXEXFEXKLUAXMBXMVTXKVTVCVDXGXH $.
    $}

    $( Construction of a Hilbert space ( ~ df-hil ) ` U ` from a Hilbert
       lattice ( ~ df-hlat ) ` K ` , where ` W ` is a fixed but arbitrary
       hyperplane (co-atom) in ` K ` .

       The Hilbert space ` U ` is identical to the vector space
       ` ( ( DVecH `` K ) `` W ) ` (see ~ dvhlvec ) except that it is extended
       with involution and inner product components.  The construction of these
       two components is provided by Theorem 3.6 in [Holland95] p. 13, whose
       proof we follow loosely.

       An example of involution is the complex conjugate when the division ring
       is the field of complex numbers.  The nature of the division ring we
       constructed is indeterminate, however, until we specialize the initial
       Hilbert lattice with additional conditions found by Maria Sol&egrave;r
       in 1995 and refined by Ren&eacute; Mayet in 1998 that result in a
       division ring isomorphic to ` CC ` .  See additional discussion at
       ~ http://us.metamath.org/qlegif/mmql.html#what .

       ` W ` corresponds to the w in the proof of Theorem 13.4 of [Crawley]
       p. 111.  Such a ` W ` always exists since ` HL ` has lattice rank of at
       least 4 by ~ df-hil .  It can be eliminated if we just want to show the
       existence of a Hilbert space, as is done in the literature.
       (Contributed by NM, 23-Jun-2015.) $)
    hlathil $p |- ( ph -> U e. Hil ) $=
      ( vx vy cdvh cfv csca cbs ccss cplusg c0g cvsca cv eqid cmulr chdma cmpt2
      chg cip cocv hlhilhillem ) AIJEDKLLZMLZNLZBOLZUHPLZUIPLZUIQLZUIUHRLZUIUAL
      ZBIJUHNLZUQISJSEDUBLLZLLUCZBMLZEDUDLLZCBUELZURDUHBUFLZUQEUHQLZFGHUTTUHTUQ
      TULTUOTUITUJTUMTUPTUNTVDTVBTURTVATUSTVCTUKTUG $.
  $}

$( (End of Norm Megill's mathbox.) $)

$( End $[ set-mbox.mm $] $)
